[![Build Status](https://github.com/MITgcm/MITgcm/workflows/build/badge.svg)](https://github.com/MITgcm/MITgcm/actions)
[![Documentation Status](http://readthedocs.org/projects/mitgcm/badge/?version=latest)](http://mitgcm.readthedocs.io/en/latest/?badge=latest)
[![DOI](https://zenodo.org/badge/DOI/10.5281/zenodo.1409237.svg)](https://doi.org/10.5281/zenodo.1409237)

# MITgcm

MIT General Circulation Model master code and documentation. The main MITgcm webpage can be found [here](http://mitgcm.org).

## Documentation

Access the latest documentation [here](http://mitgcm.readthedocs.io/en/latest/)

See [Chapter 4](https://mitgcm.readthedocs.io/en/latest/examples/examples.html#) of the online documentation for instructions to build, run, and analyze output from MITgcm Tutorial Example Experiments.

A list of additional verification experiments in this directory, with brief description, is presented for forward model setups [here](https://mitgcm.readthedocs.io/en/latest/examples/examples.html#subsec-add-expts-fwd) and for adjoint model setups [here](https://mitgcm.readthedocs.io/en/latest/examples/examples.html#subsec-add-expts-adj).

This directory contains code to generate the libary `lsopt_ecco` need
for the optimization routine "optim.x" in `../optim`. Please refer to
rudimentary instructions in `../optim/README.md`.

The following are instruction how the different precompiled
BLAS-libraries in the directory have been obtained. If your compiling
environment includes the BLAS-library, you do not need to worry about
this.

> Obtaining optimized BLAS routines for HPC platforms
> (e.g. O3K, Altix, Opteron, ...)
> heimbach@mit.edu, 9-Sep-2004
>
> 1.
> Go to
> http://www.cs.utexas.edu/users/kgoto/
> which has a set of high performance BLAS libraries for
> all kinds of platforms.
>
> 2.
> Download (e.g. for Opteron)
> http://www.cs.utexas.edu/users/kgoto/libraries/libgoto_opt64p-r0.94-2.so.gz
> which seems to be the suitable one for your Opteron 64 bit multi-threaded
> and put them in a directory, e.g. ~/mylib/
>
> 3.
> As per website instruction,
> also need the file  xerbla.f
> http://www.cs.utexas.edu/users/kgoto/libraries/xerbla.f
> Download it into the MITgcm/optim/ directory as
> xerbla.F (note capital F)
> (maybe cleaner to generate an object file and keep it in ~/mylib/ )
>
> 4.
> in .bashrc added line
> export LD_LIBRARY_PATH=~/mylib
> (consistent with the directory where I keep the library)
>
> 5.
> in MITgcm/optim/
> edit the Makefile as follows
> * add xerbla.F to             $SRC
> * add -L~/mylib/              $LIBDIRS
> * add -lgoto_opt64-r0.94-2    $LIBS
> and ignore
> -lblas1
>
> That works.

```
Some BLAS    libraries provided in lsopt/ are
SGI O3K:     libblas1.a_IRIX64.gz
SUN:         libblas1.a_SUN.gz
SGI Altix:   libgoto_it2-r0.95.so.gz
PC Pentium4: libgoto_p4_512-r0.94.so.gz
```

# Description and building instructions for optim.x

This directory contains code to compile the optimization routine `optim.x`.

Note, that there is an alternative optimization package [optim_m1qn3](
https://github.com/mjlosch/optim_m1qn3) that is based on the latest (and last)
version of
[m1qn3](https://who.rocq.inria.fr/Jean-Charles.Gilbert/modulopt/optimization-routines/m1qn3/m1qn3.html).

`optim.x` requires the library `lsopt_ecco` and the BLAS library `blas`. The
build procedure is a two step process (first build `lsopt_ecco` and `blas`, and
then `optim.x` ) and by no means foolproof. It requires that you generate a
makefile in this directory and modify the sample `Makefile` in `../lsopt`. For
illustration purposes, let us assume that we want to generate an `optim.x` for
`myExp=tutorial_global_oce_optim` in `MITgcm/verification`.

## Building library `lsopt_ecco` and `blas`

In `MITgcm/lsopt` adjust the compiler and compiler flags in `Makefile`. Using
the same compiler and flags as for building the `mitgcmuv_ad` executable in
`$myExp` is probably the best guess, see also below how the `MITgcm/optim`
`Makefile` is generated. The default works for a standard Ubuntu system, but
not e.g. for a Mac. There's a makefile `MITgcm/lsopt/Makefile_macos` that has
worked for MacOS, but may require adjustment. After adjusting the makefile,
compile the libraries like this:

```
cd ../lsopt
make
```
The resulting libraries `lsopt_ecco` and `blas` will be used in the second
step.

## Building `optim.x`

To generate the makefile based on the setting in `$myExp` and to build
`optim.x`, change into `optim` and run

```
cd ../optim
./prep_make ../../MITgcm/verification/${myExp}/build
make clean
make depend
make
```

`prep_make` generates a local `Makefile` from `makefile_templ` and from
`$myExp` `build/Makefile`. It fills some `makefile_templ` placeholder
`_GET_keyWord` with the corresponding option/parameter value "keyWord" found in
the build/Makefile (the current list of keyWords is: `BLD_DIR`, `EXTRA_OPT`,
`CPPCMD`, `SFX`, `FC`, `FFLAGS` and `FOPTIM`).  A simple usage description is
returned when typing `./prep_make` alone.

In some cases you may have to adjust `makefile_templ`(e.g. for the path to a
non-standard `makedepend`) before running `prep_make`.
Note that the `Makefile` generated using `prep_make` option `-fake` is only for
testing purpose, to get a fake `optim.x` that just reads gradient vector files
without any lsopt pieces.

It may make sense to first generate the makefile in `MITgcm/optim` with
`prep_make`, and then use the parameters in the generated `Makefile` to adjust
the sample `Makefile` in `MITgcm/lsopt`, build the libraries, and then
return to `MITgcm/optim` to build `optim.x`.

## Backward compatibility

With PR #[796](https://github.com/MITgcm/MITgcm/pull/796), the header format of
the control and gradient vector files and the length of the stored fields has
changed. To read old gradient vector files (typically called
`ecco_cost_MIT_CE_000.opt0000` for the first optimisation call) with `optim.x`,
define CPP flag `READ_OLD_CTRL_PACK_FILE` in `CTRL_OPTIONS.h` before compiling
`optim.x`. The resulting `optim.x` will read the old format gradient vector and
write the new control vector (typically called `ecco_ctrl_MIT_CE_000.opt0001`)
in the new format. After the new control vector has been written,
`READ_OLD_CTRL_PACK_FILE` should be reset to `undef` again (and `optim.x`
recompiled) for the next optimisation.

## Old README

The following is the content of the old README. It describes some sort of
interface, i.e. the header of the control and gradient vectors written and read
by the `mitgcmuv_ad` (and `optim.x`), see `optim_readdata.F` and
`optim_writedata.F`. More details can be found in the [online
manual](https://mitgcm.readthedocs.io/en/latest/ocean_state_est/ocean_state_est.html#the-line-search-optimisation-algorithm)
(Chapter 10).

```
c     expid           - experiment name
c     optimcycle      - optimization no.
c     missing value   - missing value identifier (usually -9999.)
c     ig              - global start index x (zonal)
c     jg              - global start index y (merid.)
c     nsx             - no. of x-subgrids
c     nsy             - no. of y-subgrids

 >>> MISSING: <<<
c     nr              - no. of z-points vertical
c     snx
c     sny
c     nvartype
c     nvarlength
 >>> <<<

c     maxcvars        - Number of control variables
c                       (currently 6; 2 init. + 4 bound.)
      integer     maxcvars
      parameter ( maxcvars = 20 )

c     ncvarindex      - "arbitrary" index to define variable:
c                       * 101: initial temp.
c                       * 102: initial sali.
c                       * 103: heat flux
c                       * 104: freshwater flux
c                       * 105: u stress (zonal)
c                       * 106: v stress (merid.)
      integer ncvarindex    ( maxcvars )

c     ncvarrecs       - no. of records in control vector
c                       * = 1                      for init. temp./sali.
c                       * = endrec - startrec + 1  for fluxes
      integer ncvarrecs     ( maxcvars )

c     ncvarrecstart   - first record:
c                       * NOT DEFINED  for init. temp./sali.
c                       * = startrec   for fluxes
      integer ncvarrecstart ( maxcvars )

c     ncvarrecsend    - last record:
c                       * NOT DEFINED  for init. temp./sali.
c                       * = endrec     for fluxes
      integer ncvarrecsend  ( maxcvars )

c     ncvarxmax       - no. of x-points in subgrid (zonal)
c                       = snx
      integer ncvarxmax     ( maxcvars )

c     ncvarymax       - no. of y-points in subgrid (merid.)
c                       = sny
      integer ncvarymax     ( maxcvars )

c     ncvarnrmax      - no. of z-points (vert.)
c                       * = nr  for init. temp./sali.
c                       * = 1   for fluxes
      integer ncvarnrmax    ( maxcvars )

c     nwet[c/s/w]tile - Number of wet points in a tile for center (c),
c                       south (s), and western (w) mask, resp.
      integer nwetctile     ( nsx, nsy, nr )
      integer nwetstile     ( nsx, nsy, nr )
      integer nwetwtile     ( nsx, nsy, nr )

c     ncvargrd        - position in grid
c                       * = 'c' : (center,center)
c                       * = 's' : (center,south)
c                       * = 'w' : (west,center)
      character*(1) ncvargrd(maxcvars)

```

Simple solid-body rotation test on cubed-sphere grid
========================================================

### Overview:
This is a single level, steady-state atmospheric example
(`bouyancyRelation='ATMOSPHERIC'`) on cubed-sphere (cs-32) grid with initial
zonal wind field $U(\phi)$ and surface pressure anomaly $\eta(\phi)$,
both dependent on latitude $\phi$ only, that corresponds to an additional
relative rotation ($\omega\'$) on top of the solid-planet rotation ($\Omega$)
and around the same axis:

$$ U(\phi) = U_{eq} ~ \cos( \phi ) ~~~ \mathrm{with:} ~~~ U_{eq} = \omega' \times R $$

$$ \eta(\phi) = \rho_{const} ~ U_{eq} ~ ( \Omega R + U_{eq} / 2 ) ~~ ( \cos^{2}(\phi) - 2/3 ) $$

The parameters used here are slightly different from Earth (an opportunity to
test this capability) with a smaller planet radius (`rSphere`) $R = 5500 km$,
a slower rotation ( 30 h period, `rotationPeriod=108000.`) and an equatorial
zonal wind $U_{eq} = 80 m/s$ which corresponds to a 5 day revolution time.

The set-up uses linear free-surface with uniform density $\rho_{const} = 1$,
no viscosity and no bottom friction so that the solution is expected to remain
unchanged over time.
A bell-shape patch of passive tracer centered at mid-latitude
($\phi_{0} = 45^{o}$) is advected with the simulated wind field.

## Instructions
Configure and compile the code:

```
  cd build
  ../../../tools/genmake2 -mods ../code [-of my_platform_optionFile]
  make depend
  make
  cd ..
```

To run:

```
  cd run
  ln -s ../input/* .
  ln -s ../build/mitgcmuv .
  ./mitgcmuv > output.txt
  cd ..
```

There is comparison output in the directory:

```
  results/output.txt
```

## Setup details
In the current setup, the initial wind field and initial surface pressure anomaly are computed
from customized versions of
[ini_vel.F](https://github.com/MITgcm/MITgcm/blob/master/verification/solid-body.cs-32x32x1/code/ini_vel.F)
 and [ini_psurf.F](https://github.com/MITgcm/MITgcm/blob/master/verification/solid-body.cs-32x32x1/code/ini_psurf.F), respectively.
Note that $(1/3 - \sin^2)$ is used instead of $(\cos^2 - 2/3)$ in `ini_psurf.F`
for $\eta(\phi)$ expression; and the two horizontal components of the wind
`uVel,vVel` along the local grid direction are computed from a stream-function
$\Psi$ which is naturally defined at the grid-cell corner of the C-grid mesh
(`XG,YG`) so that the initial flow is divergence free:

$$ \Psi( \phi ) = R \times U_{eq} ~ \sin( \phi ) $$

$$ \mathrm{uVel} = + \delta^j \Psi / \mathrm{dyG} ~~ ; ~~ \mathrm{vVel} = - \delta^i \Psi / \mathrm{dxG} $$

Alternatively, one could generate initial condition binary files by running
matlab script `gendata.m` (after changing `kwr=1` to `kwr=2` in gendata.m,
line 75) and use these binary files instead of customized source code (just by
un-commenting lines 67-69 in main parameter file `data`).

## Comments
This set-up uses the "compact format" for all I/O (i.e., one facet after the
other, stacked along the second dimension, as opposed to the default old format
with all 6 facets stacked along the first dimension) by setting `W2_mapIO = 1`
in `data.exch2`.
The initial passive tracer (here "salinity") input file
(`hydrogSaltFile='S_init.bin'`) is `real*8` and generated using the MATLAB
script `gendata.m`. Note that `gendata.m` uses scripts
from `MITgcm/utils/matlab/` and `MITgcm/utils/matlab/cs_grid/`.

c
c
c   =========================================
c   Adjoint support Package for the MITgcmUV
c   =========================================
c
c   Current Version: 0.1.0 (20-Jun-2000)
c
c
c   General Outline:
c   ----------------
c
c      The directory autodiff only contains pieces
c      of code that are of general use in getting
c      the adjoint or the tangent linear model of
c      a some MITgcmUV setup.
c
c      Such pieces are hand-coded adjoint routines,
c      initialization and finalization of a future
c      autodiff package, flow directives for TAF
c      and header files necessary to include for
c      doing automatic differentiation.
c
c   ========
c   HISTORY:
c   ========
c
c
c   started: Christian Eckert eckert@mit.edu  1999
c
c   changed: Patrick Heimbach heimbach@mit.edu 20-Jun-2000
c
c            - adjoint support routines:
c              * active_file_ad.F (changed subroutine argument list)
c              * adopen_adclose.F (changed subroutine argument list)
c              * adread_adwrite.F (changed subroutine argument list)
c              * adread_adwrite.F (single file name convention with or
c                                without ALLOW_ECCO_OPTIMIZATION)
c
c            - flow directives:
c              * added: print_message.flow, check_exp.flow
c
c            - exch_ad.F:
c              NB: Exchanges have been modified substantially since
c                  exch_ad.F was written.

Example: "Internal Wave Forced by Open Boundary"
================================================

This uses a simply EOS (rho = - rho_o alpha T')
 and treats salt as a passive tracer.

Configure and compile the code:
  cd build
  ../../../tools/genmake2 -mods ../code [-of my_platform_optionFile]
  make depend
  make
  cd ..

To run:
  cd run
  ln -s ../input/* .
  ln -s ../build/mitgcmuv .
  ./mitgcmuv > output.txt
  cd ..

There is comparison output in:
  results/output.txt

Comments:
  The input data is real*8 and generated using the MATLAB script
  input/gendata.m

Global ocean on Lat-Lon grid using forcing from pkg/exf
=========================================================
This experiment has been moved (PR #830, #944):
1. inside `global_oce_latlon` (Forward primary and secondary set-up)
   and is now run there.
2. inside `global_oce_latlon` (Adjoint set-ups) and is now run there
   as a secondary test ("global_oce_latlon.w_exf")
   using `input_ad.w_exfs/` and `input_tap.w_exf/`.

Original Description:
=====================

 heimbach@mit.edu 07-Nov-2002.
This verification experiment is almost identical to the
`tutorial_global_oce_latlon` experiment, except that it uses
the `exf` (and `cal`) package instead of the
external_fields_load routine.
To obtain identical results between the two experiments,
the following 2 modifications are necessary:
1. in `external_fields_load.F`:
   replace the line
      `Imytm=int(myTime*rdt+0.5)`
   by
      `Imytm=int((myTime+1296000.)*rdt+0.5)`
2. in `exf_set_climsst.F`:
   comment the 'quality' check, i.e. avoid the setting
   to freezing temperature if less than `climtempfreeze`.

================================

menemenlis@jpl.nasa.gov 05-Aug-2003

Input-field spatial interpolation has been added to `pkg/exf`.
It is enabled by defining CPP option `USE_EXF_INTERPOLATION`
in `EXF_CPPOPTIONS.h` or in `ECCO_CPPOPTIONS.h`
Both bi-linear and bi-cubic interpolation schemes are supported.

This package is a placeholder until a more general coupler
is made available by the ESMF project.  The output grid can be
arbitrary (cubed-sphere should be OK), but it is assumed that
the input grid is Cartesian with arbitrary latitude increments
in the y-direction and with equidistant longitude increments in
the x-direction.  The input grid must encompass the complete
output grid in the y-direction (i.e., extrapolation is not
supported).  It is also assumed that the grid is periodic in
the x-direction; to use the interpolation routine with a
non-periodic domain, make sure there is sufficient padding
at the edges, i.e., two points for bicubic and one for bilinear
interpolation.

The `verification/global_with_exf` experiment has been modified to use
the `USE_EXF_INTERPOLATION` option, the input grids being defined by variables
`*_lon0`, `*_lon_inc`, `*_lat0`, `*_lat_inc`, `*_nlon` and `*_nlat`
in `input/dat.exf` and `input/data.exf_clim`

```
   *_lon0, *_lat0    :: lon and lat of sw corner of global input grid
   *_lon_inc         :: scalar x-grid increment
   *_lat_inc         :: vector y-grid increments
   *_nlon and *_nlat :: input x-grid and y-grid size
```
In this particular example the input and output grids are
the same, so the results of the verification experiment remain
unchanged from before.

Held-Suarez zonal average config. - no eddy param
=================================================

--- Instructions for Forward tests:

Configure and compile the code:
  cd build
  ../../../tools/genmake2 -mods ../code [-of my_platform_optionFile]
  make depend
  make
  cd ..

To run:
  cd run
  ln -s ../input/* .
  ../build/mitgcmuv > output.txt
  cd ..

There is comparison output in the directory:
  results/output.txt

-- Instructions for Adjoint tests:
Note: This requires access to a TAF license.

Configure and compile the code:
  cd build
  ../../../tools/genmake2 -mods ../code_ad [-of my_platform_optionFile]
  make depend
  make adall
  cd ..

To run:
  cd run
  ln -s ../input_ad/* .
  ../build/mitgcmuv_ad  > output_adm.txt
  cd ..

There is comparison output in the directory:
  results/output_adm.txt

--- Comments:

Tutorial Example: "Baroclinic gyre"
(Baroclinic Ocean Gyre In Spherical Coordinates)
============================================================
(formerly "exp1" verification ;
 also "baroclinic_gyre_on_a_sphere" in release.1 branch)

Configure and compile the code:
```
  cd build
  ../../../tools/genmake2 -mods ../code [-of my_platform_optionFile]
  make depend
  make
  cd ..
```

To run:
```
  cd run
  ln -s ../input/* .
  ../build/mitgcmuv > output.txt
```

There is comparison output in the directory:
  results/output.txt

Comments:
  The input data is real*4 and generated using the MATLAB script
  gendata.m.

================
===  WARNING ===
================


For MITgcm Users :

This directory (MITgcm/doc) does *NOT* contain the primary user
documentation for the MITgcm code.  We strongly suggest that you forgo
the effort of downloading and "building" the documentation in the
different formats (pdf, html, etc.) and instead read and/or download
the documentation which is conveniently referenced from the main web
site at:

  http://mitgcm.org



For MITgcm Developers:

If you wish to customize or extend the MITgcm code, this directory
contains a "HOWTO" document that tries to explain:

  + where the code, documentation, and test/verification
    data sets are arranged within the CVS repository;

  + how to run the verification tests;

  + how to get help from the core developers; and

  + how to best integrate your work with the overall project.


The document is available in SGML source within this directory:

  devel_HOWTO.sgml

and in various formats on our web site:

  http://mitgcm.org/dev_docs/devel_HOWTO/



======================================================================
===  WARNING :  The following has been superseeded by the on-line  ===
===             documentation at:  http://mitgcm.org               ===
======================================================================


MITgcmUV Getting Started
========================

o Introduction

  This note is a guide to using the MIT General Circulation Model Ultra Verstaile
  implementation, MITgmcUV. MITgcmUV is a Fortran code that implements the 
  algorithm described in Marshall et. al. 1997, Hill, Adcroft, ...
   The MITgcmUV implementation is designed to work efficiently on all classes
  of computer platforms. It can be used in both a single processor mode
  and a parallel processor mode. Parallel processing can be either multi-threaded
  shared memory such as that found on CRAY T90 machines or it can be multi-process
  distributed memory. A set of "execution enviroment" support routines are 
  used to allow the same numerical code to run on top of a single-process, multi-threaded
  or distributed multi-process configuration.

o Installing
  To setup the model on a particular computer the code tree must be created
  and appropriate compile and run scripts set up. For some platforms
  the necessary scripts are included in the release - in this case follow
  the steps below:

  1. Extract MITgcmUV from the downloadable archive
     tar -xvf cNN.tar 

  2. Create platform specific make file
     For example on a Digital UNIX machine the script "genmake" can
     be used as shown below

     cd bin
     ../tools/genmake 
     cp Makefile.alpha Makefile                  ( On Alpha machine)

  3. Now create header file dependency entries
     make depend

  4. Compile code
     make

  5. To run the model with example data see the "README" in each of
     the example experiments in ../verification/exp*/
     e.g.  ../verification/exp2/README
  

o Running

  - Input and output files

    Required files
    ==============
    The model is configured to look for two files with fixed names.
    These files are called
     "eedata" and "data".
    The file eedata contains "execution environment" data. At present
    this consists of a specification of the number of threads to
    use in X and Y under multithreaded execution.

  - Serial execution

  - Parallel execution. MPI
    mPx, nPy
    dmpirun

  - Parallel execution. Threads
    nSx, nSy
    setenv PARALLEL n
    nTx=2, nTy=2

  - Parallel execution. Hybrid

o Cutomising the code

  Model structure
  ===============
  The "numerical" model is contained within a execution 
  environment support wrapper. This wrapper is designed 
  to provide a general framework for grid-point models.
  MITgcmUV is a specific numerical model that uses the
  framework.
   Under this structure the model is split into 
  execution environment support code and conventional
  numerical model code. The execution environment
  support code is held under the "eesupp" directory.
  The grid point model code is held under the 
  "model" directory. 
   Code execution actually starts in the eesupp 
  routines and not in the model routines. For this
  reason the top level main.F is in the eesupp/src
  directory. End-users should not need to worry about
  this level. The top-level routine for the numerical
  part of the code is in model/src/the_model_main.F.


o References
  Web sites - HP
  for doc     Digital
              SGI
              Sun
              Linux threads
              CRAY multitasking
              PPT notes

Intermediate Atmospheric physics, 5 layers Molteni Physics package.
Global spherical-grid configuration, 128x64x5 resolution.
====================================================================

Configure and compile the code:
  cd build
  ../../../tools/genmake2 -mods ../code [-of my_platform_optionFile]
  make depend
  make
  cd ..

To run:
  cd run
  ln -s ../input/* .
  ln -s ../build/mitgcmuv .
  ./mitgcmuv > output.txt
  cd ..

There is comparison output in the directory:
  results/output.txt

---------------------------
Note:
Originally, this set up was very close to the one in
/development/adcroft/atmos/verification/molteni.128x64x5
with few modifications taken from run on hyades.

Others modifications have been added to improve the stability of the
model (fixed some bugs) and to get a less diffuse Q distribution:
o 3rd order scheme for the Horizontal advection of Q
o changes in the mapping between C-grid and A-grid  for surface stress
---------------------------

The following utilities are available in this directory:

  cm_landwater.m            :: creates colormap for plotting bathymetry/orography
  contourfv.m               :: customized contourf version (for finite volume topo)
  densjmd95.m               :: calculate in-situ density (Jackett & McDougall 1995)
  densmdjwf.m               :: calculate in-situ density (McDougall et.al. 2003)
  dens_poly3.m              :: calculate in-situ density as MITgcm POLY3
  gluemnc.m                 :: glue together different tiles into a global file
  grepread.m                :: a new (from Aug 2001) useful script
  griddata_fast.m           :: script to help use cube and netcdf
  griddata_preprocess.m     :: script to help use cube and netcdf
  ini_poly3.m               :: calculate in-situ density as MITgcm POLY3
  inpaint_nans.m            :: used by interpickups.m (for topography mask)
  interpickups.m            :: interpolate mnc pickup files
  ioLb2num.m                :: convert from ptracer io-label to ptracer number
  load_grid.m               :: load MITgcm output grid-files into one structure array
  longitude.m               :: new (from Aug 2001) script for plotting cube stuff.
  mnc_assembly.m            :: assemble MNC tiles into single NetCDF files
  nc_add.m                  :: script to help use cube and netcdf
  num2ioLb.m                :: convert from ptracer number to ptracer io-label
  pcolorfv.m                :: customized pcolor version (for finite volume topo)
  rdmds.m                   :: read MDSIO output (data & meta) files
  rdmeta.m                  :: read MDSIO output meta file
  rdmnc.m                   :: read tiled MNC output files
  stats.m                   :: calculate and print basic statistics of 1 array
  test_nc_add.m             :: script to help use cube and netcdf


Subdirectories:

  Graphix                   :: cubed-sphere data manipulation and plotting package
  cs_grid                   :: cubed-sphere and lat-lon-cap routines
  gmt                       :: general MITgcm tiles/topologies
  ocean_basin               :: basin mask generation routines


And more complete directions for each script are:

===  mnc_assembly.m  ===

  This utility is available for assembling the data from one or more
  variables contained in multiple MNC tiles (each having their own
  file) into a single NetCDF file.  It understands both "old-style"
  MITgcm exch1 topologies and newer exch2 topologies.  A complete set
  of examples demonstrating the use of this tool on both exch1 and
  exch2 data sets is available from the MITgcm.org CVS server at:

    $ export CVSROOT=':pserver:cvsanon@mitgcm.org:/u/gcmpack'
    $ cvs login
    $ cvs co development/edhill/mnc_assembly

Example: Subtropical North Atlantic Subduction area
====================================================
This experiment has been moved (PR #830) inside `lab_sea` and is now run there
as secondary tests ("lab_sea.natl_box" and "lab_sea.longstep")
using `input.natl_box/` and `input.longstep/`.

Original Description:
=====================
- with KPP & shortwave heating
- no GMRedi

Configure and compile the code:
```
  cd build
  ../../../tools/genmake2 -mods ../code [-of my_platform_optionFile]
  make depend
  make
  cd ..
```

To run:
```
  cd run
  ln -s ../input/* .
  ../input/prepare_run
  ln -s ../build/mitgcmuv .
  ./mitgcmuv > output.txt
  cd ..
```

There is comparison output in the directory:
  `results/output.txt`

----------------------------------------------------
A FORTRAN program provides a verification procedure.
It is based on the boundary layer depth and will either issue:

```'North Atlantic test passed.  KPPhbl file is unchanged.'```

or:

```'North Atlantic test failed.  KPPhbl file has changed.'```

```
  cd run
  ln -sf ../output/KPPhbl.001.001.data KPPhbl_orig
  f77 ../results/comp_orig.F -o comp_orig
  comp_orig
```

N.B.: On ORIGIN 2000 use `f77 -bytereclen`

A matlab script, `matlab/comp_output.m`, creates plots for
reference (c32) and new surface temperature, boundary layer depth,
meridional section of tracer diffusivities, and
corresponding differences.

Comments:
The input data is `real*4`.

global ocean using the cubed-sphere grid 32x32x32 with 15 levels
=================================================================

Specific option:
* Use Non-Linear Free surface formulation with z* coordinate
   with real fresh-water flux.
* Oceanic set-up on the cubed-sphere grid using the vector-invariant
   formulation.

Forcing :
 use Monthly mean climatological forcing (except P-E-R, annual mean).
 same data set as global-ocean lat-long experiments but interpolated
  on CS-32 grid.

Comments:
* bathymetry :
 designed to be coupled to Atmospheric model, therefore includes
 most of the semi-enclosed sea (Mediterranean, Black-Sea, Red-Sea,
   Hudson Bay ...)
 bathy_cs32.bin: initial bathymetry
   h < 0 is meant to stay wet-point whatever delZ(1) is ; Consequently
   the global ocean area is not affected by the vertical resolution.
 bathy_Hmin50.bin: bathymetry file used in the current set-up
    generated from bathy_cs32.bin using matlab script mk_bathy4gcm.m
 mk_bathy4gcm.m matlab script that deepen all shallow point up to 50m.
* global integral of E-P-R and annual mean net Q flux are zero.
* package thSIce and bulk_forc are included but not used in the standard
  set-up.

* additional forcing fields and parameter files are provided (in input.thsice)
  in order to illustrate the use of thSIce pkg.
  the output of a short run (20.iter) is given in results/output_thsice.txt

October 1rst, 2005:
* input.viscA4/data has been added to test biharmonic viscosity on CS-grid
  with side-drag. However, this set of parameters has only be used for
  short tests and is not recommended to begin with.

Simplified experiment to test pkg/shelfice vertical remeshing code
(simplified version of experiment verification_other/shelfice_remeshing/)
===============================================================================

Specific options:
* Use a 2-D (y z) slice southern ocean (lat-long grid) domain with
  flat bottom and Open Boundary at Northern edge; uniform horiz and
  vertical resolution.
* shelfice pkg is used with SHELFICEuseGammaFrict=T but without
  SHELFICEboundaryLayer. To avoid horizontal noise in solution next to a
  large jump in top grid-cell thickness, vertical viscosity and diffusivity
  are increased wherever the top grid-cell is too thin (pCellMix_select=20)
  and are treated implicitly (implicitDiffusion=implicitViscosity=T).
* Use Non-Linear Free surface formulation with real fresh-water flux.
* Ice-Shelf has a simple initial shape (trapezoidal) and evolves
  (SHELFICEMassStepping=T) as a result of melting and prescribed external
  tendency (SHELFICEMassDynTendFile).

IMPORTANT:
  In order to experience several remeshing event during a very short test run,
  the ice-mass tendency forcing has been set to to un-realistically large value.

Input files:
* generated from matlab script: gendata.n

Sequence of runs:
* From resting initial conditions, model was integrated for 1 day (-> iter=2880)
  without SHELFICEMassDynTendFile.
  Then, with SHELFICEMassDynTendFile, run just 18.it to generated current pickup
  files (at iter=2898).
* During current short test run (20.iter long), 4 remeshing event occurs,
  ( grep -A4 'SHI_REMESH at' output.txt )
  2 top-cell merge (it= 2900 & 2916) and 2 top-cell split (it= 2904 & 2914).

Southern-Ocean box with Biochemistry, using Open-Boundary Conditions
 (pkg/obcs) at Northern, Eastern and Western edges of the domain.
======================================================================

This experiment illustrates and tests the use of package DIC with OBCS.

The configuration (e.g., resolution), model parameters and forcing are
almost identical to tutorial_global_oce_biogeo expect that the horizontal
domain is limited to a sub-domain around Drake passage with open-boundary
conditions coming from the last year of a 2 yrs global simulation and
initial conditions taken from t=1.yr of this same simulation.
This enable to compare directly the results of the first year simulation
of this regional set-up with the 2nd year results of the global set-up run.

Configure and compile the code:
  cd build
  ../../../tools/genmake2 -mods ../code [-of my_platform_optionFile]
  make depend
  make
  cd ..

To run:
  cd run
  ln -s ../input/* .
  ln -s ../build/mitgcmuv .
  ./mitgcmuv > output.txt
  cd ..

There is comparison output in the directory:
  results/output.txt

----------------------------------------------------------------------
To generate inital and open boundary conditions:
a) The global set-up (using executable from: tutorial_global_oce_biogeo/build)
   was run for 2 years using model-parameter from inp_global/.
 The only differences with the ones used in tutorial_global_oce_biogeo are:
 - CD-Scheme is turned off (useCDscheme=F), since it is not implemented for OBCS ;
 - as a consequence, horizontal viscosity (viscAh) is increased from 2.E5 to 3.E5;
 - convective-adjustment diffusivity (ivdc_kappa) is reduced from 100. to 10.m^2/s;
 - implicit vertical viscosity is turned off (not needed);
 - free-surface exact conservation is turned on (exactConserv=T);
 - use the Avective-Form of GM (in data.gmredi: GM_AdvForm=T) instead of Skew-Flux;

 to repeat this global simutlation, from so_box_biogeo/
  mkdir run_glob ; cd run_glob
  ln -s ../inp_global/* .
  ../inp_global/prepare_run
  ln -s ../../tutorial_global_oce_biogeo/build/mitgcmuv .
  ./mitgcmuv > output.glob
  cd ..

b) Then regional model forcing files, initial conditions and open-boundary
  conditions files are generated using the matlab script: "mk_box_input.m"
  cd inp_global/
  matlab
  >> mk_box_input

Package `BBL` is a simple bottom boundary layer scheme.  The initial
motivation is to allow dense water that forms on the continental shelf around
Antarctica (High Salinity Shelf Water) in the CS510 configuration to sink to
the bottom of the model domain and to become a source of Antarctic Bottom
Water.  The bbl package aims to address the following two limitations of
package down_slope:

(i) In `pkg/down_slope`, dense water cannot flow down-slope unless there is a
step, i.e., a change of vertical level in the bathymetry.  In pkg/bbl, dense
water can flow even on a slight incline or flat bottom.

(ii) In `pkg/down_slope`, dense water is diluted as it flows into grid cells
whose thickness depends on model configuration, typically much thicker than a
bottom boundary layer.  In pkg/bbl, dense water is contained in a thin
sub-layer and hence able to preserve its tracer properties.

Specifically, the bottommost wet grid cell of thickness

    thk = hFacC(kBot) * drF(kBot),

with properties `tracer`, and density `rho` is divided in two sub-levels:

1. A bottom boundary layer with T/S tracer properties `bbl_tracer`,
density `bbl_rho`, and thickness `bbl_eta`.

2. A residual thickness `resThk = thk - bbl_eta` with tracer properties

    resTracer = ( tracer * thk - bbl_tracer * bbl_eta ) / resThk

such that the volume integral of `bbl_tracer` and `resTracer` is consistent with
the Tracer properties of bottommost wet grid cell.

The bottom boundary layer properties `bbl_tracer` evolve as follows:

I. Vertical detrainment between BBL and residual volume of bottommost wet cell:

(i) If `bbl_rho > rho` , the T/S properties of the BBL are detrained into
the residual volume with a vertical velocity `bbl_wvel` such that:

    bbl_eta(T+deltaT) = max( 0, bbl_eta(T) - bbl_wvel * deltaT )

(ii) If `rho >= bbl_rho` or `bbl_eta(T) = 0` then set `bbl_tracer = Tracer`

Above operations do not change tracer properties of bottommost wet cell.

II. Horizontal exchange between adjacent bottom boundary layer cells when
heavy BBL water is above or at the same level as lighter BBL water.  The
strength of horizontal exchange is controlled by velocity parameter `bbl_hvel`.

(i) Replenish thickness of donor cell, `bbl_eta(d)`, if needed:

    IF bbl_tracer(d) .EQ. Tracer(d) .AND. bbl_eta(d) .LT. bbl_initEta THEN
       bbl_eta(d) = min ( bbl_initEta, Thk(d) )
    ENDIF

(ii) Heavy water flowing out of a cell lowers `bbl_eta(d)` in donor cell and
increases `bbl_eta(r)` in receiving cell.  The volume transport `dVol` out
of the donor cell is:

    dVol = min( bbl_eta(d) * rA(d) / 2,
                (thk(r) - bbl_eta(r)) * rA(r) / 2,
                d(x/y)G * bbl_eta(d) * bbl_hvel * deltaT )

(iii) Compute and accumulate tracer tendencies for donor and receiving cell.
These will be applied to the model's tracer quantities by `bbl_tendency_apply`.

    bbl_tend = dVol * (bbl_tracer(d) - resTracer(r)) / deltaT

    bbl_tendTracer(d) = bbl_tendTracer(d) - bbl_tend / rA(d) / thk(d)

    bbl_tendTracer(r) = bbl_tendTracer(r) + bbl_tend / rA(r) / thk(r)

(iv) Adjust bbl thickness and tracer properties.

    bbl_eta(d,T+deltaT) = bbl_eta(d,T) - dVol / rA(d)
    IF bbl_eta(d) .LT. 0.0001 THEN
       bbl_eta(d) = 0.0
       bbl_tracer(d) = tracer(d)
    ENDIF

    bbl_eta(r,T+deltaT) = bbl_eta(r,T) + dVol / rA(r)

    bbl_tracer(r,T+deltaT) = ( dVol * bbl_tracer(d,T) +
                               bbl_eta(r,T) * rA(r) * bbl_tracer(r,T) ) /
                             ( bbl_eta(r,T+deltaT) * rA(r) )

Note that horizontal exchange is carried out in following order:

1. Meridional bbl exchange at northern edge.
2. Meridional bbl exchange inside tile.
3. Zonal bbl exchange at eastern edge.
4. Zonal bbl exchange inside tile.

The northern and eastern edge computations need to be done before
computations inside the tile in order to avoid edge artifacts.
Note that different tiling will produce slightly different results
as order of computations does matters.

Some key limitations of package as it stands:

- Detrainment and horizontal transport velocities (`bbl_wvel` and `bbl_hvvel`) are
  prescribed rather than computed.
- There is no provision for entrainment (negative `bbl_wvel`).
- bbl depth (`bbl_eta`) cannot be thicker than thickness of bottommost wet grid cell.

Tutorial Example: "Global ocean"
(Global Ocean Simulation at 4^o Resolution)
===========================================

Configure and compile the code:
  cd build
  ../../../tools/genmake2 -mods ../code [-of my_platform_optionFile]
  make depend
  make
  cd ..

To run:
  cd run
  ln -s ../input/* .
  ln -s ../build/mitgcmuv .
  ./mitgcmuv > output.txt
  cd ..

There is comparison output in the directory:
  results/output.txt

Comments:

Example: "Flow over a bump with Open Boundaries and passive tracers"
====================================================================

This experiment is a 400 x 210 x 4.5 km channel (80 x 42 x 8 grid-points)
on an f-plane with a tall seamount in the middle.
It is intended to illustrate the interaction of a zonal flow over and around
a steep bump as well as the use of Open Boundary (`pkg/obcs`) and Floats
packages (`pkg/flt`).

### Overview:
This experiment contains 4 set-ups (with corresponding `input[.*]/` dir) that
can be run with the same executable (built from `build/` dir using customized
code from `code/`);
binary input files (all `real*8`) have been generated using matlab script
`gendata.m` from `input` dir.
All four set-ups use a simple EOS ( $\rho' = -\rho_0 ~ \alpha_T ~ \theta'$ )
and treat salt as a passive tracer ;

The **primary** test, using input files from `input/` dir, use four open
boundaries with simple specifications (`useOBCSprescribe`) from open boundary
parameter file `data.obcs`.
This is a non-hydrostatic set-up using the flux-form momentum equations.

Different kinds of open boundary values are used:
zonal (x-)velocity U is prescribed at all open boundaries with values that are
read from data files (specified in data.obcs);
meridional (y-)velocity V is set to zero on all boundaries, and temperature to
`tRef(z)`, both `in obcs_calc.F`, this is the default behavior;
at the western boundary, salinity values are used for salinity and one passive
tracer in the same way.
Salinity is set to sLev at all other boundaries, while a (nearly) homogeneous
Neumann condition is applied to the passive tracer (the latter is the default
in `obcs_calc.F`), with a relaxation (using pkg rbcs) in the Eastern part of
the channel.

The **secondary** test, using `input.nlfs/` dir, is similar to the primary test except
it is hydrostatic with the vector-invariant momentum formulation and using the
`z*` coordinate. A time-varying small imbalance between the Western boundary
inflow and Eastern boundary outflow generates sea-level fluctuations.

The **secondary** test, using `input.stevens/` dir, is very similar to the primary test
except it is hydrostatic with some bottom friction and use Stevens Open-Boundary
Condition formulation at the Eastern and Western edges.

The **secondary** test, using `input.with_flt/` dir, is intended to illustrate the use
of `pkg/flt` in a simple configuration (hydrostatic, no Open-Boundary but force
with a zonal wind-stress instead).
***Note:*** this set-up has been moved (in PR #830) from `verification/flt_example/`

### Instructions:
default paths are (as used in `testreport`):

```
  set build_dir = ${cwd}/build
  set run_dir   = ${cwd}/run
  set MITGCM    = ${cwd}/../../
```

Configure and compile the code:

```
  cd ${build_dir}
  ${MITGCM}/tools/genmake2 -mods ../code [-of my_platform_optionFile]
 [make Clean]
  make depend
  make
  cd ..
```

To run primary test:

```
  cd ${run_dir}
  ln -s ../input/* .
  ${build_dir}/mitgcmuv > output.txt
  cd ..
```

There is comparison output in the directory:
 results      ( absolute path: `${run_dir}/../results` )

To run any of secondary `$st` test (`$st` in: `nlfs`, `stevens`, `with_flt`):

```
  cd ${run_dir}
  rm *
  ln -s ../input.$st/* .
  ln -s ../input/* .
  ${build_dir}/mitgcmuv > output.txt
  cd ..
```

There is comparison output in the directory:

  `results/output.$st.txt`

### Notes:

Test set-up for seaice pkg with Open-Boundary Conditions
========================================================

This verification experiment is used to test `pkg/seaice` with `pkg/obcs`
and the set-up itself is carved out from `../lab_sea/input.salt_plume/`.

The **primary** test uses input files from `input/` dir which have been generated using
the matlab script [`input/mk_input.m`](input/mk_input.m) together with the set of output files from running
test experiment `../lab_sea/input.salt_plume`.

The **secondary** test `input.seaiceSponge/` uses OBCS sponge-layer for seaice fields
(`useSeaiceSponge=.TRUE.`) in addition to prescribed OBCS from the primary test.

The **secondary** test `input.tides/` adds 4 tidal components to the barotropic velocity
at the open-boundaries (`useOBCStides=.TRUE.`) in addition to prescribed OBCS from the
primary test. The additional tidal component binary input files have been generated using
the matlab script `mk_tides.m` (see comments inside).

Note: naming of tidal input files ("OB\*File") has been changed and augmented to include
Open-Boundary tangential flows in PR [#752](https://github.com/MITgcm/MITgcm/pull/752)
 (see [`input.tides/update_TideFileName.sed`](input.tides/update_TideFileName.sed) on how
to update `data.obcs`)

Simple 1 layer, Barotropic adjustment on the Sphere, using the
                cubed-sphere grid 32x32x32
Contains also a "minimal" test case (just compile eesupp/src + pkgs)
                that does not do much.
=================================================================

General Description:
* using the same executable, 2 set-up can be tested, corresponding
  to input dir. "input" and "input.nlfs".
* Default set-up (input & parameter files in dir "input"):
  Oceanic set-up initially at rest, with flat bottom and a large
  quasi-rectangular continent. An initial free-surface large-scale
  anomaly centered at the equator triggers a barotropic adjustment
  and generates External Inertial-Gravity waves (Poincare waves).
  Use linear Free-Surface and linear dynamics (no momentum advection)
* Additional set-up (input & parameter files in dir "input.nlfs"):
  Atmospheric set-up, without orography, initially at rest.
  An initial large-scale surface pressure anomaly generated pure
  external gravity waves.
  Use non-linear Free-Surface, linear dynamics (no momentum advection)
  without rotation.

IMPORTANT: For the purpose of testing multiple tiles and "blank-tiles":
* Use multiple tiles (8) per cube-face (tile size: 16x8),
  which results in a total of 48 tiles:
    code/SIZE.h
* The oceanic-set-up contains 4 empty tiles (tiles: 11,12,13,14)
  associated with the large continent.
  This gives the opportunity to test the "blank-tiles" option of
  the EXCH2 pkg. An MPI version of this set-up is available to
  test this "blank-tiles" option:
    code/SIZE.h_mpi          : to replace code/SIZE.h
    input/data.exch2.mpi     : to be rename to data.exch2
    code/CPP_EEOPTIONS.h_mpi : to replace eesupp/inc/CPP_EEOPTIONS.h
  However, this particular (MPI) executable cannot be used for the
  atmospheric set-up (input.nlfs) and, in this case, an error
  from S/R EXCH2_CHECK_DEPTHS will stop the execution.

Forcing: none
Input Files (initial conditions):
  generated using matlab script input/gendata.m
 grid-files are linked using the script "input/prepare_run"

Comments:

=================================================================
"minimal" test case:
 provide an example of a minimal set-up which only compiles eesupp/src
 and the 2 pkgs (exch2 & debug) which don't need model/src & inc.

code_min:
  CPP_OPTIONS.h (standard version, needed here since model/inc is not linked)
  packages.conf (2 pkgs: exch2 & debug)
  main.F        (copied from eesupp/src, but skip the call to THE_MODEL_MAIN)
  SIZE.h	(same as code/SIZE.h)
  SIZE.h_mpi    (same as code/SIZE.h_mpi)

input_min
  eedataa	(standard version)
  eedata.mth    (to test running 2 threads)
  data.exch2.mpi (to test blank-tiles with exch2 and MPI built)

to build:
 in order not to compile model/src, need to:
 either put (in build dir) a "genmake_local" file:
 % cat > genmake_local <<EOF
  STANDARDDIRS="eesupp"
EOF
 - or -
 use genmake2 command line: "genmake2 -standarddirs eesupp -mods ../code_min"

=================================================================

Tutorial Example: "Reentrant channel"
(Southern Ocean Reentrant Channel Example)
==========================================

Configure and compile the code:
```
  cd build
  ../../../tools/genmake2 -mods ../code [-of my_platform_optionFile]
  make depend
  make
  cd ..
```

To run:
```
  cd run
  ln -s ../input/* .
  ln -s ../build/mitgcmuv .
  ./mitgcmuv > output.txt
  cd ..
```

There is comparison output in the directory:
results/output.txt

Comments:
  The input data is real*4 and generated using the MATLAB script gendata_50km.m.

Tutorial Example: "Offline CFC Experiments"
============================================================
(formerly "cfc_offline" verification )

Configure and compile the code:
```
  cd build
  ../../../tools/genmake2 -mods ../code [-of my_platform_optionFile]
  make depend
  make
  cd ..
```

To run:
```
  cd run
  ln -s ../input/* .
  ./prepare_run
  ../build/mitgcmuv > output.txt
```

There is comparison output in the directory:
  results/output.txt

Comments:
  The input data is real*4

And to run the simpler (no CFC) offline test:
```
  cd run ; rm -f *
  ln -s ../input_tutorial/* .
  ln -s ../input/* .
  ./prepare_run
  ../build/mitgcmuv > output.tut
```

Tutorial Example: "Gravity plume on a continental slope"
========================================================
(formerly "plume_on_slope" verification ;
 also "nonhydrostatic_plume_on_slope" in release.1 branch)

### Overview:
This is a 2D set-up with (variable) high-resolution and non-hydrostatic dynamics, where dense water is produced on a shelf that then flows as a gravity current down the slope. 

The **primary** test uses a no-slip bottom boundary condition (`no_slip_bottom=.TRUE.`) and no explicit drag. 

The **secondary** test `rough.Bot` uses the logarithmic law of the wall to compute the drag coefficient for quadratic bottom drag as a function of distance from the bottom (i.e. cell thickness) and a prescribed roughness length `zRoughBot = 0.01` (in meters). For this configuration (i.e. vertical grid spacing) this value of `zRoughBot` corresponds to approximately `bottomDragQuadratic=5.E-2`. For consistency, the bottom boundary conditions is set to free slip (`no_slip_bottom=.FALSE.`).

## Instructions
Configure and compile the code:

```
  cd build
  ../../../tools/genmake2 -mods ../code [-of my_platform_optionFile]
  make depend
  make
  cd ..
```

To run:

```
  cd run
  ln -s ../input/* .
  ln -s ../build/mitgcmuv .
  ./mitgcmuv > output.txt
  cd ..
```

To run the **secondary** test `roughBot`:

```
  cd run
  rm *
  ln -s ../input.roughBot/* .
  ln -s ../input/* .
  ../build/mitgcmuv > output.txt
```

There is comparison output in the directory:

```
  results/output.txt
  results/output.roughBot.txt
```

## Comments
  The input data is `real*8` and generated using the MATLAB script
  gendata.m.

# Global Ocean Simulation at 4 degree Resolution, including Adjoint Set-Up
First configuration to use OpenAD, started on 2005-08-19
 by heimbach@mit.edu, utke@mcs.anl.gov, cnh@mit.edu
***Note*** this experiment was previously named "OpenAD".

### Overview:
This experiment is derived from `tutorial_global_oce_latlon` (see also `global_ocean.90x40x15`)
with surface forcing provided by specific pkgs, either
`pkg/exf` or `pkg/ebm`, instead of relying on the main model surface forcing capability.
It contains 3 forward set-up, all using the same executable built from `code`
config but with specific input files from `input/` (primary test) and,
as secondary tests, from `input.yearly/` and `input.ebm/`.

It provides also adjoint settings for 3 AD compilers, OpenAD, TAF and Tapenade, with primary
test input files in `input_oad/`, `input_ad/` and `input_tap/` respectively, but also
several secondary test setting with each of the AD compilers.

## Part 0, Forward only tests:

The **primary** forward test, using input files from `input/`,
uses prescribed monthly-mean air-sea surface fluxes from `pkg/exf`.<br>

The **secondary** test, using input files from `input.yearly/`,
is very similar except for the specification of yearly input fields to`pkg/exf`.<br>

**Note:**

1.  These 2 set-up have been moved (in PR #830) from `verification/global_with_exf/`
    where a "README" still provides some details related to `pkg/exf` specific
    features used here.
2.  The ability, using `pkg/exf`, to compute surface fluxes from near surface
    atmospheric state and downward radiation as shown, e.g., in experiment
    `global_ocean.cs32x15` (secondary test `input.seaice` or `input.icedyn` or `input.in_p`)
    is not used here (`#undef ALLOW_BULKFORMULAE`).

The **secondary** test, using input files from `input.ebm/`,
relies on the Energy-Balance Model package (`pkg/ebm`) to compute oceanic surface forcing.<br>

**Note:**

This secondary test set-up has been moved (in PR #944) from `verification/global_ocean_ebm/`
and a "README" there still provides some details related to `pkg/ebm` specific
features used here.

## Part 1, using OpenAD Adjoint Compiler:

The built process needed to be modified, and some routines
needed changes. Most changes were commited to default routines,
the remaining changes are kept in `code_oad/` for now.

### Instructions:
Configure and compile the code:

```
  cd build
  ../../../tools/genmake2 -mods ../code_oad [-of my_platform_optionFile]
 [make Clean]
  make adAll
  cd ..
```

***Note:*** might want to split the full single step above (make adAll) in
several intermediate steps such as:

```
  make cb2m
  make makefile
  make small_f
  make allmods
  make adAll
```
where the first step (`cb2m`) invokes a script to convert `COMMON` block headers
(e.g. `FILE.h`) to `MODULE` headers (`FILE_mod.h`) and create new module files
(`FILE_mod.F90`); the second step (`makefile`) re-generates the makefile to take
into account newly created files `FILE_mod.h`, `FILE_mod.F90` ; the third step
(`small_f`) generates `.f` and `.f90` files. The fourth step (`allmods`)
compiles all module files `.f90` ; and the fifth and last step compliles all f90
src files.

To run primary test:

```
  cd run
  ln -s ../input_oad/* .
  ./prepare_run
  ../build/mitgcmuv_ad > output_oadm.txt
  cd ..
```

There is comparison output in the directory:
  `results/output_oadm.txt`

To run any of secondary `$st` test (`$st` in: `ggl90`, `kpp`):

```
  cd run
  rm *
  ln -s ../input_oad.$st/* .
  ln -s ../input_oad/* .
  ./prepare_run
  ../build/mitgcmuv_ad > output_oadm.txt
```

There is comparison output in the directory:
  `results/output_oadm.$st.txt`

## Part 2, using TAF Adjoint Compiler:
similar to above but using set-up specific code from `code_ad/` and input files from `input_ad/`

### Instructions:
Configure and compile the code:

```
  cd build
  ../../../tools/genmake2 -mods ../code_ad [-of my_platform_optionFile]
 [make Clean]
  make depend
  make adall
  cd ..
```

To run primary test:

```
  cd run
  ln -s ../input_ad/* .
  ./prepare_run
  ../build/mitgcmuv_ad > output_adm.txt
  cd ..
```

There is comparison output in the directory:
  `results/output_adm.txt`

To run any of secondary `$st` test (`$st` in: `ggl90`, `w_exf`, `ebm`):

```
  cd run
  rm *
  ln -s ../input_ad.$st/* .
  ln -s ../input_ad/* .
  ./prepare_run
  ../build/mitgcmuv_ad > output_adm.txt
```

There is comparison output in the directory:
  `results/output_adm.$st.txt`

**Note:**

1.  `input_ad.w_exf` set-up has been moved (in PR #830)
    from `verification/global_with_exf/input_ad`
2.  `input_ad.ebm` set-up has been moved (in PR #944)
    from `verification/global_ocean_ebm/input_ad`

## Part 3, using Tapenade Adjoint Compiler:
similar to above but using set-up specific code from `code_tap/` and input files from `input_tap/`

Seaice-only verification experiment in idealized periodic channel with
ice thickness distribution (otherwise very similar to
offline_exf_seaice): CPP-flag SEAICE_ITD is defined
-----------------------------------------------------------------

1) main forward experiment (code, input)

  Re-entrant zonally periodic channel (80x42 grid points) with just level (Nr=1)
   uniform resolution (5.km, 10m), solid Southern boundary with triangular shape
   coastline ("bathy_3c.bin")

  Use seaice (dynamics & thermodynamics from pkg/seaice) with EXF (see data.pkg)
   with initial ice thickness ranging from nearly 0 m in the "south"
   to over 7 m in the "north"(but no snow)
   (HeffFile  = 'heff_quartic.bin', in "input/data.seaice")
  Initial seaice concentration is 100 % everywhere
   (AreaFile='const100.bin', in "input/data.seaice")
  and seaice is initially at rest.

  Ridging is computed according to Thorndyke et al (1975) and Hibler
  (1980). Ice strength P is computed following Rothrock (1975)

  At runtime turn off time-stepping in 'data', PARM01, using:
    momStepping  = .FALSE.,
    saltStepping = .FALSE.,
    tempAdvection=.FALSE.,

 Forcing:
  None of the forcing vary with time; the input files have been
   generated using the python script "input/gendata.py".
  SST relaxation field is uniform in X, parabolic function of Y with
   maximum close to Southern boundary.

  Atmospheric air temp is uniform in Y, and only vary with X (~sin(2.pi.x/Lx))
   with an amplitude of 4.K ('tair_4x.bin');
  Uses constant Relative Humidity (70%, file 'qa70_4x.bin')
  constant and uniform downward shortwave (100.W/m2, 'dsw_100.bin'),
                       downward longwave (250.W/m^2, 'dlw_250.bin'),
                       zonal wind (10.m/s, 'windx.bin'),
  no meridional wind, no precip.

  Ocean surface currents comes from a 3 levels ocean-only run (without seaice)
   using the same wind forcing (uVel_3c0.bin, vVel_3c0.bin) (matlab script:
  "input/getdata.m")

2) other (secondary) experiments (with the same executable)

 a) input.lipscomb07: seaice-dynamics only with ridging scheme
    following Lipscomb et al (2007); uses same forcing as main forward 
    experiment, without thermodynamic forcing
    (usePW79thermodynamics=.FALSE., SEAICEpartFunc = 1, SEAICEredistFunc = 1,
    in input.dyn_lsr/data.seaice).

 b) input.thermo: seaice-dynamics and thermodynamics with ridging, but
    ice strength is computed following Hibler (1979): 
    P = 27.5e4*(h*c)*exp(-20*(1-c)) 

Labrador Sea Region with Sea-Ice
=========================================

### Primary test Overview:
This example sets up a small (20x16x23) Labrador Sea experiment
coupled to a dynamic thermodynamic sea-ice model (MITgcm Documentation 8.6.2).

The domain of integration spans $`[280, 320]^\circ`$E and $`[46, 78]^\circ`$N.
Horizontal grid spacing is 2 degrees.
The 23 vertical levels and the bathymetry file

```
  bathyFile      = 'bathy.labsea1979'
```
are obtained from the the 2$`^\circ`$ ECCO configuration.

Integration is initialized from annual-mean Levitus climatology

```
 hydrogThetaFile = 'LevCli_temp.labsea1979'
 hydrogSaltFile  = 'LevCli_salt.labsea1979'
```

Surface salinity relaxation is to the monthly mean Levitus climatology

```
 saltClimFile    = 'SSS.labsea1979'
```

Forcing files are a 1979-1999 monthly climatology computed from the
NCEP reanalysis (see [`SEAICE_PARAMS.h`](https://github.com/MITgcm/MITgcm/blob/master/pkg/seaice/SEAICE_PARAMS.h) for units and signs)

```
  uwindFile      = 'u10m.labsea1979'  # 10-m zonal wind
  vwindFile      = 'v10m.labsea1979'  # 10-m meridional wind
  atempFile      = 'tair.labsea1979'  # 2-m air temperature
  aqhFile        = 'qa.labsea1979'    # 2-m specific humidity
  lwdownFile     = 'flo.labsea1979'   # downward longwave radiation
  swdownFile     = 'fsh.labsea1979'   # downward shortwave radiation
  precipFile     = 'prate.labsea1979' # precipitation
```

The experiment uses `pkg/gmredi`, `pkg/kpp`, `pkg/seaice`, and `pkg/exf`.
The test is a 1-cpu, 10-hour integration. Both the atmospheric
state and the open-water surface fluxes are provided by `pkg/exf`.

More `pkg/seaice` test experiments, configured for low and
high-resolution global cube-sphere domains are described
in `MITgcm_contrib/high_res_cube/README_ice`.

### Lab Sea adjoint
The `code_ad` directory provides files required to compile the adjoint
version of this verification experiment.  This verification
experiment uses the 'divided adjoint'.

To compile the adjoint, one must enable the divided adjoint with the
compile-time flag `USE_DIVA`, the location of which is specified in
the file `build/genmake_local`.
To wit,

```
  USE_DIVA=1
```

To compile the adjoint without the divided adjoint, the compile-time
flag `ALLOW_DIVIDED_ADJOINT` in `code_ad/AUTODIFF_OPTIONS.h` should
be changed from

```
  #define ALLOW_DIVIDED_ADJOINT
```
to

```
  #undef ALLOW_DIVIDED_ADJOINT
```

Note: `testreport` builds in the `lab_sea/build` directory which contains
this `genmake_local` file and so it knows to use the divided adjoint.

## Instructions
Navigate to experiment directory

```
  cd MITgcm/verification/lab_sea
```

### 1-CPU forward experiment
Configure and compile the code:
```
  cd build
  ../../../tools/genmake2 -mods ../code [-of my_platform_optionFile]
 [make Clean]
  make depend
  make
  cd ..
```

To run:
```
  cd run
  ln -s ../input/* .
  ln -s ../build/mitgcmuv .
  ./mitgcmuv > output.txt
  cd ..
```

There is comparison output in the directory:
```
  results/output.txt
```

Use matlab script `lookat_ice.m` to compare the output
 with that from `checkpoint51f` sea-ice code:
```
  cd ../../../verification/lab_sea/matlab
  matlab
  lookat_ice
```

### 2-CPU forward experiment
Configure and compile the code:
```
  cd build
  ../../../tools/genmake2 -mpi -mods ../code [-of my_platform_optionFile]
  ln -s ../code/SIZE.h_mpi SIZE.h
 [make Clean]
  make depend
  make
  cd ..
```

To run:
```
  cd run
  ln -s ../input/* .
  mpirun -np 2 ../build/mitgcmuv
  cd ..
```

### 1-CPU adjoint experiment
Configure and compile the code:
```
  cd build
  ../../../tools/genmake2 -mods ../code_ad [-of my_platform_optionFile]
  make adall
  cd ..
```

To run:
```
  cd run
  ln -s ../input_ad/* .
  ./prepare_run
  ln -s ../build/mitgcmuv_ad .
  ./do_run.sh
  cd ..
```

**Note:** `prepare_run` shell script is also used when running `testreport` (see below)
and could be replaced by these 2 commands:
```
  ln -s ../input/* .
  ln -s ../../isomip/input_ad/ones_64b.bin .
```
And the overly simple shell script "do_run.sh" just executes four times
(as specified in file "run_ADM_DIVA", `add_DIVA_runs = 4`) `mitgcmuv_ad`, saving
output in intermediate files "output_adm.txt.diva_0,1,2,3", plus a final time:
```
  mitgcmuv_ad > output_adm.txt
```
where output file `output_adm.txt` can be compared with reference output:
```
  results/output_adm.txt
```

## Secondary tests
In addition to the primary tests described above, 5 secondary forward tests and
and 2 secondary adjoint tests can be run using the same executable as the corresponding
primary tests but with specific input parameter files (in `input.$st\` and `input_ad.$st\`).
The secondary forward tests include alternative seaice model formulations:
free-drift in `input.fd/`; using EVP and `useHB87stressCoupling` in `input.hb87/` ;
with `pkg/salt_plume` in `input.salt_plume/`;
and two other ice-free "North-Altlantic box" set-up (formerly in `verification/natl_box/`)
in `input.natl_box\` and with `pkg/longstep` in `input.longstep/`.
The secondary adjoint tests are simpler version of the primary adjoint test,
without seaice in `input_ad.noseaice/` and without seaice dynamics in `input_ad.noseaicedyn/`.

### Instruction to run secondary tests
Run the testscript _forward_ experiments:

```
  cd MITgcm/verification
  ./testreport -t lab_sea [-of my_platform_optionFile]
```

Standard testreport output, with all secondary tests:
```
default 10  ----T-----  ----S-----  ----U-----  ----V-----  --PTR 01--  --PTR 02--  --PTR 03--  --PTR 04--  --PTR 05--
G D M    c        m  s        m  s        m  s        m  s        m  s        m  s        m  s        m  s        m  s
e p a R  g  m  m  e  .  m  m  e  .  m  m  e  .  m  m  e  .  m  m  e  .  m  m  e  .  m  m  e  .  m  m  e  .  m  m  e  .
n n k u  2  i  a  a  d  i  a  a  d  i  a  a  d  i  a  a  d  i  a  a  d  i  a  a  d  i  a  a  d  i  a  a  d  i  a  a  d
2 d e n  d  n  x  n  .  n  x  n  .  n  x  n  .  n  x  n  .  n  x  n  .  n  x  n  .  n  x  n  .  n  x  n  .  n  x  n  .

Y Y Y Y>11<13 16 16 16 16 16 16 14 13 13 13 16 16 16 12 14 22 16 16 16 22 16 16 16 pass  lab_sea
Y Y Y Y>12<16 16 16 16 16 16 16 16 16 13 13 16 14 16 13 16 22 16 16 16 22 16 16 16 pass  lab_sea.fd
Y Y Y Y> 4< 9 10  9  9 16 13 11  8  6  8  4  5  7  8  4  6 22  7  7  7 22  6  7  7 FAIL  lab_sea.hb87
Y Y Y Y 11 16 16 16 14 16 16 16 16 16 13 12 14 16 13 12 14 16 16 16>16<pass  lab_sea.longstep
Y Y Y Y>11<16 16 16 16 16 16 16 16 13 12 12 14 14 13 12 14 pass  lab_sea.natl_box
Y Y Y Y>13<16 16 16 16 16 16 16 14 16 14 13 14 16 14 13 16 22 16 16 16 22 16 16 16  pass  lab_sea.salt_plume
```

**Note:** Some differences in accuracy occur across different platforms as seen
here for secondary test "lab_sea.hb87".

Run the testscript _adjoint_ experiments:

```
  cd MITgcm/verification
  ./testreport -t lab_sea -ad [-of my_platform_optionFile]
```

Standard adjoint testreport output, with all secondary tests:
```
Adjoint generated by TAF Version 6.5.1

default    10     ----T-----  ----S-----  ----U-----  ----V-----
G D M    C  A  F        m  s        m  s        m  s        m  s
e p a R  o  d  D  m  m  e  .  m  m  e  .  m  m  e  .  m  m  e  .
n n k u  s  G  G  i  a  a  d  i  a  a  d  i  a  a  d  i  a  a  d
2 d e n  t  r  r  n  x  n  .  n  x  n  .  n  x  n  .  n  x  n  .

Y Y Y Y 16>16<16 16 14 16 16 16 16 16 16 16 16 16 14 14 16 16 16 pass  lab_sea  (e=0, w=0, lfd=1, dop=1, sm=1)
Y Y Y Y 14>15< 6 16 16 16 13 16 13 13 11 13 13 12 13 11 11 12 12 pass  lab_sea.noseaice
Y Y Y Y 16>13<16 16 16 14 16 16 13 13 16 16 16 16 14 14 16 14 16 pass  lab_sea.noseaicedyn
```

Example to test pkg/matrix

Instructions for building:

1) mkdir build
2) cd build
3) run genmake with: -mods=../code and -enable=matrix
e.g.,
../../../tools/genmake2  "-mods=../code" "-optfile=../../../tools/build_options/darwin_ppc_xlf_spk" "-enable=matrix"

4) make depend
5) make

Instructions for running:

1) mkdir run
2) cd run
3) cp -p ../input/* .
4) ./mitgcmuv > output.txt

Results:

compare with results/output.txt

HOW TO RUN AND ANALYZE A 11,000 TIME STEP EXPERIMENT
JAN 23, 2013

MITgcm checkpoint 64c.  
seaice_growth.F version: 1.185 (2012/12/27)

1) Make the following changes to the input_ad/data* files 
for the 11,000 time step simulation.

a) data 

>  nTimeSteps= 11000,
>  monitorFreq=0.
>  adjMonitorFreq = 1.,

b) data.autodiff 

>   useKPPinAdMode = .FALSE.,

c) data.diagnostics

>   frequency(1)  = 86400,
>   fields(1,1)   = 'EXFuwind','EXFvwind','EXFlwdn', 'EXFswdn','EXFatemp','EXFaqh','EXFevap','EXFpreci','EXFempmr','EXFhl   ','EXFhs   ',
>   filename(1)   = 'EXF_avg_daily',

>   frequency(2)  = 86400,
>   fields(1:3,2)   = 'SIarea  ','SIheff  ','SIhsnow ',
>   filename(2)   = 'ICE_avg_daily',

d) data.pkg

>   useGrdchk = .FALSE.,
>   useMNC    = .TRUE,
>   useDiagnostics = .TRUE.,


2) Make the following changes to packages.conf in code_ad:

a) packages.conf 

> diagnostics
> mnc


3) After running, use the two matlab scripts (analyze_forward_run_general.m, analyze_adjoint_run_general.m) in ./matlab_scripts to plot the results.  Be sure that the helper script, 'tenPercentAboveBelowLeftRight.m' is in your matlab path. 

Update: 
- testing scripts were no longer maintained here and have been
  removed (around Dec 01, 2018). 
- updated ones can be found in:
   http://wwwcvs.mitgcm.org/viewvc/MITgcm/MITgcm_contrib/test_scripts/
 and can be downloaded using CVS (http://mitgcm.org/public/using_cvs.html)
------------------------------------------------------------------------

=====  What is this?  =====

This directory is a collection of scripts and "crontab" entries mostly
intended for automated testing.  These scripts are not intended for
casual users.  If you have any questions about them or would like help
writing one for your system, please contact the folks at:

  MITgcm-support <MITgcm-support@mitgcm.org>

The convention is to name the directories here after the machine (or
"system" or site) where the scripts are known (or were known at one
time) to run.  Directories are used since each system may use multiple
different testing scripts.


=====  Why does it work this way?  =====

We're sorry that testreport does not work 100% automatically on all
MPI systems.  The problem is that the $MPIRUN or equivalent command is
different on almost every system.  Even on a single system, there may
be a variety of different $MPIRUN executables and each one might take
slightly different arguments, etc.  And these $MPIRUN issues are
further complicated by their (often *forced*) interactions with
whatever queueing system is in effect.  Many systems (eg. UCAR/NCAR)
will not allow a user to run any MPI programs--even small
ones--outside of their queueing system.  So the MPI programs *MUST* be
submitted through the queue.

And this means that you have to get all of the queue system details
right including (but not limited to!):

  - $QRUN syntax (PBS vs LoadLeveler vs Condor vs ...)
  - paths to /scratch disks for input and output
  - shells and shell parameters
  - "module" conventions (PATHs)
  - etc-etc-etc...

Unfortunately, these details can vary wildly from one system to the
next and often require per-user customizations.

These example scripts are meant only as templates!

============================================
Example: "4x4 Global Simulation with Seasonal Forcing"
============================================
(see also similar set-up in: verification/tutorial_global_oce_latlon/)

From verification/global_ocean.90x40x15 dir:

Configure and compile the code:
  cd build
  ../../../tools/genmake2 -mods ../code [-of my_platform_optionFile]
 [make Clean]
  make depend
  make
  cd ..

To run:
  cd run
  ln -s ../input/* .
  ./prepare_run
  ln -s ../build/mitgcmuv .
  ./mitgcmuv > output.txt
  cd ..

There is comparison output in the directory:
  results/output.txt

There is comparison output in directory:
  (verification/global_ocean.90x40x15/) results

Comments:
o The input data is real*4.
o The surface fluxes are derived from monthly means of the NCEP climatology;
  - a matlab script is provided that created the surface flux data files from
    the original NCEP data: ncep2global_ocean.m in the diags_matlab directory,
    needs editing to adjust search paths.
o matlab scripts that make a simple diagnostic (barotropic stream function,
  overturning stream functions, averaged hydrography etc.) is provided in
  verification/tutorial_global_oce_latlon/diags_matlab:
  - mit_loadglobal is the toplevel script that run all other scripts
  - mit_globalmovie animates theta, salinity, and 3D-velocity field for
    a layer "iz", if "meanfields=0"

--------------------------------------------
Additional example:
  similar set-up, with the same executable, and using pkg/dwnslp:
to run this 2nd example:
  cd run ; rm *
  ln -s ../input.dwnslp/* .
  ln -s ../input/* .
  ./prepare_run
  ../build/mitgcmuv > output.dwnslp.txt
  cd ..

============================================
Use of "blank tiles" in conjunction with exch2 package:
============================================

This verification experiment also demonstrate the omission of tiles
(or processors) for tiles that are fully land cover and don't need computation.
The relevant config. files to be manipulated are:
* at compile time, in dir. code/: packages.conf, SIZE.h
* at run time, in dir. input/: data.exch2

To enable this feature requires package "exch2"
(see Section 6.2.4 "exch2: Extended Cubed Sphere Topology" of online manual),
i.e. in code/packages.conf add "exch2"

The basic layout of the experiment is Nx*Ny = 90x40.
In a single-processor config. with very small tile sizes (sNx*sNy=10*10)
this can be represented, e.g. via
     &           sNx =  10,
     &           sNy =  10,
     &           OLx =   3,
     &           OLy =   3,
     &           nSx =   9,
     &           nSy =   4,
     &           nPx =   1,
     &           nPy =   1,
i.e. we use nSx*nSy=9*4=36 virtual processors.

An equivalent parallel setup using 9 virtual and 4 real processors
would look like:
     &           sNx =  10,
     &           sNy =  10,
     &           OLx =   3,
     &           OLy =   3,
     &           nSx =   9,
     &           nSy =   1,
     &           nPx =   1,
     &           nPy =   4,

In this layout it turns out that tile number 30 is "empty", i.e. fully land covered.
We wish to remove this tile from our calculation. How to proceed?

1. Find out which tiles to eliminate via a config. that uses all tiles
---
1.1. At compile time:
* add line "exch2" to packages.conf
* configure SIZE.h using your desired individual tile size, e.g. sNx*sNy=10*10, as follows:
     &           sNx =  10,
     &           sNy =  10,
     &           OLx =   3,
     &           OLy =   3,
     &           nSx =   9,
     &           nSy =   1,
     &           nPx =   1,
     &           nPy =   4,
  As described above you are using 4 real processors with 9 virtual tiles per processor.
* compile (don't forget to compile via -mpi or similar)

1.2 At runtime:
* need to reflect your basic layout in data.exch2
  This is simple: since you are not using any non-trivial topology with
  multiple facets (such as cubed-sphere),
  you only need to specify one basic facet (Nx,Ny)=(90,40) layout via following line:
  dimsFacets = 90, 40,
  Then run the moodel, e.g. via:
  mpirun -np 4 ./mitgcmuv

1.3 Diagnose which tile numbers are empty:
* from STDOUT.000[0-3] you can infer which tiles are empty using following grep:
  grep "Empty tile" STDOUT.* | awk '{print "  " $6 ","}' > empty_tiles.txt
* In this example there's only one empty tile, and it is #30.

2. Configuring with empty tiles removed
---
2.1 At compile time:
   We've determined that 1 out of nSx*nPx*nSy*nPy=36 tiles is empty and can be removed,
   leaving 36-1=35 non-empty tiles. We are free to re-order nSx,nPx,nSy,nPy in any way,
   as long as nSx*nPx*nSy*nPy=35. Here's how it's chosen in the verif. experiment
   (see file SIZE.h_mpi)
     &           sNx =  10,
     &           sNy =  10,
     &           OLx =   3,
     &           OLy =   3,
     &           nSx =   7,
     &           nSy =   1,
     &           nPx =   1,
     &           nPy =   5,
   and for which, as required nSx*nPx*nSy*nPy=35

2.2 At runtime:
We now need to specify in data.exch2 the number of the empty tile to be removed.
This is done as follows (see file data.exch2.mpi):
  blankList  = 30,
If there were more empty tiles, this would be a more extensive index array, e.g.
  blankList = tile1, tile2, tile3, ...
Now run the model (note that we've selected nPy=5, so in this example we actually
*increase* the number of "real" processors used, despite reducing the number of
total, i.e. "real" plus virtual tiles from 36 to 35):
mpirun -np 5 ./mitgcmuv

============================================
Adjoint set-up example:
============================================

Configure and compile the code:
  cd build
  ../../../tools/genmake2 -mods='../code_ad'
 [make Clean]
  make depend
  make adall
  cd ..
To run the code:
  cd run ; rm *
  ln -s ../input_ad/* .
  ./prepare_run
  ../build/mitgcmuv_ad > output_adm.txt
  cd ..

Gray atmosphere physics example on Cubed-Sphere grid
============================================================

Use gray atmospheric physics (O'Gorman and Schneider, JCl, 2008)
from package `atm_phys` inside  MITgcm dynamical core, in a global
cubed-sphere grid set-up (6 faces 32x32, 26 levels, non uniform deltaP).

### Overview:
This experiment contains 2 aqua-planet like set-ups (with corresponding `input[.*]/` dir)
that can be run with the same executable (built from `build/` dir using customized
code from `code/`); binary input files have been generated using matlab script
`gendata.m` from the `input` dir.
Both test experiments start from a spin-up state using pickup files written after 1 year.

The **primary** test, using input files from `input/` dir,
has an interactive SST with a 10m mixed layer depth and a prescribed,
time-invariant Q-flux. It also includes a weak damping of stratospheric winds.

The **secondary** test, using files from `input.ape/` dir, is the same as the primary
test but without stratospheric wind damping, and uses prescribed idealized SST from
Neale and Hoskins, 2001, Aqua-Planet Experiment (APE) project.

### Instructions:
Configure and compile the code:

```
  cd build
  ../../../tools/genmake2 -mods ../code [-of my_platform_optionFile]
  make depend
  make
  cd ..
```

To run primary test:

```
  cd run
  ln -s ../input/* .
  ./prepare_run
  ../build/mitgcmuv > output.txt
```

There is comparison output in the directory:

  `results/output.txt`

To run secondary "ape" test:

```
  cd run
  rm *
  ln -s ../input.ape/* .
  ln -s ../input/* .
  ./prepare_run
  ../build/mitgcmuv > output.txt
```
There is comparison output in the directory:

  `results/output.ape.txt`

### Notes:
There are special compiler options inside `build/genmake_local` to allow to compile
some of the files from `pkg/atm_phy` ; this requires to provide explicitly an optfile
to the `genmake2` command.

Package longstep
================

This package allows the passive tracer time step to be longer than that for
dynamical fields: the ptracers are updated only every LS_nIter time step. 
Dynamical fields are averaged over LS_nIter time steps and are available as
fields LS_* (declared in LONGSTEP.h):

original fld.  averaged fld.
------------------------------               
UVEL           LS_uVel
VVEL           LS_vVel
WVEL           LS_wVel
THETA          LS_theta
SALT           LS_salt
IVDConvCount   LS_IVDConvCount
Qsw            LS_Qsw
               
Kwx            LS_Kwx
Kwy            LS_Kwy
Kwz            LS_Kwz
               
KPPdiffKzS     LS_KPPdiffKzS
KPPghat        LS_KPPghat

The T and S time step remains the same as that for u,v,...


Packages that use ptracers (like DIC) need to be adapted:

1. replace dtTracerLev by PTRACERS_dTLev
2. replace THETA, SALT, etc. by their longstep averages from the table above.
   This should be made between #ifdef ALLOW_LONGSTEP ... #endif.
   (You need to #include "LONGSTEP.h")

The package is activated by including "longstep" in packages.conf.  There is
no "use_LONGSTEP", the package is always on when compiled.


The run-time parameters are set in data.longstep.  The default is:

 &LONGSTEP_PARM01
 LS_nIter=1,
 LS_whenToSample=0,
 &

LS_nIter        :: number of dynamical time steps between ptracer time steps.
LS_whenToSample :: when to sample dynamical fields for the longstep average
                   0 - at beginning of timestep (reproduces offline results)
                   1 - after first THERMODYNAMICS but before DYNAMICS
                       (use use old U,V,W for advection, but new T,S for GCHEM if
                       staggerTimeStep=.FALSE.; reproduces online with
                       staggerTimeStep=.FALSE. for LS_nIter=1)
                   2 - after DYNAMICS and second THERMODYNAMICS
                       (use new U,V,W and T,S; reproduces online with
                       staggerTimeStep=.TRUE. for LS_nIter=1)

Default is to sample dynamical fields at the beginning of the time step.  This
reproduces results from offline runs with unshifted time averages used for the
dynamical fields.

To have a time stepping closer to the online model (and reproduce results
for LS_nIter=1), use

LS_whenToSample=1 if staggerTimeStep=.FALSE.
LS_whenToSample=2 if staggerTimeStep=.TRUE.

API Discussions:
================

As discussed in our group meeting of 2003-12-17 (AJA, CNH, JMC, AM,
PH, EH3), the NetCDF interface should resemble the following FORTRAN
subroutines:

  1) "stubs" of the form:  MNC_WV_[G|L]2D_R[S|L] ()

  2) MNC_INIT_VGRID('V_GRID_TYPE', nx, ny, nz, zc, zg)

  3) MNC_INIT_HGRID('H_GRID_TYPE', nx, ny, xc, yc, xg, yg)

  4) MNC_INIT_VAR('file', 'Vname', 'Vunits', 'H_GTYPE', 'V_GTYPE', PREC, FillVal)

  5) MNC_WRITE_VAR('file', 'Vname', var, bi, bj, myThid)

This is a reasonable start but its inflexible since it isn't easily
generalized to grids with dimensions other than [2,3,4] or grids with
non-horizontal orientations (eg. vertical slices).


Generalizing what we would like to write as "variables defined on 1-D
to n-D grids", one can imagine a small number of objects containing
all the relevant information:

  a dimension:   [ name, size, units ]
  a grid:        [ name, 1+ dim-ref ]
  a variable:    [ name, units, *1* grid-ref, data ]
  an attribute:  [ name, units, data ]
  a NetCDF file: [ name, 0+ attr, 0+ grid-ref, 0+ var-ref ]

which can then be manipulated (created, associated, destroyed, etc.)
using a simple interface such as:

  MNC_INIT(              myThid )

  MNC_FILE_CREATE(       fname, myThid )
  MNC_FILE_OPEN(         fname, itype, myThid )
  MNC_FILE_ADD_ATTR_STR( fname, atname, sval, myThid )
  MNC_FILE_ADD_ATTR_DBL( fname, atname, len, dval, myThid )
  MNC_FILE_ADD_ATTR_REAL(fname, atname, len, rval, myThid )
  MNC_FILE_ADD_ATTR_INT( fname, atname, len, ival, myThid )
  MNC_FILE_ADD_ATTR_ANY( fname, atname, atype, cs,len,dv,rv,iv, myThid )
  ...
  MNC_FILE_READ_HEADER(  fname, myThid )

  MNC_DIM_INIT(          fname, dname, dlen, myThid )

  MNC_GRID_INIT(         fname, gname, ndim, dnames, myThid )

  MNC_VAR_INIT_DBL(      fname, gname, vname, units, myThid )
  MNC_VAR_INIT_REAL(     fname, gname, vname, units, myThid )
  MNC_VAR_INIT_INT(      fname, gname, vname, units, myThid )
  MNC_VAR_INIT_ANY(      fname, gname, vname, units, type, myThid )
  MNC_VAR_ADD_ATTR_STR(  fname, vname, atname, sval, myThid )
  MNC_VAR_ADD_ATTR_DBL(  fname, vname, atname, nv, dval, myThid )
  MNC_VAR_ADD_ATTR_REAL( fname, vname, atname, nv, rval, myThid )
  MNC_VAR_ADD_ATTR_INT(  fname, vname, atname, nv, ival, myThid )
  MNC_VAR_ADD_ATTR_ANY(  fname, vname, atname, atype, cs,len,dv,rv,iv, myThid )
  MNC_VAR_WRITE_DBL(     fname, vname, var, myThid )
  MNC_VAR_WRITE_REAL(    fname, vname, var, myThid )
  MNC_VAR_WRITE_INT(     fname, vname, var, myThid )
  MNC_VAR_WRITE_ANY(     fname, vname, vtype, dv, rv, iv, myThid )
  ...
  MNC_VAR_READ(          fname, vname, var, myThid )

  MNC_FILE_SYNC(         fname, myThid )
  MNC_FILE_CLOSE(        fname, myThid )


Heres a further "convenience wrapper" written on top of the above UI:

  MNC_CW_INIT(  Gtype, Htype, Hsub, Vtype, Ttype, wHalo, myThid )

    with pre-defined           -      xy    -      -      n
    combinations:              U      x     c      t      y
    'Cen_xy_c_t_Hn'            V      y     i
    'U_xy_i_t_Hn',             Cen
    'Cor_x_-_-_Hy'             Cor

  MNC_CW_SET_UDIM( fbname, udim, myThid )

  MNC_CW_RX_W( 'R|D|I', fbname,bi,bj, vtype, indu, var, myThid )
  MNC_CW_RX_R( 'R|D|I', fbname,bi,bj, vtype, indu, var, myThid )
          |
	  +--  RX = 'RL', 'RS', or 'I'

  MNC_COMP_VTYPE_VAR( ind_vt, ind_fv_ids, ires, myThid )



To-Do:
======

 1) NAMING -- We should (as much as possible) try to name variables so
    that they are in agreement with the CF naming conventions.

 2) UNITS -- as with the names we need to follow conventions

 3) CNH pointed out that grid interpolation needs to be handled
    "on-the-fly" since pre-processing would result in overly large
    input files.  We need an interpolation API...

# Relaxation of a front in a channel : simplest example that uses GM-Redi parameterization


A 2-D, y-z set-up is used to mimic a zonally symmetric, reentrant channel with
a baroclinicly unstable initial density front.<br>
As meso-scale eddies are not resolved in this 2-D set-up, the GM-Redi
parameterization is used to represent their effects.

### Overview:
This experiment contains 5 set-ups (with corresponding `input[.*]/` dir) that
can be run with the same executable (built from `build/` dir using customized
code from `code/`); binary input files have been generated using matlab script
`gendata.m` from the corresponding `input` dir. All five set-ups use a
simple EOS ( $\rho' = -\rho_0 ~ \alpha_T ~ \theta'$ ) and treat salt as a
passive tracer ; without any surface forcing, the density front is expected to
flatten (GM effect) while salinity spread along isopycnal (Redi diffusion).

The **primary** test, using input files from `input/` dir, is the simplest
one, with flat bottom, non-uniform resolution in both direction (15 levels
from 50 m to 400 m thick near the bottom and, in Y-direction, 32 grid-points
with about 10 km spacing) and stratified every-where (background
$N = 2\times 10^{-3} ~s^{-1}$, see matlab script `input/gendata.m`),
avoiding the need for tapering or clipping.<br>
It uses the skew-flux formulation of GM with same Redi and GM diffusivity (
`GM_background_K` = 1000 $m^2/s$, see: `input/data.gmredi`). Note that 10 dead
levels were added (below the bottom) to allow to use the same executable
(compiled with `Nr = 25`) for all 5 set-ups.

The **secondary** test `input.in_p/` dir is the same as the primary test but
converted to use P-coordinates instead of height coordinates. For the purpose
of comparing P and Z coordinates, gravity and reference density `rhoNil` are
set to round number (respectively 10 and 1000) to facilitate conversions. It
uses the advective form of GM with same Redi and GM diffusivity (see:
`input.in_p/data.gmredi`).

The **next two secondary** set-ups, `input.mxl/` and `input.bvp/` are very
similar, sharing the same binary input files from `input.mxl/` dir ; they use
the full 25 level model to represent a 10 level, 200 m thick mixed layer on
top of a stratified warm bowl of water.  The `input.mxl/` illustrates the use
of the transition-layer tapering scheme 'fm07' with the skew-flux formulation
of GM with same Redi and GM diffusivity ( `GM_background_K` = 1000 $m^2/s$,
see: `input.mxl/data.gmredi`) and a flat bottom while the secondary test
`input.bvp/` has a sloping bottom and uses the Boundary-Value Problem
(`GM_useBVP=T,` with 5 modes: `GM_BVP_modeNumber=5,`) of the GM advective form
with same Redi and GM diffusivity (see: `input.bvp/data.gmredi`). In addition,
in this later test, the sub-meso parameterization is activated
(`GM_useSubMeso=T`).

The **last secondary** test `input.top/` shares some similarity with the previous
one (similar warm bowl, use BVP with GM advective form) except that the model
top is depressed by 50 m near the center, as it would under, e.g., a floating
ice-shelf. Also the mixed layer is thinner (60 m only) and very weakly
stratified ( $N = 10^{-6} ~s^{-1}$ ) and vertical resolution is slightly
different, reaching a maximum depth of 2.5 km (vs only 2 km in the previous 2
set-ups).

### Instructions:
Configure and compile the code:

```
  cd build
  ../../../tools/genmake2 -mods ../code [-of my_platform_optionFile]
  make depend
  make
  cd ..
```

To run primary test:

```
  cd run
  ln -s ../input/* .
  ../build/mitgcmuv > output.txt
```

There is comparison output in the directory:

  `results/output.txt`

To run any of secondary `$sc` test (`$sc` in: `in_p`, `mxl`, `bvp`, `top`):

```
  cd run
  rm *
  ln -s ../input.$sc/* .
  ln -s ../input/* .
  ./prepare_run          #- only for "bvp" test
  ../build/mitgcmuv > output.txt
```
Note that the "prepare_run" step is only needed for `bvp` test.

There is comparison output in the directory:

  `results/output.$sc.txt`

### Notes:
1. **Comparison between P and Z coordinates**:

    The results from the secondary set-up `input.in_p/`, using Pressure
    coordinate, can be compared to the Z-coordinate, primary set-up `input/`,
    providing one uses the same `pkg/gmredi` parameters (same 'data.gmredi'),
    e.g.:

    - Using GM advective form, with 'data.gmredi' from `input.in_p/` for both
      runs.

    - Using the GM skew-flux form, with 'data.gmredi' from `input/` for both
      runs.

    Note that, when comparing output, the vertical index `k` of 3-D variables
    needs to be flipped ; the SSH (in m) comparison is between output variable
    'Eta' (in-Z) and 'PHL' (in-P) divided by 10 (=gravity); and the bottom
    pressure (in Pa) is between 'PHL' (in-Z) multiplied by $1000 = \rho_0$ and
    'Eta' (in-P).<br>
    Most of the differences (e.g., after 20 time-steps, T,S max-diff are:
    $1.4\times 10^{-4}$, $2.3 \times 10^{-5}$ and RMS: $6.6 \times 10^{-5}$,
    $9.6 \times 10^{-6}$ ) come from the dynamics and not from GM since without
    dynamics (un-commenting line 34: `momStepping=.FALSE.,` in both set-up
    `data` files) the differences are down to machine precision (RMS of T,S
    diff: $1.5 \times 10^{-14}, ~ 1. \times 10^{-15}$ ).

2. **Testing GM or Redi diffusion alone** in either of the 2 set-ups above:

    To test GM alone, without isopycnal diffusion, just un-comment:
    `GM_isopycK = 0.,` in `data.gmredi`.<br>
    And to test Redi diffusion alone, without GM, just set: `GM_isopycK =
    1000.,` and comment out `GM_background_K` setting in `data.gmredi`. Also
    changing the initial salinity to a centered patch (using file
    `Sini_Patch.bin` instead of `Sini_Ydir.bin`) better illustrates the Redi
    effects on a passive tracer.

3. **Switching from a Y-Z to X-Z set-up**

    Since none of the 5 set-up use any feature specific to Y-direction, all
    using 'f-plane' (`f0 = 1.E-4, beta=0`), the same set of input files could
    be used by the X-Z model instead of the current Y-Z model (simply
    switching `sNx,nSx,nPx` <-> `sNy,nSy,nPy` in `SIZE.h`) to produce similar
    results (flipping U & V with 1 minus sign). The only minor adjustment to
    input files is related to the setting of delX, delY in the parameter file
    `data`, which also need to be switched, e.g., for the primary set-up:

    ```
     delXfile='dy.bin',
     delY=1*10.E3,
    ```
    instead of:

    ```
     delX=1*10.E3,
     delYfile='dy.bin',
    ```
    This may be used to verify implementation of X-fluxes versus Y-fluxes.

Example: "4 Layer Double Gyre with Pressure Loading"
====================================================

Comments:
The input data is real*8 and can be generated with the supplied
matlab script gendata.m
To change the input precision to real*4 change readBinaryPrec=32 in
data as well as in gendata.m

The experiment follow roughly the analytical analysis
Wunsch and Stammer, Atmospheric loading and the oceanic "inverted
barometer" effect. Rev. Geophys., 35, pp. 79-107, 1997.

# Global Ocean Simulation at 4 degree Resolution, Alternative Forcing
Quasi-global ocean set-up, $`80^\circ`$S -- $`80^\circ`$N, at $`4^\circ`$
horizontal resolution with 15 vertical levels.

This experiment has been moved (PR #944) inside `global_oce_latlon`,
and is now run there as a secondary test (`global_oce_latlon.ebm`) using
`input.ebm/` and `input_ad.ebm/` for the forward and adjoint test respectively.

Original Description:
=====================

### Overview:
This experiment is derived from `tutorial_global_oce_latlon` (see also
`global_ocean.90x40x15`) and relies on Energy-Balance Model
package (`pkg/ebm`) to compute oceanic surface forcing.<br>

The adjoint test, with customized code in `code_ad` and input files in `input_ad/` dir, provides
an adjoint set-up of the forward primary tests with some adjoint specific simplifications
(less compiled pkgs, simpler GM-Redi code, no time-dependent control ...).

### Instructions for Forward tests:
Configure and compile the code:
```
  cd build
  ../../../tools/genmake2 -mods ../code [-of my_platform_optionFile]
 [make Clean]
  make depend
  make
  cd ..
```

To run primary test:
```
  cd run
  ln -s ../input/* .
  ../build/mitgcmuv > output.txt
  cd ..
```

There is comparison output in the directory:
  `results/output.txt`

### Instructions for Adjoint tests:
Note: This requires access to a TAF license.<br>
Configure and compile the code:
```
  cd build
  ../../../tools/genmake2 -mods ../code_ad [-of my_platform_optionFile]
 [make Clean]
  make depend
  make adall
  cd ..
```

To run:
```
  cd run
  ln -s ../input_ad/* .
  ../input_ad/prepare_run
  ../build/mitgcmuv_ad > output_adm.txt
  cd ..
```

There is comparison output in the directory:
  `results/output_adm.txt`

***************************************************************************************
|                               Initialisation                                        |
***************************************************************************************

MITCOMPONENT_init
=================

      CALL MITCOMPONENT_init( 
     I                  name, 
     O                  comm )
      
      name - Name of component to register e.g.
             'ocean', 'atmos', 'ice', 'land'. Up to
             MAX_COMPONENTS ( see "CPLR_SIG.h" )
             are allowed. Default is MAX_COMPONENTS = 10.

      comm - MPI_Communicator which includes all procs.
             that registered as component type 'name.

      Each process can only register as one component type.

      Every process has to call MITCOMPONENT_init at the
      same point otherwise everything deadlocks or dies.
      Except the coupler process which calls MITCOUPLER_init.

      Initialises the MPI context for a particular component
      model. On return the component is given a communicator
      that can be used for communication based on MPI
      for the processes of the component. Internal 
      coupler data structures are also populated that
      hold information about the component. Typical start-up 
      sequence is

      Ocean model (N processes)
        :
        :
      MPI_Init
      MITCOMPONENT_init('Ocean', MPI_COMM_Ocean )
             
      Atmos model (M processes)
        :
        :
      MPI_Init
      MITCOMPONENT_init('Atmos', MPI_COMM_Atmos )

      Coupler (one process only)
        :
        :
      MPI_Init
      MITCOUPLER_init( 'Coupler', MPI_COMM_Coupler )
             

MITCOMPONENT_tile_register
==========================
      MITCOMPONENT_tile_register(
     I                           ntx, nty, ireg, rreg )
      ntx  - number of tiles in X to register
      nty  - number of tiles in Y to register
      ireg - array of integer tile attributes. 
             Current attributes are:
             ireg(1,bi,bj) - tile size in X
             ireg(2,bi,bj) - tile size in Y
             ireg(3,bi,bj) - tile base coordinate on global grid in X
             ireg(4,bi,bj) - tile base coordinate on global grid in Y
             Declared:
             INTEGER IREG(4,NTX,NTY)

      rreg - array of float (32-bit) tile attributes
             Current attributes are:
             rreg is not used at the moment.
             Declared:
             REAL*4 RREG(4,NTX,NTY)

MITCOMPONENT_register
=====================
      MITCOMPONENT_register( 
     I                      nx, ny, 1, 1 )
      routine for registering tile size for a single tile model.
      Deprecated - use MITCOMPONENT_tile_register with ntx and nty
      set to 1. This routine will not be supported in future coupler releases.







***************************************************************************************
|                               Sending data                                          |
***************************************************************************************
COMPSEND_R4
===========
      COMPSEND_R4('Q_a',nx,0,ny,0,Q_surf)
      REAL*4 Q_surf(nx,ny)

COMPSEND_R4TILES
================
      COMPSEND_R4TILES('SST_o',nx,0,ny,0,1,nSx,nSy, SST)
      REAK*4 SST(SNX,SNY,NSX,NSY)

COMPSEND_R8TILES
================
      COMPSEND_R8TILES('Ocean Mask',nx,0,ny,0,1,nSx,nSy, landmask)
      REAK*8 LANDMASK(SNX,SNY,NSX,NSY)






***************************************************************************************
|                               Receiving data                                        |
***************************************************************************************
COMPRECV_R4
===========
      COMPRECV_R4('SST_a',nx,0,ny,0,SST)
      REAL*4 SST(nx,ny)
      CALL COMPRECV_R4(dataname,sNx,OLx,sNy,OLy,array)
      REAL*4 array(1-OLx:sNx+OLx,1-OLy:sNy+OLy)

COMPRECV_R8
===========
      COMPRECV_R8('Ocean Mask',nx,0,ny,0,landmask)
      REAL*8 landmask(nx,ny)
      CALL COMPRECV_R8(dataname,sNx,OLx,sNy,OLy,array)
      REAL*8 array(1-OLx:sNx+OLx,1-OLy:sNy+OLy)

Tutorial Example: "Biochemistry Tutorial"
=========================================
(formerly "dic_example" verification)

--- Instructions for Forward tests:

Configure and compile the code:
  cd build
  ../../../tools/genmake2 -mods ../code [-of my_platform_optionFile]
  make depend
  make
  cd ..

To run:
  cd run
  ln -s ../input/* .
  ./prepare_run
  ../build/mitgcmuv > output.txt
  cd ..

There is comparison output in the directory:
  results/output.txt

-- Instructions for Adjoint tests:
Note: This requires access to a TAF license.

Configure and compile the code:
  cd build
  ../../../tools/genmake2 -mods ../code_ad [-of my_platform_optionFile]
  make depend
  make adall
  cd ..

To run:
  cd run
  ln -s ../input_ad/* .
  ./prepare_run
  ../build/mitgcmuv_ad  > output_adm.txt
  cd ..

There is comparison output in the directory:
  results/output_adm.txt

--- Comments:

Example using floats (pkg/flt) based on verification/exp4
=========================================================
This experiment has been moved (PR #830) inside `exp4` and is now run there
as a secondary test ("exp4.with_flt") using `input.with_flt/`.

Configure and compile the code:
```
  cd build
  ../../../tools/genmake2 -mods ../code [-of my_platform_optionFile]
  make depend
  make
  cd ..
```
To run:
```
  cd run
  ln -s ../input/* .
  ln -s ../build/mitgcmuv .
  ./mitgcmuv > output.txt
  cd ..
```

There is comparison output in the directory:
  `results/output.txt`

Comments:
The input data is `real*8`.

Atmosphere-Ocean coupled set-up example "cpl_aim+ocn"
================================================================================
using simplified atmospheric physics (AIM), in realistic configuration (orography
& continent) with land and seaice component, on cubed-sphere (cs-32) grid.

### Overview:
Uses "in-house" MITgcm coupler<br>
(`pkg/atm_ocn_coupler`, `pkg/compon_communic`, `pkg/atm_compon_interf`,
`pkg/ocn_compon_interf`)<br>
with each component config and customized src code in: `code_cpl`, `code_atm`,
`code_ocn` ;<br>
and input parameter files in: `input_cpl`, `input_atm`, `input_ocn`.

- Atmos set-up and parameter is similar to `aim_5l_cs/` experiment
- Ocean set-up and parameter is similar to `global_ocean.cs32x15/` experiment

Requires the use of MPI; as default, use 1 proc for each component.

### Instructions:
To help getting started with this coupled set-up, the bash script
[../../tools/run_cpl_test](https://github.com/MITgcm/MITgcm/blob/master/tools/run_cpl_test)
(a short option summary is displayed when run without argument)
is provided and detailed instructions follow.

To clean everything:

    ../../tools/run_cpl_test 0

Configure and compile, e.g., using gfortran optfile:

    ../../tools/run_cpl_test 1 -of ../../tools/build_options/linux_amd64_gfortran

To run primary setup, thermodynamic seaice only (no seaice dynamics):

    ../../tools/run_cpl_test 2
    ../../tools/run_cpl_test 3

Step 2 above copies input files and directories, step 3 runs the coupled model.

To run secondary test (with seaice dynamics as part of ocean component), using
input parameter files in: `input_cpl.icedyn`, `input_atm.icedyn`, `input_ocn.icedyn`:

    ../../tools/run_cpl_test 2 icedyn
    ../../tools/run_cpl_test 3

Results are written in directories `rank_{0,1,2}`, for coupler, ocean and atmos
components, respectively.

There is comparison output corresponding to the primary set-up in the directory:<br>
`results/atmSTDOUT.0000` & `results/ocnSTDOUT.0000`<br>
and the secondary test, in the same directory:<br>
`results/atmSTDOUT.icedyn` & `results/ocnSTDOUT.icedyn`

##### Note:
To check the results, the monitor output can be compared to the reference (in `results/`)
using `run_cpl_test`, but this requires the additional comparison script `comp_res` and
the program `cmpnum.f`. Both can be found in GitHub repository
[MITgcm-contrib/jmc_scripts](https://github.com/MITgcm-contrib/jmc_scripts),
see README there. Once in place, step 4 performs the output comparison:<br>
For primary set-up:

    ../../tools/run_cpl_test 4

and for secondary test:

    ../../tools/run_cpl_test 4 icedyn

Example: "4x4 Steady Global Simulation"
=======================================

The notes for this experiment are now on-line.  Please see the third
chapter ("Getting started with MITgcm") which is available at:

  http://mitgcm.org/public/r2_manual/latest/online_documents/node1.html

Tutorial Example: "P coordinate Global Ocean"
(Global Ocean Simulation at 4o Resolution in Pressure Coordinates)
==================================================================
(formerly "global_ocean_pressure")

Configure and compile the code:
  cd build
  ../../../tools/genmake2 -mods ../code [-of my_platform_optionFile]
  make depend
  make
  cd ..

To run:
  cd run
  ln -s ../input/* .
  ln -s ../build/mitgcmuv .
  ./mitgcmuv > output.txt
  cd ..

There is comparison output in the directory:
  results/output.txt

Comments:
o the set up is similar to that of tutorial_global_oce_latlon
o the code directory contains calc_phi_hyd.F, where the potential is computed
  according to the more natural finite volume discretization. Finite difference
  discretization is energy conserving, but the representation of the "fixed"
  surface (interface ocean-atmosphere) is less consistent.
o the code directory also contains dynamics.F which calls
  remove_mean_rl.F, a generic routine, to remove the mean from the
  diagnostic variable phiHydLow (sea surface height/gravity in pressure
  coordinates)

changes: 07 Feb. 2003 (jmc):
o find difficult to maintain the local version of dynamics.F up to date.
  therefore, has been remove from the code directory.
  One can recover the same version (but up to date) simply
  by activating the commented lines [between lines Cml( and Cml) ],
  at the end of the standard version of dynamics.F
o finite volume form of calc_phi_hyd.F is now a standard option.
  only needs to set integr_GeoPot=1 in file "data" to select this form.

Tutorial Example: "Global Ocean State Estimation"
(Global Ocean State Estimation at 4.o Resolution)
=================================================

Configure and compile the code:
  cd build
  ../../../tools/genmake2 -mods ../code_ad [-of my_platform_optionFile]
  make depend
  make adall
  cd ..

To run:
  cd run
  ln -s ../input_ad/* .
  ./prepare_run
  ln -s ../build/mitgcmuv_ad .
  ./mitgcmuv_ad > output_adm.txt
  cd ..

There is comparison output in the directory:
  results/output_adm.txt

grep for grdchk output:
  grep 'grdchk output' output_adm.txt

Comments:

heimbach@mit.edu, 16-Aug-2001

The following files (and probably only those) could
potentially cause problems in the context of AD,
i.e. may leed to large sensitivities:

- gmredi_calc_tensor:
  (all for the case GM_VISBECK_VARIABLE_K)
         N2=(-Gravity*recip_Rhonil)/dRdSigmaLtd(i,j)
         SN=sqrt(Ssq*N2)
        VisbeckK(i,j,bi,bj)=
     &     min(VisbeckK(i,j,bi,bj),GM_Visbeck_maxval_K)

- gmredi_slope_limit:
  gradSmod, Small_Number, dSigmaDrLtd, Smod
  Lrho=Cspd/abs(Fcori(i,j,bi,bj))

Five level intermediate atmospheric physics example.
 Experimental configuration is an equatorial channel
 of 65 degrees wide cented on the Equator. A warm SST anomaly
 with a gaussian shape is defined at the center of the domain
 with an extension of ~30 degrees meridionally and ~60 degrees
 zonally.

The local copy of S/R aim_surf_bc.F (in code directory) provide
a) the SST field (hard coded).
b) the time in the year is fixed and corresponds to the spring equinox;
 this ensures a symetric forcing between N & S hemispheres.
The model uses the standard 5-level vertical resolution of the Speedy_v23
 code; the horizontal resolution is 2.8125 with 128x23 grid points.

====================================================================

Configure and compile the code:
  cd build
  ../../../tools/genmake2 -mods ../code [-of my_platform_optionFile]
  make depend
  make
  cd ..

To run:
  cd run
  ln -s ../input/* .
  ln -s ../build/mitgcmuv .
  ./mitgcmuv > output.txt
  cd ..

There is comparison output in the directory:
  results/output.txt

---------------------------
Notes:
* To produce a short test that is relevant for the Atmosphere physics part,
  a restart file (pickup.0000051840) is included. The model reaches
  a statistical equilibrium after 1 year.
* the file aim_SST.* contains the SST field.
* Since aim pkg uses arrays with MAX_NO_THREADS as dimension, the maximum
  number of treads is set to 1 (in code/EEPARAMS.h) instead of 32, so that the
  size of the executable is reduced. This obviously needs to be changed
  before compiling on a multi-threaded platform.
---------------------------
Northern boundary :
o initially, the domain (SIZE.h) 128x24x5 with a land line as the Northern
  boundary, reduciong the effective domain to 128x23x5.
o To have a more efficient code (and a good starting point for MIT Atmos.
  Physics), the new domain (SIZE.h) is now 128x23x5 .
  Northern and Southern boundaries are "closed" like the in Lat-Lon set-up.

Seaice-only verification experiment in idealized periodic channel
-----------------------------------------------------------------

1) main forward experiment (code, input)

  Re-entrant zonally periodic channel (80x42 grid points) with just level (Nr=1)
   uniform resolution (5.km, 10m), solid Southern boundary with triangular shape
   coastline ("bathy_3c.bin")

  Use seaice (dynamics & thermodynamics from pkg/thsice) with EXF (see data.pkg)
   with initial ice thickness of 0.2 m (but no snow)
   (thSIceThick_InitFile='const+20.bin', in "input/data.ice")
  Initial seaice concentration is 100 % everywhere
   (thSIceFract_InitFile='const100.bin', in "input/data.ice")
  and seaice is initially at rest.

  At runtime turn off time-stepping in 'data', PARM01, using:
    momStepping  = .FALSE.,
    saltStepping = .FALSE.,
    tempAdvection=.FALSE.,
  And just keep surface temp relaxation (tauRelax = 1 month) toward fixed SST:
   in data.exf :
  > climsstperiod      = 0.0,
  > climsstTauRelax    = 2592000.,
  >  climsstfile       = 'tocn.bin',

 Forcing:
  None of the forcing vary with time; Most of the input files have been
   generated using matlab script "input/gendata.m".
  SST relaxation field is uniform in X, parabolic function of Y with
   maximum close to Southern boundary.

  Atmospheric air temp is uniform in Y, and only vary with X (~sin(2.pi.x/Lx))
   with an amplitude of 4.K ('tair_4x.bin');
  Uses constant Relative Humidity (70%, file 'qa70_4x.bin')
  constant and uniform downward shortwave (100.W/m2, 'dsw_100.bin'),
                       downward longwave (250.W/m^2, 'dlw_250.bin'),
                       zonal wind (10.m/s, 'windx.bin'),
  no meridional wind, no precip.

  Ocean surface currents comes from a 3 levels ocean-only run (without seaice)
   using the same wind forcing (uVel_3c0.bin, vVel_3c0.bin) (matlab script:
  "input/getdata.m")

  Two matlab scripts ("input/grph_res.m" and "input/grph_diag.m")
   are provided to make some basic plots (snap-shot and time-averaged
   diagnostics).

2) other (secondary) experiments (using the same executable)

 a) seaice-dynamics only with LSR solver (input.dyn_lsr/)
  use same forcing as main forward experiment,
  ( link input files from "input.dyn_lsr/" dir 1rst, then from "input/" dir )
  but does not use at all pkg/thsice (advect pkg/seaice properties using
   pkg/seaice advection S/R.); turn off seaice thermodynamics
  (usePW79thermodynamics=.FALSE., in input.dyn_lsr/data.seaice).

 b) seaice-dynamics only with JNFK solver (input.dyn_jfnk/)
  use same forcing as main forward experiment,
  ( link input files from "input.dyn_jfnk/" dir 1rst, then from "input/" dir )
  turn off seaice thermodynamics (thSIce_skipThermo=.TRUE., in file
   "input.dyn_jfnk/data.ice") and advect pkg/thsice properties using
   pkg/thsice advection S/R.

 c) seaice-dynamics only with LSR solver and elliptical yieldcurve with
    non-normal flow rule (input.dyn_ellnnfr)
  use same forcing as main forward experiment,
  ( link input files from "input.dyn_ellnnfr/" dir 1rst, then from
    "input.dyn_lsr/" and "input/" dir )
  advect pkg/seaice properties using pkg/seaice advection S/R.;
  turn off seaice thermodynamics (usePW79thermodynamics=.FALSE., in
   input.dyn_ellnnfr/data.seaice).

 d) seaice-dynamics only with LSR solver and Mohr-Coulomb
    yieldcurve with elliptical plastic potential (input.dyn_mce)
  use same forcing as main forward experiment,
  ( link input files from "input.dyn_mce/" dir 1rst, then from
    "input.dyn_lsr/" and "input/" dir )
  advect pkg/seaice properties using pkg/seaice advection S/R.;
  turn off seaice thermodynamics (usePW79thermodynamics=.FALSE., in
   input.dyn_mce/data.seaice).

 e) seaice-dynamics only with KRYLOV solver and parabolic lens yieldcurve
    (input.dyn_paralens)
  use same forcing as main forward experiment,
  ( link input files from "input.dyn_paralens/" dir 1rst, then from
    "input.dyn_jfnk/" and "input/" dir )
  turn off seaice thermodynamics (thSIce_skipThermo=.TRUE., in file
   "input.dyn_mce/data.ice" linked from "input.dyn_jfnk/") and
   advect pkg/thsice properties using pkg/thsice advection S/R.

 f) seaice-dynamics only with JFNK solver and teardrop yieldcurve
    (input.dyn_teardrop)
  use same forcing as main forward experiment,
  ( link input files from "input.dyn_teardrop/" dir 1rst, then from
    "input.dyn_jfnk/" and "input/" dir )
  turn off seaice thermodynamics (thSIce_skipThermo=.TRUE., in file
   "input.dyn_mce/data.ice" linked from "input.dyn_jfnk/") and
   advect pkg/thsice properties using pkg/thsice advection S/R.

 g) seaice-thermodynamics only from pkg/seaice (input.thermo/)
  use same forcing as main forward experiment,
  ( link input files from "input.thermo/" dir 1rst, then from "input/" dir )
  Except a different bathymetry (no triangular shape coast line in the South,
   just a simple channel of constant width, with constant and uniform
   zonal current of 0.2 m/s):
   in "input.thermo/data":
    bathyFile = 'channel.bin',
    uVelInitFile    = 'const+20.bin',
    vVelInitFile    = 'const_00.bin',
  And use different initial seaice concentration from the main forward experiment:
   (in "input.thermo/data.seaice", AreaFile = 'ice0_area.bin',
                               and HeffFile = 'ice0_heff.bin',)
   100 % everywhere except in the 1rst and last 2 rows: 0., 10.% in the South
   and 1.%, 0. in the North:
  Turn off seaice dynamics (SEAICEuseDYNAMICS =.FALSE., in
   "input.thermo/data.seaice") which implies no advection (zero ice velocity).

 h) seaice-thermodynamics only from pkg/thsice (input.thsice/)
  use same forcing as main forward experiment,
  ( link input files from "input.thsice/" dir 1rst, then from "input/" dir )
  Except for bathymetry and initial seaice concentration which are identical
   to the one used in input.thermo/ :
   (thSIceFract_InitFile='ice0_area.bin', in "input.thsice/data.ice")
  No seaice dynamics and no seaice advection, so that none of pkg/seaice S/R
   are used (useSEAICE = .TRUE., commented out in "input.thsice/data.pkg"),

3) main adjoint experiment (code_ad, input_ad)
  Use similar forward set-up as "input.thermo/",
  no seaice dynamics and no seaice advection.

4) other (secondary) adjoint experiment (using the same executable)

 a) seaice-thermodynamics form pkg/thsice (input_ad.thsice)
  use similar forward set-up as  "input.thsice",
  no seaice dynamics and no seaice advection.

test - experiment : ideal_2D_oce

purpose: Shows that the residual mean circulation is becoming small
 at the Equilibrium (Bolus cancel the Euleurian circ.) and is function
 of the diapycnal mixing.

Set up:
 Idealized 2D global ocean with flat bathymetry and no continent,
 symetric relative to the Eq.
 Forcing: zonal wind stress and surface temp. relaxation toward a
 "realistic" SST (function of Latitude).

To reduce diapycnal mixing, "exotic" parameters are used (and tested)
in this test-experiment:
a) vertical discretization: interface at the middle (use delRc)
b) GM advect form
c) use Visbeck
d) GM advect(Euler+Bolus) and Flux Limit Adv scheme.
e) 3 different time-steps (MOM,FS,Tracer)
f) oceanic exp using stagger time stepping
g) oceanic exp using cg2dTargetResWunit

Simple set-up to test flow-dependent horizontal viscosity implementation.

 Domain size is 50 x 26 x 40 grid-cells,
 with uniform resolution dx=dy= 1.km , dz = 5.m

 Zonally re-entrant, flat bottom channel (closed by Northern Wall @ j=26)

 input files are real*8 (see matlab script input/gendata.m )

 start from initial density field (given by initial Temp), no forcing

 Test Exp. |  Momentum   |  Viscosity  | useFullLeith | Biharmonic | side-drag   |
           | formulation | formulation |              | vs harmonic| (no_slip BC)|
----------------------------------------------------------------------------------
 standard  | Vector-Inv. |  Vort-Div   |  FullLeith   |   viscC4   |    No       |
(dir=input)|             |             |              |            |             |
----------------------------------------------------------------------------------
 .A4FlxF   |  Flux-Form  |  FLux-Form  |  FullLeith   |   viscC4   |    Yes      |
----------------------------------------------------------------------------------
 .AhFlxF   |  Flux-Form  |  Flux-Form  |    No        |   viscC2   |    No       |
----------------------------------------------------------------------------------
 .AhVrDv   | Vector-Inv. |  Vort-Div   |  FullLeith   |   viscC2   |    Yes      |
----------------------------------------------------------------------------------
 .AhStTn   | Vector-Inv. | Strain-Tens |  FullLeith   |   viscC2   |    Yes      |
----------------------------------------------------------------------------------
 .QGLeith  | Vector-Inv. |  Vort-Div   |  FullLeith   |   viscC2   |    Yes      |
----------------------------------------------------------------------------------
 .QGLthGM  | Vector-Inv. |  Vort-Div   |  FullLeith   |   viscC2   |    Yes      |
----------------------------------------------------------------------------------

Notes:
1) Stain-Tension viscosity formulation is used when setting
     useStrainTensionVisc=.TRUE.,
   and currently only available with Vector-Invariant momentum.
   Default is .False., to use Vorticity & Divergence formulation
   (pkg/mom_vecinv) or Flux-Form formulation (pkg/mom_fluxform)
2) test .A4FlxF (input.A4FlxF) starts from a pickup-file,
   all other test exp. start from iter0=0
3) test with Biharmonic visc. are using:
    viscC4leith = viscC4leithD = 1.85,
    viscC4smag  = 1.,
    viscA4GridMax = 1.,
4) test with Harmonic visc. are using:
    viscC2leith = viscC2leithD=1.85,
    viscC2smag  = 1.,
    viscAhGridMax = 1.,

-------------------------------------

Contents of the ADFirstAidKit
=============================

## adStack.c && adStack.h
  Mechanism for the main stack used by codes produced by Tapenade in reverse mode.
  Use these files regardless of the language of the reverse-differentiated code.
  For OpenMP compatibility, compile with option -fopenmp.

## adBinomial.c && adBinomial.h
  Primitives for Tapenade adjoint with binomial checkpoiting (cf Griewank-Walther
  "revolve" method). Triggered by Tapenade directive $AD BINOMIAL-CKP.

## (adContext.c || adContextMPI.c) && adContext.h
  Primitives used by Tapenade-differentiated code with automated validation.
  Triggered by tapenade command-line option -context.
  Use adContextMPI.c instead of adContext.c on MPI code.

## adContextCPX.c && adContextCPX.h
  Same as adContext, but to validate code differentiated with the command-line
  option -complexstep, which is an attempt to automate differentiation
  via the complex-step method.

## (adDebug.c || adDebugMPI.c) && adDebug.h
  Primitives used by Tapenade-differentiated code with automated debugging.
  Triggered by tapenade command-line option -context combined either with
  -debugTGT or with -debugADJ.
  Use adDebugMPI.c instead of adDebug.c on MPI code.

## adComplex.h
  Utility for adStack, adContext, adDebug

## admm.c && admm.h (might be integrated later into adBuffer)
  The "ADMM" primitives, which manage push/pop of pointers when the pointer's
  destination lies in memory chunks that have been deallocated and reallocated.

## admm_tapenade_interface.f90
  A Fortran90 module that must be USE'd by Tapenade-generated adjoint code,
  if these codes need push/pop of pointers or use ADMM primitives.

## adProfile.c && adProfile.h (Currently broken, sorry)
  Primitives used by Tapenade adjoint to measure the cost/benefit of checkpointing,
  to find parts of the code that should or shouldn't be checkpointed.

## fortranSupport.F && ampiSupport.c
  Files needed by AMPI, for Tapenade adjoint code of MPI programs.

## ampi
  Directory containing the include files needed by code using the "adjoinable mpi" library.
  This is primarily intended for some nonRegression tests. This is not the ampi install.

## PUSHPOPGeneralLib && PUSHPOPDiff.f
  Useful for repeated differentiation forward-on-reverse. Specification of the
  activity behavior of push/pop primitives + implementation of the forward
  derivatives of these primitives.

## testMemSizef.f && testMemSizec.c
  Short standalone code that tries to measure the size of primitive types in bytes.

## testpushpop.sh && testpushpop.f90
  Short standalone code to test push/pop primitives of adStack.c

## validityTest.f (Poorly tested, sorry)
  Primitives used by Tapenade tangent code to estimate how close the execution
  comes to non-differentiable behavior (e.g. tests).
  Triggered by tapenade command-line option -directValid.

## OLDadBuffer.c && OLDadBuffer.h && OLDadBuffer.f && OLDadStack.c && OLDadStack.h
  Old version of the stack mechanism used by reverse AD codes. The new adStack.c && adStack.h do not need adBuffer any more.
  With gfortran 10.2.1, use -fallow-argument-mismatch option to compile OLDadBuffer.f.

Notice that, in order to run some nonRegression tests, you may have to place manually into this ADFirstAidKit directory two symbolic links: one named "mpich" pointing to the include directory of your mpich insall, and another one named "openmpi" pointing to the include directory of your openmpi install.

Examples of parameter file "data.exch2" can be found here;
Some dimension files "SIZE.h" which match the "data.exch2"
files are also provided.

naming convention: 
 llc_120 : lat-lon-cap grid, 120-360-120 (=nRed,nGreen,nBlue)
 (grid-files in MITgcm_contrib/llc_120/grid_files )

SIZE.h.14t_120x120 :
   llc_120 grid, 6-facets, tiles size = 120x120, no blank tiles
      (<=> largest tile size => minimum total Nb of tiles = 14)

SIZE.h.156t_20x60 : can be used with:
      llc_120, 6-facets, tiles =  20x60 + 12 blank tiles
   or llc_120, 5-facets, tiles =  20x60 , no blank tiles
   or cs-180,  6-facets, tiles =  20x60 +  6 blank tiles

data.exch2.llc_120_6f :
 llc_120, 6-facets, no blank tiles 
 works for any tiling of facets and in particular with SIZE.h.14t_120x120

data.exch2.llc_120_6f.168t-12b :
 llc_120, 6-facets, 168 tiles - 12 blank tiles = 156 active tiles
 Notes: list and number of blank-tiles generaly depend on tiling of facets;
        however, to blank out the last facet just requires listing all tiles
        of the last facets and does not depend on precise tile-size but
        just on Number of tiles.
 works with SIZE.h.156t_20x60 (and also SIZE.h.156t_60x20 <- not provided)

data.exch2.llc_120_5f :
 llc_120, 5-facets (drop the last one), no blank tiles
 works for any facet tiling, and in particular with SIZE.h.156t_20x60

data.exch2.cs180.162t-6b_20x60 :
 regular CS-180 cube, 162 tiles - 6 blank (on face 2 along the Eq) = 156 active T.
 would work with SIZE.h.156t_20x60 (but what about grid-files ?)

---- Oct 13, 2010 (after checkpoint62l)
 matlab-topology-generator is no longer supported and does not work anymore
 since latest additions to pkg/exch2 (for OBCS) have not been incorporated into
 the matlab scripts.
 example of "data.exch2" file to use are provided in MITgcm/utils/exch2/input/

---- May 12, 2009 (after checkpoint61n)
 fortran code to set-up topology is now part of pkg/exch2, with new parameter
 file "data.exch2". For now, keep a compatile version of matlab-topology-generator
 (writing files "W2_EXCH2_SIZE.h" and "w2_e2setup.F") as back-up solution
 until new code is extensively tested.
------------------

Matlab code to generate topology description for MITgcm cs6 conventions.

o To run start matlab and execute script driver.m
o To set sizes edit lines in driver.m
  - Settings nr, ng, nb are index space sizes for cube grid.
    They are (nr,ng) the two dimensions (in x and y) or the 1rst face
    followed by (nb) the 1rst dimension (in x) of the 2nd face.
    Note - nr, ng and nb do not have to equal, however the
    current physical grid generation software assumes they
    are equal.
  - Settings tnx and tny are the tile sizes ( these correspond to
    snx and sny in SIZE.h ). tnx and tny must subdivide nr, ng and nb
    exactly.
    The product nsx*npx from SIZE.h needs to equal the number of
    tiles created by driver.m
  - Setting mapIO select option for global-IO mapping.
    3 options are implemented:
    mapIO=-1 : old format: put domains 1 after the other in the X direction.
           can waste disk space if cube dimensions (nr,ng,nb) are not equal.
    mapIO= 1 : compact format, 1 domain after the other (mostly in Y direction)
           but needs to fold some domains (face) that are too large.
    mapIO= 0 : compact format (= 1 long line), one domain after the other.
           This format is not yet supported by pkg/mdsio.

The key output from this code is a Fortran header file W2_EXCH2_TOPOLOGY.h
and one or more Fotran files called e2setup*.F. These are written
by exch2_setup_cs6_print.m. The header file contains the declarations
of the arrays used to describe the index space topology of the cube domain.
The e2setp*.F files contain the code to initialize these arrays.
Two output options ( variable outmode ) are available in
exch2_setup_cs6_print.m. One produces a single file e2setup.F with a driver
routine that calls a setup routine for each tile. For large numbers of tiles
this file can be huge and can cause some Fortran compilers (g77 certainly) to
allocate ridiculous amounts of memory to parse this file. An alternate output
mode produces one file for each tile initialization routine and one file
"e2setup.F" for the driver.  This mode is kinder to the compiler but creates a
visually annoying large number of source files (one for each tile).


File list
driver.m                                                :: Controls the topology generation
exch2_divider.m                                         :: Calculate the larger divider of input list
exch2_setup_cs6_domains.m                               :: Defines the cube faces (aka domains)
exch2_setup_cs6_get_external_neighbor_index_ranges.m    :: Figures out the index remapping operators
                                                        :: and index ranges for halo's between cube faces.
exch2_setup_cs6_get_external_neighbor_tiles.m           :: Figures out neighbor between domains for each tile.
exch2_setup_cs6_get_internal_neighbor_index_ranges.m    :: Figures out the index remapping operators
                                                        :: and index ranges for halo's within a cube face.
exch2_setup_cs6_get_internal_neighbor_tiles.m           :: Figures out neighbors with a domain for each tile.
exch2_setup_cs6_get_neighbor_domains.m                  :: Defines connectivity between domains.
exch2_setup_cs6_plot.m                                  :: Plots the tiles using the conventional cube
                                                        :: domain layout.
exch2_setup_cs6_print.m                                 :: Writes the Fortran code that defines the topology
                                                        :: and that is linked with the model run.
exch2_setup_cs6_tiles.m                                 :: Builds lists of each tile and its location within
                                                        :: a domain and within the global index space.

generate_blanklist.m                                    :: generate blanklist.example.txt

#  -*- mode: text -*-
   =======   gmt:  General MITgcm Tiles/Topologies   =======

This directory contains MatLAB and shell utilities for post-processing
data on generalized MITgcm tiles and topologies.  It is meant to work
with the input and output from the latest version of the "mnc" package
(the MITgcm netCDF interface) for all kinds of MITgcm domains
including:

 - "traditional" exch1 topologies
 - exch2 cubes
 - more general topologies

and the available tools are:

  rdnctiles.m  ::  reads data from collections of netCDF tiles

This set of matlab scripts and functions does some basic diagnostics on the
global ocean run. By no means are they meant to be universal or exhaustive. 
Use them as a starting point for your own diagnostics.

After including this directory into your matlab path, 
change into the directory where the model output is (e.g.: cd build) 
and type at the matlab prompt:
matlab>> path('../diags_matlab',path); % <- if not already in your path
matlab>> mit_loadglobal
to get a number of plots of meridional overturning stream functions, 
barotropic streamfunctions, surface fluxes of heat and freshwater, model 
drift, devations of model hydrography from levitus etc. 
By default the script will look for time-averaged fields. If there are not 
any time averaged fields, type 
matlab>> meanfields = 0;
at the matlab prompt before runing the scripts so that the latest snapshot
fields are displayed instead.

Martin Losch, Oct 17, 2002
mlosch@mit.edu

Update (from Aug 1rst, 2008): 
 move all supplementary code to utils/exch2/code-mods
------------------------------------------------------------
Supplementary code mods sets for alternate verification tests
that involve additional code mods. The tests here are designed to check that
cube tilings that have multiple tiles per cube face and that have
missing tiles for all land regions are working OK.

Code mods are in addition to the base mods in code/, i.e. they are applied in genmake2 together
using a command such as
% ../../../tools/genmake2 -mods="../code_alt/code.176t_8x4 ../code"

Directories
code.12t_32x16  :: Same as base but with 12 tiles each of 32x16

code.192t_8x4   :: Same as base but with 192 tiles each of 8x4

code.176t_8x4   :: Same as base but with 176 tiles each of 8x4. This
                :: case has dropped the 8x4 tiles that are
                :: all land in bathy_Hmin50.bin.

The modified "ini_masks_etc.F" in code.192t_8x4/ was used to generate
the list of all land tiles for code.176t_8x4/. This list is used by the
utils/exch2/matlab_topology_generator/driver.m program. The "driver.m"
program reads an optional file "blanklist.txt" that lists tiles that
are blank in the full tile case. The topology files (W2_EXCH2_TOPOLOGY.h 
and w2_e2setup.F) that are generated are then missing thise tiles.

# MITgcmutils

Python utilities for the MIT General Circulation Model,
[MITgcm](http://mitgcm.org).

This package is developed as a part of MITgcm on
[github](https://github.com/MITgcm/MITgcm/tree/master/utils/python/MITgcmutils).

It is documented in the MITgcm
[manual](http://mitgcm.rtfd.io/en/latest/utilities/utilities.html#mitgcmutils).

---- May 12, 2009 (after checkpoint61n)
 fortran code to set-up topology is now part of pkg/exch2, with new parameter
 file "data.exch2". 
 None of the modified src file (from any sub.dir) is necessary (just SIZE.h 
 is enough) and therefore has not been updated. No additional parameter
 is needed (can run without "data.exch2", using the default), except for
 the last case (s176t_8x4) with blank tiles: data.exch2.16_blk 
 An other example with blank-tiles can be foundi in:
  verification/adjusment.cs-32x32x1/input/data.exch2.mpi
------------------

Example of modified src code (from matlab-topology-generator) corresponding
to different tiling of regular CS-32 grid:

- s6t_32x32  :   6 tiles, dimension of each tile: 32 x 32 ( 1x1 tile per face)
- s12t_16x32 :  12 tiles, dimension of each tile: 16 x 32 ( 2x1 tile per face)
- s12t_32x16 :  12 tiles, dimension of each tile: 32 x 16 ( 1x2 tile per face)
- s24t_16x16 :  24 tiles, dimension of each tile: 16 x 16 ( 2x2 tile per face)
- s24t_32x8  :  24 tiles, dimension of each tile: 32 x  8 ( 1x4 tile per face)
- s24t_8x32  :  24 tiles, dimension of each tile:  8 x 32 ( 4x1 tile per face)
- s192t_8x4  : 192 tiles, dimension of each tile:  8 x  4 ( 4x8 tile per face)
- s176t_8x4  : 176 tiles, same as s192t_8x4 with 16 blank-tiles

------------------

Matlab scripts (written by Alistair) specific to Cubed-Shere grid:
 [initially in utils/matlab and moved here Sep. 15, 2005]

Interpolate to Lat-Lon grid:
 cube2latlon.m
 cube2latlon_fast.m
 cube2latlon_preprocess.m
 uvcube2latlon.m
 uvcube2latlon_fast.m
 uvcube2latlongrid.m  (faster version, from Guillaume Maze)

make graphics of cs-grid fields:
 merccube.m
 displaytiles.m
 drawedges.m
 fancycube.m
 plotcube.m

others:
 permutetiles.m
 tiles.m

--------------------------------------------------------------------------
Some tools specific to the Cubed-Sphere grid :

split_C_cub.m   :: split a 2d,3d global CS-field into 6 faces ;
        apply to cell-centered CS-field ; extend the face array by
        adding 1 row & 1 column (like the exchanges)
split_Z_cub.m   :: split a 2d,3d global CS-field into 6 faces ;
        apply to cell-corner CS-field ; extend the face array by
        adding 1 row & 1 column (like the exchanges)
split_UV_cub.m  :: split the 2 C-grid components of a vector
        (2d,3d global CS-field) into 6 faces ; extend the face array
        by adding 1 row or 1 column (like the exchanges)

cubeZ2latlon.m  :: interpolate a CS-field to regular Lat-lon grid ;
        similar to cube2latlon.m but apply to a field that is
        located at the corner point of the C-grid cell.
        (deal with the 2 "missing corners")

calc_vort_cs.m  :: compute vorticity (vertical component) on CS-grid
        from MITgcm output velocity fields u,c (on C-grid);
        Use the model discretization of vorticity.

the following scripts are reading a file that contains the orientation
        of the local direction of the CS-grid relative to E-W,N-S direction.
  file= proj_cs[]_2uEvN.bin :: cos & sin of rotation angle,
                      format:: real*8, big-endian, size=32x6x32 x2(cos+sin)
        for standard cs32 grid, the corresponding file is:
           verification/global_ocean.cs32x15/input/proj_cs32_2uEvN.bin

rotate_uv2uvEN.m :: Rotate CS-grid vector U,V components to East,North directions.
        Input at grid-cell center (A-grid) or grid-cell edges (C-grid);
        works for 2D or 3D vector.

uvLatLon2cube.m :: interpolate a 2 components vector field U,V (on A-grid)
        to the MITgcm CS-grid (C-grid).

mk_psiLine_CS.m :: define path to integrate horizontally horizontal transport
        for computing Barotropic Stream-Function, starting from the N.Pole and
        going southward.  => write matlab file: psiLine_N2S_cs32.mat
use_psiLine.m :: an example that uses "psiLine_N2S_cs32.mat" to compute & plot
        Barotropic Transport Stream-function.

mk_isoLat_bkl.m :: define "broken-lines" as close to latitude-target vector
        "yLat", for computing Meridional Transport stream-function.
        => write matlab file: isoLat_${ydim}_cs32.mat (with ydim = length(yLat))
use_isoLat_bkl.m :: an example that uses "isoLat_59_cs32.mat" to compute & plot
        Meridional Transport Stream-function.

%--------------------------------------------------
More in dir bk_line:
 Scripts that generate "broken-lines" (used to compute Meridional Transport
  stream-function) as close as great-circle and some ploting script for CS-grid.
 see bk_line/README file there

And in dir read_cs:
 Scripts for reading and writing cube-sphere binary output in various ways.
 Look at read_cs/read_cs.txt for example usage.

To compile and run this short test:

1) Compile with TAF in build
E.G.
  cd build
  ../../../tools/genmake2 -mods ../code_ad -of ../../../tools/build_options/linux_amd64_gfortran
  make depend
  make adall
  cd ..

2) Then in "run" dir:
  cd run
  ln -s ../input_ad/* .
  ./prepare_run
  ln -s ../build/mitgcmuv_ad .

3) RUN IT!
  ./mitgcmuv_ad >& output_adm.txt

test - experiment : adjustment.cs_32x32x1 (.nlfs)

purpose: 
test the non-linear free-surface in a simple barotropic adjustment
problem.

this experiment was identical to standard "adjustment.cs_32x32x1" (before 
this later got changed to an oceanic test on Apr 18, 2009) except:
* use NonLin-FreeSurf  
  (CPP_OPTION.h : "#define NONLIN_FRSURF" and nonlinFreeSurf=3 in data)
* use a Cranck-Nickelson time stepping (implicSurfPress=implicDiv2DFlow=1/2)
  to compute the free-surface pressure anomaly.
* use a smaller time step for a better resolution of gravity waves and
  a larger initial surface pressure anomaly (100.mb) to increase the
  non-linear effects.

%- Feb 12 2013:
needs MDS (binary) grid files (XC,YC,XG,YG & RAC) in dir "./grid_files/"
 (read-in using matlab script: MITgcm/utils/matlab/load_grid.m
  which also allows to use MNC (NetCDF) grid files by changing "ncdf=0;"
  to "ncdf=1;" in all the matlab scripts listed here after).

%-----------------------------------------------------------
NOTE: For the purpose of computing meridional transport, a simpler, more robust
 method (based on grid-cell center latitude) is preferred, see "mk_isoLat_bkl.m"
 and "use_isoLat_bkl.m" in the directory one level up (i.e., in matlab/cs_grid/).
 However, other functions provided here (great-circle section line, basin
 mask and separation) have no improved equivalent (yet) in matlab/cs_grid/.

%- define broken-line on the C.S. grid as close as possible to given yLat latitude:
%  Method: find the list of grid-cell corner points that stay as close as
%  the corresponding target latitude, and collect the connecting grid-cell edges
%  (i.e., velocity points) to generate the broken-line.
%- started: Sep 15  2002
%  Note: have not been updated to accept compact-format input files

gener_bk_line.m
(use: load_grid.m find_bk_line.m clean_bk_line.m save_bk_line.m grph_bk_line.m)
=> write matlab file: isoLat_cube32_59.mat
( run 1rst time to try ; then set krd=0 and run 2nd time to calculate
  all the broken line and write to file)

%- generate array (= bkl_Zon) that give
%  the latitude zone (= between 2 broken-line) of each grid mesh (tracer pt),
%- Started: Jul 24 2003

gen_bk_Zon.m
<= read grid_files/isoLat_cube32_59.mat
=> write matlab file: isoLat_cs32_59.mat
(contains all the arrays that were in isoLat_cube32_59.mat)

%-----------------------------------------------------------
% define mask of 3 basins (Atlantic , Indian , Pacific)
%  and the list of border points (U,V point)
%- Jul 26 2003
%  Note: have not been updated to accept compact-format input files

def_API_msk.m
(use: line_sep.m; needs also hFacC,W,S from ocean-set-up, in dir: ./grid_files/ )
=> write binary files: maskC_bas.bin maskS_bas.bin maskW_bas.bin
 + list of U,V points at the border: => open_basins_section.mat

%- combine "broken-line" + 3 basins
% used to compute the mask of Meridional Stream-Funct. for Atl,Ind,Pac
%- Started: Jul 26 2003

sep_API_basins.m
=> write matlab file: sepBas_cs32_60.mat

%-----------------------------------------------------------
%- define a single broken-line on CS-grid that follows as close as possible
%  a great-circle line:
%- started: Feb 05 2007
%  Note: have not been updated to accept compact-format input files
grt_circ_bkl.m :
uses: load_grid.m rotate_xy.m split_Z_cub.m find_bk_line.m clean_bk_line.m
      save_bk_line.m shift_bk_line.m
(+ optional, for plots: grph_CS.m moveHV_colbar.m )

%------------------------------------------------------
% Example on how to use those broken-line files:
% a) to compute & plot Meridional Transport Stream-function
%   using broken-line file (i.e., like "isoLat_cs32_59.mat") generated by:
%   gener_bk_line.m + gen_bk_Zon.m from this dir.
% b) changing to krd=3, to compute the horizontally integrated transport
%   through a Great-Circle section using broken-line file generated by:
%  grt_circ_bkl.m from this dir.
%- Started: Jul 2003
% Note: has been updated to accept compact-format input files

use_bk_line.m
%-----------------------------------------------------------

Dockerfile that specifies container for testreport testing of MITgcm
under centos and including OpenAD. The docker container build automatically
in dockerhub. To fetch the container use the command

```
docker pull mitgcm/testreport-images:centos
```

#     include "GAD_OPTIONS.h"

      SUBROUTINE GAD_PPM_ADV_R(meth,bi,bj,
     I           delT,velR,facR,fbar,
     O           flux,myThid )
C     |================================================================|
C     | PPM_ADV_R: evaluate grid-cell advective flux in R.             |
C     | Lagrangian-type Piecewise Parabolic Method (PPM).              |
C     |================================================================|

          implicit none

C     =============================================== global variables
#         include "SIZE.h"
#         include "GRID.h"
#         include "GAD.h"

C     ================================================================
C       meth     :: advection method.
C       bi,bj    :: tile indexing
C       delT     :: level-wise time-steps.
C       velR     :: vel. field in r-direction.
C       facR     :: grid-areas in r-direction.
C       fbar     :: grid-cell values.
C       flux     :: trac.-flux in r-direction.
C       myThid   :: thread number.
C     ================================================================
          integer meth
          integer bi,bj
          _RL delT(1:Nr)
          _RL velR(1-OLx:sNx+OLx,
     &             1-OLy:sNy+OLy,
     &             1:Nr)
          _RL facR(1-OLx:sNx+OLx,
     &             1-OLy:sNy+OLy,
     &             1:Nr)
          _RL fbar(1-OLx:sNx+OLx,
     &             1-OLy:sNy+OLy,
     &             1:Nr)
          _RL flux(1-OLx:sNx+OLx,
     &             1-OLy:sNy+OLy,
     &             1:Nr)
          integer myThid

C     ================================================================
C       ix,iy,ir :: grid indexing.
C       floc     :: col. of grid-cell values.
C       mloc     :: col. of grid-cell mask values.
C       fhat     :: col. of poly. coeff.
C                    - FHAT(:,I) = PQM coeff.
C       edge     :: col. of edge-wise values/slopes.
C                    - EDGE(1,:) = VALUE.
C                    - EDGE(2,:) = DF/DR.
C       ohat     :: col. of oscl. coeff.
C                    - OHAT(1,:) = D^1F/DS^1.
C                    - OHAT(2,:) = D^2F/DS^2.
C     ================================================================
          integer ix,iy,ir
          _RL floc(    1-3:Nr+3)
          _RL mloc(    1-3:Nr+3)
          _RL fhat(1:3,1-0:Nr+0)
          _RL edge(    1-0:Nr+1)
          _RL ohat(1:2,1-3:Nr+3)
          _RL vsum

C     ======================================= mask boundary conditions
          mloc(  -2) = 0.0 _d 0
          mloc(  -1) = 0.0 _d 0
          mloc(  +0) = 0.0 _d 0
          mloc(Nr+1) = 0.0 _d 0
          mloc(Nr+2) = 0.0 _d 0
          mloc(Nr+3) = 0.0 _d 0

C     ================================================================
C       (1): copy a single row of data onto contiguous storage, treat
C            as a set of one-dimensional problems.
C       (2): calc. "oscillation-indicators" for each grid-cell if ad-
C            vection scheme is WENO-class.
C       (3): calc. edge-centred values/slopes by high-order interpol-
C            ation.
C       (4): calc. cell-centred polynomial profiles with appropriate
C            slope-limiting.
C       (5): calc. fluxes using a local, semi-lagrangian integration.
C     ================================================================

          do iy = 1-OLy+0, sNy+OLy-0
          do ix = 1-OLx+0, sNx+OLx-0
C     ======================================= no flux through surf. bc
          flux(ix,iy,+1) = 0.0 _d +0
          end do
          end do

C     ==================== calculate transport for interior grid-cells
          do iy = 1-OLy+0, sNy+OLy-0
          do ix = 1-OLx+0, sNx+OLx-0

          vsum = 0.0 _d 0
          do ir = 2, Nr
C     ================================== quick break on zero transport
              vsum = vsum
     &             + abs(velR(ix,iy,ir))
          end do

          if (vsum .gt. 0. _d 0) then

          do ir = 1, Nr
C     ================================== make local unit-stride copies
              floc(ir) = fbar(ix,iy,ir)
              mloc(ir) =
     &            maskC(ix,iy,ir,bi,bj)
          end do

C     ================================== make mask boundary conditions
          floc(  -2) = floc(+1)
          floc(  -1) = floc(+1)
          floc(  +0) = floc(+1)
          floc(Nr+1) = floc(Nr)
          floc(Nr+2) = floc(Nr)
          floc(Nr+3) = floc(Nr)

C     ==================== reconstruct derivatives for WENO indicators
          if (meth.eq.ENUM_PPM_WENO_LIMIT) then
          CALL GAD_OSC_HAT_R(bi,bj,ix,iy,
     &                   mloc,floc,
     &                   ohat,myThid)
          end if

C     ==================== reconstruct 3rd--order accurate edge values
          CALL GAD_PPM_P3E_R(bi,bj,ix,iy,
     &                   mloc,floc,
     &                   edge,myThid)

C     ==================== reconstruct coeff. for grid-cell poynomials
          CALL GAD_PPM_HAT_R(bi,bj,ix,iy,
     &                   meth,
     &                   mloc,floc,
     &                   edge,ohat,
     &                   fhat,myThid)

C     ==================== evaluate integral fluxes on grid-cell edges
          CALL GAD_PPM_FLX_R(bi,bj,ix,iy,
     &                   delT,velR,
     &                   facR,fhat,
     &                   flux,myThid)

          else

          do ir = 2, Nr
C     ================================== "null" flux on zero transport
              flux(ix,iy,ir) = 0.0 _d +0
          end do

          end if

          end do
          end do

          return

c     end subroutine GAD_PPM_ADV_R
      end

#include "FLT_OPTIONS.h"
#undef _USE_INTEGERS

      SUBROUTINE FLT_RUNGA4 (
     I                        myTime, myIter, myThid )

C     ==================================================================
C     SUBROUTINE FLT_RUNGA4
C     ==================================================================
C     o This routine steps floats forward with second order Runge-Kutta
C
C     started: Arne Biastoch
C
C     changed: 2004.06.10 Antti Westerlund (antti.westerlund@helsinki.fi)
C              and Sergio Jaramillo (sju@eos.ubc.ca)
C     ==================================================================

C     !USES:
      IMPLICIT NONE

C     == global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "DYNVARS.h"
#include "FLT_SIZE.h"
#include "FLT.h"

C     == routine arguments ==
      _RL myTime
      INTEGER myIter, myThid

C     == Functions ==
#ifdef USE_FLT_ALT_NOISE
      Real*8   PORT_RAND_NORM
      EXTERNAL PORT_RAND_NORM
#else
      Real*8   PORT_RAND
      EXTERNAL PORT_RAND
#ifdef _USE_INTEGERS
      INTEGER seed
#else
      Real*8 seed
#endif
#endif /* USE_FLT_ALT_NOISE */

C     == local variables ==
      INTEGER bi, bj
      INTEGER ip
      INTEGER ic, jc, kc, iG, jG
      _RL u1, v1, u2, v2, u3, v3, u4, v4
#ifdef ALLOW_3D_FLT
      _RL w1, w2, w3, w4, ktz1, ktz2, ktz3, kz, scalez
      _RL kzlo, kzhi
#endif
      _RL ix, jy, itx1, jty1, itx2, jty2, itx3, jty3
      _RL scalex, scaley

C     == end of interface ==

#ifndef USE_FLT_ALT_NOISE
#ifdef _USE_INTEGERS
      seed = -1
#else
      seed = -1.d0
#endif
#endif /* ndef USE_FLT_ALT_NOISE */

#ifdef ALLOW_3D_FLT
      kzlo = 0.5 _d 0
      kzhi = 0.5 _d 0 + DFLOAT(Nr)
#endif

      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
         DO ip=1,npart_tile(bi,bj)

C     If float has died move to level 0
           IF ( tend(ip,bi,bj).NE.-1. .AND. myTime.GT.tend(ip,bi,bj)
     &        ) THEN
            kpart(ip,bi,bj) = 0.
           ELSE
C     Start integration between tstart and tend (individual for each float)
            IF ( (tstart(ip,bi,bj).EQ.-1..OR.myTime.GE.tstart(ip,bi,bj))
     &      .AND.(  tend(ip,bi,bj).EQ.-1..OR.myTime.LE.  tend(ip,bi,bj))
     &      .AND.(   iup(ip,bi,bj).NE.-3.)
     &         ) THEN

              ix = ipart(ip,bi,bj)
              jy = jpart(ip,bi,bj)
              ic=NINT(ix)
              jc=NINT(jy)
              kc=NINT(kpart(ip,bi,bj))

              scalex=recip_dxF(ic,jc,bi,bj)
              scaley=recip_dyF(ic,jc,bi,bj)
              iG = myXGlobalLo + (bi-1)*sNx + ic-1
              jG = myYGlobalLo + (bj-1)*sNy + jc-1

C     First step

#ifdef ALLOW_3D_FLT
              IF (iup(ip,bi,bj).EQ.-1.) THEN
c               kz=global2local_k(kpart(ip,bi,bj),bi,bj,mjtyhid)

C recip_drF is in units 1/r (so IF r is in m this is in 1/m)
                scalez=rkSign*recip_drF(kc)
C We should not do any special conversions for kz, since flt_trilinear
C expects it to be just a normal kpart type variable.
                kz=kpart(ip,bi,bj)
                CALL FLT_TRILINEAR(ix,jy,kz,u1,uVel,1,bi,bj,myThid)
                CALL FLT_TRILINEAR(ix,jy,kz,v1,vVel,2,bi,bj,myThid)
                CALL FLT_TRILINEAR(ix,jy,kz,w1,wVel,4,bi,bj,myThid)
              ELSE
#else  /* ALLOW_3D_FLT */
              IF ( .TRUE. ) THEN
#endif /* ALLOW_3D_FLT */
                CALL FLT_BILINEAR(ix,jy,u1,uVel,kc,1,bi,bj,myThid)
                CALL FLT_BILINEAR(ix,jy,v1,vVel,kc,2,bi,bj,myThid)
              ENDIF

C When using this alternative scheme the noise probably should not be added twice.
#ifndef USE_FLT_ALT_NOISE
              IF ( flt_noise.NE.0. .AND. iup(ip,bi,bj).NE.-2. ) THEN
                u1 = u1 + u1*(PORT_RAND(seed)-0.5)*flt_noise
                v1 = v1 + v1*(PORT_RAND(seed)-0.5)*flt_noise
#ifdef ALLOW_3D_FLT
#ifdef ALLOW_FLT_3D_NOISE
                IF (iup(ip,bi,bj).EQ.-1.) THEN
                  w1 = w1 + w1*(PORT_RAND(seed)-0.5)*flt_noise
                ENDIF
#endif
#endif /* ALLOW_3D_FLT */
              ENDIF
#endif /* ndef USE_FLT_ALT_NOISE */

C ix and itx are in indices. Therefore it is necessary to multiply
C with a grid scale factor.

              itx1=ix+0.5*flt_deltaT*u1*scalex
              jty1=jy+0.5*flt_deltaT*v1*scaley

C     Second step

#ifdef ALLOW_3D_FLT
              IF (iup(ip,bi,bj).EQ.-1.) THEN
                ktz1=kz+0.5*flt_deltaT*w1*scalez
                CALL FLT_TRILINEAR(itx1,jty1,ktz1,u2,uVel,
     &               1,bi,bj,myThid)
                CALL FLT_TRILINEAR(itx1,jty1,ktz1,v2,vVel,
     &               2,bi,bj,myThid)
                CALL FLT_TRILINEAR(itx1,jty1,ktz1,w2,wVel,
     &               4,bi,bj,myThid)
              ELSE
#else  /* ALLOW_3D_FLT */
              IF ( .TRUE. ) THEN
#endif /* ALLOW_3D_FLT */
                CALL FLT_BILINEAR(itx1,jty1,u2,uVel,
     &               kc,1,bi,bj,myThid)
                CALL FLT_BILINEAR(itx1,jty1,v2,vVel,
     &               kc,2,bi,bj,myThid)
              ENDIF

              IF ( flt_noise.NE.0. .AND. iup(ip,bi,bj).NE.-2. ) THEN
#ifdef USE_FLT_ALT_NOISE
                u2 = u2 + PORT_RAND_NORM()*flt_noise
                v2 = v2 + PORT_RAND_NORM()*flt_noise
#ifdef ALLOW_3D_FLT
#ifdef ALLOW_FLT_3D_NOISE
                IF (iup(ip,bi,bj).EQ.-1.) THEN
                  w2 = w2 + PORT_RAND_NORM()*flt_noise
                ENDIF
#endif
#endif /* ALLOW_3D_FLT */

#else /* USE_FLT_ALT_NOISE */
                u2 = u2 + u2*(PORT_RAND(seed)-0.5)*flt_noise
                v2 = v2 + v2*(PORT_RAND(seed)-0.5)*flt_noise
#ifdef ALLOW_3D_FLT
#ifdef ALLOW_FLT_3D_NOISE
                IF (iup(ip,bi,bj).EQ.-1.) THEN
                  w2 = w2 + w2*(PORT_RAND(seed)-0.5)*flt_noise
                ENDIF
#endif
#endif /* ALLOW_3D_FLT */

#endif /* USE_FLT_ALT_NOISE */
              ENDIF

              itx2=ix+0.5*flt_deltaT*u2*scalex
              jty2=jy+0.5*flt_deltaT*v2*scaley

C     Third step

#ifdef ALLOW_3D_FLT
              IF (iup(ip,bi,bj).EQ.-1.) THEN
                ktz2=kz+0.5*flt_deltaT*w2*scalez
                CALL FLT_TRILINEAR(itx2,jty2,ktz2,u3,uVel,
     &               1,bi,bj,myThid)
                CALL FLT_TRILINEAR(itx2,jty2,ktz2,v3,vVel,
     &               2,bi,bj,myThid)
                CALL FLT_TRILINEAR(itx2,jty2,ktz2,w3,wVel,
     &               4,bi,bj,myThid)
              ELSE
#else  /* ALLOW_3D_FLT */
              IF ( .TRUE. ) THEN
#endif /* ALLOW_3D_FLT */
                CALL FLT_BILINEAR(itx2,jty2,u3,uVel,
     &               kc,1,bi,bj,myThid)
                CALL FLT_BILINEAR(itx2,jty2,v3,vVel,
     &               kc,2,bi,bj,myThid)
              ENDIF

              IF ( flt_noise.NE.0. .AND. iup(ip,bi,bj).NE.-2. ) THEN
#ifdef USE_FLT_ALT_NOISE
                u3 = u3 + PORT_RAND_NORM()*flt_noise
                v3 = v3 + PORT_RAND_NORM()*flt_noise
#ifdef ALLOW_3D_FLT
#ifdef ALLOW_FLT_3D_NOISE
                IF (iup(ip,bi,bj).EQ.-1.) THEN
                  w3 = w3 + PORT_RAND_NORM()*flt_noise
                ENDIF
#endif
#endif /* ALLOW_3D_FLT */

#else /* USE_FLT_ALT_NOISE */
                u3 = u3 + u3*(PORT_RAND(seed)-0.5)*flt_noise
                v3 = v3 + v3*(PORT_RAND(seed)-0.5)*flt_noise
#ifdef ALLOW_3D_FLT
#ifdef ALLOW_FLT_3D_NOISE
                IF (iup(ip,bi,bj).EQ.-1.) THEN
                  w3 = w3 + w3*(PORT_RAND(seed)-0.5)*flt_noise
                ENDIF
#endif
#endif /* ALLOW_3D_FLT */

#endif /* USE_FLT_ALT_NOISE */
              ENDIF

              itx3=ix+flt_deltaT*u3*scalex
              jty3=jy+flt_deltaT*v3*scaley

C     Fourth step

#ifdef ALLOW_3D_FLT
              IF (iup(ip,bi,bj).EQ.-1.) THEN
                ktz3=kz+0.5*flt_deltaT*w2*scalez
                CALL FLT_TRILINEAR(itx3,jty3,ktz3,u4,uVel,
     &               1,bi,bj,myThid)
                CALL FLT_TRILINEAR(itx3,jty3,ktz3,v4,vVel,
     &               2,bi,bj,myThid)
                CALL FLT_TRILINEAR(itx3,jty3,ktz3,w4,wVel,
     &               4,bi,bj,myThid)
              ELSE
#else  /* ALLOW_3D_FLT */
              IF ( .TRUE. ) THEN
#endif /* ALLOW_3D_FLT */
                CALL FLT_BILINEAR(itx3,jty3,u4,uVel,
     &               kc,1,bi,bj,myThid)
                CALL FLT_BILINEAR(itx3,jty3,v4,vVel,
     &               kc,2,bi,bj,myThid)
              ENDIF

              IF ( flt_noise.NE.0. .AND. iup(ip,bi,bj).NE.-2. ) THEN
#ifdef USE_FLT_ALT_NOISE
                u4 = u4 + PORT_RAND_NORM()*flt_noise
                v4 = v4 + PORT_RAND_NORM()*flt_noise
#ifdef ALLOW_3D_FLT
#ifdef ALLOW_FLT_3D_NOISE
                IF (iup(ip,bi,bj).EQ.-1.) THEN
                  w4 = w4 + PORT_RAND_NORM()*flt_noise
                ENDIF
#endif
#endif /* ALLOW_3D_FLT */

#else /* USE_FLT_ALT_NOISE */
                u4 = u4 + u4*(PORT_RAND(seed)-0.5)*flt_noise
                v4 = v4 + v4*(PORT_RAND(seed)-0.5)*flt_noise
#ifdef ALLOW_3D_FLT
#ifdef ALLOW_FLT_3D_NOISE
                IF (iup(ip,bi,bj).EQ.-1.) THEN
                  w4 = w4 + w4*(PORT_RAND(seed)-0.5)*flt_noise
                ENDIF
#endif
#endif /* ALLOW_3D_FLT */

#endif /* USE_FLT_ALT_NOISE */
              ENDIF

C ipart is in coordinates. Therefore it is necessary to multiply
C with a grid scale factor divided by the number grid points per
C geographical coordinate.
              ipart(ip,bi,bj) = ipart(ip,bi,bj) + flt_deltaT/6
     &                        * (u1 + 2*u2 + 2*u3 + u4) * scalex
              jpart(ip,bi,bj) = jpart(ip,bi,bj) + flt_deltaT/6
     &                        * (v1 + 2*v2 + 2*v3 + v4) * scaley
#ifdef ALLOW_3D_FLT
              IF (iup(ip,bi,bj).EQ.-1.) THEN
                kpart(ip,bi,bj) = kpart(ip,bi,bj) + flt_deltaT/6
     &                          * (w1 + 2*w2 + 2*w3 + w4) * scalez
              ENDIF
#endif /* ALLOW_3D_FLT */

C--  new horizontal grid indices
              ic = MAX( 1-OLx, MIN( NINT(ipart(ip,bi,bj)), sNx+OLx ) )
              jc = MAX( 1-OLy, MIN( NINT(jpart(ip,bi,bj)), sNy+OLy ) )

#ifdef ALLOW_3D_FLT
C If float is 3D, make sure that it remains in water
              IF (iup(ip,bi,bj).EQ.-1.) THEN
C reflect on surface
                IF (kpart(ip,bi,bj).LT.kzlo) kpart(ip,bi,bj)=kzlo
     &                                      +kzlo-kpart(ip,bi,bj)
C stop at bottom
                IF (kpart(ip,bi,bj).GT.kzhi) kpart(ip,bi,bj)=kzhi
C-to work also with non flat-bottom set-up:
c               IF ( kpart(ip,bi,bj).GT.kLowC(ic,jc,bi,bj)+0.5 )
c    &               kpart(ip,bi,bj) = kLowC(ic,jc,bi,bj)+0.5
              ENDIF
#endif /* ALLOW_3D_FLT */

#ifdef ALLOW_OBCS
              IF ( useOBCS ) THEN
C--  stop floats which enter the OB region:
               IF ( maskInC(ic,jc,bi,bj).EQ.0. .AND.
     &              maskC(ic,jc,1,bi,bj).EQ.1. ) THEN
C    for now, just reset "tend" to myTime-deltaT
C    (a better way would be to remove this one & re-order the list of floats)
                  tend(ip,bi,bj) = myTime - flt_deltaT
               ENDIF
              ENDIF
#endif /* ALLOW_OBCS */

            ENDIF
           ENDIF

C-    end ip loop
         ENDDO
C-    end bi,bj loops
       ENDDO
      ENDDO

      RETURN
      END

#include "MONITOR_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 0
C     !ROUTINE: MON_ADVCFLW2

C     !INTERFACE:
      SUBROUTINE MON_ADVCFLW2(
     I     label, W, rHFac, rDrF, dT,
     I     myThid )

C     !DESCRIPTION:
C     Calculates maximum CFL number in the vertical relevant for tracer
C     Adv. Pb. with Partial Cell.

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "MONITOR.h"

C     !INPUT PARAMETERS:
      CHARACTER*(*) label
      _RL     W(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      _RS rHFac(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy) 
      _RS rDrF(Nr)
      _RL dT
      INTEGER myThid
CEOP

C     !LOCAL VARIABLES:
      INTEGER bi,bj,I,J,K
      _RL tmpVal,theMax

      theMax=0.

      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        DO K=2,Nr
         DO J=1,sNy
          DO I=1,sNx
           tmpVal=abs(W(I,J,K,bi,bj))*dT
     &           *max(  rDrF(K)*rHfac(I,J,K,bi,bj),
     &                rDrF(K-1)*rHfac(I,J,K-1,bi,bj) )
           theMax=max(theMax,tmpVal)
          ENDDO
         ENDDO
        ENDDO
       ENDDO
      ENDDO
      _GLOBAL_MAX_RL(theMax,myThid)

      CALL MON_OUT_RL( label, theMax, mon_foot_max ,myThid)

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

!=======================================================================
      subroutine comprecv_r4( dataname, Ni,Oi,Nj,Oj, arr )
      implicit none
! Arguments
      character*(*) dataname
      integer Ni,Oi,Nj,Oj,Io,Jo
      real*4 arr(1-Oi:Ni+Oi,1-Oj:Nj+Oj)
! Predefined constants/arrays
#include "CPLR_SIG.h"
! MPI variables
#include "mpif.h"
      integer count,dtype,rank,tag,comm,ierr
      integer stat(MPI_STATUS_SIZE)
! Functions
      integer generate_tag
! Local
      integer i,j,ij,nx,ny
      character*(MAXLEN_COMP_NAME) recvdname
!     ------------------------------------------------------------------

      if (HEADER_SIZE+Ni*Nj.gt.MAX_R4_BUFLEN)
     &    stop 'comprecv_r4: Nx*Ny too big'

! Receive message
      count=HEADER_SIZE+MAX_R4_BUFLEN
      dtype=MPI_REAL
      tag=generate_tag(121,my_rank_in_global,dataname)
      rank=my_coupler_rank
      comm=MPI_COMM_myglobal

      if (VERB) then
       write(LogUnit,*) 'comprecv_r4: calling MPI_Recv rank=',rank
       write(LogUnit,*) 'comprecv_r4: dataname=',dataname
       call flush(LogUnit)
      endif
      call MPI_Recv(r4buf, count, dtype, rank, tag, comm, stat, ierr)
      if (VERB) then
       write(LogUnit,*) 'comprecv_r4: returned ierr=',ierr
       call flush(LogUnit)
      endif

      if (ierr.ne.0) then
       write(LogUnit,*) 'comprecv_r4tiles: rank(W,G)=',
     &            my_rank_in_world,my_rank_in_global,
     &            ' ierr=',ierr
       stop 'comprecv_r4: MPI_Recv failed'
      endif

! Extract buffer
      Io=int(0.5+r4buf(1))
      Jo=int(0.5+r4buf(2))
      nx=int(0.5+r4buf(3))
      ny=int(0.5+r4buf(4))
      call mitcplr_real2char( r4buf(9), recvdname )

      if (Io.ne.my_tile_i0(1)) stop 'comprecv_r4: bad Io'
      if (Jo.ne.my_tile_j0(1)) stop 'comprecv_r4: bad Jo'
      if (nx.ne.my_tile_nx(1)) stop 'comprecv_r4: bad nx'
      if (ny.ne.my_tile_ny(1)) stop 'comprecv_r4: bad ny'
      if (recvdname .ne. dataname) then
       write(LogUnit,*) 'comprecv_r4: recvdname = ',recvdname
       write(LogUnit,*) 'comprecv_r4:  dataname = ',dataname
       stop 'comprecv_r4: recvdname != dataname'
      endif

! Copy buffer to interior of tile
      do j=1,Nj
       do i=1,Ni
        ij=HEADER_SIZE+i+Ni*(j-1)
        arr(i,j)=r4buf(ij)
       enddo
      enddo

!     ------------------------------------------------------------------
      return
      end
!=======================================================================

#include "SMOOTH_OPTIONS.h"

      SUBROUTINE SMOOTH_READPARMS( myThid )

C     *==========================================================*
C     | SUBROUTINE SMOOTH_READPARMS
C     | o Routine that reads the pkg/smooth namelist from data.smooth
C     *==========================================================*

      IMPLICIT NONE

C     == global variables ==
#include "EEPARAMS.h"
#include "SIZE.h"
#include "GRID.h"
#include "PARAMS.h"
#include "SMOOTH.h"

C     == routine arguments ==
      INTEGER myThid

C     == local variables ==
C     msgBuf     :: Informational/error message buffer
C     iUnit      :: Work variable for IO unit number
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      INTEGER iUnit
      INTEGER smoothOpNb

      CHARACTER*(MAX_LEN_FNAM) namBuf
      INTEGER IL
#ifdef HAVE_SYSTEM
      INTEGER pIL
#endif

c     == functions ==
      INTEGER  ILNBLNK
      EXTERNAL ILNBLNK

C     == end of interface ==

C--   Read the namelist input.
      NAMELIST /smooth_nml/
     &                   smooth2Dnbt,
     &                   smooth2Dtype,
     &                   smooth2Dsize,
     &                   smooth2D_Lx0,
     &                   smooth2D_Ly0,
     &                   smooth2Dfilter,
     &                   smooth2DmaskName,
     &                   smooth3Dnbt,
     &                   smooth3DtypeH,
     &                   smooth3DsizeH,
     &                   smooth3DtypeZ,
     &                   smooth3DsizeZ,
     &                   smooth3D_Lx0,
     &                   smooth3D_Ly0,
     &                   smooth3D_Lz0,
     &                   smooth3Dfilter,
     &                   smooth3DmaskName,
     &                   smoothDir

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      IF ( .NOT.useSMOOTH ) THEN
C-    pkg SMOOTH is not used
        _BEGIN_MASTER(myThid)
C-    Track pkg activation status:
C     print a (weak) warning if data.smooth is found
         CALL PACKAGES_UNUSED_MSG( 'useSMOOTH', ' ', ' ' )
        _END_MASTER(myThid)
        RETURN
      ENDIF

      _BEGIN_MASTER( myThid )

C--   Set default values.
      DO smoothOpNb=1,smoothOpNbMax
        smooth2Dnbt(smoothOpNb)=0
        smooth2D_Lx0(smoothOpNb)=0. _d 0
        smooth2D_Ly0(smoothOpNb)=0. _d 0
        smooth2Dtype(smoothOpNb)=0
        smooth2Dsize(smoothOpNb)=0
        smooth2Dfilter(smoothOpNb)=0
        smooth2DmaskName(smoothOpNb)(1:5) = 'maskC'

        smooth3Dnbt(smoothOpNb)=0
        smooth3D_Lx0(smoothOpNb)=0. _d 0
        smooth3D_Ly0(smoothOpNb)=0. _d 0
        smooth3D_Lz0(smoothOpNb)=0. _d 0
        smooth3DtypeH(smoothOpNb)=0
        smooth3DsizeH(smoothOpNb)=0
        smooth3DtypeZ(smoothOpNb)=0
        smooth3DsizeZ(smoothOpNb)=0
        smooth3Dfilter(smoothOpNb)=0
        smooth3DmaskName(smoothOpNb)(1:5) = 'maskC'
      ENDDO
      smoothDir = ' '

C--   Read settings from model parameter file "data.smooth".
      WRITE(msgBuf,'(A)') 'SMOOTH_READPARMS: opening data.smooth'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )

      CALL OPEN_COPY_DATA_FILE(
     I                          'data.smooth', 'SMOOTH_READPARMS',
     O                          iUnit,
     I                          myThid )

      READ(  iUnit, nml = smooth_nml )

      WRITE(msgBuf,'(2A)') 'SMOOTH_READPARMS: ',
     &       'finished reading data.smooth'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )

#ifdef SINGLE_DISK_IO
      CLOSE(iUnit)
#else
      CLOSE(iUnit,STATUS='DELETE')
#endif /* SINGLE_DISK_IO */

C--   Print pkg/smooth settings to standard output:
      WRITE(msgBuf,'(A)')
     &'// ======================================================='
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)') '// pkg/smooth configuration'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)')
     &'// ======================================================='
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )

      IF ( smoothDir .NE. ' ' ) THEN
       IL = ILNBLNK( smoothDir )
C      append "/", if necessary
       IF ( IL.LT.MAX_LEN_FNAM .AND. smoothDir(IL:IL).NE.'/' ) THEN
        namBuf(1:IL) = smoothDir(1:IL)
        WRITE(smoothDir(1:IL+1),'(2A)') namBuf(1:IL),'/'
       ENDIF
#ifdef HAVE_SYSTEM
C      create directory
       IL = ILNBLNK( smoothDir ) -1
       WRITE(namBuf,'(2A)') ' mkdir -p ', smoothDir(1:IL)
       pIL = 1 + ILNBLNK( namBuf )
       WRITE(standardMessageUnit,'(3A)')
     &  '==> SYSTEM CALL (from SMOOTH_READPARMS): >',
     &                                 namBuf(1:pIL), '<'
       CALL SYSTEM( namBuf(1:pIL) )
#else
       WRITE(msgBuf,'(2A)') '** WARNING ** SMOOTH_READPARMS: ',
     &       'cannot call mkdir -> please create smoothDir manually'
       CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                     SQUEEZE_RIGHT, myThid )
#endif
      ENDIF

      DO smoothOpNb=1,smoothOpNbMax
        IF (smooth2Dtype(smoothOpNb).NE.0) THEN
          WRITE(msgBuf,'(A,I2,I6,2F6.0,A)') 'smooth 2D parameters: ',
     &       smoothOpNb,smooth2Dnbt(smoothOpNb),
     &       smooth2D_Lx0(smoothOpNb),smooth2D_Ly0(smoothOpNb),
     &       smooth2DmaskName(smoothOpNb)
          CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                        SQUEEZE_RIGHT, myThid )
        ENDIF
      ENDDO

      DO smoothOpNb=1,smoothOpNbMax
        IF ((smooth3DtypeZ(smoothOpNb).NE.0).OR.
     &      (smooth3DtypeH(smoothOpNb).NE.0)) then
          WRITE(msgBuf,'(A,I2,I6,3F6.0,A)') 'smooth 3D parameters: ',
     &       smoothOpNb,smooth3Dnbt(smoothOpNb),
     &       smooth3D_Lx0(smoothOpNb),smooth3D_Ly0(smoothOpNb),
     &       smooth3D_Lz0(smoothOpNb),
     &       smooth3DmaskName(smoothOpNb)
          CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                        SQUEEZE_RIGHT, myThid )
        ENDIF
      ENDDO

      WRITE(msgBuf,'(A)')
     &'// ======================================================='
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)') '// End of pkg/smooth config. summary'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)')
     &'// ======================================================='
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)') ' '
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )

      _END_MASTER( myThid )

C--   Everyone else must wait for the parameters to be loaded
      _BARRIER

      RETURN
      END

#include "GAD_OPTIONS.h"
#include "PTRACERS_OPTIONS.h"

CBOP
C !ROUTINE: PTRACERS_WRITE_PICKUP

C !INTERFACE: ==========================================================
      SUBROUTINE PTRACERS_WRITE_PICKUP( permCheckPoint,
     &                    suff, myTime, myIter, myThid )

C !DESCRIPTION:
C     Writes current state of passive tracers to a pickup file

C !USES: ===============================================================
#include "PTRACERS_MOD.h"
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GAD.h"
#include "PTRACERS_SIZE.h"
#include "PTRACERS_PARAMS.h"
#include "PTRACERS_FIELDS.h"

C !INPUT PARAMETERS: ===================================================
C     permCheckPoint  :: permanent or a rolling checkpoint
C     suff            :: suffix for pickup file (eg. ckptA or 0000000010)
C     myTime          :: model time
C     myIter          :: time-step number
C     myThid          :: thread number
      LOGICAL permCheckPoint
      CHARACTER*(*) suff
      _RL myTime
      INTEGER myIter
      INTEGER myThid

C !OUTPUT PARAMETERS: ==================================================
C  none

#ifdef ALLOW_PTRACERS

C     === Functions ====
      INTEGER  ILNBLNK
      EXTERNAL ILNBLNK

C !LOCAL VARIABLES: ====================================================
C     iTracer     :: tracer index
C     j           :: loop index / field number
C     prec        :: pickup-file precision
C     glf         :: local flag for "globalFiles"
C     fn          :: character buffer for creating filename
C     nWrFlds     :: number of fields being written
C     listDim     :: dimension of "wrFldList" local array
C     wrFldList   :: list of written fields
C     msgBuf      :: Informational/error message buffer
      INTEGER iTracer, j, prec, lChar
      LOGICAL glf
      _RL     timList(1)
      CHARACTER*(MAX_LEN_FNAM) fn
      INTEGER listDim, nWrFlds
      PARAMETER( listDim = 3*PTRACERS_num )
      CHARACTER*(8) wrFldList(listDim)
      CHARACTER*(MAX_LEN_MBUF) msgBuf
#ifdef PTRACERS_ALLOW_DYN_STATE
      INTEGER n, iRec
#endif
CEOP

#ifdef ALLOW_MNC
      IF ( PTRACERS_pickup_write_mnc ) THEN
        IF ( permCheckPoint ) THEN
          WRITE(fn,'(A)') 'pickup_ptracers'
        ELSE
          lChar = ILNBLNK(suff)
          WRITE(fn,'(2A)') 'pickup_ptracers.', suff(1:lChar)
        ENDIF
        CALL MNC_FILE_CLOSE_ALL_MATCHING(fn, myThid)
C       First ***define*** the file group name
        CALL MNC_CW_SET_UDIM(fn, 1, myThid)
        IF ( permCheckPoint ) THEN
          CALL MNC_CW_SET_CITER(fn, 3, 3, myIter, -1, myThid)
        ELSE
          CALL MNC_CW_SET_CITER(fn, 2, -1, -1, -1, myThid)
        ENDIF
C       Then set the actual unlimited dimension
        CALL MNC_CW_SET_UDIM(fn, 1, myThid)
C       The following two values should probably be for the n-1 time
C       step since we are saving the gpTrNm1 variable first
        CALL MNC_CW_RL_W_S('D',fn,0,0,'T', myTime, myThid)
        CALL MNC_CW_I_W_S('I',fn,0,0,'iter', myIter, myThid)
        DO iTracer = 1,PTRACERS_numInUse
          CALL MNC_CW_RL_W('D',fn,0,0, PTRACERS_names(iTracer),
     &         gpTrNm1(1-OLx,1-OLy,1,1,1,iTracer),myThid)
        ENDDO
        CALL MNC_CW_SET_UDIM(fn, 2, myThid)
        CALL MNC_CW_RL_W_S('D',fn,0,0,'T', myTime, myThid)
        CALL MNC_CW_I_W_S('I',fn,0,0,'iter', myIter, myThid)
        DO iTracer = 1,PTRACERS_numInUse
          CALL MNC_CW_RL_W('D',fn,0,0, PTRACERS_names(iTracer),
     &         pTracer(1-OLx,1-OLy,1,1,1,iTracer),myThid)
        ENDDO
      ENDIF
      IF ( useMNC .AND. PTRACERS_pickup_write_mnc ) THEN
       DO iTracer = 1, PTRACERS_numInUse
        IF ( PTRACERS_SOM_Advection(iTracer) ) THEN
         WRITE(msgBuf,'(3A)')'PTRACERS_WRITE_PICKUP: MNC not yet coded',
     &                       ' for SOM advection',
     &                       ' => write bin file instead'
         CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                       SQUEEZE_RIGHT, myThid)
        ENDIF
       ENDDO
      ENDIF
#endif /*  ALLOW_MNC  */

      lChar = ILNBLNK(suff)
      IF ( PTRACERS_pickup_write_mdsio ) THEN

        IF ( lChar.EQ.0 ) THEN
          WRITE(fn,'(2A)') 'pickup_ptracers'
        ELSE
          WRITE(fn,'(2A)') 'pickup_ptracers.',suff(1:lChar)
        ENDIF
        prec = precFloat64

C       Firstly, write ptracer fields as consecutive records,
C       one tracer after the other, for all tracers "InUse".

        j  = 0
C     record number < 0 : a hack not to write meta files now:
        DO iTracer = 1, PTRACERS_numInUse
          j = j + 1
          CALL WRITE_REC_3D_RL( fn, prec, Nr,
     &         pTracer(1-OLx,1-OLy,1,1,1,iTracer),
     &         -j, myIter, myThid )
          IF (j.LE.listDim)
     &      wrFldList(j) = 'pTr'//PTRACERS_ioLabel(iTracer)//'   '
        ENDDO

C       Then write ptracer tendencies (if this tracer is using AB time-stepping)
        DO iTracer = 1, PTRACERS_numInUse
         IF ( PTRACERS_AdamsBashGtr(iTracer) .OR.
     &        PTRACERS_AdamsBash_Tr(iTracer) ) THEN
          j = j + 1
          CALL WRITE_REC_3D_RL( fn, prec, Nr,
     &         gpTrNm1(1-OLx,1-OLy,1,1,1,iTracer),
     &         -j, myIter, myThid )
          IF ( j.LE.listDim .AND. PTRACERS_AdamsBashGtr(iTracer) )
     &      wrFldList(j) = 'gPtr'//PTRACERS_ioLabel(iTracer)//'m1'
          IF ( j.LE.listDim .AND. PTRACERS_AdamsBash_Tr(iTracer) )
     &      wrFldList(j) = 'pTr'//PTRACERS_ioLabel(iTracer)//'Nm1'
         ENDIF

        ENDDO

C--------------------------
        nWrFlds = j
        IF ( nWrFlds.GT.listDim ) THEN
          WRITE(msgBuf,'(2A,I5,A)') 'PTRACERS_WRITE_PICKUP: ',
     &     'trying to write ',nWrFlds,' fields'
          CALL PRINT_ERROR( msgBuf, myThid )
          WRITE(msgBuf,'(2A,I5,A)') 'PTRACERS_WRITE_PICKUP: ',
     &     'field-list dimension (listDim=',listDim,') too small'
          CALL PRINT_ERROR( msgBuf, myThid )
          STOP 'ABNORMAL END: S/R PTRACERS_WRITE_PICKUP (list-size Pb)'
        ENDIF
#ifdef ALLOW_MDSIO
C     uses this specific S/R to write (with more informations) only meta files
        glf  = globalFiles
        timList(1) = myTime
        CALL MDS_WR_METAFILES( fn, prec, glf, .FALSE.,
     &                         0, 0, Nr, ' ',
     &                         nWrFlds, wrFldList,
     &                         1, timList, oneRL,
     &                         j, myIter, myThid )
#endif /* ALLOW_MDSIO */
C--------------------------
      ENDIF

#ifdef PTRACERS_ALLOW_DYN_STATE
C     write pickup for 2nd-order moment fields
C     we write a separate file for each Ptracer that uses SOM advection
        DO iTracer = 1, PTRACERS_numInUse
         IF ( PTRACERS_SOM_Advection(iTracer) ) THEN
          IF ( lChar.EQ.0 ) THEN
            WRITE(fn,'(2A)') 'pickup_somTRAC',PTRACERS_ioLabel(iTracer)
          ELSE
            WRITE(fn,'(4A)') 'pickup_somTRAC',PTRACERS_ioLabel(iTracer),
     &                       '.',suff(1:lChar)
          ENDIF
          _BEGIN_MASTER(myThid)
          WRITE(msgBuf,'(A,I4,A)')'PTRACERS_WRITE_PICKUP: iTracer =',
     &                       iTracer, ' : writing 2nd-order moments'
          CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                        SQUEEZE_RIGHT, myThid )
          j = ILNBLNK(fn)
          WRITE(msgBuf,'(A,A)') ' to file: ',fn(1:j)
          CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                        SQUEEZE_RIGHT, myThid )
          _END_MASTER(myThid)
          prec = precFloat64
C     Write 2nd Order moments as consecutive records
          DO n=1,nSOM
            iRec = n
            CALL WRITE_REC_3D_RL( fn, prec, Nr,
     I               _Ptracers_som(:,:,:,:,:,n,iTracer),
     I               iRec, myIter, myThid )
          ENDDO
         ENDIF
        ENDDO
#endif /* PTRACERS_ALLOW_DYN_STATE */

#endif /* ALLOW_PTRACERS */

      RETURN
      END

#include "SALT_PLUME_OPTIONS.h"

CBOP 0
C     !ROUTINE: SALT_PLUME_DIAGNOSTICS_INIT
C     !INTERFACE:
      SUBROUTINE SALT_PLUME_DIAGNOSTICS_INIT( myThid )

C     !DESCRIPTION:
C     Initialize list of all available diagnostics

C     !USES:
      IMPLICIT NONE
#include "EEPARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     myThid ::  my Thread Id number
      INTEGER myThid
CEOP

#ifdef ALLOW_SALT_PLUME
#ifdef ALLOW_DIAGNOSTICS

C     !LOCAL VARIABLES:
C     === Local variables ===
C     diagNum   :: diagnostics number in the (long) list of available diag.
C     diagName  :: local short name (8c) of a diagnostics
C     diagCode  :: local parser field with characteristics of the diagnostics
C              cf head of S/R DIAGNOSTICS_INIT_EARLY or DIAGNOSTICS_MAIN_INIT
C     diagUnits :: local string (16c): physical units of a diagnostic field
C     diagTitle :: local string (80c): description of field in diagnostic
      INTEGER       diagNum
      CHARACTER*8   diagName
      CHARACTER*16  diagCode
      CHARACTER*16  diagUnits
      CHARACTER*(80) diagTitle

      diagName  = 'PLUMEKB '
      diagTitle = 'fractional plume: [0-1] (unitless)'
      diagUnits = '                '
      diagCode  = 'SM      MR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'oceSPtnd'
      diagTitle = 'salt tendency due to salt plume flux' 
     &          //' >0 increases salinity'
      diagUnits = 'g/m^2/s         '
      diagCode  = 'SM      MR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )


      diagName  = 'oceSPflx'
      diagTitle = 'net surface Salt flux rejected into the ocean during'
     &          //' freezing, (+=down),'
c    &          //' >0 increases salinity'
      diagUnits = 'g/m^2/s         '
      diagCode  = 'SM      U1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'oceSPDep'
      diagTitle = 'Salt plume depth based on density criterion (>0)'
      diagUnits = 'm               '
      diagCode  = 'SM      U1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

#ifdef SALT_PLUME_VOLUME
      diagName  = 'oceSPvol'
      diagTitle = ''
     &          //'surf brineVol associated w salt plume flux'
      diagUnits = 'm/s             '
      diagCode  = 'SM      U1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )
c
      diagName  = 'PLUMEKB1'
      diagTitle = 'fractional plume: [0-1] (unitless)'
      diagUnits = '                '
      diagCode  = 'SM      UR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'oceEPtnd'
      diagTitle = 'temperature tendency due to salt plume flux'
     &          //' >0 increases temperature'
      diagUnits = 'W/m^2           '
      diagCode  = 'SM      MR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )
c
      diagName  = 'SPtd_TH '
      diagTitle = 'Energy tendency associated with salt plume flux'
     &          //' >0 increases temperature'
      diagUnits = 'W/m^2           '
      diagCode  = 'SM      MR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )
cSPtd_SLT is a duplicate of oceSPtnd
      diagName  = 'SPtd_SLT'
      diagTitle = 'salt tendency associated with salt plume flux'
     &          //' >0 increases salinity'
      diagUnits = 'g/m^2/s         '
      diagCode  = 'SM      MR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'SPforcT1'
      diagTitle = ''
     &          //' range [1:Nr] '
      diagUnits = 'unitless        '
      diagCode  = 'SM      U1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'SPforcS1'
      diagTitle = ''
     &          //' range [1:Nr] '
      diagUnits = 'unitless        '
      diagCode  = 'SM      U1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'SPVsuf2k'
      diagTitle = 'salt plume volume flux from surface INTO lev k'
     &          //' >0 increases volume(k)'
      diagUnits = 'm/s             '
      diagCode  = 'SM      MR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'SPVk2m  '
      diagTitle = 'vol flux LEAVING k to k-1 due to SPVsuf2k&SPVp2k'
     &          //' <0 decreases volume(k)'
      diagUnits = 'm/s             '
      diagCode  = 'SM      MR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )
#endif /* SALT_PLUME_VOLUME */

#endif /* ALLOW_DIAGNOSTICS */
#endif /* ALLOW_SALT_PLUME */

      RETURN
      END

#include "MOM_VECINV_OPTIONS.h"

CBOP
C     !ROUTINE: MOM_VI_V_CORIOLIS
C     !INTERFACE:
      SUBROUTINE MOM_VI_V_CORIOLIS(
     I                     bi, bj, k,
     I                     selectVortScheme, useJamartMomAdv,
     I                     uFld, omega3, hFacZ, r_hFacZ,
     O                     vCoriolisTerm,
     I                     myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R MOM_VI_V_CORIOLIS
C     |==========================================================*
C     | o Calculate flux (in X-dir.) of vorticity at V point
C     |   using 2nd order interpolation
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "GRID.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
      INTEGER bi, bj, k
      _RL     uFld     (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL     omega3   (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RS     hFacZ    (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RS     r_hFacZ  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL vCoriolisTerm(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER selectVortScheme
      LOGICAL useJamartMomAdv
      INTEGER myThid
CEOP

C     == Local variables ==
C     msgBuf :: Informational/error message buffer
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      INTEGER i, j
      _RL     uBarXY, uBarYm, uBarYp
      _RL     vort3v
      _RL     vort3im, vort3ij, vort3pm, vort3pj
      _RL     oneThird, tmpFac
      _RS     epsil

      epsil = 1. _d -9
      tmpFac = 1. _d 0
c     oneThird = 1. _d 0 / ( 1. _d 0 + 2.*tmpFac )
      oneThird = 1. _d 0 / 3. _d 0

      IF ( selectVortScheme.EQ.0 ) THEN
C--   using enstrophy conserving scheme (Shallow-Water Eq.) by Sadourny, JAS 75

       DO j=2-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx-1
         uBarXY = 0.25 _d 0 *(
     &      ( uFld( i , j )*dyG( i , j ,bi,bj)*_hFacW( i , j ,k,bi,bj)
     &      + uFld( i ,j-1)*dyG( i ,j-1,bi,bj)*_hFacW( i ,j-1,k,bi,bj) )
     &     +( uFld(i+1, j )*dyG(i+1, j ,bi,bj)*_hFacW(i+1, j ,k,bi,bj)
     &      + uFld(i+1,j-1)*dyG(i+1,j-1,bi,bj)*_hFacW(i+1,j-1,k,bi,bj) )
     &                       )
         vort3v = halfRL*( omega3(i,j)*r_hFacZ(i,j)
     &                   + omega3(i+1,j)*r_hFacZ(i+1,j) )
         vCoriolisTerm(i,j) = -vort3v*uBarXY*recip_dyC(i,j,bi,bj)
     &                               * _maskS(i,j,k,bi,bj)
        ENDDO
       ENDDO

      ELSEIF ( selectVortScheme.EQ.1 ) THEN
C--   same as above, with different formulation (relatively to hFac)

       DO j=2-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx-1
         uBarXY = halfRL*(
     &      ( uFld( i , j )*dyG( i , j ,bi,bj)*hFacZ( i ,j)
     &      + uFld( i ,j-1)*dyG( i ,j-1,bi,bj)*hFacZ( i ,j) )
     &     +( uFld(i+1, j )*dyG(i+1, j ,bi,bj)*hFacZ(i+1,j)
     &      + uFld(i+1,j-1)*dyG(i+1,j-1,bi,bj)*hFacZ(i+1,j) )
     &                     )/MAX( epsil, hFacZ(i,j)+hFacZ(i+1,j) )
         vort3v = halfRL*( omega3(i,j) + omega3(i+1,j) )
         vCoriolisTerm(i,j) = -vort3v*uBarXY*recip_dyC(i,j,bi,bj)
     &                               * _maskS(i,j,k,bi,bj)
        ENDDO
       ENDDO

      ELSEIF ( selectVortScheme.EQ.2 ) THEN
C--   using energy conserving scheme (used by Sadourny in JAS 75 paper)

       DO j=2-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx-1
         uBarYm = halfRL*(
     &       uFld( i , j )*dyG( i , j ,bi,bj)*_hFacW( i , j ,k,bi,bj)
     &     + uFld( i ,j-1)*dyG( i ,j-1,bi,bj)*_hFacW( i ,j-1,k,bi,bj) )
         uBarYp = halfRL*(
     &       uFld(i+1, j )*dyG(i+1, j ,bi,bj)*_hFacW(i+1, j ,k,bi,bj)
     &     + uFld(i+1,j-1)*dyG(i+1,j-1,bi,bj)*_hFacW(i+1,j-1,k,bi,bj) )
         vort3v = ( uBarYm*r_hFacZ( i ,j)*omega3( i ,j)
     &            + uBarYp*r_hFacZ(i+1,j)*omega3(i+1,j)
     &            )*halfRL
         vCoriolisTerm(i,j) = -vort3v*recip_dyC(i,j,bi,bj)
     &                               * _maskS(i,j,k,bi,bj)
        ENDDO
       ENDDO

      ELSEIF ( selectVortScheme.EQ.3 ) THEN
C--   using energy & enstrophy conserving scheme
C     (from Sadourny, described by Burridge & Haseler, ECMWF Rep.4, 1977)

C     domain where vCoriolisTerm is valid :
C     [ 2-Olx : sNx+Olx-1 ] x [ 3-Oly : sNy+Oly-1 ]
C     (=> might need overlap of 3 if using CD-scheme)
       DO j=2-OLy,sNy+OLy-1
        DO i=1-OLx,sNx+OLx-1
         vort3im = ( r_hFacZ(i, j )*omega3(i, j )
     &             +(r_hFacZ(i+1,j)*omega3(i+1,j)
     &              +r_hFacZ(i,j-1)*omega3(i,j-1)
     &             ))*oneThird
c    &             )*tmpFac)*oneThird
     &      *uFld( i ,j-1)*dyG( i ,j-1,bi,bj)*_hFacW( i ,j-1,k,bi,bj)
         vort3ij = ( r_hFacZ(i, j )*omega3(i, j )
     &             +(r_hFacZ(i+1,j)*omega3(i+1,j)
     &              +r_hFacZ(i,j+1)*omega3(i,j+1)
     &             ))*oneThird
c    &             )*tmpFac)*oneThird
     &      *uFld( i , j )*dyG( i , j ,bi,bj)*_hFacW( i , j ,k,bi,bj)
         vort3pm = ( r_hFacZ(i+1,j)*omega3(i+1,j)
     &             +(r_hFacZ(i, j )*omega3(i, j )
     &              +r_hFacZ(i+1,j-1)*omega3(i+1,j-1)
     &             ))*oneThird
c    &             )*tmpFac)*oneThird
     &      *uFld(i+1,j-1)*dyG(i+1,j-1,bi,bj)*_hFacW(i+1,j-1,k,bi,bj)
         vort3pj = ( r_hFacZ(i+1,j)*omega3(i+1,j)
     &             +(r_hFacZ(i, j )*omega3(i, j )
     &              +r_hFacZ(i+1,j+1)*omega3(i+1,j+1)
     &             ))*oneThird
c    &             )*tmpFac)*oneThird
     &      *uFld(i+1, j )*dyG(i+1, j ,bi,bj)*_hFacW(i+1, j ,k,bi,bj)
C---
         vCoriolisTerm(i,j) = -( (vort3im+vort3ij)+(vort3pm+vort3pj) )
     &                      *0.25 _d 0 *recip_dyC(i,j,bi,bj)
     &                                 * _maskS(i,j,k,bi,bj)
        ENDDO
       ENDDO

      ELSEIF ( selectVortScheme.EQ.4 ) THEN
C--   using energy conserving scheme without r_hFacZ factor

       DO j=2-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx-1
         uBarYm = halfRL*(
     &       uFld( i , j )*dyG( i , j ,bi,bj)*_hFacW( i , j ,k,bi,bj)
     &     + uFld( i ,j-1)*dyG( i ,j-1,bi,bj)*_hFacW( i ,j-1,k,bi,bj) )
         uBarYp = halfRL*(
     &       uFld(i+1, j )*dyG(i+1, j ,bi,bj)*_hFacW(i+1, j ,k,bi,bj)
     &     + uFld(i+1,j-1)*dyG(i+1,j-1,bi,bj)*_hFacW(i+1,j-1,k,bi,bj) )
         vort3v = ( uBarYm*omega3( i ,j)
     &            + uBarYp*omega3(i+1,j)
     &            )*halfRL
         vCoriolisTerm(i,j) = -vort3v*recip_dyC(i,j,bi,bj)
     &                               *recip_hFacS(i,j,k,bi,bj)
        ENDDO
       ENDDO

      ELSE
        WRITE(msgBuf,'(A,I5,A)')
     &   'MOM_VI_V_CORIOLIS: selectVortScheme=', selectVortScheme,
     &   ' not implemented'
        CALL PRINT_ERROR( msgBuf, myThid )
        STOP 'ABNORMAL END: S/R MOM_VI_V_CORIOLIS'

      ENDIF

      IF ( useJamartMomAdv ) THEN
       DO j=2-OLy,sNy+OLy-1
        DO i=1-OLx,sNx+OLx-1
         vCoriolisTerm(i,j) = vCoriolisTerm(i,j)
     &           * 4. _d 0 * _hFacS(i,j,k,bi,bj)
     &           / MAX( epsil,
     &                  (_hFacW( i ,j,k,bi,bj)+_hFacW( i ,j-1,k,bi,bj))
     &                 +(_hFacW(i+1,j,k,bi,bj)+_hFacW(i+1,j-1,k,bi,bj))
     &                )
        ENDDO
       ENDDO
      ENDIF

      RETURN
      END

#include "CTRL_OPTIONS.h"

      subroutine ctrl_init_wet( myThid )

c     ==================================================================
c     SUBROUTINE ctrl_init_wet
c     ==================================================================

      IMPLICIT NONE

c     == global variables ==
#include "EEPARAMS.h"
#include "SIZE.h"
#include "PARAMS.h"
#include "GRID.h"
#include "CTRL_SIZE.h"
#include "CTRL.h"
#include "CTRL_OBCS.h"

#ifdef ALLOW_OBCS_CONTROL
# include "OBCS_GRID.h"
#endif
#ifdef ALLOW_SHELFICE
# include "SHELFICE.h"
#endif /* ALLOW_SHELFICE */

c     == routine arguments ==
      integer myThid

c     == local variables ==
      integer bi,bj
      integer i,j,k
      integer itlo,ithi
      integer jtlo,jthi
      integer jmin,jmax
      integer imin,imax
      integer ivar
      integer ntmp2(4)
      integer nwetc3d
#ifdef ALLOW_SHELFICE
      integer ntmpshi
#endif
#ifdef ALLOW_OBCS_CONTROL
      integer iobcs
      integer ntmpob(nobcs)
      CHARACTER*(MAX_LEN_FNAM) ymaskobcs
#endif
c#ifdef REAL4_IS_SLOW
c     _RL dummy
c#endif
      _RS dummyRS
      CHARACTER*(MAX_LEN_MBUF) msgbuf

c--   Set loop ranges.
      jtlo = myByLo(myThid)
      jthi = myByHi(myThid)
      itlo = myBxLo(myThid)
      ithi = myBxHi(myThid)
      jmin = 1
      jmax = sNy
      imin = 1
      imax = sNx

c--   Determine the number of wet points in each tile:
c--   maskc, masks, and maskw.

c--   Initialise the counters.
      do bj = jtlo,jthi
        do bi = itlo,ithi
          do k = 1,Nr
            nwetctile(bi,bj,k) = 0
            nwetstile(bi,bj,k) = 0
            nwetwtile(bi,bj,k) = 0
            nwetvtile(bi,bj,k) = 0
#ifdef ALLOW_SHELFICE
            nwetitile(bi,bj,k) = 0
#endif
          enddo
        enddo
      enddo

#ifdef ALLOW_OBCS_CONTROL
c--   Initialise obcs counters.
      do bj = jtlo,jthi
        do bi = itlo,ithi
          do k = 1,Nr
            do iobcs = 1,nobcs
#ifdef ALLOW_OBCSN_CONTROL
              nwetobcsn(bi,bj,k,iobcs) = 0
#endif
#ifdef ALLOW_OBCSS_CONTROL
              nwetobcss(bi,bj,k,iobcs) = 0
#endif
#ifdef ALLOW_OBCSW_CONTROL
              nwetobcsw(bi,bj,k,iobcs) = 0
#endif
#ifdef ALLOW_OBCSE_CONTROL
              nwetobcse(bi,bj,k,iobcs) = 0
#endif
            enddo
          enddo
        enddo
      enddo
#endif

c--   Count wet points on each tile.
      do bj = jtlo,jthi
        do bi = itlo,ithi
          do k = 1,Nr
            do j = jmin,jmax
              do i = imin,imax
c--             Center mask.
                if (maskC(i,j,k,bi,bj) .ne. 0.) then
                  nwetctile(bi,bj,k) = nwetctile(bi,bj,k) + 1
                endif
c--             South mask.
                if (maskS(i,j,k,bi,bj) .eq. 1.) then
                  nwetstile(bi,bj,k) = nwetstile(bi,bj,k) + 1
                endif
c--             West mask.
                if (maskW(i,j,k,bi,bj) .eq. 1.) then
                  nwetwtile(bi,bj,k) = nwetwtile(bi,bj,k) + 1
                endif
#ifdef ALLOW_SHELFICE
c--             Ice shelf mask.
                if (maskSHI(i,j,k,bi,bj) .eq. 1.) then
                 nwetitile(bi,bj,k) = nwetitile(bi,bj,k) + 1
                endif
#endif /* ALLOW_SHELFICE */
              enddo
            enddo
          enddo
        enddo
      enddo

#ifdef ALLOW_OBCSN_CONTROL
c--   Count wet points at Northern boundary.
c--   mask conventions are adopted from obcs_apply_ts, obcs_apply_uv
      ymaskobcs = 'maskobcsn'
      call ctrl_mask_set_xz( 0, OB_indexNone, OB_Jn,
     &                       nwetobcsn, ymaskobcs, myThid )
#endif

#ifdef ALLOW_OBCSS_CONTROL
c--   Count wet points at Southern boundary.
c--   mask conventions are adopted from obcs_apply_ts, obcs_apply_uv
      ymaskobcs = 'maskobcss'
      call ctrl_mask_set_xz( 1, OB_indexNone, OB_Js,
     &                       nwetobcss, ymaskobcs, myThid )
#endif

#ifdef ALLOW_OBCSW_CONTROL
c--   Count wet points at Western boundary.
c--   mask conventions are adopted from obcs_apply_ts, obcs_apply_uv
      ymaskobcs = 'maskobcsw'
      call ctrl_mask_set_yz( 1, OB_indexNone, OB_Iw,
     &                       nwetobcsw, ymaskobcs, myThid )
#endif

#ifdef ALLOW_OBCSE_CONTROL
c--   Count wet points at Eastern boundary.
c--   mask conventions are adopted from obcs_apply_ts, obcs_apply_uv
      ymaskobcs = 'maskobcse'
      call ctrl_mask_set_yz( 0, OB_indexNone, OB_Ie,
     &                       nwetobcse, ymaskobcs, myThid )
#endif

      _BEGIN_MASTER( myThid )
c--   Determine the total number of control variables.
      nvartype   = 0
      nvarlength = 0
      do ivar = 1, maxcvars
c
       if ( ncvarindex(ivar) .ge. 0 ) then
        nvartype = nvartype + 1
        do bj = jtlo,jthi
         do bi = itlo,ithi
          do k = 1,ncvarnrmax(ivar)
           if ( ncvargrd(ivar) .eq. 'c' ) then
            nvarlength = nvarlength + ncvarrecs(ivar)*nwetctile(bi,bj,k)
           else if ( ncvargrd(ivar) .eq. 's' ) then
            nvarlength = nvarlength + ncvarrecs(ivar)*nwetstile(bi,bj,k)
           else if ( ncvargrd(ivar) .eq. 'w' ) then
            nvarlength = nvarlength + ncvarrecs(ivar)*nwetwtile(bi,bj,k)
c          else if ( ncvargrd(ivar) .eq. 'v' ) then
c           nvarlength = nvarlength + ncvarrecs(ivar)*nwetvtile(bi,bj,k)
#ifdef ALLOW_SHELFICE
c--             Ice shelf mask.
           else if ( ncvargrd(ivar) .eq. 'i') then
            nvarlength = nvarlength + ncvarrecs(ivar)*nwetitile(bi,bj,k)
#endif /* ALLOW_SHELFICE */
           else if ( ncvargrd(ivar) .eq. 'm' ) then
#ifdef ALLOW_OBCS_CONTROL
            do iobcs = 1, nobcs
cgg   This overcounts the number of o.b. control points by a factor of "nobcs".
cgg   As an ad-hoc solution I have divided by nobcs everywhere.
#ifdef ALLOW_OBCSN_CONTROL
             if ( ncvarindex(ivar) .eq. 1 ) nvarlength = nvarlength
     &            + nwetobcsn(bi,bj,k,iobcs)*(ncvarrecs(ivar)/nobcs)
#endif
#ifdef ALLOW_OBCSS_CONTROL
             if ( ncvarindex(ivar) .eq. 2 ) nvarlength = nvarlength
     &            + nwetobcss(bi,bj,k,iobcs)*(ncvarrecs(ivar)/nobcs)
#endif
#ifdef ALLOW_OBCSE_CONTROL
             if ( ncvarindex(ivar) .eq. 3 ) nvarlength = nvarlength
     &            + nwetobcse(bi,bj,k,iobcs)*(ncvarrecs(ivar)/nobcs)
#endif
#ifdef ALLOW_OBCSW_CONTROL
             if ( ncvarindex(ivar) .eq. 4 ) nvarlength = nvarlength
     &            + nwetobcsw(bi,bj,k,iobcs)*(ncvarrecs(ivar)/nobcs)
#endif
            enddo
#endif
           else
            print*,'ctrl_init_wet: invalid grid location'
            print*,'     control variable = ',ncvarindex(ivar)
            print*,'     grid location    = ',ncvargrd(ivar)
            stop   ' ... stopped in ctrl_init_wet'
           endif
          enddo
         enddo
        enddo
       endif
      enddo

cph(
      write(msgbuf,'(a,2x,I10)')
     &     'ctrl-wet 1:    nvarlength = ', nvarlength
      call print_message( msgbuf, standardMessageUnit,
     &     SQUEEZE_RIGHT, myThid )
      write(msgbuf,'(a,2x,I10)')
     &     'ctrl-wet 2: surface wet C = ', nwetctile(1,1,1)
      call print_message( msgbuf, standardMessageUnit,
     &     SQUEEZE_RIGHT, myThid )
      write(msgbuf,'(a,2x,I10)')
     &     'ctrl-wet 3: surface wet W = ', nwetwtile(1,1,1)
      call print_message( msgbuf, standardMessageUnit,
     &     SQUEEZE_RIGHT, myThid )
      write(msgbuf,'(a,2x,I10)')
     &     'ctrl-wet 4: surface wet S = ', nwetstile(1,1,1)
      call print_message( msgbuf, standardMessageUnit,
     &     SQUEEZE_RIGHT, myThid )
c     write(msgbuf,'(a,2x,I10)')
c    &     'ctrl-wet 4a:surface wet V = ', nwetvtile(1,1,1)
c     call print_message( msgbuf, standardMessageUnit,
c    &     SQUEEZE_RIGHT, myThid )

      nwetc3d = 0
      do k = 1, Nr
         nwetc3d = nwetc3d + nwetctile(1,1,k)
      end do
      write(msgbuf,'(a,2x,I10)')
     &     'ctrl-wet 5: 3D wet points = ', nwetc3d
      call print_message( msgbuf, standardMessageUnit,
     &     SQUEEZE_RIGHT, myThid )

      do ivar = 1, maxcvars
         write(msgbuf,'(a,2x,I3,2x,I10)')
     &     'ctrl-wet 6: no recs for ivar = ', ivar, ncvarrecs(ivar)
        call print_message( msgbuf, standardMessageUnit,
     &       SQUEEZE_RIGHT, myThid )
      end do

#ifdef ALLOW_OBCSN_CONTROL
      write(msgbuf,'(a,2x,4I10)')
     &     'ctrl-wet 9: surface wet obcsn = '
     &     , nwetobcsn(1,1,1,1), nwetobcsn(1,1,1,2)
     &     , nwetobcsn(1,1,1,3), nwetobcsn(1,1,1,4)
      call print_message( msgbuf, standardMessageUnit,
     &     SQUEEZE_RIGHT, myThid )
#endif
#ifdef ALLOW_OBCSS_CONTROL
      write(msgbuf,'(a,2x,4I10)')
     &     'ctrl-wet 10: surface wet obcss = '
     &     , nwetobcss(1,1,1,1), nwetobcss(1,1,1,2)
     &     , nwetobcss(1,1,1,3), nwetobcss(1,1,1,4)
      call print_message( msgbuf, standardMessageUnit,
     &     SQUEEZE_RIGHT, myThid )
#endif
#ifdef ALLOW_OBCSW_CONTROL
      write(msgbuf,'(a,2x,4I10)')
     &     'ctrl-wet 11: surface wet obcsw = '
     &     , nwetobcsw(1,1,1,1), nwetobcsw(1,1,1,2)
     &     , nwetobcsw(1,1,1,3), nwetobcsw(1,1,1,4)
      call print_message( msgbuf, standardMessageUnit,
     &     SQUEEZE_RIGHT, myThid )
#endif
#ifdef ALLOW_OBCSE_CONTROL
      write(msgbuf,'(a,2x,4I10)')
     &     'ctrl-wet 12: surface wet obcse = '
     &     , nwetobcse(1,1,1,1), nwetobcse(1,1,1,2)
     &     , nwetobcse(1,1,1,3), nwetobcse(1,1,1,4)
      call print_message( msgbuf, standardMessageUnit,
     &     SQUEEZE_RIGHT, myThid )
#endif
cph)

      write(msgbuf,'(a)')
     &    'ctrl-wet -------------------------------------------------'
      call print_message( msgbuf, standardMessageUnit,
     &    SQUEEZE_RIGHT, myThid )

      CALL GLOBAL_SUM_INT( nvarlength,  myThid )

      write(msgbuf,'(a,2x,I3,2x,I10)')
     &     'ctrl-wet 13: global nvarlength for Nr =', Nr, nvarlength
      call print_message( msgbuf, standardMessageUnit,
     &     SQUEEZE_RIGHT, myThid )

      write(msgbuf,'(a)')
     &    'ctrl-wet -------------------------------------------------'
      call print_message( msgbuf, standardMessageUnit,
     &    SQUEEZE_RIGHT, myThid )

c
c     Summation of wet point counters
c
      do k = 1, Nr

         ntmp2(1)=0
         do bj=1,nSy
            do bi=1,nSx
               ntmp2(1)=ntmp2(1)+nWetcTile(bi,bj,k)
            enddo
         enddo
         CALL GLOBAL_SUM_INT( ntmp2(1),  myThid )
         nWetcGlobal(k)=ntmp2(1)

         ntmp2(2)=0
         do bj=1,nSy
            do bi=1,nSx
               ntmp2(2)=ntmp2(2)+nWetsTile(bi,bj,k)
            enddo
         enddo
         CALL GLOBAL_SUM_INT( ntmp2(2),  myThid )
         nWetsGlobal(k)=ntmp2(2)

         ntmp2(3)=0
         do bj=1,nSy
            do bi=1,nSx
               ntmp2(3)=ntmp2(3)+nWetwTile(bi,bj,k)
            enddo
         enddo
         CALL GLOBAL_SUM_INT( ntmp2(3),  myThid )
         nWetwGlobal(k)=ntmp2(3)

         ntmp2(4)=0
c        do bj=1,nSy
c           do bi=1,nSx
c              ntmp2(4)=ntmp2(4)+nWetvTile(bi,bj,k)
c           enddo
c        enddo
c        CALL GLOBAL_SUM_INT( ntmp2(4),  myThid )
         nWetvGlobal(k)=ntmp2(4)

         write(msgbuf,'(a,2x,I3,4(2x,I10))')
     &        'ctrl-wet 14: global nWet C/S/W k=', k, (ntmp2(i),i=1,3)
c    &        'ctrl-wet 14: global nWet C/S/W/V k=', k, ntmp2
         call print_message( msgbuf, standardMessageUnit,
     &       SQUEEZE_RIGHT, myThid )

      enddo

      write(msgbuf,'(a)')
     &    'ctrl-wet -------------------------------------------------'
      call print_message( msgbuf, standardMessageUnit,
     &    SQUEEZE_RIGHT, myThid )

      do k = 1, Nr

#ifdef ALLOW_OBCSN_CONTROL
         do iobcs = 1, nobcs
            ntmpob(iobcs)=0
            do bj=1,nSy
               do bi=1,nSx
                  ntmpob(iobcs)=ntmpob(iobcs)+nwetobcsn(bi,bj,k,iobcs)
               enddo
            enddo
            CALL GLOBAL_SUM_INT( ntmpob(iobcs),  myThid )
            nwetobcsnglo(k,iobcs)=ntmpob(iobcs)
         enddo
         write(msgbuf,'(a,2x,I3,4(2x,I10))')
     &       'ctrl-wet 15a: global obcsN T,S,U,V k=', k, ntmpob
         call print_message( msgbuf, standardMessageUnit,
     &       SQUEEZE_RIGHT, myThid )
#endif
#ifdef ALLOW_OBCSS_CONTROL
         do iobcs = 1, nobcs
            ntmpob(iobcs)=0
            do bj=1,nSy
               do bi=1,nSx
                  ntmpob(iobcs)=ntmpob(iobcs)+nwetobcss(bi,bj,k,iobcs)
               enddo
            enddo
            CALL GLOBAL_SUM_INT( ntmpob(iobcs),  myThid )
            nwetobcssglo(k,iobcs)=ntmpob(iobcs)
         enddo
         write(msgbuf,'(a,2x,I3,4(2x,I10))')
     &       'ctrl-wet 15b: global obcsS T,S,U,V k=', k, ntmpob
         call print_message( msgbuf, standardMessageUnit,
     &       SQUEEZE_RIGHT, myThid )
#endif
#ifdef ALLOW_OBCSW_CONTROL
         do iobcs = 1, nobcs
            ntmpob(iobcs)=0
            do bj=1,nSy
               do bi=1,nSx
                  ntmpob(iobcs)=ntmpob(iobcs)+nwetobcsw(bi,bj,k,iobcs)
               enddo
            enddo
            CALL GLOBAL_SUM_INT( ntmpob(iobcs),  myThid )
            nwetobcswglo(k,iobcs)=ntmpob(iobcs)
         enddo
         write(msgbuf,'(a,2x,I3,4(2x,I10))')
     &       'ctrl-wet 15c: global obcsW T,S,U,V k=', k, ntmpob
         call print_message( msgbuf, standardMessageUnit,
     &       SQUEEZE_RIGHT, myThid )
#endif
#ifdef ALLOW_OBCSE_CONTROL
         do iobcs = 1, nobcs
            ntmpob(iobcs)=0
            do bj=1,nSy
               do bi=1,nSx
                  ntmpob(iobcs)=ntmpob(iobcs)+nwetobcse(bi,bj,k,iobcs)
               enddo
            enddo
            CALL GLOBAL_SUM_INT( ntmpob(iobcs),  myThid )
            nwetobcseglo(k,iobcs)=ntmpob(iobcs)
         enddo
         write(msgbuf,'(a,2x,I3,4(2x,I10))')
     &       'ctrl-wet 15d: global obcsE T,S,U,V k=', k, ntmpob
         call print_message( msgbuf, standardMessageUnit,
     &       SQUEEZE_RIGHT, myThid )
#endif

      enddo

#ifdef ALLOW_OBCS_CONTROL
      write(msgbuf,'(a)')
     &    'ctrl-wet -------------------------------------------------'
      call print_message( msgbuf, standardMessageUnit,
     &    SQUEEZE_RIGHT, myThid )
#endif

#ifdef ALLOW_OBCSN_CONTROL
      do iobcs = 1, nobcs
        ntmpob(iobcs)=0
        do k = 1, Nr
          ntmpob(iobcs)=ntmpob(iobcs)+nwetobcsnglo(k,iobcs)
        enddo
      enddo
      write(msgbuf,'(a,4(2x,I10))')
     &    'ctrl-wet 16a: global SUM(K) obcsN T,S,U,V ', ntmpob
      call print_message( msgbuf, standardMessageUnit,
     &    SQUEEZE_RIGHT, myThid )
#endif
#ifdef ALLOW_OBCSS_CONTROL
      do iobcs = 1, nobcs
        ntmpob(iobcs)=0
        do k = 1, Nr
          ntmpob(iobcs)=ntmpob(iobcs)+nwetobcssglo(k,iobcs)
        enddo
      enddo
      write(msgbuf,'(a,4(2x,I10))')
     &    'ctrl-wet 16b: global SUM(K) obcsS T,S,U,V ', ntmpob
      call print_message( msgbuf, standardMessageUnit,
     &    SQUEEZE_RIGHT, myThid )
#endif
#ifdef ALLOW_OBCSW_CONTROL
      do iobcs = 1, nobcs
        ntmpob(iobcs)=0
        do k = 1, Nr
          ntmpob(iobcs)=ntmpob(iobcs)+nwetobcswglo(k,iobcs)
        enddo
      enddo
      write(msgbuf,'(a,4(2x,I10))')
     &    'ctrl-wet 16c: global SUM(K) obcsW T,S,U,V ', ntmpob
      call print_message( msgbuf, standardMessageUnit,
     &    SQUEEZE_RIGHT, myThid )
#endif
#ifdef ALLOW_OBCSE_CONTROL
      do iobcs = 1, nobcs
        ntmpob(iobcs)=0
        do k = 1, Nr
          ntmpob(iobcs)=ntmpob(iobcs)+nwetobcseglo(k,iobcs)
        enddo
      enddo
      write(msgbuf,'(a,4(2x,I10))')
     &    'ctrl-wet 16d: global SUM(K) obcsE T,S,U,V ', ntmpob
      call print_message( msgbuf, standardMessageUnit,
     &    SQUEEZE_RIGHT, myThid )
#endif
#ifdef ALLOW_OBCS_CONTROL
      write(msgbuf,'(a)')
     &    'ctrl-wet -------------------------------------------------'
      call print_message( msgbuf, standardMessageUnit,
     &    SQUEEZE_RIGHT, myThid )
#endif

#ifdef ALLOW_SHELFICE
      write(msgbuf,'(a,2x,I10)')
     &     'ctrl-wet 17a:surface wet I = ', nwetitile(1,1,1)
      call print_message( msgbuf, standardMessageUnit,
     &     SQUEEZE_RIGHT, myThid )

      do k = 1, Nr
       ntmpshi=0
       do bj=1,nSy
        do bi=1,nSx
         ntmpshi=ntmpshi+nWetiTile(bi,bj,k)
        enddo
       enddo
       CALL GLOBAL_SUM_INT( ntmpshi,  myThid )
       if (k.eq.1) then
        nWetiGlobal(k)=ntmpshi
       else
        nWetiGlobal(k)=0
       endif
       write(msgbuf,'(a,2x,I3,2x,I10)')
     &      'ctrl-wet 17b: global nWet I k=', k, ntmpshi
       call print_message( msgbuf, standardMessageUnit,
     &      SQUEEZE_RIGHT, myThid )
      enddo

      ntmpshi=0
      do k = 1, Nr
       ntmpshi=ntmpshi+nWetiGlobal(k)
      enddo
      write(msgbuf,'(a,2x,I10)')
     &    'ctrl-wet 17c: global SUM(K) shelfice ', ntmpshi
      call print_message( msgbuf, standardMessageUnit,
     &    SQUEEZE_RIGHT, myThid )

      write(msgbuf,'(a)')
     &    'ctrl-wet -------------------------------------------------'
      call print_message( msgbuf, standardMessageUnit,
     &    SQUEEZE_RIGHT, myThid )
#endif

      write(msgbuf,'(a,2x,I10)')
     &     'ctrl_init_wet: no. of control variables: ', nvartype
      call print_message( msgbuf, standardMessageUnit,
     &     SQUEEZE_RIGHT, myThid )
      write(msgbuf,'(a,2x,I10)')
     &     'ctrl_init_wet: control vector length:    ', nvarlength
      call print_message( msgbuf, standardMessageUnit,
     &     SQUEEZE_RIGHT, myThid )

      _END_MASTER( myThid )

#ifdef ALLOW_AUTODIFF
c     write masks and weights to files to be read by a master process
c
c#ifdef REAL4_IS_SLOW
C     leave this commented out (in case of problems with ACTIVE_WRITE_GEN_RS)
c     call active_write_xyz( 'maskCtrlC', maskC, 1, 0, myThid, dummy)
c     call active_write_xyz( 'maskCtrlW', maskW, 1, 0, myThid, dummy)
c     call active_write_xyz( 'maskCtrlS', maskS, 1, 0, myThid, dummy)
c#else
      CALL ACTIVE_WRITE_GEN_RS( 'maskCtrlC', maskC, 'XY', Nr,
     I                          1, .FALSE., 0, myThid, dummyRS )
      CALL ACTIVE_WRITE_GEN_RS( 'maskCtrlW', maskW, 'XY', Nr,
     I                          1, .FALSE., 0, myThid, dummyRS )
      CALL ACTIVE_WRITE_GEN_RS( 'maskCtrlS', maskS, 'XY', Nr,
     I                          1, .FALSE., 0, myThid, dummyRS )
c#endif
#ifdef ALLOW_SHELFICE
c#ifdef REAL4_IS_SLOW
c     call active_write_xyz( 'maskCtrlI', maskSHI, 1, 0, myThid, dummy)
c#else
      CALL ACTIVE_WRITE_GEN_RS( 'maskCtrlI', maskSHI, 'XY', Nr,
     I                          1, .FALSE., 0, myThid, dummyRS )
c#endif
#endif

#endif /* ALLOW_AUTODIFF */

      RETURN
      END

#include "CAL_OPTIONS.h"

      subroutine cal_MonthsPerYear(
     I                              myiter,
     I                              mytime,
     O                              nmonths,
     I                              mythid
     &                            )

c     ==================================================================
c     SUBROUTINE cal_MonthsPerYear
c     ==================================================================
c
c     o Given the iteration number during the integration and/or the
c       currenttime of integration return the number of months left in
c       the current calendar year including the one containing
c       currenttime/iter.
c              
c     started: Christian Eckert eckert@mit.edu  30-Jun-1999
c
c     changed: Christian Eckert eckert@mit.edu  29-Dec-1999
c
c              - restructured the original version in order to have a
c                better interface to the MITgcmUV.
c
c              Christian Eckert eckert@mit.edu  03-Feb-2000
c
c              - Introduced new routine and function names, cal_<NAME>,
c                for verion 0.1.3.
c
c     ==================================================================
c     SUBROUTINE cal_MonthsPerYear
c     ==================================================================

      implicit none

c     == global variables ==

#include "cal.h"

c     == routine arguments ==

      integer myiter
      _RL     mytime
      integer nmonths
      integer mythid

c     == local variables ==

      integer mydate(4)
      integer present
      integer final

c     == end of interface ==

      call cal_GetDate( myiter, mytime, mydate, mythid )

      present = mydate(1)/10000
      final   = modelenddate(1)/10000

      if (present .eq. final) then
        present = mod(mydate(1)/100,100)
        final   = mod(modelenddate(1)/100,100)
ce      nmonths = final - present + 1
      else
        present = mod(mydate(1)/100,100)
        final   = nmonthyear
ce      nmonths = nmonthyear - mod(mydate(1)/100,100) + 1
      endif
      nmonths = final - present + 1

      return
      end

#include "PACKAGES_CONFIG.h"
#include "CPP_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C     files.

CBOP
C     !ROUTINE: PACKAGES_WRITE_PICKUP

C     !INTERFACE:
      SUBROUTINE PACKAGES_WRITE_PICKUP(
     I                    permPickup, suffix,
     I                    myTime, myIter, myThid )

C     !DESCRIPTION:
C     Write pickup files for each package which needs it to restart.
C     This routine (S/R PACKAGES_WRITE_PICKUP) calls per-package
C     write-pickup (or checkpoint) routines.  It writes both
C     "rolling-pickup" files (ckptA,ckptB) and permanent pickup.

C     !CALLING SEQUENCE:
C     PACKAGES_WRITE_PICKUP
C       |
C       |-- GAD_WRITE_PICKUP
C       |
C       |-- CD_CODE_WRITE_PICKUP
C       |
C       |-- OBCS_WRITE_PICKUP
C       |
C       |-- GGL90_WRITE_PICKUP
C       |
C       |-- GMREDI_WRITE_PICKUP
C       |
C       |-- BBL_WRITE_PICKUP
C       |
C       |-- CHEAPAML_WRITE_PICKUP
C       |
C       |-- FLT_WRITE_PICKUP
C       |
C       |-- PTRACERS_WRITE_PICKUP
C       |
C       |-- GCHEM_WRITE_PICKUP
C       |
C       |-- STREAMICE_WRITE_PICKUP
C       |
C       |-- SHELFICE_WRITE_PICKUP
C       |
C       |-- SEAICE_WRITE_PICKUP
C       |
C       |-- THSICE_WRITE_PICKUP
C       |
C       |-- LAND_WRITE_PICKUP
C       |
C       |-- ATM_PHYS_WRITE_PICKUP
C       |
C       |-- FIZHI_WRITE_PICKUP
C       |-- FIZHI_WRITE_VEGTILES
C       |-- FIZHI_WRITE_DATETIME
C       |
C       |-- DIAGNOSTICS_WRITE_PICKUP
C       |
C       |-- CPL_WRITE_PICKUP
C       |
C       |-- ECCO_WRITE_PICKUP
C       |
C       |-- MYPACKAGE_WRITE_PICKUP

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "RESTART.h"

C     !INPUT/OUTPUT PARAMETERS:
C     permPickup :: Is or is not a permanent pickup.
C     suffix     :: pickup-name suffix
C     myTime     :: Current time of simulation ( s )
C     myIter     :: Iteration number
C     myThid     :: Thread number for this instance of the routine.
      LOGICAL permPickup
      CHARACTER*(*) suffix
      _RL     myTime
      INTEGER myIter
      INTEGER myThid

C     !LOCAL VARIABLES:
CEOP

C     Going to really do some IO. Make everyone except master thread wait.
C     this is done within IO routines => no longer needed
c     _BARRIER

#ifdef ALLOW_GENERIC_ADVDIFF
C     Write restart file for 2nd-Order moment (active) Tracers
      IF ( useGAD ) THEN
        CALL GAD_WRITE_PICKUP(
     I                 suffix, myTime, myIter, myThid )
      ENDIF
#endif /* ALLOW_GENERIC_ADVDIFF */

#ifdef ALLOW_CD_CODE
      IF (useCDscheme) THEN
        CALL CD_CODE_WRITE_PICKUP( permPickup,
     I                     suffix, myTime, myIter, myThid )
      ENDIF
#endif /* ALLOW_CD_CODE */

#ifdef  ALLOW_OBCS
      IF (useOBCS) THEN
        CALL OBCS_WRITE_PICKUP(
     &                  suffix, myTime, myIter, myThid )
      ENDIF
#endif  /* ALLOW_OBCS */

#ifdef  ALLOW_GGL90
      IF ( useGGL90 ) THEN
        CALL GGL90_WRITE_PICKUP( permPickup,
     I                      suffix, myTime, myIter, myThid )
      ENDIF
#endif  /* ALLOW_GGL90 */

#ifdef ALLOW_GMREDI
      IF ( useGMRedi ) THEN
        CALL GMREDI_WRITE_PICKUP( permPickup,
     I                      suffix, myTime, myIter, myThid )
      ENDIF
#endif

#ifdef ALLOW_BBL
      IF (useBBL) THEN
        CALL BBL_WRITE_PICKUP( permPickup,
     I                      suffix, myTime, myIter, myThid )
      ENDIF
#endif /* ALLOW_MYPACKAGE */

#ifdef ALLOW_CHEAPAML
C     Write restart file for CHEAPAML pkg
      IF ( useCheapAML ) THEN
         CALL CHEAPAML_WRITE_PICKUP( permPickup,
     I                      suffix, myTime, myIter, myThid)
       ENDIF
#endif /* ALLOW_CHEAPAML */

#ifdef ALLOW_FLT
C     Write restart file for floats
      IF (useFLT) THEN
        CALL FLT_WRITE_PICKUP(
     &                  suffix, myTime, myIter, myThid )
      ENDIF
#endif

#ifdef ALLOW_PTRACERS
C     Write restart file for passive tracers
      IF (usePTRACERS) THEN
        CALL PTRACERS_WRITE_PICKUP( permPickup,
     I                      suffix, myTime, myIter, myThid )
      ENDIF
#endif /* ALLOW_PTRACERS */

#ifdef ALLOW_GCHEM
C     Write restart file for GCHEM pkg & GCHEM sub-packages
      IF ( useGCHEM ) THEN
        CALL GCHEM_WRITE_PICKUP( permPickup,
     I                      suffix, myTime, myIter, myThid )
      ENDIF
#endif

#ifdef ALLOW_STREAMICE
      IF (useStreamIce) THEN
        CALL STREAMICE_WRITE_PICKUP( permPickup,
     I                    suffix, myTime, myIter, myThid )
      ENDIF
#endif

#ifdef ALLOW_SHELFICE
      IF (useShelfIce) THEN
        CALL SHELFICE_WRITE_PICKUP( permPickup,
     I                    suffix, myTime, myIter, myThid )
      ENDIF
#endif

#ifdef  ALLOW_SEAICE
      IF ( useSEAICE ) THEN
        CALL SEAICE_WRITE_PICKUP( permPickup,
     I                    suffix, myTime, myIter, myThid )
      ENDIF
#endif  /* ALLOW_SEAICE */

#ifdef ALLOW_THSICE
      IF (useThSIce) THEN
        CALL THSICE_WRITE_PICKUP( permPickup,
     I                    suffix, myTime, myIter, myThid )
      ENDIF
#endif /* ALLOW_THSICE */

#ifdef ALLOW_LAND
C     Write pickup file for Land package:
      IF (useLand) THEN
        CALL LAND_WRITE_PICKUP( permPickup,
     &                  suffix, myTime, myIter, myThid )
      ENDIF
#endif

#ifdef ALLOW_ATM_PHYS
      IF ( useAtm_Phys ) THEN
        CALL ATM_PHYS_WRITE_PICKUP( permPickup,
     I                      suffix, myTime, myIter, myThid )
      ENDIF
#endif /* ALLOW_ATM_PHYS */

#ifdef ALLOW_FIZHI
C     Write pickup file for fizhi package
      IF (usefizhi) THEN
        CALL FIZHI_WRITE_PICKUP(suffix,myTime,myIter,myThid)
        CALL FIZHI_WRITE_VEGTILES(suffix,0,myTime,myIter,myThid)
        CALL FIZHI_WRITE_DATETIME(myTime,myIter,myThid)
      ENDIF
#endif

#ifdef ALLOW_DIAGNOSTICS
C     Write pickup file for diagnostics package
      IF (useDiagnostics) THEN
        CALL DIAGNOSTICS_WRITE_PICKUP( permPickup,
     I                         suffix, myTime, myIter, myThid )
      ENDIF
#endif

#ifdef  COMPONENT_MODULE
      IF (useCoupler) THEN
        CALL CPL_WRITE_PICKUP(
     &                 suffix, myTime, myIter, myThid )
      ENDIF
#endif  /* COMPONENT_MODULE */

#ifdef ALLOW_ECCO
      IF (useECCO) THEN
        CALL ECCO_WRITE_PICKUP( permPickup,
     I                      suffix, myTime, myIter, myThid )
      ENDIF
#endif /* ALLOW_ECCO */

#ifdef ALLOW_MYPACKAGE
      IF (useMYPACKAGE) THEN
        CALL MYPACKAGE_WRITE_PICKUP( permPickup,
     I                      suffix, myTime, myIter, myThid )
      ENDIF
#endif /* ALLOW_MYPACKAGE */

C--   Every one else must wait until writing is done.
C     this is done within IO routines => no longer needed
c     _BARRIER

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#include "CTRL_OPTIONS.h"
#ifdef ALLOW_COST
#include "COST_OPTIONS.h"
#endif

CBOP
C     !ROUTINE: CTRL_COST_FINAL
C     !INTERFACE:
      SUBROUTINE CTRL_COST_FINAL( ifc, optimcycle, myThid )

C     !DESCRIPTION:
C     *==========================================================*
C     | SUBROUTINE CTRL_COST_FINAL
C     *==========================================================*

C     !USES:
      IMPLICIT NONE

C     == global variables ==
#include "EEPARAMS.h"
#include "SIZE.h"
#include "PARAMS.h"
#ifdef ALLOW_COST
# include "cost.h"
#endif
#include "CTRL_SIZE.h"
#include "CTRL.h"
#include "CTRL_GENARR.h"

C     !INPUT/OUTPUT PARAMETERS:
C     ifc        :: file unit for costfunction_ctrl.XXXX
C     optimcycle :: cycle number of the off-line optimization.
C     myThid     :: my Thread Id number
      INTEGER ifc
      INTEGER optimcycle
      INTEGER myThid

#if defined ALLOW_COST && ( defined ALLOW_GENTIM2D_CONTROL || \
                            defined ALLOW_GENARR2D_CONTROL || \
                            defined ALLOW_GENARR3D_CONTROL )
C     ! FUNCTIONS:
      INTEGER  ILNBLNK
      EXTERNAL ILNBLNK

C     !LOCAL VARIABLES:
      INTEGER bi, bj, num_var
# ifdef ALLOW_GENTIM2D_CONTROL
      _RL f_gentim2d(maxCtrlTim2D)
      _RL no_gentim2d(maxCtrlTim2D)
# endif
# ifdef ALLOW_GENARR2D_CONTROL
      _RL f_genarr2d(maxCtrlArr2D)
      _RL no_genarr2d(maxCtrlArr2D)
# endif
# ifdef ALLOW_GENARR3D_CONTROL
      _RL f_genarr3d(maxCtrlArr3D)
      _RL no_genarr3d(maxCtrlArr3D)
# endif

      CHARACTER*23 cfname
      INTEGER IL
      CHARACTER*(MAX_LEN_FNAM) xx_fname_loc
      CHARACTER*(MAX_LEN_MBUF) msgBuf
CEOP

      IF ( useCtrlCostContribution ) THEN

C     Initialise cost function variables zo zero
# ifdef ALLOW_GENTIM2D_CONTROL
       DO num_var=1,maxCtrlTim2D
        f_gentim2d(num_var)= 0. _d 0
        no_gentim2d(num_var)= 0. _d 0
       ENDDO
# endif
# ifdef ALLOW_GENARR2D_CONTROL
       DO num_var=1,maxCtrlArr2D
        f_genarr2d(num_var)= 0. _d 0
        no_genarr2d(num_var)= 0. _d 0
       ENDDO
# endif
# ifdef ALLOW_GENARR3D_CONTROL
       DO num_var=1,maxCtrlArr3D
        f_genarr3d(num_var)= 0. _d 0
        no_genarr3d(num_var)= 0. _d 0
       ENDDO
# endif

       DO bj = myByLo(myThid), myByHi(myThid)
        DO bi = myBxLo(myThid), myBxHi(myThid)
# ifdef ALLOW_GENTIM2D_CONTROL
         DO num_var=1,maxCtrlTim2D
          tile_fc(bi,bj) = tile_fc(bi,bj)
     &         + mult_gentim2d(num_var)
     &         *objf_gentim2d(bi,bj,num_var)
          f_gentim2d(num_var) = f_gentim2d(num_var)
     &         +objf_gentim2d(bi,bj,num_var)
          no_gentim2d(num_var) = no_gentim2d(num_var)
     &         +num_gentim2d(bi,bj,num_var)
         ENDDO
# endif
# ifdef ALLOW_GENARR2D_CONTROL
         DO num_var=1,maxCtrlArr2D
          tile_fc(bi,bj) = tile_fc(bi,bj)
     &         + mult_genarr2d(num_var)
     &         *objf_genarr2d(bi,bj,num_var)
          f_genarr2d(num_var) = f_genarr2d(num_var)
     &         +objf_genarr2d(bi,bj,num_var)
          no_genarr2d(num_var) = no_genarr2d(num_var)
     &         +num_genarr2d(bi,bj,num_var)
         ENDDO
# endif
# ifdef ALLOW_GENARR3D_CONTROL
         DO num_var=1,maxCtrlArr3D
          tile_fc(bi,bj) = tile_fc(bi,bj)
     &         + mult_genarr3d(num_var)
     &         *objf_genarr3d(bi,bj,num_var)
          f_genarr3d(num_var) = f_genarr3d(num_var)
     &         +objf_genarr3d(bi,bj,num_var)
          no_genarr3d(num_var) = no_genarr3d(num_var)
     &         +num_genarr3d(bi,bj,num_var)
         ENDDO
# endif
        ENDDO
       ENDDO

c#ifndef ALLOW_OPENAD
# ifdef ALLOW_GENTIM2D_CONTROL
       DO num_var=1,maxCtrlTim2D
        _GLOBAL_SUM_RL(f_gentim2d(num_var), myThid )
        _GLOBAL_SUM_RL(no_gentim2d(num_var), myThid )
        IF (no_gentim2d(num_var).GT.0. _d 0) THEN
         xx_fname_loc = xx_gentim2d_file(num_var)
         IL  = ILNBLNK( xx_fname_loc )
         WRITE(msgBuf,'(A,1PE22.14,I2,1X,1PE9.2,1X,3A)')
     &        ' --> f_gentim2d =',f_gentim2d(num_var), num_var,
     &        mult_gentim2d(num_var), '(', xx_fname_loc(1:IL), ')'
         CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                       SQUEEZE_RIGHT, myThid )
        ENDIF
       ENDDO
# endif
# ifdef ALLOW_GENARR2D_CONTROL
       DO num_var=1,maxCtrlArr2D
        _GLOBAL_SUM_RL(f_genarr2d(num_var), myThid )
        _GLOBAL_SUM_RL(no_genarr2d(num_var), myThid )
        IF (no_genarr2d(num_var).GT.0. _d 0) THEN
         xx_fname_loc = xx_genarr2d_file(num_var)
         IL  = ILNBLNK( xx_fname_loc )
         WRITE(msgBuf,'(A,1PE22.14,I2,1X,1PE9.2,1X,3A)')
     &        ' --> f_genarr2d =',f_genarr2d(num_var), num_var,
     &        mult_genarr2d(num_var), '(', xx_fname_loc(1:IL), ')'
         CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                       SQUEEZE_RIGHT, myThid )
        ENDIF
       ENDDO
# endif
# ifdef ALLOW_GENARR3D_CONTROL
       DO num_var=1,maxCtrlArr3D
        _GLOBAL_SUM_RL(f_genarr3d(num_var), myThid )
        _GLOBAL_SUM_RL(no_genarr3d(num_var), myThid )
        IF (no_genarr3d(num_var).GT.0. _d 0) THEN
         xx_fname_loc = xx_genarr3d_file(num_var)
         IL  = ILNBLNK( xx_fname_loc )
         WRITE(msgBuf,'(A,1PE22.14,I2,1X,1PE9.2,1X,3A)')
     &        ' --> f_genarr3d =',f_genarr3d(num_var), num_var,
     &        mult_genarr3d(num_var), '(', xx_fname_loc(1:IL), ')'
         CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                       SQUEEZE_RIGHT, myThid )
        ENDIF
       ENDDO
# endif

C     write contributions to costfunction file

C--   Each process has calculated the global part for itself.
       IF ( ifc .NE. -1 ) THEN
        WRITE(cfname,'(A,I4.4)') 'costfunction_ctrl.',optimcycle
        OPEN(unit=ifc,file=cfname)
        WRITE(msgBuf,'(A,A)')
     &       'Writing generic ctrl cost function info to ', cfname
        CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )

# ifdef ALLOW_GENTIM2D_CONTROL
        DO num_var=1,maxCtrlTim2D
         IF (no_gentim2d(num_var).GT.0. _d 0) THEN
          xx_fname_loc = xx_gentim2d_file(num_var)
          IL  = ILNBLNK( xx_fname_loc )
          IL  = max (IL,15)
          WRITE(ifc,'(2A,I2.0,A,1PE22.14,1PE22.14,1X,1PE9.2)')
     &         xx_fname_loc(1:IL), ' (gentim2d ', num_var, ') = ',
     &         f_gentim2d(num_var), no_gentim2d(num_var),
     &         mult_gentim2d(num_var)
         ENDIF
        ENDDO
# endif

# ifdef ALLOW_GENARR2D_CONTROL
        DO num_var=1,maxCtrlArr2D
         IF (no_genarr2d(num_var).GT.0. _d 0) THEN
          xx_fname_loc = xx_genarr2d_file(num_var)
          IL  = ILNBLNK( xx_fname_loc )
          IL  = max (IL,15)
          WRITE(ifc,'(2A,I2.0,A,1PE22.14,1PE22.14,1X,1PE9.2)')
     &         xx_fname_loc(1:IL), ' (genarr2d ', num_var, ') = ',
     &         f_genarr2d(num_var), no_genarr2d(num_var),
     &         mult_genarr2d(num_var)
         ENDIF
        ENDDO
# endif

# ifdef ALLOW_GENARR3D_CONTROL
        DO num_var=1,maxCtrlArr3D
         IF (no_genarr3d(num_var).GT.0. _d 0) THEN
          xx_fname_loc = xx_genarr3d_file(num_var)
          IL  = ILNBLNK( xx_fname_loc )
          IL  = MAX(IL,15)
          WRITE(ifc,'(2A,I2.0,A,1PE22.14,1PE22.14,1X,1PE9.2)')
     &         xx_fname_loc(1:IL), ' (genarr3d ', num_var, ') = ',
     &         f_genarr3d(num_var), no_genarr3d(num_var),
     &         mult_genarr3d(num_var)
         ENDIF
        ENDDO
# endif
        CLOSE(ifc)
       ENDIF

C     useCtrlCostContribution
      ENDIF

#endif /* ALLOW_COST */

      RETURN
      END

#include "COST_OPTIONS.h"

      SUBROUTINE COST_CHECK( myThid )
C     *==========================================================*
C     | SUBROUTINE CTRK_CHECK                                    |
C     | o Validate basic package setup and inter-package         |
C     | dependencies.                                            |
C     *==========================================================*
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"

C     === Routine arguments ===
C     myThid  :: my Thread Id number
      INTEGER myThid

C     === Local variables ===
C     nRetired :: Counter used to trap gracefully "retired" option & parameters
C     msgBuf   :: Informational/error message buffer
      INTEGER nRetired
      CHARACTER*(MAX_LEN_MBUF) msgBuf

      _BEGIN_MASTER(myThid)
      nRetired = 0

      WRITE(msgBuf,'(A)') 'COST_CHECK: #define ALLOW_COST'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )

#ifdef ALLOW_COST_TRANSPORT
        WRITE(msgBuf,'(2A)') 'COST_CHECK: ',
     &    'ALLOW_COST_TRANSPORT not allowed anymore in COST_OPTIONS.h'
        CALL PRINT_ERROR( msgBuf, myThid )
        nRetired = nRetired + 1
#endif
#ifdef ALLOW_COST_ATLANTIC
        WRITE(msgBuf,'(2A)') 'COST_CHECK: ',
     &    'ALLOW_COST_ATLANTIC not allowed anymore in COST_OPTIONS.h'
        CALL PRINT_ERROR( msgBuf, myThid )
        nRetired = nRetired + 1
#endif
#ifdef ALLOW_COST_DEPTH
        WRITE(msgBuf,'(2A)') 'COST_CHECK: ',
     &    'ALLOW_COST_DEPTH not allowed anymore in COST_OPTIONS.h'
        CALL PRINT_ERROR( msgBuf, myThid )
        nRetired = nRetired + 1
#endif

      IF ( nRetired .GT. 0 ) THEN
        WRITE(msgBuf,'(2A)') 'S/R COST_CHECK: ',
     &   'retired compile-time options need to be undefined'
        CALL PRINT_ERROR( msgBuf, myThid )
        CALL ALL_PROC_DIE( 0 )
        STOP 'ABNORMAL END: S/R COST_CHECK'
      ENDIF

      _END_MASTER(myThid)

      RETURN
      END

#include "SALT_PLUME_OPTIONS.h"

CBOP
C     !ROUTINE: SALT_PLUME_DO_EXCH
C     !INTERFACE:
      SUBROUTINE SALT_PLUME_DO_EXCH(
     I                           myTime, myIter, myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE SALT_PLUME_DO_EXCH
C     | o Apply Exchanges to SALT_PLUME variables when necessary
C     *==========================================================*
C     | o If coupled, prior to EXCH call, also apply update
C     |   from coupling interface
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "SALT_PLUME.h"
#ifdef ALLOW_OCN_COMPON_INTERF
# include "CPL_PARAMS.h"
# include "OCNCPL.h"
#endif /* ALLOW_OCN_COMPON_INTERF */

C     !INPUT/OUTPUT PARAMETERS:
C     myTime :: Current time in simulation
C     myIter :: Current iteration number in simulation
C     myThid :: my Thread Id. number
      _RL     myTime
      INTEGER myIter
      INTEGER myThid
CEOP

C     !LOCAL VARIABLES:
#ifdef ALLOW_OCN_COMPON_INTERF
      INTEGER bi, bj, i, j
#endif /* ALLOW_OCN_COMPON_INTERF */

#ifdef ALLOW_OCN_COMPON_INTERF
c     IF ( useSALT_PLUME .AND. useCoupler ) THEN
      IF ( useCoupler ) THEN
       IF ( useImportSltPlm ) THEN
C-    Take a fraction (SPsalFRAC) of the coupler-imported salt-flux
C      and apply it to salt-plume array (for vertical redistribution)
        DO bj = myByLo(myThid), myByHi(myThid)
         DO bi = myBxLo(myThid), myBxHi(myThid)
           DO j=1-OLy,sNy+OLy
            DO i=1-OLx,sNx+OLx
              saltPlumeFlux(i,j,bi,bj) = saltPlmFlx_cpl(i,j,bi,bj)
     &                                 * SPsalFRAC
            ENDDO
           ENDDO
         ENDDO
        ENDDO
       ENDIF
      ENDIF
#endif /* ALLOW_OCN_COMPON_INTERF */

      IF ( useSALT_PLUME ) THEN
       _EXCH_XY_RL( saltPlumeFlux, myThid )
      ENDIF

      RETURN
      END

#include "OBCS_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 0
C     !ROUTINE: OBCS_READ_PICKUP

C     !INTERFACE:
      SUBROUTINE OBCS_READ_PICKUP( myIter, myThid )

C     !DESCRIPTION:
C     *==========================================================*
C     | SUBROUTINE OBCS_READ_PICKUP
C     | o Read open boundary pickup file
C     *==========================================================*
C     |   Note: only Orlanski OBC needs pickup files to restart
C     *==========================================================*

C     !USES:
      IMPLICIT NONE
C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "OBCS_PARAMS.h"
#include "OBCS_FIELDS.h"
#include "ORLANSKI.h"

C     !INPUT/OUTPUT PARAMETERS:
      INTEGER myIter
      INTEGER myThid
CEOP

#if (defined ALLOW_ORLANSKI) || (defined ALLOW_OBCS_STEVENS)

C     !LOCAL VARIABLES:
      CHARACTER*(MAX_LEN_FNAM) fn
      CHARACTER*(10) suff
      INTEGER prec

      IF ( pickupSuff.EQ.' ' ) THEN
        IF ( rwSuffixType.EQ.0 ) THEN
          WRITE(suff,'(I10.10)') myIter
        ELSE
          CALL RW_GET_SUFFIX( suff, startTime, myIter, myThid )
        ENDIF
      ELSE
        suff = pickupSuff
      ENDIF
      prec = precFloat64

C--   Unlike horizontal 2D or 3D IO routines, no thread synchronisation is
C     done within  Vertical Section IO routines. Since only thread one is
C     doing IO, we need a barrier here to wait for every one to finish.
      _BARRIER

#ifdef ALLOW_ORLANSKI
#ifdef ALLOW_OBCS_NORTH
      IF ( useOrlanskiNorth ) THEN
C     READ N and S OB storage and phase speed arrays
        WRITE(fn,'(2A)') 'pickup_orlanskiN.',suff
        CALL READ_REC_XZ_RL(fn,prec,Nr,UN_STORE_1, 1,myIter,myThid)
        CALL READ_REC_XZ_RL(fn,prec,Nr,UN_STORE_2, 2,myIter,myThid)
        CALL READ_REC_XZ_RL(fn,prec,Nr,UN_STORE_3, 3,myIter,myThid)
        CALL READ_REC_XZ_RL(fn,prec,Nr,UN_STORE_4, 4,myIter,myThid)
        CALL READ_REC_XZ_RL(fn,prec,Nr,VN_STORE_1, 5,myIter,myThid)
        CALL READ_REC_XZ_RL(fn,prec,Nr,VN_STORE_2, 6,myIter,myThid)
        CALL READ_REC_XZ_RL(fn,prec,Nr,VN_STORE_3, 7,myIter,myThid)
        CALL READ_REC_XZ_RL(fn,prec,Nr,VN_STORE_4, 8,myIter,myThid)
        CALL READ_REC_XZ_RL(fn,prec,Nr,TN_STORE_1, 9,myIter,myThid)
        CALL READ_REC_XZ_RL(fn,prec,Nr,TN_STORE_2,10,myIter,myThid)
        CALL READ_REC_XZ_RL(fn,prec,Nr,TN_STORE_3,11,myIter,myThid)
        CALL READ_REC_XZ_RL(fn,prec,Nr,TN_STORE_4,12,myIter,myThid)
        CALL READ_REC_XZ_RL(fn,prec,Nr,SN_STORE_1,13,myIter,myThid)
        CALL READ_REC_XZ_RL(fn,prec,Nr,SN_STORE_2,14,myIter,myThid)
        CALL READ_REC_XZ_RL(fn,prec,Nr,SN_STORE_3,15,myIter,myThid)
        CALL READ_REC_XZ_RL(fn,prec,Nr,SN_STORE_4,16,myIter,myThid)
        CALL READ_REC_XZ_RL(fn,prec,Nr, CVEL_UN , 17,myIter,myThid)
        CALL READ_REC_XZ_RL(fn,prec,Nr, CVEL_VN , 18,myIter,myThid)
        CALL READ_REC_XZ_RL(fn,prec,Nr, CVEL_TN , 19,myIter,myThid)
        CALL READ_REC_XZ_RL(fn,prec,Nr, CVEL_SN , 20,myIter,myThid)
#ifdef ALLOW_NONHYDROSTATIC
       IF ( nonHydrostatic ) THEN
        CALL READ_REC_XZ_RL(fn,prec,Nr,WN_STORE_1,21,myIter,myThid)
        CALL READ_REC_XZ_RL(fn,prec,Nr,WN_STORE_2,22,myIter,myThid)
        CALL READ_REC_XZ_RL(fn,prec,Nr,WN_STORE_3,23,myIter,myThid)
        CALL READ_REC_XZ_RL(fn,prec,Nr,WN_STORE_4,24,myIter,myThid)
        CALL READ_REC_XZ_RL(fn,prec,Nr, CVEL_WN , 25,myIter,myThid)
        CALL READ_REC_XZ_RL(fn,prec,Nr, OBNw    , 26,myIter,myThid)
       ENDIF
#endif
      ENDIF
#endif /* ALLOW_OBCS_NORTH */

#ifdef ALLOW_OBCS_SOUTH
      IF ( useOrlanskiSouth ) THEN
        WRITE(fn,'(2A)') 'pickup_orlanskiS.',suff
        CALL READ_REC_XZ_RL(fn,prec,Nr,US_STORE_1, 1,myIter,myThid)
        CALL READ_REC_XZ_RL(fn,prec,Nr,US_STORE_2, 2,myIter,myThid)
        CALL READ_REC_XZ_RL(fn,prec,Nr,US_STORE_3, 3,myIter,myThid)
        CALL READ_REC_XZ_RL(fn,prec,Nr,US_STORE_4, 4,myIter,myThid)
        CALL READ_REC_XZ_RL(fn,prec,Nr,VS_STORE_1, 5,myIter,myThid)
        CALL READ_REC_XZ_RL(fn,prec,Nr,VS_STORE_2, 6,myIter,myThid)
        CALL READ_REC_XZ_RL(fn,prec,Nr,VS_STORE_3, 7,myIter,myThid)
        CALL READ_REC_XZ_RL(fn,prec,Nr,VS_STORE_4, 8,myIter,myThid)
        CALL READ_REC_XZ_RL(fn,prec,Nr,TS_STORE_1, 9,myIter,myThid)
        CALL READ_REC_XZ_RL(fn,prec,Nr,TS_STORE_2,10,myIter,myThid)
        CALL READ_REC_XZ_RL(fn,prec,Nr,TS_STORE_3,11,myIter,myThid)
        CALL READ_REC_XZ_RL(fn,prec,Nr,TS_STORE_4,12,myIter,myThid)
        CALL READ_REC_XZ_RL(fn,prec,Nr,SS_STORE_1,13,myIter,myThid)
        CALL READ_REC_XZ_RL(fn,prec,Nr,SS_STORE_2,14,myIter,myThid)
        CALL READ_REC_XZ_RL(fn,prec,Nr,SS_STORE_3,15,myIter,myThid)
        CALL READ_REC_XZ_RL(fn,prec,Nr,SS_STORE_4,16,myIter,myThid)
        CALL READ_REC_XZ_RL(fn,prec,Nr, CVEL_US , 17,myIter,myThid)
        CALL READ_REC_XZ_RL(fn,prec,Nr, CVEL_VS , 18,myIter,myThid)
        CALL READ_REC_XZ_RL(fn,prec,Nr, CVEL_TS , 19,myIter,myThid)
        CALL READ_REC_XZ_RL(fn,prec,Nr, CVEL_SS , 20,myIter,myThid)
#ifdef ALLOW_NONHYDROSTATIC
       IF ( nonHydrostatic ) THEN
        CALL READ_REC_XZ_RL(fn,prec,Nr,WS_STORE_1,21,myIter,myThid)
        CALL READ_REC_XZ_RL(fn,prec,Nr,WS_STORE_2,22,myIter,myThid)
        CALL READ_REC_XZ_RL(fn,prec,Nr,WS_STORE_3,23,myIter,myThid)
        CALL READ_REC_XZ_RL(fn,prec,Nr,WS_STORE_4,24,myIter,myThid)
        CALL READ_REC_XZ_RL(fn,prec,Nr, CVEL_WS , 25,myIter,myThid)
        CALL READ_REC_XZ_RL(fn,prec,Nr, OBSw    , 26,myIter,myThid)
       ENDIF
#endif
      ENDIF
#endif /* ALLOW_OBCS_SOUTH */

C     READ E and W OB storage and phase speed arrays
#ifdef ALLOW_OBCS_EAST
      IF ( useOrlanskiEast ) THEN
        WRITE(fn,'(2A)') 'pickup_orlanskiE.',suff
        CALL READ_REC_YZ_RL(fn,prec,Nr,UE_STORE_1, 1,myIter,myThid)
        CALL READ_REC_YZ_RL(fn,prec,Nr,UE_STORE_2, 2,myIter,myThid)
        CALL READ_REC_YZ_RL(fn,prec,Nr,UE_STORE_3, 3,myIter,myThid)
        CALL READ_REC_YZ_RL(fn,prec,Nr,UE_STORE_4, 4,myIter,myThid)
        CALL READ_REC_YZ_RL(fn,prec,Nr,VE_STORE_1, 5,myIter,myThid)
        CALL READ_REC_YZ_RL(fn,prec,Nr,VE_STORE_2, 6,myIter,myThid)
        CALL READ_REC_YZ_RL(fn,prec,Nr,VE_STORE_3, 7,myIter,myThid)
        CALL READ_REC_YZ_RL(fn,prec,Nr,VE_STORE_4, 8,myIter,myThid)
        CALL READ_REC_YZ_RL(fn,prec,Nr,TE_STORE_1, 9,myIter,myThid)
        CALL READ_REC_YZ_RL(fn,prec,Nr,TE_STORE_2,10,myIter,myThid)
        CALL READ_REC_YZ_RL(fn,prec,Nr,TE_STORE_3,11,myIter,myThid)
        CALL READ_REC_YZ_RL(fn,prec,Nr,TE_STORE_4,12,myIter,myThid)
        CALL READ_REC_YZ_RL(fn,prec,Nr,SE_STORE_1,13,myIter,myThid)
        CALL READ_REC_YZ_RL(fn,prec,Nr,SE_STORE_2,14,myIter,myThid)
        CALL READ_REC_YZ_RL(fn,prec,Nr,SE_STORE_3,15,myIter,myThid)
        CALL READ_REC_YZ_RL(fn,prec,Nr,SE_STORE_4,16,myIter,myThid)
        CALL READ_REC_YZ_RL(fn,prec,Nr, CVEL_UE , 17,myIter,myThid)
        CALL READ_REC_YZ_RL(fn,prec,Nr, CVEL_VE , 18,myIter,myThid)
        CALL READ_REC_YZ_RL(fn,prec,Nr, CVEL_TE , 19,myIter,myThid)
        CALL READ_REC_YZ_RL(fn,prec,Nr, CVEL_SE , 20,myIter,myThid)
#ifdef ALLOW_NONHYDROSTATIC
       IF ( nonHydrostatic ) THEN
        CALL READ_REC_YZ_RL(fn,prec,Nr,WE_STORE_1,21,myIter,myThid)
        CALL READ_REC_YZ_RL(fn,prec,Nr,WE_STORE_2,22,myIter,myThid)
        CALL READ_REC_YZ_RL(fn,prec,Nr,WE_STORE_3,23,myIter,myThid)
        CALL READ_REC_YZ_RL(fn,prec,Nr,WE_STORE_4,24,myIter,myThid)
        CALL READ_REC_YZ_RL(fn,prec,Nr, CVEL_WE , 25,myIter,myThid)
        CALL READ_REC_YZ_RL(fn,prec,Nr, OBEw    , 26,myIter,myThid)
       ENDIF
#endif
      ENDIF
#endif /* ALLOW_OBCS_EAST */

#ifdef ALLOW_OBCS_WEST
      IF ( useOrlanskiWest ) THEN
        WRITE(fn,'(2A)') 'pickup_orlanskiW.',suff
        CALL READ_REC_YZ_RL(fn,prec,Nr,UW_STORE_1, 1,myIter,myThid)
        CALL READ_REC_YZ_RL(fn,prec,Nr,UW_STORE_2, 2,myIter,myThid)
        CALL READ_REC_YZ_RL(fn,prec,Nr,UW_STORE_3, 3,myIter,myThid)
        CALL READ_REC_YZ_RL(fn,prec,Nr,UW_STORE_4, 4,myIter,myThid)
        CALL READ_REC_YZ_RL(fn,prec,Nr,VW_STORE_1, 5,myIter,myThid)
        CALL READ_REC_YZ_RL(fn,prec,Nr,VW_STORE_2, 6,myIter,myThid)
        CALL READ_REC_YZ_RL(fn,prec,Nr,VW_STORE_3, 7,myIter,myThid)
        CALL READ_REC_YZ_RL(fn,prec,Nr,VW_STORE_4, 8,myIter,myThid)
        CALL READ_REC_YZ_RL(fn,prec,Nr,TW_STORE_1, 9,myIter,myThid)
        CALL READ_REC_YZ_RL(fn,prec,Nr,TW_STORE_2,10,myIter,myThid)
        CALL READ_REC_YZ_RL(fn,prec,Nr,TW_STORE_3,11,myIter,myThid)
        CALL READ_REC_YZ_RL(fn,prec,Nr,TW_STORE_4,12,myIter,myThid)
        CALL READ_REC_YZ_RL(fn,prec,Nr,SW_STORE_1,13,myIter,myThid)
        CALL READ_REC_YZ_RL(fn,prec,Nr,SW_STORE_2,14,myIter,myThid)
        CALL READ_REC_YZ_RL(fn,prec,Nr,SW_STORE_3,15,myIter,myThid)
        CALL READ_REC_YZ_RL(fn,prec,Nr,SW_STORE_4,16,myIter,myThid)
        CALL READ_REC_YZ_RL(fn,prec,Nr, CVEL_UW , 17,myIter,myThid)
        CALL READ_REC_YZ_RL(fn,prec,Nr, CVEL_VW , 18,myIter,myThid)
        CALL READ_REC_YZ_RL(fn,prec,Nr, CVEL_TW , 19,myIter,myThid)
        CALL READ_REC_YZ_RL(fn,prec,Nr, CVEL_SW , 20,myIter,myThid)
#ifdef ALLOW_NONHYDROSTATIC
       IF ( nonHydrostatic ) THEN
        CALL READ_REC_YZ_RL(fn,prec,Nr,WW_STORE_1,21,myIter,myThid)
        CALL READ_REC_YZ_RL(fn,prec,Nr,WW_STORE_2,22,myIter,myThid)
        CALL READ_REC_YZ_RL(fn,prec,Nr,WW_STORE_3,23,myIter,myThid)
        CALL READ_REC_YZ_RL(fn,prec,Nr,WW_STORE_4,24,myIter,myThid)
        CALL READ_REC_YZ_RL(fn,prec,Nr, CVEL_WW , 25,myIter,myThid)
        CALL READ_REC_YZ_RL(fn,prec,Nr, OBWw    , 26,myIter,myThid)
       ENDIF
#endif
      ENDIF
#endif /* ALLOW_OBCS_WEST */

C     Fill in edge regions
c      _EXCH_XZ_RL(UN_STORE_1 , myThid)
C      same with 2,3,4
C      same with VN_STORE_n, TN_STORE_n, SN_STORE_n, with n=1,2,3,4
C      same with XS_STORE_n, XE_STORE_N, XW_STORE_n, with X=U,V,T,S & n=1,2,3,4

c      _EXCH_XZ_RL(CVEL_UN , myThid)
C      same with CVEL_VN,  CVEL_TN,  CVEL_SN
C      same with CVEL_XS,  CVEL_XE,  CVEL_XW, with X=U,V,T,S
c#ifdef ALLOW_NONHYDROSTATIC
c      _EXCH_XZ_RL(WN_STORE_1 , myThid)
C      same with 2,3,4
C      same with WE_STORE_n, WE_STORE_n, WW_STORE_n, with n=1,2,3,4
c      _EXCH_XZ_RL(CVEL_WN , myThid)
C      same with CVEL_WS,  CVEL_WE,  CVEL_WW
c#endif
#endif /* ALLOW_ORLANSKI */

#ifdef ALLOW_OBCS_STEVENS
#ifdef ALLOW_OBCS_NORTH
      IF ( useStevensNorth ) THEN
        WRITE(fn,'(2A)') 'pickup_stevensN.',suff
        CALL READ_REC_XZ_RL(fn,prec,Nr,OBNvStevens, 1,myIter,myThid)
        CALL READ_REC_XZ_RL(fn,prec,Nr,OBNtStevens, 2,myIter,myThid)
        CALL READ_REC_XZ_RL(fn,prec,Nr,OBNsStevens, 3,myIter,myThid)
      ENDIF
#endif /* ALLOW_OBCS_NORTH */

#ifdef ALLOW_OBCS_SOUTH
      IF ( useStevensSouth ) THEN
        WRITE(fn,'(2A)') 'pickup_stevensS.',suff
        CALL READ_REC_XZ_RL(fn,prec,Nr,OBSvStevens, 1,myIter,myThid)
        CALL READ_REC_XZ_RL(fn,prec,Nr,OBStStevens, 2,myIter,myThid)
        CALL READ_REC_XZ_RL(fn,prec,Nr,OBSsStevens, 3,myIter,myThid)
      ENDIF
#endif /* ALLOW_OBCS_SOUTH */

#ifdef ALLOW_OBCS_EAST
      IF ( useStevensEast ) THEN
        WRITE(fn,'(2A)') 'pickup_stevensE.',suff
        CALL READ_REC_YZ_RL(fn,prec,Nr,OBEuStevens, 1,myIter,myThid)
        CALL READ_REC_YZ_RL(fn,prec,Nr,OBEtStevens, 2,myIter,myThid)
        CALL READ_REC_YZ_RL(fn,prec,Nr,OBEsStevens, 3,myIter,myThid)
      ENDIF
#endif /* ALLOW_OBCS_EAST */

#ifdef ALLOW_OBCS_WEST
      IF ( useStevensWest ) THEN
        WRITE(fn,'(2A)') 'pickup_stevensW.',suff
        CALL READ_REC_YZ_RL(fn,prec,Nr,OBWuStevens, 1,myIter,myThid)
        CALL READ_REC_YZ_RL(fn,prec,Nr,OBWtStevens, 2,myIter,myThid)
        CALL READ_REC_YZ_RL(fn,prec,Nr,OBWsStevens, 3,myIter,myThid)
      ENDIF
#endif /* ALLOW_OBCS_WEST */
#endif /* ALLOW_OBCS_STEVENS */

C--   Every one wait for thread 1 to finish (see comment @ the top)
      _BARRIER

#endif /* ALLOW_ORLANSKI or ALLOW_OBCS_STEVENS */
      RETURN
      END

#include "CHEAPAML_OPTIONS.h"
#undef CHEAPAML_OLD_MASK_SETTING

CBOP
C     !ROUTINE: CHEAPAML_INIT_FIXED
C     !INTERFACE:
      SUBROUTINE CHEAPAML_INIT_FIXED( myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE CHEAPAML_INIT_FIXED
C     *==========================================================*
C     \ev
C     !USES:
      IMPLICIT NONE

C     === Global variables ===
#include "EEPARAMS.h"
#include "SIZE.h"
#include "PARAMS.h"
#include "GRID.h"
#include "CHEAPAML.h"

C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
C     myThid ::  my Thread Id number
      INTEGER myThid

C     !FUNCTIONS
      INTEGER  ILNBLNK
      EXTERNAL ILNBLNK

C     !LOCAL VARIABLES:
C     bi,bj  :: tile indices
C     i,j    :: grid-point indices
C     msgBuf :: Informational/error message buffer
C     relaxMask :: relaxation mask [no units]
C     xgs       :: relaxation coefficient [units: 1/s]
      INTEGER bi, bj
      INTEGER i, j
      INTEGER iG,jG
      INTEGER xmw
      _RL xmf, tmpVar
      _RL relaxMask(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL xgs      (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      INTEGER iL, ioUnit
      CHARACTER*(MAX_LEN_MBUF) msgBuf
#ifdef CHEAPAML_OLD_MASK_SETTING
      _RL recipMW
      _RL cheapaml_taurelax, cheapaml_taurelaxocean
#endif /* CHEAPAML_OLD_MASK_SETTING */
CEOP

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
      ioUnit = standardMessageUnit

C--   Initialise CheapAML local & fixed variables
      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          relaxMask(i,j,bi,bj) = 0. _d 0
          xgs      (i,j,bi,bj) = 0. _d 0
          xrelf    (i,j,bi,bj) = 0. _d 0
         ENDDO
        ENDDO
       ENDDO
      ENDDO

#ifdef CHEAPAML_OLD_MASK_SETTING
      cheapaml_taurelax      =  cheap_tauRelax   /86400. _d 0
      cheapaml_taurelaxocean =  cheap_tauRelaxOce/86400. _d 0

c--   Setup CheapAML mask (for relaxation):
C Do  mask
      IF ( cheapMaskFile .NE. ' ') THEN
         iL = ILNBLNK(cheapMaskFile)
         WRITE(msgBuf,'(4A)') 'CHEAPAML_INIT_VARIA: ',
     &      'Relaxation Mask read from ->', cheapMaskFile(1:iL), '<-'
         CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
         CALL READ_FLD_XY_RL( cheapMaskFile,' ',relaxMask,0,myThid )
      ELSE
         WRITE(msgBuf,'(4A)') 'CHEAPAML_INIT_VARIA: ',
     &      'Generate Cheapaml mask'
         CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
         xmw = Cheapaml_mask_width
         recipMW = ( xmw - 1 )
         IF ( xmw.NE.1 ) recipMW = 1. _d 0 / recipMW
         DO bj = myByLo(myThid), myByHi(myThid)
          DO bi = myBxLo(myThid), myBxHi(myThid)
           DO j=1,sNy
            DO i=1,sNx
             xmf = 0. _d 0
             iG=myXGlobalLo-1+(bi-1)*sNx+i
             jG = myYGlobalLo-1+(bj-1)*sNy+j
             IF (jG.GT.xmw) THEN
               IF (jG.LT.Ny-xmw+1) THEN
                 IF (iG.LE.xmw)      xmf = 1. _d 0 - (iG-1 )*recipMW
                 IF (iG.GE.Nx-xmw+1) xmf = 1. _d 0 - (Nx-iG)*recipMW
               ELSE
                 xmf = 1. _d 0 - (Ny-jG)*recipMW
                 IF (iG.LE.xmw) THEN
                   xmf =  1. _d 0 - (iG-1 )*recipMW *(Ny-jG)*recipMW
                 ELSEIF (iG.GE.Nx-xmw+1) THEN
                   xmf =  1. _d 0 - (Nx-iG)*recipMW *(Ny-jG)*recipMW
                 ENDIF
               ENDIF
             ELSE
               xmf = 1. _d 0 - (jG-1)*recipMW
               IF (iG.LE.xmw) THEN
                 xmf = 1. _d 0 - (iG-1 )*recipMW*(jG-1)*recipMW
               ELSEIF (iG.GE.Nx-xmw+1) THEN
                 xmf = 1. _d 0 - (Nx-iG)*recipMW*(jG-1)*recipMW
               ENDIF
             ENDIF
             relaxMask(i,j,bi,bj) = xmf*cheapaml_taurelax
            ENDDO
           ENDDO
          ENDDO
         ENDDO
      ENDIF

C     relaxation forced on land
       DO bj = myByLo(myThid), myByHi(myThid)
         DO bi = myBxLo(myThid), myBxHi(myThid)
           DO j=1,sNy
             DO i=1,sNx
               IF( maskC(i,j,1,bi,bj).EQ.0. _d 0) THEN
                 relaxMask(i,j,bi,bj)=cheapaml_taurelax
C     relaxation over the ocean
               ELSEIF( relaxMask(i,j,bi,bj).EQ.0. _d 0) THEN
                 relaxMask(i,j,bi,bj)=cheapaml_taurelaxocean
               ENDIF
             ENDDO
           ENDDO
         ENDDO
       ENDDO
       _EXCH_XY_RL( relaxMask, myThid )

C relaxation time scales from input
       DO bj = myByLo(myThid), myByHi(myThid)
        DO bi = myBxLo(myThid), myBxHi(myThid)
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           IF (relaxMask(i,j,bi,bj).NE.0.) THEN
            xgs(i,j,bi,bj)=1. _d 0/relaxMask(i,j,bi,bj)/8.64 _d 4
           ELSE
            xgs(i,j,bi,bj)=0. _d 0
           ENDIF
           xrelf(i,j,bi,bj)= xgs(i,j,bi,bj)*deltaT
     &                     /(1. _d 0+xgs(i,j,bi,bj)*deltaT)
          ENDDO
         ENDDO
        ENDDO
       ENDDO
c      _EXCH_XY_RL( xgs, myThid )
c      _EXCH_XY_RL( xrelf, myThid )

#else /* CHEAPAML_OLD_MASK_SETTING */

C--   Setup CheapAML mask (for relaxation):
      IF ( cheapMaskFile .NE. ' ' ) THEN
C-    read mask from file
        iL = ILNBLNK(cheapMaskFile)
        WRITE(msgBuf,'(4A)') 'CHEAPAML_INIT_VARIA: ',
     &      'Relaxation Mask read from ->', cheapMaskFile(1:iL), '<-'
        CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
        CALL READ_FLD_XY_RL( cheapMaskFile,' ',relaxMask,0,myThid )
      ELSE
        WRITE(msgBuf,'(4A)') 'CHEAPAML_INIT_VARIA: ',
     &     'Generate Cheapaml mask'
        CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
        DO bj = myByLo(myThid), myByHi(myThid)
         DO bi = myBxLo(myThid), myBxHi(myThid)
C-    set mask according to boundaries
          IF ( Cheapaml_mask_width.LE.0 .OR.
     &         ( cheapamlXperiodic .AND. cheapamlYperiodic ) ) THEN
            DO j=1,sNy
             DO i=1,sNx
               relaxMask(i,j,bi,bj) = 0.
             ENDDO
            ENDDO
          ELSE
            xmw = Cheapaml_mask_width
            tmpVar = xmw
            tmpVar = oneRL / tmpVar
            DO j=1,sNy
             DO i=1,sNx
              xmf = 0. _d 0
              iG = myXGlobalLo-1+(bi-1)*sNx+i
              jG = myYGlobalLo-1+(bj-1)*sNy+j
              IF ( .NOT.cheapamlXperiodic ) THEN
                IF (iG.LE.xmw)      xmf = oneRL - (iG-1 )*tmpVar
                IF (iG.GE.Nx-xmw+1) xmf = oneRL - (Nx-iG)*tmpVar
              ENDIF
              IF ( .NOT.cheapamlYperiodic ) THEN
                IF (jG.LE.xmw)
     &                    xmf = MAX( xmf, oneRL - (jG-1 )*tmpVar )
                IF (jG.GE.Ny-xmw+1)
     &                    xmf = MAX( xmf, oneRL - (Ny-jG)*tmpVar )
              ENDIF
              relaxMask(i,j,bi,bj) = xmf
             ENDDO
            ENDDO
          ENDIF
C-    set mask to one over land:
          DO j=1,sNy
            DO i=1,sNx
              relaxMask(i,j,bi,bj) = MAX( relaxMask(i,j,bi,bj),
     &                               (oneRL - maskC(i,j,1,bi,bj)) )
            ENDDO
          ENDDO
         ENDDO
        ENDDO
      ENDIF
      _EXCH_XY_RL( relaxMask, myThid )

C-    Set relaxation coeff "xgs"
      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
         IF ( cheap_tauRelax .LE. zeroRL ) THEN
           DO j=1-OLy,sNy+OLy
            DO i=1-OLx,sNx+OLx
              xgs(i,j,bi,bj) = 0. _d 0
            ENDDO
           ENDDO
         ELSE
           tmpVar =  oneRL/cheap_tauRelax
           DO j=1-OLy,sNy+OLy
            DO i=1-OLx,sNx+OLx
              xgs(i,j,bi,bj) = relaxMask(i,j,bi,bj)*tmpVar
            ENDDO
           ENDDO
         ENDIF
         IF ( cheap_tauRelaxOce .GT. zeroRL
     &        .AND. cheapMaskFile .EQ. ' ' ) THEN
           tmpVar =  oneRL/cheap_tauRelaxOce
           DO j=1-OLy,sNy+OLy
            DO i=1-OLx,sNx+OLx
              xgs(i,j,bi,bj) = MAX( xgs(i,j,bi,bj), tmpVar )
            ENDDO
           ENDDO
         ENDIF
C-    Calculate implicit relaxation factor "xrelf"
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
            tmpVar = xgs(i,j,bi,bj)*deltaT
            xrelf(i,j,bi,bj)= tmpVar/( oneRL + tmpVar )
          ENDDO
         ENDDO
       ENDDO
      ENDDO
#endif /* CHEAPAML_OLD_MASK_SETTING */

      IF ( debugLevel.GE.debLevB .AND. nIter0.EQ.0 ) THEN
        CALL WRITE_FLD_XY_RL('CheapMask',  ' ', relaxMask, 0, myThid )
      ENDIF
      IF ( debugLevel.GE.debLevC .AND. nIter0.EQ.0 ) THEN
        CALL WRITE_FLD_XY_RL('Cheap_xgs',   ' ', xgs,   0, myThid )
        CALL WRITE_FLD_XY_RL('Cheap_xrelf', ' ', xrelf, 0, myThid )
      ENDIF

      _BEGIN_MASTER( myThid )

C-    Initialise AB starting level
      cheapTairStartAB = nIter0
      cheapQairStartAB = nIter0
      cheapTracStartAB = nIter0

      _END_MASTER( myThid )

C-    Everyone else must wait for parameters to be set
      _BARRIER

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#ifdef ALLOW_MNC
c     IF (useMNC) THEN
c     ENDIF
#endif /* ALLOW_MNC */

#ifdef ALLOW_DIAGNOSTICS
      IF ( useDiagnostics ) THEN
        CALL CHEAPAML_DIAGNOSTICS_INIT( myThid )
      ENDIF
#endif

      RETURN
      END

#include "CTRL_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      SUBROUTINE CTRL_INIT_REC(
     I     fldname,
     I     fldstartdate1, fldstartdate2, fldperiod, nfac,
     O     fldstartdate, diffrec, startrec, endrec,
     I     myThid )

C     ==================================================================
C     SUBROUTINE CTRL_INIT_REC
C     ==================================================================
C
C     helper routine to compute the first and last record of a
C     time dependent control variable
C
C     Martin.Losch@awi.de, 2011-Mar-15
C
C     ==================================================================
C     SUBROUTINE CTRL_INIT_REC
C     ==================================================================

      IMPLICIT NONE

C     == global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#ifdef ALLOW_CAL
# include "cal.h"
#endif

C     == input variables ==
C     fldstartdate1/2 :: start time (date/time) of fld
C     fldperod        :: sampling interval of fld
C     nfac            :: factor for the case that fld is an obcs variable
C                        in this case nfac = 4, otherwise nfac = 1
C     myThid          :: my thread Id number
      CHARACTER*(*) fldname
      INTEGER fldstartdate1
      INTEGER fldstartdate2
      _RL     fldperiod
      INTEGER nfac
      INTEGER myThid

C     == output variables ==
C     fldstartdate :: full date from fldstartdate1 and 2
C     startrec     :: first record of ctrl variable
C     startrec     :: last record of ctrl variable
C     diffrec      :: difference between first and last record of ctrl variable
      INTEGER fldstartdate(4)
      INTEGER startrec
      INTEGER endrec
      INTEGER diffrec

C     == functions ==
      INTEGER  ILNBLNK
      EXTERNAL ILNBLNK

C     == local variables ==
      INTEGER i
#ifdef ALLOW_CAL
      INTEGER difftime(4)
      INTEGER modelBaseDate(4)
      _RL     diffsecs
#endif /* ALLOW_CAL */
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      INTEGER il

      IF ( debugLevel .GE. debLevB ) THEN
       il = ILNBLNK(fldname)
       WRITE( msgBuf,'(A,A)')
     &     'CTRL_INIT_REC: Getting record indices for ',fldname(1:il)
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                     SQUEEZE_RIGHT, myThid )
      ENDIF

C     initialise some output
      DO i = 1,4
       fldstartdate(i) = 0
      ENDDO
      startrec = 0
      endrec   = 0
      diffrec  = 0
      IF ( fldperiod .EQ. -12. ) THEN
       startrec = 1
       endrec   = 12*nfac
      ELSEIF ( fldperiod .EQ. 0. ) THEN
       startrec = 1
       endrec   = 1*nfac
# ifdef ALLOW_CAL
      ELSEIF ( useCAL ) THEN
       CALL cal_FullDate( startdate_1, startdate_2,
     &                        modelBaseDate , myThid )
       CALL cal_FullDate( fldstartdate1, fldstartdate2,
     &                        fldstartdate , myThid )
       CALL cal_TimePassed( modelBaseDate, fldstartdate,
     &                           difftime, myThid )
       CALL cal_ToSeconds ( difftime, diffsecs, myThid )
       startrec = int((modelstart - diffsecs)/fldperiod) + 1
       endrec   = int((modelend   - diffsecs + modelstep/2)
     &                                       /fldperiod) + 2
       IF ( nfac .NE. 1 ) THEN
C     This is the case of obcs.
        startrec = (startrec - 1)*nfac + 1
        endrec   = endrec*nfac
       ENDIF
#endif /* ALLOW_CAL */
      ELSE
       startrec = 1
       endrec   = (int((endTime - startTime)/fldperiod) + 1)*nfac
      ENDIF
      diffrec  = endrec - startrec + 1

      IF ( debugLevel .GE. debLevB ) THEN
       WRITE( msgBuf,'(A,A,A)')
     &      'CTRL_INIT_REC: Record indices for ',fldname(1:il),':'
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                     SQUEEZE_RIGHT, myThid )
       WRITE( msgBuf,'(A,I10,A,I10)')
     &      'CTRL_INIT_REC: startrec = ',startrec,', endrec = ',endrec
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                     SQUEEZE_RIGHT, myThid )
      ENDIF

      RETURN
      END

#include "ECCO_OPTIONS.h"
#include "AD_CONFIG.h"
#ifdef ALLOW_CTRL
# include "CTRL_OPTIONS.h"
#endif

      subroutine ecco_cost_init_barfiles( myThid )

c     ==================================================================
c     SUBROUTINE ecco_cost_init_barfiles
c     ==================================================================
c
c--   Initialise adjoint of monthly mean files calculated
c--   in cost_averagesfields (and their ad...).
c
c     started: heimbach@mit.edu 20-Mar-2002
c
c     ==================================================================
c     SUBROUTINE ecco_cost_cost_init_barfiles
c     ==================================================================

      IMPLICIT NONE

c     == global variables ==

#include "EEPARAMS.h"
#include "SIZE.h"
#include "PARAMS.h"

#ifdef ALLOW_ECCO
# include "ECCO_SIZE.h"
# include "ECCO.h"
#endif
#ifdef ALLOW_CTRL
# include "CTRL_SIZE.h"
# include "CTRL.h"
# include "CTRL_DUMMY.h"
#endif

c     == routine arguments ==

      integer myThid

c     == local variables ==

      integer bi,bj
      integer i,j,k
      integer itlo,ithi
      integer jtlo,jthi
      integer jmin,jmax
      integer imin,imax

      integer ilt, irec

#ifdef ALLOW_GENCOST_CONTRIBUTION
      CHARACTER*(128) fname_gencostbar
      CHARACTER*(128) adfname_gencostbar
#endif /* ALLOW_GENCOST_CONTRIBUTION */

      _RL tmpfld2d (1-OLx:sNx+OLx,1-OLy:sNy+OLy,   nSx,nSy)
      _RL tmpfld3d (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)

c     == external functions ==

      integer  ilnblnk
      external ilnblnk

c     == end of interface ==

      jtlo = myByLo(myThid)
      jthi = myByHi(myThid)
      itlo = myBxLo(myThid)
      ithi = myBxHi(myThid)
      jmin = 1
      jmax = sNy
      imin = 1
      imax = sNx

      do bj = jtlo,jthi
        do bi = itlo,ithi
          do j = jmin,jmax
            do i =  imin,imax
              tmpfld2d(i,j,bi,bj) = 0. _d 0
            enddo
          enddo
        enddo
      enddo
      do bj = jtlo,jthi
        do bi = itlo,ithi
          do k = 1,Nr
            do j = jmin,jmax
              do i =  imin,imax
                tmpfld3d(i,j,k,bi,bj) = 0. _d 0
              enddo
            enddo
          enddo
        enddo
      enddo

#ifdef ALLOW_GENCOST_CONTRIBUTION
c--   Save gencost_barfile on file.
      do k=1,NGENCOST
      if ( .NOT.gencost_barskip(k) ) then
      ilt=ilnblnk( gencost_barfile(k) )
      write(fname_gencostbar,'(2a,i10.10)')
     &     gencost_barfile(k)(1:ilt), '.', eccoiter

#ifdef ALLOW_AUTODIFF
      if ( useAUTODIFF ) then
      write(adfname_gencostbar,'(3a,i10.10)')
     &     yadprefix, gencost_barfile(k)(1:ilt), '.', eccoiter
      do irec = 1,gencost_nrec(k)
#ifdef ALLOW_ADJOINT_RUN
        if (.NOT.gencost_is3d(k))
     &  call active_write_xy( adfname_gencostbar, tmpfld2d, irec,
     &       eccoiter, myThid, gencost_dummy(k) )
        if (gencost_is3d(k))
     &  call active_write_xyz( adfname_gencostbar, tmpfld3d, irec,
     &       eccoiter, myThid, gencost_dummy(k) )
#endif
      enddo
      endif
#endif

      endif
      enddo
#endif /* ALLOW_GENCOST_CONTRIBUTION */

      return
      end

#include "CPP_OPTIONS.h"

CBOP
C     !ROUTINE: CPL_RECV_OCN_FIELDS
C     !INTERFACE:
      SUBROUTINE CPL_RECV_OCN_FIELDS( msgUnit, iter )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE CPL_RECV_OCN_FIELDS
C     | o Routine for receiving surface fields from ocean
C     |   component.
C     *==========================================================*
C     | This version talks to the MITgcm general circulation
C     | model.
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     == Global variables ==
#include "CPL_PARAMS.h"
#include "OCNSIZE.h"
#include "OCNVARS.h"
#include "OCNIDS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     msgUnit   :: log-file I/O unit
C     iter      :: current iteration number
      INTEGER msgUnit, iter

C     !LOCAL VARIABLES:
CEOP

C     Receive Ocean mixed-layer depths from ocean component
      CALL COUPRECV_R8TILES( ocnCompName, ocnMxlDName,
     I                       Nx_ocn, Ny_ocn,
     O                       OcMxlD_ocn )

C     Receive sea surface temperature from ocean component
      CALL COUPRECV_R8TILES( ocnCompName, ocnSSTName,
     I                       Nx_ocn, Ny_ocn,
     O                       SST_ocn )

C     Receive sea surface salinity from ocean component
      CALL COUPRECV_R8TILES( ocnCompName, ocnSSSName,
     I                       Nx_ocn, Ny_ocn,
     O                       SSS_ocn )

C     Receive sea surface velocity square from ocean component
      CALL COUPRECV_R8TILES( ocnCompName, ocnSSVsqName,
     I                       Nx_ocn, Ny_ocn,
     O                       vSq_ocn )

      IF ( MOD(cpl_exchange_DIC,2).EQ.1 ) THEN
C       Receive ocn->atm flux of CO2 from ocean component
        CALL COUPRECV_R8TILES( ocnCompName, ocnCO2FluxName,
     I                         Nx_ocn, Ny_ocn,
     O                         fluxCO2_ocn )
      ENDIF

      IF ( MOD(cpl_exchange2W_sIce,2).EQ.1 ) THEN
C-    Receive seaice fraction from ocean component
        CALL COUPRECV_R8TILES( ocnCompName, ocnSIceFracName,
     I                         Nx_ocn, Ny_ocn,
     O                         sIceFrac_ocn )
C-    Receive seaice thickness from ocean component
        CALL COUPRECV_R8TILES( ocnCompName, ocnSIceThickName,
     I                         Nx_ocn, Ny_ocn,
     O                         sIceThick_ocn )
C-    Receive snow thickness from ocean component
        CALL COUPRECV_R8TILES( ocnCompName, ocnSIceSnowName,
     I                         Nx_ocn, Ny_ocn,
     O                         sIceSnowH_ocn )
C-    Receive seaice enthalpy (layer 1) from ocean component
        CALL COUPRECV_R8TILES( ocnCompName, ocnSIceQ1Name,
     I                         Nx_ocn, Ny_ocn,
     O                         sIceQ1_ocn )
C-    Receive seaice enthalpy (layer 2) from ocean component
        CALL COUPRECV_R8TILES( ocnCompName, ocnSIceQ2Name,
     I                         Nx_ocn, Ny_ocn,
     O                         sIceQ2_ocn )
      ENDIF

      RETURN
      END

#include "CAL_OPTIONS.h"

      subroutine cal_StepsPerDay(
     I                            myiter,
     I                            mytime,
     O                            numsteps,
     I                            mythid
     &                          )

c     ==================================================================
c     SUBROUTINE cal_StepsPerDay
c     ==================================================================
c
c     o Given the iteration number and/or the current time of
c       integration return the number of steps left for the current
c       calendar day including the step belonging to iter/currenttime.
c              
c     started: Christian Eckert eckert@mit.edu  30-Jun-1999
c
c     changed: Christian Eckert eckert@mit.edu  29-Dec-1999
c
c              - restructured the original version in order to have a
c                better interface to the MITgcmUV.
c
c              Christian Eckert eckert@mit.edu  03-Feb-2000
c
c              - Introduced new routine and function names, cal_<NAME>,
c                for verion 0.1.3.
c
c     ==================================================================
c     SUBROUTINE cal_StepsPerDay
c     ==================================================================

      implicit none

c     == global variables ==

#include "cal.h"

c     == routine arguments ==

      integer myiter
      _RL     mytime
      integer numsteps
      integer mythid

c     == local variables ==

      integer currentdate(4)
      integer present
      integer presentsecs
      integer final
      integer finalsecs
      integer ierr
      integer modelstepsperday

c     == end of interface ==

      call cal_GetDate( myiter, mytime, currentdate, mythid )

      present     = currentdate(1)
      presentsecs = (currentdate(2)/10000)*secondsperhour +
     &              mod(currentdate(2)/100,100)*secondsperminute +
     &              mod(currentdate(2),100)
      final       = modelenddate(1)

      if (present .lt. final) then
C       modelstepsperday = cal_nStepDay(mythid)
C-jmc: inline Function "cal_nStepDay":
        modelstepsperday = secondsperday/nint(modelstep)
        numsteps = modelstepsperday -
     &             int(presentsecs/modelstep)
      else if (present .eq. final) then
        finalsecs   = (modelenddate(2)/10000)*secondsperhour +
     &                mod(modelenddate(2)/100,100)*secondsperminute +
     &                mod(modelenddate(2),100)
        numsteps    = int((finalsecs - presentsecs)/modelstep)
      else

        ierr = 1101
        call cal_PrintError( ierr, mythid )
        stop ' stopped in cal_StepsPerDay.'

      endif

      return
      end

#include "PACKAGES_CONFIG.h"
#include "OPENAD_OPTIONS.h"

      subroutine template()
#ifdef ALLOW_OPENAD_DIVA
      use OAD_regular_cp
      use OAD_tape
      use OAD_rev

c we may need these for the checkpointing
      use SIZE_mod
      use EEPARAMS_mod
      use PARAMS_mod
      use BAR2_mod
      use BARRIER_mod
#ifdef ALLOW_CD_CODE
      use CD_CODE_VARS_mod
#endif
      use CG2D_mod
      use CG3D_mod
      use DYNVARS_mod
      use EESUPPORT_mod
      use EOS_mod
      use EXCH_mod
      use FC_NAMEMANGLE_mod
      use FFIELDS_mod
#ifdef ALLOW_GENERIC_ADVDIFF
      use GAD_mod
#endif
      use GLOBAL_MAX_mod
      use GLOBAL_SUM_mod
#ifdef ALLOW_GMREDI
      use GMREDI_mod
#endif
      use GRID_mod
#ifdef ALLOW_MOM_COMMON
      use MOM_VISC_mod
#endif
      use MPI_INFO_mod
#ifdef ALLOW_SHAP_FILT
      use SHAP_FILT_mod
#endif
#ifdef ALLOW_STREAMICE
      use STREAMICE_mod
      use STREAMICE_ADV_mod
      use STREAMICE_BDRY_mod
      use STREAMICE_CG_mod
#endif
      use SURFACE_mod
      use cost_mod
      use g_cost_mod
      use CTRL_mod
      use CTRL_DUMMY_mod
      use OPTIMCYCLE_mod
      use GRDCHK_mod

!$TEMPLATE_PRAGMA_DECLARATIONS
      integer, save :: currcp, curradjointcp
      integer :: cp_loop_variable_1,cp_loop_variable_2,
     +     cp_loop_variable_3,cp_loop_variable_4,cp_loop_variable_5

      double precision, dimension(:), allocatable, save :: theArgFStack
      integer, save :: theArgFStackoffset=0, theArgFStackSize=0
      integer, dimension(:), allocatable, save :: theArgIStack
      integer, save :: theArgIStackoffset=0, theArgIStackSize=0
      type(modeType) :: our_orig_mode
      integer nt

      integer iaddr
      external iaddr
      if (our_rev_mode%arg_store) then
        call cp_write_open()
!$PLACEHOLDER_PRAGMA$ id=8
        call cp_close()
      end if
      if (our_rev_mode%arg_restore) then
        call cp_read_open()
!$PLACEHOLDER_PRAGMA$ id=9
        call cp_close()
      end if
      if (our_rev_mode%plain) then
        do nt=1,nTimeSteps_l2
          CALL OpenAD_inner_do_loop(nt, MYTIME, MYITER, MYTHID)
        enddo
      end if
      if (our_rev_mode%tape) then
        print *, 'DIVA Running Regular Plain nTimeSteps_l2 ', nTimeSteps
     +_l2
        currcp = 0
        do nt=1,nTimeSteps_l2
          print *, 'DIVA Checkpointing currcp  and running plain', currc
     +p
            call cp_write_open(currcp)
!$PLACEHOLDER_PRAGMA$ id=8
            call cp_close
            currcp=currcp+1
          call OAD_revPlain
          CALL OpenAD_inner_do_loop(nt, MYTIME, MYITER, MYTHID)
          call OAD_revTape
        end do
        currcp = currcp -1
      end if
      if (our_rev_mode%adjoint) then
        curradjointcp = currcp
        print *, 'DIVA Reading plain checkpoint currcp ', currcp
        call cp_read_open(currcp)
!$PLACEHOLDER_PRAGMA$ id=9
        call cp_close
        call OAD_revTape
        print *, 'DIVA Running First Tape'
        CALL OpenAD_inner_do_loop(nTimeSteps_l2, MYTIME, MYITER, MYTHID)
        print *, 'DIVA Running First Adjoint '
        call OAD_revAdjoint
        CALL OpenAD_inner_do_loop(nTimeSteps_l2, MYTIME, MYITER, MYTHID)
        print *, 'DIVA Writing adjoint checkpoint curradjointcp ', curra
     +djointcp
        call cp_write_open(curradjointcp)
!$PLACEHOLDER_PRAGMA$ id=12
        call cp_close
        do nt=nTimeSteps_l2-1,1,-1
          currcp = currcp -1
          print *, 'DIVA Running TA pairs'
          print *, 'DIVA Reading plain checkpoint currcp ', currcp
          call cp_read_open(currcp)
!$PLACEHOLDER_PRAGMA$ id=9
          call cp_close
          call OAD_revTape
          print *, 'DIVA Running Tape'
          CALL OpenAD_inner_do_loop(nt, MYTIME, MYITER, MYTHID)
          print *, 'DIVA Reading adjoint checkpoint curradjointcp ', cur
     +radjointcp
          call cp_read_open(curradjointcp)
!$PLACEHOLDER_PRAGMA$ id=13
          call cp_close
          print *, 'DIVA Running adjoint '
          call OAD_revAdjoint
          CALL OpenAD_inner_do_loop(nt, MYTIME, MYITER, MYTHID)
          print *, 'DIVA Writing adjoint checkpoint curradjointcp ', cur
     +radjointcp-1
         call cp_write_open(curradjointcp-1)
!$PLACEHOLDER_PRAGMA$ id=12
          curradjointcp = curradjointcp-1
          call cp_close
        end do
      end if
#endif
      end subroutine template

#include "CPP_OPTIONS.h"

C--  File mds_byteswap.F: Routines to do IO byte swapping
C--   Contents
C--   o MDS_BYTESWAPR4
C--   o MDS_BYTESWAPR8

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      SUBROUTINE MDS_BYTESWAPR4( n, arr )
C IN:
C   n          integer :: Number of 4-byte words in arr
C IN/OUT:
C   arr        real*4  :: Array declared as real*4(n)
C
C Created: 05/05/99 adcroft@mit.edu (This is an unfortunate hack!!)

      IMPLICIT NONE
C Arguments
      INTEGER n
      CHARACTER*(*) arr

#ifdef _BYTESWAPIO

C Local
      integer i
      character*(1) cc
C     ------------------------------------------------------------------
      do i=1,4*n,4
       cc=arr(i:i)
       arr(i:i)=arr(i+3:i+3)
       arr(i+3:i+3)=cc
       cc=arr(i+1:i+1)
       arr(i+1:i+1)=arr(i+2:i+2)
       arr(i+2:i+2)=cc
      enddo
C     ------------------------------------------------------------------
#endif /* _BYTESWAPIO */
      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      SUBROUTINE MDS_BYTESWAPR8( n, arr )
C IN:
C   n          integer :: Number of 8-byte words in arr
C IN/OUT:
C   arr        real*8  :: Array declared as real*8(n)
C
C Created: 05/05/99 adcroft@mit.edu (This is an unfortunate hack!!)

      IMPLICIT NONE
C Arguments
      INTEGER n
      CHARACTER*(*) arr

#ifdef _BYTESWAPIO

C Local
      integer i
      character*(1) cc
C     ------------------------------------------------------------------
      do i=1,8*n,8
       cc=arr(i:i)
       arr(i:i)=arr(i+7:i+7)
       arr(i+7:i+7)=cc
       cc=arr(i+1:i+1)
       arr(i+1:i+1)=arr(i+6:i+6)
       arr(i+6:i+6)=cc
       cc=arr(i+2:i+2)
       arr(i+2:i+2)=arr(i+5:i+5)
       arr(i+5:i+5)=cc
       cc=arr(i+3:i+3)
       arr(i+3:i+3)=arr(i+4:i+4)
       arr(i+4:i+4)=cc
      enddo
C     ------------------------------------------------------------------
#endif /* _BYTESWAPIO */
      RETURN
      END

#include "SEAICE_OPTIONS.h"
#ifdef ALLOW_OBCS
#include "OBCS_OPTIONS.h"
#endif

CBOP
C     !ROUTINE: SEAICE_OBCS_OUTPUT

C     !INTERFACE:
      SUBROUTINE SEAICE_OBCS_OUTPUT( myTime, myIter, myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE SEAICE_OBCS_OUTPUT
C     | o General routine for SEAICE Open-Boundary output
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     == Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#ifdef ALLOW_OBCS
# include "OBCS_PARAMS.h"
# include "OBCS_SEAICE.h"
#endif

C     !INPUT PARAMETERS:
C     myTime :: my time in simulation ( s )
C     myIter :: my Iteration number
C     myThid :: my Thread Id number
      _RL     myTime
      INTEGER myIter
      INTEGER myThid
CEOP

#ifdef ALLOW_SEAICE
#ifdef ALLOW_OBCS
C     !FUNCTIONS:
      LOGICAL  DIFFERENT_MULTIPLE
      EXTERNAL DIFFERENT_MULTIPLE
c     INTEGER  ILNBLNK
c     EXTERNAL ILNBLNK

C     !LOCAL VARIABLES:
      CHARACTER*(10) suff
      CHARACTER*(MAX_LEN_FNAM) fn
      INTEGER prec

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C--   Write OB aray to binary files (mainly for debugging => use "diagFreq")
      IF (
     &     DIFFERENT_MULTIPLE(diagFreq,myTime,deltaTClock)
     &   ) THEN

       _BARRIER
        prec = writeBinaryPrec
c       IF ( rwSuffixType.EQ.0 ) THEN
          WRITE(suff,'(I10.10)') myIter
c       ELSE
c         CALL RW_GET_SUFFIX( suff, myTime, myIter, myThid )
c       ENDIF

C     Write Sea-Ice OB arrays
# ifdef ALLOW_OBCS_NORTH
        WRITE(fn,'(2A)') 'seaice_ob_N.', suff
        CALL WRITE_REC_XZ_RL(fn,prec, 1,OBNa,    1,myIter,myThid)
        CALL WRITE_REC_XZ_RL(fn,prec, 1,OBNh,    2,myIter,myThid)
        CALL WRITE_REC_XZ_RL(fn,prec, 1,OBNsl,   3,myIter,myThid)
        CALL WRITE_REC_XZ_RL(fn,prec, 1,OBNsn,   4,myIter,myThid)
        CALL WRITE_REC_XZ_RL(fn,prec, 1,OBNuice, 5,myIter,myThid)
        CALL WRITE_REC_XZ_RL(fn,prec, 1,OBNvice, 6,myIter,myThid)
# endif
# ifdef ALLOW_OBCS_SOUTH
        WRITE(fn,'(2A)') 'seaice_ob_S.', suff
        CALL WRITE_REC_XZ_RL(fn,prec, 1,OBSa,    1,myIter,myThid)
        CALL WRITE_REC_XZ_RL(fn,prec, 1,OBSh,    2,myIter,myThid)
        CALL WRITE_REC_XZ_RL(fn,prec, 1,OBSsl,   3,myIter,myThid)
        CALL WRITE_REC_XZ_RL(fn,prec, 1,OBSsn,   4,myIter,myThid)
        CALL WRITE_REC_XZ_RL(fn,prec, 1,OBSuice, 5,myIter,myThid)
        CALL WRITE_REC_XZ_RL(fn,prec, 1,OBSvice, 6,myIter,myThid)
# endif
# ifdef ALLOW_OBCS_EAST
        WRITE(fn,'(2A)') 'seaice_ob_E.', suff
        CALL WRITE_REC_YZ_RL(fn,prec, 1,OBEa,    1,myIter,myThid)
        CALL WRITE_REC_YZ_RL(fn,prec, 1,OBEh,    2,myIter,myThid)
        CALL WRITE_REC_YZ_RL(fn,prec, 1,OBEsl,   3,myIter,myThid)
        CALL WRITE_REC_YZ_RL(fn,prec, 1,OBEsn,   4,myIter,myThid)
        CALL WRITE_REC_YZ_RL(fn,prec, 1,OBEuice, 5,myIter,myThid)
        CALL WRITE_REC_YZ_RL(fn,prec, 1,OBEvice, 6,myIter,myThid)
# endif
# ifdef ALLOW_OBCS_WEST
        WRITE(fn,'(2A)') 'seaice_ob_W.', suff
        CALL WRITE_REC_YZ_RL(fn,prec, 1,OBWa,    1,myIter,myThid)
        CALL WRITE_REC_YZ_RL(fn,prec, 1,OBWh,    2,myIter,myThid)
        CALL WRITE_REC_YZ_RL(fn,prec, 1,OBWsl,   3,myIter,myThid)
        CALL WRITE_REC_YZ_RL(fn,prec, 1,OBWsn,   4,myIter,myThid)
        CALL WRITE_REC_YZ_RL(fn,prec, 1,OBWuice, 5,myIter,myThid)
        CALL WRITE_REC_YZ_RL(fn,prec, 1,OBWvice, 6,myIter,myThid)
# endif

       _BARRIER

      ENDIF

#endif /* ALLOW_OBCS */
#endif /* ALLOW_SEAICE */

      RETURN
      END

#include "STREAMICE_OPTIONS.h"
#ifdef ALLOW_AUTODIFF
# include "AUTODIFF_OPTIONS.h"
#endif

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

CBOP
      SUBROUTINE STREAMICE_VISC_BETA_HYBRID ( myThid )

C     /============================================================\
C     | SUBROUTINE                                                 |
C     | o                                                          |
C     |============================================================|
C     |                                                            |
C     \============================================================/
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "GRID.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "STREAMICE.h"
#include "STREAMICE_CG.h"
#ifdef ALLOW_AUTODIFF_TAMC
# include "tamc.h"
#endif

C     !INPUT/OUTPUT ARGUMENTS
      INTEGER myThid
c       _RL taudx (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
c       _RL taudx (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)

#ifdef ALLOW_STREAMICE
#ifdef STREAMICE_HYBRID_STRESS

C     LOCAL VARIABLES
      INTEGER i, j, bi, bj, k, l, m
      _RL ux, uy, vx, vy, exx, eyy, exy, unorm, second_inv
      _RL ub, vb, fb, mean_u_shear, mean_v_shear, umid, vmid
      _RL omega_temp (Nr+1), u_shear(Nr+1), v_shear(Nr+1)
      _RL C_fric_val, Bglen_val
#ifdef STREAMICE_FLOWLINE_BUTTRESS
      _RL buttr_param, pwr
#endif
#ifdef STREAMICE_COULOMB_SLIDING
      _RL effective_stress, hf
      _RL ETA_GL_STREAMICE
      _RL i_nbasalfric
      EXTERNAL ETA_GL_STREAMICE
#endif
#ifdef ALLOW_AUTODIFF_TAMC
      INTEGER ikey_1
#endif
      _RL STREAMICE_BSTRESS_EXP
c       _RL total_vol_out
      EXTERNAL STREAMICE_BSTRESS_EXP

#ifdef STREAMICE_FLOWLINE_BUTTRESS
      buttr_param = 5**(1./3.) / (streamice_buttr_width/2.)**(4./3.)
      pwr = 1./n_glen
#endif

#ifdef STREAMICE_COULOMB_SLIDING
      i_nbasalfric = 1. / n_basal_friction
#endif

      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        DO j=1,sNy
         DO i=1,sNx
          IF (STREAMICE_hmask(i,j,bi,bj).eq.1) THEN

           umid = 0
           vmid = 0

           DO k=0,1
            DO l=0,1
             umid = umid + 0.25 *
     &        dxG(i,j+l,bi,bj)*dyG(i+k,j,bi,bj) *
     &        recip_rA(i,j,bi,bj) *
     &        U_streamice(i+k,j+l,bi,bj)
             vmid = vmid + 0.25 *
     &        dxG(i,j+l,bi,bj)*dyG(i+k,j,bi,bj) *
     &        recip_rA(i,j,bi,bj) *
     &        V_streamice(i+k,j+l,bi,bj)
            ENDDO
           ENDDO

           ux = (U_streamice(i+1,j+1,bi,bj) +
     &           U_streamice(i+1,j,bi,bj)   -
     &           U_streamice(i,j+1,bi,bj)   -
     &           U_streamice(i,j,bi,bj)) /
     &           (2. * dxF(i,j,bi,bj))
           vx = (V_streamice(i+1,j+1,bi,bj) +
     &           V_streamice(i+1,j,bi,bj)   -
     &           V_streamice(i,j+1,bi,bj)   -
     &           V_streamice(i,j,bi,bj)) /
     &           (2. * dxF(i,j,bi,bj))
           uy = (U_streamice(i+1,j+1,bi,bj) -
     &           U_streamice(i+1,j,bi,bj)   +
     &           U_streamice(i,j+1,bi,bj)   -
     &           U_streamice(i,j,bi,bj)) /
     &           (2. * dyF(i,j,bi,bj))
           vy = (V_streamice(i+1,j+1,bi,bj) -
     &           V_streamice(i+1,j,bi,bj)   +
     &           V_streamice(i,j+1,bi,bj)   -
     &           V_streamice(i,j,bi,bj)) /
     &           (2. * dyF(i,j,bi,bj))

           exx = ux + k1AtC_str(i,j,bi,bj)*vmid
           eyy = vy + k2AtC_str(i,j,bi,bj)*umid
           exy = .5*(uy+vx) +
     &      k1AtC_str(i,j,bi,bj)*umid + k2AtC_str(i,j,bi,bj)*vmid

           visc_streamice (i,j,bi,bj) = 0.0
           streamice_omega(i,j,bi,bj) = 0.0
           omega_temp (Nr+1) = 0.0
           u_shear(Nr+1) = 0.0
           v_shear(Nr+1) = 0.0

           DO m=Nr,1,-1

#ifdef ALLOW_AUTODIFF_TAMC
            ikey_1 = bi + (bj-1)*nSx + (ikey_dynamics-1)*nSx*nSy
            ikey_1 = m + ((i-1) + (j-1)*sNx + (ikey_1-1)*sNx*sNy)*Nr
CADJ STORE visc_streamice_full(i,j,m,bi,bj)
CADJ &     = comlev1_stream_hybrid, key=ikey_1
#endif

            streamice_vert_shear_uz (m) = streamice_taubx(i,j,bi,bj) /
     &       visc_streamice_full(i,j,m,bi,bj)
     &       * streamice_sigma_coord(m)

            streamice_vert_shear_vz (m) = streamice_tauby(i,j,bi,bj) /
     &       visc_streamice_full(i,j,m,bi,bj)
     &       * streamice_sigma_coord(m)

            second_inv =
     &       sqrt(exx**2+eyy**2+exx*eyy+exy**2+eps_glen_min**2+
     &            0.25 * streamice_vert_shear_uz(m)**2 +
     &            0.25 * streamice_vert_shear_vz(m)**2)

#ifdef STREAMICE_3D_GLEN_CONST
            IF (.not.STREAMICE_use_log_ctrl) THEN
             Bglen_val = (B_glen(i,j,m,bi,bj))**2
            ELSE
             Bglen_val = exp(B_glen(i,j,m,bi,bj))
            ENDIF
#else
            IF (.not.STREAMICE_use_log_ctrl) THEN
             Bglen_val = (B_glen(i,j,bi,bj))**2
            ELSE
             Bglen_val = exp(B_glen(i,j,bi,bj))
            ENDIF
#endif

#ifdef ALLOW_STREAMICE_FP_ADJ
            visc_full_new_si(i,j,m,bi,bj) =
#else
            visc_streamice_full(i,j,m,bi,bj) =
#endif
     &       .5 * Bglen_val *
     &        second_inv**((1-n_glen)/n_glen)

            visc_streamice (i,j,bi,bj) = visc_streamice (i,j,bi,bj) +
     &       H_streamice(i,j,bi,bj) * streamice_delsigma (m) *
#ifdef ALLOW_STREAMICE_FP_ADJ
     &       visc_full_new_si(i,j,m,bi,bj)
#else
     &       visc_streamice_full(i,j,m,bi,bj)
#endif

            omega_temp (m) = omega_temp(m+1) +
     &       streamice_sigma_coord(m) * streamice_delsigma(m) /
#ifdef ALLOW_STREAMICE_FP_ADJ
     &       visc_full_new_si(i,j,m,bi,bj)
#else
     &       visc_streamice_full(i,j,m,bi,bj)
#endif

            u_shear (m) = u_shear (m+1) +
     &       streamice_vert_shear_uz (m) * streamice_delsigma (m) *
     &       H_streamice(i,j,bi,bj)

            v_shear (m) = v_shear (m+1) +
     &       streamice_vert_shear_vz (m) * streamice_delsigma (m) *
     &       H_streamice(i,j,bi,bj)

           ENDDO

           mean_u_shear = 0.0
           mean_v_shear = 0.0

           DO m=Nr,1,-1

            streamice_omega(i,j,bi,bj) = streamice_omega(i,j,bi,bj) +
     &       streamice_delsigma(m)*(omega_temp(m)+omega_temp(m+1))*.5
     &       * H_streamice(i,j,bi,bj)**2

            mean_u_shear = mean_u_shear +
     &       streamice_delsigma(m)*(u_shear(m)+u_shear(m+1))*.5

            mean_v_shear = mean_v_shear +
     &       streamice_delsigma(m)*(v_shear(m)+v_shear(m+1))*.5

           ENDDO

           streamice_u_surf(i,j,bi,bj) =
     &      u_shear(1) + umid - mean_u_shear

           streamice_v_surf(i,j,bi,bj) =
     &      v_shear(1) + vmid - mean_v_shear

           ub = umid - streamice_taubx(i,j,bi,bj) *
     &      streamice_omega(i,j,bi,bj) / H_streamice(i,j,bi,bj)

           streamice_u_bed (i,j,bi,bj) = ub

           vb = vmid - streamice_tauby(i,j,bi,bj) *
     &      streamice_omega(i,j,bi,bj) / H_streamice(i,j,bi,bj)

           streamice_v_bed (i,j,bi,bj) = vb

           unorm = sqrt(ub**2+vb**2+eps_u_min**2)

           if (.not.STREAMICE_use_log_ctrl) THEN
            C_fric_val =
     &      (C_basal_friction(i,j,bi,bj))**2
           else
            C_fric_val =
     &      exp(C_basal_friction(i,j,bi,bj))
           endif

#ifdef STREAMICE_COULOMB_SLIDING
           IF (.not.streamice_allow_reg_coulomb) THEN
#endif
           fb = C_fric_val *
     &      STREAMICE_BSTRESS_EXP (unorm,n_basal_friction) *
     &      streamice_basal_geom(i,j,bi,bj) *
     &      float_frac_streamice(i,j,bi,bj)

#ifdef STREAMICE_COULOMB_SLIDING
           ELSE

           hf = max (0.0, -1.0 *streamice_density_ocean_avg
     &        / streamice_density * R_low_si(i,j,bi,bj))

           effective_stress = streamice_density * gravity *
     &      (H_streamice(i,j,bi,bj)-hf)
           effective_stress= max(0.0, effective_stress)
           fb = C_fric_val *
     &      unorm ** n_basal_friction *
     &      .5 * effective_stress /
     &      (C_fric_val**(i_nbasalfric)*unorm+
     &       (0.5 * effective_stress) ** (i_nbasalfric)) **
     &        n_basal_friction *
     &      streamice_basal_geom(i,j,bi,bj) *
     &      float_frac_streamice(i,j,bi,bj) / unorm
           ENDIF

#endif

           tau_beta_eff_streamice(i,j,bi,bj) =
     &       fb /
     &       (1+fb*streamice_omega(i,j,bi,bj)/H_streamice(i,j,bi,bj))
#ifdef STREAMICE_FLOWLINE_BUTTRESS
           if (usestreamiceflowlineButtr) then
           tau_beta_eff_streamice(i,j,bi,bj) =
     &      tau_beta_eff_streamice(i,j,bi,bj) +
     &      buttr_param*B_glen(i,j,bi,bj)**2 *
     &      STREAMICE_BSTRESS_EXP (unorm,pwr)*
     &      H_streamice(i,j,bi,bj)
          endif
#endif

          ENDIF
         ENDDO
        ENDDO
       ENDDO
      ENDDO
#ifdef ALLOW_OPENAD
#ifdef STREAMICE_HYBRID_STRESS
      tau_beta_eff_streamice(1,1,1,1) =
     &  tau_beta_eff_streamice(1,1,1,1) +
     &  0. * streamice_u_surf(1,1,1,1) +
     &  0. * streamice_v_surf(1,1,1,1)
#endif
#endif

#endif
#endif
      RETURN
      END

#include "PACKAGES_CONFIG.h"
#include "CPP_OPTIONS.h"

CBOP
C     !ROUTINE: PRE_CG3D
C     !INTERFACE:
      SUBROUTINE PRE_CG3D(
     I                     oldFreeSurfTerm,
     I                     cg2d_x,
     U                     cg3d_b,
     I                     myTime, myIter, myThid )

C     !DESCRIPTION:
C     Called from SOLVE_FOR_PRESSURE, before 3-D solver (cg3d):
C     Finish calculation of 3-D RHS after 2-D inversionis done.

C     !USES:
      IMPLICIT NONE
C     == Global variables
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "SURFACE.h"
#include "FFIELDS.h"
#include "DYNVARS.h"
#ifdef ALLOW_NONHYDROSTATIC
#include "NH_VARS.h"
#endif

C     === Functions ====
c     LOGICAL  DIFFERENT_MULTIPLE
c     EXTERNAL DIFFERENT_MULTIPLE

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     oldFreeSurfTerm :: Treat free-surface term in the old way (no exactConserv)
C     cg2d_x          :: Solution vector of the 2-D solver equation a.x=b
C     cg3d_b          :: Right Hand side vector of the 3-D solver equation A.X=B
C     myTime          :: Current time in simulation
C     myIter          :: Current iteration number in simulation
C     myThid          :: My Thread Id number
      LOGICAL oldFreeSurfTerm
      _RL     cg2d_x(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL     cg3d_b(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      _RL     myTime
      INTEGER myIter
      INTEGER myThid

#ifdef ALLOW_NONHYDROSTATIC
C     !LOCAL VARIABLES:
C     == Local variables ==
C     wSurfP2d :: surface vertical velocity after 2-D solver
      INTEGER i,j,k,bi,bj
      INTEGER ks, kp1
c     CHARACTER*10 sufx
c     CHARACTER*(MAX_LEN_MBUF) msgBuf
      _RL     locGamma, surfFac, tmpFac
      _RL     wFacKm, wFacKp
      _RL     uf(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL     vf(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL     wSurfP2d(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
CEOP

c     IF ( use3Dsolver ) THEN

C--   Solve for a three-dimensional pressure term (NH or IGW or both ).
C     see CG3D.h for the interface to this routine.
       DO bj=myByLo(myThid),myByHi(myThid)
        DO bi=myBxLo(myThid),myBxHi(myThid)

C--   Calculate updated (after 2-D solver) vertical velocity at the surface
         IF ( oldFreeSurfTerm .OR. implicDiv2DFlow.EQ.zeroRL ) THEN
           DO j=1-OLy,sNy+OLy
            DO i=1-OLx,sNx+OLx
              wSurfP2d(i,j) = 0. _d 0
            ENDDO
           ENDDO
         ELSE
           DO j=1-OLy,sNy+OLy
            DO i=1-OLx,sNx+OLx
               wSurfP2d(i,j) = ( etaN(i,j,bi,bj)-etaH(i,j,bi,bj) )
     &                       / ( implicDiv2DFlow*deltaTFreeSurf )
            ENDDO
           ENDDO
         ENDIF

C--   Add EmPmR contribution to top level cg3d_b or to wSurfP2d:
C      (has been done for cg2d_b ; and addMass was added by CALC_DIV_GHAT)
         IF ( useRealFreshWaterFlux.AND.fluidIsWater ) THEN
          IF ( oldFreeSurfTerm .OR. usingPCoords ) THEN
           tmpFac = freeSurfFac*mass2rUnit*implicDiv2DFlow/deltaTMom
           ks = 1
           IF ( usingPCoords ) ks = Nr
           DO j=1,sNy
            DO i=1,sNx
              cg3d_b(i,j,ks,bi,bj) = cg3d_b(i,j,ks,bi,bj)
     &          + tmpFac*_rA(i,j,bi,bj)*EmPmR(i,j,bi,bj)
     &                                 *maskInC(i,j,bi,bj)
            ENDDO
           ENDDO
          ELSE
           DO j=1-OLy,sNy+OLy
            DO i=1-OLx,sNx+OLx
              wSurfP2d(i,j) = wSurfP2d(i,j)
     &                      + EmPmR(i,j,bi,bj)*mass2rUnit
     &                                 *maskInC(i,j,bi,bj)
            ENDDO
           ENDDO
          ENDIF
         ENDIF

C--   Update or Add free-surface contribution to cg3d_b:
         surfFac = 0.
         IF ( selectNHfreeSurf.GE.1 ) THEN
           tmpFac = freeSurfFac*implicDiv2DFlow/deltaTMom
           DO j=1,sNy
            DO i=1,sNx
              locGamma = drC(1)*recip_Bo(i,j,bi,bj)
     &                 /( deltaTMom*deltaTFreeSurf
     &                   *implicitNHPress*implicDiv2DFlow )
              ks = 1
c             ks = kSurfC(i,j,bi,bj)
c             IF ( ks.LE.Nr ) THEN
               cg3d_b(i,j,ks,bi,bj) = cg3d_b(i,j,ks,bi,bj)
     &                      + tmpFac*( wSurfP2d(i,j)
     &                               + locGamma*wVel(i,j,ks,bi,bj) )
     &                              /( 1. _d 0 + locGamma )
     &                              *_rA(i,j,bi,bj)*deepFac2F(ks)
c             ENDIF
C-    Save wSurfP2d (used in POST_CG3D) into dPhiNH :
              dPhiNH(i,j,bi,bj) = wSurfP2d(i,j)
            ENDDO
           ENDDO
         ELSEIF ( .NOT.oldFreeSurfTerm ) THEN
           tmpFac = freeSurfFac*implicDiv2DFlow/deltaTMom
           DO j=1,sNy
            DO i=1,sNx
              ks = kSurfC(i,j,bi,bj)
              IF ( ks.LE.Nr ) THEN
               cg3d_b(i,j,ks,bi,bj) = cg3d_b(i,j,ks,bi,bj)
     &                      + tmpFac*wSurfP2d(i,j)
     &                              *_rA(i,j,bi,bj)*deepFac2F(ks)
              ENDIF
            ENDDO
           ENDDO
         ELSEIF ( uniformFreeSurfLev ) THEN
C-       Z coordinate: assume surface @ level k=1
           surfFac = freeSurfFac*deepFac2F(1)
         ELSE
C-       Other than Z coordinate: no assumption on surface level index
           DO j=1,sNy
            DO i=1,sNx
              ks = kSurfC(i,j,bi,bj)
              IF ( ks.LE.Nr ) THEN
               cg3d_b(i,j,ks,bi,bj) = cg3d_b(i,j,ks,bi,bj)
     &              +freeSurfFac*etaN(i,j,bi,bj)/deltaTFreeSurf
     &                  *_rA(i,j,bi,bj)*deepFac2F(ks)/deltaTMom
              ENDIF
            ENDDO
           ENDDO
         ENDIF

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C--   Finish updating cg3d_b: 1) increment in horiz velocity due to new cg2d_x
C                             2) add vertical velocity contribution.
         DO j=1,sNy+1
          DO i=1,sNx+1
           uf(i,j) = -_recip_dxC(i,j,bi,bj)
     &             * implicSurfPress*implicDiv2DFlow
     &             *(cg2d_x(i,j,bi,bj)-cg2d_x(i-1,j,bi,bj))
#ifdef ALLOW_OBCS
     &             *maskInC(i,j,bi,bj)*maskInC(i-1,j,bi,bj)
#endif
           vf(i,j) = -_recip_dyC(i,j,bi,bj)
     &             * implicSurfPress*implicDiv2DFlow
     &             *(cg2d_x(i,j,bi,bj)-cg2d_x(i,j-1,bi,bj))
#ifdef ALLOW_OBCS
     &             *maskInC(i,j,bi,bj)*maskInC(i,j-1,bi,bj)
#endif
          ENDDO
         ENDDO

C Note: with implicDiv2DFlow < 1, wVel contribution to cg3d_b is similar to
C       uVel,vVel contribution to cg2d_b when exactConserv=T, since wVel is
C       always recomputed from continuity eq (like eta when exactConserv=T)
         k=1
         kp1 = MIN(k+1,Nr)
         wFacKp = implicDiv2DFlow*deepFac2F(kp1)*rhoFacF(kp1)
         IF (k.GE.Nr) wFacKp = 0.
         DO j=1,sNy
          DO i=1,sNx
            cg3d_b(i,j,k,bi,bj) = cg3d_b(i,j,k,bi,bj)
     &       +drF(k)*dyG(i+1,j,bi,bj)*_hFacW(i+1,j,k,bi,bj)*uf(i+1,j)
     &       -drF(k)*dyG( i ,j,bi,bj)*_hFacW( i ,j,k,bi,bj)*uf( i ,j)
     &       +drF(k)*dxG(i,j+1,bi,bj)*_hFacS(i,j+1,k,bi,bj)*vf(i,j+1)
     &       -drF(k)*dxG(i, j ,bi,bj)*_hFacS(i, j ,k,bi,bj)*vf(i, j )
     &       +( surfFac*etaN(i,j,bi,bj)/deltaTFreeSurf
     &         -wVel(i,j,kp1,bi,bj)*wFacKp
     &        )*_rA(i,j,bi,bj)/deltaTMom
          ENDDO
         ENDDO
         DO k=2,Nr
          kp1 = MIN(k+1,Nr)
C-       deepFac & rhoFac cancel with the ones in uf[=del_i(Phi)/dx],vf ;
C        both appear in wVel term, but at 2 different levels
          wFacKm = implicDiv2DFlow*deepFac2F( k )*rhoFacF( k )
          wFacKp = implicDiv2DFlow*deepFac2F(kp1)*rhoFacF(kp1)
          IF (k.GE.Nr) wFacKp = 0.
          DO j=1,sNy
           DO i=1,sNx
            cg3d_b(i,j,k,bi,bj) = cg3d_b(i,j,k,bi,bj)
     &       +drF(k)*dyG(i+1,j,bi,bj)*_hFacW(i+1,j,k,bi,bj)*uf(i+1,j)
     &       -drF(k)*dyG( i ,j,bi,bj)*_hFacW( i ,j,k,bi,bj)*uf( i ,j)
     &       +drF(k)*dxG(i,j+1,bi,bj)*_hFacS(i,j+1,k,bi,bj)*vf(i,j+1)
     &       -drF(k)*dxG(i, j ,bi,bj)*_hFacS(i, j ,k,bi,bj)*vf(i, j )
     &       +( wVel(i,j, k ,bi,bj)*wFacKm*maskC(i,j,k-1,bi,bj)
     &         -wVel(i,j,kp1,bi,bj)*wFacKp
     &        )*_rA(i,j,bi,bj)/deltaTMom
           ENDDO
          ENDDO
         ENDDO

#ifdef ALLOW_OBCS
C- Note: solver matrix is trivial outside OB region (main diagonal only)
C     => no real need to reset RHS (=cg3d_b) & cg3d_x, except that:
C    a) normalisation is fct of Max(RHS), which can be large ouside OB region
C      (would be different if we were solving for increment of phi_nh
C       instead of directly for phi_nh).
C       => need to reset RHS to ensure that interior solution does not depend
C       on ouside OB region.
C    b) provide directly the trivial solution cg3d_x == 0 for outside OB region
C      (=> no residual => no effect on solver convergence and interior solution)
         IF (useOBCS) THEN
          DO k=1,Nr
           DO j=1,sNy
            DO i=1,sNx
              cg3d_b(i,j,k,bi,bj) = cg3d_b(i,j,k,bi,bj)
     &                            *maskInC(i,j,bi,bj)
              phi_nh(i,j,k,bi,bj) = phi_nh(i,j,k,bi,bj)
     &                            *maskInC(i,j,bi,bj)
            ENDDO
           ENDDO
          ENDDO
         ENDIF
#endif /* ALLOW_OBCS */

C-    end bi,bj loops
        ENDDO
       ENDDO

c     ENDIF
#endif /* ALLOW_NONHYDROSTATIC */

      RETURN
      END

#include "THSICE_OPTIONS.h"

CBOP
C     !ROUTINE: THSICE_ALBEDO
C     !INTERFACE:
      SUBROUTINE THSICE_ALBEDO(
     I                  bi, bj, siLo, siHi, sjLo, sjHi,
     I                  iMin,iMax, jMin,jMax,
     I                  iceMask, hIce, hSnow, tSrf, ageSnw,
     O                  sAlb, sAlbNIR,
     I                  myTime, myIter, myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R THSICE_ALBEDO
C     *==========================================================*
C     | Compute surface albedo over sea-ice
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     == Global data ==
#include "EEPARAMS.h"
#include "THSICE_PARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine Arguments ==
C     siLo,siHi   :: size of input/output array: 1rst dim. lower,higher bounds
C     sjLo,sjHi   :: size of input/output array: 2nd  dim. lower,higher bounds
C     bi,bj       :: tile indices
C     iMin,iMax   :: computation domain: 1rst index range
C     jMin,jMax   :: computation domain: 2nd  index range
C---  Input:
C         iceMask :: sea-ice fractional mask [0-1]
C  hIce    (hi)   :: ice height [m]
C  hSnow   (hs)   :: snow height [m]
C  tSrf    (Tsf)  :: surface (ice or snow) temperature [oC]
C  ageSnw  (age)  :: snow age [s]
C---  Output
C  sAlb  (albedo) :: surface albedo [0-1]
C  sAlbNIR(albedo):: near IR surface albedo [0-1]
C---  Input:
C     myTime      :: current Time of simulation [s]
C     myIter      :: current Iteration number in simulation
C     myThid      :: my Thread Id number
      INTEGER siLo, siHi, sjLo, sjHi
      INTEGER bi,bj
      INTEGER iMin, iMax
      INTEGER jMin, jMax
      _RL iceMask(siLo:siHi,sjLo:sjHi)
      _RL hIce   (siLo:siHi,sjLo:sjHi)
      _RL hSnow  (siLo:siHi,sjLo:sjHi)
      _RL tSrf   (siLo:siHi,sjLo:sjHi)
      _RL ageSnw (siLo:siHi,sjLo:sjHi)
      _RL sAlb   (siLo:siHi,sjLo:sjHi)
      _RL sAlbNIR(siLo:siHi,sjLo:sjHi)
      _RL  myTime
      INTEGER myIter
      INTEGER myThid
CEOP

#ifdef ALLOW_THSICE
C     !LOCAL VARIABLES:
C---  local copy of input/output argument list variables (see description above)
      _RL  hi                  ! ice height
      _RL  hs                  ! snow height
      _RL  Tsf                 ! surface temperature
      _RL  age                 ! snow age
      _RL  albedo              ! surface albedo
C     == Local variables ==
C     frsnow     :: fractional snow cover
C     albsno     :: albedo of snow
C     albice     :: albedo of ice
C     albNewSnow :: albedo of new (fresh) snow
C     albNewSnow :: albedo of new (fresh) snow
C     msgBuf     :: Informational/error message buffer
c     _RL  frsnow
      _RL albsno
      _RL albice
      _RL albNewSnow
      _RL albNIR_ocean, albNIR_thick, albNIR_dsnow
      _RL albNIR_ice, albNIR_fHice, recFac_albNIR
      INTEGER i,j
      INTEGER ii,jj,icount
#ifndef ALLOW_AUTODIFF
      CHARACTER*(MAX_LEN_MBUF) msgBuf
#endif

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      IF ( thSIce_calc_albNIR ) THEN
C     Near-InfraRed albedo
        albNIR_ocean = 0.06 _d 0
        albNIR_thick = 0.33 _d 0
        albNIR_dsnow = 0.68 _d 0
        albNIR_fHice = 4. _d 0
        recFac_albNIR = 1. _d 0 / ATAN(albNIR_fHice*0.5 _d 0)
      ENDIF

      icount = 0
      DO j = jMin, jMax
       DO i = iMin, iMax
        IF ( iceMask(i,j).GT.0. _d 0 ) THEN
         hi  = hIce(i,j)
         hs  = hSnow(i,j)
         Tsf = tSrf(i,j)
         age = ageSnw(i,j)

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C--   Albedo of Bare Sea-Ice
         albice = albIceMax + (albIceMin-albIceMax)*EXP(-hi/hAlbIce)

C--   LANL albedo calculation
c     frsnow = 0.
c     if (hs .gt. 0.) frsnow = 1.
c     if (Tsf .lt. 0.) then
c        albedo = frsnow*albColdSnow + (1.-frsnow)*albice
c     else
c        albedo = frsnow*albWarmSnow + (1.-frsnow)*albice
c     endif
C-end LANL albedo calculation

C--   GISS model albedo calculation
c     albice = 0.7 _d 0

C-    New snow: (linear) transition between tempSnowAlb (oC) and 0.oC
C      from cold/dry snow albedo to warm/wet snow albedo
         IF ( tempSnowAlb.LT.0. _d 0 ) THEN
          albNewSnow = albColdSnow
     &         + (albWarmSnow - albColdSnow)
     &         *MAX( 0. _d 0, MIN(1. _d 0 - Tsf/tempSnowAlb, 1. _d 0) )
         ELSE
          albNewSnow = albColdSnow
         ENDIF
C-    albedo of snow is function of snow-age (make age units into days):
         albsno = albOldSnow
     &        +(albNewSnow-albOldSnow)*EXP(-0.2 _d 0*age/86400. _d 0)
C-    layer of snow over the ice:
         albedo = albsno + (albice-albsno)*EXP(-hs/hAlbSnow)

         IF ( thSIce_calc_albNIR ) THEN
C--   Compute near-infrared albedo
          albNIR_ice = albNIR_ocean + (albNIR_thick -  albNIR_ocean)*
     &         MIN( recFac_albNIR*ATAN(albNIR_fHice*hi), 1. _d 0 )
     &         + 0.075 _d 0 * MIN( -Tsf - 1. _d 0, 0. _d 0 )

          sAlbNIR(i,j) = albNIR_ice * ( 1. _d 0 - hs/(hs + 0.02 _d 0) )
     &         + ( albNIR_dsnow
     &             + 0.15 _d 0 *MIN( -Tsf - 1. _d 0, 0. _d 0) )
     &         * hs/(hs + 0.02 _d 0)
         ELSE
          sAlbNIR(i,j) = albedo
         ENDIF
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
         IF (albedo.GT.1. _d 0 .OR. albedo.LT. .2 _d 0) THEN
C     test for potential errors (move print statements out of i,j-loops
C     for vectorization
          ii=i
          jj=j
          icount=icount+1
         ENDIF
         sAlb(i,j) = albedo
        ELSE
         sAlb(i,j) = 0. _d 0
         sAlbNIR(i,j) = 0. _d 0
        ENDIF
       ENDDO
      ENDDO
C
#ifndef ALLOW_AUTODIFF
C     catch potential errors
      IF (icount .gt. 0) THEN
c       print*,'QQ - albedo problem', albedo, age, hs, albsno
       WRITE(msgBuf,'(A,I10,4I6)')
     &      'THSICE_ALBEDO: Problem, e.g., at:', myIter,ii,jj,bi,bj
       CALL PRINT_ERROR( msgBuf , myThid)
       WRITE(msgBuf,'(A,1P3E17.9)')
     &      'THSICE_ALBEDO: albedo=', sAlb(ii,jj),ageSnw(ii,jj),
     &      hsnow(ii,jj)
       CALL PRINT_ERROR( msgBuf , myThid)
       STOP 'THSICE_ALBEDO: albedo out of range'
      ENDIF
#endif

#endif  /* ALLOW_THSICE */

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      RETURN
      END

#include "THSICE_OPTIONS.h"

CBOP
C     !ROUTINE: THSICE_RESHAPE_LAYERS
C     !INTERFACE:
      SUBROUTINE THSICE_RESHAPE_LAYERS(
     U                                 qicen,
     I                                 hlyr, hnew, myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R THSICE_RESHAPE_LAYERS
C     | Repartition into equal-thickness layers, conserving energy.
C     *==========================================================*
C     | This is the 2-layer version (formerly "NEW_LAYERS_WINTON") 
C     |  from M. Winton 1999, JAOT, sea-ice model.
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     == Global variables ===
#include "EEPARAMS.h"
#include "THSICE_PARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine Arguments ==
C     qicen  :: ice enthalpy (J/kg)
C     hnew   :: new ice layer thickness (m)
C     hlyr   :: individual ice layer thickness (m)
C     myThid :: Number of this instance
      _RL  qicen(*)
      _RL  hnew(*)
      _RL  hlyr
      INTEGER myThid
CEOP

#ifdef ALLOW_THSICE
C     == Local Variables ==
C      f1         :: Fraction of upper layer ice in new layer
C      qh1, qh2   :: qice*h for layers 1 and 2
C      qhtot      :: qh1 + qh2
C      q2tmp      :: Temporary value of qice for layer 2
      _RL  f1
      _RL  qh1, qh2
      _RL  qhtot
      _RL  q2tmp

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      if (hnew(1).gt.hnew(2)) then
C-    Layer 1 gives ice to layer 2
         f1 = (hnew(1)-hlyr)/hlyr
         q2tmp = f1*qicen(1) + (1. _d 0-f1)*qicen(2)
         if (q2tmp.gt.Lfresh) then
            qicen(2) = q2tmp
         else
C-    Keep q2 fixed to avoid q2<Lfresh and T2>0
            qh2 = hlyr*qicen(2)
            qhtot = hnew(1)*qicen(1) + hnew(2)*qicen(2)
            qh1 = qhtot - qh2
            qicen(1) = qh1/hlyr
         endif
      else
C-    Layer 2 gives ice to layer 1
         f1 = hnew(1)/hlyr
         qicen(1) = f1*qicen(1) + (1. _d 0-f1)*qicen(2)
      endif

#endif  /* ALLOW_THSICE */

      RETURN
      END

#include "OPPS_OPTIONS.h"

      SUBROUTINE OPPS_INIT( myThid )
C     *==========================================================*
C     | SUBROUTINE OPPS_INIT                                     |
C     | o Routine to initialize OPPS parameters and variables.   |
C     *==========================================================*
C     | Initialize OPPS parameters and variables.                |
C     *==========================================================*
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "OPPS.h"

C     === Routine arguments ===
C     myThid :: my Thread Id number
      INTEGER myThid

C     !LOCAL VARIABLES :
C     === Local variables ===
C     diagNum   :: diagnostics number in the (long) list of available diag.
C     diagName  :: local short name (8c) of a diagnostics
C     diagCode  :: local parser field with characteristics of the diagnostics
C              cf head of S/R DIAGNOSTICS_INIT_EARLY or DIAGNOSTICS_MAIN_INIT
C     diagUnits :: local string (16c): physical units of a diagnostic field
C     diagTitle :: local string (80c): description of field in diagnostic

#ifdef ALLOW_DIAGNOSTICS
      INTEGER       diagNum
      CHARACTER*8   diagName
      CHARACTER*16  diagCode
      CHARACTER*16  diagUnits
      CHARACTER*(80) diagTitle
#endif
CEOP

C-----------------------------------------------------------------------
C Initialize OPPS variables
C-----------------------------------------------------------------------

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#ifdef ALLOW_DIAGNOSTICS
      IF ( useDiagnostics ) THEN
        diagName  = 'OPPScadj'
        diagTitle = 'OPPS Convective Adjustment Index [0-1] '
        diagUnits = 'fraction        '
        diagCode  = 'SMR     LR      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )
      ENDIF
#endif /* ALLOW_DIAGNOSTICS */

      RETURN
      END

#include "MOM_COMMON_OPTIONS.h"

CBOP
C !ROUTINE: MOM_CALC_TENSION

C !INTERFACE: ==========================================================
      SUBROUTINE MOM_CALC_TENSION(
     I        bi,bj,k,
     I        uFld, vFld,
     O        tension,
     I        myThid )
C !DESCRIPTION:
C Calculates the tension of the horizontal flow field (at tracer points):
C \begin{equation*}
C D_T = \frac{\Delta y_f}{\Delta x_f} \delta_i \frac{u}{\Delta y_g}
C     - \frac{\Delta x_f}{\Delta y_f} \delta_j \frac{v}{\Delta x_g}
C \end{equation*}

C !USES: ===============================================================
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"

C !INPUT PARAMETERS: ===================================================
C  bi,bj                :: tile indices
C  k                    :: vertical level
C  uFld                 :: zonal flow
C  vFld                 :: meridional flow
C  myThid               :: thread number
      INTEGER bi,bj,k
      _RL uFld(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL vFld(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER myThid

C !OUTPUT PARAMETERS: ==================================================
C  tension              :: tension of horizontal flow
      _RL tension(1-OLx:sNx+OLx,1-OLy:sNy+OLy)

C !LOCAL VARIABLES: ====================================================
C  i,j                  :: loop indices
      INTEGER i,j
CEOP

      DO j=1-OLy,sNy+OLy-1
       DO i=1-OLx,sNx+OLx-1

C Calculate tension of horizontal flow (ignoring lopping factors)
C *NOTE* that masking is implicit in the contents of the (u,v) fields.
        tension(i,j)=
     &    ( dyG(i+1, j ,bi,bj)*uFld(i+1, j )
     &     -dyG( i , j ,bi,bj)*uFld( i , j )
     &     -dxG( i ,j+1,bi,bj)*vFld( i ,j+1)
     &     +dxG( i , j ,bi,bj)*vFld( i , j )
     &    )*recip_rA(i,j,bi,bj)*recip_deepFacC(k)
#ifdef ALLOW_OBCS
     &     *maskInC(i,j,bi,bj)
#endif
c       tension(i,j)=
c    &    (dyF(i,j,bi,bj)*recip_dxF(i,j,bi,bj))
c    &   *( uFld(i+1, j )*recip_dyG(i+1, j ,bi,bj)
c    &     -uFld( i , j )*recip_dyG( i , j ,bi,bj) )
c    &   -(dxF(i,j,bi,bj)*recip_dyF(i,j,bi,bj))
c    &   *( vFld( i ,j+1)*recip_dxG( i ,j+1,bi,bj)
c    &     -vFld( i , j )*recip_dxG( i , j ,bi,bj) )

       ENDDO
      ENDDO

      RETURN
      END

c#include "PACKAGES_CONFIG.h"
#include "CPP_OPTIONS.h"

CBOP
C     !ROUTINE: ADD_WALLS2MASKS
C     !INTERFACE:
      SUBROUTINE ADD_WALLS2MASKS( rEmpty, myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE ADD_WALLS2MASKS
C     | o Apply additional closing of Western and Southern edges
C     |   grid-cell open-water factor
C     *==========================================================*
C     | Reset to zero hFacW and/or hFacS grid factors at some
C     | specific locations. In particular, allow to prevent fluid
C     | transport (at any detph) between 2 adjacent vertical
C     | column by adding a "thin wall" between the 2.
C     | Location of "thin-wall" is reccorded as kSurfW/S = Nr+2
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
c#include "SURFACE.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     rEmpty  :: empty column r-position
C     myThid  :: my Thread Id number
      _RS rEmpty
      INTEGER myThid

C     !LOCAL VARIABLES:
C     == Local variables ==
C     bi,bj   :: tile indices
C     i,j,k   :: Loop counters
C     tmpFldW :: Temporary array used to load file in
C     tmpFldS :: Temporary array used to load file in
      _RS tmpFldW(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RS tmpFldS(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      INTEGER bi, bj
      INTEGER i, j, k
CEOP

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      IF ( addWwallFile.NE.' ' .OR. addSwallFile.NE.' ' ) THEN

C--   Load files "addWwallFile" and/or "addSwallFile":
        DO bj=myByLo(myThid), myByHi(myThid)
         DO bi=myBxLo(myThid), myBxHi(myThid)
           DO j=1-OLy,sNy+OLy
            DO i=1-OLx,sNx+OLx
             tmpFldW(i,j,bi,bj) = zeroRS
             tmpFldS(i,j,bi,bj) = zeroRS
            ENDDO
           ENDDO
         ENDDO
        ENDDO
        IF ( addWwallFile.NE.' ' ) THEN
          CALL READ_FLD_XY_RS( addWwallFile, ' ', tmpFldW, 0, myThid )
        ENDIF
        IF ( addSwallFile.NE.' ' ) THEN
          CALL READ_FLD_XY_RS( addSwallFile, ' ', tmpFldS, 0, myThid )
        ENDIF
        CALL EXCH_UV_XY_RS( tmpFldW, tmpFldS, .FALSE., myThid )

      ENDIF

c     IF ( selectSigmaCoord.EQ.0 ) THEN
C---  r-coordinate with partial-cell or full cell mask

C--   The following block allows thin walls representation of non-periodic
C     boundaries such as happen on the lat-lon grid at the N/S poles.
C     We should really supply a flag for doing this.
c      IF ( closedBoundaryAtPoles ) THEN
        DO bj=myByLo(myThid), myByHi(myThid)
         DO bi=myBxLo(myThid), myBxHi(myThid)
           DO j=1-OLy,sNy+OLy
            DO i=1-OLx,sNx+OLx
              IF ( dyG(i,j,bi,bj).EQ.zeroRS ) THEN
                DO k=1,Nr
                 hFacW(i,j,k,bi,bj) = zeroRS
                ENDDO
                rLowW (i,j,bi,bj) = rEmpty
                rSurfW(i,j,bi,bj) = rEmpty
                kSurfW(i,j,bi,bj) = Nr+2
                maskInW(i,j,bi,bj)= zeroRS
              ENDIF
              IF ( dxG(i,j,bi,bj).EQ.zeroRS ) THEN
                DO k=1,Nr
                 hFacS(i,j,k,bi,bj) = zeroRS
                ENDDO
                rLowS (i,j,bi,bj) = rEmpty
                rSurfS(i,j,bi,bj) = rEmpty
                kSurfS(i,j,bi,bj) = Nr+2
                maskInS(i,j,bi,bj)= zeroRS
              ENDIF
            ENDDO
           ENDDO
         ENDDO
        ENDDO
c      ENDIF

C--   Addtional closing of Western and Southern grid-cell edges
C      as provided in files: "addWwallFile" or "addSwallFile"
       IF ( addWwallFile.NE.' ' .OR. addSwallFile.NE.' ' ) THEN
        DO bj=myByLo(myThid), myByHi(myThid)
         DO bi=myBxLo(myThid), myBxHi(myThid)
           DO j=1-OLy,sNy+OLy
            DO i=1-OLx,sNx+OLx
              IF ( tmpFldW(i,j,bi,bj).EQ.oneRS ) THEN
                DO k=1,Nr
                 hFacW(i,j,k,bi,bj) = zeroRS
                ENDDO
                rLowW (i,j,bi,bj) = rEmpty
                rSurfW(i,j,bi,bj) = rEmpty
                kSurfW(i,j,bi,bj) = Nr+2
                maskInW(i,j,bi,bj)= zeroRS
              ENDIF
              IF ( tmpFldS(i,j,bi,bj).EQ.oneRS ) THEN
                DO k=1,Nr
                 hFacS(i,j,k,bi,bj) = zeroRS
                ENDDO
                rLowS (i,j,bi,bj) = rEmpty
                rSurfS(i,j,bi,bj) = rEmpty
                kSurfS(i,j,bi,bj) = Nr+2
                maskInS(i,j,bi,bj)= zeroRS
              ENDIF
            ENDDO
           ENDDO
         ENDDO
        ENDDO
       ENDIF

c     ELSE
C---  Sigma and Hybrid-Sigma set-up:
c     ENDIF

      RETURN
      END

#include "DIC_OPTIONS.h"
#ifdef ALLOW_AUTODIFF
# include "AUTODIFF_OPTIONS.h"
#endif

CBOP
C !ROUTINE: DIC_BIOTIC_FORCING

C !INTERFACE: ==========================================================
      SUBROUTINE DIC_BIOTIC_FORCING(
     U                      PTR_DIC, PTR_ALK, PTR_PO4, PTR_DOP,
#ifdef ALLOW_O2
     U                      PTR_O2,
#endif
#ifdef ALLOW_FE
     U                      PTR_FE,
#endif
     I                      bi, bj, iMin, iMax, jMin, jMax,
     I                      myTime, myIter, myThid )

C !DESCRIPTION:
C updates all the tracers for the effects of air-sea exchange, biological
c activity and remineralization

C !USES: ===============================================================
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "DYNVARS.h"
#include "DIC_VARS.h"
#include "PTRACERS_SIZE.h"
#include "PTRACERS_PARAMS.h"
#ifdef ALLOW_AUTODIFF_TAMC
# include "tamc.h"
#endif

C !INPUT/OUTPUT PARAMETERS: ===================================================
C  PTR_DIC              :: dissolced inorganic carbon
C  PTR_ALK              :: alkalinity
C  PTR_PO4              :: phosphate
c  PTR_DOP              :: dissolve organic phosphurous
c  PTR_O2               :: oxygen
C  PTR_FE               :: iron
c  bi, bj               :: current tile indices
C  myTime               :: current time
C  myIter               :: current timestep
C  myThid               :: thread number
      _RL  PTR_DIC(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL  PTR_ALK(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL  PTR_PO4(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL  PTR_DOP(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
#ifdef ALLOW_O2
      _RL  PTR_O2(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
#endif
#ifdef ALLOW_FE
      _RL  PTR_FE(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
#endif
      INTEGER bi, bj, iMin, iMax, jMin, jMax
      _RL myTime
      INTEGER myIter
      INTEGER myThid

#ifdef DIC_BIOTIC
C !FUNCTIONS:       ====================================================
      LOGICAL  DIFFERENT_MULTIPLE
      EXTERNAL DIFFERENT_MULTIPLE

C !LOCAL VARIABLES: ====================================================
C  i,j,k                  :: loop indices
C  G*                     :: tendency term for the tracers
C  SURA                   :: tendency of alkalinity due to freshwater
C  SURC                   :: tendency of DIC due to air-sea exchange
C                            and virtual flux
C  SURO                   :: tendency of O2 due to air-sea exchange
C  GPO4                   :: tendency of PO4 due to biological productivity,
C                            exchange with DOP pool and reminerization
C  CAR                    :: carbonate changes due to biological
C                             productivity and remineralization
C  BIOac                  :: biological productivity
C  RDOP                   :: DOP sink due to remineralization
C  pflux                  :: changes to PO4 due to flux and remineralization
C  CAR_S                  :: carbonate sink
C  cflux                  :: carbonate changes due to flux and remineralization
C  freefe                 :: iron not bound to ligand
      _RL  GDIC(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL  GALK(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL  GPO4(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL  GDOP(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL  SURA(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL  SURC(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL  SURO(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL  CAR(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL  BIOac(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL  RDOP(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL  pflux(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL  exportflux(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL  CAR_S(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL  cflux(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
#ifdef ALLOW_O2
      _RL  GO2(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
#endif
#ifdef ALLOW_FE
      _RL  GFE(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL  freefe(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
#endif
      INTEGER i,j,k
#ifdef ALLOW_FE
# ifdef SEDFE
      INTEGER kBottom
# endif
#endif
#ifdef ALLOW_AUTODIFF_TAMC
C     tkey :: tape key TAF-AD simulations (depends on tiles)
      INTEGER tkey
#endif
CEOP

#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_ENTER('DIC_BIOTIC_FORCING',myThid)
#endif

#ifdef ALLOW_AUTODIFF_TAMC
      tkey = bi + (bj-1)*nSx + (ikey_dynamics-1)*nSx*nSy
#endif
      IF ( useThSIce .OR. useSEAICE .OR. useCoupler ) THEN
#ifdef ALLOW_DEBUG
        IF (debugMode) CALL DEBUG_CALL('DIC_FIELDS_UPDATE',myThid)
#endif
        CALL DIC_FIELDS_UPDATE(
     I                    bi, bj, myTime, myIter, myThid )
      ENDIF

       DO k=1,Nr
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           RDOP(i,j,k) =0. _d 0
           GDIC(i,j,k) =0. _d 0
           GALK(i,j,k) =0. _d 0
           GPO4(i,j,k) =0. _d 0
           GDOP(i,j,k) =0. _d 0
           CAR(i,j,k)  =0. _d 0
           BIOac(i,j,k)   =0. _d 0
           pflux(i,j,k)   =0. _d 0
           exportflux(i,j,k)=0. _d 0
           cflux(i,j,k)   =0. _d 0
           CAR_S(i,j,k)   =0. _d 0
#ifdef ALLOW_O2
           GO2(i,j,k)     =0. _d 0
#endif
#ifdef ALLOW_FE
           GFE(i,j,k)     =0. _d 0
C  no longer needed after adding full initialisation of freefe in S/R FE_CHEM
c          freefe(i,j,k)  =0. _d 0
#endif
          ENDDO
         ENDDO
       ENDDO
       DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
           SURA(i,j)   =0. _d 0
           SURC(i,j)   =0. _d 0
           SURO(i,j)   =0. _d 0
         ENDDO
       ENDDO

C carbon air-sea interaction
#ifdef ALLOW_DEBUG
       IF (debugMode) CALL DEBUG_CALL('DIC_SURFFORCING',myThid)
#endif
       CALL DIC_SURFFORCING(
     I                    PTR_DIC, PTR_ALK, PTR_PO4,
     O                    SURC,
     I                    bi, bj, iMin, iMax, jMin, jMax,
     I                    myTime, myIter, myThid )

#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE Kwexch_pre(:,:,bi,bj) = comlev1_bibj, key=tkey, kind=isbyte
#endif

C alkalinity air-sea interaction
#ifdef ALLOW_DEBUG
       IF (debugMode) CALL DEBUG_CALL('ALK_SURFFORCING',myThid)
#endif
       CALL ALK_SURFFORCING(
     I                    PTR_ALK,
     O                    SURA,
     I                    bi, bj, iMin, iMax, jMin, jMax,
     I                    myTime, myIter, myThid )

#ifdef ALLOW_O2
C oxygen air-sea interaction
#ifdef ALLOW_DEBUG
       IF (debugMode) CALL DEBUG_CALL('O2_SURFFORCING',myThid)
#endif
       CALL O2_SURFFORCING(
     I                    PTR_O2,
     O                    SURO,
     I                    bi, bj, iMin, iMax, jMin, jMax,
     I                    myTime, myIter, myThid )
#endif

#ifdef ALLOW_FE
C find free iron
#ifdef ALLOW_DEBUG
       IF (debugMode) CALL DEBUG_CALL('FE_CHEM',myThid)
#endif
       CALL FE_CHEM( bi, bj, iMin, iMax, jMin, jMax,
     U               PTR_FE,
     O               freefe,
     I               myIter, myThid )
#endif

C biological activity
#ifdef ALLOW_DEBUG
       IF (debugMode) CALL DEBUG_CALL('BIO_EXPORT',myThid)
#endif
       CALL BIO_EXPORT(
     I                    PTR_PO4,
#ifdef ALLOW_FE
     I                    PTR_FE,
#endif
     O                    BIOac,
     I                    bi, bj, iMin, iMax, jMin, jMax,
     I                    myTime, myIter, myThid )
#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE BIOac = comlev1_bibj, key = tkey, kind = isbyte
#endif

C flux of po4 from layers with biological activity
#ifdef ALLOW_DEBUG
       IF (debugMode) CALL DEBUG_CALL('PHOS_FLUX',myThid)
#endif
       CALL PHOS_FLUX(
     I                    BIOac,
     U                    pflux, exportflux,
     I                    bi, bj, iMin, iMax, jMin, jMax,
     I                    myTime, myIter, myThid )

C- Carbonate sink
       DO k=1,Nr
         DO j=jMin,jMax
          DO i=iMin,iMax
             CAR_S(i,j,k)=BIOac(i,j,k)*R_CP*rain_ratio(i,j,bi,bj)*
     &                    (1. _d 0-DOPfraction)
          ENDDO
         ENDDO
       ENDDO

C carbonate
#ifdef DIC_CALCITE_SAT
       IF ( useCalciteSaturation ) THEN
C calcite dissolution occurs only below saturation horizon
C    code following method by Karsten Friis
C could be expensive, so find out if it is time to update the omega calcite
C    field (requires 3-d computation of pH).
        IF ( myIter.EQ.(nIter0 + 1) .OR.
     &       DIFFERENT_MULTIPLE( calcOmegaCalciteFreq,
     &                           myTime, deltaTClock ) ) THEN
#ifdef ALLOW_DEBUG
          IF (debugMode) CALL DEBUG_CALL('CALCITE_SATURATION',myThid)
#endif
          CALL CALCITE_SATURATION(
     I                    PTR_DIC, PTR_ALK, PTR_PO4,
     I                    bi, bj, iMin, iMax, jMin, jMax,
     I                    myTime, myIter, myThid )
        ENDIF
#ifdef ALLOW_DEBUG
        IF (debugMode) CALL DEBUG_CALL('CAR_FLUX_OMEGA_TOP',myThid)
#endif
        CALL CAR_FLUX_OMEGA_TOP(
     I                    BIOac,
     O                    cflux,
     I                    bi, bj, iMin, iMax, jMin, jMax,
     I                    myTime, myIter, myThid )
       ELSE
#endif /* DIC_CALCITE_SAT */
C calcite dissolution occurs according to a power law scaled by zca
C    code follwing the old OCMIP way
#ifdef ALLOW_DEBUG
        IF (debugMode) CALL DEBUG_CALL('CAR_FLUX',myThid)
#endif
         CALL CAR_FLUX(
     I                    CAR_S,
     U                    cflux,
     I                    bi, bj, iMin, iMax, jMin, jMax,
     I                    myTime, myIter, myThid )
#ifdef DIC_CALCITE_SAT
       ENDIF
#endif /* DIC_CALCITE_SAT */

C add all tendencies for PO4, DOP, ALK, DIC
       DO k=1,Nr
         DO j=jMin,jMax
          DO i=iMin,iMax
#ifdef DIC_NO_NEG
           RDOP(i,j,k)= MAX(maskC(i,j,k,bi,bj)*KDOPRemin*PTR_DOP(i,j,k)
     &                     ,0. _d 0)
#else
           RDOP(i,j,k)= maskC(i,j,k,bi,bj)*KDOPRemin*PTR_DOP(i,j,k)
#endif
           GPO4(i,j,k)=-BIOac(i,j,k)+pflux(i,j,k) + RDOP(i,j,k)

           car(i,j,k) = cflux(i,j,k) - CAR_S(i,j,k)

           GDOP(i,j,k)=+BIOac(i,j,k)*DOPfraction - RDOP(i,j,k)

           GALK(i,j,k)=+2. _d 0 *car(i,j,k)-R_NP*GPO4(i,j,k)

           GDIC(i,j,k)=car(i,j,k)+R_CP*GPO4(i,j,k)

#ifdef ALLOW_O2
           if (PTR_O2(i,j,k).GT.O2crit) then
             GO2(i,j,k)= R_OP*GPO4(i,j,k)
           else
             GO2(i,j,k)= 0. _d 0
           endif
#endif
#ifdef ALLOW_FE
           GFE(i,j,k) = R_FeP*GPO4(i,j,k)
     &                 -Kscav*freefe(i,j,k)
#endif
          ENDDO
         ENDDO
       ENDDO

       DO j=jMin,jMax
         DO i=iMin,iMax
               GALK(i,j,1)=GALK(i,j,1)+SURA(i,j)
               GDIC(i,j,1)=GDIC(i,j,1)+SURC(i,j)
#ifdef ALLOW_O2
               GO2(i,j,1) =GO2(i,j,1)+SURO(i,j)
#endif
#ifdef ALLOW_FE
               GFE(i,j,1)=GFE(i,j,1)+alpfe*
     &                    InputFe(i,j,bi,bj)*recip_drF(1)
     &                       *recip_hFacC(i,j,1,bi,bj)
# ifdef SEDFE
C include iron sediment source using the flux of po4 into bottom layer
               kBottom   = MAX(kLowC(i,j,bi,bj),1)
               GFE(i,j,kBottom)=GFE(i,j,kBottom)
     &              +( fesedflux_pcm*pflux(i,j,kBottom) + FeIntSec )
     &              *recip_drF(kBottom)*recip_hFacC(i,j,kBottom,bi,bj)
# endif
#endif
         ENDDO
       ENDDO

       IF ( useOBCS ) THEN
        DO k=1,Nr
         DO j=jMin,jMax
          DO i=iMin,iMax
            GDIC(i,j,k) = GDIC(i,j,k)*maskInC(i,j,bi,bj)
            GALK(i,j,k) = GALK(i,j,k)*maskInC(i,j,bi,bj)
            GPO4(i,j,k) = GPO4(i,j,k)*maskInC(i,j,bi,bj)
            GDOP(i,j,k) = GDOP(i,j,k)*maskInC(i,j,bi,bj)
#ifdef ALLOW_O2
            GO2(i,j,k)  =  GO2(i,j,k)*maskInC(i,j,bi,bj)
#endif
#ifdef ALLOW_FE
            GFE(i,j,k)  =  GFE(i,j,k)*maskInC(i,j,bi,bj)
#endif
          ENDDO
         ENDDO
        ENDDO
       ENDIF

C update
       DO k=1,Nr
         DO j=jMin,jMax
          DO i=iMin,iMax
           PTR_DIC(i,j,k)=
     &      PTR_DIC(i,j,k)+GDIC(i,j,k)*PTRACERS_dTLev(k)
           PTR_ALK(i,j,k)=
     &      PTR_ALK(i,j,k)+GALK(i,j,k)*PTRACERS_dTLev(k)
           PTR_PO4(i,j,k)=
     &      PTR_PO4(i,j,k)+GPO4(i,j,k)*PTRACERS_dTLev(k)
           PTR_DOP(i,j,k)=
     &      PTR_DOP(i,j,k)+GDOP(i,j,k)*PTRACERS_dTLev(k)
#ifdef ALLOW_O2
           PTR_O2(i,j,k)=
     &      PTR_O2(i,j,k)+GO2(i,j,k)*PTRACERS_dTLev(k)
#endif
#ifdef ALLOW_FE
           PTR_FE(i,j,k)=
     &      PTR_FE(i,j,k)+GFE(i,j,k)*PTRACERS_dTLev(k)
#endif
          ENDDO
         ENDDO
       ENDDO

#ifdef ALLOW_FE
#ifdef MINFE
c find free iron and get rid of insoluble part
#ifdef ALLOW_DEBUG
       IF (debugMode) CALL DEBUG_CALL('FE_CHEM',myThid)
#endif
       CALL FE_CHEM( bi, bj, iMin, iMax, jMin, jMax,
     U               PTR_FE,
     O               freefe,
     I               myIter, myThid )
#endif
#endif

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#ifdef ALLOW_DIAGNOSTICS
      IF ( useDiagnostics ) THEN
        CALL DIAGNOSTICS_FILL(BIOac  ,'DICBIOA ',0,Nr,2,bi,bj,myThid)
        CALL DIAGNOSTICS_FILL(CAR    ,'DICCARB ',0,Nr,2,bi,bj,myThid)
        CALL DIAGNOSTICS_FILL(pCO2   ,'DICPCO2 ',0,1 ,1,bi,bj,myThid)
        CALL DIAGNOSTICS_FILL(fluxCO2,'DICCFLX ',0,1 ,1,bi,bj,myThid)
        CALL DIAGNOSTICS_FILL(pH     ,'DICPHAV ',0,1 ,1,bi,bj,myThid)
        CALL DIAGNOSTICS_FILL(SURC   ,'DICTFLX ',0,1 ,2,bi,bj,myThid)
#ifdef ALLOW_O2
        CALL DIAGNOSTICS_FILL(SURO   ,'DICOFLX ',0,1 ,2,bi,bj,myThid)
#endif
      ENDIF
#endif /* ALLOW_DIAGNOSTICS */

#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_LEAVE('DIC_BIOTIC_FORCING',myThid)
#endif

#endif /* DIC_BIOTIC */

       RETURN
       END

#include "CPP_OPTIONS.h"

CBOP
C     !ROUTINE: POST_CG3D
C     !INTERFACE:
      SUBROUTINE POST_CG3D(
     I                      myTime, myIter, myThid )

C     !DESCRIPTION:
C     Called from SOLVE_FOR_PRESSURE, after 3-D solver (cg3d):
C     Finish computation of Non-hydrostatic pressure from 3-D solver solution

C     !USES:
      IMPLICIT NONE
C     == Global variables
#include "SIZE.h"
#include "EEPARAMS.h"
#ifdef ALLOW_NONHYDROSTATIC
# include "PARAMS.h"
# include "GRID.h"
# include "SURFACE.h"
c#include "FFIELDS.h"
# include "DYNVARS.h"
# include "NH_VARS.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     myTime      :: Current time in simulation
C     myIter      :: Current iteration number in simulation
C     myThid      :: My Thread Id. number
      _RL     myTime
      INTEGER myIter
      INTEGER myThid

#ifdef ALLOW_NONHYDROSTATIC
C     !FUNCTIONS:
      LOGICAL  DIFFERENT_MULTIPLE
      EXTERNAL DIFFERENT_MULTIPLE

C     !LOCAL VARIABLES:
      INTEGER i, j, bi, bj
      INTEGER ks
c     CHARACTER*(MAX_LEN_MBUF) msgBuf
      _RL     locGamma
CEOP

C--   Separate the Hydrostatic Surface Pressure adjusment (=> put it in dPhiNH)
C     from the Non-hydrostatic pressure (since cg3d_x contains both contribution)
      IF ( nonHydrostatic .AND. exactConserv ) THEN
       DO bj=myByLo(myThid),myByHi(myThid)
        DO bi=myBxLo(myThid),myBxHi(myThid)

         IF ( selectNHfreeSurf.GE.1 ) THEN
          DO j=1,sNy
           DO i=1,sNx
            locGamma = drC(1)*recip_Bo(i,j,bi,bj)
     &               /( deltaTMom*deltaTFreeSurf
     &                 *implicitNHPress*implicDiv2DFlow )
            ks = 1
c           ks = kSurfC(i,j,bi,bj)
c           IF ( ks.LE.Nr ) THEN
             dPhiNH(i,j,bi,bj) = ( phi_nh(i,j,ks,bi,bj)
     &           + locGamma*Bo_surf(i,j,bi,bj)
     &                     *implicDiv2DFlow*deltaTFreeSurf
c    &                     *( wVel(i,j,ks,bi,bj) - wSurfP2d(i,j) )
     &                     *( wVel(i,j,ks,bi,bj) - dPhiNH(i,j,bi,bj) )
     &                           )/(1. _d 0 + locGamma )
c           ENDIF
           ENDDO
          ENDDO
         ELSEIF ( uniformFreeSurfLev ) THEN
C-       Z coordinate: assume surface @ level k=1
          DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
             dPhiNH(i,j,bi,bj) = phi_nh(i,j,1,bi,bj)
           ENDDO
          ENDDO
         ELSE
C-       Other than Z coordinate: no assumption on surface level index
          DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
            ks = kSurfC(i,j,bi,bj)
            IF ( ks.LE.Nr ) THEN
             dPhiNH(i,j,bi,bj) = phi_nh(i,j,ks,bi,bj)
            ELSE
             dPhiNH(i,j,bi,bj) = 0.
            ENDIF
           ENDDO
          ENDDO
         ENDIF

        ENDDO
       ENDDO
       IF ( selectNHfreeSurf.GE.1 .AND.
     &  ( implicitNHPress.LT.oneRL .OR. selectP_inEOS_Zc.EQ.3 ) ) THEN
         CALL EXCH_XY_RL( dPhiNH, myThid )
       ENDIF
      ENDIF

#endif /* ALLOW_NONHYDROSTATIC */

      RETURN
      END

#include "CPP_EEOPTIONS.h"

CBOP
C     !ROUTINE: W2_MAP_PROCS

C     !INTERFACE:
      SUBROUTINE W2_MAP_PROCS( myThid )

C     !DESCRIPTION:
C     *==========================================================*
C     | SUBROUTINE W2_MAP_PROCS
C     | o Setup Mapping of W2-topology tiles to processes
C     *==========================================================*
C     | Set which process "own" which tiles
C     | and store the 2-way relation between, on one side,
C     |  tile Id from W2-topology and, on the other side,
C     |  process Id with local tile indices bi,bj.
C     *==========================================================*

C     !USES:
      IMPLICIT NONE

#include "SIZE.h"
#include "EEPARAMS.h"
#include "W2_EXCH2_SIZE.h"
#include "W2_EXCH2_TOPOLOGY.h"
#include "W2_EXCH2_PARAMS.h"

C     !INPUT PARAMETERS:
C     myThid  :: my Thread Id number
C               (Note: not relevant since threading has not yet started)
      INTEGER myThid
CEOP

C     !FUNCTIONS:

C     !LOCAL VARIABLES:
      INTEGER thisProc
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      CHARACTER commFlag
      INTEGER myTileId
      INTEGER I, J
      INTEGER np, ii, jj, bi, bj
      INTEGER iErr, tNx, tNy

C--   Initialise common blocs W2_MAP_TILE2PROC & W2_EXCH2_COMMFLAG:
      DO I = 1,W2_maxNbTiles
        W2_tileProc(I)  = 0
        W2_tileIndex(I) = 0
c       W2_tileRank(I)  = 0
      ENDDO
      DO bj=1,nSy
       DO bi=1,nSx
         W2_myTileList(bi,bj) = 0
         DO np=1,nPx*nPy
           W2_procTileList(bi,bj,np) = 0
         ENDDO
         DO J=1,W2_maxNeighbours
           W2_myCommFlag(J,bi,bj) = ' '
         ENDDO
       ENDDO
      ENDDO

C--   Decide which tiles this process handles - do this inline for now, but
C     should go in subroutine.
C     Set which rank processes "own" which tiles. This should probably
C     be queried as part of some hand-shaking but for now we use the
C     functional relationship that was used above.
C     Fill also W2_procTileList for Single-CPU-IO.

C     Number of tiles I handle is nSx*nSy
      thisProc = 1 + myProcId
      J = 0
      DO I=1,exch2_nTiles
       IF ( exch2_myFace(I) .NE. 0 ) THEN
C--   old ordering (makes no difference if nSy*nPy=1 )
c       np = 1 + J/(nSx*nSy)
c       jj = MOD(J,nSx*nSy)
c       bj = 1 + jj/nSx
c       bi = 1 + MOD(jj,nSx)
C--   new ordering: for single sub-domain (nFacets=1) case, match default setting
        jj = J/(nSx*nPx)
        ii = MOD(J,nSx*nPx)
C--   natural way to order processors:
c       np = 1 + ii/nSx + (jj/nSy)*nPx
C--   switch processor order to match MPI_CART set-up
        np = 1 + jj/nSy + (ii/nSx)*nPy
        bj = 1 + MOD(jj,nSy)
        bi = 1 + MOD(ii,nSx)
C--
        W2_tileProc(I) = np
        W2_tileIndex(I)= bi + (bj-1)*nSx
        W2_procTileList(bi,bj,np) = I
        IF ( np.EQ.thisProc ) W2_myTileList(bi,bj) = I
        J = J + 1
c       W2_tileRank(I) = J
       ENDIF
      ENDDO
      IF ( J .NE. nSx*nSy*nPx*nPy ) THEN
       STOP
     & 'ERROR W2_MAP_PROCS: number of active tiles not =nPx*nSx*nPy*nSy'
      ENDIF

C--   Check tile sizes
      iErr = 0
      DO bj=1,nSy
       DO bi=1,nSx
        myTileId = W2_myTileList(bi,bj)
        tNx = exch2_tNx(myTileId)
        tNy = exch2_tNy(myTileId)
        IF ( tNx .NE. sNx ) THEN
         WRITE(msgBuf,'(A,I8,2(A,I5))')
     &   'ERROR: S/R W2_MAP_PROCS Topology for tile', myTileId,
     &   'tNx=', tNx, ' is not equal to subgrid size sNx=', sNx
         CALL PRINT_MESSAGE(msgBuf,
     &        errorMessageUnit, SQUEEZE_RIGHT, 1 )
         iErr = iErr+1
        ENDIF
        IF ( tNy .NE. sNy ) THEN
         WRITE(msgBuf,'(A,I8,2(A,I5))')
     &   'ERROR: S/R W2_MAP_PROCS Topology for tile', myTileId,
     &   'tNy=', tNy, ' is not equal to subgrid size sNy=', sNy
         CALL PRINT_MESSAGE(msgBuf,
     &        errorMessageUnit, SQUEEZE_RIGHT, 1 )
         iErr = iErr+1
        ENDIF
       ENDDO
      ENDDO
      IF ( iErr .NE. 0 ) THEN
       STOP 'ABNORMAL END: W2_MAP_PROCS'
      ENDIF

C--   Print tiles connection for this process and set myCommonFlag :
      WRITE(msgBuf,'(A)') '===== W2 TILE TOPOLOGY ====='
      CALL PRINT_MESSAGE( msgBuf, W2_oUnit, SQUEEZE_BOTH, myThid )
      DO bj=1,nSy
       DO bi=1,nSx
        myTileId = W2_myTileList(bi,bj)
        WRITE(msgBuf,'(A,I5,A,2I4,2A,I3)')
     &       ' TILE: ', myTileId,' (bi,bj=', bi, bj, ' )',
     &       ', Nb of Neighbours =', exch2_nNeighbours(myTileId)
c       WRITE(msgBuf,'(2(A,I5),A,I3)') ' TILE: ', myTileId,
c    &       ' , rank=', W2_tileRank(myTileId),
c    &       ' , Nb of Neighbours =', exch2_nNeighbours(myTileId)
        CALL PRINT_MESSAGE( msgBuf, W2_oUnit, SQUEEZE_RIGHT, myThid )
        DO J=1,exch2_nNeighbours(myTileId)
         commFlag = 'M'
         jj = exch2_neighbourId(J,myTileId)
         IF ( W2_tileProc(jj).EQ.thisProc ) commFlag = 'P'
         IF ( commFlag .EQ. 'M' ) THEN
          WRITE(msgBuf,'(A,I3,A,I8,A,I3,2A,I8,A)')
     &    '    NEIGHBOUR',J,' = TILE', exch2_neighbourId(J,myTileId),
     &    ' (n=', exch2_opposingSend(J,myTileId), ') Comm = MSG',
     &    ' (PROC=',W2_tileProc(exch2_neighbourId(J,myTileId)),')'
          CALL PRINT_MESSAGE( msgBuf, W2_oUnit, SQUEEZE_RIGHT, myThid )
         ENDIF
         IF ( commFlag .EQ. 'P' ) THEN
          WRITE(msgBuf,'(A,I3,A,I8,A,I3,2A,I8,A)')
     &    '    NEIGHBOUR',J,' = TILE', exch2_neighbourId(J,myTileId),
     &    ' (n=', exch2_opposingSend(J,myTileId), ') Comm = PUT',
     &    ' (PROC=',W2_tileProc(exch2_neighbourId(J,myTileId)),')'
          CALL PRINT_MESSAGE( msgBuf, W2_oUnit, SQUEEZE_RIGHT, myThid )
         ENDIF
         W2_myCommFlag(J,bi,bj) = commFlag
        ENDDO
       ENDDO
      ENDDO

      RETURN
      END

#include "SEAICE_OPTIONS.h"
#ifdef ALLOW_EXF
# include "EXF_OPTIONS.h"
#endif
#ifdef ALLOW_AUTODIFF
# include "AUTODIFF_OPTIONS.h"
#endif

CBOP
C !ROUTINE: SEAICE_MODEL

C !INTERFACE: ==========================================================
      SUBROUTINE SEAICE_MODEL( myTime, myIter, myThid )

C !DESCRIPTION: \bv
C     *===========================================================*
C     | SUBROUTINE SEAICE_MODEL                                   |
C     | o Time stepping of a dynamic/thermodynamic sea ice model. |
C     |  Dynamics solver: Zhang/Hibler, JGR, 102, 8691-8702, 1997 |
C     |  Thermodynamics:        Hibler, MWR, 108, 1943-1973, 1980 |
C     |  Rheology:              Hibler, JPO,   9,  815- 846, 1979 |
C     |  Snow:          Zhang et al.  , JPO,  28,  191- 217, 1998 |
C     |  Parallel forward ice model written by Jinlun Zhang PSC/UW|
C     |  & coupled into MITgcm by Dimitris Menemenlis (JPL) 2/2001|
C     |  zhang@apl.washington.edu / menemenlis@jpl.nasa.gov       |
C     | o The code has been rewritten substantially to use the    |
C     |   MITgcm C-grid, see Losch et al. OM, 33,  129- 144, 2010 |
C     *===========================================================*
      IMPLICIT NONE
C \ev

C !USES: ===============================================================
#include "SIZE.h"
#include "EEPARAMS.h"
#include "DYNVARS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "FFIELDS.h"
#include "SEAICE_SIZE.h"
#include "SEAICE_PARAMS.h"
#include "SEAICE.h"
#include "SEAICE_TRACER.h"
#ifdef ALLOW_EXF
# include "EXF_FIELDS.h"
#endif
#ifdef ALLOW_AUTODIFF_TAMC
# include "tamc.h"
#endif

C !INPUT PARAMETERS: ===================================================
C     myTime :: Current time in simulation
C     myIter :: Current iteration number in simulation
C     myThid :: my Thread Id number
      _RL     myTime
      INTEGER myIter
      INTEGER myThid

C !LOCAL VARIABLES: ====================================================
C     i,j,bi,bj :: Loop counters
      INTEGER i, j
      INTEGER bi, bj
#ifdef ALLOW_EXF
      INTEGER grpDiag
#endif
#ifdef ALLOW_SITRACER
      INTEGER iTr
#endif
#ifdef SEAICE_BGRID_DYNAMICS
      _RL uLoc(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL vLoc(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
#endif
CEOP
#ifdef ALLOW_DIAGNOSTICS
      LOGICAL  DIAGNOSTICS_IS_ON
      EXTERNAL DIAGNOSTICS_IS_ON
      LOGICAL  diag_SIenph_isOn
      _RL mTmp(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL recip_deltaTtherm
      _RL addSnow
#endif
#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_ENTER( 'SEAICE_MODEL', myThid )
#endif

      IF ( usingPCoords ) THEN
C     In z-coordinates, phiHydLow is just a diagnostics and hence its
C     overlaps are never filled properly
C     in p-coordinates, phiHydLow is the sea level elevation that is required
C     for the sea level tilt term in the momentum equation, so we need
C     to fill the overlaps properly here
C     (or elsewhere, not sure where it would be best)
       _EXCH_XY_RL( phiHydLow, myThid )
      ENDIF
#ifdef ALLOW_THSICE
      IF ( useThSice ) THEN
C--   Map thSice-variables to HEFF, HSNOW, and AREA, because they are
C     needed in S/R SEAICE_DYNSOLVER
       CALL SEAICE_MAP_THSICE( myTime, myIter, myThid )
      ENDIF
#endif /* ALLOW_THSICE */
#ifdef ALLOW_DIAGNOSTICS
      IF ( useDiagnostics ) THEN
       diag_SIenph_isOn = DIAGNOSTICS_IS_ON('SIenph  ',myThid)
       IF ( diag_SIenph_isOn ) THEN
        IF ( SEAICEaddSnowMass ) THEN
         addSnow=1. _d 0
        ELSE
         addSnow=0. _d 0
        ENDIF
        DO bj=myByLo(myThid),myByHi(myThid)
         DO bi=myBxLo(myThid),myBxHi(myThid)
          DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
            mTmp(i,j,bi,bj)=SEAICE_rhoIce*HEFF(i,j,bi,bj)
     &                     +addSnow*SEAICE_rhoSnow*HSNOW(i,j,bi,bj)
           ENDDO
          ENDDO
         ENDDO
        ENDDO
       ENDIF
      ENDIF
#endif /* ALLOW_DIAGNOSTICS */

#ifdef ALLOW_EXF
      IF ( useEXF ) THEN
C--   Winds are from pkg/exf, which does not update edges.
       CALL EXCH_UV_AGRID_3D_RL( uwind, vwind, .TRUE., 1, myThid )
       IF ( useDiagnostics ) THEN
C-    Fill-in EXF wind-stess diags, weighted by open-ocean fraction
        grpDiag = -1
        IF ( SEAICEuseDYNAMICS ) grpDiag = 1
        CALL EXF_WEIGHT_SFX_DIAGS(
     I                  AREA, grpDiag, myTime, myIter, myThid )
       ENDIF
      ENDIF
#endif /* ALLOW_EXF */

#ifdef ALLOW_AUTODIFF
      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          uIceNm1(i,j,bi,bj) = 0. _d 0
          vIceNm1(i,j,bi,bj) = 0. _d 0
# ifdef ALLOW_SITRACER
          DO iTr = 1, SItrMaxNum
           SItrBucket(i,j,bi,bj,iTr) = 0. _d 0
          ENDDO
# endif
         ENDDO
        ENDDO
       ENDDO
      ENDDO
#endif /* ALLOW_AUTODIFF */
#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE heff  = comlev1, key=ikey_dynamics, kind=isbyte
CADJ STORE area  = comlev1, key=ikey_dynamics, kind=isbyte
CADJ STORE hsnow = comlev1, key=ikey_dynamics, kind=isbyte
# ifdef SEAICE_CGRID
CADJ STORE fu    = comlev1, key=ikey_dynamics, kind=isbyte
CADJ STORE fv    = comlev1, key=ikey_dynamics, kind=isbyte
#  ifdef SEAICE_ALLOW_EVP
CADJ STORE seaice_sigma1  = comlev1, key=ikey_dynamics, kind=isbyte
CADJ STORE seaice_sigma2  = comlev1, key=ikey_dynamics, kind=isbyte
CADJ STORE seaice_sigma12 = comlev1, key=ikey_dynamics, kind=isbyte
#  endif /* SEAICE_ALLOW_EVP */
# endif /* SEAICE_CGRID */
# ifdef ALLOW_SITRACER
CADJ STORE siceload = comlev1, key=ikey_dynamics, kind=isbyte
CADJ STORE sitracer = comlev1, key=ikey_dynamics, kind=isbyte
# endif
#endif /* ALLOW_AUTODIFF_TAMC */

C--   Solve ice momentum equations and calculate ocean surface stress.
C     The surface stress always needs to be updated, even if neither B-
C     or C-grid dynamics are compiled, and SEAICEuseDYNAMICS = F.
#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_CALL( 'SEAICE_DYNSOLVER', myThid )
#endif
#ifdef SEAICE_BGRID_DYNAMICS
      CALL TIMER_START('DYNSOLVER          [SEAICE_MODEL]',myThid)
      CALL DYNSOLVER ( myTime, myIter, myThid )
      CALL TIMER_STOP ('DYNSOLVER          [SEAICE_MODEL]',myThid)
#else /* use default C-grid solver */
      CALL TIMER_START('SEAICE_DYNSOLVER   [SEAICE_MODEL]',myThid)
      CALL SEAICE_DYNSOLVER ( myTime, myIter, myThid )
      CALL TIMER_STOP ('SEAICE_DYNSOLVER   [SEAICE_MODEL]',myThid)
#endif

C--   Apply ice velocity open boundary conditions
#ifdef ALLOW_OBCS
# ifndef DISABLE_SEAICE_OBCS
      IF ( useOBCS ) CALL OBCS_ADJUST_UVICE( uice, vice, myThid )
# endif /* DISABLE_SEAICE_OBCS */
#endif /* ALLOW_OBCS */

#if ( defined ALLOW_AUTODIFF_TAMC &&  defined SEAICE_CGRID )
CADJ STORE uice  = comlev1, key=ikey_dynamics, kind=isbyte
CADJ STORE vice  = comlev1, key=ikey_dynamics, kind=isbyte
C     Note: Storing u/vice **after** seaice_dynsolver (and obcs_adjust_uvice)
C     has the effect that seaice_dynsolver is not called from seaice_model_ad
C     anymore. This is important because with the numerous tricks to avoid
C     complicated code in the backward integration (see pkg/autodiff),
C     the extra call would update the ice velocities with the wrong
C     set of flag values.
#endif

#ifdef ALLOW_THSICE
      IF ( useThSice ) THEN
#ifdef ALLOW_DEBUG
       IF (debugMode) CALL DEBUG_CALL( 'THSICE_DO_ADVECT', myThid )
#endif
       CALL THSICE_DO_ADVECT( 0, 0, myTime, myIter, myThid )
      ELSE
#endif /* ALLOW_THSICE */
C--   Only call advection of heff, area, snow, and salt and
C--   growth for the generic 0-layer thermodynamics of seaice
C--   if useThSice=.false., otherwise the 3-layer Winton thermodynamics
C--   (called from DO_OCEANIC_PHYSICS) take care of this
C NOW DO ADVECTION and DIFFUSION
       IF ( SEAICEadvHeff .OR. SEAICEadvArea .OR. SEAICEadvSnow
     &        .OR. SEAICEadvSalt ) THEN
#ifdef ALLOW_DEBUG
        IF (debugMode) CALL DEBUG_CALL( 'SEAICE_ADVDIFF', myThid )
#endif
C--   There always needs to be advection, even if neither B- or C-grid
C     dynamics are compiled.
#ifdef SEAICE_BGRID_DYNAMICS
        CALL SEAICE_ADVDIFF( uLoc, vLoc, myTime, myIter, myThid )
#else /* default C-grid advection */
        CALL SEAICE_ADVDIFF( uIce, vIce, myTime, myIter, myThid )
#endif
       ENDIF
#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE heff  = comlev1, key=ikey_dynamics, kind=isbyte
CADJ STORE area  = comlev1, key=ikey_dynamics, kind=isbyte
CADJ STORE hsnow = comlev1, key=ikey_dynamics, kind=isbyte
# ifdef SEAICE_VARIABLE_SALINITY
CADJ STORE hsalt = comlev1, key=ikey_dynamics, kind=isbyte
# endif
C     Note: This store has the effect that seaice_advdiff is not called
C     from seaice_model_ad anymore. Instead, the stored values are used.
#endif /* ALLOW_AUTODIFF_TAMC */

C     After advection, the sea ice variables may have unphysical values
C     e.g., < 0, that are regularized here. Concentration as a special case
C     may be > 1 in convergent motion and a ridging algorithm redistributes
C     the ice to limit the concentration to 1.
       CALL SEAICE_REG_RIDGE( myTime, myIter, myThid )

#ifdef ALLOW_EXF
       IF ( useEXF .AND. useDiagnostics ) THEN
C-    Fill-in EXF surface flux diags, weighted by open-ocean fraction
        grpDiag = -2
        IF ( usePW79thermodynamics ) grpDiag = 2
        CALL EXF_WEIGHT_SFX_DIAGS(
     I                  AREA, grpDiag, myTime, myIter, myThid )
       ENDIF
#endif /* ALLOW_EXF */

#ifdef DISABLE_SEAICE_GROWTH
       IF ( .TRUE. ) THEN
#else /* DISABLE_SEAICE_GROWTH */
C     thermodynamics growth
C     must call growth after calling advection
C     because of ugly time level business
       IF ( usePW79thermodynamics ) THEN
# ifdef SEAICE_USE_GROWTH_ADX
#  ifdef ALLOW_DEBUG
        IF (debugMode) CALL DEBUG_CALL( 'SEAICE_GROWTH_ADX', myThid )
#  endif
        CALL SEAICE_GROWTH_ADX( myTime, myIter, myThid )
# else /* SEAICE_USE_GROWTH_ADX */
#  ifdef ALLOW_DEBUG
        IF (debugMode) CALL DEBUG_CALL( 'SEAICE_GROWTH', myThid )
#  endif
        CALL SEAICE_GROWTH( myTime, myIter, myThid )
# endif /* SEAICE_USE_GROWTH_ADX */
       ELSE
#endif /* DISABLE_SEAICE_GROWTH */
        DO bj=myByLo(myThid),myByHi(myThid)
         DO bi=myBxLo(myThid),myBxHi(myThid)
          DO j=1,sNy
           DO i=1,sNx
            sIceLoad(i,j,bi,bj) = HEFF(i,j,bi,bj)*SEAICE_rhoIce
     &                         + HSNOW(i,j,bi,bj)*SEAICE_rhoSnow
           ENDDO
          ENDDO
c#ifdef SEAICE_CAP_ICELOAD
c         sIceTooHeavy = rhoConst*drF(1) / 5. _d 0
c         DO j=1,sNy
c          DO i=1,sNx
c           sIceLoad(i,j,bi,bj) = MIN( sIceLoad(i,j,bi,bj),
c    &                                 sIceTooHeavy )
c          ENDDO
c         ENDDO
c#endif
         ENDDO
        ENDDO
       ENDIF

#ifdef ALLOW_SITRACER
# ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE sitracer  = comlev1, key=ikey_dynamics, kind=isbyte
# endif
       CALL SEAICE_TRACER_PHYS ( myTime, myIter, myThid )
#endif

C--   Apply ice tracer open boundary conditions
#ifdef ALLOW_OBCS
# ifndef DISABLE_SEAICE_OBCS
       IF ( useOBCS ) CALL OBCS_APPLY_SEAICE( myThid )
# endif /* DISABLE_SEAICE_OBCS */
#endif /* ALLOW_OBCS */

C--   Update overlap regions for a bunch of stuff
       _EXCH_XY_RL( HEFF,  myThid )
       _EXCH_XY_RL( AREA,  myThid )
       _EXCH_XY_RL( HSNOW, myThid )
#ifdef SEAICE_ITD
       CALL EXCH_3D_RL( HEFFITD,  nITD, myThid )
       CALL EXCH_3D_RL( AREAITD,  nITD, myThid )
       CALL EXCH_3D_RL( HSNOWITD, nITD, myThid )
#endif
#ifdef SEAICE_VARIABLE_SALINITY
       _EXCH_XY_RL( HSALT, myThid )
#endif
#ifdef ALLOW_SITRACER
       DO iTr = 1, SItrNumInUse
        _EXCH_XY_RL( SItracer(1-OLx,1-OLy,1,1,iTr),myThid )
       ENDDO
#endif
       _EXCH_XY_RS(EmPmR, myThid )
       _EXCH_XY_RS(saltFlux, myThid )
       _EXCH_XY_RS(Qnet , myThid )
#ifdef SHORTWAVE_HEATING
       _EXCH_XY_RS(Qsw  , myThid )
#endif /* SHORTWAVE_HEATING */
#ifdef ATMOSPHERIC_LOADING
       IF ( useRealFreshWaterFlux )
     &      _EXCH_XY_RS( sIceLoad, myThid )
#endif

#ifdef ALLOW_OBCS
C--   In case we use scheme with a large stencil that extends into overlap:
C     no longer needed with the right masking in advection & diffusion S/R.
c      IF ( useOBCS ) THEN
c       DO bj=myByLo(myThid),myByHi(myThid)
c        DO bi=myBxLo(myThid),myBxHi(myThid)
c          CALL OBCS_COPY_TRACER( HEFF(1-OLx,1-OLy,bi,bj),
c    I                            1, bi, bj, myThid )
c          CALL OBCS_COPY_TRACER( AREA(1-OLx,1-OLy,bi,bj),
c    I                            1, bi, bj, myThid )
c          CALL OBCS_COPY_TRACER( HSNOW(1-OLx,1-OLy,bi,bj),
c    I                            1, bi, bj, myThid )
#ifdef SEAICE_VARIABLE_SALINITY
c          CALL OBCS_COPY_TRACER( HSALT(1-OLx,1-OLy,bi,bj),
c    I                            1, bi, bj, myThid )
#endif
c        ENDDO
c       ENDDO
c      ENDIF
#endif /* ALLOW_OBCS */

#ifdef ALLOW_DIAGNOSTICS
       IF ( useDiagnostics ) THEN
C     diagnostics for "non-state variables" that are modified by
C     the seaice model ...
        CALL DIAGNOSTICS_FILL_RS(EmPmR,'SIempmr ',0,1 ,0,1,1,myThid)
        CALL DIAGNOSTICS_FILL_RS(Qnet ,'SIqnet  ',0,1 ,0,1,1,myThid)
        CALL DIAGNOSTICS_FILL_RS(Qsw  ,'SIqsw   ',0,1 ,0,1,1,myThid)
C     ... and energy diagnostic
        IF ( diag_SIenph_isOn ) THEN
         recip_deltaTtherm = 1. _d 0 / SEAICE_deltaTtherm
         DO bj=myByLo(myThid),myByHi(myThid)
          DO bi=myBxLo(myThid),myBxHi(myThid)
           DO j=1,sNy
            DO i=1,sNx
             mTmp(i,j,bi,bj) = 0.25 _d 0 * (
     &              uIce (i,j,bi,bj)**2 + uIce (i+1,j,  bi,bj)**2
     &            + vIce (i,j,bi,bj)**2 + vIce (i,  j+1,bi,bj)**2 )
     &            * (SEAICE_rhoIce*HEFF(i,j,bi,bj)
     &            + addSnow*SEAICE_rhoSnow*HSNOW(i,j,bi,bj)
     &            - mTmp(i,j,bi,bj))
     &             *recip_deltaTtherm
            ENDDO
           ENDDO
          ENDDO
         ENDDO
         CALL DIAGNOSTICS_FILL(mTmp,'SIenph  ',0,1,0,1,1,myThid)
        ENDIF
       ENDIF
#endif /* ALLOW_DIAGNOSTICS */

#ifdef ALLOW_THSICE
C     endif .not.useThSice
      ENDIF
#endif /* ALLOW_THSICE */
CML   This has already been done in seaice_ocean_stress/ostres, so why repeat?
CML   CALL EXCH_UV_XY_RS(fu,fv,.TRUE.,myThid)

#ifdef ALLOW_EXF
# ifdef ALLOW_AUTODIFF
#  ifdef ALLOW_AUTODIFF_MONITOR
      CALL EXF_ADJOINT_SNAPSHOTS( 3, myTime, myIter, myThid )
#  endif
# endif
#endif

#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_LEAVE( 'SEAICE_MODEL', myThid )
#endif

      RETURN
      END

#include "SEAICE_OPTIONS.h"

CBOP
C     !ROUTINE: SEAICE_OCEAN_STRESS
C     !INTERFACE:
      SUBROUTINE SEAICE_OCEAN_STRESS(
     I                  windTauX, windTauY,
     I                  myTime, myIter, myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE SEAICE_OCEAN_STRESS                           |
C     | o Calculate ocean surface stresses                       |
C     |   - C-grid version                                       |
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "DYNVARS.h"
#include "GRID.h"
#include "FFIELDS.h"
#include "SEAICE_SIZE.h"
#include "SEAICE_PARAMS.h"
#include "SEAICE.h"

C     !INPUT/OUTPUT PARAMETERS:
C     windTauX :: X-direction wind stress over seaice at U point
C     windTauY :: Y-direction wind stress over seaice at V point
C     myTime   :: Current time in simulation
C     myIter   :: Current iteration number
C     myThid   :: my Thread Id number
      _RL     windTauX(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL     windTauY(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL     myTime
      INTEGER myIter
      INTEGER myThid

C     !LOCAL VARIABLES:
C     i,j,bi,bj :: Loop counters
C     kSrf      :: vertical index of surface layer
      INTEGER i, j, bi, bj
      INTEGER kSrf
      _RL  COSWAT
      _RS  SINWAT
      _RL  fuIceLoc, fvIceLoc
      _RL  areaW, areaS
CEOP

C     surrface level
      IF ( usingPCoords ) THEN
       kSrf = Nr
      ELSE
       kSrf = 1
      ENDIF
C     introduce turning angle (default is zero)
      SINWAT=SIN(SEAICE_waterTurnAngle*deg2rad)
      COSWAT=COS(SEAICE_waterTurnAngle*deg2rad)

      IF ( useHB87StressCoupling ) THEN
C
C     use an intergral over ice and ocean surface layer to define
C     surface stresses on ocean following Hibler and Bryan (1987, JPO)
C
       DO bj=myByLo(myThid),myByHi(myThid)
        DO bi=myBxLo(myThid),myBxHi(myThid)
         DO J=1,sNy
          DO I=1,sNx
C     average wind stress over ice and ocean and apply averaged wind
C     stress and internal ice stresses to surface layer of ocean
           areaW = 0.5 * (AREA(I,J,bi,bj) + AREA(I-1,J,bi,bj))
     &          * SEAICEstressFactor
           fu(I,J,bi,bj)=(ONE-areaW)*fu(I,J,bi,bj)
     &          + areaW*windTauX(I,J,bi,bj)
#ifdef SEAICE_CGRID
     &          + stressDivergenceX(I,J,bi,bj) * SEAICEstressFactor
#endif
          ENDDO
         ENDDO
C     This loop separation makes the adjoint code vectorize
         DO J=1,sNy
          DO I=1,sNx
           areaS = 0.5 * (AREA(I,J,bi,bj) + AREA(I,J-1,bi,bj))
     &          * SEAICEstressFactor
           fv(I,J,bi,bj)=(ONE-areaS)*fv(I,J,bi,bj)
     &          + areaS*windTauY(I,J,bi,bj)
#ifdef SEAICE_CGRID
     &          + stressDivergenceY(I,J,bi,bj) * SEAICEstressFactor
#endif
          ENDDO
         ENDDO
        ENDDO
       ENDDO

      ELSE
C     else: useHB87StressCoupling=F

C--   Compute ice-affected wind stress (interpolate to U/V-points)
C     by averaging wind stress and ice-ocean stress according to
C     ice cover
      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        DO j=1,sNy
         DO i=1,sNx
          fuIceLoc=HALF*( DWATN(I,J,bi,bj)+DWATN(I-1,J,bi,bj) )*
     &         COSWAT *
     &         ( uIce(I,J,bi,bj)-uVel(I,J,kSrf,bi,bj) )
     &         - SIGN(SINWAT, _fCori(I,J,bi,bj)) * 0.5 _d 0 *
     &         ( DWATN(I  ,J,bi,bj) *
     &         0.5 _d 0*(vIce(I  ,J  ,bi,bj)-vVel(I  ,J  ,kSrf,bi,bj)
     &                  +vIce(I  ,J+1,bi,bj)-vVel(I  ,J+1,kSrf,bi,bj))
     &         + DWATN(I-1,J,bi,bj) *
     &         0.5 _d 0*(vIce(I-1,J  ,bi,bj)-vVel(I-1,J  ,kSrf,bi,bj)
     &                  +vIce(I-1,J+1,bi,bj)-vVel(I-1,J+1,kSrf,bi,bj))
     &         )
          fvIceLoc=HALF*( DWATN(I,J,bi,bj)+DWATN(I,J-1,bi,bj) )*
     &         COSWAT *
     &         ( vIce(I,J,bi,bj)-vVel(I,J,kSrf,bi,bj) )
     &         + SIGN(SINWAT,  _fCori(I,J,bi,bj)) * 0.5 _d 0 *
     &         ( DWATN(I,J  ,bi,bj) *
     &         0.5 _d 0*(uIce(I  ,J  ,bi,bj)-uVel(I  ,J  ,kSrf,bi,bj)
     &                  +uIce(I+1,J  ,bi,bj)-uVel(I+1,J  ,kSrf,bi,bj))
     &         + DWATN(I,J-1,bi,bj) *
     &         0.5 _d 0*(uIce(I  ,J-1,bi,bj)-uVel(I  ,J-1,kSrf,bi,bj)
     &                  +uIce(I+1,J-1,bi,bj)-uVel(I+1,J-1,kSrf,bi,bj))
     &         )
          areaW = 0.5 _d 0 * (AREA(I,J,bi,bj) + AREA(I-1,J,bi,bj))
     &         * SEAICEstressFactor
          areaS = 0.5 _d 0 * (AREA(I,J,bi,bj) + AREA(I,J-1,bi,bj))
     &         * SEAICEstressFactor
          fu(I,J,bi,bj)=(ONE-areaW)*fu(I,J,bi,bj)+areaW*fuIceLoc
          fv(I,J,bi,bj)=(ONE-areaS)*fv(I,J,bi,bj)+areaS*fvIceLoc
         ENDDO
        ENDDO
       ENDDO
      ENDDO
      ENDIF
      CALL EXCH_UV_XY_RS(fu, fv, .TRUE., myThid)

      RETURN
      END

#include "AIM_OPTIONS.h"

CBOP
C     !ROUTINE: AIM_DIAGNOSTICS_INIT
C     !INTERFACE:
      SUBROUTINE AIM_DIAGNOSTICS_INIT( myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE AIM_DIAGNOSTICS_INIT
C     | o Routine to initialize list of all available diagnostics
C     |   for AIM package
C     *==========================================================*
C     \ev
C     !USES:
      IMPLICIT NONE

C     === Global variables ===
#include "EEPARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
C     myThid ::  my Thread Id number
      INTEGER myThid
CEOP

#ifdef ALLOW_DIAGNOSTICS
C     !LOCAL VARIABLES:
C     === Local variables ===
C     diagNum   :: diagnostics number in the (long) list of available diag.
C     diagMate  :: diag. mate number in the (long) list of available diag.
C     diagName  :: local short name (8c) of a diagnostics
C     diagCode  :: local parser field with characteristics of the diagnostics
C              cf head of S/R DIAGNOSTICS_INIT_EARLY or DIAGNOSTICS_MAIN_INIT
C     diagUnits :: local string (16c): physical units of a diagnostic field
C     diagTitle :: local string (80c): description of field in diagnostic
      INTEGER       diagNum
      INTEGER       diagMate
      CHARACTER*8   diagName
      CHARACTER*16  diagCode
      CHARACTER*16  diagUnits
      CHARACTER*(80) diagTitle

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      diagName  = 'DIABT   '
      diagTitle =
     &  'Pot. Temp.  Tendency (Mass-Weighted) from Diabatic Processes'
      diagUnits = 'K/s             '
      diagCode  = 'SMr     MR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I            diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'DIABQ   '
      diagTitle =
     &  'Spec.Humid. Tendency (Mass-Weighted) from Diabatic Processes'
      diagUnits = 'g/kg/s          '
      diagCode  = 'SMr     MR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I            diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'RADSW   '
      diagTitle =
     &  'Temperature Tendency due to Shortwave Radiation (TT_RSW)'
      diagUnits = 'K/s             '
      diagCode  = 'SM      ML      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I            diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'RADLW   '
      diagTitle =
     &  'Temperature Tendency due to Longwave  Radiation (TT_RLW)'
      diagUnits = 'K/s             '
      diagCode  = 'SM      ML      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I            diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'DTCONV  '
      diagTitle = 'Temperature Tendency due to Convection (TT_CNV)'
      diagUnits = 'K/s             '
      diagCode  = 'SM      ML      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I            diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'TURBT   '
      diagTitle =
     &  'Temperature Tendency due to Turbulence in PBL (TT_PBL)'
      diagUnits = 'K/s             '
      diagCode  = 'SM      ML      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I            diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'DTLS    '
      diagTitle =
     &  'Temperature Tendency due to Large-scale condens. (TT_LSC)'
      diagUnits = 'K/s             '
      diagCode  = 'SM      ML      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I            diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'DQCONV  '
      diagTitle = 'Spec. Humidity Tendency due to Convection (QT_CNV)'
      diagUnits = 'g/kg/s          '
      diagCode  = 'SM      MR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I            diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'TURBQ   '
      diagTitle =
     &  'Spec. Humidity Tendency due to Turbulence in PBL (QT_PBL)'
      diagUnits = 'g/kg/s          '
      diagCode  = 'SM      ML      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I            diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'DQLS    '
      diagTitle =
     &  'Spec. Humidity Tendency due to Large-Scale Condens. (QT_LSC)'
      diagUnits = 'g/kg/s          '
      diagCode  = 'SM      ML      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I            diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'RELHUM  '
      diagTitle = 'Relative Humidity (fraction)'
      diagUnits = '0-1             '
      diagCode  = 'SMR     MR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I            diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'TSR     '
      diagTitle = 'Top-of-atm. net Shortwave Radiation (+=dw)'
      diagUnits = 'W/m^2           '
      diagCode  = 'SM P    U1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I            diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'OLR     '
      diagTitle = 'Outgoing Longwave  Radiation (+=up)'
      diagUnits = 'W/m^2           '
      diagCode  = 'SM P    U1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I            diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'RADSWG  '
      diagTitle = 'Net Shortwave Radiation at the Ground (+=dw)'
      diagUnits = 'W/m^2           '
      diagCode  = 'SM P    L1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I            diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'RADLWG  '
      diagTitle = 'Net Longwave  Radiation at the Ground (+=up)'
      diagUnits = 'W/m^2           '
      diagCode  = 'SM      L1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I            diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'HFLUX   '
      diagTitle = 'Sensible Heat Flux (+=up)'
      diagUnits = 'W/m^2           '
      diagCode  = 'SM      L1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I            diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'EVAP    '
      diagTitle = 'Surface Evaporation (g/m2/s)'
      diagUnits = 'g/m^2/s         '
      diagCode  = 'SM      L1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I            diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'PRECON  '
      diagTitle = 'Convective  Precipitation (g/m2/s)'
      diagUnits = 'g/m^2/s         '
      diagCode  = 'SM P    L1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I            diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'PRECLS  '
      diagTitle = 'Large Scale Precipitation (g/m2/s)'
      diagUnits = 'g/m^2/s         '
      diagCode  = 'SM      M1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I            diagName, diagCode, diagUnits, diagTitle, 0, myThid )

#ifdef ALLOW_CLOUD_3D
      diagName  = 'CLDCLW  '
      diagTitle = 'Local Cloud Fraction (0-1)'
      diagUnits = '0-1             '
      diagCode  = 'SM P    ML      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I            diagName, diagCode, diagUnits, diagTitle, 0, myThid )
#endif

      diagName  = 'CLDFRC  '
      diagTitle = 'Total Cloud Fraction (0-1)'
      diagUnits = '0-1             '
      diagCode  = 'SM P    M1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I            diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'CLDPRS  '
      diagTitle = 'Cloud Top Pressure (normalized)'
      diagUnits = '0-1             '
      diagCode  = 'SM PC   M1      '
      diagMate  = diagNum
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

      diagName  = 'CLDMAS  '
      diagTitle = 'Cloud-base Mass Flux  (kg/m^2/s)'
      diagUnits = 'kg/m^2/s        '
      diagCode  = 'SM P    L1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I            diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'DRAG    '
      diagTitle = 'Surface Drag Coefficient (kg/m^2/s)'
      diagUnits = 'kg/m^2/s        '
      diagCode  = 'SM P    L1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I            diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'WINDS   '
      diagTitle = 'Surface Wind Speed  (m/s)'
      diagUnits = 'm/s             '
      diagCode  = 'SM P    L1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I            diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'TS      '
      diagTitle = 'near Surface Air Temperature  (K)'
      diagUnits = 'K               '
      diagCode  = 'SM      L1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I            diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'QS      '
      diagTitle = 'near Surface Specific Humidity  (g/kg)'
      diagUnits = 'g/kg            '
      diagCode  = 'SM P    L1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I            diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'ENPREC  '
      diagTitle ='Energy flux associated with precip. (snow, rain Temp)'
      diagUnits = 'W/m^2           '
      diagCode  = 'SM      M1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I            diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'ALBVISDF'
      diagTitle = 'Surface Albedo (Visible band) (0-1)'
      diagUnits = '0-1             '
      diagCode  = 'SM P    L1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I            diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'DWNLWG  '
      diagTitle =
     &   'Downward Component of Longwave Flux at the Ground (+=dw)'
      diagUnits = 'W/m^2           '
      diagCode  = 'SM P    L1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I            diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'UPSWG   '
      diagTitle =
     &   'Upward Shortwave Flux at the Ground (+=up)'
      diagUnits = 'W/m^2           '
      diagCode  = 'SM P    L1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I            diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'SWCLR   '
      diagTitle = 'Clear Sky Temp. Tendency due to Shortwave Radiation'
      diagUnits = 'K/s             '
      diagCode  = 'SM      ML      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I            diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'LWCLR   '
      diagTitle = 'Clear Sky Temp. Tendency due to Longwave  Radiation'
      diagUnits = 'K/s             '
      diagCode  = 'SM      ML      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I            diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'TSRCLR  '
      diagTitle = 'Clear Sky Top-of-atm. net Shortwave Radiation (+=dw)'
      diagUnits = 'W/m^2           '
      diagCode  = 'SM P    U1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I            diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'OLRCLR  '
      diagTitle = 'Clear Sky Outgoing Longwave  Radiation  (+=up)'
      diagUnits = 'W/m^2           '
      diagCode  = 'SM P    U1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I            diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'SWGCLR  '
      diagTitle =
     &    'Clear Sky Net Shortwave Radiation at the Ground (+=dw)'
      diagUnits = 'W/m^2           '
      diagCode  = 'SM P    L1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I            diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'LWGCLR  '
      diagTitle =
     &    'Clear Sky Net Longwave  Radiation at the Ground (+=up)'
      diagUnits = 'W/m^2           '
      diagCode  = 'SM      L1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I            diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'UPSWGclr'
      diagTitle =
     &   'Upward Shortwave Flux at the Ground (+=up)'
      diagUnits = 'W/m^2           '
      diagCode  = 'SM P    L1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I            diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'UFLUX   '
      diagTitle = 'Zonal Wind Surface Stress  (N/m^2)'
      diagUnits = 'N/m^2           '
      diagCode  = 'UU      L1      '
      diagMate  = diagNum + 2
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

      diagName  = 'VFLUX   '
      diagTitle = 'Meridional Wind Surface Stress  (N/m^2)'
      diagUnits = 'N/m^2           '
      diagCode  = 'VV      L1      '
      diagMate  = diagNum
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

      diagName  = 'dKE_Ustr'
      diagTitle =
     &    'KE sink due to Zonal Surf. Stress and Strat. drag (<0)'
      diagUnits = 'W/m^2           '
      diagCode  = 'SU      L1      '
      diagMate  = diagNum + 2
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

      diagName  = 'dKE_Vstr'
      diagTitle =
     &    'KE sink due to Merid. Surf. Stress and Strat. drag (<0)'
      diagUnits = 'W/m^2           '
      diagCode  = 'SV      L1      '
      diagMate  = diagNum
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

      diagName  = 'DTSIMPL '
      diagTitle = 'Surf. Temp Change after 1 implicit time step'
      diagUnits = 'K               '
      diagCode  = 'SM P    L1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I            diagName, diagCode, diagUnits, diagTitle, 0, myThid )

#ifdef ALLOW_AIM_CO2
      diagName  = 'aim_pCO2'
      diagTitle = 'Atmospheric CO2'
      diagUnits = 'ppm             '
      diagCode  = 'SM P    L1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I            diagName, diagCode, diagUnits, diagTitle, 0, myThid )
#endif

cdfer
      diagName  = 'FSOL    '
      diagTitle = 'Incoming Solar radiation'
      diagUnits = 'W/m^2           '
      diagCode  = 'SM P    L1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I            diagName, diagCode, diagUnits, diagTitle, 0, myThid )
cdfer

#endif /* ALLOW_DIAGNOSTICS */

      RETURN
      END

#include "MY82_OPTIONS.h"

CBOP
C !ROUTINE: MY82_CALC

C !INTERFACE: ======================================================
      subroutine MY82_CALC(
     I                bi, bj, sigmaR, myTime, myIter, myThid )

C !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE MY82_CALC                                     |
C     | o Compute all MY82 fields defined in MY82.h              |
C     *==========================================================*
C     | This subroutine is based on SPEM code                    |
C     *==========================================================*
      IMPLICIT NONE
C
C--------------------------------------------------------------------

C global parameters updated by pp_calc
C     MYviscAz  :: MY82 eddy viscosity coefficient              (m^2/s)
C     MYdiffKzT :: MY82 diffusion coefficient for temperature   (m^2/s)
C
C \ev

C !USES: ============================================================
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "MY82.h"
#ifdef ALLOW_3D_DIFFKR
# include "DYNVARS.h"
#endif

C !INPUT PARAMETERS: ===================================================
C Routine arguments
C     bi, bj :: Current tile indices
C     sigmaR :: Vertical gradient of iso-neutral density
C     myTime :: Current time in simulation
C     myIter :: Current time-step number
C     myThid :: My Thread Id number
      INTEGER bi, bj
      _RL     sigmaR(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL     myTime
      INTEGER myIter
      INTEGER myThid

C !LOCAL VARIABLES: ====================================================
c Local constants
C     imin, imax, jmin, jmax  - array computation indices
C     RiNumber - Richardson Number = -GH/GM
C     GH       - buoyancy freqency after call to Ri_number, later
C                GH of M. Satoh, Eq. (11.3.45)
C     GM       - vertical shear of velocity after call Ri_number,
C                later GM of M. Satoh, Eq. (11.3.44)
      INTEGER I, J, K
      INTEGER   iMin ,iMax ,jMin ,jMax
      _RL     RiFlux, RiTmp
      _RL     SHtmp, bTmp, tkesquare, tkel
      _RL     RiNumber(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL     GH(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL     GM(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL     SH(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL     SM(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL     tke(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
CEOP
      iMin = 2-OLx
      iMax = sNx+OLx-1
      jMin = 2-OLy
      jMax = sNy+OLy-1

C     Initialize local fields
      DO J=1-OLy,sNy+OLy
       DO I=1-OLx,sNx+OLx
        GH(I,J) = 0. _d 0
        GM(I,J) = 0. _d 0
       ENDDO
      ENDDO
      DO K = 1, Nr
       DO J=1-OLy,sNy+OLy
        DO I=1-OLx,sNx+OLx
         SH(I,J,K)  = 0. _d 0
         SM(I,J,K)  = 0. _d 0
         tke(I,J,K) = 0. _d 0
        ENDDO
       ENDDO
      ENDDO
C     first k-loop
C     compute turbulent kinetic energy from richardson number
      DO K = 2, Nr
       CALL MY82_RI_NUMBER(
     I      bi, bj, K, iMin, iMax, jMin, jMax,
     O      RiNumber, GH, GM,
     I      myTime, myThid )
       DO J=jMin,jMax
        DO I=iMin,iMax
         RiTmp  = MIN(RiNumber(I,J),RiMax)
         btmp   = beta1+beta4*RiTmp
C     M. Satoh, Atmospheric Circulation Dynamics and General
C     Circulation models, Springer, 2004: Eq. (11.3.60)
         RiFlux =( btmp - SQRT(btmp*btmp - 4. _d 0 *beta2*beta3*RiTmp) )
     &        /(2. _d 0*beta2)
C     M. Satoh: Eq. (11.3.58)
         SHtmp       = (alpha1-alpha2*RiFlux)/(1. _d 0-RiFlux)
         SH(I,J,K)   = SHtmp
         SM(I,J,K)   = SHtmp*(beta1-beta2*RiFlux)/(beta3-beta4*RiFlux)
C     M. Satoh: Eq. (11.3.53/55)
         tkesquare = MAX( 0. _d 0,
     &        b1*(SH(I,J,K)*GH(I,J) + SM(I,J,K)*GM(I,J)) )
         tke(I,J,K) = sqrt(tkesquare)
CML         if ( k.eq.2 .and. i.ge.1 .and. i.le.sNx .and. j.eq.1)
CML     &   print '(A,3I3,8E13.5)', 'ml-my82', I,J,K, RiNumber(I,J),
CML     &        RiTmp,RiFlux,
CML     &      SH(I,J,K), SM(I,J,K), GH(I,J), GM(I,J), tke(I,J,K)
        ENDDO
       ENDDO
C     end of first k-loop
      ENDDO

C     re-initilialize GM and GH for abuse, they no longer have
C     the meaning of shear and negative  buoyancy frequency
      DO J=jMin,jMax
       DO I=iMin,iMax
        GH(I,J) = 0. _d 0
        GM(I,J) = 0. _d 0
       ENDDO
      ENDDO
C     Find boundary length scale from energy weighted mean.
C     This is something like "center of mass" of the vertical
C     tke-distribution
C     begin second k-loop
      DO K = 2, Nr
       DO J=jMin,jMax
        DO I=iMin,iMax
         GM(I,J) = GM(I,J) + tke(I,J,K)*rF(K)
         GH(I,J) = GH(I,J) + tke(I,J,K)
        ENDDO
       ENDDO
C     end of second k-loop
      END DO
C     compute boundary length scale MYhbl
      DO J=jMin,jMax
       DO I=iMin,iMax
        IF ( GH(I,J) .EQ. 0. _d 0 ) THEN
         MYhbl(I,J,bi,bj) = 0. _d 0
        ELSE
         MYhbl(I,J,bi,bj) = -GM(I,J)/GH(I,J)*MYhblScale
        ENDIF
       ENDDO
      ENDDO
C     begin third k-loop
      DO K = 1, Nr
C     integrate tke to find integral length scale
       DO J=jMin,jMax
        DO I=iMin,iMax
         tkel = MYhbl(I,J,bi,bj)*tke(I,J,K)
C     M. Satoh: Eq. (11.3.43)
         MYviscAr(I,J,K,bi,bj) = MYhbl(I,J,bi,bj)*tkel*SM(I,J,K)
         MYdiffKr(I,J,K,bi,bj) = MYhbl(I,J,bi,bj)*tkel*SH(I,J,K)
C     Set a minium (= background) value
         MYviscAr(I,J,K,bi,bj) = MAX(MYviscAr(I,J,K,bi,bj),
     &                               viscArnr(k) )
         MYdiffKr(I,J,K,bi,bj) = MAX(MYdiffKr(I,J,K,bi,bj),
#ifdef ALLOW_3D_DIFFKR
     &                               diffKr(i,j,k,bi,bj) )
#else
     &                               diffKrNrS(k) )
#endif
C     Set a maximum and mask land point
         MYviscAr(I,J,K,bi,bj) = MIN(MYviscAr(I,J,K,bi,bj),MYviscMax)
     &        * maskC(I,J,K,bi,bj)
         MYdiffKr(I,J,K,bi,bj) = MIN(MYdiffKr(I,J,K,bi,bj),MYdiffMax)
     &        * maskC(I,J,K,bi,bj)
        ENDDO
       ENDDO
C     end third k-loop
      ENDDO

#ifdef ALLOW_DIAGNOSTICS
      IF ( useDiagnostics ) THEN
       CALL DIAGNOSTICS_FILL(MYviscAr,'MYVISCAR',0,Nr,1,bi,bj,myThid)
       CALL DIAGNOSTICS_FILL(MYdiffKr,'MYDIFFKR',0,Nr,1,bi,bj,myThid)
       CALL DIAGNOSTICS_FILL(MYhbl   ,'MYHBL   ',0,1 ,1,bi,bj,myThid)
      ENDIF
#endif /* ALLOW_DIAGNOSTICS */

      RETURN
      END

#include "CPP_EEOPTIONS.h"

C--  File fool_the_compiler.F: Routines to prevent compiler to skip pieces of code
C--   Contents
C--   o FOOL_THE_COMPILER
C--   o FOOL_THE_COMPILER_R8
C--   o FOOL_THE_COMPILER_RL

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP

C      !ROUTINE: FOOL_THE_COMPILER

C      !INTERFACE:
       SUBROUTINE FOOL_THE_COMPILER( foolishArg )
C      !DESCRIPTION:
C      *=================================================================*
C      | SUBROUTINE FOOL\_THE\_COMPILER
C      | o Dummy routine used to supress compiler behavior.
C      *=================================================================*
C      | Routine is used to stop compiler optimizations in which global
C      | data is held in a register while it is updated by a separate
C      | thread. Calling this routine introduces the possibility of side
C      | effects on global data ensuring that memory locs. are reread.
C      *=================================================================*
       IMPLICIT NONE
CEOP
       INTEGER foolishArg
       RETURN
       END
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP

C      !ROUTINE: FOOL_THE_COMPILER_R8

C      !INTERFACE:
       SUBROUTINE FOOL_THE_COMPILER_R8( foolishArg )
C      !DESCRIPTION:
C      *=================================================================*
C      | SUBROUTINE FOOL\_THE\_COMPILER\_R8
C      | o Dummy routine used to supress compiler behavior.
C      *=================================================================*
C      | Routine is used to stop compiler optimizations in which global
C      | data is held in a register while it is updated by a separate
C      | thread. Calling this routine introduces the possibility of side
C      | effects on global data ensuring that memory locs. are reread.
C      *=================================================================*
       IMPLICIT NONE
CEOP
       Real*8 foolishArg
       RETURN
       END
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP

C      !ROUTINE: FOOL_THE_COMPILER_RL

C      !INTERFACE:
       SUBROUTINE FOOL_THE_COMPILER_RL( foolishArg )
C      !DESCRIPTION:
C      *=================================================================*
C      | SUBROUTINE FOOL\_THE\_COMPILER\_RL
C      | o Dummy routine used to supress compiler behavior.
C      *=================================================================*
C      | Routine is used to stop compiler optimizations in which global
C      | data is held in a register while it is updated by a separate
C      | thread. Calling this routine introduces the possibility of side
C      | effects on global data ensuring that memory locs. are reread.
C      *=================================================================*
       IMPLICIT NONE
CEOP
       _RL    foolishArg
       RETURN
       END

#include "EXF_OPTIONS.h"

CBOP
C !ROUTINE: EXF_RADIATION

C !INTERFACE: ==========================================================
      SUBROUTINE EXF_RADIATION( exf_Tsf, myTime, myIter, myThid )

C !DESCRIPTION:
C Set radiative fluxes at the surface
C
C - Use atmospheric state to compute surface fluxes.
C - Compute net from downward and downward from net longwave and
C   shortwave radiation, IF needed.
C   lwflux = Stefan-Boltzmann constant * emissivity * SST - lwdown
C   swflux = - ( 1 - albedo ) * swdown

C !USES:
      IMPLICIT NONE
C == Global variables ==
#include "EEPARAMS.h"
#include "SIZE.h"
#include "PARAMS.h"
#include "GRID.h"
#include "EXF_PARAM.h"
#include "EXF_FIELDS.h"
#include "EXF_CONSTANTS.h"

C !INPUT PARAMETERS:
C myTime  :: Current time in simulation
C myIter  :: Current iteration number in simulation
C myThid  :: My Thread Id number
C exf_Tsf :: local copy of global field gcmSST or extrapolated
C            surface temperature (in deg Celsius)
      _RL     myTime
      INTEGER myIter
      INTEGER myThid
      _RL exf_Tsf(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)

#ifdef ALLOW_DOWNWARD_RADIATION
C !LOCAL VARIABLES: ====================================================
C bi,bj     :: Tile indices
C kl,ks    :: loop indices
      INTEGER bi,bj
      INTEGER i,j
#ifdef ALLOW_ATM_TEMP
c     INTEGER ks
      INTEGER kl
#endif
CEOP

#ifdef ALLOW_ATM_TEMP
c     ks = 1
      kl = 2
      IF ( usingPCoords ) THEN
c      ks = Nr
       kl = Nr-1
      ENDIF

      IF ( lwfluxfile .EQ. ' ' .AND. lwdownfile .NE. ' ' ) THEN
C     Loop over tiles.
       DO bj = myByLo(myThid),myByHi(myThid)
        DO bi = myBxLo(myThid),myBxHi(myThid)

         DO j = 1,sNy
          DO i = 1,sNx
           lwflux(i,j,bi,bj) =
     &          ocean_emissivity*stefanBoltzmann*
     &          exf_Tsf(i,j,bi,bj)**4
     &          - lwdown(i,j,bi,bj)
#ifdef EXF_LWDOWN_WITH_EMISSIVITY
     &          *ocean_emissivity
C     the lw exitance (= out-going long wave radiation) is
C     emissivity*stefanBoltzmann*T^4 + rho*lwdown, where the
C     reflectivity rho = 1-emissivity for conservation reasons:
C     the sum of emissivity, reflectivity, and transmissivity must be
C     one, and transmissivity is zero in our case (long wave radiation
C     does not penetrate the ocean surface)
#endif /* EXF_LWDOWN_WITH_EMISSIVITY */
          ENDDO
         ENDDO

C--   end bi,bj loops
        ENDDO
       ENDDO
      ENDIF

C-jmc: commented out: no need to compute Downward-LW (not used) from Net-LW
c     IF ( lwfluxfile .NE. ' ' .AND. lwdownfile .EQ. ' ' ) THEN
C     Loop over tiles.
c      DO bj = myByLo(myThid),myByHi(myThid)
c       DO bi = myBxLo(myThid),myBxHi(myThid)
c        DO j = 1,sNy
c         DO i = 1,sNx
c          lwdown(i,j,bi,bj) =
c    &          ocean_emissivity*stefanBoltzmann*
c    &          ((gcmSST(i,j,bi,bj)+cen2kel)**4)
c    &          - lwflux(i,j,bi,bj)
c         ENDDO
c        ENDDO
c       ENDDO
c      ENDDO
c     ENDIF
#endif /* ALLOW_ATM_TEMP */

#if defined(ALLOW_ATM_TEMP) || defined(SHORTWAVE_HEATING)
      IF ( swfluxfile .EQ. ' ' .AND. swdownfile .NE. ' ' ) THEN
#ifdef ALLOW_ZENITHANGLE
      IF ( useExfZenAlbedo .OR. useExfZenIncoming ) THEN
       CALL EXF_ZENITHANGLE(myTime, myIter, myThid)
#ifdef ALLOW_AUTODIFF
      ELSE
       DO bj = myByLo(myThid),myByHi(myThid)
        DO bi = myBxLo(myThid),myBxHi(myThid)
         DO j = 1,sNy
          DO i = 1,sNx
           zen_albedo (i,j,bi,bj) = 0. _d 0
           zen_fsol_diurnal (i,j,bi,bj) = 0. _d 0
           zen_fsol_daily (i,j,bi,bj) = 0. _d 0
          ENDDO
         ENDDO
        ENDDO
       ENDDO
#endif
      ENDIF
#endif /* ALLOW_ZENITHANGLE */
       DO bj = myByLo(myThid),myByHi(myThid)
        DO bi = myBxLo(myThid),myBxHi(myThid)
#ifdef ALLOW_ZENITHANGLE
         IF ( useExfZenAlbedo ) THEN
          DO j = 1,sNy
           DO i = 1,sNx
            swflux(i,j,bi,bj) = - swdown(i,j,bi,bj)
     &                        * (1.0-zen_albedo(i,j,bi,bj))
           ENDDO
          ENDDO
         ELSE
#endif /* ALLOW_ZENITHANGLE */
          DO j = 1,sNy
           DO i = 1,sNx
            swflux(i,j,bi,bj) = - swdown(i,j,bi,bj)
     &                        * (1.0-exf_albedo)
           ENDDO
          ENDDO
#ifdef ALLOW_ZENITHANGLE
         ENDIF
#endif
        ENDDO
       ENDDO
      ENDIF
C-jmc: commented out: no need to compute Downward-SW (not used) from Net-SW
c     IF ( swfluxfile .NE. ' ' .AND. swdownfile .EQ. ' ' ) THEN
c      DO bj = myByLo(myThid),myByHi(myThid)
c       DO bi = myBxLo(myThid),myBxHi(myThid)
c        DO j = 1,sNy
c         DO i = 1,sNx
c          swdown(i,j,bi,bj) = -swflux(i,j,bi,bj) / (1.0-exf_albedo)
c         ENDDO
c        ENDDO
c       ENDDO
c      ENDDO
c     ENDIF
#endif /* ALLOW_ATM_TEMP or SHORTWAVE_HEATING */

#endif /* ALLOW_DOWNWARD_RADIATION */

      RETURN
      END

#include "PACKAGES_CONFIG.h"
#include "CPP_OPTIONS.h"
#ifdef ALLOW_AUTODIFF
# include "AUTODIFF_OPTIONS.h"
#endif
#ifdef ALLOW_CTRL
# include "CTRL_OPTIONS.h"
#endif

CML THIS DOES NOT WORK +++++
#undef ALLOW_LOOP_DIRECTIVE
CBOP
C     !ROUTINE: CG2D_NSA
C     !INTERFACE:
      SUBROUTINE CG2D_NSA(
     U                cg2d_b, cg2d_x,
     O                firstResidual, minResidualSq, lastResidual,
     U                numIters, nIterMin,
     I                myThid )
C     !DESCRIPTION: \bv
C     *================================================================*
C     | SUBROUTINE CG2D_NSA
C     | o Two-dimensional grid problem conjugate-gradient inverter
C     |   (with preconditioner).
C     | o This version is used only in the case when the matrix
C     |   operator is Not "Self-Adjoint" (NSA). Any remaining residuals
C     |   will be immediately reported to the National Security Agency
C     *================================================================*
C     | Con. grad is an iterative procedure for solving Ax = b.
C     | It requires the A be symmetric.
C     | This implementation assumes A is a five-diagonal matrix
C     | of the form that arises in the discrete representation of
C     | the del^2 operator in a two-dimensional space.
C     *================================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     === Global data ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "CG2D.h"
#ifdef ALLOW_AUTODIFF_TAMC
# include "tamc.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     cg2d_b    :: The source term or "right hand side" (Output: normalised RHS)
C     cg2d_x    :: The solution (Input: first guess)
C     firstResidual :: the initial residual before any iterations
C     minResidualSq :: the lowest residual reached (squared)
C     lastResidual  :: the actual residual reached
C     numIters  :: Inp: the maximum number of iterations allowed
C                  Out: the actual number of iterations used
C     nIterMin  :: Inp: decide to store (if >=0) or not (if <0) lowest res. sol.
C                  Out: iteration number corresponding to lowest residual
C     myThid    :: my Thread Id number
      _RL  cg2d_b(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL  cg2d_x(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL  firstResidual
      _RL  minResidualSq
      _RL  lastResidual
      INTEGER numIters
      INTEGER nIterMin
      INTEGER myThid

#ifdef ALLOW_CG2D_NSA
C     !LOCAL VARIABLES:
C     bi, bj     :: tile index in X and Y.
C     i, j, it2d :: Loop counters ( it2d counts CG iterations )
C     actualIts  :: actual CG iteration number
C     err_sq     :: Measure of the square of the residual of Ax - b.
C     eta_qrN    :: Used in computing search directions; suffix N and NM1
C     eta_qrNM1     denote current and previous iterations respectively.
C     recip_eta_qrNM1 :: reciprocal of eta_qrNM1
C     cgBeta     :: coeff used to update conjugate direction vector "s".
C     alpha      :: coeff used to update solution & residual
C     alphaSum   :: to avoid the statement: alpha = 1./alpha (for TAF)
C     sumRHS     :: Sum of right-hand-side. Sometimes this is a useful
C                   debugging/trouble shooting diagnostic. For neumann problems
C                   sumRHS needs to be ~0 or it converge at a non-zero residual.
C     msgBuf     :: Informational/error message buffer
C--   local working array (used to be in CG2D.h common block:
C     cg2d_q     :: Intermediate matrix-vector product term
C     cg2d_r     ::   *same*
C     cg2d_s     ::   *same*
C     cg2d_z     :: Intermediate matrix-vector product term
C                :: reduces the number of recomputation in adjoint mode
C                :: this field is superfluous if your cg2d is self-adjoint.
      INTEGER bi, bj
      INTEGER i, j, it2d
      INTEGER actualIts
#ifdef ALLOW_AUTODIFF_TAMC
C     ikey       :: tape key (depends on iteration it2d)
      INTEGER ikey
#else
      _RL    rhsNorm
#endif
      _RL    err_sq,  errTile(nSx,nSy)
      _RL    eta_qrN, eta_qrNtile(nSx,nSy)
      _RL    eta_qrNM1, recip_eta_qrNM1
      _RL    cgBeta,  alpha
      _RL    alphaSum,alphaTile(nSx,nSy)
      _RL    sumRHS,  sumRHStile(nSx,nSy)
      _RL    rhsMax
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      LOGICAL printResidual
      _RL    cg2d_z(1:sNx,1:sNy,nSx,nSy)
      _RL    cg2d_q(1:sNx,1:sNy,nSx,nSy)
C     Fields cg2d_r and ct2d_s are exchanged and since there are no AD-exchanges
C     for fields with smaller overlap, they are defined with full overlap size
      _RL    cg2d_r(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL    cg2d_s(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
CEOP

#ifdef ALLOW_AUTODIFF_TAMC
      IF ( numIters .GT. numItersMax ) THEN
        WRITE(msgBuf,'(A,I10)')
     &    'CG2D_NSA: numIters > numItersMax =', numItersMax
        CALL PRINT_ERROR( msgBuf, myThid )
        STOP 'ABNORMAL END: S/R CG2D_NSA'
      ENDIF
      IF ( cg2dNormaliseRHS ) THEN
        WRITE(msgBuf,'(A)') 'CG2D_NSA: cg2dNormaliseRHS is disabled'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(A)')
     &    'set cg2dTargetResWunit (instead of cg2dTargetResidual)'
        CALL PRINT_ERROR( msgBuf, myThid )
        STOP 'ABNORMAL END: S/R CG2D_NSA'
      ENDIF
#endif /* ALLOW_AUTODIFF_TAMC */

C--   Initialise auxiliary constant, some output variable and inverter
      minResidualSq = -1. _d 0
      eta_qrNM1     =  1. _d 0
      recip_eta_qrNM1= 1. _d 0

C--   Normalise RHS
      rhsMax = 0. _d 0
      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        DO j=1,sNy
         DO i=1,sNx
          cg2d_b(i,j,bi,bj) = cg2d_b(i,j,bi,bj)*cg2dNorm
          rhsMax = MAX(ABS(cg2d_b(i,j,bi,bj)),rhsMax)
         ENDDO
        ENDDO
       ENDDO
      ENDDO

#ifndef ALLOW_AUTODIFF_TAMC
      IF (cg2dNormaliseRHS) THEN
C-    Normalise RHS :
       _GLOBAL_MAX_RL( rhsMax, myThid )
       rhsNorm = 1. _d 0
       IF ( rhsMax .NE. 0. ) rhsNorm = 1. _d 0 / rhsMax
       DO bj=myByLo(myThid),myByHi(myThid)
        DO bi=myBxLo(myThid),myBxHi(myThid)
         DO j=1,sNy
          DO i=1,sNx
           cg2d_b(i,j,bi,bj) = cg2d_b(i,j,bi,bj)*rhsNorm
           cg2d_x(i,j,bi,bj) = cg2d_x(i,j,bi,bj)*rhsNorm
          ENDDO
         ENDDO
        ENDDO
       ENDDO
C-    end Normalise RHS
      ENDIF
#endif /* ndef ALLOW_AUTODIFF_TAMC */

C--   Update overlaps
      CALL EXCH_XY_RL( cg2d_x, myThid )

C--   Initial residual calculation
#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE cg2d_b = comlev1_cg2d, key = ikey_dynamics, byte = isbyte
CADJ STORE cg2d_x = comlev1_cg2d, key = ikey_dynamics, byte = isbyte
#endif /* ALLOW_AUTODIFF_TAMC */
      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
C-    Initialise local working arrays:
        DO j=1,sNy
         DO i=1,sNx
          cg2d_q(i,j,bi,bj) = 0. _d 0
          cg2d_z(i,j,bi,bj) = 0. _d 0
         ENDDO
        ENDDO
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          cg2d_r(i,j,bi,bj) = 0. _d 0
          cg2d_s(i,j,bi,bj) = 0. _d 0
         ENDDO
        ENDDO
        errTile(bi,bj)    = 0. _d 0
        sumRHStile(bi,bj) = 0. _d 0
        DO j=1,sNy
         DO i=1,sNx
          cg2d_r(i,j,bi,bj) = cg2d_b(i,j,bi,bj) -
     &    (aW2d(i  ,j  ,bi,bj)*cg2d_x(i-1,j  ,bi,bj)
     &    +aW2d(i+1,j  ,bi,bj)*cg2d_x(i+1,j  ,bi,bj)
     &    +aS2d(i  ,j  ,bi,bj)*cg2d_x(i  ,j-1,bi,bj)
     &    +aS2d(i  ,j+1,bi,bj)*cg2d_x(i  ,j+1,bi,bj)
     &    +aC2d(i  ,j  ,bi,bj)*cg2d_x(i  ,j  ,bi,bj)
     &    )
          errTile(bi,bj)    = errTile(bi,bj)
     &                      + cg2d_r(i,j,bi,bj)*cg2d_r(i,j,bi,bj)
          sumRHStile(bi,bj) = sumRHStile(bi,bj) + cg2d_b(i,j,bi,bj)
         ENDDO
        ENDDO
       ENDDO
      ENDDO

c     CALL EXCH_S3D_RL( cg2d_r, 1, myThid )
      CALL EXCH_XY_RL ( cg2d_r, myThid )
      CALL GLOBAL_SUM_TILE_RL( errTile,    err_sq, myThid )
      CALL GLOBAL_SUM_TILE_RL( sumRHStile, sumRHS, myThid )
      actualIts = 0
      IF ( err_sq .NE. 0. ) THEN
        firstResidual = SQRT(err_sq)
      ELSE
        firstResidual = 0.
      ENDIF

      printResidual = .FALSE.
      IF ( debugLevel .GE. debLevZero ) THEN
        _BEGIN_MASTER( myThid )
        printResidual = printResidualFreq.GE.1
        WRITE(standardMessageUnit,'(A,1P2E22.14)')
     &  ' cg2d_nsa: Sum(rhs),rhsMax = ', sumRHS,rhsMax
        _END_MASTER( myThid )
      ENDIF

C     >>>>>>>>>>>>>>> BEGIN SOLVER <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
Cml   begin main solver loop
#if ((defined ALLOW_AUTODIFF_TAMC) && (defined ALLOW_LOOP_DIRECTIVE))
CADJ LOOP = iteration, cg2d_x = comlev_cg2d_iter
#endif /* ALLOW_AUTODIFF_TAMC and ALLOW_LOOP_DIRECTIVE */
      DO it2d=1, numIters
#ifdef ALLOW_LOOP_DIRECTIVE
CML      it2d = 0
CML      DO WHILE ( err_sq .GT. cg2dTolerance_sq .and. it2d .LT. numIters )
CML      it2d = it2d+1
#endif /* ALLOW_LOOP_DIRECTIVE */

#ifdef ALLOW_AUTODIFF_TAMC
       ikey = it2d + (ikey_dynamics-1)*numItersMax
CADJ STORE err_sq = comlev1_cg2d_iter, key = ikey, byte = isbyte
#endif /* ALLOW_AUTODIFF_TAMC */
       IF ( it2d .LE. cg2dMinItersNSA .OR.
     &      err_sq .GE. cg2dTolerance_sq ) THEN

C--    Solve preconditioning equation and update
C--    conjugate direction vector "s".
#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE cg2d_r = comlev1_cg2d_iter, key = ikey, byte = isbyte
CADJ STORE cg2d_s = comlev1_cg2d_iter, key = ikey, byte = isbyte
#endif /* ALLOW_AUTODIFF_TAMC */
       DO bj=myByLo(myThid),myByHi(myThid)
        DO bi=myBxLo(myThid),myBxHi(myThid)
         eta_qrNtile(bi,bj) = 0. _d 0
         DO j=1,sNy
          DO i=1,sNx
           cg2d_z(i,j,bi,bj) =
     &      pC(i  ,j  ,bi,bj)*cg2d_r(i  ,j  ,bi,bj)
     &     +pW(i  ,j  ,bi,bj)*cg2d_r(i-1,j  ,bi,bj)
     &     +pW(i+1,j  ,bi,bj)*cg2d_r(i+1,j  ,bi,bj)
     &     +pS(i  ,j  ,bi,bj)*cg2d_r(i  ,j-1,bi,bj)
     &     +pS(i  ,j+1,bi,bj)*cg2d_r(i  ,j+1,bi,bj)
           eta_qrNtile(bi,bj) = eta_qrNtile(bi,bj)
     &     +cg2d_z(i,j,bi,bj)*cg2d_r(i,j,bi,bj)
          ENDDO
         ENDDO
        ENDDO
       ENDDO

       CALL GLOBAL_SUM_TILE_RL( eta_qrNtile,eta_qrN,myThid )
#ifdef ALLOW_AUTODIFF_TAMC
CMLCADJ STORE eta_qrNM1 = comlev1_cg2d_iter, key = ikey, byte = isbyte
CADJ STORE recip_eta_qrNM1 = comlev1_cg2d_iter, key=ikey, byte=isbyte
#endif /* ALLOW_AUTODIFF_TAMC */
CML       cgBeta   = eta_qrN/eta_qrNM1
       cgBeta   = eta_qrN*recip_eta_qrNM1
Cml    store normalisation factor for the next interation (in case there is one).
CML    store the inverse of the normalization factor for higher precision
CML       eta_qrNM1 = eta_qrN
       recip_eta_qrNM1 = 0. _d 0
       IF ( eta_qrN .NE. 0. _d 0 ) recip_eta_qrNM1 = 1. _d 0/eta_qrN

       DO bj=myByLo(myThid),myByHi(myThid)
        DO bi=myBxLo(myThid),myBxHi(myThid)
         DO j=1,sNy
          DO i=1,sNx
           cg2d_s(i,j,bi,bj) = cg2d_z(i,j,bi,bj)
     &                       + cgBeta*cg2d_s(i,j,bi,bj)
          ENDDO
         ENDDO
        ENDDO
       ENDDO

C--    Do exchanges that require messages i.e. between
C--    processes.
c      CALL EXCH_S3D_RL( cg2d_s, 1, myThid )
       CALL EXCH_XY_RL ( cg2d_s, myThid )

C==    Evaluate laplace operator on conjugate gradient vector
C==    q = A.s
#ifdef ALLOW_AUTODIFF_TAMC
#ifndef ALLOW_LOOP_DIRECTIVE
CADJ STORE cg2d_s = comlev1_cg2d_iter, key = ikey, byte = isbyte
#endif /* not ALLOW_LOOP_DIRECTIVE */
#endif /* ALLOW_AUTODIFF_TAMC */
       DO bj=myByLo(myThid),myByHi(myThid)
        DO bi=myBxLo(myThid),myBxHi(myThid)
         alphaTile(bi,bj) = 0. _d 0
         DO j=1,sNy
          DO i=1,sNx
           cg2d_q(i,j,bi,bj) =
     &     aW2d(i  ,j  ,bi,bj)*cg2d_s(i-1,j  ,bi,bj)
     &    +aW2d(i+1,j  ,bi,bj)*cg2d_s(i+1,j  ,bi,bj)
     &    +aS2d(i  ,j  ,bi,bj)*cg2d_s(i  ,j-1,bi,bj)
     &    +aS2d(i  ,j+1,bi,bj)*cg2d_s(i  ,j+1,bi,bj)
     &    +aC2d(i  ,j  ,bi,bj)*cg2d_s(i  ,j  ,bi,bj)
           alphaTile(bi,bj) = alphaTile(bi,bj)
     &                      + cg2d_s(i,j,bi,bj)*cg2d_q(i,j,bi,bj)
          ENDDO
         ENDDO
        ENDDO
       ENDDO
       CALL GLOBAL_SUM_TILE_RL( alphaTile, alphaSum, myThid )
       alpha = 0. _d 0
       IF ( alphaSum .NE. 0 _d 0 ) alpha = eta_qrN/alphaSum

C==    Update simultaneously solution and residual vectors (and Iter number)
C      Now compute "interior" points.
#ifdef ALLOW_AUTODIFF_TAMC
#ifndef ALLOW_LOOP_DIRECTIVE
CADJ STORE cg2d_r = comlev1_cg2d_iter, key = ikey, byte = isbyte
#endif /* ALLOW_LOOP_DIRECTIVE */
#endif /* ALLOW_AUTODIFF_TAMC */
       DO bj=myByLo(myThid),myByHi(myThid)
        DO bi=myBxLo(myThid),myBxHi(myThid)
         errTile(bi,bj) = 0. _d 0
         DO j=1,sNy
          DO i=1,sNx
           cg2d_x(i,j,bi,bj)=cg2d_x(i,j,bi,bj)+alpha*cg2d_s(i,j,bi,bj)
           cg2d_r(i,j,bi,bj)=cg2d_r(i,j,bi,bj)-alpha*cg2d_q(i,j,bi,bj)
           errTile(bi,bj) = errTile(bi,bj)
     &                    + cg2d_r(i,j,bi,bj)*cg2d_r(i,j,bi,bj)
          ENDDO
         ENDDO
        ENDDO
       ENDDO
       actualIts = it2d

       CALL GLOBAL_SUM_TILE_RL( errTile,    err_sq,    myThid )
       IF ( printResidual ) THEN
        IF ( MOD( it2d-1, printResidualFreq ).EQ.0 ) THEN
         WRITE(msgBuf,'(A,I6,A,1PE21.14)')
     &    ' cg2d_nsa: iter=', it2d, ' ; resid.= ', SQRT(err_sq)
         CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                       SQUEEZE_RIGHT, myThid )
        ENDIF
       ENDIF

c      CALL EXCH_S3D_RL( cg2d_r, 1, myThid )
       CALL EXCH_XY_RL ( cg2d_r, myThid )

Cml   end of if "err >= cg2dTolerance" block ; end main solver loop
      ENDIF
      ENDDO

#ifndef ALLOW_AUTODIFF_TAMC
      IF (cg2dNormaliseRHS) THEN
C--   Un-normalise the answer
        DO bj=myByLo(myThid),myByHi(myThid)
         DO bi=myBxLo(myThid),myBxHi(myThid)
          DO j=1,sNy
           DO i=1,sNx
            cg2d_x(i,j,bi,bj) = cg2d_x(i,j,bi,bj)/rhsNorm
           ENDDO
          ENDDO
         ENDDO
        ENDDO
      ENDIF
#endif /* ndef ALLOW_AUTODIFF_TAMC */

C--   Return parameters to caller
      IF ( err_sq .NE. 0. ) THEN
        lastResidual = SQRT(err_sq)
      ELSE
        lastResidual = 0.
      ENDIF
      numIters = actualIts

#endif /* ALLOW_CG2D_NSA */
      RETURN
      END

#if ((defined ALLOW_AUTODIFF_TAMC) && (defined ALLOW_LOOP_DIRECTIVE))

C     These routines are routinely part of the TAF library that is
C     not included in the MITcgm, therefore they are mimicked here.

      SUBROUTINE ADSTORE(chardum,int1,idow,int2,int3,icount)

      IMPLICIT NONE

#include "SIZE.h"
#include "tamc.h"

      CHARACTER*(*) chardum
      INTEGER int1, int2, int3, idow, icount

C     the length of this vector must be greater or equal
C     twice the number of timesteps
      INTEGER nidow
#ifdef ALLOW_TAMC_CHECKPOINTING
      PARAMETER ( nidow = 2*nchklev_1*nchklev_2*nchklev_3 )
#else
      PARAMETER ( nidow = 1000000 )
#endif /* ALLOW_TAMC_CHECKPOINTING */
      INTEGER istoreidow(nidow)
      COMMON /istorecommon/ istoreidow

      PRINT *, 'ADSTORE: ', chardum, int1, idow, int2, int3, icount

      IF ( icount .GT. nidow ) THEN
         PRINT *, 'adstore: error: icount > nidow = ', nidow
         STOP 'ABNORMAL STOP in ADSTORE'
      ENDIF

      istoreidow(icount) = idow

      RETURN
      END

      SUBROUTINE ADRESTO(chardum,int1,idow,int2,int3,icount)

      IMPLICIT NONE

#include "SIZE.h"
#include "tamc.h"

      CHARACTER*(*) chardum
      INTEGER int1, int2, int3, idow, icount

C     the length of this vector must be greater or equal
C     twice the number of timesteps
      INTEGER nidow
#ifdef ALLOW_TAMC_CHECKPOINTING
      PARAMETER ( nidow = 2*nchklev_1*nchklev_2*nchklev_3 )
#else
      PARAMETER ( nidow = 1000000 )
#endif /* ALLOW_TAMC_CHECKPOINTING */
      INTEGER istoreidow(nidow)
      COMMON /istorecommon/ istoreidow

      PRINT *, 'ADRESTO: ', chardum, int1, idow, int2, int3, icount

      IF ( icount .GT. nidow ) THEN
         PRINT *, 'ADRESTO: error: icount > nidow = ', nidow
         STOP 'ABNORMAL STOP in ADRESTO'
      ENDIF

      idow = istoreidow(icount)

      RETURN
      END
#endif /* ALLOW_AUTODIFF_TAMC and ALLOW_LOOP_DIRECTIVE */

#include "CPP_EEOPTIONS.h"

CBOP
C     !ROUTINE: BARRIER_INIT

C     !INTERFACE:
      SUBROUTINE BARRIER_INIT
      IMPLICIT NONE

C     !DESCRIPTION:
C     *=====================================================================*
C     | SUBROUTINE BARRIER\_INIT
C     | o Setup global barrier data structures.
C     *=====================================================================*
C     | Initialise global barrier data structures that can be used in
C     | conjunction with MPI or that can also be used to create
C     *=====================================================================*

C     !USES:
C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "EESUPPORT.h"
#include "BARRIER.h"

C     !LOCAL VARIABLES:
C     == Local Variables ==
C     I :: Loop counter
      INTEGER I
CEOP

      DO I=1,nThreads
       key1(1,I) = INVALID
       key2(1,I) = INVALID
       key3(1,I) = INVALID
       door1     = SHUT
       door2     = SHUT
       door3     = SHUT
       bCount(I) = 0
       masterSet(I) = 0
      ENDDO

      RETURN
      END

CBOP
C     !ROUTINE: BARRIER

C     !INTERFACE:
      SUBROUTINE BARRIER( myThid )
      IMPLICIT NONE

C     !DESCRIPTION:
C     *==========================================================*
C     | SUBROUTINE BARRIER
C     | o Barrier routine that uses "busy waiting".
C     *==========================================================*
C     | This routine provides a pure fortran mechanism to
C     | synchronise multiple threads in a multi-threaded code.
C     | No thread can leave this routine before all the threads
C     | have entered it.
C     | Notes
C     | =====
C     | The door and key variables are assumed to have been
C     | initialized once an initial state of key = INVALID
C     | and door = SHUT.
C     | We use the routine FOOL\_THE\_COMPILER to stop compilers
C     | generating code which might simply set and test a
C     | register value. Shared-memory systems only maintain
C     | coherency over process caches and not registers.
C     | Also we have to be a bit careful regarding sequential
C     | consistency - or lack of it. At the moment the code
C     | assumes a total store order memory model, which some
C     | machines do not have! However, I have yet to find a
C     | problem with this I think because the tolerances in
C     | terms of memory ordering i.e. a little bit of reordering
C     | probably will not break the barrier mechanism!
C     | On non-cache coherent systems e.g. T3E we need to use
C     | a library function to do barriers.
C     | Note - The PANIC tests can be removed for working code
C     |        I have left them in without an ifdef option
C     |        because without them programming errors can
C     |        lead to infinitely spinning code. If you are
C     |        confident that your code is OK then removing
C     |        them may increase performance. Do not remove these
C     |        lines to make your code "work" If the code is
C     |        stopping in these PANIC blocks then something is
C     |        wrong with your program and it needs to be fixed.
C     *==========================================================*

C     !USES:
C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "EESUPPORT.h"
#include "BARRIER.h"

C     !INPUT PARAMETERS:
C     == Routine arguments ==
      INTEGER myThid

C     !LOCAL VARIABLES:
C     === Local variables ===
C     nDone :: Counter for number of threads that have
C              completed a section.
C     I     :: Loop counter
      INTEGER nDone
      INTEGER I
CEOP

CcnhDebugStarts
C      WRITE(myThid,*) ' Barrier entered '
CcnhDebugEnds

#ifdef USE_OMP_THREADING
C$OMP BARRIER
      bCount(myThid) = bCount(myThid) + 1
      IF ( masterSet(myThid) .NE. 0 ) THEN
       PRINT *, 'BARRIER called for master reg myThid == ',
     &   myThid, masterSet(myThid)
      ENDIF
Cdbg C$OMP BARRIER
Cdbg       DO I=2, nThreads
Cdbg        IF (bCount(I) .NE. bCount(1) ) THEN
Cdbg          PRINT *, bCount(1:nThreads)
Cdbg          CALL SYSTEM('sleep 1')
Cdbg          PRINT *, bCount(1:nThreads)
Cdbg          PRINT *, bCount(1:nThreads)
Cdbg          PRINT *, bCount(1:nThreads)
Cdbg          PRINT *, bCount(1:nThreads)
Cdbg          STOP ' barrier out of sync '
Cdbg        ENDIF
Cdbg       ENDDO
Cdbg C$OMP BARRIER
      RETURN
#endif

C--   Check that thread number is expected range
      IF ( myThid .LT. 1 .OR. myThid .GT. nThreads ) THEN
       WRITE(*,*) '!!!!!!! PANIC !!!!!!! CATASTROPHIC ERROR'
       WRITE(*,*) '!!!!!!! PANIC !!!!!!! in S/R BARRIER  myThid = ',
     &  myThid, ' nThreads = ', nThreads
       STOP 'ABNROMAL END: S/R BARRIER'
      ENDIF

C--   When every threads key1 is valid thread 1 will open door1.
      IF ( key1(1,myThid) .EQ. VALID ) THEN
       WRITE(*,*) '!!!!!!! PANIC !!!!!!! CATASTROPHIC ERROR'
       WRITE(*,*) '!!!!!!! PANIC !!!!!!! in S/R BARRIER  myThid = ',
     &  myThid, ' key1 already validated'
       STOP 'ABNROMAL END: S/R BARRIER'
      ENDIF
      key1(1,myThid) = VALID

      IF ( myThid .eq. 1 ) THEN
   10  CONTINUE
        nDone = 0
        DO I=1,nThreads
         if ( key1(1,I) .EQ. VALID ) nDone = nDone+1
        ENDDO
        CALL FOOL_THE_COMPILER( key1(1,1) )
       IF ( nDone .LT. nThreads ) GOTO 10
       door1 = OPEN
      ELSE
  11   CONTINUE
        CALL FOOL_THE_COMPILER( door1 )
       IF ( door1 .NE. OPEN ) GOTO 11
      ENDIF
C--   Invalidate keys for door1 here as it is now open
      key1(1,myThid) = INVALID

CcnhDebugStarts
C     IF ( myThid .EQ. 1 ) THEN
C      WRITE(*,*) ' DOOR1 Opened '
C     ENDIF
CcnhDebugEnds

C--   I can now shut door3 because I know everyone has reached
C--   door1. I can not shut door1 because I do not know if everyone
C--   has "gone" through the door yet. Nobody has yet reached
C--   door3 because they have to go through door2 first.
      IF ( myThid .EQ. 1 ) THEN
       door3 = SHUT
      ENDIF

C--   When every threads key2 is valid thread 1 will open door2.
C     Notes
C     =====
C     I think that to work with any memory model ( i.e. relaxed,
C     partial store, total store) the variables key1, key2 and key3
C     might need to be set to invalid by thread 1.
C
      IF ( key2(1,myThid) .EQ. VALID ) THEN
       WRITE(*,*) '!!!!!!! PANIC !!!!!!! CATASTROPHIC ERROR'
       WRITE(*,*) '!!!!!!! PANIC !!!!!!! in S/R BARRIER  myThid = ',
     &  myThid, ' key2 already validated'
       STOP 'ABNROMAL END: S/R BARRIER'
      ENDIF
      key2(1,myThid) = VALID
C
      IF ( myThid .eq. 1 ) THEN
   20  CONTINUE
        nDone = 0
        DO I=1,nThreads
         if ( key2(1,I) .EQ. VALID ) nDone = nDone+1
        ENDDO
        CALL FOOL_THE_COMPILER( key2(1,1) )
       IF ( nDone .LT. nThreads ) GOTO 20
       door2 = OPEN
      ELSE
  21   CONTINUE
        CALL FOOL_THE_COMPILER( door2 )
       IF ( door2 .NE. OPEN ) GOTO 21
      ENDIF

C--   Invalidate keys for door2 here as it is now open
      key2(1,myThid) = INVALID

C--   I can now shut door1 because I know everyone has reached
C--   door2. I can not shut door2 because I do not know if everyone
C--   has "gone" through the door yet. Nobody has yet reached
C--   door1 because they have to go through door3 first.
      IF ( myThid .EQ. 1 ) THEN
       door1 = SHUT
      ENDIF


C--   When every threads key3 is valid thread 1 will open door3.
      IF ( key3(1,myThid) .EQ. VALID ) THEN
       WRITE(*,*) '!!!!!!! PANIC !!!!!!! CATASTROPHIC ERROR'
       WRITE(*,*) '!!!!!!! PANIC !!!!!!! in S/R BARRIER  myThid = ',
     &  myThid, ' key3 already validated'
       STOP 'ABNROMAL END: S/R BARRIER'
      ENDIF
      key3(1,myThid) = VALID
C
      IF ( myThid .eq. 1 ) THEN
   30  CONTINUE
        nDone = 0
        DO I=1,nThreads
         if ( key3(1,I) .EQ. VALID ) nDone = nDone+1
        ENDDO
        CALL FOOL_THE_COMPILER( key3(1,1) )
       IF ( nDone .LT. nThreads ) GOTO 30
       door3 = OPEN
      ELSE
  31   CONTINUE
        CALL FOOL_THE_COMPILER( door3 )
       IF ( door3 .NE. OPEN ) GOTO 31
      ENDIF

C--   Invalidate keys for door3 here as it is now open
      key3(1,myThid) = INVALID

C--   I can now shut door2 because I know everyone has reached
C--   door3. I can not shut door3 because I do not know if everyone
C--   has "gone" through the door yet. Nobody has yet reached
C--   door2 because they have to go through door1 first.
      IF ( myThid .EQ. 1 ) THEN
       door2 = SHUT
      ENDIF

CcnhDebugStarts
C      WRITE(myThid,*) ' Barrier exited '
CcnhDebugEnds

      RETURN
      END

CBOP
      SUBROUTINE BARRIER_MS( myThid )
      IMPLICIT NONE

C     !USES:
C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "EESUPPORT.h"
#include "BARRIER.h"
      INTEGER myThid

      masterSet(myThid) = masterSet(myThid) + 1

      RETURN
      END
      SUBROUTINE BARRIER_MU( myThid )
      IMPLICIT NONE

C     !USES:
C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "EESUPPORT.h"
#include "BARRIER.h"
      INTEGER myThid

      masterSet(myThid) = masterSet(myThid) - 1

      RETURN
      END

!=======================================================================
      subroutine couprecv_r4( component, dataname, Nx, Ny, arr )
      implicit none
! Arguments
      character*(*) component
      character*(*) dataname
      integer Nx,Ny
      real*4 arr(Nx,Ny)
! Predefined constants/arrays
#include "CPLR_SIG.h"
! MPI variables
#include "mpif.h"
      integer count,dtype,rank,tag,comm,ierr
      integer stat(MPI_STATUS_SIZE)
! Functions
      integer mitcplr_match_comp
      integer generate_tag
! Local
      integer compind,numprocs
      integer i,j,ij,n
      integer Ni,Io,Nj,Jo
      character*(MAXLEN_COMP_NAME) recvdname
!     ------------------------------------------------------------------

! Establish who I am communicating with
      compind=mitcplr_match_comp( component )
      if (compind.le.0) stop 'couprecv_r4: Bad component id'
      comm=MPI_COMM_compcplr( compind )
      numprocs=num_component_procs(compind)
      if (numprocs.lt.1) then
       write(LogUnit,*) 'couprecv_r4: compind = ',compind
       stop 'couprecv_r4: numprocs < 1'
      endif
      if (VERB)
     &  write(LogUnit,*) 'couprecv_r4: ',component_Name(compind)
      if (VERB)
     &  write(LogUnit,*) 'couprecv_r4: dataname=',dataname

! Foreach component process
      do n=1,numprocs

! Receive message
       count=HEADER_SIZE+MAX_R4_BUFLEN
       dtype=MPI_REAL
       tag=generate_tag(102,n,dataname)
       rank=rank_component_procs(n,compind)
       if (VERB) then
        write(LogUnit,*) 'couprecv_r4: calling MPI_Recv rank=',rank,
     &    ' proc=',n,'/',numprocs
        call flush(LogUnit)
       endif
       call MPI_Recv(r4buf, count, dtype, rank, tag, comm, stat, ierr)
       if (VERB) then
        write(LogUnit,*) 'couprecv_r4: returned ierr=',ierr
        call flush(LogUnit)
       endif

       if (ierr.ne.0) then
        write(LogUnit,*) 'couprecv_r4tiles: rank(W,G)=',
     &            my_rank_in_world,my_rank_in_global,
     &            ' ierr=',ierr
        stop 'couprecv_r4: MPI_Recv failed'
       endif

! Extract header
       Io=int(0.5+r4buf(1))
       Ni=int(0.5+r4buf(2))
       Jo=int(0.5+r4buf(3))
       Nj=int(0.5+r4buf(4))

       if (Io+Ni-1.gt.Nx .or. Io.lt.1) then
        write(LogUnit,*) 'couprecv_r4tiles: Io,Ni=',Io,Ni
        stop 'couprecv_r4: Incompatible header/target array'
       endif
       if (Jo+Nj-1.gt.Ny .or. Jo.lt.1) then
        write(LogUnit,*) 'couprecv_r4tiles: Jo,Nj=',Jo,Nj
        stop 'couprecv_r4: Incompatible header/target array'
       endif

       call mitcplr_real2char( r4buf(9), recvdname )
       if (recvdname .ne. dataname) then
        write(LogUnit,*) 'couprecv_r4: recvdname = ',recvdname
        write(LogUnit,*) 'couprecv_r4:  dataname = ',dataname
        stop 'couprecv_r4: recvdname != dataname'
       endif

! Extract data
       do j=1,Nj
        do i=1,Ni
         ij=HEADER_SIZE+i+Ni*(j-1)
         arr(Io+i-1,Jo+j-1)=r4buf(ij)
        enddo
       enddo

      enddo

!     ------------------------------------------------------------------
      return
      end
!=======================================================================

#include "AUTODIFF_OPTIONS.h"
#ifdef ALLOW_CTRL
# include "CTRL_OPTIONS.h"
#endif

CBOP
C !ROUTINE: ADAUTODIFF_INADMODE_SET

C !INTERFACE:
      SUBROUTINE ADAUTODIFF_INADMODE_SET( myTime, myIter, myThid )

C     !DESCRIPTION:
C     *==========================================================*
C     | SUBROUTINE ADAUTODIFF_INADMODE_SET
C     *==========================================================*

C     !USES:
      IMPLICIT NONE
C     == Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "AUTODIFF_PARAMS.h"
#ifdef ALLOW_SEAICE
# include "SEAICE_SIZE.h"
# include "SEAICE_PARAMS.h"
#endif
#ifdef ALLOW_CTRL
# include "CTRL_SIZE.h"
# include "CTRL.h"
#endif
#ifdef ALLOW_DIAGNOSTICS
# include "DIAGNOSTICS_P2SHARE.h"
#endif /* ALLOW_DIAGNOSTICS */

C     !INPUT/OUTPUT PARAMETERS:
C     myTime    :: Current time in simulation
C     myIter    :: Current iteration number
C     myThid    :: my Thread Id number
      _RL     myTime
      INTEGER myIter
      INTEGER myThid

C     !LOCAL VARIABLES:
      CHARACTER*(MAX_LEN_MBUF) msgBuf
#ifdef ALLOW_DIAGNOSTICS
      _RL wrTime
      INTEGER wrIter
#endif /* ALLOW_DIAGNOSTICS */
CEOP

C--   Set backward-sweep switch:
      inAdMode  = .TRUE.

#ifdef ALLOW_DIAGNOSTICS
      IF ( useDiag4AdjOutp ) THEN
C-    Consistent with S/R DIAGNOSTICS_WRITE_ADJ and where both S/R are called:
        wrIter = myIter - 1
        wrTime = myTime - deltaTClock
        CALL DIAGNOSTICS_SWITCH_ONOFF( -1, wrTime, wrIter, myThid )
      ENDIF
#endif /* ALLOW_DIAGNOSTICS */

C--   Update some pkg and scheme switches:
      useKPP    = useKPPinAdMode
      useGMRedi = useGMRediInAdMode
      useSEAICE = useSEAICEinAdMode
      useGGL90  = useGGL90inAdMode
      useSALT_PLUME = useSALT_PLUMEinAdMode
#ifdef ALLOW_SEAICE
      IF ( SEAICEuseFREEDRIFTswitchInAd ) THEN
        SEAICEuseFREEDRIFT = .NOT.SEAICEuseFREEDRIFTinFwdMode
        SEAICEuseLSR       = .NOT.SEAICEuseFREEDRIFT
      ENDIF
      IF ( SEAICEuseDYNAMICSswitchInAd ) THEN
        SEAICEuseDYNAMICS  = .NOT.SEAICEuseDYNAMICSinFwdMode
      ENDIF
      SEAICEadjMODE=SEAICEapproxLevInAd
C     SIregFacInAd = UNSET_RL by default, so we need to check this here
      IF ( SIregFacInAd .NE. UNSET_RL ) SINegFac = SIregFacInAd
#endif /* ALLOW_SEAICE */
      viscFacAdj=viscFacInAd

      IF ( debugLevel.GE.debLevC ) THEN
C--   Print status of some switches:

       WRITE(msgBuf,'(A,L5)')
     &      'S/R ADAUTODIFF_INADMODE_SET: useKPP    =', useKPP
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                     SQUEEZE_RIGHT, myThid )
       WRITE(msgBuf,'(A,L5)')
     &      'S/R ADAUTODIFF_INADMODE_SET: useGMRedi =', useGMRedi
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                     SQUEEZE_RIGHT, myThid )
       WRITE(msgBuf,'(A,L5)')
     &      'S/R ADAUTODIFF_INADMODE_SET: useSEAICE =', useSEAICE
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                     SQUEEZE_RIGHT, myThid )
       WRITE(msgBuf,'(A,L5)')
     &      'S/R ADAUTODIFF_INADMODE_SET: useGGL90    =', useGGL90
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                     SQUEEZE_RIGHT, myThid )
       WRITE(msgBuf,'(A,L5)')
     &      'S/R ADAUTODIFF_INADMODE_SET: useSALT_PLUME    =',
     &      useSALT_PLUME
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                     SQUEEZE_RIGHT, myThid )

       WRITE(msgBuf,'(A,1PE21.14)')
     &      'S/R ADAUTODIFF_INADMODE_SET: viscFacAdj =',viscFacAdj
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                     SQUEEZE_RIGHT, myThid )

#ifdef ALLOW_SEAICE
       IF ( SEAICEuseFREEDRIFTswitchInAd ) THEN
         WRITE(msgBuf,'(2A,L5)') 'S/R ADAUTODIFF_INADMODE_SET: ',
     &        'SEAICEuseFREEDRIFT =', SEAICEuseFREEDRIFT
         CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                       SQUEEZE_RIGHT, myThid )
         WRITE(msgBuf,'(2A,L5)') 'S/R ADAUTODIFF_INADMODE_SET: ',
     &        'SEAICEuseLSR       =', SEAICEuseLSR
         CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                       SQUEEZE_RIGHT, myThid )
       ENDIF
       IF ( SEAICEuseDYNAMICSswitchInAd ) THEN
         WRITE(msgBuf,'(2A,L5)') 'S/R ADAUTODIFF_INADMODE_SET: ',
     &        'SEAICEuseDYNAMICS =', SEAICEuseDYNAMICS
         CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                       SQUEEZE_RIGHT, myThid )
       ENDIF
       IF ( SEAICEapproxLevInAd.NE.0 ) THEN
         WRITE(msgBuf,'(2A,I2)') 'S/R ADAUTODIFF_INADMODE_SET: ',
     &        'SEAICEadjMODE =', SEAICEadjMODE
         CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                       SQUEEZE_RIGHT, myThid )
       ENDIF
#endif /* ALLOW_SEAICE */

C--   end printing switch status (if debugLevel >= debLevC).
      ENDIF

      RETURN
      END

#include "PACKAGES_CONFIG.h"
#include "CPP_OPTIONS.h"

CBOP
C     !ROUTINE: CALC_SURF_DR
C     !INTERFACE:
      SUBROUTINE CALC_SURF_DR( etaFld,
     I                         myTime, myIter, myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE CALC_SURF_DR
C     | o Calculate the new surface level thickness according to
C     |   the surface r-position  (Non-Linear Free-Surf)
C     | o take decision if grid box becomes too thin or too thick
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     == Global variables
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "SURFACE.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     etaFld    :: current eta field used to update the hFactor
C     myTime    :: current time in simulation
C     myIter    :: current iteration number in simulation
C     myThid    :: thread number for this instance of the routine.
      _RL etaFld(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL myTime
      INTEGER myIter
      INTEGER myThid

#ifdef NONLIN_FRSURF

C     !LOCAL VARIABLES:
C     Local variables
C     i,j,k,bi,bj  :: loop counter
C     rSurftmp     :: free surface r-position that is used to compute hFac_surf
C     adjust_nb_pt :: Nb of grid points where rSurf is adjusted (hFactInf)
C     adjust_volum :: adjustment effect on the volume (domain size)
C     numbWrite    :: count the Number of warning written on STD-ERR file
C     numbWrMax    ::  maximum  Number of warning written on STD-ERR file
      INTEGER i,j,bi,bj
      INTEGER ks, nTmp
      INTEGER numbWrite, numbWrMax
      _RL hFactmp, adjust_nb_pt, adjust_volum
      _RL rSurftmp(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RS hhm, hhp
c     CHARACTER*(MAX_LEN_MBUF) suff
CEOP
      DATA numbWrite / 0 /
      numbWrMax = Nx*Ny

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      adjust_nb_pt = 0.
      adjust_volum = 0.

      DO bj=myByLo(myThid), myByHi(myThid)
       DO bi=myBxLo(myThid), myBxHi(myThid)

C--   before updating hFac_surfC/S/W save current fields
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
           hFac_surfNm1C(i,j,bi,bj) = hFac_surfC(i,j,bi,bj)
           hFac_surfNm1S(i,j,bi,bj) = hFac_surfS(i,j,bi,bj)
           hFac_surfNm1W(i,j,bi,bj) = hFac_surfW(i,j,bi,bj)
         ENDDO
        ENDDO

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C-- Compute the new fractional thickness of surface level (kSurfC):

        DO j=0,sNy+1
         DO i=0,sNx+1
          rSurftmp(i,j) = Ro_surf(i,j,bi,bj)+etaFld(i,j,bi,bj)
          ks = kSurfC(i,j,bi,bj)
          IF (ks.LE.Nr) THEN
           IF ( rSurftmp(i,j).LT.Rmin_surf(i,j,bi,bj) ) THEN
C-- Needs to do something :
            IF ( numbWrite.LE.numbWrMax .AND.
     &           ( i.GE.1.AND.i.LE.sNx .AND.
     &             j.GE.1.AND.j.LE.sNy ) ) THEN
             numbWrite = numbWrite + 1
             hFactmp = h0FacC(i,j,ks,bi,bj)
     &         + ( rSurftmp(i,j) - Ro_surf(i,j,bi,bj) )*recip_drF(ks)
             IF (hFactmp.LT.hFacInf) THEN
              WRITE(errorMessageUnit,'(2A,6I4,I10)')
     &         'WARNING: hFacC < hFacInf at:',
     &         ' i,j,k,bi,bj,Thid,Iter=',i,j,ks,bi,bj,myThid,myIter
             ELSE
              WRITE(errorMessageUnit,'(2A,6I4,I10)')
     &         'WARNING: hFac < hFacInf near:',
     &         ' i,j,k,bi,bj,Thid,Iter=',i,j,ks,bi,bj,myThid,myIter
             ENDIF
             WRITE(errorMessageUnit,'(A,2F10.6,1PE14.6)')
     &         ' hFac_n-1,hFac_n,eta =',
     &          hfacC(i,j,ks,bi,bj), hFactmp, etaFld(i,j,bi,bj)
            ENDIF
C-- Decide to STOP :
c            WRITE(errorMessageUnit,'(A)')
c    &        'STOP in CALC_SURF_DR : too SMALL hFac !'
c            STOP 'ABNORMAL END: S/R CALC_SURF_DR'
C-- Or continue with Rmin_surf:
            IF ( i.GE.1.AND.i.LE.sNx .AND.
     &           j.GE.1.AND.j.LE.sNy ) THEN
              adjust_nb_pt = adjust_nb_pt + 1.
              adjust_volum = adjust_volum
     &          + rA(i,j,bi,bj)*(Rmin_surf(i,j,bi,bj)-rSurftmp(i,j))
            ENDIF
            rSurftmp(i,j) = Rmin_surf(i,j,bi,bj)
C----------
           ENDIF

C-- Set hFac_surfC :
           hFac_surfC(i,j,bi,bj) = h0FacC(i,j,ks,bi,bj)
     &            + ( rSurftmp(i,j) - Ro_surf(i,j,bi,bj)
     &              )*recip_drF(ks)*maskC(i,j,ks,bi,bj)

C-- Usefull warning when hFac becomes very large:
           IF ( numbWrite.LE.numbWrMax .AND.
     &          hFac_surfC(i,j,bi,bj).GT.hFacSup ) THEN
              numbWrite = numbWrite + 1
              WRITE(errorMessageUnit,'(2A,6I4,I10)')
     &         'WARNING: hFacC > hFacSup at:',
     &         ' i,j,k,bi,bj,Thid,Iter=',i,j,ks,bi,bj,myThid,myIter
              WRITE(errorMessageUnit,'(A,2F10.6,1PE14.6)')
     &         ' hFac_n-1,hFac_n,eta =', hfacC(i,j,ks,bi,bj),
     &          hFac_surfC(i,j,bi,bj), etaFld(i,j,bi,bj)
           ENDIF
C----------
          ENDIF

         ENDDO
        ENDDO

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C-- Compute fractional thickness of surface level, for U & V point:

        DO j=1,sNy
         DO i=1,sNx+1
          ks = kSurfW(i,j,bi,bj)
          IF (ks.LE.Nr) THEN
C-  allows hFacW to be larger than surrounding hFacC=1 @ edge of a step with
C   different kSurfC on either side (topo in p-coords, ice-shelf in z-coords)
            hhm = rSurftmp(i-1,j)
            hhp = rSurftmp(i,j)
C-  make sure hFacW is not larger than the 2 surrounding hFacC
c           hhm = rF(ks)
c           IF(ks.EQ.kSurfC(i-1,j,bi,bj)) hhm = rSurftmp(i-1,j)
c           hhp = rF(ks)
c           IF(ks.EQ.kSurfC(i,j,bi,bj))   hhp = rSurftmp(i,j)
            hFac_surfW(i,j,bi,bj) = h0FacW(i,j,ks,bi,bj)
     &            + ( MIN(hhm,hhp) - rSurfW(i,j,bi,bj)
     &              )*recip_drF(ks)*maskW(i,j,ks,bi,bj)
          ENDIF
         ENDDO
        ENDDO

        DO j=1,sNy+1
         DO i=1,sNx
          ks = kSurfS(i,j,bi,bj)
          IF (ks.LE.Nr) THEN
C-  allows hFacS to be larger than surrounding hFacC=1 @ edge of a step with
C   different kSurfC on either side (topo in p-coords, ice-shelf in z-coords)
            hhm = rSurftmp(i,j-1)
            hhp = rSurftmp(i,j)
C-  make sure hFacS is not larger than the 2 surrounding hFacC
c           hhm = rF(ks)
c           IF(ks.EQ.kSurfC(i,j-1,bi,bj)) hhm = rSurftmp(i,j-1)
c           hhp = rF(ks)
c           IF(ks.EQ.kSurfC(i,j,bi,bj))   hhp = rSurftmp(i,j)
            hFac_surfS(i,j,bi,bj) = h0FacS(i,j,ks,bi,bj)
     &            + ( MIN(hhm,hhp) - rSurfS(i,j,bi,bj)
     &              )*recip_drF(ks)*maskS(i,j,ks,bi,bj)
          ENDIF
         ENDDO
        ENDDO

#ifdef ALLOW_OBCS
C-- Apply OBC to hFac_surfW,S before the EXCH calls
        IF ( useOBCS ) THEN
          CALL OBCS_APPLY_SURF_DR(
     I                    bi, bj, etaFld,
     U                    hFac_surfC, hFac_surfW, hFac_surfS,
     I                    myTime, myIter, myThid )
        ENDIF
#endif /* ALLOW_OBCS */

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C-    end bi,bj loop.
       ENDDO
      ENDDO

C-- Global diagnostic :
      _GLOBAL_SUM_RL( adjust_nb_pt , myThid )
      IF ( adjust_nb_pt.GE.1. ) THEN
        _GLOBAL_SUM_RL( adjust_volum , myThid )
        _BEGIN_MASTER( myThid )
C   just to avoid issue with OpenAD: copy to integer nTmp before printing
        nTmp = NINT(adjust_nb_pt)
        WRITE(standardMessageUnit,'(2(A,I10),1PE16.8)')
     &    ' SURF_ADJUSTMENT: Iter=', myIter,
     &    ' Nb_pts,Vol=', nTmp, adjust_volum
        _END_MASTER( myThid )
      ENDIF

      _EXCH_XY_RS(hFac_surfC, myThid )
      CALL EXCH_UV_XY_RS(hFac_surfW,hFac_surfS,.FALSE.,myThid)

C-----
C Note: testing kSurfW,S is equivalent to a full height mask
C   ==> no need for applying the mask here.
C and with "partial thin wall" ==> mask could be applied in S/R UPDATE_SURF_DR
C-----

c     IF ( myIter.GE.0 ) THEN
c       WRITE(suff,'(I10.10)') myIter
c       CALL WRITE_FLD_XY_RS( 'hFac_surfC.', suff, hFac_surfC,
c    &                         myIter, myThid )
c     ENDIF

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
#endif /* NONLIN_FRSURF */

      RETURN
      END

#include "DIC_OPTIONS.h"

C !INTERFACE: ==========================================================
      SUBROUTINE DIC_DIAGNOSTICS_INIT(myThid )

C !DESCRIPTION:
C define diagnostics for dic package
C experiment

C !USES: ===============================================================
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"

C !INPUT PARAMETERS: ===================================================
C  myThid               :: thread number
      INTEGER myThid
CEOP

#ifdef ALLOW_DIAGNOSTICS

C     !LOCAL VARIABLES:
      INTEGER       diagNum
      CHARACTER*8   diagName
      CHARACTER*16  diagCode
      CHARACTER*16  diagUnits
      CHARACTER*(80) diagTitle

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C     Define diagnostics Names :

      diagName  = 'DICBIOA '
      diagTitle = 'Biological Productivity (mol/m3/s)'
      diagUnits = 'mol/m3/sec      '
      diagCode  = 'SMRP    MR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'DICCARB '
      diagTitle = 'Carbonate chg-biol prod and remin (mol eq/m3/s)'
      diagUnits = 'mol eq/m3/sec   '
      diagCode  = 'SMRP    MR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'DICTFLX '
      diagTitle = 'Tendency of DIC due to air-sea exch (mol/m3/s)'
      diagUnits = 'mol/m3/sec      '
      diagCode  = 'SM P    L1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'DICOFLX '
      diagTitle = 'Tendency of O2 due to air-sea exch (mol/m3/s)'
      diagUnits = 'mol/m3/sec      '
      diagCode  = 'SM P    L1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'DICCFLX '
      diagTitle = 'Flux of CO2 - air-sea exch (mol/m2/s)'
      diagUnits = 'mol/m2/sec      '
      diagCode  = 'SM P    L1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'DICPCO2 '
      diagTitle = 'Partial Pressure of CO2 (atm)'
      diagUnits = 'atm             '
      diagCode  = 'SM P    M1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'DICPHAV '
      diagTitle = 'pH (dimensionless)'
      diagUnits = 'dimensionless   '
      diagCode  = 'SM P    M1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

#ifdef DIC_CALCITE_SAT
       diagName  = 'DIC3DSIT'
       diagTitle = 'Three dimensional silicate concentration (mol/m3)'
       diagUnits = 'mol/m3          '
       diagCode  = 'SMRP    MR      '
       CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

       diagName  = 'OMEGAC  '
       diagTitle = 'Carbonate saturation'
       diagUnits = 'mol eq/m3/s     '
       diagCode  = 'SMRP    MR      '
       CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

       diagName  = 'DIC3DPH '
       diagTitle = 'Three dimensional pH (dimensionless)'
       diagUnits = 'dimensionless   '
       diagCode  = 'SM P    MR      '
       CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

       diagName  = 'DIC3DPCO'
       diagTitle = 'Three dimensional CO2 partial pressure (atm)'
       diagUnits = 'atm             '
       diagCode  = 'SMRP    MR      '
       CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

       diagName  = 'DIC3DCO3'
       diagTitle = 'Three dimensional carbonate concentration (mol/m3)'
       diagUnits = 'mol/m3          '
       diagCode  = 'SMRP    MR      '
       CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )
#endif /* DIC_CALCITE_SAT */

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#endif /* ALLOW_DIAGNOSTICS */

      RETURN
      END

#include "THSICE_OPTIONS.h"
#ifdef ALLOW_SEAICE
# include "SEAICE_OPTIONS.h"
#endif /* ALLOW_SEAICE */

CBOP
C     !ROUTINE: THSICE_GET_OCEAN
C     !INTERFACE:
      SUBROUTINE THSICE_GET_OCEAN(
     I                        bi, bj, myTime, myIter, myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R THSICE_GET_OCEAN
C     | o Get mixed layer properties from ocean main
C     |   variables (surface level) and store them
C     |   into this package local mixed-layer arrays
C     *==========================================================*

C     !USES:
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "SURFACE.h"
#include "DYNVARS.h"
c#include "THSICE_PARAMS.h"
#include "THSICE_SIZE.h"
#include "THSICE_VARS.h"
#ifdef ALLOW_SEAICE
# include "SEAICE_SIZE.h"
# include "SEAICE.h"
#endif /* ALLOW_SEAICE */

C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
C     bi, bj    :: Tile indices
C     myTime    :: Current time in simulation (s)
C     myIter    :: Current iteration number
C     myThid    :: My Thread Id. number
      INTEGER bi, bj
      _RL     myTime
      INTEGER myIter
      INTEGER myThid
CEOP

#ifdef ALLOW_THSICE
C     !LOCAL VARIABLES:
C     === Local variables ===
      INTEGER i,j
      INTEGER ks
#ifdef ALLOW_SEAICE
      _RL uRel1, uRel2, vRel1, vRel2
#endif /* ALLOW_SEAICE */

C--     Mixed layer thickness: take the 1rst layer
        ks = 1
#ifdef NONLIN_FRSURF
        IF ( staggerTimeStep .AND. nonlinFreeSurf.GT.0 ) THEN
         IF ( select_rStar.GT.0 ) THEN
          DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
             hOceMxL(i,j,bi,bj) = drF(ks)*h0FacC(i,j,ks,bi,bj)
     &                                   *rStarFacC(i,j,bi,bj)
           ENDDO
          ENDDO
         ELSE
          DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
            IF ( kSurfC(i,j,bi,bj).EQ.1 ) THEN
             hOceMxL(i,j,bi,bj) = drF(ks)*hFac_surfC(i,j,bi,bj)
            ELSE
             hOceMxL(i,j,bi,bj) = drF(ks)*hFacC(i,j,ks,bi,bj)
            ENDIF
           ENDDO
          ENDDO
         ENDIF
        ELSE
#else /* ndef NONLIN_FRSURF */
        IF (.TRUE.) THEN
#endif /* NONLIN_FRSURF */
          DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
             hOceMxL(i,j,bi,bj) = drF(ks)*hFacC(i,j,ks,bi,bj)
           ENDDO
          ENDDO
        ENDIF

#ifdef ALLOW_SHELFICE
C--   Prevent seaice to form where Ice-Shelf is present
        IF ( useShelfIce ) THEN
          CALL SHELFICE_MASK_SEAICE(
     U                  hOceMxL,
     I                  bi, bj, myIter, myThid )
        ENDIF
#endif /* ALLOW_SHELFICE */

        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          tOceMxL(i,j,bi,bj) = theta(i,j,ks,bi,bj)
          sOceMxL(i,j,bi,bj) = salt (i,j,ks,bi,bj)
          v2ocMxL(i,j,bi,bj) = 0. _d 0
          icFrwAtm(i,j,bi,bj) = 0. _d 0
          icFlxAtm(i,j,bi,bj) = 0. _d 0
          icFlxSW (i,j,bi,bj) = 0. _d 0
          siceAlb (i,j,bi,bj) = 0. _d 0
         ENDDO
        ENDDO
        IF ( .NOT.useSEAICE ) THEN
         DO j=1-OLy,sNy+OLy-1
          DO i=1-OLx,sNx+OLx-1
           v2ocMxL(i,j,bi,bj) =
     &              ( uVel(i,j,ks,bi,bj) * uVel(i,j,ks,bi,bj)
     &              + uVel(i+1,j,ks,bi,bj)*uVel(i+1,j,ks,bi,bj)
     &              + vVel(i,j+1,ks,bi,bj)*vVel(i,j+1,ks,bi,bj)
     &              + vVel(i,j,ks,bi,bj) * vVel(i,j,ks,bi,bj)
     &              )*0.5 _d 0
         ENDDO
        ENDDO
#ifdef ALLOW_SEAICE
        ELSE
         DO j=1-OLy,sNy+OLy-1
          DO i=1-OLx,sNx+OLx-1
           uRel1 = uVel( i, j,ks,bi,bj)-uIce( i, j,bi,bj)
           uRel2 = uVel(i+1,j,ks,bi,bj)-uIce(i+1,j,bi,bj)
           vRel1 = vVel(i, j, ks,bi,bj)-vIce(i, j, bi,bj)
           vRel2 = vVel(i,j+1,ks,bi,bj)-vIce(i,j+1,bi,bj)
           v2ocMxL(i,j,bi,bj) =
     &              ( ( uRel1*uRel1 + uRel2*uRel2 )
     &              + ( vRel1*vRel1 + vRel2*vRel2 )
     &              )*0.5 _d 0
          ENDDO
         ENDDO
#endif /* ALLOW_SEAICE */
        ENDIF

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
#endif  /*ALLOW_THSICE*/

      RETURN
      END

#include "SMOOTH_OPTIONS.h"

      SUBROUTINE SMOOTH_INIT2D( smoothOpNb, myThid )

C     *==========================================================*
C     | SUBROUTINE smooth_init2D
C     | o Routine that initializes one 2D smoothing/correlation operator
C     |   by computing/writing the corresponding diffusion operator
C     *==========================================================*

Cgf the choices of smooth2Dtype and smooth2Dsize need comments...

      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "SMOOTH.h"

      INTEGER smoothOpNb
      INTEGER myThid

      INTEGER i, j, bi, bj
      CHARACTER*(MAX_LEN_FNAM) fnamegeneric

      INTEGER IL

c     == functions ==
      INTEGER  ILNBLNK
      EXTERNAL ILNBLNK

      IL = ILNBLNK( smoothDir )

      smooth2DtotTime = smooth2Dnbt(smoothOpNb)*smooth2DdelTime

      IF ( (smooth2Dtype(smoothOpNb).NE.0).AND.
     &     (smooth2Dsize(smoothOpNb).EQ.2) ) THEN
        WRITE(fnamegeneric,'(2A,I3.3)')
     &        smoothDir(1:IL),
     &        'smooth2Dscales',smoothOpNb
        CALL READ_REC_3D_RL( fnamegeneric, smoothprec,
     &                       1, smooth2D_Lx, 1, 1, myThid )
        CALL READ_REC_3D_RL( fnamegeneric, smoothprec,
     &                       1, smooth2D_Ly, 2, 1, myThid )
        CALL EXCH_XY_RL( smooth2D_Lx, myThid )
        CALL EXCH_XY_RL( smooth2D_Ly, myThid )
      ELSE
        DO bj=myByLo(myThid),myByHi(myThid)
         DO bi=myBxLo(myThid),myBxHi(myThid)
           DO j=1-OLy,sNy+OLy
            DO i=1-OLx,sNx+OLx
             smooth2D_Lx(i,j,bi,bj)=smooth2D_Lx0(smoothOpNb)
             smooth2D_Ly(i,j,bi,bj)=smooth2D_Ly0(smoothOpNb)
            ENDDO
           ENDDO
         ENDDO
        ENDDO
      ENDIF

      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           smooth2D_Kux(i,j,bi,bj)=smooth2D_Lx(i,j,bi,bj)*
     &            smooth2D_Lx(i,j,bi,bj)/smooth2DtotTime/2
           smooth2D_Kvy(i,j,bi,bj)=smooth2D_Ly(i,j,bi,bj)*
     &            smooth2D_Ly(i,j,bi,bj)/smooth2DtotTime/2
          ENDDO
         ENDDO
       ENDDO
      ENDDO

      CALL EXCH_XY_RL( smooth2D_Kux, myThid )
      CALL EXCH_XY_RL( smooth2D_Kvy, myThid )

C write diffusion operator to file
      WRITE(fnamegeneric,'(2A,I3.3)')
     &      smoothDir(1:IL),
     &      'smooth2Doperator', smoothOpNb
      CALL WRITE_REC_3D_RL( fnamegeneric, smoothprec,
     &                      1, smooth2D_Kux, 1, 1, myThid )
      CALL WRITE_REC_3D_RL( fnamegeneric, smoothprec,
     &                      1, smooth2D_Kvy, 2, 1, myThid )

      RETURN
      END

#include "DIAG_OPTIONS.h"

CBOP
C     !ROUTINE: DIAGSTATS_SET_POINTERS
C     !INTERFACE:
      SUBROUTINE DIAGSTATS_SET_POINTERS( myThid )

C     !DESCRIPTION: \bv
C     *==================================================================
C     | S/R DIAGSTATS_SET_POINTERS
C     | o set pointers for active statistics diagnostics
C     *==================================================================
C     \ev

C     !USES:
      IMPLICIT NONE

C     == Global variables ===
#include "EEPARAMS.h"
#include "SIZE.h"
#include "DIAGNOSTICS_SIZE.h"
#include "DIAGNOSTICS.h"
#include "DIAGSTATS_REGIONS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     myThid - Thread number for this instance of the routine.
      INTEGER myThid
CEOP

C     !LOCAL VARIABLES:
C     == Local variables ==
      INTEGER ndiagcount, ndCount
      INTEGER md,ld,nd
      INTEGER mm, mate, nActiveMax
      INTEGER j, k, l
      LOGICAL found, addMate2List, inList, regListPb
      CHARACTER*(MAX_LEN_MBUF) msgBuf

      _BEGIN_MASTER( myThid)

C--   Initialize pointer arrays to zero:
      DO ld=1,numlists
       DO md=1,numperlist
        iSdiag(md,ld) = 0
        jSdiag(md,ld) = 0
        mSdiag(md,ld) = 0
       ENDDO
      ENDDO

C--   Calculate pointers for diagnostics set to non-zero frequency

      ndiagcount = 0
      nActiveMax = 0
      DO ld=1,diagSt_nbLists
       diagSt_nbActv(ld) = diagSt_nbFlds(ld)
       DO md=1,diagSt_nbFlds(ld)

         found = .FALSE.
C        Search all possible model diagnostics
         DO nd=1,ndiagt
          IF ( diagSt_Flds(md,ld).EQ.cdiag(nd) ) THEN
            CALL DIAGSTATS_SETDIAG(mate,ndiagcount,md,ld,nd,myThid)
            found = .TRUE.
            jSdiag(md,ld) = nd
          ENDIF
         ENDDO
         IF ( .NOT.found ) THEN
           CALL DIAGNOSTICS_LIST_CHECK(
     O                      ndCount,
     I                      ld,md, diagSt_nbLists,
     I                      diagSt_nbFlds,diagSt_Flds,myThid)
           IF ( ndCount.EQ.0 ) THEN
             WRITE(msgBuf,'(3A)') 'DIAGSTATS_SET_POINTERS: ',
     &                     diagSt_Flds(md,ld),' is not a Diagnostic'
             CALL PRINT_ERROR( msgBuf , myThid )
           ENDIF
           STOP 'ABNORMAL END: S/R DIAGSTATS_SET_POINTERS'
         ENDIF
         IF ( found .AND. mate.LE.-1 ) THEN
C-       add this fields to the active list in case regions are differents:
           addMate2List = .FALSE.
           DO l=1,ld-1
            inList = .FALSE.
            DO k=1,diagSt_nbActv(l)
              IF ( diagSt_Flds(k,l).EQ.cdiag(-mate) ) inList=.TRUE.
            ENDDO
            IF ( inList ) THEN
             DO j=0,nRegions
              addMate2List = addMate2List
     &                 .OR. (diagSt_region(j,l).LT.diagSt_region(j,ld))
             ENDDO
            ENDIF
           ENDDO
           IF ( .NOT.addMate2List ) mate = 0
         ENDIF
         IF ( found .AND. mate.NE.0 ) THEN
            mm = diagSt_nbActv(ld) + 1
            IF ( mm.LE.numperlist ) THEN
             iSdiag(mm,ld) = SIGN(mSdiag(md,ld),mate)
             mate = ABS(mate)
             jSdiag(mm,ld) = mate
             diagSt_Flds(mm,ld) = cdiag(mate)
            ENDIF
            diagSt_nbActv(ld) = mm
         ENDIF

       ENDDO
       nActiveMax = MAX(diagSt_nbActv(ld),nActiveMax)
      ENDDO

      IF (  ndiagcount.LE.diagSt_size .AND.
     &      nActiveMax.LE.numperlist ) THEN
        WRITE(msgBuf,'(A,I8,A)')
     &    '  space allocated for all stats-diags:',
     &    ndiagcount, ' levels'
        CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
      ELSE
       IF ( ndiagcount.GT.diagSt_size ) THEN
         WRITE(msgBuf,'(2A)')
     &    'DIAGSTATS_SET_POINTERS: Not enough space',
     &    ' for all active stats-diags (from data.diagnostics)'
         CALL PRINT_ERROR( msgBuf , myThid )
         WRITE(msgBuf,'(A,I8,A,I8)')
     &    'DIAGSTATS_SET_POINTERS: diagSt_size=', diagSt_size,
     &    ' but needs at least', ndiagcount
         CALL PRINT_ERROR( msgBuf , myThid )
       ENDIF
       IF ( nActiveMax.GT.numperlist ) THEN
         WRITE(msgBuf,'(2A)')
     &    'DIAGSTATS_SET_POINTERS: Not enough space',
     &    ' for all active stats-diags (from data.diagnostics)'
         CALL PRINT_ERROR( msgBuf , myThid )
         WRITE(msgBuf,'(A,I6,A,I6)')
     &    'DIAGSTATS_SET_POINTERS: numperlist=', numperlist,
     &    ' but needs at least', nActiveMax
         CALL PRINT_ERROR( msgBuf , myThid )
       ENDIF
       STOP 'ABNORMAL END: S/R DIAGSTATS_SET_POINTERS'
      ENDIF

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C--   Set list of regions to write
C-    check that all selected regions are actually defined
      regListPb = .FALSE.
      DO l=1,diagSt_nbLists
       DO j=1,nRegions
        IF ( diagSt_region(j,l).NE.0 ) THEN
          IF ( diagSt_kRegMsk(j).LT.1 .OR.
     &         diagSt_kRegMsk(j).GT.nSetRegMask ) THEN
            WRITE(msgBuf,'(A,3(A,I5))') 'DIAGSTATS_SET_POINTERS:',
     &       ' region', j, ' undefined (k=', diagSt_kRegMsk(j),
     &       ') in list l=', l
            CALL PRINT_ERROR( msgBuf , myThid )
            regListPb = .TRUE.
          ENDIF
        ENDIF
       ENDDO
      ENDDO
      IF ( regListPb ) THEN
        WRITE(msgBuf,'(2A)') 'DIAGSTATS_SET_POINTERS:',
     &                       ' Cannot select undefined regions'
        CALL PRINT_ERROR( msgBuf , myThid )
        STOP 'ABNORMAL END: S/R DIAGSTATS_SET_POINTERS'
      ENDIF

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      WRITE(msgBuf,'(2A,2(I8,A))') 'DIAGSTATS_SET_POINTERS: done',
     &  ', use', ndiagcount, ' levels (diagSt_size=', diagSt_size, ' )'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(2A)')
     &   '------------------------------------------------------------'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )

      _END_MASTER( myThid )

      RETURN
      END

      program cvprofiles
c
c=======================================================================
c     converts binary float profiles to netCDF
c
c     * must be compiled with a FORTRAN90 compiler and netcdf library
c       f90 cvprofiles.F /usr/local/lib/libnetcdf.a
c       f90 cvprofiles.F /net/ice/ecco/lib/libnetcdf.a (for the ECCO cluster)
c     * uses namelist data.profiles
c
c     Arne Biastoch, abiastoch@ucsd.edu, 11/16/2000
c
c=======================================================================
c
      integer stdin, stdout, stderr
      parameter (stdin = 5, stdout = 6, stderr = 6)
c
      parameter (maxcoord=3000, maxdepth=100)
      character iotext*80, expnam*60, stamp*32
c
c variables for filenames
      integer narg, npart
      character*6 cpart
      character*1 split
      integer factor(6)
      data factor / 1.e5, 1.e4, 1.e3, 1.e2, 1.e1, 1.e0 /
      character*(80) dataFName
      logical exst
c
c     parameter(spval=-1.0e+23)
      parameter(spval=-999.)

c number of variables per record
c     parameter(imax=10)
      integer narg
      logical preflag
c
c netCDF ids
c
      integer  iret, ncid, VARid
      integer  partdim,Timedim,Dep_tdim, Dep_wdim, Dep_wm1dim
      integer  partid, Timeid
      integer  xpartid, ypartid, kpartid
      integer  tempid, saltid, uvelid, vvelid, zetaid
      integer  Dep_tid, Dep_wid, Dep_wm1id 
c
c variable shapes, corner and edge lengths
c
      integer dims(4), corner(4), edges(4)
c
      character*1 inumber(4)
c
c attribute vectors
c
      integer  longval(1)
      real  floatval(2)
      character*1 charval(1)
      character name*24, unit*16, grid*2
      logical   usingSphericalPolarGrid
      logical iedge
c 
c data variables for NetCDF
c
      real, dimension(:), allocatable :: Dep_t, Dep_w, Dep_wm1
      real, dimension(:),   allocatable :: pnum,time
      real, dimension(:,:), allocatable :: xpart,ypart,kpart,zeta
      real, dimension(:,:,:), allocatable :: uvel,vvel,temp,salt
      double precision, dimension(:), allocatable ::  tmp
c
c these variables cannot be allocatable because they appear in the namelist
c
      real delZ(maxdepth)
c
c namelist contains
c
      data npart /10/
      character*50 outname2
      character*50 fName, outname
      data fName / 'float_profiles' /
      character*20 startDate
      data startDate / '01-JAN-1992:12:00:00' /
      data expnam /'Experimentname not set in data.profiles'/
      data usingSphericalPolarGrid /.true./
      namelist /dimensions/ expnam, startDate, usingSphericalPolarGrid
      namelist /floats/ fName
      namelist /coord/ Nr, delZ
c
c in most systems netcdf.inc should be side in /usr/local/include
c     include '/usr/local/include/netcdf.inc'
c     include '/users/guests2/ux451985/netcdf/include/netcdf.inc'
      include '/net/ice/ecco/include/netcdf.inc'

      ioun=11
      open(ioun,file='data.profiles',status='old',form='formatted')
      read  (unit=ioun, end=666, nml=dimensions)
      write (stdout,dimensions)
      close (ioun)
 666  continue
      open(ioun,file='data.profiles',status='old',form='formatted')
      read  (unit=ioun, end=777, nml=coord)
c     write (stdout,coord)
      close (ioun)
 777  continue
      open(ioun,file='data.profiles',status='old',form='formatted')
      read  (unit=ioun, end=999, nml=floats)
      write (stdout,floats)
      close (ioun)
 999  continue

c
c     big data set:
c     if the data set contains a big number of particles and timesteps
c     it has to be read in chunks. This takes longer but fits better
c     into the memory. The argument preflag is used to indicate a big 
c     data set.
c
      preflag = .false.
      narg=iargc()
      if ( narg .gt. 0 ) preflag = .true.

c
c strip names
c
      IL=ILNBLNK( fName )

c check existent files
c
      iGmax=1
      do m=1,100
         write(dataFname(1:80),'(2a,i3.3,a,i3.3,a)')
     &             fName(1:IL),'.',iGmax,'.',1,'.data'
         inquire( file=dataFname, exist=exst )
         if (exst)  iGmax = iGmax + 1
      enddo

      jGmax=1
      do m=1,100
         write(dataFname(1:80),'(2a,i3.3,a,i3.3,a)')
     &             fName(1:IL),'.',1,'.',jGmax,'.data'
         inquire( file=dataFname, exist=exst )
         if (exst)  jGmax = jGmax + 1
      enddo

      iGmax = iGmax - 1
      jGmax = jGmax - 1
      print*, 'There are ',iGmax,' x ',jGmax,' files'

c open first file and get dimensions (float number and time)
c     
      imax=(6+4*Nr)
      ilen=imax*8

      allocate (tmp(imax))
c
      write(dataFname(1:80),'(2a,a)')
     &          fName(1:IL),'.001.001.data'
       open(1,file=dataFname,status='old',form='unformatted'
     &      ,access='direct',recl=ilen)
c
       read(1,rec=1) tmp
       rcountstart = SNGL(tmp(2))
       rcountdelta = SNGL(tmp(4))
       icount      = INT(tmp(5))
       npart       = INT(tmp(6))
       close(1)
      print*, 'npart    = ',npart
      print*, 'timesteps= ',icount
      if (preflag) then
         print*, 'big data set --> read in chunks'
      endif


c-----------------------------------------------------------------------
c     allocate variables
c-----------------------------------------------------------------------
c
      allocate (pnum(npart))
      allocate (time(icount))
      allocate (Dep_t(Nr))
      allocate (Dep_w(Nr+1))
      allocate (Dep_wm1(Nr))
      allocate (xpart(npart,icount))
      allocate (ypart(npart,icount))
      allocate (kpart(npart,icount))
      allocate (temp(npart,Nr,icount))
      if (.not. preflag) then
         allocate (uvel(npart,Nr,icount))
         allocate (vvel(npart,Nr,icount))
         allocate (salt(npart,Nr,icount))
      endif
      allocate (zeta(npart,icount))

c initialize arrays
c
      do m=1,npart
         do n=1,icount
            xpart(m,n) = spval
            ypart(m,n) = spval
            kpart(m,n) = spval
            do k=1,Nr
             if (.not. preflag) uvel(m,k,n) = spval
             if (.not. preflag) vvel(m,k,n) = spval
             temp(m,k,n) = spval
             if (.not. preflag) salt(m,k,n) = spval
            enddo
            zeta(m,n) = spval
         enddo
      enddo
c
c
c test if depth axis is evenly spaced (in that case no edges have to
c be set)
c
      iedge=.false.
      do k=2,Nr
         if (delZ(k) .ne. delZ(k-1)) then
            iedge=.true.
            goto 20
         endif
      enddo
 20   continue
c
      Dep_w(1)=0.
      Dep_wm1(1)=0.
      do k=2,Nr+1
         Dep_w(k)=Dep_w(k-1)+delZ(k-1)
         if (k .ne. Nr+1) Dep_wm1(k) = Dep_w(k)
      enddo
c
      do k=1,Nr
         Dep_t(k)=(Dep_w(k)+Dep_w(k+1))*0.5
      enddo
c
c generate axes
c
      time(1)=rcountstart
      do m=2,icount
         time(m) = time(m-1)+rcountdelta
      enddo
      print*, 'time: ',time
c
      do ip=1,npart
         pnum(ip) = FLOAT(ip)
      enddo
c      print*, 'pnum: ',pnum
c
c
c-----------------------------------------------------------------------
c     open files and read input
c-----------------------------------------------------------------------
c
      itotalrecord = 0

      do iG=1,iGmax
         do jG=1,jGmax
c
            write(dataFname(1:80),'(2a,i3.3,a,i3.3,a)')
     &                fName(1:IL),'.',iG,'.',jG,'.data'
            open(1,file=dataFname,status='old',form='unformatted'
     &           ,access='direct',recl=ilen)
c
            read(1,rec=1) tmp
            imaxrecord = INT(tmp(1))
            print*,'read ',dataFname,imaxrecord
            itotalrecord = itotalrecord + imaxrecord
c                goto 200

            do irec=2,imaxrecord+1

               read(1,rec=irec) tmp
               ip = INT(tmp(1))
               if (ip .gt. npart) then
                  print*,'ip out of order: ',ip,npart
                  stop
               endif
               np = INT((tmp(2)-rcountstart)/rcountdelta+1)


               if (usingSphericalPolarGrid) then
               xpart(ip,np)  = SNGL(tmp(3))
               ypart(ip,np)  = SNGL(tmp(4))
               else
               xpart(ip,np)  = SNGL(tmp(3))/1000.
               ypart(ip,np)  = SNGL(tmp(4))/1000.
               endif
               kpart(ip,np)  = SNGL(tmp(5))
               zeta(ip,np)   = SNGL(tmp(6))
               do k=1,Nr
                if (.not. preflag) uvel(ip,k,np)   = SNGL(tmp(6+k))
                if (.not. preflag) vvel(ip,k,np)   = SNGL(tmp(6+1*Nr+k))
                                   temp(ip,k,np)   = SNGL(tmp(6+2*Nr+k))
                if (.not. preflag) salt(ip,k,np)   = SNGL(tmp(6+3*Nr+k))
                  if (temp(ip,k,np) .eq. 0.) then
                    if (.not. preflag)  uvel(ip,k,np)   = spval
                    if (.not. preflag)  vvel(ip,k,np)   = spval
                                        temp(ip,k,np)   = spval
                    if (.not. preflag)  salt(ip,k,np)   = spval
                  endif
               enddo
c            print*, 'rec= ',irec,' npart= ',ip,' timestep= ',np
c     &      ,time(np),tmp
c     &     ,xpart(ip,np),ypart(ip,np),kpart(ip,np),uvel(ip,np,1),
c     &      vvel(ip,np,1),temp(ip,np,1),salt(ip,np,1),zeta(ip,np)
 100           continue
            enddo

            close(1)
 200            continue
         enddo
      enddo

      print*,icount,' x ',npart,' = ',icount*npart,' records expected,',
     & ' found ',itotalrecord,' float records'
      print*,'==> ',icount*npart-itotalrecord,' float records missing'
c
c-----------------------------------------------------------------------
c     define netCDF variables
c-----------------------------------------------------------------------
c
      write(stdout,*) ' Start Converting'
c
c enter define mode: NCCLOB=overwrite, NCNOCLOB=do not overwrite
c
      IL=ILNBLNK( fname )
      outname2=fname(1:IL)//'.cdf'
      write (stdout,*)
     &       ' ==>  Writing a profiles to file ',outname2(1:IL+4)
      ncid = nccre(outname2(1:IL+4), NCCLOB, iret)
      if (iret .ne. 0) write(stdout,*) 'Error: Open NetCDF file'
c 
c define dimensions
c
      partdim = ncddef(ncid, 'Particles', npart, iret)
      Dep_tdim  = ncddef(ncid, 'Depth_t',     Nr, iret)
      Dep_wm1dim= ncddef(ncid, 'Depth_wm1',   Nr, iret)
      Dep_wdim  = ncddef(ncid, 'Depth_w',   Nr+1, iret)
      Timedim = ncddef(ncid, 'Time', NCUNLIM, iret)
      if (iret .ne. 0) write(stdout,*) 'Error: define dimensions'
c
c define variables
c
      dims(1)  = partdim
      partid  = ncvdef (ncid,'Particles',NCFLOAT,1,dims,iret)
      dims(1)  = Dep_tdim
      Dep_tid  = ncvdef (ncid,'Depth_t',    NCFLOAT,1,dims,iret)
      dims(1)  = Dep_wdim
      Dep_wid  = ncvdef (ncid,'Depth_w',    NCFLOAT,1,dims,iret)
      dims(1)  = Dep_wm1dim
      Dep_wm1id= ncvdef (ncid,'Depth_wm1',  NCFLOAT,1,dims,iret)
      dims(1)  = Timedim
      Timeid   = ncvdef (ncid,'Time',   NCFLOAT,1,dims,iret)
      if (iret .ne. 0) write(stdout,*) 'Error: define axis ids'
c
      dims(1) = partdim
      dims(2) = Timedim
      xpartid = ncvdef (ncid,'xpart', NCFLOAT,2,dims,iret)
      ypartid = ncvdef (ncid,'ypart', NCFLOAT,2,dims,iret)
      kpartid = ncvdef (ncid,'kpart', NCFLOAT,2,dims,iret)
      zetaid  = ncvdef (ncid,'zeta',  NCFLOAT,2,dims,iret)
c
      dims(1) = partdim
      dims(2) = Dep_tdim
      dims(3) = Timedim
      uvelid  = ncvdef (ncid,'uvel',  NCFLOAT,3,dims,iret)
      vvelid  = ncvdef (ncid,'vvel',  NCFLOAT,3,dims,iret)
      tempid  = ncvdef (ncid,'temp',  NCFLOAT,3,dims,iret)
      saltid  = ncvdef (ncid,'salt',  NCFLOAT,3,dims,iret)
      if (iret .ne. 0) write(stdout,*) 'Error: define variable ids'
c
c-----------------------------------------------------------------------
c     assign attributes
c-----------------------------------------------------------------------
c
      charval(1) = ' '
c      
      name = 'Particles Number    '
c      unit = 'particle number  '
      call ncaptc(ncid, partid, 'long_name', NCCHAR, 24, name, iret) 
      call ncaptc(ncid, partid, 'units',     NCCHAR, 16, unit, iret) 
c
      name = 'Time'
      unit = 'seconds'
      call ncaptc(ncid, Timeid, 'long_name', NCCHAR, 24, name, iret) 
      call ncaptc(ncid, Timeid, 'units',     NCCHAR, 16, unit, iret) 
      call ncaptc(ncid, Timeid,'time_origin',NCCHAR, 20,startDate, iret)
      if (iret .ne. 0) write(stdout,*) 'Error: assign axis attributes'
c
c      
      name = 'Depth of T grid points  '
      unit = 'meters          '
      call ncaptc(ncid, Dep_tid, 'long_name', NCCHAR, 24, name, iret) 
      call ncaptc(ncid, Dep_tid, 'units',     NCCHAR, 16, unit, iret) 
      call ncaptc(ncid, Dep_tid, 'positive',  NCCHAR, 4, 'down',iret)     
c     call ncaptc(ncid, Dep_tid, 'point_spacing',NCCHAR,6,'uneven',iret)     
      if (iedge)
     & call ncaptc(ncid, Dep_tid, 'edges',NCCHAR, 7,'Depth_w',iret)     
c      
      name = 'Depth at top of T box'
      unit = 'meters          '
      call ncaptc(ncid, Dep_wm1id, 'long_name', NCCHAR, 24, name, iret) 
      call ncaptc(ncid, Dep_wm1id, 'units',     NCCHAR, 16, unit, iret) 
      call ncaptc(ncid, Dep_wm1id, 'positive',  NCCHAR, 4, 'down',iret)     
c
      name = 'Depth at bottom of T box'
      unit = 'meters          '
      call ncaptc(ncid, Dep_wid, 'long_name', NCCHAR, 24, name, iret) 
      call ncaptc(ncid, Dep_wid, 'units',     NCCHAR, 16, unit, iret) 
      call ncaptc(ncid, Dep_wid, 'positive',  NCCHAR, 4, 'down',iret)     
      floatval(1) = spval
c
      if (usingSphericalPolarGrid) then
         name = 'LONGITUDE '
         unit = 'degrees_W '
      else
         name = 'X_t '
         unit = 'kilometer '
      endif
      call ncaptc(ncid, xpartid, 'long_name', NCCHAR, 24, name, iret) 
      call ncaptc(ncid, xpartid, 'units',     NCCHAR, 16, unit, iret) 
      call ncapt (ncid, xpartid,'missing_value',NCFLOAT,1,floatval,iret)
      call ncapt (ncid, xpartid,'_FillValue', NCFLOAT, 1,floatval, iret)
c
      if (usingSphericalPolarGrid) then
         name = 'LATITUDE '
         unit = 'degrees_N '
      else
         name = 'Y_t '
         unit = 'kilometer '
      endif
      call ncaptc(ncid, ypartid, 'long_name', NCCHAR, 24, name, iret) 
      call ncaptc(ncid, ypartid, 'units',     NCCHAR, 16, unit, iret) 
      call ncapt (ncid, ypartid,'missing_value',NCFLOAT,1,floatval,iret)
      call ncapt (ncid, ypartid,'_FillValue', NCFLOAT, 1,floatval, iret)
c
      name = 'LEVEL '
      unit = 'LEVEL '
      call ncaptc(ncid, kpartid, 'long_name', NCCHAR, 24, name, iret) 
      call ncaptc(ncid, kpartid, 'units',     NCCHAR, 16, unit, iret) 
      call ncapt (ncid, kpartid,'missing_value',NCFLOAT,1,floatval,iret)
      call ncapt (ncid, kpartid,'_FillValue', NCFLOAT, 1,floatval, iret)
c
      name = 'POTENTIAL TEMPERATURE '
      unit = 'deg C '
      call ncaptc(ncid, tempid, 'long_name', NCCHAR, 24, name, iret) 
      call ncaptc(ncid, tempid, 'units',     NCCHAR, 16, unit, iret) 
      call ncapt (ncid, tempid, 'missing_value',NCFLOAT,1,floatval,iret)
      call ncapt (ncid, tempid, '_FillValue', NCFLOAT, 1,floatval, iret)
c
      name = 'SALINITY '
      unit = 'PSU '
      call ncaptc(ncid, saltid, 'long_name', NCCHAR, 24, name, iret) 
      call ncaptc(ncid, saltid, 'units',     NCCHAR, 16, unit, iret) 
      call ncapt (ncid, saltid, 'missing_value',NCFLOAT,1,floatval,iret)
      call ncapt (ncid, saltid, '_FillValue', NCFLOAT, 1,floatval, iret)
c
      name = 'U VELOCITY '
      unit = 'm/sec'
      call ncaptc(ncid, uvelid, 'long_name', NCCHAR, 24, name, iret) 
      call ncaptc(ncid, uvelid, 'units',     NCCHAR, 16, unit, iret) 
      call ncapt (ncid, uvelid, 'missing_value',NCFLOAT,1,floatval,iret)
      call ncapt (ncid, uvelid, '_FillValue', NCFLOAT, 1,floatval, iret)
c
      name = 'V VELOCITY '
      unit = 'm/sec'
      call ncaptc(ncid, vvelid, 'long_name', NCCHAR, 24, name, iret) 
      call ncaptc(ncid, vvelid, 'units',     NCCHAR, 16, unit, iret) 
      call ncapt (ncid, vvelid, 'missing_value',NCFLOAT,1,floatval,iret)
      call ncapt (ncid, vvelid, '_FillValue', NCFLOAT, 1,floatval, iret)
c
      name = 'SEA SURFACE HEIGHT '
      unit = 'm '
      call ncaptc(ncid, zetaid, 'long_name', NCCHAR, 24, name, iret) 
      call ncaptc(ncid, zetaid, 'units',     NCCHAR, 16, unit, iret) 
      call ncapt (ncid, zetaid,'missing_value',NCFLOAT, 1,floatval,iret)
      call ncapt (ncid, zetaid,'_FillValue', NCFLOAT, 1, floatval, iret)
c
      if (iret .ne. 0) write(stdout,*) 'Error: define variable attrib.'
c
      expname= ' '
      stamp = ' '
      call ncaptc(ncid, NCGLOBAL, 'title',   NCCHAR, 60, expnam, iret)
      call ncaptc(ncid, NCGLOBAL, 'history', NCCHAR, 32, stamp, iret)
c
c-----------------------------------------------------------------------
c     leave define mode
c-----------------------------------------------------------------------
c
      call ncendf(ncid, iret)
c
c
c-----------------------------------------------------------------------
c     put variables in netCDF file
c-----------------------------------------------------------------------
c
c store Particles
      corner(1) = 1
      edges(1) = npart
      call ncvpt(ncid, partid, corner, edges, pnum, iret)
c
c store Time      
      corner(1) = 1 
      edges(1) = icount
      call ncvpt(ncid, Timeid, corner, edges, Time, iret)
c
c store Depth_t
      corner(1) = 1
      edges(1) = Nr
      call ncvpt(ncid, Dep_tid, corner, edges, Dep_t, iret)
c store Depth_w
      corner(1) = 1
      edges(1) = Nr+1
      call ncvpt(ncid, Dep_wid, corner, edges, Dep_w, iret)
c store Depth_wm1
      corner(1) = 1
      edges(1) = Nr
      call ncvpt(ncid, Dep_wm1id, corner, edges, Dep_wm1, iret)
c store 2D values
      corner(1) = 1
      corner(2) = 1
      edges(1) = npart
      edges(2) = icount
      VARid=xpartid
      call ncvpt(ncid, VARid, corner, edges, xpart, iret)
      VARid=ypartid
      call ncvpt(ncid, VARid, corner, edges, ypart, iret)
      VARid=kpartid
      call ncvpt(ncid, VARid, corner, edges, kpart, iret)
      VARid=zetaid
      call ncvpt(ncid, VARid, corner, edges, zeta, iret)
c store values
      corner(1) = 1
      corner(2) = 1
      corner(3) = 1
      edges(1) = npart
      edges(2) = Nr
      edges(3) = icount
      VARid=tempid
      call ncvpt(ncid, VARid, corner, edges, temp, iret)

      if (preflag) then
c read in salt into temp array
      do iG=1,iGmax
         do jG=1,jGmax
c
            write(dataFname(1:80),'(2a,i3.3,a,i3.3,a)')
     &                fName(1:IL),'.',iG,'.',jG,'.data'
            open(1,file=dataFname,status='old',form='unformatted'
     &           ,access='direct',recl=ilen)
c
            read(1,rec=1) tmp
            imaxrecord = INT(tmp(1))
            print*,'read salt from ',dataFname
            do irec=2,imaxrecord+1

               read(1,rec=irec) tmp
               ip = INT(tmp(1))
               np = INT((tmp(2)-rcountstart)/rcountdelta+1)
               do k=1,Nr
                  temp(ip,k,np)   = SNGL(tmp(6+3*Nr+k))
                  if (SNGL(tmp(6+2*Nr+k)) .eq. 0.) then
                     temp(ip,k,np)   = spval
                  endif
               enddo
            enddo
            close(1)
         enddo
      enddo
         VARid=saltid
         call ncvpt(ncid, VARid, corner, edges, temp, iret)

c read in u into temp array
      do iG=1,iGmax
         do jG=1,jGmax
c
            write(dataFname(1:80),'(2a,i3.3,a,i3.3,a)')
     &                fName(1:IL),'.',iG,'.',jG,'.data'
            open(1,file=dataFname,status='old',form='unformatted'
     &           ,access='direct',recl=ilen)
c
            read(1,rec=1) tmp
            imaxrecord = INT(tmp(1))
            print*,'read uvel from ',dataFname
            do irec=2,imaxrecord+1

               read(1,rec=irec) tmp
               ip = INT(tmp(1))
               np = INT((tmp(2)-rcountstart)/rcountdelta+1)
               do k=1,Nr
                  temp(ip,k,np)   = SNGL(tmp(6+k))
                  if (SNGL(tmp(6+2*Nr+k)) .eq. 0.) then
                     temp(ip,k,np)   = spval
                  endif
               enddo
            enddo
            close(1)
         enddo
      enddo
         VARid=uvelid
         call ncvpt(ncid, VARid, corner, edges, temp, iret)

c read in v into temp array
      do iG=1,iGmax
         do jG=1,jGmax
c
            write(dataFname(1:80),'(2a,i3.3,a,i3.3,a)')
     &                fName(1:IL),'.',iG,'.',jG,'.data'
            open(1,file=dataFname,status='old',form='unformatted'
     &           ,access='direct',recl=ilen)
c
            read(1,rec=1) tmp
            imaxrecord = INT(tmp(1))
            print*,'read vvel from ',dataFname
            do irec=2,imaxrecord+1

               read(1,rec=irec) tmp
               ip = INT(tmp(1))
               np = INT((tmp(2)-rcountstart)/rcountdelta+1)
               do k=1,Nr
                  temp(ip,k,np)   = SNGL(tmp(6+1*Nr+k))
                  if (SNGL(tmp(6+2*Nr+k)) .eq. 0.) then
                     temp(ip,k,np)   = spval
                  endif
               enddo
            enddo
            close(1)
         enddo
      enddo
         VARid=vvelid
         call ncvpt(ncid, VARid, corner, edges, temp, iret)

      else

         VARid=saltid
         call ncvpt(ncid, VARid, corner, edges, salt, iret)
         VARid=uvelid
         call ncvpt(ncid, VARid, corner, edges, uvel, iret)
         VARid=vvelid
         call ncvpt(ncid, VARid, corner, edges, vvel, iret)

      endif
c
      if (iret .ne. 0) write(stdout,*) 'Error: write variables'
      call ncclos (ncid, iret)
c
      write(stdout,*) ' End '
 
      end


      INTEGER FUNCTION ILNBLNK( string )
C     /==========================================================\
C     | FUNCTION ILNBLNK                                         |
C     | o Find last non-blank in character string.               |
C     \==========================================================/
      IMPLICIT NONE
      CHARACTER*(*) string
CEndOfInterface
      INTEGER L, LS
C
      LS      = LEN(string)
      ILNBLNK = LS
      DO 10 L = LS, 1, -1
        IF ( string(L:L) .EQ. ' ' ) GOTO 10
         ILNBLNK = L
         GOTO 11
   10 CONTINUE
   11 CONTINUE
C
      RETURN
      END

#include "MDSIO_OPTIONS.h"

CBOP
C     !ROUTINE: MDS_READ_META
C     !INTERFACE:
      SUBROUTINE MDS_READ_META(
     I               fileName,
     O               simulName,
     O               titleLine,
     O               filePrec,
     U               nDims,   nFlds,   nTimRec,
     O               dimList, fldList, timList,
     O               misVal, nRecords, fileIter,
     I               useCurrentDir,
     I               myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R MDS_READ_META
C     | o Read the content of 1 meta file
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     == Global variables / common blocks
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"

C     !INPUT PARAMETERS:
C     fileName  (string ) :: prefix of meta-file name
C     nDims     (integer) :: max size of array dimList (or =0 if not reading dimList)
C     nFlds     (integer) :: max size of array fldList (or =0 if not reading fldList)
C     nTimRec   (integer) :: max size of array timList (or =0 if not reading timList)
C     useCurrentDir(logic):: always read from the current directory (even if
C                            "mdsioLocalDir" is set)
C     myThid    (integer) :: my Thread Id number
C
C     !OUTPUT PARAMETERS:
C     simulName (string)  :: name of simulation (recorded in file)
C     titleLine (string)  :: title or any descriptive comments (in file)
C     filePrec  (integer) :: number of bits per word in data-file (32 or 64)
C     nDims     (integer) :: number of dimensions
C     dimList   (integer) :: array of dimensions
cC    map2gl    (integer) :: used for mapping tiled file to global file
C     nFlds     (integer) :: number of fields in "fldList"
C     fldList   (string)  :: list of fields (names) stored in file
C     nTimRec   (integer) :: number of time-specification in "timList"
C     timList   (real)    :: array of time-specifications (recorded in file)
C     misVal    (real)    :: missing value
C     nRecords  (integer) :: number of records
C     fileIter  (integer) :: time-step number (recorded in file)
C
      CHARACTER*(*) fileName
      CHARACTER*(*) simulName
      CHARACTER*(*) titleLine
      INTEGER filePrec
      INTEGER nDims
      INTEGER dimList(3,*)
c     INTEGER map2gl(2)
      INTEGER nFlds
      CHARACTER*(8) fldList(*)
      INTEGER nTimRec
      _RL     timList(*)
      _RL     misVal
      INTEGER nRecords
      INTEGER fileIter
      LOGICAL useCurrentDir
      INTEGER myThid
CEOP

C     !FUNCTIONS
      INTEGER  ILNBLNK
      EXTERNAL ILNBLNK

C     !LOCAL VARIABLES:
C     i, j, ii    :: loop indices
C     iG,jG       :: global tile indices
C     iL,pL,iLm   :: length of character strings (temp. variables)
C     nDimFil     :: number of dimensions (in meta file)
C     nFldFil     :: number of fields in "fldList" (in meta file)
C     nTimFil     :: number of time-specification in "timList" (meta file)
      INTEGER i,j,ii
      INTEGER iG,jG
      INTEGER iL,pL,iLm
      INTEGER mUnit, errIO
      INTEGER nDimFil, nFldFil, nTimFil
      LOGICAL fileExist, globalFile
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      CHARACTER*(MAX_LEN_MBUF) lineBuf
      CHARACTER*(MAX_LEN_FNAM) mFileName, pfName

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C--   Initialise output arguments
      simulName = ' '
      titleLine = ' '
      filePrec  = 0
      nRecords  = 0
      fileIter  = 0
c     map2gl(1) = 0
c     map2gl(2) = 1
      DO j=1,nDims
       DO i=1,3
        dimList(i,j) = 0
       ENDDO
      ENDDO
      DO i=1,nFlds
       fldList(i)= ' '
      ENDDO
      DO i=1,nTimRec
       timList(i) = 0.
      ENDDO
      misVal = oneRL
C--   Initialise Temp Var.
      fileExist  = .FALSE.
      globalFile = .FALSE.
      nDimFil   = 0
      nFldFil   = 0
      nTimFil   = 0

C--   Only Master thread check for file, open & read ; others will
C     return null argument ; sharing output needs to be done outside
C     this S/R, using, e.g., common block (+ Master_thread + Barrier)
      _BEGIN_MASTER( myThid )

C     Assign special directory
      iL = ILNBLNK(fileName)
      pL = ILNBLNK( mdsioLocalDir )
      IF ( useCurrentDir .OR. pL.EQ.0 ) THEN
        pfName = fileName
      ELSE
        WRITE(pfName,'(2A)') mdsioLocalDir(1:pL), fileName(1:iL)
      ENDIF
      pL = ILNBLNK( pfName )

C--   Search for meta file:
C-    look for meta-file = {fileName}
      mFileName = fileName(1:iL)
      iLm = iL
c     INQUIRE( FILE=mFileName, EXIST=fileExist )
      IF ( .NOT.fileExist ) THEN
C-    look for meta-file = {fileName}'.meta'
        WRITE(mFileName,'(2A)') fileName(1:iL), '.meta'
        iLm = iL+5
        INQUIRE( FILE=mFileName, EXIST=fileExist )
      ENDIF
      IF ( fileExist ) THEN
        globalFile = .TRUE.
      ELSE
C-    look for meta-file = {fileName}'.{iG}.{jG}.meta'
        iG = 1+(myXGlobalLo-1)/sNx
        jG = 1+(myYGlobalLo-1)/sNy
        WRITE(mFileName,'(2A,I3.3,A,I3.3,A)')
     &             pfName(1:pL),'.',iG,'.',jG,'.meta'
        iLm = pL+8+5
        INQUIRE( FILE=mFileName, EXIST=fileExist )
      ENDIF
      IF ( .NOT.fileExist ) THEN
C-    look for meta-file = {fileName}'.001.001.meta'
        WRITE(mFileName,'(2A,I3.3,A,I3.3,A)')
     &             pfName(1:pL),'.',1,'.',1,'.meta'
        iLm = pL+8+5
        INQUIRE( FILE=mFileName, EXIST=fileExist )
      ENDIF
      IF ( .NOT.fileExist ) THEN
        WRITE(msgBuf,'(4A)') 'WARNING >> MDS_READ_META: file: ',
     &          fileName(1:iL), '.meta , ', mFileName(1:iLm)
c    &               fileName(1:iL), ' , ', mFileName(1:iLm)
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                        SQUEEZE_RIGHT , myThid )
        WRITE(msgBuf,'(A)')
     &           'WARNING >> MDS_READ_META: Files DO not exist'
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                        SQUEEZE_RIGHT , myThid )
        nFldFil = -1
      ELSE

C--   File exist
        IF ( debugLevel .GE. debLevB ) THEN
          WRITE(msgBuf,'(2A)') ' MDS_READ_META: opening file: ',
     &                        mFileName(1:iLm)
          CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                        SQUEEZE_RIGHT , myThid)
        ENDIF

C-    Assign a free unit number as the I/O channel for this subroutine
        CALL MDSFINDUNIT( mUnit, myThid )

C-    Open meta-file
        OPEN( mUnit, FILE=mFileName, STATUS='old', _READONLY_ACTION
     &        FORM='formatted', IOSTAT=errIO )
c       write(0,*) 'errIO=',errIO
        IF ( errIO .NE. 0 ) THEN
          WRITE(msgBuf,'(A,A)') 'MDS_READ_META: Unable to open file: ',
     &                           mFileName(1:iLm)
          CALL PRINT_ERROR( msgBuf , myThid )
          STOP 'ABNORMAL END: S/R MDS_READ_META'
        ENDIF

C-    Read the meta file in the same way as S/R OPEN_COPY_DATA_FILE
C     (which seems to be works on many platforms):
        DO WHILE ( .TRUE. )
         READ( mUnit, FMT='(A)', END=1001 ) lineBuf
C--   Extract information from buffer: "lineBuf"
         iL = ILNBLNK(lineBuf)

C-    Read simulation name (stored in file)
         IF ( iL.GE.22 .AND. lineBuf(1:14).EQ.' simulation = ' ) THEN
          ii = LEN(simulName)
c         IF ( ii.LT.iL-21 )  print 'warning: truncate simulName'
          ii = MIN(ii+17,iL-4)
          simulName = lineBuf(18:ii)
          iL = 0
         ENDIF

C-    Read the number of dimensions
         IF ( nDimFil.EQ.0 .AND.
     &        iL.GE.15 .AND. lineBuf(1:9).EQ.' nDims = ' ) THEN
          READ(lineBuf(12:iL),'(I3)') nDimFil
          IF ( nDimFil.GT.nDims .AND. nDims.GE.1 ) THEN
            WRITE(msgBuf,'(2(A,I3),A)') ' MDS_READ_META: nDims=',
     &                   nDimFil, ' too large ( >', nDims, ' )'
            CALL PRINT_ERROR( msgBuf, myThid )
            STOP 'ABNORMAL END: S/R MDS_READ_META'
          ENDIF
          iL = 0
         ENDIF

C-    Read list of dimensions
         IF ( nDims.GE.1 .AND. nDimFil.GE.1 .AND.
     &        iL.GE.11 .AND. lineBuf(1:11).EQ.' dimList = ' ) THEN
C-    For each dimension, read the following:
C     1  global size  (ie. the size of the global dimension of all files)
C     2  global start (ie. the global position of the start of this file)
C     3  global end   (ie. the global position of the end   of this file)
          DO j=1,nDimFil
C-    This is to accomodate with the 2 versions of meta file:
           READ( mUnit, FMT='(A)', END=1001 ) lineBuf
           ii = ILNBLNK(lineBuf)
           IF ( ii.LT.20 ) THEN
C     New version (S/R MDS_WRITE_META, file mdsio_write_meta.F):
C          small-size domain without starting blanks.
            READ(lineBuf, FMT='(3(1X,I5))',    ERR=1002, END=1002 )
     &                  (dimList(i,j),i=1,3)
           ELSEIF ( ii.LT.30 ) THEN
C     Old version (S/R MDSWRITEMETA, file mdsio_writemeta.F):
C          start each line with 10 blanks.
            READ(lineBuf, FMT='(9X,3(1X,I5))', ERR=1002, END=1002 )
     &                  (dimList(i,j),i=1,3)
           ELSE
C     New version (S/R MDS_WRITE_META, file mdsio_write_meta.F):
C          large-size domain without starting blanks.
            READ(lineBuf, FMT='(3(1X,I10))',   ERR=1002, END=1002 )
     &                  (dimList(i,j),i=1,3)
           ENDIF
          ENDDO
          READ(  mUnit, FMT='(A)', END=1001 ) lineBuf
          iL = 0
         ENDIF

C-    only write if different from default:
c     IF ( map2gl(1).NE.0 .OR. map2gl(2).NE.1 ) THEN
c       WRITE(mUnit,'(1X,2(A,I5),A)') 'map2glob = [ ',
c    &                  map2gl(1),',',map2gl(2),' ];'
c     ENDIF

C-    Read the precision of the file
         IF ( iL.GE.20 .AND. lineBuf(1:12).EQ.' dataprec = ' ) THEN
          IF (     lineBuf(16:22).EQ. 'float32' )  THEN
            filePrec = precFloat32
          ELSEIF ( lineBuf(16:22).EQ. 'float64' ) THEN
            filePrec = precFloat64
          ELSE
            WRITE(msgBuf,'(A)') ' MDS_READ_META: invalid dataprec'
            CALL PRINT_ERROR( msgBuf, myThid )
            CALL PRINT_ERROR(lineBuf, myThid )
            STOP 'ABNORMAL END: S/R MDS_READ_META'
          ENDIF
          iL = 0
         ENDIF
C-    Read (old format) precision of the file
         IF ( filePrec.EQ.0 .AND.
     &        iL.GE.18 .AND. lineBuf(1:10).EQ.' format = ' ) THEN
          IF (     lineBuf(14:20).EQ. 'float32' )  THEN
            filePrec = precFloat32
          ELSEIF ( lineBuf(14:20).EQ. 'float64' ) THEN
            filePrec = precFloat64
          ELSE
            WRITE(msgBuf,'(A)') ' MDS_READ_META: invalid dataprec'
            CALL PRINT_ERROR( msgBuf, myThid )
            CALL PRINT_ERROR(lineBuf, myThid )
            STOP 'ABNORMAL END: S/R MDS_READ_META'
          ENDIF
          iL = 0
         ENDIF

C-    Read the number of records
         IF ( nRecords.EQ.0 .AND.
     &        iL.GE.20 .AND. lineBuf(1:12).EQ.' nrecords = ' ) THEN
          IF ( iL.GE.25 ) THEN
            READ(lineBuf(15:iL),'(I10)') nRecords
          ELSE
            READ(lineBuf(15:iL),'(I5)') nRecords
          ENDIF
          iL = 0
         ENDIF

C-    Read recorded iteration number
         IF ( fileIter.EQ.0 .AND. iL.GE.31 .AND.
     &        lineBuf(1:18).EQ.' timeStepNumber = ' ) THEN
          READ(lineBuf(21:iL),'(I10)') fileIter
          iL = 0
         ENDIF

C-    Read list of Time Intervals
         IF ( nTimFil.EQ.0 .AND.
     &        iL.GE.38 .AND. lineBuf(1:16).EQ.' timeInterval = ' ) THEN
C note: format might change once we have a better idea of what will
C       be the time-information to write.
          nTimFil = INT((iL-17-3)/20)
          IF ( nTimRec.GE.1 ) THEN
            IF ( nTimFil.GT.nTimRec ) THEN
             WRITE(msgBuf,'(2(A,I6),A)') ' MDS_READ_META: nTimRec=',
     &                    nTimFil, ' too large ( >', nTimRec, ' )'
             CALL PRINT_ERROR( msgBuf, myThid )
             STOP 'ABNORMAL END: S/R MDS_READ_META'
            ENDIF
            READ(lineBuf(18:iL-3),'(1P20E20.12)',ERR=1003)
     &                            (timList(i),i=1,nTimFil)
          ENDIF
          iL = 0
         ENDIF

         IF ( iL.GE.8 .AND. lineBuf(1:4).EQ.' /* ' ) THEN
          IF ( lineBuf(iL-2:iL).EQ.' */' ) THEN
C-    Read title or comments (ignored by rdmds)
           ii = LEN(titleLine)
c          IF ( ii.LT.iL-7 )  print 'warning: truncate titleLine'
           ii = MIN(ii+4,iL-3)
           titleLine = lineBuf(5:ii)
           iL = 0
          ENDIF
         ENDIF

C-    Read missing value
         IF ( misVal.EQ.oneRL .AND. iL.GE.40 .AND.
     &        lineBuf(1:16).EQ.' missingValue = ' ) THEN
          READ(lineBuf(19:iL),'(1PE21.14)') misVal
          iL = 0
         ENDIF

C-    Read number of Fields
         IF ( nFldFil.EQ.0 .AND.
     &        iL.GE.16 .AND. lineBuf(1:9).EQ.' nFlds = ' ) THEN
          READ(lineBuf(12:iL),'(I4)') nFldFil
          IF ( nFldFil.GT.nFlds .AND. nFlds.GE.1 ) THEN
            WRITE(msgBuf,'(2(A,I6),A)') ' MDS_READ_META: nFlds=',
     &                   nFldFil, ' too large ( >', nFlds, ' )'
            CALL PRINT_ERROR( msgBuf, myThid )
            STOP 'ABNORMAL END: S/R MDS_READ_META'
          ENDIF
          iL = 0
         ENDIF

C-    Read list of Fields
         IF ( nFldFil.GE.1 .AND. nFlds.GE.1 .AND.
     &        iL.GE.11 .AND. lineBuf(1:11).EQ.' fldList = ' ) THEN
          DO j=1,nFldFil,20
           READ( mUnit, FMT='(20(2X,A8,1X))', ERR=1004, END=1004 )
     &          (fldList(i),i=j,MIN(nFldFil,j+19))
          ENDDO
          READ(  mUnit, FMT='(A)', END=1001 ) lineBuf
          iL = 0
         ENDIF

C--   End of reading file line per line
        ENDDO
 1004   CONTINUE
        WRITE(msgBuf,'(2(A,I4),A)')
     &    ' MDS_READ_META: error reading Fields: nFlds=',
     &     nFldFil, ' , j=', j
        CALL PRINT_ERROR( msgBuf, myThid )
        STOP 'ABNORMAL END: S/R MDS_READ_META'
 1003   CONTINUE
        WRITE(msgBuf,'(2(A,I4),A)')
     &    ' MDS_READ_META: error reading Time-Interval: nTimRec=',
     &     nTimFil, ' , iL=', iL
        CALL PRINT_ERROR( msgBuf, myThid )
        CALL PRINT_ERROR(lineBuf, myThid )
        STOP 'ABNORMAL END: S/R MDS_READ_META'
 1002   CONTINUE
        WRITE(msgBuf,'(3(A,I3),A)')
     &    ' MDS_READ_META: error reading Dim-List: nDims=',
     &     nDimFil, ' , j=', j, ' , ii=', ii
        CALL PRINT_ERROR( msgBuf, myThid )
        CALL PRINT_ERROR(lineBuf, myThid )
        STOP 'ABNORMAL END: S/R MDS_READ_META'
 1001   CONTINUE

C-    Close meta-file
        CLOSE(mUnit)

C-    end if block: file exist
      ENDIF

      _END_MASTER( myThid )

C-    Update Arguments with values read from file
      nDims   = nDimFil
      nFlds   = nFldFil
      nTimRec = nTimFil

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      RETURN
      END

#include "GCHEM_OPTIONS.h"

CBOP
C !ROUTINE: GCHEM_READPARMS

C !INTERFACE: ==========================================================
      SUBROUTINE GCHEM_READPARMS( myThid )

C !DESCRIPTION:
C     Initialize GCHEM parameters, read in data.gchem

C !USES: ===============================================================
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GCHEM.h"
#ifdef ALLOW_CAL
# include "cal.h"
#endif

C !INPUT PARAMETERS: ===================================================
C  myThid         :: thread number
      INTEGER myThid

C !OUTPUT PARAMETERS: ==================================================
C  none

#ifdef ALLOW_GCHEM

C !LOCAL VARIABLES: ====================================================
C  tIter0         :: retired parameter
C  iUnit          :: unit number for I/O
C  msgBuf         :: message buffer
      INTEGER tIter0
      INTEGER iUnit
      CHARACTER*(MAX_LEN_MBUF) msgBuf
CEOP

C- Sub-package on/off flags: not fully implemented, requires
C  to test the flag before any corresponding pkg S/R call

      NAMELIST /GCHEM_PARM01/
     &                   useCFC,
     &                   useDIC,
     &                   useBLING,
     &                   useSPOIL,
     &                   useDARWIN,
     &           fileName1, fileName2, fileName3,
     &           fileName4, fileName5,
     &           gchem_int1, gchem_int2, gchem_int3,
     &           gchem_int4, gchem_int5, nsubtime,
     &           gchem_rl1, gchem_rl2, gchem_rl3,
     &           gchem_rl4, gchem_rl5,
     &           gchem_ForcingPeriod, gchem_ForcingCycle,
     &           gchem_secondsPerYear,
     &           tIter0

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      IF ( .NOT.useGCHEM ) THEN
C-    pkg GCHEM is not used
        _BEGIN_MASTER(myThid)
C-    Track pkg activation status:
C     print a (weak) warning if data.gchem is found
         CALL PACKAGES_UNUSED_MSG( 'useGCHEM', ' ', ' ' )
        _END_MASTER(myThid)
        RETURN
      ENDIF

      _BEGIN_MASTER(myThid)

C- Set defaults values for parameters in GCHEM.h
       useCFC = .FALSE.
       useDIC = .FALSE.
       useBLING  = .FALSE.
       useSPOIL  = .FALSE.
       useDARWIN = .FALSE.
       tIter0 = UNSET_I
       fileName1=' '
       fileName2=' '
       fileName3=' '
       fileName4=' '
       fileName5=' '
       nsubtime = 1
       gchem_int1=0
       gchem_int2=0
       gchem_int3=0
       gchem_int4=0
       gchem_int5=0
       gchem_rl1=0. _d 0
       gchem_rl2=0. _d 0
       gchem_rl3=0. _d 0
       gchem_rl4=0. _d 0
       gchem_rl5=0. _d 0
C  default periodic forcing to same as for physics
       gchem_ForcingPeriod=externForcingPeriod
       gchem_ForcingCycle=externForcingCycle
C  default based on 360 day year or related to calendar settings
       gchem_secondsPerYear   = 360. _d 0 * 86400. _d 0
#ifdef ALLOW_CAL
       IF ( useCAL ) THEN
        IF ( theCalendar .EQ. 'gregorian') THEN
         gchem_secondsPerYear = 365.25 _d 0*86400. _d 0
        ELSEIF ( theCalendar .EQ. 'noLeapYear') THEN
         gchem_secondsPerYear = 365.00 _d 0*86400. _d 0
        ENDIF
       ENDIF
#endif
C- Open and read the data.gchem file
      WRITE(msgBuf,'(A)') ' GCHEM_READPARMS: opening data.gchem'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      CALL OPEN_COPY_DATA_FILE(
     I                   'data.gchem', 'GCHEM_PARM01',
     O                   iUnit,
     I                   myThid )
      READ(UNIT=iUnit,NML=GCHEM_PARM01)
      WRITE(msgBuf,'(A)')
     &  ' GCHEM_READPARMS: finished reading data.gchem'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )

C- Close the open data file
#ifdef SINGLE_DISK_IO
      CLOSE(iUnit)
#else
      CLOSE(iUnit,STATUS='DELETE')
#endif /* SINGLE_DISK_IO */

C- Check for retired parameters:
      IF ( tIter0 .NE. UNSET_I ) THEN
c      nRetired = nRetired+1
       WRITE(msgBuf,'(A,A)')
     &  'S/R GCHEM_READPARMS: Paramater "tIter0" is',
     &  ' no longer allowed in file "data.gchem"'
       CALL PRINT_ERROR( msgBuf, myThid )
       WRITE(msgBuf,'(A,A)')
     &  'S/R GCHEM_READPARMS: "tIter0" has been moved to',
     &  ' PTRACERS_Iter0 in file "data.ptracers".'
       CALL PRINT_ERROR( msgBuf, myThid )
       STOP 'ABNORMAL END: S/R GCHEM_READPARMS'
      ENDIF

      _END_MASTER(myThid)

C  Everyone else must wait for the parameters to be loaded
      _BARRIER

#ifdef ALLOW_CFC
      IF ( useCFC ) THEN
        CALL CFC_READPARMS(myThid)
      ENDIF
#endif

#ifdef ALLOW_DIC
      IF ( useDIC ) THEN
        CALL DIC_READPARMS(myThid)
      ENDIF
#endif

#ifdef ALLOW_BLING
      IF ( useBLING ) THEN
        CALL BLING_READPARMS(myThid)
      ENDIF
#endif

#ifdef ALLOW_SPOIL
      IF ( useSPOIL ) THEN
        CALL SPOIL_READPARMS(myThid)
      ENDIF
#endif

#ifdef ALLOW_DARWIN
      IF ( useDARWIN ) THEN
        CALL DARWIN_READPARMS(myThid)
      ENDIF
#endif

C- Register GCHEM tracer indices
      CALL GCHEM_TR_REGISTER( myThid )

#endif /* ALLOW_GCHEM */

      RETURN
      END

#include "ATM_CPL_OPTIONS.h"

CBOP
C     !ROUTINE: ATM_STORE_SURFFLUX
C     !INTERFACE:
      SUBROUTINE ATM_STORE_SURFFLUX(
     I                     bi, bj,
     I                     myTime, myIter, myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE ATM_STORE_SURFFLUX
C     | o Routine for saving surface flux fields (in FFIELDS.h)
C     |   for export to coupling layer.
C     *==========================================================*
C     | This version interfaces to the main model
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     == Global variables ==
#include "SIZE.h"

#include "EEPARAMS.h"
#include "PARAMS.h"
#include "CPL_PARAMS.h"
C     == Global variables (main model)
#include "FFIELDS.h"
C     == Global variables for coupling interface ==
#include "ATMCPL.h"

C     !INPUT/OUTPUT PARAMETERS:
C     bi, bj    :: Tile indices
C     myTime    :: Current time in simulation (s)
C     myIter    :: Current iteration number
C     myThid    :: My Thread Id. number
      INTEGER bi, bj
      _RL     myTime
      INTEGER myIter
      INTEGER myThid

C     !LOCAL VARIABLES:
C     i, j      :: Loop counters
      INTEGER i,j
      _RL cplTimeFraction
CEOP

       cplTimeFraction = 1. _d 0 / DFLOAT(cplSendFrq_iter)

C     o Accumulate net surface heat flux (Qnet, +=upward, W/m2)
C       that will be exported to the coupling layer.
       HeatFluxTime(bi,bj) = HeatFluxTime(bi,bj) + cplTimeFraction
       DO j=1,sNy
        DO i=1,sNx
          HeatFlux(i,j,bi,bj) = HeatFlux(i,j,bi,bj)
     &                        + Qnet(i,j,bi,bj)*cplTimeFraction
        ENDDO
       ENDDO

C     o Accumulate net surface shortwave heat flux (Qsw, +=upward, W/m2)
C       that will be exported to the coupling layer.
       qShortWaveTime(bi,bj) = qShortWaveTime(bi,bj) + cplTimeFraction
       DO j=1,sNy
        DO i=1,sNx
          qShortWave(i,j,bi,bj) = qShortWave(i,j,bi,bj)
     &                          + Qsw(i,j,bi,bj)*cplTimeFraction
        ENDDO
       ENDDO

C     o Accumulate fresh water flux ( E-P, +=upward, kg/m^2/s)
C       that will be exported to the coupling layer.
       EvMPrTime(bi,bj) = EvMPrTime(bi,bj) + cplTimeFraction
       DO j=1,sNy
        DO i=1,sNx
          EvMPrFlux(i,j,bi,bj) = EvMPrFlux(i,j,bi,bj)
     &                         + EmPmR(i,j,bi,bj)*cplTimeFraction
        ENDDO
       ENDDO

#ifdef ALLOW_THSICE
      IF ( useThSIce ) THEN
C     o Accumulate SaltFlux from sea-ice (saltFlux, +=upward, g/m^2/s)
C       that will be exported to the coupling layer.
       saltFxTime(bi,bj) = saltFxTime(bi,bj) + cplTimeFraction
       DO j=1,sNy
        DO i=1,sNx
          iceSaltFlx(i,j,bi,bj) = iceSaltFlx(i,j,bi,bj)
     &                 + saltFlux(i,j,bi,bj)*cplTimeFraction
        ENDDO
       ENDDO
      ENDIF
#endif /* ALLOW_THSICE */

      IF ( useAtm_Phys ) THEN
C     o Accumulate surface wind-stress
C       that will be exported to the coupling layer.
       tauXTime(bi,bj) = tauXTime(bi,bj) + cplTimeFraction
       tauYTime(bi,bj) = tauYTime(bi,bj) + cplTimeFraction
       DO j=1,sNy
        DO i=1,sNx
          tauX(i,j,bi,bj) = tauX(i,j,bi,bj)
     &                    + fu(i,j,bi,bj)*cplTimeFraction
          tauY(i,j,bi,bj) = tauY(i,j,bi,bj)
     &                    + fv(i,j,bi,bj)*cplTimeFraction
        ENDDO
       ENDDO
      ENDIF

      RETURN
      END

      subroutine template()
      use OAD_cp
      use OAD_tape
      use OAD_rev

!$TEMPLATE_PRAGMA_DECLARATIONS

      integer :: cp_loop_variable_1,cp_loop_variable_2,
     +     cp_loop_variable_3,cp_loop_variable_4

      type(modeType) :: our_orig_mode

      integer iaddr
      external iaddr

      INTEGER numItersHelper, myThidHelper, nIterMinHelper

      Real*8  cg2d_b_p(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      Real*8  cg2d_x_p(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)

#ifdef OAD_DEBUG_JOINT
      character*(80):: indentation='                                        
     +                                         '
      our_indent=our_indent+1

      write(standardmessageunit, '(A,A,A)', ADVANCE='NO') 
     +'OAD:',indentation(1:our_indent), 'enter __SRNAME__:'
      call oad_dump_revmod(); call oad_dump_tapestats()
      write(standardmessageunit,*) 
#endif
      if (our_rev_mode%plain) then
#ifdef OAD_DEBUG_JOINT
         write(standardmessageunit,'(A,A,A)') 
     +'OAD:',indentation(1:our_indent), 
     +' __SRNAME__: entering plain'
#endif
c set up for plain execution
         our_orig_mode=our_rev_mode
         our_rev_mode%arg_store=.FALSE.
         our_rev_mode%arg_restore=.FALSE.
         our_rev_mode%plain=.TRUE.
         our_rev_mode%tape=.FALSE.
         our_rev_mode%adjoint=.FALSE.
#ifdef OAD_DEBUG_JOINT
         write(standardmessageunit,'(A,A,A)') 
     +'OAD:',indentation(1:our_indent), 
     +' __SRNAME__: runninng plain / down plain'
#endif
         cg2d_b_p=cg2d_b%v
         cg2d_x_p=cg2d_x%v
	call cg2d (
     I                cg2d_b_p,
     U                cg2d_x_p,
     O                firstResidual,
     O                minResidualSq,
     O                lastResidual,
     U                numIters,
     O                nIterMin,
     I                myThid) 
        cg2d_x%v=cg2d_x_p        
c reset the mode
         our_rev_mode=our_orig_mode
      end if
      if (our_rev_mode%tape) then

         numItersHelper=numiters
         mythidHelper=mythid
         nIterMinHelper=nIterMin
#ifdef OAD_DEBUG_JOINT
         write(standardmessageunit,'(A,A,A)') 
     +'OAD:',indentation(1:our_indent), 
     +' __SRNAME__: entering tape'
#endif
c set up for plain execution
         our_orig_mode=our_rev_mode
         our_rev_mode%arg_store=.FALSE.
         our_rev_mode%arg_restore=.FALSE.
         our_rev_mode%plain=.TRUE.
         our_rev_mode%tape=.FALSE.
         our_rev_mode%adjoint=.FALSE.
#ifdef OAD_DEBUG_JOINT
         write(standardmessageunit,'(A,A,A)') 
     +'OAD:',indentation(1:our_indent), 
     +' __SRNAME__: runninng plain / down plain'
#endif
         cg2d_b_p=cg2d_b%v
         cg2d_x_p=cg2d_x%v
	call cg2d (
     I                cg2d_b_p,
     U                cg2d_x_p,
     O                firstResidual,
     O                minResidualSq,
     O                lastResidual,
     U                numIters,
     O                nIterMin,
     I                myThid) 
        cg2d_x%v=cg2d_x_p        
c reset the mode
         our_rev_mode=our_orig_mode
c manually push integers to the tape:
         call oad_tape_push(numItersHelper)
         call oad_tape_push(nIterMinHelper)
         call oad_tape_push(mythidHelper)
      end if
      if (our_rev_mode%adjoint) then
#ifdef OAD_DEBUG_JOINT
         write(standardmessageunit,'(A,A,A)') 
     +'OAD:',indentation(1:our_indent), 
     +' __SRNAME__: entering adjoint'
#endif
c manually pop two integers from the tape:        
         call oad_tape_pop(mythid)
         call oad_tape_pop(nIterMin)
         call oad_tape_pop(numiters)
c selfadjoint:
c the original is called with 
c  cg2d(b,x,...)
c in the adjoint context if we 
c use the same code base 
c we call with 
c  cg2d(x_bar,bh,...
c where afterwards
c b_bar+=bh  and x_bar=0
c the adjoint second formal argument cg2d_x should be
c the values of the first argument:  
      cg2d_b_p=cg2d_x%d
c the first formal argument cg2d_b should hold 
c the increment, i.e. we nullify the second formal 
c argument (cg2d_x) value:
      cg2d_x_p=0.0
c set up for plain execution
         our_orig_mode=our_rev_mode
         our_rev_mode%arg_store=.FALSE.
         our_rev_mode%arg_restore=.FALSE.
         our_rev_mode%plain=.TRUE.
         our_rev_mode%tape=.FALSE.
         our_rev_mode%adjoint=.FALSE.
#ifdef OAD_DEBUG_JOINT
         write(standardmessageunit,'(A,A,A)') 
     +'OAD:',indentation(1:our_indent), 
     +' __SRNAME__: runninng self adjoint / down plain'
#endif
	call cg2d (
     I                cg2d_b_p,
     U                cg2d_x_p,
     O                firstResidual,
     O                minResidualSq,
     O                lastResidual,
     U                numIters,
     O                nIterMin,
     I                myThid) 
c reset the mode
         our_rev_mode=our_orig_mode
c now the adjoint result is the increment 
c contained in the second formal argument
         cg2d_b%d= cg2d_b%d+cg2d_x_p
         cg2d_x%d=0.0
      end if 
#ifdef OAD_DEBUG_JOINT
      write(standardmessageunit,'(A,A,A)', ADVANCE='NO') 
     +'OAD:',indentation(1:our_indent), 'leave __SRNAME__:'
      call oad_dump_revmod(); call oad_dump_tapestats()
      write(standardmessageunit,*) 

      our_indent=our_indent-1
#endif

      end subroutine template

#include "PACKAGES_CONFIG.h"
#include "CPP_OPTIONS.h"

CBOP
C     !INTERFACE:
       _RL FUNCTION myActiveFunction ( mytmp3d, myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     == Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     myThid - Thread number for this instance of the routine.
C     myIter - Iteration number
C     myTime - Current time of simulation ( s )
      _RL     mytmp3d(sNx,sNy,Nr,nSx,nSy)
      INTEGER myThid

C     !LOCAL VARIABLES:
CEOP

      myActiveFunction = 1.0

      RETURN
      END

#include "PACKAGES_CONFIG.h"
#include "CPP_EEOPTIONS.h"
#include "W2_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 0
C !ROUTINE: W2_E2SETUP

C !INTERFACE:
      SUBROUTINE W2_E2SETUP( myThid )

C     !DESCRIPTION:
C     Set-up W2_EXCH2 tile topology structures

C     !USES:
      IMPLICIT NONE

C      Tile topology settings data structures
#include "SIZE.h"
#include "EEPARAMS.h"
#ifdef ALLOW_EXCH2
#include "W2_EXCH2_SIZE.h"
#include "W2_EXCH2_TOPOLOGY.h"
#include "W2_EXCH2_PARAMS.h"
#endif

C     !INPUT PARAMETERS:
C     myThid  :: my Thread Id number
C               (Note: not relevant since threading has not yet started)
      INTEGER myThid

#ifdef ALLOW_EXCH2

C     !LOCAL VARIABLES:
C     === Local variables ===
C     msgBuf     :: Informational/error message buffer
C     stdUnit    :: Standard-Output IO unit number
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      INTEGER stdUnit
      INTEGER i, j, k
      LOGICAL addBlank
CEOP

      stdUnit = standardMessageUnit

C--   Initialise parameters from EXCH2_PARAMS common blocks
C     (except params from namelist which are set in W2_READPARMS)
      DO j=1,W2_maxNbFacets
        facet_owns(1,j) = 0
        facet_owns(2,j) = 0
        DO i=1,4
         DO k=1,4
          facet_pij(k,i,j) = 0
         ENDDO
          facet_oi(i,j) = 0
          facet_oj(i,j) = 0
        ENDDO
      ENDDO

C--   Count Nb of Blank-Tiles and set Number of tiles:
      nBlankTiles = 0
      DO i=1,W2_maxNbTiles
       IF (blankList(i).NE.0 ) THEN
         addBlank = .TRUE.
         DO j=1,nBlankTiles
          IF ( blankList(i).EQ.blankList(j) ) THEN
           addBlank = .FALSE.
           WRITE(msgBuf,'(A,I8,A,2I8,A)')
     &     '** WARNING ** W2_E2SETUP: #', blankList(i),
     &     ' appears several times in blankList (',j,i,')'
           CALL PRINT_MESSAGE( msgBuf, W2_oUnit,SQUEEZE_RIGHT,myThid )
           CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                         SQUEEZE_RIGHT, myThid )
          ENDIF
         ENDDO
         IF ( addBlank ) THEN
           nBlankTiles = nBlankTiles + 1
           blankList(nBlankTiles) = blankList(i)
         ENDIF
       ENDIF
      ENDDO
      exch2_nTiles = nBlankTiles + (nSx*nSy*nPx*nPy)

      WRITE(msgBuf,'(A,I8)')
     &    'W2_E2SETUP: number of Active Tiles =', nSx*nSy*nPx*nPy
      CALL PRINT_MESSAGE( msgBuf, W2_oUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A,I8)')
     &    'W2_E2SETUP: number of Blank Tiles  =', nBlankTiles
      CALL PRINT_MESSAGE( msgBuf, W2_oUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A,I8)')
     &    'W2_E2SETUP: Total number of Tiles  =', exch2_nTiles
      CALL PRINT_MESSAGE( msgBuf, W2_oUnit, SQUEEZE_RIGHT, myThid )

      IF ( exch2_nTiles.GT.W2_maxNbTiles ) THEN
        WRITE(msgBuf,'(3(A,I8))') 'W2_E2SETUP: Number of Tiles=',
     &             exch2_nTiles, ' >', W2_maxNbTiles, ' =W2_maxNbTiles'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(2A)') 'Must increase "W2_maxNbTiles"',
     &                       ' in "W2_EXCH2_SIZE.h" + recompile'
        CALL PRINT_ERROR( msgBuf, myThid )
        STOP 'ABNORMAL END: S/R W2_E2SETUP (nTiles>maxNbTiles)'
      ENDIF

C--   Check blankList:
      DO i=1,nBlankTiles
       IF ( blankList(i).LT.1 .OR. blankList(i).GT.exch2_nTiles ) THEN
         WRITE(msgBuf,'(A,I8,A,I8)')
     &     'W2_E2SETUP: Invalid blankTile number (i=', i,
     &     ' )=', blankList(i)
         WRITE(msgBuf,'(A,I8,A,I8,A)') 'W2_E2SETUP:', blankList(i),
     &                    ' = Invalid blankTile number (i=', i, ')'
         CALL PRINT_ERROR( msgBuf, myThid )
         STOP 'ABNORMAL END: S/R W2_E2SETUP (blankList error)'
       ENDIF
      ENDDO

C--   Define Facet (sub-domain) Topology: Size and Connections
      IF     ( preDefTopol.EQ.0 ) THEN
        CALL W2_SET_GEN_FACETS( myThid )
      ELSEIF ( preDefTopol.EQ.1 ) THEN
        CALL W2_SET_SINGLE_FACET( myThid )
      ELSEIF ( preDefTopol.EQ.2 ) THEN
        CALL W2_SET_MYOWN_FACETS( myThid )
      ELSEIF ( preDefTopol.EQ.3 ) THEN
        CALL W2_SET_CS6_FACETS( myThid )
      ELSE
        STOP 'ABNORMAL END: S/R W2_E2SETUP (invalid preDefTopol)'
      ENDIF

      WRITE(msgBuf,'(A,I8)')
     &    'W2_E2SETUP: Total number of Facets =', nFacets
      CALL PRINT_MESSAGE( msgBuf, W2_oUnit, SQUEEZE_RIGHT, myThid )

C--   Check Topology; setup correspondence matrix for connected Facet-Edges
      CALL W2_SET_F2F_INDEX( myThid )

C--   Define Tile Mapping (+ IO global mapping)
      CALL W2_SET_MAP_TILES( myThid )

C--   Define Tile Mapping (for Cumulated Sum)
      CALL W2_SET_MAP_CUMSUM( myThid )

C--   Set-up tile neighbours and index relations for EXCH2
      CALL W2_SET_TILE2TILES( myThid )

#endif /* ALLOW_EXCH2 */

      RETURN
      END

#include "CPP_EEOPTIONS.h"

      SUBROUTINE MDS_BYTESWAPR8( n, arr )
C IN:
C   n    INTEGER :: Number of 8-byte words in arr
C IN/OUT:
C   arr  real*8  :: Array declared as real*8(n)
C
C Created: 05/05/99 adcroft@mit.edu (This is an unfortunate hack!!)

      IMPLICIT NONE

C Arguments
      INTEGER n
      CHARACTER*(*) arr

C Local
      INTEGER i
      CHARACTER*(1) cc

      DO i=1,8*n,8
       cc=arr(i:i)
       arr(i:i)=arr(i+7:i+7)
       arr(i+7:i+7)=cc
       cc=arr(i+1:i+1)
       arr(i+1:i+1)=arr(i+6:i+6)
       arr(i+6:i+6)=cc
       cc=arr(i+2:i+2)
       arr(i+2:i+2)=arr(i+5:i+5)
       arr(i+5:i+5)=cc
       cc=arr(i+3:i+3)
       arr(i+3:i+3)=arr(i+4:i+4)
       arr(i+4:i+4)=cc
      ENDDO

      RETURN
      END

#include "SMOOTH_OPTIONS.h"

      SUBROUTINE SMOOTH2D(
     &           fld_in, mask_in, smoothOpNb, myThid )

C     *==========================================================*
C     | SUBROUTINE smooth2D
C     | o Routine that applies 2D spatial smoothing
C     *==========================================================*

      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "GRID.h"
#include "PARAMS.h"
#include "SMOOTH.h"

      _RL fld_in (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RS mask_in(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      INTEGER smoothOpNb
      INTEGER myThid

      INTEGER nbt_in
      CHARACTER*(MAX_LEN_FNAM) fnamegeneric

      INTEGER IL

c     == functions ==
      INTEGER  ILNBLNK
      EXTERNAL ILNBLNK

      IL = ILNBLNK( smoothDir )

C read smoothing [i.e diffusion] operator:
      WRITE(fnamegeneric,'(2A,I3.3)')
     &      smoothDir(1:IL),
     &      'smooth2Doperator',smoothOpNb
      CALL READ_REC_3D_RL( fnamegeneric, smoothprec,
     &                     1, smooth2D_Kux, 1, 1, myThid )
      CALL READ_REC_3D_RL( fnamegeneric, smoothprec,
     &                     1, smooth2D_Kvy, 2, 1, myThid )
      CALL EXCH_XY_RL( smooth2D_Kux, myThid )
      CALL EXCH_XY_RL( smooth2D_Kvy, myThid )

C do the smoothing:
      nbt_in = smooth2Dnbt(smoothOpNb)
      CALL SMOOTH_DIFF2D( fld_in, mask_in, nbt_in, myThid )

      RETURN
      END

#include "CPP_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: PACKAGES_UNUSED_MSG
C     !INTERFACE:
      SUBROUTINE PACKAGES_UNUSED_MSG( sw_name, sr_name, df_sufx )

C     !DESCRIPTION: \bv
C     *==============================================================*
C     | SUBROUTINE PACKAGES_UNUSED_MSG
C     | o This routine is called (within the corresponding
C     |   {PKG}_READPARAMS routine) when this {PKG} is not used; it
C     |   prints a (weak) warning if {PKG} parameter file is found.
C     *==============================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
C     sw_name :: package on/off switch flag name
C     sr_name :: subroutine name which calls this S/R
C     df_sufx :: package parameter file sufix (prefix='data.')
C     myThid  ::  My thread Id number
      CHARACTER*(*) sw_name, sr_name, df_sufx
c     INTEGER myThid

C     !FUNCTIONS:
      INTEGER  ILNBLNK
      EXTERNAL ILNBLNK

C     !LOCAL VARIABLES:
C     === Local variables ===
C     caller_sub :: name of subroutine which is calling this S/R
C     data_file  :: parameter file to open and copy
C     pkgLwc     :: PKG name (Lower case)
C     pkgUpc     :: PKG name (Upper case)
C     msgBuf     :: Informational/error message buffer
      CHARACTER*(MAX_LEN_FNAM) data_file
      CHARACTER*(MAX_LEN_MBUF) caller_sub
      CHARACTER*(MAX_LEN_MBUF) pkgLwc, pkgUpc
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      INTEGER iLen, iLen1, iLen2, iLen3
      INTEGER myThid
      LOGICAL existing
CEOP

      WRITE(caller_sub,'(A)') ' '
      WRITE(data_file, '(A)') ' '

      iLen1 = ILNBLNK(sw_name)
      iLen2 = ILNBLNK(sr_name)
      iLen3 = ILNBLNK(df_sufx)

      IF ( iLen1.GE.4 ) THEN
        iLen = iLen1 - 3
        pkgLwc = sw_name(4:iLen1)
        CALL LCASE(pkgLwc(1:iLen))
        pkgUpc = sw_name(4:iLen1)
        CALL UCASE(pkgUpc(1:iLen))
          WRITE(data_file,'(2A)') 'data.', sw_name(4:iLen1)
      ELSE
        iLen = 7
        pkgLwc = 'unknown'
        pkgUpc = 'UNKNOWN'
      ENDIF
      IF ( iLen2.EQ.0 ) THEN
        WRITE(caller_sub,'(2A)') pkgUpc(1:iLen), '_READPARMS'
        iLen2 = iLen + 10
      ELSE
        WRITE(caller_sub,'(2A)') sr_name(1:iLen2)
      ENDIF
      IF ( iLen3.EQ.0 ) THEN
        WRITE(data_file,'(2A)') 'data.', pkgLwc(1:iLen)
        iLen3 = 5 + iLen
      ELSE
        WRITE(data_file,'(2A)') 'data.', df_sufx(1:iLen3)
        iLen3 = 5 + iLen3
      ENDIF

c       WRITE(errorMessageUnit,'(I4,3A)')
c    &        iLen1, ' >', sw_name(1:iLen1),    '<'
c       WRITE(errorMessageUnit,'(I4,3A)')
c    &        iLen2, ' >', caller_sub(1:iLen2), '<'
c       WRITE(errorMessageUnit,'(I4,3A)')
c    &        iLen3, ' >', data_file(1:iLen3),  '<'

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C--   PKG exf is not used: print a (weak) warning if data_file is found
      myThid = 1
      IF ( iLen1.GE.1 ) THEN
        INQUIRE( FILE=data_file, EXIST=existing )
        IF ( existing ) THEN
           WRITE(msgBuf,'(5A)') '** Warning ** ', caller_sub(1:iLen2),
     &       ': ignores "', data_file(1:iLen3), '" file since'
           CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                         SQUEEZE_RIGHT, myThid )
           WRITE(msgBuf,'(5A)') '** Warning ** ', caller_sub(1:iLen2),
     &       ': ', sw_name(1:iLen1), '= F (set from "data.pkg")'
           CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                         SQUEEZE_RIGHT, myThid )
        ENDIF
      ENDIF

      RETURN
      END

#include "DEBUG_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: DEBUG_FLD_STATS_RS

C     !INTERFACE:
      SUBROUTINE DEBUG_FLD_STATS_RS(
     I                myNr, arr, exclValue,
     O                theMin, theMax, theMean, theSD,
     I                myThid )

C     *==========================================================*
C     | SUBROUTINE DEBUG_FLD_STATS_RS                            |
C     | o Calculate bare statistics of global array "_RS arr"    |
C     *==========================================================*

C     !USES:
      IMPLICIT NONE

C     === Global data ===
#include "SIZE.h"
#include "EEPARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     myNr      :: 3rd  dimension of input field array
C     arr       :: input field array
C     exclValue :: exclusion value
C     theMin    :: field minimum value
C     theMax    :: field maximun value
C     theMean   :: field averaged value
C     theStD    :: field Standard Deviation
C     myThid    :: my Thread Id number
      INTEGER myNr
      _RS arr(1-OLx:sNx+OLx,1-OLy:sNy+OLy,myNr,nSx,nSy)
      _RS exclValue
      _RL theMin
      _RL theMax
      _RL theMean
      _RL theSD
      INTEGER myThid

C     !LOCAL VARIABLES:
      INTEGER bi,bj,i,j,k
      LOGICAL noPnts
      _RL tmpVal
      _RL nbPnts, rNbPnts
      _RL theVar
      _RL tileMean(nSx,nSy)
      _RL tileVar (nSx,nSy)
      _RL tileSD  (nSx,nSy)
      _RL tileNbPt(nSx,nSy)
CEOP

      theMin = 0.
      theMax = 0.
      theMean= 0.
      theSD  = 0.
      theVar = 0.
      nbPnts = 0.
      noPnts = .TRUE.

      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        tileNbPt(bi,bj) = 0.
        tileMean(bi,bj) = 0.
        tileVar (bi,bj) = 0.
        DO k=1,myNr
         DO j=1,sNy
          DO i=1,sNx
           tmpVal = arr(i,j,k,bi,bj)
           IF ( tmpVal.NE.exclValue .AND. noPnts ) THEN
            theMin = tmpVal
            theMax = tmpVal
            noPnts = .FALSE.
           ENDIF
           IF ( tmpVal.NE.exclValue ) THEN
            theMin = MIN( theMin, tmpVal )
            theMax = MAX( theMax, tmpVal )
            tileNbPt(bi,bj) = tileNbPt(bi,bj) + 1. _d 0
            tileMean(bi,bj) = tileMean(bi,bj) + tmpVal
            tileVar (bi,bj) = tileVar (bi,bj) + tmpVal*tmpVal
           ENDIF
          ENDDO
         ENDDO
        ENDDO
       ENDDO
      ENDDO

      CALL GLOBAL_SUM_TILE_RL( tileNbPt, nbPnts,  myThid )
      CALL GLOBAL_SUM_TILE_RL( tileMean, theMean, myThid )
c     CALL GLOBAL_SUM_TILE_RL( tileVar , theVar,  myThid )

      IF ( nbPnts.GT.zeroRL ) THEN
       rNbPnts = 1. _d 0/nbPnts
       theMean = theMean*rNbPnts
c      theVar  = theVar *rNbPnts

       IF ( noPnts ) theMin = theMean
       theMin = -theMin
       _GLOBAL_MAX_RL( theMin, myThid )
       theMin = -theMin
       IF ( noPnts ) theMax = theMean
       _GLOBAL_MAX_RL( theMax, myThid )

       DO bj=myByLo(myThid),myByHi(myThid)
        DO bi=myBxLo(myThid),myBxHi(myThid)
         tileSD(bi,bj) = 0.
         DO k=1,myNr
          DO j=1,sNy
           DO i=1,sNx
            tmpVal = arr(i,j,k,bi,bj)
            IF ( tmpVal.NE.exclValue ) THEN
             tileSD(bi,bj) = tileSD(bi,bj)
     &                     + (tmpVal-theMean)*(tmpVal-theMean)
            ENDIF
           ENDDO
          ENDDO
         ENDDO
        ENDDO
       ENDDO

       CALL GLOBAL_SUM_TILE_RL( tileSD, theSD, myThid )

       theSD = SQRT( theSD*rNbPnts )
c      theSD = SQRT( theVar - theMean*theMean )
      ENDIF

      RETURN
      END

#include "PACKAGES_CONFIG.h"
#include "CPP_OPTIONS.h"
#ifdef ALLOW_AUTODIFF
# include "AUTODIFF_OPTIONS.h"
#endif
#ifdef ALLOW_SALT_PLUME
# include "SALT_PLUME_OPTIONS.h"
#endif
#undef CHECK_OVERLAP_FORCING

CBOP
C     !ROUTINE: EXTERNAL_FORCING_SURF
C     !INTERFACE:
      SUBROUTINE EXTERNAL_FORCING_SURF(
     I             iMin, iMax, jMin, jMax,
     I             myTime, myIter, myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE EXTERNAL_FORCING_SURF
C     | o Determines forcing terms based on external fields
C     |   relaxation terms etc.
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "FFIELDS.h"
#include "DYNVARS.h"
#include "GRID.h"
#include "SURFACE.h"
#ifdef ALLOW_AUTODIFF_TAMC
# include "tamc.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
C     iMin,iMax, jMin,jMax :: Range of points for calculation
C     myTime :: Current time in simulation
C     myIter :: Current iteration number in simulation
C     myThid :: Thread no. that called this routine.
      INTEGER iMin, iMax
      INTEGER jMin, jMax
      _RL myTime
      INTEGER myIter
      INTEGER myThid

C     !LOCAL VARIABLES:
C     === Local variables ===
C     bi,bj  :: tile indices
C     i,j    :: loop indices
C     ks     :: index of surface interface layer
      INTEGER bi,bj
      INTEGER i,j
      INTEGER ks
#ifdef ALLOW_AUTODIFF_TAMC
      INTEGER tkey
#endif
      _RL recip_Cp
#ifdef ALLOW_BALANCE_FLUXES
      _RS tmpVar(1)
#endif
#ifdef CHECK_OVERLAP_FORCING
      _RS fixVal
#endif
#ifdef SHORTWAVE_HEATING
      _RS tmpFac
#endif
CEOP

      IF ( usingPCoords ) THEN
       ks        = Nr
      ELSE
       ks        = 1
      ENDIF
      recip_Cp = 1. _d 0 / HeatCapacity_Cp
#ifdef SHORTWAVE_HEATING
      tmpFac = oneRS
      IF ( selectPenetratingSW .LE. 0 ) tmpFac = zeroRS
#endif

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C--   Apply adjustment (balancing forcing) and exchanges
C     to oceanic surface forcing

#ifdef ALLOW_BALANCE_FLUXES
C     balance fluxes
# ifdef ALLOW_AUTODIFF
      tmpVar(1) = oneRS
#  ifdef ALLOW_AUTODIFF_TAMC
CADJ INCOMPLETE tmpVar
#  endif
# endif
      IF ( selectBalanceEmPmR.GE.1 .AND.
     &     (.NOT.useSeaice .OR. useThSIce) ) THEN
       IF ( selectBalanceEmPmR.EQ.1 ) THEN
        tmpVar(1) = oneRS
        CALL REMOVE_MEAN_RS( 1, EmPmR, maskInC, maskInC, rA,
     &                       tmpVar, 'EmPmR', myTime, myIter, myThid )
       ELSEIF ( selectBalanceEmPmR.EQ.2 ) THEN
        tmpVar(1) = -oneRS
        CALL REMOVE_MEAN_RS( 1, EmPmR, weight2BalanceFlx, maskInC, rA,
     &                       tmpVar, 'EmPmR', myTime, myIter, myThid )
       ENDIF
      ENDIF
      IF ( balanceQnet  .AND. (.NOT.useSeaice .OR. useThSIce) ) THEN
        tmpVar(1) = oneRS
        CALL REMOVE_MEAN_RS( 1, Qnet,  maskInC, maskInC, rA,
     &                       tmpVar, 'Qnet ', myTime, myIter, myThid )
      ENDIF
#endif /* ALLOW_BALANCE_FLUXES */

C-    Apply exchanges (if needed)

#ifdef CHECK_OVERLAP_FORCING
C     Put large value in overlap of forcing array to check if exch is needed
c     IF ( .NOT. useKPP ) THEN
       fixVal = 1.
       CALL RESET_HALO_RS ( EmPmR, fixVal, 1, myThid )
       fixVal = 400.
       CALL RESET_HALO_RS ( Qnet, fixVal, 1, myThid )
       fixVal = -200.
       CALL RESET_HALO_RS ( Qsw, fixVal, 1, myThid )
       fixVal = 40.
       CALL RESET_HALO_RS ( saltFlux, fixVal, 1, myThid )
c     ENDIF
#endif /* CHECK_OVERLAP_FORCING */

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE PmEpR = comlev1, key = ikey_dynamics,  kind = isbyte
CADJ STORE EmPmR = comlev1, key = ikey_dynamics,  kind = isbyte
#endif
      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
C--   set surfaceForcingT,S to zero.
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
           surfaceForcingT(i,j,bi,bj) = 0. _d 0
           surfaceForcingS(i,j,bi,bj) = 0. _d 0
         ENDDO
        ENDDO
c#ifdef ALLOW_EBM
        IF ( useRealFreshWaterFlux ) THEN
C--   in case some pkgs put non-zero values over land, clean this up:
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           EmPmR(i,j,bi,bj) = EmPmR(i,j,bi,bj)*maskInC(i,j,bi,bj)
          ENDDO
         ENDDO
        ENDIF
c#endif /* ALLOW_EBM */
C NB: synchronous time step: PmEpR lags 1 time step behind EmPmR
C     to stay consistent with volume change (=d/dt etaH).
        IF ( staggerTimeStep ) THEN
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           PmEpR(i,j,bi,bj) = -EmPmR(i,j,bi,bj)
          ENDDO
         ENDDO
        ENDIF
       ENDDO
      ENDDO

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C--   Start with surface restoring term :
      IF ( doThetaClimRelax .OR. doSaltClimRelax ) THEN
       CALL FORCING_SURF_RELAX(
     I              iMin, iMax, jMin, jMax,
     I              myTime, myIter, myThid )
      ENDIF

#ifdef ALLOW_PTRACERS
C--   passive tracer surface forcing:
#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE surfaceForcingS = comlev1, key = ikey_dynamics,
CADJ &    kind = isbyte
#ifdef ALLOW_BLING
CADJ STORE EmPmR = comlev1, key = ikey_dynamics,  kind = isbyte
#endif
#endif
      IF ( usePTRACERS ) THEN
       DO bj=myByLo(myThid),myByHi(myThid)
        DO bi=myBxLo(myThid),myBxHi(myThid)
         CALL PTRACERS_FORCING_SURF(
     I        surfaceForcingS(1-OLx,1-OLy,bi,bj),
     I        bi, bj, iMin, iMax, jMin, jMax,
     I        myTime, myIter, myThid )
        ENDDO
       ENDDO
      ENDIF
#endif /* ALLOW_PTRACERS */

C- Notes: setting of PmEpR and pTracers surface forcing could have been
C         moved below, inside a unique bi,bj block. However this results
C         in tricky dependencies for TAF (and recomputations).
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)

#ifdef ALLOW_AUTODIFF_TAMC
        tkey = bi + (bj-1)*nSx + (ikey_dynamics-1)*nSx*nSy
#endif /* ALLOW_AUTODIFF_TAMC */

#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE EmPmR(:,:,bi,bj) = comlev1_bibj, key=tkey,  kind = isbyte
CADJ STORE PmEpR(:,:,bi,bj) = comlev1_bibj, key=tkey,  kind = isbyte
#endif /* ALLOW_AUTODIFF_TAMC */

C--   Surface Fluxes :
        DO j = jMin, jMax
         DO i = iMin, iMax

C     Zonal wind stress fu:
          surfaceForcingU(i,j,bi,bj) = fu(i,j,bi,bj)*mass2rUnit
C     Meridional wind stress fv:
          surfaceForcingV(i,j,bi,bj) = fv(i,j,bi,bj)*mass2rUnit
C     Net heat flux Qnet:
          surfaceForcingT(i,j,bi,bj) = surfaceForcingT(i,j,bi,bj)
     &       - ( Qnet(i,j,bi,bj)
#ifdef SHORTWAVE_HEATING
     &          -Qsw(i,j,bi,bj)*tmpFac
#endif
     &         ) *recip_Cp*mass2rUnit
C     Net Salt Flux :
          surfaceForcingS(i,j,bi,bj) = surfaceForcingS(i,j,bi,bj)
     &      -saltFlux(i,j,bi,bj)*mass2rUnit

         ENDDO
        ENDDO

#ifdef ALLOW_SALT_PLUME
C saltPlume is the amount of salt rejected by ice while freezing;
C it is here subtracted from surfaceForcingS and will be redistributed
C to multiple vertical levels later on as per Duffy et al. (GRL 1999)
C-- for the case of SALT_PLUME_VOLUME, need to call this S/R right
C-- before kpp in do_oceanic_phys.F due to recent moved of
C-- external_forcing_surf.F outside bi,bj loop.
#ifndef SALT_PLUME_VOLUME
        IF ( useSALT_PLUME ) THEN
         CALL SALT_PLUME_FORCING_SURF(
     I        bi, bj, iMin, iMax, jMin, jMax,
     I        myTime, myIter, myThid )
        ENDIF
#endif /* SALT_PLUME_VOLUME */
#endif /* ALLOW_SALT_PLUME */

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C--   Fresh-water flux

C-    Apply mask on Fresh-Water flux (if useRealFreshWaterFlux)
C     <== removed: maskInC is applied directly in S/R SOLVE_FOR_PRESSURE

      IF ( ( nonlinFreeSurf.GT.0 .OR. usingPCoords )
     &     .AND. useRealFreshWaterFlux ) THEN

C--   NonLin_FrSurf and RealFreshWaterFlux : PmEpR effectively changes
C     the water column height ; temp., salt, (tracer) flux associated
C     with this input/output of water is added here to the surface tendency.

       IF (temp_EvPrRn.NE.UNSET_RL) THEN
        DO j = jMin, jMax
         DO i = iMin, iMax
          surfaceForcingT(i,j,bi,bj) = surfaceForcingT(i,j,bi,bj)
     &      + PmEpR(i,j,bi,bj)
     &          *( temp_EvPrRn - theta(i,j,ks,bi,bj) )
     &          *mass2rUnit
         ENDDO
        ENDDO
       ENDIF

       IF (salt_EvPrRn.NE.UNSET_RL) THEN
        DO j = jMin, jMax
         DO i = iMin, iMax
          surfaceForcingS(i,j,bi,bj) = surfaceForcingS(i,j,bi,bj)
     &      + PmEpR(i,j,bi,bj)
     &          *( salt_EvPrRn - salt(i,j,ks,bi,bj) )
     &          *mass2rUnit
         ENDDO
        ENDDO
       ENDIF

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
      ELSE

C--   EmPmR does not really affect the water column height (for tracer budget)
C     and is converted to a salt tendency.

       IF (convertFW2Salt .EQ. -1.) THEN
C-    use local surface tracer field to calculate forcing term:

        IF (temp_EvPrRn.NE.UNSET_RL) THEN
C     account for Rain/Evap heat content (temp_EvPrRn) using local SST
         DO j = jMin, jMax
          DO i = iMin, iMax
           surfaceForcingT(i,j,bi,bj) = surfaceForcingT(i,j,bi,bj)
     &       + EmPmR(i,j,bi,bj)
     &           *( theta(i,j,ks,bi,bj) - temp_EvPrRn )
     &           *mass2rUnit
          ENDDO
         ENDDO
        ENDIF
        IF (salt_EvPrRn.NE.UNSET_RL) THEN
C     converts EmPmR to salinity tendency using surface local salinity
         DO j = jMin, jMax
          DO i = iMin, iMax
           surfaceForcingS(i,j,bi,bj) = surfaceForcingS(i,j,bi,bj)
     &       + EmPmR(i,j,bi,bj)
     &           *( salt(i,j,ks,bi,bj) - salt_EvPrRn )
     &           *mass2rUnit
          ENDDO
         ENDDO
        ENDIF

       ELSE
C-    use uniform tracer value to calculate forcing term:

        IF (temp_EvPrRn.NE.UNSET_RL) THEN
C     account for Rain/Evap heat content (temp_EvPrRn) assuming uniform SST (=tRef)
         DO j = jMin, jMax
          DO i = iMin, iMax
           surfaceForcingT(i,j,bi,bj) = surfaceForcingT(i,j,bi,bj)
     &       + EmPmR(i,j,bi,bj)
     &           *( tRef(ks) - temp_EvPrRn )
     &           *mass2rUnit
          ENDDO
         ENDDO
        ENDIF
        IF (salt_EvPrRn.NE.UNSET_RL) THEN
C     converts EmPmR to virtual salt flux using uniform salinity (default=35)
         DO j = jMin, jMax
          DO i = iMin, iMax
           surfaceForcingS(i,j,bi,bj) = surfaceForcingS(i,j,bi,bj)
     &       + EmPmR(i,j,bi,bj)
     &           *( convertFW2Salt - salt_EvPrRn )
     &           *mass2rUnit
          ENDDO
         ENDDO
        ENDIF

C-    end local-surface-tracer / uniform-value distinction
       ENDIF

      ENDIF

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#ifdef ATMOSPHERIC_LOADING
C-- Atmospheric surface Pressure loading : added to phi0surf when using Z-coord;
C   Not yet implemented for Ocean in P: would need to be applied to the other end
C   of the column, as a vertical velocity (omega); (meaningless for Atmos in P).
C- Note:
C   Using P-coord., a hack (now directly applied from S/R INI_FORCING)
C   is sometime used to read phi0surf from a file (pLoadFile) instead
C   of computing it from bathymetry & density ref. profile.

        IF ( usingZCoords ) THEN
C   The true atmospheric P-loading is not yet implemented for P-coord
C   (requires time varying dP(Nr) like dP(k-bottom) with NonLin FS).
         IF ( useRealFreshWaterFlux ) THEN
          DO j = jMin, jMax
           DO i = iMin, iMax
            phi0surf(i,j,bi,bj) = ( pLoad(i,j,bi,bj)
     &                          +sIceLoad(i,j,bi,bj)*gravity*sIceLoadFac
     &                            )*recip_rhoConst
           ENDDO
          ENDDO
         ELSE
          DO j = jMin, jMax
           DO i = iMin, iMax
            phi0surf(i,j,bi,bj) = pLoad(i,j,bi,bj)*recip_rhoConst
           ENDDO
          ENDDO
         ENDIF
c       ELSEIF ( usingPCoords ) THEN
C-- This is a hack used to read phi0surf from a file (pLoadFile)
C   instead of computing it from bathymetry & density ref. profile.
C   ==> now done only once, in S/R INI_FORCING
c         DO j = jMin, jMax
c          DO i = iMin, iMax
c           phi0surf(i,j,bi,bj) = pLoad(i,j,bi,bj)
c          ENDDO
c         ENDDO
        ENDIF
#endif /* ATMOSPHERIC_LOADING */

#ifdef ALLOW_SHELFICE
        IF ( useSHELFICE) THEN
          CALL SHELFICE_FORCING_SURF(
     I                  bi, bj, iMin, iMax, jMin, jMax,
     I                  myTime, myIter, myThid )
        ENDIF
#endif /* ALLOW_SHELFICE */

C--   end bi,bj loops.
       ENDDO
      ENDDO

      RETURN
      END

#include "GCHEM_OPTIONS.h"

CBOP
C !ROUTINE: GCHEM_TR_REGISTER

C !INTERFACE: ==========================================================
      SUBROUTINE GCHEM_TR_REGISTER( myThid )

C !DESCRIPTION:
C     Register GCHEM tracer indices

C !USES: ===============================================================
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GCHEM.h"

C !INPUT PARAMETERS: ===================================================
C  myThid         :: thread number
      INTEGER myThid

C !OUTPUT PARAMETERS: ==================================================
C  none

#ifdef ALLOW_GCHEM

C !LOCAL VARIABLES: ====================================================
C  iUnit          :: unit number for I/O
C  msgBuf         :: message buffer
c     INTEGER iUnit
      CHARACTER*(MAX_LEN_MBUF) msgBuf
CEOP

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      _BEGIN_MASTER(myThid)

      WRITE(msgBuf,'(2A,2I5)') 'GCHEM_TR_REGISTER: ',
     &     ' Start registering GCHEM tracers'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )

C--   Initialise
      gchem_Tracer_num = 0
      gchem_sepFTr_num = 0

C--   Register GCHEM tracers: start with those using Separate Forcing
C                             and finish with those using gchem-tendency

#ifdef ALLOW_DIC
      IF ( useDIC ) THEN
        CALL DIC_TR_REGISTER(
     U              gchem_Tracer_num, gchem_sepFTr_num,
     I              myThid )
      ENDIF
#endif
#ifdef ALLOW_BLING
      IF ( useBLING ) THEN
        CALL BLING_TR_REGISTER(
     U                gchem_Tracer_num, gchem_sepFTr_num,
     I                myThid )
      ENDIF
#endif
#ifdef ALLOW_DARWIN
      IF ( useDARWIN ) THEN
        CALL DARWIN_TR_REGISTER(
     U                 gchem_Tracer_num, gchem_sepFTr_num,
     I                 myThid )
      ENDIF
#endif

#ifdef ALLOW_CFC
      IF ( useCFC ) THEN
        CALL CFC_TR_REGISTER(
     U              gchem_Tracer_num, gchem_sepFTr_num,
     I              myThid )
      ENDIF
#endif
#ifdef ALLOW_SPOIL
      IF ( useSPOIL ) THEN
        CALL SPOIL_TR_REGISTER(
     U                gchem_Tracer_num, gchem_sepFTr_num,
     I                myThid )
      ENDIF
#endif

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      WRITE(msgBuf,'(2A,2I5)') 'GCHEM_TR_REGISTER: ',
     &     ' Numb. Trac & SepForc Trac:',
     &     gchem_Tracer_num, gchem_sepFTr_num
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)') ' '
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )

      _END_MASTER(myThid)
      _BARRIER

#endif /* ALLOW_GCHEM */

      RETURN
      END

#include "MDSIO_OPTIONS.h"

C--  File mdsio_gl_slice.F: Routines to handle mid-level I/O interface.
C--   Contents
C--   o MDSREADFIELD_XZ_GL
C--   o MDSREADFIELD_YZ_GL
C--   o MDSWRITEFIELD_XZ_GL
C--   o MDSWRITEFIELD_YZ_GL

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      SUBROUTINE MDSREADFIELD_XZ_GL(
     I   fName,
     I   filePrec,
     I   arrType,
     I   nNz,
     O   arr_gl,
     I   irecord,
     I   myThid )
C
C Arguments:
C
C fName      string  :: base name for file to read
C filePrec   integer :: number of bits per word in file (32 or 64)
C arrType    char(2) :: declaration of "arr": either "RS" or "RL"
C nNz        integer :: size of third dimension: normally either 1 or Nr
C arr         RS/RL  :: array to read into, arr(:,:,nNz,:,:)
C irecord    integer :: record number to read
C myThid     integer :: thread identifier
C
C MDSREADFIELD first checks to see if the file "fName" exists, then
C if the file "fName.data" exists and finally the tiled files of the
C form "fName.xxx.yyy.data" exist. Currently, the meta-files are not
C read because it is difficult to parse files in fortran.
C The precision of the file is decsribed by filePrec, set either
C to floatPrec32 or floatPrec64. The precision or declaration of
C the array argument must be consistently described by the char*(2)
C string arrType, either "RS" or "RL". nNz allows for both 2-D and
C 3-D arrays to be handled. nNz=1 implies a 2-D model field and
C nNz=Nr implies a 3-D model field. irecord is the record number
C to be read and must be >= 1. The file data is stored in
C arr *but* the overlaps are *not* updated. ie. An exchange must
C be called. This is because the routine is sometimes called from
C within a MASTER_THID region.
C
C Created: 03/16/99 adcroft@mit.edu

      implicit none
C Global variables / common blocks
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"

C Routine arguments
      character*(*) fName
      integer filePrec
      character*(2) arrType
      integer nNz
      _RL arr_gl(sNx,nSx,nPx,nSy,nPy,Nr)
      integer irecord
      integer myThid

#ifdef ALLOW_AUTODIFF
C Functions
      integer ILNBLNK
      integer MDS_RECLEN
C Local variables
      character*(MAX_LEN_FNAM) dataFName
      integer ip,jp,iG,jG,irec,bi,bj,ii,k,dUnit,IL
      logical exst
      _RL arr(1-oLx:sNx+oLx,Nr,nSx,nSy)
      Real*4 r4seg(sNx)
      Real*8 r8seg(sNx)
      logical globalFile,fileIsOpen
      integer length_of_rec
      character*(max_len_mbuf) msgbuf
C     ------------------------------------------------------------------

C Only do I/O if I am the master thread
      _BEGIN_MASTER( myThid )

#ifndef REAL4_IS_SLOW
      if (arrType .eq. 'RS') then
       write(msgbuf,'(a)')
     &   ' MDSREADFIELD_XZ_GL is wrong for arrType="RS" (=real*4)'
       call print_error( msgbuf, mythid )
       stop 'ABNORMAL END: S/R MDSREADFIELD_XZ_GL'
      endif
#endif

C Record number must be >= 1
      if (irecord .LT. 1) then
       write(msgbuf,'(a,i9.8)')
     &   ' MDSREADFIELD_XZ_GL: argument irecord = ',irecord
       call print_message( msgbuf, standardmessageunit,
     &                     SQUEEZE_RIGHT , mythid)
       write(msgbuf,'(a)')
     &   ' MDSREADFIELD_XZ_GL: Invalid value for irecord'
       call print_error( msgbuf, mythid )
       stop 'ABNORMAL END: S/R MDSREADFIELD_XZ_GL'
      endif

C Assume nothing
      globalFile = .FALSE.
      fileIsOpen = .FALSE.
      IL=ILNBLNK( fName )

C Assign a free unit number as the I/O channel for this routine
      call MDSFINDUNIT( dUnit, mythid )

C Check first for global file with simple name (ie. fName)
      dataFName = fName
      inquire( file=dataFname, exist=exst )
      if (exst) then
       write(msgbuf,'(a,a)')
     &   ' MDSREADFIELD: opening global file: ',dataFName(1:IL)
       call print_message( msgbuf, standardmessageunit,
     &                     SQUEEZE_RIGHT , mythid)
      endif

C If negative check for global file with MDS name (ie. fName.data)
      if (.NOT. globalFile) then
       write(dataFname,'(2a)') fName(1:IL),'.data'
       inquire( file=dataFname, exist=exst )
       if (exst) then
        write(msgbuf,'(a,a)')
     &   ' MDSREADFIELD_XZ_GL: opening global file: ',dataFName(1:IL+5)
        call print_message( msgbuf, standardmessageunit,
     &                      SQUEEZE_RIGHT , mythid)
        globalFile = .TRUE.
       endif
      endif

C Loop over all processors
      do jp=1,nPy
      do ip=1,nPx
C Loop over all tiles
      do bj=1,nSy
      do bi=1,nSx
C If we are reading from a tiled MDS file then we open each one here
        if (.NOT. globalFile) then
         iG=bi+(ip-1)*nsx ! Kludge until unstructered tiles
         jG=bj+(jp-1)*nsy ! Kludge until unstructered tiles
         write(dataFname,'(2a,i3.3,a,i3.3,a)')
     &              fName(1:IL),'.',iG,'.',jG,'.data'
         inquire( file=dataFname, exist=exst )
C Of course, we only open the file if the tile is "active"
C (This is a place-holder for the active/passive mechanism
         if (exst) then
          if ( debugLevel .GE. debLevB ) then
           write(msgbuf,'(a,a)')
     &      ' MDSREADFIELD_XZ_GL: opening file: ',dataFName(1:IL+13)
           call print_message( msgbuf, standardmessageunit,
     &                        SQUEEZE_RIGHT , mythid)
          endif
          length_of_rec=MDS_RECLEN( filePrec, sNx, mythid )
          open( dUnit, file=dataFName, status='old',
     &        access='direct', recl=length_of_rec )
          fileIsOpen=.TRUE.
         else
          fileIsOpen=.FALSE.
          write(msgbuf,'(a,a)')
     &      ' MDSREADFIELD_XZ_GL: filename: ',dataFName(1:IL+13)
          call print_message( msgbuf, standardmessageunit,
     &                        SQUEEZE_RIGHT , mythid)
          write(msgbuf,'(a)')
     &      ' MDSREADFIELD_XZ_GL: File does not exist'
          call print_error( msgbuf, mythid )
          stop 'ABNORMAL END: S/R MDSREADFIELD_GL'
         endif
        endif

        if (fileIsOpen) then
         do k=1,Nr
            iG = 0
            jG = 0
            irec=k + Nr*(irecord-1)
           if (filePrec .eq. precFloat32) then
            read(dUnit,rec=irec) r4seg
#ifdef _BYTESWAPIO
            call MDS_BYTESWAPR4( sNx, r4seg )
#endif
            if (arrType .eq. 'RS') then
#ifdef REAL4_IS_SLOW
             call MDS_SEG4toRS_2D(sNx,oLx,nNz,bi,bj,k,.TRUE.,r4seg,arr)
#endif
            elseif (arrType .eq. 'RL') then
             call MDS_SEG4toRL_2D(sNx,oLx,nNz,bi,bj,k,.TRUE.,r4seg,arr)
            else
             write(msgbuf,'(a)')
     &         ' MDSREADFIELD_XZ_GL: illegal value for arrType'
             call print_error( msgbuf, mythid )
             stop 'ABNORMAL END: S/R MDSREADFIELD_XZ_GL'
            endif
           elseif (filePrec .eq. precFloat64) then
            read(dUnit,rec=irec) r8seg
#ifdef _BYTESWAPIO
            call MDS_BYTESWAPR8( sNx, r8seg )
#endif
            if (arrType .eq. 'RS') then
#ifdef REAL4_IS_SLOW
             call MDS_SEG8toRS_2D(sNx,oLx,nNz,bi,bj,k,.TRUE.,r8seg,arr)
#endif
            elseif (arrType .eq. 'RL') then
             call MDS_SEG8toRL_2D(sNx,oLx,nNz,bi,bj,k,.TRUE.,r8seg,arr)
            else
             write(msgbuf,'(a)')
     &         ' MDSREADFIELD_XZ_GL: illegal value for arrType'
             call print_error( msgbuf, mythid )
             stop 'ABNORMAL END: S/R MDSREADFIELD_XZ_GL'
            endif
           else
            write(msgbuf,'(a)')
     &        ' MDSREADFIELD_XZ_GL: illegal value for filePrec'
            call print_error( msgbuf, mythid )
            stop 'ABNORMAL END: S/R MDSREADFIELD_XZ_GL'
           endif
       do ii=1,sNx
        arr_gl(ii,bi,ip,bj,jp,k)=arr(ii,k,bi,bj)
       enddo

C End of k loop
         enddo
         if (.NOT. globalFile) then
          close( dUnit )
          fileIsOpen = .FALSE.
         endif
        endif
C End of bi,bj loops
       enddo
      enddo
C End of ip,jp loops
       enddo
      enddo

C If global file was opened then close it
      if (fileIsOpen .AND. globalFile) then
       close( dUnit )
       fileIsOpen = .FALSE.
      endif

      _END_MASTER( myThid )

#else /* ALLOW_AUTODIFF */
      STOP 'ABNORMAL END: S/R MDSREADFIELD_XZ_GL is empty'
#endif /* ALLOW_AUTODIFF */
C     ------------------------------------------------------------------
      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      SUBROUTINE MDSREADFIELD_YZ_GL(
     I   fName,
     I   filePrec,
     I   arrType,
     I   nNz,
     O   arr_gl,
     I   irecord,
     I   myThid )

C Arguments:
C
C fName      string  :: base name for file to read
C filePrec   integer :: number of bits per word in file (32 or 64)
C arrType    char(2) :: declaration of "arr": either "RS" or "RL"
C nNz        integer :: size of third dimension: normally either 1 or Nr
C arr         RS/RL  :: array to read into, arr(:,:,nNz,:,:)
C irecord    integer :: record number to read
C myThid     integer :: thread identifier
C
C MDSREADFIELD first checks to see if the file "fName" exists, then
C if the file "fName.data" exists and finally the tiled files of the
C form "fName.xxx.yyy.data" exist. Currently, the meta-files are not
C read because it is difficult to parse files in fortran.
C The precision of the file is decsribed by filePrec, set either
C to floatPrec32 or floatPrec64. The precision or declaration of
C the array argument must be consistently described by the char*(2)
C string arrType, either "RS" or "RL". nNz allows for both 2-D and
C 3-D arrays to be handled. nNz=1 implies a 2-D model field and
C nNz=Nr implies a 3-D model field. irecord is the record number
C to be read and must be >= 1. The file data is stored in
C arr *but* the overlaps are *not* updated. ie. An exchange must
C be called. This is because the routine is sometimes called from
C within a MASTER_THID region.
C
C Created: 03/16/99 adcroft@mit.edu

      implicit none
C Global variables / common blocks
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"

C Routine arguments
      character*(*) fName
      integer filePrec
      character*(2) arrType
      integer nNz
      _RL arr_gl(nSx,nPx,sNy,nSy,nPy,Nr)
      integer irecord
      integer myThid

#ifdef ALLOW_AUTODIFF
C Functions
      integer ILNBLNK
      integer MDS_RECLEN
C Local variables
      character*(MAX_LEN_FNAM) dataFName
      integer ip,jp,iG,jG,irec,bi,bj,jj,k,dUnit,IL
      logical exst
      _RL arr(1-oLy:sNy+oLy,Nr,nSx,nSy)
      Real*4 r4seg(sNy)
      Real*8 r8seg(sNy)
      logical globalFile,fileIsOpen
      integer length_of_rec
      character*(max_len_mbuf) msgbuf
C     ------------------------------------------------------------------

C Only do I/O if I am the master thread
      _BEGIN_MASTER( myThid )

#ifndef REAL4_IS_SLOW
      if (arrType .eq. 'RS') then
       write(msgbuf,'(a)')
     &   ' MDSREADFIELD_YZ_GL is wrong for arrType="RS" (=real*4)'
       call print_error( msgbuf, mythid )
       stop 'ABNORMAL END: S/R MDSREADFIELD_YZ_GL'
      endif
#endif

C Record number must be >= 1
      if (irecord .LT. 1) then
       write(msgbuf,'(a,i9.8)')
     &   ' MDSREADFIELD_YZ_GL: argument irecord = ',irecord
       call print_message( msgbuf, standardmessageunit,
     &                     SQUEEZE_RIGHT , mythid)
       write(msgbuf,'(a)')
     &   ' MDSREADFIELD_YZ_GL: Invalid value for irecord'
       call print_error( msgbuf, mythid )
       stop 'ABNORMAL END: S/R MDSREADFIELD_YZ_GL'
      endif

C Assume nothing
      globalFile = .FALSE.
      fileIsOpen = .FALSE.
      IL=ILNBLNK( fName )

C Assign a free unit number as the I/O channel for this routine
      call MDSFINDUNIT( dUnit, mythid )

C Check first for global file with simple name (ie. fName)
      dataFName = fName
      inquire( file=dataFname, exist=exst )
      if (exst) then
       write(msgbuf,'(a,a)')
     &  ' MDSREADFIELD_YZ: opening global file: ',dataFName(1:IL)
       call print_message( msgbuf, standardmessageunit,
     &                     SQUEEZE_RIGHT , mythid)
      endif

C If negative check for global file with MDS name (ie. fName.data)
      if (.NOT. globalFile) then
       write(dataFname,'(2a)') fName(1:IL),'.data'
       inquire( file=dataFname, exist=exst )
       if (exst) then
        write(msgbuf,'(a,a)')
     &   ' MDSREADFIELD_YZ_GL: opening global file: ',dataFName(1:IL+5)
        call print_message( msgbuf, standardmessageunit,
     &                      SQUEEZE_RIGHT , mythid)
        globalFile = .TRUE.
       endif
      endif
C Loop over all processors
      do jp=1,nPy
      do ip=1,nPx
C Loop over all tiles
      do bj=1,nSy
      do bi=1,nSx
C If we are reading from a tiled MDS file then we open each one here
        if (.NOT. globalFile) then
         iG=bi+(ip-1)*nsx ! Kludge until unstructered tiles
         jG=bj+(jp-1)*nsy ! Kludge until unstructered tiles
         write(dataFname,'(2a,i3.3,a,i3.3,a)')
     &              fName(1:IL),'.',iG,'.',jG,'.data'
         inquire( file=dataFname, exist=exst )
C Of course, we only open the file if the tile is "active"
C (This is a place-holder for the active/passive mechanism
         if (exst) then
          if ( debugLevel .GE. debLevB ) then
           write(msgbuf,'(a,a)')
     &      ' MDSREADFIELD_YZ_GL: opening file: ',dataFName(1:IL+13)
           call print_message( msgbuf, standardmessageunit,
     &                        SQUEEZE_RIGHT , mythid)
          endif
          length_of_rec=MDS_RECLEN( filePrec, sNy, mythid )
          open( dUnit, file=dataFName, status='old',
     &        access='direct', recl=length_of_rec )
          fileIsOpen=.TRUE.
         else
          fileIsOpen=.FALSE.
          write(msgbuf,'(a,a)')
     &      ' MDSREADFIELD_YZ_GL: filename: ',dataFName(1:IL+13)
          call print_message( msgbuf, standardmessageunit,
     &                        SQUEEZE_RIGHT , mythid)
          write(msgbuf,'(a)')
     &      ' MDSREADFIELD_YZ_GL: File does not exist'
          call print_error( msgbuf, mythid )
          stop 'ABNORMAL END: S/R MDSREADFIELD_YZ_GL'
         endif
        endif

        if (fileIsOpen) then
         do k=1,Nr
            iG = 0
            jG = 0
            irec=k + Nr*(irecord-1)
           if (filePrec .eq. precFloat32) then
            read(dUnit,rec=irec) r4seg
#ifdef _BYTESWAPIO
            call MDS_BYTESWAPR4( sNy, r4seg )
#endif
            if (arrType .eq. 'RS') then
#ifdef REAL4_IS_SLOW
             call MDS_SEG4toRS_2D(sNy,oLy,nNz,bi,bj,k,.TRUE.,r4seg,arr)
#endif
            elseif (arrType .eq. 'RL') then
             call MDS_SEG4toRL_2D(sNy,oLy,nNz,bi,bj,k,.TRUE.,r4seg,arr)
            else
             write(msgbuf,'(a)')
     &         ' MDSREADFIELD_YZ_GL: illegal value for arrType'
             call print_error( msgbuf, mythid )
             stop 'ABNORMAL END: S/R MDSREADFIELD_YZ_GL'
            endif
           elseif (filePrec .eq. precFloat64) then
            read(dUnit,rec=irec) r8seg
#ifdef _BYTESWAPIO
            call MDS_BYTESWAPR8( sNy, r8seg )
#endif
            if (arrType .eq. 'RS') then
#ifdef REAL4_IS_SLOW
             call MDS_SEG8toRS_2D(sNy,oLy,nNz,bi,bj,k,.TRUE.,r8seg,arr)
#endif
            elseif (arrType .eq. 'RL') then
             call MDS_SEG8toRL_2D(sNy,oLy,nNz,bi,bj,k,.TRUE.,r8seg,arr)
            else
             write(msgbuf,'(a)')
     &         ' MDSREADFIELD_YZ_GL: illegal value for arrType'
             call print_error( msgbuf, mythid )
             stop 'ABNORMAL END: S/R MDSREADFIELD_YZ_GL'
            endif
           else
            write(msgbuf,'(a)')
     &        ' MDSREADFIELD_YZ_GL: illegal value for filePrec'
            call print_error( msgbuf, mythid )
            stop 'ABNORMAL END: S/R MDSREADFIELD_YZ_GL'
           endif
       do jj=1,sNy
        arr_gl(bi,ip,jj,bj,jp,k)=arr(jj,k,bi,bj)
       enddo

C End of k loop
         enddo
         if (.NOT. globalFile) then
          close( dUnit )
          fileIsOpen = .FALSE.
         endif
        endif
C End of bi,bj loops
       enddo
      enddo
C End of ip,jp loops
       enddo
      enddo

C If global file was opened then close it
      if (fileIsOpen .AND. globalFile) then
       close( dUnit )
       fileIsOpen = .FALSE.
      endif

      _END_MASTER( myThid )

#else /* ALLOW_AUTODIFF */
      STOP 'ABNORMAL END: S/R MDSREADFIELD_YZ_GL is empty'
#endif /* ALLOW_AUTODIFF */
C     ------------------------------------------------------------------
      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      SUBROUTINE MDSWRITEFIELD_XZ_GL(
     I   fName,
     I   filePrec,
     I   arrType,
     I   nNz,
     I   arr_gl,
     I   irecord,
     I   myIter,
     I   myThid )
C
C Arguments:
C
C fName      string  :: base name for file to write
C filePrec   integer :: number of bits per word in file (32 or 64)
C arrType    char(2) :: declaration of "arr": either "RS" or "RL"
C nNz        integer :: size of third dimension: normally either 1 or Nr
C arr         RS/RL  :: array to write, arr(:,:,nNz,:,:)
C irecord    integer :: record number to write
C myIter     integer :: time step number
C myThid     integer :: thread identifier
C
C MDSWRITEFIELD creates either a file of the form "fName.data" and
C "fName.meta" if the logical flag "globalFile" is set true. Otherwise
C it creates MDS tiled files of the form "fName.xxx.yyy.data" and
C "fName.xxx.yyy.meta". A meta-file is always created.
C Currently, the meta-files are not read because it is difficult
C to parse files in fortran. We should read meta information before
C adding records to an existing multi-record file.
C The precision of the file is decsribed by filePrec, set either
C to floatPrec32 or floatPrec64. The precision or declaration of
C the array argument must be consistently described by the char*(2)
C string arrType, either "RS" or "RL". nNz allows for both 2-D and
C 3-D arrays to be handled. nNz=1 implies a 2-D model field and
C nNz=Nr implies a 3-D model field. irecord is the record number
C to be read and must be >= 1. NOTE: It is currently assumed that
C the highest record number in the file was the last record written.
C Nor is there a consistency check between the routine arguments and file.
C ie. if your write record 2 after record 4 the meta information
C will record the number of records to be 2. This, again, is because
C we have read the meta information. To be fixed.
C
C Created: 03/16/99 adcroft@mit.edu
C
C Changed: 05/31/00 heimbach@mit.edu
C          open(dUnit, ..., status='old', ... -> status='unknown'

      implicit none
C Global variables / common blocks
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"

C Routine arguments
      character*(*) fName
      integer filePrec
      character*(2) arrType
      integer nNz
cph(
cph      Real arr(*)
      _RL arr_gl(sNx,nSx,nPx,nSy,nPy,Nr)
cph)
      integer irecord
      integer myIter
      integer myThid

#ifdef ALLOW_AUTODIFF
C Functions
      integer ILNBLNK
      integer MDS_RECLEN
C Local variables
      character*(MAX_LEN_FNAM) dataFName,metaFName
      integer ip,jp,iG,jG,irec,bi,bj,ii,k,dUnit,IL
      Real*4 r4seg(sNx)
      Real*8 r8seg(sNx)
      _RL arr(1-oLx:sNx+oLx,Nr,nSx,nSy)
      INTEGER dimList(3,3), nDims, map2gl(2)
      _RL dummyRL(1)
      CHARACTER*8 blank8c
      integer length_of_rec
      logical fileIsOpen
      character*(max_len_mbuf) msgbuf
C     ------------------------------------------------------------------

      DATA dummyRL(1) / 0. _d 0 /
      DATA blank8c / '        ' /

C Only do I/O if I am the master thread
      _BEGIN_MASTER( myThid )

#ifndef REAL4_IS_SLOW
      if (arrType .eq. 'RS') then
       write(msgbuf,'(a)')
     &   ' MDSWRITEFIELD_XZ_GL is wrong for arrType="RS" (=real*4)'
       call print_error( msgbuf, mythid )
       stop 'ABNORMAL END: S/R MDSWRITEFIELD_XZ_GL'
      endif
#endif

C Record number must be >= 1
      if (irecord .LT. 1) then
       write(msgbuf,'(a,i9.8)')
     &   ' MDSWRITEFIELD_XZ_GL: argument irecord = ',irecord
       call print_message( msgbuf, standardmessageunit,
     &                     SQUEEZE_RIGHT , mythid)
       write(msgbuf,'(a)')
     &   ' MDSWRITEFIELD_XZ_GL: invalid value for irecord'
       call print_error( msgbuf, mythid )
       stop 'ABNORMAL END: S/R MDSWRITEFIELD_XZ_GL'
      endif

C Assume nothing
      fileIsOpen=.FALSE.
      IL=ILNBLNK( fName )

C Assign a free unit number as the I/O channel for this routine
      call MDSFINDUNIT( dUnit, mythid )


C Loop over all processors
      do jp=1,nPy
      do ip=1,nPx
C Loop over all tiles
      do bj=1,nSy
       do bi=1,nSx
C If we are writing to a tiled MDS file then we open each one here
         iG=bi+(ip-1)*nsx ! Kludge until unstructered tiles
         jG=bj+(jp-1)*nsy ! Kludge until unstructered tiles
         write(dataFname,'(2a,i3.3,a,i3.3,a)')
     &              fName(1:IL),'.',iG,'.',jG,'.data'
         if (irecord .EQ. 1) then
          length_of_rec=MDS_RECLEN( filePrec, sNx, mythid )
          open( dUnit, file=dataFName, status=_NEW_STATUS,
     &       access='direct', recl=length_of_rec )
          fileIsOpen=.TRUE.
         else
          length_of_rec=MDS_RECLEN( filePrec, sNx, mythid )
          open( dUnit, file=dataFName, status=_OLD_STATUS,
     &       access='direct', recl=length_of_rec )
          fileIsOpen=.TRUE.
         endif
        if (fileIsOpen) then
         do k=1,Nr
            do ii=1,sNx
               arr(ii,k,bi,bj)=arr_gl(ii,bi,ip,bj,jp,k)
            enddo
            iG = 0
            jG = 0
            irec=k + Nr*(irecord-1)
           if (filePrec .eq. precFloat32) then
            if (arrType .eq. 'RS') then
#ifdef REAL4_IS_SLOW
             call MDS_SEG4toRS_2D(sNx,oLx,nNz,bi,bj,k,.FALSE.,r4seg,arr)
#endif
            elseif (arrType .eq. 'RL') then
             call MDS_SEG4toRL_2D(sNx,oLx,nNz,bi,bj,k,.FALSE.,r4seg,arr)
            else
             write(msgbuf,'(a)')
     &         ' MDSWRITEFIELD_XZ_GL: illegal value for arrType'
             call print_error( msgbuf, mythid )
             stop 'ABNORMAL END: S/R MDSWRITEFIELD_XZ_GL'
            endif
#ifdef _BYTESWAPIO
            call MDS_BYTESWAPR4( sNx, r4seg )
#endif
            write(dUnit,rec=irec) r4seg
           elseif (filePrec .eq. precFloat64) then
            if (arrType .eq. 'RS') then
#ifdef REAL4_IS_SLOW
             call MDS_SEG8toRS_2D(sNx,oLx,nNz,bi,bj,k,.FALSE.,r8seg,arr)
#endif
            elseif (arrType .eq. 'RL') then
             call MDS_SEG8toRL_2D(sNx,oLx,nNz,bi,bj,k,.FALSE.,r8seg,arr)
            else
             write(msgbuf,'(a)')
     &         ' MDSWRITEFIELD_XZ_GL: illegal value for arrType'
             call print_error( msgbuf, mythid )
             stop 'ABNORMAL END: S/R MDSWRITEFIELD_XZ_GL'
            endif
#ifdef _BYTESWAPIO
            call MDS_BYTESWAPR8( sNx, r8seg )
#endif
            write(dUnit,rec=irec) r8seg
           else
            write(msgbuf,'(a)')
     &        ' MDSWRITEFIELD_XZ_GL: illegal value for filePrec'
            call print_error( msgbuf, mythid )
            stop 'ABNORMAL END: S/R MDSWRITEFIELD_XZ_GL'
           endif
C End of k loop
         enddo
        else
         write(msgbuf,'(a)')
     &     ' MDSWRITEFIELD_XZ_GL: I should never get to this point'
         call print_error( msgbuf, mythid )
         stop 'ABNORMAL END: S/R MDSWRITEFIELD_XZ_GL'
        endif
C If we were writing to a tiled MDS file then we close it here
        if (fileIsOpen) then
         close( dUnit )
         fileIsOpen = .FALSE.
        endif
C Create meta-file for each tile if we are tiling
         iG=bi+(ip-1)*nsx ! Kludge until unstructered tiles
         jG=bj+(jp-1)*nsy ! Kludge until unstructered tiles
         write(metaFname,'(2a,i3.3,a,i3.3,a)')
     &              fName(1:IL),'.',iG,'.',jG,'.meta'
         dimList(1,1)=Nx
         dimList(2,1)=((ip-1)*nSx+(bi-1))*sNx+1
         dimList(3,1)=((ip-1)*nSx+bi)*sNx
         dimList(1,2)=nSy*nPy
         dimList(2,2)=(jp-1)*nSy+bj
         dimList(3,2)= jp*nSy+bj
         dimList(1,3)=Nr
         dimList(2,3)=1
         dimList(3,3)=Nr
         nDims=3
         if (Nr .EQ. 1) nDims=2
         map2gl(1) = 0
         map2gl(2) = 1
         CALL MDS_WRITE_META(
     I              metaFName, dataFName, the_run_name, ' ',
     I              filePrec, nDims, dimList, map2gl, 0, blank8c,
     I              0, dummyRL, oneRL, irecord, myIter, myThid )
C End of bi,bj loops
       enddo
      enddo
C End of ip,jp loops
       enddo
      enddo

      _END_MASTER( myThid )

#else /* ALLOW_AUTODIFF */
      STOP 'ABNORMAL END: S/R MDSWRITEFIELD_XZ_GL is empty'
#endif /* ALLOW_AUTODIFF */
C     ------------------------------------------------------------------
      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      SUBROUTINE MDSWRITEFIELD_YZ_GL(
     I   fName,
     I   filePrec,
     I   arrType,
     I   nNz,
     I   arr_gl,
     I   irecord,
     I   myIter,
     I   myThid )
C
C Arguments:
C
C fName      string  :: base name for file to write
C filePrec   integer :: number of bits per word in file (32 or 64)
C arrType    char(2) :: declaration of "arr": either "RS" or "RL"
C nNz        integer :: size of third dimension: normally either 1 or Nr
C arr         RS/RL  :: array to write, arr(:,:,nNz,:,:)
C irecord    integer :: record number to write
C myIter     integer :: time step number
C myThid     integer :: thread identifier
C
C MDSWRITEFIELD creates either a file of the form "fName.data" and
C "fName.meta" if the logical flag "globalFile" is set true. Otherwise
C it creates MDS tiled files of the form "fName.xxx.yyy.data" and
C "fName.xxx.yyy.meta". A meta-file is always created.
C Currently, the meta-files are not read because it is difficult
C to parse files in fortran. We should read meta information before
C adding records to an existing multi-record file.
C The precision of the file is decsribed by filePrec, set either
C to floatPrec32 or floatPrec64. The precision or declaration of
C the array argument must be consistently described by the char*(2)
C string arrType, either "RS" or "RL". nNz allows for both 2-D and
C 3-D arrays to be handled. nNz=1 implies a 2-D model field and
C nNz=Nr implies a 3-D model field. irecord is the record number
C to be read and must be >= 1. NOTE: It is currently assumed that
C the highest record number in the file was the last record written.
C Nor is there a consistency check between the routine arguments and file.
C ie. if your write record 2 after record 4 the meta information
C will record the number of records to be 2. This, again, is because
C we have read the meta information. To be fixed.
C
C Created: 03/16/99 adcroft@mit.edu
C
C Changed: 05/31/00 heimbach@mit.edu
C          open(dUnit, ..., status='old', ... -> status='unknown'

      implicit none
C Global variables / common blocks
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"

C Routine arguments
      character*(*) fName
      integer filePrec
      character*(2) arrType
      integer nNz
cph(
cph      Real arr(*)
      _RL arr_gl(nSx,nPx,sNy,nSy,nPy,Nr)
cph)
      integer irecord
      integer myIter
      integer myThid

#ifdef ALLOW_AUTODIFF
C Functions
      integer ILNBLNK
      integer MDS_RECLEN
C Local variables
      character*(MAX_LEN_FNAM) dataFName,metaFName
      integer ip,jp,iG,jG,irec,bi,bj,jj,k,dUnit,IL
      Real*4 r4seg(sNy)
      Real*8 r8seg(sNy)
      _RL arr(1-oLy:sNy+oLy,Nr,nSx,nSy)
      INTEGER dimList(3,3), nDims, map2gl(2)
      _RL dummyRL(1)
      CHARACTER*8 blank8c
      integer length_of_rec
      logical fileIsOpen
      character*(max_len_mbuf) msgbuf
C     ------------------------------------------------------------------

      DATA dummyRL(1) / 0. _d 0 /
      DATA blank8c / '        ' /

C Only do I/O if I am the master thread
      _BEGIN_MASTER( myThid )

#ifndef REAL4_IS_SLOW
      if (arrType .eq. 'RS') then
       write(msgbuf,'(a)')
     &   ' MDSWRITEFIELD_YZ_GL is wrong for arrType="RS" (=real*4)'
       call print_error( msgbuf, mythid )
       stop 'ABNORMAL END: S/R MDSWRITEFIELD_YZ_GL'
      endif
#endif

C Record number must be >= 1
      if (irecord .LT. 1) then
       write(msgbuf,'(a,i9.8)')
     &   ' MDSWRITEFIELD_YZ_GL: argument irecord = ',irecord
       call print_message( msgbuf, standardmessageunit,
     &                     SQUEEZE_RIGHT , mythid)
       write(msgbuf,'(a)')
     &   ' MDSWRITEFIELD_YZ_GL: invalid value for irecord'
       call print_error( msgbuf, mythid )
       stop 'ABNORMAL END: S/R MDSWRITEFIELD_YZ_GL'
      endif

C Assume nothing
      fileIsOpen=.FALSE.
      IL=ILNBLNK( fName )

C Assign a free unit number as the I/O channel for this routine
      call MDSFINDUNIT( dUnit, mythid )


C Loop over all processors
      do jp=1,nPy
      do ip=1,nPx
C Loop over all tiles
      do bj=1,nSy
       do bi=1,nSx
C If we are writing to a tiled MDS file then we open each one here
         iG=bi+(ip-1)*nsx ! Kludge until unstructered tiles
         jG=bj+(jp-1)*nsy ! Kludge until unstructered tiles
         write(dataFname,'(2a,i3.3,a,i3.3,a)')
     &              fName(1:IL),'.',iG,'.',jG,'.data'
         if (irecord .EQ. 1) then
          length_of_rec=MDS_RECLEN( filePrec, sNy, mythid )
          open( dUnit, file=dataFName, status=_NEW_STATUS,
     &       access='direct', recl=length_of_rec )
          fileIsOpen=.TRUE.
         else
          length_of_rec=MDS_RECLEN( filePrec, sNy, mythid )
          open( dUnit, file=dataFName, status=_OLD_STATUS,
     &       access='direct', recl=length_of_rec )
          fileIsOpen=.TRUE.
         endif
        if (fileIsOpen) then
         do k=1,Nr
            do jj=1,sNy
               arr(jj,k,bi,bj)=arr_gl(bi,ip,jj,bj,jp,k)
            enddo
            iG = 0
            jG = 0
            irec=k + Nr*(irecord-1)
           if (filePrec .eq. precFloat32) then
            if (arrType .eq. 'RS') then
#ifdef REAL4_IS_SLOW
             call MDS_SEG4toRS_2D(sNy,oLy,nNz,bi,bj,k,.FALSE.,r4seg,arr)
#endif
            elseif (arrType .eq. 'RL') then
             call MDS_SEG4toRL_2D(sNy,oLy,nNz,bi,bj,k,.FALSE.,r4seg,arr)
            else
             write(msgbuf,'(a)')
     &         ' MDSWRITEFIELD_YZ_GL: illegal value for arrType'
             call print_error( msgbuf, mythid )
             stop 'ABNORMAL END: S/R MDSWRITEFIELD_YZ_GL'
            endif
#ifdef _BYTESWAPIO
            call MDS_BYTESWAPR4( sNy, r4seg )
#endif
            write(dUnit,rec=irec) r4seg
           elseif (filePrec .eq. precFloat64) then
            if (arrType .eq. 'RS') then
#ifdef REAL4_IS_SLOW
             call MDS_SEG8toRS_2D(sNy,oLy,nNz,bi,bj,k,.FALSE.,r8seg,arr)
#endif
            elseif (arrType .eq. 'RL') then
             call MDS_SEG8toRL_2D(sNy,oLy,nNz,bi,bj,k,.FALSE.,r8seg,arr)
            else
             write(msgbuf,'(a)')
     &         ' MDSWRITEFIELD_YZ_GL: illegal value for arrType'
             call print_error( msgbuf, mythid )
             stop 'ABNORMAL END: S/R MDSWRITEFIELD_YZ_GL'
            endif
#ifdef _BYTESWAPIO
            call MDS_BYTESWAPR8( sNy, r8seg )
#endif
            write(dUnit,rec=irec) r8seg
           else
            write(msgbuf,'(a)')
     &        ' MDSWRITEFIELD_YZ_GL: illegal value for filePrec'
            call print_error( msgbuf, mythid )
            stop 'ABNORMAL END: S/R MDSWRITEFIELD_YZ_GL'
           endif
C End of k loop
         enddo
        else
         write(msgbuf,'(a)')
     &     ' MDSWRITEFIELD_YZ_GL: I should never get to this point'
         call print_error( msgbuf, mythid )
         stop 'ABNORMAL END: S/R MDSWRITEFIELD_YZ_GL'
        endif
C If we were writing to a tiled MDS file then we close it here
        if (fileIsOpen) then
         close( dUnit )
         fileIsOpen = .FALSE.
        endif
C Create meta-file for each tile if we are tiling
         iG=bi+(ip-1)*nsx ! Kludge until unstructered tiles
         jG=bj+(jp-1)*nsy ! Kludge until unstructered tiles
         write(metaFname,'(2a,i3.3,a,i3.3,a)')
     &              fName(1:IL),'.',iG,'.',jG,'.meta'
         dimList(1,1)=Nx
         dimList(2,1)=(ip-1)*nSx+bi
         dimList(3,1)=ip*nSx+bi
         dimList(1,2)=Ny
         dimList(2,2)=((jp-1)*nSy+(bj-1))*sNy+1
         dimList(3,2)=((jp-1)*nSy+bj)*sNy
         dimList(1,3)=Nr
         dimList(2,3)=1
         dimList(3,3)=Nr
         nDims=3
         if (Nr .EQ. 1) nDims=2
         map2gl(1) = 0
         map2gl(2) = 1
         CALL MDS_WRITE_META(
     I              metaFName, dataFName, the_run_name, ' ',
     I              filePrec, nDims, dimList, map2gl, 0, blank8c,
     I              0, dummyRL, oneRL, irecord, myIter, myThid )
C End of bi,bj loops
       enddo
      enddo
C End of ip,jp loops
       enddo
      enddo

      _END_MASTER( myThid )

#else /* ALLOW_AUTODIFF */
      STOP 'ABNORMAL END: S/R MDSWRITEFIELD_YZ_GL is empty'
#endif /* ALLOW_AUTODIFF */
C     ------------------------------------------------------------------
      RETURN
      END

#include "DIAG_OPTIONS.h"

CBOP
C     !ROUTINE: DIAGNOSTICS_INI_IO
C     !INTERFACE:
      SUBROUTINE DIAGNOSTICS_INI_IO( myThid )

C     !DESCRIPTION: \bv
C     *==================================================================
C     | S/R DIAGNOSTICS_INI_IO
C     | o create directory for mds output if needed
C     *==================================================================
C     \ev

C     !USES:
      IMPLICIT NONE

C     == Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "DIAGNOSTICS_SIZE.h"
#include "DIAGNOSTICS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     myThid - Thread number for this instance of the routine.
      INTEGER myThid
CEOP

C     !LOCAL VARIABLES:
C     == Local variables ==
      INTEGER iL, pIL
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      CHARACTER*(MAX_LEN_FNAM) namBuf
      INTEGER  ILNBLNK
      EXTERNAL ILNBLNK

      _BEGIN_MASTER( myThid )

      IF ( diag_mdsio .AND. (diagMdsDir.NE.' ') .AND.
     &     diagMdsDirCreate .AND. (mdsioLocalDir.EQ.' ') ) THEN
#ifdef HAVE_SYSTEM
C      create directory
        iL = ILNBLNK( diagMdsDir )
        WRITE(namBuf,'(3A)') ' mkdir -p ', diagMdsDir(1:iL), ' '
        pIL = 1 + ILNBLNK( namBuf )
        WRITE(standardMessageUnit,'(4A)')
     &       ' ==> SYSTEM CALL (from DIAGNOSTICS_INI_IO): ',
     &       '>', namBuf(1:pIL), '<'
        CALL SYSTEM( namBuf(1:pIL) )
        WRITE(msgBuf,'(A)') ' '
        CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
#else
        WRITE(msgBuf,'(2A)') 'S/R DIAGNOSTICS_INI_IO: ',
     &       'cannot call mkdir -> please create diagMdsDir manually'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(2A)') 'S/R DIAGNOSTICS_INI_IO: ',
     &       'and set diagMdsDirCreate=.FALSE. in data.diagnostics'
        CALL PRINT_ERROR( msgBuf, myThid )
        CALL ALL_PROC_DIE( 0 )
        STOP 'ABNORMAL END: S/R DIAGNOSTICS_INI_IO'
#endif
      ENDIF

      _END_MASTER( myThid )

      RETURN
      END

#include "ctrparam.h"
#include "ATM2D_OPTIONS.h"

C     !INTERFACE:
      SUBROUTINE TAVE_END_DIAGS(  nYears, myTime, myIter, myThid )
C     *==========================================================*
C     | Calculate and dump all diagnostics at tave periods.      |
C     *==========================================================*
        IMPLICIT NONE

C     === Global Atmosphere Variables ===
#include "ATMSIZE.h"
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "ATM2D_VARS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
C     nYears - number of years in this dump (maybe be different from
C              tave if starting time not divisible by tave)
C     myTime - current simulation time (ocean model time)
C     myIter - iteration number (ocean model)
C     myThid - Thread no. that called this routine.
      INTEGER nYears
      _RL     myTime
      INTEGER myIter
      INTEGER myThid

C     LOCAL VARIABLES:
      CHARACTER*(MAX_LEN_MBUF) suff, fn
      INTEGER ndmonth(12)
      DATA ndmonth/31,28,31,30,31,30,31,31,30,31,30,31/
      _RL secYr
      DATA secYr /31536000. _d 0/
      INTEGER i,j,mn,j_atm
      INTEGER simYr
      INTEGER dUnit
      _RS norm_factor
      _RL qnet_ann(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL evap_ann(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL precip_ann(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL runoff_ann(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL qrel_ann(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL frel_ann(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL qnet_mon(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL evap_mon(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL precip_mon(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL runoff_mon(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL qrel_mon(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL frel_mon(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL iceMask_mon(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL iceHeight_mon(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL iceTime_mon(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL oceMxLT_mon(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL oceMxLS_mon(1-OLx:sNx+OLx,1-OLy:sNy+OLy)


      DO j=1,sNy
        DO i=1,sNx

          qnet_ann(i,j) = 0. _d 0
          evap_ann(i,j) = 0. _d 0
          precip_ann(i,j) = 0. _d 0
          runoff_ann(i,j) = 0. _d 0
          qrel_ann(i,j) = 0. _d 0
          frel_ann(i,j) = 0. _d 0

        ENDDO
      ENDDO

      DO mn=1,nForcingPer

        norm_factor=nYears*ndmonth(mn)*86400.0
        DO j=1,sNy
          DO i=1,sNx

            qnet_mon(i,j)= qnet_atm_ta(i,j,mn)/norm_factor
            evap_mon(i,j)= evap_atm_ta(i,j,mn)/norm_factor
            precip_mon(i,j)= precip_atm_ta(i,j,mn)/norm_factor
            runoff_mon(i,j)=  runoff_atm_ta(i,j,mn)/norm_factor
            qrel_mon(i,j)= sum_qrel_ta(i,j,mn)/norm_factor
            frel_mon(i,j)= sum_frel_ta(i,j,mn)/norm_factor
            iceMask_mon(i,j)= sum_iceMask_ta(i,j,mn)/norm_factor
            iceHeight_mon(i,j)= sum_iceHeight_ta(i,j,mn)/norm_factor
            iceTime_mon(i,j)= sum_iceTime_ta(i,j,mn)/norm_factor
            oceMxLT_mon(i,j)= sum_oceMxLT_ta(i,j,mn)/norm_factor
            oceMxLS_mon(i,j)= sum_oceMxLS_ta(i,j,mn)/norm_factor

            qnet_ann(i,j) = qnet_ann(i,j) +
     &                      qnet_mon(i,j)*ndmonth(mn)/365.0
            evap_ann(i,j) = evap_ann(i,j) +
     &                      evap_mon(i,j)*ndmonth(mn)/365.0
            precip_ann(i,j) = precip_ann(i,j) +
     &                        precip_mon(i,j)*ndmonth(mn)/365.0
            runoff_ann(i,j) = runoff_ann(i,j) +
     &                        runoff_mon(i,j)*ndmonth(mn)/365.0
            qrel_ann(i,j) = qrel_ann(i,j) +
     &                      qrel_mon(i,j)*ndmonth(mn)/365.0
            frel_ann(i,j) = frel_ann(i,j) +
     &                      frel_mon(i,j)*ndmonth(mn)/365.0

            qnet_atm_ta(i,j,mn)= 0. _d 0
            evap_atm_ta(i,j,mn)= 0. _d 0
            precip_atm_ta(i,j,mn)= 0. _d 0
            runoff_atm_ta(i,j,mn)= 0. _d 0
            sum_qrel_ta(i,j,mn)= 0. _d 0
            sum_frel_ta(i,j,mn)= 0. _d 0
            sum_iceMask_ta(i,j,mn)= 0. _d 0
            sum_iceHeight_ta(i,j,mn)= 0. _d 0
            sum_iceTime_ta(i,j,mn)= 0. _d 0
            sum_oceMxLT_ta(i,j,mn)= 0. _d 0
            sum_oceMxLS_ta(i,j,mn)= 0. _d 0

          ENDDO
        ENDDO

        DO j_atm=1,jm0
          sum_tauu_ta(j_atm,mn) = sum_tauu_ta(j_atm,mn) / norm_factor
          sum_tauv_ta(j_atm,mn) = sum_tauv_ta(j_atm,mn) / norm_factor
          sum_wsocean_ta(j_atm,mn) = sum_wsocean_ta(j_atm,mn) /
     &                               norm_factor
          sum_ps4ocean_ta(j_atm,mn) = sum_ps4ocean_ta(j_atm,mn) /
     &                                norm_factor
        ENDDO

        WRITE(suff,'(I2.2)') mn
        CALL WRITE_FLD_XY_RL('amQnetAtmtave.', suff,
     &                       qnet_mon, myIter, myThid)
        CALL WRITE_FLD_XY_RL('amEvapAtmtave.', suff,
     &                       evap_mon, myIter, myThid)
        CALL WRITE_FLD_XY_RL('amPrecipAtmtave.', suff,
     &                       precip_mon, myIter, myThid)
        CALL WRITE_FLD_XY_RL('amRunoffAtmtave.', suff,
     &                       runoff_mon, myIter, myThid)
        CALL WRITE_FLD_XY_RL('amQrelfluxtave.', suff,
     &                       qrel_mon, myIter, myThid)
        CALL WRITE_FLD_XY_RL('amFrelfluxtave.', suff,
     &                       frel_mon, myIter, myThid)
        CALL WRITE_FLD_XY_RL('amIceMasktave.', suff,
     &                       iceMask_mon, myIter, myThid)
        CALL WRITE_FLD_XY_RL('amIceHeighttave.', suff,
     &                       iceHeight_mon, myIter, myThid)
        CALL WRITE_FLD_XY_RL('amIceTimetave.', suff,
     &                       iceTime_mon, myIter, myThid)
        CALL WRITE_FLD_XY_RL('amOceMxLTtave.', suff,
     &                       oceMxLT_mon, myIter, myThid)
        CALL WRITE_FLD_XY_RL('amOceMxLStave.', suff,
     &                       oceMxLS_mon, myIter, myThid)

      ENDDO

      WRITE(suff,'(I10.10)') myIter
      CALL WRITE_FLD_XY_RL('QnetAtmtave.',  suff,
     &                     qnet_ann,  myIter, myThid)
      CALL WRITE_FLD_XY_RL('EvapAtmtave.',  suff,
     &                     evap_ann,  myIter, myThid)
      CALL WRITE_FLD_XY_RL('PrecipAtmtave.',  suff,
     &                     precip_ann,  myIter, myThid)
      CALL WRITE_FLD_XY_RL('RunoffAtmtave.',  suff,
     &                     runoff_ann,  myIter, myThid)
      CALL WRITE_FLD_XY_RL('Qrelfluxtave.',  suff,
     &                     qrel_ann,  myIter, myThid)
      CALL WRITE_FLD_XY_RL('Frelfluxtave.',  suff,
     &                     frel_ann,  myIter, myThid)


      simYr = int(myIter*deltaTClock/secYr)
      CALL MDSFINDUNIT( dUnit, mythid )

      WRITE(fn,'(A,I5.5)') 'attauu.', simYr
      OPEN(dUnit, FILE=fn, STATUS='unknown',
     &     ACCESS='direct', RECL=8*jm0*nForcingPer, FORM='unformatted')
      WRITE(dUnit,REC=1) sum_tauu_ta
      CLOSE(dUnit)

      WRITE(fn,'(A,I5.5)') 'attauv.', simYr
      OPEN(dUnit, FILE=fn, STATUS='unknown',
     &     ACCESS='direct', RECL=8*jm0*nForcingPer, FORM='unformatted')
      WRITE(dUnit,REC=1) sum_tauv_ta
      CLOSE(dUnit)

      WRITE(fn,'(A,I5.5)') 'atwind.', simYr
      OPEN(dUnit, FILE=fn, STATUS='unknown',
     &     ACCESS='direct', RECL=8*jm0*nForcingPer, FORM='unformatted')
      WRITE(dUnit,REC=1) sum_wsocean_ta
      CLOSE(dUnit)

      WRITE(fn,'(A,I5.5)') 'atps4ocn.', simYr
      OPEN(dUnit, FILE=fn, STATUS='unknown',
     &     ACCESS='direct', RECL=8*jm0*nForcingPer, FORM='unformatted')
      WRITE(dUnit,REC=1) sum_ps4ocean_ta
      CLOSE(dUnit)

      DO mn=1,nForcingPer
        DO j_atm=1,jm0
          sum_tauu_ta(j_atm,mn) = 0. _d 0
          sum_tauv_ta(j_atm,mn) = 0. _d 0
          sum_wsocean_ta(j_atm,mn) = 0. _d 0
          sum_ps4ocean_ta(j_atm,mn) = 0. _d 0
        ENDDO
      ENDDO

      RETURN
      END

#include "AUTODIFF_OPTIONS.h"

      SUBROUTINE AUTODIFF_INADMODE_UNSET( myTime, myIter, myThid )
C     *==========================================================*
C     | SUBROUTINE AUTODIFF_INADMODE_UNSET
C     *==========================================================*

C     !USES:
      IMPLICIT NONE
C     == Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     myTime    :: Current time in simulation
C     myIter    :: Current iteration number
C     myThid    :: my Thread Id number
      _RL     myTime
      INTEGER myIter
      INTEGER myThid

      RETURN
      END

#include "SHELFICE_OPTIONS.h"

      SUBROUTINE SHELFICE_CHECK( myThid )
C     *==========================================================*
C     | SUBROUTINE SHELFICE_CHECK                                |
C     | o Validate basic package setup and inter-package         |
C     | dependencies.                                            |
C     *==========================================================*
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "SHELFICE.h"

C     === Routine arguments ===
C     myThid   :  Number of this instance of SHELFICE_CHECK
      INTEGER myThid

#ifdef ALLOW_SHELFICE

C     === Local variables ===
C     msgBuf   :: Informational/error message buffer
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      INTEGER errCount

      _BEGIN_MASTER(myThid)
      errCount = 0

      WRITE(msgBuf,'(A)') 'SHELFICE_CHECK: #define ALLOW_SHELFICE'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &     SQUEEZE_RIGHT, myThid )

C     print shelfice summary here before checking the parameter combinations
      WRITE(msgBuf,'(A)') ' '
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &     SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)')
     &     'SHELFICE_CHECK: start of SHELFICE config. summary'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &     SQUEEZE_RIGHT, myThid )

       CALL WRITE_0D_L( SHELFICEisOn, INDEX_NONE,
     &   'SHELFICEisOn =', ' /* package is turned on */')

       CALL WRITE_0D_L( useISOMIPTD, INDEX_NONE,
     &   'useISOMIPTD =', ' /* use simple isomip thermodynamics */')
       CALL WRITE_0D_L( SHELFICEconserve, INDEX_NONE,
     &   'SHELFICEconserve =',
     &      ' /* use a conservative form of boundary conditions */')
       CALL WRITE_0D_L( SHELFICEboundaryLayer, INDEX_NONE,
     &   'SHELFICEboundaryLayer =',
     &   ' /* use simple boundary layer scheme to suppress noise */')
       IF ( SHELFICEboundaryLayer ) THEN
        CALL WRITE_0D_L( SHI_withBL_realFWflux, INDEX_NONE,
     &   'SHI_withBL_realFWflux =',
     &   ' /* use real FW Flux in boundary layer scheme */')
       ENDIF
       CALL WRITE_0D_L( SHELFICEadvDiffHeatFlux, INDEX_NONE,
     &   'SHELFICEadvDiffHeatFlux =',
     &   ' /* use adv.-diff. instead of just diff. heat flux into'//
     &   ' the ice shelf */')
       CALL WRITE_0D_L( SHELFICEMassStepping, INDEX_NONE,
     &   'SHELFICEMassStepping =',
     &   ' /* step forward ice shelf mass/thickness */')
       CALL WRITE_0D_L( SHI_update_kTopC, INDEX_NONE,
     &   'SHI_update_kTopC =',
     &   ' /* update "kTopC" as ice shelf expand or retreat */')
       CALL WRITE_0D_L( no_slip_shelfice, INDEX_NONE,
     &   'no_slip_shelfice =', ' /* use no slip boundary conditions */')
       CALL WRITE_0D_RL( SHELFICEdragLinear, INDEX_NONE,
     & 'SHELFICEdragLinear    =', ' /* linear drag coefficient */')
       CALL WRITE_0D_RL( SHELFICEdragQuadratic, INDEX_NONE,
     & 'SHELFICEdragQuadratic =', ' /* quadratic drag coefficient */')
       CALL WRITE_0D_I( SHELFICEselectDragQuadr, INDEX_NONE,
     &  'SHELFICEselectDragQuadr =',
     &  ' /* select quadratic drag option */')
       CALL WRITE_0D_RL( SHELFICElatentHeat, INDEX_NONE,
     & 'SHELFICElatentHeat      =', ' /* latent heat of ice */')
       CALL WRITE_0D_RL( SHELFICEheatCapacity_Cp, INDEX_NONE,
     & 'SHELFICEheatCapacity_Cp =', ' /* heat capacity of ice shelf */')
       CALL WRITE_0D_RL( rhoShelfice, INDEX_NONE,
     & 'rhoShelfice   =', ' /* density of ice shelf */')
       CALL WRITE_0D_RL( SHELFICEkappa, INDEX_NONE,
     & 'SHELFICEkappa =', ' /* thermal conductivity of ice shelf */')
       CALL WRITE_0D_RL( SHELFICEthetaSurface, INDEX_NONE,
     & 'SHELFICEthetaSurface =',' /* surface temperature above i.s. */')
       CALL WRITE_0D_RL( SHELFICEheatTransCoeff, INDEX_NONE,
     & 'SHELFICEheatTransCoeff =', ' /* heat transfer coefficient */')
       CALL WRITE_0D_RL( SHELFICEsaltTransCoeff, INDEX_NONE,
     & 'SHELFICEsaltTransCoeff =', ' /* salt transfer coefficient */')

       CALL WRITE_0D_L( SHELFICEuseGammaFrict, INDEX_NONE,
     &   'SHELFICEuseGammaFrict =',
     &   ' /* use velocity dependent exchange coefficients */')
       IF ( SHELFICEuseGammaFrict ) THEN
        IF ( SHELFICEboundaryLayer ) THEN
         CALL WRITE_0D_L( SHI_withBL_uStarTopDz, INDEX_NONE,
     &   'SHI_withBL_uStarTopDz =',
     &   ' /* compute uStar from top Dz averaged uVel,vVel */')
        ELSE
         CALL WRITE_0D_L( SHELFICE_oldCalcUStar, INDEX_NONE,
     &   'SHELFICE_oldCalcUStar =', ' /* use old uStar expression */')
        ENDIF
        CALL WRITE_0D_RL( shiCdrag, INDEX_NONE,
     & 'shiCdrag   =', ' /* quadr. drag coefficient for uStar */')
        CALL WRITE_0D_RL( shiZetaN, INDEX_NONE,
     & 'shiZetaN   =', ' /* parameter for gammaTurb */')
        CALL WRITE_0D_RL( shiRc, INDEX_NONE,
     & 'shiRc      =', ' /* parameter for gammaTurb (not used) */')
        CALL WRITE_0D_RL( shiPrandtl, INDEX_NONE,
     & 'shiPrandtl =', ' /* const. Prandtl No. for gammaTurb */')
        CALL WRITE_0D_RL( shiSchmidt, INDEX_NONE,
     & 'shiSchmidt =', ' /* const. Schmidt No. for gammaTurb */')
        CALL WRITE_0D_RL( shiKinVisc, INDEX_NONE,
     & 'shiKinVisc =', ' /* const. kin. viscosity for gammaTurb */')
       ENDIF

      CALL WRITE_0D_RL( SHELFICEremeshFrequency, INDEX_NONE,
     &   'SHELFICEremeshFrequency =',
     &   ' /* Frequency (in s) of Remeshing */')
      IF ( SHELFICEremeshFrequency .GT. zeroRL ) THEN
        CALL WRITE_0D_RL( SHELFICEsplitThreshold, INDEX_NONE,
     &   'SHELFICEsplitThreshold =',
     &   ' /* hFac remesh threshold above which cell splits */')
        CALL WRITE_0D_RL( SHELFICEmergeThreshold, INDEX_NONE,
     &   'SHELFICEmergeThreshold =',
     &   ' /* hFac remesh threshold below which cell merges */')
      ENDIF

      CALL WRITE_0D_C( SHELFICEloadAnomalyFile, -1, INDEX_NONE,
     &  'SHELFICEloadAnomalyFile =',
     &  ' /* file name of loaded loadAnomaly field */')
      CALL WRITE_0D_C( SHELFICEmassFile, -1, INDEX_NONE,
     &  'SHELFICEmassFile =', ' /* file name of loaded mass field */')
      CALL WRITE_0D_C( SHELFICEtopoFile, -1, INDEX_NONE,
     &  'SHELFICEtopoFile =',
     &  ' /* file name of loaded under-ice topography */')
      CALL WRITE_0D_C( SHELFICEMassDynTendFile, -1, INDEX_NONE,
     &  'SHELFICEMassDynTendFile =',
     &  ' /* file name of loaded dynamic mass tendency field */')
C-    I/O parameters:
       CALL WRITE_0D_L( SHELFICEwriteState, INDEX_NONE,
     &   'SHELFICEwriteState  =', ' /* do simple standard output */')
       CALL WRITE_0D_L( SHELFICE_dump_mdsio, INDEX_NONE,
     &   'SHELFICE_dump_mdsio =', ' /* use mdsio for snapshots */')
       CALL WRITE_0D_L( SHELFICE_dump_mnc, INDEX_NONE,
     &   'SHELFICE_dump_mnc   =', ' /* use netcdf for snapshots */')
       CALL WRITE_0D_RL( SHELFICE_dumpFreq, INDEX_NONE,
     & 'SHELFICE_dumpFreq =', ' /* analoguous to dumpFreq */')

      WRITE(msgBuf,'(A)')
     &     'SHELFICE_CHECK: end of SHELFICE config. summary'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &     SQUEEZE_RIGHT, myThid )

C-    Check that CPP option is "defined" when corresponding run-time parameter is on
#ifndef ALLOW_ISOMIP_TD
      IF ( useISOMIPTD ) THEN
       WRITE(msgBuf,'(A,A,A)')
     &      'Run-time control flag useISOMIPTD was used'
       CALL PRINT_ERROR( msgBuf, myThid )
       WRITE(msgBuf,'(A,A,A)')
     &      'when CPP flag ALLOW_ISOMIP_TD was unset'
       CALL PRINT_ERROR( msgBuf, myThid )
       errCount = errCount + 1
      ENDIF
#else
      IF ( useISOMIPTD ) THEN
       IF ( SHELFICEconserve ) THEN
        WRITE(msgBuf,'(A,A,A)')
     &       'Run-time control flag SHELFICEconserve=.TRUE. was used'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(A,A,A)')
     &       'when useISOMIPTD=.TRUE.; this does not work!'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
       ENDIF
      ENDIF
#endif /* ALLOW_ISOMIP_TD */

#ifndef SHI_ALLOW_GAMMAFRICT
      IF ( SHELFICEuseGammaFrict ) THEN
       WRITE(msgBuf,'(A,A,A)')
     &      'Run-time control flag SHELFICEuseGammaFrict was used'
       CALL PRINT_ERROR( msgBuf, myThid )
       WRITE(msgBuf,'(A,A,A)')
     &      'when CPP flag SHI_ALLOW_GAMMAFRICT was unset'
       CALL PRINT_ERROR( msgBuf, myThid )
       errCount = errCount + 1
      ENDIF
#endif /* SHI_ALLOW_GAMMAFRICT */

#ifndef ALLOW_SHELFICE_REMESHING
      IF ( SHI_update_kTopC ) THEN
       WRITE(msgBuf,'(2A)') 'SHELFICE_CHECK: ',
     &      'SHI_update_kTopC only available with'
       CALL PRINT_ERROR( msgBuf, myThid )
       WRITE(msgBuf,'(2A)') 'SHELFICE_CHECK: ',
     &      'CPP option ALLOW_SHELFICE_REMESHING defined'
       CALL PRINT_ERROR( msgBuf, myThid )
       errCount = errCount + 1
      ENDIF
      IF ( SHELFICEremeshFrequency.GT.zeroRL ) THEN
       WRITE(msgBuf,'(A,A,A)')
     &      'Run-time SHELFICEremeshFrequency was set ( > 0 )'
       CALL PRINT_ERROR( msgBuf, myThid )
       WRITE(msgBuf,'(A,A,A)')
     &      'when CPP flag ALLOW_SHELFICE_REMESHING is unset'
       CALL PRINT_ERROR( msgBuf, myThid )
       errCount = errCount + 1
      ENDIF
#endif /* ALLOW_SHELFICE_REMESHING */

C     Consistent choice of parameter:

      IF ( SHELFICEmassFile.NE.' ' .AND. SHELFICEloadAnomalyFile.NE.' '
     &   ) THEN
         WRITE(msgBuf,'(2A)') 'SHELFICE_CHECK: cannot specify both',
     &      ' SHELFICEmassFile and SHELFICEloadAnomalyFile'
         CALL PRINT_ERROR( msgBuf, myThid )
         errCount = errCount + 1
      ENDIF
      IF ( SHELFICEMassStepping .AND. SHELFICEmassFile.EQ.' '
     &                   .AND. SHELFICEloadAnomalyFile.NE.' ' ) THEN
        WRITE(msgBuf,'(2A)') '** Warning ** SHELFICE_CHECK: ',
     &   'safer to set initial Mass when using SHELFICEMassStepping'
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
      ENDIF

C     So far, SHELFICE works only with oceanic z-coordinates
      IF ( buoyancyRelation .NE. 'OCEANIC' ) THEN
         WRITE(msgBuf,'(A)')
     &      'SHELFICE works only with buoyancyRelation = ''OCEANIC'''
         CALL PRINT_ERROR( msgBuf, myThid )
         errCount = errCount + 1
      ENDIF

      IF ( selectNHfreeSurf.NE.0 ) THEN
C--   Non-Hydrostatic Free-Surf below Ice-Shelf:
C     a) there is a practical implementation issue (kSurf > 1) that has to be
C        fixed before removing this stop.
C     b) In general, should also account for the vertical acceleration of the
C        Ice-shelf mass above Free-Surf in NH.Free-Surf equation (less obvious).
C        Ignore this term for now; as a consequence, might over-estimate
C        d.Eta/dt below Ice-Shelf.
         WRITE(msgBuf,'(2A,I3,A)') 'Current nonHydrostatic',
     &    ' Free-Surf option (selectNHfreeSurf=',selectNHfreeSurf,' )'
         CALL PRINT_ERROR( msgBuf, myThid )
         WRITE(msgBuf,'(A)') ' not compatible with SHELFICE code'
         CALL PRINT_ERROR( msgBuf, myThid )
         errCount = errCount + 1
      ENDIF

      IF ( SHELFICEremeshFrequency.GT.zeroRL ) THEN
       IF ( nonlinFreeSurf.LE.0 ) THEN
        WRITE(msgBuf,'(A,A,A)')
     &     'remeshing requires Non-Lin Free-Surf (nonlinFreeSurf > 0)'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
       ELSEIF ( select_rStar.GT.0 ) THEN
        WRITE(msgBuf,'(A,A,A)')
     &     'remeshing not implemented for r-Star coordinate ',
     &     '(select_rStar > 0)'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
       ENDIF
      ENDIF
      IF ( SHI_update_kTopC .AND. nonlinFreeSurf.LE.0 ) THEN
        WRITE(msgBuf,'(2A)') '** WARNING ** SHELFICE_CHECK: ',
     &       'linear Free-Surf not consistent with SHI_update_kTopC'
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
      ENDIF

C     SHELFICE may not work with many other packages,
C     e.g. vertical mixing schemes, in particular KPP will not work properly,
C     as KPP requires surface fluxes at the surface, whereas shelfice will
C     provide interfacial fluxes at some depth. Richardson flux number based
C     schemes such as Packanowski-Philander (PP81) should be no problem.
CML      IF ( useKPP ) THEN
CML         WRITE(msgBuf,'(A)')
CML     &      'SHELFICE and KPP cannot be turned on at the same time'
CML         CALL PRINT_ERROR( msgBuf , 1)
CML         errCount = errCount + 1
CML      ENDIF

      IF ( SHI_update_kTopC .AND. useSEAICE ) THEN
        WRITE(msgBuf,'(2A)') 'SHELFICE_CHECK: ',
     &   'pkg/seaice IGNORES Ice-Shelf retreat/advance'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(2A)') 'SHELFICE_CHECK: ',
     &   ' and does not work with SHI_update_kTopC=T'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF

C     Currently cannot use SHELFICEMassStepping with OpenAD
C     See shelfice_mass_stepping.F and github.com/MITgcm/MITgcm/pull/495
#ifdef ALLOW_OPENAD
      IF (SHELFICEMassStepping) THEN
       WRITE(msgBuf,'(2A)')
     &    'SHELFICEMassStepping does not currently work',
     &    ' with #define ALLOW_OPENAD'
       CALL PRINT_ERROR( msgBuf, myThid )
       errCount = errCount + 1
      ENDIF
#endif
      IF ( errCount.GE.1 ) THEN
        WRITE(msgBuf,'(A,I3,A)')
     &       'SHELFICE_CHECK: detected', errCount,' fatal error(s)'
        CALL PRINT_ERROR( msgBuf, myThid )
        CALL ALL_PROC_DIE( 0 )
        STOP 'ABNORMAL END: S/R SHELFICE_CHECK'
      ENDIF

      _END_MASTER(myThid)

#endif /* ALLOW_SHELFICE */

      RETURN
      END

#include "PROFILES_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C !ROUTINE: PROFILES_READPARMS

C !INTERFACE:
      SUBROUTINE PROFILES_READPARMS( myThid )

C     !DESCRIPTION:
C     Initialise the package cost.
C     Started: Ralf Giering 18-Jan-2001

C     !USES:
      IMPLICIT NONE
C     == Global variables ===
#include "EEPARAMS.h"
#include "SIZE.h"
#include "PARAMS.h"
#include "PROFILES_SIZE.h"
#include "profiles.h"

C     !INPUT/OUTPUT PARAMETERS:
C     myThid :: my Thread Id number
      INTEGER myThid
CEOP

C     !FUNCTIONS:
      INTEGER  ILNBLNK
      EXTERNAL ILNBLNK

C     !LOCAL VARIABLES:
C     msgBuf :: Informational/error message buffer
C     iUnit  :: Work variable for IO unit number
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      INTEGER iUnit, num_file, num_var, IL
      LOGICAL exst, specifiedNames
      CHARACTER*(128) fname

C Read the namelist input.
      NAMELIST /profiles_nml/
     &                   profilesDir,
     &                   profilesfiles,
     &                   mult_profiles,
     &                   mult_profiles_mean,
#ifdef ALLOW_PROFILES_SAMPLESPLIT_COST
C Number of independent samples
     &                   profiles_mean_indsamples,
#endif
     &                   prof_facmod,
     &                   prof_names,
     &                   prof_namesmod,
#ifdef ALLOW_PROFILES_CLIMMASK
     &                   prof_namesclim,
#endif
     &                   prof_itracer,
     &                   profilesDoNcOutput,
     &                   profilesDoGenGrid,
     &                   prof_make_nc

      IF ( .NOT.usePROFILES ) THEN
        _BEGIN_MASTER(myThid)
C Track pkg activation status:
C Print a (weak) warning if data.profiles is found
        CALL PACKAGES_UNUSED_MSG( 'usePROFILES', ' ', ' ' )
        _END_MASTER(myThid)
        RETURN
      ENDIF

      _BEGIN_MASTER( myThid )

C Set default values.
      profilesDir=' '

      DO num_file = 1, NFILESPROFMAX
        profilesfiles(num_file) = ' '
      ENDDO

      DO num_file = 1, NFILESPROFMAX
        DO num_var = 1, NVARMAX
          mult_profiles(num_file,num_var) = 1. _d 0
          prof_facmod(num_file,num_var)  = 1. _d 0
          prof_names(num_file,num_var) = 'empty'
          prof_itracer(num_file,num_var) = 1
          prof_namesmod(num_file,num_var) = 'empty'
#ifdef ALLOW_PROFILES_CLIMMASK
          prof_namesclim(num_file,num_var) = 'empty'
#endif
        ENDDO
      ENDDO

      DO num_var = 1, NVARMAX
        mult_profiles_mean(num_var) = 1. _d 0
#ifdef ALLOW_PROFILES_SAMPLESPLIT_COST
        profiles_mean_indsamples(num_var) = 1
#endif
      ENDDO

      profilesDoNcOutput = .false.
      prof_make_nc = .false.

      IF ( (.NOT.usingSphericalPolarGrid.OR.rotateGrid) ) THEN
        profilesDoGenGrid = .true.
      ELSE
        profilesDoGenGrid = .false.
      ENDIF

C Next, read cost data file.
      WRITE(msgBuf,'(A)') 'PROFILES_READPARMS: opening data.profiles'
      CALL PRINT_MESSAGE( msgBuf,
     &     standardMessageUnit, SQUEEZE_RIGHT, 1 )

      CALL OPEN_COPY_DATA_FILE(
     I     'data.profiles', 'PROFILES_READPARMS',
     O     iUnit,
     I     myThid )

      READ( iUnit, nml = profiles_nml )

      WRITE(msgBuf,'(2A)') 'PROFILES_READPARMS: ',
     & 'finished reading data.profiles'
      CALL PRINT_MESSAGE( msgBuf,
     &     standardMessageUnit, SQUEEZE_RIGHT, 1 )

#ifdef SINGLE_DISK_IO
      CLOSE(iUnit)
#else
      CLOSE(iUnit, STATUS = 'DELETE')
#endif /* SINGLE_DISK_IO */

      DO num_file = 1, NFILESPROFMAX
        specifiedNames = .FALSE.

        DO num_var = 1, NVARMAX
          IF (prof_names(num_file,num_var).NE.'empty')
     &      specifiedNames = .TRUE.
        ENDDO

        IF (.NOT.specifiedNames) THEN
          prof_names(num_file,1) = 'prof_T'
          prof_names(num_file,2) = 'prof_S'
#ifdef ALLOW_BLING
          prof_names(num_file,3) = 'prof_U'
          prof_names(num_file,4) = 'prof_V'
          prof_names(num_file,5) = 'prof_ptr'
          prof_names(num_file,6) = 'prof_ssh'
          prof_names(num_file,7) = 'prof_DIC'
          prof_names(num_file,8) = 'prof_ALK'
          prof_names(num_file,9) = 'prof_O2'
          prof_names(num_file,10) = 'prof_NO3'
          prof_names(num_file,11) = 'prof_PO4'
          prof_names(num_file,12) = 'prof_FE'
          prof_names(num_file,13) = 'prof_PCO'
          prof_names(num_file,14) = 'prof_PH'
          prof_names(num_file,15) = 'prof_CHL'
          prof_names(num_file,16) = 'prof_POC'

          prof_itracer(num_file,1) = 1
          prof_itracer(num_file,2) = 1
          prof_itracer(num_file,3) = 1
          prof_itracer(num_file,4) = 1
          prof_itracer(num_file,5) = 1
          prof_itracer(num_file,6) = 1
          prof_itracer(num_file,7) = 1
          prof_itracer(num_file,8) = 2
          prof_itracer(num_file,9) = 3
          prof_itracer(num_file,10) = 4
          prof_itracer(num_file,11) = 5
          prof_itracer(num_file,12) = 6
          prof_itracer(num_file,13) = 1
          prof_itracer(num_file,14) = 1
          prof_itracer(num_file,15) = 1
          prof_itracer(num_file,16) = 1
#endif /* ALLOW_BLING */

          prof_namesmod(num_file,1) = 'theta'
          prof_namesmod(num_file,2) = 'salt'
#ifdef ALLOW_BLING
          prof_namesmod(num_file,3) = 'uVel'
          prof_namesmod(num_file,4) = 'vVel'
          prof_namesmod(num_file,5) = 'pTracer'
          prof_namesmod(num_file,6) = 'etaN'
          prof_namesmod(num_file,7) = 'pTracer'
          prof_namesmod(num_file,8) = 'pTracer'
          prof_namesmod(num_file,9) = 'pTracer'
          prof_namesmod(num_file,10) = 'pTracer'
          prof_namesmod(num_file,11) = 'pTracer'
          prof_namesmod(num_file,12) = 'pTracer'
          prof_namesmod(num_file,13) = 'PCO'
          prof_namesmod(num_file,14) = 'PH'
          prof_namesmod(num_file,15) = 'CHL'
          prof_namesmod(num_file,16) = 'POC'
#endif /* ALLOW_BLING */
#ifdef ALLOW_PROFILES_CLIMMASK

          prof_namesclim(num_file,1) = 'prof_Tclim'
          prof_namesclim(num_file,2) = 'prof_Sclim'
#endif

        ENDIF !IF (.NOT. specifiedNames)

        DO num_var = 1, NVARMAX
          IF ( ((prof_names(num_file,num_var).NE.'empty') .AND.
     &          (prof_namesmod(num_file,num_var).EQ.'empty')) .OR.
     &         ((prof_names(num_file,num_var).EQ.'empty') .AND.
     &          (prof_namesmod(num_file,num_var).NE.'empty')) ) THEN
            PRINT *, 'prof_names = ',prof_names(num_file,num_var),' ',
     &       prof_namesmod(num_file,num_var),' ',num_file,num_var

            WRITE(errorMessageUnit,'(2A)')
     &       'ERROR in PROFILES_READPARMS: inconsistent ',
     &       'prof_names and prof_namesmod'
            CALL ALL_PROC_DIE( myThid )
            STOP 'ABNORMAL END: S/R PROFILES_READPARMS'

          ENDIF

          IL  = ILNBLNK( prof_names(num_file,num_var) )
          WRITE(prof_namesmask(num_file,num_var),'(2A)')
     &     prof_names(num_file,num_var)(1:IL),'mask'
          WRITE(prof_namesweight(num_file,num_var),'(2A)')
     &     prof_names(num_file,num_var)(1:IL),'weight'
#ifdef ALLOW_PROFILES_CLIMMASK
          WRITE(prof_namesclim(num_file,num_var),'(2A)')
     &     prof_names(num_file,num_var)(1:IL),'clim'
#endif
        ENDDO !DO num_var

        IF (profilesfiles(num_file).NE.' ') THEN
          IL  = ILNBLNK( profilesfiles(num_file) )
          fname = profilesfiles(num_file)(1:IL)//'.nc'
          INQUIRE( FILE = fname, EXIST = exst )
          IF (.NOT.exst) THEN
C Warn user as we override profilesfiles
            WRITE(msgBuf,'(3A)')
     &       '** WARNING ** PROFILES_READPARMS: missing file: ',
     &       profilesfiles(num_file)(1:IL),' gets switched off'
            CALL PRINT_MESSAGE( msgBuf,
     &           errorMessageUnit, SQUEEZE_RIGHT, myThid )

C Switch off this file (and potential cost function term)
              profilesfiles(num_file) = ' '

          ENDIF
        ENDIF

      ENDDO !DO num_file

      _END_MASTER( myThid )

      _BARRIER

      RETURN
      END

#include "PACKAGES_CONFIG.h"
#include "OPENAD_OPTIONS.h"

      subroutine template()
      use OAD_cp
      use OAD_tape
      use OAD_rev
      use revolve

c we may need these for the checkpointing
      use SIZE_mod
      use EEPARAMS_mod
      use PARAMS_mod
      use BAR2_mod
      use BARRIER_mod
#ifdef ALLOW_CD_CODE
      use CD_CODE_VARS_mod
#endif
      use CG2D_mod
      use CG3D_mod
      use DYNVARS_mod
      use EESUPPORT_mod
      use EOS_mod
      use EXCH_mod
      use FC_NAMEMANGLE_mod
      use FFIELDS_mod
#ifdef ALLOW_GENERIC_ADVDIFF
      use GAD_mod
#endif
      use GLOBAL_MAX_mod
      use GLOBAL_SUM_mod
#ifdef ALLOW_GGL90
      use GGL90_mod
#endif
#ifdef ALLOW_GMREDI
      use GMREDI_mod
#endif
      use GRID_mod
#ifdef ALLOW_KPP
      use KPP_mod
      use KPP_PARAMS_mod
#endif
#ifdef ALLOW_MOM_COMMON
      use MOM_VISC_mod
#endif
      use MPI_INFO_mod
#ifdef ALLOW_SHAP_FILT
      use SHAP_FILT_mod
#endif
#ifdef ALLOW_STREAMICE
      use STREAMICE_mod
      use STREAMICE_ADV_mod
      use STREAMICE_BDRY_mod
      use STREAMICE_CG_mod
#endif
      use SURFACE_mod
      use cost_mod
      use g_cost_mod
      use CTRL_mod
      use CTRL_DUMMY_mod
      use OPTIMCYCLE_mod
      use GRDCHK_mod

!$TEMPLATE_PRAGMA_DECLARATIONS
      LOGICAL :: initialized=.FALSE.
      TYPE(rvAction),save :: theAction
      CHARACTER(80) :: errorMsg
      integer, save :: jointCPCount
      integer, save :: currIter

      integer :: cp_loop_variable_1,cp_loop_variable_2,
     +     cp_loop_variable_3,cp_loop_variable_4,cp_loop_variable_5

      type(modeType) :: our_orig_mode

      integer iaddr
      external iaddr

#ifdef OAD_DEBUG_JOINT
      character*(80):: indentation='                                        
     +                                         '
      our_indent=our_indent+1

      write(standardmessageunit, '(A,A,A)', ADVANCE='NO')
     +'OAD:',indentation(1:our_indent), 'enter __SRNAME__:'
      call oad_dump_revmod(); call oad_dump_tapestats()
      write(standardmessageunit,*)
#endif

      nIter0 = NINT( (startTime-baseTime)/deltaTClock )
      if (our_rev_mode%arg_store) then
        call cp_write_open()
#ifdef OAD_DEBUG_JOINT
         write(standardmessageunit,'(A,A,A)')
     +'OAD:',indentation(1:our_indent),
     +' __SRNAME__: entering arg store'
#endif
!$PLACEHOLDER_PRAGMA$ id=8
       call cp_close()
      end if
      if (our_rev_mode%arg_restore) then
#ifdef OAD_DEBUG_JOINT
         write(standardmessageunit,'(A,A,A)')
     +'OAD:',indentation(1:our_indent),
     +' __SRNAME__: entering arg restore'
#endif
        call cp_read_open()
!$PLACEHOLDER_PRAGMA$ id=9
        call cp_close()
      end if
      if (our_rev_mode%plain) then
#ifdef OAD_DEBUG_JOINT
         write(standardmessageunit,'(A,A,A)')
     +'OAD:',indentation(1:our_indent),
     +' __SRNAME__: run plain, down plain'
#endif
#ifdef ALLOW_OPENAD_DIVA
      DO iloop1 = 1, nTimeSteps
        PROD = (ILOOP1 + NTIMESTEPS_L2 *(ILOOP +(-1)))
        print *, 'DIVA Revolve Plain PROD = ', PROD
        CALL OpenAD_forward_step( PROD, mytime, myiter, mythid )
      enddo
#else
      DO iloop = 1, nTimeSteps
        CALL OpenAD_forward_step( iloop, mytime, myiter, mythid )
      enddo
#endif
      end if
      if (our_rev_mode%tape) then
#ifdef OAD_DEBUG_JOINT
         write(standardmessageunit,'(A,A,A)')
     +'OAD:',indentation(1:our_indent),
     +' __SRNAME__: run tape, down revolve until first U turn'
#endif
         currIter=0
         jointCPcount=cp_fNumber()
         initialized=rvInit(nTimeSteps,120,
     +                      errorMsg,theAction)
         IF (.NOT.initialized) WRITE(*,'(A,A)') 'Error: ', errorMsg
         do while (theAction%actionFlag/=rvDone)
           theAction=rvNextAction()
           select case (theAction%actionFlag)
             case (rvStore)
                call cp_write_open(theAction%cpNum+jointCPCount)
!$PLACEHOLDER_PRAGMA$ id=8
                call cp_close
             case (rvForward)
                call OAD_revPlain
                do currIter=currIter,theAction%iteration-1
#ifdef ALLOW_OPENAD_DIVA
                   PROD = (currIter+1 + NTIMESTEPS_L2 *(ILOOP +(-1)))
                   print *, 'DIVA Revolve Tape rvForward PROD = ', PROD
                   CALL OpenAD_forward_step( PROD, mytime,
     +myiter, mythid )
#else
                   CALL OpenAD_forward_step( currIter+1, mytime,
     +myiter, mythid )
#endif
                end do
                call OAD_revTape
             case (rvFirstUTurn)
#ifdef ALLOW_OPENAD_DIVA
                PROD = (currIter+1 + NTIMESTEPS_L2 *(ILOOP +(-1)))
                print *, 'DIVA Revolve Tape rvFirstUTurn PROD = ', PROD
                CALL OpenAD_forward_step( PROD, mytime, myiter,
     +mythid )
#else
                CALL OpenAD_forward_step( currIter+1, mytime, myiter,
     +mythid )
#endif
! get out now ...
                exit
             end select
          end do
      end if
      if (our_rev_mode%adjoint) then
        IF (.NOT.initialized) WRITE(*,'(A)') 'Error: not initialized'
        do while (theAction%actionFlag/=rvDone)
           select case (theAction%actionFlag)
             case (rvFirstUTurn)
!we taped already ... see above
#ifdef ALLOW_OPENAD_DIVA
                PROD = (currIter+1 + NTIMESTEPS_L2 *(ILOOP +(-1)))
                print *, 'DIVA Revolve Adjoint rvFirstUTurn PROD = ', PROD
                CALL OpenAD_forward_step( PROD, mytime, myiter,
     +mythid )
#else
                CALL OpenAD_forward_step( currIter+1, mytime, myiter,
     +mythid )
#endif
             case (rvStore)
                call cp_write_open(theAction%cpNum+jointCPCount)
!$PLACEHOLDER_PRAGMA$ id=8
                call cp_close
             case (rvRestore)
                call cp_read_open(theAction%cpNum+jointCPCount)
!$PLACEHOLDER_PRAGMA$ id=9
                currIter=theAction%iteration
                call cp_close
             case (rvForward)
                call OAD_revPlain
                do currIter=currIter,theAction%iteration-1
#ifdef ALLOW_OPENAD_DIVA
                   PROD = (currIter+1 + NTIMESTEPS_L2 *(ILOOP +(-1)))
                   print *, 'DIVA Revolve Adjoint rvForward PROD = ', PROD
                   CALL OpenAD_forward_step( PROD, mytime, myiter,
     + mythid )
#else
                   CALL OpenAD_forward_step( currIter+1, mytime, myiter,
     + mythid )
#endif
                end do
                call OAD_revAdjoint
             case (rvUTurn)
#ifdef ALLOW_OPENAD_DIVA
                PROD = (currIter+1 + NTIMESTEPS_L2 *(ILOOP +(-1)))
#endif
                call OAD_revTape
#ifdef ALLOW_OPENAD_DIVA
                print *, 'DIVA Revolve Adjoint rvUTurn tp PROD = ', PROD
                CALL OpenAD_forward_step( PROD, mytime, myiter,
     +mythid )
#else
                CALL OpenAD_forward_step( currIter+1, mytime, myiter,
     +mythid )
#endif
                call OAD_revAdjoint
#ifdef ALLOW_OPENAD_DIVA
                print *, 'DIVA Revolve Adjoint rvUTurn ad PROD = ', PROD
                CALL OpenAD_forward_step( PROD, mytime, myiter,
     +mythid )
#else
                CALL OpenAD_forward_step( currIter+1, mytime, myiter,
     +mythid )
#endif
           end select
           theAction=rvNextAction()
        end do
      end if

#ifdef OAD_DEBUG_JOINT
      write(standardmessageunit,'(A,A,A)', ADVANCE='NO')
     +'OAD:',indentation(1:our_indent), 'leave __SRNAME__:'
      call oad_dump_revmod(); call oad_dump_tapestats()
      write(standardmessageunit,*)

      our_indent=our_indent-1
#endif

      end subroutine template

#include "DEBUG_OPTIONS.h"

CBOP
C     !ROUTINE: DEBUG_MSG
C     !INTERFACE:
      SUBROUTINE DEBUG_MSG(
     I                text,
     I                myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE DEBUG_MSG
C     | o Prints to STDOUT the text argument
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     === Global data ===
#include "SIZE.h"
#include "EEPARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     text      :: test to write
C     myThid    :: my Thread Id number
      CHARACTER*(*) text
      INTEGER myThid

C     !LOCAL VARIABLES:
C     msgBuf    :: Informational/error message buffer
      CHARACTER*(MAX_LEN_MBUF) msgBuf
CEOP

      _BEGIN_MASTER( myThid )
      WRITE(msgBuf,'(A11,A60)') 'DEBUG_MSG: ',text
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
C-    can be usefull to flush the io unit (but not standard f77)
c     CALL FLUSH(standardMessageUnit)
      _END_MASTER( myThid )

      RETURN
      END

#include "AIM_OPTIONS.h"

C--  File aim_tendency_apply.F: Routines to Add AIM tendency contributions
C--   Contents
C--   o AIM_TENDENCY_APPLY_U
C--   o AIM_TENDENCY_APPLY_V
C--   o AIM_TENDENCY_APPLY_T
C--   o AIM_TENDENCY_APPLY_S

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: AIM_TENDENCY_APPLY_U
C     !INTERFACE:
      SUBROUTINE AIM_TENDENCY_APPLY_U(
     U                        gU_arr,
     I                        iMin,iMax,jMin,jMax, k, bi, bj,
     I                        myTime, myIter, myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R AIM_TENDENCY_APPLY_U
C     | o Add AIM tendency terms to U tendency.
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     == Global data ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "DYNVARS.h"
#ifdef ALLOW_FRICTION_HEATING
# include "FFIELDS.h"
#endif

#include "AIM_PARAMS.h"
#include "AIM2DYN.h"

C     !INPUT/OUTPUT PARAMETERS:
C     gU_arr    :: the tendency array
C     iMin,iMax :: Working range of x-index for applying forcing.
C     jMin,jMax :: Working range of y-index for applying forcing.
C     k         :: Current vertical level index
C     bi,bj     :: Current tile indices
C     myTime    :: Current time in simulation
C     myIter    :: Current iteration number
C     myThid    :: my Thread Id number
      _RL     gU_arr(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER iMin, iMax, jMin, jMax
      INTEGER k, bi, bj
      _RL     myTime
      INTEGER myIter
      INTEGER myThid
CEOP

#ifdef ALLOW_AIM
C     == Local variables in common block ==
#ifdef ALLOW_DIAGNOSTICS
C     aim_uStress :: surface stress applied to zonal wind
      COMMON /LOCAL_AIM_TENDENCY_APPLY_U/ aim_uStress,aim_KEuStr
      _RL aim_uStress(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL aim_KEuStr (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
#endif

C     == Local variables ==
C     i,j  :: Loop counters
      INTEGER i, j
      _RL uStr_tmp
#if ( defined ALLOW_FRICTION_HEATING ) || ( defined ALLOW_DIAGNOSTICS )
      _RL aim_dKE(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
#endif

#ifdef ALLOW_DIAGNOSTICS
      IF ( myTime.EQ.startTime .AND. k.EQ.1 ) THEN
C-    Initialise diagnostic array aim_uStress
       DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
         aim_uStress(i,j,bi,bj) = 0.
         aim_KEuStr(i,j,bi,bj)  = 0.
        ENDDO
       ENDDO
      ENDIF
#endif

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
      IF ( k.EQ.Nr .AND. aim_dragStrato.GT.0. ) THEN
C- Note: exclusive IF / ELSE is legitimate here since surface drag
C        is not supposed to be applied in stratosphere
       DO j=jMin,jMax
        DO i=iMin,iMax
          gU_arr(i,j) = gU_arr(i,j)
     &     -maskW(i,j,k,bi,bj)*uVel(i,j,k,bi,bj)/aim_dragStrato
#if ( defined ALLOW_FRICTION_HEATING ) || ( defined ALLOW_DIAGNOSTICS )
          aim_dKE(i,j) =
     &     -uVel(i,j,k,bi,bj)*uVel(i,j,k,bi,bj)/aim_dragStrato
     &                       *hFacW(i,j,k,bi,bj)*drF(k)*rUnit2mass
#endif
        ENDDO
       ENDDO
      ELSEIF ( k.EQ.1 ) THEN
       DO j=jMin,jMax
        DO i=iMin,iMax
         IF ( maskW(i,j,k,bi,bj) .NE. 0. ) THEN
          uStr_tmp =
     &     -( aim_drag(i-1,j,bi,bj)+aim_drag(i,j,bi,bj) )
     &       * 0.5 _d 0 * uVel(i,j,k,bi,bj)
          gU_arr(i,j) = gU_arr(i,j)
     &                + uStr_tmp*gravity*recip_drF(k)
     &                * recip_hFacW(i,j,k,bi,bj)
#ifdef ALLOW_DIAGNOSTICS
          aim_uStress(i,j,bi,bj) = uStr_tmp
#endif
#if ( defined ALLOW_FRICTION_HEATING ) || ( defined ALLOW_DIAGNOSTICS )
          aim_dKE(i,j) = uStr_tmp * uVel(i,j,k,bi,bj)
         ELSE
          aim_dKE(i,j) = 0.
#endif
         ENDIF
        ENDDO
       ENDDO
      ELSE
       DO j=jMin,jMax
        DO i=iMin,iMax
         IF ( maskW(i,j,k-1,bi,bj) .EQ. 0.
     &    .AND. maskW(i,j,k,bi,bj) .NE. 0. ) THEN
          uStr_tmp =
     &      -( (1.-maskC(i-1,j,k-1,bi,bj))*aim_drag(i-1,j,bi,bj)
     &        +(1.-maskC( i ,j,k-1,bi,bj))*aim_drag( i ,j,bi,bj)
     &       )* 0.5 _d 0 * uVel(i,j,k,bi,bj)
          gU_arr(i,j) = gU_arr(i,j)
     &                + uStr_tmp*gravity*recip_drF(k)
     &                * recip_hFacW(i,j,k,bi,bj)
#ifdef ALLOW_DIAGNOSTICS
          aim_uStress(i,j,bi,bj) = uStr_tmp
#endif
#if ( defined ALLOW_FRICTION_HEATING ) || ( defined ALLOW_DIAGNOSTICS )
          aim_dKE(i,j) = uStr_tmp * uVel(i,j,k,bi,bj)
         ELSE
          aim_dKE(i,j) = 0.
#endif
         ENDIF
        ENDDO
       ENDDO
      ENDIF
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#ifdef ALLOW_FRICTION_HEATING
      IF ( addFrictionHeating ) THEN
        DO j=1,sNy
         DO i=1,sNx
           frictionHeating(i,j,k,bi,bj) = frictionHeating(i,j,k,bi,bj)
     &         - halfRL * ( aim_dKE( i, j)*rAw( i, j,bi,bj)
     &                    + aim_dKE(i+1,j)*rAw(i+1,j,bi,bj)
     &                    )*recip_rA(i,j,bi,bj)
         ENDDO
        ENDDO
      ENDIF
#endif /* ALLOW_FRICTION_HEATING */
#ifdef ALLOW_DIAGNOSTICS
      IF ( usediagnostics ) THEN
       IF ( k.EQ.1 ) THEN
        DO j=jMin,jMax
         DO i=iMin,iMax
          aim_KEuStr(i,j,bi,bj) = aim_dKE(i,j)
         ENDDO
        ENDDO
       ELSE
        DO j=jMin,jMax
         DO i=iMin,iMax
          aim_KEuStr(i,j,bi,bj) = aim_KEuStr(i,j,bi,bj)
     &                          + aim_dKE(i,j)
         ENDDO
        ENDDO
       ENDIF
       IF ( k.EQ.Nr ) THEN
        CALL DIAGNOSTICS_FILL( aim_uStress, 'UFLUX   ',
     &                         0,1,1,bi,bj,myThid)
        CALL DIAGNOSTICS_FILL( aim_KEuStr,  'dKE_Ustr',
     &                         0,1,1,bi,bj,myThid)
       ENDIF
      ENDIF
#endif /* ALLOW_DIAGNOSTICS */

#endif /* ALLOW_AIM */

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: AIM_TENDENCY_APPLY_V
C     !INTERFACE:
      SUBROUTINE AIM_TENDENCY_APPLY_V(
     U                        gV_arr,
     I                        iMin,iMax,jMin,jMax, k, bi, bj,
     I                        myTime, myIter, myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R TENDENCY_APPLY_V
C     | o Add AIM tendency terms to V tendency.
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     == Global data ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "DYNVARS.h"
#ifdef ALLOW_FRICTION_HEATING
# include "FFIELDS.h"
#endif

#include "AIM_PARAMS.h"
#include "AIM2DYN.h"

C     !INPUT/OUTPUT PARAMETERS:
C     gV_arr    :: the tendency array
C     iMin,iMax :: Working range of x-index for applying forcing.
C     jMin,jMax :: Working range of y-index for applying forcing.
C     k         :: Current vertical level index
C     bi,bj     :: Current tile indices
C     myTime    :: Current time in simulation
C     myIter    :: Current iteration number
C     myThid    :: my Thread Id number
      _RL     gV_arr(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER iMin, iMax, jMin, jMax
      INTEGER k, bi, bj
      _RL     myTime
      INTEGER myIter
      INTEGER myThid
CEOP

#ifdef ALLOW_AIM
C     == Local variables in common block ==
#ifdef ALLOW_DIAGNOSTICS
C     aim_vStress :: surface stress applied to meridional wind
      COMMON /LOCAL_AIM_TENDENCY_APPLY_V/ aim_vStress,aim_KEvStr
      _RL aim_vStress(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL aim_KEvStr(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
#endif

C     == Local variables ==
C     i,j  :: Loop counters
      INTEGER i, j
      _RL vStr_tmp
#if ( defined ALLOW_FRICTION_HEATING ) || ( defined ALLOW_DIAGNOSTICS )
      _RL aim_dKE(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
#endif

#ifdef ALLOW_DIAGNOSTICS
      IF ( myTime.EQ.startTime .AND. k.EQ.1 ) THEN
C-    Initialise diagnostic array aim_uStress
       DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
         aim_vStress(i,j,bi,bj) = 0.
         aim_KEvStr(i,j,bi,bj)  = 0.
        ENDDO
       ENDDO
      ENDIF
#endif

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
      IF ( k.EQ.Nr .AND. aim_dragStrato.GT.0. ) THEN
C- Note: exclusive IF / ELSE is legitimate here since surface drag
C        is not supposed to be applied in the stratosphere
       DO j=jMin,jMax
        DO i=iMin,iMax
          gV_arr(i,j) = gV_arr(i,j)
     &     -maskS(i,j,k,bi,bj)*vVel(i,j,k,bi,bj)/aim_dragStrato
#if ( defined ALLOW_FRICTION_HEATING ) || ( defined ALLOW_DIAGNOSTICS )
          aim_dKE(i,j) =
     &     -vVel(i,j,k,bi,bj)*vVel(i,j,k,bi,bj)/aim_dragStrato
     &                       *hFacS(i,j,k,bi,bj)*drF(k)*rUnit2mass
#endif
        ENDDO
       ENDDO
      ELSEIF ( k.EQ.1 ) THEN
       DO j=jMin,jMax
        DO i=iMin,iMax
         IF ( maskS(i,j,k,bi,bj) .NE. 0. ) THEN
          vStr_tmp =
     &     -( aim_drag(i,j-1,bi,bj)+aim_drag(i,j,bi,bj) )
     &       * 0.5 _d 0 * vVel(i,j,k,bi,bj)
          gV_arr(i,j) = gV_arr(i,j)
     &                + vStr_tmp*gravity*recip_drF(k)
     &                * recip_hFacS(i,j,k,bi,bj)
#ifdef ALLOW_DIAGNOSTICS
          aim_vStress(i,j,bi,bj) = vStr_tmp
#endif
#if ( defined ALLOW_FRICTION_HEATING ) || ( defined ALLOW_DIAGNOSTICS )
          aim_dKE(i,j) = vStr_tmp * vVel(i,j,k,bi,bj)
         ELSE
          aim_dKE(i,j) = 0.
#endif
         ENDIF
        ENDDO
       ENDDO
      ELSE
       DO j=jMin,jMax
        DO i=iMin,iMax
         IF ( maskS(i,j,k-1,bi,bj) .EQ. 0.
     &    .AND. maskS(i,j,k,bi,bj) .NE. 0. ) THEN
          vStr_tmp =
     &     -( (1.-maskC(i,j-1,k-1,bi,bj))*aim_drag(i,j-1,bi,bj)
     &       +(1.-maskC(i, j ,k-1,bi,bj))*aim_drag(i, j ,bi,bj)
     &      )* 0.5 _d 0 * vVel(i,j,k,bi,bj)
          gV_arr(i,j) = gV_arr(i,j)
     &                + vStr_tmp*gravity*recip_drF(k)
     &                * recip_hFacS(i,j,k,bi,bj)
#ifdef ALLOW_DIAGNOSTICS
          aim_vStress(i,j,bi,bj) = vStr_tmp
#endif
#if ( defined ALLOW_FRICTION_HEATING ) || ( defined ALLOW_DIAGNOSTICS )
          aim_dKE(i,j) = vStr_tmp * vVel(i,j,k,bi,bj)
         ELSE
          aim_dKE(i,j) = 0.
#endif
         ENDIF
        ENDDO
       ENDDO
      ENDIF
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#ifdef ALLOW_FRICTION_HEATING
      IF ( addFrictionHeating ) THEN
        DO j=1,sNy
         DO i=1,sNx
           frictionHeating(i,j,k,bi,bj) = frictionHeating(i,j,k,bi,bj)
     &         - halfRL * ( aim_dKE(i, j )*rAs(i, j, bi,bj)
     &                    + aim_dKE(i,j+1)*rAs(i,j+1,bi,bj)
     &                    )*recip_rA(i,j,bi,bj)
         ENDDO
        ENDDO
      ENDIF
#endif /* ALLOW_FRICTION_HEATING */
#ifdef ALLOW_DIAGNOSTICS
      IF ( usediagnostics ) THEN
       IF ( k.EQ.1 ) THEN
        DO j=jMin,jMax
         DO i=iMin,iMax
          aim_KEvStr(i,j,bi,bj) = aim_dKE(i,j)
         ENDDO
        ENDDO
       ELSE
        DO j=jMin,jMax
         DO i=iMin,iMax
          aim_KEvStr(i,j,bi,bj) = aim_KEvStr(i,j,bi,bj)
     &                          + aim_dKE(i,j)
         ENDDO
        ENDDO
       ENDIF
       IF ( k.EQ.Nr ) THEN
        CALL DIAGNOSTICS_FILL( aim_vStress, 'VFLUX   ',
     &                         0,1,1,bi,bj,myThid)
        CALL DIAGNOSTICS_FILL( aim_KEvStr,  'dKE_Vstr',
     &                         0,1,1,bi,bj,myThid)
       ENDIF
      ENDIF
#endif /* ALLOW_DIAGNOSTICS */

#endif /* ALLOW_AIM */

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: AIM_TENDENCY_APPLY_T
C     !INTERFACE:
      SUBROUTINE AIM_TENDENCY_APPLY_T(
     U                        gT_arr,
     I                        iMin,iMax,jMin,jMax, k, bi, bj,
     I                        myTime, myIter, myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R AIM_TENDENCY_APPLY_T
C     | o Add AIM tendency to potential Temp tendency.
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     == Global data ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
c#include "DYNVARS.h"

#include "AIM2DYN.h"

C     !INPUT/OUTPUT PARAMETERS:
C     gT_arr    :: the tendency array
C     iMin,iMax :: Working range of x-index for applying forcing.
C     jMin,jMax :: Working range of y-index for applying forcing.
C     k         :: Current vertical level index
C     bi,bj     :: Current tile indices
C     myTime    :: Current time in simulation
C     myIter    :: Current iteration number
C     myThid    :: my Thread Id number
      _RL     gT_arr(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER iMin, iMax, jMin, jMax
      INTEGER k, bi, bj
      _RL     myTime
      INTEGER myIter
      INTEGER myThid
CEOP

#ifdef ALLOW_AIM
C     == Local variables ==
C     i,j  :: Loop counters
      INTEGER I, J

C--   Forcing: add AIM heating/cooling tendency to gT:
      DO J=1,sNy
       DO I=1,sNx
        gT_arr(i,j) = maskC(i,j,k,bi,bj)
     &              *( gT_arr(i,j) + aim_dTdt(i,j,k,bi,bj) )
       ENDDO
      ENDDO

#endif /* ALLOW_AIM */

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: AIM_TENDENCY_APPLY_S
C     !INTERFACE:
      SUBROUTINE AIM_TENDENCY_APPLY_S(
     U                        gS_arr,
     I                        iMin,iMax,jMin,jMax, k, bi, bj,
     I                        myTime, myIter, myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R AIM_TENDENCY_APPLY_S
C     | o Add AIM tendency to Specific Humidity tendency.
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     == Global data ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
c#include "DYNVARS.h"

#include "AIM2DYN.h"

C     !INPUT/OUTPUT PARAMETERS:
C     gS_arr    :: the tendency array
C     iMin,iMax :: Working range of x-index for applying forcing.
C     jMin,jMax :: Working range of y-index for applying forcing.
C     k         :: Current vertical level index
C     bi,bj     :: Current tile indices
C     myTime    :: Current time in simulation
C     myIter    :: Current iteration number
C     myThid    :: my Thread Id number
      _RL     gS_arr(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER iMin, iMax, jMin, jMax
      INTEGER k, bi, bj
      _RL     myTime
      INTEGER myIter
      INTEGER myThid
CEOP

#ifdef ALLOW_AIM
C     == Local variables ==
C     i,j  :: Loop counters
      INTEGER I, J

C--   Forcing: add AIM dq/dt tendency to gS:
      DO J=1,sNy
       DO I=1,sNx
        gS_arr(i,j) = maskC(i,j,k,bi,bj)
     &              *( gS_arr(i,j) + aim_dSdt(i,j,k,bi,bj) )
       ENDDO
      ENDDO

#endif /* ALLOW_AIM */

      RETURN
      END

#include "EMBED_FILES_OPTIONS.h"
      
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 0
C     !ROUTINE: EMBED_FILES_INIT

C     !INTERFACE:
      SUBROUTINE EMBED_FILES_INIT( myThid )

C     !DESCRIPTION:
C     The functionality for the embed_files package is very simple, so
C     all this "initialization" routine needs to do is call the C
C     routine which writes whatever files have been embedded.
      
C     !USES:
#include "SIZE.h"
#include "EEPARAMS.h"
#include "EESUPPORT.h"

C     !INPUT PARAMETERS:
      integer myThid
CEOP

C     !LOCAL VARIABLES:

      _BEGIN_MASTER( myThid )

#ifdef ALLOW_USE_MPI
      IF ( mpiMyId.EQ.0 ) THEN
#endif

        CALL embdec

#ifdef ALLOW_USE_MPI
      ENDIF
#endif

      _END_MASTER( myThid )

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#include "OCN_CPL_OPTIONS.h"

CBOP 0
C !ROUTINE: CPL_INIT

C !INTERFACE:
      SUBROUTINE CPL_INIT

C !DESCRIPTION:
C     *==========================================================*
C     | SUBROUTINE CPL_INIT
C     | o Routine controlling coupler layer initialisation.
C     | - Oceanic version -
C     *==========================================================*
C     | This version talks to the MIT Coupler. It uses the MIT
C     | Coupler "checkpoint1" library calls.
C     *==========================================================*

C !USES:
      IMPLICIT NONE
C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "EESUPPORT.h"
#include "OCNIDS.h"

C !INPUT/OUTPUT PARAMETERS:
C     myThid   :: Thread number for this instance of the routine
c     INTEGER myThid
CEOP

#ifdef COMPONENT_MODULE
C !LOCAL VARIABLES:
C     msgUnit  :: log-file I/O unit
      INTEGER msgUnit

C--   Initialise connection with coupler
      CALL MITCOMPONENT_INIT(
     I                  ocnCompName,
     O                  MPI_COMM_MODEL, msgUnit )
#endif

      RETURN
      END

#include "SBO_OPTIONS.h"

CBOP
C !ROUTINE: SBO_READPARMS

C !INTERFACE:
      SUBROUTINE SBO_READPARMS( myThid )

C !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE SBO_READPARMS
C     | o Routine to read in file data.sbo
C     *==========================================================*

C !USES:
      IMPLICIT NONE
C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "SBO.h"

C !INPUT PARAMETERS:
C     myThid   :: my Thread Id number
      INTEGER myThid

#ifdef ALLOW_SBO
C !LOCAL VARIABLES:
C     === Local variables ===
C     msgBuf   :: Informational/error message buffer
C     iUnit    :: Work variable for IO unit number
C     nRetired :: Counter used to trap namelists containing "retired" parameters

      CHARACTER*(MAX_LEN_MBUF) msgBuf
      INTEGER iUnit
      INTEGER nRetired, errCount
      _RL     sbo_taveFreq
CEOP

C--   SBO parameters
      NAMELIST /SBO_PARM01/ sbo_taveFreq, sbo_monFreq

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      IF ( .NOT.useSBO ) THEN
C-    pkg SBO is not used
        _BEGIN_MASTER(myThid)
C-    Track pkg activation status:
C     print a (weak) warning if data.sbo is found
         CALL PACKAGES_UNUSED_MSG( 'useSBO', ' ', ' ' )
        _END_MASTER(myThid)
        RETURN
      ENDIF

      _BEGIN_MASTER(myThid)
      errCount = 0

      WRITE(msgBuf,'(A)') ' SBO_READPARMS: opening data.sbo'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )

      CALL OPEN_COPY_DATA_FILE(
     I                          'data.sbo', 'SBO_READPARMS',
     O                          iUnit,
     I                          myThid )

C--   set default SBO parameters
      sbo_monFreq  = monitorFreq

C--   Initialise retired parameters to unlikely value
      nRetired = 0
      sbo_taveFreq = UNSET_RL

C-----------------------------------------------------------------------

C--   Read settings from model parameter file "data.sbo".
      READ(UNIT=iUnit,NML=SBO_PARM01)

C     Close the open data file
#ifdef SINGLE_DISK_IO
      CLOSE(iUnit)
#else
      CLOSE(iUnit,STATUS='DELETE')
#endif /* SINGLE_DISK_IO */

      WRITE(msgBuf,'(A)') ' SBO_READPARMS: finished reading data.sbo'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )

C     Check for retired parameters still being used
      IF ( sbo_taveFreq .NE. UNSET_RL ) THEN
        nRetired = nRetired + 1
        WRITE(msgBuf,'(A,A)') 'S/R SBO_READPARMS: "sbo_taveFreq" ',
     &  'is no longer allowed in file "data.sbo"'
        CALL PRINT_ERROR( msgBuf, myThid )
      ENDIF

C--   Check whether any retired parameters were found.
      IF ( nRetired .GT. 0 ) THEN
        WRITE(msgBuf,'(2A)') 'S/R SBO_READPARMS: ',
     &   'Error reading parameter file "data.sbo"'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(A)')
     &   'some out of date parameters were found in the namelist'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF

C--   Stop if any error was found (including retired params):
      IF ( errCount .GE. 1 ) THEN
        WRITE(msgBuf,'(A,I3,A)')
     &   'S/R SBO_READPARMS: detected', errCount,' fatal error(s)'
        CALL PRINT_ERROR( msgBuf, myThid )
        CALL ALL_PROC_DIE( 0 )
        STOP 'ABNORMAL END: S/R SBO_READPARMS'
      ENDIF

      _END_MASTER(myThid)

C--   Everyone else must wait for the parameters to be loaded
      _BARRIER

#endif /* ALLOW_SBO */

      RETURN
      END

#include "PTRACERS_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: PTRACERS_INIT_FIXED

C     !INTERFACE:
      SUBROUTINE PTRACERS_INIT_FIXED( myThid )

C     !DESCRIPTION:
C     Initialize PTRACERS constant

C     !USES:
#include "PTRACERS_MOD.h"
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "PTRACERS_SIZE.h"
#include "PTRACERS_PARAMS.h"
#include "GAD.h"

C     !INPUT PARAMETERS:
      INTEGER myThid
CEOP

#ifdef ALLOW_PTRACERS
C     !FUNCTIONS
      INTEGER  GAD_ADVSCHEME_GET
      EXTERNAL GAD_ADVSCHEME_GET

C     !LOCAL VARIABLES:
C     iTracer     :: tracer index
C     errCount    :: error counter
C     tracMinSize :: overlap minimum size for ptracers advection
C     msgBuf      :: Informational/error message buffer
      INTEGER iTracer
      INTEGER errCount
      INTEGER tracMinSize, minSize
      LOGICAL updateMinSize
      CHARACTER*(MAX_LEN_MBUF) msgBuf

      _BEGIN_MASTER( myThid )
      errCount = 0

C     Initialise internal parameter in common block:
      DO iTracer = 1, PTRACERS_num
        PTRACERS_MultiDimAdv(iTracer)  = multiDimAdvection
        PTRACERS_SOM_Advection(iTracer)= .FALSE.
        PTRACERS_AdamsBashGtr(iTracer) = .FALSE.
        PTRACERS_AdamsBash_Tr(iTracer) = .FALSE.
      ENDDO

C--   Loop over tracers
      tracMinSize = 0
      DO iTracer = 1, PTRACERS_numInUse

C-    Check for valid advection-scheme number
        IF ( PTRACERS_advScheme(iTracer).NE.0 ) THEN
         minSize = GAD_ADVSCHEME_GET( PTRACERS_advScheme(iTracer) )
         IF ( minSize.LT.0 ) THEN
          WRITE(msgBuf,'(2A,I6)') 'PTRACERS_INIT_FIXED: ',
     &    'invalid Adv. Scheme number=', PTRACERS_advScheme(iTracer)
          CALL PRINT_ERROR( msgBuf, myThid )
          WRITE(msgBuf,'(2A,I6)') 'PTRACERS_INIT_FIXED: ',
     &    'for tracer #', iTracer
          CALL PRINT_ERROR( msgBuf, myThid )
          errCount = errCount + 1
         ENDIF
        ELSE
         minSize = 1
        ENDIF
C     Overlap minimum size consistent with ptracers advection
        tracMinSize = MAX( tracMinSize, minSize )

        IF (
     &       PTRACERS_advScheme(iTracer).EQ.ENUM_CENTERED_2ND .OR.
     &       PTRACERS_advScheme(iTracer).EQ.ENUM_UPWIND_3RD .OR.
     &       PTRACERS_advScheme(iTracer).EQ.ENUM_CENTERED_4TH .OR.
     &       PTRACERS_advScheme(iTracer).EQ.0
     &     ) PTRACERS_MultiDimAdv(iTracer) = .FALSE.
        useMultiDimAdvec = useMultiDimAdvec
     &                .OR. PTRACERS_MultiDimAdv(iTracer)
        PTRACERS_AdamsBashGtr(iTracer) =
     &       PTRACERS_advScheme(iTracer).EQ.ENUM_CENTERED_2ND .OR.
     &       PTRACERS_advScheme(iTracer).EQ.ENUM_UPWIND_3RD .OR.
     &       PTRACERS_advScheme(iTracer).EQ.ENUM_CENTERED_4TH
        IF ( .NOT.PTRACERS_doAB_onGpTr ) THEN
         PTRACERS_AdamsBash_Tr(iTracer) = PTRACERS_AdamsBashGtr(iTracer)
         PTRACERS_AdamsBashGtr(iTracer) = .FALSE.
        ENDIF

        PTRACERS_SOM_Advection(iTracer) =
     &    PTRACERS_advScheme(iTracer).GE.ENUM_SOM_PRATHER
     &    .AND. PTRACERS_advScheme(iTracer).LE.ENUM_SOM_LIMITER
#ifndef PTRACERS_ALLOW_DYN_STATE
        IF ( PTRACERS_SOM_Advection(iTracer) ) THEN
          WRITE(msgBuf,'(2A)') 'PTRACERS_INIT_FIXED: ',
     &   'trying to use 2nd.Order-Moment Advection without'
          CALL PRINT_ERROR( msgBuf, myThid )
          WRITE(msgBuf,'(2A)') 'PTRACERS_INIT_FIXED: ',
     &   'dynamical internal state data structures compiled'
          CALL PRINT_ERROR( msgBuf, myThid )
          WRITE(msgBuf,'(2A)') 'PTRACERS_INIT_FIXED: ',
     &   'Re-compile with:  #define PTRACERS_ALLOW_DYN_STATE'
          CALL PRINT_ERROR( msgBuf, myThid )
          errCount = errCount + 1
        ENDIF
#endif /* ndef PTRACERS_ALLOW_DYN_STATE */

C--   end of Tracer loop
      ENDDO

C--   Update Overlap minimum size according to tracer advection
      updateMinSize = GAD_OlMinSize(1).LT.tracMinSize
      GAD_OlMinSize(1) = MAX( GAD_OlMinSize(1), tracMinSize )
C-    Constraint on size of the overlap (after updating "useMultiDimAdvec"):
      IF ( useCubedSphereExchange .AND. useMultiDimAdvec ) THEN
C-    multi-dim-advection on CS-grid requires to double the size of OLx,OLy
        updateMinSize = updateMinSize .OR. ( GAD_OlMinSize(3).LT.2 )
        GAD_OlMinSize(3) = MAX( GAD_OlMinSize(3), 2 )
      ENDIF
      IF ( updateMinSize ) THEN
        WRITE(msgBuf,'(2A,9I3)') 'PTRACERS_INIT_FIXED: ',
     &      'updated GAD_OlMinSize=', GAD_OlMinSize
        CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      ENDIF

#ifdef PTRACERS_ALLOW_DYN_STATE
      CALL PTRACERS_INIT_FIXED_DYNAMIC( PtrISt,
     &                                  PTRACERS_numInUse,
     &                                  PTRACERS_SOM_Advection,
     &                                  sNx, sNy, Nr, OLx, OLy,
     &                                  nSx, nSy, nSOM,
     &                                  myThid )
#endif

C--   Stop if any error was found:
      IF ( errCount .GE. 1 ) THEN
        WRITE(msgBuf,'(A,I3,A)')
     &  'S/R PTRACERS_INIT_FIXED: detected', errCount,' fatal error(s)'
        CALL PRINT_ERROR( msgBuf, myThid )
        CALL ALL_PROC_DIE( 0 )
        STOP 'ABNORMAL END: S/R PTRACERS_INIT_FIXED'
      ENDIF

      _END_MASTER( myThid )
      _BARRIER

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#ifdef ALLOW_MNC
      IF (useMNC) THEN
C       Initialize the MNC variable types for PTRACERS
        CALL PTRACERS_MNC_INIT( myThid )
      ENDIF
#endif

#ifdef ALLOW_DIAGNOSTICS
      IF ( useDiagnostics ) THEN
        CALL PTRACERS_DIAGNOSTICS_INIT( myThid )
      ENDIF
#endif

#endif /* ALLOW_PTRACERS */

      RETURN
      END

#include "GMREDI_OPTIONS.h"
#ifdef ALLOW_AUTODIFF
# include "AUTODIFF_OPTIONS.h"
#endif
#ifdef ALLOW_CTRL
# include "CTRL_OPTIONS.h"
#endif
#if ( defined GM_READ_K3D_GM   || defined GM_VISBECK_VARIABLE_K \
      || defined ALLOW_GM_LEITH_QG || defined GM_BATES_K3D )
# define GM_USE_K3D_GM
#endif

CBOP
C     !ROUTINE: GMREDI_CALC_PSI_BOLUS
C     !INTERFACE:
      SUBROUTINE GMREDI_CALC_PSI_BOLUS(
     I             bi, bj, iMin, iMax, jMin, jMax,
     I             sigmaX, sigmaY, sigmaR, locK3dGM,
     I             ldd97_LrhoW, ldd97_LrhoS,
     I             myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE GMREDI_CALC_PSI_BOLUS
C     | o Calculate stream-functions for GM bolus velocity
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     == Global variables ==
#include "SIZE.h"
#include "GRID.h"
#include "DYNVARS.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GMREDI.h"
#include "FFIELDS.h"
#ifdef ALLOW_CTRL
# include "CTRL_FIELDS.h"
#endif
#ifdef ALLOW_AUTODIFF_TAMC
# include "tamc.h"
#endif /* ALLOW_AUTODIFF_TAMC */

C     !INPUT/OUTPUT PARAMETERS:
      _RL sigmaX(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL sigmaY(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL sigmaR(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
#ifdef GM_USE_K3D_GM
      _RL locK3dGM(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
#else
      _RL locK3dGM(1)
#endif
      _RL ldd97_LrhoW(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL ldd97_LrhoS(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER bi,bj,iMin,iMax,jMin,jMax
      INTEGER myThid
CEOP

#ifdef ALLOW_GMREDI
#ifdef GM_BOLUS_ADVEC

C     !LOCAL VARIABLES:
      INTEGER i,j,k, km1
#ifdef ALLOW_AUTODIFF_TAMC
C     tkey :: tape key (depends on tiles)
C     kkey :: tape key (depends on levels and tiles)
      INTEGER tkey, kkey
#endif
      _RL halfSign
      _RL rDepth, half_K
      _RL SlopeX(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL SlopeY(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL dSigmaDrW(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL dSigmaDrS(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL taperX(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL taperY(1-OLx:sNx+OLx,1-OLy:sNy+OLy)

C-    Initialization : <= done in S/R gmredi_init

#ifdef ALLOW_AUTODIFF_TAMC
      tkey = bi + (bj-1)*nSx + (ikey_dynamics-1)*nSx*nSy
#endif /* ALLOW_AUTODIFF_TAMC */

      IF (GM_AdvForm) THEN
C     change sign of vertical Sigma gradient to match stratification sign
       halfSign = halfRL*gravitySign

       DO k=2,Nr
        km1 = k-1

#ifdef ALLOW_AUTODIFF
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          SlopeX(i,j)       = 0. _d 0
          SlopeY(i,j)       = 0. _d 0
          dSigmaDrW(i,j)    = 0. _d 0
          dSigmaDrS(i,j)    = 0. _d 0
         ENDDO
        ENDDO
#endif

C      Gradient of Sigma below U and V points
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx+1,sNx+OLx
          SlopeX(i,j) = ( sigmaX(i,j,km1)+sigmaX(i,j,k) )*halfRL
     &                   *maskW(i,j,km1,bi,bj)*maskW(i,j,k,bi,bj)
          dSigmaDrW(i,j) = ( sigmaR(i-1,j,k)+sigmaR(i,j,k) )*halfSign
     &                   *maskW(i,j,km1,bi,bj)*maskW(i,j,k,bi,bj)
         ENDDO
        ENDDO
        DO j=1-OLy+1,sNy+OLy
         DO i=1-OLx,sNx+OLx
          SlopeY(i,j) = ( sigmaY(i,j,km1)+sigmaY(i,j,k) )*halfRL
     &                   *maskS(i,j,km1,bi,bj)*maskS(i,j,k,bi,bj)
          dSigmaDrS(i,j) = ( sigmaR(i,j-1,k)+sigmaR(i,j,k) )*halfSign
     &                   *maskS(i,j,km1,bi,bj)*maskS(i,j,k,bi,bj)
         ENDDO
        ENDDO

C      set "rDepth" (= depth from the surface, in rUnit) for 'ldd97' tapering
        IF ( usingZcoords ) THEN
         rDepth = rF(1) - rF(k)
        ELSE
         rDepth = rF(k) - rF(Nr+1)
        ENDIF
C      Calculate slopes , taper and/or clip
        CALL GMREDI_SLOPE_PSI(
     O              taperX, taperY,
     U              SlopeX, SlopeY,
     U              dSigmaDrW, dSigmaDrS,
     I              ldd97_LrhoW, ldd97_LrhoS, rDepth, k,
     I              bi, bj, myThid )

#ifdef ALLOW_AUTODIFF_TAMC
        kkey = k + (tkey-1)*Nr
CADJ STORE SlopeX(:,:)       = comlev1_bibj_k, key=kkey, byte=isbyte
CADJ STORE SlopeY(:,:)       = comlev1_bibj_k, key=kkey, byte=isbyte
CADJ STORE taperX(:,:)       = comlev1_bibj_k, key=kkey, byte=isbyte
CADJ STORE taperY(:,:)       = comlev1_bibj_k, key=kkey, byte=isbyte
#endif /* ALLOW_AUTODIFF_TAMC */

C-  Compute the 2 stream-function Components ( GM bolus vel.)
C   Note: since SlopeX,Y have been masked, no needs to mask again GM_PsiX,Y
        half_K = GM_background_K
     &         *(GM_bolFac1d(km1)+GM_bolFac1d(k))*op25
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx+1,sNx+OLx
          GM_PsiX(i,j,k,bi,bj) = SlopeX(i,j)*taperX(i,j)
#ifdef GM_USE_K3D_GM
     &     *( op25
     &        *( locK3dGM(i-1,j,km1)+locK3dGM(i,j,km1)
     &         + locK3dGM(i-1,j,k)+locK3dGM(i,j,k) )
#else
     &     *( half_K
     &          *(GM_bolFac2d(i-1,j,bi,bj)+GM_bolFac2d(i,j,bi,bj))
#endif
#ifdef GM_GEOM_VARIABLE_K
     &      + op5*(GEOM_K3d(i-1,j,k,bi,bj)+GEOM_K3d(i,j,k,bi,bj))
#endif
     &      )
c    &       *maskW(i,j,km1,bi,bj)*maskW(i,j,k,bi,bj)
#ifdef ALLOW_EDDYPSI
     &     +eddyPsiX(i,j,k,bi,bj)*maskW(i,j,k,bi,bj)
#endif
         ENDDO
        ENDDO
        DO j=1-OLy+1,sNy+OLy
         DO i=1-OLx,sNx+OLx
          GM_PsiY(i,j,k,bi,bj) = SlopeY(i,j)*taperY(i,j)
#ifdef GM_USE_K3D_GM
     &     *( op25
     &        *( locK3dGM(i,j-1,km1)+locK3dGM(i,j,km1)
     &         + locK3dGM(i,j-1,k)+locK3dGM(i,j,k) )
#else
     &     *( half_K
     &          *(GM_bolFac2d(i,j-1,bi,bj)+GM_bolFac2d(i,j,bi,bj))
#endif
#ifdef GM_GEOM_VARIABLE_K
     &      + op5*(GEOM_K3d(i,j-1,k,bi,bj)+GEOM_K3d(i,j,k,bi,bj))
#endif
     &      )
c    &       *maskS(i,j,km1,bi,bj)*maskS(i,j,k,bi,bj)
#ifdef ALLOW_EDDYPSI
     &     +eddyPsiY(i,j,k,bi,bj)*maskS(i,j,k,bi,bj)
#endif
         ENDDO
        ENDDO

C----- end of loop on level k
       ENDDO

C     end if GM_AdvForm block
      ENDIF
#endif /* GM_BOLUS_ADVEC */
#endif /* ALLOW_GMREDI */

      RETURN
      END

#include "GCHEM_OPTIONS.h"
#undef GCHEM_REPORT_UNUSED_PARAMS

CBOP
C     !ROUTINE: GCHEM_CHECK
C     !INTERFACE:
      SUBROUTINE GCHEM_CHECK( myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE GCHEM_CHECK
C     | o Validate basic package setup and inter-package
C     |   dependencies.
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GCHEM.h"
#ifdef ALLOW_CFC
# include "CFC_SIZE.h"
#endif
#ifdef ALLOW_SPOIL
# include "SPOIL_SIZE.h"
#endif
#include "GCHEM_SIZE.h"
#ifdef ALLOW_PTRACERS
# include "PTRACERS_SIZE.h"
# include "PTRACERS_PARAMS.h"
#endif
#ifdef ALLOW_CAL
# include "cal.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     myThid   :: My Thread Id number
      INTEGER myThid

#ifdef ALLOW_GCHEM
C     !FUNCTIONS:
#ifdef ALLOW_CAL
      INTEGER  ILNBLNK
      EXTERNAL ILNBLNK
#endif

C     !LOCAL VARIABLES:
C     msgBuf   :: Informational/error message buffer
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      INTEGER errCount
      INTEGER nb_tendTr
      INTEGER ioUnit
#ifdef ALLOW_CAL
      INTEGER IL
#endif
#ifdef GCHEM_REPORT_UNUSED_PARAMS
      INTEGER k
      INTEGER gchem_int(5)
      _RL     gchem_rl(5)
      CHARACTER*(MAX_LEN_FNAM) gchem_fileName(5)
      CHARACTER*(10) varName
#endif
CEOP

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      _BEGIN_MASTER(myThid)
      errCount = 0

      WRITE(msgBuf,'(2A)') 'GCHEM_CHECK ',
     &                     ' --> Starts to check GCHEM set-up'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )

C--   Check GCHEM Options and Parameters:

#ifndef GCHEM_ADD2TR_TENDENCY
      IF ( useCFC ) THEN
        WRITE(msgBuf,'(A)') 'GCHEM_ADD2TR_TENDENCY needed to use CFC'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF
#endif /* ndef GCHEM_ADD2TR_TENDENCY */

#ifndef GCHEM_SEPARATE_FORCING
      IF ( useDIC ) THEN
        WRITE(msgBuf,'(A)') 'GCHEM_SEPARATE_FORCING needed to use DIC'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF
      IF ( useBLING ) THEN
        WRITE(msgBuf,'(A)')
     &       'GCHEM_SEPARATE_FORCING needed to use BLING'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF
      IF ( useDARWIN ) THEN
        WRITE(msgBuf,'(A)')
     &       'GCHEM_SEPARATE_FORCING needed to use DARWIN'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF
#endif /* ndef GCHEM_SEPARATE_FORCING */

C     GCHEM needs passive tracer package
      IF ( .NOT.usePTRACERS) THEN
        WRITE(msgBuf,'(A)') 'usePTRACERS has to be .TRUE. for GCHEM'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF

C     GCHEM cannot run BLING and DIC together
      IF ( useBLING .AND. useDIC ) THEN
        WRITE(msgBuf,'(A)')
     &       'useBLING and useDIC cannot both be .TRUE.'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF

C     GCHEM cannot run BLING and DARWIN together
      IF ( useBLING .AND. useDARWIN ) THEN
        WRITE(msgBuf,'(A)')
     &       'useBLING and useDARWIN cannot both be .TRUE.'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF

C     GCHEM cannot run DARWIN and DIC together
      IF ( useDARWIN .AND. useDIC ) THEN
        WRITE(msgBuf,'(A)')
     &       'useDARWIN and useDIC cannot both be .TRUE.'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF

      nb_tendTr = gchem_Tracer_num - gchem_sepFTr_num
      IF ( nb_tendTr.GT.GCHEM_tendTr_num ) THEN
        WRITE(msgBuf,'(2A,I5,A)') 'GCHEM_CHECK: ',
     &    'Number of tendency-tracers: nb_tendTr=', nb_tendTr
        CALL PRINT_ERROR( msgBuf , myThid )
        WRITE(msgBuf,'(2A,I5,A)') 'GCHEM_CHECK: ',
     &    'Exceeds GCHEM_tendTr_num=', GCHEM_tendTr_num,
     &    ' (from GCHEM_SIZE.h)'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF
      IF ( gchem_Tracer_num.GT.PTRACERS_numInUse ) THEN
        WRITE(msgBuf,'(2A,I5,A)') 'GCHEM_CHECK: ',
     &  'Number of GCHEM tracers: gchem_Tracer_num =', gchem_Tracer_num
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(2A,I5,A)') 'GCHEM_CHECK: ',
     &  ' exceeds number of pTr: PTRACERS_numInUse =',PTRACERS_numInUse
c    &  ' exceeds number of PTRACERS(_numInUse)=', PTRACERS_numInUse
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF

      IF ( errCount.GE.1 ) THEN
        WRITE(msgBuf,'(A,I3,A)')
     &       'GCHEM_CHECK: detected', errCount,' fatal error(s)'
        CALL PRINT_ERROR( msgBuf, myThid )
        CALL ALL_PROC_DIE( 0 )
        STOP 'ABNORMAL END: S/R GCHEM_CHECK'
      ENDIF

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C     some consistency checks with a soft warning
      ioUnit = errorMessageUnit
#ifdef ALLOW_CAL
      IF ( useCAL ) THEN
       errCount = 0
       IF ( usingGregorianCalendar .AND.
     &      gchem_secondsPeryear .NE. 365.25 _d 0*86400. _d 0 ) THEN
        errCount = errCount + 1
       ELSEIF ( .NOT. usingGregorianCalendar .AND.
     &       gchem_secondsPerYear .NE. nDaysNoLeap*86400. _d 0 ) THEN
        errCount = errCount + 1
       ENDIF
       IF ( errCount .GT. 0 ) THEN
        IL = ILNBLNK(theCalendar)
        WRITE(msgBuf,'(A,F13.1,3A)')
     &       '** warning ** GCHEM_CHECK: gchem_secondsPeryear=',
     &       gchem_secondsPerYear,
     &       ' is not consistent with theCalendar= "',
     &       theCalendar(1:IL),'"'
        CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
        WRITE(msgBuf,'(A)')
     &       '** warning ** GCHEM_CHECK:   Is this intentional ?'
        CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
       ENDIF
      ENDIF
#endif
      IF ( periodicExternalForcing ) THEN
       errCount = 0
       IF ( gchem_ForcingCycle .EQ. externForcingCycle .AND.
     &      gchem_secondsPeryear .NE. externForcingCycle ) THEN
        WRITE(msgBuf,'(2(A,F13.1))')
     &       '** warning ** GCHEM_CHECK: gchem_secondsPeryear=',
     &       gchem_secondsPerYear,
     &       ' is different from externForcingCycle=',
     &       externForcingCycle
        errCount = errCount + 1
       ELSEIF ( gchem_secondsPeryear .NE. gchem_ForcingCycle ) THEN
        WRITE(msgBuf,'(2(A,F13.1))')
     &       '** warning ** GCHEM_CHECK: gchem_secondsPeryear=',
     &       gchem_secondsPerYear,
     &       ' is different from gchem_ForcingCycle=',
     &       gchem_ForcingCycle
        errCount = errCount + 1
       ENDIF
       IF ( errCount .GT. 0 ) THEN
        CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
        WRITE(msgBuf,'(A)')
     &       '** warning ** GCHEM_CHECK:   Is this intentional ?'
        CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
       ENDIF
      ENDIF

      _END_MASTER(myThid)

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C--   Check other GCHEM pkgs:

#ifdef ALLOW_CFC
C-    run checks specific to CFC
      IF ( useCFC ) THEN
        CALL CFC_CHECK( myThid )
      ENDIF
#endif

#ifdef ALLOW_DARWIN
C-    run checks specific to darwin
      IF ( useDARWIN ) THEN
        CALL DARWIN_CHECK( myThid )
      ENDIF
#endif

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      _BEGIN_MASTER(myThid)
      ioUnit = standardMessageUnit

      WRITE(msgBuf,'(A)')
     &'// ======================================================='
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)') '// pkg/gchem configuration'
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)')
     &'// ======================================================='
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )

      WRITE(msgBuf,'(A)') '//  '
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )

      CALL WRITE_0D_L( useCFC, INDEX_NONE,
     &     'useCFC =', ' /* use pkg/cfc */')
      CALL WRITE_0D_L( useDIC, INDEX_NONE,
     &     'useDIC =', '  /* use pkg/dic */')
      CALL WRITE_0D_L( useBLING, INDEX_NONE,
     &     'useBLING =', ' /* use pkg/bling */')
      CALL WRITE_0D_L( useSPOIL, INDEX_NONE,
     &     'useSPOIL =', ' /* use pkg/spoil */')
      CALL WRITE_0D_L( useDARWIN, INDEX_NONE,
     &     'useDARWIN =', ' /* use pkg/darwin */')
      CALL WRITE_0D_I( nsubtime, INDEX_NONE, 'nsubtime =',
     &     ' /* number of sub-timesteps withing bgc-module */')
#ifdef GCHEM_REPORT_UNUSED_PARAMS
      gchem_int = (/gchem_int1,gchem_int2,
     &     gchem_int3,gchem_int4,gchem_int5/)
      gchem_rl = (/gchem_rl1,gchem_rl2,
     &     gchem_rl3,gchem_rl4,gchem_rl5/)
      gchem_fileName = (/fileName1,fileName2,
     &     fileName3,fileName4,fileName5/)
      DO k = 1, 5
       varName = ' '
       IF ( gchem_fileName(k) .NE. ' ' ) THEN
        WRITE(varName,'(A,I1)') 'fileName',k
        CALL WRITE_0D_C( gchem_fileName(k), -1, INDEX_NONE,
     &      varName(1:9)//' =', ' /* generic file name parameter */')
       ENDIF
       IF ( gchem_int(k) .NE. 0 ) THEN
        WRITE(varName,'(A,I1)') 'gchem_int',k
        CALL WRITE_0D_I( gchem_int(k), INDEX_NONE,
     &      varName(1:10)//' =', ' /* generic INTEGER parameter */')
       ENDIF
       IF ( gchem_rl(k) .NE. 0. _d 0 ) THEN
        WRITE(varName,'(A,I1)') 'gchem_rl',k
        CALL WRITE_0D_RL( gchem_rl(k), INDEX_NONE,
     &      varName(1:9)//' =', ' /* generic REAL*8 parameter */')
       ENDIF
      ENDDO
#endif
      CALL WRITE_0D_RL( gchem_ForcingPeriod, INDEX_NONE,
     & 'gchem_ForcingPeriod =', ' /* gchem forcing period (s) */')
      CALL WRITE_0D_RL( gchem_ForcingCycle, INDEX_NONE,
     & 'gchem_ForcingCycle =',
     & ' /* period of gchem forcing cycle (s) */')
      CALL WRITE_0D_RL( gchem_secondsPerYear, INDEX_NONE,
     & 'gchem_secondsPerYear =',
     & ' /* second in a year for light computations */')

      WRITE(msgBuf,'(A)')
     &'// ======================================================='
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)') '// End of pkg/gchem config. summary'
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)')
     &'// ======================================================='
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)') ' '
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )

      WRITE(msgBuf,'(2A)') 'GCHEM_CHECK ', ' <-- Ends Normally'
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(2A)') ' '
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )

      _END_MASTER(myThid)

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#endif /* ALLOW_GCHEM */

      RETURN
      END

#include "DWNSLP_OPTIONS.h"

CBOP
C     !ROUTINE: DWNSLP_INIT_VARIA
C     !INTERFACE:
      SUBROUTINE DWNSLP_INIT_VARIA( myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE DWNSLP_INIT_VARIA
C     | o Initialize Down_Slope variables
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
c#include "PARAMS.h"
#include "DWNSLP_SIZE.h"
#include "DWNSLP_PARAMS.h"
#include "DWNSLP_VARS.h"


C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
C     myThid    :: my Thread Id number
      INTEGER myThid
CEOP

C     !LOCAL VARIABLES:
C     === Local variables ===
C     msgBuf     :: Informational/error message buffer
c     CHARACTER*(MAX_LEN_MBUF) msgBuf
      INTEGER n, bi, bj

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|


      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)

C     Initialize arrays in common blocks :
        DO n=1,DWNSLP_size
          DWNSLP_deepK (n,bi,bj) = 0
          DWNSLP_Transp(n,bi,bj) = 0. _d 0
        ENDDO

       ENDDO
      ENDDO

      RETURN
      END

#include "ICEFRONT_OPTIONS.h"

CBOP
C !ROUTINE: ICEFRONT_READPARMS

C !INTERFACE: ==========================================================
      SUBROUTINE ICEFRONT_READPARMS( myThid )

C !DESCRIPTION:
C     Initialize ICEFRONT parameters, read in data.icefront

C !USES: ===============================================================
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "ICEFRONT.h"
#include "PARAMS.h"
#ifdef ALLOW_SHELFICE
# include "SHELFICE.h"
#endif

C !INPUT PARAMETERS: ===================================================
C  myThid               :: my thread Id number
      INTEGER myThid

C !OUTPUT PARAMETERS: ==================================================
C  none

#ifdef ALLOW_ICEFRONT

C !LOCAL VARIABLES: ====================================================
C  iUnit                :: unit number for I/O
C  msgBuf               :: message buffer
      INTEGER iUnit
      CHARACTER*(MAX_LEN_MBUF) msgBuf
CEOP

      NAMELIST /ICEFRONT_PARM01/
     &     rhoIcefront, ICEFRONTkappa,
     &     ICEFRONTlatentHeat, ICEFRONTHeatCapacity_Cp,
     &     ICEFRONTthetaSurface,
     &     applyIcefrontTendT,applyIcefrontTendS,
     &     ICEFRONTdepthFile, ICEFRONTlengthFile

#ifdef ALLOW_EXF
      NAMELIST /ICEFRONT_EXF_PARM02/
     &     SGRunOffFile,   SGRunOffperiod,   SGRunOffStartTime,
     &     SGRunOffstartdate1, SGRunOffstartdate2,
     &     SGRunOffconst,      SGRunOff_inscal,
     &     SGRunOff_remov_intercept, SGRunOff_remov_slope
#endif /* ALLOW_EXF */

      IF ( .NOT.useICEFRONT ) THEN
C-    pkg ICEFRONT is not used
        _BEGIN_MASTER(myThid)
C-    Track pkg activation status:
         ICEFRONTisON = .FALSE.
C     print a (weak) warning if data.icefront is found
         CALL PACKAGES_UNUSED_MSG( 'useICEFRONT', ' ', ' ' )
        _END_MASTER(myThid)
        RETURN
      ENDIF

      _BEGIN_MASTER(myThid)

C This routine has been called by the main model so we set our
C internal flag to indicate we are in business
      ICEFRONTisON = .TRUE.

C Set defaults values for parameters in ICEFRONT.h
#ifdef ALLOW_SHELFICE
      IF (useShelfice) THEN
C Use the same values as in SHELFICE
       ICEFRONTlatentHeat       = SHELFICElatentHeat
       ICEFRONTHeatCapacity_Cp  = SHELFICEHeatCapacity_Cp
       rhoIcefront              = rhoShelfice
       ICEFRONTkappa            = SHELFICEkappa
       ICEFRONTthetaSurface     = SHELFICEthetaSurface
      ELSE
#else /* ifndef ALLOW_SHELFICE */
      IF (.TRUE.) THEN
#endif /* ALLOW_SHELFICE */
C Default values when SHELFICE is not used
       ICEFRONTlatentHeat       =  334.0 _d 3
       ICEFRONTHeatCapacity_Cp  = 2000.0 _d 0
       rhoIcefront              =  917.0 _d 0
       ICEFRONTkappa            =   1.54 _d -06
       ICEFRONTthetaSurface     = - 20.0 _d 0
      ENDIF

      recip_ICEFRONTlatentHeat =    0.0 _d 0
      ICEFRONTlengthFile       = ' '
      ICEFRONTdepthFile        = ' '
      applyIcefrontTendS       = .TRUE.
      applyIcefrontTendT       = .TRUE.

#ifdef ALLOW_EXF
      SGRunOffstartdate1       = 0
      SGRunOffstartdate2       = 0
      SGRunOffStartTime        = UNSET_RL
      SGRunOffperiod           = 0.0 _d 0
      SGRunOffconst            = 0.0 _d 0
      SGRunOff_remov_intercept = 0.0 _d 0
      SGRunOff_remov_slope     = 0.0 _d 0
      SGRunOff_inscal          = 1.0 _d 0
      SGRunOffFile             = ' '
C-    internal parameters (not in namelist):
      SGRunOffmask             = 'c'
#endif /* ALLOW_EXF */

C Open and read the data.icefront file
      WRITE(msgBuf,'(A)') ' ICEFRONT_READPARMS: opening data.icefront'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      CALL OPEN_COPY_DATA_FILE(
     I                   'data.icefront', 'ICEFRONT_READPARMS',
     O                   iUnit,
     I                   myThid )

      WRITE(msgBuf,'(A)') ' ICEFRONT_READPARMS: reading ICEFRONT_PARM01'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      READ(UNIT=iUnit,NML=ICEFRONT_PARM01)

#ifdef ALLOW_EXF
      IF ( useEXF ) THEN
       WRITE(msgBuf,'(A)')
     &     ' ICEFRONT_READPARMS: reading ICEFRONT_EXF_PARM02'
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                     SQUEEZE_RIGHT, myThid )
       READ( UNIT=iUnit, NML=ICEFRONT_EXF_PARM02 )
      ENDIF
#endif /* ALLOW_EXF */

      WRITE(msgBuf,'(A)')
     &  ' ICEFRONT_READPARMS: finished reading data.icefront'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )

C Close the open data file
#ifdef SINGLE_DISK_IO
      CLOSE(iUnit)
#else
      CLOSE(iUnit,STATUS='DELETE')
#endif /* SINGLE_DISK_IO */

C Now set-up any remaining parameters that result from the input parameters
      IF ( ICEFRONTlatentHeat .NE. 0. _d 0 )
     &     recip_ICEFRONTlatentHeat = 1. _d 0/ICEFRONTlatentHeat

      _END_MASTER(myThid)
C Everyone else must wait for the parameters to be loaded
      _BARRIER

#endif /* ALLOW_ICEFRONT */

      RETURN
      END

#include "CTRL_OPTIONS.h"

      subroutine ctrl_set_unpack_xyz(
     &     lxxadxx, cunit, ivar, fname, masktype, weighttype,
     &     weightfld, nwetglobal, myThid )

c     ==================================================================
c     SUBROUTINE ctrl_set_unpack_xyz
c     ==================================================================
c
c     o Unpack the control vector such that land points are filled in.
c
c     o Use a more precise nondimensionalization that depends on (x,y)
c       Added weighttype to the argument list so that I can geographically
c       vary the nondimensionalization.
c       gebbie@mit.edu, 18-Mar-2003
c
c     ==================================================================

      implicit none

c     == global variables ==

#include "EEPARAMS.h"
#include "SIZE.h"
#include "PARAMS.h"
#include "GRID.h"

#include "CTRL_SIZE.h"
#include "CTRL.h"
#include "OPTIMCYCLE.h"

c     == routine arguments ==

      logical lxxadxx
      integer cunit
      integer ivar
      character*(MAX_LEN_FNAM)   fname
      character*(  9) masktype
      character*(MAX_LEN_FNAM) weighttype
      _RL     weightfld( Nr,nSx,nSy )
      integer nwetglobal(Nr)
      integer myThid

#ifndef EXCLUDE_CTRL_PACK
c     == external ==
      integer  ilnblnk
      external ilnblnk

c     == local variables ==
      integer bi,bj
      integer i,j,k
      integer ii, irec
      integer cbuffindex
      real*4 cbuff( sNx*nSx*nPx*sNy*nSy*nPy )
      character*(MAX_LEN_FNAM) cfile2, cfile3
C     These variables are read-in from file, but not used much
      integer loc_ncbuffindex
      integer loc_i
      integer loc_j
      integer loc_k
      integer loc_ncvarindex
C========================================================================
# ifndef ALLOW_PACKUNPACK_METHOD2
      integer ip,jp
      integer itlo,ithi
      integer jtlo,jthi
      integer jmin,jmax
      integer imin,imax
      _RL     globmsk  ( sNx,nSx,nPx,sNy,nSy,nPy,Nr )
      _RL     globfld3d( sNx,nSx,nPx,sNy,nSy,nPy,Nr )
#ifdef CTRL_UNPACK_PRECISE
      integer il
      character*(MAX_LEN_FNAM) weightname
      _RL   weightfld3d( sNx,nSx,nPx,sNy,nSy,nPy,Nr )
#endif
      real*4 globfldtmp2( sNx,nSx,nPx,sNy,nSy,nPy )
      real*4 globfldtmp3( sNx,nSx,nPx,sNy,nSy,nPy )
      _RL delZnorm
      integer reclen, irectrue
      integer cunit2, cunit3
# else /* ALLOW_PACKUNPACK_METHOD2 */
      integer il
      _RL msk3d(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      real*8 msk2d_buf(sNx,sNy,nSx,nSy)
      real*8 msk2d_buf_glo(Nx,Ny)
      real*8 fld2d_buf(sNx,sNy,nSx,nSy)
      real*8 fld2d_buf_glo(Nx,Ny)
      _RL fld3dDim(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      _RL fld3dNodim(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
#ifdef CTRL_UNPACK_PRECISE
      _RL wei3d(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
#endif
      _RL delZnorm
      _RL dummy
# endif /* ALLOW_PACKUNPACK_METHOD2 */
c     == end of interface ==

# ifndef ALLOW_PACKUNPACK_METHOD2

      jtlo = 1
      jthi = nSy
      itlo = 1
      ithi = nSx
      jmin = 1
      jmax = sNy
      imin = 1
      imax = sNx

#ifdef CTRL_DELZNORM
      delZnorm = 0.
      do k = 1, Nr
         delZnorm = delZnorm + delR(k)/FLOAT(Nr)
      enddo
#endif

c     Initialise temporary file
      do k = 1,Nr
       do jp = 1,nPy
        do bj = jtlo,jthi
         do j = jmin,jmax
          do ip = 1,nPx
           do bi = itlo,ithi
            do i = imin,imax
             globfld3d  (i,bi,ip,j,bj,jp,k) = 0. _d 0
             globmsk    (i,bi,ip,j,bj,jp,k) = 0. _d 0
             globfldtmp2(i,bi,ip,j,bj,jp)   = 0. _d 0
             globfldtmp3(i,bi,ip,j,bj,jp)   = 0. _d 0
            enddo
           enddo
          enddo
         enddo
        enddo
       enddo
      enddo

c--   Only the master thread will do I/O.
      _BEGIN_MASTER( myThid )

#ifdef CTRL_DELZNORM
      do k = 1, Nr
       print *, 'ph-delznorm ', k, delZnorm, delR(k)
       print *, 'ph-weight   ', weightfld(k,1,1)
      enddo
#endif

      if ( doPackDiag ) then
       if ( lxxadxx ) then
        write(cfile2,'(a,I3.3,a,I4.4,a)')
     &           'diag_unpack_nondim_ctrl_',
     &           ivar, '_', optimcycle, '.bin'
        write(cfile3,'(a,I3.3,a,I4.4,a)')
     &           'diag_unpack_dimens_ctrl_',
     &           ivar, '_', optimcycle, '.bin'
       else
        write(cfile2,'(a,I3.3,a,I4.4,a)')
     &           'diag_unpack_nondim_grad_',
     &           ivar, '_', optimcycle, '.bin'
        write(cfile3,'(a,I3.3,a,I4.4,a)')
     &           'diag_unpack_dimens_grad_',
     &           ivar, '_', optimcycle, '.bin'
       endif

       reclen = FLOAT(sNx*nSx*nPx*sNy*nSy*nPy*4)
       call mdsfindunit( cunit2, myThid )
       open( cunit2, file=cfile2, status='unknown',
     &       access='direct', recl=reclen )
       call mdsfindunit( cunit3, myThid )
       open( cunit3, file=cfile3, status='unknown',
     &       access='direct', recl=reclen )
      endif

#ifdef CTRL_UNPACK_PRECISE
      if (weighttype.NE.' ') then
       il=ilnblnk( weighttype)
       write(weightname,'(a)') weighttype(1:il)
       call MDSREADFIELD_3D_GL(
     &     weightname, ctrlprec, 'RL',
     &     Nr, weightfld3d, 1, myThid)
      else
       do k = 1,Nr
        do jp = 1,nPy
         do bj = jtlo,jthi
          do j = jmin,jmax
           do ip = 1,nPx
            do bi = itlo,ithi
             do i = imin,imax
              weightfld3d(i,bi,ip,j,bj,jp,k) = 1. _d 0
             enddo
            enddo
           enddo
          enddo
         enddo
        enddo
       enddo
      endif
#endif

      call MDSREADFIELD_3D_GL(
     &     masktype, ctrlprec, 'RL',
     &     Nr, globmsk, 1, myThid)

      do irec = 1, ncvarrecs(ivar)
#ifndef ALLOW_ADMTLM
       read(cunit) loc_ncvarindex
       if (loc_ncvarindex .NE. ncvarindex(ivar)) then
        IF ( irec.EQ.1 )
     &  print *, 'ctrl_set_unpack_xyz:WARNING: wrong ncvarindex ',
     &           loc_ncvarindex, ncvarindex(ivar)
# ifndef READ_OLD_CTRL_PACK_FILE
        STOP 'in S/R ctrl_set_unpack_xyz'
# endif
       endif
       read(cunit) loc_j
       read(cunit) loc_i
#endif /* ALLOW_ADMTLM */
       do k = 1, Nr
        irectrue = (irec-1)*Nr + k
        if ( doZscaleUnpack ) then
         delZnorm = (delR(1)/delR(k))**delZexp
        else
         delZnorm = 1. _d 0
        endif
        cbuffindex = nwetglobal(k)
        if ( cbuffindex .gt. 0 ) then
#ifndef ALLOW_ADMTLM
         read(cunit) loc_ncbuffindex
         if (loc_ncbuffindex .NE. cbuffindex) then
          print *, 'WARNING: wrong cbuffindex ',
     &             loc_ncbuffindex, cbuffindex
          STOP 'in S/R ctrl_set_unpack_xyz'
         endif
         read(cunit) loc_k
         if (loc_k .NE. k) then
          print *, 'WARNING: wrong k ',
     &             loc_k, k
          STOP 'in S/R ctrl_set_unpack_xyz'
         endif
cph#endif /* ALLOW_ADMTLM */
         read(cunit) (cbuff(ii), ii=1,cbuffindex)
#endif /* ALLOW_ADMTLM */
        endif
c
        cbuffindex = 0
        do jp = 1,nPy
         do bj = jtlo,jthi
          do j = jmin,jmax
           do ip = 1,nPx
            do bi = itlo,ithi
             do i = imin,imax
              if ( globmsk(i,bi,ip,j,bj,jp,k) .ne. 0. ) then
               cbuffindex = cbuffindex + 1
               globfld3d(i,bi,ip,j,bj,jp,k) = cbuff(cbuffindex)
cph(
               globfldtmp2(i,bi,ip,j,bj,jp) = cbuff(cbuffindex)
cph)
#ifdef ALLOW_ADMTLM
               nveccount = nveccount + 1
               globfld3d(i,bi,ip,j,bj,jp,k) = phtmpadmtlm(nveccount)
cph(
               globfldtmp2(i,bi,ip,j,bj,jp) = phtmpadmtlm(nveccount)
cph)
#endif
              else
               globfld3d(i,bi,ip,j,bj,jp,k) = 0. _d 0
              endif
cph(
              globfldtmp3(i,bi,ip,j,bj,jp) =
     &             globfld3d(i,bi,ip,j,bj,jp,k)
cph)
             enddo
            enddo
           enddo
          enddo
         enddo
        enddo
c
        if ( doPackDiag ) then
         write(cunit2,rec=irectrue) globfldtmp2
         write(cunit3,rec=irectrue) globfldtmp3
        endif
c
       enddo

       call MDSWRITEFIELD_3D_GL( fname, ctrlprec, 'RL',
     &                           Nr, globfld3d,
     &                           irec,  optimcycle, myThid)

      enddo

      if ( doPackDiag ) then
       close ( cunit2 )
       close ( cunit3 )
      endif

      _END_MASTER( myThid )

# else /* ALLOW_PACKUNPACK_METHOD2 */

c-- part 1: preliminary reads and definitions

#ifdef CTRL_UNPACK_PRECISE
#ifdef ALLOW_AUTODIFF
      call active_read_xyz(weighttype, wei3d, 1,
     &    .FALSE., .FALSE., 0 , myThid, dummy)
#else
      CALL READ_REC_XYZ_RL( weighttype, wei3d, 1, 1, myThid )
#endif
#endif

#ifdef ALLOW_AUTODIFF
      call active_read_xyz(masktype, msk3d, 1,
     &    .FALSE., .FALSE., 0 , myThid, dummy)
#else
      CALL READ_REC_XYZ_RL( masktype, msk3d, 1, 1, myThid )
#endif

      if ( doPackDiag ) then
       il = ilnblnk( fname )
       if ( lxxadxx ) then
        write(cfile2,'(2a)') fname(1:il),'.unpack_ctrl_adim'
        write(cfile3,'(2a)') fname(1:il),'.unpack_ctrl_dim'
       else
        write(cfile2,'(2a)') fname(1:il),'.unpack_grad_adim'
        write(cfile3,'(2a)') fname(1:il),'.unpack_grad_dim'
       endif
      endif

c-- part 2: loop over records

      do irec = 1, ncvarrecs(ivar)

c-- 2.1: array <- buffer <- global buffer <- global file

#ifndef ALLOW_ADMTLM
       _BEGIN_MASTER( myThid )
       IF ( myProcId .eq. 0 ) THEN
        read(cunit) loc_ncvarindex
        if (loc_ncvarindex .NE. ncvarindex(ivar)) then
         IF ( irec.EQ.1 )
     &   print *, 'ctrl_set_unpack_xyz:WARNING: wrong ncvarindex ',
     &            loc_ncvarindex, ncvarindex(ivar)
# ifndef READ_OLD_CTRL_PACK_FILE
         STOP 'in S/R ctrl_set_unpack_xyz'
# endif
        endif
        read(cunit) loc_j
        read(cunit) loc_i
       ENDIF
       _END_MASTER( myThid )
       _BARRIER
#endif /* ALLOW_ADMTLM */

       do k = 1, Nr

        CALL MDS_PASS_R8toRL( msk2d_buf, msk3d,
     &                        0, 0, 1, k, Nr, 0, 0, .FALSE., myThid )
        CALL BAR2( myThid )
        CALL GATHER_2D_R8( msk2d_buf_glo, msk2d_buf,
     &                     Nx,Ny,.FALSE.,.TRUE.,myThid)
        CALL BAR2( myThid )

        _BEGIN_MASTER( myThid )
        cbuffindex = nwetglobal(k)
        IF ( myProcId .eq. 0 ) THEN

#ifndef ALLOW_ADMTLM
         if ( cbuffindex .gt. 0) then
          read(cunit) loc_ncbuffindex
          read(cunit) loc_k
          if (loc_ncbuffindex .NE. cbuffindex) then
           print *, 'WARNING: wrong cbuffindex ',
     &              loc_ncbuffindex, cbuffindex
           STOP 'in S/R ctrl_set_unpack_xyz'
          endif
          if (loc_k .NE. k) then
           print *, 'WARNING: wrong k ', loc_k, k
           STOP 'in S/R ctrl_set_unpack_xyz'
          endif
          read(cunit) (cbuff(ii), ii=1,cbuffindex)
         endif
#endif

         cbuffindex = 0
         DO j=1,Ny
          DO i=1,Nx
           if (msk2d_buf_glo(i,j) .ne. 0. ) then
            cbuffindex = cbuffindex + 1
            fld2d_buf_glo(i,j) = cbuff(cbuffindex)
           endif
          ENDDO
         ENDDO

        ENDIF
        _END_MASTER( myThid )
        _BARRIER

        CALL BAR2( myThid )
        CALL SCATTER_2D_R8( fld2d_buf_glo, fld2d_buf,
     &                      Nx,Ny,.FALSE.,.TRUE.,myThid)
        CALL BAR2( myThid )
        CALL MDS_PASS_R8toRL( fld2d_buf, fld3dNodim,
     &                        0, 0, 1, k, Nr, 0, 0, .TRUE., myThid )

       enddo !do k = 1, Nr

c-- 2.2: normalize field if needed
       DO bj = myByLo(myThid), myByHi(myThid)
        DO bi = myBxLo(myThid), myBxHi(myThid)
         DO k=1,Nr
          if ( doZscalePack ) then
           delZnorm = (delR(1)/delR(k))**delZexp
          else
           delZnorm = 1. _d 0
          endif
          DO j=1,sNy
           DO i=1,sNx
            if (msk3d(i,j,k,bi,bj).EQ.0. _d 0) then
             fld3dDim(i,j,k,bi,bj)=0. _d 0
             fld3dNodim(i,j,k,bi,bj)=0. _d 0
            else
#ifdef ALLOW_ADMTLM
             nveccount = nveccount + 1
             fld3dNodim(i,j,k,bi,bj)=phtmpadmtlm(nveccount)
#endif
             fld3dDim(i,j,k,bi,bj)=fld3dNodim(i,j,k,bi,bj)
            endif
           ENDDO
          ENDDO
         ENDDO
        ENDDO
       ENDDO

c-- 2.3:
       if ( doPackDiag ) then
c     error: twice the same one
        call WRITE_REC_3D_RL( cfile2, ctrlprec,
     &       Nr, fld3dNodim, irec, 0, myThid)
        call WRITE_REC_3D_RL( cfile3, ctrlprec,
     &       Nr, fld3dDim, irec, 0, myThid)
       endif

c-- 2.4:
       call WRITE_REC_3D_RL( fname, ctrlprec,
     &      Nr, fld3dDim, irec, 0, myThid)

      enddo !do irec = 1, ncvarrecs(ivar)

# endif /* ALLOW_PACKUNPACK_METHOD2 */
# endif /* EXCLUDE_CTRL_PACK */

      return
      end

#include "EXF_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

CBOP
C     !ROUTINE: EXF_INTERP
C     !INTERFACE:
       SUBROUTINE EXF_INTERP(
     I                inFile, filePrec,
#ifdef EXF_INTERP_USE_DYNALLOC
     O                arrayout,
#else
     O                arrayout, arrayin,
#endif
     I                irecord, xG_in, yG,
     I                lon_0, lon_inc, lat_0, lat_inc,
     I                nxIn, nyIn, method, myIter, myThid )

C !DESCRIPTION: \bv
C  *==========================================================*
C  | SUBROUTINE EXF_INTERP
C  | o Load from file a regular lat-lon input field
C  |   and interpolate on to the model grid location
C  *==========================================================*
C \ev

C !USES:
      IMPLICIT NONE
C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "EXF_INTERP_SIZE.h"
#ifdef ALLOW_DEBUG
# include "EXF_PARAM.h"
#endif

C !INPUT/OUTPUT PARAMETERS:
C  inFile      (string)  :: name of the binary input file (direct access)
C  filePrec    (integer) :: number of bits per word in file (32 or 64)
C  arrayout    ( _RL )   :: output array
#ifndef EXF_INTERP_USE_DYNALLOC
C  arrayin     ( _RL )   :: input field array (loaded from file)
#endif
C  irecord     (integer) :: record number to read
C     xG_in,yG           :: coordinates for output grid to interpolate to
C     lon_0, lat_0       :: lon and lat of sw corner of global input grid
C     lon_inc            :: scalar x-grid increment
C     lat_inc            :: vector y-grid increments
C  nxIn,nyIn   (integer) :: size in x & y direction of input file to read
C     method             :: 1,11,21 for bilinear; 2,12,22 for bicubic
C                        :: 1,2 for tracer; 11,12 for U; 21,22 for V
C  myIter      (integer) :: current iteration number
C  myThid      (integer) :: My Thread Id number
      CHARACTER*(*) inFile
      INTEGER       filePrec, irecord, nxIn, nyIn
      _RL           arrayout(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
#ifndef EXF_INTERP_USE_DYNALLOC
      _RL           arrayin ( -1:nxIn+2, -1:nyIn+2 )
#endif
      _RS           xG_in   (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RS           yG      (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL           lon_0, lon_inc
c     _RL           lat_0, lat_inc(nyIn-1)
      _RL           lat_0, lat_inc(*)
      INTEGER       method, myIter, myThid

C !FUNCTIONS:
#ifdef ALLOW_DEBUG
      INTEGER  ILNBLNK
      EXTERNAL ILNBLNK
#endif

C !LOCAL VARIABLES:
C     x_in        :: longitude vector defining input field grid
C     y_in        :: latitude  vector defining input field grid
C     w_ind       :: input field longitudinal index, on western side of model grid pt
C     s_ind       :: input field latitudinal index, on southern side of model grid pt
C     bi, bj      :: tile indices
C     i, j, k, l  :: loop indices
C     msgBuf      :: Informational/error message buffer
#ifdef EXF_INTERP_USE_DYNALLOC
C     arrayin     :: input field array (loaded from file)
      _RL      arrayin( -1:nxIn+2, -1:nyIn+2 )
      _RL      x_in(-1:nxIn+2), y_in(-1:nyIn+2)
#else /* EXF_INTERP_USE_DYNALLOC */
      _RL      x_in(-1:exf_max_nLon+2), y_in(-1:exf_max_nLat+2)
#endif /* EXF_INTERP_USE_DYNALLOC */
      INTEGER  w_ind(sNx,sNy), s_ind(sNx,sNy)
      INTEGER  bi, bj
      INTEGER  i, j, k, l
      INTEGER  nLoop
      _RL      tmpVar
      _RS      xG(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RS      threeSixtyRS
      _RL      yPole, symSign, poleValue
      _RL      edgeFac, poleFac
      PARAMETER ( threeSixtyRS = 360. )
      PARAMETER ( yPole = 90. )
      INTEGER  nxd2
      LOGICAL  xIsPeriodic, poleSymmetry
#ifdef ALLOW_DEBUG
      LOGICAL  debugFlag
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      _RS      prtPole(-1:4)
#endif
CEOP

#ifndef EXF_INTERP_USE_DYNALLOC
C--   Check size declaration:
      IF ( nxIn.GT.exf_max_nLon ) THEN
       STOP 'EXF_INTERP: exf_max_nLon too small'
      ENDIF
      IF ( nyIn.GT.exf_max_nLat ) THEN
       STOP 'EXF_INTERP: exf_max_nLat too small'
      ENDIF
      IF ( (nxIn+4)*(nyIn+4).GT.exf_interp_bufferSize ) THEN
       STOP 'EXF_INTERP: exf_interp_bufferSize too small'
      ENDIF
#endif /* ndef EXF_INTERP_USE_DYNALLOC */

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C---  Load inut field

      CALL EXF_INTERP_READ(
     I         inFile, filePrec,
     O         arrayin,
     I         irecord, nxIn, nyIn, myThid )

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C---  Prepare input grid and input field

C--   setup input longitude grid
      DO i=-1,nxIn+2
       x_in(i) = lon_0 + (i-1)*lon_inc
      ENDDO
      xIsPeriodic = nxIn.EQ.NINT( threeSixtyRS / lon_inc )
      nxd2 = NINT( nxIn*0.5 )
      poleSymmetry = xIsPeriodic .AND. ( nxIn.EQ.2*nxd2 )
#ifdef EXF_USE_OLD_INTERP_POLE
      poleSymmetry = .FALSE.
#endif

C--   setup input latitude grid
      y_in(1) = lat_0
      DO j=1,nyIn+1
       i = MIN(j,nyIn-1)
       y_in(j+1) = y_in(j) + lat_inc(i)
      ENDDO
      y_in(0) = y_in(1) - lat_inc(1)
      y_in(-1)= y_in(0) - lat_inc(1)
#ifdef ALLOW_DEBUG
      DO l=-1,4
        prtPole(l) = 0.
      ENDDO
#endif
C--   For tracer (method=1,2) add 1 row @ the pole (if last row is not)
C     and will fill it with the polarmost-row zonally averaged value.
C     For vector component, cannot do much without the other component;
C     averaging properly done if uvInterp=T in S/R EXF_INTERP_UV
#ifdef EXF_USE_OLD_INTERP_POLE
      IF ( .TRUE. ) THEN
#else
      IF ( method.LT.10 ) THEN
C-    Add 2 row @ southern end; if one is beyond S.pole, put one @ S.pole
       j = 0
       IF ( ABS(y_in(j+1)).LT.yPole .AND. ABS(y_in(j)).GT.yPole ) THEN
         y_in(j) = -yPole
         y_in(j-1) = -2.*yPole - y_in(j+1)
#ifdef ALLOW_DEBUG
         prtPole(j)   = 1.
         prtPole(j-1) = 2.
#endif
       ENDIF
       j = -1
       IF ( ABS(y_in(j+1)).LT.yPole .AND. ABS(y_in(j)).GT.yPole ) THEN
         y_in(j) = -yPole
#ifdef ALLOW_DEBUG
         prtPole(j)   = 1.
#endif
       ENDIF
#endif /* EXF_USE_OLD_INTERP_POLE */
C-    Add 2 row @ northern end; if one is beyond N.pole, put one @ N.pole
       j = nyIn+1
       IF ( ABS(y_in(j-1)).LT.yPole .AND. ABS(y_in(j)).GT.yPole ) THEN
         y_in(j) = yPole
         y_in(j+1) = 2.*yPole - y_in(j-1)
#ifdef ALLOW_DEBUG
         prtPole(3)   = 1.
         prtPole(3+1) = 2.
#endif
       ENDIF
       j = nyIn+2
       IF ( ABS(y_in(j-1)).LT.yPole .AND. ABS(y_in(j)).GT.yPole ) THEN
         y_in(j) = yPole
#ifdef ALLOW_DEBUG
         prtPole(4)   = 1.
#endif
       ENDIF
      ENDIF

C--   Enlarge boundary
      IF ( xIsPeriodic ) THEN
C-    fill-in added column assuming periodicity
        DO j=1,nyIn
         arrayin( 0,j)     = arrayin(nxIn  ,j)
         arrayin(-1,j)     = arrayin(nxIn-1,j)
         arrayin(nxIn+1,j) = arrayin(1,j)
         arrayin(nxIn+2,j) = arrayin(2,j)
        ENDDO
      ELSE
C-    fill-in added column from nearest column
        DO j=1,nyIn
         arrayin( 0,j)     = arrayin(1,j)
         arrayin(-1,j)     = arrayin(1,j)
         arrayin(nxIn+1,j) = arrayin(nxIn,j)
         arrayin(nxIn+2,j) = arrayin(nxIn,j)
        ENDDO
      ENDIF
      symSign = 1. _d 0
      IF ( method.GE.10 ) symSign = -1. _d 0
      DO l=-1,2
       j = l
       IF ( l.GE.1 ) j = nyIn+l
       k = MAX(1,MIN(j,nyIn))
       IF ( poleSymmetry .AND. ABS(y_in(j)).GT.yPole ) THEN
        IF ( nyIn.GE.3 .AND. ABS(y_in(k)).EQ.yPole )
     &    k = MAX(2,MIN(j,nyIn-1))
C-    fill-in added row assuming pole-symmetry
        DO i=-1,nxd2
         arrayin(i,j) = symSign*arrayin(i+nxd2,k)
        ENDDO
        DO i=1,nxd2+2
         arrayin(i+nxd2,j) = symSign*arrayin(i,k)
        ENDDO
#ifdef ALLOW_DEBUG
        i = l + 2*( (l+1)/2 )
        prtPole(i) = prtPole(i) + 0.2
#endif
       ELSE
C-    fill-in added row from nearest column values
        DO i=-1,nxIn+2
         arrayin(i,j) = arrayin(i,k)
        ENDDO
       ENDIF
      ENDDO

C--   For tracer (method=1,2) set to northernmost zonal-mean value
C     at 90N to avoid sharp zonal gradients near the Pole.
C     For vector component, cannot do much without the other component;
C     averaging properly done if uvInterp=T in S/R EXF_INTERP_UV
#ifdef EXF_USE_OLD_INTERP_POLE
      IF ( .TRUE. ) THEN
       DO l= 3,4
#else
      IF ( method.LT.10 ) THEN
       DO l=-1,4
#endif
        j = l
        IF ( l.GE.2 ) j = nyIn+l-2
        IF ( ABS(y_in(j)).EQ.yPole ) THEN
         IF (method.EQ.1 .OR. method.EQ.2) THEN
          poleValue = 0.
          DO i=1,nxIn
           poleValue = poleValue + arrayin(i,j)
          ENDDO
          poleValue = poleValue / nxIn
          DO i=-1,nxIn+2
           arrayin(i,j) = poleValue
          ENDDO
#ifdef ALLOW_DEBUG
          prtPole(l) = prtPole(l) + 0.1
#endif
#ifdef EXF_USE_OLD_INTERP_POLE
         ELSEIF (method.EQ.11 .OR. method.EQ.12) THEN
          DO i=-1,nxIn+2
           arrayin(i,j) = 0.
          ENDDO
#ifdef ALLOW_DEBUG
          prtPole(l) = prtPole(l) + 0.9
#endif
#endif /* EXF_USE_OLD_INTERP_POLE */
         ENDIF
        ENDIF
       ENDDO
      ENDIF
#ifndef EXF_USE_OLD_INTERP_POLE
      IF (method.EQ.1 .OR. method.EQ.2) THEN
C-    change first additional row from simple copy to linear interpolation
C     between nearest column values and pole value
       DO l=0,1
        k = l*(nyIn+3) -1
        IF ( ABS(y_in(k)).EQ.yPole ) THEN
         j = l*(nyIn+1)
         i = l*(nyIn-1) +1
         edgeFac = (y_in(j) - y_in(k)) / (y_in(i) - y_in(k))
         poleFac = (y_in(i) - y_in(j)) / (y_in(i) - y_in(k))
         DO i=-1,nxIn+2
           arrayin(i,j) = arrayin(i,j) * edgeFac
     &                  + arrayin(i,k) * poleFac
         ENDDO
#ifdef ALLOW_DEBUG
         prtPole(3*l) = prtPole(3*l) + 0.3
#endif
        ENDIF
       ENDDO
      ENDIF
#endif /* EXF_USE_OLD_INTERP_POLE */

#ifdef ALLOW_DEBUG
      debugFlag = ( exf_debugLev.GE.debLevC )
     &       .OR. ( exf_debugLev.GE.debLevB .AND. myIter.LE.nIter0 )
C     prtPole(l)=0 : extended, =1 : changed to pole, =2 : changed to symetric
      IF ( debugFlag ) THEN
        l = ILNBLNK(inFile)
        _BEGIN_MASTER(myThid)
        WRITE(msgBuf,'(3A,I6,A,2L5)')
     &   ' EXF_INTERP: file="',inFile(1:l),'", rec=', irecord,
     &   ' , x-Per,P.Sym=', xIsPeriodic, poleSymmetry
        CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
        WRITE(msgBuf,'(2A,3F4.1,A,3F12.6)') ' S.edge (j=-1,0,1) :',
     &   ' proc=', (prtPole(j),j=-1,1), ', yIn=', (y_in(j),j=-1,1)
        CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
        WRITE(msgBuf,'(2A,3F4.1,A,3F12.6)') ' N.edge (j=+0,+1,+2)',
     &   ' proc=', (prtPole(j),j=2,4), ', yIn=',(y_in(j),j=nyIn,nyIn+2)
        CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
        _END_MASTER(myThid)
      ENDIF
#endif /* ALLOW_DEBUG */

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C---  Prepare output grid and interpolate for each tile

C--   put xG in interval [ lon_0 , lon_0+360 [
      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          xG(i,j,bi,bj) = xG_in(i,j,bi,bj)-lon_0
     &                  + threeSixtyRS*2.
          xG(i,j,bi,bj) = lon_0+MOD(xG(i,j,bi,bj),threeSixtyRS)
         ENDDO
        ENDDO
#ifdef ALLOW_DEBUG
C--   Check validity of input/output coordinates
        IF ( debugFlag ) THEN
         DO j=1,sNy
          DO i=1,sNx
           IF ( xG(i,j,bi,bj) .LT. x_in(0)        .OR.
     &          xG(i,j,bi,bj) .GE. x_in(nxIn+1)   .OR.
     &          yG(i,j,bi,bj) .LT. y_in(0)        .OR.
     &          yG(i,j,bi,bj) .GE. y_in(nyIn+1) ) THEN
            l = ILNBLNK(inFile)
            WRITE(msgBuf,'(3A,I6)')
     &        'EXF_INTERP: file="', inFile(1:l), '", rec=', irecord
            CALL PRINT_ERROR( msgBuf, myThid )
            WRITE(msgBuf,'(A)')
     &        'EXF_INTERP: input grid must encompass output grid.'
            CALL PRINT_ERROR( msgBuf, myThid )
            WRITE(msgBuf,'(A,2I8,2I6,A,1P2E14.6)') 'i,j,bi,bj=',
     &        i,j,bi,bj, ' , xG,yG=', xG(i,j,bi,bj), yG(i,j,bi,bj)
            CALL PRINT_ERROR( msgBuf, myThid )
            WRITE(msgBuf,'(A,I9,A,1P2E14.6)') 'nxIn=', nxIn,
     &        ' , x_in(0,nxIn+1)=', x_in(0) ,x_in(nxIn+1)
            CALL PRINT_ERROR( msgBuf, myThid )
            WRITE(msgBuf,'(A,I9,A,1P2E14.6)') 'nyIn=', nyIn,
     &        ' , y_in(0,nyIn+1)=', y_in(0) ,y_in(nyIn+1)
            CALL PRINT_ERROR( msgBuf, myThid )
            STOP 'ABNORMAL END: S/R EXF_INTERP'
           ENDIF
          ENDDO
         ENDDO
        ENDIF
#endif /* ALLOW_DEBUG */
       ENDDO
      ENDDO

      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)

C--   Compute interpolation lon & lat index mapping
C--     latitude index
        DO j=1,sNy
         DO i=1,sNx
          s_ind(i,j) = 0
          w_ind(i,j) = nyIn+1
         ENDDO
        ENDDO
C       # of pts = nyIn+2 ; # of interval = nyIn+1 ; evaluate nLoop as
C       1 + truncated log2(# interval -1); add epsil=1.e-3 for safey
        tmpVar = nyIn + 1. _d -3
        nLoop = 1 + INT( LOG(tmpVar)/LOG(2. _d 0) )
        DO l=1,nLoop
         DO j=1,sNy
          DO i=1,sNx
           IF ( w_ind(i,j).GT.s_ind(i,j)+1 ) THEN
            k = NINT( (s_ind(i,j)+w_ind(i,j))*0.5 )
            IF ( yG(i,j,bi,bj) .LT. y_in(k) ) THEN
              w_ind(i,j) = k
            ELSE
              s_ind(i,j) = k
            ENDIF
           ENDIF
          ENDDO
         ENDDO
        ENDDO
#ifdef ALLOW_DEBUG
        IF ( debugFlag ) THEN
C-      Check that we found the right lat. index
         DO j=1,sNy
          DO i=1,sNx
           IF ( w_ind(i,j).NE.s_ind(i,j)+1 ) THEN
            l = ILNBLNK(inFile)
            WRITE(msgBuf,'(3A,I4,A,I4)')
     &        'EXF_INTERP: file="', inFile(1:l), '", rec=', irecord,
     &        ', nLoop=', nLoop
            CALL PRINT_ERROR( msgBuf, myThid )
            WRITE(msgBuf,'(A)')
     &        'EXF_INTERP: did not find Latitude index for grid-pt:'
            CALL PRINT_ERROR( msgBuf, myThid )
            WRITE(msgBuf,'(A,2I8,2I6,A,1PE16.8)')
     &        'EXF_INTERP: i,j,bi,bj=',i,j,bi,bj,' , yG=',yG(i,j,bi,bj)
            CALL PRINT_ERROR( msgBuf, myThid )
            WRITE(msgBuf,'(A,I8,A,1PE16.8)')
     &        'EXF_INTERP: s_ind=',s_ind(i,j),', lat=',y_in(s_ind(i,j))
            CALL PRINT_ERROR( msgBuf, myThid )
            WRITE(msgBuf,'(A,I8,A,1PE16.8)')
     &        'EXF_INTERP: n_ind=',w_ind(i,j),', lat=',y_in(w_ind(i,j))
            CALL PRINT_ERROR( msgBuf, myThid )
            STOP 'ABNORMAL END: S/R EXF_INTERP'
           ENDIF
          ENDDO
         ENDDO
        ENDIF
#endif /* ALLOW_DEBUG */
C--     longitude index
        DO j=1,sNy
         DO i=1,sNx
           w_ind(i,j) = INT((xG(i,j,bi,bj)-x_in(-1))/lon_inc) - 1
         ENDDO
        ENDDO

C--   Do interpolation using lon & lat index mapping
        CALL EXF_INTERPOLATE(
     I                inFile, irecord, method,
     I                nxIn, nyIn, x_in, y_in,
     I                arrayin,
     O                arrayout,
     I                xG, yG,
     I                w_ind, s_ind,
     I                bi, bj, myThid )

       ENDDO
      ENDDO

      RETURN
      END

#include "FIZHI_OPTIONS.h"
       SUBROUTINE FIZHI_INIT_FIXED (myThid)
c-----------------------------------------------------------------------
c  Routine to initialise the fizhi package.
c
c  Input: myThid       - Process number calling this routine
c
c  Notes:
c   1) This routine is the interface to read input datasets and set
c      other fixed variables for fizhi
c      the datasets are:
c         vegetation (data for each tile at every grid point)
c         ozone (varies with lat, height and time - read it all in
c                   now and interpolate between values later)
c      the other fixed parameters are:
c         N2O, Methane (vary with space)
c         CO2, CFC11, CFC12, CFC22 (set to a global value)
c   3) For now, the fizhi package contains the alarms and clocks
c      routines, so this routine will also initialize the alarms.
c-----------------------------------------------------------------------
       IMPLICIT NONE
#include "SIZE.h"
#include "fizhi_SIZE.h"
#include "fizhi_land_SIZE.h"
#include "EEPARAMS.h"
#include "fizhi_chemistry_coms.h"
#include "fizhi_earth_coms.h"
#include "fizhi_land_coms.h"
#include "fizhi_ocean_coms.h"
#include "chronos.h"
#include "gridalt_mapping.h"
#include "GRID.h"
#include "PARAMS.h"
#ifdef ALLOW_EXCH2
#include "W2_EXCH2_SIZE.h"
#include "W2_EXCH2_TOPOLOGY.h"
#endif /* ALLOW_EXCH2 */

       INTEGER myThid

       INTEGER i,j,L,bi,bj
       INTEGER im1, im2, jm1, jm2, idim2, jdim2
       INTEGER nymdb,nhmsb
       CHARACTER*40 vegdata
       _RL pressure0(Nrphys+1)
       _RL pressure(Nrphys)
       _RL lats(sNx,sNy,nSx,nSy), lons(sNx,sNy,nSx,nSy)
       _RL fracland(sNx,sNy,nSx,nSy)
       _RL tempoverlap(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
       INTEGER xsize, ysize

#if defined(ALLOW_EXCH2)
       xsize = exch2_global_Nx
       ysize = exch2_global_Ny
#else
       xsize = Nx
       ysize = Ny
#endif
       idim2 = sNx+OLx
       jdim2 = sNy+OLy
       im1 = 1
       im2 = sNx
       jm1 = 1
       jm2 = sNy
       nymdb = nymd0
       nhmsb = nhms0

#ifdef ALLOW_MNC
       if (useMNC) then
        call fizhi_mnc_init(myThid)
       endif
#endif

#ifdef ALLOW_DIAGNOSTICS
       if ( useDiagnostics ) then
        call fizhi_diagnostics_init( myThid )
       endif
#endif

       call fizhi_alarms(nymdb,nhmsb,deltaTClock)

       do bj = myByLo(myThid), myByHi(myThid)
       do bi = myBxLo(myThid), myBxHi(myThid)
       do j = jm1,jm2
       do i = im1,im2
        lons(i,j,bi,bj) = xC(i,j,bi,bj)
        lats(i,j,bi,bj) = yC(i,j,bi,bj)
       enddo
       enddo
       enddo
       enddo
       if(xsize.eq.192) then
        vegdata = 'veg19232.data'
       elseif(xsize.eq.612) then
        vegdata = 'veg612102.data'
       else
       print *,' xsize is ',xsize
       stop 'do not seem to have correct vegetation data '
       endif

       call fizhi_init_veg ( myThid, vegdata,im2,jm2,nSx,nSy,
     &         nSx*nPx,nSy*nPy,maxtyp,nchp,nchptot,nchpland,lons,lats,
     &         surftype,tilefrac,igrd,ityp,chfr,chlt,chlon)

C And now fill the earth export landtype
       do bj = myByLo(myThid), myByHi(myThid)
       do bi = myBxLo(myThid), myBxHi(myThid)
        call get_landfrac(im2,jm2,nSx,nSy,bi,bj,maxtyp,
     &        surftype,tilefrac,fracland(1,1,bi,bj))
        do j=jm1,jm2
        do i=im1,im2
         landtype(i,j,bi,bj) = surftype(i,j,1,bi,bj)
         if(fracland(i,j,bi,bj).ge.0.3.and.surftype(i,j,1,bi,bj).ge.100)
     &            landtype(i,j,bi,bj) = surftype(i,j,2,bi,bj)
         if(sice(i,j,bi,bj).ne.0.0)landtype(i,j,bi,bj) = 101
        enddo
        enddo
       enddo
       enddo

C Compute pressure profile to get methane and n2o values
C     - First bottom-up (in mb)

       pressure0(1)=1000.
       do L = 2,Nrphys+1
        pressure0(L)=pressure0(L-1)-dpphys0(1,1,L-1,1,1)/100.
       enddo
C Now flip pressure to a top-down array and average to mid levels
C     to send to fizhi init chem
       do L = 1,Nrphys
        pressure(L)=(pressure0(Nrphys+2-L)+pressure0(Nrphys+1-L))/2.
       enddo

       call fizhi_init_chem(myThid,
     &      nlatsoz,nlevsoz,ntimesoz,latsoz,levsoz,ozone,
     &      nlatsq,nlevsq,ntimesq,latsq,levsq,stratq,
     &      Nrphys,pressure,n2o,methane,co2,cfc11,cfc12,cfc22)

C Read dataset that contains topography variance (10m by 10m in a 2x2.5 box)
       if(xsize.eq.192) then
        CALL READ_REC_XY_RL('topvar19232.data',tempoverlap,1,0,myThid )
       elseif(xsize.eq.612) then
        CALL READ_REC_XY_RL('topvar612102.data',tempoverlap,1,0,myThid )
       else
       print *,' xsize is ',xsize
       stop 'do not seem to have correct topog variance data '
       endif
       _BARRIER

       do bj = myByLo(myThid), myByHi(myThid)
       do bi = myBxLo(myThid), myBxHi(myThid)
        do j=jm1,jm2
        do i=im1,im2
         if(fracland(i,j,bi,bj).gt.0.3) then
          phis_var(i,j,bi,bj) = tempoverlap(i,j,bi,bj)
         else
          phis_var(i,j,bi,bj) = 0.
         endif
        enddo
        enddo
       enddo
       enddo

C Finally, grab unit numbers for reading sst and sea ice
C   (held in common block fizhi ocean coms)

       call mdsfindunit( kice, myThid )
       open(kice)
       call mdsfindunit( ksst, myThid )
       open(ksst)

       return
       end

#include "CPP_OPTIONS.h"
#undef CHECK_ANALYLIC_THETA

CBOP
C     !ROUTINE: INI_P_GROUND
C     !INTERFACE:
      SUBROUTINE INI_P_GROUND(selectMode,
     &                        Hfld, Pfld,
     I                        myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE INI_P_GROUND
C     | o Convert Topography [m] to (reference) Surface Pressure
C     |   according to tRef profile,
C     |   using same discretisation as in calc_phi_hyd
C     |
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     == Global variables ==
#include "SIZE.h"
#include "GRID.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "SURFACE.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     selectMode ::  > 0 = find Pfld from Hfld ; < 0 = compute Hfld from Pfld
C                   selectFindRoSurf = 0 : use Theta_Ref profile
C                   selectFindRoSurf = 1 : use analytic fct Theta(Lat,P)
C     Hfld (input/outp) :: Ground elevation [m]
C     Pfld (outp/input) :: reference Pressure at the ground [Pa]
      INTEGER selectMode
      _RS Hfld(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RS Pfld(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      INTEGER myThid

C     !LOCAL VARIABLES:
C     == Local variables ==
C     msgBuf :: Informational/error message buffer
C-
C       For an accurate definition of the reference surface pressure,
C       define a High vertical resolution (in P):
C     nLevHvR :: Number of P-level used for High vertical Resolution (HvR)
C     plowHvR :: Lower bound of the High vertical Resolution
C     dpHvR   :: normalized pressure increment (HvR)
C     pLevHvR :: normalized P-level of the High vertical Resolution
C     pMidHvR :: normalized mid point level (HvR)
C     thetaHvR :: potential temperature at mid point level (HvR)
C     PiHvR  :: Exner function at P-level
C     dPiHvR :: Exner function difference between 2 P-levels
C     recip_kappa :: 1/kappa = Cp/R
C     PiLoc, zLoc, dzLoc, yLatLoc, phiLoc :: hold on temporary values
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      INTEGER bi,bj,i,j,k, ks
      _RL Po_surf
      _RL hRef(2*Nr+1), rHalf(2*Nr+1)
      LOGICAL findPoSurf

      INTEGER nLevHvR
      PARAMETER ( nLevHvR = 60 )
      _RL plowHvR, dpHvR, pLevHvR(nLevHvR+1), pMidHvR(nLevHvR)
      _RL thetaHvR(nLevHvR), PiHvR(nLevHvR+1), dPiHvR(nLevHvR)
      _RL recip_kappa, PiLoc, zLoc, dzLoc, yLatLoc, phiLoc
      _RL  psNorm, rMidKp1
      _RL ratioRm(Nr), ratioRp(Nr)
      INTEGER kLev
#ifdef CHECK_ANALYLIC_THETA
      _RL tmpVar(nLevHvR,61)
#endif
CEOP

      IF ( selectFindRoSurf.LT.0 .OR. selectFindRoSurf.GT.1 ) THEN
        WRITE(msgBuf,'(A,I2,A)')
     &   'INI_P_GROUND: selectFindRoSurf =', selectFindRoSurf,
     &        ' <== bad value !'
        CALL PRINT_ERROR( msgBuf, myThid )
        STOP 'INI_P_GROUND'
      ENDIF

      DO k=1,Nr
        rHalf(2*k-1) = rF(k)
        rHalf(2*k)   = rC(k)
      ENDDO
       rHalf(2*Nr+1) = rF(Nr+1)

C- Reference Geopotential at Half levels :
C    Tracer level: hRef(2k)  ;  Interface_W level: hRef(2k+1)
C- Convert phiRef to Z unit :
      DO k=1,2*Nr+1
        hRef(k) = phiRef(k)*recip_gravity
      ENDDO

      IF (selectFindRoSurf.EQ.0 .AND. selectMode .GT. 0 ) THEN
C- Find Po_surf : Linear between 2 half levels :
      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
        DO j=1,sNy
         DO i=1,sNx
           ks = 1
           DO k=1,2*Nr
             IF (Hfld(i,j,bi,bj).GE.hRef(k)) ks = k
           ENDDO
           Po_surf = rHalf(ks) + (rHalf(ks+1)-rHalf(ks))*
     &       (Hfld(i,j,bi,bj)-hRef(ks))/(hRef(ks+1)-hRef(ks))

c          IF (Hfld(i,j,bi,bj).LT.hRef(1)) Po_surf= rHalf(1)
c          IF (Hfld(i,j,bi,bj).GT.hRef(2*Nr+1)) Po_surf=rHalf(2*Nr+1)
           Pfld(i,j,bi,bj) = Po_surf
         ENDDO
        ENDDO
       ENDDO
      ENDDO

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C-- endif selectFindRoSurf=0 & selectMode > 0
      ENDIF

      IF ( selectFindRoSurf.EQ.1 ) THEN
C-- define high resolution Pressure discretization:

      recip_kappa = 1. _d 0 / atm_kappa
      plowHvR = 0.4 _d 0
      dpHvR = nLevHvR
      dpHvR = (1. - plowHvR) / dpHvR
        pLevHvR(1)= rF(1)/atm_Po
        PiHvR(1) = atm_Cp*(pLevHvR(1)**atm_kappa)
      DO k=1,nLevHvR
        pLevHvR(k+1)= pLevHvR(1) - k*dpHvR
        PiHvR(k+1)  = atm_Cp*(pLevHvR(k+1)**atm_kappa)
        pMidHvR(k)= (pLevHvR(k)+pLevHvR(k+1))*0.5 _d 0
        dPiHvR(k) = PiHvR(k) - PiHvR(k+1)
      ENDDO

C--   to modify pressure when using non fully linear relation between Phi & p
C       (Integr_GeoPot=2 & Tracer Point at middle between 2 interfaces)
      DO k=1,Nr
         ratioRm(k) = 1. _d 0
         ratioRp(k) = 1. _d 0
         IF (k.GT.1 ) ratioRm(k) = 0.5 _d 0*drC(k)/(rF(k)-rC(k))
         IF (k.LT.Nr) ratioRp(k) = 0.5 _d 0*drC(k+1)/(rC(k)-rF(k+1))
      ENDDO

#ifdef CHECK_ANALYLIC_THETA
      _BEGIN_MASTER( myThid )
      DO j=1,61
        yLatLoc =-90.+(j-1)*3.
        CALL ANALYLIC_THETA( yLatLoc, pMidHvR,
     &                       tmpVar(1,j), nLevHvR, myThid )
      ENDDO
      OPEN(88,FILE='analytic_theta',
     &      STATUS='unknown',FORM='unformatted')
      WRITE(88) tmpVar
      CLOSE(88)
      _END_MASTER( myThid )
      STOP 'CHECK_ANALYLIC_THETA'
#endif /* CHECK_ANALYLIC_THETA */

C-- endif selectFindRoSurf=1
      ENDIF

      IF ( selectFindRoSurf*selectMode .GT. 0) THEN
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C- Find Po_surf such as g*Hfld = Phi[Po_surf,theta(yLat,p)]:

      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
C- start bi,bj loop:

        DO j=1,sNy
         DO i=1,sNx
          phiLoc = Hfld(i,j,bi,bj) - hRef(1)
          IF ( phiLoc .LE. 0. _d 0 ) THEN
           Pfld(i,j,bi,bj) = rF(1)
          ELSE
           yLatLoc  = yC(i,j,bi,bj)
           CALL ANALYLIC_THETA( yLatLoc, pMidHvR,
     &                          thetaHvR, nLevHvR, myThid )
           zLoc = 0.
           DO k=1,nLevHvR
            IF (zLoc.GE.0.) THEN
C-    compute  phi/g corresponding to next p_level:
             dzLoc = dPiHvR(k)*thetaHvR(k)*recip_gravity
             IF ( phiLoc .LE. zLoc+dzLoc ) THEN
C-    compute the normalized surf. Pressure psNorm
               PiLoc = PiHvR(k)
     &               - gravity*( phiLoc - zLoc )/thetaHvR(k)
               psNorm = (PiLoc/atm_Cp)**recip_kappa
C- use linear interpolation:
c              psNorm = pLevHvR(k)
c    &                - dpHvR*( phiLoc - zLoc )/dzLoc
               zLoc = -1.
             ELSE
               zLoc = zLoc + dzLoc
             ENDIF
            ENDIF
           ENDDO
           IF (zLoc.GE.0.) THEN
             WRITE(msgBuf,'(2A)')
     &        'INI_P_GROUND: FAIL in trying to find Pfld:',
     &        ' selectMode,i,j,bi,bj=',selectMode,i,j,bi,bj
             CALL PRINT_ERROR( msgBuf, myThid )
             WRITE(msgBuf,'(A,F7.1,2A,F6.4,A,F8.0)')
     &        'INI_P_GROUND: Hfld=', Hfld(i,j,bi,bj), ' exceeds',
     &        ' Zloc(lowest P=', pLevHvR(1+nLevHvR),' )=',zLoc
             CALL PRINT_ERROR( msgBuf, myThid )
             STOP 'ABNORMAL END: S/R INI_P_GROUND'
           ELSE
             Pfld(i,j,bi,bj) = psNorm*atm_Po
           ENDIF
          ENDIF
         ENDDO
        ENDDO

        IF (selectMode.EQ.2 .AND. integr_GeoPot.NE.1) THEN
C---------
C     Modify pressure to account for non fully linear relation between
C      Phi & p (due to numerical truncation of the Finite Difference scheme)
C---------
          DO j=1,sNy
           DO i=1,sNx
             Po_surf = Pfld(i,j,bi,bj)
              IF ( Po_surf.LT.rC(1) .AND. Po_surf.GT.rC(Nr) ) THEN
                findPoSurf = .TRUE.
                DO k=1,Nr
                  IF ( findPoSurf .AND. Po_surf.GE.rC(k) ) THEN
                    Po_surf = rC(k) + (Po_surf-rC(k))/ratioRm(k)
                    findPoSurf = .FALSE.
                  ENDIF
                  rMidKp1 = rF(k+1)
                  IF (k.LT.Nr) rMidKp1 = (rC(k)+rC(k+1))*0.5 _d 0
                  IF ( findPoSurf .AND. Po_surf.GE.rMidKp1 ) THEN
                    Po_surf = rC(k) + (Po_surf-rC(k))/ratioRp(k)
                    findPoSurf = .FALSE.
                  ENDIF
                ENDDO
                IF ( findPoSurf )
     &               STOP 'S/R INI_P_GROUND: Pb with selectMode=2'
              ENDIF
             Pfld(i,j,bi,bj) = Po_surf
           ENDDO
          ENDDO
C---------
        ENDIF

C- end bi,bj loop.
       ENDDO
      ENDDO

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C-- endif selectFindRoSurf*selectMode > 0
      ENDIF

      IF (selectMode .LT. 0) THEN
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C--- Compute Hfld = Phi(Pfld)/g.

      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
C- start bi,bj loop:

C--  Compute Hfld from g*Hfld = hRef(Po_surf)
        DO j=1,sNy
         DO i=1,sNx
C-   compute phiLoc = hRef(Ro_surf):
          ks = kSurfC(i,j,bi,bj)
          IF (ks.LE.Nr) THEN
C-   sigma coord. case (=> uniform kSurfC), find true ks:
           IF ( selectSigmaCoord.NE.0 ) THEN
             DO k=2,Nr
               IF ( Pfld(i,j,bi,bj).LT.rF(k) ) ks = k
             ENDDO
           ENDIF
           IF ( Pfld(i,j,bi,bj).GE.rC(ks) ) THEN
            phiLoc = hRef(2*ks)
     &       + (hRef(2*ks-1)-hRef(2*ks))
     &        *(Pfld(i,j,bi,bj)-rC(ks))/(rHalf(2*ks-1)-rHalf(2*ks))
           ELSE
            phiLoc = hRef(2*ks)
     &       + (hRef(2*ks+1)-hRef(2*ks))
     &        *(Pfld(i,j,bi,bj)-rC(ks))/(rHalf(2*ks+1)-rHalf(2*ks))
           ENDIF
           Hfld(i,j,bi,bj) = phiLoc
          ELSE
           Hfld(i,j,bi,bj) = 0.
          ENDIF
         ENDDO
        ENDDO

        IF (selectFindRoSurf.EQ.1) THEN
C-----
C  goal: evaluate phi0surf (used for computing geopotential_prime = Phi - PhiRef):
C   phi0surf = g*Ztopo-PhiRef(Ro_surf) if no truncation was applied to Ro_surf;
C  but because of hFacMin, surf.ref.pressure (=Ro_surf) is truncated and
C   phi0surf = Phi(Theta-Analytic,P=Ro_surf) - PhiRef(P=Ro_surf)
C-----
C--   Compute Hfld from g*Hfld = Phi[Po_surf,theta(yLat,p)]:
         DO j=1,sNy
          DO i=1,sNx
           zLoc = hRef(1)
           IF ( Pfld(i,j,bi,bj) .LT. rF(1) ) THEN
            Po_surf = Pfld(i,j,bi,bj)
C---------
C     Modify pressure to account for non fully linear relation between
C      Phi & p (due to numerical truncation of the Finite Difference scheme)
             IF (selectMode.EQ.-2 .AND. integr_GeoPot.NE.1) THEN
              IF ( Po_surf.LT.rC(1) .AND. Po_surf.GT.rC(Nr) ) THEN
                findPoSurf = .TRUE.
                DO k=1,Nr
                  IF ( findPoSurf .AND. Po_surf.GE.rC(k) ) THEN
                    Po_surf = rC(k) + (Po_surf-rC(k))*ratioRm(k)
                    findPoSurf = .FALSE.
                  ENDIF
                  IF ( findPoSurf .AND. Po_surf.GE.rF(k+1) ) THEN
                    Po_surf = rC(k) + (Po_surf-rC(k))*ratioRp(k)
                    findPoSurf = .FALSE.
                  ENDIF
                ENDDO
              ENDIF
             ENDIF
C---------
            psNorm = Po_surf/atm_Po
            kLev = 1 + INT( (pLevHvR(1)-psNorm)/dpHvR )
            yLatLoc  = yC(i,j,bi,bj)
            CALL ANALYLIC_THETA( yLatLoc, pMidHvR,
     &                           thetaHvR, kLev, myThid )
C-    compute height at level pLev(kLev) just below Pfld:
            DO k=1,kLev-1
              dzLoc = dPiHvR(k)*thetaHvR(k)*recip_gravity
              zLoc = zLoc + dzLoc
            ENDDO
            dzLoc = ( PiHvR(kLev)-atm_Cp*(psNorm**atm_kappa) )
     &            * thetaHvR(kLev)*recip_gravity
            zLoc = zLoc + dzLoc
           ENDIF
C-    compute phi0surf = Phi[Po_surf,theta(yLat,p)] - PhiRef(Po_surf)
           phi0surf(i,j,bi,bj) = gravity*(zLoc - Hfld(i,j,bi,bj))
C-    save Phi[Po_surf,theta(yLat,p)] in Hfld (replacing PhiRef(Po_surf)):
           Hfld(i,j,bi,bj) = zLoc
          ENDDO
         ENDDO
C- endif selectFindRoSurf=1
        ENDIF

C- end bi,bj loop.
       ENDDO
      ENDDO

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C-- endif selectMode < 0
      ENDIF

      RETURN
      END

CBOP
C     !SUBROUTINE: ANALYLIC_THETA
C     !INTERFACE:
      SUBROUTINE ANALYLIC_THETA( yLat, pNlev,
     O                           thetaLev,
     I                           kSize, myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE ANALYLIC_THETA
C     | o Conpute analyticaly the potential temperature Theta
C     |   as a function of Latitude (yLat) and normalized
C     |   pressure pNlev.
C     |   approximatively match the N-S symetric, zonal-mean and
C     |   annual-mean NCEP climatology in the troposphere.
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     yLat   :: latitude (degre)
C     pNlev  :: normalized pressure levels
C     kSize  :: dimension of pNlev & ANALYLIC_THETA
C     myThid :: Thread number for this instance of the routine
      INTEGER kSize
      _RL  yLat
      _RL  pNlev  (kSize)
      _RL  thetaLev(kSize)
      INTEGER myThid

C     !LOCAL VARIABLES:
C     == Local variables ==
      INTEGER k
      _RL  yyA, yyB, yyC, yyAd, yyBd, yyCd
      _RL  cAtmp, cBtmp, ttdC
      _RL  ppN0, ppN1, ppN2, ppN3a, ppN3b, ppN4
      _RL  ttp1, ttp2, ttp3, ttp4, ttp5
      _RL  yAtmp, yBtmp, yCtmp, yDtmp
      _RL  ttp2y, ttp4y, a1tmp
      _RL  ppl, ppm, pph, ppr
CEOP

      DATA yyA ,    yyB ,     yyC ,     yyAd ,   yyBd ,   yyCd
     &  / 45. _d 0, 65. _d 0, 65. _d 0, .9 _d 0, .9 _d 0, 10. _d 0 /
      DATA  cAtmp ,   cBtmp ,   ttdC
     &   /  2.6 _d 0, 1.5 _d 0, 3.3 _d 0 /
      DATA  ppN0  ,   ppN1  ,  ppN2  ,  ppN3a ,  ppN3b ,  ppN4
     &   / .1 _d 0, .19 _d 0, .3 _d 0, .9 _d 0, .7 _d 0, .925 _d 0 /
      DATA ttp1 ,     ttp2 ,     ttp3 ,     ttp4 ,     ttp5
     &   / 350. _d 0, 342. _d 0, 307. _d 0, 301. _d 0, 257. _d 0 /

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

       yAtmp = ABS(yLat) - yyA
       yAtmp = yyA + MIN(0. _d 0,yAtmp/yyAd) + MAX(yAtmp, 0. _d 0)
       yAtmp = COS( deg2rad*MAX(yAtmp, 0. _d 0) )
       yBtmp = ABS(yLat) - yyB
       yBtmp = yyB + yBtmp/yyBd
       yBtmp = COS( deg2rad*MAX( 0. _d 0, MIN(yBtmp,90. _d 0) ) )
       yCtmp = ABS(yLat) - yyC
       yCtmp = MAX( 0. _d 0, 1. _d 0 - (yCtmp/yyCd)**2 )
       yDtmp = ppN3a +(ppN3b - ppN3a)*yCtmp
       ttp2y = ttp3 + (ttp2-ttp3)*yAtmp**cAtmp
       ttp4y = ttp5 + (ttp4-ttp5)*yBtmp**cBtmp
       a1tmp = (ttp1-ttp2y)*ppN1*ppN2/(ppN2-ppN1)
      DO k=1,kSize
       ppl = MIN(pNlev(k),ppN1)
       ppm = MIN(MAX(pNlev(k),ppN1),ppN2)
       pph = MAX(pNlev(k),ppN2)
       ppr =( ppN0 + ABS(ppl-ppN0) - ppN1 )/(ppN2-ppN1)
       thetaLev(k) =
     &       ( (1. _d 0 -ppr)*ttp1*ppN1**atm_kappa
     &        + ppr*ttp2y*ppN2**atm_kappa
     &       )*ppl**(-atm_kappa)
     &     + a1tmp*(1. _d 0 /ppm - 1. _d 0/ppN1)
     &     + (ttp4y-ttp2y)*(pph-ppN2)/(ppN4-ppN2)
     &     + (ttdC+yCtmp)*MAX(0. _d 0,pNlev(k)-yDtmp)/(1-yDtmp)
      ENDDO

C---------------------------------------------------
C matlab script, input: pN, yp=abs(yLat)
C pN0=.1; pN1=.19 ; pN2=.3; pN4=.925;
C pm=min(max(pN,pN1),pN2); pp=max(pN,pN2);
C pl=min(pN,pN1); pr=(pN0+abs(pl-pN0)-pN1)/(pN2-pN1);
C
C  yA=yp-45; yA=45+min(0,yA/.9)+max(0,yA); yA=max(0,yA); cosyA=cos(yA*rad) ;
C  yB=yp-65; yB=65+yB/.9; yB=min(max(0,yB),90); cosyB=cos(yB*rad) ;
C  tp1=350*ones(nyA,1);
C  tp2=307+(342-307)*cosyA.^2.6;
C  tp4=257+(301-257)*cosyB.^1.5;
C  a1=(tp1-tp2)*pN1*pN2/(pN2-pN1);
C  pF=max(0,1.-((yp-65)/10).^2); pT=.9+(0.7-.9)*pF;
C
C  tA0=((1-pr(k))*tp1(j)*pN1^kappa+pr(k)*tp2(j)*pN2^kappa)*pl(k)^-kappa;
C  tA1=a1(j)*(1./pm(k)-1./pN1);
C  tA2=(tp4(j)-tp2(j))*(pp(k)-pN2)/(pN4-pN2);
C  tA3=(3.3+pF(j))*max(0,pN(k)-pT(j))/(1-pT(j));
C  tAn(j,k)=tA0+tA1+tA2+tA3;
C---------------------------------------------------

      RETURN
      END

#include "MOM_FLUXFORM_OPTIONS.h"
#ifdef ALLOW_MOM_COMMON
# include "MOM_COMMON_OPTIONS.h"
#endif

CBOP
C !ROUTINE: MOM_U_YVISCFLUX

C !INTERFACE: ==========================================================
      SUBROUTINE MOM_U_YVISCFLUX(
     I        bi,bj,k,
     I        uFld, del2u, hFacZ,
     O        yViscFluxU,
     I        viscAh_Z,viscA4_Z,
     I        myThid )

C !DESCRIPTION:
C Calculates the area integrated meridional viscous fluxes of U:
C \begin{equation*}
C F^y = - \frac{ \Delta y_v \Delta r_f h_z }{\Delta y_u}
C  ( A_h \delta_j u - A_4 \delta_j \nabla^2 u )
C \end{equation*}

C !USES: ===============================================================
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"

C !INPUT PARAMETERS: ===================================================
C  bi,bj                :: tile indices
C  k                    :: vertical level
C  uFld                 :: zonal flow
C  del2u                :: Laplacian of zonal flow
C  myThid               :: thread number
      INTEGER bi,bj,k
      _RL uFld(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL del2u(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RS hFacZ(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL viscAh_Z(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL viscA4_Z(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER myThid

C !OUTPUT PARAMETERS: ==================================================
C  yViscFluxU           :: viscous fluxes
      _RL yViscFluxU(1-OLx:sNx+OLx,1-OLy:sNy+OLy)

C !LOCAL VARIABLES: ====================================================
C  i,j                  :: loop indices
      INTEGER i,j
CEOP

C     - Laplacian  and bi-harmonic terms
      DO j=1-OLy+1,sNy+OLy
       DO i=1-OLx,sNx+OLx
        yViscFluxU(i,j) =
     &    _dxV(i,j,bi,bj)*drF(k)*hFacZ(i,j)
     &     *(
     &       -viscAh_Z(i,j)*( uFld(i,j)-uFld(i,j-1) )
#ifdef ISOTROPIC_COS_SCALING
     &       *cosFacV(j,bi,bj)
#endif
     &       +viscA4_Z(i,j)*(del2u(i,j)-del2u(i,j-1))
#ifdef ISOTROPIC_COS_SCALING
#ifdef COSINEMETH_III
     &       *sqCosFacV(j,bi,bj)
#else
     &       *cosFacV(j,bi,bj)
#endif
#endif
     &      )*_recip_dyU(i,j,bi,bj)
c    &       *deepFacC(k)        ! dxV scaling factor
c    &       *recip_deepFacC(k)  ! recip_dyU scaling factor
       ENDDO
      ENDDO

      RETURN
      END

#include "EXF_OPTIONS.h"

C--  File exf_swapffields.F: Routines to swap 2 fields
C--   Contents
C--   o EXF_SWAPFFIELDS
C--   o EXF_SWAPFFIELDS_3D
C--   o EXF_SWAPFFIELDS_XZ
C--   o EXF_SWAPFFIELDS_YZ

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      SUBROUTINE EXF_SWAPFFIELDS(
     O                            ffld0,
     U                            ffld1,
     I                            myThid )

C     ==================================================================
C     SUBROUTINE exf_SwapFFields
C     ==================================================================
C
C     o Copy a forcing field ffld1 to ffld0 and set ffld0 to zero.
C
C     started: Christian Eckert eckert@mit.edu  30-Jun-1999
C
C     changed: Christian Eckert eckert@mit.edu  14-Jan-2000
C
C              - Restructured the code in order to create a package
C                for the MITgcmUV.
C
C              Christian Eckert eckert@mit.edu  12-Feb-2000
C
C              - Changed Routine names (package prefix: exf_)
C
C     ==================================================================
C     SUBROUTINE exf_SwapFFields
C     ==================================================================

      IMPLICIT NONE

C     == global variables ==
#include "EEPARAMS.h"
#include "SIZE.h"

C     == routine arguments ==
      _RL ffld0(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL ffld1(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      INTEGER myThid

C     == local variables ==
      INTEGER bi, bj
      INTEGER i, j

C     == end of interface ==

      DO bj=myByLo(myThid),myByHi(myThid)
        DO bi=myBxLo(myThid),myBxHi(myThid)
          DO j = 1,sNy
            DO i = 1,sNx
              ffld0(i,j,bi,bj) = ffld1(i,j,bi,bj)
              ffld1(i,j,bi,bj) = 0. _d 0
            ENDDO
          ENDDO
        ENDDO
      ENDDO

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      SUBROUTINE EXF_SWAPFFIELDS_3D(
     O                            ffld0,
     U                            ffld1,
     I                            nNz, myThid )

C     ==================================================================
C     SUBROUTINE exf_SwapFFields_3d
C     ==================================================================
C
C     o Copy a forcing field ffld1 to ffld0 and set ffld0 to zero.
C
C     ==================================================================
C     SUBROUTINE exf_SwapFFields
C     ==================================================================

      IMPLICIT NONE

C     == global variables ==
#include "EEPARAMS.h"
#include "SIZE.h"

C     == routine arguments ==
C     nNz   :: number of levels to process
      INTEGER nNz
      _RL ffld0(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nNz,nSx,nSy)
      _RL ffld1(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nNz,nSx,nSy)
      INTEGER myThid

C     == local variables ==
      INTEGER bi, bj
      INTEGER i, j, k

C     == end of interface ==

      DO bj=myByLo(myThid),myByHi(myThid)
        DO bi=myBxLo(myThid),myBxHi(myThid)
          DO k = 1,nNz
            DO j = 1,sNy
              DO i = 1,sNx
                ffld0(i,j,k,bi,bj) = ffld1(i,j,k,bi,bj)
                ffld1(i,j,k,bi,bj) = 0. _d 0
              ENDDO
            ENDDO
          ENDDO
        ENDDO
      ENDDO

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      SUBROUTINE EXF_SWAPFFIELDS_XZ(
     O                               ffld0,
     U                               ffld1,
     I                               nNz, myThid )

C     ==================================================================
C     SUBROUTINE exf_swapffields_xz
C     ==================================================================
C
C     o Copy a forcing field ffld1 to ffld0 and set ffld0 to zero.
C
C     started: heimbach@mit.edu 01-May-2001
C
C     ==================================================================
C     SUBROUTINE exf_swapffields_xz
C     ==================================================================

      IMPLICIT NONE

C     == global variables ==
#include "EEPARAMS.h"
#include "SIZE.h"

C     == routine arguments ==
C     nNz   :: number of levels to process
      INTEGER nNz
      _RL ffld0(1-OLx:sNx+OLx,nNz,nSx,nSy)
      _RL ffld1(1-OLx:sNx+OLx,nNz,nSx,nSy)
      INTEGER myThid

C     == local variables ==
      INTEGER bi, bj
      INTEGER i, k

C     == end of interface ==

      DO bj=myByLo(myThid),myByHi(myThid)
        DO bi=myBxLo(myThid),myBxHi(myThid)
          DO k = 1,nNz
            DO i = 1,sNx
              ffld0(i,k,bi,bj) = ffld1(i,k,bi,bj)
              ffld1(i,k,bi,bj) = 0. _d 0
            ENDDO
          ENDDO
        ENDDO
      ENDDO

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      SUBROUTINE EXF_SWAPFFIELDS_YZ(
     O                               ffld0,
     U                               ffld1,
     I                               nNz, myThid )

C     ==================================================================
C     SUBROUTINE exf_swapffields_yz
C     ==================================================================
C
C     o Copy a forcing field ffld1 to ffld0 and set ffld0 to zero.
C
C     started: heimbach@mit.edu 01-May-2001
C
C     ==================================================================
C     SUBROUTINE exf_swapffields_yz
C     ==================================================================

      IMPLICIT NONE

C     == global variables ==
#include "EEPARAMS.h"
#include "SIZE.h"

C     == routine arguments ==
C     nNz   :: number of levels to process
      INTEGER nNz
      _RL ffld0(1-OLy:sNy+OLy,nNz,nSx,nSy)
      _RL ffld1(1-OLy:sNy+OLy,nNz,nSx,nSy)
      INTEGER myThid

C     == local variables ==
      INTEGER bi, bj
      INTEGER j, k

C     == end of interface ==

      DO bj=myByLo(myThid),myByHi(myThid)
        DO bi=myBxLo(myThid),myBxHi(myThid)
          DO k = 1,nNz
            DO j = 1,sNy
              ffld0(j,k,bi,bj) = ffld1(j,k,bi,bj)
              ffld1(j,k,bi,bj) = 0. _d 0
            ENDDO
          ENDDO
        ENDDO
      ENDDO

      RETURN
      END

#include "PTRACERS_OPTIONS.h"

CBOP
C     !ROUTINE: PTRACERS_CALC_WSURF_TR
C     !INTERFACE:
      SUBROUTINE PTRACERS_CALC_WSURF_TR(wVelFld,
     I                                  myTime, myIter, myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE CALC_WSURF_TR
C     | o Compute a correction for the source/sink of tracer
C     |   due to the linear free surface.
C     | o The source/sink results from W*Tr not summing to
C     |   zero at the free surface.
C     | o Here, we compute an area-integrated correction
C     |   to be applied in biogeochemistry packages.
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     == Global variables
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "SURFACE.h"
#include "PTRACERS_SIZE.h"
#include "PTRACERS_PARAMS.h"
#include "PTRACERS_FIELDS.h"

C     !INPUT PARAMETERS:
C     wvelFld  :: vertical velocity field
C     myTime   :: Current time in simulation
C     myIter   :: Current iteration number in simulation
C     myThid   :: Thread number for this instance of the routine.
      _RL wVelFld (1-Olx:sNx+Olx,1-Oly:sNy+Oly,Nr,nSx,nSy)
      _RL myTime
      INTEGER myIter
      INTEGER myThid
CEOP

C     !LOCAL VARIABLES:
      INTEGER i,j,bi,bj,ks,itr
      _RL wT_Tile(nSx,nSy,PTRACERS_num)
      _RL wT_Mean(PTRACERS_num)

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      DO itr=1,PTRACERS_numInUse
       totSurfCorPTr(iTr)  = 0.0 _d 0
       meanSurfCorPTr(iTr) = 0.0 _d 0
       wT_mean(iTr)        = 0.0 _d 0
      ENDDO

C-- compute per-tile sums
      DO bj=myByLo(myThid), myByHi(myThid)
       DO bi=myBxLo(myThid), myBxHi(myThid)
        DO itr=1,PTRACERS_numInUse
         wT_Tile(bi,bj,itr) = 0.
         DO j=1,sNy
          DO i=1,sNx
           ks = ksurfC(i,j,bi,bj)
           IF (ks.LE.Nr) THEN
            wT_Tile(bi,bj,itr) = wT_Tile(bi,bj,itr)
     &       + rA(i,j,bi,bj)*wVelFld(i,j,ks,bi,bj)
     &                      *ptracer(i,j,ks,bi,bj,iTr)
           ENDIF
          ENDDO
         ENDDO
        ENDDO
       ENDDO
      ENDDO

C-- sum over tiles
      DO itr=1,PTRACERS_numInUse
       CALL GLOBAL_SUM_TILE_RL( wT_Tile(1,1,itr), wT_Mean(iTr),
     &                          myThid )
       totSurfCorPTr(iTr) = wT_Mean(iTr)
      ENDDO

      IF ( globalArea.GT.0. ) THEN
       _BEGIN_MASTER( myThid )
       DO itr=1,PTRACERS_numInUse
        meanSurfCorPTr(iTr) = wT_Mean(iTr) / globalArea
       ENDDO
       _END_MASTER( myThid )
      ENDIF

      _BARRIER

      RETURN
      END

#include "CPP_EEOPTIONS.h"

CBOP
C     !ROUTINE: CHECK_THREADS

C     !INTERFACE:
      SUBROUTINE CHECK_THREADS( myThid )

C     !DESCRIPTION:
C     *==========================================================
C     | SUBROUTINE CHECK\_THREADS
C     | o Check that all the threads we need did indeed start.
C     *==========================================================
C     | This routine is called during the initialisation phase
C     | to check whether all the threads have started.
C     | It is invoked by every thread and if any thread finds an
C     | error it should set its error flag.
C     | Notes:
C     |  Different mechanisms may be required on different
C     | platforms to actually perform the check. For example as
C     | coded here each thread checks for a semaphore set by the
C     | other threads to see if they are running.
C     | It is also possible for a system to schedule threads
C     | sequentially, unless some system call is made to yield
C     | the process. This routine would detect this situation too
C     | and allow a programmer to modify this routine and the
C     | barrier code to allow threads to be scheduled more
C     | appropriately.
C     *==========================================================

C     !USES:
      IMPLICIT NONE
C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "EESUPPORT.h"

C     !INPUT PARAMETERS:
C     == Routine arguments ==
C     myThid :: My thread number
      INTEGER myThid

C     !FUNCTIONS:
#ifdef USE_OMP_THREADING
      INTEGER  OMP_GET_NUM_THREADS
      EXTERNAL OMP_GET_NUM_THREADS
#endif

C     !LOCAL VARIABLES:
C     == Local variables ==
C     I         :: Loop counter
C     numberThreadRunning :: Count of number of threads this thread
C                            thinks are running.
C     nChecks   :: Number of times checked for all threads. After so
C                  many checks give up and report an error.
C     msgBuf    :: Informational/error message buffer
      INTEGER nChecks
      CHARACTER*(MAX_LEN_MBUF) msgBuf
#ifdef USE_OMP_THREADING
#ifdef ALLOW_USE_MPI
      INTEGER myErr, mpiRC
#endif
#else /* USE_OMP_THREADING */
      INTEGER I, numberThreadsRunning
#endif /* USE_OMP_THREADING */
CEOP

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#ifdef USE_OMP_THREADING
C--   Check early-on that number of threads match

      IF ( OMP_GET_NUM_THREADS() .NE. nThreads ) THEN
C-    This process has problems in multi-threads setting (detected by
C     all pseudo-threads); note: cannot use any Barrier in this context

       WRITE(msgBuf,'(2A,I6)') 'CHECK_THREADS:',
     &              ' from "eedata", nThreads=', nThreads
       CALL PRINT_ERROR( msgBuf, myThid )
       WRITE(msgBuf,'(2A,I6)') ' not equal to ',
     &              'Env.Var. OMP_NUM_THREADS=', OMP_GET_NUM_THREADS()
       CALL PRINT_ERROR( msgBuf, myThid )
       thError(myThid) = .TRUE.
       eeBootError     = .TRUE.
       IF ( myThid.EQ.1 ) THEN
C-    one pseudo-thread (thId=1) export the error to other MPI processes
        nChecks = 1
#ifdef ALLOW_USE_MPI
        IF ( usingMPI ) THEN
         myErr = nChecks
         CALL MPI_Allreduce( myErr,nChecks,1,MPI_INTEGER,
     &                       MPI_SUM,MPI_COMM_MODEL,mpiRC )
        ENDIF
#endif /* ALLOW_USE_MPI */
       ENDIF

      ELSE
C-    this process has a working multi-threads setting

       threadIsRunning(myThid) = .TRUE.
       IF ( myThid.EQ.1 ) THEN
C-    master collects error from other MPI processes
        nChecks = 0
#ifdef ALLOW_USE_MPI
        IF ( usingMPI ) THEN
         myErr = nChecks
         CALL MPI_Allreduce( myErr,nChecks,1,MPI_INTEGER,
     &                       MPI_SUM,MPI_COMM_MODEL,mpiRC )
        ENDIF
#endif /* ALLOW_USE_MPI */
        IF ( nChecks.NE.0 ) THEN
          WRITE(msgBuf,'(A,I5,A)') 'CHECK_THREADS:', nChecks,
     &                     ' error(s) from other Processes'
          CALL PRINT_ERROR( msgBuf, myThid )
          eeBootError = .TRUE.
        ENDIF
       ENDIF
C-    ensure all threads leave with updated eeBootError (shared) value
C$OMP BARRIER

      ENDIF

#else /* ndef USE_OMP_THREADING */

      threadIsRunning(myThid) = .TRUE.
      nChecks                 = 0

   10 CONTINUE
      numberThreadsRunning = 0
      nChecks = nChecks + 1
      DO I = 1, nThreads
       IF ( threadIsRunning(I) )
     &  numberThreadsRunning = numberThreadsRunning+1
      ENDDO
      IF ( nChecks .GT. 10 ) THEN
       thError(myThid) = .TRUE.
       eeBootError     = .TRUE.
       WRITE(msgBuf,'(A,I5,A,I5,A)')
     &  'CHECK_THREADS: Only ',numberThreadsRunning,
     &  ' thread(s), ',nThreads,' are needed for this config!'
        CALL PRINT_ERROR( msgBuf, myThid )
C--     Not enough threads are running so halt the program.
C       I did not want this here but it is the only place I have found that
C       KAP deadlocks if it there are fewer threads than iterations in a BLOCKED(1)
C       loop. The deadlock appears to be in the routine mppjoin which never
C       returns. I tried putting the STOP in main or breaking out of the loop in main
C       but this causes KAP to insert a call to mppjoin - which then deadlocks!
        IF ( myThid .EQ. 1 ) THEN
         STOP 'ABNORMAL END: S/R CHECK_THREADS'
        ENDIF
       GOTO 11
      ENDIF
      IF ( numberThreadsRunning .NE. nThreads ) THEN
#ifdef HAVE_SYSTEM
       CALL SYSTEM('sleep 1')
#endif
       GOTO 10
      ENDIF
   11 CONTINUE

#endif /* ndef USE_OMP_THREADING */

C--   check barrier synchronization: 1rst (initial) call.
      IF ( .NOT. eeBootError ) THEN
        CALL BAR_CHECK( 1, myThid )
      ENDIF

      RETURN
      END

#include "GCHEM_OPTIONS.h"

CBOP
C     !ROUTINE: CFC_ATMOS
C     !INTERFACE:
      SUBROUTINE CFC_ATMOS( myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE CFC_ATMOS
C     | o read in time-series of atmoshperic CFC
C     *==========================================================*

C     !USES:
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "CFC.h"
#include "CFC_ATMOS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
C     myThid    :: My Thread Id. number
      INTEGER myThid
CEOP

#ifdef ALLOW_CFC
C     !FUNCTIONS:
      INTEGER  ILNBLNK
      EXTERNAL ILNBLNK

C     !LOCAL VARIABLES:
C     msgBuf     :: message buffer
      INTEGER iUnit, i, it, iL
      LOGICAL exst
      _RL tmpVar(5)
      CHARACTER*(MAX_LEN_MBUF) msgBuf

      _BEGIN_MASTER( myThid )

C read in CFC atmospheric timeseries data
      iL = ILNBLNK(atmCFC_inpFile)
      IF ( iL.EQ.0 ) THEN
        WRITE(msgBuf,'(A)')
     &       'CFC_ATMOS: File-name missing for atmos CFC time-series'
        CALL PRINT_ERROR( msgBuf, myThid )
       STOP 'ABNORMAL END: S/R CFC_ATMOS'
      ENDIF
      INQUIRE( FILE=atmCFC_inpFile(1:iL), EXIST=exst )
      IF (exst) THEN
       WRITE(msgBuf,'(3A)')
     &   'CFC_ATMOS: opening file "', atmCFC_inpFile(1:iL), '"'
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                     SQUEEZE_RIGHT, myThid )
      ELSE
       WRITE(msgBuf,'(3A)')
     &   'CFC_ATMOS: File "', atmCFC_inpFile(1:iL),'" does not exist!'
       CALL PRINT_ERROR( msgBuf, myThid )
       STOP 'ABNORMAL END: S/R CFC_ATMOS'
      ENDIF

C assign a free unit number as the I/O channel for this subroutine
      CALL MDSFINDUNIT( iUnit, myThid )
      OPEN(iUnit,FILE=atmCFC_inpFile(1:iL),STATUS='old')
C skip 6 descriptor lines
      DO i =1,6
        READ(iUnit,*)
      ENDDO
C Read in CFC11 and CFC12, N and S Hemisphere time histories
      it = 0
      DO WHILE ( it.LE.ACFCrecSize )
        READ(iUnit,*,END=1001) (tmpVar(i),i=1,5)
        it = it + 1
        IF ( it .LE. ACFCrecSize ) THEN
          ACFCyear(it) = tmpVar(1)
          ACFC11(it,1) = tmpVar(2)
          ACFC12(it,1) = tmpVar(3)
          ACFC11(it,2) = tmpVar(4)
          ACFC12(it,2) = tmpVar(5)
        ENDIF
      ENDDO
      IF ( it.GT.ACFCrecSize ) THEN
       CLOSE(iUnit)
       WRITE(msgBuf,'(3A)')
     &   'CFC_ATMOS: length of file "',atmCFC_inpFile(1:iL),'"'
       CALL PRINT_ERROR( msgBuf, myThid )
       WRITE(msgBuf,'(2A,I9)') 'CFC_ATMOS: exceeds max num',
     &             ' of records: ACFCrecSize=', ACFCrecSize
       CALL PRINT_ERROR( msgBuf, myThid )
       STOP 'ABNORMAL END: S/R CFC_ATMOS'
      ENDIF
 1001 CONTINUE
      CLOSE(iUnit)
      ACFCnRec = it

C--  Print values to check:
      WRITE(msgBuf,'(A,I8,A)')
     &  'CFC_ATMOS: read', ACFCnRec, ' (=ACFCnRec) time records :'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)')
     &  '  year , cfc11_N, cfc12_N, cfc11_S, cfc12_S'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      DO it = 1,ACFCnRec
        WRITE(msgBuf,'(F7.1,4F9.2)')
     &        ACFCyear(it), ACFC11(it,1),ACFC12(it,1),
     &                      ACFC11(it,2),ACFC12(it,2)
        CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
      ENDDO

      WRITE(msgBuf,'(A)')
     &  'CFC_ATMOS: Setting atmos CFC time series: done'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )

      _END_MASTER(myThid)

C--   Everyone else must wait for the parameters to be loaded
      _BARRIER

#endif /* ALLOW_CFC */

      RETURN
      END

#include "DIC_OPTIONS.h"

CBOP
C !ROUTINE: O2_SURFFORCING

C !INTERFACE: ==========================================================
      SUBROUTINE O2_SURFFORCING( PTR_O2, SGO2,
     I           bi,bj,iMin,iMax,jMin,jMax,
     I           myTime, myIter, myThid )

C !DESCRIPTION:
C Calculate the oxygen air-sea flux terms

C !USES: ===============================================================
      IMPLICIT NONE
#include "SIZE.h"
#include "DYNVARS.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "FFIELDS.h"
#include "DIC_VARS.h"

c  !INPUT PARAMETERS: ===================================================
C  PTR_O2               :: oxygen tracer field
C  myTime               :: current time
C  myIter               :: current timestep
C  myThid               :: thread number
      _RL  PTR_O2(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      INTEGER iMin,iMax,jMin,jMax, bi, bj
      _RL myTime
      INTEGER myIter, myThid

c  !OUTPUT PARAMETERS: ===================================================
C  SGO2                  :: air-sea exchange of oxygen
      _RL  SGO2(1-OLx:sNx+OLx,1-OLy:sNy+OLy)

#ifdef ALLOW_PTRACERS

#ifdef ALLOW_O2

C !LOCAL VARIABLES: ===================================================
C I, J, K - Loop counters
      INTEGER i,j,k
C Solubility relation coefficients
      _RL SchmidtNoO2(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL O2sat(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL Kwexch(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL FluxO2(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL  aTT
      _RL  aTK
      _RL  aTS
      _RL  aTS2
      _RL  aTS3
      _RL  aTS4
      _RL  aTS5
      _RL  o2s
      _RL  ttemp
      _RL  stemp
      _RL  oCnew
CEOP

      k=1

C calculate SCHMIDT NO. for O2
        DO j=jmin,jmax
          DO i=imin,imax
            IF (maskC(i,j,k,bi,bj).NE.0.) THEN
              ttemp = theta(i,j,k,bi,bj)
              stemp = salt(i,j,k,bi,bj)

              SchmidtNoO2(i,j) =
     &            sox1
     &          + sox2 * ttemp
     &          + sox3 * ttemp*ttemp
     &          + sox4 * ttemp*ttemp*ttemp

C Determine surface flux of O2
C exchange coeff accounting for ice cover and Schmidt no.
C Kwexch_Pre= pisvel*(1-fice): previously computed in dic_surfforcing.F

              Kwexch(i,j) = Kwexch_Pre(i,j,bi,bj)
     &                    / sqrt(SchmidtNoO2(i,j)/660.0 _d 0)

C determine saturation O2
C using Garcia and Gordon (1992), L&O (mistake in original ?)
              aTT  = 298.15 _d 0 -ttemp
              aTK  = 273.15 _d 0 +ttemp
              aTS  = log(aTT/aTK)
              aTS2 = aTS*aTS
              aTS3 = aTS2*aTS
              aTS4 = aTS3*aTS
              aTS5 = aTS4*aTS

              oCnew  = oA0 + oA1*aTS + oA2*aTS2 + oA3*aTS3 +
     &            oA4*aTS4 + oA5*aTS5
     &          + stemp*(oB0 + oB1*aTS + oB2*aTS2 + oB3*aTS3)
     &          + oC0*(stemp*stemp)

              o2s = EXP(oCnew)

c Convert from ml/l to mol/m^3
              O2sat(i,j) = o2s/22391.6 _d 0 * 1. _d 3

C Determine flux, inc. correction for local atmos surface pressure
              FluxO2(i,j) = Kwexch(i,j)*
     &                     (AtmosP(i,j,bi,bj)*O2sat(i,j)
     &                      - PTR_O2(i,j,k))
            ELSE
              FluxO2(i,j) = 0. _d 0
            ENDIF

          END DO
        END DO

C update surface tendencies
        DO j=jmin,jmax
          DO i=imin,imax
           SGO2(i,j)= FluxO2(i,j)
     &         *recip_drF(k) * recip_hFacC(i,j,k,bi,bj)
          ENDDO
         ENDDO
#endif
#endif

        RETURN
        END

#include "THSICE_OPTIONS.h"
#ifdef ALLOW_BULK_FORCE
# include "BULK_FORCE_OPTIONS.h"
#endif
#ifdef ALLOW_CHEAPAML
# include "CHEAPAML_OPTIONS.h"
#endif

CBOP
C     !ROUTINE: THSICE_GET_PRECIP
C     !INTERFACE:
      SUBROUTINE THSICE_GET_PRECIP(
     I                  iceMsk, locSST,
     O                  precip, snowPrc, qPrcRnO, flxSW,
     I                  iMin,iMax,jMin,jMax, bi,bj, myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R  THSICE_GET_PRECIP
C     | Interface S/R : get Precip, Snow-precip
C     |             and downward short-wave from pkg BULK_FORCE
C     |      - or - get Precip, Snow-precip from pkg cheapAML
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     == Global data ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#ifdef ALLOW_BULK_FORCE
# include "BULKF_PARAMS.h"
# include "BULKF.h"
#elif defined(ALLOW_CHEAPAML)
# include "CHEAPAML.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
C     iceMsk    :: sea-ice fraction: no ice=0, grid all ice 1  []
C     locSST    :: local Sea-Surface Temperature [deg.C]
C     precip    :: Total Precipitation (including run-off) [kg/m2/s]
C     snowPrc   :: Snow Precipitation [kg/m2/s]
C     qPrcRnO   :: Energy content of Precip+RunOff (+=down) [W/m2]
C     flxSW     :: Downward short-wave surface flux (+=down) [W/m2]
C     iMin,iMax :: range of indices of computation domain
C     jMin,jMax :: range of indices of computation domain
C     bi,bj     :: current tile indices
C     myThid      :: Thread no. that called this routine.
      _RL iceMsk (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL locSST (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL precip (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL snowPrc(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL qPrcRnO(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL flxSW  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER iMin,iMax
      INTEGER jMin,jMax
      INTEGER bi,bj
      INTEGER myThid
CEOP

#ifdef ALLOW_THSICE
#if defined(ALLOW_BULK_FORCE) || defined(ALLOW_CHEAPAML)

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C     === Local variables ===
C     i,j   :: current grid point indices
      INTEGER i,j

#ifdef ALLOW_BULK_FORCE
      IF ( useBulkforce ) THEN

       DO j = jMin, jMax
        DO i = iMin, iMax
          precip(i,j) = ( rain(i,j,bi,bj)+runoff(i,j,bi,bj) )*rhofw
          flxSW (i,j) = solar(i,j,bi,bj)
        ENDDO
       ENDDO

c      IF ( SnowFile .NE. ' ' ) THEN
c      ELSE
C     If specific snow precipitiation is not available, use
C     precipitation when ever the air temperature is below 0 degC
        DO j = jMin, jMax
         DO i = iMin, iMax
          IF ( iceMsk(i,j,bi,bj).GT.0. _d 0
     &      .AND. Tair(i,j,bi,bj).LE.Tf0kel )  THEN
             snowPrc(i,j) = rain(i,j,bi,bj)*rhofw
          ENDIF
         ENDDO
        ENDDO
c      ENDIF

       IF ( temp_EvPrRn .NE. UNSET_RL ) THEN
C--   Account for energy content of Precip + RunOff :
C     assume 1) rain has same temp as Air (higher altitude, e.g., 850.mb would
C      be better); 2) Snow has no heat capacity (+ is counted separately)
C     3) no distinction between sea-water Cp and fresh-water Cp
C     4) Run-Off comes at the temp of surface water (with same Cp)
        DO j = jMin, jMax
         DO i = iMin, iMax
          qPrcRnO(i,j) = HeatCapacity_Cp*(
     &           ( Tair(i,j,bi,bj) - Tf0kel - temp_EvPrRn )
     &          *( rain(i,j,bi,bj)*rhofw - snowPrc(i,j) )
     &         + ( locSST(i,j,bi,bj) - temp_EvPrRn )
     &          *runoff(i,j,bi,bj)*rhofw )
         ENDDO
        ENDDO
       ENDIF

C-    end if useBulkforce
      ENDIF

      IF ( useCheapAML )
     & STOP 'cannot use thsIce and CheapAML with BULK_FORCE compiled'

#elif defined(ALLOW_CHEAPAML)
      IF ( useCheapAML ) THEN

       DO j = jMin, jMax
        DO i = iMin, iMax
          precip(i,j) = cheapPrecip(i,j,bi,bj)
c    &                + runoff(i,j,bi,bj)*rhofw
        ENDDO
       ENDDO

c      IF ( SnowFile .NE. ' ' ) THEN
c      ELSE
C     If specific snow precipitiation is not available, use
C     precipitation when ever the air temperature is below 0 degC
        DO j = jMin, jMax
         DO i = iMin, iMax
          IF ( iceMsk(i,j,bi,bj).GT.0. _d 0
     &      .AND. Tair(i,j,bi,bj).LT.zeroRL )  THEN
             snowPrc(i,j) = cheapPrecip(i,j,bi,bj)
          ENDIF
         ENDDO
        ENDDO
c      ENDIF

       IF ( temp_EvPrRn .NE. UNSET_RL ) THEN
C--   Account for energy content of Precip + RunOff :
C     assume 1) rain has same temp as Air (higher altitude, e.g., 850.mb would
C      be better); 2) Snow has no heat capacity (+ is counted separately)
C     3) no distinction between sea-water Cp and fresh-water Cp
        DO j = jMin, jMax
         DO i = iMin, iMax
          qPrcRnO(i,j) = HeatCapacity_Cp*
     &           ( Tair(i,j,bi,bj) - temp_EvPrRn )
     &          *( cheapPrecip(i,j,bi,bj) - snowPrc(i,j) )
c                      + HeatCapacity_Cp*
c    &           ( locSST(i,j,bi,bj) - temp_EvPrRn )
c    &          *runoff(i,j,bi,bj)*rhofw
         ENDDO
        ENDDO
       ENDIF

C-    end if useCheapAML
      ENDIF
#endif /* if ALLOW_BULK_FORCE elif ALLOW_CHEAPAML */

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#endif /* ALLOW_BULK_FORCE or ALLOW_CHEAPAML */
#endif /* ALLOW_THSICE */

      RETURN
      END

#include "MY82_OPTIONS.h"

CBOP
C !ROUTINE: MY82_READPARMS

C !INTERFACE: ==========================================================
      SUBROUTINE MY82_READPARMS( myThid )

C !DESCRIPTION:
C     Initialize MY82 parameters, read in data.pp

C !USES: ===============================================================
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "MY82.h"

C !INPUT PARAMETERS: ===================================================
C  myThid       :: thread number
      INTEGER myThid

C !OUTPUT PARAMETERS: ==================================================
C  none

#ifdef ALLOW_MY82

C !LOCAL VARIABLES: ====================================================
C  iUnit        :: unit number for I/O
C  msgBuf       :: message buffer
      INTEGER iUnit
      CHARACTER*(MAX_LEN_MBUF) msgBuf
CEOP

      NAMELIST /MY_PARM01/
     &     MYviscMax,
     &     MYdiffMax,
     &     MYhblScale,
     &     MYdumpFreq,
     &     MYMixingMaps,
     &     MYwriteState

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      IF ( .NOT.useMY82 ) THEN
C-    pkg MY82 is not used
        _BEGIN_MASTER(myThid)
C-    Track pkg activation status:
         MYisON = .FALSE.
C     print a (weak) warning if data.my82 is found
         CALL PACKAGES_UNUSED_MSG( 'useMY82', ' ', ' ' )
        _END_MASTER(myThid)
        RETURN
      ENDIF

C This routine has been called by the main model so we set our
C internal flag to indicate we are in business
      MYisON = .TRUE.

C Set defaults values for parameters in MY82.h
      MYviscMax    = 1. _d 0
      MYdiffMax    = 1. _d 0
      MYhblScale   = 0.1 _d 0
      RiMax        = 0.1950 _d 0
      MYdumpFreq   = dumpFreq
      MYMixingMaps = .FALSE.
      MYwriteState = .FALSE.

C Open and read the data.pp file
      _BEGIN_MASTER(myThid)
      WRITE(msgBuf,'(A)') ' MY82_READPARMS: opening data.my82'
      CALL PRINT_MESSAGE(msgBuf, standardMessageUnit,
     &                   SQUEEZE_RIGHT , 1)
      CALL OPEN_COPY_DATA_FILE(
     I                   'data.my82', 'MY82_READPARMS',
     O                   iUnit,
     I                   myThid )
      READ(UNIT=iUnit,NML=MY_PARM01)
      WRITE(msgBuf,'(A)')
     &  ' MY82_READPARMS: finished reading data.my82'
      CALL PRINT_MESSAGE(msgBuf, standardMessageUnit,
     &                   SQUEEZE_RIGHT , 1)

C Close the open data file
#ifdef SINGLE_DISK_IO
      CLOSE(iUnit)
#else
      CLOSE(iUnit,STATUS='DELETE')
#endif /* SINGLE_DISK_IO */
      _END_MASTER(myThid)

C Everyone else must wait for the parameters to be loaded
      _BARRIER

C Now set-up any remaining parameters that result from the input parameters
      IF ( MYviscMax .LE. 0. ) THEN
       WRITE(msgBuf,'(A)') 'MYviscMax must be greater than zero'
       CALL PRINT_ERROR( msgBuf, myThid )
       STOP 'ABNORMAL END: S/R MY82_READPARMS'
      ENDIF
      IF ( MYdiffMax .LE. 0. ) THEN
       WRITE(msgBuf,'(A)') 'MYdiffMax must be greater than zero'
       CALL PRINT_ERROR( msgBuf, myThid )
       STOP 'ABNORMAL END: S/R MY82_READPARMS'
      ENDIF
#endif /* ALLOW_MY82 */

      RETURN
      END

!=======================================================================
      subroutine MITCOUPLER_init( 
     I                      myTypeStr, 
     O                      MPI_COMM_local, msgUnit )
      implicit none

! MPI variables
#include "mpif.h"

! Predefined constants/arrays
#include "CPLR_SIG.h"

! Arguments
      character*(*) myTypeStr
      integer MPI_COMM_local
      integer msgUnit

! Functions

! Local
      logical couplerFlag

!     ------------------------------------------------------------------

! Homogeneous registration phase (every process Bcasts)
!  also open a coupling log file (.clog) with I/O unit: LogUnit
      couplerFlag = .TRUE.
      call MITCPLR_init1( myTypeStr, couplerFlag )
      msgUnit = LogUnit

! Return the communicator for my component
      MPI_COMM_local = MPI_COMM_mylocal

! Heterogeneous registration phase (within component incl. coupler)
      call mitcplr_init2b( myTypeStr )

!     ------------------------------------------------------------------
      return
      end
!=======================================================================

#include "PP81_OPTIONS.h"

      SUBROUTINE PP81_CHECK( myThid )
C     /==========================================================\
C     | SUBROUTINE PP81_CHECK                                    |
C     | o Validate basic package setup and inter-package         |
C     | dependencies.                                            |
C     \==========================================================/
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"

C     === Routine arguments ===
C     myThid -  Number of this instance of PP81_CHECK
      INTEGER myThid

#ifdef ALLOW_PP81

C     === Local variables ===
C     msgBuf      - Informational/error meesage buffer
      CHARACTER*(MAX_LEN_MBUF) msgBuf

      WRITE(msgBuf,'(A)') 'PP81_CHECK: #define ALLOW_PP81'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &     SQUEEZE_RIGHT , 1)

C     So far, PP81 works only with oceanic z-coordinates
      IF ( buoyancyRelation .NE. 'OCEANIC' ) THEN
         WRITE(msgBuf,'(A)')
     &      'PP81 works only with buoyancyRelation = ''OCEANIC'''
         CALL PRINT_ERROR( msgBuf , 1)
         STOP 'ABNORMAL END: S/R PP81_CHECK'
      ENDIF

C     PP81 needs convection turned off (will be packaged later)
      IF (cAdjFreq.NE.0.  .OR.
     &     ivdc_kappa.NE.0. ) THEN
         WRITE(msgBuf,'(A)') 'Some form of convection has been enabled'
         CALL PRINT_ERROR( msgBuf , 1)
         STOP 'ABNORMAL END: S/R PP81_CHECK'
      ENDIF

      IF ( useKPP ) THEN
         WRITE(msgBuf,'(A)')
     &      'PP81 and KPP cannot be turned on at the same time'
         CALL PRINT_ERROR( msgBuf , 1)
         STOP 'ABNORMAL END: S/R PP81_CHECK'
      ENDIF

C     PP81 needs implicit vertical diffusion and viscosity
      IF (.NOT.implicitDiffusion ) THEN
         WRITE(msgBuf,'(A)') 
     &      'PP81 needs implicitDiffusion to be enabled'
         CALL PRINT_ERROR( msgBuf , 1)
         STOP 'ABNORMAL END: S/R PP81_CHECK'
      ENDIF
      IF (.NOT.implicitViscosity) THEN
         WRITE(msgBuf,'(A)') 
     &      'PP81 needs implicitViscosity to be enabled'
         CALL PRINT_ERROR( msgBuf , 1)
         STOP 'ABNORMAL END: S/R PP81_CHECK'
      ENDIF

#endif /* ALLOW_PP81 */

      return
      end

#include "LAND_OPTIONS.h"

CBOP
C     !ROUTINE: LAND_DIAGNOSTICS
C     !INTERFACE:
      SUBROUTINE LAND_ALBEDO( 
     I                land_frc, grnd_alb,
     O                alb_land,
     I                bi,bj, myTime, myIter, myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R LAND_ALBEDO
C     | o Calculate snow albedo over land
C     *==========================================================*
C     \ev
 
C     !USES:
      IMPLICIT NONE

C     == Global variables ===
C-- size for MITgcm & Land package :
#include "LAND_SIZE.h"

#include "EEPARAMS.h"
#include "PARAMS.h"
#include "LAND_PARAMS.h"
#include "LAND_VARS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     land_frc :: land fraction [0-1]
C     grnd_alb :: ground albedo [0-1]
C     alb_land :: albedo of land (including snow effect) [0-1]
C     bi,bj    :: Tile index
C     myTime   :: Current time of simulation ( s )
C     myIter   :: Current iteration number in simulation
C     myThid   :: Number of this instance of the routine
      _RS land_frc(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RS grnd_alb(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL alb_land(sNx,sNy)
      INTEGER bi, bj, myIter, myThid
      _RL     myTime
CEOP

#ifdef ALLOW_LAND

C     == Local Variables == 
C     i,j      :: Loop counters
C     albSnow  :: albedo of snow
C     ageSnow  :: age of snow [days]
      INTEGER i,j
      _RL albSnow, ageSnow, hSnow, Tsf

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C-     Compute albedo of snow and then albedo of land.

        DO j=1,sNy
         DO i=1,sNx
          alb_land(i,j) = grnd_alb(i,j,bi,bj)
          IF ( land_frc(i,j,bi,bj).GT.0. ) THEN
           Tsf = land_skinT(i,j,bi,bj)
C       snow age  (units = days):
           ageSnow = land_snowAge(i,j,bi,bj)/86400. _d 0
           hSnow = land_hSnow(i,j,bi,bj)

C--------------------------------------------
C--- taken from thsice/thsice_albedo.F :
C-    New snow: (linear) transition between tempSnowAlbL (oC) and 0.oC
C      from cold/dry snow albedo to warm/wet snow albedo
           IF ( tempSnowAlbL.LT.0. _d 0 ) THEN
               albSnow = albColdSnow
     &         + (albWarmSnow - albColdSnow)
     &         *MAX( 0. _d 0, MIN(1. _d 0 - Tsf/tempSnowAlbL, 1. _d 0) )
           ELSE
               albSnow = albColdSnow
           ENDIF
C-    albedo of snow is function of snow-age
           albSnow = albOldSnow
     &       +(albSnow-albOldSnow)*exp(-0.2 _d 0*ageSnow)

C-    layer of snow over the ground:
           alb_land(i,j) = albSnow 
     &       +(alb_land(i,j)-albSnow)*exp(-hSnow/hAlbSnow)
C--------------------------------------------
          ENDIF
         ENDDO
        ENDDO

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#endif /* ALLOW_LAND */

      RETURN
      END

#include "PACKAGES_CONFIG.h"
#include "CPP_EEOPTIONS.h"

C--  File exch_tap_b.F: Tapenade Adjoint (Backward) EXCH1 routines
C--   Contents
C--   o  EXCH1_UV_RL_CUBE_B
C--   o  EXCH1_UV_RS_CUBE_B
C--   o  EXCH1_RL_CUBE_B
C--   o  EXCH1_RL_CUBE_FWD (for adjoint without checkpointing)
C--   o  EXCH1_RL_CUBE_BWD (for adjoint without checkpointing)
C--   o  EXCH1_RS_CUBE_B
C--   o  EXCH1_RL_B
C--   o  EXCH1_RL_FWD (for adjoint without checkpointing)
C--   o  EXCH1_RL_BWD (for adjoint without checkpointing)
C--   o  EXCH1_RS_B
C--   o  EXCH1_RS_FWD (for adjoint without checkpointing)
C--   o  EXCH1_RS_BWD (for adjoint without checkpointing)

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      SUBROUTINE EXCH1_UV_RL_CUBE_B(
     U                          Uarray, Uarrayb, Varray, Varrayb,
     I                          withSigns,
     I                          myOLw, myOLe, myOLs, myOLn,
     I                          myNz, exchwidthx,exchWidthY,
     I                          cornerMode, myThid )
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"

      INTEGER myOLw, myOLe, myOLs, myOLn, myNz
      _RL     Uarray( 1-myOLw:sNx+myOLe,
     &                1-myOLs:sNy+myOLn,
     &                myNz, nSx, nSy )
      _RL     Uarrayb( 1-myOLw:sNx+myOLe,
     &                1-myOLs:sNy+myOLn,
     &                myNz, nSx, nSy )
      _RL     Varray( 1-myOLw:sNx+myOLe,
     &                1-myOLs:sNy+myOLn,
     &                myNz, nSx, nSy )
      _RL     Varrayb( 1-myOLw:sNx+myOLe,
     &                1-myOLs:sNy+myOLn,
     &                myNz, nSx, nSy )
      LOGICAL withSigns
      INTEGER exchWidthX
      INTEGER exchWidthY
      INTEGER cornerMode
      INTEGER myThid

      CALL EXCH1_UV_RL_CUBE_AD(
     U                 Uarrayb, Varrayb,
     I                 withSigns,
     I                 myOLw, myOLe, myOLs, myOLn, myNz,
     I                 exchWidthX, exchWidthY,
     I                 cornerMode, myThid )

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      SUBROUTINE EXCH1_UV_RS_CUBE_B(
     U                          Uarray, Uarrayb, Varray, Varrayb,
     I                          withSigns,
     I                          myOLw, myOLe, myOLs, myOLn,
     I                          myNz, exchwidthx,exchWidthY,
     I                          cornerMode, myThid )
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"

      INTEGER myOLw, myOLe, myOLs, myOLn, myNz
      _RS     Uarray( 1-myOLw:sNx+myOLe,
     &                1-myOLs:sNy+myOLn,
     &                myNz, nSx, nSy )
      _RS     Uarrayb( 1-myOLw:sNx+myOLe,
     &                1-myOLs:sNy+myOLn,
     &                myNz, nSx, nSy )
      _RS     Varray( 1-myOLw:sNx+myOLe,
     &                1-myOLs:sNy+myOLn,
     &                myNz, nSx, nSy )
      _RS     Varrayb( 1-myOLw:sNx+myOLe,
     &                1-myOLs:sNy+myOLn,
     &                myNz, nSx, nSy )
      LOGICAL withSigns
      INTEGER exchWidthX
      INTEGER exchWidthY
      INTEGER cornerMode
      INTEGER myThid

      CALL EXCH1_UV_RS_CUBE_AD(
     U                 Uarrayb, Varrayb,
     I                 withSigns,
     I                 myOLw, myOLe, myOLs, myOLn, myNz,
     I                 exchWidthX, exchWidthY,
     I                 cornerMode, myThid )

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      SUBROUTINE EXCH1_RL_CUBE_B(
     U                 array, arrayb,
     I                 withSigns,
     I                 myOLw, myOLe, myOLs, myOLn, myNz,
     I                 exchWidthX, exchWidthY,
     I                 cornerMode, myThid )
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"

      INTEGER myOLw, myOLe, myOLs, myOLn, myNz
      _RL     array( 1-myOLw:sNx+myOLe,
     &               1-myOLs:sNy+myOLn,
     &               myNz, nSx, nSy )
      _RL     arrayb( 1-myOLw:sNx+myOLe,
     &               1-myOLs:sNy+myOLn,
     &               myNz, nSx, nSy )
      LOGICAL withSigns
      INTEGER exchWidthX
      INTEGER exchWidthY
      INTEGER cornerMode
      INTEGER myThid

      CALL EXCH1_RL_CUBE_AD(
     U                 arrayb,
     I                 withSigns,
     I                 myOLw, myOLe, myOLs, myOLn, myNz,
     I                 exchWidthX, exchWidthY,
     I                 cornerMode, myThid )

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      SUBROUTINE EXCH1_RL_CUBE_FWD(
     U                 array,
     I                 withSigns,
     I                 myOLw, myOLe, myOLs, myOLn, myNz,
     I                 exchWidthX, exchWidthY,
     I                 cornerMode, myThid )
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"

      INTEGER myOLw, myOLe, myOLs, myOLn, myNz
      _RL     array( 1-myOLw:sNx+myOLe,
     &               1-myOLs:sNy+myOLn,
     &               myNz, nSx, nSy )
      LOGICAL withSigns
      INTEGER exchWidthX
      INTEGER exchWidthY
      INTEGER cornerMode
      INTEGER myThid

#ifdef ALLOW_TAPENADE
c [llh] the following PUSHREAL8ARRAY could certainly be refined!
c [ssg] for halfpipe_streamice
c      CALL PUSHREAL8ARRAY(array, 26**2*2)
c [ssg] for tutorial_global_oce_biogeo
      CALL PUSHBOOLEAN(withSigns)
      CALL PUSHINTEGER4(myOLw)
      CALL PUSHINTEGER4(myOLe)
      CALL PUSHINTEGER4(myOLs)
      CALL PUSHINTEGER4(myOLn)
      CALL PUSHINTEGER4(myNz)
      CALL PUSHINTEGER4(exchWidthX)
      CALL PUSHINTEGER4(exchWidthY)
      CALL PUSHINTEGER4(cornerMode)
      CALL PUSHINTEGER4(myThid)
      CALL EXCH1_RL_CUBE(
     U                 array,
     I                 withSigns,
     I                 myOLw, myOLe, myOLs, myOLn, myNz,
     I                 exchWidthX, exchWidthY,
     I                 cornerMode, myThid )
#endif

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      SUBROUTINE EXCH1_RL_CUBE_BWD(
     U                 array, arrayb,
     I                 withSigns,
     I                 myOLw, myOLe, myOLs, myOLn, myNz,
     I                 exchWidthX, exchWidthY,
     I                 cornerMode, myThid )
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"

      INTEGER myOLw, myOLe, myOLs, myOLn, myNz
      _RL     array( 1-myOLw:sNx+myOLe,
     &               1-myOLs:sNy+myOLn,
     &               myNz, nSx, nSy )
      _RL     arrayb( 1-myOLw:sNx+myOLe,
     &               1-myOLs:sNy+myOLn,
     &               myNz, nSx, nSy )
      LOGICAL withSigns
      INTEGER exchWidthX
      INTEGER exchWidthY
      INTEGER cornerMode
      INTEGER myThid

#ifdef ALLOW_TAPENADE
      CALL POPBOOLEAN(withSigns)
      CALL POPINTEGER4(myOLw)
      CALL POPINTEGER4(myOLe)
      CALL POPINTEGER4(myOLs)
      CALL POPINTEGER4(myOLn)
      CALL POPINTEGER4(myNz)
      CALL POPINTEGER4(exchWidthX)
      CALL POPINTEGER4(exchWidthY)
      CALL POPINTEGER4(cornerMode)
      CALL POPINTEGER4(myThid)
      CALL EXCH1_RL_CUBE_AD(
     U                 arrayb,
     I                 withSigns,
     I                 myOLw, myOLe, myOLs, myOLn, myNz,
     I                 exchWidthX, exchWidthY,
     I                 cornerMode, myThid )
c [ssg] for halfpipe_streamice
c      CALL POPREAL8ARRAY(array, 26**2*2)
c [ssg] for tutorial_global_oce_biogeo
#endif

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      SUBROUTINE EXCH1_RS_CUBE_B(
     U                 array, arrayb,
     I                 withSigns,
     I                 myOLw, myOLe, myOLs, myOLn, myNz,
     I                 exchWidthX, exchWidthY,
     I                 cornerMode, myThid )
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"

      INTEGER myOLw, myOLe, myOLs, myOLn, myNz
      _RS     array( 1-myOLw:sNx+myOLe,
     &               1-myOLs:sNy+myOLn,
     &               myNz, nSx, nSy )
      _RS     arrayb( 1-myOLw:sNx+myOLe,
     &               1-myOLs:sNy+myOLn,
     &               myNz, nSx, nSy )
      LOGICAL withSigns
      INTEGER exchWidthX
      INTEGER exchWidthY
      INTEGER cornerMode
      INTEGER myThid

      CALL EXCH1_RS_CUBE_AD(
     U                 arrayb,
     I                 withSigns,
     I                 myOLw, myOLe, myOLs, myOLn, myNz,
     I                 exchWidthX, exchWidthY,
     I                 cornerMode, myThid )

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      SUBROUTINE EXCH1_RL_B(array, arrayb,
     &        myOLw, myOLe, myOLs, myOLn,  myNz,
     &        exchWidthX, exchWidthY, cornerMode, myThid)
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "EXCH.h"
      INTEGER myOLw, myOLe, myOLs, myOLn, myNz
      _RL     array( 1-myOLw:sNx+myOLe,
     &               1-myOLs:sNy+myOLn,
     &               myNz, nSx, nSy )
      _RL     arrayb( 1-myOLw:sNx+myOLe,
     &               1-myOLs:sNy+myOLn,
     &               myNz, nSx, nSy )
      INTEGER exchWidthX
      INTEGER exchWidthY
      INTEGER cornerMode
      INTEGER myThid

      CALL EXCH1_RL_AD(arrayb,myOLw, myOLe, myOLs, myOLn,
     &     myNz, exchWidthX , exchWidthY, cornerMode, myThid )

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      SUBROUTINE EXCH1_RL_FWD(array,
     &        myOLw, myOLe, myOLs, myOLn,  myNz,
     &        exchWidthX, exchWidthY, cornerMode, myThid)
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "EXCH.h"
      INTEGER myOLw, myOLe, myOLs, myOLn, myNz
      _RL     array( 1-myOLw:sNx+myOLe,
     &               1-myOLs:sNy+myOLn,
     &               myNz, nSx, nSy )
      INTEGER exchWidthX
      INTEGER exchWidthY
      INTEGER cornerMode
      INTEGER myThid

#ifdef ALLOW_TAPENADE
c [llh] the following PUSHREAL8ARRAY could certainly be refined!
c [ssg] for halfpipe_streamice
c      CALL PUSHREAL8ARRAY(array, 26**2*2)
c [ssg] for tutorial_global_oce_biogeo
      CALL PUSHINTEGER4(myOLw)
      CALL PUSHINTEGER4(myOLe)
      CALL PUSHINTEGER4(myOLs)
      CALL PUSHINTEGER4(myOLn)
      CALL PUSHINTEGER4(myNz)
      CALL PUSHINTEGER4(exchWidthX)
      CALL PUSHINTEGER4(exchWidthY)
      CALL PUSHINTEGER4(cornerMode)
      CALL PUSHINTEGER4(myThid)
      CALL EXCH1_RL(array, myOLw, myOLe, myOLs, myOLn,
     &     myNz, exchWidthX , exchWidthY, cornerMode, myThid )
#endif

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      SUBROUTINE EXCH1_RL_BWD(array, arrayb,
     &        myOLw, myOLe, myOLs, myOLn,  myNz,
     &        exchWidthX, exchWidthY, cornerMode, myThid)
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "EXCH.h"
      INTEGER myOLw, myOLe, myOLs, myOLn, myNz
      _RL     array( 1-myOLw:sNx+myOLe,
     &               1-myOLs:sNy+myOLn,
     &               myNz, nSx, nSy )
      _RL     arrayb( 1-myOLw:sNx+myOLe,
     &               1-myOLs:sNy+myOLn,
     &               myNz, nSx, nSy )
      INTEGER exchWidthX
      INTEGER exchWidthY
      INTEGER cornerMode
      INTEGER myThid
#ifdef ALLOW_TAPENADE
      INTEGER tempCM

      CALL POPINTEGER4(myThid)
      CALL POPINTEGER4(tempCM)
      CALL POPINTEGER4(exchWidthY)
      CALL POPINTEGER4(exchWidthX)
      CALL POPINTEGER4(myNz)
      CALL POPINTEGER4(myOLn)
      CALL POPINTEGER4(myOLs)
      CALL POPINTEGER4(myOLe)
      CALL POPINTEGER4(myOLw)
      CALL EXCH1_RL_AD(arrayb, myOLw, myOLe, myOLs, myOLn,
     &     myNz, exchWidthX , exchWidthY, tempCM, myThid )
c [ssg] for halfpipe_streamice
c      CALL POPREAL8ARRAY(array, 26**2*2)
c [ssg] for tutorial_global_oce_biogeo
#endif

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      SUBROUTINE EXCH1_RS_B(array, arrayb,
     &      myOLw, myOLe,  myOLs, myOLn,  myNz,
     &      exchWidthX, exchWidthY,
     &      cornerMode, myThid)
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "EXCH.h"
      INTEGER myOLw, myOLe, myOLs, myOLn, myNz
      _RS     array( 1-myOLw:sNx+myOLe,
     &               1-myOLs:sNy+myOLn,
     &               myNz, nSx, nSy )
      _RS     arrayb( 1-myOLw:sNx+myOLe,
     &               1-myOLs:sNy+myOLn,
     &               myNz, nSx, nSy )
      INTEGER exchWidthX
      INTEGER exchWidthY
      INTEGER cornerMode
      INTEGER myThid

      CALL EXCH1_RS_AD(arrayb, myOLw, myOLe, myOLs,
     &     myOLn, myNz, exchWidthX, exchWidthY,
     &     cornerMode, myThid)

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      SUBROUTINE EXCH1_RS_FWD(array,
     &        myOLw, myOLe, myOLs, myOLn,  myNz,
     &        exchWidthX, exchWidthY, cornerMode, myThid)
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "EXCH.h"
      INTEGER myOLw, myOLe, myOLs, myOLn, myNz
      _RS     array( 1-myOLw:sNx+myOLe,
     &               1-myOLs:sNy+myOLn,
     &               myNz, nSx, nSy )
      INTEGER exchWidthX
      INTEGER exchWidthY
      INTEGER cornerMode
      INTEGER myThid

#ifdef ALLOW_TAPENADE
c [llh] the following PUSHREAL8ARRAY could certainly be refined!
c [ssg] for halfpipe_streamice
c      CALL PUSHREAL8ARRAY(array, 26**2*2)
c [ssg] for tutorial_global_oce_biogeo
      CALL PUSHINTEGER4(myOLw)
      CALL PUSHINTEGER4(myOLe)
      CALL PUSHINTEGER4(myOLs)
      CALL PUSHINTEGER4(myOLn)
      CALL PUSHINTEGER4(myNz)
      CALL PUSHINTEGER4(exchWidthX)
      CALL PUSHINTEGER4(exchWidthY)
      CALL PUSHINTEGER4(cornerMode)
      CALL PUSHINTEGER4(myThid)
      CALL EXCH1_RS(array, myOLw, myOLe, myOLs, myOLn,
     &     myNz, exchWidthX , exchWidthY, cornerMode, myThid )
#endif

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      SUBROUTINE EXCH1_RS_BWD(array, arrayb,
     &        myOLw, myOLe, myOLs, myOLn,  myNz,
     &        exchWidthX, exchWidthY, cornerMode, myThid)
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "EXCH.h"
      INTEGER myOLw, myOLe, myOLs, myOLn, myNz
      _RS     array( 1-myOLw:sNx+myOLe,
     &               1-myOLs:sNy+myOLn,
     &               myNz, nSx, nSy )
      _RS     arrayb( 1-myOLw:sNx+myOLe,
     &               1-myOLs:sNy+myOLn,
     &               myNz, nSx, nSy )
      INTEGER exchWidthX
      INTEGER exchWidthY
      INTEGER cornerMode
      INTEGER myThid
#ifdef ALLOW_TAPENADE
      INTEGER tempCM

      CALL POPINTEGER4(myThid)
      CALL POPINTEGER4(tempCM)
      CALL POPINTEGER4(exchWidthY)
      CALL POPINTEGER4(exchWidthX)
      CALL POPINTEGER4(myNz)
      CALL POPINTEGER4(myOLn)
      CALL POPINTEGER4(myOLs)
      CALL POPINTEGER4(myOLe)
      CALL POPINTEGER4(myOLw)
      CALL EXCH1_RS_AD(arrayb, myOLw, myOLe, myOLs, myOLn,
     &     myNz, exchWidthX , exchWidthY, cornerMode, myThid )
c [ssg] for tutorial_global_oce_biogeo
#endif

      RETURN
      END

#include "MNC_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 0
C     !ROUTINE: MNC_DUMP

C     !INTERFACE:
      SUBROUTINE MNC_DUMP( myThid )

C     !DESCRIPTION:
C     Create a short (usually incomplete) summary of the current state
C     of the MNC lookup tables.  This can be helpful for debugging MNC.
      
C     !INPUT PARAMETERS:
      INTEGER myThid
CEOP
      CALL MNC_DUMP_ALL(5, 20, myThid)
      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 1
C     !ROUTINE: MNC_DUMP_ALL

C     !INTERFACE:
      SUBROUTINE MNC_DUMP_ALL( n_id, n_items, myThid )

C     !DESCRIPTION:
C     Create a summary of a specified portion of the current state of
C     the MNC lookup tables.  This can be helpful for debugging MNC.

C     !USES:
#include "MNC_COMMON.h"

C     !INPUT PARAMETERS:
      integer n_id, n_items, myThid
CEOP

C     !LOCAL VARIABLES:
      integer i,j

      write(*,*) 'mnc_f_names :'
      DO i = 1,n_id
        write(*,'(i3,a,a40)') i,':', mnc_f_names(i)(1:40)
      ENDDO
      write(*,*) 'mnc_g_names :'
      DO i = 1,n_id
        write(*,'(i3,a,a40)') i,':', mnc_g_names(i)(1:40)
      ENDDO
      write(*,*) 'mnc_v_names :'
      DO i = 1,n_id
        write(*,'(i3,a,a40)') i,':', mnc_v_names(i)(1:40)
      ENDDO
      write(*,*) 'mnc_d_names :'
      DO i = 1,n_id
        write(*,'(i3,a,a40)') i,':', mnc_d_names(i)(1:40)
      ENDDO

      write(*,*) 'mnc_d_ids, mnc_d_size :'
      DO i = 1,n_id
        write(*,*) i,': ',mnc_d_ids(i), mnc_d_size(i)
      ENDDO

      write(*,*) 'mnc_f_info :'
      DO i = 1,n_id
        write(*,*) i,': ',(mnc_f_info(i,j), j=1,n_items)
      ENDDO
      write(*,*) 'mnc_fd_ind :'
      DO i = 1,n_id
        write(*,*) i,': ',(mnc_fd_ind(i,j), j=1,n_items)
      ENDDO
      write(*,*) 'mnc_fv_ids :'
      DO i = 1,n_id
        write(*,*) i,': ',(mnc_fv_ids(i,j), j=1,n_items)
      ENDDO
      write(*,*) 'mnc_f_alld :'
      DO i = 1,n_id
        write(*,*) i,': ',(mnc_f_alld(i,j), j=1,n_items)
      ENDDO

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#include "MOM_COMMON_OPTIONS.h"

CBOP
C !ROUTINE: MOM_VISC_QGL_STRETCH

C !INTERFACE: ==========================================================
      SUBROUTINE MOM_VISC_QGL_STRETCH(
     I                                 bi, bj, k,
     O                                 stretching, Nsquare,
     I                                 myTime, myIter, myThid )

C     !DESCRIPTION:
C     *==========================================================*
C     | SUBROUTINE MOM_VISC_QGL_STRETCH
C     | Calculates the stratification and vortex stretching terms
C     | for the Quasi-Geostrophic implementation of Leith
C     | dynamic viscosity.
C     | At the upper and lower boundaries, the stratification is
C     | assumed constant. This means that 'stretching' is
C     | dictated by the buoyancy difference between the
C     | boundary cell and its vertical neighbour.
C     *==========================================================*

C !USES: ===============================================================
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "DYNVARS.h"
c#include "MOM_VISC.h"

C !INPUT PARAMETERS: ===================================================
C  bi,bj                :: tile indices
C  k                    :: vertical level
C  myTime               :: current time of simulation ( s )
C  myIter               :: current iteration number of simulation
C  myThid               :: my Thread Id number
      INTEGER bi,bj, k
      _RL     myTime
      INTEGER myIter
      INTEGER myThid

C !OUTPUT PARAMETERS: ==================================================
C  stretching           :: vortex stretching contribution, calculated at
C                          cell centre, except near top and bottom, when
C                          it is calculated at cell face, but assumed to
C                          reside at cell centre.
C  Nsquare              :: buoyancy frequency, averaged to cell centre,
C                          except near top and bottom, when constant
C                          stratification is assumed, and it is copied
C                          to cell centre.
      _RL stretching(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL Nsquare(1-OLx:sNx+OLx,1-OLy:sNy+OLy)

#ifdef ALLOW_LEITH_QG

C !LOCAL VARIABLES: ====================================================
      INTEGER i, j
      INTEGER iMin, iMax
      INTEGER jMin, jMax

      _RL QGL_epsil

      _RL kernel_1(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL kernel_2(1-OLx:sNx+OLx,1-OLy:sNy+OLy)

      _RL buoy(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL buoy_m1(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL buoy_p1(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL buoy_1(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL buoy_2(1-OLx:sNx+OLx,1-OLy:sNy+OLy)

      _RL Nsquarep1

CEOP

      DO j=1-OLy,sNy+OLy
       DO i=1-OLx,sNx+OLx
        kernel_1(i,j)   = 0. _d 0
        kernel_2(i,j)   = 0. _d 0
        buoy(i,j)       = 0. _d 0
        buoy_m1(i,j)    = 0. _d 0
        buoy_p1(i,j)    = 0. _d 0
        buoy_1(i,j)     = 0. _d 0
        buoy_2(i,j)     = 0. _d 0
        stretching(i,j) = 0. _d 0
        Nsquare(i,j)    = 0. _d 0
       ENDDO
      ENDDO

      QGL_epsil = 1. _d -12
      Nsquarep1 = 0. _d 0

C use sigmaRfield, rhoInSitu from common block DYNVARS.h
C sigmaRfield is correctly masked, so no need to mask Nsquare

      iMin = 1-OLx
      iMax = sNx+OLx
      jMin = 1-OLy
      jMax = sNy+OLy

      DO j=jMin,jMax
        DO i=iMin,iMax
          IF (k.GT.kSurfC(i,j,bi,bj) .AND.
     &                 k.LT.kLowC(i,j,bi,bj)) THEN
C           In the ocean interior. Standard calculation.

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C              buoyancy
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
            buoy(i,j)    = gravity*gravitySign*recip_rhoConst*
     &                       rhoInSitu(i,j,k,bi,bj)
            buoy_m1(i,j) = gravity*gravitySign*recip_rhoConst*
     &                       rhoInSitu(i,j,k-1,bi,bj)
            buoy_p1(i,j) = gravity*gravitySign*recip_rhoConst*
     &                       rhoInSitu(i,j,k+1,bi,bj)

C           Interpolate buoyancy to upper and lower cell faces.
C           (same location as Nsquare is calculated)
            buoy_1(i,j)= halfRL * (buoy(i,j) + buoy_m1(i,j))
            buoy_2(i,j)= halfRL * (buoy(i,j) + buoy_p1(i,j))

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C              (f/N^2) * b
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
            Nsquare(i,j) = gravity*gravitySign*recip_rhoConst
     &                  * sigmaRfield(i,j,k,bi,bj)
            Nsquarep1    = gravity*gravitySign*recip_rhoConst
     &                  * sigmaRfield(i,j,k+1,bi,bj)

            kernel_1(i,j) = (fCori(i,j,bi,bj)/
     &                     MAX(Nsquare(i,j),QGL_epsil))*
     &                        buoy_1(i,j)
            kernel_2(i,j)=(fCori(i,j,bi,bj)/
     &                     MAX(Nsquarep1,QGL_epsil))*
     &                        buoy_2(i,j)

C           Average Nsquare to cell centre for use in
C           MOM_VISC_QGL_LIMIT
            Nsquare(i,j) = halfRL * ( Nsquare(i,j) + Nsquarep1 )

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C              d/dz of it
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
            stretching(i,j)= maskC(i,j,k,bi,bj)
     &                *recip_drF(k)*rkSign
     &                *(kernel_2(i,j)-kernel_1(i,j))

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
          ELSEIF (k.EQ.kSurfC(i,j,bi,bj) .AND.
     &                 k.EQ.kLowC(i,j,bi,bj)) THEN
C           Ocean only has one level. There is no possibility
C           for vertical stratification. Fail gracefully.
            stretching(i,j) = 0. _d 0

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
          ELSEIF (k.EQ.kSurfC(i,j,bi,bj) .AND.
     &                 k.LT.kLowC(i,j,bi,bj)) THEN
C           Ocean has at least two levels - currently in the uppermost one.
C           Use stratification from k+1, and assume it is constant.

C           buoyancy
            buoy(i,j)    = gravity*gravitySign*recip_rhoConst*
     &                       rhoInSitu(i,j,k,bi,bj)
            buoy_p1(i,j) = gravity*gravitySign*recip_rhoConst*
     &                       rhoInSitu(i,j,k+1,bi,bj)

C           Assuming constant stratification, so no need to
C           interpolate these.

C           (f/N^2) * b
            Nsquarep1    = gravity*gravitySign*recip_rhoConst
     &                  * sigmaRfield(i,j,k+1,bi,bj)

            kernel_1(i,j) = (fCori(i,j,bi,bj)/
     &                     MAX(Nsquarep1,QGL_epsil))*
     &                        buoy(i,j)
            kernel_2(i,j)=(fCori(i,j,bi,bj)/
     &                     MAX(Nsquarep1,QGL_epsil))*
     &                        buoy_p1(i,j)

C           Average Nsquare to cell centre for use in
C           MOM_VISC_QGL_LIMIT
C           (have assumed constant stratification, so
C           just assign it)
            Nsquare(i,j) = Nsquarep1

C           d/dz of it
            stretching(i,j)= maskC(i,j,k,bi,bj)
     &                *recip_drC(k+1)*rkSign
     &                *(kernel_2(i,j)-kernel_1(i,j))

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
          ELSEIF (k.GT.kSurfC(i,j,bi,bj) .AND.
     &                 k.EQ.kLowC(i,j,bi,bj)) THEN
C         Ocean has at least two levels - currently in the lowest one.
C         Use stratification from this level, and assume it is constant.

C           buoyancy
            buoy(i,j)    = gravity*gravitySign*recip_rhoConst*
     &                       rhoInSitu(i,j,k,bi,bj)
            buoy_m1(i,j) = gravity*gravitySign*recip_rhoConst*
     &                       rhoInSitu(i,j,k-1,bi,bj)

C           Assuming constant stratification, so no need to
C           interpolate these.

C           (f/N^2) * b
            Nsquare(i,j) = gravity*gravitySign*recip_rhoConst
     &                  * sigmaRfield(i,j,k,bi,bj)

            kernel_1(i,j) = (fCori(i,j,bi,bj)/
     &                     MAX(Nsquare(i,j),QGL_epsil))*
     &                        buoy_m1(i,j)
            kernel_2(i,j)=(fCori(i,j,bi,bj)/
     &                     MAX(Nsquare(i,j),QGL_epsil))*
     &                        buoy(i,j)

C           Average Nsquare to cell centre for use in
C           MOM_VISC_QGL_LIMIT
C           (have assumed constant stratification, so
C           no need to do anything)

C           d/dz of it
            stretching(i,j)= maskC(i,j,k,bi,bj)
     &                *recip_drC(k)*rkSign
     &                *(kernel_2(i,j)-kernel_1(i,j))

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
          ELSE
C           Not in the ocean (probably in an ice shelf)
C           Do nothing - stretching should be zero
            stretching(i,j) = 0. _d 0

          ENDIF

        ENDDO
      ENDDO

#endif /* ALLOW_LEITH_QG */

      RETURN
      END

#include "ATM_PHYS_OPTIONS.h"
C--  File atm_phys_tendency_apply.F: Routines to apply ATM_PHYS tendencies
C--   Contents
C--   o ATM_PHYS_TENDENCY_APPLY_U
C--   o ATM_PHYS_TENDENCY_APPLY_V
C--   o ATM_PHYS_TENDENCY_APPLY_T
C--   o ATM_PHYS_TENDENCY_APPLY_S

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 0
C !ROUTINE: ATM_PHYS_TENDENCY_APPLY_U

C !INTERFACE:
      SUBROUTINE ATM_PHYS_TENDENCY_APPLY_U(
     U                    gU_arr,
     I                    iMin,iMax,jMin,jMax, k, bi, bj,
     I                    myTime, myIter, myThid )

C     !DESCRIPTION:
C     Add AtmPhys tendency terms to U tendency.  Routine works for one
C     level at a time. Assumes that U and V tendencies are on A-Grid

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "DYNVARS.h"
#include "FFIELDS.h"
#include "ATM_PHYS_PARAMS.h"
#include "ATM_PHYS_VARS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     gU_arr    :: the tendency array
C     iMin,iMax :: Working range of x-index for applying forcing.
C     jMin,jMax :: Working range of y-index for applying forcing.
C     k         :: Current vertical level index
C     bi,bj     :: Current tile indices
C     myTime    :: Current time in simulation
C     myIter    :: Current iteration number
C     myThid    :: my Thread Id number
      _RL     gU_arr(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER iMin, iMax, jMin, jMax
      INTEGER k, bi, bj
      _RL     myTime
      INTEGER myIter
      INTEGER myThid
CEOP

C     !LOCAL VARIABLES:
      INTEGER i, j
      _RL damp_dKE(1-OLx:sNx+OLx,1-OLy:sNy+OLy)

      IF ( atmPhys_addTendU ) THEN

C--   Assume Agrid position:
        DO j=jMin,jMax
         DO i=iMin,iMax
          gU_arr(i,j) = gU_arr(i,j)
     &      + halfRL *( atmPhys_dU(i-1,j,k,bi,bj)
     &                + atmPhys_dU( i ,j,k,bi,bj)
     &                )*recip_hFacW(i,j,k,bi,bj)
c    &                )*maskW(i,j,k,bi,bj)
         ENDDO
        ENDDO

       IF ( atmPhys_dampUVfac(k).GT.zeroRL ) THEN
        DO j=jMin,jMax
         DO i=iMin,iMax
          gU_arr(i,j) = gU_arr(i,j)
     &     - maskW(i,j,k,bi,bj)*uVel(i,j,k,bi,bj)*atmPhys_dampUVfac(k)
          damp_dKE(i,j) =
     &     - uVel(i,j,k,bi,bj)*uVel(i,j,k,bi,bj)*atmPhys_dampUVfac(k)
     &                       *hFacW(i,j,k,bi,bj)*drF(k)*rUnit2mass
         ENDDO
        ENDDO
#ifdef ALLOW_FRICTION_HEATING
        IF ( addFrictionHeating ) THEN
         DO j=1,sNy
          DO i=1,sNx
           frictionHeating(i,j,k,bi,bj) = frictionHeating(i,j,k,bi,bj)
     &         - halfRL * ( damp_dKE( i, j)*rAw( i, j,bi,bj)
     &                    + damp_dKE(i+1,j)*rAw(i+1,j,bi,bj)
     &                    )*recip_rA(i,j,bi,bj)
          ENDDO
         ENDDO
        ENDIF
#endif /* ALLOW_FRICTION_HEATING */
       ENDIF

      ENDIF

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 0
C !ROUTINE: ATM_PHYS_TENDENCY_APPLY_V

C !INTERFACE:
      SUBROUTINE ATM_PHYS_TENDENCY_APPLY_V(
     U                    gV_arr,
     I                    iMin,iMax,jMin,jMax, k, bi, bj,
     I                    myTime, myIter, myThid )

C     !DESCRIPTION:
C     Add AtmPhys tendency terms to V tendency.  Routine works for one
C     level at a time. Assumes that U and V tendencies are on A-Grid

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "DYNVARS.h"
#include "FFIELDS.h"
#include "ATM_PHYS_PARAMS.h"
#include "ATM_PHYS_VARS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     gV_arr    :: the tendency array
C     iMin,iMax :: Working range of x-index for applying forcing.
C     jMin,jMax :: Working range of y-index for applying forcing.
C     k         :: Current vertical level index
C     bi,bj     :: Current tile indices
C     myTime    :: Current time in simulation
C     myIter    :: Current iteration number
C     myThid    :: my Thread Id number
      _RL     gV_arr(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER iMin, iMax, jMin, jMax
      INTEGER k, bi, bj
      _RL     myTime
      INTEGER myIter
      INTEGER myThid
CEOP

C     !LOCAL VARIABLES:
      INTEGER i, j
      _RL damp_dKE(1-OLx:sNx+OLx,1-OLy:sNy+OLy)

      IF ( atmPhys_addTendV ) THEN

C--   Assume Agrid position:
        DO j=jMin,jMax
         DO i=iMin,iMax
          gV_arr(i,j) = gV_arr(i,j)
     &      + halfRL *( atmPhys_dV(i,j-1,k,bi,bj)
     &                + atmPhys_dV(i, j ,k,bi,bj)
     &                )*recip_hFacS(i,j,k,bi,bj)
c    &                )*maskS(i,j,k,bi,bj)
         ENDDO
        ENDDO

       IF ( atmPhys_dampUVfac(k).GT.zeroRL ) THEN
        DO j=jMin,jMax
         DO i=iMin,iMax
          gV_arr(i,j) = gV_arr(i,j)
     &     - maskS(i,j,k,bi,bj)*vVel(i,j,k,bi,bj)*atmPhys_dampUVfac(k)
          damp_dKE(i,j) =
     &     - vVel(i,j,k,bi,bj)*vVel(i,j,k,bi,bj)*atmPhys_dampUVfac(k)
     &                        *hFacS(i,j,k,bi,bj)*drF(k)*rUnit2mass
         ENDDO
        ENDDO
#ifdef ALLOW_FRICTION_HEATING
        IF ( addFrictionHeating ) THEN
         DO j=1,sNy
          DO i=1,sNx
           frictionHeating(i,j,k,bi,bj) = frictionHeating(i,j,k,bi,bj)
     &         - halfRL * ( damp_dKE( i, j)*rAs(i, j ,bi,bj)
     &                    + damp_dKE(i,j+1)*rAs(i,j+1,bi,bj)
     &                    )*recip_rA(i,j,bi,bj)
          ENDDO
         ENDDO
        ENDIF
#endif /* ALLOW_FRICTION_HEATING */
       ENDIF

      ENDIF

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 0
C !ROUTINE: ATM_PHYS_TENDENCY_APPLY_T

C !INTERFACE:
      SUBROUTINE ATM_PHYS_TENDENCY_APPLY_T(
     U                    gT_arr,
     I                    iMin,iMax,jMin,jMax, k, bi, bj,
     I                    myTime, myIter, myThid )

C     !DESCRIPTION:
C     Add AtmPhys tendency terms to T (theta) tendency.  Routine works
C     for one level at a time

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "GRID.h"
#include "EEPARAMS.h"
c#include "DYNVARS.h"
#include "ATM_PHYS_PARAMS.h"
#include "ATM_PHYS_VARS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     gT_arr    :: the tendency array
C     iMin,iMax :: Working range of x-index for applying forcing.
C     jMin,jMax :: Working range of y-index for applying forcing.
C     k         :: Current vertical level index
C     bi,bj     :: Current tile indices
C     myTime    :: Current time in simulation
C     myIter    :: Current iteration number
C     myThid    :: my Thread Id number
      _RL     gT_arr(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER iMin, iMax, jMin, jMax
      INTEGER k, bi, bj
      _RL     myTime
      INTEGER myIter
      INTEGER myThid
CEOP

C     !LOCAL VARIABLES:
      INTEGER i, j

      IF ( atmPhys_addTendT ) THEN
        DO j=jMin,jMax
         DO i=iMin,iMax
          gT_arr(i,j) = gT_arr(i,j)
     &     + maskC(i,j,k,bi,bj) * atmPhys_dT(i,j,k,bi,bj)
         ENDDO
        ENDDO
      ENDIF

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 0
C !ROUTINE: ATM_PHYS_TENDENCY_APPLY_S

C !INTERFACE:
      SUBROUTINE ATM_PHYS_TENDENCY_APPLY_S(
     U                    gS_arr,
     I                    iMin,iMax,jMin,jMax, k, bi, bj,
     I                    myTime, myIter, myThid )

C     !DESCRIPTION:
C     Add AtmPhys tendency terms to S tendency.  Routine works for one
C     level at a time

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "GRID.h"
#include "EEPARAMS.h"
c#include "DYNVARS.h"
#include "ATM_PHYS_PARAMS.h"
#include "ATM_PHYS_VARS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     gS_arr    :: the tendency array
C     iMin,iMax :: Working range of x-index for applying forcing.
C     jMin,jMax :: Working range of y-index for applying forcing.
C     k         :: Current vertical level index
C     bi,bj     :: Current tile indices
C     myTime    :: Current time in simulation
C     myIter    :: Current iteration number
C     myThid    :: my Thread Id number
      _RL     gS_arr(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER iMin, iMax, jMin, jMax
      INTEGER k, bi, bj
      _RL     myTime
      INTEGER myIter
      INTEGER myThid
CEOP

C     !LOCAL VARIABLES:
      INTEGER i, j

      IF ( atmPhys_addTendS ) THEN
        DO j=jMin,jMax
         DO i=iMin,iMax
          gS_arr(i,j) = gS_arr(i,j)
     &     + maskC(i,j,k,bi,bj) * atmPhys_dQ(i,j,k,bi,bj)
         ENDDO
        ENDDO
      ENDIF

      RETURN
      END

#include "ATM_CPL_OPTIONS.h"

CBOP
C     !ROUTINE: ATM_CPL_READ_PICKUP
C     !INTERFACE:
      SUBROUTINE ATM_CPL_READ_PICKUP( myIter, myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE ATM_CPL_READ_PICKUP
C     | o Reads fields from a pickup file for a restart
C     *==========================================================*
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "CPL_PARAMS.h"
#include "ATMCPL.h"

C     !INPUT/OUTPUT PARAMETERS:
C     myIter  :: Current time-step number
C     myThid  :: my Thread Id number
      INTEGER myIter
      INTEGER myThid

#ifdef COMPONENT_MODULE
C     !LOCAL VARIABLES:
C     fn          :: character buffer for creating filename
C     fp          :: precision of pickup files
C     filePrec    :: pickup-file precision (read from meta file)
C     nbFields    :: number of fields in pickup file (read from meta file)
C     missFldList :: List of missing fields   (attempted to read but not found)
C     missFldDim  :: Dimension of missing fields list array: missFldList
C     nMissing    :: Number of missing fields (attempted to read but not found)
C     j           :: loop index
C     nj          :: record number
C     ioUnit      :: temp for writing msg unit
C     msgBuf      :: Informational/error message buffer
      INTEGER fp
      INTEGER filePrec, nbFields
      INTEGER missFldDim, nMissing
      INTEGER j, nj, ioUnit
      PARAMETER( missFldDim = 18 )
      CHARACTER*(10) suff
      CHARACTER*(MAX_LEN_FNAM) fn
      CHARACTER*(8) missFldList(missFldDim)
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      INTEGER i, bi, bj
CEOP

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

       IF ( pickupSuff.EQ.' ' ) THEN
        IF ( rwSuffixType.EQ.0 ) THEN
          WRITE(fn,'(A,I10.10)') 'pickup_cpl.', myIter
        ELSE
          CALL RW_GET_SUFFIX( suff, startTime, myIter, myThid )
          WRITE(fn,'(A,A)') 'pickup_cpl.', suff
        ENDIF
       ELSE
        WRITE(fn,'(A,A10)') 'pickup_cpl.', pickupSuff
       ENDIF
       fp = precFloat64

       CALL READ_MFLDS_SET(
     I                      fn,
     O                      nbFields, filePrec,
     I                      Nr, myIter, myThid )
       _BEGIN_MASTER( myThid )
c      IF ( filePrec.NE.0 .AND. filePrec.NE.fp ) THEN
       IF ( nbFields.GE.0 .AND. filePrec.NE.fp ) THEN
         WRITE(msgBuf,'(2A,I4)') 'ATM_CPL_READ_PICKUP: ',
     &    'pickup-file binary precision do not match !'
         CALL PRINT_ERROR( msgBuf, myThid )
         WRITE(msgBuf,'(A,2(A,I4))') 'ATM_CPL_READ_PICKUP: ',
     &    'file prec.=', filePrec, ' but expecting prec.=', fp
         CALL PRINT_ERROR( msgBuf, myThid )
         CALL ALL_PROC_DIE( 0 )
         STOP 'ABNORMAL END: S/R ATM_CPL_READ_PICKUP (data-prec Pb)'
       ENDIF
       _END_MASTER( myThid )

       IF ( nbFields.LE.0 ) THEN
C-      No meta-file or old meta-file without List of Fields
        ioUnit = errorMessageUnit
        IF ( pickupStrictlyMatch ) THEN
          WRITE(msgBuf,'(4A)') 'ATM_CPL_READ_PICKUP: ',
     &      'no field-list found in meta-file',
     &      ' => cannot check for strick-matching'
          CALL PRINT_ERROR( msgBuf, myThid )
          WRITE(msgBuf,'(4A)') 'ATM_CPL_READ_PICKUP: ',
     &      'try with " pickupStrictlyMatch=.FALSE.,"',
     &      ' in file: "data", NameList: "PARM03"'
          CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
          CALL ALL_PROC_DIE( myThid )
          STOP 'ABNORMAL END: S/R ATM_CPL_READ_PICKUP'
        ELSE
          WRITE(msgBuf,'(4A)') 'WARNING >> ATM_CPL_READ_PICKUP: ',
     &      ' no field-list found'
          CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
         IF ( nbFields.EQ.-1 ) THEN
C-      No meta-file
          WRITE(msgBuf,'(4A)') 'WARNING >> ',
     &      ' try to read pickup as currently written'
          CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
         ELSE
C-      Old meta-file without List of Fields
          WRITE(msgBuf,'(4A)') 'WARNING >> ',
     &      ' try to read pickup as it used to be written'
          CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
          WRITE(msgBuf,'(4A)') 'WARNING >> ',
     &      ' until checkpoint65r (2015 Dec 21)'
          CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
c         WRITE(msgBuf,'(4A)') 'ATM_CPL_READ_PICKUP: ',
c    &      'no field-list found in meta-file'
c         CALL PRINT_ERROR( msgBuf, myThid )
c         CALL ALL_PROC_DIE( myThid )
c         STOP 'ABNORMAL END: S/R ATM_CPL_READ_PICKUP'
         ENDIF
        ENDIF
       ENDIF

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

       IF ( nbFields.EQ.0 ) THEN
C---   Old way to read pickup:

c       CALL READ_REC_3D_RL( fn, fp, 1, ocMxlD    ,  1, myIter,myThid )
c       CALL READ_REC_3D_RL( fn, fp, 1, SSTocn    ,  2, myIter,myThid )
c       CALL READ_REC_3D_RL( fn, fp, 1, SSSocn    ,  3, myIter,myThid )
c       CALL READ_REC_3D_RL( fn, fp, 1, vSqocn    ,  4, myIter,myThid )
c       CALL READ_REC_3D_RL( fn, fp, 1, atmSLPr   ,  5, myIter,myThid )
        CALL READ_REC_3D_RL( fn, fp, 1, HeatFlux  ,  6, myIter,myThid )
        CALL READ_REC_3D_RL( fn, fp, 1, qShortWave,  7, myIter,myThid )
        CALL READ_REC_3D_RL( fn, fp, 1, tauX      ,  8, myIter,myThid )
        CALL READ_REC_3D_RL( fn, fp, 1, tauY      ,  9, myIter,myThid )
        CALL READ_REC_3D_RL( fn, fp, 1, EvMPrFlux , 10, myIter,myThid )
#ifdef ALLOW_LAND
        CALL READ_REC_3D_RL( fn, fp, 1, RunOffFlux, 11, myIter,myThid )
        CALL READ_REC_3D_RL( fn, fp, 1, RunOffEnFx, 12, myIter,myThid )
#endif /* ALLOW_LAND */
#ifdef ALLOW_THSICE
        CALL READ_REC_3D_RL( fn, fp, 1, iceSaltFlx, 13, myIter,myThid )
c       CALL READ_REC_3D_RL( fn, fp, 1, seaIceMass, 14, myIter,myThid )
#endif /* ALLOW_THSICE */
#ifdef ALLOW_AIM
        IF ( atm_cplExch_DIC ) THEN
c        CALL READ_REC_3D_RL( fn,fp, 1, flxCO2ocn , 15, myIter,myThid )
         CALL READ_REC_3D_RL( fn,fp, 1, airCO2    , 16, myIter,myThid )
         CALL READ_REC_3D_RL( fn,fp, 1, sWSpeed   , 17, myIter,myThid )
# ifdef ALLOW_THSICE
c        CALL READ_REC_3D_RL( fn,fp,1,sIceFrac_cpl, 18, myIter,myThid )
# endif /* ALLOW_THSICE */
        ENDIF
#endif /* ALLOW_AIM */

       ELSE
C---   New way to read ATM_CPL pickup:
        nj = 0
C---    read ATM_CPL 3-D fields for restart
        nj = nj*Nr

C---    read ATM_CPL 2-D fields for restart
        CALL READ_MFLDS_3D_RL( 'qHeatFlx', HeatFlux,
     &                                 nj, fp, 1 , myIter, myThid )
        CALL READ_MFLDS_3D_RL( 'qShortW ', qShortWave,
     &                                 nj, fp, 1 , myIter, myThid )
        CALL READ_MFLDS_3D_RL( 'surfTauX', tauX,
     &                                 nj, fp, 1 , myIter, myThid )
        CALL READ_MFLDS_3D_RL( 'surfTauY', tauY,
     &                                 nj, fp, 1 , myIter, myThid )
        CALL READ_MFLDS_3D_RL( 'Evp-Prec', EvMPrFlux,
     &                                 nj, fp, 1 , myIter, myThid )
#ifdef ALLOW_LAND
        IF ( atm_cplExch_RunOff ) THEN
         CALL READ_MFLDS_3D_RL('RunOffFx', RunOffFlux,
     &                                 nj, fp, 1 , myIter, myThid )
         CALL READ_MFLDS_3D_RL('RnOfEnFx', RunOffEnFx,
     &                                 nj, fp, 1 , myIter, myThid )
        ENDIF
#endif /* ALLOW_LAND */
#ifdef ALLOW_THSICE
        IF ( atm_cplExch1W_sIce ) THEN
         CALL READ_MFLDS_3D_RL('saltFlux', iceSaltFlx,
     &                                 nj, fp, 1 , myIter, myThid )
        ENDIF
        IF ( atm_cplExch_SaltPl ) THEN
         CALL READ_MFLDS_3D_RL('sltPlmFx', saltPlmFlx_cpl,
     &                                 nj, fp, 1 , myIter, myThid )
        ENDIF
#endif /* ALLOW_THSICE */
#ifdef ALLOW_AIM
        IF ( atm_cplExch_DIC ) THEN
         CALL READ_MFLDS_3D_RL('atm-CO2 ', airCO2,
     &                                 nj, fp, 1 , myIter, myThid )
         CALL READ_MFLDS_3D_RL('wndSpeed', sWSpeed,
     &                                 nj, fp, 1 , myIter, myThid )
        ENDIF
#endif /* ALLOW_AIM */

C--    end: new way to read pickup file
       ENDIF

C--    Check for missing fields:
       nMissing = missFldDim
       CALL READ_MFLDS_CHECK(
     O                     missFldList,
     U                     nMissing,
     I                     myIter, myThid )
       IF ( nMissing.GT.missFldDim ) THEN
         WRITE(msgBuf,'(2A,I4)') 'ATM_CPL_READ_PICKUP: ',
     &     'missing fields list has been truncated to', missFldDim
         CALL PRINT_ERROR( msgBuf, myThid )
         CALL ALL_PROC_DIE( myThid )
         STOP 'ABNORMAL END: S/R ATM_CPL_READ_PICKUP (list-size Pb)'
       ENDIF
       IF ( nMissing.GE.1 ) THEN
        ioUnit = errorMessageUnit
        DO j=1,nMissing
         WRITE(msgBuf,'(4A)') 'ATM_CPL_READ_PICKUP: ',
     &       'cannot restart without field "',missFldList(nj),'"'
         CALL PRINT_ERROR( msgBuf, myThid )
        ENDDO
        CALL ALL_PROC_DIE( myThid )
        STOP 'ABNORMAL END: S/R ATM_CPL_READ_PICKUP'
       ENDIF

C--    Update overlap regions:

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      IF ( cpl_oldPickup ) THEN
        _BARRIER
C-    EmP & RunOff were (before checkpoint59h) in m/s , but are now in kg/m2/s:
        DO bj = myByLo(myThid), myByHi(myThid)
         DO bi = myBxLo(myThid), myBxHi(myThid)
          DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
            EvMPrFlux (i,j,bi,bj) = EvMPrFlux (i,j,bi,bj)*rhoConstFresh
#ifdef ALLOW_LAND
            RunOffFlux(i,j,bi,bj) = RunOffFlux(i,j,bi,bj)*rhoConstFresh
#endif /* ALLOW_LAND */
           ENDDO
          ENDDO
         ENDDO
        ENDDO
      ENDIF

#endif /* COMPONENT_MODULE */

      RETURN
      END

#include "PTRACERS_OPTIONS.h"

CBOP
C !ROUTINE: PTRACERS_MONITOR

C !INTERFACE: ==========================================================
      SUBROUTINE PTRACERS_MONITOR(
     I                    myIter, myTime, myThid )

C !DESCRIPTION:
C writes out ptracer statistics

C !USES: ===============================================================
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "PTRACERS_SIZE.h"
#include "PTRACERS_PARAMS.h"
#include "PTRACERS_FIELDS.h"
#ifdef ALLOW_MONITOR
#include "MONITOR.h"
#endif

C !INPUT PARAMETERS: ===================================================
C  myTime               :: current time
C  myIter               :: current timestep
C  myThid               :: thread number
      _RL     myTime
      INTEGER myIter
      INTEGER myThid

C     === Functions ====
      LOGICAL  DIFFERENT_MULTIPLE
      EXTERNAL DIFFERENT_MULTIPLE
      LOGICAL  MASTER_CPU_IO
      EXTERNAL MASTER_CPU_IO

#ifdef ALLOW_PTRACERS
#ifdef ALLOW_MONITOR

C !LOCAL VARIABLES: ====================================================
C  i,j                  :: loop indices
C  ip                   :: ptracer number
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      CHARACTER*(MAX_LEN_MBUF) suff
      INTEGER ip
      _RL dummyRL(6)
CEOP

      IF ( DIFFERENT_MULTIPLE( PTRACERS_monitorFreq,myTime,deltaTClock )
     &   ) THEN

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C--   Ptracers field monitor start
        IF ( MASTER_CPU_IO(myThid) ) THEN
C--   only the master thread is allowed to switch On/Off mon_write_stdout
C     & mon_write_mnc (since it is the only thread that uses those flags):

          IF (monitor_stdio) THEN
            mon_write_stdout = .TRUE.
          ELSE
            mon_write_stdout = .FALSE.
          ENDIF
          mon_write_mnc    = .FALSE.
#ifdef ALLOW_MNC
          IF (useMNC .AND. PTRACERS_monitor_mnc) THEN
            WRITE(mon_fname,'(A)') 'monitor_ptracer'
            CALL MNC_CW_APPEND_VNAME(
     &           'T', '-_-_--__-__t', 0,0, myThid)
            CALL MNC_CW_SET_UDIM(mon_fname, -1, myThid)
            CALL MNC_CW_RL_W_S(
     &          'D',mon_fname,1,1,'T', myTime, myThid)
            CALL MNC_CW_SET_UDIM(mon_fname, 0, myThid)
            mon_write_mnc = .TRUE.
          ENDIF
#endif /* ALLOW_MNC */

          IF ( mon_write_stdout ) THEN
            WRITE(msgBuf,'(2A)') '// ==========================',
     &             '============================='
            CALL PRINT_MESSAGE( msgBuf, mon_ioUnit, SQUEEZE_RIGHT , 1)
            WRITE(msgBuf,'(A)')
     &             '// Begin MONITOR ptracer field statistics'
            CALL PRINT_MESSAGE( msgBuf, mon_ioUnit, SQUEEZE_RIGHT , 1)
            WRITE(msgBuf,'(2A)') '// ==========================',
     &             '============================='
            CALL PRINT_MESSAGE( msgBuf, mon_ioUnit, SQUEEZE_RIGHT , 1)
          ENDIF

C--   endif master cpu io
       ENDIF

C--   Ptracers field monitor : compute stats & write
       IF ( PTRACERS_monitorFreq .NE. monitorFreq
     &     .OR. (useMNC.AND.PTRACERS_monitor_mnc) ) THEN
C      repeat printing of time to make grepping easier, default is not
C      to do this, because the default is to use the same monitorFreq
C      for ptracers as for the dynamics variables.
         CALL MON_SET_PREF('trctime',myThid)
         CALL MON_OUT_I( '_tsnumber', myIter,mon_string_none,myThid)
         CALL MON_OUT_RL('_secondsf', myTime,mon_string_none,myThid)
       ENDIF
C      Print the basic statistics of ptracer variables
       CALL MON_SET_PREF('trcstat_',myThid)
       DO ip = 1, PTRACERS_numInUse
         WRITE(suff,'(A7,A2)') 'ptracer',PTRACERS_ioLabel(ip)
c        WRITE(suff,'(A6,I4.4)') 'ptrac', ip
         CALL MON_WRITESTATS_RL(
     &            Nr, pTracer(1-OLx,1-OLy,1,1,1,ip), suff,
     &            hFacC, maskInC, rA ,drF, dummyRL, myThid )
       ENDDO

C--   Ptracers field monitor finish
       IF ( MASTER_CPU_IO(myThid) ) THEN
C-    only the master thread is allowed to switch On/Off mon_write_stdout
C     & mon_write_mnc (since it is the only thread that uses those flags):

        IF ( mon_write_stdout ) THEN
         WRITE(msgBuf,'(2A)') '// ==========================',
     &        '============================='
         CALL PRINT_MESSAGE( msgBuf, mon_ioUnit, SQUEEZE_RIGHT , 1)
         WRITE(msgBuf,'(A)')
     &        '// End MONITOR ptracer field statistics'
         CALL PRINT_MESSAGE( msgBuf, mon_ioUnit, SQUEEZE_RIGHT , 1)
         WRITE(msgBuf,'(2A)') '// ==========================',
     &        '============================='
         CALL PRINT_MESSAGE( msgBuf, mon_ioUnit, SQUEEZE_RIGHT , 1)
        ENDIF

        mon_write_stdout = .FALSE.
        mon_write_mnc    = .FALSE.

C-    endif master cpu io
       ENDIF

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C---  endif different multiple
      ENDIF

#endif /* ALLOW_MONITOR */
#endif /* ALLOW_PTRACERS */

      RETURN
      END

#include "DIAG_OPTIONS.h"

CBOP
C     !ROUTINE: DIAGSTATS_CLOSE_IO
C     !INTERFACE:
      SUBROUTINE DIAGSTATS_CLOSE_IO( myThid )

C     !DESCRIPTION: \bv
C     *==================================================================
C     | S/R DIAGSTATS_CLOSE_IO
C     | o Close I/O unit of ASCII output file
C     *==================================================================
C     \ev

C     !USES:
      IMPLICIT NONE

C     == Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "DIAGNOSTICS_SIZE.h"
#include "DIAGNOSTICS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     myThid   :: my Thread Id number
      INTEGER myThid

C     !FUNCTIONS:
      INTEGER  ILNBLNK
      EXTERNAL ILNBLNK

C     !LOCAL VARIABLES:
      INTEGER  n, iL, nUnit
      CHARACTER*(10) suff
      CHARACTER*(MAX_LEN_FNAM) dataFName
      CHARACTER*(MAX_LEN_MBUF) msgBuf
CEOP

      _BEGIN_MASTER( myThid)

      IF ( diagSt_Ascii .AND. myProcId.EQ.0 ) THEN

        DO n=1,diagSt_nbLists

          nUnit = diagSt_ioUnit(n)

C-      write a conclusion & close the file:
          WRITE(nUnit,'(A)') '# records End here.'
          CLOSE(nUnit)

          IF ( rwSuffixType.EQ.0 ) THEN
            WRITE(suff,'(I10.10)') nIter0
          ELSE
            CALL RW_GET_SUFFIX( suff, startTime, nIter0, myThid )
          ENDIF
          iL = ILNBLNK(diagSt_Fname(n))
          WRITE(dataFName,'(4A)')
     &          diagSt_Fname(n)(1:iL), '.', suff, '.txt'
          WRITE(msgBuf,'(4A,I6)') 'DIAGSTATS_CLOSE_IO: ',
     &         'close file: ',dataFName(1:iL+15), ' , unit=', nUnit
          CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                        SQUEEZE_RIGHT, myThid )

        ENDDO

      ENDIF

C-    Close also local diagnostics output file
      IF ( diagLoc_ioUnit.GT.0 ) THEN
        CLOSE(diagLoc_ioUnit)
      ENDIF

      _END_MASTER( myThid )

      RETURN
      END

#include "PACKAGES_CONFIG.h"
#include "CPP_OPTIONS.h"

CBOP
C     !ROUTINE: UPDATE_CG2D
C     !INTERFACE:
      SUBROUTINE UPDATE_CG2D( myTime, myIter, myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE UPDATE_CG2D
C     | o Update 2d conjugate gradient solver operators
C     |   account for Free-Surf effect on total column thickness
C     *==========================================================*
C     | This routine is based on INI_CG2D, and simplified. It is
C     | used when the non-linear free surface mode is activated
C     | or when bottom depth is part of the control vector.
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "SURFACE.h"
#include "CG2D.h"
#ifdef ALLOW_SOLVE4_PS_AND_DRAG
# include "DYNVARS.h"
#endif /* ALLOW_SOLVE4_PS_AND_DRAG */

C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
C     myTime :: Current time in simulation
C     myIter :: Current iteration number in simulation
C     myThid :: Thread number for this instance of the routine.
      _RL myTime
      INTEGER myIter
      INTEGER myThid

C     !LOCAL VARIABLES:
C-- Note : compared to "INI_CG2D", no needs to compute again
C   the solver normalisation factor or the solver tolerance
C     === Local variables ===
C     bi,bj  :: tile indices
C     i,j,k  :: Loop counters
C     faceArea :: Temporary used to hold cell face areas.
      INTEGER bi, bj
      INTEGER i, j, k, ks
      _RL     faceArea
      _RL     pW_tmp, pS_tmp
      LOGICAL updatePreCond
CEOP

C--   Decide when to update cg2d Preconditioner :
      IF ( cg2dPreCondFreq.EQ.0 ) THEN
        updatePreCond = .FALSE.
      ELSE
        updatePreCond = ( myIter.EQ.nIter0 )
        IF ( MOD(myIter,cg2dPreCondFreq).EQ.0 ) updatePreCond=.TRUE.
      ENDIF

C--   Initialise laplace operator
C     aW2d: integral in Z Ax/dX
C     aS2d: integral in Z Ay/dY
      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          aW2d(i,j,bi,bj) = 0. _d 0
          aS2d(i,j,bi,bj) = 0. _d 0
#ifdef ALLOW_AUTODIFF
          aC2d(i,j,bi,bj) = 0. _d 0
#endif /* ALLOW_AUTODIFF */
         ENDDO
        ENDDO
#ifdef ALLOW_SOLVE4_PS_AND_DRAG
        IF ( selectImplicitDrag.EQ.2 ) THEN
         DO k=1,Nr
          DO j=1,sNy+1
           DO i=1,sNx+1
            faceArea = _dyG(i,j,bi,bj)*drF(k)*deepFacC(k)*rhoFacC(k)
     &                *_hFacW(i,j,k,bi,bj)
            aW2d(i,j,bi,bj) = aW2d(i,j,bi,bj)
     &               + faceArea*dU_psFacX(i,j,k,bi,bj)
     &                         *recip_dxC(i,j,bi,bj)
            faceArea = _dxG(i,j,bi,bj)*drF(k)*deepFacC(k)*rhoFacC(k)
     &                *_hFacS(i,j,k,bi,bj)
            aS2d(i,j,bi,bj) = aS2d(i,j,bi,bj)
     &               + faceArea*dV_psFacY(i,j,k,bi,bj)
     &                         *recip_dyC(i,j,bi,bj)
           ENDDO
          ENDDO
         ENDDO
        ELSE
#endif /* ALLOW_SOLVE4_PS_AND_DRAG */
         DO k=1,Nr
          DO j=1,sNy+1
           DO i=1,sNx+1
C  deep-model: *deepFacC (faceArea), /deepFacC (recip_dx,y): => no net effect
            faceArea = _dyG(i,j,bi,bj)*drF(k)
     &                *_hFacW(i,j,k,bi,bj)
            aW2d(i,j,bi,bj) = aW2d(i,j,bi,bj)
     &               + faceArea*recip_dxC(i,j,bi,bj)
            faceArea = _dxG(i,j,bi,bj)*drF(k)
     &                *_hFacS(i,j,k,bi,bj)
            aS2d(i,j,bi,bj) = aS2d(i,j,bi,bj)
     &               + faceArea*recip_dyC(i,j,bi,bj)
           ENDDO
          ENDDO
         ENDDO
#ifdef ALLOW_SOLVE4_PS_AND_DRAG
        ENDIF
#endif /* ALLOW_SOLVE4_PS_AND_DRAG */
        DO j=1,sNy+1
         DO i=1,sNx+1
          aW2d(i,j,bi,bj) = aW2d(i,j,bi,bj)*cg2dNorm
     &                     *implicSurfPress*implicDiv2DFlow
#ifdef ALLOW_OBCS
     &                  *maskInC(i,j,bi,bj)*maskInC(i-1,j,bi,bj)
#endif
          aS2d(i,j,bi,bj) = aS2d(i,j,bi,bj)*cg2dNorm
     &                     *implicSurfPress*implicDiv2DFlow
#ifdef ALLOW_OBCS
     &                  *maskInC(i,j,bi,bj)*maskInC(i,j-1,bi,bj)
#endif
         ENDDO
        ENDDO
C--   compute matrix main diagonal :
        IF ( deepAtmosphere ) THEN
         DO j=1,sNy
          DO i=1,sNx
           ks = kSurfC(i,j,bi,bj)
           aC2d(i,j,bi,bj) = -(
     &       aW2d(i,j,bi,bj) + aW2d(i+1, j ,bi,bj)
     &      +aS2d(i,j,bi,bj) + aS2d( i ,j+1,bi,bj)
     &      +freeSurfFac*cg2dNorm*recip_Bo(i,j,bi,bj)*deepFac2F(ks)
     &                  *rA(i,j,bi,bj)/deltaTMom/deltaTFreeSurf
     &                        )
          ENDDO
         ENDDO
        ELSE
         DO j=1,sNy
          DO i=1,sNx
           aC2d(i,j,bi,bj) = -(
     &       aW2d(i,j,bi,bj) + aW2d(i+1, j ,bi,bj)
     &      +aS2d(i,j,bi,bj) + aS2d( i ,j+1,bi,bj)
     &      +freeSurfFac*cg2dNorm*recip_Bo(i,j,bi,bj)
     &                  *rA(i,j,bi,bj)/deltaTMom/deltaTFreeSurf
     &                        )
          ENDDO
         ENDDO
        ENDIF
C-    end bi,bj loops
       ENDDO
      ENDDO

      IF ( updatePreCond ) THEN
C--   Update overlap regions
      CALL EXCH_XY_RS(aC2d, myThid)

C--   Initialise preconditioner
      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        DO j=1,sNy+1
         DO i=1,sNx+1
          IF ( aC2d(i,j,bi,bj) .EQ. 0. ) THEN
            pC(i,j,bi,bj) = 1. _d 0
          ELSE
           pC(i,j,bi,bj) =  1. _d 0 / aC2d(i,j,bi,bj)
          ENDIF
          pW_tmp = aC2d(i,j,bi,bj)+aC2d(i-1,j,bi,bj)
          IF ( pW_tmp .EQ. 0. ) THEN
           pW(i,j,bi,bj) = 0.
          ELSE
           pW(i,j,bi,bj) =
     &     -aW2d(i,j,bi,bj)/((cg2dpcOffDFac *pW_tmp)**2 )
          ENDIF
          pS_tmp = aC2d(i,j,bi,bj)+aC2d(i,j-1,bi,bj)
          IF ( pS_tmp .EQ. 0. ) THEN
           pS(i,j,bi,bj) = 0.
          ELSE
           pS(i,j,bi,bj) =
     &     -aS2d(i,j,bi,bj)/((cg2dpcOffDFac *pS_tmp)**2 )
          ENDIF
         ENDDO
        ENDDO
       ENDDO
      ENDDO
C-    if update Preconditioner : end
      ENDIF

      RETURN
      END

#include "MYPACKAGE_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C !ROUTINE: MYPACKAGE_INIT_FIXED

C !INTERFACE:
      SUBROUTINE MYPACKAGE_INIT_FIXED( myThid )

C     !DESCRIPTION:
C     Initialize MYPACKAGE variables that are kept fixed during the run.

C     !USES:
      IMPLICIT NONE
C     == Global variables ===
#include "EEPARAMS.h"
#include "SIZE.h"
#include "PARAMS.h"
#include "MYPACKAGE.h"

C     !INPUT/OUTPUT PARAMETERS:
C     myThid ::  my Thread Id number
      INTEGER myThid
CEOP

C     !LOCAL VARIABLES:

#ifdef ALLOW_MNC
      IF (useMNC) THEN
        CALL MYPACKAGE_MNC_INIT( myThid )
      ENDIF
#endif /* ALLOW_MNC */

#ifdef ALLOW_DIAGNOSTICS
      IF ( useDiagnostics ) THEN
        CALL MYPACKAGE_DIAGNOSTICS_INIT( myThid )
      ENDIF
#endif

      RETURN
      END

#include "CTRL_OPTIONS.h"

      subroutine ctrl_Summary( myThid )

c     ==================================================================
c     SUBROUTINE ctrl_Summary
c     ==================================================================
c
c     o Summarize the control vector settings.
c
c     ==================================================================
c     SUBROUTINE ctrl_Summary
c     ==================================================================

      IMPLICIT NONE

c     == global variables ==

#include "EEPARAMS.h"
#include "SIZE.h"
#include "PARAMS.h"

#ifdef ALLOW_CAL
# include "cal.h"
#endif
#ifdef ALLOW_AUTODIFF
# include "AUTODIFF_PARAMS.h"
#endif
#ifdef ALLOW_CTRL
# include "CTRL_SIZE.h"
# include "CTRL.h"
# if (   defined ALLOW_GENARR2D_CONTROL \
      || defined ALLOW_GENARR3D_CONTROL \
      || defined ALLOW_GENTIM2D_CONTROL  )
#  include "CTRL_GENARR.h"
# endif
# ifdef ALLOW_OBCS
#  include "CTRL_OBCS.h"
# endif
#endif

c     == routine arguments ==
      integer myThid

c     == external ==
      integer  ilnblnk
      external ilnblnk

c     == local variables ==
      integer bi,bj
      integer k
      integer ivar
      integer il
      integer errCount
      integer nwetcenter
      integer nwetsouth
      integer nwetwest

      character*(MAX_LEN_MBUF) msgbuf

#if (defined (ALLOW_GENARR2D_CONTROL) \
      || defined (ALLOW_GENARR3D_CONTROL) \
      || defined (ALLOW_GENTIM2D_CONTROL))
      INTEGER iarr, jarr, iw
#endif
#if ( defined ALLOW_GENTIM2D_CONTROL && defined ALLOW_CAL )
      integer i, timeint(4)
#endif

c     == end of interface ==

      errCount = 0

      write(msgbuf,'(a)') ' '
      call print_message( msgbuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      write(msgbuf,'(a)')
     &'// ======================================================='
      call print_message( msgbuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      write(msgbuf,'(a)')
     &'// control vector configuration  >>> START <<<'
      call print_message( msgbuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      write(msgbuf,'(a)')
     &'// ======================================================='
      call print_message( msgbuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      write(msgbuf,'(a)') ' '
      call print_message( msgbuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )

      write(msgbuf,'(a)')
     &' Total number of ocean points per tile:'
      call print_message( msgbuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      write(msgbuf,'(a)')
     &' --------------------------------------'
      call print_message( msgbuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      write(msgbuf,'(a,i8)') ' sNx*sNy*Nr = ',sNx*sNy*Nr
      call print_message( msgbuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      write(msgbuf,'(a)') ' '
      call print_message( msgbuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      write(msgbuf,'(a)')
     &' Number of ocean points per tile:'
      call print_message( msgbuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      write(msgbuf,'(a)')
     &' --------------------------------'
      call print_message( msgbuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      do bj = 1,nSy
        do bi = 1,nSx
          nwetcenter = 0
          nwetsouth  = 0
          nwetwest   = 0
          do k = 1,Nr
            nwetcenter = nwetcenter + nwetctile(bi,bj,k)
            nwetsouth  = nwetsouth  + nwetstile(bi,bj,k)
            nwetwest   = nwetwest   + nwetwtile(bi,bj,k)
          enddo
c         write(msgbuf,'(a,i5.4,i5.4,i7.6,i7.6,i7.6)')
          write(msgbuf,'(a,i4.3,i4.3,i8,i8,i8)')
     &    ' bi,bj,#(c/s/w):',bi,bj,nwetcenter, nwetsouth, nwetwest
          call print_message( msgbuf, standardMessageUnit,
     &                        SQUEEZE_RIGHT, myThid )
        enddo
      enddo

      do ivar = 1, maxcvars
C     only print active variables for which ncvarindex has been set
C     (default = -1)
       if ( ncvarindex(ivar) .GE. 0 ) then

        write(msgbuf,'(a)') ' '
        call print_message( msgbuf, standardMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
        il   = ILNBLNK( ncvarfname(ivar) )
C     find out if current variable is a generic control variable name
#ifdef ALLOW_GENARR3D_CONTROL
        if ( ncvartype(ivar) .eq. 'Arr3D') then
         iarr = ncvarindex(ivar)
         if ( xx_genarr3d_file(iarr) .eq. ncvarfname(ivar) ) then
          write(msgbuf,'(a,i3,a)')
     &    ' -> 3d control, genarr3d no.',iarr,' is in use'
          call print_message( msgbuf, standardMessageUnit,
     &                        SQUEEZE_RIGHT, myThid )
         else
          write(msgbuf,'(a,i6)')
     &    ' -> something is wrong with 3d control, genarr3d no.',iarr
          call print_error( msgbuf, myThid )
          errCount = errCount + 1
         endif
        endif
#endif
#ifdef ALLOW_GENARR2D_CONTROL
        if ( ncvartype(ivar) .eq. 'Arr2D') then
         iarr = ncvarindex(ivar)
         if ( xx_genarr2d_file(iarr) .eq. ncvarfname(ivar) ) then
          write(msgbuf,'(a,i3,a)')
     &    ' -> 2d control, genarr2d no.',iarr,' is in use'
          call print_message( msgbuf, standardMessageUnit,
     &                        SQUEEZE_RIGHT, myThid )
         else
          write(msgbuf,'(a,i6)')
     &    ' -> something is wrong with 2d control, genarr2d no.',iarr
          call print_error( msgbuf, myThid )
          errCount = errCount + 1
         endif
        endif
#endif
#ifdef ALLOW_GENTIM2D_CONTROL
        if ( ncvartype(ivar) .eq. 'Tim2D') then
         iarr = ncvarindex(ivar)
         if ( xx_gentim2d_file(iarr) .eq. ncvarfname(ivar) ) then
          write(msgbuf,'(2a,i3,a)') ' -> ',
     &    'time variable 2d control, gentim2d no.',iarr,' is in use'
          call print_message( msgbuf, standardMessageUnit,
     &                        SQUEEZE_RIGHT, myThid )
         else
          write(msgbuf,'(2a,i6)') ' -> something is wrong with ',
     &    'time variable  2d control, gentim2d no.',iarr
          call print_error( msgbuf, myThid )
          errCount = errCount + 1
         endif
        endif
#endif
        write(msgbuf,'(a,a)')
     &'      file       = ',ncvarfname(ivar)(1:il)
        call print_message( msgbuf, standardMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
        write(msgbuf,'(a,a)')
     &'      ncvartype  = ', ncvartype(ivar)
        call print_message( msgbuf, standardMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
        write(msgbuf,'(a,i5,a)')
     &'      index      = ', ivar, '  (use this for pkg/grdchk)'
        call print_message( msgbuf, standardMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
        write(msgbuf,'(a,i5)')
     &'      ncvarindex = ', ncvarindex(ivar)
        call print_message( msgbuf, standardMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
C     extra information only available for generic control variables
#ifdef ALLOW_GENARR3D_CONTROL
        if ( ncvartype(ivar) .eq. 'Arr3D') then
         iarr = ncvarindex(ivar)
         iw   = ILNBLNK( xx_genarr3d_weight(iarr) )
         write(msgbuf,'(a,a)')
     &'      weight     = ',xx_genarr3d_weight(iarr)(1:iw)
         call print_message( msgbuf, standardMessageUnit,
     &                       SQUEEZE_RIGHT, myThid )
         do jarr=1,maxCtrlProc
          if (xx_genarr3d_preproc(jarr,iarr).NE.' ') then
           il = ilnblnk(xx_genarr3d_preproc(jarr,iarr))
           write(msgbuf,'(a,a)') ' preprocess = ',
     &          xx_genarr3d_preproc(jarr,iarr)(1:il)
           call print_message( msgbuf, standardMessageUnit,
     &                         SQUEEZE_RIGHT, myThid )
          endif
         enddo
        endif
#endif
#ifdef ALLOW_GENARR2D_CONTROL
        if ( ncvartype(ivar) .eq. 'Arr2D' ) then
         iarr = ncvarindex(ivar)
         iw   = ILNBLNK( xx_genarr2d_weight(iarr) )
         write(msgbuf,'(a,a)')
     &'      weight     = ',xx_genarr2d_weight(iarr)(1:iw)
         call print_message( msgbuf, standardMessageUnit,
     &                       SQUEEZE_RIGHT, myThid )
         do jarr=1,maxCtrlProc
          if (xx_genarr2d_preproc(jarr,iarr).NE.' ') then
           il = ilnblnk(xx_genarr2d_preproc(jarr,iarr))
           write(msgbuf,'(a,a)') ' preprocess = ',
     &          xx_genarr2d_preproc(jarr,iarr)(1:il)
           call print_message( msgbuf, standardMessageUnit,
     &                         SQUEEZE_RIGHT, myThid )
          endif
         enddo
        endif
#endif
#ifdef ALLOW_GENTIM2D_CONTROL
        if ( ncvartype(ivar) .eq. 'Tim2D' ) then
         iarr = ncvarindex(ivar)
         iw   = ILNBLNK( xx_gentim2d_weight(iarr) )
         write(msgbuf,'(a,a)')
     &'      weight     = ',xx_gentim2d_weight(iarr)(1:iw)
         call print_message( msgbuf, standardMessageUnit,
     &                       SQUEEZE_RIGHT, myThid )
#ifdef ALLOW_CAL
         if ( useCAL ) then
          call cal_TimeInterval( xx_gentim2d_period(iarr),
     &                          'secs', timeint, myThid )
          write(msgbuf,'(a,i9.8,i7.6)')
     &'      period     = ',(timeint(i), i=1,2)
          call print_message( msgbuf, standardMessageUnit,
     &                        SQUEEZE_RIGHT, myThid )
         endif
#endif

         do jarr=1,maxCtrlProc
          if (xx_gentim2d_preproc(jarr,iarr).NE.' ') then
           il = ilnblnk(xx_gentim2d_preproc(jarr,iarr))
           write(msgbuf,'(a,a)') '      preprocess = ',
     &          xx_gentim2d_preproc(jarr,iarr)(1:il)
           call print_message( msgbuf, standardMessageUnit,
     &                         SQUEEZE_RIGHT, myThid )
C
           if (xx_gentim2d_preproc_c(jarr,iarr).NE.' ') then
            il = ilnblnk(xx_gentim2d_preproc_c(jarr,iarr))
            write(msgbuf,'(a,a)') '        param. (text)= ',
     &           xx_gentim2d_preproc_c(jarr,iarr)(1:il)
            call print_message( msgbuf, standardMessageUnit,
     &                          SQUEEZE_RIGHT, myThid )
           endif
C
           if (xx_gentim2d_preproc_i(jarr,iarr).NE.0) then
            write(msgbuf,'(a,i6)') '        param. (int.)= ',
     &           xx_gentim2d_preproc_i(jarr,iarr)
            call print_message( msgbuf, standardMessageUnit,
     &                          SQUEEZE_RIGHT, myThid )
           endif
C
           if (xx_gentim2d_preproc_r(jarr,iarr).NE.0. _d 0) then
            write(msgbuf,'(a,e10.3)') '        param. (real)= ',
     &           xx_gentim2d_preproc_r(jarr,iarr)
            call print_message( msgbuf, standardMessageUnit,
     &                          SQUEEZE_RIGHT, myThid )
           endif

          endif
         enddo
        endif
#endif
       endif
      enddo

      if ( errCount.GE.1 ) then
        write(msgbuf,'(a,i3,a)')
     &       'ctrl_summary: detected', errCount,' fatal error(s)'
        call print_error( msgbuf, myThid )
        stop 'ABNORMAL END: S/R CTRL_SUMMARY'
      endif

      CALL WRITE_0D_L( useCtrlCostContribution, INDEX_NONE,
     &     'useCtrlCostContribution =',
     &     '  /* compute regularisation for gen. ctrls */')
#ifdef ALLOW_OBCS
      CALL WRITE_0D_L( useObcsCostContribution, INDEX_NONE,
     &     'useObcsCostContribution =',
     &     '  /* compute regularisation for obcs ctrls */')
C-    these 2 following params are related to currently disabled code:
      IF ( mult_obcsvol .NE. 0. _d 0 ) THEN
       WRITE(msgBuf,'(2A)') '** WARNING ** CTRL_SUMMARY: ',
     &   '"mult_obcsvol" currently has not effect; code needs fixing.'
       CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
      ENDIF
      IF ( mult_ageos.NE.0. _d 0 ) THEN
       WRITE(msgBuf,'(2A)') '** WARNING ** CTRL_SUMMARY: ',
     &   '"mult_ageos" currently has no effect; code needs fixing.'
       CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
      ENDIF
#endif

      write(msgbuf,'(a)') ' '
      call print_message( msgbuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      write(msgbuf,'(a)')
     &'// ======================================================='
      call print_message( msgbuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      write(msgbuf,'(a)')
     &'// control vector configuration  >>> END <<<'
      call print_message( msgbuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      write(msgbuf,'(a)')
     &'// ======================================================='
      call print_message( msgbuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      write(msgbuf,'(a)') ' '
      call print_message( msgbuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )

      return
      end

#include "PACKAGES_CONFIG.h"
#include "CPP_OPTIONS.h"
c#ifdef ALLOW_AUTODIFF
c# include "AUTODIFF_OPTIONS.h"
c#endif

CBOP
C     !ROUTINE: DO_ATMOSPHERIC_PHYS
C     !INTERFACE:
      SUBROUTINE DO_ATMOSPHERIC_PHYS(myTime, myIter, myThid)
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE DO_ATMOSPHERIC_PHYS
C     | o Controlling routine for atmospheric physics and
C     |   parameterization
C     *==========================================================*
C     | o originally, part of S/R thermodynamics & forward_step
C     *==========================================================*
C     \ev

C     !CALLING SEQUENCE:
C     DO_ATMOSPHERIC_PHYS
C       |
C       |-- UPDATE_OCEAN_EXPORTS
C       |-- UPDATE_EARTH_EXPORTS
C       |-- UPDATE_CHEMISTRY_EXPORTS
C       |-- FIZHI_WRAPPER
C       |-- STEP_FIZHI_FG
C       |-- FIZHI_UPDATE_TIME
C       |
C       |-- ATM_PHYS_DRIVER
C       |
C       |-- AIM_DO_PHYSICS

C     !USES:
      IMPLICIT NONE
C     == Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "DYNVARS.h"
c#ifdef ALLOW_AUTODIFF_TAMC
c# include "tamc.h"
c#endif /* ALLOW_AUTODIFF_TAMC */

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     myTime :: Current time in simulation
C     myIter :: Current iteration number in simulation
C     myThid :: my Thread Id number
      _RL myTime
      INTEGER myIter
      INTEGER myThid
CEOP

C     !LOCAL VARIABLES:
C     == Local variables
C     bi, bj   :: tile indices
C     i,j,k    :: loop indices
      INTEGER bi, bj
      INTEGER i, j, k
      _RL thetaRef

#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_ENTER('DO_ATMOSPHERIC_PHYS',myThid)
#endif

      IF ( fluidIsAir ) THEN
C     These store directives do not seem to be necessary, but we leave
C     them here as a reminder.
c#ifdef ALLOW_AUTODIFF_TAMC
cCADJ STORE theta = comlev1, key=ikey_dynamics, kind=isbyte
cCADJ STORE salt  = comlev1, key=ikey_dynamics, kind=isbyte
c#endif
       DO bj=myByLo(myThid),myByHi(myThid)
        DO bi=myBxLo(myThid),myBxHi(myThid)

C--   Compute virtual potential temperature anomaly (including water vapour
C     effect), stored in rhoInSitu (similar to what is done for oceanic EOS)
          DO k=1,Nr
           IF ( select_rStar.GE.1 .OR. selectSigmaCoord.GE.1 ) THEN
C-    isothermal (theta=const) reference state
             thetaRef = thetaConst
           ELSE
C-    horizontally uniform (tRef) reference state
             thetaRef = tRef(k)
           ENDIF
           DO j=1-OLy,sNy+OLy
            DO i=1-OLx,sNx+OLx
             rhoInSitu(i,j,k,bi,bj) =
     &         ( theta(i,j,k,bi,bj)
     &              *( salt(i,j,k,bi,bj)*atm_Rq + oneRL )
     &         - thetaRef )*maskC(i,j,k,bi,bj)
            ENDDO
           ENDDO
          ENDDO

        ENDDO
       ENDDO
#ifdef ALLOW_AUTODIFF
      ELSE
       DO bj=myByLo(myThid),myByHi(myThid)
        DO bi=myBxLo(myThid),myBxHi(myThid)
          DO k=1,Nr
           DO j=1-OLy,sNy+OLy
            DO i=1-OLx,sNx+OLx
              rhoInSitu(i,j,k,bi,bj) = 0.
            ENDDO
           ENDDO
          ENDDO
        ENDDO
       ENDDO
#endif /* ALLOW_AUTODIFF */
      ENDIF

#ifdef ALLOW_FIZHI
      IF ( useFIZHI ) THEN
        CALL TIMER_START('FIZHI          [DO_ATMOSPHERIC_PHYS]',myThid)
        CALL UPDATE_OCEAN_EXPORTS ( myTime, myIter, myThid )
        CALL UPDATE_EARTH_EXPORTS ( myTime, myIter, myThid )
        CALL UPDATE_CHEMISTRY_EXPORTS ( myTime, myIter, myThid )
        CALL FIZHI_WRAPPER ( myTime, myIter, myThid )
        CALL STEP_FIZHI_FG ( myTime, myIter, myThid, dTtracerLev(1) )
        CALL FIZHI_UPDATE_TIME ( myIter, myThid, deltaTClock )
        CALL TIMER_STOP ('FIZHI          [DO_ATMOSPHERIC_PHYS]',myThid)
      ENDIF
#endif /* ALLOW_FIZHI */

#ifdef ALLOW_ATM_PHYS
C     Atmospheric Physics package - Atm_Phys - main driver
      IF ( useAtm_Phys ) THEN
        CALL TIMER_START('ATM_PHYS_DRIVER [DO_ATMOSPHERIC_PHYS]',myThid)
        CALL ATM_PHYS_DRIVER( myTime, myIter, myThid )
        CALL TIMER_STOP( 'ATM_PHYS_DRIVER [DO_ATMOSPHERIC_PHYS]',myThid)
      ENDIF
#endif /* ALLOW_ATM_PHYS */

#ifdef ALLOW_AIM
      IF ( useAIM ) THEN
C       AIM - atmospheric intermediate model, physics package code.
#ifdef ALLOW_DEBUG
        IF (debugMode) CALL DEBUG_CALL('AIM_DO_PHYSICS',myThid)
#endif
        CALL TIMER_START('AIM_DO_PHYSICS [DO_ATMOSPHERIC_PHYS]',myThid)
        CALL AIM_DO_PHYSICS( myTime, myIter, myThid )
        CALL TIMER_STOP( 'AIM_DO_PHYSICS [DO_ATMOSPHERIC_PHYS]',myThid)
      ENDIF
#endif /* ALLOW_AIM */

#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_LEAVE('DO_ATMOSPHERIC_PHYS',myThid)
#endif

      RETURN
      END

#include "FIZHI_OPTIONS.h"
       SUBROUTINE FIZHI_WRAPPER (myTime, myIter, myThid)
c-----------------------------------------------------------------------
c  Subroutine fizhi_wrapper - 'Wrapper' routine to interface
c        with physics driver.
c        1) Set up "bi, bj loop"  and some timers and clocks.
c        2) Call do_fizhi - driver for physics which computes tendencies
c        3) Interpolate tendencies to dynamics grid in vertical
c        4) Convert u,v tendencies to C-Grid
c
c Calls: do_fizhi (get u,v,t,s tend, step tke, etc and tc, etc. forward)
c        phys2dyn (4 calls - all physics tendencies)
c        AtoC (u and v tendencies)
c-----------------------------------------------------------------------
       IMPLICIT NONE
#include "SIZE.h"
#include "GRID.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "SURFACE.h"
#include "DYNVARS.h"
#include "fizhi_land_SIZE.h"
#include "fizhi_SIZE.h"
#include "fizhi_coms.h"
#include "gridalt_mapping.h"
#include "fizhi_land_coms.h"
#include "fizhi_earth_coms.h"
#include "fizhi_ocean_coms.h"
#include "fizhi_chemistry_coms.h"
#ifdef ALLOW_DIAGNOSTICS
#include "fizhi_SHP.h"
#endif

       INTEGER myIter, myThid
       _RL myTime
       LOGICAL  diagnostics_is_on
       EXTERNAL diagnostics_is_on

c pe on dynamics and physics grid refers to bottom edge
       _RL pephy4fiz(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nrphys+1,nSx,nSy)
       _RL pephy(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nrphys+1,nSx,nSy)
       _RL pedyn(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr+1,nSx,nSy)
       _RL tempphy(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nrphys,nSx,nSy)
       _RL fracland(sNx,sNy,nSx,nSy)
       _RL tempLdiag(sNx,sNy,Nrphys+1)
       _RL tempLdiag2(sNx,sNy,Nrphys)
       _RL tempdiag(sNx,sNy)
       _RL slp(sNx,sNy)

       INTEGER i, j, L, Lbotij, bi, bj
       INTEGER im1, im2, jm1, jm2, idim1, idim2, jdim1, jdim2
       _RL grav, getcon

       grav = getcon('GRAVITY')
       idim1 = 1-OLx
       idim2 = sNx+OLx
       jdim1 = 1-OLy
       jdim2 = sNy+OLy
       im1 = 1
       im2 = sNx
       jm1 = 1
       jm2 = sNy

#ifdef ALLOW_DIAGNOSTICS
      if ( useDiagnostics ) then
       if(diagnostics_is_on('TENDUFIZ',myThid) .or.
     &       diagnostics_is_on('CORRDU  ',myThid) ) then
        do bj = myByLo(myThid), myByHi(myThid)
        do bi = myBxLo(myThid), myBxHi(myThid)
        do L = 1,Nrphys
        do j = 1,sNy
        do i = 1,sNx
         ubef(i,j,L,bi,bj) = uphy(i,j,L,bi,bj)
        enddo
        enddo
        enddo
        do L = 1,Nr
        do j = 1,sNy
        do i = 1,sNx+1
         udynbef(i,j,L,bi,bj) = uvel(i,j,L,bi,bj)
        enddo
        enddo
        enddo
        enddo
        enddo
       endif
       if(diagnostics_is_on('TENDVFIZ',myThid) .or.
     &       diagnostics_is_on('CORRDV  ',myThid) ) then
        do bj = myByLo(myThid), myByHi(myThid)
        do bi = myBxLo(myThid), myBxHi(myThid)
        do L = 1,Nrphys
        do j = 1,sNy
        do i = 1,sNx
         vbef(i,j,L,bi,bj) = vphy(i,j,L,bi,bj)
        enddo
        enddo
        enddo
        do L = 1,Nr
        do j = 1,sNy+1
        do i = 1,sNx
         vdynbef(i,j,L,bi,bj) = vvel(i,j,L,bi,bj)
        enddo
        enddo
        enddo
        enddo
        enddo
       endif
       if(diagnostics_is_on('TENDTFIZ',myThid) .or.
     &       diagnostics_is_on('CORRDT  ',myThid) ) then
        do bj = myByLo(myThid), myByHi(myThid)
        do bi = myBxLo(myThid), myBxHi(myThid)
        do L = 1,Nrphys
        do j = 1,sNy
        do i = 1,sNx
         thbef(i,j,L,bi,bj) = thphy(i,j,L,bi,bj)
        enddo
        enddo
        enddo
        do L = 1,Nr
        do j = 1,sNy
        do i = 1,sNx
         thdynbef(i,j,L,bi,bj) = theta(i,j,L,bi,bj)
        enddo
        enddo
        enddo
        enddo
        enddo
       endif
       if(diagnostics_is_on('TENDQFIZ',myThid) .or.
     &       diagnostics_is_on('CORRDQ  ',myThid) ) then
        do bj = myByLo(myThid), myByHi(myThid)
        do bi = myBxLo(myThid), myBxHi(myThid)
        do L = 1,Nrphys
        do j = 1,sNy
        do i = 1,sNx
         sbef(i,j,L,bi,bj) = sphy(i,j,L,bi,bj)
        enddo
        enddo
        enddo
        do L = 1,Nr
        do j = 1,sNy
        do i = 1,sNx
         sdynbef(i,j,L,bi,bj) = salt(i,j,L,bi,bj)
        enddo
        enddo
        enddo
        enddo
        enddo
       endif
      endif
#endif

       do bj = myByLo(myThid), myByHi(myThid)
       do bi = myBxLo(myThid), myBxHi(myThid)

c Construct the physics grid pressures
C  Note: Need one array to send to fizhi (top-down) and another
C        For the interpolations between physics and dynamics (bottom-up)
        do j = 1,sNy
        do i = 1,sNx
         pephy(i,j,1,bi,bj)=(Ro_surf(i,j,bi,bj) + etaH(i,j,bi,bj))
         do L = 2,Nrphys+1
          pephy(i,j,L,bi,bj)=pephy(i,j,L-1,bi,bj)-dpphys(i,j,L-1,bi,bj)
         enddo
c Do not use a zero field as the top edge pressure for interpolation
         do L = 1,Nrphys+1
          pephy4fiz(i,j,Nrphys+2-L,bi,bj)=pephy(i,j,L,bi,bj)
         enddo
         if(pephy(i,j,Nrphys+1,bi,bj).lt.1.e-5)
     &                               pephy(i,j,Nrphys+1,bi,bj) = 1.e-5
        enddo
        enddo
C Build pressures on dynamics grid
        do j = 1,sNy
        do i = 1,sNx
         do L = 1,Nr
          pedyn(i,j,L,bi,bj) = 0.
         enddo
        enddo
        enddo
        do j = 1,sNy
        do i = 1,sNx
         Lbotij = kSurfC(i,j,bi,bj)
         if(Lbotij.ne.0.)
     & pedyn(i,j,Lbotij,bi,bj) = (Ro_surf(i,j,bi,bj) + etaH(i,j,bi,bj))
        enddo
        enddo
        do j = 1,sNy
        do i = 1,sNx
         Lbotij = kSurfC(i,j,bi,bj)
         do L = Lbotij+1,Nr+1
          pedyn(i,j,L,bi,bj) = pedyn(i,j,L-1,bi,bj) -
     &           drF(L-1)* rStarExpC(i,j,bi,bj)*hfacC(i,j,L-1,bi,bj)
         enddo
c Do not use a zero field as the top edge pressure for interpolation
         if(pedyn(i,j,Nr+1,bi,bj).lt.1.e-5)
     &                               pedyn(i,j,Nr+1,bi,bj) = 1.e-5
        enddo
        enddo
       enddo
       enddo

#ifdef ALLOW_DIAGNOSTICS
      if ( useDiagnostics ) then
       if(diagnostics_is_on('FIZPRES ',myThid) ) then
        do bj = myByLo(myThid), myByHi(myThid)
        do bi = myBxLo(myThid), myBxHi(myThid)
        do j = 1,sNy
        do i = 1,sNx
        do L = 1,Nrphys
         tempphy(i,j,L,bi,bj) = pephy4fiz(i,j,L,bi,bj)
        enddo
        enddo
        enddo
        enddo
        enddo
        call diagnostics_fill(tempphy,'FIZPRES ',0,
     &                                     Nrphys,0,1,1,myThid)
       endif
      endif
#endif

       CALL TIMER_START ('DO_FIZHI          [FIZHI_WRAPPER]',myThid)
       do bj = myByLo(myThid), myByHi(myThid)
       do bi = myBxLo(myThid), myBxHi(myThid)
        call get_landfrac(im2,jm2,nSx,nSy,bi,bj,maxtyp,
     &        surftype,tilefrac,fracland(1,1,bi,bj))

#ifdef ALLOW_DIAGNOSTICS
      if ( useDiagnostics ) then
       if(diagnostics_is_on('SLP     ',myThid) ) then
        L = Nrphys+1
        do j = 1,sNy
        do i = 1,sNx
         tempdiag(i,j) = topoZ(i,j,bi,bj)*grav
         tempLdiag(i,j,L) = pephy4fiz(i,j,L,bi,bj)/100.
        enddo
        enddo
        do L = 1,Nrphys
        do j = 1,sNy
        do i = 1,sNx
         tempLdiag(i,j,L) = pephy4fiz(i,j,L,bi,bj)/100.
         tempLdiag2(i,j,L) = thphy(i,j,L,bi,bj) *
     &        (1.+0.609*sphy(i,j,L,bi,bj))

        enddo
        enddo
        enddo
        call slprs( tempdiag, tempLdiag, tempLdiag2,
     &              fracland(1,1,bi,bj),sNx,sNy,Nrphys,slp)
        call diagnostics_fill( slp,'SLP     ',1,1,3,bi,bj,myThid )
       endif
      endif
#endif
c
c Compute physics increments
        turbStart(bi,bj) = turbStart(bi,bj) .AND. ( myIter.EQ.nIter0 )

        call do_fizhi(myIter,myThid,
     &  idim1,idim2,jdim1,jdim2,Nrphys,nSx,nSy,im1,im2,jm1,jm2,bi,bj,
     &  turbStart(bi,bj), nchp,nchptot,nchpland,
     &  uphy,vphy,thphy,sphy,pephy4fiz,xC,yC,topoZ,
     &  ctmt,xxmt,yymt,zetamt,xlmt,khmt,tke,
     &  tgz,sst,sice,phis_var,landtype,fracland,emiss,albnirdr,albnirdf,
     &  albvisdr,albvisdf,ityp,chfr,alai,agrn,igrd,chlt,chlon,
     &  tcanopy,tdeep,ecanopy,swetshal,swetroot,swetdeep,snodep,capac,
     &  o3,qstr,co2,cfc11,cfc12,cfc22,n2o,methane,
     &  iras,nlwcld,cldtot_lw,cldras_lw,cldlsp_lw,nlwlz,lwlz,
     &  nswcld,cldtot_sw,cldras_sw,cldlsp_sw,nswlz,swlz,
     &  imstturbsw,imstturblw,qliqavesw,qliqavelw,fccavesw,fccavelw,
     &  raincon,rainlsp,snowfall,
     &  duphy,dvphy,dthphy,dsphy)
       enddo
       enddo

       CALL TIMER_STOP ('DO_FIZHI          [FIZHI_WRAPPER]',myThid)

       CALL TIMER_START ('PHYS2DYN          [FIZHI_WRAPPER]',myThid)
       do bj = myByLo(myThid), myByHi(myThid)
       do bi = myBxLo(myThid), myBxHi(myThid)
c Interpolate (A-Grid) physics increments to dynamics grid
C   First flip the physics arrays (which are top-down)
C   into bottom-up arrays for interpolation to dynamics grid
        do j = 1,sNy
        do i = 1,sNx
         do L = 1,Nrphys
          tempphy(i,j,Nrphys+1-L,bi,bj)=duphy(i,j,L,bi,bj)
         enddo
        enddo
        enddo
        call phys2dyn(tempphy,pephy,idim1,idim2,jdim1,jdim2,Nrphys,
     & nSx,nSy,im1,im2,jm1,jm2,bi,bj,pedyn,kSurfC,Nr,nlperdyn,guphy)
        do j = 1,sNy
        do i = 1,sNx
         do L = 1,Nrphys
          tempphy(i,j,Nrphys+1-L,bi,bj)=dvphy(i,j,L,bi,bj)
         enddo
        enddo
        enddo
        call phys2dyn(tempphy,pephy,idim1,idim2,jdim1,jdim2,Nrphys,
     & nSx,nSy,im1,im2,jm1,jm2,bi,bj,pedyn,kSurfC,Nr,nlperdyn,gvphy)
        do j = 1,sNy
        do i = 1,sNx
         do L = 1,Nrphys
          tempphy(i,j,Nrphys+1-L,bi,bj)=dthphy(i,j,L,bi,bj)
         enddo
        enddo
        enddo
        call phys2dyn(tempphy,pephy,idim1,idim2,jdim1,jdim2,Nrphys,
     & nSx,nSy,im1,im2,jm1,jm2,bi,bj,pedyn,kSurfC,Nr,nlperdyn,gthphy)
        do j = 1,sNy
        do i = 1,sNx
         do L = 1,Nrphys
          tempphy(i,j,Nrphys+1-L,bi,bj)=dsphy(i,j,L,bi,bj)
         enddo
        enddo
        enddo
        call phys2dyn(tempphy,pephy,idim1,idim2,jdim1,jdim2,Nrphys,
     & nSx,nSy,im1,im2,jm1,jm2,bi,bj,pedyn,kSurfC,Nr,nlperdyn,gsphy)

       enddo
       enddo

       CALL TIMER_STOP ('PHYS2DYN          [FIZHI_WRAPPER]',myThid)

c Convert guphy and gvphy from A-grid to C-grid for use by dynamics
       CALL TIMER_START ('ATOC              [FIZHI_WRAPPER]',myThid)
       call AtoC(myThid,guphy,gvphy,maskC,idim1,idim2,jdim1,jdim2,Nr,
     &                      nSx,nSy,im1,im2,jm1,jm2,guphy,gvphy)
       CALL TIMER_STOP ('ATOC              [FIZHI_WRAPPER]',myThid)

       CALL TIMER_START ('EXCHANGES         [FIZHI_WRAPPER]',myThid)
c Call the c-grid exchange routine to fill in the halo regions (du,dv)
       call exch_uv_xyz_RL(guphy,gvphy,.TRUE.,myThid)
c Call the a-grid exchange routine to fill in the halo regions (dth,ds)
       _EXCH_XYZ_RL(gthphy,myThid)
       _EXCH_XYZ_RL(gsphy,myThid)
       CALL TIMER_STOP ('EXCHANGES         [FIZHI_WRAPPER]',myThid)

      return
      end

#include "MOM_FLUXFORM_OPTIONS.h"

CBOP
C !ROUTINE: MOM_U_ADV_UU

C !INTERFACE: ==========================================================
      SUBROUTINE MOM_U_ADV_UU(
     I        bi,bj,k,
     I        uTrans, uFld,
     O        AdvectFluxUU,
     I        myThid)

C !DESCRIPTION:
C Calculates the zonal advective flux of zonal momentum:
C \begin{equation*}
C F^x = \overline{U}^i \overline{u}^{i}
C \end{equation*}

C !USES: ===============================================================
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"

C !INPUT PARAMETERS: ===================================================
C  bi,bj                :: tile indices
C  k                    :: vertical level
C  uTrans               :: zonal transport
C  uFld                 :: zonal flow
C  myThid               :: thread number
      INTEGER bi,bj,k
      _RL uTrans(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL uFld(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER myThid

C !OUTPUT PARAMETERS: ==================================================
C  AdvectFluxUU         :: advective flux
      _RL AdvectFluxUU(1-OLx:sNx+OLx,1-OLy:sNy+OLy)

C !LOCAL VARIABLES: ====================================================
C  i,j                  :: loop indices
      INTEGER i,j
CEOP

      DO j=1-Oly,sNy+Oly-1
       DO i=1-Olx,sNx+Olx-1
        AdvectFluxUU(i,j) =
     &  0.25*( uTrans(i,j) + uTrans(i+1,j) )
#ifdef MOM_BOUNDARY_CONSERVE
     &      *(   uFld(i,j)*_maskW(i+1,j,k,bi,bj)
     &         + uFld(i+1,j)*_maskW(i,j,k,bi,bj) )
#else
     &      *(   uFld(i,j) +   uFld(i+1,j) )
#endif
       ENDDO
      ENDDO

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#include "THSICE_OPTIONS.h"

CBOP
C     !ROUTINE: THSICE_MNC_INIT

C     !INTERFACE:
      SUBROUTINE THSICE_MNC_INIT( myThid )

C     !DESCRIPTION:
C     Initialize MNC variables for THSICE

C     !USES:
      IMPLICIT NONE

C     !INPUT/OUTPUT PARAMETERS:
      INTEGER myThid
CEOP

#ifdef ALLOW_MNC

C     =====  Fields for the pickups and snapshot output =====
      CALL MNC_CW_ADD_VNAME('iceMask','Cen_xy_Hn__-__t',3,4,myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('iceMask','units','---', myThid)

      CALL MNC_CW_ADD_VNAME('iceHeight','Cen_xy_Hn__-__t',3,4,myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('iceHeight','units','---', myThid)

      CALL MNC_CW_ADD_VNAME('snowHeight','Cen_xy_Hn__-__t',3,4,myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('snowHeight','units','---', myThid)

      CALL MNC_CW_ADD_VNAME('Tsrf','Cen_xy_Hn__-__t',3,4,myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('Tsrf','units','---', myThid)

      CALL MNC_CW_ADD_VNAME('Tice1','Cen_xy_Hn__-__t',3,4,myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('Tice1','units','---', myThid)

      CALL MNC_CW_ADD_VNAME('Tice2','Cen_xy_Hn__-__t',3,4,myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('Tice2','units','---', myThid)

      CALL MNC_CW_ADD_VNAME('Qice1','Cen_xy_Hn__-__t',3,4,myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('Qice1','units','---', myThid)

      CALL MNC_CW_ADD_VNAME('Qice2','Cen_xy_Hn__-__t',3,4,myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('Qice2','units','---', myThid)

      CALL MNC_CW_ADD_VNAME('snowAge','Cen_xy_Hn__-__t',3,4,myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('snowAge','units','---', myThid)

      CALL MNC_CW_ADD_VNAME('tOceMxL','Cen_xy_Hn__-__t',3,4,myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('tOceMxL','units','---', myThid)

      CALL MNC_CW_ADD_VNAME('sOceMxL','Cen_xy_Hn__-__t',3,4,myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('sOceMxL','units','---', myThid)

#endif

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      RETURN
      END

#include "LONGSTEP_OPTIONS.h"

CBOP
C !ROUTINE: LONGSTEP_FORCING_SURF

C !INTERFACE: ==========================================================
      SUBROUTINE LONGSTEP_FORCING_SURF(
     I                            bi, bj, iMin, iMax, jMin, jMax,
     I                            myTime, myIter, myThid )

C !DESCRIPTION:
C     Precomputes surface forcing term for pkg/ptracers.
C     Precomputation is needed because of non-local KPP transport term,
C     routine KPP_TRANSPORT_PTR.

C !USES: ===============================================================
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
c #include "GRID.h"
c #include "SURFACE.h"
c #include "FFIELDS.h"
c #include "DYNVARS.h"
#include "LONGSTEP.h"
#ifdef ALLOW_PTRACERS
# include "PTRACERS_SIZE.h"
# include "PTRACERS_PARAMS.h"
# include "PTRACERS_FIELDS.h"
#endif

C !INPUT PARAMETERS: ===================================================
C  bi,bj                :: tile indices
C  myTime               :: model time
C  myIter               :: time-step number
C  myThid               :: thread number
      INTEGER bi, bj, iMin, iMax, jMin, jMax
      _RL myTime
      INTEGER myIter
      INTEGER myThid

#ifdef ALLOW_LONGSTEP
#ifdef ALLOW_PTRACERS

C !LOCAL VARIABLES: ====================================================
C  i,j                  :: loop indices
C  iTrc                 :: tracer index
C  ks                   :: surface level index
      INTEGER i, j
      INTEGER iTrc, ks
CEOP

      IF ( usingPCoords ) THEN
        ks = Nr
      ELSE
        ks = 1
      ENDIF

C Example of how to add forcing at the surface
      DO iTrc=1,PTRACERS_numInUse
          DO j = jMin, jMax
           DO i = iMin, iMax
             surfaceForcingPTr(i,j,bi,bj,iTrc) =
     &               0. _d 0
c    &               surfaceForcingS(i,j,bi,bj)
           ENDDO
          ENDDO
      ENDDO

      IF ( (nonlinFreeSurf.GT.0 .OR. usingPCoords)
     &     .AND. useRealFreshWaterFlux ) THEN

       DO iTrc=1,PTRACERS_numInUse

c-  NonLin_FrSurf and RealFreshWaterFlux : PmEpR effectively changes
c   the water column height ; temp., salt, (tracer) flux associated
c   with this input/output of water is added here to the surface tendency.
c
c   NB: LS_fwflux is PmEpR
c
         IF (PTRACERS_EvPrRn(iTrc).NE.UNSET_RL) THEN
          DO j = jMin, jMax
           DO i = iMin, iMax
             surfaceForcingPTr(i,j,bi,bj,iTrc) =
     &          surfaceForcingPTr(i,j,bi,bj,iTrc)
     &        + LS_fwFlux(i,j,bi,bj)
     &          *( PTRACERS_EvPrRn(iTrc) - pTracer(i,j,ks,bi,bj,iTrc) )
     &          *mass2rUnit
           ENDDO
          ENDDO
         ENDIF

       ENDDO

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
      ELSE

C--   EmPmR does not really affect the water column height (for tracer budget)
C     and is converted to a salt tendency.

       IF (convertFW2Salt .EQ. -1.) THEN
C-    use local surface tracer field to calculate forcing term:

        DO iTrc=1,PTRACERS_numInUse

         IF (PTRACERS_EvPrRn(iTrc).NE.UNSET_RL) THEN
C        account for Rain/Evap tracer content (PTRACERS_EvPrRn) using
C        local surface tracer
c
c   NB: LS_fwflux is EmPmR

          DO j = jMin, jMax
           DO i = iMin, iMax
            surfaceForcingPTr(i,j,bi,bj,iTrc) =
     &          surfaceForcingPTr(i,j,bi,bj,iTrc)
     &        + LS_fwFlux(i,j,bi,bj)
     &          *( pTracer(i,j,ks,bi,bj,iTrc) - PTRACERS_EvPrRn(iTrc) )
     &          *mass2rUnit
           ENDDO
          ENDDO
         ENDIF

        ENDDO

       ELSE
C-    use uniform tracer value to calculate forcing term:

        DO iTrc=1,PTRACERS_numInUse

         IF (PTRACERS_EvPrRn(iTrc).NE.UNSET_RL) THEN
C     account for Rain/Evap tracer content (PTRACERS_EvPrRn) assuming uniform
C     surface tracer (=PTRACERS_ref)
c
c   NB: LS_fwflux is EmPmR

          DO j = jMin, jMax
           DO i = iMin, iMax
            surfaceForcingPTr(i,j,bi,bj,iTrc) =
     &          surfaceForcingPTr(i,j,bi,bj,iTrc)
     &        + LS_fwFlux(i,j,bi,bj)
     &            *( PTRACERS_ref(ks,iTrc) - PTRACERS_EvPrRn(iTrc) )
     &            *mass2rUnit
           ENDDO
          ENDDO
         ENDIF

        ENDDO

C-    end local-surface-tracer / uniform-value distinction
       ENDIF

      ENDIF

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#endif /* ALLOW_PTRACERS */
#endif /* ALLOW_LONGSTEP */

      RETURN
      END

#include "PACKAGES_CONFIG.h"
#include "CPP_OPTIONS.h"

CBOP
C     !ROUTINE: INI_GRID

C     !INTERFACE:
      SUBROUTINE INI_GRID( myThid )
C     !DESCRIPTION:
C     These arrays are used throughout the code in evaluating gradients,
C     integrals and spatial avarages. This routine is called separately
C     by each thread and initializes only the region of the domain it is
C     "responsible" for.

C     !CALLING SEQUENCE:
C     INI_GRID
C      |   -- LOAD_GRID_SPACING
C      |   -- INI_VERTICAL_GRID
C      |    / INI_CARTESIAN_GRID
C      |   /  INI_SPHERICAL_POLAR_GRID
C      |   \  INI_CURVILINEAR_GRID
C      |    \ INI_CYLINDER_GRID

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#ifdef ALLOW_MNC
#include "MNC_PARAMS.h"
#endif
#ifdef ALLOW_MONITOR
#include "MONITOR.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     myThid  :: my Thread Id number
      INTEGER myThid

C     !FUNCTIONS:
      LOGICAL  MASTER_CPU_IO
      EXTERNAL MASTER_CPU_IO

C     !LOCAL VARIABLES:
C     bi, bj  :: tile indices
C     i, j    :: Loop counters
C     msgBuf  :: Informational/error message buffer
      INTEGER bi, bj
      INTEGER i, j
      CHARACTER*(MAX_LEN_MBUF) msgBuf
CEOP

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C--   Load grid spacing (vector) from files
      CALL LOAD_GRID_SPACING( myThid )

C--   Set up vertical grid and coordinate system
      CALL INI_VERTICAL_GRID( myThid )

C--   Initialise (everywhere) all horizontal grid array to null value
C     Note: some arrays are not defined in some parts of the halo
C     region. We set them to zero here for safety. If they are ever
C     referred to, especially in the denominator then it is a mistake!
      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          xC(i,j,bi,bj)  = 0.
          yC(i,j,bi,bj)  = 0.
          xG(i,j,bi,bj)  = 0.
          yG(i,j,bi,bj)  = 0.
          dxC(i,j,bi,bj) = 0.
          dyC(i,j,bi,bj) = 0.
          dxG(i,j,bi,bj) = 0.
          dyG(i,j,bi,bj) = 0.
          dxF(i,j,bi,bj) = 0.
          dyF(i,j,bi,bj) = 0.
          dxV(i,j,bi,bj) = 0.
          dyU(i,j,bi,bj) = 0.
          rA(i,j,bi,bj)  = 0.
          rAz(i,j,bi,bj) = 0.
          rAw(i,j,bi,bj) = 0.
          rAs(i,j,bi,bj) = 0.
          recip_dxG(i,j,bi,bj) = 0.
          recip_dyG(i,j,bi,bj) = 0.
          recip_dxC(i,j,bi,bj) = 0.
          recip_dyC(i,j,bi,bj) = 0.
          recip_dxF(i,j,bi,bj) = 0.
          recip_dyF(i,j,bi,bj) = 0.
          recip_dxV(i,j,bi,bj) = 0.
          recip_dyU(i,j,bi,bj) = 0.
          recip_rA (i,j,bi,bj) = 0.
          recip_rAs(i,j,bi,bj) = 0.
          recip_rAw(i,j,bi,bj) = 0.
          recip_rAz(i,j,bi,bj) = 0.
          tanPhiAtU(i,j,bi,bj) = 0.
          tanPhiAtV(i,j,bi,bj) = 0.
          angleCosC(i,j,bi,bj) = 1.
          angleSinC(i,j,bi,bj) = 0.
          u2zonDir(i,j,bi,bj)  = 1.
          v2zonDir(i,j,bi,bj)  = 0.
         ENDDO
         cosFacU(j,bi,bj)   = 1.
         cosFacV(j,bi,bj)   = 1.
         sqCosFacU(j,bi,bj) = 1.
         sqCosFacV(j,bi,bj) = 1.
        ENDDO
       ENDDO
      ENDDO

C     Two examples are shown in this code. One illustrates the
C     initialization of a cartesian grid. The other shows the
C     inialization of a spherical polar grid. Other orthonormal grids
C     can be fitted into this design. In this case custom metric terms
C     also need adding to account for the projections of velocity
C     vectors onto these grids.  The structure used here also makes it
C     possible to implement less regular grid mappings. In particular:
C      o Schemes which leave out blocks of the domain that are
C        all land could be supported.
C      o Multi-level schemes such as icosohedral or cubic
C        grid projectedions onto a sphere can also be fitted
C       within the strategy we use.
C        Both of the above also require modifying the support
C        routines that map computational blocks to simulation
C        domain blocks.

C--   Set up horizontal grid and coordinate system
      IF ( usingCartesianGrid ) THEN
        CALL INI_CARTESIAN_GRID( myThid )
      ELSEIF ( usingSphericalPolarGrid ) THEN
        CALL INI_SPHERICAL_POLAR_GRID( myThid )
      ELSEIF ( usingCurvilinearGrid ) THEN
        CALL INI_CURVILINEAR_GRID( myThid )
      ELSEIF ( usingCylindricalGrid ) THEN
        CALL INI_CYLINDER_GRID( myThid )
      ELSE
        _BEGIN_MASTER(myThid)
        WRITE(msgBuf,'(2A)') 'S/R INI_GRID: ',
     &       'No grid coordinate system has been selected'
        CALL PRINT_ERROR( msgBuf , myThid)
        CALL ALL_PROC_DIE( 0 )
        STOP 'ABNORMAL END: S/R INI_GRID'
        _END_MASTER(myThid)
      ENDIF

C--   Calculate reciprocals grid lengths (formerly part of INI_MASKS_ETC)
      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          IF ( dxG(i,j,bi,bj) .NE. 0. )
     &    recip_dxG(i,j,bi,bj) = 1. _d 0/dxG(i,j,bi,bj)
          IF ( dyG(i,j,bi,bj) .NE. 0. )
     &    recip_dyG(i,j,bi,bj) = 1. _d 0/dyG(i,j,bi,bj)
          IF ( dxC(i,j,bi,bj) .NE. 0. )
     &    recip_dxC(i,j,bi,bj) = 1. _d 0/dxC(i,j,bi,bj)
          IF ( dyC(i,j,bi,bj) .NE. 0. )
     &    recip_dyC(i,j,bi,bj) = 1. _d 0/dyC(i,j,bi,bj)
          IF ( dxF(i,j,bi,bj) .NE. 0. )
     &    recip_dxF(i,j,bi,bj) = 1. _d 0/dxF(i,j,bi,bj)
          IF ( dyF(i,j,bi,bj) .NE. 0. )
     &    recip_dyF(i,j,bi,bj) = 1. _d 0/dyF(i,j,bi,bj)
          IF ( dxV(i,j,bi,bj) .NE. 0. )
     &    recip_dxV(i,j,bi,bj) = 1. _d 0/dxV(i,j,bi,bj)
          IF ( dyU(i,j,bi,bj) .NE. 0. )
     &    recip_dyU(i,j,bi,bj) = 1. _d 0/dyU(i,j,bi,bj)
          IF ( rA (i,j,bi,bj) .NE. 0. )
     &    recip_rA (i,j,bi,bj) = 1. _d 0/rA (i,j,bi,bj)
          IF ( rAs(i,j,bi,bj) .NE. 0. )
     &    recip_rAs(i,j,bi,bj) = 1. _d 0/rAs(i,j,bi,bj)
          IF ( rAw(i,j,bi,bj) .NE. 0. )
     &    recip_rAw(i,j,bi,bj) = 1. _d 0/rAw(i,j,bi,bj)
          IF ( rAz(i,j,bi,bj) .NE. 0. )
     &    recip_rAz(i,j,bi,bj) = 1. _d 0/rAz(i,j,bi,bj)
         ENDDO
        ENDDO
       ENDDO
      ENDDO

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#ifdef ALLOW_MONITOR
      IF ( MASTER_CPU_IO(myThid) ) THEN
C--   only the master thread is allowed to switch On/Off mon_write_stdout
C     & mon_write_mnc (since it is the only thread that uses those flags):

        IF (monitor_stdio) THEN
          mon_write_stdout = .TRUE.
        ELSE
          mon_write_stdout = .FALSE.
        ENDIF
        mon_write_mnc = .FALSE.
#ifdef ALLOW_MNC
        IF (useMNC .AND. monitor_mnc) THEN
          DO i = 1,MAX_LEN_MBUF
            mon_fname(i:i) = ' '
          ENDDO
          mon_fname(1:12) = 'monitor_grid'
          CALL MNC_CW_SET_UDIM(mon_fname, 1, myThid)
          mon_write_mnc = .TRUE.
        ENDIF
#endif /*  ALLOW_MNC  */

      ENDIF

C     Print out statistics of each horizontal grid array (helps when debugging)
      CALL MON_PRINTSTATS_RS(1,xC,'XC',myThid)
      CALL MON_PRINTSTATS_RS(1,xG,'XG',myThid)
      CALL MON_PRINTSTATS_RS(1,dxC,'DXC',myThid)
      CALL MON_PRINTSTATS_RS(1,dxF,'DXF',myThid)
      CALL MON_PRINTSTATS_RS(1,dxG,'DXG',myThid)
      CALL MON_PRINTSTATS_RS(1,dxV,'DXV',myThid)
      CALL MON_PRINTSTATS_RS(1,yC,'YC',myThid)
      CALL MON_PRINTSTATS_RS(1,yG,'YG',myThid)
      CALL MON_PRINTSTATS_RS(1,dyC,'DYC',myThid)
      CALL MON_PRINTSTATS_RS(1,dyF,'DYF',myThid)
      CALL MON_PRINTSTATS_RS(1,dyG,'DYG',myThid)
      CALL MON_PRINTSTATS_RS(1,dyU,'DYU',myThid)
      CALL MON_PRINTSTATS_RS(1,rA,'RA',myThid)
      CALL MON_PRINTSTATS_RS(1,rAw,'RAW',myThid)
      CALL MON_PRINTSTATS_RS(1,rAs,'RAS',myThid)
      CALL MON_PRINTSTATS_RS(1,rAz,'RAZ',myThid)
      CALL MON_PRINTSTATS_RS(1,angleCosC,'AngleCS',myThid)
      CALL MON_PRINTSTATS_RS(1,angleSinC,'AngleSN',myThid)

      IF ( MASTER_CPU_IO(myThid) ) THEN
        mon_write_stdout = .FALSE.
        mon_write_mnc    = .FALSE.
      ENDIF
#endif /* ALLOW_MONITOR */

C--   Everyone else must wait for the grid to be set
      _BARRIER

      RETURN
      END

#include "DIAG_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 0
C     !ROUTINE: DIAGSTATS_MNC_OUT

C     !INTERFACE:
      SUBROUTINE DIAGSTATS_MNC_OUT(
     I     statGlob, nLev, ndId,
     I     mId, listId, myTime, myIter, myThid )

C     !DESCRIPTION:
C     Write Global statistics to a netCDF file

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "EESUPPORT.h"
#include "PARAMS.h"
#include "GRID.h"
#include "DIAGNOSTICS_SIZE.h"
#include "DIAGNOSTICS.h"

#ifdef ALLOW_FIZHI
#include "fizhi_SIZE.h"
#else
      INTEGER Nrphys
      PARAMETER (Nrphys=0)
#endif

C     !INPUT PARAMETERS:
C     statGlob :: AVERAGED DIAGNOSTIC QUANTITY
C     nLev     :: 2nd Dimension (max Nb of levels) of statGlob array
C     ndId     :: diagnostic Id number (in diagnostics long list)
C     mId      :: field rank in list "listId"
C     listId   :: current output Stream list
C     myIter   :: current Iteration Number
C     myTime   :: current time of simulation (s)
C     myThid   :: my thread Id number
      INTEGER nLev
      _RL     statGlob(0:nStats,0:nLev,0:nRegions)
      _RL     myTime
      INTEGER ndId, mId, listId
      INTEGER myIter, myThid
CEOP

C     !LOCAL VARIABLES:
#ifdef ALLOW_MNC
      INTEGER im, ix, iv, ist
      PARAMETER ( iv = nStats - 2 , im = nStats - 1 , ix = nStats )
      INTEGER i, j, k
      CHARACTER*(MAX_LEN_FNAM) tnam
      CHARACTER*(3) stat_typ(5)
      INTEGER ILNBLNK
      EXTERNAL ILNBLNK
      INTEGER ii, ilen
      CHARACTER*(MAX_LEN_FNAM) diag_mnc_bn
      INTEGER CW_DIMS, NLEN
      PARAMETER ( CW_DIMS = 10 )
      PARAMETER ( NLEN    = 80 )
      INTEGER dim(CW_DIMS), ib(CW_DIMS), ie(CW_DIMS)
      CHARACTER*(NLEN) dn(CW_DIMS)
      CHARACTER*(NLEN) d_cw_gname
      CHARACTER*(NLEN) d_cw_gname0
      CHARACTER*(NLEN) dn_blnk
#ifdef DIAGST_MNC_NEEDSWORK
      CHARACTER*(5) ctmp
      _RS ztmp(Nr+Nrphys)
#endif
      _RL stmp(Nr+Nrphys+1,nRegions+1)
#endif /*  ALLOW_MNC  */

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#ifdef ALLOW_MNC

      _BEGIN_MASTER( myThid)

      stat_typ(1) = 'vol'
      stat_typ(2) = 'ave'
      stat_typ(3) = 'std'
      stat_typ(4) = 'min'
      stat_typ(5) = 'max'

#ifdef ALLOW_USE_MPI
      IF ( diagSt_MNC .AND. mpiMyId.EQ.0 ) THEN
#else
      IF ( diagSt_MNC ) THEN
#endif

        DO i = 1,MAX_LEN_FNAM
          diag_mnc_bn(i:i) = ' '
        ENDDO
        DO i = 1,NLEN
          dn_blnk(i:i) = ' '
        ENDDO
        ilen = ILNBLNK(diagSt_Fname(listId))
        WRITE(diag_mnc_bn, '(a)') diagSt_Fname(listId)(1:ilen)

        IF (mId .EQ. 1) THEN
C         Update the record dimension by writing the iteration number
          CALL MNC_CW_SET_UDIM(diag_mnc_bn, -1, myThid)
          CALL MNC_CW_RL_W_S('D',diag_mnc_bn,1,1,'T',myTime,myThid)
          CALL MNC_CW_SET_UDIM(diag_mnc_bn, 0, myThid)
          CALL MNC_CW_I_W_S('I',diag_mnc_bn,1,1,'iter',myIter,myThid)
        ENDIF

#ifdef DIAGST_MNC_NEEDSWORK
C       This is turned off for the time being but it should eventually
C       be re-worked and turned on so that coordinate dimensions are
C       supplied along with the data.  Unfortunately, the current
C       diagnostics system has **NO** way of telling us whether a
C       quantity is defined on a typical vertical grid (eg. the dynamics
C       grid), a gridalt--style grid, or a single-level field that has
C       no specified vertical location.

        dn(1)(1:NLEN) = dn_blnk(1:NLEN)
        WRITE(dn(1),'(a,i6.6)') 'Zmd', kdiag(ndId)
        dim(1) = kdiag(ndId)
        ib(1)  = 1
        ie(1)  = kdiag(ndId)

        CALL MNC_CW_ADD_GNAME('diag_levels', 1,
     &       dim, dn, ib, ie, myThid)
        CALL MNC_CW_ADD_VNAME('diag_levels', 'diag_levels',
     &       0,0, myThid)
        CALL MNC_CW_ADD_VATTR_TEXT('diag_levels','description',
     &       'Indicies of vertical levels within the source arrays',
     &       myThid)

        CALL MNC_CW_RL_W('D',diag_mnc_bn,1,1,
     &       'diag_levels', levs(1,listId), myThid)

        CALL MNC_CW_DEL_VNAME('diag_levels', myThid)
        CALL MNC_CW_DEL_GNAME('diag_levels', myThid)

C       Now define:  Zmdxxxxxx, Zudxxxxxx, Zldxxxxxx
        ctmp(1:5) = 'mul  '
        DO i = 1,3
          dn(1)(1:NLEN) = dn_blnk(1:NLEN)
          WRITE(dn(1),'(3a,i6.6)') 'Z',ctmp(i:i),'d',nlevels(listId)
          CALL MNC_CW_ADD_GNAME(dn(1), 1, dim, dn, ib, ie, myThid)
          CALL MNC_CW_ADD_VNAME(dn(1), dn(1), 0,0, myThid)

C         The following three ztmp() loops should eventually be modified
C         to reflect the fractional nature of levs(j,l) -- they should
C         do something like:
C            ztmp(j) = rC(INT(FLOOR(levs(j,l))))
C                      + ( rC(INT(FLOOR(levs(j,l))))
C                          + rC(INT(CEIL(levs(j,l)))) )
C                        / ( levs(j,l) - FLOOR(levs(j,l)) )
C         for averaged levels.
          IF (i .EQ. 1) THEN
            DO j = 1,nlevels(listId)
              ztmp(j) = rC(NINT(levs(j,listId)))
            ENDDO
            CALL MNC_CW_ADD_VATTR_TEXT(dn(1),'description',
     &           'Dimensional coordinate value at the mid point',
     &           myThid)
          ELSEIF (i .EQ. 2) THEN
            DO j = 1,nlevels(listId)
              ztmp(j) = rF(NINT(levs(j,listId)) + 1)
            ENDDO
            CALL MNC_CW_ADD_VATTR_TEXT(dn(1),'description',
     &           'Dimensional coordinate value at the upper point',
     &           myThid)
          ELSEIF (i .EQ. 3) THEN
            DO j = 1,nlevels(listId)
              ztmp(j) = rF(NINT(levs(j,listId)))
            ENDDO
            CALL MNC_CW_ADD_VATTR_TEXT(dn(1),'description',
     &           'Dimensional coordinate value at the lower point',
     &           myThid)
          ENDIF
          CALL MNC_CW_RS_W('D',diag_mnc_bn,1,1, dn(1), ztmp, myThid)
          CALL MNC_CW_DEL_VNAME(dn(1), myThid)
          CALL MNC_CW_DEL_GNAME(dn(1), myThid)
        ENDDO
#endif  /* DIAGST_MNC_NEEDSWORK */

        DO ii = 1,CW_DIMS
          d_cw_gname(1:NLEN) = dn_blnk(1:NLEN)
          dn(ii)(1:NLEN) = dn_blnk(1:NLEN)
        ENDDO

C       Z is special since it varies
        WRITE(dn(1),'(a,i6.6)') 'Zd', kdiag(ndId)
        IF ( (gdiag(ndId)(10:10) .EQ. 'R')
     &       .AND. (gdiag(ndId)(9:9) .EQ. 'M') ) THEN
          WRITE(dn(1),'(a,i6.6)') 'Zmd', kdiag(ndId)
        ENDIF
        IF ( (gdiag(ndId)(10:10) .EQ. 'R')
     &       .AND. (gdiag(ndId)(9:9) .EQ. 'L') ) THEN
          WRITE(dn(1),'(a,i6.6)') 'Zld', kdiag(ndId)
        ENDIF
        IF ( (gdiag(ndId)(10:10) .EQ. 'R')
     &       .AND. (gdiag(ndId)(9:9) .EQ. 'U') ) THEN
          WRITE(dn(1),'(a,i6.6)') 'Zud', kdiag(ndId)
        ENDIF
        dim(1) = Nr+Nrphys+1
        ib(1)  = 1
        ie(1)  = kdiag(ndId)

C       "region" dimension
        dim(2)     = nRegions + 1
        ib(2)      = 1
        dn(2)(1:6) = 'region'
        ie(2)      = nRegions + 1

C       Time dimension
        dn(3)(1:1) = 'T'
        dim(3)     = -1
        ib(3)      = 1
        ie(3)      = 1

C       Note that the "d_cw_gname" variable is a hack that hides a
C       subtlety within MNC.  Basically, each MNC-wrapped file is
C       caching its own concept of what each "grid name" (that is, a
C       dimension group name) means.  So one cannot re-use the same
C       "grid" name for different collections of dimensions within a
C       given file.  By appending the "ndId" values to each name, we
C       guarantee uniqueness within each MNC-produced file.

        WRITE(d_cw_gname,'(a7,i6.6)') 'dst_cw_', ndId
        CALL MNC_CW_ADD_GNAME(d_cw_gname, 3,
     &       dim, dn, ib, ie, myThid)

        WRITE(dn(1),'(a3)') 'Zd0'
        ie(1)  = 1
        WRITE(d_cw_gname0,'(a9,i6.6)') 'dst_cw_0_', ndId
        CALL MNC_CW_ADD_GNAME(d_cw_gname0, 3,
     &       dim, dn, ib, ie, myThid)

        DO ist = 0,nStats

          DO i = 1,MAX_LEN_FNAM
            tnam(i:i) = ' '
          ENDDO

c         IF ( kdiag(ndId) .GT. 1 ) THEN

            ilen = ILNBLNK(cdiag(ndId))
            WRITE(tnam,'(a,a1,a3)')
     &           cdiag(ndId)(1:ilen),'_',stat_typ(ist+1)

            CALL MNC_CW_ADD_VNAME(tnam, d_cw_gname0,
     &           0,0, myThid)
            CALL MNC_CW_ADD_VATTR_TEXT(tnam,'description',
     &           tdiag(ndId),myThid)
            CALL MNC_CW_ADD_VATTR_TEXT(tnam,'units',
     &           udiag(ndId),myThid)

C           Copy the data into a temporary with the necessary shape
            DO j = 0,nRegions
              stmp(1,j+1) = statGlob(ist,0,j)
            ENDDO

C-jmc: fflags is not for Statistics-Diagnostics, can be unset, and since
C-     size of the output file will not be an issue here: Always write real*8
c           IF ((fflags(listId)(1:1) .EQ. ' ')
c    &           .OR. (fflags(listId)(1:1) .EQ. 'R')) THEN
c
c             CALL MNC_CW_RL_W('R',diag_mnc_bn,1,1,
c    &             tnam, stmp, myThid)
c
c           ELSEIF (fflags(listId)(1:1) .EQ. 'D') THEN

              CALL MNC_CW_RL_W('D',diag_mnc_bn,1,1,
     &             tnam, stmp, myThid)

c           else
c             write(0,*) myIter, ndId, listId
c             write(0,'(3A)') '>',cdiag(ndId),'<'
c             write(0,'(3A)') '>',fflags(listId),'<'
c             STOP ' in DIAGSTATS_MNC_OUT'
c           ENDIF

            CALL MNC_CW_DEL_VNAME(tnam, myThid)

c         ENDIF

          IF ( kdiag(ndId) .GT. 1 ) THEN

            ilen = ILNBLNK(cdiag(ndId))
            WRITE(tnam,'(a,a4,a3)')
     &           cdiag(ndId)(1:ilen),'_lv_',stat_typ(ist+1)

            CALL MNC_CW_ADD_VNAME(tnam, d_cw_gname,
     &           0,0, myThid)
            CALL MNC_CW_ADD_VATTR_TEXT(tnam,'description',
     &           tdiag(ndId),myThid)
            CALL MNC_CW_ADD_VATTR_TEXT(tnam,'units',
     &         udiag(ndId),myThid)

C           Copy the data into a temporary with the necessary shape
            DO j = 0,nRegions
              DO k = 1,kdiag(ndId)
                stmp(k,j+1) = statGlob(ist,k,j)
              ENDDO
            ENDDO

C-jmc: Always write real*8 (size of the output file will not be an issue here)
              CALL MNC_CW_RL_W('D',diag_mnc_bn,1,1,
     &             tnam, stmp, myThid)

            CALL MNC_CW_DEL_VNAME(tnam, myThid)

          ENDIF

        ENDDO

        CALL MNC_CW_DEL_GNAME(d_cw_gname, myThid)
        CALL MNC_CW_DEL_GNAME(d_cw_gname0, myThid)

      ENDIF

      _END_MASTER( myThid )

#endif /*  ALLOW_MNC  */

      RETURN
      END
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#include "MDSIO_OPTIONS.h"

C--  File mdsio_gl.F: Routines to handle mid-level I/O interface.
C--   Contents
C--   o MDSREADFIELD_3D_GL
C--   o MDSWRITEFIELD_3D_GL
C--   o MDSREADFIELD_2D_GL
C--   o MDSWRITEFIELD_2D_GL

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      SUBROUTINE MDSREADFIELD_3D_GL(
     I   fName,
     I   filePrec,
     I   arrType,
     I   nNz,
     O   arr_gl,
     I   irecord,
     I   myThid )
C
C Arguments:
C
C fName     (string)  :: base name for file to read
C filePrec  (integer) :: number of bits per word in file (32 or 64)
C arrType   (char(2)) :: type of array "arr": either "RS" or "RL"
C nNz       (integer) :: size of third dimension: normally either 1 or Nr
C arr        (RS/RL)  :: array to read into, arr(:,:,nNz,:,:)
C irecord   (integer) :: record number to read
C myThid    (integer) :: thread identifier
C
C MDSREADFIELD first checks to see if the file "fName" exists, then
C if the file "fName.data" exists and finally the tiled files of the
C form "fName.xxx.yyy.data" exist. Currently, the meta-files are not
C read because it is difficult to parse files in fortran.
C The precision of the file is decsribed by filePrec, set either
C to floatPrec32 or floatPrec64. The precision or declaration of
C the array argument must be consistently described by the char*(2)
C string arrType, either "RS" or "RL". nNz allows for both 2-D and
C 3-D arrays to be handled. nNz=1 implies a 2-D model field and
C nNz=Nr implies a 3-D model field. irecord is the record number
C to be read and must be >= 1. The file data is stored in
C arr *but* the overlaps are *not* updated. ie. An exchange must
C be called. This is because the routine is sometimes called from
C within a MASTER_THID region.
C
C Created: 03/16/99 adcroft@mit.edu

      implicit none
C Global variables / common blocks
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"

C Routine arguments
      character*(*) fName
      integer filePrec
      character*(2) arrType
      integer nNz
      _RL arr_gl(sNx,nSx,nPx,sNy,nSy,nPy,Nr)
      integer irecord
      integer myThid

#ifdef ALLOW_CTRL

C Functions
      integer ILNBLNK
      integer MDS_RECLEN
C Local variables
      character*(MAX_LEN_FNAM) dataFName
      integer ip,jp,iG,jG,irec,bi,bj,i,j,k,dUnit,IL
      logical exst
      _RL arr(1-oLx:sNx+oLx,1-oLy:sNy+oLy,Nr,nSx,nSy)
      Real*4 r4seg(sNx)
      Real*8 r8seg(sNx)
      logical globalFile,fileIsOpen
      integer length_of_rec
      character*(max_len_mbuf) msgbuf
cph-usesingle(
      integer ii,jj
c     integer iG_IO,jG_IO,npe
      integer x_size,y_size
      PARAMETER ( x_size = Nx )
      PARAMETER ( y_size = Ny )
      Real*4 xy_buffer_r4(x_size,y_size)
      Real*8 xy_buffer_r8(x_size,y_size)
      Real*8 global(Nx,Ny)
c     _RL    local(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
cph-usesingle)
CMM(
      integer pIL
CMM)

C     ------------------------------------------------------------------

C Only do I/O if I am the master thread
      _BEGIN_MASTER( myThid )

#ifndef REAL4_IS_SLOW
      if (arrType .eq. 'RS') then
       write(msgbuf,'(a)')
     &   ' MDSREADFIELD_GL is wrong for arrType="RS" (=real*4)'
       call print_error( msgbuf, mythid )
       stop 'ABNORMAL END: S/R MDSREADFIELD_GL'
      endif
#endif

C Record number must be >= 1
      if (irecord .LT. 1) then
       write(msgbuf,'(a,i9.8)')
     &   ' MDSREADFIELD_GL: argument irecord = ',irecord
       call print_message( msgbuf, standardmessageunit,
     &                     SQUEEZE_RIGHT , mythid)
       write(msgbuf,'(a)')
     &   ' MDSREADFIELD_GL: Invalid value for irecord'
       call print_error( msgbuf, mythid )
       stop 'ABNORMAL END: S/R MDSREADFIELD_GL'
      endif

C Assume nothing
      globalFile = .FALSE.
      fileIsOpen = .FALSE.
      IL=ILNBLNK( fName )
CMM(
      pIL = ILNBLNK( mdsioLocalDir )
CMM)
CMM(
C Assign special directory
      if ( pIL.NE.0 ) then
       write(fName,'(2a)') mdsioLocalDir(1:pIL), fName(1:IL)
      endif
CMM)

C Assign a free unit number as the I/O channel for this routine
      call MDSFINDUNIT( dUnit, mythid )

      if ( useSingleCPUIO ) then

#ifdef ALLOW_USE_MPI
        IF( myProcId .EQ. 0 ) THEN
#else
        IF ( .TRUE. ) THEN
#endif /* ALLOW_USE_MPI */

C Check first for global file with simple name (ie. fName)
         dataFName = fName
         inquire( file=dataFname, exist=exst )
         if (exst) globalFile = .TRUE.

C If negative check for global file with MDS name (ie. fName.data)
         if (.NOT. globalFile) then
          write(dataFname,'(2a)') fName(1:IL),'.data'
          inquire( file=dataFname, exist=exst )
          if (exst) globalFile = .TRUE.
         endif

C If global file is visible to process 0, then open it here.
C Otherwise stop program.
         if ( globalFile) then
          length_of_rec=MDS_RECLEN( filePrec, x_size*y_size, mythid )
          open( dUnit, file=dataFName, status='old',
     &         access='direct', recl=length_of_rec )
         else
          write(msgbuf,'(2a)')
     &      ' MDSREADFIELD: filename: ',dataFName(1:IL)
          call print_message( msgbuf, standardmessageunit,
     &                        SQUEEZE_RIGHT , mythid)
          call print_error( msgbuf, mythid )
          write(msgbuf,'(a)')
     &      ' MDSREADFIELD: File does not exist'
          call print_message( msgbuf, standardmessageunit,
     &                        SQUEEZE_RIGHT , mythid)
          call print_error( msgbuf, mythid )
          stop 'ABNORMAL END: S/R MDSREADFIELD'
         endif

        ENDIF

c-- useSingleCpuIO
      else
C Only do I/O if I am the master thread

C Check first for global file with simple name (ie. fName)
       dataFName = fName
       inquire( file=dataFname, exist=exst )
       if (exst) then
        write(msgbuf,'(a,a)')
     &    ' MDSREADFIELD: opening global file: ',dataFName(1:IL)
        call print_message( msgbuf, standardmessageunit,
     &                      SQUEEZE_RIGHT , mythid)
       endif

C If negative check for global file with MDS name (ie. fName.data)
       if (.NOT. globalFile) then
        write(dataFname,'(2a)') fName(1:IL),'.data'
        inquire( file=dataFname, exist=exst )
        if (exst) then
         write(msgbuf,'(a,a)')
     &     ' MDSREADFIELD_GL: opening global file: ',dataFName(1:IL+5)
         call print_message( msgbuf, standardmessageunit,
     &                       SQUEEZE_RIGHT , mythid)
         globalFile = .TRUE.
        endif
       endif

c-- useSingleCpuIO
      endif

      if ( .not. useSingleCpuIO ) then
cph      if ( .not. ( globalFile .and. useSingleCPUIO ) ) then
      if ( .not. ( globalFile ) ) then

C If we are reading from a global file then we open it here
      if (globalFile) then
       length_of_rec=MDS_RECLEN( filePrec, sNx, mythid )
       open( dUnit, file=dataFName, status='old',
     &      access='direct', recl=length_of_rec )
       fileIsOpen=.TRUE.
      endif

C Loop over all processors
      do jp=1,nPy
      do ip=1,nPx
C Loop over all tiles
      do bj=1,nSy
      do bi=1,nSx
C If we are reading from a tiled MDS file then we open each one here
        if (.NOT. globalFile) then
         iG=bi+(ip-1)*nsx ! Kludge until unstructered tiles
         jG=bj+(jp-1)*nsy ! Kludge until unstructered tiles
         write(dataFname,'(2a,i3.3,a,i3.3,a)')
     &              fName(1:IL),'.',iG,'.',jG,'.data'
         inquire( file=dataFname, exist=exst )
C Of course, we only open the file if the tile is "active"
C (This is a place-holder for the active/passive mechanism
         if (exst) then
          if ( debugLevel .GE. debLevB ) then
           write(msgbuf,'(a,a)')
     &      ' MDSREADFIELD_GL: opening file: ',dataFName(1:IL+13)
           call print_message( msgbuf, standardmessageunit,
     &                        SQUEEZE_RIGHT , mythid)
          endif
          length_of_rec=MDS_RECLEN( filePrec, sNx, mythid )
          open( dUnit, file=dataFName, status='old',
     &        access='direct', recl=length_of_rec )
          fileIsOpen=.TRUE.
         else
          fileIsOpen=.FALSE.
          write(msgbuf,'(a,a)')
     &      ' MDSREADFIELD_GL: filename: ',dataFName(1:IL+13)
          call print_message( msgbuf, standardmessageunit,
     &                        SQUEEZE_RIGHT , mythid)
          call print_error( msgbuf, mythid )
          write(msgbuf,'(a)')
     &      ' MDSREADFIELD_GL: File does not exist'
          call print_message( msgbuf, standardmessageunit,
     &                        SQUEEZE_RIGHT , mythid)
          call print_error( msgbuf, mythid )
          stop 'ABNORMAL END: S/R MDSREADFIELD_GL'
         endif
        endif

        if (fileIsOpen) then
         do k=1,Nr
          do j=1,sNy
           if (globalFile) then
            iG=bi+(ip-1)*nsx
            jG=bj+(jp-1)*nsy
            irec=1 + INT(iG/sNx) + nSx*nPx*(jG+j-1) + nSx*nPx*Ny*(k-1)
     &             + nSx*nPx*Ny*nNz*(irecord-1)
           else
            iG = 0
            jG = 0
            irec=j + sNy*(k-1) + sNy*Nr*(irecord-1)
           endif
           if (filePrec .eq. precFloat32) then
            read(dUnit,rec=irec) r4seg
#ifdef _BYTESWAPIO
            call MDS_BYTESWAPR4( sNx, r4seg )
#endif
            if (arrType .eq. 'RS') then
#ifdef REAL4_IS_SLOW
             call MDS_SEG4toRS( j,bi,bj,k,Nr, r4seg, .TRUE., arr )
#endif
            elseif (arrType .eq. 'RL') then
             call MDS_SEG4toRL( j,bi,bj,k,Nr, r4seg, .TRUE., arr )
            else
             write(msgbuf,'(a)')
     &         ' MDSREADFIELD_GL: illegal value for arrType'
             call print_error( msgbuf, mythid )
             stop 'ABNORMAL END: S/R MDSREADFIELD_GL'
            endif
           elseif (filePrec .eq. precFloat64) then
            read(dUnit,rec=irec) r8seg
#ifdef _BYTESWAPIO
            call MDS_BYTESWAPR8( sNx, r8seg )
#endif
            if (arrType .eq. 'RS') then
#ifdef REAL4_IS_SLOW
             call MDS_SEG8toRS( j,bi,bj,k,Nr, r8seg, .TRUE., arr )
#endif
            elseif (arrType .eq. 'RL') then
             call MDS_SEG8toRL( j,bi,bj,k,Nr, r8seg, .TRUE., arr )
            else
             write(msgbuf,'(a)')
     &         ' MDSREADFIELD_GL: illegal value for arrType'
             call print_error( msgbuf, mythid )
             stop 'ABNORMAL END: S/R MDSREADFIELD_GL'
            endif
           else
            write(msgbuf,'(a)')
     &        ' MDSREADFIELD_GL: illegal value for filePrec'
            call print_error( msgbuf, mythid )
            stop 'ABNORMAL END: S/R MDSREADFIELD_GL'
           endif
       do ii=1,sNx
        arr_gl(ii,bi,ip,j,bj,jp,k)=arr(ii,j,k,bi,bj)
       enddo

C End of j loop
          enddo
C End of k loop
         enddo
         if (.NOT. globalFile) then
          close( dUnit )
          fileIsOpen = .FALSE.
         endif
        endif
C End of bi,bj loops
       enddo
      enddo
C End of ip,jp loops
       enddo
      enddo

C If global file was opened then close it
      if (fileIsOpen .AND. globalFile) then
       close( dUnit )
       fileIsOpen = .FALSE.
      endif

c      end of if ( .not. ( globalFile ) ) then
      endif

c      else of if ( .not. ( globalFile .and. useSingleCPUIO ) ) then
      else

       DO k=1,nNz

#ifdef ALLOW_USE_MPI
         IF( myProcId .EQ. 0 ) THEN
#else
         IF ( .TRUE. ) THEN
#endif /* ALLOW_USE_MPI */
          irec = k+nNz*(irecord-1)
          if (filePrec .eq. precFloat32) then
           read(dUnit,rec=irec) xy_buffer_r4
#ifdef _BYTESWAPIO
           call MDS_BYTESWAPR4( x_size*y_size, xy_buffer_r4 )
#endif
           DO J=1,Ny
            DO I=1,Nx
             global(I,J) = xy_buffer_r4(I,J)
            ENDDO
           ENDDO
          elseif (filePrec .eq. precFloat64) then
           read(dUnit,rec=irec) xy_buffer_r8
#ifdef _BYTESWAPIO
           call MDS_BYTESWAPR8( x_size*y_size, xy_buffer_r8 )
#endif
           DO J=1,Ny
            DO I=1,Nx
             global(I,J) = xy_buffer_r8(I,J)
            ENDDO
           ENDDO
          else
           write(msgbuf,'(a)')
     &            ' MDSREADFIELD: illegal value for filePrec'
           call print_error( msgbuf, mythid )
           stop 'ABNORMAL END: S/R MDSREADFIELD'
          endif
         ENDIF
        DO jp=1,nPy
         DO ip=1,nPx
          DO bj = myByLo(myThid), myByHi(myThid)
           DO bi = myBxLo(myThid), myBxHi(myThid)
            DO J=1,sNy
             JJ=((jp-1)*nSy+(bj-1))*sNy+J
             DO I=1,sNx
              II=((ip-1)*nSx+(bi-1))*sNx+I
              arr_gl(i,bi,ip,j,bj,jp,k) = global(II,JJ)
             ENDDO
            ENDDO
           ENDDO
          ENDDO
         ENDDO
        ENDDO

       ENDDO
c      ENDDO k=1,nNz

        close( dUnit )

      endif
c      end of if ( .not. ( globalFile .and. useSingleCPUIO ) ) then

      _END_MASTER( myThid )

#else /* ALLOW_CTRL */
      STOP 'ABNORMAL END: S/R MDSREADFIELD_3D_GL is empty'
#endif /* ALLOW_CTRL */
C     ------------------------------------------------------------------
      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      SUBROUTINE MDSWRITEFIELD_3D_GL(
     I   fName,
     I   filePrec,
     I   arrType,
     I   nNz,
     I   arr_gl,
     I   irecord,
     I   myIter,
     I   myThid )
C
C Arguments:
C
C fName     (string)  :: base name for file to write
C filePrec  (integer) :: number of bits per word in file (32 or 64)
C arrType   (char(2)) :: type of array "arr": either "RS" or "RL"
C nNz       (integer) :: size of third dimension: normally either 1 or Nr
C arr        (RS/RL)  :: array to write, arr(:,:,nNz,:,:)
C irecord   (integer) :: record number to write
C myIter    (integer) :: time step number
C myThid    (integer) :: thread identifier
C
C MDSWRITEFIELD creates either a file of the form "fName.data" and
C "fName.meta" if the logical flag "globalFile" is set true. Otherwise
C it creates MDS tiled files of the form "fName.xxx.yyy.data" and
C "fName.xxx.yyy.meta". A meta-file is always created.
C Currently, the meta-files are not read because it is difficult
C to parse files in fortran. We should read meta information before
C adding records to an existing multi-record file.
C The precision of the file is decsribed by filePrec, set either
C to floatPrec32 or floatPrec64. The precision or declaration of
C the array argument must be consistently described by the char*(2)
C string arrType, either "RS" or "RL". nNz allows for both 2-D and
C 3-D arrays to be handled. nNz=1 implies a 2-D model field and
C nNz=Nr implies a 3-D model field. irecord is the record number
C to be read and must be >= 1. NOTE: It is currently assumed that
C the highest record number in the file was the last record written.
C Nor is there a consistency check between the routine arguments and file.
C ie. if your write record 2 after record 4 the meta information
C will record the number of records to be 2. This, again, is because
C we have read the meta information. To be fixed.
C
C Created: 03/16/99 adcroft@mit.edu
C
C Changed: 05/31/00 heimbach@mit.edu
C          open(dUnit, ..., status='old', ... -> status='unknown'

      implicit none
C Global variables / common blocks
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"

C Routine arguments
      character*(*) fName
      integer filePrec
      character*(2) arrType
      integer nNz
cph(
cph      Real arr(*)
      _RL arr_gl(sNx,nSx,nPx,sNy,nSy,nPy,Nr)
cph)
      integer irecord
      integer myIter
      integer myThid

#ifdef ALLOW_CTRL

C Functions
      integer ILNBLNK
      integer MDS_RECLEN
C Local variables
      character*(MAX_LEN_FNAM) dataFName,metaFName
      integer ip,jp,iG,jG,irec,bi,bj,i,j,k,dUnit,IL
      Real*4 r4seg(sNx)
      Real*8 r8seg(sNx)
      _RL arr(1-oLx:sNx+oLx,1-oLy:sNy+oLy,Nr,nSx,nSy)
      INTEGER dimList(3,3), nDims, map2gl(2)
      _RL dummyRL(1)
      CHARACTER*8 blank8c
      integer length_of_rec
      logical fileIsOpen
      character*(max_len_mbuf) msgbuf
cph-usesingle(
#ifdef ALLOW_USE_MPI
      integer ii,jj
c     integer iG_IO,jG_IO,npe
      integer x_size,y_size
      PARAMETER ( x_size = Nx )
      PARAMETER ( y_size = Ny )
      Real*4 xy_buffer_r4(x_size,y_size)
      Real*8 xy_buffer_r8(x_size,y_size)
      Real*8 global(Nx,Ny)
#endif
cph-usesingle)
CMM(
      integer pIL
CMM)

      DATA dummyRL(1) / 0. _d 0 /
      DATA blank8c / '        ' /

C     ------------------------------------------------------------------

C Only do I/O if I am the master thread
      _BEGIN_MASTER( myThid )

#ifndef REAL4_IS_SLOW
      if (arrType .eq. 'RS') then
       write(msgbuf,'(a)')
     &   ' MDSWRITEFIELD_GL is wrong for arrType="RS" (=real*4)'
       call print_error( msgbuf, mythid )
       stop 'ABNORMAL END: S/R MDSWRITEFIELD_GL'
      endif
#endif

C Record number must be >= 1
      if (irecord .LT. 1) then
       write(msgbuf,'(a,i9.8)')
     &   ' MDSWRITEFIELD_GL: argument irecord = ',irecord
       call print_message( msgbuf, standardmessageunit,
     &                     SQUEEZE_RIGHT , mythid)
       write(msgbuf,'(a)')
     &   ' MDSWRITEFIELD_GL: invalid value for irecord'
       call print_error( msgbuf, mythid )
       stop 'ABNORMAL END: S/R MDSWRITEFIELD_GL'
      endif

C Assume nothing
      fileIsOpen=.FALSE.
      IL=ILNBLNK( fName )
CMM(
      pIL = ILNBLNK( mdsioLocalDir )
CMM)
CMM(
C Assign special directory
      if ( pIL.NE.0 ) then
       write(fName,'(2a)') mdsioLocalDir(1:pIL), fName(1:IL)
      endif
CMM)

C Assign a free unit number as the I/O channel for this routine
      call MDSFINDUNIT( dUnit, mythid )

cph-usesingle(
#ifdef ALLOW_USE_MPI
      _END_MASTER( myThid )
C If option globalFile is desired but does not work or if
C globalFile is too slow, then try using single-CPU I/O.
      if (useSingleCpuIO) then

C Master thread of process 0, only, opens a global file
       _BEGIN_MASTER( myThid )
        IF( myProcId .EQ. 0 ) THEN
         write(dataFname,'(2a)') fName(1:IL),'.data'
         length_of_rec=MDS_RECLEN(filePrec,x_size*y_size,mythid)
         if (irecord .EQ. 1) then
          open( dUnit, file=dataFName, status=_NEW_STATUS,
     &        access='direct', recl=length_of_rec )
         else
          open( dUnit, file=dataFName, status=_OLD_STATUS,
     &        access='direct', recl=length_of_rec )
         endif
        ENDIF
       _END_MASTER( myThid )

C Gather array and write it to file, one vertical level at a time
       DO k=1,nNz
C Loop over all processors
        do jp=1,nPy
        do ip=1,nPx
        DO bj = myByLo(myThid), myByHi(myThid)
         DO bi = myBxLo(myThid), myBxHi(myThid)
          DO J=1,sNy
           JJ=((jp-1)*nSy+(bj-1))*sNy+J
           DO I=1,sNx
            II=((ip-1)*nSx+(bi-1))*sNx+I
            global(II,JJ) = arr_gl(i,bi,ip,j,bj,jp,k)
           ENDDO
          ENDDO
         ENDDO
        ENDDO
        enddo
        enddo
        _BEGIN_MASTER( myThid )
         IF( myProcId .EQ. 0 ) THEN
          irec=k+nNz*(irecord-1)
          if (filePrec .eq. precFloat32) then
           DO J=1,Ny
            DO I=1,Nx
             xy_buffer_r4(I,J) = global(I,J)
            ENDDO
           ENDDO
#ifdef _BYTESWAPIO
           call MDS_BYTESWAPR4( x_size*y_size, xy_buffer_r4 )
#endif
           write(dUnit,rec=irec) xy_buffer_r4
          elseif (filePrec .eq. precFloat64) then
           DO J=1,Ny
            DO I=1,Nx
             xy_buffer_r8(I,J) = global(I,J)
            ENDDO
           ENDDO
#ifdef _BYTESWAPIO
           call MDS_BYTESWAPR8( x_size*y_size, xy_buffer_r8 )
#endif
           write(dUnit,rec=irec) xy_buffer_r8
          else
           write(msgbuf,'(a)')
     &       ' MDSWRITEFIELD: illegal value for filePrec'
           call print_error( msgbuf, mythid )
           stop 'ABNORMAL END: S/R MDSWRITEFIELD'
          endif
         ENDIF
        _END_MASTER( myThid )
       ENDDO

C Close data-file and create meta-file
       _BEGIN_MASTER( myThid )
        IF( myProcId .EQ. 0 ) THEN
         close( dUnit )
         write(metaFName,'(2a)') fName(1:IL),'.meta'
         dimList(1,1)=Nx
         dimList(2,1)=1
         dimList(3,1)=Nx
         dimList(1,2)=Ny
         dimList(2,2)=1
         dimList(3,2)=Ny
         dimList(1,3)=nNz
         dimList(2,3)=1
         dimList(3,3)=nNz
         nDims=3
         if (nNz .EQ. 1) nDims=2
         map2gl(1) = 0
         map2gl(2) = 1
         CALL MDS_WRITE_META(
     I              metaFName, dataFName, the_run_name, ' ',
     I              filePrec, nDims, dimList, map2gl, 0, blank8c,
     I              0, dummyRL, oneRL, irecord, myIter, myThid )
        ENDIF
       _END_MASTER( myThid )
C To be safe, make other processes wait for I/O completion
       _BARRIER

      elseif ( .NOT. useSingleCpuIO ) then
      _BEGIN_MASTER( myThid )
#endif /* ALLOW_USE_MPI */
cph-usesingle)

C Loop over all processors
      do jp=1,nPy
      do ip=1,nPx
C Loop over all tiles
      do bj=1,nSy
       do bi=1,nSx
C If we are writing to a tiled MDS file then we open each one here
         iG=bi+(ip-1)*nsx ! Kludge until unstructered tiles
         jG=bj+(jp-1)*nsy ! Kludge until unstructered tiles
         write(dataFname,'(2a,i3.3,a,i3.3,a)')
     &              fName(1:IL),'.',iG,'.',jG,'.data'
         if (irecord .EQ. 1) then
          length_of_rec=MDS_RECLEN( filePrec, sNx, mythid )
          open( dUnit, file=dataFName, status=_NEW_STATUS,
     &       access='direct', recl=length_of_rec )
          fileIsOpen=.TRUE.
         else
          length_of_rec=MDS_RECLEN( filePrec, sNx, mythid )
          open( dUnit, file=dataFName, status=_OLD_STATUS,
     &       access='direct', recl=length_of_rec )
          fileIsOpen=.TRUE.
         endif
        if (fileIsOpen) then
         do k=1,Nr
          do j=1,sNy
             do i=1,sNx
                arr(i,j,k,bi,bj)=arr_gl(i,bi,ip,j,bj,jp,k)
             enddo
            iG = 0
            jG = 0
            irec=j + sNy*(k-1) + sNy*Nr*(irecord-1)
           if (filePrec .eq. precFloat32) then
            if (arrType .eq. 'RS') then
#ifdef REAL4_IS_SLOW
             call MDS_SEG4toRS( j,bi,bj,k,Nr, r4seg, .FALSE., arr )
#endif
            elseif (arrType .eq. 'RL') then
             call MDS_SEG4toRL( j,bi,bj,k,Nr, r4seg, .FALSE., arr )
            else
             write(msgbuf,'(a)')
     &         ' MDSWRITEFIELD_GL: illegal value for arrType'
             call print_error( msgbuf, mythid )
             stop 'ABNORMAL END: S/R MDSWRITEFIELD_GL'
            endif
#ifdef _BYTESWAPIO
            call MDS_BYTESWAPR4( sNx, r4seg )
#endif
            write(dUnit,rec=irec) r4seg
           elseif (filePrec .eq. precFloat64) then
            if (arrType .eq. 'RS') then
#ifdef REAL4_IS_SLOW
             call MDS_SEG8toRS( j,bi,bj,k,Nr, r8seg, .FALSE., arr )
#endif
            elseif (arrType .eq. 'RL') then
             call MDS_SEG8toRL( j,bi,bj,k,Nr, r8seg, .FALSE., arr )
            else
             write(msgbuf,'(a)')
     &         ' MDSWRITEFIELD_GL: illegal value for arrType'
             call print_error( msgbuf, mythid )
             stop 'ABNORMAL END: S/R MDSWRITEFIELD_GL'
            endif
#ifdef _BYTESWAPIO
            call MDS_BYTESWAPR8( sNx, r8seg )
#endif
            write(dUnit,rec=irec) r8seg
           else
            write(msgbuf,'(a)')
     &        ' MDSWRITEFIELD_GL: illegal value for filePrec'
            call print_error( msgbuf, mythid )
            stop 'ABNORMAL END: S/R MDSWRITEFIELD_GL'
           endif
C End of j loop
          enddo
C End of k loop
         enddo
        else
         write(msgbuf,'(a)')
     &     ' MDSWRITEFIELD_GL: I should never get to this point'
         call print_error( msgbuf, mythid )
         stop 'ABNORMAL END: S/R MDSWRITEFIELD_GL'
        endif
C If we were writing to a tiled MDS file then we close it here
        if (fileIsOpen) then
         close( dUnit )
         fileIsOpen = .FALSE.
        endif
C Create meta-file for each tile if we are tiling
         iG=bi+(ip-1)*nsx ! Kludge until unstructered tiles
         jG=bj+(jp-1)*nsy ! Kludge until unstructered tiles
         write(metaFname,'(2a,i3.3,a,i3.3,a)')
     &              fName(1:IL),'.',iG,'.',jG,'.meta'
         dimList(1,1)=Nx
         dimList(2,1)=((ip-1)*nSx+(bi-1))*sNx+1
         dimList(3,1)=((ip-1)*nSx+bi)*sNx
         dimList(1,2)=Ny
         dimList(2,2)=((jp-1)*nSy+(bj-1))*sNy+1
         dimList(3,2)=((jp-1)*nSy+bj)*sNy
         dimList(1,3)=Nr
         dimList(2,3)=1
         dimList(3,3)=Nr
         nDims=3
         if (Nr .EQ. 1) nDims=2
         map2gl(1) = 0
         map2gl(2) = 1
         CALL MDS_WRITE_META(
     I              metaFName, dataFName, the_run_name, ' ',
     I              filePrec, nDims, dimList, map2gl, 0, blank8c,
     I              0, dummyRL, oneRL, irecord, myIter, myThid )
C End of bi,bj loops
       enddo
      enddo
C End of ip,jp loops
       enddo
      enddo

      _END_MASTER( myThid )

cph-usesingle(
#ifdef ALLOW_USE_MPI
C endif useSingleCpuIO
      endif
#endif /* ALLOW_USE_MPI */
cph-usesingle)

#else /* ALLOW_CTRL */
      STOP 'ABNORMAL END: S/R MDSWRITEFIELD_3D_GL is empty'
#endif /* ALLOW_CTRL */
C     ------------------------------------------------------------------
      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      SUBROUTINE MDSREADFIELD_2D_GL(
     I   fName,
     I   filePrec,
     I   arrType,
     I   nNz,
     O   arr_gl,
     I   irecord,
     I   myThid )
C
C Arguments:
C
C fName     (string)  :: base name for file to read
C filePrec  (integer) :: number of bits per word in file (32 or 64)
C arrType   (char(2)) :: type of array "arr": either "RS" or "RL"
C nNz       (integer) :: size of third dimension: normally either 1 or Nr
C arr        (RS/RL)  :: array to read into, arr(:,:,nNz,:,:)
C irecord   (integer) :: record number to read
C myThid    (integer) :: thread identifier
C
C MDSREADFIELD first checks to see if the file "fName" exists, then
C if the file "fName.data" exists and finally the tiled files of the
C form "fName.xxx.yyy.data" exist. Currently, the meta-files are not
C read because it is difficult to parse files in fortran.
C The precision of the file is decsribed by filePrec, set either
C to floatPrec32 or floatPrec64. The precision or declaration of
C the array argument must be consistently described by the char*(2)
C string arrType, either "RS" or "RL". nNz allows for both 2-D and
C 3-D arrays to be handled. nNz=1 implies a 2-D model field and
C nNz=Nr implies a 3-D model field. irecord is the record number
C to be read and must be >= 1. The file data is stored in
C arr *but* the overlaps are *not* updated. ie. An exchange must
C be called. This is because the routine is sometimes called from
C within a MASTER_THID region.
C
C Created: 03/16/99 adcroft@mit.edu

      implicit none
C Global variables / common blocks
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"

C Routine arguments
      character*(*) fName
      integer filePrec
      character*(2) arrType
      integer nNz, nLocz
      parameter (nLocz = 1)
      _RL arr_gl(sNx,nSx,nPx,sNy,nSy,nPy,nLocz)
      integer irecord
      integer myThid

#ifdef ALLOW_CTRL

C Functions
      integer ILNBLNK
      integer MDS_RECLEN
C Local variables
      character*(MAX_LEN_FNAM) dataFName
      integer ip,jp,iG,jG,irec,bi,bj,i,j,k,dUnit,IL
      logical exst
      _RL arr(1-oLx:sNx+oLx,1-oLy:sNy+oLy,nLocz,nSx,nSy)
      Real*4 r4seg(sNx)
      Real*8 r8seg(sNx)
      logical globalFile,fileIsOpen
      integer length_of_rec
      character*(max_len_mbuf) msgbuf
cph-usesingle(
      integer ii,jj
c     integer iG_IO,jG_IO,npe
      integer x_size,y_size
      PARAMETER ( x_size = Nx )
      PARAMETER ( y_size = Ny )
      Real*4 xy_buffer_r4(x_size,y_size)
      Real*8 xy_buffer_r8(x_size,y_size)
      Real*8 global(Nx,Ny)
c     _RL    local(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
cph-usesingle)
CMM(
      integer pIL
CMM)

C     ------------------------------------------------------------------

C Only do I/O if I am the master thread
      _BEGIN_MASTER( myThid )

#ifndef REAL4_IS_SLOW
      if (arrType .eq. 'RS') then
       write(msgbuf,'(a)')
     &   ' MDSREADFIELD_GL is wrong for arrType="RS" (=real*4)'
       call print_error( msgbuf, mythid )
       stop 'ABNORMAL END: S/R MDSREADFIELD_GL'
      endif
#endif

C Record number must be >= 1
      if (irecord .LT. 1) then
       write(msgbuf,'(a,i9.8)')
     &   ' MDSREADFIELD_GL: argument irecord = ',irecord
       call print_message( msgbuf, standardmessageunit,
     &                     SQUEEZE_RIGHT , mythid)
       write(msgbuf,'(a)')
     &   ' MDSREADFIELD_GL: Invalid value for irecord'
       call print_error( msgbuf, mythid )
       stop 'ABNORMAL END: S/R MDSREADFIELD_GL'
      endif

C Assume nothing
      globalFile = .FALSE.
      fileIsOpen = .FALSE.
      IL=ILNBLNK( fName )
CMM(
      pIL = ILNBLNK( mdsioLocalDir )
CMM)
CMM(
C Assign special directory
      if ( pIL.NE.0 ) then
       write(fName,'(2a)') mdsioLocalDir(1:pIL), fName(1:IL)
      endif
CMM)

C Assign a free unit number as the I/O channel for this routine
      call MDSFINDUNIT( dUnit, mythid )

      if ( useSingleCPUIO ) then

C master thread of process 0, only, opens a global file
#ifdef ALLOW_USE_MPI
        IF( myProcId .EQ. 0 ) THEN
#else
        IF ( .TRUE. ) THEN
#endif /* ALLOW_USE_MPI */

C Check first for global file with simple name (ie. fName)
         dataFName = fName
         inquire( file=dataFname, exist=exst )
         if (exst) globalFile = .TRUE.

C If negative check for global file with MDS name (ie. fName.data)
         if (.NOT. globalFile) then
          write(dataFname,'(2a)') fName(1:IL),'.data'
          inquire( file=dataFname, exist=exst )
          if (exst) globalFile = .TRUE.
         endif

C If global file is visible to process 0, then open it here.
C Otherwise stop program.
         if ( globalFile) then
          length_of_rec=MDS_RECLEN( filePrec, x_size*y_size, mythid )
          open( dUnit, file=dataFName, status='old',
     &         access='direct', recl=length_of_rec )
         else
          write(msgbuf,'(2a)')
     &      ' MDSREADFIELD: filename: ',dataFName(1:IL)
          call print_message( msgbuf, standardmessageunit,
     &                        SQUEEZE_RIGHT , mythid)
          call print_error( msgbuf, mythid )
          write(msgbuf,'(a)')
     &      ' MDSREADFIELD: File does not exist'
          call print_message( msgbuf, standardmessageunit,
     &                        SQUEEZE_RIGHT , mythid)
          call print_error( msgbuf, mythid )
          stop 'ABNORMAL END: S/R MDSREADFIELD'
         endif

        ENDIF

c-- useSingleCpuIO
      else

C Check first for global file with simple name (ie. fName)
       dataFName = fName
       inquire( file=dataFname, exist=exst )
       if (exst) then
        write(msgbuf,'(a,a)')
     &    ' MDSREADFIELD: opening global file: ',dataFName(1:IL)
        call print_message( msgbuf, standardmessageunit,
     &                      SQUEEZE_RIGHT , mythid)
       endif

C If negative check for global file with MDS name (ie. fName.data)
       if (.NOT. globalFile) then
        write(dataFname,'(2a)') fName(1:IL),'.data'
        inquire( file=dataFname, exist=exst )
        if (exst) then
         write(msgbuf,'(a,a)')
     &     ' MDSREADFIELD_GL: opening global file: ',dataFName(1:IL+5)
         call print_message( msgbuf, standardmessageunit,
     &                       SQUEEZE_RIGHT , mythid)
         globalFile = .TRUE.
        endif
       endif

c-- useSingleCpuIO
      endif

      if ( .not. useSingleCpuIO ) then
cph      if ( .not. ( globalFile .and. useSingleCPUIO ) ) then
      if ( .not. ( globalFile ) ) then

C If we are reading from a global file then we open it here
      if (globalFile) then
       length_of_rec=MDS_RECLEN( filePrec, sNx, mythid )
       open( dUnit, file=dataFName, status='old',
     &      access='direct', recl=length_of_rec )
       fileIsOpen=.TRUE.
      endif

C Loop over all processors
      do jp=1,nPy
      do ip=1,nPx
C Loop over all tiles
      do bj=1,nSy
      do bi=1,nSx
C If we are reading from a tiled MDS file then we open each one here
        if (.NOT. globalFile) then
         iG=bi+(ip-1)*nsx ! Kludge until unstructered tiles
         jG=bj+(jp-1)*nsy ! Kludge until unstructered tiles
         write(dataFname,'(2a,i3.3,a,i3.3,a)')
     &              fName(1:IL),'.',iG,'.',jG,'.data'
         inquire( file=dataFname, exist=exst )
C Of course, we only open the file if the tile is "active"
C (This is a place-holder for the active/passive mechanism
         if (exst) then
          if ( debugLevel .GE. debLevB ) then
           write(msgbuf,'(a,a)')
     &      ' MDSREADFIELD_GL: opening file: ',dataFName(1:IL+13)
           call print_message( msgbuf, standardmessageunit,
     &                        SQUEEZE_RIGHT , mythid)
          endif
          length_of_rec=MDS_RECLEN( filePrec, sNx, mythid )
          open( dUnit, file=dataFName, status='old',
     &        access='direct', recl=length_of_rec )
          fileIsOpen=.TRUE.
         else
          fileIsOpen=.FALSE.
          write(msgbuf,'(a,a)')
     &      ' MDSREADFIELD_GL: filename: ',dataFName(1:IL+13)
          call print_message( msgbuf, standardmessageunit,
     &                        SQUEEZE_RIGHT , mythid)
          call print_error( msgbuf, mythid )
          write(msgbuf,'(a)')
     &      ' MDSREADFIELD_GL: File does not exist'
          call print_message( msgbuf, standardmessageunit,
     &                        SQUEEZE_RIGHT , mythid)
          call print_error( msgbuf, mythid )
          stop 'ABNORMAL END: S/R MDSREADFIELD_GL'
         endif
        endif

        if (fileIsOpen) then
         do k=1,nLocz
          do j=1,sNy
           if (globalFile) then
            iG=bi+(ip-1)*nsx
            jG=bj+(jp-1)*nsy
            irec=1 + INT(iG/sNx) + nSx*nPx*(jG+j-1) + nSx*nPx*Ny*(k-1)
     &             + nSx*nPx*Ny*nLocz*(irecord-1)
           else
            iG = 0
            jG = 0
            irec=j + sNy*(k-1) + sNy*nLocz*(irecord-1)
           endif
           if (filePrec .eq. precFloat32) then
            read(dUnit,rec=irec) r4seg
#ifdef _BYTESWAPIO
            call MDS_BYTESWAPR4( sNx, r4seg )
#endif
            if (arrType .eq. 'RS') then
#ifdef REAL4_IS_SLOW
             call MDS_SEG4toRS( j,bi,bj,k,nLocz, r4seg, .TRUE., arr )
#endif
            elseif (arrType .eq. 'RL') then
             call MDS_SEG4toRL( j,bi,bj,k,nLocz, r4seg, .TRUE., arr )
            else
             write(msgbuf,'(a)')
     &         ' MDSREADFIELD_GL: illegal value for arrType'
             call print_error( msgbuf, mythid )
             stop 'ABNORMAL END: S/R MDSREADFIELD_GL'
            endif
           elseif (filePrec .eq. precFloat64) then
            read(dUnit,rec=irec) r8seg
#ifdef _BYTESWAPIO
            call MDS_BYTESWAPR8( sNx, r8seg )
#endif
            if (arrType .eq. 'RS') then
#ifdef REAL4_IS_SLOW
             call MDS_SEG8toRS( j,bi,bj,k,nLocz, r8seg, .TRUE., arr )
#endif
            elseif (arrType .eq. 'RL') then
             call MDS_SEG8toRL( j,bi,bj,k,nLocz, r8seg, .TRUE., arr )
            else
             write(msgbuf,'(a)')
     &         ' MDSREADFIELD_GL: illegal value for arrType'
             call print_error( msgbuf, mythid )
             stop 'ABNORMAL END: S/R MDSREADFIELD_GL'
            endif
           else
            write(msgbuf,'(a)')
     &        ' MDSREADFIELD_GL: illegal value for filePrec'
            call print_error( msgbuf, mythid )
            stop 'ABNORMAL END: S/R MDSREADFIELD_GL'
           endif
       do ii=1,sNx
        arr_gl(ii,bi,ip,j,bj,jp,k)=arr(ii,j,k,bi,bj)
       enddo

C End of j loop
          enddo
C End of k loop
         enddo
         if (.NOT. globalFile) then
          close( dUnit )
          fileIsOpen = .FALSE.
         endif
        endif
C End of bi,bj loops
       enddo
      enddo
C End of ip,jp loops
       enddo
      enddo

C If global file was opened then close it
      if (fileIsOpen .AND. globalFile) then
       close( dUnit )
       fileIsOpen = .FALSE.
      endif

c      end of if ( .not. ( globalFile ) ) then
      endif

c      else of if ( .not. ( globalFile .and. useSingleCPUIO ) ) then
      else

       DO k=1,nLocz

#ifdef ALLOW_USE_MPI
         IF( myProcId .EQ. 0 ) THEN
#else
         IF ( .TRUE. ) THEN
#endif /* ALLOW_USE_MPI */
          irec = k+nNz*(irecord-1)
          if (filePrec .eq. precFloat32) then
           read(dUnit,rec=irec) xy_buffer_r4
#ifdef _BYTESWAPIO
           call MDS_BYTESWAPR4( x_size*y_size, xy_buffer_r4 )
#endif
           DO J=1,Ny
            DO I=1,Nx
             global(I,J) = xy_buffer_r4(I,J)
            ENDDO
           ENDDO
          elseif (filePrec .eq. precFloat64) then
           read(dUnit,rec=irec) xy_buffer_r8
#ifdef _BYTESWAPIO
           call MDS_BYTESWAPR8( x_size*y_size, xy_buffer_r8 )
#endif
           DO J=1,Ny
            DO I=1,Nx
             global(I,J) = xy_buffer_r8(I,J)
            ENDDO
           ENDDO
          else
           write(msgbuf,'(a)')
     &            ' MDSREADFIELD: illegal value for filePrec'
           call print_error( msgbuf, mythid )
           stop 'ABNORMAL END: S/R MDSREADFIELD'
          endif
         ENDIF
        DO jp=1,nPy
         DO ip=1,nPx
          DO bj = myByLo(myThid), myByHi(myThid)
           DO bi = myBxLo(myThid), myBxHi(myThid)
            DO J=1,sNy
             JJ=((jp-1)*nSy+(bj-1))*sNy+J
             DO I=1,sNx
              II=((ip-1)*nSx+(bi-1))*sNx+I
              arr_gl(i,bi,ip,j,bj,jp,k) = global(II,JJ)
             ENDDO
            ENDDO
           ENDDO
          ENDDO
         ENDDO
        ENDDO

       ENDDO
c      ENDDO k=1,nNz

        close( dUnit )

      endif
c      end of if ( .not. ( globalFile .and. useSingleCPUIO ) ) then

      _END_MASTER( myThid )

#else /* ALLOW_CTRL */
      STOP 'ABNORMAL END: S/R MDSREADFIELD_2D_GL is empty'
#endif /* ALLOW_CTRL */
C     ------------------------------------------------------------------
      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      SUBROUTINE MDSWRITEFIELD_2D_GL(
     I   fName,
     I   filePrec,
     I   arrType,
     I   nNz,
     I   arr_gl,
     I   irecord,
     I   myIter,
     I   myThid )
C
C Arguments:
C
C fName     (string)  :: base name for file to write
C filePrec  (integer) :: number of bits per word in file (32 or 64)
C arrType   (char(2)) :: type of array "arr": either "RS" or "RL"
C nNz       (integer) :: size of third dimension: normally either 1 or Nr
C arr        (RS/RL)  :: array to write, arr(:,:,nNz,:,:)
C irecord   (integer) :: record number to write
C myIter    (integer) :: time step number
C myThid    (integer) :: thread identifier
C
C MDSWRITEFIELD creates either a file of the form "fName.data" and
C "fName.meta" if the logical flag "globalFile" is set true. Otherwise
C it creates MDS tiled files of the form "fName.xxx.yyy.data" and
C "fName.xxx.yyy.meta". A meta-file is always created.
C Currently, the meta-files are not read because it is difficult
C to parse files in fortran. We should read meta information before
C adding records to an existing multi-record file.
C The precision of the file is decsribed by filePrec, set either
C to floatPrec32 or floatPrec64. The precision or declaration of
C the array argument must be consistently described by the char*(2)
C string arrType, either "RS" or "RL". nNz allows for both 2-D and
C 3-D arrays to be handled. nNz=1 implies a 2-D model field and
C nNz=Nr implies a 3-D model field. irecord is the record number
C to be read and must be >= 1. NOTE: It is currently assumed that
C the highest record number in the file was the last record written.
C Nor is there a consistency check between the routine arguments and file.
C ie. if your write record 2 after record 4 the meta information
C will record the number of records to be 2. This, again, is because
C we have read the meta information. To be fixed.
C
C Created: 03/16/99 adcroft@mit.edu
C
C Changed: 05/31/00 heimbach@mit.edu
C          open(dUnit, ..., status='old', ... -> status='unknown'

      implicit none
C Global variables / common blocks
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"

C Routine arguments
      character*(*) fName
      integer filePrec
      character*(2) arrType
      integer nNz, nLocz
      parameter (nLocz = 1)
cph(
cph      Real arr(*)
      _RL arr_gl(sNx,nSx,nPx,sNy,nSy,nPy,nLocz)
cph)
      integer irecord
      integer myIter
      integer myThid

#ifdef ALLOW_CTRL

C Functions
      integer ILNBLNK
      integer MDS_RECLEN
C Local variables
      character*(MAX_LEN_FNAM) dataFName,metaFName
      integer ip,jp,iG,jG,irec,bi,bj,i,j,k,dUnit,IL
      Real*4 r4seg(sNx)
      Real*8 r8seg(sNx)
      _RL arr(1-oLx:sNx+oLx,1-oLy:sNy+oLy,nLocz,nSx,nSy)
      INTEGER dimList(3,3), nDims, map2gl(2)
      _RL dummyRL(1)
      CHARACTER*8 blank8c
      integer length_of_rec
      logical fileIsOpen
      character*(max_len_mbuf) msgbuf
cph-usesingle(
#ifdef ALLOW_USE_MPI
      integer ii,jj
c     integer iG_IO,jG_IO,npe
      integer x_size,y_size
      PARAMETER ( x_size = Nx )
      PARAMETER ( y_size = Ny )
      Real*4 xy_buffer_r4(x_size,y_size)
      Real*8 xy_buffer_r8(x_size,y_size)
      Real*8 global(Nx,Ny)
#endif
cph-usesingle)
CMM(
      integer pIL
CMM)

      DATA dummyRL(1) / 0. _d 0 /
      DATA blank8c / '        ' /

C     ------------------------------------------------------------------

C Only do I/O if I am the master thread
      _BEGIN_MASTER( myThid )

#ifndef REAL4_IS_SLOW
      if (arrType .eq. 'RS') then
       write(msgbuf,'(a)')
     &   ' MDSWRITEFIELD_GL is wrong for arrType="RS" (=real*4)'
       call print_error( msgbuf, mythid )
       stop 'ABNORMAL END: S/R MDSWRITEFIELD_GL'
      endif
#endif

C Record number must be >= 1
      if (irecord .LT. 1) then
       write(msgbuf,'(a,i9.8)')
     &   ' MDSWRITEFIELD_GL: argument irecord = ',irecord
       call print_message( msgbuf, standardmessageunit,
     &                     SQUEEZE_RIGHT , mythid)
       write(msgbuf,'(a)')
     &   ' MDSWRITEFIELD_GL: invalid value for irecord'
       call print_error( msgbuf, mythid )
       stop 'ABNORMAL END: S/R MDSWRITEFIELD_GL'
      endif

C Assume nothing
      fileIsOpen=.FALSE.
      IL=ILNBLNK( fName )
CMM(
      pIL = ILNBLNK( mdsioLocalDir )
CMM)
CMM(
C Assign special directory
      if ( pIL.NE.0 ) then
       write(fName,'(2a)') mdsioLocalDir(1:pIL), fName(1:IL)
      endif
CMM)

C Assign a free unit number as the I/O channel for this routine
      call MDSFINDUNIT( dUnit, mythid )


cph-usesingle(
#ifdef ALLOW_USE_MPI
      _END_MASTER( myThid )
C If option globalFile is desired but does not work or if
C globalFile is too slow, then try using single-CPU I/O.
      if (useSingleCpuIO) then

C Master thread of process 0, only, opens a global file
       _BEGIN_MASTER( myThid )
        IF( myProcId .EQ. 0 ) THEN
         write(dataFname,'(2a)') fName(1:IL),'.data'
         length_of_rec=MDS_RECLEN(filePrec,x_size*y_size,mythid)
         if (irecord .EQ. 1) then
          open( dUnit, file=dataFName, status=_NEW_STATUS,
     &        access='direct', recl=length_of_rec )
         else
          open( dUnit, file=dataFName, status=_OLD_STATUS,
     &        access='direct', recl=length_of_rec )
         endif
        ENDIF
       _END_MASTER( myThid )

C Gather array and write it to file, one vertical level at a time
       DO k=1,nLocz
C Loop over all processors
        do jp=1,nPy
        do ip=1,nPx
        DO bj = myByLo(myThid), myByHi(myThid)
         DO bi = myBxLo(myThid), myBxHi(myThid)
          DO J=1,sNy
           JJ=((jp-1)*nSy+(bj-1))*sNy+J
           DO I=1,sNx
            II=((ip-1)*nSx+(bi-1))*sNx+I
            global(II,JJ) = arr_gl(i,bi,ip,j,bj,jp,k)
           ENDDO
          ENDDO
         ENDDO
        ENDDO
        enddo
        enddo
        _BEGIN_MASTER( myThid )
         IF( myProcId .EQ. 0 ) THEN
          irec=k+nLocz*(irecord-1)
          if (filePrec .eq. precFloat32) then
           DO J=1,Ny
            DO I=1,Nx
             xy_buffer_r4(I,J) = global(I,J)
            ENDDO
           ENDDO
#ifdef _BYTESWAPIO
           call MDS_BYTESWAPR4( x_size*y_size, xy_buffer_r4 )
#endif
           write(dUnit,rec=irec) xy_buffer_r4
          elseif (filePrec .eq. precFloat64) then
           DO J=1,Ny
            DO I=1,Nx
             xy_buffer_r8(I,J) = global(I,J)
            ENDDO
           ENDDO
#ifdef _BYTESWAPIO
           call MDS_BYTESWAPR8( x_size*y_size, xy_buffer_r8 )
#endif
           write(dUnit,rec=irec) xy_buffer_r8
          else
           write(msgbuf,'(a)')
     &       ' MDSWRITEFIELD: illegal value for filePrec'
           call print_error( msgbuf, mythid )
           stop 'ABNORMAL END: S/R MDSWRITEFIELD'
          endif
         ENDIF
        _END_MASTER( myThid )
       ENDDO

C Close data-file and create meta-file
       _BEGIN_MASTER( myThid )
        IF( myProcId .EQ. 0 ) THEN
         close( dUnit )
         write(metaFName,'(2a)') fName(1:IL),'.meta'
         dimList(1,1)=Nx
         dimList(2,1)=1
         dimList(3,1)=Nx
         dimList(1,2)=Ny
         dimList(2,2)=1
         dimList(3,2)=Ny
         dimList(1,3)=nLocz
         dimList(2,3)=1
         dimList(3,3)=nLocz
         nDims=3
         if (nLocz .EQ. 1) nDims=2
         map2gl(1) = 0
         map2gl(2) = 1
         CALL MDS_WRITE_META(
     I              metaFName, dataFName, the_run_name, ' ',
     I              filePrec, nDims, dimList, map2gl, 0, blank8c,
     I              0, dummyRL, oneRL, irecord, myIter, myThid )
        ENDIF
       _END_MASTER( myThid )
C To be safe, make other processes wait for I/O completion
       _BARRIER

      elseif ( .NOT. useSingleCpuIO ) then
      _BEGIN_MASTER( myThid )
#endif /* ALLOW_USE_MPI */
cph-usesingle)

C Loop over all processors
      do jp=1,nPy
      do ip=1,nPx
C Loop over all tiles
      do bj=1,nSy
       do bi=1,nSx
C If we are writing to a tiled MDS file then we open each one here
         iG=bi+(ip-1)*nsx ! Kludge until unstructered tiles
         jG=bj+(jp-1)*nsy ! Kludge until unstructered tiles
         write(dataFname,'(2a,i3.3,a,i3.3,a)')
     &              fName(1:IL),'.',iG,'.',jG,'.data'
         if (irecord .EQ. 1) then
          length_of_rec=MDS_RECLEN( filePrec, sNx, mythid )
          open( dUnit, file=dataFName, status=_NEW_STATUS,
     &       access='direct', recl=length_of_rec )
          fileIsOpen=.TRUE.
         else
          length_of_rec=MDS_RECLEN( filePrec, sNx, mythid )
          open( dUnit, file=dataFName, status=_OLD_STATUS,
     &       access='direct', recl=length_of_rec )
          fileIsOpen=.TRUE.
         endif
        if (fileIsOpen) then
         do k=1,nLocz
          do j=1,sNy
             do i=1,sNx
                arr(i,j,k,bi,bj)=arr_gl(i,bi,ip,j,bj,jp,k)
             enddo
            iG = 0
            jG = 0
            irec=j + sNy*(k-1) + sNy*nLocz*(irecord-1)
           if (filePrec .eq. precFloat32) then
            if (arrType .eq. 'RS') then
#ifdef REAL4_IS_SLOW
             call MDS_SEG4toRS( j,bi,bj,k,nLocz, r4seg, .FALSE., arr )
#endif
            elseif (arrType .eq. 'RL') then
             call MDS_SEG4toRL( j,bi,bj,k,nLocz, r4seg, .FALSE., arr )
            else
             write(msgbuf,'(a)')
     &         ' MDSWRITEFIELD_GL: illegal value for arrType'
             call print_error( msgbuf, mythid )
             stop 'ABNORMAL END: S/R MDSWRITEFIELD_GL'
            endif
#ifdef _BYTESWAPIO
            call MDS_BYTESWAPR4( sNx, r4seg )
#endif
            write(dUnit,rec=irec) r4seg
           elseif (filePrec .eq. precFloat64) then
            if (arrType .eq. 'RS') then
#ifdef REAL4_IS_SLOW
             call MDS_SEG8toRS( j,bi,bj,k,nLocz, r8seg, .FALSE., arr )
#endif
            elseif (arrType .eq. 'RL') then
             call MDS_SEG8toRL( j,bi,bj,k,nLocz, r8seg, .FALSE., arr )
            else
             write(msgbuf,'(a)')
     &         ' MDSWRITEFIELD_GL: illegal value for arrType'
             call print_error( msgbuf, mythid )
             stop 'ABNORMAL END: S/R MDSWRITEFIELD_GL'
            endif
#ifdef _BYTESWAPIO
            call MDS_BYTESWAPR8( sNx, r8seg )
#endif
            write(dUnit,rec=irec) r8seg
           else
            write(msgbuf,'(a)')
     &        ' MDSWRITEFIELD_GL: illegal value for filePrec'
            call print_error( msgbuf, mythid )
            stop 'ABNORMAL END: S/R MDSWRITEFIELD_GL'
           endif
C End of j loop
          enddo
C End of k loop
         enddo
        else
         write(msgbuf,'(a)')
     &     ' MDSWRITEFIELD_GL: I should never get to this point'
         call print_error( msgbuf, mythid )
         stop 'ABNORMAL END: S/R MDSWRITEFIELD_GL'
        endif
C If we were writing to a tiled MDS file then we close it here
        if (fileIsOpen) then
         close( dUnit )
         fileIsOpen = .FALSE.
        endif
C Create meta-file for each tile if we are tiling
         iG=bi+(ip-1)*nsx ! Kludge until unstructered tiles
         jG=bj+(jp-1)*nsy ! Kludge until unstructered tiles
         write(metaFname,'(2a,i3.3,a,i3.3,a)')
     &              fName(1:IL),'.',iG,'.',jG,'.meta'
         dimList(1,1)=Nx
         dimList(2,1)=((ip-1)*nSx+(bi-1))*sNx+1
         dimList(3,1)=((ip-1)*nSx+bi)*sNx
         dimList(1,2)=Ny
         dimList(2,2)=((jp-1)*nSy+(bj-1))*sNy+1
         dimList(3,2)=((jp-1)*nSy+bj)*sNy
         dimList(1,3)=Nr
         dimList(2,3)=1
         dimList(3,3)=Nr
         nDims=3
         if (nLocz .EQ. 1) nDims=2
         map2gl(1) = 0
         map2gl(2) = 1
         CALL MDS_WRITE_META(
     I              metaFName, dataFName, the_run_name, ' ',
     I              filePrec, nDims, dimList, map2gl, 0, blank8c,
     I              0, dummyRL, oneRL, irecord, myIter, myThid )
C End of bi,bj loops
       enddo
      enddo
C End of ip,jp loops
       enddo
      enddo

      _END_MASTER( myThid )

#ifdef ALLOW_USE_MPI
C endif useSingleCpuIO
      endif
#endif /* ALLOW_USE_MPI */

#else /* ALLOW_CTRL */
      STOP 'ABNORMAL END: S/R MDSWRITEFIELD_2D_GL is empty'
#endif /* ALLOW_CTRL */
C     ------------------------------------------------------------------
      RETURN
      END

#include "SHELFICE_OPTIONS.h"
#ifdef ALLOW_STEEP_ICECAVITY
# include "STIC_OPTIONS.h"
#endif

C--  File shelfice_forcing.F:
C--   Contents
C--   o SHELFICE_FORCING_T
C--   o SHELFICE_FORCING_S

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: SHELFICE_FORCING_T
C     !INTERFACE:
      SUBROUTINE SHELFICE_FORCING_T(
     U                    gT_arr,
     I                    iMin,iMax,jMin,jMax, kLev, bi, bj,
     I                    myTime, myIter, myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R SHELFICE_FORCING_T
C     | o Contains problem specific forcing for temperature.
C     *==========================================================*
C     | Adds terms to gT for forcing by shelfice sources
C     | e.g. heat flux
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     == Global data ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
c#include "DYNVARS.h"
c#include "FFIELDS.h"
#include "SHELFICE.h"
#ifdef ALLOW_STEEP_ICECAVITY
# include "STIC.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     gT_arr    :: the tendency array
C     iMin,iMax :: Working range of x-index for applying forcing.
C     jMin,jMax :: Working range of y-index for applying forcing.
C     kLev      :: Current vertical level index
C     bi,bj     :: Current tile indices
C     myTime    :: Current time in simulation
C     myIter    :: Current iteration number
C     myThid    :: my Thread Id number
      _RL     gT_arr(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER iMin, iMax, jMin, jMax
      INTEGER kLev, bi, bj
      _RL     myTime
      INTEGER myIter
      INTEGER myThid

#ifdef ALLOW_SHELFICE
C     !LOCAL VARIABLES:
C     == Local variables ==
C     i,j   :: Loop counters
C     kp1,km1 :: index of next/previous level
C     gTloc   :: local tendency in boundary layer
C     drLoc   :: fractional cell width of boundary layer in (k+/-1)th layer
      INTEGER i, j
      INTEGER Kp1, Km1
      _RS     drLoc
      _RL     gTloc
CEOP

C--   Forcing term
      IF ( SHELFICEboundaryLayer ) THEN
       DO j=1,sNy
        DO i=1,sNx
         IF ( kLev .LT. Nr .AND. kLev .EQ. kTopC(I,J,bi,bj) ) THEN
          kp1 = MIN(kLev+1,Nr)
          drLoc = drF(kLev)*( 1. _d 0 - _hFacC(I,J,kLev,bi,bj) )
          drLoc = MIN( drLoc, drF(Kp1) * _hFacC(I,J,Kp1,bi,bj) )
          drLoc = MAX( drLoc, 0. _d 0)
          gTloc = shelficeForcingT(i,j,bi,bj)
     &         /( drF(kLev)*_hFacC(I,J,kLev,bi,bj)+drLoc )
          gT_arr(i,j) = gT_arr(i,j) + gTloc
         ELSEIF ( kLev .GT. 1 .AND. kLev-1 .EQ. kTopC(I,J,bi,bj) ) THEN
          km1 = MAX(kLev-1,1)
          drLoc = drF(km1)*( 1. _d 0 - _hFacC(I,J,km1,bi,bj) )
          drLoc = MIN( drLoc, drF(kLev) * _hFacC(I,J,kLev,bi,bj) )
          drLoc = MAX( drLoc, 0. _d 0)
          gTloc = shelficeForcingT(i,j,bi,bj)
     &         /( drF(km1)*_hFacC(I,J,km1,bi,bj)+drLoc )
C     The following is shorthand for the averaged tendency:
C     gT(k+1) = gT(k+1) + { gTloc * [drF(k)*(1-hFacC(k))]
C                       +   0     * [drF(k+1) - drF(k)*(1-hFacC(k))]
C                         }/[drF(k+1)*hFacC(k+1)]
          gT_arr(i,j) = gT_arr(i,j) + gTloc
     &         * drLoc*recip_drF(kLev)* _recip_hFacC(i,j,kLev,bi,bj)
         ENDIF
        ENDDO
       ENDDO
      ENDIF

# ifdef ALLOW_STEEP_ICECAVITY
      IF ( useSTIC ) THEN
       DO j=1,sNy
        DO i=1,sNx
C--     TENDENCY FROM STEEP ICECAVITY (BOTH ICE SHELF AND ICE FRONT)
         gT_arr(i,j) = gT_arr(i,j) + stic_gT(i,j,kLev,bi,bj)
        ENDDO
       ENDDO
      ENDIF
# endif /* ALLOW_STEEP_ICECAVITY */

#endif /* ALLOW_SHELFICE */
      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: SHELFICE_FORCING_S
C     !INTERFACE:
      SUBROUTINE SHELFICE_FORCING_S(
     U                    gS_arr,
     I                    iMin,iMax,jMin,jMax, kLev, bi, bj,
     I                    myTime, myIter, myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R SHELFICE_FORCING_S
C     | o Contains problem specific forcing for merid velocity.
C     *==========================================================*
C     | Adds terms to gS for forcing by shelfice sources
C     | e.g. fresh-water flux (virtual salt flux).
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     == Global data ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
c#include "DYNVARS.h"
c#include "FFIELDS.h"
#include "SHELFICE.h"
#ifdef ALLOW_STEEP_ICECAVITY
# include "STIC.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     gS_arr    :: the tendency array
C     iMin,iMax :: Working range of x-index for applying forcing.
C     jMin,jMax :: Working range of y-index for applying forcing.
C     kLev      :: Current vertical level index
C     bi,bj     :: Current tile indices
C     myTime    :: Current time in simulation
C     myIter    :: Current iteration number
C     myThid    :: my Thread Id number
      _RL     gS_arr(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER iMin, iMax, jMin, jMax
      INTEGER kLev, bi, bj
      _RL     myTime
      INTEGER myIter
      INTEGER myThid

#ifdef ALLOW_SHELFICE
C     !LOCAL VARIABLES:
C     i,j   :: Loop counters
C     kp/m1 :: index of next/previous level
C     gTloc :: local tendency in boundary layer
C     drLoc :: fractional cell width of boundary layer
      INTEGER i, j
      INTEGER Kp1, Km1
      _RS     drLoc
      _RL     gSloc
CEOP

C--   Forcing term
      IF ( SHELFICEboundaryLayer ) THEN
       DO j=1,sNy
        DO i=1,sNx
         IF ( kLev .LT. Nr .AND. kLev .EQ. kTopC(I,J,bi,bj) ) THEN
          kp1 = MIN(kLev+1,Nr)
          drLoc = drF(kLev)*( 1. _d 0 - _hFacC(I,J,kLev,bi,bj) )
          drLoc = MIN( drLoc, drF(Kp1) * _hFacC(I,J,Kp1,bi,bj) )
          drLoc = MAX( drLoc, 0. _d 0)
          gSloc = shelficeForcingS(i,j,bi,bj)
     &         /( drF(kLev)*_hFacC(I,J,kLev,bi,bj)+drLoc )
          gS_arr(i,j) = gS_arr(i,j) + gSloc
         ELSEIF ( kLev .GT. 1 .AND. kLev-1 .EQ. kTopC(I,J,bi,bj) ) THEN
          km1 = MAX(kLev-1,1)
          drLoc = drF(km1)*( 1. _d 0 - _hFacC(I,J,km1,bi,bj) )
          drLoc = MIN( drLoc, drF(kLev) * _hFacC(I,J,kLev,bi,bj) )
          drLoc = MAX( drLoc, 0. _d 0)
          gSloc = shelficeForcingS(i,j,bi,bj)
     &         /( drF(km1)*_hFacC(I,J,km1,bi,bj)+drLoc )
C     The following is shorthand for the averaged tendency:
C     gS(k+1) = gS(k+1) + { gSloc * [drF(k)*(1-hFacC(k))]
C                       +   0     * [drF(k+1) - drF(k)*(1-hFacC(k))]
C                         }/[drF(k+1)*hFacC(k+1)]
          gS_arr(i,j) = gS_arr(i,j) + gSloc
     &         * drLoc*recip_drF(kLev)* _recip_hFacC(i,j,kLev,bi,bj)
         ENDIF
        ENDDO
       ENDDO
      ENDIF

# ifdef ALLOW_STEEP_ICECAVITY
      IF ( useSTIC ) THEN
       DO j=1,sNy
        DO i=1,sNx
C--     TENDENCY FROM STEEP ICECAVITY (BOTH ICE SHELF AND ICE FRONT)
         gS_arr(i,j) = gS_arr(i,j) + stic_gS(i,j,kLev,bi,bj)
        ENDDO
       ENDDO
      ENDIF
# endif /* ALLOW_STEEP_ICECAVITY */

#endif /* ALLOW_SHELFICE */
      RETURN
      END

#include "KL10_OPTIONS.h"

      SUBROUTINE KL10_CHECK( myThid )
C     /==========================================================\
C     | SUBROUTINE KL10_CHECK                                    |
C     | o Validate basic package setup and inter-package         |
C     | dependencies.                                            |
C     \==========================================================/
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"

C     === Routine arguments ===
C     myThid -  Number of this instance of KL10_CHECK
      INTEGER myThid

#ifdef ALLOW_KL10

C     === Local variables ===
C     msgBuf      - Informational/error message buffer
      CHARACTER*(MAX_LEN_MBUF) msgBuf

      WRITE(msgBuf,'(A)') 'KL10_CHECK: #define ALLOW_KL10'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &     SQUEEZE_RIGHT , 1)

C     So far, KL10 works only with oceanic z-coordinates
      IF ( buoyancyRelation .NE. 'OCEANIC' ) THEN
         WRITE(msgBuf,'(A)')
     &      'KL10 works only with buoyancyRelation = ''OCEANIC'''
         CALL PRINT_ERROR( msgBuf , 1)
         STOP 'ABNORMAL END: S/R KL10_CHECK'
      ENDIF

C     KL10 needs convection turned off (will be packaged later)
      IF (cAdjFreq.NE.0.  .OR.
     &     ivdc_kappa.NE.0. ) THEN
         WRITE(msgBuf,'(A)') 'Some form of convection has been enabled'
         CALL PRINT_ERROR( msgBuf , 1)
         STOP 'ABNORMAL END: S/R KL10_CHECK'
      ENDIF

C TODO: JMK: Check if this is really necessary.  I don't see why they can't
C co-exist
C      IF ( useKPP ) THEN
C         WRITE(msgBuf,'(A)')
C     &      'KL10 and KPP cannot be turned on at the same time'
C         CALL PRINT_ERROR( msgBuf , 1)
C         STOP 'ABNORMAL END: S/R KL10_CHECK'
C      ENDIF

C     KL10 needs implicit vertical diffusion and viscosity
      IF (.NOT.implicitDiffusion ) THEN
         WRITE(msgBuf,'(A)')
     &      'KL10 needs implicitDiffusion to be enabled'
         CALL PRINT_ERROR( msgBuf , 1)
         STOP 'ABNORMAL END: S/R KL10_CHECK'
      ENDIF
      IF (.NOT.implicitViscosity) THEN
         WRITE(msgBuf,'(A)')
     &      'KL10 needs implicitViscosity to be enabled'
         CALL PRINT_ERROR( msgBuf , 1)
         STOP 'ABNORMAL END: S/R KL10_CHECK'
      ENDIF

#endif /* ALLOW_KL10 */

      return
      end

#include "ECCO_OPTIONS.h"
#ifdef ALLOW_SEAICE
# include "SEAICE_OPTIONS.h"
#endif
#ifdef ALLOW_SHELFICE
# include "SHELFICE_OPTIONS.h"
#endif
#ifdef ALLOW_AUTODIFF
# include "AUTODIFF_OPTIONS.h"
#endif

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: ECCO_PHYS

C     !INTERFACE:
      SUBROUTINE ECCO_PHYS( myTime, myIter, myThid )

C     !DESCRIPTION:
C     Compute some derived quantities and averages
C     for GenCost and ECCO cost function.

C     !USES:
      IMPLICIT NONE
c     == global variables ==
#include "EEPARAMS.h"
#include "SIZE.h"
#include "PARAMS.h"
#include "GRID.h"
#include "DYNVARS.h"
#include "FFIELDS.h"
#ifdef ALLOW_ECCO
# include "ECCO_SIZE.h"
# include "ECCO.h"
#endif
#ifdef ALLOW_SEAICE
# include "SEAICE_SIZE.h"
# include "SEAICE.h"
# include "SEAICE_PARAMS.h"
#endif
#ifdef ALLOW_PTRACERS
# include "PTRACERS_SIZE.h"
# include "PTRACERS_FIELDS.h"
#endif
#if (defined ALLOW_GENCOST_CONTRIBUTION) && (defined ALLOW_SHELFICE)
# include "SHELFICE.h"
#endif
#ifdef ALLOW_AUTODIFF_TAMC
# include "tamc.h"
#endif

C     !INPUT PARAMETERS:
C     myTime    :: Current time in simulation
C     myIter    :: Current time-step number
C     myThid    :: my Thread Id number
      _RL     myTime
      INTEGER myIter, myThid

C     !LOCAL VARIABLES:
C     bi, bj    :: tile indices
C     i, j, k   :: loop indices
      INTEGER bi, bj
      INTEGER i, j, k
#ifdef ALLOW_GENCOST_CONTRIBUTION
      INTEGER kgen, kgen3d, itr
      _RL areavolTile(nSx,nSy), areavolGlob
      _RL tmpfld, tmpvol, tmpmsk, tmpmsk2, tmpmskW, tmpmskS
      _RL tmp_sigmsk, tmpsig, tmpsig_lower, tmpsig_upper
#endif

C- note: defined with overlap here, not needed, but more efficient
      _RL trVolW(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL trVolS(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL trHeatW(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL trHeatS(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL trSaltW(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL trSaltS(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)

      _RL tmpfac
      _RL sIceLoadFacLoc
#ifdef ATMOSPHERIC_LOADING
#ifdef ALLOW_IB_CORR
      _RL ploadbar, AREAsumGlob, PLOADsumGlob
      _RL AREAsumTile(nSx,nSy), PLOADsumTile(nSx,nSy)
      _RL m_eta_ib(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL sterht  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
#endif
#endif
      _RL rhoLoc(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
#ifdef ALLOW_PSBAR_STERIC
      _RL VOLsumTile(nSx,nSy), RHOsumTile(nSx,nSy)
      _RL VOLsumGlob_1, RHOsumGlob_1
c     CHARACTER*(MAX_LEN_MBUF) msgBuf
#endif
C     Mload     :: total mass load (kg/m**2)
c     _RL Mload(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
#ifdef ALLOW_SEAICE
      _RL tmprecip_area,  tmphsnowact, tmpheffact
      _RL area_reg_sq
#endif
#if ( defined ALLOW_AUTODIFF_TAMC && defined ALLOW_GENCOST_CONTRIBUTION )
C     ikey   :: tape key (depends on kgen)
      INTEGER ikey
#endif
CEOP

#ifdef ALLOW_SEAICE
      area_reg_sq = SEAICE_area_reg * SEAICE_area_reg
#endif
      tmpfac = recip_rhoConst*recip_gravity
      sIceLoadFacLoc = zeroRL
      IF ( useRealFreshWaterFlux ) sIceLoadFacLoc = recip_rhoConst

      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        IF ( myIter .EQ. -1 ) THEN
          DO k = 1,Nr
            CALL FIND_RHO_2D(
     I                1-OLx, sNx+OLx, 1-OLy, sNy+OLy, k,
     I                theta(1-OLx,1-OLy,k,bi,bj),
     I                salt (1-OLx,1-OLy,k,bi,bj),
     O                rhoLoc(1-OLx,1-OLy,k,bi,bj),
     I                k, bi, bj, myThid )
          ENDDO
        ELSE
          DO k = 1,Nr
           DO j=1-OLy,sNy+OLy
            DO i=1-OLx,sNx+OLx
              rhoLoc(i,j,k,bi,bj) = rhoInSitu(i,j,k,bi,bj)
            ENDDO
           ENDDO
          ENDDO
        ENDIF
       ENDDO
      ENDDO

#ifdef ALLOW_PSBAR_STERIC
      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        RHOsumTile(bi,bj) = 0. _d 0
        VOLsumTile(bi,bj) = 0. _d 0
        DO k = 1,Nr
         DO j = 1,sNy
          DO i =  1,sNx
           RHOsumTile(bi,bj) = RHOsumTile(bi,bj)
     &          + ( rhoConst + rhoLoc(i,j,k,bi,bj) )
     &           *hFacC(i,j,k,bi,bj)*drF(k)*rA(i,j,bi,bj)
           VOLsumTile(bi,bj) = VOLsumTile(bi,bj)
     &          + hFacC(i,j,k,bi,bj)*drF(k)*rA(i,j,bi,bj)
          ENDDO
         ENDDO
        ENDDO
       ENDDO
      ENDDO
      CALL GLOBAL_SUM_TILE_RL( VOLsumTile, VOLsumGlob_1, myThid )
      CALL GLOBAL_SUM_TILE_RL( RHOsumTile, RHOsumGlob_1, myThid )

# ifndef ALLOW_AUTODIFF
      _BEGIN_MASTER(myThid)
# endif
      VOLsumGlob = VOLsumGlob_1
      RHOsumGlob = RHOsumGlob_1/VOLsumGlob

      IF (RHOsumGlob_0.GT.0. _d 0) THEN
        sterGloH = VOLsumGlob_0/globalArea
     &        *(1. _d 0 - RHOsumGlob/RHOsumGlob_0)
      ELSE
        sterGloH = 0. _d 0
      ENDIF

c     WRITE(msgBuf,'(A,1PE21.14)') ' sterGloH= ', sterGloH
c     CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
c    &                       SQUEEZE_RIGHT, myThid )
# ifndef ALLOW_AUTODIFF
      _END_MASTER(myThid)
      _BARRIER
# endif

#endif /* ALLOW_PSBAR_STERIC */

#ifdef ATMOSPHERIC_LOADING
#ifdef ALLOW_IB_CORR
      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        PLOADsumTile(bi,bj) = 0. _d 0
        AREAsumTile(bi,bj) = 0. _d 0
        DO j = 1,sNy
         DO i =  1,sNx
          PLOADsumTile(bi,bj) = PLOADsumTile(bi,bj)
     &          + pLoad(i,j,bi,bj)
     &           *maskC(i,j,1,bi,bj)*rA(i,j,bi,bj)
          AREAsumTile(bi,bj) = AREAsumTile(bi,bj)
     &          + maskC(i,j,1,bi,bj)*rA(i,j,bi,bj)
         ENDDO
        ENDDO
       ENDDO
      ENDDO
      CALL GLOBAL_SUM_TILE_RL( AREAsumTile, AREAsumGlob, myThid )
      CALL GLOBAL_SUM_TILE_RL( PLOADsumTile, PLOADsumGlob, myThid )
      ploadbar = PLOADsumGlob/AREAsumGlob
#endif /* ALLOW_IB_CORR */
#endif /* ATMOSPHERIC_LOADING */

      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        DO j = 1-OLy, sNy+OLy
         DO i = 1-OLx, sNx+OLx

C calculate total sea level including inverse barometer (IB) effect if
C  there is air pressure forcing
           m_eta(i,j,bi,bj) =
     &           ( etaN(i,j,bi,bj)
     &           + sIceLoad(i,j,bi,bj)*sIceLoadFacLoc
#ifdef ALLOW_PSBAR_STERIC
C apply Greatbatch correction
     &           + sterGloH
#endif /* ALLOW_PSBAR_STERIC */
     &           ) * maskC(i,j,1,bi,bj)

C Model equivalent of ocean bottom pressure gauge data (in m^2/s^2)
C  that are NOT corrected for global ocean mean atmospheric pressure variations
C  = Ocean mass + sea-ice & snow load + air-pressure load + Greatbatch corr.
C  (all terms on RHS are converted to m^2/s^2). It is
C  essentially Mload (as in pkg/sbo/sbo_calc.F) plus air-pressure load
           m_bp(i,j,bi,bj) =
     &           ( etaN(i,j,bi,bj)
c    &           + Ro_surf(i,j,bi.bj)
     &           - R_low(i,j,bi,bj)
#ifdef ALLOW_PSBAR_STERIC
C add back the correction due to the global mean steric ssh change,
C     i.e. sterGloH computed above (units converted from m to m2/s2)
     &           + sterGloH
#endif /* ALLOW_PSBAR_STERIC */
     &           ) * gravity
C sIceLoad in kg/m^2
     &         + sIceLoad(i,j,bi,bj) * gravity * sIceLoadFacLoc
C pLoad in N/m^2
     &         + pLoad(i,j,bi,bj) * recip_rhoConst
         ENDDO
        ENDDO
C integrate rho_anomaly through water column
        DO k = 1, Nr
         DO j = 1-OLy, sNy+OLy
          DO i = 1-OLx, sNx+OLx
           m_bp(i,j,bi,bj) = m_bp(i,j,bi,bj)
     &         + rhoLoc(i,j,k,bi,bj)*drF(k)*hFacC(i,j,k,bi,bj)
     &                              * gravity * recip_rhoConst
          ENDDO
         ENDDO
        ENDDO
        DO j = 1-OLy, sNy+OLy
         DO i = 1-OLx, sNx+OLx
           m_bp(i,j,bi,bj) = m_bp(i,j,bi,bj) * maskC(i,j,1,bi,bj)
         ENDDO
        ENDDO

#ifdef ATMOSPHERIC_LOADING
#ifdef ALLOW_IB_CORR
        DO j = 1-OLy, sNy+OLy
         DO i = 1-OLx, sNx+OLx
C calculate IB correction m_eta_ib (in m)
           m_eta_ib(i,j,bi,bj) =
     &           ( ploadbar - pLoad(i,j,bi,bj) )*tmpfac
     &           * maskC(i,j,1,bi,bj)
C calculte dynamic sea level for comparison with altimetry data (in m)
           m_eta_dyn(i,j,bi,bj) =
     &           ( m_eta(i,j,bi,bj) - m_eta_ib(i,j,bi,bj) )
     &           * maskC(i,j,1,bi,bj)

C calculate GRACE-equvivalent ocean bottom pressure (in m2/s2)
C  by removing global ocean mean atmospheric pressure variations
           m_bp_nopabar(i,j,bi,bj) =
     &           ( m_bp(i,j,bi,bj)
     &           - ploadbar * recip_rhoConst
     &           ) * maskC(i,j,1,bi,bj)
C calculate steric height
C (in m; = m_eta_dyn - (m_bp_nopabr * recip_gravity + R_low))
C R_low (<0) is Depth in m.
           sterht(i,j,bi,bj) = m_eta_dyn(i,j,bi,bj)
     &          - ( m_bp_nopabar(i,j,bi,bj) * recip_gravity
c    &            - Ro_surf(i,j,bi,bj)
     &            + R_low(i,j,bi,bj)  )
         ENDDO
        ENDDO
#endif /* ALLOW_IB_CORR */
#endif /* ATMOSPHERIC_LOADING */
       ENDDO
      ENDDO

#ifdef ALLOW_DIAGNOSTICS
      IF ( useDiagnostics .AND. myIter.GE.0 ) THEN
        CALL DIAGNOSTICS_FILL( m_eta, 'SSHNOIBC', 0,1, 0,1,1, myThid )
        CALL DIAGNOSTICS_SCALE_FILL( m_bp, recip_gravity, 1,
     &                         'OBPGMAP ', 0,1, 0,1,1, myThid )
#ifdef ATMOSPHERIC_LOADING
#ifdef ALLOW_IB_CORR
        CALL DIAGNOSTICS_FILL( m_eta_ib,
     &                         'SSHIBC  ', 0,1, 0,1,1, myThid )
        CALL DIAGNOSTICS_FILL( m_eta_dyn,
     &                         'SSH     ', 0,1, 0,1,1, myThid )
        CALL DIAGNOSTICS_FILL( sterht,
     &                         'STERICHT', 0,1, 0,1,1, myThid )
        CALL DIAGNOSTICS_SCALE_FILL( m_bp_nopabar, recip_gravity, 1,
     &                         'OBP     ', 0,1, 0,1,1, myThid )
#endif /* ALLOW_IB_CORR */
#endif /* ATMOSPHERIC_LOADING */
      ENDIF
#endif /* ALLOW_DIAGNOSTICS */

      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        DO k = 1,Nr
         DO j = 1-OLy,sNy+OLy
          DO i = 1-OLx,sNx+OLx
           m_UE(i,j,k,bi,bj) = 0. _d 0
           m_VN(i,j,k,bi,bj) = 0. _d 0
          ENDDO
         ENDDO
        ENDDO
       ENDDO
      ENDDO

      CALL ROTATE_UV2EN_RL(
     U          uVel, vVel, m_UE, m_VN,
     I          .TRUE., .TRUE., .FALSE., Nr, myThid )

c--   trVol : volume flux    --- [m^3/sec] (order of 10^6 = 1 Sv)
c--   trHeat: heat transport --- [Watt] (order of 1.E15 = PW)
c--   trSalt: salt transport --- [kg/sec] (order 1.E9 equiv. 1 Sv in vol.)
c--       convert from [ppt*m^3/sec] via rhoConst/1000.
c--       ( 1ppt = 1000*[mass(salt)]/[mass(seawater)] )

c-- init
      CALL ECCO_ZERO( trVol,  Nr, zeroRL, myThid )
      CALL ECCO_ZERO( trHeat, Nr, zeroRL, myThid )
      CALL ECCO_ZERO( trSalt, Nr, zeroRL, myThid )

#ifdef ALLOW_GENCOST_CONTRIBUTION

cts ---
c First: Fill the following SCALAR masks & weights for each (i,j,k,bi,bj) grid cell
c   tmpvol - 3D cell volume
c   tmpmsk - mask for the gencost_barfile field (e.g. theta)
c            Either: expand from 2D mask gencost_mskCsurf across nonzero
c            entries of gencost_mskVertical (Nr x NGENCOST array)
c            or
c            copy from 3D mask gencost_mskC
cts ---
      DO kgen=1,NGENCOST

       itr = gencost_itracer(kgen)

       CALL ECCO_ZERO( gencost_storefld(1-OLx,1-OLy,1,1,kgen),
     &                 1, zeroRL, myThid )

       DO bj=myByLo(myThid),myByHi(myThid)
        DO bi=myBxLo(myThid),myBxHi(myThid)
         areavolTile(bi,bj)=0. _d 0
        ENDDO
       ENDDO
       areavolGlob=0. _d 0

#ifdef ALLOW_SEAICE
       IF (gencost_barfile(kgen)(1:11).EQ.'m_freeboard') THEN
        DO bj=myByLo(myThid),myByHi(myThid)
         DO bi=myBxLo(myThid),myBxHi(myThid)
          DO j = 1,sNy
           DO i =  1,sNx
            tmprecip_area = 1. _d 0/SQRT(area(i,j,bi,bj)*area(i,j,bi,bj)
     &       + area_reg_sq)
            tmphsnowact = hsnow(i,j,bi,bj) * tmprecip_area
            tmpheffact  = heff(i,j,bi,bj) * tmprecip_area
C gencost_storefld is the total freeboard, which is the sum of snow
C thickness and sea-ice freeboard. Based on Archimedes principle,
C the total freeboard is equal to the sum of snow thickness and
C sea-ice thickness minus the sea-ice thickness below the water line
C (see, e.g., Kwok & Markus, 2018, Advances in Space Research,
C https://doi.org/10.1016/j.asr.2017.09.007; their equation for lidar).
C Note that snow thickness and sea-ice thickness are the actual,
C not effective, thickness.
C Note that recip_rhoConst (the reciprocal of the constant reference
C density) is used here instead of the more accurate reciprocal of
C the in-situ seawater density rhoInSitu(:,:,1).
C This is something worth improving in the future.
            gencost_storefld(i,j,bi,bj,kgen) =
     &       ( ( tmphsnowact + tmpheffact ) -
     &         ( tmphsnowact * SEAICE_rhoSnow +
     &           tmpheffact * SEAICE_rhoIce ) * recip_rhoConst
     &       ) * maskC(i,j,1,bi,bj)
           ENDDO
          ENDDO
         ENDDO
        ENDDO
       ENDIF
#endif

       DO bj=myByLo(myThid),myByHi(myThid)
        DO bi=myBxLo(myThid),myBxHi(myThid)
         DO j = 1,sNy
          DO i =  1,sNx
c---------
           DO k = 1,Nr
            tmpvol=hFacC(i,j,k,bi,bj)*drF(k)*rA(i,j,bi,bj)

            tmpmsk=0. _d 0
            IF (.NOT.gencost_msk_is3d(kgen)) THEN
             tmpmsk=gencost_mskCsurf(i,j,bi,bj,kgen)*
     &              gencost_mskVertical(k,kgen)
#ifdef ALLOW_GENCOST3D
            ELSE
             kgen3d=gencost_msk_pointer3d(kgen)
             tmpmsk=gencost_mskC(i,j,k,bi,bj,kgen3d)
#endif /* ALLOW_GENCOST3D */
            ENDIF

C ---- If density mask is enabled, use it here ----
            IF ( maskC(i,j,k,bi,bj).EQ.oneRS .AND.
     &           gencost_useDensityMask(kgen) ) THEN
C            - first, calculate the scalar density
             CALL FIND_RHO_SCALAR(
     I              theta(i,j,k,bi,bj),
     I              salt(i,j,k,bi,bj),
     I              gencost_refPressure(kgen),
     O              tmpsig,
     I              myThid )
C            - subtract 1000 to get sigma
             tmpsig = tmpsig - 1000. _d 0
C            - now, tmpmsk is sigmoid times this value
             tmpsig_lower = 0.5 + 0.5*tanh(gencost_tanhScale(kgen)
     &           *(tmpsig-gencost_sigmaLow(kgen)))
             tmpsig_upper = 0.5 - 0.5*tanh(gencost_tanhScale(kgen)
     &           *(tmpsig-gencost_sigmaHigh(kgen)))
C             - update mask value based on the sigmoid function
             tmp_sigmsk = tmpsig_lower*tmpsig_upper
             tmpmsk = tmpmsk*tmp_sigmsk
            ENDIF
C ---- end of density mask (but tmpmsk is used below)

cts ---
c Now: at each (i,j,k,bi,bj) fill the SCALAR variables
c   tmpfld - from 3D field theta, salt, ptracer
c            or
c            from 2D field with eta, shelfice
c
c   tmpmsk2 - 1 or 0 weighting for areavolTile
cts ---
            tmpfld=0. _d 0
            tmpmsk2=0. _d 0
            IF (gencost_barfile(kgen)(1:15).EQ.'m_boxmean_theta') THEN
             tmpfld=theta(i,j,k,bi,bj)
             IF (tmpmsk.NE.0. _d 0) tmpmsk2=1. _d 0
            ELSEIF (gencost_barfile(kgen)(1:14).EQ.'m_boxmean_salt')
     &        THEN
             tmpfld=salt(i,j,k,bi,bj)
             IF (tmpmsk.NE.0. _d 0) tmpmsk2=1. _d 0
            ELSEIF (gencost_barfile(kgen)(1:13).EQ.'m_boxmean_vol') THEN
             tmpfld=1. _d 0
             IF (tmpmsk.NE.0. _d 0) tmpmsk2=1. _d 0
#ifdef ALLOW_PTRACERS
            ELSEIF (gencost_barfile(kgen)(1:17).EQ.'m_boxmean_ptracer')
     &        THEN
             tmpfld=pTracer(i,j,k,bi,bj,itr)
             IF (tmpmsk.NE.0. _d 0) tmpmsk2=1. _d 0
#endif /* ALLOW_PTRACERS */
            ENDIF

cts ---
c Fill 3D field
c       gencost_store - masked field of interest * grid cell volume
c                       note: this accumulates along z dim
c
c Fill tile field (1 val per tile)
c       areavolTile - volume of each tile, this gets summed to a global
c                     value
cts ---
            gencost_storefld(i,j,bi,bj,kgen) =
     &          gencost_storefld(i,j,bi,bj,kgen)
     &          +tmpmsk*tmpfld*tmpvol
            areavolTile(bi,bj)=areavolTile(bi,bj)
#ifdef ECCO_VARIABLE_AREAVOLGLOB
     &          +tmpmsk2*tmpvol
#else
     &          +tmpmsk2*eccoVol_0(i,j,k,bi,bj)
#endif

           ENDDO ! Ends do k=1,Nr

           tmpmsk  = 0. _d 0
           tmpfld  = 0. _d 0
           tmpmsk2 = 0. _d 0
           IF (gencost_barfile(kgen)(1:13).EQ.'m_boxmean_eta') THEN
            tmpmsk=maskC(i,j,1,bi,bj)*gencost_mskCsurf(i,j,bi,bj,kgen)
            tmpfld = m_eta(i,j,bi,bj)
#if (defined ATMOSPHERIC_LOADING) && (defined ALLOW_IB_CORR)
            IF (gencost_barfile(kgen)(1:17).EQ.'m_boxmean_eta_dyn') THEN
             tmpfld = m_eta_dyn(i,j,bi,bj)
            ENDIF
#endif
            IF (tmpmsk.NE.0. _d 0) tmpmsk2=1. _d 0
           ENDIF
#ifdef ALLOW_SHELFICE
cts ---
c Shelfice:
c   Simply accumulate shelfice FWF or HF into tmpfld here
c   This will fill gencost_storefld with this value *rA
c   For FreshWaterFlux
c           gencost_storefld = shelficefreshwaterflux / rho * rA
c                            = [kg/m^2/s] / [kg/m^3] * [m^2]
c                            = [m^3/s]
c
c   For heatflux
c           gencost_storefld = shelficeheatflux * rA
c                            = [W/m^2] *[m^2]
c                            = [W]
cts ---
           IF((gencost_barfile(kgen)(1:16).EQ.'m_boxmean_shifwf').OR.
     &        (gencost_barfile(kgen)(1:16).EQ.'m_boxmean_shihtf')) THEN

            tmpmsk=maskSHI(i,j,1,bi,bj)*
     &             gencost_mskCsurf(i,j,bi,bj,kgen)

            IF (gencost_barfile(kgen)(11:16).EQ.'shifwf') THEN
             tmpfld=shelficeFreshWaterFlux(i,j,bi,bj) / rhoConstFresh
            ELSEIF (gencost_barfile(kgen)(11:16).EQ.'shihtf') THEN
             tmpfld=shelficeHeatFlux(i,j,bi,bj)
            ENDIF
            IF (tmpmsk.NE.0. _d 0) tmpmsk2=1. _d 0
           ENDIF
#endif /* ALLOW_SHELFICE */

cts ---
c Fill 2D field
c   gencost_store - masked field of interest * rA
c
c Fill tile field (1 val per tile)
c       areavolTile - total rA on each tile for mskC != 0
cts ---
           gencost_storefld(i,j,bi,bj,kgen) =
     &        gencost_storefld(i,j,bi,bj,kgen)
     &        +tmpmsk*tmpfld*rA(i,j,bi,bj)
           areavolTile(bi,bj)=areavolTile(bi,bj)
     &        +tmpmsk2*rA(i,j,bi,bj)
c---------
           DO k = 1,Nr

            tmpmskW=0. _d 0
            tmpmskS=0. _d 0
            IF (.NOT.gencost_msk_is3d(kgen)) THEN
              tmpmskW=gencost_mskWsurf(i,j,bi,bj,kgen)
     &          *gencost_mskVertical(k,kgen)
              tmpmskS=gencost_mskSsurf(i,j,bi,bj,kgen)
     &          *gencost_mskVertical(k,kgen)
#ifdef ALLOW_GENCOST3D
            ELSE
              kgen3d=gencost_msk_pointer3d(kgen)
              tmpmskW=gencost_mskW(i,j,k,bi,bj,kgen3d)
              tmpmskS=gencost_mskS(i,j,k,bi,bj,kgen3d)
#endif /* ALLOW_GENCOST3D */
            ENDIF
            tmpmskW=tmpmskW*hFacW(i,j,k,bi,bj)*dyG(i,j,bi,bj)*drF(k)
            tmpmskS=tmpmskS*hFacS(i,j,k,bi,bj)*dxG(i,j,bi,bj)*drF(k)

            IF (gencost_barfile(kgen)(1:13).EQ.'m_horflux_vol') THEN
              gencost_storefld(i,j,bi,bj,kgen) =
     &          gencost_storefld(i,j,bi,bj,kgen)
     &          +uVel(i,j,k,bi,bj)*tmpmskW
     &          +vVel(i,j,k,bi,bj)*tmpmskS

            ! Only compute tr[Vol,Heat,Salt] if necessary, use
            ! gencost_mask[W/S] rather than old msktrVol
            ELSEIF ( gencost_barfile(kgen)(1:7).EQ.'m_trVol' .OR.
     &               gencost_barfile(kgen)(1:8).EQ.'m_trHeat'.OR.
     &               gencost_barfile(kgen)(1:8).EQ.'m_trSalt'    ) THEN

             trVolW(i,j,k) =
     &                 uVel(i,j,k,bi,bj)*tmpmskW
     &                *maskInW(i,j,bi,bj)
             trVolS(i,j,k) =
     &                 vVel(i,j,k,bi,bj)*tmpmskS
     &                *maskInS(i,j,bi,bj)

             trHeatW(i,j,k) = trVolW(i,j,k)
     &                *(theta(i,j,k,bi,bj)+theta(i-1,j,k,bi,bj))*halfRL
     &                *HeatCapacity_Cp*rhoConst
             trHeatS(i,j,k) = trVolS(i,j,k)
     &                *(theta(i,j,k,bi,bj)+theta(i,j-1,k,bi,bj))*halfRL
     &                *HeatCapacity_Cp*rhoConst

             trSaltW(i,j,k) = trVolW(i,j,k)
     &                *(salt(i,j,k,bi,bj)+salt(i-1,j,k,bi,bj))*halfRL
     &                *rhoConst/1000.
             trSaltS(i,j,k) = trVolS(i,j,k)
     &                *(salt(i,j,k,bi,bj)+salt(i,j-1,k,bi,bj))*halfRL
     &                *rhoConst/1000.
c now summing
             trVol(i,j,k,bi,bj)=trVolW(i,j,k)+trVolS(i,j,k)
             trHeat(i,j,k,bi,bj)=trHeatW(i,j,k)+trHeatS(i,j,k)
             trSalt(i,j,k,bi,bj)=trSaltW(i,j,k)+trSaltS(i,j,k)

            ENDIF
C     end k-loop
           ENDDO
c---------
          ENDDO
         ENDDO
        ENDDO
       ENDDO

cts ---
c Divide all values in gencost_storefld by
c   areavolGlob: scalar representing global volume of
c                quantity of interest.
c
c Note: for shelfice, do not take this final average to make
c       comparable to shelfice_cost_final.
cts ---
       IF ( gencost_barfile(kgen)(1:9).EQ.'m_boxmean' .AND.
     &      gencost_barfile(kgen)(11:13).NE.'shi' .AND.
     &      gencost_barfile(kgen)(11:13).NE.'vol' ) THEN
        CALL GLOBAL_SUM_TILE_RL( areavolTile, areavolGlob, myThid )
#ifdef ALLOW_AUTODIFF_TAMC
C     avoid recomputing areavolGlob multiple times each time this
C     routine is called
        ikey = kgen + (ikey_dynamics-1)*NGENCOST
CADJ STORE areavolGlob = comlev1_ngencost, key = ikey
#endif
        CALL ECCO_DIV( gencost_storefld(1-OLx,1-OLy,1,1,kgen),
     &                 areavolGlob, 1, 1, myThid )
       ENDIF

C     end kgen-loop
      ENDDO

#endif /* ALLOW_GENCOST_CONTRIBUTION */

      RETURN
      END

#include "AIM_OPTIONS.h"

CBOP
C     !ROUTINE: AIM_WRITE_PHYS
C     !INTERFACE:
      SUBROUTINE AIM_WRITE_PHYS(
     I               pref, suff, nNr, field,
     I               kLev, bi, bj, iRec, myIter, myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE AIM_WRITE_PHYS
C     | o Write variable from AIM physics common block
C     |   (=> no overlap & nThreads) and reverse K index.
C     *==========================================================*
C     | Note: assume symetry in tiles per thread treatment
C     *==========================================================*
C     !USES
      IMPLICIT NONE

C     == Global variables ===
#include "AIM_SIZE.h"

#include "EEPARAMS.h"
c #include "PARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     pref   :: Prefix of the output file name
C     suff   :: Suffix of the output file name
C     nNr    :: 3rd dim. of the input field
C     field  :: Field (from aim-physics) to write
C     kLev   :: level index to write (0 = write all levels)
C     bi,bj  :: Tile index
C     iRec   :: reccord number in the output file
C     myIter :: Current iteration number in simulation
C     myThid :: my Thread Id number
      CHARACTER*(*) pref, suff
      INTEGER nNr
      _RL field(sNx,sNy,nNr,MAX_NO_THREADS)
      INTEGER kLev, bi, bj, iRec, myIter, myThid

#ifdef ALLOW_AIM

C Functions
      INTEGER  ILNBLNK
      EXTERNAL ILNBLNK

C     !LOCAL VARIABLES:
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      _RL tmpFld(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      INTEGER iL
      INTEGER i, j, k, Katm, nLoc
      INTEGER ith, biLoc, bjLoc
CEOP

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#ifdef LOCBIN_IO_THREAD_SAFE
C-    safe for any thread to do IO
      ith = myThid
      biLoc = bi
      bjLoc = bj
#else /* LOCBIN_IO_THREAD_SAFE */
C-    master-thread does IO for all threads
      _BARRIER
      _BEGIN_MASTER( myThid )
      DO ith=1,nThreads
        biLoc = bi + myBxLo(ith) - 1
        bjLoc = bj + myByLo(ith) - 1
#endif /* LOCBIN_IO_THREAD_SAFE */

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C--   Check for argument list consistency
        IF ( nNr.LT.1 .OR. nNr.GT.Nr ) THEN
          iL = ILNBLNK( pref )
          WRITE(msgBuf,'(A,I10,A,2I5,A,I4,2A)')
     &      'AIM_WRITE_PHYS (it=', myIter, ' bi,bj=', bi,bj,
     &      ' iRec=', iRec, ' ): try to write: ', pref(1:iL)
          CALL PRINT_ERROR( msgBuf, myThid )
          WRITE(msgBuf,'(A,I4,A,I4)')
     &      'AIM_WRITE_PHYS: 3rd dim.(field)=',nNr,' has to be <',Nr
          CALL PRINT_ERROR( msgBuf , myThid)
          STOP 'ABNORMAL END: S/R AIM_WRITE_PHYS'
        ELSEIF ( kLev.NE.0 .AND. kLev.GT.nNr ) THEN
          iL = ILNBLNK( pref )
          WRITE(msgBuf,'(A,I10,A,2I5,A,I4,2A)')
     &      'AIM_WRITE_PHYS (it=', myIter, ' bi,bj=', bi,bj,
     &      ' iRec=', iRec, ' ): try to write: ', pref(1:iL)
          CALL PRINT_ERROR( msgBuf, myThid )
          WRITE(msgBuf,'(A,I4,A,I4)')
     &     'AIM_WRITE_PHYS: kLev=', kLev,
     &     ' out of bounds (dim=', nNr,' )'
          CALL PRINT_ERROR( msgBuf , myThid)
          STOP 'ABNORMAL END: S/R AIM_WRITE_PHYS'
        ENDIF

C--   Copy the input field into tempo. array:
        nLoc = nNr
        IF ( kLev.GE.1 .AND. kLev.LE.nNr ) THEN
          nLoc = 1
          DO j=1,sNy
           DO i=1,sNx
            tmpFld(i,j,1) = field(i,j,kLev,ith)
           ENDDO
          ENDDO
        ELSEIF (nNr.EQ.Nr) THEN
C-     Reverse K index:
         DO k=1,Nr
          Katm = _KD2KA( k )
          DO j=1,sNy
           DO i=1,sNx
            tmpFld(i,j,k) = field(i,j,Katm,ith)
           ENDDO
          ENDDO
         ENDDO
        ELSE
C-     Do simple copy
         DO k=1,nNr
          DO j=1,sNy
           DO i=1,sNx
            tmpFld(i,j,k) = field(i,j,k,ith)
           ENDDO
          ENDDO
         ENDDO
        ENDIF

C--   Write to file: note: call with myThArg=0 => single thread job
        CALL WRITE_LOCAL_RL( pref, suff, nLoc, tmpFld,
     &                       biLoc, bjLoc, iRec, myIter, 0 )

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#ifndef LOCBIN_IO_THREAD_SAFE
      ENDDO
      _END_MASTER( myThid )
      _BARRIER
#endif /* ndef LOCBIN_IO_THREAD_SAFE */

#endif /* ALLOW_AIM */
      RETURN
      END

#include "FIZHI_OPTIONS.h"
      SUBROUTINE FIZHI_STEP_DIAG(myid,p,uphy,vphy,thphy,sphy,qq,pk,dp,
     &  radswt,radswg,swgclr,osr,osrclr,st4,dst4,tgz,tg0,radlwg,lwgclr,
     &  turbu,turbv,turbt,turbq,moistu,moistv,moistt,moistq,
     &  lwdt,swdt,lwdtclr,swdtclr,dlwdtg,
     &  im1,im2,jm1,jm2,Nrphys,Nbi,Nbj,bi,bj,ntracer)
C***********************************************************************
      IMPLICIT NONE

      INTEGER myid,im1,im2,jm1,jm2,Nrphys,Nbi,Nbj,bi,bj,ntracer
      _RL p(im2,jm2,Nbi,Nbj)
      _RL uphy(im2,jm2,Nrphys)
      _RL vphy(im2,jm2,Nrphys)
      _RL thphy(im2,jm2,Nrphys)
      _RL sphy(im2,jm2,Nrphys)
      _RL qq(im2,jm2,Nrphys,Nbi,Nbj),pk(im2,jm2,Nrphys,Nbi,Nbj)
      _RL dp(im2,jm2,Nrphys,Nbi,Nbj)
      _RL radswt(im2,jm2,Nbi,Nbj),radswg(im2,jm2,Nbi,Nbj)
      _RL swgclr(im2,jm2,Nbi,Nbj),osr(im2,jm2,Nbi,Nbj)
      _RL osrclr(im2,jm2,Nbi,Nbj),st4(im2,jm2,Nbi,Nbj)
      _RL dst4(im2,jm2,Nbi,Nbj),tgz(im2,jm2,Nbi,Nbj)
      _RL tg0(im2,jm2,Nbi,Nbj),radlwg(im2,jm2,Nbi,Nbj)
      _RL lwgclr(im2,jm2,Nbi,Nbj)
      _RL turbu(im2,jm2,Nrphys,Nbi,Nbj)
      _RL turbv(im2,jm2,Nrphys,Nbi,Nbj)
      _RL turbt(im2,jm2,Nrphys,Nbi,Nbj)
      _RL turbq(im2,jm2,Nrphys,ntracer,Nbi,Nbj)
      _RL moistu(im2,jm2,Nrphys,Nbi,Nbj)
      _RL moistv(im2,jm2,Nrphys,Nbi,Nbj)
      _RL moistt(im2,jm2,Nrphys,Nbi,Nbj)
      _RL moistq(im2,jm2,Nrphys,ntracer,Nbi,Nbj)
      _RL lwdt(im2,jm2,Nrphys,Nbi,Nbj)
      _RL swdt(im2,jm2,Nrphys,Nbi,Nbj)
      _RL lwdtclr(im2,jm2,Nrphys,Nbi,Nbj)
      _RL swdtclr(im2,jm2,Nrphys,Nbi,Nbj)
      _RL dlwdtg(im2,jm2,Nrphys,Nbi,Nbj)

      INTEGER  i,j,L
      _RL getcon, gravity
      _RL pinv(im2,jm2), qbar(im2,jm2),tmpdiag(im2,jm2)
#ifdef ALLOW_DIAGNOSTICS
      LOGICAL  diagnostics_is_on
      EXTERNAL diagnostics_is_on
#endif

C **********************************************************************

#ifdef ALLOW_DIAGNOSTICS
      do j=jm1,jm2
      do i=im1,im2
      pinv(i,j) = 1.0 / p(i,j,bi,bj)
      enddo
      enddo

c Surface Pressure (mb)
c ---------------------------------
      call diagnostics_fill(p(1,1,bi,bj),'PS      ',0,1,3,bi,bj,myid)

c Incident Solar Radiation (W/m**2)
c ---------------------------------
      call diagnostics_fill(radswt(1,1,bi,bj),'RADSWT  ',
     &                      0,1,3,bi,bj,myid)

c Net Solar Radiation at the Ground (W/m**2)
c ------------------------------------------
      if(diagnostics_is_on('RADSWG  ',myid) ) then
       do j=jm1,jm2
       do i=im1,im2
        tmpdiag(i,j) = radswg(i,j,bi,bj)*radswt(i,j,bi,bj)
       enddo
       enddo
       call diagnostics_fill(tmpdiag,'RADSWG  ',0,1,3,bi,bj,myid)
      endif

c Net Clear Sky Solar Radiation at the Ground (W/m**2)
c ----------------------------------------------------
      if(diagnostics_is_on('SWGCLR  ',myid) ) then
       do j=jm1,jm2
       do i=im1,im2
        tmpdiag(i,j) = swgclr(i,j,bi,bj)*radswt(i,j,bi,bj)
       enddo
       enddo
       call diagnostics_fill(tmpdiag,'SWGCLR  ',0,1,3,bi,bj,myid)
      endif

c Outgoing Solar Radiation at top (W/m**2)
c -----------------------------------------
      if(diagnostics_is_on('OSR     ',myid) ) then
       do j=jm1,jm2
       do i=im1,im2
        tmpdiag(i,j) = (1.0-osr(i,j,bi,bj))*radswt(i,j,bi,bj)
       enddo
       enddo
       call diagnostics_fill(tmpdiag,'OSR     ',0,1,3,bi,bj,myid)
      endif

c Outgoing Clear Sky Solar Radiation at top (W/m**2)
c ---------------------------------------------------
      if(diagnostics_is_on('OSRCLR  ',myid) ) then
       do j=jm1,jm2
       do i=im1,im2
        tmpdiag(i,j) = (1.0-osrclr(i,j,bi,bj))*radswt(i,j,bi,bj)
       enddo
       enddo
       call diagnostics_fill(tmpdiag,'OSRCLR  ',0,1,3,bi,bj,myid)
      endif

c Planetary Albedo
c ----------------
      if(diagnostics_is_on('PLALBEDO',myid) ) then
       do j=jm1,jm2
       do i=im1,im2
        if(radswt(i,j,bi,bj).ne.0.) then
         tmpdiag(i,j) = osr(i,j,bi,bj)
        else
         tmpdiag(i,j) = 0.
        endif
       enddo
       enddo
       call diagnostics_fill(tmpdiag,'PLALBEDO',0,1,3,bi,bj,myid)
      endif

c Upward Longwave Flux at the Ground (W/m**2)
c -------------------------------------------
      if(diagnostics_is_on('LWGUP   ',myid) ) then
       do j=jm1,jm2
       do i=im1,im2
        tmpdiag(i,j) = st4(i,j,bi,bj)
     &                 + dst4(i,j,bi,bj)*(tgz(i,j,bi,bj)-tg0(i,j,bi,bj))
       enddo
       enddo
       call diagnostics_fill(tmpdiag,'LWGUP   ',0,1,3,bi,bj,myid)
      endif

c Net Longwave Flux at the Ground (W/m**2)
c ----------------------------------------
      if(diagnostics_is_on('RADLWG  ',myid) ) then
       do j=jm1,jm2
       do i=im1,im2
        tmpdiag(i,j) = radlwg(i,j,bi,bj) +
     &                  dst4(i,j,bi,bj)*(tgz(i,j,bi,bj)-tg0(i,j,bi,bj))
       enddo
       enddo
       call diagnostics_fill(tmpdiag,'RADLWG  ',0,1,3,bi,bj,myid)
      endif

c Net Longwave Flux at the Ground Clear Sky (W/m**2)
c --------------------------------------------------
      if(diagnostics_is_on('LWGCLR  ',myid) ) then
       do j=jm1,jm2
       do i=im1,im2
        tmpdiag(i,j) = lwgclr(i,j,bi,bj) +
     &                  dst4(i,j,bi,bj)*(tgz(i,j,bi,bj)-tg0(i,j,bi,bj))
       enddo
       enddo
       call diagnostics_fill(tmpdiag,'LWGCLR  ',0,1,3,bi,bj,myid)
      endif

C **********************************************************************
      do L=1,Nrphys

c Total Diabatic U-Tendency (m/sec/day)
c -------------------------------------
      if(diagnostics_is_on('DIABU   ',myid) ) then
       do j=jm1,jm2
       do i=im1,im2
        tmpdiag(i,j) = (moistu (i,j,L,bi,bj)+turbu(i,j,L,bi,bj) )*86400
       enddo
       enddo
       call diagnostics_fill(tmpdiag,'DIABU   ',L,1,3,bi,bj,myid)
      endif

c Total Diabatic V-Tendency (m/sec/day)
c -------------------------------------
      if(diagnostics_is_on('DIABV   ',myid) ) then
       do j=jm1,jm2
       do i=im1,im2
        tmpdiag(i,j) = (moistv (i,j,L,bi,bj)+turbv(i,j,L,bi,bj) )*86400
       enddo
       enddo
       call diagnostics_fill(tmpdiag,'DIABV   ',L,1,3,bi,bj,myid)
      endif

c Total Diabatic T-Tendency (deg/day)
c -----------------------------------
      if(diagnostics_is_on('DIABT   ',myid) ) then
       do j=jm1,jm2
       do i=im1,im2
        tmpdiag(i,j) =
     &   ( turbt(i,j,L,bi,bj) + moistt(i,j,L,bi,bj) +
     &      lwdt(i,j,L,bi,bj) +
     &      dlwdtg(i,j,L,bi,bj)*(tgz(i,j,bi,bj)-tg0(i,j,bi,bj)) +
     &      swdt(i,j,L,bi,bj)*radswt(i,j,bi,bj) )
     &      * pk(i,j,L,bi,bj)*pinv(i,j)*86400
       enddo
       enddo
       call diagnostics_fill(tmpdiag,'DIABT   ',L,1,3,bi,bj,myid)
      endif

c Total Diabatic Q-Tendency (g/kg/day)
c ------------------------------------
      if(diagnostics_is_on('DIABQ   ',myid) ) then
       do j=jm1,jm2
       do i=im1,im2
        tmpdiag(i,j) =
     & ( turbq(i,j,L,1,bi,bj) + moistq(i,j,L,1,bi,bj) ) *
     &                                      pinv(i,j)*86400*1000
       enddo
       enddo
       call diagnostics_fill(tmpdiag,'DIABQ   ',L,1,3,bi,bj,myid)
      endif

c Longwave Heating (deg/day)
c --------------------------
      if(diagnostics_is_on('RADLW   ',myid) ) then
       do j=jm1,jm2
       do i=im1,im2
        tmpdiag(i,j) =
     & ( lwdt(i,j,l,bi,bj) +
     &            dlwdtg (i,j,L,bi,bj)*(tgz(i,j,bi,bj)-tg0(i,j,bi,bj)) )
     &                      * pk(i,j,l,bi,bj)*pinv(i,j)*86400
       enddo
       enddo
       call diagnostics_fill(tmpdiag,'RADLW   ',L,1,3,bi,bj,myid)
      endif

c Longwave Heating Clear-Sky (deg/day)
c ------------------------------------
      if(diagnostics_is_on('LWCLR   ',myid) ) then
       do j=jm1,jm2
       do i=im1,im2
        tmpdiag(i,j) =
     & ( lwdtclr(i,j,l,bi,bj) +
     &            dlwdtg (i,j,L,bi,bj)*(tgz(i,j,bi,bj)-tg0(i,j,bi,bj)) )
     &                      * pk(i,j,l,bi,bj)*pinv(i,j)*86400
       enddo
       enddo
       call diagnostics_fill(tmpdiag,'LWCLR   ',L,1,3,bi,bj,myid)
      endif

c Solar Radiative Heating (deg/day)
c ---------------------------------
      if(diagnostics_is_on('RADSW   ',myid) ) then
       do j=jm1,jm2
       do i=im1,im2
        tmpdiag(i,j) =
     &  + swdt(i,j,l,bi,bj)*radswt(i,j,bi,bj)*
     &                   pk(i,j,l,bi,bj)*pinv(i,j)*86400
       enddo
       enddo
       call diagnostics_fill(tmpdiag,'RADSW   ',L,1,3,bi,bj,myid)
      endif

c Clear Sky Solar Radiative Heating (deg/day)
c -------------------------------------------
      if(diagnostics_is_on('SWCLR   ',myid) ) then
       do j=jm1,jm2
       do i=im1,im2
        tmpdiag(i,j) =
     &  + swdtclr(i,j,l,bi,bj)*radswt(i,j,bi,bj)*
     &                   pk(i,j,l,bi,bj)*pinv(i,j)*86400
       enddo
       enddo
       call diagnostics_fill(tmpdiag,'SWCLR   ',L,1,3,bi,bj,myid)
      endif

c Averaged U-Field (m/sec)
c ------------------------
      if(diagnostics_is_on('UWND    ',myid) ) then
       do j=jm1,jm2
       do i=im1,im2
        tmpdiag(i,j) = uphy(i,j,L)
       enddo
       enddo
       call diagnostics_fill(tmpdiag,'UWND    ',L,1,3,bi,bj,myid)
      endif

c Averaged V-Field (m/sec)
c ------------------------
      if(diagnostics_is_on('VWND    ',myid) ) then
       do j=jm1,jm2
       do i=im1,im2
        tmpdiag(i,j) = vphy(i,j,L)
       enddo
       enddo
       call diagnostics_fill(tmpdiag,'VWND    ',L,1,3,bi,bj,myid)
      endif

c Averaged T-Field (deg)
c ----------------------
      if(diagnostics_is_on('TMPU    ',myid) ) then
       do j=jm1,jm2
       do i=im1,im2
        tmpdiag(i,j) = thphy(i,j,L)*pk(i,j,L,bi,bj)
       enddo
       enddo
       call diagnostics_fill(tmpdiag,'TMPU    ',L,1,3,bi,bj,myid)
      endif

c Averaged QQ-Field (m/sec)**2
c ----------------------------
      if(diagnostics_is_on('TKE     ',myid) ) then
       do j=jm1,jm2
       do i=im1,im2
        tmpdiag(i,j) = qq(i,j,L,bi,bj)
       enddo
       enddo
       call diagnostics_fill(tmpdiag,'TKE     ',L,1,3,bi,bj,myid)
      endif

c Averaged Q-Field (g/kg)
c -----------------------
      if(diagnostics_is_on('SPHU    ',myid) ) then
       do j=jm1,jm2
       do i=im1,im2
        tmpdiag(i,j) = sphy(i,j,L) * 1000.
       enddo
       enddo
       call diagnostics_fill(tmpdiag,'SPHU    ',L,1,3,bi,bj,myid)
      endif

      enddo

C **********************************************************************

c Vertically Averaged Moist-T Increment (K/day)
c ---------------------------------------------
      if(diagnostics_is_on('VDTMOIST',myid) ) then
       do j=jm1,jm2
       do i=im1,im2
       qbar(i,j) = 0.0
       enddo
       enddo
       do L=1,Nrphys
       do j=jm1,jm2
       do i=im1,im2
       qbar(i,j) = qbar(i,j) +
     &             moistt(i,j,L,bi,bj)*pk(i,j,l,bi,bj)*dp(i,j,L,bi,bj)
       enddo
       enddo
       enddo
       do j=jm1,jm2
       do i=im1,im2
       tmpdiag(i,j) = qbar(i,j)*pinv(i,j)*pinv(i,j)*86400
       enddo
       enddo
       call diagnostics_fill(tmpdiag,'VDTMOIST',0,1,3,bi,bj,myid)
      endif

c Vertically Averaged Turb-T Increment (K/day)
c --------------------------------------------
      if(diagnostics_is_on('VDTTURB ',myid) ) then
       do j=jm1,jm2
       do i=im1,im2
       qbar(i,j) = 0.0
       enddo
       enddo
       do L=1,Nrphys
       do j=jm1,jm2
       do i=im1,im2
       qbar(i,j) = qbar(i,j) +
     &             turbt(i,j,L,bi,bj)*pk(i,j,l,bi,bj)*dp(i,j,L,bi,bj)
       enddo
       enddo
       enddo
       do j=jm1,jm2
       do i=im1,im2
       tmpdiag(i,j) = qbar(i,j)*pinv(i,j)*pinv(i,j)*86400
       enddo
       enddo
       call diagnostics_fill(tmpdiag,'VDTTURB ',0,1,3,bi,bj,myid)
      endif

c Vertically Averaged RADLW Temperature Increment (K/day)
c -------------------------------------------------------
      if(diagnostics_is_on('VDTRADLW',myid) ) then
       do j=jm1,jm2
       do i=im1,im2
       qbar(i,j) = 0.0
       enddo
       enddo
       do L=1,Nrphys
       do j=jm1,jm2
       do i=im1,im2
        qbar(i,j) = qbar(i,j) + ( lwdt(i,j,L,bi,bj) +
     &  dlwdtg(i,j,L,bi,bj)*(tgz(i,j,bi,bj)-tg0(i,j,bi,bj)) )
     &             *pk(i,j,l,bi,bj)*dp(i,j,L,bi,bj)
       enddo
       enddo
       enddo
       do j=jm1,jm2
       do i=im1,im2
       tmpdiag(i,j) = qbar(i,j)*pinv(i,j)*pinv(i,j)*86400
       enddo
       enddo
       call diagnostics_fill(tmpdiag,'VDTRADLW',0,1,3,bi,bj,myid)
      endif

c Vertically Averaged RADSW Temperature Increment (K/day)
c -------------------------------------------------------
      if(diagnostics_is_on('VDTRADSW',myid) ) then
       do j=jm1,jm2
       do i=im1,im2
       qbar(i,j) = 0.0
       enddo
       enddo
       do L=1,Nrphys
       do j=jm1,jm2
       do i=im1,im2
        qbar(i,j) = qbar(i,j) +
     &             swdt(i,j,L,bi,bj)*pk(i,j,l,bi,bj)*dp(i,j,L,bi,bj)
       enddo
       enddo
       enddo
       do j=jm1,jm2
       do i=im1,im2
       tmpdiag(i,j) = qbar(i,j) *
     &             radswt(i,j,bi,bj) * pinv(i,j) * pinv(i,j) * 86400
       enddo
       enddo
       call diagnostics_fill(tmpdiag,'VDTRADSW',0,1,3,bi,bj,myid)
      endif

c Total Precipitable Water (g/cm^2)
c ---------------------------------------------
      if(diagnostics_is_on('TPW     ',myid) ) then
       gravity = getcon('GRAVITY')
       do j=jm1,jm2
       do i=im1,im2
       qbar(i,j) = 0.0
       enddo
       enddo
       do L=1,Nrphys
       do j=jm1,jm2
       do i=im1,im2
       qbar(i,j) = qbar(i,j) +
     &             sphy(i,j,L)*dp(i,j,L,bi,bj)
       enddo
       enddo
       enddo
       do j=jm1,jm2
       do i=im1,im2
       tmpdiag(i,j) = qbar(i,j)*10. _d 0 /gravity
       enddo
       enddo
       call diagnostics_fill(tmpdiag,'TPW     ',0,1,3,bi,bj,myid)
      endif
#endif
      return
      end

#include "AUTODIFF_OPTIONS.h"
#ifdef ALLOW_CTRL
# include "CTRL_OPTIONS.h"
#endif
#include "AD_CONFIG.h"

CBOP
C     !ROUTINE: g_dummy_in_stepping
C     !INTERFACE:
      subroutine g_dummy_in_stepping( myTime, myIter, myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE g_dummy_in_stepping                           |
C     *==========================================================*
C     Extract tangent linear variable from TAF-generated
C     tangent linear common blocks, contained in g_common.h
C     and write fields to file;
C     Make sure common blocks in g_common.h are up-to-date
C     w.r.t. current adjoint code.
C     *==========================================================*
C     | SUBROUTINE g_dummy_in_stepping                           |
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     == Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#ifdef ALLOW_AUTODIFF_MONITOR
# include "g_common.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     myIter :: iteration counter for this thread
C     myTime :: time counter for this thread
C     myThid :: Thread number for this instance of the routine.
      INTEGER myThid
      INTEGER myIter
      _RL     myTime

#ifdef ALLOW_TANGENTLINEAR_RUN
#ifdef ALLOW_AUTODIFF_MONITOR

C     !FUNCTIONS:
      LOGICAL  DIFFERENT_MULTIPLE
      EXTERNAL DIFFERENT_MULTIPLE
      INTEGER  IO_ERRCOUNT
      EXTERNAL IO_ERRCOUNT

C     !LOCAL VARIABLES:
c     == local variables ==
C     suff   :: Hold suffix part of a filename
C     msgBuf :: Error message buffer
      CHARACTER*(10) suff
      INTEGER beginIOErrCount
      INTEGER endIOErrCount
      CHARACTER*(MAX_LEN_MBUF) msgBuf
CEOP

      IF (
     &  DIFFERENT_MULTIPLE(adjDumpFreq,myTime,deltaTClock)
     &   ) THEN

        CALL TIMER_START('I/O (WRITE)        [ADJOINT LOOP]', myThid )
c       write(*,*) 'myIter= ',myIter

C--     Set suffix for this set of data files.
        IF ( rwSuffixType.EQ.0 ) THEN
          WRITE(suff,'(I10.10)') myIter
        ELSE
          CALL RW_GET_SUFFIX( suff, myTime, myIter, myThid )
        ENDIF

C--     Read IO error counter
        beginIOErrCount = IO_ERRCOUNT(myThid)

        CALL WRITE_FLD_XY_RL ( 'G_Jtaux.',suff, g_fu, myIter, myThid )
        CALL WRITE_FLD_XY_RL ( 'G_Jtauy.',suff, g_fv, myIter, myThid )
        CALL WRITE_FLD_XY_RL ( 'G_Jqnet.',suff, g_qnet, myIter,myThid )
        CALL WRITE_FLD_XY_RL ( 'G_Jempr.',suff, g_empmr,myIter,myThid )
c
        CALL WRITE_FLD_XYZ_RL(
     &       'G_Jtheta.',suff, g_theta, myIter, myThid )
        CALL WRITE_FLD_XYZ_RL(
     &       'G_Jsalt.',suff, g_salt, myIter, myThid )
        CALL WRITE_FLD_XYZ_RL(
     &       'G_Juvel.',suff, g_uvel, myIter, myThid )
        CALL WRITE_FLD_XYZ_RL(
     &       'G_Jvvel.',suff, g_vvel, myIter, myThid )
        CALL WRITE_FLD_XYZ_RL(
     &       'G_Jwvel.',suff, g_wvel, myIter, myThid )
        CALL WRITE_FLD_XY_RL(
     &       'G_Jetan.',suff, g_etan, myIter, myThid )

#ifdef ALLOW_DIFFKR_CONTROL
        CALL WRITE_FLD_XYZ_RL ( 'G_Jdiffkr.',suff, g_diffkr,
     &       myIter, myThid )
#endif
#ifdef ALLOW_KAPGM_CONTROL
        CALL WRITE_FLD_XYZ_RL ( 'G_Jkapgm.',suff, g_kapgm,
     &       myIter, myThid )
#endif
#ifdef ALLOW_KAPREDI_CONTROL
        CALL WRITE_FLD_XYZ_RL ( 'G_Jkapredi.',suff, g_kapredi,
     &       myIter, myThid )
#endif

cph        CALL WRITE_FLD_XY_RL( 'G_J_sst.',suff, g_sst, myIter, myThid )
cph        CALL WRITE_FLD_XY_RL( 'G_J_sss.',suff, g_sss, myIter, myThid )

C--     Reread IO error counter
        endIOErrCount = IO_ERRCOUNT(myThid)

C--     Check for IO errors
        IF ( endIOErrCount .NE. beginIOErrCount ) THEN
         WRITE(msgBuf,'(A)')  'S/R WRITE_STATE'
         CALL PRINT_ERROR( msgBuf, myThid )
         WRITE(msgBuf,'(A)')  'Error writing out model state'
         CALL PRINT_ERROR( msgBuf, myThid )
         WRITE(msgBuf,'(A,I10)') 'Timestep ',myIter
         CALL PRINT_ERROR( msgBuf, myThid )
        ELSE
         WRITE(msgBuf,'(A,I10)')
     &    '// Model state written, timestep', myIter
         CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                       SQUEEZE_RIGHT, myThid )
         WRITE(msgBuf,'(A)')  ' '
         CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                       SQUEEZE_RIGHT, myThid )
        ENDIF

        CALL TIMER_STOP( 'I/O (WRITE)        [ADJOINT LOOP]', myThid )

      ENDIF

#endif /* ALLOW_AUTODIFF_MONITOR */
#endif /* ALLOW_TANGENTLINEAR_RUN */

      RETURN
      END

#include "KPP_OPTIONS.h"
#ifdef ALLOW_AUTODIFF
# include "AUTODIFF_OPTIONS.h"
#endif
#ifdef ALLOW_SALT_PLUME
#include "SALT_PLUME_OPTIONS.h"
#endif
#if (defined ALLOW_AUTODIFF_TAMC) && (defined KPP_AUTODIFF_EXCESSIVE_STORE)
# define KPP_AUTODIFF_MORE_STORE
#endif

C-- File kpp_routines.F: subroutines needed to implement
C--                      KPP vertical mixing scheme
C--  Contents
C--  o KPPMIX      - Main driver and interface routine.
C--  o BLDEPTH     - Determine oceanic planetary boundary layer depth.
C--  o WSCALE      - Compute turbulent velocity scales.
C--  o RI_IWMIX    - Compute interior viscosity diffusivity coefficients.
C--  o Z121        - Apply 121 vertical smoothing.
C--  o SMOOTH_HORIZ- Apply horizontal smoothing to global array.
C--  o BLMIX       - Boundary layer mixing coefficients.
C--  o ENHANCE     - Enhance diffusivity at boundary layer interface.
C--  o STATEKPP    - Compute buoyancy-related input arrays.
C--  o KPP_DOUBLEDIFF - Compute double diffusive contribution to diffusivities

c***********************************************************************

      SUBROUTINE KPPMIX (
     I       kmtj, shsq, dvsq, ustar, msk,
     I       bo, bosol,
#ifdef ALLOW_SALT_PLUME
     I       boplume, SPDepth,
#ifdef SALT_PLUME_SPLIT_BASIN
     I       lon, lat,
#endif /* SALT_PLUME_SPLIT_BASIN */
#endif /* ALLOW_SALT_PLUME */
     I       dbloc, Ritop, coriol,
#ifdef SHORTWAVE_HEATING
     I       swatt,
#endif
     I       diffusKzS, diffusKzT,
     I       ikey,
     O       diffus,
     U       ghat,
     O       hbl,
#ifdef SHORTWAVE_HEATING
     O       kbl,
#endif
     I       bi, bj, myTime, myIter, myThid )

c-----------------------------------------------------------------------
c
c     Main driver subroutine for kpp vertical mixing scheme and
c     interface to greater ocean model
c
c     written  by: bill large,    june  6, 1994
c     modified by: jan morzel,    june 30, 1994
c                  bill large,  august 11, 1994
c                  bill large, january 25, 1995 : "dVsq" and 1d code
c                  detlef stammer,  august 1997 : for use with MIT GCM Classic
c                  d. menemenlis,     june 1998 : for use with MIT GCM UV
c
c-----------------------------------------------------------------------

      IMPLICIT NONE

#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "KPP_PARAMS.h"
#ifdef ALLOW_AUTODIFF_TAMC
# include "tamc.h"
#endif

c input
c   bi, bj :: Array indices on which to apply calculations
c   myTime :: Current time in simulation
c   myIter :: Current iteration number in simulation
c   myThid :: My Thread Id. number
C     ikey :: tape key TAF-AD simulations (depends on tiles)
c     kmtj   (imt)     - number of vertical layers on this row
c     msk    (imt)     - surface mask (=1 if water, =0 otherwise)
c     shsq   (imt,Nr)  - (local velocity shear)^2                     ((m/s)^2)
c     dvsq   (imt,Nr)  - (velocity shear re sfc)^2                    ((m/s)^2)
c     ustar  (imt)     - surface friction velocity                        (m/s)
c     bo     (imt)     - surface turbulent buoy. forcing              (m^2/s^3)
c     bosol  (imt)     - radiative buoyancy forcing                   (m^2/s^3)
c     boplume(imt,Nrp1)- haline buoyancy forcing                      (m^2/s^3)
c     dbloc  (imt,Nr)  - local delta buoyancy across interfaces         (m/s^2)
c     dblocSm(imt,Nr)  - horizontally smoothed dbloc                    (m/s^2)
c                          stored in ghat to save space
c     Ritop  (imt,Nr)  - numerator of bulk Richardson Number
c                          (zref-z) * delta buoyancy w.r.t. surface   ((m/s)^2)
c     coriol (imt)     - Coriolis parameter                               (1/s)
c     swatt  (imt,Nr+1)- fraction of SW radiation entering kth-cell from above
c     diffusKzS(imt,Nr)- background vertical diffusivity for scalars    (m^2/s)
c     diffusKzT(imt,Nr)- background vertical diffusivity for theta      (m^2/s)
c     hbl    (imt)     - mixing layer depth                                 (m)
c     kbl    (imt)     - index of first grid level below hbl
c     note: there is a conversion from 2-D to 1-D for input output variables,
c           e.g., hbl(sNx,sNy) -> hbl(imt),
c           where hbl(i,j) -> hbl((j-1)*sNx+i)
      INTEGER bi, bj
      _RL     myTime
      INTEGER myIter
      INTEGER myThid
      INTEGER kmtj (imt   )
      INTEGER kbl  (imt   )
      _RL shsq     (imt,Nr)
      _RL dvsq     (imt,Nr)
      _RL ustar    (imt   )
      _RL bo       (imt   )
      _RL bosol    (imt   )
#ifdef ALLOW_SALT_PLUME
      _RL boplume  (imt,Nrp1)
      _RL SPDepth  (imt   )
#ifdef SALT_PLUME_SPLIT_BASIN
      _RL lon  (imt   )
      _RL lat  (imt   )
#endif /* SALT_PLUME_SPLIT_BASIN */
#endif /* ALLOW_SALT_PLUME */
      _RL dbloc    (imt,Nr)
      _RL Ritop    (imt,Nr)
      _RS coriol   (imt   )
#ifdef SHORTWAVE_HEATING
      _RS swatt    (imt,Nr+1)
#endif
      _RS msk      (imt   )
      _RL diffusKzS(imt,Nr)
      _RL diffusKzT(imt,Nr)

      INTEGER ikey

c output
c     diffus (imt,1)  - vertical viscosity coefficient                  (m^2/s)
c     diffus (imt,2)  - vertical scalar diffusivity                     (m^2/s)
c     diffus (imt,3)  - vertical temperature diffusivity                (m^2/s)
c     ghat   (imt)    - nonlocal transport coefficient                  (s/m^2)
c     hbl    (imt)    - mixing layer depth                                  (m)

      _RL diffus(imt,0:Nrp1,mdiff)
      _RL ghat  (imt,Nr)
      _RL hbl   (imt)

#ifdef ALLOW_KPP

c local
c     bfsfc  (imt         ) - surface buoyancy forcing                (m^2/s^3)
c     casea  (imt         ) - 1 in case A; 0 in case B
c     stable (imt         ) - 1 in stable forcing; 0 if unstable
c     dkm1   (imt,   mdiff) - boundary layer diffusivity at kbl-1 level
c     blmc   (imt,Nr,mdiff) - boundary layer mixing coefficients
c     sigma  (imt         ) - normalized depth (d / hbl)
c     Rib    (imt,Nr      ) - bulk Richardson number

      _RL bfsfc  (imt         )
      _RL casea  (imt         )
      _RL stable (imt         )
      _RL dkm1   (imt,   mdiff)
      _RL blmc   (imt,Nr,mdiff)
      _RL sigma  (imt         )
      _RL Rib    (imt,Nr      )

      INTEGER i, k, md

c-----------------------------------------------------------------------
c compute interior mixing coefficients everywhere, due to constant
c internal wave activity, static instability, and local shear
c instability.
c (ghat is temporary storage for horizontally smoothed dbloc)
c-----------------------------------------------------------------------

cph(
cph these storings avoid recomp. of Ri_iwmix
#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE ghat  = comlev1_kpp, key=ikey, kind=isbyte
CADJ STORE dbloc = comlev1_kpp, key=ikey, kind=isbyte
#endif
cph)
      CALL Ri_iwmix (
     I       kmtj, shsq, dbloc, ghat,
     I       diffusKzS, diffusKzT,
     I       ikey,
     O       diffus, myThid )

cph(
cph storing diffus avoids recomp. of Ri_iwmix
#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE diffus = comlev1_kpp, key=ikey, kind=isbyte
#endif
cph)

c-----------------------------------------------------------------------
c set seafloor values to zero and fill extra "Nrp1" coefficients
c for blmix
c-----------------------------------------------------------------------

      DO md = 1, mdiff
       DO k=1,Nrp1
        DO i = 1,imt
         IF (k.GE.kmtj(i)) diffus(i,k,md) = 0.0
        ENDDO
       ENDDO
      ENDDO

c-----------------------------------------------------------------------
c compute boundary layer mixing coefficients:
c
c diagnose the new boundary layer depth
c-----------------------------------------------------------------------

      CALL bldepth (
     I       kmtj,
     I       dvsq, dbloc, Ritop, ustar, bo, bosol,
#ifdef ALLOW_SALT_PLUME
     I       boplume, SPDepth,
#ifdef SALT_PLUME_SPLIT_BASIN
     I       lon, lat,
#endif /* SALT_PLUME_SPLIT_BASIN */
#endif /* ALLOW_SALT_PLUME */
     I       coriol,
#ifdef SHORTWAVE_HEATING
     I       swatt,
#endif
     I       ikey,
     O       hbl, bfsfc, stable, casea, kbl, Rib, sigma,
     I       bi, bj, myTime, myIter, myThid )

#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE hbl,bfsfc,stable,casea,kbl = comlev1_kpp,
CADJ &     key=ikey, kind=isbyte
#endif

c-----------------------------------------------------------------------
c compute boundary layer diffusivities
c-----------------------------------------------------------------------

      CALL blmix (
     I       ustar, bfsfc, hbl, stable, casea, diffus, kbl,
     O       dkm1, blmc, ghat, sigma,
     I       ikey, myThid )
cph(
#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE dkm1,blmc,ghat = comlev1_kpp, key=ikey, kind=isbyte
#endif
cph)

c-----------------------------------------------------------------------
c enhance diffusivity at interface kbl - 1
c-----------------------------------------------------------------------

      CALL enhance (
     I       dkm1, hbl, kbl, diffus, casea,
     U       ghat,
     O       blmc,
     I       myThid )

cph(
cph avoids recomp. of enhance
#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE blmc = comlev1_kpp, key=ikey, kind=isbyte
#endif
cph)

c-----------------------------------------------------------------------
c combine interior and boundary layer coefficients and nonlocal term
c !!!NOTE!!! In shallow (2-level) regions and for shallow mixed layers
c (< 1 level), diffusivity blmc can become negative.  The max-s below
c are a hack until this problem is properly diagnosed and fixed.
c-----------------------------------------------------------------------
#ifdef ALLOW_SHELFICE
# ifdef ALLOW_AUTODIFF_TAMC
CADJ INCOMPLETE blmc
# endif
      DO k = 1, Nr
       DO i = 1, imt
        IF (k .LT. kbl(i)) THEN
         DO md = 1, mdiff
C     when there is shelfice on top (msk(i)=0), reset the boundary layer
C     mixing coefficients blmc to pure Ri-number based mixing
          blmc(i,k,md) = MAX ( blmc(i,k,md)*msk(i), diffus(i,k,md) )
         ENDDO
        ENDIF
       ENDDO
      ENDDO
# ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE blmc = comlev1_kpp, key=ikey, kind=isbyte
# endif
#endif
      DO k = 1, Nr
       DO i = 1, imt
        IF (k .LT. kbl(i)) THEN
         diffus(i,k,1) = MAX ( blmc(i,k,1), viscArNr(1) )
         diffus(i,k,2) = MAX ( blmc(i,k,2), diffusKzS(i,Nr) )
         diffus(i,k,3) = MAX ( blmc(i,k,3), diffusKzT(i,Nr) )
        ELSE
         ghat(i,k) = 0. _d 0
        ENDIF
       ENDDO
      ENDDO

#endif /* ALLOW_KPP */

      RETURN
      END

c*************************************************************************

      subroutine bldepth (
     I       kmtj,
     I       dvsq, dbloc, Ritop, ustar, bo, bosol,
#ifdef ALLOW_SALT_PLUME
     I       boplume, SPDepth,
#ifdef SALT_PLUME_SPLIT_BASIN
     I       lon, lat,
#endif /* SALT_PLUME_SPLIT_BASIN */
#endif /* ALLOW_SALT_PLUME */
     I       coriol,
#ifdef SHORTWAVE_HEATING
     I       swatt,
#endif
     I       ikey,
     O       hbl, bfsfc, stable, casea, kbl, Rib, sigma,
     I       bi, bj, myTime, myIter, myThid )

c     the oceanic planetary boundary layer depth, hbl, is determined as
c     the shallowest depth where the bulk Richardson number is
c     equal to the critical value, Ricr.
c
c     bulk Richardson numbers are evaluated by computing velocity and
c     buoyancy differences between values at zgrid(kl) < 0 and surface
c     reference values.
c     in this configuration, the reference values are equal to the
c     values in the surface layer.
c     when using a very fine vertical grid, these values should be
c     computed as the vertical average of velocity and buoyancy from
c     the surface down to epsilon*zgrid(kl).
c
c     when the bulk Richardson number at k exceeds Ricr, hbl is
c     linearly interpolated between grid levels zgrid(k) and zgrid(k-1).
c
c     The water column and the surface forcing are diagnosed for
c     stable/ustable forcing conditions, and where hbl is relative
c     to grid points (caseA), so that conditional branches can be
c     avoided in later subroutines.
c
      IMPLICIT NONE

#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "KPP_PARAMS.h"
#ifdef ALLOW_AUTODIFF_TAMC
# include "tamc.h"
#endif

c input
c------
c   bi, bj :: Array indices on which to apply calculations
c   myTime :: Current time in simulation
c   myIter :: Current iteration number in simulation
c   myThid :: My Thread Id. number
c kmtj      : number of vertical layers
c dvsq      : (velocity shear re sfc)^2             ((m/s)^2)
c dbloc     : local delta buoyancy across interfaces  (m/s^2)
c Ritop     : numerator of bulk Richardson Number
c             =(z-zref)*dbsfc, where dbsfc=delta
c             buoyancy with respect to surface      ((m/s)^2)
c ustar     : surface friction velocity                 (m/s)
c bo        : surface turbulent buoyancy forcing    (m^2/s^3)
c bosol     : radiative buoyancy forcing            (m^2/s^3)
c boplume   : haline buoyancy forcing               (m^2/s^3)
c coriol    : Coriolis parameter                        (1/s)
      INTEGER bi, bj
      _RL     myTime
      INTEGER myIter
      INTEGER myThid
      INTEGER kmtj(imt)
      _RL dvsq    (imt,Nr)
      _RL dbloc   (imt,Nr)
      _RL Ritop   (imt,Nr)
      _RL ustar   (imt)
      _RL bo      (imt)
      _RL bosol   (imt)
      _RS coriol  (imt)
#ifdef SHORTWAVE_HEATING
      _RS swatt   (imt,Nr+1)
#endif
      INTEGER ikey
#ifdef ALLOW_SALT_PLUME
      _RL boplume (imt,Nrp1)
      _RL SPDepth (imt)
#ifdef SALT_PLUME_SPLIT_BASIN
      _RL lon (imt)
      _RL lat (imt)
#endif /* SALT_PLUME_SPLIT_BASIN */
#endif /* ALLOW_SALT_PLUME */

c  output
c--------
c hbl       : boundary layer depth                        (m)
c bfsfc     : Bo+radiation absorbed to d=hbf*hbl    (m^2/s^3)
c stable    : =1 in stable forcing; =0 unstable
c casea     : =1 in case A, =0 in case B
c kbl       : -1 of first grid level below hbl
c Rib       : Bulk Richardson number
c sigma     : normalized depth (d/hbl)
      _RL hbl    (imt)
      _RL bfsfc  (imt)
      _RL stable (imt)
      _RL casea  (imt)
      INTEGER kbl(imt)
      _RL Rib    (imt,Nr)
      _RL sigma  (imt)

#ifdef ALLOW_KPP

c  local
c-------
c wm, ws    : turbulent velocity scales         (m/s)
      _RL wm(imt), ws(imt)
      _RL bvsq, vtsq, hekman, hmonob, hlimit, tempVar1, tempVar2
      INTEGER i, kl

      _RL         p5    , eins
      PARAMETER ( p5=0.5, eins=1.0 )
      _RL         minusone
      PARAMETER ( minusone=-1.0 )
#if ( defined ALLOW_SALT_PLUME || defined SHORTWAVE_HEATING )
      _RL worka(imt)
#endif
#ifdef SHORTWAVE_HEATING
      INTEGER k
      _RL rFac
#endif
#ifdef SALT_PLUME_VOLUME
      INTEGER km, km1
      _RL temp
#endif
#ifdef ALLOW_AUTODIFF_TAMC
C     kkey :: tape key TAF-AD simulations (depends on vertical levels and tiles)
      INTEGER kkey
#endif

#ifdef ALLOW_DIAGNOSTICS
c     KPPBFSFC - Bo+radiation absorbed to d=hbf*hbl + plume (m^2/s^3)
      _RL KPPBFSFC(imt,Nr)
#endif /* ALLOW_DIAGNOSTICS */

c find bulk Richardson number at every grid level until > Ricr
c
c note: the reference depth is -epsilon/2.*zgrid(k), but the reference
c       u,v,t,s values are simply the surface layer values,
c       and not the averaged values from 0 to 2*ref.depth,
c       which is necessary for very fine grids(top layer < 2m thickness)
c note: max values when Ricr never satisfied are
c       kbl(i)=kmtj(i) and hbl(i)=-zgrid(kmtj(i))

c     initialize hbl and kbl to bottomed out values

      DO i = 1, imt
         Rib(i,1) = 0. _d 0
         kbl(i) = kmtj(i)
         IF (kmtj(i).LT.1) kbl(i) = 1
         kl     = kbl(i)
         hbl(i) = -zgrid(kl)
      ENDDO

#ifdef ALLOW_DIAGNOSTICS
      DO kl = 1, Nr
         DO i = 1, imt
            KPPBFSFC(i,kl) = 0. _d 0
         ENDDO
      ENDDO
#endif /* ALLOW_DIAGNOSTICS */

      DO kl = 2, Nr

#ifdef ALLOW_AUTODIFF_TAMC
         kkey = (ikey-1)*Nr + kl
#endif

c     compute bfsfc = sw fraction at hbf * zgrid

#ifdef SHORTWAVE_HEATING
        IF ( selectPenetratingSW .GE. 1 ) THEN
# ifdef ALLOW_AUTODIFF_TAMC
C     suppress a TAF warning and recomputations
CADJ incomplete worka
# endif
         IF ( KPPuseSWfrac3D ) THEN
C     worka is the value of swatt at cell centers kl
C     swatt(kl) is defined at the upper interface
          DO i = 1, imt
           worka(i) = 0.5*( swatt(i,kl) + swatt(i,kl+1) )
          ENDDO
CMLC     far more accurate
CML         IF ( kl .LT. Nr ) THEN
CML          DO i = 1, imt
CML           worka(i) = worka(i) - 0.125*( swatt(i,kl) + swatt(i,kl+1) )
CML     &          +              0.125*( swatt(i,kl-1) + swatt(i,kl+2) )
CML         ENDDO
CML        ENDIF
         ELSE
          DO i = 1, imt
           worka(i) = zgrid(kl)
          ENDDO
          CALL SWFRAC(
     I       imt, hbf,
     U       worka,
     I       myTime, myIter, myThid )
         ENDIF
# ifdef ALLOW_AUTODIFF_TAMC
CADJ store worka = comlev1_kpp_k, key = kkey, kind=isbyte
# endif

c     compute bfsfc= Bo + radiative contribution down to hbf * hbl
         DO i = 1, imt
            bfsfc(i) = bo(i) + bosol(i)*(1. - worka(i))
         ENDDO
        ELSE
#endif /* SHORTWAVE_HEATING */
         DO i = 1, imt
            bfsfc(i) = bo(i)
         ENDDO
#ifdef SHORTWAVE_HEATING
        ENDIF
#endif /* SHORTWAVE_HEATING */

#ifdef ALLOW_SALT_PLUME
c     compute bfsfc = plume fraction at hbf * zgrid
         IF ( useSALT_PLUME ) THEN
# ifndef SALT_PLUME_VOLUME
           DO i = 1, imt
              worka(i) = zgrid(kl)
           ENDDO
Ccatn: in original way: accumulate all fractions of boplume above zgrid(kl)
           CALL SALT_PLUME_FRAC(
     I         imt, hbf,SPDepth,
#  ifdef SALT_PLUME_SPLIT_BASIN
     I         lon,lat,
#  endif /* SALT_PLUME_SPLIT_BASIN */
     U         worka,
     I         myTime, myIter, myThid)
#  ifdef ALLOW_AUTODIFF_TAMC
CADJ store worka = comlev1_kpp_k, key = kkey, kind=isbyte
#  endif
           DO i = 1, imt
              bfsfc(i) = bfsfc(i) + boplume(i,1)*(worka(i))
C            km=MAX(1,kbl(i)-1)
C            temp = (plumefrac(i,km)+plumefrac(i,kbl(i)))/2.0
C            bfsfc(i) = bfsfc(i) + boplume(i,1)*temp
           ENDDO
# else /* def SALT_PLUME_VOLUME */
catn: in vol way: need to integrate down to hbl, so first locate
c     k level associated with this hbl, then sum up all SPforc[T,S]
           DO i = 1, imt
            km =MAX(1,kbl(i)-1)
            km1=MAX(1,kbl(i))
            temp = (boplume(i,km)+boplume(i,km1))*p5
            bfsfc(i) = bfsfc(i) + temp
           ENDDO
# endif /* ndef SALT_PLUME_VOLUME */
         ENDIF
#endif /* ALLOW_SALT_PLUME */
#ifdef ALLOW_AUTODIFF_TAMC
CADJ store bfsfc = comlev1_kpp_k, key = kkey, kind=isbyte
#endif

#ifdef ALLOW_DIAGNOSTICS
         DO i = 1, imt
            KPPBFSFC(i,kl) = bfsfc(i)
         ENDDO
#endif /* ALLOW_DIAGNOSTICS */

         DO i = 1, imt
            stable(i) = p5 + sign(p5,bfsfc(i))
            sigma(i) = stable(i) + (1. - stable(i)) * epsilon
c     use caseA as temporary array
            casea(i) = -zgrid(kl)
         ENDDO

c-----------------------------------------------------------------------
c     compute velocity scales at sigma, for hbl= caseA = -zgrid(kl)
c-----------------------------------------------------------------------

         CALL wscale (
     I        sigma, casea, ustar, bfsfc,
     O        wm, ws, myThid )
#ifdef ALLOW_AUTODIFF_TAMC
CADJ store ws = comlev1_kpp_k, key = kkey, kind=isbyte
#endif

         DO i = 1, imt

c-----------------------------------------------------------------------
c     compute the turbulent shear contribution to Rib
c-----------------------------------------------------------------------

            bvsq = p5 *
     1           ( dbloc(i,kl-1) / (zgrid(kl-1)-zgrid(kl  ))+
     2             dbloc(i,kl  ) / (zgrid(kl  )-zgrid(kl+1)))
CMLC     Van Roekel et al 2018 suggest this, but our solution is
CMLC     probably OK, too:
CML            bvsq = MAX
CML     1           ( dbloc(i,kl-1) / (zgrid(kl-1)-zgrid(kl  )),
CML     2             dbloc(i,kl  ) / (zgrid(kl  )-zgrid(kl+1)))

            IF (bvsq .EQ. 0. _d 0) THEN
              vtsq = 0. _d 0
            ELSE
              vtsq = -zgrid(kl) * ws(i) * SQRT(ABS(bvsq)) * Vtc
            ENDIF

c     compute bulk Richardson number at new level
c     note: Ritop needs to be zero on land and ocean bottom
c     points so that the following if statement gets triggered
c     correctly; otherwise, hbl might get set to (big) negative
c     values, that might exceed the limit for the "exp" function
c     in "SWFRAC"

c
c     rg: assignment to double precision variable to avoid overflow
c     ph: test for zero nominator
c

            tempVar1  = dvsq(i,kl) + vtsq
#ifdef KPP_SMOOTH_REGULARISATION
            tempVar2 = tempVar1 + phepsi
#else
            tempVar2 = MAX(tempVar1, phepsi)
#endif /* KPP_SMOOTH_REGULARISATION */
            Rib(i,kl) = Ritop(i,kl) / tempVar2

         ENDDO
      ENDDO

#ifdef ALLOW_DIAGNOSTICS
      IF ( useDiagnostics ) THEN
         CALL DIAGNOSTICS_FILL(KPPBFSFC,'KPPbfsfc',0,Nr,2,bi,bj,myThid)
         CALL DIAGNOSTICS_FILL(Rib     ,'KPPRi   ',0,Nr,2,bi,bj,myThid)
      ENDIF
#endif /* ALLOW_DIAGNOSTICS */

cph(
cph  without this store, there is a recomputation error for
cph  rib in adbldepth (probably partial recomputation problem)
#ifdef ALLOW_AUTODIFF_TAMC
CADJ store Rib = comlev1_kpp, key=ikey, kind=isbyte
#endif
cph)

      DO kl = 2, Nr
         DO i = 1, imt
            IF (kbl(i).EQ.kmtj(i) .AND. Rib(i,kl).GT.Ricr) kbl(i) = kl
         ENDDO
      ENDDO

#ifdef ALLOW_AUTODIFF_TAMC
CADJ store kbl = comlev1_kpp, key=ikey, kind=isbyte
#endif

      DO i = 1, imt
         kl = kbl(i)
c     linearly interpolate to find hbl where Rib = Ricr
         IF (kl.GT.1 .AND. kl.LT.kmtj(i)) THEN
            tempVar1 = (Rib(i,kl)-Rib(i,kl-1))
            hbl(i) = -zgrid(kl-1) + (zgrid(kl-1)-zgrid(kl)) *
     1           (Ricr - Rib(i,kl-1)) / tempVar1
C     this is the MOM5 formulation, (nearly) identical results
CML            hbl(i) = ((Rib(i,kl-1)-Ricr)*zgrid(kl) -
CML     1           (Rib(i,kl)-Ricr)*zgrid(kl-1))/tempVar1
         ENDIF
      ENDDO

#ifdef ALLOW_AUTODIFF_TAMC
CADJ store hbl = comlev1_kpp, key=ikey, kind=isbyte
#endif

c-----------------------------------------------------------------------
c     find stability and buoyancy forcing for boundary layer
c-----------------------------------------------------------------------

#ifdef SHORTWAVE_HEATING
      IF ( selectPenetratingSW .GE. 1 ) THEN
# ifdef ALLOW_AUTODIFF_TAMC
C     suppress a TAF warning and recomputations
CADJ incomplete worka
# endif
       IF ( KPPuseSWfrac3D ) THEN
        DO i = 1, imt
         k = kbl(i)
C     since we do not have rF available we try to reconstruct as
C     zgrid+0.5*hwide = rC+0.5*drF; this is only accurate if rC is
C     really at the cell centers, which is not always the case
         rFac = MAX( (hbl(i)+zgrid(k)+p5*hwide(k))/hwide(k), zeroRL )
         worka(i) = swatt(i,k) + rFac*(swatt(i,k+1)-swatt(i,k))
        ENDDO
       ELSE
        DO i = 1, imt
         worka(i) = hbl(i)
        ENDDO
        CALL SWFRAC(
     I     imt, minusone,
     U     worka,
     I     myTime, myIter, myThid )
       ENDIF
# ifdef ALLOW_AUTODIFF_TAMC
CADJ store worka = comlev1_kpp, key=ikey, kind=isbyte
# endif
       DO i = 1, imt
         bfsfc(i) = bo(i) + bosol(i) * (1. - worka(i))
       ENDDO
      ELSE
#endif /* SHORTWAVE_HEATING */
       DO i = 1, imt
         bfsfc(i) = bo(i)
       ENDDO
#ifdef SHORTWAVE_HEATING
      ENDIF
#endif /* SHORTWAVE_HEATING */

#ifdef ALLOW_SALT_PLUME
# ifdef ALLOW_AUTODIFF_TAMC
C     suppress a TAF warning and recomputations
CADJ incomplete worka
# endif
      IF ( useSALT_PLUME ) THEN
# ifndef SALT_PLUME_VOLUME
        DO i = 1, imt
           worka(i) = hbl(i)
        ENDDO
        CALL SALT_PLUME_FRAC(
     I         imt,minusone,SPDepth,
#  ifdef SALT_PLUME_SPLIT_BASIN
     I         lon,lat,
#  endif /* SALT_PLUME_SPLIT_BASIN */
     U         worka,
     I         myTime, myIter, myThid )
#  ifdef ALLOW_AUTODIFF_TAMC
CADJ store worka = comlev1_kpp, key = ikey, kind=isbyte
#  endif
        DO i = 1, imt
           bfsfc(i) = bfsfc(i) + boplume(i,1) * (worka(i))
C            km=MAX(1,kbl(i)-1)
C            temp = (plumefrac(i,km)+plumefrac(i,kbl(i)))/2.0
C            bfsfc(i) = bfsfc(i) + boplume(i,1)*temp
        ENDDO
# else /* def SALT_PLUME_VOLUME */
        DO i = 1, imt
            km =MAX(1,kbl(i)-1)
            km1=MAX(1,kbl(i))
            temp = (boplume(i,km)+boplume(i,km1))/2.0
            bfsfc(i) = bfsfc(i) + temp
        ENDDO
# endif /* ndef SALT_PLUME_VOLUME */
      ENDIF
#endif /* ALLOW_SALT_PLUME */
#ifdef ALLOW_AUTODIFF_TAMC
CADJ store bfsfc = comlev1_kpp, key=ikey, kind=isbyte
#endif

c--   ensure bfsfc is never 0
      DO i = 1, imt
         stable(i) = p5 + sign( p5, bfsfc(i) )
         bfsfc(i) = sign(eins,bfsfc(i))*MAX(phepsi,ABS(bfsfc(i)))
      ENDDO

cph(
cph  added stable to store list to avoid extensive recomp.
#ifdef ALLOW_AUTODIFF_TAMC
CADJ store bfsfc, stable = comlev1_kpp, key=ikey, kind=isbyte
#endif
cph)

c-----------------------------------------------------------------------
c check hbl limits for hekman or hmonob
c     ph: test for zero nominator
c-----------------------------------------------------------------------

      IF ( LimitHblStable ) THEN
       DO i = 1, imt
        IF (bfsfc(i) .GT. 0.0) THEN
         hekman = cekman * ustar(i) / MAX(ABS(Coriol(i)),phepsi)
         hmonob = cmonob * ustar(i)*ustar(i)*ustar(i)
     &        / vonk / bfsfc(i)
         hlimit = stable(i) * MIN(hekman,hmonob)
     &        + (stable(i)-1.) * zgrid(Nr)
         hbl(i) = MIN(hbl(i),hlimit)
        ENDIF
       ENDDO
      ENDIF

#ifdef ALLOW_AUTODIFF_TAMC
CADJ store hbl = comlev1_kpp, key=ikey, kind=isbyte
#endif

      DO i = 1, imt
         hbl(i) = MAX(hbl(i),minKPPhbl)
         kbl(i) = kmtj(i)
      ENDDO

#ifdef ALLOW_AUTODIFF_TAMC
CADJ store hbl = comlev1_kpp, key=ikey, kind=isbyte
#endif

c-----------------------------------------------------------------------
c      find new kbl
c-----------------------------------------------------------------------

      DO kl = 2, Nr
         DO i = 1, imt
            IF ( kbl(i).EQ.kmtj(i) .AND. (-zgrid(kl)).GT.hbl(i) ) THEN
               kbl(i) = kl
            ENDIF
         ENDDO
      ENDDO

c-----------------------------------------------------------------------
c      find stability and buoyancy forcing for final hbl values
c-----------------------------------------------------------------------

#ifdef SHORTWAVE_HEATING
      IF ( selectPenetratingSW .GE. 1 ) THEN
# ifdef ALLOW_AUTODIFF_TAMC
C     suppress a TAF warning and recomputations
CADJ incomplete worka
# endif
       IF ( KPPuseSWfrac3D ) THEN
        DO i = 1, imt
         k = kbl(i)
         rFac = MAX( (hbl(i)+zgrid(k)+p5*hwide(k))/hwide(k), zeroRL )
         worka(i) = swatt(i,k) + rFac*(swatt(i,k+1)-swatt(i,k))
        ENDDO
       ELSE
        DO i = 1, imt
         worka(i) = hbl(i)
        ENDDO
        CALL SWFRAC(
     I     imt, minusone,
     U     worka,
     I     myTime, myIter, myThid )
       ENDIF
# ifdef ALLOW_AUTODIFF_TAMC
CADJ store worka = comlev1_kpp, key=ikey, kind=isbyte
# endif

       DO i = 1, imt
         bfsfc(i) = bo(i) + bosol(i) * (1. - worka(i))
       ENDDO
      ELSE
#endif /* SHORTWAVE_HEATING */
       DO i = 1, imt
         bfsfc(i) = bo(i)
       ENDDO
#ifdef SHORTWAVE_HEATING
      ENDIF
#endif /* SHORTWAVE_HEATING */

#ifdef ALLOW_SALT_PLUME
# ifdef ALLOW_AUTODIFF_TAMC
C     suppress a TAF warning and recomputations
CADJ incomplete worka
# endif
      IF ( useSALT_PLUME ) THEN
# ifndef SALT_PLUME_VOLUME
        DO i = 1, imt
           worka(i) = hbl(i)
        ENDDO
        CALL SALT_PLUME_FRAC(
     I         imt,minusone,SPDepth,
#  ifdef SALT_PLUME_SPLIT_BASIN
     I         lon,lat,
#  endif /* SALT_PLUME_SPLIT_BASIN */
     U         worka,
     I         myTime, myIter, myThid )
#  ifdef ALLOW_AUTODIFF_TAMC
CADJ store worka = comlev1_kpp, key = ikey, kind=isbyte
#  endif
        DO i = 1, imt
           bfsfc(i) = bfsfc(i) + boplume(i,1) * (worka(i))
C            km=MAX(1,kbl(i)-1)
C            temp = (plumefrac(i,km)+plumefrac(i,kbl(i)))/2.0
C            bfsfc(i) = bfsfc(i) + boplume(i,1)*temp
        ENDDO
# else /* def SALT_PLUME_VOLUME */
        DO i = 1, imt
            km =MAX(1,kbl(i)-1)
            km1=MAX(1,kbl(i)-0)
            temp = (boplume(i,km)+boplume(i,km1))/2.0
            bfsfc(i) = bfsfc(i) + temp
        ENDDO
# endif /* ndef SALT_PLUME_VOLUME */
      ENDIF
#endif /* ALLOW_SALT_PLUME */
#ifdef ALLOW_AUTODIFF_TAMC
CADJ store bfsfc = comlev1_kpp, key=ikey, kind=isbyte
#endif

c--   ensures bfsfc is never 0
      DO i = 1, imt
         stable(i) = p5 + sign( p5, bfsfc(i) )
         bfsfc(i) = sign(eins,bfsfc(i))*MAX(phepsi,ABS(bfsfc(i)))
      ENDDO

c-----------------------------------------------------------------------
c determine caseA and caseB
c-----------------------------------------------------------------------

      DO i = 1, imt
         kl = kbl(i)
         casea(i) = p5 +
     1        sign(p5, -zgrid(kl) - p5*hwide(kl) - hbl(i))
      ENDDO

#endif /* ALLOW_KPP */

      RETURN
      END

c*************************************************************************

      subroutine wscale (
     I     sigma, hbl, ustar, bfsfc,
     O     wm, ws,
     I     myThid )

c     compute turbulent velocity scales.
c     use a 2D-lookup table for wm and ws as functions of ustar and
c     zetahat (=vonk*sigma*hbl*bfsfc).
c
c     note: the lookup table is only used for unstable conditions
c     (zehat.LE.0), in the stable domain wm (=ws) gets computed
c     directly.
c
      IMPLICIT NONE

#include "SIZE.h"
#include "KPP_PARAMS.h"

c input
c------
c sigma   : normalized depth (d/hbl)
c hbl     : boundary layer depth (m)
c ustar   : surface friction velocity         (m/s)
c bfsfc   : total surface buoyancy flux       (m^2/s^3)
c myThid  : thread number for this instance of the routine
      INTEGER myThid
      _RL sigma(imt)
      _RL hbl  (imt)
      _RL ustar(imt)
      _RL bfsfc(imt)

c  output
c--------
c wm, ws  : turbulent velocity scales at sigma
      _RL wm(imt), ws(imt)

#ifdef ALLOW_KPP

c local
c------
c zehat   : = zeta *  ustar**3
      _RL zehat

      INTEGER iz, izp1, ju, i, jup1
      _RL udiff, zdiff, zfrac, ufrac, fzfrac, wam
      _RL wbm, was, wbs, u3, tempVar

c-----------------------------------------------------------------------
c use lookup table for zehat < zmax only; otherwise use
c stable formulae
c-----------------------------------------------------------------------

      DO i = 1, imt
         zehat = vonk*sigma(i)*hbl(i)*bfsfc(i)

         IF (zehat .LE. zmax) THEN

            zdiff = zehat - zmin
C     For extremely negative buoyancy forcing bfsfc, zehat and hence
C     zdiff can become very negative (default value of zmin = 4.e-7) and
C     the extrapolation beyond the limit zmin of the lookup table can
C     give very bad values and may make the model crash. Here is a
C     simple fix (thanks to Dimitry Sidorenko) that effectively replaces
C     linear extrapolation with nearest neighbor extrapolation so that
C     only the lower limit values of the lookup tables wmt/wst are used.
C     Alternatively, one can get rid of the lookup table altogether
C     and compute the coefficients online (done in NEMO, for example).
C           zdiff = MAX( 0. _d 0, zehat - zmin )
            iz    = INT( zdiff / deltaz )
            iz    = MIN( iz, nni )
            iz    = MAX( iz, 0 )
            izp1  = iz + 1

            udiff = ustar(i) - umin
            ju    = INT( udiff / deltau )
            ju    = MIN( ju, nnj )
            ju    = MAX( ju, 0 )
            jup1  = ju + 1

            zfrac = zdiff / deltaz - float(iz)
            ufrac = udiff / deltau - float(ju)

            fzfrac= 1. - zfrac
            wam   = fzfrac     * wmt(iz,jup1) + zfrac * wmt(izp1,jup1)
            wbm   = fzfrac     * wmt(iz,ju  ) + zfrac * wmt(izp1,ju  )
            wm(i) = (1.-ufrac) * wbm          + ufrac * wam

            was   = fzfrac     * wst(iz,jup1) + zfrac * wst(izp1,jup1)
            wbs   = fzfrac     * wst(iz,ju  ) + zfrac * wst(izp1,ju  )
            ws(i) = (1.-ufrac) * wbs          + ufrac * was

         ELSE

            u3 = ustar(i) * ustar(i) * ustar(i)
            tempVar = u3 + conc1 * zehat
            wm(i) = vonk * ustar(i) * u3 / tempVar
            ws(i) = wm(i)

         ENDIF

      ENDDO

#endif /* ALLOW_KPP */

      RETURN
      END

c*************************************************************************

      subroutine Ri_iwmix (
     I       kmtj, shsq, dbloc, dblocSm,
     I       diffusKzS, diffusKzT,
     I       ikey,
     O       diffus,
     I       myThid )

c     compute interior viscosity diffusivity coefficients due
c     to shear instability (dependent on a local Richardson number),
c     to background internal wave activity, and
c     to static instability (local Richardson number < 0).

      IMPLICIT NONE

#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "KPP_PARAMS.h"
#ifdef ALLOW_AUTODIFF
# include "AUTODIFF_PARAMS.h"
#endif
#ifdef ALLOW_AUTODIFF_TAMC
# include "tamc.h"
#endif

c  input
c     kmtj   (imt)         number of vertical layers on this row
c     shsq   (imt,Nr)      (local velocity shear)^2               ((m/s)^2)
c     dbloc  (imt,Nr)      local delta buoyancy                     (m/s^2)
c     dblocSm(imt,Nr)      horizontally smoothed dbloc              (m/s^2)
c     diffusKzS(imt,Nr)- background vertical diffusivity for scalars    (m^2/s)
c     diffusKzT(imt,Nr)- background vertical diffusivity for theta      (m^2/s)
c     myThid :: My Thread Id. number
      INTEGER kmtj (imt)
      _RL shsq     (imt,Nr)
      _RL dbloc    (imt,Nr)
      _RL dblocSm  (imt,Nr)
      _RL diffusKzS(imt,Nr)
      _RL diffusKzT(imt,Nr)
      INTEGER ikey
      INTEGER myThid

c output
c     diffus(imt,0:Nrp1,1)  vertical viscosivity coefficient        (m^2/s)
c     diffus(imt,0:Nrp1,2)  vertical scalar diffusivity             (m^2/s)
c     diffus(imt,0:Nrp1,3)  vertical temperature diffusivity        (m^2/s)
      _RL diffus(imt,0:Nrp1,3)

#ifdef ALLOW_KPP

c local variables
c     Rig                   local Richardson number
c     fRi, fcon             function of Rig
      _RL Rig
      _RL fRi, fcon
      _RL ratio
      INTEGER i, ki, kp1
      _RL c1, c0

#ifdef ALLOW_KPP_VERTICALLY_SMOOTH
      INTEGER mr
CADJ INIT kpp_ri_tape_mr = common, 1
#endif

c constants
      c1 = 1. _d 0
      c0 = 0. _d 0

c-----------------------------------------------------------------------
c     compute interior gradient Ri at all interfaces ki=1,Nr, (not surface)
c     use diffus(*,*,1) as temporary storage of Ri to be smoothed
c     use diffus(*,*,2) as temporary storage for Brunt-Vaisala squared
c     set values at bottom and below to nearest value above bottom
#ifdef ALLOW_AUTODIFF
C     break data flow dependence on diffus
      diffus(1,1,1) = 0.0
      DO ki = 1, Nr
         DO i = 1, imt
            diffus(i,ki,1) = 0.
            diffus(i,ki,2) = 0.
            diffus(i,ki,3) = 0.
         ENDDO
      ENDDO
#endif

      DO ki = 1, Nr
         DO i = 1, imt
            IF     (kmtj(i) .LE. 1      ) THEN
               diffus(i,ki,1) = 0.
               diffus(i,ki,2) = 0.
            ELSEIF (ki      .GE. kmtj(i)) THEN
               diffus(i,ki,1) = diffus(i,ki-1,1)
               diffus(i,ki,2) = diffus(i,ki-1,2)
            ELSE
               diffus(i,ki,1) = dblocSm(i,ki) * (zgrid(ki)-zgrid(ki+1))
#ifdef KPP_SMOOTH_REGULARISATION
     &            / ( Shsq(i,ki) + phepsi**2 )
#else
     &            / MAX( Shsq(i,ki), phepsi )
#endif
               diffus(i,ki,2) = dbloc(i,ki)   / (zgrid(ki)-zgrid(ki+1))
            ENDIF
         ENDDO
      ENDDO
#ifdef ALLOW_AUTODIFF_TAMC
CADJ store diffus = comlev1_kpp, key=ikey, kind=isbyte
#endif

c-----------------------------------------------------------------------
c     vertically smooth Ri
#ifdef ALLOW_KPP_VERTICALLY_SMOOTH
      DO mr = 1, num_v_smooth_Ri

#ifdef ALLOW_AUTODIFF_TAMC
CADJ store diffus(:,:,1) = kpp_ri_tape_mr, key=mr
CADJ &  , shape=(/ (sNx+2*OLx)*(sNy+2*OLy),Nr+2 /)
CMLCADJ store diffus(:,:,2) = kpp_ri_tape_mr, key=mr
CMLCADJ &  , shape=(/ (sNx+2*OLx)*(sNy+2*OLy),Nr+2 /)
#endif

         CALL z121 (
     U     diffus(1,0,1),
     I     myThid )
C     it may also make sense to smooth buoyancy vertically
CML         CALL z121 (
CML     U     diffus(1,0,2),
CML     I     myThid )
      ENDDO
#endif

c-----------------------------------------------------------------------
c                           after smoothing loop

      DO ki = 1, Nr
         DO i = 1, imt

c  evaluate f of Brunt-Vaisala squared for convection, store in fcon

            Rig   = MAX ( diffus(i,ki,2) , BVSQcon )
            ratio = MIN ( (BVSQcon - Rig) / BVSQcon, c1 )
            fcon  = c1 - ratio * ratio
            fcon  = fcon * fcon * fcon

c  evaluate f of smooth Ri for shear instability, store in fRi

            Rig   = MAX ( diffus(i,ki,1), c0 )
            ratio = MIN ( Rig / Riinfty , c1 )
            fRi   = c1 - ratio * ratio
            fRi   = fRi * fRi * fRi
#ifdef KPP_SCALE_SHEARMIXING
C     reduce shear mixing when there is no shear (Polzin, 1996, JPO, 1409-1425)
C     importend from MOM5 code
            fRi   = fRi * shsq(i,ki)*shsq(i,ki)
     &           /(shsq(i,ki)*shsq(i,ki) + 1. _d -16)
#endif
c ----------------------------------------------------------------------
c            evaluate diffusivities and viscosity
c    mixing due to internal waves, and shear and static instability

            kp1 = MIN(ki+1,Nr)
#ifdef EXCLUDE_KPP_SHEAR_MIX
            diffus(i,ki,1) = viscArNr(1)
            diffus(i,ki,2) = diffusKzS(i,kp1)
            diffus(i,ki,3) = diffusKzT(i,kp1)
#else /* EXCLUDE_KPP_SHEAR_MIX */
# ifdef ALLOW_AUTODIFF
            IF ( inAdMode .AND. .NOT. inAdExact ) THEN
              diffus(i,ki,1) = viscArNr(1)
              diffus(i,ki,2) = diffusKzS(i,kp1)
              diffus(i,ki,3) = diffusKzT(i,kp1)
            ELSE
# else /* ALLOW_AUTODIFF */
            IF ( .TRUE. ) THEN
# endif /* ALLOW_AUTODIFF */
              diffus(i,ki,1) = viscArNr(1) + fcon*difmcon + fRi*difm0
              diffus(i,ki,2) = diffusKzS(i,kp1)+fcon*difscon+fRi*difs0
              diffus(i,ki,3) = diffusKzT(i,kp1)+fcon*diftcon+fRi*dift0
            ENDIF
#endif /* EXCLUDE_KPP_SHEAR_MIX */
         ENDDO
      ENDDO

c ------------------------------------------------------------------------
c         set surface values to 0.0

      DO i = 1, imt
         diffus(i,0,1) = c0
         diffus(i,0,2) = c0
         diffus(i,0,3) = c0
      ENDDO

#endif /* ALLOW_KPP */

      RETURN
      END

c*************************************************************************

      subroutine z121 (
     U     v,
     I     myThid )

c     Apply 121 smoothing in k to 2-d array V(i,k=1,Nr)
c     top (0) value is used as a dummy
c     bottom (Nrp1) value is set to input value from above.

c     Note that it is important to exclude from the smoothing any points
c     that are outside the range of the K(Ri) scheme, ie.  >0.8, or <0.0.
c     Otherwise, there is interference with other physics, especially
c     penetrative convection.

      IMPLICIT NONE
#include "SIZE.h"
#include "KPP_PARAMS.h"

c input/output
c-------------
c v     : 2-D array to be smoothed in Nrp1 direction
c myThid: thread number for this instance of the routine
      INTEGER myThid
      _RL v(imt,0:Nrp1)

#ifdef ALLOW_KPP

c local
      _RL zwork, zflag
      _RL KRi_range(1:Nrp1)
      INTEGER i, k, km1, kp1

      _RL         p0      , p25       , p5      , p2
      PARAMETER ( p0 = 0.0, p25 = 0.25, p5 = 0.5, p2 = 2.0 )

      KRi_range(Nrp1) = p0

#ifdef ALLOW_AUTODIFF_TAMC
C--   dummy assignment to end declaration part for TAF
      i = 0
C--   HPF directive to help TAF
CHPF$ INDEPENDENT
#endif /* ALLOW_AUTODIFF_TAMC */

      DO i = 1, imt

         k = 1
         v(i,Nrp1) = v(i,Nr)

         DO k = 1, Nr
            KRi_range(k) = p5 + SIGN(p5,v(i,k))
            KRi_range(k) = KRi_range(k) *
     &                     ( p5 + SIGN(p5,(Riinfty-v(i,k))) )
         ENDDO

         zwork  = KRi_range(1) * v(i,1)
         v(i,1) = p2 * v(i,1) +
     &            KRi_range(1) * KRi_range(2) * v(i,2)
         zflag  = p2 + KRi_range(1) * KRi_range(2)
         v(i,1) = v(i,1) / zflag

         DO k = 2, Nr
            km1 = k - 1
            kp1 = k + 1
            zflag = v(i,k)
            v(i,k) = p2 * v(i,k) +
     &           KRi_range(k) * KRi_range(kp1) * v(i,kp1) +
     &           KRi_range(k) * zwork
            zwork = KRi_range(k) * zflag
            zflag = p2 + KRi_range(k)*(KRi_range(kp1)+KRi_range(km1))
            v(i,k) = v(i,k) / zflag
         ENDDO

      ENDDO

#endif /* ALLOW_KPP */

      RETURN
      END

c*************************************************************************

      subroutine smooth_horiz (
     I     k, bi, bj,
     U     fld,
     I     myThid )

c     Apply horizontal smoothing to global _RL 2-D array

      IMPLICIT NONE
#include "SIZE.h"
#include "GRID.h"
#include "KPP_PARAMS.h"

c     input
c     bi, bj : array indices
c     k      : vertical index used for masking
c     myThid : thread number for this instance of the routine
      INTEGER myThid
      INTEGER k, bi, bj

c     input/output
c     fld    : 2-D array to be smoothed
      _RL fld( 1-OLx:sNx+OLx, 1-OLy:sNy+OLy )

#ifdef ALLOW_KPP

c     local
      INTEGER i, j, im1, ip1, jm1, jp1
      _RL tempVar
      _RL fld_tmp( 1-OLx:sNx+OLx, 1-OLy:sNy+OLy )

      INTEGER   iMin      , iMax          , jMin      , jMax
      PARAMETER(iMin=2-OLx, iMax=sNx+OLx-1, jMin=2-OLy, jMax=sNy+OLy-1)

      _RL        p0    , p5    , p25     , p125      , p0625
      PARAMETER( p0=0.0, p5=0.5, p25=0.25, p125=0.125, p0625=0.0625 )

      DO j = jMin, jMax
         jm1 = j-1
         jp1 = j+1
         DO i = iMin, iMax
            im1 = i-1
            ip1 = i+1
            tempVar =
     &           p25   *   maskC(i  ,j  ,k,bi,bj)   +
     &           p125  * ( maskC(im1,j  ,k,bi,bj)   +
     &                     maskC(ip1,j  ,k,bi,bj)   +
     &                     maskC(i  ,jm1,k,bi,bj)   +
     &                     maskC(i  ,jp1,k,bi,bj) ) +
     &           p0625 * ( maskC(im1,jm1,k,bi,bj)   +
     &                     maskC(im1,jp1,k,bi,bj)   +
     &                     maskC(ip1,jm1,k,bi,bj)   +
     &                     maskC(ip1,jp1,k,bi,bj) )
            IF ( tempVar .GE. p25 ) THEN
               fld_tmp(i,j) = (
     &              p25  * fld(i  ,j  )*maskC(i  ,j  ,k,bi,bj) +
     &              p125 *(fld(im1,j  )*maskC(im1,j  ,k,bi,bj) +
     &                     fld(ip1,j  )*maskC(ip1,j  ,k,bi,bj) +
     &                     fld(i  ,jm1)*maskC(i  ,jm1,k,bi,bj) +
     &                     fld(i  ,jp1)*maskC(i  ,jp1,k,bi,bj))+
     &              p0625*(fld(im1,jm1)*maskC(im1,jm1,k,bi,bj) +
     &                     fld(im1,jp1)*maskC(im1,jp1,k,bi,bj) +
     &                     fld(ip1,jm1)*maskC(ip1,jm1,k,bi,bj) +
     &                     fld(ip1,jp1)*maskC(ip1,jp1,k,bi,bj)))
     &              / tempVar
            ELSE
               fld_tmp(i,j) = fld(i,j)
            ENDIF
         ENDDO
      ENDDO

c     transfer smoothed field to output array
      DO j = jMin, jMax
         DO i = iMin, iMax
            fld(i,j) = fld_tmp(i,j)
         ENDDO
      ENDDO

#endif /* ALLOW_KPP */

      RETURN
      END

c*************************************************************************

      subroutine blmix (
     I       ustar, bfsfc, hbl, stable, casea, diffus, kbl,
     O       dkm1, blmc, ghat, sigma,
     I       ikey, myThid )

c     mixing coefficients within boundary layer depend on surface
c     forcing and the magnitude and gradient of interior mixing below
c     the boundary layer ("matching").
c
c     caution: if mixing bottoms out at hbl = -zgrid(Nr) then
c     fictitious layer at Nrp1 is needed with small but finite width
c     hwide(Nrp1) (eg. epsln = 1.e-20).
c
      IMPLICIT NONE

#include "SIZE.h"
#include "KPP_PARAMS.h"
#ifdef ALLOW_AUTODIFF_TAMC
# include "tamc.h"
#endif

c input
c     ustar (imt)                 surface friction velocity             (m/s)
c     bfsfc (imt)                 surface buoyancy forcing          (m^2/s^3)
c     hbl   (imt)                 boundary layer depth                    (m)
c     stable(imt)                 = 1 in stable forcing
c     casea (imt)                 = 1 in case A
c     diffus(imt,0:Nrp1,mdiff)    vertical diffusivities              (m^2/s)
c     kbl   (imt)                 -1 of first grid level below hbl
c     myThid               thread number for this instance of the routine
      INTEGER myThid
      _RL ustar (imt)
      _RL bfsfc (imt)
      _RL hbl   (imt)
      _RL stable(imt)
      _RL casea (imt)
      _RL diffus(imt,0:Nrp1,mdiff)
      INTEGER kbl(imt)

c output
c     dkm1 (imt,mdiff)            boundary layer difs at kbl-1 level
c     blmc (imt,Nr,mdiff)         boundary layer mixing coefficients  (m^2/s)
c     ghat (imt,Nr)               nonlocal scalar transport
c     sigma(imt)                  normalized depth (d / hbl)
      _RL dkm1 (imt,mdiff)
      _RL blmc (imt,Nr,mdiff)
      _RL ghat (imt,Nr)
      _RL sigma(imt)
      INTEGER ikey

#ifdef ALLOW_KPP

c  local
c     gat1*(imt)                 shape function at sigma = 1
c     dat1*(imt)                 derivative of shape function at sigma = 1
c     ws(imt), wm(imt)           turbulent velocity scales             (m/s)
      _RL gat1m(imt), gat1s(imt), gat1t(imt)
      _RL dat1m(imt), dat1s(imt), dat1t(imt)
      _RL ws(imt), wm(imt)
      INTEGER i, kn, ki, kl
#ifndef KPP_DO_NOT_MATCH_DIFFUSIVITIES
# ifndef KPP_DO_NOT_MATCH_DERIVATIVES
      _RL R, dvdzup, dvdzdn
# endif
      _RL delhat
#endif
      _RL viscp, difsp, diftp, visch, difsh, difth
      _RL f1, sig, a1, a2, a3
      _RL Gm, Gs, Gt
      _RL tempVar

      _RL    p0    , eins
      PARAMETER (p0=0.0, eins=1.0)
#ifdef ALLOW_AUTODIFF_TAMC
C     kkey :: tape key TAF-AD simulations (depends on vertical levels and tiles)
      INTEGER kkey
#endif

c-----------------------------------------------------------------------
c compute velocity scales at hbl
c-----------------------------------------------------------------------

      DO i = 1, imt
         sigma(i) = stable(i) * 1.0 + (1. - stable(i)) * epsilon
      ENDDO

#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE sigma = comlev1_kpp, key=ikey, kind=isbyte
#endif
      CALL wscale (
     I        sigma, hbl, ustar, bfsfc,
     O        wm, ws, myThid )
#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE wm = comlev1_kpp, key=ikey, kind=isbyte
CADJ STORE ws = comlev1_kpp, key=ikey, kind=isbyte
#endif

      DO i = 1, imt
         wm(i) = sign(eins,wm(i))*MAX(phepsi,ABS(wm(i)))
         ws(i) = sign(eins,ws(i))*MAX(phepsi,ABS(ws(i)))
      ENDDO
#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE wm = comlev1_kpp, key=ikey, kind=isbyte
CADJ STORE ws = comlev1_kpp, key=ikey, kind=isbyte
#endif

      DO i = 1, imt

         kn = INT(caseA(i)+phepsi) *(kbl(i) -1) +
     $        (1 - INT(caseA(i)+phepsi)) * kbl(i)

c-----------------------------------------------------------------------
c find the interior viscosities and derivatives at hbl(i)
c-----------------------------------------------------------------------

C     initialise diffusivities (*h) and derivatives (*p)
#ifdef KPP_DO_NOT_MATCH_DIFFUSIVITIES
         visch  = 0.
         difsh  = 0.
         difth  = 0.
         viscp  = 0.
         difsp  = 0.
         diftp  = 0.
#else /* DO_MATCH_DIFFUSIVITIES */
# ifdef KPP_DO_NOT_MATCH_DERIVATIVES
         viscp  = 0.
         difsp  = 0.
         diftp  = 0.
         delhat = 0.
# else /*  DO_MATCH_DERIVATIVES */
         delhat = 0.5*hwide(kn) - zgrid(kn) - hbl(i)
         R      = 1.0 - delhat / hwide(kn)
         dvdzup = (diffus(i,kn-1,1) - diffus(i,kn  ,1)) / hwide(kn)
         dvdzdn = (diffus(i,kn  ,1) - diffus(i,kn+1,1)) / hwide(kn+1)
CML   This is the same as:
CML      viscp  = (1.-R) * MAX(dvdzup,0.) + R  * MAX(dvdzdn,0.)
CML   why do we need that here?
         viscp  = 0.5 * ( (1.-R) * (dvdzup + ABS(dvdzup)) +
     1                        R  * (dvdzdn + ABS(dvdzdn))  )

         dvdzup = (diffus(i,kn-1,2) - diffus(i,kn  ,2)) / hwide(kn)
         dvdzdn = (diffus(i,kn  ,2) - diffus(i,kn+1,2)) / hwide(kn+1)
         difsp  = 0.5 * ( (1.-R) * (dvdzup + ABS(dvdzup)) +
     1                        R  * (dvdzdn + ABS(dvdzdn))  )

         dvdzup = (diffus(i,kn-1,3) - diffus(i,kn  ,3)) / hwide(kn)
         dvdzdn = (diffus(i,kn  ,3) - diffus(i,kn+1,3)) / hwide(kn+1)
         diftp  = 0.5 * ( (1.-R) * (dvdzup + ABS(dvdzup)) +
     1                        R  * (dvdzdn + ABS(dvdzdn))  )
# endif /* KPP_DO_NOT_MATCH_DERIVATIVES */
         visch  = diffus(i,kn,1) + viscp * delhat
         difsh  = diffus(i,kn,2) + difsp * delhat
         difth  = diffus(i,kn,3) + diftp * delhat
#endif /* KPP_DO_NOT_MATCH_DIFFUSIVITIES */

         f1 = stable(i) * conc1 * bfsfc(i) /
#ifdef KPP_SMOOTH_REGULARISATION
     &        (ustar(i)**4 + phepsi)
#else
     &        MAX(ustar(i)**4,phepsi)
#endif
         gat1m(i) = visch / hbl(i) / wm(i)
         dat1m(i) = -viscp / wm(i) + f1 * visch

         gat1s(i) = difsh  / hbl(i) / ws(i)
         dat1s(i) = -difsp / ws(i) + f1 * difsh

         gat1t(i) = difth /  hbl(i) / ws(i)
         dat1t(i) = -diftp / ws(i) + f1 * difth

      ENDDO
#ifdef KPP_AUTODIFF_MORE_STORE
CADJ STORE gat1m = comlev1_kpp, key=ikey, kind=isbyte
CADJ STORE gat1s = comlev1_kpp, key=ikey, kind=isbyte
CADJ STORE gat1t = comlev1_kpp, key=ikey, kind=isbyte
CADJ STORE dat1m = comlev1_kpp, key=ikey, kind=isbyte
CADJ STORE dat1s = comlev1_kpp, key=ikey, kind=isbyte
CADJ STORE dat1t = comlev1_kpp, key=ikey, kind=isbyte
#endif
      DO i = 1, imt
         dat1m(i) = MIN(dat1m(i),p0)
         dat1s(i) = MIN(dat1s(i),p0)
         dat1t(i) = MIN(dat1t(i),p0)
      ENDDO
#ifdef KPP_AUTODIFF_MORE_STORE
CADJ STORE dat1m = comlev1_kpp, key=ikey, kind=isbyte
CADJ STORE dat1s = comlev1_kpp, key=ikey, kind=isbyte
CADJ STORE dat1t = comlev1_kpp, key=ikey, kind=isbyte
#endif

      DO ki = 1, Nr

#ifdef ALLOW_AUTODIFF_TAMC
         kkey = (ikey-1)*Nr + ki
#endif

c-----------------------------------------------------------------------
c     compute turbulent velocity scales on the interfaces
c-----------------------------------------------------------------------

         DO i = 1, imt
            sig      = (-zgrid(ki) + 0.5 * hwide(ki)) / hbl(i)
            sigma(i) = stable(i)*sig + (1.-stable(i))*MIN(sig,epsilon)
         ENDDO
#ifdef KPP_AUTODIFF_MORE_STORE
CADJ STORE wm = comlev1_kpp_k, key = kkey
CADJ STORE ws = comlev1_kpp_k, key = kkey
#endif
#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE sigma = comlev1_kpp_k, key = kkey
#endif
         CALL wscale (
     I        sigma, hbl, ustar, bfsfc,
     O        wm, ws, myThid )
#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE wm = comlev1_kpp_k, key = kkey
CADJ STORE ws = comlev1_kpp_k, key = kkey
#endif

c-----------------------------------------------------------------------
c     compute the dimensionless shape functions at the interfaces
c-----------------------------------------------------------------------

         DO i = 1, imt
            sig = (-zgrid(ki) + 0.5 * hwide(ki)) / hbl(i)
            a1 = sig - 2.
            a2 = 3. - 2. * sig
            a3 = sig - 1.

            Gm = a1 + a2 * gat1m(i) + a3 * dat1m(i)
            Gs = a1 + a2 * gat1s(i) + a3 * dat1s(i)
            Gt = a1 + a2 * gat1t(i) + a3 * dat1t(i)

c-----------------------------------------------------------------------
c     compute boundary layer diffusivities at the interfaces
c-----------------------------------------------------------------------

            blmc(i,ki,1) = hbl(i) * wm(i) * sig * (1. + sig * Gm)
            blmc(i,ki,2) = hbl(i) * ws(i) * sig * (1. + sig * Gs)
            blmc(i,ki,3) = hbl(i) * ws(i) * sig * (1. + sig * Gt)

c-----------------------------------------------------------------------
c     nonlocal transport term = ghat * <ws>o
c-----------------------------------------------------------------------

            tempVar = ws(i) * hbl(i)
#ifdef KPP_SMOOTH_REGULARISATION
            ghat(i,ki) = (1.-stable(i)) * cg / (phepsi+tempVar)
#else
            ghat(i,ki) = (1.-stable(i)) * cg / MAX(phepsi,tempVar)
#endif
         ENDDO
      ENDDO

c-----------------------------------------------------------------------
c find diffusivities at kbl-1 grid level
c-----------------------------------------------------------------------

      DO i = 1, imt
         kl = kbl(i)
         sig      = -zgrid(kl-1) / hbl(i)
         sigma(i) = stable(i) * sig
     &            + (1. - stable(i)) * MIN(sig,epsilon)
      ENDDO

#ifdef KPP_AUTODIFF_MORE_STORE
CADJ STORE wm = comlev1_kpp, key=ikey, kind=isbyte
CADJ STORE ws = comlev1_kpp, key=ikey, kind=isbyte
#endif
#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE sigma = comlev1_kpp, key=ikey, kind=isbyte
#endif
      CALL wscale (
     I        sigma, hbl, ustar, bfsfc,
     O        wm, ws, myThid )
#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE wm = comlev1_kpp, key=ikey, kind=isbyte
CADJ STORE ws = comlev1_kpp, key=ikey, kind=isbyte
#endif

      DO i = 1, imt
         kl = kbl(i)
         sig = -zgrid(kl-1) / hbl(i)
         a1 = sig - 2.
         a2 = 3. - 2. * sig
         a3 = sig - 1.
         Gm = a1 + a2 * gat1m(i) + a3 * dat1m(i)
         Gs = a1 + a2 * gat1s(i) + a3 * dat1s(i)
         Gt = a1 + a2 * gat1t(i) + a3 * dat1t(i)
         dkm1(i,1) = hbl(i) * wm(i) * sig * (1. + sig * Gm)
         dkm1(i,2) = hbl(i) * ws(i) * sig * (1. + sig * Gs)
         dkm1(i,3) = hbl(i) * ws(i) * sig * (1. + sig * Gt)
      ENDDO

#endif /* ALLOW_KPP */

      RETURN
      END

c*************************************************************************

      subroutine enhance (
     I       dkm1, hbl, kbl, diffus, casea,
     U       ghat,
     O       blmc,
     &       myThid )

c enhance the diffusivity at the kbl-.5 interface

      IMPLICIT NONE

#include "SIZE.h"
#include "KPP_PARAMS.h"

c input
c     dkm1(imt,mdiff)          bl diffusivity at kbl-1 grid level
c     hbl(imt)                  boundary layer depth                 (m)
c     kbl(imt)                  grid above hbl
c     diffus(imt,0:Nrp1,mdiff) vertical diffusivities           (m^2/s)
c     casea(imt)                = 1 in caseA, = 0 in case B
c     myThid                    thread number for this instance of the routine
      INTEGER   myThid
      _RL dkm1  (imt,mdiff)
      _RL hbl   (imt)
      INTEGER kbl   (imt)
      _RL diffus(imt,0:Nrp1,mdiff)
      _RL casea (imt)

c input/output
c     nonlocal transport, modified ghat at kbl(i)-1 interface    (s/m**2)
      _RL ghat (imt,Nr)

c output
c     enhanced bound. layer mixing coeff.
      _RL blmc  (imt,Nr,mdiff)

#ifdef ALLOW_KPP

c local
c     fraction hbl lies beteen zgrid neighbors
      _RL delta
      INTEGER ki, i, md
      _RL dkmp5, dstar

      DO i = 1, imt
         ki = kbl(i)-1
         IF ((ki .ge. 1) .AND. (ki .LT. Nr)) THEN
            delta = (hbl(i) + zgrid(ki)) / (zgrid(ki) - zgrid(ki+1))
            DO md = 1, mdiff
               dkmp5         =      casea(i)  * diffus(i,ki,md) +
     1                         (1.- casea(i)) * blmc  (i,ki,md)
C     I think that this is meant here, but I cannot be sure because there
C     there is no reference for this. In MOM6/CVMix, the square is outside
C     of the parentheses
CML               dstar         = (1.- delta**2) * dkm1(i,md)
               dstar         = (1.- delta)**2 * dkm1(i,md)
     &                       + delta**2 * dkmp5
               blmc(i,ki,md) = (1.- delta)*diffus(i,ki,md)
     &                       + delta*dstar
            ENDDO
            ghat(i,ki) = (1.- casea(i)) * ghat(i,ki)
         ENDIF
      ENDDO

#endif /* ALLOW_KPP */

      RETURN
      END

c*************************************************************************

      SUBROUTINE STATEKPP (
     O     RHO1, DBLOC, DBSFC, TTALPHA, SSBETA,
     I     ikey, bi, bj, myThid )
c
c-----------------------------------------------------------------------
c     "statekpp" computes all necessary input arrays
c     for the kpp mixing scheme
c
c     input:
c      bi, bj = array indices on which to apply calculations
c
c     output:
c      rho1   = potential density of surface layer                     (kg/m^3)
c      dbloc  = local buoyancy gradient at Nr interfaces
c               g/rho{k+1,k+1} * [ drho{k,k+1}-drho{k+1,k+1} ]          (m/s^2)
c      dbsfc  = buoyancy difference with respect to the surface
c               g * [ drho{1,k}/rho{1,k} - drho{k,k}/rho{k,k} ]         (m/s^2)
c      ttalpha= thermal expansion coefficient without 1/rho factor
c               d(rho) / d(potential temperature)                    (kg/m^3/C)
c      ssbeta = salt expansion coefficient without 1/rho factor
c               d(rho) / d(salinity)                          ((kg/m^3)/(g/kg))
c
c     see also subroutines find_rho.F find_alpha.F find_beta.F
c
c     written  by: jan morzel,   feb. 10, 1995 (converted from "sigma" version)
c     modified by: d. menemenlis,    june 1998 : for use with MIT GCM UV
c

c-----------------------------------------------------------------------

      IMPLICIT NONE

#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "KPP_PARAMS.h"
#include "DYNVARS.h"
#include "GRID.h"
#ifdef ALLOW_AUTODIFF_TAMC
# include "tamc.h"
#endif

c-------------- Routine arguments -----------------------------------------
      INTEGER bi, bj, myThid
      _RL RHO1   ( 1-OLx:sNx+OLx, 1-OLy:sNy+OLy       )
      _RL DBLOC  ( 1-OLx:sNx+OLx, 1-OLy:sNy+OLy, Nr   )
      _RL DBSFC  ( 1-OLx:sNx+OLx, 1-OLy:sNy+OLy, Nr   )
      _RL TTALPHA( 1-OLx:sNx+OLx, 1-OLy:sNy+OLy, Nrp1 )
      _RL SSBETA ( 1-OLx:sNx+OLx, 1-OLy:sNy+OLy, Nrp1 )
      INTEGER ikey

#ifdef ALLOW_KPP

c--------------------------------------------------------------------------
c
c     local arrays:
c
c     rhok         - density of t(k  ) & s(k  ) at depth k
c     rhokm1       - density of t(k-1) & s(k-1) at depth k
c     rho1k        - density of t(1  ) & s(1  ) at depth k
c     work1,2,3    - work arrays for holding horizontal slabs

      _RL RHOK  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL RHOKM1(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL RHO1K (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL WORK1 (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL WORK2 (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL WORK3 (1-OLx:sNx+OLx,1-OLy:sNy+OLy)

      INTEGER i, j, k
#ifdef KPP_AUTODIFF_MORE_STORE
C     kkey :: tape key TAF-AD simulations (depends on vertical levels and tiles)
      INTEGER kkey
#endif

c calculate density, alpha, beta in surface layer, and set dbsfc to zero

      k = 1
#ifdef KPP_AUTODIFF_MORE_STORE
      kkey = (ikey-1)*Nr + k
CADJ STORE theta(:,:,k,bi,bj) = comlev1_kpp_k, key=kkey, kind=isbyte
CADJ STORE salt (:,:,k,bi,bj) = comlev1_kpp_k, key=kkey, kind=isbyte
#endif /* KPP_AUTODIFF_MORE_STORE */
      CALL FIND_RHO_2D(
     I     1-OLx, sNx+OLx, 1-OLy, sNy+OLy, 1,
     I     theta(1-OLx,1-OLy,k,bi,bj), salt(1-OLx,1-OLy,k,bi,bj),
     O     WORK1,
     I     k, bi, bj, myThid )
#ifdef KPP_AUTODIFF_MORE_STORE
CADJ STORE theta(:,:,k,bi,bj) = comlev1_kpp_k, key=kkey, kind=isbyte
CADJ STORE salt (:,:,k,bi,bj) = comlev1_kpp_k, key=kkey, kind=isbyte
#endif /* KPP_AUTODIFF_MORE_STORE */

      CALL FIND_ALPHA(
     I     bi, bj, 1-OLx, sNx+OLx, 1-OLy, sNy+OLy, 1, 1,
     O     WORK2, myThid )

      CALL FIND_BETA(
     I     bi, bj, 1-OLx, sNx+OLx, 1-OLy, sNy+OLy, 1, 1,
     O     WORK3, myThid )

      DO j = 1-OLy, sNy+OLy
       DO i = 1-OLx, sNx+OLx
        RHO1(i,j)      = WORK1(i,j) + rhoConst
        TTALPHA(i,j,1) = WORK2(i,j)
        SSBETA(i,j,1)  = WORK3(i,j)
        DBSFC(i,j,1)   = 0.
       ENDDO
      ENDDO

c calculate alpha, beta, and gradients in interior layers

CHPF$  INDEPENDENT, NEW (RHOK,RHOKM1,RHO1K,WORK1,WORK2)
      DO k = 2, Nr

#ifdef KPP_AUTODIFF_MORE_STORE
         kkey = (ikey-1)*Nr + k
CADJ STORE theta(:,:,k,bi,bj) = comlev1_kpp_k, key=kkey, kind=isbyte
CADJ STORE salt (:,:,k,bi,bj) = comlev1_kpp_k, key=kkey, kind=isbyte
#endif /* KPP_AUTODIFF_MORE_STORE */
         CALL FIND_RHO_2D(
     I        1-OLx, sNx+OLx, 1-OLy, sNy+OLy, k,
     I        theta(1-OLx,1-OLy,k,bi,bj), salt(1-OLx,1-OLy,k,bi,bj),
     O        RHOK,
     I        k, bi, bj, myThid )

#ifdef KPP_AUTODIFF_MORE_STORE
CADJ STORE theta(:,:,k-1,bi,bj) = comlev1_kpp_k, key=kkey, kind=isbyte
CADJ STORE salt (:,:,k-1,bi,bj) = comlev1_kpp_k, key=kkey, kind=isbyte
#endif /* KPP_AUTODIFF_MORE_STORE */
         CALL FIND_RHO_2D(
     I        1-OLx, sNx+OLx, 1-OLy, sNy+OLy, k,
     I        theta(1-OLx,1-OLy,k-1,bi,bj),salt(1-OLx,1-OLy,k-1,bi,bj),
     O        RHOKM1,
     I        k-1, bi, bj, myThid )

#ifdef KPP_AUTODIFF_MORE_STORE
CADJ STORE theta(:,:,1,bi,bj) = comlev1_kpp_k, key=kkey, kind=isbyte
CADJ STORE salt (:,:,1,bi,bj) = comlev1_kpp_k, key=kkey, kind=isbyte
#endif /* KPP_AUTODIFF_MORE_STORE */
         CALL FIND_RHO_2D(
     I        1-OLx, sNx+OLx, 1-OLy, sNy+OLy, k,
     I        theta(1-OLx,1-OLy,1,bi,bj), salt(1-OLx,1-OLy,1,bi,bj),
     O        RHO1K,
     I        1, bi, bj, myThid )

#ifdef KPP_AUTODIFF_MORE_STORE
CADJ STORE rhok  (:,:) = comlev1_kpp_k, key=kkey, kind=isbyte
CADJ STORE rhokm1(:,:) = comlev1_kpp_k, key=kkey, kind=isbyte
CADJ STORE rho1k (:,:) = comlev1_kpp_k, key=kkey, kind=isbyte
#endif /* KPP_AUTODIFF_MORE_STORE */

         CALL FIND_ALPHA(
     I        bi, bj, 1-OLx, sNx+OLx, 1-OLy, sNy+OLy, k, k,
     O        WORK1, myThid )

         CALL FIND_BETA(
     I        bi, bj, 1-OLx, sNx+OLx, 1-OLy, sNy+OLy, k, k,
     O        WORK2, myThid )

         DO j = 1-OLy, sNy+OLy
            DO i = 1-OLx, sNx+OLx
               TTALPHA(i,j,k) = WORK1 (i,j)
               SSBETA(i,j,k)  = WORK2 (i,j)
               DBLOC(i,j,k-1) = gravity * (RHOK(i,j) - RHOKM1(i,j)) /
     &                                    (RHOK(i,j) + rhoConst)
               DBSFC(i,j,k)   = gravity * (RHOK(i,j) - RHO1K (i,j)) /
     &                                    (RHOK(i,j) + rhoConst)
            ENDDO
         ENDDO

      ENDDO

c     compute arrays for k = Nrp1
      DO j = 1-OLy, sNy+OLy
       DO i = 1-OLx, sNx+OLx
        TTALPHA(i,j,Nrp1) = TTALPHA(i,j,Nr)
        SSBETA(i,j,Nrp1)  = SSBETA(i,j,Nr)
        DBLOC(i,j,Nr)     = 0.
       ENDDO
      ENDDO

#ifdef ALLOW_DIAGNOSTICS
      IF ( useDiagnostics ) THEN
       CALL DIAGNOSTICS_FILL(DBSFC ,'KPPdbsfc',0,Nr,2,bi,bj,myThid)
       CALL DIAGNOSTICS_FILL(DBLOC ,'KPPdbloc',0,Nr,2,bi,bj,myThid)
      ENDIF
#endif /* ALLOW_DIAGNOSTICS */

#endif /* ALLOW_KPP */

      RETURN
      END

c*************************************************************************

      SUBROUTINE KPP_DOUBLEDIFF (
     I     TTALPHA, SSBETA,
     U     kappaRT,
     U     kappaRS,
     I     ikey, iMin, iMax, jMin, jMax, bi, bj, myThid )
c
c-----------------------------------------------------------------------
c     "KPP_DOUBLEDIFF" adds the double diffusive contributions
C     as Rrho-dependent parameterizations to kappaRT and kappaRS
c
c     input:
c     bi, bj  = array indices on which to apply calculations
c     iMin, iMax, jMin, jMax = array boundaries
c     ikey = key for TAF automatic differentiation
c     myThid  = thread id
c
c      ttalpha= thermal expansion coefficient without 1/rho factor
c               d(rho) / d(potential temperature)                    (kg/m^3/C)
c      ssbeta = salt expansion coefficient without 1/rho factor
c               d(rho) / d(salinity)                          ((kg/m^3)/(g/kg))
c     output: updated
c     kappaRT/S :: background diffusivities for temperature and salinity
c
c     written  by: martin losch,   sept. 15, 2009
c

c-----------------------------------------------------------------------

      IMPLICIT NONE

#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "KPP_PARAMS.h"
#include "DYNVARS.h"
#include "GRID.h"
#ifdef ALLOW_AUTODIFF_TAMC
# include "tamc.h"
#endif

c-------------- Routine arguments -----------------------------------------
      INTEGER ikey, iMin, iMax, jMin, jMax, bi, bj, myThid

      _RL TTALPHA( 1-OLx:sNx+OLx, 1-OLy:sNy+OLy, Nrp1 )
      _RL SSBETA ( 1-OLx:sNx+OLx, 1-OLy:sNy+OLy, Nrp1 )
      _RL KappaRT( 1-OLx:sNx+OLx, 1-OLy:sNy+OLy, Nr   )
      _RL KappaRS( 1-OLx:sNx+OLx, 1-OLy:sNy+OLy, Nr   )

#ifdef ALLOW_KPP

C--------------------------------------------------------------------------
C
C     local variables
C     i,j,k :: loop indices
C     kkey  :: key for TAF automatic differentiation
C
      INTEGER i, j, k
      INTEGER kkey
C     alphaDT   :: d\rho/d\theta * d\theta
C     betaDS    :: d\rho/dsalt * dsalt
C     Rrho      :: "density ratio" R_{\rho} = \alpha dT/dz / \beta dS/dz
C     nuddt/s   :: double diffusive diffusivities
C     numol     :: molecular diffusivity
C     rFac      :: abbreviation for 1/(R_{\rho0}-1)

      _RL alphaDT ( 1-OLx:sNx+OLx, 1-OLy:sNy+OLy )
      _RL betaDS  ( 1-OLx:sNx+OLx, 1-OLy:sNy+OLy )
      _RL nuddt   ( 1-OLx:sNx+OLx, 1-OLy:sNy+OLy )
      _RL nudds   ( 1-OLx:sNx+OLx, 1-OLy:sNy+OLy )
      _RL Rrho
      _RL numol, rFac, nutmp
      INTEGER Km1

C     set some constants here
      numol = 1.5 _d -06
      rFac  = 1. _d 0 / (Rrho0 - 1. _d 0 )
C
      kkey = (ikey-1)*Nr + 1

CML#ifdef KPP_AUTODIFF_MORE_STORE
CMLCADJ STORE theta(:,:,1,bi,bj) = comlev1_kpp_k,
CMLCADJ &     key=kkey, kind=isbyte
CMLCADJ STORE salt (:,:,1,bi,bj) = comlev1_kpp_k,
CMLCADJ &     key=kkey, kind=isbyte
CML#endif /* KPP_AUTODIFF_MORE_STORE */

      DO k = 1, Nr
       Km1 = MAX(k-1,1)
       DO j = 1-OLy, sNy+OLy
        DO i = 1-OLx, sNx+OLx
         alphaDT(i,j) = ( theta(i,j,km1,bi,bj)-theta(i,j,k,bi,bj) )
     &        * 0.5 _d 0 * ABS( TTALPHA(i,j,km1) + TTALPHA(i,j,k) )
         betaDS(i,j)  = ( salt(i,j,km1,bi,bj)-salt(i,j,k,bi,bj) )
     &        * 0.5 _d 0 * ( SSBETA(i,j,km1) + SSBETA(i,j,k) )
         nuddt(i,j) = 0. _d 0
         nudds(i,j) = 0. _d 0
        ENDDO
       ENDDO
       IF ( k .GT. 1 ) THEN
        DO j = jMin, jMax
         DO i = iMin, iMax
          Rrho  = 0. _d 0
C     Now we have many different cases
C     a. alphaDT > 0 and betaDS > 0 => salt fingering
C        (salinity destabilizes)
          IF (      alphaDT(i,j) .GT. betaDS(i,j)
     &         .AND. betaDS(i,j) .GT. 0. _d 0 ) THEN
           Rrho = MIN( alphaDT(i,j)/betaDS(i,j), Rrho0 )
C     Large et al. 1994, eq. 31a
C          nudds(i,j) = dsfmax * ( 1. _d 0 - (Rrho - 1. _d 0) * rFac )**3
           nutmp      =          ( 1. _d 0 - (Rrho - 1. _d 0) * rFac )
           nudds(i,j) = dsfmax * nutmp * nutmp * nutmp
C     Large et al. 1994, eq. 31c
           nuddt(i,j) = 0.7 _d 0 * nudds(i,j)
          ELSEIF (   alphaDT(i,j) .LT. 0. _d 0
     &          .AND. betaDS(i,j) .LT. 0. _d 0
     &          .AND.alphaDT(i,j) .GT. betaDS(i,j) ) THEN
C     b. alphaDT < 0 and betaDS < 0 => semi-convection, diffusive convection
C        (temperature destabilizes)
C     for Rrho >= 1 the water column is statically unstable and we never
C     reach this point
           Rrho = alphaDT(i,j)/betaDS(i,j)
C     Large et al. 1994, eq. 32
           nuddt(i,j) = numol * 0.909 _d 0
     &          * exp ( 4.6 _d 0 * exp (
     &          - 5.4 _d 0 * ( 1. _d 0/Rrho - 1. _d 0 ) ) )
CMLC     or
CMLC     Large et al. 1994, eq. 33
CML         nuddt(i,j) = numol * 8.7 _d 0 * Rrho**1.1
C     Large et al. 1994, eqs. 34
           nudds(i,j) = nuddt(i,j) * MAX( 0.15 _d 0 * Rrho,
     &          1.85 _d 0 * Rrho - 0.85 _d 0 )
          ELSE
C     Do nothing, because in this case the water colume is unstable
C     => double diffusive processes are negligible and mixing due
C     to shear instability will dominate
          ENDIF
         ENDDO
        ENDDO
C     ENDIF ( k .GT. 1 )
       ENDIF
C
       DO j = 1-OLy, sNy+OLy
        DO i = 1-OLx, sNx+OLx
         kappaRT(i,j,k) = kappaRT(i,j,k) + nuddt(i,j)
         kappaRS(i,j,k) = kappaRS(i,j,k) + nudds(i,j)
        ENDDO
       ENDDO
#ifdef ALLOW_DIAGNOSTICS
       IF ( useDiagnostics ) THEN
        CALL DIAGNOSTICS_FILL(nuddt,'KPPnuddt',k,1,2,bi,bj,myThid)
        CALL DIAGNOSTICS_FILL(nudds,'KPPnudds',k,1,2,bi,bj,myThid)
       ENDIF
#endif /* ALLOW_DIAGNOSTICS */
C     end of k-loop
      ENDDO
#endif /* ALLOW_KPP */

      RETURN
      END

#include "PACKAGES_CONFIG.h"
#include "CPP_OPTIONS.h"
#ifdef ALLOW_MOM_COMMON
# include "MOM_COMMON_OPTIONS.h"
#endif
#define CALC_GW_NEW_THICK

CBOP
C     !ROUTINE: CALC_GW
C     !INTERFACE:
      SUBROUTINE CALC_GW(
     I               bi, bj, kappaRU, kappaRV,
     I               str13, str23, str33,
     I               viscAh3d_00, viscAh3d_13, viscAh3d_23,
     I               myTime, myIter, myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R CALC_GW
C     | o Calculate vertical velocity tendency terms
C     |   ( Non-Hydrostatic only )
C     *==========================================================*
C     | In NH, the vertical momentum tendency must be
C     | calculated explicitly and included as a source term
C     | for a 3d pressure eqn. Calculate that term here.
C     | This routine is not used in HYD calculations.
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "RESTART.h"
#include "SURFACE.h"
#include "DYNVARS.h"
#include "NH_VARS.h"
#ifdef ALLOW_ADDFLUID
# include "FFIELDS.h"
#endif
#ifdef ALLOW_MOM_COMMON
# include "MOM_VISC.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     bi,bj   :: current tile indices
C     kappaRU :: vertical viscosity at U points
C     kappaRV :: vertical viscosity at V points
C     myTime  :: Current time in simulation
C     myIter  :: Current iteration number in simulation
C     myThid  :: Thread number for this instance of the routine.
      INTEGER bi,bj
      _RL kappaRU(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr+1)
      _RL kappaRV(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr+1)
#ifdef ALLOW_SMAG_3D
      _RL str13(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr+1)
      _RL str23(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr+1)
      _RL str33(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL viscAh3d_00(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL viscAh3d_13(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr+1)
      _RL viscAh3d_23(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr+1)
#else /* ALLOW_SMAG_3D */
      _RL str13(1), str23(1), str33(1)
      _RL viscAh3d_00(1), viscAh3d_13(1), viscAh3d_23(1)
#endif /* ALLOW_SMAG_3D */
      _RL     myTime
      INTEGER myIter
      INTEGER myThid

#ifdef ALLOW_NONHYDROSTATIC
#ifdef ALLOW_MOM_COMMON

C     !LOCAL VARIABLES:
C     == Local variables ==
C     biharmonicVisc:: use horizontal biharmonic viscosity for vertical momentum
C     iMin, iMax    :: Ranges and sub-block indices on which calculations
C     jMin, jMax       are applied.
C     xA            :: W-Cell face area normal to X
C     yA            :: W-Cell face area normal to Y
C     rThickC_W     :: thickness (in r-units) of W-Cell at Western Edge
C     rThickC_S     :: thickness (in r-units) of W-Cell at Southern Edge
C     rThickC_C     :: thickness (in r-units) of W-Cell (centered on W pt)
C     recip_rThickC :: reciprocal thickness of W-Cell (centered on W-point)
C     flx_NS        :: vertical momentum flux, meridional direction
C     flx_EW        :: vertical momentum flux, zonal direction
C     flxAdvUp      :: vertical mom. advective   flux, vertical direction (@ level k-1)
C     flxDisUp      :: vertical mom. dissipation flux, vertical direction (@ level k-1)
C     flx_Dn        :: vertical momentum flux, vertical direction (@ level k)
C     gwDiss        :: vertical momentum dissipation tendency
C     gwAdd         :: other tendencies (Coriolis, Metric-terms)
C     gw_AB         :: tendency increment from Adams-Bashforth
C     del2w         :: laplacian of wVel
C     wFld          :: local copy of wVel
C     i,j,k         :: Loop counters
      LOGICAL biharmonicVisc
      INTEGER iMin,iMax,jMin,jMax
      _RS    xA    (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RS    yA    (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL    rThickC_W    (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL    rThickC_S    (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL    rThickC_C    (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL    recip_rThickC(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL    flx_NS(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL    flx_EW(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL    flx_Dn(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL    flxAdvUp(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL    flxDisUp(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL    gwDiss(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL    gwAdd (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL    gw_AB (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL    del2w (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL    wFld  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER i,j,k, km1, kp1
      _RL  mskM1, mskP1
      _RL  tmp_WbarZ
      _RL  uTrans, vTrans, rTrans
      _RL  viscLoc
      PARAMETER( iMin = 1 , iMax = sNx )
      PARAMETER( jMin = 1 , jMax = sNy )
CEOP
#ifdef ALLOW_DIAGNOSTICS
      LOGICAL diagDiss, diagAdvec, diagMetric, diag_AB
      LOGICAL  DIAGNOSTICS_IS_ON
      EXTERNAL DIAGNOSTICS_IS_ON
#endif /* ALLOW_DIAGNOSTICS */

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#ifdef ALLOW_DIAGNOSTICS
      IF ( useDiagnostics ) THEN
        diagDiss  = DIAGNOSTICS_IS_ON( 'Wm_Diss ', myThid )
        diagAdvec = DIAGNOSTICS_IS_ON( 'Wm_Advec', myThid )
        diagMetric= DIAGNOSTICS_IS_ON( 'Wm_Metr ', myThid )
        diag_AB   = DIAGNOSTICS_IS_ON( 'AB_gW   ', myThid )
      ELSE
        diagDiss  = .FALSE.
        diagAdvec = .FALSE.
        diagMetric= .FALSE.
        diag_AB   = .FALSE.
      ENDIF
#endif /* ALLOW_DIAGNOSTICS */

      biharmonicVisc = viscA4W.NE.zeroRL
     &           .OR. ( useVariableVisc .AND. useBiharmonicVisc )

C--   Initialise gW to zero
      DO k=1,Nr
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
           gW(i,j,k,bi,bj) = 0.
         ENDDO
        ENDDO
      ENDDO
C-    Initialise gwDiss to zero
      DO j=1-OLy,sNy+OLy
       DO i=1-OLx,sNx+OLx
         gwDiss(i,j) = 0.
       ENDDO
      ENDDO
      IF (momViscosity) THEN
C-    Initialize del2w to zero:
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
           del2w(i,j) = 0. _d 0
         ENDDO
        ENDDO
      ENDIF

C--   Boundaries condition at top (vertical advection of vertical momentum):
      DO j=1-OLy,sNy+OLy
       DO i=1-OLx,sNx+OLx
         flxAdvUp(i,j) = 0.
c        flxDisUp(i,j) = 0.
       ENDDO
      ENDDO

C---  Sweep down column
      DO k=1,Nr
        km1 = MAX( k-1, 1 )
        kp1 = MIN( k+1,Nr )
        mskM1 = 1.
        mskP1 = 1.
        IF ( k.EQ. 1 ) mskM1 = 0.
        IF ( k.EQ.Nr ) mskP1 = 0.
        IF ( k.GT.1 ) THEN
C--   Compute grid factor arround a W-point:
#ifdef CALC_GW_NEW_THICK
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           IF ( maskC(i,j,k-1,bi,bj).EQ.0. .OR.
     &          maskC(i,j, k ,bi,bj).EQ.0. ) THEN
             recip_rThickC(i,j) = 0.
           ELSE
C-    valid in z & p coord.; also accurate if Interface @ middle between 2 centers
             recip_rThickC(i,j) = 1. _d 0 /
     &        (  MIN( Ro_surf(i,j,bi,bj),rC(k-1) )
     &         - MAX( R_low(i,j,bi,bj),  rC(k)   )
     &        )
           ENDIF
          ENDDO
         ENDDO
         IF (momViscosity) THEN
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           rThickC_C(i,j) = MAX( zeroRS,
     &                           MIN( Ro_surf(i,j,bi,bj), rC(k-1) )
     &                          -MAX(   R_low(i,j,bi,bj),  rC(k)  )
     &                         )
          ENDDO
         ENDDO
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx+1,sNx+OLx
           rThickC_W(i,j) = MAX( zeroRS,
     &                           MIN( rSurfW(i,j,bi,bj), rC(k-1) )
     &                          -MAX(  rLowW(i,j,bi,bj), rC(k)   )
     &                         )
C     W-Cell Western face area:
           xA(i,j) = _dyG(i,j,bi,bj)*rThickC_W(i,j)
c    &                              *deepFacF(k)
          ENDDO
         ENDDO
         DO j=1-OLy+1,sNy+OLy
          DO i=1-OLx,sNx+OLx
           rThickC_S(i,j) = MAX( zeroRS,
     &                           MIN( rSurfS(i,j,bi,bj), rC(k-1) )
     &                          -MAX(  rLowS(i,j,bi,bj), rC(k)   )
     &                         )
C     W-Cell Southern face area:
           yA(i,j) = _dxG(i,j,bi,bj)*rThickC_S(i,j)
c    &                              *deepFacF(k)
C deep-model: xA,yA is only used for viscous flux, in terms like: xA/dxC,yA/dyC.
C this gives deepFacF*recip_deepFacF => cancel each other (and therefore omitted)
          ENDDO
         ENDDO
         ENDIF
#else /* CALC_GW_NEW_THICK */
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
C-    note: assume fluid @ smaller k than bottom: does not work in p-coordinate !
           IF ( maskC(i,j,k,bi,bj).EQ.0. ) THEN
             recip_rThickC(i,j) = 0.
           ELSE
             recip_rThickC(i,j) = 1. _d 0 /
     &        ( drF(k-1)*halfRS
     &        + drF( k )*MIN( _hFacC(i,j, k ,bi,bj), halfRS )
     &        )
           ENDIF
c          IF (momViscosity) THEN
#ifdef NONLIN_FRSURF
           rThickC_C(i,j) =
     &          drF(k-1)*MAX( h0FacC(i,j,k-1,bi,bj)-halfRS, zeroRS )
     &        + drF( k )*MIN( h0FacC(i,j,k  ,bi,bj), halfRS )
#else
           rThickC_C(i,j) =
     &          drF(k-1)*MAX( _hFacC(i,j,k-1,bi,bj)-halfRS, zeroRS )
     &        + drF( k )*MIN( _hFacC(i,j,k  ,bi,bj), halfRS )
#endif
           rThickC_W(i,j) =
     &          drF(k-1)*MAX( _hFacW(i,j,k-1,bi,bj)-halfRS, zeroRS )
     &        + drF( k )*MIN( _hFacW(i,j,k  ,bi,bj), halfRS )
           rThickC_S(i,j) =
     &          drF(k-1)*MAX( _hFacS(i,j,k-1,bi,bj)-halfRS, zeroRS )
     &        + drF( k )*MIN( _hFacS(i,j, k ,bi,bj), halfRS )
C     W-Cell Western face area:
           xA(i,j) = _dyG(i,j,bi,bj)*rThickC_W(i,j)
c    &                              *deepFacF(k)
C     W-Cell Southern face area:
           yA(i,j) = _dxG(i,j,bi,bj)*rThickC_S(i,j)
c    &                              *deepFacF(k)
C deep-model: xA,yA is only used for viscous flux, in terms like: xA/dxC,yA/dyC.
C this gives deepFacF*recip_deepFacF => cancel each other (and therefore omitted)
c          ENDIF
          ENDDO
         ENDDO
#endif /* CALC_GW_NEW_THICK */
        ELSEIF ( selectNHfreeSurf.GE.1 ) THEN
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           recip_rThickC(i,j) = recip_drC(k)
c          rThickC_C(i,j) = drC(k)
c          rThickC_W(i,j) = drC(k)
c          rThickC_S(i,j) = drC(k)
c          xA(i,j) = _dyG(i,j,bi,bj)*drC(k)
c          yA(i,j) = _dxG(i,j,bi,bj)*drC(k)
          ENDDO
         ENDDO
        ENDIF

C--   local copy of wVel:
        DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
            wFld(i,j) = wVel(i,j,k,bi,bj)
          ENDDO
        ENDDO

C--   horizontal bi-harmonic dissipation
        IF ( momViscosity .AND. k.GT.1 .AND. biharmonicVisc ) THEN

C-    calculate the horizontal Laplacian of vertical flow
C     Zonal flux d/dx W
          IF ( useCubedSphereExchange ) THEN
C     to compute d/dx(W), fill corners with appropriate values:
            CALL FILL_CS_CORNER_TR_RL( 1, .FALSE.,
     &                                 wFld, bi,bj, myThid )
          ENDIF
          DO j=1-OLy,sNy+OLy
           flx_EW(1-OLx,j)=0.
           DO i=1-OLx+1,sNx+OLx
            flx_EW(i,j) =
     &               ( wFld(i,j) - wFld(i-1,j) )
     &              *_recip_dxC(i,j,bi,bj)*xA(i,j)
#ifdef COSINEMETH_III
     &              *sqCosFacU(j,bi,bj)
#endif
#ifdef ALLOW_OBCS
     &              *maskInW(i,j,bi,bj)
#endif
           ENDDO
          ENDDO

C     Meridional flux d/dy W
          IF ( useCubedSphereExchange ) THEN
C     to compute d/dy(W), fill corners with appropriate values:
            CALL FILL_CS_CORNER_TR_RL( 2, .FALSE.,
     &                                 wFld, bi,bj, myThid )
          ENDIF
          DO i=1-OLx,sNx+OLx
           flx_NS(i,1-OLy)=0.
          ENDDO
          DO j=1-OLy+1,sNy+OLy
           DO i=1-OLx,sNx+OLx
            flx_NS(i,j) =
     &               ( wFld(i,j) - wFld(i,j-1) )
     &              *_recip_dyC(i,j,bi,bj)*yA(i,j)
#ifdef ISOTROPIC_COS_SCALING
#ifdef COSINEMETH_III
     &              *sqCosFacV(j,bi,bj)
#endif
#endif
#ifdef ALLOW_OBCS
     &              *maskInS(i,j,bi,bj)
#endif
           ENDDO
          ENDDO

C     del^2 W
C     Divergence of horizontal fluxes
          DO j=1-OLy,sNy+OLy-1
           DO i=1-OLx,sNx+OLx-1
            del2w(i,j) = ( ( flx_EW(i+1,j)-flx_EW(i,j) )
     &                    +( flx_NS(i,j+1)-flx_NS(i,j) )
     &                   )*recip_rA(i,j,bi,bj)*recip_rThickC(i,j)
     &                    *recip_deepFac2F(k)
           ENDDO
          ENDDO
C end if biharmonic viscosity
        ENDIF

        IF ( momViscosity .AND. k.GT.1 ) THEN
C Viscous Flux on Western face
          DO j=jMin,jMax
           DO i=iMin,iMax+1
             flx_EW(i,j)=
     &       - (viscAh_W(i,j,k,bi,bj)+viscAh_W(i-1,j,k,bi,bj))*halfRL
     &              *(wVel(i,j,k,bi,bj)-wVel(i-1,j,k,bi,bj))
     &              *_recip_dxC(i,j,bi,bj)*xA(i,j)
     &              *cosFacU(j,bi,bj)
     &       + (viscA4_W(i,j,k,bi,bj)+viscA4_W(i-1,j,k,bi,bj))*halfRL
     &              *(del2w(i,j)-del2w(i-1,j))
     &              *_recip_dxC(i,j,bi,bj)*xA(i,j)
#ifdef COSINEMETH_III
     &              *sqCosFacU(j,bi,bj)
#else
     &              *cosFacU(j,bi,bj)
#endif
           ENDDO
          ENDDO
C Viscous Flux on Southern face
          DO j=jMin,jMax+1
           DO i=iMin,iMax
             flx_NS(i,j)=
     &       - (viscAh_W(i,j,k,bi,bj)+viscAh_W(i,j-1,k,bi,bj))*halfRL
     &              *(wVel(i,j,k,bi,bj)-wVel(i,j-1,k,bi,bj))
     &              *_recip_dyC(i,j,bi,bj)*yA(i,j)
#ifdef ISOTROPIC_COS_SCALING
     &              *cosFacV(j,bi,bj)
#endif
     &       + (viscA4_W(i,j,k,bi,bj)+viscA4_W(i,j-1,k,bi,bj))*halfRL
     &              *(del2w(i,j)-del2w(i,j-1))
     &              *_recip_dyC(i,j,bi,bj)*yA(i,j)
#ifdef ISOTROPIC_COS_SCALING
#ifdef COSINEMETH_III
     &              *sqCosFacV(j,bi,bj)
#else
     &              *cosFacV(j,bi,bj)
#endif
#endif
           ENDDO
          ENDDO
C Viscous Flux on Lower face of W-Cell (= at tracer-cell center, level k)
          DO j=jMin,jMax
           DO i=iMin,iMax
C     Interpolate vert viscosity to center of tracer-cell (level k):
             viscLoc = ( kappaRU(i,j,k)  +kappaRU(i+1,j,k)
     &                  +kappaRU(i,j,k+1)+kappaRU(i+1,j,k+1)
     &                  +kappaRV(i,j,k)  +kappaRV(i,j+1,k)
     &                  +kappaRV(i,j,k+1)+kappaRV(i,j+1,k+1)
     &                 )*0.125 _d 0
             flx_Dn(i,j) =
     &          - viscLoc*( wVel(i,j,kp1,bi,bj)*mskP1
     &                     -wVel(i,j, k ,bi,bj) )*rkSign
     &                   *recip_drF(k)*rA(i,j,bi,bj)
     &                   *deepFac2C(k)*rhoFacC(k)
           ENDDO
          ENDDO
          IF ( k.EQ.2 ) THEN
C Viscous Flux on Upper face of W-Cell (= at tracer-cell center, level k-1)
           DO j=jMin,jMax
            DO i=iMin,iMax
C     Interpolate horizontally (but not vertically) vert viscosity to center:
C     Although background visc. might be defined at k=1, this is not
C     generally true when using variable visc. (from vertical mixing scheme).
C     Therefore, no vert. interp. and only horizontal interpolation.
             viscLoc = ( kappaRU(i,j,k) + kappaRU(i+1,j,k)
     &                  +kappaRV(i,j,k) + kappaRV(i,j+1,k)
     &                 )*0.25 _d 0
             flxDisUp(i,j) =
     &          - viscLoc*( wVel(i,j, k ,bi,bj)
     &                     -wVel(i,j,k-1,bi,bj) )*rkSign
     &                   *recip_drF(k-1)*rA(i,j,bi,bj)
     &                   *deepFac2C(k-1)*rhoFacC(k-1)
C to recover old (before 2009/11/30) results (since flxDisUp(k=2) was zero)
c            flxDisUp(i,j) = 0.
            ENDDO
           ENDDO
          ENDIF
C     Tendency is minus divergence of viscous fluxes:
C     anelastic: vert.visc.flx is scaled by rhoFac but hor.visc.fluxes are not
          DO j=jMin,jMax
           DO i=iMin,iMax
             gwDiss(i,j) =
     &        -(   ( flx_EW(i+1,j)-flx_EW(i,j) )
     &           + ( flx_NS(i,j+1)-flx_NS(i,j) )
     &           + ( flx_Dn(i,j)-flxDisUp(i,j) )*rkSign
     &                                          *recip_rhoFacF(k)
     &         )*recip_rA(i,j,bi,bj)*recip_rThickC(i,j)
     &          *recip_deepFac2F(k)
C--        prepare for next level (k+1)
             flxDisUp(i,j)=flx_Dn(i,j)
           ENDDO
          ENDDO
        ENDIF

        IF ( momViscosity .AND. k.GT.1 .AND. no_slip_sides ) THEN
C-     No-slip BCs impose a drag at walls...
          CALL MOM_W_SIDEDRAG(
     I               bi,bj,k,
     I               wVel, del2w,
     I               rThickC_C, recip_rThickC,
     I               viscAh_W, viscA4_W,
     O               gwAdd,
     I               myThid )
          DO j=jMin,jMax
           DO i=iMin,iMax
            gwDiss(i,j) = gwDiss(i,j) + gwAdd(i,j)
           ENDDO
          ENDDO
        ENDIF

#ifdef ALLOW_SMAG_3D
        IF ( useSmag3D .AND. k.GT.1 ) THEN
             CALL MOM_W_SMAG_3D(
     I         str13, str23, str33,
     I         viscAh3d_00, viscAh3d_13, viscAh3d_23,
     I         rThickC_W, rThickC_S, rThickC_C, recip_rThickC,
     O         gwAdd,
     I         iMin,iMax,jMin,jMax, k, bi, bj, myThid )
          DO j = jMin,jMax
           DO i = iMin,iMax
            gwDiss(i,j) = gwDiss(i,j) + gwAdd(i,j)
           ENDDO
          ENDDO
        ENDIF
#endif /* ALLOW_SMAG_3D */

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

        IF ( momAdvection ) THEN

         IF ( k.GT.1 .OR. selectNHfreeSurf.GE.1 ) THEN
C Advective Flux on Western face
          DO j=jMin,jMax
           DO i=iMin,iMax+1
C     transport through Western face area:
             uTrans = (
     &          drF(km1)*_hFacW(i,j,km1,bi,bj)*uVel(i,j,km1,bi,bj)
     &                  *rhoFacC(km1)*mskM1
     &        + drF( k )*_hFacW(i,j, k ,bi,bj)*uVel(i,j, k ,bi,bj)
     &                  *rhoFacC(k)
     &                )*halfRL*_dyG(i,j,bi,bj)*deepFacF(k)
             flx_EW(i,j) = uTrans*(wFld(i,j)+wFld(i-1,j))*halfRL
c            flx_EW(i,j)=
c    &         uTrans*(wVel(i,j,k,bi,bj)+wVel(i-1,j,k,bi,bj))*halfRL
           ENDDO
          ENDDO
C Advective Flux on Southern face
          DO j=jMin,jMax+1
           DO i=iMin,iMax
C     transport through Southern face area:
             vTrans = (
     &          drF(km1)*_hFacS(i,j,km1,bi,bj)*vVel(i,j,km1,bi,bj)
     &                  *rhoFacC(km1)*mskM1
     &         +drF( k )*_hFacS(i,j, k ,bi,bj)*vVel(i,j, k ,bi,bj)
     &                  *rhoFacC(k)
     &                )*halfRL*_dxG(i,j,bi,bj)*deepFacF(k)
             flx_NS(i,j) = vTrans*(wFld(i,j)+wFld(i,j-1))*halfRL
c            flx_NS(i,j)=
c    &         vTrans*(wVel(i,j,k,bi,bj)+wVel(i,j-1,k,bi,bj))*halfRL
           ENDDO
          ENDDO
         ENDIF
C Advective Flux on Lower face of W-Cell (= at tracer-cell center, level k)
c        IF (.TRUE.) THEN
          DO j=jMin,jMax
           DO i=iMin,iMax
C     NH in p-coord.: advect wSpeed [m/s] with rTrans
             tmp_WbarZ = halfRL*
     &              ( wVel(i,j, k ,bi,bj)*rVel2wUnit( k )
     &               +wVel(i,j,kp1,bi,bj)*rVel2wUnit(kp1)*mskP1 )
C     transport through Lower face area:
             rTrans = halfRL*
     &              ( wVel(i,j, k ,bi,bj)*deepFac2F( k )*rhoFacF( k )
     &               +wVel(i,j,kp1,bi,bj)*deepFac2F(kp1)*rhoFacF(kp1)
     &                                   *mskP1
     &              )*rA(i,j,bi,bj)
             flx_Dn(i,j) = rTrans*tmp_WbarZ
           ENDDO
          ENDDO
c        ENDIF
         IF ( k.EQ.1 .AND. selectNHfreeSurf.GE.1 ) THEN
C Advective Flux on Upper face of W-Cell (= at surface)
           DO j=jMin,jMax
            DO i=iMin,iMax
             tmp_WbarZ = wVel(i,j,k,bi,bj)*rVel2wUnit(k)
             rTrans = wVel(i,j,k,bi,bj)*deepFac2F(k)*rhoFacF(k)
     &               *rA(i,j,bi,bj)
             flxAdvUp(i,j) = rTrans*tmp_WbarZ
c            flxAdvUp(i,j) = 0.
            ENDDO
           ENDDO
         ENDIF

         IF ( k.GT.1 .OR. selectNHfreeSurf.GE.1 ) THEN
C     Tendency is minus divergence of advective fluxes:
C     anelastic: all transports & advect. fluxes are scaled by rhoFac
          DO j=jMin,jMax
           DO i=iMin,iMax
C to recover old (before 2009/11/30) results (since flxAdvUp(k=2) was zero)
c            IF (k.EQ.2) flxAdvUp(i,j) = 0.
             gW(i,j,k,bi,bj) =
     &        -(   ( flx_EW(i+1,j)-flx_EW(i,j) )
     &           + ( flx_NS(i,j+1)-flx_NS(i,j) )
     &           + ( flx_Dn(i,j)-flxAdvUp(i,j) )*rkSign*wUnit2rVel(k)
     &         )*recip_rA(i,j,bi,bj)*recip_rThickC(i,j)
     &          *recip_deepFac2F(k)*recip_rhoFacF(k)
           ENDDO
          ENDDO
#ifdef ALLOW_ADDFLUID
          IF ( selectAddFluid.GE.1 ) THEN
           DO j=jMin,jMax
            DO i=iMin,iMax
             gW(i,j,k,bi,bj) = gW(i,j,k,bi,bj)
     &        + wVel(i,j,k,bi,bj)*mass2rUnit*0.5 _d 0
     &          *( addMass(i,j,k,bi,bj)
     &            +addMass(i,j,km1,bi,bj)*mskM1 )
     &          *recip_rA(i,j,bi,bj)*recip_rThickC(i,j)
     &          *recip_deepFac2F(k)*recip_rhoFacF(k)
            ENDDO
           ENDDO
          ENDIF
#endif /* ALLOW_ADDFLUID */
         ENDIF

         DO j=jMin,jMax
           DO i=iMin,iMax
C--          prepare for next level (k+1)
             flxAdvUp(i,j)=flx_Dn(i,j)
           ENDDO
         ENDDO

c       ELSE
C-    if momAdvection / else
c         DO j=1-OLy,sNy+OLy
c          DO i=1-OLx,sNx+OLx
c            gW(i,j,k,bi,bj) = 0. _d 0
c          ENDDO
c         ENDDO

C-    endif momAdvection.
        ENDIF

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

        IF ( useNHMTerms .AND. k.GT.1 ) THEN
          CALL MOM_W_METRIC_NH(
     I               bi, bj, k,
     I               uVel, vVel,
     O               gwAdd,
     I               myThid )
          DO j=jMin,jMax
           DO i=iMin,iMax
             gW(i,j,k,bi,bj) = gW(i,j,k,bi,bj)+gwAdd(i,j)
           ENDDO
          ENDDO
#ifdef ALLOW_DIAGNOSTICS
          IF ( diagMetric ) THEN
           CALL DIAGNOSTICS_FILL( gwAdd, 'Wm_Metr ',
     I                            k,1,2, bi,bj, myThid )
C- note: need to explicitly increment the counter since DIAGNOSTICS_FILL
C        does it only if k=1 (never the case here)
           IF ( k.EQ.2 ) CALL DIAGNOSTICS_COUNT('Wm_Metr ',bi,bj,myThid)
          ENDIF
#endif /* ALLOW_DIAGNOSTICS */
        ENDIF
        IF ( select3dCoriScheme.GE.1 .AND. k.GT.1 ) THEN
          CALL MOM_W_CORIOLIS_NH(
     I               bi, bj, k,
     I               uVel, vVel, recip_rThickC,
     O               gwAdd,
     I               myThid )
          DO j=jMin,jMax
           DO i=iMin,iMax
             gW(i,j,k,bi,bj) = gW(i,j,k,bi,bj)+gwAdd(i,j)
           ENDDO
          ENDDO
        ENDIF

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#ifdef ALLOW_DIAGNOSTICS
        IF ( diagDiss )  THEN
          CALL DIAGNOSTICS_FILL( gwDiss, 'Wm_Diss ',
     &                           k, 1, 2, bi,bj, myThid )
c         IF ( k.EQ.2 ) CALL DIAGNOSTICS_COUNT('Wm_Diss ',bi,bj,myThid)
        ENDIF
        IF ( diagAdvec ) THEN
          CALL DIAGNOSTICS_FILL( gW, 'Wm_Advec',
     &                           k,Nr, 1, bi,bj, myThid )
c         IF ( k.EQ.2 ) CALL DIAGNOSTICS_COUNT('Wm_Advec',bi,bj,myThid)
        ENDIF
#endif /* ALLOW_DIAGNOSTICS */

C--   Dissipation term inside the Adams-Bashforth:
        IF ( momViscosity .AND. momDissip_In_AB) THEN
          DO j=jMin,jMax
           DO i=iMin,iMax
             gW(i,j,k,bi,bj) = gW(i,j,k,bi,bj)+gwDiss(i,j)
           ENDDO
          ENDDO
        ENDIF

C-    Compute effective gW_[n+1/2] terms (including Adams-Bashforth weights)
C     and save gW_[n] into gwNm1 for the next time step.
#ifdef ALLOW_ADAMSBASHFORTH_3
        CALL ADAMS_BASHFORTH3(
     I                         bi, bj, k, Nr,
     U                         gW(1-OLx,1-OLy,1,bi,bj), gwNm,
     O                         gw_AB,
     I                         nHydStartAB, myIter, myThid )
#else /* ALLOW_ADAMSBASHFORTH_3 */
        CALL ADAMS_BASHFORTH2(
     I                         bi, bj, k, Nr,
     U                         gW(1-OLx,1-OLy,1,bi,bj),
     U                         gwNm1(1-OLx,1-OLy,1,bi,bj),
     O                         gw_AB,
     I                         nHydStartAB, myIter, myThid )
#endif /* ALLOW_ADAMSBASHFORTH_3 */
#ifdef ALLOW_DIAGNOSTICS
        IF ( diag_AB ) THEN
          CALL DIAGNOSTICS_FILL(gw_AB,'AB_gW   ',k,1,2,bi,bj,myThid)
        ENDIF
#endif /* ALLOW_DIAGNOSTICS */

C--   Dissipation term outside the Adams-Bashforth:
        IF ( momViscosity .AND. .NOT.momDissip_In_AB ) THEN
          DO j=jMin,jMax
           DO i=iMin,iMax
             gW(i,j,k,bi,bj) = gW(i,j,k,bi,bj)+gwDiss(i,j)
           ENDDO
          ENDDO
        ENDIF

C-    end of the k loop
      ENDDO

#ifdef ALLOW_DIAGNOSTICS
      IF (useDiagnostics) THEN
        CALL DIAGNOSTICS_FILL(viscAh_W,'VISCAHW ',0,Nr,1,bi,bj,myThid)
        CALL DIAGNOSTICS_FILL(viscA4_W,'VISCA4W ',0,Nr,1,bi,bj,myThid)
      ENDIF
#endif /* ALLOW_DIAGNOSTICS */

#endif /* ALLOW_MOM_COMMON */
#endif /* ALLOW_NONHYDROSTATIC */

      RETURN
      END

#include "EXF_OPTIONS.h"

C--  File exf_summary.F: Routines to print out EXF settings
C--   Contents
C--   o EXF_SUMMARY
C--   o EXF_FLD_SUMMARY
C--   o EXF_PRINT_INTERP

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: EXF_SUMMARY( myThid )
C     !INTERFACE:

      SUBROUTINE EXF_SUMMARY( myThid )

C     !DESCRIPTION: \bv
C     ==================================================================
C     SUBROUTINE exf_summary
C     ==================================================================
C
C     o List all the settings of the external forcing.
C
C     started: Christian Eckert eckert@mit.edu 11-Jan-1999
C
C     changed: Christian Eckert eckert@mit.edu 12-Feb-2000
C              - changed routine names (package prefix: exf_)
C
C     changed: Patrick Heimbach heimbach@mit.edu 04-May-2000
C              - changed the handling of precip and sflux with respect
C                to CPP options ALLOW_BULKFORMULAE and ALLOW_ATM_TEMP
C
C     changed: Dimitris Menemenlis menemenlis@jpl.nasa.gov 20-Dec-2002
C              - modifications for using pkg/exf with pkg/seaice
C
C     ==================================================================
C     SUBROUTINE exf_summary
C     ==================================================================
C     \ev

C     !USES:
      IMPLICIT NONE

C     === Global variables ===
#include "EEPARAMS.h"
#include "SIZE.h"
#include "EXF_PARAM.h"
#include "EXF_CONSTANTS.h"
#include "EXF_INTERP_SIZE.h"
#include "EXF_INTERP_PARAM.h"

C     !INPUT/OUTPUT PARAMETERS:
C     myThid  :: My thread Id number
      INTEGER myThid

C     !FUNCTIONS:
#ifdef ALLOW_RUNOFTEMP
      INTEGER  ILNBLNK
      EXTERNAL ILNBLNK
      INTEGER iL
#endif

C     !LOCAL VARIABLES:
      LOGICAL prtBlkLn, addBlkLn
      CHARACTER*1 blkLin
      CHARACTER*(MAX_LEN_MBUF) msgBuf
CEOP

      _BEGIN_MASTER( myThid )

      blkLin = ' '
      CALL PRINT_MESSAGE( blkLin, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)')
     &'// ======================================================='
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)')
     &'// External forcing (EXF) configuration >>> START <<<'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)')
     &'// ======================================================='
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      CALL PRINT_MESSAGE( blkLin, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )

C--   Print general parameters:
      WRITE(msgBuf,'(A)') ' EXF general parameters:'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT , myThid )
      WRITE(msgBuf,'(A)') ' '
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT , myThid )
      CALL WRITE_0D_I( exf_iprec, INDEX_NONE, 'exf_iprec =',
     &  ' /* exf file precision */')
      CALL WRITE_0D_L( useExfYearlyFields, INDEX_NONE,
     &  'useExfYearlyFields =',
     &  ' /* add extension _YEAR to input file names */')
      CALL WRITE_0D_L( twoDigitYear, INDEX_NONE, 'twoDigitYear =',
     &  ' /* use 2-digit year extension */')
      CALL WRITE_0D_L( useExfCheckRange, INDEX_NONE,
     &  'useExfCheckRange =', ' /* check for fields range */')
#ifdef USE_EXF_INTERPOLATION
      CALL WRITE_0D_L( exf_output_interp, INDEX_NONE,
     &  'exf_output_interp =',
     &  ' /* output directly interpolation result */')
#endif
      CALL WRITE_0D_L( diags_opOceWeighted, INDEX_NONE,
     &  'diags_opOceWeighted =',
     &  ' /* weight flux diags by open-ocean fraction */')
      CALL WRITE_0D_I( exf_debugLev, INDEX_NONE, 'exf_debugLev =',
     &  ' /* select EXF-debug printing level */')
      CALL WRITE_0D_RL( exf_monFreq, INDEX_NONE, 'exf_monFreq  =',
     &  ' /* EXF monitor frequency [ s ] */')
      CALL WRITE_0D_I( exf_adjMonSelect, INDEX_NONE,
     &  'exf_adjMonSelect =',
     &  ' /* select group of exf AD-variables to monitor */')
      CALL WRITE_0D_RL( repeatPeriod, INDEX_NONE, 'repeatPeriod =',
     &  ' /* period for cycling forcing dataset [ s ] */')
      CALL WRITE_0D_RL( climtempfreeze, INDEX_NONE,'climTempFreeze=',
     &  ' /* Minimum climatological temperature [deg.C] */')
      CALL WRITE_0D_RL( windStressMax, INDEX_NONE,'windStressMax =',
     &  ' /* Maximum absolute windstress [ Pa ] */')
      CALL WRITE_0D_L( stressIsOnCgrid,INDEX_NONE,'stressIsOnCgrid =',
     &  ' /* set u,v_stress on Arakawa C-grid */')
      CALL WRITE_0D_L( rotateStressOnAgrid,INDEX_NONE,
     &  'rotateStressOnAgrid =',
     &  ' /* rotate u,v_stress on Arakawa A-grid */')
      CALL WRITE_0D_RL( cen2kel, INDEX_NONE, 'cen2kel =',
     &  ' /* conversion of deg. Centigrade to Kelvin [K] */')
      CALL WRITE_0D_RL( gravity_mks, INDEX_NONE, 'gravity_mks=',
     &  ' /* gravitational acceleration [m/s^2] */')
      CALL WRITE_0D_RL( atmrho, INDEX_NONE, 'atmrho =',
     & '  /* mean atmospheric density [kg/m^3] */')
      CALL WRITE_0D_RL( atmcp, INDEX_NONE, 'atmcp =',
     & '  /* mean atmospheric specific heat [J/kg/K] */')
      CALL WRITE_0D_RL( flamb, INDEX_NONE, 'flamb =',
     & '  /* latent heat of evaporation [J/kg] */')
      CALL WRITE_0D_RL( flami, INDEX_NONE, 'flami =',
     & '  /* latent heat of pure-ice melting [J/kg] */')
      CALL WRITE_0D_RL( cvapor_fac, INDEX_NONE, 'cvapor_fac =',
     &  ' /* const. for Saturation calculation [?] */')
      CALL WRITE_0D_RL( cvapor_exp, INDEX_NONE, 'cvapor_exp =',
     &  ' /* const. for Saturation calculation [?] */')
      CALL WRITE_0D_RL( cvapor_fac_ice, INDEX_NONE, 'cvapor_fac_ice=',
     &  ' /* const. for Saturation calculation [?] */')
      CALL WRITE_0D_RL( cvapor_exp_ice, INDEX_NONE, 'cvapor_exp_ice=',
     &  ' /* const. for Saturation calculation [?] */')
      CALL WRITE_0D_RL( humid_fac, INDEX_NONE, 'humid_fac =',
     &  ' /* humidity coef. in virtual temp. [(kg/kg)^-1] */')
      CALL WRITE_0D_RL( gamma_blk, INDEX_NONE, 'gamma_blk =',
     &  ' /* adiabatic lapse rate [?] */')
      CALL WRITE_0D_RL( saltsat, INDEX_NONE, 'saltsat =',
     &  ' /* reduction of Qsat over salty water [-] */')
      CALL WRITE_0D_L( noNegativeEvap,INDEX_NONE,'noNegativeEvap =',
     &  ' /* prevent negative Evaporation */')
      CALL WRITE_0D_RL( sstExtrapol, INDEX_NONE, 'sstExtrapol =',
     &  ' /* extrapolation coeff from lev. 1 & 2 to surf [-] */')
      CALL WRITE_0D_RL( cdrag_1, INDEX_NONE, 'cDrag_1 =',
     &  ' /* coef used in drag calculation [m/s] */')
      CALL WRITE_0D_RL( cdrag_2, INDEX_NONE, 'cDrag_2 =',
     &  ' /* coef used in drag calculation [-] */')
      CALL WRITE_0D_RL( cdrag_3, INDEX_NONE, 'cDrag_3 =',
     &  ' /* coef used in drag calculation [s/m] */')
      CALL WRITE_0D_RL( cdrag_8, INDEX_NONE, 'cDrag_8 =',
     &  ' /* coef used in drag calculation [(s/m)^6] */')
      CALL WRITE_0D_RL( cdragMax, INDEX_NONE, 'cDragMax =',
     &  ' /* maximum drag (Large and Yeager, 2009) [-] */')
      CALL WRITE_0D_RL( umax, INDEX_NONE, 'umax =',
     &  ' /* at maximum wind (Large and Yeager, 2009) [m/s] */')
      CALL WRITE_0D_RL( cstanton_1, INDEX_NONE, 'cStanton_1 =',
     &  ' /* coef used in Stanton number calculation [-] */')
      CALL WRITE_0D_RL( cstanton_2, INDEX_NONE, 'cStanton_2 =',
     &  ' /* coef used in Stanton number calculation [-] */')
      CALL WRITE_0D_RL( cdalton, INDEX_NONE, 'cDalton =',
     &  ' /* Dalton number [-] */')
      CALL WRITE_0D_RL( exf_scal_BulkCdn, INDEX_NONE,
     &  'exf_scal_BulkCdn=',
     &  ' /* Drag coefficient scaling factor [-] */')
      CALL WRITE_0D_RL( zolmin, INDEX_NONE, 'zolmin =',
     &  ' /* minimum stability parameter [?] */')
      CALL WRITE_0D_RL( psim_fac, INDEX_NONE, 'psim_fac =',
     &  ' /* coef used in turbulent fluxes calculation [-] */')
      CALL WRITE_0D_RL( zref, INDEX_NONE, 'zref =',
     & '  /* reference height [ m ] */')
      CALL WRITE_0D_RL( hu, INDEX_NONE, 'hu =',
     & '  /* height of mean wind [ m ] */')
      CALL WRITE_0D_RL( ht, INDEX_NONE, 'ht =',
     & '  /* height of mean temperature [ m ] */')
      CALL WRITE_0D_RL( hq, INDEX_NONE, 'hq =',
     & '  /* height of mean spec.humidity [ m ] */')
      CALL WRITE_0D_RL( umin, INDEX_NONE, 'uMin =',
     &  ' /* minimum wind speed [m/s] */')
      CALL WRITE_0D_L( useStabilityFct_overIce, INDEX_NONE,
     &  'useStabilityFct_overIce=',
     &  ' /* transfert Coeffs over sea-ice depend on stability */')
      CALL WRITE_0D_RL( exf_iceCd, INDEX_NONE, 'exf_iceCd =',
     &  ' /* drag coefficient over sea-ice (fixed) [-] */')
      CALL WRITE_0D_RL( exf_iceCe, INDEX_NONE, 'exf_iceCe =',
     &  ' /* transfert coeff. over sea-ice, for Evap (fixed) [-] */')
      CALL WRITE_0D_RL( exf_iceCh, INDEX_NONE, 'exf_iceCh =',
     &  ' /* transfert coeff. over sea-ice, Sens.Heat.(fixed)[-] */')
      CALL WRITE_0D_RL( exf_albedo, INDEX_NONE, 'exf_albedo =',
     & '  /* Sea-water albedo [-] */')
      CALL WRITE_0D_L( useExfZenAlbedo, INDEX_NONE, 'useExfZenAlbedo =',
     &  ' /* Sea-water albedo varies with zenith angle */')
      CALL WRITE_0D_I( select_ZenAlbedo,INDEX_NONE,'select_ZenAlbedo =',
     &  ' /* Sea-water albedo computation method */')
      CALL WRITE_0D_L( useExfZenIncoming, INDEX_NONE,
     &  'useExfZenIncoming =',' /* compute incoming solar radiation */')
      CALL WRITE_0D_RL( ocean_emissivity, INDEX_NONE,
     &  'ocean_emissivity =',
     &  ' /* longwave ocean-surface emissivity [-] */')
      CALL WRITE_0D_RL( ice_emissivity, INDEX_NONE,'ice_emissivity =',
     &  ' /* longwave seaice emissivity [-] */')
      CALL WRITE_0D_RL(snow_emissivity, INDEX_NONE,'snow_emissivity =',
     &  ' /* longwave snow  emissivity [-] */')
      CALL PRINT_MESSAGE( blkLin, standardMessageUnit,
     &                    SQUEEZE_RIGHT , myThid )

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C--   Print settings of some CPP flags.
      WRITE(msgBuf,'(A)') ' EXF main CPP flags:'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT , myThid )
      CALL PRINT_MESSAGE( blkLin, standardMessageUnit,
     &                    SQUEEZE_RIGHT , myThid )

#ifdef USE_EXF_INTERPOLATION
      WRITE(msgBuf,'(A)')
     &'// USE_EXF_INTERPOLATION:              defined'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT , myThid)
#else
      WRITE(msgBuf,'(A)')
     &'// USE_EXF_INTERPOLATION:          NOT defined'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT , myThid)
#endif

#ifdef ALLOW_ATM_TEMP
      WRITE(msgBuf,'(A)')
     &'// ALLOW_ATM_TEMP:                     defined'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
#else
      WRITE(msgBuf,'(A)')
     &'// ALLOW_ATM_TEMP:                 NOT defined'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
#endif

      IF ( useAtmWind ) THEN
      WRITE(msgBuf,'(A)')
     &'// ALLOW_ATM_WIND (useAtmWind):        defined'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      ELSE
      WRITE(msgBuf,'(A)')
     &'// ALLOW_ATM_WIND (useAtmWind):    NOT defined'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      ENDIF

#ifdef ALLOW_DOWNWARD_RADIATION
      WRITE(msgBuf,'(A)')
     &'// ALLOW_DOWNWARD_RADIATION:           defined'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
#else
      WRITE(msgBuf,'(A)')
     &'// ALLOW_DOWNWARD_RADIATION:       NOT defined'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
#endif

#ifdef ALLOW_BULKFORMULAE
      WRITE(msgBuf,'(A)')
     &'// ALLOW_BULKFORMULAE:                 defined'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
#else
      WRITE(msgBuf,'(A)')
     &'// ALLOW_BULKFORMULAE:             NOT defined'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
#endif

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C--   For each data set used the summary prints the calendar data
C     and the corresponding file from which the data will be read.
      prtBlkLn = .FALSE.
      addBlkLn = .TRUE.

C--   Zonal wind stress.
      IF ( .NOT.useAtmWind .AND. ustressfile.NE.' ' ) THEN
       CALL EXF_FLD_SUMMARY( 'Zonal wind stress forcing',
     I      ustressfile, ustressRepCycle, ustressperiod,
     I      ustressStartTime, useExfYearlyFields, addBlkLn, myThid )
#ifdef USE_EXF_INTERPOLATION
       CALL EXF_PRINT_INTERP( 'ustress',
     &  ustress_lon0, ustress_lon_inc, ustress_lat0, ustress_lat_inc,
     &  ustress_nlon, ustress_nlat, ustress_interpMethod, myThid )
#endif
       prtBlkLn = .TRUE.
      ENDIF

C--   Meridional wind stress.
      IF ( .NOT.useAtmWind .AND. vstressfile.NE.' ' ) THEN
       CALL EXF_FLD_SUMMARY( 'Meridional wind stress forcing',
     I      vstressfile, vstressRepCycle, vstressperiod,
     I      vstressStartTime, useExfYearlyFields, addBlkLn, myThid )
#ifdef USE_EXF_INTERPOLATION
       CALL EXF_PRINT_INTERP( 'vstress',
     &  vstress_lon0, vstress_lon_inc, vstress_lat0, vstress_lat_inc,
     &  vstress_nlon, vstress_nlat, vstress_interpMethod, myThid )
       WRITE(msgBuf,'(2A,L5)') '    Interp. U & V comp. together:',
     &                   ' uvInterp_stress =', uvInterp_stress
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                     SQUEEZE_RIGHT, myThid )
#endif
       prtBlkLn = .TRUE.
      ENDIF

C--   Heat flux.
      IF ( hfluxfile.NE.' ' ) THEN
       CALL EXF_FLD_SUMMARY( 'Heat flux forcing',
     I      hfluxfile, hfluxRepCycle, hfluxperiod,
     I      hfluxStartTime, useExfYearlyFields, addBlkLn, myThid )
#ifdef USE_EXF_INTERPOLATION
       CALL EXF_PRINT_INTERP( 'hflux',
     &  hflux_lon0, hflux_lon_inc, hflux_lat0, hflux_lat_inc,
     &  hflux_nlon, hflux_nlat, hflux_interpMethod, myThid )
#endif
       prtBlkLn = .TRUE.
      ENDIF

C--   Fresh-Water flux.
      IF ( sfluxfile.NE.' ' ) THEN
       CALL EXF_FLD_SUMMARY( 'Fresh-Water flux forcing',
     I      sfluxfile, sfluxRepCycle, sfluxperiod,
     I      sfluxStartTime, useExfYearlyFields, addBlkLn, myThid )
#ifdef USE_EXF_INTERPOLATION
       CALL EXF_PRINT_INTERP( 'sflux',
     &  sflux_lon0, sflux_lon_inc, sflux_lat0, sflux_lat_inc,
     &  sflux_nlon, sflux_nlat, sflux_interpMethod, myThid )
#endif
       prtBlkLn = .TRUE.
      ENDIF

#if defined(ALLOW_ATM_TEMP) || defined(SHORTWAVE_HEATING)
C--   Net shortwave.
      IF ( swfluxfile.NE.' ' ) THEN
       CALL EXF_FLD_SUMMARY( 'Net shortwave flux forcing',
     I      swfluxfile, swfluxRepCycle, swfluxperiod,
     I      swfluxStartTime, useExfYearlyFields, addBlkLn, myThid )
#ifdef USE_EXF_INTERPOLATION
       CALL EXF_PRINT_INTERP( 'swflux',
     &  swflux_lon0, swflux_lon_inc, swflux_lat0, swflux_lat_inc,
     &  swflux_nlon, swflux_nlat, swflux_interpMethod, myThid )
#endif
       prtBlkLn = .TRUE.
      ENDIF
#endif /* ALLOW_ATM_TEMP or SHORTWAVE_HEATING */

C--   Zonal wind.
      IF ( useAtmWind .AND. uwindfile.NE.' ' ) THEN
       CALL EXF_FLD_SUMMARY( 'Zonal wind forcing',
     I      uwindfile, uwindRepCycle, uwindperiod,
     I      uwindStartTime, useExfYearlyFields, addBlkLn, myThid )
#ifdef USE_EXF_INTERPOLATION
       CALL EXF_PRINT_INTERP( 'uwind',
     &  uwind_lon0, uwind_lon_inc, uwind_lat0, uwind_lat_inc,
     &  uwind_nlon, uwind_nlat, uwind_interpMethod, myThid )
#endif
       prtBlkLn = .TRUE.
      ENDIF

C--   Meridional wind.
      IF ( useAtmWind .AND. vwindfile.NE.' ' ) THEN
       CALL EXF_FLD_SUMMARY( 'Meridional wind forcing',
     I      vwindfile, vwindRepCycle, vwindperiod,
     I      vwindStartTime, useExfYearlyFields, addBlkLn, myThid )
#ifdef USE_EXF_INTERPOLATION
       CALL EXF_PRINT_INTERP( 'vwind',
     &  vwind_lon0, vwind_lon_inc, vwind_lat0, vwind_lat_inc,
     &  vwind_nlon, vwind_nlat, vwind_interpMethod, myThid )
       WRITE(msgBuf,'(2A,L5)') '    Interp. U & V comp. together:',
     &                      ' uvInterp_wind =', uvInterp_wind
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                     SQUEEZE_RIGHT, myThid )
#endif
       prtBlkLn = .TRUE.
      ENDIF

C--   Surface wind speed
      IF ( wspeedfile.NE.' ' ) THEN
       CALL EXF_FLD_SUMMARY( 'Surface wind speed',
     I      wspeedfile, wspeedRepCycle, wspeedperiod,
     I      wspeedStartTime, useExfYearlyFields, addBlkLn, myThid )
#ifdef USE_EXF_INTERPOLATION
       CALL EXF_PRINT_INTERP( 'wspeed',
     &  wspeed_lon0, wspeed_lon_inc, wspeed_lat0, wspeed_lat_inc,
     &  wspeed_nlon, wspeed_nlat, wspeed_interpMethod, myThid )
#endif
       prtBlkLn = .TRUE.
      ENDIF

#ifdef ALLOW_ATM_TEMP
C--   Atmospheric temperature.
      IF ( atempfile.NE.' ' ) THEN
       CALL EXF_FLD_SUMMARY( 'Atmospheric temperature',
     I      atempfile, atempRepCycle, atempperiod,
     I      atempStartTime, useExfYearlyFields, addBlkLn, myThid )
#ifdef USE_EXF_INTERPOLATION
       CALL EXF_PRINT_INTERP( 'atemp',
     &  atemp_lon0, atemp_lon_inc, atemp_lat0, atemp_lat_inc,
     &  atemp_nlon, atemp_nlat, atemp_interpMethod, myThid )
#endif
       prtBlkLn = .TRUE.
      ENDIF

C--   Atmospheric specific humidity.
      IF ( aqhfile.NE.' ' ) THEN
       CALL EXF_FLD_SUMMARY( 'Atmospheric specific humidity',
     I      aqhfile, aqhRepCycle, aqhperiod,
     I      aqhStartTime, useExfYearlyFields, addBlkLn, myThid )
#ifdef USE_EXF_INTERPOLATION
       CALL EXF_PRINT_INTERP( 'aqh',
     &  aqh_lon0, aqh_lon_inc, aqh_lat0, aqh_lat_inc,
     &  aqh_nlon, aqh_nlat, aqh_interpMethod, myThid )
#endif
       prtBlkLn = .TRUE.
      ENDIF

C--   Turbulent heat flues
      IF ( prtBlkLn ) THEN
       CALL PRINT_MESSAGE( blkLin, standardMessageUnit,
     &                     SQUEEZE_RIGHT, myThid )
       prtBlkLn = .FALSE.
      ENDIF
#ifdef ALLOW_READ_TURBFLUXES
      WRITE(msgBuf,'(A)')
     &'// ALLOW_READ_TURBFLUXES:              defined'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )

C--   Sensible heat flux
      IF ( hs_file.NE.' ' ) THEN
       CALL EXF_FLD_SUMMARY( 'Sensible heat flux (+=down)',
     I      hs_file, hs_RepCycle, hs_period,
     I      hs_StartTime, useExfYearlyFields, addBlkLn, myThid )
#ifdef USE_EXF_INTERPOLATION
       CALL EXF_PRINT_INTERP( 'hs',
     &  hs_lon0, hs_lon_inc, hs_lat0, hs_lat_inc,
     &  hs_nlon, hs_nlat, hs_interpMethod, myThid )
#endif
       prtBlkLn = .TRUE.
      ENDIF

C--   Latent heat flux
      IF ( hl_file.NE.' ' ) THEN
       CALL EXF_FLD_SUMMARY( 'Latent heat flux (+=down)',
     I      hl_file, hl_RepCycle, hl_period,
     I      hl_StartTime, useExfYearlyFields, addBlkLn, myThid )
#ifdef USE_EXF_INTERPOLATION
       CALL EXF_PRINT_INTERP( 'hl',
     &  hl_lon0, hl_lon_inc, hl_lat0, hl_lat_inc,
     &  hl_nlon, hl_nlat, hl_interpMethod, myThid )
#endif
       prtBlkLn = .TRUE.
      ENDIF

#else /* ALLOW_READ_TURBFLUXES */
      WRITE(msgBuf,'(A)')
     &'// ALLOW_READ_TURBFLUXES:          NOT defined'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
#endif /* ALLOW_READ_TURBFLUXES */

C--   Net longwave.
      IF ( lwfluxfile.NE.' ' ) THEN
       CALL EXF_FLD_SUMMARY( 'Net longwave flux forcing',
     I      lwfluxfile, lwfluxRepCycle, lwfluxperiod,
     I      lwfluxStartTime, useExfYearlyFields, addBlkLn, myThid )
#ifdef USE_EXF_INTERPOLATION
       CALL EXF_PRINT_INTERP( 'lwflux',
     &  lwflux_lon0, lwflux_lon_inc, lwflux_lat0, lwflux_lat_inc,
     &  lwflux_nlon, lwflux_nlat, lwflux_interpMethod, myThid )
#endif
       prtBlkLn = .TRUE.
      ENDIF
#endif /* ALLOW_ATM_TEMP */

C--   Evaporation.
      IF ( prtBlkLn ) THEN
       CALL PRINT_MESSAGE( blkLin, standardMessageUnit,
     &                     SQUEEZE_RIGHT, myThid )
       prtBlkLn = .FALSE.
      ENDIF
#ifdef EXF_READ_EVAP
      WRITE(msgBuf,'(A)')
     &'// EXF_READ_EVAP:                      defined'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
# ifdef ALLOW_ATM_TEMP
      IF ( evapfile.NE.' ' ) THEN
       addBlkLn = .FALSE.
       CALL EXF_FLD_SUMMARY( 'Evaporation',
     I      evapfile, evapRepCycle, evapperiod,
     I      evapStartTime, useExfYearlyFields, addBlkLn, myThid )
       addBlkLn = .TRUE.
#ifdef USE_EXF_INTERPOLATION
       CALL EXF_PRINT_INTERP( 'evap',
     &  evap_lon0, evap_lon_inc, evap_lat0, evap_lat_inc,
     &  evap_nlon, evap_nlat, evap_interpMethod, myThid )
#endif
       prtBlkLn = .TRUE.
      ENDIF
# endif /* ALLOW_ATM_TEMP */
#else /* EXF_READ_EVAP */
      WRITE(msgBuf,'(A)')
     &'// EXF_READ_EVAP:                  NOT defined'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
#endif /* EXF_READ_EVAP */

#ifdef ALLOW_ATM_TEMP
C--   Precipitation.
      IF ( precipfile.NE.' ' ) THEN
       CALL EXF_FLD_SUMMARY( 'Precipitation data',
     I      precipfile, precipRepCycle, precipperiod,
     I      precipStartTime, useExfYearlyFields, addBlkLn, myThid )
#ifdef USE_EXF_INTERPOLATION
       CALL EXF_PRINT_INTERP( 'precip',
     &  precip_lon0, precip_lon_inc, precip_lat0, precip_lat_inc,
     &  precip_nlon, precip_nlat, precip_interpMethod, myThid )
#endif
       prtBlkLn = .TRUE.
      ENDIF

C--   Snow Precipitation
      IF ( snowprecipfile.NE.' ' ) THEN
       CALL EXF_FLD_SUMMARY( 'Snow Precipitation data',
     I      snowprecipfile, snowprecipRepCycle, snowprecipperiod,
     I      snowprecipStartTime, useExfYearlyFields, addBlkLn, myThid )
#ifdef USE_EXF_INTERPOLATION
       CALL EXF_PRINT_INTERP( 'snowprecip',
     &  snowprecip_lon0, snowprecip_lon_inc, snowprecip_lat0,
     &  snowprecip_lat_inc, snowprecip_nlon, snowprecip_nlat,
     &  snowprecip_interpMethod, myThid )
#endif
       prtBlkLn = .TRUE.
      ENDIF
#endif /* ALLOW_ATM_TEMP */

C--   Runoff.
      IF ( prtBlkLn ) THEN
       CALL PRINT_MESSAGE( blkLin, standardMessageUnit,
     &                     SQUEEZE_RIGHT, myThid )
       prtBlkLn = .FALSE.
      ENDIF
#ifdef ALLOW_RUNOFF
      WRITE(msgBuf,'(A)')
     &'// ALLOW_RUNOFF:                       defined'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      IF ( runofffile.NE.' ' ) THEN
       addBlkLn = .FALSE.
       CALL EXF_FLD_SUMMARY( 'Runoff data',
     I      runofffile, runoffRepCycle, runoffperiod,
     I      runoffStartTime, useExfYearlyFields, addBlkLn, myThid )
       addBlkLn = .TRUE.
# ifdef USE_EXF_INTERPOLATION
       CALL EXF_PRINT_INTERP( 'runoff',
     &  runoff_lon0, runoff_lon_inc, runoff_lat0, runoff_lat_inc,
     &  runoff_nlon, runoff_nlat, runoff_interpMethod, myThid )
# endif /* USE_EXF_INTERPOLATION */
       prtBlkLn = .TRUE.
      ENDIF
      IF ( prtBlkLn ) THEN
       CALL PRINT_MESSAGE( blkLin, standardMessageUnit,
     &                     SQUEEZE_RIGHT, myThid )
       prtBlkLn = .FALSE.
      ENDIF
# ifdef ALLOW_RUNOFTEMP
      WRITE(msgBuf,'(A)')
     &'// ALLOW_RUNOFTEMP:                    defined'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      IF ( runoftempfile.NE.' ' ) THEN
c      addBlkLn = .FALSE.
c      CALL EXF_FLD_SUMMARY( 'Runoff temp.',
c    I      runoftempfile, runoffRepCycle, runoffperiod,
c    I      runoffStartTime, useExfYearlyFields, addBlkLn, myThid )
c      addBlkLn = .TRUE.
       iL = ILNBLNK(runoftempfile)
       WRITE(msgBuf,'(A)')
     & '   Runoff temp. is read from file:'
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                     SQUEEZE_RIGHT, myThid )
       WRITE(msgBuf,'(3A)') '   >> ', runoftempfile(1:iL), ' <<'
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                     SQUEEZE_RIGHT, myThid )
       prtBlkLn = .TRUE.
      ENDIF
# else /* ALLOW_RUNOFTEMP */
      WRITE(msgBuf,'(A)')
     &'// ALLOW_RUNOFTEMP:                NOT defined'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
# endif /* ALLOW_RUNOFTEMP */
#else /* ALLOW_RUNOFF */
      WRITE(msgBuf,'(A)')
     &'// ALLOW_RUNOFF:                   NOT defined'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
#endif /* ALLOW_RUNOFF */

C--   Salt-Flux
      IF ( prtBlkLn ) THEN
       CALL PRINT_MESSAGE( blkLin, standardMessageUnit,
     &                     SQUEEZE_RIGHT, myThid )
       prtBlkLn = .FALSE.
      ENDIF
#ifdef ALLOW_SALTFLX
      WRITE(msgBuf,'(A)')
     &'// ALLOW_SALTFLX:                      defined'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      IF ( saltflxfile.NE.' ' ) THEN
       CALL EXF_FLD_SUMMARY( 'Net upward Salt-Flux forcing',
     I      saltflxfile, saltflxRepCycle, saltflxperiod,
     I      saltflxStartTime, useExfYearlyFields, addBlkLn, myThid )
#ifdef USE_EXF_INTERPOLATION
       CALL EXF_PRINT_INTERP( 'saltflx',
     &  saltflx_lon0, saltflx_lon_inc, saltflx_lat0, saltflx_lat_inc,
     &  saltflx_nlon, saltflx_nlat, saltflx_interpMethod, myThid )
#endif
       prtBlkLn = .TRUE.
      ENDIF
#else /* ALLOW_SALTFLX */
      WRITE(msgBuf,'(A)')
     &'// ALLOW_SALTFLX:                  NOT defined'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
#endif /* ALLOW_SALTFLX */

#ifdef ALLOW_DOWNWARD_RADIATION
C--   Downward shortwave.
      IF ( swdownfile.NE.' ' ) THEN
       CALL EXF_FLD_SUMMARY( 'Downward shortwave flux',
     I      swdownfile, swdownRepCycle, swdownperiod,
     I      swdownStartTime, useExfYearlyFields, addBlkLn, myThid )
#ifdef USE_EXF_INTERPOLATION
       CALL EXF_PRINT_INTERP( 'swdown',
     &  swdown_lon0, swdown_lon_inc, swdown_lat0, swdown_lat_inc,
     &  swdown_nlon, swdown_nlat, swdown_interpMethod, myThid )
#endif
       prtBlkLn = .TRUE.
      ENDIF

C--   Downward longwave.
      IF ( lwdownfile.NE.' ' ) THEN
       CALL EXF_FLD_SUMMARY( 'Downward longwave flux',
     I      lwdownfile, lwdownRepCycle, lwdownperiod,
     I      lwdownStartTime, useExfYearlyFields, addBlkLn, myThid )
#ifdef USE_EXF_INTERPOLATION
       CALL EXF_PRINT_INTERP( 'lwdown',
     &  lwdown_lon0, lwdown_lon_inc, lwdown_lat0, lwdown_lat_inc,
     &  lwdown_nlon, lwdown_nlat, lwdown_interpMethod, myThid )
#endif
       prtBlkLn = .TRUE.
      ENDIF
#endif /* ALLOW_DOWNWARD_RADIATION */

#ifdef ATMOSPHERIC_LOADING
C--   Atmospheric pressure.
      IF ( apressurefile.NE.' ' ) THEN
       CALL EXF_FLD_SUMMARY( 'Atmospheric pressure forcing',
     I      apressurefile, apressureRepCycle, apressureperiod,
     I      apressureStartTime, useExfYearlyFields, addBlkLn, myThid )
#ifdef USE_EXF_INTERPOLATION
       CALL EXF_PRINT_INTERP( 'apressure', apressure_lon0,
     &  apressure_lon_inc, apressure_lat0, apressure_lat_inc,
     &  apressure_nlon, apressure_nlat, apressure_interpMethod, myThid )
#endif
       prtBlkLn = .TRUE.
      ENDIF
#endif /* ATMOSPHERIC_LOADING */

#ifdef EXF_ALLOW_TIDES
C--   Tidal geopotential
      IF ( tidePotFile.NE.' ' ) THEN
       CALL EXF_FLD_SUMMARY( 'Tidal geopotential',
     I      tidePotFile, tidePotRepCycle, tidePotPeriod,
     I      tidePotStartTime, useExfYearlyFields, addBlkLn, myThid )
#ifdef USE_EXF_INTERPOLATION
       CALL EXF_PRINT_INTERP( 'tidePot', tidePot_lon0,
     &  tidePot_lon_inc, tidePot_lat0, tidePot_lat_inc,
     &  tidePot_nlon, tidePot_nlat, tidePot_interpMethod, myThid )
#endif
       prtBlkLn = .TRUE.
      ENDIF
#endif /* EXF_ALLOW_TIDES */

#ifdef EXF_SEAICE_FRACTION
C--   Fractional ice-covered area
      IF ( areamaskfile.NE.' ' ) THEN
       CALL EXF_FLD_SUMMARY( 'Fractional ice-covered area',
     I      areamaskfile, areamaskRepCycle, areamaskperiod,
     I      areamaskStartTime, useExfYearlyFields, addBlkLn, myThid )
#ifdef USE_EXF_INTERPOLATION
       CALL EXF_PRINT_INTERP( 'areamask', areamask_lon0,
     &  areamask_lon_inc, areamask_lat0, areamask_lat_inc,
     &  areamask_nlon, areamask_nlat, areamask_interpMethod, myThid )
#endif
       prtBlkLn = .TRUE.
      ENDIF
#endif /* EXF_SEAICE_FRACTION */

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      CALL PRINT_MESSAGE( blkLin, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)')
     &'// ======================================================='
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)')
     &'// External forcing (EXF) climatology configuration :'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)')
     &'// ======================================================='
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      CALL PRINT_MESSAGE( blkLin, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      prtBlkLn = .FALSE.
      addBlkLn = .FALSE.

C     For each data set used the summary prints the calendar data
C     and the corresponding file from which the data will be read.

C     The climatological data sets are assumed to contain monthly
C     data. This can be changed in a later version to an arbitrary
C     number of intervals during a given year.

#ifdef ALLOW_CLIMSST_RELAXATION
      WRITE(msgBuf,'(A)')
     &'// ALLOW_CLIMSST_RELAXATION:           defined'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
C     Relaxation to SST climatology.
      IF ( climsstfile .NE. ' ' ) THEN
       CALL EXF_FLD_SUMMARY( 'Climatological SST',
     I      climsstfile, climsstRepCycle, climsstperiod,
     I      climsstStartTime, useExfYearlyFields, addBlkLn, myThid )
#ifdef USE_EXF_INTERPOLATION
       CALL EXF_PRINT_INTERP( 'climsst',
     &  climsst_lon0, climsst_lon_inc, climsst_lat0, climsst_lat_inc,
     &  climsst_nlon, climsst_nlat, climsst_interpMethod, myThid )
#endif
       prtBlkLn = .TRUE.
      ELSE
       WRITE(msgBuf,'(A)') '   climsst relaxation is NOT used'
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                     SQUEEZE_RIGHT, myThid )
      ENDIF
#else /* ALLOW_CLIMSST_RELAXATION */
      WRITE(msgBuf,'(A)')
     &'// ALLOW_CLIMSST_RELAXATION:       NOT defined'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
#endif /* ALLOW_CLIMSST_RELAXATION */

c     IF ( prtBlkLn ) THEN
       CALL PRINT_MESSAGE( blkLin, standardMessageUnit,
     &                     SQUEEZE_RIGHT, myThid )
c      prtBlkLn = .FALSE.
c     ENDIF

#ifdef ALLOW_CLIMSSS_RELAXATION
      WRITE(msgBuf,'(A)')
     &'// ALLOW_CLIMSSS_RELAXATION:           defined'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
C     Relaxation to SSS climatology.
      IF ( climsssfile .NE. ' ' ) THEN
       CALL EXF_FLD_SUMMARY( 'Climatological SSS',
     I      climsssfile, climsssRepCycle, climsssperiod,
     I      climsssStartTime, useExfYearlyFields, addBlkLn, myThid )
#ifdef USE_EXF_INTERPOLATION
       CALL EXF_PRINT_INTERP( 'climsss',
     &  climsss_lon0, climsss_lon_inc, climsss_lat0, climsss_lat_inc,
     &  climsss_nlon, climsss_nlat, climsss_interpMethod, myThid )
#endif
       prtBlkLn = .TRUE.
      ELSE
       WRITE(msgBuf,'(A)') '   climsss relaxation is NOT used'
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                     SQUEEZE_RIGHT, myThid )
      ENDIF
#else /* ALLOW_CLIMSSS_RELAXATION */
      WRITE(msgBuf,'(A)')
     &'// ALLOW_CLIMSSS_RELAXATION:       NOT defined'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
#endif /* ALLOW_CLIMSSS_RELAXATION */

      CALL PRINT_MESSAGE( blkLin, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)')
     &'// ======================================================='
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)')
     &'// External forcing (EXF) configuration  >>> END <<<'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)')
     &'// ======================================================='
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      CALL PRINT_MESSAGE( blkLin, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )

      _END_MASTER( myThid )

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: EXF_FLD_SUMMARY
C     !INTERFACE:
      SUBROUTINE EXF_FLD_SUMMARY(
     I               fld_fullName, fld_file,
     I               fld_repeatCycle, fld_period, fld_start_time,
     I               useYearlyFields, addBlkLn, myThid )

C     !DESCRIPTION:
C     Print EXF timing parameters for one EXF input field

C     !USES:
      IMPLICIT NONE

#include "EEPARAMS.h"

C     !INPUT PARAMETERS:
C     fld_fullName    :: field full name description (shorter than 32c)
C     fld_file        :: file-name for this field
C     fld_repeatCycle :: time duration of a repeating cycle
C     fld_period      :: time period (in sec) between 2 reccords
C     fld_start_time  :: corresponding starting time (in sec) for this field
C     useYearlyFields :: select if using EXF Yearly-fields or not
C     addBlkLn        :: print blank line before parameter summary
C     myThid          :: My Thread Id number
      CHARACTER*(*) fld_fullName
      CHARACTER*(*) fld_file
      _RL fld_repeatCycle
      _RL fld_period
      _RL fld_start_time
      LOGICAL useYearlyFields
      LOGICAL addBlkLn
      INTEGER myThid

C     !FUNCTIONS:
      INTEGER  ILNBLNK
      EXTERNAL ILNBLNK

C     !LOCAL VARIABLES:
      INTEGER iL, jL
      CHARACTER*(MAX_LEN_MBUF) tmpBuf, msgBuf
      CHARACTER*1 blkLin
CEOP

      blkLin = ' '
      jL = 47

      IF ( addBlkLn ) THEN
       CALL PRINT_MESSAGE( blkLin, standardMessageUnit,
     &                     SQUEEZE_RIGHT, myThid )
      ENDIF
      IF ( fld_period.GT.0. .OR.
     &     (fld_period.EQ.-1. .AND. .NOT.useYearlyFields) ) THEN
       WRITE(tmpBuf,'(3A)') '   ', fld_fullName, ' starts at'
       WRITE(msgBuf,'(A,F12.0)') tmpBuf(1:jL), fld_start_time
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                     SQUEEZE_RIGHT, myThid )
      ENDIF
       WRITE(tmpBuf,'(3A)') '   ', fld_fullName, ' period is'
       WRITE(msgBuf,'(A,F12.0)') tmpBuf(1:jL), fld_period
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                     SQUEEZE_RIGHT, myThid )
c     IF ( fld_period.GT.0. .AND. .NOT.useYearlyFields ) THEN
      IF ( fld_period.GT.0. ) THEN
       iL = ILNBLNK(fld_fullName)
       IF ( iL.LT.28 ) THEN
         WRITE(tmpBuf,'(3A)') '   ', fld_fullName, ' repeat-cycle is'
       ELSE
         WRITE(tmpBuf,'(3A)') '   ', fld_fullName, ' rep-cycle is'
       ENDIF
       WRITE(msgBuf,'(A,F12.0)') tmpBuf(1:jL), fld_repeatCycle
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                     SQUEEZE_RIGHT, myThid )
      ENDIF
       WRITE(msgBuf,'(3A)') '   ', fld_fullName, ' is read from file:'
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                     SQUEEZE_RIGHT, myThid )
       iL = ILNBLNK(fld_file)
       WRITE(msgBuf,'(3A)') '   >> ', fld_file(1:iL), ' <<'
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                     SQUEEZE_RIGHT, myThid )

      RETURN
      END

#ifdef USE_EXF_INTERPOLATION
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: EXF_PRINT_INTERP
C     !INTERFACE:
      SUBROUTINE EXF_PRINT_INTERP( var_name,
     I               var_lon0, var_lon_inc, var_lat0, var_lat_inc,
     I               var_nlon, var_nlat, var_interpMethod, myThid )

C     !DESCRIPTION:
C     Print EXF interpolation parameters for one EXF input field

C     !USES:
      IMPLICIT NONE

#include "EEPARAMS.h"

C     !INPUT PARAMETERS:
C     myThid :: My Thread Id number
      CHARACTER*(*) var_name
      _RL     var_lon0, var_lon_inc, var_lat0
      _RL     var_lat_inc(*)
      INTEGER var_nlon, var_nlat, var_interpMethod
      INTEGER myThid

C     !FUNCTIONS:
c     INTEGER  ILNBLNK
c     EXTERNAL ILNBLNK

C     !LOCAL VARIABLES:
      INTEGER i
      _RL var_min, var_max
      CHARACTER*(MAX_LEN_MBUF) msgBuf
CEOP

      IF ( var_interpMethod.EQ.0 ) THEN
        WRITE(msgBuf,'(3X,A,A,A)')
     &    'assume "',var_name,'" on model-grid (no interpolation)'
        CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                      SQUEEZE_RIGHT , myThid )
      ELSE
        WRITE(msgBuf,'(3X,A,A,A,I3,A)')
     &    'interpolate "',var_name,'" (method=',var_interpMethod,' ):'
        CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                      SQUEEZE_RIGHT , myThid )
C-      print input-field longitude position:
        IF ( ABS(var_lon0).LT.1000. .AND. var_lon_inc.GT.-10.
     &                              .AND. var_lon_inc.LT.100. ) THEN
          WRITE(msgBuf,'(3X,A,F10.5,A,I6,A,F10.7)')
     &    'lon0=', var_lon0, ', nlon=', var_nlon,
     &    ', lon_inc=',var_lon_inc
        ELSE
          WRITE(msgBuf,'(3X,A,1PE10.3,A,I6,A,1PE10.3)')
     &    'lon0=', var_lon0, ', nlon=', var_nlon,
     &    ', lon_inc=',var_lon_inc
        ENDIF
        CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                      SQUEEZE_RIGHT , myThid )
C-      print input-field latitude position:
        var_min = var_lat_inc(1)
        var_max = var_lat_inc(1)
        DO i=1,var_nlat-1
          var_min = MIN( var_lat_inc(i), var_min )
          var_max = MAX( var_lat_inc(i), var_max )
        ENDDO
        IF ( ABS(var_lat0).LT.1000. .AND. var_min.GT.-10.
     &                              .AND. var_max.LT.100. ) THEN
         IF ( var_min.EQ.var_max ) THEN
          WRITE(msgBuf,'(3X,A,F10.5,A,I6,A,F10.7)')
     &    'lat0=', var_lat0, ', nlat=', var_nlat,
     &    ', lat_inc=', var_min
         ELSE
          WRITE(msgBuf,'(3X,A,F10.5,A,I6,A,2F8.5)')
     &    'lat0=', var_lat0, ', nlat=', var_nlat,
     &    ', inc(min,max)=', var_min, var_max
         ENDIF
        ELSE
         IF ( var_min.EQ.var_max ) THEN
          WRITE(msgBuf,'(3X,A,1PE10.3,A,I6,A,1PE10.3)')
     &    'lat0=', var_lat0, ', nlat=', var_nlat,
     &    ', lat_inc=', var_min
         ELSE
          WRITE(msgBuf,'(3X,A,1PE10.3,A,I6,A,1P2E10.3)')
     &    'lat0=', var_lat0, ', nlat=', var_nlat,
     &    ', inc(min,max)=', var_min, var_max
         ENDIF
        ENDIF
        CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                      SQUEEZE_RIGHT , myThid )
      ENDIF

      RETURN
      END
#endif /* USE_EXF_INTERPOLATION */

#include "PACKAGES_CONFIG.h"
#include "CPP_OPTIONS.h"
#include "AD_CONFIG.h"
#ifdef ALLOW_OPENAD
# include "OPENAD_OPTIONS.h"
#endif
#ifdef ALLOW_AUTODIFF
# include "AUTODIFF_OPTIONS.h"
#endif
#ifdef ALLOW_CTRL
# include "CTRL_OPTIONS.h"
#endif
#ifdef ALLOW_STREAMICE
# include "STREAMICE_OPTIONS.h"
#endif

CBOP
C     !ROUTINE: THE_MODEL_MAIN

C     !INTERFACE:
      SUBROUTINE THE_MODEL_MAIN(myThid)

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE THE_MODEL_MAIN
C     | o This is the OpenAD local version of S/R THE_MODEL_MAIN
C     |   see ref. version: model/src/the_model_main.F
C     |   for details about what this routine does.
C     *==========================================================*
C     \ev

C     !CALLING SEQUENCE:
C     THE_MODEL_MAIN()
C       |
C       |
C       |--INITIALISE_FIXED
C       |   o Set model configuration (fixed arrays)
C       |     Topography, hydrography, timestep, grid, etc..
C       |
C       |--CTRL_UNPACK      o Derivative mode. Unpack control vector.
C       |
C       |--ADTHE_MAIN_LOOP  o Main timestepping loop for combined
C       |                     prognostic and reverse mode integration.
C       |
C       |--THE_MAIN_LOOP    o Main timestepping loop for pure prognostic
C       |                     integration.
C       |
C       |--CTRL_PACK        o Derivative mode. Unpack control vector.
C       |
C       |--GRDCHK_MAIN      o Gradient check control routine.
C       |
C       |--TIMER_PRINTALL   o Print out timing statistics.
C       |
C       |--COMM_STATS       o Print out communication statistics.

C     !USES:
      IMPLICIT NONE

C     == Global variables ===
C -->> OpenAD
      use OAD_active
      use OAD_rev
      use OAD_tape
      use OAD_cp
#include "cost.h"
C <<-- OpenAD
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "DYNVARS.h"
#include "FFIELDS.h"

#ifdef ALLOW_CTRL
# include "CTRL_SIZE.h"
# include "CTRL.h"
# include "OPTIMCYCLE.h"
# include "CTRL_GENARR.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     myThid :: Thread number for this instance of the routine.
      INTEGER myThid

C     !FUNCTIONS:
      INTEGER  ILNBLNK
      EXTERNAL ILNBLNK

C     !LOCAL VARIABLES:
C     == Local variables ==
C     Note: Under the multi-threaded model myIter and myTime are local
C           variables passed around as routine arguments.
C           Although this is fiddly it saves the need to impose
C           additional synchronisation points when they are updated.
C     myTime :: Time counter for this thread
C     myIter :: Iteration counter for this thread
      INTEGER myIter
      _RL     myTime
      LOGICAL costFinalExist
      LOGICAL lastdiva
C -->> OpenAD
      _RL foo(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
c     _RL foo2D(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      CHARACTER*(10) suff
      CHARACTER*(MAX_LEN_FNAM) fname
      INTEGER il
c     INTEGER ik
C <<-- OpenAD
CEOP

C--   set default:
      costFinalExist = .TRUE.
      lastdiva = .TRUE.
C -->> OpenAD
C-    Set the execution mode
      our_rev_mode%arg_store=.FALSE.
      our_rev_mode%arg_restore=.FALSE.
      our_rev_mode%res_store=.FALSE.
      our_rev_mode%res_restore=.FALSE.
      our_rev_mode%plain=.TRUE.
      our_rev_mode%tape=.FALSE.
      our_rev_mode%adjoint=.FALSE.
      our_rev_mode%switchedToCheckpoint=.FALSE.
C-    Initialize the tape
      CALL OAD_TAPE_INIT()
C-    Initialize the checkpoint areas
      CALL CP_INIT()
C <<-- OpenAD

#ifdef ALLOW_PETSC
      CALL STREAMICE_INITIALIZE_PETSC
#endif

#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_ENTER('THE_MODEL_MAIN',myThid)
#endif

#if defined(USE_PAPI) || defined(USE_PCL_FLOPS_SFP) || defined(USE_PCL_FLOPS) || defined(USE_PCL)
      CALL TIMER_CONTROL('','INIT','THE_MODEL_MAIN',myThid)
#endif
C--   This timer encompasses the whole code
      CALL TIMER_START('ALL                    [THE_MODEL_MAIN]',myThid)

#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_CALL('INITIALISE_FIXED',myThid)
#endif
C--   Set model configuration (fixed arrays)
      CALL TIMER_START('INITIALISE_FIXED       [THE_MODEL_MAIN]',myThid)
C -->> OpenAD
c     CALL INITIALISE_FIXED( myThid )
      CALL OpenAD_INITIALISE_FIXED( myThid )
C <<-- OpenAD
      CALL TIMER_STOP ('INITIALISE_FIXED       [THE_MODEL_MAIN]',myThid)

      myTime = startTime
      myIter = nIter0

#if ( defined (ALLOW_ADMTLM) )

      STOP 'should never get here; ADMTLM_DSVD calls ADMTLM_DRIVER'

#elif ( defined (ALLOW_AUTODIFF))

# ifdef ALLOW_CTRL
      IF ( useCTRL ) THEN
#  ifndef EXCLUDE_CTRL_PACK
        INQUIRE( file='costfinal', exist=costFinalExist )
        IF ( .NOT. costFinalExist ) THEN
          IF ( (optimcycle.NE.0 .OR. .NOT.doinitxx)
     &         .AND. doMainUnpack ) THEN
            CALL TIMER_START('CTRL_UNPACK   [THE_MODEL_MAIN]',myThid)
            CALL CTRL_UNPACK( .TRUE. , myThid )
            CALL TIMER_STOP ('CTRL_UNPACK   [THE_MODEL_MAIN]',myThid)
          ENDIF
        ENDIF
# endif /* EXCLUDE_CTRL_PACK */
      ENDIF
# endif /* ALLOW_CTRL */

# ifdef ALLOW_COST
      CALL COST_DEPENDENT_INIT ( myThid )
# endif

# if defined( ALLOW_TANGENTLINEAR_RUN )

#  ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_CALL('G_THE_MAIN_LOOP',myThid)
#  endif
      CALL TIMER_START('G_THE_MAIN_LOOP           [TANGENT RUN]',myThid)
      CALL G_THE_MAIN_LOOP ( myTime, myIter, myThid )
      CALL TIMER_STOP ('G_THE_MAIN_LOOP           [TANGENT RUN]',myThid)

# elif defined( ALLOW_ADJOINT_RUN )

#  ifdef ALLOW_DIVIDED_ADJOINT
      STOP 'In (OpenAD) THE_MODEL_MAIN: ALLOW_DIVIDED_ADJOINT not coded'
#  else /* ALLOW_DIVIDED_ADJOINT undef */
#   ifndef ALLOW_OPENAD
#    ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_CALL('ADTHE_MAIN_LOOP',myThid)
#    endif
      CALL TIMER_START('ADTHE_MAIN_LOOP          [ADJOINT RUN]', myThid)
      CALL ADTHE_MAIN_LOOP ( myThid )
      CALL TIMER_STOP ('ADTHE_MAIN_LOOP          [ADJOINT RUN]', myThid)
#   else /* ALLOW_OPENAD defined */
C -->> OpenAD
#   ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_CALL('THE_MAIN_LOOP',myThid)
#   endif
      CALL TIMER_START('THE_MAIN_LOOP (F)      [THE_MODEL_MAIN]',myThid)
      our_rev_mode%plain=.FALSE.
      our_rev_mode%tape=.TRUE.
      CALL TIMERATIO()
      CALL OpenAD_THE_MAIN_LOOP( myTime, myIter, myThid )
      CALL TIMER_STOP ('THE_MAIN_LOOP (F)      [THE_MODEL_MAIN]',myThid)
      CALL TIMER_START('THE_MAIN_LOOP (A)      [THE_MODEL_MAIN]',myThid)
      our_rev_mode%arg_store=.FALSE.
      our_rev_mode%arg_restore=.FALSE.
      our_rev_mode%plain=.FALSE.
      our_rev_mode%tape=.FALSE.
      our_rev_mode%adjoint=.TRUE.
      IF (myProcID .EQ. 0) THEN
        fc%d=1.0
      ENDIF
      CALL TIMERATIO()
      CALL OpenAD_THE_MAIN_LOOP( myTime, myIter, myThid )
      CALL TIMERATIO()
      our_rev_mode%arg_store=.FALSE.
      our_rev_mode%arg_restore=.FALSE.
      our_rev_mode%plain=.TRUE.
      our_rev_mode%tape=.FALSE.
      our_rev_mode%adjoint=.FALSE.
      WRITE(suff,'(I10.10)') optimcycle
#   ifndef ALLOW_OPENAD_ACTIVE_READ_XYZ
#   ifdef ALLOW_DIFFKR_CONTROL
      foo=diffkr%d
      il=ILNBLNK( xx_diffkr_file )
      write(fname,'(4a)') 'ad', xx_diffkr_file(1:il), '.', suff
      CALL WRITE_REC_3D_RL(fname,ctrlprec,Nr,foo,1,myIter,myThid)
#   endif
#   endif /* ALLOW_OPENAD_ACTIVE_READ_XYZ */

cc#   ifdef ALLOW_GENARR2D_CONTROL
cc      do ik = 1, maxCtrlArr2D
cc        foo2d=xx_genarr2d(:,:,:,:,ik)%d
cc        write(fname,'(A,I2.2,A)') 'adxx_genarr2d_',ik,'.'
cc        call write_fld_xy_rl(fname,suff,foo2D,myIter,1)
cc      enddo
cc#   endif
cc#   ifdef ALLOW_GENTIM2D_CONTROL
cc      do ik = 1, maxCtrlTim2D
cc        foo2d=xx_gentim2d(:,:,:,:,ik)%d
cc        write(fname,'(A,I2.2,A)') 'adxx_gentim2d_',ik,'.'
cc        call write_fld_xy_rl(fname,suff,foo2D,myIter,1)
cc      enddo
cc#   endif
cc#   ifdef ALLOW_GENARR3D_CONTROL
cc      do ik = 1, maxCtrlArr3D
cc        foo=xx_genarr3d(:,:,:,:,:,ik)%d
cc        write(fname,'(A,I2.2,A)') 'adxx_genarr3d_',ik,'.'
cc        call write_fld_xyz_rl(fname,suff,foo,myIter,1)
cc      enddo
cc#   endif
      our_rev_mode%plain=.TRUE.
      our_rev_mode%tape=.FALSE.
      our_rev_mode%adjoint=.FALSE.
      CALL TIMER_STOP ('THE_MAIN_LOOP (A)      [THE_MODEL_MAIN]',myThid)

C <<-- OpenAD
#   endif /* ALLOW_OPENAD */
#  endif /* ALLOW_DIVIDED_ADJOINT */

# else /* forward run only within AD setting */

#  ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_CALL('THE_MAIN_LOOP',myThid)
#  endif
C--   Call time stepping loop of full model
      CALL TIMER_START('THE_MAIN_LOOP          [THE_MODEL_MAIN]',myThid)
      CALL THE_MAIN_LOOP( myTime, myIter, myThid )
      CALL TIMER_STOP ('THE_MAIN_LOOP          [THE_MODEL_MAIN]',myThid)

# endif /* forward run only within AD setting */

# ifdef ALLOW_CTRL
# ifndef EXCLUDE_CTRL_PACK
#  ifdef ALLOW_OPENAD
cph-- ad hoc fix for OpenAD time stepping counter lagging one step
cph-- after final adjoint step
      myIter=nIter0
#  endif
      IF ( useCTRL .AND. lastdiva .AND. doMainPack ) THEN
        CALL TIMER_START('CTRL_PACK           [THE_MODEL_MAIN]',myThid)
        CALL CTRL_PACK( .FALSE. , myThid )
        CALL TIMER_STOP ('CTRL_PACK           [THE_MODEL_MAIN]',myThid)
        IF ( ( optimcycle.EQ.0 .OR. (.NOT. doMainUnpack) )
     &       .AND. myIter.EQ.nIter0 ) THEN
          CALL TIMER_START('CTRL_PACK     [THE_MODEL_MAIN]',myThid)
          CALL CTRL_PACK( .TRUE. , myThid )
          CALL TIMER_STOP ('CTRL_PACK     [THE_MODEL_MAIN]',myThid)
        ENDIF
      ENDIF
# endif /* EXCLUDE_CTRL_PACK */
# endif /* ALLOW_CTRL */

# ifdef ALLOW_GRDCHK
      IF ( useGrdchk .AND. lastdiva ) THEN
        CALL TIMER_START('GRDCHK_MAIN         [THE_MODEL_MAIN]',myThid)
        CALL GRDCHK_MAIN( myThid )
        CALL TIMER_STOP ('GRDCHK_MAIN         [THE_MODEL_MAIN]',myThid)
      ENDIF
# endif

#else /* ALL AD-related undef */

# ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_CALL('THE_MAIN_LOOP',myThid)
# endif
C--   Call time stepping loop of full model
      CALL TIMER_START('THE_MAIN_LOOP          [THE_MODEL_MAIN]',myThid)
      CALL THE_MAIN_LOOP( myTime, myIter, myThid )
      CALL TIMER_STOP ('THE_MAIN_LOOP          [THE_MODEL_MAIN]',myThid)

#endif /* ALLOW_TANGENTLINEAR_RUN ALLOW_ADJOINT_RUN ALLOW_ADMTLM */

#ifdef ALLOW_PETSC
      CALL STREAMICE_FINALIZE_PETSC
#endif

#ifdef ALLOW_MNC
      IF (useMNC) THEN
C       Close all open NetCDF files
        _BEGIN_MASTER( myThid )
        CALL MNC_FILE_CLOSE_ALL( myThid )
        _END_MASTER( myThid )
      ENDIF
#endif

C--   This timer encompasses the whole code
      CALL TIMER_STOP ('ALL                    [THE_MODEL_MAIN]',myThid)

C--   Write timer statistics
      IF ( myThid .EQ. 1 ) THEN
        CALL TIMER_PRINTALL( myThid )
        CALL COMM_STATS
      ENDIF

C--   Check threads synchronization :
      CALL BAR_CHECK( 9, myThid )

#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_LEAVE('THE_MODEL_MAIN',myThid)
#endif

      RETURN
      END

#include "CTRL_OPTIONS.h"

CBOP
C     !ROUTINE: CTRL_INIT_FIXED
C     !INTERFACE:
      SUBROUTINE CTRL_INIT_FIXED( myThid )

C     !DESCRIPTION: \bv
C     *=================================================================
C     | SUBROUTINE CTRL_INIT_FIXED
C     | o Define the vector of control variables
C     *=================================================================
C     \ev

C     !USES:
      IMPLICIT NONE

C     === Global variables ===
#include "EEPARAMS.h"
#include "SIZE.h"
#include "PARAMS.h"
#include "GRID.h"
#ifdef ALLOW_CTRL
# include "CTRL_SIZE.h"
# include "CTRL.h"
# include "CTRL_GENARR.h"
# include "CTRL_OBCS.h"
#endif
#ifdef ALLOW_CAL
# include "cal.h"
#endif
#ifdef ALLOW_DIC_CONTROL
# include "DIC_CTRL.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     myThid     :: my Thread Id number
      INTEGER myThid

C     !FUNCTIONS:
#ifdef ALLOW_GENTIM2D_CONTROL
      INTEGER  ILNBLNK
      EXTERNAL ILNBLNK
#endif
#ifdef ALLOW_OBCS_CONTROL_MODES
      INTEGER  MDS_RECLEN
      EXTERNAL MDS_RECLEN
#endif

C     !LOCAL VARIABLES:
C     msgBuf     :: Informational/error message buffer
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      INTEGER bi, bj
      INTEGER i, j, k
      INTEGER ivar, iarr
      LOGICAL costFinalExist
      _RL dummy
      _RL loctmp3d (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)

#if ( defined ALLOW_GENTIM2D_CONTROL || \
      defined ALLOW_GENARR2D_CONTROL || \
      defined ALLOW_GENARR3D_CONTROL )
      CHARACTER*(1) ncvargrdtmp
#endif
#ifdef ALLOW_GENTIM2D_CONTROL
      CHARACTER*(MAX_LEN_FNAM) fnamegen
      INTEGER ilgen, k2, diffrecFull, endrecFull
      INTEGER diffrec, startrec, endrec
#elif ( defined ALLOW_OBCS_CONTROL )
      INTEGER diffrec, startrec, endrec
#endif

#ifdef ALLOW_OBCS_CONTROL_MODES
      INTEGER  length_of_rec, dUnit
#endif
CEOP

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C--     Set default values.
      DO ivar = 1,maxcvars
       ncvarindex(ivar) = -1
       ncvarrecs(ivar)  =  0
       ncvarxmax(ivar)  =  0
       ncvarymax(ivar)  =  0
       ncvarnrmax(ivar) =  0
       ncvargrd(ivar)   = '?'
       ncvartype(ivar)  = '?'
       ncvarfname(ivar) = ' '
      ENDDO

C     Set unit weight to 1
      DO bj=1,nSy
       DO bi=1,nSx
        DO k=1,Nr
          wunit(k,bi,bj) = 1. _d 0
          DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
             loctmp3d(i,j,k,bi,bj) = 1. _d 0
           ENDDO
          ENDDO
        ENDDO
       ENDDO
      ENDDO

#ifdef ALLOW_AUTODIFF
      CALL active_write_xyz( 'wunit', loctmp3d, 1, 0, myThid, dummy)
#else
      CALL WRITE_REC_XYZ_RL( 'wunit', loctmp3d, 1, 1, myThid )
#endif

#ifdef CTRL_DO_PACK_UNPACK_ONLY
      costFinalExist = .FALSE.
#else /* CTRL_DO_PACK_UNPACK_ONLY */
c     _BEGIN_MASTER( myThid )
      INQUIRE( FILE='costfinal', EXIST=costFinalExist )
c     _END_MASTER( myThid )
#endif /* CTRL_DO_PACK_UNPACK_ONLY */

      _BARRIER

      ivar = 0
C--   ===========================
C--   Open boundary contributions.
C--   ===========================

C----------------------------------------------------------------------

#ifdef ALLOW_OBCSN_CONTROL
C--   Northern obc.
      CALL CTRL_INIT_REC ( xx_obcsN_file,
     I     xx_obcsNstartdate1, xx_obcsNstartdate2, xx_obcsNperiod, 4,
     O     xx_obcsNstartdate, diffrec, startrec, endrec,
     I     myThid )
      ivar = ivar + 1
      iarr = 1
      CALL CTRL_INIT_CTRLVAR (
     I     xx_obcsN_file, ivar, iarr, diffrec, startrec, endrec,
     I     sNx, 1, Nr, 'm', 'SecXZ', costFinalExist, myThid )
#endif /* ALLOW_OBCSN_CONTROL */

C----------------------------------------------------------------------

#ifdef ALLOW_OBCSS_CONTROL
C--   Southern obc.
      CALL CTRL_INIT_REC ( xx_obcsS_file,
     I     xx_obcsSstartdate1, xx_obcsSstartdate2, xx_obcsSperiod, 4,
     O     xx_obcsSstartdate, diffrec, startrec, endrec,
     I     myThid )
      ivar = ivar+1
      iarr = 2
      CALL CTRL_INIT_CTRLVAR (
     I     xx_obcsS_file, ivar, iarr, diffrec, startrec, endrec,
     I     sNx, 1, Nr, 'm', 'SecXZ', costFinalExist, myThid )
#endif /* ALLOW_OBCSS_CONTROL */

C----------------------------------------------------------------------

#ifdef ALLOW_OBCSW_CONTROL
C--   Western obc.
      CALL CTRL_INIT_REC ( xx_obcsW_file,
     I     xx_obcsWstartdate1, xx_obcsWstartdate2, xx_obcsWperiod, 4,
     O     xx_obcsWstartdate, diffrec, startrec, endrec,
     I     myThid )
      ivar = ivar+1
      iarr = 4
      CALL CTRL_INIT_CTRLVAR (
     I     xx_obcsW_file, ivar, iarr, diffrec, startrec, endrec,
     I     1, sNy, Nr, 'm', 'SecYZ', costFinalExist, myThid )
#endif  /* ALLOW_OBCSW_CONTROL */

C----------------------------------------------------------------------

#ifdef ALLOW_OBCSE_CONTROL
C--   Eastern obc.
      CALL CTRL_INIT_REC ( xx_obcsE_file,
     I     xx_obcsEstartdate1, xx_obcsEstartdate2, xx_obcsEperiod, 4,
     O     xx_obcsEstartdate, diffrec, startrec, endrec,
     I     myThid )
      ivar = ivar+1
      iarr = 3
      CALL CTRL_INIT_CTRLVAR (
     I     xx_obcsE_file, ivar, iarr, diffrec, startrec, endrec,
     I     1, sNy, Nr, 'm', 'SecYZ', costFinalExist, myThid )
#endif /* ALLOW_OBCSE_CONTROL */

C----------------------------------------------------------------------

#ifdef ALLOW_OBCS_CONTROL_MODES
Cih  Get matrices for reconstruction from barotropic-barclinic modes
CMM  To use modes now hardcoded with ECCO_CPPOPTION.  Would be good to have
C     run-time option and also define filename=baro_invmodes.bin
        CALL MDSFINDUNIT( dUnit, myThid )
        length_of_rec = MDS_RECLEN( 64, Nr*Nr, myThid )
        OPEN( dUnit, FILE='baro_invmodes.bin', STATUS='old',
     &         ACCESS='direct', RECL=length_of_rec )
        DO j = 1,Nr
           READ(dUnit,rec=j) ((modesv(k,i,j), k=1,Nr), i=1,Nr)
        ENDDO
        CLOSE( dUnit )
CMM  double precision modesv is size [NR,NR,NR]
C     dim one is z-space
C     dim two is mode space
C     dim three is the total depth for which this set of modes applies
C     so for example modesv(:,2,nr) will be the second mode
C     in z-space for the full model depth
C    The modes are to be orthogonal when weighted by dz.
C     i.e. if f_i(z) = mode i, sum_j(f_i(z_j)*f_j(z_j)*dz_j = delta_ij
C    first mode should also be constant in depth...barotropic
C    For a matlab code example how to construct the orthonormal modes,
C     which are ideally the solution of planetary vertical mode equation
C     using model mean dRho/dz, see
C     MITgcm/verification/obcs_ctrl/input/gendata.m
C    This code is compatible with partial cells
#endif /* ALLOW_OBCS_CONTROL_MODES */

C----------------------------------------------------------------------

#ifdef ALLOW_GENARR2D_CONTROL
      DO iarr = 1, maxCtrlArr2D
       ncvargrdtmp='c'
# ifdef ALLOW_SHELFICE
C      Under iceshelf, use maskSHI for these
       IF ((xx_genarr2d_file(iarr)(1:11).EQ.'xx_shicoeff').OR.
     &     (xx_genarr2d_file(iarr)(1:11).EQ.'xx_shicdrag')) THEN
         ncvargrdtmp='i'
       ENDIF
# endif

#ifndef ALLOW_OPENAD
       IF (xx_genarr2d_weight(iarr).NE.' ') THEN
#endif
        ivar = ivar+1
        CALL CTRL_INIT_CTRLVAR (
     I       xx_genarr2d_file(iarr),
     I       ivar, iarr, 1, 1, 1,
     I       sNx, sNy, 1, ncvargrdtmp, 'Arr2D', costFinalExist,
     I       myThid )
#ifndef ALLOW_OPENAD
       ENDIF
#endif
      ENDDO
#endif /* ALLOW_GENARR2D_CONTROL */

C----------------------------------------------------------------------

#ifdef ALLOW_GENARR3D_CONTROL
      DO iarr = 1, maxCtrlArr3D
       ncvargrdtmp='c'
#ifndef ALLOW_OPENAD
       IF (xx_genarr3d_weight(iarr).NE.' ') THEN
#endif
        ivar = ivar+1
        CALL CTRL_INIT_CTRLVAR (
     I       xx_genarr3d_file(iarr),
     I       ivar, iarr, 1, 1, 1,
     I       sNx, sNy, Nr, ncvargrdtmp, 'Arr3D', costFinalExist,
     I       myThid )
#ifndef ALLOW_OPENAD
       ENDIF
#endif
      ENDDO
#endif /* ALLOW_GENARR3D_CONTROL */

C----------------------------------------------------------------------

#ifdef ALLOW_GENTIM2D_CONTROL
      DO iarr = 1, maxCtrlTim2D

#ifdef ALLOW_CAL
       IF (xx_gentim2d_startdate1(iarr).EQ.0) THEN
          xx_gentim2d_startdate1(iarr)=startdate_1
          xx_gentim2d_startdate2(iarr)=startdate_2
       ENDIF
#endif
       ncvargrdtmp='c'
# ifdef ALLOW_SHELFICE
C      Under iceshelf, use maskSHI for these
       IF (xx_gentim2d_file(iarr)(1:11).EQ.'xx_shifwflx')
     &       ncvargrdtmp='i'
# endif
       IF (xx_gentim2d_file(iarr)(1:5).EQ.'xx_fu')
     &       ncvargrdtmp='w'
       IF (xx_gentim2d_file(iarr)(1:5).EQ.'xx_fv')
     &       ncvargrdtmp='s'

       CALL CTRL_INIT_REC ( xx_gentim2d_file(iarr),
     I       xx_gentim2d_startdate1(iarr),
     I       xx_gentim2d_startdate2(iarr),
     I       xx_gentim2d_period(iarr),
     I       1,
     O       xx_gentim2d_startdate(1,iarr),
     O       diffrec, startrec, endrec,
     I       myThid )

#ifndef ALLOW_OPENAD
       IF (xx_gentim2d_weight(iarr).NE.' ') THEN
#endif
        DO k2 = 1, maxCtrlProc
         IF (xx_gentim2d_preproc(k2,iarr).EQ.'replicate')
     &    xx_gentim2d_preproc(k2,iarr)='docycle'
         IF (xx_gentim2d_preproc(k2,iarr).EQ.'doglomean')
     &    xx_gentim2d_glosum(iarr)     = .TRUE.
         IF (xx_gentim2d_preproc(k2,iarr).EQ.'documul')
     &    xx_gentim2d_cumsum(iarr)     = .TRUE.
        ENDDO

        diffrecFull=diffrec
        endrecFull=endrec
        DO k2 = 1, maxCtrlProc
          IF (xx_gentim2d_preproc(k2,iarr).EQ.'docycle') THEN
           IF (xx_gentim2d_preproc_i(k2,iarr).NE.0) THEN
            diffrec=min(diffrec,xx_gentim2d_preproc_i(k2,iarr))
            endrec=min(endrec,xx_gentim2d_preproc_i(k2,iarr))
           ENDIF
          ENDIF
        ENDDO

        ivar = ivar+1
        ilgen = ILNBLNK( xx_gentim2d_file(iarr) )
        WRITE(fnamegen,'(2a)')
     &       xx_gentim2d_file(iarr)(1:ilgen),'.effective'
        CALL CTRL_INIT_CTRLVAR (
     I       fnamegen,
     I       0, iarr,
     I       diffrecFull, startrec, endrecFull,
     I       sNx, sNy, 1, ncvargrdtmp, 'Tim2D', costFinalExist,
     I       myThid )

        WRITE(fnamegen,'(2a)')
     &       xx_gentim2d_file(iarr)(1:ilgen),'.tmp'
        CALL CTRL_INIT_CTRLVAR (
     I       fnamegen,
     I       0, iarr,
     I       diffrecFull, startrec, endrecFull,
     I       sNx, sNy, 1, ncvargrdtmp, 'Tim2D', costFinalExist,
     I       myThid )

C     The length of adxx-files needs to be 1:endrec
        CALL CTRL_INIT_CTRLVAR (
     I       xx_gentim2d_file(iarr),
     I       ivar, iarr,
     I       endrec, 1, endrec,
     I       sNx, sNy, 1, ncvargrdtmp, 'Tim2D', costFinalExist,
     I       myThid )

#ifndef ALLOW_OPENAD
       ENDIF
#endif

      ENDDO
#endif /* ALLOW_GENTIM2D_CONTROL */

C----------------------------------------------------------------------

C--   short report before calling INIT_WET:
      WRITE(msgBuf,'(2A,I4,A)') 'CTRL_INIT_FIXED: ',
     &     'ivar=', ivar, ' = number of CTRL variables defined'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)') ' '
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )

C----------------------------------------------------------------------

      CALL CTRL_INIT_WET( myThid )

#ifdef ALLOW_DIC_CONTROL
      DO i = 1, dic_n_control
       xx_dic(i) = 0. _d 0
      ENDDO
#endif

C----------------------------------------------------------------------

      _BARRIER

C--   Summarize the CTRL package setup.
      _BEGIN_MASTER( myThid )
      CALL CTRL_SUMMARY( myThid )
      _END_MASTER( myThid )

      RETURN
      END

#include "DIAG_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 0
C     !ROUTINE: DIAGNOSTICS_CHECK

C     !INTERFACE:
      SUBROUTINE DIAGNOSTICS_CHECK(myThid)

C     !DESCRIPTION:
C     Check option and parameter consistency

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "DIAGNOSTICS_SIZE.h"
#include "DIAGNOSTICS_P2SHARE.h"
#include "DIAGNOSTICS.h"

C     !INPUT PARAMETERS:
      INTEGER myThid
CEOP

C     !LOCAL VARIABLES:
C     msgBuf     :: Informational/error message buffer
C     errCount   :: Error counter
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      INTEGER errCount
      INTEGER ld,md,nd
      INTEGER k,m
      INTEGER jpoint1, ipoint1, jpoint2, ipoint2
      _RL     margin

      _BEGIN_MASTER(myThid)
      errCount = 0

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C     Check diagnostics parameter consistency

      IF ( useMissingValue .AND. .NOT. diag_mnc ) THEN
        WRITE(msgBuf,'(2A)') '** WARNING ** DIAGNOSTICS_CHECK: ',
     &            'ignore "useMissingValue" since "diag_mnc" is off'
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                      SQUEEZE_RIGHT , myThid )
      ENDIF

      IF ( diag_mnc.AND.(diagMdsDir.NE.' ') ) THEN
        WRITE(msgBuf,'(A,A)') 'S/R DIAGNOSTICS_CHECK: diagMdsDir ',
     &       'and pkg/mnc cannot be used together'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF

      IF ( (mdsioLocalDir.NE.' ').AND.(diagMdsDir.NE.' ') ) THEN
        WRITE(msgBuf,'(A)')
     &   'S/R DIAGNOSTICS_CHECK: mdsioLocalDir and diagMdsDir cannot be'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(A)')
     &   'S/R DIAGNOSTICS_CHECK: specified at the same time'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF

#ifdef DIAGNOSTICS_HAS_PICKUP
      IF ( diag_pickup_read ) THEN
        WRITE(msgBuf,'(2A)') '**CAUTION** (DIAGNOSTICS_CHECK): ',
     &   'reading diagnostics previous state'
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &       SQUEEZE_RIGHT , myThid)
        WRITE(msgBuf,'(2A)') '**CAUTION** ',
     &   ' from a pickup file can only work if data.diagnostics'
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &       SQUEEZE_RIGHT , myThid)
        WRITE(msgBuf,'(2A)') '**CAUTION** ',
     &   ' is not changed (<= further checking not yet implemented)'
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &       SQUEEZE_RIGHT , myThid)
      ENDIF
#else /* undef DIAGNOSTICS_HAS_PICKUP */
C-    stop if trying to use part of the code that is not compiled:
      IF ( diag_pickup_read  ) THEN
        WRITE(msgBuf,'(3A)') 'DIAGNOSTICS_CHECK: ',
     &   'diag_pickup_read  is TRUE ',
     &   'but DIAGNOSTICS_HAS_PICKUP is "#undef"'
        CALL PRINT_ERROR( msgBuf , myThid)
        errCount = errCount + 1
      ENDIF
      IF ( diag_pickup_write ) THEN
        WRITE(msgBuf,'(3A)') 'DIAGNOSTICS_CHECK: ',
     &   'diag_pickup_write is TRUE ',
     &   'but DIAGNOSTICS_HAS_PICKUP is "#undef"'
        CALL PRINT_ERROR( msgBuf , myThid)
        errCount = errCount + 1
      ENDIF
#endif /* DIAGNOSTICS_HAS_PICKUP */

C-    File names:
      DO ld = 2,nlists
       DO m = 1,ld-1
        IF ( fnames(ld).EQ.fnames(m) ) THEN
         WRITE(msgBuf,'(2A)') 'DIAGNOSTICS_CHECK: ',
     &            'found 2 identical file-names:'
         CALL PRINT_ERROR( msgBuf , myThid )
         WRITE(msgBuf,'(2A,I5,2A)') 'DIAGNOSTICS_CHECK: ',
     &    '1rst (m=', m, ' ): ', fnames(m)
         CALL PRINT_ERROR( msgBuf , myThid )
         WRITE(msgBuf,'(2A,I5,2A)') 'DIAGNOSTICS_CHECK: ',
     &    ' 2nd (n=', ld, ' ): ', fnames(ld)
         CALL PRINT_ERROR( msgBuf , myThid )
         errCount = errCount + 1
        ENDIF
       ENDDO
      ENDDO

      DO ld = 2,diagSt_nbLists
       DO m = 1,ld-1
        IF ( diagSt_Fname(ld).EQ.diagSt_Fname(m) ) THEN
         WRITE(msgBuf,'(2A)') 'DIAGNOSTICS_CHECK: ',
     &            'found 2 identical stat_fName:'
         CALL PRINT_ERROR( msgBuf , myThid )
         WRITE(msgBuf,'(2A,I5,2A)') 'DIAGNOSTICS_CHECK: ',
     &    '1rst (m=', m, ' ): ', diagSt_Fname(m)
         CALL PRINT_ERROR( msgBuf , myThid )
         WRITE(msgBuf,'(2A,I5,2A)') 'DIAGNOSTICS_CHECK: ',
     &    ' 2nd (n=', ld, ' ): ', diagSt_Fname(ld)
         CALL PRINT_ERROR( msgBuf , myThid )
         errCount = errCount + 1
        ENDIF
       ENDDO
      ENDDO

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C-    Check for field that appears 2 times (or more) with differents frequency:
C     disable this checking since now diagnostics pkg can handle this case.

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C--   Vertical Interpolation: check for compatibility:
C     better to stop here, rather much later, when trying to write output
      DO ld = 1,nlists
       IF ( fflags(ld)(2:2).EQ.'P' ) THEN
        IF ( fluidIsAir ) THEN
C-    check that interpolated levels are >0 & fall within the domain +/- X %
C      (needs p>0 for p^kappa ; here take a 10 % margin)
          margin = rkSign*(rF(Nr+1)-rF(1))*0.1 _d 0
          DO k=1,nlevels(ld)
           IF ( levs(k,ld)-MAX(rF(1),rF(Nr+1)).GT.margin
     &     .OR. levs(k,ld)-MIN(rF(1),rF(Nr+1)).LT.-margin
     &     .OR. levs(k,ld).LE.0. ) THEN

            WRITE(msgBuf,'(2A,I5,2A)') 'DIAGNOSTICS_CHECK: ',
     &       'Vertical Interp. for list l=', ld,
     &       ', fileName: ', fnames(ld)
            CALL PRINT_ERROR( msgBuf , myThid )
            WRITE(msgBuf,'(2A,I4,3(A,F16.8))') 'DIAGNOSTICS_CHECK: ',
     &       ' lev(k=', k, ') p=', levs(k,ld),
     &       ' not in the domain:',rF(1),' :',rF(Nr+1)
            CALL PRINT_ERROR( msgBuf , myThid )
            errCount = errCount + 1
           ENDIF
          ENDDO
        ELSE
C-    p^kappa interpolation: meaningfull only if Atmosphere & P-coordiante
          WRITE(msgBuf,'(2A)') 'DIAGNOSTICS_CHECK: ',
     &       'INTERP_VERT not allowed in this config'
          CALL PRINT_ERROR( msgBuf , myThid )
           WRITE(msgBuf,'(2A,I5,2A)') 'DIAGNOSTICS_CHECK: ',
     &       ' for list l=', ld, ', fileName: ', fnames(ld)
          CALL PRINT_ERROR( msgBuf , myThid )
          errCount = errCount + 1
        ENDIF
        IF (select_rStar.GT.0) THEN
C-    If nonlinear free surf is active, need averaged pressures
         DO md = 1,nfields(ld)
          nd = ABS(jdiag(md,ld))
          CALL DIAGNOSTICS_GET_POINTERS( 'RSURF   ', ld,
     &                                   jpoint1, ipoint1, myThid )
          IF ( useFIZHI .AND.
     &          gdiag(nd)(10:10) .EQ. 'L') THEN
           CALL DIAGNOSTICS_GET_POINTERS('FIZPRES ', ld,
     &                                   jpoint2, ipoint2, myThid )
          ELSE
           CALL DIAGNOSTICS_GET_POINTERS('RCENTER ', ld,
     &                                   jpoint2, ipoint2, myThid )
          ENDIF
          IF ( ipoint1.EQ.0 .OR. ipoint2.EQ.0 ) THEN
            WRITE(msgBuf,'(2A,I5)') 'DIAGNOSTICS_CHECK: ',
     &      'to interpolate diags from output list:', ld
            CALL PRINT_ERROR( msgBuf , myThid )
            IF ( ipoint1.EQ.0 .AND. jpoint1.EQ.0 ) THEN
              WRITE(msgBuf,'(3A)') 'DIAGNOSTICS_CHECK: ',
     &        'needs to turn ON surface pressure diagnostic "RSURF   "'
              CALL PRINT_ERROR( msgBuf , myThid )
            ELSEIF ( ipoint1.EQ.0 ) THEN
              WRITE(msgBuf,'(3A)') 'DIAGNOSTICS_CHECK: ',
     &        'needs surface pressure diagnostic "RSURF   " ',
     &        'with same output time'
              CALL PRINT_ERROR( msgBuf , myThid )
            ENDIF
            IF ( ipoint2.EQ.0 .AND. jpoint2.EQ.0 ) THEN
              WRITE(msgBuf,'(3A)') 'DIAGNOSTICS_CHECK: ',
     &        'needs to turn ON  3-D pressure diagnostic "RCENTER "'
              CALL PRINT_ERROR( msgBuf , myThid )
            ELSEIF ( ipoint2.EQ.0 ) THEN
              WRITE(msgBuf,'(3A)') 'DIAGNOSTICS_CHECK: ',
     &        'needs  3-D pressure diagnostic "RCENTER " ',
     &        'with same output time'
              CALL PRINT_ERROR( msgBuf , myThid )
            ENDIF
            errCount = errCount + 1
          ENDIF
         ENDDO
        ENDIF
       ENDIF
      ENDDO

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C     To print adjoint variables through diagnostics package, must keep
C     fwd and adjoint variables separate within lists.
C     Here: Check to see if variables are mixed, stop if so
      IF ( useDiag4AdjOutp ) THEN
       DO ld = 1,nlists
        nd = ABS(jdiag(1,ld))
        IF (gdiag(nd)(4:4).EQ.'A') THEN
         DO md = 1,nfields(ld)
          nd = ABS(jdiag(md,ld))
          IF (gdiag(nd)(4:4).NE.'A') THEN
            WRITE(msgBuf,'(2A)') 'DIAGNOSTICS_CHECK: ',
     &        'Cannot define forward and adjoint variables within the'
            CALL PRINT_ERROR( msgBuf , myThid )
            WRITE(msgBuf,'(2A,I5,2A)') 'DIAGNOSTICS_CHECK: ',
     &       ' same diag list, l=', ld, ', fileName: ', fnames(ld)
            CALL PRINT_ERROR( msgBuf , myThid )
            errCount = errCount + 1
          ENDIF
         ENDDO
        ELSE
         DO md = 1,nfields(ld)
          nd = ABS(jdiag(md,ld))
          IF (gdiag(nd)(4:4).EQ.'A') THEN
            WRITE(msgBuf,'(2A)') 'DIAGNOSTICS_CHECK: ',
     &        'Cannot define forward and adjoint variables within the'
            CALL PRINT_ERROR( msgBuf , myThid )
            WRITE(msgBuf,'(2A,I5,2A)') 'DIAGNOSTICS_CHECK: ',
     &       ' same diag list, l=', ld, ', fileName: ', fnames(ld)
            CALL PRINT_ERROR( msgBuf , myThid )
            errCount = errCount + 1
          ENDIF
         ENDDO
        ENDIF
       ENDDO
      ENDIF
C-    for now, adjoint variable diagnostics not implemented for stats-diags
      DO ld = 1,diagSt_nbLists
       DO md=1,diagSt_nbFlds(ld)
        nd = ABS(jSdiag(md,ld))
        IF ( gdiag(nd)(4:4).EQ.'A' ) THEN
         WRITE(msgBuf,'(4A,I5,2A)') 'DIAGNOSTICS_CHECK: ',
     &    'Adj-diag "', diagSt_Flds(md,ld), '" in list ld=', ld,
     &    ', stat_fName: ', diagSt_Fname(ld)
         CALL PRINT_ERROR( msgBuf , myThid )
         WRITE(msgBuf,'(2A)') 'DIAGNOSTICS_CHECK: ',
     &    'but Adj-Var diagnostic not coded for Stats-Diags output'
         CALL PRINT_ERROR( msgBuf , myThid )
         errCount = errCount + 1
        ENDIF
       ENDDO
      ENDDO

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      IF ( errCount.GE.1 ) THEN
        WRITE(msgBuf,'(A,I5,A)')
     &     'DIAGNOSTICS_CHECK: detected', errCount,' fatal error(s)'
        CALL PRINT_ERROR( msgBuf, myThid )
        CALL ALL_PROC_DIE( 0 )
        STOP 'ABNORMAL END: S/R DIAGNOSTICS_CHECK'
      ENDIF

      _END_MASTER(myThid)

      RETURN
      END

#include "OBSFIT_OPTIONS.h"

CBOP
C     !ROUTINE: OBSFIT_INI_IO

C     !INTERFACE:
      SUBROUTINE OBSFIT_INI_IO( myThid )

C     !DESCRIPTION:
C     ==================================================================
C     | Create directory for obsfit output if needed
C     ==================================================================

C     !USES:
      IMPLICIT NONE
C     == Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "EESUPPORT.h"
#include "PARAMS.h"
#include "OBSFIT_SIZE.h"
#include "OBSFIT.h"

C     !INPUT PARAMETERS:
C     myThid :: my thread ID number
      INTEGER myThid

C     !FUNCTIONS
      INTEGER  ILNBLNK
      EXTERNAL ILNBLNK
CEOP

#ifdef ALLOW_OBSFIT
C !LOCAL VARIABLES:
#ifndef HAVE_SYSTEM
      CHARACTER*(MAX_LEN_MBUF) msgBuf
#endif
      CHARACTER*(MAX_LEN_FNAM) namBuf
      INTEGER iL, pIL

      _BEGIN_MASTER( myThid )

      IF ( obsfitDir .NE. ' ' ) THEN
        iL = ILNBLNK( obsfitDir )
C Append "/", if necessary
        IF ( iL.LT.MAX_LEN_FNAM .AND. obsfitDir(iL:iL).NE.'/' ) THEN
          namBuf(1:iL) = obsfitDir(1:iL)
          WRITE(obsfitDir(1:iL+1),'(2A)') namBuf(1:iL),'/'
        ENDIF
#ifdef HAVE_SYSTEM
C Create directory
        iL = ILNBLNK( obsfitDir ) -1
        WRITE( namBuf,'(2A)' ) ' mkdir -p ', obsfitDir(1:iL)
        pIL = 1 + ILNBLNK( namBuf )
        WRITE( standardMessageUnit,'(3A)' )
     &  '==> SYSTEM CALL (from OBSFIT_INI_IO): >',namBuf(1:pIL),'<'
        CALL SYSTEM( namBuf(1:pIL) )
#else
        WRITE( msgBuf,'(2A)' ) '** WARNING ** OBSFIT_INI_IO: cannot ',
     &   'call mkdir -> please create obsfitDir manually'
        CALL PRINT_MESSAGE( msgBuf,
     &       errorMessageUnit, SQUEEZE_RIGHT, myThid )
#endif
      ENDIF

      _END_MASTER( myThid )

#endif /* ALLOW_OBSFIT */

      RETURN
      END

#include "MATRIX_OPTIONS.h"

      SUBROUTINE MATRIX_INIT_VARIA( myThid )

      IMPLICIT NONE

#include "EEPARAMS.h"
#include "SIZE.h"
#include "PTRACERS_SIZE.h"
#include "PTRACERS_PARAMS.h"
#include "PTRACERS_FIELDS.h"
#include "MATRIX.h"
#include "PARAMS.h"

      INTEGER myThid

#ifdef ALLOW_MATRIX

C     local variables:
      INTEGER i, j, k, bi, bj
      INTEGER iTracer

C     Initialize counters
      expMatrixWriteCount = 1
      impMatrixWriteCount = 1
      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
         expMatrixCounter(bi,bj) = 0
         impMatrixCounter(bi,bj) = 0
       ENDDO
      ENDDO
      DO iTracer=1,PTRACERS_num
        DO bj=myByLo(myThid),myByHi(myThid)
         DO bi=myBxLo(myThid),myBxHi(myThid)
           DO k=1,Nr
            DO j=1-Oly, sNy+Oly
             DO i=1-Olx, sNx+Olx
               PTRACERS_initial(i,j,k,bi,bj,iTracer) =
     &                  pTracer(i,j,k,bi,bj,iTracer)
               MATRIX(i,j,k,bi,bj,iTracer,1) = 0. _d 0
               MATRIX(i,j,k,bi,bj,iTracer,2) = 0. _d 0
             ENDDO
            ENDDO
           ENDDO
         ENDDO
        ENDDO
      ENDDO

#endif /* ALLOW_MATRIX */
      RETURN
      END

module monin_obukhov_mod

!=======================================================================
!
!                         MONIN-OBUKHOV MODULE
!
!          Routines for computing surface drag coefficients
!                 from data at the lowest model level
!              and for computing the profile of fields
!           between the lowest model level and the ground
!                  using Monin-Obukhov scaling
!
!=======================================================================

use gcm_params_mod, only: gcm_LEN_MBUF, gcm_SQZ_R, gcm_stdMsgUnit
use constants_mod, only : grav, vonkarm
!use       fms_mod, only:  error_mesg, FATAL, file_exist,   &
!                          check_nml_error, open_namelist_file,      &
!                          mpp_pe, mpp_root_pe, close_file, stdlog, &
!                          write_version_number

implicit none
private

!=======================================================================
 public mo_drag
 public mo_profile
 public mo_diff
 public stable_mix
!=======================================================================

interface mo_drag
    module procedure  mo_drag_0d, mo_drag_1d, mo_drag_2d
end interface

interface mo_profile
    module procedure  mo_profile_0d,   mo_profile_1d,   mo_profile_2d, &
                      mo_profile_0d_n, mo_profile_1d_n, mo_profile_2d_n
end interface

interface mo_diff
    module procedure  mo_diff_0d_n, mo_diff_0d_1, &
                      mo_diff_1d_n, mo_diff_1d_1, &
                      mo_diff_2d_n, mo_diff_2d_1
end interface

interface stable_mix
    module procedure  stable_mix_0d, stable_mix_1d, &
                      stable_mix_2d, stable_mix_3d
end interface

!--------------------- version number ---------------------------------

character(len=128) :: version = '$Id: monin_obukhov_mod.F90,v 1.2 2017/08/11 20:48:51 jmc Exp $'
character(len=128) :: tagname = '$Name:  $'

!=======================================================================

!  DEFAULT VALUES OF NAMELIST PARAMETERS:

real    :: rich_crit      = 2.0
real    :: drag_min       = 1.e-05
logical :: neutral        = .false.
integer :: stable_option  = 1
real    :: zeta_trans     = 0.5

namelist /monin_obukhov_nml/ rich_crit, neutral, drag_min, &
                             stable_option, zeta_trans

!=======================================================================

!  MODULE VARIABLES

real, parameter    :: small  = 1.e-04
real               :: b_stab, r_crit, sqrt_drag_min, lambda, rich_trans
logical            :: init = .false.

contains

!=======================================================================

subroutine monin_obukhov_init(myThid)

integer, intent(in) :: myThid
integer :: unit, ierr, io

integer         :: iUnit
CHARACTER*(gcm_LEN_MBUF) :: msgBuf
!------------------- read namelist input -------------------------------

! read namelist and copy to logfile

!    _BARRIER
!    _BEGIN_MASTER(myThid)
     CALL BARRIER(myThid)
     IF ( myThid.EQ.1 ) THEN

     WRITE(msgBuf,'(A)') 'MONIN_OBUKHOV_INIT: opening data.atm_gray'
     CALL PRINT_MESSAGE( msgBuf, gcm_stdMsgUnit, gcm_SQZ_R, myThid )
     CALL OPEN_COPY_DATA_FILE(                                      &
                           'data.atm_gray', 'MONIN_OBUKHOV_INIT',       &
                           iUnit,                                   &
                           myThid )
!    Read parameters from open data file
     READ(UNIT=iUnit,NML=monin_obukhov_nml)
     WRITE(msgBuf,'(A)')                                            &
          'MONIN_OBUKHOV_INIT: finished reading data.atm_gray'
     CALL PRINT_MESSAGE( msgBuf, gcm_stdMsgUnit, gcm_SQZ_R, myThid )
!    Close the open data file
#ifdef SINGLE_DISK_IO
     CLOSE(iUnit)
#else
     CLOSE(iUnit,STATUS='DELETE')
#endif /* SINGLE_DISK_IO */

!      if (file_exist('input.nml')) then
!         unit = open_namelist_file ()
!         ierr=1; do while (ierr /= 0)
!            read  (unit, nml=monin_obukhov_nml, iostat=io, end=10)
!            ierr = check_nml_error(io,'monin_obukhov_nml')
!         enddo
!  10     call close_file (unit)
!      endif

!---------- output namelist to log-------------------------------------

!      call write_version_number(version, tagname)
!      if ( mpp_pe() == mpp_root_pe() ) write (stdlog(), nml=monin_obukhov_nml)

!----------------------------------------------------------------------

if(rich_crit.le.0.25)  call PRINT_ERROR( &
        'MONIN_OBUKHOV_INIT in MONIN_OBUKHOV_MOD'// &
         'rich_crit in monin_obukhov_mod must be > 0.25', myThid )
!if(rich_crit.le.0.25)  call error_mesg( &
!        'MONIN_OBUKHOV_INIT in MONIN_OBUKHOV_MOD', &
!        'rich_crit in monin_obukhov_mod must be > 0.25', FATAL)

if(drag_min.lt.0.0)  call PRINT_ERROR( &
        'MONIN_OBUKHOV_INIT in MONIN_OBUKHOV_MOD'// &
        'drag_min in monin_obukhov_mod must be >= 0.0', myThid )
!if(drag_min.lt.0.0)  call error_mesg( &
!        'MONIN_OBUKHOV_INIT in MONIN_OBUKHOV_MOD', &
!        'drag_min in monin_obukhov_mod must be >= 0.0', FATAL)

if(stable_option < 1 .or. stable_option > 2) call PRINT_ERROR( &
        'MONIN_OBUKHOV_INIT in MONIN_OBUKHOV_MOD'// &
        'the only allowable values of stable_option are 1 and 2', myThid )
!if(stable_option < 1 .or. stable_option > 2) call error_mesg( &
!        'MONIN_OBUKHOV_INIT in MONIN_OBUKHOV_MOD', &
!        'the only allowable values of stable_option are 1 and 2', FATAL)

if(stable_option == 2 .and. zeta_trans < 0) call PRINT_ERROR( &
        'MONIN_OBUKHOV_INIT in MONIN_OBUKHOV_MOD'// &
        'zeta_trans must be positive', myThid )
!if(stable_option == 2 .and. zeta_trans < 0) call error_mesg( &
!        'MONIN_OBUKHOV_INIT in MONIN_OBUKHOV_MOD', &
!        'zeta_trans must be positive', FATAL)

b_stab = 1.0/rich_crit
r_crit = 0.95*rich_crit  ! convergence can get slow if one is
                         ! close to rich_crit

sqrt_drag_min = 0.0
if(drag_min.ne.0.0) sqrt_drag_min = sqrt(drag_min)

lambda     = 1.0 + (5.0 - b_stab)*zeta_trans   ! used only if stable_option = 2
rich_trans = zeta_trans/(1.0 + 5.0*zeta_trans) ! used only if stable_option = 2

init = .true.

!    _END_MASTER(myThid)
!    _BARRIER
     ENDIF
     CALL BARRIER(myThid)

return
end subroutine monin_obukhov_init

!=======================================================================

subroutine mo_drag_1d &
         (pt, pt0, z, z0, zt, zq, speed, drag_m, drag_t, drag_q, &
          u_star, b_star, myThid, avail)

real, intent(in)   , dimension(:) :: pt, pt0, z, z0, zt, zq, speed
real, intent(inout), dimension(:) :: drag_m, drag_t, drag_q, u_star, b_star
integer, intent(in)               :: myThid
logical, intent(in), optional, dimension(:) :: avail

real   , dimension(size(pt)) :: rich, fm, ft, fq, zz
logical, dimension(size(pt)) :: mask, mask_1, mask_2

real   , dimension(size(pt)) :: delta_b, us, bs, qs

if(.not.init) call monin_obukhov_init(myThid)

mask = .true.
if(present(avail)) mask = avail

where(mask)
   delta_b = grav*(pt0 - pt)/pt0
   rich    = - z*delta_b/(speed*speed + small)
   zz      = max(z,z0,zt,zq)
else where
   rich = 0.0
end where

if(neutral) then

  where(mask)
    fm   = log(zz/z0)
    ft   = log(zz/zt)
    fq   = log(zz/zq)
    us   = vonkarm/fm
    bs   = vonkarm/ft
    qs   = vonkarm/fq
    drag_m    = us*us
    drag_t    = us*bs
    drag_q    = us*qs
    u_star = us*speed
    b_star = bs*delta_b
  end where

else

  mask_1 = mask .and. rich <  r_crit
  mask_2 = mask .and. rich >= r_crit

  where(mask_2)
    drag_m   = drag_min
    drag_t   = drag_min
    drag_q   = drag_min
    us       = sqrt_drag_min
    bs       = sqrt_drag_min
    qs       = sqrt_drag_min
    u_star   = us*speed
    b_star   = bs*delta_b
  end where
  call solve_zeta (rich, zz, z0, zt, zq, fm, ft, fq, mask_1, myThid)

  where (mask_1)
    us   = max(vonkarm/fm, sqrt_drag_min)
    bs   = max(vonkarm/ft, sqrt_drag_min)
    qs   = max(vonkarm/fq, sqrt_drag_min)
    drag_m   = us*us
    drag_t   = us*bs
    drag_q   = us*qs
    u_star   = us*speed
    b_star   = bs*delta_b
  end where

end if

return
end subroutine mo_drag_1d

!=======================================================================

subroutine mo_profile_1d(zref, zref_t, z, z0, zt, zq, u_star, b_star, q_star, &
                         del_m, del_t, del_q, myThid, avail)

real,    intent(in)                :: zref, zref_t
real,    intent(in) , dimension(:) :: z, z0, zt, zq, u_star, b_star, q_star
real,    intent(out), dimension(:) :: del_m, del_t, del_q
integer, intent(in)                :: myThid
logical, intent(in) , optional, dimension(:) :: avail

real, dimension(size(z)) :: zeta, zeta_0, zeta_t, zeta_q, zeta_ref, zeta_ref_t, &
                            ln_z_z0, ln_z_zt, ln_z_zq, ln_z_zref, ln_z_zref_t,  &
                            f_m_ref, f_m, f_t_ref, f_t, f_q_ref, f_q,           &
                            mo_length_inv

logical, dimension(size(z)) :: mask

if(.not.init) call monin_obukhov_init(myThid)

mask = .true.
if(present(avail)) mask = avail

del_m = 0.0  ! zero output arrays
del_t = 0.0
del_q = 0.0

where(mask)
  ln_z_z0     = log(z/z0)
  ln_z_zt     = log(z/zt)
  ln_z_zq     = log(z/zq)
  ln_z_zref   = log(z/zref)
  ln_z_zref_t = log(z/zref_t)
endwhere

if(neutral) then

  where(mask)
    del_m = 1.0 - ln_z_zref  /ln_z_z0
    del_t = 1.0 - ln_z_zref_t/ln_z_zt
    del_q = 1.0 - ln_z_zref_t/ln_z_zq
  endwhere

else

  where(mask .and. u_star > 0.0)
    mo_length_inv = - vonkarm * b_star/(u_star*u_star)
    zeta       = z     *mo_length_inv
    zeta_0     = z0    *mo_length_inv
    zeta_t     = zt    *mo_length_inv
    zeta_q     = zq    *mo_length_inv
    zeta_ref   = zref  *mo_length_inv
    zeta_ref_t = zref_t*mo_length_inv
  endwhere

  call mo_integral_m(f_m,     zeta, zeta_0,   ln_z_z0,   mask, myThid)
  call mo_integral_m(f_m_ref, zeta, zeta_ref, ln_z_zref, mask, myThid)

  call mo_integral_tq(f_t, f_q, zeta, zeta_t, zeta_q, ln_z_zt, ln_z_zq, mask, myThid)
  call mo_integral_tq(f_t_ref, f_q_ref, zeta, zeta_ref_t, zeta_ref_t, &
                      ln_z_zref_t, ln_z_zref_t,  mask, myThid)

  where(mask)
    del_m = 1.0 - f_m_ref/f_m
    del_t = 1.0 - f_t_ref/f_t
    del_q = 1.0 - f_q_ref/f_q
  endwhere

end if

return
end subroutine mo_profile_1d

!=======================================================================

subroutine stable_mix_3d(rich, mix, myThid)

real, intent(in) , dimension(:,:,:)  :: rich
real, intent(out), dimension(:,:,:)  :: mix
integer, intent(in)                  :: myThid

real, dimension(size(rich,1),size(rich,2),size(rich,3)) :: &
      r, a, b, c, zeta, phi

mix = 0.0

if(stable_option == 1) then

  where(rich > 0.0 .and. rich < rich_crit)
    r = 1.0/rich
    a = r - b_stab
    b = r - (1.0 + 5.0)
    c = - 1.0

    zeta = (-b + sqrt(b*b - 4.0*a*c))/(2.0*a)
    phi = 1.0 + b_stab*zeta + (5.0 - b_stab)*zeta/(1.0 + zeta)
    mix = 1./(phi*phi)
  end where

else if(stable_option == 2) then

  where(rich > 0.0 .and. rich <= rich_trans)
    mix = (1.0 - 5.0*rich)**2
  end where
  where(rich > rich_trans .and. rich < rich_crit)
    mix = ((1.0 - b_stab*rich)/lambda)**2
  end where

end if

return
end subroutine stable_mix_3d

!=======================================================================

subroutine mo_diff_2d_n(z, u_star, b_star, k_m, k_h, myThid)

real, intent(in),  dimension(:,:,:) :: z
real, intent(in),  dimension(:,:)   :: u_star, b_star
real, intent(out), dimension(:,:,:) :: k_m, k_h
integer, intent(in)                 :: myThid

real , dimension(size(z,1),size(z,2)) :: phi_m, phi_h, zeta, uss
integer :: j, k
INTEGER :: I
logical, dimension(size(z,1)) :: mask

if(.not.init) call monin_obukhov_init(myThid)

mask = .true.
uss = max(u_star, 1.e-10)

if(neutral) then
  do k = 1, size(z,3)
    k_m(:,:,k) = vonkarm *uss*z(:,:,k)
    k_h(:,:,k) = k_m(:,:,k)
  end do
else
  do k = 1, size(z,3)
    zeta = - vonkarm * b_star*z(:,:,k)/(uss*uss)

    do j = 1, size(z,2)
      call mo_derivative_m(phi_m(:,j), zeta(:,j), mask, myThid)
      call mo_derivative_t(phi_h(:,j), zeta(:,j), mask, myThid)
    enddo
    k_m(:,:,k) = vonkarm * uss*z(:,:,k)/phi_m
    k_h(:,:,k) = vonkarm * uss*z(:,:,k)/phi_h
  end do
endif

return
end subroutine mo_diff_2d_n

!=======================================================================
! The following routines are used by the public interfaces above
!=======================================================================

subroutine solve_zeta(rich, z, z0, zt, zq, f_m, f_t, f_q, mask, myThid)

real   , intent(in) , dimension(:) :: rich, z, z0, zt, zq
logical, intent(in) , dimension(:) :: mask
real   , intent(out), dimension(:) :: f_m, f_t, f_q
integer, intent(in)                :: myThid

real, parameter    :: error    = 1.e-04
real, parameter    :: zeta_min = 1.e-06
integer, parameter :: max_iter = 20

real    :: max_cor
integer :: iter

real, dimension(size(rich)) ::   &
          d_rich, rich_1, correction, corr, z_z0, z_zt, z_zq, &
          ln_z_z0, ln_z_zt, ln_z_zq, zeta,                    &
          phi_m, phi_m_0, phi_t, phi_t_0, rzeta,              &
          zeta_0, zeta_t, zeta_q, df_m, df_t

logical, dimension(size(rich)) :: mask_1

z_z0 = z/z0
z_zt = z/zt
z_zq = z/zq
ln_z_z0 = log(z_z0)
ln_z_zt = log(z_zt)
ln_z_zq = log(z_zq)

corr = 0.0
mask_1 = mask

! initial guess

where(mask_1)
  zeta = rich*ln_z_z0*ln_z_z0/ln_z_zt
else where
  zeta = 0.0
end where

where (mask_1 .and. rich >= 0.0)
  zeta = zeta/(1.0 - rich/rich_crit)
end where

iter_loop: do iter = 1, max_iter

  where (mask_1 .and. abs(zeta).lt.zeta_min)
    zeta = 0.0
    f_m = ln_z_z0
    f_t = ln_z_zt
    f_q = ln_z_zq
    mask_1 = .false.  ! don't do any more calculations at these pts
  end where

  where (mask_1)
    rzeta  = 1.0/zeta
    zeta_0 = zeta/z_z0
    zeta_t = zeta/z_zt
    zeta_q = zeta/z_zq
  else where
    zeta_0 = 0.0
    zeta_t = 0.0
    zeta_q = 0.0
  end where

  call mo_derivative_m(phi_m  , zeta  , mask_1, myThid)
  call mo_derivative_m(phi_m_0, zeta_0, mask_1, myThid)
  call mo_derivative_t(phi_t  , zeta  , mask_1, myThid)
  call mo_derivative_t(phi_t_0, zeta_t, mask_1, myThid)

  call mo_integral_m(f_m, zeta, zeta_0, ln_z_z0, mask_1, myThid)
  call mo_integral_tq(f_t, f_q, zeta, zeta_t, zeta_q, ln_z_zt, ln_z_zq, mask_1, myThid)

  where (mask_1)
    df_m  = (phi_m - phi_m_0)*rzeta
    df_t  = (phi_t - phi_t_0)*rzeta
    rich_1 = zeta*f_t/(f_m*f_m)
    d_rich = rich_1*( rzeta +  df_t/f_t - 2.0 *df_m/f_m)
    correction = (rich - rich_1)/d_rich
    corr = min(abs(correction),abs(correction/zeta))
      ! the criterion corr < error seems to work ok, but is a bit arbitrary
      !  when zeta is small the tolerance is reduced
  end where

  max_cor= maxval(corr)

  if(max_cor > error) then
    mask_1 = mask_1 .and. (corr > error)
       ! change the mask so computation proceeds only on non-converged points
    where(mask_1)
      zeta = zeta + correction
    end where
    cycle iter_loop
  else
    return
  end if

end do iter_loop

!call error_mesg ('solve_zeta in monin_obukhov_mod',  &
!                 'surface drag iteration did not converge', FATAL)

end subroutine solve_zeta

!=======================================================================

subroutine mo_derivative_m(phi_m, zeta, mask, myThid)

! the differential similarity function for momentum

real    , intent(out),  dimension(:) :: phi_m
real    , intent(in),   dimension(:) :: zeta
logical , intent(in),   dimension(:) :: mask
integer, intent(in)                  :: myThid

logical, dimension(size(zeta)) :: stable, unstable
real   , dimension(size(zeta)) :: x

stable   = mask .and. zeta >= 0.0
unstable = mask .and. zeta <  0.0

where (unstable)
  x     = (1 - 16.0*zeta  )**(-0.5)
  phi_m = sqrt(x)  ! phi_m = (1 - 16.0*zeta)**(-0.25)
end where

if(stable_option == 1) then

  where (stable)
    phi_m = 1.0 + zeta  *(5.0 + b_stab*zeta)/(1.0 + zeta)
  end where

else if(stable_option == 2) then

  where (stable .and. zeta < zeta_trans)
    phi_m = 1 + 5.0*zeta
  end where
  where (stable .and. zeta >= zeta_trans)
    phi_m = lambda + b_stab*zeta
  end where

endif

return
end subroutine mo_derivative_m

!=======================================================================

subroutine mo_derivative_t(phi_t, zeta, mask, myThid)

! the differential similarity function for buoyancy and tracers

real    , intent(out),  dimension(:) :: phi_t
real    , intent(in),   dimension(:) :: zeta
logical , intent(in),   dimension(:) :: mask
integer, intent(in)                  :: myThid

logical, dimension(size(zeta)) :: stable, unstable

stable   = mask .and. zeta >= 0.0
unstable = mask .and. zeta <  0.0

where (unstable)
  phi_t = (1 - 16.0*zeta)**(-0.5)
end where

if(stable_option == 1) then

  where (stable)
    phi_t = 1.0 + zeta*(5.0 + b_stab*zeta)/(1.0 + zeta)
  end where

else if(stable_option == 2) then

  where (stable .and. zeta < zeta_trans)
    phi_t = 1 + 5.0*zeta
  end where
  where (stable .and. zeta >= zeta_trans)
    phi_t = lambda + b_stab*zeta
  end where

endif

return
end subroutine mo_derivative_t

!=======================================================================

subroutine mo_integral_tq (psi_t, psi_q, zeta, zeta_t, zeta_q, &
                           ln_z_zt, ln_z_zq, mask, myThid)

! the integral similarity function for moisture and tracers

real    , intent(out), dimension(:) :: psi_t, psi_q
real    , intent(in),  dimension(:) :: zeta, zeta_t, zeta_q, ln_z_zt, ln_z_zq
logical , intent(in),  dimension(:) :: mask
integer, intent(in)                 :: myThid

real, dimension(size(zeta)) :: x, x_t, x_q

logical, dimension(size(zeta)) :: stable, unstable, &
                                  weakly_stable, strongly_stable

stable   = mask .and. zeta >= 0.0
unstable = mask .and. zeta <  0.0

where(unstable)

  x     = sqrt(1 - 16.0*zeta)
  x_t   = sqrt(1 - 16.0*zeta_t)
  x_q   = sqrt(1 - 16.0*zeta_q)

  psi_t = ln_z_zt - 2.0*log( (1.0 + x)/(1.0 + x_t) )
  psi_q = ln_z_zq - 2.0*log( (1.0 + x)/(1.0 + x_q) )

end where

if( stable_option == 1) then

  where (stable)

    psi_t = ln_z_zt + (5.0 - b_stab)*log((1.0 + zeta)/(1.0 + zeta_t)) &
       + b_stab*(zeta - zeta_t)
    psi_q = ln_z_zq + (5.0 - b_stab)*log((1.0 + zeta)/(1.0 + zeta_q)) &
       + b_stab*(zeta - zeta_q)

  end where

else if (stable_option == 2) then

  weakly_stable   = stable .and. zeta <= zeta_trans
  strongly_stable = stable .and. zeta >  zeta_trans

  where (weakly_stable)
    psi_t = ln_z_zt + 5.0*(zeta - zeta_t)
    psi_q = ln_z_zq + 5.0*(zeta - zeta_q)
  end where

  where(strongly_stable)
    x = (lambda - 1.0)*log(zeta/zeta_trans) + b_stab*(zeta - zeta_trans)
  endwhere

  where (strongly_stable .and. zeta_t <= zeta_trans)
    psi_t = ln_z_zt + x + 5.0*(zeta_trans - zeta_t)
  end where
  where (strongly_stable .and. zeta_t > zeta_trans)
    psi_t = lambda*ln_z_zt + b_stab*(zeta  - zeta_t)
  endwhere

  where (strongly_stable .and. zeta_q <= zeta_trans)
    psi_q = ln_z_zq + x + 5.0*(zeta_trans - zeta_q)
  end where
  where (strongly_stable .and. zeta_q > zeta_trans)
    psi_q = lambda*ln_z_zq + b_stab*(zeta  - zeta_q)
  endwhere

end if

return
end subroutine mo_integral_tq

!=======================================================================

subroutine mo_integral_m (psi_m, zeta, zeta_0, ln_z_z0, mask, myThid)

!  the integral similarity function for momentum

real    , intent(out), dimension(:) :: psi_m
real    , intent(in),  dimension(:) :: zeta, zeta_0, ln_z_z0
logical , intent(in),  dimension(:) :: mask
integer, intent(in)                 :: myThid

real, dimension(size(zeta)) :: x, x_0, x1, x1_0, num, denom, y

logical, dimension(size(zeta)) :: stable, unstable, &
                                  weakly_stable, strongly_stable

stable   = mask .and. zeta >= 0.0
unstable = mask .and. zeta <  0.0

where(unstable)

  x     = sqrt(1 - 16.0*zeta)
  x_0   = sqrt(1 - 16.0*zeta_0)

  x      = sqrt(x)
  x_0    = sqrt(x_0)

  x1     = 1.0 + x
  x1_0   = 1.0 + x_0

  num    = x1*x1*(1.0 + x*x)
  denom  = x1_0*x1_0*(1.0 + x_0*x_0)
  y      = atan(x) - atan(x_0)
  psi_m  = ln_z_z0 - log(num/denom) + 2*y

end where

if( stable_option == 1) then

  where (stable)
    psi_m = ln_z_z0 + (5.0 - b_stab)*log((1.0 + zeta)/(1.0 + zeta_0)) &
       + b_stab*(zeta - zeta_0)
  end where

else if (stable_option == 2) then

  weakly_stable   = stable .and. zeta <= zeta_trans
  strongly_stable = stable .and. zeta >  zeta_trans

  where (weakly_stable)
    psi_m = ln_z_z0 + 5.0*(zeta - zeta_0)
  end where

  where(strongly_stable)
    x = (lambda - 1.0)*log(zeta/zeta_trans) + b_stab*(zeta - zeta_trans)
  endwhere

  where (strongly_stable .and. zeta_0 <= zeta_trans)
    psi_m = ln_z_z0 + x + 5.0*(zeta_trans - zeta_0)
  end where
  where (strongly_stable .and. zeta_0 > zeta_trans)
    psi_m = lambda*ln_z_z0 + b_stab*(zeta  - zeta_0)
  endwhere

end if

return
end subroutine mo_integral_m

!=======================================================================
! The following routines allow the public interfaces to be used
! with different dimensions of the input and output
!
!=======================================================================

subroutine mo_drag_2d &
    (pt, pt0, z, z0, zt, zq, speed, drag_m, drag_t, drag_q, u_star, b_star, myThid)

real, intent(in)   , dimension(:,:) :: z, speed, pt, pt0, z0, zt, zq
real, intent(out)  , dimension(:,:) :: drag_m, drag_t, drag_q
real, intent(inout), dimension(:,:) :: u_star, b_star
integer, intent(in)                 :: myThid

integer :: j

do j = 1, size(pt,2)
  call mo_drag_1d (pt(:,j), pt0(:,j), z(:,j), z0(:,j), zt(:,j), zq(:,j), &
                   speed(:,j), drag_m(:,j), drag_t(:,j), drag_q(:,j), &
                   u_star(:,j), b_star(:,j), myThid )
end do

return
end subroutine mo_drag_2d

!=======================================================================
subroutine mo_drag_0d &
    (pt, pt0, z, z0, zt, zq, speed, drag_m, drag_t, drag_q, u_star, b_star, myThid)

real, intent(in)    :: z, speed, pt, pt0, z0, zt, zq
real, intent(out)   :: drag_m, drag_t, drag_q, u_star, b_star

real, dimension(1) :: pt_1, pt0_1, z_1, z0_1, zt_1, zq_1, speed_1, &
                      drag_m_1, drag_t_1, drag_q_1, u_star_1, b_star_1
integer, intent(in):: myThid

pt_1   (1) = pt
pt0_1  (1) = pt0
z_1    (1) = z
z0_1   (1) = z0
zt_1   (1) = zt
zq_1   (1) = zq
speed_1(1) = speed

call mo_drag_1d (pt_1, pt0_1, z_1, z0_1, zt_1, zq_1, speed_1, &
                 drag_m_1, drag_t_1, drag_q_1, u_star_1, b_star_1, myThid )

drag_m = drag_m_1(1)
drag_t = drag_t_1(1)
drag_q = drag_q_1(1)
u_star = u_star_1(1)
b_star = b_star_1(1)

return
end subroutine mo_drag_0d
!=======================================================================

subroutine mo_profile_2d(zref, zref_t, z, z0, zt, zq, u_star, b_star, q_star, &
                         del_m, del_h, del_q, myThid)

real, intent(in)                  :: zref, zref_t
real, intent(in) , dimension(:,:) :: z, z0, zt, zq, u_star, b_star, q_star
real, intent(out), dimension(:,:) :: del_m, del_h, del_q
integer, intent(in)               :: myThid

integer :: j

do j = 1, size(z,2)
  call mo_profile_1d (zref, zref_t, z(:,j), z0(:,j), zt(:,j),         &
                      zq(:,j), u_star(:,j), b_star(:,j), q_star(:,j), &
                      del_m(:,j), del_h (:,j), del_q (:,j), myThid )
enddo

return
end subroutine mo_profile_2d

!=======================================================================

subroutine mo_profile_0d(zref, zref_t, z, z0, zt, zq, u_star, b_star, q_star, &
                         del_m, del_h, del_q, myThid)

real, intent(in)  :: zref, zref_t
real, intent(in)  :: z, z0, zt, zq, u_star, b_star, q_star
real, intent(out) :: del_m, del_h, del_q

real, dimension(1) :: z_1, z0_1, zt_1, zq_1, u_star_1, b_star_1, q_star_1, &
                      del_m_1, del_h_1, del_q_1
integer, intent(in):: myThid

z_1     (1) = z
z0_1    (1) = z0
zt_1    (1) = zt
zq_1    (1) = zq
u_star_1(1) = u_star
b_star_1(1) = b_star
q_star_1(1) = q_star

call mo_profile_1d (zref, zref_t, z_1, z0_1, zt_1, zq_1, &
                    u_star_1, b_star_1, q_star_1,        &
                    del_m_1, del_h_1, del_q_1, myThid )

del_m = del_m_1(1)
del_h = del_h_1(1)
del_q = del_q_1(1)

return
end subroutine mo_profile_0d

!=======================================================================

subroutine mo_profile_1d_n(zref, z, z0, zt, zq, u_star, b_star, q_star, &
                         del_m, del_t, del_q, myThid, avail)

real,    intent(in),  dimension(:)   :: zref
real,    intent(in) , dimension(:)   :: z, z0, zt, zq, u_star, b_star, q_star
real,    intent(out), dimension(:,:) :: del_m, del_t, del_q
integer, intent(in)                  :: myThid
logical, intent(in) , optional, dimension(:) :: avail

integer :: k

do k = 1, size(zref)
  if(present(avail)) then
    call mo_profile_1d (zref(k), zref(k), z, z0, zt, zq, &
       u_star, b_star, q_star, del_m(:,k), del_t(:,k), del_q(:,k), myThid, avail)
  else
      call mo_profile_1d (zref(k), zref(k), z, z0, zt, zq, &
       u_star, b_star, q_star, del_m(:,k), del_t(:,k), del_q(:,k), myThid )
  endif
enddo

return
end subroutine mo_profile_1d_n

!=======================================================================

subroutine mo_profile_0d_n(zref, z, z0, zt, zq, u_star, b_star, q_star, &
                         del_m, del_t, del_q, myThid)

real,    intent(in),  dimension(:) :: zref
real,    intent(in)                :: z, z0, zt, zq, u_star, b_star, q_star
real,    intent(out), dimension(:) :: del_m, del_t, del_q
integer, intent(in)                :: myThid

integer :: k

do k = 1, size(zref)
  call mo_profile_0d (zref(k), zref(k), z, z0, zt, zq, &
       u_star, b_star, q_star, del_m(k), del_t(k), del_q(k), myThid)
enddo

return
end subroutine mo_profile_0d_n

!=======================================================================

subroutine mo_profile_2d_n(zref, z, z0, zt, zq, u_star, b_star, q_star, &
                         del_m, del_t, del_q, myThid)

real,    intent(in),  dimension(:)     :: zref
real,    intent(in),  dimension(:,:)   :: z, z0, zt, zq, u_star, b_star, q_star
real,    intent(out), dimension(:,:,:) :: del_m, del_t, del_q
integer, intent(in)                    :: myThid

integer :: k

do k = 1, size(zref)
  call mo_profile_2d (zref(k), zref(k), z, z0, zt, zq, &
       u_star, b_star, q_star, del_m(:,:,k), del_t(:,:,k), del_q(:,:,k), myThid)
enddo

return
end subroutine mo_profile_2d_n

!=======================================================================

subroutine mo_diff_2d_1(z, u_star, b_star, k_m, k_h, myThid)

real, intent(in),  dimension(:,:) :: z, u_star, b_star
real, intent(out), dimension(:,:) :: k_m, k_h

real   , dimension(size(z,1),size(z,2),1) :: z_n, k_m_n, k_h_n
integer, intent(in)                       :: myThid

z_n(:,:,1) = z

call mo_diff_2d_n(z_n, u_star, b_star, k_m_n, k_h_n, myThid)

k_m = k_m_n(:,:,1)
k_h = k_h_n(:,:,1)

return
end subroutine mo_diff_2d_1

!=======================================================================

subroutine mo_diff_1d_1(z, u_star, b_star, k_m, k_h, myThid)

real, intent(in),  dimension(:) :: z, u_star, b_star
real, intent(out), dimension(:) :: k_m, k_h

real, dimension(size(z),1,1) :: z_n, k_m_n, k_h_n
real, dimension(size(z),1)   :: u_star_n, b_star_n
integer, intent(in)          :: myThid

z_n   (:,1,1) = z
u_star_n(:,1) = u_star
b_star_n(:,1) = b_star

call mo_diff_2d_n(z_n, u_star_n, b_star_n, k_m_n, k_h_n, myThid)

k_m = k_m_n(:,1,1)
k_h = k_h_n(:,1,1)

return
end subroutine mo_diff_1d_1

!=======================================================================

subroutine mo_diff_1d_n(z, u_star, b_star, k_m, k_h, myThid)

real, intent(in),  dimension(:,:) :: z
real, intent(in),  dimension(:)   :: u_star, b_star
real, intent(out), dimension(:,:) :: k_m, k_h
integer, intent(in)               :: myThid

real, dimension(size(z,1),1)            :: u_star2, b_star2
real, dimension(size(z,1),size(z,2), 1) :: z2, k_m2, k_h2

z2   (:,:,1) = z
u_star2(:,1) = u_star
b_star2(:,1) = b_star

call mo_diff_2d_n(z2, u_star2, b_star2, k_m2, k_h2, myThid)

k_m = k_m2(:,:,1)
k_h = k_h2(:,:,1)

return
end subroutine mo_diff_1d_n

!=======================================================================

subroutine mo_diff_0d_1(z, u_star, b_star, k_m, k_h, myThid)

real, intent(in)   :: z, u_star, b_star
real, intent(out)  :: k_m, k_h
integer, intent(in):: myThid

real, dimension(1,1,1) :: z_n, k_m_n, k_h_n
real, dimension(1,1)   :: u_star_n, b_star_n

z_n   (1,1,1) = z
u_star_n(1,1) = u_star
b_star_n(1,1) = b_star

call mo_diff_2d_n(z_n, u_star_n, b_star_n, k_m_n, k_h_n, myThid)

k_m = k_m_n(1,1,1)
k_h = k_h_n(1,1,1)

return
end subroutine mo_diff_0d_1

!=======================================================================

subroutine mo_diff_0d_n(z, u_star, b_star, k_m, k_h, myThid)

real, intent(in),  dimension(:) :: z
real, intent(in)                :: u_star, b_star
real, intent(out), dimension(:) :: k_m, k_h
integer, intent(in)             :: myThid

real, dimension(1,1)            :: u_star2, b_star2
real, dimension(size(z,1),1, 1) :: z2, k_m2, k_h2

z2   (:,1,1) = z
u_star2(1,1) = u_star
b_star2(1,1) = b_star

call mo_diff_2d_n(z2, u_star2, b_star2, k_m2, k_h2, myThid)

k_m = k_m2(:,1,1)
k_h = k_h2(:,1,1)

return
end subroutine mo_diff_0d_n

!=======================================================================

subroutine stable_mix_2d(rich, mix, myThid)

real, intent(in) , dimension(:,:)  :: rich
real, intent(out), dimension(:,:)  :: mix
integer, intent(in)                :: myThid

real, dimension(size(rich,1),size(rich,2),1) :: rich_3d, mix_3d

rich_3d(:,:,1) = rich

call stable_mix_3d(rich_3d, mix_3d, myThid)

mix = mix_3d(:,:,1)

return
end subroutine stable_mix_2d

!=======================================================================

subroutine stable_mix_1d(rich, mix, myThid)

real, intent(in) , dimension(:)  :: rich
real, intent(out), dimension(:)  :: mix
integer, intent(in)              :: myThid

real, dimension(size(rich),1,1) :: rich_3d, mix_3d

rich_3d(:,1,1) = rich

call stable_mix_3d(rich_3d, mix_3d, myThid)

mix = mix_3d(:,1,1)

return
end subroutine stable_mix_1d

!=======================================================================

subroutine stable_mix_0d(rich, mix, myThid)

real, intent(in)    :: rich
real, intent(out)   :: mix
integer, intent(in) :: myThid

real, dimension(1,1,1) :: rich_3d, mix_3d

rich_3d(1,1,1) = rich

call stable_mix_3d(rich_3d, mix_3d, myThid)

mix = mix_3d(1,1,1)

return
end subroutine stable_mix_0d
!=======================================================================

end module monin_obukhov_mod

#include "ctrparam.h"
#include "ATM2D_OPTIONS.h"

C     !INTERFACE:
      SUBROUTINE PASS_THSICE_FLUXES( myThid )
C     *==========================================================*
C     | Called after each atm time step - put Qneti, dF/dT, solar|
c     | for seaice to use, accumlate precip fluxes for thsice pkg|
C     *==========================================================*
        IMPLICIT NONE

#include "ATMSIZE.h"
#include "SIZE.h"
#include "GRID.h"
#include "EEPARAMS.h"

C     === Global SeaIce Variables ===
#include "THSICE_PARAMS.h"
#include "THSICE_VARS.h"

C     === Atmos/Ocean/Seaice Interface Variables ===
#include "ATM2D_VARS.h"


C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
C     myThid - Thread no. that called this routine.
      INTEGER myThid

C     LOCAL VARIABLES:
      INTEGER i,j

      DO j=1, sNy
       DO i=1, sNx

         IF (iceMask(i,j,1,1) .GT. 0. _d 0) THEN
           netSW(i,j) = solarinc_2D(i,j)*(1. _d 0 - siceAlb(i,j,1,1)) ! convert to netSW
           sFlx(i,j,0)= -qneti_2D(i,j) -netSW(i,j) +
     &                  Tsrf(i,j,1,1)*dFdT_ice_2D(i,j)
           sFlx(i,j,1)= -qneti_2D(i,j) -netSW(i,j)
           sFlx(i,j,2)= -dFdT_ice_2D(i,j)

C          Note conversion to ice model sign convention below
           sum_prcIce(i,j) = sum_prcIce(i,j) - precipi_2D(i,j)*rhofw
           sum_evapIce(i,j) = sum_evapIce(i,j) - evapi_2D(i,j)*rhofw
           IF (Tair_2D(i,j) .LE. 0. _d 0)
     &      sum_snowPrc(i,j) = sum_snowPrc(i,j) - precipi_2D(i,j)*rhofw

         ENDIF

       ENDDO
      ENDDO


      RETURN
      END

#include "CPP_EEOPTIONS.h"

C--  File write_utils.F: Routine for formatted textual I/O to Standard Output
C--   Contents
C--   o  WRITE_1D_I
C--   o  WRITE_1D_L
C--   o  WRITE_1D_RL
C--   o  WRITE_0D_I
C--   o  WRITE_0D_L
C--   o  WRITE_0D_R4
C--   o  WRITE_0D_R8
C--   o  WRITE_0D_RS
C--   o  WRITE_0D_RL
C--   o  WRITE_0D_C
C--   o  WRITE_COPY1D_R4
C--   o  WRITE_COPY1D_R8
C--   o  WRITE_COPY1D_RS
C--   o  WRITE_XY_XLINE_RS
C--   o  WRITE_XY_YLINE_RS

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

CBOP
C     !ROUTINE: WRITE_1D_I
C     !INTERFACE:
      SUBROUTINE WRITE_1D_I( fld, lFld, index_type, head, comment )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | o SUBROUTINE WRITE_1D_I
C     | Controls formatted, tabular I/O for a one-dimensional
C     | INTEGER field.
C     *==========================================================*
C     | This routine produces a standard format for list
C     | one-dimensional INTEGER data in textual form. The format
C     | is designed to be readily parsed by a post-processing
C     | utility.
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     == Global data ==
#include "SIZE.h"
#include "EEPARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     fld        :: Field to be printed
C     lFld       :: Number of elements (in field "fld") to print
C     index_type :: Type of index labelling (I=,J=,...) to use
C     head       :: Statement start (e.g. phi = )
C     comment    :: Descriptive comment for field
      INTEGER lFld
      INTEGER fld(lFld)
      INTEGER index_type
      CHARACTER*(*) head
      CHARACTER*(*) comment

C     !LOCAL VARIABLES:
C     == Local variables ==
      CHARACTER*(MAX_LEN_MBUF) msgBuf
CEOP

      WRITE(msgBuf,'(A,A)') head, comment
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT , 1)
      CALL PRINT_LIST_I( fld, 1, lFld, index_type, .FALSE.,
     &                   .TRUE., standardMessageUnit )
      WRITE(msgBuf,'(A)')   '    ;     '
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT , 1)

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

CBOP
C     !ROUTINE: WRITE_1D_L
C     !INTERFACE:
      SUBROUTINE WRITE_1D_L( fld, lFld, index_type, head, comment )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | o SUBROUTINE WRITE_1D_L
C     | Controls formatted, tabular I/O for a one-dimensional
C     | LOGICAL field.
C     *==========================================================*
C     | This routine produces a standard format for list
C     | one-dimensional LOGICAL data in textual form. The format
C     | is designed to be readily parsed by a post-processing
C     | utility.
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     == Global data ==
#include "SIZE.h"
#include "EEPARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     fld        :: Field to be printed
C     lFld       :: Number of elements (in field "fld") to print
C     index_type :: Type of index labelling (I=,J=,...) to use
C     head       :: Statement start (e.g. phi = )
C     comment    :: Descriptive comment for field
      INTEGER lFld
      LOGICAL fld(lFld)
      INTEGER index_type
      CHARACTER*(*) head
      CHARACTER*(*) comment

C     !LOCAL VARIABLES:
C     == Local variables ==
      CHARACTER*(MAX_LEN_MBUF) msgBuf
CEOP

      WRITE(msgBuf,'(A,A)') head, comment
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT , 1)
      CALL PRINT_LIST_L( fld, 1, lFld, index_type, .FALSE.,
     &                   .TRUE., standardMessageUnit )
      WRITE(msgBuf,'(A)')   '    ;     '
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT , 1)

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

CBOP
C     !ROUTINE: WRITE_1D_RL
C     !INTERFACE:
      SUBROUTINE WRITE_1D_RL( fld, lFld, index_type, head, comment )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | o SUBROUTINE WRITE_1D_RL
C     | Controls formatted, tabular I/O for a one-dimensional
C     | "RL" type field.
C     *==========================================================*
C     | This routine produces a standard format for list
C     | one-dimensional real*8 data in textual form. The format
C     | is designed to be readily parsed by a post-processing
C     | utility.
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     == Global data ==
#include "SIZE.h"
#include "EEPARAMS.h"
      EXTERNAL ILNBLNK
      INTEGER  ILNBLNK

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     fld        :: Field to be printed
C     lFld       :: Number of elements (in field "fld") to print
C     index_type :: Type of index labelling (I=,J=,...) to use
C     head       :: Statement start (e.g. phi = )
C     comment    :: Descriptive comment for field
      INTEGER lFld
      _RL     fld(lFld)
      INTEGER index_type
      CHARACTER*(*) head
      CHARACTER*(*) comment

C     !LOCAL VARIABLES:
C     == Local variables ==
C     ILH, ILC - Index of last balnk in head and comment
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      INTEGER ILH, ILC
      INTEGER i, j, ic, i1, i2, nCount
      LOGICAL outpAll
      _RL     prev
CEOP

C-    when list is long, try to write just few of them
      outpAll = .TRUE.
      IF ( ( index_type.EQ.INDEX_I .OR. index_type.EQ.INDEX_J )
     &     .AND. lFld.GT.maxLengthPrt1D ) THEN
C-    Count how many would be written
        nCount = 1
        prev = fld(1)
        DO i= 2,lFld
          IF ( fld(i).NE.prev ) nCount = nCount + 1
          prev = fld(i)
        ENDDO
        IF ( nCount.GT.maxLengthPrt1D ) outpAll = .FALSE.
      ENDIF
      ILH=ILNBLNK(head)
      ILC=ILNBLNK(comment)
      WRITE(msgBuf,'(A,A)') head(1:ILH), comment(1:ILC)
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT , 1)
      IF ( outpAll ) THEN
C-    write all of them
        CALL PRINT_LIST_RL( fld, 1, lFld, index_type, .FALSE.,
     &                      .TRUE., standardMessageUnit )
      ELSE
C-    write just 5 sets of 5-6 consecutive values (truncate 1rst and last)
       DO j=1,4
C  e.g. lFld=33 => 1:1+2  9-2:9+2  17-2:17+2 25-2:25+2 33-2:33
C  e.g. lFld=32 => 1:1+2  8-2:9+2  16-2:17+2 24-2:25+2 32-2:32
        ic = (lFld-1)*(j-1)/4
        i1 = 1+ic-2
        i2 = 1+ic+2
        IF ( ic*4 .LT. (lFld-1)*(j-1) ) i2=i2+1
        i1 = MAX(i1,1)
        i2 = MIN(i2,lFld)
        CALL PRINT_LIST_RL( fld(i1), i1, i2, index_type, .TRUE.,
     &                      .FALSE., standardMessageUnit )
        WRITE(msgBuf,'(A)') '     . . .'
        CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                      SQUEEZE_RIGHT , 1)
       ENDDO
        i1 = MAX(lFld-2,1)
        i2 = lFld
        CALL PRINT_LIST_RL( fld(i1), i1, i2, index_type, .FALSE.,
     &                      .FALSE., standardMessageUnit )
      ENDIF
      WRITE(msgBuf,'(A)')   '    ;     '
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT , 1)

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

CBOP
C     !ROUTINE: WRITE_0D_I
C     !INTERFACE:
      SUBROUTINE WRITE_0D_I( fld, index_type, head, comment )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | o SUBROUTINE WRITE_0D_I
C     | Controls formatted, tabular I/O for an INTEGER variable.
C     *==========================================================*
C     | This routine produces a standard format for list
C     | one-dimensional INTEGER data in textual form. The format
C     | is designed to be readily parsed by a post-processing
C     | utility.
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     == Global data ==
#include "SIZE.h"
#include "EEPARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     fld        :: Field to be printed
C     index_type :: Type of index labelling (I=,J=,...) to use
C     head       :: Statement start (e.g. phi = )
C     comment    :: Descriptive comment for field
      INTEGER fld
      INTEGER index_type
      CHARACTER*(*) head
      CHARACTER*(*) comment

C     !LOCAL VARIABLES:
C     == Local variables ==
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      INTEGER idummy(1)
CEOP

      idummy(1) = fld

      WRITE(msgBuf,'(A,A)') head, comment
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT , 1)
      CALL PRINT_LIST_I( idummy, 1, 1, index_type, .FALSE.,
     &                   .TRUE., standardMessageUnit )
      WRITE(msgBuf,'(A)')   '    ;     '
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT , 1)

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

CBOP
C     !ROUTINE: WRITE_0D_L
C     !INTERFACE:
      SUBROUTINE WRITE_0D_L( fld, index_type, head, comment )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | o SUBROUTINE WRITE_0D_L
C     | Controls formatted, tabular I/O for a LOGICAL variable.
C     *==========================================================*
C     | This routine produces a standard format for list
C     | one-dimensional LOGICAL data in textual form. The format
C     | is designed to be readily parsed by a post-processing
C     | utility.
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     == Global data ==
#include "SIZE.h"
#include "EEPARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     fld        :: Field to be printed
C     index_type :: Type of index labelling (I=,J=,...) to use
C     head       :: Statement start (e.g. phi = )
C     comment    :: Descriptive comment for field
      LOGICAL fld
      INTEGER index_type
      CHARACTER*(*) head
      CHARACTER*(*) comment

C     !LOCAL VARIABLES:
C     == Local variables ==
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      LOGICAL ldummy(1)
CEOP

      ldummy(1) = fld
      WRITE(msgBuf,'(A,A)') head, comment
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT , 1)
      CALL PRINT_LIST_L( ldummy, 1, 1, index_type, .FALSE.,
     &                   .TRUE., standardMessageUnit )
      WRITE(msgBuf,'(A)')   '    ;     '
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT , 1)

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

CBOP
C     !ROUTINE: WRITE_0D_R4
C     !INTERFACE:
      SUBROUTINE WRITE_0D_R4( fld, index_type, head, comment )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | o SUBROUTINE WRITE_0D_R4
C     | Controls formatted, tabular I/O for a real*4 variable.
C     *==========================================================*
C     | This routine produces a standard format for list
C     | one-dimensional real*4 data in textual form. The format
C     | is designed to be readily parsed by a post-processing
C     | utility.
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     == Global data ==
#include "SIZE.h"
#include "EEPARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     fld        :: Field to be printed
C     index_type :: Type of index labelling (I=,J=,...) to use
C     head       :: Statement start (e.g. phi = )
C     comment    :: Descriptive comment for field
      Real*4 fld
      INTEGER index_type
      CHARACTER*(*) head
      CHARACTER*(*) comment

C     !LOCAL VARIABLES:
C     == Local variables ==
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      _RL    dummyRL(1)
CEOP

C-    convert to "RL"
      dummyRL(1) = fld

      WRITE(msgBuf,'(A,A)') head, comment
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT , 1)
      CALL PRINT_LIST_RL( dummyRL, 1, 1, index_type, .FALSE.,
     &                    .TRUE., standardMessageUnit )
      WRITE(msgBuf,'(A)')   '    ;     '
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT , 1)

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

CBOP
C     !ROUTINE: WRITE_0D_R8
C     !INTERFACE:
      SUBROUTINE WRITE_0D_R8( fld, index_type, head, comment )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | o SUBROUTINE WRITE_0D_R8
C     | Controls formatted, tabular I/O for a real*8 variable.
C     *==========================================================*
C     | This routine produces a standard format for list
C     | one-dimensional real*8 data in textual form. The format
C     | is designed to be readily parsed by a post-processing
C     | utility.
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     == Global data ==
#include "SIZE.h"
#include "EEPARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     fld        :: Field to be printed
C     index_type :: Type of index labelling (I=,J=,...) to use
C     head       :: Statement start (e.g. phi = )
C     comment    :: Descriptive comment for field
      Real*8 fld
      INTEGER index_type
      CHARACTER*(*) head
      CHARACTER*(*) comment

C     !LOCAL VARIABLES:
C     == Local variables ==
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      _RL    dummyRL(1)
CEOP

C-    convert to "RL"
      dummyRL(1) = fld

      WRITE(msgBuf,'(A,A)') head, comment
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT , 1)
      CALL PRINT_LIST_RL( dummyRL, 1, 1, index_type, .FALSE.,
     &                    .TRUE., standardMessageUnit )
      WRITE(msgBuf,'(A)')   '    ;     '
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT , 1)

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

CBOP
C     !ROUTINE: WRITE_0D_RS
C     !INTERFACE:
      SUBROUTINE WRITE_0D_RS( fld, index_type, head, comment )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | o SUBROUTINE WRITE_0D_RS
C     | Controls formatted, tabular I/O for a real "RS" variable.
C     *==========================================================*
C     | This routine produces a standard format for list
C     | one-dimensional real data in textual form. The format
C     | is designed to be readily parsed by a post-processing
C     | utility.
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     == Global data ==
#include "SIZE.h"
#include "EEPARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     fld        :: Field to be printed
C     index_type :: Type of index labelling (I=,J=,...) to use
C     head       :: Statement start (e.g. phi = )
C     comment    :: Descriptive comment for field
      _RS fld
      INTEGER index_type
      CHARACTER*(*) head
      CHARACTER*(*) comment

C     !LOCAL VARIABLES:
C     == Local variables ==
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      _RL    dummyRL(1)
CEOP

C-    convert to "RL"
      dummyRL(1) = fld

      WRITE(msgBuf,'(A,A)') head, comment
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT , 1)
      CALL PRINT_LIST_RL( dummyRL, 1, 1, index_type, .FALSE.,
     &                    .TRUE., standardMessageUnit )
      WRITE(msgBuf,'(A)')   '    ;     '
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT , 1)

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

CBOP
C     !ROUTINE: WRITE_0D_RL
C     !INTERFACE:
      SUBROUTINE WRITE_0D_RL( fld, index_type, head, comment )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | o SUBROUTINE WRITE_0D_RL
C     | Controls formatted, tabular I/O for a real "RL" variable.
C     *==========================================================*
C     | This routine produces a standard format for list
C     | one-dimensional real data in textual form. The format
C     | is designed to be readily parsed by a post-processing
C     | utility.
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     == Global data ==
#include "SIZE.h"
#include "EEPARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     fld        :: Field to be printed
C     index_type :: Type of index labelling (I=,J=,...) to use
C     head       :: Statement start (e.g. phi = )
C     comment    :: Descriptive comment for field
      _RL    fld
      INTEGER index_type
      CHARACTER*(*) head
      CHARACTER*(*) comment

C     !LOCAL VARIABLES:
C     == Local variables ==
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      _RL    dummyRL(1)
CEOP

C-    copy to array "RL"
      dummyRL(1) = fld

      WRITE(msgBuf,'(A,A)') head, comment
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT , 1)
      CALL PRINT_LIST_RL( dummyRL, 1, 1, index_type, .FALSE.,
     &                    .TRUE., standardMessageUnit )
      WRITE(msgBuf,'(A)')   '    ;     '
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT , 1)

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

CBOP
C     !ROUTINE: WRITE_0D_C
C     !INTERFACE:
      SUBROUTINE WRITE_0D_C( fld, lFld, index_type, head, comment )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | o SUBROUTINE WRITE_0D_C
C     | Controls formatted, tabular I/O for a character string
C     *==========================================================*
C     | This routine produces a standard format for list
C     | a character string data in textual form. The format
C     | is designed to be readily parsed by a post-processing
C     | utility.
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     == Global data ==
#include "SIZE.h"
#include "EEPARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     fld        :: Field to be printed
C     lFld       :: Number of character (in field "fld") to print
C                   0 = all ; -1 & -2 = until the last non-blank
C                  -2 = starting at the first non-blank
C     index_type :: Type of index labelling (I=,J=,...) to use
C     head       :: Statement start (e.g. phi = )
C     comment    :: Descriptive comment for field
      CHARACTER*(*) fld
      INTEGER lFld
      INTEGER index_type
      CHARACTER*(*) head
      CHARACTER*(*) comment

C     !FUNCTIONS:
      INTEGER  IFNBLNK
      INTEGER  ILNBLNK
      EXTERNAL IFNBLNK
      EXTERNAL ILNBLNK

C     !LOCAL VARIABLES:
C     == Local variables ==
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      INTEGER iS,iL
CEOP

      iS = 1
      iL = LEN(fld)
      IF ( lFld .GT. 0 ) THEN
        iL = MIN( lFld, iL )
      ELSEIF ( lFld .LT. 0 ) THEN
        iL = ILNBLNK(fld)
      ENDIF
      IF ( lFld .EQ. -2 ) iS = IFNBLNK(fld)
      iS = MAX(1,iS)

      WRITE(msgBuf,'(A,A)') head, comment
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, 1 )
      IF ( iL.GE.iS ) THEN
        iL = MIN( MAX_LEN_MBUF + iS - 17, iL )
        WRITE(msgBuf,'(14X,3A)') "'", fld(iS:iL), "'"
      ELSE
        WRITE(msgBuf,'(14X,3A)') "'","'"
      ENDIF
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, 1 )
      WRITE(msgBuf,'(A)') '    ;'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, 1 )

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

CBOP
C     !ROUTINE: WRITE_COPY1D_R4
C     !INTERFACE:
      SUBROUTINE WRITE_COPY1D_R4(
     O                        tmpBufRL,
     I                        fld, lFld, index_type, head, comment )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | o SUBROUTINE WRITE_COPY1D_R4
C     | Write as formatted I/O to STDOUT a copy (in "RL" buffer)
C     |  of a one-dimensional real*4 field.
C     *==========================================================*
C     | Copy the 1.D array (fld) to "RL" type buffer (tmpBufRL)
C     |  and then call WRITE_1D_RL;
C     | Length of buffer array must be equal or larger than
C     |  input 1.D field (fld) to write.
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     == Global data ==
#include "SIZE.h"
#include "EEPARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     tmpBufRL   :: buffer ("RL" type) passed to WRITE_1D_RL
C     fld        :: Field to be printed
C     lFld       :: Number of elements (in field "fld") to print
C     index_type :: Type of index labelling (I=,J=,...) to use
C     head       :: Statement start (e.g. phi = )
C     comment    :: Descriptive comment for field
      INTEGER lFld
      _RL    tmpBufRL(lFld)
      Real*4 fld(lFld)
      INTEGER index_type
      CHARACTER*(*) head
      CHARACTER*(*) comment

C     !LOCAL VARIABLES:
C     == Local variables ==
      INTEGER i
CEOP

      DO i=1,lFld
        tmpBufRL(i) = fld(i)
      ENDDO
      CALL WRITE_1D_RL( tmpBufRL, lFld, index_type, head, comment )

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

CBOP
C     !ROUTINE: WRITE_COPY1D_R8
C     !INTERFACE:
      SUBROUTINE WRITE_COPY1D_R8(
     O                        tmpBufRL,
     I                        fld, lFld, index_type, head, comment )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | o SUBROUTINE WRITE_COPY1D_R8
C     | Write as formatted I/O to STDOUT a copy (in "RL" buffer)
C     |  of a one-dimensional real*8 field.
C     *==========================================================*
C     | Copy the 1.D array (fld) to "RL" type buffer (tmpBufRL)
C     |  and then call WRITE_1D_RL;
C     | Length of buffer array must be equal or larger than
C     |  input 1.D field (fld) to write.
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     == Global data ==
#include "SIZE.h"
#include "EEPARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     tmpBufRL   :: buffer ("RL" type) passed to WRITE_1D_RL
C     fld        :: Field to be printed
C     lFld       :: Number of elements (in field "fld") to print
C     index_type :: Type of index labelling (I=,J=,...) to use
C     head       :: Statement start (e.g. phi = )
C     comment    :: Descriptive comment for field
      INTEGER lFld
      _RL    tmpBufRL(lFld)
      Real*8 fld(lFld)
      INTEGER index_type
      CHARACTER*(*) head
      CHARACTER*(*) comment

C     !LOCAL VARIABLES:
C     == Local variables ==
      INTEGER i
CEOP

      DO i=1,lFld
        tmpBufRL(i) = fld(i)
      ENDDO
      CALL WRITE_1D_RL( tmpBufRL, lFld, index_type, head, comment )

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

CBOP
C     !ROUTINE: WRITE_COPY1D_RS
C     !INTERFACE:
      SUBROUTINE WRITE_COPY1D_RS(
     O                        tmpBufRL,
     I                        fld, lFld, index_type, head, comment )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | o SUBROUTINE WRITE_COPY1D_RS
C     | Write as formatted I/O to STDOUT a copy (in "RL" buffer)
C     |  of a one-dimensional RS field.
C     *==========================================================*
C     | Copy the 1.D array (fld) to "RL" type buffer (tmpBufRL)
C     |  and then call WRITE_1D_RL;
C     | Length of buffer array must be equal or larger than
C     |  input 1.D field (fld) to write.
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     == Global data ==
#include "SIZE.h"
#include "EEPARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     tmpBufRL   :: buffer ("RL" type) passed to WRITE_1D_RL
C     fld        :: Field to be printed
C     lFld       :: Number of elements (in field "fld") to print
C     index_type :: Type of index labelling (I=,J=,...) to use
C     head       :: Statement start (e.g. phi = )
C     comment    :: Descriptive comment for field
      INTEGER lFld
      _RL    tmpBufRL(lFld)
      _RS    fld(lFld)
      INTEGER index_type
      CHARACTER*(*) head
      CHARACTER*(*) comment

C     !LOCAL VARIABLES:
C     == Local variables ==
      INTEGER i
CEOP

      DO i=1,lFld
        tmpBufRL(i) = fld(i)
      ENDDO
      CALL WRITE_1D_RL( tmpBufRL, lFld, index_type, head, comment )

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

CBOP
C     !ROUTINE: WRITE_XY_XLINE_RS
C     !INTERFACE:
      SUBROUTINE WRITE_XY_XLINE_RS(
     I                              fld, sCoord, tCoord,
     I                              head, comment )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | o SUBROUTINE WRITE_XY_XLINE_RS
C     | Prints out X row of an XY RS field e.g. phi(:,n,:,m)
C     *==========================================================*
C     | This routine produces a standard format for list
C     | one-dimensional RS data in textual form. The format
C     | is designed to be readily parsed by a post-processing
C     | utility.
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     == Global data ==
#include "SIZE.h"
#include "EEPARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     fld        :: Field to be printed along X.direction
C     sCoord     :: subgrid coordinate
C     tCoord     :: tile coordinate
C     head       :: Statement start (e.g. phi = )
C     comment    :: Descriptive comment for field
      _RS fld(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      INTEGER sCoord
      INTEGER tCoord
      CHARACTER*(*) head
      CHARACTER*(*) comment

C     !FUNCTIONS:
      EXTERNAL IFNBLNK
      INTEGER  IFNBLNK
      EXTERNAL ILNBLNK
      INTEGER  ILNBLNK

C     !LOCAL VARIABLES:
C     == Local variables ==
      CHARACTER*(MAX_LEN_MBUF) msgBuf1
      CHARACTER*(MAX_LEN_MBUF) msgBuf2
      CHARACTER*10 num1, num2
      _RL     xcoord(sNx*nSx)
      INTEGER bi, bj, i, j
      INTEGER IFN1, ILN1, IFN2, ILN2
CEOP

      WRITE(msgBuf1,'(A,A)') head,' = '
      bj = tCoord
      J  = sCoord
      WRITE(num1,'(I10)') J
      WRITE(num2,'(I10)') bj
      IFN1 = IFNBLNK(num1)
      ILN1 = ILNBLNK(num1)
      IFN2 = IFNBLNK(num2)
      ILN2 = ILNBLNK(num2)
C     fld(:,J,:,bj)
      WRITE(msgBuf2,'(A,A,A,A,A,A,A,A,A)')
     & '  /* ', head,'(:,',
     & num1(IFN1:ILN1),',:,',
     & num2(IFN2:ILN2),') ',
     & comment,' */'
      DO bi=1,nSx
       DO I=1,sNx
        xcoord(sNx*(bi-1)+I)=fld(I,J,bi,bj)
       ENDDO
      ENDDO
      CALL WRITE_1D_RL( xcoord, sNx*nSx, INDEX_I,msgBuf1,msgBuf2)

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

CBOP
C     !ROUTINE: WRITE_XY_YLINE_RS
C     !INTERFACE:
      SUBROUTINE WRITE_XY_YLINE_RS(
     I                              fld, sCoord, tCoord,
     I                              head, comment )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | o SUBROUTINE WRITE_XY_YLINE_RS
C     | Prints out Y row of an XY RS field e.g. phi(n,:,m,:)
C     *==========================================================*
C     | This routine produces a standard format for list
C     | one-dimensional RS data in textual form. The format
C     | is designed to be readily parsed by a post-processing
C     | utility.
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     == Global data ==
#include "SIZE.h"
#include "EEPARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     fld        :: Field to be printed along Y.direction
C     sCoord     :: subgrid coordinate
C     tCoord     :: tile coordinate
C     head       :: Statement start (e.g. phi = )
C     comment    :: Descriptive comment for field
      _RS fld(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      INTEGER sCoord
      INTEGER tCoord
      CHARACTER*(*) head
      CHARACTER*(*) comment

C     !FUNCTIONS:
      EXTERNAL IFNBLNK
      INTEGER  IFNBLNK
      EXTERNAL ILNBLNK
      INTEGER  ILNBLNK

C     !LOCAL VARIABLES:
C     == Local variables ==
      CHARACTER*(MAX_LEN_MBUF) msgBuf1
      CHARACTER*(MAX_LEN_MBUF) msgBuf2
      _RL     ycoord(sNy*nSy)
      INTEGER bi, bj, i, j
      CHARACTER*10 num1, num2
      INTEGER IFN1, ILN1, IFN2, ILN2
CEOP

      WRITE(msgBuf1,'(A,A)') head,' = '
      bi = tCoord
      I  = sCoord
      WRITE(num1,'(I10)') I
      WRITE(num2,'(I10)') bi
      IFN1 = IFNBLNK(num1)
      ILN1 = ILNBLNK(num1)
      IFN2 = IFNBLNK(num2)
      ILN2 = ILNBLNK(num2)
C     fld(I,:,bi,:)
      WRITE(msgBuf2,'(A,A,A,A,A,A,A,A,A)')
     & '  /* ',head,'(',
     & num1(IFN1:ILN1),',:,',
     & num2(IFN2:ILN2),',:) ',
     & comment,' */'
      DO bj=1,nSy
       DO J=1,sNy
        ycoord(sNy*(bj-1)+J)=fld(I,J,bi,bj)
       ENDDO
      ENDDO
      CALL WRITE_1D_RL( ycoord, sNy*nSy, INDEX_J,msgBuf1,msgBuf2)

      RETURN
      END

module mixed_layer_mod

!
! Implementation of mixed layer boundary condition
!

!use                  fms_mod, only: set_domain, write_version_number, &
!                                    mpp_pe, mpp_root_pe, error_mesg, FATAL, WARNING

!use                  fms_mod, only: stdlog, check_nml_error, close_file,&
!                                    open_namelist_file, stdout, file_exist, &
!                                    read_data, write_data, open_file

use           gcm_params_mod, only: gcm_LEN_MBUF, gcm_SQZ_R, gcm_stdMsgUnit
use            constants_mod, only: HLV, PI, RHO_CP, CP_AIR

!use         diag_manager_mod, only: register_diag_field, send_data

!use       time_manager_mod,   only: time_type

!use           transforms_mod, only: get_deg_lat

!use            vert_diff_mod, only: surf_diff_type

implicit none
private
!===================================================================================================

character(len=128) :: version = '$Id: mixed_layer_mod.F90,v 1.3 2017/08/11 20:48:51 jmc Exp $'
character(len=128) :: tagname = '$Name:  $'
character(len=128), parameter :: mod_name='mixed_layer'

!===================================================================================================

public :: mixed_layer_init, mixed_layer, mixed_layer_end

!===================================================================================================

logical :: evaporation = .true.
real    :: qflux_amp = 0.0
real    :: qflux_width = 16.0  ! width of qflux region in degrees
real    :: depth = 40.0

namelist/mixed_layer_nml/ evaporation, qflux_amp, depth, qflux_width

!===================================================================================================

logical :: module_is_initialized =.false.
logical :: used

integer :: iter
integer, dimension(4) :: axes
!integer ::                                                                    &
!     id_t_surf,            &   ! surface temperature
!     id_flux_lhe,          &   ! latent heat flux at surface
!     id_flux_oceanq,       &   ! oceanic Q flux
!     id_flux_t                 ! sensible heat flux at surface

!real, allocatable, dimension(:,:)   ::                                        &
!     ocean_qflux,           &   ! Q-flux
!     rad_lat_2d                 ! latitude in radians

!real, allocatable, dimension(:)   :: deg_lat

!real, allocatable, dimension(:,:)   ::                                        &
!     gamma_t,               &   ! Used to calculate the implicit
!     gamma_q,               &   ! correction to the diffusion in
!     fn_t,                  &   ! the lowest layer
!     fn_q,                  &   !
!     en_t,                  &   !
!     en_q,                  &   !
!     alpha_t,               &   !
!     alpha_q,               &   !
!     alpha_lw,              &   !
!     beta_t,                &   !
!     beta_q,                &   !
!     beta_lw,               &   !
!     t_surf_dependence,     &   !
!     corrected_flux,        &   !
!     eff_heat_capacity,     &   ! Effective heat capacity
!     delta_t_surf               ! Increment in surface temperature

real inv_cp_air

!===================================================================================================
contains
!===================================================================================================

!subroutine mixed_layer_init(is, ie, js, je, num_levels, t_surf, axes,  &
!                            rad_lat_2d, ocean_qflux,                   &
subroutine mixed_layer_init( is, ie, js, je, num_levels,         axes,  &
                             Time, cst_mxlDepth, myThid )

integer, intent(in) :: is, ie, js, je, num_levels
!real, intent(inout), dimension(:,:) :: t_surf
integer, intent(in), dimension(4) :: axes
!type(time_type), intent(in)       :: Time
real, intent(in)                   :: Time
real, intent(out)                  :: cst_mxlDepth
integer, intent(in)                :: myThid
!real, intent(in), dimension(:,:)  :: rad_lat_2d
!real, intent(out), dimension(:,:) :: ocean_qflux

!integer :: j
!real    :: rad_qwidth
!integer:: ierr, io, unit
integer         :: iUnit
CHARACTER*(gcm_LEN_MBUF) :: msgBuf

if(module_is_initialized) return

! read namelist and copy to logfile
!    _BARRIER
!    _BEGIN_MASTER(myThid)
     CALL BARRIER(myThid)
     IF ( myThid.EQ.1 ) THEN

     WRITE(msgBuf,'(A)') 'MIXED_LAYER_INIT: opening data.atm_gray'
     CALL PRINT_MESSAGE( msgBuf, gcm_stdMsgUnit, gcm_SQZ_R, myThid )
     CALL OPEN_COPY_DATA_FILE(                                      &
                           'data.atm_gray', 'MIXED_LAYER_INIT',     &
                           iUnit,                                   &
                           myThid )
!    Read parameters from open data file
     READ(UNIT=iUnit,NML=mixed_layer_nml)
     WRITE(msgBuf,'(A)')                                            &
          'MIXED_LAYER_INIT: finished reading data.atm_gray'
     CALL PRINT_MESSAGE( msgBuf, gcm_stdMsgUnit, gcm_SQZ_R, myThid )
!    Close the open data file
#ifdef SINGLE_DISK_IO
     CLOSE(iUnit)
#else
     CLOSE(iUnit,STATUS='DELETE')
#endif /* SINGLE_DISK_IO */

!call write_version_number(version, tagname)

!unit = open_namelist_file ()
!ierr=1
!do while (ierr /= 0)
!  read  (unit, nml=mixed_layer_nml, iostat=io, end=10)
!  ierr = check_nml_error (io, 'mixed_layer_nml')
!enddo
!10 call close_file (unit)

!if ( mpp_pe() == mpp_root_pe() )   write (stdlog(), nml=mixed_layer_nml)

!allocate(rad_lat_2d              (is:ie, js:je))
!allocate(ocean_qflux             (is:ie, js:je))

!allocate(deg_lat                 (js:je))

!allocate(gamma_t                 (is:ie, js:je))
!allocate(gamma_q                 (is:ie, js:je))
!allocate(en_t                    (is:ie, js:je))
!allocate(en_q                    (is:ie, js:je))
!allocate(fn_t                    (is:ie, js:je))
!allocate(fn_q                    (is:ie, js:je))
!allocate(alpha_t                 (is:ie, js:je))
!allocate(alpha_q                 (is:ie, js:je))
!allocate(alpha_lw                (is:ie, js:je))
!allocate(beta_t                  (is:ie, js:je))
!allocate(beta_q                  (is:ie, js:je))
!allocate(beta_lw                 (is:ie, js:je))
!allocate(delta_t_surf            (is:ie, js:je))
!allocate(eff_heat_capacity       (is:ie, js:je))
!allocate(corrected_flux          (is:ie, js:je))
!allocate(t_surf_dependence       (is:ie, js:je))

inv_cp_air = 1.0 / CP_AIR

module_is_initialized = .true.

     ENDIF
     CALL BARRIER(myThid)
     cst_mxlDepth = depth

!see if restart file exists for the surface temperature
!
!if (file_exist('INPUT/mixed_layer.res')) then
!         unit = open_file (file='INPUT/mixed_layer.res', &
!                           form='native', action='read')
!         call read_data (unit, t_surf)
!         call close_file (unit)
!else if (file_exist('INPUT/swamp.res')) then
!         unit = open_file (file='INPUT/swamp.res', &
!                           form='native', action='read')
!         call read_data (unit, t_surf)
!         call close_file (unit)
!  call error_mesg('mixed_layer','mixed_layer restart file not found, using swamp restart file', WARNING)
!else
!  call error_mesg('mixed_layer','mixed_layer restart file not found', WARNING)
!endif

!id_t_surf = register_diag_field(mod_name, 't_surf',        &
!                                axes(1:2), Time, 'surface temperature','K')
!id_flux_t = register_diag_field(mod_name, 'flux_t',        &
!                                axes(1:2), Time, 'sensible heat flux up at surface','watts/m2')
!id_flux_lhe = register_diag_field(mod_name, 'flux_lhe',        &
!                                 axes(1:2), Time, 'latent heat flux up at surface','watts/m2')
!id_flux_oceanq = register_diag_field(mod_name, 'flux_oceanq',        &
!                                 axes(1:2), Time, 'oceanic Q-flux','watts/m2')

! latitude will be needed for oceanic q flux
!call get_deg_lat(deg_lat)
!do j=js,je
!  rad_lat_2d(:,j) = deg_lat(j)*PI/180.
!enddo

! calculate ocean Q flux
!rad_qwidth = qflux_width*PI/180.
!ocean_qflux = qflux_amp*(1-2.*rad_lat_2d**2/rad_qwidth**2) * &
!        exp(- ((rad_lat_2d)**2/(rad_qwidth)**2))

return
end subroutine mixed_layer_init

!===================================================================================================

subroutine mixed_layer (                                &
     Time,                                              &
     t_surf,                                            &
     flux_t,                                            &
     flux_q,                                            &
     flux_r,                                            &
     dt,                                                &
     net_surf_sw_down,                                  &
     surf_lw_down,                                      &
!    Tri_surf,                                          &
                tri_surf_dtmass,                               &
                tri_surf_dflux_t, tri_surf_dflux_q,            &
                tri_surf_delta_t, tri_surf_delta_q,            &
     dhdt_surf,                                         &
     dedt_surf,                                         &
     dedq_surf,                                         &
     drdt_surf,                                         &
     dhdt_atm,                                          &
     dedq_atm,                                          &
     ocean_qflux, mixLayDepth,                          &
     delta_t_surf, &               ! Increment in surface temperature
     myThid )

! ---- arguments -----------------------------------------------------------
!type(time_type), intent(in)       :: Time
real, intent(in)                  :: Time
real, intent(in),  dimension(:,:) :: &
     net_surf_sw_down, surf_lw_down
real, intent(inout), dimension(:,:) :: &
     flux_t,    flux_q,     flux_r
real, intent(inout), dimension(:,:) :: t_surf
real, intent(in), dimension(:,:) :: &
   dhdt_surf, dedt_surf, dedq_surf, &
   drdt_surf, dhdt_atm, dedq_atm
real, intent(in) :: dt
!type(surf_diff_type), intent(inout) :: Tri_surf
real, intent(inout), dimension(:,:)  :: tri_surf_dtmass
real, intent(inout), dimension(:,:)  :: tri_surf_dflux_t, tri_surf_dflux_q
real, intent(inout), dimension(:,:)  :: tri_surf_delta_t, tri_surf_delta_q
real, intent(in),    dimension(:,:)  :: ocean_qflux
real, intent(in),    dimension(:,:)  :: mixLayDepth
real, intent(out),   dimension(:,:)  :: delta_t_surf
integer, intent(in) :: myThid

! ---- local variables --------------------------------------------------
real, allocatable, dimension(:,:)   ::                                        &
     gamma_t,               &   ! Used to calculate the implicit
     gamma_q,               &   ! correction to the diffusion in
     fn_t,                  &   ! the lowest layer
     fn_q,                  &   !
     en_t,                  &   !
     en_q,                  &   !
     alpha_t,               &   !
     alpha_q,               &   !
     alpha_lw,              &   !
     beta_t,                &   !
     beta_q,                &   !
     beta_lw,               &   !
     t_surf_dependence,     &   !
     corrected_flux,        &   !
     eff_heat_capacity          ! Effective heat capacity
!    eff_heat_capacity,     &   ! Effective heat capacity
!    delta_t_surf               ! Increment in surface temperature
integer :: im, jm
!----------------------------------------------------------------

im = size(t_surf,1)
jm = size(t_surf,2)
allocate(gamma_t            (im,jm) )
allocate(gamma_q            (im,jm) )
allocate(en_t               (im,jm) )
allocate(en_q               (im,jm) )
allocate(fn_t               (im,jm) )
allocate(fn_q               (im,jm) )
allocate(alpha_t            (im,jm) )
allocate(alpha_q            (im,jm) )
allocate(alpha_lw           (im,jm) )
allocate(beta_t             (im,jm) )
allocate(beta_q             (im,jm) )
allocate(beta_lw            (im,jm) )
allocate(eff_heat_capacity  (im,jm) )
allocate(corrected_flux     (im,jm) )
allocate(t_surf_dependence  (im,jm) )
!allocate(delta_t_surf       (im,jm) )

if(.not.module_is_initialized) then
! call error_mesg('mixed_layer','mixed_layer module is not initialized',FATAL)
  call PRINT_ERROR('mixed_layer: mixed_layer module is not initialized',myThid)
  STOP 'ABNORMAL END: S/R MIXED_LAYER'
endif

! Need to calculate the implicit changes to the lowest level delta_q and delta_t
! - see the discussion in vert_diff.tech.ps

! Care is needed to differentiate between the sensible heat flux and the
! diffusive flux of temperature

gamma_t = 1.0 / (1.0 - Tri_surf_dtmass * (Tri_surf_dflux_t + dhdt_atm * inv_cp_air))
gamma_q = 1.0 / (1.0 - Tri_surf_dtmass * (Tri_surf_dflux_q + dedq_atm))

fn_t = gamma_t * (Tri_surf_delta_t + Tri_surf_dtmass * flux_t * inv_cp_air)
fn_q = gamma_q * (Tri_surf_delta_q + Tri_surf_dtmass * flux_q)

en_t = gamma_t * Tri_surf_dtmass * dhdt_surf * inv_cp_air
en_q = gamma_q * Tri_surf_dtmass * dedt_surf

!
! Note flux_sw doesn't depend on surface or lowest layer values
! Note drdt_atm is not used - should be fixed
!
alpha_t = flux_t * inv_cp_air + dhdt_atm * inv_cp_air * fn_t
alpha_q = flux_q + dedq_atm * fn_q
alpha_lw = flux_r

beta_t = dhdt_surf * inv_cp_air + dhdt_atm * inv_cp_air * en_t
beta_q = dedt_surf + dedq_atm * en_q
beta_lw = drdt_surf

!
! Implement mixed layer surface boundary condition
!
corrected_flux = - net_surf_sw_down - surf_lw_down + alpha_t * CP_AIR + alpha_lw + ocean_qflux
t_surf_dependence = beta_t * CP_AIR + beta_lw

if (evaporation) then
  corrected_flux = corrected_flux + alpha_q * HLV
  t_surf_dependence = t_surf_dependence + beta_q * HLV
endif

!
! Now update the mixed layer surface temperature using an implicit step
!
!eff_heat_capacity = depth * RHO_CP + t_surf_dependence * dt
eff_heat_capacity = mixLayDepth * RHO_CP + t_surf_dependence * dt

if (any(eff_heat_capacity .eq. 0.0))  then
  write(*,*) 'mixed_layer: error', eff_heat_capacity
! call error_mesg('mixed_layer', 'Avoiding division by zero',fatal)
  call PRINT_ERROR('mixed_layer: Avoiding division by zero',myThid)
  STOP 'ABNORMAL END: S/R MIXED_LAYER'
end if

delta_t_surf = - corrected_flux  * dt / eff_heat_capacity

t_surf = t_surf + delta_t_surf

! Finally calculate the increments for the lowest atmospheric layer
!
Tri_surf_delta_t = fn_t + en_t * delta_t_surf
Tri_surf_delta_q = fn_q + en_q * delta_t_surf

! Note:
! When using an implicit step there is not a clearly defined flux for a given timestep

! Final flux values (match mixed layer heat content variations)
  flux_t = ( alpha_t  + delta_t_surf*beta_t )*CP_AIR
  flux_r =   alpha_lw + delta_t_surf*beta_lw
  flux_q =   alpha_q  + delta_t_surf*beta_q

!if(id_t_surf > 0) used = send_data(id_t_surf, t_surf, Time)
!if(id_flux_t > 0) used = send_data(id_flux_t, flux_t, Time)
!if(id_flux_lhe > 0) used = send_data(id_flux_lhe, HLV * flux_q, Time)
!if(id_flux_oceanq > 0)   used = send_data(id_flux_oceanq, ocean_qflux, Time)

deallocate(gamma_t            )
deallocate(gamma_q            )
deallocate(en_t               )
deallocate(en_q               )
deallocate(fn_t               )
deallocate(fn_q               )
deallocate(alpha_t            )
deallocate(alpha_q            )
deallocate(alpha_lw           )
deallocate(beta_t             )
deallocate(beta_q             )
deallocate(beta_lw            )
deallocate(eff_heat_capacity  )
deallocate(corrected_flux     )
deallocate(t_surf_dependence  )
!deallocate(delta_t_surf       )

end subroutine mixed_layer

!===================================================================================================

subroutine mixed_layer_end(t_surf,myThid)

real, intent(inout), dimension(:,:) :: t_surf
integer, intent(in)                :: myThid

!integer:: unit

if(.not.module_is_initialized) return

! write a restart file for the surface temperature
!unit = open_file ('RESTART/mixed_layer.res', &
!                  form='native', action='write')
!call write_data (unit, t_surf)
!call close_File (unit)

module_is_initialized = .false.

end subroutine mixed_layer_end

!===================================================================================================

end module mixed_layer_mod

#include "MATRIX_OPTIONS.h"

      SUBROUTINE MATRIX_WRITE_GRID( myThid )

      IMPLICIT NONE

#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"

      INTEGER myThid

#ifdef ALLOW_MATRIX

C     local variables:

      IF (useMatrix) THEN
        CALL WRITE_FLD_XY_RS( 'DXF',' ',DXF,0,myThid)
        CALL WRITE_FLD_XY_RS( 'DYF',' ',DYF,0,myThid)
      ENDIF

#endif /* ALLOW_MATRIX */
      RETURN
      END

CBOI
C
C !TITLE: WRAPPER CODE SYNOPSIS
C !AUTHORS: mitgcm developers ( support@mitgcm.org )
C !AFFILIATION: Massachussetts Institute of Technology
C !DATE:
C !INTRODUCTION:
C     Wrapper synopsis and code Routines in the subdirectories under
C     eesupp/ ( src/ and inc/ ) provide the core framework within which
C     numerical and ancilliary software of MITgcm operates.  The eesupp/
C     directories provide a collection of software we call {\bf WRAPPER}
C     ( ({\bf W}rappable {\bf A}pplication {\bf P}aralell {\bf
C     P}rogramming {\bf E}nvironment {\bf R}esource).  The {bf WRAPPER}
C     provides a generic bootstrapping capability to start applications
C     in a manner that allows them to exploit single and
C     multi-processing environments on all present day hardware
C     platforms (spanning vector SMP systems to distributed memory and
C     processing cluster systems). Numerical applications must be coded
C     to fit within the {\bf WRAPPER}. This entails applications
C     adopting a particular style for declaring data structures
C     representing grids and values on grids. The {\bf WRAPPER}
C     currently provides support for grid point models using a single
C     global indexing system. This is sufficient for latitude-logitude,
C     cylindrical, and cartesian coordinate configurations. There is
C     also limited support for composing grids in which no single,
C     sructured global index can be defined. At present, this support is
C     limited to specific configurations of projections of a cube onto
C     the sphere.
C
C     The main functions supported by the current {\bf WRAPPER} code are
C     \begin{itemize}
C     \item program startup and termination including
C       creation/management of multiple threads and/or processes
C     \item communication and synchronisatioin operations between
C       multiple processes and/or threads
C     \item multi-process input and output operations to disk and to
C       other applications
C     \end{itemize}
C
C     Multi-process execution assumes the existence of MPI for process
C     startup and termination. However, MPI does not have to be used for
C     performance critical operations. Instead, {\bf WRAPPER}
C     performance critical parallel primitives are implemented to allow
C     them to bind to different low-level system software
C     layers. Bindings exist for using {\bf WRAPPER} with portable
C     systems such as MPI and UNIX System V IPC memory mapping, as well
C     bindings for high-performance propreitary systems such as Myrinet
C     GM software and Compaq IMC memory channel technology.
C
CEOI

C--   Get C preprocessor options
#include "PACKAGES_CONFIG.h"
#include "CPP_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C !ROUTINE: MAIN

C !INTERFACE:
      PROGRAM MAIN

C !DESCRIPTION:
C     *==========================================================*
C     | PROGRAM MAIN
C     | o MAIN wrapper for MITgcm UV implementation.
C     *==========================================================*
C     | MAIN controls the "execution environment".
C     | Its main functions are
C     | 1. call procedure EEBOOT to perform execution environment
C     |    initialisation.
C     | 2. call procedure THE\_MODEL\_MAIN once for each concurrent
C     |    thread. THE\_MODEL\_MAIN is the user supplied top-level
C     |    routine.
C     | 3. call procedure EEDIE to perform execution environment
C     |    shutdown.
C     *==========================================================*

C      !CALLING SEQUENCE:
C
C      main()
C      |
C      |--eeboot()         :: WRAPPER initilization
C      |
C      |--check_threads()  :: Validate multiple thread start up.
C      |
C      |--the_model_main() :: Numerical code top-level driver routine
C      |
C      |--eedie()          :: WRAPPER termination

C     !USES:
      IMPLICIT NONE

C     == Global variables ==
C     Include all the "shared" data here. That means all common
C     blocks used in the model. On many implementations this is not
C     necessary but doing this is the safest method.
#include "SIZE.h"
#include "EEPARAMS.h"
#include "EESUPPORT.h"
#include "PARAMS.h"
#include "GRID.h"
#include "DYNVARS.h"
#include "FFIELDS.h"
#include "SURFACE.h"
#ifdef HAVE_SIGREG
#include "SIGREG.h"
#endif

C     !LOCAL VARIABLES:
C     msgBuf       :: I/O message buffer
C     I            :: loop counter
C     myThid       :: thread Id number
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      INTEGER myThid
      INTEGER I
      INTEGER dummyComm

#ifdef USE_OMP_THREADING
      INTEGER OMP_GET_THREAD_NUM
      EXTERNAL OMP_GET_THREAD_NUM
#endif

CEOP

#ifdef USE_GSL_IEEE
      CALL FGSL_IEEE_ENV_SETUP ()
#endif

C--   Set up the execution environment
C     EEBOOT loads a execution environment parameter file
C     ( called "eedata" by default ) and sets variables accordingly.
      dummyComm = -1
      CALL EEBOOT( dummyComm )

C--   Trap errors
      IF ( eeBootError ) THEN
       fatalError = .TRUE.
       GOTO 999
      ENDIF

#ifdef HAVE_SETRLSTK
      IF (useSETRLSTK) THEN
        CALL setrlstk
      ENDIF
#endif

#ifdef HAVE_SIGREG
      IF (useSIGREG) THEN
        i_got_signal = 0
        CALL sigreg( i_got_signal )
      ENDIF
#endif

#ifdef HAVE_PTHREADS
c      IF (usePTHREADS) THEN
        CALL PTINIT(nThreads)
c      ELSE
#else

C--   Start nThreads concurrent threads.
C     Note: We do a fiddly check here. The check is performed
C           by CHECK_THREADS. CHECK_THREADS does a count
C           of all the threads. If after ten seconds it has not
C           found nThreads threads are running it flags an
C           error. This traps the case in which the input
C           parameter nThreads is different from the actual
C           number of concurrent threads the OS gives us. This
C           case causes a deadlock if we do not trap it here.
#include "MAIN_PDIRECTIVES1.h"
      DO I=1,nThreads
#ifdef USE_OMP_THREADING
        IF ( OMP_GET_THREAD_NUM() .EQ. I-1 ) THEN
#endif
         myThid = I

C--      Do check to see if there are nThreads threads running
         IF ( .NOT. eeBootError ) THEN
          CALL CHECK_THREADS( myThid )
         ENDIF

C--      Invoke nThreads instances of the numerical model
         IF ( .NOT. eeBootError ) THEN
#if (defined (ALLOW_ADMTLM))
          CALL ADMTLM_DSVD(myThid)
#elif (defined (ALLOW_HESSIAN_CODE))
          CALL HESSIAN_MAIN(myThid)
#else
          CALL THE_MODEL_MAIN(myThid)
#endif
         ENDIF

C--      Each threads sets flag indicating it is done
         threadIsComplete(myThid) = .TRUE.
         IF ( .NOT. eeBootError ) THEN
          _BARRIER
         ENDIF
#ifdef USE_OMP_THREADING
        ENDIF
#endif
      ENDDO
#include "MAIN_PDIRECTIVES2.h"

#endif  /*  HAVE_PTHREADS  */

  999 CONTINUE
C--   Shut down execution environment
      CALL EEDIE

C--   Write closedown status
      IF ( fatalError ) THEN
       WRITE( msgBuf,'(A)') 'PROGRAM MAIN: ends with fatal Error'
       CALL PRINT_ERROR( msgBuf, 1 )
       WRITE(standardMessageUnit,'(A)')
     &      'PROGRAM MAIN: ends with fatal Error'
       STOP 'ABNORMAL END: PROGRAM MAIN'
      ELSE
       WRITE(standardMessageUnit,'(A)')
     &      'PROGRAM MAIN: Execution ended Normally'
       STOP 'NORMAL END'
      ENDIF

      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

CBOP 0
C     !ROUTINE: PTREENTRY

C     !INTERFACE:
      SUBROUTINE PTREENTRY(
     I     myThid )

C     !DESCRIPTION:
C     Re-entry point for a pthreads-based threading mechanism.  The
C     intent is to produce a threading hack that will work with gcc/g77.

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "EESUPPORT.h"
#include "PARAMS.h"
#include "GRID.h"
#include "DYNVARS.h"
#include "FFIELDS.h"
#include "SURFACE.h"

C     !INPUT PARAMETERS:
C     myThid       :: my thread Id number
      INTEGER myThid
CEOP

      WRITE(*,*) 'myThid = ', myThid
      CALL CHECK_THREADS( myThid )

c     CALL THE_MODEL_MAIN(myThid)

      threadIsComplete(myThid) = .TRUE.

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#include "PACKAGES_CONFIG.h"
#include "CPP_OPTIONS.h"
#ifdef ALLOW_AUTODIFF
# include "AUTODIFF_OPTIONS.h"
#endif
#ifdef ALLOW_CTRL
# include "CTRL_OPTIONS.h"
#endif
#ifdef ALLOW_TAPENADE
# ifdef ALLOW_SHELFICE
#  include "SHELFICE_OPTIONS.h"
# endif
# ifdef ALLOW_GMREDI
#  include "GMREDI_OPTIONS.h"
# endif
# ifdef ALLOW_EXF
#  include "EXF_OPTIONS.h"
# endif
# ifdef ALLOW_SEAICE
#  include "SEAICE_OPTIONS.h"
# endif
# ifdef ALLOW_ECCO
#  include "ECCO_OPTIONS.h"
# endif
c# ifdef ALLOW_THSICE
c# include "THSICE_OPTIONS.h"
c# endif
# ifdef ALLOW_BLING
#  include "BLING_OPTIONS.h"
# endif
#endif /* ALLOW_TAPENADE */

CBOP
C     !ROUTINE: INITIALISE_VARIA
C     !INTERFACE:
      SUBROUTINE INITIALISE_VARIA( myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE INITIALISE_VARIA
C     | o Set the initial conditions for dynamics variables
C     |   and time dependent arrays
C     *==========================================================*
C     | This routine reads/writes  data from an input file and
C     | from various binary files.
C     | Each thread invokes an instance of this routine as does
C     | each process in a multi-process parallel environment like
C     | MPI.
C     *==========================================================*
C     \ev

C     !CALLING SEQUENCE:
C     INITIALISE_VARIA
C       |
C #ifdef ALLOW_AUTODIFF
C       |-- INI_DEPTHS         \
C       |-- CTRL_DEPTH_INI      \
C       |-- UPDATE_MASKS_ETC     } ALLOW_DEPTH_CONTROL case
C       |-- UPDATE_CG2D         /
C #endif
C       |-- INI_NLFS_VARS
C       |-- INI_DYNVARS
C       |-- INI_NH_VARS
C       |-- INI_FFIELDS
C       |
C       |-- INI_FIELDS
C       |
C       |-- INI_MIXING
C       |
C       |-- TAUEDDY_INIT_VARIA
C       |
C       |-- INI_FORCING
C       |
C       |-- AUTODIFF_INIT_VARIA
C       |
C       |-- PACKAGES_INIT_VARIABLES
C       |
C       |-- COST_INIT_VARIA
C       |
C       |-- CONVECTIVE_ADJUSTMENT_INI
C       |
C       |-- CALC_R_STAR
C       |-- UPDATE_R_STAR
C       |-- UPDATE_SIGMA
C       |-- CALC_SURF_DR
C       |-- UPDATE_SURF_DR
C       |
C       |-- UPDATE_CG2D
C       |
C       |-- INTEGR_CONTINUITY
C       |
C       |-- CALC_R_STAR
C       |-- CALC_SURF_DR
C       |
C       |-- STATE_SUMMARY
C       |
C       |-- MONITOR
C       |
C       |-- DO_THE_MODEL_IO

C     !USES:
      IMPLICIT NONE
C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "DYNVARS.h"
#include "SURFACE.h"
#ifdef ALLOW_AUTODIFF
# include "GRID.h"
# include "FFIELDS.h"
# if ( defined ALLOW_CTRL && defined ALLOW_GENTIM2D_CONTROL && !defined ALLOW_TAPENADE )
#  include "CTRL_SIZE.h"
#  include "CTRL_DUMMY.h"
# endif
#endif /* ALLOW_AUTODIFF */

#ifdef ALLOW_TAPENADE
# ifdef ALLOW_GMREDI
#  include "GMREDI.h"
# endif
# ifdef ALLOW_CTRL
#  include "CTRL_SIZE.h"
#  include "CTRL.h"
#  include "CTRL_GENARR.h"
#  include "CTRL_DUMMY.h"
# endif
# ifdef ALLOW_CD_CODE
#  include "CD_CODE_VARS.h"
# endif
# ifdef ALLOW_DIC
#  include "DIC_VARS.h"
#  include "DIC_ATMOS.h"
#  include "DIC_LOAD.h"
# endif
# ifdef ALLOW_PTRACERS
#  include "PTRACERS_SIZE.h"
#  include "PTRACERS_FIELDS.h"
#  include "PTRACERS_PARAMS.h"
# endif
# ifdef ALLOW_GENERIC_ADVDIFF
#  include "GAD_SOM_VARS.h"
# endif
# ifdef ALLOW_EXF
#  include "EXF_PARAM.h"
#  include "EXF_INTERP_SIZE.h"
#  include "EXF_INTERP_PARAM.h"
#  include "EXF_FIELDS.h"
# endif
# ifdef ALLOW_STREAMICE
#  include "STREAMICE.h"
#  include "STREAMICE_CG.h"
# endif
# ifdef ALLOW_THSICE
#  include "THSICE_VARS.h"
# endif
# ifdef ALLOW_SEAICE
#  include "SEAICE_SIZE.h"
#  include "SEAICE.h"
# endif
# ifdef ALLOW_ECCO
#  include "ECCO_SIZE.h"
#  include "ECCO.h"
# endif
# ifdef ALLOW_BLING
#  include "BLING_VARS.h"
#  include "BLING_LOAD.h"
# endif
#endif /* ALLOW_TAPENADE */

C     !INPUT/OUTPUT PARAMETERS:
      INTEGER myThid

C     !LOCAL VARIABLES:
#ifdef INCLUDE_CONVECT_INI_CALL
      INTEGER bi,bj
#endif
CEOP

#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_ENTER('INITIALISE_VARIA',myThid)
#endif

#ifdef ALLOW_AUTODIFF
      nIter0 = NINT( (startTime-baseTime)/deltaTClock )
#endif /* ALLOW_AUTODIFF */

#ifdef ALLOW_DEPTH_CONTROL
C--   Intialize the depth for TAF
      CALL INI_DEPTHS( myThid )
C--   Get control parameter depth
      CALL CTRL_DEPTH_INI( myThid )
C--   Re-calculate hFacS/W and some other parameters from hFacC
      CALL UPDATE_MASKS_ETC( myThid )
C--   Update laplace operators for use in 2D conjugate gradient solver.
      CALL UPDATE_CG2D( startTime, nIter0, myThid )
#endif /* ALLOW_DEPTH_CONTROL */

C--   Initialise Non-Lin FreeSurf variables:
      CALL INI_NLFS_VARS( myThid )

C--   Initialize DYNVARS arrays (state fields + G terms: Gu,Gv,...) to zero [always]
#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_CALL('INI_DYNVARS',myThid)
#endif
      CALL INI_DYNVARS( myThid )

C--   Initialize NH_VARS arrays to zero [always]
#ifdef ALLOW_NONHYDROSTATIC
      CALL INI_NH_VARS( myThid )
#endif

C--   Initialize FFIELDS arrays to zero [always]
      CALL INI_FFIELDS( myThid )

C--   Initialise model fields.
C     Starting values of U, V, W, temp., salt. and tendency terms
C     are set here. Fields are either set to default or read from
C     stored files.
#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_CALL('INI_FIELDS',myThid)
#endif
#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE phi0surf = tapelev_init, key = 1
#endif
      CALL INI_FIELDS( myThid )

C--   Initialise 3-dim. diffusivities
#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_CALL('INI_MIXING',myThid)
#endif
      CALL INI_MIXING( myThid )

#ifdef ALLOW_EDDYPSI
C--  Initialise eddy diffusivities
      CALL TAUEDDY_INIT_VARIA( myThid )
#endif

C--   Initialise model forcing fields.
#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_CALL('INI_FORCING',myThid)
#endif
      CALL INI_FORCING( myThid )

#ifdef ALLOW_AUTODIFF
C--   Initialise active fields to help TAF
      if (useAUTODIFF) CALL AUTODIFF_INIT_VARIA( myThid )
#endif

C--   Initialize variable data for packages
#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_CALL('PACKAGES_INIT_VARIABLES',myThid)
#endif
#ifdef ALLOW_AUTODIFF_TAMC
# ifdef NONLIN_FRSURF
CADJ STORE recip_hFacC = tapelev_init, key = 1
# endif
# ifdef ALLOW_GENTIM2D_CONTROL
C     It not clear, why this is needed and hopefully we will find a
C     better way to avoid the recomputation warning.
CADJ STORE xx_gentim2d_dummy = dummytape, key = 1
# endif
#endif
      CALL PACKAGES_INIT_VARIABLES( myThid )

#ifdef ALLOW_COST
C--   Initialise the cost function (moved out of packages_init_variables to
C     here to prevent resetting cost-funct in adinitialise_varia recomput.)
      CALL COST_INIT_VARIA( myThid )
#endif /* ALLOW_COST */

c#ifndef ALLOW_AUTODIFF
c     IF ( usePickupBeforeC35 .AND. startTime .NE. baseTime ) THEN
C-- IMPORTANT : Need to activate the following call to restart from a pickup
C     file written by MITgcmUV_checkpoint34 (Feb-08, 2001) or earlier.
C-  Disable this option on Jan-09, 2007.
c      CALL THE_CORRECTION_STEP(startTime, nIter0, myThid)
c     ENDIF
c#endif

#ifdef INCLUDE_CONVECT_INI_CALL
C--   Initial conditions are convectively adjusted (for historical reasons)
      IF ( startTime .EQ. baseTime .AND. cAdjFreq .NE. 0. ) THEN
#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_CALL('CONVECTIVE_ADJUSTMENT_INI',myThid)
#endif
CADJ loop = parallel
        DO bj = myByLo(myThid), myByHi(myThid)
CADJ loop = parallel
         DO bi = myBxLo(myThid), myBxHi(myThid)
           CALL CONVECTIVE_ADJUSTMENT_INI(
     I                     bi, bj, startTime, nIter0, myThid )
         ENDDO
        ENDDO
      ENDIF
#endif /* INCLUDE_CONVECT_INI_CALL */

#ifdef NONLIN_FRSURF
C--   Compute the surface level thickness <-- function of etaH(n)
C     and modify hFac(C,W,S) accordingly :
# ifndef DISABLE_RSTAR_CODE
      IF ( select_rStar.NE.0 )
     &  CALL CALC_R_STAR(etaH, startTime, -1 , myThid )
# endif /* DISABLE_RSTAR_CODE */
      IF ( nonlinFreeSurf.GT.0 ) THEN
       IF ( select_rStar.GT.0 ) THEN
# ifndef DISABLE_RSTAR_CODE
        CALL UPDATE_R_STAR( .TRUE., startTime, nIter0, myThid )
# endif /* DISABLE_RSTAR_CODE */
       ELSEIF ( selectSigmaCoord.NE.0 ) THEN
# ifndef DISABLE_SIGMA_CODE
        CALL UPDATE_SIGMA( etaH, startTime, nIter0, myThid )
# endif /* DISABLE_SIGMA_CODE */
       ELSE
        CALL CALC_SURF_DR(etaH, startTime, -1 , myThid )
#ifdef ALLOW_AUTODIFF_TAMC
C     These fields are only updated in the surface layer and TAF gets
C     confused about it so that their contribution is not always added
C     to the hfac*_ad lateron. This directive fixes that.
CADJ INCOMPLETE recip_hFacC, recip_hFacW, recip_hFacS
#endif /* ALLOW_AUTODIFF_TAMC */
        CALL UPDATE_SURF_DR( .TRUE., startTime, nIter0, myThid )
       ENDIF
      ENDIF
C-    update also CG2D matrix (and preconditioner)
      IF ( nonlinFreeSurf.GT.2 ) THEN
        CALL UPDATE_CG2D( startTime, nIter0, myThid )
      ENDIF
#endif /* NONLIN_FRSURF */

#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_CALL('INTEGR_CONTINUITY',myThid)
#endif
C--   Integrate continuity vertically for vertical velocity
      CALL INTEGR_CONTINUITY( uVel, vVel,
     I                        startTime, nIter0, myThid )

#ifdef NONLIN_FRSURF
      IF ( select_rStar.NE.0 ) THEN
#ifndef DISABLE_RSTAR_CODE
C--   r* : compute the future level thickness according to etaH(n+1)
          CALL CALC_R_STAR(etaH, startTime, nIter0, myThid )
#endif
      ELSEIF ( nonlinFreeSurf.GT.0 .AND. selectSigmaCoord.EQ.0 ) THEN
C--   compute the future surface level thickness according to etaH(n+1)
          CALL CALC_SURF_DR(etaH, startTime, nIter0, myThid )
      ENDIF
#endif /* NONLIN_FRSURF */

c     IF ( nIter0.EQ.0 .AND. staggerTimeStep ) THEN
C--    Filter initial T & S fields if staggerTimeStep
C       (only for backward compatibility ; to be removed later)
#ifdef ALLOW_SHAP_FILT
c      IF ( useSHAP_FILT .AND. shap_filt_TrStagg ) THEN
c       CALL SHAP_FILT_APPLY_TS(theta,salt,startTime,nIter0,myThid)
c      ENDIF
#endif
#ifdef ALLOW_ZONAL_FILT
c      IF ( useZONAL_FILT .AND. zonal_filt_TrStagg ) THEN
c       CALL ZONAL_FILT_APPLY_TS( theta, salt, myThid )
c      ENDIF
#endif
c     ENDIF

#ifdef ALLOW_GRIDALT
      IF (useGRIDALT) THEN
         CALL TIMER_START('GRIDALT_UPDATE  [INITIALISE_VARIA]',myThid)
         CALL GRIDALT_UPDATE(myThid)
         CALL TIMER_STOP ('GRIDALT_UPDATE  [INITIALISE_VARIA]',myThid)
      ENDIF
#endif

C--   Finally summarise the model state
#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_CALL('STATE_SUMMARY',myThid)
#endif
      CALL STATE_SUMMARY( myThid )

#ifdef ALLOW_MONITOR
#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_CALL('MONITOR',myThid)
#endif
C--   Check status of initial state (statistics, cfl, etc...)
      CALL MONITOR( startTime, nIter0, myThid )
#endif /* ALLOW_MONITOR */

C--   Dump initial state to files
#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_CALL('DO_THE_MODEL_IO',myThid)
#endif
      CALL DO_THE_MODEL_IO( .FALSE., startTime, nIter0, myThid )

#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_LEAVE('INITIALISE_VARIA',myThid)
#endif

C--   Check barrier synchronization:
      CALL BAR_CHECK( 4, myThid )

      RETURN
      END

#include "STREAMICE_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

CBOP
      SUBROUTINE STREAMICE_PETSC_NUMERATE (myThid)

C     *============================================================*
C     | SUBROUTINE                                                 |
C     | o                                                          |
C     *============================================================*
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "GRID.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "STREAMICE.h"
#ifdef ALLOW_PETSC
#ifdef ALLOW_USE_MPI
#include "EESUPPORT.h"
#endif
#endif

      INTEGER myThid

#ifdef ALLOW_STREAMICE

#ifdef ALLOW_PETSC
      INTEGER i, j, bi, bj
c     CHARACTER*(MAX_LEN_MBUF) msgBuf
#ifdef ALLOW_USE_MPI
      integer mpiRC
#endif
      integer mpimywid
      _RS DoFCount
      integer n_dofs_proc_loc (0:nPx*nPy-1)
      integer n_dofs_cum_sum (0:nPx*nPy-1)

      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
        DO j=1,sNy
         DO i=1,sNx
           streamice_petsc_dofs_u (i,j,bi,bj) = -2.0
           streamice_petsc_dofs_v (i,j,bi,bj) = -2.0
         ENDDO
        ENDDO
       ENDDO
      ENDDO

      DoFCount = -1.0
      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
        DO j=1,sNy
         DO i=1,sNx

C   DOFS ARE NUMBERED AS FOLLOWS ON PROCESSOR DOMAIN:
C    grid is stepped through in order bj, bi, j, i
C    1) if umask(i,j,bi,bj)==1, the counter is updated by 1;
C        streamice_petsc_dofs_u is assigned the counter;
C        o/w  streamice_petsc_dofs_u is assigned -1
C    2) if vmask(i,j,bi,bj)==1, the counter is updated by 1;
C        streamice_petsc_dofs_v is assigned the counter;
C        o/w  streamice_petsc_dofs_v is assigned -1
C    NOTE THESE NUMBERING ARRAYS ARE USED TO CONSTRUCT PETSC VECTORS AND MATRIX

          if (STREAMICE_umask (i,j,bi,bj).eq.1.0) THEN
           DoFCount = DoFCount + 1.0
           streamice_petsc_dofs_u (i,j,bi,bj) = DoFCount
          else
           streamice_petsc_dofs_u (i,j,bi,bj) = -1.0
          endif

          if (STREAMICE_vmask (i,j,bi,bj).eq.1.0) THEN
           DoFCount = DoFCount + 1.0
           streamice_petsc_dofs_v (i,j,bi,bj) = DoFCount
          else
           streamice_petsc_dofs_v (i,j,bi,bj) = -1.0
          endif

         ENDDO
        ENDDO
       ENDDO
      ENDDO

      print *, "DOF_COUNT", dofcount

#ifdef ALLOW_USE_MPI

      DO i=0,nPx*nPy-1
       n_dofs_proc_loc (i) = 0
      ENDDO

      CALL MPI_COMM_RANK( MPI_COMM_WORLD, mpiMyWId, mpiRC )

      n_dofs_proc_loc (mpiMyWId) = INT(DoFCount)+1

      CALL MPI_Allreduce(n_dofs_proc_loc,n_dofs_process,nPx*nPy,
     &       MPI_INTEGER, MPI_SUM,MPI_COMM_MODEL,mpiRC)

      n_dofs_cum_sum(0) = 0

      DO i=1,nPx*nPy-1
       n_dofs_cum_sum(i) = n_dofs_cum_sum(i-1)+
     &                     n_dofs_process(i-1)
      ENDDO

#else /* ALLOW_USE_MPI */

      n_dofs_process (0) = INT(DoFCount)+1
      n_dofs_cum_sum (0) = 0
      mpimywid = 0

#endif /* ALLOW_USE_MPI */

      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
        DO j=1,sNy
         DO i=1,sNx
          IF (streamice_petsc_dofs_u(i,j,bi,bj).ge.0 ) THEN
           streamice_petsc_dofs_u(i,j,bi,bj) =
     &      streamice_petsc_dofs_u(i,j,bi,bj) +
     &      n_dofs_cum_sum(mpimywid)
          ENDIF
          IF (streamice_petsc_dofs_v(i,j,bi,bj).ge.0 ) THEN
           streamice_petsc_dofs_v(i,j,bi,bj) =
     &      streamice_petsc_dofs_v(i,j,bi,bj) +
     &      n_dofs_cum_sum(mpimywid)
          ENDIF
         ENDDO
        ENDDO
       ENDDO
      ENDDO

      _EXCH_XY_RS(streamice_petsc_dofs_u,myThid)
      _EXCH_XY_RS(streamice_petsc_dofs_v,myThid)

#endif /* ALLOW_PETSC */

#endif
      RETURN
      END

#include "GAD_OPTIONS.h"

CBOP
C !ROUTINE: GAD_BIHARM_Y

C !INTERFACE: ==========================================================
      SUBROUTINE GAD_BIHARM_Y(
     I           bi,bj,k,
     I           yA,del2T,diffK4,
     O           dfy,
     I           myThid )

C !DESCRIPTION:
C Calculates the meridional flux due to bi-harmonic diffusion of a tracer.
C Routine takes the laplacian of the tracer as argument and calculates
C the meridional gradient:
C \begin{equation*}
C F^y_{diff} = \kappa_4 \partial_y \nabla^2 \theta
C \end{equation*}

C !USES: ===============================================================
      IMPLICIT NONE
#include "SIZE.h"
#include "GRID.h"

C !INPUT PARAMETERS: ===================================================
C  bi,bj                :: tile indices
C  k                    :: vertical level
C  yA                   :: area of face at V points
C  del2T                :: Laplacian of tracer
C  myThid               :: thread number
      INTEGER bi,bj,k
      _RS yA   (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL del2T(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL diffK4
      INTEGER myThid

C !OUTPUT PARAMETERS: ==================================================
C  dfy                  :: meridional diffusive flux
      _RL dfy  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)

C !LOCAL VARIABLES: ====================================================
C  i,j                  :: loop indices
      INTEGER i,j
CEOP

C     Difference of meridional fluxes ...
c     DO i=1-Olx,sNx+Olx
c      dfy(i,1-Oly) = 0.
c     ENDDO
      DO j=1-Oly+1,sNy+Oly
       DO i=1-Olx,sNx+Olx
c        dfy(i,j) = diffK4*yA(i,j)
         dfy(i,j) = dfy(i,j) + diffK4*yA(i,j)
     &    *_recip_dyC(i,j,bi,bj)*recip_deepFacC(k)
     &    *(del2T(i,j)-del2T(i,j-1))
#ifdef ISOTROPIC_COS_SCALING
#ifdef COSINEMETH_III
     &    *sqCosFacV(j,bi,bj)
#else
     &    *cosFacV(j,bi,bj)
#endif
#endif
       ENDDO
      ENDDO

      RETURN
      END

#include "LONGSTEP_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: LONGSTEP_CHECK

C     !INTERFACE:
      SUBROUTINE LONGSTEP_CHECK( myThid )

C     !DESCRIPTION:
C     Print summary of longstep parameters

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "LONGSTEP_PARAMS.h"

C     !INPUT PARAMETERS:
      INTEGER myThid
CEOP

#ifdef ALLOW_LONGSTEP

C     !LOCAL VARIABLES:
C     msgBuf     :: message buffer
      CHARACTER*(MAX_LEN_MBUF) msgBuf

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      _BEGIN_MASTER(myThid)

      WRITE(msgBuf,'(A)') 'LONGSTEP_CHECK: #define ALLOW_LONGSTEP'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )

      WRITE(msgBuf,'(A)') '// ==================================='
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)') '// longstep parameters '
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)') '// ==================================='
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      CALL WRITE_0D_I( LS_nIter, INDEX_NONE,
     &   'LS_nIter =',
     &   ' /* number of dynamics steps between ptracer steps */')
      CALL WRITE_0D_I( LS_whenToSample, INDEX_NONE,
     &   'LS_whenToSample =',
     &   ' /* 0: before; 1: after TD, before DYN; 2: after */')

      IF ( (nonlinFreeSurf.GT.0 .OR. usingPCoords)
     &     .AND. useRealFreshWaterFlux .AND. staggerTimeStep
     &     .AND. LS_whenToSample.LT.2 ) THEN
        WRITE(msgBuf,'(2A)')
     &   ' LONGSTEP: staggerTimeStep with useRealFreshWaterFlux'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(2A)')
     &     ' LONGSTEP: and nonlinFreeSurf or PCoords',
     &     ' requires LS_whenToSample=2'
        CALL PRINT_ERROR( msgBuf, myThid )
        STOP 'ABNORMAL END: S/R LONGSTEP_INIT_FIXED'
      ENDIF

      _END_MASTER(myThid)
      _BARRIER

#endif /* ALLOW_LONGSTEP */

      RETURN
      END

#include "SHELFICE_OPTIONS.h"

CBOP
C !ROUTINE: SHELFICE_READPARMS

C !INTERFACE: ==========================================================
      SUBROUTINE SHELFICE_READPARMS( myThid )

C !DESCRIPTION:
C     Initialize SHELFICE parameters, read in data.shelfice

C !USES: ===============================================================
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "SHELFICE.h"
#ifdef ALLOW_COST
# include "SHELFICE_COST.h"
#endif /* ALLOW_COST */
#ifdef ALLOW_MNC
# include "MNC_PARAMS.h"
#endif

C !INPUT PARAMETERS: ===================================================
C  myThid               :: thread number
      INTEGER myThid

C !OUTPUT PARAMETERS: ==================================================
C  none

#ifdef ALLOW_SHELFICE

C !LOCAL VARIABLES: ====================================================
C  iUnit                :: unit number for I/O
C  msgBuf               :: message buffer
      INTEGER iUnit
      CHARACTER*(MAX_LEN_MBUF) msgBuf
C-    retired parameters:
      _RL SHELFICE_taveFreq
      LOGICAL SHELFICE_tave_mnc
CEOP

      NAMELIST /SHELFICE_PARM01/
     &     SHELFICEsaltToHeatRatio,
     &     SHELFICEheatTransCoeff,
     &     SHELFICEsaltTransCoeff,
     &     SHELFICEMassStepping, SHI_update_kTopC,
     &     rhoShelfice, SHELFICEkappa,
     &     SHELFICElatentHeat, SHELFICEHeatCapacity_Cp,
     &     no_slip_shelfice, SHELFICEDragLinear,
     &     SHELFICEDragQuadratic, SHELFICEselectDragQuadr,
     &     SHELFICEthetaSurface, SHELFICEsalinity,
     &     useISOMIPTD,
     &     SHELFICEconserve, SHELFICEboundaryLayer,
     &     SHI_withBL_realFWflux, SHI_withBL_uStarTopDz,
     &     SHELFICEwriteState,
     &     SHELFICE_dumpFreq,
     &     SHELFICE_taveFreq,
     &     SHELFICE_tave_mnc,
     &     SHELFICE_dump_mnc,
     &     SHELFICEtopoFile,
     &     SHELFICEmassFile, SHELFICEloadAnomalyFile,
     &     SHELFICEMassDynTendFile, SHELFICETransCoeffTFile,
     &     SHELFICEDynMassOnly,
     &     SHELFICEadvDiffHeatFlux,
     &     SHELFICEuseGammaFrict, SHELFICE_oldCalcUStar,
     &     shiCdrag, shiZetaN, shiRc,
     &     shiPrandtl, shiSchmidt, shiKinVisc,
#ifdef ALLOW_COST
     &     mult_shelfice,
     &     mult_shifwflx, wshifwflx0, shifwflx_errfile,
#endif
     &     SHELFICEremeshFrequency,
     &     SHELFICEsplitThreshold, SHELFICEmergeThreshold

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      IF ( .NOT.useShelfIce ) THEN
C-    pkg SHELFICE is not used
        _BEGIN_MASTER(myThid)
C-    Track pkg activation status:
         SHELFICEisOn = .FALSE.
C     print a (weak) warning if data.shelfice is found
         CALL PACKAGES_UNUSED_MSG( 'useShelfIce', ' ', ' ' )
        _END_MASTER(myThid)
        RETURN
      ENDIF

      _BEGIN_MASTER(myThid)

C This routine has been called by the main model so we set our
C internal flag to indicate we are in business
      SHELFICEisOn = .TRUE.

C Set defaults values for parameters in SHELFICE.h
      useISOMIPTD              = .FALSE.
      SHELFICEconserve         = .FALSE.
      SHELFICEboundaryLayer    = .FALSE.
      SHI_withBL_realFWflux    = .FALSE.
      SHI_withBL_uStarTopDz    = .FALSE.
      SHELFICEMassStepping     = .FALSE.
#ifdef ALLOW_SHELFICE_REMESHING
      SHI_update_kTopC         = .TRUE.
#else
      SHI_update_kTopC         = .FALSE.
#endif
      SHELFICEDynMassOnly      = .FALSE.
      SHELFICEtopoFile         = ' '
      SHELFICEmassFile         = ' '
      SHELFICEloadAnomalyFile  = ' '
      SHELFICEMassDynTendFile  = ' '
      SHELFICETransCoeffTFile  = ' '
      SHELFICElatentHeat       =  334.0 _d 3
      SHELFICEHeatCapacity_Cp  = 2000.0 _d 0
      rhoShelfIce              =  917.0 _d 0
      SHELFICEsaltToHeatRatio  =   5.05 _d -03
      SHELFICEheatTransCoeff   =    1.0 _d -04
      SHELFICEsaltTransCoeff   = UNSET_RL
C--   Molecular thermal conductivity ice shelf (m^2/s)
      SHELFICEkappa            =   1.54 _d -06
      SHELFICEthetaSurface     = - 20.0 _d 0
      SHELFICEsalinity         = 0.0 _d 0
      no_slip_shelfice         = no_slip_bottom
      SHELFICEDragLinear       = bottomDragLinear
      SHELFICEDragQuadratic    = UNSET_RL
      SHELFICEselectDragQuadr  = -1
      SHELFICEwriteState       = .FALSE.
      SHELFICE_dumpFreq        = dumpFreq
      SHELFICEadvDiffHeatFlux  = .FALSE.
      SHELFICEuseGammaFrict    = .FALSE.
      SHELFICE_oldCalcUStar    = .FALSE.
      SHELFICEremeshFrequency  = 0.
      SHELFICEsplitThreshold   = hFacMin*1.1 _d 0 + 1. _d 0
      SHELFICEmergeThreshold   = hFacMin*0.9 _d 0
C these params. are default of Holland and Jenkins (1999)
      shiCdrag                 = 0.0015 _d 0
      shiZetaN                 = 0.052 _d 0
      shiRc                    = 0.2 _d 0
      shiPrandtl               = 13.8 _d 0
      shiSchmidt               = 2432.0 _d 0
      shiKinVisc               = 1.95 _d -6
#ifdef ALLOW_COST
      mult_shelfice            = 0. _d 0
      mult_shifwflx            = 0. _d 0
      wshifwflx0               = 0. _d 0
      shifwflx_errfile         = ' '
#endif
#ifdef ALLOW_MNC
      SHELFICE_dump_mnc = snapshot_mnc
#else
      SHELFICE_dump_mnc = .FALSE.
#endif
C-    retired params:
      SHELFICE_taveFreq = UNSET_RL
      SHELFICE_tave_mnc = .FALSE.

C Open and read the data.shelfice file
      WRITE(msgBuf,'(A)') ' SHELFICE_READPARMS: opening data.shelfice'
      CALL PRINT_MESSAGE(msgBuf, standardMessageUnit,
     &                   SQUEEZE_RIGHT, myThid )
      CALL OPEN_COPY_DATA_FILE(
     I                   'data.shelfice', 'SHELFICE_READPARMS',
     O                   iUnit,
     I                   myThid )
      READ(UNIT=iUnit,NML=SHELFICE_PARM01)
      WRITE(msgBuf,'(A)')
     &  ' SHELFICE_READPARMS: finished reading data.shelfice'
      CALL PRINT_MESSAGE(msgBuf, standardMessageUnit,
     &                   SQUEEZE_RIGHT, myThid )

C Close the open data file
#ifdef SINGLE_DISK_IO
      CLOSE(iUnit)
#else
      CLOSE(iUnit,STATUS='DELETE')
#endif /* SINGLE_DISK_IO */

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C--   Check for retired parameters:
      IF ( SHELFICE_taveFreq .NE. UNSET_RL ) THEN
        WRITE(msgBuf,'(2A)') 'SHELFICE_READPARMS: "SHELFICE_taveFreq"',
     &    ' is no longer allowed in file "data.shelfice"'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(2A)') 'SHELFICE_READPARMS: ',
     &    ' since "pkg/timeave" has been removed.'
        CALL PRINT_ERROR( msgBuf, myThid )
c       errCount = errCount + 1
        STOP 'ABNORMAL END: S/R SHELFICE_READPARMS'
      ENDIF
      IF ( SHELFICE_tave_mnc ) THEN
        WRITE(msgBuf,'(2A)') 'SHELFICE_READPARMS: "SHELFICE_tave_mnc"',
     &    ' is no longer allowed in file "data.shelfice"'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(2A)') 'SHELFICE_READPARMS: ',
     &    ' since "pkg/timeave" has been removed.'
        CALL PRINT_ERROR( msgBuf, myThid )
c       errCount = errCount + 1
        STOP 'ABNORMAL END: S/R SHELFICE_READPARMS'
      ENDIF

C Now set-up any remaining parameters that result from the input parameters
      IF ( SHELFICEsaltTransCoeff .EQ. UNSET_RL )
     &     SHELFICEsaltTransCoeff =
     &     SHELFICEsaltToHeatRatio * SHELFICEheatTransCoeff

C New calcUstar expression not available with SHELFICEboundaryLayer:
      IF ( SHELFICEboundaryLayer ) SHELFICE_oldCalcUStar = .TRUE.
C  specific options within SHELFICEboundaryLayer:
      SHI_withBL_realFWflux = SHI_withBL_realFWflux .AND.
     &    SHELFICEboundaryLayer .AND. useRealFreshWaterFlux
      SHI_withBL_uStarTopDz = SHI_withBL_uStarTopDz .AND.
     &    SHELFICEboundaryLayer .AND. SHELFICEuseGammaFrict

C Set quadratic bottom drag depending on choices:
      IF ( SHELFICEDragQuadratic .EQ. UNSET_RL) THEN
       IF ( SHELFICEuseGammaFrict ) THEN
        SHELFICEDragQuadratic = shiCdrag
       ELSE
        SHELFICEDragQuadratic = bottomDragQuadratic
       ENDIF
      ENDIF
      IF ( SHELFICEDragQuadratic.EQ.0. _d 0 ) THEN
        SHELFICEselectDragQuadr = -1
      ELSEIF ( SHELFICEselectDragQuadr.EQ.-1 ) THEN
        SHELFICEselectDragQuadr = MAX( 0, selectBotDragQuadr )
      ENDIF

C-    reset SHI_update_kTopC to avoid having to test for both:
      SHI_update_kTopC = SHI_update_kTopC .AND. SHELFICEMassStepping

C-    Set Output type flags :
      SHELFICE_dump_mdsio = .TRUE.
#ifdef ALLOW_MNC
      IF (useMNC) THEN
        IF ( .NOT.outputTypesInclusive
     &       .AND. SHELFICE_dump_mnc ) SHELFICE_dump_mdsio = .FALSE.
      ENDIF
#endif

      _END_MASTER(myThid)
C Everyone else must wait for the parameters to be loaded
      _BARRIER

#endif /* ALLOW_SHELFICE */

      RETURN
      END

#include "CPP_EEOPTIONS.h"

CStartofinterface
      SUBROUTINE FILL_IN_CORNERS_RL( 
     U              fld, 
     I              spvFld, Ksize,
     I              myThid )
C     *==========================================================*
C     | SUBROUTINE FILL_IN_CORNERS_RL
C     | o Fill-in the corner part of the halo region.
C     *==========================================================*
C     | Only used to test some configuration and scheme:
C     | put a special value in corners to test the impact
C     *==========================================================*
      IMPLICIT NONE

C     == Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"

C     == Routine arguments ==
C     myThid - Thread number for this instance of the routine.
C     fld   - input Field to modify 
C     spvFld - special value to fill-in the corner with
C     Ksize - 3rd dimension of local arrays (Input-Output field)
      INTEGER Ksize
      _RL fld(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Ksize,nSx,nSy)
      _RL spvFld
      INTEGER myThid

CEndofinterface

C     == Local variables ==
C     i,j,k,bi,bj  - Loop counters
      INTEGER i, j, k
      INTEGER ii, jj
      INTEGER bi, bj
 
      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
        DO k=1,Ksize
         DO j=1-Oly,0
          jj = j + sNy+Oly
          DO i=1-Olx,0
           ii = i + sNx+Olx
           fld(i,j,k,bi,bj)   = spvFld
           fld(ii,j,k,bi,bj)  = spvFld
           fld(i,jj,k,bi,bj)  = spvFld
           fld(ii,jj,k,bi,bj) = spvFld
          ENDDO
         ENDDO
        ENDDO
       ENDDO
      ENDDO
 
      RETURN
      END

#include "PACKAGES_CONFIG.h"
#include "CPP_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: WRITE_PICKUP
C     !INTERFACE:
      SUBROUTINE WRITE_PICKUP(
     I                 permPickup, suffix,
     I                 myTime, myIter, myThid )

C     !DESCRIPTION:
C     Write the main-model pickup-file and do it NOW.
C     It writes both "rolling-pickup" files (ckptA,ckptB) and
C     permanent pickup files (with iteration number in the file name).
C     It calls routines from other packages (\textit{eg.} rw and mnc)
C     to do the per-variable writes.

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "RESTART.h"
#include "DYNVARS.h"
#include "NH_VARS.h"
#include "SURFACE.h"
#include "FFIELDS.h"
#ifdef ALLOW_GENERIC_ADVDIFF
# include "GAD.h"
#endif
#ifdef ALLOW_MNC
# include "MNC_PARAMS.h"
#endif
#if defined(ALLOW_EDDYPSI) && defined(ALLOW_GMREDI)
# include "GMREDI.h"
#endif

C     !INPUT PARAMETERS:
C     permPickup      :: Is or is not a permanent pickup.
C     suffix          :: pickup-name suffix
C     myTime          :: Current time of simulation ( s )
C     myIter          :: Iteration number
C     myThid          :: Thread number for this instance of the routine.
      LOGICAL permPickup
      CHARACTER*(*) suffix
      _RL     myTime
      INTEGER myIter
      INTEGER myThid
CEOP

C     !LOCAL VARIABLES:
C     fp          :: pickup-file precision
C     glf         :: local flag for "globalFiles"
C     fn          :: Temp. for building file name.
C     nWrFlds     :: number of fields being written
C     n3D         :: number of 3-D fields being written
C     listDim     :: dimension of "wrFldList" local array
C     wrFldList   :: list of written fields
C     m1,m2       :: 6.th dim index (AB-3) corresponding to time-step N-1 & N-2
C     j           :: loop index / field number
C     nj          :: record number
C     msgBuf      :: Informational/error message buffer
      INTEGER fp
      LOGICAL  glf
      _RL      timList(1)
      CHARACTER*(MAX_LEN_FNAM) fn
      INTEGER listDim, nWrFlds, n3D
      PARAMETER( listDim = 20 )
      CHARACTER*(8) wrFldList(listDim)
#ifdef ALLOW_ADAMSBASHFORTH_3
      INTEGER m1, m2
#endif
      INTEGER j, nj
      CHARACTER*(MAX_LEN_MBUF) msgBuf
#ifndef ALLOW_GENERIC_ADVDIFF
      LOGICAL AdamsBashforthGt
      LOGICAL AdamsBashforthGs
      LOGICAL AdamsBashforth_T
      LOGICAL AdamsBashforth_S
      PARAMETER ( AdamsBashforthGt = .FALSE. ,
     &            AdamsBashforthGs = .FALSE. ,
     &            AdamsBashforth_T = .FALSE. ,
     &            AdamsBashforth_S = .FALSE. )
#endif

C-    Initialise:
      DO j=1,listDim
        wrFldList(j) = ' '
      ENDDO

C     Write model fields

C     Going to really do some IO. Make everyone except master thread wait.
C     this is done within IO routines => no longer needed
c     _BARRIER

      IF (pickup_write_mdsio) THEN

        WRITE(fn,'(A,A)') 'pickup.', suffix
        fp = precFloat64
        j  = 0
C     record number < 0 : a hack not to write meta files now:

C---  write State 3-D fields for restart
        j = j + 1
        CALL WRITE_REC_3D_RL( fn, fp, Nr, uVel,   -j, myIter, myThid )
        IF (j.LE.listDim) wrFldList(j) = 'Uvel    '
        j = j + 1
        CALL WRITE_REC_3D_RL( fn, fp, Nr, vVel,   -j, myIter, myThid )
        IF (j.LE.listDim) wrFldList(j) = 'Vvel    '

#if defined(ALLOW_EDDYPSI) && defined(ALLOW_GMREDI)
        IF (GM_InMomAsStress) THEN
          j = j + 1
          CALL WRITE_REC_3D_RL( fn, fp, Nr, uEulerMean,
     &                                            -j, myIter, myThid )
          IF (j.LE.listDim) wrFldList(j) = 'UEulerM '
          j = j + 1
          CALL WRITE_REC_3D_RL( fn, fp, Nr, vEulerMean,
     &                                            -j, myIter, myThid )
          IF (j.LE.listDim) wrFldList(j) = 'VEulerM '
      ENDIF
#endif

        j = j + 1
        CALL WRITE_REC_3D_RL( fn, fp, Nr, theta,  -j, myIter, myThid )
        IF (j.LE.listDim) wrFldList(j) = 'Theta   '
        j = j + 1
        CALL WRITE_REC_3D_RL( fn, fp, Nr, salt,   -j, myIter, myThid )
        IF (j.LE.listDim) wrFldList(j) = 'Salt    '
C---  write 3-D fields for AB-restart
#ifdef ALLOW_ADAMSBASHFORTH_3

        m1 = 1 + MOD(myIter+1,2)
        m2 = 1 + MOD( myIter ,2)
      IF ( momStepping ) THEN
C--   U velocity:
       IF ( alph_AB.NE.0. .OR. beta_AB.NE.0. ) THEN
        j = j + 1
        CALL WRITE_REC_3D_RL( fn, fp, Nr, guNm(1-OLx,1-OLy,1,1,1,m1),
     &                                            -j, myIter, myThid )
        IF (j.LE.listDim) wrFldList(j) = 'GuNm1   '
       ENDIF
       IF ( beta_AB.NE.0. ) THEN
        j = j + 1
        CALL WRITE_REC_3D_RL( fn, fp, Nr, guNm(1-OLx,1-OLy,1,1,1,m2),
     &                                            -j, myIter, myThid )
        IF (j.LE.listDim) wrFldList(j) = 'GuNm2   '
       ENDIF
C--   V velocity:
       IF ( alph_AB.NE.0. .OR. beta_AB.NE.0. ) THEN
        j = j + 1
        CALL WRITE_REC_3D_RL( fn, fp, Nr, gvNm(1-OLx,1-OLy,1,1,1,m1),
     &                                            -j, myIter, myThid )
        IF (j.LE.listDim) wrFldList(j) = 'GvNm1   '
       ENDIF
       IF ( beta_AB.NE.0. ) THEN
        j = j + 1
        CALL WRITE_REC_3D_RL( fn, fp, Nr, gvNm(1-OLx,1-OLy,1,1,1,m2),
     &                                            -j, myIter, myThid )
        IF (j.LE.listDim) wrFldList(j) = 'GvNm2   '
       ENDIF
      ENDIF
C--   Temperature:
      IF ( AdamsBashforthGt.OR.AdamsBashforth_T ) THEN
       IF ( alph_AB.NE.0. .OR. beta_AB.NE.0. ) THEN
        j = j + 1
        CALL WRITE_REC_3D_RL( fn, fp, Nr, gtNm(1-OLx,1-OLy,1,1,1,m1),
     &                                            -j, myIter, myThid )
        IF (j.LE.listDim) THEN
         IF ( AdamsBashforthGt ) wrFldList(j) = 'GtNm1   '
         IF ( AdamsBashforth_T ) wrFldList(j) = 'TempNm1 '
        ENDIF
       ENDIF
       IF ( beta_AB.NE.0. ) THEN
        j = j + 1
        CALL WRITE_REC_3D_RL( fn, fp, Nr, gtNm(1-OLx,1-OLy,1,1,1,m2),
     &                                            -j, myIter, myThid )
        IF (j.LE.listDim) THEN
         IF ( AdamsBashforthGt ) wrFldList(j) = 'GtNm2   '
         IF ( AdamsBashforth_T ) wrFldList(j) = 'TempNm2 '
        ENDIF
       ENDIF
      ENDIF
C--   Salinity:
      IF ( AdamsBashforthGs.OR.AdamsBashforth_S ) THEN
       IF ( alph_AB.NE.0. .OR. beta_AB.NE.0. ) THEN
        j = j + 1
        CALL WRITE_REC_3D_RL( fn, fp, Nr, gsNm(1-OLx,1-OLy,1,1,1,m1),
     &                                            -j, myIter, myThid )
        IF (j.LE.listDim) THEN
         IF ( AdamsBashforthGs ) wrFldList(j) = 'GsNm1   '
         IF ( AdamsBashforth_S ) wrFldList(j) = 'SaltNm1 '
        ENDIF
       ENDIF
       IF ( beta_AB.NE.0. ) THEN
        j = j + 1
        CALL WRITE_REC_3D_RL( fn, fp, Nr, gsNm(1-OLx,1-OLy,1,1,1,m2),
     &                                            -j, myIter, myThid )
        IF (j.LE.listDim) THEN
         IF ( AdamsBashforthGs ) wrFldList(j) = 'GsNm2   '
         IF ( AdamsBashforth_S ) wrFldList(j) = 'SaltNm2 '
        ENDIF
       ENDIF
      ENDIF
#ifdef ALLOW_NONHYDROSTATIC
C--   W velocity:
      IF ( nonHydrostatic ) THEN
       IF ( alph_AB.NE.0. .OR. beta_AB.NE.0. ) THEN
        j = j + 1
        CALL WRITE_REC_3D_RL( fn, fp, Nr, gwNm(1-OLx,1-OLy,1,1,1,m1),
     &                                            -j, myIter, myThid )
        IF (j.LE.listDim) wrFldList(j) = 'GwNm1   '
       ENDIF
       IF ( beta_AB.NE.0. ) THEN
        j = j + 1
        CALL WRITE_REC_3D_RL( fn, fp, Nr, gwNm(1-OLx,1-OLy,1,1,1,m2),
     &                                            -j, myIter, myThid )
        IF (j.LE.listDim) wrFldList(j) = 'GwNm2   '
       ENDIF
      ENDIF
#endif /* ALLOW_NONHYDROSTATIC */
#ifdef ALLOW_QHYD_STAGGER_TS
C--   Quasi-Hydrostatic Adams-Bashforth variables:
      IF ( quasiHydrostatic .AND. staggerTimeStep ) THEN
       IF ( alph_AB.NE.0. .OR. beta_AB.NE.0. ) THEN
        j = j + 1
        CALL WRITE_REC_3D_RL( fn,fp, Nr, QHydGwNm(1-OLx,1-OLy,1,1,1,m1),
     &                                            -j, myIter, myThid )
        IF (j.LE.listDim) wrFldList(j) = 'QH_GwNm1'
       ENDIF
       IF ( beta_AB.NE.0. ) THEN
        j = j + 1
        CALL WRITE_REC_3D_RL( fn,fp, Nr, QHydGwNm(1-OLx,1-OLy,1,1,1,m2),
     &                                            -j, myIter, myThid )
        IF (j.LE.listDim) wrFldList(j) = 'QH_GwNm2'
       ENDIF
      ENDIF
#endif /* ALLOW_QHYD_STAGGER_TS */

#else /*  ALLOW_ADAMSBASHFORTH_3 */

       IF ( momStepping ) THEN
        j = j + 1
        CALL WRITE_REC_3D_RL( fn, fp, Nr, guNm1,  -j, myIter, myThid )
        IF (j.LE.listDim) wrFldList(j) = 'GuNm1   '
        j = j + 1
        CALL WRITE_REC_3D_RL( fn, fp, Nr, gvNm1,  -j, myIter, myThid )
        IF (j.LE.listDim) wrFldList(j) = 'GvNm1   '
       ENDIF
       IF ( AdamsBashforthGt.OR.AdamsBashforth_T ) THEN
        j = j + 1
        CALL WRITE_REC_3D_RL( fn, fp, Nr, gtNm1,  -j, myIter, myThid )
        IF (j.LE.listDim) THEN
         IF ( AdamsBashforthGt ) wrFldList(j) = 'GtNm1   '
         IF ( AdamsBashforth_T ) wrFldList(j) = 'TempNm1 '
        ENDIF
       ENDIF
       IF ( AdamsBashforthGs.OR.AdamsBashforth_S ) THEN
        j = j + 1
        CALL WRITE_REC_3D_RL( fn, fp, Nr, gsNm1,  -j, myIter, myThid )
        IF (j.LE.listDim) THEN
         IF ( AdamsBashforthGs ) wrFldList(j) = 'GsNm1   '
         IF ( AdamsBashforth_S ) wrFldList(j) = 'SaltNm1 '
        ENDIF
       ENDIF
#ifdef ALLOW_NONHYDROSTATIC
       IF ( nonHydrostatic ) THEN
        j = j + 1
        CALL WRITE_REC_3D_RL( fn, fp, Nr, gwNm1,  -j, myIter, myThid )
        IF (j.LE.listDim) wrFldList(j) = 'GwNm1   '
       ENDIF
#endif /* ALLOW_NONHYDROSTATIC */
#ifdef ALLOW_QHYD_STAGGER_TS
C--   Quasi-Hydrostatic Adams-Bashforth variables:
      IF ( quasiHydrostatic .AND. staggerTimeStep ) THEN
        j = j + 1
        CALL WRITE_REC_3D_RL( fn,fp, Nr, QHydGwNm, -j, myIter, myThid )
        IF (j.LE.listDim) wrFldList(j) = 'QH_GwNm1'
      ENDIF
#endif /* ALLOW_QHYD_STAGGER_TS */

#endif /*  ALLOW_ADAMSBASHFORTH_3 */

C-    write Full Pressure for EOS in pressure:
       IF ( storePhiHyd4Phys ) THEN
        j = j + 1
        CALL WRITE_REC_3D_RL( fn, fp, Nr,totPhiHyd,-j,myIter, myThid )
        IF (j.LE.listDim) wrFldList(j) = 'PhiHyd  '
       ENDIF
#ifdef ALLOW_NONHYDROSTATIC
       IF ( use3Dsolver ) THEN
        j = j + 1
        CALL WRITE_REC_3D_RL( fn, fp, Nr, phi_nh, -j, myIter, myThid )
        IF (j.LE.listDim) wrFldList(j) = 'Phi_NHyd'
       ENDIF
#endif /* ALLOW_NONHYDROSTATIC */
#ifdef ALLOW_SMAG_3D_DIFFUSIVITY
C-    With synchronous time-stepping, Smag-3D diffusivity is lagging by 1 time-step
C     (i.e., used before being updated meaning field is from previous time-step calc)
C     --> needs to be stored in pickup file
       IF ( smag3D_diffCoeff.GT.zeroRL .AND. .NOT.staggerTimeStep ) THEN
        j = j + 1
        CALL WRITE_REC_3D_RL( fn, fp, Nr, smag3D_diffK,
     &                                            -j, myIter, myThid )
        IF (j.LE.listDim) wrFldList(j) = 'SmagDiff'
       ENDIF
#endif /* ALLOW_SMAG_3D_DIFFUSIVITY */
#ifdef ALLOW_ADDFLUID
C-    write mass source/sink of fluid (but not needed if selectAddFluid=-1)
       IF ( selectAddFluid.NE.0 ) THEN
        j = j + 1
        CALL WRITE_REC_3D_RL( fn, fp, Nr, addMass,-j, myIter, myThid )
        IF (j.LE.listDim) wrFldList(j) = 'AddMass '
       ENDIF
#endif /* ALLOW_ADDFLUID */
#ifdef ALLOW_FRICTION_HEATING
C-    needs frictional heating when using synchronous time-stepping
       IF ( addFrictionHeating .AND. .NOT.staggerTimeStep ) THEN
        j = j + 1
        CALL WRITE_REC_3D_RS( fn, fp, Nr, frictionHeating,
     &                                            -j, myIter, myThid )
        IF (j.LE.listDim) wrFldList(j) = 'FricHeat'
       ENDIF
#endif /* ALLOW_FRICTION_HEATING */

        n3D = j
C---  Write 2-D fields, starting with Eta:
        j = j + 1
        nj = -( n3D*(Nr-1) + j )
        CALL WRITE_REC_3D_RL( fn, fp, 1 , etaN,   nj, myIter, myThid )
        IF (j.LE.listDim) wrFldList(j) = 'EtaN    '
       IF ( usingPCoords .AND. useSEAICE ) THEN
        j = j + 1
        nj = -( n3D*(Nr-1) + j )
        CALL WRITE_REC_3D_RL( fn, fp, 1, phiHydLow, nj,myIter,myThid )
        IF (j.LE.listDim) wrFldList(j) = 'Phi_rLow'
       ENDIF
#ifdef ALLOW_NONHYDROSTATIC
       IF ( selectNHfreeSurf.GE.1 ) THEN
        j = j + 1
        nj = -( n3D*(Nr-1) + j )
        CALL WRITE_REC_3D_RL( fn, fp, 1, dPhiNH,  nj, myIter, myThid )
        IF (j.LE.listDim) wrFldList(j) = 'dPhiNH  '
       ENDIF
#endif /* ALLOW_NONHYDROSTATIC */
c      IF ( exactConserv ) THEN
        j = j + 1
        nj = -( n3D*(Nr-1) + j )
        CALL WRITE_REC_3D_RL( fn, fp, 1, dEtaHdt, nj, myIter, myThid )
        IF (j.LE.listDim) wrFldList(j) = 'dEtaHdt '
c      ENDIF
C- note: always write dEtaHdt & EtaH but read only if exactConserv & nonlinFreeSurf
C        this works only because nonlinFreeSurf > 0 => exactConserv=T
c      IF ( nonlinFreeSurf.GT.0 ) THEN
        j = j + 1
        nj = -( n3D*(Nr-1) + j )
        CALL WRITE_REC_3D_RL( fn, fp, 1, etaHnm1, nj, myIter, myThid )
        IF (j.LE.listDim) wrFldList(j) = 'EtaH    '
c      ENDIF
C--------------------------
        nWrFlds = j
        IF ( nWrFlds.GT.listDim ) THEN
          WRITE(msgBuf,'(2A,I5,A)') 'WRITE_PICKUP: ',
     &     'trying to write ',nWrFlds,' fields'
          CALL PRINT_ERROR( msgBuf, myThid )
          WRITE(msgBuf,'(2A,I5,A)') 'WRITE_PICKUP: ',
     &     'field-list dimension (listDim=',listDim,') too small'
          CALL PRINT_ERROR( msgBuf, myThid )
          STOP 'ABNORMAL END: S/R WRITE_PICKUP (list-size Pb)'
        ENDIF
#ifdef ALLOW_MDSIO
C-    Note: temporary: since it is a pain to add more arguments to
C     all MDSIO S/R, uses instead this specific S/R to write only
C     meta files but with more informations in it.
        nj = ABS(nj)
        glf  = globalFiles
        timList(1) = myTime
        CALL MDS_WR_METAFILES( fn, fp, glf, .FALSE.,
     &                         0, 0, 1, ' ',
     &                         nWrFlds, wrFldList,
     &                         1, timList, oneRL,
     &                         nj, myIter, myThid )
#endif /* ALLOW_MDSIO */
C--------------------------
      ENDIF

#ifdef ALLOW_MNC
      IF (useMNC .AND. pickup_write_mnc) THEN
        IF ( permPickup ) THEN
          WRITE(fn,'(A)') 'pickup'
        ELSE
          WRITE(fn,'(A,A)') 'pickup.',checkPtSuff(nCheckLev)
        ENDIF
C       First ***define*** the file group name
        CALL MNC_CW_SET_UDIM(fn, 0, myThid)
        IF ( permPickup ) THEN
          CALL MNC_CW_SET_CITER(fn, 3, 3, myIter, 0, myThid)
        ELSE
          CALL MNC_CW_SET_CITER(fn, 2, -1, -1, -1, myThid)
        ENDIF
C       Then set the actual unlimited dimension
        CALL MNC_CW_SET_UDIM(fn, 1, myThid)
        CALL MNC_CW_RL_W_S('D',fn,0,0,'T', myTime, myThid)
        CALL MNC_CW_I_W_S('I',fn,0,0,'iter', myIter, myThid)
        CALL MNC_CW_RL_W('D',fn,0,0,'U', uVel, myThid)
        CALL MNC_CW_RL_W('D',fn,0,0,'V', vVel, myThid)
#if defined(ALLOW_EDDYPSI) && defined(ALLOW_GMREDI)
        IF (GM_InMomAsStress) THEN
          CALL MNC_CW_RL_W('D',fn,0,0,'UEulerM', uEulerMean, myThid)
          CALL MNC_CW_RL_W('D',fn,0,0,'VEulerM', vEulerMean, myThid)
        ENDIF
#endif
        CALL MNC_CW_RL_W('D',fn,0,0,'Temp', theta, myThid)
        CALL MNC_CW_RL_W('D',fn,0,0,'S', salt, myThid)
        CALL MNC_CW_RL_W('D',fn,0,0,'Eta', etaN, myThid)
#ifndef ALLOW_ADAMSBASHFORTH_3
        CALL MNC_CW_RL_W('D',fn,0,0,'gUnm1', guNm1, myThid)
        CALL MNC_CW_RL_W('D',fn,0,0,'gVnm1', gvNm1, myThid)
        CALL MNC_CW_RL_W('D',fn,0,0,'gTnm1', gtNm1, myThid)
        CALL MNC_CW_RL_W('D',fn,0,0,'gSnm1', gsNm1, myThid)
#endif /* ALLOW_ADAMSBASHFORTH_3 */
        CALL MNC_CW_RL_W('D',fn,0,0,'dEtaHdt', dEtaHdt, myThid)
        CALL MNC_CW_RL_W('D',fn,0,0,'EtaH', etaHnm1, myThid)
#ifdef ALLOW_NONHYDROSTATIC
        IF ( use3Dsolver ) THEN
          CALL MNC_CW_RL_W('D',fn,0,0,'phi_nh', phi_nh, myThid)
c         CALL MNC_CW_RL_W('D',fn,0,0,'gW', gW, myThid)
#ifndef ALLOW_ADAMSBASHFORTH_3
          CALL MNC_CW_RL_W('D',fn,0,0,'gWnm1', gwNm1, myThid)
#endif
        ENDIF
#endif /* ALLOW_NONHYDROSTATIC */
        IF ( storePhiHyd4Phys ) THEN
          CALL MNC_CW_RL_W('D',fn,0,0,'phiHyd', totPhiHyd, myThid)
        ENDIF
        CALL MNC_FILE_CLOSE_ALL_MATCHING(fn, myThid)
      ENDIF
#endif /*  ALLOW_MNC  */

C--   Every one else must wait until writing is done.
C     this is done within IO routines => no longer needed
c     _BARRIER

      RETURN
      END

#include "DIAG_OPTIONS.h"

CBOP 0
C     !ROUTINE: DIAGNOSTICS_SUMMARY

C     !INTERFACE:
      SUBROUTINE DIAGNOSTICS_SUMMARY(
     I                       seqFlag, myTime, myIter, myThid )

C     !DESCRIPTION:
C     Write a summary of diagnostics state to ASCII file unit "dUnit"
C     Notes: Only called after initialisation but could be called
C            from any place in the code.

C     !USES:
      IMPLICIT NONE

#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "DIAGNOSTICS_SIZE.h"
#include "DIAGNOSTICS.h"

C     !INPUT PARAMETERS:
C     seqFlag  :: flag that indicates where this S/R is called from:
C              :: = 0 : called from DIAGNOSTICS_INIT_VARIA
C              :: = 1 : called from DIAGNOSTICS_WRITE, forward sweep
C              :: =-1 : called from DIAGNOSTICS_WRITE_ADJ, backward sweep
C     myTime   :: current Time of simulation ( s )
C     myIter   :: current Iteration number
C     myThid   :: my Thread Id number
      INTEGER seqFlag
      _RL     myTime
      INTEGER myIter, myThid

C     !FUNCTIONS:
      INTEGER  ILNBLNK
      EXTERNAL ILNBLNK

C     !LOCAL VARIABLES:
      INTEGER md, ld, ndId, ipt, im
      INTEGER j, k, k1, k2, l
      INTEGER  dUnit, stdUnit, iLen
      INTEGER xNew, xOld, ii, nDup
      CHARACTER*(2) cSep
      CHARACTER*(MAX_LEN_MBUF) msgBuf, tmpBuf
      CHARACTER*(MAX_LEN_FNAM) fn
      CHARACTER*(72) ccLine, ccFlds, ccList
      LOGICAL  outpSummary
#ifdef ALLOW_AUTODIFF
      CHARACTER*(3) sfx3c
#endif
CEOP

      _BEGIN_MASTER( myThid )
      stdUnit = standardMessageUnit

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      IF ( diag_dBugLevel.GE.debLevB ) THEN
       IF ( seqFlag.EQ.0 ) THEN
        outpSummary = .TRUE.
        dUnit = standardMessageUnit
        WRITE(msgBuf,'(A,I6)')
     &   ' write diagnostics summary to file ioUnit: ',dUnit
        CALL PRINT_MESSAGE( msgBuf, stdUnit,SQUEEZE_RIGHT, myThid)
       ELSE
        outpSummary = ( myXGlobalLo.EQ.1 .AND. myYGlobalLo.EQ.1 )
        IF ( outpSummary ) THEN
#ifdef ALLOW_AUTODIFF
         sfx3c = 'fwd'
         IF ( seqFlag.EQ.-1 ) sfx3c = 'adm'
         WRITE(fn,'(3A,I10.10,A)') 'diagnostics_status.',
     %                              sfx3c, '.', myIter, '.txt'
#else /* ALLOW_AUTODIFF */
         WRITE(fn,'(A,I10.10,A)') 'diagnostics_status.', myIter, '.txt'
#endif /* ALLOW_AUTODIFF */
         iLen = ILNBLNK(fn)
         CALL MDSFINDUNIT( dUnit, myThid )
         OPEN(dUnit,file=fn(1:iLen),status='unknown',form='formatted')
         WRITE(msgBuf,'(2A)')
     &   ' write diagnostics summary to file: ',fn(1:iLen)
         CALL PRINT_MESSAGE( msgBuf, stdUnit,SQUEEZE_RIGHT, myThid)
        ENDIF
       ENDIF
      ELSE
       outpSummary = .FALSE.
      ENDIF

      IF ( outpSummary .AND. diag_dBugLevel.GE.debLevB ) THEN
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C     write a summary diagnostics state:

        DO l=1,LEN(ccLine)
         ccLine(l:l) = '-'
        ENDDO
        WRITE(ccList,'(2A)')
     &  ' nFlds, nActive,       freq     &     phase        , nLev'
        WRITE(ccFlds,'(2A)')
     &  ' diag# | name   |   ipt  |  iMate | kLev|   count |   mate.C|'

        WRITE(dUnit,'(A,I10,A,1PE21.13)')
     &   'Iter.Nb:',myIter,' ; Time(s):', myTime
        WRITE(dUnit,'(A)') ccLine
        WRITE(dUnit,'(A,I6)')
     &   '2D/3D diagnostics: Number of lists:', nlists
        WRITE(dUnit,'(A)') ccLine

        DO ld=1,nlists
         iLen = ILNBLNK(fnames(ld))
         WRITE(dUnit,'(A,I5,2A)') 'listId=', ld,
     &                            ' ; file name: ',fnames(ld)(1:iLen)
         WRITE(dUnit,'(A)') ccList
         WRITE(dUnit,'(2(I5,A),2F17.6,A,I4)')
     &    nfields(ld), '  |',nActive(ld), '  |',
     &    freq(ld), phase(ld), ' |', nlevels(ld)
         IF ( fflags(ld)(2:2).EQ.'P' ) THEN
          DO k1=1,nlevels(ld),10
           k2 = MIN(nlevels(ld),k1+9)
           WRITE(dUnit,'(A,1P10E10.3)')' interp:', (levs(k,ld),k=k1,k2)
          ENDDO
         ELSE
          DO k1=1,nlevels(ld),25
           k2 = MIN(nlevels(ld),k1+24)
           WRITE(dUnit,'(A,25I4)')' levels:',(NINT(levs(k,ld)),k=k1,k2)
          ENDDO
         ENDIF
         WRITE(dUnit,'(A)') ccFlds
         DO md=1,nActive(ld)
           ndId = ABS(jdiag(md,ld))
           WRITE(msgBuf,'(I6,3A,2(I7,A),I4,A)')
     &       jdiag(md,ld),' |', flds(md,ld),'|',idiag(md,ld),' |',
     &       mdiag(md,ld),' |', kdiag(ndId),' |'
           ipt = ABS(idiag(md,ld))
           IF (ipt.NE.0 .AND. averageCycle(ld).GT.1) THEN
             xOld=ndiag(ipt,1,1)
             nDup = 1
             cSep = ', '
             DO l=1,averageCycle(ld)
               ii = ipt+l*kdiag(ndId)
               IF (l.EQ.averageCycle(ld)) THEN
                 cSep = ' |'
                 xNew=xOld+1
               ELSE
                 xNew=ndiag(ii,1,1)
               ENDIF
               IF (xNew.EQ.xOld) THEN
                 nDup = nDup + 1
               ELSE
                 iLen = ILNBLNK(msgBuf)
                 tmpBuf(1:iLen) = msgBuf(1:iLen)
                 IF (nDup.EQ.1) THEN
                   WRITE(msgBuf,'(A,I7,A)') tmpBuf(1:iLen),xOld,cSep
                 ELSE
                   WRITE(msgBuf,'(A,I7,A,I3,2A)') tmpBuf(1:iLen),xOld,
     &              '(x',nDup,')',cSep
                 ENDIF
                 xOld = xNew
                 nDup = 1
               ENDIF
             ENDDO
           ELSEIF (ipt.NE.0) THEN
            iLen = ILNBLNK(msgBuf)
            tmpBuf(1:iLen) = msgBuf(1:iLen)
            WRITE(msgBuf,'(A,I8,A)') tmpBuf(1:iLen),ndiag(ipt,1,1),' |'
            im = mdiag(md,ld)
            IF (im.NE.0) THEN
             iLen = ILNBLNK(msgBuf)
             tmpBuf(1:iLen) = msgBuf(1:iLen)
             WRITE(msgBuf,'(A,I8,A)') tmpBuf(1:iLen),ndiag(im,1,1),' |'
            ENDIF
           ENDIF
           iLen = ILNBLNK(msgBuf)
           WRITE(dUnit,'(A)') msgBuf(1:iLen)
         ENDDO
c        WRITE(dUnit,'(A)') ccFlds
         WRITE(dUnit,'(A)') ccLine

        ENDDO

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

c       WRITE(dUnit,'(A)') ccLine
        WRITE(dUnit,'(A,I6)')
     &   'Global & Regional Statistics diagnostics: Number of lists:',
     &     diagSt_nbLists
        WRITE(dUnit,'(A)') ccLine

        WRITE(ccList,'(2A)')
     &   ' nFlds, nActive,       freq     &     phase        |'
        WRITE(ccFlds,'(2A)')
     &   ' diag# | name   |   ipt  |  iMate |',
     &          '    Volume   |   mate-Vol. |'

        DO ld=1,diagSt_nbLists
         iLen = ILNBLNK(diagSt_Fname(ld))
         WRITE(dUnit,'(A,I4,2A)') 'listId=', ld,
     &                     ' ; file name: ',diagSt_Fname(ld)(1:iLen)
         WRITE(dUnit,'(A)') ccList
         WRITE(dUnit,'(2(I5,A),2F17.6,A,I4)')
     &    diagSt_nbFlds(ld), '  |',diagSt_nbActv(ld), '  |',
     &    diagSt_freq(ld), diagSt_phase(ld), ' |'
         WRITE(msgBuf,'(A)') ' Regions: '
         iLen = 10
         DO j=0,nRegions
           IF ( diagSt_region(j,ld).GE.1
     &          .AND. iLen+3.LE.MAX_LEN_MBUF) THEN
             tmpBuf(1:iLen) = msgBuf(1:iLen)
             WRITE(msgBuf,'(A,I3)') tmpBuf(1:iLen),j
             iLen = iLen+3
           ENDIF
         ENDDO
         WRITE(dUnit,'(A)') msgBuf(1:iLen)

         WRITE(dUnit,'(A)') ccFlds
         DO md=1,diagSt_nbActv(ld)
           WRITE(msgBuf,'(I6,3A,2(I7,A))')
     &       jSdiag(md,ld),' |', diagSt_Flds(md,ld),'|',iSdiag(md,ld),
     &       ' |', mSdiag(md,ld),' |'
           ipt = ABS(iSdiag(md,ld))
           IF (ipt.NE.0) THEN
            iLen = ILNBLNK(msgBuf)
            tmpBuf(1:iLen) = msgBuf(1:iLen)
            WRITE(msgBuf,'(A,1PE12.5,A)') tmpBuf(1:iLen),
     &                         qSdiag(0,0,ipt,1,1),' |'
           ENDIF
           im = mSdiag(md,ld)
           IF (im.NE.0) THEN
            iLen = ILNBLNK(msgBuf)
            tmpBuf(1:iLen) = msgBuf(1:iLen)
            WRITE(msgBuf,'(A,1PE12.5,A)') tmpBuf(1:iLen),
     &                         qSdiag(0,0,im, 1,1),' |'
           ENDIF
           iLen = ILNBLNK(msgBuf)
           WRITE(dUnit,'(A)') msgBuf(1:iLen)
         ENDDO
c        WRITE(dUnit,'(A)') ccFlds
         WRITE(dUnit,'(A)') ccLine

        ENDDO

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
        IF ( dUnit.NE.standardMessageUnit ) CLOSE(dUnit)
      ENDIF

      _END_MASTER( myThid )

      RETURN
      END

#include "DIAG_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 0
C     !ROUTINE: DIAGNOSTICS_CALC_PHIVEL

C     !INTERFACE:
      SUBROUTINE DIAGNOSTICS_CALC_PHIVEL(
     I                        listId, md, ndId, ip, im, lm,
     I                        NrMax,
     U                        qtmp1, qtmp2,
     I                        myTime, myIter, myThid )

C     !DESCRIPTION:
C     Compute Velocity Potential and Velocity Stream-Function

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "DIAGNOSTICS_SIZE.h"
#include "DIAGNOSTICS.h"
#include "DIAGNOSTICS_CALC.h"

C     !INPUT PARAMETERS:
C     listId  :: Diagnostics list number being written
C     md      :: field number in the list "listId".
C     ndId    :: diagnostics  Id number (in available diagnostics list)
C     ip      :: diagnostics  pointer to storage array
C     im      :: counter-mate pointer to storage array
C     lm      :: index in the averageCycle
C     NrMax   :: 3rd dimension of input/output arrays
C     qtmp1   :: horizontal velocity input diag., u-component
C     qtmp2   :: horizontal velocity input diag., v-component
C     myTime  :: current time of simulation (s)
C     myIter  :: current iteration number
C     myThid  :: my Thread Id number
      INTEGER listId, md, ndId, ip, im, lm
      INTEGER NrMax
      _RL     qtmp1(1-OLx:sNx+OLx,1-OLy:sNy+OLy,NrMax,nSx,nSy)
      _RL     qtmp2(1-OLx:sNx+OLx,1-OLy:sNy+OLy,NrMax,nSx,nSy)
      _RL     myTime
      INTEGER myIter, myThid

C     !OUTPUT PARAMETERS:
C     qtmp1   :: horizontal-velocity potential
C     qtmp2   :: horizontal-velocity stream-function
CEOP

C     !FUNCTIONS:
      INTEGER  ILNBLNK
      EXTERNAL ILNBLNK

C     !LOCAL VARIABLES:
C     bi, bj  :: tile indices
C     i,j,k   :: loop indices
C     uTrans  :: horizontal transport, u-component
C     vTrans  :: horizontal transport, u-component
C     psiVel  :: horizontal stream-function
C     psiLoc  :: horizontal stream-function at special location
      INTEGER bi, bj
      INTEGER i, j, k

      INTEGER ks
      INTEGER numIters, nIterMin
      LOGICAL normaliseMatrice, diagNormaliseRHS
      _RL  residCriter, firstResidual, minResidual, lastResidual
      _RL  a2dMax, a2dNorm
      _RL  rhsMax, b2dNorm, x2dNorm
      _RS  aW2d(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RS  aS2d(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL  b2d (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL  x2d (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL uTrans(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL vTrans(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL psiVel(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL psiLoc(2)
      INTEGER iL
      CHARACTER*(MAX_LEN_FNAM) dataFName
      CHARACTER*(MAX_LEN_MBUF) msgBuf

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_ENTER('DIAGNOSTICS_CALC_PHIVEL',myThid)
#endif

      DO ks = 1,nlevels(listId)
        k = NINT(levs(ks,listId))
C--   Solve for velocity potential for each level:

        a2dMax = 0. _d 0
        rhsMax = 0. _d 0
        DO bj = myByLo(myThid), myByHi(myThid)
         DO bi = myBxLo(myThid), myBxHi(myThid)
C-    Initialise fist guess & RHS
           DO j = 1-OLy,sNy+OLy
            DO i = 1-OLx,sNx+OLx
              b2d(i,j,bi,bj) = 0.
              x2d(i,j,bi,bj) = 0.
            ENDDO
           ENDDO
C-    calculate cg2d matrix:
C     Note: Here, at Open-Boundary location, we keep non-zero aW & aS (using
C     maskInW & maskInS) whereas in S/R CG2D they are zero (product of maskInC)
           DO j = 1,sNy+1
            DO i = 1,sNx+1
              aW2d(i,j,bi,bj) = dyG(i,j,bi,bj)*recip_dxC(i,j,bi,bj)
     &                         *drF(k)*hFacW(i,j,k,bi,bj)
     &                         *maskInW(i,j,bi,bj)
              aS2d(i,j,bi,bj) = dxG(i,j,bi,bj)*recip_dyC(i,j,bi,bj)
     &                         *drF(k)*hFacS(i,j,k,bi,bj)
     &                         *maskInS(i,j,bi,bj)
              a2dMax = MAX(a2dMax,aW2d(i,j,bi,bj))
              a2dMax = MAX(a2dMax,aS2d(i,j,bi,bj))
            ENDDO
           ENDDO

C-    calculate horizontal transport
           DO j = 1,sNy+1
            DO i = 1,sNx+1
              uTrans(i,j,bi,bj) = dyG(i,j,bi,bj)*drF(k)
     &                          *qtmp1(i,j,ks,bi,bj)*maskInW(i,j,bi,bj)
              vTrans(i,j,bi,bj) = dxG(i,j,bi,bj)*drF(k)
     &                          *qtmp2(i,j,ks,bi,bj)*maskInS(i,j,bi,bj)
            ENDDO
           ENDDO
C-   end bi,bj loops
         ENDDO
        ENDDO

C-    calculate RHS = rAc*Div(uVel,vVel):
        DO bj = myByLo(myThid), myByHi(myThid)
         DO bi = myBxLo(myThid), myBxHi(myThid)
           DO j = 1,sNy
            DO i = 1,sNx
              b2d(i,j,bi,bj) = (
     &                    ( uTrans(i+1,j,bi,bj) - uTrans(i,j,bi,bj) )
     &                  + ( vTrans(i,j+1,bi,bj) - vTrans(i,j,bi,bj) )
     &                         )*maskInC(i,j,bi,bj)
            ENDDO
           ENDDO
         ENDDO
        ENDDO

#ifdef ALLOW_OBCS
C  There is ambiguity in splitting OB cross flow into divergent (grad.Phi)
C    contribution and rotational (rot.Psi) contribution:
C  a) In most cases, will interpret most of the OB cross flow (except
C     the net inflow which has to come from grad.Phi) as non divergent
C     and only keep the divergence associated with the net inflow
C     (assuming here uniform distribution along the OB section;
C     This processing must be done for each domain-connected section
C     of the OB (using pkg/obcs OB[N,S,E,W]_connect Id) otherwise the
C     solver will not converge.
C  b) When setting a null domain-connected Id for some OB section,
C     we can recover the other extreme where the OB cross flow is
C     interpreted as a pure divergent (grad.Phi) contribution (-> constant
C      Psi along this section). This is done by keeping the full RHS just
C     outside OB (i.e., where tracer OBCS are applied.
        IF ( useOBCS ) THEN
         CALL OBCS_DIAG_BALANCE(
     U             b2d,
     I             uTrans, vTrans, k,
     I             myTime, myIter, myThid )
        ENDIF
#endif /* ALLOW_OBCS */

C-    Normalise Matrice & RHS :
        diagNormaliseRHS = diagCG_resTarget.GT.0.
        normaliseMatrice = .TRUE.
        diagNormaliseRHS = .TRUE.
        IF ( diagNormaliseRHS ) THEN
         DO bj = myByLo(myThid), myByHi(myThid)
          DO bi = myBxLo(myThid), myBxHi(myThid)
           DO j = 1,sNy
            DO i = 1,sNx
              rhsMax = MAX(ABS(b2d(i,j,bi,bj)),rhsMax)
            ENDDO
           ENDDO
          ENDDO
         ENDDO
        ENDIF
        a2dNorm = 1. _d 0
        b2dNorm = 1. _d 0
        x2dNorm = 1. _d 0
        IF ( normaliseMatrice ) THEN
          _GLOBAL_MAX_RL( a2dMax, myThid )
          IF ( a2dMax .GT. 0. _d 0 ) a2dNorm = 1. _d 0/a2dMax
          b2dNorm = a2dNorm
        ENDIF
        IF ( diagNormaliseRHS ) THEN
          _GLOBAL_MAX_RL( rhsMax, myThid )
          IF ( rhsMax .GT. 0. _d 0 ) THEN
            b2dNorm = 1. _d 0/rhsMax
            x2dNorm = a2dNorm*rhsMax
          ENDIF
          residCriter = diagCG_resTarget
        ELSE
          residCriter = a2dNorm * ABS(diagCG_resTarget)
     &                          * globalArea / deltaTMom
        ENDIF
        IF ( normaliseMatrice .OR. diagNormaliseRHS ) THEN
          DO bj = myByLo(myThid), myByHi(myThid)
           DO bi = myBxLo(myThid), myBxHi(myThid)
            DO j = 1,sNy+1
             DO i = 1,sNx+1
              aW2d(i,j,bi,bj) = aW2d(i,j,bi,bj)*a2dNorm
              aS2d(i,j,bi,bj) = aS2d(i,j,bi,bj)*a2dNorm
              b2d(i,j,bi,bj)  = b2d(i,j,bi,bj) *b2dNorm
c             x2d(i,j,bi,bj) =  x2d(i,j,bi,bj) /x2dNorm
             ENDDO
            ENDDO
           ENDDO
          ENDDO
        ENDIF

        IF ( diag_dBugLevel.GE.debLevA .AND. k.EQ.1 ) THEN
          _BEGIN_MASTER( myThid )
          WRITE(standardMessageUnit,'(A,I9,2(A,1P1E13.6),A,1P1E9.2)')
     &     ' diag_cg2d (it=', myIter,') a2dNorm,x2dNorm=', a2dNorm,
     &     ' ,', x2dNorm, ' ; Criter=', residCriter
          _END_MASTER( myThid )
        ENDIF

        numIters = diagCG_maxIters
        CALL DIAG_CG2D(
     I                aW2d, aS2d, b2d,
     I                diagCG_pcOffDFac, residCriter,
     O                firstResidual, minResidual, lastResidual,
     U                x2d, numIters,
     O                nIterMin,
     I                diagCG_prtResFrq, myThid )

        IF ( diag_dBugLevel.GE.debLevA ) THEN
          _BEGIN_MASTER( myThid )
          WRITE(standardMessageUnit,'(A,I4,A,2I6,A,1P3E14.7)')
     &    ' diag_cg2d : k=', k, ' , it=', nIterMin, numIters,
     &    ' ; ini,min,last_Res=',firstResidual,minResidual,lastResidual
          _END_MASTER( myThid )
        ENDIF

        _EXCH_XY_RL( x2d, myThid )

C-    Un-normalise the answer
        IF (diagNormaliseRHS) THEN
          DO bj = myByLo(myThid), myByHi(myThid)
           DO bi = myBxLo(myThid), myBxHi(myThid)
            DO j = 1-OLy,sNy+OLy
             DO i = 1-OLx,sNx+OLx
              x2d(i,j,bi,bj) =  x2d(i,j,bi,bj)*x2dNorm
             ENDDO
            ENDDO
           ENDDO
          ENDDO
        ENDIF

C-    Compte divergence-free transport:
        DO bj = myByLo(myThid), myByHi(myThid)
         DO bi = myBxLo(myThid), myBxHi(myThid)
          DO j = 1,sNy+1
           DO i = 1,sNx+1
            uTrans(i,j,bi,bj) = uTrans(i,j,bi,bj)
     &                        - ( x2d(i,j,bi,bj) - x2d(i-1,j,bi,bj) )
     &                         *recip_dxC(i,j,bi,bj)*dyG(i,j,bi,bj)
     &                         *drF(k)*hFacW(i,j,k,bi,bj)
     &                         *maskInW(i,j,bi,bj)
            vTrans(i,j,bi,bj) = vTrans(i,j,bi,bj)
     &                        - ( x2d(i,j,bi,bj) - x2d(i,j-1,bi,bj) )
     &                         *recip_dyC(i,j,bi,bj)*dxG(i,j,bi,bj)
     &                         *drF(k)*hFacS(i,j,k,bi,bj)
     &                         *maskInS(i,j,bi,bj)
           ENDDO
          ENDDO
         ENDDO
        ENDDO
        CALL DIAG_CALC_PSIVEL(
     I                         k, iPsi0, jPsi0, uTrans, vTrans,
     O                         psiVel, psiLoc,
     I                         prtFirstCall, myTime, myIter, myThid )

        _BEGIN_MASTER( myThid)
        IF ( useCubedSphereExchange .AND.
     &       diag_mdsio .AND. myProcId.EQ.0 ) THEN
C-      Missing-corner value are not written in MDS output file
C       Write separately these 2 values (should be part of DIAGNOSTICS_OUT)
         IF ( diagLoc_ioUnit.EQ.0 ) THEN
          CALL MDSFINDUNIT( diagLoc_ioUnit, myThid )
          WRITE(dataFName,'(2A,I10.10,A)')
     &         'diags_CScorners', '.', nIter0, '.txt'
          OPEN( diagLoc_ioUnit, FILE=dataFName, STATUS='unknown' )
          iL = ILNBLNK(dataFName)
          WRITE(msgBuf,'(2A,I6,2A)') 'DIAGNOSTICS_CALC_PHIVEL: ',
     &         'open unit=',diagLoc_ioUnit, ', file: ',dataFName(1:iL)
          CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                        SQUEEZE_RIGHT, myThid )
         ENDIF
         IF ( diagLoc_ioUnit.GT.0 ) THEN
          WRITE(diagLoc_ioUnit,'(1P2E18.10,A,2I4,I8,A,2I4,I6,2A)')
     &      psiLoc, ' #', k, lm, myIter,
     &      ' :',listId, md, ndId, ' ', cdiag(ndId)
C-       check accuracy (f1.SW-corner = f6.NW-corner = f5-NE-corner)
c         WRITE(0,'(1P2E18.10,A,2I4,I8)')
c    &         psiVel(1,1+sNy,nSx,nSy)- psiVel(1,1,1,1),
c    &     psiVel(1+sNx,1+sNy,nSx-1,nSy)-psiVel(1,1,1,1),
c    &      ' #', k, lm, myIter
         ENDIF
        ENDIF
        IF ( prtFirstCall ) prtFirstCall = .FALSE.
        _END_MASTER( myThid)

C-    Put the results back in qtmp[1,2]
        DO bj = myByLo(myThid), myByHi(myThid)
         DO bi = myBxLo(myThid), myBxHi(myThid)
          DO j = 1,sNy+1
           DO i = 1,sNx+1
              qtmp1(i,j,ks,bi,bj) =  x2d(i,j,bi,bj)
              qtmp2(i,j,ks,bi,bj) =  psiVel(i,j,bi,bj)
           ENDDO
          ENDDO
         ENDDO
        ENDDO

      ENDDO

#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_LEAVE('DIAGNOSTICS_CALC_PHIVEL',myThid)
#endif

      RETURN
      END

#include "STREAMICE_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

CBOP
      SUBROUTINE STREAMICE_CG_SOLVE(
     U                               cg_Uin,     ! x-velocities
     U                               cg_Vin,     ! y-velocities
     I                               cg_Bu,      ! force in x dir
     I                               cg_Bv,      ! force in y dir
     I                               A_uu,       ! section of matrix that multiplies u and projects on u
     I                               A_uv,       ! section of matrix that multiplies v and projects on u
     I                               A_vu,       ! section of matrix that multiplies u and projects on v
     I                               A_vv,       ! section of matrix that multiplies v and projects on v
     I                               tolerance,
     O                               iters,
     I                               maxIter,
     I                               myThid )
C     /============================================================\
C     | SUBROUTINE                                                 |
C     | o                                                          |
C     |============================================================|
C     |                                                            |
C     \============================================================/
      IMPLICIT NONE

#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "STREAMICE.h"
#include "STREAMICE_CG.h"

c#ifdef ALLOW_PETSC
c#include "finclude/petsc.h"
c UNCOMMENT IF V3.0
c#include "finclude/petscvec.h"
c#include "finclude/petscmat.h"
c#include "finclude/petscksp.h"
c#include "finclude/petscpc.h"
c#endif
C     === Global variables ===

C     !INPUT/OUTPUT ARGUMENTS
C     cg_Uin, cg_Vin - input and output velocities
C     cg_Bu, cg_Bv - driving stress
      INTEGER myThid
      INTEGER iters
      INTEGER maxIter
      _RL tolerance
      _RL cg_Uin (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL cg_Vin (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL cg_Bu (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL cg_Bv (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL
     & A_uu (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy,-1:1,-1:1),
     & A_vu (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy,-1:1,-1:1),
     & A_uv (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy,-1:1,-1:1),
     & A_vv (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy,-1:1,-1:1)

C     LOCAL VARIABLES
      INTEGER i, j, bi, bj, cg_halo, conv_flag
      INTEGER iter, is, js, ie, je, colx, coly
      _RL dot_p1, dot_p2, alpha_k, beta_k, resid, resid_0
      _RL dot_p1_tile (nSx,nSy)
      _RL dot_p2_tile (nSx,nSy)
      CHARACTER*(MAX_LEN_MBUF) msgBuf

c#ifdef ALLOW_PETSC
c      INTEGER indices(2*(sNx*nSx*sNy*nSy))
c      INTEGER n_dofs_cum_sum (0:nPx*nPy-1), idx(1)
c      _RL rhs_values(2*(sNx*nSx*sNy*nSy))
c      _RL solution_values(2*(sNx*nSx*sNy*nSy))
c      _RL mat_values (2*Nx*Ny,2*(sNx*nSx*sNy*nSy))
c      _RL mat_values (18,1), mat_val_return(1)
c      INTEGER indices_col(18)
c      INTEGER local_dofs, global_dofs, dof_index, dof_index_col
c      INTEGER local_offset
c      Mat matrix
c      KSP ksp
c      PC  pc
c      Vec rhs
c      Vec solution
c      PetscErrorCode ierr
c#ifdef ALLOW_USE_MPI
c      integer mpiRC, mpiMyWid
c#endif
c#endif

#ifdef ALLOW_STREAMICE

      CALL TIMER_START ('STREAMICE_CG_SOLVE',myThid)
#ifndef STREAMICE_SERIAL_TRISOLVE

#ifdef ALLOW_PETSC

#if ((!defined ALLOW_OPENAD) && (!defined ALLOW_TAPENADE))
      if (streamice_use_petsc.and.petscFlag.eq.1) then
#else
      if (streamice_use_petsc) then
#endif

      CALL STREAMICE_CG_SOLVE_PETSC(
     U         cg_Uin,     ! x-velocities
     U         cg_Vin,     ! y-velocities
     I         cg_Bu,      ! force in x dir
     I         cg_Bv,      ! force in y dir
     I         A_uu,       ! section of matrix that multiplies u and projects on u
     I         A_uv,       ! section of matrix that multiplies v and projects on u
     I         A_vu,       ! section of matrix that multiplies u and projects on v
     I         A_vv,       ! section of matrix that multiplies v and projects on v
     I         tolerance,
     I         iters,
     O         maxiter,
     I         myThid )

      else

#endif  /* ALLOW_PETSC */

      iters = maxIter
      conv_flag = 0

      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
        DO j=1,sNy
         DO i=1,sNx
          Zu_SI (i,j,bi,bj) = 0. _d 0
          Zv_SI (i,j,bi,bj) = 0. _d 0
          Ru_SI (i,j,bi,bj) = 0. _d 0
          Rv_SI (i,j,bi,bj) = 0. _d 0
          Au_SI (i,j,bi,bj) = 0. _d 0
          Av_SI (i,j,bi,bj) = 0. _d 0
          Du_SI (i,j,bi,bj) = 0. _d 0
          Dv_SI (i,j,bi,bj) = 0. _d 0
         ENDDO
        ENDDO
       ENDDO
      ENDDO

C     FIND INITIAL RESIDUAL, and initialize r

c #ifdef STREAMICE_CONSTRUCT_MATRIX

        DO bj = myByLo(myThid), myByHi(myThid)
         DO bi = myBxLo(myThid), myBxHi(myThid)
          DO j=1,sNy
           DO i=1,sNx
            DO colx=-1,1
             DO coly=-1,1
              Au_SI(i,j,bi,bj) = Au_SI(i,j,bi,bj) +
     &         A_uu(i,j,bi,bj,colx,coly)*
     &         cg_Uin(i+colx,j+coly,bi,bj)+
     &         A_uv(i,j,bi,bj,colx,coly)*
     &         cg_Vin(i+colx,j+coly,bi,bj)

              Av_SI(i,j,bi,bj) = Av_SI(i,j,bi,bj) +
     &         A_vu(i,j,bi,bj,colx,coly)*
     &         cg_Uin(i+colx,j+coly,bi,bj)+
     &         A_vv(i,j,bi,bj,colx,coly)*
     &         cg_Vin(i+colx,j+coly,bi,bj)
             ENDDO
            ENDDO
           ENDDO
          ENDDO
         ENDDO
        ENDDO

      _EXCH_XY_RL( Au_SI, myThid )
      _EXCH_XY_RL( Av_SI, myThid )

      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          Ru_SI(i,j,bi,bj)=cg_Bu(i,j,bi,bj)-
     &     Au_SI(i,j,bi,bj)
          Rv_SI(i,j,bi,bj)=cg_Bv(i,j,bi,bj)-
     &     Av_SI(i,j,bi,bj)
         ENDDO
        ENDDO
        dot_p1_tile(bi,bj) = 0. _d 0
        dot_p2_tile(bi,bj) = 0. _d 0
       ENDDO
      ENDDO

      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
        DO j=1,sNy
         DO i=1,sNx
          IF (STREAMICE_umask(i,j,bi,bj).eq.1.0)
     &      dot_p1_tile(bi,bj)=dot_p1_tile(bi,bj)+Ru_SI(i,j,bi,bj)**2
          IF (STREAMICE_vmask(i,j,bi,bj).eq.1.0)
     &      dot_p1_tile(bi,bj)=dot_p1_tile(bi,bj)+Rv_SI(i,j,bi,bj)**2
         ENDDO
        ENDDO
       ENDDO
      ENDDO

      CALL GLOBAL_SUM_TILE_RL( dot_p1_tile, dot_p1, myThid )
      resid_0 = sqrt(dot_p1)

      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)

       WRITE(msgBuf,'(A,I1,I1,E14.7)') 'CONJ GRAD INIT RESID LOCAL, ',
     &         bi,bj, dot_p1_tile(bi,bj)
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                     SQUEEZE_RIGHT , 1)

       enddo
      enddo

      WRITE(msgBuf,'(A,E14.7)') 'CONJ GRAD INIT RESID, ',
     &         resid_0
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                     SQUEEZE_RIGHT , 1)

C    CCCCCCCCCCCCCCCCCCCC

      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          IF (STREAMICE_umask(i,j,bi,bj).eq.1.0)
     &      Zu_SI(i,j,bi,bj)=Ru_SI(i,j,bi,bj) / DIAGu_SI(i,j,bi,bj)
          IF (STREAMICE_vmask(i,j,bi,bj).eq.1.0)
     &      Zv_SI(i,j,bi,bj)=Rv_SI(i,j,bi,bj) / DIAGv_SI(i,j,bi,bj)
         ENDDO
        ENDDO
       ENDDO
      ENDDO

      cg_halo = min(OLx-1,OLy-1)
      conv_flag = 0

      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          Du_SI(i,j,bi,bj)=Zu_SI(i,j,bi,bj)
          Dv_SI(i,j,bi,bj)=Zv_SI(i,j,bi,bj)
         ENDDO
        ENDDO
       ENDDO
      ENDDO

      resid = resid_0
      iters = 0

c  !!!!!!!!!!!!!!!!!!
c  !!              !!
c  !! MAIN CG LOOP !!
c  !!              !!
c  !!!!!!!!!!!!!!!!!!

c  ! initially, b-grid data is valid up to 3 halo nodes out -- right? (check for MITgcm!!)

      WRITE(msgBuf,'(A)') 'BEGINNING MAIN CG LOOP'
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                     SQUEEZE_RIGHT , 1)

c       IF(STREAMICE_construct_matrix) CALL STREAMICE_CG_MAKE_A(myThid)

      do iter = 1, maxIter
       if (resid .gt. tolerance*resid_0) then

c      to avoid using "exit"
       iters = iters + 1

       is = 1 - cg_halo
       ie = sNx + cg_halo
       js = 1 - cg_halo
       je = sNy + cg_halo

       DO bj = myByLo(myThid), myByHi(myThid)
        DO bi = myBxLo(myThid), myBxHi(myThid)
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           Au_SI(i,j,bi,bj) = 0. _d 0
           Av_SI(i,j,bi,bj) = 0. _d 0
          ENDDO
         ENDDO
        ENDDO
       ENDDO

c        IF (STREAMICE_construct_matrix) THEN

c #ifdef STREAMICE_CONSTRUCT_MATRIX

        DO bj = myByLo(myThid), myByHi(myThid)
         DO bi = myBxLo(myThid), myBxHi(myThid)
          DO j=js,je
           DO i=is,ie
            DO colx=-1,1
             DO coly=-1,1
              Au_SI(i,j,bi,bj) = Au_SI(i,j,bi,bj) +
     &         A_uu(i,j,bi,bj,colx,coly)*
     &         Du_SI(i+colx,j+coly,bi,bj)+
     &         A_uv(i,j,bi,bj,colx,coly)*
     &         Dv_SI(i+colx,j+coly,bi,bj)
              Av_SI(i,j,bi,bj) = Av_SI(i,j,bi,bj) +
     &         A_vu(i,j,bi,bj,colx,coly)*
     &         Du_SI(i+colx,j+coly,bi,bj)+
     &         A_vv(i,j,bi,bj,colx,coly)*
     &         Dv_SI(i+colx,j+coly,bi,bj)
             ENDDO
            ENDDO
           ENDDO
          ENDDO
         ENDDO
        ENDDO

c        else
c #else
c
c         CALL STREAMICE_CG_ACTION( myThid,
c      O     Au_SI,
c      O     Av_SI,
c      I     Du_SI,
c      I     Dv_SI,
c      I     is,ie,js,je)
c
c !        ENDIF
c
c #endif

       DO bj = myByLo(myThid), myByHi(myThid)
        DO bi = myBxLo(myThid), myBxHi(myThid)
         dot_p1_tile(bi,bj) = 0. _d 0
         dot_p2_tile(bi,bj) = 0. _d 0
        ENDDO
       ENDDO

       DO bj = myByLo(myThid), myByHi(myThid)
        DO bi = myBxLo(myThid), myBxHi(myThid)
         DO j=1,sNy
          DO i=1,sNx
           IF (STREAMICE_umask(i,j,bi,bj).eq.1.0) THEN
           dot_p1_tile(bi,bj)=dot_p1_tile(bi,bj)+Zu_SI(i,j,bi,bj)*
     &        Ru_SI(i,j,bi,bj)
            dot_p2_tile(bi,bj)=dot_p2_tile(bi,bj)+Du_SI(i,j,bi,bj)*
     &        Au_SI(i,j,bi,bj)
           ENDIF
           IF (STREAMICE_vmask(i,j,bi,bj).eq.1.0) THEN
            dot_p1_tile(bi,bj)=dot_p1_tile(bi,bj)+Zv_SI(i,j,bi,bj)*
     &        Rv_SI(i,j,bi,bj)
            dot_p2_tile(bi,bj)=dot_p2_tile(bi,bj)+Dv_SI(i,j,bi,bj)*
     &        Av_SI(i,j,bi,bj)
           ENDIF
          ENDDO
         ENDDO
        ENDDO
       ENDDO

       CALL GLOBAL_SUM_TILE_RL( dot_p1_tile, dot_p1, myThid )
       CALL GLOBAL_SUM_TILE_RL( dot_p2_tile, dot_p2, myThid )
       alpha_k = dot_p1/dot_p2

       DO bj = myByLo(myThid), myByHi(myThid)
        DO bi = myBxLo(myThid), myBxHi(myThid)
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx

           IF (STREAMICE_umask(i,j,bi,bj).eq.1.0) THEN
            cg_Uin(i,j,bi,bj)=cg_Uin(i,j,bi,bj)+
     &       alpha_k*Du_SI(i,j,bi,bj)
            Ru_old_SI(i,j,bi,bj) = Ru_SI(i,j,bi,bj)
            Zu_old_SI(i,j,bi,bj) = Zu_SI(i,j,bi,bj)
            Ru_SI(i,j,bi,bj) = Ru_SI(i,j,bi,bj)-
     &       alpha_k*Au_SI(i,j,bi,bj)
            Zu_SI(i,j,bi,bj) = Ru_SI(i,j,bi,bj) /
     &       DIAGu_SI(i,j,bi,bj)
           ENDIF

           IF (STREAMICE_vmask(i,j,bi,bj).eq.1.0) THEN
            cg_Vin(i,j,bi,bj)=cg_Vin(i,j,bi,bj)+
     &       alpha_k*Dv_SI(i,j,bi,bj)
            Rv_old_SI(i,j,bi,bj) = Rv_SI(i,j,bi,bj)
            Zv_old_SI(i,j,bi,bj) = Zv_SI(i,j,bi,bj)
            Rv_SI(i,j,bi,bj) = Rv_SI(i,j,bi,bj)-
     &       alpha_k*Av_SI(i,j,bi,bj)
            Zv_SI(i,j,bi,bj) = Rv_SI(i,j,bi,bj) /
     &       DIAGv_SI(i,j,bi,bj)

           ENDIF
          ENDDO
         ENDDO
        ENDDO
       ENDDO

       DO bj = myByLo(myThid), myByHi(myThid)
        DO bi = myBxLo(myThid), myBxHi(myThid)
         dot_p1_tile(bi,bj) = 0. _d 0
         dot_p2_tile(bi,bj) = 0. _d 0
        ENDDO
       ENDDO

       DO bj = myByLo(myThid), myByHi(myThid)
        DO bi = myBxLo(myThid), myBxHi(myThid)
         DO j=1,sNy
          DO i=1,sNx

           IF (STREAMICE_umask(i,j,bi,bj).eq.1.0) THEN
            dot_p1_tile(bi,bj)=dot_p1_tile(bi,bj)+Zu_SI(i,j,bi,bj)*
     &        Ru_SI(i,j,bi,bj)
            dot_p2_tile(bi,bj)=dot_p2_tile(bi,bj)+Zu_old_SI(i,j,bi,bj)*
     &        Ru_old_SI(i,j,bi,bj)
           ENDIF

           IF (STREAMICE_vmask(i,j,bi,bj).eq.1.0) THEN
            dot_p1_tile(bi,bj)=dot_p1_tile(bi,bj)+Zv_SI(i,j,bi,bj)*
     &        Rv_SI(i,j,bi,bj)
            dot_p2_tile(bi,bj)=dot_p2_tile(bi,bj)+Zv_old_SI(i,j,bi,bj)*
     &        Rv_old_SI(i,j,bi,bj)
           ENDIF

          ENDDO
         ENDDO
        ENDDO
       ENDDO

       CALL GLOBAL_SUM_TILE_RL( dot_p1_tile, dot_p1, myThid )
       CALL GLOBAL_SUM_TILE_RL( dot_p2_tile, dot_p2, myThid )

       beta_k = dot_p1/dot_p2

       DO bj = myByLo(myThid), myByHi(myThid)
        DO bi = myBxLo(myThid), myBxHi(myThid)
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           IF (STREAMICE_umask(i,j,bi,bj).eq.1.0)
     &      Du_SI(i,j,bi,bj)=beta_k*Du_SI(i,j,bi,bj)+
     &      Zu_SI(i,j,bi,bj)
           IF (STREAMICE_vmask(i,j,bi,bj).eq.1.0)
     &      Dv_SI(i,j,bi,bj)=beta_k*Dv_SI(i,j,bi,bj)+
     &      Zv_SI(i,j,bi,bj)
          ENDDO
         ENDDO
        ENDDO
       ENDDO

       DO bj = myByLo(myThid), myByHi(myThid)
        DO bi = myBxLo(myThid), myBxHi(myThid)
         dot_p1_tile(bi,bj) = 0. _d 0
        ENDDO
       ENDDO

       DO bj = myByLo(myThid), myByHi(myThid)
        DO bi = myBxLo(myThid), myBxHi(myThid)
         DO j=1,sNy
          DO i=1,sNx
           IF (STREAMICE_umask(i,j,bi,bj).eq.1.0)
     &      dot_p1_tile(bi,bj)=dot_p1_tile(bi,bj)+Ru_SI(i,j,bi,bj)**2
           IF (STREAMICE_vmask(i,j,bi,bj).eq.1.0)
     &      dot_p1_tile(bi,bj)=dot_p1_tile(bi,bj)+Rv_SI(i,j,bi,bj)**2
          ENDDO
         ENDDO
        ENDDO
       ENDDO

       CALL GLOBAL_SUM_TILE_RL( dot_p1_tile, dot_p1, myThid )
       resid = sqrt(dot_p1)

c        IF (iter .eq. 1) then
c         print *, alpha_k, beta_k, resid
c        ENDIF

       cg_halo = cg_halo - 1

       if (cg_halo .eq. 0) then
        cg_halo = min(OLx-1,OLy-1)
        _EXCH_XY_RL( Du_SI, myThid )
        _EXCH_XY_RL( Dv_SI, myThid )
        _EXCH_XY_RL( Ru_SI, myThid )
        _EXCH_XY_RL( Rv_SI, myThid )
        _EXCH_XY_RL( cg_Uin, myThid )
        _EXCH_XY_RL( cg_Vin, myThid )
       endif

       endif
      enddo ! end of CG loop

c     to avoid using "exit"
c     if iters has reached max_iters there is no convergence

      IF (iters .lt. maxIter) THEN
       conv_flag = 1
      ENDIF
      PRINT *, "GOT HERE CG ITERATIONS", iters

c       DO bj = myByLo(myThid), myByHi(myThid)
c        DO bi = myBxLo(myThid), myBxHi(myThid)
c         DO j=1-OLy,sNy+OLy
c          DO i=1-OLy,sNx+OLy
c           IF (STREAMICE_umask(i,j,bi,bj).eq.3.0)
c      &     cg_Uin(i,j,bi,bj)=u_bdry_values_SI(i,j,bi,bj)
c           IF (STREAMICE_vmask(i,j,bi,bj).eq.3.0)
c      &     cg_Vin(i,j,bi,bj)=v_bdry_values_SI(i,j,bi,bj)
c          ENDDO
c         ENDDO
c        ENDDO
c       ENDDO
c
c       _EXCH_XY_RL( cg_Uin, myThid )
c       _EXCH_XY_RL( cg_Vin, myThid )

#ifdef ALLOW_PETSC
      endif   !if (streamice_use_petsc)
#endif

#else /* STREAMICE_SERIAL_TRISOLVE */

      iters = 0

      CALL STREAMICE_TRIDIAG_SOLVE(
     U                               cg_Uin,     ! x-velocities
     U                               cg_Vin,
     U                               cg_Bu,      ! force in x dir
     I                               A_uu,       ! section of matrix that multiplies u and projects on u
     I                               STREAMICE_umask,
     I                               myThid )

#endif

      CALL TIMER_STOP ('STREAMICE_CG_SOLVE',myThid)

#endif
      RETURN
      END

#include "OFFLINE_OPTIONS.h"
#ifdef ALLOW_DIC
# include "DIC_OPTIONS.h"
#endif
#ifdef ALLOW_DARWIN
# include "DARWIN_OPTIONS.h"
#endif
#ifdef ALLOW_GMREDI
# include "GMREDI_OPTIONS.h"
#endif

CBOP
C     !ROUTINE: OFFLINE_GET_SURFFORCING
C     !INTERFACE:
      SUBROUTINE OFFLINE_GET_DIFFUS( myTime, myIter, myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE OFFLINE_GET_DIFFUS
C     | o Interpolate in time diffusivity fields that have
C     |   been loaded from file
C     *==========================================================*
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "DYNVARS.h"
#include "FFIELDS.h"
#include "OFFLINE.h"
#include "OFFLINE_SWITCH.h"
#ifdef ALLOW_GMREDI
# include "GMREDI.h"
#endif
#ifdef ALLOW_KPP
# include "KPP.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
C     myTime  :: current time in simulation
C     myIter  :: current iteration number in simulation
C     myThid  :: my Thread Id number
      _RL     myTime
      INTEGER myIter
      INTEGER myThid
CEOP

C     !LOCAL VARIABLES:
      INTEGER i,j,k
      INTEGER bi,bj
      _RL aWght, bWght
#ifdef ALLOW_AUTODIFF
      _RL locTime
      INTEGER intimeP, intime0, intime1
#endif /* ALLOW_AUTODIFF */

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#ifdef ALLOW_AUTODIFF
C--   Re-compute the weights (bWght, aWght) to simplify dependencies
C     (since they are not stored on tapes)
      locTime = myTime - offlineTimeOffset
      CALL GET_PERIODIC_INTERVAL(
     O                  intimeP, intime0, intime1, bWght, aWght,
     I                  offlineForcingCycle, offlineForcingPeriod,
     I                  deltaToffline, locTime, myThid )
#endif /* ALLOW_AUTODIFF */

C--   Interpolate Diffusivity Components:
      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
#ifndef ALLOW_AUTODIFF
        bWght = offline_Wght(1,bi,bj)
        aWght = offline_Wght(2,bi,bj)
#endif /* ndef ALLOW_AUTODIFF */

        IF ( Wvelfile .NE. ' '  .AND. myIter.EQ.nIter0 ) THEN
         DO k=1,Nr
          DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
            wVel(i,j,k,bi,bj) = bWght*wvel0(i,j,k,bi,bj)
     &                        + aWght*wvel1(i,j,k,bi,bj)
           ENDDO
          ENDDO
         ENDDO
        ENDIF
        IF ( offlineLoadConvec ) THEN
         DO k=1,Nr
          DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
            IVDConvCount(i,j,k,bi,bj) = bWght*conv0(i,j,k,bi,bj)
     &                                + aWght*conv1(i,j,k,bi,bj)
           ENDDO
          ENDDO
         ENDDO
        ENDIF
#ifdef ALLOW_GMREDI
        IF ( offlineLoadGMRedi ) THEN
         DO k=1,Nr
          DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
            Kwx(i,j,k,bi,bj)  = bWght*gmkx0(i,j,k,bi,bj)
     &                        + aWght*gmkx1(i,j,k,bi,bj)
            Kwy(i,j,k,bi,bj)  = bWght*gmky0(i,j,k,bi,bj)
     &                        + aWght*gmky1(i,j,k,bi,bj)
            Kwz(i,j,k,bi,bj)  = bWght*gmkz0(i,j,k,bi,bj)
     &                        + aWght*gmkz1(i,j,k,bi,bj)
#ifndef GM_NON_UNITY_DIAGONAL
            Kux(i,j,k,bi,bj) = GM_isopycK
            Kvy(i,j,k,bi,bj) = GM_isopycK
#endif
           ENDDO
          ENDDO
         ENDDO
        ENDIF
#endif /* ALLOW_GMREDI */
#ifdef ALLOW_KPP
        IF ( offlineLoadKPP ) THEN
         DO k=1,Nr
          DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
            KPPdiffKzS(i,j,k,bi,bj) = bWght*kdfs0(i,j,k,bi,bj)
     &                              + aWght*kdfs1(i,j,k,bi,bj)
C-- Note: for convenience, the array KPPghat will contain
C         the product ghat*diffKzS (and not ghat alone).
            KPPghat(i,j,k,bi,bj) = bWght*kght0(i,j,k,bi,bj)
     &                           + aWght*kght1(i,j,k,bi,bj)
           ENDDO
          ENDDO
         ENDDO
        ENDIF
#endif /* ALLOW_KPP */

C--   Interpolate surface forcing
#if ( (defined ALLOW_DIC) || (defined ALLOW_DARWIN) )
#ifdef ALLOW_OLD_VIRTUALFLUX
        IF ( SFluxFile.NE.' ' ) THEN
          DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
            surfaceForcingS(i,j,bi,bj) = bWght*sflx0(i,j,bi,bj)
     &                                 + aWght*sflx1(i,j,bi,bj)
            surfaceForcingS(i,j,bi,bj) = surfaceForcingS(i,j,bi,bj)
     &                                  *mass2rUnit
           ENDDO
          ENDDO
        ENDIF
#endif /* ALLOW_OLD_VIRTUALFLUX */
#endif /* ALLOW_DIC or ALLOW_DARWIN */

C--    kept from older version:
c           surfaceForcingT(i,j,bi,bj) = bWght*hflx0(i,j,bi,bj)
c    &                                 + aWght*hflx1(i,j,bi,bj)
c           surfaceForcingT(i,j,bi,bj) = surfaceForcingT(i,j,bi,bj)
c    &                         *recip_Cp*mass2rUnit
c           ICEM(i,j,bi,bj) = bWght*icem0(i,j,bi,bj)
c    &                      + aWght*icem1(i,j,bi,bj)

C--   end bi,bj loops
       ENDDO
      ENDDO

      RETURN
      END

#include "ICEFRONT_OPTIONS.h"

CBOP
C     !ROUTINE: ICEFRONT_THERMODYNAMICS
C     !INTERFACE:
      SUBROUTINE ICEFRONT_THERMODYNAMICS(
     I                        myTime, myIter, myThid )
C     !DESCRIPTION: \bv
C     *=============================================================*
C     | S/R  ICEFRONT_THERMODYNAMICS
C     | o shelf-ice main routine.
C     |   compute temperature and (virtual) salt flux at the
C     |   shelf-ice ocean interface
C     |
C     | stresses at the ice/water interface are computed in separate
C     | routines that are called from mom_fluxform/mom_vecinv
C     *=============================================================*

C     !USES:
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "DYNVARS.h"
#include "FFIELDS.h"
#include "ICEFRONT.h"

C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
C     myIter :: iteration counter for this thread
C     myTime :: time counter for this thread
C     myThid :: thread number for this instance of the routine.
      _RL  myTime
      INTEGER myIter
      INTEGER myThid
CEOP

#ifdef ALLOW_ICEFRONT
C     !LOCAL VARIABLES :
C     === Local variables ===
C     I,J,K,bi,bj      :: loop counters
C     tLoc, sLoc, pLoc :: local in-situ temperature, salinity, pressure
C     thetaICE         :: averaged temperature of glacier interior
C     theta/saltFreeze :: temperature and salinity of water at the
C                         ice-ocean interface (at the freezing point)
C     FreshWaterFlux   :: fresh water flux due to freezing or melting of ice
C                         front in kg/m^2/s (positive increases ocean salinity)
C     HeatFlux         :: ice front heat flux in W/m^2
C                         (positive decreases ocean temperature)
C     auxiliary variables and abbreviations:
C     a0, b, c0
C     eps1, eps2, eps3, eps4, eps5, eps6, eps7
C     aqe, bqe, cqe, discrim, recip_aqe
      INTEGER I,J,K
      INTEGER bi,bj
      _RL tLoc, sLoc, pLoc
      _RL thetaICE
      _RL thetaFreeze, saltFreeze
      _RS FreshWaterFlux( 1:sNx, 1:sNy )
      _RS HeatFlux      ( 1:sNx, 1:sNy )
      _RS ICEFRONTheatTransCoeff ( 1:sNx, 1:sNy )
      _RS ICEFRONTsaltTransCoeff ( 1:sNx, 1:sNy )
      _RL a0, b, c0
      _RL eps1, eps2, eps3, eps4, eps5, eps6, eps7
      _RL aqe, bqe, cqe, discrim, recip_aqe


      _RL SW_TEMP
      EXTERNAL SW_TEMP

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C     Linear dependence of freezing point on salinity.
      a0 = -0.0575   _d  0
      c0 =  0.0901   _d  0
      b  =  -7.61    _d -4


      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
        DO K = 1, Nr
         DO J = 1, sNy
          DO I = 1, sNx

C     Calculate ICEFRONTheatTransCoeff & ICEFRONTsaltTransCoeff
           IF( ICEFRONTlength(I,J,bi,bj) .GT. 0. _d 0
     &          .AND. K .LE. K_icefront(I,J,bi,bj) ) THEN
            ICEFRONTheatTransCoeff(I,J) = 1.0 _d -02
     &                                  *abs(wVEL(I,J,K,bi,bj))
     &                                  *sqrt(1.5 _d -03)
            ICEFRONTheatTransCoeff(I,J) = max
     &                          (ICEFRONTheatTransCoeff(I,J),1. _d -04)
            ICEFRONTsaltTransCoeff(I,J) = 5.05 _d -3
     &                                  *ICEFRONTheatTransCoeff(I,J)

C     A few abbreviations.
      eps1 = rUnit2mass*HeatCapacity_Cp*ICEFRONTheatTransCoeff(I,J)
      eps2 = rUnit2mass*ICEFRONTlatentHeat*ICEFRONTsaltTransCoeff(I,J)
      eps3 = rUnit2mass*ICEFRONTheatCapacity_Cp
     &       *ICEFRONTsaltTransCoeff(I,J)
      eps5 = mass2rUnit/HeatCapacity_Cp
      aqe  = a0  *(-eps1+eps3)
      recip_aqe = 0.5 _d 0/aqe

C     Make local copies of temperature, salinity and depth (pressure).
            pLoc = ABS(rC(k))
            tLoc = theta(I,J,K,bi,bj)
            sLoc = MAX(salt(I,J,K,bi,bj), 0. _d 0)

C     Turn potential temperature into in-situ temperature.
            tLoc = SW_TEMP(sLoc,tLoc,pLoc,0.D0)

C     Get ice temperature. Assume linear ice temperature change from 
C     the surface (ICEFRONTthetaSurface) to the base(0 degree C).
            IF ( K .EQ. K_icefront(I,J,bi,bj)) THEN
             pLoc = 0.5*(ABS(R_icefront(I,J,bi,bj))+ABS(rF(K)))
            ENDIF
            thetaICE = ICEFRONTthetaSurface*
     &           (R_icefront(I,J,bi,bj)-pLoc) 
     &           / R_icefront(I,J,bi,bj)

C     A few more abbreviations.
            eps4 = b*pLoc + c0
            eps6 = eps4 - tLoc
            eps7 = eps4 - thetaIce

C     Solve quadratic equation to get salinity at icefront-ocean interface.
            bqe = - eps1*eps6 -sLoc*a0*eps3 + eps3*eps7 + eps2
            cqe = -(eps2+eps3*eps7)*sLoc
            discrim = bqe*bqe - 4. _d 0*aqe*cqe
            saltFreeze = (- bqe - SQRT(discrim))*recip_aqe
            IF ( saltFreeze .LT. 0. _d 0 )
     &           saltFreeze = (- bqe + SQRT(discrim))*recip_aqe
            thetaFreeze = a0*saltFreeze + eps4

C--   Calculate the outward (leaving the ocean) heat (W/m^2)
C     and freshwater (kg/m^2/s).
C     Sign convention: inward (negative) fresh water flux implies glacier
C     melting due to outward (positive) heat flux.
            FreshWaterFlux(I,J) = maskC(I,J,K,bi,bj) *
     &           eps1 * ( thetaFreeze - tLoc ) /
     &           (ICEFRONTlatentHeat + ICEFRONTheatCapacity_cp*
     &           (thetaFreeze - thetaIce))
            HeatFlux(I,J) = maskC(I,J,K,bi,bj) * HeatCapacity_Cp *
     &           ( -rUnit2mass*ICEFRONTheatTransCoeff(I,J) +
     &           FreshWaterFlux(I,J) ) * ( thetaFreeze - tLoc )

C     Compute tendencies.
            icefront_TendT(i,j,K,bi,bj) = - HeatFlux(I,J)* eps5
            icefront_TendS(i,j,K,bi,bj) = FreshWaterFlux(I,J) *
     &           mass2rUnit * sLoc

C     Scale by icefrontlength, which is the ratio of the horizontal length
C     of the ice front in each model grid cell divided by the grid cell area.
            IF (k .LT. k_icefront(i,j,bi,bj)) THEN  
             icefront_TendT(i,j,K,bi,bj) = icefront_TendT(i,j,K,bi,bj)
     &            * ICEFRONTlength(i,j,bi,bj)
             icefront_TendS(i,j,K,bi,bj) = icefront_TendS(i,j,K,bi,bj)
     &            * ICEFRONTlength(i,j,bi,bj)
            ELSEIF (k .EQ. k_icefront(i,j,bi,bj)) THEN
C     At the bottom of the ice shelf there is additional scaling due
C     to the partial depth of the ice front.
             icefront_TendT(i,j,K,bi,bj) = icefront_TendT(i,j,K,bi,bj)
     &            * ICEFRONTlength(i,j,bi,bj)
     &            * (ABS(R_icefront(I,J,bi,bj))-ABS(rF(K)))
     &            * recip_drF(K)
             icefront_TendS(i,j,K,bi,bj) = icefront_TendS(i,j,K,bi,bj)
     &            * ICEFRONTlength(i,j,bi,bj)
     &            * (ABS(R_icefront(I,J,bi,bj))-ABS(rF(K)))
     &            * recip_drF(K)
            ENDIF

           ELSE                 ! K .LE. K_icefront

            HeatFlux      (I,J) = 0. _d 0
            FreshWaterFlux(I,J) = 0. _d 0

           ENDIF                ! K .LE. K_icefront

          ENDDO                 ! I = 1, sNx
         ENDDO                  ! J = 1, sNy

#ifdef ALLOW_DIAGNOSTICS
         IF ( useDiagnostics ) THEN
          CALL DIAGNOSTICS_FILL_RS(FreshWaterFlux,'ICFfwFlx',
     &         k,1,3,bi,bj,myThid)
          CALL DIAGNOSTICS_FILL_RS(HeatFlux,      'ICFhtFlx',
     &         k,1,3,bi,bj,myThid)
         ENDIF
#endif /* ALLOW_DIAGNOSTICS */

        ENDDO                   ! K = 1, Nr
       ENDDO                    ! bi = myBxLo, myBxHi
      ENDDO                     ! bj = myByLo, myByHi

#endif /* ALLOW_ICEFRONT */
      RETURN
      END

#include "BLING_OPTIONS.h"
#ifdef ALLOW_AUTODIFF
# include "AUTODIFF_OPTIONS.h"
#endif

CBOP
      SUBROUTINE BLING_CARBONATE_SYS(
     I           PTR_DIC, PTR_ALK, PTR_PO4,
#ifdef USE_SIBLING
     I           PTR_SI,
#endif
     I           bi, bj, iMin, iMax, jMin, jMax,
     I           myTime, myIter, myThid )

C     =================================================================
C     | subroutine bling_carbonate_sys
C     | o Calculate carbonate fluxes
C     |   Also update pH (3d field)
C     =================================================================

      IMPLICIT NONE

C     == GLobal variables ==
#include "SIZE.h"
#include "DYNVARS.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "BLING_VARS.h"
#ifdef ALLOW_AUTODIFF_TAMC
# include "tamc.h"
#endif

C     == Routine arguments ==
C     PTR_DIC              :: dissolved inorganic carbon
C     PTR_ALK              :: alkalinity
C     PTR_PO4              :: phosphate
C     myTime               :: current time
C     myIter               :: current timestep
C     myThid               :: thread Id. number
      _RL  PTR_DIC(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL  PTR_ALK(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL  PTR_PO4(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
#ifdef USE_SIBLING
      _RL  PTR_SI(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
#endif
      INTEGER bi, bj, iMin, iMax, jMin, jMax
      _RL  myTime
      INTEGER myIter
      INTEGER myThid

#ifdef ALLOW_PTRACERS

C     == Local variables ==
C     i,j,k             :: loop indices
C     carbonate         :: local value of calcium carbonate
C     calcium           :: local value of Ca
C     sitlocal          :: local value of Si
C     diclocal          :: local value of DIC
C     alklocal          :: local value of ALK
C     pCO2local         :: local value of pCO2
C     pHlocal           :: local value of pH
C     CO3iter           :: iterations counter for CO3 ion calculation
C     CO3iterMax        :: total number of iterations
       INTEGER i,j,k
       _RL carbonate
       _RL calcium
       _RL po4local
       _RL sitlocal
       _RL diclocal
       _RL alklocal
       _RL pCO2local
       _RL pHlocal
       _RL locTemp(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
       _RL locSalt(1-OLx:sNx+OLx,1-OLy:sNy+OLy)

c      INTEGER CO3iter
c      INTEGER CO3iterMax
#ifdef ALLOW_AUTODIFF_TAMC
C     tkey :: tape key (tile dependent)
C     kkey :: tape key (level and tile dependent)
C     ikey :: tape key (position, level, and tile dependent)
      INTEGER tkey, kkey, ikey
#endif
CEOP

C  Since pH is now a 3D field and is solved for at every time step
C  few iterations are needed
c      CO3iterMax = 1

C determine carbonate ion concentration through full domain
C determine calcite saturation state

#ifdef ALLOW_AUTODIFF_TAMC
      tkey = bi + (bj - 1)*nSx + (ikey_dynamics - 1)*nSx*nSy
#endif
C$TAF LOOP = parallel
       DO k=1,Nr

#ifdef ALLOW_AUTODIFF_TAMC
        kkey = k + (tkey - 1)*Nr
#endif
        DO j=jMin,jMax
         DO i=iMin,iMax
          locTemp(i,j) = theta(i,j,k,bi,bj)
          locSalt(i,j) = salt (i,j,k,bi,bj)
         ENDDO
        ENDDO

#ifdef CARBONCHEM_SOLVESAPHE
#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_CALL(
     &   'DIC_COEFFS_DEEP',myThid)
#endif
C Calculate carbon coefficients
        CALL DIC_COEFFS_SURF(
     I                       locTemp, locSalt,
     I                       bi,bj,iMin,iMax,jMin,jMax,myThid)

C Now correct the coefficients for pressure dependence
        CALL DIC_COEFFS_DEEP(
     I                       locTemp, locSalt,
     I                       bi,bj,iMin,iMax,jMin,jMax,
     I                       k,myThid)

#else /* CARBONCHEM_SOLVESAPHE */

#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_CALL(
     &   'CARBON_COEFFS_PRESSURE_DEP',myThid)
#endif

C  Get coefficients for carbonate calculations
        CALL CARBON_COEFFS_PRESSURE_DEP(
     I                       locTemp, locSalt,
     I                       bi, bj, iMin, iMax, jMin, jMax,
     I                       k, myThid )
#endif /* CARBONCHEM_SOLVESAPHE */

C--------------------------------------------------

C$TAF LOOP = parallel
        DO j=jMin,jMax
C$TAF LOOP = parallel
         DO i=iMin,iMax

          IF ( hFacC(i,j,k,bi,bj) .GT. 0. _d 0) THEN

#ifdef ALLOW_AUTODIFF_TAMC
           ikey = i + (j - 1)*sNx + (kkey - 1)*sNx*sNy
#endif
#ifdef CARBONCHEM_SOLVESAPHE
           calcium = cat(i,j,bi,bj)
#else
C  Estimate calcium concentration from salinity
           calcium = 1.028 _d -2*salt(i,j,k,bi,bj)/35. _d 0
#endif

           po4local = PTR_PO4(i,j,k)
           diclocal = PTR_DIC(i,j,k)
           alklocal = PTR_ALK(i,j,k)
           pHlocal  = pH(i,j,k,bi,bj)

C  Assume constant deep silica value
C  30 micromol = 0.03 mol m-3
C  unless SIBLING is used
#ifdef USE_SIBLING
           sitlocal = PTR_SI(i,j,k)
#else
           sitlocal = 0.03 _d 0
#endif

#ifdef CARBONCHEM_SOLVESAPHE
           IF ( selectPHsolver.GT.0 ) THEN
C Use Munhoven (2013) Solvesaphe routine to calculate pH and pCO2
#ifdef ALLOW_DEBUG
         IF (debugMode) CALL DEBUG_CALL('AHINI_FOR_AT',myThid)
#endif
CAV since we carry pH, no need for an initial guess
C call AHINI_FOR_AT to get better initial guess of pH
c               CALL AHINI_FOR_AT(alklocal*permil,
c     I           diclocal*permil,
c     I           bt(i,j,bi,bj),
c     O           pHlocal,
c     I           i,j,k,bi,bj,myIter,myThid )
#ifdef ALLOW_DEBUG
         IF (debugMode) CALL DEBUG_CALL('CALC_PCO2_SOLVESAPHE',myThid)
#endif
            CALL CALC_PCO2_SOLVESAPHE(
     I          locTemp(i,j), locSalt(i,j),
     I          diclocal, po4local,
     I          sitlocal, alklocal,
     U          pHlocal, pCO2local, carbonate,
     I          i,j,k,bi,bj,myIter,myThid )

C- convert carbonate to mol kg^-1-SW for calculation of saturation state
            carbonate = carbonate*permil
           ELSE
C Use the original Follows et al. (2006) solver
#endif /* CARBONCHEM_SOLVESAPHE */
#ifdef ALLOW_DEBUG
            IF (debugMode) CALL DEBUG_CALL('CALC_PCO2_APPROX',myThid)
#endif

C  Evaluate carbonate (CO3) ions concentration
C  iteratively

c           DO CO3iter = 1, CO3iterMax

C--------------------------------------------------

             CALL CALC_PCO2_APPROX(
     I          locTemp(i,j), locSalt(i,j),
     I          diclocal, po4local,
     I          sitlocal,alklocal,
     I          ak1(i,j,bi,bj),ak2(i,j,bi,bj),
     I          ak1p(i,j,bi,bj),ak2p(i,j,bi,bj),ak3p(i,j,bi,bj),
     I          aks(i,j,bi,bj),akb(i,j,bi,bj),akw(i,j,bi,bj),
     I          aksi(i,j,bi,bj),akf(i,j,bi,bj),
     I          ak0(i,j,bi,bj),fugf(i,j,bi,bj),ff(i,j,bi,bj),
     I          bt(i,j,bi,bj),st(i,j,bi,bj),ft(i,j,bi,bj),
     U          pHlocal,pCO2local,carbonate,
     I          i,j,k,bi,bj,myIter,myThid )
c           ENDDO

#ifdef CARBONCHEM_SOLVESAPHE
           ENDIF
#endif /* CARBONCHEM_SOLVESAPHE */
#ifdef ALLOW_AUTODIFF_TAMC
CADJ store carbonate = comlev1_bibj_ijk, key = ikey, kind = isbyte
#endif
           pH(i,j,k,bi,bj) = pHlocal

C  Calculate calcium carbonate (calcite and aragonite)
C  saturation state
           omegaC(i,j,k,bi,bj) = calcium * carbonate /
     &                          Ksp_TP_Calc(i,j,bi,bj)
           omegaAr(i,j,k,bi,bj) = calcium * carbonate /
     &                          Ksp_TP_Arag(i,j,bi,bj)

          ELSE

           pH(i,j,k,bi,bj) = 8. _d 0
           omegaC(i,j,k,bi,bj)  = 0. _d 0
           omegaAr(i,j,k,bi,bj) = 0. _d 0

          ENDIF

         ENDDO
        ENDDO
       ENDDO

#endif /* ALLOW_PTRACERS */
       RETURN
       END

#include "SHELFICE_OPTIONS.h"
#ifdef ALLOW_COST
# include "COST_OPTIONS.h"
#endif

CBOP
C     !ROUTINE: SHELFICE_COST_FINAL
C     !INTERFACE:
      SUBROUTINE SHELFICE_COST_FINAL( ifc, optimcycle, myThid )

C     !DESCRIPTION:
C     *==========================================================*
C     | subroutine shelfice_cost_final                           |
C     | o final cost evalualtion                                 |
C     *==========================================================*

C     !USES:
      IMPLICIT NONE

C     == Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "DYNVARS.h"
#include "GRID.h"
#include "SHELFICE.h"
#include "SHELFICE_COST.h"

#ifdef ALLOW_COST
# include "cost.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     ifc        :: file unit for costfunction_shelfice.XXXX
C     optimcycle :: cycle number of the off-line optimization.
C     myThid     :: Thread number for this instance of the routine.
      INTEGER ifc
      INTEGER optimcycle
      INTEGER myThid

#ifdef ALLOW_COST
C     !LOCAL VARIABLES:
      INTEGER bi, bj
      CHARACTER*15  tile15c
#ifndef ALLOW_OPENAD
      CHARACTER*(26) cfname
#endif

      _RL f_shelfice
      _RL f_shifwflx
cML      _RL no_shelfice
      _RL no_shifwflx

      INTEGER i, j
CEOP

      f_shelfice = 0. _d 0
      f_shifwflx = 0. _d 0
cML      no_shelfice= 0. _d 0
      no_shifwflx= 0. _d 0

C--   Calculate cost function on tile of this instance
      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
ccc        do klev = 1, Nr
         DO j=1,sNy
          DO i=1,sNx

            objf_shelfice(bi,bj) = objf_shelfice(bi,bj)
     &            + cMeanSHIforS(i,j,bi,bj)/lastinterval/rhoConstFresh
     &            *_rA(i,j,bi,bj)

          ENDDO
         ENDDO
ccc        end do
       ENDDO
      ENDDO

C--   Sum up all contributions.
      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
        WRITE(tile15c,'(2(A,I3),A)') '(bi,bj=', bi, ',', bj, ')'
        WRITE(standardMessageUnit,'(3A,1PE22.14,1X,1PE9.2)')
     &       ' --> objf_shelfice ', tile15c, ' =',
     &       objf_shelfice(bi,bj), mult_shelfice
        tile_fc(bi,bj) = tile_fc(bi,bj)
     &       + mult_shelfice * objf_shelfice(bi,bj)

       ENDDO
      ENDDO

      CALL GLOBAL_SUM_TILE_RL( objf_shelfice, f_shelfice, myThid )
cML      CALL GLOBAL_SUM_TILE_RL( num_shelfice, no_shelfice, myThid )

# ifndef ALLOW_OPENAD
C--   Each process has calculated the global part for itself.
      IF ( ifc .NE. -1 ) THEN

       WRITE(cfname,'(A,i4.4)') 'costfunction_shelfice.',optimcycle
       OPEN(unit=ifc,file=cfname)

C     makes little sense to print this now, because it is zero at this point
c       WRITE(ifc,*) 'fc =', fc
cML       WRITE(ifc,*) 'f_shelfice =', f_shelfice, no_shelfice
       WRITE(ifc,'(A,1PE22.14,1X,1PE9.2)')
     &      'f_shelfice =', f_shelfice, mult_shelfice

       CLOSE(ifc)

      ENDIF
# endif /* ALLOW_OPENAD */

#endif /* ALLOW_COST */

      RETURN
      END

#include "MNC_OPTIONS.h"
      
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 0
C     !ROUTINE: MNC_INIT

C     !INTERFACE:
      SUBROUTINE MNC_INIT( myThid )

C     !DESCRIPTION:
C     Initialize (zero) the look-up tables.  This routine should
C     \textbf{always} be run before any other MNC subroutines to ensure
C     that the lookup tables start in a well-defined state.
      
C     !USES:
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "MNC_COMMON.h"
#include "MNC_PARAMS.h"

C     !INPUT PARAMETERS:
      integer myThid
CEOP

C     !LOCAL VARIABLES:
      integer i,j, g
      character blank*(MNC_MAX_CHAR)
      character bpath*(MNC_MAX_PATH)

C     Write blanks or zeros to all the internal names and ID tables
      DO i = 1,MNC_MAX_CHAR
        blank(i:i) = ' '
      ENDDO
      DO i = 1,MNC_MAX_PATH
        bpath(i:i) = ' '
      ENDDO

      mnc_blank_name(1:MNC_MAX_CHAR) = blank(1:MNC_MAX_CHAR)
      DO i = 1,MNC_MAX_FID
        mnc_f_names(i)(1:MNC_MAX_PATH) = bpath(1:MNC_MAX_PATH)
        DO j = 1,MNC_MAX_INFO
          mnc_f_info(i,j) = 0
          mnc_fv_ids(i,j) = 0
          mnc_fd_ind(i,j) = 0
          mnc_f_alld(i,j) = 0
        ENDDO
      ENDDO
      DO i = 1,MNC_MAX_ID
        mnc_d_size(i) = 0
        mnc_d_ids(i)  = 0
        mnc_g_names(i)(1:MNC_MAX_CHAR) = blank(1:MNC_MAX_CHAR)
        mnc_v_names(i)(1:MNC_MAX_CHAR) = blank(1:MNC_MAX_CHAR)
        mnc_d_names(i)(1:MNC_MAX_CHAR) = blank(1:MNC_MAX_CHAR)
      ENDDO

C     Blank the CW tables
      DO g = 1,MNC_MAX_ID
        mnc_cw_gname(g)(1:MNC_MAX_CHAR) = blank(1:MNC_MAX_CHAR)
        mnc_cw_vname(g)(1:MNC_MAX_CHAR) = blank(1:MNC_MAX_CHAR)
        mnc_cw_vgind(g) = 0
        mnc_cw_vfmv(g) = 0
        mnc_cw_ndim(g) = 0
        mnc_cw_fgnm(g)(1:MNC_MAX_CHAR) = blank(1:MNC_MAX_CHAR)
        mnc_cw_fgud(g) = 0
        mnc_cw_fgis(g) = 0
        mnc_cw_fgci(g) = 1
C       mnc_cw_cvnm(g)(1:MNC_MAX_CHAR) = blank(1:MNC_MAX_CHAR)
        DO i = 1,MNC_CW_MAX_I
          mnc_cw_dn(i,g)(1:MNC_MAX_CHAR) = blank(1:MNC_MAX_CHAR)
          mnc_cw_vtnm(i,g)(1:MNC_MAX_CHAR) = blank(1:MNC_MAX_CHAR)
          mnc_cw_vinm(i,g)(1:MNC_MAX_CHAR) = blank(1:MNC_MAX_CHAR)
          mnc_cw_vdnm(i,g)(1:MNC_MAX_CHAR) = blank(1:MNC_MAX_CHAR)
          mnc_cw_vtat(i,g)(1:MNC_MAX_CHAR) = blank(1:MNC_MAX_CHAR)
          mnc_cw_dims(i,g) = 0
          mnc_cw_is(i,g) = 0
          mnc_cw_ie(i,g) = 0
          mnc_cw_viat(i,g) = 0
          mnc_cw_vdat(i,g) = 0.0D0
        ENDDO
        DO i = 1,3
          mnc_cw_vnat(i,g) = 0
        ENDDO
        DO i = 1,2
           mnc_cw_vbij(i,g) = 0
           mnc_cw_vmvi(i,g) = 0
           mnc_cw_vmvr(i,g) = 0.0
           mnc_cw_vmvd(i,g) = 0.0D0
C          mnc_cw_cvse(i,g) = 0
        ENDDO
      ENDDO

      DO i = 1,MNC_MAX_INFO
        mnc_cw_cit(1,i) = 0
        mnc_cw_cit(2,i) = 0
        mnc_cw_cit(3,i) = -1
      ENDDO

      DO i = 1,2
       mnc_def_imv(i) = UNSET_I
       mnc_def_rmv(i) = UNSET_FLOAT4
       mnc_def_dmv(i) = UNSET_FLOAT8
      ENDDO

C     The default for all file types is to add the iter to the name and
C     grow them in "lock step" together
      mnc_cw_cit(1,1) = 1
      mnc_cw_cit(2,1) = nIter0

C     Here, we do not add the iter to the file name
      mnc_cw_cit(1,2) = -1
      mnc_cw_cit(2,2) = -1

C     For checkpoint files, we want to use the current iter but we do
C     not (by default, anyway) want to update the current iter for
C     everything else
      mnc_cw_cit(1,3) = 3
      mnc_cw_cit(2,3) = nIter0

C     DO i = 1,MNC_CW_CVDAT
C     mnc_cw_cvdt(i) = 0.0D0
C     ENDDO

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      subroutine lsline( 
     &     simul
     &     , nn, ifail, lphprint
     &     , ifunc, nfunc
     &     , ff, dotdg
     &     , tmin, tmax, tact, epsx
     &     , dd, gg, xx, xdiff
     &     )

c     ==================================================================
c     SUBROUTINE lsline
c     ==================================================================
c
c     o line search algorithm for determining control vector update;
c       After computing updated control vector from given gradient,
c       a forward and adjoint model run are performed (simul.F)
c       using the updated control vector.
c       Tests are then applied to see whether solution has improved.
c
c     o Reference: J.C. Gilbert & C. Lemarechal
c                  Some numerical experiments with variable-storage
c                  quasi-Newton algorithms
c                  Mathematical Programming 45 (1989), pp. 407-435
c
c     o started: ??? not reproducible
c
c     o changed: Patrick Heimbach, MIT/EAPS
c
c     o Version: 2.0, 24-Feb-2000: Patrick Heimbach, MIT/EAPS
c                   - severe changes in structure including various
c                     shifts of variables which are only used in this
c                     routine
c                   - number of 3 control flags for error handling
c                     (indic, moderl, ifail) reduced to 1 (ifail)
c                     and homogenized with routine lsoptv
c
c     o Version: 2.1.0, 02-Mar-2000: Patrick Heimbach, MIT/EAPS
c                   - initial computation of tact and
c                     xdiff = xx + tact*dd 
c                     moved to new routine lsupdxx
c                     tmin, tmax, tact needed as parameters
c
c     ==================================================================
c     SUBROUTINE lsline
c     ==================================================================

#include "blas1.h"

      implicit none

c----------------------------------
c declare arguments
c----------------------------------
      integer nn, ifail, ifunc, nfunc
      double precision ff, dotdg, tmin, tmax, tact, epsx
      double precision xx(nn), dd(nn), gg(nn), xdiff(nn)

      logical lphprint

      external simul

c----------------------------------
c declare local variables
c----------------------------------

      double precision xpara1, xpara2
      parameter( xpara1 = 0.0001, xpara2=0.9 )

      double precision    factor
      parameter( factor = 0.2 )

      double precision    barmax
      parameter( barmax = 0.3 )
      double precision    barmul
      parameter( barmul = 5.0 )
      double precision    barmin
      parameter( barmin = 0.01 )

      integer i, indic

      double precision    tg, fg, td, ta
      double precision    fa, fpa, fp
      double precision    fnew, fdiff
      double precision    z, test, barr
      double precision    left, right, told

      external DDOT
      double precision     DDOT

c----------------------------------
c check parameters
c----------------------------------

      if (  (nn.le.0)
     &     .or. (dotdg.ge.0.0)  
     &     .or. (xpara1.le.0.0) .or. (xpara1.ge.0.5)
     &     .or. (xpara2.le.xpara1)  .or. (xpara2.ge.1.0) ) then
         ifail = 9
         go to 999
      endif

c----------------------------------
c initialization
c----------------------------------
      indic = 0

      barr   = barmin
      fg     = ff
      fa     = ff
      fpa    = dotdg

      td     = 0.0
      tg     = 0.0
      ta     = 0.0

c=======================================================================
c begin of simulation iter.
c=======================================================================

      do ifunc = 1, nfunc

         if (lphprint) 
     &        print *, 'pathei-lsopt: ', ifunc, ' simul.'

c------------------------------------
c compute cost function and gradient
c------------------------------------
         call simul( indic, nn, xdiff, fnew, gg )

         fp = DDOT( nn, dd, 1, gg, 1 )
         fdiff = fnew - ff

c-----------------------------------------
c apply 1st Wolfe test
c-----------------------------------------
         if (fdiff .gt. tact*xpara1*dotdg) then
            td     = tact
            ifail  = 0
            go to 500
         endif

c-----------------------------------------
c 1st Wolfe test 1 ok, apply 2nd Wolf test
c-----------------------------------------
         if (fp .gt. xpara2*dotdg) then
            ifail = 0
            go to 320
         endif

         if (ifail.eq.0) go to 350

c-----------------------------------------
c 2nd Wolfe test 2 ok, donc pas serieux, on sort
c-----------------------------------------

 320     continue

         ff = fnew
         do i = 1, nn
            xx(i) = xdiff(i)
         end do
cph(
         if (lphprint) 
     &        print *, 'pathei-lsopt: no inter-/extrapolation in lsline'
cph)
         go to 999


c-----------------------------------------
c extrapolation
c-----------------------------------------

 350     continue

         tg  = tact
         fg  = fnew
         if (td .ne. 0.0) go to 500

         told    = tact
         left = (1.0+barmin)*tact
         right = 10.0*tact
         call cubic( tact, fnew, fp, ta, fa, fpa, left, right )
         ta     = told
         if (tact.ge.tmax) then
            ifail = 7
            tact     = tmax
         endif

         if (lphprint) 
     &        print *, 'pathei-lsopt: extrapolation: ',
     &        'td, tg, tact, ifail = ', td, tg, tact, ifail

         go to 900

c-----------------------------------------
c interpolation
c-----------------------------------------

 500     continue

         test   = barr*(td-tg)
         left = tg+test
         right = td-test
         told    = tact
         call cubic( tact, fnew, fp, ta, fa, fpa, left, right )
         ta = told
         if (tact.gt.left .and. tact.lt.right) then
            barr = dmax1( barmin, barr/barmul )
         else
            barr = dmin1( barmul*barr, barmax )
         endif

         if (lphprint) 
     &        print *, 'pathei-lsopt: interpolation: ',
     &        'td, tg, tact, ifail = ', td, tg, tact, ifail

c-----------------------------------------
c end of iteration loop
c     - tact peut etre bloque sur tmax
c       (venant de lextrapolation avec ifail=7)
c-----------------------------------------

 900     continue

         fa  = fnew
         fpa = fp

c-----------------------------------------
c --- faut-il continuer ?
c-----------------------------------------
         if (td .eq. 0.0)     go to 950
         if (td-tg .lt. tmin) go to 920

c-----------------------------------------
c limit due to machine precision
c-----------------------------------------
         do i = 1, nn
            z = xx(i) + tact*dd(i)
            if ((z.ne.xx(i)) .and. (z.ne.xdiff(i))) go to 950
         end do

c-----------------------------------------
c arret sur dxmin ou de secours
c-----------------------------------------
 920     continue
         ifail = 8

c-----------------------------------------
c     si tg=0, xx = xx_depart,
c     sinon on prend xx=x_left qui fait decroitre f
c-----------------------------------------
         if (tg .ne. 0.0) then
            ff = fg
            do i = 1, nn
               xx(i) = xx(i) + tg*dd(i)
            end do
         endif

         go to 999

c-----------------------------------------
c update vector for new simulation
c-----------------------------------------
 950     continue

         do i = 1, nn
            xdiff(i) = xx(i) + tact*dd(i)
         end do

c=======================================================================
c end of simulation iter.
c=======================================================================
      end do

c-----------------------------------------
c too many function evaluations
c-----------------------------------------
      ifail = 6
      ff    = fg
      do i = 1, nn
         xx(i) = xx(i) + tg*dd(i)
      end do

c-----------------------------------------
c end of routine
c-----------------------------------------
  999 continue

      return

      end

#include "EXF_OPTIONS.h"
#ifdef ALLOW_AUTODIFF
# include "AUTODIFF_OPTIONS.h"
#endif

CBOP
C     !ROUTINE: EXF_BULKFORMULAE
C     !INTERFACE:
      SUBROUTINE EXF_BULKFORMULAE( exf_Tsf, myTime, myIter, myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE EXF_BULKFORMULAE
C     | o Calculate bulk formula fluxes over open ocean
C     |   either following
C     |   Large and Pond, 1981 & 1982
C     |   or (if defined ALLOW_BULK_LARGEYEAGER04)
C     |   Large and Yeager, 2004, NCAR/TN-460+STR.
C     *==========================================================*
C     \ev
C
C
C     NOTES:
C     ======
C
C     See EXF_OPTIONS.h for a description of the various possible
C     ocean-model forcing configurations.
C
C     The bulk formulae of pkg/exf are not valid for sea-ice covered
C     oceans but they can be used in combination with a sea-ice model,
C     for example, pkg/seaice, to specify open water flux contributions.
C
C     ==================================================================
C
C     for Large and Pond, 1981 & 1982
C
C     The calculation of the bulk surface fluxes has been adapted from
C     the NCOM model which uses the formulae given in Large and Pond
C     (1981 & 1982 )
C
C
C     Header taken from NCOM version: ncom1.4.1
C     -----------------------------------------
C
C     Following procedures and coefficients in Large and Pond
C     (1981 ; 1982)
C
C     Output: Bulk estimates of the turbulent surface fluxes.
C     -------
C
C     hs  - sensible heat flux  (W/m^2), into ocean
C     hl  - latent   heat flux  (W/m^2), into ocean
C
C     Input:
C     ------
C
C     us  - mean wind speed (m/s)     at height hu (m)
C     th  - mean air temperature (K)  at height ht (m)
C     qh  - mean air humidity (kg/kg) at height hq (m)
C     sst - sea surface temperature (K)
C     tk0 - Kelvin temperature at 0 Celsius (K)
C
C     Assume 1) a neutral 10m drag coefficient =
C
C               cdn = .0027/u10 + .000142 + .0000764 u10
C
C            2) a neutral 10m stanton number =
C
C               ctn = .0327 sqrt(cdn), unstable
C               ctn = .0180 sqrt(cdn), stable
C
C            3) a neutral 10m dalton number =
C
C               cen = .0346 sqrt(cdn)
C
C            4) the saturation humidity of air at
C
C               t(k) = exf_BulkqSat(t)  (kg/m^3)
C
C     Note:  1) here, tstar = <wt>/u*, and qstar = <wq>/u*.
C            2) wind speeds should all be above a minimum speed,
C               say 0.5 m/s.
C            3) with optional iteration loop, niter=3, should suffice.
C            4) this version is for analyses inputs with hu = 10m and
C               ht = hq.
C            5) sst enters in Celsius.
C
C     ==================================================================
C
C       started: Christian Eckert eckert@mit.edu 27-Aug-1999
C
C     changed: Christian Eckert eckert@mit.edu 14-Jan-2000
C            - restructured the original version in order to have a
C              better interface to the MITgcmUV.
C
C            Christian Eckert eckert@mit.edu  12-Feb-2000
C            - Changed Routine names (package prefix: exf_)
C
C            Patrick Heimbach, heimbach@mit.edu  04-May-2000
C            - changed the handling of precip and sflux with respect
C              to CPP options ALLOW_BULKFORMULAE and ALLOW_ATM_TEMP
C            - included some CPP flags ALLOW_BULKFORMULAE to make
C              sure ALLOW_ATM_TEMP, ALLOW_ATM_WIND are used only in
C              conjunction with defined ALLOW_BULKFORMULAE
C            - statement functions discarded
C
C            Ralf.Giering@FastOpt.de 25-Mai-2000
C            - total rewrite using new subroutines
C
C            Detlef Stammer: include river run-off. Nov. 21, 2001
C
C            heimbach@mit.edu, 10-Jan-2002
C            - changes to enable field swapping
C
C     mods for pkg/seaice: menemenlis@jpl.nasa.gov 20-Dec-2002
C
C     martin.losch@awi.de: merged with exf_bulk_largeyeager04, 21-May-2010
C
C     ==================================================================
C
C     for Large and Yeager, 2004
C
C === Turbulent Fluxes :
C  * use the approach "B": shift coeff to height & stability of the
C    atmosphere state (instead of "C": shift temp & humid to the height
C    of wind, then shift the coeff to this height & stability of the atmos).
C  * similar to EXF (except over sea-ice) ; default parameter values
C    taken from Large & Yeager.
C  * assume that Qair & Tair inputs are from the same height (zq=zt)
C  * formulae in short:
C     wind stress = (ust,vst) = rhoA * Cd * Ws * (del.u,del.v)
C     Sensib Heat flux = fsha = rhoA * Ch * Ws * del.T * CpAir
C     Latent Heat flux = flha = rhoA * Ce * Ws * del.Q * Lvap
C                      = -Evap * Lvap
C   with Ws = wind speed = sqrt(del.u^2 +del.v^2) ;
C        del.T = Tair - Tsurf ; del.Q = Qair - Qsurf ;
C        Cd,Ch,Ce = drag coefficient, Stanton number and Dalton number
C              respectively [no-units], function of height & stability

C     !USES:
       IMPLICIT NONE
C     === Global variables ===
#include "EEPARAMS.h"
#include "SIZE.h"
#include "PARAMS.h"
#include "DYNVARS.h"
#include "GRID.h"

#include "EXF_PARAM.h"
#include "EXF_FIELDS.h"
#include "EXF_CONSTANTS.h"

#ifdef ALLOW_AUTODIFF_TAMC
#include "tamc.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     input:
C     myTime  :: Current time in simulation
C     myIter  :: Current iteration number in simulation
C     myThid  :: My Thread Id number
C     exf_Tsf :: local copy of global field gcmSST or extrapolated
C                surface temperature (in deg Celsius)
      _RL     myTime
      INTEGER myIter
      INTEGER myThid
      _RL exf_Tsf(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
C     output:
CEOP

#ifdef ALLOW_BULKFORMULAE
#ifdef ALLOW_ATM_TEMP
C     == external Functions

C     == Local variables ==
C     i,j      :: grid point indices
C     bi,bj    :: tile indices
C     ssq      :: saturation specific humidity [kg/kg] in eq. with Sea-Surface water
      INTEGER i,j,bi,bj

      _RL czol
      _RL Tsf                   ! surface temperature [K]
      _RL wsm                   ! limited wind speed [m/s] (> umin)
      _RL t0                    ! virtual temperature [K]
C     these need to be 2D-arrays for vectorizing code
      _RL tstar (1:sNx,1:sNy)   ! turbulent temperature scale [K]
      _RL qstar (1:sNx,1:sNy)   ! turbulent humidity scale  [kg/kg]
      _RL ustar (1:sNx,1:sNy)   ! friction velocity [m/s]
      _RL tau   (1:sNx,1:sNy)   ! surface stress coef = rhoA * Ws * sqrt(Cd)
      _RL rdn   (1:sNx,1:sNy)   ! neutral, zref (=10m) values of rd
      _RL rd    (1:sNx,1:sNy)   ! = sqrt(Cd)          [-]
      _RL delq  (1:sNx,1:sNy)   ! specific humidity difference [kg/kg]
      _RL deltap(1:sNx,1:sNy)
#ifdef EXF_CALC_ATMRHO
      _RL atmrho_loc(1:sNx,1:sNy) ! local atmospheric density [kg/m^3]
#endif

#ifdef ALLOW_BULK_LARGEYEAGER04
      _RL dzTmp
#endif
      _RL ssq
      _RL re                    ! = Ce / sqrt(Cd)     [-]
      _RL rh                    ! = Ch / sqrt(Cd)     [-]
      _RL ren, rhn              ! neutral, zref (=10m) values of re, rh
      _RL usn, usm
      _RL stable                ! = 1 if stable ; = 0 if unstable
      _RL huol                  ! stability parameter at zwd [-] (=z/Monin-Obuklov length)
      _RL htol                  ! stability parameter at zth [-]
      _RL hqol
      _RL x                     ! stability function  [-]
      _RL xsq                   ! = x^2               [-]
      _RL psimh                 ! momentum stability function
      _RL psixh                 ! latent & sensib. stability function
      _RL zwln                  ! = log(zwd/zref)
      _RL ztln                  ! = log(zth/zref)
      _RL tmpbulk
      _RL recip_rhoConstFresh
      INTEGER ks, kl
      INTEGER iter
C     solve4Stress :: if F, by-pass momentum turb. flux (wind-stress) calculation
      LOGICAL solve4Stress
      _RL windStress            ! surface wind-stress (@ grid cell center)

#ifdef ALLOW_AUTODIFF_TAMC
      INTEGER ikey, ikey_1, ikey_2
#endif

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      IF ( useAtmWind ) THEN
        solve4Stress = .TRUE.
      ELSE
#ifdef ALLOW_BULK_LARGEYEAGER04
        solve4Stress = wspeedfile .NE. ' '
#else
        solve4Stress = .FALSE.
#endif
      ENDIF

      IF ( usingPCoords ) THEN
       ks = Nr
       kl = Nr-1
      ELSE
       ks = 1
       kl = 2
      ENDIF

C--   Set surface parameters :
      zwln = LOG(hu/zref)
      ztln = LOG(ht/zref)
      czol = hu*karman*gravity_mks
C--   abbreviation
      recip_rhoConstFresh = 1. _d 0/rhoConstFresh

C     Loop over tiles.
#ifdef ALLOW_AUTODIFF_TAMC
C--   HPF directive to help TAF
CHPF$ INDEPENDENT
#endif
      DO bj = myByLo(myThid),myByHi(myThid)
#ifdef ALLOW_AUTODIFF_TAMC
C--    HPF directive to help TAF
CHPF$  INDEPENDENT
#endif
       DO bi = myBxLo(myThid),myBxHi(myThid)

#ifdef ALLOW_AUTODIFF_TAMC
        ikey = bi + (bj-1)*nSx + (ikey_dynamics-1)*nSx*nSy
#endif
        DO j = 1,sNy
         DO i = 1,sNx

#ifdef ALLOW_AUTODIFF_TAMC
          ikey_1 = i + (j-1)*sNx + (ikey-1)*sNx*sNy
#endif

#ifdef ALLOW_AUTODIFF
          deltap(i,j) = 0. _d 0
          delq(i,j)   = 0. _d 0
#endif
C--- Compute turbulent surface fluxes
C-   Pot. Temp and saturated specific humidity
          IF ( atemp(i,j,bi,bj) .NE. 0. _d 0 ) THEN
C-   Surface Temp.
           Tsf = exf_Tsf(i,j,bi,bj)
           tmpbulk = cvapor_fac*exp(-cvapor_exp/Tsf)
#ifdef EXF_CALC_ATMRHO
           atmrho_loc(i,j) = apressure(i,j,bi,bj) /
     &                  (287.04 _d 0*atemp(i,j,bi,bj)
     &                  *(1. _d 0 + humid_fac*aqh(i,j,bi,bj)))
           ssq = saltsat*tmpbulk/atmrho_loc(i,j)
#else
           ssq = saltsat*tmpbulk/atmrho
#endif
           deltap(i,j) = atemp(i,j,bi,bj) + gamma_blk*ht - Tsf
           delq(i,j)   = aqh(i,j,bi,bj) - ssq
C--  no negative evaporation over ocean:
           IF ( noNegativeEvap ) delq(i,j) = MIN( 0. _d 0, delq(i,j) )

C--  initial guess for exchange coefficients:
C    take U_N = del.U ; stability from del.Theta ;
           stable = exf_half + SIGN(exf_half, deltap(i,j))

           IF ( solve4Stress ) THEN
#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE sh(i,j,bi,bj)     = comlev1_exf_1, key = ikey_1
#endif /* ALLOW_AUTODIFF_TAMC */
C--   Wind speed
            wsm        = sh(i,j,bi,bj)
#ifdef  ALLOW_DRAG_LARGEYEAGER09
C     Large and Yeager (2009), Climate Dynamics, equation 11a/b
            tmpbulk =  cdrag_1/wsm + cdrag_2 + cdrag_3*wsm
     &           + cdrag_8 * wsm**6
            tmpbulk = exf_scal_BulkCdn * (
     &             ( halfRL - SIGN(halfRL, wsm-umax) )*tmpbulk
     &           + ( halfRL + SIGN(halfRL, wsm-umax) )*cdragMax
     &           )
#else
            tmpbulk    = exf_scal_BulkCdn *
     &           ( cdrag_1/wsm + cdrag_2 + cdrag_3*wsm )
#endif
            rdn(i,j)   = SQRT(tmpbulk)
            ustar(i,j) = rdn(i,j)*wsm
           ELSE
            rdn(i,j)   = 0. _d 0
            windStress = wStress(i,j,bi,bj)
#ifdef EXF_CALC_ATMRHO
            ustar(i,j) = SQRT(windStress/atmrho_loc(i,j))
            tau(i,j)   = SQRT(windStress*atmrho_loc(i,j))
#else
            ustar(i,j) = SQRT(windStress/atmrho)
c           tau(i,j)   = windStress/ustar(i,j)
            tau(i,j)   = SQRT(windStress*atmrho)
#endif
           ENDIF

C--  initial guess for exchange other coefficients:
           rhn = (exf_one-stable)*cstanton_1 + stable*cstanton_2
           ren = cDalton
C--  calculate turbulent scales
           tstar(i,j)=rhn*deltap(i,j)
           qstar(i,j)=ren*delq(i,j)

          ELSE
C     atemp(i,j,bi,bj) .EQ. 0.
           tstar (i,j) = 0. _d 0
           qstar (i,j) = 0. _d 0
           ustar (i,j) = 0. _d 0
           tau   (i,j) = 0. _d 0
           rdn   (i,j) = 0. _d 0
          ENDIF
         ENDDO
        ENDDO
        DO iter=1,niter_bulk
         DO j = 1,sNy
          DO i = 1,sNx
           IF ( atemp(i,j,bi,bj) .NE. 0. _d 0 ) THEN
C--- iterate with psi-functions to find transfer coefficients

#ifdef ALLOW_AUTODIFF_TAMC
            ikey_2 = i + (j-1)*sNx + (iter-1)*sNx*sNy
     &           + (ikey-1)*sNx*sNy*niter_bulk
CADJ STORE rdn   (i,j)       = comlev1_exf_2, key = ikey_2
CADJ STORE ustar (i,j)       = comlev1_exf_2, key = ikey_2
CADJ STORE qstar (i,j)       = comlev1_exf_2, key = ikey_2
CADJ STORE tstar (i,j)       = comlev1_exf_2, key = ikey_2
CADJ STORE sh    (i,j,bi,bj) = comlev1_exf_2, key = ikey_2
CADJ STORE wspeed(i,j,bi,bj) = comlev1_exf_2, key = ikey_2
#endif

            t0   = atemp(i,j,bi,bj)*
     &           (exf_one + humid_fac*aqh(i,j,bi,bj))
            huol = ( tstar(i,j)/t0 +
     &               qstar(i,j)/(exf_one/humid_fac+aqh(i,j,bi,bj))
     &              )*czol/(ustar(i,j)*ustar(i,j))
#ifdef ALLOW_BULK_LARGEYEAGER04
            tmpbulk = MIN(abs(huol),10. _d 0)
            huol   = SIGN(tmpbulk , huol)
#else
C--   Large&Pond1981:
            huol   = max(huol,zolmin)
#endif /* ALLOW_BULK_LARGEYEAGER04 */
            htol   = huol*ht/hu
            hqol   = huol*hq/hu
            stable = exf_half + sign(exf_half, huol)

C     Evaluate all stability functions assuming hq = ht.
            IF ( solve4Stress ) THEN
#ifdef ALLOW_BULK_LARGEYEAGER04
C--   Large&Yeager04:
             xsq    = SQRT( ABS(exf_one - huol*16. _d 0) )
#else
C--   Large&Pond1981:
             xsq    = MAX(SQRT(ABS(exf_one - 16.*huol)),exf_one)
#endif /* ALLOW_BULK_LARGEYEAGER04 */
             x      = SQRT(xsq)
             psimh  = -psim_fac*huol*stable
     &               +(exf_one-stable)*
     &                ( LOG( (exf_one + exf_two*x + xsq)*
     &                       (exf_one+xsq)*.125 _d 0 )
     &                  -exf_two*ATAN(x) + exf_half*pi )
            ELSE
             psimh  = 0. _d 0
            ENDIF
#ifdef ALLOW_BULK_LARGEYEAGER04
C--   Large&Yeager04:
            xsq   = SQRT( ABS(exf_one - htol*16. _d 0) )
#else
C--   Large&Pond1981:
            xsq   = MAX(SQRT(ABS(exf_one - 16.*htol)),exf_one)
#endif /* ALLOW_BULK_LARGEYEAGER04 */
            psixh = -psim_fac*htol*stable + (exf_one-stable)*
     &               ( exf_two*LOG(exf_half*(exf_one+xsq)) )

            IF ( solve4Stress ) THEN
#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE rdn(i,j)       = comlev1_exf_2, key = ikey_2
#endif
C-   Shift wind speed using old coefficient
#ifdef ALLOW_BULK_LARGEYEAGER04
C--   Large&Yeager04:
             dzTmp = (zwln-psimh)/karman
             usn   = wspeed(i,j,bi,bj)/(exf_one + rdn(i,j)*dzTmp )
#else
C--   Large&Pond1981:
c           rd(i,j)= rdn(i,j)/(exf_one - rdn(i,j)/karman*psimh )
c           usn    = sh(i,j,bi,bj)*rd(i,j)/rdn(i,j)
C     ML: the original formulation above is replaced below to be
C     similar to largeyeager04, but does not give the same results, strange
             usn   = sh(i,j,bi,bj)/(exf_one - rdn(i,j)/karman*psimh)
#endif /* ALLOW_BULK_LARGEYEAGER04 */
             usm   = MAX(usn, umin)

C-   Update the 10m, neutral stability transfer coefficients (momentum)
#ifdef  ALLOW_DRAG_LARGEYEAGER09
C     Large and Yeager (2009), J.Clim equation 11a/b
             tmpbulk =  cdrag_1/usm + cdrag_2 + cdrag_3*usm
     &            + cdrag_8 * usm**6
             tmpbulk = exf_scal_BulkCdn * (
     &              ( halfRL - SIGN(halfRL, usm-umax) )*tmpbulk
     &            + ( halfRL + SIGN(halfRL, usm-umax) )*cdragMax
     &            )
#else
             tmpbulk  = exf_scal_BulkCdn *
     &            ( cdrag_1/usm + cdrag_2 + cdrag_3*usm )
#endif
             rdn(i,j)   = SQRT(tmpbulk)
#ifdef ALLOW_BULK_LARGEYEAGER04
             rd(i,j)    = rdn(i,j)/(exf_one + rdn(i,j)*dzTmp)
#else
             rd(i,j)    = rdn(i,j)/(exf_one - rdn(i,j)/karman*psimh)
#endif /* ALLOW_BULK_LARGEYEAGER04 */
             ustar(i,j) = rd(i,j)*sh(i,j,bi,bj)
C-   Coeff:
#ifdef EXF_CALC_ATMRHO
             tau(i,j)   = atmrho_loc(i,j)*rd(i,j)*wspeed(i,j,bi,bj)
#else
             tau(i,j)   = atmrho*rd(i,j)*wspeed(i,j,bi,bj)
#endif
            ENDIF

C-   Update the 10m, neutral stability transfer coefficients (sens&evap)
            rhn = (exf_one-stable)*cstanton_1 + stable*cstanton_2
            ren = cDalton

C-   Shift all coefficients to the measurement height and stability.
            rh = rhn/(exf_one + rhn*(ztln-psixh)/karman)
            re = ren/(exf_one + ren*(ztln-psixh)/karman)

C--  Update ustar, tstar, qstar using updated, shifted coefficients.
            qstar(i,j) = re*delq(i,j)
            tstar(i,j) = rh*deltap(i,j)

           ENDIF
          ENDDO
         ENDDO
C end of iteration loop
        ENDDO
        DO j = 1,sNy
         DO i = 1,sNx
          IF ( atemp(i,j,bi,bj) .NE. 0. _d 0 ) THEN

#ifdef ALLOW_AUTODIFF_TAMC
           ikey_1 = i + (j-1)*sNx + (ikey-1)*sNx*sNy
CADJ STORE qstar(i,j)    = comlev1_exf_1, key = ikey_1
CADJ STORE tstar(i,j)    = comlev1_exf_1, key = ikey_1
CADJ STORE tau  (i,j)    = comlev1_exf_1, key = ikey_1
CADJ STORE rd   (i,j)    = comlev1_exf_1, key = ikey_1
#endif /* ALLOW_AUTODIFF_TAMC */

C-   Turbulent Fluxes
           hs(i,j,bi,bj) = atmcp*tau(i,j)*tstar(i,j)
           hl(i,j,bi,bj) = flamb*tau(i,j)*qstar(i,j)
#ifndef EXF_READ_EVAP
C   change sign and convert from kg/m^2/s to m/s via rhoConstFresh
c          evap(i,j,bi,bj) = -recip_rhonil*tau(i,j)*qstar(i,j)
           evap(i,j,bi,bj) = -recip_rhoConstFresh*tau(i,j)*qstar(i,j)
C   but older version was using rhonil instead:
c           evap(i,j,bi,bj) = -recip_rhonil*tau(i,j)*qstar(i,j)
#endif
           IF ( useAtmWind .AND. useRelativeWind ) THEN
            tmpbulk =  tau(i,j)*rd(i,j)
            ustress(i,j,bi,bj) = tmpbulk* ( uwind(i,j,bi,bj) -
     &           0.5 _d 0 * (uVel(i,j,ks,bi,bj)+uVel(i+1,j,ks,bi,bj)) )
            vstress(i,j,bi,bj) = tmpbulk* ( vwind(i,j,bi,bj) -
     &           0.5 _d 0 * (vVel(i,j,ks,bi,bj)+vVel(i,j+1,ks,bi,bj)) )
           ELSEIF ( useAtmWind ) THEN
c           ustress(i,j,bi,bj) = tau(i,j)*rd(i,j)*ws*cw(i,j,bi,bj)
c           vstress(i,j,bi,bj) = tau(i,j)*rd(i,j)*ws*sw(i,j,bi,bj)
C- jmc: below is how it should be written ; different from above when
C       both wind-speed & 2 compon. of the wind are specified, and in
C-      this case, formula below is better.
            tmpbulk =  tau(i,j)*rd(i,j)
            ustress(i,j,bi,bj) = tmpbulk*uwind(i,j,bi,bj)
            vstress(i,j,bi,bj) = tmpbulk*vwind(i,j,bi,bj)
           ENDIF

c IF ( ATEMP(i,j,bi,bj) .NE. 0. )
          ELSE
           IF ( useAtmWind ) ustress(i,j,bi,bj) = 0. _d 0
           IF ( useAtmWind ) vstress(i,j,bi,bj) = 0. _d 0
           hflux  (i,j,bi,bj) = 0. _d 0
           evap   (i,j,bi,bj) = 0. _d 0
           hs     (i,j,bi,bj) = 0. _d 0
           hl     (i,j,bi,bj) = 0. _d 0

c IF ( ATEMP(i,j,bi,bj) .NE. 0. )
          ENDIF

         ENDDO
        ENDDO
       ENDDO
      ENDDO

#endif /* ALLOW_ATM_TEMP */
#endif /* ALLOW_BULKFORMULAE */

      RETURN
      END

#include "OBSFIT_OPTIONS.h"
C--  File obsfit_active_file_ad.F:
C--   Contents
C--   o adactive_read_obs_tile
C--   o adactive_write_obs_tile
C--   o adactive_read_obs_glob
C--   o adactive_write_obs_glob

CBOP
C     !ROUTINE: ADACTIVE_READ_OBS_TILE

C     !INTERFACE:
      SUBROUTINE ADACTIVE_READ_OBS_TILE(
     I                                   active_num_file,
     O                                   adactive_var,
     I                                   irec,
     I                                   lAdInit,
     I                                   myIter,
     I                                   bi,
     I                                   bj,
     I                                   myThid )

C     !DESCRIPTION:
C     ==================================================================
C     | Adjoint of active_read_obs_tile
C     ==================================================================

C     !USES:
      IMPLICIT NONE
C     == Global variables ===
#include "EEPARAMS.h"
#include "SIZE.h"
#ifdef ALLOW_OBSFIT
# include "OBSFIT_SIZE.h"
# include "OBSFIT.h"
#endif

C     !INPUT PARAMETERS:
C     active_num_file: file number
C     adactive_var:    array
C     irec:            record number
C     myIter:          number of optimization iteration (default: 0)
C     myThid:          my thread ID number
C     lAdInit:         initialisation of corresponding adjoint
C                      variable and write to active file
      INTEGER active_num_file
      _RL     adactive_var
      INTEGER irec
      INTEGER myIter
      INTEGER bi, bj, myThid
      LOGICAL lAdInit
CEOP

#ifdef ALLOW_OBSFIT
      CALL ACTIVE_READ_OBS_TILE_RL(
     I     fidadj_obs(active_num_file,bi,bj), active_num_file,
     O     adactive_var,
     I     lAdInit, irec, sample_ind_glob(active_num_file,irec,bi,bj),
     I     REVERSE_SIMULATION, myIter, bi, bj, myThid )

#endif

      END

C     ==================================================================

CBOP
C     !ROUTINE: ADACTIVE_WRITE_OBS_TILE

C     !INTERFACE:
      SUBROUTINE ADACTIVE_WRITE_OBS_TILE(
     I                                    active_num_file,
     I                                    adactive_var,
     I                                    irec,
     I                                    myIter,
     I                                    bi,
     I                                    bj,
     I                                    myThid,
     I                                    dummy )

C     !DESCRIPTION:
C     ==================================================================
C     | Adjoint of active_write_obs_tile
C     ==================================================================

C     !USES:
      IMPLICIT NONE
C     == Global variables ===
#include "EEPARAMS.h"
#include "SIZE.h"
#ifdef ALLOW_OBSFIT
# include "OBSFIT_SIZE.h"
# include "OBSFIT.h"
#endif

C     !INPUT PARAMETERS:
C     active_num_file: file number
C     adactive_var:    array
C     irec:            record number
C     myIter:          number of optimization iteration (default: 0)
C     myThid:          my thread ID number
C     lAdInit:         initialisation of corresponding adjoint
C                      variable and write to active file
      INTEGER active_num_file
      _RL     adactive_var
      INTEGER irec
      INTEGER myIter
      INTEGER bi, bj, myThid
      _RL     dummy
CEOP

#ifdef ALLOW_OBSFIT

      CALL ACTIVE_WRITE_OBS_TILE_RL(
     I     fidadj_obs(active_num_file,bi,bj),
     I     active_num_file, adactive_var,
     I     irec, sample_ind_glob(active_num_file,irec,bi,bj),
     I     REVERSE_SIMULATION, myIter, bi, bj, myThid )

#endif

      END

C     ==================================================================

CBOP
C     !ROUTINE: ADACTIVE_READ_OBS_GLOB

C     !INTERFACE:
      SUBROUTINE ADACTIVE_READ_OBS_GLOB(
     I                                   active_num_file,
     O                                   adactive_var,
     O                                   adactive_mask,
     I                                   irec,
     I                                   lAdInit,
     I                                   myIter,
     I                                   myThid )

C     !DESCRIPTION:
C     ==================================================================
C     | Adjoint of active_read_obs_glob
C     ==================================================================

C     !USES:
      IMPLICIT NONE
C     == Global variables ===
#include "EEPARAMS.h"
#include "SIZE.h"
#ifdef ALLOW_OBSFIT
# include "OBSFIT_SIZE.h"
# include "OBSFIT.h"
#endif

C     !INPUT PARAMETERS:
C     active_num_file: file number
C     adactive_var:    array
C     adactive_mask:   array mask
C     irec:            record number
C     myIter:          number of optimization iteration (default: 0)
C     myThid:          my thread ID number
C     lAdInit:         initialisation of corresponding adjoint
C                      variable and write to active file
      INTEGER active_num_file
      _RL     adactive_var
      _RL     adactive_mask
      INTEGER irec
      INTEGER myIter
      INTEGER myThid
      LOGICAL lAdInit
CEOP

#ifdef ALLOW_OBSFIT

      CALL ACTIVE_READ_OBS_GLOB_RL(
     I     fidadglobal(active_num_file), active_num_file,
     O     adactive_var, adactive_mask,
     I     lAdInit, irec, obs_ind_glob(active_num_file,irec),
     I     REVERSE_SIMULATION, myIter, myThid )

#endif

      END

C     ==================================================================

CBOP
C     !ROUTINE: ADACTIVE_WRITE_OBS_GLOB

C     !INTERFACE:
      SUBROUTINE ADACTIVE_WRITE_OBS_GLOB(
     I                                    active_num_file,
     I                                    adactive_var,
     I                                    adactive_mask,
     I                                    irec,
     I                                    myIter,
     I                                    myThid,
     I                                    dummy )

C     !DESCRIPTION:
C     ==================================================================
C     | Adjoint of active_write_obs_glob
C     ==================================================================

C     !USES:
      IMPLICIT NONE
C     == Global variables ===
#include "EEPARAMS.h"
#include "SIZE.h"
#ifdef ALLOW_OBSFIT
# include "OBSFIT_SIZE.h"
# include "OBSFIT.h"
#endif

C     !INPUT PARAMETERS:
C     active_num_file: file number
C     adactive_var:    array
C     adactive_mask:   array mask
C     irec:            record number
C     myIter:          number of optimization iteration (default: 0)
C     myThid:          my thread ID number
C     lAdInit:         initialisation of corresponding adjoint
C                      variable and write to active file
      INTEGER active_num_file
      _RL     adactive_var
      _RL     adactive_mask
      INTEGER irec
      INTEGER myIter
      INTEGER myThid
      _RL     dummy
CEOP

#ifdef ALLOW_OBSFIT
      CALL ACTIVE_WRITE_OBS_GLOB_RL(
     I     fidadglobal(active_num_file), active_num_file,
     I     adactive_var, adactive_mask,
     I     irec, obs_ind_glob(active_num_file,irec),
     I     REVERSE_SIMULATION, myIter,myThid )

#endif

      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#include "KPP_OPTIONS.h"

      SUBROUTINE KPP_CHECK( myThid )

C     *==========================================================*
C     | SUBROUTINE KPP_CHECK
C     | o Validate basic package setup and inter-package
C     |   dependencies.
C     *==========================================================*

      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "KPP_PARAMS.h"

C     === Routine arguments ===
C     myThid :: my Thread Id Number
      INTEGER myThid

#ifdef ALLOW_KPP
C     === Local variables ===
C     msgBuf :: Informational/error message buffer
      CHARACTER*(MAX_LEN_MBUF) msgBuf

      _BEGIN_MASTER(myThid)

      WRITE(msgBuf,'(A)') 'KPP_CHECK: #define ALLOW_KPP'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )

C--   Print out KPP parameters:
      CALL WRITE_0D_RL( kpp_freq, INDEX_NONE, ' kpp_freq =',
     &  ' /* frequency of KPP calculation */')

      CALL WRITE_0D_L( KPP_ghatUseTotalDiffus, INDEX_NONE,
     &  'KPP_ghatUseTotalDiffus=',
     &  ' /* non-local term fct of total diffus */')
      CALL WRITE_0D_L( KPPuseDoubleDiff, INDEX_NONE,
     &  'KPPuseDoubleDiff =', ' /* include double diffusive contrib */')
      CALL WRITE_0D_L( KPPuseSWfrac3D, INDEX_NONE,
     &  'KPPuseSWfrac3D =', ' /* for light attenuation use SWfrac3D */')
      CALL WRITE_0D_L( LimitHblStable, INDEX_NONE,
     &  'LimitHblStable =', ' /* limits depth of hbl if stable cond.*/')
      CALL WRITE_0D_RL( minKPPhbl, INDEX_NONE, ' minKPPhbl =',
     &  ' /* minimum KPPhbl value [m] */')
      CALL WRITE_0D_RL( epsln,     INDEX_NONE, ' epsln     =',
     &  ' /* constant [-] */')
      CALL WRITE_0D_RL( phepsi,    INDEX_NONE, ' phepsi    =',
     &  ' /* constant [-] */')
      CALL WRITE_0D_RL( epsilon,   INDEX_NONE, ' epsilon   =',
     &  ' /* constant [-] */')
      CALL WRITE_0D_RL( vonk,      INDEX_NONE, ' vonk      =',
     &  ' /* Von Karmans constant [-] */')
      CALL WRITE_0D_RL( dB_dz,     INDEX_NONE, ' dB_dz     =',
     &  ' /* maximum N^2 in mixed layer [s^-2] */')
      CALL WRITE_0D_RL( conc1,     INDEX_NONE, ' conc1     =',
     &  ' /* scalar constant [-] */')
      CALL WRITE_0D_RL( conam,     INDEX_NONE, ' conam     =',
     &  ' /* scalar constant [-] */')
      CALL WRITE_0D_RL( concm,     INDEX_NONE, ' concm     =',
     &  ' /* scalar constant [-] */')
      CALL WRITE_0D_RL( conc2,     INDEX_NONE, ' conc2     =',
     &  ' /* scalar constant [-] */')
      CALL WRITE_0D_RL( conas,     INDEX_NONE, ' conas     =',
     &  ' /* scalar constant [-] */')
      CALL WRITE_0D_RL( concs,     INDEX_NONE, ' concs     =',
     &  ' /* scalar constant [-] */')
      CALL WRITE_0D_RL( conc3,     INDEX_NONE, ' conc3     =',
     &  ' /* scalar constant [-] */')
      CALL WRITE_0D_RL( zetam,     INDEX_NONE, ' zetam     =',
     &  ' /* scalar constant [-] */')
      CALL WRITE_0D_RL( zetas,     INDEX_NONE, ' zetas     =',
     &  ' /* scalar constant [-] */')
      CALL WRITE_0D_RL( Ricr,      INDEX_NONE, ' Ricr      =',
     &  ' /* critical bulk Richardson Number [-] */')
      CALL WRITE_0D_RL( cekman,    INDEX_NONE, ' cekman    =',
     &  ' /* coeff for Ekman depth [-] */')
      CALL WRITE_0D_RL( cmonob,    INDEX_NONE, ' cmonob    =',
     &  ' /* coeff for Monin-Obukhov depth [-] */')
      CALL WRITE_0D_RL( concv,     INDEX_NONE, ' concv     =',
     &  ' /* buoyancy freq ratio [-] */')
      CALL WRITE_0D_RL( hbf,       INDEX_NONE, ' hbf       =',
     &  ' /* solar radiation depth ratio [-] */')
      CALL WRITE_0D_RL( zmin,      INDEX_NONE, ' zmin      =',
     &  ' /* minimum for zehat in table [m3/s3] */')
      CALL WRITE_0D_RL( zmax,      INDEX_NONE, ' zmax      =',
     &  ' /* maximum for zehat in table [m3/s3] */')
      CALL WRITE_0D_RL( umin,      INDEX_NONE, ' umin      =',
     &  ' /* minimum for ustar in table [m/s] */')
      CALL WRITE_0D_RL( umax,      INDEX_NONE, ' umax      =',
     &  ' /* maximum for ustar in table [m/s] */')
      CALL WRITE_0D_I( num_v_smooth_Ri, INDEX_NONE,
     & 'num_v_smooth_Ri =', ' /* number of vertical smoothing */')
      CALL WRITE_0D_RL( Riinfty,   INDEX_NONE, ' Riinfty   =',
     &  ' /* shear instability Ri number limit [-] */')
      CALL WRITE_0D_RL( BVSQcon,   INDEX_NONE, ' BVSQcon   =',
     &  ' /* Brunt-Vaisala squared (=N^2) [s^-2] */')
      CALL WRITE_0D_RL( difm0,     INDEX_NONE, ' difm0     =',
     &  ' /* max viscosity from shear instab. [m2/s] */')
      CALL WRITE_0D_RL( difs0,     INDEX_NONE, ' difs0     =',
     &  ' /* max diffusiv. from shear instab. [m2/s] */')
      CALL WRITE_0D_RL( dift0,     INDEX_NONE, ' dift0     =',
     &  ' /* max diffusiv. from shear instab. [m2/s] */')
      CALL WRITE_0D_RL( difmcon,   INDEX_NONE, ' difmcon   =',
     &  ' /* convective viscosity [m2/s] */')
      CALL WRITE_0D_RL( difscon,   INDEX_NONE, ' difscon   =',
     &  ' /* convective diffusiv. [m2/s] */')
      CALL WRITE_0D_RL( diftcon,   INDEX_NONE, ' diftcon   =',
     &  ' /* convective diffusiv. [m2/s] */')
      CALL WRITE_0D_RL( Rrho0,     INDEX_NONE, ' Rrho0     =',
     &  ' /* double diffusion density ratio [-] */')
      CALL WRITE_0D_RL( dsfmax,    INDEX_NONE, ' dsfmax    =',
     &  ' /* max diffusiv. for salt fingering [m2/s] */')
      CALL WRITE_0D_RL( cstar,     INDEX_NONE, ' cstar     =',
     &  ' /* coeff for non-locak transport [-] */')
C--
      CALL WRITE_0D_L( KPPwriteState, INDEX_NONE,
     &  'KPPwriteState =', ' /* write KPP fields to file */')
      CALL WRITE_0D_RL( kpp_dumpFreq, INDEX_NONE, ' kpp_dumpFreq =',
     &  ' /* dump freq of KPP output */')

C--  Check parameters:

C     KPP needs convection turned off (will be packaged later)
      IF (cAdjFreq.NE.0.  .OR.
     &     ivdc_kappa.NE.0.) THEN
         WRITE(msgBuf,'(A)') 'Some form of convection has been enabled'
         CALL PRINT_ERROR( msgBuf , myThid )
         STOP 'ABNORMAL END: S/R KPP_CHECK'
      ENDIF

C     KPP needs implicit vertical diffusion and viscosity
      IF (.NOT.implicitDiffusion ) THEN
         WRITE(msgBuf,'(A)') 'KPP needs implicitDiffusion to be enabled'
         CALL PRINT_ERROR( msgBuf , myThid )
         STOP 'ABNORMAL END: S/R KPP_CHECK'
      ENDIF
      IF ( .NOT.implicitViscosity .AND. momStepping ) THEN
         WRITE(msgBuf,'(A)') 'KPP needs implicitViscosity to be enabled'
         CALL PRINT_ERROR( msgBuf , myThid )
         STOP 'ABNORMAL END: S/R KPP_CHECK'
      ENDIF

C     Check that overlap region is adequate.
C     When horizontal smoothing is turned on,
C     KPP_CALC computes vertical viscosity and diffusivity for region
C     (-2:sNx+3,-2:sNy+3) as required by CALC_DIFFUSIVITY and requires
C     values of uVel, vVel, surfaceForcingU, surfaceForcingV in the
C     region (-2:sNx+4,-2:sNy+4).
C     Hence overlap region needs to be set OLx=4, OLy=4.
#if defined(KPP_SMOOTH_SHSQ) || defined(KPP_SMOOTH_DVSQ)
#  define KPP_NEEDS_OVERLAP_4
#endif
#if defined(KPP_SMOOTH_DBLOC) || defined(KPP_SMOOTH_DENS)
#  define KPP_NEEDS_OVERLAP_4
#endif
#ifdef KPP_NEEDS_OVERLAP_4
#ifdef KPP_REACTIVATE_OL4
      IF (OLx.LT.4 .OR. OLy.LT.4) THEN
       WRITE(msgBuf,'(A)') 'KPP horizontal smoothing requires OLx=OLy=4'
       CALL PRINT_ERROR( msgBuf , myThid )
       STOP 'ABNORMAL END: S/R KPP_CHECK'
      ENDIF
#endif
#endif

#ifdef EXCLUDE_KPP_DOUBLEDIFF
      IF ( KPPuseDoubleDiff ) THEN
       WRITE(msgBuf,'(A,A)') 'KPPuseDoubleDiff=.TRUE. requires ',
     &      'that EXCLUDE_KPP_DOUBLEDIFF is undefined'
       CALL PRINT_ERROR( msgBuf , myThid )
       STOP 'ABNORMAL END: S/R KPP_CHECK'
      ENDIF
#endif /* EXCLUDE_KPP_DOUBLEDIFF */

      WRITE(msgBuf,'(A)') ' '
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )

      _END_MASTER(myThid)

#endif /* ALLOW_KPP */
      RETURN
      END

#include "AIM_OPTIONS.h"

CBOP
C     !ROUTINE: AIM_DIAGNOSTICS
C     !INTERFACE:
      SUBROUTINE AIM_DIAGNOSTICS( bi, bj, myTime, myIter, myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R AIM_DIAGNOSTICS
C     | o Calculate AIM diagnostics
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     == Global variables ===
C-- size for MITgcm & Physics package :
#include "AIM_SIZE.h"

#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"

#include "AIM_PARAMS.h"
c #include "AIM2DYN.h"
#include "com_physvar.h"
#include "com_forcing.h"

C     !INPUT/OUTPUT PARAMETERS:
C     bi, bj :: Tile index
C     myTime :: Current time of simulation ( s )
C     myIter :: Current iteration number in simulation
C     myThid :: my Thread Id number
      INTEGER bi, bj
      _RL     myTime
      INTEGER myIter, myThid
CEOP

#ifdef ALLOW_AIM
C     !FUNCTIONS:
      LOGICAL  DIFFERENT_MULTIPLE
      EXTERNAL DIFFERENT_MULTIPLE
#ifdef ALLOW_DIAGNOSTICS
      LOGICAL  DIAGNOSTICS_IS_ON
      EXTERNAL DIAGNOSTICS_IS_ON
#endif

C     !LOCAL VARIABLES:
      INTEGER J
      CHARACTER*(10) suff
#ifdef ALLOW_DIAGNOSTICS
      _RL tmpVar(NGP)
#endif
#ifdef ALLOW_MNC
      CHARACTER*(1) pf
#endif

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C--  mean surf. temp. change:
C note: comment out ice-free ocean contribution (small part anyway)
C       which is not yet available when this S/R is called
      DO J=1,NGP
         dTsurf(J,1,myThid) = fMask1(J,1,myThid)*dTsurf(J,1,myThid)
c    &                      + fMask1(J,2,myThid)*dTsurf(J,2,myThid)
     &                      + fMask1(J,3,myThid)*dTsurf(J,3,myThid)
         dTsurf(J,1,myThid) = ABS(dTsurf(J,1,myThid))
      ENDDO

      IF ( DIFFERENT_MULTIPLE( aim_tendFreq,
     &                         myTime+deltaTClock, deltaTClock )
     &   ) THEN
C---  Write Tendencies to files :

       IF ( aim_snapshot_mdsio ) THEN
C-    using MDSIO based S/R
         IF ( rwSuffixType.EQ.0 ) THEN
           WRITE(suff,'(I10.10)') myIter+1
         ELSE
           CALL RW_GET_SUFFIX( suff,
     &                 myTime+deltaTClock, myIter+1, myThid )
         ENDIF

         CALL AIM_WRITE_PHYS( 'aim_dT_RSW.', suff, Nr, TT_RSW,
     &                         0, bi, bj, 1, myIter, myThid )
         CALL AIM_WRITE_PHYS( 'aim_dT_RLW.', suff, Nr, TT_RLW,
     &                         0, bi, bj, 1, myIter, myThid )
         CALL AIM_WRITE_PHYS( 'aim_dT_CNV.', suff, Nr, TT_CNV,
     &                         0, bi, bj, 1, myIter, myThid )
         CALL AIM_WRITE_PHYS( 'aim_dT_PBL.', suff, Nr, TT_PBL,
     &                         0, bi, bj, 1, myIter, myThid )
         CALL AIM_WRITE_PHYS( 'aim_dT_LSC.', suff, Nr, TT_LSC,
     &                         0, bi, bj, 1, myIter, myThid )
         CALL AIM_WRITE_PHYS( 'aim_dQ_CNV.', suff, Nr, QT_CNV,
     &                         0, bi, bj, 1, myIter, myThid )
         CALL AIM_WRITE_PHYS( 'aim_dQ_PBL.', suff, Nr, QT_PBL,
     &                         0, bi, bj, 1, myIter, myThid )
         CALL AIM_WRITE_PHYS( 'aim_dQ_LSC.', suff, Nr, QT_LSC,
     &                         0, bi, bj, 1, myIter, myThid )
#ifdef ALLOW_CLR_SKY_DIAG
C-    write clear-sky tendencies to files :
         IF ( aim_clrSkyDiag ) THEN
          CALL AIM_WRITE_PHYS( 'aim_dT_clskySW.', suff, Nr, TT_SWclr,
     &                         0, bi, bj, 1, myIter, myThid )
          CALL AIM_WRITE_PHYS( 'aim_dT_clskyLW.', suff, Nr, TT_LWclr,
     &                         0, bi, bj, 1, myIter, myThid )
         ENDIF
#endif /* ALLOW_CLR_SKY_DIAG */

C-    end if aim_snapshot_mdsio
       ENDIF

#ifdef ALLOW_MNC
c      IF ( useMNC .AND. aim_snapshot_mnc ) THEN
C-    using MNC S/R
       IF ( .FALSE. ) THEN
C jmc: temporary turn off this part until this get fixed:
C      > MNC_CW_RL_W ERROR: vtype 'aim_dT_RSW' is not defined

         IF ( writeBinaryPrec .EQ. precFloat64 ) THEN
           pf(1:1) = 'D'
         ELSE
           pf(1:1) = 'R'
         ENDIF

         IF ( bi.EQ.1 .AND. bj.EQ.1 ) THEN
          WRITE(suff,'(a)') 'aim_tend'
          CALL MNC_CW_SET_UDIM(suff, -1, myThid)
          CALL MNC_CW_RL_W_S('D',suff,0,0,'T',myTime,myThid)
          CALL MNC_CW_SET_UDIM(suff, 0, myThid)
          CALL MNC_CW_I_W_S('I',suff,0,0,'iter',myIter,myThid)
         ENDIF

         CALL MNC_CW_RL_W(pf,suff,bi,bj,'aim_dT_RSW',TT_RSW,myThid)
         CALL MNC_CW_RL_W(pf,suff,bi,bj,'aim_dT_RLW',TT_RLW,myThid)
         CALL MNC_CW_RL_W(pf,suff,bi,bj,'aim_dT_CNV',TT_CNV,myThid)
         CALL MNC_CW_RL_W(pf,suff,bi,bj,'aim_dT_PBL',TT_PBL,myThid)
         CALL MNC_CW_RL_W(pf,suff,bi,bj,'aim_dT_LSC',TT_LSC,myThid)
         CALL MNC_CW_RL_W(pf,suff,bi,bj,'aim_dQ_CNV',QT_CNV,myThid)
         CALL MNC_CW_RL_W(pf,suff,bi,bj,'aim_dQ_PBL',QT_PBL,myThid)
         CALL MNC_CW_RL_W(pf,suff,bi,bj,'aim_dQ_LSC',QT_LSC,myThid)

C-    end if aim_snapshot_mnc
       ENDIF
#endif /* ALLOW_MNC */

C---  end writing tendencies
      ENDIF

      IF ( DIFFERENT_MULTIPLE( aim_diagFreq,
     &                         myTime+deltaTClock, deltaTClock )
     &   ) THEN
C---  Write Physics Fields

       IF ( aim_snapshot_mdsio ) THEN
C-    using MDSIO based S/R
         IF ( rwSuffixType.EQ.0 ) THEN
           WRITE(suff,'(I10.10)') myIter+1
         ELSE
           CALL RW_GET_SUFFIX( suff,
     &                 myTime+deltaTClock, myIter+1, myThid )
         ENDIF

C--   Write Relative Humidity :
         CALL AIM_WRITE_PHYS( 'aim_RelHum.', suff, Nr, RH,
     &                         0, bi, bj, 1, myIter, myThid )

C--   Write AIM Physics diagnostics (2D, all in 1 file) :
         CALL AIM_WRITE_PHYS( 'aimPhyDiag.', suff, 4, DRAG,
     &                         1, bi, bj, 1, myIter, myThid )
         CALL AIM_WRITE_PHYS( 'aimPhyDiag.', suff, 1, SPEED0,
     &                         1, bi, bj, 2, myIter, myThid )
         CALL AIM_WRITE_PHYS( 'aimPhyDiag.', suff, 1, TSR,
     &                         1, bi, bj, 3, myIter, myThid )
         CALL AIM_WRITE_PHYS( 'aimPhyDiag.', suff, 1, OLR,
     &                         1, bi, bj, 4, myIter, myThid )
         CALL AIM_WRITE_PHYS( 'aimPhyDiag.', suff, 4, SSR,
     &                         1, bi, bj, 5, myIter, myThid )
         CALL AIM_WRITE_PHYS( 'aimPhyDiag.', suff, 4, SLR,
     &                         1, bi, bj, 6, myIter, myThid )
         CALL AIM_WRITE_PHYS( 'aimPhyDiag.', suff, 4, SHF,
     &                         1, bi, bj, 7, myIter, myThid )
         CALL AIM_WRITE_PHYS( 'aimPhyDiag.', suff, 4, EVAP,
     &                         1, bi, bj, 8, myIter, myThid )
         CALL AIM_WRITE_PHYS( 'aimPhyDiag.', suff, 1, PRECNV,
     &                         1, bi, bj, 9, myIter, myThid )
         CALL AIM_WRITE_PHYS( 'aimPhyDiag.', suff, 1, PRECLS,
     &                         1, bi, bj,10, myIter, myThid )
         CALL AIM_WRITE_PHYS( 'aimPhyDiag.', suff, 1, CLOUDC,
     &                         1, bi, bj,11, myIter, myThid )
         CALL AIM_WRITE_PHYS( 'aimPhyDiag.', suff, 1, CLTOP,
     &                         1, bi, bj,12, myIter, myThid )
         CALL AIM_WRITE_PHYS( 'aimPhyDiag.', suff, 1, CBMF,
     &                         1, bi, bj,13, myIter, myThid )
         CALL AIM_WRITE_PHYS( 'aimPhyDiag.', suff, 1, T0,
     &                         1, bi, bj,14, myIter, myThid )
         CALL AIM_WRITE_PHYS( 'aimPhyDiag.', suff, 1, Q0,
     &                         1, bi, bj,15, myIter, myThid )
         CALL AIM_WRITE_PHYS( 'aimPhyDiag.', suff, 1, EnPrec,
     &                         1, bi, bj,16, myIter, myThid )
         CALL AIM_WRITE_PHYS( 'aimPhyDiag.', suff, 4, alb1,
     &                         1, bi, bj,17, myIter, myThid )
         CALL AIM_WRITE_PHYS( 'aimPhyDiag.', suff, 3, dTsurf,
     &                         1, bi, bj,18, myIter, myThid )
#ifdef ALLOW_CLR_SKY_DIAG
C--   write clear-sky radiative fluxes to files :
         IF ( aim_clrSkyDiag ) THEN
          CALL AIM_WRITE_PHYS('aimPhyDiag.', suff, 1, TSWclr,
     &                         1, bi, bj,19, myIter, myThid )
          CALL AIM_WRITE_PHYS('aimPhyDiag.', suff, 1, OLWclr,
     &                         1, bi, bj,20, myIter, myThid )
          CALL AIM_WRITE_PHYS('aimPhyDiag.', suff, 1, SSWclr,
     &                         1, bi, bj,21, myIter, myThid )
          CALL AIM_WRITE_PHYS('aimPhyDiag.', suff, 1, SLWclr,
     &                         1, bi, bj,22, myIter, myThid )
         ENDIF
#endif /* ALLOW_CLR_SKY_DIAG */

C-    end if aim_snapshot_mdsio
       ENDIF

#ifdef ALLOW_MNC
       IF ( useMNC .AND. aim_snapshot_mnc ) THEN
C-    using MNC S/R

         IF ( writeBinaryPrec .EQ. precFloat64 ) THEN
           pf(1:1) = 'D'
         ELSE
           pf(1:1) = 'R'
         ENDIF

         IF ( bi.EQ.1 .AND. bj.EQ.1 ) THEN
          WRITE(suff,'(a)') 'aim_phys'
          CALL MNC_CW_SET_UDIM(suff, -1, myThid)
          CALL MNC_CW_RL_W_S('D',suff,0,0,'T',myTime+deltaTClock,myThid)
          CALL MNC_CW_SET_UDIM(suff, 0, myThid)
          CALL MNC_CW_I_W_S('I',suff,0,0,'iter',myIter+1,myThid)
         ENDIF

         CALL MNC_CW_RL_W(pf,suff,bi,bj,
     &        'aim_DRAG0',DRAG(1,0,myThid),myThid)
         CALL MNC_CW_RL_W(pf,suff,bi,bj,
     &        'aim_SPEED0',SPEED0(1,myThid),myThid)
         CALL MNC_CW_RL_W(pf,suff,bi,bj,
     &        'aim_TSR',TSR(1,myThid),myThid)
         CALL MNC_CW_RL_W(pf,suff,bi,bj,
     &        'aim_OLR',OLR(1,myThid),myThid)
         CALL MNC_CW_RL_W(pf,suff,bi,bj,
     &        'aim_SSR0',SSR(1,0,myThid),myThid)
         CALL MNC_CW_RL_W(pf,suff,bi,bj,
     &        'aim_SLR0',SLR(1,0,myThid),myThid)
         CALL MNC_CW_RL_W(pf,suff,bi,bj,
     &        'aim_SHF0',SHF(1,0,myThid),myThid)
         CALL MNC_CW_RL_W(pf,suff,bi,bj,
     &        'aim_EVAP0',EVAP(1,0,myThid),myThid)
         CALL MNC_CW_RL_W(pf,suff,bi,bj,
     &        'aim_PRECNV',PRECNV(1,myThid),myThid)
         CALL MNC_CW_RL_W(pf,suff,bi,bj,
     &        'aim_PRECLS',PRECLS(1,myThid),myThid)
         CALL MNC_CW_RL_W(pf,suff,bi,bj,
     &        'aim_CLOUDC',CLOUDC(1,myThid),myThid)
         CALL MNC_CW_RL_W(pf,suff,bi,bj,
     &        'aim_CLTOP',CLTOP(1,myThid),myThid)
         CALL MNC_CW_RL_W(pf,suff,bi,bj,
     &        'aim_CBMF',CBMF(1,myThid),myThid)
         CALL MNC_CW_RL_W(pf,suff,bi,bj,
     &        'aim_T0',T0(1,myThid),myThid)
         CALL MNC_CW_RL_W(pf,suff,bi,bj,
     &        'aim_Q0',Q0(1,myThid),myThid)
         CALL MNC_CW_RL_W(pf,suff,bi,bj,
     &        'aim_EnPrec',EnPrec(1,myThid),myThid)
         CALL MNC_CW_RL_W(pf,suff,bi,bj,
     &        'aim_alb10',alb1(1,0,myThid),myThid)
         CALL MNC_CW_RL_W(pf,suff,bi,bj,
     &        'aim_dTsurf1',dTsurf(1,1,myThid),myThid)
#ifdef ALLOW_CLR_SKY_DIAG
C--   write clear-sky radiative fluxes to files :
        IF ( aim_clrSkyDiag ) THEN
         CALL MNC_CW_RL_W(pf,suff,bi,bj,
     &        'aim_TSWclr',TSWclr(1,myThid),myThid)
         CALL MNC_CW_RL_W(pf,suff,bi,bj,
     &        'aim_OLWclr',OLWclr(1,myThid),myThid)
         CALL MNC_CW_RL_W(pf,suff,bi,bj,
     &        'aim_SSWclr',SSWclr(1,myThid),myThid)
         CALL MNC_CW_RL_W(pf,suff,bi,bj,
     &        'aim_SLWclr',SLWclr(1,myThid),myThid)
        ENDIF
#endif /* ALLOW_CLR_SKY_DIAG */

C     end if aim_snapshot_mnc
       ENDIF
#endif /* ALLOW_MNC */

C--   end writing Physics Fields
      ENDIF

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C--   cloud-top pressure: multiplied by cloud fraction before averaging:
      DO J=1,NGP
        CLTOP(J,myThid)=CLTOP(J,myThid)*CLOUDC(J,myThid)
      ENDDO

#ifdef ALLOW_DIAGNOSTICS
       IF ( useDiagnostics ) THEN
        CALL DIAGNOSTICS_FILL( TT_RSW(1,1,myThid),
     &                        'RADSW   ',-1, Nr, 3,bi,bj, myThid )
        CALL DIAGNOSTICS_FILL( TT_RLW(1,1,myThid),
     &                        'RADLW   ',-1, Nr, 3,bi,bj, myThid )
        CALL DIAGNOSTICS_FILL( TT_CNV(1,1,myThid),
     &                        'DTCONV  ',-1, Nr, 3,bi,bj, myThid )
        CALL DIAGNOSTICS_FILL( TT_PBL(1,1,myThid),
     &                        'TURBT   ',-1, Nr, 3,bi,bj, myThid )
        CALL DIAGNOSTICS_FILL( TT_LSC(1,1,myThid),
     &                        'DTLS    ',-1, Nr, 3,bi,bj, myThid )
        CALL DIAGNOSTICS_FILL( QT_CNV(1,1,myThid),
     &                        'DQCONV  ',-1, Nr, 3,bi,bj, myThid )
        CALL DIAGNOSTICS_FILL( QT_PBL(1,1,myThid),
     &                        'TURBQ   ',-1, Nr, 3,bi,bj, myThid )
        CALL DIAGNOSTICS_FILL( QT_LSC(1,1,myThid),
     &                        'DQLS    ',-1, Nr, 3,bi,bj, myThid )
        CALL DIAGNOSTICS_FILL( RH(1,1,myThid),
     &                        'RELHUM  ',-1, Nr, 3,bi,bj, myThid )
        CALL DIAGNOSTICS_FILL( TSR(1,myThid),
     &                        'TSR     ', 1, 1 , 3,bi,bj, myThid )
        CALL DIAGNOSTICS_FILL( OLR(1,myThid),
     &                        'OLR     ', 1, 1 , 3,bi,bj, myThid )
        CALL DIAGNOSTICS_FILL( SSR(1,0,myThid),
     &                        'RADSWG  ', 1, 1 , 3,bi,bj, myThid )
        CALL DIAGNOSTICS_FILL( SLR(1,0,myThid),
     &                        'RADLWG  ', 1, 1 , 3,bi,bj, myThid )
        CALL DIAGNOSTICS_FILL( SHF(1,0,myThid),
     &                        'HFLUX   ', 1, 1 , 3,bi,bj, myThid )
        CALL DIAGNOSTICS_FILL( EVAP(1,0,myThid),
     &                        'EVAP    ', 1, 1 , 3,bi,bj, myThid )
        CALL DIAGNOSTICS_FILL( PRECNV(1,myThid),
     &                        'PRECON  ', 1, 1 , 3,bi,bj, myThid )
        CALL DIAGNOSTICS_FILL( PRECLS(1,myThid),
     &                        'PRECLS  ', 1, 1 , 3,bi,bj, myThid )
        CALL DIAGNOSTICS_FILL( CLOUDC(1,myThid),
     &                        'CLDFRC  ', 1, 1 , 3,bi,bj, myThid )
        CALL DIAGNOSTICS_FILL( CLTOP(1,myThid),
     &                        'CLDPRS  ', 1, 1 , 3,bi,bj, myThid )
c       CALL DIAGNOSTICS_FILL( CLOUDC(1,myThid),
c    &                        'CTPCNT  ', 1, 1 , 3,bi,bj, myThid )
        CALL DIAGNOSTICS_FILL( CBMF(1,myThid),
     &                        'CLDMAS  ', 1, 1 , 3,bi,bj, myThid )
        CALL DIAGNOSTICS_FILL( DRAG(1,0,myThid),
     &                        'DRAG    ', 1, 1 , 3,bi,bj, myThid )
        CALL DIAGNOSTICS_FILL( SPEED0(1,myThid),
     &                        'WINDS   ', 1, 1 , 3,bi,bj, myThid )
        CALL DIAGNOSTICS_FILL( T0(1,myThid),
     &                        'TS      ', 1, 1 , 3,bi,bj, myThid )
        CALL DIAGNOSTICS_FILL( Q0(1,myThid),
     &                        'QS      ', 1, 1 , 3,bi,bj, myThid )
        IF ( DIAGNOSTICS_IS_ON('ENPREC  ',myThid) ) THEN
          DO J=1,NGP
            tmpVar(J) = EnPrec(J,myThid)
     &                *(PRECNV(J,myThid)+PRECLS(J,myThid))
          ENDDO
          CALL DIAGNOSTICS_FILL( tmpVar,
     &                        'ENPREC  ', 1, 1 , 3,bi,bj, myThid )
        ENDIF
        CALL DIAGNOSTICS_FILL( alb1(1,0,myThid),
     &                        'ALBVISDF', 1, 1 , 3,bi,bj, myThid )
        CALL DIAGNOSTICS_FILL( dTsurf(1,1,myThid),
     &                        'DTSIMPL ', 1, 1 , 3,bi,bj, myThid )
#ifdef ALLOW_CLR_SKY_DIAG
        IF ( aim_clrSkyDiag ) THEN
          CALL DIAGNOSTICS_FILL( TT_SWclr(1,1,myThid),
     &                        'SWCLR   ',-1, Nr, 3,bi,bj, myThid )
          CALL DIAGNOSTICS_FILL( TT_LWclr(1,1,myThid),
     &                        'LWCLR   ',-1, Nr, 3,bi,bj, myThid )
          CALL DIAGNOSTICS_FILL( TSWclr(1,myThid),
     &                        'TSRCLR  ', 1, 1 , 3,bi,bj, myThid )
          CALL DIAGNOSTICS_FILL( OLWclr(1,myThid),
     &                        'OLRCLR  ', 1, 1 , 3,bi,bj, myThid )
          CALL DIAGNOSTICS_FILL( SSWclr(1,myThid),
     &                        'SWGCLR  ', 1, 1 , 3,bi,bj, myThid )
          CALL DIAGNOSTICS_FILL( SLWclr(1,myThid),
     &                        'LWGCLR  ', 1, 1 , 3,bi,bj, myThid )
        ENDIF
#endif /* ALLOW_CLR_SKY_DIAG */

       ENDIF
#endif /* ALLOW_DIAGNOSTICS */

#endif /* ALLOW_AIM */

      RETURN
      END

#include "GAD_OPTIONS.h"

CBOP
C !ROUTINE: GAD_BIHARM_X

C !INTERFACE: ==========================================================
      SUBROUTINE GAD_BIHARM_X(
     I           bi,bj,k,
     I           xA,del2T,diffK4,
     U           dfx,
     I           myThid )

C !DESCRIPTION:
C Calculates the zonal flux due to bi-harmonic diffusion of a tracer.
C Routine takes the laplacian of the tracer as argument and calculates
C the zonal gradient:
C \begin{equation*}
C F^x_{diff} = \kappa_4 \partial_x \nabla^2 \theta
C \end{equation*}

C !USES: ===============================================================
      IMPLICIT NONE
#include "SIZE.h"
#include "GRID.h"

C !INPUT PARAMETERS: ===================================================
C  bi,bj                :: tile indices
C  k                    :: vertical level
C  xA                   :: area of face at U points
C  del2T                :: Laplacian of tracer
C  myThid               :: thread number
      INTEGER bi,bj,k
      _RS xA   (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL del2T(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL diffK4
      INTEGER myThid

C !OUTPUT PARAMETERS: ==================================================
C  dfx                  :: zonal diffusive flux
      _RL dfx  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)

C !LOCAL VARIABLES: ====================================================
C  i,j                  :: loop indices
      INTEGER i,j
CEOP

C     Difference of zonal fluxes ...
      DO j=1-Oly,sNy+Oly
c      dfx(1-Olx,j) = 0.
       DO i=1-Olx+1,sNx+Olx
c        dfx(i,j) = diffK4*xA(i,j)
         dfx(i,j) = dfx(i,j) + diffK4*xA(i,j)
     &    *_recip_dxC(i,j,bi,bj)*recip_deepFacC(k)
     &    *(del2T(i,j)-del2T(i-1,j))
#ifdef COSINEMETH_III
     &    *sqCosFacU(j,bi,bj)
#else
     &    *cosFacU(j,bi,bj)
#endif
       ENDDO
      ENDDO

      RETURN
      END

#include "AUTODIFF_OPTIONS.h"

C--   File global_adsum.F: Routines that perform adjoint of
C                          global sum on all threads and all processors
C      Contents
C      o GLOBAL_ADSUM_R4
C      o GLOBAL_ADSUM_R8

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: GLOBAL_ADSUM_R4

C     !INTERFACE:
#ifdef AUTODIFF_TAMC_COMPATIBILITY
      SUBROUTINE GLOBAL_ADSUM_R4(
     I                            myThid,
     U                            adsumPhi
     &                          )
#else
      SUBROUTINE GLOBAL_ADSUM_R4(
     U                            adsumPhi,
     I                            myThid
     &                          )
#endif

C     !DESCRIPTION:
C     *==========================================================*
C     | SUBROUTINE GLOBAL_ADSUM_R4
C     | o Handle sum for real*4 data.
C     *==========================================================*
C     *==========================================================*

C     !USES:
      IMPLICIT NONE

C     == Global data ==
#include "SIZE.h"
#include "EEPARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     sumPhi :: Result of sum.
C     myThid :: My thread id.
      Real*4 adsumPhi
      INTEGER myThid
CEOP

C     !LOCAL VARIABLES:

      CALL GLOBAL_SUM_R4( adsumPhi, myThid )

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: GLOBAL_ADSUM_R8

C     !INTERFACE:
#ifdef AUTODIFF_TAMC_COMPATIBILITY
      SUBROUTINE GLOBAL_ADSUM_R8(
     I                            myThid,
     U                            adsumPhi
     &                          )
#else
      SUBROUTINE GLOBAL_ADSUM_R8(
     U                            adsumPhi,
     I                            myThid
     &                          )
#endif

C     !DESCRIPTION:
C     *==========================================================*
C     | SUBROUTINE GLOBAL_ADSUM_R8
C     | o Handle sum for real*8 data.
C     *==========================================================*
C     *==========================================================*

C     !USES:
      IMPLICIT NONE

C     == Global data ==
#include "SIZE.h"
#include "EEPARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     sumPhi :: Result of sum.
C     myThid :: My thread id.
      Real*8 adsumPhi
      INTEGER myThid
CEOP

C     !LOCAL VARIABLES:
C     == Local variables ==

      CALL GLOBAL_SUM_R8( adsumPhi, myThid )

      RETURN
      END

#include "SEAICE_OPTIONS.h"
#ifdef ALLOW_AUTODIFF
# include "AUTODIFF_OPTIONS.h"
#endif
#ifndef SEAICE_LSRBNEW
C     Define this option below for an alternative discretization of
C     d/dx[ (zeta-eta) dV/dy] and d/dy[ (zeta-eta) dU/dx]
# undef SEAICE_TEST
#endif

CStartOfInterface
      SUBROUTINE lsr( ilcall, myThid )
C     *==========================================================*
C     | SUBROUTINE  lsr                                          |
C     | o Solve ice momentum equation with an LSR dynamics solver|
C     |   (see Zhang and Hibler,   JGR, 102, 8691-8702, 1997     |
C     |    and Zhang and Rothrock, MWR, 131,  845- 861, 2003)    |
C     |   Written by Jinlun Zhang, PSC/UW, Feb-2001              |
C     |                     zhang@apl.washington.edu             |
C     *==========================================================*
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "SEAICE_SIZE.h"
#include "SEAICE_PARAMS.h"
#include "SEAICE_GRID.h"
#include "SEAICE.h"

#ifdef ALLOW_AUTODIFF_TAMC
# include "tamc.h"
#endif

C     === Routine arguments ===
C     myThid - Thread no. that called this routine.
      INTEGER ilcall
      INTEGER myThid
CEndOfInterface

#ifdef SEAICE_BGRID_DYNAMICS

C     === Local variables ===
C     i,j,bi,bj - Loop counters

      INTEGER i, j, m, bi, bj, j1, j2, im, jm
      INTEGER ICOUNT1, ICOUNT2

      _RL WFAU, WFAV, WFAU1, WFAV1, WFAU2, WFAV2
      _RL AA3, S1, S2, S1A, S2A

      _RL e11loc, e22loc, e12loc

      _RL COSWAT
      _RS SINWAT
      _RL ECM2, DELT1, DELT2
      _RL TEMPVAR

C     diagonals of coefficient matrices
      _RL AU   (1:sNx,1:sNy,nSx,nSy)
      _RL BU   (1:sNx,1:sNy,nSx,nSy)
      _RL CU   (1:sNx,1:sNy,nSx,nSy)
      _RL AV   (1:sNx,1:sNy,nSx,nSy)
      _RL BV   (1:sNx,1:sNy,nSx,nSy)
      _RL CV   (1:sNx,1:sNy,nSx,nSy)

C     coefficients for lateral points, u(j+/-1)
      _RL uRt1(1:sNx,1:sNy,nSx,nSy)
      _RL uRt2(1:sNx,1:sNy,nSx,nSy)
C     coefficients for lateral points, v(i+/-1)
      _RL vRt1(1:sNx,1:sNy,nSx,nSy)
      _RL vRt2(1:sNx,1:sNy,nSx,nSy)
C     RHS
      _RL rhsU (1:sNx,1:sNy,nSx,nSy)
      _RL rhsV (1:sNx,1:sNy,nSx,nSy)
C     symmetric and anti-symmetric drag coefficients
      _RL DRAGS      (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL DRAGA      (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
#ifdef SEAICE_LSRBNEW
      LOGICAL doIterate4u, doIterate4v
      CHARACTER*(MAX_LEN_MBUF) msgBuf
C     coefficients of ice velocities in coefficient matrix
C     for both U and V-equation
C     XX: double derivative in X
C     YY: double derivative in Y
C     XM: metric term with derivative in X
C     YM: metric term with derivative in Y
      _RL UXX  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL UYY  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL UXM  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL UYM  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL VXX  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL VYY  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL VXM  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL VYM  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
C     abbreviations
      _RL etaU (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL zetaU(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL etaV (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL zetaV(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
C     contribution of sigma on righ hand side
      _RL sig11(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL sig22(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL sig12(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL sig21(1-OLx:sNx+OLx,1-OLy:sNy+OLy)

C     auxillary fields
      _RL CUU  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL CVV  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL URT  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL VRT  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
#else
      _RL URT(1-OLx:sNx+OLx), CUU(1-OLx:sNx+OLx)
      _RL VRT(1-OLy:sNy+OLy), CVV(1-OLy:sNy+OLy)

      _RL etaPlusZeta (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL zetaMinusEta(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL ETAMEAN  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL ZETAMEAN (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)

      _RL dVdx     (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL dVdy     (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL dUdx     (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL dUdy     (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
#ifdef SEAICE_TEST
      _RL uz     (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL vz     (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
#endif

      INTEGER phexit

      _RL  AA1, AA2, AA4, AA5, AA6

#endif /* SEAICE_LSRBNEW */

      _RL UERR

C     abbreviations
      _RL ucLoc(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL vcLoc(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL uTmp (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL vTmp (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)

C SET SOME VALUES
      WFAU1=0.95 _d 0
      WFAV1=0.95 _d 0
      WFAU2=ZERO
      WFAV2=ZERO

      S1A=0.80 _d 0
      S2A=0.80 _d 0
      WFAU=WFAU1
      WFAV=WFAV1

      ICOUNT1=SEAICElinearIterMax
      ICOUNT2=SEAICElinearIterMax

      ECM2= 1. _d 0/(SEAICE_eccen**2)

      SINWAT=SIN(SEAICE_waterTurnAngle*deg2rad)
      COSWAT=COS(SEAICE_waterTurnAngle*deg2rad)

      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        DO j=1-OLy,sNy+OLy-1
         DO i=1-OLx,sNx+OLx-1
          ucLoc(I,J,bi,bj) = 0.25 _d 0 * (
     &         +  uIceB(I+1,J,bi,bj) +  uIceB(I+1,J+1,bi,bj)
     &         +  uIceB(I  ,J,bi,bj) +  uIceB(I,  J+1,bi,bj) )
          vcLoc(I,J,bi,bj) = 0.25 _d 0 * (
     &         +  vIceB(I+1,J,bi,bj) +  vIceB(I+1,J+1,bi,bj)
     &         +  vIceB(I  ,J,bi,bj) +  vIceB(I,  J+1,bi,bj) )
         ENDDO
        ENDDO
        DO J=1-OLy,sNy+OLy-1
         DO I=1-OLy,sNx+OLy-1
          e11loc = 0.5 _d 0 * _recip_dxF(I,J,bi,bj) *
     &                (uIceB(I+1,J+1,bi,bj)+uIceB(I+1,J,bi,bj)
     &                -uIceB(I,  J+1,bi,bj)-uIceB(I,  J,bi,bj))
     &                + vcLoc(I,J,bi,bj) * k2AtC(I,J,bi,bj)
          e22loc = 0.5 _d 0 * _recip_dyF(I,J,bi,bj) *
     &                (vIceB(I+1,J+1,bi,bj)+vIceB(I,J+1,bi,bj)
     &                -vIceB(I+1,J,  bi,bj)-vIceB(I,J,  bi,bj))
     &                + ucLoc(I,J,bi,bj) * k1AtC(I,J,bi,bj)
          e12loc = 0.5 _d 0*(
     &           0.5 _d 0 * _recip_dyF(I,J,bi,bj) *
     &         (uIceB(I+1,J+1,bi,bj)+uIceB(I,J+1,bi,bj)
     &         -uIceB(I+1,J,  bi,bj)-uIceB(I,J,  bi,bj))
     &         + 0.5 _d 0 * _recip_dxF(I,J,bi,bj) *
     &         (vIceB(I+1,J+1,bi,bj)+vIceB(I+1,J,bi,bj)
     &         -vIceB(I,  J+1,bi,bj)-vIceB(I,  J,bi,bj))
     &         - vcLoc(I,J,bi,bj)*k1AtC(I,J,bi,bj)
     &         - ucLoc(I,J,bi,bj)*k2AtC(I,J,bi,bj) )
C  NOW EVALUATE VISCOSITIES
          DELT1=(e11loc**2+e22loc**2)*(1. _d 0+ECM2)
     &         +4.0 _d 0*ECM2*e12loc**2
     &         +2.0 _d 0*e11loc*e22loc*(1. _d 0-ECM2)
          IF ( DELT1 .LE. SEAICE_EPS_SQ ) THEN
             DELT2=SEAICE_EPS
          ELSE
             DELT2=SQRT(DELT1)
          ENDIF
          ZETA(I,J,bi,bj)  = 0.5 _d 0*PRESS0(I,J,bi,bj)/DELT2
C NOW PUT MIN AND MAX VISCOSITIES IN
          ZETA(I,J,bi,bj)  = MIN(SEAICE_zMax(I,J,bi,bj),ZETA(I,J,bi,bj))
          ZETA(I,J,bi,bj)  = MAX(SEAICE_zMin(I,J,bi,bj),ZETA(I,J,bi,bj))
C NOW SET VISCOSITIES TO ZERO AT HEFFMFLOW PTS
          ZETA(I,J,bi,bj)  = ZETA(I,J,bi,bj)*HEFFM(I,J,bi,bj)
          ETA(I,J,bi,bj)   = ECM2*ZETA(I,J,bi,bj)
          PRESS(I,J,bi,bj) = 2.0 _d 0*ZETA(I,J,bi,bj)*DELT2
         ENDDO
        ENDDO
        DO j=1,sNy
         DO i=1,sNx
C NOW SET UP NON-LINEAR WATER DRAG, FORCEX, FORCEY
          TEMPVAR=(uIce(I,J,bi,bj)-GWATX(I,J,bi,bj))**2
     &           +(vIce(I,J,bi,bj)-GWATY(I,J,bi,bj))**2
          IF ( YC(I,J,bi,bj) .LT. ZERO ) THEN
           DWATN(I,J,bi,bj) = SEAICE_waterDrag_south*SQRT(TEMPVAR)
          ELSE
           DWATN(I,J,bi,bj) = SEAICE_waterDrag*SQRT(TEMPVAR)
          ENDIF
          DWATN(I,J,bi,bj) = MAX(DWATN(I,J,bi,bj)*rhoConst,QUART)
C NOW SET UP SYMMETTRIC DRAG
          DRAGS(I,J,bi,bj)=DWATN(I,J,bi,bj)*COSWAT
C NOW SET UP ANTI SYMMETTRIC DRAG PLUS CORIOLIS
          DRAGA(I,J,bi,bj)=DWATN(I,J,bi,bj)
     &         *SIGN(SINWAT, _fCori(I,J,bi,bj))
     &         + AMASS(I,J,bi,bj) * _fCoriG(I,J,bi,bj)
C NOW ADD IN CURRENT FORCE
          FORCEX(I,J,bi,bj)=FORCEX0(I,J,bi,bj)+DWATN(I,J,bi,bj)
     &         *(COSWAT*GWATX(I,J,bi,bj)
     &         -SIGN(SINWAT, _fCori(I,J,bi,bj))*GWATY(I,J,bi,bj))
          FORCEY(I,J,bi,bj)=FORCEY0(I,J,bi,bj)+DWATN(I,J,bi,bj)
     &         *(SIGN(SINWAT, _fCori(I,J,bi,bj))*GWATX(I,J,bi,bj)
     &         +COSWAT*GWATY(I,J,bi,bj))
#ifndef SEAICE_LSRBNEW
C NOW CALCULATE PRESSURE FORCE AND ADD TO EXTERNAL FORCE
C     only for old code, in the new code the pressure force
C     is added to the rhs stress tensor terms
          FORCEX(I,J,bi,bj)=FORCEX(I,J,bi,bj)
     &          -QUART * _recip_dxV(I,J,bi,bj)
     &          *(PRESS(I,  J,bi,bj) + PRESS(I,  J-1,bi,bj)
     &          - PRESS(I-1,J,bi,bj) - PRESS(I-1,J-1,bi,bj))
          FORCEY(I,J,bi,bj)=FORCEY(I,J,bi,bj)
     &         -QUART * _recip_dyU(I,J,bi,bj)
     &          *(PRESS(I,J,  bi,bj) + PRESS(I-1,J,  bi,bj)
     &          - PRESS(I,J-1,bi,bj) - PRESS(I-1,J-1,bi,bj))
#endif /* not SEAICE_LSRBNEW */
          FORCEX(I,J,bi,bj)=FORCEX(I,J,bi,bj)
     &         +AMASS(I,J,bi,bj)/SEAICE_deltaTdyn*uIceNm1(I,J,bi,bj)
          FORCEY(I,J,bi,bj)=FORCEY(I,J,bi,bj)
     &         +AMASS(I,J,bi,bj)/SEAICE_deltaTdyn*vIceNm1(I,J,bi,bj)
          FORCEX(I,J,bi,bj)=FORCEX(I,J,bi,bj)*UVM(I,J,bi,bj)
          FORCEY(I,J,bi,bj)=FORCEY(I,J,bi,bj)*UVM(I,J,bi,bj)
         ENDDO
        ENDDO
       ENDDO
      ENDDO

#ifdef SEAICE_LSRBNEW
      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
C     coefficients for matrices
        DO j=1-OLy,sNy+OLy-1
         DO i=1-OLx+1,sNx+OLx-1
          etaU(I,J) = 0.5 _d 0 * (
     &         +  eta(I,J,bi,bj) +  eta(I-1,J,bi,bj) )
          zetaU(I,J)= 0.5 _d 0 *(
     &         + zeta(I,J,bi,bj) + zeta(I-1,J,bi,bj) )
         ENDDO
        ENDDO
        DO j=1-OLy+1,sNy+OLy-1
         DO i=1-OLx,sNx+OLx-1
          etaV(I,J) = 0.5 _d 0 * (
     &         +  eta(I,J,bi,bj) +  eta(I,J-1,bi,bj) )
          zetaV(I,J)= 0.5 _d 0 *(
     &         + zeta(I,J,bi,bj) + zeta(I,J-1,bi,bj) )
         ENDDO
        ENDDO
C     coefficients of uIce(I,J) and vIce(I,J) belonging to ...
        DO J=1,sNy
         DO I=0,sNx
C     ... d/dx (eta+zeta) d/dx u
          UXX(I,J) = _dyC(I,J,bi,bj) * (zetaV(I,J)+etaV(I,J))
     &         * _recip_dxG(I,J,bi,bj)
C     ... d/dx (zeta-eta) k1 u
          UXM(I,J) = _dyC(I,J,bi,bj) * (zetaV(I,J)-etaV(I,J))
     &         * k1AtV(I,J,bi,bj) * 0.5 _d 0
         ENDDO
        ENDDO
        DO J=0,sNy
         DO I=1,sNx
C     ... d/dy eta d/dy u
          UYY(I,J) = _dxC(I,J,bi,bj) * etaU(I,J)
     &         * _recip_dyG(I,J,bi,bj)
C     ... d/dy eta k2 u
          UYM(I,J) = _dxC(I,J,bi,bj) * etaU(I,J)
     &         * k2AtU(I,J,bi,bj) * 0.5 _d 0
         ENDDO
        ENDDO
        DO J=1,sNy
         DO I=0,sNx
C     ... d/dx eta dv/dx
          VXX(I,J) = _dyC(I,J,bi,bj) * etaV(I,J)
     &         * _recip_dxG(I,J,bi,bj)
C     ... d/dx eta k1 v
          VXM(I,J) = _dyC(I,J,bi,bj) * etaV(I,J)
     &         * k1AtV(I,J,bi,bj) * 0.5 _d 0
         ENDDO
        ENDDO
        DO J=0,sNy
         DO I=1,sNx
C     ... d/dy eta+zeta dv/dy
          VYY(I,J) = _dxC(I,J,bi,bj) * (zetaU(I,J)+etaU(I,J))
     &         * _recip_dyG(I,J,bi,bj)
C     ... d/dy (zeta-eta) k2 v
          VYM(I,J) = _dxC(I,J,bi,bj) * (zetaU(I,J)-etaU(I,J))
     &         * k2AtU(I,J,bi,bj) * 0.5 _d 0
         ENDDO
        ENDDO

C     assemble coefficient matrix of uIce
C     beware of sign convention: because this
C     is the left hand side we calculate -grad(sigma), but the coefficients
C     of U(I,J+/-1) are counted on the right hand side
        DO J=1,sNy
         DO I=1,sNx
C     coefficients for uIce(I-1,J)
          AU(I,J,bi,bj)= ( - UXX(I-1,J) + UXM(I-1,J) )
     &         * UVM(I,J,bi,bj)
C     coefficients for uIce(I+1,J)
          CU(I,J,bi,bj)= ( - UXX(I  ,J) - UXM(I  ,J) )
     &         * UVM(I,J,bi,bj)
C     coefficients for uIce(I,J)
          BU(I,J,bi,bj)=(ONE - UVM(I,J,bi,bj)) +
     &         ( UXX(I-1,J) + UXX(I,J) + UYY(I,J-1) + UYY(I,J)
     &         + UXM(I-1,J) - UXM(I,J) - UYM(I,J-1) + UYM(I,J)
     &         ) * UVM(I,J,bi,bj)
C     coefficients of uIce(I,J-1)
          uRt1(I,J,bi,bj)= UYY(I,J-1) + UYM(I,J-1)
C     coefficients of uIce(I,J+1)
          uRt2(I,J,bi,bj)= UYY(I,J  ) - UYM(I,J  )
         ENDDO
        ENDDO

C     now we need to normalize everything by the grid cell area
        DO J=1,sNy
         DO I=1,sNx
          AU(I,J,bi,bj)    = AU(I,J,bi,bj)    * recip_rAz(I,J,bi,bj)
          CU(I,J,bi,bj)    = CU(I,J,bi,bj)    * recip_rAz(I,J,bi,bj)
C     here we need add in the contribution from the time derivative
C     and the symmetric drag term; must be done after normalizing
          BU(I,J,bi,bj)    = BU(I,J,bi,bj)    * recip_rAz(I,J,bi,bj)
     &         + UVM(I,J,bi,bj) *
     &         ( AMASS(I,J,bi,bj)/SEAICE_deltaTdyn
     &         + DRAGS(I,J,bi,bj) )
          uRt1(I,J,bi,bj) = uRt1(I,J,bi,bj) * recip_rAz(I,J,bi,bj)
          uRt2(I,J,bi,bj) = uRt2(I,J,bi,bj) * recip_rAz(I,J,bi,bj)
         ENDDO
        ENDDO

C     assemble coefficient matrix of vIce
C     beware of sign convention: because this
C     is the left hand side we calculate -grad(sigma), but the coefficients
C     of V(I,J+/-1) are counted on the right hand side
        DO J=1,sNy
         DO I=1,sNx
C     coefficients for vIce(I,J-1)
          AV(I,J,bi,bj)=( - VYY(I,J-1) + VYM(I,J-1)
     &         ) * UVM(I,J,bi,bj)
C     coefficients for vIce(I,J+1)
          CV(I,J,bi,bj)=( - VYY(I,J  ) - VYM(I,J  )
     &         ) * UVM(I,J,bi,bj)
C     coefficients for vIce(I,J)
          BV(I,J,bi,bj)= (ONE - UVM(I,J,bi,bj)) +
     &         ( VXX(I,J) + VXX(I-1,J) + VYY(I,J) + VYY(I,J-1)
     &         + VXM(I,J) - VXM(I-1,J) - VYM(I,J) + VYM(I,J-1)
     &         ) * UVM(I,J,bi,bj)
C     coefficients for V(I-1,J)
          vRt1(I,J,bi,bj) = VXX(I-1,J) + VXM(I-1,J)
C     coefficients for V(I+1,J)
          vRt2(I,J,bi,bj) = VXX(I  ,J) - VXM(I  ,J)
         ENDDO
        ENDDO

C     now we need to normalize everything by the grid cell area
        DO J=1,sNy
         DO I=1,sNx
          AV(I,J,bi,bj)    = AV(I,J,bi,bj)    * recip_rAz(I,J,bi,bj)
          CV(I,J,bi,bj)    = CV(I,J,bi,bj)    * recip_rAz(I,J,bi,bj)
C     here we need add in the contribution from the time derivative
C     and the symmetric drag term; must be done after normalizing
          BV(I,J,bi,bj)    = BV(I,J,bi,bj)    * recip_rAz(I,J,bi,bj)
     &         + UVM(I,J,bi,bj) *
     &         ( AMASS(I,J,bi,bj)/SEAICE_deltaTdyn
     &         + DRAGS(I,J,bi,bj) )
          vRt1(I,J,bi,bj) = vRt1(I,J,bi,bj) * recip_rAz(I,J,bi,bj)
          vRt2(I,J,bi,bj) = vRt2(I,J,bi,bj) * recip_rAz(I,J,bi,bj)
         ENDDO
        ENDDO

C     set up right-hand sides
        DO j=1,sNy
         DO i=0,sNx
C     at V-point
          sig11(I,J) =
     &           (zetaV(I,J)-etaV(I,J))
     &         * (vcLoc(I,J,bi,bj)-vcLoc(I,J-1,bi,bj))
     &         * _recip_dyC(I,J,bi,bj)
     &         + (zetaV(I,J)+etaV(I,J))*k2atV(I,J,bi,bj)
     &         * 0.5 _d 0 * (vIceB(I,J,bi,bj)+vIceB(I+1,J,bi,bj))
     &         - 0.5 _d 0 * (PRESS(I,J,bi,bj)+PRESS(I,J-1,bi,bj))
          sig12(I,J) = etaV(I,J)
     &         * (ucLoc(I,J,bi,bj)-ucLoc(I,J-1,bi,bj))
     &         * _recip_dyC(I,J,bi,bj)
     &         - etaV(I,J) * k2AtV(I,J,bi,bj)
     &         * 0.5 _d 0 * (uIceB(I,J,bi,bj)+uIceB(I+1,J,bi,bj))
         ENDDO
        ENDDO
        DO j=0,sNy
         DO i=1,sNx
C     at U-point
          sig22(I,J) =
     &           (zetaU(I,J)-etaU(I,J))
     &         * (ucLoc(I,J,bi,bj)-ucLoc(I-1,J,bi,bj))
     &         * _recip_dxC(I,J,bi,bj)
     &         + (zetaU(I,J)+etaU(I,J))*k2atU(I,J,bi,bj)
     &         * 0.5 _d 0 * (uIceB(I,J,bi,bj)+uIceB(I,J+1,bi,bj))
     &         - 0.5 _d 0 * (PRESS(I,J,bi,bj)+PRESS(I-1,J,bi,bj))
          sig21(I,J) = etaU(I,J)
     &         * (vcLoc(I,J,bi,bj)-vcLoc(I-1,J,bi,bj))
     &         * _recip_dxC(I,J,bi,bj)
     &         - etaU(I,J) * k1AtU(I,J,bi,bj)
     &         * 0.5 _d 0 * (vIceB(I,J,bi,bj)+vIceB(I,J+1,bi,bj))
         ENDDO
        ENDDO
        DO j=1,sNy
         DO i=1,sNx
          rhsU(I,J,bi,bj) =   DRAGA(I,J,bi,bj)*vIceB(I,J,bi,bj)
     &         +FORCEX(I,J,bi,bj)
     &         + ( _dyC(I,  J,  bi,bj) * sig11(I,  J  )
     &           - _dyC(I-1,J,  bi,bj) * sig11(I-1,J  )
     &           + _dxC(I,  J,  bi,bj) * sig21(I,  J  )
     &           - _dxC(I,  J-1,bi,bj) * sig21(I,  J-1) )
     &         * recip_rAz(I,J,bi,bj) * UVM(I,J,bi,bj)
          rhsV(I,J,bi,bj) = - DRAGA(I,J,bi,bj)*uIceB(I,J,bi,bj)
     &         +FORCEY(I,J,bi,bj)
     &         + ( _dyC(I,  J,  bi,bj) * sig12(I,  J  )
     &           - _dyC(I-1,J,  bi,bj) * sig12(I-1,J  )
     &           + _dxC(I,  J,  bi,bj) * sig22(I,  J  )
     &           - _dxC(I,  J-1,bi,bj) * sig22(I,  J-1) )
     &         * recip_rAz(I,J,bi,bj) * UVM(I,J,bi,bj)
         ENDDO
        ENDDO
C     bi/bj-loops
       ENDDO
      ENDDO

C NOW DO ITERATION

      doIterate4u = .TRUE.
      doIterate4v = .TRUE.

C ITERATION START -----------------------------------------------------

      DO m = 1, SEAICElinearIterMax
       IF ( doIterate4u .OR. doIterate4v ) THEN

        IF ( useCubedSphereExchange ) THEN
          doIterate4u = .TRUE.
          doIterate4v = .TRUE.
        ENDIF

        DO bj=myByLo(myThid),myByHi(myThid)
         DO bi=myBxLo(myThid),myBxHi(myThid)

C-jmc: get less TAF warnings when always (no if doIterate) saving uIce,vIce:
C     save uIce prior to iteration, NOW SET U(3)=U(1)
          DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
            uTmp(I,J,bi,bj)=uIce(I,J,bi,bj)
           ENDDO
          ENDDO
C     save vIce prior to iteration, NOW SET V(3)=V(1)
          DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
            vTmp(I,J,bi,bj)=vIce(I,J,bi,bj)
           ENDDO
          ENDDO

          IF ( doIterate4u ) THEN
C Solve for uIce :
           DO J=1,sNy
            DO I=1,sNx
             AA3 = ZERO
             IF (I.EQ.1)   AA3 = AA3 - AU(I,J,bi,bj)*uIce(I-1,J,bi,bj)
             IF (I.EQ.sNx) AA3 = AA3 - CU(I,J,bi,bj)*uIce(I+1,J,bi,bj)

             URT(I,J)=rhsU(I,J,bi,bj)
     &            + AA3
#ifdef SEAICE_VECTORIZE_LSR
     &            + uRt1(I,J,bi,bj)*uTmp(I,J-1,bi,bj)
     &            + uRt2(I,J,bi,bj)*uTmp(I,J+1,bi,bj)
#else
     &            + uRt1(I,J,bi,bj)*uIce(I,J-1,bi,bj)
     &            + uRt2(I,J,bi,bj)*uIce(I,J+1,bi,bj)
#endif /* SEAICE_VECTORIZE_LSR */
             URT(I,J)=URT(I,J)* UVM(I,J,bi,bj)
            ENDDO

            DO I=1,sNx
             CUU(I,J)=CU(I,J,bi,bj)
            ENDDO
            CUU(1,J)=CUU(1,J)/BU(1,J,bi,bj)
            URT(1,J)=URT(1,J)/BU(1,J,bi,bj)
#ifdef SEAICE_VECTORIZE_LSR
           ENDDO
C     start a new loop with reversed order to support automatic vectorization
           DO I=2,sNx
            IM=I-1
            DO J=1,sNy
#else /* do not SEAICE_VECTORIZE_LSR */
            DO I=2,sNx
             IM=I-1
#endif /* SEAICE_VECTORIZE_LSR */
             CUU(I,J)=CUU(I,J)/(BU(I,J,bi,bj)-AU(I,J,bi,bj)*CUU(IM,J))
             URT(I,J)=(URT(I,J)-AU(I,J,bi,bj)*URT(IM,J))
     &           /(BU(I,J,bi,bj)-AU(I,J,bi,bj)*CUU(IM,J))
            ENDDO
#ifdef SEAICE_VECTORIZE_LSR
           ENDDO
C     go back to original order
           DO J=1,sNy
#endif /* SEAICE_VECTORIZE_LSR */
            DO I=1,sNx-1
             J1=sNx-I
             J2=J1+1
             URT(J1,J)=URT(J1,J)-CUU(J1,J)*URT(J2,J)
            ENDDO
            DO I=1,sNx
             uIce(I,J,bi,bj)=uTmp(I,J,bi,bj)
     &           +WFAU*(URT(I,J)-uTmp(I,J,bi,bj))
            ENDDO
           ENDDO
C--   end doIterate4u
          ENDIF

          IF ( doIterate4v ) THEN
C Solve for vIce
           DO I=1,sNx
            DO J=1,sNy
             AA3 = ZERO
             IF (J.EQ.1)   AA3 = AA3 - AV(I,J,bi,bj)*vIce(I,J-1,bi,bj)
             IF (J.EQ.sNy) AA3 = AA3 - CV(I,J,bi,bj)*vIce(I,J+1,bi,bj)

             VRT(I,J)=rhsV(I,J,bi,bj)
     &            + AA3
#ifdef SEAICE_VECTORIZE_LSR
     &            + vRt1(I,J,bi,bj)*vTmp(I-1,J,bi,bj)
     &            + vRt2(I,J,bi,bj)*vTmp(I+1,J,bi,bj)
#else
     &            + vRt1(I,J,bi,bj)*vIce(I-1,J,bi,bj)
     &            + vRt2(I,J,bi,bj)*vIce(I+1,J,bi,bj)
#endif /* SEAICE_VECTORIZE_LSR */
             VRT(I,J)=VRT(I,J)* UVM(I,J,bi,bj)
            ENDDO

            DO J=1,sNy
             CVV(I,J)=CV(I,J,bi,bj)
            ENDDO
            CVV(I,1)=CVV(I,1)/BV(I,1,bi,bj)
            VRT(I,1)=VRT(I,1)/BV(I,1,bi,bj)
            DO J=2,sNy
             JM=J-1
             CVV(I,J)=CVV(I,J)/(BV(I,J,bi,bj)-AV(I,J,bi,bj)*CVV(I,JM))
             VRT(I,J)=(VRT(I,J)-AV(I,J,bi,bj)*VRT(I,JM))
     &            /(BV(I,J,bi,bj)-AV(I,J,bi,bj)*CVV(I,JM))
            ENDDO
            DO J=1,sNy-1
             J1=sNy-J
             J2=J1+1
             VRT(I,J1)=VRT(I,J1)-CVV(I,J1)*VRT(I,J2)
            ENDDO
            DO J=1,sNy
             vIce(I,J,bi,bj)=vTmp(I,J,bi,bj)
     &           +WFAV*(VRT(I,J)-vTmp(I,J,bi,bj))
            ENDDO
           ENDDO
C--   end doIterate4v
          ENDIF

C     end bi,bj-loops
         ENDDO
        ENDDO

        IF ( doIterate4u.AND.MOD(m,SOLV_NCHECK).EQ.0) THEN
         S1=ZERO
         DO bj=myByLo(myThid),myByHi(myThid)
          DO bi=myBxLo(myThid),myBxHi(myThid)
           DO J=1,sNy
            DO I=1,sNx
             UERR=(uIce(I,J,bi,bj)-uTmp(I,J,bi,bj))
     &               * UVM(I,J,bi,bj)
             S1=MAX(ABS(UERR),S1)
            ENDDO
           ENDDO
          ENDDO
         ENDDO
         _GLOBAL_MAX_RL( S1, myThid )
c        WRITE(standardMessageUnit,'(A,2I6,1P4E16.9)')
c    &   ' U iters,error,WF = ',ilcall,M,S1,S1A,WFAU
C SAFEGUARD AGAINST BAD FORCING ETC
         IF(m.GT.1.AND.S1.GT.S1A) WFAU=WFAU2
         S1A=S1
         IF(S1.LT.LSR_ERROR) THEN
          ICOUNT1=m
          doIterate4u = .FALSE.
         ENDIF
        ENDIF

        IF ( doIterate4v.AND.MOD(m,SOLV_NCHECK).EQ.0) THEN
         S2=ZERO
         DO bj=myByLo(myThid),myByHi(myThid)
          DO bi=myBxLo(myThid),myBxHi(myThid)
           DO J=1,sNy
            DO I=1,sNx
             UERR=(vIce(I,J,bi,bj)-vTmp(I,J,bi,bj))
     &               * UVM(I,J,bi,bj)
             S2=MAX(ABS(UERR),S2)
            ENDDO
           ENDDO
          ENDDO
         ENDDO
         _GLOBAL_MAX_RL( S2, myThid )
C SAFEGUARD AGAINST BAD FORCING ETC
         IF(m.GT.1.AND.S2.GT.S2A) WFAV=WFAV2
         S2A=S2
         IF(S2.LT.LSR_ERROR) THEN
          ICOUNT2=m
          doIterate4v = .FALSE.
         ENDIF
        ENDIF

        CALL EXCH_UV_XY_RL( uIce, vIce,.TRUE.,myThid)

C--    end doIterate4u or doIterate4v
       ENDIF
      ENDDO
C ITERATION END -----------------------------------------------------
#ifdef ALLOW_DEBUG
      IF ( debugLevel .GE. debLevD ) THEN
        WRITE(msgBuf,'(A,I3,A)')
     &        'Uice post iter (SEAICE_LSR', MOD(ilcall,1000), ')'
        CALL DEBUG_STATS_RL( 1, uIce, msgBuf, myThid )
        WRITE(msgBuf,'(A,I3,A)')
     &        'Vice post iter (SEAICE_LSR', MOD(ilcall,1000), ')'
        CALL DEBUG_STATS_RL( 1, vIce, msgBuf, myThid )
      ENDIF
#endif /* ALLOW_DEBUG */
      IF ( doIterate4u .OR. doIterate4v ) THEN
        WRITE(msgBuf,'(2A,I10,A,I4,A)') '** WARNING ** SEAICE_LSR ',
     &    '(it=', -9999, ',', ilcall,') did not converge :'
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
        WRITE(msgBuf,'(2(A,I6,0PF6.3,1PE14.6))')
     &      ' nIt,wFU,dU=', ICOUNT1, WFAU, S1,
     &    ' ; nIt,wFV,dV=', ICOUNT2, WFAV, S2
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
      ENDIF

#else /* SEAICE_LSRBNEW */
C SOLVE FOR UICE

#ifdef ALLOW_AUTODIFF_TAMC
cph That is an important one! Note, that
cph * lsr is called twice, thus the icall index
cph * this storing is still outside the iteration loop
CADJ STORE uice = comlev1_dynsol,
CADJ &            key = ikey_dynamics + (ilcall-1)*nchklev_1
CADJ STORE vice = comlev1_dynsol,
CADJ &            key = ikey_dynamics + (ilcall-1)*nchklev_1
#endif /* ALLOW_AUTODIFF_TAMC */

      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          etaPlusZeta(I,J,bi,bj) = ETA(I,J,bi,bj)+ZETA(I,J,bi,bj)
          zetaMinusEta(I,J,bi,bj) = ZETA(I,J,bi,bj)-ETA(I,J,bi,bj)
         ENDDO
        ENDDO
        DO j=1-OLy+1,sNy+OLy
         DO i=1-OLx+1,sNx+OLx
          ETAMEAN(I,J,bi,bj) =QUART*(
     &          ETA(I,J-1,bi,bj) + ETA(I-1,J-1,bi,bj)
     &         +ETA(I,J  ,bi,bj) + ETA(I-1,J  ,bi,bj))
          ZETAMEAN(I,J,bi,bj)=QUART*(
     &          ZETA(I,J-1,bi,bj) + ZETA(I-1,J-1,bi,bj)
     &         +ZETA(I,J  ,bi,bj) + ZETA(I-1,J  ,bi,bj))
         ENDDO
        ENDDO
       ENDDO
      ENDDO

      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)

        DO J=1,sNy
         DO I=1,sNx
          AA1=( etaPlusZeta(I  ,J-1,bi,bj) * _recip_dxF(I  ,J-1,bi,bj)
     &         +etaPlusZeta(I  ,J  ,bi,bj) * _recip_dxF(I  ,J  ,bi,bj)
     &         )*0.5 _d 0 * _recip_dxV(I,J,bi,bj) * UVM(I,J,bi,bj)
          AA2=( etaPlusZeta(I-1,J-1,bi,bj) * _recip_dxF(I-1,J-1,bi,bj)
     &         +etaPlusZeta(I-1,J  ,bi,bj) * _recip_dxF(I-1,J  ,bi,bj)
     &         )*0.5 _d 0 * _recip_dxV(I,J,bi,bj) * UVM(I,J,bi,bj)
          AA3=  0.5 _d 0 *(ETA(I-1,J  ,bi,bj)+ETA(I,J  ,bi,bj))
          AA4=  0.5 _d 0 *(ETA(I-1,J-1,bi,bj)+ETA(I,J-1,bi,bj))
          AA5= -(AA3-AA4) * _tanPhiAtV(I,J,bi,bj)
     &         * _recip_dyU(I,J,bi,bj)*recip_rSphere
          AA6=TWO*ETAMEAN(I,J,bi,bj) *recip_rSphere*recip_rSphere
     &          * _tanPhiAtV(I,J,bi,bj)  * _tanPhiAtV(I,J,bi,bj)
          AU(I,J,bi,bj)=-AA2
          CU(I,J,bi,bj)=-AA1
          BU(I,J,bi,bj)=(ONE-UVM(I,J,bi,bj))
     &         - AU(I,J,bi,bj) - CU(I,J,bi,bj)
     &         + ((AA3+AA4)*_recip_dyU(I,J,bi,bj)*_recip_dyU(I,J,bi,bj)
     &           + AA5 + AA6
     &           + AMASS(I,J,bi,bj)/SEAICE_deltaTdyn
     &           + DRAGS(I,J,bi,bj)
     &           )*UVM(I,J,bi,bj)
         END DO
        END DO

        DO J=1,sNy
         AU(1,J,bi,bj)=ZERO
         CU(sNx,J,bi,bj)=ZERO
         CU(1,J,bi,bj)=CU(1,J,bi,bj)/BU(1,J,bi,bj)
        END DO

C     now set up right-hand side
        DO J=1-OLy,sNy+OLy-1
         DO I=1-OLx,sNx+OLx-1
          dVdy(I,J) = 0.5 _d 0 * (
     &         ( vIceB(I+1,J+1,bi,bj) - vIceB(I+1,J  ,bi,bj) )
     &         * _recip_dyG(I+1,J,bi,bj)
     &         +(vIceB(I  ,J+1,bi,bj) - vIceB(I  ,J  ,bi,bj) )
     &         * _recip_dyG(I,  J,bi,bj) )
          dVdx(I,J) = 0.5 _d 0 * (
     &         ( vIceB(I+1,J+1,bi,bj) - vIceB(I  ,J+1,bi,bj) )
     &         * _recip_dxG(I,J+1,bi,bj)
     &         +(vIceB(I+1,J  ,bi,bj) - vIceB(I  ,J  ,bi,bj) )
     &         * _recip_dxG(I,J,  bi,bj) )
         ENDDO
        ENDDO
#ifdef SEAICE_TEST
        DO j=1-OLy,sNy+OLy-1
         DO i=1-OLx,sNx+OLx-1
          vz(i,j) = quart * (
     &         vIceB(i,j,bi,bj) + vIceB(i+1,j,bi,bj) )
          vz(i,j)= vz(i,j) + quart * (
     &         vIceB(i,j+1,bi,bj) + vIceB(i+1,j+1,bi,bj) )
         ENDDO
        ENDDO
#endif
        DO J=1,sNy
         DO I=1,sNx
          rhsU(I,J,bi,bj)=DRAGA(I,J,bi,bj)*vIceB(I,J,bi,bj)
     &         +FORCEX(I,J,bi,bj)
#ifdef SEAICE_TEST
     &        + ( 0.5 _d 0 *
     &         (zetaMinusEta(i,j,bi,bj)+zetaMinusEta(i,j-1,bi,bj))
     &         *(vz(i,j)-vz(i,j-1)) * _recip_dyC(i,j,bi,bj)
     &          - 0.5 _d 0 *
     &         (zetaMinusEta(i-1,j,bi,bj)+zetaMinusEta(i-1,j-1,bi,bj))
     &         *(vz(i-1,j)-vz(i-1,j-1)) * _recip_dyC(i-1,j,bi,bj)
     &         ) * _recip_dxV(i,j,bi,bj)
#else
     &         + ( zetaMinusEta(I  ,J  ,bi,bj) * dVdy(I  ,J  )
     &           + zetaMinusEta(I  ,J-1,bi,bj) * dVdy(I  ,J-1)
     &           - zetaMinusEta(I-1,J  ,bi,bj) * dVdy(I-1,J  )
     &           - zetaMinusEta(I-1,J-1,bi,bj) * dVdy(I-1,J-1)
     &         )* 0.5 _d 0 * _recip_dxV(I,J,bi,bj)
#endif
     &
     &         + ( ETA         (I  ,J  ,bi,bj) * dVdx(I  ,J  )
     &           + ETA         (I-1,J  ,bi,bj) * dVdx(I-1,J  )
     &           - ETA         (I  ,J-1,bi,bj) * dVdx(I  ,J-1)
     &           - ETA         (I-1,J-1,bi,bj) * dVdx(I-1,J-1)
     &         ) * 0.5 _d 0 * _recip_dyU(I,J,bi,bj)
     &
     &        -(etaPlusZeta(I  ,J  ,bi,bj)+etaPlusZeta(I  ,J-1,bi,bj)
     &         -etaPlusZeta(I-1,J-1,bi,bj)-etaPlusZeta(I-1,J  ,bi,bj))
     &         * vIceB(I,J,bi,bj)
     &            * _tanPhiAtV(I,J,bi,bj)
     &         * 0.5 _d 0 * _recip_dxV(I,J,bi,bj)*recip_rSphere
     &
     &         -(ETAMEAN(I,J,bi,bj)+ZETAMEAN(I,J,bi,bj))
     &         *(vIceB(I+1,J,bi,bj) - vIceB(I-1,J,bi,bj))
     &            * _tanPhiAtV(I,J,bi,bj)
     &         * 1.0 _d 0 /( _dxG(I,J,bi,bj) + _dxG(I-1,J,bi,bj) )
     &         *recip_rSphere
     &
     &         -ETAMEAN(I,J,bi,bj)
     &         *(vIceB(I+1,J,bi,bj) - vIceB(I-1,J,bi,bj))
     &            *TWO* _tanPhiAtV(I,J,bi,bj)
     &         * 1.0 _d 0 /( _dxG(I,J,bi,bj) + _dxG(I-1,J,bi,bj) )
     &         *recip_rSphere

          URT1(I,J,bi,bj)=
     &         0.5 _d 0 * (ETA(I-1,J-1,bi,bj)+ETA(I,J-1,bi,bj))
     &         * _recip_dyU(I,J,bi,bj) * _recip_dyU(I,J,bi,bj)
     &         -     ETAMEAN(I,J,bi,bj) * _tanPhiAtV(I,J-1,bi,bj)
     &          * 0.5 _d 0 * _recip_dyU(I,J,bi,bj)*recip_rSphere
     &         + TWO*ETAMEAN(I,J,bi,bj) * _tanPhiAtV(I,J,bi,bj)
     &          * 0.5 _d 0 * _recip_dyU(I,J,bi,bj)*recip_rSphere
          URT2(I,J,bi,bj)=
     &         0.5 _d 0 * (ETA(I-1,J,bi,bj)+ETA(I,J,bi,bj))
     &         * _recip_dyU(I,J,bi,bj) * _recip_dyU(I,J,bi,bj)
     &         +     ETAMEAN(I,J,bi,bj) * _tanPhiAtV(I,J+1,bi,bj)
     &          * 0.5 _d 0 * _recip_dyU(I,J,bi,bj)*recip_rSphere
     &         - TWO*ETAMEAN(I,J,bi,bj) * _tanPhiAtV(I,J,bi,bj)
     &          * 0.5 _d 0 * _recip_dyU(I,J,bi,bj)*recip_rSphere
         END DO
        END DO

       ENDDO
      ENDDO

C NOW DO ITERATION

cph--- iteration starts here
cph--- need to kick out goto
      phexit = -1

C ITERATION START -----------------------------------------------------
#ifdef ALLOW_AUTODIFF_TAMC
CADJ LOOP = iteration uice
#endif /* ALLOW_AUTODIFF_TAMC */
      DO M=1, SEAICElinearIterMax
      IF ( phexit .EQ. -1 ) THEN

      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
C NOW SET U(3)=U(1)
        DO J=1,sNy
         DO I=1,sNx
          UTMP(I,J,bi,bj)=UICE(I,J,bi,bj)
         END DO
        END DO

        DO J=1,sNy
         DO I=1,sNx
          IF(I.EQ.1) THEN
           AA2=(etaPlusZeta(I-1,J-1,bi,bj) * _recip_dxF(I-1,J-1,bi,bj)
     &         +etaPlusZeta(I-1,J  ,bi,bj) * _recip_dxF(I-1,J  ,bi,bj)
     &          )*0.5 _d 0 * _recip_dxV(I,J,bi,bj)
           AA3=AA2*UICE(I-1,J,bi,bj)*UVM(I,J,bi,bj)
          ELSE IF(I.EQ.sNx) THEN
           AA1=(etaPlusZeta(I  ,J-1,bi,bj) * _recip_dxF(I  ,J-1,bi,bj)
     &         +etaPlusZeta(I  ,J  ,bi,bj) * _recip_dxF(I  ,J  ,bi,bj)
     &          )*0.5 _d 0 * _recip_dxV(I,J,bi,bj)
           AA3=AA1*UICE(I+1,J,bi,bj)*UVM(I,J,bi,bj)
          ELSE
           AA3=ZERO
          END IF
          URT(I)=rhsU(I,J,bi,bj)+AA3
     &          +URT1(I,J,bi,bj)*UICE(I,J-1,bi,bj)
     &          +URT2(I,J,bi,bj)*UICE(I,J+1,bi,bj)
          URT(I)=URT(I)*UVM(I,J,bi,bj)
         END DO

         DO I=1,sNx
          CUU(I)=CU(I,J,bi,bj)
         END DO
         URT(1)=URT(1)/BU(1,J,bi,bj)
         DO I=2,sNx
          IM=I-1
          CUU(I)=CUU(I)/(BU(I,J,bi,bj)-AU(I,J,bi,bj)*CUU(IM))
          URT(I)=(URT(I)-AU(I,J,bi,bj)*URT(IM))
     &          /(BU(I,J,bi,bj)-AU(I,J,bi,bj)*CUU(IM))
         END DO
         DO I=1,sNx-1
          J1=sNx-I
          J2=J1+1
          URT(J1)=URT(J1)-CUU(J1)*URT(J2)
         END DO
         DO I=1,sNx
          UICE(I,J,bi,bj)=UTMP(I,J,bi,bj)
     &        +WFAU*(URT(I)-UTMP(I,J,bi,bj))
         END DO

        END DO

       ENDDO
      ENDDO

      IF(MOD(M,SOLV_NCHECK).EQ.0) THEN
       S1=ZERO
       DO bj=myByLo(myThid),myByHi(myThid)
        DO bi=myBxLo(myThid),myBxHi(myThid)
         DO J=1,sNy
          DO I=1,sNx
           UERR=(UICE(I,J,bi,bj)-UTMP(I,J,bi,bj))
     &             *UVM(I,J,bi,bj)
           S1=MAX(ABS(UERR),S1)
          END DO
         END DO
        ENDDO
       ENDDO
       _GLOBAL_MAX_RL( S1, myThid )
C SAFEGUARD AGAINST BAD FORCING ETC
       IF(M.GT.1.AND.S1.GT.S1A) WFAU=WFAU2
       S1A=S1
       IF(S1.LT.LSR_ERROR) THEN
        ICOUNT1=M
        phexit = 1
       END IF
      END IF
      _EXCH_XY_RL( UICE, myThid )

      ENDIF
      ENDDO
C ITERATION END -----------------------------------------------------

      IF ( debugLevel .GE. debLevC ) THEN
       _BEGIN_MASTER( myThid )
        write(*,'(A,I6,1P2E22.14)')' U lsr iters, error = ',ICOUNT1,S1
       _END_MASTER( myThid )
      ENDIF

C NOW FOR VICE
      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)

        DO J=1,sNy
         DO I=1,sNx
          AA1=0.5 _d 0 * _recip_dyU(I,J,bi,bj) * _recip_dyU(I,J,bi,bj)
     &         * (etaPlusZeta(I-1,J  ,bi,bj) + etaPlusZeta(I,J  ,bi,bj))
          AA2=0.5 _d 0 * _recip_dyU(I,J,bi,bj) * _recip_dyU(I,J,bi,bj)
     &         * (etaPlusZeta(I-1,J-1,bi,bj) + etaPlusZeta(I,J-1,bi,bj))
          AA3= (ETA(I  ,J-1,bi,bj) * _recip_dxV(I,J,bi,bj)
     &         +ETA(I  ,J  ,bi,bj) * _recip_dxV(I,J,bi,bj)
     &         )* 0.5 _d 0 * _recip_dxV(I,J,bi,bj)
          AA4= (ETA(I-1,J-1,bi,bj)+ETA(I-1,J,bi,bj))*0.5 _d 0
     &          *_recip_dxV(I,J,bi,bj) * _recip_dxV(I,J,bi,bj)
          AA5=(zetaMinusEta(I-1,J  ,bi,bj) + zetaMinusEta(I,J  ,bi,bj)
     &        -zetaMinusEta(I-1,J-1,bi,bj) - zetaMinusEta(I,J-1,bi,bj)
     &          )* _tanPhiAtV(I,J,bi,bj)
     &         * 0.5 _d 0 * _recip_dyU(I,J,bi,bj)*recip_rSphere

          AA6=TWO*ETAMEAN(I,J,bi,bj) * recip_rSphere*recip_rSphere
     &         * _tanPhiAtV(I,J,bi,bj) * _tanPhiAtV(I,J,bi,bj)

         AV(I,J,bi,bj)=(
     &         - AA2
     &         - (ZETAMEAN(I,J,bi,bj)-ETAMEAN(I,J,bi,bj))
     &          * _tanPhiAtV(I,J-1,bi,bj)
     &          * 0.5 _d 0 * _recip_dyU(I,J,bi,bj)*recip_rSphere
     &         -ETAMEAN(I,J,bi,bj)*TWO* _tanPhiAtV(I,J,bi,bj)
     &          * 0.5 _d 0 * _recip_dyU(I,J,bi,bj)*recip_rSphere
     &         )*UVM(I,J,bi,bj)
         CV(I,J,bi,bj)=(
     &         -AA1
     &        +(ZETAMEAN(I,J,bi,bj)-ETAMEAN(I,J,bi,bj))
     &         * _tanPhiAtV(I,J+1,bi,bj)
     &         * 0.5 _d 0 * _recip_dyU(I,J,bi,bj)*recip_rSphere
     &        +ETAMEAN(I,J,bi,bj)*TWO* _tanPhiAtV(I,J,bi,bj)
     &         * 0.5 _d 0 * _recip_dyU(I,J,bi,bj)*recip_rSphere
     &        )*UVM(I,J,bi,bj)
          BV(I,J,bi,bj)= (ONE-UVM(I,J,bi,bj))
     &        +( (AA1+AA2) + (AA3+AA4)  + AA5 + AA6
     &        +AMASS(I,J,bi,bj)/SEAICE_deltaTdyn+DRAGS(I,J,bi,bj))
     &        *UVM(I,J,bi,bj)
         END DO
        END DO

        DO I=1,sNx
         AV(I,1,bi,bj)=ZERO
         CV(I,sNy,bi,bj)=ZERO
         CV(I,1,bi,bj)=CV(I,1,bi,bj)/BV(I,1,bi,bj)
        END DO

C     now set up right-hand-side
        DO J=1-OLy,sNy+OLy-1
         DO I=1-OLx,sNx+OLx-1
          dUdx(I,J) = 0.5 _d 0 * (
     &         ( uIceB(I+1,J+1,bi,bj) - uIceB(I ,J+1,bi,bj) )
     &         * _recip_dxG(I,J+1,bi,bj)
     &         +(uIceB(I+1,J  ,bi,bj) - uIceB(I ,J  ,bi,bj) )
     &         * _recip_dxG(I,J  ,bi,bj) )
          dUdy(I,J) = 0.5 _d 0 * (
     &          ( uIceB(I+1,J+1,bi,bj) - uIceB(I+1,J  ,bi,bj) )
     &         * _recip_dyG(I+1,J,bi,bj)
     &          +(uIceB(I  ,J+1,bi,bj) - uIceB(I  ,J  ,bi,bj) )
     &         * _recip_dyG(I,  J,bi,bj) )
         ENDDO
        ENDDO
#ifdef SEAICE_TEST
        DO j=1-OLy,sNy+OLy-1
         DO i=1-OLx,sNx+OLx-1
          uz(i,j) = quart * (
     &         uIceB(i,j,bi,bj) + uIceB(i+1,j,bi,bj) )
          uz(i,j)= uz(i,j) + quart * (
     &         uIceB(i,j+1,bi,bj) + uIceB(i+1,j+1,bi,bj) )
         ENDDO
        ENDDO
#endif
        DO J=1,sNy
         DO I=1,sNx
           rhsV(I,J,bi,bj)=-DRAGA(I,J,bi,bj)*uIceB(I,J,bi,bj)
     &        +FORCEY(I,J,bi,bj)
     &
#ifdef SEAICE_TEST
     &        + ( 0.5 _d 0 *
     &         (zetaMinusEta(i,j,bi,bj)+zetaMinusEta(i-1,j,bi,bj))
     &         *(uz(i,j)-uz(i-1,j)) * _recip_dxC(i,j,bi,bj)
     &          - 0.5 _d 0 *
     &         (zetaMinusEta(i,j-1,bi,bj)+zetaMinusEta(i-1,j-1,bi,bj))
     &         *(uz(i,j-1)-uz(i-1,j-1)) * _recip_dxC(i,j-1,bi,bj)
     &         ) * _recip_dyU(i,j,bi,bj)
#else
     &         + ( zetaMinusEta(I  ,J  ,bi,bj) * dUdx(I  ,J  )
     &           + zetaMinusEta(I-1,J  ,bi,bj) * dUdx(I-1,J  )
     &           - zetaMinusEta(I  ,J-1,bi,bj) * dUdx(I  ,J-1)
     &           - zetaMinusEta(I-1,J-1,bi,bj) * dUdx(I-1,J-1)
     &         )* 0.5 _d 0 * _recip_dyU(I,J,bi,bj)
#endif
     &
     &        + ( ETA          (I  ,J  ,bi,bj) * dUdy(I  ,J  )
     &         +  ETA          (I  ,J-1,bi,bj) * dUdy(I  ,J-1)
     &         -  ETA          (I-1,J  ,bi,bj) * dUdy(I-1,J  )
     &         -  ETA          (I-1,J-1,bi,bj) * dUdy(I-1,J-1)
     &         )*0.5 _d 0* _recip_dxV(I,J,bi,bj)
     &
     &        +(ETA(I  ,J  ,bi,bj) + ETA(I  ,J-1,bi,bj)
     &         -ETA(I-1,J-1,bi,bj) - ETA(I-1,J  ,bi,bj))
     &         * uIceB(I,J,bi,bj)
     &         * _tanPhiAtV(I,J,bi,bj)
     &         * 0.5 _d 0 * _recip_dxV(I,J,bi,bj)*recip_rSphere
     &        +ETAMEAN(I,J,bi,bj) * _tanPhiAtV(I,J,bi,bj)
     &         *(uIceB(I+1,J,bi,bj)-uIceB(I-1,J,bi,bj))
     &         * 0.5 _d 0 * _recip_dxV(I,J,bi,bj)*recip_rSphere
     &
     &        +ETAMEAN(I,J,bi,bj)*TWO  * _tanPhiAtV(I,J,bi,bj)
     &        *(uIceB(I+1,J,bi,bj)-uIceB(I-1,J,bi,bj))
     &         * 1. _d 0 /( _dxG(I,J,bi,bj) + _dxG(I-1,J,bi,bj))
     &         *recip_rSphere
          VRT1(I,J,bi,bj)= 0.5 _d 0 * (
     &           ETA(I-1,J-1,bi,bj) * _recip_dxV(I,J,bi,bj)
     &          +ETA(I-1,J  ,bi,bj) * _recip_dxV(I,J,bi,bj)
     &          ) * _recip_dxV(I,J,bi,bj)
          VRT2(I,J,bi,bj)= 0.5 _d 0 * (
     &          ETA(I  ,J-1,bi,bj) * _recip_dxV(I,J,bi,bj)
     &         +ETA(I  ,J  ,bi,bj) * _recip_dxV(I,J,bi,bj)
     &         ) * _recip_dxV(I,J,bi,bj)

         END DO
        END DO

       ENDDO
      ENDDO

C NOW DO ITERATION

cph--- iteration starts here
cph--- need to kick out goto
      phexit = -1

C ITERATION START -----------------------------------------------------
#ifdef ALLOW_AUTODIFF_TAMC
CADJ LOOP = iteration vice
#endif /* ALLOW_AUTODIFF_TAMC */
      DO M=1, SEAICElinearIterMax
      IF ( phexit .EQ. -1 ) THEN

C NOW SET U(3)=U(1)
      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)

        DO J=1,sNy
         DO I=1,sNx
          VTMP(I,J,bi,bj)=VICE(I,J,bi,bj)
         END DO
        END DO

        DO I=1,sNx
         DO J=1,sNy
           IF(J.EQ.1) THEN
            AA2= _recip_dyU(I,J,bi,bj) * _recip_dyU(I,J,bi,bj)
     &           * 0.5 _d 0 *(
     &           etaPlusZeta(I-1,J-1,bi,bj) + etaPlusZeta(I,J-1,bi,bj)
     &           )
              AA3=( AA2
     &         +( ZETAMEAN(I,J,bi,bj)-ETAMEAN(I,J,bi,bj) )
     &         * _tanPhiAtV(I,J-1,bi,bj)
     &         * 0.5 _d 0 * _recip_dyU(I,J,bi,bj)*recip_rSphere
     &         + ETAMEAN(I,J,bi,bj)*TWO* _tanPhiAtV(I,J,bi,bj)
     &         * 0.5 _d 0 * _recip_dyU(I,J,bi,bj)*recip_rSphere )
     &         *VICE(I,J-1,bi,bj)*UVM(I,J,bi,bj)
           ELSE IF(J.EQ.sNy) THEN
            AA1= _recip_dyU(I,J,bi,bj) * _recip_dyU(I,J,bi,bj)
     &           * 0.5 _d 0 * (
     &           etaPlusZeta(I-1,J,bi,bj) + etaPlusZeta(I,J,bi,bj)
     &            )
            AA3=( AA1
     &         -( ZETAMEAN(I,J,bi,bj)-ETAMEAN(I,J,bi,bj))
     &         * _tanPhiAtV(I,J+1,bi,bj)
     &         * 0.5 _d 0 * _recip_dyU(I,J,bi,bj)*recip_rSphere
     &         - ETAMEAN(I,J,bi,bj)*TWO* _tanPhiAtV(I,J,bi,bj)
     &         * 0.5 _d 0 * _recip_dyU(I,J,bi,bj)*recip_rSphere )
     &         *VICE(I,J+1,bi,bj)*UVM(I,J,bi,bj)
           ELSE
            AA3=ZERO
           END IF

          VRT(J)=rhsV(I,J,bi,bj)+AA3+VRT1(I,J,bi,bj)*VICE(I-1,J,bi,bj)
     &                       +VRT2(I,J,bi,bj)*VICE(I+1,J,bi,bj)
          VRT(J)=VRT(J)*UVM(I,J,bi,bj)
         END DO

         DO J=1,sNy
          CVV(J)=CV(I,J,bi,bj)
         END DO
         VRT(1)=VRT(1)/BV(I,1,bi,bj)
         DO J=2,sNy
          JM=J-1
          CVV(J)=CVV(J)/(BV(I,J,bi,bj)-AV(I,J,bi,bj)*CVV(JM))
          VRT(J)=(VRT(J)-AV(I,J,bi,bj)*VRT(JM))
     &          /(BV(I,J,bi,bj)-AV(I,J,bi,bj)*CVV(JM))
         END DO
         DO J=1,sNy-1
          J1=sNy-J
          J2=J1+1
          VRT(J1)=VRT(J1)-CVV(J1)*VRT(J2)
         END DO
         DO J=1,sNy
          VICE(I,J,bi,bj)=VTMP(I,J,bi,bj)
     &        +WFAV*(VRT(J)-VTMP(I,J,bi,bj))
         END DO
        ENDDO

       ENDDO
      ENDDO

      IF(MOD(M,SOLV_NCHECK).EQ.0) THEN
       S2=ZERO
       DO bj=myByLo(myThid),myByHi(myThid)
        DO bi=myBxLo(myThid),myBxHi(myThid)
         DO J=1,sNy
          DO I=1,sNx
           UERR=(VICE(I,J,bi,bj)-VTMP(I,J,bi,bj))
     &             *UVM(I,J,bi,bj)
           S2=MAX(ABS(UERR),S2)
          END DO
         END DO
        ENDDO
       ENDDO
       _GLOBAL_MAX_RL( S2, myThid )
C SAFEGUARD AGAINST BAD FORCING ETC
       IF(M.GT.1.AND.S2.GT.S2A) WFAV=WFAV2
       S2A=S2
       IF(S2.LT.LSR_ERROR) THEN
        ICOUNT2=M
        phexit = 1
       END IF
      END IF

      _EXCH_XY_RL( VICE, myThid )

      ENDIF
      ENDDO
C ITERATION END -----------------------------------------------------

      IF ( debugLevel .GE. debLevC ) THEN
       _BEGIN_MASTER( myThid )
        write(*,'(A,I6,1P2E22.14)')' V lsr iters, error = ',ICOUNT2,S2
       _END_MASTER( myThid )
      ENDIF

#endif /* SEAICE_LSRBNEW */

C NOW END
C NOW MAKE COROLIS TERM IMPLICIT
      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        DO J=1-OLy,sNy+OLy
         DO I=1-OLx,sNx+OLx
          UICE(I,J,bi,bj)=UICE(I,J,bi,bj)*UVM(I,J,bi,bj)
          VICE(I,J,bi,bj)=VICE(I,J,bi,bj)*UVM(I,J,bi,bj)
         END DO
        END DO
       ENDDO
      ENDDO

#endif /* SEAICE_BGRID_DYNAMICS */

      RETURN
      END

#include "ATM_PHYS_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 0
C !ROUTINE: ATM_PHYS_INIT_VARIA

C !INTERFACE:
      SUBROUTINE ATM_PHYS_INIT_VARIA( myThid )

C     !DESCRIPTION:
C     Initialize Atm_Phys variables

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "ATM_PHYS_PARAMS.h"
#include "ATM_PHYS_VARS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     myThid ::  my Thread Id number
      INTEGER myThid
CEOP

#ifdef ALLOW_ATM_PHYS

C     !LOCAL VARIABLES:
C     === Local variables ===
      INTEGER i,j,k,bi,bj

      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)

C--   Initialize arrays in common blocks :
C     3-dim.
        DO k=1,Nr
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           atmPhys_dT(i,j,k,bi,bj) = 0. _d 0
           atmPhys_dQ(i,j,k,bi,bj) = 0. _d 0
           atmPhys_dU(i,j,k,bi,bj) = 0. _d 0
           atmPhys_dV(i,j,k,bi,bj) = 0. _d 0
          ENDDO
         ENDDO
        ENDDO

C     2-dim.
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          atmPhys_SST(i,j,bi,bj) = 0. _d 0
         ENDDO
        ENDDO

C- end bi,bj loops
       ENDDO
      ENDDO

C--   Initialize Boundary conditions:
      IF ( atmPhys_SSTFile .NE. ' ' ) THEN
         CALL READ_FLD_XY_RL( atmPhys_SSTFile,' ',
     &                        atmPhys_SST, 0, myThid )
         CALL EXCH_XY_RL( atmPhys_SST, myThid )
      ENDIF

C--   Initialize ATM_PHYS State Variables:
      IF ( startTime.EQ.baseTime .AND. nIter0.EQ.0
     &                           .AND. pickupSuff.EQ.' ' ) THEN
C-    start new run from iter-zero:

      ELSE
C-    restart from a pickup:
         CALL ATM_PHYS_READ_PICKUP( nIter0, myThid )

C-    end start-from-iter-zero if/else block
      ENDIF

#endif /* ALLOW_ATM_PHYS */

      RETURN
      END

#include "SEAICE_OPTIONS.h"
#ifdef ALLOW_AUTODIFF
# include "AUTODIFF_OPTIONS.h"
#endif

CBOP
C     !ROUTINE: ADVECT
C     !INTERFACE:
      SUBROUTINE ADVECT(
     I                   UI, VI,
     U                   fld,
     O                   fldNm1,
     I                   iceMsk, myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R ADVECT
C     | o Calculate advection and diffusion
C     |   and update the input ice-field
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     == Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "SEAICE_SIZE.h"
#include "SEAICE_PARAMS.h"
#ifdef ALLOW_AUTODIFF_TAMC
# include "tamc.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     UI, VI     :: ice velocity components
C     fld        :: input and updated ice-field
C     fldNm1     :: copy of the input ice-field
C     iceMsk     :: Ocean/Land mask
C     myThid     :: my Thread Id. number
      _RL UI     (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL VI     (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL fld    (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL fldNm1 (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL iceMsk (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      INTEGER myThid
CEOP

C     !LOCAL VARIABLES:
C     == Local variables ==
C     i,j,k,bi,bj :: Loop counters
      INTEGER i, j, bi, bj
      INTEGER k
      _RL DELTT
      _RL DIFFA  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL tmpFld (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL afx    (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL afy    (1-OLx:sNx+OLx,1-OLy:sNy+OLy)

      DELTT=SEAICE_deltaTtherm
C     save fld from previous time step
      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          fldNm1(i,j,bi,bj) = fld(i,j,bi,bj)
         ENDDO
        ENDDO
       ENDDO
      ENDDO

#ifdef ALLOW_AUTODIFF_TAMC
CADJ INIT loctape_advect = COMMON, 2
#endif
      DO k=1,2
#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE fld = loctape_advect, key = k
#endif
C     Backward Euler correction step
        DO bj=myByLo(myThid),myByHi(myThid)
         DO bi=myBxLo(myThid),myBxHi(myThid)
          DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
            tmpFld(i,j,bi,bj)=HALF*(fld(i,j,bi,bj)
     &           +fldNm1(i,j,bi,bj))
           ENDDO
          ENDDO
         ENDDO
        ENDDO

#ifdef ALLOW_AUTODIFF
       DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
         afx(i,j) = 0. _d 0
         afy(i,j) = 0. _d 0
        ENDDO
       ENDDO
#endif /* ALLOW_AUTODIFF */

C NOW GO THROUGH STANDARD CONSERVATIVE ADVECTION
       IF ( .NOT. SEAICEuseFluxForm ) THEN
        DO bj=myByLo(myThid),myByHi(myThid)
         DO bi=myBxLo(myThid),myBxHi(myThid)
          DO j=0,sNy+1
           DO i=0,sNx+1
CML   This formulation gives the same result as the original code on a
CML   lat-lon-grid, but may not be accurate on irregular grids
            fld(i,j,bi,bj)=fldNm1(i,j,bi,bj)
     &           -DELTT*(
     &           ( tmpFld(i  ,j  ,bi,bj)+tmpFld(i+1,j  ,bi,bj))
     &           *   UI(i+1,j,  bi,bj) -
     &           ( tmpFld(i  ,j  ,bi,bj)+tmpFld(i-1,j  ,bi,bj))
     &           *   UI(i  ,j,  bi,bj) )*maskInC(i,j,bi,bj)
     &           *(HALF * _recip_dxF(i,j,bi,bj))
     &           -DELTT*(
     &           ( tmpFld(i  ,j  ,bi,bj)+tmpFld(i  ,j+1,bi,bj))
     &           *   VI(i  ,j+1,  bi,bj)
     &           * _dxG(i  ,j+1,bi,bj) -
     &           ( tmpFld(i  ,j  ,bi,bj)+tmpFld(i  ,j-1,bi,bj))
     &           *   VI(i  ,j  ,  bi,bj)
     &           * _dxG(i,j,bi,bj))*maskInC(i,j,bi,bj)
     &           *(HALF * _recip_dyF(i,j,bi,bj) * _recip_dxF(i,j,bi,bj))
           ENDDO
          ENDDO
         ENDDO
        ENDDO
       ELSE
C--   Use flux form for MITgcm compliance, unfortunately changes results
        DO bj=myByLo(myThid),myByHi(myThid)
         DO bi=myBxLo(myThid),myBxHi(myThid)
C--   first compute fluxes across cell faces
          DO j=1,sNy+1
           DO i=1,sNx+1
            afx(i,j) = _dyG(i,j,bi,bj) * UI(i,j,bi,bj)
     &           * 0.5 _d 0 * (tmpFld(i,j,bi,bj)+tmpFld(i-1,j,bi,bj))
            afy(i,j) = _dxG(i,j,bi,bj) * VI(i,j,bi,bj)
     &           * 0.5 _d 0 * (tmpFld(i,j,bi,bj)+tmpFld(i,j-1,bi,bj))
           ENDDO
          ENDDO
          DO j=1,sNy
           DO i=1,sNx
            fld(i,j,bi,bj)=fldNm1(i,j,bi,bj)
     &           -DELTT * (
     &             afx(i+1,j) - afx(i,j)
     &           + afy(i,j+1) - afy(i,j)
     &           )*recip_rA(i,j,bi,bj)*maskInC(i,j,bi,bj)
           ENDDO
          ENDDO
         ENDDO
        ENDDO
       ENDIF

       CALL EXCH_XY_RL( fld, myThid )

      ENDDO

      IF ( DIFF1.GT.0. _d 0 ) THEN
C NOW DO DIFFUSION

C     make a working copy of field from last time step
       DO bj=myByLo(myThid),myByHi(myThid)
        DO bi=myBxLo(myThid),myBxHi(myThid)
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           tmpFld(i,j,bi,bj) = fldNm1(i,j,bi,bj)
          ENDDO
         ENDDO
        ENDDO
       ENDDO

C NOW CALCULATE DIFFUSION COEF ROUGHLY
C  1rst pass: compute changes due to harmonic diffusion and add it to ice-field
       DO bj=myByLo(myThid),myByHi(myThid)
        DO bi=myBxLo(myThid),myBxHi(myThid)
          DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
            DIFFA(i,j,bi,bj) = MIN( _dxF(i,j,bi,bj), _dyF(i,j,bi,bj) )
           ENDDO
          ENDDO
        ENDDO
       ENDDO
C-     Compute laplacian of ice-field; return result in same array
       CALL DIFFUS( tmpFld, DIFFA, iceMsk, myThid )

       DO bj=myByLo(myThid),myByHi(myThid)
        DO bi=myBxLo(myThid),myBxHi(myThid)
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           fld(i,j,bi,bj) = ( fld(i,j,bi,bj)
     &                       +tmpFld(i,j,bi,bj)*DIFF1*DELTT
     &                      )*iceMsk(i,j,bi,bj)
          ENDDO
         ENDDO
        ENDDO
       ENDDO

c     IF ( useBiHarmonic ) THEN
C  2nd  pass: compute changes due to biharmonic diffusion and add it to ice-field
       _EXCH_XY_RL( tmpFld, myThid )
C     use some strange quadratic form for the second time around
       DO bj=myByLo(myThid),myByHi(myThid)
        DO bi=myBxLo(myThid),myBxHi(myThid)
          DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
#ifdef ALLOW_AUTODIFF_TAMC
C      to avoid recomputations when there was a k loop; not needed anymore
c           DIFFA(i,j,bi,bj) = MIN( _dxF(i,j,bi,bj), _dyF(i,j,bi,bj) )
#endif
            DIFFA(i,j,bi,bj) = - DIFFA(i,j,bi,bj)*DIFFA(i,j,bi,bj)
           ENDDO
          ENDDO
        ENDDO
       ENDDO
C-     Compute bilaplacian (laplacian of laplacian); return result in same array
       CALL DIFFUS( tmpFld, DIFFA, iceMsk, myThid )

       DO bj=myByLo(myThid),myByHi(myThid)
        DO bi=myBxLo(myThid),myBxHi(myThid)
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           fld(i,j,bi,bj) = ( fld(i,j,bi,bj)
     &                       +tmpFld(i,j,bi,bj)*DIFF1*DELTT
     &                      )*iceMsk(i,j,bi,bj)
          ENDDO
         ENDDO
        ENDDO
       ENDDO
C--   end biharmonic block
c     ENDIF

C--   end DIFF1 > 0 block
      ENDIF

      RETURN
      END

#include "STREAMICE_OPTIONS.h"
#ifdef ALLOW_AUTODIFF
# include "AUTODIFF_OPTIONS.h"
#endif

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

CBOP
      SUBROUTINE STREAMICE_ADVECT_THICKNESS ( myThid,myIter,time_step )

C     *============================================================*
C     | SUBROUTINE                                                 |
C     | o                                                          |
C     *============================================================*
C     |                                                            |
C     *============================================================*
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "GRID.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "STREAMICE.h"
#include "STREAMICE_ADV.h"
#ifdef ALLOW_AUTODIFF_TAMC
# include "tamc.h"
#endif
#ifdef ALLOW_SHELFICE
# include "SHELFICE.h"
#endif

      INTEGER myThid, myIter
      _RL time_step

#ifdef ALLOW_STREAMICE

      INTEGER i, j, bi, bj, Gi, Gj
      _RL uflux, vflux, max_icfl, loc_icfl
      _RL time_step_full, time_step_rem
      _RL sec_per_year, time_step_loc, MR, SMB, TMB, irho
      _RL bdot_depth, bdot_max
      _RL BCVALX(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL BCVALY(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RS BCMASKX(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RS BCMASKY(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL utrans(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL vtrans(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL h_after_uflux_SI(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL h_after_vflux_SI(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL hflux_x_SI(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL hflux_y_SI(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)

      CHARACTER*(MAX_LEN_MBUF) msgBuf

      CALL TIMER_START ('STREAMICE_ADVECT_THICKNESS',myThid)

      sec_per_year = 365.*86400.

      time_step_loc = time_step / sec_per_year
      time_step_full = time_step_loc
      time_step_rem = time_step_loc
      PRINT *, "time_step_loc ", time_step_loc

#ifdef ALLOW_AUTODIFF_TAMC
CADJ INIT loctape_stream_adv = COMMON, 1
CADJ STORE area_shelf_streamice = loctape_stream_adv, key = 1
CADJ STORE bdot_streamice       = loctape_stream_adv, key = 1
#endif

#ifdef ALLOW_OPENAD
      DO k=1,streamice_smooth_thick_adjoint
      CALL STREAMICE_SMOOTH_ADJOINT_FIELD (
     O            H_streamice,
     I            myThid)
      ENDDO
#endif

#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE streamice_hmask  = comlev1, key=ikey_dynamics
#endif
      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        DO j=1,sNy+1
         DO i=1,sNx+1

          H_streamice_prev(i,j,bi,bj) =
     &     H_streamice(i,j,bi,bj)

          hflux_x_SI (i,j,bi,bj) = 0. _d 0
          hflux_y_SI (i,j,bi,bj) = 0. _d 0

          IF (STREAMICE_hmask(i,j,bi,bj).eq.1.0) THEN
           h_after_uflux_SI(i,j,bi,bj) = 0. _d 0
           h_after_vflux_SI(i,j,bi,bj) = 0. _d 0
          ELSE
           h_after_uflux_SI(i,j,bi,bj) = H_streamice(i,j,bi,bj)
           h_after_vflux_SI(i,j,bi,bj) = H_streamice(i,j,bi,bj)
          ENDIF

          IF (STREAMICE_ufacemask(i,j,bi,bj).eq.3.0) THEN
           BCMASKX(i,j,bi,bj) = 3.0
           BCVALX(i,j,bi,bj) = h_ubdry_values_SI(i,j,bi,bj)
           IF (STREAMICE_vel_ext_cgrid) THEN
            utrans(i,j,bi,bj) = u_streamice_ext(i,j,bi,bj)
           ELSEIF (STREAMICE_vel_ext) THEN
            utrans(i,j,bi,bj) = .5 * (
     &       u_streamice_ext(i,j,bi,bj)+u_streamice_ext(i,j+1,bi,bj))
           ELSE
            utrans(i,j,bi,bj) = .5 * (
     &       u_streamice(i,j,bi,bj)+u_streamice(i,j+1,bi,bj))
           ENDIF
          ELSEIF (STREAMICE_ufacemask(i,j,bi,bj).eq.4.0) THEN
           IF (STREAMICE_hmask(i,j,bi,bj).eq.1.0) THEN
            uflux = u_flux_bdry_SI(i,j,bi,bj)
            BCMASKX(i,j,bi,bj) = 3.0
            BCVALX(i,j,bi,bj) = uflux
            utrans(i,j,bi,bj) = 1.0
           ELSEIF (STREAMICE_hmask(i-1,j,bi,bj).eq.1.0) THEN
            uflux = u_flux_bdry_SI(i,j,bi,bj)
            BCMASKX(i,j,bi,bj) = 3.0
            BCVALX(i,j,bi,bj) = uflux
            utrans(i,j,bi,bj) = -1.0
           ENDIF
          ELSEIF (.not.(
     &     STREAMICE_hmask(i,j,bi,bj).eq.1.0.OR.
     &     STREAMICE_hmask(i-1,j,bi,bj).eq.1.0)) THEN
           BCMASKX(i,j,bi,bj) = 0.0
           BCVALX(i,j,bi,bj) = 0. _d 0
           utrans(i,j,bi,bj) = 0. _d 0
          ELSE
           BCMASKX(i,j,bi,bj) = 0.0
           BCVALX(i,j,bi,bj) = 0. _d 0
           IF (STREAMICE_vel_ext_cgrid) THEN
            utrans(i,j,bi,bj) = u_streamice_ext(i,j,bi,bj)
           ELSEIF (STREAMICE_vel_ext) THEN
            utrans(i,j,bi,bj) = .5 * (
     &       u_streamice_ext(i,j,bi,bj)+u_streamice_ext(i,j+1,bi,bj))
           ELSE
            utrans(i,j,bi,bj) = .5 * (
     &       u_streamice(i,j,bi,bj)+u_streamice(i,j+1,bi,bj))
           ENDIF
          ENDIF

          IF (STREAMICE_vfacemask(i,j,bi,bj).eq.3.0) THEN
           BCMASKy(i,j,bi,bj) = 3.0
           BCVALy(i,j,bi,bj) = h_vbdry_values_SI(i,j,bi,bj)
           IF (STREAMICE_vel_ext_cgrid) THEN
            vtrans(i,j,bi,bj) = v_streamice_ext(i,j,bi,bj)
           ELSEIF (STREAMICE_vel_ext) THEN
            vtrans(i,j,bi,bj) = .5 * (
     &       v_streamice_ext(i,j,bi,bj)+v_streamice_ext(i+1,j,bi,bj))
           ELSE
            vtrans(i,j,bi,bj) = .5 * (
     &       v_streamice(i,j,bi,bj)+v_streamice(i+1,j,bi,bj))
           ENDIF
          ELSEIF (STREAMICE_vfacemask(i,j,bi,bj).eq.4.0) THEN
           IF (STREAMICE_hmask(i,j,bi,bj).eq.1.0) THEN
            vflux = v_flux_bdry_SI(i,j,bi,bj)
            BCMASKY(i,j,bi,bj) = 3.0
            BCVALY(i,j,bi,bj) = vflux
            vtrans(i,j,bi,bj) = 1.0
           ELSEIF (STREAMICE_hmask(i,j-1,bi,bj).eq.1.0) THEN
            vflux = v_flux_bdry_SI(i,j,bi,bj)
            BCMASKY(i,j,bi,bj) = 3.0
            BCVALY(i,j,bi,bj) = vflux
            vtrans(i,j,bi,bj) = -1.0
           ENDIF
          ELSEIF (.not.(
     &     STREAMICE_hmask(i,j,bi,bj).eq.1.0.OR.
     &     STREAMICE_hmask(i,j-1,bi,bj).eq.1.0)) THEN
           BCMASKY(i,j,bi,bj) = 0.0
           BCVALY(i,j,bi,bj) = 0. _d 0
           vtrans(i,j,bi,bj) = 0. _d 0
          ELSE
           BCMASKy(i,j,bi,bj) = 0.0
           BCVALy(i,j,bi,bj) = 0. _d 0
           IF (STREAMICE_vel_ext_cgrid) THEN
            vtrans(i,j,bi,bj) = v_streamice_ext(i,j,bi,bj)
           ELSEIF (STREAMICE_vel_ext) THEN
            vtrans(i,j,bi,bj) = .5 * (
     &       v_streamice_ext(i,j,bi,bj)+v_streamice_ext(i+1,j,bi,bj))
           ELSE
            vtrans(i,j,bi,bj) = .5 * (
     &       v_streamice(i,j,bi,bj)+v_streamice(i+1,j,bi,bj))
           ENDIF
          ENDIF

         ENDDO
        ENDDO
       ENDDO
      ENDDO

      _EXCH_XY_RL(utrans,myThid)
      _EXCH_XY_RL(vtrans,myThid)
      _EXCH_XY_RS(BCMASKx,myThid)
      _EXCH_XY_RS(BCMASKy,myThid)
      _EXCH_XY_RL(BCVALX,myThid)
      _EXCH_XY_RL(BCVALY,myThid)
      _EXCH_XY_RL(h_after_uflux_SI,myThid)
      _EXCH_XY_RL(h_after_vflux_SI,myThid)
      _EXCH_XY_RL(hflux_x_SI,myThid)
      _EXCH_XY_RL(hflux_y_SI,myThid)

#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE BCMASKx, BCMASKy= comlev1, key=ikey_dynamics
CADJ STORE BCVALX, BCVALY  = comlev1, key=ikey_dynamics
CADJ STORE utrans, vtrans  = comlev1, key=ikey_dynamics
CADJ STORE streamice_hmask = comlev1, key=ikey_dynamics
CADJ STORE H_streamice     = comlev1, key=ikey_dynamics
#endif

#ifndef ALLOW_AUTODIFF

      max_icfl = 1.e-20

      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        DO j=1,sNy
         DO i=1,sNx
          IF (streamice_hmask(i,j,bi,bj).eq.1.0) THEN
           loc_icfl=max(abs(utrans(i,j,bi,bj)),
     &                  abs(utrans(i+1,j,bi,bj))) / dxF(i,j,bi,bj)
           loc_icfl=max(loc_icfl,max(abs(vtrans(i,j,bi,bj)),
     &                  abs(vtrans(i,j+1,bi,bj))) / dyF(i,j,bi,bj))
           if (loc_icfl.gt.max_icfl) then
            max_icfl = loc_icfl
           ENDIF
          ENDIF
         ENDDO
        ENDDO
       ENDDO
      ENDDO

      CALL GLOBAL_MAX_R8 (max_icfl, myThid)

#endif /* ALLOW_AUTODIFF */

#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE streamice_hmask  = comlev1, key=ikey_dynamics
CADJ STORE H_streamice  = comlev1, key=ikey_dynamics
#endif

#ifndef ALLOW_AUTODIFF
      do while (time_step_rem .gt. 1.e-15)
       time_step_loc = min (
     &  streamice_cfl_factor / max_icfl,
     &  time_step_rem )
       if (time_step_loc .lt. time_step_full) then
        PRINT *, "TAKING PARTIAL TIME STEP", time_step_loc
       endif
#endif /* ALLOW_AUTODIFF */

      CALL STREAMICE_ADV_FLUX_FL_X ( myThid ,
     I   utrans ,
     I   H_streamice ,
     I   BCMASKX,
     I   BCVALX,
     O   hflux_x_SI,
     I   time_step_loc )

      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        DO j=1-3,sNy+3
         DO i=1,sNx
          Gi = (myXGlobalLo-1)+(bi-1)*sNx+i
          Gj = (myYGlobalLo-1)+(bj-1)*sNy+j
          IF (((Gj .ge. 1) .and. (Gj .le. Ny))
     &       .or.STREAMICE_NS_PERIODIC) THEN

          IF (STREAMICE_hmask(i,j,bi,bj).eq.1.0) THEN
           h_after_uflux_SI (i,j,bi,bj) = H_streamice(i,j,bi,bj) -
     &      (hflux_x_SI(i+1,j,bi,bj)*dyG(i+1,j,bi,bj) -
     &        hflux_x_SI(i,j,bi,bj)*dyG(i,j,bi,bj))
     &        * recip_rA (i,j,bi,bj) * time_step_loc
           IF ( h_after_uflux_SI (i,j,bi,bj).le.0.0) THEN
            PRINT *, "h neg after x", i,j,hflux_x_SI(i+1,j,bi,bj),
     &        hflux_x_SI(i,j,bi,bj)
           ENDIF
          ENDIF

          ENDIF
         ENDDO
        ENDDO
       ENDDO
      ENDDO

#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE h_after_uflux_SI = comlev1, key = ikey_dynamics
#endif

c      CALL STREAMICE_ADVECT_THICKNESS_Y ( myThid,
c     O   hflux_y_SI,
c     O   h_after_vflux_SI,
c     I   time_step_loc )

      CALL STREAMICE_ADV_FLUX_FL_Y ( myThid ,
     I   vtrans ,
     I   h_after_uflux_si ,
     I   BCMASKY,
     I   BCVALY,
     O   hflux_y_SI,
     I   time_step_loc )

      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        DO j=1,sNy
         DO i=1,sNx
          Gi = (myXGlobalLo-1)+(bi-1)*sNx+i
          Gj = (myYGlobalLo-1)+(bj-1)*sNy+j
          IF (((Gj .ge. 1) .and. (Gj .le. Ny))
     &       .or.STREAMICE_EW_PERIODIC) THEN

          IF (STREAMICE_hmask(i,j,bi,bj).eq.1.0) THEN
           h_after_vflux_SI (i,j,bi,bj) = h_after_uflux_SI(i,j,bi,bj) -
     &      (hflux_y_SI(i,j+1,bi,bj)*dxG(i,j+1,bi,bj) -
     &        hflux_y_SI(i,j,bi,bj)*dxG(i,j,bi,bj)) *
     &        recip_rA (i,j,bi,bj) * time_step_loc
           IF ( h_after_vflux_SI (i,j,bi,bj).le.0.0) THEN
            PRINT *, "h neg after y", i,j,hflux_y_SI(i,j+1,bi,bj),
     &        hflux_y_SI(i,j,bi,bj)
           ENDIF

          ENDIF
         ENDIF

         ENDDO
        ENDDO
       ENDDO
      ENDDO

      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        DO j=1,sNy
         DO i=1,sNx
          IF (STREAMICE_hmask(i,j,bi,bj).eq.1.0) THEN
           H_streamice (i,j,bi,bj) =
     &      h_after_vflux_SI (i,j,bi,bj)
          ENDIF
         ENDDO
        ENDDO
       ENDDO
      ENDDO

c NOTE: AT THIS POINT H IS NOT VALID ON OVERLAP!!!

      if (streamice_move_front) then
      CALL STREAMICE_ADV_FRONT (
     &  myThid, time_step_loc,
     &  hflux_x_SI, hflux_y_SI )
      endif
#ifdef ALLOW_AUTODIFF_TAMC
C     These make calling S/R STREAMICE_ADV_FRONT in
C     S/R STREAMICE_ADVECTION_THICKNESS_AD go away.
CADJ STORE H_streamice            = comlev1, key=ikey_dynamics
CADJ STORE streamice_hmask        = comlev1, key=ikey_dynamics
#endif

#ifdef ALLOW_STREAMICE_2DTRACER
      CALL STREAMICE_ADVECT_2DTRACER(
     &  myThid,
     &  myIter,
     &  time_step,
     &  uTrans,
     &  vTrans,
     &  BCMASKx,
     &  BCMASKy )
#endif

#ifndef ALLOW_AUTODIFF
      time_step_rem = time_step_rem - time_step_loc
      enddo
#endif /* ALLOW_AUTODIFF */

c NOW WE APPLY MELT RATES !!
c THIS MAY BE MOVED TO A SEPARATE SUBROUTINE
      irho = 1./streamice_density
      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        DO j=1,sNy
         DO i=1,sNx
          Gi = (myXGlobalLo-1)+(bi-1)*sNx+i
          Gj = (myYGlobalLo-1)+(bj-1)*sNy+j
#ifdef ALLOW_AUTODIFF
C     Interestingly, this helps avoiding 10 recomputation warnings;
C     hopefully it does not change results.
          MR = 0. _d 0
#endif
          IF (STREAMICE_hmask(i,j,bi,bj).eq.1.0 .or.
     &       STREAMICE_hmask(i,j,bi,bj).eq.2.0) THEN

           IF (STREAMICE_allow_cpl) THEN
#ifdef ALLOW_SHELFICE
            MR = -1. * (1.-float_frac_streamice(i,j,bi,bj)) *
     &        shelfIceFreshWaterFlux(i,j,bi,bj) * irho *
     &        sec_per_year

#else
            STOP 'SHELFICE IS NOT ENABLED'
#endif
           ELSE

              IF (STREAMICEBdotConfig.EQ.'FILE' ) THEN

               MR = (1.-float_frac_streamice(i,j,bi,bj)) *
     &             (BDOT_STREAMICE(i,j,bi,bj) +
     &              BDOT_pert(i,j,bi,bj))

              ELSEIF (STREAMICEBdotConfig.EQ.'PARAM') THEN

               bdot_depth =
     &            streamice_bdot_depth_maxmelt_v(i,j,bi,bj) +
     &            streamice_bdot_depth_maxmelt

               bdot_max =
     &           streamice_bdot_maxmelt_v(i,j,bi,bj) +
     &           streamice_bdot_maxmelt

               IF (base_el_streamice(i,j,bi,bj) .lt.
     &             streamice_bdot_depth_nomelt) THEN
                IF (base_el_streamice(i,j,bi,bj) .lt.
     &             bdot_depth) THEN
                 MR = ABS(bdot_max)**streamice_bdot_exp
                ELSE
                 MR = (ABS((streamice_bdot_depth_nomelt-
     &                 base_el_streamice(i,j,bi,bj)) /
     &                (streamice_bdot_depth_nomelt-
     &                 bdot_depth) *
     &                 bdot_max))**streamice_bdot_exp
                ENDIF
               ELSE
                 MR = 0.0
               ENDIF
               MR = (1.-float_frac_streamice(i,j,bi,bj)) *
     &             (MR + BDOT_pert(i,j,bi,bj))
               BDOT_STREAMICE(i,j,bi,bj) = MR
              ELSE
               MR = 0.
               BDOT_STREAMICE(i,j,bi,bj) = MR
              ENDIF

           ENDIF

           SMB = ADOT_STREAMICE(i,j,bi,bj)
           TMB = SMB - MR
           IF ((TMB.lt.0.0) .and.
     &         (MR * time_step_loc .gt.
     &          H_streamice (i,j,bi,bj))) THEN
                H_streamice (i,j,bi,bj) = 0. _d 0
                STREAMICE_hmask(i,j,bi,bj) = 0.0
               PRINT *, "GOT HERE melted away! ", i,j
           ELSE
               H_streamice (i,j,bi,bj) =
     &          H_streamice (i,j,bi,bj) + TMB * time_step_loc
           ENDIF

          ENDIF
         ENDDO
        ENDDO
       ENDDO
      ENDDO

      _EXCH_XY_RL(H_streamice,myThid)

      WRITE(msgBuf,'(A)') 'END STREAMICE_ADVECT_THICKNESS'
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                     SQUEEZE_RIGHT , 1)
      CALL TIMER_STOP ('STREAMICE_ADVECT_THICKNESS',myThid)

#endif
      RETURN
      END

#include "OBCS_OPTIONS.h"

      SUBROUTINE OBCS_CALC( futureTime, futureIter,
     &                      uVel, vVel, wVel, theta, salt,
     &                      myThid )
C     *==========================================================*
C     | SUBROUTINE OBCS_CALC
C     | o Calculate future boundary data at open boundaries
C     |   at time = futureTime
C     *==========================================================*
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#ifdef ALLOW_EXCH2
# include "W2_EXCH2_SIZE.h"
#endif /* ALLOW_EXCH2 */
#include "SET_GRID.h"
#include "GRID.h"
#include "OBCS_PARAMS.h"
#include "OBCS_GRID.h"
#include "OBCS_FIELDS.h"
#include "EOS.h"

C     == Routine arguments ==
      INTEGER futureIter
      _RL futureTime
      _RL uVel (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      _RL vVel (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      _RL wVel (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      _RL theta(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      _RL salt (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      INTEGER myThid

#ifdef ALLOW_OBCS

C     == Local variables ==
      INTEGER bi, bj
      INTEGER I, J ,K
      _RL obTimeScale,Uinflow,rampTime2
      _RL vertStructWst(Nr)
      _RL mz,strat,kx
      _RL tmpsum

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_ENTER('OBCS_CALC',myThid)
#endif

C Vertical mode number
      mz=1.0 _d 0
C Stratification
      strat = 1.0 _d -6 / (gravity*tAlpha)

C Create a vertical structure function with zero mean
      tmpsum=0.
      do K=1,Nr
       vertStructWst(K)=cos(mz*PI* (rC(K)/rF(Nr+1)) )
       tmpsum=tmpsum+vertStructWst(K)*drF(K)
      enddo
      tmpsum=tmpsum/rF(Nr+1)
      do K=1,Nr
       vertStructWst(K)=vertStructWst(K)-tmpsum
      enddo
c
      obTimeScale = 44567.0 _d 0
       kx=mz*2. _d 0*pi/400.0 _d 0
     &  *sqrt((2.0 _d 0*pi*2.0 _d 0*pi/(obTimeScale*obTimeScale)
     & - f0*f0)/(1.0 _d -6
     & - 2.0 _d 0*pi*2.0 _d 0*pi/(obTimeScale*obTimeScale)))
      Uinflow = 0.024 _d 0
C *NOTE* I have commented out the ramp function below
C just to speed things up. You will probably want to use it
C for smoother looking solutions.
      rampTime2 = 4. _d 0*44567.0 _d 0

      DO bj=myByLo(myThid),myByHi(myThid)
      DO bi=myBxLo(myThid),myBxHi(myThid)

C     Eastern OB
      IF (useOrlanskiEast) THEN
        CALL ORLANSKI_EAST(
     &          bi, bj, futureTime,
     &          uVel, vVel, wVel, theta, salt,
     &          myThid )
      ELSE
        DO K=1,Nr
          DO J=1-Oly,sNy+Oly
            OBEu(J,K,bi,bj)=0.
            OBEv(J,K,bi,bj)=0.
            OBEt(J,K,bi,bj)=tRef(K)
            OBEs(J,K,bi,bj)=sRef(K)
#ifdef ALLOW_NONHYDROSTATIC
            OBEw(J,K,bi,bj)=0.
#endif
          ENDDO
        ENDDO
      ENDIF

C     Western OB
      IF (useOrlanskiWest) THEN
        CALL ORLANSKI_WEST(
     &          bi, bj, futureTime,
     &          uVel, vVel, wVel, theta, salt,
     &          myThid )
      ELSE
        DO K=1,Nr
          DO J=1-Oly,sNy+Oly
          OBWu(J,K,bi,bj)=0. _d 0
     &       +Uinflow
     &       *vertStructWst(K)
     &       *sin(2. _d 0*PI*futureTime/obTimeScale)
c    &       *(exp(futureTime/rampTime2)
c    &   - exp(-futureTime/rampTime2))
c    &   /(exp(futureTime/rampTime2)
c    &  + exp(-futureTime/rampTime2))
     &   *cos(kx*(3. _d 0-2. _d 0-0.5 _d 0)*delX(1))
          OBWv(J,K,bi,bj)=0. _d 0
     &       +Uinflow
     &       *f0/(2.0 _d 0*PI/obTimeScale)
     &       *vertStructWst(K)
     &       *cos(2. _d 0*PI*futureTime/obTimeScale )
     & * (exp(futureTime/rampTime2)
     &   - exp(-futureTime/rampTime2))
     &   /(exp(futureTime/rampTime2)
     &  + exp(-futureTime/rampTime2))
          OBWt(J,K,bi,bj)=tRef(K)
     & + Uinflow*sin(mz*PI*(float(k)-0.5 _d 0)/float(Nr))
     & * sin(2.0 _d 0*PI*futureTime/obTimeScale)
     & *sqrt(strat/(tAlpha*gravity))
     & *sqrt(2.0 _d 0*PI/obTimeScale*2.0*PI/obTimeScale - f0*f0)
     & /(2.0 _d 0*PI/obTimeScale)
c    & * (exp(futureTime/rampTime2)
c    &   - exp(-futureTime/rampTime2))
c    &   /(exp(futureTime/rampTime2)
c    &  + exp(-futureTime/rampTime2))
#ifdef ALLOW_NONHYDROSTATIC
          OBWw(J,K,bi,bj)=-Uinflow
     & *sqrt(2.0 _d 0*PI/obTimeScale*2.0 _d 0*PI/obTimeScale - f0*f0)
     & /sqrt(strat*strat -
     &          2.0 _d 0*PI/obTimeScale*2.0 _d 0*PI/obTimeScale)
     & *sin(mz*PI*(float(k)-0.5 _d 0)/float(Nr))
     &       *cos(2. _d 0*PI*futureTime/obTimeScale)
c    &       *(exp(futureTime/rampTime2)
c    &   - exp(-futureTime/rampTime2))
c    &   /(exp(futureTime/rampTime2)
c    &  + exp(-futureTime/rampTime2))
#endif
          ENDDO
        ENDDO
      ENDIF

C         Northern OB, template for forcing
      IF (useOrlanskiNorth) THEN
        CALL ORLANSKI_NORTH(
     &          bi, bj, futureTime,
     &          uVel, vVel, wVel, theta, salt,
     &          myThid )
      ELSE
        DO K=1,Nr
          DO I=1-Olx,sNx+Olx
            OBNv(I,K,bi,bj)=0.
            OBNu(I,K,bi,bj)=0.
            OBNt(I,K,bi,bj)=tRef(K)
            OBNs(I,K,bi,bj)=sRef(K)
#ifdef ALLOW_NONHYDROSTATIC
            OBNw(I,K,bi,bj)=0.
#endif
          ENDDO
        ENDDO
      ENDIF

C         Southern OB, template for forcing
      IF (useOrlanskiSouth) THEN
        CALL ORLANSKI_SOUTH(
     &          bi, bj, futureTime,
     &          uVel, vVel, wVel, theta, salt,
     &          myThid )
      ELSE
        DO K=1,Nr
          DO I=1-Olx,sNx+Olx
            OBSu(I,K,bi,bj)=0.
            OBSv(I,K,bi,bj)=0.
            OBSt(I,K,bi,bj)=tRef(K)
            OBSs(I,K,bi,bj)=sRef(K)
#ifdef ALLOW_NONHYDROSTATIC
            OBSw(I,K,bi,bj)=0.
#endif
          ENDDO
        ENDDO
      ENDIF

C--   end bi,bj loops.
      ENDDO
      ENDDO

#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_LEAVE('OBCS_CALC',myThid)
#endif
#endif /* ALLOW_OBCS */

      RETURN
      END

#include "BLING_OPTIONS.h"

CBOP
      subroutine BLING_WRITE_PICKUP( permPickup,
     I                             suff, myTime, myIter, myThid )

C     =================================================================
C     | subroutine bling_write_pickup
C     | o Writes BLING arrays (needed for a restart) to a pickup file
C     =================================================================

      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "BLING_VARS.h"

C     === Routine arguments ===
C     permPickup :: write a permanent pickup
C     suff       :: suffix for pickup file (eg. ckptA or 0000000010)
C     myTime     :: Current time in simulation
C     myIter     :: Current iteration number in simulation
C     myThid     :: My Thread Id number
      LOGICAL permPickup
      CHARACTER*(*) suff
      _RL     myTime
      INTEGER myIter
      INTEGER myThid
CEOP

#ifdef ALLOW_BLING

C     == Local variables ==
      CHARACTER*(MAX_LEN_FNAM) fn
      INTEGER prec
      LOGICAL glf
      _RL     timList(1)
      INTEGER j
      INTEGER listDim, nWrFlds
      PARAMETER( listDim = 6 )
      CHARACTER*(8) wrFldList(listDim)
      CHARACTER*(MAX_LEN_MBUF) msgBuf

        prec = precFloat64

        WRITE(fn,'(A,A)') 'pickup_bling.',suff
        j = 0

C     Firstly, write 3-D fields as consecutive records,

C       record number < 0 : a hack not to write meta files now:
        j = j + 1
        CALL WRITE_REC_3D_RL( fn, prec, Nr, pH, -j, myIter, myThid )
        IF (j.LE.listDim) wrFldList(j) = 'BLG_pH3d'

        j = j + 1
        CALL WRITE_REC_3D_RL( fn, prec, Nr, irr_mem,
     &                        -j, myIter, myThid )
        IF (j.LE.listDim) wrFldList(j) = 'BLG_irrm'

        j = j + 1
        CALL WRITE_REC_3D_RL( fn, prec, Nr, chl, -j, myIter, myThid )
        IF (j.LE.listDim) wrFldList(j) = 'BLG_chl '

        j = j + 1
        CALL WRITE_REC_3D_RL( fn, prec, Nr, phyto_sm, -j, myIter,
     & myThid )
        IF (j.LE.listDim) wrFldList(j) = 'BLG_Psm '

        j = j + 1
        CALL WRITE_REC_3D_RL( fn, prec, Nr, phyto_lg, -j, myIter,
     & myThid )
        IF (j.LE.listDim) wrFldList(j) = 'BLG_Plg '

#ifndef USE_BLING_V1
        j = j + 1
        CALL WRITE_REC_3D_RL( fn, prec, Nr, phyto_diaz, -j, myIter,
     & myThid )
        IF (j.LE.listDim) wrFldList(j) = 'BLG_Pdia'
#endif

C--------------------------
        nWrFlds = j
        IF ( nWrFlds.GT.listDim ) THEN
          WRITE(msgBuf,'(2A,I5,A)') 'BLING_WRITE_PICKUP: ',
     &     'trying to write ',nWrFlds,' fields'
          CALL PRINT_ERROR( msgBuf, myThid )
          WRITE(msgBuf,'(2A,I5,A)') 'BLING_WRITE_PICKUP: ',
     &     'field-list dimension (listDim=',listDim,') too small'
          CALL PRINT_ERROR( msgBuf, myThid )
          STOP 'ABNORMAL END: S/R BLING_WRITE_PICKUP (list-size Pb)'
        ENDIF

#ifdef ALLOW_MDSIO
C     uses this specific S/R to write (with more informations) only meta
C     files
        j  = 1
        glf  = globalFiles
        timList(1) = myTime
        CALL MDS_WR_METAFILES( fn, prec, glf, .FALSE.,
     &                         0, 0, Nr, ' ',
     &                         nWrFlds, wrFldList,
     &                         1, timList, oneRL,
     &                         j, myIter, myThid )
#endif /* ALLOW_MDSIO */
C--------------------------

#endif /* ALLOW_BLING */

      RETURN
      END

#include "SHAP_FILT_OPTIONS.h"

CBOP
C     !ROUTINE: SHAP_FILT_READPARMS
C     !INTERFACE:
      SUBROUTINE SHAP_FILT_READPARMS( myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE SHAP_FILT_READPARMS
C     | o Routine to initialize Shapiro Filter parameters
C     *==========================================================*
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "SHAP_FILT.h"

C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
      INTEGER myThid

#ifdef ALLOW_SHAP_FILT

C     !LOCAL VARIABLES:
C     === Local variables ===
C     msgBuf     :: Informational/error message buffer
C     iUnit      :: Work variable for IO unit number
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      INTEGER iUnit
CEOP

      NAMELIST /SHAP_PARM01/
     &   Shap_funct, shap_filt_uvStar, shap_filt_TrStagg,
     &   Shap_alwaysExchUV, Shap_alwaysExchTr,
     &   nShapT,nShapS, nShapTrPhys, Shap_Trtau, Shap_TrLength,
     &   nShapUV, nShapUVPhys, Shap_uvtau, Shap_uvLength,
     &   Shap_noSlip, Shap_diagFreq

      IF ( .NOT.useSHAP_FILT ) THEN
C-    pkg SHAP_FILT is not used
        _BEGIN_MASTER(myThid)
C-    Track pkg activation status:
c        SHAPIsOn = .FALSE.
C     print a (weak) warning if data.shap is found
         CALL PACKAGES_UNUSED_MSG( 'useSHAP_FILT', ' ', 'shap' )
        _END_MASTER(myThid)
        RETURN
      ENDIF

C--   SHAP_FILT_READPARMS has been called so we know that
C     the package is active.
c     SHAPIsOn = .TRUE.

      _BEGIN_MASTER(myThid)

      WRITE(msgBuf,'(A)') ' SHAP_FILT_READPARMS: opening data.shap'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT , 1)

      CALL OPEN_COPY_DATA_FILE(
     I                          'data.shap', 'SHAP_FILT_READPARMS',
     O                          iUnit,
     I                          myThid )

C--   Default flags and values for Shapiro Filter
      Shap_funct = 2
      shap_filt_uvStar  = .TRUE.
      shap_filt_TrStagg = .TRUE.
      Shap_alwaysExchUV = .FALSE.
      Shap_alwaysExchTr = .FALSE.
      nShapT = 0
      nShapS = -1
      nShapUV = 0
      nShapTrPhys = 0
      nShapUVPhys = 0
      Shap_Trtau = dTtracerLev(1)
      Shap_TrLength = 0.
      Shap_uvtau = deltaTMom
      Shap_TrLength = 0.
      Shap_noSlip = 0.
      Shap_diagFreq = diagFreq

C--   Read parameters from open data file
      READ(UNIT=iUnit,NML=SHAP_PARM01)

      WRITE(msgBuf,'(A)')
     &   ' SHAP_FILT_READPARMS: finished reading data.shap'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT , 1)

C--   Close the open data file
#ifdef SINGLE_DISK_IO
      CLOSE(iUnit)
#else
      CLOSE(iUnit,STATUS='DELETE')
#endif /* SINGLE_DISK_IO */

C     for backward compatibility:
      IF (nShapS.EQ.-1) nShapS = nShapT

      IF (Shap_funct.EQ.20) THEN
C     use shap-funct S2 with nShap_Phys=nShap
C     to get exactly the same results as shap-funct S2G.
        nShapTrPhys = MAX(nShapT,nShapS)
        nShapUVPhys = nShapUV
      ENDIF

      IF ( Shap_funct.EQ.1 .OR. Shap_funct.EQ.4
     &     .OR. Shap_funct.EQ.21
     &   ) THEN
        Shap_alwaysExchUV = .TRUE.
      ENDIF
      IF ( Shap_funct.EQ.1 .OR. Shap_funct.EQ.4
     &   ) THEN
        Shap_alwaysExchTr = .TRUE.
      ENDIF

C- print out some kee parameters :
      CALL WRITE_0D_I( Shap_funct, INDEX_NONE,
     & 'Shap_funct =',
     & '   /* select Shapiro filter function */')
      CALL WRITE_0D_I( nShapT , INDEX_NONE,
     & 'nShapT =',
     & '   /* power of Shapiro filter for Temperat */')
      CALL WRITE_0D_I( nShapS , INDEX_NONE,
     & 'nShapS =',
     & '   /* power of Shapiro filter for Salinity */')
      CALL WRITE_0D_I( nShapUV, INDEX_NONE,
     & 'nShapUV =',
     & '   /* power of Shapiro filter for momentum */')

      CALL WRITE_0D_L( shap_filt_uvStar,  INDEX_NONE,
     & 'shap_filt_uvStar =',' /* apply filter before Press. Solver */')
      CALL WRITE_0D_L( shap_filt_TrStagg, INDEX_NONE,
     & 'shap_filt_TrStagg =',
     & ' /* filter T,S before calc PhiHyd (staggerTimeStep) */')
      CALL WRITE_0D_L( Shap_alwaysExchUV, INDEX_NONE,
     & 'Shap_alwaysExchUV =',' /* always exch(U,V)    nShapUV times*/')
      CALL WRITE_0D_L( Shap_alwaysExchTr, INDEX_NONE,
     & 'Shap_alwaysExchTr =',' /* always exch(Tracer) nShapTr times*/')

      IF (Shap_funct.EQ.2) THEN
       CALL WRITE_0D_I( nShapTrPhys, INDEX_NONE,
     & 'nShapTrPhys =',
     & '   /* power of physical-space filter (Tracer) */')
       CALL WRITE_0D_I( nShapUVPhys, INDEX_NONE,
     & 'nShapUVPhys =',
     & '   /* power of physical-space filter (Momentum) */')
      ENDIF

      CALL WRITE_0D_RL( Shap_Trtau, INDEX_NONE,
     & 'Shap_Trtau =',
     & '   /* time scale of Shapiro filter (Tracer) */')
      CALL WRITE_0D_RL( Shap_TrLength, INDEX_NONE,
     & 'Shap_TrLength =',
     & '   /* Length scale of Shapiro filter (Tracer) */')
      CALL WRITE_0D_RL( Shap_uvtau, INDEX_NONE,
     & 'Shap_uvtau =',
     & '   /* time scale of Shapiro filter (Momentum) */')
      CALL WRITE_0D_RL( Shap_uvLength, INDEX_NONE,
     & 'Shap_uvLength =',
     & '   /* Length scale of Shapiro filter (Momentum) */')
      CALL WRITE_0D_RL( Shap_noSlip, INDEX_NONE,
     & 'Shap_noSlip =',
     &  '  /* No-slip parameter (0=Free-slip ; 1=No-slip)*/')
      CALL WRITE_0D_RL( Shap_diagFreq, INDEX_NONE,
     & 'Shap_diagFreq =',
     & '   /* Frequency^-1 for diagnostic output (s)*/')

C--   Check the Options :
#ifndef USE_OLD_SHAPIRO_FILTERS
#ifdef NO_SLIP_SHAP
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
         WRITE(msgBuf,'(2A)') 'SHAP_FILT: CPP-option NO_SLIP_SHAP',
     &                        ' only in OLD_SHAPIRO S/R ;'
         CALL PRINT_ERROR( msgBuf , 1)
         WRITE(msgBuf,'(2A)') ' ==> use parameter Shap_noSlip=1. ',
     &                        '(in "data.shap") instead'
         CALL PRINT_ERROR( msgBuf , 1)
         STOP 'ABNORMAL END: S/R SHAP_FILT_READPARMS'
#endif
#endif

C--   Check the parameters :

      IF ( .NOT.shap_filt_uvStar ) THEN

C- Notes: applying the filter at the end of the time step (after SOLVE_FOR_P)
C    affects the barotropic flow divergence ; this might not be consistent
C    with some option of the code.

        IF ( rigidLid ) THEN
         WRITE(msgBuf,'(2A)') 'SHAP_FILT with rigidLid ',
     &                         'needs shap_filt_uvStar=.true.'
         CALL PRINT_ERROR( msgBuf , 1)
         STOP 'ABNORMAL END: S/R SHAP_FILT_READPARMS'
        ELSEIF ( .NOT.exactConserv ) THEN
         WRITE(msgBuf,'(2A)') 'S/R SHAP_FILT_READPARMS: WARNING <<< ',
     &    'applying Filter after SOLVE_FOR_P (shap_filt_uvStar=FALSE)'
         CALL PRINT_MESSAGE(msgBuf, errorMessageUnit, SQUEEZE_RIGHT,1)
         WRITE(msgBuf,'(2A)') 'S/R SHAP_FILT_READPARMS: WARNING <<< ',
     &    'requires to recompute Eta after ==> turn on exactConserv '
         CALL PRINT_MESSAGE(msgBuf, errorMessageUnit, SQUEEZE_RIGHT,1)
        ENDIF

      ENDIF

C-    Some Filters / options are not available on CS-grid:
      IF (useCubedSphereExchange) THEN
       IF ( Shap_funct.EQ.1 .OR. Shap_funct.EQ.4 ) THEN
         WRITE(msgBuf,'(2A,I3)') 'SHAP_FILT on CS-grid ',
     &           'does not work with Shap_funct=', Shap_funct
         CALL PRINT_ERROR( msgBuf , 1)
         STOP 'ABNORMAL END: S/R SHAP_FILT_READPARMS'
       ELSEIF ( Shap_funct.EQ.21 .AND. nShapUV.GT.0
     &                 .AND. nSx*nSy*nPx*nPy .NE. 6 ) THEN
         WRITE(msgBuf,'(2A)') 'SHAP_FILT on CS-grid:',
     &     ' multi-tiles / face not implemented with'
         CALL PRINT_ERROR( msgBuf , 1)
         WRITE(msgBuf,'(A,I3,A)') ' Shap_funct=', Shap_funct,
     &     ' ; => use instead Shap_funct=2 & nShap[]Phys=0'
         CALL PRINT_ERROR( msgBuf , 1)
         STOP 'ABNORMAL END: S/R SHAP_FILT_READPARMS'
       ENDIF
      ENDIF

      _END_MASTER(myThid)

C--   Everyone else must wait for the parameters to be loaded
      _BARRIER

#endif /* ALLOW_SHAP_FILT */
      RETURN
      END

#include "CPP_EEOPTIONS.h"

C--  File reset_halo.F: to fill-up halo region with constant value
C--   Contents
C--   o RESET_HALO_RL
C--   o RESET_HALO_RS

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

CBOP
C     !ROUTINE: RESET_HALO_RL
C     !INTERFACE:
      SUBROUTINE RESET_HALO_RL(
     U                          glFld,
     I                          fixVal, kSize, myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R RESET_HALO_RL
C     *==========================================================*
C     | o Reset to constant value the halo region of a global
C     |   3-D array. Note: used for debugging only .
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine Arguments ==
C     glFld    :: field global array to update in halo-region
C     fixVal   :: constant value to fill-up the halo region with
C     kSize    :: size of 3-D field-array
C     myThid   :: my Thread Id number
      INTEGER kSize
      _RL glFld(1-OLx:sNx+OLx,1-OLy:sNy+OLy,kSize,nSx,nSy)
      _RL fixVal
      INTEGER myThid

C     !LOCAL VARIABLES:
C     == Local variables ==
      INTEGER bi, bj, k
      INTEGER ii, i, j
CEOP

      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)

        DO k=1,kSize

         DO j=1-OLy,sNy+OLy
          IF ( j.LT.1 .OR. j.GT.sNy ) THEN
           DO i=1-OLx,sNx+OLx
             glFld(i,j,k,bi,bj) = fixVal
           ENDDO
          ELSE
           DO ii=1-OLx,OLx
             i = ii
             IF ( ii.GE.1 ) i= ii+sNx
             glFld(i,j,k,bi,bj) = fixVal
           ENDDO
          ENDIF
         ENDDO

        ENDDO

C-   end bi,bj loops
       ENDDO
      ENDDO

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

CBOP
C     !ROUTINE: RESET_HALO_RS
C     !INTERFACE:
      SUBROUTINE RESET_HALO_RS(
     U                          glFld,
     I                          fixVal, kSize, myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R RESET_HALO_RS
C     *==========================================================*
C     | o Reset to constant value the halo region of a global
C     |   3-D array. Note: used for debugging only .
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine Arguments ==
C     glFld    :: field global array to update in halo-region
C     fixVal   :: constant value to fill-up the halo region with
C     kSize    :: size of 3-D field-array
C     myThid   :: my Thread Id number
      INTEGER kSize
      _RS glFld(1-OLx:sNx+OLx,1-OLy:sNy+OLy,kSize,nSx,nSy)
      _RS fixVal
      INTEGER myThid

C     !LOCAL VARIABLES:
C     == Local variables ==
      INTEGER bi, bj, k
      INTEGER ii, i, j
CEOP

      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)

        DO k=1,kSize

         DO j=1-OLy,sNy+OLy
          IF ( j.LT.1 .OR. j.GT.sNy ) THEN
           DO i=1-OLx,sNx+OLx
             glFld(i,j,k,bi,bj) = fixVal
           ENDDO
          ELSE
           DO ii=1-OLx,OLx
             i = ii
             IF ( ii.GE.1 ) i= ii+sNx
             glFld(i,j,k,bi,bj) = fixVal
           ENDDO
          ENDIF
         ENDDO

        ENDDO

C-   end bi,bj loops
       ENDDO
      ENDDO

      RETURN
      END

#include "PROFILES_OPTIONS.h"

C     ==================================================================
C
C     active_file.F: Routines to handle the I/O of the active file for
C                    the adjoint calculations. All files are direct
C                    access files.
C
C     Routines
C
C    o  active_read_profile       - Read  an active 1D record.
C    o  active_write_profile      - Write an active 1D record.
C
C
C        changed: gforget@ocean.mit.edu 23-Mar-2006
C
C     ==================================================================

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C !ROUTINE: ACTIVE_READ_PROFILE

C !INTERFACE:
      SUBROUTINE ACTIVE_READ_PROFILE(
     I                           active_num_file,
     I                           nactive_var,
     O                           active_var,
     I                           active_varnum,
     I                           irec,
     I                           lAdInit,
     I                           myOptimIter,
     I                           bi,
     I                           bj,
     I                           myThid,
     I                           dummy
     &                         )

C     !DESCRIPTION:
C     Read an active 1D record from an profile data file.

C     !USES:
      IMPLICIT NONE
C     == Global variables ===
#include "EEPARAMS.h"
#include "SIZE.h"
#ifdef ALLOW_PROFILES
# include "PROFILES_SIZE.h"
# include "profiles.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     active_var_file: filename
C     nactive_var:     integer size of active_var
C     active_var:      array
C     active_varname:  name for the quantity to save
C     irec:            record number
C     myOptimIter:     number of optimization iteration (default: 0)
C     myThid:          my thread ID number
C     lAdInit:         initialisation of corresponding adjoint
C                      variable and write to active file
      INTEGER  nactive_var,active_num_file
      _RL      active_var(nactive_var)
      INTEGER  irec,active_varnum
      INTEGER  myOptimIter
      INTEGER  bi,bj,myThid
      LOGICAL  lAdInit
      _RL      dummy
CEOP

#ifdef ALLOW_PROFILES

      CALL ACTIVE_READ_PROFILE_RL( fidforward(active_num_file,bi,bj),
     &     active_num_file,
     &     nactive_var, active_var, active_varnum, lAdInit,
     &     irec, prof_ind_glob(active_num_file,irec,bi,bj),
     &     FORWARD_SIMULATION, myOptimIter,bi,bj, myThid)

#endif

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C !ROUTINE: ACTIVE_WRITE_PROFILE

C !INTERFACE:
      SUBROUTINE ACTIVE_WRITE_PROFILE(
     I                           active_num_file,
     I                           nactive_var,
     I                           active_var,
     I                           active_varnum,
     I                           irec,
     I                           myOptimIter,
     I                           bi,
     I                           bj,
     I                           myThid,
     I                           dummy
     &                         )

C     !DESCRIPTION:
C     Write an active 1D record from file.

C     !USES:
      IMPLICIT NONE
C     == Global variables ===
#include "EEPARAMS.h"
#include "SIZE.h"
#ifdef ALLOW_PROFILES
# include "PROFILES_SIZE.h"
# include "profiles.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     active_var_file: filename
C     nactive_var:     integer size of active_var
C     active_var:      array
C     active_varname:  name for the quantity to save
C     irec:            record number
C     myOptimIter:     number of optimization iteration (default: 0)
C     myThid:          my thread ID number
      INTEGER  nactive_var,active_num_file, active_varnum
      _RL      active_var(nactive_var)
      INTEGER  irec
      INTEGER  myOptimIter
      INTEGER  bi,bj,myThid
      _RL      dummy
CEOP

#ifdef ALLOW_PROFILES

      CALL ACTIVE_WRITE_PROFILE_RL( fidforward(active_num_file,bi,bj),
     &     active_num_file,
     &     nactive_var, active_var, active_varnum,
     &     irec, prof_ind_glob(active_num_file,irec,bi,bj),
     &     FORWARD_SIMULATION, myOptimIter,bi,bj, myThid)

#endif

      RETURN
      END

#include "SALT_PLUME_OPTIONS.h"

CBOP
C     !ROUTINE: SALT_PLUME_FRAC
C     !INTERFACE:
      SUBROUTINE SALT_PLUME_FRAC(
     I                  imax, fact,SPDepth,
#ifdef SALT_PLUME_SPLIT_BASIN
     I                  lon,lat,
#endif
     U                  plumek,
     I                  myTime, myIter, myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE SALT_PLUME_FRAC
C     | o Compute saltplume penetration.
C     *==========================================================*
C     | Compute fraction of saltplume (flux) penetrating to
C     | specified depth, plumek, due to rejected salt
C     | during freezing.
C     | For example, if surface value is Saltplume0,
C     | and each level gets equal fraction 1/5 down to SPDepth=5,
C     | SALT_PLUME_FRAC will report plumek = 1/5,2/5,3/5,4/5,5/5 on
C     | output if input plumek = 1,2,3,4,5. Else, output plumek = 0.
C     | Reference : Duffy et al, (GRL 1999)
C     |
C     | =====
C     | Written by   : ATN (based on SWFRAC)
C     | Date         : Sep 13, 2007
C     | Modified     : Mar 16, 2014 by atn to improve/clean up
C     | -> replace 1-[cummulative plumefrac] code which was based
C     |    on swfrac with cleaner [cummulative plumefrac] on output
C     |    in order to avoid 1-[1-[cummulative_plumefrac]] whenever
C     |    SALT_PLUME_FRAC is called and used from outside.
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "SALT_PLUME.h"

C     !INPUT/OUTPUT PARAMETERS:
C     input arguments
C     imax    :: number of vertical grid points
C     fact    :: scale  factor to apply to depth array
C     SPDpeth :: corresponding SaltPlumeDepth(i,j) at this grid point
C     myTime  :: Current time in simulation
C     myIter  :: Current iteration number in simulation
C     myThid  :: My Thread Id. number
      INTEGER imax
      _RL     fact
      _RL     myTime
      INTEGER myIter
      INTEGER myThid
C     input/output arguments
C     plumek :: on input: vertical depth for desired plume fraction
C               (fact*plumek) is negative distance (m) from surface
C     plumek :: on output: saltplume contribution fraction
      _RL     plumek(imax), SPDepth(imax)
#ifdef SALT_PLUME_SPLIT_BASIN
      _RL     lon(imax), lat(imax)
#endif
CEOP

#ifdef ALLOW_SALT_PLUME
C     !LOCAL VARIABLES:
      _RL facz, dd, dd20
      INTEGER i, Npowerloc
c     INTEGER kk
      _RL     one, two, three, S, So, zero
      parameter( one = 1. _d 0, two = 2. _d 0, three = 3. _d 0 )
      parameter( zero = 0. _d 0 )
C     This is an abbreviation of 1./(exp(1.)-1.)
      _RL     recip_expOneM1
      parameter( recip_expOneM1 = 0.581976706869326343 )

      DO i = 1,imax
       facz = abs(fact*plumek(i))
#ifdef SALT_PLUME_SPLIT_BASIN
       IF(SaltPlumeSplitBasin) THEN
         Npowerloc = Npower(2)
         IF(lat(imax).LT. 85.0 .AND. lat(imax).GT. 71.0
     &      .AND. lon(imax) .LT. -90.0) Npowerloc = Npower(1)
       ELSE
         Npowerloc = Npower(1)
       ENDIF
#else
         Npowerloc = Npower
#endif

       IF (SPDepth(i).GE.facz .and. SPDepth(i) .GT. zero) THEN

C     Default: uniform distribution, PlumeMethod=1, Npower=0
        IF (PlumeMethod .EQ. 1) THEN
         dd20 = (abs(SPDepth(i)))
c#ifdef TARGET_NEC_SX
C     This rewriting (originally for TARGET_NEC_SX) is better for all platforms
         IF ( dd20 .GT. zero ) THEN
          S   = (facz/dd20)
C     crazy attempt to make the code faster and raise S to (Npower+1)
          IF (Npowerloc .GT. 0) S = S*S**Npowerloc
         ELSE
          S = zero
         ENDIF
         plumek(i) = max(zero,S)
c#else
c        S  = one                  !input depth temp
c        So = one
c        DO kk=1,Npowerloc+1
c         S  = facz*S              !raise to the Npowerloc+1
c         So = dd20*So
c        ENDDO
c        plumek(i) = max(zero,S/So)
c#endif /* TARGET_NEC_SX */

        ELSEIF (PlumeMethod .EQ. 2) THEN !exponential distribution
         dd = abs(SPDepth(i))
         S  = exp(facz/dd)-one
         So = recip_expOneM1       !So = exp(one)-one
         plumek(i) = max(zero,S*So)

C     PlumeMethod = 3, distribute salt LINEARLY between SPDepth and
C     SPDepth/SPovershoot
C     (1-SPovershoot)percent has already been taken into account in
C     SPDepth calculation, i.e., SPDepth = SPovershoot*SPDepth.
        ELSEIF (PlumeMethod .EQ. 3) THEN !overshoot 20%
         dd20 = (abs(SPDepth(i)))
         dd   = dd20/SPovershoot
         So=dd20-dd
         S =facz-dd
         IF( (facz.GE.dd).AND.(facz.LT.dd20) ) THEN
          plumek(i) = max(zero,S/So)
         ELSE
          plumek(i) = zero
         ENDIF

C     PlumeMethod = 5, dumping all salt at the top layer
        ELSEIF (PlumeMethod .EQ. 5) THEN
         dd   = zero
         dd20 = one
         IF( (facz.GE.dd).AND.(facz.LT.dd20) ) THEN
          plumek(i) = zero
         ELSE
          plumek(i) = one
         ENDIF
        ELSEIF (PlumeMethod .EQ. 6) THEN
C     PLumeMethod = 6, currently only works for Npower = 1 and 2.
         dd20 = (abs(SPDepth(i)))
c#ifdef TARGET_NEC_SX
C     This rewriting (originally for TARGET_NEC_SX) is better for all platforms
         IF ( dd20 .GT. zero ) THEN
          S  = (facz/dd20)
C     crazy attempt to make the code faster and raise S to (Npower+1)
          IF (Npowerloc .GT. 0) S = S*S**Npowerloc
          So = 1. _d 0/dd20
         ELSE
          S  = zero
          So = zero
         ENDIF
         IF(Npowerloc.EQ.1) THEN   !Npower=1
          plumek(i) = max(zero,two*So*facz-S)
         ELSE                      !Npower=2
          plumek(i) = max(zero,
     &         three*So*facz - three*So*So*facz*facz + S)
         ENDIF
c#else
c        S  = one                  !input depth temp
c        So = one
c        DO kk=1,Npowerloc+1
c         S  = facz*S              !raise to the Npower+1
c         So = dd20*So
c        ENDDO
c        IF(Npowerloc.EQ.1) THEN   !Npower=1
c         plumek(i) = max(zero,two/dd20*facz-S/So)
c        ELSE                      !Npower=2
c         plumek(i) = max(zero,
c    &         three/dd20*facz - three/(dd20*dd20)*facz*facz + S/So)
c        ENDIF
c#endif /* TARGET_NEC_SX */

catn: 15.Mar.2014
catn: this is a new method by atn. After fixing adjoint compiling error,
catn: will switch this on.  Currently commenting out for purpose of
catn: comparing old (1-abc) vs new (abc) way of coding
c        ELSEIF (PlumeMethod .EQ. 7) THEN
cC     PLumeMethod = 7, dump an offset parabolla with more salt at surface
cC        tapered to zero at depth SPDepth/2, then increased until SPDepth
cC        need input SPDepth, NPower = percentage of SPDepth
cC        Ex: if Npower = 10 -> (10/2)=5% of SPDepth
cC        NPower can be negative integer here.
cC        0 -> parabola centered at SPDepth/2;
cC        + -> parabola offset, salt @ surface < @ SPDepth
cC        - -> parabola offset, salt @ surface > @ SPDepth
cC        S and So are dummy variables
c         dd   = (abs(SPDepth(i)))
c         dd20 = dd*(one/two-Npower/200. _d 0)
c         So   = (dd*dd*dd/three)
c     &            -(dd*dd)      *dd20
c     &            +(dd)         *dd20*dd20
c         S    = (facz*facz *facz/three)
c     &             - (facz*facz)*dd20
c     &             + (facz)     *dd20*dd20
c         plumek(i) = max(zero,(S/So))
c
        ELSE
         plumek(i) = one
#ifndef TARGET_NEC_SX
         WRITE(*,*) 'salt_plume_frac: PLumeMethod =', PLumeMethod,
     &        'not implemented'
         STOP 'ABNORMAL in S/R SALT_PLUME_FRAC'
#endif /* not TARGET_NEC_SX */
        ENDIF
       ELSE
        plumek(i) = one
       ENDIF
      ENDDO

#endif /* ALLOW_SALT_PLUME */

      RETURN
      END

#include "LAYERS_OPTIONS.h"
#ifdef ALLOW_GMREDI
#include "GMREDI_OPTIONS.h"
#endif

C--  File layers_fluxcalc.F:
C--   Contents
C--   o LAYERS_FLUXCALC
C--   o LAYERS_DIAPYCNAL
C--   o LAYERS_LOCATE

CBOP 0
C     !ROUTINE: LAYERS_FLUXCALC
C     !INTERFACE:
      SUBROUTINE LAYERS_FLUXCALC(
     I                  uVel,vVel,tracer,iLa,
     O                  UH,VH,Hw,Hs,PIw,PIs,Uw,Vs,
     I                  myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE LAYERS_FLUXCALC
C     | Calculate the transport in isotracer layers, for a chosen
C     | tracer. This is the meat of the LAYERS package.
C     *==========================================================*
C     \ev

C !USES:
      IMPLICIT NONE
C     == Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "LAYERS_SIZE.h"
#include "LAYERS.h"
#ifdef ALLOW_GMREDI
# include "GMREDI.h"
#endif

C !INPUT PARAMETERS:
C     myThid    :: my Thread Id number
C     uVel  :: zonal velocity (m/s, i=1 held at western face)
C     vVel  :: meridional velocity (m/s, j=1 held at southern face)
C     tracer :: potential temperature, salt or potential density prho
C      UH   :: U integrated over layer (m^2/s)
C      VH   :: V integrated over layer (m^2/s)
C      Hw   :: Layer thickness at the U point (m)
C      Hs   :: Layer thickness at the V point (m)
C      PIw  :: 1 if layer exists, 0 otherwise (at U point)
C      PIs  :: 1 if layer exists, 0 otherwise (at V point)
C      Uw   :: average U over layer (m/s)
C      Vs   :: average V over layer (m/s)
C      iLa  :: layer coordinate index
      INTEGER myThid
      _RL uVel   (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,     nSx,nSy)
      _RL vVel   (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,     nSx,nSy)
      _RL tracer (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,     nSx,nSy)
#ifdef LAYERS_UFLUX
      _RL UH     (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nlayers,nSx,nSy)
# ifdef LAYERS_THICKNESS
      _RL Hw     (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nlayers,nSx,nSy)
      _RL PIw    (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nlayers,nSx,nSy)
      _RL Uw     (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nlayers,nSx,nSy)
# else
      _RL Hw(1), PIw(1), Uw(1)
# endif
#else
      _RL UH(1), Hw(1), PIw(1), Uw(1)
#endif
#ifdef LAYERS_VFLUX
      _RL VH     (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nlayers,nSx,nSy)
# ifdef LAYERS_THICKNESS
      _RL Hs     (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nlayers,nSx,nSy)
      _RL PIs    (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nlayers,nSx,nSy)
      _RL Vs     (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nlayers,nSx,nSy)
# else
      _RL Hs(1), PIs(1), Vs(1)
# endif
#else
      _RL VH(1), Hs(1), PIs(1), Vs(1)
#endif
      INTEGER iLa
CEOP

#ifdef ALLOW_LAYERS

C !LOCAL VARIABLES:
C     bi, bj   :: tile indices
C     i,j      :: horizontal indices
C     k        :: vertical index for model grid
C     kci      :: index from CellIndex
C     kg       :: index for looping though layers_bounds
C     kk       :: vertical index for ZZ (fine) grid
C     kgu,kgv  :: vertical index for isopycnal grid
C     kloc     :: local copy of kgu/v to reduce accesses to index arrays
C     mSteps   :: maximum number of steps for bisection method
C     prho     :: pot. density (less 1000) referenced to layers_krho pressure
C     TatU     :: temperature at U point
C     TatV     :: temperature at V point
C     dzfac    :: temporary sublayer thickness
C     Tloc,Tp1 :: horizontally interpolated tracer values

      INTEGER bi, bj
      INTEGER i,j,k,kk,kg,kci,kp1,kloc
      INTEGER mSteps
      INTEGER kgu(sNx+1,sNy+1), kgv(sNx+1,sNy+1)
      _RL TatU(sNx+1,sNy+1), TatV(sNx+1,sNy+1)
      _RL dzfac
#ifdef ALLOW_GMREDI
      INTEGER kcip1
      _RL delPsi, maskp1
#endif
      LOGICAL errorFlag
      CHARACTER*(MAX_LEN_MBUF) msgBuf

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C     compute maximum number of steps for bisection method (approx.
C     log2(Nlayers)) as log2(Nlayers) + 1 for safety
      mSteps = int(log10(dble(Nlayers))/log10(2. _d 0))+1

C --- The tile loops
      DO bj=myByLo(myThid),myByHi(myThid)
      DO bi=myBxLo(myThid),myBxHi(myThid)

C     Initialize the search indices
      DO j = 1,sNy+1
        DO i = 1,sNx+1
C       The temperature index (layer_G) goes from cold to warm.
C       The water column goes from warm (k=1) to cold (k=Nr).
C       So initialize the search with the warmest value.
          kgu(i,j) = Nlayers
          kgv(i,j) = Nlayers
        ENDDO
      ENDDO

C     Reset the arrays
      DO kg=1,Nlayers
       DO j = 1-OLy,sNy+OLy
        DO i = 1-OLx,sNx+OLx
#ifdef LAYERS_UFLUX
         UH (i,j,kg,bi,bj) = 0. _d 0
#ifdef LAYERS_THICKNESS
         Hw(i,j,kg,bi,bj) = 0. _d 0
         PIw(i,j,kg,bi,bj) = 0. _d 0
         Uw(i,j,kg,bi,bj) = 0. _d 0
#endif /* LAYERS_THICKNESS */
#endif /* UH */
#ifdef LAYERS_VFLUX
         VH (i,j,kg,bi,bj) = 0. _d 0
#ifdef LAYERS_THICKNESS
         Hs(i,j,kg,bi,bj) = 0. _d 0
         PIs(i,j,kg,bi,bj) = 0. _d 0
         Vs(i,j,kg,bi,bj) = 0. _d 0
#endif /* LAYERS_THICKNESS */
#endif /* VH */
        ENDDO
       ENDDO
      ENDDO

      DO kk=1,NZZ
       k = MapIndex(kk)
       kci = CellIndex(kk)
#ifdef ALLOW_GMREDI
       kcip1 = MIN(kci+1,Nr)
       maskp1 = 1.
       IF (kci.GE.Nr) maskp1 = 0.
#endif /* ALLOW_GMREDI */
#ifdef LAYERS_UFLUX
       DO j = 1,sNy+1
        DO i = 1,sNx+1

C ------ Find theta at the U point (west) on the fine Z grid
         kp1=k+1
         IF (maskW(i,j,kp1,bi,bj).EQ.zeroRS) kp1=k
         TatU(i,j) = MapFact(kk) *
     &    0.5 _d 0 * (tracer(i-1,j,k,bi,bj)+tracer(i,j,k,bi,bj)) +
     &    (1. _d 0 -MapFact(kk)) *
     &    0.5 _d 0 * (tracer(i-1,j,kp1,bi,bj)+tracer(i,j,kp1,bi,bj))

        ENDDO
       ENDDO
C ------ Now that we know T everywhere, determine the binning.
C        find the layer indices kgu
       CALL LAYERS_LOCATE(
     I      layers_bounds(1,iLa),Nlayers,mSteps,sNx,sNy,TatU,
     O      kgu,
     I      myThid )
#ifndef TARGET_NEC_SX
C     check for failures
       IF ( debugLevel .GE. debLevC ) THEN
        errorFlag = .FALSE.
        DO j = 1,sNy+1
         DO i = 1,sNx+1
          IF ( kgu(i,j) .LE. 0 ) THEN
           WRITE(msgBuf,'(2A,I3,A,I3,A,1E14.6)')
     &          'S/R LAYERS_LOCATE: Could not find a bin in ',
     &          'layers_bounds for TatU(',i,',',j,',)=',TatU(i,j)
           CALL PRINT_ERROR( msgBuf, myThid )
           errorFlag = .TRUE.
          ENDIF
         ENDDO
        ENDDO
        IF ( errorFlag ) STOP 'ABNORMAL END: S/R LAYERS_FLUXCALC'
       ENDIF
#endif /* ndef TARGET_NEC_SX */
C
       DO j = 1,sNy+1
        DO i = 1,sNx+1

         kloc = kgu(i,j)
         dzfac = dZZf(kk) * hFacW(i,j,kci,bi,bj)

C ------ Augment the bin values
         UH(i,j,kloc,bi,bj) =
     &    UH(i,j,kloc,bi,bj) +
     &    dzfac * uVel(i,j,kci,bi,bj)

#ifdef ALLOW_GMREDI
         IF ( layers_bolus(iLa)  ) THEN
           IF ( .NOT.GM_AdvForm ) THEN
             delPsi = 0.25 _d 0 *(
     &              ( rA(i-1,j,bi,bj)*Kwx(i-1,j,kcip1,bi,bj)
     &               +rA( i ,j,bi,bj)*Kwx( i ,j,kcip1,bi,bj)
     &              ) * maskW(i,j,kcip1,bi,bj) * maskp1
     &            - ( rA(i-1,j,bi,bj)*Kwx(i-1,j, kci ,bi,bj)
     &               +rA( i ,j,bi,bj)*Kwx( i ,j, kci ,bi,bj)
     &              ) * maskW(i,j, kci ,bi,bj)
     &                           ) * recip_rAw(i,j,bi,bj)
#ifdef GM_BOLUS_ADVEC
           ELSE
             delPsi = GM_PsiX(i,j,kcip1,bi,bj)*maskp1
     &              - GM_PsiX(i,j, kci, bi,bj)
#endif
           ENDIF
           UH(i,j,kloc,bi,bj) = UH(i,j,kloc,bi,bj)
     &      + delPsi*recip_drF(kci)*_recip_hFacW(i,j,kci,bi,bj)
     &      * dzfac
         ENDIF
#endif /* ALLOW_GMREDI */

#ifdef LAYERS_THICKNESS
         Hw(i,j,kloc,bi,bj) = Hw(i,j,kloc,bi,bj) + dzfac
#endif /* LAYERS_THICKNESS */

        ENDDO
       ENDDO
#endif /* LAYERS_UFLUX */

#ifdef LAYERS_VFLUX
       DO j = 1,sNy+1
        DO i = 1,sNx+1
C ------ Find theta at the V point (south) on the fine Z grid
         kp1=k+1
         IF (maskS(i,j,kp1,bi,bj).EQ.zeroRS) kp1=k
         TatV(i,j) = MapFact(kk) *
     &    0.5 _d 0 * (tracer(i,j-1,k,bi,bj)+tracer(i,j,k,bi,bj)) +
     &    (1. _d 0 -MapFact(kk)) *
     &    0.5 _d 0 * (tracer(i,j-1,kp1,bi,bj)+tracer(i,j,kp1,bi,bj))

        ENDDO
       ENDDO
C ------ Now that we know T everywhere, determine the binning.
C        find the layer indices kgv
       CALL LAYERS_LOCATE(
     I      layers_bounds(1,iLa),Nlayers,mSteps,sNx,sNy,TatV,
     O      kgv,
     I      myThid )
#ifndef TARGET_NEC_SX
       IF ( debugLevel .GE. debLevC ) THEN
C     check for failures
        errorFlag = .FALSE.
        DO j = 1,sNy+1
         DO i = 1,sNx+1
          IF ( kgv(i,j) .LE. 0 ) THEN
           WRITE(msgBuf,'(2A,I3,A,I3,A,1E14.6)')
     &          'S/R LAYERS_LOCATE: Could not find a bin in ',
     &          'layers_bounds for TatV(',i,',',j,',)=',TatV(i,j)
           CALL PRINT_ERROR( msgBuf, myThid )
           errorFlag = .TRUE.
          ENDIF
         ENDDO
        ENDDO
        IF ( errorFlag ) STOP 'ABNORMAL END: S/R LAYERS_FLUXCALC'
       ENDIF
#endif /* ndef TARGET_NEC_SX */
C
       DO j = 1,sNy+1
        DO i = 1,sNx+1

         kloc = kgv(i,j)
         dzfac = dZZf(kk) * hFacS(i,j,kci,bi,bj)

C ------ debugging stuff
C         IF (i.EQ.10 .AND. j.EQ.10) THEN
C           WRITE(msgBuf,'(A,I3,A,F10.2,A,F6.2)')
C     &          '    kloc=', kloc,
C     &          ', TatV=',TatV(i,j),
C     &          ', dzfac=',dzfac
C           CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
C     &                         SQUEEZE_RIGHT, myThid )
C         ENDIF

C ------ Augment the bin values
         VH(i,j,kloc,bi,bj) =
     &    VH(i,j,kloc,bi,bj) + dzfac * vVel(i,j,kci,bi,bj)

#ifdef ALLOW_GMREDI
         IF ( layers_bolus(iLa) ) THEN
           IF ( .NOT.GM_AdvForm ) THEN
             delPsi = 0.25 _d 0 *(
     &              ( rA(i,j-1,bi,bj)*Kwy(i,j-1,kcip1,bi,bj)
     &               +rA(i, j ,bi,bj)*Kwy(i, j ,kcip1,bi,bj)
     &              ) * maskS(i,j,kcip1,bi,bj) * maskp1
     &            - ( rA(i,j-1,bi,bj)*Kwy(i,j-1, kci ,bi,bj)
     &               +rA(i, j ,bi,bj)*Kwy(i, j , kci ,bi,bj)
     &              ) * maskS(i,j, kci ,bi,bj)
     &                           ) * recip_rAs(i,j,bi,bj)
#ifdef GM_BOLUS_ADVEC
           ELSE
             delPsi = GM_PsiY(i,j,kcip1,bi,bj)*maskp1
     &              - GM_PsiY(i,j, kci, bi,bj)
#endif
           ENDIF
           VH(i,j,kloc,bi,bj) = VH(i,j,kloc,bi,bj)
     &      + delPsi*recip_drF(kci)*_recip_hFacS(i,j,kci,bi,bj)
     &      * dzfac
         ENDIF
#endif /* ALLOW_GMREDI */

#ifdef LAYERS_THICKNESS
         Hs(i,j,kloc,bi,bj) = Hs(i,j,kloc,bi,bj) + dzfac
#endif /* LAYERS_THICKNESS */

        ENDDO
       ENDDO
#endif /* LAYERS_VFLUX */
      ENDDO

C--   Now that we know the thicknesses, compute the heaviside function
C--   (Needs another loop through Ng)
#ifdef LAYERS_THICKNESS
      DO kg=1,Nlayers
       DO j = 1,sNy+1
        DO i = 1,sNx+1
#ifdef LAYERS_UFLUX
         IF (Hw(i,j,kg,bi,bj) .GT. 0.) THEN
          PIw(i,j,kg,bi,bj) = 1. _d 0
          Uw(i,j,kg,bi,bj) =
     &        UH(i,j,kg,bi,bj) / Hw(i,j,kg,bi,bj)
         ENDIF
#endif /* LAYERS_UFLUX */
#ifdef LAYERS_VFLUX
         IF (Hs(i,j,kg,bi,bj) .GT. 0.) THEN
          PIs(i,j,kg,bi,bj) = 1. _d 0
          Vs(i,j,kg,bi,bj) =
     &        VH(i,j,kg,bi,bj) / Hs(i,j,kg,bi,bj)
         ENDIF
#endif /* LAYERS_VFLUX */
        ENDDO
       ENDDO
      ENDDO
#endif /* LAYERS_THICKNESS */

C --- End bi,bj loop
      ENDDO
      ENDDO

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 0
C     !ROUTINE: LAYERS_DIAPYCNAL
C     !INTERFACE:
      SUBROUTINE LAYERS_DIAPYCNAL(
     I                  tracer,iLa,
     O                  TtendSurf, TtendDiffh, TtendDiffr,
     O                  TtendAdvh, TtendAdvr, Ttendtot,
     O                  StendSurf, StendDiffh, StendDiffr,
     O                  StendAdvh, StendAdvr, Stendtot,
     O                  Hc, PIc,
     I                  myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE LAYERS_DIAPYCNAL
C     | Calculate the diapycnal velocity in isotracer layers, for a chosen
C     | tracer.
C     *==========================================================*
C     \ev
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "LAYERS_SIZE.h"
#include "LAYERS.h"

C !INPUT PARAMETERS:
C     myThid    :: my Thread Id number
C     tracer    :: potential temperature, salt or potential density prho
C     iLa       :: layer coordinate index
C     TtendSurf :: temperature tendency due to surface forcing times thickness
C     TtendDiffh:: temperature tendency due to horiz. diffusion times thickness
C     TtendDiffr:: temperature tendency due to vert. diffusion times thickness
C     TtendAdvh:: salinity tendency due to horiz. advection times thickness
C     TtendAdvr:: salinity tendency due to vert. advection times thickness
C     StendSurf :: salinity tendency due to surface forcing times thickness
C     StendDiffh:: salinity tendency due to horiz. diffusion times thickness
C     StendDiffr:: salinity tendency due to vert. diffusion times thickness
C     StendAdvh :: salinity tendency due to horiz. advection times thickness
C     StendAdvr :: salinity tendency due to vert. advection times thickness
C     Hc        :: Layer thickness at the tracer point (m)
C     PIw       :: 1 if layer exists, 0 otherwise (at tracer point)
      INTEGER iLa, myThid
      _RL tracer    (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,     nSx,nSy)
      _RL Hc        (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nlayers,nSx,nSy)
      _RL PIc       (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nlayers,nSx,nSy)
      _RL TtendSurf (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nlayers-1,nSx,nSy)
      _RL TtendDiffh(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nlayers-1,nSx,nSy)
      _RL TtendDiffr(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nlayers-1,nSx,nSy)
      _RL TtendAdvh (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nlayers-1,nSx,nSy)
      _RL TtendAdvr (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nlayers-1,nSx,nSy)
      _RL Ttendtot  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nlayers-1,nSx,nSy)
      _RL StendSurf (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nlayers-1,nSx,nSy)
      _RL StendDiffh(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nlayers-1,nSx,nSy)
      _RL StendDiffr(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nlayers-1,nSx,nSy)
      _RL StendAdvh (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nlayers-1,nSx,nSy)
      _RL StendAdvr (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nlayers-1,nSx,nSy)
      _RL Stendtot  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nlayers-1,nSx,nSy)
CEOP

#ifdef LAYERS_THERMODYNAMICS

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C !LOCAL VARIABLES:
C     bi, bj   :: tile indices
C     i,j      :: horizontal indices
C     k        :: vertical index for model grid
C     kp1      :: vertical index for model grid next cell
C     kci      :: index from CellIndex
C     kg       :: index for looping though layers_bounds
C     kk       :: vertical index for ZZ (fine) grid
C     kloc     :: local copy of kgu/v to reduce accesses to index arrays
C     mSteps   :: maximum number of steps for bisection method
C     TatC     :: temperature at C point
      _RL Hcw       (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nlayers-1,nSx,nSy)
      INTEGER bi, bj
      INTEGER i,j,k,kk,kg,kci,kloc
      INTEGER mSteps
      INTEGER kgc(sNx+1,sNy+1)
      INTEGER kgcw(sNx+1,sNy+1)
      _RL TatC(sNx+1,sNy+1), dzfac, Tfac, Sfac
      LOGICAL errorFlag
      CHARACTER*(MAX_LEN_MBUF) msgBuf
#ifdef LAYERS_FINEGRID_DIAPYCNAL
      INTEGER kp1
#endif

C --  constants for T and S forcing, gets reset later for rho
      Tfac = 1. _d 0
      Sfac = 1. _d 0

C     compute maximum number of steps for bisection method (approx.
C     log2(Nlayers)) as log2(Nlayers) + 1 for safety
      mSteps = int(log10(dble(Nlayers))/log10(2. _d 0))+1

C      STOP 'DEBUG END: S/R LAYERS_DIAPYCNAL'

C --- The tile loops
      DO bj=myByLo(myThid),myByHi(myThid)
      DO bi=myBxLo(myThid),myBxHi(myThid)

C     Initialize the search indices
      DO j = 1,sNy+1
        DO i = 1,sNx+1
C       The temperature index (layer_G) goes from cold to warm.
C       The water column goes from warm (k=1) to cold (k=Nr).
C       So initialize the search with the warmest value.
          kgc(i,j) = Nlayers
          kgcw(i,j) = Nlayers-1
        ENDDO
      ENDDO

C     Reset the arrays
C --- These are at the w point
      DO kg=1,Nlayers-1
       DO j = 1-OLy,sNy+OLy
        DO i = 1-OLx,sNx+OLx
         TtendSurf (i,j,kg,bi,bj) = 0. _d 0
         TtendDiffh(i,j,kg,bi,bj) = 0. _d 0
         TtendDiffr(i,j,kg,bi,bj) = 0. _d 0
         TtendAdvh(i,j,kg,bi,bj)  = 0. _d 0
         TtendAdvr(i,j,kg,bi,bj)  = 0. _d 0
         Ttendtot(i,j,kg,bi,bj)   = 0. _d 0
         StendSurf (i,j,kg,bi,bj) = 0. _d 0
         StendDiffh(i,j,kg,bi,bj) = 0. _d 0
         StendDiffr(i,j,kg,bi,bj) = 0. _d 0
         StendAdvh(i,j,kg,bi,bj)  = 0. _d 0
         StendAdvr(i,j,kg,bi,bj)  = 0. _d 0
         Stendtot(i,j,kg,bi,bj)   = 0. _d 0
         Hcw(i,j,kg,bi,bj) = 0. _d 0
        ENDDO
       ENDDO
      ENDDO
C --- These are at the c point
      DO kg=1,Nlayers
       DO j = 1-OLy,sNy+OLy
        DO i = 1-OLx,sNx+OLx
         Hc(i,j,kg,bi,bj) = 0. _d 0
         PIc(i,j,kg,bi,bj) = 0. _d 0
        ENDDO
       ENDDO
      ENDDO

#ifdef LAYERS_FINEGRID_DIAPYCNAL
      DO kk=1,NZZ
       k = MapIndex(kk)
       kci = CellIndex(kk)
       DO j = 1,sNy+1
        DO i = 1,sNx+1
C ------ Find theta at the V point (south) on the fine Z grid
         kp1=k+1
         IF (maskC(i,j,kp1,bi,bj).EQ.zeroRS) kp1=k
         TatC(i,j) = MapFact(kk) * tracer(i,j,k,bi,bj) +
     &    (1. _d 0 -MapFact(kk)) * tracer(i,j,kp1,bi,bj)
        ENDDO
       ENDDO
#else
      DO kk=1,Nr
       k = kk
       kci = kk
       DO j = 1,sNy+1
        DO i = 1,sNx+1
         TatC(i,j) = tracer(i,j,k,bi,bj)
        ENDDO
       ENDDO
#endif /* LAYERS_FINEGRID_DIAPYCNAL */

C ------ debugging stuff
c         IF (i.EQ.38 .AND. j.EQ.4 .AND. bi.EQ.1 .AND. bj.EQ.1) THEN
c           i=38
c           j=4
c           WRITE(msgBuf,
c     &       '(A,I3,A,I3,A,I3,A,F7.2,A,F7.2,A,F7.2,A,F7.2,A,F3.1)')
c     &          'LAYERS_DEBUG: iLa=', iLa,
c     &          ', kk=', kk,
c     &          ', k=', k,
c     &          ', tracer=', tracer(i,j,k,bi,bj),
c     &          ', TatC=',TatC(i,j),
c     &          ', hFacC=',hFacC(i,j,k,bi,bj)
c           CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
c     &                         SQUEEZE_RIGHT, myThid )
c         ENDIF
C ------ Now that we know T everywhere, determine the binning.
C        find the layer indices kgc for the center point
       CALL LAYERS_LOCATE(
     I      layers_bounds(1,iLa),Nlayers,mSteps,sNx,sNy,TatC,
     O      kgc,
     I      myThid )
#ifndef TARGET_NEC_SX
C     check for failures
       IF ( debugLevel .GE. debLevC ) THEN
        errorFlag = .FALSE.
        DO j = 1,sNy+1
         DO i = 1,sNx+1
          IF ( kgc(i,j) .LE. 0 ) THEN
           WRITE(msgBuf,'(2A,I3,A,I3,A,1E14.6)')
     &          'S/R LAYERS_LOCATE: Could not find a bin in ',
     &          'layers_bounds for TatC(',i,',',j,',)=',TatC(i,j)
           CALL PRINT_ERROR( msgBuf, myThid )
           errorFlag = .TRUE.
          ENDIF
         ENDDO
        ENDDO
        IF ( errorFlag ) STOP 'ABNORMAL END: S/R LAYERS_DIAPYCNAL'
       ENDIF
#endif /* ndef TARGET_NEC_SX */

C        find the layer indices kgcw for the w point
       CALL LAYERS_LOCATE(
     I      layers_bounds_w(1,iLa),Nlayers-1,mSteps,sNx,sNy,TatC,
     O      kgcw,
     I      myThid )
#ifndef TARGET_NEC_SX
C     check for failures
       IF ( debugLevel .GE. debLevC ) THEN
        errorFlag = .FALSE.
        DO j = 1,sNy+1
         DO i = 1,sNx+1
          IF ( kgcw(i,j) .LE. 0 ) THEN
           WRITE(msgBuf,'(2A,I3,A,I3,A,1E14.6)')
     &          'S/R LAYERS_LOCATE: Could not find a bin in ',
     &          'layers_bounds for TatC(',i,',',j,',)=',TatC(i,j)
           CALL PRINT_ERROR( msgBuf, myThid )
           errorFlag = .TRUE.
          ENDIF
         ENDDO
        ENDDO
        IF ( errorFlag ) STOP 'ABNORMAL END: S/R LAYERS_DIAPYCNAL'
       ENDIF
#endif /* ndef TARGET_NEC_SX */

C ------ Augment the bin values
       DO j = 1,sNy+1
        DO i = 1,sNx+1
#ifdef LAYERS_FINEGRID_DIAPYCNAL
         dzfac = dZZf(kk) * hFacC(i,j,kci,bi,bj)
#else
         dzfac = dRf(kci) * hFacC(i,j,kci,bi,bj)
#endif /* LAYERS_FINEGRID_DIAPYCNAL */
         kloc = kgcw(i,j)

C ------- Thickness at w point
         Hcw(i,j,kloc,bi,bj) = Hcw(i,j,kloc,bi,bj)
     &     + dzfac
C ------- Thickness at c point
         Hc(i,j,kgc(i,j),bi,bj) = Hc(i,j,kgc(i,j),bi,bj)
     &     + dzfac

C ------- Now rescale dzfac to include the layer coordinate spacing
         dzfac = dzfac * layers_recip_delta(kloc,iLa)

#ifdef LAYERS_PRHO_REF 
         IF ( layers_num(iLa) .EQ. 3 ) THEN
           Tfac = layers_alpha(i,j,kci,bi,bj)
           Sfac = layers_beta(i,j,kci,bi,bj)
         ENDIF
#endif
         IF (kci.EQ.1) THEN
C ------- We are in the surface layer
          TtendSurf(i,j,kloc,bi,bj) =
     &     TtendSurf(i,j,kloc,bi,bj) +
     &     Tfac * dzfac * layers_surfflux(i,j,1,1,bi,bj)
          StendSurf(i,j,kloc,bi,bj) =
     &     StendSurf(i,j,kloc,bi,bj) +
     &     Sfac * dzfac * layers_surfflux(i,j,1,2,bi,bj)
         ENDIF

#ifdef SHORTWAVE_HEATING
          TtendSurf(i,j,kloc,bi,bj) =
     &     TtendSurf(i,j,kloc,bi,bj) +
     &     Tfac * dzfac * layers_sw(i,j,kci,1,bi,bj)
#endif /* SHORTWAVE_HEATING */

C ------- Diffusion
         TtendDiffh(i,j,kloc,bi,bj) =
     &     TtendDiffh(i,j,kloc,bi,bj) + dzfac * Tfac *
     &    (layers_dfx(i,j,kci,1,bi,bj)+
     &     layers_dfy(i,j,kci,1,bi,bj))
         TtendDiffr(i,j,kloc,bi,bj) =
     &     TtendDiffr(i,j,kloc,bi,bj) +
     &     dzfac * Tfac * layers_dfr(i,j,kci,1,bi,bj)
         StendDiffh(i,j,kloc,bi,bj) =
     &     StendDiffh(i,j,kloc,bi,bj) + dzfac * Sfac *
     &    (layers_dfx(i,j,kci,2,bi,bj)+
     &     layers_dfy(i,j,kci,2,bi,bj))
         StendDiffr(i,j,kloc,bi,bj) =
     &     StendDiffr(i,j,kloc,bi,bj) +
     &     dzfac * Sfac * layers_dfr(i,j,kci,2,bi,bj)
C ------- Advection
         TtendAdvh(i,j,kloc,bi,bj) =
     &     TtendAdvh(i,j,kloc,bi,bj) + dzfac * Tfac *
     &    (layers_afx(i,j,kci,1,bi,bj)+
     &     layers_afy(i,j,kci,1,bi,bj))
         TtendAdvr(i,j,kloc,bi,bj) =
     &     TtendAdvr(i,j,kloc,bi,bj) +
     &     dzfac * Tfac * layers_afr(i,j,kci,1,bi,bj)
         StendAdvh(i,j,kloc,bi,bj) =
     &     StendAdvh(i,j,kloc,bi,bj) + dzfac * Sfac *
     &    (layers_afx(i,j,kci,2,bi,bj)+
     &     layers_afy(i,j,kci,2,bi,bj))
         StendAdvr(i,j,kloc,bi,bj) =
     &     StendAdvr(i,j,kloc,bi,bj) +
     &     dzfac * Sfac * layers_afr(i,j,kci,2,bi,bj)
C -------- Total Tendency
         Ttendtot(i,j,kloc,bi,bj) =
     &     Ttendtot(i,j,kloc,bi,bj) +
     &     dzfac * Tfac * layers_tottend(i,j,kci,1,bi,bj)
         Stendtot(i,j,kloc,bi,bj) =
     &     Stendtot(i,j,kloc,bi,bj) +
     &     dzfac * Sfac * layers_tottend(i,j,kci,2,bi,bj)
        ENDDO
       ENDDO
      ENDDO

C--   Now that we know the thicknesses, compute the heaviside function
C--   (Needs another loop through Ng)
      DO kg=1,Nlayers
       DO j = 1,sNy+1
        DO i = 1,sNx+1
         IF (Hc(i,j,kg,bi,bj) .GT. 0.) THEN
          PIc(i,j,kg,bi,bj) = 1. _d 0
         ENDIF
        ENDDO
       ENDDO
      ENDDO

C --- End bi,bj loop
      ENDDO
      ENDDO

#endif /* LAYERS_THERMODYNAMICS */

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

CBOP
      SUBROUTINE LAYERS_LOCATE(
     I                          xx,n,m,sNx,sNy,x,
     O                          k,
     I                          myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | Find the index(-array) k such that x is between xx(k)
C     | and xx(k+1) by bisection, following Press et al.,
C     | Numerical Recipes in Fortran. xx must be monotonic.
C     *==========================================================*
C     \ev

C !USES:
      IMPLICIT NONE
C !INPUT PARAMETERS:
C     xx        :: array of bin-boundaries (layers_boundaries)
C     n         :: length of xx
C     m         :: int(log2(n)) + 1 = length of bisection loop
C     sNx,sNy   :: size of index array and input x
C     x         :: input array of values
C     k         :: index array (output)
C     myThid    :: my Thread Id number
      INTEGER n,m,sNx,sNy
      _RL     xx(1:n+1)
      _RL     x(snx+1,sny+1)
      INTEGER k(snx+1,sny+1)
      INTEGER myThid

C !LOCAL VARIABLES:
C     i,j      :: horizontal indices
C     l        :: bisection loop index
C     kl,ku,km :: work arrays and variables
      INTEGER i,j
CEOP
#ifdef TARGET_NEC_SX
      INTEGER l, km
      INTEGER kl(sNx+1,sNy+1), ku(sNx+1,sNy+1)

C     bisection, following Press et al., Numerical Recipes in Fortran,
C     mostly, because it can be vectorized
      DO j = 1,sNy+1
       DO i = 1,sNx+1
        kl(i,j)=1
        ku(i,j)=n+1
       END DO
      END DO
      DO l = 1,m
       DO j = 1,sNy+1
        DO i = 1,sNx+1
         IF (ku(i,j)-kl(i,j).GT.1) THEN
          km=(ku(i,j)+kl(i,j))/2
CML       IF ((xx(n).GE.xx(1)).EQV.(x(i,j).GE.xx(km))) THEN
          IF ( ((xx(n).GE.xx(1)).AND.(x(i,j).GE.xx(km))).OR.
     &         ((xx(n).GE.xx(1)).AND.(x(i,j).GE.xx(km))) ) THEN
           kl(i,j)=km
          ELSE
           ku(i,j)=km
          END IF
         END IF
        END DO
       END DO
      END DO
      DO j = 1,sNy+1
       DO i = 1,sNx+1
        IF ( x(i,j).LT.xx(2) ) THEN
         k(i,j)=1
        ELSE IF ( x(i,j).GE.xx(n) ) THEN
         k(i,j)=n
        ELSE
         k(i,j)=kl(i,j)
        END IF
       END DO
      END DO
#else
C     the old way
      DO j = 1,sNy+1
       DO i = 1,sNx+1
        IF (x(i,j) .GE. xx(n)) THEN
C     the point is in the hottest bin or hotter
         k(i,j) = n
        ELSE IF (x(i,j) .LT. xx(2)) THEN
C        the point is in the coldest bin or colder
         k(i,j) = 1
        ELSE IF ( (x(i,j) .GE. xx(k(i,j)))
     &    .AND.   (x(i,j) .LT. xx(k(i,j)+1)) ) THEN
C     already on the right bin -- do nothing
        ELSE IF (x(i,j) .GE. xx(k(i,j))) THEN
C     have to hunt for the right bin by getting hotter
         DO WHILE (x(i,j) .GE. xx(k(i,j)+1))
          k(i,j) = k(i,j) + 1
         ENDDO
C     now xx(k) < x <= xx(k+1)
        ELSE IF (x(i,j) .LT. xx(k(i,j)+1)) THEN
C     have to hunt for the right bin by getting colder
         DO WHILE (x(i,j) .LT. xx(k(i,j)))
          k(i,j) = k(i,j) - 1
         ENDDO
C     now xx(k) <= x < xx(k+1)
        ELSE
C     that should have covered all the options
         k(i,j) = -1
        ENDIF

       ENDDO
      ENDDO
#endif /* TARGET_NEC_SX */

#endif /* ALLOW_LAYERS */

      RETURN
      END

#include "CPP_OPTIONS.h"

CBOP
C     !ROUTINE: INI_THETA
C     !INTERFACE:
      SUBROUTINE INI_THETA( myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE INI_THETA
C     | o Set model initial temperature field.
C     *==========================================================*
C     | There are several options for setting the initial
C     | temperature file
C     |  1. Inline code
C     |  2. Vertical profile ( uniform T in X and Y )
C     |  3. Three-dimensional data from a file. For example from
C     |     Levitus or from a checkpoint file from a previous
C     |     integration.
C     | In addition to setting the temperature field we also
C     | set the initial temperature tendency term here.
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "DYNVARS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     myThid :: Number of this instance of INI_THETA
      INTEGER myThid

C     !LOCAL VARIABLES:
C     == Local variables ==
C     bi,bj  :: Tile indices
C     i,j,k  :: Loop counters
C     rD     :: Radial displacement of point i,j
      INTEGER bi, bj
      INTEGER i, j, k, localWarnings
      _RL     Tfreezing
      _RL     rD
      CHARACTER*(MAX_LEN_MBUF) msgBuf
CEOP

C--   Initialise temperature field to the vertical reference profile
      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
        DO k=1,Nr
         DO j=1-Oly,sNy+Oly
          DO i=1-Olx,sNx+Olx
           theta(i,j,k,bi,bj) = tRef(k)
          ENDDO
         ENDDO
C=== Set-up specific modification starts here ===
C--    Initialise temperature field to a circular patch.
         DO j=1,sNy
          DO i=1,sNx
            rD = SQRT( ( xC(i,j,bi,bj) - 40. _d 3 )**2
     &                +( yC(i,j,bi,bj) - 40. _d 3 )**2
     &                +( rC(k) + 50. _d 3 )**2
     &               )
            theta(i,j,k,bi,bj) = EXP( -0.5 _d 0*( rD/20. _d 3 )**2 )
          ENDDO
         ENDDO
C=== Set-up specific modification ends here  ===
        ENDDO
       ENDDO
      ENDDO
C=== Set-up specific modification starts here ===
      _EXCH_XYZ_RL( theta, myThid )
C=== Set-up specific modification ends here  ===

      IF ( hydrogThetaFile .NE. ' ' ) THEN
        CALL READ_FLD_XYZ_RL( hydrogThetaFile, ' ', theta, 0, myThid )
        _EXCH_XYZ_RL(theta,myThid)
      ENDIF

C--   Apply mask and test consistency
      localWarnings=0
      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
        DO k=1,Nr
         IF ( maskIniTemp ) THEN
          DO j=1-Oly,sNy+Oly
           DO i=1-Olx,sNx+Olx
            IF (maskC(i,j,k,bi,bj).EQ.0.) theta(i,j,k,bi,bj) = 0.
           ENDDO
          ENDDO
         ENDIF
         IF ( tRef(k).NE.0. ) THEN
          DO j=1,sNy
           DO i=1,sNx
            IF (  maskC(i,j,k,bi,bj).NE.0.
     &      .AND. theta(i,j,k,bi,bj).EQ.0. ) THEN
              localWarnings=localWarnings+1
            ENDIF
           ENDDO
          ENDDO
         ENDIF
        ENDDO
       ENDDO
      ENDDO
      IF (localWarnings.NE.0) THEN
       IF ( checkIniTemp ) THEN
        WRITE(msgBuf,'(A,I10,A)')
     &   ' INI_THETA: found', localWarnings,
     &   ' wet grid-pts with theta=0 identically.'
        CALL PRINT_ERROR( msgBuf , myThid)
        WRITE(msgBuf,'(A,A)')
     &  ' If this is intentional, you need to',
     &  ' set checkIniTemp=.false. in "data", namelist PARM05'
        CALL PRINT_ERROR( msgBuf , myThid)
        STOP 'ABNORMAL END: S/R INI_THETA'
       ELSE
        WRITE(msgBuf,'(A,I10,A)')
     &   '** WARNINGS ** INI_THETA: found', localWarnings,
     &   ' wet grid-pts with theta=0 identically.'
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
       ENDIF
      ENDIF

C--   Check that there are no values of temperature below freezing point.
      Tfreezing=-1.9 _d 0
      IF ( allowFreezing ) THEN
       DO bj = myByLo(myThid), myByHi(myThid)
        DO bi = myBxLo(myThid), myBxHi(myThid)
         DO k=1,Nr
          DO j=1-Oly,sNy+Oly
           DO i=1-Olx,sNx+Olx
            IF (theta(i,j,k,bi,bj) .LT. Tfreezing) THEN
               theta(i,j,k,bi,bj) = Tfreezing
            ENDIF
           ENDDO
          ENDDO
         ENDDO
        ENDDO
       ENDDO
      ENDIF

      IF (debugMode) THEN
        CALL PLOT_FIELD_XYZRL( theta, 'Initial Temperature',
     &                         Nr, 1, myThid )
      ENDIF

      RETURN
      END

#include "FLT_OPTIONS.h"

C--   Contents
C--   o FLT_BILINEAR
C--   o FLT_TRILINEAR
C--   o FLT_BILINEAR2D

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      SUBROUTINE FLT_BILINEAR(
     I                         ix, jy,
     O                         uu,
     I                         var,
     I                         kl, nu, bi, bj, myThid )

C     ==================================================================
C     SUBROUTINE FLT_BILINEAR
C     ==================================================================
C     o Bilinear scheme to interpolate variable to particle position
C       given by its fractional (real) index ix,jy location
C     ==================================================================

C     !USES:
      IMPLICIT NONE

C     == global variables ==
#include "SIZE.h"

C     == routine arguments ==
      _RL ix, jy
      _RL uu
      _RL var(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      INTEGER kl, nu, bi, bj, myThid

C     == local variables ==
      INTEGER i1, j1, i2, j2, klp
      _RL ddx, ddy
      _RL u11, u12, u22, u21

C     == end of interface ==

C--   to choose the u box in which the particle is found
C nu=0 for T, S
C nu=1 for u
C nu=2 for v
C nu=3 for Vorticity
C nu=4 for w

      IF ( kl.LT.1 .OR. kl.GT.Nr ) THEN
c           WRITE(msgbuf,'(A,I8)')
c    &        ' FLT_BILINEAR: illegal value for kl=',kl
c           CALL PRINT_ERROR( msgbuf, myThid )
            STOP 'ABNORMAL END: S/R FLT_BILINEAR'
      ENDIF

C--   find x-index according to grid-location of variable
      IF ( MOD(nu,2).EQ.0 ) THEN
        i1 = INT(ix)
        ddx = ix - DFLOAT(i1)
      ELSE
        i1 = NINT(ix)
        ddx = 0.5 _d 0 + ix - DFLOAT(i1)
      ENDIF
C--   find y-index according to grid-location of variable
      IF ( MOD(nu,4).LE.1 ) THEN
        j1 = INT(jy)
        ddy = jy - DFLOAT(j1)
      ELSE
        j1 = NINT(jy)
        ddy = 0.5 _d 0 + jy - DFLOAT(j1)
      ENDIF

C--   Set the higher index for interpolation
      i2 = i1 + 1
      j2 = j1 + 1

C--   No need to change start/end index : use array overlap if needed

C--   bilinear interpolation (from numerical recipes)
      IF (nu.LE.3) THEN
        uu =          ( (1.-ddx)*(1.-ddy)*var(i1,j1,kl,bi,bj)
     &                +     ddx * ddy    *var(i2,j2,kl,bi,bj) )
     &              + (     ddx *(1.-ddy)*var(i2,j1,kl,bi,bj)
     &                + (1.-ddx)* ddy    *var(i1,j2,kl,bi,bj) )
      ELSE
        klp = MIN(kl+1,Nr)
        u11 = ( var(i1,j1,kl,bi,bj)+var(i1,j1,klp,bi,bj) )*0.5 _d 0
        u21 = ( var(i2,j1,kl,bi,bj)+var(i2,j1,klp,bi,bj) )*0.5 _d 0
        u22 = ( var(i2,j2,kl,bi,bj)+var(i2,j2,klp,bi,bj) )*0.5 _d 0
        u12 = ( var(i1,j2,kl,bi,bj)+var(i1,j2,klp,bi,bj) )*0.5 _d 0
        uu =          ( (1.-ddx)*(1.-ddy)*u11
     &                +     ddx * ddy    *u22 )
     &              + (     ddx *(1.-ddy)*u21
     &                + (1.-ddx)* ddy    *u12 )
      ENDIF


      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      SUBROUTINE FLT_TRILINEAR(
     I                         ix, jy, kz,
     O                         uu,
     I                         var,
     I                         nu, bi, bj, myThid )

C     ==================================================================
C     SUBROUTINE FLT_TRILINEAR
C     ==================================================================
C     o Trilinear scheme to interpolate variable to particle position
C       given by its fractional (real) index ix,jy,kz location
C       This routine is a straight forward generalization of the
C       bilinear interpolation scheme.
C
C     started: 2004.05.28 Antti Westerlund (antti.westerlund@fimr.fi)
C              and Sergio Jaramillo (sju@eos.ubc.ca).
C              (adopted from SUBROUTINE bilinear by Arne Biastoch)
C     ==================================================================

C     !USES:
      IMPLICIT NONE

C     == global variables ==
#include "SIZE.h"

C     == routine arguments ==
      _RL ix, jy, kz
      _RL uu
      _RL var(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      INTEGER nu, bi, bj, myThid

C     == local variables ==
      INTEGER i1, j1, k1, i2, j2, k2
      _RL ddx, ddy, ddz

C     == end of interface ==

C to choose the u box in which the particle is found
C nu=0 for T, S
C nu=1 for u
C nu=2 for v
C nu=3 for Vorticity
C nu=4 for w

C--   find x-index according to grid-location of variable
      IF ( MOD(nu,2).EQ.0 ) THEN
        i1 = INT(ix)
        ddx = ix - DFLOAT(i1)
      ELSE
        i1 = NINT(ix)
        ddx = 0.5 _d 0 + ix - DFLOAT(i1)
      ENDIF
C--   find y-index according to grid-location of variable
      IF ( MOD(nu,4).LE.1 ) THEN
        j1 = INT(jy)
        ddy = jy - DFLOAT(j1)
      ELSE
        j1 = NINT(jy)
        ddy = 0.5 _d 0 + jy - DFLOAT(j1)
      ENDIF
C--   find z-index according to grid-location of variable
      IF ( nu.LE.3 ) THEN
        k1 = INT(kz)
        ddz = kz - DFLOAT(k1)
      ELSE
        k1 = NINT(kz)
        ddz = 0.5 _d 0 + kz - DFLOAT(k1)
      ENDIF

C--   Set the higher index for interpolation
      i2 = i1 + 1
      j2 = j1 + 1
      k2 = k1 + 1

C--   No need to change start/end horizontal index : use array overlap if needed
C--   Need to adjust start/end vertical index :
      k1 = MIN( MAX( k1, 1 ), Nr )
      k2 = MIN( MAX( k2, 1 ), Nr )

C     Trilinear interpolation, a straight forward generalization
C     of the bilinear interpolation scheme.
      uu = (1.-ddz)*( ( (1.-ddx)*(1.-ddy)*var(i1,j1,k1,bi,bj)
     &                +     ddx * ddy    *var(i2,j2,k1,bi,bj) )
     &              + (     ddx *(1.-ddy)*var(i2,j1,k1,bi,bj)
     &                + (1.-ddx)* ddy    *var(i1,j2,k1,bi,bj) ) )
     &   +   ddz   *( ( (1.-ddx)*(1.-ddy)*var(i1,j1,k2,bi,bj)
     &                +     ddx * ddy    *var(i2,j2,k2,bi,bj) )
     &              + (     ddx*(1.-ddy) *var(i2,j1,k2,bi,bj)
     &                + (1.-ddx)* ddy    *var(i1,j2,k2,bi,bj) ) )

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      SUBROUTINE FLT_BILINEAR2D(
     I                           ix, jy,
     O                           uu,
     I                           var,
     I                           nu, bi, bj, myThid )

C     ==================================================================
C     SUBROUTINE FLT_BILINEAR2D
C     ==================================================================
C     o Bilinear scheme to interpolate 2-D variable to particle position
C       given by its fractional (real) index ix,jy location
C
C     started: Arne Biastoch abiastoch@ucsd.edu 13-Jan-2000
C              (adopted from SUBROUTINE bilinear)
C     ==================================================================

C     !USES:
      IMPLICIT NONE

C     == global variables ==
#include "SIZE.h"

C     == routine arguments ==
      _RL ix, jy
      _RL uu
      _RL var(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      INTEGER nu, bi, bj, myThid

C     == local variables ==
      INTEGER i1, j1, i2, j2
      _RL ddx, ddy

C     == end of interface ==

C to choose the u box in which the particle is found
C nu=0 for T, S
C nu=1 for u
C nu=2 for v
C nu=3 for Vorticity
C nu=4 for w

C--   find x-index according to grid-location of variable
      IF ( MOD(nu,2).EQ.0 ) THEN
        i1 = INT(ix)
        ddx = ix - DFLOAT(i1)
      ELSE
        i1 = NINT(ix)
        ddx = 0.5 _d 0 + ix - DFLOAT(i1)
      ENDIF
C--   find y-index according to grid-location of variable
      IF ( MOD(nu,4).LE.1 ) THEN
        j1 = INT(jy)
        ddy = jy - DFLOAT(j1)
      ELSE
        j1 = NINT(jy)
        ddy = 0.5 _d 0 + jy - DFLOAT(j1)
      ENDIF

C--   Set the higher index for interpolation
      i2 = i1 + 1
      j2 = j1 + 1

C--   No need to change start/end index : use array overlap if needed

C bilinear interpolation (from numerical recipes)
      uu =            ( (1.-ddx)*(1.-ddy)*var(i1,j1,bi,bj)
     &                +     ddx * ddy    *var(i2,j2,bi,bj) )
     &              + (     ddx *(1.-ddy)*var(i2,j1,bi,bj)
     &                + (1.-ddx)* ddy    *var(i1,j2,bi,bj) )

      RETURN
      END

!=======================================================================
      subroutine MITCOUPLER_register( compName, nnx, nny )
      implicit none

! MPI variables
#include "mpif.h"

! Predefined constants/arrays
#include "CPLR_SIG.h"

! Arguments
      character*(*) compName
      integer nnx, nny

! Functions
      integer mitcplr_match_comp
      integer generate_tag
      external mitcplr_match_comp
      external generate_tag

! Local
      integer n,numprocs
      integer comm
      integer compind,count,dtype,tag,rank
      integer ierr
      integer stat(MPI_STATUS_SIZE)
      integer numtiles,nx,ny,i0,j0
      integer ibuf(MAX_IBUF)

!     ------------------------------------------------------------------

! Establish who I am communicating with
      compind=mitcplr_match_comp( compName )
      if (compind.le.0) STOP 'MITCOUPLER_register: Bad component'
      comm=MPI_COMM_compcplr( compind )
      numprocs=num_component_procs(compind)
      if (numprocs.lt.1) then
       write(LogUnit,*) 'MITCOUPLER_register: compind = ',compind
       STOP 'MITCOUPLER_register: numprocs < 1'
      endif

! Foreach component process
      do n=1,numprocs

! Receive message
       count=MAX_IBUF
       dtype=MPI_INTEGER
       tag=generate_tag(115,n,'Register')
       rank=rank_component_procs(n,compind)

       call MPI_Recv(ibuf, count, dtype, rank, tag, comm, stat, ierr)

       if (ierr.ne.0) then
        write(LogUnit,*) 'MITCOUPLER_register: rank(W,G)=',
     &            my_rank_in_world,my_rank_in_global,
     &            ' ierr=',ierr
        STOP 'MITCOUPLER_register: MPI_Recv failed'
       endif

! Extract data
       numtiles=ibuf(1)
       nx=ibuf(2)
       ny=ibuf(3)
       i0=ibuf(4)
       j0=ibuf(5)

       if (numtiles.ne.1) then
        write(LogUnit,*) 'MITCOUPLER_tile_register: #tiles = ',numtiles
        STOP 'MITCOUPLER_tile_register: invalid value for numtiles'
       endif
       if (nx.lt.1) then
        write(LogUnit,*) 'MITCOUPLER_register: nx = ',nx
        STOP 'MITCOUPLER_register: invalid value for nx'
       endif
       if (ny.lt.1) then
        write(LogUnit,*) 'MITCOUPLER_register: ny = ',ny
        STOP 'MITCOUPLER_register: invalid value for ny'
       endif
       if (i0.lt.1) then
        write(LogUnit,*) 'MITCOUPLER_register: i0 = ',i0
        STOP 'MITCOUPLER_register: invalid value for i0'
       endif
       if (j0.lt.1) then
        write(LogUnit,*) 'MITCOUPLER_register: j0 = ',j0
        STOP 'MITCOUPLER_register: invalid value for j0'
       endif
       if (i0+nx-1.gt.nnx) then
        write(LogUnit,*) 'MITCOUPLER_register: i0 = ',i0
        STOP 'MITCOUPLER_register: i0 + nx -1 > nnx'
       endif
       if (j0+ny-1.gt.nny) then
        write(LogUnit,*) 'MITCOUPLER_register: j0 = ',j0
        STOP 'MITCOUPLER_register: j0 + ny -1 > nny'
       endif

       component_num_tiles(n,compind)=1
       component_tile_nx(1,n,compind)=nx
       component_tile_ny(1,n,compind)=ny
       component_tile_i0(1,n,compind)=i0
       component_tile_j0(1,n,compind)=j0

      enddo ! n

      do n=1,numprocs
       write(LogUnit,*) 'MITCOUPLER_register: proc,nx,ny = ',n,
     &    component_tile_nx(1,n,compind),component_tile_ny(1,n,compind)
      enddo ! n

!     ------------------------------------------------------------------
      call flush(LogUnit)
      return
      end
!=======================================================================

#include "COST_OPTIONS.h"

      subroutine cost_test( myThid )
C     *==========================================================*
C     | subroutine cost_test
C     | o this routine computes the cost function for the tiles
C     |   of this processor
C     *==========================================================*
C     | Notes
C     *==========================================================*
      IMPLICIT NONE

C     == Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "DYNVARS.h"
#include "GRID.h"

#include "cost.h"

C     == Routine arguments ==
C     myThid - Thread number for this instance of the routine.
      integer myThid

#ifdef ALLOW_COST_TEST
C     == Local variables
      integer bi, bj
      _RL thetaRef
      integer i, j, k
      integer ig, jg
      integer itlo,ithi
      integer jtlo,jthi
      _RL  thetaLev(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)

      jtlo = mybylo(mythid)
      jthi = mybyhi(mythid)
      itlo = mybxlo(mythid)
      ithi = mybxhi(mythid)

      if ( useCubedSphereExchange) then
         iLocOut =  7
         jLocOut =  28
         kLocOut =  1
      else
         iLocOut =  80
         jLocOut =  30
         kLocOut =  1
      endif

      CALL READ_FLD_XYZ_RL( hydrogThetaFile, ' ', thetaLev, 0, myThid )

ce    some reference temperature
      thetaRef = 24.0 _d 0

C--   Calculate mask for tracer cells  (0 => land, 1 => water)
      k=1

C--   Calculate cost function on tile of this instance
      do bj = jtlo,jthi
        do bi = itlo,ithi
          do j=1,sNy
          jg = myYGlobalLo-1+(bj-1)*sNy+j
            do i=1,sNx
            ig = myXGlobalLo-1+(bi-1)*sNx+i

#ifndef ALLOW_COST_TSQUARED
            if ((ig .eq. iLocOut) .and. (jg .eq. jLocOut)) then
               write(*,'(a,3(x,i4),a,4(x,i4))')
     &              'COST    ',ig,jg,kLocOut,' TILE ',i,j,bi,bj
               objf_test(bi,bj) = theta(i,j,kLocOut,bi,bj)
cph(
               print *, 'ph-cost ', ig, jg, kLocOut,
     &              theta(i,j,kLocOut,bi,bj)
cph)
            endif
#else
       do k=1,nr
         if (maskC(i,j,k,bi,bj).NE.0.) then
           objf_test(bi,bj) = objf_test(bi,bj) +
     &        (theta(i,j,k,bi,bj)-thetaLev(i,j,k,bi,bj))**2
         endif
       enddo
#endif

            enddo
          enddo
        enddo
      enddo

#endif  /* ALLOW_COST_TEST */

      RETURN
      END

#include "CD_CODE_OPTIONS.h"

CBOP
C !ROUTINE: CD_CODE_SCHEME

C !INTERFACE: ==========================================================
      SUBROUTINE CD_CODE_SCHEME(
     I        bi,bj,k, dPhiHydX,dPhiHydY, guFld,gvFld,
     O        guCor,gvCor,
     I        myTime, myIter, myThid)

C !DESCRIPTION:
C The C-D scheme. The less said the better :-)

C !USES: ===============================================================
C     == Global variables ==
      IMPLICIT NONE
#include "SIZE.h"
#include "DYNVARS.h"
#ifdef ALLOW_CD_CODE
#include "CD_CODE_VARS.h"
#endif
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "SURFACE.h"

C !INPUT PARAMETERS: ===================================================
C  bi,bj                :: tile indices
C  k                    :: vertical level
C     dPhiHydX,Y        :: Gradient (X & Y dir.) of Hydrostatic Potential
C  guFld,gvFld          :: Acceleration (U & V compon.) from the C grid
C  guCor,gvCor          :: Coriolis terms (2 compon.) computed on C grid
C  myTime               :: current time
C  myIter               :: current time-step number
C  myThid               :: thread number

      INTEGER bi,bj,k
      _RL dPhiHydX(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL dPhiHydY(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL    guFld(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL    gvFld(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL    guCor(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL    gvCor(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL     myTime
      INTEGER myIter
      INTEGER myThid


C !LOCAL VARIABLES: ====================================================
#ifdef ALLOW_CD_CODE
C  i,j                  :: loop indices
C  pF                   :: pressure gradient
C  vF                   :: work space
C  aF                   :: work space
      INTEGER i,j
      _RL pF(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL vF(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL aF(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL ab15,ab05
      _RL phxFac, phyFac
C     Define ranges
      INTEGER iMin,iMax, jMin,jMax
      PARAMETER( iMin = 1-OLx+1 , iMax = sNx+OLx-1 )
      PARAMETER( jMin = 1-OLy+1 , jMax = sNy+OLy-1 )
CEOP

C     Adams-Bashforth weighting factors
      IF ( myIter.EQ.0 ) THEN
        ab15   =  1. _d 0
        ab05   = -0. _d 0
      ELSE
        ab15   =  1.5 _d 0 + epsAB_CD
        ab05   = -0.5 _d 0 - epsAB_CD
      ENDIF

C-- stagger time stepping: grad Phi_Hyp is not in gU,gV and needs to be added:
      IF (staggerTimeStep) THEN
        phxFac = pfFacMom
        phyFac = pfFacMom
      ELSE
        phxFac = 0.
        phyFac = 0.
      ENDIF

C-    Initialize output (dummy) arrays:
c     DO j=1-OLy,sNy+OLy
c      DO i=1-OLx,sNx+OLx
c       guCor(i,j) = 0. _d 0
c       gvCor(i,j) = 0. _d 0
c      ENDDO
c     ENDDO

C     Pressure extrapolated forward in time
      DO j=1-OLy,sNy+OLy
       DO i=1-OLx,sNx+OLx
#ifdef CD_CODE_NO_AB_CORIOLIS
C     Keep this just to reproduce old results (to get same truncation)
        pf(i,j) =
     &   ab15*(  etaN(i,j,bi,bj)*Bo_surf(i,j,bi,bj) )
     &  +ab05*(etaNm1(i,j,bi,bj)*Bo_surf(i,j,bi,bj) )
#else /* CD_CODE_NO_AB_CORIOLIS */
        pf(i,j) = Bo_surf(i,j,bi,bj)
     &          *( ab15*etaN(i,j,bi,bj) + ab05*etaNm1(i,j,bi,bj) )
#endif /* CD_CODE_NO_AB_CORIOLIS */
       ENDDO
      ENDDO

C--   Zonal velocity coriolis term
C     Note. As coded here, coriolis will not work with "thin walls"
C--   Coriolis with CD scheme allowed
C     grady(p) + gV
      DO j=1-OLy+1,sNy+OLy
       DO i=1-OLx,sNx+OLx
        af(i,j) =
     &        (  gvFld(i,j)
     &          -( _recip_dyC(i,j,bi,bj)*(pf(i,j)-pf(i,j-1))
     &            +phyFac*dPhiHydY(i,j) )
     &        )*_maskS(i,j,k,bi,bj)
#ifdef ALLOW_OBCS
     &         *maskInC(i,j-1,bi,bj)*maskInC(i,j,bi,bj)
#endif
       ENDDO
      ENDDO
C     Average to Vd point and add coriolis
      DO j=jMin,jMax
       DO i=iMin,iMax
        vf(i,j) =
     &           ( (af(i,j)+af(i-1,j+1))
     &            +(af(i-1,j)+af(i,j+1)) )*0.25 _d 0
     &           *_maskW(i,j,k,bi,bj)
     &          -( _fCori( i, j,bi,bj)
     &            +_fCori(i-1,j,bi,bj) )*0.5 _d 0
#ifdef CD_CODE_NO_AB_CORIOLIS
     &           *uVel(i,j,k,bi,bj)
#else /* CD_CODE_NO_AB_CORIOLIS */
     &           *( ab15*uVel(i,j,k,bi,bj) + ab05*uNM1(i,j,k,bi,bj) )
#endif /* CD_CODE_NO_AB_CORIOLIS */
       ENDDO
      ENDDO
C     Step forward Vd
      DO j=jMin,jMax
       DO i=iMin,iMax
        vVelD(i,j,k,bi,bj) = vVelD(i,j,k,bi,bj) + deltaTmom*vf(i,j)
       ENDDO
      ENDDO
C     Relax D grid V to C grid V
      DO j=jMin,jMax
       DO i=iMin,iMax
         vVelD(i,j,k,bi,bj) = ( rCD*vVelD(i,j,k,bi,bj)
     &                         +(1. _d 0 - rCD)
     &         *( ab15*(
     &                  (vVel(i,j,k,bi,bj)+vVel(i-1,j+1,k,bi,bj))
     &                 +(vVel(i-1,j,k,bi,bj)+vVel(i,j+1,k,bi,bj))
     &                 )*0.25 _d 0
     &           +ab05*(
     &                  (vNM1(i,j,k,bi,bj)+vNM1(i-1,j+1,k,bi,bj))
     &                 +(vNM1(i-1,j,k,bi,bj)+vNM1(i,j+1,k,bi,bj))
     &                 )*0.25 _d 0
     &          )             )*_maskW(i,j,k,bi,bj)
       ENDDO
      ENDDO
C     Calculate coriolis force on U
      DO j=jMin,jMax
       DO i=iMin,iMax
        guCor(i,j) =
     &              ( _fCori( i, j,bi,bj)
     &               +_fCori(i-1,j,bi,bj) )*0.5 _d 0
     &              *vVelD(i,j,k,bi,bj)*cfFacMom
       ENDDO
      ENDDO

C--   Meridional velocity coriolis term
C     gradx(p)+gU
      DO j=1-OLy,sNy+OLy
       DO i=1-OLx+1,sNx+OLx
        af(i,j) =
     &        (  guFld(i,j)
     &          -( _recip_dxC(i,j,bi,bj)*(pf(i,j)-pf(i-1,j))
     &            +phxFac*dPhiHydX(i,j) )
     &        )*_maskW(i,j,k,bi,bj)
#ifdef ALLOW_OBCS
     &         *maskInC(i-1,j,bi,bj)*maskInC(i,j,bi,bj)
#endif
       ENDDO
      ENDDO
C     Average to Ud point and add coriolis
      DO j=jMin,jMax
       DO i=iMin,iMax
        vf(i,j) =
     &           ( (af(i,j)+af(i+1,j-1))
     &            +(af(i+1,j)+af(i,j-1)) )*0.25 _d 0
     &           *_maskS(i,j,k,bi,bj)
     &          +( _fCori(i, j, bi,bj)
     &            +_fCori(i,j-1,bi,bj) )*0.5 _d 0
#ifdef CD_CODE_NO_AB_CORIOLIS
     &           *vVel(i,j,k,bi,bj)
#else /* CD_CODE_NO_AB_CORIOLIS */
     &           *( ab15*vVel(i,j,k,bi,bj) + ab05*vNM1(i,j,k,bi,bj) )
#endif /* CD_CODE_NO_AB_CORIOLIS */
       ENDDO
      ENDDO
C     Step forward Ud
      DO j=jMin,jMax
       DO i=iMin,iMax
        uVelD(i,j,k,bi,bj) = uVelD(i,j,k,bi,bj) + deltaTmom*vf(i,j)
       ENDDO
      ENDDO
C     Relax D grid U to C grid U
      DO j=jMin,jMax
       DO i=iMin,iMax
         uVelD(i,j,k,bi,bj) = ( rCD*uVelD(i,j,k,bi,bj)
     &                         +(1. _d 0 - rCD)
     &         *( ab15*(
     &                  (uVel(i,j,k,bi,bj)+uVel(i+1,j-1,k,bi,bj))
     &                 +(uVel(i,j-1,k,bi,bj)+uVel(i+1,j,k,bi,bj))
     &                 )*0.25 _d 0
     &           +ab05*(
     &                  (uNM1(i,j,k,bi,bj)+uNM1(i+1,j-1,k,bi,bj))
     &                 +(uNM1(i,j-1,k,bi,bj)+uNM1(i+1,j,k,bi,bj))
     &                 )*0.25 _d 0
     &          )             )*_maskS(i,j,k,bi,bj)
       ENDDO
      ENDDO
C     Calculate coriolis force on V
      DO j=jMin,jMax
       DO i=iMin,iMax
        gvCor(i,j) =
     &             -( _fCori(i, j, bi,bj)
     &               +_fCori(i,j-1,bi,bj) )*0.5 _d 0
     &              *uVelD(i,j,k,bi,bj)*cfFacMom
       ENDDO
      ENDDO

C--   Save "previous time level" variables
      DO j=1-OLy,sNy+OLy
       DO i=1-OLx,sNx+OLx
         uNM1(i,j,k,bi,bj) = uVel(i,j,k,bi,bj)
         vNM1(i,j,k,bi,bj) = vVel(i,j,k,bi,bj)
       ENDDO
      ENDDO

#endif /* ALLOW_CD_CODE */

      RETURN
      END

MODULE ADMM_TAPENADE_INTERFACE
  IMPLICIT NONE
  INTERFACE PUSHPOINTER8
      SUBROUTINE PUSHPOINTER8(pp) BIND(c, name='pushPointer8')
        USE ISO_C_BINDING
        TYPE(C_PTR), VALUE :: pp
      END SUBROUTINE PUSHPOINTER8
  END INTERFACE PUSHPOINTER8

  INTERFACE POPPOINTER8
      SUBROUTINE POPPOINTER8(pp) BIND(c, name='popPointer8')
        USE ISO_C_BINDING
        TYPE(C_PTR) :: pp
      END SUBROUTINE POPPOINTER8
  END INTERFACE POPPOINTER8

  INTERFACE ADMM_REGISTERSHADOWED
      SUBROUTINE ADMM_REGISTERSHADOWED(base, obase, size, baseb, obaseb&
&       , sizeb, nbelem) BIND(c, name='ADMM_registerShadowed')
        USE ISO_C_BINDING
        TYPE(C_PTR), VALUE :: base, obase
        TYPE(C_PTR), VALUE :: baseb, obaseb
        INTEGER, VALUE :: size, sizeb
        INTEGER, VALUE :: nbelem
      END SUBROUTINE ADMM_REGISTERSHADOWED
  END INTERFACE ADMM_REGISTERSHADOWED

  INTERFACE ADMM_REGISTER
      SUBROUTINE ADMM_REGISTER(base, obase, size, nbelem) BIND(c, name=&
&     'ADMM_register')
        USE ISO_C_BINDING
        TYPE(C_PTR), VALUE :: base, obase
        INTEGER, VALUE :: size
        INTEGER, VALUE :: nbelem
      END SUBROUTINE ADMM_REGISTER
  END INTERFACE ADMM_REGISTER

  INTERFACE ADMM_UNREGISTERSHADOWED
      SUBROUTINE ADMM_UNREGISTERSHADOWED(base, baseb, nbelem) BIND(c, &
&     name='ADMM_unregisterShadowed')
        USE ISO_C_BINDING
        TYPE(C_PTR), VALUE :: base, baseb
        INTEGER :: nbelem
      END SUBROUTINE ADMM_UNREGISTERSHADOWED
  END INTERFACE ADMM_UNREGISTERSHADOWED

  INTERFACE ADMM_UNREGISTER
      SUBROUTINE ADMM_UNREGISTER(base, nbelem) BIND(c, name=&
&     'ADMM_unregister')
        USE ISO_C_BINDING
        TYPE(C_PTR), VALUE :: base
        INTEGER :: nbelem
      END SUBROUTINE ADMM_UNREGISTER
  END INTERFACE ADMM_UNREGISTER

  INTERFACE ADMM_REBASESHADOWED
      SUBROUTINE ADMM_REBASESHADOWED(base, baseb) BIND(c, name=&
&     'ADMM_rebaseShadowed')
        USE ISO_C_BINDING
        TYPE(C_PTR) :: base, baseb
      END SUBROUTINE ADMM_REBASESHADOWED
  END INTERFACE ADMM_REBASESHADOWED

  INTERFACE ADMM_REBASE
      SUBROUTINE ADMM_REBASE(base) BIND(c, name='ADMM_rebase')
        USE ISO_C_BINDING
        TYPE(C_PTR) :: base
      END SUBROUTINE ADMM_REBASE
  END INTERFACE ADMM_REBASE

END MODULE ADMM_TAPENADE_INTERFACE

#include "FIZHI_OPTIONS.h"
      subroutine gwdrag (myid,pz,pl,ple,dpres,pkz,uz,vz,tz,qz,phis_var,
     .         dudt,dvdt,dtdt,im,jm,Lm,bi,bj,istrip,npcs,imglobal)
C***********************************************************************
C
C  PURPOSE:
C  ========
C    Driver Routine for Gravity Wave Drag
C
C  INPUT:
C  ======
C  myid  ....... Process ID
C  pz    ....... Surface Pressure [im,jm]
C  pl    ....... 3D pressure field [im,jm,Lm]
C  ple   ....... 3d pressure at model level edges [im,jm,Lm+1]
C  dpres ....... pressure difference across level [im,jm,Lm]
C  pkz   ....... pressure**kappa [im,jm,Lm]
C  uz    ....... zonal velocity [im,jm,Lm]
C  vz    ....... meridional velocity [im,jm,Lm]
C  tz    ....... temperature [im,jm,Lm]
C  qz    ....... specific humidity [im,jm,Lm]
C  phis_var .... topography variance
C  im    ....... number of grid points in x direction
C  jm    ....... number of grid points in y direction
C  Lm    ....... number of grid points in vertical
C  istrip ...... 'strip' length for cache size control
C  npcs  ....... number of strips
C  imglobal .... (avg) number of longitude points around the globe
C
C  INPUT/OUTPUT:
C  ============
C  dudt  ....... Updated U-Wind   Tendency including Gravity Wave Drag
C  dvdt  ....... Updated V-Wind   Tendency including Gravity Wave Drag
C  dtdt  ....... Updated Pi*Theta Tendency including Gravity Wave Drag
C
C***********************************************************************
      implicit none

c Input Variables
c ---------------
      integer myid,im,jm,Lm,bi,bj,istrip,npcs,imglobal
      _RL pz(im,jm)
      _RL pl(im,jm,Lm)
      _RL ple(im,jm,Lm+1)
      _RL dpres(im,jm,Lm)
      _RL pkz(im,jm,Lm)
      _RL uz(im,jm,Lm)
      _RL vz(im,jm,Lm)
      _RL tz(im,jm,Lm)
      _RL qz(im,jm,Lm)
      _RL phis_var(im,jm)

      _RL dudt(im,jm,Lm)
      _RL dvdt(im,jm,Lm)
      _RL dtdt(im,jm,Lm)

c Local Variables
c ---------------
      _RL tv(im,jm,Lm)
      _RL dragu(im,jm,Lm), dragv(im,jm,Lm)
      _RL dragt(im,jm,Lm) 
      _RL dragx(im,jm), dragy(im,jm)
      _RL sumu(im,jm)
      integer nthin(im,jm),nbase(im,jm)
      integer nthini, nbasei

      _RL phis_std(im,jm)

      _RL std(istrip), ps(istrip)
      _RL us(istrip,Lm), vs(istrip,Lm), ts(istrip,Lm)
      _RL dragus(istrip,Lm), dragvs(istrip,Lm) 
      _RL dragxs(istrip), dragys(istrip)
      _RL plstr(istrip,Lm),plestr(istrip,Lm+1),dpresstr(istrip,Lm)
      integer nthinstr(istrip),nbasestr(istrip)

      integer n,i,j,L
      _RL getcon, pi
      _RL grav, rgas, cp, cpinv, lstar
#ifdef ALLOW_DIAGNOSTICS
      logical  diagnostics_is_on
      external diagnostics_is_on
      _RL tmpdiag(im,jm)
#endif

c Initialization
c --------------
      pi    = 4.0*atan(1.0)
      grav  = getcon('GRAVITY')
      rgas  = getcon('RGAS')
      cp    = getcon('CP')
      cpinv = 1.0/cp
      lstar = 2*getcon('EARTH RADIUS')*cos(pi/3.0)/imglobal

c Compute NTHIN and NBASE
c -----------------------
      do j=1,jm
      do i=1,im

      do nthini = 1,Lm+1
       if( pz(i,j)-ple(i,j,Lm+2-nthini).gt.25. ) then
        nthin(i,j) = nthini
        goto 10
       endif
      enddo
   10 continue
      do nbasei = 1,Lm+1
       if( ple(i,j,Lm+2-nbasei).lt.(0.667*pz(i,j)) ) then
        nbase(i,j) = nbasei
        goto 20
       endif
      enddo
   20 continue
      if( (0.667*pz(i,j))-ple(i,j,Lm+2-nbase(i,j)) .gt. 
     .           ple(i,j,Lm+3-nbase(i,j))-(0.667*pz(i,j)) ) then
      nbase(i,j) = nbase(i,j)-1
      endif

      enddo
      enddo

c Compute Topography Sub-Grid Standard Deviation
c        and constrain the Maximum Value
c ----------------------------------------------
      do j=1,jm
      do i=1,im
         phis_std(i,j) = min( 400.0 _d 0, sqrt( max(0.0 _d 0,
     $        phis_var(i,j)) )/grav )
      enddo
      enddo

c Compute Virtual Temperatures
c ----------------------------
      do L = 1,Lm
      do j = 1,jm
      do i = 1,im
      tv(i,j,L) = tz(i,j,L)*pkz(i,j,L)*(1.+.609*qz(i,j,L))
      enddo
      enddo
      enddo

      do L = 1,Lm
      do j = 1,jm
      do i = 1,im
       dragu(i,j,L) = 0.
       dragv(i,j,L) = 0.
       dragt(i,j,L) = 0.
      enddo
      enddo
      enddo

c Call Gravity Wave Drag Paramterization on A-Grid
c ------------------------------------------------

      do n=1,npcs

      call stripit ( phis_std,std,im*jm,im*jm,istrip,1,n )

      call stripit ( pz,ps,im*jm,im*jm,istrip,1 ,n )
      call stripit ( uz,us,im*jm,im*jm,istrip,Lm,n )
      call stripit ( vz,vs,im*jm,im*jm,istrip,Lm,n )
      call stripit ( tv,ts,im*jm,im*jm,istrip,Lm,n )
      call stripit ( pl,plstr,im*jm,im*jm,istrip,Lm,n )
      call stripit ( ple,plestr,im*jm,im*jm,istrip,Lm+1,n )
      call stripit ( dpres,dpresstr,im*jm,im*jm,istrip,Lm,n )
      call stripitint ( nthin,nthinstr,im*jm,im*jm,istrip,1,n )
      call stripitint ( nbase,nbasestr,im*jm,im*jm,istrip,1,n )

      call GWDD ( ps,us,vs,ts,
     .            dragus,dragvs,dragxs,dragys,std,
     .            plstr,plestr,dpresstr,grav,rgas,cp,
     .            istrip,Lm,nthinstr,nbasestr,lstar )

      call pastit( dragus,dragu,istrip,im*jm,im*jm,Lm,n )
      call pastit( dragvs,dragv,istrip,im*jm,im*jm,Lm,n )
      call pastit( dragxs,dragx,istrip,im*jm,im*jm,1 ,n )
      call pastit( dragys,dragy,istrip,im*jm,im*jm,1 ,n )

      enddo

c Add Gravity-Wave Drag to Wind and Theta Tendencies
c -------------------------------------------------- 
      do L = 1,Lm
      do j = 1,jm
      do i = 1,im
         dragu(i,j,L) = sign( min(0.006 _d 0,abs(dragu(i,j,L))), dragu(i
     $        ,j,L) ) 
         dragv(i,j,L) = sign( min(0.006 _d 0,abs(dragv(i,j,L))), dragv(i
     $        ,j,L) ) 
      dragt(i,j,L) = -( uz(i,j,L)*dragu(i,j,L)+vz(i,j,L)*dragv(i,j,L) )
     .                                                         *cpinv
       dudt(i,j,L) = dudt(i,j,L) + dragu(i,j,L)
       dvdt(i,j,L) = dvdt(i,j,L) + dragv(i,j,L)
       dtdt(i,j,L) = dtdt(i,j,L) + dragt(i,j,L)*pz(i,j)/pkz(i,j,L)
      enddo
      enddo
      enddo

c Compute Diagnostics
c -------------------
#ifdef ALLOW_DIAGNOSTICS
      do L = 1,Lm

      if(diagnostics_is_on('GWDU    ',myid) ) then
       do j=1,jm
       do i=1,im
        tmpdiag(i,j) = dragu(i,j,L)*86400
       enddo
       enddo
       call diagnostics_fill(tmpdiag,'GWDU    ',L,1,3,bi,bj,myid)
      endif

      if(diagnostics_is_on('GWDV    ',myid) ) then
       do j=1,jm
       do i=1,im
        tmpdiag(i,j) = dragv(i,j,L)*86400
       enddo
       enddo
       call diagnostics_fill(tmpdiag,'GWDV    ',L,1,3,bi,bj,myid)
      endif

      if(diagnostics_is_on('GWDT    ',myid) ) then
       do j=1,jm
       do i=1,im
        tmpdiag(i,j) = dragt(i,j,L)*86400
       enddo
       enddo
       call diagnostics_fill(tmpdiag,'GWDT    ',L,1,3,bi,bj,myid)
      endif

      enddo

c Gravity Wave Drag at Surface (U-Wind)
c -------------------------------------
      if(diagnostics_is_on('GWDUS   ',myid) ) then
       call diagnostics_fill(dragx,'GWDUS   ',0,1,3,bi,bj,myid)
      endif

c Gravity Wave Drag at Surface (V-Wind)
c -------------------------------------
      if(diagnostics_is_on('GWDVS   ',myid) ) then
       call diagnostics_fill(dragy,'GWDVS   ',0,1,3,bi,bj,myid)
      endif

c Gravity Wave Drag at Model Top (U-Wind)
c ---------------------------------------
      if(diagnostics_is_on('GWDUT   ',myid) ) then
      do j = 1,jm
      do i = 1,im
      sumu(i,j) = 0.0
      enddo
      enddo
      do L = 1,Lm
      do j = 1,jm
      do i = 1,im
      sumu(i,j) = sumu(i,j) + dragu(i,j,L)*dpres(i,j,L)/pz(i,j)
      enddo
      enddo
      enddo
       do j=1,jm
       do i=1,im
        tmpdiag(i,j) = dragx(i,j) + sumu(i,j)*pz(i,j)/grav*100
       enddo
       enddo
       call diagnostics_fill(tmpdiag,'GWDUT   ',0,1,3,bi,bj,myid)
      endif

c Gravity Wave Drag at Model Top (V-Wind)
c ---------------------------------------
      if(diagnostics_is_on('GWDVT   ',myid) ) then
      do j = 1,jm
      do i = 1,im
      sumu(i,j) = 0.0
      enddo
      enddo
      do L = 1,Lm
      do j = 1,jm
      do i = 1,im
      sumu(i,j) = sumu(i,j) + dragv(i,j,L)*dpres(i,j,L)/pz(i,j)
      enddo
      enddo
      enddo
       do j=1,jm
       do i=1,im
        tmpdiag(i,j) = dragy(i,j) + sumu(i,j)*pz(i,j)/grav*100
       enddo
       enddo
       call diagnostics_fill(tmpdiag,'GWDVT   ',0,1,3,bi,bj,myid)
      endif
#endif

      return
      end
      SUBROUTINE GWDD ( ps,u,v,t,dudt,dvdt,xdrag,ydrag,
     .                  std,pl,ple,dpres,
     .                  grav,rgas,cp,irun,Lm,nthin,nbase,lstar )
C***********************************************************************
C
C Description:
C  ============
C    Parameterization to introduce a Gravity Wave Drag
C    due to sub-grid scale orographic forcing
C
C Input:
C  ======
C    ps ......... Surface Pressure
C    u .......... Zonal      Wind (m/sec)
C    v .......... Meridional Wind (m/sec)
C    t .......... Virtual Temperature (deg K)
C    std ........ Standard Deviation of sub-grid Orography (m)
C    ple  ....... Model pressure Edge Values
C    pl  ........ Model pressure Values
C    dpres....... Model Delta pressure Values
C    grav ....... Gravitational constant (m/sec**2)
C    rgas ....... Gas constant
C    cp ......... Specific Heat at constant pressure
C    irun ....... Number of grid-points in horizontal dimension
C    Lm ......... Number of grid-points in vertical   dimension
C    lstar ...... Monochromatic Wavelength/(2*pi)
C
C Output:
C  =======
C    dudt ....... Zonal Acceleration due to GW Drag (m/sec**2)
C    dvdt ....... Meridional Acceleration due to GW Drag (m/sec**2)
C    xdrag ...... Zonal Surface and Base Layer Stress (Pa)
C    ydrag ...... Meridional Surface and Base Layer Stress (Pa)
C
C NOTE: Quantities computed locally in GWDD use a
C              bottom-up counting of levels
C       The fizhi code uses a top-down so all
C       Quantities that came in through the arg list
C       must use reverse vertical indexing!!!
C***********************************************************************

      implicit none

c Input Variables
c ---------------
      integer irun,Lm
      _RL ps(irun)
      _RL u(irun,Lm), v(irun,Lm), t(irun,Lm)
      _RL dudt(irun,Lm), dvdt(irun,Lm)
      _RL xdrag(irun), ydrag(irun)
      _RL std(irun)
      _RL ple(irun,Lm+1), pl(irun,Lm), dpres(irun,Lm)
      _RL grav, rgas, cp
      integer nthin(irun),nbase(irun)
      _RL lstar

c Dynamic Allocation Variables
c ----------------------------
      _RL ubar(irun), vbar(irun), robar(irun)
      _RL speed(irun), ang(irun)
      _RL bv(irun,Lm)
      _RL nbar(irun)

      _RL XTENS(irun,Lm+1), YTENS(irun,Lm+1)
      _RL TENSIO(irun,Lm+1)
      _RL DRAGSF(irun)
      _RL RO(irun,Lm), DZ(irun,Lm)

      integer icrilv(irun)

c Local Variables
c ---------------
      integer  i,L
      _RL a,g,agrav,akwnmb
      _RL gocp,roave,roiave,frsf,gstar,vai1,vai2
      _RL vaisd,velco,deluu,delvv,delve2,delz,vsqua
      _RL richsn,crifro,crif2,fro2,coef

c Initialization
c --------------
      a      = 1.0
      g      = 1.0
      agrav  = 1.0/grav
      akwnmb = 1.0/lstar
      gocp   = grav/cp

c Compute Atmospheric Density (with virtual temp)
c -----------------------------------------------
      do l = 1,Lm
      do i = 1,irun
       ro(i,L) = pl(i,Lm+1-L)/(rgas*t(i,Lm+1-L))
      enddo
      enddo

c Compute Layer Thicknesses
c -------------------------
      do l = 2,Lm
      do i = 1,irun
       roiave  = ( 1./ro(i,L-1) + 1./ro(i,L) )*0.5
       dz(i,L) = agrav*roiave*( pl(i,Lm+2-L)-pl(i,Lm+1-L) )
      enddo
      enddo


c***********************************************************************
c          Surface and Base Layer Stress                               *
c***********************************************************************

c Definition of Surface Wind Vector
c ---------------------------------
      do  i = 1,irun
       robar(i) = 0.0
       ubar(i) = 0.0
       vbar(i) = 0.0
      enddo

      do  i = 1,irun
      do  L = 1,nbase(i)-1
       robar(i) = robar(i) + ro(i,L) * (ple(i,Lm+2-L)-ple(i,Lm+1-L))
       ubar(i) = ubar(i) + u(i,Lm+1-L) * (ple(i,Lm+2-L)-ple(i,Lm+1-L))
       vbar(i) = vbar(i) + v(i,Lm+1-L) * (ple(i,Lm+2-L)-ple(i,Lm+1-L))
      enddo
      enddo

      do  i = 1,irun
       robar(i) = robar(i)/(ps(i)-ple(i,Lm+1-(nbase(i)-1))) * 100.0
       ubar(i) = ubar(i)/(ps(i)-ple(i,Lm+1-(nbase(i)-1)))
       vbar(i) = vbar(i)/(ps(i)-ple(i,Lm+1-(nbase(i)-1)))

       speed(i) = sqrt( ubar(i)*ubar(i) + vbar(i)*vbar(i) )
       ang(i) = atan2(vbar(i),ubar(i))
      enddo

c Brunt Vaisala Frequency
c -----------------------
      do i = 1,irun
       do l = 2,nbase(i)
        vai1 = (t(i,Lm+1-L)-t(i,Lm+2-L))/dz(i,L)+gocp
        if( vai1.LT.0.0 ) then
         vai1 =  0.0
        endif
        vai2    = 2.0*grav/( t(i,Lm+1-L)+t(i,Lm+2-L) )
        vsqua   = vai1*vai2
        bv(i,L) = sqrt(vsqua)
       enddo
      enddo

c Stress at the Surface Level
c ---------------------------
      do i = 1,irun
       nbar(i) = 0.0
      enddo
      do i = 1,irun
      do l = 2,nbase(i)
       nbar(i) = nbar(i) + bv(i,L)*(pl(i,Lm+2-L)-pl(i,Lm+1-L))
      enddo
      enddo

      do i = 1,irun
       nbar(i) = nbar(i)/(pl(i,Lm)-pl(i,Lm+1-nbase(i)))
       frsf = nbar(i)*std(i)/speed(i)

       if( speed(i).eq.0.0 .or. nbar(i).eq.0.0 ) then
        tensio(i,1) = 0.0
       else
        gstar = g*frsf*frsf/(frsf*frsf+a*a)
        tensio(i,1) = gstar*(robar(i)*speed(i)*speed(i)*speed(i))
     .            / (nbar(i)*lstar)
       endif

       xtens(i,1) = tensio(i,1) * cos(ang(i))
       ytens(i,1) = tensio(i,1) * sin(ang(i))
       dragsf(i) = tensio(i,1)
       xdrag(i) = xtens(i,1)
       ydrag(i) = ytens(i,1)
      enddo

c Check for Very thin lowest layer
c --------------------------------
      do i = 1,irun
       if( nthin(i).gt.1 ) then
        do l = 1,nthin(i)
         tensio(i,L) = tensio(i,1)
         xtens(i,L) = xtens(i,1)
         ytens(i,L) = ytens(i,1)
        enddo
       endif
      enddo

c******************************************************
c  Compute Gravity Wave Stress from NTHIN+1 to NBASE  *
c******************************************************

      do i = 1,irun
       do l = nthin(i)+1,nbase(i)

        velco = 0.5*( (u(i,Lm+1-L)*ubar(i) + v(i,Lm+1-L)*vbar(i))
     .            + (u(i,Lm+2-L)*ubar(i) + v(i,Lm+2-L)*vbar(i))  )
     .      /   speed(i)

C Convert to Newton/m**2
        roave = 0.5*(ro(i,L-1)+ro(i,L)) * 100.0     

        if( velco.le.0.0 ) then
         tensio(i,L) = tensio(i,L-1)
         goto 1500
        endif
                    
c Froude number squared
c ---------------------
        fro2 = bv(i,L)/(akwnmb*roave*velco*velco*velco)*tensio(i,L-1)
        deluu = u(i,Lm+1-L)-u(i,Lm+2-L)
        delvv = v(i,Lm+1-L)-v(i,Lm+2-L)
        delve2 = ( deluu*deluu + delvv*delvv )

c Compute Richarson Number
c ------------------------
        if( delve2.ne.0.0 ) then
         delz = dz(i,L)
         vsqua = bv(i,L)*bv(i,L)
         richsn = delz*delz*vsqua/delve2
        else
         richsn = 99999.0
        endif

        if( richsn.le.0.25 ) then
         tensio(i,L) = tensio(i,L-1)
         goto 1500
        endif

c Stress in the Base Layer changes if the local Froude number
c exceeds the Critical Froude number
c ----------------------------------
        crifro = 1.0 - 0.25/richsn
        crif2 = crifro*crifro
        if( l.eq.2 ) crif2 = min(0.7 _d 0,crif2)

        if( fro2.gt.crif2 ) then
         tensio(i,L) = crif2/fro2*tensio(i,L-1)
        else
         tensio(i,L) = tensio(i,L-1)
        endif

1500    continue
        xtens(i,L) = tensio(i,L)*cos(ang(i))
        ytens(i,L) = tensio(i,L)*sin(ang(i))

       enddo
      enddo

c******************************************************
c    Compute Gravity Wave Stress from Base+1 to Top   *
c******************************************************

      do i = 1,irun
       icrilv(i) = 0
      enddo

      do i = 1,irun
       do l = nbase(i)+1,Lm+1

        tensio(i,L) = 0.0

c Check for Critical Level Absorption
c -----------------------------------
        if( icrilv(i).eq.1 ) goto 130

c Let Remaining Stress escape out the top edge of model
c -----------------------------------------------------
        if( l.eq.Lm+1 ) then
         tensio(i,L) = tensio(i,L-1)
         goto 130
        endif

        roave = 0.5*(ro(i,L-1)+ro(i,L)) * 100.0
        vai1  = (t(i,Lm+1-L)-t(i,Lm+2-L))/dz(i,L)+gocp
 
        if( vai1.lt.0.0 ) then
         icrilv(i)   = 1
         tensio(i,L) = 0.0
         goto 130
        endif

        vai2  = 2.0*grav/(t(i,Lm+1-L)+t(i,Lm+2-L))
        vsqua = vai1*vai2
        vaisd = sqrt(vsqua)

        velco = 0.5*( (u(i,Lm+1-L)*ubar(i) + v(i,Lm+1-L)*vbar(i))
     .            + (u(i,Lm+2-L)*ubar(i) + v(i,Lm+2-L)*vbar(i))  )
     .      /   speed(i)

        if( velco.lt.0.0 ) then
         icrilv(i)   = 1
         tensio(i,L) = 0.0
         goto 130
        endif

c Froude number squared
c ---------------------
        fro2 = vaisd/(akwnmb*roave*velco*velco*velco)*tensio(i,L-1)
        deluu = u(i,Lm+1-L)-u(i,Lm+2-L)
        delvv = v(i,Lm+1-L)-v(i,Lm+2-L)
        delve2 = ( deluu*deluu + delvv*delvv )

c Compute Richarson Number
c ------------------------
        if( delve2.ne.0.0 ) then
         delz   = dz(i,L)
         richsn = delz*delz*vsqua/delve2
        else
         richsn = 99999.0
        endif

        if( richsn.le.0.25 ) then
         tensio(i,L) = 0.0
         icrilv(i)   = 1
         goto 130
        endif

c Stress in Layer changes if the local Froude number
c exceeds the Critical Froude number
c ----------------------------------
        crifro = 1.0 - 0.25/richsn
        crif2 = crifro*crifro

        if( fro2.ge.crif2 ) then
         tensio(i,L) = crif2/fro2*tensio(i,L-1)
        else
         tensio(i,L) = tensio(i,L-1)
        endif

  130   continue
        xtens(i,L) = tensio(i,L)*cos(ang(i))
        ytens(i,L) = tensio(i,L)*sin(ang(i))
       enddo
      enddo
 
C ******************************************************
C       MOMENTUM CHANGE FOR FREE ATMOSPHERE            *
C ******************************************************
 
      do i = 1,irun
      do l = nthin(i)+1,Lm
       coef = -grav*ps(i)/dpres(i,Lm+1-L)
       dudt(i,Lm+1-L) = coef*(xtens(i,L+1)-xtens(i,L))
       dvdt(i,Lm+1-L) = coef*(ytens(i,L+1)-ytens(i,L))
      enddo
      enddo
 
c Momentum change near the surface
c --------------------------------
      do i = 1,irun
       coef = grav*ps(i)/(ple(i,Lm+1-nthin(i))-ple(i,Lm+1))
       dudt(i,Lm) = coef*(xtens(i,nthin(i)+1)-xtens(i,1))
       dvdt(i,Lm) = coef*(ytens(i,nthin(i)+1)-ytens(i,1))
      enddo

c If Lowest layer is very thin, it is strapped to next layer
c ----------------------------------------------------------
      do i = 1,irun
       if( nthin(i).gt.1 ) then
        do l = 2,nthin(i)
         dudt(i,Lm+1-L) = dudt(i,Lm)
         dvdt(i,Lm+1-L) = dvdt(i,Lm)
        enddo
       endif
      enddo

c Convert Units to (m/sec**2)
c --------------------------- 
      do l = 1,Lm
      do i = 1,irun
       dudt(i,L) = - dudt(i,L)/ps(i)*0.01
       dvdt(i,L) = - dvdt(i,L)/ps(i)*0.01
      enddo
      enddo

      return
      end

#include "LONGSTEP_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: LONGSTEP_READPARMS

C     !INTERFACE:
      SUBROUTINE LONGSTEP_READPARMS( myThid )

C     !DESCRIPTION:
C     Initialize longstep parameters, read in data.longstep

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "LONGSTEP_PARAMS.h"

C     !INPUT PARAMETERS:
      INTEGER myThid
CEOP

#ifdef ALLOW_LONGSTEP

C     !LOCAL VARIABLES:
C     iUnit      :: unit number for I/O
C     msgBuf     :: message buffer
      INTEGER iUnit
      CHARACTER*(MAX_LEN_MBUF) msgBuf

C     LS_nIter        :: number of dynamics time steps between ptracer steps
C     LS_whenToSample :: when to sample dynamical fields for the longstep average
C                        0 - at beginning of timestep (reproduces offline results)
C                        1 - after first THERMODYNAMICS but before DYNAMICS
C                            (use use old U,V,W for advection, but new T,S for GCHEM if
C                            staggerTimeStep=.FALSE.; reproduces online with
C                            staggerTimeStep=.FALSE. for LS_nIter=1)
C                        2 - after DYNAMICS and second THERMODYNAMICS
C                            (use new U,V,W and T,S; reproduces online with
C                            staggerTimeStep=.TRUE. for LS_nIter=1)
      NAMELIST /LONGSTEP_PARM01/
     &     LS_nIter, LS_whenToSample

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      IF ( .NOT.usePTRACERS ) THEN
C-    pkg LONGSTEP is not used
        _BEGIN_MASTER(myThid)
C-    Track pkg activation status:
C     print a (weak) warning if data.longstep is found
         CALL PACKAGES_UNUSED_MSG(
     &        'usePTRACERS', 'LONGSTEP_READPARMS', 'longstep' )
        _END_MASTER(myThid)
        RETURN
      ENDIF

      _BEGIN_MASTER(myThid)

C     Set defaults values for parameters in LONGSTEP_PARAMS.h
      LS_nIter = 1
      LS_whenToSample = 0

C     Open and read the data.longstep file
      WRITE(msgBuf,'(A)') ' LONGSTEP_READPARMS: opening data.longstep'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT , myThid )
      CALL OPEN_COPY_DATA_FILE(
     I                   'data.longstep', 'LONGSTEP_READPARMS',
     O                   iUnit,
     I                   myThid )
      READ(UNIT=iUnit,NML=LONGSTEP_PARM01)
      WRITE(msgBuf,'(A)')
     &  ' LONGSTEP_READPARMS: finished reading data.longstep'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT , myThid )

C     Close the open data file
#ifdef SINGLE_DISK_IO
      CLOSE(iUnit)
#else
      CLOSE(iUnit,STATUS='DELETE')
#endif /* SINGLE_DISK_IO */

C     Now set-up any remaining parameters that result from the input
C     parameters

C     whether to average EmPmR or PmEpR in LS_fwFlux
      LS_usePmEpR = (nonlinFreeSurf.GT.0 .OR. usingPCoords)
     &              .AND. useRealFreshWaterFlux

      _END_MASTER(myThid)
C     Everyone else must wait for the parameters to be loaded
      _BARRIER

#endif /* ALLOW_LONGSTEP */

      RETURN
      END

#include "AUTODIFF_OPTIONS.h"

C     ==================================================================
C     active_files_ad.F: Routines to handle the I/O of the active file
C                        for the adjoint calculations. All files are
C                        direct access files.
C     Routines
C     o  adactive_read_xy         - Adjoint of active_read_xy
C     o  adactive_read_xyz        - Adjoint of active_read_xyz
C     o  adactive_read_xz         - Adjoint of active_read_xz
C     o  adactive_read_yz         - Adjoint of active_read_yz
C     o  adactive_read_1d         - Adjoint of active_read_1d
C
C     o  adactive_write_xy        - Adjoint of active_write_xy
C     o  adactive_write_xyz       - Adjoint of active_write_xyz
C     o  adactive_write_xz        - Adjoint of active_write_xz
C     o  adactive_write_yz        - Adjoint of active_write_yz
C     o  adactive_write_1d        - Adjoint of active_write_1d
C
C        changed: Christian Eckert eckert@mit.edu 24-Apr-2000
C                 - Added routines that do active writes on tiles
C                   instead of a whole thread.
C        changed: Patrick Heimbach heimbach@mit.edu 27-May-2000
C                 - changed suboutine argument list:
C                   dropped mycurrentiter, mycurrenttime
C        changed: heimbach@mit.edu 25-Mar-2002
C                 - added active file handling of xz-/yz-arrays
C        changed: tsmith@oden.utexas.edu 22-Oct-2019
C                 - added 1D vectors
C        changed: ou.wang@jpl.nasa.gov 24-Aug-2022
C                 - added helper S/R capable of handling
C                   active_var_file containing directory names
C     ==================================================================

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: adactive_read_xy
C     !INTERFACE:
#ifdef AUTODIFF_TAMC_COMPATIBILITY
      subroutine adactive_read_xy(
     I                             active_var_file,
     I                             iRec,
     I                             doglobalread,
     I                             lAdInit,
     I                             myIter,
     I                             myThid,
     I                             adactive_var
     &                           )
#else
      subroutine adactive_read_xy(
     I                             active_var_file,
     I                             adactive_var,
     I                             iRec,
     I                             doglobalread,
     I                             lAdInit,
     I                             myIter,
     I                             myThid,
     I                             dummy,
     O                             addummy
     &                           )
#endif

C     !DESCRIPTION: \bv
C     ==================================================================
C     SUBROUTINE adactive_read_xy
C     ==================================================================
C     o Adjoint of active_read_xy.
C     started: Christian Eckert eckert@mit.edu 24-May-1999
C     ==================================================================
C     \ev

C     !USES:
      IMPLICIT NONE

C     == global variables ==
#include "EEPARAMS.h"
#include "SIZE.h"

C     !INPUT/OUTPUT PARAMETERS:
C     active_var_file:: filename
C     adactive_var   :: array
C     iRec           :: record number
C     myIter         :: number of optimization iteration (default: 0)
C     myThid         :: thread number for this instance
C     doglobalread   :: flag for global or local read/write
C                       (default: .false.)
C     lAdInit        :: initialisation of corresponding adjoint
C                       variable and write to active file
      CHARACTER*(*) active_var_file
      _RL     adactive_var(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      INTEGER iRec
      INTEGER myIter, myThid
      LOGICAL doglobalread
      LOGICAL lAdInit
C Tags for IO: ctrl input and adjoint (gradient) output
      _RL  dummy, addummy

C     !LOCAL VARIABLES:
      CHARACTER*(2) adpref
      CHARACTER*(MAX_LEN_FNAM) fname
      INTEGER myNr
      LOGICAL useCurrentDir
CEOP

      adpref = 'ad'
      CALL ADD_PREFIX( adpref, active_var_file, fname )
      myNr = 1
      useCurrentDir = .FALSE.

      CALL ACTIVE_READ_3D_RL(
     &                 fname, adactive_var, doglobalread,
     &                 useCurrentDir, lAdInit, iRec, myNr,
     &                 REVERSE_SIMULATION, myIter, myThid )

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: adactive_read_xyz
C     !INTERFACE:
#ifdef AUTODIFF_TAMC_COMPATIBILITY
      subroutine adactive_read_xyz(
     I                              active_var_file,
     I                              iRec,
     I                              doglobalread,
     I                              lAdInit,
     I                              myIter,
     I                              myThid,
     I                              adactive_var
     &                            )
#else
      subroutine adactive_read_xyz(
     I                              active_var_file,
     I                              adactive_var,
     I                              iRec,
     I                              doglobalread,
     I                              lAdInit,
     I                              myIter,
     I                              myThid,
     I                              dummy,
     I                              addummy
     &                            )
#endif

C     !DESCRIPTION: \bv
C     ==================================================================
C     SUBROUTINE adactive_read_xyz
C     ==================================================================
C     o Adjoint of active_read_xyz.
C     started: Christian Eckert eckert@mit.edu 24-May-1999
C     ==================================================================
C     \ev

C     !USES:
      IMPLICIT NONE

C     == global variables ==
#include "EEPARAMS.h"
#include "SIZE.h"

C     !INPUT/OUTPUT PARAMETERS:
C     active_var_file:: filename
C     adactive_var   :: array
C     iRec           :: record number
C     myIter         :: number of optimization iteration (default: 0)
C     myThid         :: thread number for this instance
C     doglobalread   :: flag for global or local read/write
C                       (default: .false.)
C     lAdInit        :: initialisation of corresponding adjoint
C                       variable and write to active file
      CHARACTER*(*) active_var_file
      _RL     adactive_var(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      INTEGER iRec
      INTEGER myIter, myThid
      LOGICAL doglobalread
      LOGICAL lAdInit
C Tags for IO: ctrl input and adjoint (gradient) output
      _RL  dummy, addummy

C     !LOCAL VARIABLES:
      CHARACTER*(2) adpref
      CHARACTER*(MAX_LEN_FNAM) fname
      INTEGER myNr
      LOGICAL useCurrentDir
CEOP

      adpref = 'ad'
      CALL ADD_PREFIX( adpref, active_var_file, fname )
      myNr = Nr
      useCurrentDir = .FALSE.

      CALL ACTIVE_READ_3D_RL(
     &                 fname, adactive_var, doglobalread,
     &                 useCurrentDir, lAdInit, iRec, myNr,
     &                 REVERSE_SIMULATION, myIter, myThid )

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: adactive_read_xz
C     !INTERFACE:
#ifdef AUTODIFF_TAMC_COMPATIBILITY
      subroutine adactive_read_xz(
     I                              active_var_file,
     I                              iRec,
     I                              doglobalread,
     I                              lAdInit,
     I                              myIter,
     I                              myThid,
     I                              adactive_var
     &                            )
#else
      subroutine adactive_read_xz(
     I                              active_var_file,
     I                              adactive_var,
     I                              iRec,
     I                              doglobalread,
     I                              lAdInit,
     I                              myIter,
     I                              myThid,
     I                              dummy,
     O                              addummy
     &                            )
#endif

C     !DESCRIPTION: \bv
C     ==================================================================
C     SUBROUTINE adactive_read_xz
C     ==================================================================
C     o Adjoint of active_read_xz.
C     started: heimbach@mit.edu 05-Mar-2001
C     ==================================================================
C     \ev

C     !USES:
      IMPLICIT NONE

C     == global variables ==
#include "EEPARAMS.h"
#include "SIZE.h"

C     !INPUT/OUTPUT PARAMETERS:
C     active_var_file:: filename
C     adactive_var   :: array
C     iRec           :: record number
C     myIter         :: number of optimization iteration (default: 0)
C     myThid         :: thread number for this instance
C     doglobalread   :: flag for global or local read/write
C                       (default: .false.)
C     lAdInit        :: initialisation of corresponding adjoint
C                       variable and write to active file
      CHARACTER*(*) active_var_file
      _RL     adactive_var(1-OLx:sNx+OLx,Nr,nSx,nSy)
      INTEGER iRec
      INTEGER myIter, myThid
      LOGICAL doglobalread
      LOGICAL lAdInit
C Tags for IO: ctrl input and adjoint (gradient) output
      _RL  dummy, addummy

C     !LOCAL VARIABLES:
      CHARACTER*(2) adpref
      CHARACTER*(MAX_LEN_FNAM) fname
      INTEGER myNr
      LOGICAL useCurrentDir
CEOP

      adpref = 'ad'
      CALL ADD_PREFIX( adpref, active_var_file, fname )
      myNr = Nr
      useCurrentDir = .FALSE.

      CALL ACTIVE_READ_XZ_RL(
     &                 fname, adactive_var, doglobalread,
     &                 useCurrentDir, lAdInit, iRec, myNr,
     &                 REVERSE_SIMULATION, myIter, myThid )

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: adactive_read_yz
C     !INTERFACE:
#ifdef AUTODIFF_TAMC_COMPATIBILITY
      subroutine adactive_read_yz(
     I                              active_var_file,
     I                              iRec,
     I                              doglobalread,
     I                              lAdInit,
     I                              myIter,
     I                              myThid,
     I                              adactive_var
     &                            )
#else
      subroutine adactive_read_yz(
     I                              active_var_file,
     I                              adactive_var,
     I                              iRec,
     I                              doglobalread,
     I                              lAdInit,
     I                              myIter,
     I                              myThid,
     I                              dummy,
     O                              addummy
     &                            )
#endif

C     !DESCRIPTION: \bv
C     ==================================================================
C     SUBROUTINE adactive_read_yz
C     ==================================================================
C     o Adjoint of active_read_yz.
C     started: heimbach@mit.edu 05-Mar-2001
C     ==================================================================
C     \ev

C     !USES:
      IMPLICIT NONE

C     == global variables ==
#include "EEPARAMS.h"
#include "SIZE.h"

C     !INPUT/OUTPUT PARAMETERS:
C     active_var_file:: filename
C     adactive_var   :: array
C     iRec           :: record number
C     myIter         :: number of optimization iteration (default: 0)
C     myThid         :: thread number for this instance
C     doglobalread   :: flag for global or local read/write
C                       (default: .false.)
C     lAdInit        :: initialisation of corresponding adjoint
C                       variable and write to active file
      CHARACTER*(*) active_var_file
      _RL     adactive_var(1-OLy:sNy+OLy,Nr,nSx,nSy)
      INTEGER iRec
      INTEGER myIter, myThid
      LOGICAL doglobalread
      LOGICAL lAdInit
C Tags for IO: ctrl input and adjoint (gradient) output
      _RL  dummy, addummy

C     !LOCAL VARIABLES:
      CHARACTER*(2) adpref
      CHARACTER*(MAX_LEN_FNAM) fname
      INTEGER myNr
      LOGICAL useCurrentDir
CEOP

      adpref = 'ad'
      CALL ADD_PREFIX( adpref, active_var_file, fname )
      myNr = Nr
      useCurrentDir = .FALSE.

      CALL ACTIVE_READ_YZ_RL(
     &                 fname, adactive_var, doglobalread,
     &                 useCurrentDir, lAdInit, iRec, myNr,
     &                 REVERSE_SIMULATION, myIter, myThid )

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: adactive_read_1d
C     !INTERFACE:
#ifdef AUTODIFF_TAMC_COMPATIBILITY
      subroutine adactive_read_1d(
     I                             active_var_file,
     I                             active_var_length,
     I                             iRec,
     I                             lAdInit,
     I                             myIter,
     I                             myThid,
     I                             adactive_var
     &                           )
#else
      subroutine adactive_read_1d(
     I                             active_var_file,
     I                             adactive_var,
     I                             active_var_length,
     I                             iRec,
     I                             lAdInit,
     I                             myIter,
     I                             myThid,
     I                             dummy,
     O                             addummy
     &                           )
#endif

C     !DESCRIPTION: \bv
C     ==================================================================
C     SUBROUTINE adactive_read_1d
C     ==================================================================
C     o Adjoint of active_read_1d.
C     started: Tim Smith tsmith@oden.utexas.edu 22-Oct-2019
C     ==================================================================
C     \ev

C     !USES:
      IMPLICIT NONE

C     == global variables ==
#include "EEPARAMS.h"
#include "SIZE.h"

C     !INPUT/OUTPUT PARAMETERS:
C     active_var_file:: filename
C     adactive_var:  :: array
C     active_var_length :: length of array
C     iRec           :: record number
C     myIter         :: number of optimization iteration (default: 0)
C     myThid         :: thread number for this instance
C     lAdInit        :: initialisation of corresponding adjoint
C                       variable and write to active file
      CHARACTER*(*) active_var_file
      _RL     adactive_var(*)
      INTEGER active_var_length
      INTEGER iRec
      INTEGER myIter, myThid
      LOGICAL lAdInit
C Tags for IO: ctrl input and adjoint (gradient) output
      _RL  dummy, addummy

C     !FUNCTIONS:
      INTEGER  ILNBLNK
      EXTERNAL ILNBLNK

C     !LOCAL VARIABLES:
      CHARACTER*(2) adpref
      CHARACTER*(MAX_LEN_FNAM) fname
      INTEGER il
CEOP

      adpref = 'ad'
      il   = ILNBLNK( active_var_file )
      WRITE(fname,'(2A)') adpref, active_var_file(1:il)

      CALL ACTIVE_READ_1D_RL(
     &                 fname, adactive_var, active_var_length,
     &                 lAdInit, iRec,
     &                 REVERSE_SIMULATION, myIter, myThid )

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: adactive_write_xy
C     !INTERFACE:
#ifdef AUTODIFF_TAMC_COMPATIBILITY
      subroutine adactive_write_xy(
     I                              active_var_file,
     I                              iRec,
     I                              myIter,
     I                              myThid,
     U                              adactive_var,
     I                              dummy
     &                            )
#else
      subroutine adactive_write_xy(
     I                              active_var_file,
     U                              adactive_var,
     I                              iRec,
     I                              myIter,
     I                              myThid,
     I                              dummy
     &                            )
#endif

C     !DESCRIPTION: \bv
C     ==================================================================
C     SUBROUTINE adactive_write_xy
C     ==================================================================
C     o Adjoint of active_write_xy.
C     started: Christian Eckert eckert@mit.edu 24-May-1999
C     ==================================================================
C     \ev

C     !USES:
      IMPLICIT NONE

C     == global variables ==
#include "EEPARAMS.h"
#include "SIZE.h"

C     !INPUT/OUTPUT PARAMETERS:
C     active_var_file:: filename
C     adactive_var   :: array
C     iRec           :: record number
C     myIter         :: number of optimization iteration (default: 0)
C     myThid         :: thread number for this instance
      CHARACTER*(*) active_var_file
      _RL     adactive_var(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      INTEGER iRec
      INTEGER myIter, myThid
      _RL     dummy

C     !LOCAL VARIABLES:
      CHARACTER*(2) adpref
      CHARACTER*(MAX_LEN_FNAM) fname
      INTEGER myNr
      LOGICAL globalFile
      LOGICAL useCurrentDir
CEOP

      adpref = 'ad'
      CALL ADD_PREFIX( adpref, active_var_file, fname )
      myNr = 1
      globalFile = .FALSE.
      useCurrentDir = .FALSE.

      CALL ACTIVE_WRITE_3D_RL(
     &                 fname, adactive_var, globalFile,
     &                 useCurrentDir, iRec, myNr,
     &                 REVERSE_SIMULATION, myIter, myThid )

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: adactive_write_xyz
C     !INTERFACE:
#ifdef AUTODIFF_TAMC_COMPATIBILITY
      subroutine adactive_write_xyz(
     I                               active_var_file,
     I                               iRec,
     I                               myIter,
     I                               myThid,
     U                               adactive_var,
     I                               dummy
     &                             )
#else
      subroutine adactive_write_xyz(
     I                               active_var_file,
     U                               adactive_var,
     I                               iRec,
     I                               myIter,
     I                               myThid,
     I                               dummy
     &                             )
#endif

C     !DESCRIPTION: \bv
C     ==================================================================
C     SUBROUTINE adactive_write_xyz
C     ==================================================================
C     o Adjoint of active_write_xyz.
C     started: Christian Eckert eckert@mit.edu 24-May-1999
C     ==================================================================
C     \ev

C     !USES:
      IMPLICIT NONE

C     == global variables ==
#include "EEPARAMS.h"
#include "SIZE.h"

C     !INPUT/OUTPUT PARAMETERS:
C     active_var_file:: filename
C     adactive_var   :: array
C     iRec           :: record number
C     myIter         :: number of optimization iteration (default: 0)
C     myThid         :: thread number for this instance
      CHARACTER*(*) active_var_file
      _RL     adactive_var(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      INTEGER iRec
      INTEGER myIter, myThid
      _RL dummy

C     !LOCAL VARIABLES:
      CHARACTER*(2) adpref
      CHARACTER*(MAX_LEN_FNAM) fname
      INTEGER myNr
      LOGICAL globalFile
      LOGICAL useCurrentDir
CEOP

      adpref = 'ad'
      CALL ADD_PREFIX( adpref, active_var_file, fname )
      myNr = Nr
      globalFile = .FALSE.
      useCurrentDir = .FALSE.

      CALL ACTIVE_WRITE_3D_RL(
     &                 fname, adactive_var, globalFile,
     &                 useCurrentDir, iRec, myNr,
     &                 REVERSE_SIMULATION, myIter, myThid )

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: adactive_write_xz
C     !INTERFACE:
#ifdef AUTODIFF_TAMC_COMPATIBILITY
      subroutine adactive_write_xz(
     I                               active_var_file,
     I                               iRec,
     I                               myIter,
     I                               myThid,
     U                               adactive_var,
     I                               dummy
     &                             )
#else
      subroutine adactive_write_xz(
     I                               active_var_file,
     U                               adactive_var,
     I                               iRec,
     I                               myIter,
     I                               myThid,
     I                               dummy
     &                             )
#endif

C     !DESCRIPTION: \bv
C     ==================================================================
C     SUBROUTINE adactive_write_xz
C     ==================================================================
C     o Adjoint of active_write_xz.
C     started: heimbach@mit.edu 05-Mar-2001
C     ==================================================================
C     \ev

C     !USES:
      IMPLICIT NONE

C     == global variables ==
#include "EEPARAMS.h"
#include "SIZE.h"

C     !INPUT/OUTPUT PARAMETERS:
C     active_var_file:: filename
C     adactive_var   :: array
C     iRec           :: record number
C     myIter         :: number of optimization iteration (default: 0)
C     myThid         :: thread number for this instance
      CHARACTER*(*) active_var_file
      _RL     adactive_var(1-OLx:sNx+OLx,Nr,nSx,nSy)
      INTEGER iRec
      INTEGER myIter, myThid
      _RL dummy

C     !LOCAL VARIABLES:
      CHARACTER*(2) adpref
      CHARACTER*(MAX_LEN_FNAM) fname
      INTEGER myNr
      LOGICAL globalFile
      LOGICAL useCurrentDir
CEOP

      adpref = 'ad'
      CALL ADD_PREFIX( adpref, active_var_file, fname )
      myNr = Nr
      globalFile = .FALSE.
      useCurrentDir = .FALSE.

      CALL ACTIVE_WRITE_XZ_RL(
     &                 fname, adactive_var, globalFile,
     &                 useCurrentDir, iRec, myNr,
     &                 REVERSE_SIMULATION, myIter, myThid )

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: adactive_write_yz
C     !INTERFACE:
#ifdef AUTODIFF_TAMC_COMPATIBILITY
      subroutine adactive_write_yz(
     I                               active_var_file,
     I                               iRec,
     I                               myIter,
     I                               myThid,
     U                               adactive_var,
     I                               dummy
     &                             )
#else
      subroutine adactive_write_yz(
     I                               active_var_file,
     U                               adactive_var,
     I                               iRec,
     I                               myIter,
     I                               myThid,
     I                               dummy
     &                             )
#endif

C     !DESCRIPTION: \bv
C     ==================================================================
C     SUBROUTINE adactive_write_yz
C     ==================================================================
C     o Adjoint of active_write_yz.
C     started: heimbach@mit.edu 05-Mar-2001
C     ==================================================================
C     \ev

C     !USES:
      IMPLICIT NONE

C     == global variables ==
#include "EEPARAMS.h"
#include "SIZE.h"

C     !INPUT/OUTPUT PARAMETERS:
C     active_var_file:: filename
C     adactive_var   :: array
C     iRec           :: record number
C     myIter         :: number of optimization iteration (default: 0)
C     myThid         :: thread number for this instance
      CHARACTER*(*) active_var_file
      _RL     adactive_var(1-OLy:sNy+OLy,Nr,nSx,nSy)
      INTEGER iRec
      INTEGER myIter, myThid
      _RL dummy

C     !LOCAL VARIABLES:
      CHARACTER*(2) adpref
      CHARACTER*(MAX_LEN_FNAM) fname
      INTEGER myNr
      LOGICAL globalFile
      LOGICAL useCurrentDir
CEOP

      adpref = 'ad'
      CALL ADD_PREFIX( adpref, active_var_file, fname )
      myNr = Nr
      globalFile = .FALSE.
      useCurrentDir = .FALSE.

      CALL ACTIVE_WRITE_YZ_RL(
     &                 fname, adactive_var, globalFile,
     &                 useCurrentDir, iRec, myNr,
     &                 REVERSE_SIMULATION, myIter, myThid )

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: adactive_write_1d
C     !INTERFACE:
#ifdef AUTODIFF_TAMC_COMPATIBILITY
      subroutine adactive_write_1d(
     I                               active_var_file,
     I                               active_var_length,
     I                               iRec,
     I                               myIter,
     I                               myThid,
     U                               adactive_var,
     I                               dummy
     &                             )
#else
      subroutine adactive_write_1d(
     I                               active_var_file,
     U                               adactive_var,
     U                               active_var_length,
     I                               iRec,
     I                               myIter,
     I                               myThid,
     I                               dummy
     &                             )
#endif

C     !DESCRIPTION: \bv
C     ==================================================================
C     SUBROUTINE adactive_write_1d
C     ==================================================================
C     o Adjoint of active_write_1d.
C     started: tsmith@oden.utexas.edu 22-Oct-2019
C     ==================================================================
C     \ev

C     !USES:
      IMPLICIT NONE

C     == global variables ==
#include "EEPARAMS.h"
#include "SIZE.h"

C     !INPUT/OUTPUT PARAMETERS:
C     active_var_file:: filename
C     adactive_var   :: array
C     active_var_length :: length of array
C     iRec           :: record number
C     myIter         :: number of optimization iteration (default: 0)
C     myThid         :: thread number for this instance
      CHARACTER*(*) active_var_file
      _RL     adactive_var(*)
      INTEGER active_var_length
      INTEGER iRec
      INTEGER myIter, myThid
      _RL dummy

C     !FUNCTIONS:
      INTEGER  ILNBLNK
      EXTERNAL ILNBLNK

C     !LOCAL VARIABLES:
      CHARACTER*(2) adpref
      CHARACTER*(MAX_LEN_FNAM) fname
      INTEGER il
CEOP

      adpref = 'ad'
      il   = ILNBLNK( active_var_file )
      WRITE(fname,'(2A)') adpref, active_var_file(1:il)

      CALL ACTIVE_WRITE_1D_RL(
     &                 fname, adactive_var, active_var_length,
     &                 iRec, REVERSE_SIMULATION, myIter, myThid )

      RETURN
      END

#include "EXF_OPTIONS.h"
#include "AD_CONFIG.h"
#ifdef ALLOW_AUTODIFF
# include "AUTODIFF_OPTIONS.h"
#endif

CBOP
C     !ROUTINE: ADEXF_ADJOINT_SNAPSHOTS
C     !INTERFACE:
      SUBROUTINE ADEXF_ADJOINT_SNAPSHOTS(
     I                 iwhen, myTime, myIter, myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE ADEXF_ADJOINT_SNAPSHOTS                       |
C     *==========================================================*
C     Adjoint version of EXF Adjoint-variable output subroutine:
C     extract adjoint variable from TAF-generated
C     adjoint common blocks, contained in adcommon.h
C     and write fields to file;
C     Make sure common blocks in adcommon.h are up-to-date
C     w.r.t. current adjoint code.
C     *==========================================================*
C     | SUBROUTINE ADEXF_ADJOINT_SNAPSHOTS                       |
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     == Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "EXF_PARAM.h"
#ifdef ALLOW_MNC
# include "MNC_PARAMS.h"
#endif
#include "GRID.h"
#ifdef ALLOW_AUTODIFF
#ifdef ALLOW_AUTODIFF_MONITOR
# include "AUTODIFF_PARAMS.h"
# include "AUTODIFF.h"
# include "adcommon.h"
#endif
#endif /* ALLOW_AUTODIFF */

C     !INPUT/OUTPUT PARAMETERS:
C     iwhen  :: indicates where this S/R is called from
C     myTime :: time counter for this thread
C     myIter :: iteration counter for this thread
C     myThid :: Thread number for this instance of the routine.
      INTEGER iwhen
      _RL     myTime
      INTEGER myIter
      INTEGER myThid

#if (defined (ALLOW_ADJOINT_RUN) || defined (ALLOW_ADMTLM))
#ifdef ALLOW_AUTODIFF_MONITOR

C     !FUNCTIONS:
      LOGICAL  DIFFERENT_MULTIPLE
      EXTERNAL DIFFERENT_MULTIPLE

C     !LOCAL VARIABLES:
C     suff   :: Hold suffix part of a filename
C     msgBuf :: Error message buffer
c     CHARACTER*(10) suff
c     CHARACTER*(MAX_LEN_MBUF) msgBuf
      _RS dumRS(1)
      _RL dumRL(1)
      INTEGER dumpAdRecEx
      LOGICAL doDump
CEOP

C-----------------------------------------------------------------------
C--- do dump?
C-----------------------------------------------------------------------
      doDump = DIFFERENT_MULTIPLE(adjDumpFreq,myTime,deltaTClock)
      IF ( doDump ) THEN
c     determine ad dump record number (used only if dumpAdByRec is true)
       IF (useSeaice.AND.(iWhen.EQ.3)) THEN
        dumpAdRecEx=dumpAdRecMn+1
       ELSE
        dumpAdRecEx=dumpAdRecMn
       ENDIF
c#ifdef ALLOW_DEBUG
c      IF ( debugMode ) print*,'dumpAdRecEx',dumpAdRecEx
c#endif
       CALL TIMER_START('I/O (WRITE)        [ADJOINT LOOP]', myThid )
      ENDIF

      IF ( iwhen .EQ.1 ) THEN

       CALL DUMP_ADJ_XY_UV(
     &      dumRS, adustress, 'ADJustrs', 'ADJustress.',
     &      dumRS, advstress, 'ADJvstrs', 'ADJvstress.',
     &      34, doDump, dumpAdRecEx, myTime, myIter, myThid )
       CALL DUMP_ADJ_XY( dumRS, adhflux, 'ADJhflux', 'ADJhflux.',
     &      12, doDump, dumpAdRecEx, myTime, myIter, myThid )
       CALL DUMP_ADJ_XY( dumRS, adsflux, 'ADJsflux', 'ADJsflux.',
     &      12, doDump, dumpAdRecEx, myTime, myIter, myThid )

      ELSEIF ( iwhen .EQ.2 ) THEN

# ifdef ALLOW_ATM_TEMP
       CALL DUMP_ADJ_XY( dumRS, adatemp, 'ADJatemp', 'ADJatemp.',
     &      12, doDump, dumpAdRecEx, myTime, myIter, myThid )
       CALL DUMP_ADJ_XY( dumRS, adaqh,   'ADJaqh  ', 'ADJaqh.',
     &      12, doDump, dumpAdRecEx, myTime, myIter, myThid )
       CALL DUMP_ADJ_XY( dumRS, adprecip, 'ADJpreci', 'ADJprecip.',
     &      12, doDump, dumpAdRecEx, myTime, myIter, myThid )
# endif
# ifdef ALLOW_RUNOFF
       CALL DUMP_ADJ_XY( dumRS, adrunoff, 'ADJroff ', 'ADJrunoff.',
     &      12, doDump, dumpAdRecEx, myTime, myIter, myThid )
# endif
       IF ( useAtmWind ) THEN
        CALL DUMP_ADJ_XY( dumRS, aduwind, 'ADJuwind', 'ADJuwind.',
     &       12, doDump, dumpAdRecEx, myTime, myIter, myThid )
        CALL DUMP_ADJ_XY( dumRS, advwind, 'ADJvwind', 'ADJvwind.',
     &       12, doDump, dumpAdRecEx, myTime, myIter, myThid )
       ENDIF
# ifdef ALLOW_DOWNWARD_RADIATION
       CALL DUMP_ADJ_XY( dumRS, adswdown, 'ADJswdn ', 'ADJswdown.',
     &      12, doDump, dumpAdRecEx, myTime, myIter, myThid )
       CALL DUMP_ADJ_XY( dumRS, adlwdown, 'ADJlwdn ', 'ADJlwdown.',
     &      12, doDump, dumpAdRecEx, myTime, myIter, myThid )
# endif
# ifdef ALLOW_CLIMSST_RELAXATION
       CALL DUMP_ADJ_XY( dumRS, adclimsst, 'ADJclsst', 'ADJclimsst.',
     &      12, doDump, dumpAdRecEx, myTime, myIter, myThid )
# endif
# ifdef ALLOW_CLIMSSS_RELAXATION
       CALL DUMP_ADJ_XY( dumRS, adclimsss, 'ADJclsst', 'ADJclimsss.',
     &      12, doDump, dumpAdRecEx, myTime, myIter, myThid )
# endif

      ELSEIF ( iwhen .EQ.3 ) THEN

       CALL DUMP_ADJ_XY_UV(
     &      adFu, dumRL, 'ADJtaux ', 'ADJtaux.',
     &      adFv, dumRL, 'ADJtauy ', 'ADJtauy.',
     &      33, doDump, dumpAdRecEx, myTime, myIter, myThid )
       CALL DUMP_ADJ_XY(adQnet, dumRL, 'ADJqnet ', 'ADJqnet.',
     &      11, doDump, dumpAdRecEx, myTime, myIter, myThid )
       CALL DUMP_ADJ_XY(adEmPmR, dumRL, 'ADJempmr', 'ADJempr.',
     &      11, doDump, dumpAdRecEx, myTime, myIter, myThid )
# ifdef SHORTWAVE_HEATING
       CALL DUMP_ADJ_XY(adQsw, dumRL, 'ADJqsw  ', 'ADJqsw.',
     &      11, doDump, dumpAdRecEx, myTime, myIter, myThid )
# endif

      ENDIF

      IF ( doDump ) THEN
#ifdef ALLOW_MNC
        IF (useMNC .AND. autodiff_mnc) THEN

         IF ( iwhen.EQ.1 ) THEN

          CALL MNC_CW_SET_UDIM('adexf', -1, myThid)
          CALL MNC_CW_RL_W_S('D','adexf',0,0,'T',myTime,myThid)
          CALL MNC_CW_SET_UDIM('adexf', 0, myThid)
          CALL MNC_CW_I_W_S('I','adexf',0,0,'iter',myIter,myThid)
          CALL MNC_CW_RL_W_S('D','adexf',0,0,'model_time',myTime,
     &         myThid)

          CALL MNC_CW_RL_W('D','adexf',0,0,'adustress',
     &         adustress, myThid)
          CALL MNC_CW_RL_W('D','adexf',0,0,'advstress',
     &         advstress, myThid)
          CALL MNC_CW_RL_W('D','adexf',0,0,'adhflux',
     &         adhflux, myThid)
          CALL MNC_CW_RL_W('D','adexf',0,0,'adsflux',
     &         adsflux, myThid)
         ELSEIF ( iwhen.EQ.2 ) THEN
# ifdef ALLOW_ATM_TEMP
          CALL MNC_CW_RL_W('D','adexf',0,0,'adatemp',
     &         adatemp, myThid)
          CALL MNC_CW_RL_W('D','adexf',0,0,'adaqh',
     &         adaqh, myThid)
          CALL MNC_CW_RL_W('D','adexf',0,0,'adprecip',
     &         adprecip, myThid)
# endif
# ifdef ALLOW_RUNOFF
          CALL MNC_CW_RL_W('D','adexf',0,0,'adrunoff',
     &         adrunoff, myThid)
# endif
          IF ( useAtmWind ) THEN
           CALL MNC_CW_RL_W('D','adexf',0,0,'aduwind',
     &          aduwind, myThid)
           CALL MNC_CW_RL_W('D','adexf',0,0,'advwind',
     &          advwind, myThid)
          ENDIF
# ifdef ALLOW_DOWNWARD_RADIATION
          CALL MNC_CW_RL_W('D','adexf',0,0,'adswdown',
     &         adswdown, myThid)
          CALL MNC_CW_RL_W('D','adexf',0,0,'adlwdown',
     &         adlwdown, myThid)
# endif
# ifdef ALLOW_CLIMSST_RELAXATION
          CALL MNC_CW_RL_W('D','adexf',0,0,'adclimsst',
     &         adclimsst, myThid)
# endif
# ifdef ALLOW_CLIMSSS_RELAXATION
          CALL MNC_CW_RL_W('D','adexf',0,0,'adclimsss',
     &         adclimsss, myThid)
# endif

         ENDIF

        ENDIF
#endif /* ALLOW_MNC */

        CALL TIMER_STOP( 'I/O (WRITE)        [ADJOINT LOOP]', myThid )
      ENDIF

#ifdef ALLOW_MONITOR
      CALL ADEXF_MONITOR ( iwhen, myTime, myIter, myThid )
#endif

#endif /* ALLOW_AUTODIFF_MONITOR */
#endif /* ALLOW_ADJOINT_RUN */

      RETURN
      END

#include "SEAICE_OPTIONS.h"

CBOP
C !ROUTINE: SEAICE_DO_RIDGING
C !INTERFACE: ==========================================================
      SUBROUTINE SEAICE_DO_RIDGING(
     I     bi, bj, myTime, myIter, myThid )

C !DESCRIPTION: \bv
C     *===========================================================*
C     | SUBROUTINE SEAICE_DO_RIDGING
C     | o compute mechanical redistribution of thin (undeformed) into
C     |   thick (deformed, i.e. ridged) ice categories
C     |   according to Thorndyke et al (1975) and Hibler (1980)
C     |   or Bitz et al (2001) and Lipscomb et al (2007)
C     |
C     | Martin Losch, Apr. 2014, Martin.Losch@awi.de
C     *===========================================================*
C \ev

C !USES: ===============================================================
      IMPLICIT NONE

#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "SEAICE_SIZE.h"
#include "SEAICE_PARAMS.h"
#include "SEAICE_GRID.h"
#include "SEAICE.h"

C !INPUT PARAMETERS: ===================================================
C     === Routine arguments ===
C     bi, bj    :: outer loop counters
C     myTime    :: current time
C     myIter    :: iteration number
C     myThid    :: Thread no. that called this routine.
      _RL myTime
      INTEGER bi,bj
      INTEGER myIter
      INTEGER myThid
CEndOfInterface

C !LOCAL VARIABLES: ====================================================
C     === Local variables ===
C     i,j,k       :: inner loop counters
C     openWater   :: open water area fraction
C
      INTEGER i, j
      INTEGER iMin, iMax, jMin, jMax
#ifdef SEAICE_ITD
      INTEGER k, l, n
      _RL ridgingModeNorm (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL partFunc        (1-OLx:sNx+OLx,1-OLy:sNy+OLy,0:nITD)
C     ridgeRatio :: mean ridge thickness/ thickness of ridging ice
C     hrMin      :: min ridge thickness
C     hrMax      :: max ridge thickness   (SEAICEredistFunc = 0)
C     hrExp      :: ridge e-folding scale (SEAICEredistFunc = 1)
      _RL hrMin           (1-OLx:sNx+OLx,1-OLy:sNy+OLy,1:nITD)
      _RL hrMax           (1-OLx:sNx+OLx,1-OLy:sNy+OLy,1:nITD)
      _RL hrExp           (1-OLx:sNx+OLx,1-OLy:sNy+OLy,1:nITD)
      _RL ridgeRatio      (1-OLx:sNx+OLx,1-OLy:sNy+OLy,1:nITD)
C     computed and returned by S/R seaice_prepare_ridging, but not needed here
      _RL hActual         (1-OLx:sNx+OLx,1-OLy:sNy+OLy,1:nITD)
C
      _RL openWater       (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL netArea         (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
C     variables related to ridging schemes
      _RL openingRate     (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL closingRate     (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL grossClosing    (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
C     amount of ice that participates in ridging (according to partFunc)
      _RL ridgingArea     (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL ridgingHeff     (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL ridgingHsnw     (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
C     fractions of deformed/ridged ice
      _RL areaFraction    (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL volFraction     (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
C     absolute area/concentration of deformed/ridged ice
      _RL ridgedArea      (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      LOGICAL doRidging   (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      LOGICAL doRidgeAgain, areaTooLarge
C
      _RL recip_deltaT, convergence, divergence, shear, divAdv
      _RL tmp, tmpFac, hL, hR, expL, expR
      _RL areaPR          (1-OLx:sNx+OLx,1-OLy:sNy+OLy,1:nITD)
      _RL heffPR          (1-OLx:sNx+OLx,1-OLy:sNy+OLy,1:nITD)
      _RL hsnwPR          (1-OLx:sNx+OLx,1-OLy:sNy+OLy,1:nITD)
C
      CHARACTER*(MAX_LEN_MBUF) msgBuf
#endif /* SEAICE_ITD */
CEOP

C---+-|--1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      iMin=1
      iMax=sNx
      jMin=1
      jMax=sNy
#ifndef SEAICE_ITD
C     Hiblers "ridging function" for single category ice
      DO j=jMin,jMax
       DO i=iMin,iMax
        AREA(i,j,bi,bj) = MIN(AREA(i,j,bi,bj),SEAICE_area_max)
       ENDDO
      ENDDO
#else
C     calculate area of open water
      DO j=jMin,jMax
       DO i=iMin,iMax
        openWater(i,j) = ONE
       ENDDO
      ENDDO
      DO k=1,nITD
       DO j=jMin,jMax
        DO i=iMin,iMax
         openWater(i,j) = openWater(i,j) - AREAITD(i,j,k,bi,bj)
        ENDDO
       ENDDO
      ENDDO
      IF ( SEAICEsimpleRidging ) THEN
C--   Hibler-type "ridging", i.e. cut back excessive ice area fraction ---
C     in case ice concentration exceeds 100% assume that
C     convergence of floe field has eliminated all open water
C     and eventual rafting occured in thinnest category:
       DO j=jMin,jMax
        DO i=iMin,iMax
         IF (openWater(i,j) .lt. 0.0)
     &        AREAITD(i,j,1,bi,bj) = openWater(i,j)+AREAITD(i,j,1,bi,bj)
        ENDDO
       ENDDO
C---+-|--1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
      ELSE
C     initialisation
      DO j=jMin,jMax
       DO i=iMin,iMax
        ridgingArea(i,j)       = 0. _d 0
        ridgingHeff(i,j)       = 0. _d 0
        ridgingHsnw(i,j)       = 0. _d 0
        areaFraction(i,j)      = 0. _d 0
        volFraction(i,j)       = 0. _d 0
        fw2ObyRidge(i,j,bi,bj) = 0. _d 0
        ridgedArea(i,j)        = 0. _d 0
       ENDDO
      ENDDO
      CALL SEAICE_PREPARE_RIDGING(
     O     hActual,
     O     hrMin, hrMax, hrExp, ridgeRatio, ridgingModeNorm, partFunc,
     I     iMin, iMax, jMin, jMax, bi, bj, myTime, myIter, myThid )
C     Compute the first strain rate invariant epsilonI (divergence)
C     energy dissipation by convergence = -min (divergence, 0)
C     energy dissipation by shearing    = (1/2) * (Delta - abs(divergence))
      DO j=jMin,jMax
       DO i=iMin,iMax
        divergence  = e11(i,j,bi,bj) + e22(i,j,bi,bj)
        shear       = 0.5 _d 0 * ( deltaC(i,j,bi,bj) - ABS(divergence) )
        convergence = - MIN(divergence, 0.D0)
        closingRate(i,j) = SEAICEshearParm*shear + convergence
       ENDDO
      ENDDO
C     we need a new estimate of the total AREA (including the open water
C     fraction, but for computational reason it is not included here)
      DO j=jMin,jMax
       DO i=iMin,iMax
        netArea(i,j) = 0. _d 0
       ENDDO
      ENDDO
      DO k=1,nITD
       DO j=jMin,jMax
        DO i=iMin,iMax
         netArea(i,j) = netArea(i,j) + AREAITD(i,j,k,bi,bj)
        ENDDO
       ENDDO
      ENDDO
      recip_DeltaT = 1. _d 0/SEAICE_deltaTtherm
      DO j=jMin,jMax
       DO i=iMin,iMax
C     divergence rate due to advection; this term need not be zero due
C     to numerical effects
C     (this is copied from CICE but I am not sure about that)
        divAdv = (1. _d 0-netArea(i,j)-opnWtrFrac(i,j,bi,bj))
     &       *recip_deltaT
        IF (divAdv .LT. 0. _d 0)
     &       closingRate(i,j) = MAX(closingRate(i,j), -divAdv)
C     finally compute a non-negative opening rate that will lead to
C     a net area of 1
        openingRate(i,j) = closingRate(i,j) + divAdv
       ENDDO
      ENDDO
C
C     start of the ridging loop
C
      doRidgeAgain = .TRUE.
      n = 1
      DO WHILE (doRidgeAgain)
C     save pre-ridging ice concentration and ridged ice volume
      DO k=1,nITD
       DO j=jMin,jMax
        DO i=iMin,iMax
         areaPR(i,j,k) = AREAITD(i,j,k,bi,bj)
         heffPR(i,j,k) = HEFFITD(i,j,k,bi,bj)
         hsnwPR(i,j,k) = HSNOWITD(i,j,k,bi,bj)
C        ridgeFrac(i,j,k) = 0. _d 0
C        IF (HEFFITD(i,j,k,bi,bj) .GT. 0. _d 0 )
C   &     ridgeFrac(i,j,k) = ridgedHeff/HEFF
        ENDDO
       ENDDO
      ENDDO
C
      DO j=jMin,jMax
       DO i=iMin,iMax
C     Based on the ITD of ridging and ridged ice, convert the net
C     closing rate to a gross closing rate times deltaT.
C     NOTE: 0 < ridgingModeNorm <= 1
        grossClosing(i,j) = closingRate(i,j)*SEAICE_deltaTtherm
     &       /ridgingModeNorm(i,j)
C     reduce rates in case more than 100% of open water would be removed
        IF ( partFunc(i,j,0) .GT. 0. _d 0 ) THEN
         tmp = partFunc(i,j,0)*grossClosing(i,j)
         IF ( tmp .GT. opnWtrFrac(i,j,bi,bj) ) THEN
          tmpFac = opnWtrFrac(i,j,bi,bj)/tmp
          grossClosing(i,j) = grossClosing(i,j) * tmpFac
          openingRate(i,j)  =  openingRate(i,j) * tmpFac
         ENDIF
        ENDIF
       ENDDO
      ENDDO
      DO k=1,nITD
       DO j=jMin,jMax
        DO i=iMin,iMax
C     reduce rates in case more than 100% of any ice categroy would be removed
         IF ( areaPR(i,j,k) .GT. SEAICE_area_reg
     &        .AND. partFunc(i,j,k) .GT. 0. _d 0 ) THEN
          tmp = partFunc(i,j,k)*grossClosing(i,j)
          IF ( tmp .GT. AREAITD(i,j,k,bi,bj) ) THEN
           tmpFac = AREAITD(i,j,k,bi,bj)/tmp
           grossClosing(i,j) = grossClosing(i,j) * tmpFac
           openingRate(i,j)  =  openingRate(i,j) * tmpFac
          ENDIF
         ENDIF
        ENDDO
       ENDDO
      ENDDO
C
C     start redistribution
C
      DO j=jMin,jMax
       DO i=iMin,iMax
C     open water first
        opnWtrFrac(i,j,bi,bj) = opnWtrFrac(i,j,bi,bj)
     &       - partFunc(i,j,0)*grossClosing(i,j)
     &       + openingRate(i,j)*SEAICE_deltaTtherm
C     need to catch openWater << 0 properly
C     negative open water it not allowed
        opnWtrFrac(i,j,bi,bj) = MAX( 0. _d 0, opnWtrFrac(i,j,bi,bj) )
       ENDDO
      ENDDO
C
      DO k=1,nITD
C     need to catch partFunc*grossClosing > AREAITD (or areaPR)
       DO j=jMin,jMax
        DO i=iMin,iMax
         doRidging(i,j) = areaPR(i,j,k) .GT. SEAICE_area_reg
     &        .AND. partFunc(i,j,k) .GT. 0. _d 0
     &        .AND. grossClosing(i,j) .GT. 0. _d 0
     &        .AND. HEFFM(i,j,bi,bj) .GT. 0. _d 0
C     this would be safety catch only
C     &        .AND. netArea(i,j) .GT. 1. _d 0
         IF ( doRidging(i,j) ) THEN
CML          ridgingArea(i,j) = MIN(partFunc(i,j,k)*grossClosing(i,j),
CML     &         areaPR(i,j,k))
          ridgingArea(i,j) = partFunc(i,j,k)*grossClosing(i,j)
          IF ( ridgingArea(i,j) .GT. areaPR(i,j,k) ) THEN
           ridgingArea(i,j) = areaPR(i,j,k)
          ENDIF
          areaFraction(i,j) = ridgingArea(i,j)/areaPR(i,j,k)
          ridgedArea(i,j)   = ridgingArea(i,j)/ridgeRatio(i,j,k)
C     compute ice volume (HEFF) and snow volume to be removed from this
C     ridging category
          ridgingHEFF(i,j) = heffPR(i,j,k) * areaFraction(i,j)
          ridgingHsnw(i,j) = hsnwPR(i,j,k) * areaFraction(i,j)
C     part of the snow mass is pushed into the ocean during ridging;
C     this freshwater flux will be added to the net feshwater flux into
C     the ocean in seaice_growth
          fw2ObyRidge(i,j,bi,bj) = fw2ObyRidge(i,j,bi,bj)
     &         + SEAICE_rhoSnow*ridgingHsnw(i,j)
     &         *(1. _d 0 - SEAICEsnowFracRidge)
C     reduce the snow volume that is left for redistribution
          ridgingHsnw(i,j) = ridgingHsnw(i,j) * SEAICEsnowFracRidge
C     remove ice concentration, volume (HEFF), and snow volume from
C     this ridging category
          AREAITD(i,j,k,bi,bj) = AREAITD(i,j,k,bi,bj) - ridgingArea(i,j)
          HEFFITD(i,j,k,bi,bj) = HEFFITD(i,j,k,bi,bj) - ridgingHeff(i,j)
          HSNOWITD(i,j,k,bi,bj)=HSNOWITD(i,j,k,bi,bj) - ridgingHsnw(i,j)
         ENDIF
        ENDDO
       ENDDO
C     inner loop over categories: distribute what has been removed from the
C     kth category to all categories according to area/volFraction
       DO l=1,nITD
C     initialising these is essential, because here the ridging-mask doRidging
C     to area/volFraction, and applied via these fields
        DO j=jMin,jMax
         DO i=iMin,iMax
          areaFraction(i,j) = 0. _d 0
          volFraction (i,j) = 0. _d 0
         ENDDO
        ENDDO
        IF ( SEAICEredistFunc .EQ. 0 ) THEN
C     Assume ridged ice is uniformly distributed between hrmin and hrmax
C     (Hibler, 1980), see also s/r seaice_prepare_ridging.
         DO j=jMin,jMax
          DO i=iMin,iMax
           IF ( doRidging(i,j) ) THEN
            IF ( hrMin(i,j,k) .GE. hLimit(l) .OR.
     &           hrMax(i,j,k) .LE. hLimit(l-1) ) THEN
CML             hL = 0. _d 0
CML             hR = 0. _d 0
             areaFraction(i,j) = 0. _d 0
             volFraction (i,j) = 0. _d 0
            ELSE
             hL = MAX(hrMin(i,j,k), hLimit(l-1))
             hR = MIN(hrMax(i,j,k), hLimit(l))
             areaFraction(i,j) = ( hR - hL )
     &            / ( hrMax(i,j,k) - hrMin(i,j,k) )
CML             volFraction (i,j) = ( hR*hR - hL*hL )
CML     &            / ( hrMax(i,j,k)**2 - hrMin(i,j,k)**2 )
             volFraction (i,j) = areaFraction(i,j)*( hR + hL )
     &            / ( hrMax(i,j,k) + hrMin(i,j,k) )
            ENDIF
           ENDIF
          ENDDO
         ENDDO
        ELSEIF ( SEAICEredistFunc .EQ. 1 ) THEN
C     Follow Lipscomb et al. (2007) and model ridge ITD as an exponentially
C     decaying function, see also s/r seaice_prepare_ridging.
         IF ( l.LT.nITD ) THEN
          DO j=jMin,jMax
           DO i=iMin,iMax
            IF ( doRidging(i,j)
     &           .AND. hrMin(i,j,k) .LT. hLimit(l)
     &           .AND. hrExp(i,j,k) .NE. 0. _d 0 ) THEN
             hL   = MAX( hrMin(i,j,k), hLimit(l-1) )
             hR   = hLimit(l)
             expL = EXP(-( hL - hrMin(i,j,k) )/hrExp(i,j,k) )
             expR = EXP(-( hR - hrMin(i,j,k) )/hrExp(i,j,k) )
             areaFraction(i,j) = expL - expR
             volFraction (i,j) =
     &            ( ( hL + hrExp(i,j,k) ) * expL
     &            - ( hR + hrExp(i,j,k) ) * expR )
     &            / ( hrMin(i,j,k) + hrExp(i,j,k) )
            ENDIF
           ENDDO
          ENDDO
         ELSE
          DO j=jMin,jMax
           DO i=iMin,iMax
            IF ( doRidging(i,j) .AND. hrExp(i,j,k) .NE. 0. _d 0 ) THEN
              hL   = MAX( hrMin(i,j,k), hLimit(l-1) )
              expL = EXP(-( hL - hrMin(i,j,k) )/hrExp(i,j,k) )
              areaFraction(i,j) = expL
              volFraction (i,j) = ( hL + hrExp(i,j,k) ) * expL
     &             / ( hrMin(i,j,k) + hrExp(i,j,k) )
             ENDIF
           ENDDO
          ENDDO
         ENDIF
        ENDIF
C     after computing the fraction ridged ice for this category, apply it
        DO j=jMin,jMax
         DO i=iMin,iMax
          AREAITD(i,j,l,bi,bj) = AREAITD(i,j,l,bi,bj)
     &         +areaFraction(i,j)*ridgedArea(i,j)
          HEFFITD(i,j,l,bi,bj) = HEFFITD(i,j,l,bi,bj)
     &         +volFraction(i,j)*ridgingHeff(i,j)
          HSNOWITD(i,j,l,bi,bj) = HSNOWITD(i,j,l,bi,bj)
     &         +volFraction(i,j)*ridgingHsnw(i,j)*SEAICEsnowFracRidge
         ENDDO
        ENDDO
C     category l-loop
       ENDDO
C     category k-loop
      ENDDO
C     determine if the ridging process needs to be repeated
C     we need a new estimate of the total AREA
      DO j=jMin,jMax
       DO i=iMin,iMax
        netArea(i,j) = 0. _d 0
       ENDDO
      ENDDO
      DO k=1,nITD
       DO j=jMin,jMax
        DO i=iMin,iMax
         netArea(i,j) = netArea(i,j) + AREAITD(i,j,k,bi,bj)
        ENDDO
       ENDDO
      ENDDO
      doRidgeAgain   = .FALSE.
      DO j=jMin,jMax
       DO i=iMin,iMax
        tmp = netArea(i,j)+opnWtrFrac(i,j,bi,bj)
        areaTooLarge = tmp - 1. _d 0 .GT. 1. _d -11
        IF ( HEFFM(i,j,bi,bj) .GT. 0. _d 0 .AND. areaTooLarge ) THEN
         doRidging(i,j) = .TRUE.
         doRidgeAgain   = .TRUE.
         divAdv = (1. _d 0-tmp)*recip_deltaT
         closingRate(i,j) = MAX( 0. _d 0, -divAdv)
         openingRate(i,j) = MAX( 0. _d 0,  divAdv)
        ELSE
C     set to zero avoid going through this grid point again
         closingRate(i,j) = 0. _d 0
         openingRate(i,j) = 0. _d 0
         doRidging(i,j)   = .FALSE.
        ENDIF
       ENDDO
      ENDDO
      IF ( doRidgeAgain .AND. n.GE.SEAICEridgingIterMax ) THEN
C     some debugging information
       WRITE(msgBuf,'(A)') 'SEAICE_DO_RIDGING: *** WARNING ***'
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &      SQUEEZE_RIGHT, myThid )
       WRITE(msgBuf,'(A,I2,A)') 'SEAICE_DO_RIDGING: '//
     &      'did not converge in SEAICEridgingIterMax = ',
     &      SEAICEridgingIterMax, ' iterations.'
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &      SQUEEZE_RIGHT, myThid )
CML       CALL PRINT_ERROR( msgBuf, myThid )
      ENDIF
      doRidgeAgain = doRidgeAgain .AND. n.LT.SEAICEridgingIterMax
      IF ( doRidgeAgain .AND. debugLevel .GE. debLevA ) THEN
C     some debugging information
       WRITE(msgBuf,'(A,I2,A,I10)')
     &      'SEAICE_DO_RIDGING: Repeat ridging after iteration ',
     &      n, ' in timestep ', myIter
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &      SQUEEZE_RIGHT, myThid )
      ENDIF
      IF ( doRidgeAgain ) CALL SEAICE_PREPARE_RIDGING(
     O     hActual,
     O     hrMin, hrMax, hrExp, ridgeRatio, ridgingModeNorm, partFunc,
     I     iMin, iMax, jMin, jMax, bi, bj, myTime, myIter, myThid )
      n = n + 1
C     ridging iteration
      ENDDO
C     .not. SEAICEsimpleRidging
      ENDIF
#endif /* SEAICE_ITD */

C     after ridging is complete, the critical variables need to be
C     regularized and checked for consistency. This is done in a separate
C     routine
CML      CALL SEAICE_REGULARIZE( bi, bj, myTime, myIter, myThid )

      RETURN
      END

#include "CPP_EEOPTIONS.h"
#include "W2_OPTIONS.h"

C--  File w2_set_map_tiles.F:
C--   Contents
C--   o W2_SET_MAP_TILES :: Set tiles and IO mapping
C--   o FIND_GCD_N       :: Returns the Greatest Common Divisor

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 0
C !ROUTINE: W2_SET_MAP_TILES

C !INTERFACE:
      SUBROUTINE W2_SET_MAP_TILES( myThid )

C     !DESCRIPTION:
C     Set-up tiles mapping and IO global mapping

C     !USES:
      IMPLICIT NONE

C      Tile topology settings data structures
#include "SIZE.h"
#include "EEPARAMS.h"
#include "W2_EXCH2_SIZE.h"
#include "W2_EXCH2_PARAMS.h"
#include "W2_EXCH2_TOPOLOGY.h"

C     !INPUT PARAMETERS:
C     myThid  :: my Thread Id number
C               (Note: not relevant since threading has not yet started)
      INTEGER myThid

C     !FUNCTIONS:
      INTEGER  FIND_GCD_N
      EXTERNAL FIND_GCD_N

C     !LOCAL VARIABLES:
C     === Local variables ===
C     msgBuf     :: Informational/error message buffer
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      INTEGER tNx, tNy, fNx, fNy, nbPts, fBaseX, fBaseY
      INTEGER nbTx, nbTy
      INTEGER j, ii, k, tId, tx, ty
      INTEGER divide, nnx(W2_maxNbFacets)
      INTEGER errCnt, tCnt
      LOGICAL tileIsActive, prtFlag
CEOP

C     Set-up tiles mapping and IO global mapping
      WRITE(msgBuf,'(2A)') 'W2_SET_MAP_TILES:',
     &       ' tile mapping within facet and global Map:'
      CALL PRINT_MESSAGE( msgBuf, W2_oUnit, SQUEEZE_RIGHT, myThid )
      prtFlag = ABS(W2_printMsg).GE.2
     &       .OR. ( W2_printMsg .NE.0 .AND. myProcId.EQ.0 )

      tNx = sNx
      tNy = sNy
C--   Check that tile dims divide facet dims
      errCnt = 0
      tCnt = 0
      nbPts = 0
      DO j=1,nFacets
        fNx = facet_dims(2*j-1)
        fNy = facet_dims( 2*j )
        nbTx = fNx/tNx
        nbTy = fNy/tNy
        IF ( nbTx*tNx .NE. fNx ) THEN
          WRITE(msgBuf,'(A,I3,2(A,I7))') 'Facet',j,
     &      ' : X-size=', fNx, ' not multiple of sNx=', tNx
          CALL PRINT_ERROR( msgBuf, myThid )
          errCnt = errCnt + 1
        ENDIF
        IF ( nbTy*tNy .NE. fNy ) THEN
          WRITE(msgBuf,'(A,I3,2(A,I7))') 'Facet',j,
     &      ' : Y-size=', fNy, ' not multiple of sNy=', tNy
          CALL PRINT_ERROR( msgBuf, myThid )
          errCnt = errCnt + 1
        ENDIF
        facet_owns(1,j) = tCnt+1
        tCnt = tCnt + nbTx*nbTy
        facet_owns(2,j) = tCnt
        nbPts = nbPts + fNx*fNy
      ENDDO
      IF ( errCnt.GT.0 ) THEN
        WRITE(msgBuf,'(A,I3,A)')
     &   ' W2_SET_MAP_TILES: found', errCnt, ' Fatal errors'
        CALL PRINT_ERROR( msgBuf, myThid )
        STOP 'ABNORMAL END: S/R W2_SET_MAP_TILES'
      ENDIF
C--   Check that domain size and (SIZE.h + blankList) match:
      IF ( tCnt.NE.exch2_nTiles ) THEN
        WRITE(msgBuf,'(A,I8,A)')
     &   'W2_SET_MAP_TILES: Domain Total # of tiles =', tCnt, ' does'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(A,I8)')
     &   'W2_SET_MAP_TILES:  not match (SIZE.h+blankList)=',exch2_nTiles
        CALL PRINT_ERROR( msgBuf, myThid )
        STOP 'ABNORMAL END: S/R W2_SET_MAP_TILES'
      ENDIF

      IF ( W2_mapIO.EQ.1 ) THEN
C--   Compact IO map (mostly in Y dir): search for Greatest Common Divisor
C     of all x-size (faster to apply GCD to Nb of Tiles in X):
        k = 0
        nnx(1) = 0
        DO j=1,nFacets
C     skip empty facet
          IF ( facet_dims(2*j-1).GT.0 ) THEN
            k = k + 1
            nnx(k) = facet_dims(2*j-1)/tNx
          ENDIF
        ENDDO
        divide = FIND_GCD_N( nnx, k )
        W2_mapIO = divide*tNx
        WRITE(msgBuf,'(A,2(I5,A))') ' W2_mapIO =', W2_mapIO,
     &                              ' (=', divide, '*sNx)'
        CALL PRINT_MESSAGE( msgBuf, W2_oUnit, SQUEEZE_RIGHT, myThid )
      ENDIF

C--   Global Map size:
C     facets stacked in x direction
      exch2_xStack_Nx = 0
      exch2_xStack_Ny = 0
      DO j=1,nFacets
        exch2_xStack_Nx =   exch2_xStack_Nx + facet_dims(2*j-1)
        exch2_xStack_Ny = MAX( exch2_xStack_Ny, facet_dims(2*j) )
      ENDDO
C     facets stacked in y direction
      exch2_yStack_Nx = 0
      exch2_yStack_Ny = 0
      DO j=1,nFacets
        exch2_yStack_Nx = MAX( exch2_yStack_Nx, facet_dims(2*j-1) )
        exch2_yStack_Ny =   exch2_yStack_Ny + facet_dims(2*j)
      ENDDO
      IF ( W2_mapIO.EQ.-1 ) THEN
        exch2_global_Nx = exch2_xStack_Nx
        exch2_global_Ny = exch2_xStack_Ny
      ELSEIF ( W2_mapIO.EQ.0 ) THEN
        exch2_global_Nx = nbPts
        exch2_global_Ny = 1
      ELSE
        exch2_global_Nx = W2_mapIO
        exch2_global_Ny = nbPts/W2_mapIO
      ENDIF
      WRITE(msgBuf,'(A,2(A,I8))') ' Global Map (IO):',
     &  ' X-size=', exch2_global_Nx, ' , Y-size=', exch2_global_Ny
      CALL PRINT_MESSAGE( msgBuf, W2_oUnit, SQUEEZE_RIGHT, myThid )

C--   Set tiles mapping within facet (sub-domain) and within Global Map
      WRITE(msgBuf,'(2A)') 'W2_SET_MAP_TILES:',
     &       ' tile offset within facet and global Map:'
      CALL PRINT_MESSAGE( msgBuf, W2_oUnit, SQUEEZE_RIGHT, myThid )
      tId = 0
      nbPts = 0
      fBaseX = 0
      fBaseY = 0
      DO j=1,nFacets
        fNx = facet_dims(2*j-1)
        fNy = facet_dims( 2*j )
        nbTx = fNx/tNx
        nbTy = fNy/tNy
        WRITE(W2_oUnit,'(A,I3,2(A,I6),A,I8,2(A,I4),A)')
     &    '- facet', j, ' : X-size=', fNx, ' , Y-size=', fNy,
     &    ' ;', nbTx*nbTy, ' tiles (Tx,Ty=', nbTx,',',nbTy,')'
c       CALL PRINT_MESSAGE( msgBuf, W2_oUnit, SQUEEZE_RIGHT, myThid )
        DO ty=1,nbTy
         DO tx=1,nbTx
          tId = tId + 1
C--   Tags blank tile by removing facet # (exch2_myFace) but keeps its location
          tileIsActive = .TRUE.
          DO k=1,nBlankTiles
           IF ( blankList(k).EQ.tId ) tileIsActive = .FALSE.
          ENDDO
          IF ( tileIsActive ) exch2_myFace(tId) = j
          exch2_mydNx ( tId ) = fNx
          exch2_mydNy ( tId ) = fNy
          exch2_tNx   ( tId ) = tNx
          exch2_tNy   ( tId ) = tNy
          exch2_tBasex( tId ) = (tx-1)*tNx
          exch2_tBasey( tId ) = (ty-1)*tNy
C--   Global IO Mappings
C       these are for OBCS (vertical slices)
          exch2_txXStackLo( tId ) = 1 + exch2_tBasex(tId) + fBaseX
          exch2_tyXStackLo( tId ) = 1 + exch2_tBasey(tId)
          exch2_txYStackLo( tId ) = 1 + exch2_tBasex(tId)
          exch2_tyYStackLo( tId ) = 1 + exch2_tBasey(tId) + fBaseY
C       and these for global files (3d files/horizontal 2d files)
          IF ( W2_mapIO.EQ.-1 ) THEN
C-        Old format
            exch2_txGlobalo( tId ) = 1 + exch2_tBasex(tId) + fBaseX
            exch2_tyGlobalo( tId ) = 1 + exch2_tBasey(tId)
          ELSEIF ( W2_mapIO.EQ.0 ) THEN
C-        Compact format = 1 long line
            ii = nbPts + exch2_tBasex(tId) + exch2_tBasey(tId)*fNx
            exch2_txGlobalo( tId ) = 1 + ii
            exch2_tyGlobalo( tId ) = 1
          ELSE
C         Compact format: piled in the Y direction
            ii = nbPts + exch2_tBasex(tId) + exch2_tBasey(tId)*fNx
            exch2_txGlobalo( tId ) = 1 + MOD(ii,W2_mapIO)
            exch2_tyGlobalo( tId ) = 1 + ii/W2_mapIO
          ENDIF
          IF ( prtFlag )
     &    WRITE(W2_oUnit,'(A,I8,3(A,I3),2A,2I5,2A,2I8)') '  tile',tId,
     &    ' on facet', exch2_myFace(tId),' (',tx,',',ty,'):',
     &         ' offset=', exch2_tBasex(tId), exch2_tBasey(tId),' ;',
     &    ' on Glob.Map=', exch2_txGlobalo(tId),exch2_tyGlobalo(tId)
         ENDDO
        ENDDO
        fBaseX = fBaseX + fNx
        fBaseY = fBaseY + fNy
        nbPts = nbPts + fNx*fNy
      ENDDO

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: FIND_GCD_N

C     !INTERFACE:
      INTEGER FUNCTION FIND_GCD_N( fldList, nFld )

C     !DESCRIPTION:
C     *==========================================================*
C     | FUNCTION FIND_GCD_N
C     | o Find the Greatest Common Divisor of N integers
C     *==========================================================*

C     !USES:
      IMPLICIT NONE

C     !INPUT PARAMETERS:
C     fldList :: list of integers to search for GCD
C     nFLd    :: length of the input integer list.
      INTEGER nFLd
      INTEGER fldList(nFld)

C     !LOCAL VARIABLES:
      INTEGER mnFld, divide
      INTEGER j, ii
      LOGICAL flag
      LOGICAL localDBg
CEOP
      PARAMETER ( localDBg = .FALSE. )
c     PARAMETER ( localDBg = .TRUE. )

      mnFld = fldList(1)
      DO j=1,nFld
        mnFld = MIN( mnFld, fldList(j) )
      ENDDO
      IF (localDBg) WRITE(0,'(A,I8)') 'FIND_GCD_N: mnFld=',mnFld

      IF (mnFld.GT.1 ) THEN
        divide = 1
        ii = 2
        DO WHILE ( ii.LE.mnFld )
          IF (localDBg) WRITE(0,'(A,I8)') '     GCD  : try',ii
          flag = .TRUE.
          DO j=1,nFld
            flag = flag.AND.(MOD(fldList(j),ii).EQ.0 )
          ENDDO
          IF ( flag ) THEN
            divide = divide*ii
            DO j=1,nFld
              fldList(j) = fldList(j)/ii
            ENDDO
            IF (localDBg) WRITE(0,'(A,I8)')
     &                              'FIND_GCD_N: com.fact=',ii
            mnFld = mnFld/ii
          ELSE
            ii = ii+2
            IF (ii.EQ.4) ii=3
          ENDIF
        ENDDO
C-    Put back the original Nb:
        IF (localDBg) WRITE(0,'(10I8)') (fldList(j),j=1,nFld)
        DO j=1,nFld
          fldList(j) = fldList(j)*divide
        ENDDO
      ELSE
        divide = MAX( 0, mnFld )
      ENDIF

      FIND_GCD_N = divide

      RETURN
      END

#include "CPP_EEOPTIONS.h"
#undef W2_PRINT_PREFIX

CBOP
C     !ROUTINE: W2_PRINT_COMM_SEQUENCE

C     !INTERFACE:
      SUBROUTINE W2_PRINT_COMM_SEQUENCE( myThid )

C     !DESCRIPTION:
C     *==========================================================*
C     | SUBROUTINE W2_PRINT_COMM_SEQUENCE
C     | o Write communication sequence for a given WRAPPER2
C     |   topology
C     *==========================================================*

C     !USES:
      IMPLICIT NONE
C     == Global data ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "W2_EXCH2_SIZE.h"
#include "W2_EXCH2_TOPOLOGY.h"
#include "W2_EXCH2_PARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     W2_oUnit   :: fortran I/O unit
C     myThid     :: my Thread Id number
c     INTEGER W2_oUnit
      INTEGER myThid

#ifndef W2_PRINT_PREFIX
C     !FUNCTIONS:
      INTEGER  ILNBLNK
      EXTERNAL ILNBLNK
#endif

C     !LOCAL VARIABLES:
C     == Local variables ==
C     bi         :: tile index
C     N          :: Neighbours index
C     nN         :: number of Neighbours
C     targetTile ::
C     sourceProc ::
      INTEGER myTileId, nN
c     INTEGER PI_TC2SC(2), PJ_TC2SC(2), O_TC2SC(2)
c     _RL     SXDIR_TX2CX(2), SYDIR_TX2CX(2)
      INTEGER targetIlo, targetIhi, targetJlo, targetJhi
      INTEGER sourceIlo, sourceIhi, sourceJlo, sourceJhi
      INTEGER targetTile, targetProc, sourceProc
      INTEGER bi, bj, N
      INTEGER iStride, jStride
      INTEGER pi(2), pj(2), oi, oj, tN
      INTEGER itb, jtb, isb, jsb
      CHARACTER*(MAX_LEN_MBUF) msgBuf
#ifndef W2_PRINT_PREFIX
      INTEGER iLen
#endif
CEOP

C     Send loop for cell centered
      DO bj=1,nSy
       DO bi=1,nSx
        myTileId=W2_myTileList(bi,bj)
        nN=exch2_nNeighbours(myTileId)
        sourceProc=W2_tileProc(myTileId)
        DO N=1,nN
         targetTile=exch2_neighbourId(N,myTileId)
         targetProc=W2_tileProc(targetTile)
         tN = exch2_opposingSend(N,myTileId)
         pi(1)     =exch2_pij(1,N,myTileId)
         pi(2)     =exch2_pij(2,N,myTileId)
         pj(1)     =exch2_pij(3,N,myTileId)
         pj(2)     =exch2_pij(4,N,myTileId)
         oi        =exch2_oi(N,myTileId)
         oj        =exch2_oj(N,myTileId)
         CALL EXCH2_GET_SCAL_BOUNDS(
     I              'T ', OLx, .TRUE.,
     I              targetTile, tN,
     O              targetIlo, targetIhi, targetJlo, targetJhi,
     O              iStride, jStride,
     I              myThid )

         itb = exch2_tBasex(targetTile)
         jtb = exch2_tBasey(targetTile)
         isb = exch2_tBasex(myTileId)
         jsb = exch2_tBasey(myTileId)
         sourceIlo=pi(1)*(targetIlo+itb)+pi(2)*(targetJlo+jtb)+oi-isb
         sourceJlo=pj(1)*(targetIlo+itb)+pj(2)*(targetJlo+jtb)+oj-jsb
         sourceIhi=pi(1)*(targetIhi+itb)+pi(2)*(targetJhi+jtb)+oi-isb
         sourceJhi=pj(1)*(targetIhi+itb)+pj(2)*(targetJhi+jtb)+oj-jsb
C        Tile XX sends to points i=ilo:ihi,j=jlo:jhi in tile YY
         WRITE(msgBuf,'(A,I8,A,I8,A,4(A,I4))')
     &    'Tile', myTileId,' (pr=',sourceProc,')',
     &    ' sends pts i=',sourceIlo,':',sourceIhi,
     &             ', j=',sourceJlo,':',sourceJhi
#ifdef W2_PRINT_PREFIX
         CALL PRINT_MESSAGE( msgBuf, W2_oUnit, SQUEEZE_RIGHT, myThid )
#else
         iLen = ILNBLNK(msgBuf)
         WRITE(W2_oUnit,'(A)') msgBuf(1:iLen)
#endif
         WRITE(msgBuf,'(26X,4(A,I4),A,I8,A,I8,A)')
     &    '    to pts i=',targetIlo,':',targetIhi,
     &             ', j=',targetJlo,':',targetJhi,
     &    ' in tile ',targetTile,' (pr=',targetProc,')'
#ifdef W2_PRINT_PREFIX
         CALL PRINT_MESSAGE( msgBuf, W2_oUnit, SQUEEZE_RIGHT, myThid )
#else
         iLen = ILNBLNK(msgBuf)
         WRITE(W2_oUnit,'(A)') msgBuf(1:iLen)
#endif
        ENDDO
       ENDDO
      ENDDO

C     Recv loop for cell centered
      DO bj=1,nSy
       DO bi=1,nSx
        myTileId=W2_myTileList(bi,bj)
        nN=exch2_nNeighbours(myTileId)
        sourceProc=W2_tileProc(myTileId)
        DO N=1,nN
         targetTile=exch2_neighbourId(N,myTileId)
         targetProc=W2_tileProc(targetTile)
C        Find entry for tile targetTile entry that sent to this edge.
         tN=exch2_opposingSend(N,myTileId)
C        Get the range of points associated with that entry
         CALL EXCH2_GET_SCAL_BOUNDS(
     I              'T ', OLx, .TRUE.,
     I              myTileId, N,
     O              targetIlo, targetIhi, targetJlo, targetJhi,
     O              iStride, jStride,
     I              myThid )
C        Tile XX receives points i=ilo:ihi,j=jlo:jhi in tile YY
         WRITE(msgBuf,'(A,I8,A,I8,A,4(A,I4),A,I8,A,I8,A)')
     &    'Tile', myTileId,' (pr=',sourceProc,')',
     &    ' recv pts i=',targetIlo,':',targetIhi,
     &            ', j=',targetJlo, ':',targetJhi,
     &    ' from tile',targetTile,' (pr=',targetProc,')'
#ifdef W2_PRINT_PREFIX
         CALL PRINT_MESSAGE( msgBuf, W2_oUnit, SQUEEZE_RIGHT, myThid )
#else
         iLen = ILNBLNK(msgBuf)
         WRITE(W2_oUnit,'(A)') msgBuf(1:iLen)
#endif
        ENDDO
       ENDDO
      ENDDO

      RETURN
      END

#include "EBM_OPTIONS.h"
#ifdef ALLOW_AUTODIFF
# include "AUTODIFF_OPTIONS.h"
#endif

CBOP 0
C !ROUTINE: EBM_ATMOSPHERE

C !INTERFACE:
      SUBROUTINE EBM_ATMOSPHERE ( myTime, myIter, myThid )

C     !DESCRIPTION:
C     *==========================================================*
C     | S/R CALCULATE FORCING FROM ENERGY AND MOISTURE
C     | BALANCE ATMOSPHERE
C     *==========================================================*
C      References:
C      * X. Wang, P. Stone and J. Marotzke, 1999:
C        Global thermohaline circulation. Part I:
C        Sensitivity to atmospheric moisture transport.
C        J. Climate 12(1), 71-82
C      * X. Wang, P. Stone and J. Marotzke, 1999:
C        Global thermohaline circulation. Part II:
C        Sensitivity with interactive transport.
C        J. Climate 12(1), 83-91
C      * M. Nakamura, P. Stone and J. Marotzke, 1994:
C        Destabilization of the thermohaline circulation
C        by atmospheric eddy transports.
C        J. Climate 7(12), 1870-1882

C     !USES:
      IMPLICIT NONE
C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "FFIELDS.h"
#include "GRID.h"
#include "EBM.h"
#ifdef ALLOW_AUTODIFF_TAMC
# include "tamc.h"
#endif

C     !INPUT PARAMETERS:
C     === Routine arguments ===
C     myThid  :: my Thread Id number
      _RL myTime
      INTEGER myIter
      INTEGER myThid
CEOP

#ifdef ALLOW_EBM
C     !LOCAL VARIABLES:
      INTEGER i, j, bi, bj
      INTEGER no_so
#ifdef ALLOW_AUTODIFF_TAMC
C     ikey :: tape key (tile dependent)
      INTEGER ikey
#endif /* ALLOW_AUTODIFF_TAMC */
      _RL ReCountX(1-OLy:sNy+OLy,nSy)

C--   Local arrays used for EBM computation (previously declared in EBM.h)
C-    sin(lat) and Legendre polynomials
cph We will make these three (i,j) arrays to
cph avoid AD recomputations
      _RL S(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSy)
      _RL P2(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSy)
      _RL P4(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSy)
C-    Shortwave and albedo parameters
      _RL SW(1-OLy:sNy+OLy,nSy)
C-    Longwave parameters
      _RL LW(1-OLy:sNy+OLy,nSy)
C-    Heat transport parameters
      _RL Hd(1-OLy:sNy+OLy,nSy), Hd35(2)
C-    Freshwater flux parameters
      _RL Fw(1-OLy:sNy+OLy,nSy), Fw35(2)
C-    Temperature parameterization
      _RL T(1-OLy:sNy+OLy,nSy)
      _RL T_var(4), T0(2), T2(2), T35(2), DTDy35(2)
C-    Parameters used to calculate the transport efficiency
      _RL Cl, Cf, Cs, C
      _RL gamma, kappa, De
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)

#ifdef ALLOW_AUTODIFF_TAMC
        ikey = bi + (bj-1)*nSx + (ikey_dynamics-1)*nSx*nSy
#endif /* ALLOW_AUTODIFF_TAMC */

        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          S(i,j,bj) = 0.0
          P2(i,j,bj) = 0.0
          P4(i,j,bj) = 0.0
         ENDDO
         SW(j,bj) = 0.0
         LW(j,bj) = 0.0
         Hd(j,bj) = 0.0
         Fw(j,bj) = 0.0
         T(j,bj) = 0.0
         ReCountX(j,bj) = 0.0
        ENDDO

        print *, 'SH', TmlS-t_mlt, TtS-t_mlt
        print *, 'NH', TmlN-t_mlt, TtN-t_mlt

C--   account for ice (can absorb heat on an annual averaged basis)
C--   Greenland in Northern Hemisphere, Antarctica in Southern
        DO j = 1,sNy
         ReCountX(j,bj) = CountX(j,bj)
         IF (yC(1,j,bi,bj) .LE. -62.0) THEN
            ReCountX(j,bj) = 90.
         ELSE IF (yC(1,j,bi,bj) .EQ. 74.0) THEN
            ReCountX(j,bj) = CountX(j,bj) + 9.0
         ELSE IF (yC(1,j,bi,bj) .EQ. 70.0) THEN
            ReCountX(j,bj) = CountX(j,bj) + 8.0
         ELSE IF (yC(1,j,bi,bj) .EQ. 66.0) THEN
            ReCountX(j,bj) = CountX(j,bj) + 5.0
         ELSE IF (yC(1,j,bi,bj) .EQ. 62.0) THEN
            ReCountX(j,bj) = CountX(j,bj) + 1.0
         ENDIF
        ENDDO
#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE ReCountX(:,bj) = comlev1_bibj, key=ikey, byte=isbyte
#endif

c=====================================================
c     Fit area-weighed  averaged SST north/south of 34
c     degree  to second  Legendre polynomial:
c=======================================================
        T_var(1) = SIN(latBnd(2)*deg2rad) - SIN(latBnd(1)*deg2rad)
        T_var(2) = SIN(latBnd(3)*deg2rad) - SIN(latBnd(2)*deg2rad)
        T_var(3) = SIN(latBnd(2)*deg2rad)**3 - SIN(latBnd(1)*deg2rad)**3
        T_var(4) = SIN(latBnd(3)*deg2rad)**3 - SIN(latBnd(2)*deg2rad)**3
#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE T_var(:) = comlev1_bibj, key=ikey, byte=isbyte
#endif

c----------------------------------------
c     Southern hemisphere:
c----------------------------------------
        T2(1) =  2.*(TtS - TmlS)*T_var(1)*T_var(2)/
     &     (T_var(3)*T_var(2) - T_var(4)*T_var(1))
        T0(1) = TtS - 0.5*T2(1)*((T_var(3)/T_var(1)) - 1.)
c----------------------------------------
c     Northern hemisphere
c----------------------------------------
        T2(2) =  2.*(TtN - TmlN)*T_var(1)*T_var(2)/
     &     (T_var(3)*T_var(2) - T_var(4)*T_var(1))
        T0(2) = TtN - 0.5*T2(2)*((T_var(3)/T_var(1)) - 1.)
c-----------------------------------------
c     Temperature  at 35 N/S
c-----------------------------------------
        DO no_so = 1,2
         T35(no_so)= T0(no_so) +
     &        T2(no_so)*0.5*
     &        ( 3.*SIN(latBnd(2)*deg2rad)**2 - 1. )
        ENDDO
c-----------------------------------------
c     Temperature gradient at 35 N/S
c-----------------------------------------
        DO no_so = 1, 2
         DTDy35(no_so) = 3.*T2(no_so)*
     &        SIN(latBnd(2)*deg2rad)/rSphere
        ENDDO
c-----------------------------------------------------------
c     Magnitude of the heat and moisture transport at 35 N/S
c-----------------------------------------------------------

#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE T35(:)    = comlev1_bibj, key=ikey, byte=isbyte
CADJ STORE DTDy35(:) = comlev1_bibj, key=ikey, byte=isbyte
#endif
        DO no_so = 1, 2
         IF ( DTDy35(no_so).NE.0. .AND. T35(no_so).NE.0. ) THEN
          gamma = -T35(no_so)*beta*Hw*Nw*Nw/
     &        (gravity*f0*DTDy35(no_so))
          kappa = Hw/(1. _d 0 + gamma)
          De = Hw/(0.48 _d 0 + 1.48 _d 0 *gamma)
          C = 0.6 _d 0 *gravity*kappa*kappa*Nw/
     &        (Tw*f0*f0)
          Cs = rho_air*cp*C*
     &        ( 1. _d 0 /(1. _d 0 /Hw + 1. _d 0 /De)
     &         -1. _d 0 /(1. _d 0 /Hw+1. _d 0 /De+1. _d 0 /dz) )
          Cf = htil*2.97 _d 12*C/(T35(no_so)**3)*(
     &        1. _d 0/(1. _d 0/De + (5420. _d 0*tau /(T35(no_so)**2)))
     &        -1. _d 0/(1. _d 0/De+5420. _d 0*tau/(T35(no_so)**2)
     &        +1. _d 0/dz))
          Cl = Cf*lv
          Hd35(no_so) = 2.*PI*rSphere*COS(latBnd(2)*deg2rad)
     &        *(Cs + Cl*exp(-5420./T35(no_so)))
     &        *(abs(DTDy35(no_so))**trans_eff)
          Fw35(no_so) = 2.*PI*rSphere*COS(latBnd(2)*deg2rad)
     &        *(abs(DTDy35(no_so))**trans_eff)
     &        *Cf*exp(-5420./T35(no_so))
         ELSE
          Hd35(no_so) = 0.
          Fw35(no_so) = 0.
         ENDIF
        ENDDO
c
        Fw35(1) = 929944128.
        Fw35(2) = 678148032.
c
#ifdef EBM_VERSION_1BASIN
c      Fw35(2) = 0.7*Fw35(2)
#else
        Hd35(2) = 1.6 _d 0*Hd35(2)
#endif
c======================================================
c     Calculation of latitudinal profiles
c======================================================
c
        DO j=1,sNy
         DO i=1,sNx
C     sin(lat)
          S(i,j,bj) = SIN(yC(i,j,bi,bj)*deg2rad)
C     setup Legendre polynomials and  derivatives
          P2(i,j,bj) = 0.5*(3.*S(i,j,bj)**2 - 1.)
          P4(i,j,bj) = 0.12 _d 0 *
     &                (35.*S(i,j,bj)**4 - 30.*S(i,j,bj)**2 + 3.)
         ENDDO
        ENDDO
#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE S(:,:,bj)    = comlev1_bibj, key=ikey, byte=isbyte
CADJ STORE P2(:,:,bj)   = comlev1_bibj, key=ikey, byte=isbyte
CADJ STORE P4(:,:,bj)   = comlev1_bibj, key=ikey, byte=isbyte
#endif
c
        DO j=1,sNy
         DO i=1,sNx

          IF (yC(i,j,bi,bj) .LT. 0.) THEN
             no_so = 1
          ELSE
             no_so = 2
          ENDIF
c     net shortwave
          SW(j,bj) = 0.25 _d 0 *Q0*(1. _d 0 + Q2*P2(i,j,bj))*
     &         (1. _d 0 - A0 - A2*P2(i,j,bj) - A4*P4(i,j,bj) )
c     temperature
          T(j,bj) = T0(no_so) + T2(no_so)*P2(i,j,bj)
c     net longwave
          LW(j,bj) = LW0 + LW1*(T(j,bj)-t_mlt)
c     climate change run, the parameter to change is DLW
#ifdef EBM_CLIMATE_CHANGE
             LW(j,bj) = LW(j,bj) -
     &            (myTime-startTime)*3.215 _d -8*DLW
c     <            - 6.0
c     <            *75.0*0.0474*
c     <            (-2.62*S(i,j,bj)**8 + 0.73*S(i,j,bj)**7 +
c     <            4.82*S(i,j,bj)**6 -
c     <            1.12*S(i,j,bj)**5 - 2.69*S(i,j,bj)**4 + 0.47*S(i,j,bj)**3 +
c     <            0.51*S(i,j,bj)**2 - 0.05*S(i,j,bj)**1 + 0.17)
#endif
c     fluxes at ocean/atmosphere interface
c     Heat Flux = -Div(atmospheric heat transport) + SW - LW
#ifdef EBM_VERSION_1BASIN
         Qnet(i,j,bi,bj) = -1.0 _d 0 *( SW(j,bj) - LW(j,bj) -
     &        Hd35(no_so)*(
     &        0.000728 _d 4      - 0.00678 _d 4*S(i,j,bj) +
     &        0.0955 _d 4*S(i,j,bj)**2 + 0.0769 _d 4*S(i,j,bj)**3 -
     &        0.8508 _d 4*S(i,j,bj)**4 - 0.3581 _d 4*S(i,j,bj)**5 +
     &        2.9240 _d 4*S(i,j,bj)**6 + 0.8311 _d 4*S(i,j,bj)**7 -
     &        4.9548 _d 4*S(i,j,bj)**8 - 0.8808 _d 4*S(i,j,bj)**9 +
     &        4.0644 _d 4*S(i,j,bj)**10 +0.3409 _d 4*S(i,j,bj)**11 -
     &        1.2893 _d 4*S(i,j,bj)**12 )
     &        /(2.*PI*rSphere*rSphere*25.) )
c             Qnet(i,j,bi,bj) = -1.0*( SW(j,bj) - LW(j,bj) -
c     <            0.5*Hd35(no_so)*(3.054e1 - 3.763e1*S(i,j,bj) +
c     <        1.892e2*S(i,j,bj)**2 + 3.041e2*S(i,j,bj)**3 -
c     <        1.540e3*S(i,j,bj)**4 - 9.586e2*S(i,j,bj)**5 +
c     <        2.939e3*S(i,j,bj)**6 + 1.219e3*S(i,j,bj)**7 -
c     <        2.550e3*S(i,j,bj)**8 - 5.396e2*S(i,j,bj)**9 +
c     <        8.119e2*S(i,j,bj)**10)
c     <            /(2*PI*rSphere*rSphere*22.3) )
#else
          IF (ReCountX(j,bj) .GT. 0.) THEN
             Qnet(i,j,bi,bj) = (-90. _d 0 /ReCountX(j,bj))*
     &            ( SW(j,bj) - LW(j,bj) -
     &            Hd35(no_so)*(3.054 _d 1 - 3.763 _d 1*S(i,j,bj) +
     &        1.892 _d 2*S(i,j,bj)**2 + 3.041 _d 2*S(i,j,bj)**3 -
     &        1.540 _d 3*S(i,j,bj)**4 - 9.586 _d 2*S(i,j,bj)**5 +
     &        2.939 _d 3*S(i,j,bj)**6 + 1.219 _d 3*S(i,j,bj)**7 -
     &        2.550 _d 3*S(i,j,bj)**8 - 5.396 _d 2*S(i,j,bj)**9 +
     &        8.119 _d 2*S(i,j,bj)**10)
     &            /(2.*PI*rSphere*rSphere*22.3 _d 0) )
          ELSE
             Qnet(i,j,bi,bj) = 0.
          ENDIF
#endif
c     Freshwater Flux = Div(atmospheric moisture transport)
c---  conversion of E-P from kg/(s m^2) -> m/s -> g/kg/s: 1e-3*35/delZ(1)
#ifdef EBM_VERSION_1BASIN
          EmPmR(i,j,bi,bj) = -1. _d -3*Fw35(no_so)
     &    *(-0.8454 _d 5*S(i,j,bj)**14 + 0.5367 _d 5*S(i,j,bj)**13
     &    +3.3173 _d 5*S(i,j,bj)**12 - 1.8965 _d 5*S(i,j,bj)**11
     &    -5.1701 _d 5*S(i,j,bj)**10
     &    +2.6240 _d 5*S(i,j,bj)**9 + 4.077 _d 5*S(i,j,bj)**8
     &    -1.791 _d 5*S(i,j,bj)**7
     &    -1.7231 _d 5*S(i,j,bj)**6 + 0.6229 _d 5*S(i,j,bj)**5
     &    +0.3824 _d 5*S(i,j,bj)**4
     &    -0.1017 _d 5*S(i,j,bj)**3 - 0.0387 _d 5*S(i,j,bj)**2
     &    +0.00562 _d 5*S(i,j,bj)  + 0.0007743 _d 5)
     &    /(2.0*12.0*PI*rSphere*rSphere)
c             EmPmR(i,j,bi,bj) = 1.e-3*Fw35(no_so)
c     <            *(50.0 + 228.0*S(i,j,bj) -1.593e3*S(i,j,bj)**2
c     <            - 2.127e3*S(i,j,bj)**3 + 7.3e3*S(i,j,bj)**4
c     <            + 5.799e3*S(i,j,bj)**5 - 1.232e4*S(i,j,bj)**6
c     <            - 6.389e3*S(i,j,bj)**7 + 9.123e3*S(i,j,bj)**8
c     <            + 2.495e3*S(i,j,bj)**9 - 2.567e3*S(i,j,bj)**10)
c     <            /(2*PI*rSphere*rSphere*15.0)
#else
          IF (yC(i,j,bi,bj) .LT. -40.) THEN
c--   Southern Hemisphere
           EmPmR(i,j,bi,bj) = -1. _d -3*(Fw35(no_so)*
     &            (-6.5 _d 0 + 35.3 _d 0 + 71.7 _d 0*S(i,j,bj)
     &           - 1336.3 _d 0*S(i,j,bj)**2 - 425.8 _d 0*S(i,j,bj)**3
     &           + 5434.8 _d 0*S(i,j,bj)**4 + 707.9 _d 0*S(i,j,bj)**5
     &           - 6987.7 _d 0*S(i,j,bj)**6 - 360.4 _d 0*S(i,j,bj)**7
     &           + 2855.0 _d 0*S(i,j,bj)**8)
     &            /(2.*PI*rSphere*rSphere*18.0))
          ELSE
c--   Atlantic
           IF (xC(i,j,bi,bj) .GT. 284.
     &      .OR. xC(i,j,bi,bj) .LT. 28.) THEN
              EmPmR(i,j,bi,bj) = -1. _d -3*(Fw35(no_so)*
     &             (-6.5 _d 0 -2.878 _d 0 + 3.157 _d 2*S(i,j,bj) -
     &             2.388 _d 3*S(i,j,bj)**2 - 4.101 _d 3*S(i,j,bj)**3 +
     &             1.963 _d 4*S(i,j,bj)**4 + 1.534 _d 4*S(i,j,bj)**5 -
     &             6.556 _d 4*S(i,j,bj)**6 - 2.478 _d 4*S(i,j,bj)**7 +
     &             1.083 _d 5*S(i,j,bj)**8 + 1.85 _d 4*S(i,j,bj)**9 -
     &             8.703 _d 4*S(i,j,bj)**10 - 5.276 _d 3*S(i,j,bj)**11 +
     &             2.703 _d 4*S(i,j,bj)**12)
     &             /(2.*PI*rSphere*rSphere*12.0))
           ELSE
c--   Pacific
              EmPmR(i,j,bi,bj) = -1. _d -3*(Fw35(no_so)
     &             *(-6.5 _d 0 +51.89 _d 0 + 4.916 _d 2*S(i,j,bj) -
     &             1.041 _d 3*S(i,j,bj)**2 - 7.546 _d 3*S(i,j,bj)**3 +
     &             2.335 _d 3*S(i,j,bj)**4 + 3.449 _d 4*S(i,j,bj)**5 +
     &             6.702 _d 3*S(i,j,bj)**6 - 6.601 _d 4*S(i,j,bj)**7 -
     &             2.594 _d 4*S(i,j,bj)**8 + 5.652 _d 4*S(i,j,bj)**9 +
     &             2.738 _d 4*S(i,j,bj)**10 - 1.795 _d 4*S(i,j,bj)**11 -
     &             9.486 _d 3*S(i,j,bj)**12)
     &             /(2.*PI*rSphere*rSphere*12.0))
           ENDIF
          ENDIF
#endif
          EmPmR(i,j,bi,bj) = EmPmR(i,j,bi,bj)
     &                     - Run(i,j,bi,bj)*scale_runoff
          EmPmR(i,j,bi,bj) = EmPmR(i,j,bi,bj)*rhoConstFresh
         ENDDO
        ENDDO
       ENDDO
      ENDDO

      _EXCH_XY_RS(Qnet , myThid )
      _EXCH_XY_RS(EmPmR , myThid )

C      CALL PLOT_FIELD_XYRS( Qnet, 'Qnet' , 1, myThid )
C      CALL PLOT_FIELD_XYRS( EmPmR, 'EmPmR' , 1, myThid )

#endif /* ALLOW_EBM */

      RETURN
      END

#include "AUTODIFF_OPTIONS.h"
#include "AD_CONFIG.h"

CBOP
C     !ROUTINE: AUTODIFF_CHECK
C     !INTERFACE:
      SUBROUTINE AUTODIFF_CHECK( myThid )

C     !DESCRIPTION: \bv
C     \ev

      IMPLICIT NONE
#include "SIZE.h"
#include "GRID.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#ifdef ALLOW_AUTODIFF_TAMC
# include "tamc.h"
#endif
#ifdef ALLOW_DIAGNOSTICS
# include "DIAGNOSTICS_P2SHARE.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     myThid -  Number of this instances
      INTEGER myThid
C     msgBuf :: Informational/error message buffer
      CHARACTER*(MAX_LEN_MBUF) msgBuf
CEOP

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#ifdef ALLOW_AUTODIFF_TAMC

#ifdef ALLOW_TAMC_CHECKPOINTING
# if (defined (AUTODIFF_2_LEVEL_CHECKPOINT))
      IF (nchklev_1*nchklev_2 .lt. nTimeSteps) THEN
        WRITE(msgBuf,'(A)')
     &       'THE_MAIN_LOOP: TAF checkpointing parameters'
        CALL PRINT_ERROR( msgBuf , myThid )
        WRITE(msgBuf,'(A,I10)')
     &       'nchklev_1*nchklev_2 = ',
     &       nchklev_1*nchklev_2
        CALL PRINT_ERROR( msgBuf , myThid )
        WRITE(msgBuf,'(A,I10)')
     &       'are not consistent with nTimeSteps = ',
     &       nTimeSteps
        CALL PRINT_ERROR( msgBuf , myThid )
        STOP 'ABNORMAL END: S/R AUTODIFF_CHECK'
      ENDIF
# elif (defined (AUTODIFF_4_LEVEL_CHECKPOINT))
      IF (nchklev_1*nchklev_2*nchklev_3*nchklev_4 .lt. nTimeSteps) THEN
        WRITE(msgBuf,'(A)')
     &       'THE_MAIN_LOOP: TAF checkpointing parameters'
        CALL PRINT_ERROR( msgBuf , myThid )
        WRITE(msgBuf,'(A,I10)')
     &       'nchklev_1*nchklev_2*nchklev_3*nchklev_4 = ',
     &       nchklev_1*nchklev_2*nchklev_3*nchklev_4
        CALL PRINT_ERROR( msgBuf , myThid )
        WRITE(msgBuf,'(A,I10)')
     &       'are not consistent with nTimeSteps = ',
     &       nTimeSteps
        CALL PRINT_ERROR( msgBuf , myThid )
        STOP 'ABNORMAL END: S/R AUTODIFF_CHECK'
      ENDIF
# else
c--   Check the choice of the checkpointing parameters in relation
c--   to nTimeSteps: (nchklev_1*nchklev_2*nchklev_3 .ge. nTimeSteps)
      IF (nchklev_1*nchklev_2*nchklev_3 .lt. nTimeSteps) THEN
        WRITE(msgBuf,'(A)')
     &       'THE_MAIN_LOOP: TAF checkpointing parameters'
        CALL PRINT_ERROR( msgBuf , myThid )
        WRITE(msgBuf,'(A,I10)')
     &       'nchklev_1*nchklev_2*nchklev_3 = ',
     &       nchklev_1*nchklev_2*nchklev_3
        CALL PRINT_ERROR( msgBuf , myThid )
        WRITE(msgBuf,'(A,I10)')
     &       'are not consistent with nTimeSteps = ',
     &       nTimeSteps
        CALL PRINT_ERROR( msgBuf , myThid )
        STOP 'ABNORMAL END: S/R AUTODIFF_CHECK'
      ENDIF
# endif
#else /* undef ALLOW_TAMC_CHECKPOINTING */
      IF (nchklev_1 .lt. nTimeSteps) THEN
        WRITE(msgBuf,'(A)')
     &       'THE_MAIN_LOOP: TAF checkpointing parameters'
        CALL PRINT_ERROR( msgBuf , myThid )
        WRITE(msgBuf,'(A,I10)')
     &       'nchklev_1 = ', nchklev_1
        CALL PRINT_ERROR( msgBuf , myThid )
        WRITE(msgBuf,'(A,I10)')
     &       'are not consistent with nTimeSteps = ', nTimeSteps
        CALL PRINT_ERROR( msgBuf , myThid )
        STOP 'ABNORMAL END: S/R AUTODIFF_CHECK'
      ENDIF
#endif /* ALLOW_TAMC_CHECKPOINTING */

c#ifndef ALLOW_AUTODIFF_WHTAPEIO
c      IF ( useSingleCpuIO ) THEN
c       WRITE(msgBuf,'(3A)') '** WARNING ** AUTODIFF_CHECK: ',
c    &        'relying on mdsio_read/writevector.F to write ',
c    &        'tapes is unsafe when useSingleCpuIO is true.'
c       CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
c    &  SQUEEZE_RIGHT, myThid )
c      ENDIF
c#endif

#endif /* ALLOW_AUTODIFF_TAMC */

#ifndef ALLOW_AUTODIFF_MONITOR
       IF ( adjDumpFreq .NE. 0. ) THEN
        WRITE(msgBuf,'(A)')
     &         'adjDumpFreq <> 0, but undef ALLOW_AUTODIFF_MONITOR'
        CALL PRINT_ERROR( msgBuf , myThid )
        STOP 'ABNORMAL END: S/R AUTODIFF_CHECK'
       ENDIF
       IF ( adjMonitorFreq .NE. 0. ) THEN
        WRITE(msgBuf,'(A)')
     &         'adjMonitorFreq <> 0, but undef ALLOW_AUTODIFF_MONITOR'
        CALL PRINT_ERROR( msgBuf , myThid )
        STOP 'ABNORMAL END: S/R AUTODIFF_CHECK'
       ENDIF
# ifdef ALLOW_DIAGNOSTICS
       IF ( useDiag4AdjOutp ) THEN
        WRITE(msgBuf,'(A)')
     &    'using Adj-Diagnostics, but undef ALLOW_AUTODIFF_MONITOR'
        CALL PRINT_ERROR( msgBuf , myThid )
        STOP 'ABNORMAL END: S/R AUTODIFF_CHECK'
       ENDIF
# endif /*  ALLOW_DIAGNOSTICS */
#endif /* ndef ALLOW_AUTODIFF_MONITOR */

#ifdef ALLOW_OPENAD
# if (defined (ALLOW_ECCO) || defined (ALLOW_PROFILES))
       WRITE(msgBuf,'(2A)')
     &  'AUTODIFF_CHECK: pkg ECCO or PROFILES not yet implemented ',
     &  ' for ALLOW_AUTODIFF_OPENAD'
       CALL PRINT_ERROR( msgBuf , myThid )
       STOP 'ABNORMAL END: S/R AUTODIFF_CHECK'
# endif
#endif /* ALLOW_OPENAD */

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      RETURN
      END

#include "COST_OPTIONS.h"

CBOP
C     !ROUTINE: COST_TEST
C     !INTERFACE:
      SUBROUTINE COST_TEST( myThid )
C     *==========================================================*
C     | SUBROUTINE COST_TEST
C     | o this routine computes the cost function for the tiles
C     |   of this processor
C     *==========================================================*
C     | Notes
C     *==========================================================*
C     !USES:
       IMPLICIT NONE
C     == Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "DYNVARS.h"
#include "GRID.h"
#include "cost.h"

C !INPUT/OUTPUT PARAMETERS:
C     myThid - Thread number for this instance of the routine.
      INTEGER myThid
CEOP

#ifdef ALLOW_COST_TEST
C     Abuse this routine as driver to call a free-format function and
C     pass all variables normally imported by include statements.
      CALL COST_TEST_LOCAL (
     I     sNx, sNy, nSx, nSy, OLx, OLy, Nr,
     I     myBxLo(myThid), myBxHi(myThid),
     I     myByLo(myThid), myByHi(myThid),
     I     myXGlobalLo, myYGlobalLo,
     I     theta,
     U     objf_test,
     I     myThid )
#endif  /* ALLOW_COST_TEST */

      RETURN
      END

#include "DIAG_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 0
C     !ROUTINE: DIAGNOSTICS_INTERP_P2P

C     !INTERFACE:
      SUBROUTINE DIAGNOSTICS_INTERP_P2P(
     O                       qprs,
     I                       qinp,pkz,pksrf,pktop,pk,
     I                       undef, pInc,ijm,lm, myThid )

C     !DESCRIPTION:
C***********************************************************************
C
C PURPOSE
C   To interpolate an arbitrary quantity to Specified Pressure Levels
C
C INPUT
C   QINP .. QINP (ijm,lm) Arbitrary Input Quantity
C   PKZ ... PKZ  (ijm,lm) Pressure to the Kappa at Input Levels
C   PKSRF . PKSRF(ijm) Surface Pressure to the Kappa
C   PKTOP . Pressure to the Kappa at Input-Level-Edge (1) (top of model)
C   PK .... Output Pressure to the Kappa Level (mb)
C   pInc .. if True, assume pressure increases with level index
C   IJM ... Horizontal Dimension of Input
C   LM .... Vertical  Dimension of Input
C
C OUTPUT
C   QPRS .. QPRS (ijm) Arbitrary Quantity at Pressure p
C
C NOTE
C   Quantity is interpolated Linear in P**Kappa.
C   Between  PTOP**Kappa and PKZ(1),  quantity is extrapolated.
C   Between PKSRF**Kappa and PKZ(LM), quantity is extrapolated.
C   Undefined Input quantities are not used.
C   Finally: This routine assumes that pressure levels are counted
C            top down -- ie, level 1 is the top, level lm is the bottom
C
C***********************************************************************
C     !USES:
      IMPLICIT NONE

C     !INPUT PARAMETERS:
      INTEGER  ijm,lm,myThid
      _RL  qinp (ijm,lm)
      _RL  pkz  (ijm,lm)
      _RL  pksrf(ijm)
      _RL  pktop,pk
      _RL  undef
      LOGICAL pInc

C     !OUTPUT PARAMETERS:
      _RL  qprs (ijm)
CEOP

C     !LOCAL VARIABLES:
      INTEGER  i,l
      _RL  pkmin,pkmax,temp

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

c Initialize to UNDEFINED
c -----------------------
      DO i=1,ijm
       qprs(i) = undef
      ENDDO

      IF ( pInc ) THEN
C---  Case where Levels are orderd by increasing pressure

c Interpolate to Pressure Between Input Levels
c --------------------------------------------
      DO L=1,lm-1
       pkmin = pkz(1,L)
       pkmax = pkz(1,L+1)

       DO i=2,ijm
         IF ( pkz(i,L)  .LT.pkmin ) pkmin = pkz(i,L)
         IF ( pkz(i,L+1).GT.pkmax ) pkmax = pkz(i,L+1)
       ENDDO

       IF ( pk.LE.pkmax .AND. pk.GE.pkmin ) THEN
         DO i=1,ijm
           IF ( pk.GE.pkz(i,L) .AND. pk.LE.pkz(i,L+1) ) THEN
             temp = ( pk-pkz(i,L) ) / ( pkz(i,L+1)-pkz(i,L) )

             IF     ( qinp(i,L)  .NE.undef  .AND.
     &                qinp(i,L+1).NE.undef ) THEN
               qprs(i) = qinp(i,L+1)*temp + qinp(i,L)*(1.-temp)
             ELSEIF ( qinp(i,L+1).NE.undef  .AND. temp.GE.0.5 ) THEN
               qprs(i) = qinp(i,L+1)
             ELSEIF ( qinp(i,L)  .NE.undef  .AND. temp.LE.0.5 ) THEN
               qprs(i) = qinp(i,L)
             ENDIF
           ENDIF
         ENDDO
       ENDIF

      ENDDO

      DO i=1,ijm
c Extrapolate to Pressure between Ptop and Highest Input Level
c ----------------------------------------------------------
       IF ( pk.LE.pkz(i,1) .AND. pk.GE.pktop ) THEN
         temp = ( pk-pkz(i,1) ) / ( pkz(i,2)-pkz(i,1) )

         IF     ( qinp(i,1).NE.undef  .AND.
     &           qinp(i,2).NE.undef ) THEN
           qprs(i) = qinp(i,2)*temp + qinp(i,1)*(1.-temp)
         ELSEIF ( qinp(i,1).NE.undef ) THEN
           qprs(i) = qinp(i,1)
         ENDIF

       ENDIF

c Extrapolate to Pressure between Psurf and Lowest Input Level
c ------------------------------------------------------------
       IF ( pk.GE.pkz(i,lm) .AND. pk.LE.pksrf(i) ) THEN
         temp = ( pk-pkz(i,lm) ) / ( pkz(i,lm-1)-pkz(i,lm) )

         IF     ( qinp(i,lm)  .NE.undef  .AND.
     &            qinp(i,lm-1).NE.undef ) THEN
            qprs(i) = qinp(i,lm-1)*temp + qinp(i,lm)*(1.-temp)
         ELSEIF ( qinp(i,lm)  .NE.undef ) THEN
            qprs(i) = qinp(i,lm)
         ENDIF

       ENDIF
      ENDDO

      ELSE
C---  Case where Levels are orderd by decreasing pressure

c Interpolate to Pressure Between Input Levels
c --------------------------------------------
      DO L=1,lm-1
       pkmin = pkz(1,L+1)
       pkmax = pkz(1,L)

       DO i=2,ijm
         IF ( pkz(i,L+1).LT.pkmin ) pkmin = pkz(i,L+1)
         IF ( pkz(i,L)  .GT.pkmax ) pkmax = pkz(i,L)
       ENDDO

       IF ( pk.LE.pkmax .AND. pk.GE.pkmin ) THEN
         DO i=1,ijm
           IF ( pk.LE.pkz(i,L) .AND. pk.GE.pkz(i,L+1) ) THEN
             temp = ( pk-pkz(i,L) ) / ( pkz(i,L+1)-pkz(i,L) )

             IF     ( qinp(i,L)  .NE.undef  .AND.
     &                qinp(i,L+1).NE.undef ) THEN
               qprs(i) = qinp(i,L+1)*temp + qinp(i,L)*(1.-temp)
             ELSEIF ( qinp(i,L+1).NE.undef  .AND. temp.GE.0.5 ) THEN
               qprs(i) = qinp(i,L+1)
             ELSEIF ( qinp(i,L)  .NE.undef  .AND. temp.LE.0.5 ) THEN
               qprs(i) = qinp(i,L)
             ENDIF
           ENDIF
         ENDDO
       ENDIF

      ENDDO

      DO i=1,ijm
c Extrapolate to Pressure between Ptop and Highest Input Level
c ----------------------------------------------------------
       IF ( pk.LE.pkz(i,lm) .AND. pk.GE.pktop ) THEN
         temp = ( pk-pkz(i,lm) ) / ( pkz(i,lm-1)-pkz(i,lm) )

         IF     ( qinp(i,lm)  .NE.undef  .AND.
     &            qinp(i,lm-1).NE.undef ) THEN
            qprs(i) = qinp(i,lm-1)*temp + qinp(i,lm)*(1.-temp)
         ELSEIF ( qinp(i,lm)  .NE.undef ) THEN
            qprs(i) = qinp(i,lm)
         ENDIF

       ENDIF

c Extrapolate to Pressure between Psurf and Lowest Input Level
c ------------------------------------------------------------
       IF ( pk.GE.pkz(i,1) .AND. pk.LE.pksrf(i) ) THEN
         temp = ( pk-pkz(i,1) ) / ( pkz(i,2)-pkz(i,1) )

         IF     ( qinp(i,1).NE.undef  .AND.
     &            qinp(i,2).NE.undef ) THEN
           qprs(i) = qinp(i,2)*temp + qinp(i,1)*(1.-temp)
         ELSEIF ( qinp(i,1).NE.undef ) THEN
           qprs(i) = qinp(i,1)
         ENDIF

       ENDIF
      ENDDO

C---  End case increasing/decreasing pressure
      ENDIF

      RETURN
      END

#include "COST_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C !ROUTINE: COST_INIT_FIXED

C !INTERFACE:
      SUBROUTINE COST_INIT_FIXED( myThid )

C     !DESCRIPTION:
C     Initialize COST variables that are kept fixed during the run.

C     !USES:
      IMPLICIT NONE
C     == Global variables ===
#include "EEPARAMS.h"
#include "SIZE.h"
#include "cost.h"

C     !INPUT/OUTPUT PARAMETERS:
C     myThid ::  my Thread Id number
      INTEGER myThid
CEOP

C     !LOCAL VARIABLES:

C--   The first time around we want to write the cost function to a file
      costWriteCostFunction = .TRUE.

      RETURN
      END

#include "PACKAGES_CONFIG.h"
#include "CPP_OPTIONS.h"
#ifdef ALLOW_AUTODIFF
# include "AUTODIFF_OPTIONS.h"
#endif

CBOP
C     !ROUTINE: CALC_3D_DIFFUSIVITY
C     !INTERFACE:
      SUBROUTINE CALC_3D_DIFFUSIVITY(
     I        bi, bj, iMin,iMax,jMin,jMax,
     I        trIdentity, trUseGMRedi, trUseKPP,
     O        KappaRTr,
     I        myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE CALC_3D_DIFFUSIVITY
C     | o Calculate net (3D) vertical diffusivity for 1 tracer
C     *==========================================================*
C     | Combines spatially varying diffusion coefficients from
C     | KPP and/or GM and/or convective stability test.
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     == GLobal variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "DYNVARS.h"
#include "GRID.h"
#ifdef ALLOW_GENERIC_ADVDIFF
#include "GAD.h"
#endif
#ifdef ALLOW_PTRACERS
#include "PTRACERS_SIZE.h"
#include "PTRACERS_PARAMS.h"
#endif
#ifdef ALLOW_LONGSTEP
#include "LONGSTEP.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     bi, bj     :: tile indices
C     iMin,iMax  :: Range of points for which calculation is performed.
C     jMin,jMax  :: Range of points for which calculation is performed.
C     trIdentity :: tracer identifier
C     trUseGMRedi:: this tracer use GM-Redi
C     trUseKPP   :: this tracer use KPP
C     myThid     :: Instance number for this innvocation of CALC_3D_DIFFUSIVITY
C     KappaRTr   :: Net diffusivity for this tracer (trIdentity)
      INTEGER bi,bj,iMin,iMax,jMin,jMax
      INTEGER trIdentity
      LOGICAL trUseGMRedi, trUseKPP
      _RL KappaRTr(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      INTEGER myThid

#ifdef ALLOW_GENERIC_ADVDIFF
C     !LOCAL VARIABLES:
C     == Local variables ==
C     i, j, k    :: Loop counters
C     iTr        :: passive tracer index
C     msgBuf     :: message buffer
      INTEGER i,j,k
      _RL KbryanLewis79
#ifdef ALLOW_BL79_LAT_VARY
      _RL KbryanLewisEQ
#endif
      CHARACTER*(MAX_LEN_MBUF) msgBuf
#ifdef ALLOW_PTRACERS
      INTEGER iTr
#endif
#ifndef EXCLUDE_PCELL_MIX_CODE
      INTEGER km, mixSurf, mixBott
      _RL pC_kFac
      _RL tmpFac(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
#endif
CEOP

      IF ( .NOT. trUseKPP ) THEN
       DO k = 1,Nr
        KbryanLewis79=diffKrBL79surf+(diffKrBL79deep-diffKrBL79surf)
     &       *(atan(-(rF(k)-diffKrBL79Ho)/diffKrBL79scl)/PI+0.5 _d 0)
#ifdef ALLOW_BL79_LAT_VARY
        KbryanLewisEQ=diffKrBLEQsurf+(diffKrBLEQdeep-diffKrBLEQsurf)
     &       *(atan(-(rF(k)-diffKrBLEQHo)/diffKrBLEQscl)/PI+0.5 _d 0)
#endif
#ifdef ALLOW_LONGSTEP
        IF ( trIdentity .GE. GAD_TR1) THEN
         DO j = 1-OLy,sNy+OLy
          DO i = 1-OLx,sNx+OLx
           KappaRTr(i,j,k) =
     &         LS_IVDConvCount(i,j,k,bi,bj)*ivdc_kappa
     &         + KbryanLewis79
#ifdef ALLOW_BL79_LAT_VARY
     &         + (KbryanLewisEQ-KbryanLewis79)*BL79LatArray(i,j,bi,bj)
#endif
          ENDDO
         ENDDO
        ELSE
#else
        IF ( .TRUE. ) THEN
#endif /* ALLOW_LONGSTEP */
         DO j = 1-OLy,sNy+OLy
          DO i = 1-OLx,sNx+OLx
           KappaRTr(i,j,k) =
     &         IVDConvCount(i,j,k,bi,bj)*ivdc_kappa
     &         + KbryanLewis79
#ifdef ALLOW_BL79_LAT_VARY
     &         + (KbryanLewisEQ-KbryanLewis79)*BL79LatArray(i,j,bi,bj)
#endif
          ENDDO
         ENDDO
        ENDIF
       ENDDO
       IF ( trIdentity.EQ.GAD_TEMPERATURE ) THEN
        DO k = 1,Nr
         DO j = 1-OLy,sNy+OLy
          DO i = 1-OLx,sNx+OLx
           KappaRTr(i,j,k) = KappaRTr(i,j,k)
#ifdef ALLOW_3D_DIFFKR
     &          + diffKr(i,j,k,bi,bj)
#else
     &          + diffKrNrT(k)
#endif
          ENDDO
         ENDDO
        ENDDO
       ELSEIF ( trIdentity.EQ.GAD_SALINITY) THEN
        DO k = 1,Nr
         DO j = 1-OLy, sNy+OLy
          DO i = 1-OLx, sNx+OLx
           KappaRTr(i,j,k) = KappaRTr(i,j,k)
#ifdef ALLOW_3D_DIFFKR
     &          + diffKr(i,j,k,bi,bj)
#else
     &          + diffKrNrS(k)
#endif
          ENDDO
         ENDDO
        ENDDO
#ifdef ALLOW_PTRACERS
       ELSEIF ( trIdentity.GE.GAD_TR1) THEN

        iTr = trIdentity - GAD_TR1 + 1
        DO k = 1,Nr
         DO j = 1-OLy, sNy+OLy
          DO i = 1-OLx, sNx+OLx
           KappaRTr(i,j,k) = KappaRTr(i,j,k)
#ifdef ALLOW_3D_DIFFKR
     &          + diffKr(i,j,k,bi,bj)
#else
     &          + PTRACERS_diffKrNr(k,iTr)
#endif
          ENDDO
         ENDDO
        ENDDO
#endif /* ALLOW_PTRACERS */
       ELSE
        WRITE(msgBuf,'(A,I4)')
     &       ' CALC_3D_DIFFUSIVITY: Invalid tracer Id: ',trIdentity
        CALL PRINT_ERROR(msgBuf, myThid)
        STOP 'ABNORMAL END: S/R CALC_3D_DIFFUSIVITY'
       ENDIF
      ENDIF

C--   Add physical pacakge contributions:

#ifdef ALLOW_KPP
      IF (trUseKPP) THEN
C--   Set vertical diffusivity contribution from KPP
       IF (trIdentity.EQ.GAD_TEMPERATURE) THEN
         CALL KPP_CALC_DIFF_T(
     I        bi,bj,iMin,iMax,jMin,jMax,0,Nr,
     O        KappaRTr,
     I        myThid)
       ELSEIF (trIdentity.EQ.GAD_SALINITY) THEN
         CALL KPP_CALC_DIFF_S(
     I        bi,bj,iMin,iMax,jMin,jMax,0,Nr,
     O        KappaRTr,
     I        myThid)
#ifdef ALLOW_PTRACERS
       ELSEIF ( trIdentity.GE.GAD_TR1) THEN
         iTr = trIdentity - GAD_TR1 + 1
         CALL KPP_CALC_DIFF_Ptr(
     I        bi,bj,iMin,iMax,jMin,jMax,0,Nr,
     O        KappaRTr,
     I        iTr, myThid )
#endif /* ALLOW_PTRACERS */
       ELSE
        WRITE(msgBuf,'(A,I4)')
     &       ' CALC_3D_DIFFUSIVITY: Invalid tracer Id: ',trIdentity
        CALL PRINT_ERROR( msgBuf, myThid )
        STOP 'ABNORMAL END: S/R CALC_3D_DIFFUSIVITY'
       ENDIF
      ENDIF
#endif /* ALLOW_KPP */

#ifdef ALLOW_GMREDI
      IF (trUseGMRedi) THEN
         CALL GMREDI_CALC_DIFF(
     I        bi,bj,iMin,iMax,jMin,jMax,0,Nr,
     U        KappaRTr,
     I        trIdentity,myThid)
      ENDIF
#endif

#ifdef ALLOW_PP81
      IF (usePP81) THEN
         CALL PP81_CALC_DIFF(
     I        bi,bj,iMin,iMax,jMin,jMax,0,Nr,
     U        KappaRTr,
     I        myThid)
      ENDIF
#endif

#ifdef ALLOW_KL10
      IF (useKL10) THEN
         CALL KL10_CALC_DIFF(
     I        bi,bj,iMin,iMax,jMin,jMax,0,Nr,
     U        KappaRTr,
     I        myThid)
      ENDIF
#endif

#ifdef ALLOW_MY82
      IF (useMY82) THEN
         CALL MY82_CALC_DIFF(
     I        bi,bj,iMin,iMax,jMin,jMax,0,Nr,
     U        KappaRTr,
     I        myThid)
      ENDIF
#endif

#ifdef ALLOW_GGL90
      IF (useGGL90) THEN
         CALL GGL90_CALC_DIFF(
     I        bi,bj,iMin,iMax,jMin,jMax,0,Nr,
     O        KappaRTr,
     I        myThid)
      ENDIF
#endif

#ifdef ALLOW_SMAG_3D_DIFFUSIVITY
       IF ( smag3D_diffCoeff.GT.zeroRL ) THEN
        DO k = 2,Nr
         DO j = 1-OLy,sNy+OLy
          DO i = 1-OLx,sNx+OLx
           KappaRTr(i,j,k) = KappaRTr(i,j,k)
     &          + halfRL*( smag3D_diffK(i,j,k-1,bi,bj)
     &                   + smag3D_diffK(i,j, k, bi,bj) )
          ENDDO
         ENDDO
        ENDDO
       ENDIF
#endif /* ALLOW_SMAG_3D_DIFFUSIVITY */

#ifndef EXCLUDE_PCELL_MIX_CODE
# ifdef ALLOW_AUTODIFF_TAMC
CADJ INIT loctape_3d_diff = COMMON, Nr
CADJ STORE kappartr = loctape_3d_diff
# endif
      IF ( interDiffKr_pCell ) THEN
C--   This is a hack: alter vertical diffusivity (instead of changing many S/R)
C     in order to account for missing hFac in diffusion term
       DO k = 2,Nr
         km = k - 1
C-    account for true distance (including hFac) in vertical gradient
         DO j = 2-OLy, sNy+OLy
          DO i = 2-OLx, sNx+OLx
           IF ( k.GT.kSurfC(i,j,bi,bj) .AND.
     &          k.LE.kLowC(i,j,bi,bj) ) THEN
             KappaRTr(i,j,k) = KappaRTr(i,j,k)
     &                *twoRL/(hFacC(i,j,km,bi,bj)+hFacC(i,j,k,bi,bj))
           ENDIF
          ENDDO
         ENDDO
       ENDDO
      ENDIF

      IF ( pCellMix_select.GT.0 ) THEN
C--   This is a hack: alter vertical diffusivity (instead of changing many S/R)
C     in order to to increase mixing for too thin surface/bottom partial cell
       mixSurf = pCellMix_select/10
       mixBott = MOD(pCellMix_select,10)
       DO k = 2,Nr
         km = k - 1
         pC_kFac = 1.
         IF ( pCellMix_delR.LT.drF(k) )
     &     pC_kFac = pCellMix_delR*recip_drF(k)

# ifdef ALLOW_AUTODIFF
         DO j = 1-OLy, sNy+OLy
          DO i = 1-OLx, sNx+OLx
           tmpFac(i,j) = 0. _d 0
          ENDDO
         ENDDO
# endif

C-    Increase KappaRTr above bottom level:
         IF ( mixBott.GE.1 ) THEN
          DO j = 2-OLy, sNy+OLy
           DO i = 2-OLx, sNx+OLx
             tmpFac(i,j) = 0. _d 0
             IF ( k.EQ.kLowC(i,j,bi,bj) .AND.
     &            k.GT.kSurfC(i,j,bi,bj) ) THEN
               tmpFac(i,j) = pC_kFac*_recip_hFacC(i,j,k,bi,bj)
             ENDIF
           ENDDO
          ENDDO
# ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE tmpFac          = loctape_3d_diff, key = k
# endif
          IF ( mixBott.EQ.2 ) THEN
           DO j = 2-OLy, sNy+OLy
            DO i = 2-OLx, sNx+OLx
             tmpFac(i,j) = tmpFac(i,j)*tmpFac(i,j)
            ENDDO
           ENDDO
          ELSEIF ( mixBott.EQ.3 ) THEN
           DO j = 2-OLy, sNy+OLy
            DO i = 2-OLx, sNx+OLx
             tmpFac(i,j) = tmpFac(i,j)*tmpFac(i,j)*tmpFac(i,j)
            ENDDO
           ENDDO
          ELSEIF ( mixBott.EQ.4 ) THEN
           DO j = 2-OLy, sNy+OLy
            DO i = 2-OLx, sNx+OLx
             tmpFac(i,j) = tmpFac(i,j)*tmpFac(i,j)
     &                   * tmpFac(i,j)*tmpFac(i,j)
            ENDDO
           ENDDO
          ENDIF
C-    increase mixing above bottom (by ~(1/hFac)^mixBott) if too thin p-cell
          DO j = 2-OLy, sNy+OLy
           DO i = 2-OLx, sNx+OLx
             tmpFac(i,j) = MIN( tmpFac(i,j), pCellMix_maxFac )
# ifdef ALLOW_AUTODIFF_TAMC
           ENDDO
          ENDDO
CADJ STORE tmpFac          = loctape_3d_diff, key = k
CADJ STORE kappartr(:,:,k) = loctape_3d_diff, key = k
          DO j = 2-OLy, sNy+OLy
           DO i = 2-OLx, sNx+OLx
# endif
             KappaRTr(i,j,k) = MAX( KappaRTr(i,j,k),
     &                              pCellMix_diffKr(k)*tmpFac(i,j) )
           ENDDO
          ENDDO
         ENDIF

         pC_kFac = 1.
         IF ( pCellMix_delR.LT.drF(km) )
     &     pC_kFac = pCellMix_delR*recip_drF(km)

C-    Increase KappaRTr below surface level:
         IF ( mixSurf.GE.1 ) THEN
          DO j = 2-OLy, sNy+OLy
           DO i = 2-OLx, sNx+OLx
             tmpFac(i,j) = 0. _d 0
             IF ( km.EQ.kSurfC(i,j,bi,bj) .AND.
     &            km.LT.kLowC(i,j,bi,bj) ) THEN
               tmpFac(i,j) = pC_kFac*_recip_hFacC(i,j,km,bi,bj)
             ENDIF
           ENDDO
          ENDDO
# ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE tmpFac          = loctape_3d_diff, key = k
# endif
          IF ( mixSurf.EQ.2 ) THEN
           DO j = 2-OLy, sNy+OLy
            DO i = 2-OLx, sNx+OLx
             tmpFac(i,j) = tmpFac(i,j)*tmpFac(i,j)
            ENDDO
           ENDDO
          ELSEIF ( mixSurf.EQ.3 ) THEN
           DO j = 2-OLy, sNy+OLy
            DO i = 2-OLx, sNx+OLx
             tmpFac(i,j) = tmpFac(i,j)*tmpFac(i,j)*tmpFac(i,j)
            ENDDO
           ENDDO
          ELSEIF ( mixSurf.EQ.4 ) THEN
           DO j = 2-OLy, sNy+OLy
            DO i = 2-OLx, sNx+OLx
             tmpFac(i,j) = tmpFac(i,j)*tmpFac(i,j)
     &                   * tmpFac(i,j)*tmpFac(i,j)
            ENDDO
           ENDDO
          ENDIF
C-    increase mixing below surface (by ~(1/hFac)^mixSurf) if too thin p-cell
          DO j = 2-OLy, sNy+OLy
           DO i = 2-OLx, sNx+OLx
             tmpFac(i,j) = MIN( tmpFac(i,j), pCellMix_maxFac )
# ifdef ALLOW_AUTODIFF_TAMC
           ENDDO
          ENDDO
CADJ STORE tmpFac          = loctape_3d_diff, key = k
CADJ STORE kappartr(:,:,k) = loctape_3d_diff, key = k
          DO j = 2-OLy, sNy+OLy
           DO i = 2-OLx, sNx+OLx
# endif
             KappaRTr(i,j,k) = MAX( KappaRTr(i,j,k),
     &                              pCellMix_diffKr(k)*tmpFac(i,j) )
           ENDDO
          ENDDO
         ENDIF

C--   end of k loop
       ENDDO
      ENDIF
#endif /* ndef EXCLUDE_PCELL_MIX_CODE */

C-    Apply mask to vertical diffusivity
C jmc: do not have the impression that masking is needed
C      but could be removed later if it is the case.
c     DO j = 1-OLy, sNy+OLy
c      DO i = 1-OLx, sNx+OLx
c       KappaRTr(i,j,k) = maskUp(i,j)*KappaRTr(i,j,k)
c      ENDDO
c     ENDDO

#endif /* ALLOW_GENERIC_ADVDIFF */

      RETURN
      END

#include "RBCS_OPTIONS.h"

CBOP
C !ROUTINE: RBCS_READPARMS

C !INTERFACE: ==========================================================
      SUBROUTINE RBCS_READPARMS( myThid )

C !DESCRIPTION:
C     Initialize RBCS parameters, read in data.rbcs

C !USES: ===============================================================
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#ifdef ALLOW_PTRACERS
#include "PTRACERS_SIZE.h"
#endif
#include "RBCS_SIZE.h"
#include "RBCS_PARAMS.h"

C !INPUT PARAMETERS: ===================================================
C  myThid         :: my thread Id. number
      INTEGER myThid

C !OUTPUT PARAMETERS: ==================================================
C  none

#ifdef ALLOW_RBCS

C     === Local variables ===
C     msgBuf      :: Informational/error message buffer
C     iUnit       :: Work variable for IO unit number
C     iTracer     :: passive tracer index
C     relaxMaskFile :: local mask-file name to read from namelist
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      INTEGER iUnit
      INTEGER irbc, errCount
      INTEGER locSize
#ifdef ALLOW_PTRACERS
      INTEGER iTracer
      PARAMETER( locSize = 10+PTRACERS_num )
#else
      PARAMETER( locSize = 4 )
#endif
      CHARACTER*(MAX_LEN_FNAM) relaxMaskFile(locSize)
C--   useRBCptracers is no longer used
      LOGICAL useRBCptracers
      INTEGER rbcsIniter
CEOP

C--   RBCS parameters:
      NAMELIST /RBCS_PARM01/
     &          tauRelaxU,
     &          tauRelaxV,
     &          tauRelaxT,
     &          tauRelaxS,
     &          relaxMaskUFile,
     &          relaxMaskVFile,
     &          relaxMaskFile,
     &          relaxUFile,
     &          relaxVFile,
     &          relaxTFile,
     &          relaxSFile,
     &          useRBCuVel,
     &          useRBCvVel,
     &          useRBCtemp,
     &          useRBCsalt,
     &          useRBCptracers,
     &          rbcsIniter,
     &          rbcsForcingPeriod,
     &          rbcsForcingCycle,
     &          rbcsForcingOffset,
     &          rbcsVanishingTime,
     &          rbcsSingleTimeFiles,
     &          deltaTrbcs,
     &          rbcsIter0

#ifdef ALLOW_PTRACERS
      NAMELIST /RBCS_PARM02/
     &          useRBCpTrNum, tauRelaxPTR,
     &          relaxPtracerFile
#endif

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      IF ( .NOT.useRBCS ) THEN
C-    pkg RBCS is not used
        _BEGIN_MASTER(myThid)
C-    Track pkg activation status:
C     print a (weak) warning if data.rbcs is found
         CALL PACKAGES_UNUSED_MSG( 'useRBCS', ' ', ' ' )
        _END_MASTER(myThid)
        RETURN
      ENDIF

      _BEGIN_MASTER(myThid)

C--   Default values
      useRBCuVel =.FALSE.
      useRBCvVel =.FALSE.
      useRBCtemp =.FALSE.
      useRBCsalt =.FALSE.
      tauRelaxU = 0.
      tauRelaxV = 0.
      tauRelaxT = 0.
      tauRelaxS = 0.
      relaxMaskUFile = ' '
      relaxMaskVFile = ' '
      DO irbc=1,locSize
        relaxMaskFile(irbc) = ' '
      ENDDO
      relaxUFile = ' '
      relaxVFile = ' '
      relaxTFile = ' '
      relaxSFile = ' '
      rbcsIniter = 0
      rbcsForcingPeriod = 0. _d 0
      rbcsForcingCycle  = 0. _d 0
      rbcsForcingOffset = 0. _d 0
      rbcsVanishingTime = 0. _d 0
      rbcsSingleTimeFiles = .FALSE.
      deltaTrbcs = deltaTClock
      rbcsIter0 = 0
#ifdef ALLOW_PTRACERS
      DO iTracer=1,PTRACERS_num
        useRBCpTrNum(iTracer)=.FALSE.
        tauRelaxPTR(iTracer) = 0.
        relaxPtracerFile(iTracer) = ' '
      ENDDO
#endif
      useRBCptracers=.FALSE.

C--   Open and read the data.rbcs file

      WRITE(msgBuf,'(A)') ' RBCS_READPARMS: opening data.rbcs'
      CALL PRINT_MESSAGE(msgBuf, standardMessageUnit,
     &                   SQUEEZE_RIGHT , 1)
      CALL OPEN_COPY_DATA_FILE(
     I                   'data.rbcs', 'RBCS_READPARMS',
     O                   iUnit,
     I                   myThid )
      READ(UNIT=iUnit,NML=RBCS_PARM01)
#ifdef ALLOW_PTRACERS
      READ(UNIT=iUnit,NML=RBCS_PARM02)
#endif
      WRITE(msgBuf,'(A)')
     &  ' RBCS_READPARMS: finished reading data.rbcs'
      CALL PRINT_MESSAGE(msgBuf, standardMessageUnit,
     &                   SQUEEZE_RIGHT , 1)

C--   Close the open data file
#ifdef SINGLE_DISK_IO
      CLOSE(iUnit)
#else
      CLOSE(iUnit,STATUS='DELETE')
#endif /* SINGLE_DISK_IO */

C-    save local mask-file name into relaxMaskTrFile (stored in common block)
      DO irbc=1,maskLEN
        relaxMaskTrFile(irbc) = ' '
      ENDDO
      errCount = 0
      DO irbc=1,locSize
        IF ( irbc.LE.maskLEN ) THEN
          relaxMaskTrFile(irbc) = relaxMaskFile(irbc)
        ELSEIF ( relaxMaskFile(irbc).NE.' ' ) THEN
          errCount = errCount + 1
        ENDIF
      ENDDO
      IF ( errCount.GT.0 ) THEN
        WRITE(msgBuf,'(2A,I6)') 'RBCS_READPARMS: ',
     &   'Too many "relaxMaskFile" are set ! exceeds maskLEN=', maskLEN
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(2A)') 'RBCS_READPARMS: ',
     &   '==> Increase maskLEN (in RBCS_SIZE.h) and recompile'
        CALL PRINT_ERROR( msgBuf, myThid )
      ENDIF

C---  Check RBCS config and params:
#ifdef DISABLE_RBCS_MOM
      IF ( useRBCuVel .OR. useRBCvVel ) THEN
        WRITE(msgBuf,'(2A,2(L2,A))') 'RBCS_READPARMS: ',
     &    'cannot use RBC for U,V (useRBCuVel=',useRBCuVel,
     &    ', useRBCvVel=',useRBCvVel,')'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(2A)') 'RBCS_READPARMS: ',
     &    'when DISABLE_RBCS_MOM is defined (in RBCS_OPTIONS.h)'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF
#endif /* DISABLE_RBCS_MOM */
      IF (rbcsIniter.NE.0) THEN
        WRITE(msgBuf,'(2A)') 'RBCS_READPARMS: ',
     &  'rbcsIniter has been replaced by rbcsForcingOffset '
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(2A)') 'RBCS_READPARMS: ',
     &  'which is in seconds. Please change your data.rbcs'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ELSEIF (startTime.LT.rbcsForcingOffset+0.5*rbcsForcingPeriod .AND.
     &    .NOT. rbcsSingleTimeFiles) THEN
       IF (rbcsForcingCycle.GT.0.) THEN
        WRITE(msgBuf,'(2A)') '** WARNING ** RBCS_READPARMS: ',
     &  'startTime before rbcsForcingOffset+0.5*rbcsForcingPeriod '
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
        WRITE(msgBuf,'(2A)') '** WARNING ** RBCS_READPARMS: ',
     &  'will use last record'
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
       ELSE
        WRITE(msgBuf,'(2A)') 'RBCS_READPARMS: ',
     &  'startTime before rbcsForcingOffset+0.5*rbcsForcingPeriod '
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(2A)') 'RBCS_READPARMS: ',
     &  'not allowed with rbcsForcingCycle=0 unless rbcsSingleTimeFiles'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
       ENDIF
      ENDIF
      IF ( useRBCuVel .AND. tauRelaxU.LE.0. ) THEN
        WRITE(msgBuf,'(2A)') 'RBCS_READPARMS: ',
     &    'tauRelaxU cannot be zero with useRBCuVel'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF
      IF ( useRBCvVel .AND. tauRelaxV.LE.0. ) THEN
        WRITE(msgBuf,'(2A)') 'RBCS_READPARMS: ',
     &    'tauRelaxV cannot be zero with useRBCvVel'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF
      IF ( useRBCtemp .AND. tauRelaxT.LE.0. ) THEN
        WRITE(msgBuf,'(2A)') 'RBCS_READPARMS: ',
     &    'tauRelaxT cannot be zero with useRBCtemp'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF
      IF ( useRBCsalt .AND. tauRelaxS.LE.0. ) THEN
        WRITE(msgBuf,'(2A)') 'RBCS_READPARMS: ',
     &    'tauRelaxS cannot be zero with useRBCsalt'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF
#ifdef ALLOW_PTRACERS
      DO iTracer=1,PTRACERS_num
       IF ( useRBCpTrNum(iTracer) ) THEN
        IF ( .NOT.usePTRACERS ) THEN
         WRITE(msgBuf,'(2A,I6,A)') 'RBCS_READPARMS: ',
     &   'usePTRACERS=F => cannot use RBCS for tracer:', iTracer
         CALL PRINT_ERROR( msgBuf, myThid )
         errCount = errCount + 1
        ENDIF
c       IF ( iTracer.GT.PTRACERS_numInUse ) THEN
c        STOP 'ABNORMAL END: S/R RBCS_READPARMS'
c       ENDIF
        IF ( tauRelaxPTR(iTracer).LE.0. ) THEN
         WRITE(msgBuf,'(2A,I6,A)') 'RBCS_READPARMS: ',
     &     'tauRelaxPTR(itr=', iTracer, ' ) = 0. is'
         CALL PRINT_ERROR( msgBuf, myThid )
         WRITE(msgBuf,'(2A,I6,A)') 'RBCS_READPARMS: ',
     &     'not allowed with useRBCptr(itr)=T'
         CALL PRINT_ERROR( msgBuf, myThid )
         errCount = errCount + 1
        ENDIF
       ENDIF
      ENDDO
#endif
      IF ( errCount.GT.0 ) THEN
       WRITE(msgBuf,'(A,I3,A)')
     &       'RBCS_READPARMS: detected', errCount,' fatal error(s)'
       CALL PRINT_ERROR( msgBuf, myThid )
       CALL ALL_PROC_DIE( 0 )
       STOP 'ABNORMAL END: S/R RBCS_READPARMS'
      ENDIF
      _END_MASTER(myThid)

C Everyone else must wait for the parameters to be loaded
      _BARRIER

#endif /* ALLOW_RBCS */

      RETURN
      END

#include "OBCS_OPTIONS.h"

CBOP
C     !ROUTINE: OBCS_CHECK
C     !INTERFACE:
      SUBROUTINE OBCS_CHECK( myThid )

C     !DESCRIPTION:
C     *==========================================================*
C     | SUBROUTINE OBCS_CHECK
C     | o Check OBC parameters and set-up
C     *==========================================================*

C     !USES:
      IMPLICIT NONE
C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "OBCS_PARAMS.h"
#include "OBCS_GRID.h"
#include "OBCS_SEAICE.h"
#ifdef ALLOW_PTRACERS
# include "PTRACERS_SIZE.h"
# include "PTRACERS_PARAMS.h"
# include "OBCS_PTRACERS.h"
#endif /* ALLOW_PTRACERS */

C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
C     myThid   :: My thread Id number
      INTEGER myThid
CEOP

#ifdef ALLOW_OBCS

C     !FUNCTIONS:
      INTEGER  ILNBLNK
      EXTERNAL ILNBLNK

C     !LOCAL VARIABLES:
C     msgBuf  :: Informational/error message buffer
C     bi,bj   :: tile indices
C     i, j    :: Loop counters
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      INTEGER bi, bj
      INTEGER i, j
      INTEGER ln
      INTEGER ioUnit
      INTEGER errCount
#ifdef ALLOW_OBCS_BALANCE
C     number of tiles with open boundaries
      INTEGER nTileWithActiveOB
#endif

      ioUnit = standardMessageUnit

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C--   Print OBCS set-up summary:

      _BEGIN_MASTER(myThid)

      WRITE(msgBuf,'(A)') 'OBCS_CHECK: #define ALLOW_OBCS'
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )

#ifdef ALLOW_OBCS_BALANCE
      IF ( OBCSbalanceSurf .AND. .NOT. useRealFreshWaterFlux ) THEN
        WRITE(msgBuf,'(2A)') '** WARNING ** OBCS_CHECK: ',
     &       'OBCSbalanceSurf requires useRealFreshWaterFlux=T'
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
        WRITE(msgBuf,'(2A)') '** WARNING ** OBCS_CHECK: ',
     &       'resetting OBCSbalanceSurf to False'
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
        OBCSbalanceSurf = .FALSE.
      ENDIF
#endif /* ALLOW_OBCS_BALANCE */

      WRITE(msgBuf,'(A)')
     &'// ======================================================='
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)') '// OBCS_CHECK: OBCS configuration summary'
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)')
     &'// ======================================================='
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)') ' '
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
C
      CALL WRITE_0D_L( useOBCSprescribe, INDEX_NONE,
     &   'useOBCSprescribe =', ' /* prescribe OB values */')
      CALL WRITE_0D_L( useOBCSbalance, INDEX_NONE,
     &   'useOBCSbalance =', ' /* balance the flow through OB */')
      IF ( useOBCSbalance ) THEN
        CALL WRITE_0D_L( OBCSbalanceSurf, INDEX_NONE,
     &   'OBCSbalanceSurf =', ' /* include surf. flux in balance */')
        CALL WRITE_0D_RL( OBCS_balanceFacN, INDEX_NONE,
     &   'OBCS_balanceFacN =',
     &   ' /* Northern OB Factor for balancing OB flow [-] */')
        CALL WRITE_0D_RL( OBCS_balanceFacS, INDEX_NONE,
     &   'OBCS_balanceFacS =',
     &   ' /* Southern OB Factor for balancing OB flow [-] */')
        CALL WRITE_0D_RL( OBCS_balanceFacE, INDEX_NONE,
     &   'OBCS_balanceFacE =',
     &   ' /* Eastern  OB Factor for balancing OB flow [-] */')
        CALL WRITE_0D_RL( OBCS_balanceFacW, INDEX_NONE,
     &   'OBCS_balanceFacW =',
     &   ' /* Western  OB Factor for balancing OB flow [-] */')
      ENDIF
C
      CALL WRITE_0D_L( OBCSfixTopo,   INDEX_NONE,
     & 'OBCSfixTopo =',
     & '  /* mod. topo to have zero gradient across boundaries. */')
      CALL WRITE_0D_RL( OBCS_uvApplyFac, INDEX_NONE,
     &   'OBCS_uvApplyFac =',
     &   ' /* Factor to apply to U,V 2nd column/row */')
      CALL WRITE_0D_I( OBCS_u1_adv_T, INDEX_NONE,
     &   'OBCS_u1_adv_T =', ' /* Temp uses upwind adv-scheme @ OB */')
      CALL WRITE_0D_I( OBCS_u1_adv_S, INDEX_NONE,
     &   'OBCS_u1_adv_S =', ' /* Salt uses upwind adv-scheme @ OB */')
#ifdef ALLOW_PTRACERS
      IF ( usePTRACERS ) THEN
       CALL WRITE_1D_I( OBCS_u1_adv_Tr, PTRACERS_numInUse, INDEX_NONE,
     &   'OBCS_u1_adv_Tr =', ' /* pTr uses upwind adv-scheme @ OB */')
      ENDIF
#endif /* ALLOW_PTRACERS */
      CALL WRITE_0D_RL( OBCS_monitorFreq, INDEX_NONE,
     &   'OBCS_monitorFreq =', ' /* monitor output frequency [s] */')
      CALL WRITE_0D_I( OBCS_monSelect, INDEX_NONE, 'OBCS_monSelect =',
     &                  ' /* select group of variables to monitor */')
      CALL WRITE_0D_L( OBCSprintDiags,   INDEX_NONE,
     &   'OBCSprintDiags =', '  /* print some OBCS diagnostics. */')
C
      CALL WRITE_0D_L( useOBCStides, INDEX_NONE,
     &   'useOBCStides =', ' /* apply tidal forcing through OB */')
      IF ( useOBCStides ) THEN
       CALL WRITE_0D_I( OBCS_nTidalComp, INDEX_NONE,
     &   'OBCS_nTidalComp =', ' /* number of tidal-Comp to use */')
       CALL WRITE_1D_RL( OBCS_tidalPeriod, OBCS_tideCompSize, INDEX_K,
     &   'OBCS_tidalPeriod = ', ' /* (s) */')
      ENDIF
C
      CALL WRITE_0D_L( useOrlanskiNorth,   INDEX_NONE,
     & 'useOrlanskiNorth =', '  /* use Orlanski for northern bound. */')
      CALL WRITE_0D_L( useOrlanskiSouth,   INDEX_NONE,
     & 'useOrlanskiSouth =', '  /* use Orlanski for southern bound. */')
      CALL WRITE_0D_L( useOrlanskiEast,    INDEX_NONE,
     & 'useOrlanskiEast  =', '  /* use Orlanski for eastern bound. */')
      CALL WRITE_0D_L( useOrlanskiWest,    INDEX_NONE,
     & 'useOrlanskiWest  =', '  /* use Orlanski for western bound. */')
C
      CALL WRITE_0D_L( useStevensNorth,   INDEX_NONE,
     & 'useStevensNorth =', '  /* use Stevens for northern bound. */')
      CALL WRITE_0D_L( useStevensSouth,   INDEX_NONE,
     & 'useStevensSouth =', '  /* use Stevens for southern bound. */')
      CALL WRITE_0D_L( useStevensEast,    INDEX_NONE,
     & 'useStevensEast  =', '  /* use Stevens for eastern bound. */')
      CALL WRITE_0D_L( useStevensWest,    INDEX_NONE,
     & 'useStevensWest  =', '  /* use Stevens for western bound. */')
      CALL WRITE_0D_L( useStevensPhaseVel,    INDEX_NONE,
     & 'useStevensPhaseVel  =', '  /* include phase vel. term. */')
      CALL WRITE_0D_L( useStevensAdvection,    INDEX_NONE,
     & 'useStevensAdvection  =', '  /* include advection term. */')
      CALL WRITE_0D_RS( TrelaxStevens, INDEX_NONE,
     & 'TrelaxStevens =',
     & ' /* relaxation time scale for theta ( s ). */')
      CALL WRITE_0D_RS( SrelaxStevens, INDEX_NONE,
     & 'SrelaxStevens =',
     & ' /* relaxation time scale for salinity ( s ). */')
C
      CALL WRITE_0D_L( useOBCSsponge,   INDEX_NONE,
     & 'useOBCSSponge =', '  /* use sponge along boundaries */')
      IF ( useOBCSSponge ) THEN
       CALL WRITE_0D_L( OBCSsponge_N,   INDEX_NONE,
     & 'OBCSSponge_N =', '  /* use sponge for northern boundary */')
       CALL WRITE_0D_L( OBCSsponge_S,   INDEX_NONE,
     & 'OBCSSponge_S =', '  /* use sponge for southern boundary */')
       CALL WRITE_0D_L( OBCSsponge_E,    INDEX_NONE,
     & 'OBCSSponge_E =', '  /* use sponge for eastern boundary */')
       CALL WRITE_0D_L( OBCSsponge_W,    INDEX_NONE,
     & 'OBCSSponge_W =', '  /* use sponge for western boundary */')
       CALL WRITE_0D_L( OBCSsponge_UatNS,   INDEX_NONE,
     & 'OBCSSponge_UatNS =', '  /* use u-vel. sponge at N/S bound. */')
       CALL WRITE_0D_L( OBCSsponge_UatEW,   INDEX_NONE,
     & 'OBCSSponge_UatEW =', '  /* use u-vel. sponge at E/W bound. */')
       CALL WRITE_0D_L( OBCSsponge_VatNS,   INDEX_NONE,
     & 'OBCSSponge_VatNS =', '  /* use v-vel. sponge at N/S bound. */')
       CALL WRITE_0D_L( OBCSsponge_UatEW,   INDEX_NONE,
     & 'OBCSSponge_VatEW =', '  /* use v-vel. sponge at E/W bound. */')
       CALL WRITE_0D_L( OBCSsponge_Theta,   INDEX_NONE,
     & 'OBCSSponge_Theta =', '  /* use sponge for Theta. */')
       CALL WRITE_0D_L( OBCSsponge_Salt,   INDEX_NONE,
     & 'OBCSSponge_Salt =', '  /* use sponge for salinity. */')
       CALL WRITE_0D_L( useLinearSponge,   INDEX_NONE,
     & 'useLinearSponge =', '  /* use linear sponge. */')
       CALL WRITE_0D_I( spongeThickness, INDEX_NONE,
     & 'spongeThickness =',
     & ' /* number grid points in sponge */')
       CALL WRITE_0D_RS( Urelaxobcsinner, INDEX_NONE,
     &  'Urelaxobcsinner =',
     & ' /* innermost relaxation time scale, u-velocity ( s ). */')
       CALL WRITE_0D_RS( Urelaxobcsbound, INDEX_NONE,
     &  'Urelaxobcsbound =',
     & ' /* boudnary relaxation time scale, u-velocity ( s ). */')
       CALL WRITE_0D_RS( Vrelaxobcsinner, INDEX_NONE,
     &  'Vrelaxobcsinner =',
     & ' /* innermost relaxation time scale, v-velocity ( s ). */')
       CALL WRITE_0D_RS( Vrelaxobcsbound, INDEX_NONE,
     &  'Vrelaxobcsbound =',
     & ' /* boundary relaxation time scale, v-velocity ( s ). */')
      ENDIF
      CALL WRITE_0D_L( useSeaiceSponge, INDEX_NONE,
     & 'useSeaiceSponge =', '  /* use sponge for sea ice variables */')
      CALL WRITE_0D_L( useSeaiceNeumann, INDEX_NONE,
     & 'useSeaiceNeumann =',
     & '  /* use Neumann conditions for sea ice variables */')
C
      ln = ILNBLNK(insideOBmaskFile)
      IF ( ln.GT.0 ) THEN
        CALL WRITE_0D_C( insideOBmaskFile, ln, INDEX_NONE,
     &   'insideOBmaskFile =',
     &   ' /* used to specify Inside OB region mask */')
      ENDIF
      CALL WRITE_0D_I( OB_indexNone, INDEX_NONE, 'OB_indexNone =',
     &                 ' /* null value for OB index (i.e. no OB) */')

      IF ( debugLevel.GE.debLevA ) THEN
       DO bj = 1,nSy
        DO bi = 1,nSx
         WRITE(msgBuf,'(A,2(I4,A))')
     &     '======== Tile bi=', bi, ' , bj=', bj, ' ========'
         CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
         WRITE(msgBuf,'(A)') ' OB_Jn = /* Northern OB local indices */'
         CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
         CALL PRINT_LIST_I( OB_Jn(1-OLx,bi,bj), 1-OLx, sNx+OLx, INDEX_I,
     &                     .FALSE., .TRUE., ioUnit )
         WRITE(msgBuf,'(A)') ' OB_Js = /* Southern OB local indices */'
         CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
         CALL PRINT_LIST_I( OB_Js(1-OLx,bi,bj), 1-OLx, sNx+OLx, INDEX_I,
     &                     .FALSE., .TRUE., ioUnit )
         WRITE(msgBuf,'(A)') ' OB_Ie = /* Eastern OB local indices */'
         CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
         CALL PRINT_LIST_I( OB_Ie(1-OLy,bi,bj), 1-OLy, sNy+OLy, INDEX_J,
     &                     .FALSE., .TRUE., ioUnit )
         WRITE(msgBuf,'(A)') ' OB_Iw = /* Western OB local indices */'
         CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
         CALL PRINT_LIST_I( OB_Iw(1-OLy,bi,bj), 1-OLy, sNy+OLy, INDEX_J,
     &                     .FALSE., .TRUE., ioUnit )
        ENDDO
       ENDDO
      ENDIF

      WRITE(msgBuf,'(A)')
     &'// ======================================================='
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)') '// End of OBCS config. summary'
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)')
     &'// ======================================================='
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)') ' '
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )

      _END_MASTER(myThid)

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C--   Check OBCS set-up

C-    Check each tile set-up
      errCount = 0
      _BEGIN_MASTER( myThid )
      DO bj = 1,nSy
       DO bi = 1,nSx
#ifndef ALLOW_OBCS_NORTH
         IF ( tileHasOBN(bi,bj) ) THEN
           WRITE(msgBuf,'(A)')
     &      'OBCS_CHECK: #undef ALLOW_OBCS_NORTH and'
           CALL PRINT_ERROR( msgBuf, myThid )
           WRITE(msgBuf,'(A,2I4,A)')
     &      'OBCS_CHECK: tile bi,bj=',bi,bj, ' has Northern OB'
           CALL PRINT_ERROR( msgBuf, myThid )
           errCount = errCount + 1
         ENDIF
#endif
#ifndef ALLOW_OBCS_SOUTH
         IF ( tileHasOBS(bi,bj) ) THEN
           WRITE(msgBuf,'(A)')
     &      'OBCS_CHECK: #undef ALLOW_OBCS_SOUTH and'
           CALL PRINT_ERROR( msgBuf, myThid )
           WRITE(msgBuf,'(A,2I4,A)')
     &      'OBCS_CHECK: tile bi,bj=',bi,bj, ' has Southern OB'
           CALL PRINT_ERROR( msgBuf, myThid )
           errCount = errCount + 1
         ENDIF
#endif
#ifndef ALLOW_OBCS_EAST
         IF ( tileHasOBE(bi,bj) ) THEN
           WRITE(msgBuf,'(A)')
     &      'OBCS_CHECK: #undef ALLOW_OBCS_EAST and'
           CALL PRINT_ERROR( msgBuf, myThid )
           WRITE(msgBuf,'(A,2I4,A)')
     &      'OBCS_CHECK: tile bi,bj=',bi,bj, ' has Eastern OB'
           CALL PRINT_ERROR( msgBuf, myThid )
           errCount = errCount + 1
         ENDIF
#endif
#ifndef ALLOW_OBCS_WEST
         IF ( tileHasOBW(bi,bj) ) THEN
           WRITE(msgBuf,'(A)')
     &      'OBCS_CHECK: #undef ALLOW_OBCS_WEST and'
           CALL PRINT_ERROR( msgBuf, myThid )
           WRITE(msgBuf,'(A,2I4,A)')
     &      'OBCS_CHECK: tile bi,bj=',bi,bj, ' has Western OB'
           CALL PRINT_ERROR( msgBuf, myThid )
           errCount = errCount + 1
         ENDIF
#endif
       ENDDO
      ENDDO
      _END_MASTER(myThid)
      CALL GLOBAL_SUM_INT( errCount, myThid )
      IF ( errCount.GE.1 ) THEN
        WRITE(msgBuf,'(A,I6,A)')
     &       'OBCS_CHECK:', errCount,' errors in tile OB set-up'
        CALL PRINT_ERROR( msgBuf, myThid )
        CALL ALL_PROC_DIE( myThid )
        STOP 'ABNORMAL END: S/R OBCS_CHECK'
      ENDIF

#ifdef ALLOW_OBCS_BALANCE
      IF ( OBCSbalanceSurf ) THEN
C     check if there is any open boundary to balance the flow with
        nTileWithActiveOB  = 0
        DO bj = myByLo(myThid), myByHi(myThid)
         DO bi = myBxLo(myThid), myBxHi(myThid)
C     Eastern boundary
          IF ( tileHasOBE(bi,bj) .AND. OBCS_balanceFacE .GT. 0. _d 0 )
     &         nTileWithActiveOB = nTileWithActiveOB + 1
C     Western boundary
          IF ( tileHasOBW(bi,bj) .AND. OBCS_balanceFacW .GT. 0. _d 0 )
     &         nTileWithActiveOB = nTileWithActiveOB + 1
C     Northern boundary
          IF ( tileHasOBN(bi,bj) .AND. OBCS_balanceFacN .GT. 0. _d 0 )
     &         nTileWithActiveOB = nTileWithActiveOB + 1
C     Southern boundary
          IF ( tileHasOBS(bi,bj) .AND. OBCS_balanceFacS .GT. 0. _d 0 )
     &         nTileWithActiveOB = nTileWithActiveOB + 1
         ENDDO
        ENDDO
        CALL GLOBAL_SUM_INT( nTileWithActiveOB, myThid )
      ENDIF
#endif /* ALLOW_OBCS_BALANCE */

C----------------------------------
C-    Check options and parameters
      _BEGIN_MASTER( myThid )
      errCount = 0

#ifdef ALLOW_CD_CODE
      IF ( useCDscheme ) THEN
        WRITE(msgBuf,'(2A)') 'OBCS_CHECK: ',
     &      'OBCS not yet implemented in CD-Scheme (useCDscheme=T)'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF
#endif /* ALLOW_CD_CODE */

#ifdef ALLOW_ORLANSKI
      WRITE(msgBuf,'(A)') 'OBCS_CHECK: #define ALLOW_ORLANSKI'
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
#else
      IF (useOrlanskiNorth.OR.useOrlanskiSouth.OR.
     &    useOrlanskiEast.OR.useOrlanskiWest) THEN
        WRITE(msgBuf,'(A)')
     &  'OBCS_CHECK: #undef ALLOW_ORLANSKI  and'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(A)')
     &  'OBCS_CHECK: one of useOrlanski* logicals is true'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF
#endif /* ALLOW_ORLANSKI */

      IF (useOrlanskiNorth.OR.useOrlanskiSouth.OR.
     &    useOrlanskiEast.OR.useOrlanskiWest) THEN
       IF (nonlinFreeSurf.GT.0) THEN
        WRITE(msgBuf,'(2A)') 'OBCS_CHECK: ',
     &      'nonlinFreeSurf not yet implemented in Orlanski OBC'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
       ENDIF
       IF (usePTracers) THEN
        WRITE(msgBuf,'(2A)') 'OBCS_CHECK: ',
     &      ' useOrlanski* OBC not yet implemented for pTracers'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
       ENDIF
       IF (useSEAICE) THEN
        WRITE(msgBuf,'(2A)') 'OBCS_CHECK: ',
     &      ' useOrlanski* OBC not yet implemented for SEAICE'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
       ENDIF
      ENDIF

#ifdef ALLOW_OBCS_STEVENS
      WRITE(msgBuf,'(A)') 'OBCS_CHECK: #define ALLOW_OBCS_STEVENS'
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
C     check compatibility with Orlanski
      IF (      ( useStevensNorth.AND.useOrlanskiNorth )
     &     .OR. ( useStevensSouth.AND.useOrlanskiSouth )
     &     .OR. (  useStevensEast.AND.useOrlanskiEast )
     &     .OR. (  useStevensWest.AND.useOrlanskiWest ) ) THEN
        WRITE(msgBuf,'(A)')
     &  'OBCS_CHECK: both useOrlanski* and useStevens* logicals'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(A)')
     &      'OBCS_CHECK: are true for at least one boundary'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF
      IF (useStevensNorth.OR.useStevensSouth.OR.
     &    useStevensEast.OR.useStevensWest) THEN
       IF (nonlinFreeSurf.GT.0) THEN
        WRITE(msgBuf,'(2A)') 'OBCS_CHECK: ',
     &    'useStevens OBC with nonlinFreeSurf not yet implemented'
        CALL PRINT_ERROR( msgBuf, myThid )
       ENDIF
       IF (usePTracers) THEN
        WRITE(msgBuf,'(2A)') '** WARNING ** OBCS_CHECK: ',
     &    'useStevens OBC with pTracers not yet implemented'
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
        WRITE(msgBuf,'(2A)') '** WARNING ** OBCS_CHECK: ',
     &    'therefore expect the unexpected'
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
       ENDIF
       IF (useSEAICE) THEN
        WRITE(msgBuf,'(2A)') '** WARNING ** OBCS_CHECK: ',
     &    'useStevens OBC with SEAICE not yet implemented'
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
        WRITE(msgBuf,'(2A)') '** WARNING ** OBCS_CHECK: ',
     &    'therefore expect the unexpected'
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
       ENDIF
CML       IF (usePTracers) THEN
CML        WRITE(msgBuf,'(2A)') 'OBCS_CHECK: ',
CML     &  'useStevens* OBC with pTracers not yet implemented'
CML        CALL PRINT_ERROR( msgBuf, myThid )
CML        errCount = errCount + 1
CML       ENDIF
CML       IF (useSEAICE) THEN
CML        WRITE(msgBuf,'(2A)') 'OBCS_CHECK: ',
CML     &  'useStevens* OBC with SEAICE not yet implemented'
CML        CALL PRINT_ERROR( msgBuf, myThid )
CML        errCount = errCount + 1
CML       ENDIF
      ENDIF
#else
      IF (useStevensNorth.OR.useStevensSouth.OR.
     &    useStevensEast.OR.useStevensWest) THEN
        WRITE(msgBuf,'(A)')
     &  'OBCS_CHECK: #undef OBCS_ALLOW_STEVENS  and'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(A)')
     &  'OBCS_CHECK: one of useStevens* logicals is true'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF
#endif /* ALLOW_OBCS_STEVENS */

#ifndef ALLOW_OBCS_PRESCRIBE
      IF (useOBCSprescribe) THEN
        WRITE(msgBuf,'(A)')
     &       'OBCS_CHECK: useOBCSprescribe = .TRUE. for'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(A)')
     &       'OBCS_CHECK: undef ALLOW_OBCS_PRESCRIBE'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF
#endif /* ALLOW_OBCS_PRESCRIBE */

#ifndef ALLOW_OBCS_SPONGE
      IF (useOBCSsponge) THEN
        WRITE(msgBuf,'(2A)') 'OBCS_CHECK: ',
     &       'Cannot set useOBCSsponge=.TRUE. (data.obcs)'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(2A)') 'OBCS_CHECK: ',
     &       'with #undef ALLOW_OBCS_SPONGE (OBCS_OPTIONS.h)'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF
#endif /* ALLOW_OBCS_SPONGE */

#ifndef ALLOW_OBCS_SEAICE_SPONGE
      IF (useSeaiceSponge) THEN
        WRITE(msgBuf,'(2A)') 'OBCS_CHECK: ',
     &       'Cannot set useSeaiceSponge=.TRUE. (data.obcs)'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(2A)') 'OBCS_CHECK: ',
     &       'with #undef ALLOW_OBCS_SEAICE_SPONGE (OBCS_OPTIONS.h)'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF
#endif /* ALLOW_OBCS_SEAICE_SPONGE */

#ifdef ALLOW_OBCS_BALANCE
      IF ( OBCSbalanceSurf ) THEN
C     The surface correction is not applied when none of the
C     four OBCS_balanceFacE,W,N,S is positive.
        IF ( nTileWithActiveOB .EQ. 0 ) THEN
         WRITE(msgBuf,'(A)')
     &    'OBCS_CHECK: OBCSbalanceSurf=T requires to have at least'
         CALL PRINT_ERROR( msgBuf, myThid )
         WRITE(msgBuf,'(2A)')
     &        'OBCS_CHECK: one of OBCS_balanceFac[E,W,N,S] > 0',
     &        ' on an active boundary to work.'
         CALL PRINT_ERROR( msgBuf, myThid )
         errCount = errCount + 1
        ENDIF
      ENDIF
#else /* ALLOW_OBCS_BALANCE */
      IF ( useOBCSbalance ) THEN
        WRITE(msgBuf,'(A)')
     &  'OBCS_CHECK: useOBCSbalance requires to define'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(A)')
     &  'OBCS_CHECK: ALLOW_OBCS_BALANCE in "OBCS_OPTIONS.h"'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF
#endif /* ALLOW_OBCS_BALANCE */

#ifndef ALLOW_OBCS_TIDES
      IF ( useOBCStides ) THEN
        WRITE(msgBuf,'(A)')
     &  'OBCS_CHECK: useOBCStides requires to define'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(A)')
     &  'OBCS_CHECK: ALLOW_OBCS_TIDES in "OBCS_OPTIONS.h"'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF
#endif /* ALLOW_OBCS_TIDES */

      IF ( .NOT.nonHydrostatic .AND.
     &         ( OBNwFile.NE.' ' .OR. OBSwFile.NE.' ' .OR.
     &           OBEwFile.NE.' ' .OR. OBWwFile.NE.' ' )
     &   ) THEN
        WRITE(msgBuf,'(2A)')
     &  'OBCS_CHECK: OB*wFile only allowed with nonHydrostatic'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF
      IF ( nonlinFreeSurf.EQ.0 .AND.
     &         ( OBNetaFile.NE.' ' .OR. OBSetaFile.NE.' ' .OR.
     &           OBEetaFile.NE.' ' .OR. OBWetaFile.NE.' ' )
     &   ) THEN
        WRITE(msgBuf,'(2A)')
     &  'OBCS_CHECK: OB*etaFile(s) only allowed with nonlinFreeSurf'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF

      IF (useSEAICE .AND. .NOT. useEXF) THEN
        WRITE(msgBuf,'(A)')
     &   'OBCS_CHECK: for SEAICE OBCS, use'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(A)')
     &   'OBCS_CHECK: pkg/exf to read input files'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF
#ifndef OBCS_UVICE_OLD
c     IF ( useSEAICE .AND. SEAICEuseDYNAMICS ) THEN
      IF ( useSEAICE ) THEN
#if ( defined (OBCS_SEAICE_COMPUTE_UVICE)     || \
      defined (OBCS_SEAICE_AVOID_CONVERGENCE) || \
      defined (OBCS_SEAICE_SMOOTH_UVICE_PERP) || \
      defined (OBCS_SEAICE_SMOOTH_UVICE_PAR) )
        WRITE(msgBuf,'(2A)') 'OBCS_CHECK: ',
     &       'needs to define OBCS_UVICE_OLD in OBCS_OPTIONS.h'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(2A)') 'OBCS_CHECK: ',
     &       'to activate such OBCS_SEAICE_[] option'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
#endif
      ENDIF
#endif /* ndef OBCS_UVICE_OLD */

      IF ( errCount.GE.1 ) THEN
        WRITE(msgBuf,'(A,I3,A)')
     &       'OBCS_CHECK: detected', errCount,' fatal error(s)'
        CALL PRINT_ERROR( msgBuf, myThid )
        CALL ALL_PROC_DIE( 0 )
        STOP 'ABNORMAL END: S/R OBCS_CHECK'
      ENDIF

      WRITE(msgBuf,'(A)') 'OBCS_CHECK: set-up OK'
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )

      _END_MASTER(myThid)

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C--   Check if Interior mask is consistent with OB list of indices
c     IF ( insideOBmaskFile.NE.' ' ) THEN
       errCount = 0
       WRITE(msgBuf,'(2A)') 'S/R OBCS_CHECK: ',
     &              'Inside Mask and OB locations disagree :'
       DO bj = myByLo(myThid), myByHi(myThid)
        DO bi = myBxLo(myThid), myBxHi(myThid)

         DO j=1,sNy
C-    Eastern boundary
          i = OB_Ie(j,bi,bj)
          IF ( i.NE.OB_indexNone ) THEN
           IF ( maskInC(i,j,bi,bj).NE.0. ) THEN
            IF ( errCount.EQ.0 ) CALL PRINT_ERROR( msgBuf, myThid )
            WRITE(msgBuf,'(2(A,I3),2(A,I5))')
     &        ' from OB_Ie (bi,bj=', bi, ',', bj,
     &        ') expects Mask=0 @ i,j=', i, ',', j
            CALL PRINT_ERROR( msgBuf, myThid )
            errCount = errCount + 1
           ENDIF
          ENDIF
          DO i=1,sNx+1
           IF ( maskInC(i-1,j,bi,bj).GT.maskInC(i,j,bi,bj)
     &          .AND.kSurfW(i,j,bi,bj).LE.Nr
     &          .AND. i.NE.OB_Ie(j,bi,bj) ) THEN
            IF ( errCount.EQ.0 ) CALL PRINT_ERROR( msgBuf, myThid )
            WRITE(msgBuf,'(2(A,I3),2(A,I5))')
     &        ' from insideMask (bi,bj=', bi, ',', bj,
     &        ') expects OBE=', i, ' @ j=', j
            CALL PRINT_ERROR( msgBuf, myThid )
            errCount = errCount + 1
           ENDIF
          ENDDO
C-    Western boundary
          i = OB_Iw(j,bi,bj)
          IF ( i.NE.OB_indexNone ) THEN
           IF ( maskInC(i,j,bi,bj).NE.0. ) THEN
            IF ( errCount.EQ.0 ) CALL PRINT_ERROR( msgBuf, myThid )
            WRITE(msgBuf,'(2(A,I3),2(A,I5))')
     &        ' from OB_Iw (bi,bj=', bi, ',', bj,
     &        ') expects Mask=0 @ i,j=', i, ',', j
            CALL PRINT_ERROR( msgBuf, myThid )
            errCount = errCount + 1
           ENDIF
          ENDIF
          DO i=1,sNx+1
           IF ( maskInC(i-1,j,bi,bj).LT.maskInC(i,j,bi,bj)
     &          .AND.kSurfW(i,j,bi,bj).LE.Nr
     &          .AND. i.NE.OB_Iw(j,bi,bj)+1 ) THEN
            IF ( errCount.EQ.0 ) CALL PRINT_ERROR( msgBuf, myThid )
            WRITE(msgBuf,'(2(A,I3),2(A,I5))')
     &        ' from insideMask (bi,bj=', bi, ',', bj,
     &        ') expects OBW=', i-1, ' @ j=', j
            CALL PRINT_ERROR( msgBuf, myThid )
            errCount = errCount + 1
           ENDIF
          ENDDO
         ENDDO

         DO i=1,sNx
C-    Northern boundary
          j = OB_Jn(i,bi,bj)
          IF ( j.NE.OB_indexNone ) THEN
           IF ( maskInC(i,j,bi,bj).NE.0. ) THEN
            IF ( errCount.EQ.0 ) CALL PRINT_ERROR( msgBuf, myThid )
            WRITE(msgBuf,'(2(A,I3),2(A,I5))')
     &        ' from OB_Jn (bi,bj=', bi, ',', bj,
     &        ') expects Mask=0 @ i,j=', i, ',', j
            CALL PRINT_ERROR( msgBuf, myThid )
            errCount = errCount + 1
           ENDIF
          ENDIF
          DO j=1,sNy+1
           IF ( maskInC(i,j-1,bi,bj).GT.maskInC(i,j,bi,bj)
     &          .AND.kSurfS(i,j,bi,bj).LE.Nr
     &          .AND. j.NE.OB_Jn(i,bi,bj) ) THEN
            IF ( errCount.EQ.0 ) CALL PRINT_ERROR( msgBuf, myThid )
            WRITE(msgBuf,'(2(A,I3),2(A,I5))')
     &        ' from insideMask (bi,bj=', bi, ',', bj,
     &        ') expects OBN=', j, ' @ i=', i
            CALL PRINT_ERROR( msgBuf, myThid )
            errCount = errCount + 1
           ENDIF
          ENDDO
C-    Southern boundary
          j = OB_Js(i,bi,bj)
          IF ( j.NE.OB_indexNone ) THEN
           IF ( maskInC(i,j,bi,bj).NE.0. ) THEN
            IF ( errCount.EQ.0 ) CALL PRINT_ERROR( msgBuf, myThid )
            WRITE(msgBuf,'(2(A,I3),2(A,I5))')
     &        ' from OB_Js (bi,bj=', bi, ',', bj,
     &        ') expects Mask=0 @ i,j=', i, ',', j
            CALL PRINT_ERROR( msgBuf, myThid )
            errCount = errCount + 1
           ENDIF
          ENDIF
          DO j=1,sNy+1
           IF ( maskInC(i,j-1,bi,bj).LT.maskInC(i,j,bi,bj)
     &          .AND.kSurfS(i,j,bi,bj).LE.Nr
     &          .AND. j.NE.OB_Js(i,bi,bj)+1 ) THEN
            IF ( errCount.EQ.0 ) CALL PRINT_ERROR( msgBuf, myThid )
            WRITE(msgBuf,'(2(A,I3),2(A,I5))')
     &        ' from insideMask (bi,bj=', bi, ',', bj,
     &        ') expects OBS=', j-1, ' @ i=', i
            CALL PRINT_ERROR( msgBuf, myThid )
            errCount = errCount + 1
           ENDIF
          ENDDO
         ENDDO

        ENDDO
       ENDDO
       CALL GLOBAL_SUM_INT( errCount, myThid )
       IF ( errCount.GE.1 ) THEN
         WRITE(msgBuf,'(A,I6,A)')
     &       'OBCS_CHECK:', errCount,' errors in OB location vs Mask'
         CALL PRINT_ERROR( msgBuf, myThid )
         CALL ALL_PROC_DIE( myThid )
         STOP 'ABNORMAL END: S/R OBCS_CHECK'
       ELSE
         _BEGIN_MASTER(myThid)
         WRITE(msgBuf,'(2A)') 'OBCS_CHECK: ',
     &              'check Inside Mask and OB locations: OK'
         CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
         WRITE(msgBuf,'(A)') ' '
         CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
         _END_MASTER(myThid)
       ENDIF
c     ENDIF

#endif /* ALLOW_OBCS */
      RETURN
      END

#include "MOM_COMMON_OPTIONS.h"

CBOP
C !ROUTINE: MOM_QUASIHYDROSTATIC

C !INTERFACE: ==========================================================
      SUBROUTINE MOM_QUASIHYDROSTATIC(
     I                bi, bj, k,
     I                uFld, vFld,
     U                effectiveBuoy,
     I                myTime, myIter, myThid )

C !DESCRIPTION:
C     *==========================================================*
C     | o SUBROUTINE MOM_QUASIHYDROSTATIC
C     |   Add Quasi-Hydrostatic Terms to buoyancy
C     *==========================================================*

C !USES: ===============================================================
      IMPLICIT NONE

C--   == Global data ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#ifdef ALLOW_QHYD_STAGGER_TS
# include "RESTART.h"
# include "NH_VARS.h"
#endif

C--   == Routine arguments ==
C !INPUT VARIABLES: ====================================================
C  bi, bj        :: tile indices
C  k             :: vertical level
C  uFld          :: zonal flow
C  vFld          :: meridional flow
C  myTime        :: current time in simulation
C  myIter        :: current iteration number
C  myThid        :: my Thread Id number
      INTEGER bi, bj, k
      _RL uFld(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      _RL vFld(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      _RL myTime
      INTEGER myIter
      INTEGER myThid

C !OUTPUT/MODIFIED VARIABLES: ==========================================
C  effectiveBuoy :: Density (z-coord) / specific volume (p-coord) anomaly
      _RL effectiveBuoy(1-OLx:sNx+OLx,1-OLy:sNy+OLy)

C !LOCAL VARIABLES: ====================================================
C  i, j          :: loop indices
C  gWinBuoy      :: vertical acceleraton term to add to buoyancy
C  gw_AB         :: tendency increment from Adams-Bashforth
C  scalingFactor :: scaling factor (from acceleration to density)
      INTEGER iMin,iMax,jMin,jMax
      PARAMETER( iMin = 0 , iMax = sNx+1 )
      PARAMETER( jMin = 0 , jMax = sNy+1 )
      INTEGER i, j
      _RL gWinBuoy(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
#ifdef ALLOW_QHYD_STAGGER_TS
      _RL gw_AB   (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
#endif
      _RL scalingFactor
CEOP

      IF ( select3dCoriScheme.GE.1 .OR. useNHMTerms ) THEN

        IF ( usingZCoords ) THEN
C--   Z-coordinate case: Input is density anomaly

          scalingFactor = rhoConst*gravitySign
     &                            *recip_gravity*recip_gravFacC(k)
C-    to reproduce old (wrong) results:
c         scalingFactor=gravitySign*recip_gravity

        ELSEIF ( fluidIsWater ) THEN
C--   P-coordinate, oceanic case: Input is specific-volume anomaly

c         scalingFactor = recip_rhoConst*recip_gravity
C     better to use rhoRef = rho(tRef,sRef,p) and consistent with
C-    omega <-> w-velocity conversion:
          scalingFactor = ( oneRL / rhoRef(k) )*recip_gravity

        ELSE
C--   P-coord., Ideal-Gas case: Input is virtual potential temp. anomaly
C     (see White & Bromley, QJRMS 1995)
          scalingFactor = tRef(k)*recip_gravity

        ENDIF

        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
           gWinBuoy(i,j) = 0. _d 0
         ENDDO
        ENDDO

        IF ( select3dCoriScheme.GE.1 ) THEN
         DO j=jMin,jMax
          DO i=iMin,iMax
           gWinBuoy(i,j) = fCoriCos(i,j,bi,bj)*
     &       ( angleCosC(i,j,bi,bj)*halfRL
     &             *( uFld(i,j,k,bi,bj) + uFld(i+1,j,k,bi,bj) )
     &        -angleSinC(i,j,bi,bj)*halfRL
     &             *( vFld(i,j,k,bi,bj) + vFld(i,j+1,k,bi,bj) )
     &       )
          ENDDO
         ENDDO
        ENDIF

        IF ( useNHMTerms ) THEN
         DO j=jMin,jMax
          DO i=iMin,iMax
           gWinBuoy(i,j) = gWinBuoy(i,j)
     &       + (  ( uFld( i ,j,k,bi,bj)*uFld( i ,j,k,bi,bj)
     &            + uFld(i+1,j,k,bi,bj)*uFld(i+1,j,k,bi,bj) )
     &          + ( vFld(i, j ,k,bi,bj)*vFld(i, j ,k,bi,bj)
     &            + vFld(i,j+1,k,bi,bj)*vFld(i,j+1,k,bi,bj) )
     &         )* halfRL*recip_rSphere*recip_deepFacC(k)
          ENDDO
         ENDDO
        ENDIF

#ifdef ALLOW_QHYD_STAGGER_TS
        IF ( staggerTimeStep ) THEN
# ifdef ALLOW_ADAMSBASHFORTH_3
          CALL ADAMS_BASHFORTH3( bi, bj, k, 1,
     U                           gWinBuoy,
     U                           QHydGwNm,
     O                           gw_AB,
     I                           qHydStartAB, myIter, myThid )
# else /* ALLOW_ADAMSBASHFORTH_3 */
          CALL ADAMS_BASHFORTH2( bi, bj, 1, 1,
     U                           gWinBuoy,
     U                           QHydGwNm(1-OLx,1-OLy,k,bi,bj),
     O                           gw_AB,
     I                           qHydStartAB, myIter, myThid )
# endif /* ALLOW_ADAMSBASHFORTH_3 */
        ENDIF
#endif /* ALLOW_QHYD_STAGGER_TS */

        DO j=jMin,jMax
         DO i=iMin,iMax
           effectiveBuoy(i,j) = effectiveBuoy(i,j)
     &                        + scalingFactor*gWinBuoy(i,j)
         ENDDO
        ENDDO

      ENDIF

      RETURN
      END

#include "MOM_VECINV_OPTIONS.h"
#include "MOM_COMMON_OPTIONS.h"
#ifdef ALLOW_AUTODIFF
# include "AUTODIFF_OPTIONS.h"
#endif
#ifdef ALLOW_GGL90
# include "GGL90_OPTIONS.h"
#endif

      SUBROUTINE MOM_VECINV(
     I        bi,bj,k,iMin,iMax,jMin,jMax,
     I        kappaRU, kappaRV,
     I        fVerUkm, fVerVkm,
     O        fVerUkp, fVerVkp,
     O        guDiss, gvDiss,
     I        myTime, myIter, myThid )
C     *==========================================================*
C     | S/R MOM_VECINV                                           |
C     | o Form the right hand-side of the momentum equation.     |
C     *==========================================================*
C     | Terms are evaluated one layer at a time working from     |
C     | the bottom to the top. The vertically integrated         |
C     | barotropic flow tendency term is evluated by summing the |
C     | tendencies.                                              |
C     | Notes:                                                   |
C     | We have not sorted out an entirely satisfactory formula  |
C     | for the diffusion equation bc with lopping. The present  |
C     | form produces a diffusive flux that does not scale with  |
C     | open-area. Need to do something to solidfy this and to   |
C     | deal "properly" with thin walls.                         |
C     *==========================================================*
      IMPLICIT NONE

C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "SURFACE.h"
#include "DYNVARS.h"
#include "FFIELDS.h"
#include "MOM_VISC.h"
#if ( defined ALLOW_GGL90 && defined ALLOW_GGL90_LANGMUIR )
# include "GGL90.h"
#endif
#ifdef ALLOW_MNC
# include "MNC_PARAMS.h"
#endif
#ifdef ALLOW_AUTODIFF_TAMC
# include "tamc.h"
#endif

C     == Routine arguments ==
C     bi,bj   :: current tile indices
C     k       :: current vertical level
C     iMin,iMax,jMin,jMax :: loop ranges
C     fVerU   :: Flux of momentum in the vertical direction, out of the upper
C     fVerV   :: face of a cell k ( flux into the cell above ).
C     fVerUkm :: vertical viscous flux of U, interface above (k-1/2)
C     fVerVkm :: vertical viscous flux of V, interface above (k-1/2)
C     fVerUkp :: vertical viscous flux of U, interface below (k+1/2)
C     fVerVkp :: vertical viscous flux of V, interface below (k+1/2)

C     guDiss  :: dissipation tendency (all explicit terms), u component
C     gvDiss  :: dissipation tendency (all explicit terms), v component
C     myTime  :: current time
C     myIter  :: current time-step number
C     myThid  :: my Thread Id number
      INTEGER bi,bj,k
      INTEGER iMin,iMax,jMin,jMax
      _RL kappaRU(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr+1)
      _RL kappaRV(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr+1)
      _RL fVerUkm(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL fVerVkm(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL fVerUkp(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL fVerVkp(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL guDiss(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL gvDiss(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL     myTime
      INTEGER myIter
      INTEGER myThid

#ifdef ALLOW_MOM_VECINV
C     == Functions ==
      LOGICAL  DIFFERENT_MULTIPLE
      EXTERNAL DIFFERENT_MULTIPLE
#ifdef ALLOW_DIAGNOSTICS
      LOGICAL  DIAGNOSTICS_IS_ON
      EXTERNAL DIAGNOSTICS_IS_ON
#endif

C     == Local variables ==
C     strainBC :: same as strain but account for no-slip BC
C     vort3BC  :: same as vort3  but account for no-slip BC
C     i,j      :: Loop counters
      INTEGER i,j
      _RL      vF (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL      vrF(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL      uCf(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL      vCf(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RS hFacZ   (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RS h0FacZ  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RS r_hFacZ (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL uFld    (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL vFld    (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
#if ( defined ALLOW_GGL90 && defined ALLOW_GGL90_LANGMUIR )
      _RL uRes    (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL vRes    (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
#endif
      _RL del2u   (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL del2v   (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL dStar   (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL zStar   (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL tension (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL strain  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL strainBC(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL stretching(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
#ifdef ALLOW_LEITH_QG
      _RL Nsquare (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
#endif
      _RL cDrag   (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL KE      (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL omega3  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL vort3   (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL vort3BC (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL hDiv    (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL viscAh_Z(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL viscAh_D(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL viscA4_Z(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL viscA4_D(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
C     xxxFac :: On-off tracer parameters used for switching terms off.
      _RL  ArDudrFac
      _RL  ArDvdrFac
      _RL  sideMaskFac
      LOGICAL bottomDragTerms
      LOGICAL writeDiag
#if ( defined ALLOW_MOM_TEND_EXTRA_DIAGS && defined ALLOW_DIAGNOSTICS )
      LOGICAL botDragDiagIsOn
      LOGICAL shelfDragDiagIsOn
#endif /* ALLOW_MOM_TEND_EXTRA_DIAGS && ALLOW_DIAGNOSTICS */
#ifdef ALLOW_AUTODIFF_TAMC
C     kkey :: tape key (depends on level and tile indices)
      INTEGER kkey
#endif
#ifdef ALLOW_MNC
      INTEGER offsets(9)
      CHARACTER*(1) pf
#endif

#ifdef ALLOW_AUTODIFF
C--   only the kDown part of fverU/V is set in this subroutine
C--   the kUp is still required
C--   In the case of mom_fluxform kUp is set as well
C--   (at least in part)
      fVerUkm(1,1) = fVerUkm(1,1)
      fVerVkm(1,1) = fVerVkm(1,1)
#endif

#ifdef ALLOW_AUTODIFF_TAMC
      kkey = bi + (bj-1)*nSx + (ikey_dynamics-1)*nSx*nSy
      kkey = k  + (kkey-1)*Nr
#endif /* ALLOW_AUTODIFF_TAMC */

      writeDiag = DIFFERENT_MULTIPLE(diagFreq, myTime, deltaTClock)

#ifdef ALLOW_MNC
      IF (useMNC .AND. snapshot_mnc .AND. writeDiag) THEN
        IF ( writeBinaryPrec .EQ. precFloat64 ) THEN
          pf(1:1) = 'D'
        ELSE
          pf(1:1) = 'R'
        ENDIF
        IF ((bi .EQ. 1).AND.(bj .EQ. 1).AND.(k .EQ. 1)) THEN
          CALL MNC_CW_SET_UDIM('mom_vi', -1, myThid)
          CALL MNC_CW_RL_W_S('D','mom_vi',0,0,'T',myTime,myThid)
          CALL MNC_CW_SET_UDIM('mom_vi', 0, myThid)
          CALL MNC_CW_I_W_S('I','mom_vi',0,0,'iter',myIter,myThid)
        ENDIF
        DO i = 1,9
          offsets(i) = 0
        ENDDO
        offsets(3) = k
c       write(*,*) 'offsets = ',(offsets(i),i=1,9)
      ENDIF
#endif /*  ALLOW_MNC  */

C--   Initialise intermediate terms
      DO j=1-OLy,sNy+OLy
       DO i=1-OLx,sNx+OLx
        vF(i,j)    = 0.
        vrF(i,j)   = 0.
        uCf(i,j)   = 0.
        vCf(i,j)   = 0.
        del2u(i,j) = 0.
        del2v(i,j) = 0.
        dStar(i,j) = 0.
        zStar(i,j) = 0.
        guDiss(i,j)= 0.
        gvDiss(i,j)= 0.
#if ( defined ALLOW_GGL90 && defined ALLOW_GGL90_LANGMUIR )
c       uRes(i,j)  = 0.
c       vRes(i,j)  = 0.
#endif
        vort3(i,j) = 0.
        omega3(i,j)= 0.
        KE(i,j)    = 0.
C-    need to initialise hDiv for MOM_VI_DEL2UV(call FILL_CS_CORNER_TR_RL)
        hDiv(i,j)  = 0.
c       viscAh_Z(i,j) = 0.
c       viscAh_D(i,j) = 0.
c       viscA4_Z(i,j) = 0.
c       viscA4_D(i,j) = 0.
        strain(i,j)  = 0. _d 0
        strainBC(i,j)= 0. _d 0
        stretching(i,j) = 0. _d 0
#ifdef ALLOW_LEITH_QG
        Nsquare(i,j) = 0. _d 0
#endif
        tension(i,j) = 0. _d 0
#ifdef ALLOW_AUTODIFF
        hFacZ(i,j)   = 0. _d 0
#endif
       ENDDO
      ENDDO

C--   Term by term tracer parmeters
C     o U momentum equation
      ArDudrFac    = vfFacMom*1.
C     o V momentum equation
      ArDvdrFac    = vfFacMom*1.

C note: using standard stencil (no mask) results in under-estimating
C       vorticity at a no-slip boundary by a factor of 2 = sideDragFactor
      IF ( no_slip_sides ) THEN
        sideMaskFac = sideDragFactor
      ELSE
        sideMaskFac = 0. _d 0
      ENDIF

      IF ( selectImplicitDrag.EQ.0 .AND.
     &      (  no_slip_bottom
     &    .OR. selectBotDragQuadr.GE.0
     &    .OR. bottomDragLinear.NE.0. ) ) THEN
       bottomDragTerms=.TRUE.
      ELSE
       bottomDragTerms=.FALSE.
      ENDIF

#if ( defined ALLOW_MOM_TEND_EXTRA_DIAGS && defined ALLOW_DIAGNOSTICS )
      botDragDiagIsOn = .FALSE.
      shelfDragDiagIsOn = .FALSE.
      IF ( useDiagnostics ) THEN
       IF ( bottomDragTerms ) botDragDiagIsOn =
     &            DIAGNOSTICS_IS_ON( 'UBotDrag', myThid )
     &       .OR. DIAGNOSTICS_IS_ON( 'VBotDrag', myThid )
       IF ( useShelfIce ) shelfDragDiagIsOn =
     &            DIAGNOSTICS_IS_ON( 'UShIDrag', myThid )
     &       .OR. DIAGNOSTICS_IS_ON( 'VShIDrag', myThid )
      ENDIF
#endif /* ALLOW_MOM_TEND_EXTRA_DIAGS && ALLOW_DIAGNOSTICS */

C--   Calculate open water fraction at vorticity points
      CALL MOM_CALC_HFACZ(bi,bj,k,hFacZ,r_hFacZ,myThid)

C     Make local copies of horizontal flow field
      DO j=1-OLy,sNy+OLy
       DO i=1-OLx,sNx+OLx
        uFld(i,j) = uVel(i,j,k,bi,bj)
        vFld(i,j) = vVel(i,j,k,bi,bj)
       ENDDO
      ENDDO

#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE hFacZ(:,:)   = comlev1_bibj_k, key = kkey, byte = isbyte
CADJ STORE r_hFacZ(:,:) = comlev1_bibj_k, key = kkey, byte = isbyte
CADJ STORE fverukm(:,:) = comlev1_bibj_k, key = kkey, byte = isbyte
CADJ STORE fvervkm(:,:) = comlev1_bibj_k, key = kkey, byte = isbyte
#endif

C note (jmc) : Dissipation and Vort3 advection do not necesary
C              use the same maskZ (and hFacZ)  => needs 2 call(s)
c     CALL MOM_VI_HFACZ_DISS(bi,bj,k,hFacZ,r_hFacZ,myThid)

      CALL MOM_CALC_KE(bi,bj,k,selectKEscheme,uFld,vFld,KE,myThid)

      CALL MOM_CALC_RELVORT3(bi,bj,k,uFld,vFld,hFacZ,vort3,myThid)

C-    mask vort3 and account for no-slip / free-slip BC in vort3BC:
      DO j=1-OLy,sNy+OLy
       DO i=1-OLx,sNx+OLx
         vort3BC(i,j) = vort3(i,j)
         IF ( hFacZ(i,j).EQ.zeroRS ) THEN
           vort3BC(i,j) = sideMaskFac*vort3BC(i,j)
           vort3(i,j)   = 0.
         ENDIF
       ENDDO
      ENDDO

#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE KE(:,:)      = comlev1_bibj_k, key = kkey, byte = isbyte
CADJ STORE vort3(:,:)   = comlev1_bibj_k, key = kkey, byte = isbyte
CADJ STORE vort3bc(:,:) = comlev1_bibj_k, key = kkey, byte = isbyte
#endif

      IF (momViscosity) THEN
C--    For viscous term, compute horizontal divergence, tension & strain
C      and mask relative vorticity (free-slip case):

       DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
          h0FacZ(i,j) = hFacZ(i,j)
        ENDDO
       ENDDO
#ifdef NONLIN_FRSURF
       IF ( no_slip_sides .AND. nonlinFreeSurf.GT.0 ) THEN
        DO j=2-OLy,sNy+OLy
         DO i=2-OLx,sNx+OLx
          h0FacZ(i,j) = MIN(
     &       MIN( h0FacW(i,j,k,bi,bj), h0FacW(i,j-1,k,bi,bj) ),
     &       MIN( h0FacS(i,j,k,bi,bj), h0FacS(i-1,j,k,bi,bj) ) )
         ENDDO
        ENDDO
       ENDIF
# ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE h0FacZ(:,:) = comlev1_bibj_k, key = kkey, byte = isbyte
# endif
#endif /* NONLIN_FRSURF */

       CALL MOM_CALC_HDIV(bi,bj,k,2,uFld,vFld,hDiv,myThid)

       IF ( useVariableVisc .OR. useStrainTensionVisc ) THEN
        CALL MOM_CALC_TENSION( bi,bj,k,uFld,vFld,tension,myThid )
        CALL MOM_CALC_STRAIN( bi,bj,k,uFld,vFld,hFacZ,strain,myThid )
C-    mask strain and account for no-slip / free-slip BC in strainBC:
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
           strainBC(i,j) = strain(i,j)
           IF ( hFacZ(i,j).EQ.zeroRS ) THEN
             strainBC(i,j) = sideMaskFac*strainBC(i,j)
             strain(i,j)   = 0.
           ENDIF
         ENDDO
        ENDDO
#ifdef ALLOW_LEITH_QG
        IF ( viscC2LeithQG.NE.zeroRL ) THEN
          CALL MOM_VISC_QGL_STRETCH(bi,bj,k,
     O                            stretching, Nsquare,
     I                            myTime, myIter, myThid )
          CALL MOM_VISC_QGL_LIMIT(bi,bj,k,
     O                          stretching,
     I                          Nsquare, uFld,vFld,vort3,
     I                          myTime, myIter, myThid )
        ENDIF
#endif /* ALLOW_LEITH_QG */
       ENDIF

#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE hDiv(:,:)     = comlev1_bibj_k, key = kkey, byte = isbyte
CADJ STORE tension(:,:)  = comlev1_bibj_k, key = kkey, byte = isbyte
CADJ STORE strain(:,:)   = comlev1_bibj_k, key = kkey, byte = isbyte
CADJ STORE strainBC(:,:) = comlev1_bibj_k, key = kkey, byte = isbyte
#endif

C--    Calculate Lateral Viscosities
       DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
         viscAh_D(i,j) = viscAhD
         viscAh_Z(i,j) = viscAhZ
         viscA4_D(i,j) = viscA4D
         viscA4_Z(i,j) = viscA4Z
        ENDDO
       ENDDO
       IF ( useVariableVisc ) THEN
C-     uses vort3BC & strainBC which account for no-slip / free-slip BC
#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE KE(:,:) = comlev1_bibj_k, key = kkey, byte = isbyte
#endif
         CALL MOM_CALC_VISC( bi, bj, k,
     O            viscAh_Z, viscAh_D, viscA4_Z, viscA4_D,
     I            hDiv, vort3BC, tension, strainBC, stretching,
     I            KE, hfacZ, myThid )
#ifdef ALLOW_AUTODIFF_TAMC
# ifndef AUTODIFF_ALLOW_VISCFACADJ
C     These store directive must not be here, if you want to recompute
C     these viscosity coefficients with a modified viscFacAdj = viscFacInAd
C     because the store directives intentionally prevent the recomputation.
CADJ STORE viscAh_Z(:,:) = comlev1_bibj_k, key = kkey, byte = isbyte
CADJ STORE viscAh_D(:,:) = comlev1_bibj_k, key = kkey, byte = isbyte
CADJ STORE viscA4_Z(:,:) = comlev1_bibj_k, key = kkey, byte = isbyte
CADJ STORE viscA4_D(:,:) = comlev1_bibj_k, key = kkey, byte = isbyte
# endif /* AUTODIFF_ALLOW_VISCFACADJ */
#endif /* ALLOW_AUTODIFF_TAMC */
       ENDIF

#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE hDiv(:,:) = comlev1_bibj_k, key = kkey, byte = isbyte
#endif

C      Calculate del^2 u and del^2 v for bi-harmonic term
       IF (useBiharmonicVisc) THEN
         CALL MOM_VI_DEL2UV(bi,bj,k,hDiv,vort3,hFacZ,
     O                      del2u,del2v,
     I                      myThid)
         CALL MOM_CALC_HDIV(bi,bj,k,2,del2u,del2v,dStar,myThid)
         CALL MOM_CALC_RELVORT3(bi,bj,k,
     &                          del2u,del2v,hFacZ,zStar,myThid)
       ENDIF

#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE del2u(:,:) = comlev1_bibj_k, key = kkey, byte = isbyte
CADJ STORE del2v(:,:) = comlev1_bibj_k, key = kkey, byte = isbyte
CADJ STORE dStar(:,:) = comlev1_bibj_k, key = kkey, byte = isbyte
CADJ STORE zStar(:,:) = comlev1_bibj_k, key = kkey, byte = isbyte
#endif

C---   Calculate dissipation terms for U and V equations

C-     in terms of tension and strain
       IF (useStrainTensionVisc) THEN
C      use masked strain as if free-slip since side-drag is computed separately
         CALL MOM_HDISSIP( bi, bj, k,
     I            tension, strain, hFacZ,
     I            viscAh_Z, viscAh_D, viscA4_Z, viscA4_D,
     I            useHarmonicVisc, useBiharmonicVisc, useVariableVisc,
     O            guDiss, gvDiss,
     I            myThid )
       ELSE
C-     in terms of vorticity and divergence
         CALL MOM_VI_HDISSIP( bi, bj, k,
     I            hDiv, vort3, dStar, zStar, hFacZ,
     I            viscAh_Z, viscAh_D, viscA4_Z, viscA4_D,
     I            useHarmonicVisc, useBiharmonicVisc, useVariableVisc,
     O            guDiss, gvDiss,
     I            myThid )
       ENDIF

C---  Other dissipation terms in Zonal momentum equation

C--   Vertical flux (fVer is at upper face of "u" cell)
C     Eddy component of vertical flux (interior component only) -> vrF
       IF ( .NOT.implicitViscosity ) THEN
        CALL MOM_U_RVISCFLUX(bi,bj,k+1,uVel,kappaRU,vrF,myThid)
C     Combine fluxes
        DO j=jMin,jMax
         DO i=iMin,iMax
          fVerUkp(i,j) = ArDudrFac*vrF(i,j)
         ENDDO
        ENDDO

#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE fVerUkp(:,:) = comlev1_bibj_k, key = kkey, byte = isbyte
#endif

C--   Tendency is minus divergence of the fluxes
C     vert.visc.flx is scaled by deepFac2F (deep-atmos) and rhoFac (anelastic)
        DO j=jMin,jMax
         DO i=iMin,iMax
          guDiss(i,j) = guDiss(i,j)
     &    -_recip_hFacW(i,j,k,bi,bj)*recip_drF(k)
     &    *recip_rAw(i,j,bi,bj)
     &    *( fVerUkp(i,j) - fVerUkm(i,j) )*rkSign
     &    *recip_deepFac2C(k)*recip_rhoFacC(k)
         ENDDO
        ENDDO
       ENDIF

C-- No-slip and drag BCs appear as body forces in cell abutting topography
       IF ( no_slip_sides ) THEN
C-     No-slip BCs impose a drag at walls...
        CALL MOM_U_SIDEDRAG( bi, bj, k,
     I           uFld, del2u, h0FacZ,
     I           viscAh_Z, viscA4_Z,
     I           useHarmonicVisc, useBiharmonicVisc, useVariableVisc,
     O           vF,
     I           myThid )
        DO j=jMin,jMax
         DO i=iMin,iMax
          guDiss(i,j) = guDiss(i,j)+vF(i,j)
         ENDDO
        ENDDO
       ENDIF

C-    No-slip BCs impose a drag at bottom
       IF ( bottomDragTerms ) THEN
#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE KE(:,:) = comlev1_bibj_k, key = kkey, byte = isbyte
#endif
        CALL MOM_U_BOTDRAG_COEFF( bi, bj, k, .TRUE.,
     I                  uFld, vFld, kappaRU, KE,
     O                  cDrag,
     I                  myIter, myThid )
#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE cDrag(:,:) = comlev1_bibj_k, key = kkey, byte = isbyte
#endif
        DO j=jMin,jMax
         DO i=iMin,iMax
           vF(i,j) = -cDrag(i,j)*uFld(i,j)
     &             *_recip_hFacW(i,j,k,bi,bj)*recip_drF(k)
           gUdiss(i,j) = gUdiss(i,j) + vF(i,j)
         ENDDO
        ENDDO
        IF ( useDiagnostics ) THEN
         DO j=jMin,jMax
          DO i=iMin,iMax
           botDragU(i,j,bi,bj) = botDragU(i,j,bi,bj)
     &                         - cDrag(i,j)*uFld(i,j)*rUnit2mass
          ENDDO
         ENDDO
        ENDIF
#if ( defined ALLOW_MOM_TEND_EXTRA_DIAGS && defined ALLOW_DIAGNOSTICS )
        IF ( botDragDiagIsOn ) THEN
         CALL DIAGNOSTICS_FILL( vF, 'UBotDrag', k,1,2,bi,bj, myThid )
        ENDIF
#endif /* ALLOW_MOM_TEND_EXTRA_DIAGS && ALLOW_DIAGNOSTICS */
       ENDIF
#ifdef ALLOW_SHELFICE
       IF ( useShelfIce .AND. selectImplicitDrag.EQ.0 ) THEN
#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE KE(:,:) = comlev1_bibj_k, key = kkey, byte = isbyte
#endif
        CALL SHELFICE_U_DRAG_COEFF( bi, bj, k, .TRUE.,
     I                  uFld, vFld, kappaRU, KE,
     O                  cDrag,
     I                  myIter, myThid )
#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE cDrag(:,:) = comlev1_bibj_k, key = kkey, byte = isbyte
#endif
        DO j=jMin,jMax
         DO i=iMin,iMax
           gUdiss(i,j) = gUdiss(i,j)
     &                 - cDrag(i,j)*uFld(i,j)
     &                 *_recip_hFacW(i,j,k,bi,bj)*recip_drF(k)
         ENDDO
        ENDDO
#if ( defined ALLOW_MOM_TEND_EXTRA_DIAGS && defined ALLOW_DIAGNOSTICS )
        IF ( shelfDragDiagIsOn ) THEN
         DO j=jMin,jMax
          DO i=iMin,iMax
           vrF(i,j) = -cDrag(i,j)*uFld(i,j)
     &              *_recip_hFacW(i,j,k,bi,bj)*recip_drF(k)
          ENDDO
         ENDDO
         CALL DIAGNOSTICS_FILL( vrF, 'UShIDrag', k,1,2,bi,bj, myThid )
        ENDIF
#endif /* ALLOW_MOM_TEND_EXTRA_DIAGS && ALLOW_DIAGNOSTICS */
       ENDIF
#endif /* ALLOW_SHELFICE */

C---  Other dissipation terms in Meridional momentum equation

C--   Vertical flux (fVer is at upper face of "v" cell)
C     Eddy component of vertical flux (interior component only) -> vrF
       IF ( .NOT.implicitViscosity ) THEN
        CALL MOM_V_RVISCFLUX(bi,bj,k+1,vVel,kappaRV,vrF,myThid)
C     Combine fluxes -> fVerV
        DO j=jMin,jMax
         DO i=iMin,iMax
          fVerVkp(i,j) = ArDvdrFac*vrF(i,j)
         ENDDO
        ENDDO
#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE fVerVkp(:,:) = comlev1_bibj_k, key = kkey, byte = isbyte
#endif
C--   Tendency is minus divergence of the fluxes
C     vert.visc.flx is scaled by deepFac2F (deep-atmos) and rhoFac (anelastic)
        DO j=jMin,jMax
         DO i=iMin,iMax
          gvDiss(i,j) = gvDiss(i,j)
     &    -_recip_hFacS(i,j,k,bi,bj)*recip_drF(k)
     &    *recip_rAs(i,j,bi,bj)
     &    *( fVerVkp(i,j) - fVerVkm(i,j) )*rkSign
     &    *recip_deepFac2C(k)*recip_rhoFacC(k)
         ENDDO
        ENDDO
       ENDIF

C-- No-slip and drag BCs appear as body forces in cell abutting topography
       IF ( no_slip_sides ) THEN
C-     No-slip BCs impose a drag at walls...
        CALL MOM_V_SIDEDRAG( bi, bj, k,
     I           vFld, del2v, h0FacZ,
     I           viscAh_Z, viscA4_Z,
     I           useHarmonicVisc, useBiharmonicVisc, useVariableVisc,
     O           vF,
     I           myThid )
        DO j=jMin,jMax
         DO i=iMin,iMax
          gvDiss(i,j) = gvDiss(i,j)+vF(i,j)
         ENDDO
        ENDDO
       ENDIF

C-    No-slip BCs impose a drag at bottom
       IF ( bottomDragTerms ) THEN
#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE KE(:,:) = comlev1_bibj_k, key = kkey, byte = isbyte
#endif
        CALL MOM_V_BOTDRAG_COEFF( bi, bj, k, .TRUE.,
     I                  uFld, vFld, kappaRV, KE,
     O                  cDrag,
     I                  myIter, myThid )
#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE cDrag(:,:) = comlev1_bibj_k, key = kkey, byte = isbyte
#endif
        DO j=jMin,jMax
         DO i=iMin,iMax
           vF(i,j) = -cDrag(i,j)*vFld(i,j)
     &             *_recip_hFacS(i,j,k,bi,bj)*recip_drF(k)
           gvDiss(i,j) = gvDiss(i,j) + vF(i,j)
         ENDDO
        ENDDO
        IF ( useDiagnostics ) THEN
         DO j=jMin,jMax
          DO i=iMin,iMax
           botDragV(i,j,bi,bj) = botDragV(i,j,bi,bj)
     &                         - cDrag(i,j)*vFld(i,j)*rUnit2mass
          ENDDO
         ENDDO
        ENDIF
#if ( defined ALLOW_MOM_TEND_EXTRA_DIAGS && defined ALLOW_DIAGNOSTICS )
        IF ( botDragDiagIsOn ) THEN
         CALL DIAGNOSTICS_FILL( vF, 'VBotDrag', k,1,2,bi,bj, myThid )
        ENDIF
#endif /* ALLOW_MOM_TEND_EXTRA_DIAGS && ALLOW_DIAGNOSTICS */
       ENDIF
#ifdef ALLOW_SHELFICE
       IF ( useShelfIce .AND. selectImplicitDrag.EQ.0 ) THEN
#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE KE(:,:) = comlev1_bibj_k, key = kkey, byte = isbyte
#endif
        CALL SHELFICE_V_DRAG_COEFF( bi, bj, k, .TRUE.,
     I                  uFld, vFld, kappaRV, KE,
     O                  cDrag,
     I                  myIter, myThid )
#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE cDrag(:,:) = comlev1_bibj_k, key = kkey, byte = isbyte
#endif
        DO j=jMin,jMax
         DO i=iMin,iMax
           gvDiss(i,j) = gvDiss(i,j)
     &                 - cDrag(i,j)*vFld(i,j)
     &                 *_recip_hFacS(i,j,k,bi,bj)*recip_drF(k)
         ENDDO
        ENDDO
#if ( defined ALLOW_MOM_TEND_EXTRA_DIAGS && defined ALLOW_DIAGNOSTICS )
        IF ( shelfDragDiagIsOn ) THEN
         DO j=jMin,jMax
          DO i=iMin,iMax
           vrF(i,j) = -cDrag(i,j)*vFld(i,j)
     &              *_recip_hFacS(i,j,k,bi,bj)*recip_drF(k)
          ENDDO
         ENDDO
         CALL DIAGNOSTICS_FILL( vrF, 'VShIDrag', k,1,2,bi,bj, myThid )
        ENDIF
#endif /* ALLOW_MOM_TEND_EXTRA_DIAGS && ALLOW_DIAGNOSTICS */
       ENDIF
#endif /* ALLOW_SHELFICE */

C--   if (momViscosity) end of block.
      ENDIF

C-    Return to standard hfacZ (min-4) and mask vort3 accordingly:
c     CALL MOM_VI_MASK_VORT3(bi,bj,k,hFacZ,r_hFacZ,vort3,myThid)

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C---  Prepare for Advection & Coriolis terms:
C-    calculate absolute vorticity
      IF (useAbsVorticity)
     &  CALL MOM_CALC_ABSVORT3(bi,bj,k,vort3,omega3,myThid)

#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE omega3(:,:) = comlev1_bibj_k, key = kkey, byte = isbyte
#endif

C--   Horizontal Coriolis terms
c     IF (useCoriolis .AND. .NOT.useCDscheme
c    &    .AND. .NOT. useAbsVorticity) THEN
C- jmc: change it to keep the Coriolis terms when useAbsVorticity=T & momAdvection=F
      IF ( useCoriolis .AND.
     &     .NOT.( useCDscheme .OR. useAbsVorticity.AND.momAdvection )
     &   ) THEN
       IF (useAbsVorticity) THEN
        CALL MOM_VI_U_CORIOLIS(bi,bj,k,selectVortScheme,useJamartMomAdv,
     &                         vFld,omega3,hFacZ,r_hFacZ,
     &                         uCf,myThid)
        CALL MOM_VI_V_CORIOLIS(bi,bj,k,selectVortScheme,useJamartMomAdv,
     &                         uFld,omega3,hFacZ,r_hFacZ,
     &                         vCf,myThid)
#if ( defined ALLOW_GGL90 && defined ALLOW_GGL90_LANGMUIR )
       ELSEIF ( useLANGMUIR ) THEN
        CALL GGL90_ADD_STOKESDRIFT(
     O                 uRes, vRes,
     I                 uFld, vFld, k, bi, bj, myThid )
        CALL MOM_VI_CORIOLIS(bi,bj,k,uRes,vRes,hFacZ,r_hFacZ,
     &                       uCf,vCf,myThid)
#endif
       ELSE
        CALL MOM_VI_CORIOLIS(bi,bj,k,uFld,vFld,hFacZ,r_hFacZ,
     &                       uCf,vCf,myThid)
       ENDIF
       DO j=jMin,jMax
        DO i=iMin,iMax
         gU(i,j,k,bi,bj) = uCf(i,j)
         gV(i,j,k,bi,bj) = vCf(i,j)
        ENDDO
       ENDDO
       IF ( writeDiag ) THEN
         IF (snapshot_mdsio) THEN
           CALL WRITE_LOCAL_RL('fV','I10',1,uCf,bi,bj,k,myIter,myThid)
           CALL WRITE_LOCAL_RL('fU','I10',1,vCf,bi,bj,k,myIter,myThid)
         ENDIF
#ifdef ALLOW_MNC
         IF (useMNC .AND. snapshot_mnc) THEN
           CALL MNC_CW_RL_W_OFFSET(pf,'mom_vi',bi,bj, 'fV', uCf,
     &          offsets, myThid)
           CALL MNC_CW_RL_W_OFFSET(pf,'mom_vi',bi,bj, 'fU', vCf,
     &          offsets, myThid)
         ENDIF
#endif /*  ALLOW_MNC  */
       ENDIF
#ifdef ALLOW_DIAGNOSTICS
       IF ( useDiagnostics ) THEN
         CALL DIAGNOSTICS_FILL(uCf,'Um_Cori ',k,1,2,bi,bj,myThid)
         CALL DIAGNOSTICS_FILL(vCf,'Vm_Cori ',k,1,2,bi,bj,myThid)
       ENDIF
#endif /* ALLOW_DIAGNOSTICS */
      ELSE
       DO j=jMin,jMax
        DO i=iMin,iMax
         gU(i,j,k,bi,bj) = 0. _d 0
         gV(i,j,k,bi,bj) = 0. _d 0
        ENDDO
       ENDDO
      ENDIF

#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE ucf(:,:) = comlev1_bibj_k, key = kkey, byte = isbyte
CADJ STORE vcf(:,:) = comlev1_bibj_k, key = kkey, byte = isbyte
#endif

      IF (momAdvection) THEN
C--   Horizontal advection of relative (or absolute) vorticity
       IF ( (highOrderVorticity.OR.upwindVorticity)
     &     .AND.useAbsVorticity ) THEN
        CALL MOM_VI_U_CORIOLIS_C4(bi,bj,k,selectVortScheme,
     &                         highOrderVorticity,upwindVorticity,
     &                         vFld,omega3,r_hFacZ,
     &                         uCf,myThid)
       ELSEIF ( (highOrderVorticity.OR.upwindVorticity) ) THEN
        CALL MOM_VI_U_CORIOLIS_C4(bi,bj,k,selectVortScheme,
     &                         highOrderVorticity, upwindVorticity,
     &                         vFld,vort3, r_hFacZ,
     &                         uCf,myThid)
       ELSEIF ( useAbsVorticity ) THEN
        CALL MOM_VI_U_CORIOLIS(bi,bj,k,selectVortScheme,useJamartMomAdv,
     &                         vFld,omega3,hFacZ,r_hFacZ,
     &                         uCf,myThid)
       ELSE
        CALL MOM_VI_U_CORIOLIS(bi,bj,k,selectVortScheme,useJamartMomAdv,
     &                         vFld,vort3, hFacZ,r_hFacZ,
     &                         uCf,myThid)
       ENDIF
       DO j=jMin,jMax
        DO i=iMin,iMax
         gU(i,j,k,bi,bj) = gU(i,j,k,bi,bj)+uCf(i,j)
        ENDDO
       ENDDO
       IF ( (highOrderVorticity.OR.upwindVorticity)
     &     .AND.useAbsVorticity ) THEN
        CALL MOM_VI_V_CORIOLIS_C4(bi,bj,k,selectVortScheme,
     &                         highOrderVorticity, upwindVorticity,
     &                         uFld,omega3,r_hFacZ,
     &                         vCf,myThid)
       ELSEIF ( (highOrderVorticity.OR.upwindVorticity) ) THEN
        CALL MOM_VI_V_CORIOLIS_C4(bi,bj,k,selectVortScheme,
     &                         highOrderVorticity, upwindVorticity,
     &                         uFld,vort3, r_hFacZ,
     &                         vCf,myThid)
       ELSEIF ( useAbsVorticity ) THEN
        CALL MOM_VI_V_CORIOLIS(bi,bj,k,selectVortScheme,useJamartMomAdv,
     &                         uFld,omega3,hFacZ,r_hFacZ,
     &                         vCf,myThid)
       ELSE
        CALL MOM_VI_V_CORIOLIS(bi,bj,k,selectVortScheme,useJamartMomAdv,
     &                         uFld,vort3, hFacZ,r_hFacZ,
     &                         vCf,myThid)
       ENDIF
       DO j=jMin,jMax
        DO i=iMin,iMax
         gV(i,j,k,bi,bj) = gV(i,j,k,bi,bj)+vCf(i,j)
        ENDDO
       ENDDO

#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE ucf(:,:) = comlev1_bibj_k, key = kkey, byte = isbyte
CADJ STORE vcf(:,:) = comlev1_bibj_k, key = kkey, byte = isbyte
#endif

       IF ( writeDiag ) THEN
         IF (snapshot_mdsio) THEN
           CALL WRITE_LOCAL_RL('zV','I10',1,uCf,bi,bj,k,myIter,myThid)
           CALL WRITE_LOCAL_RL('zU','I10',1,vCf,bi,bj,k,myIter,myThid)
         ENDIF
#ifdef ALLOW_MNC
         IF (useMNC .AND. snapshot_mnc) THEN
           CALL MNC_CW_RL_W_OFFSET(pf,'mom_vi',bi,bj, 'zV', uCf,
     &          offsets, myThid)
           CALL MNC_CW_RL_W_OFFSET(pf,'mom_vi',bi,bj, 'zU', vCf,
     &          offsets, myThid)
         ENDIF
#endif /*  ALLOW_MNC  */
       ENDIF

#ifdef ALLOW_DIAGNOSTICS
       IF ( useDiagnostics ) THEN
         CALL DIAGNOSTICS_FILL(uCf,'Um_AdvZ3',k,1,2,bi,bj,myThid)
         CALL DIAGNOSTICS_FILL(vCf,'Vm_AdvZ3',k,1,2,bi,bj,myThid)
       ENDIF
#endif /* ALLOW_DIAGNOSTICS */

C--   Vertical shear terms (-w*du/dr & -w*dv/dr)
       IF ( .NOT. momImplVertAdv ) THEN
        CALL MOM_VI_U_VERTSHEAR( bi, bj, k, deepFacAdv,
     &                           uVel, wVel, uCf, myThid )
        DO j=jMin,jMax
         DO i=iMin,iMax
          gU(i,j,k,bi,bj) = gU(i,j,k,bi,bj)+uCf(i,j)
         ENDDO
        ENDDO
        CALL MOM_VI_V_VERTSHEAR( bi, bj, k, deepFacAdv,
     &                           vVel, wVel, vCf, myThid )
        DO j=jMin,jMax
         DO i=iMin,iMax
          gV(i,j,k,bi,bj) = gV(i,j,k,bi,bj)+vCf(i,j)
         ENDDO
        ENDDO
#ifdef ALLOW_DIAGNOSTICS
        IF ( useDiagnostics ) THEN
         CALL DIAGNOSTICS_FILL(uCf,'Um_AdvRe',k,1,2,bi,bj,myThid)
         CALL DIAGNOSTICS_FILL(vCf,'Vm_AdvRe',k,1,2,bi,bj,myThid)
        ENDIF
#endif /* ALLOW_DIAGNOSTICS */
       ENDIF

C--   Bernoulli term
       CALL MOM_VI_U_GRAD_KE(bi,bj,k,KE,uCf,myThid)
       DO j=jMin,jMax
        DO i=iMin,iMax
         gU(i,j,k,bi,bj) = gU(i,j,k,bi,bj)+uCf(i,j)
        ENDDO
       ENDDO
       CALL MOM_VI_V_GRAD_KE(bi,bj,k,KE,vCf,myThid)
       DO j=jMin,jMax
        DO i=iMin,iMax
         gV(i,j,k,bi,bj) = gV(i,j,k,bi,bj)+vCf(i,j)
        ENDDO
       ENDDO
       IF ( writeDiag ) THEN
         IF (snapshot_mdsio) THEN
           CALL WRITE_LOCAL_RL('KEx','I10',1,uCf,bi,bj,k,myIter,myThid)
           CALL WRITE_LOCAL_RL('KEy','I10',1,vCf,bi,bj,k,myIter,myThid)
         ENDIF
#ifdef ALLOW_MNC
         IF (useMNC .AND. snapshot_mnc) THEN
           CALL MNC_CW_RL_W_OFFSET(pf,'mom_vi',bi,bj, 'KEx', uCf,
     &          offsets, myThid)
           CALL MNC_CW_RL_W_OFFSET(pf,'mom_vi',bi,bj, 'KEy', vCf,
     &          offsets, myThid)
         ENDIF
#endif /*  ALLOW_MNC  */
       ENDIF

C--   end if momAdvection
      ENDIF

C--   3.D Coriolis term (horizontal momentum, Eastward component: -fprime*w)
      IF ( select3dCoriScheme.GE.1 ) THEN
        CALL MOM_U_CORIOLIS_NH(bi,bj,k,wVel,uCf,myThid)
        DO j=jMin,jMax
         DO i=iMin,iMax
          gU(i,j,k,bi,bj) = gU(i,j,k,bi,bj)+uCf(i,j)
         ENDDO
        ENDDO
       IF ( usingCurvilinearGrid .OR. rotateGrid ) THEN
C-     presently, non zero angleSinC array only supported with Curvilinear-Grid
        CALL MOM_V_CORIOLIS_NH(bi,bj,k,wVel,vCf,myThid)
        DO j=jMin,jMax
         DO i=iMin,iMax
          gV(i,j,k,bi,bj) = gV(i,j,k,bi,bj)+vCf(i,j)
         ENDDO
        ENDDO
       ENDIF
      ENDIF

C--   Non-Hydrostatic (spherical) metric terms
#ifdef MOM_USE_OLD_DEEP_VERT_ADV
      IF ( useNHMTerms ) THEN
#else
      IF ( useNHMTerms .AND. .NOT.deepAtmosphere ) THEN
#endif
       CALL MOM_U_METRIC_NH(bi,bj,k,uFld,wVel,uCf,myThid)
       CALL MOM_V_METRIC_NH(bi,bj,k,vFld,wVel,vCf,myThid)
       DO j=jMin,jMax
        DO i=iMin,iMax
         gU(i,j,k,bi,bj) = gU(i,j,k,bi,bj) + uCf(i,j)
         gV(i,j,k,bi,bj) = gV(i,j,k,bi,bj) + vCf(i,j)
        ENDDO
       ENDDO
#ifdef ALLOW_DIAGNOSTICS
       IF ( useDiagnostics ) THEN
        CALL DIAGNOSTICS_FILL( uCf, 'Um_Metr ', k,1,2, bi,bj, myThid )
        CALL DIAGNOSTICS_FILL( vCf, 'Vm_Metr ', k,1,2, bi,bj, myThid )
       ENDIF
#endif /* ALLOW_DIAGNOSTICS */
      ENDIF

C--   Set du/dt & dv/dt on boundaries to zero
      DO j=jMin,jMax
       DO i=iMin,iMax
        gU(i,j,k,bi,bj) = gU(i,j,k,bi,bj)*_maskW(i,j,k,bi,bj)
        gV(i,j,k,bi,bj) = gV(i,j,k,bi,bj)*_maskS(i,j,k,bi,bj)
       ENDDO
      ENDDO

#ifdef ALLOW_DEBUG
      IF ( debugLevel .GE. debLevC
     &   .AND. k.EQ.4 .AND. myIter.EQ.nIter0
     &   .AND. nPx.EQ.1 .AND. nPy.EQ.1
     &   .AND. useCubedSphereExchange ) THEN
        CALL DEBUG_CS_CORNER_UV( ' uDiss,vDiss from MOM_VECINV',
     &             guDiss,gvDiss, k, standardMessageUnit,bi,bj,myThid )
      ENDIF
#endif /* ALLOW_DEBUG */

      IF ( writeDiag ) THEN
        IF (useBiharmonicVisc) THEN
         CALL WRITE_LOCAL_RL( 'del2u', 'I10', 1, del2u,
     &                        bi,bj,k, myIter, myThid )
         CALL WRITE_LOCAL_RL( 'del2v', 'I10', 1, del2v,
     &                        bi,bj,k, myIter, myThid )
         CALL WRITE_LOCAL_RL( 'dStar', 'I10', 1, dStar,
     &                        bi,bj,k, myIter, myThid )
         CALL WRITE_LOCAL_RL( 'zStar', 'I10', 1, zStar,
     &                        bi,bj,k, myIter, myThid )
        ENDIF
        IF (snapshot_mdsio) THEN
         CALL WRITE_LOCAL_RL('W3','I10',1,omega3, bi,bj,k,myIter,myThid)
         CALL WRITE_LOCAL_RL('Z3','I10',1,vort3BC,bi,bj,k,myIter,myThid)
         CALL WRITE_LOCAL_RL('KE','I10',1,KE,     bi,bj,k,myIter,myThid)
         CALL WRITE_LOCAL_RL('D', 'I10',1,hDiv,   bi,bj,k,myIter,myThid)
         CALL WRITE_LOCAL_RL('Dt','I10',1,tension,bi,bj,k,myIter,myThid)
         CALL WRITE_LOCAL_RL( 'Ds', 'I10', 1, strainBC,
     &                        bi,bj,k, myIter, myThid )
         CALL WRITE_LOCAL_RL('Du','I10',1,guDiss, bi,bj,k,myIter,myThid)
         CALL WRITE_LOCAL_RL('Dv','I10',1,gvDiss, bi,bj,k,myIter,myThid)
        ENDIF
#ifdef ALLOW_MNC
        IF (useMNC .AND. snapshot_mnc) THEN
          CALL MNC_CW_RL_W_OFFSET(pf,'mom_vi',bi,bj,'W3',omega3,
     &          offsets, myThid)
          CALL MNC_CW_RL_W_OFFSET(pf,'mom_vi',bi,bj,'Z3',vort3BC,
     &          offsets, myThid)
          CALL MNC_CW_RL_W_OFFSET(pf,'mom_vi',bi,bj,'KE',KE,
     &          offsets, myThid)
          CALL MNC_CW_RL_W_OFFSET(pf,'mom_vi',bi,bj,'D', hDiv,
     &          offsets, myThid)
          CALL MNC_CW_RL_W_OFFSET(pf,'mom_vi',bi,bj,'Dt',tension,
     &          offsets, myThid)
          CALL MNC_CW_RL_W_OFFSET(pf,'mom_vi',bi,bj,'Ds',strainBC,
     &          offsets, myThid)
          CALL MNC_CW_RL_W_OFFSET(pf,'mom_vi',bi,bj,'Du',guDiss,
     &          offsets, myThid)
          CALL MNC_CW_RL_W_OFFSET(pf,'mom_vi',bi,bj,'Dv',gvDiss,
     &          offsets, myThid)
        ENDIF
#endif /*  ALLOW_MNC  */
      ENDIF

#ifdef ALLOW_DIAGNOSTICS
      IF ( useDiagnostics ) THEN
        CALL DIAGNOSTICS_FILL(vort3BC,'momVort3',k,1,2,bi,bj,myThid)
        CALL DIAGNOSTICS_FILL(KE,     'momKE   ',k,1,2,bi,bj,myThid)
       IF (momViscosity) THEN
        CALL DIAGNOSTICS_FILL(hDiv,   'momHDiv ',k,1,2,bi,bj,myThid)
       ENDIF
       IF ( useVariableVisc .OR. useStrainTensionVisc ) THEN
        CALL DIAGNOSTICS_FILL(tension, 'Tension ',k,1,2,bi,bj,myThid)
        CALL DIAGNOSTICS_FILL(strainBC,'Strain  ',k,1,2,bi,bj,myThid)
C         stretching will be zero, unless using QG Leith
        IF ( viscC2LeithQG.NE.zeroRL ) THEN
          CALL DIAGNOSTICS_FILL(stretching,
     I                          'Stretch ',k,1,2,bi,bj,myThid)
        ENDIF
       ENDIF
        CALL DIAGNOSTICS_FILL(gU(1-OLx,1-OLy,k,bi,bj),
     &                                'Um_Advec',k,1,2,bi,bj,myThid)
        CALL DIAGNOSTICS_FILL(gV(1-OLx,1-OLy,k,bi,bj),
     &                                'Vm_Advec',k,1,2,bi,bj,myThid)
      ENDIF
#endif /* ALLOW_DIAGNOSTICS */

#endif /* ALLOW_MOM_VECINV */

      RETURN
      END

#include "THSICE_OPTIONS.h"

CBOP
C     !ROUTINE: THSICE_INIT_FIXED
C     !INTERFACE:
      SUBROUTINE THSICE_INIT_FIXED( myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE THSICE_INIT_FIXED
C     | o Routine to initialize THSICE variables 
C     |   that are kept fixed during the run.
C     *==========================================================*
C     \ev
C     !USES:
      IMPLICIT NONE

C     === Global variables ===
#include "EEPARAMS.h"
#include "SIZE.h"
#include "PARAMS.h"
c #include "THSICE_PARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
C     myThid ::  my thread Id number
      INTEGER myThid
CEOP

C     !LOCAL VARIABLES:
C     === Local variables ===

#ifdef ALLOW_MNC
      IF ( useMNC ) THEN
        CALL THSICE_MNC_INIT( myThid )
      ENDIF
#endif

#ifdef ALLOW_DIAGNOSTICS
      IF ( useDiagnostics ) THEN
        CALL THSICE_DIAGNOSTICS_INIT( myThid )
      ENDIF
#endif

      RETURN
      END

#include "GAD_OPTIONS.h"

      SUBROUTINE GAD_OS7MP_ADV_X(
     I           bi,bj,k, calcCFL, deltaTloc,
     I           uTrans, uFld,
     I           maskLocW, Q,
     O           uT,
     I           myThid )
C     /==========================================================\
C     | SUBROUTINE GAD_OS7MP_ADV_X                               |
C     | o Compute Zonal advective Flux of tracer Q using         |
C     |   7th Order DST Sceheme with monotone preserving limiter |
C     |==========================================================|
      IMPLICIT NONE

C     == GLobal variables ==
#include "SIZE.h"
#include "GRID.h"
#include "GAD.h"

C     == Routine arguments ==
      INTEGER bi,bj,k
      LOGICAL calcCFL
      _RL deltaTloc
      _RL uTrans(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL uFld  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RS maskLocW(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL Q     (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL uT    (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER myThid

C     == Local variables ==
      INTEGER i,j
      _RL cfl,Psi
      _RL uLoc,Fac,DelIp,DelI,Phi,Eps,rp1h,rp1h_cfl
      _RL recip_DelIp, recip_DelI
      _RL Qippp,Qipp,Qip,Qi,Qim,Qimm,Qimmm
      _RL MskIpp,MskIp,MskI,MskIm,MskImm,MskImmm
      _RL d2,d2p1,d2m1,A,B,C,D
      _RL dp1h,dm1h, PhiMD,PhiLC,PhiMin,PhiMax
      _RL DelM,DelP,DelMM,DelPP,DelMMM,DelPPP
      _RL Del2MM,Del2M,Del2,Del2P,Del2PP
      _RL Del3MM,Del3M,Del3P,Del3PP
      _RL Del4M,Del4,Del4P
      _RL Del5M,Del5P
      _RL Del6

      Eps = 1. _d -20

      DO j=1-OLy,sNy+OLy
       uT(1-OLx,j)=0. _d 0
       uT(2-OLx,j)=0. _d 0
       uT(3-OLx,j)=0. _d 0
       uT(4-OLx,j)=0. _d 0
       uT(sNx+OLx-2,j)=0. _d 0
       uT(sNx+OLx-1,j)=0. _d 0
       uT(sNx+OLx,j)=0. _d 0
      ENDDO
      DO j=1-OLy,sNy+OLy
       DO i=1-OLx+4,sNx+OLx-3

        uLoc = uFld(i,j)
        cfl = uLoc
        IF ( calcCFL ) cfl = abs(uLoc*deltaTloc*recip_dxC(i,j,bi,bj))

        IF (uTrans(i,j).GT.0. _d 0) THEN
         Qippp = Q(i+2,j)
         Qipp  = Q(i+1,j)
         Qip   = Q(i,j)
         Qi    = Q(i-1,j)
         Qim   = Q(i-2,j)
         Qimm  = Q(i-3,j)
         Qimmm = Q(i-4,j)

         MskIpp  = maskLocW(i+2,j)
         MskIp   = maskLocW(i+1,j)
         MskI    = maskLocW(i,j)
         MskIm   = maskLocW(i-1,j)
         MskImm  = maskLocW(i-2,j)
         MskImmm = maskLocW(i-3,j)
        ELSEIF (uTrans(i,j).LT.0. _d 0) THEN
         Qippp = Q(i-3,j)
         Qipp  = Q(i-2,j)
         Qip   = Q(i-1,j)
         Qi    = Q(i,j)
         Qim   = Q(i+1,j)
         Qimm  = Q(i+2,j)
         Qimmm = Q(i+3,j)

         MskIpp  = maskLocW(i-2,j)
         MskIp   = maskLocW(i-1,j)
         MskI    = maskLocW(i,j)
         MskIm   = maskLocW(i+1,j)
         MskImm  = maskLocW(i+2,j)
         MskImmm = maskLocW(i+3,j)
        ELSE
         Qippp = 0. _d 0
         Qipp  = 0. _d 0
         Qip   = 0. _d 0
         Qi    = 0. _d 0
         Qim   = 0. _d 0
         Qimm  = 0. _d 0
         Qimmm = 0. _d 0

         MskIpp  = 0. _d 0
         MskIp   = 0. _d 0
         MskI    = 0. _d 0
         MskIm   = 0. _d 0
         MskImm  = 0. _d 0
         MskImmm = 0. _d 0
        ENDIF

        IF (uTrans(i,j).NE.0. _d 0) THEN
C        2nd order correction [i i-1]
         Fac = 1. _d 0
         DelP = (Qip-Qi)*MskI
         Phi = Fac * DelP
C        3rd order correction [i i-1 i-2]
         Fac = Fac * ( cfl + 1. _d 0 )/3. _d 0
         DelM = (Qi-Qim)*MskIm
         Del2 = DelP - DelM
         Phi = Phi - Fac * Del2
C        4th order correction [i+1 i i-1 i-2]
         Fac = Fac * ( cfl - 2. _d 0 )/4. _d 0
         DelPP = (Qipp-Qip)*MskIp*MskI
         Del2P = DelPP - DelP
         Del3P = Del2P - Del2
         Phi = Phi + Fac * Del3p
C        5th order correction [i+1 i i-1 i-2 i-3]
         Fac = Fac * ( cfl - 3. _d 0 )/5. _d 0
         DelMM = (Qim-Qimm)*MskImm*MskIm
         Del2M = DelM - DelMM
         Del3M = Del2 - Del2M
         Del4 = Del3P - Del3M
         Phi = Phi + Fac * Del4
C        6th order correction [i+2 i+1 i i-1 i-2 i-3]
         Fac = Fac * ( cfl + 2. _d 0 )/6. _d 0
         DelPPP = (Qippp-Qipp)*MskIpp*MskIp*MskI
         Del2PP = DelPP - DelP
         Del3PP = Del2PP - Del2P
         Del4P = Del3PP - Del3P
         Del5P = Del4P - Del4
         Phi = Phi + Fac * Del5P
C        7th order correction [i+2 i+1 i i-1 i-2 i-3 i-4]
         Fac = Fac * ( cfl + 2. _d 0 )/7. _d 0
         DelMMM = (Qimm-Qimmm)*MskImmm*MskImm*MskIm
         Del2MM = DelMM - DelMMM
         Del3MM = Del2M - Del2MM
         Del4M = Del3M - Del3MM
         Del5M = Del4 - Del4M
         Del6 = Del5P - Del5M
         Phi = Phi - Fac * Del6

         DelIp = ( Qip - Qi ) * MskI
c        Phi = sign(1. _d 0,Phi)*sign(1. _d 0,DelIp)
c    &        *abs(Phi+Eps)/abs(DelIp+Eps)
C--   simplify and avoid division by zero
         recip_DelIp = sign(1. _d 0,DelIp)/max(abs(DelIp),Eps)
         Phi = Phi*recip_DelIp

         DelI = ( Qi - Qim ) * MskIm
c        rp1h =sign(1. _d 0,DelI)*sign(1. _d 0,DelIp)
c    &        *abs(DelI+Eps)/abs(DelIp+Eps)
C--   simplify and avoid division by zero
         recip_DelI = sign(1. _d 0,DelI)/max(abs(DelI),Eps)
         rp1h = DelI*recip_DelIp
         rp1h_cfl = rp1h/(cfl+Eps)

C        TVD limiter
c        Phi = max(0. _d 0, min( 2./(1-cfl), Phi, 2.*rp1h_cfl ) )

C        MP limiter
         d2   = Del2 !( ( Qip + Qim ) - 2.*Qi  ) * MskI * MskIm
         d2p1 = Del2P !( ( Qipp + Qi ) - 2.*Qip ) * MskIp * MskI
         d2m1 = Del2M !( ( Qi + Qimm ) - 2.*Qim ) * MskIm * MskImm
         A = 4. _d 0*d2 - d2p1
         B = 4. _d 0*d2p1 - d2
         C = d2
         D = d2p1
         dp1h = max(min(min(A,B),min(C,D)),0. _d 0)
     &        + min(max(max(A,B),max(C,D)),0. _d 0)
         A = 4. _d 0*d2m1 - d2
         B = 4. _d 0*d2 - d2m1
         C = d2m1
         D = d2
         dm1h = max(min(min(A,B),min(C,D)),0. _d 0)
     &        + min(max(max(A,B),max(C,D)),0. _d 0)
c        qMD = 0.5*( ( Qi + Qip ) - dp1h )
c        qMD = 0.5 _d 0*( ( 2. _d 0*Qi + DelIp ) - dp1h )
c        qUL = Qi + (1. _d 0-cfl)/(cfl+Eps)*DelI
c        qLC = Qi + 0.5 _d 0*( 1. _d 0+dm1h/(DelI+Eps) )*(qUL-Qi)
c        PhiMD = 2. _d 0/(1. _d 0-cfl)*(qMD-Qi+Eps)/(DelIp+Eps)
c        PhiLC = 2. _d 0*rp1h_cfl*(qLC-Qi+Eps)/(qUL-Qi+Eps)
C--   simplify and avoid division by zero
         PhiMD = 1. _d 0/(1. _d 0-cfl)*(DelIp-dp1h)*recip_DelIp
         PhiLC = rp1h_cfl*( 1. _d 0+dm1h*recip_DelI )
C--
         PhiMin = max( min(0. _d 0,PhiMD),
     &                 min(min(0. _d 0,2. _d 0*rp1h_cfl),PhiLC) )
         PhiMax = min( max(2. _d 0/(1. _d 0-cfl),PhiMD),
     &                 max(max(0. _d 0,2. _d 0*rp1h_cfl),PhiLC) )
         Phi = max(PhiMin,min(Phi,PhiMax))

         Psi = Phi * 0.5 _d 0 * (1. _d 0 - cfl)
         uT(i,j) = uTrans(i,j)*( Qi + Psi*DelIp )
        ELSE
         uT(i,j) = 0. _d 0
        ENDIF

       ENDDO
      ENDDO

      RETURN
      END

#include "DIAG_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 0
C     !ROUTINE: DIAGNOSTICS_INIT_FIXED

C     !INTERFACE:
      SUBROUTINE DIAGNOSTICS_INIT_FIXED(myThid)

C     !DESCRIPTION:
C     finish setting up the list of available diagnostics and
C     prepare for storing selected diagnostics and statistics-diags.

C     !USES:
      IMPLICIT NONE
#include "EEPARAMS.h"
#include "SIZE.h"
#include "DIAGNOSTICS_SIZE.h"
#include "DIAGNOSTICS.h"
#ifdef ALLOW_FIZHI
#include "PARAMS.h"
#endif

C     !INPUT PARAMETERS:
      INTEGER myThid
CEOP

C     !LOCAL VARIABLES:
c#ifdef ALLOW_DIVIDED_ADJOINT
      LOGICAL dummyBoolean
c#endif

C--   Set number of levels for all available diagnostics
C     (cannot add diags to list anymore after this call)
      CALL DIAGNOSTICS_SET_LEVELS( myThid )

C--   Calculate pointers for diagnostics set to non-zero frequency
      CALL DIAGNOSTICS_SET_POINTERS( myThid )

C--   Set parameters and variables used in post-processing diagnostics
      CALL DIAGNOSTICS_SET_CALC( myThid )

C--   Define region-mask for regional statistics diagnostics
      CALL DIAGSTATS_SET_REGIONS( myThid )

C--   Calculate pointers for statistics-diags set to non-zero frequency
      CALL DIAGSTATS_SET_POINTERS( myThid )

#ifdef ALLOW_FIZHI
      IF ( useFIZHI ) THEN
        CALL FIZHI_DIAGALARMS( myThid )
      ENDIF
#endif
c#ifdef ALLOW_DIVIDED_ADJOINT
      CALL DIAGS_TRACK_DIVA( dummyBoolean, -2, myThid )
c#endif

      RETURN
      END

#include "DIAG_OPTIONS.h"

CBOP 0
C     !ROUTINE: DIAGNOSTICS_SET_LEVELS

C     !INTERFACE:
      SUBROUTINE DIAGNOSTICS_SET_LEVELS( myThid )

C     !DESCRIPTION:
C     Initialize Diagnostic Levels, according to GDIAG
C      for all available diagnostics
C     Notes: needs to be called after all packages set they own available
C            diagnostics

C     \begin{center}
C       \begin{tabular}[h]{|c|c|}\hline
C         \textbf{Positions}  &  \textbf{Characters}
C         &  \textbf{Meanings} \\\hline
C         parse(10) &  0  &  levels = 0  \\
C                   &  1  &  levels = 1  \\
C                   &  R  &  levels = Nr  \\
C                   &  L  &  levels = MAX(Nr,NrPhys)  \\
C                   &  M  &  levels = MAX(Nr,NrPhys) - 1  \\
C                   &  G  &  levels = Ground_level Number \\
C                   &  I  &  levels = sea-Ice_level Number \\
C                   &  X  &  free levels option (need to be set explicitly) \\
C       \end{tabular}
C     \end{center}

C     !USES:
      IMPLICIT NONE

#include "SIZE.h"
#define SIZE_IS_SET
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "DIAGNOSTICS_SIZE.h"
#include "DIAGNOSTICS.h"

#ifdef ALLOW_FIZHI
#include "fizhi_SIZE.h"
#else
       INTEGER Nrphys
       PARAMETER (Nrphys=0)
#endif

#ifdef ALLOW_LAND
#include "LAND_SIZE.h"
#else
      INTEGER land_nLev
      PARAMETER ( land_nLev = 0 )
#endif

C     !INPUT PARAMETERS:
C     myThid :: my Thread Id number
      INTEGER myThid
CEOP

C     !LOCAL VARIABLES:
      INTEGER l, n, ncount
      INTEGER nlevs, nGroundLev
      INTEGER  dUnit, stdUnit
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      CHARACTER*84 ccHead, ccLine
      CHARACTER*10 gcode
      CHARACTER*1  g10code
      INTEGER  ILNBLNK
      EXTERNAL ILNBLNK

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      _BARRIER
      _BEGIN_MASTER( myThid )

C--   Diagnostics definition/setting ends (cannot add diags to list anymore)
c     IF ( diag_pkgStatus.NE.2 ) STOP
      diag_pkgStatus = 3

      nlevs   = MAX(Nr,Nrphys)
      nGroundLev = land_nLev

C     Diagnostic Levels
C     -----------------
      ncount = 0
      DO n = 1,ndiagt
        g10code = gdiag(n)(10:10)
        IF     ( g10code .EQ. '0' ) THEN
          kdiag(n) = 0
        ELSEIF ( g10code .EQ. '1' ) THEN
          kdiag(n) = 1
        ELSEIF ( g10code .EQ. 'R' ) THEN
          kdiag(n) = Nr
        ELSEIF ( g10code .EQ. 'L' ) THEN
          kdiag(n) = nlevs
        ELSEIF ( g10code .EQ. 'M' ) THEN
          kdiag(n) = nlevs - 1
        ELSEIF ( g10code .EQ. 'G' ) THEN
          kdiag(n) = nGroundLev
        ELSEIF ( g10code .EQ. 'g' ) THEN
          kdiag(n) = 1
        ELSEIF ( g10code .EQ. 'X' ) THEN
         IF ( kdiag(n) .LE. 0 ) THEN
          WRITE(msgBuf,'(2A,I4,3A)')
     &     '** WARNING ** DIAGNOSTICS_SET_LEVELS: ',
     &     'level Nb =', kdiag(n), ' < 1 for diag."', cdiag(n),'"'
          CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                        SQUEEZE_RIGHT , myThid )
         ENDIF
        ELSE
C-      enforce a strict matching:
          WRITE(msgBuf,'(2A,4A)') 'DIAGNOSTICS_SET_LEVELS: ',
     &     'invalid gdiag(10)="', g10code, '" code for diag."',
     &                            cdiag(n),'"'
          CALL PRINT_ERROR( msgBuf , myThid )
          ncount = ncount + 1
        ENDIF
      ENDDO
      IF ( ncount.GT.0 ) THEN
        WRITE(msgBuf,'(2A,I6,3A)') 'DIAGNOSTICS_SET_LEVELS: ',
     &   'found', ncount, ' invalid parser "gdiag(10)" => STOP'
        CALL PRINT_ERROR( msgBuf , myThid )
        STOP 'ABNORMAL END: S/R DIAGSTATS_SET_LEVELS'
      ENDIF

C--   Check for inconsistent diagnostic parser field
      ncount = 0
      DO n = 1,ndiagt
       gcode = gdiag(n)(1:10)
       IF ( ( gcode(3:3).EQ.'r' .OR. gcode(3:3).EQ.'R' )
     &                         .AND. gcode(10:10).NE.'R' ) THEN
        WRITE(msgBuf,'(2A,4A)') 'DIAGNOSTICS_SET_LEVELS: ',
     &   'inconsistent gdiag(3&10)="',gcode,'" for diag."',cdiag(n),'"'
        CALL PRINT_ERROR( msgBuf , myThid )
        ncount = ncount + 1
       ENDIF
      ENDDO
      IF ( ncount.GT.0 ) THEN
        WRITE(msgBuf,'(2A,I6,3A)') 'DIAGNOSTICS_SET_LEVELS: ',
     &   'found', ncount, ' inconsistent parser "gdiag" => STOP'
        CALL PRINT_ERROR( msgBuf , myThid )
        STOP 'ABNORMAL END: S/R DIAGSTATS_SET_LEVELS'
      ENDIF

C--   Check for unvalid diag.mate number
      ncount = 0
      DO n = 1,ndiagt
       IF ( hdiag(n).LT.0 .OR. hdiag(n).GT.ndiagt ) THEN
        WRITE(msgBuf,'(2A,I6,3A)') 'DIAGNOSTICS_SET_LEVELS: ',
     &    'unvalid mate number=',hdiag(n),' for diag."',cdiag(n),'"'
        CALL PRINT_ERROR( msgBuf , myThid )
        ncount = ncount + 1
       ENDIF
       gcode = gdiag(n)(1:10)
       IF ( ( gcode(5:5).EQ.'C' .OR. gcode(5:5).EQ.'P' )
     &                         .AND. hdiag(n).EQ.0 ) THEN
        WRITE(msgBuf,'(6A)') 'DIAGNOSTICS_SET_LEVELS: ',
     &    'mate number required for diag."',cdiag(n),
     &    '" (gdiag(5)=',gcode(5:5),')'
        CALL PRINT_ERROR( msgBuf , myThid )
        ncount = ncount + 1
       ENDIF
      ENDDO
      IF ( ncount.GT.0 ) THEN
        WRITE(msgBuf,'(2A,I6,3A)') 'DIAGNOSTICS_SET_LEVELS: ',
     &    'found', ncount, ' unvalid/missing mate number(s) => STOP'
        CALL PRINT_ERROR( msgBuf , myThid )
        STOP 'ABNORMAL END: S/R DIAGSTATS_SET_LEVELS'
      ENDIF

C--   Print to standard output
      stdUnit = standardMessageUnit
      WRITE(msgBuf,'(2A)')
     &   '------------------------------------------------------------'
      CALL PRINT_MESSAGE( msgBuf, stdUnit,SQUEEZE_RIGHT, myThid)
      WRITE(msgBuf,'(A)') 'DIAGNOSTICS_SET_LEVELS: done'
      CALL PRINT_MESSAGE( msgBuf, stdUnit,SQUEEZE_RIGHT, myThid)
      WRITE(msgBuf,'(A,I6)')
     &   ' Total Nb of available Diagnostics: ndiagt=', ndiagt
      CALL PRINT_MESSAGE( msgBuf, stdUnit,SQUEEZE_RIGHT, myThid)

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C     write a summary of the (long) list of all available diagnostics:
      IF ( diag_dBugLevel.GE.debLevA .AND. myProcId.EQ.0 ) THEN

        WRITE(msgBuf,'(2A)')
     &   ' write list of available Diagnostics to file: ',
     &   'available_diagnostics.log'
        CALL PRINT_MESSAGE( msgBuf, stdUnit,SQUEEZE_RIGHT, myThid)

        WRITE(ccHead,'(2A)')
     &   '  Num  |<-Name->|Levs|  mate |<- code ->|',
     &   '<--  Units   -->|<- Tile (max=80c)'
        DO l=1,LEN(ccLine)
         ccLine(l:l) = '-'
        ENDDO

        CALL MDSFINDUNIT( dUnit, myThid )
        OPEN(dUnit, file='available_diagnostics.log',
     &              status='unknown', form='formatted')
        WRITE(dUnit,'(A,I6)')
     &   ' Total Nb of available Diagnostics: ndiagt=', ndiagt
        WRITE(dUnit,'(A)') ccLine
        WRITE(dUnit,'(A)') ccHead
        WRITE(dUnit,'(A)') ccLine
        DO n=1,ndiagt
         IF ( MOD(n,100).EQ.0 ) THEN
           WRITE(dUnit,'(A)') ccLine
           WRITE(dUnit,'(A)') ccHead
           WRITE(dUnit,'(A)') ccLine
         ENDIF
         l = ILNBLNK(tdiag(n))
         gcode = gdiag(n)(1:10)
         IF ( hdiag(n).NE.0 .AND. l.GE.1 ) THEN
           WRITE(dUnit,'(I6,3A,I3,A,I6,6A)') n, ' |', cdiag(n), '|',
     &                 kdiag(n),' |', hdiag(n), ' |', gcode, '|',
     &                 udiag(n), '|', tdiag(n)(1:l)
         ELSEIF ( hdiag(n).NE.0 ) THEN
           WRITE(dUnit,'(I6,3A,I3,A,I6,6A)') n, ' |', cdiag(n), '|',
     &                 kdiag(n),' |', hdiag(n), ' |', gcode, '|',
     &                 udiag(n), '|'
         ELSEIF (l.GE.1) THEN
           WRITE(dUnit,'(I6,3A,I3,6A)')      n, ' |', cdiag(n), '|',
     &                 kdiag(n),' |       |',         gcode, '|',
     &                 udiag(n), '|', tdiag(n)(1:l)
         ELSE
           WRITE(dUnit,'(I6,3A,I3,6A)')      n, ' |', cdiag(n), '|',
     &                 kdiag(n),' |       |',         gcode, '|',
     &                 udiag(n), '|'
         ENDIF
        ENDDO
        WRITE(dUnit,'(A)') ccLine
        WRITE(dUnit,'(A)') ccHead
        WRITE(dUnit,'(A)') ccLine
        CLOSE(dUnit)

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
      ENDIF

C--   Check for multiple definition of the same diagnostic name
      DO n = 2,ndiagt
       IF ( cdiag(n).NE.blkName ) THEN
        DO l = 1,n-1
         IF ( cdiag(l).EQ.cdiag(n) ) THEN
            WRITE(msgBuf,'(4A)') 'DIAGNOSTICS_SET_LEVELS: ',
     &       'diag.Name: ',cdiag(n),' registered 2 times :'
            CALL PRINT_ERROR( msgBuf , myThid )
            WRITE(msgBuf,'(2A,I4,2A)') 'DIAGNOSTICS_SET_LEVELS: ',
     &       '1rst (l=', l, ' ), title= ',tdiag(l)
            CALL PRINT_ERROR( msgBuf , myThid )
            WRITE(msgBuf,'(2A,I4,2A)') 'DIAGNOSTICS_SET_LEVELS: ',
     &       ' 2nd (n=', n, ' ), title= ',tdiag(n)
            CALL PRINT_ERROR( msgBuf , myThid )
            STOP 'ABNORMAL END: S/R DIAGNOSTICS_SET_LEVELS'
         ENDIF
        ENDDO
       ENDIF
      ENDDO

C--   Check that number of levels to write (in data.diagnostics) does not
C     exceeds max size: nlevs=max(Nr,NrPhys)
C   note: max size of array to write has been changed to "numLevels",
C         so that this checking is no longer usefull since nlevels
C         cannot be larger than "numLevels" anyway.

      _END_MASTER( myThid )

C--   Everyone else must wait for the levels to be set
      _BARRIER

      RETURN
      END

#include "MONITOR_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 0
C     !ROUTINE: MON_ADVCFLW

C     !INTERFACE:
      SUBROUTINE MON_ADVCFLW(
     I     label, W, rDz, dT,
     I     myThid )

C     !DESCRIPTION:
C     Calculates maximum CFL number in the vertical direction.

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "MONITOR.h"

C     !INPUT PARAMETERS:
      CHARACTER*(*) label
      _RL W(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      _RS rDz(Nr)
      _RL dT
      INTEGER myThid
CEOP

C     !LOCAL VARIABLES:
      INTEGER bi,bj,I,J,K
      _RL tmpVal,theMax

      theMax=0.

      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        DO K=1,Nr
         DO J=1,sNy
          DO I=1,sNx
           tmpVal=abs(W(I,J,K,bi,bj))*rDz(K)*dT
           theMax=max(theMax,tmpVal)
          ENDDO
         ENDDO
        ENDDO
       ENDDO
      ENDDO
      _GLOBAL_MAX_RL(theMax,myThid)

      CALL MON_OUT_RL( label, theMax, mon_foot_max ,myThid)

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#include "SEAICE_OPTIONS.h"

      SUBROUTINE SEAICE_COST_INIT_FIXED( myThid )

C     ==================================================================
C     SUBROUTINE seaice_cost_init_fixed
C     ==================================================================
C
C     o Set contributions to the cost function and the cost function
C       itself to zero. The cost function and the individual contribu-
C       tions are defined in the header file "SEAICE_COST.h".
C
C     ==================================================================
C     SUBROUTINE seaice_cost_init_fixed
C     ==================================================================

      IMPLICIT NONE

C     == global variables ==
#include "EEPARAMS.h"
#include "SIZE.h"
#include "PARAMS.h"
#ifdef ALLOW_COST
# include "SEAICE_COST.h"
#endif
#ifdef ALLOW_CAL
# include "cal.h"
#endif

C     == routine arguments ==
      INTEGER myThid

#if (defined ALLOW_COST && defined ALLOW_COST_ICE)
#ifdef ALLOW_CAL
C     == local variables ==
      INTEGER tempDate1(4)
      INTEGER tempDate2(4)
C     == end of interface ==

      _BEGIN_MASTER( myThid )

      IF ( useCAL ) THEN
C--   Sea-ice cost function start and stop times in model seconds.
        CALL cal_FullDate  ( costIceStart1 , costIceStart2,
     &                       tempDate1     , myThid )
        CALL cal_TimePassed( modelStartDate, tempDate1    ,
     &                       tempDate2     , myThid )
        CALL cal_ToSeconds ( tempDate2 , costIceStart , myThid )
        costIceStart = costIceStart + startTime

        IF ( costIceEnd1.EQ.0 ) THEN
C-      use "modelEndDate" as default value for costIceEnd
          costIceEnd1 = modelEndDate(1)
          costIceEnd2 = modelEndDate(2)
        ENDIF
        CALL cal_FullDate  ( costIceEnd1   , costIceEnd2  ,
     &                       tempDate1     , myThid )
        CALL cal_TimePassed( modelStartDate, tempDate1    ,
     &                       tempDate2     , myThid )
        CALL cal_ToSeconds ( tempDate2 , costIceEnd , myThid )
        costIceEnd = costIceEnd + startTime
C--
      ENDIF
      _END_MASTER( myThid )

      _BARRIER

#endif /* ALLOW_CAL */
#endif /* ALLOW_COST and ALLOW_COST_ICE */

      RETURN
      END

#include "MOM_FLUXFORM_OPTIONS.h"

CBOP
C !ROUTINE: MOM_V_METRIC_SPHERE

C !INTERFACE: ==========================================================
      SUBROUTINE MOM_V_METRIC_SPHERE(
     I        bi, bj, k,
     I        uFld,
     O        vMetricTerms,
     I        myThid )

C !DESCRIPTION:
C Calculates the meridional metric term due to sphericity:
C \begin{equation}
C \frac{1}{a} \overline{u}^{ij} \overline{u}^{ij} \tan{\phi}
C \end{equation}

C !USES: ===============================================================`
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"

C !INPUT PARAMETERS: ===================================================
C  bi, bj               :: tile indices
C  k                    :: vertical level
C  uFld                 :: zonal velocity
C  myThid               :: my Thread Id number
      INTEGER bi, bj, k
      _RL uFld(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER myThid

C !OUTPUT PARAMETERS: ==================================================
C  vMetricTerms         :: metric term
      _RL vMetricTerms(1-OLx:sNx+OLx,1-OLy:sNy+OLy)

C !LOCAL VARIABLES: ====================================================
C  i, j                 :: loop indices
      INTEGER i, j
CEOP

      IF ( selectMetricTerms.EQ.1 ) THEN
C-    Use analytical expression for tan(Phi) (stored in: tanPhiAtV)
        DO j=1-OLx+1,sNy+OLy
         DO i=1-OLx,sNx+OLx-1
           vMetricTerms(i,j) = -recip_rSphere*recip_deepFacC(k)
     &      *0.25 _d 0*( uFld(i,j  ) + uFld(i+1,j  )
     &                 + uFld(i,j-1) + uFld(i+1,j-1)
     &                 )
     &      *0.25 _d 0*( uFld(i,j  ) + uFld(i+1,j  )
     &                 + uFld(i,j-1) + uFld(i+1,j-1)
     &                 )
     &      *_tanPhiAtV(i,j,bi,bj)
         ENDDO
        ENDDO
      ELSE
C-    Using grid-spacing gradient: estimates tan(Phi)/rSphere as -del^j(dxC)/rAz
        DO j=2-OLx,sNy+OLy
         DO i=1-OLx,sNx+OLx-1
           vMetricTerms(i,j) = +halfRL*
     &     ( ( uFld(i,j-1) + uFld(i,j) )*halfRL
     &      *( dxC( i,  j, bi,bj)
     &       - dxC( i, j-1,bi,bj) )*recip_rAz( i, j,bi,bj)
     &      *( uFld( i, j-1)*dyG( i, j-1,bi,bj)*hFacW( i, j-1,k,bi,bj)
     &       + uFld( i,  j )*dyG( i,  j, bi,bj)*hFacW( i,  j, k,bi,bj)
     &       )*halfRL
     &     + ( uFld(i+1,j-1) + uFld(i+1,j) )*halfRL
     &      *( dxC(i+1, j, bi,bj)
     &       - dxC(i+1,j-1,bi,bj) )*recip_rAz(i+1,j,bi,bj)
     &      *( uFld(i+1,j-1)*dyG(i+1,j-1,bi,bj)*hFacW(i+1,j-1,k,bi,bj)
     &       + uFld(i+1, j )*dyG(i+1, j, bi,bj)*hFacW(i+1, j, k,bi,bj)
     &       )*halfRL
     &     )*recip_hFacS(i,j,k,bi,bj)
     &      *recip_dyC(i,j,bi,bj)*recip_deepFacC(k)
         ENDDO
        ENDDO
      ENDIF

      RETURN
      END

#include "CTRL_OPTIONS.h"
#define PREVENT_TOO_COLD_TEMP

CBOP
C     !ROUTINE: CTRL_MAP_INI_GENARR
C     !INTERFACE:
      SUBROUTINE CTRL_MAP_INI_GENARR( myThid )

C     !DESCRIPTION: \bv
C     *=================================================================
C     | SUBROUTINE CTRL_MAP_INI_GENARR
C     | Add the generic arrays of the
C     | control vector to the model state and update the tile halos.
C     | The control vector is defined in the header file "CTRL.h".
C     *=================================================================
C     | local version for OpenAD exp. isomip
C     *=================================================================
C     \ev

C     !USES:
      IMPLICIT NONE

C     == global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "DYNVARS.h"
CML#include "FFIELDS.h"
#include "CTRL_SIZE.h"
#include "CTRL.h"
#include "CTRL_GENARR.h"
#include "CTRL_DUMMY.h"
#include "OPTIMCYCLE.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == routine arguments ==
      INTEGER myThid

C     !FUNCTIONS:
      INTEGER  ILNBLNk
      EXTERNAL ILNBLNK

C     !LOCAL VARIABLES:
C     == local variables ==
      INTEGER bi,bj
      INTEGER i,j,k
      INTEGER il
      INTEGER iarr

      LOGICAL doglobalread
      LOGICAL ladinit
      CHARACTER*(MAX_LEN_FNAM) fnamebase
      CHARACTER*(MAX_LEN_FNAM) fnamegeneric
      _RL     fac
#ifdef ALLOW_GENARR2D_CONTROL
      _RL     tmpfld2d(1-OLx:sNx+OLx,1-OLy:sNy+OLy,   nSx,nSy)
#endif
#ifdef ALLOW_GENARR3D_CONTROL
      _RL     tmpfld3d(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
#endif
CEOP

      doglobalread = .FALSE.
      ladinit      = .FALSE.
      fac = 1. _d 0

#ifdef ALLOW_GENARR2D_CONTROL
C--   An example of connecting specific fields
C--   to 3 generic 2D control arrays
cc--->>>
cc--->>> COMPILE FAILURE IS DELIBERATE
cc--->>> BE SURE WHAT YOU ARE DOING AND CUSTOMIZE <<<---
cc--->>>
C--   generic - user-defined control vars
      DO iarr = 1, maxCtrlArr2D

C     These forcing control variables are constant in time for this
C     experiment, so that we can specify them here. Once we know how to
C     make OpenAD use the gentim2d controls, these should be handled via
C     ctrl_map_gentim2d.F
       DO bj=myByLo(myThid), myByHi(myThid)
        DO bi=myBxLo(myThid), myBxHi(myThid)
         DO j = 1,sNy
          DO i = 1,sNx
           tmpfld2d(i,j,bi,bj) = 0. _d 0
          ENDDO
         ENDDO
        ENDDO
       ENDDO
       fnamebase = xx_genarr2d_file(iarr)
       il=ILNBLNK( fnamebase )
       WRITE(fnamegeneric,'(2A,I10.10)')
     &     fnamebase(1:il),'.',optimcycle
       CALL ACTIVE_READ_XY ( fnamegeneric, tmpfld2d, 1,
     &                      doglobalread, ladinit, optimcycle,
     &                      myThid, xx_genarr2d_dummy(iarr) )
       IF ( iarr .EQ. 1 ) THEN
CML        DO bj=myByLo(myThid), myByHi(myThid)
CML         DO bi=myBxLo(myThid), myBxHi(myThid)
CML          DO j = 1,sNy
CML           DO i = 1,sNx
CML            qnet(i,j,bi,bj) = qnet(i,j,bi,bj)
CML     &           + fac*tmpfld2d(i,j,bi,bj)
CML           ENDDO
CML          ENDDO
CML         ENDDO
CML        ENDDO
       ELSEIF ( iarr .EQ. 2 ) THEN
CML        DO bj=myByLo(myThid), myByHi(myThid)
CML         DO bi=myBxLo(myThid), myBxHi(myThid)
CML          DO j = 1,sNy
CML           DO i = 1,sNx
CML            empmr(i,j,bi,bj) = empmr(i,j,bi,bj)
CML     &           + fac*tmpfld2d(i,j,bi,bj)
CML           ENDDO
CML          ENDDO
CML         ENDDO
CML        ENDDO
       ELSEIF ( iarr .EQ. 3 ) THEN
CML        DO bj=myByLo(myThid), myByHi(myThid)
CML         DO bi=myBxLo(myThid), myBxHi(myThid)
CML          DO j = 1,sNy
CML           DO i = 1,sNx
CML            fu(i,j,bi,bj) = fu(i,j,bi,bj)
CML     &           + fac*tmpfld2d(i,j,bi,bj)
CML           ENDDO
CML          ENDDO
CML         ENDDO
CML        ENDDO
       ELSEIF ( iarr .EQ. 4 ) THEN
CML        DO bj=myByLo(myThid), myByHi(myThid)
CML         DO bi=myBxLo(myThid), myBxHi(myThid)
CML          DO j = 1,sNy
CML           DO i = 1,sNx
CML            fv(i,j,bi,bj) = fv(i,j,bi,bj)
CML     &           + fac*tmpfld2d(i,j,bi,bj)
CML           ENDDO
CML          ENDDO
CML         ENDDO
CML        ENDDO
       ENDIF
C--   end iarr loop
      ENDDO
CML      _EXCH_XY_RS( qnet,  myThid )
CML      _EXCH_XY_RS( empmr, myThid )
CML      CALL EXCH_UV_XY_RS(fu,fv,.TRUE.,myThid)

#endif /* ALLOW_GENARR2D_CONTROL */

#ifdef ALLOW_GENARR3D_CONTROL
C--   An example of connecting specific fields
C--   to 3 generic 3D control arrays
cc--->>>
cc--->>> COMPILE FAILURE IS DELIBERATE
cc--->>> BE SURE WHAT YOU ARE DOING AND CUSTOMIZE <<<---
cc--->>>
cc

C--   generic - user-defined control vars
      DO iarr = 1, maxCtrlArr3D

       DO bj=myByLo(myThid), myByHi(myThid)
        DO bi=myBxLo(myThid), myBxHi(myThid)
         DO k = 1,Nr
          DO j = 1,sNy
           DO i = 1,sNx
            tmpfld3d(i,j,k,bi,bj) = 0. _d 0
           ENDDO
          ENDDO
         ENDDO
        ENDDO
       ENDDO
       fnamebase = xx_genarr3d_file(iarr)
       il=ILNBLNK( fnamebase )
       WRITE(fnamegeneric,'(2A,I10.10)')
     &     fnamebase(1:il),'.',optimcycle
       CALL ACTIVE_READ_XYZ( fnamegeneric, tmpfld3d, 1,
     &                       doglobalread, ladinit, optimcycle,
     &                       myThid, xx_genarr3d_dummy(iarr) )
       IF ( iarr .EQ. 1 ) THEN
        DO bj=myByLo(myThid), myByHi(myThid)
         DO bi=myBxLo(myThid), myBxHi(myThid)
          DO k = 1,Nr
           DO j = 1,sNy
            DO i = 1,sNx
             theta(i,j,k,bi,bj) = theta(i,j,k,bi,bj)
     &         + fac*tmpfld3d(i,j,k,bi,bj)
#ifdef PREVENT_TOO_COLD_TEMP
C     necessary to reproduce old results
             IF ( theta(i,j,k,bi,bj).LT.-2.0 _d 0 )
     &            theta(i,j,k,bi,bj) = -2.0 _d 0
#endif
            ENDDO
           ENDDO
          ENDDO
         ENDDO
        ENDDO
        CALL EXCH_3D_RL( theta, Nr, myThid )
       ELSEIF ( iarr .EQ. 2 ) THEN
        DO bj=myByLo(myThid), myByHi(myThid)
         DO bi=myBxLo(myThid), myBxHi(myThid)
          DO k = 1,Nr
           DO j = 1,sNy
            DO i = 1,sNx
             salt(i,j,k,bi,bj) = salt(i,j,k,bi,bj)
     &         + fac*tmpfld3d(i,j,k,bi,bj)
            ENDDO
           ENDDO
          ENDDO
         ENDDO
        ENDDO
        CALL EXCH_3D_RL( salt, Nr, myThid )
       ELSEIF ( iarr .EQ. 3 ) THEN
        DO bj=myByLo(myThid), myByHi(myThid)
         DO bi=myBxLo(myThid), myBxHi(myThid)
          DO k = 1,Nr
           DO j = 1,sNy
            DO i = 1,sNx
             diffKr(i,j,k,bi,bj) = diffKr(i,j,k,bi,bj)
     &         + fac*tmpfld3d(i,j,k,bi,bj)
            ENDDO
           ENDDO
          ENDDO
         ENDDO
        ENDDO
        CALL EXCH_3D_RL( diffKr, Nr, myThid )
       ENDIF

C--   end iarr loop
      ENDDO

#endif /* ALLOW_GENARR3D_CONTROL */

      RETURN
      END

#include "MOM_COMMON_OPTIONS.h"

      SUBROUTINE MOM_CALC_HDIV(
     I        bi,bj,k, hDivScheme,
     I        uFld, vFld,
     O        hDiv,
     I        myThid )
      IMPLICIT NONE
C     *==========================================================*
C     | S/R MOM_CALC_HDIV                                        |
C     *==========================================================*
C     *==========================================================*

C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
C     == Routine arguments ==
C     myThid  :: my Thread Id number
      INTEGER bi,bj,k,hDivScheme
      _RL uFld(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL vFld(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL hDiv(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER myThid

C     == Local variables ==
      INTEGER i,j

#ifdef ALLOW_AUTODIFF
C     Initialise (again) hDiv (in case it got dropped in calling S/R):
      DO j=1-OLy,sNy+OLy
       DO i=1-OLx,sNx+OLx
        hDiv(i,j)=0. _d 0
       ENDDO
      ENDDO
#endif
      IF (hDivScheme.EQ.1) THEN
       DO j=1-OLy,sNy+OLy-1
        DO i=1-OLx,sNx+OLx-1
C       This discretization is the straight forward horizontal divergence
C       that only considers the horizontal grid variations.
         hDiv(i,j)=(
     &       uFld(i+1, j )*dyG(i+1, j ,bi,bj)
     &      -uFld( i , j )*dyG( i , j ,bi,bj)
     &      +vFld( i ,j+1)*dxG( i ,j+1,bi,bj)
     &      -vFld( i , j )*dxG( i , j ,bi,bj)
     &             )*recip_rA(i,j,bi,bj)*recip_deepFacC(k)
#ifdef ALLOW_OBCS
     &              *maskInC(i,j,bi,bj)
#endif
        ENDDO
       ENDDO

      ELSEIF (hDivScheme.EQ.2) THEN
       DO j=1-OLy,sNy+OLy-1
        DO i=1-OLx,sNx+OLx-1
C       This discretization takes into account the fractional areas
C       due to the lopping. Whether we should do this is not clear!
         hDiv(i,j)=
     &    ( ( uFld(i+1, j )*dyG(i+1, j ,bi,bj)*hFacW(i+1, j ,k,bi,bj)
     &       -uFld( i , j )*dyG( i , j ,bi,bj)*hFacW( i , j ,k,bi,bj) )
     &     +( vFld( i ,j+1)*dxG( i ,j+1,bi,bj)*hFacS( i ,j+1,k,bi,bj)
     &       -vFld( i , j )*dxG( i , j ,bi,bj)*hFacS( i , j ,k,bi,bj) )
     &    )*recip_rA(i,j,bi,bj)*recip_deepFacC(k)
     &     *_recip_hFacC(i,j,k,bi,bj)
#ifdef ALLOW_OBCS
     &     *maskInC(i,j,bi,bj)
#endif
        ENDDO
       ENDDO

      ELSE
       STOP 'S/R MOM_CALC_HDIV: We should never reach this point!'
      ENDIF

      RETURN
      END

#include "CPP_OPTIONS.h"

CBOP
C     !ROUTINE: SET_GRID_FACTORS
C     !INTERFACE:
      SUBROUTINE SET_GRID_FACTORS( myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE SET_GRID_FACTORS
C     | o Initialise vertical gridding arrays
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     myThid   :: my Thread Id number
      INTEGER myThid

C     !LOCAL VARIABLES:
C     == Local variables ==
C     k        :: loop index
C     msgBuf   :: Informational/error message buffer
      INTEGER k
c     _RL     tmpRatio, checkRatio1, checkRatio2
c     CHARACTER*(MAX_LEN_MBUF) msgBuf
CEOP

      _BEGIN_MASTER(myThid)

c     WRITE(msgBuf,'(A,2(A,L5))') 'Enter SET_GRID_FACTORS:',
c    &                            ' setInterFDr=', setInterFDr,
c    &                          ' ; setCenterDr=', setCenterDr
c     CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
c    &                    SQUEEZE_RIGHT, myThid )

C--   Calculate horizontal grid factor for the deep model (<=> dropping the
C      shallow atmosphere approximation): only function of the vertical index
C-    first: initialise deep-model grid factor:
      DO k=1,Nr
        deepFacC(k) = 1. _d 0
        deepFac2C(k)= 1. _d 0
        recip_deepFacC(k) = 1. _d 0
        recip_deepFac2C(k)= 1. _d 0
      ENDDO
      DO k=1,Nr+1
        deepFacF(k) = 1. _d 0
        deepFac2F(k)= 1. _d 0
        recip_deepFacF(k) = 1. _d 0
        recip_deepFac2F(k)= 1. _d 0
      ENDDO
      IF ( deepAtmosphere ) THEN
C-    set deep-model grid factor:
       IF ( usingZCoords ) THEN
        DO k=1,Nr
          deepFacC(k)  = (rSphere+rC(k))*recip_rSphere
          deepFac2C(k) = deepFacC(k)*deepFacC(k)
        ENDDO
        DO k=1,Nr+1
          deepFacF(k)  = (rSphere+rF(k))*recip_rSphere
          deepFac2F(k) = deepFacF(k)*deepFacF(k)
        ENDDO
       ELSE
        DO k=1,Nr
          deepFacC(k)  = ( rSphere + phiRef(2*k)*recip_gravity
     &                   )*recip_rSphere
          deepFac2C(k) = deepFacC(k)*deepFacC(k)
        ENDDO
        DO k=1,Nr+1
          deepFacF(k)  = ( rSphere + phiRef(2*k-1)*recip_gravity
     &                   )*recip_rSphere
          deepFac2F(k) = deepFacF(k)*deepFacF(k)
        ENDDO
       ENDIF
C-    set reciprocal of deep-model grid factor:
       DO k=1,Nr
        recip_deepFacC(k) = 1. _d 0/deepFacC(k)
        recip_deepFac2C(k)= 1. _d 0/deepFac2C(k)
       ENDDO
       DO k=1,Nr+1
        recip_deepFacF(k) = 1. _d 0/deepFacF(k)
        recip_deepFac2F(k)= 1. _d 0/deepFac2F(k)
       ENDDO
      ENDIF

      _END_MASTER(myThid)
      _BARRIER

      RETURN
      END

#include "BLING_OPTIONS.h"
#ifdef ALLOW_EXF
# include "EXF_OPTIONS.h"
#endif

CBOP
      SUBROUTINE BLING_READPARMS( myThid )

C     *========================================================*
C     | subroutine bling_readparms
C     | o Initialise and read parameters for BLING model
C     *========================================================*

      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#ifdef ALLOW_EXF
# include "EXF_PARAM.h"
# include "EXF_INTERP_SIZE.h"
# include "EXF_INTERP_PARAM.h"
#endif /* ALLOW_EXF */
#include "BLING_VARS.h"

C     === Routine arguments ===
C     myThid    :: My Thread Id. number
      INTEGER myThid
CEOP

#ifdef ALLOW_BLING

C     === Local variables ===
C     msgBuf    :: Informational/error message buffer
C     errCount  :: error counter
C     iUnit     :: Work variable for IO unit number
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      INTEGER errCount
      INTEGER iUnit

C ==========================================================
C   Abiotic parameters
C  selectBTconst :: estimates borate concentration from salinity
C     selectBTconst=1 for the default formulation of UppstrÃ¶1974) i.e.
C     the same as S/R CARBON_COEFFS
C     selectBTconst=2 for the new formulation from Lee et al (2010)
C  selectFTconst :: estimates fluoride concentration from salinity
C     selectFTconst=1 for the default formulation of Riley (1965) i.e.
C     the same as S/R CARBON_COEFFS
C     selectFTconst=2 for the new formulation from Culkin (1965)
C  selectHFconst :: sets the first dissociation constant for hydrogen
C  fluoride:
C     selectHFconst=1 for the default  Dickson and Riley (1979) i.e. the
C     same as S/R CARBON_COEFFS
C     selectHFconst=2 for the formulation of Perez and Fraga (1987)
C  selectK1K2const :: sets the first and second dissociation constants
C  of carbonic acid:
C     selectK1K2const=1 for the default formulation of Millero (1995)
C     with data from Mehrbach et al. (1973),
C          i.e. the same as S/R CARBON_COEFFS
C     selectK1K2const=2 for the formulation of Roy et al. (1993)
C     selectK1K2const=3 for the "combination" formulation of Millero
C     (1995)
C     selectK1K2const=4 for the formulation of Luecker et al. (2000)
C     selectK1K2const=5 for the formulation of Millero (2010, Mar. Fresh
C     Wat. Res.)
C     selectK1K2const=6 for the formulation of Waters, Millero, Woosley
C     (2014, Mar. Chem.)
C  selectPHsolver  :: sets the pH solver to use
C     selectPHsolver=0 for Follows et al., (2006)
C     selectPHsolver=1 for Munhoven (2013) solvesaphe general
C     selectPHsolver=2 for Munhoven (2013) solvesaphe sec
C     selectPHsolver=3 for Munhoven (2013) solvesaphe fast
C ==========================================================

      NAMELIST /ABIOTIC_PARMS/
     &                      permil,
     &                      Pa2Atm,
     &                      epsln
#ifdef CARBONCHEM_SOLVESAPHE
     & ,selectBTconst,selectFTconst,
     &  selectHFconst,selectK1K2const,
     &  selectPHsolver
#endif

C ==========================================================
C   BLING parameters
C ==========================================================

      NAMELIST /BIOTIC_PARMS/
     &                     CtoN,
     &                     CtoP,
     &                     NtoP,
     &                     HtoC,
     &                     NO3toN,
     &                     O2toN,
     &                     O2toP,
     &                     CatoN,
     &                     CatoP,
     &                     masstoN,
#ifndef USE_BLING_V1
     &                     Pc_0_diaz,
     &                     alpha_photo,
     &                     gamma_DON,
     &                     k_Fe_diaz,
     &                     k_NO3,
     &                     k_PtoN,
     &                     k_FetoN,
     &                     k_NO3_sm,
     &                     k_NO3_lg,
     &                     k_PO4_sm,
     &                     k_PO4_lg,
     &                     k_Fe_sm,
     &                     k_Fe_lg,
     &                     PtoN_min,
     &                     PtoN_max,
     &                     FetoN_min,
     &                     FetoN_max,
     &                     kappa_eppley_diaz,
     &                     phi_dvm,
     &                     sigma_dvm,
#ifdef USE_SIBLING
     &                     k_Si,
     &                     gamma_Si_0,
     &                     kappa_remin_Si,
     &                     wsink_Si,
     &                     SitoN_uptake_min,
     &                     SitoN_uptake_max,
     &                     SitoN_uptake_scale,
     &                     SitoN_uptake_exp,
     &                     q_SitoN_diss,
#endif
#else
     &                     alpha_max,
     &                     alpha_min,
     &                     gamma_biomass,
     &                     k_FetoP,
     &                     FetoP_max,
     &                     Fe_lim_min,
#endif
     &                     pivotal,
     &                     Pc_0,
     &                     lambda_0,
     &                     resp_frac,
     &                     chl_min,
     &                     theta_Fe_max_hi,
     &                     theta_Fe_max_lo,
     &                     gamma_irr_mem,
     &                     gamma_DOP,
     &                     gamma_POM,
     &                     k_Fe,
     &                     k_O2,
     &                     k_PO4,
     &                     kFe_eq_lig_max,
     &                     kFe_eq_lig_min,
     &                     kFe_eq_lig_Femin,
     &                     kFe_eq_lig_irr,
     &                     kFe_org,
     &                     kFe_inorg,
     &                     FetoC_sed,
     &                     remin_min,
     &                     oxic_min,
     &                     ligand,
     &                     kappa_eppley,
     &                     kappa_remin,
     &                     ca_remin_depth,
     &                     phi_DOM,
     &                     phi_sm,
     &                     phi_lg,
     &                     wsink0z,
     &                     wsink0,
     &                     wsinkacc,
     &                     parfrac,
     &                     alpfe,
     &                     k0,
     &                     MLmix_max,
     &                     chlsat_locTimWindow,
     &                     river_conc_po4,
     &                     river_dom_to_nut

C ==========================================================
C   BLING forcing
C ==========================================================

      NAMELIST /BLING_FORCING/
     &          bling_windFile, bling_atmospFile, bling_iceFile,
     &          bling_ironFile, bling_silicaFile,
     &          bling_psmFile, bling_plgFile, bling_PdiazFile,
     &          bling_forcingPeriod, bling_forcingCycle,
     &          bling_Pc_2dFile, bling_Pc_2d_diazFile,
     &          bling_k0_2dFile,
     &          bling_alpha_photo2dFile,bling_phi_DOM2dFile,
     &          bling_k_Fe2dFile, bling_k_Fe_diaz2dFile,
     &          bling_gamma_POM2dFile, bling_wsink0_2dFile,
     &          bling_phi_sm2dFile,bling_phi_lg2dFile,
     &          bling_pCO2,
     &          river_conc_po4, river_dom_to_nut
#ifdef ALLOW_EXF
     &         ,apco2file, apco2startdate1, apco2startdate2,
     &          apco2RepCycle, apco2period, apco2StartTime,
     &          exf_inscal_apco2, exf_outscal_apco2, apco2const,
     &          apco2_exfremo_intercept, apco2_exfremo_slope
#ifdef USE_EXF_INTERPOLATION
     &         ,apco2_lon0, apco2_lon_inc, apco2_lat0, apco2_lat_inc,
     &          apco2_nlon, apco2_nlat, apco2_interpMethod
#endif /* USE_EXF_INTERPOLATION */
#endif /* ALLOW_EXF */

C ==========================================================
C   secperday        :: Seconds in a day = 24*60*60
C   permil           :: Set carbon mol/m3 <---> mol/kg conversion factor
C                       Default permil = 1024.5 kg/m3
C   Pa2Atm           :: Conversion factor for atmospheric pressure from EXF
C                       1 Atm = 1.01325e5 Pa = 1013.25 mb
C   epsln            :: A very small number
C   CtoN             :: Carbon to nitrogen ratio in organic matter
C   CtoP             :: Carbon to phosphorus ratio in organic matter
C   NtoP             :: Nitrogen to phosphorus ratio in organic matter
C   HtoC             :: Reduced hydrogen to carbon ratio in organic matter
C   NO3toN           :: Nitrate to organic nitrogen ratio for denitrification
C   O2toN            :: Oxygen to nitrogen for biological activity
C   O2toP            :: Oxygen to phosphorus for biological activity
C   CatoN            :: Calcium to nitrogen uptake by small phyto
C   CatoP            :: Calcium to phosphorus uptake by small phyto
C   masstoN          :: Organic matter mass to nitrogen ratio
C   pivotal          :: Pivotal phytoplankton biomass, for grazing law
C                       [mol P m-3  or  mol N m-3]
C   Pc_0             :: Maximum phytoplankton carbon-specific growth rate at 0C
C   Pc_0_diaz        :: Maximum diazotroph carbon-specific growth rate at 0C
C   lambda_0         :: Total mortality rate constant
C   resp_frac        :: Fraction of production that is respired
C   chl_min          :: Minimum chl concentration allowed (for numerical stability)
C   alpha_photo      :: Quantum yield under low light, Fe-replete
C                       [g C g Chl-1 m2 W-1 s-1]
C   alpha_max        :: Quantum yield under low light, abundant iron
C   alpha_min        :: Quantum yield under low light, iron limited
C   theta_Fe_max_hi  :: Maximum Chl:C ratio when iron-replete
C   theta_Fe_max_lo  :: Maximum Chl:C ratio when iron-limited
C   gamma_irr_mem    :: Photoadaptation timescale
C   gamma_DON        :: Dissolved organic nitrogen decay timescale
C   gamma_DOP        :: Dissolved organic phosphorus decay timescale
C   gamma_POM        :: Particulate Organic Matter decay timescale
C   gamma_biomass    :: Biomass adjustment time scale
C   gamma_Si_0       :: Opal dissolution timescale
C   k_Fe             :: Iron half-saturation concentration
C   k_Fe_diaz        :: Iron half-saturation concentration for diazotrophs
C   k_O2             :: Oxygen half-saturation concentration for aerobic respiration
C   k_PO4            :: Phosphate half-saturation concentration
C   k_NO3            :: Nitrate half-saturation concentration
C   k_Si             :: Silicate half-saturation concentration
C   k_PtoN           :: Phosphate half-saturation concentration for uptake ratio
C   k_FetoN          :: Iron half-saturation concentration for uptake ratio
C   k_FetoP          :: Iron half-saturation concentration for uptake ratio
C   kFe_eq_lig_max   :: Maximum light-dependent iron ligand stability constant
C   kFe_eq_lig_min   :: Minimum light-dependent iron ligand stability constant
C   kFe_eq_lig_Femin :: Low-iron threshold for ligand stability constant
C   kFe_eq_lig_irr   :: Irradiance scaling for iron ligand stability constant
C   kFe_org          :: Iron scavenging, 1st order
C   kFe_inorg        :: Iron scavenging, 2nd order
C   PtoN_max         :: Phosphorus to Nitrogen uptake ratio maximum
C   PtoN_min         :: Phosphorus to Nitrogen uptake ratio minimum
C   FetoN_max        :: Iron to Nitrogen uptake ratio maximum
C   FetoN_min        :: Iron to Nitrogen uptake ratio minimum
C   FetoC_sed        :: Iron released per organic carbon delivery to sediments
C   FetoP_max        :: Iron to Phosphorus uptake ratio maximum
C   Fe_lim_min       :: Minimum iron limitation
C   SitoN_uptake_max :: Silica to Nitrogen uptake ratio maximum
C   SitoN_uptake_min :: Silica to Nitrogen uptake ratio minimum
C   SitoN_uptake_scale:: Scale factor for Silica to Nitrogen uptake ratio
C   SitoN_uptake_exp :: Exponent for Silica to Nitrogen uptake ratio
C   remin_min        :: Minimum remineralization under anoxia
C   oxic_min         :: Anaerobic respiration threshold
C   ligand           :: Iron ligand concentration
C   kappa_eppley     :: Temperature dependence of growth
C   kappa_eppley_diaz:: Temperature dependence of growth for diazotrophs
C   kappa_remin      :: Temperature dependence for particle fractionation
C   kappa_remin_Si   :: Temperature dependence for silica
C   ca_remin_depth   :: CaCO3 dissolution length scale (subject to omega)
C   q_SitoN_diss     :: Stoichiometric role in opal dissolution, following TOPAZ
C   phi_DOM          :: Fraction of uptake/consumption that becomes DOM
C   phi_sm           :: Fraction of small phytoplankton biomass converted to detritus
C   phi_lg           :: Fraction of large phytoplankton biomass converted to detritus
C   phi_dvm          :: Fraction of particate production exported by animals
C   sigma_dvm        :: Standard deviation of vertical migrator resting depth range
C   wsink0           :: Sinking rate at surface
C   wsink0z          :: Depth to which sinking rate remains constant
C   wsinkacc         :: Sinking rate acceleration with depth
C   wsink_si         :: Opal sinking velocity
C   parfrac          :: Fraction of Qsw available for photosynthesis
C   alpfe            :: Solubility of aeolian iron
C   k0               :: Light attentuation coefficient
C   MLmix_max        :: Maximum depth over which light and biomass can be mixed
C   river_conc_po4   :: Phosphate concentration in river runoff
C   river_dom_to_nut :: DOM to PO4 ratio in river runoff
C   chlsat_locTimWindow(1:2) :: local-time window (in h) for
C                       satellite-equivalent chlorophyll diagnostic (and cost)

      _RL secperday
#ifdef ALLOW_EXF
#ifdef USE_EXF_INTERPOLATION
      INTEGER j
#endif /* USE_EXF_INTERPOLATION */
#endif /* ALLOW_EXF */

      _BEGIN_MASTER(myThid)
      errCount = 0

C ==========================================================
C     Default values

      secperday            = 86400. _d 0
      permil               = 1. _d 0 / 1024.5 _d 0
      Pa2Atm               = 1.01325 _d 5
      epsln                = 1. _d -30
#ifdef CARBONCHEM_SOLVESAPHE
       selectBTconst   = 1
       selectFTconst   = 1
       selectHFconst   = 1
       selectK1K2const = 1
       selectPHsolver  = 0
#endif

      CtoN                 = 6.75 _d 0
      CtoP                 = 106. _d 0
      NtoP                 = 16. _d 0
      HtoC                 = 48. _d 0 / 106. _d 0
      NO3toN               = CtoN * (1. _d 0 + 0.25 _d 0 * HtoC)
     &                        * 0.8 _d 0 + 0.6 _d 0
      O2toN                = CtoN * (1. _d 0 + 0.25 _d 0 * HtoC)
     &                        + 2. _d 0
      O2toP                = 150. _d 0
      CatoN                = CtoN * 0.015 _d 0
      CatoP                = 106.0 _d 0 * 0.015 _d 0
      masstoN              = CtoN * 12.001 _d 0
#ifndef USE_BLING_V1
      pivotal              = 1.9 _d -3 / 1028. _d 0 / CtoN / permil
      Pc_0                 = 1.7 _d -5
      Pc_0_diaz            = 0.01 _d -5
      alpha_photo          = 0.7 _d -5 * 2.77 _d 18 / 6.022 _d 17
      gamma_DON            = 0.25 _d 0 / (365.25 _d 0 * secperday)
      gamma_DOP            = 0.5 _d 0 / (365.25 _d 0 * secperday)
      PtoN_min             = 1. / 28.
      PtoN_max             = 1. / 9.
      FetoN_min            = 2. _d -6 * 6.75
      FetoN_max            = 25. _d -6 * 6.75
      k_Fe                 = 1.6 _d -10 / permil
      k_Fe_diaz            = 7. _d -10 / permil
      k_NO3                = 2. _d -6 / permil
      k_PO4                = 1. _d -8 / permil
      k_NO3_sm             = 2.0 _d -6 / permil
      k_NO3_lg             = 6.0 _d -6 / permil
      k_PO4_sm             = 1.0 _d -8 / permil
      k_PO4_lg             = 3.0 _d -8 / permil
      k_Fe_sm              = 1.6 _d -10 / permil
      k_Fe_lg              = 4.8 _d -10 / permil
      k_PtoN               = 1.5 _d -6 / permil
      k_FetoN              = 8. _d -10 / permil
      remin_min            = 0.15 _d 0
      kappa_eppley_diaz    = 0.18 _d 0
      sigma_dvm            = 40.0 _d 0
      phi_dvm              = 0.2 _d 0
#ifdef USE_SIBLING
      k_Si                 = 2.0 _d -6 / permil
      gamma_Si_0           = 0.05 / secperday
      kappa_remin_Si       = 0.075
      wsink_Si             = 100. / secperday
      SitoN_uptake_min     = 4
      SitoN_uptake_max     = 1
      SitoN_uptake_scale   = 0.6
      SitoN_uptake_exp     = 3.887
      q_SitoN_diss         = 1.0 _d 0
#endif
#else
      pivotal              = 1.9 _d -3 / 1028. _d 0 / CtoP / permil
      Pc_0                 = 1 _d -5
      alpha_max            = 1.6 _d -5 * 2.77 _d 18 / 6.022 _d 17
      alpha_min            = 0.4 _d -5 * 2.77 _d 18 / 6.022 _d 17
      gamma_biomass        = 0.5 _d 0 / secperday
      gamma_DOP            = 0.25 _d 0 / (365.25 _d 0 * secperday)
      k_Fe                 = 8. _d -10 / permil
      k_PO4                = 1. _d -7 / permil
      k_FetoP              = 7. _d -6 * CtoP
      FetoP_max            = 28. _d -6 * CtoP
      Fe_lim_min           = 0. _d 0
      remin_min            = 0.3 _d 0
#endif
      lambda_0             = 0.19 _d 0 / secperday
      resp_frac            = 0. _d 0
      chl_min              = 1. _d -5
      theta_Fe_max_hi      = 0.04 _d 0
      theta_Fe_max_lo      = 0.01 _d 0
      gamma_irr_mem        = 1. _d 0 / secperday
      gamma_POM            = 0.12 _d 0 / secperday
      k_O2                 = 20. _d -6 / permil
      kFe_eq_lig_max       = 8.0 _d 10 * permil
      kFe_eq_lig_min       = 8.0 _d 9 * permil
      kFe_eq_lig_Femin     = 0.05 _d -9 / permil
      kFe_eq_lig_irr       = 0.1 _d 0
      kFe_org              = 0.5 _d 0 / secperday * permil**(0.58)
      kFe_inorg            = 1. _d 3 / secperday * permil**(0.5)
      FetoC_sed            = 1. _d -4
      oxic_min             = 1. _d -6 / permil
      Ligand               = 1. _d -9 / permil
      kappa_eppley         = 0.063 _d 0
      kappa_remin          = -0.032 _d 0
      ca_remin_depth       = 1343. _d 0
      phi_DOM              = 0.1 _d 0
      phi_sm               = 0.18 _d 0
      phi_lg               = 1. _d 0
      wsink0               = 16. _d 0 / secperday
      wsink0z              = 80. _d 0
      wsinkacc             = 0.05 _d 0 / secperday
      parfrac              = 0.4 _d 0
      alpfe                = 0.01 _d 0
      k0                   = 0.04 _d 0
      MLmix_max            = 200.0 _d 0
      chlsat_locTimWindow(1) = 12.0 _d 0
      chlsat_locTimWindow(2) = 13.5 _d 0

      bling_windFile         = ' '
      bling_atmospFile       = ' '
      bling_iceFile          = ' '
      bling_ironFile         = ' '
      bling_silicaFile       = ' '
      bling_psmFile          = ' '
      bling_plgFile          = ' '
      bling_pdiazFile        = ' '
      bling_Pc_2dFile        = ' '
      bling_Pc_2d_diazFile   = ' '
      bling_k0_2dFile        = ' '
      bling_alpha_photo2dFile= ' '
      bling_k_Fe2dFile       = ' '
      bling_k_Fe_diaz2dFile  = ' '
      bling_gamma_POM2dFile  = ' '
      bling_wsink0_2dFile    = ' '
      bling_phi_DOM2dFile    = ' '
      bling_phi_sm2dFile     = ' '
      bling_phi_lg2dFile     = ' '

      bling_pCO2             = 278. _d -6
      river_conc_po4         = 0.007 _d 0
      river_dom_to_nut       = 0. _d 0

#ifdef ALLOW_EXF
      apco2startdate1         = 0
      apco2startdate2         = 0
      apco2StartTime          = UNSET_RL
      apco2period             = 0.0 _d 0
      apco2RepCycle           = repeatPeriod
      apco2const              = 0.0 _d 0
      apco2_exfremo_intercept = 0.0 _d 0
      apco2_exfremo_slope     = 0.0 _d 0
      apco2file               = ' '
      exf_inscal_apco2        =  1. _d 0
      exf_outscal_apco2       =  1. _d 0
#ifdef USE_EXF_INTERPOLATION
C--   set default input location to match (in case of simple Lat-Long grid)
C     model grid cell-center position (leading to trivial interpolation)
      apco2_lon0         = inp_lon0
      apco2_lat0         = inp_lat0
      apco2_nlon         = inp_gNx
      apco2_nlat         = inp_gNy
      apco2_lon_inc      = inp_dLon
      DO j=1,MAX_LAT_INC
        apco2_lat_inc(j) = inp_dLat(j)
      ENDDO
      apco2_interpMethod = 1
#endif /* USE_EXF_INTERPOLATION */
#endif /* ALLOW_EXF */

C     default periodic forcing to same as for physics
      bling_forcingPeriod = externForcingPeriod
      bling_forcingCycle  = externForcingCycle

      WRITE(msgBuf,'(A)') ' BLING_READPARMS: opening data.bling'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     I                    SQUEEZE_RIGHT, myThid )

      CALL OPEN_COPY_DATA_FILE( 'data.bling', 'BLING_READPARMS',
     O                          iUnit, myThid )

C--   Read parameters from open data file:

C-    Abiotic parameters
      READ(UNIT=iUnit,NML=ABIOTIC_PARMS)

C-    BLING parameters
      READ(UNIT=iUnit,NML=BIOTIC_PARMS)

C-    forcing filenames and parameters
      READ(UNIT=iUnit,NML=BLING_FORCING)

      WRITE(msgBuf,'(A)')
     &   ' BLING_READPARMS: finished reading data.BLING'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     I                    SQUEEZE_RIGHT, myThid )

C--   Close the open data file
#ifdef SINGLE_DISK_IO
      CLOSE(iUnit)
#else
      CLOSE(iUnit,STATUS='DELETE')
#endif /* SINGLE_DISK_IO */

      iUnit = standardMessageUnit
C Record the solver to calculate pH and evaluate surface ocean pCO2
#ifdef CARBONCHEM_SOLVESAPHE
      IF ( selectPHsolver.GT.0 ) THEN
         WRITE(msgBuf,'(A)')
     &  'Using Munhoven (2013) Solvesaphe for pH/pCO2'
         CALL PRINT_MESSAGE(msgBuf,iUnit,SQUEEZE_RIGHT,myThid)
      ELSEIF ( selectPHsolver.EQ.0 ) THEN
         WRITE(msgBuf,'(A)')
     &  'Using Follows et al. (2006) for pH/pCO2'
         CALL PRINT_MESSAGE(msgBuf,iUnit,SQUEEZE_RIGHT,myThid)
      ENDIF
#endif

C Record which carbonate coefficients are used and which pH/pCO2 solver
#ifdef CARBONCHEM_SOLVESAPHE
      WRITE(msgBuf,'(A)')
     &  'Using Munhoven (2013) Solvesaphe carbon coefficients'
      CALL PRINT_MESSAGE(msgBuf,iUnit,SQUEEZE_RIGHT,myThid)
C Munhoven (2013)'s "Solvesaphe" coefficients have several options:
      IF ( selectK1K2const.EQ.1 ) THEN
         WRITE(msgBuf,'(A)')
     &  'Using Millero (1995)/Mehrbach K1 and K2 coefficients'
         CALL PRINT_MESSAGE(msgBuf,iUnit,SQUEEZE_RIGHT,myThid)
      ELSEIF ( selectK1K2const.EQ.2 ) THEN
         WRITE(msgBuf,'(A)')
     &  'Using Roy et al. (1993) K1 and K2 coefficients'
         CALL PRINT_MESSAGE(msgBuf,iUnit,SQUEEZE_RIGHT,myThid)
      ELSEIF ( selectK1K2const.EQ.3 ) THEN
         WRITE(msgBuf,'(A)')
     &  'Using Millero (1995) "consensus" K1 and K2 coefficients'
         CALL PRINT_MESSAGE(msgBuf,iUnit,SQUEEZE_RIGHT,myThid)
      ELSEIF ( selectK1K2const.EQ.4 ) THEN
         WRITE(msgBuf,'(A)')
     &  'Using Luecker et al. (2000) K1 and K2 coefficients'
         CALL PRINT_MESSAGE(msgBuf,iUnit,SQUEEZE_RIGHT,myThid)
      ELSEIF ( selectK1K2const.EQ.5 ) THEN
         WRITE(msgBuf,'(A)')
     &  'Using Millero et al. (2010) K1 and K2 coefficients'
         CALL PRINT_MESSAGE(msgBuf,iUnit,SQUEEZE_RIGHT,myThid)
      ELSEIF ( selectK1K2const.EQ.6 ) THEN
         WRITE(msgBuf,'(A)')
     &  'Using Waters et al. (2014) K1 and K2 coefficients'
         CALL PRINT_MESSAGE(msgBuf,iUnit,SQUEEZE_RIGHT,myThid)
      ENDIF
      IF ( selectHFconst.EQ.1 ) THEN
         WRITE(msgBuf,'(A)')
     &  'Using Dickson and Riley (1979) KF coefficient'
         CALL PRINT_MESSAGE(msgBuf,iUnit,SQUEEZE_RIGHT,myThid)
      ELSEIF ( selectHFconst.EQ.2 ) THEN
         WRITE(msgBuf,'(A)')
     &  'Using Perez and Fraga (1987) KF coefficient'
         CALL PRINT_MESSAGE(msgBuf,iUnit,SQUEEZE_RIGHT,myThid)
      ENDIF
      IF ( selectBTconst.EQ.1 ) THEN
         WRITE(msgBuf,'(A)')
     & 'Using Uppstrom (1974) BT estimation from salinity'
         CALL PRINT_MESSAGE(msgBuf,iUnit,SQUEEZE_RIGHT,myThid)
      ELSEIF ( selectBTconst.EQ.2 ) THEN
         WRITE(msgBuf,'(A)')
     &  'Using Lee et al (2010) BT estimation from salinity'
         CALL PRINT_MESSAGE(msgBuf,iUnit,SQUEEZE_RIGHT,myThid)
      ENDIF
      IF ( selectFTconst.EQ.1 ) THEN
         WRITE(msgBuf,'(A)')
     &  'Using Riley (1965) FT estimation from salinity'
         CALL PRINT_MESSAGE(msgBuf,iUnit,SQUEEZE_RIGHT,myThid)
      ELSEIF ( selectBTconst.EQ.2 ) THEN
         WRITE(msgBuf,'(A)')
     &  'Using Culkin (1965) FT estimation from salinity'
         CALL PRINT_MESSAGE(msgBuf,iUnit,SQUEEZE_RIGHT,myThid)
      ENDIF
#else
C OCMIP2 Coefficients from S/R CARBON_COEFFS in CARBON_CHEM.F
      WRITE(msgBuf,'(A)')
     &  'Using Millero (1995)/Mehrbach K1 and K2 coefficients'
      CALL PRINT_MESSAGE(msgBuf,iUnit,SQUEEZE_RIGHT,myThid)
      WRITE(msgBuf,'(A)')
     &  'Using Dickson and Riley (1979) KF coefficient'
      CALL PRINT_MESSAGE(msgBuf,iUnit,SQUEEZE_RIGHT,myThid)
      WRITE(msgBuf,'(A)')
     &  'Using Uppstrom (1974) BT estimation from salinity'
      CALL PRINT_MESSAGE(msgBuf,iUnit,SQUEEZE_RIGHT,myThid)
      WRITE(msgBuf,'(A)')
     &  'Using Riley (1965) FT estimation from salinity'
      CALL PRINT_MESSAGE(msgBuf,iUnit,SQUEEZE_RIGHT,myThid)
#endif

      IF ( errCount.GE.1 ) THEN
       WRITE(msgBuf,'(A,I3,A)')
     &     'BLING_READPARMS: detected', errCount,' fatal error(s)'
       CALL PRINT_ERROR( msgBuf, myThid )
       CALL ALL_PROC_DIE( 0 )
       STOP 'ABNORMAL END: S/R BLING_READPARMS'
      ENDIF

#ifdef CARBONCHEM_SOLVESAPHE
      IF ( selectHFconst.GT.2 .OR. selectBTconst.GT.2
     & .OR. selectFTconst.GT.2 ) THEN
        WRITE(msgBuf,'(A)')
     &    'BLING_READPARMS: selectHF, selectBT or selectFT > 2'
        CALL PRINT_ERROR( msgBuf, myThid )
        STOP 'ABNORMAL END: S/R BLING_READPARMS: solvesaphe_const error'
      ELSEIF ( selectK1K2const.GT.6 ) THEN
        WRITE(msgBuf,'(A)')
     &    'BLING_READPARMS: selectK1K2const > 6 '
        CALL PRINT_ERROR( msgBuf, myThid )
        STOP 'ABNORMAL END: S/R BLING_READPARMS: solvesaphe_const error'
      ELSEIF ( selectPHsolver.GT.3 ) THEN
        WRITE(msgBuf,'(A)')
     &    'BLING_READPARMS: selectPHsolver > 3 '
        CALL PRINT_ERROR( msgBuf, myThid )
        STOP 'ABNORMAL END: S/R BLING_READPARMS: select pH solver error'
      ENDIF
#endif

      _END_MASTER(myThid)

C--   Everyone else must wait for the parameters to be loaded
      _BARRIER

#endif /* ALLOW_BLING */

      RETURN
      END

#include "KPP_OPTIONS.h"
#ifdef ALLOW_SALT_PLUME
#include "SALT_PLUME_OPTIONS.h"
#endif

CBOP
C !ROUTINE: KPP_FORCING_SURF

C !INTERFACE: ==========================================================
      SUBROUTINE KPP_FORCING_SURF(
     I     rhoSurf, surfForcU, surfForcV,
     I     surfForcT, surfForcS, surfForcTice,
     I     Qsw,
#ifdef KPP_ESTIMATE_UREF
     I     dbloc,
#endif /* KPP_ESTIMATE_UREF */
#ifdef ALLOW_SALT_PLUME
     I     SPforcS,SPforcT,
#endif /* ALLOW_SALT_PLUME */
     I     ttalpha, ssbeta,
     O     ustar, bo, bosol,
#ifdef ALLOW_SALT_PLUME
     O     boplume,
#endif /* ALLOW_SALT_PLUME */
     O     dVsq,
     I     ikey, iMin, iMax, jMin, jMax, bi, bj, myTime, myThid )

C !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE KPP_FORCING_SURF                              |
C     | o Compute all surface related KPP fields:                |
C     |   - friction velocity ustar                              |
C     |   - turbulent and radiative surface buoyancy forcing,    |
C     |     bo and bosol, and surface haline buoyancy forcing    |
C     |     boplume                                              |
C     |   - velocity shear relative to surface squared (this is  |
C     |     not really a surface affected quantity unless it is  |
C     |     computed with respect to some resolution independent |
C     |     reference level, that is KPP_ESTIMATE_UREF defined ) |
C     *==========================================================*
      IMPLICIT NONE

C \ev

C !USES: ===============================================================
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "DYNVARS.h"
#include "KPP_PARAMS.h"

C !INPUT PARAMETERS: ===================================================
C Routine arguments
C     ikey   - key for storing trajectory for adjoint (taf)
C     imin, imax, jmin, jmax  - array computation indices
C     bi, bj - array indices on which to apply calculations
C     myTime - Current time in simulation
C     myThid - Current thread id
C     rhoSurf- density of surface layer                            (kg/m^3)
C     surfForcU     units are  r_unit.m/s^2 (=m^2/s^2 if r=z)
C     surfForcV     units are  r_unit.m/s^2 (=m^2/s^-2 if r=z)
C     surfForcS     units are  r_unit.g/kg/s (=g/kg.m/s if r=z)
C            - EmPmR * S_surf plus salinity relaxation*drF(1)
C     surfForcT     units are  r_unit.Kelvin/s (=Kelvin.m/s if r=z)
C            - Qnet (+Qsw) plus temp. relaxation*drF(1)
C                -> calculate        -lambda*(T(model)-T(clim))
C            Qnet assumed to be net heat flux including ShortWave rad.
C     surfForcTice
C            - equivalent Temperature flux in the top level that corresponds
C              to the melting or freezing of sea-ice.
C              Note that the surface level temperature is modified
C              directly by the sea-ice model in order to maintain
C              water temperature under sea-ice at the freezing
C              point.  But we need to keep track of the
C              equivalent amount of heat that this surface-level
C              temperature change implies because it is used by
C              the KPP package (kpp_calc.F and kpp_transport_t.F).
C              Units are r_unit.K/s (=Kelvin.m/s if r=z) (>0 for ocean warming).
C
C     Qsw     - surface shortwave radiation (upwards positive)
C     saltPlumeFlux - salt rejected during freezing (downward = positive)
C     ttalpha - thermal expansion coefficient without 1/rho factor
C               d(rho{k,k})/d(T(k))                           (kg/m^3/C)
C     ssbeta  - salt expansion coefficient without 1/rho factor
C               d(rho{k,k})/d(S(k))                    ((kg/m^3)/(g/kg))
C !OUTPUT PARAMETERS:
C     ustar  (nx,ny)       - surface friction velocity                  (m/s)
C     bo     (nx,ny)       - surface turbulent buoyancy forcing     (m^2/s^3)
C     bosol  (nx,ny)       - surface radiative buoyancy forcing     (m^2/s^3)
C     boplume(nx,ny,Nr+1)  - surface haline buoyancy forcing        (m^2/s^3)
C     dVsq   (nx,ny,Nr)    - velocity shear re surface squared
C                            at grid levels for bldepth             (m^2/s^2)

      INTEGER ikey
      INTEGER iMin, iMax, jMin, jMax
      INTEGER bi, bj
      INTEGER myThid
      _RL     myTime

      _RL rhoSurf     (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL surfForcU   (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL surfForcV   (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL surfForcT   (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL surfForcS   (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL surfForcTice(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RS Qsw         (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL TTALPHA     (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nrp1)
      _RL SSBETA      (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nrp1)

      _RL ustar ( 1-OLx:sNx+OLx, 1-OLy:sNy+OLy                )
      _RL bo    ( 1-OLx:sNx+OLx, 1-OLy:sNy+OLy                )
      _RL bosol ( 1-OLx:sNx+OLx, 1-OLy:sNy+OLy                )
#ifdef KPP_ESTIMATE_UREF
      _RL dbloc ( 1-OLx:sNx+OLx, 1-OLy:sNy+OLy, Nr            )
#endif /* KPP_ESTIMATE_UREF */
#ifdef ALLOW_SALT_PLUME
      _RL SPforcS     (1-OLx:sNx+OLx, 1-OLy:sNy+OLy, Nr       )
      _RL SPforcT     (1-OLx:sNx+OLx, 1-OLy:sNy+OLy, Nr       )
      _RL boplume     (1-OLx:sNx+OLx, 1-OLy:sNy+OLy, Nrp1     )
#endif /* ALLOW_SALT_PLUME */
      _RL dVsq  ( 1-OLx:sNx+OLx, 1-OLy:sNy+OLy, Nr            )

C !LOCAL VARIABLES: ====================================================
C Local constants
      _RL        p0    , p5    , p125
      PARAMETER( p0=0.0, p5=0.5, p125=0.125 )
      INTEGER i, j, k, im1, ip1, jm1, jp1
      _RL tempvar2, epsLoc, epsLocSq
      _RL recip_Cp

      _RL work3 ( 1-OLx:sNx+OLx, 1-OLy:sNy+OLy                )

#ifdef KPP_ESTIMATE_UREF
c     z0     (nx,ny)       - Roughness length                             (m)
c     zRef   (nx,ny)       - Reference depth: Hmix * epsilon              (m)
c     uRef   (nx,ny)       - Reference zonal velocity                   (m/s)
c     vRef   (nx,ny)       - Reference meridional velocity              (m/s)
      INTEGER kTmp
      _RL tempvar1, dBdz1, dBdz2, ustarX, ustarY, zFac
      _RL z0    ( 1-OLx:sNx+OLx, 1-OLy:sNy+OLy                )
      _RL zRef  ( 1-OLx:sNx+OLx, 1-OLy:sNy+OLy                )
      _RL uRef  ( 1-OLx:sNx+OLx, 1-OLy:sNy+OLy                )
      _RL vRef  ( 1-OLx:sNx+OLx, 1-OLy:sNy+OLy                )
#endif
#ifdef ALLOW_SALT_PLUME
#ifdef SALT_PLUME_VOLUME
      INTEGER kp1
      _RL temparray   (1-OLx:sNx+OLx, 1-OLy:sNy+OLy           )
#endif /* SALT_PLUME_VOLUME */
#endif /* ALLOW_SALT_PLUME */
CEOP

C------------------------------------------------------------------------
C     friction velocity, turbulent and radiative surface buoyancy forcing
C     -------------------------------------------------------------------
C     taux / rho = surfForcU                               (N/m^2)
C     tauy / rho = surfForcV                               (N/m^2)
C     ustar = sqrt( sqrt( taux^2 + tauy^2 ) / rho )        (m/s)
C     bo    = - g * ( alpha*surfForcT +
C                     beta *surfForcS ) / rho              (m^2/s^3)
C     bosol = - g * alpha * Qsw * drF(1) / rho             (m^2/s^3)
C     boplume =-g * ( beta *saltPlumeFlux/rhoConst )/rho   (m^2/s^3)
C             =-g * ( beta *SPforcS      /rhoConst )/rho   (m^2/s^3)
C              -g * (alpha *SPforcT/Cp   /rhoConst )/rho   (m^2/s^3)
C------------------------------------------------------------------------

      recip_Cp = 1. _d 0 / HeatCapacity_Cp
C initialize arrays to zero
      DO j = 1-OLy, sNy+OLy
       DO i = 1-OLx, sNx+OLx
        ustar(i,j) = p0
        bo   (i,j) = p0
        bosol(i,j) = p0
       ENDDO
      ENDDO
#ifdef ALLOW_SALT_PLUME
      DO k = 1, Nrp1
       DO j = 1-OLy, sNy+OLy
        DO i = 1-OLx, sNx+OLx
         boplume(i,j,k) = p0
        ENDDO
       ENDDO
      ENDDO
#endif /* ALLOW_SALT_PLUME */

      DO j = jmin, jmax
       jp1 = j + 1
       DO i = imin, imax
        ip1 = i+1
        work3(i,j) =
     &   (surfForcU(i,j,bi,bj) + surfForcU(ip1,j,bi,bj)) *
     &   (surfForcU(i,j,bi,bj) + surfForcU(ip1,j,bi,bj)) +
     &   (surfForcV(i,j,bi,bj) + surfForcV(i,jp1,bi,bj)) *
     &   (surfForcV(i,j,bi,bj) + surfForcV(i,jp1,bi,bj))
       ENDDO
      ENDDO
      epsLocSq = phepsi*phepsi*drF(1)*drF(1)
      epsLoc   = SQRT ( p5*phepsi*drF(1) )
      DO j = jmin, jmax
       DO i = imin, imax

        IF ( work3(i,j) .lt. epsLocSq ) THEN
           ustar(i,j) = epsLoc
        ELSE
           tempVar2 =  SQRT( work3(i,j) ) * p5
           ustar(i,j) = SQRT( tempVar2 )
        ENDIF

       ENDDO
      ENDDO

C     I would like to replace 4 instances of 1/rhoSurf by multiplication
C     but this changes results in lab_sea.hb87/salt_plume, natl_box, and
C     seaice_obcs, so maybe later
CML      DO j = jmin, jmax
CML       DO i = imin, imax
CMLC     rhoSurf = dRho + rhoConst > 0 always, so we are safe here
CML        work3(i,j) = 1. _d 0 / rhoSurf(i,j)
CML       ENDDO
CML      ENDDO

      DO j = jmin, jmax
       DO i = imin, imax
        bo(i,j) = - gravity *
     &       ( TTALPHA(i,j,1) * (surfForcT(i,j,bi,bj)+
     &       surfForcTice(i,j,bi,bj)) +
     &       SSBETA(i,j,1) * surfForcS(i,j,bi,bj) )
     &       / rhoSurf(i,j)
CML  &       * work3(i,j)
       ENDDO
      ENDDO
      IF ( selectPenetratingSW .GE. 1 ) THEN
       DO j = jmin, jmax
        DO i = imin, imax
         bosol(i,j) = gravity * TTALPHA(i,j,1) * Qsw(i,j,bi,bj)
     &       *recip_Cp*recip_rhoConst
     &       / rhoSurf(i,j)
CML  &       * work3(i,j)
        ENDDO
       ENDDO
      ENDIF

#ifdef ALLOW_SALT_PLUME
Catn: need check sign of SPforcT
Cnote: on input, if notdef salt_plume_volume, SPforc[S,T](k>1)=!0
      IF ( useSALT_PLUME ) THEN
#ifdef SALT_PLUME_VOLUME
       DO k = 1, Nr
        kp1 = k+1
        DO j = jmin, jmax
         DO i = imin, imax
          temparray(i,j) = - gravity *
     &            ( SSBETA(i,j,k) * SPforcS(i,j,k) +
     &              TTALPHA(i,j,k)* SPforcT(i,j,k) / HeatCapacity_Cp )
     &              * recip_rhoConst / rhoSurf(i,j)
CML  &              * recip_rhoConst * work3(i,j)
          boplume(i,j,kp1) = boplume(i,j,k)+temparray(i,j)
         ENDDO
        ENDDO
       ENDDO
#else /* SALT_PLUME_VOLUME */
       DO j = jmin, jmax
        DO i = imin, imax
C     initialization has been done already and does not have to be
C     repeated here (and definitely not inside the i/j loops)
CML         DO k = 2, Nrp1
CML          boplume(i,j,k) = 0. _d 0
CML         ENDDO
         boplume(i,j,1) = - gravity * SSBETA(i,j,1)
     &              * SPforcS(i,j,1)
     &              * recip_rhoConst / rhoSurf(i,j)
CML  &              * recip_rhoConst * work3(i,j)
        ENDDO
       ENDDO
#endif /* SALT_PLUME_VOLUME */
      ENDIF
#endif /* ALLOW_SALT_PLUME */

#ifdef ALLOW_DIAGNOSTICS
      IF ( useDiagnostics ) THEN
       CALL DIAGNOSTICS_FILL(bo     ,'KPPbo   ',0,1,2,bi,bj,myThid)
       CALL DIAGNOSTICS_FILL(bosol  ,'KPPbosol',0,1,2,bi,bj,myThid)
#ifdef ALLOW_SALT_PLUME
       CALL DIAGNOSTICS_FILL(boplume,'KPPboplm',0,Nr,2,bi,bj,myThid)
#endif /* ALLOW_SALT_PLUME */
      ENDIF
#endif /* ALLOW_DIAGNOSTICS */

C------------------------------------------------------------------------
C     velocity shear
C     --------------
C     Get velocity shear squared, averaged from "u,v-grid"
C     onto "t-grid" (in (m/s)**2):
C     dVsq(k)=(Uref-U(k))**2+(Vref-V(k))**2      at grid levels
C------------------------------------------------------------------------

C initialize arrays to zero
      DO k = 1, Nr
       DO j = 1-OLy, sNy+OLy
        DO i = 1-OLx, sNx+OLx
         dVsq(i,j,k) = p0
        ENDDO
       ENDDO
      ENDDO

C     dVsq computation

#ifdef KPP_ESTIMATE_UREF

C     Get rid of vertical resolution dependence of dVsq term by
C     estimating a surface velocity that is independent of first level
C     thickness in the model.  First determine mixed layer depth hMix.
C     Second zRef = espilon * hMix.  Third determine roughness length
C     scale z0.  Third estimate reference velocity.
CML   Comment: so far this code only handles the case of coarse resolution.
CML   High resolution, i.e. the case zref=hMix*epsilon > drF(1), is not
CML   handled by this code.

      zFac = ABS(rF(3)) * LOG ( rF(3) / rF(2) ) * recip_drF(2)
      DO j = jmin, jmax
       jp1 = j + 1
       DO i = imin, imax
        ip1 = i + 1

C     Determine mixed layer depth hMix as the shallowest depth at which
C     dB/dz exceeds 5.2e-5 s^-2.
        kTmp = nzmax(i,j,bi,bj)
        DO k = Nr, 1, -1
         IF ( k .LT. nzmax(i,j,bi,bj) .AND.
     &        maskC(i,j,k,bi,bj) .GT. 0. .AND.
     &        dbloc(i,j,k) * recip_drC(k+1) .GT. dB_dz )
     &        kTmp = k
        ENDDO

C     Linearly interpolate to find hMix.
        k = kTmp
        IF ( k .EQ. 0 .OR. nzmax(i,j,bi,bj) .EQ. 1 ) THEN
         zRef(i,j) = p0
        ELSEIF ( k .EQ. 1) THEN
         dBdz2 = dbloc(i,j,1) *recip_drC(2)
         zRef(i,j) = drF(1) * dB_dz / dBdz2
        ELSEIF ( k .LT. nzmax(i,j,bi,bj) ) THEN
         dBdz1 = dbloc(i,j,k-1) * recip_drC(k  )
         dBdz2 = dbloc(i,j,k  ) * recip_drC(k+1)
         zRef(i,j) = ABS(rF(k)) + drF(k) * (dB_dz - dBdz1) /
     &        MAX ( phepsi, dBdz2 - dBdz1 )
        ELSE
         zRef(i,j) = ABS(rF(k+1))
        ENDIF

C     Compute roughness length scale z0 subject to 0 < z0
        tempVar1 = p5 * (
     &       (uVel(i,  j,  1,bi,bj)-uVel(i,  j,  2,bi,bj)) *
     &       (uVel(i,  j,  1,bi,bj)-uVel(i,  j,  2,bi,bj)) +
     &       (uVel(ip1,j,  1,bi,bj)-uVel(ip1,j,  2,bi,bj)) *
     &       (uVel(ip1,j,  1,bi,bj)-uVel(ip1,j,  2,bi,bj)) +
     &       (vVel(i,  j,  1,bi,bj)-vVel(i,  j,  2,bi,bj)) *
     &       (vVel(i,  j,  1,bi,bj)-vVel(i,  j,  2,bi,bj)) +
     &       (vVel(i,  jp1,1,bi,bj)-vVel(i,  jp1,2,bi,bj)) *
     &       (vVel(i,  jp1,1,bi,bj)-vVel(i,  jp1,2,bi,bj)) )
        IF ( tempVar1 .lt. (epsln*epsln) ) THEN
         tempVar2 = epsln
        ELSE
         tempVar2 = SQRT ( tempVar1 )
        ENDIF
C     ustar > sqrt(0.5*drF(1)*phepsi) by definition, so I do not know
C     why this extra max function call is required. Too small ustar
C     will lead to negative z0, which is caught in the next line
        z0(i,j) = drF(1) * ( zFac - tempVar2 * vonK / ustar(i,j) )
CML     &       ( zFac - tempVar2 * vonK / MAX ( ustar(i,j), phepsi ) )
        z0(i,j) = MAX ( z0(i,j), phepsi )

C     zRef is set to 0.1 * hMix subject to z0 <= zRef <= drF(1)
        zRef(i,j) = MAX ( epsilon * zRef(i,j), z0(i,j) )
C     with this statement the high resolution case zRef > drF(1) is ruled out
C     so we comment it out
CML        zRef(i,j) = MIN ( zRef(i,j), drF(1) )

C     Estimate reference velocity uRef and vRef.
        uRef(i,j) = p5 * ( uVel(i,j,1,bi,bj) + uVel(ip1,j,1,bi,bj) )
        vRef(i,j) = p5 * ( vVel(i,j,1,bi,bj) + vVel(i,jp1,1,bi,bj) )
        IF ( zRef(i,j) .LT. drF(1) ) THEN
         ustarX = ( surfForcU(i,  j,bi,bj) +
     &        surfForcU(ip1,j,bi,bj) ) * p5 *recip_drF(1)
         ustarY = ( surfForcV(i,j,  bi,bj) +
     &        surfForcV(i,jp1,bi,bj) ) * p5 *recip_drF(1)
         tempVar1 = ustarX * ustarX + ustarY * ustarY
         if ( tempVar1 .lt. (epsln*epsln) ) then
          tempVar2 = epsln
         else
          tempVar2 = SQRT ( tempVar1 )
         endif
         tempVar2 = ustar(i,j) *
     &        ( LOG ( zRef(i,j) * recip_drF(1) ) +
     &        z0(i,j) / zRef(i,j) - z0(i,j) * recip_drF(1) ) /
     &        vonK / tempVar2
         uRef(i,j) = uRef(i,j) + ustarX * tempVar2
         vRef(i,j) = vRef(i,j) + ustarY * tempVar2
        ELSEIF ( zRef(i,j) .GE. drF(1) ) THEN
C     if zref > drF(1), average over zref
         uRef(i,j) = uRef(i,j)*drF(1)
         vRef(i,j) = vRef(i,j)*drF(1)
         k = 2
         DO WHILE ( ABS(rF(k+1)) .LE. zRef(i,j) )
          uRef(i,j) = uRef(i,j) + drF(k) * p5
     &         * ( uVel(i,j,k,bi,bj) + uVel(ip1,j,k,bi,bj) )
          vRef(i,j) = vRef(i,j) + drF(k) * p5
     &         * ( vVel(i,j,k,bi,bj) + vVel(i,jp1,k,bi,bj) )
          k = k+1
         ENDDO
C     now k should be the index of the layer into which zref reaches
         uRef(i,j) = uRef(i,j) + MAX(0.,zref(i,j)-ABS(rF(k))) * p5
     &        * ( uVel(i,j,k,bi,bj) + uVel(ip1,j,k,bi,bj) )
         vRef(i,j) = vRef(i,j) + MAX(0.,zref(i,j)-ABS(rF(k))) * p5
     &        * ( vVel(i,j,k,bi,bj) + vVel(i,jp1,k,bi,bj) )
         uRef(i,j) = uRef(i,j)/zRef(i,j)
         vRef(i,j) = vRef(i,j)/zRef(i,j)
        ENDIF

       ENDDO
      ENDDO

      DO k = 1, Nr
       DO j = jmin, jmax
        jm1 = j - 1
        jp1 = j + 1
        DO i = imin, imax
         im1 = i - 1
         ip1 = i + 1
         dVsq(i,j,k) = p5 * (
     &        (uRef(i,j) - uVel(i,  j,  k,bi,bj)) *
     &        (uRef(i,j) - uVel(i,  j,  k,bi,bj)) +
     &        (uRef(i,j) - uVel(ip1,j,  k,bi,bj)) *
     &        (uRef(i,j) - uVel(ip1,j,  k,bi,bj)) +
     &        (vRef(i,j) - vVel(i,  j,  k,bi,bj)) *
     &        (vRef(i,j) - vVel(i,  j,  k,bi,bj)) +
     &        (vRef(i,j) - vVel(i,  jp1,k,bi,bj)) *
     &        (vRef(i,j) - vVel(i,  jp1,k,bi,bj)) )
#ifdef KPP_SMOOTH_DVSQ
         dVsq(i,j,k) = p5 * dVsq(i,j,k) + p125 * (
     &        (uRef(i,j) - uVel(i,  jm1,k,bi,bj)) *
     &        (uRef(i,j) - uVel(i,  jm1,k,bi,bj)) +
     &        (uRef(i,j) - uVel(ip1,jm1,k,bi,bj)) *
     &        (uRef(i,j) - uVel(ip1,jm1,k,bi,bj)) +
     &        (uRef(i,j) - uVel(i,  jp1,k,bi,bj)) *
     &        (uRef(i,j) - uVel(i,  jp1,k,bi,bj)) +
     &        (uRef(i,j) - uVel(ip1,jp1,k,bi,bj)) *
     &        (uRef(i,j) - uVel(ip1,jp1,k,bi,bj)) +
     &        (vRef(i,j) - vVel(im1,j,  k,bi,bj)) *
     &        (vRef(i,j) - vVel(im1,j,  k,bi,bj)) +
     &        (vRef(i,j) - vVel(im1,jp1,k,bi,bj)) *
     &        (vRef(i,j) - vVel(im1,jp1,k,bi,bj)) +
     &        (vRef(i,j) - vVel(ip1,j,  k,bi,bj)) *
     &        (vRef(i,j) - vVel(ip1,j,  k,bi,bj)) +
     &        (vRef(i,j) - vVel(ip1,jp1,k,bi,bj)) *
     &        (vRef(i,j) - vVel(ip1,jp1,k,bi,bj)) )
#endif /* KPP_SMOOTH_DVSQ */
        ENDDO
       ENDDO
      ENDDO

#else /* KPP_ESTIMATE_UREF */

      DO k = 1, Nr
       DO j = jmin, jmax
        jm1 = j - 1
        jp1 = j + 1
        DO i = imin, imax
         im1 = i - 1
         ip1 = i + 1
         dVsq(i,j,k) = p5 * (
     &        (uVel(i,  j,  1,bi,bj)-uVel(i,  j,  k,bi,bj)) *
     &        (uVel(i,  j,  1,bi,bj)-uVel(i,  j,  k,bi,bj)) +
     &        (uVel(ip1,j,  1,bi,bj)-uVel(ip1,j,  k,bi,bj)) *
     &        (uVel(ip1,j,  1,bi,bj)-uVel(ip1,j,  k,bi,bj)) +
     &        (vVel(i,  j,  1,bi,bj)-vVel(i,  j,  k,bi,bj)) *
     &        (vVel(i,  j,  1,bi,bj)-vVel(i,  j,  k,bi,bj)) +
     &        (vVel(i,  jp1,1,bi,bj)-vVel(i,  jp1,k,bi,bj)) *
     &        (vVel(i,  jp1,1,bi,bj)-vVel(i,  jp1,k,bi,bj)) )
#ifdef KPP_SMOOTH_DVSQ
         dVsq(i,j,k) = p5 * dVsq(i,j,k) + p125 * (
     &        (uVel(i,  jm1,1,bi,bj)-uVel(i,  jm1,k,bi,bj)) *
     &        (uVel(i,  jm1,1,bi,bj)-uVel(i,  jm1,k,bi,bj)) +
     &        (uVel(ip1,jm1,1,bi,bj)-uVel(ip1,jm1,k,bi,bj)) *
     &        (uVel(ip1,jm1,1,bi,bj)-uVel(ip1,jm1,k,bi,bj)) +
     &        (uVel(i,  jp1,1,bi,bj)-uVel(i,  jp1,k,bi,bj)) *
     &        (uVel(i,  jp1,1,bi,bj)-uVel(i,  jp1,k,bi,bj)) +
     &        (uVel(ip1,jp1,1,bi,bj)-uVel(ip1,jp1,k,bi,bj)) *
     &        (uVel(ip1,jp1,1,bi,bj)-uVel(ip1,jp1,k,bi,bj)) +
     &        (vVel(im1,j,  1,bi,bj)-vVel(im1,j,  k,bi,bj)) *
     &        (vVel(im1,j,  1,bi,bj)-vVel(im1,j,  k,bi,bj)) +
     &        (vVel(im1,jp1,1,bi,bj)-vVel(im1,jp1,k,bi,bj)) *
     &        (vVel(im1,jp1,1,bi,bj)-vVel(im1,jp1,k,bi,bj)) +
     &        (vVel(ip1,j,  1,bi,bj)-vVel(ip1,j,  k,bi,bj)) *
     &        (vVel(ip1,j,  1,bi,bj)-vVel(ip1,j,  k,bi,bj)) +
     &        (vVel(ip1,jp1,1,bi,bj)-vVel(ip1,jp1,k,bi,bj)) *
     &        (vVel(ip1,jp1,1,bi,bj)-vVel(ip1,jp1,k,bi,bj)) )
#endif /* KPP_SMOOTH_DVSQ */
        ENDDO
       ENDDO
      ENDDO

#endif /* KPP_ESTIMATE_UREF */

#ifdef ALLOW_DIAGNOSTICS
      IF ( useDiagnostics ) THEN
       CALL DIAGNOSTICS_FILL(dVsq,  'KPPdVsq ',0,Nr,2,bi,bj,myThid)
      ENDIF
#endif /* ALLOW_DIAGNOSTICS */

      RETURN
      END

#include "MOM_FLUXFORM_OPTIONS.h"
#ifdef ALLOW_MOM_COMMON
# include "MOM_COMMON_OPTIONS.h"
#endif

CBOP
C !ROUTINE: MOM_V_XVISCFLUX

C !INTERFACE: ==========================================================
      SUBROUTINE MOM_V_XVISCFLUX(
     I        bi,bj,k,
     I        vFld, del2v, hFacZ,
     O        xViscFluxV,
     I        viscAh_Z,viscA4_Z,
     I        myThid )

C !DESCRIPTION:
C Calculates the area integrated zonal viscous fluxes of V:
C \begin{equation*}
C F^x = - \frac{ \Delta x_u \Delta r_f h_z }{\Delta x_v}
C  ( A_h \delta_i v - A_4 \delta_i \nabla^2 v )
C \end{equation*}

C !USES: ===============================================================
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"

C !INPUT PARAMETERS: ===================================================
C  bi,bj                :: tile indices
C  k                    :: vertical level
C  vFld                 :: meridional flow
C  del2v                :: Laplacian of meridional flow
C  myThid               :: thread number
      INTEGER bi,bj,k
      _RL vFld(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL del2v(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RS hFacZ(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL viscAh_Z(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL viscA4_Z(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER myThid

C !OUTPUT PARAMETERS: ==================================================
C  xViscFluxU           :: viscous fluxes
      _RL xViscFluxV(1-OLx:sNx+OLx,1-OLy:sNy+OLy)

C !LOCAL VARIABLES: ====================================================
C  i,j                  :: loop indices
      INTEGER i,j
CEOP

C     - Laplacian  and bi-harmonic terms
      DO j=1-OLy,sNy+OLy
       DO i=1-OLx+1,sNx+OLx
        xViscFluxV(i,j) =
     &    _dyU(i,j,bi,bj)*drF(k)*hFacZ(i,j)
     &     *(
     &       -viscAh_Z(i,j)*( vFld(i,j)-vFld(i-1,j) )
     &       *cosFacV(j,bi,bj)
     &       +viscA4_Z(i,j)*(del2v(i,j)-del2v(i-1,j))
#ifdef COSINEMETH_III
     &       *sqCosFacV(j,bi,bj)
#else
     &       *cosFacV(j,bi,bj)
#endif
     &      )*_recip_dxV(i,j,bi,bj)
c    &       *deepFacC(k)        ! dyU scaling factor
c    &       *recip_deepFacC(k)  ! recip_dxV scaling factor
       ENDDO
      ENDDO

      RETURN
      END

#include "AUTODIFF_OPTIONS.h"
#ifdef ALLOW_OPENAD
# include "OPENAD_OPTIONS.h"
#endif
#ifdef ALLOW_CTRL
# include "CTRL_OPTIONS.h"
#endif
#include "AD_CONFIG.h"

CBOP
C     !ROUTINE: ADDUMMY_FOR_ETAN
C     !INTERFACE:
      SUBROUTINE ADDUMMY_FOR_ETAN( myTime, myIter, myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE ADDUMMY_FOR_ETAN                              |
C     *==========================================================*
C     Extract adjoint variable for sea level height
C     from TAF-generated
C     adjoint common blocks, contained in adcommon.h
C     and write fields to file;
C     Make sure common blocks in adcommon.h are up-to-date
C     w.r.t. current adjoint code.
C
C     This dummy routine is located inside integr_continuity
C     to get the impact of rstar or surf_dr adjoint
C     variables on adEtaN.
C
C     This does not use the diagnostics package because adEtaN is a
C     "half" time step away from the other adjoint variables, but would
C     have to be written at the same time.
C
C     Created: Tim Smith, tsmith@ices.utexas.edu, Sept 12 2018
C     *==========================================================*
C     | SUBROUTINE ADDUMMY_FOR_ETAN                              |
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     == Global variables ===
#ifdef ALLOW_OPENAD
      use OAD_active
      use OAD_rev
      use OAD_tape
      use OAD_cp
#endif
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#ifdef ALLOW_AUTODIFF_MONITOR
# ifdef ALLOW_OPENAD
#  include "DYNVARS.h"
# endif
# include "AUTODIFF_PARAMS.h"
# include "AUTODIFF.h"
# ifndef ALLOW_OPENAD
#  include "adcommon.h"
# endif /* ALLOW_OPENAD */
# ifdef ALLOW_MNC
#  include "MNC_PARAMS.h"
# endif
#endif /* ALLOW_AUTODIFF_MONITOR */

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     myTime  :: time counter for this thread
C     myIter  :: iteration counter for this thread
C     myThid  :: Thread number for this instance of the routine.
      _RL myTime
      INTEGER myIter
      INTEGER myThid

#if (defined (ALLOW_ADJOINT_RUN) || defined (ALLOW_ADMTLM))
#ifdef ALLOW_AUTODIFF_MONITOR

C     !FUNCTIONS:
      LOGICAL  DIFFERENT_MULTIPLE
      EXTERNAL DIFFERENT_MULTIPLE

C     !LOCAL VARIABLES:
C     == local variables ==
C     suff    :: Hold suffix part of a filename
C     msgBuf  :: Error message buffer
c     CHARACTER*(10) suff
c     CHARACTER*(MAX_LEN_MBUF) msgBuf
      _RS dumRS(1)
      LOGICAL doDump
CEOP

      doDump = DIFFERENT_MULTIPLE(adjDumpFreq,myTime,deltaTClock)

      IF ( doDump ) THEN
C increment ad dump record number (used only if dumpAdByRec is true)
C could be just dumpAdRecEt=dumpAdRecMn+1 ????
       dumpAdRecEt = dumpAdRecEt + 1
       CALL TIMER_START('I/O (WRITE)        [ADJOINT LOOP]', myThid )
      ENDIF

#ifndef ALLOW_OPENAD
      CALL DUMP_ADJ_XY(dumRS, adetan, 'ADJetan ', 'ADJetan.',
     &                 12, doDump, dumpAdRecEt, myTime, myIter,myThid)
#else /* ndef ALLOW_OPENAD */
      CALL DUMP_ADJ_XY(dumRS, etaN%d, 'ADJetan ', 'ADJetan.',
     &                 12, doDump, dumpAdRecEt, myTime, myIter,myThid)
#endif /* ndef ALLOW_OPENAD */

      IF ( doDump ) THEN

C-- NOW NMC output
#ifndef ALLOW_OPENAD
#ifdef ALLOW_MNC
        IF ( useMNC .AND. autodiff_mnc ) THEN
         CALL MNC_CW_SET_UDIM('adstate', -1, myThid)
         CALL MNC_CW_RL_W_S('D','adstate',0,0,'T',myTime,myThid)
         CALL MNC_CW_SET_UDIM('adstate', 0, myThid)
         CALL MNC_CW_I_W_S('I','adstate',0,0,'iter',myIter,myThid)
         CALL MNC_CW_RL_W_S('D','adstate',0,0,'model_time',myTime,
     &        myThid)
         CALL MNC_CW_RL_W('D','adstate',0,0,'adEta', adEtaN, myThid)
C     endif mnc
        ENDIF
#endif /* ALLOW_MNC */
#endif /* ALLOW_OPENAD */

        CALL TIMER_STOP( 'I/O (WRITE)        [ADJOINT LOOP]', myThid )

      ENDIF

#endif /* ALLOW_AUTODIFF_MONITOR */
#endif /* ALLOW_ADJOINT_RUN */

      RETURN
      END

#include "CPP_OPTIONS.h"

CBOP
C     !ROUTINE: INI_VERTICAL_GRID
C     !INTERFACE:
      SUBROUTINE INI_VERTICAL_GRID( myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE INI_VERTICAL_GRID
C     | o Initialise vertical gridding arrays
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     myThid   :: my Thread Id number
      INTEGER myThid

C     !LOCAL VARIABLES:
C     == Local variables ==
C     k        :: loop index
C     msgBuf   :: Informational/error message buffer
      INTEGER k
      _RL     tmpRatio, checkRatio1, checkRatio2
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      _RL maxErrC, maxErrF, epsil, tmpError
      _RL rFullDepth, recip_fullDepth
      _RS rSigBndRS, tmpRS
CEOP

      _BEGIN_MASTER(myThid)

      WRITE(msgBuf,'(A,2(A,L5))') 'Enter INI_VERTICAL_GRID:',
     &                            ' setInterFDr=', setInterFDr,
     &                          ' ; setCenterDr=', setCenterDr
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )

C--   Set factors required for mixing pressure and meters as vertical coordinate.
C     rkSign is a "sign" parameter which is used where the orientation of the vertical
C     coordinate (pressure or meters) relative to the vertical index (k) is important.
C     rkSign = -1 applies when k and the coordinate are in the opposite sense.
C     rkSign =  1 applies when k and the coordinate are in the same sense.
      rkSign       = -1. _d 0
      gravitySign  = -1. _d 0
      IF ( usingPCoords ) THEN
         gravitySign = 1. _d 0
      ENDIF

      IF ( .NOT.(setInterFDr.OR.setCenterDr) ) THEN
        WRITE(msgBuf,'(A)')
     &  'S/R INI_VERTICAL_GRID: neither delR nor delRc are defined'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(A)')
     &  'S/R INI_VERTICAL_GRID: Need at least 1 of the 2 (delR,delRc)'
        CALL PRINT_ERROR( msgBuf, myThid )
        STOP 'ABNORMAL END: S/R INI_VERTICAL_GRID'
      ENDIF

C---  Set Level r-thickness (drF) and Center r-distances (drC)

      IF (setInterFDr) THEN
C--   Interface r-distances are defined:
       DO k=1,Nr
         drF(k) = delR(k)
       ENDDO
C-    Check that all thickness are > 0 :
       DO k=1,Nr
        IF (delR(k).LE.0.) THEN
         WRITE(msgBuf,'(A,I4,A,E16.8)')
     &  'S/R INI_VERTICAL_GRID: delR(k=',k,' )=',delR(k)
         CALL PRINT_ERROR( msgBuf, myThid )
         WRITE(msgBuf,'(A)')
     &  'S/R INI_VERTICAL_GRID: Vert. grid spacing MUST BE > 0'
         CALL PRINT_ERROR( msgBuf, myThid )
         STOP 'ABNORMAL END: S/R INI_VERTICAL_GRID'
        ENDIF
       ENDDO
      ELSE
C--   Interface r-distances undefined:
C     assume Interface at middle between 2 Center
       drF(1) = delRc(1)
       DO k=2,Nr
c        drF(k-1) = 0.5 _d 0 *delRc(k) + drF(k-1)
c        drF( k ) = 0.5 _d 0 *delRc(k)
C- note: change the order to prevent some compilers to produce wrong code
C        when trying to optimise this loop :
         drF( k ) = 0.5 _d 0 *delRc(k)
         drF(k-1) = 0.5 _d 0 *delRc(k) + drF(k-1)
       ENDDO
       drF(Nr) = delRc(Nr+1) + drF(Nr)
      ENDIF

      IF (setCenterDr) THEN
C--   Cell Center r-distances are defined:
       DO k=1,Nr+1
         drC(k) = delRc(k)
       ENDDO
C-    Check that all thickness are > 0 :
       DO k=1,Nr+1
        IF (delRc(k).LE.0.) THEN
         WRITE(msgBuf,'(A,I4,A,E16.8)')
     &  'S/R INI_VERTICAL_GRID: delRc(k=',k,' )=',delRc(k)
         CALL PRINT_ERROR( msgBuf, myThid )
         WRITE(msgBuf,'(A)')
     &  'S/R INI_VERTICAL_GRID: Vert. grid spacing MUST BE > 0'
         CALL PRINT_ERROR( msgBuf, myThid )
         STOP 'ABNORMAL END: S/R INI_VERTICAL_GRID'
        ENDIF
       ENDDO
      ELSE
C--   Cell Center r-distances undefined:
C     assume Center at middle between 2 Interfaces
       drC(1)  = 0.5 _d 0 *delR(1)
       DO k=2,Nr
         drC(k) = 0.5 _d 0 *(delR(k-1)+delR(k))
       ENDDO
       drC(Nr+1) = 0.5 _d 0 *delR(Nr)
      ENDIF

C---  Set r-position of  interFace (rF) and cell-Center (rC):
C --  Use top_Pres or seaLev_Z to set vertical axis position:
C OCN in Z: top_Pres(Ref) (= rhoConst*PhiRef(1)), seaLev_Z (=rF(1), @ the top)
C ATM in Z: top_Pres(Ref) (= rhoConst*PhiRef(1)), seaLev_Z (=rF(Nr+1), @ bottom)
C OCN in P: top_Pres (=rF(Nr+1)), seaLev_Z (<-> PhiRef(Nr+1)/g, @ the top)
C ATM in P: top_Pres (=rF(Nr+1)), seaLev_Z (<-> PhiRef(1)/g, @ the bottom)
      IF ( rF(1).EQ.UNSET_RS .AND.
     &     usingZCoords.AND.fluidIsWater ) THEN
        rF(1) = seaLev_Z
      ENDIF
      IF ( rF(1).NE.UNSET_RS ) THEN
        DO k=1,Nr
          rF(k+1) = rF(k) + rkSign*drF(k)
        ENDDO
        rC(1)   = rF(1)   + rkSign*drC(1)
        DO k=2,Nr
          rC(k) = rC(k-1) + rkSign*drC(k)
        ENDDO
c       IF ( usingPCoords ) THEN
c         top_Pres = rF(Nr+1)
c       ELSEIF ( fluidIsWater ) THEN
c         seaLev_Z = rF(1)
c       ELSE
c         seaLev_Z = rF(Nr+1)
c       ENDIF
      ELSE
        IF ( usingPCoords ) THEN
          rF(Nr+1) = top_Pres
        ELSE
          rF(Nr+1) = seaLev_Z
        ENDIF
        DO k=Nr,1,-1
          rF(k) = rF(k+1) - rkSign*drF(k)
        ENDDO
        rC(Nr) = rF(Nr+1) - rkSign*drC(Nr+1)
        DO k=Nr,2,-1
          rC(k-1) = rC(k) - rkSign*drC(k)
        ENDDO
      ENDIF

C---  Check vertical discretization :
      checkRatio2 = 100.
      checkRatio1 = 1. _d 0 / checkRatio2
      DO k=1,Nr
       tmpRatio = 0.
       IF ( (rC(k)-rF(k+1)) .NE. 0. )
     &   tmpRatio = (rF(k)-rC(k)) / (rC(k)-rF(k+1))
       IF ( tmpRatio.LT.checkRatio1 .OR. tmpRatio.GT.checkRatio2 ) THEN
c       write(0,*) 'drF=',drF
c       write(0,*) 'drC=',drC
c       write(0,*) 'rF=',rF
c       write(0,*) 'rC=',rC
        WRITE(msgBuf,'(A,I4,A,E16.8)')
     &   'S/R INI_VERTICAL_GRID: Invalid relative position, level k=',
     &     k, ' :', tmpRatio
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(A,1PE14.6,A,2E14.6)')
     &   'S/R INI_VERTICAL_GRID: rC=', rC(k),
     &   ' , rF(k,k+1)=',rF(k),rF(k+1)
        CALL PRINT_ERROR( msgBuf, myThid )
        STOP 'ABNORMAL END: S/R INI_VERTICAL_GRID'
       ENDIF
      ENDDO

C-    Calculate reciprol vertical grid spacing :
      DO k=1,Nr+1
       recip_drC(k)   = 1. _d 0/drC(k)
      ENDDO
      DO k=1,Nr
       recip_drF(k)   = 1. _d 0/drF(k)
      ENDDO

C---  Hybrid-Sigma vertical coordinate:
      IF ( selectSigmaCoord .EQ. 0 ) THEN
       DO k=1,Nr+1
         aHybSigmF(k) = 0. _d 0
         bHybSigmF(k) = 0. _d 0
         dAHybSigC(k) = 0. _d 0
         dAHybSigC(k) = 0. _d 0
       ENDDO
       DO k=1,Nr
         aHybSigmC(k) = 0. _d 0
         bHybSigmC(k) = 0. _d 0
         dAHybSigF(k) = 0. _d 0
         dAHybSigF(k) = 0. _d 0
       ENDDO
      ELSE
       rFullDepth = rF(1) - rF(Nr+1)
       recip_fullDepth = 0. _d 0
       IF ( rFullDepth.GT.0. ) recip_fullDepth = 1. _d 0 / rFullDepth
       rSigBndRS = rSigmaBnd
       IF ( hybSigmFile.EQ.' ' .AND. rSigmaBnd.EQ.UNSET_RL ) THEN
C-    Default is pure sigma:
         IF ( usingPCoords ) rSigBndRS = rF(Nr+1)
         IF ( usingZCoords ) rSigBndRS = rF(1)
       ENDIF
c      IF ( hybSigmFile.EQ.' ' .AND. rSigmaBnd.EQ.UNSET_RL ) THEN
C-     compute coeff as pure sigma coordinate
c        DO k=1,Nr+1
c          aHybSigmF(k) = 0.
c          bHybSigmF(k) = (rF(k)-rF(Nr+1))*recip_fullDepth
c        ENDDO
c        DO k=1,Nr
c          aHybSigmC(k) = 0.
c          bHybSigmC(k) = (rC(k)-rF(Nr+1))*recip_fullDepth
c        ENDDO
c      ELSEIF ( hybSigmFile.EQ.' ' ) THEN
       IF ( hybSigmFile.EQ.' ' ) THEN
C--    compute coeff assuming fixed r-coord above rSigmaBnd and pure sigma below
        IF ( usingPCoords .AND. setInterFDr ) THEN
C-     Alternative method : p = pTop + A*DeltaFullP + B*(eta+Pr_surf - rSigmaBnd)
c          aHybSigmF(k) = ( MIN(rF(k),rSigmaBnd) - rF(Nr+1) )
c    &                   *recip_fullDepth
c          bHybSigmF(k) = ( MAX(rF(k),rSigmaBnd) - rSigmaBnd )
c    &                   /( rF(1) - rSigmaBnd )
C-     Standard method : p = pTop + A*DeltaFullP + B*(eta+Ro_surf - pTop)
C        sigma part goes from 0 @ rSigmaBnd (and above) to 1 @ surface
         DO k=1,Nr+1
C-     separate the 2 cases:
c         IF ( rF(k).LE.rSigmaBnd ) THEN
c          bHybSigmF(k) = 0.
c          aHybSigmF(k) = ( rF(k) - rF(Nr+1) )*recip_fullDepth
c         ELSE
c          bHybSigmF(k) = (rF(k)-rSigmaBnd)/(rF(1)-rSigmaBnd)
c          aHybSigmF(k) = (1. _d 0 - bHybSigmF(k))
c    &                  *(rSigmaBnd-rF(Nr+1) )*recip_fullDepth
c         ENDIF
C-     unique formula using min fct:
          tmpRS = MIN( rF(k), rSigBndRS )
          bHybSigmF(k) = ( rF(k) - tmpRS )/(rF(1)-rSigBndRS)
          aHybSigmF(k) = (1. _d 0 - bHybSigmF(k))
     &                  *( tmpRS -rF(Nr+1) )*recip_fullDepth
         ENDDO
        ENDIF
        IF ( usingPCoords .AND. setCenterDr ) THEN
         DO k=1,Nr
C-     separate the 2 cases:
c         IF ( rC(k).LE.rSigmaBnd ) THEN
c          bHybSigmC(k) = 0.
c          aHybSigmC(k) = ( rC(k) - rF(Nr+1) )*recip_fullDepth
c         ELSE
c          bHybSigmC(k) = (rC(k)-rSigmaBnd)/(rF(1)-rSigmaBnd)
c          aHybSigmC(k) = (1. _d 0 - bHybSigmC(k))
c    &                  *(rSigmaBnd-rF(Nr+1) )*recip_fullDepth
c         ENDIF
C-     unique formula using min fct:
          tmpRS = MIN( rC(k), rSigBndRS )
          bHybSigmC(k) = ( rC(k) - tmpRS )/(rF(1)-rSigBndRS)
          aHybSigmC(k) = (1. _d 0 - bHybSigmC(k))
     &                  *( tmpRS -rF(Nr+1) )*recip_fullDepth
         ENDDO
        ENDIF
        IF ( usingZCoords .AND. setInterFDr ) THEN
C-     Standard method : z = zBot + A*DeltaFullZ + B*(eta+Ro_surf - zBot)
C        sigma part goes from 1 @ rSigmaBnd (and above) to 0 @ bottom
         DO k=1,Nr+1
C-     separate the 2 cases:
c         IF ( rF(k).GE.rSigmaBnd ) THEN
c          bHybSigmF(k) = 1.
c          aHybSigmF(k) = ( rF(k)-rF(1) )*recip_fullDepth
c         ELSE
c          bHybSigmF(k) = ( rF(k)-rF(Nr+1) )/( rSigmaBnd-rF(Nr+1) )
c          aHybSigmF(k) = bHybSigmF(k)*(rSigmaBnd-rF(1))*recip_fullDepth
c         ENDIF
C-     unique formula using max fct:
          tmpRS = MAX( rF(k), rSigBndRS )
          bHybSigmF(k) = ( rF(k)-rF(Nr+1) )/( tmpRS-rF(Nr+1) )
          aHybSigmF(k) = bHybSigmF(k)*( tmpRS-rF(1) )*recip_fullDepth
         ENDDO
        ENDIF
        IF ( usingZCoords .AND. setCenterDr ) THEN
         DO k=1,Nr
C-     separate the 2 cases:
c         IF ( rC(k).GE.rSigmaBnd ) THEN
c          bHybSigmC(k) = 1.
c          aHybSigmC(k) = ( rC(k)-rF(1) )*recip_fullDepth
c         ELSE
c          bHybSigmC(k) = ( rC(k)-rF(Nr+1) )/( rSigmaBnd-rF(Nr+1) )
c          aHybSigmC(k) = bHybSigmC(k)*(rSigmaBnd-rF(1))*recip_fullDepth
c         ENDIF
C-     unique formula using max fct:
          tmpRS = MAX( rC(k), rSigBndRS )
          bHybSigmC(k) = ( rC(k)-rF(Nr+1) )/( tmpRS-rF(Nr+1) )
          aHybSigmC(k) = bHybSigmC(k)*( tmpRS-rF(1) )*recip_fullDepth
         ENDDO
        ENDIF
       ELSE
C--    Coeff at interface are read from file
        IF (setCenterDr) THEN
         STOP 'ABNORMAL END: S/R INI_VERTICAL_GRID: Missing Code'
        ENDIF
       ENDIF

C--    Finish setting (if not done) using simple averaging
       IF ( .NOT.setInterFDr ) THEN
C-     Interface position at the middle between 2 centers
        bHybSigmF(1) = 1. _d 0
        aHybSigmF(1) = 0. _d 0
        bHybSigmF(Nr+1) = 0. _d 0
        aHybSigmF(Nr+1) = 0. _d 0
        DO k=2,Nr
          bHybSigmF(k) = ( bHybSigmC(k) + bHybSigmC(k-1) )*0.5 _d 0
          aHybSigmF(k) = ( aHybSigmC(k) + aHybSigmC(k-1) )*0.5 _d 0
        ENDDO
       ENDIF
       IF ( .NOT.setCenterDr ) THEN
C-     Center position at the middle between 2 interfaces
        DO k=1,Nr
          bHybSigmC(k) = ( bHybSigmF(k) + bHybSigmF(k+1) )*0.5 _d 0
          aHybSigmC(k) = ( aHybSigmF(k) + aHybSigmF(k+1) )*0.5 _d 0
        ENDDO
       ENDIF

C--    Vertical increment:
       DO k=1,Nr
         dAHybSigF(k) = ( aHybSigmF(k+1) - aHybSigmF(k) )*rkSign
         dBHybSigF(k) = ( bHybSigmF(k+1) - bHybSigmF(k) )*rkSign
       ENDDO
       DO k=2,Nr
         dAHybSigC(k) = ( aHybSigmC(k) - aHybSigmC(k-1) )*rkSign
         dBHybSigC(k) = ( bHybSigmC(k) - bHybSigmC(k-1) )*rkSign
       ENDDO
       dAHybSigC(1) = ( aHybSigmC(1) - aHybSigmF(1) )*rkSign
       dBHybSigC(1) = ( bHybSigmC(1) - bHybSigmF(1) )*rkSign
       dAHybSigC(Nr+1) = ( aHybSigmF(Nr+1) - aHybSigmC(Nr) )*rkSign
       dBHybSigC(Nr+1) = ( bHybSigmF(Nr+1) - bHybSigmC(Nr) )*rkSign

C--   Check for miss-match between vertical discretization :
       maxErrC = 0.
       maxErrF = 0.
       epsil = 1. _d -9
       DO k=1,Nr
         tmpError = ( rC(k)-rF(Nr+1) )*recip_fullDepth
     &            - ( aHybSigmC(k)+bHybSigmC(k) )
         IF ( ABS(tmpError).GT.epsil ) THEN
          IF ( maxErrC.LE.epsil ) THEN
           WRITE(msgBuf,'(2A)') 'S/R INI_VERTICAL_GRID:',
     &      ' rC and Hybrid-Sigma Coeff miss-match'
           CALL PRINT_ERROR( msgBuf, myThid )
          ENDIF
          WRITE(msgBuf,'(A,I4,2(A,1PE14.6),A,1P2E14.6)')
     &     ' k=', k,' , err=', tmpError, ' ; rC=', rC(k),
     &     ' , a & b=', aHybSigmC(k), bHybSigmC(k)
          CALL PRINT_ERROR( msgBuf, myThid )
         ENDIF
         maxErrC = MAX( maxErrC, ABS(tmpError) )
       ENDDO
       DO k=1,Nr+1
         tmpError = ( rF(k)-rF(Nr+1) )*recip_fullDepth
     &            - ( aHybSigmF(k)+bHybSigmF(k) )
         IF ( ABS(tmpError).GT.epsil ) THEN
          IF ( maxErrF.LE.epsil ) THEN
           WRITE(msgBuf,'(2A)') 'S/R INI_VERTICAL_GRID:',
     &      ' rF and Hybrid-Sigma Coeff miss-match'
           CALL PRINT_ERROR( msgBuf, myThid )
          ENDIF
          WRITE(msgBuf,'(A,I4,2(A,1PE14.6),A,1P2E14.6)')
     &     ' k=', k,' , err=', tmpError, ' ; rF=', rF(k),
     &     ' , a & b=', aHybSigmF(k), bHybSigmF(k)
          CALL PRINT_ERROR( msgBuf, myThid )
         ENDIF
         maxErrF = MAX( maxErrF, ABS(tmpError) )
       ENDDO
       WRITE(msgBuf,'(2A,1PE14.6)') 'S/R INI_VERTICAL_GRID:',
     &      ' matching of aHybSigmC & rC :', maxErrC
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                     SQUEEZE_RIGHT, myThid )
       WRITE(msgBuf,'(2A,1PE14.6)') 'S/R INI_VERTICAL_GRID:',
     &      ' matching of aHybSigmF & rF :', maxErrF
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                     SQUEEZE_RIGHT, myThid )
       IF ( maxErrC.GT.epsil .OR. maxErrF.GT.epsil ) THEN
         WRITE(msgBuf,'(2A)') 'S/R INI_VERTICAL_GRID:',
     &      ' rC,rF and Hybrid-Sigma Coeff miss-match'
         CALL PRINT_ERROR( msgBuf, myThid )
         STOP 'ABNORMAL END: S/R INI_VERTICAL_GRID'
       ENDIF

C---  End setting-up Hybrid-Sigma vertical coordinate:
      ENDIF

      _END_MASTER(myThid)
      _BARRIER

      RETURN
      END

#include "THSICE_OPTIONS.h"
#ifdef ALLOW_AUTODIFF
# include "AUTODIFF_OPTIONS.h"
# ifdef ALLOW_EXF
#  include "EXF_OPTIONS.h"
# endif
#endif

CBOP
C     !ROUTINE: THSICE_MAIN
C     !INTERFACE:
      SUBROUTINE THSICE_MAIN(
     I                        myTime, myIter, myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R  THSICE_MAIN
C     | o Therm_SeaIce main routine.
C     |   step forward Thermodynamic_SeaIce variables and modify
C     |    ocean surface forcing accordingly.
C     *==========================================================*

C     !USES:
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "FFIELDS.h"
#include "THSICE_PARAMS.h"
#include "THSICE_SIZE.h"
#include "THSICE_VARS.h"
#ifdef ALLOW_AUTODIFF
# include "THSICE_COST.h"
# include "DYNVARS.h"
# ifdef ALLOW_EXF
#  include "EXF_PARAM.h"
#  include "EXF_CONSTANTS.h"
#  include "EXF_FIELDS.h"
# endif /* ALLOW_EXF */
#endif /* ALLOW_AUTODIFF */
#ifdef ALLOW_AUTODIFF_TAMC
# include "tamc.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
C     myTime    :: Current time in simulation (s)
C     myIter    :: Current iteration number
C     myThid    :: My Thread Id. number
      _RL     myTime
      INTEGER myIter
      INTEGER myThid
CEOP

#ifdef ALLOW_THSICE
C     !LOCAL VARIABLES:
C     === Local variables ===
C     prcAtm    :: total precip from the atmosphere [kg/m2/s]
C     snowPr    :: snow precipitation               [kg/m2/s]
C     qPrcRn    :: Energy content of Precip+RunOff (+=down) [W/m2]
      INTEGER i,j
      INTEGER bi,bj
      INTEGER iMin, iMax
      INTEGER jMin, jMax
      _RL prcAtm(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL snowPr(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL qPrcRn(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
c     _RL evpAtm(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
c     _RL flxAtm(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
c     _RL flxSW (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL tauFac
#ifdef ALLOW_EXF
      INTEGER grpDiag
#endif
#ifdef ALLOW_AUTODIFF_TAMC
C     tkey  :: tape key (depends on tiles)
      INTEGER tkey
#endif

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#ifdef ALLOW_EXF
      IF ( useEXF .AND. useDiagnostics ) THEN
C-    Fill-in EXF surface flux diags, weighted by open-ocean fraction
        grpDiag = 2
        IF ( thSIce_skipThermo ) grpDiag = -2
        CALL EXF_WEIGHT_SFX_DIAGS(
     I                  iceMask, grpDiag, myTime, myIter, myThid )
        IF ( .NOT.useSEAICE ) CALL EXF_WEIGHT_SFX_DIAGS(
     I                       iceMask, -1, myTime, myIter, myThid )
      ENDIF
#endif /* ALLOW_EXF */

C-    Only compute/update seaice fields over the interior
C     (excluding overlap) and apply exchanges when needed
      iMin = 1
      iMax = sNx
      jMin = 1
      jMax = sNy

      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)

#ifdef ALLOW_AUTODIFF_TAMC
        tkey = bi + (bj-1)*nSx + (ikey_dynamics-1)*nSx*nSy
CADJ STORE uvel  (:,:,1,bi,bj) = comlev1_bibj, key=tkey, kind=isbyte
CADJ STORE vvel  (:,:,1,bi,bj) = comlev1_bibj, key=tkey, kind=isbyte
CADJ STORE qsw     (:,:,bi,bj) = comlev1_bibj, key=tkey, kind=isbyte
CADJ STORE Qice1   (:,:,bi,bj) = comlev1_bibj, key=tkey, kind=isbyte
CADJ STORE Qice2   (:,:,bi,bj) = comlev1_bibj, key=tkey, kind=isbyte
CADJ STORE sHeating(:,:,bi,bj) = comlev1_bibj, key=tkey, kind=isbyte
CADJ STORE Tsrf    (:,:,bi,bj) = comlev1_bibj, key=tkey, kind=isbyte
#endif

        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          prcAtm  (i,j,bi,bj) = 0. _d 0
          snowPr  (i,j) = 0. _d 0
          qPrcRn  (i,j) = 0. _d 0
         ENDDO
        ENDDO

#ifndef ALLOW_AUTODIFF
        IF ( .NOT.useCheapAML ) THEN
#endif
         CALL THSICE_GET_OCEAN(
     I                          bi, bj, myTime, myIter, myThid )

#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE iceMask   (:,:,bi,bj) = comlev1_bibj,key=tkey,kind=isbyte
CADJ STORE iceHeight (:,:,bi,bj) = comlev1_bibj,key=tkey,kind=isbyte
CADJ STORE snowHeight(:,:,bi,bj) = comlev1_bibj,key=tkey,kind=isbyte
CADJ STORE snowAge   (:,:,bi,bj) = comlev1_bibj,key=tkey,kind=isbyte
CADJ STORE hOceMxL   (:,:,bi,bj) = comlev1_bibj,key=tkey,kind=isbyte
CADJ STORE tOceMxL   (:,:,bi,bj) = comlev1_bibj,key=tkey,kind=isbyte
CADJ STORE sOceMxL   (:,:,bi,bj) = comlev1_bibj,key=tkey,kind=isbyte
CADJ STORE v2ocMxL   (:,:,bi,bj) = comlev1_bibj,key=tkey,kind=isbyte
#endif /* ALLOW_AUTODIFF_TAMC */

#ifndef ALLOW_AUTODIFF
C-   end if not useCheapAML
        ENDIF
#endif

#ifndef ALLOW_AUTODIFF
        IF ( useBulkforce .OR. useCheapAML ) THEN
         CALL THSICE_GET_PRECIP(
     I                  iceMask, tOceMxL,
     O                  prcAtm(1-OLx,1-OLy,bi,bj),
     O                  snowPr, qPrcRn,
     O                  icFlxSW(1-OLx,1-OLy,bi,bj),
     I                  iMin,iMax,jMin,jMax, bi,bj, myThid )
        ENDIF
#endif
        IF ( useEXF ) THEN
         CALL THSICE_MAP_EXF(
     I                  iceMask, tOceMxL,
     O                  prcAtm(1-OLx,1-OLy,bi,bj),
     O                  snowPr, qPrcRn,
     O                  icFlxSW(1-OLx,1-OLy,bi,bj),
     I                  iMin,iMax,jMin,jMax, bi,bj, myThid )
        ENDIF

#ifndef ALLOW_AUTODIFF
        IF ( .NOT.( useCheapAML .OR. thSIce_skipThermo ) ) THEN
#endif
         CALL THSICE_STEP_TEMP(
     I                     bi, bj, iMin, iMax, jMin, jMax,
     I                     myTime, myIter, myThid )

#ifdef ALLOW_AUTODIFF_TAMC
C     These store directives avoid recomputation of this routine in ad-code.
CADJ STORE flxCndBt(:,:,bi,bj) = comlev1_bibj, key=tkey, kind=isbyte
CADJ STORE EmPmR   (:,:,bi,bj) = comlev1_bibj, key=tkey, kind=isbyte
CADJ STORE Qnet    (:,:,bi,bj) = comlev1_bibj, key=tkey, kind=isbyte
CADJ STORE snowAge (:,:,bi,bj) = comlev1_bibj, key=tkey, kind=isbyte
CADJ STORE sHeating(:,:,bi,bj) = comlev1_bibj, key=tkey, kind=isbyte
CADJ STORE snowPr              = comlev1_bibj, key=tkey, kind=isbyte
CADJ STORE Qice1   (:,:,bi,bj) = comlev1_bibj, key=tkey, kind=isbyte
CADJ STORE Qice2   (:,:,bi,bj) = comlev1_bibj, key=tkey, kind=isbyte
CADJ STORE icFrwAtm(:,:,bi,bj) = comlev1_bibj, key=tkey, kind=isbyte
C     This part of the state is generally not necessary, but you never
C     know so I leave it, but commented out.
cCADJ STORE Qsw     (:,:,bi,bj) = comlev1_bibj, key=tkey, kind=isbyte
cCADJ STORE icFlxSW (:,:,bi,bj) = comlev1_bibj, key=tkey, kind=isbyte
cCADJ STORE Tice1   (:,:,bi,bj) = comlev1_bibj, key=tkey, kind=isbyte
cCADJ STORE Tice2   (:,:,bi,bj) = comlev1_bibj, key=tkey, kind=isbyte
cCADJ STORE sHeating(:,:,bi,bj) = comlev1_bibj, key=tkey, kind=isbyte
cCADJ STORE Tsrf    (:,:,bi,bj) = comlev1_bibj, key=tkey, kind=isbyte
cCADJ STORE icFlxAtm(:,:,bi,bj) = comlev1_bibj, key=tkey, kind=isbyte
#endif

#ifndef ALLOW_AUTODIFF
C-   end if not skipThermo / useCheapAML
        ENDIF
        IF ( .NOT.thSIce_skipThermo ) THEN
#endif
         CALL THSICE_STEP_FWD(
     I                     bi, bj, iMin, iMax, jMin, jMax,
     I                     prcAtm(1-OLx,1-OLy,bi,bj),
     I                     snowPr, qPrcRn,
     I                     myTime, myIter, myThid )
#ifndef ALLOW_AUTODIFF
        ELSE
C-    Compute sIceLoad (if not previously done)
          DO j=1,sNy
           DO i=1,sNx
             sIceLoad(i,j,bi,bj) = ( snowHeight(i,j,bi,bj)*rhos
     &                             + iceHeight(i,j,bi,bj)*rhoi
     &                             )*iceMask(i,j,bi,bj)
           ENDDO
          ENDDO
        ENDIF
#endif

C--  end bi,bj loop
       ENDDO
      ENDDO

#ifdef ALLOW_BALANCE_FLUXES
C--   Balance net Fresh-Water flux from Atm+Land
      IF ( thSIceBalanceAtmFW.NE.0 ) THEN
        CALL THSICE_BALANCE_FRW(
     I                      iMin, iMax, jMin, jMax,
     I                      prcAtm, myTime, myIter, myThid )
      ENDIF
#endif /* ALLOW_BALANCE_FLUXES */

C     add a small piece of code to check AddFluid implementation:
c#include "thsice_test_addfluid.h"

C--   Exchange fields that are advected by seaice dynamics
      IF ( useSEAICE .OR. thSIceAdvScheme.GT.0
     &               .OR. stressReduction.GT.zeroRL ) THEN
        CALL THSICE_DO_EXCH( myThid )
      ENDIF
      IF ( thSIceAdvScheme.GT.0 .AND. .NOT.useSEAICE ) THEN
C-    when useSEAICE=.true., this S/R is called from SEAICE_MODEL;
C     otherwise, call it from here, after thsice-thermodynamics is done
         CALL THSICE_DO_ADVECT(
     I                          0, 0, myTime, myIter, myThid )
      ELSEIF ( thSIceAdvScheme.LE.0 .AND. useRealFreshWaterFlux ) THEN
        _EXCH_XY_RS( sIceLoad, myThid )
      ENDIF

      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
#ifdef ALLOW_AUTODIFF_TAMC
        tkey = bi + (bj-1)*nSx + (ikey_dynamics-1)*nSx*nSy
CADJ STORE iceMask(:,:,bi,bj) = comlev1_bibj,key=tkey,kind=isbyte
CADJ STORE fu     (:,:,bi,bj) = comlev1_bibj,key=tkey,kind=isbyte
CADJ STORE fv     (:,:,bi,bj) = comlev1_bibj,key=tkey,kind=isbyte
#endif /* ALLOW_AUTODIFF_TAMC */

C--   Cumulate time-averaged fields and also fill-up flux diagnostics
C     (if not done in THSICE_DO_ADVECT call)
        IF ( thSIceAdvScheme.LE.0 ) THEN
         CALL THSICE_AVE(
     I                     bi,bj, myTime, myIter, myThid )
        ENDIF
C--   note: If useSEAICE=.true., the stress is computed in seaice_model,
C--   and stressReduction is always set to zero
        IF ( stressReduction.GT. 0. _d 0 ) THEN
          DO j = 1-OLy,sNy+OLy-1
           DO i = 2-OLx,sNx+OLx-1
            tauFac = stressReduction
     &             *(iceMask(i-1,j,bi,bj)+iceMask(i,j,bi,bj))*0.5 _d 0
            fu(i,j,bi,bj) = (1. _d 0 - tauFac)*fu(i,j,bi,bj)
           ENDDO
          ENDDO
          DO j = 2-OLy,sNy+OLy-1
           DO i = 1-OLx,sNx+OLx-1
            tauFac = stressReduction
     &             *(iceMask(i,j-1,bi,bj)+iceMask(i,j,bi,bj))*0.5 _d 0
            fv(i,j,bi,bj) = (1. _d 0 - tauFac)*fv(i,j,bi,bj)
           ENDDO
          ENDDO
        ENDIF

C--  end bi,bj loop
       ENDDO
      ENDDO

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
#endif /* ALLOW_THSICE */

      RETURN
      END

#include "PACKAGES_CONFIG.h"
#include "CPP_OPTIONS.h"
#ifdef ALLOW_MOM_COMMON
# include "MOM_COMMON_OPTIONS.h"
#endif
#ifdef ALLOW_CTRL
# include "CTRL_OPTIONS.h"
#endif

CBOP
C     !ROUTINE: INI_DYNVARS
C     !INTERFACE:
      SUBROUTINE INI_DYNVARS( myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE INI_DYNVARS
C     | o Initialise to zero all DYNVARS.h arrays
C     *==========================================================*
C     | Sets all the State variables to zero.
C     | Sets all the Gs (arrays used for multi-level time-stepping)
C     | to zero.
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "DYNVARS.h"
#ifdef ALLOW_SOLVE4_PS_AND_DRAG
#include "GRID.h"
#endif /* ALLOW_SOLVE4_PS_AND_DRAG */

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     myThid  :: my Thread Id. number
      INTEGER myThid

C     !LOCAL VARIABLES:
C     == Local variables ==
C     bi,bj   :: tile indices
C     i,j,k   :: loop index
      INTEGER bi, bj
      INTEGER i, j, k
CEOP

C--   Over all tiles
      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)

C-      3D arrays
        DO k=1,Nr
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx

           uVel (i,j,k,bi,bj) = 0. _d 0
           vVel (i,j,k,bi,bj) = 0. _d 0
           wVel (i,j,k,bi,bj) = 0. _d 0
           theta(i,j,k,bi,bj) = 0. _d 0
           salt (i,j,k,bi,bj) = 0. _d 0

           gU(i,j,k,bi,bj) = 0. _d 0
           gV(i,j,k,bi,bj) = 0. _d 0
#ifdef USE_OLD_EXTERNAL_FORCING
           gT(i,j,k,bi,bj) = 0. _d 0
           gS(i,j,k,bi,bj) = 0. _d 0
#endif
#ifdef ALLOW_ADAMSBASHFORTH_3
           guNm(i,j,k,bi,bj,1) = 0. _d 0
           gvNm(i,j,k,bi,bj,1) = 0. _d 0
           gtNm(i,j,k,bi,bj,1) = 0. _d 0
           gsNm(i,j,k,bi,bj,1) = 0. _d 0
           guNm(i,j,k,bi,bj,2) = 0. _d 0
           gvNm(i,j,k,bi,bj,2) = 0. _d 0
           gtNm(i,j,k,bi,bj,2) = 0. _d 0
           gsNm(i,j,k,bi,bj,2) = 0. _d 0
#else
           guNm1(i,j,k,bi,bj) = 0. _d 0
           gvNm1(i,j,k,bi,bj) = 0. _d 0
           gtNm1(i,j,k,bi,bj) = 0. _d 0
           gsNm1(i,j,k,bi,bj) = 0. _d 0
#endif
#if (defined (ALLOW_3D_DIFFKR) || defined (ALLOW_DIFFKR_CONTROL))
           diffKr(i,j,k,bi,bj)= 0. _d 0
#endif
#ifdef ALLOW_SMAG_3D_DIFFUSIVITY
           smag3D_diffK(i,j,k,bi,bj) = 0. _d 0
#endif
           totPhiHyd(i,j,k,bi,bj)    = 0. _d 0
           rhoInSitu(i,j,k,bi,bj)    = 0. _d 0
           IVDConvCount(i,j,k,bi,bj) = 0. _d 0
#ifdef ALLOW_LEITH_QG
           sigmaRfield(i,j,k,bi,bj)  = 0. _d 0
#endif
#ifdef ALLOW_SOLVE4_PS_AND_DRAG
           dU_psFacX(i,j,k,bi,bj)    = 0. _d 0
           dV_psFacY(i,j,k,bi,bj)    = 0. _d 0
#endif /* ALLOW_SOLVE4_PS_AND_DRAG */
#ifdef INCLUDE_SOUNDSPEED_CALC_CODE
           cSound(i,j,k,bi,bj)       = 0. _d 0
#endif /* INCLUDE_SOUNDSPEED_CALC_CODE */
          ENDDO
         ENDDO
        ENDDO

C-      2D arrays
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          etaN(i,j,bi,bj) = 0. _d 0
          etaH(i,j,bi,bj) = 0. _d 0
          phiHydLow(i,j,bi,bj) = 0. _d 0
          hMixLayer(i,j,bi,bj) = 0. _d 0
         ENDDO
        ENDDO

#ifdef ALLOW_SOLVE4_PS_AND_DRAG
C--   Put some constant values (if not part of S/R INI_FIELDS):
        DO k=1,Nr
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           dU_psFacX(i,j,k,bi,bj) = maskW(i,j,k,bi,bj)
     &                             *recip_deepFacC(k)*recip_rhoFacC(k)
           dV_psFacY(i,j,k,bi,bj) = maskS(i,j,k,bi,bj)
     &                             *recip_deepFacC(k)*recip_rhoFacC(k)
          ENDDO
         ENDDO
        ENDDO
#endif /* ALLOW_SOLVE4_PS_AND_DRAG */

       ENDDO
      ENDDO

      RETURN
      END

#include "OBCS_OPTIONS.h"

CBOP
C     !ROUTINE: OBCS_APPLY_TS
C     !INTERFACE:

      SUBROUTINE OBCS_APPLY_TS( bi, bj, kArg,
     U                          tFld, sFld,
     I                          myThid )

C     !DESCRIPTION:
C     *==========================================================*
C     | S/R OBCS_APPLY_TS
C     |   Apply OB values to corresponding field array
C     *==========================================================*

C     !USES:
      IMPLICIT NONE
C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "OBCS_PARAMS.h"
#include "OBCS_GRID.h"
#include "OBCS_FIELDS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine Arguments ==
C     bi, bj   :: indices of current tile
C     kArg     :: index of current level which OBC apply to
C                 or if zeros, apply to all levels
C     tFld     :: temperature field
C     sFld     :: salinity field
C     myThid   :: my Thread Id number
c     INTEGER biArg, bjArg
      INTEGER bi, bj
      INTEGER kArg
      _RL tFld(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      _RL sFld(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      INTEGER myThid
CEOP

C     !LOCAL VARIABLES:
C     == Local variables ==
c     INTEGER bi, bj, itLo, itHi, jtLo, jtHi
      INTEGER k, kLo, kHi
#if (defined ALLOW_OBCS_EAST ) || (defined ALLOW_OBCS_WEST )
      INTEGER j, Iobc
#endif
#if (defined ALLOW_OBCS_NORTH) || (defined ALLOW_OBCS_SOUTH)
      INTEGER i, Jobc
#endif

c     IF ( biArg.EQ.0 .OR. bjArg.EQ.0 ) THEN
c       itLo = myBxLo(myThid)
c       itHi = myBxHi(myThid)
c       jtLo = myByLo(myThid)
c       jtHi = myByHi(myThid)
c     ELSE
c       itLo = biArg
c       itHi = biArg
c       jtLo = bjArg
c       jtHi = bjArg
c     ENDIF
      IF ( kArg.EQ.0 ) THEN
        kLo = 1
        kHi = Nr
      ELSE
        kLo = kArg
        kHi = kArg
      ENDIF

c     DO bj = jtLo,jtHi
c      DO bi = itLo,itHi

C     Set model variables to OB values on North/South Boundaries
#ifdef ALLOW_OBCS_NORTH
        IF ( tileHasOBN(bi,bj) ) THEN
C Northern boundary
# ifdef ALLOW_OBCS_STEVENS
         IF ( useStevensNorth ) THEN
          DO i=1-OLx,sNx+OLx
C     add tendency term instead of overwriting field with boundary value
           Jobc = OB_Jn(i,bi,bj)
           IF ( Jobc.NE.OB_indexNone ) THEN
            DO k = kLo,kHi
             tFld(i,Jobc,k,bi,bj) = tFld(i,Jobc,k,bi,bj)
     &            + dTtracerLev(k)*OBNt(i,k,bi,bj)
             sFld(i,Jobc,k,bi,bj) = sFld(i,Jobc,k,bi,bj)
     &            + dTtracerLev(k)*OBNs(i,k,bi,bj)
            ENDDO
           ENDIF
          ENDDO
         ELSE
# else
         IF ( .TRUE. ) THEN
# endif /* ALLOW_OBCS_STEVENS */
          DO i=1-OLx,sNx+OLx
           Jobc = OB_Jn(i,bi,bj)
           IF ( Jobc.NE.OB_indexNone ) THEN
            DO k = kLo,kHi
             tFld(i,Jobc,k,bi,bj) = OBNt(i,k,bi,bj)
             sFld(i,Jobc,k,bi,bj) = OBNs(i,k,bi,bj)
            ENDDO
           ENDIF
          ENDDO
         ENDIF
        ENDIF
#endif /* ALLOW_OBCS_NORTH */

#ifdef ALLOW_OBCS_SOUTH
        IF ( tileHasOBS(bi,bj) ) THEN
C Southern boundary
# ifdef ALLOW_OBCS_STEVENS
         IF ( useStevensSouth ) THEN
C     add tendency term instead of overwriting field with boundary value
          DO i=1-OLx,sNx+OLx
           Jobc = OB_Js(i,bi,bj)
           IF ( Jobc.NE.OB_indexNone ) THEN
            DO k = kLo,kHi
             tFld(i,Jobc,k,bi,bj) = tFld(i,Jobc,k,bi,bj)
     &            + dTtracerLev(k)*OBSt(i,k,bi,bj)
             sFld(i,Jobc,k,bi,bj) = sFld(i,Jobc,k,bi,bj)
     &            + dTtracerLev(k)*OBSs(i,k,bi,bj)
            ENDDO
           ENDIF
          ENDDO
         ELSE
# else
         IF ( .TRUE. ) THEN
# endif /* ALLOW_OBCS_STEVENS */
          DO i=1-OLx,sNx+OLx
           Jobc = OB_Js(i,bi,bj)
           IF ( Jobc.NE.OB_indexNone ) THEN
            DO k = kLo,kHi
             tFld(i,Jobc,k,bi,bj) = OBSt(i,k,bi,bj)
             sFld(i,Jobc,k,bi,bj) = OBSs(i,k,bi,bj)
            ENDDO
           ENDIF
          ENDDO
         ENDIF
        ENDIF
#endif /* ALLOW_OBCS_SOUTH */

C     Set model variables to OB values on East/West Boundaries
#ifdef ALLOW_OBCS_EAST
        IF ( tileHasOBE(bi,bj) ) THEN
C Eastern boundary
# ifdef ALLOW_OBCS_STEVENS
         IF ( useStevensEast ) THEN
C     add tendency term instead of overwriting field with boundary value
          DO j=1-OLy,sNy+OLy
           Iobc = OB_Ie(j,bi,bj)
           IF ( Iobc.NE.OB_indexNone ) THEN
            DO k = kLo,kHi
             tFld(Iobc,j,k,bi,bj) = tFld(Iobc,j,k,bi,bj)
     &            + dTtracerLev(k)*OBEt(j,k,bi,bj)
             sFld(Iobc,j,k,bi,bj) = sFld(Iobc,j,k,bi,bj)
     &            + dTtracerLev(k)*OBEs(j,k,bi,bj)
            ENDDO
           ENDIF
          ENDDO
         ELSE
# else
         IF ( .TRUE. ) THEN
# endif /* ALLOW_OBCS_STEVENS */
          DO j=1-OLy,sNy+OLy
           Iobc = OB_Ie(j,bi,bj)
           IF ( Iobc.NE.OB_indexNone ) THEN
            DO k = kLo,kHi
             tFld(Iobc,j,k,bi,bj) = OBEt(j,k,bi,bj)
             sFld(Iobc,j,k,bi,bj) = OBEs(j,k,bi,bj)
            ENDDO
           ENDIF
          ENDDO
         ENDIF
        ENDIF
#endif /* ALLOW_OBCS_EAST */

#ifdef ALLOW_OBCS_WEST
        IF ( tileHasOBW(bi,bj) ) THEN
C Western boundary
# ifdef ALLOW_OBCS_STEVENS
         IF ( useStevensWest ) THEN
C     add tendency term instead of overwriting field with boundary value
          DO j=1-OLy,sNy+OLy
           Iobc = OB_Iw(j,bi,bj)
           IF ( Iobc.NE.OB_indexNone ) THEN
            DO k = kLo,kHi
             tFld(Iobc,j,k,bi,bj) = tFld(Iobc,j,k,bi,bj)
     &            + dTtracerLev(k)*OBWt(j,k,bi,bj)
             sFld(Iobc,j,k,bi,bj) = sFld(Iobc,j,k,bi,bj)
     &            + dTtracerLev(k)*OBWs(j,k,bi,bj)
            ENDDO
           ENDIF
          ENDDO
         ELSE
# else
         IF ( .TRUE. ) THEN
# endif /* ALLOW_OBCS_STEVENS */
          DO j=1-OLy,sNy+OLy
           Iobc = OB_Iw(j,bi,bj)
           IF ( Iobc.NE.OB_indexNone ) THEN
            DO k = kLo,kHi
             tFld(Iobc,j,k,bi,bj) = OBWt(j,k,bi,bj)
             sFld(Iobc,j,k,bi,bj) = OBWs(j,k,bi,bj)
            ENDDO
           ENDIF
          ENDDO
         ENDIF
        ENDIF
#endif /* ALLOW_OBCS_WEST */

c      ENDDO
c     ENDDO

      RETURN
      END

#include "CPP_OPTIONS.h"

CBOP
C     !ROUTINE: INI_MIXING
C     !INTERFACE:
      SUBROUTINE INI_MIXING( myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE INI_MIXING
C     | o Initialise diffusivity to default constant value.
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "DYNVARS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     myThid :: my Thread Id number
      INTEGER myThid

C     !LOCAL VARIABLES:
#if (defined ALLOW_3D_DIFFKR) || (defined ALLOW_BL79_LAT_VARY)
C     bi,bj  :: tile indices
C     i,j,k  :: Loop counters
      INTEGER bi, bj
      INTEGER i, j
#endif
#ifdef ALLOW_3D_DIFFKR
      INTEGER k
#endif
CEOP

#ifdef ALLOW_3D_DIFFKR
       DO bj = myByLo(myThid), myByHi(myThid)
        DO bi = myBxLo(myThid), myBxHi(myThid)
         DO k=1,Nr
          DO j = 1-OLy, sNy+OLy
           DO i = 1-OLx, sNx+OLx
            diffKr(i,j,k,bi,bj) = diffKrNrS(k)
           ENDDO
          ENDDO
         ENDDO
        ENDDO
       ENDDO
       IF ( diffKrFile .NE. ' ' ) THEN
         CALL READ_FLD_XYZ_RL( diffKrFile, ' ', diffKr, 0, myThid )
         _EXCH_XYZ_RL( diffKr, myThid )
       ENDIF
#endif /* ALLOW_3D_DIFFKR */

#ifdef ALLOW_BL79_LAT_VARY
       DO bj = myByLo(myThid), myByHi(myThid)
        DO bi = myBxLo(myThid), myBxHi(myThid)
         DO j = 1-OLy, sNy+OLy
          DO i = 1-OLx, sNx+OLx
           BL79LatArray(i,j,bi,bj) = 0.0 _d 0
           IF ( ABS(YC(i,j,bi,bj)) .LT. BL79LatVary )
     &       BL79LatArray(i,j,bi,bj) = halfRL
     &         *( 1. _d 0 + COS(YC(i,j,bi,bj)*PI/BL79LatVary) )
          ENDDO
         ENDDO
        ENDDO
       ENDDO
#endif

      RETURN
      END

#include "COST_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C !ROUTINE: COST_COPY_FILE

C !INTERFACE:
      SUBROUTINE COST_COPY_FILE( oUnit, optimcycle, myThid )
C !DESCRIPTION:
C     Helper routine to hide irreducible statements from TAF:
C     Copy content of costfunction_${pkg}.XXXX to oUnit

C     !USES:
      IMPLICIT NONE
C     == Global variables ===
#include "EEPARAMS.h"

C !INPUT/OUTPUT PARAMETERS:
C     oUnit  :: file unit of output file (set in cost_final.F)
C     optimcycle :: cycle number of the off-line optimization.
C     myThid :: my Thread Id number
      INTEGER oUnit
      INTEGER optimcycle
      INTEGER myThid
CEOP

C !FUNCTIONS:
      INTEGER  ILNBLNK
      EXTERNAL ILNBLNK

C !LOCAL VARIABLES:
      INTEGER iUnit
      INTEGER IL
      INTEGER nPkg, iPkg
      PARAMETER ( nPkg = 7 )
      CHARACTER*8 pkgNames(nPkg)
      CHARACTER*(MAX_LEN_FNAM) cfname
      CHARACTER*(MAX_LEN_PREC) RECORD
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      LOGICAL cfexist

C     This list can be appened as necessary with the only limitation
C     that the character variables need to be all of the same length.
      DATA pkgNames /
     &     'profiles',
     &     'obsfit  ',
     &     'ecco    ',
     &     'ctrl    ',
     &     'obcs    ',
     &     'seaice  ',
     &     'shelfice' /

      iUnit = scrUnit1
      DO ipkg = 1, nPkg
       cfexist = .FALSE.
       IL = ILNBLNK( pkgNames(ipkg) )
       WRITE(cfname,'(3A,I4.4)')
     &      'costfunction_',pkgNames(ipkg)(1:IL),'.',optimcycle
       IL = ILNBLNK( cfname )
       INQUIRE(FILE=cfname(1:IL), EXIST=cfexist)
       IF ( cfexist ) THEN
        WRITE(msgBuf,'(A,A)')
     &       'Reading cost function info from ', cfname(1:IL)
        CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
        OPEN(UNIT=iUnit,FILE=cfname(1:IL),
     &       _READONLY_ACTION STATUS='OLD')

        DO WHILE ( .TRUE. )
         READ( iUnit, FMT='(A)', END=1001 ) RECORD
         IL = MAX(ILNBLNK( RECORD ),1)
         WRITE( oUnit, FMT='(A)') RECORD(1:IL)
        ENDDO
 1001   CONTINUE

        CLOSE(iUnit)
       ENDIF
      ENDDO

      RETURN
      END

#include "STREAMICE_OPTIONS.h"
#ifdef ALLOW_AUTODIFF
# include "AUTODIFF_OPTIONS.h"
#endif

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

CBOP
      SUBROUTINE STREAMICE_VELMASK_UPD ( myThid )

C     /============================================================\
C     | SUBROUTINE                                                 |
C     | o                                                          |
C     |============================================================|
C     |                                                            |
C     \============================================================/
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "GRID.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "STREAMICE.h"
c#ifdef ALLOW_PETSC
c# ifdef ALLOW_USE_MPI
c#  include "EESUPPORT.h"
c# endif
c#endif
c #include "STREAMICE_ADV.h"

#ifdef ALLOW_AUTODIFF_TAMC
# include "tamc.h"
#endif

      INTEGER myThid

#ifdef ALLOW_STREAMICE

      INTEGER i, j, bi, bj, ki, kj
      INTEGER maskFlag
#ifdef ALLOW_USE_MPI
      integer mpiRC, mpiMyWid
#endif
#ifdef ALLOW_PETSC
      INTEGER myThidCopy
      _RS DoFCount
      integer n_dofs_proc_loc (0:nPx*nPy-1)
      integer n_dofs_cum_sum (0:nPx*nPy-1)
#endif

      _EXCH_XY_RL( H_streamice, myThid )
      _EXCH_XY_RL( area_shelf_streamice, myThid )
      _EXCH_XY_RS( STREAMICE_hmask, myThid )

      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          STREAMICE_umask(i,j,bi,bj) = -1. _d 0
          STREAMICE_vmask(i,j,bi,bj) = -1. _d 0
          STREAMICE_ufacemask(i,j,bi,bj) = 0. _d 0
          STREAMICE_vfacemask(i,j,bi,bj) = 0. _d 0
         ENDDO
        ENDDO
       ENDDO
      ENDDO

      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        DO j=0,sNy+1
         DO i=0,sNx+1
          IF (STREAMICE_hmask(i,j,bi,bj) .eq. 1.0) THEN

           DO kj=0,1
            DO ki=0,1
             if (STREAMICE_umask(i+ki,j+kj,bi,bj).eq.-1.0) then
              STREAMICE_umask (i+ki,j+kj,bi,bj) = 1.0
             endif
             if (STREAMICE_vmask(i+ki,j+kj,bi,bj).eq.-1.0) then
              STREAMICE_vmask (i+ki,j+kj,bi,bj) = 1.0
             endif
            ENDDO
           ENDDO

           DO ki=0,1
            maskFlag=INT(STREAMICE_ufacemask_bdry(i+ki,j,bi,bj))
             IF (maskFlag.EQ.3) THEN
              DO kj=0,1
               if (STREAMICE_umask(i+ki,j+kj,bi,bj).ne.0.0) then
                STREAMICE_umask(i+ki,j+kj,bi,bj) = 3.0
               endif
               if(STREAMICE_vmask(i+ki,j+kj,bi,bj).ne.0.0) then
                STREAMICE_vmask(i+ki,j+kj,bi,bj) = 3.0
               endif
              ENDDO
              STREAMICE_ufacemask(i+ki,j,bi,bj) = 3.0
             ELSE IF (maskFlag.EQ.2) THEN
c             DO kj=0,1
               STREAMICE_ufacemask(i+ki,j,bi,bj) = 2.0
c             ENDDO
             ELSE IF (maskFlag.EQ.4) THEN
              DO kj=0,1
               STREAMICE_umask(i+ki,j+kj,bi,bj) = 0.0
               STREAMICE_vmask(i+ki,j+kj,bi,bj) = 0.0
              ENDDO
              STREAMICE_ufacemask(i+ki,j,bi,bj) = 4.0
             ELSE IF (maskFlag.EQ.0) THEN
              DO kj=0,1
               STREAMICE_umask(i+ki,j+kj,bi,bj) = 0.0
               STREAMICE_vmask(i+ki,j+kj,bi,bj) = 0.0
              ENDDO
              STREAMICE_ufacemask(i+ki,j,bi,bj) = 0.0
             ELSE IF (maskFlag.EQ.1) THEN
              DO kj=0,1
               STREAMICE_umask(i+ki,j+kj,bi,bj) = 0.0
              ENDDO
            END IF
           ENDDO

           DO kj=0,1
            maskFlag=INT(STREAMICE_vfacemask_bdry(i,j+kj,bi,bj))
            IF (maskFlag.EQ.3) THEN
              DO ki=0,1
               if(STREAMICE_vmask(i+ki,j+kj,bi,bj).ne.0.0) then
                STREAMICE_vmask(i+ki,j+kj,bi,bj) = 3.0
               endif
               if(STREAMICE_umask(i+ki,j+kj,bi,bj).ne.0.0) then
                STREAMICE_umask(i+ki,j+kj,bi,bj) = 3.0
               endif
              ENDDO
              STREAMICE_vfacemask(i,j+kj,bi,bj) = 3.0
           ELSE IF (maskFlag.EQ.2) THEN
c             DO ki=0,1
               STREAMICE_vfacemask(i,j+kj,bi,bj) = 2.0
c             ENDDO
           ELSE IF (maskFlag.EQ.4) THEN
              DO ki=0,1
               STREAMICE_umask(i+ki,j+kj,bi,bj) = 0.0
               STREAMICE_vmask(i+ki,j+kj,bi,bj) = 0.0
              ENDDO
              STREAMICE_vfacemask(i,j+kj,bi,bj) = 4.0
           ELSE IF (maskFlag.EQ.0) THEN
              DO ki=0,1
               STREAMICE_umask(i+ki,j+kj,bi,bj) = 0.0
               STREAMICE_vmask(i+ki,j+kj,bi,bj) = 0.0
              ENDDO
              STREAMICE_vfacemask(i+ki,j,bi,bj) = 0.0
           ELSE IF (maskFlag.EQ.1) THEN
              DO ki=0,1
               STREAMICE_vmask(i+ki,j+kj,bi,bj) = 0.0
              ENDDO
            ENDIF
           ENDDO

           IF (i .lt. sNx+OLx) THEN
            IF ((STREAMICE_hmask(i+1,j,bi,bj) .eq. 0.0) .OR.
     &          (STREAMICE_hmask(i+1,j,bi,bj) .eq. 2.0))  THEN
C           right boundary or adjacent to unfilled cell
             STREAMICE_ufacemask(i+1,j,bi,bj) = 2.0
            ENDIF
           ENDIF

           IF (i .gt. 1-OLx) THEN
            IF ((STREAMICE_hmask(i-1,j,bi,bj) .eq. 0.0) .OR.
     &          (STREAMICE_hmask(i-1,j,bi,bj) .eq. 2.0))  THEN
C           left boundary or adjacent to unfilled cell
             STREAMICE_ufacemask(i,j,bi,bj) = 2
            ENDIF
           ENDIF

           IF (j .lt. sNy+OLy) THEN
            IF ((STREAMICE_hmask(i,j+1,bi,bj) .eq. 0.0) .OR.
     &          (STREAMICE_hmask(i,j+1,bi,bj) .eq. 2.0))  THEN
C           top boundary or adjacent to unfilled cell
             STREAMICE_vfacemask(i,j+1,bi,bj) = 2
            ENDIF
           ENDIF

           IF (j .gt. 1-OLy) THEN
            IF ((STREAMICE_hmask(i,j-1,bi,bj) .eq. 0.0) .OR.
     &          (STREAMICE_hmask(i,j-1,bi,bj) .eq. 2.0))  THEN
C           bot boundary or adjacent to unfilled cell
             STREAMICE_vfacemask(i,j,bi,bj) = 2.0
            ENDIF
           ENDIF

          ENDIF
         ENDDO
        ENDDO
       ENDDO
      ENDDO

c!$TAF STORE streamice_umask = comlev1, key=ikey_dynamics
c!$TAF STORE streamice_vmask = comlev1, key=ikey_dynamics

      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        DO j=1,sNy
         DO i=1,sNx
          IF(streamice_umask(i,j,bi,bj).eq.-1.0) THEN
           streamice_umask(i,j,bi,bj)=0.0
          ENDIF
          IF(streamice_vmask(i,j,bi,bj).eq.-1.0) THEN
           streamice_vmask(i,j,bi,bj)=0.0
          ENDIF
         ENDDO
        ENDDO
       ENDDO
      ENDDO

      _EXCH_XY_RS( STREAMICE_ufacemask, myThid )
      _EXCH_XY_RS( STREAMICE_vfacemask, myThid )
      _EXCH_XY_RS( STREAMICE_umask, myThid )
      _EXCH_XY_RS( STREAMICE_vmask, myThid )

c       CALL WRITE_FULLARRAY_RL ("umask",STREAMICE_umask,
c      c   1,0,0,1,0,myThid)
c      CALL WRITE_FLD_XY_RL ("umask","",STREAMICE_umask,0,myThid)
c      CALL WRITE_FLD_XY_RL ("vmask","",STREAMICE_vmask,0,myThid)
c      CALL WRITE_FLD_XY_RL ("ufacemask","",STREAMICE_ufacemask,0,myThid)
c      CALL WRITE_FLD_XY_RL ("vfacemask","",STREAMICE_vfacemask,0,myThid)

#ifdef ALLOW_PETSC
      myThidCopy = myThid
      if (streamice_use_petsc) then
#ifdef ALLOW_OPENAD
      call streamice_petsc_numerate (myThidCopy)
#else
      call streamice_petsc_numerate (myThid)
#endif
      endif
#endif

#endif
      RETURN
      END

CBOP 0
C !ROUTINE: COUPLER

C !INTERFACE:
      PROGRAM COUPLER

C !DESCRIPTION:
C     *==========================================================*
C     | PROGRAM COUPLER
C     | o Main routine for 'Coupler' component. 'Coupler'
C     |   component coordiantes the exchange of data between
C     |   component models in a coupled model experiment.
C     *==========================================================*
C     | This version uses the MIT Coupler "checkpoint1" library
C     | calls.
C     *==========================================================*

C !USES:
      IMPLICIT NONE
C     == Global variables ==
#include "mpif.h"
#include "CPL_PARAMS.h"

C !LOCAL VARIABLES:
C     I       :: Loop counter
C     rc      :: MPI return code
C     msgUnit :: log-file I/O unit
      INTEGER I
      INTEGER rc
      INTEGER msgUnit
CEOP

C     Initialise the coupler component
      CALL INITIALISE(
     O                 msgUnit )

C     Perform registration with other components
      CALL ACCEPT_COMPONENT_REGISTRATIONS

C     Send Coupler-params to both components
      CALL CPL_SEND_ATM_CPLPARMS( msgUnit )
      CALL CPL_SEND_OCN_CPLPARMS( msgUnit )

C     Coordinate the transfer configuration information between components
      CALL EXCH_COMPONENT_CONFIGS( msgUnit )

      DO I=1,nCouplingSteps

       IF ( cpl_sequential.EQ.1 ) THEN
C-     Sequential coupling

C       Receive ATM updated state
        CALL CPL_RECV_ATM_FIELDS( msgUnit, I )
C       Send out ATM fields to OCN
        CALL CPL_SEND_OCN_FIELDS( msgUnit, I )

C       Receive OCN updated state
        CALL CPL_RECV_OCN_FIELDS( msgUnit, I )
C       Send out OCN fields to ATM
        CALL CPL_SEND_ATM_FIELDS( msgUnit, I )

       ELSE
C-     Synchronous coupling

C       Receive updated state
        CALL CPL_RECV_OCN_FIELDS( msgUnit, I )
        CALL CPL_RECV_ATM_FIELDS( msgUnit, I )

C       Send out fields
        CALL CPL_SEND_ATM_FIELDS( msgUnit, I )
        CALL CPL_SEND_OCN_FIELDS( msgUnit, I )

       ENDIF

      ENDDO

C     o Finalize MPI
C     First wait for everybody to finish. Nobody should call
C     MPI_Finalize before all the component modules are
C     ready to finish. On some systems once one participant
C     gets to MPI_Finalize then its unclear what will
C     happen after that. If everybody does on MPI_Barrier
C     on COMM_WORLD then we will be OK.
      CALL MPI_BARRIER( MPI_COMM_WORLD, rc )
      CALL MPI_FINALIZE(rc)

      STOP
      END

#include "CTRL_OPTIONS.h"

C--   File ctrl_map_genarr.F: Generic arrays control vector
C--    Contents:
C--    o CTRL_MAP_GENARR2D
C--    o CTRL_MAP_GENARR3D

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

CBOP
C     !ROUTINE: CTRL_MAP_GENARR2D
C     !INTERFACE:
      SUBROUTINE CTRL_MAP_GENARR2D( fld, iarr, myThid )

C     !DESCRIPTION: \bv
C     *=================================================================
C     | SUBROUTINE CTRL_MAP_GENARR2D
C     | Add the generic 2D-arrays of the
C     | control vector to the model state and update the tile halos.
C     | The control vector is defined in the header file "CTRL.h".
C     *=================================================================
C     \ev

C     !USES:
      IMPLICIT NONE

C     == global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"

#include "CTRL_SIZE.h"
#include "CTRL.h"
#include "OPTIMCYCLE.h"
#include "CTRL_GENARR.h"
#include "CTRL_DUMMY.h"

C     !INPUT/OUTPUT PARAMETERS:
      _RL     fld(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      INTEGER iarr
      INTEGER myThid

#ifdef ALLOW_GENARR2D_CONTROL
C     !FUNCTIONS:
      INTEGER  ILNBLNK
      EXTERNAL ILNBLNK

C     !LOCAL VARIABLES:
      INTEGER bi,bj
      INTEGER i,j
      INTEGER numsmo, k2
      LOGICAL dowc01
      LOGICAL dosmooth
      LOGICAL doscaling
      LOGICAL dolog10ctrl
      _RL log10initval
      _RL ln10
      _RL xx_gen  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      CHARACTER*(MAX_LEN_FNAM) fnamegenIn
      CHARACTER*(MAX_LEN_FNAM) fnamegenOut
      CHARACTER*(MAX_LEN_FNAM) fnamebase
      INTEGER ilgen
      LOGICAL doglobalread
      LOGICAL ladinit
      _RS mask2D (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      INTEGER ilDir
CEOP

#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_ENTER('CTRL_MAP_GENARR2D', myThid )
#endif
C--   Now, read the control vector.
      doglobalread = .FALSE.
      ladinit      = .FALSE.

#ifndef ALLOW_TAPENADE
      CALL CTRL_ASSIGN(xx_gen, 1, zeroRL, myThid)
#endif

      dosmooth=.FALSE.
      dowc01  = .FALSE.
      doscaling=.TRUE.
      dolog10ctrl=.FALSE.
      log10initval=0. _d 0
      ln10 = LOG(10. _d 0)

      numsmo = 1
      DO k2 = 1, maxCtrlProc
        IF ( xx_genarr2d_preproc(k2,iarr).EQ.'WC01' ) THEN
          dowc01 = .TRUE.
          IF (xx_genarr2d_preproc_i(k2,iarr).NE.0)
     &      numsmo = xx_genarr2d_preproc_i(k2,iarr)
        ENDIF
        IF ( (.NOT.dowc01).AND.
     &       (xx_genarr2d_preproc(k2,iarr).EQ.'smooth') ) THEN
          dosmooth = .TRUE.
          IF (xx_genarr2d_preproc_i(k2,iarr).NE.0)
     &      numsmo = xx_genarr2d_preproc_i(k2,iarr)
        ENDIF
        IF ( xx_genarr2d_preproc(k2,iarr).EQ.'noscaling' ) THEN
          doscaling = .FALSE.
        ENDIF
        IF (xx_genarr2d_preproc_c(k2,iarr).EQ.'log10ctrl') THEN
C             fld := log10(xx_gen)
C               with initial guess for xx_gen set to log10initval
C               passed to data.ctrl, (default = 0.0)
          dolog10ctrl=.TRUE.
          log10initval = xx_genarr2d_preproc_r(k2,iarr)
        ENDIF
      ENDDO

      fnamebase = xx_genarr2d_file(iarr)
      ilgen = ILNBLNK( fnamebase )
C     Find ctrlDir (w/o trailing blanks) length
      ilDir = ilnblnk(ctrlDir)
      WRITE(fnamegenIn,'(2A,I10.10)')
     & ctrlDir(1:ilDir)//fnamebase(1:ilgen),'.',optimcycle
      WRITE(fnamegenOut,'(2A,I10.10)')
     & ctrlDir(1:ilDir)//fnamebase(1:ilgen),'.effective.',optimcycle

      CALL READ_REC_3D_RL( xx_genarr2d_weight(iarr), ctrlprec, 1,
     &          wgenarr2d(1-OLx,1-OLy,1,1,iarr), 1, 1, myThid )

#ifdef ALLOW_AUTODIFF
      CALL ACTIVE_READ_XY( fnamegenIn, xx_gen, 1, doglobalread,
     &     ladinit, optimcycle, myThid, xx_genarr2d_dummy(iarr) )
#else
      CALL READ_REC_XY_RL( fnamegenIn, xx_gen, 1, 1, myThid)
#endif

C --- Get appropriate mask for ctrl variable
      CALL CTRL_GET_MASK2D(xx_genarr2d_file(iarr), mask2D, myThid)

C --- Do any smoothing
#ifdef ALLOW_SMOOTH
      IF (useSMOOTH) THEN
       IF (dowc01) CALL SMOOTH_CORREL2D(xx_gen,mask2D,numsmo,myThid)
       IF (dosmooth) CALL SMOOTH2D(xx_gen,mask2D,numsmo,myThid)
      ENDIF
#endif

      DO bj=myByLo(myThid), myByHi(myThid)
       DO bi=myBxLo(myThid), myBxHi(myThid)
        IF (doscaling) THEN
         DO j = 1,sNy
          DO i = 1,sNx
C scale param adjustment
           IF ( wgenarr2d(i,j,bi,bj,iarr).GT.0. ) THEN
            xx_gen(i,j,bi,bj) = xx_gen(i,j,bi,bj)
     &               / SQRT( wgenarr2d(i,j,bi,bj,iarr) )
            IF (dolog10ctrl) THEN
             xx_gen(i,j,bi,bj) = xx_gen(i,j,bi,bj) + log10initval
c            xx_gen(i,j,bi,bj) = 10.0 ** xx_gen(i,j,bi,bj)
C     this is faster, especially if log(10) has been evaluated before
c            xx_gen(i,j,bi,bj) = EXP(LOG(10.0) * xx_gen(i,j,bi,bj))
             xx_gen(i,j,bi,bj) = EXP(ln10 * xx_gen(i,j,bi,bj))
            ENDIF ! dolog10ctrls
           ELSE
            xx_gen(i,j,bi,bj) = 0. _d 0
           ENDIF
          ENDDO
         ENDDO
        ENDIF ! doscaling
C add to model parameter
C or in case of log10ctrl, fld = 10^(xx_gen)
        IF (dolog10ctrl) THEN
         DO j = 1,sNy
          DO i = 1,sNx
           fld(i,j,bi,bj) = xx_gen(i,j,bi,bj)*mask2D(i,j,bi,bj)
          ENDDO
         ENDDO
        ELSE
         DO j = 1,sNy
          DO i = 1,sNx
           fld(i,j,bi,bj) = fld(i,j,bi,bj)
     &           + xx_gen(i,j,bi,bj)*mask2D(i,j,bi,bj)
          ENDDO
         ENDDO
        ENDIF ! dolog10ctrls
       ENDDO
      ENDDO

C avoid param out of [boundsVec(1) boundsVec(4)]
      CALL CTRL_BOUND_2D(fld,mask2D,xx_genarr2d_bounds(1,iarr),myThid)

      CALL EXCH_XY_RL( fld, myThid )

#ifdef ALLOW_TAPENADE
C$AD DO-NOT-DIFF
#endif
      CALL WRITE_REC_3D_RL( fnamegenOut, ctrlprec, 1,
     &                      fld, 1, optimcycle, myThid )
#ifdef ALLOW_TAPENADE
C$AD END-DO-NOT-DIFF
#endif

#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_LEAVE('CTRL_MAP_GENARR2D', myThid )
#endif
#endif /* ALLOW_GENARR2D_CONTROL */

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

CBOP
C     !ROUTINE: CTRL_MAP_GENARR3D
C     !INTERFACE:
      SUBROUTINE CTRL_MAP_GENARR3D( fld, iarr, myThid )

C     !DESCRIPTION: \bv
C     *=================================================================
C     | SUBROUTINE CTRL_MAP_GENARR3D
C     | Add the generic 3D-arrays of the
C     | control vector to the model state and update the tile halos.
C     | The control vector is defined in the header file "CTRL.h".
C     *=================================================================
C     \ev

C     !USES:
      IMPLICIT NONE

C     == global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"

#include "CTRL_SIZE.h"
#include "CTRL.h"
#include "OPTIMCYCLE.h"
#include "CTRL_GENARR.h"
#include "CTRL_DUMMY.h"

C     !INPUT/OUTPUT PARAMETERS:
      _RL     fld(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      INTEGER iarr
      INTEGER myThid

#ifdef ALLOW_OPENAD
      STOP 'ABNORMAL END: CTRL_MAP_GENARR3D is empty'
#else /* ALLOW_OPENAD */
#ifdef ALLOW_GENARR3D_CONTROL
C     !FUNCTIONS:
      INTEGER  ILNBLNK
      EXTERNAL ILNBLNK

C     !LOCAL VARIABLES:
      INTEGER bi,bj
      INTEGER i,j,k
      INTEGER numsmo,k2
      LOGICAL dowc01
      LOGICAL dosmooth
      LOGICAL doscaling
      LOGICAL dolog10ctrl
      _RL log10initval
      _RL ln10
      _RL xx_gen(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      CHARACTER*(MAX_LEN_FNAM) fnamegenIn
      CHARACTER*(MAX_LEN_FNAM) fnamegenOut
      CHARACTER*(MAX_LEN_FNAM) fnamebase
      INTEGER ilgen
      LOGICAL doglobalread
      LOGICAL ladinit
      _RS mask3D(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      INTEGER ilDir
CEOP

#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_ENTER('CTRL_MAP_GENARR3D', myThid )
#endif
C--   Now, read the control vector.
      doglobalread = .FALSE.
      ladinit      = .FALSE.
#ifndef ALLOW_TAPENADE
      CALL CTRL_ASSIGN(xx_gen, Nr, zeroRL, myThid)
#endif
      dosmooth=.FALSE.
      dowc01  = .FALSE.
      doscaling=.TRUE.
      dolog10ctrl=.FALSE.
      log10initval=0. _d 0
      ln10 = LOG(10. _d 0)

      numsmo = 1
      DO k2 = 1, maxCtrlProc
        IF ( xx_genarr3d_preproc(k2,iarr).EQ.'WC01' ) THEN
          dowc01 = .TRUE.
          IF (xx_genarr3d_preproc_i(k2,iarr).NE.0)
     &      numsmo = xx_genarr3d_preproc_i(k2,iarr)
        ENDIF
        IF ( (.NOT.dowc01).AND.
     &       (xx_genarr3d_preproc(k2,iarr).EQ.'smooth') ) THEN
          dosmooth = .TRUE.
          IF (xx_genarr3d_preproc_i(k2,iarr).NE.0)
     &      numsmo = xx_genarr3d_preproc_i(k2,iarr)
        ENDIF
        IF (xx_genarr3d_preproc(k2,iarr).EQ.'noscaling') THEN
          doscaling = .FALSE.
        ENDIF
        IF (xx_genarr3d_preproc_c(k2,iarr).EQ.'log10ctrl') THEN
C             fld := log10(xx_gen)
C               with initial guess for xx_gen set to log10initval
C               passed to data.ctrl, (default = 0.0)
          dolog10ctrl=.TRUE.
          log10initval = xx_genarr3d_preproc_r(k2,iarr)
        ENDIF
      ENDDO

      fnamebase = xx_genarr3d_file(iarr)
      ilgen = ILNBLNK( fnamebase )
C     Find ctrlDir (w/o trailing blanks) length
      ilDir = ilnblnk(ctrlDir)
      WRITE(fnamegenIn,'(2a,i10.10)')
     & ctrlDir(1:ilDir)//fnamebase(1:ilgen),'.',optimcycle
      WRITE(fnamegenOut,'(2a,i10.10)')
     & ctrlDir(1:ilDir)//fnamebase(1:ilgen),'.effective.',optimcycle

      CALL READ_REC_3D_RL( xx_genarr3d_weight(iarr), ctrlprec, Nr,
     &          wgenarr3d(1-OLx,1-OLy,1,1,1,iarr), 1, 1, myThid )

#ifdef ALLOW_AUTODIFF
      CALL ACTIVE_READ_XYZ( fnamegenIn, xx_gen, 1, doglobalread,
     & ladinit, optimcycle, myThid, xx_genarr3d_dummy(iarr) )
#else
      CALL READ_REC_XYZ_RL( fnamegenIn, xx_gen, 1, 1, myThid)
#endif

C --- Get appropriate mask for ctrl variable
      CALL CTRL_GET_MASK3D(xx_genarr3d_file(iarr), mask3D, myThid)

C --- Do any smoothing
#ifdef ALLOW_SMOOTH
      IF (useSMOOTH) THEN
       IF (dowc01) CALL SMOOTH_CORREL3D( xx_gen, numsmo, myThid )
       IF (dosmooth) CALL SMOOTH3D( xx_gen, numsmo, myThid )
      ENDIF
#endif

      DO bj=myByLo(myThid), myByHi(myThid)
       DO bi=myBxLo(myThid), myBxHi(myThid)
        IF (doscaling) THEN
C     scale param adjustment
         DO k = 1,Nr
          DO j = 1,sNy
           DO i = 1,sNx
            IF ( wgenarr3d(i,j,k,bi,bj,iarr).GT.0. ) THEN
             xx_gen(i,j,k,bi,bj) = xx_gen(i,j,k,bi,bj)
     &                / SQRT( wgenarr3d(i,j,k,bi,bj,iarr) )
             IF (dolog10ctrl) THEN
              xx_gen(i,j,k,bi,bj) = xx_gen(i,j,k,bi,bj) + log10initval
c             xx_gen(i,j,k,bi,bj) = 10.0 ** xx_gen(i,j,k,bi,bj)
C     this is faster, especially if log(10) has been evaluated before
c             xx_gen(i,j,k,bi,bj) = EXP(LOG(10.0) * xx_gen(i,j,k,bi,bj))
              xx_gen(i,j,k,bi,bj) = EXP(ln10 * xx_gen(i,j,k,bi,bj))
             ENDIF
            ELSE
             xx_gen(i,j,k,bi,bj) = 0. _d 0
            ENDIF
           ENDDO
          ENDDO
         ENDDO
C     doscaling
        ENDIF
C     add to model parameter
C     or in case of log10ctrl, fld = 10^(xx_gen)
        IF ( dolog10ctrl ) THEN
         DO k = 1,Nr
          DO j = 1,sNy
           DO i = 1,sNx
            fld(i,j,k,bi,bj) = xx_gen(i,j,k,bi,bj)*mask3D(i,j,k,bi,bj)
           ENDDO
          ENDDO
         ENDDO
        ELSE
         DO k = 1,Nr
          DO j = 1,sNy
           DO i = 1,sNx
            fld(i,j,k,bi,bj) = fld(i,j,k,bi,bj)
     &           + xx_gen(i,j,k,bi,bj)*mask3D(i,j,k,bi,bj)
           ENDDO
          ENDDO
         ENDDO
        ENDIF
C     end bi/bj-loops
       ENDDO
      ENDDO

C avoid param out of [boundsVec(1) boundsVec(4)]
      CALL CTRL_BOUND_3D(fld,mask3D,xx_genarr3d_bounds(1,iarr),myThid)

C The tile exchange for xx_uvel and xx_vvel will be
C  done in CTRL_MAP_INI_GENARR.F when both
C  xx_uvel and xx_vvel are read in.
      IF (xx_genarr3d_file(iarr)(1:7).NE.'xx_uvel'.AND.
     &    xx_genarr3d_file(iarr)(1:7).NE.'xx_vvel')
     &    CALL EXCH_XYZ_RL( fld, myThid )

#ifdef ALLOW_TAPENADE
C$AD DO-NOT-DIFF
#endif
      CALL WRITE_REC_3D_RL( fnamegenOut, ctrlprec, Nr,
     &                      fld, 1, optimcycle, myThid )
#ifdef ALLOW_TAPENADE
C$AD END-DO-NOT-DIFF
#endif

#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_LEAVE('CTRL_MAP_GENARR3D', myThid )
#endif
#endif /* ALLOW_GENARR3D_CONTROL */
#endif /* ALLOW_OPENAD */

      RETURN
      END

#include "LAYERS_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      SUBROUTINE LAYERS_INIT_FIXED( myThid )

C ===================================================================
C     Initialize LAYERS variables that are kept fixed during the run.
C ===================================================================

      IMPLICIT NONE
#include "EEPARAMS.h"
#include "SIZE.h"
#include "PARAMS.h"
#include "GRID.h"
#include "LAYERS_SIZE.h"
#include "LAYERS.h"

C  INPUT/OUTPUT PARAMETERS:
C     myThid ::  my Thread Id number
      INTEGER myThid

C  LOCAL VARIABLES:
C     k         :: loop index
C     kk,kkinit :: fine grid loop indices
C     Zf        :: depth at cell boundaries
C     Zf        :: depth at cell centers
C     ZZf       :: depth at cell boundaries (fine grid)
C     ZZc       :: depth at cell centers (fine grid)
C     msgBuf    :: Informational/error message buffer
      INTEGER k,kk,kkinit,iLa
      _RL     Zf(Nr+1)
      _RL     Zc(Nr)
      _RL     ZZf(FineGridMax+1)
      _RL     ZZc(FineGridMax)

      CHARACTER*11   tmpName      
      CHARACTER*(MAX_LEN_MBUF) msgBuf

C     Functions ::
      INTEGER     ILNBLNK
      EXTERNAL    ILNBLNK
      
#ifdef ALLOW_MNC
#ifdef LAYERS_MNC
      IF (layers_MNC) THEN
        CALL LAYERS_MNC_INIT( myThid )
      ENDIF
#endif /* LAYERS_MNC */
#endif /* ALLOW_MNC */

C  Set up the vertical grid

C     for now, just use up the entire available array for ZZ
      NZZ = FineGridMax

C     Z and ZZ are INCREASING DOWNWARD!!!
C     Maybe this is dumb but it will work as long as we are consistent


C     Each dF cell is split into FineGridFact fine cells
C     Calculate dZZf on the fine grid
      kkinit = 1
      DO k=1,Nr
        DO kk=kkinit,kkinit+FineGridFact-1
          dZZf(kk) = dRf(k) / FineGridFact
        ENDDO
        kkinit = kkinit + FineGridFact
      ENDDO

C     find the depths
      Zf(1) = 0. _d 0
      Zc(1) = drC(1)
      DO k=2,Nr
        Zf(k) = Zf(k-1) + drF(k-1)
        Zc(k) = Zc(k-1) + drC(k)
      ENDDO
      Zf(Nr+1) = Zf(Nr) + drF(Nr)

C     create ZZ
      ZZf(1) = 0. _d 0
      ZZc(1) = 0.5 _d 0 * dZZf(1)

      DO kk=2,NZZ+1
            ZZf(kk) = ZZf(kk-1) + dZZf(kk-1)
            ZZc(kk-1) = 0.5 _d 0 * (ZZf(kk) + ZZf(kk-1))
      ENDDO

C     create the interpolating mapping arrays
      k = 1
      DO kk=1,NZZ
C       see if ZZc point is less than the top Zc point
        IF ( ZZc(kk) .LT. Zc(1) ) THEN
          MapIndex(kk) = 1
          MapFact(kk) = 1.0 _d 0
C       see if ZZc point is greater than the bottom Zc point
        ELSE IF ( (ZZc(kk) .GE. Zc(Nr)) .OR. (k .EQ. Nr) ) THEN
          MapIndex(kk) = Nr - 1
          MapFact(kk) = 0.0 _d 0
C       Otherwise we are somewhere in between and need to do interpolation)
        ELSE IF ( (ZZc(kk) .GE. Zc(k))
     &   .AND. (ZZc(kk) .LT. Zc(Nr)) ) THEN
C         Find the proper k value
          DO WHILE (ZZc(kk) .GE. Zc(k+1))
            k = k + 1
          ENDDO
C         If the loop stopped, that means Zc(k) <= ZZc(kk) < ZZc(k+1)
          MapIndex(kk) = k
          MapFact(kk) = 1.0 - (( ZZc(kk) - Zc(k) ) / drC(k+1))
        ELSE
C       This means there was a problem
          WRITE(msgBuf,'(A,I4,A,I4,A,1E14.6,A,2E14.6)')
     &     'S/R LAYERS_INIT_FIXED: kk=', kk, ', k=', k,
     &     ', ZZc(kk)=', ZZc(kk),' , Zc(k)=',Zc(k)
          CALL PRINT_ERROR( msgBuf, myThid )
          STOP 'ABNORMAL END: S/R LAYERS_INIT_FIXED'
        ENDIF

C       See which grid box the point lies in
        IF ( ZZc(kk).LT.Zf(MapIndex(kk)+1) ) THEN
          CellIndex(kk) = MapIndex(kk)
        ELSE
          CellIndex(kk) = MapIndex(kk)+1
        ENDIF
      ENDDO

      IF ( debugLevel .GE. debLevB ) THEN
        CALL PRINT_MESSAGE( 'LAYERS_INIT_FIXED Debugging:',
     &             standardMessageUnit, SQUEEZE_RIGHT, myThid )
        DO kk=1,NZZ
          WRITE(msgBuf,'(A,1F6.1,A,I3,A,I3,A,I3,A,1F6.4,A,I3,A,I3)')
     &     '// ZZc=', ZZc(kk),
     &     ', MapIndex(',kk,')=',MapIndex(kk),
     &     ', MapFact(',kk,')=',MapFact(kk),
     &     ', CellIndex(',kk,')=',CellIndex(kk)
          CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                        SQUEEZE_RIGHT, myThid )
        ENDDO
      ENDIF

C     Output the layer coordinates
      DO iLa=1,layers_maxNum
      IF ( layers_num(iLa).NE.0 ) THEN
      WRITE(tmpName,'(A7,I1,A3)') 'layers',iLa,layers_name(iLa)
      CALL WRITE_GLVEC_RL( tmpName, ' ',layers_bounds(1,iLa),1+Nlayers,
     & -1, myThid )
      ENDIF
      ENDDO
      
C --- Set up layers "w-grid" for transformation calculation 
#ifdef LAYERS_THERMODYNAMICS
      DO iLa=1,layers_maxNum
       IF ( layers_num(iLa).NE.0 ) THEN
        DO k=1,Nlayers
          layers_bounds_w(k,iLa) = 0.5 _d 0 * (
     &           layers_bounds(k+1,iLa) +
     &           layers_bounds(k,iLa) )
        ENDDO
        DO k=1,Nlayers-1
          layers_recip_delta(k,iLa) = 1.0 _d 0 / (
     &           layers_bounds_w(k+1,iLa) -
     &           layers_bounds_w(k,iLa) )
        ENDDO
       ENDIF
      ENDDO
#endif /* LAYERS_THERMODYNAMICS */

#ifdef ALLOW_DIAGNOSTICS
      IF ( useDiagnostics ) THEN
        CALL LAYERS_DIAGNOSTICS_INIT( myThid )
      ENDIF
#endif

      RETURN
      END

#     include "GAD_OPTIONS.h"

      SUBROUTINE GAD_PQM_FLX_R(bi,bj,ix,iy,
     &           delT,wvel,wfac,
     &           fhat,flux,myThid)
C     |================================================================|
C     | PQM_FLX_R: evaluate PQM flux on grid-cell edges.               |
C     |================================================================|

          implicit none

C     =============================================== global variables
#         include "SIZE.h"
#         include "GRID.h"
#         include "GAD.h"

C     ================================================================
C       bi,bj     :: tile indexing.
C       ix        :: x-index.
C       iy        :: y-index.
C       delT      :: time-step.
C       wvel      :: vel.-comp in r-direction.
C       wfac      :: vel.-flux in r-direction.
C       fhat      :: row of poly. coeff.
C       flux      :: adv.-flux in r-direction.
C       myThid    :: thread number.
C     ================================================================
          integer bi,bj,ix,iy
          _RL delT(1:Nr)
          _RL wvel(1-OLx:sNx+OLx,
     &             1-OLy:sNy+OLy,
     &             1:Nr)
          _RL wfac(1-OLx:sNx+OLx,
     &             1-OLy:sNy+OLy,
     &             1:Nr)
          _RL fhat(1:5 ,
     &             1:Nr)
          _RL flux(1-OLx:sNx+OLx,
     &             1-OLy:sNy+OLy,
     &             1:Nr)
          integer myThid

C     ================================================================
C       ir        :: r-indexing.
C       wCFL      :: CFL number.
C       intF      :: upwind tracer edge-value.
C       ss11,ss22 :: int. endpoints.
C       ivec      :: int. basis vec.
C     ================================================================
          integer ir
          _RL wCFL,intF
          _RL ss11,ss22
          _RL ivec(1:5)

C     ================================================================
C       (1): calc. "departure-points" for each grid-cell edge by int-
C            egrating edge position backward in time over one single
C            time-step. This is a "single-cell" implementation: requ-
C            ires CFL <= 1.0.
C       (2): calc. flux as the integral of the upwind grid-cell poly-
C            nomial over the deformation interval found in (1).
C     ================================================================

          do  ir = +2, Nr

              if (wfac(ix,iy,ir) .eq. 0. _d 0) then

                  flux(ix,iy,ir)    = 0. _d 0

              else

              if (wfac(ix,iy,ir) .lt. 0. _d 0) then

C     ==================== integrate PQM profile over upwind cell IR-1
              wCFL = wvel(ix,iy,ir)
     &             * delT(ir-1)*recip_drF(ir-1)

              ss11 = +1. _d 0 + 2. _d 0 * wCFL
              ss22 = +1. _d 0

C     ==================== integrate profile over region swept by face
              ivec(1) = ss22 - ss11
              ivec(2) =(ss22 ** 2
     &                - ss11 ** 2)*(1. _d 0 / 2. _d 0)
              ivec(3) =(ss22 ** 3
     &                - ss11 ** 3)*(1. _d 0 / 3. _d 0)
              ivec(4) =(ss22 ** 4
     &                - ss11 ** 4)*(1. _d 0 / 4. _d 0)
              ivec(5) =(ss22 ** 5
     &                - ss11 ** 5)*(1. _d 0 / 5. _d 0)

              intF = ivec(1) * fhat(1,ir-1)
     &             + ivec(2) * fhat(2,ir-1)
     &             + ivec(3) * fhat(3,ir-1)
     &             + ivec(4) * fhat(4,ir-1)
     &             + ivec(5) * fhat(5,ir-1)

CML              intF = intF / (ss22 - ss11)

              else

C     ==================== integrate PQM profile over upwind cell IR+0
              wCFL = wvel(ix,iy,ir)
     &             * delT(ir-0)*recip_drF(ir-0)

              ss11 = -1. _d 0 + 2. _d 0 * wCFL
              ss22 = -1. _d 0

C     ==================== integrate profile over region swept by face
              ivec(1) = ss22 - ss11
              ivec(2) =(ss22 ** 2
     &                - ss11 ** 2)*(1. _d 0 / 2. _d 0)
              ivec(3) =(ss22 ** 3
     &                - ss11 ** 3)*(1. _d 0 / 3. _d 0)
              ivec(4) =(ss22 ** 4
     &                - ss11 ** 4)*(1. _d 0 / 4. _d 0)
              ivec(5) =(ss22 ** 5
     &                - ss11 ** 5)*(1. _d 0 / 5. _d 0)

              intF = ivec(1) * fhat(1,ir-0)
     &             + ivec(2) * fhat(2,ir-0)
     &             + ivec(3) * fhat(3,ir-0)
     &             + ivec(4) * fhat(4,ir-0)
     &             + ivec(5) * fhat(5,ir-0)

CML              intF = intF / (ss22 - ss11)

              end if

c             intF = -0.5 _d 0 * intF / wCFL
C-    to avoid potential underflow:
              intF = -0.5 _d 0 * intF/sign(max(abs(wCFL),1.d-20),wCFL)

C     ==================== calc. flux = upwind tracer * face-transport
              flux(ix,iy,ir) = + wfac(ix,iy,ir) * intF

              end if

          end do

          return

c     end subroutine GAD_PQM_FLX_R
      end

#include "THSICE_OPTIONS.h"

      SUBROUTINE THSICE_COST_INIT_VARIA( myThid )

c     ==================================================================
c     SUBROUTINE THSICE_COST_INIT_VARIA
c     ==================================================================

      IMPLICIT NONE

c     == global variables ==
#include "EEPARAMS.h"
#include "SIZE.h"
#include "GRID.h"
#ifdef ALLOW_COST
# include "THSICE_COST.h"
#endif

c     == routine arguments ==
      INTEGER myThid

#ifdef ALLOW_COST
c     == local variables ==
      INTEGER bi,bj

c     == end of interface ==

c--   Initialize the tiled cost function contributions.
      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
         objf_thsice(bi,bj) = 0. _d 0
         num_thsice(bi,bj)  = 0. _d 0
       ENDDO
      ENDDO

#endif /* ALLOW_COST */

      RETURN
      END

#include "COST_OPTIONS.h"

CBOP
C !ROUTINE: COST_DRIVER

C !INTERFACE: ==========================================================
      SUBROUTINE COST_DRIVER(
     I                        myTime, myIter, myThid )

C !DESCRIPTION:
C Driver routine to calculate cost function terms at the end of the model run

C !USES: ===============================================================
      IMPLICIT NONE
C     == Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"

C !INPUT PARAMETERS: ===================================================
C myTime    :: Current time in simulation
C myIter    :: Current time-step number
C myThid    :: my Thread Id number
      _RL     myTime
      INTEGER myIter, myThid

C !OUTPUT PARAMETERS: ==================================================
CEOP

#ifdef ALLOW_COST

#ifdef ALLOW_OBCS
      IF ( useOBCS ) THEN
# ifdef ALLOW_DEBUG
       IF (debugMode) CALL DEBUG_CALL('OBCS_COST_DRIVER',myThid)
# endif
       CALL TIMER_START('OBCS_COST_DRIVER  [COST_DRIVER]', myThid)
       CALL OBCS_COST_DRIVER( myTime, myIter, myThid )
       CALL TIMER_STOP ('OBCS_COST_DRIVER  [COST_DRIVER]', myThid)
      ENDIF
#endif

#ifdef ALLOW_ECCO
      IF ( useECCO ) then
c--   Compute ecco specific cost function contributions, that is,
c--   user defined cost function contributions.
# ifdef ALLOW_DEBUG
       IF (debugMode) CALL DEBUG_CALL('COST_GENCOST_ALL',myThid)
# endif
       CALL TIMER_START('COST_GENCOST_ALL  [COST_DRIVER]', myThid)
       CALL COST_GENCOST_ALL( myIter, myTime, myThid )
       CALL TIMER_STOP ('COST_GENCOST_ALL  [COST_DRIVER]', myThid)
      ENDIF
#endif

#ifdef ALLOW_CTRL
      IF ( useCTRL ) THEN
# ifdef ALLOW_DEBUG
       IF (debugMode) CALL DEBUG_CALL('CTRL_COST_DRIVER',myThid)
# endif
       CALL TIMER_START('CTRL_COST_DRIVER  [COST_DRIVER]', myThid)
       CALL CTRL_COST_DRIVER( myTime, myIter, myThid )
       CALL TIMER_STOP ('CTRL_COST_DRIVER  [COST_DRIVER]', myThid)
      ENDIF
#endif

#endif /* ALLOW_COST */

      RETURN
      END

      subroutine cubic( t, f, fp, ta, fa, fpa, tlower, tupper )

c-----------------------------------------
c arguments
c-----------------------------------------
      double precision    t, f, fp, ta, fa, fpa, tlower, tupper

c-----------------------------------------
c local variables
c-----------------------------------------
      double precision sign, den, anum
      double precision z1, b, discri

c-----------------------------------------
c Using f and fp at t and ta,
c computes new t by cubic formula
c safeguarded inside [tlower,tupper].
c-----------------------------------------
      z1 = dble(fp) + dble(fpa) - 3.d0*dble(fa-f)/dble(ta-t)
      b  = z1 + dble(fp)

c-----------------------------------------
c first compute the discriminant
c (without overflow)
c-----------------------------------------
      if (abs(z1).le.1.) then
         discri = z1*z1-dble(fp)*dble(fpa)
         if (discri .lt. 0.d0) then
            if (fp.lt.0.) t = tupper
            if (fp.ge.0.) t = tlower
            return
         else
            discri = dsqrt(discri)
         end if
      else
         discri = dble(fp)/z1
         discri = discri*dble(fpa)
         discri = z1-discri
         if (z1.ge.0.d0 .and. discri.ge.0.d0) then
            discri = dsqrt(z1)*dsqrt(discri)
         else if (z1.le.0.d0 .and. discri.le.0.d0) then
            discri = dsqrt(-z1)*dsqrt(-discri)
         else
            if (fp.lt.0.) t = tupper
            if (fp.ge.0.) t = tlower
            return
         end if
      end if

c-----------------------------------------
c discriminant nonnegative,
c compute solution (without overflow)
c-----------------------------------------
      if (t-ta .lt. 0.0) then
         discri = -discri
      end if

      sign = (t-ta)/abs(t-ta)
      if (sngl(b)*sign .gt. 0.0) then
         t    = t + fp*(ta-t)/sngl(b+discri)
      else
         den  = sngl(z1+b+dble(fpa))
         anum = sngl(b-discri)
         if (abs((t-ta)*anum).lt.(tupper-tlower)*abs(den)) then
            t = t + anum*(ta-t)/den
         else
            t = tupper
         end if
      end if

      t = max( t, tlower )
      t = min( t, tupper )
      
      return
      end

#include "ECCO_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 0
C !ROUTINE: ECCO_DIAGNOSTICS_INIT

C !INTERFACE:
      SUBROUTINE ECCO_DIAGNOSTICS_INIT( myThid )

C     !DESCRIPTION:
C     Initialize list of all available diagnostics

C     !USES:
      IMPLICIT NONE

C     === Global variables ===
#include "EEPARAMS.h"
#include "SIZE.h"
#include "PARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     myThid    :: my Thread Id number
      INTEGER myThid
CEOP

#ifdef ALLOW_DIAGNOSTICS
C     !FUNCTIONS:
      CHARACTER*(16) DIAGS_MK_UNITS
      EXTERNAL DIAGS_MK_UNITS

C     !LOCAL VARIABLES:
C     diagNum   :: diagnostics number in the (long) list of available diag.
C     diagMate  :: diag. mate number in the (long) list of available diag.
C     diagName  :: local short name (8c) of a diagnostics
C     diagCode  :: local parser field with characteristics of the diagnostics
C              cf head of S/R DIAGNOSTICS_INIT_EARLY or DIAGNOSTICS_MAIN_INIT
C     diagUnits :: local string (16c): physical units of a diagnostic field
C     diagTitle :: local string (80c): description of field in diagnostic
      INTEGER       diagNum
c     INTEGER       diagMate
      CHARACTER*8   diagName
      CHARACTER*16  diagCode
      CHARACTER*16  diagUnits
      CHARACTER*(80) diagTitle
      CHARACTER*2    rUnit2c

      IF ( usingPCoords ) THEN
        rUnit2c= 'Pa'
      ELSE
        rUnit2c= 'm '
      ENDIF

      diagName  = 'SSH     '
      diagTitle = 'Dynamic Sea Surface Height Anomaly'
      diagUnits = DIAGS_MK_UNITS( rUnit2c, myThid )
      diagCode  = 'SM      M1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I        diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'SSHIBC  '
      diagTitle =
     I  'Inverted Barometer (IB) Correction to Sea Surface Height'
      diagUnits = DIAGS_MK_UNITS( rUnit2c, myThid )
      diagCode  = 'SM      M1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I        diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'SSHNOIBC'
      diagTitle = 'Sea Surface Height Anomaly without IB '
     I          //'Correction (=SSH+SSHIBC)'
      diagUnits = DIAGS_MK_UNITS( rUnit2c, myThid )
      diagCode  = 'SM      M1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I        diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'STERICHT'
      diagTitle = 'Steric Sea Surface Height Anomaly (=SSH-OBP)'
      diagUnits = DIAGS_MK_UNITS( rUnit2c, myThid )
      diagCode  = 'SM      M1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I        diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'OBP     '
      diagTitle = 'Ocean Bottom Pressure'
      diagUnits = 'm               '
      diagCode  = 'SM      M1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I        diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'OBPGMAP '
      diagTitle = 'Ocean Bottom Pressure '
     I          //'Including Global Mean Atmospheric Pressure'
      diagUnits = 'm               '
      diagCode  = 'SM      M1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I        diagName, diagCode, diagUnits, diagTitle, 0, myThid )

#endif /* ALLOW_DIAGNOSTICS */

      RETURN
      END

#include "OBCS_OPTIONS.h"

      SUBROUTINE OBCS_CHECK_DEPTHS( myThid )
C     *==========================================================*
C     | SUBROUTINE OBCS_CHECK_DEPTHS
C     | o Check for non-zero normal gradient across open
C     |   boundaries
C     | o fix them if required and print a message
C     *==========================================================*
C     *==========================================================*
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "OBCS_PARAMS.h"
#include "OBCS_GRID.h"

C     === Routine arguments ===
C     myThid    :: my Thread Id number
      INTEGER myThid

#ifdef ALLOW_OBCS
C     === Local variables ===
C     msgBuf    :: Informational/error message buffer
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      INTEGER bi, bj, i, j, ichanged

      IF ( OBCSfixTopo ) THEN
C--   Modify topography to ensure that outward d(topography)/dn >= 0,
C     topography at open boundary points must be equal or shallower than
C     topography one grid-point inward from open boundary
      ichanged = 0
      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)

#ifdef ALLOW_OBCS_NORTH
        DO i=1,sNx
         j = OB_Jn(i,bi,bj)
         IF ( j.NE.OB_indexNone ) THEN
          IF ( R_low(i,j,bi,bj) .LT. R_low(i,j-1,bi,bj) ) THEN
           ichanged = ichanged + 1
           R_low(i,j,bi,bj) = R_low(i,j-1,bi,bj)
           WRITE(msgBuf,'(2A,2I6,2I4)')
     &          'OBCS_CHECK_DEPTHS: fixed topography at ',
     &          '(i,j,bi,bj)=',  i, j, bi, bj
           CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &          SQUEEZE_RIGHT, myThid)
          ENDIF
         ENDIF
        ENDDO
#endif
#ifdef ALLOW_OBCS_SOUTH
        DO i=1,sNx
         j = OB_Js(i,bi,bj)
         IF ( j.NE.OB_indexNone ) THEN
          IF ( R_low(i,j,bi,bj) .LT. R_low(i,j+1,bi,bj) ) THEN
           ichanged = ichanged + 1
           R_low(i,j,bi,bj) = R_low(i,j+1,bi,bj)
           WRITE(msgBuf,'(2A,2I6,2I4)')
     &          'OBCS_CHECK_DEPTHS: fixed topography at ',
     &          '(i,j,bi,bj)=',  i, j, bi, bj
           CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &          SQUEEZE_RIGHT, myThid)
          ENDIF
         ENDIF
        ENDDO
#endif
#ifdef ALLOW_OBCS_EAST
        DO j=1,sNy
         i = OB_Ie(j,bi,bj)
         IF ( i.NE.OB_indexNone ) THEN
          IF ( R_low(i,j,bi,bj) .LT. R_low(i-1,j,bi,bj) ) THEN
           ichanged = ichanged + 1
           R_low(i,j,bi,bj) = R_low(i-1,j,bi,bj)
           WRITE(msgBuf,'(2A,2I6,2I4)')
     &          'OBCS_CHECK_DEPTHS: fixed topography at ',
     &          '(i,j,bi,bj)=',  i, j, bi, bj
           CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &          SQUEEZE_RIGHT, myThid)
          ENDIF
         ENDIF
        ENDDO
#endif
C Western boundary
#ifdef ALLOW_OBCS_WEST
        DO j=1,sNy
         i = OB_Iw(j,bi,bj)
         IF ( i.NE.OB_indexNone ) THEN
          IF ( R_low(i,j,bi,bj) .LT. R_low(i+1,j,bi,bj) ) THEN
           ichanged = ichanged + 1
           R_low(i,j,bi,bj) = R_low(i+1,j,bi,bj)
           WRITE(msgBuf,'(2A,2I6,2I4)')
     &          'OBCS_CHECK_DEPTHS: fixed topography at ',
     &          '(i,j,bi,bj)=',  i, j, bi, bj
           CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &          SQUEEZE_RIGHT, myThid)
          ENDIF
         ENDIF
        ENDDO
#endif

       ENDDO
      ENDDO
C--   some diagnostics to stdout
      CALL GLOBAL_SUM_INT( ichanged, myThid )
      IF ( ichanged .GT. 0 ) THEN
       _BEGIN_MASTER(myThid)
       WRITE(msgBuf,'(2A,I7,A)') 'OBCS_CHECK_DEPTHS: ',
     &   'Topography gradients normal to open boundaries:'
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                     SQUEEZE_RIGHT, myThid )
       WRITE(msgBuf,'(2A,I7,A)') 'OBCS_CHECK_DEPTHS: ',
     &   '==> corrected ', ichanged,' problematic grid-points'
c      WRITE(msgBuf,'(A,I7,A,A)')
c    &      'OBCS message: corrected ', ichanged,
c    &      ' instances of problematic topography gradients',
c    &      ' normal to open boundaries'
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                     SQUEEZE_RIGHT, myThid )
       _END_MASTER(myThid)
      ENDIF

C     endif (OBCSfixTopo)
      ENDIF
#endif /* ALLOW_OBCS */

      RETURN
      END

#include "CTRL_OPTIONS.h"
#include "AD_CONFIG.h"
#if (      defined ALLOW_GENARR2D_CONTROL \
        || defined ALLOW_GENARR3D_CONTROL \
        || defined ALLOW_GENTIM2D_CONTROL )
# define ALLOW_GENARR_CONTROL
#endif
C--  File ctrl_readparms.F:
C--   Contents
C--   o CTRL_READPARMS
C--   o CTRL_SET_RETIRED_PARMS
C--   o CTRL_CHECK_RETIRED_PARMS

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: CTRL_READPARMS
C     !INTERFACE:
      SUBROUTINE CTRL_READPARMS( myThid )

C     !DESCRIPTION:
C     ==================================================================
C     o read ctrl parameters
C     ==================================================================

C     !USES:
      IMPLICIT NONE

C     == global variables ==
#include "EEPARAMS.h"
#include "SIZE.h"
#include "PARAMS.h"
#ifdef ALLOW_CTRL
# include "CTRL_SIZE.h"
# include "CTRL.h"
# include "CTRL_GENARR.h"
# include "CTRL_OBCS.h"
# include "ctrl_local_params.h"
#endif
#ifdef ALLOW_AUTODIFF
#include "AUTODIFF_PARAMS.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
      INTEGER myThid

C     == EXTERNAL FUNCTIONS ==
      INTEGER  ILNBLNK
      EXTERNAL ILNBLNK

C     !LOCAL VARIABLES:
      INTEGER iUnit
      INTEGER nRetired
      CHARACTER*(MAX_LEN_MBUF) msgBuf
#ifdef ALLOW_GENARR_CONTROL
      INTEGER iarr,jarr
#endif
      CHARACTER*(MAX_LEN_FNAM) namBuf
      INTEGER IL
#ifdef HAVE_SYSTEM
      INTEGER pIL
#endif
C     auxillary variable to simplify code
      _RL mult_default
C     retired parameters (others are in ctrl_local_params.h)
      LOGICAL ctrlUseGen
      LOGICAL ctrlSmoothCorrel3D
      LOGICAL ctrlSmoothCorrel2D
#ifndef ALLOW_COST
C     dummy values, so that namelist need not change
      _RL  mult_obcsN, mult_obcsS
      _RL  mult_obcsE, mult_obcsW
      _RL  mult_obcsvol, mult_ageos
# ifdef ALLOW_GENARR_CONTROL
      _RL  mult_gentim2d(maxCtrlTim2D)
      _RL  mult_genarr2d(maxCtrlArr2D)
      _RL  mult_genarr3d(maxCtrlArr3D)
# endif
#endif
CEOP

C--   Read the namelist input.
      NAMELIST /CTRL_NML/
     &  xx_theta_file, xx_salt_file,
     &  xx_hflux_file, xx_hflux_remo_intercept, xx_hflux_remo_slope,
     &  xx_hfluxstartdate1, xx_hfluxstartdate2, xx_hfluxperiod,
     &  xx_sflux_file, xx_sflux_remo_intercept, xx_sflux_remo_slope,
     &  xx_sfluxstartdate1, xx_sfluxstartdate2, xx_sfluxperiod,
     &  xx_tauu_file, xx_tauu_remo_intercept, xx_tauu_remo_slope,
     &  xx_tauustartdate1,  xx_tauustartdate2,  xx_tauuperiod,
     &  xx_tauv_file, xx_tauv_remo_intercept, xx_tauv_remo_slope,
     &  xx_tauvstartdate1,  xx_tauvstartdate2,  xx_tauvperiod,
     &  xx_atemp_file, xx_atemp_remo_intercept, xx_atemp_remo_slope,
     &  xx_atempstartdate1, xx_atempstartdate2, xx_atempperiod,
     &  xx_aqh_file, xx_aqh_remo_intercept, xx_aqh_remo_slope,
     &  xx_aqhstartdate1, xx_aqhstartdate2, xx_aqhperiod,
     &  xx_precip_file, xx_precip_remo_intercept, xx_precip_remo_slope,
     &  xx_precipstartdate1, xx_precipstartdate2, xx_precipperiod,
     &  xx_swflux_file, xx_swflux_remo_intercept, xx_swflux_remo_slope,
     &  xx_swfluxstartdate1, xx_swfluxstartdate2, xx_swfluxperiod,
     &  xx_swdown_file, xx_swdown_remo_intercept, xx_swdown_remo_slope,
     &  xx_swdownstartdate1, xx_swdownstartdate2, xx_swdownperiod,
     &  xx_lwflux_file, xx_lwflux_remo_intercept, xx_lwflux_remo_slope,
     &  xx_lwfluxstartdate1, xx_lwfluxstartdate2, xx_lwfluxperiod,
     &  xx_lwdown_file, xx_lwdown_remo_intercept, xx_lwdown_remo_slope,
     &  xx_lwdownstartdate1, xx_lwdownstartdate2, xx_lwdownperiod,
     &  xx_evap_file, xx_evap_remo_intercept, xx_evap_remo_slope,
     &  xx_evapstartdate1, xx_evapstartdate2, xx_evapperiod,
     &  xx_snowprecip_file, xx_snowprecip_remo_intercept,
     &  xx_snowprecip_remo_slope,  xx_snowprecipperiod,
     &  xx_snowprecipstartdate1, xx_snowprecipstartdate2,
     &  xx_apressure_file, xx_apressure_remo_intercept,
     &  xx_apressure_remo_slope, xx_apressureperiod,
     &  xx_apressurestartdate1, xx_apressurestartdate2,
     &  xx_runoff_file, xx_runoff_remo_intercept, xx_runoff_remo_slope,
     &  xx_runoffstartdate1, xx_runoffstartdate2, xx_runoffperiod,
     &  xx_uwind_file, xx_uwind_remo_intercept, xx_uwind_remo_slope,
     &  xx_uwindstartdate1, xx_uwindstartdate2, xx_uwindperiod,
     &  xx_vwind_file, xx_vwind_remo_intercept, xx_vwind_remo_slope,
     &  xx_vwindstartdate1, xx_vwindstartdate2, xx_vwindperiod,
     &  xx_aqh_mean_file, xx_atemp_mean_file, xx_precip_mean_file,
     &  xx_swdown_mean_file, xx_uwind_mean_file, xx_vwind_mean_file,
     &  xx_obcsN_file,
     &  xx_obcsNstartdate1,  xx_obcsNstartdate2,  xx_obcsNperiod,
     &  xx_obcsS_file,
     &  xx_obcsSstartdate1,  xx_obcsSstartdate2,  xx_obcsSperiod,
     &  xx_obcsE_file,
     &  xx_obcsEstartdate1,  xx_obcsEstartdate2,  xx_obcsEperiod,
     &  xx_obcsW_file,
     &  xx_obcsWstartdate1,  xx_obcsWstartdate2,  xx_obcsWperiod,
     &  xx_diffkr_file, xx_kapgm_file, xx_kapredi_file, xx_tr1_file,
     &  xx_sst_file, xx_sst_remo_intercept, xx_sst_remo_slope,
     &  xx_sss_file, xx_sss_remo_intercept, xx_sss_remo_slope,
     &  xx_sststartdate1, xx_sststartdate2, xx_sstperiod,
     &  xx_sssstartdate1, xx_sssstartdate2, xx_sssperiod,
     &  xx_depth_file, xx_gen2d_file, xx_gen3d_file,
     &  xx_efluxy_file, xx_efluxp_file, xx_bottomdrag_file,
     &  xx_edtaux_file, xx_edtauy_file,
     &  xx_uvel_file, xx_vvel_file, xx_etan_file,
     &  xx_siarea_file, xx_siheff_file, xx_sihsnow_file,
     &  xx_shifwflx_file,
     &  xx_shifwflx_remo_intercept, xx_shifwflx_remo_slope,
     &  xx_shifwflxstartdate1, xx_shifwflxstartdate2, xx_shifwflxperiod,
     &  mult_obcsN, mult_obcsS, mult_obcsE, mult_obcsW,
     &  mult_obcsvol, mult_ageos,
     &  obcs_data_errfile,
     &  doInitXX, ctrlSmoothCorrel3D, ctrlSmoothCorrel2D, ctrlUseGen,
     &  doPackDiag,
     &  doZscaleUnpack, doZscalePack,
     &  doMainUnpack, doMainPack,
     &  doSinglePrecTapelev,
     &  doAdmtlmBypassAD,
     &  delZexp, forcingPrecond, ctrlprec, ctrlDir
cHFLUXM_CONTROL
     &  ,xx_hfluxm_file
cHFLUXM_CONTROL

      NAMELIST /CTRL_PACKNAMES/
     &  yadmark, yctrlid, yctrlposunpack, yctrlpospack,
     &  ctrlname, costname, scalname, maskname, metaname

#ifdef ALLOW_GENARR_CONTROL
      NAMELIST /CTRL_NML_GENARR/
     &  xx_genarr2d_file, xx_genarr3d_file, xx_gentim2d_file,
     &  xx_genarr2d_weight, xx_genarr3d_weight, xx_gentim2d_weight,
     &  xx_genarr2d_bounds, xx_genarr3d_bounds, xx_gentim2d_bounds,
     &  genarr2dPrecond, genarr3dPrecond, gentim2dPrecond,
     &  mult_gentim2d,mult_genarr2d,mult_genarr3d,
     &  xx_genarr2d_preproc, xx_genarr2d_preproc_i,
     &  xx_genarr2d_preproc_r, xx_genarr2d_preproc_c,
     &  xx_genarr3d_preproc, xx_genarr3d_preproc_i,
     &  xx_genarr3d_preproc_r, xx_genarr3d_preproc_c,
     &  xx_gentim2d_preproc, xx_gentim2d_preproc_i,
     &  xx_gentim2d_preproc_r, xx_gentim2d_preproc_c,
     &  xx_gentim2d_period,
     &  xx_gentim2d_startdate1, xx_gentim2d_startdate2,
     &  xx_gentim2d_cumsum,xx_gentim2d_glosum
#endif

      IF ( .NOT.useCTRL ) THEN
C-    pkg CTRL is not used
        _BEGIN_MASTER(myThid)
C-    Track pkg activation status:
C     print a (weak) warning if data.ctrl is found
         CALL PACKAGES_UNUSED_MSG( 'useCTRL', ' ', ' ' )
        _END_MASTER(myThid)
        RETURN
      ENDIF

      _BEGIN_MASTER( myThid )

C--     Set default values.
        doInitXX            = .TRUE.
#ifdef ALLOW_SMOOTH_CORREL3D
        ctrlSmoothCorrel3D  = .TRUE.
#else
        ctrlSmoothCorrel3D  = .FALSE.
#endif
#ifdef ALLOW_SMOOTH_CORREL2D
        ctrlSmoothCorrel2D  = .TRUE.
#else
        ctrlSmoothCorrel2D  = .FALSE.
#endif
        ctrlUseGen          = .TRUE.
#ifdef ALLOW_ADMTLM
        doAdmTlm            = .TRUE.
#else
        doAdmTlm            = .FALSE.
#endif
        doPackDiag          = .FALSE.
        doZscaleUnpack      = .FALSE.
        doZscalePack        = .FALSE.
        doMainUnpack        = .TRUE.
#if (defined (ALLOW_ADJOINT_RUN)||defined (ALLOW_TANGENTLINEAR_RUN))
        doMainPack          = .TRUE.
#else
        doMainPack          = .FALSE.
#endif
        doSinglePrecTapelev = .FALSE.
        doAdmtlmBypassAD    = .FALSE.

        delZexp = 0.
        forcingPrecond = 1. _d 0

#ifdef CTRL_SET_PREC_32
C     for backward compatibility set default value to 32 if this
C     flag is defined
        ctrlprec = 32
#else
        ctrlprec = 64
#endif

        obcs_data_errfile = ' '
        ctrlDir = ' '

        xx_theta_file      = 'xx_theta'
        xx_salt_file       = 'xx_salt'

        xx_gen2d_file      = 'xx_gen2d'
        xx_gen3d_file      = 'xx_gen3d'

#ifdef ALLOW_GENARR_CONTROL
        do iarr = 1, maxCtrlArr2D
         write(xx_genarr2d_file(iarr)(1:MAX_LEN_FNAM),'(a)') ' '
#ifdef ALLOW_OPENAD
         write(xx_genarr2d_file(iarr)(1:14),'(a,i2.2)')
     &        'xx_genarr2d_', iarr
         write(xx_genarr2d_file(iarr)(15:MAX_LEN_FNAM),'(a)') ' '
#endif
         write(xx_genarr2d_weight(iarr)(1:MAX_LEN_FNAM),'(a)') ' '
         genarr2dPrecond(iarr)  = 1. _d 0
         mult_genarr2d(iarr)    = UNSET_RL
         do jarr = 1, 5
           xx_genarr2d_bounds(jarr,iarr) = 0. _d 0
         enddo
         do jarr=1,maxCtrlProc
          xx_genarr2d_preproc(jarr,iarr)   = ' '
          xx_genarr2d_preproc_c(jarr,iarr) = ' '
          xx_genarr2d_preproc_i(jarr,iarr) = 0
          xx_genarr2d_preproc_r(jarr,iarr) = 0. _d 0
         enddo
        enddo

        do iarr = 1, maxCtrlArr3D
         write(xx_genarr3d_file(iarr)(1:MAX_LEN_FNAM),'(a)') ' '
#ifdef ALLOW_OPENAD
         write(xx_genarr3d_file(iarr)(1:14),'(a,i2.2)')
     &        'xx_genarr3d_', iarr
         write(xx_genarr3d_file(iarr)(15:MAX_LEN_FNAM),'(a)') ' '
#endif
         write(xx_genarr3d_weight(iarr)(1:MAX_LEN_FNAM),'(a)') ' '
         genarr3dPrecond(iarr)  = 1. _d 0
         mult_genarr3d(iarr)    = UNSET_RL
         do jarr = 1, 5
           xx_genarr3d_bounds(jarr,iarr) = 0. _d 0
         enddo
         do jarr=1,maxCtrlProc
          xx_genarr3d_preproc(jarr,iarr)   = ' '
          xx_genarr3d_preproc_c(jarr,iarr) = ' '
          xx_genarr3d_preproc_i(jarr,iarr) = 0
          xx_genarr3d_preproc_r(jarr,iarr) = 0. _d 0
         enddo
        enddo

        do iarr = 1, maxCtrlTim2D
         write(xx_gentim2d_file(iarr)(1:MAX_LEN_FNAM),'(a)') ' '
#ifdef ALLOW_OPENAD
         write(xx_gentim2d_file(iarr)(1:14),'(a,i2.2)')
     &        'xx_gentim2d_', iarr
         write(xx_gentim2d_file(iarr)(15:MAX_LEN_FNAM),'(a)') ' '
#endif
         write(xx_gentim2d_weight(iarr)(1:MAX_LEN_FNAM),'(a)') ' '
         xx_gentim2d_startdate1(iarr) = 0
         xx_gentim2d_startdate2(iarr) = 0
         xx_gentim2d_period(iarr)     = 0. _d 0
         xx_gentim2d_cumsum(iarr)     = .FALSE.
         xx_gentim2d_glosum(iarr)     = .FALSE.
         do jarr=1,maxCtrlProc
          xx_gentim2d_preproc(jarr,iarr)   = ' '
          xx_gentim2d_preproc_c(jarr,iarr) = ' '
          xx_gentim2d_preproc_i(jarr,iarr) = 0
          xx_gentim2d_preproc_r(jarr,iarr) = 0. _d 0
         enddo
         gentim2dPrecond(iarr)        = 1. _d 0
         mult_gentim2d(iarr)          = UNSET_RL
         do jarr = 1, 5
           xx_gentim2d_bounds(jarr,iarr) = 0. _d 0
         enddo
        enddo
#endif

        xx_obcsNstartdate1  =   0
        xx_obcsNstartdate2  =   0
        xx_obcsNperiod      =   0. _d 0
        xx_obcsN_file       = 'xx_obcsn'

        xx_obcsSstartdate1  =   0
        xx_obcsSstartdate2  =   0
        xx_obcsSperiod      =   0. _d 0
        xx_obcsS_file       = 'xx_obcss'

        xx_obcsEstartdate1  =   0
        xx_obcsEstartdate2  =   0
        xx_obcsEperiod      =   0. _d 0
        xx_obcsE_file       = 'xx_obcse'

        xx_obcsWstartdate1  =   0
        xx_obcsWstartdate2  =   0
        xx_obcsWperiod      =   0. _d 0
        xx_obcsW_file       = 'xx_obcsw'

        mult_obcsN          =   0. _d 0
        mult_obcsS          =   0. _d 0
        mult_obcsE          =   0. _d 0
        mult_obcsW          =   0. _d 0
        mult_obcsvol        =   0. _d 0
        mult_ageos          =   0. _d 0

C     retired parameters

        CALL CTRL_SET_RETIRED_PARMS(xx_hfluxstartdate1,
     I       xx_hfluxstartdate2, xx_hfluxperiod, xx_hflux_file,
     I       xx_hflux_file, xx_hflux_remo_intercept,
     I       xx_hflux_remo_slope , myThid )
        CALL CTRL_SET_RETIRED_PARMS(xx_sfluxstartdate1,
     I       xx_sfluxstartdate2, xx_sfluxperiod, xx_sflux_file,
     I       xx_sflux_file, xx_sflux_remo_intercept,
     I       xx_sflux_remo_slope, myThid )
        CALL CTRL_SET_RETIRED_PARMS(xx_tauustartdate1,xx_tauustartdate2,
     I       xx_tauuperiod, xx_tauu_file, xx_tauu_file,
     I       xx_tauu_remo_intercept, xx_tauu_remo_slope, myThid )
        CALL CTRL_SET_RETIRED_PARMS(xx_tauvstartdate1,xx_tauvstartdate2,
     I       xx_tauvperiod, xx_tauv_file, xx_tauv_file,
     I       xx_tauv_remo_intercept, xx_tauv_remo_slope, myThid )
        CALL CTRL_SET_RETIRED_PARMS(xx_atempstartdate1,
     I       xx_atempstartdate2, xx_atempperiod, xx_atemp_file,
     I       xx_atemp_mean_file, xx_atemp_remo_intercept,
     I       xx_atemp_remo_slope, myThid )
        CALL CTRL_SET_RETIRED_PARMS(xx_aqhstartdate1, xx_aqhstartdate2,
     I       xx_aqhperiod, xx_aqh_file, xx_aqh_mean_file,
     I       xx_aqh_remo_intercept, xx_aqh_remo_slope, myThid )
        CALL CTRL_SET_RETIRED_PARMS(xx_precipstartdate1,
     I       xx_precipstartdate2, xx_precipperiod, xx_precip_file,
     I       xx_precip_mean_file, xx_precip_remo_intercept,
     I       xx_precip_remo_slope, myThid )
        CALL CTRL_SET_RETIRED_PARMS(xx_sfluxstartdate1,
     I       xx_sfluxstartdate2, xx_sfluxperiod, xx_sflux_file,
     I       xx_sflux_file, xx_sflux_remo_intercept,xx_sflux_remo_slope,
     I       myThid )
        CALL CTRL_SET_RETIRED_PARMS(xx_swdownstartdate1,
     I       xx_swdownstartdate2, xx_swdownperiod, xx_swdown_file,
     I       xx_swdown_mean_file, xx_swdown_remo_intercept,
     I       xx_swdown_remo_slope, myThid )
        CALL CTRL_SET_RETIRED_PARMS(xx_lwfluxstartdate1,
     I       xx_lwfluxstartdate2, xx_lwfluxperiod, xx_lwflux_file,
     I       xx_lwflux_file, xx_lwflux_remo_intercept,
     I       xx_lwflux_remo_slope, myThid )
        CALL CTRL_SET_RETIRED_PARMS(xx_lwdownstartdate1,
     I       xx_lwdownstartdate2, xx_lwdownperiod, xx_lwdown_file,
     I       xx_lwdown_file, xx_lwdown_remo_intercept,
     I       xx_lwdown_remo_slope, myThid )
        CALL CTRL_SET_RETIRED_PARMS(xx_evapstartdate1,xx_evapstartdate2,
     I       xx_evapperiod, xx_evap_file, xx_evap_file,
     I       xx_evap_remo_intercept, xx_evap_remo_slope, myThid )
        CALL CTRL_SET_RETIRED_PARMS(xx_snowprecipstartdate1,
     I       xx_snowprecipstartdate2, xx_snowprecipperiod,
     I       xx_snowprecip_file, xx_snowprecip_file,
     I       xx_snowprecip_remo_intercept, xx_snowprecip_remo_slope,
     I       myThid )
        CALL CTRL_SET_RETIRED_PARMS(xx_apressurestartdate1,
     I       xx_apressurestartdate2, xx_apressureperiod,
     I       xx_apressure_file, xx_apressure_file,
     I       xx_apressure_remo_intercept, xx_apressure_remo_slope,
     I       myThid )
        CALL CTRL_SET_RETIRED_PARMS(xx_runoffstartdate1,
     I       xx_runoffstartdate2, xx_runoffperiod, xx_runoff_file,
     I       xx_runoff_file, xx_runoff_remo_intercept,
     I       xx_runoff_remo_slope, myThid )
        CALL CTRL_SET_RETIRED_PARMS(xx_uwindstartdate1,
     I       xx_uwindstartdate2, xx_uwindperiod, xx_uwind_file,
     I       xx_uwind_file, xx_uwind_remo_intercept,xx_uwind_remo_slope,
     I       myThid )
        CALL CTRL_SET_RETIRED_PARMS(xx_vwindstartdate1,
     I       xx_vwindstartdate2, xx_vwindperiod, xx_vwind_file,
     I       xx_vwind_file, xx_vwind_remo_intercept,xx_vwind_remo_slope,
     I       myThid )
        CALL CTRL_SET_RETIRED_PARMS(xx_sststartdate1, xx_sststartdate2,
     I       xx_sstperiod, xx_sst_file, xx_sst_file,
     I       xx_sst_remo_intercept, xx_sst_remo_slope, myThid )
        CALL CTRL_SET_RETIRED_PARMS(xx_sssstartdate1, xx_sssstartdate2,
     I       xx_sssperiod, xx_sss_file, xx_sss_file,
     I       xx_sss_remo_intercept, xx_sss_remo_slope, myThid )
        CALL CTRL_SET_RETIRED_PARMS(xx_shifwflxstartdate1,
     I       xx_shifwflxstartdate2, xx_shifwflxperiod, xx_shifwflx_file,
     I       xx_shifwflx_file, xx_shifwflx_remo_intercept,
     I       xx_shifwflx_remo_slope, myThid )

        xx_diffkr_file      = ' '
        xx_kapgm_file       = ' '
        xx_kapredi_file     = ' '
        xx_tr1_file         = ' '
        xx_depth_file       = ' '
        xx_efluxy_file      = ' '
        xx_efluxp_file      = ' '
        xx_bottomdrag_file  = ' '
        xx_edtaux_file      = ' '
        xx_edtauy_file      = ' '
        xx_uvel_file        = ' '
        xx_vvel_file        = ' '
        xx_etan_file        = ' '
        xx_siarea_file      = ' '
        xx_siheff_file      = ' '
        xx_sihsnow_file     = ' '
cHFLUXM_CONTROL
        xx_hfluxm_file      = ' '
cHFLUXM_CONTROL
C     end retired parameters

#ifdef ALLOW_TANGENTLINEAR_RUN
        yadprefix           = 'g_'
        yadmark             = 'g_'
#else
        yadprefix           = 'ad'
        yadmark             = 'ad'
#endif
        yctrlid             = 'MIT_CE_000'
        yctrlposunpack      = '.opt'
        yctrlpospack        = '.opt'
        ctrlname            = 'ecco_ctrl'
        costname            = 'ecco_cost'
        scalname            = ' '
        maskname            = ' '
        metaname            = ' '

C--     Next, read the cost data file.
        WRITE(msgBuf,'(A)') 'CTRL_READPARMS: opening data.ctrl'
        CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT , 1)

        CALL OPEN_COPY_DATA_FILE(
     I                          'data.ctrl', 'CTRL_READPARMS',
     O                          iUnit,
     I                          myThid )

        READ(unit = iUnit, nml = ctrl_nml)
        READ(unit = iUnit, nml = ctrl_packnames)
#ifdef ALLOW_GENARR_CONTROL
        READ(unit = iUnit, nml = ctrl_nml_genarr)
#endif

        WRITE(msgBuf,'(A)')
     &       'CTRL_READPARMS: finished reading data.ctrl'
        CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                  SQUEEZE_RIGHT , 1)

#ifdef SINGLE_DISK_IO
        CLOSE(iUnit)
#else
        CLOSE(iUnit,STATUS='DELETE')
#endif /* SINGLE_DISK_IO */

C--   Set defaults for backwards compatibility
        mult_default = 0. _d 0
        IF ( useECCO ) mult_default = 1. _d 0
#ifdef ALLOW_GENARR2D_CONTROL
        DO iarr = 1, maxCtrlArr2D
         IF ( mult_genarr2d(iarr) .EQ. UNSET_RL )
     &        mult_genarr2d(iarr) = mult_default
        ENDDO
#endif
#ifdef ALLOW_GENARR3D_CONTROL
        DO iarr = 1, maxCtrlArr3D
         IF ( mult_genarr3d(iarr) .EQ. UNSET_RL )
     &        mult_genarr3d(iarr) = mult_default
        ENDDO
#endif
#ifdef ALLOW_GENTIM2D_CONTROL
        DO iarr = 1, maxCtrlTim2D
         IF ( mult_gentim2d(iarr) .EQ. UNSET_RL )
     &        mult_gentim2d(iarr) = mult_default
        ENDDO
#endif

C--   if all multipliers are zero, we do not need to calculate the cost
C     function contribution of the ctrl-variables (no Tikhonov
C     regularisation)
        useCtrlCostContribution = .FALSE.
        useObcsCostContribution = .FALSE.
#ifdef ALLOW_COST
# ifdef ALLOW_GENARR2D_CONTROL
        DO iarr = 1, maxCtrlArr2D
         useCtrlCostContribution = useCtrlCostContribution
     &        .OR. mult_genarr2d(iarr) .GT. 0. _d 0
        ENDDO
# endif
# ifdef ALLOW_GENARR3D_CONTROL
        DO iarr = 1, maxCtrlArr3D
         useCtrlCostContribution = useCtrlCostContribution
     &        .OR. mult_genarr3d(iarr) .GT. 0. _d 0
        ENDDO
# endif
# ifdef ALLOW_GENTIM2D_CONTROL
        DO iarr = 1, maxCtrlTim2D
         useCtrlCostContribution = useCtrlCostContribution
     &        .OR. mult_gentim2d(iarr) .GT. 0. _d 0
        ENDDO
# endif
# ifdef ALLOW_OBCS
        IF ( mult_obcsN .GT. 0. _d 0 .OR. mult_obcsS .GT. 0. _d 0 .OR.
     &       mult_obcsE .GT. 0. _d 0 .OR. mult_obcsW .GT. 0. _d 0 .OR.
     &       mult_obcsvol.GT.0. _d 0 .OR. mult_ageos .GT. 0. _d 0 )
     &       useObcsCostContribution = .TRUE.
# endif
#endif

C-- Create ctrlDir if necessary
      IF ( ctrlDir .NE. ' ' ) THEN
       IL = ILNBLNK( ctrlDir )
C      append "/", if necessary
       IF ( IL.LT.MAX_LEN_FNAM .AND. ctrlDir(IL:IL).NE.'/' ) THEN
        namBuf(1:IL) = ctrlDir(1:IL)
        WRITE(ctrlDir(1:IL+1),'(2A)') namBuf(1:IL),'/'
       ENDIF
#ifdef HAVE_SYSTEM
C      create directory
       IL = ILNBLNK( ctrlDir ) -1
       WRITE(namBuf,'(2A)') ' mkdir -p ', ctrlDir(1:IL)
       pIL = 1 + ILNBLNK( namBuf )
       WRITE(standardMessageUnit,'(3A)')
     &  '==> SYSTEM CALL (from CTRL_READPARMS): >',
     &                                 namBuf(1:pIL), '<'
       CALL SYSTEM( namBuf(1:pIL) )
#else
       WRITE(msgBuf,'(2A)') '** WARNING ** CTRL_READPARMS: ',
     &       'cannot call mkdir -> please create ctrlDir manually'
       CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                     SQUEEZE_RIGHT, myThid )
#endif
      ENDIF

      IF (ctrlDir .NE. ' ') THEN
       WRITE(msgBuf,'(2A)')
     & 'read-write ctrl files from ', ctrlDir(1:IL)
      ELSE
       WRITE(msgBuf,'(A)')
     & 'read-write ctrl files from current run directory'
      ENDIF
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )

C-- Check retired parameters
      nRetired = 0
      IF ( ctrlSmoothCorrel2D ) THEN
       WRITE(msgBuf,'(2A)') 'S/R CTRL_READPARMS: ',
     &  'ctrlSmoothCorrel2D no longer allowed in file "data.ctrl"'
       CALL PRINT_ERROR( msgBuf, myThid )
#ifdef ALLOW_SMOOTH_CORREL2D
       WRITE(msgBuf,'(2A)') 'S/R CTRL_READPARMS: ',
     &  ' nor is ALLOW_SMOOTH_CORREL2D allowed to be defined.'
       CALL PRINT_ERROR( msgBuf, myThid )
#endif
       WRITE(msgBuf,'(A)')
     &  'S/R CTRL_READPARMS: Please use the smooth-pkg instead'
       CALL PRINT_ERROR( msgBuf, myThid )
       nRetired = nRetired + 1
      ENDIF
      IF ( ctrlSmoothCorrel3D ) THEN
       WRITE(msgBuf,'(2A)') 'S/R CTRL_READPARMS: ',
     &  'ctrlSmoothCorrel3D no longer allowed in file "data.ctrl"'
       CALL PRINT_ERROR( msgBuf, myThid )
#ifdef ALLOW_SMOOTH_CORREL3D
       WRITE(msgBuf,'(2A)') 'S/R CTRL_READPARMS: ',
     &  ' nor is ALLOW_SMOOTH_CORREL3D allowed to be defined.'
       CALL PRINT_ERROR( msgBuf, myThid )
#endif
       WRITE(msgBuf,'(A)')
     &  'S/R CTRL_READPARMS: Please use the smooth-pkg instead'
       CALL PRINT_ERROR( msgBuf, myThid )
       nRetired = nRetired + 1
      ENDIF
      IF ( .NOT. ctrlUseGen ) THEN
       WRITE(msgBuf,'(A,A)')
     &  'S/R CTRL_READPARMS: ctrlUseGen',
     &  ' is no longer allowed in file "data.ctrl"'
       CALL PRINT_ERROR( msgBuf, myThid )
       nRetired = nRetired + 1
      ENDIF
      CALL CTRL_CHECK_RETIRED_PARMS( 'xx_hflux',
     I     xx_hfluxstartdate1, xx_hfluxstartdate2,
     I     xx_hfluxperiod, xx_hflux_file, ' ',
     I     xx_hflux_remo_intercept, xx_hflux_remo_slope,
     U     nRetired,
     I     myThid )
      CALL CTRL_CHECK_RETIRED_PARMS( 'xx_sflux',
     I     xx_sfluxstartdate1, xx_sfluxstartdate2,
     I     xx_sfluxperiod, xx_sflux_file, ' ',
     I     xx_sflux_remo_intercept,xx_sflux_remo_slope,
     U     nRetired,
     I     myThid )
      CALL CTRL_CHECK_RETIRED_PARMS( 'xx_tauu',
     I     xx_tauustartdate1, xx_tauustartdate2,
     I     xx_tauuperiod, xx_tauu_file, ' ',
     I     xx_tauu_remo_intercept, xx_tauu_remo_slope,
     U     nRetired,
     I     myThid )
      CALL CTRL_CHECK_RETIRED_PARMS( 'xx_tauv',
     I     xx_tauvstartdate1,xx_tauvstartdate2,
     I     xx_tauvperiod, xx_tauv_file, ' ',
     I     xx_tauv_remo_intercept, xx_tauv_remo_slope,
     U     nRetired,
     I     myThid )
      CALL CTRL_CHECK_RETIRED_PARMS( 'xx_atemp',
     I     xx_atempstartdate1, xx_atempstartdate2,
     I     xx_atempperiod, xx_atemp_file, xx_atemp_mean_file,
     I     xx_atemp_remo_intercept, xx_atemp_remo_slope,
     U     nRetired,
     I     myThid )
      CALL CTRL_CHECK_RETIRED_PARMS( 'xx_aqh',
     I     xx_aqhstartdate1, xx_aqhstartdate2,
     I     xx_aqhperiod, xx_aqh_file, xx_aqh_mean_file,
     I     xx_aqh_remo_intercept, xx_aqh_remo_slope,
     U     nRetired,
     I     myThid )
      CALL CTRL_CHECK_RETIRED_PARMS( 'xx_precip',
     I     xx_precipstartdate1, xx_precipstartdate2,
     I     xx_precipperiod, xx_precip_file, xx_precip_mean_file,
     I     xx_precip_remo_intercept, xx_precip_remo_slope,
     U     nRetired,
     I     myThid )
      CALL CTRL_CHECK_RETIRED_PARMS( 'xx_sflux',
     I     xx_sfluxstartdate1, xx_sfluxstartdate2,
     I     xx_sfluxperiod, xx_sflux_file, ' ',
     I     xx_sflux_remo_intercept,xx_sflux_remo_slope,
     U     nRetired,
     I     myThid )
      CALL CTRL_CHECK_RETIRED_PARMS('xx_swdown',
     I     xx_swdownstartdate1, xx_swdownstartdate2,
     I     xx_swdownperiod, xx_swdown_file, xx_swdown_mean_file,
     I     xx_swdown_remo_intercept, xx_swdown_remo_slope,
     U     nRetired,
     I     myThid )
      CALL CTRL_CHECK_RETIRED_PARMS('xx_lwflux',
     I     xx_lwfluxstartdate1, xx_lwfluxstartdate2,
     I     xx_lwfluxperiod, xx_lwflux_file, ' ',
     I     xx_lwflux_remo_intercept, xx_lwflux_remo_slope,
     U     nRetired,
     I     myThid )
      CALL CTRL_CHECK_RETIRED_PARMS('xx_lwdown',
     I     xx_lwdownstartdate1, xx_lwdownstartdate2,
     I     xx_lwdownperiod, xx_lwdown_file, ' ',
     I     xx_lwdown_remo_intercept, xx_lwdown_remo_slope,
     U     nRetired,
     I     myThid )
      CALL CTRL_CHECK_RETIRED_PARMS( 'xx_evap',
     I     xx_evapstartdate1, xx_evapstartdate2,
     I     xx_evapperiod, xx_evap_file, ' ',
     I     xx_evap_remo_intercept, xx_evap_remo_slope,
     U     nRetired,
     I     myThid )
      CALL CTRL_CHECK_RETIRED_PARMS( 'xx_snowprecip',
     I     xx_snowprecipstartdate1, xx_snowprecipstartdate2,
     I     xx_snowprecipperiod, xx_snowprecip_file, ' ',
     I     xx_snowprecip_remo_intercept, xx_snowprecip_remo_slope,
     U     nRetired,
     I     myThid )
      CALL CTRL_CHECK_RETIRED_PARMS( 'xx_apressure',
     I     xx_apressurestartdate1, xx_apressurestartdate2,
     I     xx_apressureperiod, xx_apressure_file, ' ',
     I     xx_apressure_remo_intercept, xx_apressure_remo_slope,
     U     nRetired,
     I     myThid )
      CALL CTRL_CHECK_RETIRED_PARMS( 'xx_runoff',
     I     xx_runoffstartdate1, xx_runoffstartdate2,
     I     xx_runoffperiod, xx_runoff_file, ' ',
     I     xx_runoff_remo_intercept, xx_runoff_remo_slope,
     U     nRetired,
     I     myThid )
      CALL CTRL_CHECK_RETIRED_PARMS( 'xx_uwind',
     I     xx_uwindstartdate1, xx_uwindstartdate2,
     I     xx_uwindperiod, xx_uwind_file, ' ',
     I     xx_uwind_remo_intercept,xx_uwind_remo_slope,
     U     nRetired,
     I     myThid )
      CALL CTRL_CHECK_RETIRED_PARMS( 'xx_vwind',
     I     xx_vwindstartdate1, xx_vwindstartdate2,
     I     xx_vwindperiod, xx_vwind_file, ' ',
     I     xx_vwind_remo_intercept,xx_vwind_remo_slope,
     U     nRetired,
     I     myThid )
      CALL CTRL_CHECK_RETIRED_PARMS( 'xx_sst',
     I     xx_sststartdate1, xx_sststartdate2,
     I     xx_sstperiod, xx_sst_file, ' ',
     I     xx_sst_remo_intercept, xx_sst_remo_slope,
     U     nRetired,
     I     myThid )
      CALL CTRL_CHECK_RETIRED_PARMS( 'xx_sss',
     I     xx_sssstartdate1, xx_sssstartdate2,
     I     xx_sssperiod, xx_sss_file, ' ',
     I     xx_sss_remo_intercept, xx_sss_remo_slope,
     U     nRetired,
     I     myThid )
      CALL CTRL_CHECK_RETIRED_PARMS( 'xx_shifwflx',
     I     xx_shifwflxstartdate1, xx_shifwflxstartdate2,
     I     xx_shifwflxperiod, xx_shifwflx_file, ' ',
     I     xx_shifwflx_remo_intercept, xx_shifwflx_remo_slope,
     U     nRetired,
     I     myThid )
      CALL CTRL_CHECK_RETIRED_PARMS( 'xx_diffkr_file',
     I     UNSET_I, UNSET_I, UNSET_RL, xx_diffkr_file, ' ',
     I     UNSET_RL, UNSET_RL,
     U     nRetired,
     I     myThid )
      CALL CTRL_CHECK_RETIRED_PARMS( 'xx_kapgm_file',
     I     UNSET_I, UNSET_I, UNSET_RL, xx_kapgm_file, ' ',
     I     UNSET_RL, UNSET_RL,
     U     nRetired,
     I     myThid )
      CALL CTRL_CHECK_RETIRED_PARMS( 'xx_kapredi_file',
     I     UNSET_I, UNSET_I, UNSET_RL, xx_kapredi_file, ' ',
     I     UNSET_RL, UNSET_RL,
     U     nRetired,
     I     myThid )
      CALL CTRL_CHECK_RETIRED_PARMS( 'xx_tr1_file',
     I     UNSET_I, UNSET_I, UNSET_RL, xx_tr1_file, ' ',
     I     UNSET_RL, UNSET_RL,
     U     nRetired,
     I     myThid )
      CALL CTRL_CHECK_RETIRED_PARMS( 'xx_depth_file',
     I     UNSET_I, UNSET_I, UNSET_RL, xx_depth_file, ' ',
     I     UNSET_RL, UNSET_RL,
     U     nRetired,
     I     myThid )
      CALL CTRL_CHECK_RETIRED_PARMS( 'xx_efluxy_file',
     I     UNSET_I, UNSET_I, UNSET_RL, xx_efluxy_file, ' ',
     I     UNSET_RL, UNSET_RL,
     U     nRetired,
     I     myThid )
      CALL CTRL_CHECK_RETIRED_PARMS( 'xx_efluxp_file',
     I     UNSET_I, UNSET_I, UNSET_RL, xx_efluxp_file, ' ',
     I     UNSET_RL, UNSET_RL,
     U     nRetired,
     I     myThid )
      CALL CTRL_CHECK_RETIRED_PARMS( 'xx_bottomdrag_file',
     I     UNSET_I, UNSET_I, UNSET_RL, xx_bottomdrag_file, ' ',
     I     UNSET_RL, UNSET_RL,
     U     nRetired,
     I     myThid )
      CALL CTRL_CHECK_RETIRED_PARMS( 'xx_edtaux_file',
     I     UNSET_I, UNSET_I, UNSET_RL, xx_edtaux_file, ' ',
     I     UNSET_RL, UNSET_RL,
     U     nRetired,
     I     myThid )
      CALL CTRL_CHECK_RETIRED_PARMS( 'xx_edtauy_file',
     I     UNSET_I, UNSET_I, UNSET_RL, xx_edtauy_file, ' ',
     I     UNSET_RL, UNSET_RL,
     U     nRetired,
     I     myThid )
      CALL CTRL_CHECK_RETIRED_PARMS( 'xx_uvel_file',
     I     UNSET_I, UNSET_I, UNSET_RL, xx_uvel_file, ' ',
     I     UNSET_RL, UNSET_RL,
     U     nRetired,
     I     myThid )
      CALL CTRL_CHECK_RETIRED_PARMS( 'xx_vvel_file',
     I     UNSET_I, UNSET_I, UNSET_RL, xx_vvel_file, ' ',
     I     UNSET_RL, UNSET_RL,
     U     nRetired,
     I     myThid )
      CALL CTRL_CHECK_RETIRED_PARMS( 'xx_etan_file',
     I     UNSET_I, UNSET_I, UNSET_RL, xx_etan_file, ' ',
     I     UNSET_RL, UNSET_RL,
     U     nRetired,
     I     myThid )
      CALL CTRL_CHECK_RETIRED_PARMS( 'xx_hfluxm_file',
     I     UNSET_I, UNSET_I, UNSET_RL, xx_hfluxm_file, ' ',
     I     UNSET_RL, UNSET_RL,
     U     nRetired,
     I     myThid )

      IF ( nRetired .GT. 0 ) THEN
       WRITE(msgBuf,'(2A)') 'S/R CTRL_READPARMS: ',
     &  'Error reading parameter file "data.ctrl"'
       CALL PRINT_ERROR( msgBuf, myThid )
       WRITE(msgBuf,'(A,I3,A)') 'S/R CTRL_READPARMS: ', nRetired,
     &      ' out of date parameters were found in namelist CTRL_NML'
       CALL PRINT_ERROR( msgBuf, myThid )
       CALL ALL_PROC_DIE( 0 )
       STOP 'ABNORMAL END: S/R CTRL_READPARMS'
      ENDIF

      _END_MASTER( myThid )

      _BARRIER

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: CTRL_SET_RETIRED_PARMS
C     !INTERFACE:
      SUBROUTINE CTRL_SET_RETIRED_PARMS(
     I     xx_startdate1,
     I     xx_startdate2,
     I     xx_period,
     I     xx_file,
     I     xx_mean_file,
     I     xx_remo_intercept,
     I     xx_remo_slope,
     I     myThid )

C     !DESCRIPTION:
C     ==================================================================
C     o set some retired parameters
C     ==================================================================

C     !USES:
      IMPLICIT NONE
C     == global variables ==
#include "EEPARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
      INTEGER xx_startdate1, xx_startdate2
      _RL xx_period
      CHARACTER*(*) xx_file, xx_mean_file
      _RL xx_remo_intercept, xx_remo_slope
      INTEGER myThid

C     !LOCAL VARIABLES:
CEOP
      xx_startdate1 = UNSET_I
      xx_startdate2 = UNSET_I
      xx_period     = UNSET_RL
      xx_remo_intercept = UNSET_RL
      xx_remo_slope = UNSET_RL
      xx_file = ' '
      xx_mean_file = ' '

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: CTRL_CHECK_RETIRED_PARMS
C     !INTERFACE:
      SUBROUTINE CTRL_CHECK_RETIRED_PARMS(
     I     xx_name,
     I     xx_startdate1,
     I     xx_startdate2,
     I     xx_period,
     I     xx_file,
     I     xx_mean_file,
     I     xx_remo_intercept,
     I     xx_remo_slope,
     U     nRetired,
     I     myThid )

C     !DESCRIPTION:
C     ==================================================================
C     o check some retired parameter values
C     ==================================================================

C     !USES:
      IMPLICIT NONE
C     == global variables ==
#include "EEPARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
      CHARACTER*(*) xx_name
      INTEGER xx_startdate1, xx_startdate2
      _RL xx_period
      CHARACTER*(*) xx_file, xx_mean_file
      _RL xx_remo_intercept, xx_remo_slope
      INTEGER nRetired
      INTEGER myThid

C     !FUNCTIONS:
      INTEGER  ILNBLNK
      EXTERNAL ILNBLNK

C     !LOCAL VARIABLES:
      INTEGER il
      CHARACTER*(MAX_LEN_MBUF) msgBuf
CEOP

      IF (      xx_startdate1 .NE. UNSET_I
     &     .OR. xx_startdate2 .NE. UNSET_I
     &     .OR. xx_period .NE. UNSET_RL
     &     .OR. xx_remo_intercept .NE. UNSET_RL
     &     .OR. xx_remo_slope .NE. UNSET_RL
     &     .OR. xx_file .NE. ' '
     &     .OR. xx_mean_file .NE. ' ' ) THEN
       il = ILNBLNK(xx_name)
       WRITE(msgBuf,'(A,A,A)')
     &  'S/R CTRL_READPARMS: ', xx_name(1:il),
     &  '* is no longer allowed in file "data.ctrl"'
       CALL PRINT_ERROR( msgBuf, myThid )
       WRITE(msgBuf,'(A)')
     &  'S/R CTRL_READPARMS: use generic controls instead'
       CALL PRINT_ERROR( msgBuf, myThid )
       nRetired = nRetired + 1
      ENDIF

      RETURN
      END

#include "ATM_COMMON_OPTIONS.h"

C !INTERFACE: ==========================================================
      SUBROUTINE ATM_DIAGNOSTICS_INIT(myThid )

C !DESCRIPTION:
C define diagnostics for atmosheric physics packages

C !USES: ===============================================================
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"

C !INPUT PARAMETERS: ===================================================
C  myThid               :: thread number
      INTEGER myThid
CEOP

#ifdef ALLOW_ATM_COMMON
#ifdef ALLOW_DIAGNOSTICS

C     !LOCAL VARIABLES:
c     INTEGER       diagNum
c     INTEGER       diagMate
c     CHARACTER*8   diagName
c     CHARACTER*16  diagCode
c     CHARACTER*16  diagUnits
c     CHARACTER*(80) diagTitle

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C     Define diagnostics Names :

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#endif /* ALLOW_DIAGNOSTICS */
#endif /* ALLOW_ATM_COMMON */

      RETURN
      END

#include "AUTODIFF_OPTIONS.h"

C     ==================================================================
C
C     adread_adwrite_i.F: routines to handle the I/O of the TAF
C                         code for integer fields. All files are direct
C                         generated code or integer fields. All files
C                         are direct access files.
C     Routines:
C     o  ADREAD_I  - Read  INT data from file.
C     o  ADWRITE_I - Write INT data to   file.
C
C     see adread_adwrite.F for more explanation.
C
C     The following input variables are used throughout in the argument
C     lists:
C
C     name   -  character
C                 On entry, name is the extended tape name.
C     len    -  integer
C                 On entry, len is the number of characters in name.
C     tid    -  integer
C                 On entry, tid identifies the tape.
C     vid    -  integer
C                 On entry, vid identifies the variable to be stored on
C                 the tape.
C     var    -  real array of dimension length
C                 On entry, var contains the values to be stored.
C                           var must not be changed.
C     size   -  integer
C                 On entry, size is the size in bytes of the type of
C                           variable var.
C     length -  integer
C                 On entry, length is the dimension of the variable
C                           stored on the tape.
C     irec   -  integer
C                 On entry, irec is the record number to be written.
C     myThid -  integer
C                 On entry, myThid is the number of the thread or
C                           instance of the program.
C
C     TAF does not provide the leading argument myThid when compiling
C     the MITgcmUV code. Instead there is a sed script available that
C     changes the TAF-generated adjoint code.
C
C     Only the master thread is allowed to write data and only gobal
C     model arrays are allowed to be written be the subsequent routines.
C     Tiled data are to be stored in common blocks. This implies that at
C     least a two level checkpointing for the adjoint code has to be
C     available.
C
C     ==================================================================

CBOP
C     !ROUTINE: ADREAD_I
C     !INTERFACE:
      SUBROUTINE ADREAD_I(
     I                   myThid,
     I                   name,
     I                   len,
     I                   tid,
     I                   vid,
     O                   ivar,
     I                   size,
     I                   length,
     I                   irec )

C     !DESCRIPTION: \bv
C     ==================================================================
C     SUBROUTINE ADREAD_I
C     ==================================================================
C     o read from direct access file, INTEGER version.
C     The strategy is to read an real*8 field with ADREAD resl*8 version
C     and convert to INTEGER
C     ==================================================================
C     SUBROUTINE ADREAD_I
C     ==================================================================
C     \ev

C     !USES:
      IMPLICIT NONE

C     == global variables ==
#include "EEPARAMS.h"
#include "SIZE.h"

C     !INPUT/OUTPUT PARAMETERS:
C     myThid :: number of the thread or instance of the program.
C     name   :: extended tape name.
C     len    :: number of characters in name.
C     tid    :: tape identifier.
C     vid    :: identifies the variable to be stored on tape.
C     ivar   :: values to be stored.
C     size   :: size in bytes of the type of variable var.
C     length :: dimension of the variable stored on the tape.
C     irec   :: record number to be written.
      INTEGER myThid
      CHARACTER*(*) name
      INTEGER len
      INTEGER tid
      INTEGER vid
      INTEGER ivar(*)
      INTEGER size
      INTEGER length
      INTEGER irec

C     !LOCAL VARIABLES:
      INTEGER k, lsize, length2d
C     2D fields only
      PARAMETER ( length2d = (sNx+2*OLx)*(sNy+2*OLy)*nSx*nSy )
      real*8  var(length2d)
      CHARACTER*(MAX_LEN_MBUF) msgBuf
CEOP

#ifdef ALLOW_DEBUG
      IF ( debugMode ) CALL DEBUG_ENTER('ADREAD_I',myThid)
#endif

      IF ( length .GT. length2d ) THEN
       WRITE(msgBuf,'(A,I9,A,I9)')
     &      'ADREAD_I: length = ', length,' > length2d = ', length2d
       CALL PRINT_ERROR( msgBuf, myThid )
       CALL ALL_PROC_DIE( myThid )
       STOP 'ABNORMAL END: S/R ADREAD_I'
      ENDIF
      lsize = 8
      CALL ADREAD(
     I            myThid,
     I            name,
     I            len,
     I            tid,
     I            vid,
     O            var,
     I            lsize,
     I            length,
     I            irec )

      DO k = 1,length
       ivar(k) = NINT(var(k))
      ENDDO

#ifdef ALLOW_DEBUG
      IF ( debugMode ) CALL DEBUG_LEAVE('ADREAD_I',myThid)
#endif

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: ADWRITE_I
C     !INTERFACE:
      SUBROUTINE ADWRITE_I(
     I                    myThid,
     I                    name,
     I                    len,
     I                    tid,
     I                    vid,
     I                    ivar,
     I                    size,
     I                    length,
     I                    irec )

C     !DESCRIPTION: \bv
C     ==================================================================
C     SUBROUTINE ADWRITE_I
C     ==================================================================
C     o Write to direct access file, INTEGER version.
C     The strategy is to convert field to real*8 and use the
C     ADWRITE real*8 version.
C     ==================================================================
C     SUBROUTINE ADWRITE_I
C     ==================================================================
C     \ev

C     !USES:
      IMPLICIT NONE

C     == global variables ==
#include "EEPARAMS.h"
#include "SIZE.h"

C     !INPUT/OUTPUT PARAMETERS:
C     myThid :: number of the thread or instance of the program.
C     name   :: extended tape name.
C     len    :: number of characters in name.
C     tid    :: tape identifier.
C     vid    :: identifies the variable to be stored on tape.
C     ivar   :: values to be stored.
C     size   :: size in bytes of the type of variable var.
C     length :: dimension of the variable stored on the tape.
C     irec   :: record number to be written.
      INTEGER myThid
      CHARACTER*(*) name
      INTEGER len
      INTEGER tid
      INTEGER vid
      INTEGER ivar(*)
      INTEGER size
      INTEGER length
      INTEGER irec

C     !LOCAL VARIABLES:
      INTEGER k, lsize, length2d
      PARAMETER ( length2d = (sNx+2*OLx)*(sNy+2*OLy)*nSx*nSy )
      real*8  var(length2d)
      CHARACTER*(MAX_LEN_MBUF) msgBuf
CEOP

#ifdef ALLOW_DEBUG
      IF ( debugMode ) CALL DEBUG_ENTER('ADWRITE_I',myThid)
#endif

      IF ( length .GT. length2d ) THEN
       WRITE(msgBuf,'(A,I9,A,I9)')
     &      'ADWRITE_I: length = ',length,' > length2d = ',length2d
       CALL PRINT_ERROR( msgBuf, myThid )
       CALL ALL_PROC_DIE( myThid )
       STOP 'ABNORMAL END: S/R ADWRITE_I'
      ENDIF

      DO k = 1,length
C     no automatic conversion
c      var(k) = DFLOAT(ivar(k))
C     let compiler do the type conversion
       var(k) = ivar(k)
      ENDDO

      lsize = 8
      CALL ADWRITE(
     I             myThid,
     I             name,
     I             len,
     I             tid,
     I             vid,
     I             var,
     I             lsize,
     I             length,
     I             irec )

#ifdef ALLOW_DEBUG
      IF ( debugMode ) CALL DEBUG_LEAVE('ADWRITE_I',myThid)
#endif

      RETURN
      END

#include "OBCS_OPTIONS.h"

CBOP
C     !ROUTINE: OBCS_APPLY_UV
C     !INTERFACE:
      SUBROUTINE OBCS_APPLY_UV( bi, bj, kArg,
     U                          uFld, vFld,
     I                          myThid )

C     !DESCRIPTION:
C     *==========================================================*
C     | S/R OBCS_APPLY_UV
C     *==========================================================*

C     !USES:
      IMPLICIT NONE
C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "OBCS_PARAMS.h"
#include "OBCS_GRID.h"
#include "OBCS_FIELDS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine Arguments ==
C    bi, bj   :: indices of current tile
C    kArg     :: index of current level which OBC applies to
C                or, if zero, apply to all levels
C    uFld     :: horizontal velocity field, 1rst component (zonal)
C    vFld     :: horizontal velocity field, 2nd  component (meridional)
C    myThid   :: my Thread Id number
c     INTEGER biArg, bjArg
      INTEGER bi, bj
      INTEGER kArg
      _RL uFld(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      _RL vFld(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      INTEGER myThid
CEOP

#ifdef ALLOW_OBCS

C     !LOCAL VARIABLES:
C     == Local variables ==
c     INTEGER bi, bj, itLo, itHi, jtLo, jtHi
      INTEGER k, kLo, kHi
#if (defined ALLOW_OBCS_EAST ) || (defined ALLOW_OBCS_WEST )
      INTEGER j, Iobc
#endif
#if (defined ALLOW_OBCS_NORTH) || (defined ALLOW_OBCS_SOUTH)
      INTEGER i, Jobc
#endif

C--   Set model variables to OB values on North/South Boundaries:
C     2 steps: 1) set tangential component ; 2) set normal component.
C     This ensures that the normal component is set correctly even
C     when it conficts with tangential setting from an other OB.

c     IF ( biArg.EQ.0 .OR. bjArg.EQ.0 ) THEN
c       itLo = myBxLo(myThid)
c       itHi = myBxHi(myThid)
c       jtLo = myByLo(myThid)
c       jtHi = myByHi(myThid)
c     ELSE
c       itLo = biArg
c       itHi = biArg
c       jtLo = bjArg
c       jtHi = bjArg
c     ENDIF
      IF ( kArg.EQ.0 ) THEN
        kLo = 1
        kHi = Nr
      ELSE
        kLo = kArg
        kHi = kArg
      ENDIF

c     DO bj = jtLo,jtHi
c      DO bi = itLo,itHi

C--   Set Tangential component first:

#ifdef ALLOW_OBCS_NORTH
        IF ( tileHasOBN(bi,bj) ) THEN
C Northern boundary
         DO i=1-OLx,sNx+OLx
          Jobc = OB_Jn(i,bi,bj)
          IF ( Jobc.NE.OB_indexNone ) THEN
           DO k = kLo,kHi
             uFld(i,Jobc,k,bi,bj) = OBNu(i,k,bi,bj)
     &                            *_maskW(i,Jobc,k,bi,bj)
           ENDDO
          ENDIF
         ENDDO
        ENDIF
#endif
#ifdef ALLOW_OBCS_SOUTH
        IF ( tileHasOBS(bi,bj) ) THEN
C Southern boundary
         DO i=1-OLx,sNx+OLx
          Jobc = OB_Js(i,bi,bj)
          IF ( Jobc.NE.OB_indexNone ) THEN
           DO k = kLo,kHi
             uFld(i,Jobc,k,bi,bj) = OBSu(i,k,bi,bj)
     &                            *_maskW(i,Jobc,k,bi,bj)
           ENDDO
          ENDIF
         ENDDO
        ENDIF
#endif

C     Set model variables to OB values on East/West Boundaries
#ifdef ALLOW_OBCS_EAST
        IF ( tileHasOBE(bi,bj) ) THEN
C Eastern boundary
         DO j=1-OLy,sNy+OLy
          Iobc = OB_Ie(j,bi,bj)
          IF ( Iobc.NE.OB_indexNone ) THEN
           DO k = kLo,kHi
             vFld(Iobc,j,k,bi,bj) = OBEv(j,k,bi,bj)
     &                            *_maskS(Iobc,j,k,bi,bj)
           ENDDO
          ENDIF
         ENDDO
        ENDIF
#endif
#ifdef ALLOW_OBCS_WEST
        IF ( tileHasOBW(bi,bj) ) THEN
C Western boundary
         DO j=1-OLy,sNy+OLy
          Iobc = OB_Iw(j,bi,bj)
          IF ( Iobc.NE.OB_indexNone ) THEN
           DO k = kLo,kHi
             vFld(Iobc,j,k,bi,bj) = OBWv(j,k,bi,bj)
     &                            *_maskS(Iobc,j,k,bi,bj)
           ENDDO
          ENDIF
         ENDDO
        ENDIF
#endif

C--   Then set Normal component:

#ifdef ALLOW_OBCS_NORTH
        IF ( tileHasOBN(bi,bj) ) THEN
C Northern boundary
         DO i=1-OLx,sNx+OLx
          Jobc = OB_Jn(i,bi,bj)
          IF ( Jobc.NE.OB_indexNone ) THEN
           DO k = kLo,kHi
             vFld(i,Jobc,k,bi,bj)   = OBNv(i,k,bi,bj)
     &                              *_maskS(i,Jobc,k,bi,bj)
             vFld(i,Jobc+1,k,bi,bj) = OBNv(i,k,bi,bj)
     &                              *_maskS(i,Jobc,k,bi,bj)
     &                              *OBCS_uvApplyFac
           ENDDO
          ENDIF
         ENDDO
        ENDIF
#endif
#ifdef ALLOW_OBCS_SOUTH
        IF ( tileHasOBS(bi,bj) ) THEN
C Southern boundary
         DO i=1-OLx,sNx+OLx
          Jobc = OB_Js(i,bi,bj)
          IF ( Jobc.NE.OB_indexNone ) THEN
           DO k = kLo,kHi
             vFld(i,Jobc+1,k,bi,bj) = OBSv(i,k,bi,bj)
     &                              *_maskS(i,Jobc+1,k,bi,bj)
             vFld(i,Jobc,k,bi,bj)   = OBSv(i,k,bi,bj)
     &                              *_maskS(i,Jobc+1,k,bi,bj)
     &                              *OBCS_uvApplyFac
           ENDDO
          ENDIF
         ENDDO
        ENDIF
#endif

C     Set model variables to OB values on East/West Boundaries
#ifdef ALLOW_OBCS_EAST
        IF ( tileHasOBE(bi,bj) ) THEN
C Eastern boundary
         DO j=1-OLy,sNy+OLy
          Iobc = OB_Ie(j,bi,bj)
          IF ( Iobc.NE.OB_indexNone ) THEN
           DO k = kLo,kHi
             uFld(Iobc,j,k,bi,bj)   = OBEu(j,k,bi,bj)
     &                              *_maskW(Iobc,j,k,bi,bj)
             uFld(Iobc+1,j,k,bi,bj) = OBEu(j,k,bi,bj)
     &                              *_maskW(Iobc,j,k,bi,bj)
     &                              *OBCS_uvApplyFac
           ENDDO
          ENDIF
         ENDDO
        ENDIF
#endif
#ifdef ALLOW_OBCS_WEST
        IF ( tileHasOBW(bi,bj) ) THEN
C Western boundary
         DO j=1-OLy,sNy+OLy
          Iobc = OB_Iw(j,bi,bj)
          IF ( Iobc.NE.OB_indexNone ) THEN
           DO k = kLo,kHi
             uFld(Iobc+1,j,k,bi,bj) = OBWu(j,k,bi,bj)
     &                              *_maskW(Iobc+1,j,k,bi,bj)
             uFld(Iobc,j,k,bi,bj)   = OBWu(j,k,bi,bj)
     &                              *_maskW(Iobc+1,j,k,bi,bj)
     &                              *OBCS_uvApplyFac
           ENDDO
          ENDIF
         ENDDO
        ENDIF
#endif

c      ENDDO
c     ENDDO

#endif /* ALLOW_OBCS */

      RETURN
      END

#include "STREAMICE_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

CBOP
      SUBROUTINE STREAMICE_DRIVING_STRESS_FD( myThid )
c      O taudx,
c      O taudy )

C     /============================================================\
C     | SUBROUTINE                                                 |
C     | o                                                          |
C     |============================================================|
C     |                                                            |
C     \============================================================/
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "STREAMICE.h"
#include "STREAMICE_CG.h"

C     !INPUT/OUTPUT ARGUMENTS
      INTEGER myThid
c       _RL taudx (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
c       _RL taudx (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)

#ifdef ALLOW_STREAMICE

C     LOCAL VARIABLES
      INTEGER i, j, bi, bj
c     INTEGER Gi, Gj
      _RL dsdx
     & (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL dsdy
     & (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL face_factor, grd_below_sl, i_rhow

      i_rhow = 1./streamice_density_ocean_avg

      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
        DO j=1-OLy+1,sNy+OLy-1
         DO i=1-OLx+1,sNx+OLx-1
          taudx_SI(i,j,bi,bj) = 0. _d 0
          taudy_SI(i,j,bi,bj) = 0. _d 0
         ENDDO
        ENDDO
       ENDDO
      ENDDO

      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
        DO j=1,sNy
         DO i=1,sNx

          IF (streamice_hmask(i,j,bi,bj) .eq. 1) THEN

c    ds/dx ------------------------------------------------

           IF (streamice_hmask(i-1,j,bi,bj) .eq. 1) THEN

            dsdx(i,j,bi,bj) = recip_dxC(i,j,bi,bj) *
     &       (surf_el_streamice(i,j,bi,bj) -
     &        surf_el_streamice(i-1,j,bi,bj))

           ELSEIF (streamice_hmask(i-1,j,bi,bj).eq.0.or.
     &             streamice_hmask(i-1,j,bi,bj).eq.2) THEN

            IF (streamice_hmask(i+1,j,bi,bj).eq.1) THEN
             dsdx(i,j,bi,bj) = recip_dxC(i+1,j,bi,bj) *
     &       (surf_el_streamice(i+1,j,bi,bj) -
     &        surf_el_streamice(i,j,bi,bj))
            ELSE
             dsdx(i,j,bi,bj) = 0.0
            ENDIF

           ELSE ! streamice_hmask(i-1,j,bi,bj).eq. -1
            dsdx(i,j,bi,bj) = 0.0
           ENDIF

c    ds/dy ------------------------------------------------

           IF (streamice_hmask(i,j-1,bi,bj) .eq. 1) THEN

            dsdy(i,j,bi,bj) = recip_dyC(i,j,bi,bj) *
     &       (surf_el_streamice(i,j,bi,bj) -
     &        surf_el_streamice(i,j-1,bi,bj))

           ELSEIF (streamice_hmask(i,j-1,bi,bj).eq.0.or.
     &             streamice_hmask(i,j-1,bi,bj).eq.2) THEN

            IF (streamice_hmask(i,j+1,bi,bj).eq.1) THEN
             dsdy(i,j,bi,bj) = recip_dyC(i,j+1,bi,bj) *
     &       (surf_el_streamice(i,j+1,bi,bj) -
     &        surf_el_streamice(i,j,bi,bj))
            ELSE
             dsdy(i,j,bi,bj) = 0.0
            ENDIF

           ELSE ! streamice_hmask(i-1,j,bi,bj).eq. -1
            dsdx(i,j,bi,bj) = 0.0
           ENDIF

c    end ------------------------------------------------

          ELSEIF(streamice_hmask(i,j,bi,bj).eq.0.or.
     &            streamice_hmask(i,j,bi,bj).eq.2) THEN

c    ds/dx ------------------------------------------------

           IF(streamice_hmask(i-1,j,bi,bj).eq.1.and.
     &         streamice_hmask(i-2,j,bi,bj).eq.1) THEN

             dsdx(i,j,bi,bj) = recip_dxC(i-1,j,bi,bj) *
     &       (surf_el_streamice(i-1,j,bi,bj) -
     &        surf_el_streamice(i-2,j,bi,bj))

           ELSE
            dsdx(i,j,bi,bj) = 0.0

           ENDIF

c    ds/dy ------------------------------------------------

           IF(streamice_hmask(i,j-1,bi,bj).eq.1.and.
     &         streamice_hmask(i,j-2,bi,bj).eq.1) THEN

             dsdy(i,j,bi,bj) = recip_dyC(i,j-1,bi,bj) *
     &       (surf_el_streamice(i,j-1,bi,bj) -
     &        surf_el_streamice(i,j-2,bi,bj))

           ELSE
            dsdy(i,j,bi,bj) = 0.0

           ENDIF

c    end ------------------------------------------------

          ENDIF
         ENDDO
        ENDDO
       ENDDO
      ENDDO

      _EXCH_XY_RL(dsdy, myThid)
      _EXCH_XY_RL(dsdx, myThid)

      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)

        DO i=1,sNx
         DO j=1,sNy

c           Gi = (myXGlobalLo-1)+(bi-1)*sNx+i
c           Gj = (myYGlobalLo-1)+(bj-1)*sNy+j

          IF (streamice_hmask(i,j,bi,bj).eq.1.0) THEN

           IF (streamice_umask(i,j,bi,bj).eq.1.0) THEN

            taudx_si(i,j,bi,bj) = taudx_si(i,j,bi,bj) +
     &       gravity * streamice_density *
     &       H_streamice (i,j,bi,bj) * dsdx (i,j,bi,bj) *
     &       (0.5 * dyG(i,j,bi,bj) + 0.25 * dyF(i,j,bi,bj)) *
     &       0.5 * dxG(i,j,bi,bj)

            taudx_si(i,j,bi,bj) = taudx_si(i,j,bi,bj) +
     &       gravity * streamice_density *
     &       H_streamice (i,j,bi,bj) * dsdx (i+1,j,bi,bj) *
     &       0.25 * dyF(i,j,bi,bj) *
     &       0.5 * dxG(i,j,bi,bj)

           ENDIF

           IF (streamice_umask(i+1,j,bi,bj).eq.1.0) THEN

            taudx_si(i+1,j,bi,bj) = taudx_si(i+1,j,bi,bj) +
     &       gravity * streamice_density *
     &       H_streamice (i,j,bi,bj) * dsdx (i+1,j,bi,bj) *
     &       (0.5 * dyG(i+1,j,bi,bj) + 0.25 * dyF(i,j,bi,bj)) *
     &       0.5 * dxG(i,j,bi,bj)

            taudx_si(i+1,j,bi,bj) = taudx_si(i+1,j,bi,bj) +
     &       gravity * streamice_density *
     &       H_streamice (i,j,bi,bj) * dsdx (i,j,bi,bj) *
     &       0.25 * dyF(i,j,bi,bj) *
     &       0.5 * dxG(i,j,bi,bj)

           ENDIF

           IF (streamice_umask(i,j+1,bi,bj).eq.1.0) THEN

            taudx_si(i,j+1,bi,bj) = taudx_si(i,j+1,bi,bj) +
     &       gravity * streamice_density *
     &       H_streamice (i,j,bi,bj) * dsdx (i,j,bi,bj) *
     &       (0.5 * dyG(i,j,bi,bj) + 0.25 * dyF(i,j,bi,bj)) *
     &       0.5 * dxG(i,j+1,bi,bj)

            taudx_si(i,j+1,bi,bj) = taudx_si(i,j+1,bi,bj) +
     &       gravity * streamice_density *
     &       H_streamice (i,j,bi,bj) * dsdx (i+1,j,bi,bj) *
     &       0.25 * dyF(i,j,bi,bj) *
     &       0.5 * dxG(i,j+1,bi,bj)

           ENDIF

           IF (streamice_umask(i+1,j+1,bi,bj).eq.1.0) THEN

            taudx_si(i+1,j+1,bi,bj) = taudx_si(i+1,j+1,bi,bj) +
     &       gravity * streamice_density *
     &       H_streamice (i,j,bi,bj) * dsdx (i+1,j,bi,bj) *
     &       (0.5 * dyG(i+1,j,bi,bj) + 0.25 * dyF(i,j,bi,bj)) *
     &       0.5 * dxG(i,j+1,bi,bj)

            taudx_si(i+1,j+1,bi,bj) = taudx_si(i+1,j+1,bi,bj) +
     &       gravity * streamice_density *
     &       H_streamice (i,j,bi,bj) * dsdx (i,j,bi,bj) *
     &       0.25 * dyF(i,j,bi,bj) *
     &       0.5 * dxG(i,j+1,bi,bj)

           ENDIF

#ifdef USE_ALT_RLOW
           IF (R_low_si(i,j,bi,bj) .lt. 0. _d 0) then
#else
           IF (R_low(i,j,bi,bj) .lt. 0. _d 0) then
#endif
              grd_below_sl = 1. _d 0
           else
              grd_below_sl = 0. _d 0
           endif

c check face to right
           IF (streamice_hmask(i+1,j,bi,bj).eq.0.or.
     &         streamice_hmask(i+1,j,bi,bj).eq.2.or.
     &         streamice_ufacemask(i+1,j,bi,bj).eq.2) THEN

            IF (float_frac_streamice(i,j,bi,bj) .eq. 1.0) THEN

             face_factor =
     &        0.25 * dyG(i+1,j,bi,bj) *
     &        gravity *
     &        streamice_density * H_streamice(i,j,bi,bj)**2-
#ifdef USE_ALT_RLOW
     &         streamice_density_ocean_avg * grd_below_sl *
     &         R_low_si(i,j,bi,bj)**2
#else
     &         streamice_density_ocean_avg * grd_below_sl *
     &         R_low(i,j,bi,bj)**2
#endif

            ELSE

             face_factor =
     &        0.25 * dyG(i+1,j,bi,bj) *
     &        streamice_density * gravity *
     &        (1-streamice_density*i_rhow) *
     &         H_streamice(i,j,bi,bj)**2

            ENDIF

            taudx_si(i+1,j,bi,bj) = taudx_si(i+1,j,bi,bj)
     &       - face_factor

            taudx_si(i+1,j+1,bi,bj) = taudx_si(i+1,j+1,bi,bj)
     &       - face_factor

           ENDIF

c check face to left
           IF (streamice_hmask(i-1,j,bi,bj).eq.0.or.
     &         streamice_hmask(i-1,j,bi,bj).eq.2.or.
     &         streamice_ufacemask(i,j,bi,bj).eq.2) THEN

            IF (float_frac_streamice(i,j,bi,bj) .eq. 1.0) THEN

             face_factor =
     &        0.25 * dyG(i,j,bi,bj) *
     &        gravity *
     &        streamice_density * H_streamice(i,j,bi,bj)**2-
#ifdef USE_ALT_RLOW
     &         streamice_density_ocean_avg * grd_below_sl *
     &         R_low_si(i,j,bi,bj)**2
#else
     &         streamice_density_ocean_avg * grd_below_sl *
     &         R_low(i,j,bi,bj)**2
#endif

            ELSE

             face_factor =
     &        0.25 * dyG(i,j,bi,bj) *
     &        streamice_density * gravity *
     &        (1-streamice_density*i_rhow) *
     &         H_streamice(i,j,bi,bj)**2

            ENDIF

            taudx_si(i,j,bi,bj) = taudx_si(i,j,bi,bj)
     &       + face_factor

            taudx_si(i,j+1,bi,bj) = taudx_si(i,j+1,bi,bj)
     &       + face_factor

           ENDIF

c Y FORCES

           IF (streamice_vmask(i,j,bi,bj).eq.1.0) THEN

            taudy_si(i,j,bi,bj) = taudy_si(i,j,bi,bj) +
     &       gravity * streamice_density *
     &       H_streamice (i,j,bi,bj) * dsdy (i,j,bi,bj) *
     &       (0.5 * dxG(i,j,bi,bj) + 0.25 * dxF(i,j,bi,bj)) *
     &       0.5 * dyG(i,j,bi,bj)

            taudy_si(i,j,bi,bj) = taudy_si(i,j,bi,bj) +
     &       gravity * streamice_density *
     &       H_streamice (i,j,bi,bj) * dsdy (i,j+1,bi,bj) *
     &       0.25 * dxF(i,j,bi,bj) *
     &       0.5 * dyG(i,j,bi,bj)

           ENDIF

           IF (streamice_vmask(i,j+1,bi,bj).eq.1.0) THEN

            taudy_si(i,j+1,bi,bj) = taudy_si(i,j+1,bi,bj) +
     &       gravity * streamice_density *
     &       H_streamice (i,j,bi,bj) * dsdy (i,j+1,bi,bj) *
     &       (0.5 * dxG(i,j+1,bi,bj) + 0.25 * dxF(i,j,bi,bj)) *
     &       0.5 * dyG(i,j,bi,bj)

            taudy_si(i,j+1,bi,bj) = taudy_si(i,j+1,bi,bj) +
     &       gravity * streamice_density *
     &       H_streamice (i,j,bi,bj) * dsdy (i,j,bi,bj) *
     &       0.25 * dxF(i,j,bi,bj) *
     &       0.5 * dyG(i,j,bi,bj)

           ENDIF

           IF (streamice_vmask(i+1,j,bi,bj).eq.1.0) THEN

            taudy_si(i+1,j,bi,bj) = taudy_si(i+1,j,bi,bj) +
     &       gravity * streamice_density *
     &       H_streamice (i,j,bi,bj) * dsdy (i,j,bi,bj) *
     &       (0.5 * dxG(i,j,bi,bj) + 0.25 * dxF(i,j,bi,bj)) *
     &       0.5 * dyG(i+1,j,bi,bj)

            taudy_si(i+1,j,bi,bj) = taudy_si(i+1,j,bi,bj) +
     &       gravity * streamice_density *
     &       H_streamice (i,j,bi,bj) * dsdy (i,j+1,bi,bj) *
     &       0.25 * dxF(i,j,bi,bj) *
     &       0.5 * dyG(i+1,j,bi,bj)

           ENDIF

           IF (streamice_umask(i+1,j+1,bi,bj).eq.1.0) THEN

            taudy_si(i+1,j+1,bi,bj) = taudy_si(i+1,j+1,bi,bj) +
     &       gravity * streamice_density *
     &       H_streamice (i,j,bi,bj) * dsdy (i,j+1,bi,bj) *
     &       (0.5 * dxG(i,j+1,bi,bj) + 0.25 * dxF(i,j,bi,bj)) *
     &       0.5 * dyG(i,j+1,bi,bj)

            taudy_si(i+1,j+1,bi,bj) = taudy_si(i+1,j+1,bi,bj) +
     &       gravity * streamice_density *
     &       H_streamice (i,j,bi,bj) * dsdy (i,j,bi,bj) *
     &       0.25 * dxF(i,j,bi,bj) *
     &       0.5 * dyG(i,j+1,bi,bj)

           ENDIF

#ifdef USE_ALT_RLOW
           IF (R_low_si(i,j,bi,bj) .lt. 0. _d 0) then
#else
           IF (R_low(i,j,bi,bj) .lt. 0. _d 0) then
#endif
              grd_below_sl = 1. _d 0
           else
              grd_below_sl = 0. _d 0
           endif

c check face to right
           IF (streamice_hmask(i,j+1,bi,bj).eq.0.or.
     &         streamice_hmask(i,j+1,bi,bj).eq.2.or.
     &         streamice_vfacemask(i,j+1,bi,bj).eq.2) THEN

            IF (float_frac_streamice(i,j,bi,bj) .eq. 1.0) THEN

             face_factor =
     &        0.25 * dxG(i,j+1,bi,bj) *
     &        gravity *
     &        streamice_density * H_streamice(i,j,bi,bj)**2-
#ifdef USE_ALT_RLOW
     &         streamice_density_ocean_avg * grd_below_sl *
     &         R_low_si(i,j,bi,bj)**2
#else
     &         streamice_density_ocean_avg * grd_below_sl *
     &         R_low(i,j,bi,bj)**2
#endif

            ELSE

             face_factor =
     &        0.25 * dxG(i,j+1,bi,bj) *
     &        streamice_density * gravity *
     &        (1-streamice_density*i_rhow) *
     &         H_streamice(i,j,bi,bj)**2

            ENDIF

            taudy_si(i,j+1,bi,bj) = taudy_si(i,j+1,bi,bj)
     &       - face_factor

            taudy_si(i+1,j+1,bi,bj) = taudy_si(i+1,j+1,bi,bj)
     &       - face_factor

           ENDIF

c check face to left
           IF (streamice_hmask(i,j-1,bi,bj).eq.0.or.
     &         streamice_hmask(i,j-1,bi,bj).eq.2.or.
     &         streamice_vfacemask(i,j,bi,bj).eq.2) THEN

            IF (float_frac_streamice(i,j,bi,bj) .eq. 1.0) THEN

             face_factor =
     &        0.25 * dxG(i,j,bi,bj) *
     &        gravity *
     &        streamice_density * H_streamice(i,j,bi,bj)**2-
#ifdef USE_ALT_RLOW
     &         streamice_density_ocean_avg * grd_below_sl *
     &         R_low_si(i,j,bi,bj)**2
#else
     &         streamice_density_ocean_avg * grd_below_sl *
     &         R_low(i,j,bi,bj)**2
#endif

            ELSE

             face_factor =
     &        0.25 * dxG(i,j,bi,bj) *
     &        streamice_density * gravity *
     &        (1-streamice_density*i_rhow) *
     &         H_streamice(i,j,bi,bj)**2

            ENDIF

            taudy_si(i,j,bi,bj) = taudy_SI(i,j,bi,bj)
     &       + face_factor

            taudy_si(i+1,j,bi,bj) = taudy_si(i+1,j,bi,bj)
     &       + face_factor

           ENDIF

          ENDIF

         ENDDO
        ENDDO
       ENDDO
      ENDDO

      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
        DO j=1-OLy+1,sNy+OLy-1
         DO i=1-OLx+1,sNx+OLx-1
          taudx_SI(i,j,bi,bj) = -1.*taudx_SI(i,j,bi,bj)
          taudy_SI(i,j,bi,bj) = -1.*taudy_SI(i,j,bi,bj)
         ENDDO
        ENDDO
       ENDDO
      ENDDO
c       call write_fld_xy_rl ('driving_taux','',taudx_si,0,myThid)

#endif
      RETURN
      END

#include "TAPENADE_OPTIONS.h"
#ifdef ALLOW_STREAMICE
# include "STREAMICE_OPTIONS.h"
#endif

C--   File stubs_tap_adj.F: Subroutines with "manual" derivatives
C--  to be called by the tapenade adjoint and tangent linear code
C--    *_B: adjoint with checkpointing on
C--    *_D: tlm
C--    *_FWD, *_BWD: adjoint with no checkpointing
C--
C--    Contents:
C--    o  GLOBAL_MAX_R8_B
C--    o  GLOBAL_SUM_TILE_RL_B
C--    o  GLOBAL_SUM_TILE_RL_FWD
C--    o  GLOBAL_SUM_TILE_RL_BWD
C--    o  GLOBAL_SUM_R8_B
C--    o  CG2D_B0
C--    o  ADEXCH_3D_RL
C--    o  ADEXCH_UV_XY_RS
C--    o  ADEXCH_UV_3D_RL
C--    o  ADEXCH_XY_RS
C--    o  ADEXCH_XY_RL
C--    o  STREAMICE_CG_SOLVE_D
C--    o  STREAMICE_CG_SOLVE_B
C--    o  STREAMICE_CG_SOLVE_FWD
C--    o  STREAMICE_CG_SOLVE_BWD

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
      SUBROUTINE GLOBAL_MAX_R8_B(rhsmax, rhsmaxb, myThid)
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "EESUPPORT.h"
#include "GLOBAL_MAX.h"
      Real*8  rhsmax
      Real*8  rhsmaxb
      INTEGER myThid

      CALL GLOBAL_ADMAX_R8(rhsmaxb, myThid)
      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
      SUBROUTINE GLOBAL_SUM_TILE_RL_B(phiTile, phiTileb,
     &                                sumPhi, sumPhib, myThid)
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "EESUPPORT.h"
#include "GLOBAL_SUM.h"
      _RL     phiTile(nSx,nSy)
      _RL     phiTileb(nSx,nSy)
      _RL     sumPhib
      _RL     sumPhi
      INTEGER myThid

      CALL GLOBAL_ADSUM_TILE_RL(phiTileb, sumPhib, myThid)
      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
      SUBROUTINE GLOBAL_SUM_TILE_RL_FWD(phiTile,
     &                                  sumPhi, myThid)
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "EESUPPORT.h"
#include "GLOBAL_SUM.h"
      _RL     phiTile(nSx,nSy)
      _RL     sumPhi
      INTEGER myThid

      CALL PUSHINTEGER4(myThid)
      CALL GLOBAL_SUM_TILE_RL(phiTile, sumPhi, myThid)
      CALL PUSHREAL8(sumPhi)
      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
      SUBROUTINE GLOBAL_SUM_TILE_RL_BWD(phiTile, phiTileb,
     &                                  sumPhi, sumPhib, myThid)
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "EESUPPORT.h"
#include "GLOBAL_SUM.h"
      _RL     phiTile(nSx,nSy)
      _RL     phiTileb(nSx,nSy)
      _RL     sumPhib
      _RL     sumPhi
      INTEGER myThid

      CALL POPREAL8(sumPhi)
      CALL POPINTEGER4(myThid)
      CALL GLOBAL_ADSUM_TILE_RL(phiTileb, sumPhib, myThid)
      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
!     Adjoint of global_sum_r8 for arguments Arg1=(in;out)
      SUBROUTINE GLOBAL_SUM_R8_B(sumPhi, sumPhib, myThid)
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "EESUPPORT.h"
#include "GLOBAL_SUM.h"
      Real*8 sumPhi
      Real*8 sumPhib
      INTEGER myThid

      CALL GLOBAL_ADSUM_R8(sumPhib, myThid)
      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
      SUBROUTINE CG2D_B0(cg2d_b, cg2d_bb, cg2d_x, cg2d_xb,
     &                   firstResidual, minResidualSq, lastResidual,
     &                   numIters, nIterMin, myThid)
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "CG2D.h"
      _RL  cg2d_b(1-OLx:sNx+OLx, 1-OLy:sNy+OLy, nSx, nSy)
      _RL  cg2d_bb(1-OLx:sNx+OLx, 1-OLy:sNy+OLy, nSx, nSy)
      _RL  cg2d_x(1-OLx:sNx+OLx, 1-OLy:sNy+OLy, nSx, nSy)
      _RL  cg2d_xb(1-OLx:sNx+OLx, 1-OLy:sNy+OLy, nSx, nSy)
      _RL  firstResidual
      _RL  minResidualSq
      _RL  lastResidual
      INTEGER numIters
      INTEGER nIterMin
      INTEGER myThid

! [llh] we assume the downstream cg2d_b is passive, which helps us
!    because it seems the input 2nd arg of cg2d() pollutes its output value:
      cg2d_bb = 0. _d 0
      CALL CG2D( cg2d_xb, cg2d_bb,
     &           firstResidual, minResidualSq, lastResidual,
     &           numIters, nIterMin, myThid)
! [llh] the upstream cg2d_x is passive:
      cg2d_xb = 0. _d 0
      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
      SUBROUTINE ADEXCH_3D_RL( adVar, Nr, myThid )
      IMPLICIT NONE
      _RL    adVar
      INTEGER Nr
      INTEGER myThid
      WRITE(*,*) "Called not yet defined"
      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
      SUBROUTINE ADEXCH_UV_XY_RS( adU, adV, bool, myThid )
      IMPLICIT NONE
      _RS     adU, adV
      LOGICAL bool
      INTEGER myThid
      WRITE(*,*) "Called not yet defined"
      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
      SUBROUTINE ADEXCH_UV_3D_RL( aduVel, advVel, bool, Nr, myThid )
      IMPLICIT NONE
      _RL     aduVel, advVel
      LOGICAL bool
      INTEGER Nr
      INTEGER myThid
      WRITE(*,*) "Called not yet defined"
      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
      SUBROUTINE ADEXCH_XY_RS( adVar, myThid )
      IMPLICIT NONE
      _RS     adVar
      INTEGER myThid
      WRITE(*,*) "Called not yet defined"
      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
      SUBROUTINE ADEXCH_XY_RL( adVar, myThid )
      IMPLICIT NONE
      _RL     adVar
      INTEGER myThid
      WRITE(*,*) "Called not yet defined"
      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
      SUBROUTINE STREAMICE_CG_SOLVE_D(
     &                        cg_Uin, cg_Uind, cg_Vin, cg_Vind,
     &                        cg_Bu, cg_Bud, cg_Bv, cg_Bvd,
     &                        A_uu, A_uud, A_uv, A_uvd,
     &                        A_vu, A_vud, A_vv, A_vvd,
     &                        tolerance, iters, maxIter, myThid )
      IMPLICIT NONE

#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"

      _RL cg_Uin(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL cg_Vin(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL cg_Bu (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL cg_Bv (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL A_uu (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy,-1:1,-1:1)
      _RL A_vu (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy,-1:1,-1:1)
      _RL A_uv (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy,-1:1,-1:1)
      _RL A_vv (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy,-1:1,-1:1)
      _RL cg_Uind(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL cg_Vind(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL cg_Bud (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL cg_Bvd (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL A_uud(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy,-1:1,-1:1)
      _RL A_vud(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy,-1:1,-1:1)
      _RL A_uvd(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy,-1:1,-1:1)
      _RL A_vvd(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy,-1:1,-1:1)
      _RL tolerance
      INTEGER iters
      INTEGER maxIter
      INTEGER myThid

C     !LOCAL VARIABLES
#ifdef ALLOW_STREAMICE
      INTEGER i, j, bi, bj
      INTEGER colx, coly
      _RL deltaAu (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL deltaAv (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL deltaAuMdBu (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL deltaAvMdBv (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)

      ! A x = b
      ! delta A x + A delta x = delta b
      ! A delta x = delta b - delta A x
      ! delta x = A^{-1} (delta b - delta A x)

      CALL STREAMICE_CG_SOLVE( cg_Uin, cg_Vin,
     &                         cg_Bu, cg_Bv,
     &                         A_uu, A_uv, A_vu, A_vv,
     &                         tolerance, iters, maxIter, myThid )

      _EXCH_XY_RL(cg_Uin, myThid)
      _EXCH_XY_RL(cg_Vin, myThid)

      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
        DO j=1,sNy
         DO i=1,sNx

          deltaAu(i,j,bi,bj) = 0. _d 0
          deltaAv(i,j,bi,bj) = 0. _d 0

          DO colx=-1,1
           DO coly=-1,1
            deltaAu(i,j,bi,bj) = deltaAu(i,j,bi,bj) +
     &         A_uud(i,j,bi,bj,colx,coly)*
     &         cg_Uin(i+colx,j+coly,bi,bj)+
     &         A_uvd(i,j,bi,bj,colx,coly)*
     &         cg_Vin(i+colx,j+coly,bi,bj)

            deltaAv(i,j,bi,bj) = deltaAv(i,j,bi,bj) +
     &         A_vud(i,j,bi,bj,colx,coly)*
     &         cg_Uin(i+colx,j+coly,bi,bj)+
     &         A_vvd(i,j,bi,bj,colx,coly)*
     &         cg_Vin(i+colx,j+coly,bi,bj)
           ENDDO
          ENDDO

         ENDDO
        ENDDO
       ENDDO
      ENDDO

      _EXCH_XY_RL(deltaAu, myThid)
      _EXCH_XY_RL(deltaAv, myThid)

      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          deltaAuMdBu(i,j,bi,bj) = cg_Bud(i,j,bi,bj)-deltaAu(i,j,bi,bj)
          deltaAvMdBv(i,j,bi,bj) = cg_Bvd(i,j,bi,bj)-deltaAv(i,j,bi,bj)
         ENDDO
        ENDDO
       ENDDO
      ENDDO

      CALL STREAMICE_CG_SOLVE( cg_Uind, cg_Vind,
     &                         deltaAuMdBu, deltaAvMdBv,
     &                         A_uu, A_uv, A_vu, A_vv,
     &                         tolerance, iters, maxIter, myThid )

#endif
      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
      SUBROUTINE STREAMICE_CG_SOLVE_B(
     &                        cg_Uin, cg_Uinb, cg_Vin, cg_Vinb,
     &                        cg_Bu, cg_Bub, cg_Bv, cg_Bvb,
     &                        A_uu, A_uub, A_uv, A_uvb,
     &                        A_vu, A_vub, A_vv, A_vvb,
     &                        tolerance, iters, maxIter, myThid )

      IMPLICIT NONE

#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#ifdef ALLOW_STREAMICE
#include "STREAMICE.h"
#include "STREAMICE_CG.h"
#endif

      INTEGER myThid
      _RL cg_Uin (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL cg_Vin (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL cg_Bu (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL cg_Bv (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL
     & A_uu (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy,-1:1,-1:1),
     & A_vu (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy,-1:1,-1:1),
     & A_uv (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy,-1:1,-1:1),
     & A_vv (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy,-1:1,-1:1)
      _RL cg_Uinb (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL cg_Vinb (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL cg_Bub (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL cg_Bvb (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL
     & A_uub (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy,-1:1,-1:1),
     & A_vub (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy,-1:1,-1:1),
     & A_uvb (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy,-1:1,-1:1),
     & A_vvb (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy,-1:1,-1:1)
      _RL tolerance
      INTEGER iters
      INTEGER maxIter

#ifdef ALLOW_STREAMICE
      INTEGER recalc_vel
      recalc_vel = 1
      CALL ADSTREAMICE_CG_SOLVE(
     U  cg_Uin,    ! velocities - need to be recalc ed
     I  cg_Uinb,      ! adjoint of vel (input)
     U  cg_Vin,    ! velocities - need to be recalc ed
     I  cg_Vinb,      ! adjoint of vel (input)
     I  cg_Bu,   ! to recalc velocities
     U  cg_Bub,     ! adjoint of RHS (output)
     I  cg_Bv,   ! to recalc velocities
     U  cg_Bvb,     ! adjoint of RHS (output)
     I  A_uu,       ! section of matrix that multiplies u and projects on u
     U  A_uub,     ! adjoint of matrix coeffs (output)
     I  A_uv,       ! section of matrix that multiplies v and projects on u
     U  A_uvb,     ! adjoint of matrix coeffs (output)
     I  A_vu,       ! section of matrix that multiplies u and projects on v
     U  A_vub,     ! adjoint of matrix coeffs (output)
     I  A_vv,       ! section of matrix that multiplies v and projects on v
     U  A_vvb,     ! adjoint of matrix coeffs (output)
     I  tolerance,
     I  maxIter,
     I  recalc_vel,
     I  myThid )
#endif
      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C [llh] Hand-written forward-sweep adjoint code of STREAMICE_CG_SOLVE
C [llh] Adjoint of solving Ax=b,
C [llh]  where A is (Auu, Auv, Avu, Avv), x is (xu,xv), b is (bu,bv)
      SUBROUTINE STREAMICE_CG_SOLVE_FWD(
     &                        cg_Uin, cg_Vin, cg_Bu, cg_Bv,
     &                        A_uu, A_uv, A_vu, A_vv,
     &                        tolerance, iters, maxiters, myThid )

      IMPLICIT NONE

#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#ifdef ALLOW_STREAMICE
#include "STREAMICE.h"
#include "STREAMICE_CG.h"
#endif

      !INPUT/OUTPUT ARGUMENTS
      _RL cg_Uin (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL cg_Vin (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL cg_Bu (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL cg_Bv (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL A_uu (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy,-1:1,-1:1)
      _RL A_vu (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy,-1:1,-1:1)
      _RL A_uv (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy,-1:1,-1:1)
      _RL A_vv (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy,-1:1,-1:1)
      _RL tolerance
      INTEGER maxiters
      INTEGER iters
      INTEGER myThid

#ifdef ALLOW_STREAMICE
C     !LOCAL VARIABLES
      INTEGER i, j, bi, bj, colx, coly
      INTEGER conv_flag, tmpiter
      CHARACTER*(MAX_LEN_MBUF) msgBuf

      conv_flag = 0
      CALL STREAMICE_CG_SOLVE(
     &  cg_Uin,
     &  cg_Vin,
     &  cg_Bu,
     &  cg_Bv,
     &  A_uu,
     &  A_uv,
     &  A_vu,
     &  A_vv,
     &  tolerance,
     &  iters,
     &  maxiters,
     &  myThid )

      CALL PUSHREAL8ARRAY(cg_Vin, (sNx+2*OLx)*(sNy+2*OLy)*nSx*nSy)
      CALL PUSHREAL8ARRAY(cg_Uin, (sNx+2*OLx)*(sNy+2*OLy)*nSx*nSy)
#endif
      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C [llh] Hand-written backward-sweep adjoint code of STREAMICE_CG_SOLVE
C [llh] Adjoint of solving Ax=b,
C [llh]  where A is (Auu, Auv, Avu, Avv), x is (xu,xv), b is (bu,bv)
      SUBROUTINE STREAMICE_CG_SOLVE_BWD(
     &                        cg_Uin, cg_Uinb, cg_Vin, cg_Vinb,
     &                        cg_Bu, cg_Bub, cg_Bv, cg_Bvb,
     &                        A_uu, A_uub, A_uv, A_uvb,
     &                        A_vu, A_vub, A_vv, A_vvb,
     &                        tolerance, iters, maxIter, myThid )

      IMPLICIT NONE

#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#ifdef ALLOW_STREAMICE
#include "STREAMICE.h"
#include "STREAMICE_CG.h"
#endif

      _RL cg_Uin (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL cg_Vin (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL cg_Bu (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL cg_Bv (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL A_uu (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy,-1:1,-1:1)
      _RL A_vu (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy,-1:1,-1:1)
      _RL A_uv (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy,-1:1,-1:1)
      _RL A_vv (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy,-1:1,-1:1)
      _RL cg_Uinb (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL cg_Vinb (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL cg_Bub (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL cg_Bvb (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL A_uub (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy,-1:1,-1:1)
      _RL A_vub (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy,-1:1,-1:1)
      _RL A_uvb (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy,-1:1,-1:1)
      _RL A_vvb (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy,-1:1,-1:1)
      _RL tolerance
#ifdef ALLOW_PETSC
      _RL toleranceb
#endif
      INTEGER iters
      INTEGER maxIter
      INTEGER myThid

#ifdef ALLOW_STREAMICE
      CALL POPREAL8ARRAY(cg_Uin, (sNx+2*OLx)*(sNy+2*OLy)*nSx*nSy)
      CALL POPREAL8ARRAY(cg_Vin, (sNx+2*OLx)*(sNy+2*OLy)*nSx*nSy)

      CALL ADSTREAMICE_CG_SOLVE(
     U  cg_Uin,    ! velocities - need to be recalc ed
     I  cg_Uinb,      ! adjoint of vel (input)
     U  cg_Vin,    ! velocities - need to be recalc ed
     I  cg_Vinb,      ! adjoint of vel (input)
     I  cg_Bu,   ! to recalc velocities
     U  cg_Bub,     ! adjoint of RHS (output)
     I  cg_Bv,   ! to recalc velocities
     U  cg_Bvb,     ! adjoint of RHS (output)
     I  A_uu,       ! section of matrix that multiplies u and projects on u
     U  A_uub,     ! adjoint of matrix coeffs (output)
     I  A_uv,       ! section of matrix that multiplies v and projects on u
     U  A_uvb,     ! adjoint of matrix coeffs (output)
     I  A_vu,       ! section of matrix that multiplies u and projects on v
     U  A_vub,     ! adjoint of matrix coeffs (output)
     I  A_vv,       ! section of matrix that multiplies v and projects on v
     U  A_vvb,     ! adjoint of matrix coeffs (output)
     I  tolerance,
     I  maxIter,
     I  myThid )
#endif
      RETURN
      END

#include "PACKAGES_CONFIG.h"
#include "CPP_OPTIONS.h"

CBOP
C     !ROUTINE: INI_GLOBAL_DOMAIN
C     !INTERFACE:
      SUBROUTINE INI_GLOBAL_DOMAIN( myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE INI_GLOBAL_DOMAIN
C     | o Initialise domain (i.e., where there is fluid)
C     |   related (global) quantities.
C     |   Called after grid and masks are set (ini_grid,
C     |   ini_masks) or modified (packages_init_fixed call).
C     *==========================================================*
C     | Compute global domain Area ;
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#ifdef ALLOW_EXCH2
# include "W2_EXCH2_SIZE.h"
# include "W2_EXCH2_TOPOLOGY.h"
#endif /* ALLOW_EXCH2 */

C     !INPUT/OUTPUT PARAMETERS:
C     myThid  :: my Thread Id number
      INTEGER myThid

C     == Local variables in common ==
      _RL tileArea(nSx,nSy)
C     put tileArea in (local) common block to print from master-thread:
      COMMON / LOCAL_INI_GLOB_DOMAIN / tileArea

C     !LOCAL VARIABLES:
C     bi, bj  :: tile indices
C     i, j, k :: Loop counters
      INTEGER bi, bj
      INTEGER i, j, k, nCorners
      LOGICAL northWestCorner, northEastCorner,
     &        southWestCorner, southEastCorner
      _RL loc2dArea, loc2dNwet
      _RL loc3dArea, loc3dNwet
      _RL tileNwet(nSx,nSy)
      CHARACTER*(MAX_LEN_MBUF) msgBuf
#ifdef ALLOW_EXCH2
      INTEGER myTile
#endif /* ALLOW_EXCH2 */
CEOP

C--   Initialisation

#ifdef NONLIN_FRSURF
C--   Save initial geometrical hFac factor into h0Fac (fixed in time):
C     better here (after packages_init_fixed call) than in INI_MASKS_ETC
C     in case 1 pkg would need to modify them.
C    <= moved to INI_MASK_ETC , despite comment above, since:
C      a) in case 1 pkg is changing hFac, this pkg should also update h0Fac
C      b) pkg/shelfice does modify hFac but done directly within ini_masks_etc
#endif /* NONLIN_FRSURF */

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C--   Calculate global domain area:
C     use to be in ini_masks_etc.F but has been move after packages_init_fixed
C     in case 1 pkg (e.g., OBCS) modifies the domain size.
      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
C-      Compute the domain Area:
        tileNwet(bi,bj) = 0. _d 0
        tileArea(bi,bj) = 0. _d 0
        DO j=1,sNy
         DO i=1,sNx
          tileNwet(bi,bj) = tileNwet(bi,bj) + maskInC(i,j,bi,bj)
          tileArea(bi,bj) = tileArea(bi,bj)
     &                    + rA(i,j,bi,bj)*maskInC(i,j,bi,bj)
         ENDDO
        ENDDO
       ENDDO
      ENDDO
      CALL GLOBAL_SUM_TILE_RL( tileNwet, loc2dNwet, myThid )
      CALL GLOBAL_SUM_TILE_RL( tileArea, loc2dArea, myThid )

C--   Calculate domain 3-D average grid-cell area:
      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
C-      Compute 3-D integrated area:
        tileNwet(bi,bj) = 0. _d 0
        tileArea(bi,bj) = 0. _d 0
        DO k=1,Nr
         DO j=1,sNy
          DO i=1,sNx
           tileNwet(bi,bj) = tileNwet(bi,bj)
     &                     + maskC(i,j,k,bi,bj)*maskInC(i,j,bi,bj)
           tileArea(bi,bj) = tileArea(bi,bj)
     &                     + deepFac2C(k)*rA(i,j,bi,bj)
     &                      *maskC(i,j,k,bi,bj)*maskInC(i,j,bi,bj)
          ENDDO
         ENDDO
        ENDDO
       ENDDO
      ENDDO
      CALL GLOBAL_SUM_TILE_RL( tileNwet, loc3dNwet, myThid )
      CALL GLOBAL_SUM_TILE_RL( tileArea, loc3dArea, myThid )

      _BEGIN_MASTER( myThid )
      n2dWetPts  = loc2dNwet
      n3dWetPts  = loc3dNwet
      globalArea = loc2dArea
      rAc_3dMean = 0. _d 0
      IF ( loc3dNwet .GT. zeroRL ) rAc_3dMean = loc3dArea / loc3dNwet
C-    list empty tiles:
      msgBuf(1:1) = ' '
      DO bj = 1,nSy
       DO bi = 1,nSx
        IF ( tileArea(bi,bj).EQ.0. _d 0 ) THEN
#ifdef ALLOW_EXCH2
         WRITE(msgBuf,'(A,I6,A,2I4,A)')
     &    'Empty tile: #', W2_myTileList(bi,bj), ' (bi,bj=',bi,bj,' )'
#else
         WRITE(msgBuf,'(A,I6,I6)') 'Empty tile bi,bj=', bi, bj
#endif
         CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                       SQUEEZE_RIGHT, myThid )
        ENDIF
       ENDDO
      ENDDO
      IF ( msgBuf(1:1).NE.' ' ) THEN
         WRITE(msgBuf,'(A)') ' '
         CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                       SQUEEZE_RIGHT, myThid )
      ENDIF
      _END_MASTER( myThid )

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C--   With Cubed-Sphere Exchanges, check if CS-corners are part of the domain
      IF ( useCubedSphereExchange ) THEN
        nCorners = 0
        DO bj = myByLo(myThid), myByHi(myThid)
         DO bi = myBxLo(myThid), myBxHi(myThid)
#ifdef ALLOW_EXCH2
           myTile = W2_myTileList(bi,bj)
           southWestCorner = exch2_isWedge(myTile).EQ.1
     &                 .AND. exch2_isSedge(myTile).EQ.1
           southEastCorner = exch2_isEedge(myTile).EQ.1
     &                 .AND. exch2_isSedge(myTile).EQ.1
           northEastCorner = exch2_isEedge(myTile).EQ.1
     &                 .AND. exch2_isNedge(myTile).EQ.1
           northWestCorner = exch2_isWedge(myTile).EQ.1
     &                 .AND. exch2_isNedge(myTile).EQ.1
#else /* ALLOW_EXCH2 */
           southWestCorner = .TRUE.
           southEastCorner = .TRUE.
           northWestCorner = .TRUE.
           northEastCorner = .TRUE.
#endif /* ALLOW_EXCH2 */
           IF ( southWestCorner .AND. kSurfC( 1 , 1 ,bi,bj).LE.Nr )
     &       nCorners = nCorners + 1
           IF ( southEastCorner .AND. kSurfC(sNx, 1 ,bi,bj).LE.Nr )
     &       nCorners = nCorners + 1
           IF ( northWestCorner .AND. kSurfC( 1 ,sNy,bi,bj).LE.Nr )
     &       nCorners = nCorners + 1
           IF ( northEastCorner .AND. kSurfC(sNx,sNy,bi,bj).LE.Nr )
     &       nCorners = nCorners + 1
         ENDDO
        ENDDO
        CALL GLOBAL_SUM_INT( nCorners, myThid )
        _BEGIN_MASTER( myThid )
        IF ( nCorners.GE.1 ) hasWetCSCorners = .TRUE.
        WRITE(msgBuf,'(A,I4,A)') 'INI_GLOBAL_DOMAIN: Found',
     &                 nCorners, ' CS-corner Pts in the domain'
        CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
        _END_MASTER( myThid )
      ENDIF

C--   Everyone else must wait for global-domain parameters to be set
      _BARRIER

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
      RETURN
      END

#include "MOM_COMMON_OPTIONS.h"

CBOP
C !ROUTINE: MOM_U_RVISCFLUX

C !INTERFACE: ==========================================================
      SUBROUTINE MOM_U_RVISCFLUX(
     I        bi,bj,k,
     I        uFld, KappaRU,
     O        rViscFluxU,
     I        myThid)

C !DESCRIPTION:
C Calculates the area integrated vertical viscous fluxes of U
C  at vertical interface k (between level k & k-1):
C \begin{equation*}
C F^r = - \frac{ {\cal A}_w }{\Delta r_c} A_r \delta_k u
C \end{equation*}

C !USES: ===============================================================
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"

C !INPUT PARAMETERS: ===================================================
C  bi,bj                :: tile indices
C  k                    :: vertical level
C  uFld                 :: zonal flow
C  KappaRU              :: vertical viscosity
C  myThid               :: thread number
      INTEGER bi,bj,k
      _RL uFld(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      _RL KappaRU(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      INTEGER myThid

C !OUTPUT PARAMETERS: ==================================================
C  rViscFluxU           :: viscous fluxes
      _RL rViscFluxU(1-OLx:sNx+OLx,1-OLy:sNy+OLy)

C !LOCAL VARIABLES: ====================================================
C  i,j                  :: loop indices
      INTEGER i,j
CEOP

C     - Vertical viscous flux
      IF ( k.LE.1 .OR. k.GT.Nr ) THEN
       DO j=1-Oly,sNy+Oly
        DO i=1-Olx,sNx+Olx
          rViscFluxU(i,j) = 0. _d 0
        ENDDO
       ENDDO
      ELSE
       DO j=1-Oly,sNy+Oly-1
        DO i=1-Olx,sNx+Olx-1
          rViscFluxU(i,j) =
     &      -KappaRU(i,j,k)
     &      *rAw(i,j,bi,bj)*deepFac2F(k)*rhoFacF(k)
     &      *( uFld(i,j,k,bi,bj)-uFld(i,j,k-1,bi,bj)
     &       )*rkSign*recip_drC(k)
     &      *_maskW(i,j,k,bi,bj)
     &      *_maskW(i,j,k-1,bi,bj)
        ENDDO
       ENDDO
      ENDIF

      RETURN
      END

#include "AIM_OPTIONS.h"

CBOP
C     !ROUTINE: SNOW_PRECIP
C     !INTERFACE:
      SUBROUTINE SNOW_PRECIP (
     I                   PSA, dpFac, ThA,
     I                   IDEPTH,PRECNV,DQCNV,PRECLS,DQLSC,
     U                   DTCNV,DTLSC,
     O                   EnPrec,
     I                   kGrd,bi,bj,myThid)

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R SNOW_PRECIP
C     | o Diagnose snow precipitation according to near surface 
C     |   air temperature. 
C     *==========================================================*
C     | Correct condensation heating for energy (rain Temp, snow) 
C     |  of precipication (L.S. cond & convect. precip)
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     == Global variables ===

C     Resolution parameters
C-- size for MITgcm & Physics package :
#include "AIM_SIZE.h" 
#include "EEPARAMS.h"

C     Physical constants + functions of sigma and latitude
#include "com_physcon.h"

C     == Routine Arguments ==
C     !INPUT PARAMETERS:
C       kGrd   :: Ground level index                       (2-dim)
C       bi,bj  :: tile index
C       myThid :: Thread number for this instance of the routine
C       PSA    :: norm. surface pressure [p/p0]            (2-dim)
C       dpFac  :: cell delta_P fraction                    (3-dim)
C       ThA    :: Pot.temperature    [K]                   (3-dim)
C       IDEPTH :: convection depth in layers               (2-dim)
C       PRECNV :: convective precipitation [g/(m^2 s)]     (2-dim)
C       DQCNV  :: hum. tendency [g/(kg s)] from convection (3-dim)
C       PRECLS :: large-scale precipitation [g/(m^2 s)]    (2-dim)
C       DQLSC  :: hum. tendency [g/(kg s)] from l.s. cond  (3-dim)
C     !MODIFIED PARAMETERS:
C       DTCNV  :: temperature tendency from convection     (3-dim)
C       DTLSC  :: temperature tendency from l.s. cond      (3-dim)
C     !OUTPUT PARAMETERS:
C       EnPrec :: energy of precipitation (snow, rain temp) [J/g]
C--
      _RL PSA(NGP), dpFac(NGP,NLEV), ThA(NGP,NLEV)
      _RL PRECLS(NGP), DTLSC(NGP,NLEV), DQLSC(NGP,NLEV)
      _RL PRECNV(NGP), DTCNV(NGP,NLEV), DQCNV(NGP,NLEV)
      _RL EnPrec(NGP)
      INTEGER  IDEPTH(NGP)
      INTEGER  kGrd(NGP)
      INTEGER  bi,bj,myThid
CEOP

#ifdef ALLOW_AIM

C-- Local variables:  
      INTEGER J, K, Ktop
      _RL kappa
      _RL T1(NGP)

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C--   1. Initialization
      kappa = RD/CP

C--   2. Compute energy of precip, based on near-surface Air temperature:
C     note: EnPrec units are J/g since precip is in g/m2 and spec.hum. in g/Kg
      DO J=1,NGP
       IF ( kGrd(J).NE.0 ) THEN
        T1(J) = ThA(J,kGrd(J))*(PSA(J)**kappa)
        IF ( T1(J) .GE. tFreeze ) THEN
         EnPrec(J) = rainCP*(T1(J)-tFreeze)
        ELSE
         EnPrec(J) = -ALHF
        ENDIF
       ELSE
        EnPrec(J) = 0.
       ENDIF
      ENDDO

C--   3. Large-scale precipitation: correct condensation Heating

      DO J=1,NGP
        DO K=2,kGrd(J)
          DTLSC(J,K) = DTLSC(J,K) + EnPrec(J)*DQLSC(J,K)/CP
        ENDDO
      ENDDO

C--   4. Convective precipitation: correct condensation Heating

      DO J=1,NGP
        IF (kGrd(J).NE.0 .AND. IDEPTH(J).NE.0 ) THEN
          Ktop = kGrd(J) - IDEPTH(J)
          DTCNV(J,Ktop) = DTCNV(J,Ktop) 
     &                  - EnPrec(J)*PRECNV(J)*GRDSCP(Ktop)
        ENDIF
      ENDDO

#endif /* ALLOW_AIM */ 

      RETURN
      END

#include "DIAG_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: DIAGNOSTICS_INIT_EARLY

C     !INTERFACE:
      SUBROUTINE DIAGNOSTICS_INIT_EARLY( myThid )

C     !DESCRIPTION:
C     Initialize available diagnostics list: set the following attributes:
C     name (=cdiag), parsing code (=gdiag), units (=udiag), and title (=tdiag)
C     Note: 1) diagnostics defined here are not presently filled. To use
C           one of them, one just needs to add a call to S/R DIAGNOSTICS_FILL
C           with the diagnostic name 'SDIAG...' or 'UDIAG...'
C           2) GDIAG is defined as character*16 and can be to character*1
C           parse(16) with the following codes currently defined:

C \begin{center}
C   \begin{tabular}[h]{|c|c|}\hline
C     \textbf{Positions} & \textbf{Characters} & \textbf{Meanings} \\\hline
C     parse(1)  &  S  &  scalar \\
C               &  U  &  vector component in X direction \\
C               &  V  &  vector component in Y direction \\
C               &  W  &  vector component in vertical direction \\
C     parse(2)  &  U  &  C-grid U-Point  \\
C               &  V  &  C-grid V-Point  \\
C               &  M  &  C-grid Mass Point  \\
C               &  Z  &  C-grid Corner Point  \\
C     parse(3)  &     &  Used for Level Integrated output: cumulate levels \\
C               &  r  &  same but cumulate product by model level thickness \\
C               &  R  &  same but cumulate product by hFac & level thickness \\
C     parse(4)  &  P  &  positive definite  \\
C               &  A  &  Adjoint variable diagnostics \\
C     parse(5 ) &  C  &  with counter array  \\
C               &  P  &  post-processed (not filled up) from other diags  \\
C               &  D  &  disable an array for output  \\
C     parse(6--8) & '123'  & retired, formerly: 3-digit mate number \\
C     parse(9)  &  U  &  model-level plus 1/2  \\
C               &  M  &  model-level middle  \\
C               &  L  &  model-level minus 1/2  \\
C     parse(10) &  0  &  levels = 0  \\
C               &  1  &  levels = 1  \\
C               &  R  &  levels = Nr  \\
C               &  L  &  levels = MAX(Nr,NrPhys)  \\
C               &  M  &  levels = MAX(Nr,NrPhys) - 1  \\
C               &  G  &  levels = Ground_level Number \\
C               &  I  &  levels = sea-Ice_level Number \\
C               &  X  &  free levels option (need to be set explicitly) \\
C   \end{tabular}
C \end{center}

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "DIAGNOSTICS_SIZE.h"
#include "DIAGNOSTICS.h"

C     !INPUT PARAMETERS:
      INTEGER myThid
CEOP

C     !LOCAL VARIABLES:
      INTEGER n

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      _BARRIER
      _BEGIN_MASTER( myThid )

      DO n=1,ndiagMax
        kdiag(n) = 0
        hdiag(n) = 0
        cdiag(n) = '        '
        gdiag(n) = '                '
        udiag(n) = '                '
        tdiag(n) = ' '
      ENDDO

C--   Diagnostics definition/setting starts here (can now add diags to list)
c     IF ( diag_pkgStatus.NE.1 ) STOP
      diag_pkgStatus = ready2setDiags

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C     For each output variable,
C     specify Name (cdiag, 8c), Descriptions (tdiag, *c), Units (udiag, 16c)
C         and parsing code (location on C grid, 2D/3D, ...) (gdiag, 16c)
C----------------------------------------------------------------------
      cdiag( 1) = 'SDIAG1  '
      tdiag( 1) = 'User-Defined   Surface   Diagnostic  #1 '
      udiag( 1) = 'user-defined    '
      gdiag( 1) = 'SM      L1      '

      cdiag( 2) = 'SDIAG2  '
      tdiag( 2) = 'User-Defined   Surface   Diagnostic  #2 '
      udiag( 2) = 'user-defined    '
      gdiag( 2) = 'SM      L1      '

      cdiag( 3) = 'SDIAG3  '
      tdiag( 3) = 'User-Defined   Surface   Diagnostic  #3 '
      udiag( 3) = 'user-defined    '
      gdiag( 3) = 'SM      L1      '

      cdiag( 4) = 'SDIAG4  '
      tdiag( 4) = 'User-Defined   Surface   Diagnostic  #4 '
      udiag( 4) = 'user-defined    '
      gdiag( 4) = 'SM      L1      '

      cdiag( 5) = 'SDIAG5  '
      tdiag( 5) = 'User-Defined   Surface   Diagnostic  #5 '
      udiag( 5) = 'user-defined    '
      gdiag( 5) = 'SM      L1      '

      cdiag( 6) = 'SDIAG6  '
      tdiag( 6) = 'User-Defined   Surface   Diagnostic  #6 '
      udiag( 6) = 'user-defined    '
      gdiag( 6) = 'SM      L1      '

      cdiag( 7) = 'SDIAG7  '
      tdiag( 7) = 'User-Defined U.pt Surface Diagnostic #7 '
      udiag( 7) = 'user-defined    '
      gdiag( 7) = 'SU      L1      '

      cdiag( 8) = 'SDIAG8  '
      tdiag( 8) = 'User-Defined V.pt Surface Diagnostic #8 '
      udiag( 8) = 'user-defined    '
      gdiag( 8) = 'SV      L1      '

      cdiag( 9) = 'SDIAG9  '
      tdiag( 9) = 'User-Defined U.vector Surface Diag.  #9 '
      udiag( 9) = 'user-defined    '
      gdiag( 9) = 'UU      L1      '
      hdiag( 9) =  10

      cdiag(10) = 'SDIAG10 '
      tdiag(10) = 'User-Defined V.vector Surface Diag. #10 '
      udiag(10) = 'user-defined    '
      gdiag(10) = 'VV      L1      '
      hdiag(10) =  9

      cdiag(11) = 'UDIAG1  '
      tdiag(11) = 'User-Defined Model-Level Diagnostic  #1 '
      udiag(11) = 'user-defined    '
      gdiag(11) = 'SM      MR      '

      cdiag(12) = 'UDIAG2  '
      tdiag(12) = 'User-Defined Model-Level Diagnostic  #2 '
      udiag(12) = 'user-defined    '
      gdiag(12) = 'SM      MR      '

      cdiag(13) = 'UDIAG3  '
      tdiag(13) = 'User-Defined Model-Level Diagnostic  #3 '
      udiag(13) = 'user-defined    '
      gdiag(13) = 'SMR     MR      '

      cdiag(14) = 'UDIAG4  '
      tdiag(14) = 'User-Defined Model-Level Diagnostic  #4 '
      udiag(14) = 'user-defined    '
      gdiag(14) = 'SMR     MR      '

      cdiag(15) = 'UDIAG5  '
      tdiag(15) = 'User-Defined U.pt Model-Level Diag.  #5 '
      udiag(15) = 'user-defined    '
      gdiag(15) = 'SU      MR      '

      cdiag(16) = 'UDIAG6  '
      tdiag(16) = 'User-Defined V.pt Model-Level Diag.  #6 '
      udiag(16) = 'user-defined    '
      gdiag(16) = 'SV      MR      '

      cdiag(17) = 'UDIAG7  '
      tdiag(17) = 'User-Defined U.vector Model-Lev Diag.#7 '
      udiag(17) = 'user-defined    '
      gdiag(17) = 'UUR     MR      '
      hdiag(17) =  18

      cdiag(18) = 'UDIAG8  '
      tdiag(18) = 'User-Defined V.vector Model-Lev Diag.#8 '
      udiag(18) = 'user-defined    '
      gdiag(18) = 'VVR     MR      '
      hdiag(18) =  17

      cdiag(19) = 'UDIAG9  '
      tdiag(19) = 'User-Defined Phys-Level  Diagnostic  #9 '
      udiag(19) = 'user-defined    '
      gdiag(19) = 'SM      ML      '

      cdiag(20) = 'UDIAG10 '
      tdiag(20) = 'User-Defined Phys-Level  Diagnostic #10 '
      udiag(20) = 'user-defined    '
      gdiag(20) = 'SM      ML      '

      cdiag(21) = 'SDIAGC  '
      tdiag(21) = 'User-Defined Counted Surface Diagnostic '
      udiag(21) = 'user-defined    '
      gdiag(21) = 'SM  C   L1      '
      hdiag(21) =  22

      cdiag(22) = 'SDIAGCC '
      tdiag(22) = 'User-Defined Surface Diagnostic Counter '
      udiag(22) = 'count           '
      gdiag(22) = 'SM      L1      '

C-    set the total number of available diagnostics
      ndiagt = 22

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      _END_MASTER( myThid )
      _BARRIER

      RETURN
      END

#include "DIAG_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 0
C     !ROUTINE: DIAGNOSTICS_LIST_CHECK

C     !INTERFACE:
      SUBROUTINE DIAGNOSTICS_LIST_CHECK(
     O                       ndCount,
     I                       ld, md,
     I                       nbLists, nbFlds, fldsList, myThid )

C     !DESCRIPTION:
C     Check a list of fields for disable diagnostics,
C     starting with the current one:
C     print relevant error message and return the number
C     of disable diagnostics that this list contains.

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "DIAGNOSTICS_SIZE.h"
#include "DIAGNOSTICS.h"

C     !INPUT PARAMETERS:
C     ld       :: current ouput stream number
C     md       :: current field in ouput stream ld
C     nbLists  :: number of output streams
C     nbFlds(n):: number of diagnostics for output stream # n
C     fldsList :: list of field names to check
C     myThid   :: my Thread Id. number
      INTEGER ld, md, nbLists
      INTEGER nbFlds(numLists)
      CHARACTER*8 fldsList(numperList,numLists)
      INTEGER myThid
C     !OUTPUT PARAMETERS:
C     ndCount  :: number of disable diagnostics in list "fldsList"
      INTEGER ndCount
CEOP

C     !LOCAL VARIABLES:
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      LOGICAL found
      CHARACTER*8 diagName
      INTEGER n,m,m1,i

      ndCount = 0
      _BEGIN_MASTER(myThid)

C-    File names:
      m1 = md
      DO n = ld,nbLists
       DO m = m1,nbFlds(n)

        diagName = fldsList(m,n)
        found = .FALSE.
        IF ( ndCount.GT.0 ) THEN
C        Search all possible model diagnostics
         DO i=1,ndiagt
          IF ( diagName.EQ.cdiag(i) ) found = .TRUE.
         ENDDO
        ENDIF
        IF ( .NOT.found ) THEN
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
         IF ( diagName.EQ.'PRESSURE' ) THEN
           WRITE(msgBuf,'(3A)') 'DIAGNOSTICS_LIST_CHECK: diagnostic "',
     &             diagName, '" was replaced by "RCENTER "'
           CALL PRINT_ERROR( msgBuf , myThid )
           WRITE(msgBuf,'(3A)') 'DIAGNOSTICS_LIST_CHECK: ',
     &              '=> need to change "data.diagnostics" accordingly'
           CALL PRINT_ERROR( msgBuf , myThid )
           ndCount = ndCount + 1
         ENDIF
         IF ( diagName.EQ.'TICE    ' ) THEN
           WRITE(msgBuf,'(3A)') 'DIAGNOSTICS_LIST_CHECK: diagnostic "',
     &             diagName, '" was replaced by "oceFreez"'
           CALL PRINT_ERROR( msgBuf , myThid )
           WRITE(msgBuf,'(3A)') 'DIAGNOSTICS_LIST_CHECK: ',
     &              '=> need to change "data.diagnostics" accordingly'
           CALL PRINT_ERROR( msgBuf , myThid )
           ndCount = ndCount + 1
         ENDIF
         IF ( diagName.EQ.'TAUX    ' ) THEN
           WRITE(msgBuf,'(3A)') 'DIAGNOSTICS_LIST_CHECK: diagnostic "',
     &             diagName, '" was replaced by "oceTAUX "'
           CALL PRINT_ERROR( msgBuf , myThid )
           WRITE(msgBuf,'(3A)') 'DIAGNOSTICS_LIST_CHECK: ',
     &              '=> need to change "data.diagnostics" accordingly'
           CALL PRINT_ERROR( msgBuf , myThid )
           ndCount = ndCount + 1
         ENDIF
         IF ( diagName.EQ.'TAUY    ' ) THEN
           WRITE(msgBuf,'(3A)') 'DIAGNOSTICS_LIST_CHECK: diagnostic "',
     &             diagName, '" was replaced by "oceTAUY "'
           CALL PRINT_ERROR( msgBuf , myThid )
           WRITE(msgBuf,'(3A)') 'DIAGNOSTICS_LIST_CHECK: ',
     &              '=> need to change "data.diagnostics" accordingly'
           CALL PRINT_ERROR( msgBuf , myThid )
           ndCount = ndCount + 1
         ENDIF
         IF ( diagName.EQ.'SWFLUX  ' ) THEN
           WRITE(msgBuf,'(3A)') 'DIAGNOSTICS_LIST_CHECK: diagnostic "',
     &             diagName, '" was replaced by "oceQsw  "'
           CALL PRINT_ERROR( msgBuf , myThid )
           WRITE(msgBuf,'(3A)') 'DIAGNOSTICS_LIST_CHECK: ',
     &              '=> need to change "data.diagnostics" accordingly'
           CALL PRINT_ERROR( msgBuf , myThid )
           ndCount = ndCount + 1
         ENDIF
         IF ( diagName(1:5).EQ.'DIFx_' .OR.
     &        diagName(1:5).EQ.'DIFxT' ) THEN
           WRITE(msgBuf,'(5A)') 'DIAGNOSTICS_LIST_CHECK: diagnostic "',
     &             diagName, '" was replaced by "DFxE',
     &             diagName(5:8), '"'
           CALL PRINT_ERROR( msgBuf , myThid )
           WRITE(msgBuf,'(3A)') 'DIAGNOSTICS_LIST_CHECK: ',
     &              '=> need to change "data.diagnostics" accordingly'
           CALL PRINT_ERROR( msgBuf , myThid )
           ndCount = ndCount + 1
         ENDIF
         IF ( diagName(1:5).EQ.'DIFy_' .OR.
     &        diagName(1:5).EQ.'DIFyT' ) THEN
           WRITE(msgBuf,'(5A)') 'DIAGNOSTICS_LIST_CHECK: diagnostic "',
     &             diagName, '" was replaced by "DFyE',
     &             diagName(5:8), '"'
           CALL PRINT_ERROR( msgBuf , myThid )
           WRITE(msgBuf,'(3A)') 'DIAGNOSTICS_LIST_CHECK: ',
     &              '=> need to change "data.diagnostics" accordingly'
           CALL PRINT_ERROR( msgBuf , myThid )
           ndCount = ndCount + 1
         ENDIF
         IF ( diagName.EQ.'KPPmld  ' ) THEN
           WRITE(msgBuf,'(3A)') 'DIAGNOSTICS_LIST_CHECK: diagnostic "',
     &             diagName, '" was retired in favor of "MXLDEPTH"'
           CALL PRINT_ERROR( msgBuf , myThid )
           WRITE(msgBuf,'(3A)') 'DIAGNOSTICS_LIST_CHECK: ',
     &              '=> need to change "data.diagnostics" accordingly'
           CALL PRINT_ERROR( msgBuf , myThid )
           ndCount = ndCount + 1
         ENDIF
         IF ( diagName.EQ.'KPPghat ' ) THEN
           WRITE(msgBuf,'(3A)') 'DIAGNOSTICS_LIST_CHECK: diagnostic "',
     &             diagName, '" was retired in favor of "KPPghatK"'
           CALL PRINT_ERROR( msgBuf , myThid )
           WRITE(msgBuf,'(3A)') 'DIAGNOSTICS_LIST_CHECK: ',
     &              '=> need to change "data.diagnostics" accordingly'
           CALL PRINT_ERROR( msgBuf , myThid )
           ndCount = ndCount + 1
         ENDIF
         IF ( diagName.EQ.'SIyneg  ' ) THEN
           WRITE(msgBuf,'(3A)') 'DIAGNOSTICS_LIST_CHECK: diagnostic "',
     &             diagName, '" was retired in favor of "SIdHbOCN"'
           CALL PRINT_ERROR( msgBuf , myThid )
           WRITE(msgBuf,'(3A)') 'DIAGNOSTICS_LIST_CHECK: ',
     &              '=> need to change "data.diagnostics" accordingly'
           CALL PRINT_ERROR( msgBuf , myThid )
           ndCount = ndCount + 1
         ENDIF
         IF ( diagName.EQ.'SIfice  ' ) THEN
           WRITE(msgBuf,'(3A)') 'DIAGNOSTICS_LIST_CHECK: diagnostic "',
     &             diagName, '" was retired in favor of "SIdHbATC"'
           CALL PRINT_ERROR( msgBuf , myThid )
           WRITE(msgBuf,'(3A)') 'DIAGNOSTICS_LIST_CHECK: ',
     &              '=> need to change "data.diagnostics" accordingly'
           CALL PRINT_ERROR( msgBuf , myThid )
           ndCount = ndCount + 1
         ENDIF
         IF ( diagName.EQ.'SIsnwice' ) THEN
           WRITE(msgBuf,'(3A)') 'DIAGNOSTICS_LIST_CHECK: diagnostic "',
     &             diagName, '" was retired in favor of "SIdHbFLO"'
           CALL PRINT_ERROR( msgBuf , myThid )
           WRITE(msgBuf,'(3A)') 'DIAGNOSTICS_LIST_CHECK: ',
     &              '=> need to change "data.diagnostics" accordingly'
           CALL PRINT_ERROR( msgBuf , myThid )
           ndCount = ndCount + 1
         ENDIF
         IF ( diagName.EQ.'SIthdgrh' ) THEN
           WRITE(msgBuf,'(3A)') 'DIAGNOSTICS_LIST_CHECK: diagnostic "',
     &             diagName, '" was retired in favor of "SIdHb*"'
           CALL PRINT_ERROR( msgBuf , myThid )
           WRITE(msgBuf,'(3A)') 'DIAGNOSTICS_LIST_CHECK: ',
     &              '=> need to change "data.diagnostics" accordingly'
           CALL PRINT_ERROR( msgBuf , myThid )
           ndCount = ndCount + 1
         ENDIF
         IF ( diagName.EQ.'SI_FrcFx' ) THEN
           WRITE(msgBuf,'(3A)') 'DIAGNOSTICS_LIST_CHECK: diagnostic "',
     &             diagName, '" was retired (identical to "SI_Fract")'
           CALL PRINT_ERROR( msgBuf , myThid )
           WRITE(msgBuf,'(3A)') 'DIAGNOSTICS_LIST_CHECK: ',
     &              '=> need to change "data.diagnostics" accordingly'
           CALL PRINT_ERROR( msgBuf , myThid )
           ndCount = ndCount + 1
         ENDIF

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
        ENDIF
        IF ( ndCount.EQ.0 ) RETURN

       ENDDO
       m1 = 1
      ENDDO

      _END_MASTER(myThid)

      RETURN
      END

#include "EBM_OPTIONS.h"
#ifdef ALLOW_EXCH2
# include "W2_OPTIONS.h"
#endif /* ALLOW_EXCH2 */

CBOP 0
C !ROUTINE: EBM_LOAD_CLIMATOLOGY

C !INTERFACE:
      SUBROUTINE EBM_LOAD_CLIMATOLOGY( myThid )

C     !DESCRIPTION:
C     *==========================================================*
C     | S/R EBM_LOAD_CLIMATOLOGY
C     *==========================================================*

C     !USES:
      IMPLICIT NONE
C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#ifdef ALLOW_EXCH2
# include "W2_EXCH2_SIZE.h"
# include "W2_EXCH2_TOPOLOGY.h"
#endif /* ALLOW_EXCH2 */
#include "GRID.h"
#include "SET_GRID.h"
#include "FFIELDS.h"
#ifdef ALLOW_EBM
# include "EBM.h"
#endif

C     !INPUT PARAMETERS:
C     myThid     :: my Thread Id number
      INTEGER myThid
CEOP

#ifdef ALLOW_EBM
C     !LOCAL VARIABLES:
      INTEGER gridNy
      INTEGER bi,bj,i,j
      _RL distY,tauX,tauMax,lY

#ifdef ALLOW_EXCH2
      gridNy = exch2_mydNy(1)
#else /* ALLOW_EXCH2 */
      gridNy = Ny
#endif /* ALLOW_EXCH2 */

      IF ( RunoffFile .NE. ' ' ) THEN
       CALL READ_FLD_XY_RS( RunoffFile, ' ', Run, 0, myThid )
      ENDIF

      IF ( zonalWindFile .EQ. ' ' ) THEN
C      In cartesian yc, delY and ly are meters.
C      In spherical polar yc, delY and ly are degrees
       tauMax = 0.1 _d 0
       tauMax = 1.0 * 1./(delR(1)*rhonil)
       lY = 0. _d 0
       DO j=1,gridNy-1
        lY = lY + delY(j)
       ENDDO
       DO bj = myByLo(myThid), myByHi(myThid)
        DO bi = myBxLo(myThid), myBxHi(myThid)
         DO j=1,sNy
          DO i=1,sNx
c          distY = (yC(i,j,bi,bj)-(yC0))/lY
c jmc:    yC0 has been removed (not used except here,
c         and since it was not initialised, was generaly zero):
           distY = (yC(i,j,bi,bj)- 0.  )/lY
c          tauX  = -tauMax*cos(2. _d 0*PI*distY)
           tauX  = tauMax*sin(PI*distY)
           fu(i,j,bi,bj) = tauX
          ENDDO
         ENDDO
        ENDDO
       ENDDO
      ENDIF

      _EXCH_XY_RS( Run, myThid )

      IF ( plotLevel.GE.debLevC ) THEN
        CALL PLOT_FIELD_XYRS( SST, 'Theta Climatology' , 1, myThid )
        CALL PLOT_FIELD_XYRS( SSS, 'Salt  Climatology' , 1, myThid )
        CALL PLOT_FIELD_XYRS( Run, 'Runoff Climatology', 1, myThid )
        CALL PLOT_FIELD_XYRS(fu,'Wind Stress Climatology FU',1,myThid)
        CALL PLOT_FIELD_XYRS(fv,'Wind Stress Climatology FV',1,myThid)
      ENDIF

#endif /* ALLOW_EBM */

      RETURN
      END

c$Id$
      BLOCK DATA validityTestBD
C Keeps the current bounds of the validity interval
C Initial value is ]-infinity, +infinity[
      REAL gmin, gmax
      LOGICAL infmin, infmax
      COMMON /validity_test_common/ 
     +     gmin, gmax, infmin, infmax
      DATA infmin/.TRUE./
      DATA infmax/.TRUE./
      DATA gmin/-999.99/
      DATA gmax/999.99/
      END

      SUBROUTINE validity_domain_real8(t, td)
C Updates the bounds of the validity interval
C with the new constraint that t keeps its sign.
      real*8 t, td
      real gmin, gmax, temp
      logical infmin, infmax
      COMMON /validity_test_common/ 
     +     gmin, gmax, infmin, infmax

      if(td .ne. 0.0) then
       temp = -(t/td)
       if ( temp .lt. 0.0 ) then
         if ( infmin ) then
            gmin = temp
            infmin = .FALSE.
         else
            gmin = max(gmin,temp)
         endif
       else
         if ( infmax ) then
            gmax = temp
            infmax = .FALSE.
         else
            gmax = min(gmax,temp)
         endif
       endif
      endif
      end

      SUBROUTINE validity_domain_real4(t, td)
C Updates the bounds of the validity interval
C with the new constraint that t keeps its sign.
      real*4 t, td
      real gmin, gmax, temp
      logical infmin, infmax
      COMMON /validity_test_common/ 
     +     gmin, gmax, infmin, infmax

      if(td .ne. 0.0) then
       temp = -(t/td)
       if ( temp .lt. 0.0 ) then
         if ( infmin ) then
            gmin = temp
            infmin = .FALSE.
         else
            gmin = max(gmin,temp)
         endif
       else
         if ( infmax ) then
            gmax = temp
            infmax = .FALSE.
         else
            gmax = min(gmax,temp)
         endif
       endif
      endif
      end

#include "SALT_PLUME_OPTIONS.h"
#ifdef ALLOW_AUTODIFF
# include "AUTODIFF_OPTIONS.h"
#endif

CBOP
C     !ROUTINE: SALT_PLUME_CALC_DEPTH
C     !INTERFACE:
      SUBROUTINE SALT_PLUME_CALC_DEPTH(
     I                       rhoSurf, sigmaR,
     I                       bi, bj, myTime, myIter, myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R SALT_PLUME_CALC_DEPTH
C     | o Compute depth of penetration of salt plumes rejected
C     |   during sea ice growth
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "SURFACE.h"
#include "DYNVARS.h"
#include "SALT_PLUME.h"
#ifdef ALLOW_AUTODIFF_TAMC
# include "tamc.h"
#endif /* ALLOW_AUTODIFF_TAMC */

C     !INPUT/OUTPUT PARAMETERS:
C     rhoSurf   :: Surface density anomaly
C     sigmaR    :: Vertical gradient of potential density
C     bi,bj     :: tile indices
C     myTime    :: Current time in simulation
C     myIter    :: Current iteration number in simulation
C     myThid    :: my Thread Id number
      _RL     rhoSurf(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL     sigmaR (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      INTEGER bi, bj
      _RL     myTime
      INTEGER myIter
      INTEGER myThid
#ifdef ALLOW_AUTODIFF_TAMC
      INTEGER ikey, kkey
#endif
CEOP

#ifdef ALLOW_SALT_PLUME

C     !LOCAL VARIABLES:
C     i,j :: Loop counters
      INTEGER i,j,k
      _RL     rhoBigNb, tmpFac
      _RL     rhoMxL(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL     rhoKm1(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL     rhoLoc(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL     GG, GGm1
      _RL     SPIND (1-OLx:sNx+OLx,1-OLy:sNy+OLy)

#ifdef ALLOW_AUTODIFF_TAMC
      ikey = bi + (bj-1)*nSx + (ikey_dynamics-1)*nSx*nSy
#endif /* ALLOW_AUTODIFF_TAMC */

C Initializing the saltplume depth to bottom topography
      DO j=1-Oly,sNy+Oly
       DO i=1-Olx,sNx+Olx
        SaltPlumeDepth(i,j,bi,bj) = rF(1)-R_low(I,J,bi,bj)
        SPIND(i,j)  = 0. _d 0
        rhoKm1(i,j) = 0. _d 0
        rhoMxL(i,j) = 0. _d 0
       ENDDO
      ENDDO

#ifdef ALLOW_AUTODIFF_TAMC
C     suppress a warning
CADJ INCOMPLETE SaltPlumeDepth(:,:,bi,bj), SPIND
#endif
C CriterionType 1 = use delta_rho to determine salt plume depth
      IF (CriterionType.EQ.1) THEN

       rhoBigNb  = rhoConst*1. _d 10
       DO j=1-Oly,sNy+Oly
        DO i=1-Olx,sNx+Olx
         SaltPlumeDepth(i,j,bi,bj) = rF(1)-R_low(I,J,bi,bj)
         rhoKm1(i,j) = rhoSurf(i,j)
         rhoMxL(i,j) = rhoSurf(i,j) + SaltPlumeCriterion
        ENDDO
       ENDDO

       DO k = 2,Nr
#ifdef ALLOW_AUTODIFF_TAMC
          kkey = (ikey-1)*Nr + k
CADJ STORE rhoKm1(:,:) = comlev1_bibj_k,
CADJ &     key=kkey, byte=isbyte, kind = isbyte
CADJ STORE rhoMxL(:,:) = comlev1_bibj_k,
CADJ &     key=kkey, byte=isbyte, kind = isbyte
CADJ STORE theta(:,:,k,bi,bj) = comlev1_bibj_k,
CADJ &     key=kkey, byte=isbyte, kind = isbyte
CADJ STORE salt(:,:,k,bi,bj) = comlev1_bibj_k,
CADJ &     key=kkey, byte=isbyte, kind = isbyte
#endif
C-     potential density (reference level = surface level)
        CALL FIND_RHO_2D(
     I       1-OLx, sNx+OLx, 1-OLy, sNy+OLy, 1,
     I       theta(1-OLx,1-OLy,K,bi,bj), salt(1-OLx,1-OLy,K,bi,bj),
     O       rhoLoc,
     I       K, bi, bj, myThid )

        DO j=1-Oly,sNy+Oly
         DO i=1-Olx,sNx+Olx
          IF ( k.LE.klowC(i,j,bi,bj) .AND.
     &         rhoLoc(i,j).GE.rhoMxL(i,j) ) THEN
           IF ( rhoLoc(i,j).GT.rhoKm1(i,j) ) THEN
              tmpFac = ( rhoMxL(i,j) - rhoKm1(i,j) )
     &             / ( rhoLoc(i,j) - rhoKm1(i,j) )
           ELSE
              tmpFac = 0.
           ENDIF
           SaltPlumeDepth(i,j,bi,bj) = rF(1)-rC(k-1)+tmpFac*drC(k)
           rhoMxL(i,j) = rhoBigNb
          ELSE
            rhoKm1(i,j) = rhoLoc(i,j)
          ENDIF
         ENDDO
        ENDDO
       ENDDO

      ELSEIF ( CriterionType.EQ.2 ) THEN

        DO j=1-Oly,sNy+Oly
         DO i=1-Olx,sNx+Olx
          SaltPlumeDepth(i,j,bi,bj) = rF(1)-R_low(I,J,bi,bj)
          SPIND(i,j)  = 0. _d 0
         ENDDO
        ENDDO

        DO k=2,Nr
#ifdef ALLOW_AUTODIFF_TAMC
          kkey = (ikey-1)*Nr + k
CADJ STORE SPIND(:,:) = comlev1_bibj_k,
CADJ &     key=kkey, byte=isbyte, kind = isbyte
#endif
         DO j=1-Oly,sNy+Oly
          DO i=1-Olx,sNx+Olx
           GG  =-1.0*sigmaR(i,j,k)
           GGm1=-1.0*sigmaR(i,j,k-1)
           IF ( k.LE.klowC(i,j,bi,bj) .AND.
     &          GG.GE.SaltPlumeCriterion ) THEN
            IF (GGm1.LE.SaltPlumeCriterion) THEN
             tmpFac = (SaltPlumeCriterion - GGm1)
     &              / (GG                 - GGm1)
             IF(SPIND(i,j) .LT. 0.5) THEN
               SaltPlumeDepth(i,j,bi,bj) = rF(1)-rC(k-1)+tmpFac*drC(k)
               SPIND(i,j)=1.
             ENDIF
            ELSE
             tmpFac = 0.
            ENDIF
           ENDIF
          ENDDO
         ENDDO
        ENDDO

        DO j=1-Oly,sNy+Oly
         DO i=1-Olx,sNx+Olx
          SaltPlumeDepth(i,j,bi,bj) =
     &       min( SaltPlumeDepth(i,j,bi,bj)*SPovershoot,
     &            rF(1)-R_low(i,j,bi,bj) )
         ENDDO
        ENDDO
      ENDIF

C Make sure that the deepest SaltPlumeDepth is bottom topography:
      DO j=1-Oly,sNy+Oly
         DO i=1-Olx,sNx+Olx
          SaltPlumeDepth(i,j,bi,bj) =
     &       min( SaltPlumeDepth(i,j,bi,bj),
     &            rF(1)-R_low(i,j,bi,bj) )
         ENDDO
      ENDDO

C#ifdef ALLOW_DIAGNOSTICS
C      IF ( useDiagnostics )
C     &      CALL SALT_PLUME_DIAGNOSTICS_FILL(bi,bj,myThid)
C#endif /* ALLOW_DIAGNOSTICS */

#endif /* ALLOW_SALT_PLUME */

      RETURN
      END

#include "STIC_OPTIONS.h"
#ifdef ALLOW_SHELFICE
# include "SHELFICE_OPTIONS.h"
#endif
#ifdef ALLOW_AUTODIFF
# include "AUTODIFF_OPTIONS.h"
#endif
#ifdef ALLOW_CTRL
# include "CTRL_OPTIONS.h"
#endif

CBOP
C     !ROUTINE: STIC_THERMODYNAMICS
C     !INTERFACE:
      SUBROUTINE STIC_THERMODYNAMICS(
     I                        myTime, myIter, myThid )
C     !DESCRIPTION: \bv
C     *=============================================================*
C     | S/R  STIC_THERMODYNAMICS
C     | o shelf-ice main routine.
C     |   compute temperature and (virtual) salt flux at the
C     |   shelf-ice ocean interface
C     |
C     | stresses at the ice/water interface are computed in separate
C     | routines that are called from mom_fluxform/mom_vecinv
C     |
CIGF  | ASSUMES
C---  |   * SHELFICEconserve = true
C     *=============================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "EOS.h"
#include "GRID.h"
#include "DYNVARS.h"
#include "FFIELDS.h"
#ifdef ALLOW_SHELFICE
# include "SHELFICE.h"
# include "SHELFICE_COST.h"
#endif
#include "STIC.h"
#ifdef ALLOW_CTRL
# include "CTRL_SIZE.h"
# include "CTRL.h"
# include "CTRL_DUMMY.h"
# ifdef ALLOW_GENTIM2D_CONTROL
#  include "CTRL_GENARR.h"
# endif
#endif /* ALLOW_CTRL */
#ifdef ALLOW_AUTODIFF_TAMC
# include "tamc.h"
#endif /* ALLOW_AUTODIFF_TAMC */

C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
C     myTime :: time counter for this thread
C     myIter :: iteration counter for this thread
C     myThid :: thread number for this instance of the routine.
      _RL  myTime
      INTEGER myIter
      INTEGER myThid

C     !LOCAL VARIABLES :
C     === Local variables ===
C     i,j,k,bi,bj      :: loop counters
C     tLoc, sLoc, pLoc :: local potential temperature, salinity, pressure
C     gammaT/SLoc      :: local heat and salt transfer coefficients
C     theta/saltFreeze :: temperature and salinity of water at the
C                         ice-ocean interface (at the freezing point)
C     iceFrontCellThickness   :: the ratio of the grid cell area to
C                         the horizontal length of the ice front.
C                         unit meters.  Approximately the length of the
C                         column perpendicular to the ice front extended
C                         to the far side of the tracer cell.
C     iceFrontWidth    :: the width of the ice front.  unit meters.

      INTEGER i, j, k
      INTEGER bi, bj
      INTEGER CURI, CURJ, FRONT_K

      _RL tLoc
      _RL sLoc
      _RL pLoc
      _RL gammaTLoc
      _RL gammaSLoc

      _RL ice_bottom_Z_C
      _RL wet_top_Z_N, wet_bottom_Z_N
      _RL iceFrontWetContact_Z_max
      _RL iceFrontVertContactFrac, iceFrontCellThickness
      _RL iceFrontWidth, iceFrontFaceArea
      _RL thermalConductionDistance, thermalConductionTemp
      _RL tmpHeatFlux, tmpFWFLX
      _RL tmpForcingT, tmpForcingS
      _RL tmpFac, icfgridareaFrac
      _RL tmpHeatFluxscaled, tmpFWFLXscaled
      INTEGER SI
      _RL insituT

#ifdef ALLOW_DIAGNOSTICS
# ifdef SHI_ALLOW_GAMMAFRICT
      _RL uStarDiag(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
# endif
#ifdef NONLIN_FRSURF
      _RL tmpDiag(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      _RL tmpDiagT(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
#endif
      _RL tmpDiagIcfForcingT(1-OLx:sNx+OLx,
     & 1-OLy:sNy+OLy,Nr,nSx,nSy)
      _RL tmpDiagIcfForcingS(1-OLx:sNx+OLx,
     & 1-OLy:sNy+OLy,Nr,nSx,nSy)
      _RL tmpDiagShelficeForcingT(1-OLx:sNx+OLx,
     & 1-OLy:sNy+OLy,nSx,nSy)
      _RL tmpDiagShelficeForcingS(1-OLx:sNx+OLx,
     & 1-OLy:sNy+OLy,nSx,nSy)
#endif /* ALLOW_DIAGNOSTICS */

      _RL epsilon_H
      _RL stic_addMass(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)

#ifdef ALLOW_GENTIM2D_CONTROL
      INTEGER iarr
      _RL xx_shifwflx_loc(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
#endif

#ifdef ALLOW_AUTODIFF_TAMC
C     tkey :: tape key (depends on tiles)
C     ikey :: tape key (depends on ij-indices and tiles)
C     kkey :: tape key (depends on levels, ij-indices, and tiles)
      INTEGER tkey, ikey, kkey
#endif

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE kTopC          = comlev1, key = ikey_dynamics
#endif

C--   minimum fraction of a cell adjacent to an ice front that must be
C--   wet for exchange to happen
      epsilon_H = 1. _d -03

C--   hard coded for now.
      thermalConductionDistance = 100.0 _d 0
      thermalConductionTemp     = -20.0 _d 0
      icfgridareaFrac = 1.0 _d 0
      insituT = 0. _d 0

C     heat flux into the ice shelf, default is diffusive flux
C     (Holland and Jenkins, 1999, eq.21)

      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
        DO j = 1-OLy,sNy+OLy
         DO i = 1-OLx,sNx+OLx
          shelfIceHeatFlux        (i,j,bi,bj) = 0. _d 0
          shelfIceFreshWaterFlux  (i,j,bi,bj) = 0. _d 0
          sticfHeatFlux           (i,j,bi,bj) = 0. _d 0
          sticfFreshWaterFlux     (i,j,bi,bj) = 0. _d 0
#ifdef ALLOW_GENTIM2D_CONTROL
          xx_shifwflx_loc         (i,j,bi,bj) = 0. _d 0
#endif /* ALLOW_GENTIM2D_CONTROL */
#ifndef ALLOW_SHITRANSCOEFF_3D
          shiTransCoeffS(i,j,bi,bj) = SHELFICEsaltToHeatRatio *
     &         shiTransCoeffT(i,j,bi,bj)
#endif
         ENDDO
        ENDDO
        DO k = 1, Nr
         DO j = 1-OLy,sNy+OLy
          DO i = 1-OLx,sNx+OLx
#ifdef ALLOW_SHITRANSCOEFF_3D
           shiTransCoeffS3d(i,j,k,bi,bj) = SHELFICEsaltToHeatRatio *
     &          shiTransCoeffT3d(i,j,k,bi,bj)
#endif
           icfHeatFlux(i,j,k,bi,bj)       = 0. _d 0
           icfFreshWaterFlux(i,j,k,bi,bj) = 0. _d 0
           stic_gT(i,j,k,bi,bj)           = 0. _d 0
           stic_gS(i,j,k,bi,bj)           = 0. _d 0
           stic_addMass(i,j,k,bi,bj)      = 0. _d 0
          ENDDO
         ENDDO
        ENDDO
#ifdef ALLOW_DIAGNOSTICS
        IF ( useDiagnostics ) THEN
         DO j = 1-OLy,sNy+OLy
          DO i = 1-OLx,sNx+OLx
           tmpDiagShelficeForcingT(i,j,bi,bj) = 0. _d 0
           tmpDiagShelficeForcingS(i,j,bi,bj) = 0. _d 0
          ENDDO
         ENDDO
         DO k = 1, Nr
          DO j = 1-OLy,sNy+OLy
           DO i = 1-OLx,sNx+OLx
            tmpDiagIcfForcingT(i,j,k,bi,bj) = 0. _d 0
            tmpDiagIcfForcingS(i,j,k,bi,bj) = 0. _d 0
#ifdef NONLIN_FRSURF
            tmpDiag           (i,j,k,bi,bj) = 0. _d 0
            tmpDiagT          (i,j,k,bi,bj) = 0. _d 0
#endif
           ENDDO
          ENDDO
         ENDDO
        ENDIF
#endif /* ALLOW_DIAGNOSTICS */
       ENDDO
      ENDDO

#if (defined ALLOW_CTRL && defined ALLOW_GENTIM2D_CONTROL)
      IF ( useCTRL ) THEN
       DO iarr = 1, maxCtrlTim2D
        IF (xx_gentim2d_file(iarr)(1:11).EQ.'xx_shifwflx') THEN
         DO bj = myByLo(myThid),myByHi(myThid)
          DO bi = myBxLo(myThid),myBxHi(myThid)
           DO j = 1,sNy
            DO i = 1,sNx
             xx_shifwflx_loc(i,j,bi,bj)=xx_gentim2d(i,j,bi,bj,iarr)
            ENDDO
           ENDDO
          ENDDO
         ENDDO
        ENDIF
       ENDDO
      ENDIF
#endif

      DO bj = myByLo(myThid), myByHi(myThid)
        DO bi = myBxLo(myThid), myBxHi(myThid)
#ifdef ALLOW_AUTODIFF_TAMC
          tkey = bi + (bj-1)*nSx + (ikey_dynamics-1)*nSx*nSy
#endif
C--   First ice front then ice shelf.  Loop through each i,j point
C--   process ice fronts in k, then process ice shelf.
          DO j = 1-OLy+1,sNy+OLy-1
            DO i = 1-OLx+1,sNx+OLx-1

#ifdef ALLOW_AUTODIFF_TAMC
              ikey = i + OLx + (j+OLy-1)*(sNx+2*OLx)
     &             + (tkey-1)*(sNx+2*OLx)*(sNy+2*OLy)
#endif

C--   The K index where the ice front ends (0 if no ice front)
              FRONT_K = kIcf(i,j,bi,bj)

C--   If there is an ice front at this (i,j) continue
              IF (FRONT_K .GT. 0) THEN

C--   Loop through all depths where the ice front is fround
                DO k = 1, FRONT_K
C--   Loop around the four laterally neighboring cells of the ice front.
C--   If any neighboring points has wet volume in contact with the ice
C--   front at (i,j) then calculate ice-ocean exchanges.
C--   The four laterally neighboring point are at (CURI,CURJ)

                  DO SI = 1,4
                    CURI=CURI_ARR(i,j,bi,bj,SI)
                    CURJ=CURJ_ARR(i,j,bi,bj,SI)
                    iceFrontWidth=sticfWidth_arr(i,j,bi,bj,SI)

C--                 cell depth describes the average distance
C--                 perpendicular to the ice front fact

                    iceFrontCellThickness = 0. _d 0
                    IF(iceFrontWidth.NE.0. _d 0)
     &                iceFrontCellThickness = RA(CURI,CURJ,bi,bj)
     &                                  /iceFrontWidth
                    iceFrontFaceArea  = drF(k)*iceFrontWidth

C--   First, make sure the adjacent point has at least some water in it.
                    IF (_hFacC(CURI,CURJ,k,bi,bj) .GT. zeroRL) THEN

C--   we need to determine how much of the ice front is in contact with
C--   water in the neighboring grid cell at this depth level.

C--   1. Determine the top depth with water in the current cell
C--   2. Determine the top depth with water in the neighbor cell
C--   3. Determine the depth where water  gap between (1) and (2).
C--   4. If there is a gap then ice front is in contact with water in
C--      the neighboring cell

C--   ice_bottom_Z_C: the depth (m) of the bottom of the ice in the
C--               current cell.  Bounded between rF(k) and rF(k+1).
C--               * If the ice extends past the bottom of the cell then
C--                 ice_bottom_Z_C = rF(k+1)
C--               [rF(k) >= ice_bottom_Z_C >= rF(k+1)]  (rF is negative)
                      ice_bottom_Z_C = max(rF(k+1),
     &                  min(Ro_surf(i,j, bi,bj), rF(k)))

C--   wet_top_Z_N: the depth (m) of the bottom of the ice in the
C--              neighboring grid.  If the neighboring cell has ice in
C--              (in the form of a shelf or front) then wet_top_Z_N is
C--              the depth of this neighboring ice.
C--
C--              * If neighbor cell has no ice, then Ro_surf = 0 and
C--                wet_top_Z_N = rF(k)
C--              [rF(k) >= wet_top_Z_N >= rF(k+1)]     (rF is negative)

                      wet_top_Z_N = max(rF(k+1),
     &                 min(Ro_surf(CURI,CURJ, bi,bj), rF(k)))

C--   wet_bottom_Z_N: the depth (m) of the bottom of the wet part of the
C--              neighboring cell.  If the seafloor reaches into
C--              the grid cell then the bottom of the wet part of the
C--              grid cell is at the seafloor.
C--
C--              * If the seafloor is deeper than this grid cell then
C--                wet_bottom_Z = rF(k+1)
C--              * If the seafloor is shallower than this grid cell then
C--                wet_bottom_Z = rF(k)
C--              * If the seafloor reaches partly into this grid cell
C--                then wet_bottom_Z = R_low

C--              [rF(k) >= wet_bottom_Z >= rF(k+1)]     (rF is negative)

                      wet_bottom_Z_N = min(rF(k),
     &                  max(R_low(CURI,CURJ, bi,bj), rF(k+1)))

C--   iceFrontWetContact_Z_max:  The deepest point where the
C--              the ice front at (i,j) is in contact with water
C--              in the neighboring cell.  The shallower of
C--              wet_bottom_Z_N (seafloor depth of neighboring point) and
C--              ice_bottom_Z_C (bottom of ice front in this center cell).

C--              * wet_bottom_Z_N if the seafloor of the neighboring
C--                cell is shallower than the ice draft at (i,j).
C--              * ice_bottom_Z_C if the ice draft at (i,j) is shallower
C--                than the seafloor of the neighboring cell.

                      IF (ice_bottom_Z_C .GT. wet_bottom_Z_N) THEN
                        iceFrontWetContact_Z_max = ice_bottom_Z_C
                      ELSE
                        iceFrontWetContact_Z_max = wet_bottom_Z_N
                      ENDIF

C--   The shallowest depth where the ice front at (i,j) is in contact
C--   with water in the neighboring cell.  If the neighboring cell has
C--   no ice draft then wet_top_Z_N = rF(k), the top of the cell.
C--   Otherwise, the shallowest depth where the ice front at (i,j) can
C--   be in in contact with water (not ice) in (CURI, CURJ)
C--   is wet_top_Z_N.

C--   the fraction of the grid cell height that has ice draft in contact
C--   with water in the neighboring cell.
                      iceFrontVertContactFrac =
     &                  (wet_top_Z_N - iceFrontWetContact_Z_max)/ drF(k)

C--   Only proceed if iceFrontVertContactFrac is > 0, the
C--   ice draft at (i,j)
C--   is in contact with some water in the neighboring grid cell.
                      IF (iceFrontVertContactFrac .GT. epsilon_H) THEN
                        tLoc = theta(CURI,CURJ,k,bi,bj)
                        sLoc = MAX(salt(CURI,CURJ,k,bi,bj), zeroRL)

C--   use pressure at the halfway point between the top and bottom of
C--   points of the ice front where the ice front is in contact with
C--   open water.
                        pLoc = 0.5 _d 0 * ABS(wet_top_Z_N +
     &                    iceFrontWetContact_Z_max)
#ifdef ALLOW_SHITRANSCOEFF_3D
                        gammaTLoc = shiTransCoeffT3d(CURI,CURJ,k,bi,bj)
                        gammaSLoc = shiTransCoeffS3d(CURI,CURJ,k,bi,bj)
#else
                        gammaTLoc = shiTransCoeffT(CURI,CURJ,bi,bj)
                        gammaSLoc = shiTransCoeffS(CURI,CURJ,bi,bj)
#endif

                        CALL STIC_SOLVE4FLUXES(
     I                    tLoc, sLoc, pLoc,
     I                    gammaTLoc, gammaSLoc,
     I                    thermalConductionDistance,
     I                    thermalConductionTemp,
     O                    tmpHeatFlux, tmpFWFLX,
     O                    tmpForcingT, tmpForcingS,
     O                    insituT,
     I                    bi, bj, myTime, myIter, myThid )
#ifdef ALLOW_AUTODIFF_TAMC
                        kkey = k + (ikey-1)*Nr
CADJ STORE tmpForcingT, tmpForcingS = comlev1_stic_bibj_ijk, key = kkey
#endif
C--   fluxes and forcing must be scaled by iceFrontVertContactFract and
C--   iceFrontContactFrac some fraction of the heigth and width of the
C--   grid cell face may not ice in contact with water.

C     tmpHeatFlux and tmpFWFLX come as W/m^2 and kg/m^2/s respectively
C--   but these rates only apply to the
C--   fraction of the grid cell that has ice in contact with seawater.
C--   we must scale by iceFrontVertContactFrac to get to the average
C--   fluxes in this grid cell.
C--   We also further scale by ratio of vertical to horizontal grid
C--   cell area so when comparing ice-front flux to ice-shelf flux we
C--   can just times them by the same area, i.e. horizontal grid cell area.

C--   ratio of vertical area to horizontal grid cell area
                        icfgridareaFrac =
     &                   iceFrontFaceArea/RA(CURI,CURJ,bi,bj)

C--   In units W/m^2
                        tmpHeatFluxscaled =
     &                    tmpHeatFlux*iceFrontVertContactFrac
     &                    *icfgridareaFrac
                        icfHeatFlux(CURI,CURJ,k,bi,bj) =
     &                    icfHeatFlux(CURI,CURJ,k,bi,bj) +
     &                    tmpHeatFluxscaled

C     In units of kg/s/m^2
                        tmpFWFLXscaled =
     &                    tmpFWFLX*iceFrontVertContactFrac
     &                    *icfgridareaFrac
                        icfFreshWaterFlux(CURI,CURJ,k,bi,bj) =
     &                    icfFreshWaterFlux(CURI,CURJ,k,bi,bj) +
     &                    tmpFWFLXscaled

C ow - 06/29/2018
C ow - Verticallly sum up the 3D icefront heat and freshwater fluxes to
C ow -  compute the total flux for the water column. The shelfice fluxes,
C ow -  which are 2D, will be added later. NOTE that only
C ow -  ice-front melts below shelf-ice are included to be consistent
C ow -  with Rignot's data
                  if(k.GE.kTopC(i,j,bi,bj))then
                   if(RA(CURI,CURJ,bi,bj).NE.0. _d 0)then
                        sticfHeatFlux(CURI,CURJ,bi,bj) =
     &                   sticfHeatFlux(CURI,CURJ,bi,bj) +
     &                   tmpHeatFluxscaled
                        sticfFreshWaterFlux(CURI,CURJ,bi,bj) =
     &                   sticfFreshWaterFlux(CURI,CURJ,bi,bj) +
     &                   tmpFWFLXscaled
                   endif
                  endif
C     stic_g[T,S] are tendency contributions due to ice front melt,
C--   but these constributions only apply to the
C--   fraction of the grid cell that has ice in contact with seawater.
C--   we must scale by iceFrontVertContactFrac to get to the average
C--   fluxes in this grid cell.  We must also divide the by the length
C--   of the grid cell perpendicular to the face.

                       IF (iceFrontCellThickness .NE. 0. _d 0) THEN
C     In units of K / s
                        stic_gT(CURI,CURJ,k,bi,bj) =
     &                    stic_gT(CURI,CURJ,k,bi,bj) +
     &                    tmpForcingT/iceFrontCellThickness*
     &                    iceFrontVertContactFrac*
     &                    _recip_hFacC(CURI,CURJ,k,bi,bj)
C     In units of psu /s
                        stic_gS(CURI,CURJ,k,bi,bj) =
     &                    stic_gS(CURI,CURJ,k,bi,bj) +
     &                    tmpForcingS/iceFrontCellThickness*
     &                    iceFrontVertContactFrac*
     &                    _recip_hFacC(CURI,CURJ,k,bi,bj)
#ifdef ALLOW_DIAGNOSTICS
                        IF ( useDiagnostics ) THEN
                         tmpDiagIcfForcingT(CURI,CURJ,k,bi,bj) =
     &                     tmpDiagIcfForcingT(CURI,CURJ,k,bi,bj) +
     &                     tmpForcingT/iceFrontCellThickness*
     &                     iceFrontVertContactFrac*
     &                     drF(k)
                         tmpDiagIcfForcingS(CURI,CURJ,k,bi,bj) =
     &                     tmpDiagIcfForcingS(CURI,CURJ,k,bi,bj) +
     &                     tmpForcingS/iceFrontCellThickness*
     &                     iceFrontVertContactFrac*
     &                     drF(k)
                        ENDIF
#endif /* ALLOW_DIAGNOSTICS */
                       ENDIF /* iceFrontCellThickness */
C     In units of kg /s
                         stic_addMass(CURI,CURJ,k,bi,bj) =
     &                     stic_addMass(CURI,CURJ,k,bi,bj) -
     &                     tmpFWFLX*iceFrontFaceArea*
     &                     iceFrontVertContactFrac
#ifdef ALLOW_DIAGNOSTICS
                       IF ( useDiagnostics ) THEN
#ifdef NONLIN_FRSURF
                        IF ( (nonlinFreeSurf.GT.0 .OR. usingPCoords)
     &                   .AND. useRealFreshWaterFlux ) THEN
                         tmpDiagT(CURI,CURJ,k,bi,bj) =
     &                     stic_addMass(CURI,CURJ,k, bi,bj)/
     &                     RA(CURI,CURJ,bi,bj)*
     &                     insituT*HeatCapacity_Cp
                        ENDIF
#endif /* NONLIN_FRSURF */
                       ENDIF
#endif /* ALLOW_DIAGNOSTICS */
                      ENDIF /* iceFrontVertContactFrac */
                    ENDIF /* hFacC(CURI,CURJ,k,bi,bj) */
                  ENDDO /* SI loop for adjacent cells */
                ENDDO /* k Loop */
              ENDIF /* FRONT_K */

C--   ice shelf
              k = kTopC(i,j,bi,bj)

C--   If there is an ice front at this (i,j) continue
C--   I am assuming K is only .GT. when there is at least some
C--   nonzero wet point below the shelf in the grid cell.
              IF (k .GT. 0) THEN
C--   Initialize these values to zero
                pLoc = 0. _d 0
                tLoc = 0. _d 0
                sLoc = 0. _d 0
                gammaTLoc = 0. _d 0
                gammaSLoc = 0. _d 0

C--   make local copies of temperature, salinity and depth
C--   (pressure in deci-bar) underneath the ice
C--   for the ice shelf case we use hydrostatic pressure at the ice
C--   base of the ice shelf, top of the cavity.

                pLoc = ABS(R_shelfIce(i,j,bi,bj))
                tLoc = theta(i,j,k,bi,bj)
                sLoc = MAX(salt(i,j,k,bi,bj), zeroRL)
#ifdef ALLOW_SHITRANSCOEFF_3D
                gammaTLoc = shiTransCoeffT3d(i,j,k,bi,bj)
                gammaSLoc = shiTransCoeffS3d(i,j,k,bi,bj)
#else
                gammaTLoc = shiTransCoeffT(i,j,bi,bj)
                gammaSLoc = shiTransCoeffS(i,j,bi,bj)
#endif
                CALL STIC_SOLVE4FLUXES(
     I            tLoc, sLoc, pLoc,
     I            gammaTLoc, gammaSLoc,
     I            pLoc, thermalConductionTemp,
     O            tmpHeatFlux, tmpFWFLX,
     O            tmpForcingT, tmpForcingS,
     O            insituT,
     I            bi, bj, myTime, myIter, myThid )
C     In units of W/m^2
                shelficeHeatFlux(i,j,bi,bj) = tmpHeatFlux
#ifdef ALLOW_GENTIM2D_CONTROL
     &           - xx_shifwflx_loc(i,j,bi,bj)*SHELFICElatentHeat
#endif /*  ALLOW_GENTIM2D_CONTROL */
C     In units of kg/m^2/s
                shelfIceFreshWaterFlux(i,j,bi,bj) = tmpFWFLX
#ifdef ALLOW_GENTIM2D_CONTROL
     &           + xx_shifwflx_loc(i,j,bi,bj)
#endif /*  ALLOW_GENTIM2D_CONTROL */
C ow - 06/29/2018
C ow - Now add shelfice heat and freshwater fluxes
                        sticfHeatFlux(i,j,bi,bj) =
     &                   sticfHeatFlux(i,j,bi,bj) +
     &                   shelficeHeatFlux(i,j,bi,bj)
                        sticfFreshWaterFlux(i,j,bi,bj) =
     &                   sticfFreshWaterFlux(i,j,bi,bj) +
     &                   shelfIceFreshWaterFlux(i,j,bi,bj)
C     In units of K/s
                stic_gT(i,j,k,bi,bj) = stic_gT(i,j,k,bi,bj) +
     &              tmpForcingT*recip_drF(k)* _recip_hFacC(i,j,k,bi,bj)
C     In units of psu/s
                stic_gS(i,j,k,bi,bj) = stic_gS(i,j,k,bi,bj) +
     &              tmpForcingS*recip_drF(k)* _recip_hFacC(i,j,k,bi,bj)
C     In units of kg/s  -- multiplication of area required first
                stic_addMass(i,j,k,bi,bj) = stic_addMass(i,j,k,bi,bj) -
     &              tmpFWFLX*RA(i,j,bi,bj)
#ifdef ALLOW_DIAGNOSTICS
                IF ( useDiagnostics ) THEN
                 tmpDiagShelficeForcingT(i,j,bi,bj) = tmpForcingT
                 tmpDiagShelficeForcingS(i,j,bi,bj) = tmpForcingS
#ifdef NONLIN_FRSURF
                 IF ( (nonlinFreeSurf.GT.0 .OR. usingPCoords)
     &            .AND. useRealFreshWaterFlux ) THEN
                  tmpDiagT(i,j,k,bi,bj) =
     &                 stic_addMass(i,j,k,bi,bj) / rA(i,j,bi,bj)*
     &                 insituT*HeatCapacity_Cp
                 ENDIF
#endif /* NONLIN_FRSURF */
                ENDIF
#endif /* ALLOW_DIAGNOSTICS */
              ENDIF /* Shelf k > 0 */
            ENDDO /* i */
          ENDDO /* j */
        ENDDO /* bi */
      ENDDO /* bj */

      DO bj = myByLo(myThid), myByHi(myThid)
        DO bi = myBxLo(myThid), myBxHi(myThid)
          DO j = 1-OLy+1,sNy+OLy-1
            DO i = 1-OLx+1,sNx+OLx-1
              DO k = 1,Nr
                 addMass(i,j,k,bi,bj) = addMass(i,j,k,bi,bj) +
     &               stic_addMass(i,j,k,bi,bj)
              ENDDO /* k */
            ENDDO /* i */
          ENDDO /* j */
        ENDDO /* bi */
      ENDDO /* bj */

#ifdef ALLOW_ADDFLUID
      IF ( selectAddFluid.NE.0 .AND. salt_addMass.NE.UNSET_RL ) THEN
        IF ( ( selectAddFluid.GE.1 .AND. nonlinFreeSurf.GT.0 )
     &       .OR. convertFW2Salt.EQ.-1. _d 0 ) THEN
          DO bj = myByLo(myThid), myByHi(myThid)
            DO bi = myBxLo(myThid), myBxHi(myThid)
              DO j=0,sNy+1
                DO i=0,sNx+1
                  DO k=1,Nr
                    stic_gT(i,j,k,bi,bj) = stic_gT(i,j,k,bi,bj)
     &                - stic_addMass(i,j,k,bi,bj)*mass2rUnit
     &                  *( temp_addMass - theta(i,j,k,bi,bj) )
     &                  *recip_rA(i,j,bi,bj)
     &                  *recip_drF(k)*_recip_hFacC(i,j,k,bi,bj)
C    &                  *recip_deepFac2C(k)*recip_rhoFacC(k)
                    stic_gS(i,j,k,bi,bj) = stic_gS(i,j,k,bi,bj)
     &                - stic_addMass(i,j,k,bi,bj)*mass2rUnit
     &                  *( salt_addMass - salt(i,j,k,bi,bj) )
     &                  *recip_rA(i,j,bi,bj)
     &                  *recip_drF(k)*_recip_hFacC(i,j,k,bi,bj)
C    &                  *recip_deepFac2C(k)*recip_rhoFacC(k)
                  ENDDO /* k */
                ENDDO /* i */
              ENDDO /* j */
            ENDDO /* bi */
          ENDDO /* bj */
        ELSE
          DO bj = myByLo(myThid), myByHi(myThid)
            DO bi = myBxLo(myThid), myBxHi(myThid)
              DO j=0,sNy+1
                DO i=0,sNx+1
                  DO k=1,Nr
                    stic_gT(i,j,k,bi,bj) = stic_gT(i,j,k,bi,bj)
     &                - stic_addMass(i,j,k,bi,bj)*mass2rUnit
     &                  *( temp_addMass - tRef(k) )
     &                  *recip_rA(i,j,bi,bj)
     &                  *recip_drF(k)*_recip_hFacC(i,j,k,bi,bj)
C    &                  *recip_deepFac2C(k)*recip_rhoFacC(k)
                    stic_gS(i,j,k,bi,bj) = stic_gS(i,j,k,bi,bj)
     &                - stic_addMass(i,j,k,bi,bj)*mass2rUnit
     &                  *( salt_addMass - sRef(k) )
     &                  *recip_rA(i,j,bi,bj)
     &                  *recip_drF(k)*_recip_hFacC(i,j,k,bi,bj)
C    &                  *recip_deepFac2C(k)*recip_rhoFacC(k)
                  ENDDO /* k */
                ENDDO /* i */
              ENDDO /* j */
            ENDDO /* bi */
          ENDDO /* bj */
        ENDIF
      ENDIF
#endif /* ALLOW_ADDFLUID */

C--  Calculate new loading anomaly (in case the ice-shelf mass was updated)
#ifndef ALLOW_AUTODIFF
c     IF ( SHELFICEloadAnomalyFile .EQ. ' ' ) THEN
       DO bj = myByLo(myThid), myByHi(myThid)
        DO bi = myBxLo(myThid), myBxHi(myThid)
         DO j = 1-OLy, sNy+OLy
          DO i = 1-OLx, sNx+OLx
           shelficeLoadAnomaly(i,j,bi,bj) = gravity
     &      *( shelficeMass(i,j,bi,bj) + rhoConst*Ro_surf(i,j,bi,bj) )
          ENDDO
         ENDDO
        ENDDO
       ENDDO
c     ENDIF
#endif /* ndef ALLOW_AUTODIFF */

#ifdef ALLOW_DIAGNOSTICS
      IF ( useDiagnostics ) THEN

#ifdef NONLIN_FRSURF
       IF ( (nonlinFreeSurf.GT.0 .OR. usingPCoords)
     &         .AND. useRealFreshWaterFlux ) THEN
        DO bj = myByLo(myThid), myByHi(myThid)
         DO bi = myBxLo(myThid), myBxHi(myThid)
          DO k = 1, Nr
           DO j=1,sNy
            DO i=1,sNx
             tmpDiag(i,j,k,bi,bj) =
     &        stic_addMass(i,j,k,bi,bj)/RA(i,j,bi,bj)*
     &        theta(i,j,k,bi,bj)*HeatCapacity_Cp
            ENDDO
           ENDDO
          ENDDO
         ENDDO /* bi */
        ENDDO /* bj */
        CALL DIAGNOSTICS_FILL( tmpDiag,'TFLUXMLT',0,Nr,0,1,1,myThid )

        DO bj = myByLo(myThid), myByHi(myThid)
         DO bi = myBxLo(myThid), myBxHi(myThid)
          DO k = 1, Nr
           DO j=1,sNy
            DO i=1,sNx
             tmpDiag(i,j,k,bi,bj) =
     &        stic_addMass(i,j,k,bi,bj)/RA(i,j,bi,bj)*salt(i,j,k,bi,bj)
            ENDDO
           ENDDO
          ENDDO
         ENDDO /* bi */
        ENDDO /* bj */
        CALL DIAGNOSTICS_FILL( tmpDiag,'SFLUXMLT',0,Nr,0,1,1,myThid )

        CALL DIAGNOSTICS_FILL( tmpDiagT,'TFLUXMTI',0,Nr,0,1,1,myThid )
       ENDIF
#endif /* NONLIN_FRSURF */

       CALL DIAGNOSTICS_FILL_RS(shelfIceFreshWaterFlux,'SHIfwFlx',
     &      0,1,0,1,1,myThid)
       CALL DIAGNOSTICS_FILL_RS(shelfIceHeatFlux,      'SHIhtFlx',
     &      0,1,0,1,1,myThid)

#ifdef ALLOW_STEEP_ICECAVITY
       CALL DIAGNOSTICS_FILL( sticfFreshWaterFlux, 'SHIICFfw',
     &      0,1,0,1,1,myThid)
       CALL DIAGNOSTICS_FILL( sticfHeatFlux,       'SHIICFht',
     &      0,1,0,1,1,myThid)
#endif

        CALL DIAGNOSTICS_FILL(icfFreshWaterFlux, 'STCfwFlx',
     &      0,Nr,0,1,1,myThid)
        CALL DIAGNOSTICS_FILL(icfHeatFlux, 'STChtFlx',
     &      0,Nr,0,1,1,myThid)

C     SHIForcT (Ice shelf forcing for theta [W/m2], >0 increases theta)
       tmpFac = HeatCapacity_Cp*rUnit2mass
       CALL DIAGNOSTICS_SCALE_FILL(tmpDiagShelficeForcingT,tmpFac,1,
     &      'SHIForcT',0,1,0,1,1,myThid)
C     SHIForcS (Ice shelf forcing for salt [g/m2/s], >0 increases salt)
       tmpFac = rUnit2mass
       CALL DIAGNOSTICS_SCALE_FILL(tmpDiagShelficeForcingS,tmpFac,1,
     &      'SHIForcS',0,1,0,1,1,myThid)

C     STCForcT (Ice front forcing for theta [W/m2], >0 increases theta)
       tmpFac = HeatCapacity_Cp*rUnit2mass
       CALL DIAGNOSTICS_SCALE_FILL(tmpDiagIcfForcingT,tmpFac,1,
     &      'STCForcT',0,Nr,0,1,1,myThid)
C     STCForcS (Ice front forcing for salt [g/m2/s], >0 increases salt)
       tmpFac = rUnit2mass
       CALL DIAGNOSTICS_SCALE_FILL(tmpDiagIcfForcingS,tmpFac,1,
     &      'STCForcS',0,Nr,0,1,1,myThid)

C     Transfer coefficients
#ifdef ALLOW_SHITRANSCOEFF_3D
       CALL DIAGNOSTICS_FILL(shiTransCoeffT3d,'SHIgam3T',
     &      0,Nr,0,1,1,myThid)
       CALL DIAGNOSTICS_FILL(shiTransCoeffS3d,'SHIgam3S',
     &      0,Nr,0,1,1,myThid)
#else
       CALL DIAGNOSTICS_FILL(shiTransCoeffT,'SHIgammT',
     &      0,1,0,1,1,myThid)
       CALL DIAGNOSTICS_FILL(shiTransCoeffS,'SHIgammS',
     &      0,1,0,1,1,myThid)
#endif
C     Friction velocity
#ifdef SHI_ALLOW_GAMMAFRICT
       IF ( SHELFICEuseGammaFrict )
     &  CALL DIAGNOSTICS_FILL(uStarDiag,'SHIuStar',0,1,0,1,1,myThid)
#endif /* SHI_ALLOW_GAMMAFRICT */

      ENDIF
#endif /* ALLOW_DIAGNOSTICS */

      RETURN
      END

#include "MDSIO_OPTIONS.h"

CBOP
C     !ROUTINE: MDS_WRITE_WHALOS
C     !INTERFACE:
      SUBROUTINE MDS_WRITE_WHALOS(
     I                    fName,
     I                    len,
     I                    filePrec,
     I                    fid,
     I                    n2d,
     I                    fldRL,
     I                    irec,
     I                    locSingleCPUIO,
     I                    locBufferIO,
     I                    myThid )

C     !DESCRIPTION: \bv
C     ==================================================================
C     SUBROUTINE MDS_WRITE_WHALOS
C     o Write file that includes halos. The main purpose is for
C       adjoint related "tape I/O". The secondary purpose is debugging.
C     ==================================================================
C     \ev

C     !USES:
      IMPLICIT NONE

C     == global variables ==
#include "EEPARAMS.h"
#include "SIZE.h"
#include "PARAMS.h"
#ifdef ALLOW_WHIO
# include "MDSIO_BUFF_WH.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     fName    ::  extended tape fName.
C     len      ::  number of characters in fName.
C     filePrec ::  number of bits per word in file (32 or 64).
C     fid      ::  file unit (its use is not implemented yet).
C     n2d      ::  size of the fldRL third dimension.
C     fldRL    ::  array to read.
C     irec     ::  record number to be written.
C     myThid   ::  my Thread Id number
      CHARACTER*(*) fName
      INTEGER len
      INTEGER filePrec
      INTEGER fid
      INTEGER n2d
      _RL     fldRL(1-OLx:sNx+OLx,1-OLy:sNy+OLy,n2d,nSx,nSy)
      INTEGER irec
      LOGICAL locSingleCPUIO, locBufferIO
      INTEGER myThid

#ifdef ALLOW_WHIO
C     !FUNCTIONS:
      INTEGER  ILNBLNK
      INTEGER  MDS_RECLEN
      EXTERNAL ILNBLNK
      EXTERNAL MDS_RECLEN

C     !LOCAL VARIABLES:
C     == local parameters ==
C     sNxWh   :: x tile size with halo included
C     sNyWh   :: y tile size with halo included
C     pocNyWh :: processor sum of sNyWh
C     gloNyWh :: global sum of sNyWh
      INTEGER sNxWh
      INTEGER sNyWh
      INTEGER procNyWh
      INTEGER gloNyWh
      PARAMETER ( sNxWh = sNx+2*OLx )
      PARAMETER ( sNyWh = sNy+2*OLy )
      PARAMETER ( procNyWh = sNyWh*nSy*nSx )
      PARAMETER ( gloNyWh = procNyWh*nPy*nPx )
C     == local variables ==
      CHARACTER*(MAX_LEN_FNAM) pfName
      INTEGER IL
      INTEGER lengthBuff, length_of_rec
      INTEGER i, j, i2d
      INTEGER dUnit, irec2d
      LOGICAL iAmDoingIO
#ifdef ALLOW_WHIO_3D
      INTEGER js
#endif
CEOP

#ifdef ALLOW_WHIO_3D
      writeWh=.TRUE.
#endif

      IF ( .NOT.locSingleCpuIO ) THEN
        lengthBuff=sNxWh*procNyWh
      ELSE
        lengthBuff=sNxWh*gloNyWh
      ENDIF

C Only do I/O if I am the master thread (and mpi process 0 IF locSingleCpuIO):
      iAmDoingIO = .FALSE.
      IF ( .NOT.locSingleCpuIO .OR. myProcId.EQ.0 ) THEN
        _BEGIN_MASTER( myThid )
        iAmDoingIO = .TRUE.
        _END_MASTER( myThid )
      ENDIF

      IF ( iAmDoingIO ) THEN
C get the unit and open file
      IL  = ILNBLNK( fName )
      IF ( .NOT.locSingleCpuIO ) THEN
        WRITE(pfName,'(2A,I3.3,A)') fName(1:IL),'.',myProcId,'.data'
        length_of_rec = MDS_RECLEN( filePrec,sNxWh*procNyWh,myThid )
      ELSE
        WRITE(pfName,'(2A)') fName(1:IL),'.data'
        length_of_rec = MDS_RECLEN( filePrec,sNxWh*gloNyWh,myThid)
      ENDIF
      IF (fid.EQ.0) THEN
        CALL MDSFINDUNIT( dUnit, myThid )
        OPEN( dUnit, file=pfName, status='unknown',
     &         access='direct', recl=length_of_rec )
      ELSE
        dUnit=fid
      ENDIF
      ENDIF

      DO i2d=1,n2d

        IF (filePrec .EQ. precFloat32) THEN
          CALL MDS_PASS_R4toRL( fld2d_procbuff_r4, fldRL,
     &             OLx, OLy, 1, i2d, n2d, 0, 0, .FALSE., myThid )
          IF ( locSingleCpuIO ) THEN
            CALL BAR2( myThid )
#  ifndef EXCLUDE_WHIO_GLOBUFF_2D
            CALL GATHER_2D_WH_R4( fld2d_globuff_r4,
     &                            fld2d_procbuff_r4,myThid)
#  endif
          ENDIF
        ELSE
          CALL MDS_PASS_R8toRL( fld2d_procbuff_r8, fldRL,
     &             OLx, OLy, 1, i2d, n2d, 0, 0, .FALSE., myThid )
          IF ( locSingleCpuIO ) THEN
            CALL BAR2( myThid )
#  ifndef EXCLUDE_WHIO_GLOBUFF_2D
            CALL GATHER_2D_WH_R8( fld2d_globuff_r8,
     &                            fld2d_procbuff_r8,myThid)
#  endif
          ENDIF
        ENDIF

        _BARRIER
#ifdef ALLOW_WHIO_3D
        IF ( iAmDoingIO.AND.locBufferIO.AND.(fid.NE.0) ) THEN
C reset counter if needed
          IF (jWh.EQ.nWh) jWh=0
C increment counter
          jWh=jWh+1
C determine current file record
          irec2d=i2d+n2d*(irec-1)
          iWh=(irec2d-1)/nWh+1
C copy
          js = (jWh-1)*lengthBuff
          IF ( .NOT.locSingleCpuIO ) THEN
            IF (filePrec .EQ. precFloat32) THEN
              DO i=1,lengthBuff
                j = js + i
                fld3d_procbuff_r4(j) = fld2d_procbuff_r4(i)
              ENDDO
            ELSE
              DO i=1,lengthBuff
                j = js + i
                fld3d_procbuff_r8(j) = fld2d_procbuff_r8(i)
              ENDDO
            ENDIF
          ELSE
#  ifdef INCLUDE_WHIO_GLOBUFF_3D
            IF (filePrec .EQ. precFloat32) THEN
              DO i=1,lengthBuff
                j = js + i
                fld3d_globuff_r4(j) = fld2d_globuff_r4(i)
              ENDDO
            ELSE
              DO i=1,lengthBuff
                j = js + i
                fld3d_globuff_r8(j) = fld2d_globuff_r8(i)
              ENDDO
            ENDIF
#  endif
          ENDIF
C write chunk if needed
          IF (jWh.EQ.nWh) THEN
            IF ( .NOT.locSingleCpuIO ) THEN
              IF (filePrec .EQ. precFloat32) THEN
                WRITE(dUnit,rec=iWh) fld3d_procbuff_r4
              ELSE
                WRITE(dUnit,rec=iWh) fld3d_procbuff_r8
              ENDIF
            ELSE
#  ifdef INCLUDE_WHIO_GLOBUFF_3D
              IF (filePrec .EQ. precFloat32) THEN
                WRITE(dUnit,rec=iWh) fld3d_globuff_r4
              ELSE
                WRITE(dUnit,rec=iWh) fld3d_globuff_r8
              ENDIF
#  endif
            ENDIF
          ENDIF

        ELSEIF ( iAmDoingIO ) THEN
#else /* ALLOW_WHIO_3D */
        IF ( iAmDoingIO ) THEN
#endif /* ALLOW_WHIO_3D */
          irec2d=i2d+n2d*(irec-1)
          IF ( .NOT.locSingleCpuIO ) THEN
            IF (filePrec .EQ. precFloat32) THEN
              WRITE(dUnit,rec=irec2d) fld2d_procbuff_r4
            ELSE
              WRITE(dUnit,rec=irec2d) fld2d_procbuff_r8
            ENDIF
          ELSE
#  ifndef EXCLUDE_WHIO_GLOBUFF_2D
            IF (filePrec .EQ. precFloat32) THEN
              WRITE(dUnit,rec=irec2d) fld2d_globuff_r4
            ELSE
              WRITE(dUnit,rec=irec2d) fld2d_globuff_r8
            ENDIF
#  endif
          ENDIF
        ENDIF
        _BARRIER

      ENDDO

      IF ( iAmDoingIO.AND.(fid.EQ.0) ) THEN
        CLOSE( dUnit )
      ENDIF

#endif /* ALLOW_WHIO */

      RETURN
      END

!=======================================================================
      subroutine coupsend_r8tiles( component, dataname, Nx, Ny, arr )
      implicit none
! Predefined constants/arrays
#include "CPLR_SIG.h"
! MPI variables
#include "mpif.h"
! Arguments
      character*(*) component
      character*(*) dataname
      integer Nx,Ny
      real*8 arr(Nx,Ny)
! Functions
      integer mitcplr_match_comp
      integer generate_tag
      external mitcplr_match_comp
      external generate_tag
! Local
      integer count,dtype,dest,tag,comm,ierr
      integer compind,numprocs
      integer i,j,ij,n,bibj
      integer Ni,Io,Nj,Jo
!     ------------------------------------------------------------------

! Establish who I am communicating with
      compind=mitcplr_match_comp( component )
      if (compind.le.0) stop 'coupsend_r8tiles: Bad component id'
      comm=MPI_COMM_compcplr( compind )
      numprocs=num_component_procs(compind)
      if (numprocs.lt.1) then
       write(LogUnit,*) 'coupsend_r8tiles: compind = ',compind
       stop 'coupsend_r8tiles: numprocs < 1'
      endif
      if (VERB)
     &  write(LogUnit,*) 'coupsend_r8tiles: ',component_Name(compind)
      if (VERB)
     &  write(LogUnit,*) 'coupsend_r8tiles: dataname=',dataname

! Foreach component process
      do n=1,numprocs

! Foreach tile on that process
       do bibj=1,component_num_tiles(n,compind)

! Create header
        Io=component_tile_i0(bibj,n,compind)
        Jo=component_tile_j0(bibj,n,compind)
        Ni=component_tile_nx(bibj,n,compind)
        Nj=component_tile_ny(bibj,n,compind)
        r8buf(1)=float( Io )
        r8buf(2)=float( Jo )
        r8buf(3)=float( Ni )
        r8buf(4)=float( Nj )
        call mitcplr_char2dbl( dataname, r8buf(9) )

! Pack data
        do j=1,Nj
         do i=1,Ni
          ij=HEADER_SIZE+i+Ni*(j-1)
          r8buf(ij)=arr(Io+i-1,Jo+j-1)
         enddo
        enddo

! Send message
        count=HEADER_SIZE+Ni*Nj
        dtype=MPI_DOUBLE_PRECISION
        tag=generate_tag(123,bibj,dataname)
        dest=rank_component_procs(n,compind)

        if (VERB) then
         write(LogUnit,*) 'coupsend_r8tiles: calling MPI_Send dest=',
     &     dest,' proc=',n,'/',numprocs,' tile=',bibj
         call flush(LogUnit)
        endif
        call MPI_Send( r8buf, count, dtype, dest, tag, comm, ierr )
        if (VERB) then
         write(LogUnit,*) 'coupsend_r8tiles: returned ierr=',ierr
         call flush(LogUnit)
        endif

        if (ierr.ne.0) then
         write(LogUnit,*) 'coupsend_r8tiles: rank(W,G)=',
     &            my_rank_in_world,my_rank_in_global,
     &            ' ierr=',ierr
         stop 'coupsend_r8tiles: MPI_Send failed'
        endif

       enddo ! bibj

      enddo ! n

!     ------------------------------------------------------------------
      return
      end
!=======================================================================

#include "GRDCHK_OPTIONS.h"
#ifdef ALLOW_CTRL
# include "CTRL_OPTIONS.h"
#endif

      subroutine grdchk_get_obcs_mask( mythid )

c     ==================================================================
c     SUBROUTINE grdchk_get_obcs_mask
c     ==================================================================
c
c     o Get obcs masks from file
c
c     started: heimbach@mit.edu: 22-Apr-2003
c
c     ==================================================================
c     SUBROUTINE grdchk_get_obcs_mask
c     ==================================================================

      IMPLICIT NONE

c     == global variables ==

#include "EEPARAMS.h"
#include "SIZE.h"
#include "GRID.h"
#include "CTRL_SIZE.h"
#include "CTRL.h"
#ifdef ALLOW_OBCS_CONTROL
C     CTRL_OBCS.h must be included before GRDCHK.h
# include "CTRL_OBCS.h"
#endif
#include "GRDCHK.h"

c     == routine arguments ==
      integer mythid

#if (defined ALLOW_GRDCHK && defined ALLOW_OBCS_CONTROL)
c     == local variables ==
      integer bi,bj
      integer i,j,k
      integer iobcs
      integer itlo,ithi
      integer jtlo,jthi
      integer jmin,jmax
      integer imin,imax
      _RL dummy
#if (defined ALLOW_OBCSN_CONTROL || defined ALLOW_OBCSS_CONTROL)
      _RL tmpfldxz (1-olx:snx+olx,nr,nsx,nsy)
#endif
#if (defined ALLOW_OBCSE_CONTROL || defined ALLOW_OBCSW_CONTROL)
      _RL tmpfldyz (1-oly:sny+oly,nr,nsx,nsy)
#endif
      character*(MAX_LEN_FNAM) fname

c     == end of interface ==

      jtlo = 1
      jthi = nsy
      itlo = 1
      ithi = nsx
      jmin = 1
      jmax = sny
      imin = 1
      imax = snx

      _BEGIN_MASTER( mythid )

      IF ( ncvargrd(grdchkvarindex) .EQ. 'm' ) THEN
       IF ( ncvarindex(grdchkvarindex).EQ.1 ) THEN
#ifdef ALLOW_OBCSN_CONTROL
        write(fname,'(a)') 'maskobcsn'
        do iobcs = 1,nobcs
         call active_read_xz(  fname, tmpfldxz, iobcs,
     &        .false., .false., 0, mythid, dummy)
         do bj = jtlo,jthi
          do bi = itlo,ithi
           do k = 1,nr
            do i = imin,imax
              grdchk_maskxz(i,k,bi,bj,iobcs) = tmpfldxz(i,k,bi,bj)
            enddo
           enddo
          enddo
         enddo
        enddo
#endif

       ELSEIF ( ncvarindex(grdchkvarindex).EQ.2 ) THEN
#ifdef ALLOW_OBCSS_CONTROL
        write(fname,'(a)') 'maskobcss'
c
        do iobcs = 1,nobcs
         call active_read_xz(  fname, tmpfldxz, iobcs,
     &        .false., .false., 0, mythid, dummy)
         do bj = jtlo,jthi
          do bi = itlo,ithi
           do k = 1,nr
            do i = imin,imax
              grdchk_maskxz(i,k,bi,bj,iobcs) = tmpfldxz(i,k,bi,bj)
            enddo
           enddo
          enddo
         enddo
        enddo
#endif

       ELSEIF ( ncvarindex(grdchkvarindex).EQ.3 ) THEN
#ifdef ALLOW_OBCSE_CONTROL
        write(fname,'(a)') 'maskobcse'
        do iobcs = 1,nobcs
         call active_read_yz(  fname, tmpfldyz, iobcs,
     &        .false., .false., 0, mythid, dummy)
         do bj = jtlo,jthi
          do bi = itlo,ithi
           do k = 1,nr
            do j = jmin,jmax
               grdchk_maskyz(j,k,bi,bj,iobcs) = tmpfldyz(j,k,bi,bj)
            enddo
           enddo
          enddo
         enddo
        enddo
#endif

       ELSEIF ( ncvarindex(grdchkvarindex).EQ.4 ) THEN
#ifdef ALLOW_OBCSW_CONTROL
        write(fname,'(a)') 'maskobcsw'
        do iobcs = 1,nobcs
         call active_read_yz(  fname, tmpfldyz, iobcs,
     &        .false., .false., 0, mythid, dummy)
         do bj = jtlo,jthi
          do bi = itlo,ithi
           do k = 1,nr
            do j = jmin,jmax
              grdchk_maskyz(j,k,bi,bj,iobcs) = tmpfldyz(j,k,bi,bj)
            enddo
           enddo
          enddo
         enddo
        enddo
#endif

       ENDIF
      ENDIF

      _END_MASTER( mythid )

      _BARRIER

#endif /* ALLOW_GRDCHK */

      RETURN
      END

#include "PACKAGES_CONFIG.h"
#include "CPP_OPTIONS.h"
#ifdef ALLOW_MOM_COMMON
# include "MOM_COMMON_OPTIONS.h"
#endif

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: SET_PARMS
C     !INTERFACE:
      SUBROUTINE SET_PARMS( myThid )

C     !DESCRIPTION:
C     Set model "parameters" that might depend on the use of some pkgs;
C     called from INITIALISE_FIXED, after INI_PARMS & PACKAGES_READPARAMS
C     NOTES: After leaving this S/R, parameters will not change anymore.

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "EOS.h"
#ifdef ALLOW_MOM_COMMON
# include "MOM_VISC.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     myThid :: My Thread Id number
      INTEGER myThid

C     !FUNCTIONS:
c     INTEGER  ILNBLNK
c     EXTERNAL ILNBLNK

C     !LOCAL VARIABLES:
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      INTEGER errCount, k
      _RL tmpVar
CEOP

C--   Set (or reset) On/Off flags :

C-    For off-line calculation, switch off Momentum and Active-tracers (=T,S):
#ifdef ALLOW_OFFLINE
      IF ( useOffLine ) THEN
        CALL OFFLINE_RESET_PARMS( myThid )
      ENDIF
#endif /* ALLOW_OFFLINE */

      _BEGIN_MASTER(myThid)
      errCount = 0

C--   Make metric term & Coriolis settings consistent with underlying grid.
      IF ( usingCartesianGrid ) THEN
        selectMetricTerms = 0
        useNHMTerms   = .FALSE.
      ENDIF
      IF ( usingCylindricalGrid ) THEN
        useNHMTerms   = .FALSE.
        WRITE(msgBuf,'(A)') 'S/R INI_PARMS ; Cylinder OK'
        CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                     SQUEEZE_RIGHT, myThid )
      ENDIF
      IF ( usingCurvilinearGrid ) THEN
C-    Horizontal metric terms not implemented for Curvilinear-Grid
        selectMetricTerms = 0
      ENDIF
      IF ( usingCylindricalGrid ) THEN
C-    No current alternative metric terms formulation for Cylindrical-Grid
        selectMetricTerms = MIN( selectMetricTerms, 1 )
      ENDIF
      IF ( selectCoriMap.EQ.-1 ) THEN
        IF ( usingCartesianGrid.OR.usingCylindricalGrid ) THEN
C       default is to use Beta-Plane Coriolis
          selectCoriMap = 1
        ELSE
C       default for other grids is to use Spherical Coriolis
          selectCoriMap = 2
        ENDIF
      ENDIF
      IF ( .NOT.(nonHydrostatic.OR.quasiHydrostatic) )
     &                          select3dCoriScheme = 0
      IF ( (selectCoriMap.EQ.0 .OR.selectCoriMap.EQ.1)
     &     .AND. fPrime.EQ.0. ) select3dCoriScheme = 0

C--   On/Off flags for each terms of the momentum equation
      nonHydrostatic   = momStepping .AND. nonHydrostatic
      quasiHydrostatic = momStepping .AND. quasiHydrostatic
      momAdvection     = momStepping .AND. momAdvection
      momViscosity     = momStepping .AND. momViscosity
      momForcing       = momStepping .AND. momForcing
      momTidalForcing  = momForcing  .AND. momTidalForcing
      useCoriolis      = momStepping .AND. useCoriolis
      IF ( .NOT.useCoriolis ) select3dCoriScheme = 0
      useCDscheme      = momStepping .AND. useCDscheme
      momPressureForcing= momStepping .AND. momPressureForcing
      implicitIntGravWave=momPressureForcing .AND. implicitIntGravWave
      momImplVertAdv   = momAdvection .AND. momImplVertAdv
      useNHMTerms      = momAdvection .AND. useNHMTerms
      IF ( .NOT.momAdvection ) selectMetricTerms = 0
      implicitViscosity= momViscosity .AND. implicitViscosity
      useSmag3D        = momViscosity .AND. useSmag3D
      use3Dsolver      = nonHydrostatic.OR. implicitIntGravWave
      calc_wVelocity   = momStepping .OR. exactConserv

#ifndef ALLOW_3D_VISCAH
      IF ( viscAhDfile.NE.' ' .OR. viscAhZfile.NE.' ' ) THEN
        WRITE(msgBuf,'(2A)') 'SET_PARMS: ',
     &      'viscAhDfile and viscAhZfile cannot be used with'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(2A)') 'SET_PARMS: ',
     &      '"#undef ALLOW_3D_VISCAH" in MOM_COMMON_OPTIONS.h'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF
#endif
#ifndef ALLOW_3D_VISCA4
      IF ( viscA4Dfile.NE.' ' .OR. viscA4Zfile.NE.' ' ) THEN
        WRITE(msgBuf,'(2A)') 'SET_PARMS: ',
     &      'viscA4Dfile and viscA4Zfile cannot be used with'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(2A)') 'SET_PARMS: ',
     &      '"#undef ALLOW_3D_VISCA4" in MOM_COMMON_OPTIONS.h'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF
#endif

#ifdef ALLOW_MOM_COMMON
C-    On/Off flags for viscosity coefficients
      useVariableVisc   =
     &      viscAhGrid  .NE.zeroRL .OR. viscA4Grid  .NE.zeroRL
     &  .OR. viscC2smag .NE.zeroRL .OR. viscC4smag  .NE.zeroRL
     &  .OR. viscC2leith.NE.zeroRL .OR. viscC2leithD.NE.zeroRL
     &  .OR. viscC2LeithQG.NE.zeroRL
     &  .OR. viscC4leith.NE.zeroRL .OR. viscC4leithD.NE.zeroRL
     &  .OR. viscAhDfile.NE.' '    .OR.  viscAhZfile.NE.' '
     &  .OR. viscA4Dfile.NE.' '    .OR.  viscA4Zfile.NE.' '

      useHarmonicVisc   = viscAh .NE.zeroRL
     &  .OR. viscAhD    .NE.zeroRL .OR. viscAhZ     .NE.zeroRL
     &  .OR. viscAhGrid .NE.zeroRL .OR. viscC2smag  .NE.zeroRL
     &  .OR. viscC2leith.NE.zeroRL .OR. viscC2leithD.NE.zeroRL
     &  .OR. viscC2LeithQG.NE.zeroRL
     &  .OR. viscAhDfile.NE. ' '   .OR. viscAhZfile .NE. ' '

      useBiharmonicVisc = viscA4.NE.zeroRL
     &  .OR. viscA4D    .NE.zeroRL .OR. viscA4Z     .NE.zeroRL
     &  .OR. viscA4Grid .NE.zeroRL .OR. viscC4smag  .NE.zeroRL
     &  .OR. viscC4leith.NE.zeroRL .OR. viscC4leithD.NE.zeroRL
     &  .OR. viscA4Dfile.NE. ' '   .OR. viscA4Zfile .NE. ' '

      useVariableVisc   = momViscosity .AND. useVariableVisc
      useHarmonicVisc   = momViscosity .AND. useHarmonicVisc
      useBiharmonicVisc = momViscosity .AND. useBiharmonicVisc
#endif /* ALLOW_MOM_COMMON */
      IF ( ( bottomDragQuadratic.EQ.0. .AND. zRoughBot.EQ.0. )
     &     .OR. .NOT.momViscosity ) selectBotDragQuadr = -1

C--   Free-surface & pressure method
      uniformFreeSurfLev = usingZCoords
C- Note: comment line below to revert to full-cell hydrostatic-pressure
C        calculation in surface grid-cell below ice-shelf
      uniformFreeSurfLev = usingZCoords .AND. .NOT.useShelfIce
     &                                  .AND. topoFile.EQ.' '
      IF ( selectNHfreeSurf.NE.0 .AND.
     &      ( .NOT.nonHydrostatic .OR. usingPCoords
     &        .OR. .NOT.exactConserv
     &      ) ) THEN
        WRITE(msgBuf,'(2A)') '** WARNING ** SET_PARMS: ',
     &                       'reset selectNHfreeSurf to zero'
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
        selectNHfreeSurf = 0
      ENDIF
#ifdef ALLOW_AUTODIFF
      doResetHFactors = .TRUE.
#endif
#ifndef NONLIN_FRSURF
      doResetHFactors = .FALSE.
#endif

C--   Set default Vorticity-Term Scheme:
      IF ( vectorInvariantMomentum ) THEN
        IF ( selectVortScheme.EQ.UNSET_I ) THEN
          selectVortScheme = 1
          IF ( upwindVorticity )    selectVortScheme = 0
          IF ( highOrderVorticity ) selectVortScheme = 0
        ENDIF
      ELSEIF ( selectVortScheme.NE.UNSET_I ) THEN
        WRITE(msgBuf,'(A,A)') '** WARNING ** SET_PARMS: ',
     &   'Vector-Invariant Momentum unused => ignore selectVortScheme'
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
      ENDIF
      useAbsVorticity = vectorInvariantMomentum .AND. useAbsVorticity
C--   Momentum viscosity on/off flag.
      IF ( momViscosity        ) THEN
       vfFacMom = 1. _d 0
      ELSE
       vfFacMom = 0. _d 0
      ENDIF
C--   Momentum advection on/off flag.
      IF ( momAdvection        ) THEN
       afFacMom = 1. _d 0
      ELSE
       afFacMom = 0. _d 0
      ENDIF
C--   Momentum forcing on/off flag.
      IF ( momForcing ) THEN
       foFacMom = 1. _d 0
      ELSE
       foFacMom = 0. _d 0
      ENDIF
C--   Coriolis term on/off flag.
      IF ( useCoriolis ) THEN
       cfFacMom = 1. _d 0
      ELSE
       cfFacMom = 0. _d 0
      ENDIF
C--   Pressure term on/off flag.
      IF ( momPressureForcing ) THEN
       pfFacMom = 1. _d 0
      ELSE
       pfFacMom = 0. _d 0
      ENDIF
C--   Metric terms on/off flag.
      IF ( selectMetricTerms.GE.1 ) THEN
       mTFacMom = 1. _d 0
      ELSE
       mTFacMom = 0. _d 0
      ENDIF

C--   Advection and Forcing for Temp and salt  on/off flags
      tempVertDiff4 = .FALSE.
      saltVertDiff4 = .FALSE.
      DO k=1,Nr
        tempVertDiff4 = tempVertDiff4 .OR. ( diffKr4T(k).GT.0. _d 0 )
        saltVertDiff4 = saltVertDiff4 .OR. ( diffKr4S(k).GT.0. _d 0 )
      ENDDO
      tempAdvection = tempStepping .AND. tempAdvection
      tempVertDiff4 = tempStepping .AND. tempVertDiff4
      tempForcing   = tempStepping .AND. tempForcing
      saltAdvection = saltStepping .AND. saltAdvection
      saltVertDiff4 = saltStepping .AND. saltVertDiff4
      saltForcing   = saltStepping .AND. saltForcing
      tempImplVertAdv = tempAdvection .AND. tempImplVertAdv
      saltImplVertAdv = saltAdvection .AND. saltImplVertAdv
      doThetaClimRelax = ( tempForcing .OR.( useOffLine.AND.useKPP ) )
     &             .AND. ( tauThetaClimRelax.GT.0. _d 0 )
      doSaltClimRelax  = ( saltForcing .OR.( useOffLine.AND.useKPP ) )
     &             .AND. ( tauSaltClimRelax .GT.0. _d 0 )

C--   Dynamically Active Tracers : set flags
      tempIsActiveTr = momPressureForcing .AND. tempAdvection
      saltIsActiveTr = momPressureForcing .AND. saltAdvection
      IF ( eosType.EQ.'IDEALG' .AND. atm_Rq.EQ.0. ) THEN
        saltIsActiveTr = .FALSE.
      ELSEIF ( eosType.EQ.'LINEAR' ) THEN
        IF ( tAlpha.EQ.0. ) tempIsActiveTr = .FALSE.
        IF ( sBeta .EQ.0. ) saltIsActiveTr = .FALSE.
      ENDIF

C--   Set default for latitude-band where relaxation to climatology applies
C     note: done later (once domain size is known) if using CartesianGrid
      IF ( latBandClimRelax .EQ. UNSET_RL) THEN
        IF ( usingSphericalPolarGrid ) latBandClimRelax= 180. _d 0
        IF ( usingCurvilinearGrid )    latBandClimRelax= 180. _d 0
      ENDIF

      IF ( usingZCoords ) THEN
C--   Select which pressure to use in EOS:
C     set default according to EOS type (as it was until chkpt65t)
        IF ( selectP_inEOS_Zc.EQ.UNSET_I ) THEN
          IF ( eosType .EQ. 'JMD95P' .OR.  eosType .EQ. 'UNESCO'
     &    .OR. eosType .EQ. 'MDJWF'  .OR.  eosType .EQ. 'TEOS10'
     &       ) THEN
           selectP_inEOS_Zc = 2
          ELSE
           selectP_inEOS_Zc = 0
          ENDIF
        ELSEIF ( selectP_inEOS_Zc.LT.0
     &      .OR. selectP_inEOS_Zc.GT.3 ) THEN
          WRITE(msgBuf,'(A,I9,A)') 'SET_PARMS: selectP_inEOS_Zc=',
     &                  selectP_inEOS_Zc, ' : invalid selection'
          CALL PRINT_ERROR( msgBuf, myThid )
          errCount = errCount + 1
        ELSEIF ( .NOT.nonHydrostatic ) THEN
          selectP_inEOS_Zc = MIN( selectP_inEOS_Zc, 2 )
        ENDIF
        IF ( ( eosType .EQ. 'LINEAR' .OR.  eosType .EQ. 'POLY3 ' )
     &      .AND. selectP_inEOS_Zc.NE.0  ) THEN
          WRITE(msgBuf,'(A,I9,2A)') 'SET_PARMS: selectP_inEOS_Zc=',
     &     selectP_inEOS_Zc, ' : invalid with eosType=', eosType
          CALL PRINT_ERROR( msgBuf, myThid )
          errCount = errCount + 1
        ENDIF
      ELSE
        selectP_inEOS_Zc = -1
      ENDIF
C--   When using the dynamical pressure in EOS (with Z-coord.),
C     needs to activate specific part of the code (restart & exchange)
      storePhiHyd4Phys = selectP_inEOS_Zc.GE.2
C-    pkg/atm_phys uses main-model geopotential:
      storePhiHyd4Phys = storePhiHyd4Phys .OR. useAtm_Phys

C--   Adjust parameters related to length of the simulation

C-    Need to adjust endTime for sub-timestep mismatch , since in
C     several places, test for last iteration with time==endTime :
      tmpVar = startTime + deltaTClock*DFLOAT(nTimeSteps)
      IF ( endTime.NE.tmpVar ) THEN
       IF ( ABS(endTime-tmpVar).GT.deltaTClock*1. _d -6 ) THEN
        WRITE(msgBuf,'(A,A)') '** WARNING ** SET_PARMS: ',
     &   '(endTime-baseTime) not multiple of time-step'
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
        WRITE(msgBuf,'(2A,1PE20.13)') '** WARNING ** SET_PARMS: ',
     &   'Previous endTime=', endTime
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
        WRITE(msgBuf,'(2A,1PE20.13)') '** WARNING ** SET_PARMS: ',
     &   'Adjusted endTime=', tmpVar
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
       ENDIF
       endTime = tmpVar
      ENDIF

#ifdef ALLOW_LONGSTEP
      IF ( usePTRACERS ) THEN
        CALL LONGSTEP_CHECK_ITERS(myThid)
      ENDIF
#endif /* ALLOW_LONGSTEP */

      IF ( OLx.LE.0 .OR. OLy.LE.0 ) THEN
C--   Overlap-size will be checked later in CONFIG_CHECK. This minimal
C     check here is just to set-up the model grid (INI_GRID) safely.
        WRITE(msgBuf,'(2A)') 'SET_PARMS: ',
     &      'model unusable with no overlap (OLx,OLy = 0)'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF

      IF ( errCount.GE.1 ) THEN
        WRITE(msgBuf,'(A,I3,A)')
     &       'SET_PARMS: detected', errCount,' fatal error(s)'
        CALL PRINT_ERROR( msgBuf, myThid )
        CALL ALL_PROC_DIE( 0 )
        STOP 'ABNORMAL END: S/R SET_PARMS'
      ENDIF

C--   After this point, main model parameters are not supposed to be modified.
       WRITE(msgBuf,'(A,A)') 'SET_PARMS: done'
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                      SQUEEZE_RIGHT , 1)

      _END_MASTER(myThid)

C--   Everyone else must wait for the parameters to be set
      _BARRIER

      RETURN
      END

#include "MOM_COMMON_OPTIONS.h"

CBOP
C !ROUTINE: MOM_V_SIDEDRAG

C !INTERFACE: ==========================================================
      SUBROUTINE MOM_V_SIDEDRAG(
     I        bi, bj, k,
     I        vFld, del2v, hFacZ,
     I        viscAh_Z,viscA4_Z,
     I        harmonic, biharmonic, useVariableViscosity,
     O        vDragTerms,
     I        myThid )

C !DESCRIPTION:
C Calculates the drag terms due to the no-slip condition on viscous stresses:
C \begin{equation*}
C G^v_{drag} = - \frac{2}{\Delta x_v} (A_h v - A_4 \nabla^2 v)
C \end{equation*}

C !USES: ===============================================================
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "SURFACE.h"

C !INPUT PARAMETERS: ===================================================
C  bi,bj                :: tile indices
C  k                    :: vertical level
C  vfld                 :: meridional flow
C  del2v                :: Laplacian of meridional flow
C  hFacZ                :: fractional open water at vorticity points
C  myThid               :: my Thread Id number
      INTEGER bi, bj, k
      _RL vFld(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL del2v(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RS hFacZ(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL viscAh_Z(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL viscA4_Z(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      LOGICAL harmonic, biharmonic, useVariableViscosity
      INTEGER myThid

C !OUTPUT PARAMETERS: ==================================================
C  vDragTerms           :: drag term
      _RL vDragTerms(1-OLx:sNx+OLx,1-OLy:sNy+OLy)

C !LOCAL VARIABLES: ====================================================
C  i,j                  :: loop indices
C  hFacZClosedE         :: fractional open water to east
C  hFacZClosedW         :: fractional open water to west
      INTEGER i, j
      _RL hFacZClosedE, hFacZClosedW
      _RL Ahtmp,A4tmp
CEOP

      IF ( sideDragFactor.LE.0. ) THEN
C--   Laplacian and bi-harmonic terms: variable-Viscosity coeff. from
C     MOM_CALC_VISC are not used here (corresponds to the "old" version).

      DO j=2-OLy,sNy+OLy-1
       DO i=2-OLx,sNx+OLx-1
#ifdef NONLIN_FRSURF
        hFacZClosedW = h0FacS(i,j,k,bi,bj) - hFacZ(i,j)
        hFacZClosedE = h0FacS(i,j,k,bi,bj) - hFacZ(i+1,j)
#else
        hFacZClosedW = _hFacS(i,j,k,bi,bj) - hFacZ(i,j)
        hFacZClosedE = _hFacS(i,j,k,bi,bj) - hFacZ(i+1,j)
#endif
        Ahtmp=MIN(viscAh+viscAhGrid*rAs(i,j,bi,bj)/deltaTmom,
     &            viscAhMax)
        A4tmp=MIN(viscA4+viscA4Grid*(rAs(i,j,bi,bj)**2)/deltaTmom,
     &            viscA4Max)
        IF (viscA4GridMax.GT.0.) THEN
           A4tmp=MIN(A4tmp,viscA4GridMax*(rAs(i,j,bi,bj)**2)/deltaTmom)
        ENDIF
        A4tmp=MAX(A4tmp,viscA4GridMin*(rAs(i,j,bi,bj)**2)/deltaTmom)
        vDragTerms(i,j) =
     &   -_recip_hFacS(i,j,k,bi,bj)
     &   *recip_drF(k)*recip_rAs(i,j,bi,bj)
     &   *( hFacZClosedW*_dyU( i ,j,bi,bj)
     &      *_recip_dxV( i ,j,bi,bj)
     &     +hFacZClosedE*_dyU(i+1,j,bi,bj)
     &      *_recip_dxV(i+1,j,bi,bj) )
     &   *drF(k)*2.*(
     &                Ahtmp*vFld(i,j)*cosFacV(j,bi,bj)
#ifdef COSINEMETH_III
     &               -viscA4*del2v(i,j)*sqcosFacV(j,bi,bj)
#else
     &               -A4tmp*del2v(i,j)*cosFacV(j,bi,bj)
#endif
     &              )
       ENDDO
      ENDDO

      ELSE
C--   Laplacian and bi-harmonic terms: using variable-Viscosity coeff.
C     from MOM_CALC_VISC, consistent with dissipation in the interior

      DO j=2-OLy,sNy+OLy-1
       DO i=2-OLx,sNx+OLx-1
#ifdef NONLIN_FRSURF
        hFacZClosedW = h0FacS(i,j,k,bi,bj) - hFacZ(i,j)
        hFacZClosedE = h0FacS(i,j,k,bi,bj) - hFacZ(i+1,j)
#else
        hFacZClosedW = _hFacS(i,j,k,bi,bj) - hFacZ(i,j)
        hFacZClosedE = _hFacS(i,j,k,bi,bj) - hFacZ(i+1,j)
#endif
        vDragTerms(i,j) =
     &   -_recip_hFacS(i,j,k,bi,bj)
     &   *recip_drF(k)*recip_rAs(i,j,bi,bj)
     &   *( hFacZClosedW*_dyU( i ,j,bi,bj)*_recip_dxV( i ,j,bi,bj)
     &         *( viscAh_Z(i  ,j)*vFld(i,j)*cosFacV(j,bi,bj)
#ifdef COSINEMETH_III
     &           -viscA4_Z(i  ,j)*del2v(i,j)*sqcosFacV(j,bi,bj) )
#else
     &           -viscA4_Z(i  ,j)*del2v(i,j)*cosFacV(j,bi,bj) )
#endif
     &     +hFacZClosedE*_dyU(i+1,j,bi,bj)*_recip_dxV(i+1,j,bi,bj)
     &         *( viscAh_Z(i+1,j)*vFld(i,j)*cosFacV(j,bi,bj)
#ifdef COSINEMETH_III
     &           -viscA4_Z(i+1,j)*del2v(i,j)*sqcosFacV(j,bi,bj) )
#else
     &           -viscA4_Z(i+1,j)*del2v(i,j)*cosFacV(j,bi,bj) )
#endif
     &    )*drF(k)*sideDragFactor
       ENDDO
      ENDDO

C--   end old-version / new-version IF blocks
      ENDIF

#ifdef ALLOW_DIAGNOSTICS
      IF (useDiagnostics) THEN
        CALL DIAGNOSTICS_FILL(vDragTerms,'VSidDrag',k,1,2,bi,bj,myThid)
      ENDIF
#endif /* ALLOW_DIAGNOSTICS */

      RETURN
      END

#include "CPP_OPTIONS.h"

CBOP
C     !ROUTINE: CALC_WSURF_TR
C     !INTERFACE:
      SUBROUTINE CALC_WSURF_TR(thetaFld, saltFld, wVelFld,
     I                         myTime, myIter, myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE CALC_WSURF_TR
C     | o Compute a correction for the source/sink of tracer
C     |   due to the linear free surface.
C     | o The source/sink results from W*Tr not summing to
C     |   zero at the free surface.
C     | o Here, we compute an area-weighted mean correction
C     |   to be applied in external_forcing.F
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     == Global variables
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "SURFACE.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     myTime   :: Current time in simulation
C     myIter   :: Current iteration number in simulation
C     myThid   :: Thread number for this instance of the routine.
C     thetaFld :: Potential Temperature field
C     saltFld  :: Salinity field
C     wvelFld  :: vertical velocity field
      _RL myTime
      INTEGER myIter
      INTEGER myThid
      _RL thetaFld(1-Olx:sNx+Olx,1-Oly:sNy+Oly,Nr,nSx,nSy)
      _RL saltFld (1-Olx:sNx+Olx,1-Oly:sNy+Oly,Nr,nSx,nSy)
      _RL wVelFld (1-Olx:sNx+Olx,1-Oly:sNy+Oly,Nr,nSx,nSy)

C     !LOCAL VARIABLES:
C     Local variables
C     i,j,k,bi,bj  :: loop counter
      INTEGER i,j,bi,bj,ks
      _RL wT_Mean, wS_Mean
      _RL wT_Tile(nSx,nSy)
      _RL wS_Tile(nSx,nSy)
CEOP

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      TsurfCor= 0.
      SsurfCor= 0.

      wT_Mean = 0.
      wS_Mean = 0.

      DO bj=myByLo(myThid), myByHi(myThid)
       DO bi=myBxLo(myThid), myBxHi(myThid)
         wT_Tile(bi,bj) = 0.
         wS_Tile(bi,bj) = 0.
         DO j=1,sNy
          DO i=1,sNx
             ks = ksurfC(i,j,bi,bj)
             IF (ks.LE.Nr) THEN
                wT_Tile(bi,bj) = wT_Tile(bi,bj)
     &           + rA(i,j,bi,bj)*wVelFld(i,j,ks,bi,bj)
     &                          *thetaFld(i,j,ks,bi,bj)
                wS_Tile(bi,bj) = wS_Tile(bi,bj)
     &           + rA(i,j,bi,bj)*wVelFld(i,j,ks,bi,bj)
     &                          *saltFld(i,j,ks,bi,bj)
             ENDIF
          ENDDO
         ENDDO
c#ifdef ALLOW_AUTODIFF_TAMC
c        wT_Mean = wT_Mean + wT_Tile(bi,bj)
c        wS_Mean = wS_Mean + wS_Tile(bi,bj)
c#endif
C-     end bi,bj loop.
       ENDDO
      ENDDO

C-- Global diagnostic :
c#ifdef ALLOW_AUTODIFF_TAMC
c     _GLOBAL_SUM_RL(wT_Mean,myThid)
c     _GLOBAL_SUM_RL(wS_Mean,myThid)
c#else
      CALL GLOBAL_SUM_TILE_RL( wT_Tile, wT_Mean, myThid )
      CALL GLOBAL_SUM_TILE_RL( wS_Tile, wS_Mean, myThid )
c#endif

      IF ( globalArea.GT.0. ) THEN
        _BEGIN_MASTER( myThid )
        TsurfCor = wT_Mean / globalArea
        SsurfCor = wS_Mean / globalArea
        _END_MASTER( myThid )
      ENDIF
      _BARRIER

C-----

      RETURN
      END

#include "CAL_OPTIONS.h"

      subroutine cal_StepsForDay(
     I                            iday,
     O                            firststep,
     O                            laststep,
     O                            nsteps,
     I                            mythid
     &                          )

c     ==================================================================
c     SUBROUTINE cal_StepsForDay
c     ==================================================================
c
c     o Given the current day of the integration this routine returns
c       first, the last and the number of model steps the will have to
c       be performed.
c
c       This routine also checks consistency of variables quite
c       extensively.
c
c     started: Christian Eckert eckert@mit.edu  06-Apr-2000
c
c     changed:
c
c     ==================================================================
c     SUBROUTINE cal_StepsForDay
c     ==================================================================

      implicit none

c     == global variables ==

#include "cal.h"

c     == routine arguments ==

      integer iday
      integer firststep
      integer laststep
      integer nsteps
      integer mythid

c     == local variables ==

      integer ierr
      integer mdstep
      integer numdays
      integer numsteps
      integer frac1
      integer frac2
      integer frac3
      integer frac4
      integer fullsteps
      integer firstyear
      integer firstmonth
      integer firstday
      integer lyfirst
      integer startsecs
      integer lastday
      integer endsecs

c     == external ==

      external cal_IntDays
      integer  cal_IntDays
      external cal_IsLeap
      integer  cal_IsLeap

c     == end of interface ==

      numdays    = cal_IntDays( mythid )
      lyfirst    = cal_IsLeap( firstyear, mythid )

      mdstep     = int(modelstep)

      firstyear  = modelstartdate(1)/10000
      firstmonth = mod(modelstartdate(1)/100,100)
      firstday   = mod(modelstartdate(1),100)
      lastday    = mod(modelenddate(1),100)

      startsecs  = (modelstartdate(2)/10000)*secondsperhour +
     &             mod(modelstartdate(2)/100,100)*secondsperminute +
     &             mod(modelstartdate(2),100)
      endsecs    = (modelenddate(2)/10000)*secondsperhour +
     &             mod(modelenddate(2)/100,100)*secondsperminute +
     &             mod(modelenddate(2),100)

      if ( numdays .eq. 1 ) then
        if ( iday .eq. firstday ) then
c--       Get the number of steps in the first day.
          if ( firstday .eq. lastday ) then
            firststep = 1
            laststep  = modelintsteps
          else if ( mod(firstday+1,ndaymonth(firstmonth,lyfirst)) .eq.
     &              lastday ) then
c--         This can only happen if we end at midnight of the next day.
            if ( modelenddate(2) .eq. 0 ) then
              firststep = 1
              laststep  = modelintsteps
c--           Note: This holds only if modelenddate was determined
c--                 such that it coincides with the model final time.
            else
c--           We do not end at midnight of the first day of
c--           the next month.
              ierr = 2604
              call cal_PrintError( ierr, mythid )
              stop ' stopped in cal_StepsForDay.'
            endif
          else
c--         The first and the last day are inconsistent with iday.
            ierr = 2603
            call cal_PrintError( ierr, mythid )
            stop ' stopped in cal_StepsForDay.'
          endif
        else
c--       The variables numdays and iday are inconsistent;
c--       ( iday .gt. numdays ).
          ierr = 2602
          call cal_PrintError( ierr, mythid )
          stop ' stopped in cal_StepsForDay.'
        endif

      else if ( numdays .gt. 1 ) then
c--     More than one day of integration.
        if ( iday .eq. 1 ) then
          firststep = 1
          laststep  = int((secondsperday - startsecs)/mdstep)
        else if ( ( iday .gt. 1      ) .and.
     &            ( iday .lt. numdays) ) then
c--       Somewhere between first and last month.
c--       The first steps in iday.
          fullsteps = int((secondsperday - startsecs)/mdstep)
          numsteps  = fullsteps
c--       What is left in the first day (frac1).
          frac1     = (secondsperday - startsecs) - fullsteps*mdstep
          fullsteps = int(secondsperday/modelstep)
c--       What is left in a complete day (frac2).
          frac2     = secondsperday - fullsteps*mdstep
c--       What is left up to the current day (frac3).
          frac3     = frac1 + frac2*(iday - 1)
          numsteps  = numsteps + (iday - 1)*fullsteps +
     &                frac3/mdstep
          laststep  = numsteps
          firststep = laststep - secondsperday/mdstep + 1

        else if ( iday .eq. numdays ) then
c--       The last day of integration.
c--       The first step in iday.
          fullsteps = int((secondsperday - startsecs)/mdstep)
          numsteps  = fullsteps
c--       What is left in the first day (frac1).
          frac1     = (secondsperday - startsecs) - fullsteps*mdstep
          fullsteps = int(secondsperday/modelstep)
c--       What is left in a complete day (frac2).
          frac2     = secondsperday - fullsteps*mdstep
c--       What is left up to the day before the last (frac3).
          frac3     = frac1 + frac2*(iday - 2)
          numsteps  = numsteps + (iday - 2)*fullsteps
c--       The last step in iday.
          if ( modelenddate(2) .eq. 0 ) then
c--         This can only happen if we end at midnight of the next day.
            laststep  = numsteps + fullsteps
            firststep = numsteps + 1
c--         Note: There should be no fraction left
c--               ( mod(frac3,mdstep) = frac3/mdstep ) if modelenddate
c--               is based on an integral number of timesteps.
          else
            frac4     = frac3 + endsecs
            numsteps  = numsteps + frac4/mdstep
            laststep  = numsteps

c--         Note: There should be no fraction left
c--               ( mod(frac4,mdstep = frac4/mdstep ) if modelenddate
c--               is based on an integral number of timesteps.

            firststep = laststep - endsecs/mdstep + 1
          endif
        else
c--       The variables iday and numdays are inconsistent.
          ierr = 2605
          call cal_PrintError( ierr, mythid )
          stop ' stopped in cal_DaysForMonth.'
        endif
      else
c--     The number of days to integrate is wrong; check cal_IntDays.
        ierr = 2601
        call cal_PrintError( ierr, mythid )
        stop ' stopped in cal_StepsForDay.'
      endif

c--   The number of days to integrate in the given month.
      nsteps = laststep - firststep + 1

      return
      end

#include "ECCO_OPTIONS.h"

      subroutine cost_gencost_sstv4(
     I                     myThid
     &                   )

c     ==================================================================
c     SUBROUTINE cost_gencost_sstv4
c     ==================================================================
c
c     o Evaluate cost function contributions of sea surface temperature.
c       (Daily Pointwise and then Large Scale)
c
c       started: Gael Forget, Oct-2009
c
c     ==================================================================
c     SUBROUTINE cost_gencost_sstv4
c     ==================================================================

      implicit none

c     == global variables ==

#include "EEPARAMS.h"
#include "SIZE.h"
#include "PARAMS.h"
#include "GRID.h"
#ifdef ALLOW_CAL
# include "cal.h"
#endif
#ifdef ALLOW_ECCO
# include "ECCO_SIZE.h"
# include "ECCO.h"
#endif
#ifdef ALLOW_SMOOTH
# include "SMOOTH.h"
#endif

c     == routine arguments ==

      integer myThid

#ifdef ALLOW_SMOOTH
#ifdef ALLOW_GENCOST_CONTRIBUTION
c     == local variables ==

      integer bi,bj
      integer i,j,k
      integer itlo,ithi
      integer jtlo,jthi
      integer jmin,jmax
      integer imin,imax
      integer irec,jrec,krec
      integer ilps

      logical doglobalread
      logical ladinit

      _RL mydummy
      _RL mybar(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL anom_sst(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL obs_sst (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL nb_sst (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL msk_sst (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL tmp_sst (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL spval

      _RL junk,junkweight

      integer ndaysave
      _RL ndaysaveRL

      integer k2, k2_lsc

      character*(MAX_LEN_FNAM) fname
      character*(MAX_LEN_FNAM) fname2

#ifdef ALLOW_ECCO_DEBUG
      character*(MAX_LEN_MBUF) msgBuf
      INTEGER ioUnit
#endif
      logical exst

      _RL daytime
      _RL diffsecs
      integer il, localrec
      integer dayiter
      integer daydate(4)
      integer difftime(4)
      integer tempDate_1
      integer middate(4)
      integer locstartdate(4)
      integer yday, ymod
      integer md, dd, sd, ld, wd

      integer kgen, kgen_lsc
      logical dosumsq

c     == external functions ==

      integer  ilnblnk
      external ilnblnk

c     == end of interface ==

      jtlo = myByLo(myThid)
      jthi = myByHi(myThid)
      itlo = myBxLo(myThid)
      ithi = myBxHi(myThid)
      jmin = 1
      jmax = sNy
      imin = 1
      imax = sNx

#ifdef ALLOW_ECCO_DEBUG
      ioUnit=standardMessageUnit
#endif

c-- detect the relevant gencost indices
      kgen=0
      kgen_lsc=0
      k2_lsc=0
      do k=1,NGENCOST
       if (gencost_name(k).EQ.'sstv4-amsre') kgen=k
       if (gencost_name(k).EQ.'sstv4-amsre-lsc') then
        kgen_lsc=k
        do k2 = 1, NGENPPROC
         if (gencost_posproc(k2,kgen_lsc).EQ.'smooth') k2_lsc=k2
        enddo
       endif
      enddo

      if (kgen.NE.0) then
c ------

      dosumsq=.TRUE.
      call ecco_zero( gencost_weight(1-OLx,1-OLy,1,1,kgen),
     &                1, zeroRL, myThid )
      call ecco_zero( gencost_weight(1-OLx,1-OLy,1,1,kgen_lsc),
     &                1, zeroRL, myThid )
      if ( gencost_errfile(kgen) .NE. ' ' )
     &   call ecco_readwei( gencost_errfile(kgen),
     &     gencost_weight(1-OLx,1-OLy,1,1,kgen),
     &     1, 1, 1, dosumsq, myThid )
      if ( gencost_errfile(kgen_lsc) .NE. ' ' )
     &   call ecco_readwei( gencost_errfile(kgen_lsc),
     &     gencost_weight(1-OLx,1-OLy,1,1,kgen_lsc),
     &     1, 1, 1, dosumsq, myThid )

      call cal_FullDate(19920101,0,locstartdate,myThid)

c--   First, read tiled data.
      doglobalread = .false.
      ladinit      = .false.

      ilps=ilnblnk( gencost_barfile(kgen) )
      write(fname,'(2a,i10.10)')
     &     gencost_barfile(kgen)(1:ilps),'.',eccoiter

      spval = gencost_spmin(kgen)
      mydummy = gencost_dummy(kgen)

cgf =======================================================
cgf PART 1: compute smooth SST cost term
cgf =======================================================

      ndaysave=7
      ndaysaveRL=ndaysave

      do irec = 1, ndaysrec-ndaysave+1, 7

         do bj = jtlo,jthi
          do bi = itlo,ithi
           do j = jmin,jmax
            do i = imin,imax
              anom_sst(i,j,bi,bj)  = 0. _d 0
              obs_sst(i,j,bi,bj)  = 0. _d 0
              nb_sst(i,j,bi,bj)  = 0. _d 0
              msk_sst(i,j,bi,bj)  = 0. _d 0
            enddo
           enddo
          enddo
         enddo

c PART 1.1: compute running sample average over ndaysave
c ------------------------------------------------------

         do jrec=1,ndaysave

           krec=irec+jrec-1

c get modeled sst:
#ifdef ALLOW_AUTODIFF
             call active_read_xy( fname, mybar, krec, doglobalread,
     &                       ladinit, eccoiter, myThid,
     &                       mydummy )
#else
             CALL READ_REC_XY_RL( fname, mybar, kRec, 1, myThid )
#endif

c get observed sst:
             daytime = FLOAT(secondsperday*(krec-1)) + modelstart
             dayiter = hoursperday*(krec-1)+modeliter0
             call cal_getdate( dayiter, daytime, daydate, myThid )
             call cal_convdate( daydate,yday,md,dd,sd,ld,wd,myThid )
             ymod = locstartdate(1)/10000
             if ( ymod .GE. yday ) then
               middate(1)=1
               call cal_FullDate(locstartdate(1),0,middate,myThid)
             else
               middate(1)=1
               tempDate_1 = yday*10000+100+1
               call cal_FullDate( tempDate_1, 0, middate, myThid)
             endif
             call cal_TimePassed( middate, daydate, difftime, myThid )
             call cal_ToSeconds( difftime, diffsecs, myThid )
c             localrec = floor(diffsecs/86400.) + 1
             localrec = int(diffsecs/86400.) + 1

             il=ilnblnk(gencost_datafile(kgen))
             write(fname2,'(2a,i4)')
     &         gencost_datafile(kgen)(1:il), '_', yday
             inquire( file=fname2, exist=exst )

#ifdef ALLOW_ECCO_DEBUG
        WRITE(msgBuf,'(A,I4,A,I4,A,I10,A,1PE15.2)') 'sstv4 reading ',
     &      yday,' ',ymod,' ',localrec,' ',diffsecs
        CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
c
        CALL CAL_PRINTDATE(middate,myThid)
        CALL CAL_PRINTDATE(daydate,myThid)
        CALL CAL_PRINTDATE(difftime,myThid)
#endif

             if ( ( localrec .GT. 0 ).AND.(diffsecs .GT. 0.d0) ) then
               CALL READ_REC_3D_RL( fname2, cost_iprec, 1,
     &                              tmp_sst, localrec, 1, myThid )
             else
              do bj = jtlo,jthi
                do bi = itlo,ithi
                    do j = jmin,jmax
                      do i = imin,imax
                         tmp_sst(i,j,bi,bj) = spval
                      enddo
                    enddo
                enddo
              enddo
             endif

c accumulate obs and misfit:
             do bj = jtlo,jthi
              do bi = itlo,ithi
               do j = jmin,jmax
                do i = imin,imax
                 if ( (tmp_sst(i,j,bi,bj).GT.spval).AND.
     &                (maskc(i,j,1,bi,bj).EQ.1.) ) then
                  anom_sst(i,j,bi,bj)= anom_sst(i,j,bi,bj)+
     &               mybar(i,j,bi,bj)-tmp_sst(i,j,bi,bj)
                  obs_sst(i,j,bi,bj)= obs_sst(i,j,bi,bj)+
     &               tmp_sst(i,j,bi,bj)
                  nb_sst(i,j,bi,bj)=nb_sst(i,j,bi,bj)+1. _d 0
                 endif
                enddo
               enddo
              enddo
             enddo

         enddo !do jrec=1,ndaysave

c average obs and misfit:
         do bj = jtlo,jthi
          do bi = itlo,ithi
           do j = jmin,jmax
            do i = imin,imax
             if ( nb_sst(i,j,bi,bj) .NE. 0. ) then
              obs_sst(i,j,bi,bj) =
     &            obs_sst(i,j,bi,bj)/nb_sst(i,j,bi,bj)
              anom_sst(i,j,bi,bj) =
     &            anom_sst(i,j,bi,bj)/nb_sst(i,j,bi,bj)
              msk_sst(i,j,bi,bj) = 1. _d 0
             endif
            enddo
           enddo
          enddo
         enddo

c PART 1.2: smooth anom_sst in space
c ----------------------------------------

#ifdef ALLOW_GENCOST_SSTV4_OUTPUT
         write(fname2,'(1a)') 'sstdiff_raw'
         CALL WRITE_REC_3D_RL( fname2, precFloat32, 1,
     &                         anom_sst, irec, 1, myThid )
         write(fname2,'(1a)') 'sstobs_raw'
         CALL WRITE_REC_3D_RL( fname2, precFloat32, 1,
     &                         obs_sst, irec, 1, myThid )
#endif

         if ( useSMOOTH.AND.(k2_lsc.GT.0) )
     &     call smooth_hetero2d(anom_sst,maskInC,
     &     gencost_posproc_c(k2_lsc,kgen_lsc),
     &     gencost_posproc_i(k2_lsc,kgen_lsc),myThid)

#ifdef ALLOW_GENCOST_SSTV4_OUTPUT
         if ( useSMOOTH.AND.(k2_lsc.GT.0) )
     &     call smooth_hetero2d(obs_sst,maskInC,
     &     gencost_posproc_c(k2_lsc,kgen_lsc),
     &     gencost_posproc_i(k2_lsc,kgen_lsc),myThid)

         write(fname2,'(1a)') 'sstdiff_smooth'
         CALL WRITE_REC_3D_RL( fname2, precFloat32, 1,
     &                         anom_sst, irec, 1, myThid )
         write(fname2,'(1a)') 'sstobs_smooth'
         CALL WRITE_REC_3D_RL( fname2, precFloat32, 1,
     &                         obs_sst, irec, 1, myThid )
#endif

c PART 1.3: compute cost function term
c ------------------------------------

         do bj = jtlo,jthi
          do bi = itlo,ithi
           do j = jmin,jmax
            do i = imin,imax
             junk = anom_sst(i,j,bi,bj)
             junkweight = gencost_weight(i,j,bi,bj,kgen_lsc)*
     &          maskc(i,j,1,bi,bj)
             objf_gencost(bi,bj,kgen_lsc) =
     &          objf_gencost(bi,bj,kgen_lsc)
     &            +junk*junk*junkweight/ndaysaveRL
             if ( (junkweight.GT.0.).AND.(nb_sst(i,j,bi,bj).GT.0.) )
     &          num_gencost(bi,bj,kgen_lsc) =
     &          num_gencost(bi,bj,kgen_lsc) + 1. _d 0 /ndaysaveRL
            enddo
           enddo
          enddo
         enddo

      enddo

cgf =======================================================
cgf PART 2: compute raw SST cost term
cgf =======================================================

      do irec = 1, ndaysrec

c get modeled sst:
#ifdef ALLOW_AUTODIFF
        call active_read_xy( fname, mybar, irec, doglobalread,
     &                       ladinit, eccoiter, myThid,
     &                       mydummy )
#else
        CALL READ_REC_XY_RL( fname, mybar, iRec, 1, myThid )
#endif

c get observed sst:
             daytime = FLOAT(secondsperday*(irec-1)) + modelstart
             dayiter = hoursperday*(irec-1)+modeliter0
             call cal_getdate( dayiter, daytime, daydate, myThid )
             call cal_convdate( daydate,yday,md,dd,sd,ld,wd,myThid )
             ymod = locstartdate(1)/10000
             if ( ymod .GE. yday ) then
               middate(1)=1
               call cal_FullDate(locstartdate(1),0,middate,myThid)
             else
               middate(1)=1
               tempDate_1 = yday*10000+100+1
               call cal_FullDate( tempDate_1, 0, middate, myThid)
             endif
             call cal_TimePassed( middate, daydate, difftime, myThid )
             call cal_ToSeconds( difftime, diffsecs, myThid )
c             localrec = floor(diffsecs/86400.) + 1
             localrec = int(diffsecs/86400.) + 1

             il=ilnblnk(gencost_datafile(kgen))
             write(fname2,'(2a,i4)')
     &         gencost_datafile(kgen)(1:il), '_', yday
             inquire( file=fname2, exist=exst )

#ifdef ALLOW_ECCO_DEBUG
        WRITE(msgBuf,'(A,I4,A,I4,A,I10,A,1PE15.2)') 'sstv4 reading ',
     &      yday,' ',ymod,' ',localrec,' ',diffsecs
        CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
c
        CALL CAL_PRINTDATE(middate,myThid)
        CALL CAL_PRINTDATE(daydate,myThid)
        CALL CAL_PRINTDATE(difftime,myThid)
#endif

             if ( ( localrec .GT. 0 ).AND.(diffsecs .GT. 0.d0) ) then
               call READ_REC_3D_RL( fname2, cost_iprec, 1,
     &                              tmp_sst, localrec, 1, myThid )
             else
              do bj = jtlo,jthi
                do bi = itlo,ithi
                    do j = jmin,jmax
                      do i = imin,imax
                         tmp_sst(i,j,bi,bj) = spval
                      enddo
                    enddo
                enddo
              enddo
             endif

c compute misfit:
         do bj = jtlo,jthi
          do bi = itlo,ithi
           do j = jmin,jmax
            do i = imin,imax
             if ( (tmp_sst(i,j,bi,bj).GT.spval).AND.
     &            (maskc(i,j,1,bi,bj).EQ.1.) ) then
              anom_sst(i,j,bi,bj) =
     &               mybar(i,j,bi,bj)-tmp_sst(i,j,bi,bj)
              msk_sst(i,j,bi,bj) = 1. _d 0
             else
              anom_sst(i,j,bi,bj) = 0. _d 0
              msk_sst(i,j,bi,bj) = 0. _d 0
             endif
            enddo
           enddo
          enddo
         enddo

#ifdef ALLOW_GENCOST_SSTV4_OUTPUT
         write(fname2,'(1a)') 'sstdiff_point'
         CALL WRITE_REC_3D_RL( fname2, precFloat32, 1,
     &                         anom_sst, irec, 1, myThid )
#endif

c compute cost:

         do bj = jtlo,jthi
          do bi = itlo,ithi
           do j = jmin,jmax
            do i = imin,imax
             junk = anom_sst(i,j,bi,bj)
             junkweight = gencost_weight(i,j,bi,bj,kgen)*
     &          maskc(i,j,1,bi,bj)*msk_sst(i,j,bi,bj)
             objf_gencost(bi,bj,kgen) =
     &          objf_gencost(bi,bj,kgen)+junk*junk*junkweight
             if (junkweight.GT.0.)
     &          num_gencost(bi,bj,kgen) =
     &          num_gencost(bi,bj,kgen) + 1. _d 0
            enddo
           enddo
          enddo
         enddo

      enddo

c ------
      endif !if (kgen.NE.0) then

#endif /* ifdef ALLOW_GENCOST_CONTRIBUTION */
#endif /* ifdef ALLOW_SMOOTH */

      RETURN
      END

#include "CPP_OPTIONS.h"

CBOP
C     !ROUTINE: ADAMS_BASHFORTH2
C     !INTERFACE:
      SUBROUTINE ADAMS_BASHFORTH2(
     I                     bi, bj, kArg, kSize,
     U                     gTracer, gTrNm1,
     O                     AB_gTr,
     I                     startAB, myIter, myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R ADAMS_BASHFORTH2
C     | o Extrapolate forward in time using quasi-second order
C     |   Adams-Bashforth method.
C     *==========================================================*
C     | Either apply to tendency (kArg>0) at level k=kArg,
C     |     or apply to state variable (kArg=0) for all levels
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     == Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine Arguments ==
C     bi,bj   :: Tile indices
C     kArg    :: if >0: apply AB on tendency at level k=kArg
C             :: if =0: apply AB on state variable and process all levels
C     kSize   :: 3rd dimension of tracer and tendency arrays
C     gTracer ::  in: Tendency/State at current time
C             :: out (kArg >0): Extrapolated Tendency at current time
C     gTrNm1  ::  in: Tendency/State at previous time
C             :: out: (kArg >0) Save tendency at current time
C             :: out: (kArg =0) Extrapolated State at current time
C     AB_gTr  :: Adams-Bashforth tendency increment
C     startAB :: number of previous time level available to start/restart AB
C     myIter  :: Current time step number
C     myThid  :: my Thread Id. number
      INTEGER bi, bj, kArg, kSize
      _RL  gTracer(1-OLx:sNx+OLx,1-OLy:sNy+OLy,kSize)
      _RL  gTrNm1 (1-OLx:sNx+OLx,1-OLy:sNy+OLy,kSize)
      _RL  AB_gTr (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER startAB
      INTEGER myIter, myThid

C     !LOCAL VARIABLES:
C     == Local variables ==
C     k          :: level index
C     i,j        :: Loop counters
C     abFac      :: Adams bashforth extrapolation factor
      INTEGER i, j, k
      _RL abFac
CEOP

C     Adams-Bashforth extrapolation factor
      IF ( myIter.EQ.nIter0 .AND. startAB.EQ.0 ) THEN
       abFac = 0. _d 0
      ELSE
       abFac = 0.5 _d 0 + abEps
      ENDIF

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      IF ( kArg.EQ.0 ) THEN
C-    Extrapolate forward in time the state variable, with AB weights:
        DO k=1,kSize
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           AB_gTr(i,j) = abFac*( gTracer(i,j,k) - gTrNm1(i,j,k) )
           gTrNm1(i,j,k) = gTracer(i,j,k) + AB_gTr(i,j)
          ENDDO
         ENDDO
        ENDDO
      ELSE
C-    Extrapolate forward in time the tendency, with AB weights:
        k = kArg
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
           AB_gTr(i,j) = abFac*( gTracer(i,j,k) - gTrNm1(i,j,k) )
           gTrNm1(i,j,k) = gTracer(i,j,k)
           gTracer(i,j,k) = gTracer(i,j,k) + AB_gTr(i,j)
         ENDDO
        ENDDO
      ENDIF

      RETURN
      END

#include "OBCS_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: OBCS_INIT_FIXED

C     !INTERFACE:
      SUBROUTINE OBCS_INIT_FIXED( myThid )

C     !DESCRIPTION:
C     *==========================================================*
C     | SUBROUTINE OBCS_INIT_FIXED
C     | o Initialise OBCs fixed arrays
C     *==========================================================*

C     !USES:
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "OBCS_PARAMS.h"
#include "OBCS_GRID.h"
#ifdef ALLOW_OBCS_TIDES
# include "OBCS_FIELDS.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     myThid   :: my Thread Id. number
      INTEGER myThid
CEOP

#ifdef ALLOW_OBCS
C     !LOCAL VARIABLES:
C     msgBuf   :: Informational/error message buffer
C     OB_ApplX :: number of grid points (in X dir) overwritten by obcs_apply
C     OB_ApplY :: number of grid points (in Y dir) overwritten by obcs_apply
C     bi,bj    :: tile indices
C     i, j     :: Loop counters
      CHARACTER*(MAX_LEN_MBUF) msgBuf, errMsg
      INTEGER OB_ApplX
      INTEGER OB_ApplY
      INTEGER bi, bj
      INTEGER  i, j
      INTEGER im, jm
      INTEGER iB, jB
      LOGICAL flag
      INTEGER ioUnit
#ifdef ALLOW_OBCS_TIDES
      LOGICAL inCurrentDir
      INTEGER  k, fp
      _RS dummyRS(1)
      _RL recipPeriod, locPh
#endif

#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_ENTER('OBCS_INIT_FIXED',myThid)
#endif

C==   Set Interior mask at Cell Center:

      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
           OBCS_insideMask(i,j,bi,bj) = 1.
         ENDDO
        ENDDO
       ENDDO
      ENDDO

      IF ( insideOBmaskFile.EQ.' ' ) THEN
C--   If no maskFile is provided, set Interior mask from OB list of indices

       DO bj = myByLo(myThid), myByHi(myThid)
        DO bi = myBxLo(myThid), myBxHi(myThid)
         DO j=1,sNy
C-    Eastern boundary
          IF ( OB_Ie(j,bi,bj).NE.OB_indexNone ) THEN
           flag = .TRUE.
           DO i=OB_Ie(j,bi,bj),sNx
             flag = flag .AND.
     &              kSurfC(i,j,bi,bj).LE.Nr .AND. i.NE.OB_Iw(j,bi,bj)
             IF ( flag ) OBCS_insideMask(i,j,bi,bj) = 0.
           ENDDO
          ENDIF
C-    Western boundary
          IF ( OB_Iw(j,bi,bj).NE.OB_indexNone ) THEN
           flag = .TRUE.
           DO i=OB_Iw(j,bi,bj),1,-1
             flag = flag .AND.
     &              kSurfC(i,j,bi,bj).LE.Nr .AND. i.NE.OB_Ie(j,bi,bj)
             IF ( flag ) OBCS_insideMask(i,j,bi,bj) = 0.
           ENDDO
          ENDIF
         ENDDO
         DO i=1,sNx
C-    Northern boundary
          IF ( OB_Jn(i,bi,bj).NE.OB_indexNone ) THEN
           flag = .TRUE.
           DO j=OB_Jn(i,bi,bj),sNy
             flag = flag .AND.
     &              kSurfC(i,j,bi,bj).LE.Nr .AND. j.NE.OB_Js(i,bi,bj)
             IF ( flag ) OBCS_insideMask(i,j,bi,bj) = 0.
           ENDDO
          ENDIF
C-    Southern boundary
          IF ( OB_Js(i,bi,bj).NE.OB_indexNone ) THEN
           flag = .TRUE.
           DO j=OB_Js(i,bi,bj),1,-1
             flag = flag .AND.
     &              kSurfC(i,j,bi,bj).LE.Nr .AND. j.NE.OB_Jn(i,bi,bj)
             IF ( flag ) OBCS_insideMask(i,j,bi,bj) = 0.
           ENDDO
          ENDIF
         ENDDO

C--   end bi,bj loops
        ENDDO
       ENDDO

      ELSE
C--   Read in Interior mask from file :

       CALL READ_FLD_XY_RS( insideOBmaskFile, ' ', OBCS_insideMask,
     &                      0, myThid )

       DO bj = myByLo(myThid), myByHi(myThid)
        DO bi = myBxLo(myThid), myBxHi(myThid)
         DO j=1,sNy
          DO i=1,sNx
           IF ( OBCS_insideMask(i,j,bi,bj).NE.0. )
     &          OBCS_insideMask(i,j,bi,bj) = 1.
          ENDDO
         ENDDO
        ENDDO
       ENDDO

C--   end computing/reading Interior mask
      ENDIF

C--   Fill in the overlap:
      _EXCH_XY_RS( OBCS_insideMask, myThid )

C==   Set interior mask at U & V location (grid-cell Wester & Southern edges)
C     leave OB edges inside (maskIn=1) (e.g., Eastern OB: maskInW(OB_Ie)=1 )
C     so that velocity normal-component at OB is still in Interior region.
      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
         DO j=2-OLy,sNy+OLy
          DO i=2-OLx,sNx+OLx
            maskInW(i,j,bi,bj) = maskInW(i,j,bi,bj)
     &                     *MAX( OBCS_insideMask(i-1,j,bi,bj),
     &                           OBCS_insideMask(i,j,bi,bj) )
            maskInS(i,j,bi,bj) = maskInS(i,j,bi,bj)
     &                     *MAX( OBCS_insideMask(i,j-1,bi,bj),
     &                           OBCS_insideMask(i,j,bi,bj) )
          ENDDO
         ENDDO
       ENDDO
      ENDDO

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C--   After exchange, set tiled index arrays OB_Jn/Js/Ie/Iw in overlap region
C     issue a warning if not consistent (similar to OBCS_CHECK but for overlap)

c     IF ( .TRUE. ) THEN
      IF ( OBCS_indexStatus .LT. 2 ) THEN
       ioUnit = standardMessageUnit
       WRITE(msgBuf,'(2A)')
     &      'OBCS_INIT_FIXED: Setting OB indices in Overlap'
       CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
       WRITE(errMsg,'(2A)') 'S/R OBCS_INIT_FIXED: ',
     &              'Inside Mask and OB locations disagree :'
       flag = .TRUE.
       DO bj = myByLo(myThid), myByHi(myThid)
        DO bi = myBxLo(myThid), myBxHi(myThid)

C-    Eastern boundary
         DO j=1-OLy,sNy+OLy
          DO i=1,sNx+1
           IF ( OBCS_insideMask(i,j,bi,bj).LT.
     &          OBCS_insideMask(i-1,j,bi,bj)
     &          .AND. ( j.LT.1 .OR. j.GT.sNy )
     &          .AND. kSurfW(i,j,bi,bj).LE.Nr ) THEN
            IF ( OB_Ie(j,bi,bj).EQ.OB_indexNone ) THEN
              OB_Ie(j,bi,bj) = i
              WRITE(msgBuf,'(A,I5,2(A,I3),2(A,I5))')
     &        ' Sets OBE(j,bi,bj=',j,',',bi,',',bj,')=', OB_Ie(j,bi,bj)
              CALL PRINT_MESSAGE( msgBuf,ioUnit,SQUEEZE_RIGHT,myThid )
            ELSEIF ( OB_Ie(j,bi,bj).NE.i ) THEN
              IF ( flag ) CALL PRINT_ERROR( errMsg, myThid )
              flag = .FALSE.
              WRITE(msgBuf,'(A,I5,2(A,I3),2(A,I5))')
     &        ' OBE(j,bi,bj=',j,',',bi,',',bj,')=', OB_Ie(j,bi,bj),
     &        ' but from insideMask expects I=', i
              CALL PRINT_ERROR( msgBuf, myThid )
            ENDIF
           ENDIF
          ENDDO
         ENDDO
C-    Western boundary
         DO j=1-OLy,sNy+OLy
          DO i=0,sNx
           IF ( OBCS_insideMask(i,j,bi,bj).LT.
     &          OBCS_insideMask(i+1,j,bi,bj)
     &          .AND. ( j.LT.1 .OR. j.GT.sNy )
     &          .AND. kSurfW(i+1,j,bi,bj).LE.Nr ) THEN
            IF ( OB_Iw(j,bi,bj).EQ.OB_indexNone ) THEN
              OB_Iw(j,bi,bj) = i
              WRITE(msgBuf,'(A,I5,2(A,I3),2(A,I5))')
     &        ' Sets OBW(j,bi,bj=',j,',',bi,',',bj,')=', OB_Iw(j,bi,bj)
              CALL PRINT_MESSAGE( msgBuf,ioUnit,SQUEEZE_RIGHT,myThid )
            ELSEIF ( OB_Iw(j,bi,bj).NE.i ) THEN
              IF ( flag ) CALL PRINT_ERROR( errMsg, myThid )
              flag = .FALSE.
              WRITE(msgBuf,'(A,I5,2(A,I3),2(A,I5))')
     &        ' OBW(j,bi,bj=',j,',',bi,',',bj,')=', OB_Iw(j,bi,bj),
     &        ' but from insideMask expects I=', i
              CALL PRINT_ERROR( msgBuf, myThid )
            ENDIF
           ENDIF
          ENDDO
         ENDDO
C-    Northern boundary
         DO j=1,sNy+1
          DO i=1-OLx,sNx+OLx
           IF ( OBCS_insideMask(i,j,bi,bj).LT.
     &          OBCS_insideMask(i,j-1,bi,bj)
     &          .AND. ( i.LT.1 .OR. i.GT.sNx )
     &          .AND. kSurfS(i,j,bi,bj).LE.Nr ) THEN
            IF ( OB_Jn(i,bi,bj).EQ.OB_indexNone ) THEN
              OB_Jn(i,bi,bj) = j
              WRITE(msgBuf,'(A,I5,2(A,I3),2(A,I5))')
     &        ' Sets OBN(i,bi,bj=',i,',',bi,',',bj,')=', OB_Jn(i,bi,bj)
              CALL PRINT_MESSAGE( msgBuf,ioUnit,SQUEEZE_RIGHT,myThid )
            ELSEIF ( OB_Jn(i,bi,bj).NE.j ) THEN
              IF ( flag ) CALL PRINT_ERROR( errMsg, myThid )
              flag = .FALSE.
              WRITE(msgBuf,'(A,I5,2(A,I3),2(A,I5))')
     &        ' OBN(i,bi,bj=',i,',',bi,',',bj,')=', OB_Jn(i,bi,bj),
     &        ' but from insideMask expects J=', j
              CALL PRINT_ERROR( msgBuf, myThid )
            ENDIF
           ENDIF
          ENDDO
         ENDDO
C-    Southern boundary
         DO j=0,sNy
          DO i=1-OLx,sNx+OLx
           IF ( OBCS_insideMask(i,j,bi,bj).LT.
     &          OBCS_insideMask(i,j+1,bi,bj)
     &          .AND. ( i.LT.1 .OR. i.GT.sNx )
     &          .AND. kSurfS(i,j+1,bi,bj).LE.Nr ) THEN
            IF ( OB_Js(i,bi,bj).EQ.OB_indexNone ) THEN
              OB_Js(i,bi,bj) = j
              WRITE(msgBuf,'(A,I5,2(A,I3),2(A,I5))')
     &        ' Sets OBS(i,bi,bj=',i,',',bi,',',bj,')=', OB_Js(i,bi,bj)
              CALL PRINT_MESSAGE( msgBuf,ioUnit,SQUEEZE_RIGHT,myThid )
            ELSEIF ( OB_Js(i,bi,bj).NE.j ) THEN
              IF ( flag ) CALL PRINT_ERROR( errMsg, myThid )
              flag = .FALSE.
              WRITE(msgBuf,'(A,I5,2(A,I3),2(A,I5))')
     &        ' OBS(i,bi,bj=',i,',',bi,',',bj,')=', OB_Js(i,bi,bj),
     &        ' but from insideMask expects J=', j
              CALL PRINT_ERROR( msgBuf, myThid )
            ENDIF
           ENDIF
          ENDDO
         ENDDO

        ENDDO
       ENDDO
       WRITE(msgBuf,'(2A)')
     &      'OBCS_INIT_FIXED: Setting OB indices in Overlap <= done'
       CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      ENDIF

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C==   After EXCH: reset Interior mask to zero beyond OB: this is necessary
C     when EXCH are not disabled (e.g. with EXCH1) between tile Edges
C     that are closed by OB.
C     Do it over OLx,OLy grid points beyond OB, in agreement with OBCS code
C     (apply_tracer) which overwrites tracer over the same width.
      OB_ApplX = OLx
      OB_ApplY = OLy

      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)

C--   Set Interior mask to zero beyond OB
C-    Eastern boundary
        DO j=1-OLy,sNy+OLy
         jm = MAX( j-1, 1-OLy )
         iB = OB_Ie(j,bi,bj)
         IF ( iB.NE.OB_indexNone ) THEN
           DO i=iB,iB+OB_ApplX-1
             OBCS_insideMask(i,j,bi,bj) = 0.
           ENDDO
           DO i=iB+1,iB+OB_ApplX-1
             maskInW(i,j,bi,bj) = 0.
           ENDDO
           IF ( OB_Ie(jm,bi,bj).NE.OB_indexNone ) THEN
            iB = MAX( iB, OB_Ie(jm,bi,bj) )
            DO i=iB,iB+OB_ApplX-1
             maskInS(i,j,bi,bj) = 0.
            ENDDO
           ENDIF
         ENDIF
        ENDDO
C-    Western boundary
        DO j=1-OLy,sNy+OLy
         jm = MAX( j-1, 1-OLy )
         iB = OB_Iw(j,bi,bj)
         IF ( iB.NE.OB_indexNone ) THEN
           DO i=1-OB_ApplX+iB,iB
             OBCS_insideMask(i,j,bi,bj) = 0.
           ENDDO
           DO i=2-OB_ApplX+iB,iB
             maskInW(i,j,bi,bj) = 0.
           ENDDO
           IF ( OB_Iw(jm,bi,bj).NE.OB_indexNone ) THEN
            iB = MIN( iB, OB_Iw(jm,bi,bj) )
            DO i=1-OB_ApplX+iB,iB
             maskInS(i,j,bi,bj) = 0.
            ENDDO
           ENDIF
         ENDIF
        ENDDO
C-    Northern boundary
        DO i=1-OLx,sNx+OLx
         im = MAX( i-1, 1-OLx )
         jB = OB_Jn(i,bi,bj)
         IF ( jB.NE.OB_indexNone ) THEN
           DO j=jB,jB+OB_ApplY-1
             OBCS_insideMask(i,j,bi,bj) = 0.
           ENDDO
           DO j=jB+1,jB+OB_ApplY-1
             maskInS(i,j,bi,bj) = 0.
           ENDDO
           IF ( OB_Jn(im,bi,bj).NE.OB_indexNone ) THEN
            jB = MAX( jB, OB_Jn(im,bi,bj) )
            DO j=jB,jB+OB_ApplY-1
             maskInW(i,j,bi,bj) = 0.
            ENDDO
           ENDIF
         ENDIF
        ENDDO
C-    Southern boundary
        DO i=1-OLx,sNx+OLx
         im = MAX( i-1, 1-OLx )
         jB = OB_Js(i,bi,bj)
         IF ( jB.NE.OB_indexNone ) THEN
           DO j=1-OB_ApplY+jB,jB
             OBCS_insideMask(i,j,bi,bj) = 0.
           ENDDO
           DO j=2-OB_ApplY+jB,jB
             maskInS(i,j,bi,bj) = 0.
           ENDDO
           IF ( OB_Js(im,bi,bj).NE.OB_indexNone ) THEN
            jB = MIN( jB, OB_Js(im,bi,bj) )
            DO j=1-OB_ApplY+jB,jB
             maskInW(i,j,bi,bj) = 0.
            ENDDO
           ENDIF
         ENDIF
        ENDDO

C--   Apply mask to maskInC :
        DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
            maskInC(i,j,bi,bj) = maskInC(i,j,bi,bj)
     &                          *OBCS_insideMask(i,j,bi,bj)
          ENDDO
        ENDDO

C--   end bi,bj loops
       ENDDO
      ENDDO

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C--   Set OB active tiles:
      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
         tileHasOBE(bi,bj) = .FALSE.
         tileHasOBW(bi,bj) = .FALSE.
         tileHasOBN(bi,bj) = .FALSE.
         tileHasOBS(bi,bj) = .FALSE.
         DO j=1-OLy,sNy+OLy
          tileHasOBE(bi,bj) = tileHasOBE(bi,bj) .OR.
     &                      ( OB_Ie(j,bi,bj).NE.OB_indexNone )
          tileHasOBW(bi,bj) = tileHasOBW(bi,bj) .OR.
     &                      ( OB_Iw(j,bi,bj).NE.OB_indexNone )
         ENDDO
         DO i=1-OLx,sNx+OLx
          tileHasOBN(bi,bj) = tileHasOBN(bi,bj) .OR.
     &                      ( OB_Jn(i,bi,bj).NE.OB_indexNone )
          tileHasOBS(bi,bj) = tileHasOBS(bi,bj) .OR.
     &                      ( OB_Js(i,bi,bj).NE.OB_indexNone )
         ENDDO
       ENDDO
      ENDDO

C--   Set domain connected-piece Id for OB grid points:
      CALL OBCS_SET_CONNECT( myThid )

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
#ifdef ALLOW_OBCS_TIDES
C==   Set-up OB Tidal forcing
C     (kept fixed during simulation --> moved here from obcs_init_variables.F)

C--   Initialise Tidal Component coeff:
      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
        DO k=1,OBCS_tideCompSize
         DO i=1-OLx,sNx+OLx
# ifdef ALLOW_OBCS_NORTH
          OBN_uTideCs(i,k,bi,bj) = 0. _d 0
          OBN_uTideSn(i,k,bi,bj) = 0. _d 0
          OBN_vTideCs(i,k,bi,bj) = 0. _d 0
          OBN_vTideSn(i,k,bi,bj) = 0. _d 0
# endif
# ifdef ALLOW_OBCS_SOUTH
          OBS_uTideCs(i,k,bi,bj) = 0. _d 0
          OBS_uTideSn(i,k,bi,bj) = 0. _d 0
          OBS_vTideCs(i,k,bi,bj) = 0. _d 0
          OBS_vTideSn(i,k,bi,bj) = 0. _d 0
# endif
         ENDDO
         DO j=1-OLy,sNy+OLy
# ifdef ALLOW_OBCS_EAST
          OBE_uTideCs(j,k,bi,bj) = 0. _d 0
          OBE_uTideSn(j,k,bi,bj) = 0. _d 0
          OBE_vTideCs(j,k,bi,bj) = 0. _d 0
          OBE_vTideSn(j,k,bi,bj) = 0. _d 0
# endif
# ifdef ALLOW_OBCS_WEST
          OBW_uTideCs(j,k,bi,bj) = 0. _d 0
          OBW_uTideSn(j,k,bi,bj) = 0. _d 0
          OBW_vTideCs(j,k,bi,bj) = 0. _d 0
          OBW_vTideSn(j,k,bi,bj) = 0. _d 0
# endif
         ENDDO
        ENDDO
       ENDDO
      ENDDO
      _BARRIER

      IF ( useOBCStides ) THEN
C--   Read from files Barotropic Tidal Amplitude and Phase:
       fp = readBinaryPrec
       inCurrentDir = .FALSE.
# ifdef ALLOW_MDSIO
#  ifdef ALLOW_OBCS_NORTH
       IF ( OBN_uTidAmFile .NE. ' '  )
     &   CALL MDS_READ_SEC_XZ( OBN_uTidAmFile, fp, inCurrentDir, 'RL',
     &                         OBCS_tideCompSize, 1, OBCS_nTidalComp,
     &                         OBN_uTideCs, dummyRS, 1, myThid )
       IF ( OBN_uTidPhFile .NE. ' '  )
     &   CALL MDS_READ_SEC_XZ( OBN_uTidPhFile, fp, inCurrentDir, 'RL',
     &                         OBCS_tideCompSize, 1, OBCS_nTidalComp,
     &                         OBN_uTideSn, dummyRS, 1, myThid )
       IF ( OBN_vTidAmFile .NE. ' '  )
     &   CALL MDS_READ_SEC_XZ( OBN_vTidAmFile, fp, inCurrentDir, 'RL',
     &                         OBCS_tideCompSize, 1, OBCS_nTidalComp,
     &                         OBN_vTideCs, dummyRS, 1, myThid )
       IF ( OBN_vTidPhFile .NE. ' '  )
     &   CALL MDS_READ_SEC_XZ( OBN_vTidPhFile, fp, inCurrentDir, 'RL',
     &                         OBCS_tideCompSize, 1, OBCS_nTidalComp,
     &                         OBN_vTideSn, dummyRS, 1, myThid )
#  endif
#  ifdef ALLOW_OBCS_SOUTH
       IF ( OBS_uTidAmFile .NE. ' '  )
     &   CALL MDS_READ_SEC_XZ( OBS_uTidAmFile, fp, inCurrentDir, 'RL',
     &                         OBCS_tideCompSize, 1, OBCS_nTidalComp,
     &                         OBS_uTideCs, dummyRS, 1, myThid )
       IF ( OBS_uTidPhFile .NE. ' '  )
     &   CALL MDS_READ_SEC_XZ( OBS_uTidPhFile, fp, inCurrentDir, 'RL',
     &                         OBCS_tideCompSize, 1, OBCS_nTidalComp,
     &                         OBS_uTideSn, dummyRS, 1, myThid )
       IF ( OBS_vTidAmFile .NE. ' '  )
     &   CALL MDS_READ_SEC_XZ( OBS_vTidAmFile, fp, inCurrentDir, 'RL',
     &                         OBCS_tideCompSize, 1, OBCS_nTidalComp,
     &                         OBS_vTideCs, dummyRS, 1, myThid )
       IF ( OBS_vTidPhFile .NE. ' '  )
     &   CALL MDS_READ_SEC_XZ( OBS_vTidPhFile, fp, inCurrentDir, 'RL',
     &                         OBCS_tideCompSize, 1, OBCS_nTidalComp,
     &                         OBS_vTideSn, dummyRS, 1, myThid )
#  endif
#  ifdef ALLOW_OBCS_EAST
       IF ( OBE_uTidAmFile .NE. ' '  )
     &   CALL MDS_READ_SEC_YZ( OBE_uTidAmFile, fp, inCurrentDir, 'RL',
     &                         OBCS_tideCompSize, 1, OBCS_nTidalComp,
     &                         OBE_uTideCs, dummyRS, 1, myThid )
       IF ( OBE_uTidPhFile .NE. ' '  )
     &   CALL MDS_READ_SEC_YZ( OBE_uTidPhFile, fp, inCurrentDir, 'RL',
     &                         OBCS_tideCompSize, 1, OBCS_nTidalComp,
     &                         OBE_uTideSn, dummyRS, 1, myThid )
       IF ( OBE_vTidAmFile .NE. ' '  )
     &   CALL MDS_READ_SEC_YZ( OBE_vTidAmFile, fp, inCurrentDir, 'RL',
     &                         OBCS_tideCompSize, 1, OBCS_nTidalComp,
     &                         OBE_vTideCs, dummyRS, 1, myThid )
       IF ( OBE_vTidPhFile .NE. ' '  )
     &   CALL MDS_READ_SEC_YZ( OBE_vTidPhFile, fp, inCurrentDir, 'RL',
     &                         OBCS_tideCompSize, 1, OBCS_nTidalComp,
     &                         OBE_vTideSn, dummyRS, 1, myThid )
#  endif
#  ifdef ALLOW_OBCS_WEST
       IF ( OBW_uTidAmFile .NE. ' '  )
     &   CALL MDS_READ_SEC_YZ( OBW_uTidAmFile, fp, inCurrentDir, 'RL',
     &                         OBCS_tideCompSize, 1, OBCS_nTidalComp,
     &                         OBW_uTideCs, dummyRS, 1, myThid )
       IF ( OBW_uTidPhFile .NE. ' '  )
     &   CALL MDS_READ_SEC_YZ( OBW_uTidPhFile, fp, inCurrentDir, 'RL',
     &                         OBCS_tideCompSize, 1, OBCS_nTidalComp,
     &                         OBW_uTideSn, dummyRS, 1, myThid )
       IF ( OBW_vTidAmFile .NE. ' '  )
     &   CALL MDS_READ_SEC_YZ( OBW_vTidAmFile, fp, inCurrentDir, 'RL',
     &                         OBCS_tideCompSize, 1, OBCS_nTidalComp,
     &                         OBW_vTideCs, dummyRS, 1, myThid )
       IF ( OBW_vTidPhFile .NE. ' '  )
     &   CALL MDS_READ_SEC_YZ( OBW_vTidPhFile, fp, inCurrentDir, 'RL',
     &                         OBCS_tideCompSize, 1, OBCS_nTidalComp,
     &                         OBW_vTideSn, dummyRS, 1, myThid )
#  endif
# else /* ALLOW_MDSIO */
       STOP 'ABNORMAL END: S/R OBCS_INIT_FIXED needs pkg/mdsio'
# endif /* ALLOW_MDSIO */
       _BARRIER

C--   Set Tidal coeff (= Amplit x COS & SIN of Phase ) from Amplitude and Phase:
       DO bj = myByLo(myThid), myByHi(myThid)
        DO bi = myBxLo(myThid), myBxHi(myThid)
         DO k=1,OBCS_nTidalComp
          IF ( OBCS_tidalPeriod(k).NE.zeroRL ) THEN
           recipPeriod = twoRL * PI / OBCS_tidalPeriod(k)
           DO i=1-OLx,sNx+OLx
# ifdef ALLOW_OBCS_NORTH
            locPh = OBN_uTideSn(i,k,bi,bj)*recipPeriod
            OBN_uTideSn(i,k,bi,bj) = OBN_uTideCs(i,k,bi,bj)*SIN(locPh)
            OBN_uTideCs(i,k,bi,bj) = OBN_uTideCs(i,k,bi,bj)*COS(locPh)
            locPh = OBN_vTideSn(i,k,bi,bj)*recipPeriod
            OBN_vTideSn(i,k,bi,bj) = OBN_vTideCs(i,k,bi,bj)*SIN(locPh)
            OBN_vTideCs(i,k,bi,bj) = OBN_vTideCs(i,k,bi,bj)*COS(locPh)
# endif
# ifdef ALLOW_OBCS_SOUTH
            locPh = OBS_uTideSn(i,k,bi,bj)*recipPeriod
            OBS_uTideSn(i,k,bi,bj) = OBS_uTideCs(i,k,bi,bj)*SIN(locPh)
            OBS_uTideCs(i,k,bi,bj) = OBS_uTideCs(i,k,bi,bj)*COS(locPh)
            locPh = OBS_vTideSn(i,k,bi,bj)*recipPeriod
            OBS_vTideSn(i,k,bi,bj) = OBS_vTideCs(i,k,bi,bj)*SIN(locPh)
            OBS_vTideCs(i,k,bi,bj) = OBS_vTideCs(i,k,bi,bj)*COS(locPh)
# endif
           ENDDO
           DO j=1-OLy,sNy+OLy
# ifdef ALLOW_OBCS_EAST
            locPh = OBE_uTideSn(j,k,bi,bj)*recipPeriod
            OBE_uTideSn(j,k,bi,bj) = OBE_uTideCs(j,k,bi,bj)*SIN(locPh)
            OBE_uTideCs(j,k,bi,bj) = OBE_uTideCs(j,k,bi,bj)*COS(locPh)
            locPh = OBE_vTideSn(j,k,bi,bj)*recipPeriod
            OBE_vTideSn(j,k,bi,bj) = OBE_vTideCs(j,k,bi,bj)*SIN(locPh)
            OBE_vTideCs(j,k,bi,bj) = OBE_vTideCs(j,k,bi,bj)*COS(locPh)
# endif
# ifdef ALLOW_OBCS_WEST
            locPh = OBW_uTideSn(j,k,bi,bj)*recipPeriod
            OBW_uTideSn(j,k,bi,bj) = OBW_uTideCs(j,k,bi,bj)*SIN(locPh)
            OBW_uTideCs(j,k,bi,bj) = OBW_uTideCs(j,k,bi,bj)*COS(locPh)
            locPh = OBW_vTideSn(j,k,bi,bj)*recipPeriod
            OBW_vTideSn(j,k,bi,bj) = OBW_vTideCs(j,k,bi,bj)*SIN(locPh)
            OBW_vTideCs(j,k,bi,bj) = OBW_vTideCs(j,k,bi,bj)*COS(locPh)
# endif
           ENDDO
          ENDIF
         ENDDO
C-    end bi.bj loops:
        ENDDO
       ENDDO
C-    end if useOBCStides
      ENDIF

#endif /* ALLOW_OBCS_TIDES */
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#ifdef ALLOW_CTRL
c--   Get the weights that are to be used for the individual cost
c--   function contributions.
      CALL OBCS_COST_WEIGHTS( myThid )
#endif

#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_LEAVE('OBCS_INIT_FIXED',myThid)
#endif

#endif /* ALLOW_OBCS */
      RETURN
      END

#include "CPP_EEOPTIONS.h"

C--   File global_sum.F: Routines that perform global sum on an array
C                        of thread values.
C--    Contents
C--    o GLOBAL_SUM_R4
C--    o GLOBAL_SUM_R8
C--    o GLOBAL_SUM_INT

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: GLOBAL_SUM_R4

C     !INTERFACE:
      SUBROUTINE GLOBAL_SUM_R4(
     U                       sumPhi,
     I                       myThid )

C     !DESCRIPTION:
C     *==========================================================*
C     | SUBROUTINE GLOBAL\_SUM\_R4
C     | o Handle sum for real*4 data.
C     *==========================================================*
C     | Perform sum an array of one value per thread and then
C     | sum result of all the processes.
C     | Notes:
C     | Within a process only one thread does the sum.
C     | The same thread also does the inter-process sum for
C     | example with MPI and then writes the result into a shared
C     | location. All threads wait until the sum is avaiailable.
C     *==========================================================*

C     !USES:
      IMPLICIT NONE

C     == Global data ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "EESUPPORT.h"
#include "GLOBAL_SUM.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     sumPhi :: Result of sum.
C     myThid :: My thread id.
      Real*4 sumPhi
      INTEGER myThid

C     !LOCAL VARIABLES:
C     == Local variables ==
C     I      :: Loop counters
C     mpiRC  :: MPI return code
      INTEGER i
      Real*4  tmp
#ifdef ALLOW_USE_MPI
      INTEGER mpiRC
#endif /* ALLOW_USE_MPI */
CEOP

C--   write local sum into array
      phiGSR4(1,myThid) = sumPhi

C--   Can not start until everyone is ready
      CALL BAR2( myThid )

C--   Sum within the process first
      _BEGIN_MASTER( myThid )
       tmp = 0.
       DO i=1,nThreads
        tmp = tmp + phiGSR4(1,i)
       ENDDO
       sumPhi = tmp
#ifdef ALLOW_USE_MPI
       IF ( usingMPI ) THEN
        CALL MPI_Allreduce(tmp,sumPhi,1,MPI_REAL,MPI_SUM,
     &                   MPI_COMM_MODEL,mpiRC)
       ENDIF
#endif /* ALLOW_USE_MPI */
C--     Write solution to place where all threads can see it
       phiGSR4(1,0) = sumPhi

      _END_MASTER( myThid )
C--
      CALL BAR2( myThid )

C--   set result for every process
      sumPhi = phiGSR4(1,0)

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: GLOBAL_SUM_R8

C     !INTERFACE:
      SUBROUTINE GLOBAL_SUM_R8(
     U                       sumPhi,
     I                       myThid )

C     !DESCRIPTION:
C     *==========================================================*
C     | SUBROUTINE GLOBAL\_SUM\_R8
C     | o Handle sum for real*8 data.
C     *==========================================================*
C     | Perform sum an array of one value per thread and then
C     | sum result of all the processes.
C     | Notes:
C     | Within a process only one thread does the sum.
C     | The same thread also does the inter-process sum for
C     | example with MPI and then writes the result into a shared
C     | location. All threads wait until the sum is avaiailable.
C     *==========================================================*

C     !USES:
      IMPLICIT NONE

C     === Global data ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "EESUPPORT.h"
#include "GLOBAL_SUM.h"

C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
C     sumPhi :: Result of sum.
C     myThid :: My thread id.
      Real*8 sumPhi
      INTEGER myThid

C     !LOCAL VARIABLES:
C     === Local variables ===
C     I      :: Loop counters
C     mpiRC  :: MPI return code
      INTEGER i
      Real*8  tmp
#ifdef ALLOW_USE_MPI
      INTEGER mpiRC
#endif   /* ALLOW_USE_MPI */
CEOP

C--   write local sum into array
      phiGSR8(1,myThid) = sumPhi

C--   Can not start until everyone is ready
C     CALL FOOL_THE_COMPILER( phiGSR8 )
C     CALL MS
      CALL BAR2( myThid )
C     _BARRIER
C     _BARRIER
C     CALL FOOL_THE_COMPILER( phiGSR8 )

C--   Sum within the process first
      _BEGIN_MASTER( myThid )
       tmp = 0. _d 0
       DO i=1,nThreads
        tmp = tmp + phiGSR8(1,i)
       ENDDO
       sumPhi = tmp
#ifdef ALLOW_USE_MPI
       IF ( usingMPI ) THEN
        CALL MPI_Allreduce(tmp,sumPhi,1,MPI_DOUBLE_PRECISION,MPI_SUM,
     &                   MPI_COMM_MODEL,mpiRC)
       ENDIF
#endif /* ALLOW_USE_MPI */
C--     Write solution to place where all threads can see it
       phiGSR8(1,0) = sumPhi
      _END_MASTER( myThid )

C--   Do not leave until we are sure that the sum is done
C     CALL FOOL_THE_COMPILER( phiGSR8 )
C     CALL MS
C     _BARRIER
C     _BARRIER
      CALL BAR2( myThid )
C     CALL FOOL_THE_COMPILER( phiGSR8 )

C--   set result for every process
      sumPhi = phiGSR8(1,0)

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: GLOBAL_SUM_INT
C     !INTERFACE:
      SUBROUTINE GLOBAL_SUM_INT(
     U                       sumPhi,
     I                       myThid )

C     !DESCRIPTION:
C     *==========================================================*
C     | SUBROUTINE GLOBAL\_SUM\_INT
C     | o Handle sum for integer data.
C     *==========================================================*
C     | Perform sum an array of one value per thread and then
C     | sum result of all the processes.
C     | Notes:
C     | Within a process only one thread does the sum.
C     | The same thread also does the inter-process sum for
C     | example with MPI and then writes the result into a shared
C     | location. All threads wait until the sum is avaiailable.
C     *==========================================================*

C     !USES:
      IMPLICIT NONE

C     === Global data ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "EESUPPORT.h"
#include "GLOBAL_SUM.h"

C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
C     sumPhi :: Result of sum.
C     myThid :: My thread id.
      INTEGER sumPhi
      INTEGER myThid

C     !LOCAL VARIABLES:
C     === Local variables ===
C     I      :: Loop counters
C     mpiRC  :: MPI return code
      INTEGER i
      INTEGER  tmp
#ifdef ALLOW_USE_MPI
      INTEGER mpiRC
#endif   /* ALLOW_USE_MPI */
CEOP

C--   write local sum into array
      phiGSI(1,myThid) = sumPhi

C--   Can not start until everyone is ready
      _BARRIER

C--   Sum within the process first
      _BEGIN_MASTER( myThid )
       tmp = 0
       DO i=1,nThreads
        tmp = tmp + phiGSI(1,i)
       ENDDO
       sumPhi = tmp
#ifdef ALLOW_USE_MPI
       IF ( usingMPI ) THEN
        CALL MPI_Allreduce(tmp,sumPhi,1,MPI_INTEGER,MPI_SUM,
     &                   MPI_COMM_MODEL,mpiRC)
       ENDIF
#endif /* ALLOW_USE_MPI */
C--     Write solution to place where all threads can see it
       phiGSI(1,0) = sumPhi
      _END_MASTER( myThid )

C--   Do not leave until we are sure that the sum is done
      _BARRIER

C--   set result for every process
      sumPhi = phiGSI(1,0)

      RETURN
      END

#include "AUTODIFF_OPTIONS.h"
#ifdef ALLOW_MOM_COMMON
# include "MOM_COMMON_OPTIONS.h"
#endif /* ALLOW_MOM_COMMON */

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 0
C !ROUTINE: AUTODIFF_READPARMS

C !INTERFACE:
      SUBROUTINE AUTODIFF_READPARMS( myThid )

C     !DESCRIPTION:
C     Initialize AUTODIFF variables and constants.

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "AUTODIFF_PARAMS.h"
#ifdef ALLOW_GENERIC_ADVDIFF
# include "GAD.h"
#endif/* ALLOW_GENERIC_ADVDIFF */
#ifdef ALLOW_SEAICE
# include "SEAICE_SIZE.h"
# include "SEAICE_PARAMS.h"
#endif /* ALLOW_SEAICE */

C     !INPUT PARAMETERS:
      INTEGER myThid
CEOP

#ifdef ALLOW_AUTODIFF

C     !LOCAL VARIABLES:
C     msgBuf     :: Informational/error message buffer
C     iUnit      :: Work variable for IO unit number
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      INTEGER iUnit
      INTEGER errCount
#ifdef ALLOW_GENERIC_ADVDIFF
      LOGICAL validAdvScheme
#endif /* ALLOW_GENERIC_ADVDIFF */
C     retired parameter
      INTEGER nRetired
      LOGICAL useSmoothCorrel2DinAdMode

      NAMELIST /AUTODIFF_PARM01/
     &       dumpAdVarExch, mon_AdVarExch,
     &       dumpAdByRec,
     &       useApproxAdvectionInAdMode,
     &       useKPPinAdMode, useGGL90inAdMode,
     &       useGMRediInAdMode, useSALT_PLUMEinAdMode,
     &       useSEAICEinAdMode, useSmoothCorrel2DinAdMode,
     &       inAdExact, SEAICEapproxLevInAd,
     &       viscFacInAd, viscFacInFw, SIregFacInAd, SIregFacInFw,
     &       SEAICEuseFREEDRIFTswitchInAd, SEAICEuseDYNAMICSswitchInAd,
     &       cg2dFullAdjoint

      IF ( .NOT.useAUTODIFF ) THEN
C-    pkg AUTODIFF is not used
        _BEGIN_MASTER(myThid)
C-    Track pkg activation status:
C     print a (weak) warning if data.autodiff is found
         CALL PACKAGES_UNUSED_MSG( 'useAUTODIFF', ' ', ' ' )
        _END_MASTER(myThid)
        RETURN
      ENDIF

      _BEGIN_MASTER(myThid)
      errCount = 0

C--   Default values for AUTODIFF
      dumpAdVarExch      = 2
      mon_AdVarExch      = 2
C-    to recover old ad-monitor & ad-dump behaviour:
c     dumpAdVarExch      = 1
c     mon_AdVarExch      = 0
C--   default : write one file per record
      dumpAdByRec        = .FALSE.
      useKPPinAdMode     = .TRUE.
      useGMRediInAdMode  = .TRUE.
      useSEAICEinAdMode  = .TRUE.
      useGGL90inAdMode   = .TRUE.
      useSALT_PLUMEinAdMode = .TRUE.
      cg2dFullAdjoint    = .FALSE.
      inAdExact          = .TRUE.
      useApproxAdvectionInAdMode = .FALSE.
      SEAICEapproxLevInAd = 0
      viscFacInFw        = 1. _d 0
      viscFacInAd        = 1. _d 0
      SIregFacInAd       = UNSET_RL
      SIregFacInFw       = UNSET_RL

C-- pkg/seaice related switches
      SEAICEuseFREEDRIFTswitchInAd = .FALSE.
      SEAICEuseDYNAMICSswitchInAd  = .FALSE.
      useSmoothCorrel2DinAdMode    = .TRUE.

      WRITE(msgBuf,'(A)') 'AUTODIFF_READPARMS: opening data.autodiff'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      CALL OPEN_COPY_DATA_FILE(
     I                     'data.autodiff', 'AUTODIFF_READPARMS',
     O                     iUnit,
     I                     myThid )

C     Read parameters from open data file
      READ(UNIT=iUnit,NML=AUTODIFF_PARM01)
      WRITE(msgBuf,'(A)')
     &    'AUTODIFF_READPARMS: finished reading data.autodiff'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
C     Close the open data file
#ifdef SINGLE_DISK_IO
      CLOSE(iUnit)
#else
      CLOSE(iUnit,STATUS='DELETE')
#endif /* SINGLE_DISK_IO */

C--   Flags for approximate adjoint. Flag inAdMode is set/unset in
C     autodiff_inadmode_set/unset_ad.F. Wherever inAdMode is used it requires
C     using inAdExact or useApproxAdvectionInAdMode along with it.
      IF ( .NOT.inAdExact ) THEN
C     reset to recover old behavior, in case that is ever needed
       useApproxAdvectionInAdMode = .TRUE.
       WRITE(msgBuf,'(A)') '**WARNING** AUTODIFF_READPARMS: '//
     &      'resetting useApproxAdvectionInAdMode to .TRUE., '//
     &      'because inAdExact=.FALSE.'
       CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                     SQUEEZE_RIGHT, myThid )
      ENDIF
      inAdMode   = .FALSE.

C--   packages which can be switched off in adjoint mode (approximate adjoint):
C     store value of usePKG as it will be reset in S/R ADAUTODIFF_INADMODE_UNSET
      useKPPinFwdMode    = useKPP
      useGMRediInFwdMode = useGMRedi
      useSEAICEinFwdMode = useSEAICE
      useGGL90inFwdMode  = useGGL90
      useSALT_PLUMEinFwdMode = useSALT_PLUME

C     store value of usePKG as it will be set in S/R ADAUTODIFF_INADMODE_SET
      useKPPinAdMode    = useKPPinAdMode    .AND. useKPP
      useGMRediInAdMode = useGMRediInAdMode .AND. useGMRedi
      useSEAICEinAdMode = useSEAICEinAdMode .AND. useSEAICE
      useGGL90inAdMode  = useGGL90inAdMode  .AND. useGGL90
      useSALT_PLUMEinAdMode = useSALT_PLUMEinAdMode .AND. useSALT_PLUME

C     set this parameter to something we want to be able specify in a namelist
      viscFacAdj = viscFacInFw

#ifdef ALLOW_SEAICE
c     level of approximation in seaice thermodynamics adjoint
      if (useSEAICEinFwdMode.AND.(.NOT.useSEAICEinAdMode))
     &   SEAICEapproxLevInAd=MIN(SEAICEapproxLevInAd,0)
      if (useSEAICEinAdMode)
     &   SEAICEapproxLevInAd=MAX(SEAICEapproxLevInAd,0)
#endif

C-    Retired parameters
      nRetired = 0
      IF ( .NOT. useSmoothCorrel2DinAdMode ) THEN
       nRetired = nRetired + 1
       WRITE(msgBuf,'(A,A)')
     &  'S/R AUTODIFF_READPARMS: "useSmoothCorrel2DinAdMode" ',
     &  'is no longer allowed in file "data.autodiff"'
       CALL PRINT_ERROR( msgBuf, myThid )
       WRITE(msgBuf,'(A)')
     &  'S/R AUTODIFF_READPARMS: use "pkg/smooth" instead'
       CALL PRINT_ERROR( msgBuf, myThid )
      ENDIF
      IF ( nRetired .GT. 0 ) THEN
       CALL ALL_PROC_DIE( 0 )
       STOP 'ABNORMAL END: S/R AUTODIFF_READPARMS'
      ENDIF

C--   Print out some key parameters :
      WRITE(msgBuf,'(A)') '// ==================================='
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)') '// AUTODIFF parameters :'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)') '// ==================================='
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
       CALL WRITE_0D_L( inAdExact, INDEX_NONE,
     &  'inAdExact =', ' /* get an exact adjoint (no approximation) */')
       CALL WRITE_0D_L( useApproxAdvectionInAdMode, INDEX_NONE,
     & 'useApproxAdvectionInAdMode =',' /* approximate AD-advection */')
       CALL WRITE_0D_L( cg2dFullAdjoint, INDEX_NONE,
     &   'cg2dFullAdjoint =',
     &   ' /* use full hand written cg2d adjoint (no approximation) */')
       CALL WRITE_0D_L( useKPPinAdMode, INDEX_NONE,
     &   'useKPPinAdMode =',      ' /* use KPP in adjoint mode */')
       CALL WRITE_0D_L( useGMRediInAdMode, INDEX_NONE,
     &  'useGMRediInAdMode =', ' /* use GMRedi in adjoint mode */')
       CALL WRITE_0D_L( useSEAICEinAdMode, INDEX_NONE,
     &  'useSEAICEinAdMode =', ' /* use SEAICE in adjoint mode */')
       CALL WRITE_0D_L( useGGL90inAdMode, INDEX_NONE,
     &   'useGGL90inAdMode =',      ' /* use GGL90 in adjoint mode */')
       CALL WRITE_0D_L( useSALT_PLUMEinAdMode, INDEX_NONE,
     &   'useSALT_PLUMEinAdMode =',
     &   ' /* use SALT_PLUME in adjoint mode */')
#ifdef ALLOW_SEAICE
       CALL WRITE_0D_L( SEAICEuseDYNAMICSswitchInAd, INDEX_NONE,
     &  'SEAICEuseDYNAMICSswitchInAd =',
     &            ' /* switch On/Off SEAICE Dyn in AD mode */')
       CALL WRITE_0D_L( SEAICEuseFREEDRIFTswitchInAd, INDEX_NONE,
     &  'SEAICEuseFREEDRIFTswitchInAd=',
     &            ' /* switch On/Off Free-Drift in AD mode */')
       CALL WRITE_0D_I( SEAICEapproxLevInAd, INDEX_NONE,
     &  'SEAICEapproxLevInAd =',
     &  ' /* -1:SEAICE_FAKE, >0:other adjoint approximation */')
#endif /* ALLOW_SEAICE */
       CALL WRITE_0D_I( dumpAdVarExch, INDEX_NONE,
     &  'dumpAdVarExch =', ' /* control adexch before dumpinp */')
       CALL WRITE_0D_I( mon_AdVarExch, INDEX_NONE,
     &  'mon_AdVarExch =', ' /* control adexch before monitor */')
       CALL WRITE_0D_RL( viscFacInFw, INDEX_NONE,
     &  'viscFacInFw =', ' /* viscosity factor for forward model */')
       CALL WRITE_0D_RL( viscFacInAd, INDEX_NONE,
     &  'viscFacInAd =', ' /* viscosity factor for adjoint */')
       CALL WRITE_0D_RL( SIregFacInAd, INDEX_NONE,
     &  'SIregFacInAd =', ' /* sea ice factor for adjoint model */')
       CALL WRITE_0D_RL( SIregFacInFw, INDEX_NONE,
     &  'SIregFacInFw =', ' /* sea ice factor for forward model */')
      WRITE(msgBuf,'(A)') ' '
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )

C--   Check parameters :
      IF ( viscFacInAd .NE. 1. _d 0 .OR. viscFacInFw .NE. 1. _d 0 ) THEN
#ifndef AUTODIFF_ALLOW_VISCFACADJ
       WRITE(msgBuf,'(2A)') 'AUTODIFF_READPARMS: ',
     &'To use viscFacInFw/viscFacInAd, define AUTODIFF_ALLOW_VISCFACADJ'
       CALL PRINT_ERROR( msgBuf, myThid )
       errCount = errCount + 1
#endif /* AUTODIFF_ALLOW_VISCFACADJ */
#if (!defined ALLOW_3D_VISCAH && !defined ALLOW_3D_VISCA4)
       WRITE(msgBuf,'(2A)') 'AUTODIFF_READPARMS: ',
     &      'To use viscFacInFw/viscFacInAd, '//
     &      'define ALLOW_3D_VISCA4 and/or ALLOW_3D_VISCA4'
       CALL PRINT_ERROR( msgBuf, myThid )
       errCount = errCount + 1
#endif /* ALLOW_3D_VISCA */
#ifdef ALLOW_3D_VISCAH
       IF ( viscAhDfile .EQ. ' ' .AND. viscAhZfile .EQ. ' ' ) THEN
        WRITE(msgBuf,'(2A)') '** WARNING ** AUTODIFF_READPARMS: ',
     &       'For viscFacInFw/viscFacInAd to have any effect, '//
     &       'specify at least one of viscAh[D/Z]file'
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &       SQUEEZE_RIGHT, myThid )
       ENDIF
#endif /* ALLOW_3D_VISCAH */
#ifdef ALLOW_3D_VISCA4
       IF ( viscA4Dfile .EQ. ' ' .AND. viscA4Zfile .EQ. ' ' ) THEN
        WRITE(msgBuf,'(2A)') '** WARNING ** AUTODIFF_READPARMS: ',
     &       'For viscFacInFw/viscFacInAd to have any effect, '//
     &       'specify at least one of viscA4[D/Z]file'
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &       SQUEEZE_RIGHT, myThid )
       ENDIF
#endif /* ALLOW_3D_VISCA4 */
      ENDIF
#ifdef ALLOW_SEAICE
      IF ( SEAICEuseFREEDRIFTswitchInAd .AND. .NOT.useSEAICE ) THEN
        WRITE(msgBuf,'(2A)') 'AUTODIFF_READPARMS: ',
     &  'SEAICEuseFREEDRIFTswitchInAd not usable without useSEAICE'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF
      IF ( SEAICEuseDYNAMICSswitchInAd .AND. .NOT.useSEAICE ) THEN
        WRITE(msgBuf,'(2A)') 'AUTODIFF_READPARMS: ',
     &  'SEAICEuseDYNAMICSswitchInAd not usable without useSEAICE'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF
#else /* ALLOW_SEAICE */
      SEAICEuseFREEDRIFTswitchInAd = .FALSE.
      SEAICEuseDYNAMICSswitchInAd  = .FALSE.
#endif /* ALLOW_SEAICE */

      IF ( useApproxAdvectionInAdMode ) THEN
#ifdef ALLOW_GENERIC_ADVDIFF
C     so far this only works for flux limited DST3 scheme
       validAdvScheme = .FALSE.
       validAdvScheme = validAdvScheme
     &      .OR. tempAdvScheme.EQ.ENUM_DST3_FLUX_LIMIT
     &      .OR. saltAdvScheme.EQ.ENUM_DST3_FLUX_LIMIT
#ifdef ALLOW_SEAICE
       IF ( useSEAICE ) validAdvScheme = validAdvScheme
     &      .OR. SEAICEadvScheme .EQ.ENUM_DST3_FLUX_LIMIT
     &      .OR. SEAICEadvSchArea.EQ.ENUM_DST3_FLUX_LIMIT
     &      .OR. SEAICEadvSchHeff.EQ.ENUM_DST3_FLUX_LIMIT
     &      .OR. SEAICEadvSchSnow.EQ.ENUM_DST3_FLUX_LIMIT
     &      .OR. SEAICEadvSchSalt.EQ.ENUM_DST3_FLUX_LIMIT
#endif /* ALLOW_SEAICE */
       IF ( .NOT. validAdvScheme ) THEN
        WRITE(msgBuf,'(3A)') 'AUTODIFF_READPARMS: ',
     &       'useApproxAdvectionInAdMode = .TRUE. ',
     &       'only makes sense if at least '
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(2A,I2,A)') 'AUTODIFF_READPARMS: ',
     &       'one advection scheme is ', ENUM_DST3_FLUX_LIMIT,
     &       '. Current settings are:'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(2A,I2)') 'AUTODIFF_READPARMS: ',
     &       'tempAdvScheme    = ', tempAdvScheme
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(2A,I2)') 'AUTODIFF_READPARMS: ',
     &       'saltAdvScheme    = ', saltAdvScheme
        CALL PRINT_ERROR( msgBuf, myThid )
#ifdef ALLOW_SEAICE
        IF ( useSEAICE ) THEN
         WRITE(msgBuf,'(2A,I2)') 'AUTODIFF_READPARMS: ',
     &        'SEAICEadvScheme  = ', SEAICEadvScheme
         CALL PRINT_ERROR( msgBuf, myThid )
         WRITE(msgBuf,'(2A,I2)') 'AUTODIFF_READPARMS: ',
     &        'SEAICEadvSchArea = ', SEAICEadvSchArea
         CALL PRINT_ERROR( msgBuf, myThid )
         WRITE(msgBuf,'(2A,I2)') 'AUTODIFF_READPARMS: ',
     &        'SEAICEadvSchHeff = ', SEAICEadvSchHeff
         CALL PRINT_ERROR( msgBuf, myThid )
         WRITE(msgBuf,'(2A,I2)') 'AUTODIFF_READPARMS: ',
     &        'SEAICEadvSchSnow = ', SEAICEadvSchSnow
         CALL PRINT_ERROR( msgBuf, myThid )
         WRITE(msgBuf,'(2A,I2)') 'AUTODIFF_READPARMS: ',
     &        'SEAICEadvSchSalt = ', SEAICEadvSchSalt
         CALL PRINT_ERROR( msgBuf, myThid )
        ENDIF
#endif /* ALLOW_SEAICE */
        errCount = errCount + 1
       ENDIF
#else
       WRITE(msgBuf,'(2A)') 'AUTODIFF_READPARMS: ',
     &  'useApproxAdvectionInAdMode=.TRUE. without pkg/generic_advdiff'
       CALL PRINT_ERROR( msgBuf, myThid )
       errCount = errCount + 1
#endif /* ALLOW_GENERIC_ADVDIFF */
      ENDIF

      IF ( errCount.GE.1 ) THEN
        WRITE(msgBuf,'(A,I3,A)')
     &   'AUTODIFF_READPARMS: detected', errCount,' fatal error(s)'
        CALL PRINT_ERROR( msgBuf, myThid )
        CALL ALL_PROC_DIE( 0 )
        STOP 'ABNORMAL END: S/R AUTODIFF_READPARMS'
      ENDIF

      _END_MASTER(myThid)

C--   Everyone else must wait for the parameters to be loaded
      _BARRIER

#endif /* ALLOW_AUTODIFF */

      RETURN
      END

#include "CPP_OPTIONS.h"

CBOP
C     !ROUTINE: UPDATE_SURF_DR
C     !INTERFACE:
      SUBROUTINE UPDATE_SURF_DR( useLatest, myTime, myIter, myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE UPDATE_SURF_DR
C     | o Update the surface-level thickness fraction (hFacC,W,S)
C     |   according to the surface r-position = Non-Linear FrSurf
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     == Global variables
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "SURFACE.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     useLatest :: if true use hFac_surfC, else use hFac_surfNm1C
C     myTime    :: Current time in simulation
C     myIter    :: Current iteration number in simulation
C     myThid    :: Thread number for this instance of the routine.
      LOGICAL useLatest
      _RL myTime
      INTEGER myIter
      INTEGER myThid

C     !LOCAL VARIABLES:
#ifdef NONLIN_FRSURF
C     Local variables
C     i,j,bi,bj - loop counter
      INTEGER i,j,k,bi,bj
      INTEGER ks
CEOP

      DO bj=myByLo(myThid), myByHi(myThid)
       DO bi=myBxLo(myThid), myBxHi(myThid)

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

       IF (useLatest.AND.(nonlinFreeSurf.GT.0)) then

C-- Update the fractional thickness "hFacC" of the surface level kSurfC :
        DO j=1-Oly,sNy+Oly
         DO i=1-Olx,sNx+Olx
          ks = kSurfC(i,j,bi,bj)
          IF (ks.LE.Nr) THEN
           hFacC(i,j,ks,bi,bj) = hFac_surfC(i,j,bi,bj)
           recip_hFacC(i,j,ks,bi,bj)= 1. _d 0 / hFac_surfC(i,j,bi,bj)
          ENDIF
         ENDDO
        ENDDO

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C-- Update fractional thickness "hFacW" & "hFacS" (at U and V points)

        DO j=1-Oly,sNy+Oly
         DO i=2-Olx,sNx+Olx
          ks = kSurfW(i,j,bi,bj)
          IF (ks.LE.Nr) THEN
           hFacW(i,j,ks,bi,bj) = hFac_surfW(i,j,bi,bj)
           recip_hFacW(i,j,ks,bi,bj)= 1. _d 0 / hFac_surfW(i,j,bi,bj)
          ENDIF
         ENDDO
        ENDDO
        DO j=2-Oly,sNy+Oly
         DO i=1-Olx,sNx+Olx
          ks = kSurfS(i,j,bi,bj)
          IF (ks.LE.Nr) THEN
           hFacS(i,j,ks,bi,bj) = hFac_surfS(i,j,bi,bj)
           recip_hFacS(i,j,ks,bi,bj)= 1. _d 0 / hFac_surfS(i,j,bi,bj)
          ENDIF
         ENDDO
        ENDDO

       ELSEIF (nonlinFreeSurf.GT.0) THEN

C-- Update the fractional thickness "hFacC" of the surface level kSurfC
C:
        DO j=1-Oly,sNy+Oly
         DO i=1-Olx,sNx+Olx
          ks = kSurfC(i,j,bi,bj)
          IF (ks.LE.Nr) THEN
           hFacC(i,j,ks,bi,bj) = hFac_surfNm1C(i,j,bi,bj)
           recip_hFacC(i,j,ks,bi,bj)= 1. _d 0 / hFac_surfNm1C(i,j,bi,bj)
          ENDIF
         ENDDO
        ENDDO

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C-- Update fractional thickness "hFacW" & "hFacS" (at U and V points)

        DO j=1-Oly,sNy+Oly
         DO i=2-Olx,sNx+Olx
          ks = kSurfW(i,j,bi,bj)
          IF (ks.LE.Nr) THEN
           hFacW(i,j,ks,bi,bj) = hFac_surfNm1W(i,j,bi,bj)
           recip_hFacW(i,j,ks,bi,bj)= 1. _d 0 / hFac_surfNm1W(i,j,bi,bj)
          ENDIF
         ENDDO
        ENDDO
        DO j=2-Oly,sNy+Oly
         DO i=1-Olx,sNx+Olx
          ks = kSurfS(i,j,bi,bj)
          IF (ks.LE.Nr) THEN
           hFacS(i,j,ks,bi,bj) = hFac_surfNm1S(i,j,bi,bj)
           recip_hFacS(i,j,ks,bi,bj)= 1. _d 0 / hFac_surfNm1S(i,j,bi,bj)
          ENDIF
         ENDDO
        ENDDO

       ELSE

        DO k=1,Nr
         DO j=1-Oly,sNy+Oly
          DO i=1-Olx,sNx+Olx
           hFacC(i,j,k,bi,bj)=h0FacC(i,j,k,bi,bj)
           IF (h0FacC(i,j,k,bi,bj) .NE. 0. ) THEN
            recip_hFacC(i,j,k,bi,bj) = 1. _d 0 / h0FacC(i,j,k,bi,bj)
           ELSE
            recip_hFacC(i,j,k,bi,bj) = 0.
           ENDIF
          ENDDO
         ENDDO
        ENDDO

       ENDIF

C- end bi,bj loop
       ENDDO
      ENDDO

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
#endif /* NONLIN_FRSURF */

      RETURN
      END

#include "ATM_CPL_OPTIONS.h"

CBOP
C     !ROUTINE: ATM_STORE_MY_DATA
C     !INTERFACE:
      SUBROUTINE ATM_STORE_MY_DATA(
     I                              myTime, myIter, myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE ATM_STORE_MY_DATA
C     | o Routine for controlling storage of some coupling data
C     |   (e.g. fluxes) to coupler layer.
C     |   Note: some other coupling fields (e.g. state variables)
C     |    are stored from elsewhere, just before sending to CPL
C     *==========================================================*
C     | This version interfaces to the MITgcm AIMPHYS package.
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "CPL_PARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     myTime    :: Current internal time.
C     myIter    :: Current timestep number.
C     myThid    :: my Thread Id number
      _RL     myTime
      INTEGER myIter
      INTEGER myThid
CEOP

#ifdef COMPONENT_MODULE
C     !LOCAL VARIABLES:
C     bi, bj    :: Tile indices
      INTEGER bi,bj

      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)

C--   Store coupling data ready for export
        CALL ATM_STORE_SURFFLUX(    bi, bj, myTime, myIter, myThid )
        IF ( useAIM ) THEN
         CALL ATM_STORE_AIM_WNDSTR( bi, bj, myTime, myIter, myThid )
        ENDIF
        IF ( useAIM .AND. atm_cplExch_DIC ) THEN
         CALL ATM_STORE_AIM_FIELDS( bi, bj, myTime, myIter, myThid )
        ENDIF
        IF ( useLand ) THEN
         CALL ATM_STORE_LAND(       bi, bj, myTime, myIter, myThid )
        ENDIF

C-    These 2 calls have been moved to CPL_EXPORT_IMPORT_DATA so that model
C     DynVars and thSIce state-vars are stored (without time averaging over
C     cpl_atmSendFrq) just before beeing exported to Coupler.
c       CALL ATM_STORE_DYNVARS(     bi, bj, myTime, myIter, myThid )
c       IF ( useThSIce ) THEN
c        CALL ATM_STORE_THSICE(     bi, bj, myTime, myIter, myThid )
c       ENDIF

C--   end bi,bj loops.
       ENDDO
      ENDDO

#endif /* COMPONENT_MODULE */

      RETURN
      END

#include "ZONAL_FILT_OPTIONS.h"

      SUBROUTINE ZONAL_FILT_PRESMOOTH(
     I                           holeMask,
     U                           field,
     O                           avgField,
     I                           lField,
     I                           myThid )
C     /==========================================================\
C     | S/R ZONAL_FILT_PRESMOOTH                                 |
C     | o Smooth data with holes ready for FFT.                  |
C     |==========================================================|
C     | FFT routines act on a series of data points. Having      |
C     | arbitrary values in land introduces unrealistic noise in |
C     | the series. A better approach is to linearly ramp data   |
C     | through the missing points. The mean of the field is also|
C     | removed. The mean is restored in FFT_POSTSMOOTH. This    |
C     | step ensures no bias is introduced by the FFT process -  |
C     | strictly it isnt necessary, but it can help improve      |
C     | numerical conditioning.                                  |
C     \==========================================================/
      IMPLICIT NONE

C     == Global data ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"

C     == Routine arguments ==
C     holeMask - Array with 0 for holes and != 0 for valid data.
C     lField   - Length of field to smooth (assumed periodic)
C     field    - Field smoothed.
C     myThid   - Thread number of this instance of FFT_PRESMOOTH_IN_X
      INTEGER lField
      Real*8  holeMask(lField)
      Real*8  field(lField)
      Real*8  avgField
      INTEGER myThid

#ifdef ALLOW_ZONAL_FILT

C     == Local variables ====
C     I         - Loop counter
C     lbuf      - Size of buffer arrays
C     hBase     - Coord for last valid data point.
C     hHead     - Coord for next valid data point.
C     hLo       - Index for last valid data point.
C     hHi       - Index for next valid data point.
C     nValid    - Count of valid data points.
C     dist, len - Temps for interpolating.
C     frac        Interpolation is simple linear ramp
C                 between end-point in grid-point space.
C                 e.g. for a series of points
C          Index    1  2  3  4  5  6  7  8  9 10 11 12
C          Data    M  V  M  M  M  M  V  V  V  V  V  V
C                 where M indicates missing data and V valid
C                 and 1 2 3 .... are indexes in field. Values
C                 for the M points are found by interpolating
C                 between the two V values that bracket a series
C                 of M point. For index=1
C                 dist=1, len=2 and frac=dist/len=1/2 so that
C                 the interpolated value at index=1 is
C                 V(index=12)+frac*( V(index=2)-V(index=12) ).
C                 For index=5 dist=3, len=5 and frac=dist/len=3/5
C                 so interpolated value at index=5 is
C                 V(index=2)+frac*( V(index=7)-V(index=2) ).
C     lastGood  - Temp for tracking of last good data point index.
C     nValid    - Temp for counting number of valid points.
C
      INTEGER lBuf
      PARAMETER ( lBuf = sNx )
      INTEGER hBase(lBuf)
      INTEGER hHead(lBuf)
      INTEGER hLo(lBuf)
      INTEGER hHi(lBuf)
      INTEGER lastGood
      _RL dist
      _RL len
      _RL frac
      INTEGER nValid
      INTEGER I, iLo, iHi


C
      IF ( lField .GT. lBuf ) THEN
       STOP 'S/R FFT_PRESMOOTH_1D: lField .GT. lBuf'
      ENDIF

CcnhDebugStarts
C     WRITE(*,*) 'Before FFT pre-smooth'
C     WRITE(*,'(A,A)') 'Mask ', 'Data'
C     DO I=1,lField
C      WRITE(*,'(A,I4,1X,F3.1,1X,1PE35.25)') 'I= ',I,holeMask(I), field(I)
C     ENDDO
CcnhDebugEnds

C     Count number of valid data points
      nValid   = 0
      avgField = 0.
      DO I=1,lField
       IF ( holeMask(I) .NE. 0. ) THEN
        nValid   = nValid+1
        avgField = avgField+field(I)
       ENDIF
      ENDDO

      IF ( lField .GT. 1 .AND. nValid .GT. 0 ) THEN
C      Get lists of hole starts, ends and extents
C      ( use periodic wrap around ).

C      1. hLo   - Index of valid point at start of run of holes
C         hBase - Coord of hLo (used to get offset when interpolating).
C         Note: The mean is also subtracted from field here.
       lastGood = -1
       avgField = avgField/FLOAT(nValid)
       DO I=1,lField
        IF ( holeMask(I) .EQ. 0. ) THEN
C        A hole
         hLo (I)  = lastGood
         hBase(I) = lastGood
        ELSE
C        Data
         hLo(I)   = 0
         hBase(I) = 0
         lastGood = I
         field(I) = field(I)-avgField
        ENDIF
       ENDDO
       DO I=1,lField
        IF ( hLo(I) .EQ. -1 ) THEN
         hLo(I)   = lastGood
         hBase(I) = lastGood-lField
        ENDIF
       ENDDO

C      2. hHi - Coord of valid point at end of run of holes.
       lastGood = -1
       DO I=lField,1,-1
        IF ( holeMask(I) .EQ. 0. ) THEN
C        A hole
         hHi(I)   = lastGood
         hHead(I) = lastGood
        ELSE
C        Data
         hHi(I)   = 0
         lastGood = I
        ENDIF
       ENDDO
       DO I=lField,1,-1
        IF ( hHi(I) .EQ. -1 ) THEN
         hHi(I)   = lastGood
         hHead(I) = lastGood+lField
        ENDIF
       ENDDO

CcnhDebugStarts
C     WRITE(*,*) 'During FFT pre-smooth'
C     WRITE(*,'(A,A,A,A,A,A)') 'I   ','mask(I)','hHi(I)','hLo(I)','hBase(I)','hHead(I)'
C     DO I=1,lField
C      WRITE(*,'(6(I4,1X))')
C    & I,INT(holeMask(I)),hHi(I),hLo(I),hBase(I),hHead(I)
C     ENDDO
CcnhDebugEnds

C      3. Interpolate
       DO I=1,lField
        IF ( holeMask(I) .EQ. 0. ) THEN
C        A hole
         iLo  = hLo(I)
         iHi  = hHi(I)
         dist = I-hBase(I)
         len  = hHead(I) - hBase(I)
CcnhDebugStarts
C        WRITE(*,'(A,1X,I4,1X,1PE35.25,1X,1PE35.25,)') 'I= ',I,dist, len
C        IF ( dist .LT. 0      ) STOP ' DIST .LT. 0 '
C        IF ( len  .LT. 0      ) STOP ' LEN  .LT. 0 '
C        IF ( dist .GT. lField ) STOP ' dist .GT. lField '
C        IF ( len  .GT. lField ) STOP ' len  .GT. lField '
C        IF ( dist .GT. len    ) STOP ' dist .GT. len    '
CcnhDebugStarts
         frac = dist/len
         field(I) = field(iLo)
     &             +(field(iHi)-field(iLo))*frac
        ENDIF
       ENDDO

CcnhDebugStarts
C     WRITE(*,*) 'After FFT pre-smooth'
C     WRITE(*,'(A,A)') 'Mask ', 'Data'
C     DO I=1,lField
C      WRITE(*,'(A,I4,1X,F3.1,1X,1PE35.25)') 'I= ',I,holeMask(I), field(I)
C     ENDDO
CcnhDebugEnds

      ENDIF
C
#endif /* ALLOW_ZONAL_FILT */

      RETURN
      END

#include "SALT_PLUME_OPTIONS.h"

CBOP 0
C     !ROUTINE: SALT_PLUME_READPARMS
C     !INTERFACE:
      SUBROUTINE SALT_PLUME_READPARMS( myThid )

C     !DESCRIPTION:
C     Initialize SALT_PLUME variables and constants.

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "SALT_PLUME.h"

C     !INPUT PARAMETERS:
      INTEGER myThid
CEOP

#ifdef ALLOW_SALT_PLUME
C     !LOCAL VARIABLES:
C     msgBuf      - Informational/error message buffer
C     iUnit       - Work variable for IO unit number
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      INTEGER iUnit

      NAMELIST /SALT_PLUME_PARM01/
     &     SaltPlumeSouthernOcean,
     &     CriterionType, PlumeMethod, Npower,
     &     SaltPlumeCriterion, SPovershoot, SPsalFRAC
#ifdef SALT_PLUME_IN_LEADS
     &     , SPinflectionPoint
#endif
#ifdef SALT_PLUME_SPLIT_BASIN
     &     , SaltPlumeSplitBasin
#endif
#ifdef SALT_PLUME_VOLUME
     &     , SPbrineSconst, SPbrineSaltmax
#endif

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      IF ( .NOT.useSALT_PLUME ) THEN
C-    pkg SALT_PLUME is not used
        _BEGIN_MASTER(myThid)
C-    Track pkg activation status:
C     print a (weak) warning if data.salt_plume is found
         CALL PACKAGES_UNUSED_MSG( 'useSALT_PLUME', ' ', ' ' )
        _END_MASTER(myThid)
        RETURN
      ENDIF

      _BEGIN_MASTER(myThid)

C--   Default values for SALT_PLUME
      SaltPlumeSouthernOcean = .TRUE.
      CriterionType       = 1
      PlumeMethod         = 1
      SaltPlumeCriterion  = UNSET_RL
      SPovershoot         = 1.0 _d 0
#ifdef SALT_PLUME_SPLIT_BASIN
      SaltPlumeSplitBasin = .FALSE.
      Npower(1)           = 0
      Npower(2)           = 0
      SPsalFRAC(1)        = 1.0 _d 0
      SPsalFRAC(2)        = 1.0 _d 0
#else
      Npower              = 0
      SPsalFRAC           = 1.0 _d 0
#endif
#ifdef SALT_PLUME_IN_LEADS
      SPinflectionPoint   = 0.8 _d 0
#endif
#ifdef SALT_PLUME_VOLUME
      SPbrineSconst       = 45. _d 0
      SPbrineSaltmax      = 100. _d 0
#endif

      WRITE(msgBuf,'(A)')'SALT_PLUME_READPARMS: opening data.salt_plume'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT , 1)
      CALL OPEN_COPY_DATA_FILE(
     I                     'data.salt_plume', 'SALT_PLUME_READPARMS',
     O                     iUnit,
     I                     myThid )

C     Read parameters from open data file
      READ(UNIT=iUnit,NML=SALT_PLUME_PARM01)
      WRITE(msgBuf,'(A)')
     &    'SALT_PLUME_READPARMS: finished reading data.salt_plume'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &    SQUEEZE_RIGHT , 1)
C     Close the open data file
#ifdef SINGLE_DISK_IO
      CLOSE(iUnit)
#else
      CLOSE(iUnit,STATUS='DELETE')
#endif /* SINGLE_DISK_IO */

      IF ( SaltPlumeCriterion .EQ. UNSET_RL ) THEN
       IF ( CriterionType .EQ. 1 ) THEN
        SaltPlumeCriterion  = 0.4 _d 0
       ELSEIF ( CriterionType .EQ. 2 ) THEN
        SaltPlumeCriterion  = 0.005 _d 0
       ELSE
        WRITE(msgBuf,'(A)') 'S/R SALT_PLUME_READPARMS'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(A)') 'Invalid CriterionType'
        CALL PRINT_ERROR( msgBuf, myThid )
        STOP 'ABNORMAL END: S/R SALT_PLUME_READPARMS'
       ENDIF
      ENDIF

      _END_MASTER(myThid)

C--   Everyone else must wait for the parameters to be loaded
      _BARRIER

#endif /* ALLOW_SALT_PLUME */

      RETURN
      END

#include "GAD_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 1
C     !ROUTINE: GAD_DIAGNOSTICS_STATE

C     !INTERFACE:
      SUBROUTINE GAD_DIAGNOSTICS_STATE( myTime, myIter, myThid )

C     !DESCRIPTION:
C     Fill-in the diagnostics array for GAD state variables

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "GAD.h"
#include "GAD_SOM_VARS.h"

C     !INPUT PARAMETERS:
C     myTime  :: Current time in simulation
C     myIter  :: Current iteration number in simulation
C     myThid  :: my Thread Id. number
      _RL     myTime
      INTEGER myIter
      INTEGER myThid
CEOP

#ifdef ALLOW_DIAGNOSTICS
#ifdef GAD_ALLOW_TS_SOM_ADV
C     ! FUNCTIONS:
      CHARACTER*4  GAD_DIAG_SUFX
      EXTERNAL     GAD_DIAG_SUFX
      LOGICAL  DIAGNOSTICS_IS_ON
      EXTERNAL DIAGNOSTICS_IS_ON

C     !LOCAL VARIABLES:
      CHARACTER*8 diagName
      CHARACTER*4 diagSufx
      INTEGER   i,j,k,bi,bj,n
      _RL       locVar(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL       recipVol
      _RL       oneThird, oneFifth, oneNinth

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      oneThird = 1. _d 0 / 3. _d 0
      oneFifth = 1. _d 0 / 5. _d 0
      oneNinth = 1. _d 0 / 9. _d 0

C---  Temperature:
      diagSufx = GAD_DIAG_SUFX( GAD_TEMPERATURE, myThid )

      DO n=1,nSOM
        diagName  = 'SM'//somSfx(n)//diagSufx
        CALL DIAGNOSTICS_FILL( som_T(1-OLx,1-OLy,1,1,1,n), diagName,
     &                         0, Nr, 0, 1, 1, myThid )
      ENDDO

      diagName  = 'SM_v'//diagSufx
      IF ( DIAGNOSTICS_IS_ON( diagName, myThid ) ) THEN
        DO bj = myByLo(myThid), myByHi(myThid)
         DO bi = myBxLo(myThid), myBxHi(myThid)
C--   Compute Internal (sub-grid) variance :
C     [Sx^2 + Sy^2 + Sz^2]/3 +[Sxx^2 + Syy^2 + Szz^2]/5 +[Sxy^2 + Sxz^2 + Syz^2]/9
           DO k=1,Nr
            DO j = 1-OLy,sNy+OLy
             DO i = 1-OLx,sNx+OLx
              recipVol = recip_rA(i,j,bi,bj)*recip_deepFac2C(k)
     &                  *recip_drF(k)*_recip_hFacC(i,j,k,bi,bj)
     &                  *recip_rhoFacC(k)
              locVar(i,j,k) = (
     &               (  som_T(i,j,k,bi,bj,1)*som_T(i,j,k,bi,bj,1)
     &                + som_T(i,j,k,bi,bj,2)*som_T(i,j,k,bi,bj,2)
     &                + som_T(i,j,k,bi,bj,3)*som_T(i,j,k,bi,bj,3)
     &               )*oneThird
     &             + (  som_T(i,j,k,bi,bj,4)*som_T(i,j,k,bi,bj,4)
     &                + som_T(i,j,k,bi,bj,5)*som_T(i,j,k,bi,bj,5)
     &                + som_T(i,j,k,bi,bj,6)*som_T(i,j,k,bi,bj,6)
     &               )*oneFifth
     &             + (  som_T(i,j,k,bi,bj,7)*som_T(i,j,k,bi,bj,7)
     &                + som_T(i,j,k,bi,bj,8)*som_T(i,j,k,bi,bj,8)
     &                + som_T(i,j,k,bi,bj,9)*som_T(i,j,k,bi,bj,9)
     &               )*oneNinth
     &                        )*recipVol*recipVol

             ENDDO
            ENDDO
           ENDDO
           CALL DIAGNOSTICS_FILL( locVar, diagName,
     &                            0, Nr, 2, bi, bj, myThid )
         ENDDO
        ENDDO
      ENDIF

C---  Salinity:
      diagSufx = GAD_DIAG_SUFX( GAD_SALINITY, myThid )

      DO n=1,nSOM
        diagName  = 'SM'//somSfx(n)//diagSufx
        CALL DIAGNOSTICS_FILL( som_S(1-OLx,1-OLy,1,1,1,n), diagName,
     &                         0, Nr, 0, 1, 1, myThid )
      ENDDO

      diagName  = 'SM_v'//diagSufx
      IF ( DIAGNOSTICS_IS_ON( diagName, myThid ) ) THEN
        DO bj = myByLo(myThid), myByHi(myThid)
         DO bi = myBxLo(myThid), myBxHi(myThid)
C--   Compute Internal (sub-grid) variance :
C     [Sx^2 + Sy^2 + Sz^2]/3 +[Sxx^2 + Syy^2 + Szz^2]/5 +[Sxy^2 + Sxz^2 + Syz^2]/9
           DO k=1,Nr
            DO j = 1-OLy,sNy+OLy
             DO i = 1-OLx,sNx+OLx
              recipVol = recip_rA(i,j,bi,bj)*recip_deepFac2C(k)
     &                  *recip_drF(k)*_recip_hFacC(i,j,k,bi,bj)
     &                  *recip_rhoFacC(k)
              locVar(i,j,k) = (
     &               (  som_S(i,j,k,bi,bj,1)*som_S(i,j,k,bi,bj,1)
     &                + som_S(i,j,k,bi,bj,2)*som_S(i,j,k,bi,bj,2)
     &                + som_S(i,j,k,bi,bj,3)*som_S(i,j,k,bi,bj,3)
     &               )*oneThird
     &             + (  som_S(i,j,k,bi,bj,4)*som_S(i,j,k,bi,bj,4)
     &                + som_S(i,j,k,bi,bj,5)*som_S(i,j,k,bi,bj,5)
     &                + som_S(i,j,k,bi,bj,6)*som_S(i,j,k,bi,bj,6)
     &               )*oneFifth
     &             + (  som_S(i,j,k,bi,bj,7)*som_S(i,j,k,bi,bj,7)
     &                + som_S(i,j,k,bi,bj,8)*som_S(i,j,k,bi,bj,8)
     &                + som_S(i,j,k,bi,bj,9)*som_S(i,j,k,bi,bj,9)
     &               )*oneNinth
     &                        )*recipVol*recipVol
             ENDDO
            ENDDO
           ENDDO
           CALL DIAGNOSTICS_FILL( locVar, diagName,
     &                            0, Nr, 2, bi, bj, myThid )
         ENDDO
        ENDDO
      ENDIF

#endif /* GAD_ALLOW_TS_SOM_ADV */
#endif /* ALLOW_DIAGNOSTICS */

      RETURN
      END

#include "BLING_OPTIONS.h"
#ifdef ALLOW_AUTODIFF
# include "AUTODIFF_OPTIONS.h"
#endif

CBOP
      SUBROUTINE BLING_MIXEDLAYER(
     U           sumMLDepth,
     I           bi, bj, imin, imax, jmin, jmax,
     I           myTime, myIter, myThid)

C     =================================================================
C     | subroutine bling_mixedlayer
C     | o Calculate mixed layer depth based on density criterion
C     |   (default: second derivative criterion; optional: threshold)
C     =================================================================

      IMPLICIT NONE

C     === Global variables ===

#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "FFIELDS.h"
#include "GRID.h"
#include "DYNVARS.h"
#include "BLING_VARS.h"
#include "PTRACERS_SIZE.h"
#include "PTRACERS_PARAMS.h"
#ifdef ALLOW_AUTODIFF_TAMC
# include "tamc.h"
#endif
C     === Routine arguments ===
C     bi,bj         :: tile indices
C     iMin,iMax     :: computation domain: 1rst index range
C     jMin,jMax     :: computation domain: 2nd  index range
C     myTime        :: current time
C     myIter        :: current timestep
C     myThid        :: thread Id. number
      INTEGER bi, bj, imin, imax, jmin, jmax
      INTEGER myThid
      INTEGER myIter
      _RL     myTime
C     === Output ===
C      sumMLDepth   :: mixed layer depth
      _RL sumMLDepth(1-OLx:sNx+OLx,1-OLy:sNy+OLy)

C     === Local variables ===
#ifdef BLING_USE_THRESHOLD_MLD
      _RL dens_surf (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL dens_z    (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL delta_dens(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
#else
      _RL blg_stra   (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL rhoKm1     (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL rhoKp1     (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL blg_minstra(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL blg_str2   (Nr)
      _RL blg_str2max
      INTEGER blgI,blgJ
#endif
      INTEGER i,j,k
#ifdef ALLOW_AUTODIFF_TAMC
      INTEGER ijkkey, ikey, kkey
#endif
CEOP

#ifdef ALLOW_AUTODIFF_TAMC
      ikey = bi + (bj-1)*nSx + (ikey_dynamics-1)*nSx*nSy
      ikey = (ikey-1)*Nr
#endif /* ALLOW_AUTODIFF_TAMC */
# ifndef BLING_USE_THRESHOLD_MLD
c ---------------------------------------------------------------------
c  Mixed layer depth initialization

      DO j=jmin,jmax
        DO i=imin,imax
          sumMLDepth(i,j) = drF(1)
          rhoKm1 (i,j)   = 0. _d 0
          rhoKp1 (i,j)   = 0. _d 0
          blg_minstra(i,j) = 0. _d 0
        ENDDO
      ENDDO

      DO k=1,Nr
        DO j=jmin,jmax
          DO i=imin,imax
            blg_stra(i,j,k) = 0. _d 0
          ENDDO
        ENDDO
        blg_str2(k) = 0
      ENDDO

c  get drhdr
      DO k=1,Nr-1
       DO j=jmin,jmax
        DO i=imin,imax
          rhoKm1(i,j) = rhoKp1(i,j)
        ENDDO
       ENDDO
       CALL FIND_RHO_2D(
     I        1-OLx, sNx+OLx, 1-OLy, sNy+OLy, 1,
     I        theta(1-OLx,1-OLy,k+1,bi,bj), salt(1-OLx,1-OLy,k+1,bi,bj),
     O        rhoKp1,
     I        k+1, bi, bj, myThid )

       IF (k.EQ.1) THEN
        DO j=jmin,jmax
         DO i=imin,imax
          blg_stra(i,j,k)= 0. _d 0
         ENDDO
        ENDDO
       ELSE
        DO j=jmin,jmax
         DO i=imin,imax
          blg_stra(i,j,k)= maskC(i,j,k,bi,bj)*maskC(i,j,k-1,bi,bj)
     &                *recip_drC(k)*rkSign
     &                *(rhoKp1(i,j)-rhoKm1(i,j))
         ENDDO
        ENDDO
       ENDIF
      ENDDO
CMM Strat at k is on bottom of cell

C  % 1. find min(drho/dz)
      DO k = 1,Nr
#ifdef ALLOW_AUTODIFF_TAMC
       kkey = ikey + k
CADJ STORE blg_minstra = comlev1_bibj_k, key = kkey
#endif
       DO j=jmin,jmax
        DO i=imin,imax
         IF(blg_stra(i,j,k).LT.blg_minstra(i,j))
     &        blg_minstra(i,j) = blg_stra(i,j,k)
        ENDDO
       ENDDO
      ENDDO

CMM NOW LOOP TO GET MLD
        DO j=jmin,jmax
         DO i=imin,imax
C  % 2. check that we have at least 3 grid cells of water
          IF (hFacC(i,j,3,bi,bj).GT. 0. _d 0)  THEN
C  %  check that we have stable strat
           IF (blg_minstra(i,j).LT. 0. _d 0) THEN
C  % 3. find the index of minimum stratification
            blgI = 3
            DO k = Nr,1,-1
             IF (blg_stra(i,j,k).EQ.blg_minstra(i,j))  blgI = k
            ENDDO
C        %if deep enough see strat starts before pynocline
            IF (blgI.GT.3) THEN
C % 4. compute the second derivative (d2rho/dz2)..
CMM Only look up
            blg_str2max = -999
            DO k = 3,blgI
#ifdef ALLOW_AUTODIFF_TAMC
             ijkkey = ikey * (2*OLx+sNx) * (2*OLy+sNy)
     &            + ( (j-1)*(2*OLx+sNx) + (i-1) ) + k
CADJ STORE blg_str2max = comlev1_bibj_ijk, key = ijkkey
#endif
CMM blg_str2 will be in cell center
             blg_str2(k) = (blg_stra(i,j,k-1) -blg_stra(i,j,k))
     &                                             *recip_drF(k)
C     &                                             *blg_invdz(k)
Cblg_invdz should be DRF
             IF (blg_str2(k).GT.blg_str2max)
     &            blg_str2max = blg_str2(k)
            ENDDO
            DO k = Nr,1,-1
             IF (blg_str2(k).EQ.blg_str2max)  blgJ = k
            ENDDO

CMM %TAKE WHERE STRAT IS FASTEST INCREASING ABOVE PYCNOCLINE
            IF (blgJ.LT.blgI)  blgI = blgJ

            IF ( (blg_str2(blgI).LT. 0. _d 0) .AND. (blgI.EQ.blgJ) )
CMM; %error: strat should increase or be flat
     &       print*,'error: strat should increase or be flat'

            sumMLDepth(i,j) = -RF(blgI)
           ENDIF
          ENDIF
         ENDIF
        ENDDO
       ENDDO

#else /* BLING_USE_THRESHOLD_MLD */
c ---------------------------------------------------------------------
c  Mixed layer depth

      DO j=jmin,jmax
        DO i=imin,imax
          SumMLDepth(i,j) = drf(1)
        ENDDO
      ENDDO

c  Surface density
      CALL FIND_RHO_2D(
     I     1-OLx, sNx+OLx, 1-OLy, sNy+OLy, 1,
     I     theta(1-OLx,1-OLy,1,bi,bj), salt(1-OLx,1-OLy,1,bi,bj),
     O     dens_surf,
     I     1, bi, bj, myThid )

      DO k=1,Nr
        DO j=jmin,jmax
          DO i=imin,imax
             if (k.eq.1) then
              delta_dens(i,j,1) = 0. _d 0
             else
              delta_dens(i,j,k) = 9999. _d 0
             endif
          ENDDO
        ENDDO
      ENDDO

      DO k = 2,Nr

c  Potential density
         CALL FIND_RHO_2D(
     I        1-OLx, sNx+OLx, 1-OLy, sNy+OLy, 1,
     I        theta(1-OLx,1-OLy,k,bi,bj), salt(1-OLx,1-OLy,k,bi,bj),
     O        dens_z,
     I        k, bi, bj, myThid )

        DO j=jmin,jmax
          DO i=imin,imax

c           SumMLDepth(i,j) = 0. _d 0

           IF (hFacC(i,j,k,bi,bj) .gt. 0. _d 0) THEN
            delta_dens(i,j,k) = dens_z(i,j)-dens_surf(i,j)
            IF (delta_dens(i,j,k) .LT. 0.03 _d 0) THEN
             SumMLDepth(i,j) = SumMLDepth(i,j)+drF(k)
            ENDIF
           ENDIF

          ENDDO
        ENDDO
      ENDDO

#endif /* BLING_USE_THRESHOLD_MLD */

      RETURN
      END

#include "CPP_EEOPTIONS.h"

CStartOfInterFace
      SUBROUTINE CPL_OUTPUT( myTime, myIter, myThid )
C     *==========================================================*
C     | SUBROUTINE CPL_OUTPUT
C     | o Write CPL time-average output
C     | - Atmospheric version -
C     *==========================================================*
C     | Empty S/R for now.
C     *==========================================================*
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"

C     == Routine arguments ==
C     myTime - Current time of simulation ( s )
C     myIter - Iteration number
C     myThid - Number of this instance of the routine
      _RL     myTime
      INTEGER myIter
      INTEGER myThid
CEndOfInterface

#ifdef COMPONENT_MODULE

C     == Local variables ==

#endif /* COMPONENT_MODULE */

      RETURN
      END

#include "CD_CODE_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: CD_CODE_READ_PICKUP

C     !INTERFACE:
      SUBROUTINE CD_CODE_READ_PICKUP( myIter, myThid )

C     !DESCRIPTION:
C     Read the checkpoint.

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "CD_CODE_VARS.h"
#ifdef ALLOW_MNC
#include "MNC_PARAMS.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
      INTEGER myIter
      INTEGER myThid
CEOP

#ifdef ALLOW_CD_CODE

C     !LOCAL VARIABLES:
      CHARACTER*(MAX_LEN_FNAM) fn
      CHARACTER*(10) suff
      INTEGER prec

C     Suffix for pickup files
      IF ( pickupSuff.EQ.' ' ) THEN
        IF ( rwSuffixType.EQ.0 ) THEN
          WRITE(suff,'(I10.10)') myIter
        ELSE
          CALL RW_GET_SUFFIX( suff, startTime, myIter, myThid )
        ENDIF
      ELSE
        WRITE(suff,'(A10)') pickupSuff
      ENDIF
      prec = precFloat64

      _BARRIER

#ifdef ALLOW_MNC
      IF (useMNC .AND. pickup_read_mnc) THEN
C       Read variables from the pickup file
        WRITE(fn,'(A)') 'pickup_cd'
        CALL MNC_FILE_CLOSE_ALL_MATCHING(fn, myThid)
        CALL MNC_CW_SET_UDIM(fn, 1, myThid)
        CALL MNC_CW_SET_CITER(fn, 3, 3, myIter, 0, myThid)
        CALL MNC_CW_SET_UDIM(fn, 1, myThid)
        CALL MNC_CW_RL_R('D',fn,0,0,'uVelD',uVelD, myThid)
        CALL MNC_CW_RL_R('D',fn,0,0,'vVelD',vVelD, myThid)
        CALL MNC_CW_RL_R('D',fn,0,0,'Unm1',Unm1, myThid)
        CALL MNC_CW_RL_R('D',fn,0,0,'Vnm1',Vnm1, myThid)
        CALL MNC_CW_RL_R('D',fn,0,0,'etaNm1', etaNm1, myThid)
      ENDIF
#endif /*  ALLOW_MNC  */

      WRITE(fn,'(A,A10)') 'pickup_cd.',suff

      IF (pickup_read_mdsio) THEN
        CALL READ_REC_3D_RL( fn, prec, Nr, uVelD, 1, myIter, myThid )
        CALL READ_REC_3D_RL( fn, prec, Nr, vVelD, 2, myIter, myThid )
        CALL READ_REC_3D_RL( fn, prec, Nr, uNM1,  3, myIter, myThid )
        CALL READ_REC_3D_RL( fn, prec, Nr, vNM1,  4, myIter, myThid )
        IF ( usePickupBeforeC54 ) THEN
          CALL READ_REC_3D_RL(fn,prec, 1, etaNm1,6*Nr+1,myIter,myThid)
        ELSE
          CALL READ_REC_3D_RL(fn,prec, 1, etaNm1,4*Nr+1,myIter,myThid)
        ENDIF
      ENDIF

C-    thread synchronisation (barrier) is part of the EXCH S/R calls
      CALL EXCH_UV_DGRID_3D_RL( uVelD,vVelD, .TRUE., Nr, myThid )
      CALL EXCH_UV_XYZ_RL( uNM1,vNM1, .TRUE., myThid )
      CALL EXCH_XY_RL( etaNm1, myThid )

#endif /*  ALLOW_CD_CODE  */

      RETURN
      END

#include "SEAICE_OPTIONS.h"
#ifdef ALLOW_AUTODIFF
# include "AUTODIFF_OPTIONS.h"
#endif

C--  File seaice_krylov.F: seaice krylov dynamical solver S/R:

CBOP
C     !ROUTINE: SEAICE_KRYLOV
C     !INTERFACE:
      SUBROUTINE SEAICE_KRYLOV( myTime, myIter, myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE SEAICE_KRYLOV
C     | o Picard solver for ice dynamics using a preconditioned
C     |   KRYLOV (Generalized Minimum RESidual=GMRES) method for
C     |   solving the linearised system following J.-F. Lemieux
C     |   et al., JGR 113, doi:10.1029/2007JC004680, 2008.
C     *==========================================================*
C     | written by Martin Losch, Jan 2016
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "DYNVARS.h"
#include "GRID.h"
#include "SEAICE_SIZE.h"
#include "SEAICE_PARAMS.h"
#include "SEAICE_GRID.h"
#include "SEAICE.h"

C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
C     myTime :: Simulation time
C     myIter :: Simulation timestep number
C     myThid :: my Thread Id. number
      _RL     myTime
      INTEGER myIter
      INTEGER myThid

#if ( defined SEAICE_CGRID && defined SEAICE_ALLOW_KRYLOV )
C     !FUNCTIONS:
      LOGICAL  DIFFERENT_MULTIPLE
      EXTERNAL DIFFERENT_MULTIPLE

C     !LOCAL VARIABLES:
C     === Local variables ===
C     i,j,bi,bj :: loop indices
      INTEGER i,j,bi,bj
C     loop indices
      INTEGER picardIter
      INTEGER krylovIter, krylovFails
      INTEGER krylovIterMax, picardIterMax
      INTEGER totalKrylovItersLoc, totalPicardItersLoc
C     FGMRES parameters
C     im      :: size of Krylov space
C     ifgmres :: interation counter
      INTEGER im
      PARAMETER ( im = 50 )
      INTEGER ifgmres
C     FGMRES flag that determines amount of output messages of fgmres
      INTEGER iOutFGMRES
C     FGMRES flag that indicates what fgmres wants us to do next
      INTEGER iCode
      _RL     picardResidual
      _RL     picardResidualKm1
C     parameters to compute convergence criterion
      _RL     krylovLinTol
      _RL     FGMRESeps
      _RL     picardTol
C     backward differences extrapolation factors
      _RL bdfFac, bdfAlpha
C
      _RL     recip_deltaT
      LOGICAL picardConverged, krylovConverged
      LOGICAL writeNow
      CHARACTER*(MAX_LEN_MBUF) msgBuf

      _RL uIceLin(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL vIceLin(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
C     extra time level required for backward difference time stepping
      _RL duIcNm1(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL dvIcNm1(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
C     u/vWork   :: work arrays
      _RL uWork  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL vWork  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
C     u/vIceLHS :: left hand side of momentum equation (A*x)
      _RL uIceLHS(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL vIceLHS(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
C     u/vIceRHS :: right hand side of momentum equation (b)
      _RL uIceRHS(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL vIceRHS(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
C     helper array
      _RL resTmp (nVec,1,nSx,nSy)
C     work arrays
      _RL rhs(nVec,nSx,nSy), sol(nVec,nSx,nSy)
      _RL vv(nVec,im+1,nSx,nSy), w(nVec,im,nSx,nSy)
      _RL wk1(nVec,nSx,nSy), wk2(nVec,nSx,nSy)
CEOP

C     Initialise
      picardIter          = 0
      krylovFails         = 0
      totalKrylovItersLoc = 0
      picardConverged     = .FALSE.
      picardTol           = 0. _d 0
      picardResidual      = 0. _d 0
      picardResidualKm1   = 0. _d 0
      FGMRESeps           = 0. _d 0
      recip_deltaT        = 1. _d 0 / SEAICE_deltaTdyn

      krylovIterMax       = SEAICElinearIterMax
      picardIterMax       = SEAICEnonLinIterMax
      IF ( SEAICEusePicardAsPrecon ) THEN
       krylovIterMax       = SEAICEpreconlinIter
       picardIterMax       = SEAICEpreconNL_Iter
      ENDIF

      iOutFGMRES=0
C     with iOutFgmres=1, seaice_fgmres prints the residual at each iteration
      IF ( debugLevel.GE.debLevC .AND.
     &     .NOT.SEAICEusePicardAsPrecon .AND.
     &     DIFFERENT_MULTIPLE( SEAICE_monFreq, myTime, deltaTClock ) )
     &     iOutFGMRES=1

C     backward difference extrapolation factors
      bdfFac = 0. _d 0
      IF ( SEAICEuseBDF2 ) THEN
       IF ( myIter.EQ.nIter0 .AND. SEAICEmomStartBDF.EQ.0 ) THEN
        bdfFac = 0. _d 0
       ELSE
        bdfFac = 0.5 _d 0
       ENDIF
      ENDIF
      bdfAlpha = 1. _d 0 + bdfFac

      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        DO J=1-OLy,sNy+OLy
         DO I=1-OLx,sNx+OLx
          uIceLHS(I,J,bi,bj) = 0. _d 0
          vIceLHS(I,J,bi,bj) = 0. _d 0
          uIceRHS(I,J,bi,bj) = 0. _d 0
          vIceRHS(I,J,bi,bj) = 0. _d 0
         ENDDO
        ENDDO
C     cycle ice velocities
        DO J=1-OLy,sNy+OLy
         DO I=1-OLx,sNx+OLx
          duIcNm1(I,J,bi,bj) = uIce(I,J,bi,bj) * bdfAlpha
     &         + ( uIce(I,J,bi,bj) - uIceNm1(I,J,bi,bj) ) * bdfFac
          dvIcNm1(I,J,bi,bj) = vIce(I,J,bi,bj) * bdfAlpha
     &         + ( vIce(I,J,bi,bj) - vIceNm1(I,J,bi,bj) ) * bdfFac
          uIceNm1(I,J,bi,bj) = uIce(I,J,bi,bj)
          vIceNm1(I,J,bi,bj) = vIce(I,J,bi,bj)
          uIceLin(I,J,bi,bj) = uIce(I,J,bi,bj)
          vIceLin(I,J,bi,bj) = vIce(I,J,bi,bj)
         ENDDO
        ENDDO
C     Compute things that do no change during the OL iteration:
C     sea-surface tilt and wind stress:
C     FORCEX/Y0 - mass*(1.5*u/vIceNm1+0.5*(u/vIceNm1-u/vIceNm2))/deltaT
        DO J=1-OLy,sNy+OLy
         DO I=1-OLx,sNx+OLx
          FORCEX(I,J,bi,bj) = FORCEX0(I,J,bi,bj)
     &         + seaiceMassU(I,J,bi,bj)*duIcNm1(I,J,bi,bj)*recip_deltaT
          FORCEY(I,J,bi,bj) = FORCEY0(I,J,bi,bj)
     &         + seaiceMassV(I,J,bi,bj)*dvIcNm1(I,J,bi,bj)*recip_deltaT
         ENDDO
        ENDDO
CML        ENDIF
       ENDDO
      ENDDO
C     Start nonlinear Picard iteration: outer loop iteration
      DO WHILE ( picardIter.LT.picardIterMax .AND.
     &     .NOT.picardConverged )
       picardIter = picardIter + 1
C     smooth ice velocities in time for computation of
C     the non-linear drag coefficents
       DO bj=myByLo(myThid),myByHi(myThid)
        DO bi=myBxLo(myThid),myBxHi(myThid)
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           uIceLin(I,J,bi,bj) = 0.5 _d 0 *
     &          (uIce(I,J,bi,bj) + uIceLin(I,J,bi,bj))
           vIceLin(I,J,bi,bj) = 0.5 _d 0 *
     &          (vIce(I,J,bi,bj) + vIceLin(I,J,bi,bj))
          ENDDO
         ENDDO
        ENDDO
       ENDDO
C     u/vIce have changed in Picard iteration so that new drag
C     coefficients and viscosities are required (that will not change in
C     the Krylov iteration)
       CALL SEAICE_OCEANDRAG_COEFFS(
     I      uIceLin, vIceLin, HEFFM,
     O      DWATN,
     I      0, myTime, myIter, myThid )
#ifdef SEAICE_ALLOW_BOTTOMDRAG
       CALL SEAICE_BOTTOMDRAG_COEFFS(
     I      uIceLin, vIceLin, HEFFM,
#ifdef SEAICE_ITD
     I      HEFFITD, AREAITD, AREA,
#else
     I      HEFF, AREA,
#endif
     O      CbotC,
     I      0, myTime, myIter, myThid )
#endif /* SEAICE_ALLOW_BOTTOMDRAG */
       CALL SEAICE_CALC_STRAINRATES(
     I      uIceLin, vIceLin,
     O      e11, e22, e12,
     I      0, myTime, myIter, myThid )
       CALL SEAICE_CALC_VISCOSITIES(
     I      e11, e22, e12, SEAICE_zMin, SEAICE_zMax, HEFFM, press0,
     I      tensileStrFac,
     O      eta, etaZ, zeta, zetaZ, press, deltaC,
     I      0, myTime, myIter, myThid )
C     compute rhs that does not change during Krylov iteration
       CALL SEAICE_CALC_RHS(
     O      uIceRHS, vIceRHS,
     I      picardIter, 0, myTime, myIter, myThid )
C     compute rhs for initial residual
       CALL SEAICE_CALC_LHS(
     I         uIce, vIce,
     O         uIceLHS, vIceLHS,
     I         picardIter, myTime, myIter, myThid )
C     Calculate the residual
       DO bj=myByLo(myThid),myByHi(myThid)
        DO bi=myBxLo(myThid),myBxHi(myThid)
         DO J=1,sNy
          DO I=1,sNx
           uIceLHS(I,J,bi,bj) = uIceLHS(I,J,bi,bj) - uIceRHS(I,J,bi,bj)
           vIceLHS(I,J,bi,bj) = vIceLHS(I,J,bi,bj) - vIceRHS(I,J,bi,bj)
C     save u/vIceLin as k-2nd step for linearization (does not work properly)
CML           uIceLin(I,J,bi,bj) = uIce(I,J,bi,bj)
CML           vIceLin(I,J,bi,bj) = vIce(I,J,bi,bj)
          ENDDO
         ENDDO
        ENDDO
       ENDDO
C     Important: Compute the norm of the residual using the same scalar
C     product that SEAICE_FGMRES does
       CALL SEAICE_MAP2VEC(nVec,uIceLHS,vIceLHS,resTmp,.TRUE.,myThid)
       CALL SEAICE_SCALPROD(nVec,1,1,1,resTmp,resTmp,
     &      picardResidual,myThid)
       picardResidual = SQRT(picardResidual)

C     compute convergence criterion for linear preconditioned FGMRES
       krylovLinTol = JFNKgamma_lin_max
C     the best method is still not clear to me
C     this is described in Lemieux et al 2008
CML       IF ( picardIter .EQ. 1 ) krylovLinTol = 1./10.
CML       IF ( picardIter .EQ. 2 ) krylovLinTol = 1./20.
CML       IF ( picardIter .EQ. 3 ) krylovLinTol = 1./20.
CML       IF ( picardIter .EQ. 4 ) krylovLinTol = 1./30.
CML       IF ( picardIter .EQ. 5 ) krylovLinTol = 1./30.
CML       IF ( picardIter .EQ. 6 ) krylovLinTol = 1./30.
CML       IF ( picardIter .EQ. 7 ) krylovLinTol = 1./30.
CML       IF ( picardIter .EQ. 8 ) krylovLinTol = 1./40.
CML       IF ( picardIter .EQ. 9 ) krylovLinTol = 1./50.
CML       IF ( picardIter .GT. 9 ) krylovLinTol = 1./80.
C     this is used with the JFNK solver, but the Picard-Krylov solver
C     converges too slowly for this scheme
CML       IF ( picardIter.GT.1.AND.picardResidual.LT.JFNKres_t ) THEN
CMLC     Eisenstat and Walker (1996), eq.(2.6)
CML        krylovLinTol = SEAICE_JFNKphi
CML     &       *( picardResidual/picardResidualKm1 )**SEAICE_JFNKalpha
CML        krylovLinTol = min(JFNKgamma_lin_max, krylovLinTol)
CML        krylovLinTol = max(JFNKgamma_lin_min, krylovLinTol)
CML       ENDIF
CML       krylovLinTol = 1. _d -1
C     save the residual for the next iteration
       picardResidualKm1 = picardResidual

C     The Krylov iteration uses FGMRES, the preconditioner is LSOR
C     for now. The code is adapted from SEAICE_LSR, but heavily stripped
C     down.
C     krylovIter is mapped into "its" in seaice_fgmres and is incremented
C     in that routine
       krylovIter    = 0
       iCode         = 0

       picardConverged = picardResidual.LT.picardTol
     &      .OR.picardResidual.EQ.0. _d 0

C     do Krylov loop only if convergence is not reached

       IF ( .NOT.picardConverged ) THEN

C     start Krylov iteration (FGMRES)

        krylovConverged = .FALSE.
        FGMRESeps = krylovLinTol * picardResidual
        CALL SEAICE_MAP2VEC(nVec,uIce,vIce,sol,.TRUE.,myThid)
        CALL SEAICE_MAP2VEC(nVec,uIceRHS,vIceRHS,rhs,.TRUE.,myThid)
        DO bj=myByLo(myThid),myByHi(myThid)
         DO bi=myBxLo(myThid),myBxHi(myThid)
          DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
            uWork(i,j,bi,bj) = 0. _d 0
            vWork(i,j,bi,bj) = 0. _d 0
           ENDDO
          ENDDO
         ENDDO
        ENDDO
        DO WHILE ( .NOT.krylovConverged )
C     solution vector sol = u/vIce
C     residual vector (rhs) Fu = u/vIceRHS
C     output work vectors wk1, -> input work vector wk2

C     map results to wk2
         CALL SEAICE_MAP2VEC(nVec,uWork,vWork,wk2,.TRUE.,myThid)

         CALL SEAICE_FGMRES (nVec,im,rhs,sol,ifgmres,krylovIter,
     U        vv,w,wk1,wk2,
     I        FGMRESeps,krylovIterMax,iOutFGMRES,
     U        iCode,
     I        myThid)
C
         IF ( iCode .EQ. 0 ) THEN
C     map sol(ution) vector to u/vIce
          CALL SEAICE_MAP2VEC(nVec,uIce,vIce,sol,.FALSE.,myThid)
          CALL EXCH_UV_XY_RL( uIce, vIce,.TRUE.,myThid)
         ELSE
C     map work vector to du/vIce to either compute a preconditioner
C     solution (wk1=rhs) or a matrix times wk1
          CALL SEAICE_MAP2VEC(nVec,uWork,vWork,wk1,.FALSE.,myThid)
          CALL EXCH_UV_XY_RL( uWork, vWork,.TRUE.,myThid)
         ENDIF

C     FGMRES returns iCode either asking for an new preconditioned vector
C     or product of matrix times vector. For iCode = 0, terminate
C     iteration
         IF (iCode.EQ.1) THEN
C     Call preconditioner
          IF ( SEAICEpreconLinIter .GT. 0 )
     &         CALL SEAICE_PRECONDITIONER(
     U         uWork, vWork,
     I         zeta, eta, etaZ, zetaZ, dwatn,
     I         picardIter, krylovIter, myTime, myIter, myThid )
         ELSEIF (iCode.GE.2) THEN
C     Compute lhs of equations (A*x)
          CALL SEAICE_CALC_STRAINRATES(
     I         uWork, vWork,
     O         e11, e22, e12,
     I         krylovIter, myTime, myIter, myThid )
          CALL SEAICE_CALC_LHS(
     I         uWork, vWork,
     O         uIceLHS, vIceLHS,
     I         picardIter, myTime, myIter, myThid )
          DO bj=myByLo(myThid),myByHi(myThid)
           DO bi=myBxLo(myThid),myBxHi(myThid)
            DO j=1-OLy,sNy+OLy
             DO i=1-OLx,sNx+OLx
              uWork(i,j,bi,bj) = uIceLHS(i,j,bi,bj)
              vWork(i,j,bi,bj) = vIceLHS(i,j,bi,bj)
             ENDDO
            ENDDO
           ENDDO
          ENDDO
         ENDIF
         krylovConverged = iCode.EQ.0
C     End of Krylov iterate
        ENDDO
        totalKrylovItersLoc = totalKrylovItersLoc + krylovIter
C     some output diagnostics
        IF ( debugLevel.GE.debLevA
     &       .AND. .NOT.SEAICEusePicardAsPrecon ) THEN
         _BEGIN_MASTER( myThid )
         totalPicardItersLoc =
     &        picardIterMax*(myIter-nIter0)+picardIter
         WRITE(msgBuf,'(2A,2(1X,I6),2E12.5)')
     &        ' S/R SEAICE_KRYLOV: Picard iterate / total, ',
     &        'KRYLOVgamma_lin, initial norm = ',
     &        picardIter, totalPicardItersLoc,
     &        krylovLinTol,picardResidual
         CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &        SQUEEZE_RIGHT, myThid )
         WRITE(msgBuf,'(3(A,I6))')
     &        ' S/R SEAICE_KRYLOV: Picard iterate / total = ',
     &        picardIter, ' / ', totalPicardItersLoc,
     &        ', Nb. of FGMRES iterations = ', krylovIter
         CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &        SQUEEZE_RIGHT, myThid )
         _END_MASTER( myThid )
        ENDIF
        IF ( krylovIter.EQ.krylovIterMax ) THEN
         krylovFails = krylovFails + 1
        ENDIF
C     Set the stopping criterion for the Picard iteration and the
C     criterion for the transition from accurate to approximate FGMRES
        IF ( picardIter .EQ. 1 ) THEN
         picardTol=SEAICEnonLinTol*picardResidual
         IF ( JFNKres_tFac .NE. UNSET_RL )
     &        JFNKres_t = picardResidual * JFNKres_tFac
        ENDIF
       ENDIF
C     end of Picard iterate
      ENDDO

C--   Output diagnostics

      IF ( SEAICE_monFreq .GT. 0. _d 0 ) THEN
C     Only Master Thread updates counters in common block:
      _BEGIN_MASTER(myThid)
C     Cumulate some diagnostic counters for the Krylov solver
       totalJFNKtimeSteps = totalJFNKtimeSteps + 1
       totalNewtonIters   = totalNewtonIters + picardIter
       totalKrylovIters   = totalKrylovIters + totalKrylovItersLoc
C     Record failure
       totalKrylovFails   = totalKrylovFails + krylovFails
       IF ( picardIter .EQ. picardIterMax ) THEN
        totalNewtonfails = totalNewtonfails + 1
       ENDIF
       _END_MASTER( myThid )
      ENDIF
C     Decide whether it is time to dump and reset the counter
      writeNow = DIFFERENT_MULTIPLE(SEAICE_monFreq,
     &     myTime+deltaTClock, deltaTClock)
#ifdef ALLOW_CAL
      IF ( useCAL ) THEN
       CALL CAL_TIME2DUMP(
     I      zeroRL, SEAICE_monFreq,  deltaTClock,
     U      writeNow,
     I      myTime+deltaTClock, myIter+1, myThid )
      ENDIF
#endif
      IF ( writeNow ) THEN
       _BEGIN_MASTER( myThid )
       WRITE(msgBuf,'(A)')
     &' // ======================================================='
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &      SQUEEZE_RIGHT, myThid )
       WRITE(msgBuf,'(A)') ' // Begin KRYLOV statistics'
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &      SQUEEZE_RIGHT, myThid )
       WRITE(msgBuf,'(A)')
     &' // ======================================================='
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &      SQUEEZE_RIGHT, myThid )
       WRITE(msgBuf,'(A,I10)')
     &      ' %KRYLOV_MON: time step              = ', myIter+1
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &      SQUEEZE_RIGHT, myThid )
       WRITE(msgBuf,'(A,I10)')
     &      ' %KRYLOV_MON: Nb. of time steps      = ',
     &      totalJFNKtimeSteps
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &      SQUEEZE_RIGHT, myThid )
       WRITE(msgBuf,'(A,I10)')
     &      ' %KRYLOV_MON: Nb. of Picard steps    = ', totalNewtonIters
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &      SQUEEZE_RIGHT, myThid )
       WRITE(msgBuf,'(A,I10)')
     &      ' %KRYLOV_MON: Nb. of Krylov steps    = ', totalKrylovIters
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &      SQUEEZE_RIGHT, myThid )
       WRITE(msgBuf,'(A,I10)')
     &      ' %KRYLOV_MON: Nb. of Picard failures = ', totalNewtonfails
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &      SQUEEZE_RIGHT, myThid )
       WRITE(msgBuf,'(A,I10)')
     &      ' %KRYLOV_MON: Nb. of Krylov failures = ', totalKrylovFails
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &      SQUEEZE_RIGHT, myThid )
       WRITE(msgBuf,'(A)')
     &' // ======================================================='
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &      SQUEEZE_RIGHT, myThid )
       WRITE(msgBuf,'(A)') ' // End KRYLOV statistics'
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &      SQUEEZE_RIGHT, myThid )
       WRITE(msgBuf,'(A)')
     &' // ======================================================='
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &      SQUEEZE_RIGHT, myThid )
C     Reset and start again
       totalJFNKtimeSteps = 0
       totalNewtonIters   = 0
       totalKrylovIters   = 0
       totalKrylovFails   = 0
       totalNewtonfails   = 0
       _END_MASTER( myThid )
      ENDIF

C     Print more debugging information
      IF ( debugLevel.GE.debLevA
     &     .AND. .NOT.SEAICEusePicardAsPrecon ) THEN
       IF ( picardIter .EQ. picardIterMax ) THEN
        _BEGIN_MASTER( myThid )
        WRITE(msgBuf,'(A,I10)')
     &       ' S/R SEAICE_KRYLOV: Solver did not converge in timestep ',
     &       myIter+1
        CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &       SQUEEZE_RIGHT, myThid )
        _END_MASTER( myThid )
       ENDIF
       IF ( krylovFails .GT. 0 ) THEN
        _BEGIN_MASTER( myThid )
        WRITE(msgBuf,'(A,I4,A,I10)')
     &       ' S/R SEAICE_KRYLOV: FGMRES did not converge ',
     &       krylovFails, ' times in timestep ', myIter+1
        CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &       SQUEEZE_RIGHT, myThid )
        _END_MASTER( myThid )
       ENDIF
       _BEGIN_MASTER( myThid )
       WRITE(msgBuf,'(A,I6,A,I10)')
     &      ' S/R SEAICE_KRYLOV: Total number FGMRES iterations = ',
     &      totalKrylovItersLoc, ' in timestep ', myIter+1
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &      SQUEEZE_RIGHT, myThid )
       _END_MASTER( myThid )
      ENDIF

#endif /* SEAICE_CGRID and SEAICE_ALLOW_KRYLOV */

      RETURN
      END

#include "AUTODIFF_OPTIONS.h"
#ifdef ALLOW_CTRL
# include "CTRL_OPTIONS.h"
#endif

C     ==================================================================
C
C     adread_adwrite.F: routines to handle the I/O of the TAF
C                       generated code. All files are direct access files.
C     Routines:
C     o  ADREAD    - Read  RL/RS data from file.
C     o  ADWRITE   - Write RL/RS data to   file.
C
C     Note on short real variables (when _RS expands to real*4):
C     ADREAD/ADWRITE handles this case properly as in F77 only addresses
C     are passed to the subroutine. The size-parameter determines
C     correctly how the passed array var is passed to
C     MDS_READ/WRITE_TAPE. Some compiler/flag combinations that check
C     for subroutine argument consistency will complain about a real*4
C     array being passed to a real*8 array, but this can be avoided by
C     adding this file to the list of NOOPTFILES with appropriate
C     NOOPTFLAGS in the build-options file.
C
C     The following input variables are used throughout in the argument
C     lists:
C
C     name   -  character
C                 On entry, name is the extended tape name.
C     len    -  integer
C                 On entry, len is the number of characters in name.
C     tid    -  integer
C                 On entry, tid identifies the tape.
C     vid    -  integer
C                 On entry, vid identifies the variable to be stored on
C                 the tape.
C     var    -  real array of dimension length
C                 On entry, var contains the values to be stored.
C                           var must not be changed.
C     size   -  integer
C                 On entry, size is the size in bytes of the type of
C                           variable var.
C     length -  integer
C                 On entry, length is the dimension of the variable
C                           stored on the tape.
C     irec   -  integer
C                 On entry, irec is the record number to be written.
C     myThid -  integer
C                 On entry, myThid is the number of the thread or
C                           instance of the program.
C
C     TAF does not provide the leading argument myThid when compiling
C     the MITgcmUV code. Instead there is a sed script available that
C     changes the TAF-generated adjoint code.
C
C     Only the master thread is allowed to write data and only gobal
C     model arrays are allowed to be written be the subsequent routines.
C     Tiled data are to be stored in common blocks. This implies that at
C     least a two level checkpointing for the adjoint code has to be
C     available.
C
C     ==================================================================

CBOP
C     !ROUTINE: ADREAD
C     !INTERFACE:
      SUBROUTINE ADREAD(
     I                   myThid,
     I                   name,
     I                   len,
     I                   tid,
     I                   vid,
     O                   var,
     I                   size,
     I                   length,
     I                   irec )

C     !DESCRIPTION: \bv
C     ==================================================================
C     SUBROUTINE adread
C     ==================================================================
C     o Read direct access file.
C     A call to this routine implies an open-read-close sequence
C     since it uses the MITgcmUV i/o routine MDS_READ_TAPE. Only
C     the master thread reads the data. Otherwise each thread would
C     read from file.
C     started: Christian Eckert eckert@mit.edu 30-Jun-1999
C     ==================================================================
C     SUBROUTINE adread
C     ==================================================================
C     \ev

C     !USES:
      IMPLICIT NONE

C     == global variables ==
#include "EEPARAMS.h"
#include "SIZE.h"
#include "PARAMS.h"
#ifdef ALLOW_CTRL
# include "CTRL_SIZE.h"
# include "CTRL.h"
# include "OPTIMCYCLE.h"
#endif
C- OpenAD: this header is not converted to a module --> go after the others
#include "AUTODIFF.h"

C     !INPUT/OUTPUT PARAMETERS:
C     myThid :: number of the thread or instance of the program.
C     name   :: extended tape name.
C     len    :: number of characters in name.
C     tid    :: tape identifier.
C     vid    :: identifies the variable to be stored on tape.
C     var    :: values to be stored.
C     size   :: size in bytes of the type of variable var.
C     length :: dimension of the variable stored on the tape.
C     irec   :: record number to be written.
      INTEGER myThid
      CHARACTER*(*) name
      INTEGER len
      INTEGER tid
      INTEGER vid
      real*8  var(*)
      INTEGER size
      INTEGER length
      INTEGER irec

C     !FUNCTIONS:
      INTEGER  ILNBLNK
      EXTERNAL ILNBLNK

C     !LOCAL VARIABLES:
      CHARACTER*(MAX_LEN_FNAM) fname
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      INTEGER filePrec
      INTEGER il, jl, lenLoc
      real*8  dummyR8(1)
      real*4  dummyR4(1)
      LOGICAL useWHTapeIO
#ifdef ALLOW_AUTODIFF_WHTAPEIO
      INTEGER n2d,length2d, jrec, i2d, j2d
#endif
CEOP

#ifdef ALLOW_DEBUG
      IF ( debugMode ) CALL DEBUG_ENTER('ADREAD',myThid)
#endif

C--   default is to write tape-files of same precision as array:
C     convert bytes to file-prec
      filePrec = 8*size
      IF ( doSinglePrecTapelev ) THEN
       filePrec = precFloat32
      ENDIF

      useWHTapeIO = .FALSE.
#ifdef ALLOW_AUTODIFF_WHTAPEIO
C    determine number of 2d fields
      length2d = (sNx+2*OLx)*(sNy+2*OLy)*nSx*nSy
      n2d = INT(length/length2d)
      IF ( size.EQ.8 .AND. n2d*length2d.EQ.length ) THEN
C-    only use "WHTAPEIO" when type and length match
        useWHTapeIO = .TRUE.
      ENDIF
#endif /* ALLOW_AUTODIFF_WHTAPEIO */

      il = ILNBLNK( name )
      jl = ILNBLNK( adTapeDir )
      IF ( useWHTapeIO ) THEN
        lenLoc = il+jl
        WRITE(fname,'(2A)') adTapeDir(1:jl),name(1:il)
      ELSE
        lenLoc = il+jl+7
        WRITE(fname,'(3A,I4.4)')
     &     adTapeDir(1:jl),name(1:il),'.it',optimcycle
      ENDIF
#ifdef ALLOW_DEBUG
      IF ( debugLevel.GE.debLevC ) THEN
        WRITE(msgBuf,'(2A,3I6,I9,2I3,2A)') 'ADREAD: ',
     &    ' tid,vid, irec, length, prec(x2)=', tid, vid, irec,
     &      length, size, filePrec, ' fname=', fname(1:lenLoc)
        CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
      ENDIF
#endif

#ifdef ALLOW_AUTODIFF_WHTAPEIO
      IF ( useWHTapeIO ) THEN

cc      IF (n2d*length2d.EQ.length) THEN
        DO i2d=1,n2d
          IF (tapeFileUnit.EQ.0) THEN
            jrec=irec
          ELSE
            tapeFileCounter=tapeFileCounter+1
            jrec=tapeFileCounter+tapeMaxCounter*(irec-1)
            IF (tapeFileCounter.GT.tapeMaxCounter) THEN
              WRITE(msgBuf,'(A,2I5)')
     &              'ADREAD: tapeFileCounter > tapeMaxCounter ',
     &              tapeFileCounter, tapeMaxCounter
              CALL PRINT_ERROR( msgBuf, myThid )
              WRITE(msgBuf,'(2A)') 'for file ', fname(1:lenLoc)
              CALL PRINT_ERROR( msgBuf, myThid )
              STOP 'ABNORMAL END: S/R ADREAD'
            ENDIF
          ENDIF
          j2d=(i2d-1)*length2d+1
          CALL MDS_READ_WHALOS(fname,lenLoc,filePrec,tapeFileUnit,
     &      1,var(j2d),jrec,tapeSingleCpuIO,tapeBufferIO,myThid)
        ENDDO
cc      ELSE
C     The other case actually does not (and should not) occur within the
C     main loop, where we only store global arrays (i.e. with i,j,bi,bj
C     indices) to disk. At init and final time it is always possible to
C     recompute or store in memory without much trouble or computational
C     cost.
cc         WRITE(msgBuf,'(3A)')
cc     &        'ADREAD: ', name, ' was not saved to tape.'
cc         CALL PRINT_ERROR( msgBuf, myThid )
cc         STOP 'ABNORMAL END: S/R ADREAD'
cc      ENDIF

      ELSE
#else
      IF ( .TRUE. ) THEN
#endif /* ALLOW_AUTODIFF_WHTAPEIO */

        _BEGIN_MASTER( myThid )
         IF ( size.EQ.4 ) THEN
c          CALL MDSREADVECTOR( fname, filePrec, 'RS',
c    &                         length, var, 1, 1, irec, myThid )
           CALL MDS_READ_TAPE( fname, filePrec, 'R4',
     &                         length, dummyR8, var,
     &                         useSingleCpuIO, irec, myThid )
         ELSE
c          CALL MDSREADVECTOR( fname, filePrec, 'RL',
c    &                         length, var, 1, 1, irec, myThid )
           CALL MDS_READ_TAPE( fname, filePrec, 'R8',
     &                         length,  var, dummyR4,
     &                         useSingleCpuIO, irec, myThid )
         ENDIF
        _END_MASTER( myThid )

C     end if useWHTapeIO / else
      ENDIF

C     Everyone must wait for the read operation to be completed.
c     _BARRIER

#ifdef ALLOW_DEBUG
      IF ( debugMode ) CALL DEBUG_LEAVE('ADREAD',myThid)
#endif

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: ADWRITE
C     !INTERFACE:
      SUBROUTINE ADWRITE(
     I                    myThid,
     I                    name,
     I                    len,
     I                    tid,
     I                    vid,
     I                    var,
     I                    size,
     I                    length,
     I                    irec )

C     !DESCRIPTION: \bv
C     ==================================================================
C     SUBROUTINE adwrite
C     ==================================================================
C     o Write to direct access file.
C     A call to this routine implies an open-read-close sequence
C     since it uses the MITgcmUV i/o routine MDS_WRITE_TAPE. Only
C     the master thread writes the data. Otherwise each thread would
C     write to file. This would result in an excessive waste of
C     disk space.
C     started: Christian Eckert eckert@mit.edu 30-Jun-1999
C     ==================================================================
C     SUBROUTINE adwrite
C     ==================================================================
C     \ev

C     !USES:
      IMPLICIT NONE

C     == global variables ==
#include "EEPARAMS.h"
#include "SIZE.h"
#include "PARAMS.h"
#ifdef ALLOW_CTRL
# include "CTRL_SIZE.h"
# include "CTRL.h"
# include "OPTIMCYCLE.h"
#endif
C- OpenAD: this header is not converted to a module --> go after the others
#include "AUTODIFF.h"

C     !INPUT/OUTPUT PARAMETERS:
C     myThid :: number of the thread or instance of the program.
C     name   :: extended tape name.
C     len    :: number of characters in name.
C     tid    :: tape identifier.
C     vid    :: identifies the variable to be stored on tape.
C     var    :: values to be stored.
C     size   :: size in bytes of the type of variable var.
C     length :: dimension of the variable stored on the tape.
C     irec   :: record number to be written.
      INTEGER myThid
      CHARACTER*(*) name
      INTEGER len
      INTEGER tid
      INTEGER vid
      real*8  var(*)
      INTEGER size
      INTEGER length
      INTEGER irec

C     !FUNCTIONS:
      INTEGER ILNBLNK
      EXTERNAL ILNBLNK

C     !LOCAL VARIABLES:
      CHARACTER*(MAX_LEN_FNAM) fname
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      INTEGER filePrec
      INTEGER il,jl,lenLoc
      real*8  dummyR8(1)
      real*4  dummyR4(1)
      LOGICAL useWHTapeIO
      LOGICAL globalfile
#ifdef ALLOW_AUTODIFF_WHTAPEIO
      INTEGER n2d,length2d, jrec, i2d, j2d
#endif
CEOP

#ifdef ALLOW_DEBUG
      IF ( debugMode ) CALL DEBUG_ENTER('ADWRITE',myThid)
#endif

C--   default is to write tape-files of same precision as array:
C     convert bytes to file-prec
      filePrec = 8*size
      IF ( doSinglePrecTapelev ) THEN
       filePrec = precFloat32
      ENDIF

      useWHTapeIO = .FALSE.
#ifdef ALLOW_AUTODIFF_WHTAPEIO
C    determine number of 2d fields
      length2d = (sNx+2*OLx)*(sNy+2*OLy)*nSx*nSy
      n2d = INT(length/length2d)
      IF ( size.EQ.8 .AND. n2d*length2d.EQ.length ) THEN
C-    only use "WHTAPEIO" when type and length match
        useWHTapeIO = .TRUE.
      ENDIF
#endif /* ALLOW_AUTODIFF_WHTAPEIO */

      il = ILNBLNK( name )
      jl = ILNBLNK( adTapeDir )
      IF ( useWHTapeIO ) THEN
        lenLoc = il+jl
        WRITE(fname,'(2A)') adTapeDir(1:jl),name(1:il)
      ELSE
        lenLoc = il+jl+7
        WRITE(fname,'(3A,I4.4)')
     &     adTapeDir(1:jl),name(1:il),'.it',optimcycle
      ENDIF
#ifdef ALLOW_DEBUG
      IF ( debugLevel .GE. debLevC ) THEN
        WRITE(msgBuf,'(2A,3I6,I9,2I3,2A)') 'ADWRITE:',
     &    ' tid,vid, irec, length, prec(x2)=', tid, vid, irec,
     &      length, size, filePrec, ' fname=', fname(1:lenLoc)
        CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
      ENDIF
#endif

#ifdef ALLOW_AUTODIFF_WHTAPEIO
      IF ( useWHTapeIO ) THEN

cc      IF (n2d*length2d.EQ.length) THEN
        DO i2d=1,n2d
          IF (tapeFileUnit.EQ.0) THEN
            jrec=irec
          ELSE
            tapeFileCounter = tapeFileCounter+1
            jrec = tapeFileCounter+tapeMaxCounter*(irec-1)
            IF ( tapeFileCounter.GT.tapeMaxCounter ) THEN
              WRITE(msgBuf,'(2A,I6,A,I6,A)') 'ADWRITE: ',
     &            'tapeFileCounter (=',tapeFileCounter,
     &            ') > tapeMaxCounter (= nWh =', tapeMaxCounter, ')'
              CALL PRINT_ERROR( msgBuf, myThid )
              WRITE(msgBuf,'(3A)') 'ADWRITE: ',
     &            ' for file: ', fname(1:lenLoc)
              CALL PRINT_ERROR( msgBuf, myThid )
C     Here, we cannot determine how many tapeFiles we need, so we print
C     this rather unspecific instruction.
              WRITE(msgBuf,'(2A)') 'ADWRITE: ',
     &             '==> Need to increase "nWh" in: MDSIO_BUFF_WH.h'
              CALL PRINT_ERROR( msgBuf, myThid )
              WRITE(msgBuf,'(2A)') 'ADWRITE: Tip to find lowest',
     &             ' allowed "nWh": setting debugLevel >= 3'
              CALL PRINT_ERROR( msgBuf , myThid )
              WRITE(msgBuf,'(2A)') 'ADWRITE:  will report ',
     &             '"tapeFileCounter" to STDOUT (can grep for)'
              CALL PRINT_ERROR( msgBuf , myThid )
              STOP 'ABNORMAL END: S/R ADWRITE'
            ENDIF
#ifdef ALLOW_DEBUG
            IF ( debugLevel.GE.debLevC ) THEN
C     Print tapeFileCounter to help find minimum tapeMaxCounter=nWh value
              WRITE(msgBuf,'(A,I6)') 'ADWRITE:  tapeFileCounter =',
     &            tapeFileCounter
              CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
            ENDIF
#endif
          ENDIF
          j2d=(i2d-1)*length2d+1
          CALL MDS_WRITE_WHALOS(fname,lenLoc,filePrec,tapeFileUnit,
     &      1,var(j2d),jrec,tapeSingleCpuIO,tapeBufferIO,myThid)
        ENDDO
cc      ELSE
cc       WRITE(msgBuf,'(3A)')
cc     &      'ADWRITE: ',fname(1:lenLoc),'was not read from tape.'
cc       CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
cc     &                     SQUEEZE_RIGHT , myThid)
cc      ENDIF

      ELSE
#else
      IF ( .TRUE. ) THEN
#endif /* ALLOW_AUTODIFF_WHTAPEIO */

        globalfile = globalFiles
c       globalfile = .FALSE.

        _BEGIN_MASTER( myThid )
        IF ( size.EQ.4 ) THEN
c         CALL MDSWRITEVECTOR( fname, filePrec, globalfile, 'RS',
c    &                         length, var, 1, 1, irec, 0, myThid )
          CALL MDS_WRITE_TAPE( fname, filePrec, globalfile, 'R4',
     &                         length, dummyR8, var,
     &                         useSingleCpuIO, irec, 0, myThid )
        ELSE
c         CALL MDSWRITEVECTOR( fname, filePrec, globalfile, 'RL',
c    &                         length, var, 1, 1, irec, 0, myThid )
          CALL MDS_WRITE_TAPE( fname, filePrec, globalfile, 'R8',
     &                         length, var, dummyR4,
     &                         useSingleCpuIO, irec, 0, myThid )
        ENDIF
        _END_MASTER( myThid )

C     end if useWHTapeIO / else
      ENDIF

C     Everyone must wait for the write operation to be completed.
c     _BARRIER

#ifdef ALLOW_DEBUG
      IF ( debugMode ) CALL DEBUG_LEAVE('ADWRITE',myThid)
#endif

      RETURN
      END

#include "DIAG_OPTIONS.h"

C--   File diagstats_fill.F:
C--    Contents:
C--    o DIAGSTATS_FILL
C--    o DIAGSTATS_TO_RL

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

CBOP
C     !ROUTINE: DIAGSTATS_FILL
C     !INTERFACE:
      SUBROUTINE DIAGSTATS_FILL(
     I               inpFldRL, fracFldRL,
#ifndef REAL4_IS_SLOW
     I               inpFldRS, fracFldRS,
#endif
     I               scaleFact, power, arrType, nLevFract,
     I               ndId, kInQSd, region2fill, kLev, nLevs,
     I               bibjFlg, biArg, bjArg, myThid )

C     !DESCRIPTION:
C***********************************************************************
C   compute statistics over 1 tile
C   and increment the diagnostics array
C     using a scaling factor & square option (power=2),
C     and with the option to use a fraction-weight (assumed
C         to be the counter-mate of the current diagnostics)
C***********************************************************************
C     !USES:
      IMPLICIT NONE

C     == Global variables ===
#include "EEPARAMS.h"
#include "SIZE.h"
#include "DIAGNOSTICS_SIZE.h"
#include "DIAGNOSTICS.h"

C     !INPUT PARAMETERS:
C***********************************************************************
C  Arguments Description
C  ----------------------
C     inpFldRL  :: Field to increment diagnostics array (arrType=0,1)
C     fracFldRL :: fraction used for weighted average diagnostics (arrType=0,2)
C     inpFldRS  :: Field to increment diagnostics array (arrType=2,3)
C     fracFldRS :: fraction used for weighted average diagnostics (arrType=1,3)
C     scaleFact :: scaling factor
C     power     :: option to fill-in with the field square (power=2)
C     arrType   :: select which array & fraction (RL/RS) to process:
C                  0: both RL ; 1: inpRL & fracRS ; 2: inpRS,fracRL ; 3: both RS
C     nLevFract :: number of levels of the fraction field, =0: do not use fraction
C     ndId      :: Diagnostics Id Number (in available diag list) of diag to process
C     kInQSd    :: Pointer to the slot in qSdiag to fill
C   region2fill :: array, indicates whether to compute statistics over region
C                   "j" (if region2fill(j)=1) or not (if region2fill(j)=0)
C     kLev      :: Integer flag for vertical levels:
C                  > 0 (any integer): WHICH single level to increment in qSdiag.
C                  0,-1 to increment "nLevs" levels in qSdiag,
C                  0 : fill-in in the same order as the input array
C                  -1: fill-in in reverse order.
C     nLevs     :: indicates Number of levels of the input field array
C                  (whether to fill-in all the levels (kLev<1) or just one (kLev>0))
C     bibjFlg   :: Integer flag to indicate instructions for bi bj loop
C                  0 indicates that the bi-bj loop must be done here
C                  1 indicates that the bi-bj loop is done OUTSIDE
C                  2 indicates that the bi-bj loop is done OUTSIDE
C                     AND that we have been sent a local array (with overlap regions)
C                  3 indicates that the bi-bj loop is done OUTSIDE
C                     AND that we have been sent a local array
C                     AND that the array has no overlap region (interior only)
C                  NOTE - bibjFlg can be NEGATIVE to indicate not to increment counter
C     biArg     :: X-direction tile number - used for bibjFlg=1-3
C     bjArg     :: Y-direction tile number - used for bibjFlg=1-3
C     myThid    :: my thread Id number
C***********************************************************************
C                  NOTE: User beware! If a local (1 tile only) array
C                        is sent here, bibjFlg MUST NOT be set to 0
C                        or there will be out of bounds problems!
C***********************************************************************
      _RL inpFldRL(*)
      _RL fracFldRL(*)
#ifndef REAL4_IS_SLOW
      _RS inpFldRS(*)
      _RS fracFldRS(*)
#endif
      _RL scaleFact
      INTEGER power
      INTEGER arrType
      INTEGER nLevFract
      INTEGER ndId, kInQSd
      INTEGER region2fill(0:nRegions)
      INTEGER kLev, nLevs, bibjFlg, biArg, bjArg
      INTEGER myThid
CEOP

C     !LOCAL VARIABLES:
C ===============
C     useFract  :: flag to increment (or not) with fraction-weigted inpFld
      LOGICAL useFract
      INTEGER sizF
      INTEGER sizI1,sizI2,sizJ1,sizJ2
      INTEGER sizTx,sizTy
      INTEGER iRun, jRun, k, bi, bj
      INTEGER kFirst, kLast
      INTEGER kd, kd0, ksgn, kStore
      CHARACTER*8 parms1
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      INTEGER km, km0
#ifndef REAL4_IS_SLOW
      _RL tmpFldRL( sNx+1,sNy+1)
      _RL tmpFracRL(sNx+1,sNy+1)
#endif

C If-sequence to see if we are a valid and an active diagnostic
c     IF ( ndId.NE.0 .AND. kInQSd.NE.0 ) THEN

C-      select range for 1rst & 2nd indices to accumulate
C         depending on variable location on C-grid,
        parms1 = gdiag(ndId)(1:8)
        IF ( parms1(2:2).EQ.'Z' ) THEN
         iRun = sNx+1
         jRun = sNy+1
c       ELSEIF ( parms1(2:2).EQ.'U' ) THEN
c        iRun = sNx+1
c        jRun = sNy
c       ELSEIF ( parms1(2:2).EQ.'V' ) THEN
c        iRun = sNx
c        jRun = sNy+1
        ELSE
         iRun = sNx
         jRun = sNy
        ENDIF

C-      Dimension of the input array:
        IF (ABS(bibjFlg).EQ.3) THEN
          sizI1 = 1
          sizI2 = sNx
          sizJ1 = 1
          sizJ2 = sNy
          iRun = sNx
          jRun = sNy
        ELSE
          sizI1 = 1-OLx
          sizI2 = sNx+OLx
          sizJ1 = 1-OLy
          sizJ2 = sNy+OLy
        ENDIF
        IF (ABS(bibjFlg).GE.2) THEN
         sizTx = 1
         sizTy = 1
        ELSE
         sizTx = nSx
         sizTy = nSy
        ENDIF
C-      Which part of inpFld to add : k = 3rd index,
C         and do the loop >> do k=kFirst,kLast <<
        IF (kLev.LE.0) THEN
          kFirst = 1
          kLast  = nLevs
        ELSEIF ( nLevs.EQ.1 ) THEN
          kFirst = 1
          kLast  = 1
        ELSEIF ( kLev.LE.nLevs ) THEN
          kFirst = kLev
          kLast  = kLev
        ELSE
          STOP 'ABNORMAL END in DIAGSTATS_FILL: kLev > nLevs > 0'
        ENDIF
C-      Which part of qSdiag to update: kd = 3rd index,
C         and do the loop >> do k=kFirst,kLast ; kd = kd0 + k*ksgn <<
C  1rst try this: for the mask: km = km0 + k*ksgn so that kd= km + kInQSd - 1
        IF ( kLev.EQ.-1 ) THEN
          ksgn = -1
          kd0 = kInQSd + nLevs
          km0 = 1 + nLevs
        ELSEIF ( kLev.EQ.0 ) THEN
          ksgn = 1
          kd0 = kInQSd - 1
          km0 = 0
        ELSE
          ksgn = 0
          kd0 = kInQSd + kLev - 1
          km0 = kLev
        ENDIF
C-      Set fraction-weight option :
        useFract = nLevFract.GT.0
        IF ( useFract ) THEN
          sizF = nLevFract
        ELSE
          sizF = 1
        ENDIF

C-      Check for consistency with Nb of levels reserved in storage array
        kStore = kd0 + MAX(ksgn*kFirst,ksgn*kLast) - kInQSd + 1
        IF ( kStore.GT.kdiag(ndId) ) THEN
         _BEGIN_MASTER(myThid)
          WRITE(msgBuf,'(2A,I4,A)') 'DIAGSTATS_FILL: ',
     &     'exceed Nb of levels(=',kdiag(ndId),' ) reserved '
          CALL PRINT_ERROR( msgBuf , myThid )
          WRITE(msgBuf,'(2A,I6,2A)') 'DIAGSTATS_FILL: ',
     &     'for Diagnostics #', ndId, ' : ', cdiag(ndId)
          CALL PRINT_ERROR( msgBuf , myThid )
          WRITE(msgBuf,'(2A,2I4,I3)') 'calling DIAGSTATS_FILL ',
     I     'with kLev,nLevs,bibjFlg=', kLev,nLevs,bibjFlg
          CALL PRINT_ERROR( msgBuf , myThid )
          WRITE(msgBuf,'(2A,I6,A)') 'DIAGSTATS_FILL: ',
     I     '==> trying to store up to ', kStore, ' levels'
          CALL PRINT_ERROR( msgBuf , myThid )
          STOP 'ABNORMAL END: S/R DIAGSTATS_FILL'
         _END_MASTER(myThid)
        ENDIF

#ifndef REAL4_IS_SLOW
      IF ( arrType.EQ.0 .OR. ( arrType.EQ.1 .AND. .NOT.useFract ) ) THEN
#endif
        IF ( bibjFlg.EQ.0 ) THEN
         DO bj=myByLo(myThid), myByHi(myThid)
          DO bi=myBxLo(myThid), myBxHi(myThid)
           DO k = kFirst,kLast
            kd = kd0 + ksgn*k
            km = km0 + ksgn*k
            CALL DIAGSTATS_LOCAL(
     U                  qSdiag(0,0,kd,bi,bj),
     I                  inpFldRL, fracFldRL,
     I                  scaleFact, power, useFract, sizF,
     I                  sizI1,sizI2,sizJ1,sizJ2,nLevs,sizTx,sizTy,
     I                  iRun,jRun,k,bi,bj,
     I                  km, bi, bj, bibjFlg, region2fill,
     I                  ndId, gdiag(ndId), myThid )
           ENDDO
          ENDDO
         ENDDO
        ELSE
          bi = MIN(biArg,sizTx)
          bj = MIN(bjArg,sizTy)
          DO k = kFirst,kLast
            kd = kd0 + ksgn*k
            km = km0 + ksgn*k
            CALL DIAGSTATS_LOCAL(
     U                  qSdiag(0,0,kd,biArg,bjArg),
     I                  inpFldRL, fracFldRL,
     I                  scaleFact, power, useFract, sizF,
     I                  sizI1,sizI2,sizJ1,sizJ2,nLevs,sizTx,sizTy,
     I                  iRun,jRun,k,bi,bj,
     I                  km, biArg, bjArg, bibjFlg, region2fill,
     I                  ndId, gdiag(ndId), myThid )
          ENDDO
        ENDIF

#ifndef REAL4_IS_SLOW
      ELSE
        IF ( bibjFlg.EQ.0 ) THEN
         DO bj=myByLo(myThid), myByHi(myThid)
          DO bi=myBxLo(myThid), myBxHi(myThid)
           DO k = kFirst,kLast
            kd = kd0 + ksgn*k
            km = km0 + ksgn*k
            CALL DIAGSTATS_TO_RL(
     I                  inpFldRL, fracFldRL, inpFldRS, fracFldRS,
     O                  tmpFldRL, tmpFracRL,
     I                  arrType, useFract, sizF,
     I                  sizI1,sizI2,sizJ1,sizJ2,nLevs,sizTx,sizTy,
     I                  iRun,jRun,k,bi,bj, myThid )
            CALL DIAGSTATS_LOCAL(
     U                  qSdiag(0,0,kd,bi,bj),
     I                  tmpFldRL, tmpFracRL,
     I                  scaleFact, power, useFract, 1,
     I                  1, iRun, 1, jRun, 1, 1, 1,
     I                  iRun, jRun, 1, 1, 1,
     I                  km, bi, bj, bibjFlg, region2fill,
     I                  ndId, gdiag(ndId), myThid )
           ENDDO
          ENDDO
         ENDDO
        ELSE
          bi = MIN(biArg,sizTx)
          bj = MIN(bjArg,sizTy)
          DO k = kFirst,kLast
            kd = kd0 + ksgn*k
            km = km0 + ksgn*k
            CALL DIAGSTATS_TO_RL(
     I                  inpFldRL, fracFldRL, inpFldRS, fracFldRS,
     O                  tmpFldRL, tmpFracRL,
     I                  arrType, useFract, sizF,
     I                  sizI1,sizI2,sizJ1,sizJ2,nLevs,sizTx,sizTy,
     I                  iRun,jRun,k,bi,bj, myThid )
            CALL DIAGSTATS_LOCAL(
     U                  qSdiag(0,0,kd,biArg,bjArg),
     I                  tmpFldRL, tmpFracRL,
     I                  scaleFact, power, useFract, 1,
     I                  1, iRun, 1, jRun, 1, 1, 1,
     I                  iRun, jRun, 1, 1, 1,
     I                  km, biArg, bjArg, bibjFlg, region2fill,
     I                  ndId, gdiag(ndId), myThid )
          ENDDO
        ENDIF
      ENDIF
#endif /* ndef REAL4_IS_SLOW */

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
c     ELSE

c     ENDIF

      RETURN
      END

#ifndef REAL4_IS_SLOW
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

CBOP
C     !ROUTINE: DIAGSTATS_TO_RL
C     !INTERFACE:
      SUBROUTINE DIAGSTATS_TO_RL(
     I                  inpFldRL, inpFrcRL, inpFldRS, inpFrcRS,
     O                  outFldRL, outFrcRL,
     I                  arrType, useFract, sizF,
     I                  sizI1,sizI2,sizJ1,sizJ2,sizK,sizTx,sizTy,
     I                  iRun,jRun,kIn,biIn,bjIn,
     I                  myThid )

C     !DESCRIPTION:
C     Do a local copy with conversion to RL type array

C     !USES:
      IMPLICIT NONE

#include "EEPARAMS.h"
#include "SIZE.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine Arguments ==
C     inpFldRL    :: input field array    to convert (arrType=0,1)
C     inpFrcRL    :: input fraction array to convert (arrType=0,2)
C     inpFldRS    :: input field array    to convert (arrType=2,3)
C     inpFrcRS    :: input fraction array to convert (arrType=1,3)
C     outFldRL    :: output field array
C     outFrcRL    :: output fraction array
C     arrType     :: select which array & fraction (RL/RS) to process:
C                    0: both RL ; 1: fldRL & frcRS ; 2: fldRS,frcRL ; 3: both RS
C     useFract    :: if True, process fraction-weight
C     sizF        :: size of inpFrc array: 3rd  dimension
C     sizI1,sizI2 :: size of inpFld array: 1rst index range (min,max)
C     sizJ1,sizJ2 :: size of inpFld array: 2nd  index range (min,max)
C     sizK        :: size of inpFld array: 3rd  dimension
C     sizTx,sizTy :: size of inpFld array: tile dimensions
C     iRun,jRun   :: range of 1rst & 2nd index
C     kIn         :: level index of inpFld array to process
C     biIn,bjIn   :: tile indices of inpFld array to process
C     myThid      :: my Thread Id number
      INTEGER sizI1,sizI2,sizJ1,sizJ2
      INTEGER sizF,sizK,sizTx,sizTy
      INTEGER iRun, jRun, kIn, biIn, bjIn
      _RL     inpFldRL(sizI1:sizI2,sizJ1:sizJ2,sizK,sizTx,sizTy)
      _RL     inpFrcRL(sizI1:sizI2,sizJ1:sizJ2,sizF,sizTx,sizTy)
      _RS     inpFldRS(sizI1:sizI2,sizJ1:sizJ2,sizK,sizTx,sizTy)
      _RS     inpFrcRS(sizI1:sizI2,sizJ1:sizJ2,sizF,sizTx,sizTy)
      _RL     outFldRL(1:iRun,1:jRun)
      _RL     outFrcRL(1:iRun,1:jRun)
      INTEGER arrType
      LOGICAL useFract
      INTEGER myThid
CEOP

C     !LOCAL VARIABLES:
C     i,j    :: loop indices
      INTEGER i, j, kFr

      IF ( arrType.LE.1 ) THEN
        DO j=1,jRun
         DO i=1,iRun
           outFldRL(i,j) = inpFldRL(i,j,kIn,biIn,bjIn)
         ENDDO
        ENDDO
      ELSE
        DO j=1,jRun
         DO i=1,iRun
           outFldRL(i,j) = inpFldRS(i,j,kIn,biIn,bjIn)
         ENDDO
        ENDDO
      ENDIF

      IF ( useFract ) THEN
       kFr = MIN(kIn,sizF)
       IF ( arrType.EQ.0 .OR. arrType.EQ.2 ) THEN
        DO j=1,jRun
         DO i=1,iRun
           outFrcRL(i,j) = inpFrcRL(i,j,kFr,biIn,bjIn)
         ENDDO
        ENDDO
       ELSE
        DO j=1,jRun
         DO i=1,iRun
           outFrcRL(i,j) = inpFrcRS(i,j,kFr,biIn,bjIn)
         ENDDO
        ENDDO
       ENDIF
      ENDIF

      RETURN
      END
#endif /* ndef REAL4_IS_SLOW */

#include "KPP_OPTIONS.h"
#ifdef ALLOW_GMREDI
#include "GMREDI_OPTIONS.h"
#endif
#ifdef ALLOW_SALT_PLUME
#include "SALT_PLUME_OPTIONS.h"
#endif

      SUBROUTINE KPP_TRANSPORT_S (
     I     iMin,iMax,jMin,jMax,bi,bj,k,km1,
     O     df,
     I     myTime, myIter, myThid )
C     *==========================================================*
C     | o SUBROUTINE KPP_TRANSPORT_S
C     |   Add non local KPP transport term (ghat) to diffusive
C     |   salinity flux.
C     *==========================================================*
C     | The nonlocal transport term is nonzero only for scalars
C     | in unstable (convective) forcing conditions.
C     | Note: KPPdiffKzS(-,k) is defined at the top of grid cell
C     |       k while KPPghat(i,j,k,bi,bj) is defined at the
C     |       bottom of grid cell k.
C     |       For K=1, KPPdiffKzS(-,k) = 0 which insures no flux
C     |       through the surface.
C     *==========================================================*
      IMPLICIT NONE

C     == GLobal variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "FFIELDS.h"
#include "KPP.h"
#include "KPP_PARAMS.h"
#ifdef ALLOW_GMREDI
# include "GMREDI.h"
#endif
#ifdef ALLOW_SALT_PLUME
# include "SALT_PLUME.h"
#endif

C     == Routine arguments ==
C     iMin,iMax,jMin,  - Range of points for which calculation
C     jMax,bi,bj,k,km1   results will be set.
C     df               - Diffusive flux component work array.
C     myTime :: Current time in simulation
C     myIter :: Current iteration number in simulation
C     myThid :: My Thread Id. number
      INTEGER iMin,iMax,jMin,jMax,bi,bj,k,km1
      _RL df     (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL     myTime
      INTEGER myIter
      INTEGER myThid

#if defined(ALLOW_KPP) && defined(KPP_GHAT)

C     == Local variables ==
C     I, J - Loop counters
      INTEGER I, J
#ifdef ALLOW_GMREDI
      _RL tmpFac
#endif
#ifdef ALLOW_SALT_PLUME
      _RL tmpFac1
#endif

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

catn: will not apply if use SALT_PLUME_VOLUME because volumes
c      will be exchanged 
#ifdef ALLOW_SALT_PLUME
      IF ( useSALT_PLUME ) THEN
# ifndef SALT_PLUME_VOLUME
         tmpFac1 = 1. _d 0
# else
         tmpFac1 = 0. _d 0
# endif /* ndef SALT_PLUME_VOLUME */
      ELSE
         tmpFac1 = 0. _d 0
      ENDIF
#endif /* ALLOW_SALT_PLUME */

#ifdef ALLOW_GMREDI

      IF ( useGMRedi .AND. KPP_ghatUseTotalDiffus ) THEN
        tmpFac = 1. _d 0
      ELSE
        tmpFac = 0. _d 0
      ENDIF
      DO j=jMin,jMax
       DO i=iMin,iMax
        df(i,j) = - _rA(i,j,bi,bj)
     &        *( KPPdiffKzS(i,j,k,bi,bj) + tmpFac*Kwz(i,j,k,bi,bj) )
     &        *KPPghat(i,j,km1,bi,bj)
     &        *( surfaceForcingS(i,j,bi,bj)
#ifdef ALLOW_SALT_PLUME
     &          + tmpFac1*saltPlumeFlux(i,j,bi,bj)*recip_rhoConst
     &          *(1.-KPPplumefrac(i,j,bi,bj))
#endif /* ALLOW_SALT_PLUME */
     &         )
       ENDDO
      ENDDO

#else /* ALLOW_GMREDI */

      DO j=jMin,jMax
       DO i=iMin,iMax
        df(i,j) = - _rA(i,j,bi,bj)
     &        *KPPdiffKzS(i,j,k,bi,bj)
     &        *KPPghat(i,j,km1,bi,bj)
     &        *( surfaceForcingS(i,j,bi,bj)
#ifdef ALLOW_SALT_PLUME
     &          + tmpFac1*saltPlumeFlux(i,j,bi,bj)*recip_rhoConst
     &          *(1.-KPPplumefrac(i,j,bi,bj))
#endif /* ALLOW_SALT_PLUME */
     &         )
       ENDDO
      ENDDO

#endif /* ALLOW_GMREDI */

#endif /* ALLOW_KPP and KPP_GHAT */

      RETURN
      END

#include "EXF_OPTIONS.h"

C--  File exf_set_obcs.F:
C--   Contents
C--   o EXF_SET_OBCS_XZ
C--   o EXF_SET_OBCS_YZ
C--   o EXF_SET_OBCS_X   <- no longer maintained ; use SET_OBCS_XZ with nNz=1
C--   o EXF_SET_OBCS_Y   <- no longer maintained ; use SET_OBCS_YZ with nNz=1

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      SUBROUTINE EXF_SET_OBCS_XZ (
     U       obcs_fld_xz, obcs_xz_0, obcs_xz_1,
     I       obcs_file, obcsmask, nNz,
     I       fac, first, changed, useYearlyFields, obcs_period,
     I       count0, count1, year0, year1,
     I       myTime, myIter, myThid )

C     ==================================================================
C     SUBROUTINE EXF_SET_OBCS_XZ
C     ==================================================================
C
C     o set open boundary conditions
C
C     started: heimbach@mit.edu 01-May-2001
C     mods for pkg/seaice: menemenlis@jpl.nasa.gov 20-Dec-2002

C     ==================================================================
C     SUBROUTINE EXF_SET_OBCS_XZ
C     ==================================================================

      IMPLICIT NONE

C     == global variables ==
#include "EEPARAMS.h"
#include "SIZE.h"
#include "GRID.h"
#include "EXF_PARAM.h"
#include "EXF_CONSTANTS.h"

C     == routine arguments ==
C     nNz   :: number of levels to process
      INTEGER nNz
      _RL obcs_fld_xz(1-OLx:sNx+OLx,nNz,nSx,nSy)
      _RL obcs_xz_0(1-OLx:sNx+OLx,nNz,nSx,nSy)
      _RL obcs_xz_1(1-OLx:sNx+OLx,nNz,nSx,nSy)

      CHARACTER*(128) obcs_file
      CHARACTER*1 obcsmask
      LOGICAL first, changed
      LOGICAL useYearlyFields
      _RL     obcs_period
      INTEGER count0, count1, year0, year1
      _RL     fac
      _RL     myTime
      INTEGER myIter
      INTEGER myThid

#ifdef ALLOW_OBCS

C     == local variables ==

      CHARACTER*(128) obcs_file0, obcs_file1
      INTEGER bi, bj
      INTEGER i, k

C     == end of interface ==

      IF ( obcs_file .NE. ' ' ) THEN

         IF ( first ) THEN

            CALL exf_GetYearlyFieldName(
     I         useYearlyFields, twoDigitYear, obcs_period, year0,
     I         obcs_file,
     O         obcs_file0,
     I         myTime, myIter, myThid )

            _BARRIER
            CALL READ_REC_XZ_RL( obcs_file0, exf_iprec_obcs, nNz,
     &                           obcs_xz_1, count0, myIter, myThid )
            _BARRIER
         ENDIF

         IF ( first .OR. changed ) THEN
            CALL exf_swapffields_xz( obcs_xz_0, obcs_xz_1, nNz,myThid )

            CALL exf_GetYearlyFieldName(
     I         useYearlyFields, twoDigitYear, obcs_period, year1,
     I         obcs_file,
     O         obcs_file1,
     I         myTime, myIter, myThid )

            _BARRIER
            CALL READ_REC_XZ_RL( obcs_file1, exf_iprec_obcs, nNz,
     &                           obcs_xz_1, count1, myIter, myThid )
            _BARRIER
         ENDIF

         DO bj = myByLo(myThid),myByHi(myThid)
            DO bi = myBxLo(myThid),myBxHi(myThid)
               DO k = 1,nNz
                  DO i = 1,sNx
                     obcs_fld_xz(i,k,bi,bj) =
     &                    fac * obcs_xz_0(i,k,bi,bj) +
     &                    (exf_one - fac) * obcs_xz_1(i,k,bi,bj)
                  ENDDO
               ENDDO
            ENDDO
         ENDDO

      ENDIF

#endif /* ALLOW_OBCS */

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      SUBROUTINE EXF_SET_OBCS_YZ (
     U       obcs_fld_yz, obcs_yz_0, obcs_yz_1,
     I       obcs_file, obcsmask, nNz,
     I       fac, first, changed, useYearlyFields, obcs_period,
     I       count0, count1, year0, year1,
     I       myTime, myIter, myThid)

C     ==================================================================
C     SUBROUTINE EXF_SET_OBCS_YZ
C     ==================================================================
C
C     o set open boundary conditions
C
C     started: heimbach@mit.edu 01-May-2001

C     ==================================================================
C     SUBROUTINE EXF_SET_OBCS_YZ
C     ==================================================================

      IMPLICIT NONE

C     == global variables ==
#include "EEPARAMS.h"
#include "SIZE.h"
#include "GRID.h"
#include "EXF_PARAM.h"
#include "EXF_CONSTANTS.h"

C     == routine arguments ==
C     nNz   :: number of levels to process
      INTEGER nNz
      _RL obcs_fld_yz(1-OLy:sNy+OLy,nNz,nSx,nSy)
      _RL obcs_yz_0(1-OLy:sNy+OLy,nNz,nSx,nSy)
      _RL obcs_yz_1(1-OLy:sNy+OLy,nNz,nSx,nSy)
      CHARACTER*(MAX_LEN_FNAM) obcs_file
      CHARACTER*1 obcsmask
      LOGICAL first, changed
      LOGICAL useYearlyFields
      _RL     obcs_period
      INTEGER count0, count1, year0, year1
      _RL     fac
      _RL     myTime
      INTEGER myIter
      INTEGER myThid

#ifdef ALLOW_OBCS

C     == local variables ==

      CHARACTER*(128) obcs_file0, obcs_file1
      INTEGER bi, bj
      INTEGER j, k

C     == end of interface ==

      IF ( obcs_file .NE. ' ' ) THEN

         IF ( first ) THEN

            CALL exf_GetYearlyFieldName(
     I         useYearlyFields, twoDigitYear, obcs_period, year0,
     I         obcs_file,
     O         obcs_file0,
     I         myTime, myIter, myThid )

            _BARRIER
            CALL READ_REC_YZ_RL( obcs_file0, exf_iprec_obcs, nNz,
     &                           obcs_yz_1, count0, myIter, myThid )
            _BARRIER
         ENDIF

         IF ( first .OR. changed ) THEN
            CALL exf_swapffields_yz( obcs_yz_0, obcs_yz_1, nNz,myThid )

            CALL exf_GetYearlyFieldName(
     I         useYearlyFields, twoDigitYear, obcs_period, year1,
     I         obcs_file,
     O         obcs_file1,
     I         myTime, myIter, myThid )

            _BARRIER
            CALL READ_REC_YZ_RL( obcs_file1, exf_iprec_obcs, nNz,
     &                           obcs_yz_1, count1, myIter, myThid )
            _BARRIER
         ENDIF

         DO bj = myByLo(myThid),myByHi(myThid)
            DO bi = myBxLo(myThid),myBxHi(myThid)
               DO k = 1,nNz
                  DO j = 1,sNy
                     obcs_fld_yz(j,k,bi,bj) =
     &                    fac             *obcs_yz_0(j,k,bi,bj) +
     &                    (exf_one - fac) *obcs_yz_1(j,k,bi,bj)
                  ENDDO
               ENDDO
            ENDDO
         ENDDO

      ENDIF

#endif /* ALLOW_OBCS */

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      SUBROUTINE EXF_SET_OBCS_X (
     U       obcs_fld_x, obcs_x_0, obcs_x_1,
     I       obcs_file, obcsmask,
     I       fac, first, changed, useYearlyFields, obcs_period,
     I       count0, count1, year0, year1,
     I       myTime, myIter, myThid )

C     ==================================================================
C     SUBROUTINE EXF_SET_OBCS_X
C     ==================================================================
C
C     o set open boundary conditions
C       same as EXF_SET_OBCS_XZ but for Nr=1
C
C     ==================================================================
C     SUBROUTINE EXF_SET_OBCS_X
C     ==================================================================

      IMPLICIT NONE

C     == global variables ==

#include "EEPARAMS.h"
#include "SIZE.h"
#include "GRID.h"
#include "EXF_PARAM.h"
#include "EXF_CONSTANTS.h"

C     == routine arguments ==

      _RL obcs_fld_x(1-OLx:sNx+OLx,nSx,nSy)
      _RL obcs_x_0(1-OLx:sNx+OLx,nSx,nSy)
      _RL obcs_x_1(1-OLx:sNx+OLx,nSx,nSy)

      CHARACTER*(128) obcs_file
      CHARACTER*1 obcsmask
      LOGICAL first, changed
      LOGICAL useYearlyFields
      _RL     obcs_period
      INTEGER count0, count1, year0, year1
      _RL     fac
      _RL     myTime
      INTEGER myIter
      INTEGER myThid

#ifdef ALLOW_OBCS

C     == local variables ==

      CHARACTER*(128) obcs_file0, obcs_file1
      INTEGER bi, bj, i

C     == end of interface ==

      STOP 'S/R EXF_SET_OBCS_X no longer maintained'

      IF ( obcs_file .NE. ' ' ) THEN

         IF ( first ) THEN

            CALL exf_GetYearlyFieldName(
     I         useYearlyFields, twoDigitYear, obcs_period, year0,
     I         obcs_file,
     O         obcs_file0,
     I         myTime, myIter, myThid )

            CALL READ_REC_XZ_RL( obcs_file0, exf_iprec_obcs, 1,
     &                           obcs_x_1, count0, myIter, myThid )
         ENDIF

         IF (( first ) .OR. ( changed )) THEN
            CALL exf_swapffields_xz( obcs_x_0, obcs_x_1, 1,myThid )

            CALL exf_GetYearlyFieldName(
     I         useYearlyFields, twoDigitYear, obcs_period, year1,
     I         obcs_file,
     O         obcs_file1,
     I         myTime, myIter, myThid )

            CALL READ_REC_XZ_RL( obcs_file1, exf_iprec_obcs, 1,
     &                           obcs_x_1, count1, myIter, myThid )
         ENDIF

         DO bj = myByLo(myThid),myByHi(myThid)
            DO bi = myBxLo(myThid),myBxHi(myThid)
               DO i = 1,sNx
                  obcs_fld_x(i,bi,bj) =
     &                 fac * obcs_x_0(i,bi,bj) +
     &                 (exf_one - fac) * obcs_x_1(i,bi,bj)
               ENDDO
            ENDDO
         ENDDO

      ENDIF

#endif /* ALLOW_OBCS */

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      SUBROUTINE EXF_SET_OBCS_Y (
     U       obcs_fld_y, obcs_y_0, obcs_y_1,
     I       obcs_file, obcsmask,
     I       fac, first, changed, useYearlyFields, obcs_period,
     I       count0, count1, year0, year1,
     I       myTime, myIter, myThid )

C     ==================================================================
C     SUBROUTINE EXF_SET_OBCS_Y
C     ==================================================================
C
C     o set open boundary conditions
C       same as EXF_SET_OBCS_YZ but for Nr=1
C
C     ==================================================================
C     SUBROUTINE EXF_SET_OBCS_Y
C     ==================================================================

      IMPLICIT NONE

C     == global variables ==

#include "EEPARAMS.h"
#include "SIZE.h"
#include "GRID.h"
#include "EXF_PARAM.h"
#include "EXF_CONSTANTS.h"

C     == routine arguments ==

      _RL obcs_fld_y(1-OLy:sNy+OLy,nSx,nSy)
      _RL obcs_y_0(1-OLy:sNy+OLy,nSx,nSy)
      _RL obcs_y_1(1-OLy:sNy+OLy,nSx,nSy)
      CHARACTER*(MAX_LEN_FNAM) obcs_file
      CHARACTER*1 obcsmask
      LOGICAL first, changed
      LOGICAL useYearlyFields
      _RL     obcs_period
      INTEGER count0, count1, year0, year1
      _RL     fac
      _RL     myTime
      INTEGER myIter
      INTEGER myThid

#ifdef ALLOW_OBCS

C     == local variables ==

      CHARACTER*(128) obcs_file0, obcs_file1
      INTEGER bi, bj, j

C     == end of interface ==

      STOP 'S/R EXF_SET_OBCS_X no longer maintained'

      IF ( obcs_file .NE. ' ' ) THEN

         IF ( first ) THEN

            CALL exf_GetYearlyFieldName(
     I         useYearlyFields, twoDigitYear, obcs_period, year0,
     I         obcs_file,
     O         obcs_file0,
     I         myTime, myIter, myThid )

            CALL READ_REC_YZ_RL( obcs_file0, exf_iprec_obcs, 1,
     &                           obcs_y_1, count0, myIter, myThid )
         ENDIF

         IF (( first ) .OR. ( changed )) THEN
            CALL exf_swapffields_yz( obcs_y_0, obcs_y_1, 1,myThid )

            CALL exf_GetYearlyFieldName(
     I         useYearlyFields, twoDigitYear, obcs_period, year1,
     I         obcs_file,
     O         obcs_file1,
     I         myTime, myIter, myThid )

            CALL READ_REC_YZ_RL( obcs_file1, exf_iprec_obcs, 1,
     &                           obcs_y_1, count1, myIter, myThid )
         ENDIF

         DO bj = myByLo(myThid),myByHi(myThid)
            DO bi = myBxLo(myThid),myBxHi(myThid)
               DO j = 1,sNy
                  obcs_fld_y(j,bi,bj) =
     &                 fac             *obcs_y_0(j,bi,bj) +
     &                 (exf_one - fac) *obcs_y_1(j,bi,bj)
               ENDDO
            ENDDO
         ENDDO

      ENDIF

#endif /* ALLOW_OBCS */

      RETURN
      END

C     contains:
C     S/R SEAICE_ITD_REMAP
C     S/R SEAICE_ITD_REMAP_LINEAR
C     S/R SEAICE_ITD_REMAP_CHECK_BOUNDS

#include "SEAICE_OPTIONS.h"

CBOP
C !ROUTINE: SEAICE_ITD_REMAP

C !INTERFACE: ==========================================================
      SUBROUTINE SEAICE_ITD_REMAP(
     I     heffitdpre, areaitdpre,
     I     bi, bj, myTime, myIter, myThid )

C !DESCRIPTION: \bv
C     *===========================================================*
C     | SUBROUTINE SEAICE_ITD_REMAP
C     | o checks if absolute ice thickness in any category
C     |   exceeds its category limits
C     | o remaps sea ice area and volume
C     |   and associated ice properties in thickness space
C     |   following the remapping scheme of Lipscomb (2001), JGR
C     |
C     | Martin Losch, started in May 2014, Martin.Losch@awi.de
C     | with many fixes by Mischa Ungermann (MU)
C     *===========================================================*
C \ev

C !USES: ===============================================================
      IMPLICIT NONE

C     === Global variables to be checked and remapped ===
C     AREAITD   :: sea ice area      by category
C     HEFFITD   :: sea ice thickness by category
C
C     === Global variables to be remappped ===
C     HSNOWITD  :: snow thickness    by category
C     enthalpy ?
C     temperature ?
C     salinity ?
C     age ?
C
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "SEAICE_SIZE.h"
#include "SEAICE_PARAMS.h"
#include "SEAICE_GRID.h"
#include "SEAICE.h"

C !INPUT PARAMETERS: ===================================================
C     === Routine arguments ===
C     bi, bj    :: outer loop counters
C     myTime    :: current time
C     myIter    :: iteration number
C     myThid    :: Thread no. that called this routine.
      _RL myTime
      INTEGER bi,bj
      INTEGER myIter
      INTEGER myThid
      _RL heffitdPre  (1:sNx,1:sNy,1:nITD)
      _RL areaitdPre  (1:sNx,1:sNy,1:nITD)

#ifdef SEAICE_ITD

C !LOCAL VARIABLES: ====================================================
C     === Local variables ===
C     i,j,k       :: inner loop counters
C
      INTEGER i, j, k
      INTEGER kDonor, kRecvr
      _RL slope, area_reg_sq, hice_reg_sq
      _RL etaMin, etaMax, etam, etap, eta2
      _RL dh0, da0, daMax
CMU      _RL oneMinusEps
      _RL third
      PARAMETER ( third = 0.333333333333333333333333333 _d 0 )
C
      _RL dhActual    (1:sNx,1:sNy,1:nITD)
      _RL hActual     (1:sNx,1:sNy,1:nITD)
      _RL hActualPre  (1:sNx,1:sNy,1:nITD)
      _RL dheff, darea, dhsnw
C
      _RL hLimitNew   (1:sNx,1:sNy,0:nITD)
C     coefficients for represent g(h)
C     g0 :: constant coefficient in g(h)
C     g1 :: linear  coefficient in g(h)
C     hL :: left end of range over which g(h) > 0
C     hL :: right end of range over which g(h) > 0
      _RL g0 (1:sNx,1:sNy,0:nITD)
      _RL g1 (1:sNx,1:sNy,0:nITD)
      _RL hL (1:sNx,1:sNy,0:nITD)
      _RL hR (1:sNx,1:sNy,0:nITD)
C     local copy of AREAITD
      _RL aLoc(1:sNx,1:sNy)
      LOGICAL doRemapping (1:sNx,1:sNy)
CEOP
C---+-|--1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C     constants
      area_reg_sq = SEAICE_area_reg**2
      hice_reg_sq = SEAICE_hice_reg**2
CMU      oneMinusEps = 1. _d 0 - SEAICE_eps
C     initialisation
      DO j=1,sNy
       DO i=1,sNx
        doRemapping(i,j) = .FALSE.
        IF ( HEFFM(i,j,bi,bj) .NE. 0. _d 0 ) doRemapping(i,j) = .TRUE.
       ENDDO
      ENDDO
C     do not compute regularized hActual as in seaice_growth, because
C     with regularization, hActual deviates too much from the actual
C     category boundaries and the boundary computation fails too often.
      DO k=1,nITD
       DO j=1,sNy
        DO i=1,sNx
         hActualPre (i,j,k) = 0. _d 0
         hActual (i,j,k) = 0. _d 0
         dhActual(i,j,k) = 0. _d 0
         IF (.FALSE.) THEN
          IF ( areaitdPre(i,j,k) .GT. 0. _d 0 ) THEN
           hActualPre(i,j,k) = heffitdPre(i,j,k)
     &         /SQRT( areaitdPre(i,j,k)**2 + area_reg_sq )
CML           hActualPre(i,j,k) = SQRT( hActualPre(i,j,k)**2 + hice_reg_sq )
          ENDIF
          IF ( AREAITD(i,j,k,bi,bj) .GT. 0. _d 0 ) THEN
           hActual(i,j,k) = HEFFITD(i,j,k,bi,bj)
     &         /SQRT( AREAITD(i,j,k,bi,bj)**2 + area_reg_sq )
CML           hActual(i,j,k) = SQRT( hActual(i,j,k)**2 + hice_reg_sq )
          ENDIF
          dhActual(i,j,k) = hActual(i,j,k) - hActualPre(i,j,k)
         ELSE
          IF ( areaitdPre(i,j,k) .GT. SEAICE_area_reg ) THEN
           hActualPre(i,j,k) = heffitdPre(i,j,k)/areaitdPre(i,j,k)
          ENDIF
          IF ( AREAITD(i,j,k,bi,bj) .GT. SEAICE_area_reg ) THEN
           hActual(i,j,k) = HEFFITD(i,j,k,bi,bj)/AREAITD(i,j,k,bi,bj)
          ENDIF
          dhActual(i,j,k) = hActual(i,j,k) - hActualPre(i,j,k)
         ENDIF
        ENDDO
       ENDDO
      ENDDO
C
C     compute new category boundaries
C
      DO j=1,sNy
       DO i=1,sNx
        hLimitNew(i,j,0) = hLimit(0)
       ENDDO
      ENDDO
      DO k=1,nITD-1
       DO j=1,sNy
        DO i=1,sNx
         IF ( hActualPre(i,j,k)  .GT.SEAICE_eps .AND.
     &        hActualPre(i,j,k+1).GT.SEAICE_eps ) THEN
          slope = ( dhActual(i,j,k+1) - dhActual(i,j,k) )
     &         /( hActualPre(i,j,k+1) - hActualPre(i,j,k) )
          hLimitNew(i,j,k) =   hLimit(k) + dhActual(i,j,k)
     &         +     slope * ( hLimit(k) - hActualPre(i,j,k) )
         ELSEIF ( hActualPre(i,j,k)  .GT.SEAICE_eps ) THEN
          hLimitNew(i,j,k) = hLimit(k) + dhActual(i,j,k)
         ELSEIF ( hActualPre(i,j,k+1).GT.SEAICE_eps ) THEN
          hLimitNew(i,j,k) = hLimit(k) + dhActual(i,j,k+1)
         ELSE
          hLimitNew(i,j,k) = hLimit(k)
         ENDIF
C     After computing the new boundary, check
C     (1) if it is between two adjacent thicknesses
         IF ( ( AREAITD(i,j,k,bi,bj).GT.SEAICE_area_reg .AND.
     &          hActual(i,j,k) .GE. hLimitNew(i,j,k) ) .OR.
     &        ( AREAITD(i,j,k+1,bi,bj).GT.SEAICE_area_reg .AND.
     &          hActual(i,j,k+1) .LE. hLimitNew(i,j,k) ) )
     &        doRemapping(i,j) = .FALSE.
C     (2) that it is been the old boudnaries k-1 and k+1
C     (Note from CICE: we could allow this, but would make the code
C     more complicated)
         IF ( ( hLimitNew(i,j,k) .GT. hLimit(k+1) ) .OR.
     &        ( hLimitNew(i,j,k) .LT. hLimit(k-1) ) )
     &        doRemapping(i,j) = .FALSE.
        ENDDO
       ENDDO
      ENDDO
C     Report problems, if there are any. Because this breaks optimization
C     do not do it by default.
C     Where doRemapping is false, the rebinning of seaice_itd_redist
C     (called at the end) will take care of shifting the ice.
      IF ( debugLevel.GE.debLevA )
     &     CALL SEAICE_ITD_REMAP_CHECK_BOUNDS(
     I     AREAITD, hActual, hActualPre, hLimitNew, doRemapping,
     I     bi, bj, myTime, myIter, myThid )
C     computing the upper limit of the thickest category does not require
C     any checks and can be computed now
      k = nITD
      DO j=1,sNy
       DO i=1,sNx
        hLimitNew(i,j,k) = hLimit(k)
        IF ( AREAITD(i,j,k,bi,bj).GT.SEAICE_area_reg )
     &       hLimitNew(i,j,k) = MAX( 3. _d 0*hActual(i,j,k)
     &       - 2. _d 0 * hLimitNew(i,j,k-1), hLimit(k-1) )
       ENDDO
      ENDDO
C
C     end of limit computation, now compute the coefficients of the
C     linear approximations of g(h) => g(eta) = g0 + g1*eta
C
C     CICE does something specical for the first category.
C     compute coefficients for 1st category
      k = 1
      DO j=1,sNy
       DO i=1,sNx
C     initialisation
        aLoc(i,j) = AREAITD(i,j,k,bi,bj)
C     initialise hL and hR
C     this single line is different from the code that follows below
C     for all categories
        hL(i,j,k) = hLimitNew(i,j,k-1)
        hR(i,j,k) = hLimit(k)
       ENDDO
      ENDDO
      CALL SEAICE_ITD_REMAP_LINEAR(
     O     g0(1,1,k), g1(1,1,k),
     U     hL(1,1,k), hR(1,1,k),
     I     hActual(1,1,k), aLoc,
     I     SEAICE_area_reg, SEAICE_eps, doRemapping,
     I     myTime, myIter, myThid )
C
C     Find area lost due to melting of thin (category 1) ice
C
      DO j=1,sNy
       DO i=1,sNx
        IF ( doRemapping(i,j) .AND.
     &       AREAITD(i,j,k,bi,bj) .GT. SEAICE_area_reg ) THEN
CMU if melting of ice in category 1
         IF ( dhActual(i,j,k) .LT. 0. _d 0 ) THEN
C     integrate g(1) from zero to abs(dhActual)
CMU dh0 is max thickness of ice in first category that is melted
          dh0    = MIN(-dhActual(i,j,k),hLimit(k))
          etaMax = MIN(dh0,hR(i,j,k)) - hL(i,j,k)
          IF ( etaMax > 0. _d 0 ) THEN
CMU da0 is /int_0^dh0 g dh
           da0 = g0(i,j,k)*etaMax + g1(i,j,k)*etaMax*etaMax*0.5 _d 0
           daMax = AREAITD(i,j,k,bi,bj)
     &          * ( 1. _d 0 - hActual(i,j,k)/hActualPre(i,j,k))
           da0 = MIN( da0, daMax )
CMU adjust thickness to conserve volume
           IF ( (AREAITD(i,j,k,bi,bj)-da0) .GT. SEAICE_area_reg ) THEN
             hActual(i,j,k) = hActual(i,j,k)
     &            * AREAITD(i,j,k,bi,bj)/( AREAITD(i,j,k,bi,bj) - da0 )
           ELSE
             hActual(i,j,k) = ZERO
             da0 = AREAITD(i,j,k,bi,bj)
           ENDIF
CMU increase open water fraction
           AREAITD(i,j,k,bi,bj) = AREAITD(i,j,k,bi,bj) - da0
          ENDIF
         ELSE
CMU H_0* = F_0 * dT
          hLimitNew(i,j,k-1) = MIN( dhActual(i,j,k), hLimit(k) )
         ENDIF
        ENDIF
       ENDDO
      ENDDO
C
C     compute all coefficients
C
      DO k=1,nITD
       DO j=1,sNy
        DO i=1,sNx
C     initialisation
         aLoc(i,j) = AREAITD(i,j,k,bi,bj)
C     initialise hL and hR
         hL(i,j,k) = hLimitNew(i,j,k-1)
         hR(i,j,k) = hLimitNew(i,j,k)
        ENDDO
       ENDDO
       CALL SEAICE_ITD_REMAP_LINEAR(
     O      g0(1,1,k), g1(1,1,k),
     U      hL(1,1,k), hR(1,1,k),
     I      hActual(1,1,k), aLoc,
     I      SEAICE_area_reg, SEAICE_eps, doRemapping,
     I      myTime, myIter, myThid )
      ENDDO
C
      DO k=1,nITD-1
       DO j=1,sNy
        DO i=1,sNx
         dheff = 0. _d 0
         darea = 0. _d 0
         IF ( doRemapping(i,j) ) THEN
C     compute integration limits in eta space
          IF ( hLimitNew(i,j,k) .GT. hLimit(k) ) THEN
           etaMin = MAX(       hLimit(k), hL(i,j,k)) - hL(i,j,k)
           etaMax = MIN(hLimitNew(i,j,k), hR(i,j,k)) - hL(i,j,k)
           kDonor = k
           kRecvr = k+1
          ELSE
           etaMin = 0. _d 0
           etaMax = MIN(hLimit(k), hR(i,j,k+1)) - hL(i,j,k+1)
           kDonor = k+1
           kRecvr = k
          ENDIF
C     compute the area and volume to be moved
          IF ( etaMax .GT. etaMin ) THEN
           etam  = etaMax-etaMin
           etap  = etaMax+etaMin
           eta2  = 0.5*etam*etap
           darea = g0(i,j,kDonor)*etam + g1(i,j,kDonor)*eta2
CML           dheff = g0(i,j,kDonor)*eta2
CML     &          +  g1(i,j,kDonor)*etam*(etap*etap-etaMax*etaMin)*third
CML     &          +  darea*hL(i,j,kDonor)
           dheff = g0(i,j,kDonor)*eta2
     &          +  g1(i,j,kDonor)*(etaMax**3-etaMin**3)*third
     &          +  darea*hL(i,j,kDonor)
          ENDIF
C     ... or shift entire category, if nearly all ice is to be shifted.
CMU          IF ( (darea .GT.AREAITD(i,j,kDonor,bi,bj)*oneMinusEps).OR.
CMU     &         (dheff .GT.HEFFITD(i,j,kDonor,bi,bj)*oneMinusEps) ) THEN
          IF ( (darea .GT.AREAITD(i,j,kDonor,bi,bj)-SEAICE_eps).OR.
     &         (dheff .GT.HEFFITD(i,j,kDonor,bi,bj)-SEAICE_eps) ) THEN
           darea = AREAITD(i,j,kDonor,bi,bj)
           dheff = HEFFITD(i,j,kDonor,bi,bj)
          ENDIF
C     regularize: reset to zero, if there is too little ice to be shifted ...
CMU          IF ( (darea .LT. AREAITD(i,j,kDonor,bi,bj)*SEAICE_eps).OR.
CMU     &         (dheff .LT. HEFFITD(i,j,kDonor,bi,bj)*SEAICE_eps) ) THEN
          IF ( (darea .LT. SEAICE_eps).OR.
     &         (dheff .LT. SEAICE_eps) ) THEN
           darea  = 0. _d 0
           dheff  = 0. _d 0
          ENDIF
C     snow scaled by area
          IF ( AREAITD(i,j,kDonor,bi,bj) .GT. SEAICE_area_reg ) THEN
C     snow scaled by area (why not volume?), CICE also does it in this way
           dhsnw = darea/AREAITD(i,j,kDonor,bi,bj)
     &          * HSNOWITD(i,j,kDonor,bi,bj)
CMU          IF ( HEFFITD(i,j,kDonor,bi,bj) .GT. SEAICE_hice_reg ) THEN
CMU           dhsnw = dheff/HEFFITD(i,j,kDonor,bi,bj)
CMU     &         * HSNOWITD(i,j,kDonor,bi,bj)
          ELSE
           dhsnw = HSNOWITD(i,j,kDonor,bi,bj)
          ENDIF
C     apply increments
          HEFFITD(i,j,kRecvr,bi,bj) = HEFFITD(i,j,kRecvr,bi,bj) + dheff
          HEFFITD(i,j,kDonor,bi,bj) = HEFFITD(i,j,kDonor,bi,bj) - dheff
          AREAITD(i,j,kRecvr,bi,bj) = AREAITD(i,j,kRecvr,bi,bj) + darea
          AREAITD(i,j,kDonor,bi,bj) = AREAITD(i,j,kDonor,bi,bj) - darea
          HSNOWITD(i,j,kRecvr,bi,bj)=HSNOWITD(i,j,kRecvr,bi,bj) + dhsnw
          HSNOWITD(i,j,kDonor,bi,bj)=HSNOWITD(i,j,kDonor,bi,bj) - dhsnw
C     end if doRemapping
         ENDIF
        ENDDO
       ENDDO
      ENDDO

      RETURN
      END

C---+-|--1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

CBOP
C !ROUTINE: SEAICE_ITD_REMAP_LINEAR

C !INTERFACE: ==========================================================
      SUBROUTINE SEAICE_ITD_REMAP_LINEAR(
     O     g0, g1,
     U     hL, hR,
     I     hActual, area,
     I     SEAICE_area_reg, SEAICE_eps, doRemapping,
     I     myTime, myIter, myThid )

C !DESCRIPTION: \bv
C     *===========================================================*
C     | SUBROUTINE SEAICE_ITD_REMAP_LINEAR
C     | o compute coefficients g0, g1 for piece-wise linear fit
C     |    g(h) = g0 + g1*h
C     | o compute range boundaries hL, hR for this linear fit
C     |
C     | Martin Losch, May 2014, Martin.Losch@awi.de
C     *===========================================================*
C \ev

C !USES: ===============================================================
      IMPLICIT NONE

#include "SIZE.h"

C !INPUT PARAMETERS: ===================================================
C     === Routine arguments ===
C     myTime    :: current time
C     myIter    :: iteration number
C     myThid    :: Thread no. that called this routine.
      _RL myTime
      INTEGER myIter
      INTEGER myThid
C
C     OUTPUT: coefficients for representing g(h)
C     g0 :: constant coefficient in g(h)
C     g1 :: linear  coefficient in g(h)
C     hL :: left end of range over which g(h) > 0
C     hL :: right end of range over which g(h) > 0
      _RL g0 (1:sNx,1:sNy)
      _RL g1 (1:sNx,1:sNy)
      _RL hL (1:sNx,1:sNy)
      _RL hR (1:sNx,1:sNy)
C     INPUT:
C     hActual :: ice thickness of current category
C     area    :: ice concentration of current category
      _RL hActual (1:sNx,1:sNy)
      _RL area    (1:sNx,1:sNy)
C     regularization constants
      _RL SEAICE_area_reg
      _RL SEAICE_eps
C     doRemapping :: mask where can be done, excludes points where
C                    new category limits are outside certain bounds
      LOGICAL doRemapping (1:sNx,1:sNy)

C !LOCAL VARIABLES: ====================================================
C     === Local variables ===
C     i,j       :: inner loop counters
C
      INTEGER i, j
C     auxCoeff :: helper variable
C     recip_etaR :: reciprocal of range interval in eta space
C     etaNoR   :: ratio of distance to lower limit over etaR
      _RL auxCoeff
      _RL recip_etaR, etaNoR
      _RL third, sixth
      PARAMETER ( third = 0.333333333333333333333333333 _d 0 )
      PARAMETER ( sixth = 0.666666666666666666666666666 _d 0 )
CEOP
C
C     initialisation of hL, hR is done outside this routine
C
      DO j=1,sNy
       DO i=1,sNx
        g0(i,j) = 0. _d 0
        g1(i,j) = 0. _d 0
        IF ( doRemapping(i,j) .AND.
     &       area(i,j) .GT. SEAICE_area_reg .AND.
     &       hR(i,j) - hL(i,j) .GT. SEAICE_eps ) THEN
C     change hL and hR if hActual falls outside the central third of the range
         IF ( hActual(i,j) .LT. (2. _d 0*hL(i,j) + hR(i,j))*third ) THEN
          hR(i,j) = 3. _d 0 * hActual(i,j) - 2. _d 0 * hL(i,j)
         ELSEIF ( hActual(i,j).GT.(hL(i,j)+2. _d 0*hR(i,j))*third ) THEN
          hL(i,j) = 3. _d 0 * hActual(i,j) - 2. _d 0 * hR(i,j)
         ENDIF
C     calculate new etaR = hR - hL;
C     catch the case of hR=hL, which can happen when hActual=hR or hL
C     before entering this routine; in this case g0=g1=0.
         recip_etaR = 0. _d 0
CMU         IF ( hR(i,j) .GT. hL(i,j) ) ! crucial change; lets the model explode
         IF ( hR(i,j) - hL(i,j) .GT. SEAICE_eps )
     &        recip_etaR = 1. _d 0 / (hR(i,j) - hL(i,j))
C     some abbreviations to avoid computing the same thing multiple times
         etaNoR     = (hActual(i,j) - hL(i,j))*recip_etaR
         auxCoeff   = 6. _d 0 * area(i,j)*recip_etaR
C     equations (14) of Lipscomb (2001), JGR
         g0(i,j) = auxCoeff*( sixth - etaNoR )
         g1(i,j) = 2. _d 0 * auxCoeff*recip_etaR*( etaNoR - 0.5 _d 0 )
        ELSE
C     not doRemapping
C     reset hL and hR
         hL(i,j) = 0. _d 0
         hR(i,j) = 0. _d 0
        ENDIF
       ENDDO
      ENDDO

      RETURN
      END

C---+-|--1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

CBOP
C !ROUTINE: SEAICE_ITD_REMAP_CHECK_BOUNDS

C !INTERFACE: ==========================================================
      SUBROUTINE SEAICE_ITD_REMAP_CHECK_BOUNDS(
     I     AREAITD, hActual, hActualPre, hLimitNew, doRemapping,
     I     bi, bj, myTime, myIter, myThid )

C !DESCRIPTION: \bv
C     *===========================================================*
C     | SUBROUTINE SEAICE_ITD_REMAP_CHECK_BOUNDS
C     | o where doRemapping = .FALSE. print a warning
C     |
C     | Martin Losch, May 2014, Martin.Losch@awi.de
C     *===========================================================*
C \ev

C !USES: ===============================================================
      IMPLICIT NONE

#include "SIZE.h"
#include "EEPARAMS.h"
#include "SEAICE_SIZE.h"
#include "SEAICE_PARAMS.h"

C !INPUT PARAMETERS: ===================================================
C     === Routine arguments ===
C     bi, bj    :: outer loop counters
C     myTime    :: current time
C     myIter    :: iteration number
C     myThid    :: Thread no. that called this routine.
      _RL myTime
      INTEGER bi,bj
      INTEGER myIter
      INTEGER myThid
C     hActual :: ice thickness of current category
      _RL hActual   (1:sNx,1:sNy,1:nITD)
      _RL hActualPre(1:sNx,1:sNy,1:nITD)
C     hLimitNew :: new "advected" category boundaries after seaice_growth
      _RL hLimitNew (1:sNx,1:sNy,0:nITD)
C     AREAITD :: ice concentration of current category
      _RL AREAITD   (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nITD,nSx,nSy)
C     doRemapping :: mask where can be done, excludes points where
C                    new category limits are outside certain bounds
      LOGICAL doRemapping (1:sNx,1:sNy)

C !LOCAL VARIABLES: ====================================================
C     === Local variables ===
C     i,j,k     :: inner loop counters
C
      INTEGER i, j, k
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      CHARACTER*(39) tmpBuf
CEOP

       DO j=1,sNy
        DO i=1,sNx
         IF (.NOT.doRemapping(i,j) ) THEN
          DO k=1,nITD-1
           WRITE(tmpBuf,'(A,2I5,A,I10)')
     &          ' at (', i, j, ') in timestep ', myIter
           IF ( AREAITD(i,j,k,bi,bj).GT.SEAICE_area_reg .AND.
     &          hActual(i,j,k) .GE. hLimitNew(i,j,k) ) THEN
            WRITE(msgBuf,'(A,I3,A)')
     &           'SEAICE_ITD_REMAP: hActual(k) >= hLimitNew(k) '//
     &           'for category ', k, tmpBuf
            CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &           SQUEEZE_RIGHT, myThid )
CML            PRINT *, hActual(i,j,k),
CML     &           hLimitNew(i,j,k), hLimit(k)
           ENDIF
           IF ( AREAITD(i,j,k+1,bi,bj).GT.SEAICE_area_reg .AND.
     &          hActual(i,j,k+1) .LE. hLimitNew(i,j,k) ) THEN
            WRITE(msgBuf,'(A,I3,A)')
     &           'SEAICE_ITD_REMAP: hActual(k+1) <= hLimitNew(k) '//
     &           'for category ', k, tmpBuf
            CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &           SQUEEZE_RIGHT, myThid )
            PRINT '(8(1X,E10.4))',
     &           AREAITD(i,j,k+1,bi,bj), hActual(i,j,k+1),
     &           hActualPre(i,j,k+1),
     &           AREAITD(i,j,k,bi,bj), hActual(i,j,k),
     &           hActualPre(i,j,k),
     &           hLimitNew(i,j,k), hLimit(k)
           ENDIF
           IF ( hLimitNew(i,j,k) .GT. hLimit(k+1) ) THEN
            WRITE(msgBuf,'(A,I3,A)')
     &           'SEAICE_ITD_REMAP: hLimitNew(k) > hLimitNew(k+1) '//
     &           'for category ', k, tmpBuf
            CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &           SQUEEZE_RIGHT, myThid )
           ENDIF
           IF ( hLimitNew(i,j,k) .LT. hLimit(k-1) ) THEN
            WRITE(msgBuf,'(A,I3,A)')
     &           'SEAICE_ITD_REMAP: hLimitNew(k) < hLimitNew(k-1) '//
     &           'for category ', k, tmpBuf
            CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &           SQUEEZE_RIGHT, myThid )
           ENDIF
          ENDDO
         ENDIF
        ENDDO
       ENDDO

#endif /* SEAICE_ITD */

      RETURN
      END

#include "GAD_OPTIONS.h"
#ifdef ALLOW_AUTODIFF
# include "AUTODIFF_OPTIONS.h"
#endif

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C !ROUTINE: GAD_ADVECTION

C !INTERFACE: ==========================================================
      SUBROUTINE GAD_ADVECTION(
     I     implicitAdvection, advectionSchArg, vertAdvecSchArg,
     I     trIdentity, deltaTLev,
     I     uFld, vFld, wFld, tracer,
     O     gTracer,
     I     bi,bj, myTime,myIter,myThid)

C !DESCRIPTION:
C Calculates the tendency of a tracer due to advection.
C It uses the multi-dimensional method given in \ref{sect:multiDimAdvection}
C and can only be used for the non-linear advection schemes such as the
C direct-space-time method and flux-limiters.
C
C The algorithm is as follows:
C \begin{itemize}
C \item{$\theta^{(n+1/3)} = \theta^{(n)}
C      - \Delta t (\partial_x (u\theta^{(n)}) - \theta^{(n)} \partial_x u$)}
C \item{$\theta^{(n+2/3)} = \theta^{(n+1/3)}
C      - \Delta t (\partial_y (v\theta^{(n+1/3)}) - \theta^{(n)} \partial_y v$)}
C \item{$\theta^{(n+3/3)} = \theta^{(n+2/3)}
C      - \Delta t (\partial_r (w\theta^{(n+2/3)}) - \theta^{(n)} \partial_r w$)}
C \item{$G_\theta = ( \theta^{(n+3/3)} - \theta^{(n)} )/\Delta t$}
C \end{itemize}
C
C The tendency (output) is over-written by this routine.

C !USES: ===============================================================
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "GAD.h"
#ifdef ALLOW_AUTODIFF
# include "AUTODIFF_PARAMS.h"
# ifdef ALLOW_AUTODIFF_TAMC
#  include "tamc.h"
# endif
# ifdef ALLOW_PTRACERS
#  include "PTRACERS_SIZE.h"
# endif
#endif
#ifdef ALLOW_LAYERS
# include "LAYERS_P2SHARE.h"
#endif
#ifdef ALLOW_EXCH2
# include "W2_EXCH2_SIZE.h"
# include "W2_EXCH2_TOPOLOGY.h"
#endif /* ALLOW_EXCH2 */

C !INPUT PARAMETERS: ===================================================
C  implicitAdvection :: implicit vertical advection (later on)
C  advectionSchArg   :: advection scheme to use (Horizontal plane)
C  vertAdvecSchArg   :: advection scheme to use (vertical direction)
C  trIdentity        :: tracer identifier
C  uFld              :: Advection velocity field, zonal component
C  vFld              :: Advection velocity field, meridional component
C  wFld              :: Advection velocity field, vertical component
C  tracer            :: tracer field
C  bi,bj             :: tile indices
C  myTime            :: current time
C  myIter            :: iteration number
C  myThid            :: thread number
      LOGICAL implicitAdvection
      INTEGER advectionSchArg, vertAdvecSchArg
      INTEGER trIdentity
      _RL deltaTLev(Nr)
      _RL uFld  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL vFld  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL wFld  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL tracer(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      INTEGER bi,bj
      _RL myTime
      INTEGER myIter
      INTEGER myThid

C !OUTPUT PARAMETERS: ==================================================
C  gTracer           :: tendency array
      _RL gTracer(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)

#ifdef DISABLE_MULTIDIM_ADVECTION
      STOP 'GAD_ADVECTION is empty with DISABLE_MULTIDIM_ADVECTION'
#else /*  DISABLE_MULTIDIM_ADVECTION */
C !FUNCTIONS: ==========================================================
#ifdef ALLOW_DIAGNOSTICS
      CHARACTER*4 GAD_DIAG_SUFX
      EXTERNAL    GAD_DIAG_SUFX
      LOGICAL  DIAGNOSTICS_IS_ON
      EXTERNAL DIAGNOSTICS_IS_ON
#endif

C !LOCAL VARIABLES: ====================================================
C  maskUp        :: 2-D array for mask at W points
C  maskLocW      :: 2-D array for mask at West points
C  maskLocS      :: 2-D array for mask at South points
C [iMin,iMax]Upd :: loop range to update tracer field
C [jMin,jMax]Upd :: loop range to update tracer field
C  i,j,k         :: loop indices
C  kUp           :: index into 2 1/2D array, toggles between 1 and 2
C  kDown         :: index into 2 1/2D array, toggles between 2 and 1
C advectionScheme:: local copy of routine argument advectionSchArg
C vertAdvecScheme:: local copy of routine argument vertAdvecSchArg
C  xA,yA         :: areas of X and Y face of tracer cells
C  uTrans,vTrans :: 2-D arrays of volume transports at U,V points
C  rTrans        :: 2-D arrays of volume transports at W points
C  rTransKp      :: vertical volume transport at interface k+1
C  rTran3d       :: 3-D array of volume transport at W points
C  afr           :: 3-D array of vertical advective flux
C  af            :: 2-D array for horizontal advective flux
C  afx           :: 2-D array for horizontal advective flux, x direction
C  afy           :: 2-D array for horizontal advective flux, y direction
C  fVerT         :: 2 1/2D arrays for vertical advective flux
C  localTij      :: 2-D array, temporary local copy of tracer field
C  localT3d      :: 3-D array, temporary local copy of tracer field
C  kp1Msk        :: flag (0,1) for over-riding mask for W levels
C  calc_fluxes_X :: logical to indicate to calculate fluxes in X dir
C  calc_fluxes_Y :: logical to indicate to calculate fluxes in Y dir
C  interiorOnly  :: only update the interior of myTile, but not the edges
C  overlapOnly   :: only update the edges of myTile, but not the interior
C  npass         :: number of passes in multi-dimensional method
C  ipass         :: number of the current pass being made
C  myTile        :: variables used to determine which cube face
C  nCFace        :: owns a tile for cube grid runs using
C                :: multi-dim advection.
C [N,S,E,W]_edge :: true if N,S,E,W edge of myTile is an Edge of the cube
c     _RS maskUp  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RS maskLocW(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RS maskLocS(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER iMinUpd,iMaxUpd,jMinUpd,jMaxUpd
      INTEGER i,j,k,kUp,kDown
      INTEGER advectionScheme, vertAdvecScheme
      _RS xA      (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RS yA      (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL uTrans  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL vTrans  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL rTrans  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL rTransKp(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
#ifndef ALLOW_AUTODIFF
       LOGICAL usePPMvertAdv, usePQMvertAdv
      _RL rTran3d (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL afr     (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
#endif
      _RL af      (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL afx     (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL afy     (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL fVerT   (1-OLx:sNx+OLx,1-OLy:sNy+OLy,2)
      _RL localTij(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL localT3d(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
#ifdef GAD_MULTIDIM_COMPRESSIBLE
      _RL tmpTrac
      _RL localVol(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL locVol3d(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
#endif
      _RL kp1Msk
      LOGICAL calc_fluxes_X, calc_fluxes_Y, withSigns
      LOGICAL interiorOnly, overlapOnly
      INTEGER npass, ipass
      INTEGER nCFace
      LOGICAL N_edge, S_edge, E_edge, W_edge
#ifdef ALLOW_AUTODIFF_TAMC
C     msgBuf     :: Informational/error message buffer
C     dkey       :: tape key (direction dependent)
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      INTEGER dkey
# ifdef GAD_MULTIDIM_COMPRESSIBLE
C     ijkey      :: tape key (depends on indices i,j, and direction)
      INTEGER ijkey
# endif
#endif
#ifdef ALLOW_EXCH2
      INTEGER myTile
#endif
#ifdef ALLOW_DIAGNOSTICS
      CHARACTER*8 diagName
      CHARACTER*4 diagSufx
      LOGICAL     doDiagAdvX, doDiagAdvY, doDiagAdvR
#endif /* ALLOW_DIAGNOSTICS */
CEOP

C     make local copies to be tampered with if necessary
      advectionScheme = advectionSchArg
      vertAdvecScheme = vertAdvecSchArg
#ifdef ALLOW_AUTODIFF_TAMC
      IF ( inAdMode .AND. useApproxAdvectionInAdMode ) THEN
C     In AD-mode, we change non-linear, potentially unstable AD advection
C     schemes to linear schemes with more stability. So far only DST3 with
C     flux limiting is replaced by DST3 without flux limiting, but any
C     combination is possible.
       IF ( advectionSchArg.EQ.ENUM_DST3_FLUX_LIMIT )
     &      advectionScheme = ENUM_DST3
       IF ( vertAdvecSchArg.EQ.ENUM_DST3_FLUX_LIMIT )
     &      vertAdvecScheme = ENUM_DST3
C     here is room for more advection schemes as this becomes necessary
      ENDIF
#endif /* ALLOW_AUTODIFF_TAMC */

#ifdef ALLOW_DIAGNOSTICS
C--   Set diagnostics flags and suffix for the current tracer
      doDiagAdvX = .FALSE.
      doDiagAdvY = .FALSE.
      doDiagAdvR = .FALSE.
      IF ( useDiagnostics ) THEN
       diagSufx = GAD_DIAG_SUFX( trIdentity, myThid )
       diagName = 'ADVx'//diagSufx
       doDiagAdvX = DIAGNOSTICS_IS_ON( diagName, myThid )
       diagName = 'ADVy'//diagSufx
       doDiagAdvY = DIAGNOSTICS_IS_ON( diagName, myThid )
       diagName = 'ADVr'//diagSufx
       doDiagAdvR = DIAGNOSTICS_IS_ON( diagName, myThid )
      ENDIF
#endif /* ALLOW_DIAGNOSTICS */

C--   Set up work arrays with valid (i.e. not NaN) values
C     These inital values do not alter the numerical results. They
C     just ensure that all memory references are to valid floating
C     point numbers. This prevents spurious hardware signals due to
C     uninitialised but inert locations.
      DO j=1-OLy,sNy+OLy
       DO i=1-OLx,sNx+OLx
C-    xA,yA,vFld,uTrans,vTrans are set over the full domain
C      => no need for extra initialisation
c       xA(i,j)      = 0. _d 0
c       yA(i,j)      = 0. _d 0
c       uTrans(i,j)  = 0. _d 0
c       vTrans(i,j)  = 0. _d 0
C-    rTransKp is set over the full domain: no need for extra initialisation
c       rTransKp(i,j)= 0. _d 0
C-    rTrans and fVerT need to be initialised to zero:
        rTrans(i,j)  = 0. _d 0
        fVerT(i,j,1) = 0. _d 0
        fVerT(i,j,2) = 0. _d 0
#ifdef ALLOW_AUTODIFF
# ifdef GAD_MULTIDIM_COMPRESSIBLE
        localVol(i,j) = 0. _d 0
# endif
        localTij(i,j) = 0. _d 0
#endif /* ALLOW_AUTODIFF */
       ENDDO
      ENDDO

C--   Set tile-specific parameters for horizontal fluxes
      IF (useCubedSphereExchange) THEN
       npass  = 3
#ifdef ALLOW_EXCH2
       myTile = W2_myTileList(bi,bj)
       nCFace = exch2_myFace(myTile)
       N_edge = exch2_isNedge(myTile).EQ.1
       S_edge = exch2_isSedge(myTile).EQ.1
       E_edge = exch2_isEedge(myTile).EQ.1
       W_edge = exch2_isWedge(myTile).EQ.1
#else
       nCFace = bi
       N_edge = .TRUE.
       S_edge = .TRUE.
       E_edge = .TRUE.
       W_edge = .TRUE.
#endif
      ELSE
       npass  = 2
       nCFace = 0
       N_edge = .FALSE.
       S_edge = .FALSE.
       E_edge = .FALSE.
       W_edge = .FALSE.
      ENDIF

#ifdef ALLOW_AUTODIFF_TAMC
      IF ( npass.GT.maxcube ) THEN
        WRITE(msgBuf,'(A,2(I3,A))') 'S/R GAD_ADVECTION: npass =',
     &     npass, ' >', maxcube, ' = maxcube, ==> check "tamc.h"'
        CALL PRINT_ERROR( msgBuf, myThid )
        STOP 'ABNORMAL END: S/R GAD_ADVECTION'
      ENDIF
C     Define local tapes. Using local tapes makes it necessary to recompute
C     the forward routine (once) in AD-mode, but saves a lot of memory.
CADJ INIT loctape_gad_adv = COMMON, 1
CADJ INIT loctape_gad_adv_k = COMMON, Nr
CADJ INIT loctape_gad_adv_k_pass = COMMON, maxcube*Nr
# ifdef GAD_MULTIDIM_COMPRESSIBLE
CADJ INIT loctape_gad_adv_ijk_pass
CADJ &  = COMMON, maxcube*Nr*(sNx+2*OLx)*nSx*(sNy+2*OLy)*nSy
# endif
#endif
C--   Start of k loop for horizontal fluxes
      DO k=1,Nr

C--   Get temporary terms used by tendency routines
       DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
         xA(i,j) = _dyG(i,j,bi,bj)*deepFacC(k)
     &           *drF(k)*_hFacW(i,j,k,bi,bj)
         yA(i,j) = _dxG(i,j,bi,bj)*deepFacC(k)
     &           *drF(k)*_hFacS(i,j,k,bi,bj)
        ENDDO
       ENDDO
C--   Calculate "volume transports" through tracer cell faces.
C     anelastic: scaled by rhoFacC (~ mass transport)
       DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
         uTrans(i,j) = uFld(i,j,k)*xA(i,j)*rhoFacC(k)
         vTrans(i,j) = vFld(i,j,k)*yA(i,j)*rhoFacC(k)
        ENDDO
       ENDDO

C--   Make local copy of tracer array and mask West & South
       DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
         localTij(i,j) = tracer(i,j,k,bi,bj)
#ifdef GAD_MULTIDIM_COMPRESSIBLE
         localVol(i,j) = rA(i,j,bi,bj)*deepFac2C(k)
     &                  *rhoFacC(k)*drF(k)*hFacC(i,j,k,bi,bj)
     &                 + ( oneRS - maskC(i,j,k,bi,bj) )
#endif
#ifdef ALLOW_OBCS
         maskLocW(i,j) = _maskW(i,j,k,bi,bj)*maskInW(i,j,bi,bj)
         maskLocS(i,j) = _maskS(i,j,k,bi,bj)*maskInS(i,j,bi,bj)
#else /* ALLOW_OBCS */
         maskLocW(i,j) = _maskW(i,j,k,bi,bj)
         maskLocS(i,j) = _maskS(i,j,k,bi,bj)
#endif /* ALLOW_OBCS */
        ENDDO
       ENDDO

       IF (useCubedSphereExchange) THEN
        withSigns = .FALSE.
        CALL FILL_CS_CORNER_UV_RS(
     &            withSigns, maskLocW,maskLocS, bi,bj, myThid )
       ENDIF

C--   Multiple passes for different directions on different tiles
C--   For cube need one pass for each of red, green and blue axes.
       DO ipass=1,npass
#ifdef ALLOW_AUTODIFF_TAMC
        dkey = ipass + (k-1) * maxcube
#endif

        interiorOnly = .FALSE.
        overlapOnly  = .FALSE.
        IF (useCubedSphereExchange) THEN
C-    CubedSphere : pass 3 times, with partial update of local tracer field
         IF (ipass.EQ.1) THEN
          overlapOnly  = MOD(nCFace,3).EQ.0
          interiorOnly = MOD(nCFace,3).NE.0
          calc_fluxes_X = nCFace.EQ.6 .OR. nCFace.EQ.1 .OR. nCFace.EQ.2
          calc_fluxes_Y = nCFace.EQ.3 .OR. nCFace.EQ.4 .OR. nCFace.EQ.5
         ELSEIF (ipass.EQ.2) THEN
          overlapOnly  = MOD(nCFace,3).EQ.2
          interiorOnly = MOD(nCFace,3).EQ.1
          calc_fluxes_X = nCFace.EQ.2 .OR. nCFace.EQ.3 .OR. nCFace.EQ.4
          calc_fluxes_Y = nCFace.EQ.5 .OR. nCFace.EQ.6 .OR. nCFace.EQ.1
         ELSE
          interiorOnly = .TRUE.
          calc_fluxes_X = nCFace.EQ.5 .OR. nCFace.EQ.6
          calc_fluxes_Y = nCFace.EQ.2 .OR. nCFace.EQ.3
         ENDIF
        ELSE
C-    not CubedSphere
         calc_fluxes_X = MOD(ipass,2).EQ.1
         calc_fluxes_Y = .NOT.calc_fluxes_X
        ENDIF

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C--   X direction

#ifdef ALLOW_AUTODIFF
C-     Always reset advective flux in X
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          af(i,j) = 0.
         ENDDO
        ENDDO
#endif /* ALLOW_AUTODIFF */

        IF (calc_fluxes_X) THEN

C-     Do not compute fluxes if
C       a) needed in overlap only
C   and b) the overlap of myTile are not cube-face Edges
         IF ( .NOT.overlapOnly .OR. N_edge .OR. S_edge ) THEN

C-     Internal exchange for calculations in X
          IF ( overlapOnly ) THEN
           CALL FILL_CS_CORNER_TR_RL( 1, .FALSE.,
     &                                localTij, bi,bj, myThid )
          ENDIF

C-     Advective flux in X
#ifndef ALLOW_AUTODIFF
          DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
            af(i,j) = 0.
           ENDDO
          ENDDO
#else /* ALLOW_AUTODIFF */
# ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE localTij = loctape_gad_adv_k_pass, key = dkey, kind = isbyte
# endif
#endif /* ALLOW_AUTODIFF */

          IF ( advectionScheme.EQ.ENUM_UPWIND_1RST
     &         .OR. advectionScheme.EQ.ENUM_DST2 ) THEN
           CALL GAD_DST2U1_ADV_X(    bi,bj,k, advectionScheme, .TRUE.,
     I              deltaTLev(k),uTrans,uFld(1-OLx,1-OLy,k), localTij,
     O              af, myThid )
          ELSEIF ( advectionScheme.EQ.ENUM_FLUX_LIMIT ) THEN
           CALL GAD_FLUXLIMIT_ADV_X( bi,bj,k, .TRUE., deltaTLev(k),
     I              uTrans, uFld(1-OLx,1-OLy,k), maskLocW, localTij,
     O              af, myThid )
          ELSEIF ( advectionScheme.EQ.ENUM_DST3 ) THEN
           CALL GAD_DST3_ADV_X(      bi,bj,k, .TRUE., deltaTLev(k),
     I              uTrans, uFld(1-OLx,1-OLy,k), maskLocW, localTij,
     O              af, myThid )
          ELSEIF ( advectionScheme.EQ.ENUM_DST3_FLUX_LIMIT ) THEN
           CALL GAD_DST3FL_ADV_X(    bi,bj,k, .TRUE., deltaTLev(k),
     I              uTrans, uFld(1-OLx,1-OLy,k), maskLocW, localTij,
     O              af, myThid )
          ELSEIF ( advectionScheme.EQ.ENUM_OS7MP ) THEN
           CALL GAD_OS7MP_ADV_X(     bi,bj,k, .TRUE., deltaTLev(k),
     I              uTrans, uFld(1-OLx,1-OLy,k), maskLocW, localTij,
     O              af, myThid )
#ifndef ALLOW_AUTODIFF
          ELSEIF ( advectionScheme.EQ.ENUM_PPM_NULL_LIMIT  .OR.
     &             advectionScheme.EQ.ENUM_PPM_MONO_LIMIT  .OR.
     &             advectionScheme.EQ.ENUM_PPM_WENO_LIMIT ) THEN
           CALL GAD_PPM_ADV_X( advectionScheme, bi, bj, k , .TRUE.,
     I              deltaTLev(k), uFld(1-OLx,1-OLy,k), uTrans, localTij,
     O              af, myThid )
          ELSEIF ( advectionScheme.EQ.ENUM_PQM_NULL_LIMIT  .OR.
     &             advectionScheme.EQ.ENUM_PQM_MONO_LIMIT  .OR.
     &             advectionScheme.EQ.ENUM_PQM_WENO_LIMIT ) THEN
           CALL GAD_PQM_ADV_X( advectionScheme, bi, bj, k , .TRUE.,
     I              deltaTLev(k), uFld(1-OLx,1-OLy,k), uTrans, localTij,
     O              af, myThid )
#endif /* ndef ALLOW_AUTODIFF */
          ELSE
           STOP 'GAD_ADVECTION: adv. scheme incompatible with multi-dim'
          ENDIF

#ifdef ALLOW_OBCS
          IF ( useOBCS ) THEN
C-      replace advective flux with 1st order upwind scheme estimate
           CALL OBCS_U1_ADV_TRACER( .TRUE., trIdentity, bi, bj, k,
     I                              maskLocW, uTrans, localTij,
     U                              af, myThid )
          ENDIF
#endif /* ALLOW_OBCS */

C-     Internal exchange for next calculations in Y
          IF ( overlapOnly .AND. ipass.EQ.1 ) THEN
           CALL FILL_CS_CORNER_TR_RL( 2, .FALSE.,
     &                                localTij, bi,bj, myThid )
          ENDIF

C-     Advective flux in X : done
         ENDIF

#if ( defined ALLOW_AUTODIFF_TAMC && defined NONLIN_FRSURF )
CADJ STORE af = loctape_gad_adv_k_pass, key = dkey, kind = isbyte
#endif
C-     Update the local tracer field where needed:
C      use "maksInC" to prevent updating tracer field in OB regions

C      update in overlap-Only
         IF ( overlapOnly ) THEN
          iMinUpd = 1-OLx+1
          iMaxUpd = sNx+OLx-1
C- notes: these 2 lines below have no real effect (because recip_hFac=0
C         in corner region) but safer to keep them.
          IF ( W_edge ) iMinUpd = 1
          IF ( E_edge ) iMaxUpd = sNx

          IF ( S_edge ) THEN
#if defined ALLOW_AUTODIFF_TAMC && defined GAD_MULTIDIM_COMPRESSIBLE
CADJ STORE localTij = loctape_gad_adv_k_pass, key = dkey, kind = isbyte
#endif
           DO j=1-OLy,0
            DO i=iMinUpd,iMaxUpd
#ifdef GAD_MULTIDIM_COMPRESSIBLE
# ifdef ALLOW_AUTODIFF_TAMC
             ijkey = i + ((j-1) + (dkey-1)*(sNy+2*OLy))*(sNx+2*OLx)
CADJ STORE localVol(i,j) = loctape_gad_adv_ijk_pass, key=ijkey
CADJ &     , kind = isbyte
# endif
             tmpTrac = localTij(i,j)*localVol(i,j)
     &            -deltaTLev(k)*( af(i+1,j) - af(i,j) )
     &                         *maskInC(i,j,bi,bj)
             localVol(i,j) = localVol(i,j)
     &            -deltaTLev(k)*( uTrans(i+1,j) - uTrans(i,j) )
     &                         *maskInC(i,j,bi,bj)
             localTij(i,j) = tmpTrac/localVol(i,j)
#else /* GAD_MULTIDIM_COMPRESSIBLE */
             localTij(i,j) = localTij(i,j)
     &           -deltaTLev(k)*recip_rhoFacC(k)
     &            *_recip_hFacC(i,j,k,bi,bj)*recip_drF(k)
     &            *recip_rA(i,j,bi,bj)*recip_deepFac2C(k)
     &            *( af(i+1,j)-af(i,j)
     &              -tracer(i,j,k,bi,bj)*(uTrans(i+1,j)-uTrans(i,j))
     &             )*maskInC(i,j,bi,bj)
#endif /* GAD_MULTIDIM_COMPRESSIBLE */
            ENDDO
           ENDDO
          ENDIF
          IF ( N_edge ) THEN
#if defined ALLOW_AUTODIFF_TAMC && defined GAD_MULTIDIM_COMPRESSIBLE
CADJ STORE localTij = loctape_gad_adv_k_pass, key = dkey, kind = isbyte
#endif
           DO j=sNy+1,sNy+OLy
            DO i=iMinUpd,iMaxUpd
#ifdef GAD_MULTIDIM_COMPRESSIBLE
# ifdef ALLOW_AUTODIFF_TAMC
             ijkey = i + ((j-1) + (dkey-1)*(sNy+2*OLy))*(sNx+2*OLx)
CADJ STORE localVol(i,j) = loctape_gad_adv_ijk_pass, key=ijkey
CADJ &     , kind = isbyte
# endif
             tmpTrac = localTij(i,j)*localVol(i,j)
     &            -deltaTLev(k)*( af(i+1,j) - af(i,j) )
     &                         *maskInC(i,j,bi,bj)
             localVol(i,j) = localVol(i,j)
     &            -deltaTLev(k)*( uTrans(i+1,j) - uTrans(i,j) )
     &                         *maskInC(i,j,bi,bj)
             localTij(i,j) = tmpTrac/localVol(i,j)
#else /* GAD_MULTIDIM_COMPRESSIBLE */
             localTij(i,j) = localTij(i,j)
     &           -deltaTLev(k)*recip_rhoFacC(k)
     &            *_recip_hFacC(i,j,k,bi,bj)*recip_drF(k)
     &            *recip_rA(i,j,bi,bj)*recip_deepFac2C(k)
     &            *( af(i+1,j)-af(i,j)
     &              -tracer(i,j,k,bi,bj)*(uTrans(i+1,j)-uTrans(i,j))
     &             )*maskInC(i,j,bi,bj)
#endif /* GAD_MULTIDIM_COMPRESSIBLE */
            ENDDO
           ENDDO
          ENDIF

         ELSE
#if defined ALLOW_AUTODIFF_TAMC && defined GAD_MULTIDIM_COMPRESSIBLE
CADJ STORE localTij = loctape_gad_adv_k_pass, key = dkey, kind = isbyte
#endif
C      do not only update the overlap
          jMinUpd = 1-OLy
          jMaxUpd = sNy+OLy
          IF ( interiorOnly .AND. S_edge ) jMinUpd = 1
          IF ( interiorOnly .AND. N_edge ) jMaxUpd = sNy
          DO j=jMinUpd,jMaxUpd
           DO i=1-OLx+1,sNx+OLx-1
#ifdef GAD_MULTIDIM_COMPRESSIBLE
# ifdef ALLOW_AUTODIFF_TAMC
             ijkey = i + ((j-1) + (dkey-1)*(sNy+2*OLy))*(sNx+2*OLx)
CADJ STORE localVol(i,j) = loctape_gad_adv_ijk_pass, key=ijkey
CADJ &     , kind = isbyte
# endif
            tmpTrac = localTij(i,j)*localVol(i,j)
     &           -deltaTLev(k)*( af(i+1,j) - af(i,j) )
     &                        *maskInC(i,j,bi,bj)
            localVol(i,j) = localVol(i,j)
     &           -deltaTLev(k)*( uTrans(i+1,j) - uTrans(i,j) )
     &                        *maskInC(i,j,bi,bj)
            localTij(i,j) = tmpTrac/localVol(i,j)
#else /* GAD_MULTIDIM_COMPRESSIBLE */
            localTij(i,j) = localTij(i,j)
     &          -deltaTLev(k)*recip_rhoFacC(k)
     &           *_recip_hFacC(i,j,k,bi,bj)*recip_drF(k)
     &           *recip_rA(i,j,bi,bj)*recip_deepFac2C(k)
     &           *( af(i+1,j)-af(i,j)
     &             -tracer(i,j,k,bi,bj)*(uTrans(i+1,j)-uTrans(i,j))
     &            )*maskInC(i,j,bi,bj)
#endif /* GAD_MULTIDIM_COMPRESSIBLE */
           ENDDO
          ENDDO
C-      keep advective flux (for diagnostics)
          DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
            afx(i,j) = af(i,j)
           ENDDO
          ENDDO

C-     end if/else update overlap-Only
         ENDIF

C--   End of X direction
        ENDIF

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C--   Y direction

#ifdef ALLOW_AUTODIFF
C-     Always reset advective flux in Y
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          af(i,j) = 0.
         ENDDO
        ENDDO
#endif /* ALLOW_AUTODIFF */

        IF (calc_fluxes_Y) THEN

C-     Do not compute fluxes if
C       a) needed in overlap only
C   and b) the overlap of myTile are not cube-face edges
         IF ( .NOT.overlapOnly .OR. E_edge .OR. W_edge ) THEN

C-     Internal exchange for calculations in Y
          IF ( overlapOnly ) THEN
           CALL FILL_CS_CORNER_TR_RL( 2, .FALSE.,
     &                                localTij, bi,bj, myThid )
          ENDIF

C-     Advective flux in Y
#ifndef ALLOW_AUTODIFF
          DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
            af(i,j) = 0.
           ENDDO
          ENDDO
#else /* ALLOW_AUTODIFF */
# ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE localTij = loctape_gad_adv_k_pass, key = dkey, kind = isbyte
# endif
#endif /* ALLOW_AUTODIFF */

          IF ( advectionScheme.EQ.ENUM_UPWIND_1RST
     &         .OR. advectionScheme.EQ.ENUM_DST2 ) THEN
           CALL GAD_DST2U1_ADV_Y(    bi,bj,k, advectionScheme, .TRUE.,
     I              deltaTLev(k),vTrans,vFld(1-OLx,1-OLy,k), localTij,
     O              af, myThid )
          ELSEIF ( advectionScheme.EQ.ENUM_FLUX_LIMIT ) THEN
           CALL GAD_FLUXLIMIT_ADV_Y( bi,bj,k, .TRUE., deltaTLev(k),
     I              vTrans, vFld(1-OLx,1-OLy,k), maskLocS, localTij,
     O              af, myThid )
          ELSEIF ( advectionScheme.EQ.ENUM_DST3 ) THEN
           CALL GAD_DST3_ADV_Y(      bi,bj,k, .TRUE., deltaTLev(k),
     I              vTrans, vFld(1-OLx,1-OLy,k), maskLocS, localTij,
     O              af, myThid )
          ELSEIF ( advectionScheme.EQ.ENUM_DST3_FLUX_LIMIT ) THEN
           CALL GAD_DST3FL_ADV_Y(    bi,bj,k, .TRUE., deltaTLev(k),
     I              vTrans, vFld(1-OLx,1-OLy,k), maskLocS, localTij,
     O              af, myThid )
          ELSEIF ( advectionScheme.EQ.ENUM_OS7MP ) THEN
           CALL GAD_OS7MP_ADV_Y(     bi,bj,k, .TRUE., deltaTLev(k),
     I              vTrans, vFld(1-OLx,1-OLy,k), maskLocS, localTij,
     O              af, myThid )
#ifndef ALLOW_AUTODIFF
          ELSEIF ( advectionScheme.EQ.ENUM_PPM_NULL_LIMIT  .OR.
     &             advectionScheme.EQ.ENUM_PPM_MONO_LIMIT  .OR.
     &             advectionScheme.EQ.ENUM_PPM_WENO_LIMIT ) THEN
           CALL GAD_PPM_ADV_Y( advectionScheme, bi, bj, k , .TRUE.,
     I              deltaTLev(k), vFld(1-OLX,1-OLy,k), vTrans, localTij,
     O              af, myThid )
          ELSEIF ( advectionScheme.EQ.ENUM_PQM_NULL_LIMIT  .OR.
     &             advectionScheme.EQ.ENUM_PQM_MONO_LIMIT  .OR.
     &             advectionScheme.EQ.ENUM_PQM_WENO_LIMIT ) THEN
           CALL GAD_PQM_ADV_Y( advectionScheme, bi, bj, k , .TRUE.,
     I              deltaTLev(k), vFld(1-OLX,1-OLy,k), vTrans, localTij,
     O              af, myThid )
#endif /* ndef ALLOW_AUTODIFF */
          ELSE
           STOP 'GAD_ADVECTION: adv. scheme incompatible with mutli-dim'
          ENDIF

#ifdef ALLOW_OBCS
          IF ( useOBCS ) THEN
C-      replace advective flux with 1st order upwind scheme estimate
           CALL OBCS_U1_ADV_TRACER( .FALSE., trIdentity, bi, bj, k,
     I                              maskLocS, vTrans, localTij,
     U                              af, myThid )
          ENDIF
#endif /* ALLOW_OBCS */

C-     Internal exchange for next calculations in X
          IF ( overlapOnly .AND. ipass.EQ.1 ) THEN
           CALL FILL_CS_CORNER_TR_RL( 1, .FALSE.,
     &                                localTij, bi,bj, myThid )
          ENDIF

C-     Advective flux in Y : done
         ENDIF

#if ( defined ALLOW_AUTODIFF_TAMC && defined NONLIN_FRSURF )
CADJ STORE af = loctape_gad_adv_k_pass, key = dkey, kind = isbyte
#endif
C-     Update the local tracer field where needed:
C      use "maksInC" to prevent updating tracer field in OB regions

C      update in overlap-Only
         IF ( overlapOnly ) THEN
          jMinUpd = 1-OLy+1
          jMaxUpd = sNy+OLy-1
C- notes: these 2 lines below have no real effect (because recip_hFac=0
C         in corner region) but safer to keep them.
          IF ( S_edge ) jMinUpd = 1
          IF ( N_edge ) jMaxUpd = sNy

          IF ( W_edge ) THEN
#if defined ALLOW_AUTODIFF_TAMC && defined GAD_MULTIDIM_COMPRESSIBLE
CADJ STORE localTij = loctape_gad_adv_k_pass, key = dkey, kind = isbyte
#endif
           DO j=jMinUpd,jMaxUpd
            DO i=1-OLx,0
#ifdef GAD_MULTIDIM_COMPRESSIBLE
# ifdef ALLOW_AUTODIFF_TAMC
             ijkey = i + ((j-1) + (dkey-1)*(sNy+2*OLy))*(sNx+2*OLx)
CADJ STORE localVol(i,j) = loctape_gad_adv_ijk_pass, key = ijkey
CADJ &     , kind = isbyte
# endif
             tmpTrac = localTij(i,j)*localVol(i,j)
     &            -deltaTLev(k)*( af(i,j+1) - af(i,j) )
     &                         *maskInC(i,j,bi,bj)
             localVol(i,j) = localVol(i,j)
     &            -deltaTLev(k)*( vTrans(i,j+1) - vTrans(i,j) )
     &                         *maskInC(i,j,bi,bj)
             localTij(i,j) = tmpTrac/localVol(i,j)
#else /* GAD_MULTIDIM_COMPRESSIBLE */
             localTij(i,j) = localTij(i,j)
     &           -deltaTLev(k)*recip_rhoFacC(k)
     &            *_recip_hFacC(i,j,k,bi,bj)*recip_drF(k)
     &            *recip_rA(i,j,bi,bj)*recip_deepFac2C(k)
     &            *( af(i,j+1)-af(i,j)
     &              -tracer(i,j,k,bi,bj)*(vTrans(i,j+1)-vTrans(i,j))
     &             )*maskInC(i,j,bi,bj)
#endif /* GAD_MULTIDIM_COMPRESSIBLE */
            ENDDO
           ENDDO
          ENDIF
          IF ( E_edge ) THEN
#if defined ALLOW_AUTODIFF_TAMC && defined GAD_MULTIDIM_COMPRESSIBLE
CADJ STORE localTij = loctape_gad_adv_k_pass, key = dkey
CADJ &     , kind = isbyte
#endif
           DO j=jMinUpd,jMaxUpd
            DO i=sNx+1,sNx+OLx
#ifdef GAD_MULTIDIM_COMPRESSIBLE
# ifdef ALLOW_AUTODIFF_TAMC
             ijkey = i + ((j-1) + (dkey-1)*(sNy+2*OLy))*(sNx+2*OLx)
CADJ STORE localVol(i,j) = loctape_gad_adv_ijk_pass, key=ijkey
CADJ &     , kind = isbyte
# endif
             tmpTrac = localTij(i,j)*localVol(i,j)
     &            -deltaTLev(k)*( af(i,j+1) - af(i,j) )
     &                         *maskInC(i,j,bi,bj)
             localVol(i,j) = localVol(i,j)
     &            -deltaTLev(k)*( vTrans(i,j+1) - vTrans(i,j) )
     &                         *maskInC(i,j,bi,bj)
             localTij(i,j) = tmpTrac/localVol(i,j)
#else /* GAD_MULTIDIM_COMPRESSIBLE */
             localTij(i,j) = localTij(i,j)
     &           -deltaTLev(k)*recip_rhoFacC(k)
     &            *_recip_hFacC(i,j,k,bi,bj)*recip_drF(k)
     &            *recip_rA(i,j,bi,bj)*recip_deepFac2C(k)
     &            *( af(i,j+1)-af(i,j)
     &              -tracer(i,j,k,bi,bj)*(vTrans(i,j+1)-vTrans(i,j))
     &             )*maskInC(i,j,bi,bj)
#endif /* GAD_MULTIDIM_COMPRESSIBLE */
            ENDDO
           ENDDO
          ENDIF

         ELSE
#if defined ALLOW_AUTODIFF_TAMC && defined GAD_MULTIDIM_COMPRESSIBLE
CADJ STORE localTij = loctape_gad_adv_k_pass, key = dkey
CADJ &     , kind = isbyte
#endif
C      do not only update the overlap
          iMinUpd = 1-OLx
          iMaxUpd = sNx+OLx
          IF ( interiorOnly .AND. W_edge ) iMinUpd = 1
          IF ( interiorOnly .AND. E_edge ) iMaxUpd = sNx
          DO j=1-OLy+1,sNy+OLy-1
           DO i=iMinUpd,iMaxUpd
#ifdef GAD_MULTIDIM_COMPRESSIBLE
# ifdef ALLOW_AUTODIFF_TAMC
             ijkey = i + ((j-1) + (dkey-1)*(sNy+2*OLy))*(sNx+2*OLx)
CADJ STORE localVol(i,j) = loctape_gad_adv_ijk_pass, key=ijkey
CADJ &     , kind = isbyte
# endif
            tmpTrac = localTij(i,j)*localVol(i,j)
     &           -deltaTLev(k)*( af(i,j+1) - af(i,j) )
     &                        *maskInC(i,j,bi,bj)
            localVol(i,j) = localVol(i,j)
     &           -deltaTLev(k)*( vTrans(i,j+1) - vTrans(i,j) )
     &                        *maskInC(i,j,bi,bj)
            localTij(i,j) = tmpTrac/localVol(i,j)
#else /* GAD_MULTIDIM_COMPRESSIBLE */
            localTij(i,j) = localTij(i,j)
     &          -deltaTLev(k)*recip_rhoFacC(k)
     &           *_recip_hFacC(i,j,k,bi,bj)*recip_drF(k)
     &           *recip_rA(i,j,bi,bj)*recip_deepFac2C(k)
     &           *( af(i,j+1)-af(i,j)
     &             -tracer(i,j,k,bi,bj)*(vTrans(i,j+1)-vTrans(i,j))
     &            )*maskInC(i,j,bi,bj)
#endif /* GAD_MULTIDIM_COMPRESSIBLE */
           ENDDO
          ENDDO
C-      keep advective flux (for diagnostics)
          DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
            afy(i,j) = af(i,j)
           ENDDO
          ENDDO

C      end if/else update overlap-Only
         ENDIF

C--   End of Y direction
        ENDIF

C--   End of ipass loop
       ENDDO

       IF ( implicitAdvection ) THEN
C-    explicit advection is done ; store tendency in gTracer:
#ifdef GAD_MULTIDIM_COMPRESSIBLE
        STOP 'GAD_ADVECTION: missing code for implicitAdvection'
#endif /* GAD_MULTIDIM_COMPRESSIBLE */
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          gTracer(i,j,k) =
     &     ( localTij(i,j) - tracer(i,j,k,bi,bj) )/deltaTLev(k)
         ENDDO
        ENDDO
       ELSE
C-    horizontal advection done; store intermediate result in 3D array:
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
#ifdef GAD_MULTIDIM_COMPRESSIBLE
          locVol3d(i,j,k) = localVol(i,j)
#endif /* GAD_MULTIDIM_COMPRESSIBLE */
          localT3d(i,j,k) = localTij(i,j)
         ENDDO
        ENDDO
       ENDIF

#ifdef ALLOW_DIAGNOSTICS
       IF ( doDiagAdvX ) THEN
        diagName = 'ADVx'//diagSufx
        CALL DIAGNOSTICS_FILL( afx, diagName, k,1, 2,bi,bj, myThid )
       ENDIF
       IF ( doDiagAdvY ) THEN
        diagName = 'ADVy'//diagSufx
        CALL DIAGNOSTICS_FILL( afy, diagName, k,1, 2,bi,bj, myThid )
       ENDIF
#ifdef ALLOW_LAYERS
       IF ( layers_useThermo ) THEN
        CALL LAYERS_FILL(afx,trIdentity,'AFX',k,1,2,bi,bj,myThid)
        CALL LAYERS_FILL(afy,trIdentity,'AFY',k,1,2,bi,bj,myThid)
       ENDIF
#endif /* ALLOW_LAYERS */
#endif /* ALLOW_DIAGNOSTICS */

#ifdef ALLOW_DEBUG
       IF ( debugLevel .GE. debLevC
     &   .AND. trIdentity.EQ.GAD_TEMPERATURE
     &   .AND. k.LE.3 .AND. myIter.EQ.1+nIter0
     &   .AND. nPx.EQ.1 .AND. nPy.EQ.1
     &   .AND. useCubedSphereExchange ) THEN
        CALL DEBUG_CS_CORNER_UV( ' afx,afy from GAD_ADVECTION',
     &             afx,afy, k, standardMessageUnit,bi,bj,myThid )
       ENDIF
#endif /* ALLOW_DEBUG */

C--   End of K loop for horizontal fluxes
      ENDDO

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      IF ( .NOT.implicitAdvection ) THEN

#ifndef ALLOW_AUTODIFF
       usePPMvertAdv = vertAdvecScheme.EQ.ENUM_PPM_NULL_LIMIT
     &            .OR. vertAdvecScheme.EQ.ENUM_PPM_MONO_LIMIT
     &            .OR. vertAdvecScheme.EQ.ENUM_PPM_WENO_LIMIT
       usePQMvertAdv = vertAdvecScheme.EQ.ENUM_PQM_NULL_LIMIT
     &            .OR. vertAdvecScheme.EQ.ENUM_PQM_MONO_LIMIT
     &            .OR. vertAdvecScheme.EQ.ENUM_PQM_WENO_LIMIT
       IF ( usePPMvertAdv .OR. usePQMvertAdv ) THEN
C-- PPM-style or PQM-style vertical advection
        DO k=1,Nr
         IF (k.EQ.1) THEN
C-- vertical transport:  surface
          DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
            rTran3d(i,j,k) = 0. _d 0
           ENDDO
          ENDDO
         ELSE
C-- vertical transport: interior
          DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
            rTran3d(i,j,k) = wFld(i,j,k)*rA(i,j,bi,bj)
     &                      *deepFac2F(k)*rhoFacF(k)
     &                      *maskC(i,j,k-1,bi,bj)
           ENDDO
          ENDDO
         ENDIF
        ENDDO
        IF ( usePPMvertAdv ) THEN
C-- calc. PPM vertical flux data
         CALL GAD_PPM_ADV_R( vertAdvecScheme, bi, bj,
     I                deltaTLev, wFld, rTran3d, localT3d,
     O                afr, myThid )
        ENDIF
        IF ( usePQMvertAdv ) THEN
C-- calc. PQM vertical flux data
         CALL GAD_PQM_ADV_R( vertAdvecScheme, bi, bj,
     I                deltaTLev, wFld, rTran3d, localT3d,
     O                afr, myThid )
        ENDIF
C-- end PPM / PQM style vertical advection
       ENDIF
#endif /* ndef ALLOW_AUTODIFF */

#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE localT3d = loctape_gad_adv, key=1, kind = isbyte

# ifdef GAD_MULTIDIM_COMPRESSIBLE
CADJ STORE locVol3d = loctape_gad_adv, key=1, kind = isbyte
# endif /* GAD_MULTIDIM_COMPRESSIBLE */
#endif
#ifdef ALLOW_AUTODIFF
       DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
         fVerT(i,j,1) = 0.
         fVerT(i,j,2) = 0.
        ENDDO
       ENDDO
#endif

C--   Start of k loop for vertical flux
       DO k=Nr,1,-1
C--   kUp    Cycles through 1,2 to point to w-layer above
C--   kDown  Cycles through 2,1 to point to w-layer below
        kUp  = 1+MOD(k+1,2)
        kDown= 1+MOD(k,2)
        kp1Msk=1.
        IF (k.EQ.Nr) kp1Msk=0.

#ifdef ALLOW_AUTODIFF_TAMC
C     This directive suppresses a warning and hence makes a store
C     directive unnecessary. Before inserting this directive, the store
C     directive did not resolve a warning about a potential conflict due
C     to the incomplete variable rtrans.
CADJ INCOMPLETE rtrans
#endif

C-- Compute Vertical transport
#ifdef ALLOW_AIM
C- a hack to prevent Water-Vapor vert.transport into the stratospheric level Nr
        IF ( k.EQ.1 .OR.
     &     (useAIM .AND. trIdentity.EQ.GAD_SALINITY .AND. k.EQ.Nr)
     &              ) THEN
#else
        IF ( k.EQ.1 ) THEN
#endif

C- Surface interface :
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           rTransKp(i,j) = kp1Msk*rTrans(i,j)
           rTrans(i,j) = 0.
           fVerT(i,j,kUp) = 0.
          ENDDO
         ENDDO

        ELSE

C- Interior interface :
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           rTransKp(i,j) = kp1Msk*rTrans(i,j)
           rTrans(i,j) = wFld(i,j,k)*rA(i,j,bi,bj)
     &                 *deepFac2F(k)*rhoFacF(k)
     &                 *maskC(i,j,k-1,bi,bj)
           fVerT(i,j,kUp) = 0.
          ENDDO
         ENDDO

C-    Compute vertical advective flux in the interior:
         IF ( vertAdvecScheme.EQ.ENUM_UPWIND_1RST
     &      .OR. vertAdvecScheme.EQ.ENUM_DST2 ) THEN
          CALL GAD_DST2U1_ADV_R(    bi,bj,k, advectionScheme,
     I              deltaTLev(k),rTrans,wFld(1-OLx,1-OLy,k),localT3d,
     O              fVerT(1-OLx,1-OLy,kUp), myThid )
         ELSEIF ( vertAdvecScheme.EQ.ENUM_FLUX_LIMIT ) THEN
          CALL GAD_FLUXLIMIT_ADV_R( bi,bj,k, deltaTLev(k),
     I              rTrans, wFld(1-OLx,1-OLy,k), localT3d,
     O              fVerT(1-OLx,1-OLy,kUp), myThid )
         ELSEIF (vertAdvecScheme.EQ.ENUM_DST3) THEN
          CALL GAD_DST3_ADV_R(      bi,bj,k, deltaTLev(k),
     I              rTrans, wFld(1-OLx,1-OLy,k), localT3d,
     O              fVerT(1-OLx,1-OLy,kUp), myThid )
         ELSEIF ( vertAdvecScheme.EQ.ENUM_DST3_FLUX_LIMIT ) THEN
          CALL GAD_DST3FL_ADV_R(    bi,bj,k, deltaTLev(k),
     I              rTrans, wFld(1-OLx,1-OLy,k), localT3d,
     O              fVerT(1-OLx,1-OLy,kUp), myThid )
         ELSEIF ( vertAdvecScheme.EQ.ENUM_OS7MP ) THEN
          CALL GAD_OS7MP_ADV_R(     bi,bj,k, deltaTLev(k),
     I              rTrans, wFld(1-OLx,1-OLy,k), localT3d,
     O              fVerT(1-OLx,1-OLy,kUp), myThid )
#ifndef ALLOW_AUTODIFF
         ELSEIF ( usePPMvertAdv .OR. usePQMvertAdv ) THEN
C- copy level from 3d flux data
          DO j = 1-OLy,sNy+OLy
           DO i = 1-OLx,sNx+OLx
            fVerT(i,j,kUp) = afr(i,j,k)
           ENDDO
          ENDDO
#endif /* ndef ALLOW_AUTODIFF */
         ELSE
          STOP 'GAD_ADVECTION: adv. scheme incompatible with mutli-dim'
         ENDIF

C- end Surface/Interior if bloc
        ENDIF

#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE rtrans   = loctape_gad_adv_k, key = k, kind = isbyte
CADJ STORE rtransKp = loctape_gad_adv_k, key = k, kind = isbyte
# ifdef NONLIN_FRSURF
cph --- following storing of fVerT is critical for correct
cph --- gradient with multiDimAdvection
cph --- Without it, kDown component is not properly recomputed
cph --- This is a TAF bug (and no warning available)
CADJ STORE fVerT(:,:,:) = loctape_gad_adv_k, key = k, kind = isbyte
# endif
#endif

C--   Divergence of vertical fluxes
#ifdef GAD_MULTIDIM_COMPRESSIBLE
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          tmpTrac = localT3d(i,j,k)*locVol3d(i,j,k)
     &      -deltaTLev(k)*( fVerT(i,j,kDown)-fVerT(i,j,kUp) )
     &                   *rkSign*maskInC(i,j,bi,bj)
          localVol(i,j) = locVol3d(i,j,k)
     &      -deltaTLev(k)*( rTransKp(i,j) - rTrans(i,j) )
     &                   *rkSign*maskInC(i,j,bi,bj)
C- localTij only needed for Variance Bugget: can be move there
          localTij(i,j) = tmpTrac/localVol(i,j)
C--  without rescaling of tendencies:
c         gTracer(i,j,k) =
c    &     ( localTij(i,j) - tracer(i,j,k,bi,bj) )/deltaTLev(k)
C--  Non-Lin Free-Surf: consistent with rescaling of tendencies
C     (in FREESURF_RESCALE_G) and RealFreshFlux/addMass.
C    Also valid for linear Free-Surf (r & r* coords) w/wout RealFreshFlux
C     and consistent with linFSConserveTr and "surfExpan_" monitor.
          gTracer(i,j,k) =
     &          ( tmpTrac - tracer(i,j,k,bi,bj)*localVol(i,j) )
     &            *recip_rA(i,j,bi,bj)*recip_deepFac2C(k)
     &            *recip_drF(k)*_recip_hFacC(i,j,k,bi,bj)
     &            *recip_rhoFacC(k)
     &            /deltaTLev(k)
         ENDDO
        ENDDO
#else /* GAD_MULTIDIM_COMPRESSIBLE */
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          localTij(i,j) = localT3d(i,j,k)
     &      -deltaTLev(k)*recip_rhoFacC(k)
     &       *_recip_hFacC(i,j,k,bi,bj)*recip_drF(k)
     &       *recip_rA(i,j,bi,bj)*recip_deepFac2C(k)
     &       *( fVerT(i,j,kDown)-fVerT(i,j,kUp)
     &         -tracer(i,j,k,bi,bj)*(rTransKp(i,j)-rTrans(i,j))
     &        )*rkSign*maskInC(i,j,bi,bj)
          gTracer(i,j,k) =
     &     ( localTij(i,j) - tracer(i,j,k,bi,bj) )/deltaTLev(k)
         ENDDO
        ENDDO
#endif /* GAD_MULTIDIM_COMPRESSIBLE */

#ifdef ALLOW_DIAGNOSTICS
        IF ( doDiagAdvR ) THEN
         diagName = 'ADVr'//diagSufx
         CALL DIAGNOSTICS_FILL( fVerT(1-OLx,1-OLy,kUp),
     &                          diagName, k,1, 2,bi,bj, myThid )
        ENDIF
#ifdef ALLOW_LAYERS
        IF ( layers_useThermo ) THEN
         CALL LAYERS_FILL( fVerT(1-OLx,1-OLy,kUp), trIdentity,
     &                     'AFR', k, 1, 2,bi,bj, myThid)
        ENDIF
#endif /* ALLOW_LAYERS */
#endif /* ALLOW_DIAGNOSTICS */

C--   End of K loop for vertical flux
       ENDDO
C--   end of if not.implicitAdvection block
      ENDIF
#endif /* DISABLE_MULTIDIM_ADVECTION */

      RETURN
      END

#include "SALT_PLUME_OPTIONS.h"

CBOP
C     !ROUTINE: SALT_PLUME_VOLFRAC
C     !INTERFACE:
      SUBROUTINE SALT_PLUME_VOLFRAC(
     I                       bi, bj, myTime, myIter, myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE SALT_PLUME_VOLFRAC
C     | o Compute saltplume penetration.
C     *==========================================================*
C     | Compute fraction of volume flux associated with saltplume
C     | flux penetrating through the entire water columns due to
C     | rejected salt during freezing.
C     |
C     | For example, if surface value is Saltplume0,
C     | and each level gets equal fraction 1/5 down to SPDepth=5,
C     | SALT_PLUME_VOLFRAC will report
C     | dSPvolkLev2Above[2to1,3to2,4to3,5to4,6to5] = [4/5,3/5,2/5,1/5,  0]
C     | dSPvolSurf2kLev [1to1,1to2,1to3,1to4,1to5] = [1/5,1/5,1/5,1/5,1/5]
C     | sum [into5] = 1to5 + 6to5 - 5to4 = 1/5 +   0 - 1/5 = 0
C     |     [into4] = 1to4 + 5to4 - 4to3 = 1/5 + 1/5 - 2/5 = 0
C     |     [into3] = 1to3 + 4to3 - 3to2 = 1/5 + 2/5 - 3/5 = 0
C     |     [into2] = 1to2 + 3to2 - 2to1 = 1/5 + 3/5 - 4/5 = 0
C     |     [into1] = 1to1 + 2to1 - 1to[1,2,3,4,5] = 1/5 + 4/5 - 5/5 = 0
C     | NOTE: volume will always be conserved.
C     | =====
C     | Written by   : ATN (based on SALT_PLUME_FRAC)
C     | Date         : Apr 14, 2014
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "GRID.h"
#include "SALT_PLUME.h"
#include "EEPARAMS.h"
#include "PARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     input arguments
C     SPDpeth :: corresponding SaltPlumeDepth(i,j) at this grid point
C     myTime  :: Current time in simulation
C     myIter  :: Current iteration number in simulation
C     myThid  :: My Thread Id. number
      INTEGER bi,bj
      _RL     myTime
      INTEGER myIter
      INTEGER myThid
C     input/output arguments
C      CHARACTER*(MAX_LEN_MBUF) msgBuf
CEOP

#ifdef ALLOW_SALT_PLUME
#ifdef SALT_PLUME_VOLUME

C     !LOCAL VARIABLES:
      _RL     dMbdt        (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL     temp         (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL     dplumek
      INTEGER SPkBottom    (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER i,j,k,kp1,Nlev,Nrp1
      INTEGER imt
      parameter( imt=(sNx+2*OLx)*(sNy+2*OLy) )

C initialize at every time step
      Nrp1=Nr+1
      DO k=1,Nr
       DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
         dSPvolSurf2kLev(i,j,k,bi,bj)  = 0. _d 0
         dSPvolkLev2Above(i,j,k,bi,bj) = 0. _d 0
         SPplumek(i,j,k,bi,bj)         = 1. _d 0
        ENDDO
       ENDDO
      ENDDO
      DO j=1-OLy,sNy+OLy
       DO i=1-OLx,sNx+OLx
        SPplumek(i,j,Nrp1,bi,bj)         = 1. _d 0
        SPbrineVolFlux(i,j,bi,bj)        = 0. _d 0
        SPkBottom(i,j)                   = 0
       ENDDO
      ENDDO

C call salt_plume_frac to fill in SPplumek and SPkBottom
C use dMbdt+temp as a temporary arrays here to save memory:
      DO k = Nrp1,1,-1
       DO j=1-Oly,sNy+Oly
        DO i=1-Olx,sNx+Olx
         temp(i,j)=SaltPlumeDepth(i,j,bi,bj)
         dMbdt(i,j)=abs(rF(k))
        ENDDO
       ENDDO
       CALL SALT_PLUME_FRAC(
     I               imt,oneRS,temp,
#ifdef SALT_PLUME_SPLIT_BASIN
     I               XC(1-Olx,1-Oly,bi,bj),YC(1-Olx,1-Oly,bi,bj),
#endif
     U               dMbdt,
     I               myTime, 1, myThid )
       DO j=1-Oly,sNy+Oly
        DO i=1-Olx,sNx+Olx
         SPplumek(i,j,k,bi,bj)=dMbdt(i,j)
         IF(SPplumek(i,j,k,bi,bj).GT. 0.9999999) THEN
          SPkBottom(i,j)=k
         ENDIF
        ENDDO
       ENDDO
      ENDDO

C reinitialize dMbdt = 0
      DO j=1-Oly,sNy+Oly
       DO i=1-Olx,sNx+Olx
        dMbdt(i,j)=0. _d 0
       ENDDO
      ENDDO

C Now calculating dplumek, dSPvolumeUp, dSPvolSurf2kLev
C units:
C Sbrine=dsb/dt*dt/(rhoConst*SPalpha*drF)[g/m2/s*s/(kg/m3*m)]=[g/kg]
C SPplumek : fraction : unitless
C SaltPlumeFlux: dsb/dt [g/kg.kg/m^2/s = g/m^2/s]
C brine_mass_flux dMb/dt = dsb/dt / Sbrine [kg/m2/s]
C                        = dsb/dt / (dsb/dt*dt/(rhoConst*SPalpha*drF))
C                        = rhoConst*SPalpha*drF/dt [kg/m3 m/s]=[kg/m2/s]
C dVbrine/dt = dMb/dt 1/rhoConst [m/s]

C has 2 ways to define brine properties: either provide
C (A) SPalpha: vol frac or (B) SPbrineSalt: brine salinity.
C (A) SPalpha:  can calc SPbrineSalt as fxn of dhice/dt,
C     constrained by SPbrineSaltmax:
C     SPbrineSalt=SaltPlumeFlux/rhoConst/SPalpha/drF(1)*dt
C     SPbrineSalt=min(SPbrineSalt,SPbrineSaltmax)
C     dMbdt = saltPlumeFlux / SPbrineSalt
C           = rhoConst*SPalpha*drF(1)/dt <-- a function of SPalpha
C (B) SPbrinesalt provided
C     dMbdt = saltPlumeFlux / SPbrineSalt <-- fxn of SPbrineSalt

C Assuming we go with (B) here:
      DO j=1-OLy,sNy+OLy
       DO i=1-OLx,sNx+OLx
C brine mass and volume at surface:
        dMbdt(i,j)=saltPlumeFlux(i,j,bi,bj)/SPbrineSconst
        SPbrineVolFlux(i,j,bi,bj)=dMbdt(i,j)*mass2rUnit
       ENDDO
      ENDDO

C Distributing down: this is always from level 1 to depth
      DO k=Nr,1,-1
       DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
         dplumek=SPplumek(i,j,k+1,bi,bj)-SPplumek(i,j,k,bi,bj)
         dSPvolSurf2kLev(i,j,k,bi,bj)=dplumek*SPbrineVolFlux(i,j,bi,bj)
        ENDDO
       ENDDO
      ENDDO

C Now volume up: need to scan from bottom of SPDepth
      DO j=1-OLy,sNy+OLy
       DO i=1-OLx,sNx+OLx
        Nlev=SPkBottom(i,j)
        IF(Nlev.GE.1 .AND. Nlev.LE.Nr) THEN
         DO k=Nlev,1,-1
          kp1=k+1
          dSPvolkLev2Above(i,j,k,bi,bj)=dSPvolkLev2Above(i,j,kp1,bi,bj)
     &                                  - dSPvolSurf2kLev(i,j,k,bi,bj)
         ENDDO
        ENDIF
       ENDDO
      ENDDO

#ifdef ALLOW_DIAGNOSTICS
      IF ( useDiagnostics ) THEN
       CALL DIAGNOSTICS_FILL(
     &      SPplumek,'PLUMEKB1',0,Nr,1,bi,bj,myThid )
      ENDIF
#endif /* ALLOW_DIAGNOSTICS */

#endif /* SALT_PLUME_VOLUME */
#endif /* ALLOW_SALT_PLUME */

      RETURN
      END

#include "CPP_EEOPTIONS.h"
#include "PACKAGES_CONFIG.h"

CBOP
C     !ROUTINE: INI_THREADING_ENVIRONMENT

C     !INTERFACE:
      SUBROUTINE INI_THREADING_ENVIRONMENT

C     !DESCRIPTION:
C     *==========================================================*
C     | SUBROUTINE INI\_THREADING\_ENVIRONMENT
C     | o Initialise multi-threaded environment.
C     *==========================================================*
C     | Generally we do not start separate threads here.
C     | The separate threads a spawned at later on.
C     | Here we perform initialisation of data-structures
C     | that indicate which of the nSx x nSy tiles a thread is
C     | responsible for.
C     | The multiple threads are spawned in the top level MAIN
C     | routine.
C     *==========================================================*

C     !USES:
      IMPLICIT NONE
C     == Global data ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "EESUPPORT.h"

C     !LOCAL VARIABLES:
C     == Local variables ==
C     bXPerThread - Blocks of size sNx per thread.
C     byPerThread - Blocks of size sNy per thread.
C     thId        - Thread index. Temporary used in loops
C                   which set per. thread values on a
C                   cartesian grid.
C     bxLo, bxHi  - Work vars. for thread index
C     byLo, byHi    range. bxLo is the lowest i index
C                   that a thread covers, bxHi is the
C                   highest i index. byLo is the lowest
C                   j index, byHi is the highest j index.
C     I, J        - Loop counter
C     msgBuf      - I/O buffer for reporting status information.
C     myThid      - Dummy thread id for use in printed messages
C                   ( this routine "INI_THREADING_ENVIRONMENT" is
C                     called before multi-threading has started.)
      INTEGER bxPerThread
      INTEGER byPerThread
      INTEGER thId
      INTEGER bxLo, bxHi
      INTEGER byLo, byHi
      INTEGER I, J
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      INTEGER myThid
#ifndef ALLOW_EXCH2
      LOGICAL flag
#endif
CEOP

C--   Set default for all threads of having no blocks to
C--   work on - except for thread 1.
      myBxLo(1) = 1
      myBxHi(1) = nSx
      myByLo(1) = 1
      myByHi(1) = nSy
      DO I = 2, MAX_NO_THREADS
       myBxLo(I) = 0
       myBxHi(I) = 0
       myByLo(I) = 0
       myByHi(I) = 0
      ENDDO
      myThid = 1
      commName(COMM_NONE) = 'none'
      commName(COMM_MSG ) = 'messages'
      commName(COMM_PUT ) = 'put'
      commName(COMM_GET ) = 'get'

C--   If there are multiple threads allocate different range of the
C--   nSx*nSy blocks to each thread.
C     For now handle simple case of no. blocks nSx = n*nTx and
C     no. blocks nSy = m*nTy ( where m and n are integer ). This
C     is handled by simply mapping threads to blocks in sequence
C     with the x thread index moving fastest.
C     Later code which sets the thread number of neighboring blocks
C     needs to be consistent with the code here.
      nThreads = nTx * nTy
      IF   ( nThreads .GT. MAX_NO_THREADS ) THEN
       WRITE(msgBuf,'(2A,2I6)')
     &  'S/R INI_THREADING_ENVIRONMENT:',
     &  ' Total number of threads exceeds MAX_NO_THREADS',
     &   nTx*nTy, MAX_NO_THREADS
       CALL PRINT_ERROR(msgBuf, myThid)
       WRITE(msgBuf,'(2A)')
     &    ' Needs to increase MAX_NO_THREADS',
     &    ' in file "EEPARAMS.h" and to re-compile'
       CALL PRINT_ERROR(msgBuf, myThid)
       eeBootError = .TRUE.
       STOP 'ABNORMAL END: S/R INI_THREADING_ENVIRONMENT'
      ENDIF

C--   Initialise the barrier mechanisms
C     BAR2 will eventually replace barrier everywhere.
      CALL BARRIER_INIT
      DO I=1, MAX_NO_THREADS
       CALL BAR2_INIT(I)
      ENDDO

C--   Initialise exchange mechanism
      CALL EXCH_INIT

      IF   ( nThreads .NE. nTx*nTy ) THEN
       WRITE(msgBuf,'(A,A,A,I5,A,I5)')
     &  'S/R INI_THREADING_ENVIRONMENT:',
     &  ' Total number of threads is not the same as nTx*nTy.',
     &  ' nTx * nTy = ',nTx*nTy,' nThreads = ',nThreads
       CALL PRINT_ERROR(msgBuf, myThid)
       eeBootError = .TRUE.
       STOP 'ABNORMAL END: S/R INI_THREADING_ENVIRONMENT'
      ENDIF
      bxPerThread = nSx/nTx
      IF ( bxPerThread*nTx .NE. nSx ) THEN
       WRITE(msgBuf,'(A,A,A)')
     &  'S/R INI_THREADING_ENVIRONMENT:',
     &  ' Number of blocks in X (nSx)',
     &  ' must be exact multiple of threads in X (nTx).'
       CALL PRINT_ERROR(msgBuf, myThid)
       eeBootError = .TRUE.
       STOP 'ABNORMAL END: S/R INI_THREADING_ENVIRONMENT'
      ENDIF
      byPerThread = nSy/nTy
      IF ( byPerThread*nTy .NE. nSy ) THEN
       WRITE(msgBuf,'(A,A,A)')
     &  'S/R INI_THREADING_ENVIRONMENT:',
     &  ' Number of blocks in Y (nSy)',
     &  ' must be exact multiple of threads in Y (nTy).'
       CALL PRINT_ERROR(msgBuf, myThid)
       eeBootError = .TRUE.
       STOP 'ABNORMAL END: S/R INI_THREADING_ENVIRONMENT'
      ENDIF
      IF ( .NOT. eeBootError ) THEN
       byLo = 1
       DO J=1,nTy
        byHi = byLo+byPerThread-1
        bxLo = 1
        DO I=1,nTx
         thId = (J-1)*nTx+I
         bxHi = bxLo+bxPerThread-1
         myBxLo(thId) = bxLo
         myBxHi(thId) = bxHi
         myByLo(thId) = byLo
         myByHi(thId) = byHi
         bxLo = bxHi+1
        ENDDO
        byLo = byHi+1
       ENDDO
      ENDIF

      DO thId=1,nThreads
       CALL INI_COMMUNICATION_PATTERNS( thId )
      ENDDO

C--   Print mapping of threads to grid points.
      WRITE(msgBuf,'(A)')
     &'// ======================================================'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &  SQUEEZE_RIGHT , 1)
      WRITE(msgBuf,'(A)') '// Mapping of tiles to threads'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &  SQUEEZE_RIGHT , 1)
C     o Write list of tiles each thread is responsible for
      WRITE(msgBuf,'(A)')
     &'// ======================================================'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &  SQUEEZE_RIGHT , 1)
      DO I=1,nThreads
       WRITE(msgBuf,'(A,I4,A,4(I4,A1))')
     & '// -o- Thread',I,', tiles (',
     & myBxLo(I),':',myBxHi(I),',',myByLo(I),':',myByHi(I),')'
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,SQUEEZE_BOTH , 1)
      ENDDO
      WRITE(msgBuf,'(A)')  ' '
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,SQUEEZE_RIGHT , 1)

#ifndef ALLOW_EXCH2
C     o For each tile print its communication method(s)
      WRITE(msgBuf,'(A)')
     &'// ======================================================'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &  SQUEEZE_RIGHT , 1)
      WRITE(msgBuf,'(A)') '// Tile <-> Tile connectvity table'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &  SQUEEZE_RIGHT , 1)
      WRITE(msgBuf,'(A)')
     &'// ======================================================'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &  SQUEEZE_RIGHT , 1)
      DO J=1,nSy
       DO I=1,nSx
        WRITE(msgBuf,'(A,A,I6.6,A,I6.6,A)')
     &   '//',' Tile number: ',tileNo(I,J),
     &   ' (process no. = ',myPid,')'
        CALL PRINT_MESSAGE(msgBuf,standardMessageUnit,SQUEEZE_RIGHT , 1)
C       o West communication details
        IF ( tileNoW(I,J).NE. NULL_TILE ) THEN
         WRITE(msgBuf,'(A,A,I6.6,A,I6.6,A,A)')
     &   '//        WEST: ',
     &   'Tile = ',tileNoW(I,J),
     &   ', Process = ',tilePidW(I,J),
     &   ', Comm = ',commName(tileCommModeW(I,J))
         CALL PRINT_MESSAGE(msgBuf,standardMessageUnit,SQUEEZE_RIGHT, 1)
         WRITE(msgBuf,'(A,A,I6.6,A,I6.6)')
     &   '//              ',
     &   '  bi = ',tileBiW(I,J),
     &   ', bj = ',tileBjW(I,J)
         CALL PRINT_MESSAGE(msgBuf,standardMessageUnit,SQUEEZE_RIGHT, 1)
        ELSE
         WRITE(msgBuf,'(A)')
     &   '//         WEST: no neighbor'
         CALL PRINT_MESSAGE(msgBuf,standardMessageUnit,SQUEEZE_RIGHT, 1)
        ENDIF
C       o East communication details
        IF ( tileNoE(I,J).NE. NULL_TILE ) THEN
         WRITE(msgBuf,'(A,A,I6.6,A,I6.6,A,A)')
     &   '//        EAST: ',
     &   'Tile = ',tileNoE(I,J),
     &   ', Process = ',tilePidE(I,J),
     &   ', Comm = ',commName(tileCommModeE(I,J))
         CALL PRINT_MESSAGE(msgBuf,standardMessageUnit,SQUEEZE_RIGHT, 1)
         WRITE(msgBuf,'(A,A,I6.6,A,I6.6)')
     &   '//              ',
     &   '  bi = ',tileBiE(I,J),
     &   ', bj = ',tileBjE(I,J)
         CALL PRINT_MESSAGE(msgBuf,standardMessageUnit,SQUEEZE_RIGHT, 1)
        ELSE
         WRITE(msgBuf,'(A)')
     &   '//         EAST: no neighbor'
         CALL PRINT_MESSAGE(msgBuf,standardMessageUnit,SQUEEZE_RIGHT, 1)
        ENDIF
C       o South communication method
        IF ( tileNoS(I,J).NE. NULL_TILE ) THEN
         WRITE(msgBuf,'(A,A,I6.6,A,I6.6,A,A)')
     &   '//       SOUTH: ',
     &   'Tile = ',tileNoS(I,J),
     &   ', Process = ',tilePidS(I,J),
     &   ', Comm = ',commName(tileCommModeS(I,J))
         CALL PRINT_MESSAGE(msgBuf,standardMessageUnit,SQUEEZE_RIGHT, 1)
         WRITE(msgBuf,'(A,A,I6.6,A,I6.6)')
     &   '//              ',
     &   '  bi = ',tileBiS(I,J),
     &   ', bj = ',tileBjS(I,J)
         CALL PRINT_MESSAGE(msgBuf,standardMessageUnit,SQUEEZE_RIGHT, 1)
        ELSE
         WRITE(msgBuf,'(A)')
     &   '//        SOUTH: no neighbor'
         CALL PRINT_MESSAGE(msgBuf,standardMessageUnit,SQUEEZE_RIGHT, 1)
        ENDIF
C       o North communication method
        IF ( tileNoN(I,J).NE. NULL_TILE ) THEN
         WRITE(msgBuf,'(A,A,I6.6,A,I6.6,A,A)')
     &   '//       NORTH: ',
     &   'Tile = ',tileNoN(I,J),
     &   ', Process = ',tilePidN(I,J),
     &   ', Comm = ',commName(tileCommModeN(I,J))
         CALL PRINT_MESSAGE(msgBuf,standardMessageUnit,SQUEEZE_RIGHT, 1)
         WRITE(msgBuf,'(A,A,I6.6,A,I6.6)')
     &   '//              ',
     &   '  bi = ',tileBiN(I,J),
     &   ', bj = ',tileBjN(I,J)
         CALL PRINT_MESSAGE(msgBuf,standardMessageUnit,SQUEEZE_RIGHT, 1)
        ELSE
         WRITE(msgBuf,'(A)')
     &   '//        NORTH: no neighbor'
         CALL PRINT_MESSAGE(msgBuf,standardMessageUnit,SQUEEZE_RIGHT, 1)
        ENDIF
       ENDDO
      ENDDO
      WRITE(msgBuf,'(A)')  ' '
      CALL PRINT_MESSAGE( msgBuf,standardMessageUnit,SQUEEZE_RIGHT, 1)
#endif /* ndef ALLOW_EXCH2 */

C--   Check EXCH-1 options
#ifndef ALLOW_EXCH2
      IF ( usingMPI .AND. useCubedSphereExchange ) THEN
C-    not working with multi-procs (checked within EXCH1-CUBE S/R) and
C-    if compiled with MPI (without EXCH2) safer to set usingMPI to False.
        WRITE(msgBuf,'(2A)') 'EXCH-1 useCubedSphereExchange',
     &                       ' unsafe with usingMPI=True'
        CALL PRINT_ERROR( msgBuf, myThid )
        STOP 'ABNORMAL END: S/R INI_THREADING_ENVIRONMENT'
      ENDIF
      IF ( nThreads.GT.1 .AND. useCubedSphereExchange ) THEN
C-    multi-threads not working for local arrays; could remove the stop if
C     we are sure that only shared array (=in common blocks) are exchanged.
        WRITE(msgBuf,'(2A)') 'EXCH-1 useCubedSphereExchange',
     &                       ' unsafe with multi-threads'
        CALL PRINT_ERROR( msgBuf, myThid )
        STOP 'ABNORMAL END: S/R INI_THREADING_ENVIRONMENT'
      ENDIF
      IF ( nThreads.GT.1 ) THEN
       flag = .FALSE.
       DO J=1,nSy
        DO I=1,nSx
          flag = flag
     &       .OR. tileCommModeW(I,J).EQ.COMM_GET
     &       .OR. tileCommModeE(I,J).EQ.COMM_GET
     &       .OR. tileCommModeS(I,J).EQ.COMM_GET
     &       .OR. tileCommModeN(I,J).EQ.COMM_GET
        ENDDO
       ENDDO
       IF ( flag ) THEN
C-    multi-threads not working for local arrays; not safe neither for shared arrays
        WRITE(msgBuf,'(3A)') 'EXCH-1 using Comm = ',
     &   commName(COMM_GET), ' unsafe with multi-threads'
        CALL PRINT_ERROR( msgBuf, myThid )
        STOP 'ABNORMAL END: S/R INI_THREADING_ENVIRONMENT'
       ENDIF
      ENDIF
#endif /* ndef ALLOW_EXCH2 */

      RETURN
      END

      subroutine hessupd( nn, mupd, dd, jmin, jmax, xdiff, lphprint )

c     ==================================================================
c     SUBROUTINE hessupd
c     ==================================================================
c
c     o controls update of descent vector using available
c       approximation of Hessian Matrix based on gradients of
c       previous iterations
c
c     o Reference: J.C. Gilbert & C. Lemarechal
c                  Some numerical experiments with variable-storage
c                  quasi-Newton algorithms
c                  Mathematical Programming 45 (1989), pp. 407-435
c
c     o started: ??? not reproducible
c
c     o changed: Patrick Heimbach, MIT/EAPS
c                24-Feb-2000: 
c                   - changed some variable names to be consistent
c                     with routine lsoptv, lsline;
c
c     o Version: 2.1.0, 02-Mar-2000: Patrick Heimbach, MIT/EAPS
c
c     ==================================================================
c     SUBROUTINE hessupd
c     ==================================================================

      implicit none

#include "blas1.h"

c------------------------------------
c declare arguments
c------------------------------------
      integer nn, mupd, jmin, jmax
      double precision dd(nn), alpha(100), xdiff(nn)
      logical lphprint

c------------------------------------
c declare local variables
c------------------------------------
      external DDOT
      double precision     DDOT

      integer jfin, i, j, jp
      double precision    r

c------------------------------------
c initialization
c------------------------------------
      jfin = jmax

      if (lphprint) 
     &     print *, 'pathei-lsopt: in hessupd; ', 
     &     'jmin, jmax, mupd:', jmin, jmax, mupd

      if (jfin.lt.jmin) jfin = jmax+mupd

c------------------------------------
c compute right hand side
c------------------------------------
      do j = jfin,jmin,-1

         if (lphprint) 
     &        print *, 'pathei-lsopt: in hessupd; loop ',
     &        'j,jfin,jmin = ', j,jfin,jmin

         jp = j
         if (jp.gt.mupd) jp = jp-mupd
         call dostore( nn, xdiff, .false., 2*jp+3 )
         r = DDOT( nn, dd, 1, xdiff,1 )
         call dostore( nn, xdiff, .false., 2*jp+2 )
         alpha(jp) = r
         do i = 1, nn
            dd(i) = dd(i) - r*xdiff(i)
         end do
      end do

c------------------------------------
c multiply precondition matrix
c------------------------------------
      if (mupd .ne. 0) then
         call dostore( nn, xdiff, .false., 3 )
         do i = 1, nn
            dd(i) = dd(i)*xdiff(i)
         end do
      end if

c------------------------------------
c compute left hand side
c------------------------------------
      do j = jmin,jfin
         jp = j
         if (jp .gt. mupd) jp = jp-mupd
         call dostore( nn, xdiff, .false., 2*jp+2 )
         r = alpha(jp) - DDOT( nn, dd,1 , xdiff, 1 )
         call dostore( nn, xdiff, .false., 2*jp+3 )
         do i = 1, nn
            dd(i) = dd(i) + r*xdiff(i)
         end do
      end do

      return

      end

#include "FIZHI_OPTIONS.h"
      subroutine slprs (PHIS,PLE,THZ,lwmask,im,jm,lm,SLP)
C**********************************************************************
C  INPUT
C    PHIS .... SURFACE GEOPOTENTIAL (M2/S2)
C    THZ ..... POTENTIAL TEMPERATURE (K) ON  Model LEVELS
C    grid .... Dynamics Grid Structure
C    lwmask .. Land:(0.0) Water:(1.0) Mask
C
C  OUTPUT
C    SLP ..... SEA LEVEL PRESSURE (MB)
C
C NOTE: Level counting here for thz and ple is top down (thz(1) is top)
C***********************************************************************

      implicit none

      integer im,jm,lm
      _RL  SLP   (im*jm)
      _RL  PHIS  (im*jm),  THZ  (im*jm,lm)
      _RL  lwmask(im*jm)
      _RL  ple(im*jm,lm+1)

      _RL TWO, BETA
      PARAMETER(TWO  = 2.0)
      PARAMETER(BETA = 0.0065)

      _RL  getcon,g,r,ak
      integer i,L
      _RL  tm (im*jm)
      integer Ltop (im*jm)

      G  = GETCON('GRAVITY')
      R  = GETCON('RGAS')
      AK = GETCON('KAPPA')
C***********************************************************************
C*                COMPUTE MEAN THETA IN PBL (100 MB)                   *
C***********************************************************************

      do i=1,im*jm
      tm(i) = 0.0
      Ltop(i) = lm
      enddo

      do L = lm,1,-1
       do i=1,im*jm
        if ( ple(i,L+1).ge.(ple(i,lm+1)-100.) ) then
         Ltop(i) = L
         tm(i) = tm(i) + thz(i,L)*(ple(i,L+1)-ple(i,L))
        endif
       enddo
      enddo

      do i=1,im*jm
      tm(i) = tm(i)/(ple(i,lm+1)-ple(i,Ltop(i)))
      enddo

C***********************************************************************
C*                   COMPUTE SEA LEVEL PRESSURE                        *
C***********************************************************************

      do i=1,im*jm
      if( lwmask(i).ne.0.0 ) then
      TM(I) = TM(I) * (PLE(I,LM+1)/1000.)**AK + BETA*PHIS(I)/(TWO*G)
      else
      TM(I) = THZ(I,LM)*(PLE(I,LM+1)/1000.)**AK + BETA*PHIS(I)/(TWO*G)
      endif

      SLP(I) = PHIS(I) / ( R*TM(I) )
      SLP(I) = PLE(I,LM+1) * EXP( SLP(I) )
      enddo

      RETURN
      END

#include "ATM_CPL_OPTIONS.h"

CBOP
C     !ROUTINE: CPL_EXPORT_IMPORT_DATA
C     !INTERFACE:
      SUBROUTINE CPL_EXPORT_IMPORT_DATA(
     I                      myTime, myIter, myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE CPL_EXPORT_IMPORT_DATA
C     | o Routine for controlling
C     |   - export of coupling data to coupler layer AND
C     |   - import of coupling data from coupler layer.
C     *==========================================================*
C     | This version talks to the MIT Coupler. It uses the MIT
C     | Coupler "checkpoint1" library calls.
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "CPL_PARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     myTime  :: Current time in simulation.
C     myIter  :: Current timestep number.
C     myThid  :: Thread number for this instance of the routine.
      _RL     myTime
      INTEGER myIter
      INTEGER myThid
CEOP

#ifdef COMPONENT_MODULE
C     !LOCAL VARIABLES:
C     == Local variables ==
C     bi, bj  :: Tile indices
C     msgBuf  :: Informational/error message buffer
      INTEGER bi, bj
      CHARACTER*(MAX_LEN_MBUF) msgBuf

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C     Note MIT Coupler checkpoint1 does not allow asynchronous posting of
C     data, so ordering has to be consistent with coupling layer ordering.
C--------------------------------------------------------------------------
C-    Send data to coupling layer

      IF ( MOD(myIter,cplSendFrq_iter).EQ.0 ) THEN
       _BEGIN_MASTER( myThid )
        IF ( debugMode .OR. countPrtExp.LT.maxNumberPrint ) THEN
         WRITE(msgBuf,'(A,I10)')
     &    '  Exporting atmospheric surf fluxes at iter=', myIter
         CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                       SQUEEZE_RIGHT, myThid )
         countPrtExp = countPrtExp + 1
        ENDIF
       _END_MASTER( myThid )

C-    Store state variables (without averaging over cplSendFrq_iter time-steps)
        DO bj=myByLo(myThid),myByHi(myThid)
         DO bi=myBxLo(myThid),myBxHi(myThid)
           CALL ATM_STORE_DYNVARS( bi, bj, myTime, myIter, myThid )
           IF ( useThSIce ) THEN
            CALL ATM_STORE_THSICE( bi, bj, myTime, myIter, myThid )
           ENDIF
         ENDDO
        ENDDO

C-    Send data to coupler
        CALL ATM_EXPORT_FIELDS( myIter, myThid )

      ENDIF

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C-    Fetch data from coupling layer.

      IF ( MOD(myIter,cplSendFrq_iter).EQ.0 ) THEN
       _BEGIN_MASTER( myThid )
        IF ( debugMode .OR. countPrtImp.LT.maxNumberPrint ) THEN
         WRITE(msgBuf,'(A,I10)')
     &    '  Importing  oceanic surface fields at iter=', myIter
         CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                       SQUEEZE_RIGHT, myThid )
         countPrtImp = countPrtImp + 1
        ENDIF
       _END_MASTER( myThid )

        CALL ATM_IMPORT_FIELDS( myIter, myThid )

C     Fill diagnostics with updated coupling fields just received from Coupler
        CALL CPL_DIAGNOSTICS_FILL( myTime, myIter, myThid )

      ENDIF

#endif /* COMPONENT_MODULE */

      RETURN
      END

#include "DIAG_OPTIONS.h"

      SUBROUTINE DIAGNOSTICS_WRITE_ADJ(
     I                               modelStart,
     I                               myTime, myIter, myThid )
C***********************************************************************
C  Purpose
C  -------
C    Output sequence for adjoint diagnostic variables
C    Note: This closely mirrors diagnostics_write but is separated for
C          clarity
C    Note: For snapshots, mirror adjDump time step convention rather
C          than forward model diagnostic convention.
C
C  Arguments  Description
C  ----------------------
C     modelStart :: true if call at start of model run.
C              :: (this is the adjoint s modelEnd)
C     myTime   :: Current time of simulation ( s )
C     myIter   :: Current Iteration Number
C     myThid   :: my Thread Id number
C***********************************************************************
       IMPLICIT NONE
#include "EEPARAMS.h"
#include "SIZE.h"
#include "DIAGNOSTICS_SIZE.h"
#include "PARAMS.h"
#include "DIAGNOSTICS.h"

C     !INPUT PARAMETERS:
      LOGICAL modelStart
      _RL     myTime
      INTEGER myIter, myThid

C     !FUNCTIONS:
      LOGICAL  DIFF_PHASE_MULTIPLE
      EXTERNAL DIFF_PHASE_MULTIPLE
#ifdef ALLOW_FIZHI
      LOGICAL  ALARM2
      EXTERNAL ALARM2
#endif

c Local variables
c ===============
      INTEGER   n, nd
      INTEGER   myItM1, wrIter
      LOGICAL   dump2fileNow, write2file
      LOGICAL   writeDiags(numLists)
      _RL       phiSec, freqSec, wrTime
#ifdef ALLOW_FIZHI
      CHARACTER *9 tagname
#endif

      myItM1 = myIter - 1

C***********************************************************************
C***   Check to see if its time for Diagnostic Output                ***
C***********************************************************************

      write2file = .FALSE.
      DO n = 1,nlists
        nd = ABS(jdiag(1,n))
        IF ( gdiag(nd)(4:4).EQ.'A' ) THEN
          freqSec = freq(n)
          phiSec = phase(n)

C   Want time step of adjoint state variables to match actual time step
C   to mirror ADJdump
          wrIter = myIter
          wrTime = myTime

          dump2fileNow = DIFF_PHASE_MULTIPLE( phiSec, freqSec,
     &                                        wrTime, deltaTClock )
#ifdef ALLOW_FIZHI
          IF ( useFIZHI ) THEN
            WRITE(tagname,'(A,I2.2)')'diagtag',n
            dump2fileNow = ALARM2(tagname)
          ENDIF
#endif
#ifdef ALLOW_CAL
          IF ( useCAL ) THEN
            CALL CAL_TIME2DUMP( phiSec, freqSec, deltaTClock,
     U                          dump2fileNow,
     I                          wrTime, myIter, myThid )
          ENDIF
#endif /* ALLOW_CAL */
          IF ( dumpAtLast .AND. modelStart
     &                    .AND. freqSec.GE.0. ) dump2fileNow = .TRUE.
          IF ( dump2fileNow ) THEN
            write2file = .TRUE.
            CALL DIAGNOSTICS_OUT(n,wrTime,wrIter,myThid)
          ENDIF
          writeDiags(n) = dump2fileNow
        ELSE
          writeDiags(n) = .FALSE.
C       end if ( adj var )
        ENDIF
C-    end loop on list id number n
      ENDDO

C--- No Statistics Diag. Output for adjoint variables

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      IF ( write2file ) THEN
        IF ( diag_dBugLevel.GE.debLevC ) THEN
          CALL DIAGNOSTICS_SUMMARY( -1, myTime, myIter, myThid )
        ENDIF
C-    wait for everyone before setting arrays to zero:
        _BARRIER
      ENDIF

c     IF ( modelStart ) THEN
C-    Track diagnostics pkg activation status:
C  Note: switching off diag_pkgStatus does not work since few ADJ-diags
C      are filled outside S/R FORWARD_STEP_AD (e.g., "ADJetan " from
C      initialise_varia_ad -> integr_continuity_ad. -> addummy_for_etan )
cc      IF ( diag_pkgStatus.NE.ready2fillDiags ) STOP
c       _BARRIER
c       _BEGIN_MASTER(myThid)
c       diag_pkgStatus = 99
c       _END_MASTER(myThid)
c       _BARRIER
c     ENDIF

C--   Clear storage space:
      DO n = 1,nlists
        IF ( writeDiags(n) ) CALL DIAGNOSTICS_CLEAR(n,myThid)
      ENDDO

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      RETURN
      END

#include "GAD_OPTIONS.h"

CBOP
C !ROUTINE: GAD_C2_ADV_Y

C !INTERFACE: ==========================================================
      SUBROUTINE GAD_C2_ADV_Y( 
     I           bi,bj,k,
     I           vTrans,
     I           tracer,
     O           vT,
     I           myThid )

C !DESCRIPTION:
C Calculates the area integrated meridional flux due to advection of a tracer
C using centered second-order interpolation:
C \begin{equation*}
C F^y_{adv} = V \overline{\theta}^j
C \end{equation*}

C !USES: ===============================================================
      IMPLICIT NONE
#include "SIZE.h"
#include "GRID.h"

C !INPUT PARAMETERS: ===================================================
C  bi,bj                :: tile indices
C  k                    :: vertical level
C  vTrans               :: meridional volume transport
C  tracer               :: tracer field
C  myThid               :: thread number
      INTEGER bi,bj,k
      _RL vTrans(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL tracer(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER myThid

C !OUTPUT PARAMETERS: ==================================================
C  vT                   :: meridional advective flux
      _RL vT    (1-OLx:sNx+OLx,1-OLy:sNy+OLy)

C !LOCAL VARIABLES: ====================================================
C  i,j                  :: loop indices
      INTEGER i,j
CEOP

      DO i=1-Olx,sNx+Olx
       vT(i,1-Oly)=0.
      ENDDO
      DO j=1-Oly+1,sNy+Oly
       DO i=1-Olx,sNx+Olx
        vT(i,j) = 
     &   vTrans(i,j)*(Tracer(i,j)+Tracer(i,j-1))*0.5 _d 0
       ENDDO
      ENDDO

      RETURN
      END

#include "THSICE_OPTIONS.h"

CBOP
C     !ROUTINE: THSICE_READPARMS
C     !INTERFACE:
      SUBROUTINE THSICE_READPARMS( myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R THSICE_READPARMS
C     | o Routine to initialize THSICE parameters and constants
C     *==========================================================*
C     | Initialize Th-Sea-ICE parameters, read in data.ice
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "THSICE_PARAMS.h"
#ifdef ALLOW_MNC
#include "MNC_PARAMS.h"
#endif
#ifdef ALLOW_COST
#include "THSICE_COST.h"
#endif
C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
C     myThid    :: My Thread Id. number
      INTEGER myThid
CEOP

#ifdef ALLOW_THSICE

C     === Local variables ===
C     msgBuf    :: Informational/error message buffer
C     iUnit     :: Work variable for IO unit number
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      CHARACTER*(20) fmtR, fmtI, fmtL, fmtC
      INTEGER iUnit
C-    retired parameters:
      _RL thSIce_taveFreq
      LOGICAL thSIce_tave_mnc

C--   Th-Sea-ICE parameter
      NAMELIST /THSICE_CONST/
     &  rhos, rhoi, rhosw, rhofw,
     &  cpIce, cpWater,
     &  kIce, kSnow,
     &  bMeltCoef, Lfresh, qsnow,
     &  albColdSnow, albWarmSnow, tempSnowAlb,
     &  albOldSnow, hNewSnowAge, snowAgTime,
     &  albIceMax, albIceMin, hAlbIce, hAlbSnow,
     &  i0swFrac, ksolar, dhSnowLin,
     &  saltIce, S_winton, mu_Tf,
     &  Tf0kel, Terrmax, nitMaxTsf,
     &  hIceMin, hiMax, hsMax, iceMaskMax, iceMaskMin,
     &  fracEnMelt, fracEnFreez, hThinIce, hThickIce, hNewIceMax

      NAMELIST /THSICE_PARM01/
     &     startIceModel, stepFwd_oceMxL, thSIce_calc_albNIR,
     &     thSIce_skipThermo, thSIce_deltaT, thSIce_dtTemp,
     &     ocean_deltaT, tauRelax_MxL, tauRelax_MxL_salt,
     &     hMxL_default, sMxL_default, vMxL_default,
     &     thSIce_diffK, thSIceAdvScheme, stressReduction,
     &     thSIceBalanceAtmFW,
     &     thSIce_taveFreq, thSIce_diagFreq, thSIce_monFreq,
     &     thSIce_tave_mnc, thSIce_snapshot_mnc, thSIce_mon_mnc,
     &     thSIce_pickup_read_mnc, thSIce_pickup_write_mnc,
     &     thSIceFract_InitFile, thSIceThick_InitFile,
     &     thSIceSnowH_InitFile, thSIceSnowA_InitFile,
     &     thSIceEnthp_InitFile, thSIceTsurf_InitFile

#ifdef ALLOW_COST
      NAMELIST /THSICE_COST/
     &     mult_thsice, thsice_cost_ice_flag
#endif

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      IF ( .NOT.useThSIce ) THEN
C-    pkg THSICE is not used
        _BEGIN_MASTER(myThid)
C-    Track pkg activation status:
C     print a (weak) warning if data.ice is found
         CALL PACKAGES_UNUSED_MSG( 'useThSIce', ' ', 'ice' )
        _END_MASTER(myThid)
        RETURN
      ENDIF

      _BEGIN_MASTER(myThid)

C--   Default values (constants)
      rhos     = 330. _d 0
      rhoi     = 900. _d 0
      rhosw    = rhoConst
      rhofw    = rhoConstFresh
      cpIce    = 2106. _d 0
      cpWater  = HeatCapacity_Cp
      kIce     = 2.03 _d 0
      kSnow    = 0.30 _d 0
      bMeltCoef=0.006 _d 0
      Lfresh   = 3.34 _d 5
      qsnow    = Lfresh
      albColdSnow= 0.85 _d 0
      albWarmSnow= 0.70 _d 0
      tempSnowAlb= -10. _d 0
      albOldSnow = 0.55 _d 0
      albIceMax  = 0.65 _d 0
      albIceMin  = 0.20 _d 0
      hAlbIce    = 0.50 _d 0
      hAlbSnow   = 0.30 _d 0
      hNewSnowAge= 2. _d -3
      snowAgTime = 50. _d 0 * 86400. _d 0
      i0swFrac = 0.3 _d 0
      ksolar   = 1.5 _d 0
      dhSnowLin= 0. _d 0
      saltIce  = 4. _d 0
      S_winton = 1. _d 0
      mu_Tf    = 0.054 _d 0
      Tf0kel   = celsius2K
      Terrmax  = 5.0 _d -1
      nitMaxTsf= 20
      hIceMin    = 1. _d -2
      hiMax      = 10. _d 0
      hsMax      = 10. _d 0
      iceMaskMax =  1. _d 0
      iceMaskMin = 0.1 _d 0
      fracEnMelt = 0.4 _d 0
      fracEnFreez=  0. _d 0
      hThinIce   = 0.2 _d 0
      hThickIce  = 2.5 _d 0
      hNewIceMax = UNSET_RL

C--   Default values (parameters)
      stepFwd_oceMxL  = .FALSE.
      thSIce_skipThermo  = .FALSE.
      thSIce_calc_albNIR = .FALSE.
      startIceModel   = 0
      thSIce_deltaT   = dTtracerLev(1)
      thSIce_dtTemp   = UNSET_RL
      ocean_deltaT    = dTtracerLev(1)
      tauRelax_MxL    = 0. _d 0
      tauRelax_MxL_salt = UNSET_RL
      hMxL_default    = 50. _d 0
      sMxL_default    = 35. _d 0
      vMxL_default    = 5. _d -2
      thSIce_diffK    = 0. _d 0
      thSIceAdvScheme = 0
      stressReduction = 1. _d 0
      IF ( useSEAICE ) stressReduction = 0. _d 0
      thSIceBalanceAtmFW  = 0
      thSIce_diagFreq = dumpFreq
      thSIce_monFreq  = monitorFreq
#ifdef ALLOW_MNC
      thSIce_snapshot_mnc = useMNC .AND. snapshot_mnc
      thSIce_mon_mnc      = useMNC .AND. monitor_mnc
      thSIce_pickup_read_mnc  = useMNC .AND. pickup_read_mnc
      thSIce_pickup_write_mnc = useMNC .AND. pickup_write_mnc
#else
      thSIce_snapshot_mnc = .FALSE.
      thSIce_mon_mnc      = .FALSE.
      thSIce_pickup_read_mnc  = .FALSE.
      thSIce_pickup_write_mnc = .FALSE.
#endif
      thSIceFract_InitFile = ' '
      thSIceThick_InitFile = ' '
      thSIceSnowH_InitFile = ' '
      thSIceSnowA_InitFile = ' '
      thSIceEnthp_InitFile = ' '
      thSIceTsurf_InitFile = ' '

#ifdef ALLOW_COST
      thsice_cost_ice_flag = 1
      mult_thsice = 0. _d 0
#endif
C-    retired params default:
      thSIce_taveFreq = UNSET_RL
      thSIce_tave_mnc = .FALSE.

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      WRITE(msgBuf,'(A)') ' THSICE_READPARMS: opening data.ice'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT , 1)

      CALL OPEN_COPY_DATA_FILE(
     I                          'data.ice', 'THSICE_READPARMS',
     O                          iUnit,
     I                          myThid )

C--   Read parameters from open data file
      READ(UNIT=iUnit,NML=THSICE_CONST)
      WRITE(msgBuf,'(A)') ' THSICE_READPARMS: read THSICE_CONST'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT , 1)

      READ(UNIT=iUnit,NML=THSICE_PARM01)
      WRITE(msgBuf,'(A)') ' THSICE_READPARMS: read THSICE_PARM01'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT , 1)

#ifdef ALLOW_COST
      READ(UNIT=iUnit,NML=THSICE_COST)
      WRITE(msgBuf,'(A)') ' THSICE_READPARMS: read THSICE_COST'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT , 1)
#endif

C--   Close the open data file
#ifdef SINGLE_DISK_IO
      CLOSE(iUnit)
#else
      CLOSE(iUnit,STATUS='DELETE')
#endif /* SINGLE_DISK_IO */

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C--   Check for retired parameters:
      IF ( thSIce_taveFreq .NE. UNSET_RL ) THEN
        WRITE(msgBuf,'(2A)') 'THSICE_READPARMS: "thSIce_taveFreq"',
     &    ' is no longer allowed in file "data.ice"'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(2A)') 'THSICE_READPARMS: ',
     &    ' since "pkg/timeave" has been removed.'
        CALL PRINT_ERROR( msgBuf, myThid )
c       errCount = errCount + 1
        STOP 'ABNORMAL END: S/R THSICE_READPARMS'
      ENDIF
      IF ( thSIce_tave_mnc ) THEN
        WRITE(msgBuf,'(2A)') 'THSICE_READPARMS: "thSIce_tave_mnc"',
     &    ' is no longer allowed in file "data.ice"'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(2A)') 'THSICE_READPARMS: ',
     &    ' since "pkg/timeave" has been removed.'
        CALL PRINT_ERROR( msgBuf, myThid )
c       errCount = errCount + 1
        STOP 'ABNORMAL END: S/R THSICE_READPARMS'
      ENDIF

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C-    neutral default:
      IF ( hNewIceMax .EQ. UNSET_RL ) hNewIceMax = hiMax

C     If using the same time step for both icetop temp solver
C     and ice thickness/growth, use thSIce_deltaT value
      IF ( thSIce_dtTemp .EQ. UNSET_RL ) thSIce_dtTemp=thSIce_deltaT

C-    If undef, set salt relax to temperature relax
      IF ( tauRelax_MxL_salt .EQ. UNSET_RL ) THEN
           tauRelax_MxL_salt = tauRelax_MxL
      ENDIF

C-    Define other constants (from previous ones):
      Tmlt1=-mu_Tf*S_winton
      floodFac = (rhosw - rhoi)/rhos

C     Set I/O parameters
      thSIce_snapshot_mdsio     = .TRUE.
      thSIce_mon_stdio          = .TRUE.
      thSIce_pickup_write_mdsio = .TRUE.
#ifdef ALLOW_MNC
      thSIce_snapshot_mnc     = useMNC .AND. thSIce_snapshot_mnc
      thSIce_mon_mnc          = useMNC .AND. thSIce_mon_mnc
      thSIce_pickup_write_mnc = useMNC .AND. thSIce_pickup_write_mnc
      thSIce_snapshot_mdsio     = ( .NOT.thSIce_snapshot_mnc )
     &                        .OR. outputTypesInclusive
      thSIce_mon_stdio          = ( .NOT.thSIce_mon_mnc )
     &                        .OR. outputTypesInclusive
      thSIce_pickup_write_mdsio = ( .NOT.thSIce_pickup_write_mnc )
     &                        .OR. outputTypesInclusive
#endif

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C--   Check/reset parameters:
      IF ( useSEAICE .AND. stressReduction.NE.0. _d 0 ) THEN
C--     If useSEAICE=.true., the stress is computed in seaice_model,
C--     so that it does not need any further reduction
        WRITE(msgBuf,'(2A)') '** WARNING ** THSICE_READPARMS:',
     &                       ' reset stressReduction to zero'
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
        WRITE(msgBuf,'(2A)') 'THSICE_READPARMS: useSEAICE=T =>',
     &       ' stress is be computed by SEAICE pkg => no reduction'
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
        stressReduction = 0. _d 0
      ENDIF
      IF ( fluidIsAir .AND. thSIceBalanceAtmFW.NE.0 ) THEN
        WRITE(msgBuf,'(2A)') '** WARNING ** THSICE_READPARMS:',
     &                       ' reset thSIceBalanceAtmFW to zero'
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
        WRITE(msgBuf,'(2A)') 'THSICE_READPARMS:',
     &       ' since it is not available in Atmospheric set-up'
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
        thSIceBalanceAtmFW = 0
      ENDIF

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
      iUnit = standardMessageUnit
      fmtR = '(A6,A20,1PE21.13)'
      fmtI = '(A6,A20,I10)'
      fmtL = '(A6,A20,L10)'
      fmtC = '(A26,1X,A)'
c     CALL MDSFINDUNIT( iUnit, myThid )
c     OPEN(iUnit,file='thsice_check_params',status='unknown')
      WRITE(iUnit,fmtR) 'ThSI:', 'rhos        =', rhos
      WRITE(iUnit,fmtR) 'ThSI:', 'rhoi        =', rhoi
      WRITE(iUnit,fmtR) 'ThSI:', 'rhosw       =', rhosw
      WRITE(iUnit,fmtR) 'ThSI:', 'rhofw       =', rhofw
      WRITE(iUnit,fmtR) 'ThSI:', 'floodFac    =', floodFac
      WRITE(iUnit,fmtR) 'ThSI:', 'cpIce       =', cpIce
      WRITE(iUnit,fmtR) 'ThSI:', 'cpWater     =', cpWater
      WRITE(iUnit,fmtR) 'ThSI:', 'kIce        =', kIce
      WRITE(iUnit,fmtR) 'ThSI:', 'kSnow       =', kSnow
      WRITE(iUnit,fmtR) 'ThSI:', 'bMeltCoef   =', bMeltCoef
      WRITE(iUnit,fmtR) 'ThSI:', 'Lfresh      =', Lfresh
      WRITE(iUnit,fmtR) 'ThSI:', 'qsnow       =', qsnow
      WRITE(iUnit,fmtR) 'ThSI:', 'albColdSnow =', albColdSnow
      WRITE(iUnit,fmtR) 'ThSI:', 'albWarmSnow =', albWarmSnow
      WRITE(iUnit,fmtR) 'ThSI:', 'tempSnowAlb =', tempSnowAlb
      WRITE(iUnit,fmtR) 'ThSI:', 'albOldSnow  =', albOldSnow
      WRITE(iUnit,fmtR) 'ThSI:', 'hNewSnowAge =', hNewSnowAge
      WRITE(iUnit,fmtR) 'ThSI:', 'snowAgTime  =', snowAgTime
      WRITE(iUnit,fmtR) 'ThSI:', 'albIceMax   =', albIceMax
      WRITE(iUnit,fmtR) 'ThSI:', 'albIceMin   =', albIceMin
      WRITE(iUnit,fmtR) 'ThSI:', 'hAlbIce     =', hAlbIce
      WRITE(iUnit,fmtR) 'ThSI:', 'hAlbSnow    =', hAlbSnow
      WRITE(iUnit,fmtR) 'ThSI:', 'i0swFrac    =', i0swFrac
      WRITE(iUnit,fmtR) 'ThSI:', 'ksolar      =', ksolar
      WRITE(iUnit,fmtR) 'ThSI:', 'dhSnowLin   =', dhSnowLin
      WRITE(iUnit,fmtR) 'ThSI:', 'saltIce     =', saltIce
      WRITE(iUnit,fmtR) 'ThSI:', 'S_winton    =', S_winton
      WRITE(iUnit,fmtR) 'ThSI:', 'mu_Tf       =', mu_Tf
      WRITE(iUnit,fmtR) 'ThSI:', 'Tf0kel      =', Tf0kel
      WRITE(iUnit,fmtR) 'ThSI:', 'Tmlt1       =', Tmlt1
      WRITE(iUnit,fmtR) 'ThSI:', 'Terrmax     =', Terrmax
      WRITE(iUnit,fmtI) 'ThSI:', 'nitMaxTsf   =', nitMaxTsf
      WRITE(iUnit,fmtR) 'ThSI:', 'hIceMin     =', hIceMin
      WRITE(iUnit,fmtR) 'ThSI:', 'hiMax       =', hiMax
      WRITE(iUnit,fmtR) 'ThSI:', 'hsMax       =', hsMax
      WRITE(iUnit,fmtR) 'ThSI:', 'iceMaskMax  =', iceMaskMax
      WRITE(iUnit,fmtR) 'ThSI:', 'iceMaskMin  =', iceMaskMin
      WRITE(iUnit,fmtR) 'ThSI:', 'fracEnMelt  =', fracEnMelt
      WRITE(iUnit,fmtR) 'ThSI:', 'fracEnFreez =', fracEnFreez
      WRITE(iUnit,fmtR) 'ThSI:', 'hThinIce    =', hThinIce
      WRITE(iUnit,fmtR) 'ThSI:', 'hThickIce   =', hThickIce
      WRITE(iUnit,fmtR) 'ThSI:', 'hNewIceMax  =', hNewIceMax
      WRITE(iUnit,fmtR) 'ThSI:','stressReduction   =',stressReduction
      WRITE(iUnit,fmtL) 'ThSI:','thSIce_skipThermo =',thSIce_skipThermo
      WRITE(iUnit,fmtI) 'ThSI:','thSIceAdvScheme   =',thSIceAdvScheme
      WRITE(iUnit,fmtI) 'ThSI:','thSIceBalanceAtmFW=',thSIceBalanceAtmFW
      WRITE(iUnit,fmtR) 'ThSI:','thSIce_diffK      =',thSIce_diffK
      WRITE(iUnit,fmtR) 'ThSI:','thSIce_deltaT     =',thSIce_deltaT
      WRITE(iUnit,fmtR) 'ThSI:','ocean_deltaT      =',ocean_deltaT
      WRITE(iUnit,fmtL) 'ThSI:','stepFwd_oceMxL    =',stepFwd_oceMxL
      WRITE(iUnit,fmtR) 'ThSI:','tauRelax_MxL      =',tauRelax_MxL
      WRITE(iUnit,fmtR) 'ThSI:','tauRelax_MxL_salt =',tauRelax_MxL_salt
      WRITE(iUnit,fmtR) 'ThSI:','hMxL_default      =',hMxL_default
      WRITE(iUnit,fmtR) 'ThSI:','sMxL_default      =',sMxL_default
      WRITE(iUnit,fmtR) 'ThSI:','vMxL_default      =',vMxL_default
      WRITE(iUnit,fmtR) 'ThSI:','thSIce_diagFreq   =',thSIce_diagFreq
      WRITE(iUnit,fmtR) 'ThSI:','thSIce_monFreq    =',thSIce_monFreq
      WRITE(iUnit,fmtI) 'ThSI:','startIceModel     =',startIceModel
c     WRITE(iUnit,fmtC) 'thSIceFract_InitFile    =',thSIceFract_InitFile
      IF (iUnit.NE.standardMessageUnit) CLOSE(iUnit)
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      _END_MASTER(myThid)

C--   Everyone else must wait for the parameters to be loaded
      _BARRIER

#endif /* ALLOW_THSICE */

      RETURN
      END

#include "THSICE_OPTIONS.h"
#ifdef ALLOW_SEAICE
# include "SEAICE_OPTIONS.h"
#endif /* ALLOW_SEAICE */


CBOP
C !ROUTINE: THSICE_GET_VELOCITY

C !INTERFACE: ==========================================================
      SUBROUTINE THSICE_GET_VELOCITY(
     O                  uLoc, vLoc,
     I                  bi, bj, myTime, myIter, myThid )

C !DESCRIPTION: \bv
C     *===========================================================*
C     | SUBROUTINE THSICE_GET_VELOCITY
C     | o load seaice velocity from pkg/seaice common block
C     *===========================================================*
C \ev

C !USES: ===============================================================
      IMPLICIT NONE

C     === Global variables ===

#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
c#include "THSICE_SIZE.h"
c#include "THSICE_PARAMS.h"
#ifdef ALLOW_SEAICE
# include "SEAICE_SIZE.h"
# include "SEAICE.h"
#endif /* ALLOW_SEAICE */

C !INPUT PARAMETERS: ===================================================
C     === Routine arguments ===
C     uLoc/vLoc :: current ice velocity on C-grid [m/s]
C     bi,bj     :: Tile indices
C     myTime    :: Current time in simulation (s)
C     myIter    :: Current iteration number
C     myThid    :: My Thread Id number
      _RL     uLoc(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL     vLoc(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER bi,bj
      _RL     myTime
      INTEGER myIter
      INTEGER myThid

#ifdef ALLOW_THSICE
C !LOCAL VARIABLES: ====================================================
C     === Local variables ===
C     i,j,      :: Loop counters
      INTEGER i, j
CEOP

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|


#ifdef ALLOW_SEAICE
      IF ( useSEAICE ) THEN
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          uLoc(i,j) = UICE(i,j,bi,bj)
          vLoc(i,j) = VICE(i,j,bi,bj)
         ENDDO
        ENDDO
      ELSE
#else /* ALLOW_SEAICE */
      IF ( .TRUE. ) THEN
#endif /* ALLOW_SEAICE */
C-    set ice velocity to zero
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          uLoc(i,j) = 0.
          vLoc(i,j) = 0.
         ENDDO
        ENDDO
      ENDIF

#endif /* ALLOW_THSICE */

      RETURN
      END

#include "STREAMICE_OPTIONS.h"
#ifdef ALLOW_AUTODIFF
# include "AUTODIFF_OPTIONS.h"
#endif

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

CBOP
      SUBROUTINE STREAMICE_TIMESTEP ( myThid, myIter,
     &                                        iLoop, myTime )

C     /============================================================\
C     | SUBROUTINE                                                 |
C     | o                                                          |
C     |============================================================|
C     |                                                            |
C     \============================================================/
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "GRID.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "STREAMICE.h"
#ifdef ALLOW_AUTODIFF
# include "STREAMICE_ADV.h"
# include "STREAMICE_BDRY.h"
# include "STREAMICE_CG.h"
#endif
#ifdef ALLOW_AUTODIFF_TAMC
# include "tamc.h"
#endif

      INTEGER myThid, myIter, iLoop
      _RL myTime
      LOGICAL  DIFFERENT_MULTIPLE
      EXTERNAL DIFFERENT_MULTIPLE

#ifdef ALLOW_STREAMICE

# if (defined ALLOW_AUTODIFF || defined STREAMICE_ECSECRYO_DOSUM)
      INTEGER i, j, bi, bj
# endif
c       _RL Iratio, Imin_ratio, time_step_remain, local_u_max
c       _RL ratio, min_ratio
c       _RL local_v_max, time_step_int, min_time_step
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      LOGICAL do_vel
# ifdef STREAMICE_ECSECRYO_DOSUM
      _RL sum_square_vel_tile (nSx,nSy)
      _RL sum_square_vel
# endif

#ifdef ALLOW_AUTODIFF_TAMC
c**************************************
#include "streamice_ad_check_lev1_dir.h"
c**************************************
#endif

c       time_step_remain = deltaT
c       min_time_step = 1000.0
c       n_interm = 0

      do_vel = .false.

#ifdef ALLOW_AUTODIFF

      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          STREAMICE_ufacemask(i,j,bi,bj) = 0. _d 0
          STREAMICE_vfacemask(i,j,bi,bj) = 0. _d 0
          ru_old_si(i,j,bi,bj) = 0. _d 0
          rv_old_si(i,j,bi,bj) = 0. _d 0
          zu_old_si(i,j,bi,bj) = 0. _d 0
          zv_old_si(i,j,bi,bj) = 0. _d 0
c          h_after_uflux_si(i,j,bi,bj) = 0. _d 0
#ifdef STREAMICE_HYBRID_STRESS
          streamice_taubx (i,j,bi,bj) = 0. _d 0
          streamice_tauby (i,j,bi,bj) = 0. _d 0
#endif
         ENDDO
        ENDDO
       ENDDO
      ENDDO

#endif /* ALLOW_AUTODIFF */

      CALL TIMER_START('STREAMICE_TIMESTEP [FORWARD_STEP]',
     &       myThid)

      WRITE(msgBuf,'(A,I10.10,E9.2,A)')
     &  'streamice solo_time_step: nIter',
     &  myIter, myTime/86400.0/365.0, 'seconds'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                   SQUEEZE_RIGHT , 1)

      CALL STREAMICE_DUMP( myTime, myIter, myThid )

c NEW DIRECTIVES - DNG
c#ifdef ALLOW_AUTODIFF_TAMC
cCADJ STORE float_frac_streamice  = comlev1, key = ikey_dynamics,
cCADJ &     kind = isbyte
cCADJ STORE surf_el_streamice  = comlev1, key = ikey_dynamics,
cCADJ &     kind = isbyte
cCADJ STORE base_el_streamice  = comlev1, key = ikey_dynamics,
cCADJ &     kind = isbyte
c#endif
c NEW DIRECTIVES - DNG

      do_vel = DIFFERENT_MULTIPLE( streamice_vel_update,
     &                             myTime, deltaT )

      IF (myIter.eq.0) THEN
      CALL STREAMICE_UPD_FFRAC_UNCOUPLED ( myThid )
      CALL WRITE_FLD_XY_RL
     & ("surf_el_init","",surf_el_streamice,0,myThid)
      ENDIF

      CALL STREAMICE_VELMASK_UPD (myThid)

#ifdef ALLOW_STREAMICE_TIMEDEP_FORCING
      CALL STREAMICE_FIELDS_LOAD( myTime, myIter, myThid )
#endif

      IF (.not.(STREAMICE_vel_ext.OR.STREAMICE_vel_ext_cgrid)) THEN

#ifdef ALLOW_STREAMICE_FP_ADJ

       CALL STREAMICE_VEL_SOLVE_FP ( myThid,
     &                           streamice_max_nl_iter,
     &                           streamice_max_cg_iter,
     &                           myIter )

#else

       IF (streamice_maxnliter_cpl.eq.0 .OR. myIter.eq.0) THEN

        CALL STREAMICE_VEL_SOLVE( myThid,
     &                           streamice_max_nl_iter,
     &                           streamice_max_cg_iter,
     &                           myIter )

#ifdef STREAMICE_ECSECRYO_DOSUM

        DO bj = myByLo(myThid), myByHi(myThid)
         DO bi = myBxLo(myThid), myBxHi(myThid)
          sum_square_vel_tile (bi,bj) = 0. _d 0
          DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
            IF (streamice_hmask(i,j,bi,bj).eq.1) THEN
             sum_square_vel_tile (bi,bj) =
     &        sum_square_vel_tile (bi,bj) +
     &        U_streamice(i,j,bi,bj)**2 +
     &        V_streamice(i,j,bi,bj)**2
            ENDIF
           ENDDO
          ENDDO
         ENDDO
        ENDDO

        CALL GLOBAL_SUM_TILE_RL(
     &                sum_square_vel_tile, sum_square_vel, myThid )
        WRITE(msgBuf,'(A,I3,A,1PE22.14)') 'ECSE_CRYO_SUM ', myIter, ', '
     &                       ,sum_square_vel
        CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT , 1)

#endif

       ELSEIF (do_vel) THEN

        CALL STREAMICE_VEL_SOLVE( myThid,
     &                           streamice_maxnliter_cpl,
     &                           streamice_maxcgiter_cpl,
     &                           myIter )
       ENDIF

#endif /* OAD_FP */

      ELSE

        WRITE(msgBuf,'(A)')
     &   'STREAMICE_TIMESTEP: bypassing velocity solve'
        CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT , 1)

      ENDIF

      IF (.not.STREAMICE_diagnostic_only) THEN

       CALL STREAMICE_ADVECT_THICKNESS ( myThid, myIter, deltaT )

      ENDIF

c CALL AT END INSTEAD OF BEGINNING - DNG
      CALL STREAMICE_UPD_FFRAC_UNCOUPLED ( myThid )
c      print *, "GOT HERE TIMESTEP ", H_streamice(1,50,1,1)
c      call write_fld_xy_rl("h_got_here","",H_streamice,0,myThid)
c      call write_fld_xy_rl("u_got_here","",U_streamice,0,myThid)
c      call write_fld_xy_rl("v_got_here","",V_streamice,0,myThid)

      CALL TIMER_STOP('STREAMICE_TIMESTEP [FORWARD_STEP]',
     &       myThid)

#endif
      RETURN
      END

#include "SEAICE_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: SEAICE_MNC_INIT

C     !INTERFACE:
      SUBROUTINE SEAICE_MNC_INIT( myThid )

C     !DESCRIPTION:
C     Initialize SEAICE variables within MNC

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#ifdef SEAICE_ALLOW_EVP
#include "SEAICE_SIZE.h"
#include "SEAICE_PARAMS.h"
#endif /* SEAICE_ALLOW_EVP */

C     !INPUT PARAMETERS:
      INTEGER myThid
CEOP

#ifdef ALLOW_MNC
      IF (useMNC) THEN

#ifdef SEAICE_ALLOW_EVP
       IF ( SEAICEuseEVP ) THEN
        CALL MNC_CW_ADD_VNAME('si_sigma1','Cen_xy_Hn__-__t',3,4,myThid)
        CALL MNC_CW_ADD_VATTR_TEXT('si_sigma1','units','N/m^2', myThid)
        CALL MNC_CW_ADD_VATTR_TEXT('si_sigma1','description',
     &       'divergence of stress tensor', myThid)
        CALL MNC_CW_ADD_VNAME('si_sigma2','Cen_xy_Hn__-__t',3,4,myThid)
        CALL MNC_CW_ADD_VATTR_TEXT('si_sigma2','units','N/m^2', myThid)
        CALL MNC_CW_ADD_VATTR_TEXT('si_sigma2','description',
     &       'tension of stress tensor', myThid)
        CALL MNC_CW_ADD_VNAME('si_sigma12','Cor_xy_Hn__-__t',3,4,myThid)
        CALL MNC_CW_ADD_VATTR_TEXT('si_sigma12','units','N/m^2', myThid)
        CALL MNC_CW_ADD_VATTR_TEXT('si_sigma12','description',
     &       'shear of stress tensor', myThid)
       ENDIF
#endif /* SEAICE_ALLOW_EVP */

        CALL MNC_CW_ADD_VNAME('si_UWIND','U_xy_Hn__-__t',3,4,myThid)
        CALL MNC_CW_ADD_VATTR_TEXT('si_UWIND','units','m/s', myThid)
        CALL MNC_CW_ADD_VATTR_TEXT('si_UWIND','description',
     &       'Surface (10m) zonal wind velocity', myThid)

        CALL MNC_CW_ADD_VNAME('si_VWIND','V_xy_Hn__-__t',3,4,myThid)
        CALL MNC_CW_ADD_VATTR_TEXT('si_VWIND','units','m/s', myThid)
        CALL MNC_CW_ADD_VATTR_TEXT('si_VWIND','description',
     &       'Surface (10m) meridional wind velocity', myThid)

        CALL MNC_CW_ADD_VNAME('si_EVAP','Cen_xy_Hn__-__t',3,4,myThid)
        CALL MNC_CW_ADD_VATTR_TEXT('si_EVAP','units','m/s', myThid)
        CALL MNC_CW_ADD_VATTR_TEXT('si_EVAP','description',
     &       'Evaporation', myThid)

        CALL MNC_CW_ADD_VNAME('si_PRECIP','Cen_xy_Hn__-__t',3,4,myThid)
        CALL MNC_CW_ADD_VATTR_TEXT('si_PRECIP','units','m/s', myThid)
        CALL MNC_CW_ADD_VATTR_TEXT('si_PRECIP','description',
     &       'Precipitation', myThid)

        CALL MNC_CW_ADD_VNAME('si_RUNOFF','Cen_xy_Hn__-__t',3,4,myThid)
        CALL MNC_CW_ADD_VATTR_TEXT('si_RUNOFF','units','m/s', myThid)
        CALL MNC_CW_ADD_VATTR_TEXT('si_RUNOFF','description',
     &       'River and glacier runoff', myThid)

        CALL MNC_CW_ADD_VNAME('si_ATEMP','Cen_xy_Hn__-__t',3,4,myThid)
        CALL MNC_CW_ADD_VATTR_TEXT('si_ATEMP','units','deg K', myThid)
        CALL MNC_CW_ADD_VATTR_TEXT('si_ATEMP','description',
     &       'Surface (2m) air temperature', myThid)

        CALL MNC_CW_ADD_VNAME('si_AQH','Cen_xy_Hn__-__t',3,4,myThid)
        CALL MNC_CW_ADD_VATTR_TEXT('si_AQH','units','kg/kg', myThid)
        CALL MNC_CW_ADD_VATTR_TEXT('si_AQH','description',
     &       'Surface (2m) specific humidity', myThid)

        CALL MNC_CW_ADD_VNAME('si_SWDOWN','Cen_xy_Hn__-__t',3,4,myThid)
        CALL MNC_CW_ADD_VATTR_TEXT('si_SWDOWN','units','W/m^2', myThid)
        CALL MNC_CW_ADD_VATTR_TEXT('si_SWDOWN','description',
     &       'Downward shortwave radiation', myThid)

        CALL MNC_CW_ADD_VNAME('si_LWDOWN','Cen_xy_Hn__-__t',3,4,myThid)
        CALL MNC_CW_ADD_VATTR_TEXT('si_LWDOWN','units','W/m^2', myThid)
        CALL MNC_CW_ADD_VATTR_TEXT('si_LWDOWN','description',
     &       'Downward longwave radiation', myThid)

        CALL MNC_CW_ADD_VNAME('si_UICE','U_xy_Hn__-__t',3,4,myThid)
        CALL MNC_CW_ADD_VATTR_TEXT('si_UICE','units','m/s', myThid)
        CALL MNC_CW_ADD_VATTR_TEXT('si_UICE','description',
     &       'Ice U velocity', myThid)

        CALL MNC_CW_ADD_VNAME('si_VICE','V_xy_Hn__-__t',3,4,myThid)
        CALL MNC_CW_ADD_VATTR_TEXT('si_VICE','units','m/s', myThid)
        CALL MNC_CW_ADD_VATTR_TEXT('si_VICE','description',
     &       'Ice V velocity', myThid)

        CALL MNC_CW_ADD_VNAME('si_HEFF','Cen_xy_Hn__-__t',3,4,myThid)
        CALL MNC_CW_ADD_VATTR_TEXT('si_HEFF','units','m', myThid)
        CALL MNC_CW_ADD_VATTR_TEXT('si_HEFF','description',
     &       'Effective ice thickness',myThid)

        CALL MNC_CW_ADD_VNAME('si_AREA','Cen_xy_Hn__-__t',3,4,myThid)
        CALL MNC_CW_ADD_VATTR_TEXT('si_AREA','units','m^2/m^2',myThid)
        CALL MNC_CW_ADD_VATTR_TEXT('si_AREA','description',
     &       'Fractional ice-covered area',myThid)

      ENDIF
#endif /*  ALLOW_MNC     */

      RETURN
      END

#include "MOM_VECINV_OPTIONS.h"

CBOP
C     !ROUTINE: MOM_VI_U_VERTSHEAR

C     !INTERFACE:
      SUBROUTINE MOM_VI_U_VERTSHEAR(
     I        bi, bj, k, deepFacA,
     I        uFld, wFld,
     U        uShearTerm,
     I        myThid )

C     !DESCRIPTION:
C     *==========================================================*
C     | S/R MOM_U_VERTSHEAR
C     *==========================================================*

C     !USES:
      IMPLICIT NONE
C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "GRID.h"
#include "PARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
C  deepFacA             :: deep-model grid factor at level center
      INTEGER bi, bj, k
      _RL deepFacA(Nr)
      _RL uFld(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      _RL wFld(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      _RL uShearTerm(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER myThid

C     !LOCAL VARIABLES:
      INTEGER i, j, kp1, km1
      _RL mask_Kp1, mask_Km1, wBarXm, wBarXp
      _RL uZm, uZp, recip_drDeepRho
      LOGICAL rAdvAreaWeight
c     _RL umask_Kp1,umask_K,umask_Km1
c1    _RL wBarXZ,uZbarZ
CEOP

      rAdvAreaWeight =.TRUE.
C-    Area-weighted average either in KE or in vert. advection:
      IF ( selectKEscheme.EQ.1 .OR. selectKEscheme.EQ.3 )
     &  rAdvAreaWeight =.FALSE.

      kp1 = MIN(k+1,Nr)
      mask_Kp1 = oneRL
      IF (k.EQ.Nr) mask_Kp1 = zeroRL
      km1 = MAX(k-1,1)
      mask_Km1 = oneRL
      IF (k.EQ.1) mask_Km1 = zeroRL

      recip_drDeepRho = recip_drF(k)/deepFacA(k)
     &                * recip_deepFac2C(k)*recip_rhoFacC(k)

      DO j=1-OLy,sNy+OLy
       DO i=2-OLx,sNx+OLx

c       umask_K=_maskW(i,j,k,bi,bj)

C barZ( barX( W ) )
c       wBarXm=0.5*(wFld(I,J,K,bi,bj)+wFld(I-1,J,K,bi,bj))
c       wBarXp=0.5*(wFld(I,J,Kp1,bi,bj)+wFld(I-1,J,Kp1,bi,bj))
c    &         *mask_Kp1

       IF ( rAdvAreaWeight ) THEN
C     Transport at interface k : Area weighted average
        wBarXm = halfRL*(
     &     wFld(i,j,k,bi,bj)*rA(i,j,bi,bj)*maskC(i,j,km1,bi,bj)
     &   + wFld(i-1,j,k,bi,bj)*rA(i-1,j,bi,bj)*maskC(i-1,j,km1,bi,bj)
     &                  )*mask_Km1*deepFac2F(k)*rhoFacF(k)
     &                   *recip_rAw(i,j,bi,bj)

C     Transport at interface k+1 (here wFld is already masked)
        wBarXp = halfRL*(
     &     wFld(i,j,kp1,bi,bj)*rA(i,j,bi,bj)
     &   + wFld(i-1,j,kp1,bi,bj)*rA(i-1,j,bi,bj)
     &                  )*mask_Kp1*deepFac2F(kp1)*rhoFacF(kp1)
     &                   *recip_rAw(i,j,bi,bj)
       ELSE
C     Transport at interface k : simple average
        wBarXm = halfRL*(
     &     wFld(i,j,k,bi,bj)*maskC(i,j,km1,bi,bj)
     &   + wFld(i-1,j,k,bi,bj)*maskC(i-1,j,km1,bi,bj)
     &                  )*mask_Km1*deepFac2F(k)*rhoFacF(k)

C     Transport at interface k+1 (here wFld is already masked)
        wBarXp = halfRL*(
     &     wFld(i,j,kp1,bi,bj)
     &   + wFld(i-1,j,kp1,bi,bj)
     &                  )*mask_Kp1*deepFac2F(kp1)*rhoFacF(kp1)
       ENDIF

C-    delta_Z( U*deepFac )  @ interface k
c       umask_Km1=mask_Km1*maskW(i,j,Km1,bi,bj)
        uZm = ( uFld(i,j, k ,bi,bj)*deepFacA( k )
     &        - uFld(i,j,km1,bi,bj)*deepFacA(km1)*mask_Km1 )*rkSign
c2   &      *recip_dRC(K)
c       IF (freeslip1) uZm=uZm*umask_Km1
c       IF (noslip1.AND.umask_Km1.EQ.0.) uZm=uZm*2.

C-    delta_Z( U*deepFac )  @ interface k+1
c       umask_Kp1=mask_Kp1*maskW(i,j,Kp1,bi,bj)
        uZp = ( uFld(i,j,kp1,bi,bj)*deepFacA(kp1)*mask_Kp1
     &        - uFld(i,j, k ,bi,bj)*deepFacA( k ) )*rkSign
c2   &      *recip_dRC(Kp1)
c       IF (freeslipK) uZp=uZp*umask_Kp1
c       IF (noslipK.AND.umask_Kp1.EQ.0.) uZp=uZp*2.

c1      IF (upwindShear) THEN
c1       wBarXZ=0.5*( wBarXm + wBarXp )
c1       IF (wBarXZ.GT.0.) THEN
c1        uZbarZ=uZp
c1       ELSE
c1        uZbarZ=uZm
c1       ENDIF
c1      ELSE
c1       uZbarZ=0.5*(uZm+uZp)
c1      ENDIF
c1      uShearTerm(I,J)=-wBarXZ*uZbarZ*_maskW(I,J,K,bi,bj)

c2      uShearTerm(I,J)=-0.5*(wBarXp*uZp+wBarXm*uZm)
c2   &                  *_maskW(I,J,K,bi,bj)
        IF (upwindShear) THEN
         uShearTerm(i,j) = -halfRL*
     &                  (    (     wBarXp *uZp +     wBarXm *uZm )
     &                     + ( ABS(wBarXp)*uZp - ABS(wBarXm)*uZm )
     &                  )*_recip_hFacW(i,j,k,bi,bj)*recip_drDeepRho
        ELSE
         uShearTerm(i,j) = -halfRL*( wBarXp*uZp + wBarXm*uZm )
     &                   *_recip_hFacW(i,j,k,bi,bj)*recip_drDeepRho
        ENDIF
       ENDDO
      ENDDO

      RETURN
      END

#include "FIZHI_OPTIONS.h"
       SUBROUTINE DO_FIZHI(myIter,myid,
     & idim1,idim2,jdim1,jdim2,Nrphin,nSxIn,nSyIn,im1,im2,jm1,jm2,bi,bj,
     & turbStart, nchp,nchptot,nchpland,
     & uphy,vphy,thphy,sphy,pephy,lons,lats,Zsurf,
     & ctmt,xxmt,yymt,zetamt,xlmt,khmt,tke,
     & tgz,sst,sice,phis_var,landtype,fracland,emiss,albnirdr,albnirdf,
     & albvisdr,albvisdf,ityp,chfr,alai,agrn,igrd,chlat,chlon,
     & tcanopy,tdeep,ecanopy,swetshal,swetroot,swetdeep,snodep,capac,
     & o3,qstr,co2,cfc11,cfc12,cfc22,n2o,methane,
     & iras,nlwcld,cldtotlwin,cldraslwin,cldlsplwin,nlwlz,lwlzin,
     & nswcld,cldtotswin,cldrasswin,cldlspswin,nswlz,swlzin,imstturbsw,
     & imstturblw,qliqaveswin,qliqavelwin,fccaveswin,fccavelwin,
     & rainconin,rainlspin,snowfallin,
     & duphy,dvphy,dthphy,dsphy)
c-----------------------------------------------------------------------
c Interface routine to calculate physics increments - calls fizhi_driver.
c Purpose of this routine is to set up arrays local to fizhi and 'save'
c them from one iteration to the next, and act as interface between the
c model common blocks (held in fizhi_wrapper) and fizhi_driver.
c Copies of variables that are 'shadowed' are made here without shadows
c for passing to fizhi_driver.
c Note: routine is called from inside a bi-bj loop
c
c-----------------------------------------------------------------------
      IMPLICIT NONE
#include "SIZE.h"
#include "fizhi_SIZE.h"
#include "chronos.h"

C Argument list declarations
      INTEGER myIter,myid,im1,im2,jm1,jm2,idim1,idim2,jdim1,jdim2
      INTEGER Nrphin,nSxIn,nSyIn,bi,bj,nchp
      LOGICAL turbStart
      INTEGER nchptot(nSxIn,nSyIn),nchpland(nSxIn,nSyIn)
      _RL uphy(idim1:idim2,jdim1:jdim2,Nrphin,nSxIn,nSyIn)
      _RL vphy(idim1:idim2,jdim1:jdim2,Nrphin,nSxIn,nSyIn)
      _RL thphy(idim1:idim2,jdim1:jdim2,Nrphin,nSxIn,nSyIn)
      _RL sphy(idim1:idim2,jdim1:jdim2,Nrphin,nSxIn,nSyIn)
      _RL pephy(idim1:idim2,jdim1:jdim2,Nrphin+1,nSxIn,nSyIn)
      _RS lons(idim1:idim2,jdim1:jdim2,nSxIn,nSyIn)
      _RS lats(idim1:idim2,jdim1:jdim2,nSxIn,nSyIn)
      _RS Zsurf(idim1:idim2,jdim1:jdim2,nSxIn,nSyIn)
      _RL ctmt(nchp,nSxIn,nSyIn),xxmt(nchp,nSxIn,nSyIn)
      _RL yymt(nchp,nSxIn,nSyIn)
      _RL zetamt(nchp,nSxIn,nSyIn)
      _RL xlmt(nchp,Nrphin,nSxIn,nSyIn),khmt(nchp,Nrphin,nSxIn,nSyIn)
      _RL tke(nchp,Nrphin,nSxIn,nSyIn)
      _RL tgz(im2,jm2,nSxIn,nSyIn)
      _RL sst(idim1:idim2,jdim1:jdim2,nSxIn,nSyIn)
      _RL sice(idim1:idim2,jdim1:jdim2,nSxIn,nSyIn)
      _RL phis_var(im2,jm2,nSxIn,nSyIn)
      INTEGER landtype(im2,jm2,nSxIn,nSyIn)
      _RL fracland(im2,jm2,nSxIn,nSyIn),emiss(im2,jm2,10,nSxIn,nSyIn)
      _RL albvisdr(im2,jm2,nSxIn,nSyIn),albvisdf(im2,jm2,nSxIn,nSyIn)
      _RL albnirdr(im2,jm2,nSxIn,nSyIn),albnirdf(im2,jm2,nSxIn,nSyIn)
      _RL chfr(nchp,nSxIn,nSyIn),alai(nchp,nSxIn,nSyIn)
      _RL agrn(nchp,nSxIn,nSyIn)
      INTEGER ityp(nchp,nSxIn,nSyIn),igrd(nchp,nSxIn,nSyIn)
      _RL chlat(nchp,nSxIn,nSyIn),chlon(nchp,nSxIn,nSyIn)
      _RL tcanopy(nchp,nSxIn,nSyIn),tdeep(nchp,nSxIn,nSyIn)
      _RL ecanopy(nchp,nSxIn,nSyIn),swetshal(nchp,nSxIn,nSyIn)
      _RL swetroot(nchp,nSxIn,nSyIn),swetdeep(nchp,nSxIn,nSyIn)
      _RL snodep(nchp,nSxIn,nSyIn),capac(nchp,nSxIn,nSyIn)
      _RL o3(im2,jm2,Nrphin,nSxIn,nSyIn)
      _RL qstr(im2,jm2,Nrphin,nSxIn,nSyIn)
      _RL co2,cfc11,cfc12,cfc22,n2o(Nrphin),methane(Nrphin)

      INTEGER iras(nSxIn,nSyIn)
      INTEGER nlwcld(nSxIn,nSyIn),nlwlz(nSxIn,nSyIn)
      INTEGER nswcld(nSxIn,nSyIn),nswlz(nSxIn,nSyIn)
      INTEGER imstturbsw(nSxIn,nSyIn),imstturblw(nSxIn,nSyIn)
      _RL cldtotlwin(idim1:idim2,jdim1:jdim2,Nrphin,nSxIn,nSyIn)
      _RL cldraslwin(idim1:idim2,jdim1:jdim2,Nrphin,nSxIn,nSyIn)
      _RL cldlsplwin(idim1:idim2,jdim1:jdim2,Nrphin,nSxIn,nSyIn)
      _RL lwlzin(idim1:idim2,jdim1:jdim2,Nrphin,nSxIn,nSyIn)
      _RL cldtotswin(idim1:idim2,jdim1:jdim2,Nrphin,nSxIn,nSyIn)
      _RL cldrasswin(idim1:idim2,jdim1:jdim2,Nrphin,nSxIn,nSyIn)
      _RL cldlspswin(idim1:idim2,jdim1:jdim2,Nrphin,nSxIn,nSyIn)
      _RL swlzin(idim1:idim2,jdim1:jdim2,Nrphin,nSxIn,nSyIn)
      _RL qliqaveswin(idim1:idim2,jdim1:jdim2,Nrphin,nSxIn,nSyIn)
      _RL qliqavelwin(idim1:idim2,jdim1:jdim2,Nrphin,nSxIn,nSyIn)
      _RL fccaveswin(idim1:idim2,jdim1:jdim2,Nrphin,nSxIn,nSyIn)
      _RL fccavelwin(idim1:idim2,jdim1:jdim2,Nrphin,nSxIn,nSyIn)
      _RL rainlspin(idim1:idim2,jdim1:jdim2,nSxIn,nSyIn)
      _RL rainconin(idim1:idim2,jdim1:jdim2,nSxIn,nSyIn)
      _RL snowfallin(idim1:idim2,jdim1:jdim2,nSxIn,nSyIn)


      _RL duphy(idim1:idim2,jdim1:jdim2,Nrphin,nSxIn,nSyIn)
      _RL dvphy(idim1:idim2,jdim1:jdim2,Nrphin,nSxIn,nSyIn)
      _RL dthphy(idim1:idim2,jdim1:jdim2,Nrphin,nSxIn,nSyIn)
      _RL dsphy(idim1:idim2,jdim1:jdim2,Nrphin,nSxIn,nSyIn)

c Local Variables
      INTEGER ptracer,ntracer
      PARAMETER (ptracer = 1)
      PARAMETER (ntracer = 1)

      _RL xlats(sNx,sNy),xlons(sNx,sNy),sea_ice(sNx,sNy)
      _RL surfZ(sNx,sNy)
      _RL p(sNx,sNy,nSx,nSy)
      _RL u(sNx,sNy,Nrphys),v(sNx,sNy,Nrphys),t(sNx,sNy,Nrphys)
      _RL q(sNx,sNy,Nrphys,ntracer)
      _RL pl(sNx,sNy,Nrphys,nSx,nSy),pkl(sNx,sNy,Nrphys,nSx,nSy)
      _RL ple(sNx,sNy,Nrphys+1,nSx,nSy)
      _RL pkle(sNx,sNy,Nrphys+1,nSx,nSy)
      _RL dpres(sNx,sNy,Nrphys,nSx,nSy)
      _RL lwdt(sNx,sNy,Nrphys,nSx,nSy)
      _RL lwdtclr(sNx,sNy,Nrphys,nSx,nSy)
      _RL swdt(sNx,sNy,Nrphys,nSx,nSy)
      _RL swdtclr(sNx,sNy,Nrphys,nSx,nSy)
      _RL turbu(sNx,sNy,Nrphys,nSx,nSy)
      _RL turbv(sNx,sNy,Nrphys,nSx,nSy)
      _RL turbt(sNx,sNy,Nrphys,nSx,nSy)
      _RL turbq(sNx,sNy,Nrphys,ntracer,nSx,nSy)
      _RL moistu(sNx,sNy,Nrphys,nSx,nSy)
      _RL moistv(sNx,sNy,Nrphys,nSx,nSy)
      _RL moistt(sNx,sNy,Nrphys,nSx,nSy)
      _RL moistq(sNx,sNy,Nrphys,ntracer,nSx,nSy)
      _RL radswt(sNx,sNy,nSx,nSy),radswg(sNx,sNy,nSx,nSy)
      _RL swgclr(sNx,sNy,nSx,nSy)
      _RL fdirpar(sNx,sNy,nSx,nSy),fdifpar(sNx,sNy,nSx,nSy)
      _RL osr(sNx,sNy,nSx,nSy),osrclr(sNx,sNy,nSx,nSy)
      _RL tg0(sNx,sNy,nSx,nSy),radlwg(sNx,sNy,nSx,nSy)
      _RL lwgclr(sNx,sNy,nSx,nSy),st4(sNx,sNy,nSx,nSy)
      _RL dst4(sNx,sNy,nSx,nSy),dlwdtg(sNx,sNy,Nrphys,nSx,nSy)
      _RL qq(sNx,sNy,Nrphys,nSx,nSy)
      INTEGER i,j,L
      _RL getcon, kappa, p0kappa, s0, ra
      _RL cosz(sNx,sNy)
      _RL cldtot_lw(sNx,sNy,Nrphys)
      _RL cldras_lw(sNx,sNy,Nrphys)
      _RL cldlsp_lw(sNx,sNy,Nrphys)
      _RL lwlz(sNx,sNy,Nrphys)
      _RL cldtot_sw(sNx,sNy,Nrphys)
      _RL cldras_sw(sNx,sNy,Nrphys)
      _RL cldlsp_sw(sNx,sNy,Nrphys)
      _RL swlz(sNx,sNy,Nrphys)
      _RL qliqavesw(sNx,sNy,Nrphys)
      _RL qliqavelw(sNx,sNy,Nrphys)
      _RL fccavesw(sNx,sNy,Nrphys)
      _RL fccavelw(sNx,sNy,Nrphys)
      _RL rainlsp(sNx,sNy)
      _RL raincon(sNx,sNy)
      _RL snowfall(sNx,sNy)

      _RL tempij(sNx,sNy)

      LOGICAL alarm
      EXTERNAL alarm

      COMMON /saver/ lwdt,lwdtclr,swdt,swdtclr,turbu,turbv,turbt,turbq
      COMMON /saver/ moistu,moistv,moistt,moistq
      COMMON /saver/ radswg,swgclr,fdirpar,fdifpar,osr,osrclr,tg0,radlwg
      COMMON /saver/ st4,dst4,dlwdtg,lwgclr
      COMMON /saver/ qq
      COMMON /saver/ p,pl,ple,dpres,pkle,pkl

C***********************************************************************
C Unshadow input arrays (and make 'fizhi theta' from true theta)
C***********************************************************************
      kappa = getcon('KAPPA')
      p0kappa = 1000.0 ** kappa
      S0 = getcon('S0')

      do j = jm1,jm2
      do i = im1,im2
       xlats(i,j) = lats(i,j,bi,bj)
       xlons(i,j) = lons(i,j,bi,bj)
       surfZ(i,j) = Zsurf(i,j,bi,bj)
      enddo
      enddo

#ifdef FIZHI_USE_FIXED_DAY
      call astro ( 20040321,nhms, xlats,xlons, im2*jm2, cosz,ra )
#else
      call astro ( nymd,nhms, xlats,xlons, im2*jm2, cosz,ra )
#endif
      do j=jm1,jm2
      do i=im1,im2
       radswt(i,j,bi,bj) = S0*(1.0/ra**2)*cosz(i,j)
      enddo
      enddo

      if( alarm('moist') .or. alarm('turb')   .or.
     &    alarm('radsw') .or. alarm('radlw') ) then

C compute pressures - all pressure are converted here to hPa
      do j = jm1,jm2
      do i = im1,im2
       ple(i,j,Nrphys+1,bi,bj) = pephy(i,j,Nrphys+1,bi,bj)/100.
       pkle(i,j,Nrphys+1,bi,bj)=(pephy(i,j,Nrphys+1,bi,bj)/100.) **kappa
       p(i,j,bi,bj) = pephy(i,j,Nrphys+1,bi,bj)/100.
       sea_ice(i,j) = sice(i,j,bi,bj)
       raincon(i,j) = rainconin(i,j,bi,bj)
       rainlsp(i,j) = rainlspin(i,j,bi,bj)
       snowfall(i,j) = snowfallin(i,j,bi,bj)
      enddo
      enddo
      do L = 1,Nrphys
      do j = jm1,jm2
      do i = im1,im2
       u(i,j,L) = uphy(i,j,L,bi,bj)
       v(i,j,L) = vphy(i,j,L,bi,bj)
       t(i,j,L) = thphy(i,j,L,bi,bj)/p0kappa
       q(i,j,L,1) = sphy(i,j,L,bi,bj)
       pl(i,j,L,bi,bj) = (pephy(i,j,L,bi,bj)+pephy(i,j,L+1,bi,bj))/200.
       dpres(i,j,L,bi,bj)=(pephy(i,j,L+1,bi,bj)-pephy(i,j,L,bi,bj))/100.
       ple(i,j,L,bi,bj) = pephy(i,j,L,bi,bj)/100.
       if (ple(i,j,L,bi,bj).gt.0.) then
        pkle(i,j,L,bi,bj) = ple(i,j,L,bi,bj) **kappa
       else
        pkle(i,j,L,bi,bj) = 0.
       endif
       cldtot_lw(i,j,L) = cldtotlwin(i,j,L,bi,bj)
       cldlsp_lw(i,j,L) = cldlsplwin(i,j,L,bi,bj)
       cldras_lw(i,j,L) = cldraslwin(i,j,L,bi,bj)
       lwlz(i,j,L) = lwlzin(i,j,L,bi,bj)
       qliqavelw(i,j,L) = qliqavelwin(i,j,L,bi,bj)
       fccavelw(i,j,L) = fccavelwin(i,j,L,bi,bj)
       cldtot_sw(i,j,L) = cldtotswin(i,j,L,bi,bj)
       cldlsp_sw(i,j,L) = cldlspswin(i,j,L,bi,bj)
       cldras_sw(i,j,L) = cldrasswin(i,j,L,bi,bj)
       swlz(i,j,L) = swlzin(i,j,L,bi,bj)
       qliqavesw(i,j,L) = qliqaveswin(i,j,L,bi,bj)
       fccavesw(i,j,L) = fccaveswin(i,j,L,bi,bj)
      enddo
      enddo
      enddo

      call pkappa (im2,jm2,Nrphys,ple(1,1,1,bi,bj),pkle(1,1,1,bi,bj),
     &                                                 pkl(1,1,1,bi,bj))

      call fizhi_driver(myid,im2,jm2,Nrphys,bi,bj,ptracer,ntracer,
     & turbStart, xlats, xlons,
     & p(1,1,bi,bj),u,v,t,q,pl(1,1,1,bi,bj),ple(1,1,1,bi,bj),
     & dpres(1,1,1,bi,bj),pkle(1,1,1,bi,bj),pkl(1,1,1,bi,bj),surfZ,
     & fracland(1,1,bi,bj),landtype(1,1,bi,bj),radswt(1,1,bi,bj),
     & phis_var(1,1,bi,bj),tgz(1,1,bi,bj),sea_ice,nchp,chlat(1,bi,bj),
     & chlon(1,bi,bj),igrd(1,bi,bj),nchptot(bi,bj),nchpland(bi,bj),
     & chfr(1,bi,bj),ityp(1,bi,bj),tcanopy(1,bi,bj),tdeep(1,bi,bj),
     & ecanopy(1,bi,bj),swetshal(1,bi,bj),swetroot(1,bi,bj),
     & swetdeep(1,bi,bj),capac(1,bi,bj),snodep(1,bi,bj),
     & ctmt(1,bi,bj),xxmt(1,bi,bj),yymt(1,bi,bj),zetamt(1,bi,bj),
     & xlmt(1,1,bi,bj),khmt(1,1,bi,bj),tke(1,1,bi,bj),
     & albvisdr(1,1,bi,bj),albvisdf(1,1,bi,bj),albnirdr(1,1,bi,bj),
     & albnirdf(1,1,bi,bj),emiss(1,1,1,bi,bj),alai(1,bi,bj),
     & agrn(1,bi,bj),
     & qstr(1,1,1,bi,bj),o3(1,1,1,bi,bj),
     & co2,cfc11,cfc12,cfc22,methane,n2o,
     & lwdt(1,1,1,bi,bj),lwdtclr(1,1,1,bi,bj),swdt(1,1,1,bi,bj),
     & swdtclr(1,1,1,bi,bj),turbu(1,1,1,bi,bj),turbv(1,1,1,bi,bj),
     & turbt(1,1,1,bi,bj),turbq(1,1,1,1,bi,bj),moistu(1,1,1,bi,bj),
     & moistv(1,1,1,bi,bj),moistt(1,1,1,bi,bj),moistq(1,1,1,1,bi,bj),
     & radswg(1,1,bi,bj),swgclr(1,1,bi,bj),fdirpar(1,1,bi,bj),
     & fdifpar(1,1,bi,bj),osr(1,1,bi,bj),osrclr(1,1,bi,bj),
     & tg0(1,1,bi,bj),radlwg(1,1,bi,bj),lwgclr(1,1,bi,bj),
     & st4(1,1,bi,bj),dst4(1,1,bi,bj),dlwdtg(1,1,1,bi,bj),
     & rainlsp,raincon,snowfall,iras(bi,bj),
     & nlwcld(bi,bj),cldtot_lw,cldras_lw,cldlsp_lw,nlwlz(bi,bj),lwlz,
     & nswcld(bi,bj),cldtot_sw,cldras_sw,cldlsp_sw,nswlz(bi,bj),swlz,
     & imstturbsw(bi,bj),imstturblw(bi,bj),qliqavesw,qliqavelw,
     & fccavesw,fccavelw,qq(1,1,1,bi,bj))

      do L = 1,Nrphys
      do j = jm1,jm2
      do i = im1,im2
       cldtotlwin(i,j,L,bi,bj) = cldtot_lw(i,j,L)
       cldlsplwin(i,j,L,bi,bj) = cldlsp_lw(i,j,L)
       cldraslwin(i,j,L,bi,bj) = cldras_lw(i,j,L)
       lwlzin(i,j,L,bi,bj) = lwlz(i,j,L)
       qliqavelwin(i,j,L,bi,bj) = qliqavelw(i,j,L)
       fccavelwin(i,j,L,bi,bj) = fccavelw(i,j,L)
       cldtotswin(i,j,L,bi,bj) = cldtot_sw(i,j,L)
       cldlspswin(i,j,L,bi,bj) = cldlsp_sw(i,j,L)
       cldrasswin(i,j,L,bi,bj) = cldras_sw(i,j,L)
       swlzin(i,j,L,bi,bj) = swlz(i,j,L)
       qliqaveswin(i,j,L,bi,bj) = qliqavesw(i,j,L)
       fccaveswin(i,j,L,bi,bj) = fccavesw(i,j,L)
      enddo
      enddo
      enddo

      do j = jm1,jm2
      do i = im1,im2
       rainconin(i,j,bi,bj) = raincon(i,j)
       rainlspin(i,j,bi,bj) = rainlsp(i,j)
       snowfallin(i,j,bi,bj) = snowfall(i,j)
      enddo
      enddo

      endif

      do L = 1,Nrphys
      do j = jm1,jm2
      do i = im1,im2
       duphy(i,j,L,bi,bj) = moistu(i,j,L,bi,bj) + turbu(i,j,L,bi,bj)
       dvphy(i,j,L,bi,bj) = moistv(i,j,L,bi,bj) + turbv(i,j,L,bi,bj)
       dthphy(i,j,L,bi,bj) = ((moistt(i,j,L,bi,bj)+turbt(i,j,L,bi,bj)+
     &   lwdt(i,j,L,bi,bj) +
     &   dlwdtg(i,j,L,bi,bj) * (tgz(i,j,bi,bj)-tg0(i,j,bi,bj)) +
     &   swdt(i,j,L,bi,bj)*radswt(i,j,bi,bj) )*p0kappa ) / p(i,j,bi,bj)
       dsphy(i,j,L,bi,bj) = (moistq(i,j,L,1,bi,bj)+turbq(i,j,L,1,bi,bj))
     &                                    /p(i,j,bi,bj)
      enddo
      enddo
      enddo

      call fizhi_step_diag(myid,p,u,v,t,q,qq,pkl,dpres,
     &  radswt,radswg,swgclr,osr,osrclr,st4,dst4,tgz,tg0,radlwg,lwgclr,
     &  turbu,turbv,turbt,turbq,moistu,moistv,moistt,moistq,
     &  lwdt,swdt,lwdtclr,swdtclr,dlwdtg,
     &  im1,im2,jm1,jm2,Nrphys,nSx,nSy,bi,bj,ntracer)

      return
      end

#include "PTRACERS_OPTIONS.h"

CBOP
C !ROUTINE: PTRACERS_FORCING_SURF

C !INTERFACE: ==========================================================
      SUBROUTINE PTRACERS_FORCING_SURF(
     I                            relaxForcingS,
     I                            bi, bj, iMin, iMax, jMin, jMax,
     I                            myTime,myIter,myThid )

C !DESCRIPTION:
C     Precomputes surface forcing term for pkg/ptracers.
C     Precomputation is needed because of non-local KPP transport term,
C     routine KPP_TRANSPORT_PTR.

C !USES: ===============================================================
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "SURFACE.h"
#include "DYNVARS.h"
#include "FFIELDS.h"
#include "PTRACERS_SIZE.h"
#include "PTRACERS_PARAMS.h"
#include "PTRACERS_START.h"
#include "PTRACERS_FIELDS.h"

C !INPUT PARAMETERS: ===================================================
C  relaxForcingS        :: Salt forcing due to surface relaxation
C  bi,bj                :: tile indices
C  myTime               :: model time
C  myIter               :: time-step number
C  myThid               :: thread number
      _RL relaxForcingS(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER bi, bj, iMin, iMax, jMin, jMax
      _RL myTime
      INTEGER myIter
      INTEGER myThid

#ifdef ALLOW_PTRACERS

C !LOCAL VARIABLES: ====================================================
C  i,j                  :: loop indices
C  iTrc                 :: tracer index
C  ks                   :: surface level index
      INTEGER i, j
      INTEGER iTrc, ks
      _RL add2EmP(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL epsil, cutoff, tmpVar
CEOP

      IF ( usingPCoords ) THEN
        ks = Nr
      ELSE
        ks = 1
      ENDIF

C Example of how to add forcing at the surface
      DO iTrc=1,PTRACERS_numInUse
c       IF ( PTRACERS_StepFwd(iTrc) ) THEN
          DO j = jMin, jMax
           DO i = iMin, iMax
             surfaceForcingPTr(i,j,bi,bj,iTrc) = 0. _d 0
     &                        + surfaceForcingS(i,j,bi,bj)
           ENDDO
          ENDDO
c       ENDIF
      ENDDO

C--   Option to convert Salt-relaxation into additional EmP contribution
      IF ( PTRACERS_addSrelax2EmP ) THEN
C-    here we assume that salt_EvPrRn = 0
C     set cutoff value to prevent too large additional EmP:
C       current limit is set to 0.1 CFL
        epsil = 1. _d -10
        cutoff = 0.1 _d 0 *drF(ks)/PTRACERS_dTLev(ks)
        IF ( ( (nonlinFreeSurf.GT.0 .OR. usingPCoords)
     &         .AND. useRealFreshWaterFlux )
     &     .OR.convertFW2Salt .EQ. -1. ) THEN
         DO j = jMin, jMax
          DO i = iMin, iMax
            tmpVar = MAX( salt(i,j,ks,bi,bj), epsil )
            add2EmP(i,j) = relaxForcingS(i,j)/tmpVar
            add2EmP(i,j) = rUnit2mass
     &                  *MAX( -cutoff, MIN( add2EmP(i,j), cutoff ) )
          ENDDO
         ENDDO
        ELSE
         DO j = jMin, jMax
          DO i = iMin, iMax
            add2EmP(i,j) = relaxForcingS(i,j)/convertFW2Salt
            add2EmP(i,j) = rUnit2mass
     &                  *MAX( -cutoff, MIN( add2EmP(i,j), cutoff ) )
          ENDDO
         ENDDO
        ENDIF
#ifdef ALLOW_DIAGNOSTICS
        IF ( useDiagnostics ) THEN
         CALL DIAGNOSTICS_FILL(add2EmP,'Add2EmP ',0,1,2,bi,bj,myThid)
        ENDIF
#endif /* ALLOW_DIAGNOSTICS */
      ELSE
        DO j = jMin, jMax
          DO i = iMin, iMax
            add2EmP(i,j) = 0. _d 0
          ENDDO
        ENDDO
      ENDIF
C-- end of "addEmP" setting

      IF ( (nonlinFreeSurf.GT.0 .OR. usingPCoords)
     &     .AND. useRealFreshWaterFlux ) THEN

       DO iTrc=1,PTRACERS_numInUse

c-  NonLin_FrSurf and RealFreshWaterFlux : PmEpR effectively changes
c   the water column height ; temp., salt, (tracer) flux associated
c   with this input/output of water is added here to the surface tendency.
c
         IF ( PTRACERS_StepFwd(iTrc) .AND.
     &        PTRACERS_EvPrRn(iTrc).NE.UNSET_RL ) THEN
          DO j = jMin, jMax
           DO i = iMin, iMax
             surfaceForcingPTr(i,j,bi,bj,iTrc) =
     &          surfaceForcingPTr(i,j,bi,bj,iTrc)
     &        + ( PmEpR(i,j,bi,bj) - add2EmP(i,j) )
     &          *( PTRACERS_EvPrRn(iTrc) - pTracer(i,j,ks,bi,bj,iTrc) )
     &          *mass2rUnit
           ENDDO
          ENDDO
         ENDIF

       ENDDO

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
      ELSE

C--   EmPmR does not really affect the water column height (for tracer budget)
C     and is converted to a salt tendency.

       IF (convertFW2Salt .EQ. -1.) THEN
C-    use local surface tracer field to calculate forcing term:

        DO iTrc=1,PTRACERS_numInUse

         IF ( PTRACERS_StepFwd(iTrc) .AND.
     &        PTRACERS_EvPrRn(iTrc).NE.UNSET_RL ) THEN
C        account for Rain/Evap tracer content (PTRACERS_EvPrRn) using
C        local surface tracer
          DO j = jMin, jMax
           DO i = iMin, iMax
            surfaceForcingPTr(i,j,bi,bj,iTrc) =
     &          surfaceForcingPTr(i,j,bi,bj,iTrc)
     &        + ( EmPmR(i,j,bi,bj) + add2EmP(i,j) )
     &          *( pTracer(i,j,ks,bi,bj,iTrc) - PTRACERS_EvPrRn(iTrc) )
     &          *mass2rUnit
           ENDDO
          ENDDO
         ENDIF

        ENDDO

       ELSE
C-    use uniform tracer value to calculate forcing term:

        DO iTrc=1,PTRACERS_numInUse

         IF ( PTRACERS_StepFwd(iTrc) .AND.
     &        PTRACERS_EvPrRn(iTrc).NE.UNSET_RL ) THEN
C     account for Rain/Evap tracer content (PTRACERS_EvPrRn) assuming uniform
C     surface tracer (=PTRACERS_ref)
          DO j = jMin, jMax
           DO i = iMin, iMax
            surfaceForcingPTr(i,j,bi,bj,iTrc) =
     &          surfaceForcingPTr(i,j,bi,bj,iTrc)
     &        + ( EmPmR(i,j,bi,bj) + add2EmP(i,j) )
     &            *( PTRACERS_ref(ks,iTrc) - PTRACERS_EvPrRn(iTrc) )
     &            *mass2rUnit
           ENDDO
          ENDDO
         ENDIF

        ENDDO

C-    end local-surface-tracer / uniform-value distinction
       ENDIF

      ENDIF

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#endif /* ALLOW_PTRACERS */

      RETURN
      END

#include "GMREDI_OPTIONS.h"

CBOP
C     !ROUTINE: GMREDI_INIT_FIXED
C     !INTERFACE:
      SUBROUTINE GMREDI_INIT_FIXED( myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE GMREDI_INIT_FIXED
C     | o Routine to initialize GM/Redi variables
C     |   that are kept fixed during the run.
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     === Global variables ===
#include "EEPARAMS.h"
#include "SIZE.h"
#include "PARAMS.h"
#include "GRID.h"
#include "GMREDI.h"

C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
C     myThid ::  my Thread Id number
      INTEGER myThid
CEOP

C     !FUNCTIUONS:
      INTEGER  ILNBLNK
      INTEGER  MDS_RECLEN
      EXTERNAL ILNBLNK
      EXTERNAL MDS_RECLEN

C     !LOCAL VARIABLES:
C     === Local variables ===
      INTEGER i,j,k
      INTEGER bi,bj

C--   Initialize arrays in common blocks :
      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
           GM_isoFac2d(i,j,bi,bj) = 1. _d 0
           GM_bolFac2d(i,j,bi,bj) = 1. _d 0
#ifdef GM_GEOM_VARIABLE_K
C     compute depth tapering only once
           GEOM_taper(i,j,bi,bj) = ( ( oneRL
     &     - TANH( ( R_low(i,j,bi,bj) - rF(1) + 800. _d 0 )/ 300. _d 0 )
     &                               )*halfRL )**2
#endif /* GM_GEOM_VARIABLE_K */
         ENDDO
        ENDDO
       ENDDO
      ENDDO

C--   Read horizontal 2.D scaling factors from files:
      IF ( GM_iso2dFile .NE. ' ' ) THEN
       CALL READ_FLD_XY_RS( GM_iso2dFile, ' ', GM_isoFac2d, 0, myThid )
       CALL EXCH_XY_RS( GM_isoFac2d, myThid )
      ENDIF
      IF ( GM_bol2dFile .NE. ' ' ) THEN
       CALL READ_FLD_XY_RS( GM_bol2dFile, ' ', GM_bolFac2d, 0, myThid )
       CALL EXCH_XY_RS( GM_bolFac2d, myThid )
      ENDIF

C--   Set vertical 1.D scaling factors
      _BEGIN_MASTER( myThid )

      DO k=1,Nr
        GM_isoFac1d(k) = 1. _d 0
        GM_bolFac1d(k) = 1. _d 0
      ENDDO

C-    Read vertical 1.D scaling factors from files:
      IF ( GM_iso1dFile .NE. ' ' ) THEN
        CALL READ_GLVEC_RS( GM_iso1dFile, ' ',
     &                      GM_isoFac1d, Nr, 1, myThid )
      ENDIF
      IF ( GM_bol1dFile .NE. ' ' ) THEN
        CALL READ_GLVEC_RS( GM_bol1dFile, ' ',
     &                      GM_bolFac1d, Nr, 1, myThid )
      ENDIF
      _END_MASTER( myThid )

C-    Everyone else must wait for arrays to be loaded
      _BARRIER

#ifdef GM_READ_K3D_REDI
C--   Initialize 3-D Isopycnal diffusivity in common block
      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
        DO k=1,Nr
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           GM_inpK3dRedi(i,j,k,bi,bj) = GM_isopycK
     &                  *GM_isoFac1d(k)*GM_isoFac2d(i,j,bi,bj)
          ENDDO
         ENDDO
        ENDDO
       ENDDO
      ENDDO
C--   Read 3-D Isopycnal diffusivity from file
      IF ( GM_K3dRediFile .NE. ' ' ) THEN
       CALL READ_FLD_XYZ_RL( GM_K3dRediFile, ' ',
     &                       GM_inpK3dRedi, 0, myThid )
       CALL EXCH_XYZ_RL( GM_inpK3dRedi, myThid )
       CALL WRITE_FLD_XYZ_RL( 'KapRedi', ' ', GM_inpK3dRedi, 0, myThid )
      ENDIF
#endif
#ifdef GM_READ_K3D_GM
C--   Initialize 3-D Thickness diffusivity in common block
      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
        DO k=1,Nr
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           GM_inpK3dGM(i,j,k,bi,bj) = GM_background_K
     &                  *GM_bolFac1d(k)*GM_bolFac2d(i,j,bi,bj)
          ENDDO
         ENDDO
        ENDDO
       ENDDO
      ENDDO
C--   Read 3-D Thickness diffusivity from file
      IF ( GM_K3dGMFile .NE. ' ' ) THEN
       CALL READ_FLD_XYZ_RL( GM_K3dGMFile, ' ',
     &                       GM_inpK3dGM, 0, myThid )
       CALL EXCH_XYZ_RL( GM_inpK3dGM, myThid )
       CALL WRITE_FLD_XYZ_RL( 'KapGM', ' ', GM_inpK3dGM, 0, myThid )
      ENDIF
#endif

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#ifdef ALLOW_MNC
      IF (useMNC) THEN
        CALL GMREDI_MNC_INIT( myThid )
      ENDIF
#endif /* ALLOW_MNC */

#ifdef ALLOW_DIAGNOSTICS
      IF ( useDiagnostics ) THEN
        CALL GMREDI_DIAGNOSTICS_INIT( myThid )
      ENDIF
#endif

      RETURN
      END

#include "PACKAGES_CONFIG.h"
#include "CPP_OPTIONS.h"
#ifdef ALLOW_EXCH2
# include "W2_OPTIONS.h"
#endif

CBOP
C     !ROUTINE: CALC_R_STAR
C     !INTERFACE:
      SUBROUTINE CALC_R_STAR( etaFld,
     I                        myTime, myIter, myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE CALC_R_STAR
C     | o Calculate new column thickness & scaling factor for r*
C     |   according to the surface r-position (Non-Lin Free-Surf)
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     == Global variables
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "SURFACE.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     etaFld    :: current eta field used to update the hFactor
C     myTime    :: current time in simulation
C     myIter    :: current iteration number in simulation
C     myThid    :: thread number for this instance of the routine.
      _RL etaFld(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL myTime
      INTEGER myIter
      INTEGER myThid

#ifdef NONLIN_FRSURF

C     !LOCAL VARIABLES:
C     Local variables
C     rStarAreaWeight :: use area weighted average for rStarFac at U & V point
C     i,j, bi,bj      :: loop counter
C     numbWrite       :: count the Number of warning written on STD-ERR file
C     numbWrMax       ::  maximum  Number of warning written on STD-ERR file
      LOGICAL rStarAreaWeight
      _RL maxhFacC
      INTEGER i,j,bi,bj
      INTEGER numbWrite, numbWrMax
      INTEGER icntc1, icntc2, icntw, icnts
      _RL tmpfldW, tmpfldS
CEOP

#ifdef W2_FILL_NULL_REGIONS
      INTEGER ii,jj
#endif
      DATA numbWrite / 0 /
      numbWrMax = Nx*Ny

      maxhFacC    = 0. _d 0

      rStarAreaWeight = .TRUE.
C-    Area-weighted average consistent with KE (& vert. advection):
      IF ( vectorInvariantMomentum .AND.
     &     (selectKEscheme.EQ.1 .OR. selectKEscheme.EQ.3)
     &   ) rStarAreaWeight =.FALSE.

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_ENTER('CALC_R_STAR',myThid)
#endif

      DO bj=myByLo(myThid), myByHi(myThid)
       DO bi=myBxLo(myThid), myBxHi(myThid)

C--   before updating rStarFacC/S/W save current fields
         DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
             rStarFacNm1C(i,j,bi,bj) = rStarFacC(i,j,bi,bj)
             rStarFacNm1S(i,j,bi,bj) = rStarFacS(i,j,bi,bj)
             rStarFacNm1W(i,j,bi,bj) = rStarFacW(i,j,bi,bj)
           ENDDO
         ENDDO

C-    1rst bi,bj loop :

C-- copy rStarFacX -> rStarExpX
        DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
            rStarExpC(i,j,bi,bj) = rStarFacC(i,j,bi,bj)
            rStarExpW(i,j,bi,bj) = rStarFacW(i,j,bi,bj)
            rStarExpS(i,j,bi,bj) = rStarFacS(i,j,bi,bj)
          ENDDO
        ENDDO

C-- Compute the new column thikness :
        DO j=0,sNy+1
         DO i=0,sNx+1
          IF (kSurfC(i,j,bi,bj).LE.Nr ) THEN
           rStarFacC(i,j,bi,bj) =
     &      (etaFld(i,j,bi,bj)+Ro_surf(i,j,bi,bj)-R_low(i,j,bi,bj))
     &      *recip_Rcol(i,j,bi,bj)
          ELSE
           rStarFacC(i,j,bi,bj) = 1.
          ENDIF
         ENDDO
        ENDDO
       IF ( rStarAreaWeight ) THEN
C-     Area weighted average
        DO j=1,sNy
         DO i=1,sNx+1
          IF ( kSurfW(i,j,bi,bj).LE.Nr ) THEN
           tmpfldW = rSurfW(i,j,bi,bj) - rLowW(i,j,bi,bj)
           rStarFacW(i,j,bi,bj) =
     &       ( 0.5 _d 0 *( etaFld(i-1,j,bi,bj)*rA(i-1,j,bi,bj)
     &                    +etaFld(i,j,bi,bj)*rA(i,j,bi,bj)
     &                   )*recip_rAw(i,j,bi,bj)
     &        +tmpfldW )/tmpfldW
          ELSE
           rStarFacW(i,j,bi,bj) = 1.
          ENDIF
         ENDDO
        ENDDO
        DO j=1,sNy+1
         DO i=1,sNx
          IF ( kSurfS(i,j,bi,bj).LE.Nr ) THEN
           tmpfldS = rSurfS(i,j,bi,bj) - rLowS(i,j,bi,bj)
           rStarFacS(i,j,bi,bj) =
     &       ( 0.5 _d 0 *( etaFld(i,j-1,bi,bj)*rA(i,j-1,bi,bj)
     &                    +etaFld(i,j,bi,bj)*rA(i,j,bi,bj)
     &                   )*recip_rAs(i,j,bi,bj)
     &        +tmpfldS )/tmpfldS
          ELSE
           rStarFacS(i,j,bi,bj) = 1.
          ENDIF
         ENDDO
        ENDDO
       ELSE
C-     Simple average
        DO j=1,sNy
         DO i=1,sNx+1
          IF ( kSurfW(i,j,bi,bj).LE.Nr ) THEN
           tmpfldW = rSurfW(i,j,bi,bj) - rLowW(i,j,bi,bj)
           rStarFacW(i,j,bi,bj) =
     &       ( 0.5 _d 0 *( etaFld(i-1,j,bi,bj) + etaFld(i,j,bi,bj) )
     &        +tmpfldW )/tmpfldW
          ELSE
           rStarFacW(i,j,bi,bj) = 1.
          ENDIF
         ENDDO
        ENDDO
        DO j=1,sNy+1
         DO i=1,sNx
          IF ( kSurfS(i,j,bi,bj).LE.Nr ) THEN
           tmpfldS = rSurfS(i,j,bi,bj) - rLowS(i,j,bi,bj)
           rStarFacS(i,j,bi,bj) =
     &       ( 0.5 _d 0 *( etaFld(i,j-1,bi,bj) + etaFld(i,j,bi,bj) )
     &        +tmpfldS )/tmpfldS
          ELSE
           rStarFacS(i,j,bi,bj) = 1.
          ENDIF
         ENDDO
        ENDDO
       ENDIF
#ifdef ALLOW_OBCS
       IF (useOBCS) THEN
         CALL OBCS_APPLY_R_STAR(
     I                    bi, bj, etaFld,
     U                    rStarFacC, rStarFacW, rStarFacS,
     I                    myTime, myIter, myThid )
       ENDIF
#endif /* ALLOW_OBCS */

C-    Needs to do something when r* ratio is too small ;
C     for now, just stop
        icntc1 = 0
        icntc2 = 0
        icntw  = 0
        icnts  = 0
        DO j=1,sNy+1
         DO i=1,sNx+1
          IF ( rStarFacC(i,j,bi,bj).LT.hFacInf ) THEN
            icntc1 = icntc1 + 1
          ENDIF
          IF ( rStarFacW(i,j,bi,bj).LT.hFacInf ) THEN
            icntw = icntw + 1
          ENDIF
          IF ( rStarFacS(i,j,bi,bj).LT.hFacInf ) THEN
            icnts = icnts + 1
          ENDIF
          IF ( rStarFacC(i,j,bi,bj).GT.hFacSup ) THEN
            icntc2 = icntc2 + 1
            maxhFacC = max(rStarFacC(i,j,bi,bj),maxhFacC)
          ENDIF
         ENDDO
        ENDDO

        IF ( icntc1+icnts+icntw .GT. 0 ) THEN
C-    Print an error msg and then stop:
         DO j=1,sNy+1
          DO i=1,sNx+1
           IF ( rStarFacC(i,j,bi,bj).LT.hFacInf ) THEN
            WRITE(errorMessageUnit,'(A,2I4,A,1F10.6,1P2E14.6)')
     &       ' fail at i,j=',i,j,' ; rStarFacC,H,eta =',
     &       rStarFacC(i,j,bi,bj),
     &       Ro_surf(i,j,bi,bj)-R_low(i,j,bi,bj),
     &       etaFld(i,j,bi,bj)
           ENDIF
           IF ( rStarFacW(i,j,bi,bj).LT.hFacInf ) THEN
            tmpfldW = rSurfW(i,j,bi,bj) - rLowW(i,j,bi,bj)
            WRITE(errorMessageUnit,'(A,2I4,A,1F10.6,1P3E14.6)')
     &       ' fail at i,j=',i,j,' ; rStarFacW,H,eta =',
     &        rStarFacW(i,j,bi,bj), tmpfldW,
     &        etaFld(i-1,j,bi,bj), etaFld(i,j,bi,bj)
           ENDIF
           IF ( rStarFacS(i,j,bi,bj).LT.hFacInf ) THEN
            tmpfldS = rSurfS(i,j,bi,bj) - rLowS(i,j,bi,bj)
            WRITE(errorMessageUnit,'(A,2I4,A,1F10.6,1P3E14.6)')
     &       ' fail at i,j=',i,j,' ; rStarFacS,H,eta =',
     &        rStarFacS(i,j,bi,bj), tmpfldS,
     &        etaFld(i,j-1,bi,bj), etaFld(i,j,bi,bj)
           ENDIF
          ENDDO
         ENDDO
         IF ( icntc1  .GT. 0 ) 
     &    WRITE(errorMessageUnit,'(A,I8,A,3I4,I10)')
     &     'WARNING: r*FacC < hFacInf at',icntc1,
     &     ' pts : bi,bj,Thid,Iter=',bi,bj,myThid,myIter
         IF ( icntw  .GT. 0 ) 
     &    WRITE(errorMessageUnit,'(A,I8,A,3I4,I10)')
     &     'WARNING: r*FacW < hFacInf at',icntw,
     &     ' pts : bi,bj,Thid,Iter=',bi,bj,myThid,myIter
         IF ( icnts  .GT. 0 ) 
     &    WRITE(errorMessageUnit,'(A,I8,A,3I4,I10)')
     &     'WARNING: r*FacS < hFacInf at',icnts,
     &     ' pts : bi,bj,Thid,Iter=',bi,bj,myThid,myIter
         WRITE(errorMessageUnit,'(A)')
     &    'STOP in CALC_R_STAR : too SMALL rStarFac[C,W,S] !'
         STOP 'ABNORMAL END: S/R CALC_R_STAR'
        ENDIF

C-- Usefull warning when r*Fac becomes very large:
        IF ( icntc2.GT.0 .AND. numbWrite.LE.numbWrMax ) THEN
         numbWrite = numbWrite + 1
         WRITE(errorMessageUnit,'(A,I8,A,3I4,I10)')
     &    'WARNING: r*FacC > hFacSup at',icntc2,
     &    ' pts : bi,bj,Thid,Iter=',bi,bj,myThid,myIter
         WRITE(errorMessageUnit,'(A,E14.6)')
     &    'WARNING: max(hFacC) is ',maxhFacC
        ENDIF

C-    end 1rst bi,bj loop.
       ENDDO
      ENDDO

       _EXCH_XY_RL( rStarFacC, myThid )
      CALL EXCH_UV_XY_RL(rStarFacW,rStarFacS,.FALSE.,myThid)

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      DO bj=myByLo(myThid), myByHi(myThid)
       DO bi=myBxLo(myThid), myBxHi(myThid)
C-    2nd bi,bj loop :

#ifdef ALLOW_EXCH2
#ifdef W2_FILL_NULL_REGIONS
C- Note: rStarFacC was non-zero EVERYWHERE before exch, but exch2 put zeros
C        in the corner regions of the tile (e.g.:[1-OLx:0,1-OLy:0])
C       => need to add those lines (or to fix exch2):
        DO j=1,OLy
         DO i=1,OLx
          ii = sNx+i
          jj = sNy+j

          IF (kSurfC(1-i,1-j,bi,bj).GT.Nr) rStarFacC(1-i,1-j,bi,bj)= 1.
          IF (kSurfC(ii, 1-j,bi,bj).GT.Nr) rStarFacC(ii, 1-j,bi,bj)= 1.
          IF (kSurfC(1-i,jj, bi,bj).GT.Nr) rStarFacC(1-i,jj, bi,bj)= 1.
          IF (kSurfC(ii, jj, bi,bj).GT.Nr) rStarFacC(ii, jj, bi,bj)= 1.

          IF (kSurfW(1-i,1-j,bi,bj).GT.Nr) rStarFacW(1-i,1-j,bi,bj)= 1.
          IF (kSurfW(ii, 1-j,bi,bj).GT.Nr) rStarFacW(ii, 1-j,bi,bj)= 1.
          IF (kSurfW(1-i,jj, bi,bj).GT.Nr) rStarFacW(1-i,jj, bi,bj)= 1.
          IF (kSurfW(ii, jj, bi,bj).GT.Nr) rStarFacW(ii, jj, bi,bj)= 1.

          IF (kSurfS(1-i,1-j,bi,bj).GT.Nr) rStarFacS(1-i,1-j,bi,bj)= 1.
          IF (kSurfS(ii, 1-j,bi,bj).GT.Nr) rStarFacS(ii, 1-j,bi,bj)= 1.
          IF (kSurfS(1-i,jj, bi,bj).GT.Nr) rStarFacS(1-i,jj, bi,bj)= 1.
          IF (kSurfS(ii, jj, bi,bj).GT.Nr) rStarFacS(ii, jj, bi,bj)= 1.

         ENDDO
        ENDDO
#endif /* W2_FILL_NULL_REGIONS */
#endif /* ALLOW_EXCH2 */

        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
           rStarDhCDt(i,j,bi,bj)=(rStarFacC(i,j,bi,bj)
     &                           -rStarExpC(i,j,bi,bj))/deltaTFreeSurf
           rStarDhWDt(i,j,bi,bj)=(rStarFacW(i,j,bi,bj)
     &                           -rStarExpW(i,j,bi,bj))/deltaTFreeSurf
           rStarDhSDt(i,j,bi,bj)=(rStarFacS(i,j,bi,bj)
     &                           -rStarExpS(i,j,bi,bj))/deltaTFreeSurf
           rStarExpC(i,j,bi,bj) = rStarFacC(i,j,bi,bj)
     &                          / rStarExpC(i,j,bi,bj)
           rStarExpW(i,j,bi,bj) = rStarFacW(i,j,bi,bj)
     &                          / rStarExpW(i,j,bi,bj)
           rStarExpS(i,j,bi,bj) = rStarFacS(i,j,bi,bj)
     &                          / rStarExpS(i,j,bi,bj)
         ENDDO
        ENDDO

        IF ( fluidIsAir ) THEN
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           pStarFacK(i,j,bi,bj) = rStarFacC(i,j,bi,bj)**atm_kappa
          ENDDO
         ENDDO
#ifdef ALLOW_AUTODIFF
        ELSE
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           pStarFacK(i,j,bi,bj) = 1. _d 0
          ENDDO
         ENDDO
#endif
        ENDIF

C-    end 2nd bi,bj loop.
        ENDDO
       ENDDO

#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_LEAVE('CALC_R_STAR',myThid)
#endif

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
#endif /* NONLIN_FRSURF */

      RETURN
      END

#include "ECCO_OPTIONS.h"

      subroutine cost_gencost_moc(myThid)

c     ==================================================================
c     SUBROUTINE cost_gencost_moc
c     ==================================================================
c
c     o Evaluate cost function contributions from MOC defined:
c
c       MOC_max = max_k { cumsum_k { zonally integrated meridional volume transport } }
c
c     o mybar loads trVol from barfile, which is masked by S/W edge mask
c       these masks denote the latitude line for taking zonal integral
c
c     ==================================================================
c     SUBROUTINE cost_gencost_moc
c     ==================================================================

      implicit none

c     == global variables ==

#include "EEPARAMS.h"
#include "SIZE.h"
#include "PARAMS.h"
#include "GRID.h"
#ifdef ALLOW_ECCO
# include "ECCO_SIZE.h"
# include "ECCO.h"
#endif

c     == routine arguments ==
      integer myThid

#ifdef ALLOW_GENCOST_CONTRIBUTION

c     == local variables ==

      integer nrecloc, ioUnit

      _RL mybar     (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      _RL gencost_mskTemporal
      _RL tmpVar(1), dummyRL
      _RS dummyRS(1)
      _RL tmpCumSumTile(Nr,nSx,nSy)
      _RL tmpNumTile(nSx,nSy)
      _RL tmpCumSumGlo(Nr)
      _RL tmpTile(nSx,nSy)
      _RL myTempMax

      character*(MAX_LEN_FNAM) mybarfile
      character*(MAX_LEN_MBUF) msgbuf
      character*(128) fname0

      integer kgen, kg3
      integer bi,bj
      integer i,j,k
      integer itlo,ithi
      integer jtlo,jthi
      integer imin, imax
      integer jmin, jmax
      integer irec
      integer il
      integer kmax
      logical doglobalread
      logical ladinit
      logical exst

c     == external functions ==

      integer  ilnblnk
      external ilnblnk

c     == end of interface ==

      jtlo = myByLo(myThid)
      jthi = myByHi(myThid)
      itlo = myBxLo(myThid)
      ithi = myBxHi(myThid)
      imin = 1
      imax = sNx
      jmin = 1
      jmax = sNy

CADJ  INIT tapelev_moc   = common, Nr

      do kgen=1,NGENCOST
        kg3 = gencost_pointer3d(kgen)

c-- detect the relevant gencost indices
        if ( (gencost_name(kgen)(1:3).EQ.'moc').AND.
     &     (using_gencost(kgen)) ) then

          write(msgbuf,'(A)') 'Inside cost_gencost_moc ...'
          CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )

          il=ilnblnk(gencost_barfile(kgen))
          write(msgbuf,'(A,i4,A,A)') 'Cost ',kgen,
     &    ': ',gencost_barfile(kgen)(1:il)
          CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                        SQUEEZE_RIGHT, myThid )

c=============== PART 0: initilization ===================

c-- local variables

        doglobalread = .false.
        ladinit = .false.
        dummyRL = gencost_dummy(kgen)
        nrecloc=gencost_nrec(kgen)
        il=ilnblnk(gencost_barfile(kgen))
        write(mybarfile,'(2a,i10.10)')
     &    gencost_barfile(kgen)(1:il),'.',eccoiter

c-- Initialize to zero
          DO bj = jtlo,jthi
            DO bi = itlo,ithi
              do k = 1, Nr
                tmpCumSumTile(k,bi,bj) = 0. _d 0
              enddo
              tmpNumTile(bi,bj) = 0. _d 0
            ENDDO
          ENDDO
c model mask[W,S]: already included in transp calc in ecco_phys
        nrecloc=gencost_nrec(kgen)

c=============== PART 1: main loop ===================
        do irec = 1,nrecloc

c-- Read barfile
#ifdef ALLOW_AUTODIFF
          call active_read_xyz( mybarfile, mybar, irec,
     &                       doglobalread, ladinit,
     &                       eccoiter, myThid,
     &                       dummyRL )
#else
          call READ_REC_XYZ_RL( mybarfile, mybar, irec,
     &                       1, myThid )
#endif /* ALLOW_AUTODIFF */

c-- Initialize after read

          DO bj = jtlo,jthi
            DO bi = itlo,ithi
              do k = 1, Nr
                tmpCumSumTile(k,bi,bj) = 0. _d 0
              enddo
              tmpNumTile(bi,bj) = 0. _d 0
            ENDDO
          ENDDO

c-- Temporal mask
          il = ilnblnk(gencost_mask(kgen))
          write(fname0(1:128),'(2A)')
     &      gencost_mask(kgen)(1:il),'T'
          inquire( file=fname0(1:il+1), exist=exst )

          if ( (.NOT.exst).OR.(gencost_mask(kgen).EQ.' ')
     &          ) then

           write(msgBuf,'(3A)') '**Warning: temporal msk file: ',
     &       fname0(1:il+1), ' not found, using 1/nrecloc'
           CALL PRINT_MESSAGE(msgBuf, standardMessageUnit,
     &         SQUEEZE_RIGHT, myThid )

           gencost_mskTemporal=nrecloc
           gencost_mskTemporal=1. _d 0 / gencost_mskTemporal
          else

           write(msgBuf,'(2A)') 'Using temporal msk from file: ',
     &          fname0(1:il+1)
           CALL PRINT_MESSAGE(msgBuf, standardMessageUnit,
     &          SQUEEZE_RIGHT, myThid )

           ioUnit = 0
           CALL MDS_READVEC_LOC( fname0, cost_iprec, ioUnit, 'RL',
     &                      1, tmpVar, dummyRS, 0, 0, irec, myThid )
           gencost_mskTemporal = tmpVar(1)
          endif

c=============== PART 2: Cost Computation ===================
c-- Compute cost only if nonzero temporal mask
          if ( gencost_mskTemporal .ne. 0 ) then

          if ( myProcId .EQ. 0 ) num_gencost(1,1,kgen)=
     &      num_gencost(1,1,kgen)+gencost_mskTemporal

c=============== PART 2.1: Cumulative sum ===================
c Take cumulative sum of my bar from bottom up
c i.e. compute the streamfunction (assuming mybar = trvol)
c
          DO bj = jtlo,jthi
            DO bi = itlo,ithi
              do k = Nr, 1, -1
                do j = jmin,jmax
                  do i = imin,imax
                    tmpCumSumTile(k,bi,bj)=tmpCumSumTile(k,bi,bj) -
     &                mybar(i,j,k,bi,bj)*gencost_mskTemporal

                    tmpNumTile(bi,bj)=
     &                tmpNumTile(bi,bj)+1. _d 0
                  enddo
                enddo
               if( k .lt. Nr ) then
                tmpCumSumTile(k,bi,bj)=tmpCumSumTile(k,bi,bj) +
     &            tmpCumSumTile(k+1,bi,bj)
               endif
              enddo
            ENDDO
          ENDDO

c-- Compute global sum at each level
          do k = Nr, 1, -1
            DO bj = jtlo,jthi
              DO bi = itlo,ithi
                tmpTile(bi,bj) = tmpCumSumTile(k,bi,bj)
              ENDDO
            ENDDO
            tmpCumSumGlo(k) = 0. _d 0
            CALL GLOBAL_SUM_TILE_RL(tmpTile, tmpCumSumGlo(k), myThid )
          enddo

c=============== PART 2.2: Get max val ===================
c-- Find maximum in global cumulative sum

          myTempMax = tmpCumSumGlo(1)
          kmax = 1

          do k = 2, Nr
CADJ STORE myTempMax = tapelev_moc, key = k
            if( myTempMax < tmpCumSumGlo(k) ) then
              myTempMax = tmpCumSumGlo(k)
              kmax = k
            endif
          enddo

          WRITE(msgBuf,'(2A,I3,A,1PE21.14,A,I2)')
     &        'moc cost ',gencost_barfile(kgen)(1:il),
     &        irec,' ', myTempMax, 'kmax: ',kmax
          CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                          SQUEEZE_RIGHT, myThid )

c=============== PART 2.3: Save to obj ===================
c-- Add MOC contribution to actual objective function variable
c   Note: using global values, so only want to store in
c         one processors obj function value

          if ( myProcId .EQ. 0 ) objf_gencost(1,1,kgen)=
     &      objf_gencost(1,1,kgen)+myTempMax

c============= Done with cost computation =====================

          else ! mskTemporal == 0

            WRITE(msgBuf,'(A,I3,A,I3)')
     &          'gencost_mskTemporal = 0, irec: ',irec, ' / ',
     &          nrecloc
          CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                          SQUEEZE_RIGHT, myThid )

          endif ! mskTemporal /=0
          enddo ! irec=1->nrecloc

c-- Print out what actually is used as cost function
          WRITE(msgBuf,'(A,1PE21.14)') 'moc fc: ',
     &          objf_gencost(1,1,kgen)
          CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                        SQUEEZE_RIGHT, myThid )

        endif ! gencost_name(kgen)=moc
      enddo ! kgen=1->NGENCOST

#endif /* ALLOW_GENCOST_CONTRIBUTION */

      return
      end

#include "GMREDI_OPTIONS.h"
#ifdef ALLOW_AUTODIFF
# include "AUTODIFF_OPTIONS.h"
#endif

CBOP
C     !ROUTINE: GMREDI_YTRANSPORT
C     !INTERFACE:
      SUBROUTINE GMREDI_YTRANSPORT(
     I     trIdentity, bi, bj, k,
     I     iMin, iMax, jMin, jMax,
     I     yA, maskFk, Tracer,
     U     df,
     I     myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | o SUBROUTINE GMREDI_YTRANSPORT
C     |   Add horizontal y transport terms from GM/Redi
C     |   parameterization.
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     == GLobal variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "GMREDI.h"
#include "GAD.h"
#ifdef ALLOW_LONGSTEP
#include "LONGSTEP.h"
#endif

#ifdef ALLOW_AUTODIFF_TAMC
# include "tamc.h"
# ifdef ALLOW_PTRACERS
#  include "PTRACERS_SIZE.h"
# endif
#endif /* ALLOW_AUTODIFF_TAMC */

C     !INPUT/OUTPUT PARAMETERS:
C     trIdentity :: tracer Id number
C     bi, bj     :: current tile indices
C     k          :: current level index
C     iMin,iMax  :: Range of 1rst index where results will be set
C     jMin,jMax  :: Range of 2nd  index where results will be set
C     yA         :: Area of Y face
C     maskFk     :: 2-D mask for vertical interface k (between level k-1 & k)
C     Tracer     :: 3D Tracer field
C     df         :: Diffusive flux component work array.
C     myThid     :: my Thread Id number
      INTEGER trIdentity
      INTEGER bi, bj, k
      INTEGER iMin, iMax, jMin, jMax
      _RS yA    (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RS maskFk(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL Tracer(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL df    (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER myThid
CEOP

#ifdef ALLOW_GMREDI
C     !LOCAL VARIABLES:
C     i, j       :: Loop counters
      INTEGER i, j
#if ( defined (GM_EXTRA_DIAGONAL) || defined (GM_BOLUS_ADVEC) )
      INTEGER kp1
      _RL maskp1
#endif
#ifdef GM_EXTRA_DIAGONAL
      INTEGER km1
      _RL dTdz(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
#endif
#ifdef GM_BOLUS_ADVEC
      _RL vTrans(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
#ifdef ALLOW_DIAGNOSTICS
      LOGICAL  DIAGNOSTICS_IS_ON
      EXTERNAL DIAGNOSTICS_IS_ON
      _RL tmp1k(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
#endif
#endif /* GM_BOLUS_ADVEC */
#ifdef ALLOW_AUTODIFF_TAMC
C     kkey :: tape key (depends on levels and tiles)
      INTEGER kkey
      CHARACTER*(MAX_LEN_MBUF) msgBuf
#endif

#ifdef ALLOW_AUTODIFF_TAMC
      kkey = bi + (bj-1)*nSx + (ikey_dynamics-1)*nSx*nSy
      kkey = trIdentity + (kkey-1)*maxpass
      kkey = k + (kkey-1)*Nr
      IF (trIdentity.GT.maxpass) THEN
       WRITE(msgBuf,'(A,2I5)')
     &      'GMREDI_YTRANSPORT: trIdentity > maxpass ',
     &      trIdentity, maxpass
       CALL PRINT_ERROR( msgBuf, myThid )
       STOP 'ABNORMAL END: S/R GMREDI_YTRANSPORT'
      ENDIF
#endif /* ALLOW_AUTODIFF_TAMC */

      IF (useGMRedi) THEN

#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE Kvy(:,:,k,bi,bj) =
CADJ &     comlev1_gmredi_k_gad, key=kkey, byte=isbyte
# ifdef GM_EXTRA_DIAGONAL
CADJ STORE Kvz(:,:,k,bi,bj) =
CADJ &     comlev1_gmredi_k_gad, key=kkey, byte=isbyte
# endif
#endif /* ALLOW_AUTODIFF_TAMC */

C--   Area integrated meridional flux
#ifdef ALLOW_LONGSTEP
      IF ( trIdentity .GE. GAD_TR1 ) THEN
       DO j=jMin,jMax
        DO i=iMin,iMax
         df(i,j) = df(i,j)
     &    -yA(i,j)
     &     *LS_Kvy(i,j,k,bi,bj)
     &     *_recip_dyC(i,j,bi,bj)*recip_deepFacC(k)
     &     *( Tracer(i,j,k) - Tracer(i,j-1,k) )
        ENDDO
       ENDDO
      ELSE
#endif /* ALLOW_LONGSTEP */
       DO j=jMin,jMax
        DO i=iMin,iMax
         df(i,j) = df(i,j)
     &    -yA(i,j)
     &     *Kvy(i,j,k,bi,bj)
     &     *_recip_dyC(i,j,bi,bj)*recip_deepFacC(k)
     &     *( Tracer(i,j,k) - Tracer(i,j-1,k) )
        ENDDO
       ENDDO
#ifdef ALLOW_LONGSTEP
      ENDIF
#endif /* ALLOW_LONGSTEP */

#ifdef GM_EXTRA_DIAGONAL
      IF ( GM_ExtraDiag ) THEN
       km1 = MAX(k-1,1)
       kp1 = MIN(k+1,Nr)
C-    Vertical gradients interpolated to V points
C     Note: no real needs for masking out with maskp1 when k=Nr since the Tracer
C           difference is already zero (k=kp1 in this case); but cleaner for
C           AD-code to ensure exactly zero contribution to Tracer AD var.
       maskp1 = 1. _d 0
       IF (k.GE.Nr) maskp1 = 0. _d 0
       DO j=jMin,jMax
        DO i=iMin,iMax
         dTdz(i,j) = op5*(
     &    +op5*recip_drC(k)*
     &        ( maskFk(i,j-1)*
     &            ( Tracer(i,j-1,km1)-Tracer(i,j-1,k) )
     &         +maskFk(i, j )*
     &            ( Tracer(i, j ,km1)-Tracer(i, j ,k) )
     &        )
     &    +op5*recip_drC(kp1)*
     &        ( maskC(i,j-1,k,bi,bj)*maskC(i,j-1,kp1,bi,bj)*maskp1*
     &            ( Tracer(i,j-1,k)-Tracer(i,j-1,kp1) )
     &         +maskC(i, j ,k,bi,bj)*maskC(i, j ,kp1,bi,bj)*maskp1*
     &            ( Tracer(i, j ,k)-Tracer(i, j ,kp1) )
     &        )          )
        ENDDO
       ENDDO
#ifdef GM_AUTODIFF_EXCESSIVE_STORE
CADJ STORE dTdz(:,:) =
CADJ &     comlev1_gmredi_k_gad, key=kkey, byte=isbyte
#endif
C-    Off-diagonal components of horizontal flux
#ifdef ALLOW_LONGSTEP
       IF ( trIdentity .GE. GAD_TR1 ) THEN
        DO j=jMin,jMax
         DO i=iMin,iMax
          df(i,j) = df(i,j) - yA(i,j)*LS_Kvz(i,j,k,bi,bj)*dTdz(i,j)
         ENDDO
        ENDDO
       ELSE
#endif /* ALLOW_LONGSTEP */
        DO j=jMin,jMax
         DO i=iMin,iMax
          df(i,j) = df(i,j) - yA(i,j)*Kvz(i,j,k,bi,bj)*dTdz(i,j)
         ENDDO
        ENDDO
#ifdef ALLOW_LONGSTEP
       ENDIF
#endif /* ALLOW_LONGSTEP */
      ENDIF
#endif /* GM_EXTRA_DIAGONAL */

#ifdef GM_BOLUS_ADVEC
      IF ( GM_AdvForm .AND. GM_AdvSeparate
     &                .AND. .NOT.GM_InMomAsStress ) THEN
C      Since bolus transport is computed as curl of stream-function, needs to
C      flip sign when using Left-Handed Coordinate system such as P-coordinate
c      flipSign4LHCoord = -gravitySign
       kp1 = MIN(k+1,Nr)
       maskp1 = 1. _d 0
       IF (k.GE.Nr) maskp1 = 0. _d 0
#ifdef ALLOW_LONGSTEP
       IF ( trIdentity .GE. GAD_TR1 ) THEN
        DO j=jMin,jMax
         DO i=iMin,iMax
          vTrans(i,j) = -gravitySign*dxG(i,j,bi,bj)
     &       *( LS_PsiY(i,j,kp1,bi,bj)*deepFacF(kp1)*maskp1
     &        - LS_PsiY(i,j, k, bi,bj)*deepFacF(k)
     &        )*maskS(i,j,k,bi,bj)
         ENDDO
        ENDDO
       ELSE
#endif /* ALLOW_LONGSTEP */
        DO j=jMin,jMax
         DO i=iMin,iMax
          vTrans(i,j) = -gravitySign*dxG(i,j,bi,bj)
     &       *( GM_PsiY(i,j,kp1,bi,bj)*deepFacF(kp1)*maskp1
     &        - GM_PsiY(i,j, k, bi,bj)*deepFacF(k)
     &        )*maskS(i,j,k,bi,bj)
         ENDDO
        ENDDO
#ifdef ALLOW_LONGSTEP
       ENDIF
#endif /* ALLOW_LONGSTEP */
#ifdef GM_AUTODIFF_EXCESSIVE_STORE
CADJ STORE vTrans(:,:) =
CADJ &     comlev1_gmredi_k_gad, key=kkey, byte=isbyte
#endif
       DO j=jMin,jMax
        DO i=iMin,iMax
         df(i,j) = df(i,j)
     &    + vTrans(i,j)*op5*( Tracer(i,j,k) + Tracer(i,j-1,k) )
        ENDDO
       ENDDO
      ENDIF

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#ifdef ALLOW_DIAGNOSTICS
      IF ( useDiagnostics .AND. trIdentity.EQ.1 .AND.
     &     DIAGNOSTICS_IS_ON( 'GM_vbT  ', myThid ) ) THEN
       kp1 = MIN(k+1,Nr)
       maskp1 = 1. _d 0
       IF (k.GE.Nr) maskp1 = 0. _d 0
       DO j=jMin,jMax
        DO i=iMin,iMax
         tmp1k(i,j) = -gravitySign*dxG(i,j,bi,bj)
     &      *( GM_PsiY(i,j,kp1,bi,bj)*deepFacF(kp1)*maskp1
     &       - GM_PsiY(i,j, k, bi,bj)*deepFacF(k)
     &       )*maskS(i,j,k,bi,bj)
     &        *op5*( Tracer(i,j,k) + Tracer(i,j-1,k) )
        ENDDO
       ENDDO
       CALL DIAGNOSTICS_FILL(tmp1k,'GM_vbT  ', k,1,2,bi,bj,myThid)
      ENDIF
#endif /* ALLOW_DIAGNOSTICS */

#endif /* GM_BOLUS_ADVEC */

      ENDIF
#endif /* ALLOW_GMREDI */

      RETURN
      END

#include "MNC_OPTIONS.h"
      
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 1
C     !ROUTINE: MNC_GRID_INIT

C     !INTERFACE:
      SUBROUTINE MNC_GRID_INIT( 
     I     fname, 
     I     gname, 
     I     ndim, 
     I     dnames, 
     I     myThid )

C     !DESCRIPTION:
C     Create an MNC grid within a NetCDF file context.
      
C     !USES:
      implicit none

C     !INPUT PARAMETERS:
      integer myThid, ndim
      character*(*) fname,gname
      character*(*) dnames(ndim)
CEOP

C     !LOCAL VARIABLES:
      integer ind

      CALL MNC_GRID_INIT_ALL(fname, gname, ndim, dnames, ind, myThid)

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 1
C     !ROUTINE: MNC_GRID_INIT_ALL

C     !INTERFACE:
      SUBROUTINE MNC_GRID_INIT_ALL( 
     I     fname, 
     I     gname, 
     I     ndim, 
     I     dnames, 
     O     ind, 
     I     myThid ) 

C     !DESCRIPTION:
C     Initialize a new conceptual (MNC inner layer) grid within a NetCDF
C     file context.  If the requested grid name already exists, then
C     verify that it has exactly the same number of dimensions, each
C     with exactly the same size and report a fatal error if not.  This
C     is a necessary check since the MNC inner layer does not support
C     grid name re--definition.

C     !USES:
      implicit none
#include "MNC_COMMON.h"
#include "EEPARAMS.h"
#include "netcdf.inc"

C     !INPUT PARAMETERS:
      integer myThid, ndim, ind
      character*(*) fname,gname
      character*(*) dnames(ndim)
CEOP

C     !LOCAL VARIABLES:
      integer i,j,k,ii,jj,kk, n,nf, indf,indg,indd, fid, ngrid
      integer ng_ind,lg_ind, ds_last, ndim_file, igr,ig1,ig2
      integer ngt, ngn
      character*(MAX_LEN_MBUF) msgbuf
      character*(MNC_MAX_PATH) file_name

C     Functions
      integer ILNBLNK

C     Get the file ID and indicies
      DO i =1,MNC_MAX_PATH
        file_name(i:i) = ' '
      ENDDO
      nf = ILNBLNK(fname)
      IF (nf .GT. MNC_MAX_PATH) nf = MNC_MAX_PATH
      file_name(1:nf) = fname(1:nf)
      CALL MNC_GET_IND(MNC_MAX_FID,file_name,mnc_f_names,indf,myThid)
      IF (indf .LT. 1) THEN
        write(msgbuf,'(3a)') 'MNC ERROR: file ''', file_name(1:nf), 
     &       ''' does not exist'
        CALL print_error( msgbuf, mythid )
        stop 'ABNORMAL END: S/R MNC_GRID_INIT'
      ENDIF
      fid = mnc_f_info(indf,2)
      ngrid = mnc_f_info(indf,3)
      ng_ind = 4 + 3*ngrid
      IF (ngrid .EQ. 0) THEN
        ds_last = 0
      ELSE
        lg_ind = 4 + 3*(ngrid - 1)
        ds_last = mnc_f_info(indf,(lg_ind+2))
      ENDIF

C     Check for sufficient space in memory
      i = ds_last + ndim
      j = 3 + 3*(ngrid + 1)
      IF ((i .GE. MNC_MAX_INFO) .OR. (j .GE. MNC_MAX_INFO)) THEN
        write(msgbuf,'(2a)') 'MNC_GRID_INIT_ALL ERROR: insufficient',
     &       ' space--please increase MNC_MAX_INFO'
        CALL print_error( msgbuf, mythid )
        stop 'ABNORMAL END: S/R MNC_GRID_INIT_ALL'
      ENDIF

C     Enter DEFINE mode
      CALL MNC_FILE_REDEF(fname, myThid)

      ngn = ILNBLNK(gname)

C     Check for grid re-definition
      DO igr = 1,mnc_f_info(indf,3)
        ii = 4 + 3*(igr - 1)
        ngt = ILNBLNK(mnc_g_names(mnc_f_info(indf,ii)))
        IF ( (ngt .EQ. ngn) 
     &       .AND. (mnc_g_names(mnc_f_info(indf,ii))(1:ngt) 
     &       .EQ. gname(1:ngn)) ) THEN

          ig1 = mnc_f_info(indf,ii+1)
          ig2 = mnc_f_info(indf,ii+2)

C         Check if different number of dims
          IF (ndim .NE. (ig2-ig1+1)) THEN
            kk = ILNBLNK( mnc_f_names(indf) )
            write(msgbuf,'(6a)') 'MNC ERROR: grid ''', gname(1:ngn),
     &           ''' was previously defined for file ''', 
     &           mnc_f_names(indf)(1:kk), ''' with a different ',
     &           'number of dimensions'
            CALL print_error(msgbuf, mythid)
            stop 'ABNORMAL END: S/R MNC_GRID_INIT'
          ENDIF

C         Check if same number of dims but different dim names
          k = 0
          DO jj = ig1,ig2
            k = k + 1
            IF (mnc_d_names(mnc_fd_ind(indf,jj)) .NE. dnames(k)) THEN
              kk = ILNBLNK( mnc_f_names(indf) )
              write(msgbuf,'(6a)') 'MNC ERROR: grid ''', gname(1:ngn),
     &             ''' was previously defined for file ''', 
     &             mnc_f_names(indf)(1:kk), ''' with a different ',
     &             'combination of dimensions'
              CALL print_error(msgbuf, mythid)
              stop 'ABNORMAL END: S/R MNC_GRID_INIT'
            ENDIF
          ENDDO

C         Reaching this point means that the grid name WAS previously
C         defined and the number and sizes of the associated dimensions
C         exactly match so everything is OK and we do not need to create
C         a new definition for this grid.
          RETURN

        ENDIF
      ENDDO

C     Reaching this point means the grid was NOT previously defined and
C     we must therefore create a new definition.
      CALL MNC_GET_NEXT_EMPTY_IND(MNC_MAX_ID, mnc_g_names,
     &     'mnc_g_names', indg, myThid)
      mnc_g_names(indg)(1:MNC_MAX_CHAR) =
     &     mnc_blank_name(1:MNC_MAX_CHAR)
      n = ILNBLNK(gname)
      mnc_g_names(indg)(1:n) = gname(1:n)
      
C     Add the dimensions
      DO i = 1,ndim

        j = ds_last + i
        n = ILNBLNK(dnames(i))

C       Search for the dimension ID within the list of dimensions
C       defined for this file
        ndim_file = mnc_f_alld(indf,1)
        indd = 0
        DO ii = 1,ndim_file
          jj = mnc_f_alld(indf,ii+1)
          kk = ILNBLNK(mnc_d_names(jj))
          IF ((n .EQ. kk) 
     &         .AND. (dnames(i)(1:n) .EQ. mnc_d_names(jj)(1:kk))) THEN
            indd = jj
            GOTO 20
          ENDIF
        ENDDO
 20     CONTINUE
        IF (indd .LT. 1) THEN
          write(msgbuf,'(5a)') 'MNC ERROR: dimension ''',
     &         dnames(i)(1:n), ''' does not exist for file ''', 
     &         fname(1:nf), ''''
          CALL print_error( msgbuf, mythid )
          stop 'ABNORMAL END: S/R MNC_GRID_INIT'
        ENDIF

        mnc_fd_ind(indf,j) = indd
        
      ENDDO

C     Grid successfully added, so update file table
      mnc_f_info(indf,ng_ind) = indg
      mnc_f_info(indf,ng_ind+1) = ds_last + 1
      mnc_f_info(indf,ng_ind+2) = ds_last + ndim
      mnc_f_info(indf,3) = ngrid + 1
      ind = indg
      
      RETURN
      END
      
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 1
C     !ROUTINE: MNC_GRID_GET_DIMIND

C     !INTERFACE:
      SUBROUTINE MNC_GRID_GET_DIMIND( 
     I     indf, 
     I     dname, 
     O     ind_fg_ids, 
     I     myThid )

C     !DESCRIPTION:
C     Get the dimension ID (index) for the named dimension.
      
C     !USES:
      implicit none
#include "MNC_COMMON.h"

C     !INPUT PARAMETERS:
      integer indf, ind_fg_ids, myThid
      character*(*) dname
CEOP

C     !LOCAL VARIABLES:
      integer i,j,k,l, n,n1, ngrid, ds,de

C     Functions
      integer ILNBLNK


      ind_fg_ids = -1
      n = ILNBLNK(dname)
      ngrid = mnc_f_info(indf,3)
      DO i = 1,ngrid
        j = 4 + 3*(i - 1)
        ds = mnc_f_info(indf,j+1)
        de = mnc_f_info(indf,j+2)
        DO k = ds,de
          l = mnc_fd_ind(indf,k)
          n1 = ILNBLNK(mnc_d_names(l))
          IF ((n .EQ. n1) 
     &         .AND. (mnc_d_names(l)(1:n1) .EQ. dname(1:n))) THEN
            ind_fg_ids = k
            RETURN
          ENDIF
        ENDDO
      ENDDO
      RETURN
      END
      
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#include "CHEAPAML_OPTIONS.h"
#ifdef ALLOW_THSICE
# include "THSICE_OPTIONS.h"
#endif
#ifdef ALLOW_SEAICE
# include "SEAICE_OPTIONS.h"
#endif

CBOP
C     !ROUTINE: CHEAPAML_SEAICE
C     !INTERFACE:
      SUBROUTINE CHEAPAML_SEAICE(
     I                    swDown, lwDown, uWind, vWind, LVapor,
     O                    fsha, flha, evp, xolw, ssqt, q100, cdq,
     O                    Tsurf, iceFrac, sw2oce,
     I                    bi, bj, myTime, myIter, myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R CHEAPAML_SEAICE
C     | o Compute fluxes over seaice by calling seaice routine
C     |   to solve for surface temperature.
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     == Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#ifdef ALLOW_THSICE
#include "THSICE_PARAMS.h"
#include "THSICE_SIZE.h"
#include "THSICE_VARS.h"
#endif
#ifdef ALLOW_SEAICE
# include "SEAICE_SIZE.h"
# include "SEAICE.h"
#endif

      INTEGER siLo, siHi, sjLo, sjHi
      PARAMETER ( siLo = 1-OLx , siHi = sNx+OLx )
      PARAMETER ( sjLo = 1-OLy , sjHi = sNy+OLy )

C     !INPUT PARAMETERS:
C     == Routine Arguments ==
C     swDown   :: incoming short-wave radiation (+=dw) [W/m2]
C     lwDown   :: incoming  long-wave radiation (+=dw) [W/m2]
C     uRelWind :: relative wind speed, u-component [m/s]
C     vRelWind :: relative wind speed, v-component [m/s]
C     LVapor   :: latent heat of vaporisation
C     bi, bj   :: tile indices
C     myIter   :: current iteration number
C     myTime   :: current time in simulation
C     myThid   :: my Thread Id number
      _RL  swDown(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL  lwDown(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL uWind(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL vWind(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL LVapor
      _RL myTime
      INTEGER bi, bj, myIter, myThid

C     !OUTPUT PARAMETERS:
C     fsha     :: sensible heat-flux over seaice (+=up) [W/m2]
C     flha     :: latent heat-flux over seaice   (+=up) [W/m2]
C     evp      :: evaporation over seaice     (+=up) [kg/m2/s]
C     xolw     :: upward long-wave over seaice   (+=up) [W/m2]
C     ssqt     ::
C     q100     ::
C     cdq      ::
C     Tsurf    :: updated seaice/snow surface temperature [deg.C]
C     iceFrac  :: ice fraction [0-1]
C     sw2oce   :: short-wave over seaice into the ocean (+=dw) [W/m2]
      _RL fsha(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL flha(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL evp (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL xolw(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL ssqt(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL q100(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL cdq (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL Tsurf(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL iceFrac(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RS sw2oce (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
c     _RL prcAtm(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)

#ifdef ALLOW_THSICE
C     !LOCAL VARIABLES:
C     == Local variables ==
C     uRelWind :: relative wind speed, u-component [m/s], (C-grid)
C     vRelWind :: relative wind speed, v-component [m/s], (C-grid)
C     windSq   :: relative wind speed squared (grid-cell center)
      INTEGER i, j
      INTEGER iceOrNot
      INTEGER iMin, iMax
      INTEGER jMin, jMax
      _RL LatentHeat
      _RL icFrac, opFrac
        _RL netSW (1:sNx,1:sNy)
        _RL sFlx  (1:sNx,1:sNy,0:2)
c       _RL tFrzOce(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
        _RL dTsurf(1:sNx,1:sNy)

        _RL uRelWind(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
        _RL vRelWind(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
        _RL windSq(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
        _RL cdu, dumArg(4)
        _RL fsha0(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
        _RL evp_0(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
        _RL xolw0(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
c       _RL ssqt0(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
c       _RL q10_0(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
c       _RL cdq_0(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
        _RL dShdTs(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
        _RL dEvdTs(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
        _RL dLwdTs(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
CEOP

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      iMin = 1
      iMax = sNx
      jMin = 1
      jMax = sNy
      LatentHeat = Lfresh + LVapor

c     DO bj=myByLo(myThid),myByHi(myThid)
c      DO bi=myBxLo(myThid),myBxHi(myThid)

        CALL THSICE_GET_OCEAN(
     I                         bi, bj, myTime, myIter, myThid )

        DO j = 1-OLy, sNy+OLy
          DO i = 1-OLx, sNx+OLx
            uRelWind(i,j) = uWind(i,j)
            vRelWind(i,j) = vWind(i,j)
          ENDDO
        ENDDO
#ifdef ALLOW_SEAICE
        IF ( useSEAICE ) THEN
         DO j = 1-OLy, sNy+OLy
          DO i = 1-OLx, sNx+OLx
            uRelWind(i,j) = uRelWind(i,j)-uIce(i,j,bi,bj)
            vRelWind(i,j) = vRelWind(i,j)-vIce(i,j,bi,bj)
          ENDDO
         ENDDO
        ENDIF
#endif /* ALLOW_SEAICE */
        DO j = jMin,jMax
          DO i = iMin,iMax
            windSq(i,j) = ( uRelWind( i ,j)*uRelWind( i ,j)
     &                    + uRelWind(i+1,j)*uRelWind(i+1,j)
     &                    + vRelWind(i, j )*vRelWind(i, j )
     &                    + vRelWind(i,j+1)*vRelWind(i,j+1)
     &                    )*0.5 _d 0
          ENDDO
        ENDDO

C   1) compute albedo ; compute netSW
       CALL THSICE_ALBEDO(
     I          bi, bj, siLo, siHi, sjLo, sjHi,
     I          iMin,iMax, jMin,jMax,
     I          iceMask(siLo,sjLo,bi,bj), iceHeight(siLo,sjLo,bi,bj),
     I          snowHeight(siLo,sjLo,bi,bj), Tsrf(siLo,sjLo,bi,bj),
     I          snowAge(siLo,sjLo,bi,bj),
     O          siceAlb(siLo,sjLo,bi,bj), icAlbNIR(siLo,sjLo,bi,bj),
     I          myTime, myIter, myThid )

       DO j = jMin, jMax
        DO i = iMin, iMax
         IF (iceMask(i,j,bi,bj).GT.0. _d 0) THEN
C-      surface net SW flux:
          netSW(i,j) = swDown(i,j)
     &               *(1. _d 0 - siceAlb(i,j,bi,bj))
         ELSE
          netSW(i,j) = swDown(i,j)
         ENDIF
        ENDDO
       ENDDO


C   2) compute other flx over seaice, over melting surf
C   3) compute other flx over seaice & derivative vs Tsurf, using previous Tsurf
         DO j = jMin, jMax
          DO i = iMin, iMax

            IF ( snowHeight(i,j,bi,bj).GT.3. _d -1 ) THEN
             iceornot=2
            ELSE
             iceornot=1
            ENDIF
            Tsurf(i,j) = 0.
            CALL CHEAPAML_COARE3_FLUX(
     I                    i, j, bi, bj, iceOrNot,
     I                    Tsurf, windSq,
     O                    fsha0(i,j), flha(i,j), evp_0(i,j), xolw0(i,j),
     O                    ssqt(i,j), q100(i,j), cdq(i,j), cdu,
     O                    dumArg(1), dumArg(2), dumArg(3), dumArg(4),
     I                    myIter, myThid )
            sFlx(i,j,0) = lwDown(i,j)- xolw0(i,j)
     &                  - fsha0(i,j) - evp_0(i,j)*LatentHeat

            Tsurf(i,j) = Tsrf(i,j,bi,bj)
            CALL CHEAPAML_COARE3_FLUX(
     I                    i, j, bi, bj, iceOrNot,
     I                    Tsurf, windSq,
     O                    fsha(i,j), flha(i,j), evp(i,j), xolw(i,j),
     O                    ssqt(i,j), q100(i,j), cdq(i,j), cdu,
     O              dShdTs(i,j), dEvdTs(i,j), dLwdTs(i,j), dumArg(4),
     I                   myIter, myThid )
            sFlx(i,j,1) = lwDown(i,j)- xolw(i,j)
     &                  - fsha(i,j) - evp(i,j)*LatentHeat
            sFlx(i,j,2) = -dLwdTs(i,j)
     &                  - dShdTs(i,j) - dEvdTs(i,j)*LatentHeat
          ENDDO
         ENDDO

C   4) solve for surf & seaice temp
C--    needs to fill in snowPrc, ( & prcAtm ? )
C--    note: this S/R  assumes No overlap
         CALL THSICE_IMPL_TEMP(
     I                netSW, sFlx,
     O                dTsurf,
     I                bi, bj, myTime, myIter, myThid )

C   5) update surf fluxes
        DO j = jMin, jMax
         DO i = iMin, iMax
          iceFrac(i,j) = iceMask(i,j,bi,bj)
          sw2oce (i,j) = icFlxSW(i,j,bi,bj)
          IF ( dTsurf(i,j) .GT. 999. ) THEN
c          dTsurf(J)= tFreeze - Tsurf(J)
           Tsurf(i,j)= 0.
           fsha(i,j) = fsha0(i,j)
           flha(i,j) = evp_0(i,j)*LatentHeat
           evp(i,j)  = evp_0(i,j)
           xolw(i,j) = xolw0(i,j)
          ELSE
           Tsurf(i,j)= Tsurf(i,j)+ dTsurf(i,j)
           fsha(i,j) = fsha(i,j) + dTsurf(i,j)*dShdTs(i,j)
           evp(i,j)  = evp(i,j)  + dTsurf(i,j)*dEvdTs(i,j)
           flha(i,j) = evp(i,j)*LatentHeat
           xolw(i,j) = xolw(i,j) + dTsurf(i,j)*dLwdTs(i,j)
          ENDIF
         ENDDO
        ENDDO

        DO j = jMin, jMax
         DO i = iMin, iMax
c         IF (iceMask(i,j,bi,bj).GT.0. _d 0) THEN
           icFrac  = iceMask(i,j,bi,bj)
           opFrac = 1. _d 0 - icFrac
C--    Update Fluxes :
           icFlxAtm(i,j,bi,bj) = netSW(i,j)
     &                         + lwDown(i,j)- xolw(i,j)
     &                         - fsha(i,j) - evp(i,j)*LVapor
           icFrwAtm(i,j,bi,bj) = evp(i,j)
c         ENDIF
         ENDDO
        ENDDO

c      ENDDO
c     ENDDO

#endif /* ALLOW_THSICE */
      RETURN
      END

#include "CPP_EEOPTIONS.h"

C--   File global_sum_tile.F: Routines that perform global sum
C                             on a tile array
C--    Contents
C--    o GLOBAL_SUM_TILE_RL
C--    o GLOBAL_SUM_TILE_RS <- not yet coded

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: GLOBAL_SUM_TILE_RL

C     !INTERFACE:
      SUBROUTINE GLOBAL_SUM_TILE_RL(
     I                       phiTile,
     O                       sumPhi,
     I                       myThid )

C     !DESCRIPTION:
C     *==========================================================*
C     | SUBROUTINE GLOBAL\_SUM\_TILE\_RL
C     | o Handle sum for _RL data.
C     *==========================================================*
C     | Apply sum on an array of one value per tile
C     |  and operate over all tiles & all the processes.
C     *==========================================================*

C     !USES:
      IMPLICIT NONE

C     == Global data ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "EESUPPORT.h"
#include "GLOBAL_SUM.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     phiTile :: Input array with one value per tile
C     sumPhi  :: Result of sum.
C     myThid  :: My thread id.
      _RL     phiTile(nSx,nSy)
      _RL     sumPhi
      INTEGER myThid

C     !LOCAL VARIABLES:
C     == Local variables ==
C     bi,bj   :: Loop counters
C     mpiRC   :: MPI return code
C- type declaration of: sumMyPr, sumAllP, localBuf and shareBufGSR8 :
C         all 4 needs to have the same length as MPI_DOUBLE_PRECISION
      INTEGER bi,bj
#ifdef ALLOW_USE_MPI
#ifdef GLOBAL_SUM_SEND_RECV
      INTEGER biG, bjG, np, pId
      INTEGER lbuff, idest, itag, ready_to_receive
      INTEGER istatus(MPI_STATUS_SIZE), ierr
      Real*8  localBuf (nSx,nSy)
      Real*8  globalBuf(nSx*nPx,nSy*nPy)
#elif defined (GLOBAL_SUM_ORDER_TILES)
      INTEGER biG, bjG, lbuff
      Real*8  localBuf (nSx*nPx,nSy*nPy)
      Real*8  globalBuf(nSx*nPx,nSy*nPy)
#endif
      INTEGER mpiRC
#endif /* ALLOW_USE_MPI */
      Real*8  sumMyPr
      Real*8  sumAllP
CEOP

C     this barrier is not necessary:
c     CALL BAR2( myThid )

C--   write local sum into shared-buffer array
      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
         shareBufGSR8(bi,bj) = phiTile(bi,bj)
       ENDDO
      ENDDO

C--   Master thread cannot start until everyone is ready:
      CALL BAR2( myThid )
      _BEGIN_MASTER( myThid )

#if (defined GLOBAL_SUM_SEND_RECV && defined ALLOW_USE_MPI )
      IF ( usingMPI ) THEN

        lbuff = nSx*nSy
        idest = 0
        itag  = 0
        ready_to_receive = 0

        IF ( mpiMyId.NE.0 ) THEN

C--   All proceses except 0 wait to be polled then send local array
#ifndef DISABLE_MPI_READY_TO_RECEIVE
          CALL MPI_RECV (ready_to_receive, 1, MPI_INTEGER,
     &         idest, itag, MPI_COMM_MODEL, istatus, ierr)
#endif
          CALL MPI_SEND (shareBufGSR8, lbuff, MPI_DOUBLE_PRECISION,
     &         idest, itag, MPI_COMM_MODEL, ierr)

C--   All proceses except 0 receive result from process 0
          CALL MPI_RECV (sumAllP, 1, MPI_DOUBLE_PRECISION,
     &         idest, itag, MPI_COMM_MODEL, istatus, ierr)

        ELSE
C-      case mpiMyId = 0

C--   Process 0 fills-in its local data
         np = 1
         DO bj=1,nSy
          DO bi=1,nSx
            biG = (mpi_myXGlobalLo(np)-1)/sNx+bi
            bjG = (mpi_myYGlobalLo(np)-1)/sNy+bj
            globalBuf(biG,bjG) = shareBufGSR8(bi,bj)
          ENDDO
         ENDDO

C--   Process 0 polls and receives data from each process in turn
         DO np = 2, nPx*nPy
          pId = np - 1
#ifndef DISABLE_MPI_READY_TO_RECEIVE
          CALL MPI_SEND (ready_to_receive, 1, MPI_INTEGER,
     &           pId, itag, MPI_COMM_MODEL, ierr)
#endif
          CALL MPI_RECV (localBuf, lbuff, MPI_DOUBLE_PRECISION,
     &           pId, itag, MPI_COMM_MODEL, istatus, ierr)

C--   Process 0 gathers the local arrays into a global array.
          DO bj=1,nSy
           DO bi=1,nSx
             biG = (mpi_myXGlobalLo(np)-1)/sNx+bi
             bjG = (mpi_myYGlobalLo(np)-1)/sNy+bj
             globalBuf(biG,bjG) = localBuf(bi,bj)
           ENDDO
          ENDDO
C-       end loop on np
         ENDDO

C--   Sum over all tiles:
         sumAllP = 0.
         DO bjG = 1,nSy*nPy
          DO biG = 1,nSx*nPx
           sumAllP = sumAllP + globalBuf(biG,bjG)
          ENDDO
         ENDDO

C--   Process 0 sends result to all other processes
         lbuff = 1
         DO np = 2, nPx*nPy
          pId = np - 1
          CALL MPI_SEND (sumAllP, 1, MPI_DOUBLE_PRECISION,
     &                   pId, itag, MPI_COMM_MODEL, ierr)
         ENDDO

C       End if/else mpiMyId = 0
        ENDIF

      ELSE
#elif (defined GLOBAL_SUM_ORDER_TILES && defined ALLOW_USE_MPI )
      IF ( usingMPI ) THEN

C--   Initialise local buffer
        DO bjG=1,nSy*nPy
         DO biG=1,nSx*nPx
           localBuf(biG,bjG) = 0.
         ENDDO
        ENDDO

C--   Put my own data in local buffer
        DO bj=1,nSy
         DO bi=1,nSx
           biG = (myXGlobalLo-1)/sNx+bi
           bjG = (myYGlobalLo-1)/sNy+bj
           localBuf(biG,bjG) = shareBufGSR8(bi,bj)
         ENDDO
        ENDDO

C--   Collect data from all procs
        lbuff = nSx*nPx*nSy*nPy
        CALL MPI_Allreduce( localBuf, globalBuf, lbuff,
     &           MPI_DOUBLE_PRECISION, MPI_SUM, MPI_COMM_MODEL, mpiRC )

C--   Sum over all tiles:
         sumAllP = 0.
         DO bjG = 1,nSy*nPy
          DO biG = 1,nSx*nPx
           sumAllP = sumAllP + globalBuf(biG,bjG)
          ENDDO
         ENDDO

      ELSE
#else /* not ((GLOBAL_SUM_SEND_RECV | GLOBAL_SUM_ORDER_TILES) & ALLOW_USE_MPI) */
      IF ( .TRUE. ) THEN
#endif /* not ((GLOBAL_SUM_SEND_RECV | GLOBAL_SUM_ORDER_TILES) & ALLOW_USE_MPI) */

C--   Sum over all tiles (of the same process) first
        sumMyPr = 0.
        DO bj = 1,nSy
         DO bi = 1,nSx
          sumMyPr = sumMyPr + shareBufGSR8(bi,bj)
         ENDDO
        ENDDO

C     in case MPI is not used:
        sumAllP = sumMyPr

#ifdef ALLOW_USE_MPI
        IF ( usingMPI ) THEN
         CALL MPI_Allreduce(sumMyPr,sumAllP,1,MPI_DOUBLE_PRECISION,
     &                      MPI_SUM,MPI_COMM_MODEL,mpiRC)
        ENDIF
#endif /* ALLOW_USE_MPI */

      ENDIF

C--   Write solution to shared buffer (all threads can see it)
c     shareBufGSR8(1,1) = sumAllP
      phiGSR8(1,0) = sumAllP

      _END_MASTER( myThid )
C--   Everyone wait for Master thread to be ready
      CALL BAR2( myThid )

C--   set result for every threads
c     sumPhi = shareBufGSR8(1,1)
      sumPhi = phiGSR8(1,0)

C--   A barrier was needed here to prevent thread 1 to modify shareBufGSR8(1,1)
C     (as it would in the following call to this S/R) before all threads get
C     their global-sum result out.
C     No longer needed since a dedicated shared var. is used to share the output
c     CALL BAR2( myThid )

      RETURN
      END

#include "CPP_EEOPTIONS.h"

CBOP
C     !ROUTINE: INI_PROCS

C     !INTERFACE:
      SUBROUTINE INI_PROCS

C     !DESCRIPTION:
C     *==========================================================*
C     | SUBROUTINE INI\_PROCS
C     | o Initialise multiple concurrent processes environment.
C     *==========================================================*
C     | Under MPI this routine calls various MPI service routines
C     | that map the model grid to MPI processes. The information
C     | is then stored in a common block for later use.
C     | Note: This routine can also be compiled with CPP
C     | directives set so that no multi-processing is initialise.
C     | This is OK and should work fine.
C     *==========================================================*

C     !USES:
      IMPLICIT NONE
C     === Global data ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "EESUPPORT.h"

#ifdef ALLOW_USE_MPI
C     !FUNCTIONS:

C     !LOCAL VARIABLES:
C     === Local variables ===
C     msgBuf         :: IO buffer
C     myThid         :: Dummy thread id
C     mpiRC          :: Error code reporting variable used with MPI.
C     mpiGridSpec    :: No. of processes in X and Y.
C     mpiPeriodicity :: Flag indicating XY priodicity to MPI.
C     arrElSize      :: Size of an array element in bytes used to define
C                       MPI datatypes for communication operations.
C     arrElSep       :: Separation in units of array elements between
C                       blocks to be communicated.
C     elCount        :: No. of blocks that are associated with MPI datatype.
C     elLen          :: Length of an MPI datatype in terms of preexisting
C                       datatype.
C     elStride       :: Distance between starting location of elements in
C                       an MPI datatype - can be bytes of datatype units.
      INTEGER mpiRC
      INTEGER mpiGridSpec(2)
      INTEGER mpiPeriodicity(2)
      INTEGER mpiLProcNam
      CHARACTER*(MPI_MAX_PROCESSOR_NAME) mpiProcNam
      INTEGER arrElSize
      INTEGER arrElSep
      INTEGER elCount
      INTEGER elLen
      INTEGER elStride
      INTEGER np, pId, itemp(2)
      INTEGER ierr
      INTEGER iTmp, jTmp
      CHARACTER*(23) fmtStr
#endif /* ALLOW_USE_MPI */
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      INTEGER myThid
CEOP

C--   Default values set to single processor case
C     pid[W-SE] are the MPI process id of the neighbor processes.
C     A process can be its own neighbor!
      myThid      = 1
      myPid       = 0
      nProcs      = 1
      myPx        = 1
      myPy        = 1
      myXGlobalLo = 1
      myYGlobalLo = 1
      pidW        = 0
      pidE        = 0
      pidN        = 0
      pidS        = 0
c     errorMessageUnit    = 0
c     standardMessageUnit = 6

      IF ( usingMPI ) THEN
#ifdef ALLOW_USE_MPI
C--
C--   MPI style full multiple-process initialisation
C--   ==============================================

C--    Arrange MPI processes on a cartesian grid
C      Set variable indicating which MPI process is to the north,
C      south, east, west, south-west, south-east, north-west
C      and north-east of me e.g.
C
C      Plan view of model domain centered on process ME
C      ================================================
C
C            :         :         :        :
C            :         :         :        :
C            :         :         :        :
C       .....------------------------------.....
C            |         |         |        |
C            |  NW     |   N     |  NE    |
C            |         |         |        |
C       .....------------------------------.....
C            |         |         |        |
C            |  W      |   ME    |  E     |
C            |         |         |        |
C       .....------------------------------.....
C            |         |         |        |
C            |  SW     |   S     |  SE    |
C            |         |         |        |
C       .....------------------------------.....
C  Y         :         :         :        :
C / \        :         :         :        :
C  |         :         :         :        :
C  |
C  |----> X
C
C--    Set default MPI communicator to XY processor grid
       mpiGridSpec(1) = nPx
       mpiGridSpec(2) = nPy
C      Could be periodic in X and/or Y - set at run time or compile time!
       mpiPeriodicity(1) = _mpiTRUE_
       mpiPeriodicity(2) = _mpiTRUE_
#ifdef CAN_PREVENT_X_PERIODICITY
#ifndef ALWAYS_PREVENT_X_PERIODICITY
       IF ( notUsingXPeriodicity ) THEN
#endif
        mpiPeriodicity(1) = _mpiFALSE_
#ifndef ALWAYS_PREVENT_X_PERIODICITY
       ENDIF
#endif
#endif /* CAN_PREVENT_X_PERIODICITY */
#ifdef  CAN_PREVENT_Y_PERIODICITY
#ifndef ALWAYS_PREVENT_Y_PERIODICITY
       IF ( notUsingYPeriodicity ) THEN
#endif
        mpiPeriodicity(2) = _mpiFALSE_
#ifndef ALWAYS_PREVENT_Y_PERIODICITY
       ENDIF
#endif
#endif /* CAN_PREVENT_Y_PERIODICITY */

       CALL MPI_CART_CREATE(
     I  MPI_COMM_MODEL,2,mpiGridSpec,mpiPeriodicity,_mpiTRUE_,
     O  mpiComm, mpiRC )
       IF ( mpiRC .NE. MPI_SUCCESS ) THEN
        eeBootError = .TRUE.
        WRITE(msgBuf,'(A,I5)')
     &        'S/R INI_PROCS: MPI_CART_CREATE return code',
     &        mpiRC
        CALL PRINT_ERROR( msgBuf, myThid )
        GOTO 999
       ENDIF

C--    Get my location on the grid
       CALL MPI_CART_COORDS( mpiComm, mpiMyId, 2, mpiGridSpec, mpiRC )
       IF ( mpiRC .NE. MPI_SUCCESS ) THEN
        eeBootError = .TRUE.
        WRITE(msgBuf,'(A,I5)')
     &        'S/R INI_PROCS: MPI_CART_COORDS return code',
     &        mpiRC
        CALL PRINT_ERROR( msgBuf, myThid )
        GOTO 999
       ENDIF
       myPid = mpiMyId
       mpiPx = mpiGridSpec(1)
       mpiPy = mpiGridSpec(2)
       mpiXGlobalLo = 1 + sNx*nSx*(mpiPx)
       mpiYGlobalLo = 1 + sNy*nSy*(mpiPy)
       myXGlobalLo  = mpiXGlobalLo
       myYGlobalLo  = mpiYGlobalLo

C--   To speed-up mpi gather and scatter routines, myXGlobalLo
C     and myYGlobalLo from each process are transferred to
C     a common block array.  This allows process 0 to know
C     the location of the domains controlled by each process.
       DO np = 1, nPx*nPy
          itemp(1) = myXGlobalLo
          itemp(2) = myYGlobalLo
          pId = np - 1
          CALL MPI_BCAST(itemp, 2, MPI_INTEGER, pId,
     &         MPI_COMM_MODEL, ierr)
          mpi_myXGlobalLo(np) = itemp(1)
          mpi_myYGlobalLo(np) = itemp(2)
       ENDDO

       myPx = mpiPx+1
       myPy = mpiPy+1
C--    Get MPI id for neighboring procs.
       mpiGridSpec(1) = mpiPx-1
       IF ( mpiPeriodicity(1) .EQ. _mpiTRUE_
     &   .AND. mpiGridSpec(1) .LT. 0 )
     &  mpiGridSpec(1) = nPx-1
       mpiGridSpec(2) = mpiPy

#ifdef ALLOW_NEST_CHILD
      IF ( useNEST_CHILD) THEN
       IF ( mpiPeriodicity(1) .EQ. _mpiFALSE_
     &      .AND. mpiGridSpec(1) .LT. 0 )
     &      mpiGridSpec(1) =  0
      ENDIF
#endif /* ALLOW_NEST_CHILD */

       CALL MPI_CART_RANK( mpiComm, mpiGridSpec, mpiPidW , mpiRC )
       IF ( mpiRC .NE. MPI_SUCCESS ) THEN
        eeBootError = .TRUE.
        WRITE(msgBuf,'(A,I5)')
     &        'S/R INI_PROCS: MPI_CART_RANK (pidW) return code',
     &        mpiRC
        CALL PRINT_ERROR( msgBuf, myThid )
        GOTO 999
       ENDIF
       pidW = mpiPidW
       mpiGridSpec(1) = mpiPx+1
       IF ( mpiPeriodicity(1) .EQ. _mpiTRUE_
     &   .AND. mpiGridSpec(1) .GT. nPx-1 )
     &  mpiGridSpec(1) = 0
       mpiGridSpec(2) = mpiPy

#ifdef ALLOW_NEST_CHILD
      IF ( useNEST_CHILD) THEN
       IF ( mpiPeriodicity(1) .EQ. _mpiFALSE_
     &   .AND. mpiGridSpec(1) .GT. nPx-1 )
     &    mpiGridSpec(1) = nPx-1
      ENDIF
#endif /* ALLOW_NEST_CHILD */

       CALL MPI_CART_RANK( mpiComm, mpiGridSpec, mpiPidE , mpiRC )
       IF ( mpiRC .NE. MPI_SUCCESS ) THEN
        eeBootError = .TRUE.
        WRITE(msgBuf,'(A,I5)')
     &        'S/R INI_PROCS: MPI_CART_RANK (pidE) return code',
     &        mpiRC
        CALL PRINT_ERROR( msgBuf, myThid )
        GOTO 999
       ENDIF
       pidE = mpiPidE
       mpiGridSpec(1) = mpiPx
       mpiGridSpec(2) = mpiPy-1
       IF ( mpiPeriodicity(2) .EQ. _mpiTRUE_
     &   .AND. mpiGridSpec(2) .LT. 0 )
     &  mpiGridSpec(2) = nPy - 1
       CALL MPI_CART_RANK( mpiComm, mpiGridSpec, mpiPidS , mpiRC )
       IF ( mpiRC .NE. MPI_SUCCESS ) THEN
        eeBootError = .TRUE.
        WRITE(msgBuf,'(A,I5)')
     &        'S/R INI_PROCS: MPI_CART_RANK (pidS) return code',
     &        mpiRC
        CALL PRINT_ERROR( msgBuf, myThid )
        GOTO 999
       ENDIF
       pidS = mpiPidS
       mpiGridSpec(1) = mpiPx
       mpiGridSpec(2) = mpiPy+1
       IF ( mpiPeriodicity(2) .EQ. _mpiTRUE_
     &   .AND. mpiGridSpec(2) .GT. nPy-1 )
     &  mpiGridSpec(2) = 0
       CALL MPI_CART_RANK( mpiComm, mpiGridSpec, mpiPidN , mpiRC )
       IF ( mpiRC .NE. MPI_SUCCESS ) THEN
        eeBootError = .TRUE.
        WRITE(msgBuf,'(A,I5)')
     &        'S/R INI_PROCS: MPI_CART_RANK (pidN) return code',
     &        mpiRC
        CALL PRINT_ERROR( msgBuf, myThid )
        GOTO 999
       ENDIF
       pidN = mpiPidN

C--    Print summary of processor mapping on standard output
       CALL MPI_GET_PROCESSOR_NAME( mpiProcNam, mpilProcNam, mpiRC )
       IF ( mpiRC .NE. MPI_SUCCESS ) THEN
        eeBootError = .TRUE.
        WRITE(msgBuf,'(A,I5)')
     &        'S/R INI_PROCS: MPI_GET_PROCESSOR_NAME return code',
     &        mpiRC
        CALL PRINT_ERROR( msgBuf, myThid )
        GOTO 999
       ENDIF
       WRITE(msgBuf,'(A)')
     &   '======= Starting MPI parallel Run ========='
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                     SQUEEZE_BOTH , myThid )
       WRITE(msgBuf,'(A,I3,A,A)') ' My Processor Name (len:',
     &  mpilProcNam, ' ) = ', mpiProcNam(1:mpilProcNam)
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                     SQUEEZE_RIGHT , myThid )
       iTmp = MAX(3,1 + INT(LOG10(DFLOAT(nPx*nPy))))
       WRITE(fmtStr,'(4(A,I1),A)')
     &  '(A,I',iTmp,',A,I',iTmp,',A,I',iTmp,',A,I',iTmp,',A)'
       WRITE(msgBuf,fmtStr) ' Located at (', mpiPx,',',mpiPy,
     &  ') on processor grid (0:',nPx-1,',0:',nPy-1,')'
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                     SQUEEZE_RIGHT , myThid )
       iTmp = MAX(6,1 + INT(LOG10(DFLOAT(nPx*sNx*nSx))))
       jTmp = MAX(6,1 + INT(LOG10(DFLOAT(nPy*sNy*nSy))))
       WRITE(fmtStr,'(4(A,I1),A)')
     &  '(A,I',iTmp,',A,I',jTmp,',A,I',iTmp,',A,I',jTmp,',A)'
       WRITE(msgBuf,fmtStr) ' Origin at  (',
     &  mpiXGlobalLo,',',mpiYGLobalLo,
     &  ') on global grid (1:',nPx*sNx*nSx,',1:',nPy*sNy*nSy,')'
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                     SQUEEZE_RIGHT , myThid )
       iTmp = MAX(4,1 + INT(LOG10(DFLOAT(nPx*nPy))))
       WRITE(fmtStr,'(2(A,I1),A)') '(A,I',iTmp,'.',iTmp,')'
       WRITE(msgBuf,fmtStr) ' North neighbor = processor ', mpiPidN
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                     SQUEEZE_RIGHT , myThid )
       WRITE(msgBuf,fmtStr) ' South neighbor = processor ', mpiPidS
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                     SQUEEZE_RIGHT , myThid )
       WRITE(msgBuf,fmtStr) '  East neighbor = processor ', mpiPidE
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                     SQUEEZE_RIGHT , myThid )
       WRITE(msgBuf,fmtStr) '  West neighbor = processor ', mpiPidW
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                     SQUEEZE_RIGHT , myThid )

C--    Create MPI types for transfer of array edges.
C--    Four and eight byte primitive (one block only) datatypes.
C--    These are common to all threads in the process.
C      Notes:
C      ======
C      1. The datatypes MPI_REAL4 and MPI_REAL8 are usually predefined.
C      If they are not defined code must be added to create them -
C      the MPI standard leaves optional whether they exist.
C      2. Per thread datatypes that handle all the edges for a thread
C      are defined based on the type defined here.

C--    xFace datatypes (east<-->west messages)
C--
C      xFace (y=constant) for XY arrays with real*4 declaration.
       arrElSep  = (sNx+OLx*2)
       elCount   = sNy+OLy*2
       elLen     = OLx
       elStride  = arrElSep
#if (defined (TARGET_SGI) || defined (TARGET_AIX) || defined(TARGET_LAM))
       CALL MPI_TYPE_VECTOR(elCount,elLen,elStride,MPI_REAL,
     &                       mpiTypeXFaceBlock_xy_r4, mpiRC)
#else
       CALL MPI_TYPE_VECTOR(elCount,elLen,elStride,MPI_REAL4,
     &                       mpiTypeXFaceBlock_xy_r4, mpiRC)
#endif
       IF ( mpiRC .NE. MPI_SUCCESS ) THEN
        eeBootError = .TRUE.
        WRITE(msgBuf,'(A,I5)')
     &   'S/R INI_PROCS: MPI_TYPE_VECTOR (mpiTypeXFaceBlock_xy_r4)',
     &        mpiRC
        CALL PRINT_ERROR( msgBuf, myThid )
       ENDIF
       CALL MPI_TYPE_COMMIT( mpiTypeXFaceBlock_xy_r4, mpiRC)
       IF ( mpiRC .NE. MPI_SUCCESS ) THEN
        eeBootError = .TRUE.
        WRITE(msgBuf,'(A,I5)')
     &   'S/R INI_PROCS: MPI_TYPE_COMMIT (mpiTypeXFaceBlock_xy_r4)',
     &        mpiRC
        CALL PRINT_ERROR( msgBuf, myThid )
       ENDIF

C      xFace (y=constant) for XY arrays with real*8 declaration.
#if (defined (TARGET_SGI) || defined (TARGET_AIX) || defined(TARGET_LAM))
       CALL MPI_TYPE_VECTOR(elCount,elLen,elStride,MPI_DOUBLE_PRECISION,
     &                       mpiTypeXFaceBlock_xy_r8, mpiRC)
#else
       CALL MPI_TYPE_VECTOR(elCount,elLen,elStride,MPI_REAL8,
     &                       mpiTypeXFaceBlock_xy_r8, mpiRC)
#endif
       IF ( mpiRC .NE. MPI_SUCCESS ) THEN
        eeBootError = .TRUE.
        WRITE(msgBuf,'(A,I5)')
     &   'S/R INI_PROCS: MPI_TYPE_VECTOR (mpiTypeXFaceBlock_xy_r8)',
     &        mpiRC
        CALL PRINT_ERROR( msgBuf, myThid )
       ENDIF
       CALL MPI_TYPE_COMMIT( mpiTypeXFaceBlock_xy_r8, mpiRC)
       IF ( mpiRC .NE. MPI_SUCCESS ) THEN
        eeBootError = .TRUE.
        WRITE(msgBuf,'(A,I5)')
     &   'S/R INI_PROCS: MPI_TYPE_COMMIT (mpiTypeXFaceBlock_xy_r8)',
     &        mpiRC
        CALL PRINT_ERROR( msgBuf, myThid )
       ENDIF

C      xFace (y=constant) for XYZ arrays with real*4 declaration.
       arrElSize = 4
       arrElSep  = (sNx+OLx*2)*(sNy+OLy*2)
       elCount   = Nr
       elLen     = 1
       elStride  = arrElSize*arrElSep
       CALL MPI_TYPE_HVECTOR(elCount,elLen,elStride,
     &                        mpiTypeXFaceBlock_xy_r4,
     &                       mpiTypeXFaceBlock_xyz_r4, mpiRC)
       IF ( mpiRC .NE. MPI_SUCCESS ) THEN
        eeBootError = .TRUE.
        WRITE(msgBuf,'(A,I5)')
     &   'S/R INI_PROCS: MPI_TYPE_HVECTOR (mpiTypeXFaceBlock_xyz_r4)',
     &        mpiRC
        CALL PRINT_ERROR( msgBuf, myThid )
       ENDIF
       CALL MPI_TYPE_COMMIT( mpiTypeXFaceBlock_xyz_r4, mpiRC)
       IF ( mpiRC .NE. MPI_SUCCESS ) THEN
        eeBootError = .TRUE.
        WRITE(msgBuf,'(A,I5)')
     &   'S/R INI_PROCS: MPI_TYPE_COMMIT  (mpiTypeXFaceBlock_xyz_r4)',
     &        mpiRC
        CALL PRINT_ERROR( msgBuf, myThid )
       ENDIF

C      xFace (y=constant) for XYZ arrays with real*8 declaration.
       arrElSize = 8
       elStride  = arrElSize*arrElSep
       CALL MPI_TYPE_HVECTOR(elCount,elLen,elStride,
     &                        mpiTypeXFaceBlock_xy_r8,
     &                       mpiTypeXFaceBlock_xyz_r8, mpiRC)
       IF ( mpiRC .NE. MPI_SUCCESS ) THEN
        eeBootError = .TRUE.
        WRITE(msgBuf,'(A,I5)')
     &   'S/R INI_PROCS: MPI_TYPE_HVECTOR (mpiTypeXFaceBlock_xyz_r8)',
     &        mpiRC
        CALL PRINT_ERROR( msgBuf, myThid )
       ENDIF
       CALL MPI_TYPE_COMMIT( mpiTypeXFaceBlock_xyz_r8, mpiRC)
       IF ( mpiRC .NE. MPI_SUCCESS ) THEN
        eeBootError = .TRUE.
        WRITE(msgBuf,'(A,I5)')
     &   'S/R INI_PROCS: MPI_TYPE_COMMIT (mpiTypeXFaceBlock_xyz_r8)',
     &        mpiRC
        CALL PRINT_ERROR( msgBuf, myThid )
       ENDIF

C--    yFace datatypes (north<-->south messages)
C--
C      yFace (x=constant) for XY arrays with real*4 declaration
       elCount  = OLy*(sNx+OLx*2)
#if (defined (TARGET_SGI) || defined (TARGET_AIX) || defined(TARGET_LAM))
       CALL MPI_TYPE_CONTIGUOUS(elCount,MPI_REAL,
     &                          mpiTypeYFaceBlock_xy_r4, mpiRC)
#else
       CALL MPI_TYPE_CONTIGUOUS(elCount,MPI_REAL4,
     &                          mpiTypeYFaceBlock_xy_r4, mpiRC)
#endif
       IF ( mpiRC .NE. MPI_SUCCESS ) THEN
        eeBootError = .TRUE.
        WRITE(msgBuf,'(A,I5)')
     &   'S/R INI_PROCS: MPI_TYPE_CONTIGUOUS (mpiTypeYFaceBlock_xy_r4)',
     &        mpiRC
        CALL PRINT_ERROR( msgBuf, myThid )
       ENDIF
       CALL MPI_TYPE_COMMIT( mpiTypeYFaceBlock_xy_r4, mpiRC)
       IF ( mpiRC .NE. MPI_SUCCESS ) THEN
        eeBootError = .TRUE.
        WRITE(msgBuf,'(A,I5)')
     &   'S/R INI_PROCS: MPI_TYPE_COMMIT (mpiTypeYFaceBlock_xy_r4)',
     &        mpiRC
        CALL PRINT_ERROR( msgBuf, myThid )
       ENDIF
C      yFace (x=constant) for XY arrays with real*8 declaration
#if (defined (TARGET_SGI) || defined (TARGET_AIX) || defined(TARGET_LAM))
       CALL MPI_TYPE_CONTIGUOUS(elCount,MPI_DOUBLE_PRECISION,
     &                          mpiTypeYFaceBlock_xy_r8, mpiRC)
#else
       CALL MPI_TYPE_CONTIGUOUS(elCount,MPI_REAL8,
     &                          mpiTypeYFaceBlock_xy_r8, mpiRC)
#endif
       IF ( mpiRC .NE. MPI_SUCCESS ) THEN
        eeBootError = .TRUE.
        WRITE(msgBuf,'(A,I5)')
     &   'S/R INI_PROCS: MPI_TYPE_CONTIGUOUS (mpiTypeYFaceBlock_xy_r8)',
     &        mpiRC
        CALL PRINT_ERROR( msgBuf, myThid )
       ENDIF
       CALL MPI_TYPE_COMMIT( mpiTypeYFaceBlock_xy_r8, mpiRC)
       IF ( mpiRC .NE. MPI_SUCCESS ) THEN
        eeBootError = .TRUE.
        WRITE(msgBuf,'(A,I5)')
     &   'S/R INI_PROCS: MPI_TYPE_COMMIT (mpiTypeYFaceBlock_xy_r8)',
     &        mpiRC
        CALL PRINT_ERROR( msgBuf, myThid )
       ENDIF
C      yFace (x=constant) for XYZ arrays with real*4 declaration
       arrElSize = 4
       arrElSep  = (sNx+OLx*2)*(sNy+OLy*2)
       elCount   = Nr
       elLen     = 1
       elStride  = arrElSize*arrElSep
       CALL MPI_TYPE_HVECTOR(elCount,elLen,elStride,
     &                        mpiTypeYFaceBlock_xy_r4,
     &                       mpiTypeYFaceBlock_xyz_r4, mpiRC)
       IF ( mpiRC .NE. MPI_SUCCESS ) THEN
        eeBootError = .TRUE.
        WRITE(msgBuf,'(A,I5)')
     &   'S/R INI_PROCS: MPI_TYPE_HVECTOR (mpiTypeYFaceBlock_xyz_r4)',
     &        mpiRC
        CALL PRINT_ERROR( msgBuf, myThid )
       ENDIF
       CALL MPI_TYPE_COMMIT( mpiTypeYFaceBlock_xyz_r4, mpiRC)
       IF ( mpiRC .NE. MPI_SUCCESS ) THEN
        eeBootError = .TRUE.
        WRITE(msgBuf,'(A,I5)')
     &   'S/R INI_PROCS: MPI_TYPE_COMMIT (mpiTypeYFaceBlock_xyz_r4)',
     &        mpiRC
        CALL PRINT_ERROR( msgBuf, myThid )
       ENDIF
C      yFace (x=constant) for XYZ arrays with real*8 declaration
       arrElSize = 8
       elStride  = arrElSize*arrElSep
       CALL MPI_TYPE_HVECTOR(elCount,elLen,elStride,
     &                        mpiTypeYFaceBlock_xy_r8,
     &                       mpiTypeYFaceBlock_xyz_r8, mpiRC)
       IF ( mpiRC .NE. MPI_SUCCESS ) THEN
        eeBootError = .TRUE.
        WRITE(msgBuf,'(A,I5)')
     &   'S/R INI_PROCS: MPI_TYPE_HVECTOR (mpiTypeYFaceBlock_xyz_r8)',
     &        mpiRC
        CALL PRINT_ERROR( msgBuf, myThid )
       ENDIF
       CALL MPI_TYPE_COMMIT( mpiTypeYFaceBlock_xyz_r8, mpiRC)
       IF ( mpiRC .NE. MPI_SUCCESS ) THEN
        eeBootError = .TRUE.
        WRITE(msgBuf,'(A,I5)')
     &   'S/R INI_PROCS: MPI_TYPE_COMMIT (mpiTypeYFaceBlock_xyz_r8)',
     &        mpiRC
        CALL PRINT_ERROR( msgBuf, myThid )
       ENDIF

C--    Assign MPI values used in generating unique tags for messages.
       mpiTagW    = 1
       mpiTagE    = 2
       mpiTagS    = 3
       mpiTagN    = 4

       CALL MPI_Barrier(MPI_COMM_MODEL,mpiRC)

#endif /* ALLOW_USE_MPI */
      ELSE
C--   Case without using MPI (usingMPI=F)

C--   case without tile-communication (DISCONNECTED_TILES defined) is not
C     yet coded for multi-procs; for now, just stop if multi-procs domain
       IF ( nPx*nPy .NE. 1 ) THEN
        eeBootError = .TRUE.
        WRITE(msgBuf,'(2A,I6,A)') 'INI_PROCS: ',
     &    'needs MPI for multi-procs (nPx*nPy=',  nPx*nPy, ') setup'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(2A)') 'INI_PROCS: ',
     &    ' but presently usingMPI = False (in "eedata")'
        CALL PRINT_ERROR( msgBuf, myThid )
        GOTO 999
       ENDIF

C--   End if usingMPI
      ENDIF

 999  CONTINUE

      RETURN
      END

#include "CTRL_OPTIONS.h"

      SUBROUTINE CTRL_SET_GLOBFLD_XZ(
     I                fname, nRecArg, filePrec, myThid )

C     ==================================================================
C     SUBROUTINE ctrl_set_globfld_xz
C     ==================================================================
C
C     o initialise field
C
C     started: heimbach@mit.edu, 16-Aug-2001
C
C     changed: heimbach@mit.edu 17-Jun-2003
C              merged changes from Armin to replace write of
C              nr * globfld2d by 1 * globfld3d
C              (ad hoc fix to speed up global I/O)
C
C     ==================================================================

      IMPLICIT NONE

C     == global variables ==
#include "EEPARAMS.h"
#include "SIZE.h"
c#include "PARAMS.h"
c#include "CTRL_SIZE.h"
c#include "CTRL.h"
#include "OPTIMCYCLE.h"

C     == routine arguments ==
      CHARACTER*(MAX_LEN_FNAM) fname
      INTEGER nRecArg
      INTEGER filePrec
      INTEGER myThid

C     == local variables ==
      INTEGER bi, bj
      INTEGER i, j, k
      INTEGER irec, nrec_nl
c     _RS dummyRS(1)
      _RL globfld3d(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      _RL globfldxz(1-OLx:sNx+OLx,Nr,nSx,nSy)

C     == end of interface ==

      DO bj = myByLo(myThid), myByHi(myThid)
        DO bi = myBxLo(myThid), myBxHi(myThid)
C     Initialise temporary file
          DO k = 1,Nr
             DO i = 1-OLx,sNx+OLx
                globfldxz(i,k,bi,bj) = 0. _d 0
             ENDDO
          ENDDO
C     Initialise temporary file
          DO k = 1,Nr
            DO j = 1-OLy,sNy+OLy
              DO i = 1-OLx,sNx+OLx
                globfld3d(i,j,k,bi,bj) = 0. _d 0
              ENDDO
            ENDDO
          ENDDO
        ENDDO
      ENDDO

      IF ( useSingleCPUio ) THEN
C     MDSWRITEFIELDXZ does not know about useSingleCPUio, so the faster
C     method that works for .not.useSingleCPUio cannot be used
        nrec_nl = 0
      ELSE
        nrec_nl = INT(nRecArg/Ny)
      ENDIF

      DO irec = 1, nrec_nl
        CALL WRITE_REC_3D_RL( fname, filePrec, Nr,
     &                        globfld3d,
     &                        irec, optimcycle, myThid )
      ENDDO

      DO irec = nrec_nl*Ny+1, nRecArg
C--   Call directly MDS_WRITE_SEC_XZ (instead of indirectly via MDSWRITEFIELDXZ)
C     --> expect zero difference.
C     In this call, value "False" is passed to 3rd arg "globalFile"
C             and   value "False" is passed to 4th arg "useCurrentDir,"
c       CALL MDS_WRITE_SEC_XZ( fname, filePrec, .FALSE., .FALSE.,
c    I                         'RL', Nr, 1, Nr, globfldxz, dummyRS,
c    I                         irec, optimcycle, myThid )

C--   The only difference here (vs initial MDSWRITEFIELDXZ call) is that,
C     in WRITE_REC_XZ_RL, argument "globalFile" is not set to FALSE but is
C     instead taken from RD_WR_SEC common block (but currently set to FALSE
C     in ini_model_io.F if using OBCS)
        CALL WRITE_REC_XZ_RL( fname, filePrec,
     I                        Nr, globfldxz,
     I                        irec, optimcycle, myThid )
      ENDDO

      RETURN
      END

#include "SHAP_FILT_OPTIONS.h"

CBOP
C     !ROUTINE: SHAP_FILT_APPLY_UV
C     !INTERFACE:
      SUBROUTINE SHAP_FILT_APPLY_UV(
     U                     uFld, vFld,
     I                     myTime, myIter, myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R SHAP_FILT_cwAPPLY_UV
C     | o Apply Shapiro filter on momentum :
C     |   filter the argments uFld & vFld.
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     == Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
c #include "DYNVARS.h"
#include "GRID.h"
#include "SHAP_FILT.h"
#ifdef ALLOW_FRICTION_HEATING
# include "FFIELDS.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     uFld :: velocity field (U component) on which filter applies
C     vFld :: velocity field (V component) on which filter applies
C     myTime :: Current time in simulation
C     myIter :: Current iteration number in simulation
C     myThid :: Thread number for this instance of SHAP_FILT_APPLY_UV
      _RL  uFld(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      _RL  vFld(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      _RL myTime
      INTEGER myIter
      INTEGER myThid

#ifdef ALLOW_SHAP_FILT

C     !FUNCTIONS:
      LOGICAL  DIFFERENT_MULTIPLE
      EXTERNAL DIFFERENT_MULTIPLE
#ifdef ALLOW_DIAGNOSTICS
      LOGICAL  DIAGNOSTICS_IS_ON
      EXTERNAL DIAGNOSTICS_IS_ON
#endif /* ALLOW_DIAGNOSTICS */

C     !LOCAL VARIABLES:
C     == Local variables ==
#ifdef USE_OLD_SHAPIRO_FILTERS
C     bi,bj,k :: loop index
      INTEGER bi, bj, k
#else /* USE_OLD_SHAPIRO_FILTERS */
      LOGICAL diag_dKE
      CHARACTER*(10) suff
#if ( defined ALLOW_FRICTION_HEATING ) || ( defined ALLOW_DIAGNOSTICS )
      INTEGER bi, bj, k, i, j
      _RL dKE_shap(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
#endif
#endif /* USE_OLD_SHAPIRO_FILTERS */
CEOP

      IF ( momStepping .AND. nShapUV.GT.0) THEN

#ifdef  USE_OLD_SHAPIRO_FILTERS
        _EXCH_XYZ_RL( uFld,myThid )
        _EXCH_XYZ_RL( vFld,myThid )

        DO bj=myByLo(myThid),myByHi(myThid)
         DO bi=myBxLo(myThid),myBxHi(myThid)
          DO k=1, Nr
            CALL SHAP_FILT_U( uFld,bi,bj,k,myTime,myThid )
            CALL SHAP_FILT_V( vFld,bi,bj,k,myTime,myThid )
          ENDDO
         ENDDO
        ENDDO

        _EXCH_XYZ_RL( uFld,myThid )
        _EXCH_XYZ_RL( vFld,myThid )
#else
        IF (Shap_funct.EQ.1) THEN
          CALL SHAP_FILT_UV_S1(
     U           uFld, vFld, Shap_tmpFld1, Shap_tmpFld2,
     I           Nr, myTime, myThid )
        ELSEIF (Shap_funct.EQ.2 .OR. Shap_funct.EQ.20) THEN
          CALL SHAP_FILT_UV_S2(
     U           uFld, vFld, Shap_tmpFld1, Shap_tmpFld2,
     I           Nr, myTime, myThid )
        ELSEIF (Shap_funct.EQ.4) THEN
          CALL SHAP_FILT_UV_S4(
     U           uFld, vFld, Shap_tmpFld1, Shap_tmpFld2,
     I           Nr, myTime, myThid )
c       ELSEIF (Shap_funct.EQ.20) THEN
c         CALL SHAP_FILT_UV_S2G(
c    U           uFld, vFld, Shap_tmpFld1, Shap_tmpFld2,
c    I           Nr, myTime, myThid )
        ELSEIF (Shap_funct.EQ.21) THEN
          CALL SHAP_FILT_UV_S2C(
     U           uFld, vFld, Shap_tmpFld1, Shap_tmpFld2,
     I           Nr, myTime, myThid )
        ELSE
           STOP 'SHAP_FILT_APPLY_UV: Ooops! Bad Shap_funct in UV block'
        ENDIF

C-----  Diagnostic of Shapiro Filter effect on Momentum :
C       Note: Shap_tmpFld1,2 from shap_filt_tracer_s2 (and not s1, s4)
C             are directly proportional to Delta-U,V due to the Filter
        IF ( Shap_funct.NE.1 .AND. Shap_funct.NE.4 .AND.
     &     DIFFERENT_MULTIPLE(Shap_diagFreq,myTime,deltaTClock)
     &     ) THEN
          IF ( rwSuffixType.EQ.0 ) THEN
            WRITE(suff,'(I10.10)') myIter
          ELSE
            CALL RW_GET_SUFFIX( suff, myTime, myIter, myThid )
          ENDIF
          CALL WRITE_FLD_XYZ_RL( 'shap_dU.', suff, Shap_tmpFld1,
     &                            myIter,myThid)
          CALL WRITE_FLD_XYZ_RL( 'shap_dV.', suff, Shap_tmpFld2,
     &                            myIter,myThid)
        ENDIF

        IF ( Shap_funct.NE.1 .AND. Shap_funct.NE.4 .AND.
     &       ( addFrictionHeating .OR. useDiagnostics ) ) THEN
         diag_dKE = .FALSE.
#ifdef ALLOW_DIAGNOSTICS
         IF ( useDiagnostics ) THEN
           CALL DIAGNOSTICS_FILL( Shap_tmpFld1, 'SHAP_dU ', 0, Nr,
     &                                           0, 1, 1, myThid )
           CALL DIAGNOSTICS_FILL( Shap_tmpFld2, 'SHAP_dV ', 0, Nr,
     &                                           0, 1, 1, myThid )
           diag_dKE = DIAGNOSTICS_IS_ON('SHAP_dKE',myThid)
         ENDIF
#endif /* ALLOW_DIAGNOSTICS */
#if ( defined ALLOW_FRICTION_HEATING ) || ( defined ALLOW_DIAGNOSTICS )
         IF ( addFrictionHeating .OR. diag_dKE ) THEN
           DO bj=myByLo(myThid),myByHi(myThid)
            DO bi=myBxLo(myThid),myBxHi(myThid)
             DO k=1,Nr
              DO j=1,sNy
               DO i=1,sNx
                 dKE_shap(i,j) = 0.5 _d 0 *(
     &             (
     &               Shap_tmpFld1(i  ,j,k,bi,bj)*uFld(i  ,j,k,bi,bj)
     &                *_hFacW(i ,j, k,bi,bj)*rAw(i ,j, bi,bj)
     &              +Shap_tmpFld1(i+1,j,k,bi,bj)*uFld(i+1,j,k,bi,bj)
     &                *_hFacW(i+1,j,k,bi,bj)*rAw(i+1,j,bi,bj)
     &             )
     &           + (
     &               Shap_tmpFld2(i,j  ,k,bi,bj)*vFld(i,j  ,k,bi,bj)
     &                *_hFacS(i,j  ,k,bi,bj)*rAs(i,j  ,bi,bj)
     &              +Shap_tmpFld2(i,j+1,k,bi,bj)*vFld(i,j+1,k,bi,bj)
     &                *_hFacS(i,j+1,k,bi,bj)*rAs(i,j+1,bi,bj)
     &             )                       )*recip_rA(i,j,bi,bj)
               ENDDO
              ENDDO
#ifdef ALLOW_FRICTION_HEATING
              IF ( addFrictionHeating ) THEN
               DO j=1,sNy
                DO i=1,sNx
                   frictionHeating(i,j,k,bi,bj) =
     &                             frictionHeating(i,j,k,bi,bj)
     &                           - dKE_shap(i,j)*drF(k)*rUnit2mass
                ENDDO
               ENDDO
              ENDIF
#endif /* ALLOW_FRICTION_HEATING */
#ifdef ALLOW_DIAGNOSTICS
              IF ( diag_dKE ) THEN
               CALL DIAGNOSTICS_FILL( dKE_shap, 'SHAP_dKE',
     &                                k, 1, 2, bi, bj, myThid )
              ENDIF
#endif /* ALLOW_DIAGNOSTICS */
             ENDDO
            ENDDO
           ENDDO
         ENDIF
#endif /* ALLOW_FRICTION_HEATING or ALLOW_DIAGNOSTICS */
        ENDIF

#endif /* USE_OLD_SHAPIRO_FILTERS */

      ENDIF
#endif /* ALLOW_SHAP_FILT */

      RETURN
      END

#include "OFFLINE_OPTIONS.h"

      SUBROUTINE OFFLINE_READPARMS( myThid )
C     *==========================================================*
C     | SUBROUTINE OFFLINE_READPARMS
C     | o Routine to initialize OFFLINE variables and constants.
C     *==========================================================*
C     | Initialize OFFLINE    parameters, read in data.off
C     *==========================================================*
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "OFFLINE.h"
#include "OFFLINE_SWITCH.h"

C     === Routine arguments ===
      INTEGER myThid

C     === Local variables ===
C     msgBuf     :: Informational/error message buffer
C     iUnit      :: Work variable for IO unit number
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      INTEGER iUnit
C     Retired main data.offline file parameters
      CHARACTER*(MAX_LEN_FNAM) KPP_ghatFile
      INTEGER offlineOffsetIter

C--   Bulk Formula parameter
      NAMELIST /OFFLINE_PARM01/
     &         UvelFile, VvelFile, WvelFile, ThetFile, SaltFile,
     &         GMwxFile, GMwyFile, GMwzFile,
     &         ConvFile, KPP_DiffSFile, KPP_ghatKFile,
     &         HFluxFile, SFluxFile, IceFile,
     &         KPP_ghatFile

      NAMELIST /OFFLINE_PARM02/
     &         offlineIter0, deltaToffline, offlineTimeOffset,
     &         offlineForcingPeriod, offlineForcingCycle,
     &         offlineLoadPrec, offlineOffsetIter

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      IF ( .NOT.useOffLine ) THEN
C-    pkg OFFLINE is not used
        _BEGIN_MASTER(myThid)
C-    Track pkg activation status:
C     print a (weak) warning if data.off is found
         CALL PACKAGES_UNUSED_MSG( 'useOffLine', ' ', 'off' )
        _END_MASTER(myThid)
        RETURN
      ENDIF

      _BEGIN_MASTER(myThid)

      WRITE(msgBuf,'(A)') ' OFFLINE_READPARMS: opening data.off'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )

      CALL OPEN_COPY_DATA_FILE(
     I                          'data.off', 'OFFLINE_READPARMS',
     O                          iUnit,
     I                          myThid )

C--   Default values for params in OFFLINE_PARM01 :
      UvelFile = ' '
      VvelFile = ' '
      WvelFile = ' '
      ThetFile = ' '
      SaltFile = '  '
      GMwxFile = ' '
      GMwyFile = ' '
      GMwzFile = ' '
      ConvFile = ' '
      KPP_DiffSFile= ' '
      KPP_ghatKFile= ' '
      KPP_ghatFile = 'KPP_ghatFile has been replaced by KPP_ghatKFile'
      HFluxFile= ' '
      SFluxFile= ' '
      IceFile  = ' '

C--   Read parameters from open data file
      READ(UNIT=iUnit,NML=OFFLINE_PARM01)

C--   Default values for params in OFFLINE_PARM02 :
      deltaToffline= deltaTclock
      offlineIter0 = nIter0      !initial offline field timestep
      offlineTimeOffset = 0.     !time offset
      offlineOffsetIter = UNSET_I
      offlineForcingPeriod = 2592000.
      offlineForcingCycle = 31104000.
      offlineLoadPrec = readBinaryPrec

C--   Read parameters from open data file
      READ(UNIT=iUnit,NML=OFFLINE_PARM02)

      WRITE(msgBuf,'(A)')
     &      ' OFFLINE_READPARMS: finished reading data.off'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )

C--   Close the open data file
#ifdef SINGLE_DISK_IO
      CLOSE(iUnit)
#else
      CLOSE(iUnit,STATUS='DELETE')
#endif /* SINGLE_DISK_IO */

C--   Check for retired parameters still being used
      IF ( KPP_ghatFile .NE.
     &    'KPP_ghatFile has been replaced by KPP_ghatKFile' ) THEN
c       nRetired = nRetired+1
        WRITE(msgBuf,'(A,A)') 'S/R OFFLINE_READPARMS: "KPP_ghatFile"',
     &                     ' is no longer allowed in file "data.off"'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(A,A)') 'S/R OFFLINE_READPARMS: read instead ',
     &           'the product ghat*diffKz from file "KPP_ghatKFile"'
        CALL PRINT_ERROR( msgBuf, myThid )
        STOP 'ABNORMAL END: S/R OFFLINE_READPARMS'
      ENDIF
      IF ( offlineOffsetIter .NE. UNSET_I ) THEN
        WRITE(msgBuf,'(A,A)') 'S/R OFFLINE_READPARMS: ',
     &   'offlineOffsetIter is no longer allowed in file "data.off"'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(A,A)') 'S/R OFFLINE_READPARMS: ',
     &   'instead set "offlineTimeOffset" to OffsetIter*deltaToffline'
        CALL PRINT_ERROR( msgBuf, myThid )
        STOP 'ABNORMAL END: S/R OFFLINE_READPARMS'
      ENDIF

C--   derive other parameters:
      offlineLoadGMRedi = ( GMwxFile .NE. ' ' )
     &                .OR.( GMwyFile .NE. ' ' )
     &                .OR.( GMwzFile .NE. ' ' )
      offlineLoadKPP    = ( KPP_DiffSFile .NE. ' ' )
     &                .OR.( KPP_ghatKFile .NE. ' ' )
      offlineLoadConvec = ( ConvFile .NE. ' ' )

      _END_MASTER(myThid)

C--   Everyone else must wait for the parameters to be loaded
      _BARRIER

      RETURN
      END

#include "SMOOTH_OPTIONS.h"

CBOP
C     !ROUTINE: SMOOTH_CHECK
C     !INTERFACE:
      SUBROUTINE SMOOTH_CHECK( myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R SMOOTH_CHECK
C     | o Checks for inconsistencies in the smooth package
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     == global variables ==
#include "EEPARAMS.h"
#include "SIZE.h"
#include "SMOOTH.h"

C     !INPUT/OUTPUT PARAMETERS:
      INTEGER myThid

C     !LOCAL VARIABLES:
C     msgBuf      :: Informational/error message buffer
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      INTEGER smoothOpNb
CEOP

C --- Check for legal mask names
      DO smoothOpNb=1,smoothOpNbMax
        IF ( .NOT.(
     &       (smooth2DmaskName(smoothOpNb)(1:5).EQ.'maskC').OR.
     &       (smooth2DmaskName(smoothOpNb)(1:5).EQ.'maskW').OR.
     &       (smooth2DmaskName(smoothOpNb)(1:5).EQ.'maskS').OR.
     &       (smooth2DmaskName(smoothOpNb)(1:5).EQ.'maskI'))) THEN
          WRITE(msgBuf,'(A,A,I2,A,A,A,A)') 'SMOOTH_CHECK: ',
     &      'Unrecognized option for smooth2DmaskName(', smoothOpNb,
     &      '): ', smooth2DmaskName(smoothOpNb), ' - must be: ',
     &      'maskC, maskW, maskS, or maskI'
          CALL PRINT_ERROR( msgBuf, myThid )
          STOP 'ABNORMAL END: S/R SMOOTH_CHECK'
        ENDIF

        IF ( .NOT.(
     &       (smooth3DmaskName(smoothOpNb)(1:5).EQ.'maskC').OR.
     &       (smooth3DmaskName(smoothOpNb)(1:5).EQ.'maskW').OR.
     &       (smooth3DmaskName(smoothOpNb)(1:5).EQ.'maskS'))) THEN
          WRITE(msgBuf,'(A,A,I2,A,A,A,A)') 'SMOOTH_CHECK: ',
     &      'Unrecognized option for smooth3DmaskName(', smoothOpNb,
     &      '): ', smooth3DmaskName(smoothOpNb), ' - must be: ',
     &      'maskC, maskW, or maskS'
          CALL PRINT_ERROR( msgBuf, myThid )
          STOP 'ABNORMAL END: S/R SMOOTH_CHECK'
        ENDIF

#ifndef ALLOW_SHELFICE
C --- make sure proper macros are defined for maskI (iceshelf domain)
        IF (smooth2DmaskName(smoothOpNb)(1:5).EQ.'maskI') THEN
          WRITE(msgBuf,'(A,A,I2,A,A,A,A)') 'SMOOTH_CHECK: ',
     &      'Must compile with shelfice package, ALLOW_SHELFICE'
          CALL PRINT_ERROR( msgBuf, myThid )
          STOP 'ABNORMAL END: S/R SMOOTH_CHECK'
        ENDIF
#endif
      ENDDO

      RETURN
      END

#include "LAND_OPTIONS.h"

CBOP
C     !ROUTINE: LAND_INI_VARS
C     !INTERFACE:
      SUBROUTINE LAND_INI_VARS( myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R LAND_INI_VARS
C     | o Initialize Land package variables
C     *==========================================================*
C     | for now, used only for a restart
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     == Global variables ===

C-- size for MITgcm & Land package :
#include "LAND_SIZE.h"

#include "EEPARAMS.h"
#include "PARAMS.h"
#include "LAND_PARAMS.h"
#include "LAND_VARS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine Arguments ==
C     myThid -  Number of this instance
      INTEGER myThid
CEOP

#ifdef ALLOW_LAND

C     == Local Variables ==
C     msgBuf      - Informational/error meesage buffer
C     i,j,k,bi,bj :: loop indices
C     grd_HeatCp   :: Heat capacity of the ground (J/m3/K)
C     mWater       :: water content of the ground (kg/m3)
C     temp_af      :: ground temperature if above freezing
C     temp_bf      :: ground temperature if below freezing
c     CHARACTER*(MAX_LEN_MBUF) msgBuf
      INTEGER i,j,k,bi,bj
      _RL grd_HeatCp, mWater
      _RL temp_af, temp_bf

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C--   Initialize Land package variables

C-    Over all tiles
      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)

C-      3D arrays
        DO k=1,land_nLev
         DO J=1-Oly,sNy+Oly
          DO I=1-Olx,sNx+Olx
           land_groundT(i,j,k,bi,bj) = 0. _d 0
           land_enthalp(i,j,k,bi,bj) = 0. _d 0
           land_groundW(i,j,k,bi,bj) = 0. _d 0
          ENDDO
         ENDDO
        ENDDO

C-      2D arrays
        DO J=1-Oly,sNy+Oly
         DO I=1-Olx,sNx+Olx
           land_skinT  (i,j,bi,bj) = 0. _d 0
           land_hSnow  (i,j,bi,bj) = 0. _d 0
           land_snowAge(i,j,bi,bj) = 0. _d 0
           land_runOff (i,j,bi,bj) = 0. _d 0
           land_enRnOf (i,j,bi,bj) = 0. _d 0
           land_HeatFLx(i,j,bi,bj) = 0. _d 0
           land_Pr_m_Ev(i,j,bi,bj) = 0. _d 0
           land_EnWFlux(i,j,bi,bj) = 0. _d 0
         ENDDO
        ENDDO

C-     end bi,bj loops
       ENDDO
      ENDDO

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C-    Need to synchronize here before doing master-thread IO
      _BARRIER

      IF ( startTime.EQ.baseTime .AND. nIter0.EQ.0 ) THEN

C--   Define the initial state : read from file
       IF ( land_grT_iniFile .NE. ' ' ) THEN
        CALL READ_REC_3D_RL( land_grT_iniFile, readBinaryPrec,
     &            land_nLev, land_groundT, 1, nIter0, myThid )
       ENDIF
       IF ( land_grW_iniFile .NE. ' ' ) THEN
        CALL READ_REC_3D_RL( land_grW_iniFile, readBinaryPrec,
     &            land_nLev, land_groundW, 1, nIter0, myThid )
       ENDIF
       IF ( land_snow_iniFile .NE. ' ' ) THEN
        CALL READ_FLD_XY_RL( land_snow_iniFile, ' ',
     &                       land_hSnow, nIter0, myThid )
       ENDIF

      ELSEIF ( land_calc_grT .OR. land_calc_grW ) THEN

C--   Read Land package state variables from pickup file
        CALL LAND_READ_PICKUP( nIter0, myThid )

c     ELSE
C-    a trick to allow to start without a land pickup:
C        load grT & grW from AIM surf. BC in S/R aim_land2aim
      ENDIF

C-    Every one else must wait until loading is done.
      _BARRIER

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)

C-     to have a consistent initial state: set surface Temp & enthalpy
C       assuming all the water in 1 phase only (solid or liquid):
        IF ( ( startTime.EQ.baseTime .AND. nIter0.EQ.0 ) .OR.
     &   .NOT.( land_calc_grT .OR. land_calc_grW ) .OR.
     &       land_oldPickup ) THEN
         DO j=1,sNy
          DO i=1,sNx
c          IF ( land_frc(i,j,bi,bj).GT.0. ) THEN
            DO k=1,land_nLev
             mWater = land_rhoLiqW*land_waterCap
     &               *land_groundW(i,j,k,bi,bj)
             grd_HeatCp = land_heatCs + land_CpWater*mWater
             land_enthalp(i,j,k,bi,bj) =
     &                     grd_HeatCp*land_groundT(i,j,k,bi,bj)
             IF (land_groundT(i,j,k,bi,bj).LT. 0. _d 0)
     &       land_enthalp(i,j,k,bi,bj) = land_enthalp(i,j,k,bi,bj)
     &                                 - land_Lfreez*mWater
            ENDDO
             land_skinT(i,j,bi,bj) = land_groundT(i,j,1,bi,bj)
c          ENDIF
          ENDDO
         ENDDO
        ELSE
         DO j=1,sNy
          DO i=1,sNx
            DO k=1,land_nLev
             mWater = land_rhoLiqW*land_waterCap
     &               *land_groundW(i,j,k,bi,bj)
             grd_HeatCp = land_heatCs + land_CpWater*mWater
C         temperature if below freezing:
             temp_bf = (land_enthalp(i,j,k,bi,bj)+land_Lfreez*mWater)
     &                                            / grd_HeatCp
C         temperature if above freezing:
             temp_af =  land_enthalp(i,j,k,bi,bj) / grd_HeatCp
             land_groundT(i,j,k,bi,bj) =
     &               MIN( temp_bf, MAX(temp_af, 0. _d 0) )
            ENDDO
          ENDDO
         ENDDO
        ENDIF

C-     end bi,bj loops
       ENDDO
      ENDDO

#endif /* ALLOW_LAND */

      RETURN
      END

#include "CPP_OPTIONS.h"

CBOP 0
C !ROUTINE: CPL_SEND_ATM_CPLPARMS

C !INTERFACE:
      SUBROUTINE CPL_SEND_ATM_CPLPARMS( msgUnit )

C !DESCRIPTION:
C     *==========================================================*
C     | SUBROUTINE CPL_SEND_ATM_CPLPARMS
C     | o Routine for sending coupler-parameters
C     |   to atmos component
C     *==========================================================*
C     *==========================================================*

C !USES:
      IMPLICIT NONE
C     == Global variables ==
#include "CPL_PARAMS.h"
#include "ATMIDS.h"

C !INPUT/OUTPUT PARAMETERS:
C     msgUnit   :: log-file I/O unit
      INTEGER msgUnit

C !LOCAL VARIABLES:
C     i        :: Loop counter
C     parBuf   :: local buffer to send coupler-params
      INTEGER i
      INTEGER parBuf(atmParSize)
CEOP

C-    Initialise buffer
      DO i=1,atmParSize
        parBuf(i) = 0
      ENDDO

C-    Send exchange field selectors (coupler config) to atmos. component
      IF ( atmParSize.EQ.6 ) THEN
        parBuf(1) = cpl_sequential
        parBuf(2) = cpl_exchange_RunOff
        parBuf(3) = cpl_exchange1W_sIce
        parBuf(4) = cpl_exchange2W_sIce
        parBuf(5) = cpl_exchange_SaltPl
        parBuf(6) = cpl_exchange_DIC
      ELSE
C-    If not using an up-to-date ATMIDS.h with the wrong atmParSize
        cplErrorCount = cplErrorCount + 1
        WRITE(msgUnit,'(2A,I4,A)')
     &       ' *** ERROR *** CPL_SEND_ATM_CPLPARMS: ',
     &       'atmParSize=', atmParSize, ' is wrong (expect 6)'
        WRITE(msgUnit,'(2A,I4,A)')
     &       ' *** ERROR *** CPL_SEND_ATM_CPLPARMS: ',
     &       '==> set ErrorCount=', cplErrorCount, ' (Fatal)'
      ENDIF

      CALL COUPSEND_I4VEC(
     I              atmCompName, atmCplParamsName, atmParSize,
     I              parBuf )

      RETURN
      END

#include "RW_OPTIONS.h"

C--  File read_write_rec.F: Routines to handle mid-level I/O interface.
C--   Contents
C--   o SET_WRITE_GLOBAL_REC
C--   o SET_WRITE_GLOBAL_SEC
C--   o WRITE_REC_XY_RS
C--   o WRITE_REC_XY_RL
C--   o WRITE_REC_XYZ_RS
C--   o WRITE_REC_XYZ_RL
C--   o WRITE_REC_3D_RS
C--   o WRITE_REC_3D_RL
C--   o WRITE_REC_LEV_RS
C--   o WRITE_REC_LEV_RL
C--   o WRITE_REC_XZ_RS
C--   o WRITE_REC_XZ_RL
C--   o WRITE_REC_YZ_RS
C--   o WRITE_REC_YZ_RL

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: SET_WRITE_GLOBAL_REC
C     !INTERFACE:
      SUBROUTINE SET_WRITE_GLOBAL_REC ( flag )
      IMPLICIT NONE

C     !DESCRIPTION: \bv
C SET_WRITE_GLOBAL_REC( flag ) sets an internal logical state to
C indicate whether Record files written by subsequent call to the
C READ-WRITE package should create "global" or "tiled" files.
C   flag = .TRUE.  indicates "global" files
C   flag = .FALSE. indicates "tiled" files
C     \ev

C     !INPUT/OUTPUT PARAMETERS:
C Arguments
      LOGICAL flag
C     !USES:
C Common
      COMMON /RD_WR_REC/ globalFile
      LOGICAL globalFile
CEOP

      globalFile=flag

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: SET_WRITE_GLOBAL_SEC
C     !INTERFACE:
      SUBROUTINE SET_WRITE_GLOBAL_SEC ( flag )
      IMPLICIT NONE

C     !DESCRIPTION: \bv
C SET_WRITE_GLOBAL_SEC( flag ) sets an internal logical state to
C indicate whether files containing vertical Sections written by subsequent
C call to the READ-WRITE package should create "global" or "tiled" files.
C   flag = .TRUE.  indicates "global" files
C   flag = .FALSE. indicates "tiled" files
C     \ev

C     !INPUT/OUTPUT PARAMETERS:
C Arguments
      LOGICAL flag
C     !USES:
C Common
      COMMON /RD_WR_SEC/ globalFile
      LOGICAL globalFile
CEOP

      globalFile=flag

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: WRITE_REC_XY_RS
C     !INTERFACE:
      SUBROUTINE WRITE_REC_XY_RS( fName,field,iRec,myIter,myThid )

C     !DESCRIPTION: \bv
C WRITE_REC_XY_RS is a "front-end" interface to the low-level I/O
C routines.
C     \ev

C     !USES:
      IMPLICIT NONE
C Global
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
C Arguments
      CHARACTER*(*) fName
      _RS field(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      INTEGER iRec
      INTEGER myIter
      INTEGER myThid

C Functions
c     INTEGER ILNBLNK

C Common
      COMMON /RD_WR_REC/ globalFile
      LOGICAL globalFile

C     !LOCAL VARIABLES:
C Local
      LOGICAL useCurrentDir
      _RL dummyRL(1)
      CHARACTER*(2) fType
      INTEGER nNz
c     INTEGER IL
c     CHARACTER*(MAX_LEN_FNAM) fullName
CEOP

c     IF (myIter.GE.0) THEN
c      IL=ILNBLNK( fName )
c      WRITE(fullName,'(2a,i10.10)') fName(1:IL),'.',myIter
c     ELSE
c      fullName=fName
c     ENDIF

      useCurrentDir = .FALSE.
      fType='RS'
      nNz=1
#ifdef ALLOW_MDSIO
      CALL MDS_WRITE_FIELD(
     I                      fName, writeBinaryPrec,
     I                      globalFile, useCurrentDir,
     I                      fType, nNz, 1, nNz, dummyRL, field,
     I                      iRec, myIter, myThid )
#endif
      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: WRITE_REC_XY_RL
C     !INTERFACE:
      SUBROUTINE WRITE_REC_XY_RL( fName,field,iRec,myIter,myThid )

C     !DESCRIPTION: \bv
C WRITE_REC_XY_RL is a "front-end" interface to the low-level I/O
C routines.
C     \ev

C     !USES:
      IMPLICIT NONE
C Global
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
C Arguments
      CHARACTER*(*) fName
      _RL field(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      INTEGER iRec
      INTEGER myIter
      INTEGER myThid

C Functions
c     INTEGER ILNBLNK

C Common
      COMMON /RD_WR_REC/ globalFile
      LOGICAL globalFile

C     !LOCAL VARIABLES:
C Local
      LOGICAL useCurrentDir
      _RS dummyRS(1)
      CHARACTER*(2) fType
      INTEGER nNz
c     INTEGER IL
c     CHARACTER*(MAX_LEN_FNAM) fullName
CEOP

c     IF (myIter.GE.0) THEN
c      IL=ILNBLNK( fName )
c      WRITE(fullName,'(2a,i10.10)') fName(1:IL),'.',myIter
c     ELSE
c      fullName=fName
c     ENDIF

      useCurrentDir = .FALSE.
      fType='RL'
      nNz=1
#ifdef ALLOW_MDSIO
      CALL MDS_WRITE_FIELD(
     I                      fName, writeBinaryPrec,
     I                      globalFile, useCurrentDir,
     I                      fType, nNz, 1, nNz, field, dummyRS,
     I                      iRec, myIter, myThid )
#endif
      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: WRITE_REC_XYZ_RS
C     !INTERFACE:
      SUBROUTINE WRITE_REC_XYZ_RS( fName,field,iRec,myIter,myThid )

C     !DESCRIPTION: \bv
C WRITE_REC_XYZ_RS is a "front-end" interface to the low-level I/O
C routines.
C     \ev

C     !USES:
      IMPLICIT NONE
C Global
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
C Arguments
      CHARACTER*(*) fName
      _RS field(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      INTEGER iRec
      INTEGER myIter
      INTEGER myThid

C Functions
c     INTEGER ILNBLNK

C Common
      COMMON /RD_WR_REC/ globalFile
      LOGICAL globalFile

C     !LOCAL VARIABLES:
C Local
      LOGICAL useCurrentDir
      _RL dummyRL(1)
      CHARACTER*(2) fType
      INTEGER nNz
c     INTEGER IL
c     CHARACTER*(MAX_LEN_FNAM) fullName
CEOP

c     IF (myIter.GE.0) THEN
c      IL=ILNBLNK( fName )
c      WRITE(fullName,'(2a,i10.10)') fName(1:IL),'.',myIter
c     ELSE
c      fullName=fName
c     ENDIF

      useCurrentDir = .FALSE.
      fType='RS'
      nNz=Nr
#ifdef ALLOW_MDSIO
      CALL MDS_WRITE_FIELD(
     I                      fName, writeBinaryPrec,
     I                      globalFile, useCurrentDir,
     I                      fType, nNz, 1, nNz, dummyRL, field,
     I                      iRec, myIter, myThid )
#endif
      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: WRITE_REC_XYZ_RL
C     !INTERFACE:
      SUBROUTINE WRITE_REC_XYZ_RL( fName,field,iRec,myIter,myThid )

C     !DESCRIPTION: \bv
C WRITE_REC_XYZ_RL is a "front-end" interface to the low-level I/O
C routines.
C     \ev

C     !USES:
      IMPLICIT NONE
C Global
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
C Arguments
      CHARACTER*(*) fName
      _RL field(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      INTEGER iRec
      INTEGER myIter
      INTEGER myThid

C Functions
c     INTEGER ILNBLNK

C Common
      COMMON /RD_WR_REC/ globalFile
      LOGICAL globalFile

C     !LOCAL VARIABLES:
C Local
      LOGICAL useCurrentDir
      _RS dummyRS(1)
      CHARACTER*(2) fType
      INTEGER nNz
c     INTEGER IL
c     CHARACTER*(MAX_LEN_FNAM) fullName
CEOP

c     IF (myIter.GE.0) THEN
c      IL=ILNBLNK( fName )
c      WRITE(fullName,'(2a,i10.10)') fName(1:IL),'.',myIter
c     ELSE
c      fullName=fName
c     ENDIF

      useCurrentDir = .FALSE.
      fType='RL'
      nNz=Nr
#ifdef ALLOW_MDSIO
      CALL MDS_WRITE_FIELD(
     I                      fName, writeBinaryPrec,
     I                      globalFile, useCurrentDir,
     I                      fType, nNz, 1, nNz, field, dummyRS,
     I                      iRec, myIter, myThid )
#endif
      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: WRITE_REC_3D_RS
C     !INTERFACE:
      SUBROUTINE WRITE_REC_3D_RS(
     I                            fName, fPrec, nNz, field,
     I                            iRec, myIter, myThid )

C     !DESCRIPTION: \bv
C WRITE_REC_3D_RS is a "front-end" interface to the low-level I/O routines.
C  write a full 3D field (nNz levels) to record number "iRec"
C   in binary file "fName" (precision "fPrec", generally =32 or 64).
C     \ev

C     !USES:
      IMPLICIT NONE
C Global
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
C Arguments
      CHARACTER*(*) fName
      INTEGER fPrec
      INTEGER nNz
      _RS field(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nNz,nSx,nSy)
      INTEGER iRec
      INTEGER myIter
      INTEGER myThid

C Functions
c     INTEGER ILNBLNK

C Common
      COMMON /RD_WR_REC/ globalFile
      LOGICAL globalFile

C     !LOCAL VARIABLES:
C Local
      LOGICAL useCurrentDir
      _RL dummyRL(1)
      CHARACTER*(2) fType
c     INTEGER IL
c     CHARACTER*(MAX_LEN_FNAM) fullName
CEOP

c     IF (myIter.GE.0) THEN
c      IL=ILNBLNK( fName )
c      WRITE(fullName,'(2a,i10.10)') fName(1:IL),'.',myIter
c     ELSE
c      fullName=fName
c     ENDIF

      useCurrentDir = .FALSE.
      fType='RS'
#ifdef ALLOW_MDSIO
      CALL MDS_WRITE_FIELD(
     I                      fName, fPrec, globalFile, useCurrentDir,
     I                      fType, nNz, 1, nNz, dummyRL, field,
     I                      iRec, myIter, myThid )
#endif
      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: WRITE_REC_3D_RL
C     !INTERFACE:
      SUBROUTINE WRITE_REC_3D_RL(
     I                            fName, fPrec, nNz, field,
     I                            iRec, myIter, myThid )

C     !DESCRIPTION: \bv
C WRITE_REC_3D_RL is a "front-end" interface to the low-level I/O routines.
C  write a full 3D field (nNz levels) to record number "iRec"
C   in binary file "fName" (precision "fPrec", generally =32 or 64).
C     \ev

C     !USES:
      IMPLICIT NONE
C Global
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
C Arguments
      CHARACTER*(*) fName
      INTEGER fPrec
      INTEGER nNz
      _RL field(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nNz,nSx,nSy)
      INTEGER iRec
      INTEGER myIter
      INTEGER myThid

C Functions
c     INTEGER ILNBLNK

C Common
      COMMON /RD_WR_REC/ globalFile
      LOGICAL globalFile

C     !LOCAL VARIABLES:
C Local
      LOGICAL useCurrentDir
      _RS dummyRS(1)
      CHARACTER*(2) fType
c     INTEGER IL
c     CHARACTER*(MAX_LEN_FNAM) fullName
CEOP

c     IF (myIter.GE.0) THEN
c      IL=ILNBLNK( fName )
c      WRITE(fullName,'(2a,i10.10)') fName(1:IL),'.',myIter
c     ELSE
c      fullName=fName
c     ENDIF

      useCurrentDir = .FALSE.
      fType='RL'
#ifdef ALLOW_MDSIO
      CALL MDS_WRITE_FIELD(
     I                      fName, fPrec, globalFile, useCurrentDir,
     I                      fType, nNz, 1, nNz, field, dummyRS,
     I                      iRec, myIter, myThid )
#endif
      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: WRITE_REC_LEV_RS
C     !INTERFACE:
      SUBROUTINE WRITE_REC_LEV_RS(
     I                            fName, fPrec, kSiz, kLo, kHi, field,
     I                            iRec, myIter, myThid )

C     !DESCRIPTION: \bv
C WRITE_REC_LEV_RS is a "front-end" interface to the low-level I/O routines.
C  Write a set a consecutive levels (from kLo to kHi) from 3D array (size: kSiz)
C  to record number "iRec" in binary file "fName" (precision "fPrec",
C  generally =32 or 64).
C     \ev

C     !USES:
      IMPLICIT NONE
C Global
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
C Arguments
      CHARACTER*(*) fName
      INTEGER fPrec
      INTEGER kSiz, kLo, kHi
      _RS field(1-OLx:sNx+OLx,1-OLy:sNy+OLy,kSiz,nSx,nSy)
      INTEGER iRec
      INTEGER myIter
      INTEGER myThid

C Functions
c     INTEGER ILNBLNK

C Common
      COMMON /RD_WR_REC/ globalFile
      LOGICAL globalFile

C     !LOCAL VARIABLES:
C Local
      LOGICAL useCurrentDir
      _RL dummyRL(1)
      CHARACTER*(2) fType
c     INTEGER IL
c     CHARACTER*(MAX_LEN_FNAM) fullName
CEOP

c     IF (myIter.GE.0) THEN
c      IL=ILNBLNK( fName )
c      WRITE(fullName,'(2a,i10.10)') fName(1:IL),'.',myIter
c     ELSE
c      fullName=fName
c     ENDIF

      useCurrentDir = .FALSE.
      fType='RS'
#ifdef ALLOW_MDSIO
      CALL MDS_WRITE_FIELD(
     I                      fName, fPrec, globalFile, useCurrentDir,
     I                      fType, kSiz, kLo, kHi, dummyRL, field,
     I                      iRec, myIter, myThid )
#endif
      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: WRITE_REC_LEV_RL
C     !INTERFACE:
      SUBROUTINE WRITE_REC_LEV_RL(
     I                            fName, fPrec, kSiz, kLo, kHi, field,
     I                            iRec, myIter, myThid )

C     !DESCRIPTION: \bv
C WRITE_REC_LEV_RL is a "front-end" interface to the low-level I/O routines.
C  Write a set a consecutive levels (from kLo to kHi) from 3D array (size: kSiz)
C  to record number "iRec" in binary file "fName" (precision "fPrec",
C  generally =32 or 64).
C     \ev

C     !USES:
      IMPLICIT NONE
C Global
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
C Arguments
      CHARACTER*(*) fName
      INTEGER fPrec
      INTEGER kSiz, kLo, kHi
      _RL field(1-OLx:sNx+OLx,1-OLy:sNy+OLy,kSiz,nSx,nSy)
      INTEGER iRec
      INTEGER myIter
      INTEGER myThid

C Functions
c     INTEGER ILNBLNK

C Common
      COMMON /RD_WR_REC/ globalFile
      LOGICAL globalFile

C     !LOCAL VARIABLES:
C Local
      LOGICAL useCurrentDir
      _RS dummyRS(1)
      CHARACTER*(2) fType
c     INTEGER IL
c     CHARACTER*(MAX_LEN_FNAM) fullName
CEOP

c     IF (myIter.GE.0) THEN
c      IL=ILNBLNK( fName )
c      WRITE(fullName,'(2a,i10.10)') fName(1:IL),'.',myIter
c     ELSE
c      fullName=fName
c     ENDIF

      useCurrentDir = .FALSE.
      fType='RL'
#ifdef ALLOW_MDSIO
      CALL MDS_WRITE_FIELD(
     I                      fName, fPrec, globalFile, useCurrentDir,
     I                      fType, kSiz, kLo, kHi, field, dummyRS,
     I                      iRec, myIter, myThid )
#endif
      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: WRITE_REC_XZ_RS
C     !INTERFACE:
      SUBROUTINE WRITE_REC_XZ_RS(
     I                            fName, fPrec, nNz,
     I                            field,
     I                            iRec, myIter, myThid )

C     !DESCRIPTION: \bv
C WRITE_REC_XZ_RS is a "front-end" interface to the low-level I/O
C routines.
C     \ev

C     !USES:
      IMPLICIT NONE
C Global
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
C     !INPUT/OUTPUT PARAMETERS:
C Arguments
      CHARACTER*(*) fName
      INTEGER fPrec
      INTEGER nNz
      _RS field(1-OLx:sNx+OLx,nNz,nSx,nSy)
      INTEGER iRec
      INTEGER myIter
      INTEGER myThid

C Functions
c     INTEGER ILNBLNK

C Common
      COMMON /RD_WR_SEC/ globalFile
      LOGICAL globalFile

C     !LOCAL VARIABLES:
C Local
      LOGICAL useCurrentDir
      _RL dummyRL(1)
      CHARACTER*(2) fType
c     INTEGER IL
c     CHARACTER*(MAX_LEN_FNAM) fullName
CEOP

c     IF (myIter.GE.0) THEN
c      IL=ILNBLNK( fName )
c      WRITE(fullName,'(2a,i10.10)') fName(1:IL),'.',myIter
c     ELSE
c      fullName=fName
c     ENDIF

      useCurrentDir = .FALSE.
      fType='RS'
#ifdef ALLOW_MDSIO
      CALL MDS_WRITE_SEC_XZ(
     I                       fName, fPrec, globalFile, useCurrentDir,
     I                       fType, nNz, 1, nNz,
     I                       dummyRL, field,
     I                       iRec, myIter, myThid )
#endif
      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: WRITE_REC_XZ_RL
C     !INTERFACE:
      SUBROUTINE WRITE_REC_XZ_RL(
     I                            fName, fPrec, nNz,
     I                            field,
     I                            iRec, myIter, myThid )

C     !DESCRIPTION: \bv
C WRITE_REC_XZ_RL is a "front-end" interface to the low-level I/O
C routines.
C     \ev

C     !USES:
      IMPLICIT NONE
C Global
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
C Arguments
      CHARACTER*(*) fName
      INTEGER fPrec
      INTEGER nNz
      _RL field(1-OLx:sNx+OLx,nNz,nSx,nSy)
      INTEGER iRec
      INTEGER myIter
      INTEGER myThid

C Functions
c     INTEGER ILNBLNK

C Common
      COMMON /RD_WR_SEC/ globalFile
      LOGICAL globalFile

C     !LOCAL VARIABLES:
C Local
      LOGICAL useCurrentDir
      _RS dummyRS(1)
      CHARACTER*(2) fType
c     INTEGER IL
c     CHARACTER*(MAX_LEN_FNAM) fullName
CEOP

c     IF (myIter.GE.0) THEN
c      IL=ILNBLNK( fName )
c      WRITE(fullName,'(2a,i10.10)') fName(1:IL),'.',myIter
c     ELSE
c      fullName=fName
c     ENDIF

      useCurrentDir = .FALSE.
      fType='RL'
#ifdef ALLOW_MDSIO
      CALL MDS_WRITE_SEC_XZ(
     I                       fName, fPrec, globalFile, useCurrentDir,
     I                       fType, nNz, 1, nNz,
     I                       field, dummyRS,
     I                       iRec, myIter, myThid )
#endif
      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: WRITE_REC_YZ_RS
C     !INTERFACE:
      SUBROUTINE WRITE_REC_YZ_RS(
     I                           fName, fPrec, nNz,
     I                           field,
     I                           iRec, myIter, myThid )

C     !DESCRIPTION: \bv
C WRITE_REC_YZ_RS is a "front-end" interface to the low-level I/O
C routines.
C     \ev

C     !USES:
      IMPLICIT NONE
C Global
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
C Arguments
      CHARACTER*(*) fName
      INTEGER fPrec
      INTEGER nNz
      _RS field(1-OLy:sNy+OLy,nNz,nSx,nSy)
      INTEGER iRec
      INTEGER myIter
      INTEGER myThid

C Functions
c     INTEGER ILNBLNK

C Common
      COMMON /RD_WR_SEC/ globalFile
      LOGICAL globalFile

C     !LOCAL VARIABLES:
C Local
      LOGICAL useCurrentDir
      _RL dummyRL(1)
      CHARACTER*(2) fType
c     INTEGER IL
c     CHARACTER*(MAX_LEN_FNAM) fullName
CEOP

c     IF (myIter.GE.0) THEN
c      IL=ILNBLNK( fName )
c      WRITE(fullName,'(2a,i10.10)') fName(1:IL),'.',myIter
c     ELSE
c      fullName=fName
c     ENDIF

      useCurrentDir = .FALSE.
      fType='RS'
#ifdef ALLOW_MDSIO
      CALL MDS_WRITE_SEC_YZ(
     I                       fName, fPrec, globalFile, useCurrentDir,
     I                       fType, nNz, 1, nNz,
     I                       dummyRL, field,
     I                       iRec, myIter, myThid )
#endif
      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: WRITE_REC_YZ_RL
C     !INTERFACE:
      SUBROUTINE WRITE_REC_YZ_RL(
     I                            fName, fPrec, nNz,
     I                            field,
     I                            iRec, myIter, myThid )

C     !DESCRIPTION: \bv
C WRITE_REC_YZ_RL is a "front-end" interface to the low-level I/O
C routines.
C     \ev

C     !USES:
      IMPLICIT NONE
C Global
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
C Arguments
      CHARACTER*(*) fName
      INTEGER fPrec
      INTEGER nNz
      _RL field(1-OLy:sNy+OLy,nNz,nSx,nSy)
      INTEGER iRec
      INTEGER myIter
      INTEGER myThid

C Functions
c     INTEGER ILNBLNK

C Common
      COMMON /RD_WR_SEC/ globalFile
      LOGICAL globalFile

C     !LOCAL VARIABLES:
C Local
      LOGICAL useCurrentDir
      _RS dummyRS(1)
      CHARACTER*(2) fType
c     INTEGER IL
c     CHARACTER*(MAX_LEN_FNAM) fullName
CEOP

c     IF (myIter.GE.0) THEN
c      IL=ILNBLNK( fName )
c      WRITE(fullName,'(2a,i10.10)') fName(1:IL),'.',myIter
c     ELSE
c      fullName=fName
c     ENDIF

      useCurrentDir = .FALSE.
      fType='RL'
#ifdef ALLOW_MDSIO
      CALL MDS_WRITE_SEC_YZ(
     I                       fName, fPrec, globalFile, useCurrentDir,
     I                       fType, nNz, 1, nNz,
     I                       field, dummyRS,
     I                       iRec, myIter, myThid )
#endif
      RETURN
      END

#include "ZONAL_FILT_OPTIONS.h"

CBOP 0
C     !ROUTINE: ZONAL_FILT_APPLY_UV

C     !INTERFACE:
      SUBROUTINE ZONAL_FILT_APPLY_UV(
     U                 uFld, vFld,
     I                 myThid )

C     !DESCRIPTION:
C     *==========================================================*
C     | S/R ZONAL_FILT_APPLY_UV
C     | o Apply FFT filter to a latitude circle.
C     *==========================================================*

C     !USES:
      IMPLICIT NONE
C     == Global data ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"

C     !INPUT/OUTPUT PARAMETERS:
C     myThid  :: my Thread Id number
      _RL uFld(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      _RL vFld(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      INTEGER myThid
CEOP

#ifdef ALLOW_ZONAL_FILT

C     !LOCAL VARIABLES:
      INTEGER bi,bj
      INTEGER i, j, k
      _RL uFlow(1-OLx:sNx+OLx,1-OLy:sNy+OLy)

      DO bj=myByLo(myThid),myByHi(myThid)
      DO bi=myBxLo(myThid),myBxHi(myThid)

       IF ( select_rStar.GT.0 ) THEN

        DO k=1,Nr
C--     Loop on vertical index k
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           uFlow(i,j) = uFld(i,j,k,bi,bj)*hFacW(i,j,k,bi,bj)
          ENDDO
         ENDDO
         CALL ZONAL_FILTER(
     U                     uFlow,
     I                     hFacW(1-OLx,1-OLy,k,bi,bj),
     I                     0, sNy+1, 1, bi, bj, 1, myThid )
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           uFld(i,j,k,bi,bj) = uFlow(i,j)*recip_hFacW(i,j,k,bi,bj)
          ENDDO
         ENDDO
C--     end of k loop
        ENDDO

       ELSE

        CALL ZONAL_FILTER(
     U                     uFld( 1-OLx,1-OLy,1,bi,bj),
     I                     hFacW(1-OLx,1-OLy,1,bi,bj),
     I                     0, sNy+1, Nr, bi, bj, 1, myThid )

       ENDIF

       CALL ZONAL_FILTER(
     U                     vFld( 1-OLx,1-OLy,1,bi,bj),
     I                     hFacS(1-OLx,1-OLy,1,bi,bj),
     I                     0, sNy+1, Nr, bi, bj, 2, myThid )

      ENDDO
      ENDDO

#endif /* ALLOW_ZONAL_FILT */

      RETURN
      END

#include "THSICE_OPTIONS.h"
CBOP
C     !ROUTINE: THSICE_WRITE_PICKUP
C     !INTERFACE:
      SUBROUTINE THSICE_WRITE_PICKUP( permPickup, suff,
     I                                myTime, myIter, myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R THSICE_WRITE_PICKUP
C     | o Write thsice pickup file
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "THSICE_PARAMS.h"
#include "THSICE_VARS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     permPickup :: write a permanent pickup
C     suff    :: suffix for pickup file (eg. ckptA or 0000000010)
C     myTime  :: Current time in simulation
C     myIter  :: Current iteration number in simulation
C     myThid  :: My Thread Id number
      LOGICAL permPickup
      CHARACTER*(*) suff
      _RL     myTime
      INTEGER myIter
      INTEGER myThid
CEOP

#ifdef ALLOW_THSICE
C     == Local variables ==
      CHARACTER*(MAX_LEN_FNAM) fn
      INTEGER prec

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#ifdef ALLOW_OCN_COMPON_INTERF
      IF ( useCoupler .AND. thSIce_skipThermo ) RETURN
#endif /* ALLOW_OCN_COMPON_INTERF */

      IF ( thSIce_pickup_write_mdsio ) THEN
        prec = precFloat64
        WRITE(fn,'(A,A)') 'pickup_ic.',suff

        CALL WRITE_REC_3D_RL( fn,prec, 1, iceMask,  1, myIter,myThid )
        CALL WRITE_REC_3D_RL( fn,prec, 1, iceHeight,2, myIter,myThid )
        CALL WRITE_REC_3D_RL( fn,prec, 1,snowHeight,3, myIter,myThid )
        CALL WRITE_REC_3D_RL( fn,prec, 1, Tsrf,     4, myIter,myThid )
        CALL WRITE_REC_3D_RL( fn,prec, 1, Tice1,    5, myIter,myThid )
        CALL WRITE_REC_3D_RL( fn,prec, 1, Tice2,    6, myIter,myThid )
        CALL WRITE_REC_3D_RL( fn,prec, 1, Qice1,    7, myIter,myThid )
        CALL WRITE_REC_3D_RL( fn,prec, 1, Qice2,    8, myIter,myThid )
        CALL WRITE_REC_3D_RL( fn,prec, 1, snowAge,  9, myIter,myThid )

        IF ( stepFwd_oceMxL ) THEN
         CALL WRITE_REC_3D_RL( fn,prec,1, tOceMxL, 10, myIter,myThid )
         CALL WRITE_REC_3D_RL( fn,prec,1, sOceMxL, 11, myIter,myThid )
        ENDIF
      ENDIF

#ifdef ALLOW_MNC
      IF ( thSIce_pickup_write_mnc ) THEN
        IF ( permPickup ) THEN
          WRITE(fn,'(A)') 'pickup_ic'
        ELSE
          WRITE(fn,'(A,A)') 'pickup_ic.',suff
        ENDIF
C       First ***define*** the file group name
        CALL MNC_CW_SET_UDIM(fn, 0, myThid)
        IF ( permPickup ) THEN
          CALL MNC_CW_SET_CITER(fn, 3, 3, myIter, 0, myThid)
        ELSE
          CALL MNC_CW_SET_CITER(fn, 2, -1, -1, -1, myThid)
        ENDIF
C       Then set the actual unlimited dimension
        CALL MNC_CW_SET_UDIM(fn, 1, myThid)
        CALL MNC_CW_I_W_S('I',fn,0,0,'iter', myIter, myThid)
C       CALL MNC_CW_RL_W_S('D',fn,0,0,'T', myTime, myThid)
        CALL MNC_CW_RL_W('D',fn,0,0,'iceMask',   iceMask,   myThid)
        CALL MNC_CW_RL_W('D',fn,0,0,'iceHeight', iceHeight, myThid)
        CALL MNC_CW_RL_W('D',fn,0,0,'snowHeight',snowHeight,myThid)
        CALL MNC_CW_RL_W('D',fn,0,0,'Tsrf',      Tsrf,      myThid)
        CALL MNC_CW_RL_W('D',fn,0,0,'Tice1',     Tice1,     myThid)
        CALL MNC_CW_RL_W('D',fn,0,0,'Tice2',     Tice1,     myThid)
        CALL MNC_CW_RL_W('D',fn,0,0,'Qice1',     Qice1,     myThid)
        CALL MNC_CW_RL_W('D',fn,0,0,'Qice2',     Qice2,     myThid)
        CALL MNC_CW_RL_W('D',fn,0,0,'snowAge',   snowAge,   myThid)
        IF ( stepFwd_oceMxL ) THEN
          CALL MNC_CW_RL_W('D',fn,0,0,'tOceMxL',tOceMxL,myThid)
          CALL MNC_CW_RL_W('D',fn,0,0,'sOceMxL',sOceMxL,myThid)
        ENDIF
      ENDIF
#endif  /* ALLOW_MNC */

#endif  /* ALLOW_THSICE */
      RETURN
      END

#include "THSICE_OPTIONS.h"

C     !ROUTINE: THSICE_CHECK_CONSERV
C     !INTERFACE:
      SUBROUTINE THSICE_CHECK_CONSERV(
     I             dBugFlag, i, j, bi, bj, iceStart,
     I             iceFrac, compact, hIce, hSnow, qicen,
     I             qleft, ffresh, fsalt,
     I             myTime, myIter, myThid )
C     *==========================================================*
C     | S/R  THSICE_CHECK_CONSERV
C     | o Check Conservation of Energy, water and salt
C     *==========================================================*

C     !USES:
      IMPLICIT NONE
C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
c #include "PARAMS.h"
#include "THSICE_SIZE.h"
#include "THSICE_PARAMS.h"
#include "THSICE_VARS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
C     myIter :: iteration counter for this thread
C     myTime :: time counter for this thread
C     myThid :: thread number for this instance of the routine.
      LOGICAL dBugFlag
      INTEGER i,j, bi,bj
      INTEGER iceStart
      _RL iceFrac
      _RL compact, hIce, hSnow, qicen(nlyr)
      _RL qleft, fsalt, ffresh
      _RL  myTime
      INTEGER myIter
      INTEGER myThid

#ifdef ALLOW_THSICE
C     !LOCAL VARIABLES:
C     === Local variables ===
      _RL dEnerg, dWater, dSalt
      _RL flxFrac
      _RL flxAtm, frwAtm
      LOGICAL dBugLoc

C-    define grid-point location where to print debugging values
#include "THSICE_DEBUG.h"

 1010 FORMAT(A,1P4E14.6)

          dBugLoc = .FALSE.
#ifdef ALLOW_DBUG_THSICE
          dBugLoc = dBug(i,j,bi,bj)
#endif
          flxFrac = iceFrac
          flxAtm = icFlxAtm(i,j,bi,bj)
          frwAtm = icFrwAtm(i,j,bi,bj)
          IF (iceStart.EQ.1) flxFrac = 1.

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
          dEnerg= -rhos*snowHeight(i,j,bi,bj)*qsnow
     &            -rhoi*iceHeight(i,j,bi,bj)
     &             *(Qice1(i,j,bi,bj)+Qice2(i,j,bi,bj))*0.5
          dWater = rhos*snowheight(i,j,bi,bj)+rhoi*iceHeight(i,j,bi,bj)
          dSalt =  rhoi*iceHeight(i,j,bi,bj)*saltice
         IF (dBugLoc) WRITE(6,1010) 'ThSI_CHK: Ener0,Water0,Salt0 =',
     &    dEnerg, dWater, dSalt
C--
          dEnerg = dEnerg*iceFrac
     &     + compact*( rhos*hSnow*qsnow
     &               + rhoi*hIce*(qicen(1)+qicen(2))*0.5
     &               )
          dWater = dWater*iceFrac
     &     - compact*( rhos*hSnow + rhoi*hIce )
          dSalt =  dSalt*iceFrac
     &     - compact* rhoi*hIce*saltice

         IF (dBugLoc) WRITE(6,1010) 'ThSI_CHK: dEner,dH20,dSal /dt=',
     &    dEnerg/thSIce_deltaT,dWater/thSIce_deltaT,dSalt/thSIce_deltaT
         IF (dBugLoc) WRITE(6,1010) 'ThSI_CHK: fxH,fxW,fxS=',
     &    flxAtm-qleft, -ffresh-frwAtm,-fsalt
          dEnerg = dEnerg + thSIce_deltaT*flxFrac*(flxAtm-qleft)
          dWater = dWater - thSIce_deltaT*flxFrac*(ffresh+frwAtm)
          dSalt  = dSalt  - thSIce_deltaT*flxFrac*fsalt

c#ifdef ALLOW_TIMEAVE
c         ice_flx2oc_Ave(i,j,bi,bj) = ice_flx2oc_Ave(i,j,bi,bj)
c    &          + dEnerg
c         ice_frw2oc_Ave(i,j,bi,bj) = ice_frw2oc_Ave(i,j,bi,bj)
c    &          + dWater
c         ice_salFx_Ave(i,j,bi,bj) = ice_salFx_Ave(i,j,bi,bj)
c    &          + dSalt
c#endif /*ALLOW_TIMEAVE*/
C--
         IF (dBugLoc) WRITE(6,1010) 'ThSI_CHK: resid.H,W,S=',
     &    dEnerg/thSIce_deltaT,dWater/thSIce_deltaT,dSalt/thSIce_deltaT
         IF (dBugLoc) WRITE(6,1010) 'ThSI_CHK: hIc,hSn,snow*dt=',
     &    hIce, hSnow
c    &    hIce, hSnow, snowPrc(i,j,bi,bj)*thSIce_deltaT/rhos

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#endif  /*ALLOW_THSICE*/

      RETURN
      END

#include "MDSIO_OPTIONS.h"

CBOP
C     !ROUTINE: MDS_WRITE_META
C     !INTERFACE:
      SUBROUTINE MDS_WRITE_META(
     I    mFileName,
     I    dFileName,
     I    simulName,
     I    titleLine,
     I    filePrec,
     I    nDims,   dimList, map2gl,
     I    nFlds,   fldList,
     I    nTimRec, timList, misVal,
     I    nrecords, myIter, myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R MDS_WRITE_META
C     | o Write 1 meta file to disk
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     == Global variables / common blocks
#include "SIZE.h"
#include "EEPARAMS.h"
#ifdef ALLOW_CAL
# include "PARAMS.h"
#endif

C     !INPUT PARAMETERS:
C     mFileName (string ) :: complete name of meta-file
C     dFileName (string ) :: complete name of data-file
C     simulName (string)  :: name of this simulation
C     titleLine (string)  :: title or any descriptive comments
C     filePrec  (integer) :: number of bits per word in data-file (32 or 64)
C     nDims     (integer) :: number of dimensions
C     dimList   (integer) :: array of dimensions, etc.
C     map2gl    (integer) :: used for mapping tiled file to global file
C     nFlds     (integer) :: number of fields in "fldList"
C     fldList   (string)  :: array of field names to write
C     nTimRec   (integer) :: number of time-specification in "timList"
C     timList   (real)    :: array of time-specifications to write
C     misVal    (real)    :: missing value (ignored if = 1.)
C     nrecords  (integer) :: record number
C     myIter    (integer) :: time-step number
C     myThid    (integer) :: my Thread Id number
C
C     !OUTPUT PARAMETERS:
C
      CHARACTER*(*) mFileName
      CHARACTER*(*) dFileName
      CHARACTER*(*) simulName
      CHARACTER*(*) titleLine
      INTEGER filePrec
      INTEGER nDims
      INTEGER dimList(3,nDims)
      INTEGER map2gl(2)
      INTEGER nFlds
      CHARACTER*(8) fldList(*)
      INTEGER nTimRec
      _RL     timList(*)
      _RL     misVal
      INTEGER nrecords
      INTEGER myIter
      INTEGER myThid
CEOP

C     !FUNCTIONS
      INTEGER  ILNBLNK
      EXTERNAL ILNBLNK

C     !LOCAL VARIABLES:
      INTEGER i,j,ii,iL
      INTEGER mUnit
c     LOGICAL exst
      CHARACTER*(MAX_LEN_MBUF) msgBuf
#ifdef ALLOW_CAL
      _RL     myTime
      INTEGER myDate(4)
      INTEGER year, month, day, hour, minute, second
#endif

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C We should *read* the met-file IF it exists to check
C  that the information we are writing is consistent
C  with the current contents
c     INQUIRE( file=mFileName, exist=exst )
C However, it is bloody difficult to parse files in fortran so someone
C  else can do this.
C For now, we will assume everything is ok and that the last record
C  is written to the last consecutive record in the file.

C-    Assign a free unit number as the I/O channel for this subroutine
      CALL MDSFINDUNIT( mUnit, myThid )

C-    Open meta-file
      OPEN( mUnit, file=mFileName, status='unknown',
     &      form='formatted' )

C-    Write the simulation name
      iL = ILNBLNK(simulName)
      IF ( iL.GT.0 ) THEN
       WRITE(mUnit,'(3A)') " simulation = { '",simulName(1:iL),"' };"
      ENDIF

C-    Write the number of dimensions
      WRITE(mUnit,'(1X,A,I3,A)') 'nDims = [ ',nDims,' ];'

C-    For each dimension, write the following:
C     1  global size  (ie. the size of the global dimension of all files)
C     2  global start (ie. the global position of the start of this file)
C     3  global end   (ie. the global position of the end   of this file)

      ii = 0
      DO j=1,nDims
       ii = MAX(dimList(1,j),ii)
      ENDDO
      WRITE(mUnit,'(1X,A)') 'dimList = ['
      IF ( ii.LT.10000 ) THEN
C     Small-size domain:
       DO j=1,nDims
        IF (j.LT.nDims) THEN
         WRITE(mUnit,'(1X,3(I5,","))')    (dimList(i,j),i=1,3)
        ELSE
         WRITE(mUnit,'(1X,2(I5,","),I5)') (dimList(i,j),i=1,3)
        ENDIF
       ENDDO
      ELSE
C     Large-size domain:
       DO j=1,nDims
        IF (j.LT.nDims) THEN
         WRITE(mUnit,'(1X,3(I10,","))')     (dimList(i,j),i=1,3)
        ELSE
         WRITE(mUnit,'(1X,2(I10,","),I10)') (dimList(i,j),i=1,3)
        ENDIF
       ENDDO
      ENDIF
      WRITE(mUnit,'(1X,A)') '];'
C-    only write if different from default:
      IF ( map2gl(1).NE.0 .OR. map2gl(2).NE.1 ) THEN
        WRITE(mUnit,'(1X,2(A,I5),A)') 'map2glob = [ ',
     &                  map2gl(1),',',map2gl(2),' ];'
      ENDIF

C-    Record the precision of the file
      IF (filePrec .EQ. precFloat32) THEN
       WRITE(mUnit,'(1X,A)') "dataprec = [ 'float32' ];"
      ELSEIF (filePrec .EQ. precFloat64) THEN
       WRITE(mUnit,'(1X,A)') "dataprec = [ 'float64' ];"
      ELSE
       WRITE(msgBuf,'(A)')
     &   ' MDSWRITEMETA: invalid filePrec'
       CALL PRINT_ERROR( msgBuf, myThid )
       STOP 'ABNORMAL END: S/R MDSWRITEMETA'
      ENDIF

C-    Record the current record number
C     This is a proxy for the actual number of records in the file.
C     If we could read the file then we could do this properly.
      WRITE(mUnit,'(1X,A,I10,A)') 'nrecords = [ ',nrecords,' ];'

C-    Record the file-name for the binary data
Cveto ii=ILNBLNK( dFileName )
Cveto WRITE(mUnit,'(1X,3A)') 'binarydatafile = [ ',dFileName(1:ii),' ];'

C-    Write the integer time (integer iteration number) for later record
C     keeping. If the timestep number is less than 0 then we assume
C     that the information is superfluous and do not write it.
      IF ( myIter.GE.0 )
     & WRITE(mUnit,'(1X,A,I10,A)') 'timeStepNumber = [ ',myIter,' ];'

#ifdef ALLOW_CAL
      IF ( useCal .AND. myIter.GE.0 ) THEN
C     add the date and time according to pkg/cal that corresponds to the
C     current timestep myIter,
C     First recover current time and get date in pkg/cal-format
       myTime = baseTime + myIter*deltaTClock
       CALL CAL_GETDATE( myIter, myTime, myDate, myThid )
CMLC     this is simpler, but not so easy to read
CML       WRITE(mUnit,'(1X,A,I8.8,A,I6.6,A)')
CML     &      "timeStepDate (YYYYMMDDTHHmmss) = [ '",
CML     &      myDate(1),"T",myDate(2),"' ];"
C     Follow ISO 8601
       day    = MOD(myDate(1),100)
       month  = MOD(myDate(1)/100,100)
       year   = myDate(1)/10000
       second = MOD(myDate(2),100)
       minute = MOD(myDate(2)/100,100)
       hour   = myDate(2)/10000
       WRITE(mUnit,'(1X,A,I4.4,A,5(I2.2,A))')
     &      "timeStepDate = [ '",
     &      year,"-",month,"-",day,"T",hour,":",minute,":",second,
     &      "Z' ];"
      ENDIf
#endif

C-    Write list of Time records
C note: format might change once we have a better idea of what will
C       be the time-information to write.
      IF ( nTimRec.GT.0 ) THEN
       ii = MIN(nTimRec,20)
       WRITE(msgBuf,'(1P20E20.12)') (timList(i),i=1,ii)
       WRITE(mUnit,'(1X,3A)') 'timeInterval = [', msgBuf(1:20*ii),' ];'
      ENDIF

C-    Write missing value
      IF ( misVal.NE.oneRL ) THEN
       WRITE(mUnit,'(1X,A,1PE21.14,A)')
     &                        'missingValue = [ ',misVal,' ];'
      ENDIF

C-    Write list of Fields
      IF ( nFlds.GT.0 ) THEN
        WRITE(mUnit,'(1X,A,I4,A)') 'nFlds = [ ', nFlds, ' ];'
        WRITE(mUnit,'(1X,A)') 'fldList = {'
        WRITE(mUnit,'(20(A2,A8,A1))')
     &          (" '",fldList(i),"'",i=1,nFlds)
        WRITE(mUnit,'(1X,A)') '};'
      ENDIF

C-    Write title or comments (but ignored by rdmds)
      iL = ILNBLNK(titleLine)
      IF ( iL.GT.0 ) THEN
       WRITE(mUnit,'(3A)')' /* ', titleLine(1:iL), ' */'
      ENDIF

C-    Close meta-file
      CLOSE(mUnit)

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      RETURN
      END

#include "PACKAGES_CONFIG.h"
#include "CPP_OPTIONS.h"

CBOP
C     !ROUTINE: DIAGS_SOUND_SPEED
C     !INTERFACE:
      SUBROUTINE DIAGS_SOUND_SPEED(
     I                       myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R DIAGS_SOUND_SPEED
C     | o Diagnose speed of sound in seawater
C     |   from the algorithm by Del Grosso (1974).
C     |   This is NOT the sound-speed that can be derived from
C     |   the equation of state (EOS). It is independent of
C     |   the model setup specific EOS.
C     |
C     | o Reference:
C     | V. A. Del Grosso, "New equation for the speed of sound in
C     | natural waters (with comparisons to other equations),"
C     | J. Acoust. Soc. Am. 56, 1084-1091 (1974).
C     *==========================================================*
C     \ev
C     !USES:
      IMPLICIT NONE
C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "SURFACE.h"
#include "DYNVARS.h"
#include "EOS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine Arguments ==
C     myThid :: Thread number for this instance of the routine.
      INTEGER myThid

#ifdef INCLUDE_SOUNDSPEED_CALC_CODE
C     !FUNCTIONS:
      _RL SW_TEMP
      EXTERNAL SW_TEMP
#ifdef ALLOW_DIAGNOSTICS
      LOGICAL  DIAGNOSTICS_IS_ON
      EXTERNAL DIAGNOSTICS_IS_ON
#endif /* ALLOW_DIAGNOSTICS */

C     !LOCAL VARIABLES:
C     == Local variables ==
      INTEGER bi,bj
      INTEGER i,j,k
      _RL c0,ct,cs,cp,cstp
      _RL pres,sal,temp
      LOGICAL calc_soundSpeed
CEOP

      calc_soundSpeed = .FALSE.

C--   switch on this flag if Sound-Speed needed in any cost fct
c#ifdef ALLOW_CSOUND_COST
c     calc_soundSpeed = .TRUE.
c#endif

#ifdef ALLOW_DIAGNOSTICS
      IF ( useDiagnostics ) THEN
        calc_soundSpeed = calc_soundSpeed
     &               .OR. DIAGNOSTICS_IS_ON( 'CSound  ', myThid )
      ENDIF
#endif /* ALLOW_DIAGNOSTICS */

      IF ( calc_soundSpeed ) THEN
       c0   = 1402.392 _d 0
       ct   = 0. _d 0
       cs   = 0. _d 0
       cp   = 0. _d 0
       cstp = 0. _d 0
       pres = 0. _d 0
       sal  = 0. _d 0
       temp = 0. _d 0
       DO bj=myByLo(myThid),myByHi(myThid)
        DO bi=myBxLo(myThid),myBxHi(myThid)
         DO k=1,Nr
          DO j=1,sNy
           DO i=1,sNx
            cSound(i,j,k,bi,bj) = 0.0 _d 0
           ENDDO
          ENDDO
         ENDDO
         DO k=1,Nr
          DO j=1,sNy
           DO i=1,sNx
            IF ( maskC(i,j,k,bi,bj).EQ.oneRS ) THEN
C pressure in dbar (for SW_TEMP)
             pres = rhoConst*( totPhiHyd(i,j,k,bi,bj)
     &               - rC(k)*gravity )*SItodBar
             temp = SW_TEMP( SALT(i,j,k,bi,bj),
     &                 THETA(i,j,k,bi,bj), pres, zeroRL )
             sal  = SALT(i,j,k,bi,bj)
C convert pressure to kg/cm^2 for Del Grosso algorithm
             pres = pres/gravity
             ct   = ( 5.01109398873 _d 0 - ( 0.550946843172 _d -1
     &              - 0.221535969240 _d -3 * temp ) * temp ) * temp
             cs   = ( 1.32952290781 _d 0 + 0.128955756844 _d -3 * sal
     &              ) * sal
             cp   = ( 0.156059257041 _d 0 + ( 0.244998688441 _d -4
     &              - 0.883392332513 _d -8 * pres ) * pres ) * pres
             cstp = ( - 0.127562783426 _d -1
     &                + 0.968403156410 _d -4 *temp ) * temp * sal
     &            + ((  0.635191613389 _d -2
     &                +(0.265484716608 _d -7 *temp
     &                - 0.159349479045 _d -5
     &                + 0.522116437235 _d -9 *pres ) * pres
     &                - 0.438031096213 _d -6 * temp * temp
     &                +(0.485639620015 _d -5 * sal
     &                - 0.340597039004 _d -3 ) *sal ) * temp
     &                - 0.161674495909 _d -8 * sal * sal * pres
     &              ) * pres
             cSound(i,j,k,bi,bj) = c0+ct+cs+cp+cstp
            ENDIF
           ENDDO
          ENDDO
         ENDDO
        ENDDO
       ENDDO
#ifdef ALLOW_DIAGNOSTICS
       IF ( useDiagnostics ) THEN
        CALL DIAGNOSTICS_FILL(cSound,'CSound  ',0,Nr,0,1,1,myThid)
       ENDIF
#endif /* ALLOW_DIAGNOSTICS */

C-    end-if calc_soundSpeed
      ENDIF

#endif /* INCLUDE_SOUNDSPEED_CALC_CODE */

      RETURN
      END

#include "GGL90_OPTIONS.h"

CBOP
C !ROUTINE: GGL90_EXCHANGES

C !INTERFACE: ==========================================================
      SUBROUTINE GGL90_EXCHANGES( myThid )

C !DESCRIPTION: \bv
C     *================================================================*
C     | S/R GGL90_EXCHANGES
C     | Exchange data to update overlaps for GGL90TKE
C     *================================================================*
C \ev

C !USES: ===============================================================
      IMPLICIT NONE
C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "GGL90.h"

C     !INPUT/OUTPUT PARAMETERS: ========================================
C      myThid     :: my Thread Id number
      INTEGER myThid

#ifdef ALLOW_GGL90
C !LOCAL VARIABLES: ====================================================
CEOP

#ifdef ALLOW_GGL90_IDEMIX
      IF ( useIDEMIX .AND. IDEMIX_tau_h .GT. zeroRL ) THEN
       _EXCH_XYZ_RL( GGL90TKE, myThid )
       _EXCH_XYZ_RL( IDEMIX_E, myThid )
      ELSEIF ( GGL90diffTKEh .GT. zeroRL ) THEN
#else /* ALLOW_GGL90_IDEMIX */
      IF ( GGL90diffTKEh .GT. zeroRL ) THEN
#endif /* ALLOW_GGL90_IDEMIX */
       _EXCH_XYZ_RL( GGL90TKE, myThid )
      ENDIF

C--   Just to check that it does not affects results:
c      CALL EXCH_UV_3D_RL( GGL90viscArU, GGL90viscArV,
c    I                     .FALSE., Nr, myThid )
#endif /* ALLOW_GGL90 */

      RETURN
      END

#include "OBCS_OPTIONS.h"

CBOP
C     !ROUTINE: OBCS_READPARMS
C     !INTERFACE:
      SUBROUTINE OBCS_READPARMS( myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE OBCS_READPARMS
C     | o Routine to initialize OBCS variables and constants.
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "OBCS_PARAMS.h"
#include "OBCS_GRID.h"
#include "OBCS_SEAICE.h"
#ifdef ALLOW_ORLANSKI
#include "ORLANSKI.h"
#endif
#ifdef ALLOW_PTRACERS
#include "PTRACERS_SIZE.h"
#include "OBCS_PTRACERS.h"
#endif /* ALLOW_PTRACERS */
#ifdef ALLOW_EXCH2
#include "W2_EXCH2_SIZE.h"
#include "W2_EXCH2_TOPOLOGY.h"
#include "W2_EXCH2_PARAMS.h"
#endif /* ALLOW_EXCH2 */

C     !INPUT/OUTPUT PARAMETERS:
      INTEGER myThid

#ifdef ALLOW_OBCS
C     !FUNCTIONS:
      INTEGER  ILNBLNK
      EXTERNAL ILNBLNK

C     !LOCAL VARIABLES:
C     msgBuf       :: Informational/error message buffer
C     iUnit        :: Work variable for IO unit number
C  OB_indexUnset   :: OB index value for places where no OB is defined
C  OB_singleJnorth :: global/uniform Northern OB position index
C  OB_singleJsouth :: global/uniform Southern OB position index
C  OB_singleIeast  :: global/uniform Eastern  OB position index
C  OB_singleIwest  :: global/uniform Western  OB position index
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      INTEGER iUnit
      INTEGER errCount
      INTEGER i, j
      INTEGER bi, bj, iG, jG, iGm, jGm
      INTEGER OB_indexUnset
#ifdef ALLOW_PTRACERS
      INTEGER iTracer
#endif
#ifdef ALLOW_EXCH2
      INTEGER tN
#endif /* ALLOW_EXCH2 */

C These are input arrays (of integers) that contain the *absolute*
C computational index of an open-boundary (OB) point.
C A zero (0) element means there is no corresponding OB in that column/row.
C The computational coordinate refers to "tracer" cells.
C For a northern/southern OB, the OB V point is to the south/north.
C For an eastern/western OB, the OB U point is to the west/east.
C eg.
C     OB_Jnorth(3)=34  means that:
C          T( 3 ,34) is a an OB point
C          U(3:4,34) is a an OB point
C          V( 4 ,34) is a an OB point
C while
C     OB_Jsouth(3)=1  means that:
C          T( 3 ,1) is a an OB point
C          U(3:4,1) is a an OB point
C          V( 4 ,2) is a an OB point
C
C For convenience, negative values for Jnorth/Ieast refer to
C points relative to the Northern/Eastern edges of the model
C eg. OB_Jnorth(3)=-1  means that the point (3,Ny) is a northern O-B.
C
C When the OB index value is uniform across the full domain, one can set
C a unique OB index value using local parameter OB_singleJnorth/south,
C  OB_singleIeast/west, (same index convention) instead of multiple/repeating
C index setting
C
C With exch2, the global domain used for specifying the boundary (and
C boundary value files) is different for N,S and E,W boundaries:
C - for N,S, the facets are stacked in x (like W2_mapIO=-1)
C - for E,W, the facets are stacked in y, so that E,W boundaries in
C   different facets cannot have the same I
C
C OB_Jnorth(W2_maxXStackNx) :: global index array of northern open-boundary point
C OB_Jsouth(W2_maxXStackNx) :: global index array of southern open-boundary point
C OB_Ieast(W2_maxYStackNy)  :: global index array of eastern  open-boundary point
C OB_Iwest(W2_maxYStackNy)  :: global index array of western  open-boundary point

#ifdef ALLOW_EXCH2
      INTEGER OB_Jnorth(W2_maxXStackNx)
      INTEGER OB_Jsouth(W2_maxXStackNx)
      INTEGER OB_Ieast(W2_maxYStackNy)
      INTEGER OB_Iwest(W2_maxYStackNy)
#else
      INTEGER OB_Jnorth(Nx)
      INTEGER OB_Jsouth(Nx)
      INTEGER OB_Ieast(Ny)
      INTEGER OB_Iwest(Ny)
#endif
      INTEGER OB_singleJnorth
      INTEGER OB_singleJsouth
      INTEGER OB_singleIeast
      INTEGER OB_singleIwest

C With exch2, we use different global domains for specifying
C N,S resp. E,W boundaries (and for reading in the corresponding data):
C
C     OBNS_Nx ::  width of global domain for OB_Jnorth, OB_Jsouth
C     OBNS_Ny :: height of global domain for OB_Jnorth, OB_Jsouth
C     OBEW_Nx ::  width of global domain for OB_Ieast, OB_Iwest
C     OBEW_Ny :: height of global domain for OB_Ieast, OB_Iwest

      INTEGER OBNS_Nx, OBNS_Ny
      INTEGER OBEW_Nx, OBEW_Ny
CEOP

C     Retired parameters:
      INTEGER nRetired
      LOGICAL useOBCSYearlyFields
      _RL tidalPeriod(OBCS_tideCompSize)
      CHARACTER*(MAX_LEN_FNAM)
     &      OBNamFile, OBSamFile, OBEamFile, OBWamFile,
     &      OBNphFile, OBSphFile, OBEphFile, OBWphFile

      NAMELIST /OBCS_PARM01/
     &          insideOBmaskFile,
     &          OBNconnectFile, OBSconnectFile,
     &          OBEconnectFile, OBWconnectFile,
     &          OB_Jnorth, OB_Jsouth, OB_Ieast, OB_Iwest,
     &          OB_singleJnorth, OB_singleJsouth,
     &          OB_singleIeast,  OB_singleIwest,
     &          useOrlanskiNorth, useOrlanskiSouth,
     &          useOrlanskiEast,  useOrlanskiWest,
     &          useStevensNorth, useStevensSouth,
     &          useStevensEast,  useStevensWest,
     &          useOBCSprescribe, useOBCStides, OBCS_tidalPeriod,
     &          OBCS_u1_adv_T, OBCS_u1_adv_S,
     &          OBNuFile, OBNvFile, OBNtFile, OBNsFile, OBNetaFile,
     &          OBSuFile, OBSvFile, OBStFile, OBSsFile, OBSetaFile,
     &          OBEuFile, OBEvFile, OBEtFile, OBEsFile, OBEetaFile,
     &          OBWuFile, OBWvFile, OBWtFile, OBWsFile, OBWetaFile,
     &          OBNwFile,  OBSwFile,  OBEwFile,  OBWwFile,
     &  OBN_uTidAmFile, OBS_uTidAmFile, OBE_uTidAmFile, OBW_uTidAmFile,
     &  OBN_vTidAmFile, OBS_vTidAmFile, OBE_vTidAmFile, OBW_vTidAmFile,
     &  OBN_uTidPhFile, OBS_uTidPhFile, OBE_uTidPhFile, OBW_uTidPhFile,
     &  OBN_vTidPhFile, OBS_vTidPhFile, OBE_vTidPhFile, OBW_vTidPhFile,
     &          OBNaFile,  OBSaFile,  OBEaFile,  OBWaFile,
     &          OBNhFile,  OBShFile,  OBEhFile,  OBWhFile,
     &          OBNslFile, OBSslFile, OBEslFile, OBWslFile,
     &          OBNsnFile, OBSsnFile, OBEsnFile, OBWsnFile,
     &          OBNuiceFile, OBSuiceFile, OBEuiceFile, OBWuiceFile,
     &          OBNviceFile, OBSviceFile, OBEviceFile, OBWviceFile,
#ifdef ALLOW_PTRACERS
     &          OBCS_u1_adv_Tr,
     &          OBNptrFile, OBSptrFile, OBEptrFile, OBWptrFile,
#endif
     &          useOBCSsponge, useSeaiceSponge, useSeaiceNeumann,
     &          OBCSsponge_N , OBCSsponge_S,
     &          OBCSsponge_E, OBCSsponge_W,
     &          OBCSsponge_UatNS, OBCSsponge_UatEW,
     &          OBCSsponge_VatNS, OBCSsponge_VatEW,
     &          OBCSsponge_Theta, OBCSsponge_Salt, useLinearSponge,
     &          useOBCSbalance, OBCSbalanceSurf,
     &          OBCS_balanceFacN, OBCS_balanceFacS,
     &          OBCS_balanceFacE, OBCS_balanceFacW,
     &          OBCSfixTopo, OBCS_uvApplyFac,
     &          OBCS_monitorFreq, OBCS_monSelect, OBCSprintDiags,
     &          useOBCSYearlyFields,
     &          OBNAmFile, OBSAmFile, OBEAmFile, OBWAmFile,
     &          OBNPhFile, OBSPhFile, OBEPhFile, OBWPhFile,
     &          tidalPeriod

#ifdef ALLOW_ORLANSKI
      NAMELIST /OBCS_PARM02/
     & CMAX, cvelTimeScale, CFIX, useFixedCEast, useFixedCWest
#endif

#ifdef ALLOW_OBCS_SPONGE
      NAMELIST /OBCS_PARM03/
     &          Urelaxobcsinner,Urelaxobcsbound,
     &          Vrelaxobcsinner,Vrelaxobcsbound,
     &          spongeThickness
#endif
#ifdef ALLOW_OBCS_STEVENS
      NAMELIST /OBCS_PARM04/
     &          TrelaxStevens,SrelaxStevens,
     &          useStevensPhaseVel,useStevensAdvection
#endif /* ALLOW_OBCS_STEVENS */
#ifdef ALLOW_OBCS_SEAICE_SPONGE
      NAMELIST /OBCS_PARM05/
     &           Arelaxobcsinner, Arelaxobcsbound,
     &           Hrelaxobcsinner, Hrelaxobcsbound,
     &          SLrelaxobcsinner,SLrelaxobcsbound,
     &          SNrelaxobcsinner,SNrelaxobcsbound,
     &          seaiceSpongeThickness
#endif

      IF ( .NOT.useOBCS ) THEN
C-    pkg OBCS is not used
        _BEGIN_MASTER(myThid)
C-    Track pkg activation status:
C     print a (weak) warning if data.obcs is found
         CALL PACKAGES_UNUSED_MSG( 'useOBCS', ' ', ' ' )
        _END_MASTER(myThid)
        RETURN
      ENDIF

      _BEGIN_MASTER(myThid)

#ifdef ALLOW_EXCH2
      OBNS_Nx = exch2_xStack_Nx
      OBNS_Ny = exch2_xStack_Ny
      OBEW_Nx = exch2_yStack_Nx
      OBEW_Ny = exch2_yStack_Ny
#else
      OBNS_Nx = Nx
      OBNS_Ny = Ny
      OBEW_Nx = Nx
      OBEW_Ny = Ny
#endif

C--   Default flags and values for OBCS
      OB_indexNone  = -99
      OB_indexUnset = 0
      insideOBmaskFile = ' '
      OBNconnectFile   = ' '
      OBSconnectFile   = ' '
      OBEconnectFile   = ' '
      OBWconnectFile   = ' '
      DO i=1,OBNS_Nx
       OB_Jnorth(i) = OB_indexUnset
       OB_Jsouth(i) = OB_indexUnset
      ENDDO
      DO j=1,OBEW_Ny
       OB_Ieast(j) = OB_indexUnset
       OB_Iwest(j) = OB_indexUnset
      ENDDO
      OB_singleJnorth = OB_indexUnset
      OB_singleJsouth = OB_indexUnset
      OB_singleIeast = OB_indexUnset
      OB_singleIwest = OB_indexUnset
      OBCS_indexStatus = 0
      useOrlanskiNorth   =.FALSE.
      useOrlanskiSouth   =.FALSE.
      useOrlanskiEast    =.FALSE.
      useOrlanskiWest    =.FALSE.
      useStevensNorth    =.FALSE.
      useStevensSouth    =.FALSE.
      useStevensEast     =.FALSE.
      useStevensWest     =.FALSE.
      useStevensPhaseVel =.TRUE.
      useStevensAdvection=.TRUE.
      useOBCSprescribe   =.FALSE.
      useOBCStides       =.FALSE.
      useOBCSsponge      =.FALSE.
      useSeaiceSponge    =.FALSE.
      useSeaiceNeumann   =.FALSE.
      OBCSsponge_N       =.TRUE.
      OBCSsponge_S       =.TRUE.
      OBCSsponge_E       =.TRUE.
      OBCSsponge_W       =.TRUE.
      OBCSsponge_UatNS   =.TRUE.
      OBCSsponge_UatEW   =.TRUE.
      OBCSsponge_VatNS   =.TRUE.
      OBCSsponge_VatEW   =.TRUE.
      OBCSsponge_Theta   =.TRUE.
      OBCSsponge_Salt    =.TRUE.
      useLinearSponge    =.FALSE.
      useOBCSbalance     =.FALSE.
      OBCSbalanceSurf    =.FALSE.
      OBCS_balanceFacN   = 1. _d 0
      OBCS_balanceFacS   = 1. _d 0
      OBCS_balanceFacE   = 1. _d 0
      OBCS_balanceFacW   = 1. _d 0
      OBCS_u1_adv_T      = 0
      OBCS_u1_adv_S      = 0
      OBCSfixTopo        =.FALSE.
      OBCS_uvApplyFac    = 1. _d 0
      OBCS_monitorFreq   = monitorFreq
      OBCS_monSelect     = 0
      OBCSprintDiags     = debugLevel.GE.debLevC

      OBNuFile = ' '
      OBNvFile = ' '
      OBNtFile = ' '
      OBNsFile = ' '
      OBNaFile = ' '
      OBNhFile = ' '
      OBNslFile = ' '
      OBNsnFile = ' '
      OBNuiceFile = ' '
      OBNviceFile = ' '
      OBSuFile = ' '
      OBSvFile = ' '
      OBStFile = ' '
      OBSsFile = ' '
      OBSaFile = ' '
      OBShFile = ' '
      OBSslFile = ' '
      OBSsnFile = ' '
      OBSuiceFile = ' '
      OBSviceFile = ' '
      OBEuFile = ' '
      OBEvFile = ' '
      OBEtFile = ' '
      OBEsFile = ' '
      OBEaFile = ' '
      OBEhFile = ' '
      OBEslFile = ' '
      OBEsnFile = ' '
      OBEuiceFile = ' '
      OBEviceFile = ' '
      OBWuFile = ' '
      OBWvFile = ' '
      OBWtFile = ' '
      OBWsFile = ' '
      OBWaFile = ' '
      OBWhFile = ' '
      OBWslFile = ' '
      OBWsnFile = ' '
      OBWuiceFile = ' '
      OBWviceFile = ' '
      OBNetaFile = ' '
      OBSetaFile = ' '
      OBEetaFile = ' '
      OBWetaFile = ' '
      OBNwFile = ' '
      OBSwFile = ' '
      OBEwFile = ' '
      OBWwFile = ' '
      OBN_uTidAmFile = ' '
      OBN_uTidPhFile = ' '
      OBN_vTidAmFile = ' '
      OBN_vTidPhFile = ' '
      OBS_uTidAmFile = ' '
      OBS_uTidPhFile = ' '
      OBS_vTidAmFile = ' '
      OBS_vTidPhFile = ' '
      OBE_uTidAmFile = ' '
      OBE_uTidPhFile = ' '
      OBE_vTidAmFile = ' '
      OBE_vTidPhFile = ' '
      OBW_uTidAmFile = ' '
      OBW_uTidPhFile = ' '
      OBW_vTidAmFile = ' '
      OBW_vTidPhFile = ' '
#ifdef ALLOW_PTRACERS
      DO iTracer = 1, PTRACERS_num
       OBCS_u1_adv_Tr(iTracer) = 0
       OBNptrFile(iTracer) = ' '
       OBSptrFile(iTracer) = ' '
       OBEptrFile(iTracer) = ' '
       OBWptrFile(iTracer) = ' '
      ENDDO
#endif
c#ifdef ALLOW_OBCS_TIDES
      OBCS_nTidalComp = 0
      DO i = 1, OBCS_tideCompSize
       OBCS_tidalPeriod(i) = 0. _d 0
      ENDDO
c#endif
C-    retired parameters
      nRetired = 0
      useOBCSYearlyFields = .FALSE.
      OBNamFile = 'retired-and-unset'
      OBSamFile = 'retired-and-unset'
      OBEamFile = 'retired-and-unset'
      OBWamFile = 'retired-and-unset'
      OBNphFile = 'retired-and-unset'
      OBSphFile = 'retired-and-unset'
      OBEphFile = 'retired-and-unset'
      OBWphFile = 'retired-and-unset'
      DO i = 1, OBCS_tideCompSize
       tidalPeriod(i) = -1. _d 0
      ENDDO

C     Open and read the data.obcs file
      WRITE(msgBuf,'(A)') ' OBCS_READPARMS: opening data.obcs'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT , myThid )
      CALL OPEN_COPY_DATA_FILE(
     I                          'data.obcs', 'OBCS_READPARMS',
     O                          iUnit,
     I                          myThid )

C--   Read parameters from open data file
      READ(UNIT=iUnit,NML=OBCS_PARM01)

C-    retired parameter
      IF ( useOBCSYearlyFields ) THEN
       nRetired = nRetired + 1
       WRITE(msgBuf,'(A,A)') 'OBCS_READPARMS: ',
     &  '"useOBCSYearlyFields" no longer allowed in file "data.obcs"'
       CALL PRINT_ERROR( msgBuf, myThid )
       WRITE(msgBuf,'(A,A)') 'OBCS_READPARMS: ',
     &  ' was moved to "data.exf", namelist: "EXF_NML_OBCS"'
       CALL PRINT_ERROR( msgBuf, myThid )
      ENDIF
      errCount = 0
      DO i = 1, OBCS_tideCompSize
       IF ( tidalPeriod(i) .NE. -1. _d 0 ) errCount = errCount + 1
      ENDDO
      IF ( errCount.NE.0 ) THEN
       nRetired = nRetired + 1
       WRITE(msgBuf,'(A,A)') 'OBCS_READPARMS: ',
     &  '"tidalPeriod" no longer allowed in file "data.obcs"'
       CALL PRINT_ERROR( msgBuf, myThid )
       WRITE(msgBuf,'(A,A)') 'OBCS_READPARMS: ',
     &  ' was replaced by "OBCS_tidalPeriod" in same namelist'
       CALL PRINT_ERROR( msgBuf, myThid )
      ENDIF
      i = ILNBLNK(OBNamFile)
      IF ( i.NE.17 .OR. OBNamFile(1:17).NE.'retired-and-unset' ) THEN
       nRetired = nRetired + 1
       WRITE(msgBuf,'(A,A)') 'OBCS_READPARMS: ',
     &  '"OBNamFile" no longer allowed in file "data.obcs"'
       CALL PRINT_ERROR( msgBuf, myThid )
       WRITE(msgBuf,'(A,A)') 'OBCS_READPARMS: ',
     &  ' was replaced by "OBN_vTidAmFile" in same namelist'
       CALL PRINT_ERROR( msgBuf, myThid )
      ENDIF
      i = ILNBLNK(OBSamFile)
      IF ( i.NE.17 .OR. OBSamFile(1:17).NE.'retired-and-unset' ) THEN
       nRetired = nRetired + 1
       WRITE(msgBuf,'(A,A)') 'OBCS_READPARMS: ',
     &  '"OBSamFile" no longer allowed in file "data.obcs"'
       CALL PRINT_ERROR( msgBuf, myThid )
       WRITE(msgBuf,'(A,A)') 'OBCS_READPARMS: ',
     &  ' was replaced by "OBS_vTidAmFile" in same namelist'
       CALL PRINT_ERROR( msgBuf, myThid )
      ENDIF
      i = ILNBLNK(OBEamFile)
      IF ( i.NE.17 .OR. OBEamFile(1:17).NE.'retired-and-unset' ) THEN
       nRetired = nRetired + 1
       WRITE(msgBuf,'(A,A)') 'OBCS_READPARMS: ',
     &  '"OBEamFile" no longer allowed in file "data.obcs"'
       CALL PRINT_ERROR( msgBuf, myThid )
       WRITE(msgBuf,'(A,A)') 'OBCS_READPARMS: ',
     &  ' was replaced by "OBE_uTidAmFile" in same namelist'
       CALL PRINT_ERROR( msgBuf, myThid )
      ENDIF
      i = ILNBLNK(OBWamFile)
      IF ( i.NE.17 .OR. OBWamFile(1:17).NE.'retired-and-unset' ) THEN
       nRetired = nRetired + 1
       WRITE(msgBuf,'(A,A)') 'OBCS_READPARMS: ',
     &  '"OBWamFile" no longer allowed in file "data.obcs"'
       CALL PRINT_ERROR( msgBuf, myThid )
       WRITE(msgBuf,'(A,A)') 'OBCS_READPARMS: ',
     &  ' was replaced by "OBW_uTidAmFile" in same namelist'
       CALL PRINT_ERROR( msgBuf, myThid )
      ENDIF
      i = ILNBLNK(OBNphFile)
      IF ( i.NE.17 .OR. OBNphFile(1:17).NE.'retired-and-unset' ) THEN
       nRetired = nRetired + 1
       WRITE(msgBuf,'(A,A)') 'OBCS_READPARMS: ',
     &  '"OBNphFile" no longer allowed in file "data.obcs"'
       CALL PRINT_ERROR( msgBuf, myThid )
       WRITE(msgBuf,'(A,A)') 'OBCS_READPARMS: ',
     &  ' was replaced by "OBN_vTidPhFile" in same namelist'
       CALL PRINT_ERROR( msgBuf, myThid )
      ENDIF
      i = ILNBLNK(OBSphFile)
      IF ( i.NE.17 .OR. OBSphFile(1:17).NE.'retired-and-unset' ) THEN
       nRetired = nRetired + 1
       WRITE(msgBuf,'(A,A)') 'OBCS_READPARMS: ',
     &  '"OBSphFile" no longer allowed in file "data.obcs"'
       CALL PRINT_ERROR( msgBuf, myThid )
       WRITE(msgBuf,'(A,A)') 'OBCS_READPARMS: ',
     &  ' was replaced by "OBS_vTidPhFile" in same namelist'
       CALL PRINT_ERROR( msgBuf, myThid )
      ENDIF
      i = ILNBLNK(OBEphFile)
      IF ( i.NE.17 .OR. OBEphFile(1:17).NE.'retired-and-unset' ) THEN
       nRetired = nRetired + 1
       WRITE(msgBuf,'(A,A)') 'OBCS_READPARMS: ',
     &  '"OBEphFile" no longer allowed in file "data.obcs"'
       CALL PRINT_ERROR( msgBuf, myThid )
       WRITE(msgBuf,'(A,A)') 'OBCS_READPARMS: ',
     &  ' was replaced by "OBE_uTidPhFile" in same namelist'
       CALL PRINT_ERROR( msgBuf, myThid )
      ENDIF
      i = ILNBLNK(OBWphFile)
      IF ( i.NE.17 .OR. OBWphFile(1:17).NE.'retired-and-unset' ) THEN
       nRetired = nRetired + 1
       WRITE(msgBuf,'(A,A)') 'OBCS_READPARMS: ',
     &  '"OBWphFile" no longer allowed in file "data.obcs"'
       CALL PRINT_ERROR( msgBuf, myThid )
       WRITE(msgBuf,'(A,A)') 'OBCS_READPARMS: ',
     &  ' was replaced by "OBW_uTidPhFile" in same namelist'
       CALL PRINT_ERROR( msgBuf, myThid )
      ENDIF

#ifdef ALLOW_ORLANSKI
C     Default Orlanski radiation parameters
      CMAX = 0.45 _d 0 /* maximum allowable phase speed-CFL for AB-II */
      cvelTimeScale = 2000.0 _d 0 /* Averaging period for phase speed (s) */
      CFIX = 0.8 _d 0 /* Fixed boundary phase speed in m/s */
      useFixedCEast=.FALSE.
      useFixedCWest=.FALSE.
      IF (useOrlanskiNorth.OR.
     &    useOrlanskiSouth.OR.
     &    useOrlanskiEast.OR.
     &    useOrlanskiWest)
     & READ(UNIT=iUnit,NML=OBCS_PARM02)
#endif

#ifdef ALLOW_OBCS_SPONGE
C     Default sponge layer parameters:
C     sponge layer is turned off by default
      spongeThickness = 0
      Urelaxobcsinner = 0. _d 0
      Urelaxobcsbound = 0. _d 0
      Vrelaxobcsinner = 0. _d 0
      Vrelaxobcsbound = 0. _d 0
CML this was the previous default in units of days
CML      spongeThickness = 2
CML      Urelaxobcsinner = 5. _d 0
CML      Urelaxobcsbound = 1. _d 0
CML      Vrelaxobcsinner = 5. _d 0
CML      Vrelaxobcsbound = 1. _d 0
      IF (useOBCSsponge)
     & READ(UNIT=iUnit,NML=OBCS_PARM03)
#endif
#ifdef ALLOW_OBCS_STEVENS
      TrelaxStevens   = 0. _d 0
      SrelaxStevens   = 0. _d 0
      IF (      useStevensNorth .OR. useStevensSouth
     &     .OR. useStevensEast  .OR. useStevensWest  )
     & READ(UNIT=iUnit,NML=OBCS_PARM04)
#endif
#ifdef ALLOW_OBCS_SEAICE_SPONGE
C     Default seaice sponge layer parameters:
C     seaice sponge layer is turned off by default
      seaiceSpongeThickness = 0
      Arelaxobcsinner  = 0. _d 0
      Arelaxobcsbound  = 0. _d 0
      Hrelaxobcsinner  = 0. _d 0
      Hrelaxobcsbound  = 0. _d 0
      SLrelaxobcsinner = 0. _d 0
      SLrelaxobcsbound = 0. _d 0
      SNrelaxobcsinner = 0. _d 0
      SNrelaxobcsbound = 0. _d 0
      IF (useSeaiceSponge) READ(UNIT=iUnit,NML=OBCS_PARM05)
#endif

      WRITE(msgBuf,'(A)') ' OBCS_READPARMS: finished reading data.obcs'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT , myThid )

C--   Close the open data file
#ifdef SINGLE_DISK_IO
      CLOSE(iUnit)
#else
      CLOSE(iUnit,STATUS='DELETE')
#endif /* SINGLE_DISK_IO */

C-    retired parameter
      IF ( nRetired .GT. 0 ) THEN
       WRITE(msgBuf,'(A)')
     &  'OBCS_READPARMS: reading parameter file "data.obcs"'
       CALL PRINT_ERROR( msgBuf, myThid )
       WRITE(msgBuf,'(I4,A)') nRetired,
     &  ' out of date parameters were found in namelist'
       CALL PRINT_ERROR( msgBuf, myThid )
       STOP 'ABNORMAL END: S/R OBCS_READPARMS'
      ENDIF

#ifdef ALLOW_OBCS_TIDES
      IF ( useOBCStides ) THEN
C--   Set OBCS_nTidalComp (= the number of tidal components to use)
C     as the last non-zero tidalPeriod:
       OBCS_nTidalComp = 0
       DO i = 1, OBCS_tideCompSize
        IF ( OBCS_tidalPeriod(i).NE.zeroRL ) OBCS_nTidalComp = i
       ENDDO
       WRITE(msgBuf,'(2A,I6)') '  Set number of tidal Components ',
     &   'in use: OBCS_nTidalComp =', OBCS_nTidalComp
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                     SQUEEZE_RIGHT, myThid )
       IF ( OBCS_nTidalComp .EQ. 0 ) THEN
        WRITE(msgBuf,'(2A)') 'OBCS_READPARMS: ',
     &   'useOBCStides=T without any OBCS_tidalPeriod > 0'
        CALL PRINT_ERROR( msgBuf, myThid )
        STOP 'ABNORMAL END: S/R OBCS_READPARMS'
       ENDIF
      ENDIF
#endif /* ALLOW_OBCS_TIDES */

C-    Acount for single/uniform position OB setting:
      errCount = 0
      IF ( OB_singleIeast.NE.OB_indexUnset ) THEN
        DO j=1,OBEW_Ny
          IF ( OB_Ieast(j).EQ.OB_indexUnset ) THEN
            OB_Ieast(j) = OB_singleIeast
          ELSEIF ( OB_Ieast(j).NE.OB_singleIeast ) THEN
            errCount = errCount + 1
          ENDIF
        ENDDO
      ENDIF
      IF ( errCount .NE. 0 ) THEN
        WRITE(msgBuf,'(2A)') 'OBCS_READPARMS: ',
     &  'Inconsistent setting of OB_Ieast/OB_singleIeast'
        CALL PRINT_ERROR( msgBuf, myThid )
        STOP 'ABNORMAL END: S/R OBCS_READPARMS'
      ENDIF

      IF ( OB_singleIwest.NE.OB_indexUnset ) THEN
        DO j=1,OBEW_Ny
          IF ( OB_Iwest(j).EQ.OB_indexUnset ) THEN
            OB_Iwest(j) = OB_singleIwest
          ELSEIF ( OB_Iwest(j).NE.OB_singleIwest ) THEN
            errCount = errCount + 1
          ENDIF
        ENDDO
      ENDIF
      IF ( errCount .NE. 0 ) THEN
        WRITE(msgBuf,'(2A)') 'OBCS_READPARMS: ',
     &  'Inconsistent setting of OB_Iwest/OB_singleIwest'
        CALL PRINT_ERROR( msgBuf, myThid )
        STOP 'ABNORMAL END: S/R OBCS_READPARMS'
      ENDIF

      IF ( OB_singleJnorth.NE.OB_indexUnset ) THEN
        DO i=1,OBNS_Nx
          IF ( OB_Jnorth(i).EQ.OB_indexUnset ) THEN
            OB_Jnorth(i) = OB_singleJnorth
          ELSEIF ( OB_Jnorth(i).NE.OB_singleJnorth ) THEN
            errCount = errCount + 1
          ENDIF
        ENDDO
      ENDIF
      IF ( errCount .NE. 0 ) THEN
        WRITE(msgBuf,'(2A)') 'OBCS_READPARMS: ',
     &  'Inconsistent setting of OB_Jnorth/OB_singleJnorth'
        CALL PRINT_ERROR( msgBuf, myThid )
        STOP 'ABNORMAL END: S/R OBCS_READPARMS'
      ENDIF

      IF ( OB_singleJsouth.NE.OB_indexUnset ) THEN
        DO i=1,OBNS_Nx
          IF ( OB_Jsouth(i).EQ.OB_indexUnset ) THEN
            OB_Jsouth(i) = OB_singleJsouth
          ELSEIF ( OB_Jsouth(i).NE.OB_singleJsouth ) THEN
            errCount = errCount + 1
          ENDIF
        ENDDO
      ENDIF
      IF ( errCount .NE. 0 ) THEN
        WRITE(msgBuf,'(2A)') 'OBCS_READPARMS: ',
     &  'Inconsistent setting of OB_Jsouth/OB_singleJsouth'
        CALL PRINT_ERROR( msgBuf, myThid )
        STOP 'ABNORMAL END: S/R OBCS_READPARMS'
      ENDIF

C-    Account for periodicity if negative indices were supplied
      DO j=1,OBEW_Ny
       IF ( OB_Ieast(j) .NE.OB_indexUnset .AND.
     &      OB_Ieast(j) .LT.0 ) OB_Ieast(j) = OB_Ieast(j)+OBEW_Nx+1
      ENDDO
      DO i=1,OBNS_Nx
       IF ( OB_Jnorth(i).NE.OB_indexUnset .AND.
     &      OB_Jnorth(i).LT.0 ) OB_Jnorth(i)=OB_Jnorth(i)+OBNS_Ny+1
      ENDDO

      IF ( debugLevel.GE.debLevA ) THEN
        CALL WRITE_0D_I( OB_indexUnset, INDEX_NONE,' OB_indexUnset =',
     &                   ' /* unset OB index value (i.e. no OB) */')
c       write(*,*) 'OB Jn =',OB_Jnorth
c       write(*,*) 'OB Js =',OB_Jsouth
c       write(*,*) 'OB Ie =',OB_Ieast
c       write(*,*) 'OB Iw =',OB_Iwest
        WRITE(msgBuf,'(A)') ' Northern OB global indices : OB_Jnorth ='
        CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
        CALL PRINT_LIST_I( OB_Jnorth, 1, OBNS_Nx, INDEX_I,
     &                    .FALSE., .TRUE., standardMessageUnit )
        WRITE(msgBuf,'(A)') ' Southern OB global indices : OB_Jsouth ='
        CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
        CALL PRINT_LIST_I( OB_Jsouth, 1, OBNS_Nx, INDEX_I,
     &                    .FALSE., .TRUE., standardMessageUnit )
        WRITE(msgBuf,'(A)') ' Eastern  OB global indices : OB_Ieast ='
        CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
        CALL PRINT_LIST_I( OB_Ieast, 1, OBEW_Ny, INDEX_J,
     &                    .FALSE., .TRUE., standardMessageUnit )
        WRITE(msgBuf,'(A)') ' Western  OB global indices : OB_Iwest ='
        CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
        CALL PRINT_LIST_I( OB_Iwest, 1, OBEW_Ny, INDEX_J,
     &                    .FALSE., .TRUE., standardMessageUnit )
        WRITE(msgBuf,'(A)') ' '
        CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
      ENDIF
      OBCSbalanceSurf = OBCSbalanceSurf .AND. useOBCSbalance

C--   Continue master-thread only since global OB indices (+ OB_indexUnset)
C     are not shared (not in common block).

C--   Calculate the tiled OB index arrays OB_Jn/Js/Ie/Iw here from the
C     global indices OB_Jnorth/Jsouth/Ieast/Iwest.
C     Note: This part of the code has been moved from obcs_init_fixed
C     to this routine because the OB_Jn/Js/Ie/Iw index arrays are
C     required by INI_DEPTH (calling OBCS_CHECK_DEPTHS, but only needs
C     valid interior indices) which is called before OBCS_INIT_FIXED.
      DO bj = 1, nSy
       DO bi = 1, nSx

        DO i=1-OLx,sNx+OLx
         OB_Jn(i,bi,bj) = OB_indexNone
         OB_Js(i,bi,bj) = OB_indexNone
        ENDDO

        DO j=1-OLy,sNy+OLy
         OB_Ie(j,bi,bj) = OB_indexNone
         OB_Iw(j,bi,bj) = OB_indexNone
        ENDDO

#ifdef ALLOW_EXCH2

C--   We apply OBCS only inside tile and exchange overlaps later
        tN = W2_myTileList(bi,bj)
C 1. N/S boundaries
C     convert from local y index J to global y index jG
C     for N/S boundaries, we use faces stacked in x direction
        DO i=1,sNx
         iG = exch2_txXStackLo(tN)+i-1
C-    Northern boundaries
         IF ( OB_Jnorth(iG).NE.OB_indexUnset ) THEN
C     loop over local y index J
          DO j=1,sNy+1
           jG = exch2_tyXStackLo(tN)+j-1
           IF ( jG.EQ.OB_Jnorth(iG) ) OB_Jn(i,bi,bj) = j
          ENDDO
         ENDIF
C-    Southern boundaries
         IF ( OB_Jsouth(iG).NE.OB_indexUnset ) THEN
          DO j=0,sNy
           jG = exch2_tyXStackLo(tN)+j-1
           IF ( jG.EQ.OB_Jsouth(iG) ) OB_Js(i,bi,bj) = j
          ENDDO
         ENDIF
        ENDDO
C 2. E/W boundaries
C     convert from local y index J to global y index jG
c     for E/W boundaries, we use faces stacked in y direction
        DO j=1,sNy
         jG = exch2_tyYStackLo(tN)+j-1
C-    Eastern  boundaries
         IF ( OB_Ieast(jG).NE.OB_indexUnset ) THEN
C     loop over local x index I
          DO i=1,sNx+1
           iG = exch2_txYStackLo(tN)+i-1
           IF ( iG.EQ.OB_Ieast(jG) )  OB_Ie(j,bi,bj) = i
          ENDDO
         ENDIF
C-    Western  boundaries
         IF ( OB_Iwest(jG).NE.OB_indexUnset ) THEN
          DO i=0,sNx
           iG = exch2_txYStackLo(tN)+i-1
           IF ( iG.EQ.OB_Iwest(jG) )  OB_Iw(j,bi,bj) = i
          ENDDO
         ENDIF
        ENDDO

C-    OB-index tiled-arrays are set for tile-interior region
         OBCS_indexStatus = 1

#else /* ALLOW_EXCH2 */

        DO j=1-OLy,sNy+OLy
C     convert from local y index J to global y index jG
         jG = myYGlobalLo+(bj-1)*sNy+j-1
C     use periodicity to deal with out of range points caused by the overlaps.
C     they will be excluded by the mask in any case, but this saves array
C     out-of-bounds errors here.
         jGm = 1+MOD( jG-1+Ny , Ny )
C-    Eastern  boundaries
C     OB_Ieast(jGm) allows to put the eastern boundary at variable x locations
         IF ( OB_Ieast(jGm).NE.OB_indexUnset ) THEN
C     loop over local x index I
          DO i=1,sNx+1
           iG = myXGlobalLo+(bi-1)*sNx+i-1
           iGm = 1+MOD( iG-1+Nx , Nx )
           IF ( iG.EQ.OB_Ieast(jGm) )  OB_Ie(j,bi,bj) = i
          ENDDO
         ENDIF
C-    Western  boundaries
         IF ( OB_Iwest(jGm).NE.OB_indexUnset ) THEN
          DO i=0,sNx
           iG = myXGlobalLo+(bi-1)*sNx+i-1
           iGm = 1+MOD( iG-1+Nx , Nx )
           IF ( iG.EQ.OB_Iwest(jGm) )  OB_Iw(j,bi,bj) = i
          ENDDO
         ENDIF
        ENDDO

        DO i=1-OLx,sNx+OLx
         iG = myXGlobalLo+(bi-1)*sNx+i-1
         iGm = 1+MOD( iG-1+Nx , Nx )
C-    Northern boundaries
C     OB_Jnorth(iG) allows to put the northern boundary at variable y locations
         IF ( OB_Jnorth(iGm).NE.OB_indexUnset ) THEN
          DO j=1,sNy+1
           jG = myYGlobalLo+(bj-1)*sNy+j-1
           jGm = 1+MOD( jG-1+Ny , Ny )
           IF ( jG.EQ.OB_Jnorth(iGm) ) OB_Jn(i,bi,bj) = j
          ENDDO
         ENDIF
C-    Southern boundaries
         IF ( OB_Jsouth(iGm).NE.OB_indexUnset ) THEN
          DO j=0,sNy
           jG = myYGlobalLo+(bj-1)*sNy+j-1
           jGm = 1+MOD( jG-1+Ny , Ny )
           IF ( jG.EQ.OB_Jsouth(iGm) ) OB_Js(i,bi,bj) = j
          ENDDO
         ENDIF
        ENDDO

C-    OB-index tiled-arrays are set for interior and overlap regions
        OBCS_indexStatus = 2

#endif /* ALLOW_EXCH2 */

C     bi,bj-loops
       ENDDO
      ENDDO

      _END_MASTER(myThid)
C--   Everyone else must wait for the parameters to be loaded
C     and tiled OB indices to be set.
      _BARRIER

#endif /* ALLOW_OBCS */
      RETURN
      END

      subroutine lsopt_top( nn, xx, ff, gg, simul, optline
     $                  , epsx, fmin, epsg
     $                  , iprint, itmax, nfunc, nupdate
     $                  , dd, gold, xdiff
     $                  , loffline
     $                  , ifail )

c     ==================================================================
c     SUBROUTINE lsopt_top
c     ==================================================================
c
c     o uses a set of control variables, their adjoint variables,
c       and a cost function value
c       to compute an improved set of controls with respect to the
c       cost function via a
c       variable-storage Quasi-Newton method
c
c     o Reference: J.C. Gilbert & C. Lemarechal
c                  Some numerical experiments with variable-storage
c                  quasi-Newton algorithms
c                  Mathematical Programming 45 (1989), pp. 407-435
c
c     o started: ??? not reproducible
c
c     o changed: Patrick Heimbach, MIT/EAPS
c                
c     o Version: 2.0, 24-Feb-2000: 
c                    (Version 1.0 is considered as version
c                     starting from which changes were made).
c                   - severe changes in structure including various
c                     bug-fixes to enable multi-optimization runs;
c                   - routine lsoptw incorporated into lsoptv
c                   - optimization iteration loop restructured
c                   - complete restructuring of handling
c                     cold start cases
c                   - number of 3 control flags for error handling
c                     (indic, moderl, ifail) reduced to 1 (ifail)
c                     and homogenized with routine lsline
c
c     o Version: 2.1, 29-Feb-2000:
c                   - handling of case ifail = 6 changed;
c                     leads to stop of optimization
c                     (similar to case ifail = 8)
c                   - logical lphprint included
c
c     ==================================================================
c     SUBROUTINE lsopt_top
c     ==================================================================

      implicit none

ccc#include <blas1.h>

c-----------------------------------------
c declare arguments
c-----------------------------------------
      integer nn, iprint, itmax, nfunc, nupdate, ifail

      double precision  xx(nn), ff, gg(nn), epsx, fmin, epsg
      double precision  dd(nn), gold(nn), xdiff(nn)

cph(
      integer phniter0, phniterold
      double precision phff
      COMMON /PH_OPTI/ phniter0, phniterold, phff
cph)

      external simul, optline

c-----------------------------------------
C declare local variables
c-----------------------------------------
      logical cold, lphprint, loffline
      parameter (lphprint = .true.)

      integer mm, mupd, jmin, jmax, indic, isize, REAL_BYTE
      integer i, iiter, ifunc

      double precision   fupd
      double precision   r1, tmin, tmax, tact, gnorm, gnorm0, eps1
      double precision   fold, ys
      double precision   dotdg

      external DDOT, DNRM2, DSCAL
      double precision     DDOT, DNRM2

c-----------------------------------------
c parameters
c-----------------------------------------

      double precision rmin
      parameter( rmin = 1.e-20 )

      character*(*) iform
      parameter(iform='(i5,2x,1pe8.1,1x,i5,4x,1pe11.4,3(2x,1pe8.1))' )

c     ==================================================================
c
c-----------------------------------------
c initialization
c-----------------------------------------
      cold  = .true.
      fupd  = 1.0e+10
      indic = 0
      tmin  = 0.
      tmax  = 1.0e+10
      tact  = 1.0
cph(
      phniterold = 0
cph)
      iiter = 0
      eps1  = 1.0
      ifunc = 0
      ifail = 0
      gnorm0 = 1.

c-----------------------------------------
c initialization for dd and dds
c-----------------------------------------

      jmin  = 1
      jmax  = 0

      mm    = nn
      mupd  = nupdate

      REAL_BYTE = 4
      isize = REAL_BYTE

c-----------------------------------------
c print information
c-----------------------------------------
      if (iprint .ge. 1) then
         print '(2x,a)',
     $         '==============================================='
         print '(2x,a)',
     $         '===         O P T I M I Z A T I O N         ==='
         print '(2x,a)',
     $         '==============================================='
         print '(a,i9)'
     $        , '  number of control variables.......', nn
         print '(a,e9.2)'
     $        , '  precision on x....................', epsx
         print '(a,e9.2)'
     $        , '  precision on g....................', epsg
         print '(a,e9.2)'
     $        , '  expected optimal function value...', fmin
         print '(a,i9)'
     $        , '  maximal number of iterations......', itmax
         print '(a,i9)'
     $        , '  maximal number of simulations.....', nfunc
         print '(a,i9)'
     $        , '  information level.................', iprint
         print '(a,i9)'
     $        , '  number of updates.................', nupdate
         print '(a,i9)'
     $        , '  size of used memory...............', 3*nn
      endif

c-----------------------------------------
c check arguments
c-----------------------------------------

      if (nn .le. 0) then
         if (iprint.ge.1) then
            print '(a,i6)'  , '  ERROR : n     = ', nn
         endif
         ifail = 1
         goto 999
      endif

      if (itmax .lt. 0) then
         if (iprint.ge.1) then
            print '(a,i6)'  , '  ERROR : itmax = ', itmax
         endif
         ifail = 1
         goto 999
      endif

      if (nfunc .le. 0) then
         if (iprint.ge.10) then
            print '(a,i6)'  , '  ERROR : nfunc  = ', nfunc
         endif
         ifail = 1
         goto 999
      endif

      if (epsx .le. 0.) then
         if (iprint.ge.1) then
            print '(a,e9.2)', '  ERROR : epsx = ', epsx
         endif
         ifail = 1
         goto 999
      endif

      if (epsg .le. 0.) then
         if (iprint.ge.1) then
            print '(a,e9.2)', '  ERROR : epsg  = ', epsg
         endif
         ifail = 1
         goto 999
      endif

      if (epsg .gt. 1.) then
         if (iprint.ge.1) then
            print '(a,e9.2)', '  ERROR : epsg  = ', epsg
         endif
         ifail = 1
         goto 999
      endif

cph(
      print *, 'pathei: vor instore '
cph)
      call instore( mm, fupd, gnorm0, isize, mupd, jmin, jmax, cold,
     &              ifail )

cph(
      phff = fupd
cph)

c-----------------------------------------
c check warm start parameters
c-----------------------------------------
      if (ifail .ne. 0) then
         if (iprint.ge.1) then
            print '(a)', ' ERROR : reading restart file'
         end if
         ifail = 2
         goto 999
      end if

      if (isize .ne. REAL_BYTE) then
         if (iprint.ge.1) then
            print '(a)', ' ERROR : uncompatible floating point format'
         end if
         ifail = 2
         goto 999
      end if

      if (mupd .lt. 1) then
         if (iprint .ge. 1) then
            print '(a)', ' ERROR : m is set too small in instore'
         endif
         ifail = 2
         goto 999
      endif

c-----------------------------------------
c cold start or warm restart ?
c-----------------------------------------

      if (cold) then
c--- start if cold start ---
         if (lphprint) then
            print '(a)', 'pathei-lsopt: cold start'
         end if

         print *, 'pathei-lsopt vor simul', nn
         print *, 'pathei-lsopt xx(1), gg(1) ', xx(1), gg(1)

         call simul( indic, nn, xx, ff, gg )

         print *, 'pathei: nach simul:   nn, ff = ', nn, ff
         print *, 'pathei: nach simul:   xx(1), gg(1) = ', xx(1), gg(1)

         do i = 1, nn
            xdiff(i) = 1.
         end do

cph(
      print *, 'pathei: vor dostore '
cph)
         call dostore( nn, xx, .true., 1 )
         call dostore( nn, gg, .true., 2 )
         call dostore( nn, xdiff, .true., 3 )
               
cph(
      print *, 'pathei: vor lswri '
cph)
cph         call lswri( isize, iiter, nn, xx, gg, lphprint )

cph(
      print *, 'pathei: vor gnorm0 '
cph)
         gnorm0 = DNRM2( nn, gg, 1 )
cph(
      print *, 'pathei: gnorm0 = ', gnorm0
cph)
         if (gnorm0 .lt. rmin) then
            ifail = 3
           goto 1000
         endif

cph(
         phff = ff
cph)

         if (lphprint)
     &        print *, 'pathei-lsopt: cold; first call simul: ff = ', 
     &        phff

c--- end if cold start ---
      else
c--- start if warm start ---
         if (mm .ne. nn) then
            if (iprint.ge.1) then
               print '(a,i6)'
     $              , '  ERROR : inconsistent nn = ', mm
            endif
            ifail = 2
            goto 999
         endif
         if (mupd .ne. nupdate) then
            if (iprint.ge.1) then
               print '(a,i6)'
     $              , '  ERROR : inconsistent nupdate = ', mupd
            endif
            ifail = 2
            goto 999
         endif
         if (jmin .lt. 1) then
            if (iprint.ge.1) then
               print '(a,i6)'
     $              , '  ERROR : inconsistent jmin = ', jmin
            endif
            ifail = 2
            goto 999
         endif
         if (jmin .gt. mupd) then
            if (iprint.ge.1) then
               print '(a,i6)'
     $              , '  ERROR : inconsistent jmin = ', jmin
            endif
            ifail = 2
            goto 999
         endif
         if (jmax .gt. mupd) then
            if (iprint.ge.1) then
               print '(a,i6)'
     $              , '  ERROR : inconsistent jmax = ', jmax
            endif
            ifail = 2
            goto 999
         endif
         
         if (lphprint) then
            print *, 'pathei-lsopt: warm start; read via dostore'
            print *
         endif

         call dostore( nn, xx, .false., 1 )
         call dostore( nn, gg, .false., 2 )
         ff = fupd

cph(
         phff = ff
cph)

         if (lphprint)
     &        print *, 'pathei-lsopt: warm; first dostore read: ff = ',
     &        ff

c--- end if warm start ---
      endif

      if (iprint .ge. 1) then
         print '(2a)', '  Itn      Step  Nfun      Objective    '
     $        , 'Norm G    Norm X   Norm (X(k-1)-X(k))'
      end if

c-----------------------------------------
c print information line
c-----------------------------------------
         if (cold) then
            print iform, iiter, tact, ifunc, ff, gnorm0
     $           , DNRM2( nn, xx, 1 ), 0.

Cml            write(94,'(i5,2x,1pe11.4,4(2x,1pe8.1))')
Cml     &           iiter, ff, gnorm0, tact, 
Cml     &           DNRM2( nn, xx, 1 ), 0.

            if ( itmax .EQ. 0 ) then
               ifail = 10
               goto 1000
            end if
         end if

c=======================================================================
c begin of loop
c compute x(k+1) out of x(k) + t*d, where  t > 0.
c=======================================================================

      do iiter = 1, itmax

         if (lphprint) then
            print *, 'pathei-lsopt: ++++++++++++++++++++++++'
            print *, 'pathei-lsopt: entering iiter =', iiter
         end if

c-----------------------------------------
c store old values
c-----------------------------------------
      do i = 1, nn
         gold(i) = gg(i)
      end do

      fold = ff
cph(
      phniter0 = iiter
      phff = ff
cph)

c-----------------------------------------
c compute new dd and xx
c-----------------------------------------
c
      call lsupdxx(
     &     nn, ifail, lphprint
     &     , jmin, jmax, nupdate
     &     , ff, fmin, fold, gnorm0, dotdg
     &     , gg, dd, xx, xdiff
     &     , tmin, tmax, tact, epsx
     &     )

c-----------------------------------------
c check whether new direction is a descent one
c-----------------------------------------
      if ( ifail .eq. 4) goto 1000

c-----------------------------------------
c optline returns new values of x, f, and g
c-----------------------------------------
c
      call optline( 
     &     simul
     &     , nn, ifail, lphprint
     &     , ifunc, nfunc
     &     , ff, dotdg
     &     , tmin, tmax, tact, epsx
     &     , dd, gg, xx, xdiff
     &     )

      if (lphprint) print *, 'pathei-lsopt: ',
     &     'back from optline; ifail = ', ifail
      if (lphprint) print *, 'pathei-lsopt: ',
     &     'dostore 1,2 at iiter ', iiter

      call dostore( nn, xx, .true., 1 )
      call dostore( nn, gg, .true., 2 )
cph(
cph      call lswri( isize, iiter, nn, xx, gg, lphprint )
cph)

      gnorm = DNRM2( nn, gg, 1 )

c-----------------------------------------
c print information line
c-----------------------------------------
      print iform, iiter, tact, ifunc, ff, gnorm
     $     , DNRM2( nn, xx, 1 ), tact*DNRM2( nn, dd, 1 )

Cml      write(94,'(i5,2x,1pe11.4,4(2x,1pe8.1))')
Cml     &     iiter, ff, gnorm, tact,
Cml     &     DNRM2( nn, xx, 1 ), tact*DNRM2( nn, dd, 1 )

c-----------------------------------------
c check output mode of ifail
c-----------------------------------------
      if (ifail .eq. 7
     &     .or. ifail .eq. 8
     &     .or. ifail .eq. 9) goto 1000

c-----------------------------------------
c maximal number of simulation reached
c no goto in order to update Hessian
c-----------------------------------------
         if (ifail .eq. 6) ifail = 0

c-----------------------------------------
c NOTE: stopping tests are now done
c after having updated the matrix,
c so that update information can be stored
c in case of a later warm restart
c-----------------------------------------
c-----------------------------------------
c  compute new s, y
c-----------------------------------------
         do i = 1, nn
            xdiff(i) = tact*dd(i)
         end do

c-----------------------------------------
c compute ys
c-----------------------------------------
         do i = 1, nn
            gold(i) = gg(i)-gold(i)
         end do

         ys = DDOT( nn, gold, 1, xdiff, 1 )
         if (ys .le. 0.) then
            ifail = 4
            print *, 'pathei-lsopt: ys < 0; ifail = ', ifail
            goto 1000
         endif
cph(
cph-----------------------------------------
cph at this point it is clear that xdiff 
cph provides a true optimized solution;
cph i.e. take new gradient gg to compute new dd
cph-----------------------------------------
cph)

c-----------------------------------------
c update pointers for hessupd
c-----------------------------------------
      if (nupdate .gt. 0) then

         if (jmax .eq. 0) then
            jmax = jmax+1
            if (lphprint) 
     &           print *, 'pathei-lsopt: ',
     &           'first pointer update after cold start; ',
     &           'iiter, jmin, jmax = ', iiter, jmin, jmax
         else
            jmax = jmax+1
            if (jmax .gt. nupdate) jmax = jmax-nupdate

            if (jmin .eq. jmax) then
               if (lphprint) 
     &              print *, 'pathei-lsopt: pointers updated for ',
     &              ' iiter, jmin, jmax = ', iiter, jmin, jmax
               jmin = jmin+1
               if (jmin .gt. nupdate) jmin = jmin-nupdate
            end if
         end if

c-----------------------------------------
c compute sbar, ybar store rec = min 4,5
c-----------------------------------------
         r1 = sqrt(1./ys)
         call DSCAL( nn, r1, xdiff, 1 )
         call DSCAL( nn, r1, gold, 1 )

      if (lphprint) 
     &        print *, 'pathei-lsopt: dostore at iiter, jmin, jmax ', 
     &        iiter, jmin, jmax

         call dostore( nn, gold, .true., 2*jmax+2 )
         call dostore( nn, xdiff, .true., 2*jmax+3 )

c-----------------------------------------
c compute the diagonal preconditioner
c use dd as temporary array
c-----------------------------------------
         call dgscale( nn, gold, xdiff, dd, rmin )

      endif

c-----------------------------------------
c test convergence and stopping criteria
c-----------------------------------------
      eps1 = gnorm / gnorm0

      if (eps1 .lt. epsg) then

         ifail = 11
         goto 1000
      endif

c=======================================================================
c return of loop
c=======================================================================
      
      end do

      iiter = iiter - 1
      ifail = 5

c-----------------------------------------
c loop exit
c-----------------------------------------
 1000 continue
      nfunc = ifunc
      epsg = eps1

c-----------------------------------------------------------------------
c save data for warm start
c-----------------------------------------------------------------------

      call outstore( nn, ff, gnorm0, nupdate, jmin, jmax )

c-----------------------------------------------------------------------
c compute dd(i+1), xx(i+1) based on latest available gg(i), xx(i)
c for offline version
c-----------------------------------------------------------------------

      if (loffline) then

         call lsupdxx(
     &        nn, ifail, lphprint
     &        , jmin, jmax, nupdate
     &        , ff, fmin, fold, gnorm0, dotdg
     &        , gg, dd, xx, xdiff
     &        , tmin, tmax, tact, epsx
     &        )

c        Save xx(i+1) to file for offline version.
         call optim_write_control( nn, xdiff )

      end if

c-----------------------------------------
c print final information
c-----------------------------------------
      if (iprint .ge. 5) then
         print *
         print '(a,i9)'
     $        , '  number of iterations..............', iiter
         print '(a,i9)'
     $        , '  number of simultations............', nfunc
         print '(a,e9.2)'
     $        , '  relative precision on g...........', epsg
      end if

      if (iprint.ge.10) then
         print *
         print '(a,e15.8)'
     $        , '  cost function...............', ff
         print '(a,e15.8)'
     $        , '  norm of x...................', DNRM2( nn, xx, 1 )
         print '(a,e15.8)'
     $        , '  norm of g...................', DNRM2( nn, gg, 1 )
      end if

c-----------------------------------------
c print error message
c-----------------------------------------
 999  continue

      if (ifail .ne. 0) then
         if (iprint .ge. 5) then
            print *
            print '(a)', '  optimization stopped because :'
            if (ifail .lt. 0) then
               print '(2x,a8,I3,a)', 'ifail = ', ifail
     $              , '    user request during simul'
            else if (ifail .eq. 0) then
               print '(2x,a8,I3,a)', 'ifail = ', ifail
     $              , '    optimal solution found'
            else if (ifail .eq. 1) then
               print '(2x,a8,I3,a)', 'ifail = ', ifail
     $              , '    an input argument is wrong'
            else if (ifail .eq. 2) then
               print '(2x,a8,I3,a)', 'ifail = ', ifail
     $              , '    warm start file is corrupted'
            else if (ifail .eq. 3) then
               print '(2x,a8,I3,a)', 'ifail = ', ifail
     $              , '    the initial gradient is too small'
            else if (ifail .eq. 4) then
               print '(2x,a8,I3,a)', 'ifail = ', ifail
     $              , '    the search direction is not a descent one'
            else if (ifail .eq. 5) then
               print '(2x,a8,I3,a)', 'ifail = ', ifail
     $              , '    maximal number of iterations reached'
            else if (ifail .eq. 6) then
               print '(2x,a8,I3,a)', 'ifail = ', ifail
     $              , '    maximal number of simulations reached'
            else if (ifail .eq. 7) then
               print '(2x,a8,I3,a)', 'ifail = ', ifail
     $              , '    the linesearch failed'
            else if (ifail .eq. 8) then
               print '(2x,a8,I3,a)', 'ifail = ', ifail
     $              , '    the function could not be improved'
            else if (ifail .eq. 9) then
               print '(2x,a8,I3,a)', 'ifail = ', ifail
     $              , '    optline parameters wrong'
            else if (ifail .eq. 10) then
               print '(2x,a8,I3,a)', 'ifail = ', ifail
     $              , '    cold start, no optimization done'
            else if (ifail .eq. 11) then
               print '(2x,a8,I3,a)', 'ifail = ', ifail
     $              , '    convergence achieved within precision'
            end if
            print *
         else if (iprint .ge. 1) then
            print *
            print '(a,i9)'
     $           , '  after optimization ifail..........', ifail
            print *
         end if
      end if

c-----------------------------------------
c end of subroutine
c-----------------------------------------
      return

      end

#include "GRDCHK_OPTIONS.h"
#ifdef ALLOW_CTRL
# include "CTRL_OPTIONS.h"
#endif

      SUBROUTINE GRDCHK_CHECK( myThid )

C     ==================================================================
C     SUBROUTINE grdchk_check
C     ==================================================================
C
C     o check some gradient check parameter settings for consistency
C
C     ==================================================================
C     SUBROUTINE grdchk_check
C     ==================================================================

      IMPLICIT NONE

C     == global variables ==

#include "EEPARAMS.h"
#include "SIZE.h"
#include "CTRL_SIZE.h"
#include "CTRL.h"
#ifdef ALLOW_OBCS_CONTROL
C     CTRL_OBCS.h must be included before GRDCHK.h
# include "CTRL_OBCS.h"
#endif
#include "GRDCHK.h"

C     == routine arguments ==
      INTEGER myThid

#ifdef ALLOW_GRDCHK
C     == local variables ==
C     msgBuf      - Informational/error message buffer
      CHARACTER*(MAX_LEN_MBUF) msgBuf

C     == end of interface ==

      WRITE(msgBuf,'(A)') 'GRDCHK_CHECK: grdchk package'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )

C--   Set grdchkvarindex (if not already set from reading data.grdchk)
      _BEGIN_MASTER( myThid )
      CALL GRDCHK_CTRL_FNAME( grdchkvarname, grdchkvarindex, myThid )
      _END_MASTER( myThid )
      _BARRIER

C--   Summarize the gradient check setup.
      CALL GRDCHK_SUMMARY( myThid )

      IF ( ncvarindex(grdchkvarindex) .LT. 0 ) THEN
         WRITE(msgBuf,'(A,I4)')
     &        'Control variable not enabled for grdchkvarindex = ',
     &        grdchkvarindex
         CALL PRINT_ERROR( msgBuf, myThid )
         STOP 'ABNORMAL END: S/R GRDCHK_CHECK'
      ENDIF

#endif /* ALLOW_GRDCHK */

      RETURN
      END

#include "DIAG_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 0
C     !ROUTINE: DIAGNOSTICS_ADDTOLIST

C     !INTERFACE:
      SUBROUTINE DIAGNOSTICS_ADDTOLIST (
     O     diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, diagMate,
     I     myThid )

C     !DESCRIPTION:
C     routine to add 1 diagnostics to the list of available diagnostics:
C     set the attributes:
C     name (=cdiag), parsing code (=gdiag), units (=udiag), title (=tdiag)
C     and diagnostic mate number (=hdiag) of the new diagnostic and
C     update the total number of available diagnostics
C     Note: needs to be called after DIAGNOSTICS_INIT_EARLY
C                         and before DIAGNOSTICS_INIT_FIXED

C     !USES:
       IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "DIAGNOSTICS_SIZE.h"
#include "DIAGNOSTICS.h"

C     !INPUT PARAMETERS:
C     diagName  :: diagnostic name to declare
C     diagCode  :: parser code for this diagnostic
C     diagUnits :: field units for this diagnostic
C     diagTitle :: field description for this diagnostic
C     diagMate  :: diagnostic mate number
C     myThid    :: my Thread Id number
      CHARACTER*8   diagName
      CHARACTER*16  diagCode
      CHARACTER*16  diagUnits
      CHARACTER*(*) diagTitle
      INTEGER diagMate
      INTEGER myThid

C     !OUTPUT PARAMETERS:
C     numDiag :: diagnostic number in the list of available diagnostics
      INTEGER diagNum
CEOP

C     !LOCAL VARIABLES:
C     msgBuf :: Informational/error message buffer
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      INTEGER n

C--   Initialise
      diagNum = 0

      _BEGIN_MASTER( myThid)

C--   Check if this S/R is called from the right place ;
C     needs to be after DIAGNOSTICS_INIT_EARLY and before DIAGNOSTICS_INIT_FIXED
      IF ( diag_pkgStatus.NE.ready2setDiags ) THEN
        CALL DIAGNOSTICS_STATUS_ERROR( 'DIAGNOSTICS_ADDTOLIST',
     &                   ' ', diagName, ready2setDiags, myThid )
      ENDIF

C--   Search for "diagName" in the list of available diagnostics:
      DO n=1,ndiagt
       IF ( cdiag(n).EQ.diagName ) THEN
         diagNum = n
         IF ( gdiag(n).EQ.diagCode .AND. hdiag(n).EQ.diagMate ) THEN
C-    diagnostics is already defined and has the same characteristics
          WRITE(msgBuf,'(3A,I6,A)') 'DIAGNOSTICS_ADDTOLIST: diag=',
     &     diagName,' is already defined (# ',n,' )'
          CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                        SQUEEZE_RIGHT , myThid)
          WRITE(msgBuf,'(2A)') 'DIAGNOSTICS_ADDTOLIST:',
     &     ' with same parser => update Title & Units '
          CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                        SQUEEZE_RIGHT , myThid)
          udiag(diagNum) = diagUnits
          tdiag(diagNum) = diagTitle
         ELSE
C-    diagnostics is already defined but with different characteristics
          WRITE(msgBuf,'(3A,I6,A)') 'DIAGNOSTICS_ADDTOLIST: diag=',
     &     diagName,' is already defined (# ',n,' )'
          CALL PRINT_ERROR( msgBuf , myThid)
          WRITE(msgBuf,'(4A,I6)')   'DIAGNOSTICS_ADDTOLIST: cannot ',
     &     'change parser="',gdiag(n),'" & mate=',hdiag(n)
          CALL PRINT_ERROR( msgBuf , myThid)
          WRITE(msgBuf,'(4A,I6,A)') 'DIAGNOSTICS_ADDTOLIST:',
     &     '  to : "',diagCode,'" and mate=',diagMate,' ; => STOP'
          CALL PRINT_ERROR( msgBuf , myThid)
          STOP 'ABNORMAL END: S/R DIAGNOSTICS_ADDTOLIST'
         ENDIF
       ENDIF
      ENDDO

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      IF ( diagNum.EQ.0 ) THEN
C--   Add one diagnostic to the list of available diagnostics:
       diagNum = ndiagt + 1

       IF ( diagNum .LE. ndiagMax ) THEN
        cdiag(diagNum) = diagName
        gdiag(diagNum) = diagCode
        hdiag(diagNum) = diagMate
        udiag(diagNum) = diagUnits
        tdiag(diagNum) = diagTitle
        ndiagt = diagNum
       ELSE
        WRITE(msgBuf,'(2A,I6)') 'DIAGNOSTICS_ADDTOLIST:',
     &   ' Exceed Max.Number of diagnostics ndiagMax=', ndiagMax
        CALL PRINT_ERROR( msgBuf , myThid)
        WRITE(msgBuf,'(2A)')
     &   'DIAGNOSTICS_ADDTOLIST: when setting diagnostic: ',diagName
        CALL PRINT_ERROR( msgBuf , myThid)
        STOP 'ABNORMAL END: S/R DIAGNOSTICS_ADDTOLIST'
       ENDIF

      ENDIF

      _END_MASTER( myThid )

      RETURN
      END

#include "SEAICE_OPTIONS.h"
#ifdef ALLOW_AUTODIFF
# include "AUTODIFF_OPTIONS.h"
#endif

CBOP
C !ROUTINE: SEAICE_ADVDIFF

C !INTERFACE: ==========================================================
      SUBROUTINE SEAICE_ADVDIFF(
     U                  uc, vc,
     I                  myTime, myIter, myThid )

C !DESCRIPTION: \bv
C     *===========================================================*
C     | SUBROUTINE SEAICE_ADVDIFF
C     | o driver for different advection routines
C     |   calls an adaption of gad_advection to call different
C     |   advection routines of pkg/generic_advdiff
C     *===========================================================*
C \ev

C !USES: ===============================================================
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "SEAICE_SIZE.h"
#include "SEAICE_PARAMS.h"
#include "SEAICE_GRID.h"
#include "SEAICE.h"
#include "SEAICE_TRACER.h"
#ifdef ALLOW_AUTODIFF_TAMC
# include "tamc.h"
#endif

C !INPUT/OUTPUT PARAMETERS: ===================================================
C     === Routine arguments ===
C     uc/vc     :: current ice velocity on C-grid;
C               :: C-Grid : Input only ; B-grid : Output only
C     myTime    :: current time in simulation
C     myIter    :: current iteration number in simulation
C     myThid    :: my Thread Id number
      _RL uc   (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL vc   (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL myTime
      INTEGER myIter
      INTEGER myThid

C !LOCAL VARIABLES: ====================================================
C     === Local variables ===
C     i,j,bi,bj :: Loop counters
C     it        :: Loop counter for ice thickness categories
C     uTrans    :: volume transport, x direction
C     vTrans    :: volume transport, y direction
C     afx       :: horizontal advective flux, x direction
C     afy       :: horizontal advective flux, y direction
C     gFld      :: tendency of seaice field
C     xA,yA     :: "areas" of X and Y face of tracer cells
      INTEGER i, j, bi, bj
#ifdef SEAICE_ITD
      INTEGER it
#endif /* SEAICE_ITD */
#ifdef ALLOW_AUTODIFF_TAMC
C     tkey :: tape key (depends on tiles)
      INTEGER tkey
#endif /* ALLOW_AUTODIFF_TAMC */
#ifdef ALLOW_SITRACER
      _RL hEffNm1    (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL areaNm1    (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      INTEGER iTr, SEAICEadvSchSItr
      _RL SEAICEdiffKhSItr
      _RL SItrExt   (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL tmpscal1, tmpscal2
# ifdef ALLOW_SITRACER_ADVCAP
      _RL SItrPrev  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
# endif
# ifdef ALLOW_SITRACER_DEBUG_DIAG
      _RL DIAGarray (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
# endif
#endif /* ALLOW_SITRACER */
      _RL fldNm1    (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL uTrans    (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL vTrans    (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL afx       (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL afy       (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL gFld      (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RS xA        (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RS yA        (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL recip_heff(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
#if ( defined SEAICE_ITD || !defined ALLOW_GENERIC_ADVDIFF )
      CHARACTER*(MAX_LEN_MBUF) msgBuf
#endif
CEOP

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C--   compute cell areas used by all tracers
      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          xA(i,j,bi,bj) = _dyG(i,j,bi,bj)*SIMaskU(i,j,bi,bj)
          yA(i,j,bi,bj) = _dxG(i,j,bi,bj)*SIMaskV(i,j,bi,bj)
         ENDDO
        ENDDO
       ENDDO
      ENDDO

#ifdef SEAICE_BGRID_DYNAMICS
C--   hack to ensure backward compatibility:
C     average B-grid seaice velocity to C-grid
      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        DO j=1-OLy,sNy+OLy-1
         DO i=1-OLx,sNx+OLx-1
          uc(i,j,bi,bj)=.5 _d 0*(UICE(i,j,bi,bj)+UICE(i,j+1,bi,bj))
          vc(i,j,bi,bj)=.5 _d 0*(VICE(i,j,bi,bj)+VICE(i+1,j,bi,bj))
         ENDDO
        ENDDO
       ENDDO
      ENDDO
C     Do we need this? I am afraid so.
      CALL EXCH_UV_XY_RL(uc,vc,.TRUE.,myThid)
#endif

#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE uc   = comlev1, key = ikey_dynamics, kind=isbyte
CADJ STORE vc   = comlev1, key = ikey_dynamics, kind=isbyte
#endif /* ALLOW_AUTODIFF_TAMC */

      IF ( SEAICEmultiDimAdvection ) THEN
#ifdef ALLOW_GENERIC_ADVDIFF

      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
C---   loops on tile indices bi,bj

#ifdef ALLOW_AUTODIFF
C     Initialise to help AD-tools
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          gFld(i,j) = 0. _d 0
         ENDDO
        ENDDO
#endif
C
#ifdef ALLOW_AUTODIFF_TAMC
        tkey = bi + (bj-1)*nSx + (ikey_dynamics-1)*nSx*nSy
CADJ STORE area(:,:,bi,bj)  = comlev1_bibj, key=tkey, kind=isbyte
CADJ STORE heff(:,:,bi,bj)  = comlev1_bibj, key=tkey, kind=isbyte
CADJ STORE hsnow(:,:,bi,bj) = comlev1_bibj, key=tkey, kind=isbyte
# ifdef SEAICE_VARIABLE_SALINITY
CADJ STORE hsalt(:,:,bi,bj) = comlev1_bibj, key=tkey, kind=isbyte
# endif
#endif /* ALLOW_AUTODIFF_TAMC */

        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
#ifdef ALLOW_SITRACER
          hEffNm1(i,j,bi,bj) = HEFF(i,j,bi,bj)
          areaNm1(i,j,bi,bj) = AREA(i,j,bi,bj)
#endif
          recip_heff(i,j)    = 1. _d 0
         ENDDO
        ENDDO

C-    Calculate "volume transports" through tracer cell faces.
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          uTrans(i,j) = uc(i,j,bi,bj)*xA(i,j,bi,bj)
          vTrans(i,j) = vc(i,j,bi,bj)*yA(i,j,bi,bj)
         ENDDO
        ENDDO

#ifdef SEAICE_ITD
C--   Effective Thickness (Volume)
        IF ( SEAICEadvHeff ) THEN
         DO it=1,SEAICE_multDim
          CALL SEAICE_ADVECTION(
     I         GAD_HEFF, SEAICEadvSchHeff,
     I         uc(1-OLx,1-OLy,bi,bj), vc(1-OLx,1-OLy,bi,bj),
     I         uTrans, vTrans, HEFFITD(1-OLx,1-OLy,it,bi,bj),
     I         recip_heff,
     O         gFld, afx, afy,
     I         bi, bj, myTime, myIter, myThid )
C-    Add tendency due to diffusion
          IF ( SEAICEdiffKhHeff .GT. 0. _d 0 )
     &         CALL SEAICE_DIFFUSION(
     I         GAD_HEFF, SEAICEdiffKhHeff, ONE,
     I         HEFFITD(1-OLx,1-OLy,it,bi,bj), HEFFM,
     I         xA(1-OLx,1-OLy,bi,bj), yA(1-OLx,1-OLy,bi,bj),
     U         gFld,
     I         bi, bj, myTime, myIter, myThid )
C     now do the "explicit" time step
          DO j=1,sNy
           DO i=1,sNx
            HEFFITD(i,j,it,bi,bj) = HEFFM(i,j,bi,bj) * (
     &           HEFFITD(i,j,it,bi,bj) + SEAICE_deltaTtherm * gFld(i,j)
     &           )
           ENDDO
          ENDDO
         ENDDO
        ENDIF

C--   Fractional area
        IF ( SEAICEadvArea ) THEN
         DO it=1,SEAICE_multDim
          CALL SEAICE_ADVECTION(
     I         GAD_AREA, SEAICEadvSchArea,
     I         uc(1-OLx,1-OLy,bi,bj), vc(1-OLx,1-OLy,bi,bj),
     I         uTrans, vTrans, AREAITD(1-OLx,1-OLy,it,bi,bj),
     I         recip_heff,
     O         gFld, afx, afy,
     I         bi, bj, myTime, myIter, myThid )
C-    Add tendency due to diffusion
          IF ( SEAICEdiffKhArea .GT. 0. _d 0 )
     &         CALL SEAICE_DIFFUSION(
     I         GAD_AREA, SEAICEdiffKhArea, ONE,
     I         AREAITD(1-OLx,1-OLy,it,bi,bj), HEFFM,
     I         xA(1-OLx,1-OLy,bi,bj), yA(1-OLx,1-OLy,bi,bj),
     U         gFld,
     I         bi, bj, myTime, myIter, myThid )
C     now do the "explicit" time step
          DO j=1,sNy
           DO i=1,sNx
            AREAITD(i,j,it,bi,bj) = HEFFM(i,j,bi,bj) * (
     &           AREAITD(i,j,it,bi,bj) + SEAICE_deltaTtherm * gFld(i,j)
     &           )
           ENDDO
          ENDDO
         ENDDO
C     open water fraction needs to be advected for the ridging scheme
         CALL SEAICE_ADVECTION(
     I        GAD_AREA, SEAICEadvSchArea,
     I        uc(1-OLx,1-OLy,bi,bj), vc(1-OLx,1-OLy,bi,bj),
     I        uTrans, vTrans, opnWtrFrac(1-OLx,1-OLy,bi,bj), recip_heff,
     O        gFld, afx, afy,
     I        bi, bj, myTime, myIter, myThid )
C--   Add tendency due to diffusion
         IF ( SEAICEdiffKhArea .GT. 0. _d 0 )
     &        CALL SEAICE_DIFFUSION(
     I        GAD_AREA, SEAICEdiffKhArea, ONE,
     I        opnWtrFrac(1-OLx,1-OLy,bi,bj), HEFFM,
     I        xA(1-OLx,1-OLy,bi,bj), yA(1-OLx,1-OLy,bi,bj),
     U        gFld,
     I        bi, bj, myTime, myIter, myThid )
C     now do the "explicit" time step
         DO j=1,sNy
          DO i=1,sNx
           opnWtrFrac(i,j,bi,bj) = HEFFM(i,j,bi,bj) * (
     &          opnWtrFrac(i,j,bi,bj) + SEAICE_deltaTtherm * gFld(i,j)
     &          )
          ENDDO
         ENDDO
        ENDIF

C--   Effective Snow Thickness (Volume)
        IF ( SEAICEadvSnow ) THEN
         DO it=1,SEAICE_multDim
          CALL SEAICE_ADVECTION(
     I         GAD_SNOW, SEAICEadvSchSnow,
     I         uc(1-OLx,1-OLy,bi,bj), vc(1-OLx,1-OLy,bi,bj),
     I         uTrans, vTrans, HSNOWITD(1-OLx,1-OLy,it,bi,bj),
     I         recip_heff,
     O         gFld, afx, afy,
     I         bi, bj, myTime, myIter, myThid )
C--   Add tendency due to diffusion
          IF ( SEAICEdiffKhSnow .GT. 0. _d 0 )
     &         CALL SEAICE_DIFFUSION(
     I         GAD_SNOW, SEAICEdiffKhSnow, ONE,
     I         HSNOWITD(1-OLx,1-OLy,it,bi,bj), HEFFM,
     I         xA(1-OLx,1-OLy,bi,bj), yA(1-OLx,1-OLy,bi,bj),
     U         gFld,
     I         bi, bj, myTime, myIter, myThid )
C     now do the "explicit" time step
          DO j=1,sNy
           DO i=1,sNx
            HSNOWITD(i,j,it,bi,bj) = HEFFM(i,j,bi,bj) * (
     &           HSNOWITD(i,j,it,bi,bj) + SEAICE_deltaTtherm*gFld(i,j)
     &           )
           ENDDO
          ENDDO
         ENDDO
        ENDIF

C     update mean ice thickness HEFF and total ice concentration AREA
C     to match single category values
C     (necessary here because updated HEFF is used below for SItracer)
        CALL SEAICE_ITD_SUM(bi, bj, myTime, myIter, myThid)

#else /* not SEAICE_ITD */
C--   Effective Thickness (Volume)
        IF ( SEAICEadvHeff ) THEN
          CALL SEAICE_ADVECTION(
     I         GAD_HEFF, SEAICEadvSchHeff,
     I         uc(1-OLx,1-OLy,bi,bj), vc(1-OLx,1-OLy,bi,bj),
     I         uTrans, vTrans, HEFF(1-OLx,1-OLy,bi,bj), recip_heff,
     O         gFld, afx, afy,
     I         bi, bj, myTime, myIter, myThid )
         IF ( SEAICEdiffKhHeff .GT. 0. _d 0 ) THEN
C-    Add tendency due to diffusion
          CALL SEAICE_DIFFUSION(
     I         GAD_HEFF, SEAICEdiffKhHeff, ONE,
     I         HEFF(1-OLx,1-OLy,bi,bj), HEFFM,
     I         xA(1-OLx,1-OLy,bi,bj), yA(1-OLx,1-OLy,bi,bj),
     U         gFld,
     I         bi, bj, myTime, myIter, myThid )
         ENDIF
C     now do the "explicit" time step
         DO j=1,sNy
          DO i=1,sNx
           HEFF(i,j,bi,bj) = HEFFM(i,j,bi,bj) * (
     &          HEFF(i,j,bi,bj) + SEAICE_deltaTtherm * gFld(i,j)
     &          )
          ENDDO
         ENDDO
        ENDIF

C--   Fractional area
        IF ( SEAICEadvArea ) THEN
          CALL SEAICE_ADVECTION(
     I         GAD_AREA, SEAICEadvSchArea,
     I         uc(1-OLx,1-OLy,bi,bj), vc(1-OLx,1-OLy,bi,bj),
     I         uTrans, vTrans, AREA(1-OLx,1-OLy,bi,bj), recip_heff,
     O         gFld, afx, afy,
     I         bi, bj, myTime, myIter, myThid )
         IF ( SEAICEdiffKhArea .GT. 0. _d 0 ) THEN
C-    Add tendency due to diffusion
          CALL SEAICE_DIFFUSION(
     I         GAD_AREA, SEAICEdiffKhArea, ONE,
     I         AREA(1-OLx,1-OLy,bi,bj), HEFFM,
     I         xA(1-OLx,1-OLy,bi,bj), yA(1-OLx,1-OLy,bi,bj),
     U         gFld,
     I         bi, bj, myTime, myIter, myThid )
         ENDIF
C     now do the "explicit" time step
         DO j=1,sNy
          DO i=1,sNx
           AREA(i,j,bi,bj) = HEFFM(i,j,bi,bj) * (
     &          AREA(i,j,bi,bj) + SEAICE_deltaTtherm * gFld(i,j)
     &          )
          ENDDO
         ENDDO
        ENDIF

C--   Effective Snow Thickness (Volume)
        IF ( SEAICEadvSnow ) THEN
          CALL SEAICE_ADVECTION(
     I         GAD_SNOW, SEAICEadvSchSnow,
     I         uc(1-OLx,1-OLy,bi,bj), vc(1-OLx,1-OLy,bi,bj),
     I         uTrans, vTrans, HSNOW(1-OLx,1-OLy,bi,bj), recip_heff,
     O         gFld, afx, afy,
     I         bi, bj, myTime, myIter, myThid )
         IF ( SEAICEdiffKhSnow .GT. 0. _d 0 ) THEN
C--   Add tendency due to diffusion
          CALL SEAICE_DIFFUSION(
     I         GAD_SNOW, SEAICEdiffKhSnow, ONE,
     I         HSNOW(1-OLx,1-OLy,bi,bj), HEFFM,
     I         xA(1-OLx,1-OLy,bi,bj), yA(1-OLx,1-OLy,bi,bj),
     U         gFld,
     I         bi, bj, myTime, myIter, myThid )
         ENDIF
C     now do the "explicit" time step
         DO j=1,sNy
          DO i=1,sNx
           HSNOW(i,j,bi,bj) = HEFFM(i,j,bi,bj) * (
     &          HSNOW(i,j,bi,bj) + SEAICE_deltaTtherm * gFld(i,j)
     &          )
          ENDDO
         ENDDO
        ENDIF
#endif /* SEAICE_ITD */

#ifdef SEAICE_VARIABLE_SALINITY
C--   Effective Sea Ice Salinity (Mass of salt)
        IF ( SEAICEadvSalt ) THEN
          CALL SEAICE_ADVECTION(
     I         GAD_SALT, SEAICEadvSchSalt,
     I         uc(1-OLx,1-OLy,bi,bj), vc(1-OLx,1-OLy,bi,bj),
     I         uTrans, vTrans, HSALT(1-OLx,1-OLy,bi,bj), recip_heff,
     O         gFld, afx, afy,
     I         bi, bj, myTime, myIter, myThid )
         IF ( SEAICEdiffKhSalt .GT. 0. _d 0 ) THEN
C--   Add tendency due to diffusion
          CALL SEAICE_DIFFUSION(
     I         GAD_SALT, SEAICEdiffKhSalt, ONE,
     I         HSALT(1-OLx,1-OLy,bi,bj), HEFFM,
     I         xA(1-OLx,1-OLy,bi,bj), yA(1-OLx,1-OLy,bi,bj),
     U         gFld,
     I         bi, bj, myTime, myIter, myThid )
         ENDIF
C     now do the "explicit" time step
         DO j=1,sNy
          DO i=1,sNx
           HSALT(i,j,bi,bj) = HEFFM(i,j,bi,bj) * (
     &          HSALT(i,j,bi,bj) + SEAICE_deltaTtherm * gFld(i,j)
     &          )
          ENDDO
         ENDDO
        ENDIF
#endif /* SEAICE_VARIABLE_SALINITY */

#ifdef ALLOW_SITRACER
C--   Sea Ice Tracers
        DO iTr = 1, SItrNumInUse
        IF ( (SEAICEadvHEFF.AND.(SItrMate(iTr).EQ.'HEFF')).OR.
     &       (SEAICEadvAREA.AND.(SItrMate(iTr).EQ.'AREA')) ) THEN
C--   scale to effective value
         IF (SItrMate(iTr).EQ.'HEFF') THEN
          SEAICEadvSchSItr=SEAICEadvSchHEFF
          SEAICEdiffKhSItr=SEAICEdiffKhHEFF
          DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
            SItrExt(i,j,bi,bj) = HEFFM(i,j,bi,bj) *
     &          SItracer(i,j,bi,bj,iTr) * hEffNm1(i,j,bi,bj)
           ENDDO
          ENDDO
c TAF?   ELSEIF (SItrMate(iTr).EQ.'AREA') THEN
         ELSE
          SEAICEadvSchSItr=SEAICEadvSchAREA
          SEAICEdiffKhSItr=SEAICEdiffKhAREA
          DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
            SItrExt(i,j,bi,bj) = HEFFM(i,j,bi,bj) *
     &          SItracer(i,j,bi,bj,iTr) * areaNm1(i,j,bi,bj)
           ENDDO
          ENDDO
         ENDIF
C--   store a couple things
          DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
#ifdef ALLOW_SITRACER_ADVCAP
C--   store previous value for spurious maxima treament
            SItrPrev(i,j,bi,bj)=SItracer(i,j,bi,bj,iTr)
#endif
#ifdef ALLOW_SITRACER_DEBUG_DIAG
            diagArray(i,j,2+(iTr-1)*5) = SItrExt(i,j,bi,bj)
#endif
           ENDDO
          ENDDO
C--   compute advective tendency
          CALL SEAICE_ADVECTION(
     I         GAD_SITR+iTr-1, SEAICEadvSchSItr,
     I         uc(1-OLx,1-OLy,bi,bj), vc(1-OLx,1-OLy,bi,bj),
     I         uTrans, vTrans, SItrExt(1-OLx,1-OLy,bi,bj),
     I         recip_heff,
     O         gFld, afx, afy,
     I         bi, bj, myTime, myIter, myThid )
          IF ( SEAICEdiffKhHeff .GT. 0. _d 0 ) THEN
C--   add diffusive tendency
          CALL SEAICE_DIFFUSION(
     I         GAD_SITR+iTr-1, SEAICEdiffKhSItr, ONE,
     I         SItrExt(1-OLx,1-OLy,bi,bj), HEFFM,
     I         xA(1-OLx,1-OLy,bi,bj), yA(1-OLx,1-OLy,bi,bj),
     U         gFld,
     I         bi, bj, myTime, myIter, myThid )
          ENDIF
C--   apply tendency
          DO j=1,sNy
           DO i=1,sNx
            SItrExt(i,j,bi,bj) = HEFFM(i,j,bi,bj) * (
     &        SItrExt(i,j,bi,bj) + SEAICE_deltaTtherm * gFld(i,j) )
           ENDDO
          ENDDO
C--   scale back to actual value, or move effective value to ocean bucket
         IF (SItrMate(iTr).EQ.'HEFF') THEN
          DO j=1,sNy
           DO i=1,sNx
            IF (HEFF(i,j,bi,bj).GE.siEps) THEN
             SItracer(i,j,bi,bj,iTr)=SItrExt(i,j,bi,bj)/HEFF(i,j,bi,bj)
             SItrBucket(i,j,bi,bj,iTr)=0. _d 0
            ELSE
             SItracer(i,j,bi,bj,iTr)=0. _d 0
             SItrBucket(i,j,bi,bj,iTr)=SItrExt(i,j,bi,bj)
            ENDIF
#ifdef ALLOW_SITRACER_ADVCAP
C hack to try avoid 'spontaneous generation' of maxima, which supposedly would
C occur less frequently if we advected SItr with uXheff instead SItrXheff with u
            tmpscal1=max(SItrPrev(i,j,bi,bj),
     &       SItrPrev(i+1,j,bi,bj),SItrPrev(i-1,j,bi,bj),
     &       SItrPrev(i,j+1,bi,bj),SItrPrev(i,j-1,bi,bj))
            tmpscal2=MAX(ZERO,SItracer(i,j,bi,bj,iTr)-tmpscal1)
            SItracer(i,j,bi,bj,iTr)=SItracer(i,j,bi,bj,iTr)-tmpscal2
            SItrBucket(i,j,bi,bj,iTr)=SItrBucket(i,j,bi,bj,iTr)
     &           +tmpscal2*HEFF(i,j,bi,bj)
#endif
C           treat case of potential negative value
            IF (HEFF(i,j,bi,bj).GE.siEps) THEN
             tmpscal1=MIN(0. _d 0,SItracer(i,j,bi,bj,iTr))
             SItracer(i,j,bi,bj,iTr)=SItracer(i,j,bi,bj,iTr)-tmpscal1
             SItrBucket(i,j,bi,bj,iTr)=SItrBucket(i,j,bi,bj,iTr)
     &                                 +HEFF(i,j,bi,bj)*tmpscal1
            ENDIF
#ifdef ALLOW_SITRACER_DEBUG_DIAG
            diagArray(i,j,1+(iTr-1)*5)= -SItrBucket(i,j,bi,bj,iTr)
     &      * HEFFM(i,j,bi,bj)/SEAICE_deltaTtherm*SEAICE_rhoIce
            tmpscal1= ( HEFF(i,j,bi,bj)*SItracer(i,j,bi,bj,iTr)
     &      + SItrBucket(i,j,bi,bj,iTr) )*HEFFM(i,j,bi,bj)
            diagArray(i,j,2+(iTr-1)*5)= tmpscal1
     &                                - diagArray(i,j,2+(iTr-1)*5)
            diagArray(i,j,3+(iTr-1)*5)= HEFFM(i,j,bi,bj)
     &      * SEAICE_deltaTtherm * gFld(i,j)
#endif
           ENDDO
          ENDDO
c TAF?   ELSEIF (SItrMate(iTr).EQ.'AREA') THEN
         ELSE
          DO j=1,sNy
           DO i=1,sNx
            IF (AREA(i,j,bi,bj).GE.SEAICE_area_floor) THEN
             SItracer(i,j,bi,bj,iTr)=SItrExt(i,j,bi,bj)/AREA(i,j,bi,bj)
            ELSE
             SItracer(i,j,bi,bj,iTr)=0. _d 0
            ENDIF
            SItrBucket(i,j,bi,bj,iTr)=0. _d 0
#ifdef ALLOW_SITRACER_ADVCAP
            tmpscal1=max(SItrPrev(i,j,bi,bj),
     &       SItrPrev(i+1,j,bi,bj),SItrPrev(i-1,j,bi,bj),
     &       SItrPrev(i,j+1,bi,bj),SItrPrev(i,j-1,bi,bj))
            tmpscal2=MAX(ZERO,SItracer(i,j,bi,bj,iTr)-tmpscal1)
            SItracer(i,j,bi,bj,iTr)=SItracer(i,j,bi,bj,iTr)-tmpscal2
#endif
C           treat case of potential negative value
            IF (AREA(i,j,bi,bj).GE.SEAICE_area_floor) THEN
              tmpscal1=MIN(0. _d 0,SItracer(i,j,bi,bj,iTr))
              SItracer(i,j,bi,bj,iTr)=SItracer(i,j,bi,bj,iTr)-tmpscal1
            ENDIF
#ifdef ALLOW_SITRACER_DEBUG_DIAG
            diagArray(i,j,1+(iTr-1)*5)= 0. _d 0
            diagArray(i,j,2+(iTr-1)*5)= - diagArray(i,j,2+(iTr-1)*5)
     &      + AREA(i,j,bi,bj)*SItracer(i,j,bi,bj,iTr)*HEFFM(i,j,bi,bj)
            diagArray(i,j,3+(iTr-1)*5)=HEFFM(i,j,bi,bj)
     &      * SEAICE_deltaTtherm * gFld(i,j)
#endif
           ENDDO
          ENDDO
         ENDIF
C--
         ENDIF
        ENDDO
#ifdef ALLOW_SITRACER_DEBUG_DIAG
c     CALL DIAGNOSTICS_FILL(DIAGarray,'UDIAG2  ',0,Nr,2,bi,bj,myThid)
#endif
#endif /* ALLOW_SITRACER */

C---   end bi,bj loops
       ENDDO
      ENDDO

#else /* not ALLOW_GENERIC_ADVDIFF */
       WRITE(msgBuf,'(2A)')
     &  'SEAICE_ADVDIFF: cannot use SEAICEmultiDimAdvection',
     &  ' without pkg/generic_advdiff'
       CALL PRINT_ERROR( msgBuf , myThid )
       WRITE(msgBuf,'(2A)') 'SEAICE_ADVDIFF: ',
     &  'Re-compile with pkg "generic_advdiff" in packages.conf'
       CALL PRINT_ERROR( msgBuf , myThid )
       CALL ALL_PROC_DIE( myThid )
       STOP 'ABNORMAL END: S/R SEAICE_ADVDIFF'
#endif /* ALLOW_GENERIC_ADVDIFF */
      ELSE
C--   if not multiDimAdvection
#ifdef SEAICE_ITD
C     just for safety
       WRITE(msgBuf,'(2A)') 'SEAICE_ADVDIFF: ',
     &  'ITD with SEAICEmultiDimAdvection=.False. is not allowed,'
       CALL PRINT_ERROR( msgBuf , myThid )
       WRITE(msgBuf,'(2A)') 'SEAICE_ADVDIFF: ',
     &  'use a multidimensional advection scheme (in data.seaice)'
       CALL PRINT_ERROR( msgBuf , myThid )
       CALL ALL_PROC_DIE( myThid )
       STOP 'ABNORMAL END: S/R SEAICE_ADVDIFF'
#endif /* SEAICE_ITD */

       IF ( SEAICEadvHEff ) THEN
#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE heff = comlev1, key = ikey_dynamics, kind=isbyte
#endif
        CALL ADVECT( uc, vc, hEff, fldNm1, HEFFM, myThid )
        IF ( SEAICEdiffKhHeff .GT. 0. _d 0 ) THEN
C-    Add tendency due to diffusion
         DO bj=myByLo(myThid),myByHi(myThid)
          DO bi=myBxLo(myThid),myBxHi(myThid)
            CALL SEAICE_DIFFUSION(
     I           GAD_HEFF, SEAICEdiffKhHeff, SEAICE_deltaTtherm,
     I           fldNm1(1-OLx,1-OLy,bi,bj), HEFFM,
     I           xA(1-OLx,1-OLy,bi,bj), yA(1-OLx,1-OLy,bi,bj),
     U           HEFF(1-OLx,1-OLy,bi,bj),
     I           bi, bj, myTime, myIter, myThid )
          ENDDO
         ENDDO
        ENDIF
       ENDIF
       IF ( SEAICEadvArea ) THEN
#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE area = comlev1, key = ikey_dynamics, kind=isbyte
#endif
        CALL ADVECT( uc, vc, area, fldNm1, HEFFM, myThid )
        IF ( SEAICEdiffKhArea .GT. 0. _d 0 ) THEN
C-    Add tendency due to diffusion
         DO bj=myByLo(myThid),myByHi(myThid)
          DO bi=myBxLo(myThid),myBxHi(myThid)
            CALL SEAICE_DIFFUSION(
     I           GAD_AREA, SEAICEdiffKhArea, SEAICE_deltaTtherm,
     I           fldNm1(1-OLx,1-OLy,bi,bj), HEFFM,
     I           xA(1-OLx,1-OLy,bi,bj), yA(1-OLx,1-OLy,bi,bj),
     U           Area(1-OLx,1-OLy,bi,bj),
     I           bi, bj, myTime, myIter, myThid )
          ENDDO
         ENDDO
        ENDIF
       ENDIF
       IF ( SEAICEadvSnow ) THEN
#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE hsnow = comlev1, key = ikey_dynamics, kind=isbyte
#endif
        CALL ADVECT( uc, vc, HSNOW, fldNm1, HEFFM, myThid )
        IF ( SEAICEdiffKhSnow .GT. 0. _d 0 ) THEN
C-    Add tendency due to diffusion
         DO bj=myByLo(myThid),myByHi(myThid)
          DO bi=myBxLo(myThid),myBxHi(myThid)
            CALL SEAICE_DIFFUSION(
     I           GAD_SNOW, SEAICEdiffKhSnow, SEAICE_deltaTtherm,
     I           fldNm1(1-OLx,1-OLy,bi,bj), HEFFM,
     I           xA(1-OLx,1-OLy,bi,bj), yA(1-OLx,1-OLy,bi,bj),
     U           HSNOW(1-OLx,1-OLy,bi,bj),
     I           bi, bj, myTime, myIter, myThid )
          ENDDO
         ENDDO
        ENDIF
       ENDIF

#ifdef SEAICE_VARIABLE_SALINITY
       IF ( SEAICEadvSalt ) THEN
#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE hsalt = comlev1, key = ikey_dynamics, kind=isbyte
#endif
        CALL ADVECT( uc, vc, HSALT, fldNm1, HEFFM, myThid )
        IF ( SEAICEdiffKhSalt .GT. 0. _d 0 ) THEN
C-    Add tendency due to diffusion
         DO bj=myByLo(myThid),myByHi(myThid)
          DO bi=myBxLo(myThid),myBxHi(myThid)
            CALL SEAICE_DIFFUSION(
     I           GAD_SALT, SEAICEdiffKhSalt, SEAICE_deltaTtherm,
     I           fldNm1(1-OLx,1-OLy,bi,bj), HEFFM,
     I           xA(1-OLx,1-OLy,bi,bj), yA(1-OLx,1-OLy,bi,bj),
     U           HSALT(1-OLx,1-OLy,bi,bj),
     I           bi, bj, myTime, myIter, myThid )
          ENDDO
         ENDDO
        ENDIF
       ENDIF
#endif /* SEAICE_VARIABLE_SALINITY */

C--   end if multiDimAdvection
      ENDIF

      RETURN
      END

#include "PACKAGES_CONFIG.h"
#include "CPP_OPTIONS.h"

CBOP
C     !ROUTINE: INI_CORI

C     !INTERFACE:
      SUBROUTINE INI_CORI( myThid )
C     !DESCRIPTION:
C     Initialise coriolis term.

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#ifdef ALLOW_EXCH2
# include "W2_EXCH2_SIZE.h"
# include "W2_EXCH2_TOPOLOGY.h"
#endif
#ifdef ALLOW_MNC
# include "MNC_PARAMS.h"
#endif
#ifdef ALLOW_MONITOR
# include "MONITOR.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     myThid  :: my Thread Id number
      INTEGER myThid
CEOP

C     === Functions ====
      LOGICAL  MASTER_CPU_IO
      EXTERNAL MASTER_CPU_IO

C     !LOCAL VARIABLES:
C     bi,bj   :: Tile Indices counters
C     i, j    :: Loop counters
C     facGrid :: Factor for grid to meter conversion
      INTEGER bi,bj
      INTEGER i, j
      _RL facGrid
#ifndef OLD_GRID_IO
      INTEGER myTile, iG, iLen
      CHARACTER*(MAX_LEN_FNAM) fName
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      INTEGER  ILNBLNK
      EXTERNAL ILNBLNK
#endif


C     Initialise coriolis parameter
      IF     ( selectCoriMap.EQ.0 ) THEN
C       Constant F case
        DO bj = myByLo(myThid), myByHi(myThid)
          DO bi = myBxLo(myThid), myBxHi(myThid)
            DO j=1-Oly,sNy+Oly
              DO i=1-Olx,sNx+Olx
                fCori(i,j,bi,bj)  = f0
                fCoriG(i,j,bi,bj) = f0
                fCoriCos(i,j,bi,bj)=fPrime
              ENDDO
            ENDDO
          ENDDO
        ENDDO
      ELSEIF ( selectCoriMap.EQ.1 ) THEN
C       Beta plane case
        facGrid = 1. _d 0
        IF ( usingSphericalPolarGrid
     &     .OR. usingCurvilinearGrid ) facGrid = deg2rad*rSphere
        DO bj = myByLo(myThid), myByHi(myThid)
          DO bi = myBxLo(myThid), myBxHi(myThid)
            DO j=1-Oly,sNy+Oly
              DO i=1-Olx,sNx+Olx
                fCori(i,j,bi,bj)  = f0+beta*_yC(i,j,bi,bj)*facGrid
                fCoriG(i,j,bi,bj) = f0+beta* yG(i,j,bi,bj)*facGrid
                fCoriCos(i,j,bi,bj)=fPrime
              ENDDO
            ENDDO
          ENDDO
        ENDDO
      ELSEIF ( selectCoriMap.EQ.2 ) THEN
C       Spherical case
C       Note in this case we assume yC is in degrees.
        DO bj = myByLo(myThid), myByHi(myThid)
          DO bi = myBxLo(myThid), myBxHi(myThid)
            DO j=1-Oly,sNy+Oly
              DO i=1-Olx,sNx+Olx
                fCori(i,j,bi,bj)  =
     &                 2. _d 0*omega*sin(_yC(i,j,bi,bj)*deg2rad)
                fCoriG(i,j,bi,bj) =
     &                 2. _d 0*omega*sin(yG(i,j,bi,bj)*deg2rad)
                fCoriCos(i,j,bi,bj)=
     &                 2. _d 0*omega*cos(_yC(i,j,bi,bj)*deg2rad)
              ENDDO
            ENDDO
          ENDDO
        ENDDO
c       CALL WRITE_FLD_XY_RL('fCoriC',' ',fCori ,  0,myThid)
c       CALL WRITE_FLD_XY_RL('fCoriG',' ',fCoriG , 0,myThid)
c       CALL WRITE_FLD_XY_RL('fCorCs',' ',fCoriCos,0,myThid)
      ELSE
C       Initialise to zero
        DO bj = myByLo(myThid), myByHi(myThid)
          DO bi = myBxLo(myThid), myBxHi(myThid)
            DO j=1-Oly,sNy+Oly
              DO i=1-Olx,sNx+Olx
                fCori(i,j,bi,bj)  = 0. _d 0
                fCoriG(i,j,bi,bj) = 0. _d 0
                fCoriCos(i,j,bi,bj)=0. _d 0
              ENDDO
            ENDDO
          ENDDO
        ENDDO
      ENDIF

      IF ( selectCoriMap.EQ.3 ) THEN
C     Special custom form: read from files
        CALL READ_REC_XY_RS( 'fCoriC.bin', fCori,   1, 0, myThid )
        CALL READ_REC_XY_RS( 'fCorCs.bin', fCoriCos,1, 0, myThid )
        IF ( .NOT.useCubedSphereExchange ) THEN
         CALL READ_REC_XY_RS('fCoriG.bin', fCoriG,  1, 0, myThid )
        ELSE
#ifdef OLD_GRID_IO
         CALL READ_REC_XY_RS('fCoriG.bin', fCoriG,  1, 0, myThid )
C-       deal with the 2 missing corners (for fCoriG):
         DO bj = myByLo(myThid), myByHi(myThid)
          DO bi = myBxLo(myThid), myBxHi(myThid)
C-  Notes: this will only works with 6 tiles (1 per face) and
C    with 2 polar faces + 4 equatorials:
           IF (bi.LE.3 .OR. bi.GE.5) THEN
             fCoriG(sNx+1,1,bi,bj) = fCoriG(1,1,bi,bj)
           ELSE
             fCoriG(sNx+1,1,bi,bj) = -fCoriG(1,1,bi,bj)
           ENDIF
           IF (bi.GE.3) THEN
             fCoriG(1,sNy+1,bi,bj) = fCoriG(1,1,bi,bj)
             fCoriG(sNx+1,sNy+1,bi,bj) = fCoriG(sNx+1,1,bi,bj)
           ELSE
             fCoriG(1,sNy+1,bi,bj) = -fCoriG(1,1,bi,bj)
             fCoriG(sNx+1,sNy+1,bi,bj) = -fCoriG(sNx+1,1,bi,bj)
           ENDIF
          ENDDO
         ENDDO
#else  /* OLD_GRID_IO */
         _BEGIN_MASTER(myThid)
         DO bj = 1,nSy
          DO bi = 1,nSx
           iG = bi+(myXGlobalLo-1)/sNx
           myTile = iG
#ifdef ALLOW_EXCH2
           myTile = W2_myTileList(bi,bj)
           iG = exch2_myface(myTile)
#endif
           WRITE(fName,'(2A,I3.3,A)') 'fCoriG','.face',iG,'.bin'
           iLen = ILNBLNK(fName)
           WRITE(msgBuf,'(A,I6,2A)')
     &       ' Reading tile:', myTile, ' from file ', fName(1:iLen)
           CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                         SQUEEZE_RIGHT , myThid )
#ifdef ALLOW_MDSIO
           CALL MDS_FACEF_READ_RS( fName, readBinaryPrec, 1,
     &                             fCoriG, bi, bj, myThid )
#else /* ALLOW_MDSIO */
           WRITE(msgBuf,'(A)') 'INI_CORI: Needs to compile MDSIO pkg'
           CALL PRINT_ERROR( msgBuf, myThid )
           STOP 'ABNORMAL END: S/R INI_CORI'
#endif /* ALLOW_MDSIO */

          ENDDO
         ENDDO
         _END_MASTER(myThid)
#endif /* OLD_GRID_IO */
        ENDIF

        CALL EXCH_XY_RS( fCori, myThid )
        CALL EXCH_XY_RS( fCoriCos, myThid )
        CALL EXCH_Z_3D_RS( fCoriG, 1, myThid )
      ENDIF

#ifdef ALLOW_MONITOR
      IF ( MASTER_CPU_IO(myThid) ) THEN
C--   only the master thread is allowed to switch On/Off mon_write_stdout
C     & mon_write_mnc (since it is the only thread that uses those flags):

        IF (monitor_stdio) THEN
          mon_write_stdout = .TRUE.
        ELSE
          mon_write_stdout = .FALSE.
        ENDIF
        mon_write_mnc = .FALSE.
#ifdef ALLOW_MNC
        IF (useMNC .AND. monitor_mnc) THEN
          DO i = 1,MAX_LEN_MBUF
            mon_fname(i:i) = ' '
          ENDDO
          mon_fname(1:12) = 'monitor_grid'
          CALL MNC_CW_SET_UDIM(mon_fname, 1, myThid)
          mon_write_mnc = .TRUE.
        ENDIF
#endif /*  ALLOW_MNC  */

      ENDIF

      CALL MON_SET_PREF( mon_string_none, myThid )
      CALL MON_PRINTSTATS_RS(1,fCori,'fCori',myThid)
      CALL MON_PRINTSTATS_RS(1,fCoriG,'fCoriG',myThid)
      CALL MON_PRINTSTATS_RS(1,fCoriCos,'fCoriCos',myThid)

      IF ( MASTER_CPU_IO(myThid) ) THEN
        mon_write_stdout = .FALSE.
        mon_write_mnc    = .FALSE.
      ENDIF
#endif /* ALLOW_MONITOR */

      RETURN
      END

#include "GMREDI_OPTIONS.h"

CBOP
C !ROUTINE: GMREDI_WRITE_PICKUP

C !INTERFACE: ==========================================================
      SUBROUTINE GMREDI_WRITE_PICKUP( permPickup,
     &     suff, myTime, myIter, myThid )

C !DESCRIPTION:
C     Writes current state of passive tracers to a pickup file

C !USES: ===============================================================
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GMREDI.h"

C !INPUT PARAMETERS: ===================================================
C     permPickup      :: write a permanent pickup
C     suff            :: suffix for pickup file (eg. ckptA or 0000000010)
C     myTime          :: model time
C     myIter          :: time-step number
C     myThid          :: thread number
      LOGICAL permPickup
      CHARACTER*(*) suff
      _RL myTime
      INTEGER myIter
      INTEGER myThid

C !OUTPUT PARAMETERS: ==================================================
C  none

#if ( defined GM_BATES_K3D || defined GM_GEOM_VARIABLE_K )
C !FUNCTIONS: ==========================================================
      INTEGER  ILNBLNK
      EXTERNAL ILNBLNK

C !LOCAL VARIABLES: ====================================================
C     n           :: loop index / field number
C     nj          :: record number
C     fp          :: pickup-file precision
C     glf         :: local flag for "globalFiles"
C     fn          :: character buffer for creating filename
C     nWrFlds     :: number of fields being written
C     listDim     :: dimension of "wrFldList" local array
C     wrFldList   :: list of written fields
C     msgBuf      :: Informational/error message buffer
      INTEGER n, nj, fp, lChar
      LOGICAL glf
      _RL     timList(1)
      CHARACTER*(MAX_LEN_FNAM) fn
      INTEGER listDim, nWrFlds
#ifdef GM_BATES_K3D
      INTEGER i, j, k, bi, bj, m
      _RL vec(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
# ifdef GM_GEOM_VARIABLE_K
      PARAMETER( listDim = 5+2*GM_Bates_NModes )
# else
      PARAMETER( listDim = 2+2*GM_Bates_NModes )
# endif
#else /* GM_BATES_K3D */
      PARAMETER( listDim = 3 )
#endif /* GM_BATES_K3D */
      CHARACTER*(8) wrFldList(listDim)
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      CHARACTER*(8) fieldname
CEOP

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      IF ( GM_useBatesK3d .OR. GM_useGEOM ) THEN

       lChar = ILNBLNK(suff)
       IF ( lChar.EQ.0 ) THEN
         WRITE(fn,'(2A)') 'pickup_gmredi'
       ELSE
         WRITE(fn,'(2A)') 'pickup_gmredi.',suff(1:lChar)
       ENDIF
       fp = precFloat64
       n  = 0
       nj = 0

#ifdef GM_BATES_K3D
       IF ( GM_useBatesK3d ) THEN

C     record number < 0 : a hack not to write meta files now:

C     Centre mode
        DO bj=myByLo(myThid),myByHi(myThid)
         DO bi=myBxLo(myThid),myBxHi(myThid)
          DO k=1,Nr
           DO j=1-OLy,sNy+OLy
            DO i=1-OLx,sNx+OLx
             vec(i,j,k,bi,bj) = modesC(1,i,j,k,bi,bj)
            ENDDO
           ENDDO
          ENDDO
         ENDDO
        ENDDO
        n = n + 1
        CALL WRITE_REC_3D_RL( fn, fp, Nr,
     &                        vec, -n, myIter, myThid )
        fieldname = 'mode01C '
        IF (n.LE.listDim) wrFldList(n) = fieldname

C     Western Mode
        DO m=1,GM_Bates_NModes
         DO bj=myByLo(myThid),myByHi(myThid)
          DO bi=myBxLo(myThid),myBxHi(myThid)
           DO k=1,Nr
            DO j=1-OLy,sNy+OLy
             DO i=1-OLx,sNx+OLx
              vec(i,j,k,bi,bj) = modesW(m,i,j,k,bi,bj)
             ENDDO
            ENDDO
           ENDDO
          ENDDO
         ENDDO
         n = n + 1
         CALL WRITE_REC_3D_RL( fn, fp, Nr,
     &                         vec, -n, myIter, myThid )
         WRITE(fieldname, '(A,I2.2,A)') 'mode',m,'W'
         IF (n.LE.listDim) wrFldList(n) = fieldname
        ENDDO

C     Southern Mode
        DO m=1,GM_Bates_NModes
         DO bj=myByLo(myThid),myByHi(myThid)
          DO bi=myBxLo(myThid),myBxHi(myThid)
           DO k=1,Nr
            DO j=1-OLy,sNy+OLy
             DO i=1-OLx,sNx+OLx
              vec(i,j,k,bi,bj) = modesS(m,i,j,k,bi,bj)
             ENDDO
            ENDDO
           ENDDO
          ENDDO
         ENDDO
         n = n + 1
         CALL WRITE_REC_3D_RL( fn, fp, Nr,
     &                         vec, -n, myIter, myThid )
         WRITE(fieldname, '(A,I2.2,A)') 'mode',m,'S'
         IF (n.LE.listDim) wrFldList(n) = fieldname
        ENDDO
C--------------------------

C-    switch to 2-D fields:
        nj = -n*Nr

C     The deformation radius (2D field)
        n = n + 1
        nj = nj-1
        CALL WRITE_REC_3D_RL( fn, fp, 1,
     &                        Rdef, nj, myIter, myThid )
        fieldname = 'Rdef    '
        IF (n.LE.listDim) wrFldList(n) = fieldname

c     if GM_useBatesK3d
       ENDIF
#endif /* GM_BATES_K3D */

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#ifdef GM_GEOM_VARIABLE_K
       IF ( GM_useGEOM ) THEN

        n = n + 1
        nj = nj-1
        CALL WRITE_REC_3D_RL( fn,fp,1,GEOM_EKE,nj,myIter,myThid )
        fieldname = 'GEOM_EKE'
        IF (n.LE.listDim) wrFldList(n) = fieldname

        n = n + 1
        nj = nj-1
        CALL WRITE_REC_3D_RL( fn,fp,1,GEOM_gEKE_Nm1,nj,myIter,myThid )
        fieldname = 'GEKE_Nm1'
        IF (n.LE.listDim) wrFldList(n) = fieldname

C     if GM_useGEOM
       ENDIF
#endif /* GM_GEOM_VARIABLE_K */

       nWrFlds = n
       IF ( nWrFlds.GT.listDim ) THEN
         WRITE(msgBuf,'(2A,I5,A)') 'GMREDI_WRITE_PICKUP: ',
     &        'trying to write ',nWrFlds,' fields'
         CALL PRINT_ERROR( msgBuf, myThid )
         WRITE(msgBuf,'(2A,I5,A)') 'GMREDI_WRITE_PICKUP: ',
     &        'field-list dimension (listDim=',listDim,') too small'
         CALL PRINT_ERROR( msgBuf, myThid )
         CALL ALL_PROC_DIE( myThid )
         STOP 'ABNORMAL END: S/R GMREDI_WRITE_PICKUP (list-size Pb)'
       ENDIF

#ifdef ALLOW_MDSIO
C     uses this specific S/R to write (with more informations) only meta files
       n  = 1
       nj = ABS(nj)
       IF ( nWrFlds*Nr .EQ. nj ) THEN
         n  = Nr
         nj = nWrFlds
       ENDIF
       glf  = globalFiles
       timList(1) = myTime
       CALL MDS_WR_METAFILES( fn, fp, glf, .FALSE.,
     &       0, 0, n, ' ',
     &       nWrFlds, wrFldList,
     &       1, timList, oneRL,
     &       nj, myIter, myThid )
#endif /* ALLOW_MDSIO */

C     if GM_useBatesK3d or GM_useGEOM
      ENDIF

#endif /* GM_BATES_K3D or GM_GEOM_VARIABLE_K */

      RETURN
      END

#include "SMOOTH_OPTIONS.h"

      SUBROUTINE SMOOTH_INIT3D( smoothOpNb, myThid )

C     *==========================================================*
C     | SUBROUTINE smooth_init3D
C     | o Routine that initializes one 3D smoothing/correlation operator
C     |   by computing/writing the corresponding diffusion operator
C     *==========================================================*

Cgf the choices of smooth3Dtype and smooth3Dsize need comments...
Cgf
Cgf smooth3DtypeH= 1) HORIZONTAL ALONG GRID AXIS
Cgf              2-3) GMREDI TYPES
Cgf                4) HORIZONTAL BUT WITH ROTATED AXIS
Cgf for now I focus on the simpler smooth3DtypeH=1 case

      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "SMOOTH.h"

      INTEGER smoothOpNb
      INTEGER myThid

      INTEGER i, j, k, bi, bj
      CHARACTER*(MAX_LEN_FNAM) fnamegeneric
      _RL smooth3D_KzMax

      INTEGER IL

c     == functions ==
      INTEGER  ILNBLNK
      EXTERNAL ILNBLNK

      IL = ILNBLNK( smoothDir )

      smooth3DtotTime = smooth3Dnbt(smoothOpNb)*smooth3DdelTime

C vertical smoothing:

      IF ( smooth3DsizeZ(smoothOpNb).EQ.3 ) THEN
        WRITE(fnamegeneric,'(2A,I3.3)')
     &        smoothDir(1:IL),
     &        'smooth3DscalesZ', smoothOpNb
        CALL READ_REC_3D_RL( fnamegeneric, smoothprec,
     &                       Nr, smooth3D_Lz, 1, 1, myThid )
        CALL EXCH_XYZ_RL( smooth3D_Lz, myThid )
      ELSE
        DO bj=myByLo(myThid),myByHi(myThid)
         DO bi=myBxLo(myThid),myBxHi(myThid)
          DO k=1,Nr
           DO j=1-OLy,sNy+OLy
            DO i=1-OLx,sNx+OLx
             smooth3D_Lz(i,j,k,bi,bj) = smooth3D_Lz0(smoothOpNb)
            ENDDO
           ENDDO
          ENDDO
         ENDDO
        ENDDO
      ENDIF

      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        DO k=1,Nr
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           smooth3D_kappaR(i,j,k,bi,bj) = smooth3D_Lz(i,j,k,bi,bj)
     &             *smooth3D_Lz(i,j,k,bi,bj)/smooth3DtotTime/2
          ENDDO
         ENDDO
        ENDDO
       ENDDO
      ENDDO

C avoid excessive vertical smoothing:
      IF ( smooth3DsizeZ(smoothOpNb).NE.3 ) THEN
        DO bj=myByLo(myThid),myByHi(myThid)
         DO bi=myBxLo(myThid),myBxHi(myThid)
          DO k=1,Nr
           DO j=1-OLy,sNy+OLy
            DO i=1-OLx,sNx+OLx
             smooth3D_KzMax=drC(k)
             smooth3D_KzMax = smooth3D_KzMax*smooth3D_KzMax
     &                                      /smooth3DtotTime/2
             IF ( smooth3D_kappaR(i,j,k,bi,bj).GT.smooth3D_KzMax ) THEN
              smooth3D_kappaR(i,j,k,bi,bj) = smooth3D_KzMax
             ENDIF
            ENDDO
           ENDDO
          ENDDO
         ENDDO
        ENDDO
      ENDIF

      CALL EXCH_XYZ_RL( smooth3D_kappaR, myThid )

C horizontal smoothing:

      IF ( smooth3DsizeH(smoothOpNb).EQ.3 ) THEN
        WRITE(fnamegeneric,'(2A,I3.3)')
     &        smoothDir(1:IL),
     &        'smooth3DscalesH', smoothOpNb
        CALL READ_REC_3D_RL( fnamegeneric, smoothprec,
     &                       Nr, smooth3D_Lx, 1, 1, myThid )
        CALL READ_REC_3D_RL( fnamegeneric, smoothprec,
     &                       Nr, smooth3D_Ly, 2, 1, myThid )
        CALL EXCH_XYZ_RL( smooth3D_Lx, myThid )
        CALL EXCH_XYZ_RL( smooth3D_Ly, myThid )
      ELSE
        DO bj=myByLo(myThid),myByHi(myThid)
         DO bi=myBxLo(myThid),myBxHi(myThid)
          DO k=1,Nr
           DO j=1-OLy,sNy+OLy
            DO i=1-OLx,sNx+OLx
             smooth3D_Lx(i,j,k,bi,bj) = smooth3D_Lx0(smoothOpNb)
             smooth3D_Ly(i,j,k,bi,bj) = smooth3D_Ly0(smoothOpNb)
            ENDDO
           ENDDO
          ENDDO
         ENDDO
        ENDDO
      ENDIF

      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        DO k=1,Nr
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           smooth3D_Kuy(i,j,k,bi,bj) = 0.
           smooth3D_Kvx(i,j,k,bi,bj) = 0.
           smooth3D_Kwx(i,j,k,bi,bj) = 0.
           smooth3D_Kwy(i,j,k,bi,bj) = 0.
           smooth3D_Kwz(i,j,k,bi,bj) = 0.
           smooth3D_Kux(i,j,k,bi,bj) = smooth3D_Lx(i,j,k,bi,bj)
     &              *smooth3D_Lx(i,j,k,bi,bj)/smooth3DtotTime/2
           smooth3D_Kvy(i,j,k,bi,bj) = smooth3D_Ly(i,j,k,bi,bj)
     &              *smooth3D_Ly(i,j,k,bi,bj)/smooth3DtotTime/2
           smooth3D_Kuz(i,j,k,bi,bj) = 0.
           smooth3D_Kvz(i,j,k,bi,bj) = 0.
          ENDDO
         ENDDO
        ENDDO
       ENDDO
      ENDDO

C is exchange useful here?

      CALL EXCH_XYZ_RL( smooth3D_kappaR, myThid )
      CALL EXCH_XYZ_RL( smooth3D_Kwx, myThid )
      CALL EXCH_XYZ_RL( smooth3D_Kwy, myThid )
      CALL EXCH_XYZ_RL( smooth3D_Kwz, myThid )
      CALL EXCH_XYZ_RL( smooth3D_Kux, myThid )
      CALL EXCH_XYZ_RL( smooth3D_Kvy, myThid )
      CALL EXCH_XYZ_RL( smooth3D_Kuz, myThid )
      CALL EXCH_XYZ_RL( smooth3D_Kvz, myThid )
      CALL EXCH_XYZ_RL( smooth3D_Kuy, myThid )
      CALL EXCH_XYZ_RL( smooth3D_Kvx, myThid )

C write diffusion operator to file

      WRITE(fnamegeneric,'(2A,I3.3)')
     &      smoothDir(1:IL),
     &      'smooth3Doperator', smoothOpNb
      CALL WRITE_REC_3D_RL( fnamegeneric, smoothprec,
     &                      Nr, smooth3D_Kwx, 1, 1, myThid )
      CALL WRITE_REC_3D_RL( fnamegeneric, smoothprec,
     &                      Nr, smooth3D_Kwy, 2, 1, myThid )
      CALL WRITE_REC_3D_RL( fnamegeneric, smoothprec,
     &                      Nr, smooth3D_Kwz, 3, 1, myThid )
      CALL WRITE_REC_3D_RL( fnamegeneric, smoothprec,
     &                      Nr, smooth3D_Kux, 4, 1, myThid )
      CALL WRITE_REC_3D_RL( fnamegeneric, smoothprec,
     &                      Nr, smooth3D_Kvy, 5, 1, myThid )
      CALL WRITE_REC_3D_RL( fnamegeneric, smoothprec,
     &                      Nr, smooth3D_Kuz, 6, 1, myThid )
      CALL WRITE_REC_3D_RL( fnamegeneric, smoothprec,
     &                      Nr, smooth3D_Kvz, 7, 1, myThid )
      CALL WRITE_REC_3D_RL( fnamegeneric, smoothprec,
     &                      Nr, smooth3D_Kuy, 8, 1, myThid )
      CALL WRITE_REC_3D_RL( fnamegeneric, smoothprec,
     &                      Nr, smooth3D_Kvx, 9, 1, myThid )
      CALL WRITE_REC_3D_RL( fnamegeneric, smoothprec,
     &                      Nr, smooth3D_kappaR, 10, 1, myThid )

      RETURN
      END

#include "SEAICE_OPTIONS.h"
#ifdef ALLOW_GENERIC_ADVDIFF
# include "GAD_OPTIONS.h"
#endif
#ifdef ALLOW_AUTODIFF
# include "AUTODIFF_OPTIONS.h"
#endif

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C !ROUTINE: SEAICE_ADVECTION

C !INTERFACE: ==========================================================
      SUBROUTINE SEAICE_ADVECTION(
     I     tracerIdentity,
     I     advectionSchArg,
     I     uFld, vFld, uTrans, vTrans, iceFld, r_hFld,
     O     gFld, afx, afy,
     I     bi, bj, myTime, myIter, myThid)

C !DESCRIPTION:
C Calculates the tendency of a sea-ice field due to advection.
C It uses the multi-dimensional method given in \ref{sect:multiDimAdvection}
C and can only be used for the non-linear advection schemes such as the
C direct-space-time method and flux-limiters.
C
C This routine is an adaption of the GAD_ADVECTION for 2D-fields.
C for Area, effective thickness or other "extensive" sea-ice field,
C  the contribution iceFld*div(u) (that is present in gad_advection)
C  is not included here.
C
C The algorithm is as follows:
C \begin{itemize}
C \item{$\theta^{(n+1/2)} = \theta^{(n)}
C      - \Delta t \partial_x (u\theta^{(n)}) + \theta^{(n)} \partial_x u$}
C \item{$\theta^{(n+2/2)} = \theta^{(n+1/2)}
C      - \Delta t \partial_y (v\theta^{(n+1/2)}) + \theta^{(n)} \partial_y v$}
C \item{$G_\theta = ( \theta^{(n+2/2)} - \theta^{(n)} )/\Delta t$}
C \end{itemize}
C
C The tendency (output) is over-written by this routine.

C !USES: ===============================================================
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "SEAICE_SIZE.h"
#include "SEAICE_PARAMS.h"
#include "SEAICE_GRID.h"
#include "SEAICE.h"
#ifdef ALLOW_GENERIC_ADVDIFF
# include "GAD.h"
#endif
#ifdef ALLOW_AUTODIFF
# include "AUTODIFF_PARAMS.h"
#endif /* ALLOW_AUTODIFF */
#ifdef ALLOW_AUTODIFF_TAMC
# include "tamc.h"
# ifdef ALLOW_PTRACERS
#  include "PTRACERS_SIZE.h"
# endif
#endif /* ALLOW_AUTODIFF_TAMC */
#ifdef ALLOW_EXCH2
#include "W2_EXCH2_SIZE.h"
#include "W2_EXCH2_TOPOLOGY.h"
#endif /* ALLOW_EXCH2 */
      LOGICAL extensiveFld
      PARAMETER ( extensiveFld = .TRUE. )

C !INPUT PARAMETERS: ===================================================
C  tracerIdentity  :: tracer identifier
C  advectionSchArg :: advection scheme to use (Horizontal plane)
C  extensiveFld    :: indicates to advect an "extensive" type of ice field
C  uFld            :: velocity, zonal component
C  vFld            :: velocity, meridional component
C  uTrans,vTrans   :: volume transports at U,V points
C  iceFld          :: sea-ice field
C  r_hFld          :: reciprocal of ice-thickness (only used for "intensive"
C                     type of sea-ice field)
C  bi,bj           :: tile indices
C  myTime          :: current time
C  myIter          :: iteration number
C  myThid          :: my Thread Id number
      INTEGER tracerIdentity
      INTEGER advectionSchArg
      _RL uFld  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL vFld  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL uTrans(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL vTrans(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL iceFld(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL r_hFld(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER bi,bj
      _RL myTime
      INTEGER myIter
      INTEGER myThid

C !OUTPUT PARAMETERS: ==================================================
C  gFld          :: tendency array
C  afx           :: horizontal advective flux, x direction
C  afy           :: horizontal advective flux, y direction
      _RL gFld  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL afx   (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL afy   (1-OLx:sNx+OLx,1-OLy:sNy+OLy)

#ifdef ALLOW_GENERIC_ADVDIFF
C !LOCAL VARIABLES: ====================================================
C  maskLocW      :: 2-D array for mask at West points
C  maskLocS      :: 2-D array for mask at South points
C  iMin,iMax,    :: loop range for called routines
C  jMin,jMax     :: loop range for called routines
C [iMin,iMax]Upd :: loop range to update sea-ice field
C [jMin,jMax]Upd :: loop range to update sea-ice field
C  i,j,k         :: loop indices
C advectionScheme:: local copy of routine argument advectionSchArg
C  af            :: 2-D array for horizontal advective flux
C  localTij      :: 2-D array, temporary local copy of sea-ice fld
C  calc_fluxes_X :: logical to indicate to calculate fluxes in X dir
C  calc_fluxes_Y :: logical to indicate to calculate fluxes in Y dir
C  interiorOnly  :: only update the interior of myTile, but not the edges
C  overlapOnly   :: only update the edges of myTile, but not the interior
C  nipass        :: number of passes in multi-dimensional method
C  ipass         :: number of the current pass being made
C  myTile        :: variables used to determine which cube face
C  nCFace        :: owns a tile for cube grid runs using
C                :: multi-dim advection.
C [N,S,E,W]_edge :: true if N,S,E,W edge of myTile is an Edge of the cube
C     msgBuf     :: Informational/error message buffer
      _RS maskLocW(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RS maskLocS(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER iMin,iMax,jMin,jMax
      INTEGER iMinUpd,iMaxUpd,jMinUpd,jMaxUpd
      INTEGER i,j,k
      INTEGER advectionScheme
      _RL af      (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL localTij(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      LOGICAL calc_fluxes_X, calc_fluxes_Y, withSigns
      LOGICAL interiorOnly, overlapOnly
      INTEGER nipass,ipass
      INTEGER nCFace
      LOGICAL N_edge, S_edge, E_edge, W_edge
      CHARACTER*(MAX_LEN_MBUF) msgBuf
#ifdef ALLOW_EXCH2
      INTEGER myTile
#endif
#ifdef ALLOW_DIAGNOSTICS
      CHARACTER*8 diagName
      CHARACTER*4 SEAICE_DIAG_SUFX, diagSufx
      EXTERNAL    SEAICE_DIAG_SUFX
#endif
      LOGICAL dBug
      INTEGER ioUnit
      _RL tmpFac
#ifdef ALLOW_AUTODIFF_TAMC
C     tkey :: tape key (depends on tracer and tile indices)
C     dkey :: tape key (depends on direction and tkey)
      INTEGER tkey, dkey
#endif
CEOP

C     make local copy to be tampered with if necessary
      advectionScheme = advectionSchArg
#ifdef ALLOW_AUTODIFF_TAMC
      tkey = bi + (bj-1)*nSx + (ikey_dynamics-1)*nSx*nSy
      tkey = tracerIdentity + (tkey-1)*maxpass
      IF (tracerIdentity.GT.maxpass) THEN
       WRITE(msgBuf,'(A,2I5)')
     &      'SEAICE_ADVECTION: tracerIdentity > maxpass ',
     &      tracerIdentity, maxpass
       CALL PRINT_ERROR( msgBuf, myThid )
       STOP 'ABNORMAL END: S/R SEAICE_ADVECTION'
      ENDIF
#endif /* ALLOW_AUTODIFF_TAMC */
C
#ifdef ALLOW_AUTODIFF
      IF ( inAdMode .AND. useApproxAdvectionInAdMode ) THEN
C     In AD-mode, we change non-linear, potentially unstable AD advection
C     schemes to linear schemes with more stability. So far only DST3 with
C     flux limiting is replaced by DST3 without flux limiting, but any
C     combination is possible.
       IF ( advectionSchArg.EQ.ENUM_DST3_FLUX_LIMIT )
     &      advectionScheme = ENUM_DST3
C     here is room for more advection schemes as this becomes necessary
      ENDIF
#endif /* ALLOW_AUTODIFF */

#ifdef ALLOW_DIAGNOSTICS
C--   Set diagnostic suffix for the current tracer
      IF ( useDiagnostics ) THEN
        diagSufx = SEAICE_DIAG_SUFX( tracerIdentity, myThid )
      ENDIF
#endif

      ioUnit = standardMessageUnit
      dBug = debugLevel.GE.debLevC
     &     .AND. myIter.EQ.nIter0
     &     .AND. ( tracerIdentity.EQ.GAD_HEFF .OR.
     &             tracerIdentity.EQ.GAD_QICE2 )
c    &     .AND. tracerIdentity.EQ.GAD_HEFF

C--   Set up work arrays with valid (i.e. not NaN) values
C     These inital values do not alter the numerical results. They
C     just ensure that all memory references are to valid floating
C     point numbers. This prevents spurious hardware signals due to
C     uninitialised but inert locations.
#ifdef ALLOW_AUTODIFF
      DO j=1-OLy,sNy+OLy
       DO i=1-OLx,sNx+OLx
        localTij(i,j) = 0. _d 0
       ENDDO
      ENDDO
#endif

C--   Set tile-specific parameters for horizontal fluxes
      IF (useCubedSphereExchange) THEN
       nipass=3
#ifdef ALLOW_EXCH2
       myTile = W2_myTileList(bi,bj)
       nCFace = exch2_myFace(myTile)
       N_edge = exch2_isNedge(myTile).EQ.1
       S_edge = exch2_isSedge(myTile).EQ.1
       E_edge = exch2_isEedge(myTile).EQ.1
       W_edge = exch2_isWedge(myTile).EQ.1
#else
       nCFace = bi
       N_edge = .TRUE.
       S_edge = .TRUE.
       E_edge = .TRUE.
       W_edge = .TRUE.
#endif
      ELSE
       nipass=2
       nCFace = bi
       N_edge = .FALSE.
       S_edge = .FALSE.
       E_edge = .FALSE.
       W_edge = .FALSE.
      ENDIF

      iMin = 1-OLx
      iMax = sNx+OLx
      jMin = 1-OLy
      jMax = sNy+OLy
#ifdef ALLOW_AUTODIFF_TAMC
      IF ( nipass.GT.maxcube ) THEN
         WRITE(msgBuf,'(A,2(I3,A))') 'S/R SEAICE_ADVECTION: nipass =',
     &     nipass, ' >', maxcube, ' = maxcube, ==> check "tamc.h"'
         CALL PRINT_ERROR( msgBuf, myThid )
         STOP 'ABNORMAL END: S/R SEAICE_ADVECTION'
      ENDIF
#endif /* ALLOW_AUTODIFF_TAMC */

      k = 1
C--   Start of k loop for horizontal fluxes
#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE iceFld =
CADJ &     comlev1_bibj_k_gadice, key=tkey, byte=isbyte
#endif /* ALLOW_AUTODIFF_TAMC */

C     Content of CALC_COMMON_FACTORS, adapted for 2D fields
C--   Get temporary terms used by tendency routines

C--   Make local copy of sea-ice field and mask West & South
      DO j=1-OLy,sNy+OLy
       DO i=1-OLx,sNx+OLx
         localTij(i,j)=iceFld(i,j)
#ifdef ALLOW_OBCS
         maskLocW(i,j) = SIMaskU(i,j,bi,bj)*maskInW(i,j,bi,bj)
         maskLocS(i,j) = SIMaskV(i,j,bi,bj)*maskInS(i,j,bi,bj)
#else /* ALLOW_OBCS */
         maskLocW(i,j) = SIMaskU(i,j,bi,bj)
         maskLocS(i,j) = SIMaskV(i,j,bi,bj)
#endif /* ALLOW_OBCS */
       ENDDO
      ENDDO

#ifdef ALLOW_AUTODIFF
C-     Initialise Advective flux in X & Y
       DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
         afx(i,j) = 0.
         afy(i,j) = 0.
        ENDDO
       ENDDO
#endif

cph-exch2#ifndef ALLOW_AUTODIFF_TAMC
      IF (useCubedSphereExchange) THEN
       withSigns = .FALSE.
       CALL FILL_CS_CORNER_UV_RS(
     &      withSigns, maskLocW,maskLocS, bi,bj, myThid )
      ENDIF
cph-exch2#endif

C--   Multiple passes for different directions on different tiles
C--   For cube need one pass for each of red, green and blue axes.
      DO ipass=1,nipass
#ifdef ALLOW_AUTODIFF_TAMC
       dkey = ipass + (tkey-1)*maxcube
#endif /* ALLOW_AUTODIFF_TAMC */

       interiorOnly = .FALSE.
       overlapOnly  = .FALSE.
       IF (useCubedSphereExchange) THEN
C--   CubedSphere : pass 3 times, with partial update of local seaice field
        IF (ipass.EQ.1) THEN
         overlapOnly  = MOD(nCFace,3).EQ.0
         interiorOnly = MOD(nCFace,3).NE.0
         calc_fluxes_X = nCFace.EQ.6 .OR. nCFace.EQ.1 .OR. nCFace.EQ.2
         calc_fluxes_Y = nCFace.EQ.3 .OR. nCFace.EQ.4 .OR. nCFace.EQ.5
        ELSEIF (ipass.EQ.2) THEN
         overlapOnly  = MOD(nCFace,3).EQ.2
         calc_fluxes_X = nCFace.EQ.2 .OR. nCFace.EQ.3 .OR. nCFace.EQ.4
         calc_fluxes_Y = nCFace.EQ.5 .OR. nCFace.EQ.6 .OR. nCFace.EQ.1
        ELSE
         calc_fluxes_X = nCFace.EQ.5 .OR. nCFace.EQ.6
         calc_fluxes_Y = nCFace.EQ.2 .OR. nCFace.EQ.3
        ENDIF
       ELSE
C--   not CubedSphere
        calc_fluxes_X = MOD(ipass,2).EQ.1
        calc_fluxes_Y = .NOT.calc_fluxes_X
       ENDIF
       IF (dBug.AND.bi.EQ.3 ) WRITE(ioUnit,*)'ICE_adv:',tracerIdentity,
     &   ipass,calc_fluxes_X,calc_fluxes_Y,overlapOnly,interiorOnly

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C--   X direction

#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE localTij(:,:) =
CADJ &     comlev1_bibj_k_gadice_pass, key=dkey, byte=isbyte
# ifndef DISABLE_MULTIDIM_ADVECTION
CADJ STORE af(:,:) =
CADJ &     comlev1_bibj_k_gadice_pass, key=dkey, byte=isbyte
# endif
#endif /* ALLOW_AUTODIFF_TAMC */
C
       IF (calc_fluxes_X) THEN

C-     Do not compute fluxes if
C       a) needed in overlap only
C   and b) the overlap of myTile are not cube-face Edges
        IF ( .NOT.overlapOnly .OR. N_edge .OR. S_edge ) THEN

C-     Advective flux in X
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           af(i,j) = 0.
          ENDDO
         ENDDO

cph-exch2#ifndef ALLOW_AUTODIFF_TAMC
C-     Internal exchange for calculations in X
         IF ( useCubedSphereExchange .AND.
     &      ( overlapOnly .OR. ipass.EQ.1 ) ) THEN
          CALL FILL_CS_CORNER_TR_RL( 1, .FALSE.,
     &                               localTij, bi,bj, myThid )
         ENDIF
cph-exch2#endif

#ifdef ALLOW_AUTODIFF_TAMC
# ifndef DISABLE_MULTIDIM_ADVECTION
CADJ STORE localTij(:,:)  =
CADJ &     comlev1_bibj_k_gadice_pass, key=dkey, byte=isbyte
# endif
#endif /* ALLOW_AUTODIFF_TAMC */

         IF ( advectionScheme.EQ.ENUM_UPWIND_1RST
     &        .OR. advectionScheme.EQ.ENUM_DST2 ) THEN
          CALL GAD_DST2U1_ADV_X( bi,bj,k, advectionScheme, .TRUE.,
     I         SEAICE_deltaTtherm, uTrans, uFld, localTij,
     O         af, myThid )
          IF ( dBug .AND. bi.EQ.3 ) THEN
            i=MIN(12,sNx)
            j=MIN(11,sNy)
            WRITE(ioUnit,'(A,1P4E14.6)') 'ICE_adv: xFx=', af(i+1,j),
     &        localTij(i,j), uTrans(i+1,j), af(i+1,j)/uTrans(i+1,j)
          ENDIF
         ELSEIF ( advectionScheme.EQ.ENUM_FLUX_LIMIT ) THEN
          CALL GAD_FLUXLIMIT_ADV_X( bi,bj,k, .TRUE.,
     I         SEAICE_deltaTtherm, uTrans, uFld, maskLocW, localTij,
     O         af, myThid )
         ELSEIF ( advectionScheme.EQ.ENUM_DST3 ) THEN
          CALL GAD_DST3_ADV_X(      bi,bj,k, .TRUE.,
     I         SEAICE_deltaTtherm, uTrans, uFld, maskLocW, localTij,
     O         af, myThid )
         ELSEIF ( advectionScheme.EQ.ENUM_DST3_FLUX_LIMIT ) THEN
          CALL GAD_DST3FL_ADV_X(    bi,bj,k, .TRUE.,
     I         SEAICE_deltaTtherm, uTrans, uFld, maskLocW, localTij,
     O         af, myThid )
         ELSEIF ( advectionScheme.EQ.ENUM_OS7MP ) THEN
          CALL GAD_OS7MP_ADV_X(     bi,bj,k, .TRUE.,
     I         SEAICE_deltaTtherm, uTrans, uFld, maskLocW, localTij,
     O         af, myThid )
#ifndef ALLOW_AUTODIFF
         ELSEIF ( advectionScheme.EQ.ENUM_PPM_NULL_LIMIT  .OR.
     &            advectionScheme.EQ.ENUM_PPM_MONO_LIMIT  .OR.
     &            advectionScheme.EQ.ENUM_PPM_WENO_LIMIT ) THEN
          CALL GAD_PPM_ADV_X( advectionScheme, bi, bj, k , .TRUE.,
     I         SEAICE_deltaTtherm, uFld, uTrans, localTij,
     O         af, myThid )
         ELSEIF ( advectionScheme.EQ.ENUM_PQM_NULL_LIMIT  .OR.
     &            advectionScheme.EQ.ENUM_PQM_MONO_LIMIT  .OR.
     &            advectionScheme.EQ.ENUM_PQM_WENO_LIMIT ) THEN
          CALL GAD_PQM_ADV_X( advectionScheme, bi, bj, k , .TRUE.,
     I         SEAICE_deltaTtherm, uFld, uTrans, localTij,
     O         af, myThid )
#endif
         ELSE
           WRITE(msgBuf,'(A,I3,A)')
     &      'SEAICE_ADVECTION: adv. scheme ', advectionScheme,
     &      ' incompatibale with multi-dim. adv.'
           CALL PRINT_ERROR( msgBuf, myThid )
           STOP 'ABNORMAL END: S/R SEAICE_ADVECTION'
         ENDIF

C--   Advective flux in X : done
        ENDIF

cph-exch2#ifndef ALLOW_AUTODIFF_TAMC
C--   Internal exchange for next calculations in Y
        IF ( overlapOnly .AND. ipass.EQ.1 ) THEN
         CALL FILL_CS_CORNER_TR_RL( 2, .FALSE.,
     &                              localTij, bi,bj, myThid )
        ENDIF
cph-exch2#endif

C-     Update the local seaice field where needed:

C     update in overlap-Only
        IF ( overlapOnly ) THEN
         iMinUpd = 1-OLx+1
         iMaxUpd = sNx+OLx-1
C--   notes: these 2 lines below have no real effect (because recip_hFac=0
C            in corner region) but safer to keep them.
         IF ( W_edge ) iMinUpd = 1
         IF ( E_edge ) iMaxUpd = sNx

         IF ( S_edge .AND. extensiveFld ) THEN
          DO j=1-OLy,0
           DO i=iMinUpd,iMaxUpd
            localTij(i,j)=localTij(i,j)
     &         -SEAICE_deltaTtherm*maskInC(i,j,bi,bj)
     &           *recip_rA(i,j,bi,bj)
     &           *(  af(i+1,j)-af(i,j)
     &            )
           ENDDO
          ENDDO
         ELSEIF ( S_edge ) THEN
          DO j=1-OLy,0
           DO i=iMinUpd,iMaxUpd
            localTij(i,j)=localTij(i,j)
     &         -SEAICE_deltaTtherm*maskInC(i,j,bi,bj)
     &           *recip_rA(i,j,bi,bj)*r_hFld(i,j)
     &           *( (af(i+1,j)-af(i,j))
     &             -(uTrans(i+1,j)-uTrans(i,j))*iceFld(i,j)
     &            )
           ENDDO
          ENDDO
         ENDIF
         IF ( N_edge .AND. extensiveFld ) THEN
          DO j=sNy+1,sNy+OLy
           DO i=iMinUpd,iMaxUpd
            localTij(i,j)=localTij(i,j)
     &         -SEAICE_deltaTtherm*maskInC(i,j,bi,bj)
     &           *recip_rA(i,j,bi,bj)
     &           *(  af(i+1,j)-af(i,j)
     &            )
           ENDDO
          ENDDO
         ELSEIF ( N_edge ) THEN
          DO j=sNy+1,sNy+OLy
           DO i=iMinUpd,iMaxUpd
            localTij(i,j)=localTij(i,j)
     &         -SEAICE_deltaTtherm*maskInC(i,j,bi,bj)
     &           *recip_rA(i,j,bi,bj)*r_hFld(i,j)
     &           *( (af(i+1,j)-af(i,j))
     &             -(uTrans(i+1,j)-uTrans(i,j))*iceFld(i,j)
     &            )
           ENDDO
          ENDDO
         ENDIF
C--   keep advective flux (for diagnostics)
         IF ( S_edge ) THEN
          DO j=1-OLy,0
           DO i=1-OLx+1,sNx+OLx
            afx(i,j) = af(i,j)
           ENDDO
          ENDDO
         ENDIF
         IF ( N_edge ) THEN
          DO j=sNy+1,sNy+OLy
           DO i=1-OLx+1,sNx+OLx
            afx(i,j) = af(i,j)
           ENDDO
          ENDDO
         ENDIF

        ELSE
C     do not only update the overlap
         jMinUpd = 1-OLy
         jMaxUpd = sNy+OLy
         IF ( interiorOnly .AND. S_edge ) jMinUpd = 1
         IF ( interiorOnly .AND. N_edge ) jMaxUpd = sNy
         IF ( extensiveFld ) THEN
          DO j=jMinUpd,jMaxUpd
           DO i=1-OLx+1,sNx+OLx-1
            localTij(i,j)=localTij(i,j)
     &         -SEAICE_deltaTtherm*maskInC(i,j,bi,bj)
     &           *recip_rA(i,j,bi,bj)
     &           *(  af(i+1,j)-af(i,j)
     &            )
           ENDDO
          ENDDO
         ELSE
          DO j=jMinUpd,jMaxUpd
           DO i=1-OLx+1,sNx+OLx-1
            localTij(i,j)=localTij(i,j)
     &         -SEAICE_deltaTtherm*maskInC(i,j,bi,bj)
     &           *recip_rA(i,j,bi,bj)*r_hFld(i,j)
     &           *( (af(i+1,j)-af(i,j))
     &             -(uTrans(i+1,j)-uTrans(i,j))*iceFld(i,j)
     &            )
           ENDDO
          ENDDO
         ENDIF
C--   keep advective flux (for diagnostics)
         DO j=jMinUpd,jMaxUpd
           DO i=1-OLx+1,sNx+OLx
            afx(i,j) = af(i,j)
           ENDDO
         ENDDO

C-     end if/else update overlap-Only
        ENDIF

C--   End of X direction
       ENDIF

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C--   Y direction

#ifdef ALLOW_AUTODIFF_TAMC
# ifndef DISABLE_MULTIDIM_ADVECTION
CADJ STORE localTij(:,:)  =
CADJ &     comlev1_bibj_k_gadice_pass, key=dkey, byte=isbyte
CADJ STORE af(:,:)  =
CADJ &     comlev1_bibj_k_gadice_pass, key=dkey, byte=isbyte
# endif
#endif /* ALLOW_AUTODIFF_TAMC */

       IF (calc_fluxes_Y) THEN

C-     Do not compute fluxes if
C       a) needed in overlap only
C   and b) the overlap of myTile are not cube-face edges
        IF ( .NOT.overlapOnly .OR. E_edge .OR. W_edge ) THEN

C-     Advective flux in Y
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           af(i,j) = 0.
          ENDDO
         ENDDO

cph-exch2#ifndef ALLOW_AUTODIFF_TAMC
C-     Internal exchange for calculations in Y
         IF ( useCubedSphereExchange .AND.
     &      ( overlapOnly .OR. ipass.EQ.1 ) ) THEN
          CALL FILL_CS_CORNER_TR_RL( 2, .FALSE.,
     &                               localTij, bi,bj, myThid )
         ENDIF
cph-exch2#endif

#ifdef ALLOW_AUTODIFF_TAMC
# ifndef DISABLE_MULTIDIM_ADVECTION
CADJ STORE localTij(:,:)  =
CADJ &     comlev1_bibj_k_gadice_pass, key=dkey, byte=isbyte
# endif
#endif /* ALLOW_AUTODIFF_TAMC */

         IF ( advectionScheme.EQ.ENUM_UPWIND_1RST
     &        .OR. advectionScheme.EQ.ENUM_DST2 ) THEN
          CALL GAD_DST2U1_ADV_Y( bi,bj,k, advectionScheme, .TRUE.,
     I         SEAICE_deltaTtherm, vTrans, vFld, localTij,
     O         af, myThid )
          IF ( dBug .AND. bi.EQ.3 ) THEN
            i=MIN(12,sNx)
            j=MIN(11,sNy)
            WRITE(ioUnit,'(A,1P4E14.6)') 'ICE_adv: yFx=', af(i,j+1),
     &        localTij(i,j), vTrans(i,j+1), af(i,j+1)/vTrans(i,j+1)
          ENDIF
         ELSEIF ( advectionScheme.EQ.ENUM_FLUX_LIMIT ) THEN
          CALL GAD_FLUXLIMIT_ADV_Y( bi,bj,k, .TRUE.,
     I         SEAICE_deltaTtherm, vTrans, vFld, maskLocS, localTij,
     O         af, myThid )
         ELSEIF( advectionScheme.EQ.ENUM_DST3 ) THEN
          CALL GAD_DST3_ADV_Y(      bi,bj,k, .TRUE.,
     I         SEAICE_deltaTtherm, vTrans, vFld, maskLocS, localTij,
     O         af, myThid )
         ELSEIF ( advectionScheme.EQ.ENUM_DST3_FLUX_LIMIT ) THEN
          CALL GAD_DST3FL_ADV_Y(    bi,bj,k, .TRUE.,
     I         SEAICE_deltaTtherm, vTrans, vFld, maskLocS, localTij,
     O         af, myThid )
         ELSEIF ( advectionScheme.EQ.ENUM_OS7MP ) THEN
          CALL GAD_OS7MP_ADV_Y(     bi,bj,k, .TRUE.,
     I         SEAICE_deltaTtherm, vTrans, vFld, maskLocS, localTij,
     O         af, myThid )
#ifndef ALLOW_AUTODIFF
         ELSEIF ( advectionScheme.EQ.ENUM_PPM_NULL_LIMIT  .OR.
     &            advectionScheme.EQ.ENUM_PPM_MONO_LIMIT  .OR.
     &            advectionScheme.EQ.ENUM_PPM_WENO_LIMIT ) THEN
          CALL GAD_PPM_ADV_Y( advectionScheme, bi, bj, k , .TRUE.,
     I         SEAICE_deltaTtherm, vFld, vTrans, localTij,
     O         af, myThid )
         ELSEIF ( advectionScheme.EQ.ENUM_PQM_NULL_LIMIT  .OR.
     &            advectionScheme.EQ.ENUM_PQM_MONO_LIMIT  .OR.
     &            advectionScheme.EQ.ENUM_PQM_WENO_LIMIT ) THEN
          CALL GAD_PQM_ADV_Y( advectionScheme, bi, bj, k , .TRUE.,
     I         SEAICE_deltaTtherm, vFld, vTrans, localTij,
     O         af, myThid )
#endif
         ELSE
           WRITE(msgBuf,'(A,I3,A)')
     &      'SEAICE_ADVECTION: adv. scheme ', advectionScheme,
     &      ' incompatibale with multi-dim. adv.'
           CALL PRINT_ERROR( msgBuf, myThid )
           STOP 'ABNORMAL END: S/R SEAICE_ADVECTION'
         ENDIF

C-     Advective flux in Y : done
        ENDIF

cph-exch2#ifndef ALLOW_AUTODIFF_TAMC
C-     Internal exchange for next calculations in X
        IF ( overlapOnly .AND. ipass.EQ.1 ) THEN
         CALL FILL_CS_CORNER_TR_RL( 1, .FALSE.,
     &                              localTij, bi,bj, myThid )
        ENDIF
cph-exch2#endif

C-     Update the local seaice field where needed:

C      update in overlap-Only
        IF ( overlapOnly ) THEN
         jMinUpd = 1-OLy+1
         jMaxUpd = sNy+OLy-1
C- notes: these 2 lines below have no real effect (because recip_hFac=0
C         in corner region) but safer to keep them.
         IF ( S_edge ) jMinUpd = 1
         IF ( N_edge ) jMaxUpd = sNy

         IF ( W_edge .AND. extensiveFld ) THEN
          DO j=jMinUpd,jMaxUpd
           DO i=1-OLx,0
            localTij(i,j)=localTij(i,j)
     &         -SEAICE_deltaTtherm*maskInC(i,j,bi,bj)
     &           *recip_rA(i,j,bi,bj)
     &           *(  af(i,j+1)-af(i,j)
     &            )
           ENDDO
          ENDDO
         ELSEIF ( W_edge ) THEN
          DO j=jMinUpd,jMaxUpd
           DO i=1-OLx,0
            localTij(i,j)=localTij(i,j)
     &         -SEAICE_deltaTtherm*maskInC(i,j,bi,bj)
     &           *recip_rA(i,j,bi,bj)*r_hFld(i,j)
     &           *( (af(i,j+1)-af(i,j))
     &             -(vTrans(i,j+1)-vTrans(i,j))*iceFld(i,j)
     &            )
           ENDDO
          ENDDO
         ENDIF
         IF ( E_edge .AND. extensiveFld ) THEN
          DO j=jMinUpd,jMaxUpd
           DO i=sNx+1,sNx+OLx
            localTij(i,j)=localTij(i,j)
     &         -SEAICE_deltaTtherm*maskInC(i,j,bi,bj)
     &           *recip_rA(i,j,bi,bj)
     &           *(  af(i,j+1)-af(i,j)
     &            )
           ENDDO
          ENDDO
         ELSEIF ( E_edge ) THEN
          DO j=jMinUpd,jMaxUpd
           DO i=sNx+1,sNx+OLx
            localTij(i,j)=localTij(i,j)
     &         -SEAICE_deltaTtherm*maskInC(i,j,bi,bj)
     &           *recip_rA(i,j,bi,bj)*r_hFld(i,j)
     &           *( (af(i,j+1)-af(i,j))
     &             -(vTrans(i,j+1)-vTrans(i,j))*iceFld(i,j)
     &            )
           ENDDO
          ENDDO
         ENDIF
C--   keep advective flux (for diagnostics)
         IF ( W_edge ) THEN
          DO j=1-OLy+1,sNy+OLy
           DO i=1-OLx,0
            afy(i,j) = af(i,j)
           ENDDO
          ENDDO
         ENDIF
         IF ( E_edge ) THEN
          DO j=1-OLy+1,sNy+OLy
           DO i=sNx+1,sNx+OLx
            afy(i,j) = af(i,j)
           ENDDO
          ENDDO
         ENDIF

        ELSE
C     do not only update the overlap
         iMinUpd = 1-OLx
         iMaxUpd = sNx+OLx
         IF ( interiorOnly .AND. W_edge ) iMinUpd = 1
         IF ( interiorOnly .AND. E_edge ) iMaxUpd = sNx
         IF ( extensiveFld ) THEN
          DO j=1-OLy+1,sNy+OLy-1
           DO i=iMinUpd,iMaxUpd
            localTij(i,j)=localTij(i,j)
     &         -SEAICE_deltaTtherm*maskInC(i,j,bi,bj)
     &           *recip_rA(i,j,bi,bj)
     &           *(  af(i,j+1)-af(i,j)
     &            )
           ENDDO
          ENDDO
         ELSE
          DO j=1-OLy+1,sNy+OLy-1
           DO i=iMinUpd,iMaxUpd
            localTij(i,j)=localTij(i,j)
     &         -SEAICE_deltaTtherm*maskInC(i,j,bi,bj)
     &           *recip_rA(i,j,bi,bj)*r_hFld(i,j)
     &           *( (af(i,j+1)-af(i,j))
     &             -(vTrans(i,j+1)-vTrans(i,j))*iceFld(i,j)
     &            )
           ENDDO
          ENDDO
         ENDIF
C--   keep advective flux (for diagnostics)
         DO j=1-OLy+1,sNy+OLy
           DO i=iMinUpd,iMaxUpd
            afy(i,j) = af(i,j)
           ENDDO
         ENDDO

C      end if/else update overlap-Only
        ENDIF

C--   End of Y direction
       ENDIF

C--   End of ipass loop
      ENDDO

C-    explicit advection is done ; store tendency in gFld:
      DO j=1-OLy,sNy+OLy
       DO i=1-OLx,sNx+OLx
        gFld(i,j)=(localTij(i,j)-iceFld(i,j))/SEAICE_deltaTtherm
       ENDDO
      ENDDO
      IF ( dBug .AND. bi.EQ.3 ) THEN
       i=MIN(12,sNx)
       j=MIN(11,sNy)
       tmpFac= SEAICE_deltaTtherm*recip_rA(i,j,bi,bj)
       WRITE(ioUnit,'(A,1P4E14.6)') 'ICE_adv:',
     &      afx(i,j)*tmpFac,afx(i+1,j)*tmpFac,
     &      afy(i,j)*tmpFac,afy(i,j+1)*tmpFac
      ENDIF

#ifdef ALLOW_DIAGNOSTICS
        IF ( useDiagnostics ) THEN
         diagName = 'ADVx'//diagSufx
         CALL DIAGNOSTICS_FILL(afx,diagName, k,1, 2,bi,bj, myThid)
         diagName = 'ADVy'//diagSufx
         CALL DIAGNOSTICS_FILL(afy,diagName, k,1, 2,bi,bj, myThid)
        ENDIF
#endif

#ifdef ALLOW_DEBUG
      IF ( debugLevel .GE. debLevC
     &     .AND. tracerIdentity.EQ.GAD_HEFF
     &     .AND. k.LE.3 .AND. myIter.EQ.1+nIter0
     &     .AND. nPx.EQ.1 .AND. nPy.EQ.1
     &     .AND. useCubedSphereExchange ) THEN
       CALL DEBUG_CS_CORNER_UV( ' afx,afy from SEAICE_ADVECTION',
     &      afx,afy, k, standardMessageUnit,bi,bj,myThid )
      ENDIF
#endif /* ALLOW_DEBUG */

#endif /* ALLOW_GENERIC_ADVDIFF */
      RETURN
      END

#include "PACKAGES_CONFIG.h"
#include "CPP_OPTIONS.h"
#ifdef TARGET_NEC_SX
C     make sure that the factorized EOS is used on NEC vector computers
# define USE_FACTORIZED_EOS
#endif
C     this was the default, so we keep it that way
#define USE_FACTORIZED_POLY

C--  File find_rho.F: Routines to compute density
C--   Contents
C--   o FIND_RHO_2D
C--   o FIND_RHOP0
C--   o FIND_BULKMOD
C--   o FIND_RHONUM
C--   o FIND_RHODEN
C--   o FIND_RHOTEOS
C--   o FIND_RHO_SCALAR: in-situ density for individual points
C--   o LOOK_FOR_NEG_SALINITY

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: FIND_RHO_2D
C     !INTERFACE:
      SUBROUTINE FIND_RHO_2D(
     I                iMin, iMax, jMin, jMax, kRef,
     I                tFld, sFld,
     O                rhoLoc,
     I                k, bi, bj, myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | o SUBROUTINE FIND_RHO_2D
C     |   Calculates [rho(S,T,z)-rhoConst] of a 2-D slice
C     *==========================================================*
C     | kRef - determines pressure reference level
C     |        (not used in 'LINEAR' mode)
C     | Note:  k is not used ; keep it for debugging.
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "EOS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     k    :: Level of Theta/Salt slice
C     kRef :: Pressure reference level
      INTEGER iMin,iMax,jMin,jMax
      INTEGER kRef
      _RL tFld  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL sFld  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL rhoLoc(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER k, bi, bj
      INTEGER myThid

C     !LOCAL VARIABLES:
C     == Local variables ==
      INTEGER i,j
      _RL refTemp, refSalt, sigRef, tP, sP, deltaSig, dRho
      _RL dp0, oneMinusKap, facPres, theta_v
      _RL locPres(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL rhoP0  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL bulkMod(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL rhoNum (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL rhoDen (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      CHARACTER*(MAX_LEN_MBUF) msgBuf
CEOP

#ifdef ALLOW_AUTODIFF
      DO j=1-OLy,sNy+OLy
       DO i=1-OLx,sNx+OLx
        rhoLoc(i,j)  = 0. _d 0
        rhoP0(i,j)   = 0. _d 0
        bulkMod(i,j) = 0. _d 0
       ENDDO
      ENDDO
#endif

#ifdef CHECK_SALINITY_FOR_NEGATIVE_VALUES
      CALL LOOK_FOR_NEG_SALINITY(
     I          iMin, iMax, jMin, jMax,
     U          sFld,
     I          k, bi, bj, myThid )
#endif

      IF (equationOfState.EQ.'LINEAR') THEN

C ***NOTE***
C In the linear EOS, to make the static stability calculation meaningful
C we use reference temp & salt from level kRef ;
C **********
       refTemp=tRef(kRef)
       refSalt=sRef(kRef)

       dRho = rhoNil-rhoConst

       DO j=jMin,jMax
        DO i=iMin,iMax
         rhoLoc(i,j)=rhoNil*(
     &     sBeta*(sFld(i,j)-refSalt)
     &   -tAlpha*(tFld(i,j)-refTemp) )
     &        + dRho
        ENDDO
       ENDDO

      ELSEIF (equationOfState.EQ.'POLY3') THEN

       refTemp=eosRefT(kRef)
       refSalt=eosRefS(kRef)
       sigRef=eosSig0(kRef) + (1000.-rhoConst)

       DO j=jMin,jMax
        DO i=iMin,iMax
         tP=tFld(i,j)-refTemp
         sP=sFld(i,j)-refSalt
#ifdef USE_FACTORIZED_POLY
         deltaSig=
     &    (( eosC(9,kRef)*sP + eosC(5,kRef) )*sP + eosC(2,kRef) )*sP
     &   + ( ( eosC(6,kRef)
     &         *tP
     &        +eosC(7,kRef)*sP + eosC(3,kRef)
     &       )*tP
     &      +(eosC(8,kRef)*sP + eosC(4,kRef) )*sP + eosC(1,kRef)
     &     )*tP
#else
         deltaSig=
     &     eosC(1,kRef)*tP
     &    +eosC(2,kRef)         *sP
     &    +eosC(3,kRef)*tP*tP
     &    +eosC(4,kRef)*tP      *sP
     &    +eosC(5,kRef)         *sP*sP
     &    +eosC(6,kRef)*tP*tP*tP
     &    +eosC(7,kRef)*tP*tP   *sP
     &    +eosC(8,kRef)*tP      *sP*sP
     &    +eosC(9,kRef)         *sP*sP*sP
#endif
         rhoLoc(i,j)=sigRef+deltaSig
        ENDDO
       ENDDO

      ELSEIF ( equationOfState(1:5).EQ.'JMD95'
     &      .OR. equationOfState.EQ.'UNESCO' ) THEN
C     nonlinear equation of state in pressure coordinates
         dp0 = surf_pRef - eosRefP0

         CALL PRESSURE_FOR_EOS(
     I             bi, bj, iMin, iMax, jMin, jMax, kRef, dp0,
     O             locPres,
     I             myThid )

         CALL FIND_RHOP0(
     I             iMin, iMax, jMin, jMax,
     I             tFld, sFld,
     O             rhoP0,
     I             myThid )

         CALL FIND_BULKMOD(
     I             iMin, iMax, jMin, jMax,
     I             locPres, tFld, sFld,
     O             bulkMod,
     I             myThid )

c#ifdef ALLOW_AUTODIFF_TAMC
cph can not DO storing here since find_rho is called multiple times;
cph additional recomp. should be acceptable
c#endif /* ALLOW_AUTODIFF_TAMC */
         DO j=jMin,jMax
          DO i=iMin,iMax

C     density of sea water at pressure p
            rhoLoc(i,j) = rhoP0(i,j)
     &              /(1. _d 0 -
     &              locPres(i,j)*SItoBar/bulkMod(i,j) )
     &              - rhoConst

          ENDDO
         ENDDO

      ELSEIF ( equationOfState.EQ.'MDJWF' ) THEN
         dp0 = surf_pRef - eosRefP0

         CALL PRESSURE_FOR_EOS(
     I             bi, bj, iMin, iMax, jMin, jMax, kRef, dp0,
     O             locPres,
     I             myThid )

         CALL FIND_RHONUM(
     I             iMin, iMax, jMin, jMax,
     I             locPres, tFld, sFld,
     O             rhoNum,
     I             myThid )

         CALL FIND_RHODEN(
     I             iMin, iMax, jMin, jMax,
     I             locPres, tFld, sFld,
     O             rhoDen,
     I             myThid )

c#ifdef ALLOW_AUTODIFF_TAMC
cph can not DO storing here since find_rho is called multiple times;
cph additional recomp. should be acceptable
c#endif /* ALLOW_AUTODIFF_TAMC */
         DO j=jMin,jMax
          DO i=iMin,iMax
            rhoLoc(i,j) = rhoNum(i,j)*rhoDen(i,j) - rhoConst
          ENDDO
         ENDDO

      ELSEIF ( equationOfState.EQ.'TEOS10' ) THEN
         dp0 = surf_pRef - eosRefP0

         CALL PRESSURE_FOR_EOS(
     I             bi, bj, iMin, iMax, jMin, jMax, kRef, dp0,
     O             locPres,
     I             myThid )

         CALL FIND_RHOTEOS(
     I             iMin, iMax, jMin, jMax,
     I             locPres, tFld, sFld,
     O             rhoNum, rhoDen,
     I             myThid )

c#ifdef ALLOW_AUTODIFF_TAMC
cph can not DO storing here since find_rho is called multiple times;
cph additional recomp. should be acceptable
c#endif /* ALLOW_AUTODIFF_TAMC */
         DO j=jMin,jMax
          DO i=iMin,iMax
            rhoLoc(i,j) = rhoNum(i,j)*rhoDen(i,j) - rhoConst
          ENDDO
         ENDDO

      ELSEIF( equationOfState .EQ. 'IDEALG' ) THEN

         CALL PRESSURE_FOR_EOS(
     I             bi, bj, iMin, iMax, jMin, jMax, kRef, zeroRL,
     O             locPres,
     I             myThid )

         oneMinusKap = oneRL - atm_kappa
C        rho = P/(R*T_v) = Po/(R*theta_v)*(P/Po)^(1-kappa)
         DO j=jMin,jMax
          DO i=iMin,iMax
           IF ( locPres(i,j).GT.zeroRL .AND. tFld(i,j).GT.zeroRL ) THEN
            facPres = ( locPres(i,j)/atm_Po )**oneMinusKap
            theta_v = tFld(i,j)*( sFld(i,j)*atm_Rq + oneRL )
            rhoLoc(i,j) = atm_Po*facPres
     &                 /( atm_Rd*theta_v ) - rhoConst
           ELSE
            rhoLoc(i,j) = zeroRL
           ENDIF
          ENDDO
         ENDDO

      ELSE
       WRITE(msgBuf,'(3a)')
     &      ' FIND_RHO_2D: equationOfState = "',equationOfState,'"'
       CALL PRINT_ERROR( msgBuf, myThid )
       STOP 'ABNORMAL END: S/R FIND_RHO_2D'
      ENDIF

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: FIND_RHOP0
C     !INTERFACE:
      SUBROUTINE FIND_RHOP0(
     I                iMin, iMax, jMin, jMax,
     I                tFld, sFld,
     O                rhoP0,
     I                myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | o SUBROUTINE FIND_RHOP0
C     |   Calculates rho(S,T,0) of a slice
C     *==========================================================*
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "EOS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
      INTEGER iMin,iMax,jMin,jMax
      _RL tFld (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL sFld (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL rhoP0(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER myThid

C     !LOCAL VARIABLES:
C     == Local variables ==
      INTEGER i,j
      _RL rfresh, rsalt
      _RL t, t2, t3, t4, s, s3o2
#ifdef USE_FACTORIZED_EOS
      _RL eosF1, eosF2, eosF3, eosF4, eosF5, eosF6
      _RL eosS1, eosS2, eosS3, eosS4, eosS5, eosS6
      _RL eosS7, eosS8, eosS9
#endif /* USE_FACTORIZED_EOS */
CEOP
#ifdef USE_FACTORIZED_EOS
      eosF1 = eosJMDCFw(1)
      eosF2 = eosJMDCFw(2)
      eosF3 = eosJMDCFw(3)
      eosF4 = eosJMDCFw(4)
      eosF5 = eosJMDCFw(5)
      eosF6 = eosJMDCFw(6)
      eosS1 = eosJMDCSw(1)
      eosS2 = eosJMDCSw(2)
      eosS3 = eosJMDCSw(3)
      eosS4 = eosJMDCSw(4)
      eosS5 = eosJMDCSw(5)
      eosS6 = eosJMDCSw(6)
      eosS7 = eosJMDCSw(7)
      eosS8 = eosJMDCSw(8)
      eosS9 = eosJMDCSw(9)
#endif /* USE_FACTORIZED_EOS */

      DO j=jMin,jMax
         DO i=iMin,iMax
C     abbreviations
            t  = tFld(i,j)
            t2 = t*t
            t3 = t2*t
            t4 = t3*t

#if (defined ALLOW_AUTODIFF && defined TARGET_NEC_SX)
C     this line makes TAF create vectorizable code
            s3o2 = 0. _d 0
#endif
            s  = sFld(i,j)
           IF ( s .GT. 0. _d 0 ) THEN
            s3o2 = s*SQRT(s)
           ELSE
            s    = 0. _d 0
            s3o2 = 0. _d 0
           ENDIF

C     density of freshwater at the surface
#ifdef USE_FACTORIZED_EOS
            rfresh =
     &                    eosF1 +
     &               t* ( eosF2 +
     &               t* ( eosF3 +
     &               t* ( eosF4 +
     &               t* ( eosF5 +
     &               t*   eosF6  ))))
#else
            rfresh =
     &             eosJMDCFw(1)
     &           + eosJMDCFw(2)*t
     &           + eosJMDCFw(3)*t2
     &           + eosJMDCFw(4)*t3
     &           + eosJMDCFw(5)*t4
     &           + eosJMDCFw(6)*t4*t
#endif /* USE_FACTORIZED_EOS */
C     density of sea water at the surface
#ifdef USE_FACTORIZED_EOS
            rsalt =  s * ( eosS1 +
     &               t * ( eosS2 +
     &               t * ( eosS3 +
     &               t * ( eosS4 +
     &               t *   eosS5  ))))
     &          + s3o2 * ( eosS6 +
     &               t * ( eosS7 +
     &               t *   eosS8  ))
     &          + s*s  *   eosS9
#else
            rsalt =
     &         s*(
     &             eosJMDCSw(1)
     &           + eosJMDCSw(2)*t
     &           + eosJMDCSw(3)*t2
     &           + eosJMDCSw(4)*t3
     &           + eosJMDCSw(5)*t4
     &           )
     &       + s3o2*(
     &             eosJMDCSw(6)
     &           + eosJMDCSw(7)*t
     &           + eosJMDCSw(8)*t2
     &           )
     &           + eosJMDCSw(9)*s*s
#endif /* USE_FACTORIZED_EOS */

            rhoP0(i,j) = rfresh + rsalt

         ENDDO
      ENDDO

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: FIND_BULKMOD
C     !INTERFACE:
      SUBROUTINE FIND_BULKMOD(
     I                iMin, iMax, jMin, jMax,
     I                locPres, tFld, sFld,
     O                bulkMod,
     I                myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | o SUBROUTINE FIND_BULKMOD
C     |   Calculates the secant bulk modulus K(S,T,p) of a slice
C     *==========================================================*
C     | k    - is the level of Theta/Salt slice
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "EOS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
      INTEGER iMin,iMax,jMin,jMax
      _RL locPres(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL tFld   (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL sFld   (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL bulkMod(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER myThid

C     !LOCAL VARIABLES:
C     == Local variables ==
      INTEGER i,j
      _RL bMfresh, bMsalt, bMpres
      _RL t, t2, t3, t4, s, s3o2, p, p2
#ifdef USE_FACTORIZED_EOS
      _RL eosF1, eosF2, eosF3, eosF4, eosF5
      _RL eosS1, eosS2, eosS3, eosS4, eosS5, eosS6, eosS7
      _RL eosP1, eosP2, eosP3, eosP4, eosP5, eosP6, eosP7
      _RL eosP8, eosP9, eosP10, eosP11, eosP12, eosP13, eosP14
#endif /* USE_FACTORIZED_EOS */
CEOP
#ifdef USE_FACTORIZED_EOS
      eosF1 = eosJMDCKFw(1)
      eosF2 = eosJMDCKFw(2)
      eosF3 = eosJMDCKFw(3)
      eosF4 = eosJMDCKFw(4)
      eosF5 = eosJMDCKFw(5)

      eosS1 = eosJMDCKSw(1)
      eosS2 = eosJMDCKSw(2)
      eosS3 = eosJMDCKSw(3)
      eosS4 = eosJMDCKSw(4)
      eosS5 = eosJMDCKSw(5)
      eosS6 = eosJMDCKSw(6)
      eosS7 = eosJMDCKSw(7)

      eosP1  =eosJMDCKP(1)
      eosP2  =eosJMDCKP(2)
      eosP3  =eosJMDCKP(3)
      eosP4  =eosJMDCKP(4)
      eosP5  =eosJMDCKP(5)
      eosP6  =eosJMDCKP(6)
      eosP7  =eosJMDCKP(7)
      eosP8  =eosJMDCKP(8)
      eosP9  =eosJMDCKP(9)
      eosP10 =eosJMDCKP(10)
      eosP11 =eosJMDCKP(11)
      eosP12 =eosJMDCKP(12)
      eosP13 =eosJMDCKP(13)
      eosP14 =eosJMDCKP(14)
#endif /* USE_FACTORIZED_EOS */

      DO j=jMin,jMax
         DO i=iMin,iMax
C     abbreviations
            t  = tFld(i,j)
            t2 = t*t
            t3 = t2*t
            t4 = t3*t

#if (defined ALLOW_AUTODIFF && defined TARGET_NEC_SX)
C     this line makes TAF create vectorizable code
            s3o2 = 0. _d 0
#endif
            s  = sFld(i,j)
          IF ( s .GT. 0. _d 0 ) THEN
            s3o2 = s*SQRT(s)
          ELSE
            s    = 0. _d 0
            s3o2 = 0. _d 0
          ENDIF
C
            p = locPres(i,j)*SItoBar
            p2 = p*p
C     secant bulk modulus of fresh water at the surface
#ifdef USE_FACTORIZED_EOS
            bMfresh =       eosF1 +
     &                t * ( eosF2 +
     &                t * ( eosF3 +
     &                t * ( eosF4 +
     &                t *   eosF5  )))
#else
            bMfresh =
     &             eosJMDCKFw(1)
     &           + eosJMDCKFw(2)*t
     &           + eosJMDCKFw(3)*t2
     &           + eosJMDCKFw(4)*t3
     &           + eosJMDCKFw(5)*t4
#endif /* USE_FACTORIZED_EOS */
C     secant bulk modulus of sea water at the surface
#ifdef USE_FACTORIZED_EOS
            bMsalt =  s * ( eosS1 +
     &                t * ( eosS2 +
     &                t * ( eosS3 +
     &                t *   eosS4  )))
     &            + s3o2* ( eosS5 +
     &                t * ( eosS6 +
     &                t *   eosS7  ))
C     secant bulk modulus of sea water at pressure p
            bMpres =  p * ( eosP1 +
     &                t * ( eosP2 +
     &                t * ( eosP3 +
     &                t *   eosP4  )))
     &             + p*s* ( eosP5 +
     &                t * ( eosP6 +
     &                t *   eosP7  ))
     &             + p*s3o2*eosP8
     &             + p2 * ( eosP9 +
     &                t * ( eosP10 +
     &                t *   eosP11  ))
     &            + p2*s* ( eosP12 +
     &                t * ( eosP13 +
     &                t *   eosP14 ))
#else
C     secant bulk modulus of sea water at the surface
            bMsalt =
     &         s*( eosJMDCKSw(1)
     &           + eosJMDCKSw(2)*t
     &           + eosJMDCKSw(3)*t2
     &           + eosJMDCKSw(4)*t3
     &           )
     &    + s3o2*( eosJMDCKSw(5)
     &           + eosJMDCKSw(6)*t
     &           + eosJMDCKSw(7)*t2
     &           )
C     secant bulk modulus of sea water at pressure p
            bMpres =
     &         p*( eosJMDCKP(1)
     &           + eosJMDCKP(2)*t
     &           + eosJMDCKP(3)*t2
     &           + eosJMDCKP(4)*t3
     &           )
     &     + p*s*( eosJMDCKP(5)
     &           + eosJMDCKP(6)*t
     &           + eosJMDCKP(7)*t2
     &           )
     &      + p*s3o2*eosJMDCKP(8)
     &      + p2*( eosJMDCKP(9)
     &           + eosJMDCKP(10)*t
     &           + eosJMDCKP(11)*t2
     &           )
     &    + p2*s*( eosJMDCKP(12)
     &           + eosJMDCKP(13)*t
     &           + eosJMDCKP(14)*t2
     &           )
#endif /* USE_FACTORIZED_EOS */

            bulkMod(i,j) = bMfresh + bMsalt + bMpres

         ENDDO
      ENDDO

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: FIND_RHONUM
C     !INTERFACE:
      SUBROUTINE FIND_RHONUM(
     I                iMin, iMax, jMin, jMax,
     I                locPres, tFld, sFld,
     O                rhoNum,
     I                myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | o SUBROUTINE FIND_RHONUM
C     |   Calculates the numerator of the McDougall et al.
C     |   equation of state
C     |   - the code is more or less a copy of MOM4
C     *==========================================================*
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "EOS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
      INTEGER iMin,iMax,jMin,jMax
      _RL locPres(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL tFld   (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL sFld   (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL rhoNum (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER myThid

C     !LOCAL VARIABLES:
C     == Local variables ==
      INTEGER i,j
      _RL t1, t2, s1, p1
CEOP
      DO j=jMin,jMax
         DO i=iMin,iMax
C     abbreviations
            t1  = tFld(i,j)
            t2 = t1*t1
            s1  = sFld(i,j)

            p1   = locPres(i,j)*SItodBar

            rhoNum(i,j) = eosMDJWFnum(0)
     &           + t1*(eosMDJWFnum(1)
     &           +     t1*(eosMDJWFnum(2) + eosMDJWFnum(3)*t1) )
     &           + s1*(eosMDJWFnum(4)
     &           +     eosMDJWFnum(5)*t1  + eosMDJWFnum(6)*s1)
     &           + p1*(eosMDJWFnum(7) + eosMDJWFnum(8)*t2
     &           +     eosMDJWFnum(9)*s1
     &           +     p1*(eosMDJWFnum(10) + eosMDJWFnum(11)*t2) )

         ENDDO
      ENDDO

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: FIND_RHODEN
C     !INTERFACE:
      SUBROUTINE FIND_RHODEN(
     I                iMin, iMax, jMin, jMax,
     I                locPres, tFld, sFld,
     O                rhoDen,
     I                myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | o SUBROUTINE FIND_RHODEN
C     |   Calculates the denominator of the McDougall et al.
C     |   equation of state
C     |   - the code is more or less a copy of MOM4
C     *==========================================================*
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "EOS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
      INTEGER iMin,iMax,jMin,jMax
      _RL locPres(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL tFld   (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL sFld   (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL rhoDen (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER myThid

C     !LOCAL VARIABLES:
C     == Local variables ==
      INTEGER i,j
      _RL t1, t2, s1, sp5, p1, p1t1
      _RL den, epsln
      parameter ( epsln = 0. _d 0 )
CEOP
      DO j=jMin,jMax
         DO i=iMin,iMax
C     abbreviations
            t1  = tFld(i,j)
            t2 = t1*t1
            s1  = sFld(i,j)
#if (defined ALLOW_AUTODIFF && defined TARGET_NEC_SX)
C     this line makes TAF create vectorizable code
            sp5 = 0. _d 0
#endif
           IF ( s1 .GT. 0. _d 0 ) THEN
            sp5 = SQRT(s1)
           ELSE
            s1  = 0. _d 0
            sp5 = 0. _d 0
           ENDIF

            p1   = locPres(i,j)*SItodBar
            p1t1 = p1*t1

            den = eosMDJWFden(0)
     &           + t1*(eosMDJWFden(1)
     &           +     t1*(eosMDJWFden(2)
     &           +         t1*(eosMDJWFden(3) + t1*eosMDJWFden(4) ) ) )
     &           + s1*(eosMDJWFden(5)
     &           +     t1*(eosMDJWFden(6)
     &           +         eosMDJWFden(7)*t2)
     &           +     sp5*(eosMDJWFden(8) + eosMDJWFden(9)*t2) )
     &           + p1*(eosMDJWFden(10)
     &           +     p1t1*(eosMDJWFden(11)*t2 + eosMDJWFden(12)*p1) )

            rhoDen(i,j) = 1.0/(epsln+den)

         ENDDO
      ENDDO

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: FIND_RHOTEOS
C     !INTERFACE:
      SUBROUTINE FIND_RHOTEOS(
     I                iMin, iMax, jMin, jMax,
     I                locPres, tFld, sFld,
     O                rhoNum, rhoDen,
     I                myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | o SUBROUTINE FIND_RHOTEOS
C     |   Calculates numerator and inverse of denominator of the
C     |   TEOS-10 (McDougall et al. 2011) equation of state
C     |   - the code is more or less a copy the teos-10 toolbox
C     |     available at http://www.teos-10.org
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "EOS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
      INTEGER iMin,iMax,jMin,jMax
      _RL locPres(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL tFld   (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL sFld   (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL rhoNum (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL rhoDen (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER myThid

C     !LOCAL VARIABLES:
C     == Local variables ==
      INTEGER i,j
      _RL ct, sa, sqrtsa, p
      _RL den, epsln
      parameter ( epsln = 0. _d 0 )
CEOP
      DO j=jMin,jMax
       DO i=iMin,iMax
C     abbreviations
        ct      = tFld(i,j)
        sa      = sFld(i,j)
#if (defined ALLOW_AUTODIFF && defined TARGET_NEC_SX)
C     this line makes TAF create vectorizable code
        sqrtsa = 0. _d 0
#endif
        IF ( sa .GT. 0. _d 0 ) THEN
         sqrtsa = SQRT(sa)
        ELSE
         sa     = 0. _d 0
         sqrtsa = 0. _d 0
        ENDIF
        p       = locPres(i,j)*SItodBar

        rhoNum(i,j) = teos(01)
     &   + ct*(teos(02) + ct*(teos(03) + teos(04)*ct))
     &   + sa*(teos(05) + ct*(teos(06) + teos(07)*ct)
     &   + sqrtsa*(teos(08) + ct*(teos(09)
     &                      + ct*(teos(10) + teos(11)*ct))))
     &   + p*(teos(12) + ct*(teos(13) + teos(14)*ct)
     &                 + sa*(teos(15) + teos(16)*ct)
     &   + p*(teos(17) + ct*(teos(18) + teos(19)*ct) + teos(20)*sa))

        den = teos(21)
     &   + ct*(teos(22) + ct*(teos(23) + ct*(teos(24) + teos(25)*ct)))
     &   + sa*(teos(26) + ct*(teos(27) + ct*(teos(28)
     &   + ct*(teos(29) + teos(30)*ct)))
     &   + teos(36)*sa
     &   + sqrtsa*(teos(31) + ct*(teos(32) + ct*(teos(33)
     &            + ct*(teos(34) + teos(35)*ct)))))
     &   + p*(teos(37) + ct*(teos(38) + ct*(teos(39) + teos(40)*ct))
     &   + sa*(teos(41) + teos(42)*ct)
     &   + p*(teos(43) + ct*(teos(44) + teos(45)*ct + teos(46)*sa)
     &   + p*(teos(47) + teos(48)*ct)))

        rhoDen(i,j) = 1.0/(epsln+den)

       ENDDO
      ENDDO

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: FIND_RHO_SCALAR
C     !INTERFACE:
      SUBROUTINE FIND_RHO_SCALAR(
     I     tLoc, sLoc, pLoc,
     O     rhoLoc,
     I     myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | o SUBROUTINE FIND_RHO_SCALAR
C     |   Calculates rho(S,T,p)
C     | Note: for seawater EOS, p is pressure (Pa) relative to
C     |   reference surface pressure "surf_pRef"
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "EOS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
      _RL tLoc, sLoc, pLoc
      _RL rhoLoc
      INTEGER myThid

C     !LOCAL VARIABLES:
C     == Local variables ==
      _RL t1, t2, t3, t4, s1, s3o2, p1, p2, sp5, p1t1
      _RL dp0, ct, sa, sqrtsa, p
      _RL rfresh, rsalt, rhoP0
      _RL bMfresh, bMsalt, bMpres, BulkMod
      _RL rhoNum, rhoDen, den, epsln
      _RL oneMinusKap, facPres, theta_v
      PARAMETER ( epsln = 0. _d 0 )
      CHARACTER*(MAX_LEN_MBUF) msgBuf
#ifdef USE_FACTORIZED_EOS
      _RL eosF1, eosF2, eosF3, eosF4, eosF5, eosF6
      _RL eosS1, eosS2, eosS3, eosS4, eosS5, eosS6
      _RL eosS7, eosS8, eosS9
      _RL eosP1, eosP2, eosP3, eosP4, eosP5, eosP6, eosP7
      _RL eosP8, eosP9, eosP10, eosP11, eosP12, eosP13, eosP14
#endif /* USE_FACTORIZED_EOS */
CEOP
#ifdef USE_FACTORIZED_EOS
      eosF1 = eosJMDCFw(1)
      eosF2 = eosJMDCFw(2)
      eosF3 = eosJMDCFw(3)
      eosF4 = eosJMDCFw(4)
      eosF5 = eosJMDCFw(5)
      eosF6 = eosJMDCFw(6)
      eosS1 = eosJMDCSw(1)
      eosS2 = eosJMDCSw(2)
      eosS3 = eosJMDCSw(3)
      eosS4 = eosJMDCSw(4)
      eosS5 = eosJMDCSw(5)
      eosS6 = eosJMDCSw(6)
      eosS7 = eosJMDCSw(7)
      eosS8 = eosJMDCSw(8)
      eosS9 = eosJMDCSw(9)

      eosP1  =eosJMDCKP(1)
      eosP2  =eosJMDCKP(2)
      eosP3  =eosJMDCKP(3)
      eosP4  =eosJMDCKP(4)
      eosP5  =eosJMDCKP(5)
      eosP6  =eosJMDCKP(6)
      eosP7  =eosJMDCKP(7)
      eosP8  =eosJMDCKP(8)
      eosP9  =eosJMDCKP(9)
      eosP10 =eosJMDCKP(10)
      eosP11 =eosJMDCKP(11)
      eosP12 =eosJMDCKP(12)
      eosP13 =eosJMDCKP(13)
      eosP14 =eosJMDCKP(14)
#endif /* USE_FACTORIZED_EOS */

      rhoLoc  = 0. _d 0
      rhoP0   = 0. _d 0
      bulkMod = 0. _d 0
      rfresh  = 0. _d 0
      rsalt   = 0. _d 0
      bMfresh = 0. _d 0
      bMsalt  = 0. _d 0
      bMpres  = 0. _d 0
      rhoNum  = 0. _d 0
      rhoDen  = 0. _d 0
      den     = 0. _d 0
      dp0     = surf_pRef - eosRefP0

      t1 = tLoc
      t2 = t1*t1
      t3 = t2*t1
      t4 = t3*t1

      s1  = sLoc
      IF ( s1 .LT. 0. _d 0 ) THEN
C     issue a warning
         WRITE(msgBuf,'(A,E13.5)')
     &        ' FIND_RHO_SCALAR:   WARNING, salinity = ', s1
         CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                       SQUEEZE_RIGHT , myThid )
         s1 = 0. _d 0
      ENDIF

      IF (equationOfState.EQ.'LINEAR') THEN

         rholoc = rhoNil*(
     &                      sBeta *(sLoc-sRef(1))
     &                     -tAlpha*(tLoc-tRef(1))
     &                   ) + rhoNil
c        rhoLoc = 0. _d  0

      ELSEIF (equationOfState.EQ.'POLY3') THEN

C     this is not correct, there is a field eosSig0 which should be use here
C     but I DO not intent to include the reference level in this routine
         WRITE(msgBuf,'(A)')
     &        ' FIND_RHO_SCALAR: for POLY3, the density is not'
         CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                       SQUEEZE_RIGHT , myThid )
         WRITE(msgBuf,'(A)')
     &         '                 computed correctly in this routine'
         CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                       SQUEEZE_RIGHT , myThid )
         rhoLoc = 0. _d 0

      ELSEIF ( equationOfState(1:5).EQ.'JMD95'
     &      .OR. equationOfState.EQ.'UNESCO' ) THEN
C     nonlinear equation of state in pressure coordinates

         s3o2 = s1*SQRT(s1)

         p1 = ( pLoc + dp0 )*SItoBar
         p2 = p1*p1

C     density of freshwater at the surface
#ifdef USE_FACTORIZED_EOS
         rfresh =
     &              eosF1 +
     &        t1* ( eosF2 +
     &        t1* ( eosF3 +
     &        t1* ( eosF4 +
     &        t1* ( eosF5 +
     &        t1*   eosF6  ))))
#else
         rfresh =
     &          eosJMDCFw(1)
     &        + eosJMDCFw(2)*t1
     &        + eosJMDCFw(3)*t2
     &        + eosJMDCFw(4)*t3
     &        + eosJMDCFw(5)*t4
     &        + eosJMDCFw(6)*t4*t1
#endif /* USE_FACTORIZED_EOS */
C     density of sea water at the surface
#ifdef USE_FACTORIZED_EOS
         rsalt =   s1 * ( eosS1 +
     &             t1 * ( eosS2 +
     &             t1 * ( eosS3 +
     &             t1 * ( eosS4 +
     &             t1 *   eosS5  ))))
     &         + s3o2 * ( eosS6 +
     &             t1 * ( eosS7 +
     &             t1 *   eosS8  ))
     &         + s1*s1*   eosS9
#else
         rsalt =
     &        s1*(
     &             eosJMDCSw(1)
     &           + eosJMDCSw(2)*t1
     &           + eosJMDCSw(3)*t2
     &           + eosJMDCSw(4)*t3
     &           + eosJMDCSw(5)*t4
     &           )
     &        + s3o2*(
     &             eosJMDCSw(6)
     &           + eosJMDCSw(7)*t1
     &           + eosJMDCSw(8)*t2
     &           )
     &           + eosJMDCSw(9)*s1*s1
#endif /* USE_FACTORIZED_EOS */

         rhoP0 = rfresh + rsalt

C     secant bulk modulus of fresh water at the surface
#ifdef USE_FACTORIZED_EOS
         bMfresh =   eosF1 +
     &        t1 * ( eosF2 +
     &        t1 * ( eosF3 +
     &        t1 * ( eosF4 +
     &        t1 *   eosF5  )))
#else
         bMfresh =
     &             eosJMDCKFw(1)
     &           + eosJMDCKFw(2)*t1
     &           + eosJMDCKFw(3)*t2
     &           + eosJMDCKFw(4)*t3
     &           + eosJMDCKFw(5)*t4
#endif /* USE_FACTORIZED_EOS */
C     secant bulk modulus of sea water at the surface
#ifdef USE_FACTORIZED_EOS
         bMsalt = s1 * ( eosS1 +
     &            t1 * ( eosS2 +
     &            t1 * ( eosS3 +
     &            t1 *   eosS4  )))
     &        + s3o2 * ( eosS5 +
     &            t1 * ( eosS6 +
     &            t1 *   eosS7  ))
C     secant bulk modulus of sea water at pressure p
         bMpres =  p1 * ( eosP1 +
     &             t1 * ( eosP2 +
     &             t1 * ( eosP3 +
     &             t1 *   eosP4  )))
     &          + p1*s1*( eosP5 +
     &             t1 * ( eosP6 +
     &             t1 *   eosP7  ))
     &          + p1*s3o2*eosP8
     &          + p2  * ( eosP9 +
     &             t1 * ( eosP10 +
     &             t1 *   eosP11  ))
     &         + p2*s1* ( eosP12 +
     &             t1 * ( eosP13 +
     &             t1 *   eosP14 ))
#else
C     secant bulk modulus of sea water at the surface
         bMsalt =
     &        s1*( eosJMDCKSw(1)
     &           + eosJMDCKSw(2)*t1
     &           + eosJMDCKSw(3)*t2
     &           + eosJMDCKSw(4)*t3
     &           )
     &    + s3o2*( eosJMDCKSw(5)
     &           + eosJMDCKSw(6)*t1
     &           + eosJMDCKSw(7)*t2
     &           )
C     secant bulk modulus of sea water at pressure p
         bMpres =
     &        p1*( eosJMDCKP(1)
     &           + eosJMDCKP(2)*t1
     &           + eosJMDCKP(3)*t2
     &           + eosJMDCKP(4)*t3
     &           )
     &   + p1*s1*( eosJMDCKP(5)
     &           + eosJMDCKP(6)*t1
     &           + eosJMDCKP(7)*t2
     &           )
     &      + p1*s3o2*eosJMDCKP(8)
     &      + p2*( eosJMDCKP(9)
     &           + eosJMDCKP(10)*t1
     &           + eosJMDCKP(11)*t2
     &           )
     &    + p2*s1*( eosJMDCKP(12)
     &           + eosJMDCKP(13)*t1
     &           + eosJMDCKP(14)*t2
     &           )
#endif /* USE_FACTORIZED_EOS */

         bulkMod = bMfresh + bMsalt + bMpres

C     density of sea water at pressure p
         rhoLoc = rhoP0/(1. _d 0 - p1/bulkMod)

      ELSEIF ( equationOfState.EQ.'MDJWF' ) THEN

       sp5 = SQRT(s1)

       p1 = ( pLoc + dp0 )*SItodBar
       p1t1 = p1*t1

       rhoNum = eosMDJWFnum(0)
     &      + t1*(eosMDJWFnum(1)
     &      +     t1*(eosMDJWFnum(2) + eosMDJWFnum(3)*t1) )
     &      + s1*(eosMDJWFnum(4)
     &      +     eosMDJWFnum(5)*t1  + eosMDJWFnum(6)*s1)
     &      + p1*(eosMDJWFnum(7) + eosMDJWFnum(8)*t2
     &      +     eosMDJWFnum(9)*s1
     &      +     p1*(eosMDJWFnum(10) + eosMDJWFnum(11)*t2) )

       den = eosMDJWFden(0)
     &      + t1*(eosMDJWFden(1)
     &      +     t1*(eosMDJWFden(2)
     &      +         t1*(eosMDJWFden(3) + t1*eosMDJWFden(4) ) ) )
     &      + s1*(eosMDJWFden(5)
     &      +     t1*(eosMDJWFden(6)
     &      +         eosMDJWFden(7)*t2)
     &      +     sp5*(eosMDJWFden(8) + eosMDJWFden(9)*t2) )
     &      + p1*(eosMDJWFden(10)
     &      +     p1t1*(eosMDJWFden(11)*t2 + eosMDJWFden(12)*p1) )

       rhoDen = 1.0/(epsln+den)

       rhoLoc = rhoNum*rhoDen

      ELSEIF( equationOfState .EQ. 'TEOS10' ) THEN

       ct      = tLoc
       sa      = sLoc
       IF ( sa .GT. 0. _d 0 ) THEN
        sqrtsa = SQRT(sa)
       ELSE
        sa     = 0. _d 0
        sqrtsa = 0. _d 0
       ENDIF
       p = ( pLoc + dp0 )*SItodBar

       rhoNum = teos(01)
     &   + ct*(teos(02) + ct*(teos(03) + teos(04)*ct))
     &   + sa*(teos(05) + ct*(teos(06) + teos(07)*ct)
     &   + sqrtsa*(teos(08) + ct*(teos(09)
     &            + ct*(teos(10) + teos(11)*ct))))
     &   + p*(teos(12) + ct*(teos(13) + teos(14)*ct)
     &                      + sa*(teos(15) + teos(16)*ct)
     &   + p*(teos(17) + ct*(teos(18) + teos(19)*ct) + teos(20)*sa))

       den = teos(21)
     &   + ct*(teos(22) + ct*(teos(23) + ct*(teos(24) + teos(25)*ct)))
     &   + sa*(teos(26) + ct*(teos(27) + ct*(teos(28)
     &   + ct*(teos(29) + teos(30)*ct)))
     &   + teos(36)*sa
     %   + sqrtsa*(teos(31) + ct*(teos(32) + ct*(teos(33)
     &            + ct*(teos(34) + teos(35)*ct)))))
     %   + p*(teos(37) + ct*(teos(38) + ct*(teos(39) + teos(40)*ct))
     %   + sa*(teos(41) + teos(42)*ct)
     %   + p*(teos(43) + ct*(teos(44) + teos(45)*ct + teos(46)*sa)
     %   + p*(teos(47) + teos(48)*ct)))

       rhoDen = 1.0/(epsln+den)

       rhoLoc = rhoNum*rhoDen

      ELSEIF( equationOfState .EQ. 'IDEALG' ) THEN

         oneMinusKap = oneRL - atm_kappa
C        rho = P/(R*T_v) = Po/(R*theta_v)*(P/Po)^(1-kappa)
         facPres = ( pLoc/atm_Po )**oneMinusKap
         theta_v = tLoc*( sLoc*atm_Rq + oneRL )
         rhoLoc = atm_Po*facPres /( atm_Rd*theta_v )

      ELSE
       WRITE(msgBuf,'(3A)')
     &        ' FIND_RHO_SCALAR : equationOfState = "',
     &        equationOfState,'"'
       CALL PRINT_ERROR( msgBuf, myThid )
       STOP 'ABNORMAL END: S/R FIND_RHO_SCALAR'
      ENDIF

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: LOOK_FOR_NEG_SALINITY
C     !INTERFACE:
      SUBROUTINE LOOK_FOR_NEG_SALINITY(
     I                iMin, iMax, jMin, jMax,
     U                sFld,
     I                k, bi, bj, myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | o SUBROUTINE LOOK_FOR_NEG_SALINITY
C     |   looks for and fixes negative salinity values
C     |   this is necessary IF the equation of state uses
C     |   the square root of salinity
C     *==========================================================*
C     | k - is the Salt level
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     k    :: Level of Salt slice
      INTEGER iMin,iMax,jMin,jMax
      _RL     sFld(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER k, bi, bj
      INTEGER myThid

C     !LOCAL VARIABLES:
C     == Local variables ==
      INTEGER i,j, localWarning
      CHARACTER*(MAX_LEN_MBUF) msgBuf
CEOP

      localWarning = 0
      DO j=jMin,jMax
       DO i=iMin,iMax
C     abbreviations
        IF ( sFld(i,j) .LT. 0. _d 0 ) THEN
         localWarning = localWarning + 1
         sFld(i,j) = 0. _d 0
        ENDIF
       ENDDO
      ENDDO
C     issue a warning
      IF ( localWarning .GT. 0 ) THEN
        WRITE(msgBuf,'(2A,I5,A,2I4)') 'S/R LOOK_FOR_NEG_SALINITY:',
     &      ' from level k =', k, ' ; bi,bj =', bi, bj
        CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                      SQUEEZE_RIGHT , myThid )
        WRITE(msgBuf,'(2A,I6,A)') 'S/R LOOK_FOR_NEG_SALINITY:',
     &      ' reset to zero', localWarning, ' negative salinity.'
        CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                      SQUEEZE_RIGHT , myThid )
      ENDIF

      RETURN
      END

#include "EXF_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

CBOP
C     !ROUTINE: EXF_GETFIELD_START
C     !INTERFACE:
       SUBROUTINE EXF_GETFIELD_START(
     I                useYearlyFields,
     I                fld_startdate1, fld_startdate2,
     O                fld_start_time,
     I                myThid )

C !DESCRIPTION: \bv
C  *==========================================================*
C  | SUBROUTINE EXF_GETFIELD_START
C  | o old version of current S/R EXF_GETFFIELD_START
C  |   - with fewer arguments
C  |   - does not check if parameters are consistent with
C  |     useCAL setting
C  | o kept to allow to compile and use old piece of code
C  *==========================================================*
C \ev

C !USES:
      IMPLICIT NONE
C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"

C !INPUT/OUTPUT PARAMETERS:
C     useYearlyFields :: select if using EXF Yearly-fields or not
C     fld_startdate1  :: field starting date (YYYYMMDD)
C     fld_startdate2  :: field starting date (HHMMSS)
C     fld_start_time  :: corresponding starting time (in sec) for this field
C     myThid          :: My Thread Id number
      LOGICAL useYearlyFields
      INTEGER fld_startdate1, fld_startdate2
      _RL fld_start_time
      INTEGER myThid

C !LOCAL VARIABLES:
C     msgBuf          :: Informational/error message buffer
c     CHARACTER*(MAX_LEN_MBUF) msgBuf
      CHARACTER*(3) pkg_name
      CHARACTER*(7) fld_name
      _RL fld_period
      INTEGER errCount
CEOP

      IF ( useCAL ) THEN
        pkg_name   = 'xxx'
        fld_name   = 'exf_gen'
        fld_period = oneRL
        fld_start_time = UNSET_RL
        errCount   = 0
        CALL EXF_GETFFIELD_START( useYearlyFields,
     I                     pkg_name, fld_name, fld_period,
     I                     fld_startdate1, fld_startdate2,
     U                     fld_start_time, errCount,
     I                     myThid )
      ENDIF

      RETURN
      END

#include "STREAMICE_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

CBOP
      SUBROUTINE STREAMICE_VISC_BETA ( myThid )

C     /============================================================\
C     | SUBROUTINE                                                 |
C     | o                                                          |
C     |============================================================|
C     |                                                            |
C     \============================================================/
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "GRID.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "STREAMICE.h"
#include "STREAMICE_CG.h"

C     !INPUT/OUTPUT ARGUMENTS
      INTEGER myThid
!       _RL taudx (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
!       _RL taudx (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)

#ifdef ALLOW_STREAMICE

C     LOCAL VARIABLES
      INTEGER i, j, bi, bj, k, l
      _RL ux, uy, vx, vy, exx, eyy, exy, second_inv, unorm
      _RL umid, vmid, C_fric_val, Bglen_val

      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        DO j=1,sNy
         DO i=1,sNx
          IF (STREAMICE_hmask(i,j,bi,bj).eq.1) THEN

           umid = 0
           vmid = 0

           DO k=0,1
            DO l=0,1
             umid = umid + 0.25 *
     &        dxG(i,j+l,bi,bj)*dyG(i+k,j,bi,bj) *
     &        recip_rA(i,j,bi,bj) *
     &        U_streamice(i+k,j+l,bi,bj)
             vmid = vmid + 0.25 *
     &        dxG(i,j+l,bi,bj)*dyG(i+k,j,bi,bj) *
     &        recip_rA(i,j,bi,bj) *
     &        V_streamice(i+k,j+l,bi,bj)
            ENDDO
           ENDDO

           ux = (U_streamice(i+1,j+1,bi,bj) +
     &           U_streamice(i+1,j,bi,bj)   -
     &           U_streamice(i,j+1,bi,bj)   -
     &           U_streamice(i,j,bi,bj)) /
     &           (2. * dxF(i,j,bi,bj))
           vx = (V_streamice(i+1,j+1,bi,bj) +
     &           V_streamice(i+1,j,bi,bj)   -
     &           V_streamice(i,j+1,bi,bj)   -
     &           V_streamice(i,j,bi,bj)) /
     &           (2. * dxF(i,j,bi,bj))
           uy = (U_streamice(i+1,j+1,bi,bj) -
     &           U_streamice(i+1,j,bi,bj)   +
     &           U_streamice(i,j+1,bi,bj)   -
     &           U_streamice(i,j,bi,bj)) /
     &           (2. * dyF(i,j,bi,bj))
           vy = (V_streamice(i+1,j+1,bi,bj) -
     &           V_streamice(i+1,j,bi,bj)   +
     &           V_streamice(i,j+1,bi,bj)   -
     &           V_streamice(i,j,bi,bj)) /
     &           (2. * dyF(i,j,bi,bj))

           exx = ux + k1AtC_str(i,j,bi,bj)*vmid
           eyy = vy + k2AtC_str(i,j,bi,bj)*umid
           exy = .5*(uy+vx) +
     &      k1AtC_str(i,j,bi,bj)*umid + k2AtC_str(i,j,bi,bj)*vmid

!A_glen_isothermal, n_glen, eps_glen_min,

           second_inv =
     &      sqrt(exx**2+eyy**2+exx*eyy+exy**2+eps_glen_min**2)

#ifdef STREAMICE_3D_GLEN_CONST
           IF (.not.STREAMICE_use_log_ctrl) THEN
            Bglen_val = B_glen(i,j,1,bi,bj)**2
           ELSE
            Bglen_val = exp(B_glen(i,j,1,bi,bj))
           ENDIF
#else
           IF (.not.STREAMICE_use_log_ctrl) THEN
            Bglen_val = B_glen(i,j,bi,bj)**2
           ELSE
            Bglen_val = exp(B_glen(i,j,bi,bj))
           ENDIF
#endif

           visc_streamice(i,j,bi,bj) =
     &      .5 * Bglen_val *
     &      second_inv**((1-n_glen)/n_glen) * H_streamice(i,j,bi,bj)

           if (.not.STREAMICE_use_log_ctrl) THEN
            C_fric_val = C_basal_friction(i,j,bi,bj)**2
           else
            C_fric_val = exp(C_basal_friction(i,j,bi,bj))
           endif

           unorm = sqrt(umid**2+vmid**2+eps_u_min**2)
           tau_beta_eff_streamice(i,j,bi,bj) =
     &       C_fric_val *
     &       unorm ** (n_basal_friction-1.0) *
     &       float_frac_streamice (i,j,bi,bj)

          ENDIF
         ENDDO
        ENDDO
       ENDDO
      ENDDO

#endif
      RETURN
      END

#include "MATRIX_OPTIONS.h"

CBOP
C     !ROUTINE: MATRIX_OUTPUT

C     !INTERFACE:
      SUBROUTINE MATRIX_OUTPUT(
     I                  myTime, myIter, myThid )

C     !DESCRIPTION:
C     This is the controlling routine for MATRIX output. It is
C     called from DO_THE_MODEL_IO.

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"

C     !INPUT PARAMETERS:
C     myTime    :: model time
C     myIter    :: time-step number
C     myThid    :: thread number
      _RL myTime
      INTEGER myIter
      INTEGER myThid
CEOP

#ifdef ALLOW_MATRIX
C     !LOCAL VARIABLES:

      IF ( myIter.EQ.nIter0 ) THEN
C       Write grid info for pkg/matrix
        CALL MATRIX_WRITE_GRID( myThid )
      ELSE
C       Write matrix to file
        CALL MATRIX_WRITE_TENDENCY( myTime, myIter, myThid )
      ENDIF

#endif /* ALLOW_MATRIX */

      RETURN
      END

#include "SHELFICE_OPTIONS.h"
CBOP
C     !ROUTINE: SHELFICE_REMESH_UV_MASK
C     !INTERFACE:
      SUBROUTINE SHELFICE_REMESH_UV_MASK(
     O                    k1SurfW, k1SurfS, mrgFacW, mrgFacS,
     I                    myTime, myIter, myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE SHELFICE_REMESH_UV_MASK
C     | o Update masks and geom factors at U and V points
C     | o save surface level index and thickness factors for
C     |   update of horizontal velocity state variables
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#ifdef NONLIN_FRSURF
# include "SURFACE.h"
#endif /* NONLIN_FRSURF */

C     !INPUT/OUTPUT PARAMETERS:
C     k1SurfW   :: surface level index (at cell W.Edge) before remeshing
C     k1SurfS   :: surface level index (at cell S.Edge) before remeshing
C     mrgFacW   :: store hFacW to compute merging weight for U velocity
C     mrgFacS   :: store hFacS to compute merging weight for V velocity
C     myTime    :: Current time in simulation
C     myIter    :: Current iteration number
C     myThid    :: my Thread Id number
      INTEGER k1SurfW(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      INTEGER k1SurfS(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL mrgFacW(1-OLx:sNx+OLx,1-OLy:sNy+OLy,2,nSx,nSy)
      _RL mrgFacS(1-OLx:sNx+OLx,1-OLy:sNy+OLy,2,nSx,nSy)
      _RL myTime
      INTEGER myIter
      INTEGER myThid

#ifdef ALLOW_SHELFICE_REMESHING
#ifdef NONLIN_FRSURF
C     !LOCAL VARIABLES:
C     bi, bj    :: tile indices
C     i, j, k   :: Loop counters
C     tmpVar    :: Temporary array used to integrate column thickness
      INTEGER bi, bj
      INTEGER i, j, k
      INTEGER ks, k1, k2
      _RL tmpVar(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL hFacMnSz, hFacCtmp
      _RL hFac1tmp, hFac2tmp
      _RL Rmin_tmp, hfacInfMom
CEOP

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)

        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
           k1SurfW(i,j,bi,bj) = kSurfW(i,j,bi,bj)
           k1SurfS(i,j,bi,bj) = kSurfS(i,j,bi,bj)
           mrgFacW(i,j,1,bi,bj) = 0.
           mrgFacW(i,j,2,bi,bj) = 0.
           mrgFacS(i,j,1,bi,bj) = 0.
           mrgFacS(i,j,2,bi,bj) = 0.
         ENDDO
        ENDDO

        DO j=1-OLy,sNy+OLy
         DO i=2-OLx,sNx+OLx
           rSurfW(i,j,bi,bj) =
     &           MIN( Ro_surf(i-1,j,bi,bj), Ro_surf(i,j,bi,bj) )
           rSurfW(i,j,bi,bj) =
     &           MAX( rSurfW(i,j,bi,bj), rLowW(i,j,bi,bj) )
         ENDDO
        ENDDO
        DO j=2-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
           rSurfS(i,j,bi,bj) =
     &           MIN( Ro_surf(i,j-1,bi,bj), Ro_surf(i,j,bi,bj) )
           rSurfS(i,j,bi,bj) =
     &           MAX( rSurfS(i,j,bi,bj), rLowS(i,j,bi,bj) )
         ENDDO
        ENDDO

       ENDDO
      ENDDO

      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)

C- Method-1 (useMin4hFacEdges = T):
C    compute hFacW,hFacS as minimum of adjacent hFacC factor
C- Method-2 (useMin4hFacEdges = F):
C    compute hFacW,hFacS from rSurfW,S and rLowW,S by applying
C    same rules as for hFacC
C Note: Currently, no difference between methods except when useShelfIce=T and
C       if, in adjacent columns, ice-draft and bathy are within the same level k

        IF ( useMin4hFacEdges ) THEN
C--   hFacW and hFacS (at U and V points):
C-    Method-1: use simply minimum of adjacent hFacC factor

         DO k=1, Nr
          DO j=1-OLy,sNy+OLy
           h0FacW(1-OLx,j,k,bi,bj) = 0.
           DO i=2-OLx,sNx+OLx
            h0FacW(i,j,k,bi,bj) =
     &        MIN( h0FacC(i,j,k,bi,bj), h0FacC(i-1,j,k,bi,bj) )
           ENDDO
          ENDDO
          DO i=1-OLx,sNx+OLx
            h0FacS(i,1-OLy,k,bi,bj) = 0.
          ENDDO
          DO j=2-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
            h0FacS(i,j,k,bi,bj) =
     &        MIN( h0FacC(i,j,k,bi,bj), h0FacC(i,j-1,k,bi,bj) )
           ENDDO
          ENDDO
         ENDDO

        ELSE
C--   hFacW and hFacS (at U and V points):
C-    Method-2: compute new hFacW,S from rSurfW,S and rLowW,S
C               by applying same rules as for hFacC

         DO k=1, Nr
          hFacMnSz = MAX( hFacMin, MIN(hFacMinDr*recip_drF(k),oneRL) )
          DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
C      o Non-dimensional distance between grid bound. and domain lower_R bound.
            hFac1tmp = ( rF(k) - rLowW(i,j,bi,bj) )*recip_drF(k)
            hFacCtmp = MIN( hFac1tmp, oneRL )
c           hFacCtmp = MAX( hFacCtmp, zeroRL )
C      o Impose minimum fraction and/or size (dimensional)
            IF ( hFacCtmp.LT.hFacMnSz*halfRL ) THEN
              hFac1tmp = 0.
            ELSE
              hFac1tmp = MAX( hFacCtmp, hFacMnSz )
            ENDIF
C      o Reduce the previous fraction : substract the outside fraction
C        (i.e., beyond reference (=at rest) surface position rSurfW)
            hFac2tmp = ( rF(k) -rSurfW(i,j,bi,bj) )*recip_drF(k)
            hFacCtmp = hFac1tmp - MAX( hFac2tmp, zeroRL )
C      o Impose minimum fraction and/or size (dimensional)
            IF ( hFacCtmp.LT.hFacMnSz*halfRL ) THEN
              h0FacW(i,j,k,bi,bj) = 0.
            ELSE
              h0FacW(i,j,k,bi,bj) = MAX( hFacCtmp, hFacMnSz )
            ENDIF
           ENDDO
          ENDDO
          DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
C      o Non-dimensional distance between grid bound. and domain lower_R bound.
            hFac1tmp = ( rF(k) - rLowS(i,j,bi,bj) )*recip_drF(k)
            hFacCtmp = MIN( hFac1tmp, oneRL )
c           hFacCtmp = MAX( hFacCtmp, zeroRL )
C      o Impose minimum fraction and/or size (dimensional)
            IF ( hFacCtmp.LT.hFacMnSz*halfRL ) THEN
              hFac1tmp = 0.
            ELSE
              hFac1tmp = MAX( hFacCtmp, hFacMnSz )
            ENDIF
C      o Reduce the previous fraction : substract the outside fraction
C        (i.e., beyond reference (=at rest) surface position rSurfS)
            hFac2tmp = ( rF(k) -rSurfS(i,j,bi,bj) )*recip_drF(k)
            hFacCtmp = hFac1tmp - MAX( hFac2tmp, zeroRL )
C      o Impose minimum fraction and/or size (dimensional)
            IF ( hFacCtmp.LT.hFacMnSz*halfRL ) THEN
              h0FacS(i,j,k,bi,bj) = 0.
            ELSE
              h0FacS(i,j,k,bi,bj) = MAX( hFacCtmp, hFacMnSz )
            ENDIF
           ENDDO
          ENDDO
         ENDDO
        ENDIF

C--   Update rLow & reference rSurf at Western & Southern edges (U & V pts):
C     account for adjusted R_low & Ro_surf due to hFacMin constrain on hFacC.
C     Might need further adjustment (e.g., if useShelfIce=T) to match
C     integrated level thickness ( =Sum_k(drF*hFac) )

C--   Adjust rLow & reference rSurf at Western & Southern edges (U & V pts)
C     to get consistent column thickness from Sum_k(hFac*drF) and rSurf-rLow

C-    Total column thickness at Western edges
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
           tmpVar(i,j) = 0. _d 0
         ENDDO
        ENDDO
        DO k=1,Nr
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
            tmpVar(i,j) = tmpVar(i,j) + drF(k)*h0FacW(i,j,k,bi,bj)
          ENDDO
         ENDDO
        ENDDO
C-    Adjust only rSurf at W (correct for the difference)
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
           rSurfW(i,j,bi,bj) = rLowW(i,j,bi,bj) + tmpVar(i,j)
         ENDDO
        ENDDO

C-    Total column thickness at Southern edges
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
           tmpVar(i,j) = 0. _d 0
         ENDDO
        ENDDO
        DO k=1,Nr
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
            tmpVar(i,j) = tmpVar(i,j) + drF(k)*h0FacS(i,j,k,bi,bj)
          ENDDO
         ENDDO
        ENDDO
C-    Adjust only rSurf at edges (correct for the difference)
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
           rSurfS(i,j,bi,bj) = rLowS(i,j,bi,bj) + tmpVar(i,j)
         ENDDO
        ENDDO

C-    end bi,bj loops.
       ENDDO
      ENDDO

      CALL EXCH_UV_XYZ_RS( h0FacW,  h0FacS, .FALSE., myThid )
      CALL EXCH_UV_XY_RS( rSurfW, rSurfS, .FALSE., myThid )

      DO bj=myByLo(myThid), myByHi(myThid)
       DO bi=myBxLo(myThid), myBxHi(myThid)

C--   Account for additional closing of Western and Southern grid-cell edges
C     ( which jave been reccorded as kSurfW/S = Nr+2 )
C     and calculate surface k index for interface W & S (U & V points)
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          kSurfW(i,j,bi,bj) = MAX( k1SurfW(i,j,bi,bj), Nr+1 )
          kSurfS(i,j,bi,bj) = MAX( k1SurfS(i,j,bi,bj), Nr+1 )
         ENDDO
        ENDDO
        DO k=1,Nr
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           IF ( kSurfW(i,j,bi,bj).EQ.Nr+2 ) THEN
             h0FacW(i,j,k,bi,bj) = zeroRS
           ELSEIF ( kSurfW(i,j,bi,bj).EQ.Nr+1 ) THEN
             IF (h0FacW(i,j,k,bi,bj).NE.zeroRS) kSurfW(i,j,bi,bj) = k
           ENDIF
           IF ( kSurfS(i,j,bi,bj).EQ.Nr+2 ) THEN
             h0FacS(i,j,k,bi,bj) = zeroRS
           ELSEIF ( kSurfS(i,j,bi,bj).EQ.Nr+1 ) THEN
             IF (h0FacS(i,j,k,bi,bj).NE.zeroRS) kSurfS(i,j,bi,bj) = k
           ENDIF
          ENDDO
         ENDDO
        ENDDO

C-    end bi,bj loops.
       ENDDO
      ENDDO

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)

C--  Compute the mimimum value of r_surf (used for computing hFac_surfC)
        hFacInfMOM = hFacInf
        DO j=1,sNy
         DO i=1,sNx
           ks = kSurfC(i,j,bi,bj)
           IF (ks.LE.Nr) THEN
             Rmin_tmp = rF(ks+1)
             IF ( ks.EQ.kSurfW(i,j,bi,bj))
     &          Rmin_tmp = MAX(Rmin_tmp, R_low(i-1,j,bi,bj))
             IF ( ks.EQ.kSurfW(i+1,j,bi,bj))
     &          Rmin_tmp = MAX(Rmin_tmp, R_low(i+1,j,bi,bj))
             IF ( ks.EQ.kSurfS(i,j,bi,bj))
     &          Rmin_tmp = MAX(Rmin_tmp, R_low(i,j-1,bi,bj))
             IF ( ks.EQ.kSurfS(i,j+1,bi,bj))
     &          Rmin_tmp = MAX(Rmin_tmp, R_low(i,j+1,bi,bj))

             Rmin_surf(i,j,bi,bj) =
     &        MAX( MAX(rF(ks+1),R_low(i,j,bi,bj)) + hFacInf*drF(ks),
     &                                Rmin_tmp + hFacInfMOM*drF(ks)
     &           )
           ENDIF
         ENDDO
        ENDDO

C--  Prepare merging weights for both components of horizontal velocity;
C    they will get updated once new thickness factor are available
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          IF ( kSurfW(i,j,bi,bj).NE.k1SurfW(i,j,bi,bj) ) THEN
            k1 = k1SurfW(i,j,bi,bj)
            k2 =  kSurfW(i,j,bi,bj)
            IF ( k2.GT.k1 .AND. k2.LE.Nr ) THEN
C-      merging former (=k1) into new (=k2) surface grid cell
              mrgFacW(i,j,1,bi,bj) = hFacW(i,j,k1,bi,bj)
              mrgFacW(i,j,2,bi,bj) = hFacW(i,j,k2,bi,bj)
            ENDIF
          ENDIF
         ENDDO
        ENDDO
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          IF ( kSurfS(i,j,bi,bj).NE.k1SurfS(i,j,bi,bj) ) THEN
            k1 = k1SurfS(i,j,bi,bj)
            k2 =  kSurfS(i,j,bi,bj)
            IF ( k2.GT.k1 .AND. k2.LE.Nr ) THEN
C-      merging former (=k1) into new (=k2) surface grid cell
              mrgFacS(i,j,1,bi,bj) = hFacS(i,j,k1,bi,bj)
              mrgFacS(i,j,2,bi,bj) = hFacS(i,j,k2,bi,bj)
            ENDIF
          ENDIF
         ENDDO
        ENDDO

C--   Masks and reciprocals of hFac[CWS]
        DO k=1,Nr
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           IF ( h0FacW(i,j,k,bi,bj).NE.zeroRS ) THEN
            recip_hFacW(i,j,k,bi,bj) = 1. _d 0 / h0FacW(i,j,k,bi,bj)
            maskW(i,j,k,bi,bj) = 1.
           ELSE
            recip_hFacW(i,j,k,bi,bj) = 0.
            maskW(i,j,k,bi,bj) = 0.
           ENDIF
           IF ( h0FacS(i,j,k,bi,bj).NE.zeroRS ) THEN
            recip_hFacS(i,j,k,bi,bj) = 1. _d 0 / h0FacS(i,j,k,bi,bj)
            maskS(i,j,k,bi,bj) = 1.
           ELSE
            recip_hFacS(i,j,k,bi,bj) = 0.
            maskS(i,j,k,bi,bj) = 0.
           ENDIF
          ENDDO
         ENDDO
        ENDDO

C--   Copy initial geometrical h0FacW & h0FacW into hFac factor.
        DO k=1,Nr
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           hFacW(i,j,k,bi,bj) = h0FacW(i,j,k,bi,bj)
           hFacS(i,j,k,bi,bj) = h0FacS(i,j,k,bi,bj)
          ENDDO
         ENDDO
        ENDDO

C-    end bi,bj loops.
       ENDDO
      ENDDO

      CALL EXCH_XY_RL( Rmin_surf, myThid )

#endif /* NONLIN_FRSURF */
#endif /* ALLOW_SHELFICE_REMESHING */

      RETURN
      END

#include "EXF_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C     !ROUTINE: EXF_SET_UV
C     !INTERFACE:
      SUBROUTINE EXF_SET_UV(
     I     uVecName, uVecFile, uVecMask,
     I     uVecStartTime, uVecPeriod, uVecRepeatCycle,
     I     uVec_inScale, uVec_remove_intercept, uVec_remove_slope,
     U     uVec, uVec0, uVec1,
     I     vVecName, vVecFile, vVecMask,
     I     vVecStartTime, vVecPeriod, vVecRepeatCycle,
     I     vVec_inScale, vVec_remove_intercept, vVec_remove_slope,
     U     vVec, vVec0, vVec1,
#ifdef USE_EXF_INTERPOLATION
     I     uVec_lon0, uVec_lon_inc, uVec_lat0, uVec_lat_inc,
     I     uVec_nlon, uVec_nlat, u_interp_method,
     I     vVec_lon0, vVec_lon_inc, vVec_lat0, vVec_lat_inc,
     I     vVec_nlon, vVec_nlat, v_interp_method, uvInterp,
#endif /* USE_EXF_INTERPOLATION */
     I     myTime, myIter, myThid )

C !DESCRIPTION: \bv
C  *=================================================================*
C  | SUBROUTINE EXF_SET_UV
C  | o Read-in, interpolate, and rotate wind or wind stress vectors
C  |   from a spherical-polar input grid to an arbitrary output grid.
C  *=================================================================*
C  |   menemenlis@jpl.nasa.gov, 8-Dec-2003
C  *=================================================================*
C \ev

C !USES:
      IMPLICIT NONE
C     == global variables ==
#include "EEPARAMS.h"
#include "SIZE.h"
#include "PARAMS.h"
#include "GRID.h"
#include "EXF_PARAM.h"
#include "EXF_CONSTANTS.h"
#include "EXF_INTERP_SIZE.h"
#include "EXF_INTERP_PARAM.h"
#include "EXF_FIELDS.h"

C !INPUT/OUTPUT PARAMETERS:
C     *VecName        :: vector compon. short name (to print mesg)
C     *VecFile        :: file-name for this vector compon. field
C     *VecStartTime   :: corresponding starting time (in sec) for this vec
C     *VecPeriod      :: time period (in sec) between 2 reccords
C     *VecRepeatCycle :: time duration of a repeating cycle
C     *Vec_inScale    :: input field scaling factor
C     *VecRemove_intercept ::
C     *VecRemove_slope     ::
C     *Vec            :: field array containing current time values
C     *Vec0           :: field array holding previous reccord
C     *Vec1           :: field array holding next     reccord
#ifdef USE_EXF_INTERPOLATION
C     *vec_lon0, *vec_lat0 :: longitude and latitude of SouthWest
C                          :: corner of global input grid for *vec
C     *vec_nlon, *vec_nlat :: input x-grid and y-grid size for *vec
C     *_interp_method      :: select interpolation method for *vec
C     *vec_lon_inc         :: scalar x-grid increment for *vec
C     *vec_lat_inc         :: vector y-grid increments for *vec
#endif /* USE_EXF_INTERPOLATION */
C     myTime         :: Current time (in sec) in simulation
C     myIter         :: Current iteration number
C     myThid         :: My Thread Id number
      CHARACTER*(*) uVecName
      CHARACTER*(128) uVecFile
      CHARACTER*1 uVecMask
      _RL     uVecStartTime, uVecPeriod, uVecRepeatCycle
      _RL     uVec_inScale
      _RL     uVec_remove_intercept, uVec_remove_slope
      _RL     uVec  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL     uVec0 (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL     uVec1 (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      CHARACTER*(*) vVecName
      CHARACTER*(128) vVecFile
      CHARACTER*1 vVecMask
      _RL     vVecStartTime, vVecPeriod, vVecRepeatCycle
      _RL     vVec_inScale
      _RL     vVec_remove_intercept, vVec_remove_slope
      _RL     vVec  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL     vVec0 (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL     vVec1 (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
#ifdef USE_EXF_INTERPOLATION
      _RL uVec_lon0, uVec_lon_inc
      _RL uVec_lat0, uVec_lat_inc(MAX_LAT_INC)
      INTEGER uVec_nlon, uVec_nlat, u_interp_method
      _RL vVec_lon0, vVec_lon_inc
      _RL vVec_lat0, vVec_lat_inc(MAX_LAT_INC)
      INTEGER vVec_nlon, vVec_nlat, v_interp_method
      LOGICAL uvInterp
#endif /* USE_EXF_INTERPOLATION */
      _RL     myTime
      INTEGER myIter
      INTEGER myThid

C !FUNCTIONS:
      INTEGER  ILNBLNK
      EXTERNAL ILNBLNK

C !LOCAL VARIABLES:
      INTEGER i, j, bi, bj
      _RL     tmp_u (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL     tmp_v (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
#ifdef USE_EXF_INTERPOLATION
C     msgBuf     :: Informational/error message buffer
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      CHARACTER*(128) uVecFile0, uVecFile1
      CHARACTER*(128) vVecFile0, vVecFile1
      CHARACTER*(MAX_LEN_FNAM) out_uVecFile, out_vVecFile
      LOGICAL first, changed
      _RL     fac
#ifdef EXF_USE_OLD_VEC_ROTATION
      _RL     x1, x2, x3, x4, y1, y2, y3, y4, dx, dy
#endif
      INTEGER count0, count1
      INTEGER year0, year1
# ifndef EXF_INTERP_USE_DYNALLOC
      _RL     bufArr1( exf_interp_bufferSize )
      _RL     bufArr2( exf_interp_bufferSize )
# endif
#endif /* USE_EXF_INTERPOLATION */
CEOP

#ifdef USE_EXF_INTERPOLATION
      IF ( u_interp_method.GE.1 .AND. v_interp_method.GE.1 .AND.
     &     uVecFile.NE.' ' .AND. vVecFile.NE.' ' .AND.
     &     (usingCurvilinearGrid .OR. rotateGrid .OR. uvInterp) ) THEN

        IF ( exf_debugLev.GE.debLevD ) THEN
          _BEGIN_MASTER( myThid )
           i = ILNBLNK(uVecFile)
           j = ILNBLNK(vVecFile)
           WRITE(msgBuf,'(6A)') 'EXF_SET_UV: ',
     &       'processing fields "', uVecName, '" & "', vVecName, '"'
           CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                         SQUEEZE_RIGHT, myThid )
           WRITE(msgBuf,'(6A)') 'EXF_SET_UV: ',
     &       '  files: ', uVecFile(1:i), ' & ', vVecFile(1:j)
           CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                         SQUEEZE_RIGHT, myThid )
          _END_MASTER( myThid )
        ENDIF
        IF ( useCAL .AND. uVecPeriod .EQ. -12. ) THEN
#ifdef ALLOW_CAL
C-    genperiod=-12 means input file contains 12 monthly means
C     records, corresponding to Jan. (rec=1) through Dec. (rec=12)
          CALL cal_GetMonthsRec(
     O             fac, first, changed,
     O             count0, count1, year0, year1,
     I             myTime, myIter, myThid )
#endif /* ALLOW_CAL */
        ELSEIF ( useCAL .AND. uVecPeriod .EQ. -1.) THEN
#ifdef ALLOW_CAL
C-    uVecPeriod=-1 means fields are monthly means.
C     With useExfYearlyFields=.TRUE., each yearly input file contains
C     12 monthly mean records.  Otherwise, a single input file contains
C     monthly mean records starting at the month uVecStartTime falls in.
          CALL EXF_GetMonthsRec(
     I             uVecStartTime, useExfYearlyFields,
     O             fac, first, changed,
     O             count0, count1, year0, year1,
     I             myTime, myIter, myThid )
#endif /* ALLOW_CAL */
        ELSEIF ( uVecPeriod .LT. 0. ) THEN
          j = ILNBLNK(uVecFile)
          WRITE(msgBuf,'(4A,1PE16.8,2A)') 'EXF_SET_UV: ',
     &      '"', uVecName, '", Invalid uVecPeriod=', uVecPeriod,
     &      ' for file: ', uVecFile(1:j)
          CALL PRINT_ERROR( msgBuf, myThid )
          STOP 'ABNORMAL END: S/R EXF_SET_UV'
        ELSE
C-    get record numbers and interpolation factor
          CALL EXF_GetFFieldRec(
     I             uVecStartTime, uVecPeriod, uVecRepeatCycle,
     I             uVecName, useExfYearlyFields,
     O             fac, first, changed,
     O             count0, count1, year0, year1,
     I             myTime, myIter, myThid )
        ENDIF
        IF ( exf_debugLev.GE.debLevD ) THEN
          _BEGIN_MASTER( myThid )
           WRITE(msgBuf,'(2A,I10,2I7)') 'EXF_SET_UV:  ',
     &       ' myIter, count0, count1:', myIter, count0, count1
           CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                         SQUEEZE_RIGHT, myThid )
           WRITE(msgBuf,'(2A,2(L2,2X),F21.17)') 'EXF_SET_UV:  ',
     &       ' first, changed, fac:  ', first, changed, fac
           CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                         SQUEEZE_RIGHT, myThid )
          _END_MASTER( myThid )
        ENDIF

        IF ( first ) THEN
C--   Load and interpolate a new reccord (= 1rst one of this run)

          CALL exf_GetYearlyFieldName(
     I         useExfYearlyFields, twoDigitYear, uVecPeriod, year0,
     I         uVecFile,
     O         uVecFile0,
     I         myTime, myIter, myThid )
          CALL exf_GetYearlyFieldName(
     I         useExfYearlyFields, twoDigitYear, vVecPeriod, year0,
     I         vVecFile,
     O         vVecFile0,
     I         myTime, myIter, myThid )
          IF ( exf_debugLev.GE.debLevC ) THEN
            _BEGIN_MASTER(myThid)
            WRITE(msgBuf,'(6A,I10)') 'EXF_SET_UV: ',
     &        'fields "', uVecName, '" & "', vVecName, '", it=', myIter
            CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                          SQUEEZE_RIGHT, myThid )
            j = ILNBLNK(uVecFile0)
            WRITE(msgBuf,'(2A,I6,3A)') 'EXF_SET_UV:   ',
     &      'loading rec=', count0, ' from file: "', uVecFile0(1:j), '"'
            CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                          SQUEEZE_RIGHT, myThid )
            j = ILNBLNK(vVecFile0)
            WRITE(msgBuf,'(2A,I6,3A)') 'EXF_SET_UV:   ',
     &      'loading rec=', count0, ' from file: "', vVecFile0(1:j), '"'
            CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                          SQUEEZE_RIGHT, myThid )
            _END_MASTER(myThid)
          ENDIF

          IF ( uvInterp ) THEN
C-    vector interpolation to (xC,yC) locations
           CALL EXF_INTERP_UV(
     I             uVecFile0, vVecFile0, exf_iprec, count0,
     I             uVec_nlon, uVec_nlat,
     I             uVec_lon0, uVec_lon_inc, uVec_lat0, uVec_lat_inc,
#ifdef EXF_INTERP_USE_DYNALLOC
     O             tmp_u, tmp_v,
#else
     O             tmp_u, tmp_v, bufArr1, bufArr2,
#endif
     I             xC, yC,
     I             u_interp_method, v_interp_method, myIter, myThid )
          ELSE
C-    scalar interpolation to (xC,yC) locations
           CALL EXF_INTERP(
     I             uVecFile0, exf_iprec,
#ifdef EXF_INTERP_USE_DYNALLOC
     O             tmp_u,
#else
     O             tmp_u, bufArr1,
#endif
     I             count0, xC, yC,
     I             uVec_lon0, uVec_lon_inc, uVec_lat0, uVec_lat_inc,
     I             uVec_nlon, uVec_nlat, u_interp_method,
     I             myIter, myThid )
           CALL EXF_INTERP(
     I             vVecFile0, exf_iprec,
#ifdef EXF_INTERP_USE_DYNALLOC
     O             tmp_v,
#else
     O             tmp_v, bufArr2,
#endif
     I             count0, xC, yC,
     I             vVec_lon0, vVec_lon_inc, vVec_lat0, vVec_lat_inc,
     I             vVec_nlon, vVec_nlat, v_interp_method,
     I             myIter, myThid )
          ENDIF

C-    apply mask: Note: done after applying scaling factor and rotation
c         CALL EXF_FILTER_RL( tmp_u, uVecMask, myThid )
c         CALL EXF_FILTER_RL( tmp_v, vVecMask, myThid )

          IF ( exf_output_interp ) THEN
           j = ILNBLNK(uVecFile0)
           WRITE(out_uVecFile,'(2A)') uVecFile0(1:j), '_out'
           IF ( count0.NE.1 )
     &     CALL WRITE_REC_XY_RL(out_uVecFile,tmp_u,1,myIter,myThid)
           CALL WRITE_REC_XY_RL(out_uVecFile,tmp_u,count0,myIter,myThid)
           j = ILNBLNK(vVecFile0)
           WRITE(out_vVecFile,'(2A)') vVecFile0(1:j), '_out'
           IF ( count0.NE.1 )
     &     CALL WRITE_REC_XY_RL(out_vVecFile,tmp_v,1,myIter,myThid)
           CALL WRITE_REC_XY_RL(out_vVecFile,tmp_v,count0,myIter,myThid)
          ENDIF

C-    scaling factor and vector rotation
          IF ( usingCurvilinearGrid .OR. rotateGrid ) THEN
            DO bj = myByLo(myThid),myByHi(myThid)
             DO bi = myBxLo(myThid),myBxHi(myThid)
              DO j = 1,sNy
               DO i = 1,sNx
                 tmp_u(i,j,bi,bj) = uVec_inScale*tmp_u(i,j,bi,bj)
                 tmp_v(i,j,bi,bj) = vVec_inScale*tmp_v(i,j,bi,bj)
               ENDDO
              ENDDO
              DO j = 1,sNy
               DO i = 1,sNx
#ifdef EXF_USE_OLD_VEC_ROTATION
                    x1=xG(i,j,bi,bj)
                    x2=xG(i+1,j,bi,bj)
                    x3=xG(i,j+1,bi,bj)
                    x4=xG(i+1,j+1,bi,bj)
                    IF ((x2-x1).GT.180) x2=x2-360
                    IF ((x1-x2).GT.180) x2=x2+360
                    IF ((x3-x1).GT.180) x3=x3-360
                    IF ((x1-x3).GT.180) x3=x3+360
                    IF ((x4-x1).GT.180) x4=x4-360
                    IF ((x1-x4).GT.180) x4=x4+360
                    y1=yG(i,j,bi,bj)
                    y2=yG(i+1,j,bi,bj)
                    y3=yG(i,j+1,bi,bj)
                    y4=yG(i+1,j+1,bi,bj)
                    dx=0.5*(x3+x4-x1-x2)
                    dx=dx*
     &                  cos(deg2rad*yC(i,j,bi,bj))
                    dy=0.5*(y3+y4-y1-y2)
                    vVec1(i,j,bi,bj)=
     &                  (tmp_u(i,j,bi,bj)*dx+
     &                  tmp_v(i,j,bi,bj)*dy)/
     &                  SQRT(dx*dx+dy*dy)
                    dx=0.5*(x2+x4-x1-x3)
                    dx=dx*
     &                  cos(deg2rad*yC(i,j,bi,bj))
                    dy=0.5*(y2+y4-y1-y3)
                    uVec1(i,j,bi,bj)=
     &                  (tmp_u(i,j,bi,bj)*dx+
     &                  tmp_v(i,j,bi,bj)*dy)/
     &                  SQRT(dx*dx+dy*dy)
#else /* EXF_USE_OLD_VEC_ROTATION */
                 uVec1(i,j,bi,bj) =
     &                      angleCosC(i,j,bi,bj)*tmp_u(i,j,bi,bj)
     &                     +angleSinC(i,j,bi,bj)*tmp_v(i,j,bi,bj)
                 vVec1(i,j,bi,bj) =
     &                     -angleSinC(i,j,bi,bj)*tmp_u(i,j,bi,bj)
     &                     +angleCosC(i,j,bi,bj)*tmp_v(i,j,bi,bj)
#endif /* EXF_USE_OLD_VEC_ROTATION */
               ENDDO
              ENDDO
             ENDDO
            ENDDO
          ELSE
            DO bj = myByLo(myThid),myByHi(myThid)
             DO bi = myBxLo(myThid),myBxHi(myThid)
              DO j = 1,sNy
               DO i = 1,sNx
                 uVec1(i,j,bi,bj) = uVec_inScale*tmp_u(i,j,bi,bj)
                 vVec1(i,j,bi,bj) = vVec_inScale*tmp_v(i,j,bi,bj)
               ENDDO
              ENDDO
             ENDDO
            ENDDO
          ENDIF
C-    apply mask (after scaling factor and rotation)
          CALL EXF_FILTER_RL( uVec1, uVecMask, myThid )
          CALL EXF_FILTER_RL( vVec1, vVecMask, myThid )

C-    end if ( first ) block
        ENDIF

        IF (  first .OR. changed ) THEN
C--   Load and interpolate a new reccord

          CALL exf_SwapFFields( uVec0, uVec1, myThid )
          CALL exf_SwapFFields( vVec0, vVec1, myThid )

          CALL exf_GetYearlyFieldName(
     I         useExfYearlyFields, twoDigitYear, uVecPeriod, year1,
     I         uVecFile,
     O         uVecFile1,
     I         myTime, myIter, myThid )
          CALL exf_GetYearlyFieldName(
     I         useExfYearlyFields, twoDigitYear, vVecPeriod, year1,
     I         vVecFile,
     O         vVecFile1,
     I         myTime, myIter, myThid )
          IF ( exf_debugLev.GE.debLevC ) THEN
            _BEGIN_MASTER(myThid)
            WRITE(msgBuf,'(6A,I10)') 'EXF_SET_UV: ',
     &        'fields "', uVecName, '" & "', vVecName, '", it=', myIter
            CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                          SQUEEZE_RIGHT, myThid )
            j = ILNBLNK(uVecFile1)
            WRITE(msgBuf,'(2A,I6,3A)') 'EXF_SET_UV:   ',
     &      'loading rec=', count1, ' from file: "', uVecFile1(1:j), '"'
            CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                          SQUEEZE_RIGHT, myThid )
            j = ILNBLNK(vVecFile1)
            WRITE(msgBuf,'(2A,I6,3A)') 'EXF_SET_UV:   ',
     &      'loading rec=', count1, ' from file: "', vVecFile1(1:j), '"'
            CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                          SQUEEZE_RIGHT, myThid )
            _END_MASTER(myThid)
          ENDIF

          IF ( uvInterp ) THEN
C-    vector interpolation to (xC,yC) locations
           CALL EXF_INTERP_UV(
     I             uVecFile1, vVecFile1, exf_iprec, count1,
     I             uVec_nlon, uVec_nlat,
     I             uVec_lon0, uVec_lon_inc, uVec_lat0, uVec_lat_inc,
#ifdef EXF_INTERP_USE_DYNALLOC
     O             tmp_u, tmp_v,
#else
     O             tmp_u, tmp_v, bufArr1, bufArr2,
#endif
     I             xC, yC,
     I             u_interp_method, v_interp_method, myIter, myThid )
          ELSE
C-    scalar interpolation to (xC,yC) locations
          CALL EXF_INTERP(
     I             uVecFile1, exf_iprec,
#ifdef EXF_INTERP_USE_DYNALLOC
     O             tmp_u,
#else
     O             tmp_u, bufArr1,
#endif
     I             count1, xC, yC,
     I             uVec_lon0, uVec_lon_inc, uVec_lat0, uVec_lat_inc,
     I             uVec_nlon, uVec_nlat, u_interp_method,
     I             myIter, myThid )
          CALL EXF_INTERP(
     I             vVecFile1, exf_iprec,
#ifdef EXF_INTERP_USE_DYNALLOC
     O             tmp_v,
#else
     O             tmp_v, bufArr2,
#endif
     I             count1, xC, yC,
     I             vVec_lon0, vVec_lon_inc, vVec_lat0, vVec_lat_inc,
     I             vVec_nlon, vVec_nlat, v_interp_method,
     I             myIter, myThid )
          ENDIF

C-    apply mask: Note: done after applying scaling factor and rotation
c         CALL EXF_FILTER_RL( tmp_u, uVecMask, myThid )
c         CALL EXF_FILTER_RL( tmp_v, vVecMask, myThid )

          IF ( exf_output_interp ) THEN
           j = ILNBLNK(uVecFile1)
           WRITE(out_uVecFile,'(2A)') uVecFile1(1:j), '_out'
           CALL WRITE_REC_XY_RL(out_uVecFile,tmp_u,count1,myIter,myThid)
           j = ILNBLNK(vVecFile1)
           WRITE(out_vVecFile,'(2A)') vVecFile1(1:j), '_out'
           CALL WRITE_REC_XY_RL(out_vVecFile,tmp_v,count1,myIter,myThid)
          ENDIF

C-    scaling factor and vector rotation
          IF ( usingCurvilinearGrid .OR. rotateGrid ) THEN
            DO bj = myByLo(myThid),myByHi(myThid)
             DO bi = myBxLo(myThid),myBxHi(myThid)
              DO j = 1,sNy
               DO i = 1,sNx
                 tmp_u(i,j,bi,bj) = uVec_inScale*tmp_u(i,j,bi,bj)
                 tmp_v(i,j,bi,bj) = vVec_inScale*tmp_v(i,j,bi,bj)
               ENDDO
              ENDDO
              DO j = 1,sNy
               DO i = 1,sNx
#ifdef EXF_USE_OLD_VEC_ROTATION
                    x1=xG(i,j,bi,bj)
                    x2=xG(i+1,j,bi,bj)
                    x3=xG(i,j+1,bi,bj)
                    x4=xG(i+1,j+1,bi,bj)
                    IF ((x2-x1).GT.180) x2=x2-360
                    IF ((x1-x2).GT.180) x2=x2+360
                    IF ((x3-x1).GT.180) x3=x3-360
                    IF ((x1-x3).GT.180) x3=x3+360
                    IF ((x4-x1).GT.180) x4=x4-360
                    IF ((x1-x4).GT.180) x4=x4+360
                    y1=yG(i,j,bi,bj)
                    y2=yG(i+1,j,bi,bj)
                    y3=yG(i,j+1,bi,bj)
                    y4=yG(i+1,j+1,bi,bj)
                    dx=0.5*(x3+x4-x1-x2)
                    dx=dx*
     &                  cos(deg2rad*yC(i,j,bi,bj))
                    dy=0.5*(y3+y4-y1-y2)
                    vVec1(i,j,bi,bj)=
     &                  (tmp_u(i,j,bi,bj)*dx+
     &                  tmp_v(i,j,bi,bj)*dy)/
     &                  SQRT(dx*dx+dy*dy)
                    dx=0.5*(x2+x4-x1-x3)
                    dx=dx*
     &                  cos(deg2rad*yC(i,j,bi,bj))
                    dy=0.5*(y2+y4-y1-y3)
                    uVec1(i,j,bi,bj)=
     &                  (tmp_u(i,j,bi,bj)*dx+
     &                  tmp_v(i,j,bi,bj)*dy)/
     &                  SQRT(dx*dx+dy*dy)
#else /* EXF_USE_OLD_VEC_ROTATION */
                 uVec1(i,j,bi,bj) =
     &                      angleCosC(i,j,bi,bj)*tmp_u(i,j,bi,bj)
     &                     +angleSinC(i,j,bi,bj)*tmp_v(i,j,bi,bj)
                 vVec1(i,j,bi,bj) =
     &                     -angleSinC(i,j,bi,bj)*tmp_u(i,j,bi,bj)
     &                     +angleCosC(i,j,bi,bj)*tmp_v(i,j,bi,bj)
#endif /* EXF_USE_OLD_VEC_ROTATION */
               ENDDO
              ENDDO
             ENDDO
            ENDDO
          ELSE
            DO bj = myByLo(myThid),myByHi(myThid)
             DO bi = myBxLo(myThid),myBxHi(myThid)
              DO j = 1,sNy
               DO i = 1,sNx
                 uVec1(i,j,bi,bj) = uVec_inScale*tmp_u(i,j,bi,bj)
                 vVec1(i,j,bi,bj) = vVec_inScale*tmp_v(i,j,bi,bj)
               ENDDO
              ENDDO
             ENDDO
            ENDDO
          ENDIF
C-    apply mask (after scaling factor and rotation)
          CALL EXF_FILTER_RL( uVec1, uVecMask, myThid )
          CALL EXF_FILTER_RL( vVec1, vVecMask, myThid )

C-    end if ( first or changed ) block
        ENDIF

C--   Interpolate linearly onto the current time.
        DO bj = myByLo(myThid),myByHi(myThid)
          DO bi = myBxLo(myThid),myBxHi(myThid)
            DO j = 1,sNy
              DO i = 1,sNx
                uVec(i,j,bi,bj) = fac * uVec0(i,j,bi,bj)
     &               + (exf_one - fac)* uVec1(i,j,bi,bj)
                vVec(i,j,bi,bj) = fac * vVec0(i,j,bi,bj)
     &               + (exf_one - fac)* vVec1(i,j,bi,bj)
              ENDDO
            ENDDO
          ENDDO
        ENDDO

      ELSE
C     case no-interpolation
C     or ( .NOT.usingCurvilinearGrid & .NOT.rotateGrid & .NOT.uvInterp )
#else  /* USE_EXF_INTERPOLATION */
      IF ( .TRUE. ) THEN
#endif /* USE_EXF_INTERPOLATION */

        CALL EXF_SET_FLD(
     I      uVecName, uVecFile, uVecMask,
     I      uVecStartTime, uVecPeriod, uVecRepeatCycle,
     I      uVec_inScale, uVec_remove_intercept, uVec_remove_slope,
     U      uVec, uVec0, uVec1,
#ifdef USE_EXF_INTERPOLATION
     I      uVec_lon0, uVec_lon_inc, uVec_lat0, uVec_lat_inc,
     I      uVec_nlon, uVec_nlat, xC, yC, u_interp_method,
#endif /* USE_EXF_INTERPOLATION */
     I      myTime, myIter, myThid )

        CALL EXF_SET_FLD(
     I      vVecName, vVecFile, vVecMask,
     I      vVecStartTime, vVecPeriod, vVecRepeatCycle,
     I      vVec_inScale, vVec_remove_intercept, vVec_remove_slope,
     U      vVec, vVec0, vVec1,
#ifdef USE_EXF_INTERPOLATION
     I      vVec_lon0, vVec_lon_inc, vVec_lat0, vVec_lat_inc,
     I      vVec_nlon, vVec_nlat, xC, yC, v_interp_method,
#endif /* USE_EXF_INTERPOLATION */
     I      myTime, myIter, myThid )

C-    vector rotation
          IF ( rotateStressOnAgrid ) THEN
            DO bj = myByLo(myThid),myByHi(myThid)
             DO bi = myBxLo(myThid),myBxHi(myThid)
              DO j = 1,sNy
               DO i = 1,sNx
                 tmp_u(i,j,bi,bj) = uVec(i,j,bi,bj)
                 tmp_v(i,j,bi,bj) = vVec(i,j,bi,bj)
               ENDDO
              ENDDO
             ENDDO
            ENDDO
            DO bj = myByLo(myThid),myByHi(myThid)
             DO bi = myBxLo(myThid),myBxHi(myThid)
              DO j = 1,sNy
               DO i = 1,sNx
                 uVec(i,j,bi,bj) =
     &                      angleCosC(i,j,bi,bj)*tmp_u(i,j,bi,bj)
     &                     +angleSinC(i,j,bi,bj)*tmp_v(i,j,bi,bj)
                 vVec(i,j,bi,bj) =
     &                     -angleSinC(i,j,bi,bj)*tmp_u(i,j,bi,bj)
     &                     +angleCosC(i,j,bi,bj)*tmp_v(i,j,bi,bj)
               ENDDO
              ENDDO
             ENDDO
            ENDDO
          ENDIF

      ENDIF

      RETURN
      END

#include "LAND_OPTIONS.h"

CBOP
C     !ROUTINE: LAND_DO_DIAGS
C     !INTERFACE:
      SUBROUTINE LAND_DO_DIAGS(
     I                land_frc, bi,bj, myTime, myIter, myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R LAND_DO_DIAGS
C     | o Calculate Land diagnostics
C     *==========================================================*
C     | note: snap-shot output have been moved to a better place
C     |       and are now written from LAND_OUTPUT
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     == Global variables ===
C-- size for MITgcm & Land package :
#include "LAND_SIZE.h"

#include "EEPARAMS.h"
#include "PARAMS.h"
#include "LAND_PARAMS.h"
#include "LAND_VARS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     land_frc :: land fraction [0-1]
C     bi,bj    :: Tile index
C     myTime   :: Current time of simulation ( s )
C     myIter   :: Current iteration number in simulation
C     myThid   :: Number of this instance of the routine
      _RS land_frc(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      INTEGER bi, bj, myIter, myThid
      _RL     myTime
CEOP

#ifdef ALLOW_LAND
C     == Local Variables ==

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#ifdef ALLOW_DIAGNOSTICS

      IF ( useDiagnostics ) THEN

        CALL DIAGNOSTICS_FILL(land_runOff, 'RUNOFF  ',0,1,
     &                                                1,bi,bj,myThid)
        CALL DIAGNOSTICS_FILL(land_enRnOf, 'EnRunOff',0,1,
     &                                                1,bi,bj,myThid)
        CALL DIAGNOSTICS_FILL(land_HeatFlx,'landHFlx',0,1,
     &                                                1,bi,bj,myThid)
        CALL DIAGNOSTICS_FILL(land_Pr_m_Ev,'landPmE ',0,1,
     &                                                1,bi,bj,myThid)
        CALL DIAGNOSTICS_FILL(land_EnWFlux,'ldEnFxPr',0,1,
     &                                                1,bi,bj,myThid)

      ENDIF

#endif /* ALLOW_DIAGNOSTICS */

#endif /* ALLOW_LAND */

      RETURN
      END

#include "BBL_OPTIONS.h"

CBOP
C     !ROUTINE: BBL_CALC_RHO
C     !INTERFACE:
      SUBROUTINE BBL_CALC_RHO(
     I                tFld, sFld,
     O                rhoLoc,
     I                k, bi, bj, myTime, myIter, myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE BBL_CALC_RHO
C     | o Calculates [rho(S,T,z)-rhoConst] of a 2-D slice
C     |     filling land-points with BBL density.
C     |   pkg/bbl requires in-situ bbl density for depths equal to
C     |     and deeper than the bbl. To reduce computation and
C     |     storage requirement, these densities are stored in the
C     |     dry grid boxes of rhoInSitu:
C     |   Top cell to kLowC computes rhoLoc at level k based on
C     |     tFld(k) and sFld(k). This is identical to FIND_RHO_2D.
C     |   kLowC+1 to Nr computes rhoLoc at level k-1 based on
C     |     bbl_theta and bbl_salt.
C     |   There is one level missing, bbl density at depth Nr,
C     |     which is intead stored in bbl_rho_nr.
C     *==========================================================*

C     \ev

C     !USES:
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "BBL.h"

C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
C     tFld      :: Pot.Temperature (3-D array)
C     sFld      :: Salinity (3-D array)
C     rhoLoc    :: In-situ density [kg/m3] (2-D array) computed at z=rC ;
C     k         :: current vertical index
C     bi,bj     :: Tile indices
C     myTime    :: Current time in simulation
C     myIter    :: Current time-step number
C     myThid    :: my Thread Id number
      _RL     tFld     (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      _RL     sFld     (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      _RL     rhoLoc   (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      INTEGER k, bi, bj
      _RL     myTime
      INTEGER myIter, myThid
CEOP

C     !LOCAL VARIABLES:
C     === Local variables ===
C     msgBuf     :: Informational/error message buffer
c     CHARACTER*(MAX_LEN_MBUF) msgBuf
      _RL     rBBL     (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER i,j,kl

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C-    Compute rhoLoc at level k based on tFld(k) and sFld(k).
      CALL FIND_RHO_2D(
     I     1-OLx, sNx+OLx, 1-OLy, sNy+OLy, k,
     I     tFld(1-OLx,1-OLy,k,bi,bj),
     I     sFld(1-OLx,1-OLy,k,bi,bj),
     O     rhoLoc(1-OLx,1-OLy,k,bi,bj),
     I     k, bi, bj, myThid )

C-    Compute rBBL at level k-1 based on bbl_theta and bbl_salt.
      kl = MAX(k-1,1)
      CALL FIND_RHO_2D(
     I     1-OLx, sNx+OLx, 1-OLy, sNy+OLy, kl,
     I     bbl_theta(1-OLx,1-OLy,bi,bj),
     I     bbl_salt(1-OLx,1-OLy,bi,bj),
     O     rBBL,
     I     kl, bi, bj, myThid )

C-    For k > kLowC replace rhoLoc with rBBL
      DO j=1-OLy,sNy+OLy
       DO i=1-OLx,sNx+OLx
        IF ( k .GT. kLowC(i,j,bi,bj) )
     &       rhoLoc(i,j,k,bi,bj) = rBBL(i,j)
       ENDDO
      ENDDO

C-    Compute bbl_rho_nr at level Nr based on bbl_theta and bbl_salt.
      IF ( k .EQ. Nr ) THEN
       CALL FIND_RHO_2D(
     I      1-OLx, sNx+OLx, 1-OLy, sNy+OLy, Nr,
     I      bbl_theta(1-OLx,1-OLy,bi,bj),
     I      bbl_salt(1-OLx,1-OLy,bi,bj),
     O      bbl_rho_nr(1-OLx,1-OLy,bi,bj),
     I      Nr, bi, bj, myThid )
      ENDIF

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      RETURN
      END

#include "EXF_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

CBOP
C     !ROUTINE: EXF_INIT_FLD
C     !INTERFACE:
      SUBROUTINE EXF_INIT_FLD (
     I     fldName, fldFile, fldMask,
     I     fldPeriod, fld_inScale, fldConst,
     U     fldArr, fld0, fld1,
#ifdef USE_EXF_INTERPOLATION
     I     fld_lon0, fld_lon_inc, fld_lat0, fld_lat_inc,
     I     fld_nlon, fld_nlat, fld_xout, fld_yout, interp_method,
#endif
     I     myThid )

C !DESCRIPTION: \bv
C  *=================================================================*
C  | SUBROUTINE EXF_INIT_FLD
C  *=================================================================*
C  |  started: Ralf.Giering@FastOpt.de 25-Mai-2000
C  |  changed: heimbach@mit.edu 10-Jan-2002
C  |           heimbach@mit.edu: totally re-organized exf_set_...
C  |           replaced all routines by one generic routine
C  *=================================================================*
C \ev

C !USES:
      IMPLICIT NONE
C     == global variables ==
#include "EEPARAMS.h"
#include "SIZE.h"
#include "EXF_PARAM.h"
#include "EXF_INTERP_SIZE.h"

C !INPUT/OUTPUT PARAMETERS:
C     fldName        :: field short name (to print mesg)
C     fldFile        :: file-name for this field
C     fldPeriod      :: time period (in sec) between 2 reccords
C     fld_inScale    :: input field scaling factor
C     fldConst       :: uniform default field value
C     fldArr         :: field array containing current time values
C     fld0           :: field array holding previous reccord
C     fld1           :: field array holding next     reccord
C     myThid         :: My Thread Id number
      CHARACTER*(*) fldName
      CHARACTER*(128) fldFile
      CHARACTER*1 fldMask
      _RL fldPeriod, fld_inScale, fldConst
      _RL fldArr(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL fld0  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL fld1  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      INTEGER myThid

#ifdef USE_EXF_INTERPOLATION
C     fld_lon0, fld_lat0   :: longitude and latitude of SouthWest
C                             corner of global input grid
C     fld_nlon, fld_nlat   :: input x-grid and y-grid size
C     fld_lon_inc          :: scalar x-grid increment
C     fld_lat_inc          :: vector y-grid increments
C     fld_xout, fld_yout   :: coordinates for output grid
      _RL fld_lon0, fld_lon_inc
      _RL fld_lat0, fld_lat_inc(MAX_LAT_INC)
      INTEGER fld_nlon, fld_nlat
      _RS fld_xout  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RS fld_yout  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      INTEGER interp_method
#endif /* USE_EXF_INTERPOLATION */

C !FUNCTIONS:
      INTEGER  ILNBLNK
      EXTERNAL ILNBLNK

C !LOCAL VARIABLES:
C     msgBuf     :: Informational/error message buffer
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      INTEGER bi, bj, i, j, count
#ifdef USE_EXF_INTERPOLATION
# ifndef EXF_INTERP_USE_DYNALLOC
      _RL     bufArr( exf_interp_bufferSize )
# endif
#endif /* USE_EXF_INTERPOLATION */
CEOP

      DO bj = myByLo(myThid), myByHi(myThid)
        DO bi = myBxLo(myThid), myBxHi(myThid)
          DO j = 1-OLy, sNy+OLy
            DO i = 1-OLx, sNx+OLx
              fldArr(i,j,bi,bj)  = fldConst
              fld0(i,j,bi,bj)    = fldConst
              fld1(i,j,bi,bj)    = fldConst
            ENDDO
          ENDDO
        ENDDO
      ENDDO

      IF ( fldFile .NE. ' ' .AND. fldPeriod .EQ. 0. ) THEN
         count = 1
         IF ( exf_debugLev.GE.debLevC ) THEN
           _BEGIN_MASTER(myThid)
           j = ILNBLNK(fldFile)
           WRITE(msgBuf,'(4A,I3,2A)') 'EXF_INIT_FLD: ',
     &         'field "', fldName,
     &         '", loading rec=', count, ' from: ', fldFile(1:j)
           CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                         SQUEEZE_RIGHT, myThid )
           _END_MASTER(myThid)
         ENDIF

#ifdef USE_EXF_INTERPOLATION
         IF ( interp_method.GE.1 ) THEN
              CALL EXF_INTERP(
     I             fldFile, exf_iprec,
#ifdef EXF_INTERP_USE_DYNALLOC
     O             fldArr,
#else
     O             fldArr, bufArr,
#endif
     I             count, fld_xout, fld_yout,
     I             fld_lon0, fld_lon_inc, fld_lat0, fld_lat_inc,
     I             fld_nlon, fld_nlat, interp_method, 0, myThid )
         ELSE
#endif /* USE_EXF_INTERPOLATION */
            CALL READ_REC_3D_RL( fldFile, exf_iprec, 1,
     &                           fldArr, count, 0, myThid )
#ifdef USE_EXF_INTERPOLATION
         ENDIF
#endif /* USE_EXF_INTERPOLATION */

C-    apply mask
         CALL EXF_FILTER_RL( fldArr, fldMask, myThid )

C     Loop over tiles and scale fldArr
         DO bj = myByLo(myThid),myByHi(myThid)
          DO bi = myBxLo(myThid),myBxHi(myThid)
           DO j = 1,sNy
            DO i = 1,sNx
              fldArr(i,j,bi,bj) = fld_inScale*fldArr(i,j,bi,bj)
            ENDDO
           ENDDO
          ENDDO
         ENDDO

      ENDIF

      RETURN
      END

#include "SHELFICE_OPTIONS.h"

      subroutine shelfice_cost_accumulate( myThid )
C     *==========================================================*
C     | subroutine shelfice_cost_accumulate                      |
C     | o accumulate mean state for cost evalualtion             |
C     *==========================================================*
C     |                                                          |
C     *==========================================================*
      IMPLICIT NONE

C     == Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "DYNVARS.h"
#include "GRID.h"
#include "SHELFICE.h"
#include "SHELFICE_COST.h"

C     == Routine arguments ==
C     myThid - Thread number for this instance of the routine.
      integer myThid

#ifdef ALLOW_COST
C     == Local variables
      integer bi, bj
      integer i, j

C--   Calculate cost function on tile of this instance
      do bj = myByLo(myThid), myByHi(myThid)
       do bi = myBxLo(myThid), myBxHi(myThid)
        do j=1,sNy
         do i=1,sNx
          cMeanSHIforT(i,j,bi,bj) = cMeanSHIforT(i,j,bi,bj)
     &         + shelficeHeatFlux(i,j,bi,bj)*deltaTClock
          cMeanSHIforS(i,j,bi,bj) = cMeanSHIforS(i,j,bi,bj)
     &         + shelficeFreshWaterFlux(i,j,bi,bj)*deltaTClock
         enddo
        enddo
       enddo
      enddo

#endif /* ALLOW_COST */

      RETURN
      END

#include "ctrparam.h"
#include "ATM2D_OPTIONS.h"

C     !INTERFACE:
      SUBROUTINE READ_ATMOS(inMonth,myThid )
C     *==========================================================*
C     | o Takes atmos data on atmos grid, converts to ocean      |
C     |   model units, and combines the polar cap atmos cell     |
C     |   with its neighbor to the north or south.               |
C     *==========================================================*
        IMPLICIT NONE

C     === Global Atmos/Ocean/Seaice Interface Variables ===
#include "ATMSIZE.h"
#include "AGRID.h"
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "ATM2D_VARS.h"

      _RL secDay1000
      PARAMETER (secDay1000= 86400000.D0)

C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
C     inMonth - current month (or forcing period)
C     myThid - Thread no. that called this routine.
      INTEGER inMonth
      INTEGER myThid

C     LOCAL VARIABLES:
      _RL a1,a2
      INTEGER j_atm

C Keep track of (raw) atmos variables for diagnostics
      DO j_atm=1,jm0
        sum_tauu_ta(j_atm,inMonth)= sum_tauu_ta(j_atm,inMonth) +
     &                           tauu(j_atm)*dtatmo
        sum_tauv_ta(j_atm,inMonth)= sum_tauv_ta(j_atm,inMonth) +
     &                           tauv(j_atm)*dtatmo
        sum_wsocean_ta(j_atm,inMonth)= sum_wsocean_ta(j_atm,inMonth) +
     &                           wsocean(j_atm)*dtatmo
        sum_ps4ocean_ta(j_atm,inMonth)= sum_ps4ocean_ta(j_atm,inMonth) +
     &                           ps4ocean(j_atm)*dtatmo
      ENDDO

C
C put atmospheric data onto local arrays and convert units for ocean model
C
      DO j_atm=1,jm0

        atm_tauu(j_atm) = tauu(j_atm)
        atm_tauv(j_atm) = tauv(j_atm)
        atm_tair(j_atm) = tempr(j_atm)
        atm_precip(j_atm)    = -precip(j_atm)/secDay1000
        atm_runoff(j_atm)    = -arunoff(j_atm)/secDay1000
        atm_evap_ice(j_atm)  = -evai(j_atm)/secDay1000
        atm_evap_ocn(j_atm)  = -evao(j_atm)/secDay1000
        atm_qnet_ice(j_atm)  = -hfluxi(j_atm)
        atm_qnet_ocn(j_atm)  = -hfluxo(j_atm)
        atm_dFdt_ice(j_atm)  = -dhfidtg(j_atm)
        atm_dFdt_ocn(j_atm)  = -dhfodtg(j_atm)
C       Ice feels evap from model, no change with temperature
        atm_dLdt_ice(j_atm)  = 0. _d 0  ! -devidtg(j_atm)/secDay1000
        atm_dLdt_ocn(j_atm)  = -devodtg(j_atm)/secDay1000
        atm_dFdt_iceq(j_atm) = -dhfidtgeq(j_atm)
        atm_dFdt_ocnq(j_atm) = -dhfodtgeq(j_atm)
        atm_dLdt_iceq(j_atm) = 0. _d 0  ! -devidtgeq(j_atm)/secDay1000
        atm_dLdt_ocnq(j_atm) = -devodtgeq(j_atm)/secDay1000
        atm_solarinc(j_atm)  = solarinc_ice(j_atm)
        atm_solar_ocn(j_atm) = solarnet_ocean(j_atm)
        atm_solar_ice(j_atm) = solarnet_ice(j_atm)
        atm_windspeed(j_atm) = wsocean(j_atm)
        atm_slp(j_atm) = ps4ocean(j_atm)*1013.25/984.0 - 1013.25
        atm_pco2(j_atm) = co24ocean(j_atm)

      ENDDO

      IF (cflan(2).NE.1. _d 0)
     &          CALL COMBINE_ENDS(endwgt1,endwgt2,1,2,rsumwgt)
      IF (cflan(jm0-1).NE.1. _d 0)
     &          CALL COMBINE_ENDS(endwgt1,endwgt2,jm0,jm0-1,rsumwgt)

      RETURN
      END

C--------------------------------------------------------------------------
#include "ctrparam.h"
#include "ATM2D_OPTIONS.h"


      SUBROUTINE COMBINE_ENDS(a1,a2,ind1,ind2,rsuma)
C     *==========================================================*
C     | Subroutine used to combine the atmos model data points at|
C     | the poles with their neighboring value, area weighted.   |
C     | The calcuated new value is overwritten into ind2.        |
C     *==========================================================*
      IMPLICIT NONE


C     === Global Atmos/Ocean/Seaice Interface Variables ===
#include "ATMSIZE.h"
#include "AGRID.h"
#include "SIZE.h"
#include "EEPARAMS.h"
#include "ATM2D_VARS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
C     a1 - weighting of first index
C     a2 - weighting of second index
C     ind1 - first index into atmos data array
C     ind2 - first index into atmos data array
C     rsuma - recip of sum of ind1+ind2
      _RL     a1
      _RL     a2
      INTEGER ind1
      INTEGER ind2
      _RL  rsuma

C     LOCAL VARIABLES:

C      atm_tauu(ind2)= (a1*atm_tauu(ind1) + a2*atm_tauu(ind2))*rsuma
C      atm_tauv(ind2)= (a1*atm_tauv(ind1) + a2*atm_tauv(ind2))*rsuma
C Tau variables not combined - zero at atm pole point

      atm_tair(ind2)= (a1*atm_tair(ind1) + a2*atm_tair(ind2))*rsuma
      atm_precip(ind2)= (a1*atm_precip(ind1) +
     &                   a2*atm_precip(ind2))*rsuma
      atm_runoff(ind2)= atm_runoff(ind1)+ atm_runoff(ind2)
      atm_evap_ice(ind2)= (a1*atm_evap_ice(ind1) +
     &                     a2*atm_evap_ice(ind2))*rsuma
      atm_evap_ocn(ind2)= (a1*atm_evap_ocn(ind1) +
     &                     a2*atm_evap_ocn(ind2))*rsuma
      atm_qnet_ice(ind2)= (a1*atm_qnet_ice(ind1)+
     &                     a2*atm_qnet_ice(ind2))*rsuma
      atm_qnet_ocn(ind2)= (a1*atm_qnet_ocn(ind1) +
     &                     a2*atm_qnet_ocn(ind2))*rsuma
      atm_dFdt_ice(ind2)= (a1*atm_dFdt_ice(ind1)+
     &                     a2*atm_dFdt_ice(ind2))*rsuma
      atm_dFdt_ocn(ind2)= (a1*atm_dFdt_ocn(ind1)+
     &                     a2*atm_dFdt_ocn(ind2))*rsuma
      atm_dLdt_ice(ind2)= (a1*atm_dLdt_ice(ind1)+
     &                     a2*atm_dLdt_ice(ind2))*rsuma
      atm_dLdt_ocn(ind2)= (a1*atm_dLdt_ocn(ind1)+
     &                     a2*atm_dLdt_ocn(ind2))*rsuma
      atm_dFdt_iceq(ind2)= (a1*atm_dFdt_iceq(ind1)+
     &                      a2*atm_dFdt_iceq(ind2))*rsuma
      atm_dFdt_ocnq(ind2)= (a1*atm_dFdt_ocnq(ind1)+
     &                      a2*atm_dFdt_ocnq(ind2))*rsuma
      atm_dLdt_iceq(ind2)= (a1*atm_dLdt_iceq(ind1)+
     &                      a2*atm_dLdt_iceq(ind2))*rsuma
      atm_dLdt_ocnq(ind2)= (a1*atm_dLdt_ocnq(ind1)+
     &                      a2*atm_dLdt_ocnq(ind2))*rsuma
      atm_solarinc(ind2)= (a1*atm_solarinc(ind1) +
     &                     a2*atm_solarinc(ind2))*rsuma
      atm_solar_ocn(ind2)= (a1*atm_solar_ocn(ind1)+
     &                       a2*atm_solar_ocn(ind2))*rsuma
      atm_solar_ice(ind2)= (a1*atm_solar_ice(ind1)+
     &                     a2*atm_solar_ice(ind2))*rsuma
      atm_windspeed(ind2)= (a1*atm_windspeed(ind1) +
     &                      a2*atm_windspeed(ind2))*rsuma
      atm_slp(ind2)= (a1*atm_slp(ind1) + a2*atm_slp(ind2))*rsuma
      atm_pco2(ind2)= (a1*atm_pco2(ind1)+a2*atm_pco2(ind2))*rsuma

      RETURN
      END

#include "OPPS_OPTIONS.h"

CBOP
C     !ROUTINE: OPPS_INTERFACE
C     !INTERFACE:
      SUBROUTINE OPPS_INTERFACE(
     I       bi, bj, iMin, iMax, jMin, jMax,
     I       myTime, myIter, myThid )
C     !DESCRIPTION: \bv
C     *================================================================*
C     | SUBROUTINE OPPS_INTERFACE                                      |
C     | o Driver for OPPS mixing scheme that can be called             |
C     |   instead of convective_adjustment.                            |
C     |   Reference: Paluszkiewicz+Romea, Dynamics of Atmospheres and  |
C     |   Oceans (1997) 26, pp. 95-130                                 |
C     | o Support for passive tracers by joint treatment of            |
C     |   active (theta, salt) and passive tracers. The array          |
C     |   tracerLoc(Nr,2+PTRACERS_num) contains                        |
C     |   theta    = tracerLoc(:,1),                                   |
C     |   salt     = tracerLoc(:,2), and                               |
C     |   ptracers = tracerLoc(:,3:PTRACERS_num+2). For this to        |
C     |   work, the routine opps_calc had to be modified               |
C     |   considerably. opps_calc is based on nlopps.F but there is    |
C     |   is little left of the original (see opps_calc.F)             |
C     *================================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     == Global data ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "DYNVARS.h"
#include "GRID.h"
#include "OPPS.h"
#ifdef ALLOW_PTRACERS
#include "PTRACERS_SIZE.h"
#include "PTRACERS_PARAMS.h"
#include "PTRACERS_FIELDS.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     bi, bj :: tile indices
C     iMin, iMax, jMin, jMax :: Loop range
C     myTime :: Current time in simulation
C     myIter :: Current iteration in simulation
C     myThid :: Thread number of this instance of S/R CONVECT
      INTEGER bi, bj, iMin, iMax, jMin, jMax
      _RL myTime
      INTEGER myIter
      INTEGER myThid

#ifdef ALLOW_OPPS_SNAPSHOT
C     !FUNCTIONS:
      LOGICAL  DIFFERENT_MULTIPLE
      EXTERNAL DIFFERENT_MULTIPLE
#endif

C     !LOCAL VARIABLES:
C     == Local variables ==
C     OPPSconvectCount :: counter for freqency of convection events
C     msgBuf           :: Informational/error message buffer
      INTEGER nTracer
#ifdef ALLOW_PTRACERS
      PARAMETER( nTracer = 2+PTRACERS_num )
      INTEGER itr
#else /* not ALLOW_PTRACERS */
      PARAMETER( nTracer = 2 )
#endif /* ALLOW_PTRACERS */
      INTEGER I, J, K, kMax
      INTEGER nTracerInUse
      _RL tMin, tMax, sMin, sMax
      _RL tMinNew, tMaxNew, sMinNew, sMaxNew
      _RL wVelLoc(Nr)
      _RL tracerLoc(Nr,nTracer)
      _RL OPPSconvectCount(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      CHARACTER*(MAX_LEN_MBUF) msgBuf
#ifdef ALLOW_OPPS_SNAPSHOT
      CHARACTER*(10) suff
#endif
CEOP

C     initialization
#ifdef ALLOW_PTRACERS
      nTracerInUse = 2+PTRACERS_numInUse
#else
      nTracerInUse = 2
#endif /* ALLOW_PTRACERS */
      tMax    = -1. _d 23
      tMin    =  1. _d 23
      sMax    = -1. _d 23
      sMin    =  1. _d 23
      tMaxNew = -1. _d 23
      tMinNew =  1. _d 23
      sMaxNew = -1. _d 23
      sMinNew =  1. _d 23
      tMinNew =  1. _d 23
C     Initialize convection counter
      DO K=1,Nr
       DO J=1-OLy,sNy+OLy
        DO I=1-OLx,sNx+OLx
         OPPSconvectCount(I,J,K) = 0. _d 0
        ENDDO
       ENDDO
      ENDDO

      DO J=jMin,jMax
       DO I=iMin,iMax
        IF ( kSurfC(I,J,bi,bj) .LE. Nr ) THEN
         IF ( useGCMwVel ) THEN
          DO K=1,Nr
           tracerLoc(K,1) = theta(I,J,K,bi,bj)
           tracerLoc(K,2)  = salt(I,J,K,bi,bj)
           wVelLoc(K)  = wVel(I,J,K,bi,bj)
          ENDDO
         ELSE
          DO K=1,Nr
           tracerLoc(K,1) = theta(I,J,K,bi,bj)
           tracerLoc(K,2)  = salt(I,J,K,bi,bj)
           wVelLoc(K)  = - VERTICAL_VELOCITY
          ENDDO
         ENDIF
#ifdef ALLOW_PTRACERS
         DO itr = 3, nTracerInUse
          DO K=1,Nr
           tracerLoc(K,itr) = ptracer(I,J,K,bi,bj,itr-2)
          ENDDO
         ENDDO
#endif /* ALLOW_PTRACERS */
#ifdef ALLOW_OPPS_DEBUG
         IF ( OPPSdebugLevel .GE. debLevA ) THEN
C     determine range of temperature and salinity
          tMax = -1. d 23
          tMin =  1. d 23
          sMax = -1. d 23
          sMin =  1. d 23
          DO K=1,Nr
           tMax = MAX(tracerLoc(K,1),tMax)
           tMin = MAX(tracerLoc(K,1),tMin)
           sMax = MAX(tracerLoc(K,2),sMax)
           sMin = MAX(tracerLoc(K,2),sMin)
          ENDDO
         ENDIF
#endif /* ALLOW_OPPS_DEBUG */
         kMax = kLowC(I,J,bi,bj)
         CALL OPPS_CALC(
     U        tracerLoc,
     O        OPPSconvectCount,
     I        wVelLoc, kMax, nTracer, nTracerInUse,
     I        I, J, bi, bj, myTime, myIter, myThid )
#ifdef ALLOW_OPPS_DEBUG
         IF ( OPPSdebugLevel .GE. debLevA ) THEN
C     determine range of temperature and salinity
          tMaxNew = -1. d 23
          tMinNew =  1. d 23
          sMaxNew = -1. d 23
          sMinNew =  1. d 23
          DO K=1,Nr
           tMaxNew = MAX(tracerLoc(K,1),tMaxNew)
           tMinNew = MAX(tracerLoc(K,1),tMinNew)
           sMaxNew = MAX(tracerLoc(K,2),sMaxNew)
           sMinNew = MAX(tracerLoc(K,2),sMinNew)
          ENDDO
          IF ( tMaxNew.GT.tMax .OR. tMinNew.LT.tMin .OR.
     &         sMaxNew.GT.sMax .OR. sMinNew.LT.sMIN ) THEN
           WRITE(msgBuf,'(A,A)') 'OPPS_INTERFACE: theta or S-range is',
     &          ' larger than before mixing'
           CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &          SQUEEZE_RIGHT , myThid )
           WRITE(msgBuf,'(A,2I5)') '                for (i,j) = ', I,J
           CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &          SQUEEZE_RIGHT , myThid )
          ENDIF
         ENDIF
#endif /* ALLOW_OPPS_DEBUG */
         DO K=1,Nr
          theta(I,J,K,bi,bj) = tracerLoc(K,1)
          salt(I,J,K,bi,bj)  = tracerLoc(K,2)
         ENDDO
#ifdef ALLOW_PTRACERS
         DO itr = 3, nTracerInUse
          DO K=1,Nr
           ptracer(I,J,K,bi,bj,itr-2) = tracerLoc(K,itr)
          ENDDO
         ENDDO
#endif /* ALLOW_PTRACERS */
        ENDIF
       ENDDO
      ENDDO

#ifdef ALLOW_DIAGNOSTICS
      IF ( useDiagnostics ) THEN
       CALL DIAGNOSTICS_FILL( OPPSconvectCount, 'OPPScadj',
     &                        0 , Nr, 2, bi, bj, myThid )
      ENDIF
#endif /* ALLOW_DIAGNOSTICS */

#ifdef ALLOW_OPPS_SNAPSHOT
      IF ( DIFFERENT_MULTIPLE( dumpFreq, myTime, deltaTClock ) ) THEN
c      IF (OPPSwriteState) THEN
C       Write each snap-shot as a new file
C- Caution: This might not work in multi-threaded with multiple fields to write
        WRITE(suff,'(I10.10)') myIter
        CALL WRITE_LOCAL_RL( 'OPPSconv.', suff, Nr, OPPSconvectCount,
     &                       bi, bj, 1, myIter, myThid )
c      ENDIF
      ENDIF
#endif /* ALLOW_OPPS_SNAPSHOT */

      RETURN
      END

!=======================================================================
      integer function mitcplr_match_comp( carg )
      implicit none
! Predefined constants/arrays
#include "CPLR_SIG.h"
! Arguments
      character*(*) carg
! Local
      integer j,jmatch
!     ------------------------------------------------------------------

      if ( carg .EQ. coupler_Name ) then
       mitcplr_match_comp=-1
       stop 'mitcplr_match_comp: I should not reach this point'
      else

! Search through list of components
      jmatch=0
      do j=1,num_components
       if ( carg .EQ. component_List(j) ) then
        if ( jmatch .NE. 0 ) then
         if (DEBUG) write(0,*) 'mitcplr_match_comp: String arg = ',carg
         stop 'mitcplr_match_comp: More than one match to string'
        else
         jmatch=j
        endif
       endif
      enddo

! If no matches, create entry in list
      if ( jmatch .EQ. 0) then
       if ( num_components .EQ. MAX_COMPONENTS ) then
        stop 'mitcplr_match_comp: Too many components types entered'
       endif
       num_components=num_components+1
       jmatch=num_components
       call mitcplr_initcomp( jmatch, carg )
      endif

! Return index within list
      mitcplr_match_comp=jmatch

      endif

!     ------------------------------------------------------------------
      return
      end
!=======================================================================

#include "OBSFIT_OPTIONS.h"
#include "AD_CONFIG.h"

CBOP
C     !ROUTINE: OBSFIT_INIT_FIXED

C     !INTERFACE:
      SUBROUTINE OBSFIT_INIT_FIXED( myThid )

C     !DESCRIPTION:
C     ==================================================================
C     | Initialize ObsFit variables that are kept fixed during the run
C     ==================================================================

C     !USES:
      IMPLICIT NONE
C     == Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "DYNVARS.h"
#ifdef ALLOW_CAL
#include "cal.h"
#endif
#ifdef ALLOW_OBSFIT
# include "OBSFIT_SIZE.h"
# include "OBSFIT.h"
# include "netcdf.inc"
#endif

C     !INPUT PARAMETERS:
C     myThid :: my thread ID number
      INTEGER myThid
CEOP

#ifdef ALLOW_OBSFIT
C     !FUNCTIONS:
      INTEGER  ILNBLNK
      EXTERNAL ILNBLNK
      INTEGER  MDS_RECLEN
      EXTERNAL MDS_RECLEN

C     !LOCAL VARIABLES:
C     i,j,bi,bj    :: loop indices
C     iG,jG        :: global indices
C     diffsecs     :: absolute time
      INTEGER i,j,k,l,bi,bj,iG,jG
      INTEGER obs_num, num_file, sampleNo_tile
      INTEGER ic, ip, iq, kLev, iINTERP
      INTEGER chunkObs, chunk
      INTEGER iUnit
      INTEGER stopObsfit, stopGenericGrid
      INTEGER loopThroughSamples, weighSamples, readDelT
      INTEGER obsIsInRunTime, sampleIsInTile, sampleIsValid
      INTEGER fid, dimid, varID(2)
      INTEGER varID0, varID1a, varID1b, varID1c
      INTEGER varID2, varID3a, varID3b, varID4, varID5
      INTEGER varID6, varID7
      INTEGER varID_intp1, varID_intp2, varID_intp11, varID_intp22
      INTEGER varID_intp3, varID_intp4, varID_intp5, varID_intp6
      INTEGER tmpdate(4), tmpdiff(4)
      INTEGER tmp_type2(1000), type_cur
      INTEGER sample_i, sample_j, sample_k1, sample_k2
      INTEGER np_cur
      INTEGER ObsNo_valid, ObsNo_div1000
      INTEGER sample_cnt
      INTEGER hh, obsNo_hh, obs_np_max
      INTEGER ntype_ssh,ntype_other, obs_is_ssh_loc
      INTEGER vec_start, vec_count
      INTEGER vec_start2(2), vec_count2(2)
      INTEGER IL, JL, err, nerr
      _RL tmpyymmdd(1000),tmphhmmss(1000),diffsecs
      _RL yymmddMin,yymmddMax
      _RL hhmmssMin,hhmmssMax
      _RL tmpnp(1000), tmpdelT(1000)
      _RL tmp_lon, tmp_lon2(1000), tmp_lat2(1000), lon_cur, lat_cur
      _RL tmp_depth2(1000), depth_cur, delT_cur
      _RL tmp_weight2(1000)
      _RL tmp_sample_time(NSAMPLES_MAX_GLO)
      _RL tmp_sample_delT(NSAMPLES_MAX_GLO)
      _RL lon_1, lon_2, lat_1, lat_2
      _RL depth_1, depth_2
      _RL lon_tmp1, lon_tmp2, lat_tmp1, lat_tmp2
      _RL lat_fac, lon_fac, depth_fac
      _RL mask(NUM_INTERP_PTS_OBS)
      _RL w(NUM_INTERP_PTS_OBS), wtot
      _RL tmp_i(1000,NUM_INTERP_PTS_OBS)
      _RL tmp_j(1000,NUM_INTERP_PTS_OBS)
      _RL tmp_k(1000,NUM_INTERP_PTS_OBS)
      _RL tmp_frac(1000,NUM_INTERP_PTS_OBS),tmp_sum_fracs
      _RL tmp_xC11(1000),tmp_yC11(1000)
      _RL tmp_xCNINJ(1000),tmp_yCNINJ(1000)
c     _RL xy_buffer_r8(0:sNx+1,0:sNy+1)
      CHARACTER*(MAX_LEN_FNAM) obsfitfile, fnamedatanc
      CHARACTER*(MAX_LEN_FNAM) obsfnameequinc, obsfnameequincglo
      CHARACTER*(MAX_LEN_FNAM) fnamemisfit
# ifdef ALLOW_ADJOINT_RUN
      CHARACTER*(MAX_LEN_FNAM) adobsfnameequinc, adobsfnameequincglo
# endif
# ifdef ALLOW_TANGENTLINEAR_RUN
      CHARACTER*(MAX_LEN_FNAM) tlobsfnameequinc, tlobsfnameequincglo
# endif
      CHARACTER*(MAX_LEN_MBUF) msgbuf
      LOGICAL exst

      iUnit = standardMessageUnit
      WRITE( msgbuf,'(A)' ) ' '
      CALL PRINT_MESSAGE( msgbuf, iUnit, SQUEEZE_RIGHT, myThid )
      WRITE( msgbuf,'(A)' )
     &     '// ======================================================='
      CALL PRINT_MESSAGE( msgbuf, iUnit, SQUEEZE_RIGHT, myThid )
      WRITE( msgbuf,'(A)' )
     &     '// insitu obsfit model sampling >>> START <<<'
      CALL PRINT_MESSAGE( msgbuf, iUnit, SQUEEZE_RIGHT, myThid )
      WRITE( msgbuf,'(A)' )
     &     '// ======================================================='
      CALL PRINT_MESSAGE( msgbuf, iUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgbuf,'(A)' ) ' '
      CALL PRINT_MESSAGE( msgbuf, iUnit, SQUEEZE_RIGHT, myThid )

      stopObsfit=0
      stopGenericGrid=0

      IF ( (.NOT.obsfitDoGenGrid) .AND.
     &     (.NOT.usingSphericalPolarGrid .OR. rotateGrid) ) THEN
       WRITE( msgBuf,'(2A)' ) 'OBSFIT_INIT_FIXED: ',
     &      'obsfitDoGenGrid=.true. is required'
       CALL PRINT_ERROR( msgBuf, myThid )
       WRITE( msgBuf,'(2A)' ) 'OBSFIT_INIT_FIXED: ',
     &      'unless usingSphericalGrid=.TRUE. and rotateGrid=.FALSE.'
       CALL PRINT_ERROR( msgBuf, myThid )
       CALL ALL_PROC_DIE( myThid )
       STOP 'ABNORMAL END: S/R OBSFIT_INIT_FIXED'
      ENDIF

c      IF ( obsfitDoGenGrid ) THEN
c       WRITE(msgBuf,'(2A)') 'OBSFIT_INIT_FIXED: ',
c     &  'obsfitDoGenGrid has not been tested yet'
c       CALL PRINT_ERROR( msgBuf, myThid )
c       CALL ALL_PROC_DIE( myThid )
c       STOP 'ABNORMAL END: S/R OBSFIT_INIT_FIXED'
c      ENDIF

      WRITE( msgbuf,'(A)' ) ' '
      CALL PRINT_MESSAGE( msgbuf, iUnit, SQUEEZE_RIGHT, myThid )
      WRITE( msgbuf,'(A)' ) 'general packages parameters :'

      JL  = ILNBLNK( obsfitDir )
      IF (JL.NE.0) THEN
       WRITE( msgbuf,'(2A)' ) '  obsfitDir ',obsfitDir(1:JL)
      ELSE
       WRITE( msgbuf,'(2A)' ) '  obsfitDir ','./'
      ENDIF
      CALL PRINT_MESSAGE( msgBuf, iUnit, SQUEEZE_RIGHT, myThid )
      WRITE( msgbuf,'(A,l5)' ) '  obsfitDoGenGrid  ',obsfitDoGenGrid
      CALL PRINT_MESSAGE( msgBuf, iUnit, SQUEEZE_RIGHT, myThid )
      WRITE( msgbuf,'(A,l5)' ) '  obsfitDoNcOutput ',obsfitDoNcOutput
      CALL PRINT_MESSAGE( msgBuf, iUnit, SQUEEZE_RIGHT, myThid )
      WRITE( msgbuf,'(A)' ) ' '
      CALL PRINT_MESSAGE( msgbuf, iUnit, SQUEEZE_RIGHT, myThid )

      _BEGIN_MASTER( myThid )

C Initialize global variables for obsfit_read_obs.F
      obsfit_curfile_buff = 0
      DO l = 1, 1000
       obsfit_data_buff(l) = 0. _d 0
       obsfit_uncert_buff(l) = 0. _d 0
      ENDDO

      yymmddMin=modelstartdate(1)
      yymmddMax=modelenddate(1)
      hhmmssMin=modelstartdate(2)
      hhmmssMax=modelenddate(2)

      DO num_file = 1, NFILESMAX_OBS

       ObsNo_hh=0
       obs_np_max=0
       obs_is_ssh_loc=0
       obs_is_ssh(num_file)=0

       obsfitFile=' '
       IL = ILNBLNK( obsfitFiles(num_file) )
       IF (IL.NE.0) THEN
        WRITE( obsfitFile,'(1A)' ) obsfitFiles(num_file)(1:IL)
        WRITE( msgbuf,'(A)' ) ' '
        CALL PRINT_MESSAGE( msgbuf, iUnit, SQUEEZE_RIGHT, myThid )
        WRITE( msgbuf,'(A,I3,2A)' ) 'obsfit file #', num_file,
     &       ' is ', obsfitFile(1:IL)
        CALL PRINT_MESSAGE( msgbuf, iUnit, SQUEEZE_RIGHT, myThid )
       ENDIF

       IL = ILNBLNK( obsfitFile )
       IF (IL.NE.0) THEN

C===========================================================
C Open input files and read information
C===========================================================

        WRITE( fnamedatanc,'(2A)' ) obsfitFile(1:IL),'.nc'
        err = NF_OPEN( fnamedatanc, NF_NOWRITE, fiddata_obs(num_file) )
        CALL OBSFIT_NF_ERROR(
     &       'INIT_FIXED: NF_OPEN fiddata',err,0,0,myThid )

C Read number of observations and available dimensions:
        fid = fiddata_obs(num_file)

        err = NF_INQ_DIMID( fid,'iOBS', dimid )
        CALL OBSFIT_NF_ERROR(
     &       'INIT_FIXED: NF_INQ_DIMID iOBS',err,0,0,myThid )
        err = NF_INQ_DIMLEN( fid, dimid, obsNo(num_file) )
        CALL OBSFIT_NF_ERROR(
     &       'INIT_FIXED: NF_INQ_DIMLEN ObsNo',err,0,0,myThid )

        WRITE(msgbuf,'(A,I9)')
     &       '  # of observations in file                   =',
     &       obsNo(num_file)
        CALL PRINT_MESSAGE( msgbuf, iUnit, SQUEEZE_RIGHT, myThid )

C Read number of interpolation points (generic grid only):
        err = NF_INQ_DIMID(fid,'iINTERP', dimid)
        IF (err.EQ.NF_NOERR) THEN
         err = NF_INQ_DIMLEN( fid, dimid, iINTERP )
        ELSE

         IF ( debugLevel .GE. debLevA ) THEN
          WRITE( msgBuf,'(3A,I3)' )
     &         'S/R OBSFIT_INIT_FIXED: ',
     &         'no iINTERP dim in data file using iINTERP ',
     &         '= NUM_INTERP_POINTS =', NUM_INTERP_PTS_OBS
          CALL PRINT_MESSAGE( msgBuf, iUnit, SQUEEZE_RIGHT, myThid )
         ENDIF

         iINTERP = NUM_INTERP_PTS_OBS

        ENDIF!if (err.EQ.NF_NOERR)

        WRITE( msgbuf,'(A,I9)' )
     &       '  # of interpolation points                   =',
     &       iINTERP
        CALL PRINT_MESSAGE( msgbuf, iUnit, SQUEEZE_RIGHT, myThid )

C Read number of samples (if missing, assume it's 1):
        loopThroughSamples = 1
        err = NF_INQ_VARID( fid, 'obs_np', varID0 )
        IF (err.NE.NF_NOERR) THEN
         loopThroughSamples = 0

         WRITE( msgbuf,'(2A)' )
     &        '      input obsfit file does not have NP ',
     &        '      (num. samples); assume NP=1 for all obs '
         CALL PRINT_MESSAGE( msgbuf, iUnit, SQUEEZE_RIGHT, myThid )

        ENDIF

C Read the info for observations:
        err = NF_INQ_VARID( fid, 'obs_YYYYMMDD', varID1a )
        nerr = err
        CALL OBSFIT_NF_ERROR(
     &       'INIT_FIXED: NF_INQ_DIMID obs_YYYYMMDD',err,0,0,myThid )
        err = NF_INQ_VARID( fid, 'obs_HHMMSS', varID1b )
        nerr = nerr + err
        CALL OBSFIT_NF_ERROR(
     &       'INIT_FIXED: NF_INQ_DIMID obs_HHMMSS',err,0,0,myThid )
        err = NF_INQ_VARID( fid, 'obs_val', varID6 )
        nerr = nerr + err
        CALL OBSFIT_NF_ERROR(
     &       'INIT_FIXED: NF_INQ_DIMID obs_val',err,0,0,myThid )
        err = NF_INQ_VARID( fid, 'obs_uncert', varID7 )
        nerr = nerr + err
        CALL OBSFIT_NF_ERROR(
     &       'INIT_FIXED: NF_INQ_DIMID obs_uncert',err,0,0,myThid )

        IF (nerr.NE.NF_NOERR) THEN
         IL  = ILNBLNK( obsfitFile )
         WRITE( msgBuf,'(3A)' )
     &        'OBSFIT_INIT_FIXED: file ', obsfitFile(1:IL),
     &        '.nc is not in the pkg/obsfit format'
         CALL PRINT_ERROR( msgBuf, myThid )
         stopObsfit = 1
        ENDIF

        readDelT = 1
        err = NF_INQ_VARID( fid,'obs_delT', varID1c )
C Time interval (if missing, assume instantaneous):
        IF (err.NE.NF_NOERR) THEN
         readDelT = 0
         WRITE( msgbuf,'(2A)' )
     &        '      input obsfit file does not have time interval;',
     &        '      assume observations are instantaneous '
         CALL PRINT_MESSAGE( msgbuf, iUnit, SQUEEZE_RIGHT, myThid )
        ENDIF

C Read the info for samples:
        err = NF_INQ_VARID( fid,'sample_type',varID2 )
        nerr = err
        CALL OBSFIT_NF_ERROR(
     &       'INIT_FIXED: NF_INQ_DIMID sample_type',err,0,0,myThid )
        err = NF_INQ_VARID( fid,'sample_lon', varID3a )
        nerr = err
        CALL OBSFIT_NF_ERROR(
     &       'INIT_FIXED: NF_INQ_DIMID sample_lon',err,0,0,myThid )
        err = NF_INQ_VARID( fid,'sample_lat', varID3b )
        nerr = err
        CALL OBSFIT_NF_ERROR(
     &       'INIT_FIXED: NF_INQ_DIMID sample_lat',err,0,0,myThid )
        err = NF_INQ_VARID( fid,'sample_depth', varID4 )
        nerr = err
        CALL OBSFIT_NF_ERROR(
     &       'INIT_FIXED: NF_INQ_DIMID sample_depth',err,0,0,myThid )

        IF (err.NE.NF_NOERR) THEN
         IL  = ILNBLNK( obsfitFile )
         WRITE( msgBuf,'(3A)' )
     &        'OBSFIT_INIT_FIXED: file ', obsfitFile(1:IL),
     &        '.nc is not in the pkg/obsfit format'
         CALL PRINT_ERROR( msgBuf, myThid )
         stopObsfit=1
        ENDIF

        weighSamples = 1
        err = NF_INQ_VARID( fid,'sample_weight', varID5 )
C Weight for each sample (if missing, assume all samples weigh equally):
        IF (err.NE.NF_NOERR) THEN
         weighSamples = 0
         WRITE( msgbuf,'(2A)' )
     &        '      input obsfit file does not have sample weight;',
     &        '      assume all samples are weighed evenly '
         CALL PRINT_MESSAGE( msgbuf, iUnit, SQUEEZE_RIGHT, myThid )
        ENDIF

        IF (obsfitDoGenGrid) THEN
C Read interpolation information (grid points, fractions, etc.)
         err = NF_INQ_VARID(fid,'sample_interp_XC11',varID_intp1)
         err = NF_INQ_VARID(fid,'sample_interp_YC11',varID_intp2)
         err = NF_INQ_VARID(fid,'sample_interp_XCNINJ',varID_intp11)
         err = NF_INQ_VARID(fid,'sample_interp_YCNINJ',varID_intp22)
         err = NF_INQ_VARID(fid,'sample_interp_frac',varID_intp3)
         err = NF_INQ_VARID(fid,'sample_interp_i',varID_intp4)
         err = NF_INQ_VARID(fid,'sample_interp_j',varID_intp5)
         err = NF_INQ_VARID(fid,'sample_interp_k',varID_intp6)
         IF (err.NE.NF_NOERR) THEN
          IL  = ILNBLNK( obsfitFile )
          WRITE( msgBuf,'(3A)' )
     &         'OBSFIT_INIT_FIXED: file ', obsfitFile(1:IL), '.nc is',
     &         ' missing interpolation information (obsfitDoGenGrid)'
          CALL PRINT_ERROR( msgBuf, myThid )
          stopGenericGrid=2
         ENDIF
        ENDIF

C Variables names for equi files
        obsfit_nameequi = 'mod_val'
        obsfit_namemask = 'mod_mask'
        obsfit_nameval = 'obs_val'
        obsfit_nameuncert = 'obs_uncert'

C Create global files for obs-equivalent
        IF ( myProcId .EQ. 0 ) THEN

         WRITE( obsfnameequincglo,'(3A)' )
     &        obsfitDir(1:JL),obsfitFile(1:IL),'.equi.nc'
# ifdef ALLOW_ADJOINT_RUN
         WRITE( adobsfnameequincglo,'(4A)' )
     &        obsfitDir(1:JL),'ad',
     &        obsfitFile(1:IL),'.equi.nc'
# endif /* ALLOW_ADJOINT_RUN */
# ifdef ALLOW_TANGENTLINEAR_RUN
         WRITE( tlobsfnameequincglo,'(4A)' )
     &        obsfitDir(1:JL),'tl',
     &        obsfitFile(1:IL),'.equi.nc'
# endif /* ALLOW_TANGENTLINEAR_RUN */

         JL = ILNBLNK( obsfitDir )
         INQUIRE( file=obsfnameequincglo, exist=exst )
         IF (.NOT.exst) THEN
          err = NF_CREATE( obsfnameequincglo, NF_CLOBBER,
     &          fidglobal(num_file) )
          err = NF_DEF_DIM( fidglobal(num_file), 'iOBS',
     &          ObsNo(num_file), dimid )
          err = NF_DEF_VAR( fidglobal(num_file),
     &          obsfit_nameequi,NF_DOUBLE,1,dimid,varID(1) )
          err = NF_PUT_ATT_DOUBLE( fidglobal(num_file),
     &          varID(1),'_FillValue',NF_DOUBLE,1, -9999. _d 0 )
          err = NF_DEF_VAR( fidglobal(num_file),
     &          obsfit_namemask,NF_DOUBLE,1,dimid,varID(2) )
          err = NF_PUT_ATT_DOUBLE( fidglobal(num_file),
     &          varID(2),'_FillValue',NF_DOUBLE,1, -9999. _d 0 )
          err = NF_ENDDEF( fidglobal(num_file) )
          err = NF_CLOSE( fidglobal(num_file) )
          err = NF_OPEN( obsfnameequincglo, NF_WRITE,
     &          fidglobal(num_file) )
         ELSE
          err = NF_OPEN( obsfnameequincglo, NF_WRITE,
     &          fidglobal(num_file) )
          err = NF_INQ_VARID( fidglobal(num_file), obsfit_namemask,
     &          varID(2) )

         ENDIF
C Initialize mask values to 0
         DO obs_num = 1, ObsNo(num_file)
          err = NF_PUT_VARA_DOUBLE( fidglobal(num_file), varID(2),
     &          obs_num, 1, 0. _d 0 )
          CALL OBSFIT_NF_ERROR(
     &         'INIT_FIXED: NF_PUT_VARA_DOUBLE zero',err,0,0,myThid )
         ENDDO

#ifdef ALLOW_ADJOINT_RUN
         INQUIRE( file=adobsfnameequincglo, exist=exst )
         IF (.NOT.exst) THEN
          err = NF_CREATE( adobsfnameequincglo,NF_CLOBBER,
     &          fidadglobal(num_file) )
          err = NF_DEF_DIM( fidadglobal(num_file),'iOBS',
     &          ObsNo(num_file),dimid )
          err = NF_DEF_VAR( fidadglobal(num_file),
     &          'mod_val',NF_DOUBLE,1,dimid,varID(1) )
          err = NF_PUT_ATT_DOUBLE( fidadglobal(num_file),
     &          varID(1),'_FillValue', NF_DOUBLE,1, 0. _d 0 )
          err = NF_DEF_VAR( fidadglobal(num_file),
     &          'mod_mask',NF_DOUBLE, 1,dimid,varID(2) )
          err = NF_PUT_ATT_DOUBLE( fidadglobal(num_file),
     &          varID(2),'_FillValue',NF_DOUBLE,1, 0. _d 0 )
          err = NF_ENDDEF( fidadglobal(num_file) )
          err = NF_CLOSE( fidadglobal(num_file) )
          err = NF_OPEN( adobsfnameequincglo, NF_WRITE,
     &          fidadglobal(num_file) )
         ELSE
          err = NF_OPEN( adobsfnameequincglo, NF_WRITE,
     &          fidadglobal(num_file) )
         ENDIF
#endif
#ifdef ALLOW_TANGENTLINEAR_RUN
         INQUIRE( file=tlobsfnameequincglo, exist=exst )
         IF (.NOT.exst) THEN
          err = NF_CREATE( tlobsfnameequincglo,NF_CLOBBER,
     &          fidtanglobal(num_file) )
          err = NF_DEF_DIM( fidtanglobal(num_file),'iOBS',
     &          ObsNo(num_file),dimid )
          err = NF_DEF_VAR( fidtanglobal(num_file),
     &          'mod_val',NF_DOUBLE,1,dimid,varID(1) )
          err = NF_PUT_ATT_DOUBLE( fidtanglobal(num_file),
     &          varID(1),'_FillValue',NF_DOUBLE,1, 0. _d 0 )
          err = NF_DEF_VAR( fidtanglobal(num_file),
     &          'mod_mask',NF_DOUBLE,1,dimid,varID(2))
          err = NF_PUT_ATT_DOUBLE( fidtanglobal(num_file),
     &          varID(2),'_FillValue',NF_DOUBLE,1, 0. _d 0 )
          err = NF_ENDDEF( fidtanglobal(num_file) )
          err = NF_CLOSE( fidtanglobal(num_file) )
          err = NF_OPEN( tlobsfnameequincglo, NF_WRITE,
     &          fidtanglobal(num_file) )
         ELSE
          err = NF_OPEN( tlobsfnameequincglo, NF_WRITE,
     &          fidtanglobal(num_file) )
         ENDIF
#endif

C Global file for misfits
         WRITE( fnamemisfit,'(3A)' )
     &        obsfitDir(1:JL),obsfitfile(1:IL),'.misfit.nc'
         INQUIRE( file=fnamemisfit, exist=exst )
         IF (.NOT.exst) THEN
          err = NF_CREATE( fnamemisfit,NF_CLOBBER,fidmisfit(num_file) )
          err = NF_DEF_DIM( fidmisfit(num_file),'iOBS',ObsNo(num_file),
     &          dimid )
          err = NF_DEF_VAR( fidmisfit(num_file),'misfit',
     &          NF_DOUBLE,1,dimid,varID(1) )
          err = NF_PUT_ATT_DOUBLE( fidmisfit(num_file),varID(1),
     &          '_FillValue',NF_DOUBLE,1,-9999. _d 0 )
          err = NF_ENDDEF( fidmisfit(num_file) )
          err = NF_CLOSE( fidmisfit(num_file) )
         ELSE
          err = NF_OPEN( fnamemisfit, NF_WRITE,fidmisfit(num_file) )
         ENDIF

        ENDIF !myProcId

C===========================================================
C First: loop through observations
C===========================================================
C Default values
        DO obs_num = 1, NOBSMAX_OBS
         obs_np(num_file,obs_num) = 1
         obs_ind_glob(num_file,obs_num) = 0
        ENDDO

C Main loop: look for valid obs (within model run time)
        ObsNo_valid = 0
        Obsno_div1000 = max(0,int(ObsNo(num_file)/1000))

C Counter tracking position of first sample number for each obs
        sample_cnt = 1

        DO chunkObs = 1, Obsno_div1000+1
         chunk = 1000*(chunkObs-1)

         IF ( MIN(ObsNo(num_file), 1000*chunkObs ).GE.
     &      1+chunk ) THEN

C Read a chunk
          vec_start = 1+chunk
          vec_count = MIN(1000,ObsNo(num_file)-chunk)

          IF ( (vec_count.LE.0) .OR.
     &         (vec_count.GT.1000) .OR.
     &         (vec_start.LE.0) .OR.
     &         (vec_count+vec_start-1.GT.ObsNo(num_file)) )
     &    THEN
           IL  = ILNBLNK( obsfitFile )
           WRITE( msgBuf,'(3A)' )
     &          'OBSFIT_INIT_FIXED: file ', obsfitFile(1:IL),
     &          '.nc was not read properly (case 1).'
           CALL PRINT_ERROR( msgBuf, myThid )
           stopObsfit = 1
          ENDIF

C Read time
          err = NF_GET_VARA_DOUBLE( fid,varID1a,vec_start,
     &          vec_count, tmpyymmdd )
          err = NF_GET_VARA_DOUBLE( fid,varID1b,vec_start,
     &          vec_count, tmphhmmss )
C Read time interval
          IF ( readDelT.GT.0 ) THEN
           err = NF_GET_VARA_DOUBLE( fid,varID1c,vec_start,
     &           vec_count, tmpdelT )
          ENDIF
C Read number of samples per obs
          IF ( loopThroughSamples.EQ.1 ) THEN
           err = NF_GET_VARA_DOUBLE( fid,varID0,vec_start,
     &           vec_count, tmpnp )
          ENDIF

          IF (err.NE.NF_NOERR) THEN
           WRITE( msgBuf,'(3A)' )
     &          'OBSFIT_INIT_FIXED: file ', obsfitFile(1:IL),
     &          '.nc was not read properly (case 2).'
           CALL PRINT_ERROR( msgBuf, myThid )
           stopObsfit = 1
          ENDIF

C Loop through this chunk
          DO ic = 1, MIN(1000,ObsNo(num_file)-chunk)

           IF ( stopObsfit .EQ. 0 ) THEN
            obsIsInRunTime = 1

CAV if obs starts before model run, will be ignored even if it ends after
CAV model starts - ok for now
            IF (( ( tmpyymmdd(ic).GT.yymmddMin ) .OR.
     &           (( tmpyymmdd(ic).EQ.yymmddMin ) .AND.
     &            ( tmphhmmss(ic).GE.hhmmssMin )) ) .AND.
     &          ( ( tmpyymmdd(ic).LT.yymmddMax ) .OR.
     &           (( tmpyymmdd(ic).EQ.yymmddMax ) .AND.
     &            ( tmphhmmss(ic).LE.hhmmssMax )) )) THEN
             hh = INT(tmphhmmss(ic))/10000
             IF ( hh.LT.hoursPerDay ) THEN
              obsIsInRunTime = 1
              CALL CAL_FULLDATE( INT(tmpyymmdd(ic)),
     &             INT(tmphhmmss(ic)),tmpdate,myThid )
              CALL CAL_TIMEPASSED( modelstartdate,tmpdate,
     &             tmpdiff,myThid )
              CALL CAL_TOSECONDS( tmpdiff,diffsecs,myThid )
              diffsecs = diffsecs+nIter0*deltaTClock
             ELSE
C If tmphhmmss is out of range then disregard obs
              obsIsInRunTime = 0
              diffsecs = -deltaTClock
              ObsNo_hh = ObsNo_hh+1
             ENDIF
            ELSE
             obsIsInRunTime = 0
             diffsecs = -deltaTClock
            ENDIF

            IF ( loopThroughSamples.EQ.1 ) THEN
             np_cur = tmpnp(ic)
            ELSE
             np_cur = 1
            ENDIF

            IF ( readDelT.EQ.1 ) THEN
             IF ( tmpdelT(ic).GT.0. _d 0 ) THEN
C delT>0: time average
              delT_cur = tmpdelT(ic)
              obsfitOperation(num_file) = 1
             ELSEIF (tmpdelT(ic).LT.0. _d 0) THEN
C delT<0: time integral
              delT_cur = -tmpdelT(ic)
              obsfitOperation(num_file) = 2
             ELSE
C delT=0: instantaneous
              delT_cur = 0. _d 0
              obsfitOperation(num_file) = 0
             ENDIF
            ELSE
             delT_cur = 0. _d 0
             obsfitOperation(num_file) = 0
            ENDIF

            IF ( obsIsInRunTime.EQ.1 ) THEN
C If yes then store obs index position and number of samples:
             ObsNo_valid = ObsNo_valid+1
             obs_ind_glob(num_file,ObsNo_valid) = ic+chunk
C Number of samples in each valid observation
             obs_np(num_file,ObsNo_valid) = np_cur
             IF ( np_cur.GT.obs_np_max ) obs_np_max = np_cur
C Position of first sample
             obs_sample1_ind(num_file,ObsNo_valid) = sample_cnt
             obs_delT(num_file,ObsNo_valid) = delT_cur
            ENDIF !obsIsInRunTime.EQ.1

C Regardless of whether obs is in run time or not,
C keep track of sample index position
C and assign time to samples
            DO k = 1, np_cur
             tmp_sample_time(sample_cnt) = diffsecs
             tmp_sample_delT(sample_cnt) = delT_cur
             sample_cnt = sample_cnt+1
            ENDDO

C Check that maximum size was not reached:
            IF ( ObsNo_valid.GT.NOBSMAX_OBS ) THEN
             WRITE( msgBuf,'(3A)' )
     &            'OBSFIT_INIT_FIXED: file ', obsfitFile(1:IL),
     &            '.nc was not read properly (increase NOBSMAX_OBS).'
             CALL PRINT_ERROR( msgBuf, myThid )
             stopObsfit = 1
            ENDIF

C Check that maximum NP was not reached:
            IF ( obs_np_max.GT.NSAMP_PER_OBS_MAX ) THEN
             WRITE( msgBuf,'(3A)' )
     &           'OBSFIT_INIT_FIXED: file ', obsfitFile(1:IL),
     &           '.nc  was not read properly ',
     &           '(increase NSAMP_PER_OBS_MAX).'
             CALL PRINT_ERROR( msgBuf, myThid )
             stopObsfit = 1
            ENDIF

           ENDIF !stopObsfit
          ENDDO !ic
         ENDIF !chunk
        ENDDO !chunkObs

C Number of valid observations in the file
        ObsNo(num_file) = ObsNo_valid

        WRITE( msgbuf,'(A,I9)' )
     &       '  # of obs with erroneous HHMMSS values =', ObsNo_hh
        CALL PRINT_MESSAGE( msgbuf, iUnit, SQUEEZE_RIGHT, myThid )

        WRITE(msgbuf,'(A,I9)')
     &       '  # of obs within time period  =', ObsNo(num_file)
        CALL PRINT_MESSAGE( msgbuf, iUnit, SQUEEZE_RIGHT, myThid )

C===========================================================
C Second: loop through samples
C===========================================================
        DO bj = 1, nSy
         DO bi = 1, nSx

C Main loop: look for valid samples (in tile)
          err = NF_INQ_DIMID( fid,'iSAMPLE', dimid )
C If isample is not a dimension, use iobs for size of sampleno
          IF (err.NE.NF_NOERR) THEN
           sampleNo(num_file,bi,bj) = ObsNo(num_file)
          ELSE
           err = NF_INQ_DIMLEN( fid, dimid, sampleNo(num_file,bi,bj) )
          ENDIF

          DO ip = 1, NSAMP_PER_TILE_MAX
           sample_timeS(num_file,ip,bi,bj)  = -999. _d 0
           sample_timeE(num_file,ip,bi,bj)  = -999. _d 0
           sample_lon(num_file,ip,bi,bj)    = -999. _d 0
           sample_lat(num_file,ip,bi,bj)    = -999. _d 0
           sample_depth(num_file,ip,bi,bj)  = -999. _d 0
           sample_weight(num_file,ip,bi,bj) = 1. _d 0
           DO iq = 1, NUM_INTERP_PTS_OBS
            sample_interp_i(num_file,ip,iq,bi,bj)    = 1
            sample_interp_j(num_file,ip,iq,bi,bj)    = 1
            sample_interp_k(num_file,ip,iq,bi,bj)    = 1
            sample_interp_frac(num_file,ip,iq,bi,bj) = 0. _d 0
           ENDDO
           sample_interp_xC11(num_file,ip,bi,bj)   = -999. _d 0
           sample_interp_yC11(num_file,ip,bi,bj)   = -999. _d 0
           sample_interp_xCNINJ(num_file,ip,bi,bj) = -999. _d 0
           sample_interp_yCNINJ(num_file,ip,bi,bj) = -999. _d 0
          ENDDO

          sampleNo_tile = 0
          Obsno_div1000 = MAX(0,INT(sampleNo(num_file,bi,bj)/1000))

          ntype_ssh = 0
          ntype_other = 0

          DO chunkObs = 1, Obsno_div1000+1
           chunk = 1000*(chunkObs-1)

           IF ( MIN(sampleNo(num_file,bi,bj), 1000*chunkObs).GE.
     &          1+chunk ) THEN

C Read a chunk
            vec_start = 1+chunk
            vec_count = MIN(1000,sampleNo(num_file,bi,bj)-chunk)

            IF ( (vec_count.LE.0).OR.(vec_count.GT.1000).OR.
     &           (vec_start.LE.0).OR.
     &           (vec_count+vec_start-1.GT.
     &            sampleNo(num_file,bi,bj)) ) THEN
             IL  = ILNBLNK( obsfitFile )
             WRITE( msgBuf,'(3A)' )
     &            'OBSFIT_INIT_FIXED: file ', obsfitFile(1:IL),
     &            '.nc was not read properly (case 3).'
             CALL PRINT_ERROR( msgBuf, myThid )
             stopObsfit = 1
            ENDIF

            err = NF_GET_VARA_INT( fid,varID2,vec_start,
     &            vec_count, tmp_type2 )
            err = NF_GET_VARA_DOUBLE( fid,varID3a,vec_start,
     &            vec_count, tmp_lon2 )
            err = NF_GET_VARA_DOUBLE( fid,varID3b,vec_start,
     &            vec_count, tmp_lat2 )
            err = NF_GET_VARA_DOUBLE( fid,varID4,vec_start,
     &            vec_count, tmp_depth2 )
            IF ( weighSamples.EQ.1 ) THEN
             err = NF_GET_VARA_DOUBLE( fid,varID5,vec_start,
     &             vec_count, tmp_weight2 )
            ENDIF

C If obsfitDoGenGrid then also read in the interpolation fractions
C and indices
            IF ( obsfitDoGenGrid ) THEN
             err = NF_GET_VARA_DOUBLE( fid,varID_intp1,vec_start,
     &             vec_count, tmp_xC11 )
             err = NF_GET_VARA_DOUBLE( fid,varID_intp2,vec_start,
     &             vec_count, tmp_yC11 )
             err = NF_GET_VARA_DOUBLE( fid,varID_intp11,vec_start,
     &             vec_count, tmp_xCNINJ )
             err = NF_GET_VARA_DOUBLE( fid,varID_intp22,vec_start,
     &             vec_count, tmp_yCNINJ )
             DO iq = 1, iINTERP
              vec_start2(1) = iq
              vec_start2(2) = 1+chunk
              vec_count2(1) = 1
              vec_count2(2) = min(1000,
     &        sampleNo(num_file,bi,bj)-chunk)
              err = NF_GET_VARA_DOUBLE( fid,varID_intp3,vec_start2,
     &              vec_count2, tmp_frac(1,iq) )
              err = NF_GET_VARA_DOUBLE( fid,varID_intp4,vec_start2,
     &              vec_count2, tmp_i(1,iq) )
              err = NF_GET_VARA_DOUBLE( fid,varID_intp5,vec_start2,
     &              vec_count2, tmp_j(1,iq) )
              err = NF_GET_VARA_DOUBLE( fid,varID_intp6,vec_start2,
     &              vec_count2, tmp_k(1,iq) )
             ENDDO
            ENDIF

            IF ( err.NE.NF_NOERR ) THEN
             WRITE( msgBuf,'(3A)' )
     &            'OBSFIT_INIT_FIXED: file ', obsfitFile(1:IL),
     &            '.nc was not read properly (case 4).'
             CALL PRINT_ERROR( msgBuf, myThid )
             stopObsfit = 1
            ENDIF

C Loop through this chunk
            DO ic = 1, MIN(1000,sampleNo(num_file,bi,bj)-chunk)

             IF ( stopObsfit .EQ. 0) THEN

              sampleIsValid = 1
              sampleIsInTile = 1

C Check that sample time is valid
              IF ( tmp_sample_time(ic+chunk).LT.0. _d 0 ) THEN
               sampleIsValid = 0
              ENDIF
              IF ( (tmp_sample_time(ic+chunk).GT.modelend) .OR.
     &             (tmp_sample_time(ic+chunk).LT.modelstart) ) THEN
               sampleIsValid = 0
              ENDIF

              type_cur = tmp_type2(ic)
              lon_cur = tmp_lon2(ic)
              lat_cur = tmp_lat2(ic)
              depth_cur = tmp_depth2(ic)

C Keep track of which variables in the file
              IF ( type_cur.EQ.5 ) THEN
               ntype_ssh = ntype_ssh+1
              ELSE
               ntype_other = ntype_other+1
              ENDIF

C Determine whether sample is in current tile domain
C Process only valid samples ( sampleIsValid.EQ.1 )

C===========================================================
C lat-lon grid case
C===========================================================
              IF ( (.NOT.obsfitDoGenGrid ).AND.
     &             ( sampleIsValid.EQ.1 ) ) THEN
               IF ( xC(sNx+1,1,bi,bj).LT.xC(1,1,bi,bj) ) THEN
                tmp_lon = xC(sNx+1,1,bi,bj)+360. _d 0
               ELSE
                tmp_lon = xC(sNx+1,1,bi,bj)
               ENDIF

               IF ( (xC(1,1,bi,bj).LE.lon_cur).AND.
     &              (tmp_lon.GT.lon_cur).AND.
     &              (yC(1,1,bi,bj).LE.lat_cur).AND.
     &              (yC(1,sNy+1,bi,bj).GT.lat_cur) ) THEN
C Do nothing
               ELSEIF ( (xC(sNx+1,1,bi,bj).LT.xC(1,1,bi,bj)).AND.
     &                  (xC(1,1,bi,bj).LE.lon_cur+360. _d 0).AND.
     &                  (tmp_lon.GT.lon_cur+360. _d 0).AND.
     &                  (yC(1,1,bi,bj).LE.lat_cur).AND.
     &                  (yC(1,sNy+1,bi,bj).GT.lat_cur) ) THEN
                lon_cur=lon_cur+360. _d 0
               ELSE
C Not in this tile
                sampleIsInTile = 0
               ENDIF

C Now determine value of i,j,k south-west-down of data point
               sample_i = -10
               sample_j = -10
               sample_k1 = -10
               sample_k2 = -10
               lon_1 = -10
               lon_2 = -10
               lat_1 = -10
               lat_2 = -10
               depth_1 = -10
               depth_2 = -10

               IF ( sampleIsInTile.EQ.1 ) THEN

C Value of k, below the data point:
C Case 1: above first depth level
                IF ( -rC(1).GT.depth_cur ) THEN
                 sample_k1 = 1
                 sample_k2 = 1
                 depth_fac = 1. _d 0
                ENDIF
C Case 2: below last depth level
                IF ( -rC(Nr).LE.depth_cur ) THEN
                 sample_k1 = Nr
                 sample_k2 = Nr
                 depth_fac = 1. _d 0
                ENDIF
C Case 3: between two depth levels
                DO kLev = 1, Nr-1
                 IF ( (-rC(kLev).LE.depth_cur).AND.
     &                (-rC(kLev+1).GT.depth_cur) ) THEN
                  sample_k1 = kLev
                  sample_k2 = kLev+1
                  depth_1 = -rC(kLev)
                  depth_2 = -rC(kLev+1)
                  depth_fac = (depth_cur-depth_1)/(depth_2-depth_1)
                 ENDIF
                ENDDO

                DO j = 1, sNy+1
                 DO i = 1, sNx+1

                  IF ( type_cur.EQ.3 ) THEN
C Zonal velocity
                   lon_tmp1 = xG(i,j,bi,bj)
                   lon_tmp2 = xG(i+1,j,bi,bj)
                   lat_tmp1 = yC(i,j,bi,bj)
                   lat_tmp2 = yC(i,j+1,bi,bj)
                  ELSEIF ( type_cur.EQ.4 ) THEN
c Meridional velocity
                   lon_tmp1 = xC(i,j,bi,bj)
                   lon_tmp2 = xC(i+1,j,bi,bj)
                   lat_tmp1 = yG(i,j,bi,bj)
                   lat_tmp2 = yG(i,j+1,bi,bj)
                  ELSE
                   lon_tmp1 = xC(i,j,bi,bj)
                   lon_tmp2 = xC(i+1,j,bi,bj)
                   lat_tmp1 = yC(i,j,bi,bj)
                   lat_tmp2 = yC(i,j+1,bi,bj)
                  ENDIF

C Value of j, south of the data point:
                  IF ( (lat_tmp1.LE.lat_cur).AND.
     &                 (lat_tmp2.GT.lat_cur) ) THEN
                   sample_j = j
                   lat_1 = lat_tmp1
                   lat_2 = lat_tmp2
                  ENDIF

C Value of i, west of the data point:
                  IF ( xC(i+1,j,bi,bj).LT.xC(1,j,bi,bj) ) THEN
                   lon_tmp2 = lon_tmp2+360
                  ENDIF
                  IF ( xC(i,j,bi,bj).LT.xC(1,j,bi,bj) ) THEN
                   lon_tmp1 = lon_tmp1+360
                  ENDIF
                  IF ( (lon_tmp1.LE.lon_cur).AND.
     &                 (lon_tmp2.GT.lon_cur) ) THEN
                   sample_i = i
                   lon_1 = lon_tmp1
                   lon_2 = lon_tmp2
                  ENDIF

                 ENDDO !i
                ENDDO !j
               ENDIF !sampleIsInTile

               IF ( (sample_i.EQ.-10).OR.(sample_j.EQ.-10) ) THEN
                sampleIsInTile = 0
               ENDIF
               IF ( (sample_k1.EQ.-10).OR.(sample_k2.EQ.-10) ) THEN
                sampleIsInTile = 0
               ENDIF

               IF ( sampleIsInTile.EQ.1 ) THEN
C If yes then store sample index position and number of samples:
                sampleNo_tile = sampleNo_tile+1
                sample_ind_glob(num_file,sampleNo_tile,bi,bj)
     &           = ic+chunk
                sample_timeS(num_file,sampleNo_tile,bi,bj)=
     &           tmp_sample_time(ic+chunk)
C "-1" to avoid counting in an extra time step
C when time averaging
                IF ( obsfitOperation(num_file).eq.0 ) THEN
                 sample_timeE(num_file,sampleNo_tile,bi,bj)=
     &            sample_timeS(num_file,sampleNo_tile,bi,bj)
     &            +tmp_sample_delT(ic+chunk)
                ELSE
                 sample_timeE(num_file,sampleNo_tile,bi,bj)=
     &            sample_timeS(num_file,sampleNo_tile,bi,bj)
     &            +tmp_sample_delT(ic+chunk)-1
                ENDIF
                sample_lon(num_file,sampleNo_tile,bi,bj)=lon_cur
                sample_lat(num_file,sampleNo_tile,bi,bj)=lat_cur
                sample_depth(num_file,sampleNo_tile,bi,bj)=depth_cur
                IF ( weighSamples.EQ.1 ) THEN
                 sample_weight(num_file,sampleNo_tile,bi,bj)=
     &            tmp_weight2(ic)
                ENDIF
                sample_type(num_file,sampleNo_tile,bi,bj)=type_cur

C Store interpolation fractions and indices
                lon_fac = (lon_cur-lon_1)/(lon_2-lon_1)
                lat_fac = (lat_cur-lat_1)/(lat_2-lat_1)

                w(1)=(1-lon_fac)*(1-lat_fac)*(1-depth_fac)
                sample_interp_i(num_file,sampleNo_tile,1,bi,bj)
     &           =sample_i
                sample_interp_j(num_file,sampleNo_tile,1,bi,bj)
     &           =sample_j
                sample_interp_k(num_file,sampleNo_tile,1,bi,bj)
     &           =sample_k1
                w(2)=lon_fac*(1-lat_fac)*(1-depth_fac)
                sample_interp_i(num_file,sampleNo_tile,2,bi,bj)
     &           =sample_i+1
                sample_interp_j(num_file,sampleNo_tile,2,bi,bj)
     &           =sample_j
                sample_interp_k(num_file,sampleNo_tile,2,bi,bj)
     &           =sample_k1
                w(3)=(1-lon_fac)*lat_fac*(1-depth_fac)
                sample_interp_i(num_file,sampleNo_tile,3,bi,bj)
     &           =sample_i
                sample_interp_j(num_file,sampleNo_tile,3,bi,bj)
     &           =sample_j+1
                sample_interp_k(num_file,sampleNo_tile,3,bi,bj)
     &           =sample_k1
                w(4)=lon_fac*lat_fac*(1-depth_fac)
                sample_interp_i(num_file,sampleNo_tile,4,bi,bj)
     &           =sample_i+1
                sample_interp_j(num_file,sampleNo_tile,4,bi,bj)
     &           =sample_j+1
                sample_interp_k(num_file,sampleNo_tile,4,bi,bj)
     &           =sample_k1
                w(5)=(1-lon_fac)*(1-lat_fac)*depth_fac
                sample_interp_i(num_file,sampleNo_tile,5,bi,bj)
     &           =sample_i
                sample_interp_j(num_file,sampleNo_tile,5,bi,bj)
     &           =sample_j
                sample_interp_k(num_file,sampleNo_tile,5,bi,bj)
     &           =sample_k2
                w(6)=lon_fac*(1-lat_fac)*depth_fac
                sample_interp_i(num_file,sampleNo_tile,6,bi,bj)
     &           =sample_i+1
                sample_interp_j(num_file,sampleNo_tile,6,bi,bj)
     &           =sample_j
                sample_interp_k(num_file,sampleNo_tile,6,bi,bj)
     &           =sample_k2
                w(7)=(1-lon_fac)*lat_fac*depth_fac
                sample_interp_i(num_file,sampleNo_tile,7,bi,bj)
     &           =sample_i
                sample_interp_j(num_file,sampleNo_tile,7,bi,bj)
     &           =sample_j+1
                sample_interp_k(num_file,sampleNo_tile,7,bi,bj)
     &           =sample_k2
                w(8)=lon_fac*lat_fac*depth_fac
                sample_interp_i(num_file,sampleNo_tile,8,bi,bj)
     &           =sample_i+1
                sample_interp_j(num_file,sampleNo_tile,8,bi,bj)
     &           =sample_j+1
                sample_interp_k(num_file,sampleNo_tile,8,bi,bj)
     &           =sample_k2

C Ignore points that are not "wet"
                IF ( type_cur.EQ.3 ) THEN
c Zonal velocity
                 mask(1)=maskW(sample_i,sample_j,sample_k1,bi,bj)
                 mask(2)=maskW(sample_i+1,sample_j,sample_k1,bi,bj)
                 mask(3)=maskW(sample_i,sample_j+1,sample_k1,bi,bj)
                 mask(4)=maskW(sample_i+1,sample_j+1,sample_k1,bi,bj)
                 mask(5)=maskW(sample_i,sample_j,sample_k2,bi,bj)
                 mask(6)=maskW(sample_i+1,sample_j,sample_k2,bi,bj)
                 mask(7)=maskW(sample_i,sample_j+1,sample_k2,bi,bj)
                 mask(8)=maskW(sample_i+1,sample_j+1,sample_k2,bi,bj)
                ELSEIF ( type_cur.EQ.4 ) THEN
c Meridional velocity
                 mask(1)=maskS(sample_i,sample_j,sample_k1,bi,bj)
                 mask(2)=maskS(sample_i+1,sample_j,sample_k1,bi,bj)
                 mask(3)=maskS(sample_i,sample_j+1,sample_k1,bi,bj)
                 mask(4)=maskS(sample_i+1,sample_j+1,sample_k1,bi,bj)
                 mask(5)=maskS(sample_i,sample_j,sample_k2,bi,bj)
                 mask(6)=maskS(sample_i+1,sample_j,sample_k2,bi,bj)
                 mask(7)=maskS(sample_i,sample_j+1,sample_k2,bi,bj)
                 mask(8)=maskS(sample_i+1,sample_j+1,sample_k2,bi,bj)
                ELSE
                 mask(1)=maskC(sample_i,sample_j,sample_k1,bi,bj)
                 mask(2)=maskC(sample_i+1,sample_j,sample_k1,bi,bj)
                 mask(3)=maskC(sample_i,sample_j+1,sample_k1,bi,bj)
                 mask(4)=maskC(sample_i+1,sample_j+1,sample_k1,bi,bj)
                 mask(5)=maskC(sample_i,sample_j,sample_k2,bi,bj)
                 mask(6)=maskC(sample_i+1,sample_j,sample_k2,bi,bj)
                 mask(7)=maskC(sample_i,sample_j+1,sample_k2,bi,bj)
                 mask(8)=maskC(sample_i+1,sample_j+1,sample_k2,bi,bj)
                ENDIF !type_cur

                wtot = 0
                DO iq = 1, NUM_INTERP_PTS_OBS
                 IF (mask(iq).EQ.0) w(iq)=0
                 wtot = wtot+w(iq)
                ENDDO
                DO iq = 1, NUM_INTERP_PTS_OBS
                 sample_interp_frac(num_file,sampleNo_tile,iq,bi,bj) =
     &            w(iq)/(wtot+1. _d -10)
                ENDDO

               ENDIF !sampleIsInTile

C===========================================================
C Generic grid case
C===========================================================
C Determine whether sample is in current tile domain
              ELSEIF ( sampleIsValid.EQ.1 ) THEN

               IF ( stopGenericGrid.EQ.0 ) THEN

                IF ( (abs(tmp_xC11(ic) - xC(1,1,bi,bj))
     &               .LT.0.0001 _d 0 ).AND.
     &               (abs(tmp_yC11(ic) - yC(1,1,bi,bj))
     &               .LT.0.0001 _d 0).AND.
     &               (abs(tmp_xCNINJ(ic) - xC(sNx,sNy,bi,bj))
     &               .LT.0.0001 _d 0).AND.
     &               (abs(tmp_yCNINJ(ic) - yC(sNx,sNy,bi,bj))
     &               .LT.0.0001 _d 0) ) THEN
C Do nothing
                ELSE
                 sampleIsInTile = 0
                ENDIF

                IF ( sampleIsInTile.EQ.1 ) THEN
C If yes then store sample_time and interpolation fractions and indices:
                 sampleNo_tile = sampleNo_tile+1
                 sample_type(num_file,sampleNo_tile,bi,bj)=type_cur
                 sample_timeS(num_file,sampleNo_tile,bi,bj)=
     &            tmp_sample_time(ic+chunk)
C "-1" to avoid counting in an extra time step
C when time averaging
                 IF ( obsfitOperation(num_file).EQ.0 ) THEN
                  sample_timeE(num_file,sampleNo_tile,bi,bj)=
     &             sample_timeS(num_file,sampleNo_tile,bi,bj)
     &             +tmp_sample_delT(ic+chunk)
                 ELSE
                  sample_timeE(num_file,sampleNo_tile,bi,bj)=
     &             sample_timeS(num_file,sampleNo_tile,bi,bj)
     &             +tmp_sample_delT(ic+chunk)-1
                 ENDIF
                 IF ( weighSamples.EQ.1 ) THEN
                  sample_weight(num_file,sampleNo_tile,bi,bj)=
     &             tmp_weight2(ic)
                 ENDIF
                 sample_interp_xC11(num_file,sampleNo_tile,
     &            bi,bj)=tmp_xC11(ic)
                 sample_interp_yC11(num_file,sampleNo_tile,
     &            bi,bj)=tmp_yC11(ic)
                 sample_interp_xCNINJ(num_file,sampleNo_tile,
     &            bi,bj)=tmp_xCNINJ(ic)
                 sample_interp_yCNINJ(num_file,sampleNo_tile,
     &            bi,bj)=tmp_yCNINJ(ic)
                 tmp_sum_fracs = 0. _d 0

C Loop over interpolation points
                 DO iq = 1, iINTERP
                  sample_interp_frac(num_file,sampleNo_tile,iq,
     &             bi,bj)=tmp_frac(ic,iq)
                  sample_interp_i(num_file,sampleNo_tile,iq,
     &             bi,bj)=tmp_i(ic,iq)
                  sample_interp_j(num_file,sampleNo_tile,iq,
     &             bi,bj)=tmp_j(ic,iq)
                  sample_interp_k(num_file,sampleNo_tile,iq,
     &             bi,bj)=tmp_k(ic,iq)
                  tmp_sum_fracs = tmp_sum_fracs+tmp_frac(ic,iq)

C More test of the inputs: is the offline-computed
C interpolation information consistent (self and with grid)
                  IF ( (tmp_i(ic,iq).LT.0).OR.
     &                 (tmp_j(ic,iq).LT.0).OR.
     &                 (tmp_i(ic,iq).GT.sNx+1).OR.
     &                 (tmp_j(ic,iq).GT.sNy+1) ) THEN
                   WRITE( msgBuf,'(4A)' )
     &                  'OBSFIT_INIT_FIXED: file ',
     &                  obsfitFile(1:IL),
     &                  '.nc includes inconsistent interpolation ',
     &                  ' points (obsfitDoGenGrid; out of tile)'
                   CALL PRINT_ERROR( msgBuf, myThid )
                    stopGenericGrid = 1
                  ENDIF
#ifdef ALLOW_OBSFIT_EXCLUDE_CORNERS
                  IF ( tmp_frac(ic,iq) .NE. 0. _d 0) THEN
                   IF ( ((tmp_i(ic,iq).EQ.0) .AND.
     &                   (tmp_j(ic,iq).EQ.0)) .OR.
     &                  ((tmp_i(ic,iq).EQ.sNx+1) .AND.
     &                   (tmp_j(ic,iq).EQ.sNy+1)) .OR.
     &                  ((tmp_i(ic,iq).EQ.0) .AND.
     &                   (tmp_j(ic,iq).EQ.sNy+1)) .OR.
     &                  ((tmp_i(ic,iq).EQ.sNx+1) .AND.
     &                   (tmp_j(ic,iq).EQ.0)) ) THEN
                    WRITE( msgBuf,'(4A)' )
     &                   'OBSFIT_INIT_FIXED: file ',
     &                   obsfitFile(1:IL),
     &                   '.nc includes inconsistent interpolation ',
     &                   ' points (obsfitDoGenGrid; overlap corners)'
                    CALL PRINT_ERROR( msgBuf, myThid )
                     stopGenericGrid = 1
                   ENDIF
                  ENDIF
#endif /* ALLOW_OBSFIT_EXCLUDE_CORNERS */
                  IF ( (tmp_frac(ic,iq).LT.0. _d 0).OR.
     &                 (tmp_frac(ic,iq).GT.1. _d 0) ) THEN
                   WRITE( msgBuf,'(4A)' )
     &                  'OBSFIT_INIT_FIXED: file ',
     &                   obsfitFile(1:IL),
     &                   '.nc includes inconsistent interpolation ',
     &                   ' points (obsfitDoGenGrid; sum not 0-1)'
                   CALL PRINT_ERROR( msgBuf, myThid )
                   stopGenericGrid = 1
                  ENDIF
                 ENDDO! iq

                 IF ( abs(tmp_sum_fracs -1. _d 0 ) .GT.
     &                0.0001 _d 0) THEN
                  WRITE( msgBuf,'(4A)' )
     &                 'OBSFIT_INIT_FIXED: file ',
     &                 obsfitFile(1:IL),
     &                 '.nc includes inconsistent interpolation ',
     &                 ' weights (obsfitDoGenGrid; sum not 1)'
                  CALL PRINT_ERROR( msgBuf, myThid )
                  stopGenericGrid = 1
                 ENDIF

                 sample_ind_glob(num_file,sampleNo_tile,bi,bj)
     &            =ic+chunk

                ENDIF !sampleIsInTile
               ENDIF !stopGenericGrid
              ENDIF !obsfitDoGenGrid)

C ==============================================================================

C Check that maximum size was not reached:
              IF ( sampleNo_tile.GT.NSAMP_PER_TILE_MAX ) THEN
               WRITE( msgBuf,'(3A)' )
     &              'OBSFIT_INIT_FIXED: file ', obsfitFile(1:IL),
     &              '.nc was not read properly ',
     &              '(increase NSAMP_PER_TILE_MAX).'
               CALL PRINT_ERROR( msgBuf, myThid )
               stopObsfit = 1
              ENDIF

             ENDIF !stopObsfit
            ENDDO !ic
           ENDIF !chunk
          ENDDO !chunkObs

C Number of valid samples in the file
          sampleNo(num_file,bi,bj) = sampleNo_tile

          WRITE( msgbuf,'(A,I4,A,I4)' )
     &         '  current tile is bi,bj                      =',
     &         bi,',',bj
          CALL PRINT_MESSAGE(
     &         msgbuf, iUnit, SQUEEZE_RIGHT, myThid )

          WRITE( msgbuf,'(A,I9)' )
     &         '  # of samples within tile and time period  =',
     &         sampleNo(num_file,bi,bj)
          CALL PRINT_MESSAGE(
     &         msgbuf, iUnit, SQUEEZE_RIGHT, myThid )

          IF ( ntype_ssh.GT.0 ) THEN
           IF ( ntype_other.GT.0 ) THEN
            WRITE( msgBuf,'(4A)' )
     &           'OBSFIT_INIT_FIXED: file ', obsfitFile(1:IL),
     &           'includes both SSH and non-SSH observations; ',
     &           'this is not currently supported.'
            CALL PRINT_ERROR( msgBuf, myThid )
            stopObsfit = 1
           ELSE
            obs_is_ssh_loc = obs_is_ssh_loc+1
           ENDIF
          ENDIF

C===========================================================
C Create files for model counterparts to samples
C===========================================================

          IF ( sampleNo(num_file,bi,bj).GT.0 ) THEN
           iG=bi+(myXGlobalLo-1)/sNx ! Kludge until unstructered tiles
           jG=bj+(myYGlobalLo-1)/sNy ! Kludge until unstructered tiles

           JL  = ILNBLNK( obsfitDir )

           IF ( obsfitDoNcOutput ) THEN

            WRITE( obsfnameequinc,'(3A,I3.3,A,I3.3,A)' )
     &           obsfitDir(1:JL),obsfitFile(1:IL),
     &           '.',iG,'.',jG,'.equi.nc'
#ifdef ALLOW_ADJOINT_RUN
            WRITE( adobsfnameequinc,'(4A,I3.3,A,I3.3,A)' )
     &           obsfitDir(1:JL),'ad',obsfitFile(1:IL),
     &           '.',iG,'.',jG,'.equi.nc'
#endif
#ifdef ALLOW_TANGENTLINEAR_RUN
            WRITE( tlobsfnameequinc,'(4A,I3.3,A,I3.3,A)' )
     &           obsfitDir(1:JL),'tl',obsfitFile(1:IL),
     &           '.',iG,'.',jG,'.equi.nc'
#endif
            INQUIRE( file=obsfnameequinc, exist=exst )
            IF (.NOT.exst) THEN
             CALL OBSFIT_INIT_EQUIFILES( num_file,
     &            fiddata_obs(num_file),obsfnameequinc,
     &            fidfwd_obs(num_file,bi,bj),
     &            sampleNo(num_file,bi,bj),bi,bj,myThid )
             ELSE
              err = NF_OPEN( obsfnameequinc,NF_WRITE,
     &              fidfwd_obs(num_file,bi,bj) )
             ENDIF
#ifdef ALLOW_ADJOINT_RUN
             INQUIRE( file=adobsfnameequinc, exist=exst )
             IF (.NOT.exst) THEN
              CALL OBSFIT_INIT_EQUIFILES( num_file,
     &             fiddata_obs(num_file),adobsfnameequinc,
     &             fidadj_obs(num_file,bi,bj),
     &             sampleNo(num_file,bi,bj),bi,bj,myThid )
             ELSE
              err = NF_OPEN( adobsfnameequinc,NF_WRITE,
     &              fidadj_obs(num_file,bi,bj) )
             ENDIF
#endif
#ifdef ALLOW_TANGENTLINEAR_RUN
             INQUIRE( file=tlobsfnameequinc, exist=exst )
             IF (.NOT.exst) THEN
              CALL OBSFIT_INIT_EQUIFILES( num_file,
     &             fiddata_obs(num_file),tlobsfnameequinc,
     &             fidtan_obs(num_file,bi,bj),
     &             sampleNo(num_file,bi,bj),bi,bj,myThid )
             ELSE
              err = NF_OPEN( tlobsfnameequinc,NF_WRITE,
     &              fidtan_obs(num_file,bi,bj) )
             ENDIF
#endif
            ELSE !obsfitDoNcOutput

             WRITE( obsfnameequinc,'(3A,I3.3,A,I3.3,A)' )
     &            obsfitDir(1:JL),obsfitFile(1:IL),'.',iG,'.',jG,
     &            '.equi.data'
#ifdef ALLOW_ADJOINT_RUN
             WRITE( adobsfnameequinc,'(4A,I3.3,A,I3.3,A)' )
     &            obsfitDir(1:JL),'ad',
     &            obsfitFile(1:IL),'.',iG,'.',jG,'.equi.data'
#endif
#ifdef ALLOW_TANGENTLINEAR_RUN
             WRITE( tlobsfnameequinc,'(4A,I3.3,A,I3.3,A)' )
     &            obsfitDir(1:JL),'tl',
     &            obsfitFile(1:IL),'.',iG,'.',jG,'.equi.data'
#endif

             INQUIRE( file=obsfnameequinc, exist=exst )
#ifdef OBSFIT_USE_MDSFINDUNITS
             CALL MDSFINDUNIT( fidfwd_obs(num_file,bi,bj), myThid )
#else
             CALL OBSFIT_FINDUNIT( fidfwd_obs(num_file,bi,bj),
     &            myThid )
#endif
             IF (.NOT.exst) THEN
              CALL OBSFIT_INIT_EQUIFILES( num_file,
     &             fiddata_obs(num_file),obsfnameequinc,
     &             fidfwd_obs(num_file,bi,bj),
     &             sampleNo(num_file,bi,bj),bi,bj,myThid )
             ELSE
              OPEN( fidfwd_obs(num_file,bi,bj),
     &              file=obsfnameequinc,form ='unformatted',
     &              status='unknown',access='direct',
     &              recl=2*WORDLENGTH*2 )
             ENDIF
#ifdef ALLOW_ADJOINT_RUN
             INQUIRE( file=adobsfnameequinc, exist=exst )
#ifdef OBSFIT_USE_MDSFINDUNITS
             CALL MDSFINDUNIT( fidadj_obs(num_file,bi,bj), myThid )
#else
             CALL OBSFIT_FINDUNIT( fidadj_obs(num_file,bi,bj),
     &            myThid )
#endif
             IF (.NOT.exst) THEN
              CALL OBSFIT_INIT_EQUIFILES( num_file,
     &             fiddata_obs(num_file),adobsfnameequinc,
     &             fidadj_obs(num_file,bi,bj),
     &             sampleNo(num_file,bi,bj),bi,bj,myThid )
             ELSE
              OPEN( fidadj_obs(num_file,bi,bj),
     &              file=adobsfnameequinc,form ='unformatted',
     &              status='unknown', access='direct',
     &              recl=2*WORDLENGTH*2 )
             ENDIF
#endif
#ifdef ALLOW_TANGENTLINEAR_RUN
             INQUIRE( file=tlobsfnameequinc, exist=exst )
#ifdef OBSFIT_USE_MDSFINDUNITS
             CALL MDSFINDUNIT( fidtan_obs(num_file,bi,bj), myThid )
#else
             CALL OBSFIT_FINDUNIT( fidtan_obs(num_file,bi,bj),
     &            myThid )
#endif
             IF (.NOT.exst) THEN
              CALL OBSFIT_INIT_EQUIFILES( num_file,
     &             fiddata_obs(num_file),tlobsfnameequinc,
     &             fidtan_obs(num_file,bi,bj),
     &             sampleNo(num_file,bi,bj),bi,bj,myThid )
              ELSE
               OPEN( fidtan_obs(num_file,bi,bj),file=
     &               tlobsfnameequinc,form ='unformatted',
     &               status='unknown', access='direct',
     &               recl=2*WORDLENGTH*2 )
            ENDIF
#endif

           ENDIF !ObsfitDoNcOutput
          ENDIF !sampleNo
         ENDDO !bj
        ENDDO !bi

        CALL GLOBAL_SUM_INT(obs_is_ssh_loc, myThid)
        obs_is_ssh(num_file)=obs_is_ssh_loc

C===========================================================

       ELSE !if (IL.NE.0)

        DO bj = 1, nSy
         DO bi = 1, nSx
          ObsNo(num_file) = 0
          sampleNo(num_file,bi,bj) = 0
          DO ip = 1, NOBSMAX_OBS
           obs_np(num_file,ip) = -999. _d 0
          ENDDO
          DO ip = 1, NSAMP_PER_TILE_MAX
           sample_timeS(num_file,ip,bi,bj)    = -999. _d 0
           sample_timeE(num_file,ip,bi,bj)    = -999. _d 0
           sample_lon(num_file,ip,bi,bj)      = -999. _d 0
           sample_lat(num_file,ip,bi,bj)      = -999. _d 0
           sample_depth(num_file,ip,bi,bj)    = -999. _d 0
           sample_ind_glob(num_file,ip,bi,bj) = 0
           DO iq = 1,NUM_INTERP_PTS_OBS
            sample_interp_i(num_file,ip,iq,bi,bj)    = 1
            sample_interp_j(num_file,ip,iq,bi,bj)    = 1
            sample_interp_k(num_file,ip,iq,bi,bj)    = 1
            sample_interp_frac(num_file,ip,iq,bi,bj) = 0. _d 0
           ENDDO
           sample_interp_xC11(num_file,ip,bi,bj)   = -999. _d 0
           sample_interp_yC11(num_file,ip,bi,bj)   = -999. _d 0
           sample_interp_xCNINJ(num_file,ip,bi,bj) = -999. _d 0
           sample_interp_yCNINJ(num_file,ip,bi,bj) = -999. _d 0
          ENDDO
         ENDDO !bi
        ENDDO !bj

       ENDIF !if (IL.NE.0)
      ENDDO !num_file

C===========================================================
C error cases:
C===========================================================

c1) you want to provide interpolation information

C For generic grid. Needs to go inside bi,bj loop
      IF ( stopGenericGrid.EQ.2 ) THEN
c         iG=bi+(myXGlobalLo-1)/sNx ! Kludge until unstructered tiles
c         jG=bj+(myYGlobalLo-1)/sNy ! Kludge until unstructered tiles
ccgf XC grid
c       CALL MDSFINDUNIT( fid , myThid )
c       WRITE(obsfnameequinc(1:80),'(a,i3.3,a,i3.3,a,i4.4,a,i4.4,a)')
c     & 'profilesXCincl1PointOverlap.',iG,'.',jG,'.',sNx,'.',sNy,'.data'
c         k=MDS_RECLEN(64,(sNx+2)*(sNy+2),myThid)
c            WRITE(standardMessageUnit,'(A,/,2A)')
c     & 'OBSFIT_INIT_FIXED: creating grid from profiles; file:',
c     & obsfnameequinc
c       OPEN( fid, file= obsfnameequinc, form ='unformatted',
c     &      status='unknown',access='direct', recl= k)
c        DO m=0,sNy+1
c         DO l=0,sNx+1
c          xy_buffer_r8(l,m)=xC(l,m,bi,bj)
c         ENDDO
c        ENDDO
c#ifdef _BYTESWAPIO
c            CALL MDS_BYTESWAPR8((sNx+2)*(sNy+2),xy_buffer_r8)
c#endif
c       WRITE(fid,rec=1) xy_buffer_r8
c       close(fid)
ccgf YC grid
c       CALL MDSFINDUNIT( fid , myThid )
c       WRITE(obsfnameequinc(1:80),'(a,i3.3,a,i3.3,a,i4.4,a,i4.4,a)')
c     & 'profilesYCincl1PointOverlap.',iG,'.',jG,'.',sNx,'.',sNy,'.data'
c         k=MDS_RECLEN(64,(sNx+2)*(sNy+2),myThid)
c            WRITE(standardMessageUnit,'(A,/,A)')
c     & 'OBSFIT_INIT_FIXED: creating grid from profiles; file:',
c     & obsfnameequinc
c       OPEN( fid, file= obsfnameequinc, form ='unformatted',
c     & status='unknown', access='direct', recl= k)
c        DO m=0,sNy+1
c         DO l=0,sNx+1
c                xy_buffer_r8(l,m)=yC(l,m,bi,bj)
c         ENDDO
c        ENDDO
c#ifdef _BYTESWAPIO
c            CALL MDS_BYTESWAPR8((sNx+2)*(sNy+2),xy_buffer_r8)
c#endif
c       WRITE(fid,rec=1) xy_buffer_r8
c       close(fid)

       WRITE( msgBuf,'(3A)' )
     &      'OBSFIT_INIT_FIXED : ',
     &      'when using obsfitDoGenGrid ',
     &      'you have to provide interpolation fractions etc. '
       CALL PRINT_ERROR( msgBuf, myThid )
       WRITE( msgBuf,'(2A)' )
     &      'and some of your nc files dont have them. ',
     &      'You could use profiles_prep_mygrid.m and/or'
       CALL PRINT_ERROR( msgBuf, myThid )
       WRITE( msgBuf,'(A)' )
     &      'use the grid info in profiles*incl1PointOverlap*data'
       CALL PRINT_ERROR( msgBuf, myThid )
       stopObsfit=1

      ENDIF

      _END_MASTER( myThid )
      _BARRIER

c2) stop after other kind of errors
      CALL GLOBAL_SUM_INT( stopObsfit , myThid )
      IF ( stopObsfit.GE.1) THEN
       CALL ALL_PROC_DIE( myThid )
       STOP 'ABNORMAL END: S/R OBSFIT_INIT_FIXED'
      ENDIF

      CALL GLOBAL_SUM_INT( stopGenericGrid , myThid )
      IF ( stopGenericGrid.GE.1) THEN
       CALL ALL_PROC_DIE( myThid )
       STOP 'ABNORMAL END: S/R OBSFIT_INIT_FIXED'
      ENDIF

      WRITE(msgbuf,'(A)') ' '
      CALL PRINT_MESSAGE( msgbuf, iUnit, SQUEEZE_RIGHT, myThid )
      WRITE( msgbuf,'(A)' )
     &'// ======================================================='
      CALL PRINT_MESSAGE( msgbuf, iUnit, SQUEEZE_RIGHT, myThid )

      WRITE( msgbuf,'(A)' )
     &'// obsfit model sampling >>> END <<<'
      CALL PRINT_MESSAGE( msgbuf, iUnit, SQUEEZE_RIGHT, myThid )

      WRITE( msgbuf,'(A)' )
     &'// ======================================================='
      CALL PRINT_MESSAGE( msgbuf, iUnit, SQUEEZE_RIGHT, myThid )

      WRITE( msgbuf,'(A)' ) ' '
      CALL PRINT_MESSAGE( msgbuf, iUnit, SQUEEZE_RIGHT, myThid )

#endif

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#include "MOM_COMMON_OPTIONS.h"

CBOP
C     !ROUTINE: MOM_U_IMPLICIT_R
C     !INTERFACE:
      SUBROUTINE MOM_U_IMPLICIT_R(
     I                 kappaRU,
     I                 bi, bj, myTime, myIter, myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R MOM_U_IMPLICIT_R
C     | o Solve implicitly vertical advection & diffusion
C     |   of momentum, meridional component
C     *==========================================================*
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     == Global data ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "DYNVARS.h"
#include "FFIELDS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine Arguments ==
      _RL kappaRU(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr+1)
      INTEGER bi, bj
      _RL myTime
      INTEGER myIter, myThid

C     !LOCAL VARIABLES:
C     == Local variables ==
C iMin,iMax,jMin,jMax :: computational domain
C i,j,k     :: loop indices
C a5d       :: 2nd  lower diagonal of the pentadiagonal matrix
C b5d       :: 1rst lower diagonal of the pentadiagonal matrix
C c5d       :: main diagonal       of the pentadiagonal matrix
C d5d       :: 1rst upper diagonal of the pentadiagonal matrix
C e5d       :: 2nd  upper diagonal of the pentadiagonal matrix
C rTrans    :: vertical volume transport at interface k
C cDrag     :: bottom drag coefficient
C KE2d      :: horizontal Kinetic Energy
C diagonalNumber :: number of non-zero diagonals in the matrix
C errCode   :: > 0 if singular matrix
      INTEGER iMin,iMax,jMin,jMax
      PARAMETER( iMin = 1, iMax = sNx+1 )
      PARAMETER( jMin = 1, jMax = sNy )
      INTEGER i,j,k
      INTEGER diagonalNumber, errCode
c     _RL a5d(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL b5d(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL c5d(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL d5d(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
c     _RL e5d(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL rTrans(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL cDrag (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL KE2d  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL rCenter, rUpwind, upwindFac
#ifdef ALLOW_DIAGNOSTICS
      CHARACTER*8 diagName
      LOGICAL     DIAGNOSTICS_IS_ON
      EXTERNAL    DIAGNOSTICS_IS_ON
      _RL recip_dT
      _RL delUdt(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL vf    (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
#endif
CEOP

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C     Solve for U-component :
C----------------------------

C--   Initialise
      diagonalNumber = 1
      DO k=1,Nr
       DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
c        a5d(i,j,k) = 0. _d 0
         b5d(i,j,k) = 0. _d 0
         c5d(i,j,k) = 1. _d 0
         d5d(i,j,k) = 0. _d 0
c        e5d(i,j,k) = 0. _d 0
        ENDDO
       ENDDO
      ENDDO
      DO j=1-OLy,sNy+OLy
       DO i=1-OLx,sNx+OLx
         KE2d (i,j) = 0. _d 0
         cDrag(i,j) = 0. _d 0
       ENDDO
      ENDDO
#ifdef ALLOW_DIAGNOSTICS
      IF ( useDiagnostics .AND. ( implicitViscosity .OR.
     &                            selectImplicitDrag.GE.1 ) ) THEN
       DO k=1,Nr
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
           delUdt(i,j,k) = gU(i,j,k,bi,bj)
         ENDDO
        ENDDO
       ENDDO
      ENDIF
#endif /* ALLOW_DIAGNOSTICS */

      IF ( implicitViscosity .AND. Nr.GT.1 ) THEN

C--   set the tri-diagonal matrix to solve the implicit viscosity
       diagonalNumber = 3
C-     1rst lower diagonal :
       DO k=2,Nr
        DO j=jMin,jMax
         DO i=iMin,iMax
          IF (maskW(i,j,k-1,bi,bj).EQ.oneRS)
     &     b5d(i,j,k) = -deltaTMom
     &                  *_recip_hFacW(i,j,k,bi,bj)*recip_drF(k)
     &                  *recip_deepFac2C(k)*recip_rhoFacC(k)
     &                  *kappaRU(i,j, k )*recip_drC( k )
     &                  *deepFac2F( k )*rhoFacF( k )
         ENDDO
        ENDDO
       ENDDO
C-     1rst upper diagonal :
       DO k=1,Nr-1
        DO j=jMin,jMax
         DO i=iMin,iMax
          IF (maskW(i,j,k+1,bi,bj).EQ.oneRS)
     &     d5d(i,j,k) = -deltaTMom
     &                  *_recip_hFacW(i,j,k,bi,bj)*recip_drF(k)
     &                  *recip_deepFac2C(k)*recip_rhoFacC(k)
     &                  *kappaRU(i,j,k+1)*recip_drC(k+1)
     &                  *deepFac2F(k+1)*rhoFacF(k+1)
         ENDDO
        ENDDO
       ENDDO
C-     Main diagonal :
       DO k=1,Nr
        DO j=jMin,jMax
         DO i=iMin,iMax
           c5d(i,j,k) = 1. _d 0 - ( b5d(i,j,k) + d5d(i,j,k) )
         ENDDO
        ENDDO
       ENDDO

C--   end if implicitDiffusion
      ENDIF

      IF ( selectImplicitDrag.GE.1 ) THEN
C--   Add bottom and top drag coeff to main diagonal "c5d":

       IF ( no_slip_bottom .OR. selectBotDragQuadr.GE.0
     &                     .OR. bottomDragLinear.NE.0. ) THEN
        DO k=1,Nr
          CALL MOM_U_BOTDRAG_COEFF( bi, bj, k, .FALSE.,
     I                     uVel(1-OLx,1-OLy,k,bi,bj),
     I                     vVel(1-OLx,1-OLy,k,bi,bj),
     I                     kappaRU,
     U                     KE2d,
     O                     cDrag,
     I                     myIter, myThid )
          DO j=jMin,jMax
           DO i=iMin,iMax
             c5d(i,j,k) = c5d(i,j,k)
     &                  + cDrag(i,j)*deltaTMom
     &                  *_recip_hFacW(i,j,k,bi,bj)*recip_drF(k)
           ENDDO
          ENDDO
C--   Save (in 2-D array) drag-coeff for diagnostics of bottom-stress
          IF ( useDiagnostics ) THEN
           DO j=1-OLy,sNy+OLy
            DO i=1-OLx+1,sNx+OLx
              botDragU(i,j,bi,bj) = botDragU(i,j,bi,bj)
     &                            + cDrag(i,j)*rUnit2mass
            ENDDO
           ENDDO
          ENDIF
C-   End k loop
        ENDDO
       ENDIF

#ifdef ALLOW_SHELFICE
       IF ( useShelfIce ) THEN
C--   Add shelfice drag coeff to main diagonal "c5d":
        DO k=1,Nr
          CALL SHELFICE_U_DRAG_COEFF( bi, bj, k, .FALSE.,
     I                     uVel(1-OLx,1-OLy,k,bi,bj),
     I                     vVel(1-OLx,1-OLy,k,bi,bj),
     I                     kappaRU,
     U                     KE2d,
     O                     cDrag,
     I                     myIter, myThid )
          DO j=jMin,jMax
           DO i=iMin,iMax
             c5d(i,j,k) = c5d(i,j,k)
     &                  + cDrag(i,j)*deltaTMom
     &                  *_recip_hFacW(i,j,k,bi,bj)*recip_drF(k)
           ENDDO
          ENDDO
C-   End k loop
        ENDDO
       ENDIF
#endif /* ALLOW_SHELFICE */

C--   end if selectImplicitDrag > 0
      ENDIF

      IF ( momImplVertAdv .AND. Nr.GT.1 ) THEN

        diagonalNumber = 3
        DO k=2,Nr

          DO j=jMin,jMax
           DO i=iMin,iMax
            rTrans(i,j) = 0.5 _d 0 * (
     &                wVel( i ,j,k,bi,bj)*rA( i ,j,bi,bj)
     &                                 *maskC( i ,j,k-1,bi,bj)
     &              + wVel(i-1,j,k,bi,bj)*rA(i-1,j,bi,bj)
     &                                 *maskC(i-1,j,k-1,bi,bj)
     &                               )*deepFac2F(k)*rhoFacF(k)
           ENDDO
          ENDDO

          IF ( vectorInvariantMomentum ) THEN
C-          space Centered/Upwind advection scheme, Advective form:
            IF ( upwindShear ) THEN
              upwindFac = 1. _d 0
            ELSE
              upwindFac = 0. _d 0
            ENDIF
            DO j=jMin,jMax
             DO i=iMin,iMax
              rCenter = 0.5 _d 0 *deltaTMom*rTrans(i,j)
     &                           *recip_rAw(i,j,bi,bj)*rkSign
              rUpwind = ABS(rCenter)*upwindFac
              b5d(i,j,k) = b5d(i,j,k)
     &                   - (rCenter+rUpwind)
     &                     *_recip_hFacW(i,j,k,bi,bj)*recip_drF(k)
     &                     *recip_deepFac2C(k)*recip_rhoFacC(k)
              c5d(i,j,k) = c5d(i,j,k)
     &                   + (rCenter+rUpwind)
     &                     *_recip_hFacW(i,j,k,bi,bj)*recip_drF(k)
     &                     *recip_deepFac2C(k)*recip_rhoFacC(k)
              c5d(i,j,k-1) = c5d(i,j,k-1)
     &                   - (rCenter-rUpwind)
     &                     *_recip_hFacW(i,j,k-1,bi,bj)*recip_drF(k-1)
     &                     *recip_deepFac2C(k-1)*recip_rhoFacC(k-1)
              d5d(i,j,k-1) = d5d(i,j,k-1)
     &                   + (rCenter-rUpwind)
     &                     *_recip_hFacW(i,j,k-1,bi,bj)*recip_drF(k-1)
     &                     *recip_deepFac2C(k-1)*recip_rhoFacC(k-1)
             ENDDO
            ENDDO
          ELSE
C-          space Centered advection scheme, Flux form:
            DO j=jMin,jMax
             DO i=iMin,iMax
              rCenter = 0.5 _d 0 *deltaTMom*rTrans(i,j)
     &                           *recip_rAw(i,j,bi,bj)*rkSign
              b5d(i,j,k) = b5d(i,j,k)
     &            - rCenter*_recip_hFacW(i,j,k,bi,bj)*recip_drF(k)
     &                     *recip_deepFac2C(k)*recip_rhoFacC(k)
              c5d(i,j,k) = c5d(i,j,k)
     &            - rCenter*_recip_hFacW(i,j,k,bi,bj)*recip_drF(k)
     &                     *recip_deepFac2C(k)*recip_rhoFacC(k)
              c5d(i,j,k-1) = c5d(i,j,k-1)
     &            + rCenter*_recip_hFacW(i,j,k-1,bi,bj)*recip_drF(k-1)
     &                     *recip_deepFac2C(k-1)*recip_rhoFacC(k-1)
              d5d(i,j,k-1) = d5d(i,j,k-1)
     &            + rCenter*_recip_hFacW(i,j,k-1,bi,bj)*recip_drF(k-1)
     &                     *recip_deepFac2C(k-1)*recip_rhoFacC(k-1)
             ENDDO
            ENDDO
            STOP 'MOM_IMPLICIT_R: Flux Form not yet finished.'
          ENDIF

C--     end k loop
        ENDDO

C--   end if momImplVertAdv
      ENDIF

      IF ( diagonalNumber .EQ. 1 ) THEN
        errCode = 0
        DO k=1,Nr
         DO j=jMin,jMax
          DO i=iMin,iMax
            IF ( c5d(i,j,k).NE.zeroRL ) THEN
             c5d(i,j,k) = 1. _d 0 / c5d(i,j,k)
            ELSE
             c5d(i,j,k) = 0. _d 0
             errCode = 1
            ENDIF
          ENDDO
         ENDDO
         DO j=jMin,jMax
          DO i=iMin,iMax
            gU(i,j,k,bi,bj) = gU(i,j,k,bi,bj)*c5d(i,j,k)
          ENDDO
         ENDDO
        ENDDO
        IF (errCode.GE.1) THEN
          STOP 'MOM_IMPLICIT_R: error when solving 1-Diag problem.'
        ENDIF
      ELSEIF ( diagonalNumber .EQ. 3 ) THEN
C--   Solve tri-diagonal system :
        errCode = -1
        CALL SOLVE_TRIDIAGONAL( iMin,iMax, jMin,jMax,
     I                          b5d, c5d, d5d,
     U                          gU(1-OLx,1-OLy,1,bi,bj),
     O                          errCode,
     I                          bi, bj, myThid )
        IF (errCode.GE.1) THEN
          STOP 'MOM_IMPLICIT_R: error when solving 3-Diag problem.'
        ENDIF
      ELSE
        STOP 'MOM_IMPLICIT_R: no solver available.'
      ENDIF

#ifdef ALLOW_SOLVE4_PS_AND_DRAG
      IF ( selectImplicitDrag.EQ.2 ) THEN
       DO k=1,Nr
        DO j=jMin,jMax
         DO i=iMin,iMax
           dU_psFacX(i,j,k,bi,bj) = maskW(i,j,k,bi,bj)
     &                             *recip_deepFacC(k)*recip_rhoFacC(k)
         ENDDO
        ENDDO
       ENDDO
       IF ( diagonalNumber .EQ. 1 ) THEN
        DO k=1,Nr
         DO j=jMin,jMax
          DO i=iMin,iMax
           dU_psFacX(i,j,k,bi,bj) = dU_psFacX(i,j,k,bi,bj)*c5d(i,j,k)
          ENDDO
         ENDDO
        ENDDO
       ELSEIF ( diagonalNumber .EQ. 3 ) THEN
        CALL SOLVE_TRIDIAGONAL( iMin,iMax, jMin,jMax,
     I                          b5d, c5d, d5d,
     U                          dU_psFacX(1-OLx,1-OLy,1,bi,bj),
     O                          errCode,
     I                          bi, bj, myThid )
       ENDIF
      ENDIF
#endif /* ALLOW_SOLVE4_PS_AND_DRAG */

#ifdef ALLOW_DIAGNOSTICS
C--   Diagnostics of momentum dissipation/viscous tendency, implicit part:
      IF ( useDiagnostics .AND. ( implicitViscosity .OR.
     &                            selectImplicitDrag.GE.1 ) ) THEN
       diagName = 'Um_ImplD'
       IF ( DIAGNOSTICS_IS_ON(diagName,myThid) ) THEN
         recip_dT = 0. _d 0
         IF ( deltaTMom.GT.zeroRL ) recip_dT = oneRL / deltaTMom
         DO k=1,Nr
          DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
            delUdt(i,j,k) = ( gU(i,j,k,bi,bj)-delUdt(i,j,k) )*recip_dT
           ENDDO
          ENDDO
         ENDDO
         CALL DIAGNOSTICS_FILL(delUdt,diagName, 0,Nr, 2,bi,bj, myThid)
       ENDIF
      ENDIF

C--   Diagnostics of vertical viscous flux:
      IF ( useDiagnostics .AND. implicitViscosity ) THEN
       diagName = 'VISrI_Um'
       IF ( DIAGNOSTICS_IS_ON(diagName,myThid) ) THEN
         DO k= 1,Nr
          IF ( k.EQ.1 ) THEN
C-  Note: Needs to call DIAGNOSTICS_FILL at level k=1 even if array == 0
C         otherwise counter is not incremented !!
            DO j=1-OLy,sNy+OLy
             DO i=1-OLx,sNx+OLx
               vf(i,j) = 0. _d 0
             ENDDO
            ENDDO
          ELSE
            DO j=jMin,jMax
             DO i=iMin,iMax
               vf(i,j) = -rAw(i,j,bi,bj)*deepFac2F(k)*rhoFacF(k)
     &            * kappaRU(i,j,k)*recip_drC(k)*rkSign
     &            * (gU(i,j,k,bi,bj) - gU(i,j,k-1,bi,bj))
     &            *_maskW(i,j,k,bi,bj)
     &            *_maskW(i,j,k-1,bi,bj)
             ENDDO
            ENDDO
          ENDIF
          CALL DIAGNOSTICS_FILL(vf,diagName, k,1, 2,bi,bj, myThid)
         ENDDO
       ENDIF
      ENDIF
#endif /* ALLOW_DIAGNOSTICS */

      RETURN
      END

#include "SEAICE_OPTIONS.h"

CBOP
C !ROUTINE: SEAICE_ITD_SUM

C !INTERFACE: ==========================================================
      SUBROUTINE SEAICE_ITD_SUM(
     I                  bi, bj, myTime, myIter, myThid )

C !DESCRIPTION: \bv
C     *===========================================================*
C     | SUBROUTINE SEAICE_ITD_SUM
C     | o sum ice area and volume over all ITD categories
C     |   and write into AREA and HEFF
C     |
C     | Torge Martin, Mar. 2012, torge@mit.edu
C     *===========================================================*
C \ev

C !USES: ===============================================================
      IMPLICIT NONE

C     === Global variables ===
C     nITD      :: number of seaice thickness categories
C     AREA      :: sea ice area   total
C     AREAITD   :: sea ice area   by category
C     HEFF      :: sea ice volume total
C     HEFFITD   :: sea ice volume by category
C     HSNOW     :: snow    volume total
C     HSNOWITD  :: snow    volume by category
#include "SIZE.h"
#include "EEPARAMS.h"
c#include "PARAMS.h"
#include "SEAICE_SIZE.h"
c#include "SEAICE_PARAMS.h"
#include "SEAICE.h"

C !INPUT PARAMETERS: ===================================================
C     bi,bj     :: Current tile indices
C     myTime    :: Current time in simulation
C     myIter    :: Current iteration number
C     myThid    :: my Thread Id number
      _RL myTime
      INTEGER bi, bj
      INTEGER myIter
      INTEGER myThid
CEOP

#ifdef SEAICE_ITD
C !LOCAL VARIABLES: ====================================================
C     i,j,k     :: inner loop counters
      INTEGER i, j, k

C---+-|--1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

c      DO bj=myByLo(myThid),myByHi(myThid)
c       DO bi=myBxLo(myThid),myBxHi(myThid)
C must now be called within bi,bj loop

        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
           AREA (i,j,bi,bj) = AREAITD (i,j,1,bi,bj)
           HEFF (i,j,bi,bj) = HEFFITD (i,j,1,bi,bj)
           HSNOW(i,j,bi,bj) = HSNOWITD(i,j,1,bi,bj)
         ENDDO
        ENDDO

        DO k=2,nITD
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           AREA (i,j,bi,bj) = AREA (i,j,bi,bj) + AREAITD (i,j,k,bi,bj)
           HEFF (i,j,bi,bj) = HEFF (i,j,bi,bj) + HEFFITD (i,j,k,bi,bj)
           HSNOW(i,j,bi,bj) = HSNOW(i,j,bi,bj) + HSNOWITD(i,j,k,bi,bj)
          ENDDO
         ENDDO
        ENDDO

c       ENDDO
c      ENDDO

C---+-|--1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
#endif /* SEAICE_ITD */
      RETURN
      END

#include "PACKAGES_CONFIG.h"
#include "CPP_OPTIONS.h"
#ifdef ALLOW_GMREDI
# include "GMREDI_OPTIONS.h"
#endif

C--  File taueddy_tendency_apply.F: Routines to apply TAUEDDY tendencies
C--   Contents
C--   o TAUEDDY_TENDENCY_APPLY_U
C--   o TAUEDDY_TENDENCY_APPLY_V

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: TAUEDDY_TENDENCY_APPLY_U
C     !INTERFACE:
      SUBROUTINE TAUEDDY_TENDENCY_APPLY_U(
     U                     gU_arr,
     I                     iMin,iMax,jMin,jMax, k, bi, bj,
     I                     myTime, myIter, myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R TAUEDDY_TENDENCY_APPLY_U
C     | o Contains problem specific forcing for zonal velocity.
C     *==========================================================*
C     | Adds terms to gU for forcing by external sources
C     | e.g. wind stress, bottom friction etc..................
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     == Global data ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "FFIELDS.h"
#ifdef ALLOW_GMREDI
# include "GMREDI.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     gU_arr    :: the tendency array
C     iMin,iMax :: Working range of x-index for applying forcing.
C     jMin,jMax :: Working range of y-index for applying forcing.
C     k         :: Current vertical level index
C     bi,bj     :: Current tile indices
C     myTime    :: Current time in simulation
C     myIter    :: Current iteration number
C     myThid    :: my Thread Id number
      _RL     gU_arr(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER iMin, iMax, jMin, jMax
      INTEGER k, bi, bj
      _RL     myTime
      INTEGER myIter
      INTEGER myThid
CEOP

#ifdef ALLOW_EDDYPSI
C     !LOCAL VARIABLES:
C     i, j      :: Loop counters
      INTEGER i, j
      INTEGER kp1
      _RL maskm1, maskp1

C     Add zonal eddy momentum impulse into the layer
#ifdef ALLOW_GMREDI
      IF ( GM_InMomAsStress ) THEN
#endif
      kp1 = MIN(k+1,Nr)
      maskp1 = 1.
      maskm1 = 1.
      IF (k.EQ.Nr) maskp1 = 0.
      IF (k.EQ.1)  maskm1 = 0.
      DO j=jMin,jMax
       DO i=iMin,iMax
        gU_arr(i,j) = gU_arr(i,j)
     &  +foFacMom*recip_rhoConst*
     &  ( maskm1*_maskW(i,j, k ,bi,bj)*tauxEddy(i,j, k ,bi,bj)
     &  - maskp1*_maskW(i,j,kp1,bi,bj)*tauxEddy(i,j,kp1,bi,bj) )
     &  *recip_drF(k)*_recip_hFacW(i,j,k,bi,bj)
       ENDDO
      ENDDO
#ifdef ALLOW_GMREDI
      ENDIF
#endif

#endif /* ALLOW_EDDYPSI */

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: TAUEDDY_TENDENCY_APPLY_V
C     !INTERFACE:
      SUBROUTINE TAUEDDY_TENDENCY_APPLY_V(
     U                     gV_arr,
     I                     iMin,iMax,jMin,jMax, k, bi, bj,
     I                     myTime, myIter, myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R TAUEDDY_TENDENCY_APPLY_V
C     | o Contains problem specific forcing for merid velocity.
C     *==========================================================*
C     | Adds terms to gV for forcing by external sources
C     | e.g. wind stress, bottom friction etc..................
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     == Global data ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "FFIELDS.h"
#ifdef ALLOW_GMREDI
#include "GMREDI.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     gV_arr    :: the tendency array
C     iMin,iMax :: Working range of x-index for applying forcing.
C     jMin,jMax :: Working range of y-index for applying forcing.
C     k         :: Current vertical level index
C     bi,bj     :: Current tile indices
C     myTime    :: Current time in simulation
C     myIter    :: Current iteration number
C     myThid    :: my Thread Id number
      _RL     gV_arr(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER iMin, iMax, jMin, jMax
      INTEGER k, bi, bj
      _RL     myTime
      INTEGER myIter
      INTEGER myThid
CEOP

#ifdef ALLOW_EDDYPSI
C     !LOCAL VARIABLES:
C     i, j      :: Loop counters
      INTEGER i, j
      INTEGER kp1
      _RL maskm1, maskp1

C     Add meridional eddy momentum impulse into the layer
#ifdef ALLOW_GMREDI
      IF ( GM_InMomAsStress ) THEN
#endif
      kp1 = MIN(k+1,Nr)
      maskp1 = 1.
      maskm1 = 1.
      IF (k.EQ.Nr) maskp1 = 0.
      IF (k.EQ.1)  maskm1 = 0.
      DO j=jMin,jMax
       DO i=iMin,iMax
        gV_arr(i,j) = gV_arr(i,j)
     &  +foFacMom*recip_rhoConst*
     &  ( maskm1*_maskS(i,j, k ,bi,bj)*tauyEddy(i,j, k ,bi,bj)
     &  - maskp1*_maskS(i,j,kp1,bi,bj)*tauyEddy(i,j,kp1,bi,bj) )
     &  *recip_drF(k)*_recip_hFacS(i,j,k,bi,bj)
       ENDDO
      ENDDO
#ifdef ALLOW_GMREDI
      ENDIF
#endif

#endif /* ALLOW_EDDYPSI */

      RETURN
      END

#include "ctrparam.h"
#include "ATM2D_OPTIONS.h"

C     !INTERFACE:
      SUBROUTINE YR_END_DIAGS(  iyr, myTime, myIter, myThid )
C     *==========================================================*
C     | Normalize and dump year-end annual mean diagnostics      |
c     |                                                          |
C     *==========================================================*
        IMPLICIT NONE

C     === Global Atmosphere Variables ===
#include "ATMSIZE.h"
#include "SIZE.h"
#include "GRID.h"
#include "EEPARAMS.h"
#include "ATM2D_VARS.h"


C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
C     iyr    - current year of simulation
C     myTime - current simulation time (ocean model time)
C     myIter - iteration number (ocean model)
C     myThid - Thread no. that called this routine.
      INTEGER iyr
      _RL     myTime
      INTEGER myIter
      INTEGER myThid

C     LOCAL VARIABLES:
      _RL secYr
      DATA secYr /31536000.D0/
      _RL norm_factor

      norm_factor = globalArea * secYr / dtcouplo
      sst_tave = sst_tave / norm_factor
      sss_tave = sss_tave / norm_factor
      HF2ocn_tave = HF2ocn_tave / norm_factor
      FW2ocn_tave = FW2ocn_tave / norm_factor
      CO2flx_tave = CO2flx_tave / norm_factor

      OPEN(25,ACCESS='APPEND',FILE='resocean.dat',STATUS='old')

      WRITE(25,*) '      '
      WRITE(25,*) '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~'
      WRITE(25,*) 'YEAR MEAN', iyr
      WRITE(25,*) 'SST SSS', sst_tave, sss_tave
      WRITE(25,*) 'HFLUX FWFLUX',  HF2ocn_tave,  FW2ocn_tave
      WRITE(25,*) 'SH ICE', SHice_max*1. _d -12, SHice_min*1. _d -12
      WRITE(25,*) 'NH ICE', NHice_max*1. _d -12, NHice_min*1. _d -12
      IF  (CO2flx_tave .NE. 0. _d 0)
     &   WRITE(25,*) 'OCEAN CO2FLUX', CO2flx_tave
      WRITE(25,*) '~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~'
      WRITE(25,*) '      '

      CLOSE(25)

      SHice_min = 1. _d 18
      NHice_min = 1. _d 18
      SHice_max = 0. _d 0
      NHice_max = 0. _d 0
      sst_tave =  0. _d 0
      sss_tave =  0. _d 0
      HF2ocn_tave =  0. _d 0
      FW2ocn_tave =  0. _d 0
      CO2flx_tave =  0. _d 0

      RETURN
      END

#include "MDSIO_OPTIONS.h"

CBOP
C !ROUTINE: MDS_WRITE_TAPE
C !INTERFACE:
      SUBROUTINE MDS_WRITE_TAPE(
     I   fName,
     I   filePrec,
     I   globalfile,
     I   arrType,
     I   nSize,
     I   fldR8, fldR4,
     I   singleCpuIO,
     I   iRec,
     I   myIter,
     I   myThid )

C !DESCRIPTION:
C MDS_WRITE_TAPE: write an array (treated as vector) to a tape-file
C  (renamed from MDSWRITEVECTOR with 2 explicit input array types)
C
C Arguments:
C fName      string  :: base name for file to write
C filePrec   integer :: number of bits per word in file (32 or 64)
C globalFile logical :: selects between writing a global or tiled file
C arrType    char(2) :: which array (fldR8/R4) to write, either "R8" or "R4"
C nSize      integer :: number of elements of input array "fldR8/R4" to write
C fldR8      ( R8 )  :: array to write if arrType="R8", fldR8(nSize)
C fldR4      ( R4 )  :: array to write if arrType="R4", fldR4(nSize)
C bi,bj      integer :: tile indices (if tiled array)
C singleCpuIO ( L )  :: only proc 0 do IO and collect data from other procs
C iRec       integer :: record number to write
C myIter     integer :: time step number
C myThid     integer :: my Thread Id number

C !USES:
      IMPLICIT NONE

C-- Global variables --
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"

C !INPUT/OUTPUT PARAMETERS:
      CHARACTER*(*) fName
      INTEGER filePrec
      LOGICAL globalfile
      CHARACTER*(2) arrType
      INTEGER nSize
      _R8     fldR8(*)
      _R4     fldR4(*)
      LOGICAL singleCpuIO
      INTEGER iRec
      INTEGER myIter
      INTEGER myThid

#ifdef ALLOW_AUTODIFF

C !FUNCTIONS:
      INTEGER ILNBLNK
      INTEGER MDS_RECLEN
      EXTERNAL ILNBLNK
      EXTERNAL MDS_RECLEN

C !LOCAL VARIABLES:
      CHARACTER*(MAX_LEN_FNAM) dataFName, metaFName, pfName
      INTEGER iG, jG, jRec, dUnit, IL, pIL
      INTEGER dimList(3,1), nDims, map2gl(2)
      INTEGER length_of_rec
      CHARACTER*(MAX_LEN_MBUF) msgBuf

C simple implementation of singleCpuIO without any specific EXCH2
C feature (should work as long as reading and writing match)
      INTEGER j
      INTEGER vec_size
C Note: would be better to use explicit (allocate/delocate) dynamical
C       allocation instead of this implicit form:
      _R8    gl_buffer_r8(nSize*nPx*nPy)
      _R4    gl_buffer_r4(nSize*nPx*nPy)
      _R8    local_r8    (nSize)
      _R4    local_r4    (nSize)
      _RL dummyRL(1)
      CHARACTER*8 blank8c
CEOP

      DATA dummyRL(1) / 0. _d 0 /
      DATA blank8c / '        ' /
      DATA map2gl  / 0, 1 /

      vec_size = nSize*nPx*nPy

C--   Copy input array to local buffer
        IF ( arrType.EQ.'R4' ) THEN
          IF ( filePrec.EQ.precFloat32 ) THEN
            DO j=1,nSize
              local_r4(j) = fldR4(j)
            ENDDO
          ELSE
            DO j=1,nSize
              local_r8(j) = fldR4(j)
            ENDDO
          ENDIF
        ELSEIF ( arrType.EQ.'R8' ) THEN
          IF ( filePrec.EQ.precFloat32 ) THEN
            DO j=1,nSize
              local_r4(j) = fldR8(j)
            ENDDO
          ELSE
            DO j=1,nSize
              local_r8(j) = fldR8(j)
            ENDDO
          ENDIF
        ELSE
          WRITE(msgBuf,'(A)')
     &         ' MDS_WRITE_TAPE: illegal value for arrType'
          CALL PRINT_ERROR( msgBuf, myThid )
          STOP 'ABNORMAL END: S/R MDS_WRITE_TAPE'
        ENDIF

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C--   Only do I/O if I am the master thread
      _BEGIN_MASTER( myThid )

C-    Record number must be >= 1
      IF ( iRec.LT.1 ) THEN
       WRITE(msgBuf,'(A,I10)')
     &   ' MDS_WRITE_TAPE: argument iRec =',iRec
       CALL PRINT_ERROR( msgBuf, myThid )
       WRITE(msgBuf,'(A)')
     &   ' MDS_WRITE_TAPE: invalid value for iRec'
       CALL PRINT_ERROR( msgBuf, myThid )
       STOP 'ABNORMAL END: S/R MDS_WRITE_TAPE'
      ENDIF

C-    Assume nothing
      IL  = ILNBLNK( fName )
      pIL = ILNBLNK( mdsioLocalDir )

C-    Assign special directory
      IF ( pIL.EQ.0 ) THEN
        pfName = fName
      ELSE
        WRITE(pfName,'(2A)') mdsioLocalDir(1:pIL), fName(1:IL)
      ENDIF
      pIL = ILNBLNK( pfName )
      IF ( debugLevel.GE.debLevC .AND.
     &     ( .NOT.singleCpuIO .OR. myProcId.EQ.0 ) ) THEN
        WRITE(msgBuf,'(A,I8,2A)')
     &      ' MDS_WRITE_TAPE: iRec=', iRec, ', file=', pfName(1:pIL)
        CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
      ENDIF

C-    Assign a free unit number as the I/O channel for this routine
      CALL MDSFINDUNIT( dUnit, myThid )

C     If option globalFile is desired but does not work or if
C     globalFile is too slow, then try using single-CPU I/O.
      IF ( singleCpuIO ) THEN

C-    Gather array from all procs
        IF ( filePrec.EQ.precFloat32 ) THEN
          CALL GATHER_VEC_R4( gl_buffer_r4, local_r4, nSize, myThid )
        ELSEIF ( filePrec.EQ.precFloat64 ) THEN
          CALL GATHER_VEC_R8( gl_buffer_r8, local_r8, nSize, myThid )
        ELSE
          WRITE(msgBuf,'(A)')
     &            ' MDS_WRITE_TAPE: illegal value for filePrec'
          CALL PRINT_ERROR( msgBuf, myThid )
          STOP 'ABNORMAL END: S/R MDS_WRITE_TAPE'
        ENDIF

        IF ( myProcId .EQ. 0 ) THEN
C--   Master thread of process 0, only, opens a global file

         WRITE(dataFName,'(2a)') fName(1:IL),'.data'
         length_of_rec = MDS_RECLEN( filePrec, vec_size, myThid )
         IF (iRec .EQ. 1) THEN
          OPEN( dUnit, file=dataFName, status=_NEW_STATUS,
     &          access='direct', recl=length_of_rec )
         ELSE
          OPEN( dUnit, file=dataFName, status=_OLD_STATUS,
     &          access='direct', recl=length_of_rec )
         ENDIF

C-    Write global buffer to file:
         IF ( filePrec.EQ.precFloat32 ) THEN
#ifdef _BYTESWAPIO
           CALL MDS_BYTESWAPR4( vec_size, gl_buffer_r4 )
#endif
           WRITE(dUnit,rec=iRec) gl_buffer_r4
         ELSEIF ( filePrec.EQ.precFloat64 ) THEN
#ifdef _BYTESWAPIO
           CALL MDS_BYTESWAPR8( vec_size, gl_buffer_r8 )
#endif
           WRITE(dUnit,rec=iRec) gl_buffer_r8
         ENDIF

C-    Close data-file and create meta-file
         CLOSE( dUnit )
         WRITE(metaFName,'(2a)') fName(1:IL),'.meta'
         dimList(1,1) = vec_size
         dimList(2,1) = 1
         dimList(3,1) = vec_size
         nDims = 1
         CALL MDS_WRITE_META(
     I              metaFName, dataFName, the_run_name, ' ',
     I              filePrec, nDims, dimList, map2gl, 0, blank8c,
     I              0, dummyRL, oneRL, iRec, myIter, myThid )

C-    end if myProcId=0
        ENDIF

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C     if ( singleCpuIO ), else
      ELSEIF ( .NOT. singleCpuIO ) THEN

        IF ( globalFile ) THEN
C-    If we are writing to a global file then we open it here
         WRITE(dataFName,'(2A)') fName(1:IL),'.data'
         length_of_rec = MDS_RECLEN( filePrec, nSize, myThid )
         IF ( iRec.EQ.1 ) THEN
          OPEN( dUnit, file=dataFName, status=_NEW_STATUS,
     &          access='direct', recl=length_of_rec )
         ELSE
          OPEN( dUnit, file=dataFName, status=_OLD_STATUS,
     &          access='direct', recl=length_of_rec )
         ENDIF

        ELSE
C-    If we are writing to a tiled MDS file then we open each one here
         iG = 1 + (myXGlobalLo-1)/sNx
         jG = 1 + (myYGlobalLo-1)/sNy
         WRITE(dataFName,'(2A,I3.3,A,I3.3,A)')
     &              pfName(1:pIL),'.',iG,'.',jG,'.data'
         length_of_rec = MDS_RECLEN( filePrec, nSize, myThid )
         IF (iRec .EQ. 1) THEN
          OPEN( dUnit, file=dataFName, status=_NEW_STATUS,
     &          access='direct', recl=length_of_rec )
         ELSE
          OPEN( dUnit, file=dataFName, status=_OLD_STATUS,
     &          access='direct', recl=length_of_rec )
         ENDIF
        ENDIF

C-    Write local buffer to file:
        IF (globalFile) THEN
C-- Original: nPy=2, nSx=2 -> produces too large file (1.5 x normal size)
c          iG   = myXGlobalLo-1+(bi-1)*sNx
c          jG   = myYGlobalLo-1+(bj-1)*sNy
c          jRec = 1 + int(iG/sNx) + (jG/sNy)*nSx*nPx +
c    &            (iRec-1)*nSx*nPx*nSy*nPy
C-- Alternative: same layout as in scatter/gather_vector (for singleCpuIO)
C   problem: nPx=2, nSx=2, writing a global (i.e., with bi,bj dim);
C-         2nd proc get iG=3 -> badly placed data over nPx*nPy*nSize range
C                               that will be overwritten by next record
c          iG   = 1 + (myXGlobalLo-1)/sNx
c          jG   = 1 + (myYGlobalLo-1)/sNy
c          jRec = iG + (jG-1)*nPx + (iRec-1)*nPx*nPy
C-- Simpler: should work (but hard to interpret the sequence of data in file)
           jRec = 1 + myProcId + (iRec-1)*nPx*nPy
        ELSE
           jRec = iRec
        ENDIF
        IF ( filePrec.EQ.precFloat32 ) THEN
#ifdef _BYTESWAPIO
           CALL MDS_BYTESWAPR4( nSize, local_r4 )
#endif
           WRITE(dUnit,rec=jRec) local_r4
        ELSEIF ( filePrec.EQ.precFloat64 ) THEN
#ifdef _BYTESWAPIO
           CALL MDS_BYTESWAPR8( nSize, local_r8 )
#endif
           WRITE(dUnit,rec=jRec) local_r8
        ELSE
           WRITE(msgBuf,'(A)')
     &           ' MDS_WRITE_TAPE: illegal value for filePrec'
           CALL PRINT_ERROR( msgBuf, myThid )
           STOP 'ABNORMAL END: S/R MDS_WRITE_TAPE'
        ENDIF

C-    Close data-file and create meta-file
        CLOSE( dUnit )
        IF ( globalFile ) THEN
C     meta-file for global file
          WRITE(metaFName,'(2A)') fName(1:IL),'.meta'
          dimList(1,1) = vec_size
          dimList(2,1) = 1
          dimList(3,1) = vec_size
          nDims = 1
        ELSE
C     meta-file for tiled file
          iG = 1 + (myXGlobalLo-1)/sNx
          jG = 1 + (myYGlobalLo-1)/sNy
          WRITE(metaFName,'(2A,I3.3,A,I3.3,A)')
     &             pfName(1:pIL),'.',iG,'.',jG,'.meta'
          dimList(1,1) = nPx*nPy*nSize
          dimList(2,1) = 1 + myProcId*nSize
          dimList(3,1) = (1+myProcId)*nSize
          nDims = 1
        ENDIF
C-    write meta-file
        CALL MDS_WRITE_META(
     I              metaFName, dataFName, the_run_name, ' ',
     I              filePrec, nDims, dimList, map2gl, 0, blank8c,
     I              0, dummyRL, oneRL, iRec, myIter, myThid )
c    I              metaFName, dataFName, the_run_name, titleLine,
c    I              filePrec, nDims, dimList, map2gl, nFlds, fldList,
c    I              nTimRec, timList, misVal, iRec, myIter, myThid )

C     end-if ( .not. singleCpuIO )
      ENDIF

      _END_MASTER( myThid )

#else /* ALLOW_AUTODIFF */
      STOP 'ABNORMAL END: S/R MDS_WRITE_TAPE is empty'
#endif /* ALLOW_AUTODIFF */

      RETURN
      END

#include "GMREDI_OPTIONS.h"
#ifdef ALLOW_CTRL
# include "CTRL_OPTIONS.h"
#endif

CBOP
C     !ROUTINE: GMREDI_READPARMS
C     !INTERFACE:
      SUBROUTINE GMREDI_READPARMS( myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE GMREDI_READPARMS
C     | o Routine to initialize GM/Redi variables and constants.
C     *==========================================================*
C     | Initialize GM/Redi parameters, read in data.gmredi
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "GMREDI.h"

C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
      INTEGER myThid

#ifdef ALLOW_GMREDI
C     !LOCAL VARIABLES:
C     === Local variables ===
C     msgBuf     :: Informational/error message buffer
C     iUnit      :: Work variable for IO unit number
C     nRetired   :: Counter used to trap "retired" parameters in namelist.
C     GM_isopycK3dFile      :: input file for 3.D GM_isopycK
C     GM_background_K3dFile :: input file for 3.D GM_background_K
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      INTEGER iUnit
      INTEGER nRetired
      CHARACTER*(MAX_LEN_FNAM) GM_isopycK3dFile
      CHARACTER*(MAX_LEN_FNAM) GM_background_K3dFile
CEOP

C--   GM/Redi parameter
C     GM_Small_Number  :: epsilon used in computing the slope
C     GM_slopeSqCutoff :: slope^2 cut-off value
      NAMELIST /GM_PARM01/
     &          GM_AdvForm, GM_AdvSeparate,
     &          GM_InMomAsStress,
     &          GM_isopycK,
     &          GM_background_K,
     &          GM_iso2dFile, GM_iso1dFile,
     &          GM_bol2dFile, GM_bol1dFile,
     &          GM_K3dRediFile, GM_K3dGMFile,
     &          GM_background_K3dFile, GM_isopycK3dFile,
     &          GM_taper_scheme,
     &          GM_maxSlope,
     &          GM_Kmin_horiz,
     &          GM_Small_Number, GM_slopeSqCutoff,
     &          GM_Scrit, GM_Sd,
     &          GM_isoFac_calcK,
     &          GM_facTrL2dz, GM_facTrL2ML, GM_maxTransLay,
     &          GM_UseBVP, GM_BVP_cMin, GM_BVP_ModeNumber,
     &          GM_useSubMeso, subMeso_Ceff, subMeso_invTau,
     &          subMeso_LfMin, subMeso_Lmax,
     &          GM_Visbeck_alpha, GM_Visbeck_length,
     &          GM_Visbeck_depth,
     &          GM_Visbeck_minDepth, GM_Visbeck_maxSlope,
     &          GM_Visbeck_minVal_K, GM_Visbeck_maxVal_K,
     &          GM_useBatesK3d, GM_Bates_smooth, GM_Bates_use_constK,
     &          GM_Bates_beta_eq_0, GM_Bates_ThickSheet,
     &          GM_Bates_surfK, GM_Bates_constRedi,
     &          GM_Bates_gamma, GM_Bates_b1,
     &          GM_Bates_EadyMinDepth, GM_Bates_EadyMaxDepth,
     &          GM_Bates_Lambda, GM_Bates_smallK, GM_Bates_maxK,
     &          GM_Bates_constK, GM_Bates_maxC,
     &          GM_Bates_Rmax, GM_Bates_Rmin,
     &          GM_Bates_minCori, GM_Bates_minN2,
     &          GM_Bates_surfMinDepth, GM_Bates_vecFreq,
     &          GM_Bates_minRenorm, GM_Bates_maxRenorm,
     &          GM_useLeithQG,
     &          GM_useGEOM,
     &          GEOM_lmbda, GEOM_alpha,
     &          GEOM_ini_EKE, GEOM_diffKh_EKE,
     &          GEOM_vert_struc,
     &          GEOM_vert_struc_min, GEOM_vert_struc_max,
     &          GEOM_minval_K, GEOM_maxval_K,
     &          GM_MNC

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      IF ( .NOT.useGMRedi ) THEN
C-    pkg GMREDI is not used
        _BEGIN_MASTER(myThid)
C-    Track pkg activation status:
C     print a (weak) warning if data.gmredi is found
         CALL PACKAGES_UNUSED_MSG( 'useGMRedi', ' ', ' ' )
        _END_MASTER(myThid)
        RETURN
      ENDIF

      _BEGIN_MASTER(myThid)

C--   Default values GM/Redi
      GM_AdvForm          = .FALSE.
      GM_AdvSeparate      = .FALSE.
      GM_InMomAsStress    = .FALSE.
      GM_isopycK          = -999.
      GM_background_K     = 0. _d 0
      GM_maxSlope         = 1. _d -2
      GM_Kmin_horiz       = 0. _d 0
      GM_Small_Number     = 1. _d -20
      GM_slopeSqCutoff    = 1. _d +48
      GM_taper_scheme     = ' '
      GM_facTrL2dz        = 1.
      GM_facTrL2ML        = 5.
      GM_maxTransLay      = 500.
      GM_Scrit            = 0.004 _d 0
      GM_Sd               = 0.001 _d 0
      GM_isoFac_calcK     = 1. _d 0
      GM_MNC              = useMNC
      GM_iso2dFile        = ' '
      GM_iso1dFile        = ' '
      GM_bol2dFile        = ' '
      GM_bol1dFile        = ' '
      GM_K3dRediFile      = ' '
      GM_K3dGMFile        = ' '
      GM_useLeithQG       = .FALSE.

C--   Default values GM/Redi I/O control
c     GM_dumpFreq         = -1.

C--   Default values BVP
      GM_UseBVP           = .FALSE.
      GM_BVP_ModeNumber   = 1
      GM_BVP_cMin         = 1. _d -1

C--   Default values Sub-Meso (corresponding tau = 5.8 days):
      GM_useSubMeso = .FALSE.
      subMeso_invTau =  2.0 _d -6
      subMeso_LfMin  =  1.0 _d +3
      subMeso_Ceff   =  7.0 _d -2
      subMeso_Lmax   = 110. _d +3

C--   Default values Visbeck
      GM_Visbeck_alpha    =    0. _d 0
      GM_Visbeck_length   =  200. _d 3
      GM_Visbeck_depth    = 1000. _d 0
      GM_Visbeck_minDepth =    0. _d 0
      GM_Visbeck_maxSlope = UNSET_RL
      GM_Visbeck_minVal_K =    0. _d 0
      GM_Visbeck_maxVal_K = 2500. _d 0

C--   Default values GEOMETRIC
      GM_useGEOM              = .FALSE.
      GEOM_lmbda              = 2. _d -7
      GEOM_alpha              = 0. _d  0
      GEOM_ini_EKE            = 1. _d -3
      GEOM_diffKh_EKE         = 1. _d +3
      GEOM_vert_struc         = .FALSE.
      GEOM_vert_struc_min     = 1. _d -1
      GEOM_vert_struc_max     = 1. _d 0
      GEOM_minVal_K           = 0. _d 0
      GEOM_maxVal_K           = 2500. _d 0

C--   Default values for BatesK3d
      GM_useBatesK3d     = .FALSE.
      GM_Bates_smooth    = .TRUE.
      GM_Bates_use_constK= .FALSE.
      GM_Bates_beta_eq_0 = .TRUE.
      GM_Bates_ThickSheet= .FALSE.
      GM_Bates_surfK     = .FALSE.
      GM_Bates_constRedi = .FALSE.
      GM_Bates_gamma     = 1.0
      GM_Bates_b1        = 4.0
      GM_Bates_EadyMinDepth = 50.0
      GM_Bates_EadyMaxDepth = 1000.
      GM_Bates_Lambda    = 1.0
      GM_Bates_smallK    = 100.
      GM_Bates_maxK      = 20. _d 3
      GM_Bates_constK    = 1000.
      GM_Bates_maxC      = 0.15 _d 0
      GM_Bates_Rmax      = 75. _d 3
      GM_Bates_Rmin      = 30. _d 3
      GM_Bates_minCori   = zeroRL
      GM_Bates_minN2     = 1. _d -8
      GM_Bates_surfMinDepth = 100.
      GM_Bates_vecFreq   = 2592000.
      GM_Bates_minRenorm = oneRL
      GM_Bates_maxRenorm = 20.

C--   Initialise retired parameters to unlikely value
      nRetired = 0
      GM_background_K3dFile = ' '
      GM_isopycK3dFile    = ' '

      WRITE(msgBuf,'(A)') ' GM_READPARMS: opening data.gmredi'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT , 1)
      CALL OPEN_COPY_DATA_FILE(
     I                          'data.gmredi', 'GM_READPARMS',
     O                          iUnit,
     I                          myThid )

C     Read parameters from open data file
      READ(UNIT=iUnit,NML=GM_PARM01)
      WRITE(msgBuf,'(A)') ' GM_READPARMS: finished reading data.gmredi'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT , 1)
C     Close the open data file
#ifdef SINGLE_DISK_IO
      CLOSE(iUnit)
#else
      CLOSE(iUnit,STATUS='DELETE')
#endif /* SINGLE_DISK_IO */

C     Default value for GM_isopycK is equal to GM_background_K :
      IF (GM_isopycK.EQ.-999.) GM_isopycK = GM_background_K

C     Default value for GM_Visbeck_maxSlope is equal to GM_maxSlope :
      IF ( GM_Visbeck_maxSlope .EQ. UNSET_RL )
     &     GM_Visbeck_maxSlope = GM_maxSlope

C     Some constants
      GM_rMaxSlope = 0. _d 0
      IF (GM_maxSlope.NE.zeroRL) GM_rMaxSlope = 1. _d 0 / GM_maxSlope

C     Set (or reset) some switches:
      IF ( GM_useLeithQG .AND. viscC2LeithQG.EQ.zeroRL ) THEN
        WRITE(msgBuf,'(2A,I3)') '** WARNING ** GMREDI_READPARMS: ',
     &   'switch OFF GM_useLeithQG since viscC2LeithQG = 0'
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
        GM_useLeithQG = .FALSE.
      ENDIF

      IF ( GM_AdvForm ) THEN
        GM_skewflx = 0. _d 0
        IF ( GM_K3dRediFile .NE. ' ' ) THEN
          GM_ExtraDiag = .TRUE.
        ELSE
          GM_ExtraDiag = GM_isopycK.NE.zeroRL
        ENDIF
#ifdef ALLOW_KAPREDI_CONTROL
        IF ( useCTRL ) GM_ExtraDiag = .TRUE.
#endif
      ELSE
        GM_skewflx = 1. _d 0
        IF ( GM_K3dRediFile .NE. ' ' .OR.
     &       GM_K3dGMFile   .NE. ' ' ) THEN
          GM_ExtraDiag = GM_K3dRediFile .NE. GM_K3dGMFile
        ELSEIF ( GM_iso2dFile .NE. GM_bol2dFile .OR.
     &           GM_iso1dFile .NE. GM_bol1dFile ) THEN
          GM_ExtraDiag = .TRUE.
        ELSE
          GM_ExtraDiag = GM_isopycK.NE.GM_background_K
        ENDIF
#if (defined ALLOW_KAPREDI_CONTROL || defined ALLOW_KAPGM_CONTROL )
        IF ( useCTRL ) GM_ExtraDiag = .TRUE.
#endif
        GM_ExtraDiag = GM_ExtraDiag .OR. GM_useGEOM
      ENDIF
      IF ( GM_isoFac_calcK .NE. GM_skewflx .AND.
     &     ( GM_Visbeck_alpha.NE.zeroRL .OR.
     &       GM_useBatesK3d .OR. GM_useLeithQG ) ) THEN
        GM_ExtraDiag = .TRUE.
      ENDIF

      IF (GM_UseBVP) THEN
        GM_BVP_rModeNumber = 1. _d 0/DBLE(GM_BVP_ModeNumber)
        GM_BVP_cHat2Min = GM_BVP_cMin**2*rhoConst/gravity
      ENDIF

C     Make sure that we locally honor the global MNC on/off flag
      GM_MNC = GM_MNC .AND. useMNC
#ifndef ALLOW_MNC
C     Fix to avoid running without getting any output:
      GM_MNC = .FALSE.
#endif
      GM_MDSIO = (.NOT. GM_MNC) .OR. outputTypesInclusive

C     Check for retired parameters
      IF ( GM_background_K3dFile .NE. ' ' ) THEN
        nRetired = nRetired+1
        WRITE(msgBuf,'(2A)') 'S/R GMREDI_READPARMS: ',
     &    '"GM_background_K3dFile" has been replaced by "GM_K3dGMFile"'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(2A)') 'S/R GMREDI_READPARMS: ',
     &    'and is no longer allowed in file "data.gmredi"'
        CALL PRINT_ERROR( msgBuf, myThid )
      ENDIF
      IF ( GM_isopycK3dFile .NE. ' ' ) THEN
        nRetired = nRetired+1
        WRITE(msgBuf,'(2A)') 'S/R GMREDI_READPARMS: ',
     &    '"GM_isopycK3dFile" has been replaced by "GM_K3dRediFile"'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(2A)') 'S/R GMREDI_READPARMS: ',
     &    'and is no longer allowed in file "data.gmredi"'
        CALL PRINT_ERROR( msgBuf, myThid )
      ENDIF

      IF ( nRetired .GT. 0 ) THEN
        WRITE(msgBuf,'(2A)') 'S/R GMREDI_READPARMS: ',
     &              'Error reading parameter file "data.gmredi":'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(I4,A)') nRetired,
     &      ' out of date parameters were found in the namelist'
        CALL PRINT_ERROR( msgBuf, myThid )
        CALL ALL_PROC_DIE( 0 )
        STOP 'ABNORMAL END: S/R GMREDI_READPARMS'
      ENDIF

      _END_MASTER(myThid)

C--   Everyone else must wait for the parameters to be loaded
      _BARRIER

#endif /* ALLOW_GMREDI */

      RETURN
      END

#include "MATRIX_OPTIONS.h"

C--   File matrix_store_tendency.F:
C      Contents
C      o MATRIX_STORE_TENDENCY_EXP
C      o MATRIX_STORE_TENDENCY_IMP

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C !ROUTINE: MATRIX_STORE_TENDENCY_EXP

C !INTERFACE: ==========================================================
      SUBROUTINE MATRIX_STORE_TENDENCY_EXP(
     I                  iTracer, bi, bj,
     U                  tracNew,
     I                  myTime, myIter, myThid )

C !DESCRIPTION:
C     This routine accumalates the explicit tendency matrix. Note that
C     on entry gPtr is the tracer field after explicit advection-
C     diffusion. On exit, gPtr is set to the initial tracer field for
C     the next step (implicit matrix calculation).

C !USES: ===============================================================
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "PTRACERS_SIZE.h"
#include "PTRACERS_PARAMS.h"
#include "MATRIX.h"

C !INPUT/OUTPUT PARAMETERS: ============================================
C     tracNew :: updated tracer field (after adding explicit contributions)
      INTEGER iTracer
      INTEGER bi, bj
      _RL     myTime
      _RL     tracNew(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      INTEGER myIter
      INTEGER myThid

#ifdef ALLOW_MATRIX
C !LOCAL VARIABLES: ====================================================
      INTEGER i,j,k
CEOP

      DO k=1,Nr
       DO j=1-OLy, sNy+OLy
        DO i=1-OLx, sNx+OLx
          MATRIX(i,j,k,bi,bj,iTracer,1) = MATRIX(i,j,k,bi,bj,iTracer,1)
     &     + ( tracNew(i,j,k) - PTRACERS_initial(i,j,k,bi,bj,iTracer) )
          tracNew(i,j,k) = PTRACERS_initial(i,j,k,bi,bj,iTracer)
        ENDDO
       ENDDO
      ENDDO

C-    Increment counter when processing the last pTracer
      IF ( iTracer.EQ.PTRACERS_numInUse ) THEN
        expMatrixCounter(bi,bj) = expMatrixCounter(bi,bj) + 1
      ENDIF

#endif /* ALLOW_MATRIX */
      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C !ROUTINE: MATRIX_STORE_TENDENCY_IMP

C !INTERFACE: ==========================================================
      SUBROUTINE MATRIX_STORE_TENDENCY_IMP(
     I                  bi, bj, myTime, myIter, myThid )

C !DESCRIPTION:
C     This routine accumalates the implicit update matrix. Note that on
C     entry PTR is the tracer field after implicit advection-
C     diffusion. On exit, PTR is set to the initial tracer field.

C !USES: ===============================================================
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "PTRACERS_SIZE.h"
#include "PTRACERS_PARAMS.h"
#include "PTRACERS_FIELDS.h"
#include "MATRIX.h"

C !INPUT/OUTPUT PARAMETERS: ============================================
      INTEGER bi, bj
      _RL myTime
      INTEGER myIter
      INTEGER myThid

#ifdef ALLOW_MATRIX
C !LOCAL VARIABLES: ====================================================
      INTEGER iTracer
      INTEGER i,j,k
CEOP

      DO iTracer=1,PTRACERS_numInUse
        DO k=1,Nr
         DO j=1-OLy, sNy+OLy
          DO i=1-OLx, sNx+OLx
            MATRIX(i,j,k,bi,bj,iTracer,2) =
     &             MATRIX(i,j,k,bi,bj,iTracer,2)
     &             + pTracer(i,j,k,bi,bj,iTracer)
            pTracer(i,j,k,bi,bj,iTracer)=
     &             PTRACERS_initial(i,j,k,bi,bj,iTracer)
          ENDDO
         ENDDO
        ENDDO
      ENDDO
      impMatrixCounter(bi,bj) = impMatrixCounter(bi,bj) + 1

#endif /* ALLOW_MATRIX */
      RETURN
      END

#include "CTRL_OPTIONS.h"

CBOP
C     !ROUTINE: CTRL_MAP_INI_GENARR
C     !INTERFACE:
      SUBROUTINE CTRL_MAP_INI_GENARR( myThid )

C     !DESCRIPTION: \bv
C     *=================================================================
C     | SUBROUTINE CTRL_MAP_INI_GENARR
C     | Add the generic arrays of the
C     | control vector to the model state and update the tile halos.
C     | The control vector is defined in the header file "CTRL.h".
C     *=================================================================
C     | local version for OpenAD exp. hs94.1x64x5
C     *=================================================================
C     \ev

C     !USES:
      IMPLICIT NONE

C     == global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "DYNVARS.h"
#include "FFIELDS.h"
#include "CTRL_SIZE.h"
#include "CTRL.h"
#include "CTRL_GENARR.h"
#include "CTRL_DUMMY.h"
#include "OPTIMCYCLE.h"
#ifdef ALLOW_PTRACERS
# include "PTRACERS_SIZE.h"
c#include "PTRACERS_PARAMS.h"
# include "PTRACERS_FIELDS.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     == routine arguments ==
      INTEGER myThid

C     !FUNCTIONS:
      INTEGER  ILNBLNk
      EXTERNAL ILNBLNK

C     !LOCAL VARIABLES:
C     == local variables ==
      INTEGER bi,bj
      INTEGER i,j,k
      INTEGER jmin,jmax
      INTEGER imin,imax
      INTEGER il
      INTEGER iarr

      LOGICAL doglobalread
      LOGICAL ladinit
      CHARACTER*(MAX_LEN_FNAM) fnamebase
      CHARACTER*(MAX_LEN_FNAM) fnamegeneric
      _RL     fac
#ifdef ALLOW_GENARR2D_CONTROL
      _RL     tmpfld2d(1-OLx:sNx+OLx,1-OLy:sNy+OLy,   nSx,nSy)
#endif
#ifdef ALLOW_GENARR3D_CONTROL
      _RL     tmpfld3d(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
#endif
CEOP

      jmin = 1
      jmax = sNy
      imin = 1
      imax = sNx

      doglobalread = .FALSE.
      ladinit      = .FALSE.
      fac = 1. _d 0

#ifdef ALLOW_GENARR2D_CONTROL
C--   An example of connecting specific fields
C--   to 3 generic 2D control arrays
cc--->>>
cc--->>> COMPILE FAILURE IS DELIBERATE
cc--->>> BE SURE WHAT YOU ARE DOING AND CUSTOMIZE <<<---
cc--->>>
C--   generic - user-defined control vars
      DO iarr = 1, maxCtrlArr2D

       fnamebase = xx_genarr2d_file(iarr)
       il=ILNBLNK( fnamebase )
       WRITE(fnamegeneric,'(2A,I10.10)')
     &     fnamebase(1:il),'.',optimcycle
       CALL ACTIVE_READ_XY ( fnamegeneric, tmpfld2d, 1,
     &                      doglobalread, ladinit, optimcycle,
     &                      myThid, xx_genarr2d_dummy(iarr) )
       DO bj=myByLo(myThid), myByHi(myThid)
        DO bi=myBxLo(myThid), myBxHi(myThid)
          DO j = jmin,jmax
            DO i = imin,imax
              IF ( iarr .EQ. 1 ) THEN
                theta(i,j,1,bi,bj) = theta(i,j,1,bi,bj)
     &                             + tmpfld2d(i,j,bi,bj)
              ELSEIF ( iarr .EQ. 2 ) THEN
                salt(i,j,1,bi,bj) = salt(i,j,1,bi,bj)
     &                            + tmpfld2d(i,j,bi,bj)
              ENDIF
            ENDDO
          ENDDO
        ENDDO
       ENDDO
C--   end iarr loop
      ENDDO

       _EXCH_XYZ_RL( theta, myThid )
       _EXCH_XYZ_RL( salt, myThid )

#endif /* ALLOW_GENARR2D_CONTROL */

#ifdef ALLOW_GENARR3D_CONTROL
C--   An example of connecting specific fields
C--   to 3 generic 3D control arrays
cc--->>>
cc--->>> COMPILE FAILURE IS DELIBERATE
cc--->>> BE SURE WHAT YOU ARE DOING AND CUSTOMIZE <<<---
cc--->>>
C--   generic - user-defined control vars
      DO iarr = 1, maxCtrlArr3D

       fnamebase = xx_genarr3d_file(iarr)
       il=ILNBLNK( fnamebase )
       WRITE(fnamegeneric,'(2A,I10.10)')
     &     fnamebase(1:il),'.',optimcycle
       CALL ACTIVE_READ_XYZ( fnamegeneric, tmpfld3d, 1,
     &                       doglobalread, ladinit, optimcycle,
     &                       myThid, xx_genarr3d_dummy(iarr) )
       DO bj=myByLo(myThid), myByHi(myThid)
        DO bi=myBxLo(myThid), myBxHi(myThid)
          DO k = 1,Nr
           DO j = jmin,jmax
            DO i = imin,imax
cc              if ( iarr .EQ. 1 ) then
cc                theta(i,j,k,bi,bj) = theta(i,j,k,bi,bj)
cc     &                             + fac*tmpfld3d(i,j,k,bi,bj)
cc              ELSEIF ( iarr .EQ. 2 ) then
cc                salt(i,j,k,bi,bj) = salt(i,j,k,bi,bj)
cc     &                            + fac*tmpfld3d(i,j,k,bi,bj)
cc              endif
            ENDDO
           ENDDO
          ENDDO
        ENDDO
       ENDDO
C--   end iarr loop
      ENDDO

cc       _EXCH_XYZ_RL( theta, myThid )
cc       _EXCH_XYZ_RL( salt, myThid )

#endif /* ALLOW_GENARR3D_CONTROL */

      RETURN
      END

#include "THSICE_OPTIONS.h"
#ifdef ALLOW_AUTODIFF
# include "AUTODIFF_OPTIONS.h"
#endif
#ifdef ALLOW_EXF
#include "EXF_OPTIONS.h"
#endif

CBOP
C     !ROUTINE: THSICE_GET_EXF
C     !INTERFACE:
      SUBROUTINE THSICE_GET_EXF(
     I                  bi, bj, it2,
     I                  iMin,iMax, jMin,jMax,
     I                  icFlag, hSnow1, tsfCel,
     O                  flxExcSw, dFlxdT, evapLoc, dEvdT,
     I                  myTime, myIter, myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R  THSICE_GET_EXF
C     *==========================================================*
C     | Interface S/R : get Surface Fluxes from pkg EXF
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     == Global data ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#ifdef ALLOW_EXF
# include "EXF_CONSTANTS.h"
# include "EXF_PARAM.h"
# include "EXF_FIELDS.h"
#endif
#ifdef ALLOW_AUTODIFF_TAMC
# include "tamc.h"
# include "THSICE_SIZE.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
C     bi,bj       :: tile indices
C     it          :: solv4temp iteration
C     iMin,iMax   :: computation domain: 1rst index range
C     jMin,jMax   :: computation domain: 2nd  index range
C     icFlag     :: True= get fluxes at this location ; False= do nothing
C     hSnow1       :: snow height [m]
C     tsfCel      :: surface (ice or snow) temperature (oC)
C     flxExcSw    :: net (downward) surface heat flux, except short-wave [W/m2]
C     dFlxdT      :: deriv of flx with respect to Tsf    [W/m/K]
C     evapLoc     :: surface evaporation (>0 if evaporate) [kg/m2/s]
C     dEvdT       :: deriv of evap. with respect to Tsf  [kg/m2/s/K]
C     myTime      :: current Time of simulation [s]
C     myIter      :: current Iteration number in simulation
C     myThid      :: my Thread Id number
      INTEGER bi, bj
      INTEGER it2
      INTEGER iMin, iMax
      INTEGER jMin, jMax
      _RL     icFlag  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL     hSnow1  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL     tsfCel  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL     flxExcSw(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL     dFlxdT  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL     evapLoc (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL     dEvdT   (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL     myTime
      INTEGER myIter
      INTEGER myThid
CEOP

#ifdef ALLOW_EXF
#ifdef ALLOW_ATM_TEMP
#ifdef ALLOW_DOWNWARD_RADIATION

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C     === Local variables ===
C     hsLocal, hlLocal :: sensible & latent heat flux over sea-ice
C             t0       :: virtual temperature (K)
C             ssq      :: saturation specific humidity (kg/kg)
C             deltap   :: potential temperature diff (K)
      _RL hsLocal
      _RL hlLocal
      INTEGER iter
      INTEGER i, j
      _RL czol
      _RL wsm                ! limited wind speed [m/s] (> umin)
      _RL t0                 ! virtual temperature [K]
C     copied from exf_bulkformulae:
C     these need to be 2D-arrays for vectorizing code
C     turbulent temperature scale [K]
      _RL tstar (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
C     turbulent humidity scale  [kg/kg]
      _RL qstar (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
C     friction velocity [m/s]
      _RL ustar (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
C     neutral, zref (=10m) values of rd
      _RL rdn   (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL rd    (1-OLx:sNx+OLx,1-OLy:sNy+OLy) ! = sqrt(Cd)          [-]
      _RL rh    (1-OLx:sNx+OLx,1-OLy:sNy+OLy) ! = Ch / sqrt(Cd)     [-]
      _RL re    (1-OLx:sNx+OLx,1-OLy:sNy+OLy) ! = Ce / sqrt(Cd)     [-]
C     specific humidity difference [kg/kg]
      _RL delq  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL deltap(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
#ifdef EXF_CALC_ATMRHO
C     local atmospheric density [kg/m^3]
      _RL atmrho_loc(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
#endif
C
      _RL ssq
      _RL ren, rhn           ! neutral, zref (=10m) values of re, rh
      _RL usn, usm           ! neutral, zref (=10m) wind-speed (+limited)
      _RL stable             ! = 1 if stable ; = 0 if unstable
C     stability parameter at zwd [-] (=z/Monin-Obuklov length)
      _RL huol
      _RL htol               ! stability parameter at zth [-]
      _RL hqol
      _RL x                  ! stability function  [-]
      _RL xsq                ! = x^2               [-]
      _RL psimh              ! momentum stability function
      _RL psixh              ! latent & sensib. stability function
      _RL zwln               ! = log(zwd/zref)
      _RL ztln               ! = log(zth/zref)
      _RL tau                ! surface stress coef = rhoA * Ws * sqrt(Cd)
      _RL tmpbulk

C     additional variables that are copied from bulkf_formula_lay:
C     upward LW at surface (W m-2)
      _RL  flwup
C     net (downward) LW at surface (W m-2)
      _RL  flwNet_dwn
C     gradients of latent/sensible net upward heat flux
C     w/ respect to temperature
      _RL dflhdT
      _RL dfshdT
      _RL dflwupdT
C     emissivities, called emittance in exf
      _RL     emiss
C     Tsf    :: surface temperature [K]
C     Ts2    :: surface temperature square [K^2]
      _RL Tsf
      _RL Ts2
C     latent heat of evaporation or sublimation [J/kg]
      _RL lath
      _RL qsat_fac
      _RL qsat_exp
#ifdef ALLOW_AUTODIFF_TAMC
C     ikey  :: tape key (depends on tiles and external iteration)
C     nbkey :: tape key (depends on ikey and bulk formulae iteration)
C     ijkey :: tape key (depends on nbkey,  and i,j indices)
      INTEGER ikey, nbkey, ijkey
#endif
#ifdef ALLOW_DBUG_THSICE
      LOGICAL dBugFlag
      INTEGER stdUnit
#endif

C     == external functions ==

c     _RL       exf_BulkqSat
c     external  exf_BulkqSat
c     _RL       exf_BulkCdn
c     external  exf_BulkCdn
c     _RL       exf_BulkRhn
c     external  exf_BulkRhn

C     == end of interface ==

C-    Define grid-point location where to print debugging values
#include "THSICE_DEBUG.h"

#ifdef ALLOW_DBUG_THSICE
      dBugFlag = debugLevel.GE.debLevC
      stdUnit = standardMessageUnit
#endif

C--   Set surface parameters :
      zwln = LOG(hu/zref)
      ztln = LOG(ht/zref)
      czol = hu*karman*gravity_mks
      ren  = cDalton
C     more abbreviations
      lath     = flamb+flami
      qsat_fac = cvapor_fac_ice
      qsat_exp = cvapor_exp_ice

C     initialisation of local arrays
      DO j = 1-OLy,sNy+OLy
       DO i = 1-OLx,sNx+OLx
        tstar(i,j)  = 0. _d 0
        qstar(i,j)  = 0. _d 0
        ustar(i,j)  = 0. _d 0
        rdn(i,j)    = 0. _d 0
        rd(i,j)     = 0. _d 0
        rh(i,j)     = 0. _d 0
        re(i,j)     = 0. _d 0
        delq(i,j)   = 0. _d 0
        deltap(i,j) = 0. _d 0
       ENDDO
      ENDDO
C
      DO j=jMin,jMax
       DO i=iMin,iMax
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
#ifdef ALLOW_DBUG_THSICE
        IF ( dBug(i,j,bi,bj) .AND. (icFlag(i,j).GT.0. _d 0) )
     &    WRITE(stdUnit,'(A,2I4,2I2,2F12.6)')
     &    'ThSI_GET_EXF: i,j,atemp,lwd=',
     &           i,j,bi,bj, atemp(i,j,bi,bj),lwdown(i,j,bi,bj)
#endif

C--   Use atmospheric state to compute surface fluxes.
        IF ( (icFlag(i,j).GT.0. _d 0) .AND.
     &       (atemp(i,j,bi,bj).NE.0. _d 0) ) THEN
         IF ( hSnow1(i,j).GT.3. _d -1 ) THEN
          emiss = snow_emissivity
         ELSE
          emiss = ice_emissivity
         ENDIF
C     copy a few variables to names used in bulkf_formula_lay
         Tsf         = tsfCel(i,j)+cen2kel
         Ts2         = Tsf*Tsf
C     wind speed
         wsm         = sh(i,j,bi,bj)
C--   air - surface difference of temperature & humidity
c        tmpbulk= exf_BulkqSat(Tsf)
c        ssq         = saltsat*tmpbulk/atmrho
         tmpbulk     = qsat_fac*EXP(-qsat_exp/Tsf)
#ifdef EXF_CALC_ATMRHO
         atmrho_loc(i,j) = apressure(i,j,bi,bj) /
     &                  (287.04 _d 0*atemp(i,j,bi,bj)
     &                  *(1. _d 0 + humid_fac*aqh(i,j,bi,bj)))
         ssq         = tmpbulk/atmrho_loc(i,j)
#else
         ssq         = tmpbulk/atmrho
#endif
         deltap(i,j) = atemp(i,j,bi,bj) + gamma_blk*ht - Tsf
         delq(i,j)   = aqh(i,j,bi,bj) - ssq
C     Do the part of the output variables that do not depend
C     on the ice here to save a few re-computations
C     This is not yet dEvdT, but just a cheap way to save a 2D-field
C     for ssq and recomputing Ts2 lateron
         dEvdT(i,j)  = ssq*qsat_exp/Ts2
         flwup       = emiss*stefanBoltzmann*Ts2*Ts2
         dflwupdT    = emiss*stefanBoltzmann*Ts2*Tsf * 4. _d 0
c        flwNet_dwn  =       lwdown(i,j,bi,bj) - flwup
C-    assume long-wave albedo = 1 - emissivity :
         flwNet_dwn  = emiss*lwdown(i,j,bi,bj) - flwup
C--   This is not yet the total derivative with respect to surface temperature
         dFlxdT(i,j)   = -dflwupdT
C--   This is not yet the Net downward radiation excluding shortwave
         flxExcSw(i,j) = flwNet_dwn
        ENDIF
       ENDDO
      ENDDO

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      IF ( useStabilityFct_overIce ) THEN
#ifdef ALLOW_AUTODIFF_TAMC
C     Storing is only necessary if useStabilityFct_overIce = T, so we
C     compute the keys here, just before we need them.
       ikey = bi + (bj-1)*nSx + (ikey_dynamics-1)*nSx*nSy
       ikey = (ikey-1)*(MaxTsf+1) + it2
#endif
       DO j=jMin,jMax
        DO i=iMin,iMax
C--
         IF ( (icFlag(i,j).GT.0. _d 0) .AND.
     &        (atemp(i,j,bi,bj).NE.0. _d 0) ) THEN
C--   Compute the turbulent surface fluxes (function of stability).

C             Initial guess: z/l=0.0; hu=ht=hq=z
C             Iterations:    converge on z/l and hence the fluxes.

          t0         = atemp(i,j,bi,bj)*
     &         (exf_one + humid_fac*aqh(i,j,bi,bj))
          stable     = exf_half + SIGN(exf_half, deltap(i,j))
c         tmpbulk    = exf_BulkCdn(sh(i,j,bi,bj))
          wsm        = sh(i,j,bi,bj)
          tmpbulk    = cdrag_1/wsm + cdrag_2 + cdrag_3*wsm
          IF (tmpbulk.NE.0.) THEN
           rdn(i,j)   = SQRT(tmpbulk)
          ELSE
           rdn(i,j)   = 0. _d 0
          ENDIF
C--  initial guess for exchange other coefficients:
c         rhn        = exf_BulkRhn(stable)
          rhn        = (exf_one-stable)*cstanton_1 + stable*cstanton_2
C--  calculate turbulent scales
          ustar(i,j) = rdn(i,j)*wsm
          tstar(i,j) = rhn*deltap(i,j)
          qstar(i,j) = ren*delq(i,j)
         ENDIF
        ENDDO
       ENDDO

C     start iteration
       DO iter = 1,niter_bulk
#ifdef ALLOW_AUTODIFF_TAMC
        nbkey = (ikey-1)*niter_bulk + iter
CADJ STORE ustar = comlev1_thsice_exf_niter, key = nbkey, kind = isbyte
CADJ STORE qstar = comlev1_thsice_exf_niter, key = nbkey, kind = isbyte
CADJ STORE tstar = comlev1_thsice_exf_niter, key = nbkey, kind = isbyte
#endif
        DO j=jMin,jMax
         DO i=iMin,iMax
          IF ( (icFlag(i,j).GT.0. _d 0) .AND.
     &         (atemp(i,j,bi,bj).NE.0. _d 0) ) THEN

#ifdef ALLOW_AUTODIFF_TAMC
           ijkey = i + sNx*(j-1) + (nbkey-1)*sNx*sNy
C     Not sure why this has to be done here and not outside the ij-loop.
CADJ STORE rdn(i,j) = comlev1_thsice_exf_ij, key = ijkey, kind = isbyte
#endif

           t0     = atemp(i,j,bi,bj)*
     &          (exf_one + humid_fac*aqh(i,j,bi,bj))
           huol   = (tstar(i,j)/t0 +
     &               qstar(i,j)/(exf_one/humid_fac+aqh(i,j,bi,bj))
     &              )*czol/(ustar(i,j)*ustar(i,j))
#ifdef ALLOW_BULK_LARGEYEAGER04
C-    Large&Yeager_2004 code:
           huol   = MIN( MAX(-10. _d 0,huol), 10. _d 0 )
#else
C-    Large&Pond_1981 code (zolmin default = -100):
           huol   = MAX(huol,zolmin)
#endif /* ALLOW_BULK_LARGEYEAGER04 */
           htol   = huol*ht/hu
           hqol   = huol*hq/hu
           stable = exf_half + SIGN(exf_half, huol)

C     Evaluate all stability functions assuming hq = ht.
#ifdef ALLOW_BULK_LARGEYEAGER04
C-    Large&Yeager_2004 code:
           xsq    = SQRT( ABS(exf_one - huol*16. _d 0) )
#else
C-    Large&Pond_1981 code:
           xsq    = MAX(SQRT(ABS(exf_one - huol*16. _d 0)),exf_one)
#endif /* ALLOW_BULK_LARGEYEAGER04 */
           x      = SQRT(xsq)
           psimh  = -psim_fac*huol*stable
     &             + (exf_one-stable)
     &             *( LOG( (exf_one + exf_two*x + xsq)
     &                    *(exf_one+xsq)*0.125 _d 0 )
     &                -exf_two*ATAN(x) + exf_half*pi )
#ifdef ALLOW_BULK_LARGEYEAGER04
C-    Large&Yeager_2004 code:
           xsq    = SQRT( ABS(exf_one - htol*16. _d 0) )
#else
C-    Large&Pond_1981 code:
           xsq    = MAX(SQRT(ABS(exf_one - htol*16. _d 0)),exf_one)
#endif /* ALLOW_BULK_LARGEYEAGER04 */
           psixh  = -psim_fac*htol*stable
     &            + (exf_one-stable)
     &              *exf_two*LOG( exf_half*(exf_one+xsq) )

C     Shift wind speed using old coefficient
#ifdef ALLOW_BULK_LARGEYEAGER04
C--   Large&Yeager04:
           usn    = wspeed(i,j,bi,bj)
     &           /( exf_one + rdn(i,j)*(zwln-psimh)/karman )
#else
C--   Large&Pond1981:
           usn   = sh(i,j,bi,bj)/(exf_one - rdn(i,j)/karman*psimh)
#endif /* ALLOW_BULK_LARGEYEAGER04 */
           usm    = MAX(usn, umin)

C-    Update the 10m, neutral stability transfer coefficients
c          tmpbulk= exf_BulkCdn(usm)
           tmpbulk= cdrag_1/usm + cdrag_2 + cdrag_3*usm
           rdn(i,j) = SQRT(tmpbulk)
c          rhn    = exf_BulkRhn(stable)
           rhn    = (exf_one-stable)*cstanton_1 + stable*cstanton_2

C     Shift all coefficients to the measurement height and stability.
#ifdef ALLOW_BULK_LARGEYEAGER04
           rd(i,j)= rdn(i,j)/( exf_one + rdn(i,j)*(zwln-psimh)/karman )
#else
           rd(i,j)= rdn(i,j)/( exf_one - rdn(i,j)/karman*psimh )
#endif /* ALLOW_BULK_LARGEYEAGER04 */
           rh(i,j)= rhn/( exf_one + rhn*(ztln-psixh)/karman )
           re(i,j)= ren/( exf_one + ren*(ztln-psixh)/karman )

C     Update ustar, tstar, qstar using updated, shifted coefficients.
           ustar(i,j)  = rd(i,j)*sh(i,j,bi,bj)
           qstar(i,j)  = re(i,j)*delq(i,j)
           tstar(i,j)  = rh(i,j)*deltap(i,j)
          ENDIF
C     end i/j-loops
         ENDDO
        ENDDO
C     end iteration loop
       ENDDO
#ifdef ALLOW_AUTODIFF_TAMC
C     these stores avoid recomputing this routine in the ad-code (not
C     strictly necessary)
CADJ STORE rd    = comlev1_thsice_exf, key = ikey, kind = isbyte
CADJ STORE rh    = comlev1_thsice_exf, key = ikey, kind = isbyte
CADJ STORE re    = comlev1_thsice_exf, key = ikey, kind = isbyte
CADJ STORE qstar = comlev1_thsice_exf, key = ikey, kind = isbyte
CADJ STORE tstar = comlev1_thsice_exf, key = ikey, kind = isbyte
#endif
       DO j=jMin,jMax
        DO i=iMin,iMax
         IF ( (icFlag(i,j).GT.0. _d 0) .AND.
     &        (atemp(i,j,bi,bj).NE.0. _d 0) ) THEN
#ifdef EXF_CALC_ATMRHO
          tau     = atmrho_loc(i,j)*rd(i,j)*wspeed(i,j,bi,bj)
#else
          tau     = atmrho*rd(i,j)*wspeed(i,j,bi,bj)
#endif
          evapLoc(i,j)  = -tau*qstar(i,j)
          hlLocal       = -lath*evapLoc(i,j)
          hsLocal       = atmcp*tau*tstar(i,j)
c         ustress = tau*rd(i,j)*UwindSpeed
c         vstress = tau*rd(i,j)*VwindSpeed

C---  surf.Temp derivative of turbulent Fluxes
C     complete computation of dEvdT
          dEvdT(i,j)    = (tau*re(i,j))*dEvdT(i,j)
          dflhdT        = -lath*dEvdT(i,j)
          dfshdT        = -atmcp*tau*rh(i,j)
C--   Update total derivative with respect to surface temperature
          dFlxdT(i,j)   = dFlxdT(i,j)   + dfshdT  + dflhdT
C--   Update net downward radiation excluding shortwave
          flxExcSw(i,j) = flxExcSw(i,j) + hsLocal + hlLocal

         ENDIF
        ENDDO
       ENDDO
      ELSE
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C--   Compute the turbulent surface fluxes using fixed transfert Coeffs
C     with no stability dependence ( useStabilityFct_overIce = false )
       DO j=jMin,jMax
        DO i=iMin,iMax
         IF ( (icFlag(i,j).GT.0. _d 0) .AND.
     &        (atemp(i,j,bi,bj).NE.0. _d 0) ) THEN
          wsm           = sh(i,j,bi,bj)
#ifdef EXF_CALC_ATMRHO
          tau           = atmrho_loc(i,j)*exf_iceCe*wsm
#else
          tau           = atmrho*exf_iceCe*wsm
#endif
          evapLoc(i,j)  = -tau*delq(i,j)
          hlLocal       = -lath*evapLoc(i,j)
#ifdef EXF_CALC_ATMRHO
          hsLocal       = atmcp*atmrho_loc(i,j)
     &                                *exf_iceCh*wsm*deltap(i,j)
#else
          hsLocal       = atmcp*atmrho*exf_iceCh*wsm*deltap(i,j)
#endif
#ifdef ALLOW_DBUG_THSICE
          IF ( dBug(i,j,bi,bj) ) WRITE(stdUnit,'(A,4F12.6)')
     &      'ThSI_GET_EXF: wsm,hl,hs,Lw=',
     &                     wsm,hlLocal,hsLocal,flxExcSw(i,j)
#endif
C---  surf.Temp derivative of turbulent Fluxes
C     complete computation of dEvdT
          dEvdT(i,j)    = tau*dEvdT(i,j)
          dflhdT        = -lath*dEvdT(i,j)
#ifdef EXF_CALC_ATMRHO
          dfshdT        = -atmcp*atmrho_loc(i,j)*exf_iceCh*wsm
#else
          dfshdT        = -atmcp*atmrho*exf_iceCh*wsm
#endif
C--   Update total derivative with respect to surface temperature
          dFlxdT(i,j)   = dFlxdT(i,j)   + dfshdT  + dflhdT
C--   Update net downward radiation excluding shortwave
          flxExcSw(i,j) = flxExcSw(i,j) + hsLocal + hlLocal
#ifdef ALLOW_DBUG_THSICE
          IF ( dBug(i,j,bi,bj) ) WRITE(stdUnit,'(A,4F12.6)')
     &      'ThSI_GET_EXF: flx,dFlxdT,evap,dEvdT',
     &       flxExcSw(i,j), dFlxdT(i,j), evapLoc(i,j),dEvdT(i,j)
#endif
         ENDIF
        ENDDO
       ENDDO
C     endif useStabilityFct_overIce
      ENDIF
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
      DO j=jMin,jMax
       DO i=iMin,iMax
        IF ( (icFlag(i,j).GT.0. _d 0) .AND.
     &       (atemp(i,j,bi,bj).LE.0. _d 0) ) THEN
C--   in case atemp is zero:
         flxExcSw(i,j) = 0. _d 0
         dFlxdT  (i,j) = 0. _d 0
         evapLoc (i,j) = 0. _d 0
         dEvdT   (i,j) = 0. _d 0
        ENDIF
       ENDDO
      ENDDO

#else /* ALLOW_DOWNWARD_RADIATION */
      STOP 'ABNORMAL END: S/R THSICE_GET_EXF: DOWNWARD_RADIATION undef'
#endif /* ALLOW_DOWNWARD_RADIATION */
#else /* ALLOW_ATM_TEMP */
      STOP 'ABNORMAL END: S/R THSICE_GET_EXF: ATM_TEMP undef'
#endif /* ALLOW_ATM_TEMP */
#ifdef EXF_READ_EVAP
      STOP 'ABNORMAL END: S/R THSICE_GET_EXF: EXF_READ_EVAP defined'
#endif /* EXF_READ_EVAP */
#endif /* ALLOW_EXF */

      RETURN
      END

#include "CTRL_OPTIONS.h"

      subroutine ctrl_set_pack_xz(
     &     cunit, ivar, fname, masktype,weighttype,
     &     weightfld, lxxadxx, mythid)

c     ==================================================================
c     SUBROUTINE ctrl_set_pack_xz
c     ==================================================================
c
c     o Compress the control vector such that only ocean points are
c       written to file.
c
c     o Open boundary packing finalized :
c          gebbie@mit.edu, 18-Mar-2003
c
c     changed: heimbach@mit.edu 17-Jun-2003
c              merged changes from Armin to replace write of
c              nr * globfld2d by 1 * globfld3d
c              (ad hoc fix to speed up global I/O)
c
c     ==================================================================

      implicit none

c     == global variables ==

#include "EEPARAMS.h"
#include "SIZE.h"
#include "PARAMS.h"
#include "GRID.h"

#include "CTRL_SIZE.h"
#include "CTRL.h"
#include "CTRL_OBCS.h"
#include "OPTIMCYCLE.h"

c     == routine arguments ==

      integer cunit
      integer ivar
      character*(MAX_LEN_FNAM) fname
      character*(  9) masktype
      character*(  *) weighttype
      _RL     weightfld( Nr,nobcs )
      logical lxxadxx
      integer mythid

#ifndef EXCLUDE_CTRL_PACK
c     == local variables ==

      integer bi,bj
      integer ip,jp
      integer i,j,k
      integer ii,jj,kk
      integer irec,iobcs,nrec_nl
      integer itlo,ithi
      integer jtlo,jthi
      integer jmin,jmax
      integer imin,imax

      integer cbuffindex
      integer reclen, irectrue
      integer cunit2, cunit3
      character*(MAX_LEN_FNAM) cfile2, cfile3

      real*4  cbuff      ( sNx*nSx*nPx*nSy*nPy )
      real*4  globfldtmp2( sNx,nSx,nPx,nSy,nPy )
      real*4  globfldtmp3( sNx,nSx,nPx,nSy,nPy )
      _RL     globfldxz  ( sNx,nSx,nPx,nSy,nPy,Nr )
      _RL     globfld3d  ( sNx,nSx,nPx,sNy,nSy,nPy,Nr )
      _RL     globmskxz  ( sNx,nSx,nPx,nSy,nPy,Nr,nobcs )
#ifdef CTRL_PACK_PRECISE
      integer il
      character*(MAX_LEN_FNAM) weightname
      _RL     weightfldxz( sNx,nSx,nPx,nSy,nPy,Nr,nobcs )

c     == external ==

      integer  ilnblnk
      external ilnblnk
#endif

c     == end of interface ==

      jtlo = 1
      jthi = nSy
      itlo = 1
      ithi = nSx
      jmin = 1
      jmax = sNy
      imin = 1
      imax = sNx

c     Initialise temporary file
      do k = 1,Nr
         do jp = 1,nPy
            do bj = jtlo,jthi
               do ip = 1,nPx
                  do bi = itlo,ithi
                     do i = imin,imax
                        globfldxz  (i,bi,ip,bj,jp,k) = 0. _d 0
                        globfldtmp2(i,bi,ip,bj,jp)   = 0.
                        globfldtmp3(i,bi,ip,bj,jp)   = 0.
                        do iobcs=1,nobcs
                           globmskxz(i,bi,ip,bj,jp,k,iobcs) = 0. _d 0
                        enddo
                     enddo
                  enddo
               enddo
            enddo
         enddo
      enddo
c     Initialise temporary file
      do k = 1,Nr
         do jp = 1,nPy
            do bj = jtlo,jthi
               do j = jmin,jmax
                  do ip = 1,nPx
                     do bi = itlo,ithi
                        do i = imin,imax
                           globfld3d(i,bi,ip,j,bj,jp,k) = 0. _d 0
                        enddo
                     enddo
                  enddo
               enddo
            enddo
         enddo
      enddo

c--   Only the master thread will do I/O.
      _BEGIN_MASTER( mythid )

      if ( doPackDiag ) then
         if ( lxxadxx ) then
            write(cfile2,'(a,I2.2,a,I4.4,a)')
     &           'diag_pack_nonout_ctrl_',
     &           ivar, '_', optimcycle, '.bin'
            write(cfile3,'(a,I2.2,a,I4.4,a)')
     &           'diag_pack_dimout_ctrl_',
     &           ivar, '_', optimcycle, '.bin'
         else
            write(cfile2,'(a,I2.2,a,I4.4,a)')
     &           'diag_pack_nonout_grad_',
     &           ivar, '_', optimcycle, '.bin'
            write(cfile3,'(a,I2.2,a,I4.4,a)')
     &           'diag_pack_dimout_grad_',
     &           ivar, '_', optimcycle, '.bin'
         endif

         reclen = sNx*nSx*nPx*nSy*nPy*4
         call mdsfindunit( cunit2, mythid )
         open( cunit2, file=cfile2, status='unknown',
     &        access='direct', recl=reclen )
         call mdsfindunit( cunit3, mythid )
         open( cunit3, file=cfile3, status='unknown',
     &        access='direct', recl=reclen )
      endif

      do iobcs = 1, nobcs
         call MDSREADFIELD_XZ_GL(
     &        masktype, ctrlprec, 'RL',
     &        Nr, globmskxz(1,1,1,1,1,1,iobcs), iobcs, mythid)
#ifdef CTRL_PACK_PRECISE
         il=ilnblnk( weighttype)
         write(weightname,'(a)') weighttype(1:il)
         call MDSREADFIELD_XZ_GL(
     &        weightname, ctrlprec, 'RL',
     &        Nr, weightfldxz(1,1,1,1,1,1,iobcs), iobcs, mythid)
#endif
      enddo

      if ( useSingleCPUio ) then
C     MDSREADFIELD_XZ_GL does not know about useSingleCPUio, so the faster
C     method that works for .not.useSingleCPUio cannot be used
       nrec_nl = 0
      else
       nrec_nl = int(ncvarrecs(ivar)/Ny)
      endif
      do irec = 1, nrec_nl
         call MDSREADFIELD_3D_GL( fname, ctrlprec, 'RL',
     &        Nr, globfld3d, irec, mythid)
         do j=1,sNy
            iobcs= mod((irec-1)*sNy+j-1,nobcs)+1

            write(cunit) ncvarindex(ivar)
            write(cunit) 1
            write(cunit) 1
            do k = 1,Nr
             irectrue = (irec-1)*nobcs*Nr + (iobcs-1)*Nr + k
             cbuffindex = 0
             do jp = 1,nPy
              do bj = jtlo,jthi
               do ip = 1,nPx
                do bi = itlo,ithi
                 do i = imin,imax
                  jj=mod((j-1)*Nr+k-1,sNy)+1
                  kk=int((j-1)*Nr+K-1)/sNy+1
                  if (globmskxz(i,bi,ip,bj,jp,k,iobcs)  .ne. 0. ) then
                     cbuffindex = cbuffindex + 1
cph(
                     globfldtmp3(i,bi,ip,bj,jp) =
     &                    globfld3d(i,bi,ip,jj,bj,jp,kk)
cph)
#ifdef ALLOW_NONDIMENSIONAL_CONTROL_IO
                     if (lxxadxx) then
                        cbuff(cbuffindex) =
     &                       globfld3d(i,bi,ip,jj,bj,jp,kk) *
# ifdef CTRL_PACK_PRECISE
     &                       sqrt(weightfldxz(i,bi,ip,bj,jp,k,iobcs))
# else
     &                       sqrt(weightfld(k,iobcs))
# endif
                     else
                        cbuff(cbuffindex) =
     &                       globfld3d(i,bi,ip,jj,bj,jp,kk) /
# ifdef CTRL_PACK_PRECISE
     &                       sqrt(weightfldxz(i,bi,ip,bj,jp,k,iobcs))
# else
     &                       sqrt(weightfld(k,iobcs))
# endif
                     endif
cph(
                     globfldtmp2(i,bi,ip,bj,jp) = cbuff(cbuffindex)
cph)
#else /* ALLOW_NONDIMENSIONAL_CONTROL_IO undef */
                     cbuff(cbuffindex) = globfld3d(i,bi,ip,jj,bj,jp,kk)
#endif /* ALLOW_NONDIMENSIONAL_CONTROL_IO */
                  endif
                 enddo
                enddo
               enddo
              enddo
             enddo
c           --> check cbuffindex.
             if ( cbuffindex .gt. 0) then
                write(cunit) cbuffindex
                write(cunit) k
                write(cunit) (cbuff(ii), ii=1,cbuffindex)
             endif
c
            if ( doPackDiag ) then
               write(cunit2,rec=irectrue) globfldtmp2
               write(cunit3,rec=irectrue) globfldtmp3
            endif
c
c     -- end of k loop --
            enddo
c     -- end of j loop --
         enddo
c     -- end of irec loop --
      enddo

      do irec = nrec_nl*ny+1, ncvarrecs(ivar)
c     Need to solve for what iobcs would have been.
         iobcs= mod(irec-1,nobcs)+1

         call MDSREADFIELD_XZ_GL( fname, ctrlprec, 'RL',
     &        Nr, globfldxz, irec, mythid)

         write(cunit) ncvarindex(ivar)
         write(cunit) 1
         write(cunit) 1
         do k = 1,Nr
            irectrue = (irec-1)*nobcs*Nr + (iobcs-1)*Nr + k
            cbuffindex = 0
            do jp = 1,nPy
             do bj = jtlo,jthi
              do ip = 1,nPx
               do bi = itlo,ithi
                do i = imin,imax
                 if (globmskxz(i,bi,ip,bj,jp,k,iobcs)  .ne. 0. ) then
                     cbuffindex = cbuffindex + 1
cph(
                     globfldtmp3(i,bi,ip,bj,jp) =
     &                    globfldxz(i,bi,ip,bj,jp,k)
cph)
#ifdef ALLOW_NONDIMENSIONAL_CONTROL_IO
                     if (lxxadxx) then
                        cbuff(cbuffindex) =
     &                       globfldxz(i,bi,ip,bj,jp,k) *
# ifdef CTRL_PACK_PRECISE
     &                       sqrt(weightfldxz(i,bi,ip,bj,jp,k,iobcs))
# else
     &                       sqrt(weightfld(k,iobcs))
# endif
                     else
                        cbuff(cbuffindex) =
     &                       globfldxz(i,bi,ip,bj,jp,k) /
# ifdef CTRL_PACK_PRECISE
     &                       sqrt(weightfldxz(i,bi,ip,bj,jp,k,iobcs))
# else
     &                       sqrt(weightfld(k,iobcs))
# endif
                     endif
cph(
                     globfldtmp2(i,bi,ip,bj,jp) = cbuff(cbuffindex)
cph)
#else /* ALLOW_NONDIMENSIONAL_CONTROL_IO undef */
                     cbuff(cbuffindex) = globfldxz(i,bi,ip,bj,jp,k)
#endif /* ALLOW_NONDIMENSIONAL_CONTROL_IO */
                 endif
                enddo
               enddo
              enddo
             enddo
            enddo
c           --> check cbuffindex.
            if ( cbuffindex .gt. 0) then
               write(cunit) cbuffindex
               write(cunit) k
               write(cunit) (cbuff(ii), ii=1,cbuffindex)
            endif
c
            if ( doPackDiag ) then
               write(cunit2,rec=irectrue) globfldtmp2
               write(cunit3,rec=irectrue) globfldtmp3
            endif
c
c     -- end of k loop --
         enddo
c     -- end of irec loop --
      enddo

      _END_MASTER( mythid )

#endif

      return
      end

#undef ALLOW_LAND_TAVE
#include "LAND_OPTIONS.h"

CBOP
C     !ROUTINE: LAND_CHECK
C     !INTERFACE:
      SUBROUTINE LAND_CHECK( myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R LAND_CHECK
C     | o Check parameters and other package dependences
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     == Global variables ===
C-- size for MITgcm & Land package :
#include "LAND_SIZE.h"

#include "EEPARAMS.h"
#include "PARAMS.h"
#include "LAND_PARAMS.h"
#ifdef ALLOW_MNC
# include "MNC_PARAMS.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     myThid     :: my Thread Id number
      INTEGER myThid

#ifdef ALLOW_LAND
C     !FUNCTIONS:
      INTEGER  ILNBLNK
      EXTERNAL ILNBLNK

C     !LOCAL VARIABLES:
C     msgBuf     :: Informational/error message buffer
C     iUnit      :: Work variable for IO unit number
C     iL         :: Work variable for length of file-name
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      INTEGER iUnit, iL
CEOP

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      _BEGIN_MASTER(myThid)

      iUnit = standardMessageUnit
      WRITE(msgBuf,'(A)') 'LAND_CHECK: #define ALLOW_LAND'
      CALL PRINT_MESSAGE(msgBuf,iUnit,SQUEEZE_RIGHT,myThid)

C--   Print out parameter values :
      WRITE(msgBuf,'(A)') '// ==================================='
      CALL PRINT_MESSAGE(msgBuf,iUnit,SQUEEZE_RIGHT,myThid)
      WRITE(msgBuf,'(A)') '// Land package parameters :'
      CALL PRINT_MESSAGE(msgBuf,iUnit,SQUEEZE_RIGHT,myThid)
      WRITE(msgBuf,'(A)') '// ==================================='
      CALL PRINT_MESSAGE(msgBuf,iUnit,SQUEEZE_RIGHT,myThid)

C- namelist LAND_MODEL_PAR:
       CALL WRITE_0D_L( land_calc_grT, INDEX_NONE,
     &                 'land_calc_grT =',
     &   ' /* step forward ground Temp. on/off flag */')
       CALL WRITE_0D_L( land_calc_grW, INDEX_NONE,
     &                 'land_calc_grW =',
     &   ' /* step forward soil moiture on/off flag */')
       CALL WRITE_0D_L( land_impl_grT, INDEX_NONE,
     &                 'land_impl_grT =',
     &   ' /* solve ground temperature implicitly */')
       CALL WRITE_0D_L( land_calc_snow, INDEX_NONE,
     &                 'land_calc_snow =',
     &   ' /* step forward snow thickness */')
       CALL WRITE_0D_L( land_calc_alb, INDEX_NONE,
     &                 'land_calc_alb =',
     &   ' /* compute land+snow albedo */')
      iL = ILNBLNK( land_grT_iniFile )
      IF ( iL.GE.1 ) THEN
       WRITE(msgBuf,'(A,A)') 'land_grT_iniFile = ',
     &                       '/* Initial ground-Temp Input-File */'
       CALL PRINT_MESSAGE(msgBuf,iUnit,SQUEEZE_RIGHT,myThid)
       WRITE(msgBuf,'(16X,A)') land_grT_iniFile(1:iL)
       CALL PRINT_MESSAGE(msgBuf,iUnit,SQUEEZE_RIGHT,myThid)
       msgBuf='    ;'
       CALL PRINT_MESSAGE(msgBuf,iUnit,SQUEEZE_RIGHT,myThid)
      ENDIF
      iL = ILNBLNK( land_grW_iniFile )
      IF ( iL.GE.1 ) THEN
       WRITE(msgBuf,'(A,A)') 'land_grW_iniFile = ',
     &                       '/* Initial soil-Water Input-File */'
       CALL PRINT_MESSAGE(msgBuf,iUnit,SQUEEZE_RIGHT,myThid)
       WRITE(msgBuf,'(16X,A)') land_grW_iniFile(1:iL)
       CALL PRINT_MESSAGE(msgBuf,iUnit,SQUEEZE_RIGHT,myThid)
       msgBuf='    ;'
       CALL PRINT_MESSAGE(msgBuf,iUnit,SQUEEZE_RIGHT,myThid)
      ENDIF
      iL = ILNBLNK( land_snow_iniFile )
      IF ( iL.GE.1 ) THEN
       WRITE(msgBuf,'(A,A)') 'land_snow_iniFile= ',
     &                  '/* Initial snow thickness Input-File */'
       CALL PRINT_MESSAGE(msgBuf,iUnit,SQUEEZE_RIGHT,myThid)
       WRITE(msgBuf,'(16X,A)') land_grW_iniFile(1:iL)
       CALL PRINT_MESSAGE(msgBuf,iUnit,SQUEEZE_RIGHT,myThid)
       msgBuf='    ;'
       CALL PRINT_MESSAGE(msgBuf,iUnit,SQUEEZE_RIGHT,myThid)
      ENDIF
       CALL WRITE_0D_RL( land_deltaT, INDEX_NONE,'land_deltaT =',
     &  ' /* land model Time-Step (s) */')
       CALL WRITE_0D_RL( land_diagFreq, INDEX_NONE,'land_diagFreq =',
     &   ' /* Frequency^-1 for diagnostic output (s) */')
       CALL WRITE_0D_RL( land_diagFreq, INDEX_NONE,'land_monFreq =',
     &   ' /* Frequency^-1 for monitor output (s) */')
       CALL WRITE_1D_RL( land_dzF,land_nLev, INDEX_K,'land_dzF = ',
     &   ' /* layer thickness ( m ) */')
       CALL WRITE_1D_RL(land_rec_dzC,land_nLev,INDEX_K,'land_rec_dzC= '
     &  ,' /* recip. vertical spacing (m-1) */')
      CALL WRITE_0D_L( land_snapshot_mdsio, INDEX_NONE,
     &     'land_snapshot_mdsio =',
     &     ' /* use MDSIO for snapshot output */')
      CALL WRITE_0D_L( land_snapshot_mnc, INDEX_NONE,
     &     'land_snapshot_mnc =',' /* use MNC for snapshot output */')
      CALL WRITE_0D_L( land_mon_stdio, INDEX_NONE,
     &     'land_mon_stdio =',' /* use STDOUT for monitor output */')
      CALL WRITE_0D_L( land_mon_mnc, INDEX_NONE,
     &     'land_mon_mnc =',' /* use MNC for monitor output */')
      CALL WRITE_0D_L( land_pickup_write_mnc, INDEX_NONE,
     &     'land_pickup_write_mnc =',
     &     ' /* use MNC for writing pickups */')
      CALL WRITE_0D_L( land_pickup_read_mnc, INDEX_NONE,
     &     'land_pickup_read_mnc =',
     &     ' /* use MNC for reading pickups */')

C- namelist LAND_PHYS_PAR:
       CALL WRITE_0D_RL(land_grdLambda,INDEX_NONE,'land_grdLambda =',
     &   ' /* Thermal conductivity of the ground (W/m/K)*/')
       CALL WRITE_0D_RL( land_heatCs,INDEX_NONE,'land_heatCs =',
     &   ' /* Heat capacity of dry soil (J/m3/K) */')
       CALL WRITE_0D_RL( land_CpWater,INDEX_NONE,'land_CpWater =',
     &   ' /* Heat capacity of water    (J/kg/K) */')
       CALL WRITE_0D_RL( land_wTauDiff,INDEX_NONE,'land_wTauDiff =',
     &   ' /* soil moisture diffusion time scale (s) */')
       CALL WRITE_0D_RL( land_waterCap,INDEX_NONE,'land_waterCap =',
     &   ' /* field capacity per meter of soil (1) */')
       CALL WRITE_0D_RL(land_fractRunOff,INDEX_NONE,'land_fractRunOff='
     &  ,' /* fraction of water in excess which run-off */')
       CALL WRITE_0D_RL(land_rhoLiqW,INDEX_NONE,'land_rhoLiqW =',
     &   ' /* density of liquid water (kg/m3) */')
       CALL WRITE_0D_RL(land_rhoSnow,INDEX_NONE,'land_rhoSnow =',
     &   ' /* density of snow (kg/m3) */')
       CALL WRITE_0D_RL(land_Lfreez,INDEX_NONE,'land_Lfreez =',
     &   ' /* Latent heat of freezing (J/kg) */')
       CALL WRITE_0D_RL(land_hMaxSnow,INDEX_NONE,'land_hMaxSnow =',
     &   ' /* maximum snow-thickness (m) */')
       CALL WRITE_0D_RL(diffKsnow,INDEX_NONE,'diffKsnow =',
     &   ' /* thermal conductivity of snow (W/m/K) */')
       CALL WRITE_0D_RL(timeSnowAge,INDEX_NONE,'timeSnowAge =',
     &   ' /* snow aging time scale   (s) */')
       CALL WRITE_0D_RL(hNewSnowAge,INDEX_NONE,'hNewSnowAge =',
     &   ' /* new snow thickness to refresh snow-age by 1/e */')
       CALL WRITE_0D_RL(albColdSnow,INDEX_NONE,'albColdSnow =',
     &   ' /* albedo of cold (=dry) new snow */')
       CALL WRITE_0D_RL(albWarmSnow,INDEX_NONE,'albWarmSnow =',
     &   ' /* albedo of warm (=wet) new snow */')
       CALL WRITE_0D_RL(tempSnowAlbL,INDEX_NONE,'tempSnowAlbL =',
     &   ' /* Temp. transition from ColdSnow to WarmSnow Alb. (oC) */')
       CALL WRITE_0D_RL(albOldSnow, INDEX_NONE,'albOldSnow =',
     &   ' /* albedo of old snow (snowAge >35.d)*/')
       CALL WRITE_0D_RL(hAlbSnow, INDEX_NONE,'hAlbSnow =',
     &   ' /* snow depth for albedo transition */')

      WRITE(msgBuf,'(A)') '// ==================================='
      CALL PRINT_MESSAGE(msgBuf,iUnit,SQUEEZE_RIGHT,myThid)

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C--   Check parameters and model configuration

C-    for now, Land package works only with AIM package:
      IF ( .NOT.useAIM ) THEN
        WRITE(msgBuf,'(A)')
     &  'LAND_CHECK: land pkg only implemented with AIM physics'
        CALL PRINT_ERROR( msgBuf, myThid)
        WRITE(msgBuf,'(A)')
     &  'DO NOT use Land (useLand=T) without AIM (useAIM=F, data.pkg)'
        CALL PRINT_ERROR( msgBuf, myThid)
        STOP 'ABNORMAL END: S/R LAND_CHECK'
      ENDIF

      IF ( land_nLev.NE.2 .AND. land_impl_grT ) THEN
        WRITE(msgBuf,'(2A,I3)') 'LAND_CHECK: ',
     &  ' land_impl_grT=.T. but land_nLev=',land_nLev
        CALL PRINT_ERROR( msgBuf, myThid)
        WRITE(msgBuf,'(A)')
     &  'Implicit scheme only implemented for 2 levels land Temp'
        CALL PRINT_ERROR( msgBuf, myThid)
        STOP 'ABNORMAL END: S/R LAND_CHECK'
      ENDIF

#ifdef ALLOW_LAND_TAVE
        WRITE(msgBuf,'(2A)') 'LAND_CHECK: ',
     &  '#define ALLOW_LAND_TAVE not allowed in LAND_OPTIONS.h'
        CALL PRINT_ERROR( msgBuf, myThid)
        WRITE(msgBuf,'(2A)') 'LAND_CHECK: ',
     &  'since "pkg/timeave" has been removed.'
        CALL PRINT_ERROR( msgBuf, myThid)
        STOP 'ABNORMAL END: S/R LAND_CHECK'
#endif /* ALLOW_LAND_TAVE */

C-    If land_monFreq is > 0, then must compile the monitor pkg
#ifndef ALLOW_MONITOR
      IF (land_monFreq.GT.0.) THEN
        WRITE(msgBuf,'(2A)') 'LAND_CHECK:',
     &  ' land_monFreq > 0 but ALLOW_MONITOR undefined'
        CALL PRINT_ERROR( msgBuf, myThid)
        WRITE(msgBuf,'(2A)')
     &  'Re-compile with pkg monitor (in packages.conf)'
        CALL PRINT_ERROR( msgBuf, myThid)
        STOP 'ABNORMAL END: S/R LAND_CHECK'
      ENDIF
#endif /* ALLOW_MONITOR */

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      _END_MASTER(myThid)

#endif /* ALLOW_LAND */

      RETURN
      END

#include "CTRL_OPTIONS.h"

      SUBROUTINE CTRL_GET_GEN_REC(
     I                        xx_genstartdate,
     I                        xx_genperiod,
     O                        fac,
     O                        first,
     O                        changed,
     O                        count0,
     O                        count1,
     I                        myTime, myIter, myThid )

C     ==================================================================
C     SUBROUTINE ctrl_get_gen_rec
C     ==================================================================
C
C     o Get flags, counters, and the linear interpolation factor for a
C       given control vector contribution.
C     o New, generic, for new routine ctrl_get_gen
C
C     ==================================================================
C     SUBROUTINE ctrl_get_gen_rec
C     ==================================================================

      IMPLICIT NONE

C     == global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "CTRL_SIZE.h"
#include "CTRL.h"
#ifdef ALLOW_CAL
# include "cal.h"
#endif

C     == routine arguments ==
      INTEGER xx_genstartdate(4)
      _RL     xx_genperiod
      _RL     fac
      LOGICAL first
      LOGICAL changed
      INTEGER count0
      INTEGER count1
      _RL     myTime
      INTEGER myIter
      INTEGER myThid

C     == local variables ==
#ifdef ALLOW_CAL
      INTEGER mydate(4)
      INTEGER previousdate(4)
      INTEGER difftime(4)

      INTEGER fldcount
      _RL     fldsecs
      INTEGER prevfldcount
      _RL     prevfldsecs
      INTEGER flddate(4)

      INTEGER fldstartdate(4)
      _RL     fldperiod

      INTEGER year0
      INTEGER year1
#endif /* ALLOW_CAL */

C     Declarations for code, adapted from external_fields_load,
C     for simplied default model calendar without exf/cal
      _RL myRelTime, tmpFac
      INTEGER countP

      INTEGER shiftRec
      CHARACTER*(MAX_LEN_MBUF) msgBuf

C     == end of interface ==

      shiftRec = 0
      IF ( useCAL ) THEN
#ifdef ALLOW_CAL
      fldperiod = 0.

C     Map the field parameters.

      CALL cal_CopyDate(
     I     xx_genstartdate,
     O     fldstartdate,
     I     myThid
     &     )
      fldperiod = xx_genperiod

      IF ( xx_genperiod .EQ. -12. _d 0 ) THEN
C     record numbers are assumed 1 to 12 corresponding to
C     Jan. through Dec.
       CALL cal_GetMonthsRec(
     O      fac, first, changed,
     O      count0, count1, year0, year1,
     I      myTime, myIter, myThid
     &      )
      ELSEIF ( fldperiod .EQ. 0. _d 0 ) THEN
C     Read field only once in the beginning. Hack: count1=count0 causes
C     the model to read the first record twice, but since this this is
C     done only the first time around it is not too much of an overhead.
       first   = ((myTime - modelstart) .LT. 0.5*modelstep)
       changed = .false.
       fac     = 1. _d 0
       count0  = 1
       count1  = count0
      ELSE
C     fldperiod .NE. 0
C--   Determine the current date.
       CALL cal_GetDate( myIter, myTime, mydate, myThid )

C     Determine first record:
       CALL cal_TimePassed( fldstartdate, modelStartDate,
     &                      difftime, myThid )
       CALL cal_ToSeconds ( difftime, fldsecs, myThid )
C     set record-number shift between full ctrl time-serie and
C     "effective" sub-set (i.e., that covers this simulation)
       shiftRec = int( fldsecs/fldperiod )

C     Determine the ctrl record just before mycurrentdate.
       CALL cal_TimePassed( fldstartdate, mydate, difftime,
     &                      myThid )
       CALL cal_ToSeconds( difftime, fldsecs, myThid )
       fldsecs  = int((fldsecs+0.5)/fldperiod)*fldperiod
       fldcount = int((fldsecs+0.5)/fldperiod) + 1

C     Set switches for reading new records.
       first = ((myTime - startTime) .LT. 0.5*deltaTClock)

       IF ( first) THEN
        changed = .false.
       ELSE
        CALL cal_GetDate( myIter-1, myTime-modelstep,
     &                    previousdate, myThid )

        CALL cal_TimePassed( fldstartdate, previousdate,
     &                       difftime, myThid )
        CALL cal_ToSeconds( difftime, prevfldsecs, myThid )
        prevfldsecs  = int((prevfldsecs+0.5)/fldperiod)*fldperiod
        prevfldcount = int((prevfldsecs+0.5)/fldperiod) + 1

        IF (fldcount .NE. prevfldcount) THEN
         changed = .true.
        ELSE
         changed = .false.
        ENDIF
       ENDIF

       count0 = fldcount - shiftRec
       count1 = count0 + 1

       CALL cal_TimeInterval( fldsecs, 'secs', difftime, myThid )
       CALL cal_AddTime( fldstartdate, difftime, flddate, myThid )
       CALL cal_TimePassed( flddate, mydate, difftime, myThid )
       CALL cal_ToSeconds( difftime, fldsecs, myThid )

C     Weight belonging to irec for linear interpolation purposes.
C     Note: The weight as chosen here is 1. - fac of the "old"
C           MITgcm estimation program.
       fac = 1. _d 0 - fldsecs/fldperiod

C     fldperiod .NE. 0.
      ENDIF
#endif /* ALLOW_CAL */
      ELSE
C-    case useCAL=F

C     Code, adapted from external_fields_load, for simplied
C     default model calendar without exf/cal, but
C     based on myTime, myIter, deltaTClock, externForcingCycle, and startTime

      myRelTime = myTime - startTime
      first = (myRelTime .LT. 0.5*deltaTClock)
      IF ( xx_genperiod .EQ. 0. _d 0
     &     .OR. externForcingCycle .EQ. 0. _d 0 ) THEN
C     control parameter is constant in time and only needs to be updated
C     once in the beginning
       changed = .false.
       count0  = 1
       count1  = 1
       fac     = 1. _d 0
      ELSE

C--   Now calculate whether it is time to update the forcing arrays
       CALL GET_PERIODIC_INTERVAL(
     O                   countP, count0, count1, tmpFac, fac,
     I                   externForcingCycle, xx_genperiod,
     I                   deltaTClock, myTime, myThid )

       IF ( count0.NE.countP ) THEN
        changed = .true.
       ELSE
        changed = .false.
       ENDIF
       IF ( first ) changed = .false.

      ENDIF

C-    end if/else useCAL
      ENDIF

      IF ( debugLevel.GE.debLevC ) THEN
C     Do some printing for the protocol.
      _BEGIN_MASTER( myThid )
        WRITE(msgBuf,'(2A,I10,A,1PE21.14)') 'CTRL_GET_GEN_REC:',
     &    ' myIter, myTime =', myIter, ', ', myTime
        CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
        WRITE(msgBuf,'(A,2L3,F21.17,I5)')
     &    '     first, changed, fac, shiftRec:',
     &          first, changed, fac, shiftRec
        CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
        WRITE(msgBuf,'(A,2I5,A,2I5)')
     &    '  in xx_*.effective, count0,1=', count0, count1,
     &    ' ;  in xx_*, rec.#',  count0+shiftRec, count1+shiftRec
        CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
        WRITE(msgBuf,'(A)') ' '
        CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
      _END_MASTER( myThid )
      ENDIF

      RETURN
      END

#include "PTRACERS_OPTIONS.h"

CBOP 1
C     !ROUTINE: PTRACERS_DIAGNOSTICS_STATE

C     !INTERFACE:
      SUBROUTINE PTRACERS_DIAGNOSTICS_STATE(myTime, myIter, myThid)

C     !DESCRIPTION:
C     Fill-in the diagnostics array for PTRACERS state variables

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "DYNVARS.h"
#include "PTRACERS_SIZE.h"
#include "PTRACERS_PARAMS.h"
#include "PTRACERS_FIELDS.h"
#ifdef ALLOW_LONGSTEP
#include "LONGSTEP.h"
#endif

C     !INPUT PARAMETERS:
      _RL     myTime
      INTEGER myIter
      INTEGER myThid
CEOP

#ifdef ALLOW_DIAGNOSTICS

C     !LOCAL VARIABLES:
      LOGICAL  DIAGNOSTICS_IS_ON
      EXTERNAL DIAGNOSTICS_IS_ON
      _RL dummy(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      INTEGER i,j,k,bi,bj,iTr
      CHARACTER*8 diagName
      INTEGER km1
#ifdef ALLOW_LONGSTEP
      INTEGER trIter
#endif

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#ifdef ALLOW_LONGSTEP
C     fill only once every long time step
C     have to treat first time step by hand...
C     trIter=0 when this routine is called the first time
      IF ( staggerTimeStep ) THEN
        trIter = myIter-1
      ELSE
        trIter = myIter
      ENDIF
      IF ( LS_doTimeStep .OR. trIter.EQ.nIter0 ) THEN
#else
      IF ( .TRUE. ) THEN
#endif

       diagName = '        '

       DO iTr = 1,PTRACERS_numInUse

        diagName = '        '
        WRITE(diagName,'(A4,A2)') 'TRAC',PTRACERS_ioLabel(iTr)
        CALL DIAGNOSTICS_FILL( pTracer(1-Olx,1-Oly,1,1,1,iTr), diagName,
     &                         0,Nr,0,1,1,myThid )

        diagName = '        '
        WRITE(diagName,'(A5,A2)') 'UTRAC',PTRACERS_ioLabel(iTr)
        IF ( DIAGNOSTICS_IS_ON(diagName,myThid) ) THEN
         DO bj = myByLo(myThid), myByHi(myThid)
          DO bi = myBxLo(myThid), myBxHi(myThid)
            DO k=1,Nr
              DO j = 1,sNy
                DO i = 1,sNx+1
#ifdef ALLOW_LONGSTEP
C     at first timestep we do not have averaged velocities yet -
C     use initial velocities instead
                 IF ( trIter.GT.nIter0 ) THEN
                  dummy(i,j,k,bi,bj) =
     &                 LS_uVel(i,j,k,bi,bj)*hFacW(i,j,k,bi,bj) *
     &                 0.5 _d 0*( pTracer(i,j,k,bi,bj,iTr)
     &                          + pTracer(i-1,j,k,bi,bj,iTr) )
                 ELSE
#else
                 IF (.TRUE.) THEN
#endif
                  dummy(i,j,k,bi,bj) =
     &                 uVel(i,j,k,bi,bj)*hFacW(i,j,k,bi,bj) *
     &                 0.5 _d 0*( pTracer(i,j,k,bi,bj,iTr)
     &                          + pTracer(i-1,j,k,bi,bj,iTr) )
                 ENDIF
                ENDDO
              ENDDO
            ENDDO
          ENDDO
         ENDDO
         CALL DIAGNOSTICS_FILL( dummy, diagName, 0,Nr,0,1,1,myThid )
        ENDIF

        diagName = '        '
        WRITE(diagName,'(A5,A2)') 'VTRAC',PTRACERS_ioLabel(iTr)
        IF ( DIAGNOSTICS_IS_ON(diagName,myThid) ) THEN
         DO bj = myByLo(myThid), myByHi(myThid)
          DO bi = myBxLo(myThid), myBxHi(myThid)
            DO k=1,Nr
              DO j = 1,sNy+1
                DO i = 1,sNx
#ifdef ALLOW_LONGSTEP
C     at first timestep we do not have averaged velocities yet -
C     use initial velocities instead
                 IF ( trIter.GT.nIter0 ) THEN
                  dummy(i,j,k,bi,bj) =
     &                 LS_vVel(i,j,k,bi,bj)*hFacS(i,j,k,bi,bj) *
     &                 0.5 _d 0*( pTracer(i,j,k,bi,bj,iTr)
     &                          + pTracer(i,j-1,k,bi,bj,iTr) )
                 ELSE
#else
                 IF (.TRUE.) THEN
#endif
                  dummy(i,j,k,bi,bj) =
     &                 vVel(i,j,k,bi,bj)*hFacS(i,j,k,bi,bj) *
     &                 0.5 _d 0*( pTracer(i,j,k,bi,bj,iTr)
     &                          + pTracer(i,j-1,k,bi,bj,iTr) )
                 ENDIF
                ENDDO
              ENDDO
            ENDDO
          ENDDO
         ENDDO
         CALL DIAGNOSTICS_FILL( dummy, diagName, 0,Nr,0,1,1,myThid )
        ENDIF

        diagName = '        '
        WRITE(diagName,'(A5,A2)') 'WTRAC',PTRACERS_ioLabel(iTr)
        IF ( DIAGNOSTICS_IS_ON(diagName,myThid) ) THEN
         DO bj = myByLo(myThid), myByHi(myThid)
          DO bi = myBxLo(myThid), myBxHi(myThid)
            DO k=1,Nr
              km1 = MAX(k-1,1)
              DO j = 1,sNy
                DO i = 1,sNx
#ifdef ALLOW_LONGSTEP
C     at first timestep we do not have averaged velocities yet -
C     use initial velocities instead
                 IF ( trIter.GT.nIter0 ) THEN
                  dummy(i,j,k,bi,bj) = LS_wVel(i,j,k,bi,bj) *
     &                 0.5 _d 0*( pTracer(i,j,k,bi,bj,iTr)
     &                          + pTracer(i,j,km1,bi,bj,iTr) )
                 ELSE
#else
                 IF (.TRUE.) THEN
#endif
                  dummy(i,j,k,bi,bj) = wVel(i,j,k,bi,bj) *
     &                 0.5 _d 0*( pTracer(i,j,k,bi,bj,iTr)
     &                          + pTracer(i,j,km1,bi,bj,iTr) )
                 ENDIF
                ENDDO
              ENDDO
            ENDDO
          ENDDO
         ENDDO
         CALL DIAGNOSTICS_FILL( dummy, diagName, 0,Nr,0,1,1,myThid )
        ENDIF

       ENDDO

C     LS_doTimeStep
      ENDIF

#endif /* ALLOW_DIAGNOSTICS */

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#include "CPP_EEOPTIONS.h"

      SUBROUTINE MDSFINDUNIT( ioUnit, myThid )
C OUT:
C     ioUnit  (integer) :: unit number
C
C MDSFINDUNIT returns a valid, unused unit number for f77 I/O
C The routine stops the program is an error occurs in the process
C of searching the I/O channels.
C
C Created: 03/20/99 adcroft@mit.edu

      IMPLICIT NONE

#include "EEPARAMS.h"

C Arguments
      INTEGER ioUnit
      INTEGER myThid
C Local
      INTEGER ii
      LOGICAL op
      INTEGER ios
      CHARACTER*(MAX_LEN_MBUF) msgBuf
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C Sweep through a valid range of unit numbers
      ioUnit=-1
#ifdef HACK_FOR_GMAO_CPL
      DO ii=31,999
#else /* HACK_FOR_GMAO_CPL */
      DO ii=9,999
#endif /* HACK_FOR_GMAO_CPL */
       IF ( ioUnit.EQ.-1 ) THEN
C- skip reserved unit numbers
        IF (       ii.NE.errorMessageUnit
     &       .AND. ii.NE.standardMessageUnit
     &       .AND. ii.NE.scrUnit1   .AND. ii.NE.scrUnit2
     &       .AND. ii.NE.eeDataUnit .AND. ii.NE.modelDataUnit
     &     ) THEN
          INQUIRE(unit=ii,iostat=ios,opened=op)
          IF ( ios.NE.0 ) THEN
            WRITE(msgBuf,'(A,I4)')
     &        ' MDSFINDUNIT: inquiring unit number =', ii
            CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                          SQUEEZE_RIGHT, myThid )
            WRITE(msgBuf,'(A)')
     &        ' MDSFINDUNIT: inquire statement failed!'
            CALL PRINT_ERROR( msgBuf, myThid )
            STOP 'ABNORMAL END: S/R MDSFINDUNIT'
          ENDIF
          IF ( .NOT.op ) THEN
            ioUnit=ii
          ENDIF
        ENDIF
       ENDIF
      ENDDO

C Was there an available unit number
      IF ( ioUnit.EQ.-1 ) THEN
        WRITE(msgBuf,'(A)')
     &    ' MDSFINDUNIT: could not find an available unit number!'
        CALL PRINT_ERROR( msgBuf, myThid )
        STOP 'ABNORMAL END: S/R MDSFINDUNIT'
      ENDIF

      RETURN
      END

#include "PACKAGES_CONFIG.h"
#include "CPP_OPTIONS.h"

CBOP
C     !ROUTINE: TURNOFF_MODEL_IO
C     !INTERFACE:
      SUBROUTINE TURNOFF_MODEL_IO( seqFlag, myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE TURNOFF_MODEL_IO
C     | o Turn off some of the model output flags
C     *==========================================================*
C     | Used in adjoint simulation (and called after the first
C     |  forward sweep) to avoid writing output multiple times (if
C     |  recomputations and/or grdchk) with the same iter number.
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
c#ifdef ALLOW_MNC
c# include "MNC_PARAMS.h"
c#endif
#ifdef ALLOW_EXF
# include "EXF_PARAM.h"
#endif
#ifdef ALLOW_OBCS
# include "OBCS_PARAMS.h"
#endif
#ifdef ALLOW_ECCO
# include "ECCO_SIZE.h"
# include "ECCO.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     seqFlag :: flag that indicates where this S/R is called from:
C             :: =0 called at the end of S/R COST_FINAL
C             :: =1 called at initialisation when using DIVA
C     myThid  :: My Thread Id number
      INTEGER seqFlag
      INTEGER myThid

C     !LOCAL VARIABLES:
c     CHARACTER*(MAX_LEN_MBUF) msgBuf
CEOP

      _BARRIER

C--   only master-thread resets shared flags (in common block)
      _BEGIN_MASTER( myThid )

C--   Set output freq. to zero to avoid re-write of
C     averaged fields in reverse checkpointing loops
      monitorFreq  = 0.
      dumpFreq     = 0.
      diagFreq     = 0.
      chkPtFreq    = 0.
      pChkPtFreq   = 0.
      dumpInitAndLast = .FALSE.
      writePickupAtEnd= .FALSE.
      plotLevel    = 0

#ifdef ALLOW_MNC
C--   Not the best solution to fix some MNC output, since it is likely
C     that the same problem exists when we do not use MNC. A better fix
C     is to switch off the specific output freq; leave this commented out.
c     monitor_mnc  = .FALSE.
c     snapshot_mnc = .FALSE.
#endif

#ifdef ALLOW_EXF
C-    should call a S/R EXF_TURNOFF_IO (like SEAICE) to reset this flag
      IF ( useEXF ) exf_monFreq = 0.
#endif

#ifdef ALLOW_OBCS
C-    should call a S/R OBCS_TURNOFF_IO (like SEAICE) to reset this flag
      IF ( useOBCS ) OBCS_monitorFreq = 0.
#endif

#ifdef ALLOW_ECCO
C-    should call a S/R ECCO_TURNOFF_IO (like SEAICE) to reset this flag
      IF ( useECCO ) ecco_output_sterGloH = .FALSE.
#endif

C--   Disable SBO output
      useSBO       = .FALSE.

C--   Disable layers package
      useLayers    = .FALSE.

C--   For now, also disable diagnostics output (might need to change
C     this if we want to use diagnostics to output adjoint-variables)
      useDiagnostics = .FALSE.

      _END_MASTER( myThid )

C--   Package specific S/R to turn-off IO flags (all threads do call S/R)

#ifdef ALLOW_SEAICE
      IF ( useSEAICE ) THEN
        CALL SEAICE_TURNOFF_IO( seqFlag, myThid )
      ENDIF
#endif

#ifdef ALLOW_THSICE
      IF ( useThSIce ) THEN
        CALL THSICE_TURNOFF_IO( seqFlag, myThid )
      ENDIF
#endif

#ifdef ALLOW_PTRACERS
      IF ( usePTRACERS ) THEN
        CALL PTRACERS_TURNOFF_IO( seqFlag, myThid )
      ENDIF
#endif

C--   each thread waits for flags to be reset.
      _BARRIER

      RETURN
      END

#include "BULK_FORCE_OPTIONS.h"

CBOP
C     !ROUTINE: BULKF_FLUX_ADJUST
C     !INTERFACE:
      SUBROUTINE BULKF_FLUX_ADJUST(
     I                              bi, bj, iMin, iMax, jMin, jMax,
     I                              adjustMask,
     I                              myTime, myIter, myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R BULKF_FLUX_ADJUST
c     | o Modify fluxes (Qnet,EmPmR) where adjustMask=True
C     *==========================================================*
C     | o presently implemented:
C     | replace computed Qnet,EmPmR by prescribed Qnetch,EmPch
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     == Global data ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "FFIELDS.h"
#include "BULKF_PARAMS.h"
#include "BULKF.h"

C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
C     bi, bj      :: tile indices
C     iMin,iMax   :: computation domain: 1rst index range
C     jMin,jMax   :: computation domain: 2nd  index range
C     adjustMask  :: True where flux adjustment applies
C     myTime      :: Current time in simulation
C     myIter      :: Current iteration number in simulation
C     myThid      :: My Thread number Id

      INTEGER bi,bj
      INTEGER iMin, iMax
      INTEGER jMin, jMax
      LOGICAL adjustMask(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL     myTime
      INTEGER myIter
      INTEGER myThid
CEOP

C     == Local variables ==
      INTEGER i,j

      IF ( useQnetch ) THEN
        DO j = jMin, jMax
         DO i = iMin, iMax
           IF ( adjustMask(i,j) ) Qnet(i,j,bi,bj) = Qnetch(i,j,bi,bj)
         ENDDO
        ENDDO
      ENDIF

      IF ( useEmPch ) THEN
        DO j = jMin, jMax
         DO i = iMin, iMax
           IF ( adjustMask(i,j) ) EmPmR(i,j,bi,bj) = EmPch(i,j,bi,bj)
         ENDDO
        ENDDO
      ENDIF

      RETURN
      END

#include "AUTODIFF_OPTIONS.h"
#ifdef ALLOW_CTRL
# include "CTRL_OPTIONS.h"
#endif
#include "AD_CONFIG.h"

CBOP
C     !ROUTINE: ADDUMMY_IN_DYNAMICS
C     !INTERFACE:
      SUBROUTINE ADDUMMY_IN_DYNAMICS( myTime, myIter, myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE ADDUMMY_IN_DYNAMICS                           |
C     *==========================================================*
C     Extract adjoint variable from TAF-generated
C     adjoint common blocks, contained in adcommon.h
C     and write fields to file;
C     Make sure common blocks in adcommon.h are up-to-date
C     w.r.t. current adjoint code.
C     *==========================================================*
C     | SUBROUTINE ADDUMMY_IN_DYNAMICS                           |
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     == Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "AUTODIFF_PARAMS.h"
#ifdef ALLOW_MNC
#include "MNC_PARAMS.h"
#endif
c#include "GRID.h"
#ifdef ALLOW_AUTODIFF_MONITOR
# include "adcommon.h"
# include "AUTODIFF.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     myTime :: time counter for this thread
C     myIter :: iteration counter for this thread
C     myThid :: Thread number for this instance of the routine.
      _RL     myTime
      INTEGER myIter
      INTEGER myThid

#if (defined (ALLOW_ADJOINT_RUN) || defined (ALLOW_ADMTLM))
#ifdef ALLOW_AUTODIFF_MONITOR

C     !FUNCTIONS:
      LOGICAL  DIFFERENT_MULTIPLE
      EXTERNAL DIFFERENT_MULTIPLE

C     !LOCAL VARIABLES:
c     == local variables ==
C     suff   :: Hold suffix part of a filename
C     msgBuf :: Error message buffer
      CHARACTER*(10) suff
c     CHARACTER*(MAX_LEN_MBUF) msgBuf
#ifdef ALLOW_AUTODIFF_MONITOR_DIAG
      _RL var3Du(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      _RS dumRS(1)
#endif
CEOP

      IF (
     &  DIFFERENT_MULTIPLE(adjDumpFreq,myTime,deltaTClock)
     & ) THEN

        CALL TIMER_START('I/O (WRITE)        [ADJOINT LOOP]', myThid )

c increment ad dump record number (used only if dumpAdByRec is true)
        dumpAdRecDy=dumpAdRecDy+1
c#ifdef ALLOW_DEBUG
c      IF ( debugMode ) print*,'dumpAdRecDy',dumpAdRecDy
c#endif

        IF ( dumpAdVarExch.EQ.1 ) THEN
#ifdef AUTODIFF_TAMC_COMPATIBILITY
C
#else /* ndfef AUTODIFF_TAMC_COMPATIBILITY */
#   ifdef ALLOW_AUTODIFF_MONITOR_DIAG
         CALL ADEXCH_3D_RL( adrhoinsitu, Nr, myThid )
         CALL ADEXCH_3D_RL( adtotphihyd, Nr, myThid )
#   endif
#endif /* AUTODIFF_TAMC_COMPATIBILITY */
        ENDIF

C--     Set suffix for this set of data files.
        IF ( rwSuffixType.EQ.0 ) THEN
          WRITE(suff,'(I10.10)') myIter
        ELSE
          CALL RW_GET_SUFFIX( suff, myTime, myIter, myThid )
        ENDIF

#ifdef ALLOW_AUTODIFF_MONITOR_DIAG
        IF ( dumpAdVarExch.NE.2 ) THEN
          IF (.NOT.dumpAdByRec) CALL WRITE_FLD_XYZ_RL( 'ADJrhoinsitu.',
     &                          suff, adrhoinsitu, myIter, myThid )
          IF (  dumpAdByRec   ) CALL WRITE_REC_XYZ_RL( 'ADJrhoinsitu',
     &                      adrhoinsitu, dumpAdRecDy, myIter, myThid )
cph( is set to zero in addiags_phi_hyd
c          CALL WRITE_FLD_XYZ_RL( 'ADJtotphihyd.', suff,
c                                 adtotphihyd, myIter, myThid )
cph)
        ELSE
C       case dumpAdVarExch = 2
          CALL COPY_ADVAR_OUTP( dumRS,adrhoinsitu,var3Du,Nr,12,myThid )
          IF (.NOT.dumpAdByRec) CALL WRITE_FLD_XYZ_RL( 'ADJrhoinsitu.',
     &                          suff, var3Du, myIter, myThid )
          IF (  dumpAdByRec   ) CALL WRITE_REC_XYZ_RL( 'ADJrhoinsitu',
     &                          var3Du, dumpAdRecDy, myIter, myThid )
        ENDIF
#endif

        CALL TIMER_STOP( 'I/O (WRITE)        [ADJOINT LOOP]', myThid )

      ENDIF

#endif /* ALLOW_AUTODIFF_MONITOR */
#endif /* ALLOW_ADJOINT_RUN */

      RETURN
      END

#include "ECCO_OPTIONS.h"

      SUBROUTINE ECCO_READPARMS( myThid )

c     ==================================================================
c     SUBROUTINE ecco_readparms
c     ==================================================================
c
c     o This routine initialises the package cost.
c     started: Ralf Giering 18-Jan-2001
c
c     ==================================================================
c     SUBROUTINE ecco_readparms
c     ==================================================================

      IMPLICIT NONE

c     == global variables ==
#include "EEPARAMS.h"
#include "SIZE.h"
#include "PARAMS.h"
#ifdef ALLOW_ECCO
# include "ECCO_SIZE.h"
# include "ECCO.h"
# include "ecco_local_params.h"
#endif

c     == routine arguments ==
      INTEGER myThid

c     == external functions ==
      INTEGER  ilnblnk
      EXTERNAL ilnblnk

c     == local variables ==
C     msgBuf      - Informational/error message buffer
C     iUnit       - Work variable for IO unit number
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      INTEGER k, k2, iUnit
#ifdef ALLOW_GENCOST_CONTRIBUTION
      INTEGER IL, kk, gencost_k3d, gencost_msk_k3d, ioUnit
      CHARACTER*(128) tempfile
      LOGICAL exst
      _RS     dummyRS(1)
#endif

Catn-- retired parameters
      INTEGER nRetired
      CHARACTER*(2) cost_yftype
      CHARACTER*(MAX_LEN_FNAM) topexmeanfile
      CHARACTER*(MAX_LEN_FNAM) data_errfile
      LOGICAL using_cost_bp, using_cost_scat
      _RL mult_obcsn, mult_obcss, mult_obcsw, mult_obcse
      _RL mult_obcsvol, mult_ageos

c     == end of interface ==

c--   Read the namelist input.
      namelist /ecco_cost_nml/
     &                   data_errfile,
     &                   tbarfile, sbarfile,sstbarfile,
     &                   psbarfile, bpbarfile,iestaubarfile,
     &                   ubarfile, vbarfile, wbarfile,
     &                   tauxbarfile, tauybarfile,
     &                   hfluxmeanbarfile, sfluxmeanbarfile,
     &                   costTranspDataFile, mdtdatfile,
     &                   mdtstartdate1, mdtstartdate2,
     &                   mdtenddate1, mdtenddate2,
     &                   using_cost_altim,
     &                   using_cost_bp, using_cost_scat,
     &                   using_cost_sst, using_cost_seaice,
     &                   using_cost_transp,
     &                   using_mdt, using_tpj, using_ers, using_gfo,
     &                   using_topex,
     &                   topexstartdate1, topexstartdate2,
     &                   topexperiod, topexfile, tpTimeMaskFile,
     &                   topexintercept, topexslope, ersTimeMaskFile,
     &                   ersstartdate1, ersstartdate2, gfoTimeMaskFile,
     &                   ersperiod, ersfile,
     &                   ersintercept, ersslope,
     &                   gfostartdate1, gfostartdate2,
     &                   gfoperiod, gfofile,
     &                   gfointercept, gfoslope,
     &                   scatstartdate1, scatstartdate2,
     &                   scatperiod, scatxdatfile, scatydatfile,
     &                   scatx_errfile, scaty_errfile,
     &                   ssh_errfile, sshv4cost_scalefile,
     &                   sshv4cost_errfile, sshv4cost_errfactor,
     &                   tp_errfile, ers_errfile, gfo_errfile,
     &                   tmistartdate1, tmistartdate2, tmidatfile,
     &                   sststartdate1, sststartdate2, sstdatfile,
     &                   sssstartdate1, sssstartdate2, sssdatfile,
     &                   bpstartdate1, bpstartdate2, bpdatfile,
     &                   iesstartdate1, iesstartdate2, iesdatfile,
     &                   tdatfile, sdatfile, ctdtfile, ctdsfile,
     &                   ctdtclimfile, ctdsclimfile, xbtfile,
     &                   argotstartdate1, argotstartdate2, argotfile,
     &                   argosstartdate1, argosstartdate2, argosfile,
     &                   udriftfile, vdriftfile,
     &                   udrifterrfile, vdrifterrfile,
     &                   curmtrufile,curmtrvfile,
     &                   salterrfile, temperrfile, velerrfile,
     &                   salt0errfile, temp0errfile, vel0errfile,
     &                   etan0errfile, uvel0errfile, vvel0errfile,
     &                   ssterrfile, ssserrfile, bperrfile,ieserrfile,
     &                   hflux_errfile, sflux_errfile,
     &                   tauu_errfile, tauv_errfile,
     &                   atemp_errfile, aqh_errfile,
     &                   precip_errfile, swflux_errfile, swdown_errfile,
     &                   lwflux_errfile, lwdown_errfile, evap_errfile,
     &                   snowprecip_errfile, apressure_errfile,
     &                   uwind_errfile, vwind_errfile,
     &                   geoid_errfile, geoid_covariancefile,
     &                   bottomdrag_errfile,edtau_errfile,
     &                   kapgm_errfile,kapredi_errfile,diffkr_errfile,
     &                   usercost_datafile, usercost_errfile,
     &                   mult_hflux, mult_sflux, mult_tauu, mult_tauv,
     &                   mult_hfluxmm, mult_sfluxmm,
     &                   mult_atemp, mult_aqh,
     &                   mult_precip, mult_swflux, mult_swdown,
     &                   mult_lwflux, mult_lwdown, mult_evap,
     &                   mult_snowprecip, mult_apressure,
     &                   mult_uwind, mult_vwind,
     &                   mult_hmean, mult_h, mult_sshv4cost,
     &                   mult_tp, mult_ers, mult_gfo,
     &                   mult_temp, mult_salt,
     &                   mult_tmi, mult_sst, mult_sss, mult_bp,
     &                   mult_ctdt, mult_ctds, mult_ies,
     &                   mult_ctdtclim, mult_ctdsclim,
     &                   mult_xbt, mult_drift,
     &                   mult_argot, mult_argos,
     &                   mult_scatx, mult_scaty,
     &                   mult_sdrift, mult_tdrift, mult_wdrift,
     &                   mult_temp0, mult_salt0,
     &                   mult_etan0, mult_uvel0, mult_vvel0,
     &                   mult_obcsn, mult_obcss,
     &                   mult_obcsw, mult_obcse, mult_obcsvol,
     &                   mult_ageos,
     &                   mult_curmtr,
     &                   mult_kapgm, mult_kapredi, mult_diffkr,
     &                   mult_edtau, mult_bottomdrag,
     &                   mult_usercost, mult_transp,
     &                   mult_smooth_ic, mult_smooth_bc,
     &                   whflux0, wsflux0, wtau0,
     &                   wbottomdrag0,
     &                   watemp0, waqh0,
     &                   wprecip0, wswflux0, wswdown0, wwind0,
     &                   wsnowprecip0, wlwflux0, wlwdown0, wevap0,
     &                   wapressure0, wdiffkr0, wkapgm0, wedtau0,
     &                   wkapredi0, wmean_hflux, wmean_sflux, wmean_tau,
     &                   wmean_atemp, wmean_aqh, wmean_precip,
     &                   wmean_swflux, wmean_swdown, wmean_wind,
     &                   wmean_lwflux, wmean_lwdown, wmean_evap,
     &                   wmean_snowprecip, wmean_apressure,
     &                   cost_iprec, ecco_output_sterGloH,
     &                   ecco_keepTSeriesOutp_open,
     &                   cost_yftype, topexmeanfile

#ifdef ALLOW_GENCOST_CONTRIBUTION
      namelist /ecco_gencost_nml/
     &         using_gencost,
     &         gencost_barfile,
     &         gencost_datafile,
     &         gencost_name,
     &         gencost_scalefile,
     &         gencost_errfile,
     &         gencost_itracer,
     &         gencost_kLev_select,
     &         gencost_preproc,
     &         gencost_preproc_c,
     &         gencost_preproc_i,
     &         gencost_preproc_r,
     &         gencost_posproc,
     &         gencost_posproc_c,
     &         gencost_posproc_i,
     &         gencost_posproc_r,
     &         gencost_outputlevel,
     &         gencost_mask,
     &         gencost_spmin,
     &         gencost_spmax,
     &         gencost_spzero,
     &         gencost_wei1d,
     &         gencost_avgperiod,
     &         gencost_nrecperiod,
     &         gencost_startdate1,
     &         gencost_startdate2,
     &         gencost_enddate1,
     &         gencost_enddate2,
     &         gencost_smooth2Ddiffnbt,
     &         gencost_is1d,
     &         gencost_is3d,
     &         gencost_msk_is3d,
     &         gencost_useDensityMask,
     &         gencost_refPressure,
     &         gencost_sigmaLow,
     &         gencost_sigmaHigh,
     &         gencost_tanhScale,
     &         gencost_timevaryweight,
     &         mult_gencost
#endif /* ALLOW_GENCOST_CONTRIBUTION */

      IF ( .NOT.useECCO ) THEN
C-    pkg ECCO is not used
        _BEGIN_MASTER(myThid)
C-    Track pkg activation status:
C     print a (weak) warning if data.ecco is found
         CALL PACKAGES_UNUSED_MSG( 'useECCO', ' ', ' ' )
        _END_MASTER(myThid)
        RETURN
      ENDIF

      _BEGIN_MASTER( myThid )
      nRetired = 0

c--     Set default values.

c run time switches for main cost terms
#if (defined (ALLOW_SSH_COST_CONTRIBUTION) && \
     !defined (ALLOW_GENCOST_CONTRIBUTION) )
      using_cost_altim=.TRUE.
#else
      using_cost_altim=.FALSE.
#endif
#ifdef ALLOW_SEAICE_COST_CONTRIBUTION
      using_cost_seaice=.TRUE.
#else
      using_cost_seaice=.FALSE.
#endif

c- set default to false
      using_cost_transp=.FALSE.

#ifdef ALLOW_SST_COST_CONTRIBUTION
      using_cost_sst=.TRUE.
#else
      using_cost_sst=.FALSE.
#endif

c other run time parameters
        tbarfile              =    'tbar'
        sbarfile              =    'sbar'
        sstbarfile            =    'sstbar'
        psbarfile             =    'psbar'
        bpbarfile             =    'bpbar'
        iestaubarfile         =    'iestaubar'
        ubarfile              =    'ubar'
        vbarfile              =    'vbar'
        wbarfile              =    'wbar'
        tauxbarfile           =    'tauxbar'
        tauybarfile           =    'tauybar'
        hfluxmeanbarfile      =    'hfluxmeanbar'
        sfluxmeanbarfile      =    'sfluxmeanbar'
        costTranspDataFile    =    ' '
        using_tpj             = .false.
        topexstartdate1       =      0
        topexstartdate2       =      0
        topexperiod           =      0. _d 0
        topexintercept        =      0. _d 0
        topexslope            =      0. _d 0
        topexfile             =    ' '
catn: defaulting mdt[start,end]date1 to pavlis so that
catn  eccov4 will run without needing to read in these params
        using_mdt             =.FALSE.
        mdtdatfile            =    ' '
        mdtstartdate1         =      19930101
        mdtstartdate2         =      0
        mdtenddate1           =      20041231
        mdtenddate2           =      0
        using_ers             = .false.
        ersstartdate1         =      0
        ersstartdate2         =      0
        ersperiod             =      0. _d 0
        ersintercept          =      0. _d 0
        ersslope              =      0. _d 0
        ersfile               =    ' '
        using_gfo             = .false.
        gfostartdate1         =      0
        gfostartdate2         =      0
        gfoperiod             =      0. _d 0
        gfointercept          =      0. _d 0
        gfoslope              =      0. _d 0
        gfofile               =    ' '
        scatstartdate1        =      0
        scatstartdate2        =      0
        scatperiod            =      0. _d 0
        scatxdatfile          =    ' '
        scatydatfile          =    ' '
        ssh_errfile           =    ' '
        tp_errfile            =    ' '
        ers_errfile           =    ' '
        gfo_errfile           =    ' '
        scatx_errfile         =    ' '
        scaty_errfile         =    ' '
        tmistartdate1         =      0
        tmistartdate2         =      0
        tmidatfile            =    ' '
        sststartdate1         =      0
        sststartdate2         =      0
        sstdatfile            =    ' '
        sssstartdate1         =      0
        sssstartdate2         =      0
        sssdatfile            =    ' '
        bpstartdate1          =      0
        bpstartdate2          =      0
        bpdatfile             =    ' '
        iesstartdate1         =      0
        iesstartdate2         =      0
        iesdatfile            =    ' '
        tdatfile              =    ' '
        sdatfile              =    ' '
        ctdtfile              =    ' '
        ctdsfile              =    ' '
        ctdtclimfile          =    ' '
        ctdsclimfile          =    ' '
        curmtrufile           =    ' '
        curmtrvfile           =    ' '
        xbtfile               =    ' '
        argotstartdate1       =      0
        argotstartdate2       =      0
        argotfile             =    ' '
        argosstartdate1       =      0
        argosstartdate2       =      0
        argosfile             =    ' '
        udriftfile            =    ' '
        vdriftfile            =    ' '
        udrifterrfile         =    ' '
        vdrifterrfile         =    ' '
        salterrfile           =    ' '
        temperrfile           =    ' '
        velerrfile            =    ' '
        salt0errfile          =    ' '
        temp0errfile          =    ' '
        etan0errfile          =    ' '
        uvel0errfile          =    ' '
        vvel0errfile          =    ' '
        vel0errfile           =    ' '
        ssterrfile            =    ' '
        ssserrfile            =    ' '
        bperrfile             =    ' '
        ieserrfile            =    ' '
        hflux_errfile         =    ' '
        sflux_errfile         =    ' '
        tauu_errfile          =    ' '
        tauv_errfile          =    ' '
        atemp_errfile         =    ' '
        aqh_errfile           =    ' '
        precip_errfile        =    ' '
        swflux_errfile        =    ' '
        swdown_errfile        =    ' '
        lwflux_errfile        =    ' '
        lwdown_errfile        =    ' '
        evap_errfile          =    ' '
        snowprecip_errfile    =    ' '
        apressure_errfile     =    ' '
        uwind_errfile         =    ' '
        vwind_errfile         =    ' '
        geoid_errfile         =    ' '
        geoid_covariancefile  =    ' '
        bottomdrag_errfile    =    ' '
        edtau_errfile         =    ' '
        kapgm_errfile         =    ' '
        kapredi_errfile       =    ' '
        diffkr_errfile        =    ' '
        do k=1,NUSERCOST
         usercost_datafile(k) =    ' '
         usercost_errfile(k)  =    ' '
        enddo
        do k=1,NSSHV4COST
         sshv4cost_scalefile(k) =    ' '
         sshv4cost_errfile(k)   =    ' '
         sshv4cost_errfactor(k) =     1. _d 0
        enddo
        tpTimeMaskFile        =    ' '
        ersTimeMaskFile       =    ' '
        gfoTimeMaskFile       =    ' '

        mult_hflux            =      0. _d 0
        mult_sflux            =      0. _d 0
        mult_hfluxmm          =      0. _d 0
        mult_sfluxmm          =      0. _d 0
        mult_tauu             =      0. _d 0
        mult_tauv             =      0. _d 0
        mult_atemp            =      0. _d 0
        mult_aqh              =      0. _d 0
        mult_precip           =      0. _d 0
        mult_swflux           =      0. _d 0
        mult_swdown           =      0. _d 0
        mult_lwflux           =      0. _d 0
        mult_lwdown           =      0. _d 0
        mult_evap             =      0. _d 0
        mult_snowprecip       =      0. _d 0
        mult_apressure        =      0. _d 0
        mult_uwind            =      0. _d 0
        mult_vwind            =      0. _d 0
        mult_hmean            =      0. _d 0
        mult_h                =      1. _d 0
        mult_tp               =      0. _d 0
        mult_ers              =      0. _d 0
        mult_gfo              =      0. _d 0
        mult_temp             =      0. _d 0
        mult_salt             =      0. _d 0
        mult_temp0            =      0. _d 0
        mult_salt0            =      0. _d 0
        mult_etan0            =      0. _d 0
        mult_uvel0            =      0. _d 0
        mult_vvel0            =      0. _d 0
        mult_tmi              =      0. _d 0
        mult_sst              =      0. _d 0
        mult_sss              =      0. _d 0
        mult_bp               =      0. _d 0
        mult_ies              =      0. _d 0
        mult_ctdt             =      0. _d 0
        mult_ctds             =      0. _d 0
        mult_ctdtclim         =      0. _d 0
        mult_ctdsclim         =      0. _d 0
        mult_xbt              =      0. _d 0
        mult_argot            =      0. _d 0
        mult_argos            =      0. _d 0
        mult_drift            =      0. _d 0
        mult_tdrift           =      0. _d 0
        mult_sdrift           =      0. _d 0
        mult_wdrift           =      0. _d 0
        mult_scatx            =      0. _d 0
        mult_scaty            =      0. _d 0
        mult_curmtr           =      0. _d 0
        mult_kapgm            =      0. _d 0
        mult_kapredi          =      0. _d 0
        mult_diffkr           =      0. _d 0
        mult_edtau            =      0. _d 0
        mult_bottomdrag       =      0. _d 0
        do k=1,NUSERCOST
         mult_usercost(k)     =      0. _d 0
        enddo
        do k=1,NSSHV4COST
         mult_sshv4cost(k)    =      0. _d 0
        enddo
        mult_smooth_ic        =      0. _d 0
        mult_smooth_bc        =      0. _d 0
        mult_transp           =      0. _d 0
        watemp0               =      0. _d 0
        waqh0                 =      0. _d 0
        wprecip0              =      0. _d 0
        wswflux0              =      0. _d 0
        wswdown0              =      0. _d 0
        wlwflux0              =      0. _d 0
        wlwdown0              =      0. _d 0
        wevap0                =      0. _d 0
        wsnowprecip0          =      0. _d 0
        wapressure0           =      0. _d 0
        wwind0                =      0. _d 0
        wdiffkr0              =      1. _d 0
        wkapgm0               =      1. _d 0
        wkapredi0             =      1. _d 0
        wedtau0               =      1. _d 0
        whflux0               =      0. _d 0
        wsflux0               =      0. _d 0
        wtau0                 =      0. _d 0
        wbottomdrag0          =      1. _d 0
        wmean_atemp           =      0. _d 0
        wmean_aqh             =      0. _d 0
        wmean_precip          =      0. _d 0
        wmean_swflux          =      0. _d 0
        wmean_swdown          =      0. _d 0
        wmean_lwflux          =      0. _d 0
        wmean_lwdown          =      0. _d 0
        wmean_evap            =      0. _d 0
        wmean_snowprecip      =      0. _d 0
        wmean_apressure       =      0. _d 0
        wmean_wind            =      0. _d 0
        wmean_hflux           =      0. _d 0
        wmean_sflux           =      0. _d 0
        wmean_tau             =      0. _d 0
        cost_iprec  = precFloat32
        ecco_output_sterGloH  =      .FALSE.
        ecco_keepTSeriesOutp_open =  .FALSE.

C--   retired parameters
        cost_yftype     =   'RL'
        data_errfile    =    ' '
        topexmeanfile   =    ' '
        using_cost_bp   = .FALSE.
        using_cost_scat = .FALSE.
        mult_obcsn      =  UNSET_RL
        mult_obcss      =  UNSET_RL
        mult_obcsw      =  UNSET_RL
        mult_obcse      =  UNSET_RL
        mult_obcsvol    =  UNSET_RL
        mult_ageos      =  UNSET_RL

c--     Next, read the data.ecco file.
        WRITE(msgBuf,'(A)') 'ECCO_READPARMS: opening data.ecco'
        CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )

        CALL OPEN_COPY_DATA_FILE(
     I                          'data.ecco', 'ECCO_READPARMS',
     O                          iUnit,
     I                          myThid )

        READ(  iUnit, nml = ecco_cost_nml )

        WRITE(msgBuf,'(A)')
     &       'ECCO_READPARMS: finished reading #1: ecco_cost_nml'
        CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )

C--   Check parameters:
C-    retired parameters:
        IF ( mult_obcsn.NE.UNSET_RL .OR. mult_obcsn.NE.UNSET_RL .OR.
     &       mult_obcsw.NE.UNSET_RL .OR. mult_obcse.NE.UNSET_RL .OR.
     &       mult_ageos.NE.UNSET_RL .OR. mult_obcsvol.NE.UNSET_RL
     &       ) THEN
       WRITE(msgBuf,'(2A)') 'S/R ECCO_READPARMS: "mult_obcs*" and ',
     &  '"mult_ageos" are no longer allowed in file "data.ecco"'
       CALL PRINT_ERROR( msgBuf, myThid )
       WRITE(msgBuf,'(A)')
     &  'S/R ECCO_READPARMS: set them in data.ctrl instead'
       CALL PRINT_ERROR( msgBuf, myThid )
       nRetired = nRetired + 1
      ENDIF
      IF ( cost_yftype.NE.'RL' ) THEN
       WRITE(msgBuf,'(2A)') 'S/R ECCO_READPARMS: ',
     &  '"cost_yftype" is no longer allowed in file "data.ecco"'
       CALL PRINT_ERROR( msgBuf, myThid )
       nRetired = nRetired + 1
      ENDIF
      IF ( using_cost_bp ) THEN
       WRITE(msgBuf,'(2A)') 'S/R ECCO_READPARMS: ',
     &  '"using_cost_bp" is no longer allowed in file "data.ecco"'
       CALL PRINT_ERROR( msgBuf, myThid )
       nRetired = nRetired + 1
      ENDIF
      IF ( using_cost_scat ) THEN
       WRITE(msgBuf,'(2A)') 'S/R ECCO_READPARMS: ',
     &  '"using_cost_scat" is no longer allowed in file "data.ecco"'
       CALL PRINT_ERROR( msgBuf, myThid )
       nRetired = nRetired + 1
      ENDIF
      IF ( data_errfile .NE. ' ' ) THEN
       WRITE(msgBuf,'(A,A)')
     &  'S/R ECCO_READPARMS: "data_errfile" ',
     &  'is no longer allowed in file "data.ecco"'
       CALL PRINT_ERROR( msgBuf, myThid )
       WRITE(msgBuf,'(A,A)')
     &  'S/R ECCO_READPARMS: set "obcs_data_errfile" ',
     &  'in "data.ctrl" instead'
       CALL PRINT_ERROR( msgBuf, myThid )
       nRetired = nRetired + 1
      ENDIF
      IF ( topexmeanfile .NE. ' ' ) THEN
       WRITE(msgBuf,'(A,A)')
     &  'S/R ECCO_READPARMS: "topexmeanfile" ',
     &  'is no longer allowed in file "data.ecco"'
       CALL PRINT_ERROR( msgBuf, myThid )
       WRITE(msgBuf,'(A)')
     &  'S/R ECCO_READPARMS: set "mdtdatfile" instead'
       CALL PRINT_ERROR( msgBuf, myThid )
       nRetired = nRetired + 1
      ENDIF
      IF ( nRetired .GT. 0 ) THEN
       WRITE(msgBuf,'(2A)') 'S/R ECCO_READPARMS: ',
     &  'Error reading parameter file "data.ecco"'
       CALL PRINT_ERROR( msgBuf, myThid )
       WRITE(msgBuf,'(A)')
     &  'some out-of-date parameters were found in the namelist(s)'
       CALL PRINT_ERROR( msgBuf, myThid )
       CALL ALL_PROC_DIE( 0 )
       STOP 'ABNORMAL END: S/R ECCO_READPARMS'
      ENDIF

      _END_MASTER( myThid )

c     empty pre/post-processing :
c     =========================

      _BEGIN_MASTER( myThid )
      do k2=1,NGENPPROC
       no_preproc(k2)     = ' '
       no_preproc_c(k2)   = ' '
       no_preproc_i(k2)   = 0
       no_preproc_r(k2)   = 0. _d 0
       no_posproc(k2)     = ' '
       no_posproc_c(k2)   = ' '
       no_posproc_i(k2)   = 0
       no_posproc_r(k2)   = 0. _d 0
       clim_preproc(k2)   = ' '
       clim_preproc_i(k2) = 0
       anom_preproc(k2)   = ' '
      enddo
      clim_preproc(1)   = 'clim'
      clim_preproc_i(1) = 12
      anom_preproc(1)   = 'anom'
      _END_MASTER( myThid )

#ifdef ALLOW_GENCOST_CONTRIBUTION

      _BEGIN_MASTER( myThid )

c--   Set default values.
      do k=1,NGENCOST
         using_gencost(k)      = .FALSE.
         gencost_flag(k)       = 0
         gencost_avgperiod(k)  = '     '
         gencost_startdate1(k) = 0
         gencost_startdate2(k) = 0
         gencost_enddate1(k) = 0
         gencost_enddate2(k) = 0
         gencost_datafile(k)   = ' '
         gencost_name(k)       = 'gencost'
         do k2=1,NGENPPROC
          gencost_preproc(k2,k)   = ' '
          gencost_preproc_c(k2,k) = ' '
          gencost_preproc_i(k2,k) = 0
          gencost_preproc_r(k2,k) = 0. _d 0
          gencost_posproc(k2,k)   = ' '
          gencost_posproc_c(k2,k) = ' '
          gencost_posproc_i(k2,k) = 0
          gencost_posproc_r(k2,k) = 0. _d 0
         enddo
         gencost_outputlevel(k)= 0
         gencost_errfile(k)    = ' '
         gencost_itracer(k)    = 1
         gencost_kLev_select(k)= 1
         gencost_mask(k)       = ' '
         gencost_barfile(k)    = ' '
         gencost_spmin(k)      = 0. _d 0
         gencost_spmax(k)      = 0. _d 0
         gencost_spzero(k)     = 9876. _d 0
         gencost_wei1d(k)      = 0. _d 0
         mult_gencost(k)       = 1. _d 0
         gencost_is1d(k)       = .FALSE.
         gencost_is3d(k)       = .FALSE.
         gencost_useDensityMask(k) = .FALSE.
         gencost_refPressure(k) = 0. _d 0
         gencost_sigmaLow(k)    = 0. _d 0
         gencost_sigmaHigh(k)   = 1. _d 3
         gencost_tanhScale(k)   = 1. _d 5
         gencost_pointer3d(k)  = 0
         gencost_msk_is3d(k)   = .FALSE.
         gencost_msk_pointer3d(k)  = 0
c boxmean/horflux masks
         call ecco_zero(gencost_mskCsurf(1-OLx,1-OLy,1,1,k),
     &          1,zeroRL,myThid)
         call ecco_zero(gencost_mskWsurf(1-OLx,1-OLy,1,1,k),
     &          1,zeroRL,myThid)
         call ecco_zero(gencost_mskSsurf(1-OLx,1-OLy,1,1,k),
     &          1,zeroRL,myThid)
         do k2 = 1,Nr
          gencost_mskVertical(k2,k)= 1. _d 0
         enddo
c deprecated:
        gencost_nrecperiod(k) = 0
        gencost_scalefile(k)  = ' '
        gencost_smooth2Ddiffnbt(k) = 0
        gencost_timevaryweight(k)  = .FALSE.
      enddo

#ifdef ALLOW_GENCOST3D
      do k=1,NGENCOST3D
c boxmean/horflux masks
         call ecco_zero(gencost_mskC(1-OLx,1-OLy,1,1,1,k),
     &          Nr,zeroRL,myThid)
         call ecco_zero(gencost_mskW(1-OLx,1-OLy,1,1,1,k),
     &          Nr,zeroRL,myThid)
         call ecco_zero(gencost_mskS(1-OLx,1-OLy,1,1,1,k),
     &          Nr,zeroRL,myThid)
      enddo
#endif

      READ(  iUnit, nml = ecco_gencost_nml )

      WRITE(msgBuf,'(A)')
     &     'ECCO_READPARMS: finished reading #2: ecco_gencost_nml'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )

      gencost_k3d=1
      gencost_msk_k3d=1

      do k=1,NGENCOST

c pre-specified generic cost terms using otherwise created barfiles
         if ( (gencost_name(k).EQ.'sshv4-mdt').OR.
     &        (gencost_name(k).EQ.'sshv4-tp').OR.
     &        (gencost_name(k).EQ.'sshv4-ers').OR.
     &        (gencost_name(k).EQ.'sshv4-gfo').OR.
     &        (gencost_name(k).EQ.'sshv4-lsc').OR.
     &        (gencost_name(k).EQ.'sshv4-gmsl').OR.
     &        (gencost_name(k).EQ.'bpv4-grace').OR.
     &        (gencost_name(k).EQ.'sstv4-amsre').OR.
     &        (gencost_name(k).EQ.'sstv4-amsre-lsc') ) then
           gencost_flag(k)=-1
           using_gencost(k)=.TRUE.

catn move boxmean outside -1 to have its own check
catn preserve -2 for potential separate group above into cost
catn with and without requirements of datafile or errfile
         elseif ( (gencost_barfile(k)(1:9).EQ.'m_boxmean').OR.
     &            (gencost_barfile(k)(1:9).EQ.'m_horflux') ) then
           gencost_flag(k)=-3
           using_gencost(k)=.TRUE.
           il=ilnblnk(gencost_name(k))
           WRITE(msgBuf,'(A,I3,3A,L5)') 'gencost k_boxmean/horflux=',
     &     k,' ',gencost_name(k)(1:il),': ',using_gencost(k)
           CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                         SQUEEZE_RIGHT, myThid )

           if ( gencost_msk_is3d(k) ) then
             gencost_msk_pointer3d(k)=gencost_msk_k3d
             gencost_msk_k3d=gencost_msk_k3d+1
           endif

catn add cost global transport using gencost framework
         elseif ( gencost_name(k)(1:6).EQ.'transp' ) then
           gencost_flag(k)=-4
           using_gencost(k)=.TRUE.
           il=ilnblnk(gencost_name(k))
           WRITE(msgBuf,'(A,i3,3A,L5)') 'gencost k_transp=',
     &     k,' ',gencost_name(k)(1:il),': ',using_gencost(k)
           CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                         SQUEEZE_RIGHT, myThid )

cts moc cost function using gencost framework
         elseif ( gencost_name(k)(1:3).EQ.'moc' ) then
           gencost_flag(k)=-5
           using_gencost(k)=.TRUE.
           il=ilnblnk(gencost_name(k))
           WRITE(msgBuf,'(A,i2,2A,L5)') 'gencost k_moc=',
     &     k,gencost_name(k)(1:il),': ',using_gencost(k)
           CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                         SQUEEZE_RIGHT, myThid )

c pre-specified generic cost terms that create their own barfile
         elseif (
     &        (gencost_name(k).EQ.'siv4-conc').OR.
     &        (gencost_name(k).EQ.'siv4-deconc').OR.
     &        (gencost_name(k).EQ.'siv4-exconc') ) then
           gencost_flag(k)=2
           using_gencost(k)=.TRUE.
c fully interactive generic cost terms
         elseif ( gencost_datafile(k) .NE. ' ' ) then
           gencost_flag(k)=1
           using_gencost(k)=.TRUE.
         endif

c identified three dimensional variables
         if ( (gencost_barfile(k)(1:7).EQ.'m_theta').OR.
     &        (gencost_barfile(k)(1:6).EQ.'m_salt').OR.
     &        (gencost_barfile(k)(1:8).EQ.'m_diffkr').OR.
     &        (gencost_barfile(k)(1:7).EQ.'m_kapgm').OR.
     &        (gencost_barfile(k)(1:9).EQ.'m_kapredi').OR.
     &        (gencost_barfile(k)(1:7).EQ.'m_trVol').OR.
     &        (gencost_barfile(k)(1:8).EQ.'m_trHeat').OR.
     &        (gencost_barfile(k)(1:8).EQ.'m_trSalt')
     &       )
     &        gencost_is3d(k)=.TRUE.

c assign a 3D storage array, then increment 3D variables counter
         if ( gencost_is3d(k) ) then
           gencost_pointer3d(k)=gencost_k3d
           gencost_k3d=gencost_k3d+1
         endif

      enddo

C--   load masks if needed:
      do k=1,NGENCOST
           kk=gencost_msk_pointer3d(k)
           if ( ( gencost_mask(k) .NE. ' ' ).AND.
     &          (gencost_flag(k).EQ.-3 .or.
     &           gencost_flag(k).eq.-4 .or.
     &           gencost_flag(k).eq.-5    ) ) then
c
            il = ilnblnk(gencost_mask(k))
            write(tempfile(1:128),'(2A)') gencost_mask(k)(1:il),'C'
            inquire( file=tempfile(1:il+1), exist=exst )
            if (exst.AND.(.NOT.gencost_msk_is3d(k))) then
             CALL READ_REC_3D_RL( tempfile, cost_iprec, 1,
     &            gencost_mskCsurf(1-OLx,1-OLy,1,1,k), 1, 1, myThid )
#ifdef ALLOW_GENCOST3D
            elseif (exst.AND.(gencost_msk_pointer3d(k).LE.
     &                        NGENCOST3D)) then
             CALL READ_REC_3D_RL( tempfile, cost_iprec, Nr,
     &            gencost_mskC(1-OLx,1-OLy,1,1,1,kk), 1, 1, myThid )
#endif
            endif
c
            il = ilnblnk(gencost_mask(k))
            write(tempfile(1:128),'(2A)') gencost_mask(k)(1:il),'W'
            inquire( file=tempfile(1:il+1), exist=exst )
            if (exst.AND.(.NOT.gencost_msk_is3d(k))) then
             CALL READ_REC_3D_RL( tempfile, cost_iprec, 1,
     &            gencost_mskWsurf(1-OLx,1-OLy,1,1,k), 1, 1, myThid )
#ifdef ALLOW_GENCOST3D
            elseif (exst.AND.(gencost_msk_pointer3d(k).LE.
     &                        NGENCOST3D)) then
             CALL READ_REC_3D_RL( tempfile, cost_iprec, Nr,
     &            gencost_mskW(1-OLx,1-OLy,1,1,1,kk), 1, 1, myThid )
#endif
            endif
c
            il = ilnblnk(gencost_mask(k))
            write(tempfile(1:128),'(2A)') gencost_mask(k)(1:il),'S'
            inquire( file=tempfile(1:il+1), exist=exst )
            if (exst.AND.(.NOT.gencost_msk_is3d(k))) then
             CALL READ_REC_3D_RL( tempfile, cost_iprec, 1,
     &            gencost_mskSsurf(1-OLx,1-OLy,1,1,k), 1, 1, myThid )
#ifdef ALLOW_GENCOST3D
            elseif (exst.AND.(gencost_msk_pointer3d(k).LE.
     &                        NGENCOST3D)) then
             CALL READ_REC_3D_RL( tempfile, cost_iprec, Nr,
     &            gencost_mskS(1-OLx,1-OLy,1,1,1,kk), 1, 1, myThid )
#endif
            endif
c
            il = ilnblnk(gencost_mask(k))
            write(tempfile(1:128),'(2A)') gencost_mask(k)(1:il),'K'
            inquire( file=tempfile(1:il+1), exist=exst )
            if (exst) then
             ioUnit = 0
             CALL MDS_READVEC_LOC( tempfile, cost_iprec, ioUnit, 'RL',
     &        Nr, gencost_mskVertical(1,k), dummyRS, 0, 0, 1, myThid )
            endif
c
           endif!errfile
      enddo

C--   Check parameters:
      do k=1,NGENCOST

cgf ensure backward compatibility:
        if (gencost_barfile(k).NE.' ') then
         if (gencost_barfile(k)(1:2).NE.'m_') then
          il=ilnblnk(gencost_barfile(k))
          WRITE(msgBuf,'(A,A)') 'm_',gencost_barfile(k)(1:il)
          gencost_barfile(k)=msgBuf(1:il+2)
         endif
         if (gencost_barfile(k)(1:8).EQ.'m_tauZon') then
          il=ilnblnk(gencost_barfile(k))
          WRITE(msgBuf,'(A,A)') 'm_ustress',gencost_barfile(k)(9:il)
          gencost_barfile(k)=msgBuf(1:il+1)
         endif
         if (gencost_barfile(k)(1:8).EQ.'m_tauMer') then
          il=ilnblnk(gencost_barfile(k))
          WRITE(msgBuf,'(A,A)') 'm_vstress',gencost_barfile(k)(9:il)
          gencost_barfile(k)=msgBuf(1:il+1)
         endif
        endif

catn separate out blocks of gencost_flag so that each block is checked
        if ( using_gencost(k)) then
         if ( gencost_flag(k).GE.1 ) then

          if ( gencost_name(k) .EQ. 'gencost' )
     &        gencost_name(k) = gencost_datafile(k)

          if ( gencost_avgperiod(k) .NE. 'day  ' .AND.
     &        gencost_avgperiod(k) .NE. 'DAY  ' .AND.
     &        gencost_avgperiod(k) .NE. 'month' .AND.
     &        gencost_avgperiod(k) .NE. 'MONTH' .AND.
     &        gencost_avgperiod(k) .NE. 'step' .AND.
     &        gencost_avgperiod(k) .NE. 'STEP' .AND.
     &        gencost_avgperiod(k) .NE. 'const' .AND.
     &        gencost_avgperiod(k) .NE. 'CONST' .AND.
     &        gencost_avgperiod(k) .NE. 'year ' .AND.
     &        gencost_avgperiod(k) .NE. 'YEAR ' ) then

            il=ilnblnk(gencost_name(k))
            WRITE(msgBuf,'(A,I2,2A)')
     &          'ERROR in ECCO_READPARMS: for gencost',k,
     &          '  ',gencost_name(k)(1:il)
            CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                          SQUEEZE_RIGHT, myThid )
            STOP
     &           'ECCO_READPARMS: gencost_avgperiod not properly set'
          endif

          if ( gencost_spmin(k) .EQ. 0. _d 0 .AND.
     &        gencost_spmax(k) .EQ. 0. _d 0 ) then
            il=ilnblnk(gencost_name(k))
            WRITE(msgBuf,'(A,I2,2A)')
     &          'ERROR in ECCO_READPARMS: for gencost',k,
     &          '  ',gencost_name(k)(1:il)
            CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                          SQUEEZE_RIGHT, myThid )
            STOP
     &       'ECCO_READPARMS: gencost_spmin, gencost_spmax not set'
          endif

          if ( gencost_spzero(k) .EQ. 9876. _d 0 ) then
            il=ilnblnk(gencost_name(k))
            WRITE(msgBuf,'(A,I2,2A)')
     &          'ERROR in ECCO_READPARMS: for gencost',k,
     &          '  ',gencost_name(k)(1:il)
            CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                          SQUEEZE_RIGHT, myThid )
            STOP
     &       'ECCO_READPARMS: gencost_spzero not set'
          endif

catn -- checking for -1 flag
         elseif( gencost_flag(k) .eq. -1 ) then
catn -- checking boxmean and transp
         elseif( gencost_flag(k).lt.-1) then
            if ( gencost_avgperiod(k) .NE. 'day  ' .AND.
     &           gencost_avgperiod(k) .NE. 'DAY  ' .AND.
     &           gencost_avgperiod(k) .NE. 'month' .AND.
     &           gencost_avgperiod(k) .NE. 'MONTH' .AND.
     &           gencost_avgperiod(k) .NE. 'step' .AND.
     &           gencost_avgperiod(k) .NE. 'STEP' .AND.
     &           gencost_avgperiod(k) .NE. 'const' .AND.
     &           gencost_avgperiod(k) .NE. 'CONST' .AND.
     &           gencost_avgperiod(k) .NE. 'year ' .AND.
     &           gencost_avgperiod(k) .NE. 'YEAR ' ) then

              il=ilnblnk(gencost_name(k))
              WRITE(msgBuf,'(A,I2,2A)')
     &          'ERROR in ECCO_READPARMS: for gencost',k,
     &          '  ',gencost_name(k)(1:il)
              CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                            SQUEEZE_RIGHT, myThid )
            STOP
     &           'ECCO_READPARMS: gencost_avgperiod not properly set'
            endif
         endif !gencost_flag
        endif !using_gencost

      end do

      _END_MASTER( myThid )

#endif /* ALLOW_GENCOST_CONTRIBUTION */

      _BEGIN_MASTER( myThid )

#ifdef SINGLE_DISK_IO
      CLOSE(iUnit)
#else
      CLOSE(iUnit,STATUS='DELETE')
#endif /* SINGLE_DISK_IO */

      _END_MASTER( myThid )

      WRITE(msgBuf,'(A)')
     &     'ECCO_READPARMS: done'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )

      _BARRIER

      RETURN
      END

#include "PROFILES_OPTIONS.h"
#include "AD_CONFIG.h"

C--  File profiles_nc_utils.F:
C--   Contents
C--   o PROFILES_NF_ERROR
C--   o PROFILES_NC_CLOSE

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C !ROUTINE: PROFILES_NF_ERROR

C !INTERFACE:
      SUBROUTINE PROFILES_NF_ERROR( message, STATUS, bi, bj, myThid )

C     !DESCRIPTION:
C     Print NetCDF error message

C     !USES:
      IMPLICIT NONE
C     == Global variables ===
#ifdef ALLOW_PROFILES
# include "SIZE.h"
# include "EEPARAMS.h"
# include "PARAMS.h"
# include "netcdf.inc"
#endif

C     !INPUT PARAMETERS:
C     message   :: optional message
C     STATUS    :: NetCDF error status
C     bi,bj     :: Tile indices
C     myThid: my thread ID number
      CHARACTER*(*) message
      INTEGER STATUS, bi, bj, myThid

C     !OUTPUT PARAMETERS:
CEOP

C     !FUNCTIONS:
      INTEGER ILNBLNK
      EXTERNAL ILNBLNK

C     !LOCAL VARIABLES:
#ifdef ALLOW_PROFILES
      INTEGER IL
      CHARACTER*(MAX_LEN_MBUF) msgBuf

      IF (debugLevel .GE. debLevA .AND. STATUS .NE. NF_NOERR) THEN
        IL = ILNBLNK(message)
        IF ( IL .GT. 0 ) THEN
          WRITE(msgBuf,'(A,A,2I3,1X,A)')
     &     'NF_MESSAGE: PROFILES_', message(1:IL),
     &     bi, bj, NF_STRERROR(STATUS)
        ELSE
          WRITE(msgBuf,'(A,2I3,1X,A)') 'NF_MESSAGE: PROFILES ',
     &     bi, bj, NF_STRERROR(STATUS)
        ENDIF
        CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &       SQUEEZE_RIGHT,myThid )
      ENDIF
#endif /* ALLOW_PROFILES */

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C !ROUTINE: PROFILES_NC_CLOSE

C !INTERFACE:
      SUBROUTINE PROFILES_NC_CLOSE( myThid )

C     !DESCRIPTION:
C     Close NetCDF files

C     !USES:
      IMPLICIT NONE
C     == Global variables ===
#ifdef ALLOW_PROFILES
# include "SIZE.h"
# include "EEPARAMS.h"
# include "PROFILES_SIZE.h"
# include "profiles.h"
# include "netcdf.inc"
#endif

C     !INPUT PARAMETERS:
C     myThid :: my Thread Id number
      INTEGER myThid

C     !OUTPUT PARAMETERS:
CEOP

C     !FUNCTIONS:
      INTEGER ILNBLNK
      EXTERNAL ILNBLNK

C     !LOCAL VARIABLES:
#ifdef ALLOW_PROFILES
C     bi,bj :: Tile indices
      INTEGER bi, bj
      INTEGER IL, numFile
      INTEGER STATUS
      CHARACTER*(MAX_LEN_MBUF) msgBuf

      _BEGIN_MASTER( myThid )

      IF (profilesDoNcOutput) THEN
c       DO bj = myByLo(myThid), myByHi(myThid)
c         DO bi = myBxLo(myThid), myBxHi(myThid)
C     Since this is only done by the master thread, we loop over the
C     enire range of tiles
        DO bj = 1, nSy
          DO bi = 1, nSx
            DO numFile = 1, NFILESPROFMAX
              IL = ILNBLNK( profilesfiles(numFile) )

              IF (IL.NE.0) THEN
                WRITE(msgBuf,'(A,A,5(1X,I8))')
     &           'S/R PROFILES_NC_CLOSE:',
     &           ' Closing '//profilesfiles(numFile)(1:IL), numFile,
     &           fiddata(numFile,bi,bj),fidforward(numFile,bi,bj),
     &           fidadjoint(numFile,bi,bj),fidtangent(numFile,bi,bj)
                CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &               SQUEEZE_RIGHT,myThid )
C Data file
                IF ( fiddata(numFile,bi,bj) .GT. 0 ) THEN
                 STATUS = NF_CLOSE( fiddata(numFile,bi,bj) )
                 WRITE(msgBuf,'(A,I3,I8)')
     &                'NC_CLOSE: NF_CLOSE data unit',
     &                numFile, fiddata(numFile,bi,bj)
                 CALL PROFILES_NF_ERROR( msgBuf, STATUS,
     &                bi, bj, myThid )
                ENDIF

C Forward equivalent (.equi) file
                IF ( fidforward(numFile,bi,bj) .GT. 0 ) THEN
                 STATUS = NF_CLOSE( fidforward(numFile,bi,bj) )
                 WRITE(msgBuf,'(A,I3,I8)')
     &                'NC_CLOSE: NF_CLOSE fwd unit',
     &                numFile, fidforward(numFile,bi,bj)
                 CALL PROFILES_NF_ERROR( msgBuf, STATUS,
     &                bi, bj, myThid )
                ENDIF
#ifdef ALLOW_ADJOINT_RUN
C Adjoint equivalent (.equi) file
                IF ( fidadjoint(numFile,bi,bj) .GT. 0 ) THEN
                 STATUS = NF_CLOSE( fidadjoint(numFile,bi,bj) )
                 WRITE(msgBuf,'(A,I3,I8)')
     &                'NC_CLOSE: NF_CLOSE adj unit',
     &                numFile, fidadjoint(numFile,bi,bj)
                 CALL PROFILES_NF_ERROR( msgBuf, STATUS,
     &                bi, bj, myThid )
                ENDIF
#endif
#ifdef ALLOW_TANGENTLINEAR_RUN
C Tangent linear equivalent (.equi) file
                IF ( fidtangent(numFile,bi,bj) .GT. 0 ) THEN
                 STATUS = NF_CLOSE( fidtangent(numFile,bi,bj) )
                 WRITE(msgBuf,'(A,I3,I8)')
     &                'NC_CLOSE: NF_CLOSE tlm unit',
     &                numFile, fidtangent(numFile,bi,bj)
                 CALL PROFILES_NF_ERROR( msgBuf, STATUS,
     &                bi, bj, myThid )
                ENDIF
#endif
              ENDIF !(IL.NE.0)

            ENDDO
          ENDDO
        ENDDO
      ENDIF

      _END_MASTER( myThid )
#endif /* ALLOW_PROFILES */

      RETURN
      END

#include "ATM_PHYS_OPTIONS.h"

CBOP
C !ROUTINE: ATM_PHYS_DYN2PHYS

C !INTERFACE: ==========================================================
      SUBROUTINE ATM_PHYS_DYN2PHYS(
     O                    lat2d, pHalf3d, pFull3d,
     O                    zHalf3d, zFull3d,
     O                    t3d, q3d, u3d, v3d,
     I                    bi, bj, myTime, myIter, myThid )

C !DESCRIPTION:
C     *==========================================================*
C     | S/R ATM_PHYS_DYN2PHYS
C     | o Get grid and dynamical fields (from main model common
C     |   blocks) and return them as argument to ATM_PHYS_DRIVER
C     *==========================================================*
C     \ev

C !USES: ===============================================================
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "DYNVARS.h"
#include "SURFACE.h"

C !INPUT PARAMETERS: ===================================================
C  bi, bj   :: Tile indices
C  myTime   :: Current time in simulation
C  myIter   :: Current time-step number
C  myThid   :: my Thread Id number
      INTEGER bi, bj
      _RL     myTime
      INTEGER myIter, myThid

C !OUTPUT PARAMETERS: ==================================================
C  lat2d    :: latitude of grid-cell center          [rad]
C pHalf3d   :: pressure at interface between 2 levels [Pa]
C pFull3d   :: pressure at level center               [Pa]
C zHalf3d   :: height of interface between 2 levels   [m]
C zFull3d   :: height of level center                 [m]
C  t3d      :: absolute temperature                   [K]
C  q3d      :: specific humidity                    [kg/kg]
C  u3d      :: wind speed, 1rst component (X-dir)    [m/s]
C  v3d      :: wind speed, 2nd  component (Y-dir)    [m/s]
      _RL lat2d   (sNx,sNy)
      _RL pHalf3d (sNx,sNy,Nr+1)
      _RL pFull3d (sNx,sNy,Nr)
      _RL zHalf3d (sNx,sNy,Nr+1)
      _RL zFull3d (sNx,sNy,Nr)
      _RL t3d     (sNx,sNy,Nr)
      _RL q3d     (sNx,sNy,Nr)
      _RL u3d     (sNx,sNy,Nr)
      _RL v3d     (sNx,sNy,Nr)

C !LOCAL VARIABLES: ====================================================
      _RL conv_theta2T
      INTEGER k, kc, ki, kp
c     INTEGER ioUnit
c     _RS     dummyRS(1)
c     CHARACTER*40 namFile
CEOP

C--   latitude and pressure levels
      lat2d(:,:) = yC(1:sNx,1:sNy,bi,bj)*deg2rad
#ifdef NONLIN_FRSURF
      IF ( nonlinFreeSurf.GT.0 ) THEN
       IF ( staggerTimeStep.AND.select_rStar.GT.0 ) THEN
         DO k=1,Nr
          kc = Nr-k+1
          pFull3d(:,:,k) = rF(Nr+1) + ( rC(kc) - rF(Nr+1) )
     &                               *rStarFacC(1:sNx,1:sNy,bi,bj)
         ENDDO
         DO k=1,Nr+1
          ki = Nr-k+2
          pHalf3d(:,:,k) = rF(Nr+1) + ( rF(ki) - rF(Nr+1) )
     &                               *rStarFacC(1:sNx,1:sNy,bi,bj)
         ENDDO
       ELSEIF ( select_rStar.GT.0 ) THEN
         DO k=1,Nr
          kc = Nr-k+1
          pFull3d(:,:,k) = rF(Nr+1) + ( rC(kc) - rF(Nr+1) )
     &                               *rStarFacNm1C(1:sNx,1:sNy,bi,bj)
         ENDDO
         DO k=1,Nr+1
          ki = Nr-k+2
          pHalf3d(:,:,k) = rF(Nr+1) + ( rF(ki) - rF(Nr+1) )
     &                               *rStarFacNm1C(1:sNx,1:sNy,bi,bj)
         ENDDO
       ELSE
         STOP 'ATM_PHYS_DYN2PHYS: misssing code - 1 -'
       ENDIF
      ELSE
#else /* ndef NONLIN_FRSURF */
      IF (.TRUE.) THEN
#endif /* NONLIN_FRSURF */
       DO k=1,Nr
        kc = Nr-k+1
        pFull3d(:,:,k) = rC(kc)
       ENDDO
       DO k=1,Nr+1
        ki = Nr-k+2
        pHalf3d(:,:,k) = rF(ki)
       ENDDO
      ENDIF

C--   level height and 3-D dynamical fields
      DO k=1,Nr
        kc = Nr-k+1
        zFull3d(:,:,k) = ( phiRef(2*kc)
     &                   + totPhiHyd(1:sNx,1:sNy,kc,bi,bj)
     &                   )*recip_gravity
        conv_theta2T = (rC(kc)/atm_po)**atm_kappa
        t3d(:,:,k) = theta(1:sNx,1:sNy,kc,bi,bj)*conv_theta2T
        q3d(:,:,k) = MAX( salt(1:sNx,1:sNy,kc,bi,bj), 0. _d 0 )
        u3d(:,:,k) = ( uVel(1:sNx,  1:sNy,kc,bi,bj)
     &               + uVel(2:sNx+1,1:sNy,kc,bi,bj) )*0.5 _d 0
        v3d(:,:,k) = ( vVel(1:sNx,1:sNy,  kc,bi,bj)
     &               + vVel(1:sNx,2:sNy+1,kc,bi,bj) )*0.5 _d 0
       IF ( nonlinFreeSurf.LE.0 ) THEN
        zFull3d(:,:,k) = zFull3d(:,:,k)
     &                 - Bo_surf(1:sNx,1:sNy,bi,bj)
     &                     *etaN(1:sNx,1:sNy,bi,bj)
     &                     *recip_gravity
       ENDIF
#ifdef NONLIN_FRSURF
       IF ( select_rStar.GE.1 ) THEN
          t3d(:,:,k) = t3d(:,:,k)*pStarFacK(1:sNx,1:sNy,bi,bj)
       ENDIF
#endif /* NONLIN_FRSURF */
      ENDDO
c       ioUnit = 0
c       WRITE(namFile,'(A,I10.10)') 'z1_Atm.', myIter
c       CALL MDS_WRITEVEC_LOC(
c    I                       namFile, writeBinaryPrec, ioUnit,
c    I                       'RL', sNx*sNy, zFull3d(1,1,Nr), dummyRS,
c    I                       bi, bj, 1, myIter, myThid )
      DO k=1,Nr+1
        ki = Nr-k+2
        zHalf3d(:,:,k) = phiRef(2*ki-1)*recip_gravity
      ENDDO
      DO k=1,Nr
        kc = Nr-k+1
        kp = MIN(kc+1,Nr)
        zHalf3d(:,:,k) = zHalf3d(:,:,k)
     &                 + ( totPhiHyd(1:sNx,1:sNy,kp,bi,bj)
     &                    +totPhiHyd(1:sNx,1:sNy,kc,bi,bj) )*0.5
     &                  *recip_gravity
       IF ( nonlinFreeSurf.LE.0 ) THEN
        zHalf3d(:,:,k) = zHalf3d(:,:,k)
     &                 - Bo_surf(1:sNx,1:sNy,bi,bj)
     &                     *etaN(1:sNx,1:sNy,bi,bj)
     &                     *recip_gravity
       ENDIF
      ENDDO

      RETURN
      END

#include "OCN_CPL_OPTIONS.h"

CBOP 0
C !ROUTINE: OCN_IMPORT_ATMCONFIG

C !INTERFACE:
      SUBROUTINE OCN_IMPORT_ATMCONFIG( myThid )

C !DESCRIPTION:
C     *==========================================================*
C     | SUBROUTINE OCN_IMPORT_ATMCONFIG
C     | o Routine for importing atmos. config
C     |   into ocean component.
C     *==========================================================*
C     | This version talks to the MIT Coupler. It uses the
C     | MIT Coupler "checkpoint 1" library calls.
C     *==========================================================*

C !USES:
      IMPLICIT NONE
C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "ATMIDS.h"
#include "OCNCPL.h"

C !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     myThid :: Thread number for this instance of the routine
      INTEGER myThid
CEOP

C !LOCAL VARIABLES:
C     == Local variables ==
C     i,j,bi,bj :: Loop counters
      INTEGER i,j,bi,bj

C-    Initialise land-mask
      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          landMask(i,j,bi,bj) = 0.
         ENDDO
        ENDDO
       ENDDO
      ENDDO

C-    Receive atmos. model configuration info.
      _BARRIER
      _BEGIN_MASTER( myThid )

C     o Import atmosphere model land-mask
      CALL COMPRECV_R8TILES(
     I              atmLandName, sNx, OLx, sNy, OLy, 1, nSx, nSy,
     O              landMask )

      _END_MASTER( myThid )
      _BARRIER

      RETURN
      END

#include "ctrparam.h"
C
      SUBROUTINE ATM2D_INIT_VARS(myThid)
C     |==========================================================|
C     | Initialization steps which depend on pickups loading.    |
C     \==========================================================/
      IMPLICIT NONE

#include "ATMSIZE.h"
#include "DRIVER.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     myThid - thread number for this instance of the routine.
      INTEGER myThid

C     === Local variables ===

#ifdef PREDICTED_AEROSOL
      PRINT *,' Before eppaemission'
      CALL eppaemission (0)
#endif

#ifdef CLM
#  ifndef CLM35 
      CALL atmosphere(0,0)     ! initialize the atmospheric model
#  endif
      CALL clm4mit2d           ! initialize CLM
#  ifdef CLM35 
      PRINT *,'After clm4mit2d  initialization'
      PRINT *,'orbfix=',orbfix,' dyn_pft=',dyn_pft
      PRINT *,'orbyr=',orbyr,' rampyr_dynpft=',rampyr_dynpft
#    ifndef ORBITAL_FOR 
      IF (orbyr.ne.2000) THEN
         PRINT *,'Wrong orbyr for CLM3.5'
         STOP
      ENDIF
#    endif
      CALL atmosphere(0,0)
#  endif
#else
      CALL atmosphere(0,0)
#endif

#ifdef ML_2D
C    2D mixed layer model  initialization
      CALL ocean_ml(dtocn*3600.,dtatm*3600.)
#  ifdef CPL_OCEANCO2
      CALL zerogary
#  endif
#endif

#ifdef CPL_TEM
      PRINT *,' Start of tem_init'
      aocuav=0.0
      nepav=0.0
#  ifdef DATA4TEM
      nfile=1
#  endif
c      call tem_init(inyear,lyear)
      CALL climate2tem(0,0)
      CALL temclm_init
      CALL lcluc_init
      CALL updatelcluc(0)
      CALL tem_init
      adupt=0.0
      PRINT *,' TEM initialization finished'
#endif

#ifdef OCEAN_3D
      CALL ATM2D_READ_PICKUP(myThid)
#endif

      RETURN
      END

#include "GAD_OPTIONS.h"

CBOP
C !ROUTINE: GAD_C2_ADV_R

C !INTERFACE: ==========================================================
      SUBROUTINE GAD_C2_ADV_R(
     I           bi, bj, k,
     I           rTrans,
     I           tracer,
     O           wT,
     I           myThid )

C !DESCRIPTION:
C Calculates the area integrated vertical flux due to advection of a tracer
C using centered second-order interpolation:
C \begin{equation*}
C F^r_{adv} = W \overline{\theta}^k
C \end{equation*}

C !USES: ===============================================================
      IMPLICIT NONE
#include "SIZE.h"
#include "GRID.h"
#include "EEPARAMS.h"
#include "PARAMS.h"

C !INPUT PARAMETERS: ===================================================
C  bi,bj                :: tile indices
C  k                    :: vertical level
C  rTrans               :: vertical volume transport
C  tracer               :: tracer field
C  myThid               :: thread number
      INTEGER bi,bj,k
      _RL rTrans(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL tracer(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      INTEGER myThid

C !OUTPUT PARAMETERS: ==================================================
C  wT                   :: vertical advective flux
      _RL wT    (1-OLx:sNx+OLx,1-OLy:sNy+OLy)

C !LOCAL VARIABLES: ====================================================
C  i,j                  :: loop indices
C  km1                  :: =k+1 for k<Nr, =Nr for k>=Nr
      INTEGER i,j,km1
CEOP

      km1=max(1,k-1)

      IF ( k.EQ.1 .OR. k.GT.Nr) THEN
       DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
         wT(i,j) = 0.
        ENDDO
       ENDDO
      ELSE
       DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
         wT(i,j) = maskC(i,j,km1,bi,bj)*
     &     rTrans(i,j)*
     &        (tracer(i,j,k)+tracer(i,j,km1))*0.5 _d 0
        ENDDO
       ENDDO
      ENDIF

      RETURN
      END

#include "GMREDI_OPTIONS.h"

CBOP
C     !ROUTINE: GMREDI_DIAGNOSTICS_IMPL
C     !INTERFACE:
      SUBROUTINE GMREDI_DIAGNOSTICS_IMPL(
     I                  myTime, myIter, myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE GMREDI_DIAGNOSTICS_IMPL
C     | o fill GM-Redi diagnostics for backward (implicit) terms
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     === Global data ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "DYNVARS.h"
#include "GMREDI.h"

C     !INPUT/OUTPUT PARAMETERS:
      _RL     myTime
      INTEGER myIter
      INTEGER myThid

#ifdef ALLOW_DIAGNOSTICS
C     !FUNCTIONS:
      LOGICAL     DIAGNOSTICS_IS_ON
      EXTERNAL    DIAGNOSTICS_IS_ON
#endif /* ALLOW_DIAGNOSTICS */
CEOP

#ifdef ALLOW_GMREDI
#ifdef ALLOW_DIAGNOSTICS

C     !LOCAL VARIABLES:
      INTEGER bi,bj
      INTEGER i,j,k
      _RL tmpVar(1-OLx:sNx+OLx,1-OLy:sNy+OLy)

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      IF ( useDiagnostics .AND. implicitDiffusion .AND.
     &     Nr.GE.2 .AND. tempStepping ) THEN

       IF ( DIAGNOSTICS_IS_ON('GM_KwzTz', myThid ) ) THEN
         DO bj=myByLo(myThid),myByHi(myThid)
          DO bi=myBxLo(myThid),myBxHi(myThid)
           CALL DIAGNOSTICS_COUNT( 'GM_KwzTz', bi, bj, myThid )
           DO k=2,Nr
             DO j = 1, sNy
              DO i = 1, sNx
                tmpVar(i,j) = -recip_drC(k)*rkSign
     &            *(theta(i,j,k,bi,bj)-theta(i,j,k-1,bi,bj))
     &            * maskC(i,j,k,bi,bj)*maskC(i,j,k-1,bi,bj)
                tmpVar(i,j) = tmpVar(i,j)*Kwz(i,j,k,bi,bj)
     &                                   *rA(i,j,bi,bj)*deepFac2F(k)
              ENDDO
             ENDDO
             CALL DIAGNOSTICS_FILL( tmpVar, 'GM_KwzTz',
     &                              k, 1, 2, bi, bj, myThid )
           ENDDO
          ENDDO
         ENDDO
       ENDIF

      ENDIF

#endif /* ALLOW_DIAGNOSTICS */
#endif /* ALLOW_GMREDI */

      RETURN
      END

#include "DIAG_OPTIONS.h"

C--  File diagstats_others_calc.F: Routines to calculate regional statistics
C                                  and dealing with special type of fields
C--   o DIAGSTATS_LM_CALC :: for fields on FIZHI-grid (parse(10)='L' or 'M')
C--   o DIAGSTATS_G_CALC  :: for land-type fields     (parse(10)='G')

CBOP
C     !ROUTINE: DIAGSTATS_LM_CALC
C     !INTERFACE:
      SUBROUTINE DIAGSTATS_LM_CALC(
     O                  statArr,
     I                  inpArr, frcArr, scaleFact, power, useFract,
     I                  useReg, regMskVal,
     I                  nStats,sizI1,sizI2,sizJ1,sizJ2, iRun,jRun,
     I                  regMask, arrMask, arrArea,
     I                  specialVal, exclSpVal,
     I                  k,bi,bj, parsFld, myThid )

C     !DESCRIPTION:
C     Compute statistics for this tile, level, region
C     using FIZHI level thickness

C     !USES:
      IMPLICIT NONE

#include "EEPARAMS.h"
#include "SIZE.h"
#ifdef ALLOW_FIZHI
#include "fizhi_SIZE.h"
#include "gridalt_mapping.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine Arguments ==
C     statArr     :: output statistics array
C     inpArr      :: input field array to process (compute stats & add to statFld)
C     frcArr      :: fraction used for weighted-average diagnostics
C     scaleFact   :: scaling factor
C     power       :: option to fill-in with the field square (power=2)
C     useFract    :: if True, use fraction-weight
C     useReg      :: how to use region-mask: =0 : not used ;
C                    =1 : grid-center location ; =2 : U location ; =3 : V location
C     regMskVal   :: region-mask identificator value
C     nStats      :: size of output statArr
C     sizI1,sizI2 :: size of inpArr array: 1rst index range (min,max)
C     sizJ1,sizJ2 :: size of inpArr array: 2nd  index range (min,max)
C     iRun,jRun   :: range of 1rst & 2nd index to process
C     regMask     :: regional mask
C     arrMask     :: mask for this input array
C     arrArea     :: Area weighting factor
C     specialVal  :: special value in input array (to exclude if exclSpVal=T)
C     exclSpVal   :: if T, exclude "specialVal" in input array
C     k,bi,bj     :: level and tile indices used for weighting (mask,area ...)
C     parsFld     :: parser field with characteristics of the diagnostics
C     myThid      :: my Thread Id number
      INTEGER nStats,sizI1,sizI2,sizJ1,sizJ2
      INTEGER iRun, jRun
      _RL statArr(0:nStats)
      _RL inpArr (sizI1:sizI2,sizJ1:sizJ2)
      _RL frcArr (sizI1:sizI2,sizJ1:sizJ2)
      _RL scaleFact
      INTEGER power
      LOGICAL useFract
      INTEGER useReg
      _RS regMskVal
      _RS regMask(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RS arrMask(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RS arrArea(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL specialVal
      LOGICAL exclSpVal
      INTEGER k, bi, bj
      CHARACTER*16 parsFld
      INTEGER myThid
CEOP

#ifdef ALLOW_FIZHI
C     !LOCAL VARIABLES:
      LOGICAL useWeight
      INTEGER kl
      _RL drLoc
#ifndef REAL4_IS_SLOW
      INTEGER i,j
      _RS tmp_hFac(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
#endif

c     IF ( useFIZHI ) THEN

        IF ( parsFld(10:10).EQ.'L' ) THEN
          kl = 1 + Nrphys - k
          useWeight = .TRUE.
        ELSE
          kl = 1
          useWeight = .FALSE.
        ENDIF
        drLoc = 1. _d 0

#ifdef REAL4_IS_SLOW
        CALL DIAGSTATS_CALC(
     O            statArr,
     I            inpArr, frcArr, scaleFact, power, useFract,
     I            useReg, regMskVal,
     I            nStats,sizI1,sizI2,sizJ1,sizJ2,iRun,jRun,
     I            regMask, arrMask,
     I            dpphys(1-OLx,1-OLy,kl,bi,bj), arrArea,
     I            drLoc, specialVal, exclSpVal, useWeight, myThid )
#else /* REAL4_IS_SLOW */
C    make local copy of dpphys (RL type) into RS array tmp_hFac
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          tmp_hFac(i,j) = dpphys(i,j,kl,bi,bj)
         ENDDO
        ENDDO
        CALL DIAGSTATS_CALC(
     O            statArr,
     I            inpArr, frcArr, scaleFact, power, useFract,
     I            useReg, regMskVal,
     I            nStats,sizI1,sizI2,sizJ1,sizJ2,iRun,jRun,
     I            regMask, arrMask, tmp_hFac, arrArea,
     I            drLoc, specialVal, exclSpVal, useWeight, myThid )
#endif /* REAL4_IS_SLOW */

c     ENDIF
#endif /* ALLOW_FIZHI */

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

CBOP
C     !ROUTINE: DIAGSTATS_G_CALC
C     !INTERFACE:
      SUBROUTINE DIAGSTATS_G_CALC(
     O                  statArr,
     I                  inpArr, frcArr, scaleFact, power, useFract,
     I                  useReg, regMskVal,
     I                  nStats,sizI1,sizI2,sizJ1,sizJ2, iRun,jRun,
     I                  regMask, arrArea,
     I                  specialVal, exclSpVal,
     I                  k,bi,bj, parsFld, myThid )

C     !DESCRIPTION:
C     Compute statistics for this tile, level, region
C     using "ground" (land) type fraction

C     !USES:
      IMPLICIT NONE

#include "EEPARAMS.h"
#ifdef ALLOW_LAND
# include "LAND_SIZE.h"
# include "LAND_PARAMS.h"
# ifdef ALLOW_AIM
#  include "AIM_FFIELDS.h"
# endif
#else
# include "SIZE.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine Arguments ==
C     statArr     :: output statistics array
C     inpArr      :: input field array to process (compute stats & add to statFld)
C     frcArr      :: fraction used for weighted-average diagnostics
C     scaleFact   :: scaling factor
C     power       :: option to fill-in with the field square (power=2)
C     useFract    :: if True, use fraction-weight
C     useReg      :: how to use region-mask: =0 : not used ;
C                    =1 : grid-center location ; =2 : U location ; =3 : V location
C     regMskVal   :: region-mask identificator value
C     nStats      :: size of output statArr
C     sizI1,sizI2 :: size of inpArr array: 1rst index range (min,max)
C     sizJ1,sizJ2 :: size of inpArr array: 2nd  index range (min,max)
C     iRun,jRun   :: range of 1rst & 2nd index to process
C     regMask     :: regional mask
C     arrArea     :: Area weighting factor
C     specialVal  :: special value in input array (to exclude if exclSpVal=T)
C     exclSpVal   :: if T, exclude "specialVal" in input array
C     k,bi,bj     :: level and tile indices used for weighting (mask,area ...)
C     parsFld     :: parser field with characteristics of the diagnostics
C     myThid      :: my Thread Id number
      INTEGER nStats,sizI1,sizI2,sizJ1,sizJ2
      INTEGER iRun, jRun
      _RL statArr(0:nStats)
      _RL inpArr (sizI1:sizI2,sizJ1:sizJ2)
      _RL frcArr (sizI1:sizI2,sizJ1:sizJ2)
      _RL scaleFact
      INTEGER power
      LOGICAL useFract
      INTEGER useReg
      _RS regMskVal
      _RS regMask(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RS arrArea(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL specialVal
      LOGICAL exclSpVal
      INTEGER k, bi, bj
      CHARACTER*16 parsFld
      INTEGER myThid
CEOP

#ifdef ALLOW_LAND
C     !LOCAL VARIABLES:
      LOGICAL useWeight
      INTEGER kl
      _RL drLoc

c     IF ( useLand ) THEN

        IF ( parsFld(10:10).EQ.'G' ) THEN
          kl = MIN(k,land_nLev)
          drLoc = land_dzF(kl)
        ELSE
          drLoc = 1. _d 0
        ENDIF
        useWeight = .TRUE.

        CALL DIAGSTATS_CALC(
     O            statArr,
     I            inpArr, frcArr, scaleFact, power, useFract,
     I            useReg, regMskVal,
     I            nStats,sizI1,sizI2,sizJ1,sizJ2,iRun,jRun,
     I            regMask, aim_landFr(1-OLx,1-OLy,bi,bj),
     I            aim_landFr(1-OLx,1-OLy,bi,bj), arrArea,
     I            drLoc, specialVal, exclSpVal, useWeight, myThid )

c     ENDIF
#endif /* ALLOW_LAND */

      RETURN
      END

#include "SEAICE_OPTIONS.h"
#ifdef ALLOW_OBCS
# include "OBCS_OPTIONS.h"
#else
# define OBCS_UVICE_OLD
#endif
#ifdef ALLOW_AUTODIFF
# include "AUTODIFF_OPTIONS.h"
#endif

C--  File seaice_lsr.F: seaice LSR dynamical solver S/R:
C--   Contents
C--   o SEAICE_LSR
C--   o SEAICE_RESIDUAL
C--   o SEAICE_LSR_CALC_COEFFS
C--   o SEAICE_LSR_RHSU
C--   o SEAICE_LSR_RHSV
C--   o SEAICE_LSR_TRIDIAGU
C--   o SEAICE_LSR_TRIDIAGV

CBOP
C     !ROUTINE: SEAICE_LSR
C     !INTERFACE:
      SUBROUTINE SEAICE_LSR( myTime, myIter, myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R SEAICE_LSR
C     | o Solve ice momentum equation with an LSR dynamics solver
C     |   (see Zhang and Hibler,   JGR, 102, 8691-8702, 1997
C     |    and Zhang and Rothrock, MWR, 131,  845- 861, 2003)
C     |   Written by Jinlun Zhang, PSC/UW, Feb-2001
C     |                     zhang@apl.washington.edu
C     *==========================================================*
C     | C-grid version by Martin Losch
C     |   Since 2009/03/18: finite-Volume discretization of
C     |   stress divergence that includes all metric terms
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "DYNVARS.h"
#include "GRID.h"
#include "SEAICE_SIZE.h"
#include "SEAICE_PARAMS.h"
#include "SEAICE_GRID.h"
#include "SEAICE.h"

#ifdef ALLOW_AUTODIFF_TAMC
# include "tamc.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
C     myTime     :: Simulation time
C     myIter     :: Simulation timestep number
C     myThid     :: my Thread Id. number
      _RL     myTime
      INTEGER myIter
      INTEGER myThid
CEOP

#ifdef SEAICE_CGRID
C     !FUNCTIONS:
      LOGICAL  DIFFERENT_MULTIPLE
      EXTERNAL DIFFERENT_MULTIPLE

C     !LOCAL VARIABLES:
C     === Local variables ===
C     i,j,bi,bj  :: Loop counters

      INTEGER ipass
      INTEGER i, j, m, bi, bj
      INTEGER iMin, iMax, jMin, jMax
      INTEGER ICOUNT1, ICOUNT2, linearIterLoc, nonLinIterLoc
      INTEGER kSrf
      LOGICAL doIterate4u, doIterate4v
      LOGICAL doNonLinLoop
      CHARACTER*(MAX_LEN_MBUF) msgBuf

#ifdef ALLOW_DIAGNOSTICS
      LOGICAL  DIAGNOSTICS_IS_ON
      EXTERNAL DIAGNOSTICS_IS_ON
      _RL RTmp (1:sNx,1:sNy)
#endif /* ALLOW_DIAGNOSTICS */

      _RL WFAU, WFAV, WFAU2, WFAV2
      _RL S1, S2, S1A, S2A
      _RL recip_deltaT

#ifdef SEAICE_ALLOW_LSR_FLEX
      _RL residIni, residIniNonLin
      _RL LSRflexFac, LSR_ERRORfu, LSR_ERRORfv
      _RL residkm1, residkm2
#endif /* SEAICE_ALLOW_LSR_FLEX */

C     diagonals of coefficient matrices
      _RL AU   (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL BU   (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL CU   (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL AV   (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL BV   (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL CV   (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
C     RHS of TriDiag Linear system (both directions => 5 coef A,B,C & Rt1,2)
      _RL rhsU (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL rhsV (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
#ifdef SEAICE_GLOBAL_3DIAG_SOLVER
C     RHS of TriDiag Linear system (1 direction only => 3 coef A,B,C)
      _RL rhsUx(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL rhsVy(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      INTEGER iSubIter
      INTEGER errCode
#endif
C     coefficients for lateral points, u(j+/-1)
      _RL uRt1(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL uRt2(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
C     coefficients for lateral points, v(i+/-1)
      _RL vRt1(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL vRt2(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
C     abbreviations
      _RL etaPlusZeta (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL zetaMinusEta(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
C     symmetric drag coefficient
      _RL dragSym     (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
C     intermediate time level centered (C) between n and n-1
      _RL uIceC(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL vIceC(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
C     auxillary fields
      _RL uTmp (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL vTmp (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
C     auxillary fields to store intermediate FORCEX/Y0
      _RL fxTmp(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL fyTmp(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
C     fractional area at velocity points
      _RL areaW(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL areaS(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
#ifdef SEAICE_ALLOW_MOM_ADVECTION
C     tendency due to advection of momentum
      _RL gUmom(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL gVmom(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
#endif /*  SEAICE_ALLOW_MOM_ADVECTION */
#ifdef ALLOW_AUTODIFF_TAMC
C     nlkey :: tape key (depends on nonlinear iteration)
C     lnkey :: tape key (depends on linear and nonlinear iteration)
C     tkey  :: tape key (depends on tile indices and lnkey)
      INTEGER nlkey, lnkey, tkey
#endif
      _RL COSWAT
      _RS SINWAT
      _RL UERR
#ifdef SEAICE_ALLOW_CHECK_LSR_CONVERGENCE
      _RL resnorm, EKnorm, counter
#endif /* SEAICE_ALLOW_CHECK_LSR_CONVERGENCE */
      LOGICAL printResidual
      _RL residUini, residVini, residUend, residVend
#ifdef SEAICE_ALLOW_FREEDRIFT
      _RL uRes (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL vRes (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL errIni, errFD, errSum
      _RL residU_fd, residV_fd
      _RL residUmix, residVmix
#endif /* SEAICE_ALLOW_FREEDRIFT */
      _RL areaMinLoc

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      printResidual = debugLevel.GE.debLevA
     &  .AND. DIFFERENT_MULTIPLE( SEAICE_monFreq, myTime, deltaTClock )

C     extra overlap for (restricted) additive Schwarz method
      jMin = 1   - SEAICE_OLy
      jMax = sNy + SEAICE_OLy
      iMin = 1   - SEAICE_OLx
      iMax = sNx + SEAICE_OLx
C
      linearIterLoc = SEAICElinearIterMax
      nonLinIterLoc = SEAICEnonLinIterMax
      IF ( SEAICEusePicardAsPrecon ) THEN
       linearIterLoc = SEAICEpreconlinIter
       nonLinIterLoc = SEAICEpreconNL_Iter
      ENDIF

      recip_deltaT = 1. _d 0 / SEAICE_deltaTdyn

C     surface level
      IF ( usingPCoords ) THEN
       kSrf = Nr
      ELSE
       kSrf = 1
      ENDIF
C--   introduce turning angles
      SINWAT=SIN(SEAICE_waterTurnAngle*deg2rad)
      COSWAT=COS(SEAICE_waterTurnAngle*deg2rad)

#ifdef ALLOW_AUTODIFF
cph break artificial dependencies
      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          deltaC (i,j,bi,bj) = 0. _d 0
          press  (i,j,bi,bj) = 0. _d 0
          zeta   (i,j,bi,bj) = 0. _d 0
          zetaZ  (i,j,bi,bj) = 0. _d 0
          eta    (i,j,bi,bj) = 0. _d 0
          etaZ   (i,j,bi,bj) = 0. _d 0
          uIceC  (i,j,bi,bj) = 0. _d 0
          vIceC  (i,j,bi,bj) = 0. _d 0
          uIceNm1(i,j,bi,bj) = 0. _d 0
          vIceNm1(i,j,bi,bj) = 0. _d 0
         ENDDO
        ENDDO
       ENDDO
      ENDDO
#endif

C     initialise fractional areas at velocity points
      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          areaW(i,j,bi,bj) = 1. _d 0
          areaS(i,j,bi,bj) = 1. _d 0
          ENDDO
         ENDDO
        areaMinLoc = 0. _d 0
        IF ( SEAICEscaleSurfStress ) THEN
         areaMinLoc = 1. _d -10
CML         areaMinLoc = SEAICE_EPS
         DO j=jMin,jMax
          DO i=iMin,iMax
           areaW(i,j,bi,bj) =
     &          0.5 _d 0*(AREA(i,j,bi,bj)+AREA(i-1,j,bi,bj))
           areaS(i,j,bi,bj) =
     &          0.5 _d 0*(AREA(i,j,bi,bj)+AREA(i,j-1,bi,bj))
          ENDDO
         ENDDO
        ENDIF
       ENDDO
      ENDDO

#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE uice    = comlev1, key=ikey_dynamics, kind=isbyte
CADJ STORE vice    = comlev1, key=ikey_dynamics, kind=isbyte
#endif /*  ALLOW_AUTODIFF_TAMC */
C     This is the rhs contribution of the time derivative.
C     We add it here, because it does not change in the iteration.
C     We store this update on a local field to avoid touching FORCEX/Y0.
C     As a side effect, this avoids TAF recomputation warnings.
      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          uIceNm1(i,j,bi,bj) = uIce(i,j,bi,bj)
          vIceNm1(i,j,bi,bj) = vIce(i,j,bi,bj)
          fxTmp  (i,j,bi,bj) = FORCEX0(i,j,bi,bj)
     &         +seaiceMassU(i,j,bi,bj)*recip_deltaT
     &         *uIceNm1(i,j,bi,bj)
          fyTmp  (i,j,bi,bj) = FORCEY0(i,j,bi,bj)
     &         +seaiceMassV(i,j,bi,bj)*recip_deltaT
     &         *vIceNm1(i,j,bi,bj)
         ENDDO
        ENDDO
       ENDDO
      ENDDO

#ifdef SEAICE_ALLOW_LSR_FLEX
      IF ( SEAICEuseLSRflex ) THEN
       residkm1       = 1. _d 0
       residkm2       = 1. _d 0
       residIniNonLin = 1. _d 0
      ENDIF
#endif /* SEAICE_ALLOW_LSR_FLEX */

      doNonLinLoop = .TRUE.

C     Start of non-linear iteration ====================================

C     Note: in S/R SEAICE_CHECK, we make sure that nonLinIterLoc
C     (=SEAICEnonLinIterMax) is not larger than MPSEUDOTIMESTEPS (which
C     defines the length of the TAF tape, so it is safe to use the
C     runtime parameter value here.
      DO ipass=1,nonLinIterLoc

#ifdef ALLOW_AUTODIFF_TAMC
       nlkey = (ikey_dynamics-1)*MPSEUDOTIMESTEPS + ipass
# ifdef SEAICE_ALLOW_FREEDRIFT
CADJ STORE uice_fd, vice_fd = comlev1_dynsol, key = nlkey, kind=isbyte
CADJ STORE ures,vres        = comlev1_dynsol, key = nlkey, kind=isbyte
# endif
CADJ STORE utmp,vtmp        = comlev1_dynsol, key = nlkey, kind=isbyte
#endif /* ALLOW_AUTODIFF_TAMC */

      IF ( doNonLinLoop ) THEN
#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE uice    = comlev1_dynsol, key = nlkey, kind=isbyte
CADJ STORE vice    = comlev1_dynsol, key = nlkey, kind=isbyte
CADJ STORE uicenm1 = comlev1_dynsol, key = nlkey, kind=isbyte
CADJ STORE vicenm1 = comlev1_dynsol, key = nlkey, kind=isbyte
#endif /* ALLOW_AUTODIFF_TAMC */

C SET SOME VALUES
      WFAU=SEAICE_LSRrelaxU
      WFAV=SEAICE_LSRrelaxV
      WFAU2=ZERO
      WFAV2=ZERO
      S1 = 0.
      S2 = 0.
      S1A=0.80 _d 0
      S2A=0.80 _d 0

      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        IF ( ipass .EQ. 1 ) THEN
C     This is the predictor time step
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           uIceC(i,j,bi,bj) = uIce(i,j,bi,bj)
           vIceC(i,j,bi,bj) = vIce(i,j,bi,bj)
          ENDDO
         ENDDO
        ELSEIF ( ipass .EQ. 2 .AND. SEAICEnonLinIterMax .LE. 2 ) THEN
C     This is the modified Euler step
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           uIce (i,j,bi,bj)=HALF*( uIce(i,j,bi,bj)+uIceNm1(i,j,bi,bj) )
           vIce (i,j,bi,bj)=HALF*( vIce(i,j,bi,bj)+vIceNm1(i,j,bi,bj) )
           uIceC(i,j,bi,bj)=uIce(i,j,bi,bj)
           vIceC(i,j,bi,bj)=vIce(i,j,bi,bj)
          ENDDO
         ENDDO
        ELSE
C     This is the case for SEAICEnonLinIterMax > 2, and here we use
C     a different iterative scheme. u/vIceC = u/vIce is unstable, and
C     different stabilisation methods are possible.
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
C     This is stable but slow to converge.
C          uIceC(i,j,bi,bj) = HALF*(uIce(i,j,bi,bj)+uIceNm1(i,j,bi,bj))
C          vIceC(i,j,bi,bj) = HALF*(vIce(i,j,bi,bj)+vIceNm1(i,j,bi,bj))
C     This converges slightly faster than the previous lines.
           uIceC(i,j,bi,bj) = HALF*( uIce(i,j,bi,bj)+uIceC(i,j,bi,bj) )
           vIceC(i,j,bi,bj) = HALF*( vIce(i,j,bi,bj)+vIceC(i,j,bi,bj) )
          ENDDO
         ENDDO
        ENDIF
C     bi/bj-loops
       ENDDO
      ENDDO

#ifdef ALLOW_AUTODIFF_TAMC
C     That is an important one! Note, that
C     * ipass index is part of nlkey because we are inside
C       the nonlinear iteration
C     * this storing is still outside the lsr iteration loop
CADJ STORE uice  = comlev1_dynsol, kind=isbyte, key = nlkey
CADJ STORE vice  = comlev1_dynsol, kind=isbyte, key = nlkey
CADJ STORE uicec = comlev1_dynsol, kind=isbyte, key = nlkey
CADJ STORE vicec = comlev1_dynsol, kind=isbyte, key = nlkey
#endif /* ALLOW_AUTODIFF_TAMC */

      CALL SEAICE_CALC_STRAINRATES(
     I     uIceC, vIceC,
     O     e11, e22, e12,
     I     ipass, myTime, myIter, myThid )

      CALL SEAICE_CALC_VISCOSITIES(
     I     e11, e22, e12, SEAICE_zMin, SEAICE_zMax, HEFFM, press0,
     I     tensileStrFac,
     O     eta, etaZ, zeta, zetaZ, press, deltaC,
     I     ipass, myTime, myIter, myThid )

      CALL SEAICE_OCEANDRAG_COEFFS(
     I     uIceC, vIceC, HEFFM,
     O     DWATN,
     I     ipass, myTime, myIter, myThid )

#ifdef SEAICE_ALLOW_BOTTOMDRAG
      CALL SEAICE_BOTTOMDRAG_COEFFS(
     I     uIceC, vIceC, HEFFM,
#ifdef SEAICE_ITD
     I     HEFFITD, AREAITD, AREA,
#else
     I     HEFF, AREA,
#endif
     O     CbotC,
     I     ipass, myTime, myIter, myThid )
#endif /* SEAICE_ALLOW_BOTTOMDRAG */

#ifdef SEAICE_ALLOW_SIDEDRAG
      IF ( SEAICEsideDrag .NE. 0. _d 0 ) CALL SEAICE_SIDEDRAG_STRESS(
     I     uIceC, vIceC, coastRoughU, coastRoughV, AREA,
     O     sideDragU, sideDragV,
     I     ipass, myTime, myIter, myThid )
#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE sideDragU = comlev1_dynsol, kind=isbyte, key = nlkey
CADJ STORE sideDragV = comlev1_dynsol, kind=isbyte, key = nlkey
#endif /* ALLOW_AUTODIFF_TAMC */
#endif /* SEAICE_ALLOW_SIDEDRAG */
C
C     some abbreviations
C
      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        DO j=jMin-1,jMax
         DO i=iMin-1,iMax
          etaPlusZeta (i,j,bi,bj) = ETA (i,j,bi,bj)+ZETA(i,j,bi,bj)
          zetaMinusEta(i,j,bi,bj) = ZETA(i,j,bi,bj)-ETA (i,j,bi,bj)
         ENDDO
        ENDDO
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          dragSym(i,j,bi,bj) = DWATN(i,j,bi,bj)*COSWAT
#ifdef SEAICE_ALLOW_BOTTOMDRAG
     &         +CbotC(i,j,bi,bj)
#endif /* SEAICE_ALLOW_BOTTOMDRAG */
         ENDDO
        ENDDO
       ENDDO
      ENDDO
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C
C     Set up of right hand sides of momentum equations starts here
C
      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        DO j=jMin,jMax
         DO i=iMin,iMax
C     set up anti symmetric drag force and add in current force
C     ( remember to average to correct velocity points )
          FORCEX(i,j,bi,bj) = fxTmp(i,j,bi,bj)+
     &         ( 0.5 _d 0 * ( DWATN(i,j,bi,bj)+DWATN(i-1,j,bi,bj) ) *
     &         COSWAT * uVel(i,j,kSrf,bi,bj)
     &         - SIGN(SINWAT, _fCori(i,j,bi,bj))* 0.5 _d 0 *
     &         ( DWATN(i  ,j,bi,bj) * 0.5 _d 0 *
     &          (vVel(i  ,j  ,kSrf,bi,bj)-vIceC(i  ,j  ,bi,bj)
     &          +vVel(i  ,j+1,kSrf,bi,bj)-vIceC(i  ,j+1,bi,bj))
     &         + DWATN(i-1,j,bi,bj) * 0.5 _d 0 *
     &          (vVel(i-1,j  ,kSrf,bi,bj)-vIceC(i-1,j  ,bi,bj)
     &          +vVel(i-1,j+1,kSrf,bi,bj)-vIceC(i-1,j+1,bi,bj))
     &         ) ) * areaW(i,j,bi,bj)
          FORCEY(i,j,bi,bj) = fyTmp(i,j,bi,bj)+
     &         ( 0.5 _d 0 * ( DWATN(i,j,bi,bj)+DWATN(i,j-1,bi,bj) ) *
     &         COSWAT * vVel(i,j,kSrf,bi,bj)
     &         + SIGN(SINWAT, _fCori(i,j,bi,bj)) * 0.5 _d 0 *
     &         ( DWATN(i,j  ,bi,bj) * 0.5 _d 0 *
     &          (uVel(i  ,j  ,kSrf,bi,bj)-uIceC(i  ,j  ,bi,bj)
     &          +uVel(i+1,j  ,kSrf,bi,bj)-uIceC(i+1,j  ,bi,bj))
     &         + DWATN(i,j-1,bi,bj) * 0.5 _d 0 *
     &          (uVel(i  ,j-1,kSrf,bi,bj)-uIceC(i  ,j-1,bi,bj)
     &          +uVel(i+1,j-1,kSrf,bi,bj)-uIceC(i+1,j-1,bi,bj))
     &         ) ) * areaS(i,j,bi,bj)
         ENDDO
        ENDDO
        DO j=jMin,jMax
         DO i=iMin,iMax
C-    add Coriolis term
          FORCEX(i,j,bi,bj) = FORCEX(i,j,bi,bj) + HALF*
     &         ( seaiceMassC(i  ,j,bi,bj) * _fCori(i  ,j,bi,bj)
     &          *0.5 _d 0*( vIceC( i ,j,bi,bj)+vIceC( i ,j+1,bi,bj) )
     &         + seaiceMassC(i-1,j,bi,bj) * _fCori(i-1,j,bi,bj)
     &          *0.5 _d 0*( vIceC(i-1,j,bi,bj)+vIceC(i-1,j+1,bi,bj) ) )
          FORCEY(i,j,bi,bj) = FORCEY(i,j,bi,bj) - HALF*
     &         ( seaiceMassC(i,j  ,bi,bj) * _fCori(i,j  ,bi,bj)
     &         *0.5 _d 0*( uIceC(i  ,j  ,bi,bj)+uIceC(i+1,  j,bi,bj) )
     &         + seaiceMassC(i,j-1,bi,bj) * _fCori(i,j-1,bi,bj)
     &         *0.5 _d 0*( uIceC(i  ,j-1,bi,bj)+uIceC(i+1,j-1,bi,bj) ) )
         ENDDO
        ENDDO
C      mask the forcing so far
        DO j=jMin,jMax
         DO i=iMin,iMax
          FORCEX(i,j,bi,bj) = FORCEX(i,j,bi,bj)*seaiceMaskU(i,j,bi,bj)
          FORCEY(i,j,bi,bj) = FORCEY(i,j,bi,bj)*seaiceMaskV(i,j,bi,bj)
         ENDDO
        ENDDO
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C
C     u-equation
C
        DO j=jMin,jMax
         DO i=iMin,iMax
          rhsU(i,j,bi,bj) = FORCEX(i,j,bi,bj)
         ENDDO
        ENDDO
        CALL SEAICE_LSR_RHSU(
     I       zetaMinusEta, etaPlusZeta, etaZ, zetaZ, press,
     I       uIceC, vIceC,
     U       rhsU,
     I       iMin, iMax, jMin, jMax, bi, bj, myThid )
C
C     v-equation
C
        DO j=jMin,jMax
         DO i=iMin,iMax
          rhsV(i,j,bi,bj) = FORCEY(i,j,bi,bj)
         ENDDO
        ENDDO
        CALL SEAICE_LSR_RHSV(
     I       zetaMinusEta, etaPlusZeta, etaZ, zetaZ, press,
     I       uIceC, vIceC,
     U       rhsV,
     I       iMin, iMax, jMin, jMax, bi, bj, myThid )
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
#ifdef SEAICE_ALLOW_MOM_ADVECTION
        IF ( SEAICEmomAdvection ) THEN
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           gUmom(i,j) = 0. _d 0
           gVmom(i,j) = 0. _d 0
          ENDDO
         ENDDO
         CALL SEAICE_MOM_ADVECTION(
     I        bi,bj,iMin,iMax,jMin,jMax,
     I        uIceC, vIceC,
     O        gUmom, gVmom,
     I        myTime, myIter, myThid )
         DO j=jMin,jMax
          DO i=jMin,jMax
           rhsU(i,j,bi,bj) = rhsU(i,j,bi,bj) + gUmom(i,j)
           rhsV(i,j,bi,bj) = rhsV(i,j,bi,bj) + gVmom(i,j)
          ENDDO
         ENDDO
        ENDIF
#endif /* SEAICE_ALLOW_MOM_ADVECTION */
       ENDDO
      ENDDO
C
C     Set up of right hand sides of momentum equations ends here
C
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C
C     calculate coefficients of tridiagonal matrices for both u- and
C     v-equations
C
      CALL SEAICE_LSR_CALC_COEFFS(
     I     etaPlusZeta, zetaMinusEta, etaZ, zetaZ, dragSym,
     O     AU, BU, CU, AV, BV, CV, uRt1, uRt2, vRt1, vRt2,
     I     iMin, iMax, jMin, jMax, myTime, myIter, myThid )

#ifdef SEAICE_ALLOW_SIDEDRAG
      IF ( SEAICEsideDrag .NE. 0. _d 0 ) THEN
       DO bj=myByLo(myThid),myByHi(myThid)
        DO bi=myBxLo(myThid),myBxHi(myThid)
         DO j=jMin,jMax
          DO i=iMin,iMax
           BU(i,j,bi,bj) = BU(i,j,bi,bj)
     &          + seaiceMaskU(i,j,bi,bj) * sideDragU(i,j,bi,bj)
           BV(i,j,bi,bj) = BV(i,j,bi,bj)
     &          + seaiceMaskV(i,j,bi,bj) * sideDragV(i,j,bi,bj)
          ENDDO
         ENDDO
        ENDDO
       ENDDO
      ENDIF
#endif /* SEAICE_ALLOW_SIDEDRAG */

#ifndef OBCS_UVICE_OLD
C--     prevent tri-diagonal solver from modifying OB values:
      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        DO j=jMin,jMax
         DO i=iMin,iMax
          IF ( maskInC(i,j,bi,bj)*maskInC(i-1,j,bi,bj) .EQ. 0. ) THEN
           AU(i,j,bi,bj)   = ZERO
           BU(i,j,bi,bj)   = ONE
           CU(i,j,bi,bj)   = ZERO
           uRt1(i,j,bi,bj) = ZERO
           uRt2(i,j,bi,bj) = ZERO
           rhsU(i,j,bi,bj) = uIce(i,j,bi,bj)
          ENDIF
          IF ( maskInC(i,j,bi,bj)*maskInC(i,j-1,bi,bj) .EQ. 0. ) THEN
           AV(i,j,bi,bj)   = ZERO
           BV(i,j,bi,bj)   = ONE
           CV(i,j,bi,bj)   = ZERO
           vRt1(i,j,bi,bj) = ZERO
           vRt2(i,j,bi,bj) = ZERO
           rhsV(i,j,bi,bj) = vIce(i,j,bi,bj)
          ENDIF
         ENDDO
        ENDDO
       ENDDO
      ENDDO
#endif /* OBCS_UVICE_OLD */

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#ifdef ALLOW_DEBUG
      IF ( debugLevel .GE. debLevD ) THEN
        WRITE(msgBuf,'(A,I3,A)')
     &        'Uice pre  iter (SEAICE_LSR', MOD(ipass,1000), ')'
        CALL DEBUG_STATS_RL( 1, UICE, msgBuf, myThid )
        WRITE(msgBuf,'(A,I3,A)')
     &        'Vice pre  iter (SEAICE_LSR', MOD(ipass,1000), ')'
        CALL DEBUG_STATS_RL( 1, VICE, msgBuf, myThid )
      ENDIF
#endif /* ALLOW_DEBUG */

C--   Calculate initial residual of the linearised system
      IF ( printResidual .OR. LSR_mixIniGuess.GE.1
     &     .OR. SEAICEuseLSRflex )
     &    CALL SEAICE_RESIDUAL(
     I                  rhsU, rhsV, uRt1, uRt2, vRt1, vRt2,
     I                  AU, BU, CU, AV, BV, CV, uIce, vIce,
     O                  residUini, residVini, uTmp, vTmp,
     I                  printResidual, myIter, myThid )

#ifdef SEAICE_ALLOW_FREEDRIFT
      IF ( printResidual .OR. LSR_mixIniGuess.GE.1 ) THEN
       IF ( LSR_mixIniGuess.GE.1 ) THEN
        DO bj=myByLo(myThid),myByHi(myThid)
         DO bi=myBxLo(myThid),myBxHi(myThid)
          DO j=jMin,jMax
           DO i=iMin,iMax
            uIce_fd(i,j,bi,bj) = FORCEX(i,j,bi,bj)
     &         / ( 1. _d 0 - seaiceMaskU(i,j,bi,bj)
     &           + seaiceMassU(i,j,bi,bj)*recip_deltaT
     &           + HALF*( dragSym(i,j,bi,bj) + dragSym(i-1,j,bi,bj) )
     &                 * MAX(areaW(i,j,bi,bj),areaMinLoc)
     &           )
            vIce_fd(i,j,bi,bj) = FORCEY(i,j,bi,bj)
     &         / ( 1. _d 0 - seaiceMaskV(i,j,bi,bj)
     &           + seaiceMassV(i,j,bi,bj)*recip_deltaT
     &           + HALF*( dragSym(i,j,bi,bj) + dragSym(i,j-1,bi,bj) )
     &                 * MAX(areaS(i,j,bi,bj),areaMinLoc)
     &           )
           ENDDO
          ENDDO
         ENDDO
        ENDDO
        CALL EXCH_UV_XY_RL( uIce_fd, vIce_fd, .TRUE., myThid )
       ENDIF
       IF ( LSR_mixIniGuess.GE.0 )
     &  CALL SEAICE_RESIDUAL(
     I                  rhsU, rhsV, uRt1, uRt2, vRt1, vRt2,
     I                  AU, BU, CU, AV, BV, CV, uIce_fd, vIce_fd,
     O                  residU_fd, residV_fd, uRes, vRes,
     I                  printResidual, myIter, myThid )
      ENDIF
      IF ( LSR_mixIniGuess.GE.2 ) THEN
# ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE uice, vice = comlev1_dynsol, key = nlkey, kind=isbyte
CADJ STORE utmp, vtmp = comlev1_dynsol, key = nlkey, kind=isbyte
# endif /* ALLOW_AUTODIFF_TAMC */
       DO bj=myByLo(myThid),myByHi(myThid)
        DO bi=myBxLo(myThid),myBxHi(myThid)
         DO j=jMin,jMax
          DO i=iMin,iMax
           errIni = uTmp(i,j,bi,bj)*uTmp(i,j,bi,bj)
           errFD  = uRes(i,j,bi,bj)*uRes(i,j,bi,bj)
           IF ( LSR_mixIniGuess.GE.4 ) THEN
            errIni = errIni*errIni
            errFD  = errFD *errFD
           ENDIF
           errSum = ( errIni + errFD )
     &          *maskInC(i,j,bi,bj)*maskInC(i-1,j,bi,bj)
           IF ( errSum.GT.0. ) THEN
            uIce(i,j,bi,bj) = ( errFD *uIce(i,j,bi,bj)
     &                        + errIni*uIce_fd(i,j,bi,bj)
     &                        )/errSum
           ENDIF
           errIni = vTmp(i,j,bi,bj)*vTmp(i,j,bi,bj)
           errFD  = vRes(i,j,bi,bj)*vRes(i,j,bi,bj)
           IF ( LSR_mixIniGuess.GE.4 ) THEN
            errIni = errIni*errIni
            errFD  = errFD *errFD
           ENDIF
           errSum = ( errIni + errFD )
     &          *maskInC(i,j,bi,bj)*maskInC(i,j-1,bi,bj)
           IF ( errSum.GT.0. ) THEN
            vIce(i,j,bi,bj) = ( errFD *vIce(i,j,bi,bj)
     &                        + errIni*vIce_fd(i,j,bi,bj)
     &                        )/errSum
           ENDIF
          ENDDO
         ENDDO
        ENDDO
       ENDDO
       CALL EXCH_UV_XY_RL( uIce, vIce, .TRUE., myThid )
#ifndef ALLOW_AUTODIFF_TAMC
C     Here residU/Vmix and u/vTmp are computed but never used for anything
C     but reporting to STDOUT. Still TAF thinks this requires recomputations
C     so we hide this part of the code from TAF.
       IF ( printResidual ) THEN
        CALL SEAICE_RESIDUAL(
     I                  rhsU, rhsV, uRt1, uRt2, vRt1, vRt2,
     I                  AU, BU, CU, AV, BV, CV, uIce, vIce,
     O                  residUmix, residVmix, uTmp, vTmp,
     I                  printResidual, myIter, myThid )
       ENDIF
#endif /* ALLOW_AUTODIFF_TAMC */
      ENDIF
#endif /* SEAICE_ALLOW_FREEDRIFT */

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C NOW DO ITERATION

      doIterate4u = .TRUE.
      doIterate4v = .TRUE.

C ITERATION START -----------------------------------------------------
C     Ideally, we would like to use the loop-directive for this
C     iterative loop, but (unsurprisingly) it does not seem to work for
C     this convoluted case of mixed iterations, so it is commented out
CML#ifdef ALLOW_AUTODIFF_TAMC
CMLCADJ LOOP = iteration uice, vice = comlev1_lsr
CML#endif /* ALLOW_AUTODIFF_TAMC */

      ICOUNT1 = linearIterLoc
      ICOUNT2 = linearIterLoc

#ifdef SEAICE_ALLOW_LSR_FLEX
C     first IF doNonLinLoop
      ENDIF

      IF ( SEAICEuseLSRflex ) THEN
C     Do not do anything if the initial residuals are zero
       IF ( residUini .EQ. 0. _d 0) THEN
        doIterate4u = .FALSE.
        ICOUNT1 = 0
        S1      = residUini
       ENDIF
       IF ( residVini .EQ. 0. _d 0) THEN
        doIterate4v = .FALSE.
        ICOUNT2 = 0
        S2      = residVini
       ENDIF

       residIni = SQRT(residUini*residUini+residVini*residVini)

C     If you want to use SEAICEnonLinTol to be an absolute criterion,
C     comment out the following line.
       IF ( ipass .EQ. 1 ) residIniNonLin = residIni

C     Skip the the rest of the nonlinear loop if there is nothing to do.
       doNonLinLoop = doNonLinLoop .AND.( doIterate4u .OR. doIterate4v )
C     Check convergence of nonlinear loop, but do at least two passes
       doNonLinLoop = doNonLinLoop .AND. .NOT.
     &      ( ipass .GT. 2 .AND.
     &      ( residIni .LT. SEAICEnonLinTol*residIniNonlin ) )

C     Catch the case of zero residual
       IF  ( residIni .EQ. 0. _d 0 ) residIni = 1. _d -20
C     From Lemieux et al. 2010
C       LSRflexFac = MIN(LSRflexFac/residkm2*0.9,LSRflexFac)
C     Other possibilities
       LSRflexFac = 1. _d 0 / (1. _d 0 + ABS( LOG10(residIni) ) )
C       LSRflexFac = ABS(LOG10(residkm2))/ABS(LOG10(residkm1))
C       LSRflexFac = (residkm1/residkm2)/(1+ABS(LOG10(residIni)))
       LSRflexFac = MIN(LSRflexFac, 0.99 _d 0 )
C      LSRflexFac = MAX(LSRflexFac, 0.3 _d 0 )

C       IF ( ipass .LE. 3 ) THEN
C        LSRflexFac = 0.99 _d 0
C       ENDIF

       LSR_ERRORfu = residUini*LSRflexFac
       LSR_ERRORfv = residVini*LSRflexFac

       IF ( printResidual ) THEN
        _BEGIN_MASTER( myThid )
        WRITE(standardMessageUnit,'(A,1X,I5,1X,F10.6,3(1X,E12.6))')
     &       ' SEAICE_LSR: ipass, FLEX_FACTOR,'//
     &       ' LSR_ERRORfu, LSR_ERRORfv, residIni =',
     &       ipass, LSRflexFac, LSR_ERRORfu, LSR_ERRORfv, residIni
        _END_MASTER( myThid )
       ENDIF

      ENDIF

C     test doNonLinLoop a second time, as it may have changed
      IF ( doNonLinLoop ) THEN
#endif /* SEAICE_ALLOW_LSR_FLEX */

      DO m = 1, linearIterLoc

#ifdef ALLOW_AUTODIFF_TAMC
# ifdef SEAICE_LSR_ADJOINT_ITER
       lnkey = (nlkey-1)*SOLV_MAX_FIXED + MIN(m,SOLV_MAX_FIXED)
# else
       lnkey = nlkey
# endif /* SEAICE_LSR_ADJOINT_ITER */
C     Storing these scalars and logicals is necessary to do an exact
C     backward iteration
CADJ STORE wfau, wfav = comlev1_lsr,  kind=isbyte, key = lnkey
CADJ STORE doIterate4u, doIterate4v = comlev1_lsr, key = lnkey
#endif /* ALLOW_AUTODIFF_TAMC */

       IF ( doIterate4u .OR. doIterate4v ) THEN

        IF ( useCubedSphereExchange ) THEN
          doIterate4u = .TRUE.
          doIterate4v = .TRUE.
        ENDIF

# ifdef ALLOW_AUTODIFF_TAMC
C     Note that lnkey can get very large when SEAICE_LSR_ADJOINT_ITER
C     is defined for an accurate adjoint, otherwise it is the same for
C     each m, so that the tapes get overwritten for each iterate and
C     the adjoint is necessarily wrong.
CADJ STORE uice, vice = comlev1_lsr, kind=isbyte, key = lnkey
# endif /* ALLOW_AUTODIFF_TAMC */

#ifdef SEAICE_GLOBAL_3DIAG_SOLVER
        IF ( SEAICEuseMultiTileSolver ) THEN

         DO bj=myByLo(myThid),myByHi(myThid)
          DO bi=myBxLo(myThid),myBxHi(myThid)
           IF ( doIterate4u ) THEN
            DO j=jMin,jMax
             DO i=iMin,iMax
              uTmp(i,j,bi,bj)  = uIce(i,j,bi,bj)
              rhsUx(i,j,bi,bj) = ( rhsU(i,j,bi,bj)
     &             + uRt1(i,j,bi,bj)*uIce(i,j-1,bi,bj)
     &             + uRt2(i,j,bi,bj)*uIce(i,j+1,bi,bj)
     &                           )*seaiceMaskU(i,j,bi,bj)
             ENDDO
            ENDDO
           ENDIF
           IF ( doIterate4v ) THEN
            DO j=jMin,jMax
             DO i=iMin,iMax
              vTmp(i,j,bi,bj)  = vIce(i,j,bi,bj)
              rhsVy(i,j,bi,bj) = ( rhsV(i,j,bi,bj)
     &             + vRt1(i,j,bi,bj)*vIce(i-1,j,bi,bj)
     &             + vRt2(i,j,bi,bj)*vIce(i+1,j,bi,bj)
     &                           )*seaiceMaskU(i,j,bi,bj)
             ENDDO
            ENDDO
           ENDIF
C     end bi,bj-loops
          ENDDO
         ENDDO

         iSubIter = linearIterLoc*(ipass-1) + m
         CALL SOLVE_UV_TRIDIAGO(
     I                 1, OLx, doIterate4u, doIterate4v,
     I                 AU, BU, CU, rhsUx,
     I                 AV, BV, CV, rhsVy,
     O                 uIce, vIce, errCode,
     I                 iSubIter, myIter, myThid )

         DO bj=myByLo(myThid),myByHi(myThid)
          DO bi=myBxLo(myThid),myBxHi(myThid)
           IF ( doIterate4u ) THEN
            DO j=jMin,jMax
             DO i=iMin,iMax
              uIce(i,j,bi,bj) = uTmp(i,j,bi,bj)
     &            + WFAU*( uIce(i,j,bi,bj)-uTmp(i,j,bi,bj) )
             ENDDO
            ENDDO
           ENDIF
           IF ( doIterate4v ) THEN
            DO j=jMin,jMax
             DO i=iMin,iMax
              vIce(i,j,bi,bj) = vTmp(i,j,bi,bj)
     &            + WFAV*( vIce(i,j,bi,bj)-vTmp(i,j,bi,bj) )
             ENDDO
            ENDDO
           ENDIF
C     end bi,bj-loops
          ENDDO
         ENDDO

        ELSE
#endif /* SEAICE_GLOBAL_3DIAG_SOLVER */

        DO bj=myByLo(myThid),myByHi(myThid)
         DO bi=myBxLo(myThid),myBxHi(myThid)

#ifdef ALLOW_AUTODIFF_TAMC
          tkey = bi + (bj-1)*nSx + (lnkey-1)*nSx*nSy
CADJ STORE uice(:,:,bi,bj) = comlev1_bibj_lsr,kind=isbyte,key=tkey
CADJ STORE vice(:,:,bi,bj) = comlev1_bibj_lsr,kind=isbyte,key=tkey
#endif /* ALLOW_AUTODIFF_TAMC */
C-jmc: get fewer TAF warnings when always (no if doIterate) saving uIce,vIce:
C     save u/vIce prior to iteration
          DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
            uTmp(i,j,bi,bj)=uIce(i,j,bi,bj)
            vTmp(i,j,bi,bj)=vIce(i,j,bi,bj)
           ENDDO
          ENDDO

          IF ( doIterate4u ) THEN
C Solve for uIce :
           CALL SEAICE_LSR_TRIDIAGU(
     I          AU, BU, CU, uRt1, uRt2, rhsU, uTmp, seaiceMaskU, WFAU,
     U          uIce,
     I          iMin, iMax, jMin, jMax, bi, bj, myTime, myIter, myThid )
          ENDIF

          IF ( doIterate4v ) THEN
C Solve for vIce
           CALL SEAICE_LSR_TRIDIAGV(
     I          AV, BV, CV, vRt1, vRt2, rhsV, vTmp, seaiceMaskV, WFAV,
     U          vIce,
     I          iMin, iMax, jMin, jMax, bi, bj, myTime, myIter, myThid )
          ENDIF

C     end bi,bj-loops
         ENDDO
        ENDDO

#ifdef SEAICE_GLOBAL_3DIAG_SOLVER
        ENDIF
#endif /* SEAICE_GLOBAL_3DIAG_SOLVER */

#ifdef SEAICE_ALLOW_LSR_FLEX
        IF ( SEAICEuseLSRflex ) THEN
         IF ( MOD(m,SOLV_NCHECK) .EQ. 0
     &        .AND. (doIterate4u.OR.doIterate4v) ) THEN
          CALL SEAICE_RESIDUAL(
     I         rhsU, rhsV, uRt1, uRt2, vRt1, vRt2,
     I         AU, BU, CU, AV, BV, CV, uIce, vIce,
     O         S1, S2, uTmp, vTmp,
     I         printResidual, myIter, myThid )
          IF( S1.LT.LSR_ERRORfu ) THEN
           ICOUNT1=m
           doIterate4u = .FALSE.
          ENDIF
          IF( S2.LT.LSR_ERRORfv ) THEN
           ICOUNT2=m
           doIterate4v = .FALSE.
          ENDIF
         ENDIF
        ELSE
#endif
        IF ( doIterate4u.AND.MOD(m,SOLV_NCHECK).EQ.0) THEN
         S1=ZERO
         DO bj=myByLo(myThid),myByHi(myThid)
          DO bi=myBxLo(myThid),myBxHi(myThid)
           DO j=1,sNy
            DO i=1,sNx
             UERR=(uIce(i,j,bi,bj)-uTmp(i,j,bi,bj))
     &               * seaiceMaskU(i,j,bi,bj)
             S1=MAX(ABS(UERR),S1)
            ENDDO
           ENDDO
          ENDDO
         ENDDO
         _GLOBAL_MAX_RL( S1, myThid )
c        WRITE(standardMessageUnit,'(A,2I6,1P4E16.9)')
c    &   ' U iters,error,WF = ',ipass,M,S1,S1A,WFAU
C SAFEGUARD AGAINST BAD FORCING ETC
         IF(m.GT.1.AND.S1.GT.S1A) WFAU=WFAU2
         S1A=S1
         IF(S1.LT.LSR_ERROR) THEN
          ICOUNT1=m
          doIterate4u = .FALSE.
         ENDIF
        ENDIF

        IF ( doIterate4v.AND.MOD(m,SOLV_NCHECK).EQ.0) THEN
         S2=ZERO
         DO bj=myByLo(myThid),myByHi(myThid)
          DO bi=myBxLo(myThid),myBxHi(myThid)
           DO j=1,sNy
            DO i=1,sNx
             UERR=(vIce(i,j,bi,bj)-vTmp(i,j,bi,bj))
     &               * seaiceMaskV(i,j,bi,bj)
             S2=MAX(ABS(UERR),S2)
            ENDDO
           ENDDO
          ENDDO
         ENDDO
         _GLOBAL_MAX_RL( S2, myThid )
C SAFEGUARD AGAINST BAD FORCING ETC
         IF(m.GT.1.AND.S2.GT.S2A) WFAV=WFAV2
         S2A=S2
         IF(S2.LT.LSR_ERROR) THEN
          ICOUNT2=m
          doIterate4v = .FALSE.
         ENDIF
        ENDIF
#ifdef SEAICE_ALLOW_LSR_FLEX
        ENDIF
#endif

        CALL EXCH_UV_XY_RL( uIce, vIce,.TRUE.,myThid)

C--    end doIterate4u or doIterate4v
       ENDIF
      ENDDO
C ITERATION END -----------------------------------------------------

#ifdef SEAICE_ALLOW_LSR_FLEX
      IF ( SEAICEuseLSRflex ) THEN
       residkm2 = residkm1
       residkm1 = residIni
      ENDIF
#endif /* SEAICE_ALLOW_LSR_FLEX */

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#ifndef ALLOW_AUTODIFF_TAMC
C     Here residU/Vend and u/vTmp are computed but never used for anything
C     but reporting to STDOUT. Still TAF thinks this requires recomputations
C     so we hide this part of the code from TAF.
      IF ( printResidual ) THEN
C--   Calculate final residual of the linearised system
        CALL SEAICE_RESIDUAL(
     I                  rhsU, rhsV, uRt1, uRt2, vRt1, vRt2,
     I                  AU, BU, CU, AV, BV, CV, uIce, vIce,
     O                  residUend, residVend, uTmp, vTmp,
     I                  printResidual, myIter, myThid )

        _BEGIN_MASTER( myThid )
        WRITE(standardMessageUnit,'(A,1X,I9,1P3E16.8)')
     &    ' SEAICE_LSR: Residual Initial ipass,Uice,Vice=',
     &        ipass, residUini, residVini
#ifdef SEAICE_ALLOW_FREEDRIFT
        IF ( LSR_mixIniGuess.GE.0 )
     &  WRITE(standardMessageUnit,'(A,1P3E16.8)')
     &    ' SEAICE_LSR: Residual FrDrift U_fd,V_fd=',
     &        residU_fd, residV_fd
        IF ( LSR_mixIniGuess.GE.2 )
     &  WRITE(standardMessageUnit,'(A,1P3E16.8)')
     &    ' SEAICE_LSR: Residual Mix-ini Uice,Vice=',
     &        residUmix, residVmix
#endif /* SEAICE_ALLOW_FREEDRIFT */
        WRITE(standardMessageUnit,'(A,I9,A,I9,1P2E16.8)')
     &    ' SEAICE_LSR (ipass=',ipass,') iters,dU,Resid=',
     &      ICOUNT1, S1, residUend
        WRITE(standardMessageUnit,'(A,I9,A,I9,1P2E16.8)')
     &    ' SEAICE_LSR (ipass=',ipass,') iters,dV,Resid=',
     &      ICOUNT2, S2, residVend
        _END_MASTER( myThid )
      ENDIF
#ifdef ALLOW_DEBUG
      IF ( debugLevel .GE. debLevD ) THEN
        WRITE(msgBuf,'(A,I3,A)')
     &        'Uice post iter (SEAICE_LSR', MOD(ipass,1000), ')'
        CALL DEBUG_STATS_RL( 1, UICE, msgBuf, myThid )
        WRITE(msgBuf,'(A,I3,A)')
     &        'Vice post iter (SEAICE_LSR', MOD(ipass,1000), ')'
        CALL DEBUG_STATS_RL( 1, VICE, msgBuf, myThid )
      ENDIF
#endif /* ALLOW_DEBUG */
      IF ( doIterate4u .OR. doIterate4v ) THEN
        WRITE(msgBuf,'(2A,I10,A,I4,A)') '** WARNING ** SEAICE_LSR ',
     &    '(it=', myIter, ',', ipass,') did not converge :'
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
        WRITE(msgBuf,'(2(A,I6,0PF6.3,1PE14.6))')
     &      ' nIt,wFU,dU=', ICOUNT1, WFAU, S1,
     &    ' ; nIt,wFV,dV=', ICOUNT2, WFAV, S2
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
      ENDIF
#endif /* ALLOW_AUTODIFF_TAMC */

C     APPLY MASKS
      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          uIce(i,j,bi,bj)=uIce(i,j,bi,bj)* seaiceMaskU(i,j,bi,bj)
          vIce(i,j,bi,bj)=vIce(i,j,bi,bj)* seaiceMaskV(i,j,bi,bj)
         ENDDO
        ENDDO
       ENDDO
      ENDDO
CML      CALL EXCH_UV_XY_RL( uIce, vIce,.TRUE.,myThid)

#ifdef SEAICE_ALLOW_CHECK_LSR_CONVERGENCE
      IF ( debugLevel .GE. debLevC ) THEN
       resnorm = 0. _d 0
       EKnorm  = 0. _d 0
       counter = 0. _d 0
       DO bj=myByLo(myThid),myByHi(myThid)
        DO bi=myBxLo(myThid),myBxHi(myThid)
C--   Compute residual norm and print
         DO j=1,sNy
          DO i=1,sNx
           resnorm = resnorm + 0.5 _d 0 *
     &          ( ( (uIceNm1(i,j,bi,bj)+uIceNm1(i+1,j,bi,bj))
     &            - (uIce(i,j,bi,bj)+uIce(i+1,j,bi,bj)) )**2
     &          + ( (vIceNm1(i,j,bi,bj)+vIceNm1(i,j+1,bi,bj))
     &            - (vIce(i,j,bi,bj)+vIce(i,j+1,bi,bj)) )**2 )
           IF ( area(i,j,bi,bj) .GT. 0.5 _d 0 ) THEN
            EKnorm = EKnorm + 0.5 _d 0 * heff(i,j,bi,bj) *
     &           ( ( (uIce(i,j,bi,bj)+uIce(i+1,j,bi,bj)) )**2
     &           + ( (vIce(i,j,bi,bj)+vIce(i,j+1,bi,bj)) )**2 )
            counter = counter + 1. _d 0
           ENDIF
          ENDDO
         ENDDO
        ENDDO
       ENDDO
       _GLOBAL_SUM_RL( resnorm, myThid )
       _GLOBAL_SUM_RL( EKnorm, myThid )
       _GLOBAL_SUM_RL( counter, myThid )
       IF ( counter .GT. 0. _d 0 ) EKnorm = EKnorm/counter
       _BEGIN_MASTER( myThid )
       WRITE(standardMessageUnit,'(A,I7,1X,2E22.14)')
     &      'S/R SEAICE_LSR: IPSEUDO, RESNORM, EKNORM = ',
     &      ipass, SQRT(resnorm), EKnorm
       _END_MASTER( myThid )
      ENDIF
#endif /* SEAICE_ALLOW_CHECK_LSR_CONVERGENCE */

C     second IF doNonLinLoop
      ENDIF
C     end outer ipass pseudo-time stepping loop
      ENDDO

#ifdef ALLOW_DIAGNOSTICS
      IF ( DIAGNOSTICS_IS_ON('SIlsrRe ',myThid) ) THEN
C     S/R SEAICE_CALC_RESIDUAL does not compute residual velocities on
C     halos, so we need an exchange here to get the correct diagnostics
C     at cell centers
       CALL EXCH_UV_XY_RL( uTmp, vTmp,.TRUE.,myThid)
       DO bj = myByLo(myThid), myByHi(myThid)
        DO bi = myBxLo(myThid), myBxHi(myThid)
         DO j=1,sNy
          DO i=1,sNx
           RTmp(i,j) = SQRT( HALF * (
     &            uTmp(i,  j,bi,bj) * uTmp(i,  j,bi,bj)
     &          + uTmp(i+1,j,bi,bj) * uTmp(i+1,j,bi,bj)
     &          + vTmp(i,j,  bi,bj) * vTmp(i,j,  bi,bj)
     &          + vTmp(i,j+1,bi,bj) * vTmp(i,j+1,bi,bj)
     &          ) )
          ENDDO
         ENDDO
         CALL DIAGNOSTICS_FILL(RTmp,'SIlsrRe ',0,1,3,bi,bj,myThid)
        ENDDO
       ENDDO
      ENDIF
#endif   /* ALLOW_DIAGNOSTICS */

      IF ( useHB87StressCoupling ) THEN
# ifdef ALLOW_AUTODIFF_TAMC
C     These directives do not remove any recomputation warnings but avoid
C     recomputing the entire LSR loop before evaluating this code block
CADJ STORE uice, vice, eta, etaz, zeta = comlev1_dynsol,
CADJ &     kind=isbyte, key = ikey_dynamics
# endif /* ALLOW_AUTODIFF_TAMC */
C     compute the divergence of stress here to be used later
C
C     compute strain rate from latest velocities
       CALL SEAICE_CALC_STRAINRATES(
     I       uIce, vIce,
     O       e11, e22, e12,
     I       3, myTime, myIter, myThid )
C     compute internal stresses with updated ice velocities
C     and evaluate divergence of stress and apply to forcing
       DO bj=myByLo(myThid),myByHi(myThid)
        DO bi=myBxLo(myThid),myBxHi(myThid)
         CALL SEAICE_CALC_STRESSDIV(
     I        e11, e22, e12, press, zeta, eta, etaZ,
     O        stressDivergenceX, stressDivergenceY,
     I        bi, bj, myTime, myIter, myThid )
        ENDDO
       ENDDO
C     endif  useHB87StressCoupling
      ENDIF

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: SEAICE_RESIDUAL
C     !INTERFACE:
      SUBROUTINE SEAICE_RESIDUAL(
     I                  rhsU, rhsV, uRt1, uRt2, vRt1, vRt2,
     I                  AU, BU, CU, AV, BV, CV, uFld, vFld,
     O                  residU, residV, uRes, vRes,
     I                  calcMeanResid, myIter, myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R SEAICE_RESIDUAL
C     | o Compute Linear solver residual
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "GRID.h"
#include "SEAICE_SIZE.h"
#include "SEAICE.h"

C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
C     calcMeanResid :: also compute mean residual (=RMS)
C     myIter        :: Simulation timestep number
C     myThid        :: my Thread Id. number
C--   RHS
      _RL rhsU (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL rhsV (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
C-    coefficients for lateral points, u(j+/-1)
      _RL uRt1(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL uRt2(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
C-    coefficients for lateral points, v(i+/-1)
      _RL vRt1(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL vRt2(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
C-    diagonals of coefficient matrices
      _RL AU   (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL BU   (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL CU   (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL AV   (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL BV   (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL CV   (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
C--   seaice velocity
      _RL uFld(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL vFld(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
C-    residual (output)
      _RL residU, residV
      _RL uRes (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL vRes (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      LOGICAL calcMeanResid
      INTEGER myIter
      INTEGER myThid
CEOP

C     !LOCAL VARIABLES:
C     === Local variables ===
C     i,j,bi,bj  :: Loop counters

      INTEGER i, j, bi, bj

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C--   Calculate residual of the linearised system
      residU = 0.
      residV = 0.

      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
         DO j=1,sNy
          DO i=1,sNx
           uRes(i,j,bi,bj) = rhsU(i,j,bi,bj)
     &            + uRt1(i,j,bi,bj)*uFld(i,j-1,bi,bj)
     &            + uRt2(i,j,bi,bj)*uFld(i,j+1,bi,bj)
     &            - ( AU(i,j,bi,bj)*uFld(i-1,j,bi,bj)
     &              + BU(i,j,bi,bj)*uFld( i ,j,bi,bj)
     &              + CU(i,j,bi,bj)*uFld(i+1,j,bi,bj)
     &              )
           vRes(i,j,bi,bj) = rhsV(i,j,bi,bj)
     &            + vRt1(i,j,bi,bj)*vFld(i-1,j,bi,bj)
     &            + vRt2(i,j,bi,bj)*vFld(i+1,j,bi,bj)
     &            - ( AV(i,j,bi,bj)*vFld(i,j-1,bi,bj)
     &              + BV(i,j,bi,bj)*vFld(i, j ,bi,bj)
     &              + CV(i,j,bi,bj)*vFld(i,j+1,bi,bj)
     &              )
          ENDDO
         ENDDO
         IF ( calcMeanResid ) THEN
          DO j=1,sNy
           DO i=1,sNx
            residU = residU + uRes(i,j,bi,bj)*uRes(i,j,bi,bj)
     &                       *rAw(i,j,bi,bj)*maskInW(i,j,bi,bj)
#ifndef OBCS_UVICE_OLD
     &                       *maskInC(i,j,bi,bj)*maskInC(i-1,j,bi,bj)
#endif
            residV = residV + vRes(i,j,bi,bj)*vRes(i,j,bi,bj)
     &                       *rAs(i,j,bi,bj)*maskInS(i,j,bi,bj)
#ifndef OBCS_UVICE_OLD
     &                       *maskInC(i,j,bi,bj)*maskInC(i,j-1,bi,bj)
#endif
           ENDDO
          ENDDO
         ENDIF
       ENDDO
      ENDDO
      IF ( calcMeanResid ) THEN
       _GLOBAL_SUM_RL( residU, myThid )
       _GLOBAL_SUM_RL( residV, myThid )
C     scale residuals by globalArea so that they do not get ridiculously large
       IF ( residU.GT.0. ) residU = SQRT(residU/globalArea)
       IF ( residV.GT.0. ) residV = SQRT(residV/globalArea)
      ENDIF

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      RETURN
      END

CBOP
C     !ROUTINE: SEAICE_LSR_CALC_COEFFS
C     !INTERFACE:
      SUBROUTINE SEAICE_LSR_CALC_COEFFS(
     I     etaPlusZeta, zetaMinusEta, etaZloc, zetaZloc, dragSym,
     O     AU, BU, CU, AV, BV, CV, uRt1, uRt2, vRt1, vRt2,
     I     iMin, iMax, jMin, jMax, myTime, myIter, myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R SEAICE_LSR_CALC_COEFFS
C     | o Calculate coefficient matrix for LSR solver
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "SEAICE_SIZE.h"
#include "SEAICE_PARAMS.h"
#include "SEAICE_GRID.h"
#include "SEAICE.h"

C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
C     myTime     :: Simulation time
C     myIter     :: Simulation timestep number
C     myThid     :: my Thread Id. number
      _RL     myTime
      INTEGER myIter
      INTEGER myThid
      INTEGER iMin, iMax, jMin, jMax
C     combinations of bulk and shear viscosity at C points
C     abbreviations
      _RL etaPlusZeta (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL zetaMinusEta(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
C     shear and bulk viscosity at Z points
      _RL  etaZloc    (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL zetaZloc    (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
C     symmetric ice-ocean stress coefficient
      _RL dragSym     (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
C     coefficients of ice velocities in coefficient matrix
C     for both U and V-equation
C     diagonals of coefficient matrices
      _RL AU          (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL BU          (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL CU          (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL AV          (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL BV          (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL CV          (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
C     coefficients for lateral points, u(j+/-1)
      _RL uRt1        (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL uRt2        (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
C     coefficients for lateral points, v(i+/-1)
      _RL vRt1        (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL vRt2        (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
CEOP

C     !LOCAL VARIABLES:
C     === Local variables ===
C     i,j,bi,bj  :: Loop counters

      INTEGER i, j, bi, bj
      _RL hFacM, hFacP
C     backward difference extrapolation factor (includes 1/deltaT)
      _RL bdfAlphaOverDt
C     strongly implicit coupling factor
      _RL strImpCplFac

C     fractional area at velocity points
      _RL areaW(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL areaS(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
C     coefficients of ice velocities in coefficient matrix
C     for both U and V-equation
C     XX: double derivative in X
C     YY: double derivative in Y
C     XM: metric term with derivative in X
C     YM: metric term with derivative in Y
      _RL UXX  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL UYY  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL UXM  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL UYM  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL VXX  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL VYY  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL VXM  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL VYM  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C     backward difference extrapolation factor
      bdfAlphaOverDt = 1. _d 0
      IF ( SEAICEuseBDF2 ) THEN
       IF ( myIter.EQ.nIter0 .AND. SEAICEmomStartBDF.EQ.0 ) THEN
        bdfAlphaOverDt = 1. _d 0
       ELSE
        bdfAlphaOverDt = 1.5 _d 0
       ENDIF
      ENDIF
C
      bdfAlphaOverDt = bdfAlphaOverDt / SEAICE_deltaTdyn
C
      strImpCplFac = 0. _d 0
      IF ( SEAICEuseStrImpCpl ) strImpCplFac = 1. _d 0

      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        IF ( SEAICEscaleSurfStress ) THEN
         DO j=jMin,jMax
          DO i=iMin,iMax
           areaW(i,j) = 0.5 _d 0*(AREA(i,j,bi,bj)+AREA(i-1,j,bi,bj))
           areaS(i,j) = 0.5 _d 0*(AREA(i,j,bi,bj)+AREA(i,j-1,bi,bj))
          ENDDO
         ENDDO
        ELSE
         DO j=jMin,jMax
          DO i=iMin,iMax
           areaW(i,j) = 1. _d 0
           areaS(i,j) = 1. _d 0
          ENDDO
         ENDDO
        ENDIF
C
C     coefficients of uIce(i,j) and vIce(i,j) belonging to ...
C
        DO j=jMin,jMax
         DO i=iMin-1,iMax
C     ... d/dx (eta+zeta) d/dx u
          UXX(i,j) = _dyF(i,j,bi,bj) * etaPlusZeta(i,j,bi,bj)
     &         * _recip_dxF(i,j,bi,bj)
C     ... d/dx (zeta-eta) k1 u
          UXM(i,j) = _dyF(i,j,bi,bj) * zetaMinusEta(i,j,bi,bj)
     &         * k1AtC(i,j,bi,bj) * 0.5 _d 0
         ENDDO
        ENDDO
        DO j=jMin,jMax+1
         DO i=iMin,iMax
C     ... d/dy eta d/dy u
          UYY(i,j) = _dxV(i,j,bi,bj) *
     &         ( etaZloc(i,j,bi,bj) + strImpCplFac*zetaZloc(i,j,bi,bj) )
     &         * _recip_dyU(i,j,bi,bj)
C     ... d/dy eta k2 u
          UYM(i,j) = _dxV(i,j,bi,bj) * etaZloc(i,j,bi,bj)
     &         * k2AtZ(i,j,bi,bj) * 0.5 _d 0
         ENDDO
        ENDDO
        DO j=jMin,jMax
         DO i=iMin,iMax+1
C     ... d/dx eta dv/dx
          VXX(i,j) = _dyU(i,j,bi,bj) *
     &         ( etaZloc(i,j,bi,bj) + strImpCplFac*zetaZloc(i,j,bi,bj) )
     &         * _recip_dxV(i,j,bi,bj)
C     ... d/dx eta k1 v
          VXM(i,j) = _dyU(i,j,bi,bj) * etaZloc(i,j,bi,bj)
     &         * k1AtZ(i,j,bi,bj) * 0.5 _d 0
         ENDDO
        ENDDO
        DO j=jMin-1,jMax
         DO i=iMin,iMax
C     ... d/dy eta+zeta dv/dy
          VYY(i,j) = _dxF(i,j,bi,bj) * etaPlusZeta(i,j,bi,bj)
     &         * _recip_dyF(i,j,bi,bj)
C     ... d/dy (zeta-eta) k2 v
          VYM(i,j) = _dxF(i,j,bi,bj) * zetaMinusEta(i,j,bi,bj)
     &         * k2AtC(i,j,bi,bj) * 0.5 _d 0
         ENDDO
        ENDDO

C--   Coefficients for solving uIce :

C     assemble coefficient matrix, beware of sign convention: because this
C     is the left hand side we calculate -grad(sigma), but the coefficients
C     of U(i,j+/-1) are counted on the right hand side
        DO j=jMin,jMax
         DO i=iMin,iMax
C     coefficients for UICE(i-1,j)
          AU(i,j,bi,bj)= ( - UXX(i-1,j) + UXM(i-1,j) )
     &         * seaiceMaskU(i,j,bi,bj)
C     coefficients for UICE(i+1,j)
          CU(i,j,bi,bj)= ( - UXX(i  ,j) - UXM(i  ,j) )
     &         * seaiceMaskU(i,j,bi,bj)
C     coefficients for UICE(i,j)
          BU(i,j,bi,bj)=(ONE - seaiceMaskU(i,j,bi,bj)) +
     &         ( UXX(i-1,j) + UXX(i,j) + UYY(i,j+1) + UYY(i,j)
     &         + UXM(i-1,j) - UXM(i,j) + UYM(i,j+1) - UYM(i,j)
     &         ) * seaiceMaskU(i,j,bi,bj)
C     coefficients of uIce(i,j-1)
          uRt1(i,j,bi,bj)= UYY(i,j  ) + UYM(i,j  )
C     coefficients of uIce(i,j+1)
          uRt2(i,j,bi,bj)= UYY(i,j+1) - UYM(i,j+1)
         ENDDO
        ENDDO

C     apply boundary conditions according to slip factor
C     for no slip, set u on boundary to zero: u(j+/-1)=-u(j)
C     for the free slip case sigma_12 = 0
        DO j=jMin,jMax
         DO i=iMin,iMax
          hFacM = seaiceMaskU(i,j-1,bi,bj)
          hFacP = seaiceMaskU(i,j+1,bi,bj)
C     copy contributions to coefficient of U(i,j)
C     beware of sign convection: uRt1/2 have the opposite sign convention
C     than BU, hence the minus sign
          BU(i,j,bi,bj)=BU(i,j,bi,bj) + seaiceMaskU(i,j,bi,bj) *
     &         ( ( 1. _d 0 - hFacM ) * ( UYY(i  ,j  ) + UYM(i  ,j  ) )
     &         + ( 1. _d 0 - hFacP ) * ( UYY(i  ,j+1) - UYM(i  ,j+1) ) )
C     reset coefficients of U(i,j-1) and U(i,j+1)
          uRt1(i,j,bi,bj) = uRt1(i,j,bi,bj) * hFacM
          uRt2(i,j,bi,bj) = uRt2(i,j,bi,bj) * hFacP
         ENDDO
        ENDDO

C     now we need to normalize everything by the grid cell area
        DO j=jMin,jMax
         DO i=iMin,iMax
          AU(i,j,bi,bj)   = AU(i,j,bi,bj)   * recip_rAw(i,j,bi,bj)
          CU(i,j,bi,bj)   = CU(i,j,bi,bj)   * recip_rAw(i,j,bi,bj)
C     here we need to add the contribution from the time derivative (in
C     bdfAlphaOverDt) and the symmetric drag term; must be done after
C     normalizing
          BU(i,j,bi,bj)    = BU(i,j,bi,bj)  * recip_rAw(i,j,bi,bj)
     &         + seaiceMaskU(i,j,bi,bj) *
     &         ( bdfAlphaOverDt*seaiceMassU(i,j,bi,bj)
     &         + 0.5 _d 0 * ( dragSym(i,  j,bi,bj)
     &                      + dragSym(i-1,j,bi,bj) )*areaW(i,j)
     &         )
          uRt1(i,j,bi,bj) = uRt1(i,j,bi,bj) * recip_rAw(i,j,bi,bj)
          uRt2(i,j,bi,bj) = uRt2(i,j,bi,bj) * recip_rAw(i,j,bi,bj)
         ENDDO
        ENDDO

C--   Coefficients for solving uIce :

C     assemble coefficient matrix, beware of sign convention: because this
C     is the left hand side we calculate -grad(sigma), but the coefficients
C     of V(i+/-1,j) are counted on the right hand side
        DO j=jMin,jMax
         DO i=iMin,iMax
C     coefficients for VICE(i,j-1)
          AV(i,j,bi,bj)=( - VYY(i,j-1) + VYM(i,j-1)
     &         ) * seaiceMaskV(i,j,bi,bj)
C     coefficients for VICE(i,j+1)
          CV(i,j,bi,bj)=( - VYY(i,j  ) - VYM(i,j  )
     &         ) * seaiceMaskV(i,j,bi,bj)
C     coefficients for VICE(i,j)
          BV(i,j,bi,bj)= (ONE - seaiceMaskV(i,j,bi,bj)) +
     &         ( VXX(i,j) + VXX(i+1,j) + VYY(i,j) + VYY(i,j-1)
     &         - VXM(i,j) + VXM(i+1,j) - VYM(i,j) + VYM(i,j-1)
     &         ) * seaiceMaskV(i,j,bi,bj)
C     coefficients for V(i-1,j)
          vRt1(i,j,bi,bj) = VXX(i  ,j) + VXM(i  ,j)
C     coefficients for V(i+1,j)
          vRt2(i,j,bi,bj) = VXX(i+1,j) - VXM(i+1,j)
         ENDDO
        ENDDO

C     apply boundary conditions according to slip factor
C     for no slip, set u on boundary to zero: v(i+/-1)=-v(i)
C     for the free slip case sigma_12 = 0
        DO j=jMin,jMax
         DO i=iMin,iMax
          hFacM = seaiceMaskV(i-1,j,bi,bj)
          hFacP = seaiceMaskV(i+1,j,bi,bj)
C     copy contributions to coefficient of V(i,j)
C     beware of sign convection: vRt1/2 have the opposite sign convention
C     than BV, hence the minus sign
          BV(i,j,bi,bj)=BV(i,j,bi,bj) + seaiceMaskV(i,j,bi,bj) *
     &         ( ( 1. _d 0 - hFacM ) * ( VXX(i  ,j) + VXM(i  ,j) )
     &         + ( 1. _d 0 - hFacP ) * ( VXX(i+1,j) - VXM(i+1,j) ) )
C     reset coefficients of V(i-1,j) and V(i+1,j)
          vRt1(i,j,bi,bj) = vRt1(i,j,bi,bj) * hFacM
          vRt2(i,j,bi,bj) = vRt2(i,j,bi,bj) * hFacP
         ENDDO
        ENDDO

C     now we need to normalize everything by the grid cell area
        DO j=jMin,jMax
         DO i=iMin,iMax
          AV(i,j,bi,bj)   = AV(i,j,bi,bj)   * recip_rAs(i,j,bi,bj)
          CV(i,j,bi,bj)   = CV(i,j,bi,bj)   * recip_rAs(i,j,bi,bj)
C     here we need add the contribution from the time derivative (in
C     bdfAlphaOverDt) and the symmetric drag term; must be done after
C     normalizing
          BV(i,j,bi,bj)   = BV(i,j,bi,bj)   * recip_rAs(i,j,bi,bj)
     &         + seaiceMaskV(i,j,bi,bj) *
     &         ( bdfAlphaOverDt*seaiceMassV(i,j,bi,bj)
     &         + 0.5 _d 0 * ( dragSym(i,j,  bi,bj)
     &                      + dragSym(i,j-1,bi,bj) )*areaS(i,j)
     &         )
          vRt1(i,j,bi,bj) = vRt1(i,j,bi,bj) * recip_rAs(i,j,bi,bj)
          vRt2(i,j,bi,bj) = vRt2(i,j,bi,bj) * recip_rAs(i,j,bi,bj)
         ENDDO
        ENDDO

        IF ( ( useCubedSphereExchange .AND.
     &       (SEAICE_OLx.GT.0 .OR. SEAICE_OLy.GT.0) ) .OR.
     &       SEAICEscaleSurfStress ) THEN
C     this is clearly a hack: make sure that diagonals BU/BV are non-zero.
C     In my experience we only need to catch the case of SEAICE_OLx/y=OLx/y-2,
C     but for safety lets call this routine whenever SEAICE_OLx/y > 0
C     &       (SEAICE_OLx.EQ.OLx-2 .OR. SEAICE_OLy.EQ.OLy-2) ) THEN
C     When scaling the surface ice-ocean stress by AREA, then there will
C     be many cases of zero diagonal entries.
         DO j=jMin,jMax
          DO i=iMin,iMax
           IF (BU(i,j,bi,bj).EQ.0 _d 0) BU(i,j,bi,bj) = 1. _d 0
           IF (BV(i,j,bi,bj).EQ.0 _d 0) BV(i,j,bi,bj) = 1. _d 0
          ENDDO
         ENDDO
        ENDIF
C     bi/bj-loops
       ENDDO
      ENDDO

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

CBOP
C     !ROUTINE: SEAICE_LSR_RHSU
C     !INTERFACE:
      SUBROUTINE SEAICE_LSR_RHSU(
     I     zetaMinusEta, etaPlusZeta, etaZloc, zetaZloc, pressLoc,
     I     uIceC, vIceC,
     U     rhsU,
     I     iMin, iMax, jMin, jMax, bi, bj, myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R SEAICE_LSR_RHSU
C     | o Set up stress contribution to rhs of u-momentum eq.
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "GRID.h"
#include "SEAICE_SIZE.h"
#include "SEAICE_PARAMS.h"
#include "SEAICE_GRID.h"
#include "SEAICE.h"

C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
C     myThid     :: my Thread Id. number
      INTEGER myThid
      INTEGER iMin, iMax, jMin, jMax, bi, bj
C
      _RL zetaMinusEta(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL etaPlusZeta (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL etaZloc     (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL zetaZloc    (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL pressloc    (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL uIceC       (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL vIceC       (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL rhsU        (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)

C     !LOCAL VARIABLES:
C     === Local variables ===
C     i,j  :: Loop counters
C     eplus, eminus :: convenient abbreviations for e11+e22, e11-e22
      INTEGER i,j
      _RL eplus, eminus
      _RL hFacM
      _RL sig11(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL sig12(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
CEOP

      DO j=1-OLy,sNy+OLy
       DO i=1-OLx,sNx+OLx
        sig11(i,j) = 0. _d 0
        sig12(i,j) = 0. _d 0
       ENDDO
      ENDDO
C     contribution of sigma11 to rhs
      DO j=jMin,jMax
       DO i=iMin-1,iMax
        sig11(i,j) = zetaMinusEta(i,j,bi,bj)
     &       * ( vIceC(i,j+1,bi,bj) - vIceC(i,j,bi,bj) )
     &       * _recip_dyF(i,j,bi,bj)
     &       + etaPlusZeta(i,j,bi,bj) * k2AtC(i,j,bi,bj)
     &       * 0.5 _d 0 * ( vIceC(i,j+1,bi,bj) + vIceC(i,j,bi,bj) )
     &       - 0.5 _d 0 * pressLoc(i,j,bi,bj)
       ENDDO
      ENDDO
C     contribution of sigma12 to rhs of u-equation
      DO j=jMin,jMax+1
       DO i=iMin,iMax
        hFacM = seaiceMaskV(i,j,bi,bj) - seaiceMaskV(i-1,j,bi,bj)
        sig12(i,j) = etaZloc(i,j,bi,bj) * (
     &       ( vIceC(i,j,bi,bj) - vIceC(i-1,j,bi,bj) )
     &       * _recip_dxV(i,j,bi,bj)
     &       - k1AtZ(i,j,bi,bj)
     &       * 0.5 _d 0 * ( vIceC(i,j,bi,bj) + vIceC(i-1,j,bi,bj) )
     &       )
C     free slip conditions (sig12=0) are taken care of by masking sig12
     &       *HEFFM(i  ,j  ,bi,bj)*HEFFM(i-1,j  ,bi,bj)
     &       *HEFFM(i  ,j-1,bi,bj)*HEFFM(i-1,j-1,bi,bj)
C     no slip boundary conditions (v(i-1)=-v(i))
C     v(i)+v(i-1) = 0 is also taken care of by masking sig12, so that we
C     only need to deal with v(i)-v(i-1)
     &       + etaZloc(i,j,bi,bj) * _recip_dxV(i,j,bi,bj)
     &       * ( vIceC(i,j,bi,bj) + vIceC(i-1,j,bi,bj) )
     &       * hFacM * 2. _d 0
       ENDDO
      ENDDO

      IF ( SEAICEuseStrImpCpl ) THEN
C     strictly speaking, this is not a contribution to sig12, but for
C     convenience we add the explicit term -zetaZ*du/dy here;
C     we do not have to add any metric terms, because they cancel.
       DO j=jMin,jMax+1
        DO i=iMin,iMax
         hFacM = seaiceMaskV(i,j,bi,bj) - seaiceMaskV(i-1,j,bi,bj)
         sig12(i,j) = sig12(i,j) - zetaZloc(i,j,bi,bj) * (
     &        ( uIceC(i,j,bi,bj) - uIceC(i,j-1,bi,bj) )
     &        * _recip_dyU(i,j,bi,bj)
     &        )
C     free slip conditions (sig12=0) are taken care of by masking sig12
     &        *HEFFM(i  ,j  ,bi,bj)*HEFFM(i-1,j  ,bi,bj)
     &        *HEFFM(i  ,j-1,bi,bj)*HEFFM(i-1,j-1,bi,bj)
C     no slip boundary conditions (u(j-1)=-u(j))
C     u(j)+u(j-1) = 0 is also taken care of by masking sig12, so that we
C     only need to deal with u(j)-u(j-1)
     &        - zetaZloc(i,j,bi,bj) * _recip_dyU(i,j,bi,bj)
     &        * ( uIceC(i,j,bi,bj) + uIceC(i,j-1,bi,bj) )
     &        * hFacM * 2. _d 0
        ENDDO
       ENDDO
      ENDIF

      DO j=jMin,jMax
       DO i=iMin,iMax
C     contribution to the rhs part of grad(sigma)_x
        rhsU(i,j,bi,bj) = rhsU(i,j,bi,bj)
     &       + recip_rAw(i,j,bi,bj) * seaiceMaskU(i,j,bi,bj) *
     &       ( _dyF(i  ,j  ,bi,bj)*sig11(i  ,j  )
     &       - _dyF(i-1,j  ,bi,bj)*sig11(i-1,j  )
     &       + _dxV(i  ,j+1,bi,bj)*sig12(i  ,j+1)
     &       - _dxV(i  ,j  ,bi,bj)*sig12(i  ,j  ) )
       ENDDO
      ENDDO

C     add extra metric terms
      IF ( SEAICEselectMetricTerms .GE. 2 ) THEN
C     to save memory we re-use sig11 as sig22, hopefully without confusion
       DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
         eplus = e11(i,j,bi,bj) + e22(i,j,bi,bj)
         eminus= e11(i,j,bi,bj) - e22(i,j,bi,bj)
         sig11(i,j) = zeta(i,j,bi,bj)*eplus - eta(i,j,bi,bj)*eminus
     &        - 0.5 _d 0 * press(i,j,bi,bj)
         sig12(i,j) = 2. _d 0 * e12(i,j,bi,bj) * etaZ(i,j,bi,bj)
        ENDDO
       ENDDO

       DO j=jMin,jMax
        DO i=iMin,iMax
         rhsU(i,j,bi,bj) = rhsU(i,j,bi,bj)
     &        + seaiceMaskU(i,j,bi,bj) * halfRL *
     &        ( k2AtU(i,j,bi,bj) * ( sig12(i,j) + sig12(i,j+1) )
     &        - k1AtU(i,j,bi,bj) * ( sig11(i,j) + sig11(i-1,j) ) )
        ENDDO
       ENDDO
      ENDIF

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

CBOP
C     !ROUTINE: SEAICE_LSR_RHSV
C     !INTERFACE:
      SUBROUTINE SEAICE_LSR_RHSV(
     I     zetaMinusEta, etaPlusZeta, etaZloc, zetaZloc, pressLoc,
     I     uIceC, vIceC,
     U     rhsV,
     I     iMin, iMax, jMin, jMax, bi, bj, myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R SEAICE_LSR_RHSV
C     | o Set up stress contribution to rhs of v-momentum eq.
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "GRID.h"
#include "SEAICE_SIZE.h"
#include "SEAICE_PARAMS.h"
#include "SEAICE_GRID.h"
#include "SEAICE.h"

C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
C     myThid     :: my Thread Id. number
      INTEGER myThid
      INTEGER iMin, iMax, jMin, jMax, bi, bj
C
      _RL zetaMinusEta(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL etaPlusZeta (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL etaZloc     (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL zetaZloc    (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL pressloc    (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL uIceC       (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL vIceC       (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL rhsV        (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)

C     !LOCAL VARIABLES:
C     === Local variables ===
C     i,j  :: Loop counters
C     eplus, eminus :: convenient abbreviations for e11+e22, e11-e22
      INTEGER i,j
      _RL eplus, eminus
      _RL hFacM
      _RL sig22(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL sig12(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
CEOP

      DO j=1-OLy,sNy+OLy
       DO i=1-OLx,sNx+OLx
        sig22(i,j) = 0. _d 0
        sig12(i,j) = 0. _d 0
       ENDDO
      ENDDO

C     contribution of sigma22 to rhs
      DO j=jMin-1,jMax
       DO i=iMin,iMax
        sig22(i,j) = zetaMinusEta(i,j,bi,bj)
     &       * ( uIceC(i+1,j,bi,bj) - uIceC(i,j,bi,bj) )
     &       * _recip_dxF(i,j,bi,bj)
     &       + etaPlusZeta(i,j,bi,bj) * k1AtC(i,j,bi,bj)
     &       * 0.5 _d 0 * ( uIceC(i+1,j,bi,bj) + uIceC(i,j,bi,bj) )
     &       - 0.5 _d 0 * pressLoc(i,j,bi,bj)
       ENDDO
      ENDDO
C     contribution of sigma12 to rhs of v-equation
      DO j=jMin,jMax
       DO i=iMin,iMax+1
        hFacM = seaiceMaskU(i,j,bi,bj) - seaiceMaskU(i,j-1,bi,bj)
        sig12(i,j) = etaZloc(i,j,bi,bj) * (
     &       ( uIceC(i,j,bi,bj) - uIceC(i,j-1,bi,bj) )
     &       * _recip_dyU(i,j,bi,bj)
     &       - k2AtZ(i,j,bi,bj)
     &       * 0.5 _d 0 * ( uIceC(i,j,bi,bj) + uIceC(i,j-1,bi,bj) )
     &       )
C     free slip conditions (sig12=0) are taken care of by masking sig12,
     &       *HEFFM(i  ,j  ,bi,bj)*HEFFM(i-1,j  ,bi,bj)
     &       *HEFFM(i  ,j-1,bi,bj)*HEFFM(i-1,j-1,bi,bj)
C     no slip boundary conditions (u(j-1)=-u(j))
C     u(j)+u(j-1) = 0 is also taken care of by masking sig12, so that we
C     only need to deal with u(j)-u(j-1)
     &       + etaZloc(i,j,bi,bj) * _recip_dyU(i,j,bi,bj)
     &       * ( uIceC(i,j,bi,bj) + uIceC(i,j-1,bi,bj) )
     &         * hFacM * 2. _d 0
       ENDDO
      ENDDO

      IF ( SEAICEuseStrImpCpl ) THEN
C     strictly speaking, this is not a contribution to sig12, but for
C     convenience we add the explicit term -zetaZ*dv/dx here;
C     we do not have to add any metric terms, because they cancel.
       DO j=jMin,jMax
        DO i=iMin,iMax+1
         hFacM = seaiceMaskU(i,j,bi,bj) - seaiceMaskU(i,j-1,bi,bj)
         sig12(i,j) = sig12(i,j) - zetaZloc(i,j,bi,bj) * (
     &        ( vIceC(i,j,bi,bj) - vIceC(i-1,j,bi,bj) )
     &        * _recip_dxV(i,j,bi,bj)
     &        )
C     free slip conditions (sig12=0) are taken care of by masking sig12
     &        *HEFFM(i  ,j  ,bi,bj)*HEFFM(i-1,j  ,bi,bj)
     &        *HEFFM(i  ,j-1,bi,bj)*HEFFM(i-1,j-1,bi,bj)
C     no slip boundary conditions (v(i-1)=-v(i))
C     v(i)+v(i-1) = 0 is also taken care of by masking sig12, so that we
C     only need to deal with v(i)-v(i-1)
     &        - zetaZloc(i,j,bi,bj) * _recip_dxV(i,j,bi,bj)
     &        * ( vIceC(i,j,bi,bj) + vIceC(i-1,j,bi,bj) )
     &        * hFacM * 2. _d 0
        ENDDO
       ENDDO
      ENDIF

      DO j=jMin,jMax
       DO i=iMin,iMax
C     contribution to the rhs part of grad(sigma)_y
        rhsV(i,j,bi,bj) = rhsV(i,j,bi,bj)
     &       + recip_rAs(i,j,bi,bj) * seaiceMaskV(i,j,bi,bj) *
     &       ( _dyU(i+1,j  ,bi,bj) * sig12(i+1,j  )
     &       - _dyU(i  ,j  ,bi,bj) * sig12(i  ,j  )
     &       + _dxF(i  ,j  ,bi,bj) * sig22(i  ,j  )
     &       - _dxF(i  ,j-1,bi,bj) * sig22(i  ,j-1) )
       ENDDO
      ENDDO

      IF ( SEAICEselectMetricTerms .GE. 2 ) THEN
C     to save memory we re-use sig22 as sig11, hopefully without confusion
       DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
         eplus = e11(i,j,bi,bj) + e22(i,j,bi,bj)
         eminus= e11(i,j,bi,bj) - e22(i,j,bi,bj)
         sig22(i,j) = zeta(i,j,bi,bj)*eplus + eta(i,j,bi,bj)*eminus
     &        - 0.5 _d 0 * press(i,j,bi,bj)
         sig12(i,j) = 2. _d 0 * e12(i,j,bi,bj) * etaZ(i,j,bi,bj)
        ENDDO
       ENDDO

       DO j=jMin,jMax
        DO i=iMin,iMax
         rhsV(i,j,bi,bj) = rhsV(i,j,bi,bj)
     &        + seaiceMaskU(i,j,bi,bj) * halfRL *
     &        ( k1AtV(i,j,bi,bj) * ( sig12(i,j) + sig12(i+1,j) )
     &        - k2AtV(i,j,bi,bj) * ( sig22(i,j) + sig22(i,j-1) ) )
        ENDDO
       ENDDO
      ENDIF

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

CBOP
C     !ROUTINE: SEAICE_LSR_TRIDIAGU
C     !INTERFACE:
      SUBROUTINE SEAICE_LSR_TRIDIAGU(
     I     AU, BU, CU, uRt1, uRt2, rhsU, uTmp, seaiceMaskU, WFAU,
     U     uIce,
     I     iMin, iMax, jMin, jMax, bi, bj, myTime, myIter, myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R SEAICE_LSR_TRIDIAGU
C     | o Solve tridiagonal problem in uIce for LSR solver
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"

C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
C     myTime     :: Simulation time
C     myIter     :: Simulation timestep number
C     myThid     :: my Thread Id. number
      _RL     myTime
      INTEGER myIter
      INTEGER myThid
      INTEGER iMin, iMax, jMin, jMax, bi, bj
C     diagonals of coefficient matrices
      _RL AU   (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL BU   (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL CU   (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
C     coefficients for lateral points, v(j+/-1)
      _RL uRt1(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL uRt2(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
C     right hand side
      _RL rhsU (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
C     velocity of previous iteration step
      _RL uTmp(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
C     on entry: first guess and on exit: solution
      _RL uIce(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
C     mask
      _RL seaiceMaskU(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
C     relaxation factor
      _RL WFAU
CEOP

C     !LOCAL VARIABLES:
C     === Local variables ===
C     i,j  :: Loop counters
      INTEGER i,j,iM
      INTEGER jMinLoc, jStep
#ifdef SEAICE_LSR_ZEBRA
      INTEGER k
      PARAMETER ( jStep = 2 )
#else
      PARAMETER ( jStep = 1 )
#endif /* SEAICE_LSR_ZEBRA */
      _RL AA3, bet
      _RL URT(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL CUU(1-OLx:sNx+OLx,1-OLy:sNy+OLy)

C     Need to initialize local arrays
      DO j=1-OLy,sNy+OLy
       DO i=1-OLx,sNx+OLx
        URT(i,j) = 0. _d 0
        CUU(i,j) = 0. _d 0
       ENDDO
      ENDDO
#ifdef SEAICE_LSR_ZEBRA
      DO k=0,1
      jMinLoc = jMin+k
#else
      jMinLoc = jMin
#endif /* SEAICE_LSR_ZEBRA */
      DO j=jMinLoc,jMax,jStep
       DO i=iMin,iMax
        AA3 = 0. _d 0
        IF (i.EQ.iMin) AA3 = AA3 - AU(i,j,bi,bj)*uIce(i-1,j,bi,bj)
        IF (i.EQ.iMax) AA3 = AA3 - CU(i,j,bi,bj)*uIce(i+1,j,bi,bj)

        URT(i,j)=rhsU(i,j,bi,bj)
     &       + AA3
     &       + uRt1(i,j,bi,bj)*uIce(i,j-1,bi,bj)
     &       + uRt2(i,j,bi,bj)*uIce(i,j+1,bi,bj)
        URT(i,j)=URT(i,j)* seaiceMaskU(i,j,bi,bj)
       ENDDO
C     beginning of tridiagnoal solver
       DO i=iMin,iMax
        CUU(i,j)=CU(i,j,bi,bj)
       ENDDO
       CUU(iMin,j)=CUU(iMin,j)/BU(iMin,j,bi,bj)
       URT(iMin,j)=URT(iMin,j)/BU(iMin,j,bi,bj)
#ifdef SEAICE_VECTORIZE_LSR
      ENDDO
C     start a new loop with reversed order to support automatic vectorization
CADJ loop = sequential
      DO i=iMin+1,iMax
       iM=i-1
       DO j=jMinLoc,jMax,jStep
#else /* do not SEAICE_VECTORIZE_LSR */
CADJ loop = sequential
       DO i=iMin+1,iMax
        iM=i-1
#endif /* SEAICE_VECTORIZE_LSR */
        bet      = BU(i,j,bi,bj)-AU(i,j,bi,bj)*CUU(iM,j)
        CUU(i,j) = CUU(i,j)/bet
        URT(i,j) = (URT(i,j)-AU(i,j,bi,bj)*URT(iM,j))/bet
       ENDDO
#ifdef SEAICE_VECTORIZE_LSR
      ENDDO
CADJ loop = sequential
      DO i=iMin,iMax-1
       iM=sNx-i
       DO j=jMinLoc,jMax,jStep
#else
CADJ loop = sequential
       DO i=iMin,iMax-1
        iM=sNx-i
#endif /* SEAICE_VECTORIZE_LSR */
        URT(iM,j)=URT(iM,j)-CUU(iM,j)*URT(iM+1,j)
       ENDDO
#ifdef SEAICE_VECTORIZE_LSR
      ENDDO
#endif /* SEAICE_VECTORIZE_LSR */
C     end of tridiagnoal solver, solution is URT
C     relaxation with WFAU
#ifdef SEAICE_VECTORIZE_LSR
C     go back to original order
      DO j=jMinLoc,jMax,jStep
#endif /* SEAICE_VECTORIZE_LSR */
       DO i=iMin,iMax
        uIce(i,j,bi,bj)=uTmp(i,j,bi,bj)
     &       +WFAU*(URT(i,j)-uTmp(i,j,bi,bj))
       ENDDO
      ENDDO
#ifdef SEAICE_LSR_ZEBRA
      ENDDO
#endif /* SEAICE_LSR_ZEBRA */

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

CBOP
C     !ROUTINE: SEAICE_LSR_TRIDIAGV
C     !INTERFACE:
      SUBROUTINE SEAICE_LSR_TRIDIAGV(
     I     AV, BV, CV, vRt1, vRt2, rhsV, vTmp, seaiceMaskV, WFAV,
     U     vIce,
     I     iMin, iMax, jMin, jMax, bi, bj, myTime, myIter, myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R SEAICE_LSR_TRIDIAGV
C     | o Solve tridiagonal problem in vIce for LSR solver
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"

C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
C     myTime     :: Simulation time
C     myIter     :: Simulation timestep number
C     myThid     :: my Thread Id. number
      _RL     myTime
      INTEGER myIter
      INTEGER myThid
      INTEGER iMin, iMax, jMin, jMax, bi, bj
C     diagonals of coefficient matrices
      _RL AV   (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL BV   (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL CV   (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
C     coefficients for lateral points, v(j+/-1)
      _RL vRt1(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL vRt2(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
C     right hand side
      _RL rhsV (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
C     velocity of previous iteration step
      _RL vTmp(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
C     on entry: first guess and on exit: solution
      _RL vIce(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
C     mask
      _RL seaiceMaskV(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
C     relaxation factor
      _RL WFAV
CEOP

C     !LOCAL VARIABLES:
C     === Local variables ===
C     i,j  :: Loop counters
      INTEGER i,j,jM
      INTEGER iMinLoc, iStep
#ifdef SEAICE_LSR_ZEBRA
      INTEGER k
      PARAMETER ( iStep = 2 )
#else
      PARAMETER ( iStep = 1 )
#endif /* SEAICE_LSR_ZEBRA */
      _RL AA3, bet
      _RL VRT(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL CVV(1-OLx:sNx+OLx,1-OLy:sNy+OLy)

C     Need to initialize local arrays
      DO j=1-OLy,sNy+OLy
       DO i=1-OLx,sNx+OLx
        VRT(i,j) = 0. _d 0
        CVV(i,j) = 0. _d 0
       ENDDO
      ENDDO
#ifdef SEAICE_LSR_ZEBRA
      DO k=0,1
      iMinLoc = iMin+k
#else
      iMinLoc = iMin
#endif /*  SEAICE_LSR_ZEBRA */
#ifdef SEAICE_VECTORIZE_LSR
      DO j=jMin,jMax
       DO i=iMinLoc,iMax,iStep
#else
      DO i=iMinLoc,iMax,iStep
       DO j=jMin,jMax
#endif /* SEAICE_VECTORIZE_LSR */
        AA3 = 0. _d 0
        IF (j.EQ.jMin) AA3 = AA3 - AV(i,j,bi,bj)*vIce(i,j-1,bi,bj)
        IF (j.EQ.jMax) AA3 = AA3 - CV(i,j,bi,bj)*vIce(i,j+1,bi,bj)

        VRT(i,j)=rhsV(i,j,bi,bj)
     &       + AA3
     &       + vRt1(i,j,bi,bj)*vIce(i-1,j,bi,bj)
     &       + vRt2(i,j,bi,bj)*vIce(i+1,j,bi,bj)
        VRT(i,j)=VRT(i,j)* seaiceMaskV(i,j,bi,bj)

C     beginning of tridiagnoal solver
        CVV(i,j)=CV(i,j,bi,bj)
       ENDDO
#ifdef SEAICE_VECTORIZE_LSR
      ENDDO
      DO i=iMinLoc,iMax,iStep
#endif /* SEAICE_VECTORIZE_LSR */
       CVV(i,jMin)=CVV(i,jMin)/BV(i,jMin,bi,bj)
       VRT(i,jMin)=VRT(i,jMin)/BV(i,jMin,bi,bj)
#ifdef SEAICE_VECTORIZE_LSR
      ENDDO
C     start a new loop with reversed order to support automatic vectorization
CADJ loop = sequential
      DO j=jMin+1,jMax
       jM=j-1
       DO i=iMinLoc,iMax,iStep
#else /* do not SEAICE_VECTORIZE_LSR */
CADJ loop = sequential
       DO j=jMin+1,jMax
        jM=j-1
#endif /* SEAICE_VECTORIZE_LSR */
        bet      = BV(i,j,bi,bj)-AV(i,j,bi,bj)*CVV(i,jM)
        CVV(i,j) = CVV(i,j)/bet
        VRT(i,j) = (VRT(i,j)-AV(i,j,bi,bj)*VRT(i,jM))/bet
       ENDDO
#ifdef SEAICE_VECTORIZE_LSR
      ENDDO
C     go back to original order
CADJ loop = sequential
      DO j=jMin,jMax-1
       jM=sNy-j
       DO i=iMinLoc,iMax,iStep
#else
CADJ loop = sequential
       DO j=jMin,jMax-1
        jM=sNy-j
#endif /* SEAICE_VECTORIZE_LSR */
        VRT(i,jM)=VRT(i,jM)-CVV(i,jM)*VRT(i,jM+1)
       ENDDO
#ifdef SEAICE_VECTORIZE_LSR
      ENDDO
C     end of tridiagnoal solver, solution is VRT
C     relaxation with WFAV
      DO j=jMin,jMax
       DO i=iMinLoc,iMax,iStep
#else
       DO j=jMin,jMax
#endif /* SEAICE_VECTORIZE_LSR */
        vIce(i,j,bi,bj)=vTmp(i,j,bi,bj)
     &       +WFAV*(VRT(i,j)-vTmp(i,j,bi,bj))
       ENDDO
      ENDDO
#ifdef SEAICE_LSR_ZEBRA
      ENDDO
#endif /* SEAICE_LSR_ZEBRA */

#endif /* SEAICE_CGRID */

      RETURN
      END

#include "DIAG_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: DIAGNOSTICS_MAIN_INIT

C     !INTERFACE:
      SUBROUTINE DIAGNOSTICS_MAIN_INIT( myThid )

C     !DESCRIPTION:
C     Initialize available diagnostics list for variables of the main code
C     (not part of a package): set the following attributes:
C     name (=cdiag), parsing code (=gdiag), units (=udiag), and title (=tdiag)
C     Notes: 1) diagnostics defined here do not require any EQUIVALENCE
C            since they get filled-in with S/R FILL_DIAGNOSTICS
C            2) GDIAG is defined as character*16 and can be to character*1
C            parse(16) with the following codes currently defined:

C \begin{center}
C   \begin{tabular}[h]{|c|c|}\hline
C     \textbf{Positions} & \textbf{Characters} & \textbf{Meanings} \\\hline
C     parse(1)  &  S  &  scalar \\
C               &  U  &  vector component in X direction \\
C               &  V  &  vector component in Y direction \\
C               &  W  &  vector component in vertical direction \\
C     parse(2)  &  U  &  C-grid U-Point  \\
C               &  V  &  C-grid V-Point  \\
C               &  M  &  C-grid Mass Point  \\
C               &  Z  &  C-grid Corner Point  \\
C     parse(3)  &     &  Used for Level Integrated output: cumulate levels \\
C               &  r  &  same but cumulate product by model level thickness \\
C               &  R  &  same but cumulate product by hFac & level thickness \\
C     parse(4)  &  P  &  positive definite  \\
C               &  A  &  Adjoint variable diagnostics \\
C     parse(5 ) &  C  &  with counter array  \\
C               &  P  &  post-processed (not filled up) from other diags  \\
C               &  D  &  disable an array for output  \\
C     parse(6--8) & '123'  &  retired, formerly: 3-digit mate number \\
C     parse(9)  &  U  &  model-level plus 1/2  \\
C               &  M  &  model-level middle  \\
C               &  L  &  model-level minus 1/2  \\
C     parse(10) &  0  &  levels = 0  \\
C               &  1  &  levels = 1  \\
C               &  R  &  levels = Nr  \\
C               &  L  &  levels = MAX(Nr,NrPhys)  \\
C               &  M  &  levels = MAX(Nr,NrPhys) - 1  \\
C               &  G  &  levels = Ground_level Number \\
C               &  I  &  levels = sea-Ice_level Number \\
C               &  X  &  free levels option (need to be set explicitly) \\
C   \end{tabular}
C \end{center}

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"

C     !INPUT PARAMETERS:
      INTEGER myThid
CEOP

C     !LOCAL VARIABLES:
C     rTitle     :: r-coordinate title
C     eTitle     :: free-surface title
C     fTitle     :: fixed boundary title
C     pTitle     :: "Phi"   title
C     sTitle     :: "salt"  title
C     tTitl1     :: first part of "theta" title
C     tTitl2     :: short "theta" title
      INTEGER        diagNum
      INTEGER        diagMate
      CHARACTER*8    diagName
      CHARACTER*16   diagCode
      CHARACTER*16   diagUnits
      CHARACTER*(80) diagTitle
      CHARACTER*2    rUnit2c
      CHARACTER*4    tUnit4c
      CHARACTER*5    sUnit5c
      CHARACTER*(10) rTitle, eTitle, fTitle, tTitl2
      CHARACTER*(20) pTitle, sTitle, tTitl1

      CHARACTER*(16) DIAGS_MK_UNITS
      EXTERNAL DIAGS_MK_UNITS
      CHARACTER*(80) DIAGS_MK_TITLE
      EXTERNAL DIAGS_MK_TITLE

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C     For each output variable,
C     specify Name (cdiag, 8c), Descriptions (tdiag, *c), Units (udiag, 16c)
C         and Type/Parms (location on C grid, 2D/3D, ...) (gdiag, 16c)
C----------------------------------------------------------------------

      IF ( usingPCoords ) THEN
        rUnit2c= 'Pa'
        rTitle = ' Pressure '
        pTitle = ' Geopotential       '
      ELSE
        rUnit2c= 'm '
        rTitle = ' Height   '
        pTitle = 'Pressure Pot.(p/rho)'
      ENDIF
      IF ( fluidIsAir ) THEN
        tUnit4c= 'K   '
        sUnit5c= 'kg/kg'
        sTitle = ' Specific Humidity  '
        tTitl1 = ' Potential          '
c       tTitl2 = ' Pot.Temp.'
        tTitl2 = ' Pot Temp '
        IF (useAIM) sUnit5c= 'g/kg '
      ELSEIF ( eosType.EQ.'TEOS10' ) THEN
        tUnit4c= 'degC'
        sUnit5c= 'g/kg '
        sTitle = ' Absolute Salinity  '
        tTitl1 = ' Conservative       '
c       tTitl2 = 'Cons.Temp.'
        tTitl2 = 'Cons Temp '
      ELSE
        tUnit4c= 'degC'
        sUnit5c= 'g/kg '
        sTitle = ' Salinity           '
        tTitl1 = ' Potential          '
c       tTitl2 = ' Pot.Temp.'
        tTitl2 = ' Pot Temp '
      ENDIF
C-    free-surface (eTitle) and fixed-boundary (fTitle) position:
      IF ( fluidIsAir ) THEN
        eTitle = ' Surface  '
        fTitle = ' Top      '
      ELSEIF ( usingPCoords ) THEN
        eTitle = ' Bottom   '
        fTitle = ' Surface  '
      ELSE
        eTitle = ' Surface  '
        fTitle = ' Bottom   '
      ENDIF

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C-    state variables of the main code (and related quadratic var):

      diagName  = 'ETAN    '
      diagTitle = DIAGS_MK_TITLE( eTitle//rTitle//' Anomaly', myThid )
c     IF ( fluidIsWater .AND. usingZCoords )
c    &diagTitle = 'Sea Surface Elevation'
      diagUnits = DIAGS_MK_UNITS( rUnit2c, myThid )
      diagCode  = 'SM      M1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'ETANSQ  '
      diagTitle = DIAGS_MK_TITLE( 'Square of '//eTitle//rTitle
     I                          //' Anomaly', myThid )
      diagUnits = DIAGS_MK_UNITS( rUnit2c//'^2', myThid )
      diagCode  = 'SM P    M1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'DETADT2 '
      diagTitle = DIAGS_MK_TITLE( 'Square of '//eTitle//rTitle
     I                          //' Anomaly Tendency', myThid )
      diagUnits = DIAGS_MK_UNITS( rUnit2c//'^2/s^2', myThid )
      diagCode  = 'SM      M1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'THETA   '
      diagTitle = DIAGS_MK_TITLE( tTitl1//' Temperature',  myThid )
      diagUnits = DIAGS_MK_UNITS( tUnit4c, myThid )
      diagCode  = 'SMR     MR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

c     diagName  = 'SST     '
c     diagTitle = 'Sea Surface Temperature (degC,K)'
c     diagUnits = DIAGS_MK_UNITS( tUnit4c, myThid )
c     diagCode  = 'SM      M1      '
c     CALL DIAGNOSTICS_ADDTOLIST( diagNum,
c    I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'SALT    '
      diagTitle = DIAGS_MK_TITLE( sTitle,  myThid )
      diagUnits = DIAGS_MK_UNITS( sUnit5c, myThid )
      diagCode  = 'SMR     MR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'RELHUM  '
      diagTitle = 'Relative Humidity'
      diagUnits = 'percent         '
      diagCode  = 'SMR     MR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

c     diagName  = 'SSS     '
c     diagTitle = 'Sea Surface Salinity '
c     diagUnits = DIAGS_MK_UNITS( sUnit5c, myThid )
c     diagCode  = 'SM      M1      '
c     CALL DIAGNOSTICS_ADDTOLIST( diagNum,
c    I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      IF ( fluidIsWater ) THEN
      diagName  = 'SALTanom'
      diagTitle = 'Salt anomaly (=SALT-35; g/kg)'
      diagUnits = DIAGS_MK_UNITS( sUnit5c, myThid )
      diagCode  = 'SMR     MR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )
      ENDIF

      diagName  = 'UVEL    '
      diagTitle = 'Zonal Component of Velocity (m/s)'
      diagUnits = 'm/s             '
      diagCode  = 'UUR     MR      '
      diagMate  = diagNum + 2
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I   diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

      diagName  = 'VVEL    '
      diagTitle = 'Meridional Component of Velocity (m/s)'
      diagUnits = 'm/s             '
      diagCode  = 'VVR     MR      '
      diagMate  = diagNum
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I   diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

      diagName  = 'WVEL    '
      diagTitle = 'Vertical Component of Velocity (r_units/s)'
      diagUnits = DIAGS_MK_UNITS( rUnit2c//'/s', myThid )
      diagCode  = 'WM      LR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'THETASQ '
      diagTitle = DIAGS_MK_TITLE( 'Square of '
     I                  //tTitl1//' Temperature', myThid )
      diagUnits = DIAGS_MK_UNITS( tUnit4c//'^2', myThid )
      diagCode  = 'SMRP    MR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'SALTSQ  '
      diagTitle = DIAGS_MK_TITLE( 'Square of '//sTitle, myThid )
      diagUnits = DIAGS_MK_UNITS( '('//sUnit5c//')^2', myThid )
      diagCode  = 'SMRP    MR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      IF ( fluidIsWater ) THEN
      diagName  = 'SALTSQan'
      diagTitle = 'Square of Salt anomaly (=(SALT-35)^2 (g^2/kg^2)'
      diagUnits = DIAGS_MK_UNITS( '('//sUnit5c//')^2', myThid )
      diagCode  = 'SMRP    MR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )
      ENDIF

      diagName  = 'UVELSQ  '
      diagTitle = 'Square of Zonal Comp of Velocity (m^2/s^2)'
      diagUnits = 'm^2/s^2         '
      diagCode  = 'UURP    MR      '
      diagMate  = diagNum + 2
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I   diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

      diagName  = 'VVELSQ  '
      diagTitle = 'Square of Meridional Comp of Velocity (m^2/s^2)'
      diagUnits = 'm^2/s^2         '
      diagCode  = 'VVRP    MR      '
      diagMate  = diagNum
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I   diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

      diagName  = 'WVELSQ  '
      diagTitle = 'Square of Vertical Comp of Velocity'
      diagUnits = DIAGS_MK_UNITS( rUnit2c//'^2/s^2', myThid )
      diagCode  = 'WM P    LR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'VSHEARSQ'
      diagTitle = 'Square of Vertical Shear'
     &          //' (horiz. velocity vertical gradient)'
      diagUnits = '1/s^2           '
      IF ( .NOT.usingZCoords )
     &  diagUnits = DIAGS_MK_UNITS( '(m/s/'//rUnit2c//')^2', myThid )
      diagCode  = 'SM P    LR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'UE_VEL_C'
      diagTitle = 'Eastward Velocity (m/s) (cell center)'
      diagUnits = 'm/s             '
      diagCode  = 'UMR     MR      '
      diagMate  = diagNum + 2
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I   diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

      diagName  = 'VN_VEL_C'
      diagTitle = 'Northward Velocity (m/s) (cell center)'
      diagUnits = 'm/s             '
      diagCode  = 'VMR     MR      '
      diagMate  = diagNum
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I   diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

      diagName  = 'UV_VEL_C'
      diagTitle ='Product of horizontal Comp of velocity (cell center)'
      diagUnits = 'm^2/s^2         '
      diagCode  = 'UMR     MR      '
      diagMate  = diagNum + 1
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I   diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

      diagName  = 'UV_VEL_Z'
      diagTitle = 'Meridional Transport of Zonal Momentum (m^2/s^2)'
      diagUnits = 'm^2/s^2         '
      diagCode  = 'UZR     MR      '
      diagMate  = diagNum + 1
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I   diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

      diagName  = 'WU_VEL  '
      diagTitle = 'Vertical Transport of Zonal Momentum'
      diagUnits = DIAGS_MK_UNITS( 'm.'//rUnit2c//'/s^2', myThid )
      diagCode  = 'WU      LR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'WV_VEL  '
      diagTitle ='Vertical Transport of Meridional Momentum'
      diagUnits = DIAGS_MK_UNITS( 'm.'//rUnit2c//'/s^2', myThid )
      diagCode  = 'WV      LR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'UVELMASS'
      diagTitle = 'Zonal Mass-Weighted Comp of Velocity (m/s)'
      diagUnits = 'm/s             '
      diagCode  = 'UUr     MR      '
      diagMate  = diagNum + 2
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I   diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

      diagName  = 'VVELMASS'
      diagTitle = 'Meridional Mass-Weighted Comp of Velocity (m/s)'
      diagUnits = 'm/s             '
      diagCode  = 'VVr     MR      '
      diagMate  = diagNum
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I   diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

      diagName  = 'WVELMASS'
      diagTitle = 'Vertical Mass-Weighted Comp of Velocity'
      diagUnits = DIAGS_MK_UNITS( rUnit2c//'/s', myThid )
      diagCode  = 'WM      LR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'PhiVEL  '
      diagTitle = 'Horizontal Velocity Potential (m^2/s)'
      diagUnits = 'm^2/s           '
      diagCode  = 'SMR P   MR      '
C-    use 'UVELMASS' as mate.
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I   diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

      diagName  = 'PsiVEL  '
      diagTitle = 'Horizontal Velocity Stream-Function'
      diagUnits = DIAGS_MK_UNITS( rUnit2c//'.m^2/s', myThid )
      diagCode  = 'SZ  P   MR      '
C-    use 'PhiVEL' as mate.
      diagMate  = diagNum
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I   diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

      diagName  = 'UTHMASS '
      diagTitle = DIAGS_MK_TITLE( 'Zonal Mass-Weight Transp of '
     I                           //tTitl2, myThid )
      diagUnits = DIAGS_MK_UNITS( tUnit4c//'.m/s', myThid )
      diagCode  = 'UUr     MR      '
      diagMate  = diagNum + 2
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I   diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

      diagName  = 'VTHMASS '
      diagTitle = DIAGS_MK_TITLE( 'Meridional Mass-Weight Transp of '
     I                           //tTitl2, myThid )
      diagUnits = DIAGS_MK_UNITS( tUnit4c//'.m/s', myThid )
      diagCode  = 'VVr     MR      '
      diagMate  = diagNum
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I   diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

      diagName  = 'WTHMASS '
      diagTitle = DIAGS_MK_TITLE( 'Vertical Mass-Weight Transp of '
     I                           //tTitl2, myThid )
      diagUnits = DIAGS_MK_UNITS(tUnit4c//'.'//rUnit2c//'/s', myThid )
      diagCode  = 'WM      LR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'USLTMASS'
      diagTitle = DIAGS_MK_TITLE( 'Zonal Mass-Weight Transp of '
     I                           //sTitle, myThid )
      diagUnits = DIAGS_MK_UNITS(sUnit5c//'.m/s', myThid )
      diagCode  = 'UUr     MR      '
      diagMate  = diagNum + 2
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I   diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

      diagName  = 'VSLTMASS'
      diagTitle = DIAGS_MK_TITLE( 'Meridional Mass-Weight Transp of '
     I                           //sTitle, myThid )
      diagUnits = DIAGS_MK_UNITS(sUnit5c//'.m/s', myThid )
      diagCode  = 'VVr     MR      '
      diagMate  = diagNum
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I   diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

      diagName  = 'WSLTMASS'
      diagTitle = DIAGS_MK_TITLE( 'Vertical Mass-Weight Transp of '
     I                           //sTitle, myThid )
      diagUnits = DIAGS_MK_UNITS(sUnit5c//'.'//rUnit2c//'/s', myThid )
      diagCode  = 'WM      LR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'UVELTH  '
      diagTitle = DIAGS_MK_TITLE( 'Zonal Transport of '
     I                          //tTitl2, myThid )
      diagUnits = DIAGS_MK_UNITS( tUnit4c//'.m/s', myThid )
      diagCode  = 'UUR     MR      '
      diagMate  = diagNum + 2
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I   diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

      diagName  = 'VVELTH  '
      diagTitle = DIAGS_MK_TITLE( 'Meridional Transport of '
     I                          //tTitl2, myThid )
      diagUnits = DIAGS_MK_UNITS( tUnit4c//'.m/s', myThid )
      diagCode  = 'VVR     MR      '
      diagMate  = diagNum
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I   diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

      diagName  = 'WVELTH  '
      diagTitle = DIAGS_MK_TITLE( 'Vertical Transport of '
     I                          //tTitl2, myThid )
      diagUnits = DIAGS_MK_UNITS(tUnit4c//'.'//rUnit2c//'/s', myThid )
      diagCode  = 'WM      LR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'UVELSLT '
      diagTitle = DIAGS_MK_TITLE( 'Zonal Transport of '
     I                          //sTitle, myThid )
      diagUnits = DIAGS_MK_UNITS( sUnit5c//'.m/s', myThid )
      diagCode  = 'UUR     MR      '
      diagMate  = diagNum + 2
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I   diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

      diagName  = 'VVELSLT '
      diagTitle = DIAGS_MK_TITLE( 'Meridional Transport of '
     I                          //sTitle, myThid )
      diagUnits = DIAGS_MK_UNITS( sUnit5c//'.m/s', myThid )
      diagCode  = 'VVR     MR      '
      diagMate  = diagNum
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I   diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

      diagName  = 'WVELSLT '
      diagTitle = DIAGS_MK_TITLE( 'Vertical Transport of '
     I                          //sTitle, myThid )
      diagUnits = DIAGS_MK_UNITS(sUnit5c//'.'//rUnit2c//'/s', myThid )
      diagCode  = 'WM      LR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'UVELPHI '
      diagTitle = DIAGS_MK_TITLE( 'Zonal Mass-Weight Transp of '
     I                 //pTitle//' Anomaly', myThid )
      diagUnits = 'm^3/s^3         '
      diagCode  = 'UUr     MR      '
      diagMate  = diagNum + 2
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I   diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

      diagName  = 'VVELPHI '
      diagTitle = DIAGS_MK_TITLE( 'Merid. Mass-Weight Transp of '
     I                 //pTitle//' Anomaly', myThid )
      diagUnits = 'm^3/s^3         '
      diagCode  = 'VVr     MR      '
      diagMate  = diagNum
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I   diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      diagName  = 'RHOAnoma'
      diagTitle = 'Density Anomaly (=Rho-rhoConst)'
      diagUnits = 'kg/m^3          '
      diagCode  = 'SMR     MR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'RHOANOSQ'
      diagTitle = 'Square of Density Anomaly (=(Rho-rhoConst)^2)'
      diagUnits = 'kg^2/m^6        '
      diagCode  = 'SMRP    MR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'URHOMASS'
      diagTitle = 'Zonal Transport of Density'
      diagUnits = 'kg/m^2/s        '
      diagCode  = 'UUr     MR      '
      diagMate  = diagNum + 2
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I   diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

      diagName  = 'VRHOMASS'
      diagTitle = 'Meridional Transport of Density'
      diagUnits = 'kg/m^2/s        '
      diagCode  = 'VVr     MR      '
      diagMate  = diagNum
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I   diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

      diagName  = 'WRHOMASS'
      diagTitle = 'Vertical Transport of Density'
      diagUnits = 'kg/m^2/s        '
      diagCode  = 'WM      LR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'WdRHO_P '
      diagTitle = 'Vertical velocity times delta^k(Rho)_at-const-P'
      diagUnits = 'kg/m^2/s        '
      diagCode  = 'WM      LR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'WdRHOdP '
      diagTitle = 'Vertical velocity times delta^k(Rho)_at-const-T,S'
      diagUnits = 'kg/m^2/s        '
      diagCode  = 'WM      LR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'PHIHYD  '
      diagTitle = DIAGS_MK_TITLE( 'Hydrostatic '
     I                           //pTitle//' Anomaly', myThid )
      diagUnits = 'm^2/s^2         '
      diagCode  = 'SMR     MR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'PHIHYDSQ'
      diagTitle = DIAGS_MK_TITLE( 'Square of Hyd. '
     I                           //pTitle//' Anomaly', myThid )
      diagUnits = 'm^4/s^4         '
      diagCode  = 'SMRP    MR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'PHIBOT  '
c     diagTitle = 'ocean bottom pressure / top. atmos geo-Potential'
      diagTitle = DIAGS_MK_TITLE( fTitle
     I                           //pTitle//' Anomaly', myThid )
      diagUnits = 'm^2/s^2         '
      diagCode  = 'SM      M1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'PHIBOTSQ'
c     diagTitle = 'Square of ocean bottom pressure / top. geo-Potential'
      diagTitle = DIAGS_MK_TITLE( 'Square of '//fTitle
     I                           //pTitle//' Anomaly', myThid )
      diagUnits = 'm^4/s^4         '
      diagCode  = 'SM P    M1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'PHI_SURF'
      diagTitle = DIAGS_MK_TITLE('Surface Dynamical '//pTitle,myThid)
      diagUnits = 'm^2/s^2         '
      diagCode  = 'SM      M1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

#ifdef NONLIN_FRSURF
      diagName  = 'PHIHYDcR'
      diagTitle = DIAGS_MK_TITLE( 'Hydrostatic '
     I                       //pTitle//' Anomaly @ const r', myThid )
      diagUnits = 'm^2/s^2         '
      diagCode  = 'SMR     MR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )
#endif

#ifdef ALLOW_NONHYDROSTATIC
      diagName  = 'PHI_NH  '
      diagTitle = DIAGS_MK_TITLE( 'Non-Hydrostatic '//pTitle, myThid )
      diagUnits = 'm^2/s^2         '
      diagCode  = 'SMR     MR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )
#endif /* ALLOW_NONHYDROSTATIC */

      diagName  = 'MXLDEPTH'
      diagTitle = 'Mixed-Layer Depth (>0)'
      diagUnits = 'm               '
      diagCode  = 'SM      M1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'DRHODR  '
      diagTitle = 'Stratification: d.Sigma/dr (kg/m3/r_unit)'
      diagUnits = 'kg/m^4          '
      IF ( usingPCoords ) diagUnits = 's^2/m^2         '
      diagCode  = 'SM      LR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'CONVADJ '
      diagTitle = 'Convective Adjustment Index [0-1] '
      diagUnits = 'fraction        '
      diagCode  = 'SMR     LR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      IF ( fluidIsWater ) THEN
       diagName  = 'GCM_SST '
       diagTitle = 'Ocean model Sea Surface Temperature (degC)'
       diagUnits = 'degC            '
       diagCode  = 'SM      M1      '
       CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )
      ENDIF

C--   surface fluxes:
      diagName  = 'oceTAUX '
      diagTitle = 'zonal surface wind stress'
     &          //' (+=down), >0 increases uVel'
      diagUnits = 'N/m^2           '
      diagCode  = 'UU      U1      '
      diagMate  = diagNum + 2
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I   diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

      diagName  = 'oceTAUY '
      diagTitle = 'meridional surf. wind stress'
     &          //' (+=down), >0 increases vVel'
      diagUnits = 'N/m^2           '
      diagCode  = 'VV      U1      '
      diagMate  = diagNum
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I   diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

      diagName  = 'atmPload'
      diagTitle = 'Atmospheric pressure loading anomaly (vs surf_pRef)'
      diagUnits = 'Pa              '
      diagCode  = 'SM      U1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'sIceLoad'
      diagTitle = 'sea-ice loading (in Mass of ice+snow / area unit)'
      diagUnits = 'kg/m^2          '
      diagCode  = 'SM      U1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'oceFWflx'
      diagTitle = 'net surface Fresh-Water flux into the ocean'
     &          //' (+=down), >0 decreases salinity'
      diagUnits = 'kg/m^2/s        '
      diagCode  = 'SM      U1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'oceSflux'
      diagTitle = 'net surface Salt flux into the ocean (+=down),'
     &          //' >0 increases salinity'
      diagUnits = 'g/m^2/s         '
      diagCode  = 'SM      U1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'oceQnet '
      diagTitle = 'net surface heat flux into the ocean (+=down),'
     &          //' >0 increases theta'
      diagUnits = 'W/m^2           '
      diagCode  = 'SM      U1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'oceQsw  '
      diagTitle = 'net Short-Wave radiation (+=down),'
     &          //' >0 increases theta'
      diagUnits = 'W/m^2           '
      diagCode  = 'SM      U1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'oceFreez'
      diagTitle = 'implied heating from increasing theta'
     &          //' up to freezing point (allowFreezing=T)'
      diagUnits = 'W/m^2           '
      diagCode  = 'SM      U1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'TRELAX  '
      diagTitle = 'surface temperature relaxation, >0 increases theta'
      diagUnits = 'W/m^2           '
      diagCode  = 'SM      U1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'SRELAX  '
      diagTitle = 'surface salinity relaxation, >0 increases salt'
      diagUnits = 'g/m^2/s         '
      diagCode  = 'SM      U1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'surForcT'
      diagTitle = 'model surface forcing for Temperature,'
     &          //' >0 increases theta'
      diagUnits = 'W/m^2           '
      diagCode  = 'SM      U1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'surForcS'
      diagTitle = 'model surface forcing for Salinity,'
     &          //' >0 increases salinity'
      diagUnits = 'g/m^2/s         '
      diagCode  = 'SM      U1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'TFLUX   '
      diagTitle = 'total heat flux (matches heat-content variations,'
     &          //' +=down), >0 increases theta'
      diagUnits = 'W/m^2           '
      diagCode  = 'SM      U1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'SFLUX   '
      diagTitle = 'total salt flux (matches salt-content variations,'
     &          //' +=down), >0 increases salt'
      diagUnits = 'g/m^2/s         '
      diagCode  = 'SM      U1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      diagName  = 'RCENTER '
c     diagTitle = 'Cell-Center r-Position (Pressure, Height) (Pa,m)'
      diagTitle = DIAGS_MK_TITLE( 'Cell-Center '//rTitle, myThid )
      diagUnits = DIAGS_MK_UNITS( rUnit2c, myThid )
      diagCode  = 'SM      MR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'RSURF   '
c     diagTitle = 'Free-Surface r-Position (Pressure, Height) (Pa,m)'
      diagTitle = DIAGS_MK_TITLE( eTitle//rTitle, myThid )
      diagUnits = DIAGS_MK_UNITS( rUnit2c, myThid )
      diagCode  = 'SM      M1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      IF ( nonlinFreeSurf.GT.0 ) THEN
       diagName  = 'hFactorC'
       diagTitle = 'Center cell-thickness fraction [-]'
       diagUnits = '1               '
       diagCode  = 'SMr     MR      '
       CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

       diagName  = 'hFactorW'
       diagTitle = 'Western-Edge cell-thickness fraction [-]'
       diagUnits = '1               '
       diagCode  = 'SUr     MR      '
       diagMate  = diagNum + 2
       CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I   diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

       diagName  = 'hFactorS'
       diagTitle = 'Southern-Edge cell-thickness fraction [-]'
       diagUnits = '1               '
       diagCode  = 'SVr     MR      '
       diagMate  = diagNum
       CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I   diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )
      ENDIF

      diagName  = 'TOTUTEND'
      diagTitle = 'Tendency of Zonal Component of Velocity'
      diagUnits = 'm/s/day         '
      diagCode  = 'UUR     MR      '
      diagMate  = diagNum + 2
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I   diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

      diagName  = 'TOTVTEND'
      diagTitle = 'Tendency of Meridional Component of Velocity'
      diagUnits = 'm/s/day         '
      diagCode  = 'VVR     MR      '
      diagMate  = diagNum
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I   diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

      diagName  = 'TOTTTEND'
      diagTitle = DIAGS_MK_TITLE( 'Tendency of '
     I                  //tTitl1//' Temperature', myThid )
      diagUnits = DIAGS_MK_UNITS( tUnit4c//'/day', myThid )
      diagCode  = 'SMR     MR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'TOTSTEND'
      diagTitle = DIAGS_MK_TITLE('Tendency of '//sTitle, myThid )
      diagUnits = DIAGS_MK_UNITS( sUnit5c//'/day', myThid )
      diagCode  = 'SMR     MR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'MoistCor'
      diagTitle = 'Heating correction due to moist thermodynamics'
      diagUnits = 'W/m^2           '
      diagCode  = 'SM      MR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

#ifdef ALLOW_FRICTION_HEATING
      diagName  = 'HeatDiss'
      diagTitle = 'Heating from frictional dissipation'
      diagUnits = 'W/m^2           '
      diagCode  = 'SM      MR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )
#endif /* ALLOW_FRICTION_HEATING */

#ifdef ALLOW_GENERIC_ADVDIFF
      diagName  = 'gT_Forc '
      diagTitle = DIAGS_MK_TITLE( tTitl1//' Temp. '
     I                  //'forcing tendency', myThid )
      diagUnits = DIAGS_MK_UNITS( tUnit4c//'/s', myThid )
      diagCode  = 'SMR     MR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'gS_Forc '
      diagTitle = DIAGS_MK_TITLE( sTitle
     &                  //'forcing tendency', myThid )
      diagUnits = DIAGS_MK_UNITS( sUnit5c//'/s', myThid )
      diagCode  = 'SMR     MR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'AB_gT   '
      diagTitle = DIAGS_MK_TITLE( tTitl1//' Temp. '
     I                  //'tendency from Adams-Bashforth', myThid )
      diagUnits = DIAGS_MK_UNITS( tUnit4c//'/s', myThid )
      diagCode  = 'SMR     MR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'AB_gS   '
      diagTitle = DIAGS_MK_TITLE( sTitle
     &                  //'tendency from Adams-Bashforth', myThid )
      diagUnits = DIAGS_MK_UNITS( sUnit5c//'/s', myThid )
      diagCode  = 'SMR     MR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'gTinAB  '
      diagTitle = DIAGS_MK_TITLE( tTitl1//' Temp. '
     I                  //'tendency going in Adams-Bashforth', myThid )
      diagUnits = DIAGS_MK_UNITS( tUnit4c//'/s', myThid )
      diagCode  = 'SMR     MR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'gSinAB  '
      diagTitle = DIAGS_MK_TITLE( sTitle
     &                  //'tendency going in Adams-Bashforth', myThid )
      diagUnits = DIAGS_MK_UNITS( sUnit5c//'/s', myThid )
      diagCode  = 'SMR     MR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )
#endif /* ALLOW_GENERIC_ADVDIFF */

      diagName  = 'AB_gU   '
      diagTitle = 'U momentum tendency from Adams-Bashforth'
      diagUnits = 'm/s^2           '
      diagCode  = 'UUR     MR      '
      diagMate  = diagNum + 2
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I   diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

      diagName  = 'AB_gV   '
      diagTitle = 'V momentum tendency from Adams-Bashforth'
      diagUnits = 'm/s^2           '
      diagCode  = 'VVR     MR      '
      diagMate  = diagNum
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I   diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

#ifdef ALLOW_NONHYDROSTATIC
      diagName  = 'AB_gW   '
      diagTitle = 'W momentum tendency from Adams-Bashforth'
      diagUnits = DIAGS_MK_UNITS( rUnit2c//'/s^2', myThid )
      diagCode  = 'WM      LR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )
#endif /* ALLOW_NONHYDROSTATIC */

#ifdef ALLOW_EDDYPSI
      diagName  = 'TAUXEDDY'
      diagTitle = 'Zonal Eddy Stress'
      diagUnits = 'N/m^2           '
      diagCode  = 'UU      LR      '
      diagMate  = diagNum + 2
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I   diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

      diagName  = 'TAUYEDDY'
      diagTitle = 'Meridional Eddy Stress'
      diagUnits = 'N/m^2           '
      diagCode  = 'VV      LR      '
      diagMate  = diagNum
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I   diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

# ifdef ALLOW_GMREDI
      diagName  = 'U_EulerM'
      diagTitle = 'Zonal Eulerian-Mean Velocity (m/s)'
      diagUnits = 'm/s             '
      diagCode  = 'UUR     MR      '
      diagMate  = diagNum + 2
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I   diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

      diagName  = 'V_EulerM'
      diagTitle = 'Meridional Eulerian-Mean Velocity (m/s)'
      diagUnits = 'm/s             '
      diagCode  = 'VVR     MR      '
      diagMate  = diagNum
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I   diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )
# endif /* ALLOW_GMREDI */
#endif /* ALLOW_EDDYPSI */

#ifdef INCLUDE_SOUNDSPEED_CALC_CODE
      diagName  = 'CSound  '
      diagTitle = 'Speed of sound in seawater'
      diagUnits = 'm/s             '
      diagCode  = 'SMR     MR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )
#endif

#ifdef ALLOW_AUTODIFF
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C     Adjoint state variables

      diagName  = 'ADJetan '
      diagTitle = 'dJ/dEtaN: Sensitivity to sea surface height anomaly'
      diagUnits = 'dJ/m            '
      diagCode  = 'SM A    M1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'ADJuvel '
      diagTitle = 'dJ/dU: Sensitivity to zonal velocity'
      diagUnits = 'dJ/(m/s)        '
      diagCode  = 'UURA    MR      '
      diagMate  = diagNum + 2
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I   diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

      diagName  = 'ADJvvel '
      diagTitle = 'dJ/dV: Sensitivity to meridional velocity'
      diagUnits = 'dJ/(m/s)        '
      diagCode  = 'VVRA    MR      '
      diagMate  = diagNum
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I   diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

      diagName  = 'ADJwvel '
      diagTitle = 'dJ/dW: Sensitivity to vertical velocity'
      diagUnits = 'dJ/(m/s)        '
      diagCode  = 'WM A    LR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'ADJtheta'
      diagTitle = 'dJ/dTheta: Sensitivity to potential temperature'
      diagUnits = 'dJ/degC         '
      diagCode  = 'SMRA    MR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'ADJsalt '
      diagTitle = 'dJ/dSalt: Sensitivity to salinity'
      diagUnits = DIAGS_MK_UNITS( 'dJ/('//sUnit5c//')', myThid )
      diagCode  = 'SMRA    MR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

C--   surface fluxes:
      diagName  = 'ADJtaux '
      diagTitle = 'dJ/dTaux: Senstivity to zonal surface wind stress'
      diagUnits = 'dJ/(N/m^2)      '
      diagCode  = 'UU A    U1      '
      diagMate  = diagNum + 2
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I   diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

      diagName  = 'ADJtauy '
      diagTitle = 'dJ/dTauy: Sensitivity to merid. surface wind stress'
      diagUnits = 'dJ/(N/m^2)      '
      diagCode  = 'VV A    U1      '
      diagMate  = diagNum
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I   diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

      diagName  = 'ADJempmr'
      diagTitle = 'dJ/dEmPmR: Sensitivity to net surface freshwater'
     &          //' flux'
      diagUnits = 'dJ/(kg/m^2/s)   '
      diagCode  = 'SM A    U1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'ADJqnet'
      diagTitle = 'dJ/dQnet: Sensitivity to net surface heat flux'
      diagUnits = 'dJ/(W/m^2)      '
      diagCode  = 'SM A    U1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'ADJqsw'
      diagTitle = 'dJ/dQsw: Sensitivitiy to net Short-Wave radiation'
      diagUnits = 'dJ/(W/m^2)      '
      diagCode  = 'SM A    U1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'ADJsst'
      diagTitle = 'dJ/dSST: Sensitivity to Sea Surface Temperature'
      diagUnits = 'dJ/K'
      diagCode  = 'SM A    M1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'ADJsss'
      diagTitle = 'dJ/dSSS: Sensitivity to Sea Surface Salinity'
      diagUnits = DIAGS_MK_UNITS( 'dJ/('//sUnit5c//')', myThid )
      diagCode  = 'SM A    M1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

C Miscellanious
      diagName  = 'ADJbtdrg'
      diagTitle = 'dJ/dCd: Sensitivity to bottom drag coefficient'
      diagUnits = 'dJ/d()'
      diagCode  = 'SM A    M1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'ADJdifkr'
      diagTitle = 'dJ/dKr: Sensitivity to vertical diffusivity'
      diagUnits = 'dJ/d(m^2/s))'
      diagCode  = 'SMRA    MR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'ADJepsix'
      diagTitle = 'dJ/dEddyPsiX: Sensitivity to zonal eddy'
     &           //'streamfunction'
      diagUnits = 'dJ/(m^2/s)      '
      diagCode  = 'UURA    UR      '
      diagMate  = diagNum + 2
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I   diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

      diagName  = 'ADJepsiy'
      diagTitle = 'dJ/dEddyPsiY: Sensitivity to meridional eddy'
     &           //'streamfunction'
      diagUnits = 'dJ/(m^2/s)      '
      diagCode  = 'VVRA    UR      '
      diagMate  = diagNum
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I   diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )
#endif /* ALLOW_AUTODIFF */

      RETURN
      END

#include "STREAMICE_OPTIONS.h"
#ifdef ALLOW_AUTODIFF
# include "AUTODIFF_OPTIONS.h"
#endif

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

CBOP
      SUBROUTINE STREAMICE_GET_VEL_RESID_ERR ( err_max,
#ifdef ALLOW_AUTODIFF_TAMC
     I     ikey_nl,
#endif
     I     myThid )
C     /============================================================\
C     | SUBROUTINE                                                 |
C     | o                                                          |
C     |============================================================|
C     |                                                            |
C     \============================================================/
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "STREAMICE.h"
#include "STREAMICE_CG.h"

C     !INPUT/OUTPUT ARGUMENTS
      _RL err_max
#ifdef ALLOW_AUTODIFF_TAMC
      INTEGER ikey_nl
#endif
      INTEGER myThid

#ifdef ALLOW_STREAMICE

      INTEGER i, j, bi, bj

      _RL err_tempu, err_tempv
      _RL err_sum
      _RL err_sum_tile (nSx,nSy)

        err_max = 0. _d 0
        err_sum = 0. _d 0

        DO bj = myByLo(myThid), myByHi(myThid)
         DO bi = myBxLo(myThid), myBxHi(myThid)
          err_sum_tile(bi,bj) = 0. _d 0
         ENDDO
        ENDDO

        DO bj = myByLo(myThid), myByHi(myThid)
         DO bi = myBxLo(myThid), myBxHi(myThid)
          DO j=1,sNy
           DO i=1,sNx
            Au_SI (i,j,bi,bj) = 0. _d 0
            Av_SI (i,j,bi,bj) = 0. _d 0
            ubd_SI (i,j,bi,bj) = 0. _d 0
            vbd_SI (i,j,bi,bj) = 0. _d 0
           ENDDO
          ENDDO
         ENDDO
        ENDDO

        CALL STREAMICE_CG_BOUND_VALS( myThid,
     O    ubd_SI,
     O    vbd_SI)

        CALL STREAMICE_CG_ACTION( myThid,
     O    Au_SI,
     O    Av_SI,
     I    U_streamice,
     I    V_streamice,
     I    0, sNx+1, 0, sNy+1 )

       IF (streamice_err_norm .LT. 1.0) then

        DO bj = myByLo(myThid), myByHi(myThid)
         DO bi = myBxLo(myThid), myBxHi(myThid)
          DO j=1,sNy
           DO i=1,sNx
#ifdef ALLOW_AUTODIFF_TAMC
!$TAF STORE err_max = comlev1_stream_nl, key=ikey_nl
#endif
            err_tempu = 0. _d 0
            err_tempv = 0. _d 0
            IF (STREAMICE_umask(i,j,bi,bj).eq.1) THEN
             err_tempu =
     &        ABS (Au_SI(i,j,bi,bj)+0*ubd_SI(i,j,bi,bj) -
     &            taudx_SI(i,j,bi,bj))
            ENDIF
            IF (STREAMICE_vmask(i,j,bi,bj).eq.1) THEN
             err_tempv = MAX( err_tempu,
     &        ABS (Av_SI(i,j,bi,bj)+0*vbd_SI(i,j,bi,bj) -
     &            taudy_SI(i,j,bi,bj)))
            ENDIF
            IF (err_tempv .ge. err_max) THEN
             err_max = err_tempv
            ENDIF
           ENDDO
          ENDDO
         ENDDO
        ENDDO

        CALL GLOBAL_MAX_R8 (err_max, myThid)

       ELSE

        DO bj = myByLo(myThid), myByHi(myThid)
         DO bi = myBxLo(myThid), myBxHi(myThid)
          DO j=1,sNy
           DO i=1,sNx

            IF (STREAMICE_umask(i,j,bi,bj).eq.1) THEN
             err_sum_tile(bi,bj) = err_sum_tile(bi,bj) +
     &        (ABS (Au_SI(i,j,bi,bj)+0*ubd_SI(i,j,bi,bj) -
     &            taudx_SI(i,j,bi,bj))) ** streamice_err_norm
            ENDIF
            IF (STREAMICE_vmask(i,j,bi,bj).eq.1) THEN
             err_sum_tile(bi,bj) = err_sum_tile(bi,bj) +
     &        (ABS (Av_SI(i,j,bi,bj)+0*vbd_SI(i,j,bi,bj) -
     &            taudy_SI(i,j,bi,bj))) ** streamice_err_norm
            ENDIF

           ENDDO
          ENDDO
         ENDDO
        ENDDO

        CALL GLOBAL_SUM_TILE_RL( err_sum_tile, err_sum, myThid )

        err_max = err_sum ** (1./streamice_err_norm)

       ENDIF

#endif
      RETURN
      END

#include "MOM_FLUXFORM_OPTIONS.h"

CBOP
C !ROUTINE: MOM_V_ADV_VV

C !INTERFACE: ==========================================================
      SUBROUTINE MOM_V_ADV_VV(
     I        bi,bj,k,
     I        vTrans, vFld,
     O        AdvectFluxVV,
     I        myThid)

C !DESCRIPTION:
C Calculates the meridional advective flux of meridional momentum:
C \begin{equation*}
C F^y = \overline{V}^j \overline{v}^{j}
C \end{equation*}

C !USES: ===============================================================
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"

C !INPUT PARAMETERS: ===================================================
C  bi,bj                :: tile indices
C  k                    :: vertical level
C  vTrans               :: meridional transport
C  vFld                 :: meridional flow
C  myThid               :: thread number
      INTEGER bi,bj,k
      _RL vTrans(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL vFld(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER myThid

C !OUTPUT PARAMETERS: ==================================================
C  AdvectFluxVV         :: advective flux
      _RL AdvectFluxVV(1-OLx:sNx+OLx,1-OLy:sNy+OLy)

C !LOCAL VARIABLES: ====================================================
C  i,j                  :: loop indices
      INTEGER i,j
CEOP

      DO j=1-Oly,sNy+Oly-1
       DO i=1-Olx,sNx+Olx-1
        AdvectFluxVV(i,j) =
     &  0.25*( vTrans(i,j) + vTrans(i,j+1) )
#ifdef MOM_BOUNDARY_CONSERVE
     &      *(   vFld(i,j)*_maskS(i,j+1,k,bi,bj)
     &         + vFld(i,j+1)*_maskS(i,j,k,bi,bj) )
#else
     &      *(   vFld(i,j) +   vFld(i,j+1) )
#endif
       ENDDO
      ENDDO

      RETURN
      END

#include "ICEFRONT_OPTIONS.h"

      SUBROUTINE ICEFRONT_CHECK( myThid )
C     /==========================================================\
C     | SUBROUTINE ICEFRONT_CHECK                                |
C     | o Validate basic package setup and inter-package         |
C     | dependencies.                                            |
C     \==========================================================/
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "ICEFRONT.h"

C     === Routine arguments ===
C     myThid -  Number of this instance of ICEFRONT_CHECK
      INTEGER myThid

#ifdef ALLOW_ICEFRONT

C     === Local variables ===
C     msgBuf      - Informational/error meesage buffer
      CHARACTER*(MAX_LEN_MBUF) msgBuf

      _BEGIN_MASTER(myThid)

      WRITE(msgBuf,'(A)') 'ICEFRONT_CHECK: #define ALLOW_ICEFRONT'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &     SQUEEZE_RIGHT, myThid )

C     So far, ICEFRONT works only with oceanic z-coordinates
      IF ( buoyancyRelation .NE. 'OCEANIC' ) THEN
         WRITE(msgBuf,'(A)')
     &      'ICEFRONT works only with buoyancyRelation = ''OCEANIC'''
         CALL PRINT_ERROR( msgBuf, myThid )
         STOP 'ABNORMAL END: S/R ICEFRONT_CHECK'
      ENDIF


CML#ifdef ALLOW_NONHYDROSTATIC
CML      IF ( nonHydrostatic ) THEN
CML         WRITE(msgBuf,'(A)')
CML     &      'Currently ICEFRONT and nonHydrostatic cannot be turned'
CML         CALL PRINT_ERROR( msgBuf , 1)
CML         WRITE(msgBuf,'(A)') 'on at the same time'
CML         CALL PRINT_ERROR( msgBuf , 1)
CML         STOP 'ABNORMAL END: S/R ICEFRONT_CHECK'
CML      ENDIF
CML#endif /* ALLOW_NONHYDROSTATIC */

      _END_MASTER(myThid)

#endif /* ALLOW_ICEFRONT */

      RETURN
      END

#include "THSICE_OPTIONS.h"

CBOP
C     !ROUTINE: THSICE_DIAGNOSTICS_STATE
C     !INTERFACE:
      SUBROUTINE THSICE_DIAGNOSTICS_STATE(
     I                              myTime, myIter, myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R  THSICE_DIAGNOSTICS_STATE
C     | o fill-in diagnostics array for THSICE state variables
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
c #include "FFIELDS.h"
#include "THSICE_PARAMS.h"
#include "THSICE_VARS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine Arguments ==
C     myTime  :: time counter for this thread
C     myIter  :: iteration counter for this thread
C     myThid  :: thread number for this instance of the routine.
      _RL  myTime
      INTEGER myIter
      INTEGER myThid
CEOP

#ifdef ALLOW_DIAGNOSTICS
C     !FUNCTIONS:
      LOGICAL  DIAGNOSTICS_IS_ON
      EXTERNAL DIAGNOSTICS_IS_ON

C     !LOCAL VARIABLES:
C     == Local variables ==
C     bi,bj   :: tile indices
      INTEGER bi,bj
      INTEGER i,j
      _RL tmpFld(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL tmpFac

      IF ( useDiagnostics ) THEN

        CALL DIAGNOSTICS_FILL( iceMask,'SI_Fract', 0,1, 0,1,1,myThid )
        CALL DIAGNOSTICS_FILL( snowAge,'SIsnwAge', 0,1, 0,1,1,myThid )

C-     Ice-fraction weighted quantities:
        tmpFac = 1. _d 0
        CALL DIAGNOSTICS_FRACT_FILL(
     I                   iceHeight, iceMask,tmpFac,1,'SI_Thick',
     I                   0,1, 0,1,1,myThid )
        CALL DIAGNOSTICS_FRACT_FILL(
     I                   snowHeight,iceMask,tmpFac,1,'SI_SnowH',
     I                   0,1, 0,1,1,myThid )
        CALL DIAGNOSTICS_FRACT_FILL(
     I                   Tsrf,      iceMask,tmpFac,1,'SI_Tsrf ',
     I                   0,1, 0,1,1,myThid )
        CALL DIAGNOSTICS_FRACT_FILL(
     I                   Tice1,     iceMask,tmpFac,1,'SI_Tice1',
     I                   0,1, 0,1,1,myThid )
        CALL DIAGNOSTICS_FRACT_FILL(
     I                   Tice2,     iceMask,tmpFac,1,'SI_Tice2',
     I                   0,1, 0,1,1,myThid )

C-     Ice-Volume weighted quantities:
       IF ( DIAGNOSTICS_IS_ON('SI_Qice1',myThid) .OR.
     &      DIAGNOSTICS_IS_ON('SI_Qice2',myThid) ) THEN
        DO bj=myByLo(myThid),myByHi(myThid)
         DO bi=myBxLo(myThid),myBxHi(myThid)
C     Initialise the entire tmpFld to avoid surprises in
C     S/R diagstats_calc with TARGET_NEC_SX defined
          DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
c         DO j=1,sNy
c          DO i=1,sNx
            tmpFld(i,j) = iceMask(i,j,bi,bj)*iceHeight(i,j,bi,bj)
           ENDDO
          ENDDO
          CALL DIAGNOSTICS_FRACT_FILL(
     I                     Qice1(1-OLx,1-OLy,bi,bj),
     I                     tmpFld, tmpFac, 1, 'SI_Qice1',
     I                     0,1, 2,bi,bj, myThid )
          CALL DIAGNOSTICS_FRACT_FILL(
     I                     Qice2(1-OLx,1-OLy,bi,bj),
     I                     tmpFld, tmpFac, 1, 'SI_Qice2',
     I                     0,1, 2,bi,bj, myThid )
         ENDDO
        ENDDO
       ENDIF

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C-- Ocean Mixed-Layer temp. & salinity
       IF ( stepFwd_oceMxL ) THEN
        CALL DIAGNOSTICS_FILL( tOceMxL,'SItOcMxL', 0,1, 0,1,1,myThid )
        CALL DIAGNOSTICS_FILL( sOceMxL,'SIsOcMxL', 0,1, 0,1,1,myThid )
       ENDIF

      ENDIF
#endif /* ALLOW_DIAGNOSTICS */

      RETURN
      END

#include "CPP_OPTIONS.h"

CStartOfInterface
      SUBROUTINE CPL_REGISTER_OCN
C     /==========================================================\
C     | SUBROUTINE CPL_REGISTER_OCN                              |
C     | o Routine for registration of ocean config. with coupler |
C     |   layer.                                                 |
C     |==========================================================|
C     | This version talks to the MITgcm general circulation     |
C     | model. For now just get the models depth map.            |
C     \==========================================================/
      IMPLICIT NONE

C     == Global variables ==
#include "OCNSIZE.h"
#include "OCNVARS.h"
#include "OCNIDS.h"

C     == Routine arguments ==

C     == Local variables ==

CEndOfInterface

C     Call MIT Coupler registration acceptance procedure.  Make sure that nobody
C     who registers for ocnCompName has a sub-domain that exceeds the bounds
C     Nx_ocn, Ny_ocn.
C     The first argument to MITCOUPLER_tile_register gives the name of the
C     component whose attributes will be collected by the particular call
C     to MITCOUPLER_tile_register.
C     The second and third arguments to MITCOUPLER_tile_register are used
C     for an internal error check. This check makes sure that the sub-domain
C     sizes reported by each of the component processes for a given component
C     fall within the global domain size the coupler is expecting.
      CALL MITCOUPLER_TILE_REGISTER( ocnCompName, Nx_ocn, Ny_ocn )

      RETURN
      END

#include "EXF_OPTIONS.h"

C--  File exf_interp.F: Routines to interpolate input field on to model grid
C--   Contents
C--   o S/R EXF_INTERPOLATE
C--   o FCT LAGRAN

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

CBOP
C     !ROUTINE: LAGRAN
C     !INTERFACE:
       _RL FUNCTION LAGRAN(i,x,a,sp)

C !DESCRIPTION: \bv
C  *==========================================================*
C  | FUNCTION LAGRAN
C  | o Provide linear (sp=2) and cubic (sp=4) interpolation
C  |   weight as lagrange polynomial coefficient.
C  *==========================================================*
C \ev

C !USES:
       IMPLICIT NONE

C !INPUT/OUTPUT PARAMETERS:
        INTEGER i
        _RS x
        _RL a(4)
        INTEGER sp

C !LOCAL VARIABLES:
        INTEGER k
        _RL numer,denom

        numer = 1. _d 0
        denom = 1. _d 0

#ifdef TARGET_NEC_SX
!CDIR UNROLL=8
#endif /* TARGET_NEC_SX */
        DO k=1,sp
         IF ( k .NE. i) THEN
          denom = denom*(a(i) - a(k))
          numer = numer*(x    - a(k))
         ENDIF
        ENDDO

        LAGRAN = numer/denom

       RETURN
       END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

CBOP
C     !ROUTINE: EXF_INTERPOLATE
C     !INTERFACE:
       SUBROUTINE EXF_INTERPOLATE(
     I                inFile, irecord, method,
     I                nxIn, nyIn, x_in, y_in,
     I                arrayin,
     O                arrayout,
     I                xG, yG,
     I                w_ind, s_ind,
     I                bi, bj, myThid )

C !DESCRIPTION: \bv
C  *==========================================================*
C  | SUBROUTINE EXF_INTERPOLATE
C  | o Interpolate a regular lat-lon input field
C  |   on to the model grid location
C  *==========================================================*
C \ev

C !USES:
      IMPLICIT NONE
C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"

C !INPUT/OUTPUT PARAMETERS:
C   inFile     :: name of the binary input file (direct access)
C   irecord    :: record number in input file
C   method     :: 1,11,21 for bilinear; 2,12,22 for bicubic
C              :: 1,2 for tracer; 11,12 for U; 21,22 for V
C   nxIn,nyIn  :: size in x & y direction of input field
C    x_in      :: longitude vector defining input field grid
C    y_in      :: latitude  vector defining input field grid
C   arrayin    :: input field array (loaded from file)
C   arrayout   :: output array
C   xG, yG     :: coordinates for output grid to interpolate to
C    w_ind     :: input field longitudinal index, on western side of model grid pt
C    s_ind     :: input field latitudinal index, on southern side of model grid pt
C   bi, bj     :: tile indices
C   myThid     :: My Thread Id number

      CHARACTER*(*) inFile
      INTEGER       irecord, method
      INTEGER       nxIn, nyIn
      _RL           x_in(-1:nxIn+2), y_in(-1:nyIn+2)
      _RL           arrayin( -1:nxIn+2, -1:nyIn+2 )
      _RL           arrayout(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RS           xG      (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RS           yG      (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      INTEGER       w_ind(sNx,sNy), s_ind(sNx,sNy)
      INTEGER       bi, bj, myThid

C !FUNCTIONS:
      EXTERNAL LAGRAN
      _RL      LAGRAN
      INTEGER  ILNBLNK
      EXTERNAL ILNBLNK

C !LOCAL VARIABLES:
C   px_ind     :: local copy of longitude position around current model grid pt
C   py_ind     :: local copy of latitude  position around current model grid pt
C   ew_val     :: intermediate field value after interpolation in East-West dir.
C   sp         :: number of input-field values used in 1.d interpolation
C   i, j, k, l :: loop indices
C   msgBuf     :: Informational/error message buffer
      _RL      px_ind(4), py_ind(4), ew_val(4)
      INTEGER  sp
      INTEGER  i, j, k, l
      CHARACTER*(MAX_LEN_MBUF) msgBuf
#ifdef TARGET_NEC_SX
      _RL      ew_val1, ew_val2, ew_val3, ew_val4
#endif
CEOP

      IF (method.EQ.1 .OR. method.EQ.11 .OR. method.EQ.21) THEN

C--   Bilinear interpolation
         sp = 2
         DO j=1,sNy
          DO i=1,sNx
           arrayout(i,j,bi,bj) = 0.
           DO l=0,1
            px_ind(l+1) = x_in(w_ind(i,j)+l)
            py_ind(l+1) = y_in(s_ind(i,j)+l)
           ENDDO
#ifndef TARGET_NEC_SX
           DO k=1,2
            ew_val(k) = arrayin(w_ind(i,j)  ,s_ind(i,j)+k-1)
     &                    *LAGRAN(1,xG(i,j,bi,bj),px_ind,sp)
     &                + arrayin(w_ind(i,j)+1,s_ind(i,j)+k-1)
     &                    *LAGRAN(2,xG(i,j,bi,bj),px_ind,sp)
            arrayout(i,j,bi,bj) = arrayout(i,j,bi,bj)
     &         + ew_val(k)*LAGRAN(k,yG(i,j,bi,bj),py_ind,sp)
           ENDDO
#else
           ew_val1 = arrayin(w_ind(i,j)  ,s_ind(i,j)  )
     &                    *LAGRAN(1,xG(i,j,bi,bj),px_ind,sp)
     &             + arrayin(w_ind(i,j)+1,s_ind(i,j)  )
     &                    *LAGRAN(2,xG(i,j,bi,bj),px_ind,sp)
           ew_val2 = arrayin(w_ind(i,j)  ,s_ind(i,j)+1)
     &                    *LAGRAN(1,xG(i,j,bi,bj),px_ind,sp)
     &             + arrayin(w_ind(i,j)+1,s_ind(i,j)+1)
     &                    *LAGRAN(2,xG(i,j,bi,bj),px_ind,sp)
           arrayout(i,j,bi,bj)=
     &            +ew_val1*LAGRAN(1,yG(i,j,bi,bj),py_ind,sp)
     &            +ew_val2*LAGRAN(2,yG(i,j,bi,bj),py_ind,sp)
#endif /* TARGET_NEC_SX defined */
          ENDDO
         ENDDO
      ELSEIF (method .EQ. 2 .OR. method.EQ.12 .OR. method.EQ.22) THEN

C--   Bicubic interpolation
         sp = 4
         DO j=1,sNy
          DO i=1,sNx
           arrayout(i,j,bi,bj) = 0.
           DO l=-1,2
            px_ind(l+2) = x_in(w_ind(i,j)+l)
            py_ind(l+2) = y_in(s_ind(i,j)+l)
           ENDDO
#ifndef TARGET_NEC_SX
           DO k=1,4
            ew_val(k) = arrayin(w_ind(i,j)-1,s_ind(i,j)+k-2)
     &                    *LAGRAN(1,xG(i,j,bi,bj),px_ind,sp)
     &                + arrayin(w_ind(i,j)  ,s_ind(i,j)+k-2)
     &                    *LAGRAN(2,xG(i,j,bi,bj),px_ind,sp)
     &                + arrayin(w_ind(i,j)+1,s_ind(i,j)+k-2)
     &                    *LAGRAN(3,xG(i,j,bi,bj),px_ind,sp)
     &                + arrayin(w_ind(i,j)+2,s_ind(i,j)+k-2)
     &                    *LAGRAN(4,xG(i,j,bi,bj),px_ind,sp)
            arrayout(i,j,bi,bj) = arrayout(i,j,bi,bj)
     &         + ew_val(k)*LAGRAN(k,yG(i,j,bi,bj),py_ind,sp)
           ENDDO
#else
           ew_val1 = arrayin(w_ind(i,j)-1,s_ind(i,j)-1)
     &                    *LAGRAN(1,xG(i,j,bi,bj),px_ind,sp)
     &             + arrayin(w_ind(i,j)  ,s_ind(i,j)-1)
     &                    *LAGRAN(2,xG(i,j,bi,bj),px_ind,sp)
     &             + arrayin(w_ind(i,j)+1,s_ind(i,j)-1)
     &                    *LAGRAN(3,xG(i,j,bi,bj),px_ind,sp)
     &             + arrayin(w_ind(i,j)+2,s_ind(i,j)-1)
     &                    *LAGRAN(4,xG(i,j,bi,bj),px_ind,sp)
           ew_val2 = arrayin(w_ind(i,j)-1,s_ind(i,j)  )
     &                    *LAGRAN(1,xG(i,j,bi,bj),px_ind,sp)
     &             + arrayin(w_ind(i,j)  ,s_ind(i,j)  )
     &                    *LAGRAN(2,xG(i,j,bi,bj),px_ind,sp)
     &             + arrayin(w_ind(i,j)+1,s_ind(i,j)  )
     &                    *LAGRAN(3,xG(i,j,bi,bj),px_ind,sp)
     &             + arrayin(w_ind(i,j)+2,s_ind(i,j)  )
     &                    *LAGRAN(4,xG(i,j,bi,bj),px_ind,sp)
           ew_val3 = arrayin(w_ind(i,j)-1,s_ind(i,j)+1)
     &                    *LAGRAN(1,xG(i,j,bi,bj),px_ind,sp)
     &             + arrayin(w_ind(i,j)  ,s_ind(i,j)+1)
     &                    *LAGRAN(2,xG(i,j,bi,bj),px_ind,sp)
     &             + arrayin(w_ind(i,j)+1,s_ind(i,j)+1)
     &                    *LAGRAN(3,xG(i,j,bi,bj),px_ind,sp)
     &             + arrayin(w_ind(i,j)+2,s_ind(i,j)+1)
     &                    *LAGRAN(4,xG(i,j,bi,bj),px_ind,sp)
           ew_val4 = arrayin(w_ind(i,j)-1,s_ind(i,j)+2)
     &                    *LAGRAN(1,xG(i,j,bi,bj),px_ind,sp)
     &             + arrayin(w_ind(i,j)  ,s_ind(i,j)+2)
     &                    *LAGRAN(2,xG(i,j,bi,bj),px_ind,sp)
     &             + arrayin(w_ind(i,j)+1,s_ind(i,j)+2)
     &                    *LAGRAN(3,xG(i,j,bi,bj),px_ind,sp)
     &             + arrayin(w_ind(i,j)+2,s_ind(i,j)+2)
     &                    *LAGRAN(4,xG(i,j,bi,bj),px_ind,sp)
           arrayout(i,j,bi,bj) =
     &             ew_val1*LAGRAN(1,yG(i,j,bi,bj),py_ind,sp)
     &            +ew_val2*LAGRAN(2,yG(i,j,bi,bj),py_ind,sp)
     &            +ew_val3*LAGRAN(3,yG(i,j,bi,bj),py_ind,sp)
     &            +ew_val4*LAGRAN(4,yG(i,j,bi,bj),py_ind,sp)
#endif /* TARGET_NEC_SX defined */
          ENDDO
         ENDDO
      ELSE
         l = ILNBLNK(inFile)
         WRITE(msgBuf,'(3A,I6)')
     &    'EXF_INTERPOLATE: file="', inFile(1:l), '", rec=', irecord
         CALL PRINT_ERROR( msgBuf, myThid )
         WRITE(msgBuf,'(A,I8,A)')
     &    'EXF_INTERPOLATE: method=', method,' not supported'
         CALL PRINT_ERROR( msgBuf, myThid )
         STOP 'ABNORMAL END: S/R EXF_INTERPOLATE: invalid method'
      ENDIF

      RETURN
      END

#include "DIC_OPTIONS.h"

CBOP
C     !ROUTINE: Fe_CHEM
C     !INTERFACE:
      SUBROUTINE Fe_CHEM(
     I           bi,bj, iMin,iMax,jMin,jMax,
     I           fe,
     O           freefe,
     I           myIter, myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE Fe_CHEM
C     | o Calculate L,FeL,Fe concentration
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     == GLobal variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "DIC_VARS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     bi, bj              :: current tile indices
C     iMin,iMax,jMin,jMax :: Range of points for which calculation is performed.
C     myThid              :: my Thread Id number
      INTEGER bi,bj
      INTEGER iMin,iMax,jMin,jMax
      _RL     fe(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL freefe(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      INTEGER myIter, myThid
CEOP

#ifdef ALLOW_FE
C     !LOCAL VARIABLES:
      INTEGER i,j,k
      _RL  lig, FeL
      _RL  tmpfe
#if ( defined MINFE && defined DIC_AD_SAFE )
      _RL thx, thy, theps
#endif

CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C
C  ADAPTED FROM PAYAL
C
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC

      DO k=1,Nr
       DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
          freefe(i,j,k) = 0. _d 0
        ENDDO
       ENDDO
      ENDDO

C ligand balance in surface layer
C in surface layer

       DO k=1,Nr
        DO j=jMin,jMax
         DO i=iMin,iMax
          IF ( maskC(i,j,k,bi,bj).GT.0. ) THEN

#ifdef DIC_NO_NEG
              tmpfe =MAX( 0. _d 0 , fe(i,j,k) )
#else
              tmpfe = fe(i,j,k)
#endif

C   Ligand,FeL,Fe calculation
              lig=(-ligand_stab*tmpfe +
     &              ligand_stab*ligand_tot-1. _d 0
     &             +((ligand_stab*tmpfe
     &                -ligand_stab*ligand_tot+1. _d 0)**2
     &               +4. _d 0*ligand_stab*ligand_tot)**0.5 _d 0
     &            )/(2. _d 0*ligand_stab)

              FeL = ligand_tot-lig
              IF (tmpfe.NE.0. _d 0) THEN
                freefe(i,j,k) = tmpfe -FeL
              ELSE
                freefe(i,j,k) = 0. _d 0
              ENDIF
#ifdef MINFE
#ifdef DIC_AD_SAFE
              thx=freefe(i,j,k)
              thy=freefemax
              theps=1. _d -8
              freefe(i,j,k) =
     &                 ( 1. _d 0 - tanh((thx-thy)/theps) ) * thx/2.+
     &                 ( 1. _d 0 + tanh((thx-thy)/theps) ) * thy/2.

#else
              freefe(i,j,k) = MIN(freefe(i,j,k),freefemax)
#endif
              fe(i,j,k) = FeL+freefe(i,j,k)
#endif
          ENDIF
         ENDDO
        ENDDO
       ENDDO

#endif /* ALLOW_FE */
      RETURN
      END

#include "ECCO_OPTIONS.h"
#ifdef ALLOW_CTRL
# include "CTRL_OPTIONS.h"
#endif

C--  File ecco_toolbox.F: Routines to handle basic operations common in ecco.
C--   Contents
C--   o ECCO_ZERO
C--   o ECCO_CP
C--   o ECCO_CPRSRL
C--   o ECCO_DIFFMSK
C--   o ECCO_ADDCOST
C--   o ECCO_ADD         (currently not used)
C--   o ECCO_SUBTRACT
C--   o ECCO_ADDMASK
C--   o ECCO_DIV
C--   o ECCO_DIVFIELD
C--   o ECCO_MULT
C--   o ECCO_MULTFIELD   (currently not used)
C--   o ECCO_MASKMINDEPTH
C--   o ECCO_OFFSET
C--   o ECCO_READBAR
C--   o ECCO_READWEI
C--   o ECCO_ERROR

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: ECCO_ZERO
C     !INTERFACE:
      SUBROUTINE ECCO_ZERO( fld, nzIn, zeroLoc, myThid )
C     !DESCRIPTION: \bv
C     fill a field with zeroLoc
C     \ev

C     !USES:
      IMPLICIT NONE

C     == Global variables ==
#include "EEPARAMS.h"
#include "SIZE.h"

C     !INPUT/OUTPUT PARAMETERS:
      INTEGER nzIn
      INTEGER myThid
      _RL fld    (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nzIn,nSx,nSy)
      _RL zeroLoc

#ifdef ALLOW_ECCO
C     !LOCAL VARIABLES:
      INTEGER bi,bj,i,j,k
CEOP

      DO bj = myByLo(myThid),myByHi(myThid)
       DO bi = myBxLo(myThid),myBxHi(myThid)
        DO k = 1,nzIn
         DO j = 1-OLy,sNy+OLy
          DO i = 1-OLx,sNx+OLx
           fld(i,j,k,bi,bj) = zeroLoc
          ENDDO
         ENDDO
        ENDDO
       ENDDO
      ENDDO

#endif /* ALLOW_ECCO */

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: ECCO_DIFFMSK
C     !INTERFACE:
      SUBROUTINE ECCO_DIFFMSK(
     I                   localBar, localObs, localMask,
     I                   nzIn, nLev, spMinLoc, spMaxLoc, spzeroLoc,
     O                   localDif, difMask,
     I                   myThid )

C     !DESCRIPTION: \bv
C     compute masked difference between model and observations
C     \ev

C     !USES:
      IMPLICIT NONE

C     == Global variables ==
#include "EEPARAMS.h"
#include "SIZE.h"

C     !INPUT PARAMETERS:
      INTEGER nzIn, nLev
      INTEGER myThid
      _RL localBar (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nzIn,nSx,nSy)
      _RL localObs (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nzIn,nSx,nSy)
      _RL localMask(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nzIn,nSx,nSy)
      _RL spMinLoc, spMaxLoc, spzeroLoc
C     !OUTPUT PARAMETERS:
      _RL localDif (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nzIn,nSx,nSy)
      _RL difMask  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nzIn,nSx,nSy)

#ifdef ALLOW_ECCO
C     !LOCAL VARIABLES:
      INTEGER bi,bj,i,j,k
CEOP

c--   Determine the model-data difference mask
      IF ( nLev .GT. nzIn ) CALL ECCO_ERROR( 'ECCO_DIFFMSK',
     &     'nLev > nzIn not allowed.', myThid )
      DO bj = myByLo(myThid),myByHi(myThid)
       DO bi = myBxLo(myThid),myBxHi(myThid)
        DO k = 1,nLev
         DO j = 1,sNy
          DO i = 1,sNx
           difMask(i,j,k,bi,bj) = localMask(i,j,k,bi,bj)
           IF ( localObs(i,j,k,bi,bj) .LT. spMinLoc .OR.
     &          localObs(i,j,k,bi,bj) .GT. spMaxLoc .OR.
     &          localObs(i,j,k,bi,bj) .EQ. spzeroLoc ) THEN
            difMask(i,j,k,bi,bj) = 0. _d 0
           ENDIF
           localDif(i,j,k,bi,bj) = difMask(i,j,k,bi,bj)*
     &          (localBar(i,j,k,bi,bj)-localObs(i,j,k,bi,bj))
          ENDDO
         ENDDO
        ENDDO
       ENDDO
      ENDDO

#endif /* ALLOW_ECCO */

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: ECCO_CP
C     !INTERFACE:
      SUBROUTINE ECCO_CP(
     I                   fldIn,
     U                   fldOut,
     I                   nzIn, nlev, myThid )

C     !DESCRIPTION: \bv
C     copy a field to another array
C     \ev

C     !USES:
      IMPLICIT NONE

C     == Global variables ==
#include "EEPARAMS.h"
#include "SIZE.h"

C     !INPUT/OUTPUT PARAMETERS:
      INTEGER nzIn, nLev
      INTEGER myThid
      _RL fldIn (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nzIn,nSx,nSy)
      _RL fldOut(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nzIn,nSx,nSy)

#ifdef ALLOW_ECCO
C     !LOCAL VARIABLES:
      INTEGER bi,bj,i,j,k
CEOP

      IF ( nLev .GT. nzIn ) CALL ECCO_ERROR( 'ECCO_CP',
     &     'nLev > nzIn not allowed.', myThid )
      DO bj = myByLo(myThid),myByHi(myThid)
       DO bi = myBxLo(myThid),myBxHi(myThid)
        DO k = 1,nLev
         DO j = 1,sNy
          DO i = 1,sNx
           fldOut(i,j,k,bi,bj) = fldIn(i,j,k,bi,bj)
          ENDDO
         ENDDO
        ENDDO
       ENDDO
      ENDDO

#endif /* ALLOW_ECCO */

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: ECCO_CPRSRL
C     !INTERFACE:
      SUBROUTINE ECCO_CPRSRL(
     I                   fldIn,
     U                   fldOut,
     I                   nzIn, nlev, myThid )

C     !DESCRIPTION: \bv
C     copy a field to another array, switching from _RS to _RL
C     \ev

C     !USES:
      IMPLICIT NONE

C     == Global variables ==
#include "EEPARAMS.h"
#include "SIZE.h"

C     !INPUT/OUTPUT PARAMETERS:
      INTEGER nzIn, nLev
      INTEGER myThid
      _RS fldIn (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nzIn,nSx,nSy)
      _RL fldOut(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nzIn,nSx,nSy)

#ifdef ALLOW_ECCO
C     !LOCAL VARIABLES:
      INTEGER bi,bj,i,j,k
CEOP

      IF ( nLev .GT. nzIn ) CALL ECCO_ERROR( 'ECCO_CPRSRL',
     &     'nLev > nzIn not allowed.', myThid )
      DO bj = myByLo(myThid),myByHi(myThid)
       DO bi = myBxLo(myThid),myBxHi(myThid)
        DO k = 1,nLev
         DO j = 1,sNy
          DO i = 1,sNx
           fldOut(i,j,k,bi,bj) = fldIn(i,j,k,bi,bj)
          ENDDO
         ENDDO
        ENDDO
       ENDDO
      ENDDO

#endif /* ALLOW_ECCO */

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: ECCO_ADDCOST
C     !INTERFACE:
      SUBROUTINE ECCO_ADDCOST(
     I     localDif, localWeight, difMask, nzIn, nLev, doSumSq,
     U     objf_local, num_local,
     I     myThid )

C     !DESCRIPTION: \bv
C     adds to a cost function term
C     \ev

C     !USES:
      IMPLICIT NONE

C     == Global variables ==
#include "EEPARAMS.h"
#include "SIZE.h"

C     !INPUT PARAMETERS:
      INTEGER nzIn, nLev
      LOGICAL doSumSq
      INTEGER myThid
      _RL localDif   (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nzIn,nSx,nSy)
      _RL localWeight(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nzIn,nSx,nSy)
      _RL difMask    (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nzIn,nSx,nSy)
C     !OUTPUT PARAMETERS:
      _RL objf_local (nSx,nSy)
      _RL num_local  (nSx,nSy)

#ifdef ALLOW_ECCO
C     !LOCAL VARIABLES:
      INTEGER bi,bj,i,j,k
      _RL localwww
      _RL localcost
      _RL junk
CEOP

      localwww = 0. _d 0

      IF ( nLev .GT. nzIn ) CALL ECCO_ERROR( 'ECCO_ADDCOST',
     &     'nLev > nzIn not allowed.', myThid )
c--     Compute normalized model-obs cost function
      DO bj = myByLo(myThid),myByHi(myThid)
       DO bi = myBxLo(myThid),myBxHi(myThid)
        localcost    = 0. _d 0
        DO k = 1,nLev
         DO j = 1,sNy
          DO i = 1,sNx
           localwww  = localWeight(i,j,k,bi,bj) * difMask(i,j,k,bi,bj)
           junk      = localDif(i,j,k,bi,bj)
           IF ( doSumSq ) THEN
            localcost = localcost + junk*junk*localwww
           ELSE
            localcost = localcost + junk*localwww
           ENDIF
           IF ( localwww .NE. 0. )
     &               num_local(bi,bj) = num_local(bi,bj) + 1. _d 0
          ENDDO
         ENDDO
        ENDDO
        objf_local(bi,bj) = objf_local(bi,bj) + localcost
       ENDDO
      ENDDO

#endif /* ALLOW_ECCO */

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: ECCO_ADD
C     !INTERFACE:
      SUBROUTINE ECCO_ADD(
     U                    fldOut,
     I                    fldIn, nzIn, nLev, myThid )

C     !DESCRIPTION: \bv
C     add a field (fldIn) to another field (fldOut)
C     \ev

C     !USES:
      IMPLICIT NONE

C     == Global variables ==
#include "EEPARAMS.h"
#include "SIZE.h"

C     !INPUT/OUTPUT PARAMETERS:
      INTEGER nzIn, nLev
      INTEGER myThid
      _RL fldOut(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nzIn,nSx,nSy)
      _RL fldIn (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nzIn,nSx,nSy)

#ifdef ALLOW_ECCO
C     !LOCAL VARIABLES:
      INTEGER bi,bj,i,j,k
CEOP

      IF ( nLev .GT. nzIn ) CALL ECCO_ERROR( 'ECCO_ADD',
     &     'nLev > nzIn not allowed.', myThid )
      DO bj = myByLo(myThid),myByHi(myThid)
       DO bi = myBxLo(myThid),myBxHi(myThid)
        DO k = 1,nLev
         DO j = 1,sNy
          DO i = 1,sNx
           fldOut(i,j,k,bi,bj) = fldOut(i,j,k,bi,bj)
     &                         + fldIn (i,j,k,bi,bj)
          ENDDO
         ENDDO
        ENDDO
       ENDDO
      ENDDO

#endif /* ALLOW_ECCO */

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: ECCO_SUBTRACT
C     !INTERFACE:
      SUBROUTINE ECCO_SUBTRACT(
     U                         fldOut,
     I                         fldIn, nzIn, nLev, myThid )

C     !DESCRIPTION: \bv
C     subtract a field (fldIn) from another field (fldOut)
C     \ev

C     !USES:
      IMPLICIT NONE

C     == Global variables ==
#include "EEPARAMS.h"
#include "SIZE.h"
#include "PARAMS.h"
#ifdef ALLOW_ECCO
# include "ECCO_SIZE.h"
# include "ECCO.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
      INTEGER nzIn, nLev
      INTEGER myThid
      _RL fldOut(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nzIn,nSx,nSy)
      _RL fldIn (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nzIn,nSx,nSy)

#ifdef ALLOW_ECCO
C     !LOCAL VARIABLES:
      INTEGER bi,bj,i,j,k
CEOP

      IF ( nLev .GT. nzIn ) CALL ECCO_ERROR( 'ECCO_SUBTRACT',
     &     'nLev > nzIn not allowed.', myThid )
      DO bj = myByLo(myThid),myByHi(myThid)
       DO bi = myBxLo(myThid),myBxHi(myThid)
        DO k = 1,nLev
         DO j = 1,sNy
          DO i = 1,sNx
           fldOut(i,j,k,bi,bj) = fldOut(i,j,k,bi,bj)
     &                         - fldIn (i,j,k,bi,bj)
          ENDDO
         ENDDO
        ENDDO
       ENDDO
      ENDDO

#endif /* ALLOW_ECCO */

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: ECCO_ADDMASK
C     !INTERFACE:
      SUBROUTINE ECCO_ADDMASK(
     I                   fldIn, fldInmask,
     U                   fldOut, fldOutnum,
     I                   nzIn, nLev, myThid )

C     !DESCRIPTION: \bv
C     add a field to another array only grids where the mask is non-zero.
C     Also increase the counter by one one those girds.
C     \ev

C     !USES:
      IMPLICIT NONE

C     == Global variables ==
#include "EEPARAMS.h"
#include "SIZE.h"

C     !INPUT/OUTPUT PARAMETERS:
      INTEGER nzIn, nLev
      INTEGER myThid
      _RL fldIn     (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nzIn,nSx,nSy)
      _RL fldInmask (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nzIn,nSx,nSy)
      _RL fldOut    (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nzIn,nSx,nSy)
      _RL fldOutnum (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nzIn,nSx,nSy)

#ifdef ALLOW_ECCO
C     !LOCAL VARIABLES:
      INTEGER bi,bj,i,j,k
CEOP

      IF ( nLev .GT. nzIn ) CALL ECCO_ERROR( 'ECCO_ADDMASK',
     &     'nLev > nzIn not allowed.', myThid )
      DO bj = myByLo(myThid),myByHi(myThid)
       DO bi = myBxLo(myThid),myBxHi(myThid)
        DO k = 1,nLev
         DO j = 1,sNy
          DO i = 1,sNx
           IF ( fldInmask(i,j,k,bi,bj) .NE. 0. _d 0 ) THEN
            fldOut(i,j,k,bi,bj) = fldOut(i,j,k,bi,bj)
     &                          + fldIn (i,j,k,bi,bj)
            fldOutnum(i,j,k,bi,bj) = fldOutnum(i,j,k,bi,bj) + 1. _d 0
           ENDIF
          ENDDO
         ENDDO
        ENDDO
       ENDDO
      ENDDO

#endif /* ALLOW_ECCO */

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: ECCO_DIV
C     !INTERFACE:
      SUBROUTINE ECCO_DIV(
     U                    fld,
     I                    numerLoc, nzIn, nLev, myThid )
C     !DESCRIPTION: \bv
C     divide a field with RL constant
C     \ev

C     !USES:
      IMPLICIT NONE

C     == Global variables ==
#include "EEPARAMS.h"
#include "SIZE.h"

C     !INPUT/OUTPUT PARAMETERS:
      INTEGER nzIn, nLev
      INTEGER myThid
      _RL fld(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nzIn,nSx,nSy)
      _RL numerLoc

#ifdef ALLOW_ECCO
C     !LOCAL VARIABLES:
      INTEGER bi,bj,i,j,k
      _RL recip_num
CEOP

      IF ( nLev .GT. nzIn ) CALL ECCO_ERROR( 'ECCO_DIV',
     &     'nLev > nzIn not allowed.', myThid )
      IF ( numerLoc .NE. 0. _d 0 ) THEN
       recip_num = 1. _d 0 / numerLoc
       DO bj = myByLo(myThid),myByHi(myThid)
        DO bi = myBxLo(myThid),myBxHi(myThid)
         DO k = 1,nLev
          DO j = 1,sNy
           DO i = 1,sNx
            fld(i,j,k,bi,bj) = fld(i,j,k,bi,bj) * recip_num
           ENDDO
          ENDDO
         ENDDO
        ENDDO
       ENDDO
      ENDIF

#endif /* ALLOW_ECCO */

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: ECCO_DIVFIELD
C     !INTERFACE:
      SUBROUTINE ECCO_DIVFIELD( fld, fldDenom, nzIn, nLev, myThid )
C     !DESCRIPTION: \bv
C     divide a field by another field
C     \ev

C     !USES:
      IMPLICIT NONE

C     == Global variables ==
#include "EEPARAMS.h"
#include "SIZE.h"

C     !INPUT/OUTPUT PARAMETERS:
      INTEGER nzIn, nLev
      INTEGER myThid
      _RL fld     (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nzIn,nSx,nSy)
      _RL fldDenom(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nzIn,nSx,nSy)

#ifdef ALLOW_ECCO
C     !LOCAL VARIABLES:
      INTEGER bi,bj,i,j,k
CEOP

      IF ( nLev .GT. nzIn ) CALL ECCO_ERROR( 'ECCO_DIVFIELD',
     &     'nLev > nzIn not allowed.', myThid )
      DO bj = myByLo(myThid),myByHi(myThid)
       DO bi = myBxLo(myThid),myBxHi(myThid)
        DO k = 1,nLev
         DO j = 1,sNy
          DO i = 1,sNx
           IF ( fldDenom(i,j,k,bi,bj) .NE. 0. _d 0 ) THEN
            fld(i,j,k,bi,bj) = fld(i,j,k,bi,bj)/fldDenom(i,j,k,bi,bj)
           ELSE
            fld(i,j,k,bi,bj) = 0. _d 0
           ENDIF
          ENDDO
         ENDDO
        ENDDO
       ENDDO
      ENDDO

#endif /* ALLOW_ECCO */

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: ECCO_MULT
C     !INTERFACE:
      SUBROUTINE ECCO_MULT(
     U                     fld,
     I                     multLoc, nzIn, nLev, myThid )
C     !DESCRIPTION: \bv
C     multiply a field with RL constant
C     \ev

C     !USES:
      IMPLICIT NONE

C     == Global variables ==
#include "EEPARAMS.h"
#include "SIZE.h"

C     !INPUT/OUTPUT PARAMETERS:
      INTEGER nzIn, nLev
      INTEGER myThid
      _RL multLoc
      _RL fld(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nzIn,nSx,nSy)

#ifdef ALLOW_ECCO
C     !LOCAL VARIABLES:
      INTEGER bi,bj,i,j,k
CEOP

      IF ( nLev .GT. nzIn ) CALL ECCO_ERROR('ECCO_MULT',
     &     'nLev > nzIn not allowed.', myThid)
      DO bj = myByLo(myThid),myByHi(myThid)
       DO bi = myBxLo(myThid),myBxHi(myThid)
        DO k = 1,nLev
         DO j = 1,sNy
          DO i = 1,sNx
           fld(i,j,k,bi,bj) = fld(i,j,k,bi,bj)*multLoc
          ENDDO
         ENDDO
        ENDDO
       ENDDO
      ENDDO

#endif /* ALLOW_ECCO */

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: ECCO_MULTFIELD
C     !INTERFACE:
      SUBROUTINE ECCO_MULTFIELD(
     U                          fldOut,
     I                          fldIn, nzIn, nLev, myThid )
C     !DESCRIPTION: \bv
C     multiply a field by another field, fldOut is updated on output
C     \ev

C     !USES:
      IMPLICIT NONE

C     == Global variables ==
#include "EEPARAMS.h"
#include "SIZE.h"

C     !INPUT/OUTPUT PARAMETERS:
      INTEGER nzIn, nLev
      INTEGER myThid
      _RL fldOut(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nzIn,nSx,nSy)
      _RL fldIn (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nzIn,nSx,nSy)

#ifdef ALLOW_ECCO
C     !LOCAL VARIABLES:
      INTEGER bi,bj,i,j,k
CEOP

      IF ( nLev .GT. nzIn ) CALL ECCO_ERROR( 'ECCO_MULTFIELD',
     &     'nLev > nzIn not allowed.', myThid )
      DO bj = myByLo(myThid),myByHi(myThid)
       DO bi = myBxLo(myThid),myBxHi(myThid)
        DO k = 1,nLev
         DO j = 1,sNy
          DO i = 1,sNx
           fldOut(i,j,k,bi,bj) = fldOut(i,j,k,bi,bj)*fldIn(i,j,k,bi,bj)
          ENDDO
         ENDDO
        ENDDO
       ENDDO
      ENDDO

#endif /* ALLOW_ECCO */

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: ECCO_MASKMINDEPTH
C     !INTERFACE:
      SUBROUTINE ECCO_MASKMINDEPTH(
     U     difMask,
     I     nzIn, nLev, topoMin, myThid )
C     !DESCRIPTION: \bv
C     set difMask to zero where topography is shallower that topoMin
C     \ev

C     !USES:
      IMPLICIT NONE

C     == Global variables ==
#include "EEPARAMS.h"
#include "SIZE.h"
#include "GRID.h"

C     !INPUT/OUTPUT PARAMETERS:
      INTEGER nzIn, nLev
      INTEGER myThid
      _RL difMask(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nzIn,nSx,nSy)
      _RL topoMin

#ifdef ALLOW_ECCO
C     !LOCAL VARIABLES:
      INTEGER bi,bj,i,j,k
CEOP

      IF ( nLev .GT. nzIn ) CALL ECCO_ERROR( 'ECCO_MASMINDEPTH',
     &     'nLev > nzIn not allowed.', myThid )
      DO bj = myByLo(myThid),myByHi(myThid)
       DO bi = myBxLo(myThid),myBxHi(myThid)
         DO j = 1,sNy
          DO i = 1,sNx
           IF ( R_low(i,j,bi,bj) .GT. topoMin ) THEN
            DO k = 1,nLev
             difMask(i,j,k,bi,bj) = zeroRL
            ENDDO
           ENDIF
         ENDDO
        ENDDO
       ENDDO
      ENDDO

#endif /* ALLOW_ECCO */

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: ECCO_OFFSET
C     !INTERFACE:
      SUBROUTINE ECCO_OFFSET(
     I                   fName,
     U                   fld,
     I                   difMask, nzIn, nLev,
     I                   myThid )

C     !DESCRIPTION: \bv
C     remove mean of masked field
C     \ev

C     !USES:
      IMPLICIT NONE

C     == Global variables ==
#include "EEPARAMS.h"
#include "SIZE.h"

C     !INPUT/OUTPUT PARAMETERS:
      INTEGER myThid
      INTEGER nzIn, nLev
      CHARACTER*(*) fName
      _RL fld    (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nzIn,nSx,nSy)
      _RL difMask(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nzIn,nSx,nSy)

#ifdef ALLOW_ECCO
C     !LOCAL VARIABLES:
      INTEGER bi,bj,i,j,k
      _RL volTile(nSx,nSy), sumTile(nSx,nSy)
      _RL tmpVol, volGlob, sumGlob
      _RL theMean
      CHARACTER*(MAX_LEN_MBUF) msgBuf
CEOP

      IF ( nLev .GT. nzIn ) CALL ECCO_ERROR( 'ECCO_OFFSET',
     &     'nLev > nzIn not allowed.', myThid )
c--   Compute the mean
      DO bj = myByLo(myThid),myByHi(myThid)
       DO bi = myBxLo(myThid),myBxHi(myThid)
        volTile(bi,bj) = 0. _d 0
        sumTile(bi,bj) = 0. _d 0
        DO k = 1,nLev
         DO j = 1,sNy
          DO i = 1,sNx
           tmpVol = difMask(i,j,k,bi,bj)
           volTile(bi,bj) = volTile(bi,bj) + tmpVol
           sumTile(bi,bj) = sumTile(bi,bj) + tmpVol*fld(i,j,k,bi,bj)
          ENDDO
         ENDDO
        ENDDO
       ENDDO
      ENDDO

      CALL GLOBAL_SUM_TILE_RL( volTile, volGlob, myThid )
      CALL GLOBAL_SUM_TILE_RL( sumTile, sumGlob, myThid )

      IF ( volGlob.GT.zeroRL ) THEN
       theMean = sumGlob/volGlob
       DO bj = myByLo(myThid),myByHi(myThid)
        DO bi = myBxLo(myThid),myBxHi(myThid)
         DO k = 1,nLev
          DO j = 1,sNy
           DO i = 1,sNx
            IF (difMask(i,j,k,bi,bj) .NE. 0. _d 0) THEN
             fld(i,j,k,bi,bj) = fld(i,j,k,bi,bj) - theMean
            ENDIF
           ENDDO
          ENDDO
         ENDDO
        ENDDO
       ENDDO
      ELSE
       theMean = 0. _d 0
      ENDIF

C     Print the global mean to standard output
      _BEGIN_MASTER( myThid )
      WRITE(msgBuf,'(3A,1PE21.14)')
     &      'ecco_offset: # of nonzero constributions to mean of ',
     &      fname, ' = ', volGlob
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &      SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(3A,1PE21.14)')
     &      'ecco_offset:                         Global mean of ',
     &      fname, ' = ', theMean
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &      SQUEEZE_RIGHT, myThid )
      _END_MASTER( myThid )

#endif /* ALLOW_ECCO */

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: ECCO_READBAR
C     !INTERFACE:
      SUBROUTINE ECCO_READBAR(
     I                           active_var_file,
     O                           active_var,
     I                           iRec, nzIn, nLev,
     I                           dummy,
     I                           myThid )

C     !DESCRIPTION: \bv
C     reads one record from averaged time series ("bar file")
C     \ev

C     !USES:
      IMPLICIT NONE

C     == Global variables ==
#include "EEPARAMS.h"
#include "SIZE.h"
#ifdef ALLOW_ECCO
# include "ECCO_SIZE.h"
# include "ECCO.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     active_var_file :: filename
C     active_var      :: array
C     iRec            :: record number
C     nzIn            :: size of active_var
C     nLev            :: number vertical levels used
      CHARACTER*(*) active_var_file
      INTEGER iRec, nzIn, nLev
      INTEGER myThid
      _RL     active_var(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nzIn,nSx,nSy)
      _RL     dummy

#ifdef ALLOW_ECCO
C     !LOCAL VARIABLES:
      LOGICAL doGlobalRead
      LOGICAL lAdInit
      INTEGER i,j,bi,bj
      _RL     tmpFld2D(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      CHARACTER*(MAX_LEN_MBUF) msgBuf
CEOP

      doGlobalRead = .FALSE.
      lAdInit      = .FALSE.

#ifdef ALLOW_AUTODIFF
      IF ( nLev .EQ. 1 ) THEN
       CALL ACTIVE_READ_XY( active_var_file, tmpFld2D,
     &                      iRec, doGlobalRead,
     &                      lAdInit, eccoiter, myThid,
     &                      dummy )
      ELSEIF ( nLev .EQ. Nr .AND. nzIn .EQ. Nr ) THEN
       CALL ACTIVE_READ_XYZ( active_var_file, active_var,
     &                       iRec, doGlobalRead,
     &                       lAdInit, eccoiter, myThid,
     &                       dummy )
      ELSE
       WRITE(msgBuf,'(A,I3,A)') 'nLev = ',nLev,' should not happen'
       CALL ECCO_ERROR( 'ECCO_READBAR', msgBuf, myThid )
      ENDIF
#else
      IF ( nLev .EQ. 1 ) THEN
       CALL READ_REC_XY_RL( active_var_file, tmpFld2D,
     &                      iRec, 1, myThid )
      ELSEIF ( nLev .EQ. Nr .AND. nzIn .EQ. Nr ) THEN
       CALL READ_REC_XYZ_RL( active_var_file, active_var,
     &                       iRec, 1, myThid )
      ELSE
       WRITE(msgBuf,'(A,I3,A)') 'nLev = ',nLev,' should not happen'
       CALL ECCO_ERROR( 'ECCO_READBAR', msgBuf, myThid )
      ENDIF
#endif

      IF ( nLev .EQ. 1 ) THEN
       DO bj = myByLo(myThid),myByHi(myThid)
        DO bi = myBxLo(myThid),myBxHi(myThid)
         DO j = 1,sNy
          DO i = 1,sNx
           active_var(i,j,1,bi,bj) = tmpFld2D(i,j,bi,bj)
          ENDDO
         ENDDO
        ENDDO
       ENDDO
      ENDIF

#endif /* ALLOW_ECCO */

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: ECCO_READWEI
C     !INTERFACE:
      SUBROUTINE ECCO_READWEI(
     I                         localErr_file,
     O                         localWeight,
     I                         iRec, nzIn, nLev,
     I                         doSumSq,
     I                         myThid )

C     !DESCRIPTION: \bv
C     reads uncertainty field and compute weight as squared inverse
C     \ev

C     !USES:
      IMPLICIT NONE

C     == Global variables ==
#include "EEPARAMS.h"
#include "SIZE.h"
#ifdef ALLOW_ECCO
# include "ECCO_SIZE.h"
# include "ECCO.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     localErr_file :: filename
C     localWeight   :: array
C     iRec          :: record number
      CHARACTER*(*) localErr_file
      INTEGER iRec, nzIn, nLev
      LOGICAL doSumSq
      INTEGER myThid
      _RL     localWeight(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nzIn,nSx,nSy)

#ifdef ALLOW_ECCO
C     !LOCAL VARIABLES:
      INTEGER bi,bj
      INTEGER i,j,k
CEOP

      CALL READ_REC_LEV_RL( localErr_file, cost_iprec, nzIn, 1, nLev,
     &                      localWeight, iRec, 1, myThid )

      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        DO k = 1,nLev
         DO j = 1,sNy
          DO i = 1,sNx
c--        Test for missing values.
           IF (localWeight(i,j,k,bi,bj) .LT. -9900.) THEN
             localWeight(i,j,k,bi,bj) = 0. _d 0
c--        Convert to weight
           ELSEIF ( localWeight(i,j,k,bi,bj).NE.0. .AND. doSumSq ) THEN
              localWeight(i,j,k,bi,bj) =
     &          oneRL/localWeight(i,j,k,bi,bj)/localWeight(i,j,k,bi,bj)
           ELSEIF ( localWeight(i,j,k,bi,bj).NE.0. ) THEN
              localWeight(i,j,k,bi,bj) =
     &           oneRL/localWeight(i,j,k,bi,bj)
           ENDIF
          ENDDO
         ENDDO
        ENDDO
       ENDDO
      ENDDO

#endif /* ALLOW_ECCO */

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: ECCO_ERROR
C     !INTERFACE:
      SUBROUTINE ECCO_ERROR( srName, errMsg, myThid )
C     !DESCRIPTION: \bv
C     prints error messages and stops
C     \ev

C     !USES:
      IMPLICIT NONE

C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     srName :: name of caller
C     errMsg :: error message to be printed
      CHARACTER*(*) srName, errMsg
      INTEGER myThid

#ifdef ALLOW_ECCO
C     !LOCAL VARIABLES:
      CHARACTER*(MAX_LEN_MBUF) msgBuf
CEOP

      WRITE(msgBuf,'(A,A,A)') srName, ': ', errMsg
      CALL PRINT_ERROR( msgBuf, myThid )
      CALL ALL_PROC_DIE( myThid )
      STOP 'ABNORMAL END: S/R ECCO_ERROR'

#endif /* ALLOW_ECCO */

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#include "PACKAGES_CONFIG.h"
#include "CPP_OPTIONS.h"

CBOP
C     !ROUTINE: INI_MNC_VARS

C     !INTERFACE:
      SUBROUTINE INI_MNC_VARS( myThid )

C     !DESCRIPTION:
C     Set up (once only) information such as shape/size of variables,
C     units, etc. primarily for state and snapshot variables.

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"

C     !INPUT/OUTPUT PARAMETERS:
C     myThid :: my Thread Id number
      INTEGER myThid
CEOP

#ifdef ALLOW_MNC

C     !LOCAL VARIABLES:
#ifdef ALLOW_CAL
      INTEGER locDate(4)
      CHARACTER*(34) timeUnits
#endif /* ALLOW_CAL */

      IF (useMNC) THEN

C     Define coordinates for all MNC files ---------------------------------
C     XC
      CALL MNC_CW_ADD_VNAME('xC', 'Cen_xy_Hn__-__-', 3,4, myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('xC','description',
     &     'X coordinate of cell center (T-P point)',myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('xC',
     &     'units', 'degree_east', myThid)

C     YC
      CALL MNC_CW_ADD_VNAME('yC', 'Cen_xy_Hn__-__-', 3,4, myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('yC','description',
     &     'Y coordinate of cell center (T-P point)',myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('yC',
     &     'units', 'degree_north', myThid)

C     XU
      CALL MNC_CW_ADD_VNAME('xU', 'U_xy_Hn__-__-', 3,4, myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('xU','description',
     &     'X coordinate of U point',myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('xU',
     &     'units', 'degree_east', myThid)

C     YU
      CALL MNC_CW_ADD_VNAME('yU', 'U_xy_Hn__-__-', 3,4, myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('yU','description',
     &     'Y coordinate of U point',myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('yU',
     &     'units', 'degree_north', myThid)

C     XV
      CALL MNC_CW_ADD_VNAME('xV', 'V_xy_Hn__-__-', 3,4, myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('xV','description',
     &     'X coordinate of V point',myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('xV',
     &     'units', 'degree_east', myThid)

C     YV
      CALL MNC_CW_ADD_VNAME('yV', 'V_xy_Hn__-__-', 3,4, myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('yV','description',
     &     'Y coordinate of V point',myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('yV',
     &     'units', 'degree_north', myThid)

C     XG
      CALL MNC_CW_ADD_VNAME('xG', 'Cor_xy_Hn__-__-', 3,4, myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('xG','description',
     &     'X coordinate of cell corner (Vorticity point)',myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('xG',
     &     'units', 'degree_east', myThid)

C     YG
      CALL MNC_CW_ADD_VNAME('yG', 'Cor_xy_Hn__-__-', 3,4, myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('yG','description',
     &     'Y coordinate of cell corner (Vorticity point)',myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('yG',
     &     'units', 'degree_north', myThid)

C     RC
      CALL MNC_CW_ADD_VNAME('rC', '-_-_--__C__-', 0,0, myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('rC','description',
     &     'R coordinate of cell center',myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('rC',
     &     'units', 'm', myThid)

C     RF
      CALL MNC_CW_ADD_VNAME('rF', '-_-_--__I__-', 0,0, myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('rF','description',
     &     'R coordinate of cell interface',myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('rF',
     &     'units', 'm', myThid)

C     RL
      CALL MNC_CW_ADD_VNAME('rL', '-_-_--__L__-', 0,0, myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('rL','description',
     &     'R coordinate of lower interface',myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('rL',
     &     'units', 'm', myThid)

C     RU
      CALL MNC_CW_ADD_VNAME('rU', '-_-_--__U__-', 0,0, myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('rU','description',
     &     'R coordinate of upper interface',myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('rU',
     &     'units', 'm', myThid)
C     End define coordinates for all MNC files  ----------------------


C     Grid variables  ------------------------------------------------
      CALL MNC_CW_ADD_VNAME('drC', '-_-_--__I__-', 0,0, myThid)
      CALL MNC_CW_ADD_VNAME('drF', '-_-_--__C__-', 0,0, myThid)
      CALL MNC_CW_ADD_VNAME('dxC', 'U_xy_Hn__-__-', 3,4, myThid)
      CALL MNC_CW_ADD_VNAME('dyC', 'V_xy_Hn__-__-', 3,4, myThid)
      CALL MNC_CW_ADD_VNAME('dxF', 'Cen_xy_Hn__-__-', 3,4, myThid)
      CALL MNC_CW_ADD_VNAME('dyF', 'Cen_xy_Hn__-__-', 3,4, myThid)
      CALL MNC_CW_ADD_VNAME('dxG', 'V_xy_Hn__-__-', 3,4, myThid)
      CALL MNC_CW_ADD_VNAME('dyG', 'U_xy_Hn__-__-', 3,4, myThid)
      CALL MNC_CW_ADD_VNAME('dxV', 'Cor_xy_Hn__-__-', 3,4, myThid)
      CALL MNC_CW_ADD_VNAME('dyU', 'Cor_xy_Hn__-__-', 3,4, myThid)
      CALL MNC_CW_ADD_VNAME('rAc',  'Cen_xy_Hn__-__-', 3,4, myThid)
      CALL MNC_CW_ADD_VNAME('rAw', 'U_xy_Hn__-__-', 3,4, myThid)
      CALL MNC_CW_ADD_VNAME('rAs', 'V_xy_Hn__-__-', 3,4, myThid)
      CALL MNC_CW_ADD_VNAME('rAz', 'Cor_xy_Hn__-__-', 3,4, myThid)
      CALL MNC_CW_ADD_VNAME('angleCS','Cen_xy_Hn__-__-', 3,4,myThid)
      CALL MNC_CW_ADD_VNAME('angleSN','Cen_xy_Hn__-__-', 3,4,myThid)
      CALL MNC_CW_ADD_VNAME('fCori', 'Cen_xy_Hn__-__-', 3,4,myThid)
      CALL MNC_CW_ADD_VNAME('fCoriG','Cor_xy_Hn__-__-', 3,4,myThid)
      CALL MNC_CW_ADD_VNAME('rLowC', 'Cen_xy_Hn__-__-', 3,4,myThid)
      CALL MNC_CW_ADD_VNAME('rSurfC','Cen_xy_Hn__-__-',3,4,myThid)
      CALL MNC_CW_ADD_VNAME('Depth', 'Cen_xy_Hn__-__-', 3,4,myThid)
      CALL MNC_CW_ADD_VNAME('hFacC', 'Cen_xy_Hn__C__-', 4,5,myThid)
      CALL MNC_CW_ADD_VNAME('hFacW', 'U_xy_Hn__C__-', 4,5,myThid)
      CALL MNC_CW_ADD_VNAME('hFacS', 'V_xy_Hn__C__-', 4,5,myThid)

      CALL MNC_CW_ADD_VATTR_TEXT('drC','description',
     &     'r cell center separation',myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('drF','description',
     &     'r cell face separation',myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('dxC','description',
     &     'x cell center separation',myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('dyC','description',
     &       'y cell center separation',myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('dxF','description',
     &     'x cell face separation',myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('dyF','description',
     &     'y cell face separation',myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('dxG','description',
     &     'x cell corner separation',myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('dyG','description',
     &     'y cell corner separation',myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('dxV','description',
     &     'x v-velocity separation',myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('dyU','description',
     &     'y u-velocity separation',myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('rAc','description',
     &     'r-face area at cell center',myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('rAw','description',
     &     'r-face area at U point',myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('rAs','description',
     &     'r-face area at V point',myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('rAz','description',
     &     'r-face area at cell corner',myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('angleCS','description',
     &     'Cos of grid orientation angle at cell center',myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('angleSN','description',
     &       'Sin of grid orientation angle at cell center',myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('fCori','description',
     &     'Coriolis f at cell center',myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('fCoriG','description',
     &     'Coriolis f at cell corner',myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('rLowC','description',
     &     'base of fluid in r-units',myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('rSurfC','description',
     &     'surface reference (at rest) position',myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('Depth','description',
     &     'fluid thickness in r coordinates (at rest)',myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('hFacC','description',
     &     'vertical fraction of open cell at cell center',myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('hFacW','description',
     &       'vertical fraction of open cell at West face', myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('hFacS','description',
     &     'vertical fraction of open cell at South face',myThid)


C     Create MNC definitions for DYNVARS.h variables  ----------------
      CALL MNC_CW_ADD_VNAME('T', '-_-_--__-__t', 0,0, myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('T',
     &     'long_name','model_time', myThid)
#ifdef ALLOW_CAL
      IF ( useCAL ) THEN
       CALL CAL_GETDATE( -1, startTime, locDate, myThid )
C     format: seconds since 1992-01-01 00:00:00
       WRITE(timeUnits,'(A,I4.4,5(A,I2.2))')
     &      'seconds since ', locDate(1)/10000,       '-',
     &      (locDate(1) - locDate(1)/10000*10000)/100,'-',
     &      (locDate(1) - locDate(1)/100*100),        ' ',
     &       locDate(2)/10000,                        ':',
     &      (locDate(2) - locDate(2)/10000*10000)/100,':',
     &      (locDate(2) - locDate(2)/100*100)
       CALL MNC_CW_ADD_VATTR_TEXT('T',
     &      'units',timeUnits, myThid)
      ELSE
#else
      IF (.TRUE. ) THEN
#endif /* ALLOW_CAL */
       CALL MNC_CW_ADD_VATTR_TEXT('T',
     &     'units','s', myThid)
      ENDIF

      CALL MNC_CW_ADD_VNAME('iter', '-_-_--__-__t', 0,0, myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('iter',
     &     'long_name','iteration_count', myThid)

      CALL MNC_CW_ADD_VNAME('model_time', '-_-_--__-__t', 0,0, myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('model_time',
     &     'long_name','Model Time', myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('model_time','units','s', myThid)

      CALL MNC_CW_ADD_VNAME('U', 'U_xy_Hn__C__t', 4,5, myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('U','units','m/s', myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('U',
     &     'coordinates','xU yU rC iter', myThid)

      CALL MNC_CW_ADD_VNAME('V', 'V_xy_Hn__C__t', 4,5, myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('V','units','m/s', myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('V',
     &     'coordinates','xV yV rC iter', myThid)

      CALL MNC_CW_ADD_VNAME('Temp', 'Cen_xy_Hn__C__t', 4,5, myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('Temp','units','degC', myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('Temp','long_name',
     &     'potential_temperature', myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('Temp',
     &     'coordinates','xC yC rC iter', myThid)

      CALL MNC_CW_ADD_VNAME('S', 'Cen_xy_Hn__C__t', 4,5, myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('S','long_name',
     &     'salinity', myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('S',
     &     'coordinates','xC yC rC iter', myThid)

      CALL MNC_CW_ADD_VNAME('gUnm1', 'U_xy_Hn__C__t', 4,5, myThid)
      CALL MNC_CW_ADD_VNAME('gVnm1', 'V_xy_Hn__C__t', 4,5, myThid)
      CALL MNC_CW_ADD_VNAME('gTnm1', 'Cen_xy_Hn__C__t', 4,5, myThid)
      CALL MNC_CW_ADD_VNAME('gSnm1', 'Cen_xy_Hn__C__t', 4,5, myThid)

      CALL MNC_CW_ADD_VNAME('Eta', 'Cen_xy_Hn__-__t', 3,4, myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('Eta','long_name',
     &     'free-surface_r-anomaly', myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('Eta','units','m', myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('Eta',
     &     'coordinates','xC yC iter', myThid)

      CALL MNC_CW_ADD_VNAME('EtaH', 'Cen_xy_Hn__-__t', 3,4, myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('EtaH','long_name',
     &     'column-thickness_r-anomaly', myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('EtaH','units','m', myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('EtaH',
     &     'coordinates','xC yC iter', myThid)
      CALL MNC_CW_ADD_VNAME('dEtaHdt', 'Cen_xy_Hn__-__t', 3,4, myThid)

      CALL MNC_CW_ADD_VNAME('W', 'Cen_xy_Hn__L__t', 4,5, myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('W','units','m/s', myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('W',
     &     'coordinates','xC yC rC iter', myThid)

      CALL MNC_CW_ADD_VNAME('phiHyd', 'Cen_xy_Hn__C__t', 4,5, myThid)
      CALL MNC_CW_ADD_VNAME('phiHydLow', 'Cen_xy_Hn__-__t', 3,4, myThid)
      CALL MNC_CW_ADD_VNAME('phi_nh', 'Cen_xy_Hn__C__t', 4,5, myThid)
      CALL MNC_CW_ADD_VNAME('gW',     'Cen_xy_Hn__L__t', 4,5, myThid)
      CALL MNC_CW_ADD_VNAME('gWnm1',  'Cen_xy_Hn__L__t', 4,5, myThid)

C     Write coordinates to "state" file
C     CALL MNC_CW_SET_UDIM('state', 0, myThid)
C     CALL MNC_CW_RS_W('R','state',0,0,'xC',xC, myThid)
C     CALL MNC_CW_RS_W('R','state',0,0,'yC',yC, myThid)
C     CALL MNC_CW_RS_W('R','state',0,0,'xU',xG, myThid)
C     CALL MNC_CW_RS_W('R','state',0,0,'yU',yC, myThid)
C     CALL MNC_CW_RS_W('R','state',0,0,'xV',xC, myThid)
C     CALL MNC_CW_RS_W('R','state',0,0,'yV',yG, myThid)
C     CALL MNC_CW_RS_W('R','state',0,0,'xG',xG, myThid)
C     CALL MNC_CW_RS_W('R','state',0,0,'yG',yG, myThid)
C     CALL MNC_CW_RS_W('R','state',0,0,'rC',rC, myThid)
C     CALL MNC_CW_RS_W('R','state',0,0,'rF',rF, myThid)

C     Define variables used in mom_vecinv
C     CALL MNC_CW_ADD_VNAME('fV', 'Cen_xy_Hn__-__t', 0,0, myThid)
C     CALL MNC_CW_ADD_VATTR_TEXT('','units','', myThid)
C     CALL MNC_CW_ADD_VATTR_TEXT('','long_name',
C     &     'potential_temperature', myThid)

      CALL MNC_CW_ADD_VNAME('fV', 'V_xy_Hn__C__t', 0,0, myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('fV','units','m/s^2', myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('fV','description',
     &     'Merid. Planetary Coriolis Acceleration (f x U)', myThid)

      CALL MNC_CW_ADD_VNAME('fU', 'U_xy_Hn__C__t', 0,0, myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('fU','units','m/s^2', myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('fU','description',
     &     'Zonal. Planetary Coriolis Acceleration (f x V)', myThid)

      CALL MNC_CW_ADD_VNAME('zV', 'V_xy_Hn__C__t', 0,0, myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('zV','units','m/s^2', myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('zV','description',
     &     'Merid. Relative Coriolis Acceleration (Zeta x U)', myThid)

      CALL MNC_CW_ADD_VNAME('zU', 'U_xy_Hn__C__t', 0,0, myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('zU','units','m/s^2', myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('zU','description',
     &     'Zonal. Relative Coriolis Acceleration (Zeta x V)', myThid)

      CALL MNC_CW_ADD_VNAME('KEx','U_xy_Hn__C__t', 0,0, myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('KEx','units','m/s^2', myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('KEx','description',
     &     'Kinetic Energy Gradient Zonal Acceleration', myThid)

      CALL MNC_CW_ADD_VNAME('KEy','V_xy_Hn__C__t', 0,0, myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('KEx','units','m/s^2', myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('KEx','description',
     &     'Kinetic Energy Gradient Merid. Acceleration', myThid)

      CALL MNC_CW_ADD_VNAME('Ds', 'Cor_xy_Hn__C__t', 0,0, myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('Ds','units','1/s', myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('Ds','description',
     &     'Horiz. Velocity Shear Strain Rate (u_y+v_x)', myThid)

      CALL MNC_CW_ADD_VNAME('Dt', 'Cen_xy_Hn__C__t', 0,0, myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('Dt','units','1/s', myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('Dt','description',
     &     'Horiz. Velocity Tension Rate (u_x-v_y)', myThid)

      CALL MNC_CW_ADD_VNAME('Du', 'U_xy_Hn__C__t', 0,0, myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('Du','units','m/s^2', myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('Du','description',
     &     'Explicit Viscous Zonal Acceleration', myThid)

      CALL MNC_CW_ADD_VNAME('Dv', 'V_xy_Hn__C__t', 0,0, myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('Dv','units','m/s^2', myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('Dv','description',
     &     'Explicit Viscous Merid. Acceleration', myThid)

      CALL MNC_CW_ADD_VNAME('Z3', 'Cor_xy_Hn__C__t', 0,0, myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('Z3','units','1/s', myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('Z3','description',
     &     'Vertical Relative Vorticity (v_x-u_y)', myThid)

      CALL MNC_CW_ADD_VNAME('W3', 'Cor_xy_Hn__C__t', 0,0, myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('W3','units','1/s', myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('W3','description',
     &     'Vertical Absolute Vorticity (v_x-u_y+f)', myThid)

      CALL MNC_CW_ADD_VNAME('KE', 'Cen_xy_Hn__C__t', 0,0, myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('KE','units','1/s', myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('KE','description',
     &     'Kinetic Energy of Horiz. Vel. (u^2+v^2)/2', myThid)

      CALL MNC_CW_ADD_VNAME('D',  'Cen_xy_Hn__C__t', 0,0, myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('D','units','1/s', myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('D','description',
     &     'Divergence of Horiz. Vel. (u_x+v_y)', myThid)

C     Define variables from FFIELDS.h
      CALL MNC_CW_ADD_VNAME('fu', 'U_xy_Hn__-__t', 3,4, myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('fu','units','N/m^2', myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('fu','description',
     &     'Zonal surface wind stress', myThid)

      CALL MNC_CW_ADD_VNAME('fv', 'V_xy_Hn__-__t', 3,4, myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('fv','units','N/m^2', myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('fv','description',
     &     'Meridional surface wind stress', myThid)

      CALL MNC_CW_ADD_VNAME('Qnet', 'Cen_xy_Hn__-__t', 3,4, myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('Qnet','units','W/m^2', myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('Qnet','description',
     &     'Net upward surface heat flux (including shortwave)',
     &     myThid)

      CALL MNC_CW_ADD_VNAME('Qsw', 'Cen_xy_Hn__-__t', 3,4, myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('Qsw','units','W/m^2', myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('Qsw','description',
     &     'Net upward shortwave radiation', myThid)

      CALL MNC_CW_ADD_VNAME('EmPmR', 'Cen_xy_Hn__-__t', 3,4, myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('EmPmR','units','kg/m^2/s', myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('EmPmR','description',
     &     'Net upward freshwater flux', myThid)

      CALL MNC_CW_ADD_VNAME('saltFlux', 'Cen_xy_Hn__-__t', 3,4, myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('saltFlux','units','g/m^2/s', myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('saltFlux','description',
     &     'Net upward salt flux', myThid)

      CALL MNC_CW_ADD_VNAME('SST', 'Cen_xy_Hn__-__t', 3,4, myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('SST','units','deg C', myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('SST','description',
     &     ' Sea surface temperature for relaxation', myThid)

      CALL MNC_CW_ADD_VNAME('SSS', 'Cen_xy_Hn__-__t', 3,4, myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('SSS','units','g/kg', myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('SSS','description',
     &     'Sea surface salinity for relaxation', myThid)


      ENDIF

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
#endif /* ALLOW_MNC */

      RETURN
      END

#include "OBSFIT_OPTIONS.h"

CBOP
C     !ROUTINE: OBSFIT_READ_OBS

C     !INTERFACE:
      SUBROUTINE OBSFIT_READ_OBS(
     I                            fNb,
     I                            vNb,
     I                            irec,
     O                            vec_loc,
     I                            myThid )

C     !DESCRIPTION:
C     ==================================================================
C     | Reads an observation and its uncertainty from a netcdf ObsFit
C     | input file
C     ==================================================================

C     !USES:
      IMPLICIT NONE
C     == Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "DYNVARS.h"
#ifdef ALLOW_OBSFIT
# include "netcdf.inc"
# include "OBSFIT_SIZE.h"
# include "OBSFIT.h"
#endif

C     !INPUT PARAMETERS:
C     fNb, vNb ::
C     irec     :: sample record number
C     myThid   :: my thread ID number
C     vec_loc  ::
      INTEGER fNb, vNb
      INTEGER irec, myThid
      _RL     vec_loc
CEOP

#ifdef ALLOW_OBSFIT
C     !LOCAL VARIABLES:
C     tmpObsNo :: number of obs in the file
      INTEGER vv, err, varID, tmpObsNo
      INTEGER vec_start,vec_count
      _RL     vec_tmp1(1000),vec_tmp2(1000)
      CHARACTER*(MAX_LEN_MBUF) msgbuf

      IF ( (irec.LT.obsfit_minind_buff) .OR.
     &     (irec.GT.obsfit_maxind_buff) .OR.
     &     (obsfit_curfile_buff.NE.fNb) ) THEN
       err = NF_INQ_DIMID( fiddata_obs(fNb),'iOBS', varID )
       CALL OBSFIT_NF_ERROR(
     &      'READ_OBS: NF_INQ_DIMID fiddata iObs',
     &      err, 0, 0, myThid )
       err = NF_INQ_DIMLEN( fiddata_obs(fNb), varID, tmpObsNo )
       CALL OBSFIT_NF_ERROR( 'READ_OBS: NF_INQ_DIMLEN tmpObsNo',
     &      err, 0, 0, myThid )

       IF ( obsfit_curfile_buff.NE.fNb ) THEN
C No asumption on whether a forward or a backward loop is calling
         obsfit_minind_buff = MAX(1,irec-500+1)
         obsfit_maxind_buff = MIN(tmpObsNo,irec+500)

       ELSEIF ( irec.LT.obsfit_minind_buff ) THEN
C Implies that a backward loop is calling
         obsfit_minind_buff = MAX(1,irec-999)
         obsfit_maxind_buff = irec

       ELSE
C Implies that a forward loop is calling
         obsfit_minind_buff = irec
         obsfit_maxind_buff = MIN(tmpObsNo,irec+999)

       ENDIF !IF (obsfit_curfile_buff.NE.fNb)

#ifdef ALLOW_DEBUG
       IF ( debugLevel.GE.debLevD ) THEN
         WRITE( msgbuf,'(A,5I9)' )
     &    'buffer readobsfile ',
     &    obsfit_minind_buff, obsfit_maxind_buff,
     &    irec, ObsNo(fNb), tmpObsNo
         CALL PRINT_MESSAGE( msgbuf,
     &        standardMessageUnit, SQUEEZE_RIGHT, myThid )
       ENDIF
#endif

       vec_start = obsfit_minind_buff
       vec_count = obsfit_maxind_buff-obsfit_minind_buff+1

       err = NF_INQ_VARID( fiddata_obs(fNb), obsfit_nameval, varID )
       CALL OBSFIT_NF_ERROR(
     &      'READ_OBS: NF_INQ_VARID obsfit_nameval',err,0,0,myThid )
       err = NF_GET_VARA_DOUBLE( fiddata_obs(fNb), varID, vec_start,
     &       vec_count, vec_tmp1 )
       CALL OBSFIT_NF_ERROR(
     &      'READ_OBS: NF_GET_VARA_DOUBLE vec_tmp1',err,0,0,myThid )
       err = NF_INQ_VARID( fiddata_obs(fNb), obsfit_nameuncert, varID )
       CALL OBSFIT_NF_ERROR(
     &      'READ_OBS: NF_INQ_VARID obsfit_nameuncert',err,0,0,myThid )
       err = NF_GET_VARA_DOUBLE( fiddata_obs(fNb), varID, vec_start,
     &       vec_count, vec_tmp2 )
       CALL OBSFIT_NF_ERROR(
     &      'READ_OBS: NF_GET_VARA_DOUBLE vec_tmp2',err,0,0,myThid )

        IF ( err.NE.NF_NOERR ) THEN
         WRITE( errorMessageUnit,'(A)' )
     &        'WARNING in obsfit_read_obs: record not found!!'
        ENDIF

        DO vv = 1, vec_count
          obsfit_data_buff(vv) = vec_tmp1(vv)
          obsfit_uncert_buff(vv) = vec_tmp2(vv)
        ENDDO

        obsfit_curfile_buff = fNb
      ENDIF

      IF ( vNb.LT.0 ) THEN
        vec_loc = obsfit_uncert_buff(irec-obsfit_minind_buff+1)

      ELSE
        vec_loc = obsfit_data_buff(irec-obsfit_minind_buff+1)
      ENDIF

#endif /* ALLOW_OBSFIT */

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#include "STREAMICE_OPTIONS.h"

C--   File streamice_cg_functions.F:
C--    Contents:
C--    o STREAMICE_CG_ACTION
C--    o STREAMICE_CG_MAKE_A
C--    o STREAMICE_CG_ADIAG
C--    o STREAMICE_CG_BOUND_VALS

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

CBOP
      SUBROUTINE STREAMICE_CG_ACTION( myThid,
     O    uret,
     O    vret,
     I    u,
     I    v,
     I    is, ie, js, je )
C     /============================================================\
C     | SUBROUTINE                                                 |
C     | o                                                          |
C     |============================================================|
C     |                                                            |
C     \============================================================/
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "STREAMICE.h"
#include "STREAMICE_CG.h"

C     !INPUT/OUTPUT ARGUMENTS
C     uret, vret - result of matrix operating on u, v
C     is, ie, js, je - starting and ending cells
      INTEGER myThid
      _RL uret (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL vret (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL u (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL v (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      INTEGER is, ie, js, je

#ifdef ALLOW_STREAMICE

C the linear action of the matrix on (u,v) with triangular finite elements
C as of now everything is passed in so no grid pointers or anything of the sort have to be dereferenced,
C but this may change pursuant to conversations with others
C
C is & ie are the cells over which the iteration is done; this may change between calls to this subroutine
C     in order to make less frequent halo updates
C isym = 1 if grid is symmetric, 0 o.w.

C the linear action of the matrix on (u,v) with triangular finite elements
C Phi has the form
C Phi (i,j,k,q) - applies to cell i,j

C      3 - 4
C      |   |
C      1 - 2

C Phi (i,j,2*k-1,q) gives d(Phi_k)/dx at quadrature point q
C Phi (i,j,2*k,q) gives d(Phi_k)/dy at quadrature point q
C Phi_k is equal to 1 at vertex k, and 0 at vertex l .ne. k, and bilinear

C     !LOCAL VARIABLES:
C     == Local variables ==
      INTEGER iq, jq, inode, jnode, i, j, bi, bj, ilq, jlq, m, n,Gi,Gj
      _RL ux, vx, uy, vy, uq, vq, exx, eyy, exy
      _RL phival(2,2)

      uret(1,1,1,1) = uret(1,1,1,1)
      vret(1,1,1,1) = vret(1,1,1,1)

      DO j = js, je
       DO i = is, ie
        DO bj = myByLo(myThid), myByHi(myThid)
         DO bi = myBxLo(myThid), myBxHi(myThid)

         Gi = (myXGlobalLo-1)+(bi-1)*sNx+i
         Gj = (myYGlobalLo-1)+(bj-1)*sNy+j

          IF (STREAMICE_hmask (i,j,bi,bj) .eq. 1.0) THEN
           DO iq = 1,2
            DO jq = 1,2

            n = 2*(jq-1)+iq

            uq = u(i,j,bi,bj) * Xquad(3-iq) * Xquad(3-jq) +
     &       u(i+1,j,bi,bj) * Xquad(iq) * Xquad(3-jq) +
     &       u(i,j+1,bi,bj) * Xquad(3-iq) * Xquad(jq) +
     &       u(i+1,j+1,bi,bj) * Xquad(iq) * Xquad(jq)
            vq = v(i,j,bi,bj) * Xquad(3-iq) * Xquad(3-jq) +
     &       v(i+1,j,bi,bj) * Xquad(iq) * Xquad(3-jq) +
     &       v(i,j+1,bi,bj) * Xquad(3-iq) * Xquad(jq) +
     &       v(i+1,j+1,bi,bj) * Xquad(iq) * Xquad(jq)
            ux = u(i,j,bi,bj) * DPhi(i,j,bi,bj,1,n,1) +
     &       u(i+1,j,bi,bj) * DPhi(i,j,bi,bj,2,n,1) +
     &       u(i,j+1,bi,bj) * DPhi(i,j,bi,bj,3,n,1) +
     &       u(i+1,j+1,bi,bj) * DPhi(i,j,bi,bj,4,n,1)
            uy = u(i,j,bi,bj) * DPhi(i,j,bi,bj,1,n,2) +
     &       u(i+1,j,bi,bj) * DPhi(i,j,bi,bj,2,n,2) +
     &       u(i,j+1,bi,bj) * DPhi(i,j,bi,bj,3,n,2) +
     &       u(i+1,j+1,bi,bj) * DPhi(i,j,bi,bj,4,n,2)
            vx = v(i,j,bi,bj) * DPhi(i,j,bi,bj,1,n,1) +
     &       v(i+1,j,bi,bj) * DPhi(i,j,bi,bj,2,n,1) +
     &       v(i,j+1,bi,bj) * DPhi(i,j,bi,bj,3,n,1) +
     &       v(i+1,j+1,bi,bj) * DPhi(i,j,bi,bj,4,n,1)
            vy = v(i,j,bi,bj) * DPhi(i,j,bi,bj,1,n,2) +
     &       v(i+1,j,bi,bj) * DPhi(i,j,bi,bj,2,n,2) +
     &       v(i,j+1,bi,bj) * DPhi(i,j,bi,bj,3,n,2) +
     &       v(i+1,j+1,bi,bj) * DPhi(i,j,bi,bj,4,n,2)
            exx = ux + k1AtC_str(i,j,bi,bj)*vq
            eyy = vy + k2AtC_str(i,j,bi,bj)*uq
            exy = .5*(uy+vx) +
     &       k1AtC_str(i,j,bi,bj)*uq + k2AtC_str(i,j,bi,bj)*vq

            do inode = 1,2
             do jnode = 1,2

             m = 2*(jnode-1)+inode
             ilq = 1
             jlq = 1
             if (inode.eq.iq) ilq = 2
             if (jnode.eq.jq) jlq = 2
             phival(inode,jnode) = Xquad(ilq)*Xquad(jlq)

             if (STREAMICE_umask(i-1+inode,j-1+jnode,bi,bj).eq.1.0) then

              uret(i-1+inode,j-1+jnode,bi,bj) =
     &         uret(i-1+inode,j-1+jnode,bi,bj) + .25 *
     &         grid_jacq_streamice(i,j,bi,bj,n) *
     &         visc_streamice(i,j,bi,bj) * (
     &          DPhi(i,j,bi,bj,m,n,1)*(4*exx+2*eyy) +
     &          DPhi(i,j,bi,bj,m,n,2)*(2*exy))

              uret(i-1+inode,j-1+jnode,bi,bj) =
     &         uret(i-1+inode,j-1+jnode,bi,bj) + .25 *
     &         grid_jacq_streamice(i,j,bi,bj,n) *
     &         visc_streamice(i,j,bi,bj) * phival(inode,jnode) *
     &         (4*k2AtC_str(i,j,bi,bj)*eyy+2*k2AtC_str(i,j,bi,bj)*exx+
     &          4*0.5*k1AtC_str(i,j,bi,bj)*exy)

              uret(i-1+inode,j-1+jnode,bi,bj) =
     &         uret(i-1+inode,j-1+jnode,bi,bj) + .25 *
     &         phival(inode,jnode) *
     &         grid_jacq_streamice(i,j,bi,bj,n) *
     &         tau_beta_eff_streamice (i,j,bi,bj) * uq

             endif

             if (STREAMICE_vmask(i-1+inode,j-1+jnode,bi,bj).eq.1.0) then
              vret(i-1+inode,j-1+jnode,bi,bj) =
     &         vret(i-1+inode,j-1+jnode,bi,bj) + .25 *
     &         grid_jacq_streamice(i,j,bi,bj,n) *
     &         visc_streamice(i,j,bi,bj) * (
     &          DPhi(i,j,bi,bj,m,n,2)*(4*eyy+2*exx) +
     &          DPhi(i,j,bi,bj,m,n,1)*(2*exy))
              vret(i-1+inode,j-1+jnode,bi,bj) =
     &         vret(i-1+inode,j-1+jnode,bi,bj) + .25 *
     &         grid_jacq_streamice(i,j,bi,bj,n) *
     &         visc_streamice(i,j,bi,bj) * phival(inode,jnode) *
     &         (4*k1AtC_str(i,j,bi,bj)*exx+2*k1AtC_str(i,j,bi,bj)*eyy+
     &          4*0.5*k2AtC_str(i,j,bi,bj)*exy)
              vret(i-1+inode,j-1+jnode,bi,bj) =
     &         vret(i-1+inode,j-1+jnode,bi,bj) + .25 *
     &         phival(inode,jnode) *
     &         grid_jacq_streamice(i,j,bi,bj,n) *
     &         tau_beta_eff_streamice (i,j,bi,bj) * vq

             endif
            enddo
            enddo

           enddo
           enddo
c-- STREAMICE_hmask
          endif

         enddo
        enddo
       enddo
      enddo

#endif
      RETURN
      END SUBROUTINE

      SUBROUTINE STREAMICE_CG_MAKE_A( myThid )
C     /============================================================\
C     | SUBROUTINE                                                 |
C     | o                                                          |
C     |============================================================|
C     |                                                            |
C     \============================================================/
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "STREAMICE.h"
#include "STREAMICE_CG.h"

C     !INPUT/OUTPUT ARGUMENTS
C     uret, vret - result of matrix operating on u, v
C     is, ie, js, je - starting and ending cells
      INTEGER myThid

#ifdef ALLOW_STREAMICE

#ifdef STREAMICE_CONSTRUCT_MATRIX

C the linear action of the matrix on (u,v) with triangular finite elements
C as of now everything is passed in so no grid pointers or anything of the sort have to be dereferenced,
C but this may change pursuant to conversations with others
C
C is & ie are the cells over which the iteration is done; this may change between calls to this subroutine
C     in order to make less frequent halo updates
C isym = 1 if grid is symmetric, 0 o.w.

C the linear action of the matrix on (u,v) with triangular finite elements
C Phi has the form
C Phi (i,j,k,q) - applies to cell i,j

C      3 - 4
C      |   |
C      1 - 2

C Phi (i,j,2*k-1,q) gives d(Phi_k)/dx at quadrature point q
C Phi (i,j,2*k,q) gives d(Phi_k)/dy at quadrature point q
C Phi_k is equal to 1 at vertex k, and 0 at vertex l .ne. k, and bilinear

C     !LOCAL VARIABLES:
C     == Local variables ==
      INTEGER iq, jq, inodx, inody, i, j, bi, bj, ilqx, ilqy, m_i, n
      INTEGER jnodx,jnody, m_j, col_y, col_x, cg_halo
      INTEGER colx_rev, coly_rev
      _RL ux, vx, uy, vy, uq, vq, exx, eyy, exy, tmpval
      _RL phival(2,2)

c       do i=1,3
c        do j=0,2
c         col_index_a = i + j*3
c        enddo
c       enddo

      cg_halo = min(OLx-1,OLy-1)

      DO j = 1-cg_halo, sNy+cg_halo
       DO i = 1-cg_halo, sNx+cg_halo
        DO bj = myByLo(myThid), myByHi(myThid)
         DO bi = myBxLo(myThid), myBxHi(myThid)
cc          DO k=1,4
           DO col_x=-1,1
            DO col_y=-1,1
             streamice_cg_A1(i,j,bi,bj,col_x,col_y)=0.0
             streamice_cg_A2(i,j,bi,bj,col_x,col_y)=0.0
             streamice_cg_A3(i,j,bi,bj,col_x,col_y)=0.0
             streamice_cg_A4(i,j,bi,bj,col_x,col_y)=0.0
            ENDDO
           ENDDO
cc          ENDDO
         ENDDO
        ENDDO
       ENDDO
      ENDDO

c$openad xxx simple loop
      DO j = 1-cg_halo, sNy+cg_halo
       DO i = 1-cg_halo, sNx+cg_halo
        DO bj = myByLo(myThid), myByHi(myThid)
         DO bi = myBxLo(myThid), myBxHi(myThid)
          IF (STREAMICE_hmask (i,j,bi,bj) .eq. 1.0) THEN
           DO iq=1,2
            DO jq = 1,2

             n = 2*(jq-1)+iq

             DO inodx = 1,2
              DO inody = 1,2

               if (STREAMICE_umask(i-1+inodx,j-1+inody,bi,bj)
     &          .eq.1.0 .or.
     &             streamice_vmask(i-1+inodx,j-1+inody,bi,bj).eq.1.0)
     &          then

                m_i = 2*(inody-1)+inodx
                ilqx = 1
                ilqy = 1

                if (inodx.eq.iq) ilqx = 2
                if (inody.eq.jq) ilqy = 2
                phival(inodx,inody) = Xquad(ilqx)*Xquad(ilqy)

                DO jnodx = 1,2
                 DO jnody = 1,2
                  if (STREAMICE_umask(i-1+jnodx,j-1+jnody,bi,bj)
     &             .eq.1.0 .or.
     &             STREAMICE_vmask(i-1+jnodx,j-1+jnody,bi,bj).eq.1.0)
     &             then

                   m_j = 2*(jnody-1)+jnodx
                   ilqx = 1
                   ilqy = 1
                   if (jnodx.eq.iq) ilqx = 2
                   if (jnody.eq.jq) ilqy = 2

c                    col_j = col_index_a (
c      &              jnodx+mod(inodx,2),
c      &              jnody+mod(inody,2) )

                   col_x = mod(inodx,2)+jnodx-2
                   colx_rev = mod(jnodx,2)+inodx-2
                   col_y = mod(inody,2)+jnody-2
                   coly_rev = mod(jnody,2)+inody-2
c

                   IF ( (inodx.eq.jnodx .and. inody.eq.jnody) .or.
     &                  (inodx.eq.1 .and. inody.eq.1) .or.
     &                  (jnody.eq.2 .and. inody.eq.1) .or.
     &                  (jnody.eq.2 .and. jnodx.eq.2)) THEN

                   ux = DPhi (i,j,bi,bj,m_j,n,1)
                   uy = DPhi (i,j,bi,bj,m_j,n,2)
                   vx = 0
                   vy = 0
                   uq = Xquad(ilqx) * Xquad(ilqy)
                   vq = 0

                   exx = ux + k1AtC_str(i,j,bi,bj)*vq
                   eyy = vy + k2AtC_str(i,j,bi,bj)*uq
                   exy = .5*(uy+vx) +
     &              k1AtC_str(i,j,bi,bj)*uq + k2AtC_str(i,j,bi,bj)*vq

                    tmpval = .25 *
     &              grid_jacq_streamice(i,j,bi,bj,n) *
     &              visc_streamice(i,j,bi,bj) * (
     &              DPhi(i,j,bi,bj,m_i,n,1)*(4*exx+2*eyy) +
     &              DPhi(i,j,bi,bj,m_i,n,2)*(2*exy))

                   streamice_cg_A1
     &                 (i-1+inodx,j-1+inody,bi,bj,mod(inodx,2)+jnodx-2,
     &                  mod(inody,2)+jnody-2)=
     &             streamice_cg_A1
     &                 (i-1+inodx,j-1+inody,bi,bj,mod(inodx,2)+jnodx-2,
     &                  mod(inody,2)+jnody-2)+tmpval

                   IF (.not. (inodx.eq.jnodx .and. inody.eq.jnody)) THEN
                    streamice_cg_A1
     &               (i-1+jnodx,j-1+jnody,bi,bj,mod(jnodx,2)+inodx-2,
     &                mod(jnody,2)+inody-2)=
     &              streamice_cg_A1
     &               (i-1+jnodx,j-1+jnody,bi,bj,mod(jnodx,2)+inodx-2,
     &                mod(jnody,2)+inody-2)+
     &               tmpval
                   ENDIF

c!!

                    tmpval = .25 *
     &              grid_jacq_streamice(i,j,bi,bj,n) *
     &              visc_streamice(i,j,bi,bj) * (
     &              DPhi(i,j,bi,bj,m_i,n,2)*(4*eyy+2*exx) +
     &              DPhi(i,j,bi,bj,m_i,n,1)*(2*exy))

                   streamice_cg_A3
     &                 (i-1+inodx,j-1+inody,bi,bj,mod(inodx,2)+jnodx-2,
     &                  mod(inody,2)+jnody-2)=
     &             streamice_cg_A3
     &                 (i-1+inodx,j-1+inody,bi,bj,mod(inodx,2)+jnodx-2,
     &                  mod(inody,2)+jnody-2)+tmpval

                   IF (.not. (inodx.eq.jnodx .and. inody.eq.jnody)) THEN
                    streamice_cg_A2
     &               (i-1+jnodx,j-1+jnody,bi,bj,mod(jnodx,2)+inodx-2,
     &                mod(jnody,2)+inody-2)=
     &              streamice_cg_A2
     &               (i-1+jnodx,j-1+jnody,bi,bj,mod(jnodx,2)+inodx-2,
     &                mod(jnody,2)+inody-2)+
     &               tmpval
                   ENDIF

c!!

                    tmpval = .25 *
     &              grid_jacq_streamice(i,j,bi,bj,n) *
     &              visc_streamice(i,j,bi,bj) * phival(inodx,inody) *
     &             (4*k2AtC_str(i,j,bi,bj)*eyy+2*k2AtC_str(i,j,bi,bj)*
     &              exx+4*0.5*k1AtC_str(i,j,bi,bj)*exy)

                   streamice_cg_A1
     &                 (i-1+inodx,j-1+inody,bi,bj,mod(inodx,2)+jnodx-2,
     &                  mod(inody,2)+jnody-2)=
     &             streamice_cg_A1
     &                 (i-1+inodx,j-1+inody,bi,bj,mod(inodx,2)+jnodx-2,
     &                  mod(inody,2)+jnody-2)+tmpval

                   IF (.not. (inodx.eq.jnodx .and. inody.eq.jnody)) THEN
                    streamice_cg_A1
     &               (i-1+jnodx,j-1+jnody,bi,bj,mod(jnodx,2)+inodx-2,
     &                mod(jnody,2)+inody-2)=
     &              streamice_cg_A1
     &               (i-1+jnodx,j-1+jnody,bi,bj,mod(jnodx,2)+inodx-2,
     &                mod(jnody,2)+inody-2)+
     &               tmpval
                   ENDIF

c!!

                   tmpval = .25 *
     &              grid_jacq_streamice(i,j,bi,bj,n) *
     &              visc_streamice(i,j,bi,bj) * phival(inodx,inody) *
     &             (4*k1AtC_str(i,j,bi,bj)*exx+2*k1AtC_str(i,j,bi,bj)*
     &              eyy+4*0.5*k2AtC_str(i,j,bi,bj)*exy)

                   streamice_cg_A3
     &                 (i-1+inodx,j-1+inody,bi,bj,mod(inodx,2)+jnodx-2,
     &                  mod(inody,2)+jnody-2)=
     &             streamice_cg_A3
     &                 (i-1+inodx,j-1+inody,bi,bj,mod(inodx,2)+jnodx-2,
     &                  mod(inody,2)+jnody-2)+tmpval

                   IF (.not. (inodx.eq.jnodx .and. inody.eq.jnody)) THEN
                    streamice_cg_A2
     &               (i-1+jnodx,j-1+jnody,bi,bj,mod(jnodx,2)+inodx-2,
     &                mod(jnody,2)+inody-2)=
     &              streamice_cg_A2
     &               (i-1+jnodx,j-1+jnody,bi,bj,mod(jnodx,2)+inodx-2,
     &                mod(jnody,2)+inody-2)+
     &               tmpval
                   ENDIF

c!!

                    tmpval = .25*phival(inodx,inody) *
     &              grid_jacq_streamice(i,j,bi,bj,n) *
     &              tau_beta_eff_streamice (i,j,bi,bj) * uq

                   streamice_cg_A1
     &                 (i-1+inodx,j-1+inody,bi,bj,mod(inodx,2)+jnodx-2,
     &                  mod(inody,2)+jnody-2)=
     &             streamice_cg_A1
     &                 (i-1+inodx,j-1+inody,bi,bj,mod(inodx,2)+jnodx-2,
     &                  mod(inody,2)+jnody-2)+tmpval

                   IF (.not. (inodx.eq.jnodx .and. inody.eq.jnody)) THEN
                    streamice_cg_A1
     &               (i-1+jnodx,j-1+jnody,bi,bj,mod(jnodx,2)+inodx-2,
     &                mod(jnody,2)+inody-2)=
     &              streamice_cg_A1
     &               (i-1+jnodx,j-1+jnody,bi,bj,mod(jnodx,2)+inodx-2,
     &                mod(jnody,2)+inody-2)+
     &               tmpval
                   ENDIF

c!!
                    tmpval = .25*phival(inodx,inody) *
     &              grid_jacq_streamice(i,j,bi,bj,n) *
     &              tau_beta_eff_streamice (i,j,bi,bj) * vq

                   streamice_cg_A3
     &                 (i-1+inodx,j-1+inody,bi,bj,mod(inodx,2)+jnodx-2,
     &                  mod(inody,2)+jnody-2)=
     &             streamice_cg_A3
     &                 (i-1+inodx,j-1+inody,bi,bj,mod(inodx,2)+jnodx-2,
     &                  mod(inody,2)+jnody-2)+tmpval

                   IF (.not. (inodx.eq.jnodx .and. inody.eq.jnody)) THEN
                    streamice_cg_A2
     &               (i-1+jnodx,j-1+jnody,bi,bj,mod(jnodx,2)+inodx-2,
     &                mod(jnody,2)+inody-2)=
     &              streamice_cg_A2
     &               (i-1+jnodx,j-1+jnody,bi,bj,mod(jnodx,2)+inodx-2,
     &                mod(jnody,2)+inody-2)+
     &               tmpval
                   ENDIF

c!!

                   vx = DPhi (i,j,bi,bj,m_j,n,1)
                   vy = DPhi (i,j,bi,bj,m_j,n,2)
                   ux = 0
                   uy = 0
                   vq = Xquad(ilqx) * Xquad(ilqy)
                   uq = 0

                   exx = ux + k1AtC_str(i,j,bi,bj)*vq
                   eyy = vy + k2AtC_str(i,j,bi,bj)*uq
                   exy = .5*(uy+vx) +
     &              k1AtC_str(i,j,bi,bj)*uq + k2AtC_str(i,j,bi,bj)*vq

                    tmpval = .25 *
     &              grid_jacq_streamice(i,j,bi,bj,n) *
     &              visc_streamice(i,j,bi,bj) * (
     &              DPhi(i,j,bi,bj,m_i,n,1)*(4*exx+2*eyy) +
     &              DPhi(i,j,bi,bj,m_i,n,2)*(2*exy))

                   streamice_cg_A2
     &                 (i-1+inodx,j-1+inody,bi,bj,mod(inodx,2)+jnodx-2,
     &                  mod(inody,2)+jnody-2)=
     &             streamice_cg_A2
     &                 (i-1+inodx,j-1+inody,bi,bj,mod(inodx,2)+jnodx-2,
     &                  mod(inody,2)+jnody-2)+tmpval

                   IF (.not. (inodx.eq.jnodx .and. inody.eq.jnody)) THEN
                    streamice_cg_A3
     &               (i-1+jnodx,j-1+jnody,bi,bj,mod(jnodx,2)+inodx-2,
     &                mod(jnody,2)+inody-2)=
     &              streamice_cg_A3
     &               (i-1+jnodx,j-1+jnody,bi,bj,mod(jnodx,2)+inodx-2,
     &                mod(jnody,2)+inody-2)+
     &               tmpval
                   ENDIF

                    tmpval = .25 *
     &              grid_jacq_streamice(i,j,bi,bj,n) *
     &              visc_streamice(i,j,bi,bj) * (
     &              DPhi(i,j,bi,bj,m_i,n,2)*(4*eyy+2*exx) +
     &              DPhi(i,j,bi,bj,m_i,n,1)*(2*exy))

                   streamice_cg_A4
     &                 (i-1+inodx,j-1+inody,bi,bj,mod(inodx,2)+jnodx-2,
     &                  mod(inody,2)+jnody-2)=
     &             streamice_cg_A4
     &                 (i-1+inodx,j-1+inody,bi,bj,mod(inodx,2)+jnodx-2,
     &                  mod(inody,2)+jnody-2)+tmpval

                   IF (.not. (inodx.eq.jnodx .and. inody.eq.jnody)) THEN
                    streamice_cg_A4
     &               (i-1+jnodx,j-1+jnody,bi,bj,mod(jnodx,2)+inodx-2,
     &                mod(jnody,2)+inody-2)=
     &              streamice_cg_A4
     &               (i-1+jnodx,j-1+jnody,bi,bj,mod(jnodx,2)+inodx-2,
     &                mod(jnody,2)+inody-2)+
     &               tmpval
                   ENDIF

                   tmpval = .25 *
     &              grid_jacq_streamice(i,j,bi,bj,n) *
     &              visc_streamice(i,j,bi,bj) * phival(inodx,inody) *
     &             (4*k2AtC_str(i,j,bi,bj)*eyy+2*k2AtC_str(i,j,bi,bj)*
     &              exx+4*0.5*k1AtC_str(i,j,bi,bj)*exy)

                   streamice_cg_A2
     &                 (i-1+inodx,j-1+inody,bi,bj,mod(inodx,2)+jnodx-2,
     &                  mod(inody,2)+jnody-2)=
     &             streamice_cg_A2
     &                 (i-1+inodx,j-1+inody,bi,bj,mod(inodx,2)+jnodx-2,
     &                  mod(inody,2)+jnody-2)+tmpval

                   IF (.not. (inodx.eq.jnodx .and. inody.eq.jnody)) THEN
                    streamice_cg_A3
     &               (i-1+jnodx,j-1+jnody,bi,bj,mod(jnodx,2)+inodx-2,
     &                mod(jnody,2)+inody-2)=
     &              streamice_cg_A3
     &               (i-1+jnodx,j-1+jnody,bi,bj,mod(jnodx,2)+inodx-2,
     &                mod(jnody,2)+inody-2)+
     &               tmpval
                   ENDIF

                   tmpval = .25 *
     &              grid_jacq_streamice(i,j,bi,bj,n) *
     &              visc_streamice(i,j,bi,bj) * phival(inodx,inody) *
     &             (4*k1AtC_str(i,j,bi,bj)*exx+2*k1AtC_str(i,j,bi,bj)*
     &              eyy+4*0.5*k2AtC_str(i,j,bi,bj)*exy)

                   streamice_cg_A4
     &                 (i-1+inodx,j-1+inody,bi,bj,mod(inodx,2)+jnodx-2,
     &                  mod(inody,2)+jnody-2)=
     &             streamice_cg_A4
     &                 (i-1+inodx,j-1+inody,bi,bj,mod(inodx,2)+jnodx-2,
     &                  mod(inody,2)+jnody-2)+tmpval

                   IF (.not. (inodx.eq.jnodx .and. inody.eq.jnody)) THEN
                    streamice_cg_A4
     &               (i-1+jnodx,j-1+jnody,bi,bj,mod(jnodx,2)+inodx-2,
     &                mod(jnody,2)+inody-2)=
     &              streamice_cg_A4
     &               (i-1+jnodx,j-1+jnody,bi,bj,mod(jnodx,2)+inodx-2,
     &                mod(jnody,2)+inody-2)+
     &               tmpval
                   ENDIF

                    tmpval = .25*phival(inodx,inody) *
     &              grid_jacq_streamice(i,j,bi,bj,n) *
     &              tau_beta_eff_streamice (i,j,bi,bj) * uq

                   streamice_cg_A2
     &                 (i-1+inodx,j-1+inody,bi,bj,mod(inodx,2)+jnodx-2,
     &                  mod(inody,2)+jnody-2)=
     &             streamice_cg_A2
     &                 (i-1+inodx,j-1+inody,bi,bj,mod(inodx,2)+jnodx-2,
     &                  mod(inody,2)+jnody-2)+tmpval

                   IF (.not. (inodx.eq.jnodx .and. inody.eq.jnody)) THEN
                    streamice_cg_A3
     &               (i-1+jnodx,j-1+jnody,bi,bj,mod(jnodx,2)+inodx-2,
     &                mod(jnody,2)+inody-2)=
     &              streamice_cg_A3
     &               (i-1+jnodx,j-1+jnody,bi,bj,mod(jnodx,2)+inodx-2,
     &                mod(jnody,2)+inody-2)+
     &               tmpval
                   ENDIF

                    tmpval = .25*phival(inodx,inody) *
     &              grid_jacq_streamice(i,j,bi,bj,n) *
     &              tau_beta_eff_streamice (i,j,bi,bj) * vq

                   streamice_cg_A4
     &                 (i-1+inodx,j-1+inody,bi,bj,mod(inodx,2)+jnodx-2,
     &                  mod(inody,2)+jnody-2)=
     &             streamice_cg_A4
     &                 (i-1+inodx,j-1+inody,bi,bj,mod(inodx,2)+jnodx-2,
     &                  mod(inody,2)+jnody-2)+tmpval

                   IF (.not. (inodx.eq.jnodx .and. inody.eq.jnody)) THEN
                    streamice_cg_A4
     &               (i-1+jnodx,j-1+jnody,bi,bj,mod(jnodx,2)+inodx-2,
     &                mod(jnody,2)+inody-2)=
     &              streamice_cg_A4
     &               (i-1+jnodx,j-1+jnody,bi,bj,mod(jnodx,2)+inodx-2,
     &                mod(jnody,2)+inody-2)+
     &               tmpval
                   ENDIF

                   endif
                  endif
                 enddo
                enddo
               endif
              enddo
             enddo
            enddo
           enddo
          endif
         enddo
        enddo
       enddo
      enddo

#endif
#endif
      RETURN
      END SUBROUTINE
c END MAKE_A

      SUBROUTINE STREAMICE_CG_ADIAG( myThid,
     O      uret,
     O      vret)

C     /============================================================\
C     | SUBROUTINE                                                 |
C     | o                                                          |
C     |============================================================|
C     |                                                            |
C     \============================================================/
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "STREAMICE.h"
#include "STREAMICE_CG.h"

C     !INPUT/OUTPUT ARGUMENTS
C     uret, vret - result of matrix operating on u, v
C     is, ie, js, je - starting and ending cells
      INTEGER myThid
      _RL uret (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL vret (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)

#ifdef ALLOW_STREAMICE

C the linear action of the matrix on (u,v) with triangular finite elements
C as of now everything is passed in so no grid pointers or anything of the sort have to be dereferenced,
C but this may change pursuant to conversations with others
C
C is & ie are the cells over which the iteration is done; this may change between calls to this subroutine
C     in order to make less frequent halo updates
C isym = 1 if grid is symmetric, 0 o.w.

C the linear action of the matrix on (u,v) with triangular finite elements
C Phi has the form
C Phi (i,j,k,q) - applies to cell i,j

C      3 - 4
C      |   |
C      1 - 2

C Phi (i,j,2*k-1,q) gives d(Phi_k)/dx at quadrature point q
C Phi (i,j,2*k,q) gives d(Phi_k)/dy at quadrature point q
C Phi_k is equal to 1 at vertex k, and 0 at vertex l .ne. k, and bilinear

C     !LOCAL VARIABLES:
C     == Local variables ==
      INTEGER iq, jq, inode, jnode, i, j, bi, bj, ilq, jlq, m, n
      _RL ux, vx, uy, vy, uq, vq, exx, eyy, exy
      _RL phival(2,2)

      uret(1,1,1,1) = uret(1,1,1,1)
      vret(1,1,1,1) = vret(1,1,1,1)

      DO j = 0, sNy+1
       DO i = 0, sNx+1
        DO bj = myByLo(myThid), myByHi(myThid)
         DO bi = myBxLo(myThid), myBxHi(myThid)
          IF (STREAMICE_hmask (i,j,bi,bj) .eq. 1.0) THEN
           DO iq=1,2
            DO jq = 1,2

            n = 2*(jq-1)+iq

            DO inode = 1,2
             DO jnode = 1,2

             m = 2*(jnode-1)+inode

             if (STREAMICE_umask(i-1+inode,j-1+jnode,bi,bj).eq.1.0 .or.
     &           STREAMICE_vmask(i-1+inode,j-1+jnode,bi,bj).eq.1.0)
     &           then

              ilq = 1
              jlq = 1

              if (inode.eq.iq) ilq = 2
              if (jnode.eq.jq) jlq = 2
              phival(inode,jnode) = Xquad(ilq)*Xquad(jlq)

              ux = DPhi (i,j,bi,bj,m,n,1)
              uy = DPhi (i,j,bi,bj,m,n,2)
              vx = 0
              vy = 0
              uq = Xquad(ilq) * Xquad(jlq)
              vq = 0

              exx = ux + k1AtC_str(i,j,bi,bj)*vq
              eyy = vy + k2AtC_str(i,j,bi,bj)*uq
              exy = .5*(uy+vx) +
     &         k1AtC_str(i,j,bi,bj)*uq + k2AtC_str(i,j,bi,bj)*vq

              uret(i-1+inode,j-1+jnode,bi,bj) =
     &         uret(i-1+inode,j-1+jnode,bi,bj) + .25 *
     &         grid_jacq_streamice(i,j,bi,bj,n) *
     &         visc_streamice(i,j,bi,bj) * (
     &          DPhi(i,j,bi,bj,m,n,1)*(4*exx+2*eyy) +
     &          DPhi(i,j,bi,bj,m,n,2)*(2*exy))

              uret(i-1+inode,j-1+jnode,bi,bj) =
     &         uret(i-1+inode,j-1+jnode,bi,bj) + .25 *
     &         grid_jacq_streamice(i,j,bi,bj,n) *
     &         visc_streamice(i,j,bi,bj) * phival(inode,jnode) *
     &         (4*k2AtC_str(i,j,bi,bj)*eyy+2*k2AtC_str(i,j,bi,bj)*exx+
     &          4*0.5*k1AtC_str(i,j,bi,bj)*exy)

              uret(i-1+inode,j-1+jnode,bi,bj) =
     &         uret(i-1+inode,j-1+jnode,bi,bj) + .25 *
     &         phival(inode,jnode) * grid_jacq_streamice(i,j,bi,bj,n) *
     &         tau_beta_eff_streamice (i,j,bi,bj) * uq

              vx = DPhi (i,j,bi,bj,m,n,1)
              vy = DPhi (i,j,bi,bj,m,n,2)
              ux = 0
              uy = 0
              vq = Xquad(ilq) * Xquad(jlq)
              uq = 0

              exx = ux + k1AtC_str(i,j,bi,bj)*vq
              eyy = vy + k2AtC_str(i,j,bi,bj)*uq
              exy = .5*(uy+vx) +
     &         k1AtC_str(i,j,bi,bj)*uq + k2AtC_str(i,j,bi,bj)*vq

              vret(i-1+inode,j-1+jnode,bi,bj) =
     &         vret(i-1+inode,j-1+jnode,bi,bj) + .25 *
     &         grid_jacq_streamice(i,j,bi,bj,n) *
     &         visc_streamice(i,j,bi,bj) * (
     &          DPhi(i,j,bi,bj,m,n,2)*(4*eyy+2*exx) +
     &          DPhi(i,j,bi,bj,m,n,1)*(2*exy))
              vret(i-1+inode,j-1+jnode,bi,bj) =
     &         vret(i-1+inode,j-1+jnode,bi,bj) + .25 *
     &         grid_jacq_streamice(i,j,bi,bj,n) *
     &         visc_streamice(i,j,bi,bj) * phival(inode,jnode) *
     &         (4*k1AtC_str(i,j,bi,bj)*exx+2*k1AtC_str(i,j,bi,bj)*eyy+
     &          4*0.5*k2AtC_str(i,j,bi,bj)*exy)

              vret(i-1+inode,j-1+jnode,bi,bj) =
     &         vret(i-1+inode,j-1+jnode,bi,bj) + .25 *
     &         phival(inode,jnode) * grid_jacq_streamice(i,j,bi,bj,n) *
     &         tau_beta_eff_streamice (i,j,bi,bj) * vq

             endif

            enddo
            enddo
           enddo
           enddo
          endif
         enddo
        enddo
       enddo
      enddo

#endif
      RETURN
      END SUBROUTINE

      SUBROUTINE STREAMICE_CG_BOUND_VALS( myThid,
     O    uret,
     O    vret)
C     /============================================================\
C     | SUBROUTINE                                                 |
C     | o                                                          |
C     |============================================================|
C     |                                                            |
C     \============================================================/
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "STREAMICE.h"
#include "STREAMICE_CG.h"

C     !INPUT/OUTPUT ARGUMENTS
C     uret, vret - result of matrix operating on u, v
C     is, ie, js, je - starting and ending cells
      INTEGER myThid
      _RL uret (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL vret (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)

#ifdef ALLOW_STREAMICE

C the linear action of the matrix on (u,v) with triangular finite elements
C as of now everything is passed in so no grid pointers or anything of the sort have to be dereferenced,
C but this may change pursuant to conversations with others
C
C is & ie are the cells over which the iteration is done; this may change between calls to this subroutine
C     in order to make less frequent halo updates
C isym = 1 if grid is symmetric, 0 o.w.

C the linear action of the matrix on (u,v) with triangular finite elements
C Phi has the form
C Phi (i,j,k,q) - applies to cell i,j

C      3 - 4
C      |   |
C      1 - 2

C Phi (i,j,2*k-1,q) gives d(Phi_k)/dx at quadrature point q
C Phi (i,j,2*k,q) gives d(Phi_k)/dy at quadrature point q
C Phi_k is equal to 1 at vertex k, and 0 at vertex l .ne. k, and bilinear

C     !LOCAL VARIABLES:
C     == Local variables ==
      INTEGER iq, jq, inode, jnode, i, j, bi, bj, ilq, jlq, m, n
      _RL ux, vx, uy, vy, uq, vq, exx, eyy, exy
      _RL phival(2,2)

      uret(1,1,1,1) = uret(1,1,1,1)
      vret(1,1,1,1) = vret(1,1,1,1)

      DO j = 0, sNy+1
       DO i = 0, sNx+1
        DO bj = myByLo(myThid), myByHi(myThid)
         DO bi = myBxLo(myThid), myBxHi(myThid)
          IF ((STREAMICE_hmask (i,j,bi,bj) .eq. 1.0) .AND.
     &     ((STREAMICE_umask(i,j,bi,bj).eq.3.0) .OR.
     &      (STREAMICE_umask(i,j+1,bi,bj).eq.3.0) .OR.
     &      (STREAMICE_umask(i+1,j,bi,bj).eq.3.0) .OR.
     &      (STREAMICE_umask(i+1,j+1,bi,bj).eq.3.0) .OR.
     &      (STREAMICE_vmask(i,j,bi,bj).eq.3.0) .OR.
     &      (STREAMICE_vmask(i,j+1,bi,bj).eq.3.0) .OR.
     &      (STREAMICE_vmask(i+1,j,bi,bj).eq.3.0) .OR.
     &      (STREAMICE_vmask(i+1,j+1,bi,bj).eq.3.0))) THEN

           DO iq=1,2
            DO jq = 1,2

            n = 2*(jq-1)+iq

            uq = u_bdry_values_SI(i,j,bi,bj)*Xquad(3-iq)*Xquad(3-jq)+
     &       u_bdry_values_SI(i+1,j,bi,bj)*Xquad(iq)*Xquad(3-jq)+
     &       u_bdry_values_SI(i,j+1,bi,bj)*Xquad(3-iq)*Xquad(jq)+
     &       u_bdry_values_SI(i+1,j+1,bi,bj)*Xquad(iq)*Xquad(jq)
            vq = v_bdry_values_SI(i,j,bi,bj)*Xquad(3-iq)*Xquad(3-jq)+
     &       v_bdry_values_SI(i+1,j,bi,bj)*Xquad(iq)*Xquad(3-jq)+
     &       v_bdry_values_SI(i,j+1,bi,bj)*Xquad(3-iq)*Xquad(jq)+
     &       v_bdry_values_SI(i+1,j+1,bi,bj)*Xquad(iq)*Xquad(jq)
            ux = u_bdry_values_SI(i,j,bi,bj) * DPhi(i,j,bi,bj,1,n,1) +
     &       u_bdry_values_SI(i+1,j,bi,bj) * DPhi(i,j,bi,bj,2,n,1) +
     &       u_bdry_values_SI(i,j+1,bi,bj) * DPhi(i,j,bi,bj,3,n,1) +
     &       u_bdry_values_SI(i+1,j+1,bi,bj) * DPhi(i,j,bi,bj,4,n,1)
            uy = u_bdry_values_SI(i,j,bi,bj) * DPhi(i,j,bi,bj,1,n,2) +
     &       u_bdry_values_SI(i+1,j,bi,bj) * DPhi(i,j,bi,bj,2,n,2) +
     &       u_bdry_values_SI(i,j+1,bi,bj) * DPhi(i,j,bi,bj,3,n,2) +
     &       u_bdry_values_SI(i+1,j+1,bi,bj) * DPhi(i,j,bi,bj,4,n,2)
            vx = v_bdry_values_SI(i,j,bi,bj) * DPhi(i,j,bi,bj,1,n,1) +
     &       v_bdry_values_SI(i+1,j,bi,bj) * DPhi(i,j,bi,bj,2,n,1) +
     &       v_bdry_values_SI(i,j+1,bi,bj) * DPhi(i,j,bi,bj,3,n,1) +
     &       v_bdry_values_SI(i+1,j+1,bi,bj) * DPhi(i,j,bi,bj,4,n,1)
            vy = v_bdry_values_SI(i,j,bi,bj) * DPhi(i,j,bi,bj,1,n,2) +
     &       v_bdry_values_SI(i+1,j,bi,bj) * DPhi(i,j,bi,bj,2,n,2) +
     &       v_bdry_values_SI(i,j+1,bi,bj) * DPhi(i,j,bi,bj,3,n,2) +
     &       v_bdry_values_SI(i+1,j+1,bi,bj) * DPhi(i,j,bi,bj,4,n,2)
            exx = ux + k1AtC_str(i,j,bi,bj)*vq
            eyy = vy + k2AtC_str(i,j,bi,bj)*uq
            exy = .5*(uy+vx) +
     &       k1AtC_str(i,j,bi,bj)*uq + k2AtC_str(i,j,bi,bj)*vq

            do inode = 1,2
             do jnode = 1,2

             m = 2*(jnode-1)+inode
             ilq = 1
             jlq = 1
             if (inode.eq.iq) ilq = 2
             if (jnode.eq.jq) jlq = 2
             phival(inode,jnode) = Xquad(ilq)*Xquad(jlq)

             if (STREAMICE_umask(i-1+inode,j-1+jnode,bi,bj).eq.1.0) then

              uret(i-1+inode,j-1+jnode,bi,bj) =
     &         uret(i-1+inode,j-1+jnode,bi,bj) + .25 *
     &         grid_jacq_streamice(i,j,bi,bj,n) *
     &         visc_streamice(i,j,bi,bj) * (
     &          DPhi(i,j,bi,bj,m,n,1)*(4*exx+2*eyy) +
     &          DPhi(i,j,bi,bj,m,n,2)*(2*exy))

              uret(i-1+inode,j-1+jnode,bi,bj) =
     &         uret(i-1+inode,j-1+jnode,bi,bj) + .25 *
     &         grid_jacq_streamice(i,j,bi,bj,n) *
     &         visc_streamice(i,j,bi,bj) * phival(inode,jnode) *
     &         (4*k2AtC_str(i,j,bi,bj)*eyy+2*k2AtC_str(i,j,bi,bj)*exx+
     &          4*0.5*k1AtC_str(i,j,bi,bj)*exy)

c               if (STREAMICE_float_cond(i,j,bi,bj) .eq. 1) then
              uret(i-1+inode,j-1+jnode,bi,bj) =
     &         uret(i-1+inode,j-1+jnode,bi,bj) + .25 *
     &         phival(inode,jnode) * grid_jacq_streamice(i,j,bi,bj,n) *
     &         tau_beta_eff_streamice (i,j,bi,bj) * uq

c               endif
             endif
             if (STREAMICE_vmask(i-1+inode,j-1+jnode,bi,bj).eq.1.0) then
              vret(i-1+inode,j-1+jnode,bi,bj) =
     &         vret(i-1+inode,j-1+jnode,bi,bj) + .25 *
     &         grid_jacq_streamice(i,j,bi,bj,n) *
     &         visc_streamice(i,j,bi,bj) * (
     &          DPhi(i,j,bi,bj,m,n,2)*(4*eyy+2*exx) +
     &          DPhi(i,j,bi,bj,m,n,1)*(2*exy))
              vret(i-1+inode,j-1+jnode,bi,bj) =
     &         vret(i-1+inode,j-1+jnode,bi,bj) + .25 *
     &         grid_jacq_streamice(i,j,bi,bj,n) *
     &         visc_streamice(i,j,bi,bj) * phival(inode,jnode) *
     &         (4*k1AtC_str(i,j,bi,bj)*exx+2*k1AtC_str(i,j,bi,bj)*eyy+
     &          4*0.5*k2AtC_str(i,j,bi,bj)*exy)
              vret(i-1+inode,j-1+jnode,bi,bj) =
     &         vret(i-1+inode,j-1+jnode,bi,bj) + .25 *
     &         phival(inode,jnode) * grid_jacq_streamice(i,j,bi,bj,n) *
     &         tau_beta_eff_streamice (i,j,bi,bj) * vq
             endif
            enddo
            enddo
           enddo
           enddo
          endif
         enddo
        enddo
       enddo
      enddo

#endif
      RETURN
      END SUBROUTINE

#include "CHEAPAML_OPTIONS.h"

C--   File cheapaml_coare3_flux.F:
C--    Contents:
C--    o CHEAPAML_COARE3_FLUX
C--    o PSIU (Function)
C--    o PSIT (Function)

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

CBOP
C     !ROUTINE: CHEAPAML_COARE3_FLUX
C     !INTERFACE:
      SUBROUTINE CHEAPAML_COARE3_FLUX(
     I                    i,j,bi,bj, iceOrNot,
     I                    tSurf, windSq,
     O                    hf, ef, evap, Rnl, ssqt, q100, cdq, cdu,
     O                    dSensdTs, dEvapdTs, dLWdTs, dQAdTs,
     I                    myIter, myThid )

C     !DESCRIPTION:

C     !USES:
      IMPLICIT NONE
C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "CHEAPAML.h"

C     !INPUT PARAMETERS:
C     i, j     :: local indices of current grid-point
C     bi, bj   :: current tile indices
C     iceOrNot :: 0=open water, 1=ice cover, 2=ice+snow
C     tSurf    :: surface temperature
C     windSq   :: relative wind (vs surface motion) speed square
C     myIter   :: Current iteration number in simulation
C     myThid   :: My Thread Id number
      INTEGER i,j,bi,bj
      INTEGER iceOrNot
      _RL tSurf (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL windSq(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER myIter, myThid
C     !OUTPUT PARAMETERS:
C     cdu :: surface drag coeff (for wind stress)
      _RL hf, ef, evap, Rnl, ssqt, q100, cdq
      _RL cdu
C     derivative vs surf. temp of Sensible, Evap, LW, q100
      _RL dSensdTs, dEvapdTs, dLWdTs, dQAdTs
CEOP

C     !LOCAL VARIABLES:
      INTEGER iter,nits
      _RL tau,L,psu,pst,Bf
      _RL CD,usr,tsr,qsr
c     _RL ttas,ttt,ttt2,pt,essqt
      _RL zo,zot,zoq,RR,zL
      _RL twoPI,cwave,lwave

C various constants
      _RL u,q,Tas,tta,zi,es,qs,tsw
      _RL psiu,psit,zot10,Ct10,CC,Ribu
      _RL Du,Wg,Dt,Dq,u10,zo10,Cd10,Ch10
      _RL xBeta,visa,Ribcu,QaR
      _RL Ct,zetu,L10,charn

C Constants and coefficients (Stull 1988 p640).
      xBeta = 1.2 _d 0    !Given as 1.25 in Fairall et al.(1996)
      twoPI = 2. _d 0*PI
      visa = 1.326 _d -5
C default relative humidity
      QaR = 0.8 _d 0

C sea surface temperature without skin correction
c     tsw=theta(i,j,1,bi,bj)
      tsw = tSurf(i,j)
      Tas = Tair(i,j,bi,bj)

C net upward long wave
      Rnl = 0.96 _d 0*(stefan*(tsw+celsius2K)**4) !Net longwave (up = +).

C Teten''s return s air svp es in mb
      es = (1.0007 _d 0 + 3.46 _d -6*p0)*6.1121 _d 0
     &     *EXP( 17.502 _d 0*tsw/(240.97 _d 0+tsw) )
      es = es*0.98 _d 0             !reduced for salinity Kraus 1972 p. 46
C-    convert from mb to spec. humidity  kg/kg
      qs = 0.62197 _d 0*es/(p0 -0.378 _d 0*es)

      tta = Tas+celsius2K
c     ttas=tta+gamma_blk*zt
c     ttt=tta-(CheapHgrid(i,j,bi,bj) - zt)*gamma_blk
c     ttt2=tta-(CheapHgrid(i,j,bi,bj) - zt)*gamma_blk-celsius2K
c     pt = p0*(1.-gamma_blk*CheapHgrid(i,j,bi,bj)/ttas)
c    &     **(gravity/gamma_blk/gasR)
c     essqt = (1.0007 _d 0 + 3.46 _d -6*pt)*6.1121 _d 0
c    &        *EXP( 17.502 _d 0*ttt2/(240.97 _d 0+ttt2) )
C-    convert from mb to spec. humidity  kg/kg
c     ssqt = 0.62197 _d 0*essqt/(pt -0.378 _d 0*essqt)
C-     LANL formulation
C     saturation no more at the top:
      ssqt=ssq0*EXP( lath*(ssq1-ssq2/tta) ) / p0

      IF (useFreshWaterFlux) THEN
        q=qair(i,j,bi,bj)
      ELSE
        q=QaR*ssqt
      ENDIF

C Wave parameters
      cwave=gravity*wavesp(i,j,bi,bj)/twoPI
      lwave=cwave*wavesp(i,j,bi,bj)

C Initial guesses
      zo = 0.0001 _d 0
      Wg = 0.5 _d 0                 !Gustiness factor initial guess

C Air-sea differences - includes warm layer in Dt and Dq
c     u = (uwind(i,j,bi,bj)-uVel(i,j,1,bi,bj))**2
c    &  + (vwind(i,j,bi,bj)-vVel(i,j,1,bi,bj))**2
      u = windSq(i,j)
      Du= SQRT(u + Wg**2 )  !include gustiness in wind spd. difference
      u = SQRT(u)
      Dt=tsw-Tas-gamma_blk*zt  !potential temperature difference.
      Dq=qs-q

C **************** neutral coefficients ******************

      u10 = Du*LOG(10. _d 0/zo)/LOG(zu/zo)
      usr = 0.035 _d 0*u10
      zo10= 0.011 _d 0*usr*usr/gravity+0.11 _d 0*visa/usr
      Cd10= (xkar/LOG(10. _d 0/zo10))**2
      Ch10= 0.00115 _d 0
      Ct10= Ch10/SQRT(Cd10)
      zot10=10. _d 0/EXP(xkar/Ct10)
      Cd = (xkar/LOG(zu/zo10))**2

C standard coare3 boundary layer height
      zi=600. _d 0

C ************* Grachev and Fairall (JAM, 1997) **********

      Ct=xkar/LOG(zt/zot10)   ! Temperature transfer coefficient
      CC=xkar*Ct/Cd            ! z/L vs Rib linear coefficient
      Ribcu=-zu/(zi*0.004 _d 0*xBeta**3)  ! Saturation or plateau Rib
      Ribu=-gravity*zu*(Dt+0.61 _d 0*tta*Dq)/(tta*Du**2)
      IF (Ribu.LT.0. _d 0) THEN
          zetu=CC*Ribu/(1. _d 0+Ribu/Ribcu)   ! Unstable G and F
      ELSE
          zetu=CC*Ribu*(1. _d 0 +27. _d 0/9. _d 0*Ribu/CC) ! Stable
      ENDIF
      L10=zu/zetu                       ! MO length
      IF (zetu.GT.50. _d 0) THEN
        nits=1
      ELSE
        nits=3   ! number of iterations
      ENDIF

C First guess M-O stability dependent
C scaling params.(u*,t*,q*) to estimate zo and z/L

      usr= Du*xkar/(LOG(zu/zo10)-psiu(zu/L10))
      tsr=-(Dt)*xkar/(LOG(zt/zot10)-psit(zt/L10))
      qsr=-(Dq)*xkar/(LOG(zq/zot10)-psit(zq/L10))

      charn=0.011 _d 0     !then modify Charnock for high wind speeds Chris data
      IF (Du.GT.10. _d 0) charn=0.011 _d 0
     &                    + (0.018 _d 0-0.011 _d 0)*(Du-10.)/(18.-10.)
      IF (Du.GT.18. _d 0) charn=0.018 _d 0

C **** Iterate across u*(t*,q*),zo(zot,zoq) and z/L including cool skin ****

      DO iter=1,nits
       IF (WAVEMODEL.EQ.'Smith') THEN
        zo=charn*usr*usr/gravity + 0.11 _d 0*visa/usr    !after Smith 1988
       ELSEIF (WAVEMODEL.EQ.'Oost') THEN
        zo=(50./twoPI)*lwave*(usr/cwave)**4.5 _d 0
     &    + 0.11 _d 0*visa/usr !Oost et al.
       ELSEIF (WAVEMODEL.EQ.'TayYel') THEN
        zo=1200. _d 0*wavesh(i,j,bi,bj)*(wavesh(i,j,bi,bj)/lwave)**4.5
     &    + 0.11 _d 0*visa/usr !Taylor and Yelland
       ENDIF
       rr=zo*usr/visa

C *** zoq and zot fitted to results from several ETL cruises ************

       IF ( rr.LE.0. ) THEN
         WRITE(errorMessageUnit,'(A,I8,I4,A,5I4)')
     &    'CHEAPAML_COARE3_FLUX: myIter,iter=', myIter, iter,
     &    ' , in: i,j,bi,bj,thid=', i, j, bi, bj, myThid
         WRITE(errorMessageUnit,'(A,1P4E17.9)')
     &    ' rr,zo,usr,visa=', rr, zo, usr, visa
         WRITE(errorMessageUnit,'(A,1P4E17.9)')
     &    ' L,zu,zL,zt    =', L, zu, zL, zt
         WRITE(errorMessageUnit,'(A,1P4E16.8)')
     &    ' ln(zu/zo),psu,diff,zL*=', LOG(zu/zo), psu, LOG(zu/zo)-psu,
     &          ( tsr*(1.+0.61 _d 0*q)+0.61 _d 0*tta*qsr )
     &         /( tta*usr*usr*(1. _d 0+0.61 _d 0*q) )
         WRITE(errorMessageUnit,'(A,1P4E17.9)')
     &    ' tsr,tta,q,qsr  =', tsr, tta, q, qsr
         CALL MDS_FLUSH( errorMessageUnit, myThid )
         CALL MDS_FLUSH( standardMessageUnit, myThid )
       ENDIF
       zoq = MIN( 1.15 _d -4, 5.5 _d -5/rr**0.6 _d 0 )
       zot = zoq

       zL=xkar*gravity*zu*( tsr*(1.+0.61 _d 0*q)+0.61 _d 0*tta*qsr )
     &                   /( tta*usr*usr*(1. _d 0+0.61 _d 0*q) )
       L=zu/zL
       psu=psiu(zu/L)
       pst=psit(zt/L)
       usr=Du*xkar/(LOG(zu/zo)-psiu(zu/L))
       tsr=-(Dt)*xkar/(LOG(zt/zot)-psit(zt/L))
       qsr=-(Dq)*xkar/(LOG(zq/zoq)-psit(zq/L))
       Bf=-gravity/tta*usr*(tsr+0.61 _d 0*tta*qsr)
       IF (Bf.GT.0. _d 0) THEN
          Wg=xBeta*(Bf*zi)**.333 _d 0
       ELSE
          Wg=0.2 _d 0
       ENDIF
       Du=SQRT(u**2 + Wg**2)        !include gustiness in wind spd.
      ENDDO

C compute surface fluxes and other parameters
      tau=rhoa*usr*usr               !stress N/m2
      hf=-cpair*rhoa*usr*tsr         !sensible W/m2
      ef=-lath*rhoa*usr*qsr          !latent W/m2
      evap=-rhoa*usr*qsr
      cdq = evap/Dq
      cdu = tau/Du

      q100=qs+qsr*(LOG(100. _d 0/zoq)-psit(100. _d 0/L))

C--   compute derivative of surface fluxes relatice to Tsurf
C-    dSensdTs = -cpair*rhoa*usr*(tsr/Dt)
      dSensdTs = cpair*rhoa*usr
     &                *xkar/(LOG(zt/zot10)-psit(zt/L10))
C-    dEvapdTs  = -rhoa*usr* d/dTs(qsr)
C     d/dTs(qsr)= (-xkar/(LOG(zq/zoq)-psit(zq/L)) )* d/dTs(qs)
C     d/dTs(qs) = 0.62197 _d 0*p0/(p0 -0.378 _d 0*es)**2 * d/dTs(es)
C     d/dTs(es) = (0.98)* es * 17.502 _d 0 * 240.97 _d 0 / (240.97 _d 0+tsw)**2
C-    this simplifies (using qs) to:
      dEvapdTs = rhoa*usr*( xkar/(LOG(zq/zoq)-psit(zq/L)) )
     &         * qs*p0/(p0 -0.378 _d 0*es)
c    &         *0.98 _d 0
     &         * 17.502 _d 0 * 240.97 _d 0 / (240.97 _d 0+tsw)**2

      if (iceornot.EQ.0) THEN
c       dLWdTs = 4. _d 0*ocean_emissivity*stefan*tsr*tsr*tsr
        dLWdTs = 4. _d 0 * 0.96 _d 0 *stefan*tsr*tsr*tsr
      ELSEIF (iceornot.EQ.2) THEN
c       dLWdTs = 4. _d 0*snow_emissivity*stefan*tsr*tsr*tsr
        dLWdTs = 4. _d 0 * 0.96 _d 0 *stefan*tsr*tsr*tsr
      ELSEIF (iceornot.EQ.1) THEN
c       dLWdTs = 4. _d 0*ice_emissivity*stefan*tsr*tsr*tsr
        dLWdTs = 4. _d 0 * 0.96 _d 0 *stefan*tsr*tsr*tsr
      ENDIF

C--   for now, ignores derivative of q100 relative to Tsurf:
      dQAdTs = 0.

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

CBOP 0
C     !ROUTINE: PSIU

C     !INTERFACE:
      _RL FUNCTION psiu(zL)

C     !DESCRIPTION:
C psiu and psit evaluate stability function for wind speed and scalars
C matching Kansas and free convection forms with weighting f
C convective form follows Fairall et al (1996) with profile constants
C from Grachev et al (2000) BLM
C stable form from Beljaars and Holtslag (1991)

C     !USES:
      IMPLICIT NONE
#include "EEPARAMS.h"

C     !INPUT PARAMETERS:
      _RL zL
C     !LOCAL VARIABLES:
      _RL x,y,psik,psic,f,c
CEOP

      IF (zL.LT.0.0) THEN
       x = (1. - 15.*zL)**.25                   !Kansas unstable
       psik=2.*LOG((1.+x)/2.)+LOG((1.+x*x)/2.)-2.*ATAN(x)+2.*ATAN(oneRL)
       y = (1. - 10.15 _d 0*zL)**.3333 _d 0     !Convective
       psic = 1.5*LOG((1.+y+y*y)/3.)
     &      - SQRT(3. _d 0)*ATAN( (1.+2.*y)/SQRT(3. _d 0) )
     &      + 4.*ATAN(oneRL)/SQRT(3. _d 0)
       f = zL*zL/(1.+zL*zL)
       psiu = (1.-f)*psik+f*psic
      ELSE
       c = MIN( 50. _d 0, 0.35 _d 0*zL )        !Stable
c      psiu=-((1.+1.*zL)**1.+.6667*(zL-14.28)/EXP(c)+8.525)
       psiu = -( (1.+zL) + 0.6667 _d 0*(zL-14.28 _d 0)/EXP(c)
     &          + 8.525 _d 0 )
      ENDIF
      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

CBOP 0
C     !ROUTINE: PSIT

C     !INTERFACE:
      _RL FUNCTION psit(zL)

C     !DESCRIPTION:

C     !USES:
      IMPLICIT NONE
#include "EEPARAMS.h"

C     !INPUT PARAMETERS:
      _RL zL
C     !LOCAL VARIABLES:
      _RL x,y,psik,psic,f,c
CEOP

      IF (zL.LT.0.0) THEN
       x = (1. - 15.*zL)**.5                    !Kansas unstable
       psik = 2.*LOG((1.+x)/2.)
       y = (1. - 34.15 _d 0*zL)**.3333 _d 0     !Convective
       psic = 1.5*LOG((1.+y+y*y)/3.)
     &      - SQRT(3. _d 0)*ATAN( (1.+2.*y)/SQRT(3. _d 0) )
     &      + 4.*ATAN(oneRL)/SQRT(3. _d 0)
       f = zL*zL/(1.+zL*zL)
       psit = (1.-f)*psik+f*psic
      ELSE
       c = MIN( 50. _d 0, 0.35 _d 0*zL )        !Stable
       psit = -( (1.+2.*zL/3.)**1.5
     &          + 0.6667 _d 0*(zL-14.28 _d 0)/EXP(c)
     &          + 8.525 _d 0 )
      ENDIF

      RETURN
      END

#include "LAYERS_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 0
C !ROUTINE: LAYERS_DIAGNOSTICS_INIT

C !INTERFACE:
      SUBROUTINE LAYERS_DIAGNOSTICS_INIT( myThid )

C     !DESCRIPTION:
C     Initialize list of all available diagnostics for LAYERS package

C     !USES:
      IMPLICIT NONE
#include "EEPARAMS.h"
#include "SIZE.h"
#include "PARAMS.h"
#include "GRID.h"
#ifdef ALLOW_LAYERS
# include "LAYERS_SIZE.h"
# include "LAYERS.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     myThid ::  my Thread Id number
      INTEGER myThid

#ifdef ALLOW_LAYERS
#ifdef ALLOW_DIAGNOSTICS
C     !FUNCTIONS:
      INTEGER  DIAGS_GET_PARMS_I
      EXTERNAL DIAGS_GET_PARMS_I
      CHARACTER*(16) DIAGS_MK_UNITS
      EXTERNAL DIAGS_MK_UNITS

C     !LOCAL VARIABLES:
      INTEGER        iLa
      INTEGER        diagNum
      INTEGER        diagMate
      CHARACTER*8    diagName
      CHARACTER*16   diagCode
      CHARACTER*16   diagUnits
      CHARACTER*(80) diagTitle
      CHARACTER*2    rUnit2c
#ifdef LAYERS_PRHO_REF
      INTEGER kLoc
      _RL     rLoc
#endif
CEOP

c     IF ( useDiagnostics ) THEN

      IF ( usingPCoords ) THEN
        rUnit2c= 'Pa'
      ELSE
        rUnit2c= 'm '
      ENDIF
      diagNum = DIAGS_GET_PARMS_I( 'LAST_DIAG_ID', myThid )

      DO iLa=1,layers_maxNum
       IF ( layers_num(iLa).NE.0 ) THEN

#ifdef LAYERS_PRHO_REF
       IF ( layers_num(iLa).EQ.3 ) THEN
        WRITE(diagName,'(A4,I1,A3)') 'LaTr',iLa,layers_name(iLa)
        rLoc = 0.
        kLoc = layers_krho(iLa)
        IF ( kLoc.GE.1 .AND. kLoc.LE.Nr ) THEN
          rLoc = rC(kLoc)
        ELSE
          kLoc = 0
        ENDIF
        WRITE(diagTitle,'(2A,F9.2,A,I4)') 'Pot. density (minus 1000)',
     &    ' for layer averaging, ref_z=', rLoc, ',', kLoc
        diagUnits = 'kg/m^3          '
        diagCode  = 'SMR     MR      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I   diagName, diagCode, diagUnits, diagTitle, 0, myThid )
       ENDIF
#endif

#if (defined LAYERS_UFLUX) || (defined LAYERS_VFLUX)

C --- UH, VH
        WRITE(diagName,'(A4,I1,A3)') 'LaUH',iLa,layers_name(iLa)
        diagTitle = 'Layer Integrated  zonal Transport (UH, m^2/s)'
        diagUnits = DIAGS_MK_UNITS( rUnit2c//'.m/s', myThid )
        diagCode  = 'UU      MX      '
        diagMate  = diagNum + 2
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I   diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )
        CALL DIAGNOSTICS_SETKLEV( diagName, Nlayers , myThid )

        WRITE(diagName,'(A4,I1,A3)') 'LaVH',iLa,layers_name(iLa)
        diagTitle = 'Layer Integrated merid. Transport (VH, m^2/s)'
        diagUnits = DIAGS_MK_UNITS( rUnit2c//'.m/s', myThid )
        diagCode  = 'VV      MX      '
        diagMate  = diagNum
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I   diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )
        CALL DIAGNOSTICS_SETKLEV( diagName, Nlayers , myThid )

#ifdef LAYERS_THICKNESS

C --- Thickness
        WRITE(diagName,'(A4,I1,A3)') 'LaHw',iLa,layers_name(iLa)
        diagTitle = 'Layer Thickness at U points (m)'
        diagUnits = DIAGS_MK_UNITS( rUnit2c, myThid )
        diagCode  = 'SU      MX      '
        diagMate  = diagNum + 2
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I   diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )
        CALL DIAGNOSTICS_SETKLEV( diagName, Nlayers , myThid )

        WRITE(diagName,'(A4,I1,A3)') 'LaHs',iLa,layers_name(iLa)
        diagTitle = 'Layer Thickness at V points (m)'
        diagUnits = DIAGS_MK_UNITS( rUnit2c, myThid )
        diagCode  = 'SV      MX      '
        diagMate  = diagNum
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I   diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )
        CALL DIAGNOSTICS_SETKLEV( diagName, Nlayers , myThid )

C --- PI
        WRITE(diagName,'(A4,I1,A3)') 'LaPw',iLa,layers_name(iLa)
        diagTitle = 'Layer Probability at U points [-]'
        diagUnits = '1               '
        diagCode  = 'SU      MX      '
        diagMate  = diagNum + 2
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I   diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )
        CALL DIAGNOSTICS_SETKLEV( diagName, Nlayers , myThid )

        WRITE(diagName,'(A4,I1,A3)') 'LaPs',iLa,layers_name(iLa)
        diagTitle = 'Layer Probability at V points [-]'
        diagUnits = '1               '
        diagCode  = 'SV      MX      '
        diagMate  = diagNum
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I   diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )
        CALL DIAGNOSTICS_SETKLEV( diagName, Nlayers , myThid )

C --- U, V
        WRITE(diagName,'(A4,I1,A3)') 'LaUa',iLa,layers_name(iLa)
        diagTitle = 'Layer-averaged U velocity (non-weighted) (m/s)'
        diagUnits = 'm/s             '
        diagCode  = 'UU      MX      '
        diagMate  = diagNum + 2
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I   diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )
        CALL DIAGNOSTICS_SETKLEV( diagName, Nlayers , myThid )

        WRITE(diagName,'(A4,I1,A3)') 'LaVa',iLa,layers_name(iLa)
        diagTitle = 'Layer-averaged V velocity (non-weighted) (m/s)'
        diagUnits = 'm/s             '
        diagCode  = 'VV      MX      '
        diagMate  = diagNum
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I   diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )
        CALL DIAGNOSTICS_SETKLEV( diagName, Nlayers , myThid )

#endif /* LAYERS_THICKNESS */

#endif /* LAYERS_UFLUX or LAYERS_VFLUX */

#ifdef LAYERS_THERMODYNAMICS

        WRITE(diagName,'(A4,I1,A3)') 'LaHc',iLa,layers_name(iLa)
        diagTitle = 'Layer Thickness at tracer points (m)'
        diagUnits = DIAGS_MK_UNITS( rUnit2c, myThid )
        diagCode  = 'SM      MX      '
        diagMate  = 0
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I   diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )
        CALL DIAGNOSTICS_SETKLEV( diagName, Nlayers , myThid )

        WRITE(diagName,'(A4,I1,A3)') 'LaTs',iLa,layers_name(iLa)
        diagTitle = 
     &   'Layer thickness tendency due to THETA surf. forc.'
        diagUnits = 'm/s             '
        diagCode  = 'SM      MX      '
        diagMate  = 0
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I   diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )
        CALL DIAGNOSTICS_SETKLEV( diagName, Nlayers-1 , myThid )

        WRITE(diagName,'(A4,I1,A3)') 'LaTh',iLa,layers_name(iLa)
        diagTitle = 
     &   'Layer thickness tendency due to THETA horiz. diff.'
        diagUnits = 'm/s             '
        diagCode  = 'SM      MX      '
        diagMate  = 0
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I   diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )
        CALL DIAGNOSTICS_SETKLEV( diagName, Nlayers-1 , myThid )

C ------- This diagnostic used to be called 'LaTr', but that name
C         conflicts with JMC s prho diagnostics.
        WRITE(diagName,'(A4,I1,A3)') 'LaTz',iLa,layers_name(iLa)
        diagTitle = 
     &   'Layer thickness tendency due to THETA vert. diff.'
        diagUnits = 'm/s             '
        diagCode  = 'SM      MX      '
        diagMate  = 0
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I   diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )
        CALL DIAGNOSTICS_SETKLEV( diagName, Nlayers-1 , myThid )

        WRITE(diagName,'(A4,I1,A3)') 'LTha',iLa,layers_name(iLa)
        diagTitle = 
     &   'Layer thickness tendency due to THETA horiz. adv.'
        diagUnits = 'm/s             '
        diagCode  = 'SM      MX      '
        diagMate  = 0
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I   diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )
        CALL DIAGNOSTICS_SETKLEV( diagName, Nlayers-1 , myThid )

        WRITE(diagName,'(A4,I1,A3)') 'LTza',iLa,layers_name(iLa)
        diagTitle = 
     &   'Layer thickness tendency due to THETA vert. adv.'
        diagUnits = 'm/s             '
        diagCode  = 'SM      MX      '
        diagMate  = 0
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I   diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )
        CALL DIAGNOSTICS_SETKLEV( diagName, Nlayers-1 , myThid )

        WRITE(diagName,'(A4,I1,A3)') 'LTto',iLa,layers_name(iLa)
        diagTitle = 
     &   'Layer thickness tendency due to all THETA terms.'
        diagUnits = 'm/day           '
        diagCode  = 'SM      MX      '
        diagMate  = 0
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I   diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )
        CALL DIAGNOSTICS_SETKLEV( diagName, Nlayers-1 , myThid )

        WRITE(diagName,'(A4,I1,A3)') 'LaSs',iLa,layers_name(iLa)
        diagTitle = 
     &   'Layer thickness tendency due to SALT surf. forc.'
        diagUnits = 'm/s             '
        diagCode  = 'SM      MX      '
        diagMate  = 0
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I   diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )
        CALL DIAGNOSTICS_SETKLEV( diagName, Nlayers-1 , myThid )

        WRITE(diagName,'(A4,I1,A3)') 'LaSh',iLa,layers_name(iLa)
        diagTitle = 
     &   'Layer thickness tendency due to SALT horiz. diff.'
        diagUnits = 'm/s             '
        diagCode  = 'SM      MX      '
        diagMate  = 0
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I   diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )
        CALL DIAGNOSTICS_SETKLEV( diagName, Nlayers-1 , myThid )

        WRITE(diagName,'(A4,I1,A3)') 'LaSz',iLa,layers_name(iLa)
        diagTitle = 
     &   'Layer thickness tendency due to SALT vert. diff.'
        diagUnits = 'm/s             '
        diagCode  = 'SM      MX      '
        diagMate  = 0
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I   diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )
        CALL DIAGNOSTICS_SETKLEV( diagName, Nlayers-1 , myThid )

        WRITE(diagName,'(A4,I1,A3)') 'LSha',iLa,layers_name(iLa)
        diagTitle = 
     &   'Layer thickness tendency due to SALT horiz. adv.'
        diagUnits = 'm/s             '
        diagCode  = 'SM      MX      '
        diagMate  = 0
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I   diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )
        CALL DIAGNOSTICS_SETKLEV( diagName, Nlayers-1 , myThid )

        WRITE(diagName,'(A4,I1,A3)') 'LSza',iLa,layers_name(iLa)
        diagTitle = 
     &   'Layer thickness tendency due to SALT vert. adv.'
        diagUnits = 'm/s             '
        diagCode  = 'SM      MX      '
        diagMate  = 0
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I   diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )
        CALL DIAGNOSTICS_SETKLEV( diagName, Nlayers-1 , myThid )

        WRITE(diagName,'(A4,I1,A3)') 'LSto',iLa,layers_name(iLa)
        diagTitle = 
     &   'Layer thickness tendency due to all SALT terms.'
        diagUnits = 'm/day           '
        diagCode  = 'SM      MX      '
        diagMate  = 0
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I   diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )
        CALL DIAGNOSTICS_SETKLEV( diagName, Nlayers-1 , myThid )

C --- PI
        WRITE(diagName,'(A4,I1,A3)') 'LaPc',iLa,layers_name(iLa)
        diagTitle = 'Layer Probability at tracer points [-]'
        diagUnits = '1               '
        diagCode  = 'SM      MX      '
        diagMate  = 0
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I   diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )
        CALL DIAGNOSTICS_SETKLEV( diagName, Nlayers , myThid )
#endif /* LAYERS_THERMODYNAMICS */

       ENDIF
      ENDDO

c     ENDIF
#endif /* ALLOW_DIAGNOSTICS */
#endif /* ALLOW_LAYERS */

      RETURN
      END

#include "ZONAL_FILT_OPTIONS.h"

      SUBROUTINE ZONAL_FILT_NOFILL(
     U           field,
     I           jMin, jMax, kMin, kMax, bi, bj, gridLoc, myThid )
C     /==========================================================\
C     | S/R ZONAL_FILT_NOFILL                                    |
C     | o Apply FFT filter to a latitude circle.                 |
C     |   *No fill*                                              |
C     \==========================================================/
      IMPLICIT NONE

C     == Global data ==
#include "SIZE.h"
#include "ZONAL_FILT.h"
#include "FFTPACK.h"

C     == Routine arguments ==
C     jMin - Range of points to filter
C     jMax
C     kMin
C     kMax
C     bi
C     bj
C     myThid  - Thread number of this instance of FILTER_LATCIRC_FFT_APPLY
C     field   - Field to filter
C     gridLoc - Orientation (U or V) of field.
      INTEGER myThid
      INTEGER gridLoc
C     Real*8 field(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      Real*8 field(1-OLx:sNx+OLx,1-OLy:sNy+OLy,1,nSx,nSy)
      INTEGER jMin, jMax, kMin, kMax, bi, bj

#ifdef ALLOW_ZONAL_FILT

C     == Local data ==
      Real*8 phi(Nx)
      INTEGER I, J, K

      DO k=kMin, kMax
       DO j=jMin, jMax

C     o Copy zonal line of field into local workspace
        DO i=1,sNx
         phi(I) = field(i,j,k,bi,bj)
        ENDDO

C     o Forward transform (using specific FFT package)
C       CALL R8FFTF( Nx, phi, FFTPACKWS(1,bj) )
        CALL R8FFTF1( Nx, phi,
     &    FFTPACKWS1(1,bj), FFTPACKWS2(1,bj),FFTPACKWS3(1,bj) )

C     o Apply amplitude filter and normalize
        IF (gridLoc .EQ. 1) THEN
         DO i=1, Nx
          phi(i)=phi(i)*ampFactor(i,j,bi,bj)/float(Nx)
         ENDDO
        ELSEIF (gridLoc .EQ. 2) THEN
         DO i=1, Nx
          phi(i)=phi(i)*ampFactorV(i,j,bi,bj)/float(Nx)
         ENDDO
        ELSE
         WRITE(*,*) 'Error: gridLoc = ',gridLoc
         STOP 'Error: gridLoc has illegal value'
        ENDIF

C     o Backward transform (using specific FFT package)
C       CALL R8FFTB( Nx, phi, FFTPACKWS(1,bj) )
        CALL R8FFTB1( Nx, phi,
     &    FFTPACKWS1(1,bj), FFTPACKWS2(1,bj),FFTPACKWS3(1,bj) )

C       o Do periodic wrap around by hand
        DO i=1-OLx,0
         field(i,j,k,bi,bj) = phi(sNx+i)
        ENDDO
        DO i=1,sNx
         field(i,j,k,bi,bj) = phi(I)
        ENDDO
        DO i=sNx+1,sNx+OLx
         field(i,j,k,bi,bj) = phi(i-sNx)
        ENDDO

       ENDDO
      ENDDO

#endif /* ALLOW_ZONAL_FILT */

      RETURN
      END

#include "ctrparam.h"
#include "ATM2D_OPTIONS.h"

C     !INTERFACE:
      SUBROUTINE INIT_ATM2D(dtatm, dtocn, dtcouple, myThid )
C     *==========================================================*
C     |  INIT_1DTO2D                                             |
C     |    This initialization routine should be run after the   |
c     |    the ocean grid/pickup have been read in.               |
c     |                                                          |
c     |  Note: grid variable indices bi,bj are hard-coded 1,1    |
c     |  This should work if coupler or atmos/coupler on one     |
c     |  machine.                                                |
c     |                                                          |
C     *==========================================================*
c
        IMPLICIT NONE

C     === Global Atmosphere Variables ===
#include "ATMSIZE.h"
#include "AGRID.h"

C     === Global Ocean Variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"

C     === Global SeaIce Parameters ===
#include "THSICE_PARAMS.h"

C     === Atmos/Ocean/Seaice Interface Variables ===
#include "ATM2D_VARS.h"


C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
C     dtatm, dtocn, dtcouple - Timesteps from couple.nml (hours)
C     myThid - Thread no. that called this routine.
      INTEGER dtatm, dtocn, dtcouple
      INTEGER myThid

C     LOCAL VARIABLES:
      INTEGER i,j,jj
      INTEGER ib, ibj1, ibj2  ! runoff band loop counters
      INTEGER j_atm, mn
      INTEGER dUnit
      _RL end1, end2, enda1, enda2, enda3 !used to compute grid conv areas
      _RL totrun_b(sNy) ! total file "runoff" in runoff bands
      _RL a1,a2
      _RS atm_dyG(jm0)  ! southern point/(boundary) of atmos grid
      DATA atm_dyG/2.0,44*4.0,2.0/  ! grid spacing for atmosphere

      dtatmo = dtatm * 3600.
      dtocno = dtocn * 3600.
      dtcouplo= dtcouple * 3600.

C override data.ice seaice time step parms
C these will need to change if coupling procedure changed
      thSice_deltaT = dtcouplo
      thsIce_dtTemp = dtatmo
      ocean_deltaT = dtcouplo

CJRS  This next check - only kill it if not MPI?
      IF (dtocno.NE.dTtracerLev(1)) THEN
        PRINT *,'Ocean tracer timestep differs between coupler '
        PRINT *,'and the ocean data file'
        STOP
      ENDIF

c Assuming the atmospheric grid array not passed, do this:
      atm_yG(1)=-90.0
      DO j_atm=2,jm0
        atm_yG(j_atm)=atm_yG(j_atm-1)+atm_dyG(j_atm-1)
        atm_yC(j_atm-1)=(atm_yG(j_atm-1)+atm_yG(j_atm))/2.0
      ENDDO
      atm_yC(jm0)=atm_yG(jm0)+atm_dyG(jm0)/2.0

c end atmos grid initialization

      atm_oc_ind(1)=2
      atm_oc_wgt(1)=1. _d 0
      atm_oc_frac1(1)= (sin(yG(1,2,1,1)*deg2rad) -
     &        sin(yG(1,1,1,1)*deg2rad))/
     &        (sin(atm_yG(3)*deg2rad)-sin(atm_yG(1)*deg2rad))
      atm_oc_frac2(1)= 0. _d 0   ! assumes ocean(1) fits in atm(1)
      atm_oc_ind(sNy)=jm0-1
      atm_oc_wgt(sNy)=1. _d 0
      atm_oc_frac1(sNy)= (sin((yG(1,sNy,1,1) +
     &      dyG(1,sNy,1,1)/6.37D6/deg2rad)*deg2rad)-
     &      sin(yG(1,sNy,1,1)*deg2rad))/
     &      (sin((atm_yG(jm0)+atm_dyG(jm0))*deg2rad)-
     &      sin(atm_yG(jm0-1)*deg2rad))
      atm_oc_frac2(sNy)= 0. _d 0   ! assumes ocean(1) fits in atm(1)

      endwgt1 = sin(atm_yG(2)*deg2rad)            !hard-coded that the atmos
      endwgt2 = sin(atm_yG(3)*deg2rad) - endwgt1  !grid is same in NH and SH
      endwgt1 = endwgt1 + 1. _d 0                 !and goes 90S to 90N
      rsumwgt = 1. _d 0/(endwgt1 + endwgt2)

      atm_yG(2)=atm_yG(1) ! grid now combined atm end points
      atm_yG(jm0)=90. _d 0

      DO j=2, sNy-1

        DO jj=2,jm0-1
          IF  ((yG(1,j,1,1).GE.atm_yG(jj)).AND.
     &         (yG(1,j,1,1).LT.atm_yG(jj+1))) j_atm=jj
        ENDDO

        atm_oc_ind(j)=j_atm
        end1= sin(yG(1,j,1,1) *deg2rad)
        end2= sin(yG(1,j+1,1,1) *deg2rad)
        enda1 = sin(atm_yG(j_atm) *deg2rad)
        enda2 = sin(atm_yG(j_atm+1) *deg2rad)
        IF ( yG(1,j+1,1,1) .GT. atm_yG(j_atm+1) ) THEN
           enda3 = sin(atm_yG(j_atm+2) *deg2rad)
           atm_oc_wgt(j)=(enda2-end1)/ (end2-end1)
           atm_oc_frac1(j)= (enda2-end1) / (enda2 - enda1)
           atm_oc_frac2(j)= (end2 - enda2) / (enda3 - enda2)
        ELSE
          atm_oc_wgt(j)=1. _d 0
          atm_oc_frac1(j)= (end2-end1)/ (enda2-enda1)
          atm_oc_frac2(j)=0. _d 0
        ENDIF
      ENDDO

C     compute tauv interpolation points
      tauv_jpt(1) = 2         ! south pole point; s/b land
      tauv_jwght(1) = 1. _d 0
      DO j=2, sNy
        DO jj=1,jm0-1
          IF (( yG(1,j,1,1) .GE. atm_yC(jj)).AND.
     &        ( yG(1,j,1,1) .LT. atm_yC(jj+1))) j_atm=jj
        ENDDO
        tauv_jpt(j)= j_atm
        tauv_jwght(j)= 1. _d 0 - (yG(1,j,1,1) - atm_yC(j_atm)) /
     &                 (atm_yC(j_atm+1) - atm_yC(j_atm))
      ENDDO

C      DO j=1,sNy
C      print *, 'j, tauv_jpt:', j,tauv_jpt(j),tauv_jwght(j)
C      ENDDO

c
c find land fraction
c
      DO j_atm=1,jm0
        cflan(j_atm)=0. _d 0
        ocnArea(j_atm)=0. _d 0
      ENDDO

      DO j=1,sNy
        DO i=1,sNx
          IF (maskC(i,j,1,1,1).EQ.1.) THEN
            ocnArea(atm_oc_ind(j))=ocnArea(atm_oc_ind(j)) +
     &                           rA(i,j,1,1)*atm_oc_wgt(j)
            IF (atm_oc_wgt(j).LT.1.d0) THEN
              ocnArea(atm_oc_ind(j)+1)=ocnArea(atm_oc_ind(j)+1) +
     &                           rA(i,j,1,1)*(1.d0-atm_oc_wgt(j))
            ENDIF
          ENDIF
        ENDDO
      ENDDO

      DO j_atm=3,jm0-2
        cflan(j_atm)=1. _d 0 - ocnArea(j_atm) /
     &              (2. _d 0 * PI * 6.37 _d 6 * 6.37 _d 6 *
     &    (sin(atm_yG(j_atm+1)*deg2rad) - sin(atm_yG(j_atm)*deg2rad)))
        if (cflan(j_atm).LT.1. _d -14) cflan(j_atm)=0. _d 0
      ENDDO

C     deal with the combined atmos grid end cells...
      cflan(2)= 1. _d 0 - ocnArea(2) /
     &         (2. _d 0*PI*6.37 _d 6*6.37 _d 6*
     &         (sin(atm_yG(3)*deg2rad)+1. _d 0))
      IF (cflan(2).LT.1. _d -14) cflan(2)=0. _d 0
      cflan(1)=cflan(2)
      cflan(jm0-1)= 1.d0 - ocnArea(jm0-1) /
     &             (2. _d 0*PI*6.37 _d 6*6.37 _d 6*
     &             (1. _d 0-sin(atm_yG(jm0-1)*deg2rad)))
      IF (cflan(jm0-1).LT.1. _d -14) cflan(jm0-1)=0. _d 0
      cflan(jm0)=cflan(jm0-1)

      PRINT *,'Land fractions on atmospheric grid: '
      PRINT *, cflan
      PRINT *,'Lookup grid index, weights:'
      PRINT *, atm_oc_ind,atm_oc_wgt
C      PRINT *,'Lookup fraction 1 of atmos grid:'
C      PRINT *, atm_oc_frac1
C      PRINT *,'Lookup fraction 2 of atmos grid:'
C      PRINT *, atm_oc_frac2

c
c read in mean 1D atmos wind files -- store in memory
c
      DO j_atm=1,jm0
        DO mn=1,nForcingPer
          atau(j_atm,mn)=0. _d 0
          atav(j_atm,mn)=0. _d 0
          awind(j_atm,mn)=0. _d 0
        ENDDO
      ENDDO

      CALL MDSFINDUNIT( dUnit, myThid )

      IF ( atmosTauuFile .NE. ' '  ) THEN
         OPEN(dUnit, FILE=atmosTauuFile,STATUS='old',
     &        ACCESS='direct', RECL=8*jm0*nForcingPer,
     &        FORM='unformatted')
         READ(dUnit,REC=1), atau
         CLOSE(dUnit)
      ENDIF

      IF ( atmosTauvFile .NE. ' '  ) THEN
         OPEN(dUnit, FILE=atmosTauvFile, STATUS='old',
     &        ACCESS='direct', RECL=8*jm0*nForcingPer,
     &        FORM='unformatted')
         READ(dUnit, REC=1), atav
         CLOSE(dUnit)
      ENDIF

      IF ( atmosWindFile .NE. ' '  ) THEN
         OPEN(dUnit, FILE=atmosWindFile, STATUS='old',
     &        ACCESS='direct', RECL=8*jm0*nForcingPer,
     &        FORM='unformatted')
         READ(dUnit, REC=1), awind
         CLOSE(dUnit)
      ENDIF

C The polar data point values for winds are effectively N/A given the
C pole issue... although they are read in here, they are never used in
C any calculations, as the polar ocean points access the data at atmos
C 2 and jm0-1 points.


c read in runoff data
c to put runoff into specific grid cells
c
      IF ( runoffMapFile .NE. ' ' ) THEN
        CALL READ_FLD_XY_RL( runoffMapFile, ' ',
     &                      runoffVal, 0, myThid )
      ELSE
        DO j=1,sNy
          DO i=1,sNx
            if ( (maskC(i,j,1,1,1).EQ.1.) .AND.
     &          ( (maskC(i-1,j,1,1,1).EQ.0.).OR.
     &            (maskC(i+1,j,1,1,1).EQ.0.).OR.
     &            (maskC(i,j-1,1,1,1).EQ.0.).OR.
     &            (maskC(i,j+1,1,1,1).EQ.0.).OR.
     &            (maskC(i+1,j+1,1,1,1).EQ.0.).OR.
     &            (maskC(i-1,j-1,1,1,1).EQ.0.).OR.
     &            (maskC(i+1,j-1,1,1,1).EQ.0.).OR.
     &            (maskC(i-1,j+1,1,1,1).EQ.0.) ) ) THEN
              runoffVal(i,j)=1. _d 0
            ENDIF
          ENDDO
        ENDDO
      ENDIF

      DO ib=1,numBands
        ibj1=1
        if (ib.GT.1) ibj1=  rband(ib-1)+1
        ibj2=sNy
        if (ib.LT.numBands) ibj2= rband(ib)
        totrun_b(ib)=0.d0
        DO j=ibj1,ibj2
          DO i=1,sNx
            totrun_b(ib)=totrun_b(ib)+runoffVal(i,j)*maskC(i,j,1,1,1)
          ENDDO
        ENDDO
        DO j=ibj1,ibj2
          runIndex(j)= ib     ! for lookup of rband as fn. of latitude
          DO i=1,sNx
            runoffVal(i,j)=runoffVal(i,j)*maskC(i,j,1,1,1)/totrun_b(ib)
          ENDDO
        ENDDO
      ENDDO

      CALL INIT_SUMVARS(myThid)

C     Initialize 1D diagnostic variables
      DO j_atm=1,jm0
        DO mn=1,nForcingPer
          sum_tauu_ta(j_atm,mn)= 0. _d 0
          sum_tauv_ta(j_atm,mn)= 0. _d 0
          sum_wsocean_ta(j_atm,mn)= 0. _d 0
          sum_ps4ocean_ta(j_atm,mn)= 0. _d 0
        ENDDO
      ENDDO

C     Initialize 2D diagnostic variables
      DO i=1-OLx,sNx+OLx
        DO j=1-OLy,sNy+OLy
          DO mn=1,nForcingPer
            qnet_atm_ta(i,j,mn)= 0. _d 0
            evap_atm_ta(i,j,mn)= 0. _d 0
            precip_atm_ta(i,j,mn)= 0. _d 0
            runoff_atm_ta(i,j,mn)= 0. _d 0
            sum_qrel_ta(i,j,mn)= 0. _d 0
            sum_frel_ta(i,j,mn)= 0. _d 0
            sum_iceMask_ta(i,j,mn)= 0. _d 0
            sum_iceHeight_ta(i,j,mn)= 0. _d 0
            sum_iceTime_ta(i,j,mn)= 0. _d 0
            sum_oceMxLT_ta(i,j,mn)= 0. _d 0
            sum_oceMxLS_ta(i,j,mn)= 0. _d 0
          ENDDO
          qnet_atm(i,j)= 0. _d 0
          evap_atm(i,j)= 0. _d 0
          precip_atm(i,j)= 0. _d 0
          runoff_atm(i,j)= 0. _d 0
          sum_qrel(i,j)= 0. _d 0
          sum_frel(i,j)= 0. _d 0
          sum_iceMask(i,j)= 0. _d 0
          sum_iceHeight(i,j)= 0. _d 0
          sum_iceTime(i,j)= 0. _d 0
          sum_oceMxLT(i,j)= 0. _d 0
          sum_oceMxLS(i,j)= 0. _d 0
        ENDDO
      ENDDO

C     Initialize year-end diags and max/min seaice variables
      SHice_min = 1. _d 18
      NHice_min = 1. _d 18
      SHice_max = 0. _d 0
      NHice_max = 0. _d 0
      sst_tave=  0. _d 0
      sss_tave=  0. _d 0
      HF2ocn_tave=  0. _d 0
      FW2ocn_tave=  0. _d 0
      CO2flx_tave=  0. _d 0
      OPEN(25,FILE='resocean.dat',STATUS='replace')
      CLOSE(25)

C     Initialize following for safety and/or cold start
      DO i=1-OLx,sNx+OLx
        DO j=1-OLy,sNy+OLy
          pass_runoff(i,j)= 0. _d 0
          pass_qnet(i,j)= 0. _d 0
          pass_evap(i,j)= 0. _d 0
          pass_precip(i,j)= 0. _d 0
          pass_fu(i,j)= 0. _d 0
          pass_fv(i,j)= 0. _d 0
          pass_wspeed(i,j)= 0. _d 0
          pass_solarnet(i,j)= 0. _d 0
          pass_slp(i,j)= 0. _d 0
          pass_siceLoad(i,j)= 0. _d 0
          pass_pCO2(i,j)= 0. _d 0
          pass_prcAtm(i,j) = 0. _d 0
          snowPrc    (i,j) = 0. _d 0
          sFluxFromIce(i,j)= 0. _d 0
        ENDDO
      ENDDO

C     Initialize following (if ocn carbon not passed)
      DO i=1,sNx
        DO j=1,sNy
          oFluxCO2(i,j) = 0. _d 0
        ENDDO
      ENDDO

      RETURN
      END

#include "BBL_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 0
C !ROUTINE: BBL_READPARMS

C !INTERFACE:
      SUBROUTINE BBL_READPARMS( myThid )

C     !DESCRIPTION:
C     Initialize BBL variables and constants.

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "BBL.h"

C     !INPUT PARAMETERS:
      INTEGER myThid
CEOP

#ifdef ALLOW_BBL

C     !LOCAL VARIABLES:
C     msgBuf     :: Informational/error message buffer
C     iUnit      :: Work variable for IO unit number
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      INTEGER iUnit

      NAMELIST /BBL_PARM01/
     &     bbl_wvel, bbl_hvel, bbl_initEta,
     &     bbl_thetaFile, bbl_saltFile, bbl_etaFile

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      IF ( .NOT.useBBL ) THEN
C-    pkg BBL is not used
        _BEGIN_MASTER(myThid)
C-    Track pkg activation status:
C     print a (weak) warning if data.bbl is found
         CALL PACKAGES_UNUSED_MSG( 'useBBL', ' ', ' ' )
        _END_MASTER(myThid)
        RETURN
      ENDIF

      _BEGIN_MASTER(myThid)

C--   Default values for BBL
      bbl_wvel      = 1. _d -5
      bbl_hvel      = 1. _d 0
      bbl_initEta   = 20. _d 0

C-    file names for initial conditions:
      bbl_thetaFile = ' '
      bbl_saltFile  = ' '
      bbl_etaFile   = ' '

      WRITE(msgBuf,'(A)') 'BBL_READPARMS: opening data.bbl'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT , 1)
      CALL OPEN_COPY_DATA_FILE(
     I                     'data.bbl', 'BBL_READPARMS',
     O                     iUnit,
     I                     myThid )

C     Read parameters from open data file
      READ(UNIT=iUnit,NML=BBL_PARM01)
      WRITE(msgBuf,'(A)')
     &    'BBL_READPARMS: finished reading data.bbl'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &    SQUEEZE_RIGHT , 1)
C     Close the open data file
#ifdef SINGLE_DISK_IO
      CLOSE(iUnit)
#else
      CLOSE(iUnit,STATUS='DELETE')
#endif /* SINGLE_DISK_IO */

      _END_MASTER(myThid)

C--   Everyone else must wait for the parameters to be loaded
      _BARRIER

#endif /* ALLOW_BBL */

      RETURN
      END

#include "CPP_EEOPTIONS.h"

C--   File global_max.F: Routines that perform global max reduction on an array
C                        of thread values.
C
C      Adjoint routines are identical to forward routines,
C      but parameter list is reversed to be consistent with
C      call statement generated by TAF
C      P. Heimbach, 16-Apr-2002
C
C      Contents
C      o GLOBAL_ADMAX_R4
C      o GLOBAL_ADMAX_R8

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: GLOBAL_ADMAX_R4

C     !INTERFACE:
#ifdef AUTODIFF_TAMC_COMPATIBILITY
      SUBROUTINE GLOBAL_ADMAX_R4(
     I                            myThid,
     U                            maxPhi
     &                          )
#else
      SUBROUTINE GLOBAL_ADMAX_R4(
     U                            maxPhi,
     I                            myThid
     &                          )
#endif

C     !DESCRIPTION:
C     *==========================================================*
C     | SUBROUTINE GLOBAL_ADMAX_R4
C     | o Handle max for real*4 data.
C     *==========================================================*
C     | Perform max on array of one value per thread and then
C     | max result of all the processes.
C     | Notes
C     | =====
C     | Within a process only one thread does the max, each
C     | thread is assumed to have already maxed  its local data.
C     | The same thread also does the inter-process max for
C     | example with MPI and then writes the result into a shared
C     | location. All threads wait until the max is avaiailable.
C     *==========================================================*

C     !USES:
      IMPLICIT NONE

C     == Global data ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "EESUPPORT.h"
#include "GLOBAL_MAX.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     maxPhi :: Result of max.
C     myThid :: My thread id.
      Real*4 maxPhi
      INTEGER myThid

C     !LOCAL VARIABLES:
C     == Local variables ==
C     I      :: Loop counters
C     mpiRC  :: MPI return code
      INTEGER I
      Real*4  tmp
#ifdef ALLOW_USE_MPI
      INTEGER mpiRC
#endif /* ALLOW_USE_MPI */
CEOP

C--   write local max into array
      phiGMR4(1,myThid) = maxPhi

C--   Can not start until everyone is ready
      CALL BAR2( myThid )

C--   Max within the process first
      _BEGIN_MASTER( myThid )
       tmp = phiGMR4(1,1)
       DO I=2,nThreads
        tmp = MAX(tmp,phiGMR4(1,I))
       ENDDO
       maxPhi = tmp
#ifdef ALLOW_USE_MPI
       IF ( usingMPI ) THEN
        CALL MPI_Allreduce(tmp,maxPhi,1,MPI_REAL,MPI_MAX,
     &                   MPI_COMM_MODEL,mpiRC)
       ENDIF
#endif /* ALLOW_USE_MPI */
       phiGMR4(1,0) = maxPhi
      _END_MASTER( myThid )

C--   Do not leave until we are sure that the max is done
      CALL BAR2( myThid )

C--   set result for every process
      maxPhi = phiGMR4(1,0)

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: GLOBAL_ADMAX_R8

C     !INTERFACE:
#ifdef AUTODIFF_TAMC_COMPATIBILITY
      SUBROUTINE GLOBAL_ADMAX_R8(
     I                            myThid,
     U                            maxPhi
     &                          )
#else
      SUBROUTINE GLOBAL_ADMAX_R8(
     U                            maxPhi,
     I                            myThid
     &                          )
#endif

C     !DESCRIPTION:
C     *==========================================================*
C     | SUBROUTINE GLOBAL_ADMAX_R8
C     | o Handle max for real*8 data.
C     *==========================================================*
C     | Perform max on array of one value per thread and then
C     | max result of all the processes.
C     | Notes
C     | =====
C     | Within a process only one thread does the max, each
C     | thread is assumed to have already maxed  its local data.
C     | The same thread also does the inter-process max for
C     | example with MPI and then writes the result into a shared
C     | location. All threads wait until the max is avaiailable.
C     *==========================================================*

C     !USES:
      IMPLICIT NONE

C     === Global data ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "EESUPPORT.h"
#include "GLOBAL_MAX.h"

C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
C     maxPhi :: Result of max.
C     myThid :: My thread id.
      Real*8 maxPhi
      INTEGER myThid

C     !LOCAL VARIABLES:
C     === Local variables ===
C     I      :: Loop counters
C     mpiRC  :: MPI return code
      INTEGER I
      Real*8  tmp
#ifdef ALLOW_USE_MPI
      INTEGER mpiRC
#endif   /* ALLOW_USE_MPI */
CEOP

C--   write local max into array
      phiGMR8(1,myThid) = maxPhi

C--   Can not start until everyone is ready
      CALL BAR2( myThid )

C--   Max within the process first
      _BEGIN_MASTER( myThid )
       tmp = phiGMR8(1,1)
       DO I=2,nThreads
        tmp = MAX(tmp,phiGMR8(1,I))
       ENDDO
       maxPhi = tmp
#ifdef ALLOW_USE_MPI
       IF ( usingMPI ) THEN
        CALL MPI_Allreduce(tmp,maxPhi,1,MPI_DOUBLE_PRECISION,MPI_MAX,
     &                   MPI_COMM_MODEL,mpiRC)
       ENDIF
#endif /* ALLOW_USE_MPI */
C--     Write solution to place where all threads can see it
       phiGMR8(1,0) = maxPhi
      _END_MASTER( myThid )

C--   Do not leave until we are sure that the max is done
      CALL BAR2( myThid )

C--   set result for every process
      maxPhi = phiGMR8(1,0)

      RETURN
      END

#include "CPP_EEOPTIONS.h"

      SUBROUTINE DUMMY_IN_STEPPING_D( myTime, myIter, myThid )

      IMPLICIT NONE
      _RL     myTime
      INTEGER myIter
      INTEGER myThid
      RETURN
      END

      SUBROUTINE DUMMY_IN_STEPPING_B( myTime, myIter, myThid )

      IMPLICIT NONE
      _RL     myTime
      INTEGER myIter
      INTEGER myThid
      RETURN
      END

      SUBROUTINE DUMMY_FOR_ETAN_D(myTime, myTimed, myIter, myThid)

      IMPLICIT NONE
      _RL     myTime
      _RL     myTimed
      INTEGER myIter
      INTEGER myThid
      END

      SUBROUTINE DUMMY_FOR_ETAN_B(myTime, myTimeb, myIter, myThid)
      IMPLICIT NONE
      _RL     myTime
      _RL     myTimeb
      INTEGER myIter
      INTEGER myThid
      END

#include "MNC_OPTIONS.h"

C--  File mnc_utils.F:
C--   Contents
C--   o MNC_HANDLE_ERR
C--   o MNC_GET_IND
C--   o MNC_GET_NEXT_EMPTY_IND
C--   o MNC_GET_FVINDS
C--   o MNC_CHK_VTYP_R_NCVAR
C--   o MNC_PSNCM

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 1
C     !ROUTINE: MNC_HANDLE_ERR

C     !INTERFACE:
      SUBROUTINE MNC_HANDLE_ERR( status, msg, myThid )

C     !DESCRIPTION:
C     Convenience function for handling all MNC and NetCDF library
C     errors.

C     !USES:
      implicit none
#include "EEPARAMS.h"
#include "netcdf.inc"

C     !DESCRIPTION:
C     Create an MNC grid within a NetCDF file context.

C     !USES:
      INTEGER  myThid, status
      character*(*) msg
CEOP

C     !LOCAL VARIABLES:
      integer i,lenm
      character*(MAX_LEN_MBUF) msgbuf

C     Functions
      integer ILNBLNK

      DO i = 1,MAX_LEN_MBUF
        msgbuf(i:i) = ' '
      ENDDO

      IF ( status .NE. NF_NOERR ) THEN
        write(msgbuf,'(2a)') 'NetCDF ERROR: '
        lenm = ILNBLNK(msgbuf)
        print *, msgbuf(1:lenm)
        CALL print_error(msgbuf(1:lenm), mythid)
        print *, '==='
        print *, NF_STRERROR(status)
        print *, '==='
        lenm = ILNBLNK(msg)
        lenm = MIN(lenm,MAX_LEN_MBUF-11)
        write(msgbuf,'(2a)') 'MNC ERROR: ', msg(1:lenm)
        lenm = ILNBLNK(msgbuf)
        print *, msgbuf(1:lenm)
        CALL print_error(msgbuf(1:lenm), mythid)
        STOP 'ABNORMAL END: S/R MNC_HANDLE_ERR'
      ENDIF
      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 1
C     !ROUTINE: MNC_GET_IND

C     !INTERFACE:
      SUBROUTINE MNC_GET_IND(
     I     NT,
     I     aname,
     I     name_list,
     O     ind,
     I     myThid )

C     !DESCRIPTION:
C     Get the index of the specified name.

C     !USES:
      implicit none
#include "EEPARAMS.h"

C     !INPUT PARAMETERS:
      integer myThid, nt
      character*(*) aname
      character*(*) name_list(NT)
CEOP

C     !LOCAL VARIABLES:
      integer n, i, nf, ind, lenm
      character*(MAX_LEN_MBUF) msgbuf

C     Functions
      integer ILNBLNK

C     Check that aname contains a valid name
      n = ILNBLNK( aname )
      IF ( n .LT. 1 ) THEN
        write(msgbuf,'(a)')
     &       'MNC_GET_IND: an invalid (empty) name was specified'
        lenm = ILNBLNK(msgbuf)
        CALL print_error(msgbuf(1:lenm), myThid)
        stop 'ABNORMAL END: S/R MNC_GET_IND'
      ENDIF

C     Search for the index
      DO i=1,NT
        nf = ILNBLNK( name_list(i) )
        IF ( nf .EQ. n ) THEN
          IF ( name_list(i)(1:n) .EQ. aname(1:n) ) THEN
            ind = i
            GOTO 10
          ENDIF
        ENDIF
      ENDDO
      ind = -1
 10   CONTINUE
      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 1
C     !ROUTINE: MNC_GET_NEXT_EMPTY_IND

C     !INTERFACE:
      SUBROUTINE MNC_GET_NEXT_EMPTY_IND(
     I     NT,
     I     name_list,
     I     var_symb,
     O     ind,
     I     myThid )

C     !DESCRIPTION:
C     Get the index of the next empty entry.

C     !USES:
      implicit none
#include "EEPARAMS.h"

C     !INPUT PARAMETERS:
      integer myThid, nt
      character*(*) name_list(NT)
      character*(*) var_symb
CEOP

C     !LOCAL VARIABLES:
      integer n, i, ind
      character*(MAX_LEN_MBUF) msgbuf

C     Functions
      integer ILNBLNK


C     Search for the index
      DO i=1,NT
        n = ILNBLNK( name_list(i) )
        IF ( n .EQ. 0 ) THEN
          ind = i
          GOTO 10
        ENDIF
      ENDDO

C     If this is code is reached, we have exceeded the array size
      write(msgbuf,'(a,i6,a)')
     &     'MNC_GET_NEXT_EMPTY_IND: array size ', nt,
     &     ' exceeded'
      CALL print_error( msgbuf, myThid )
      n = ILNBLNK( var_symb )
      write(msgbuf,'(a,a,a)')
     &     'MNC_GET_NEXT_EMPTY_IND: occurred within the ''',
     &     var_symb(1:n), ''' array'
      CALL print_error( msgbuf, myThid )
      stop 'ABNORMAL END: S/R MNC_GET_NEXT_EMPTY_IND'

 10   CONTINUE
      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 1
C     !ROUTINE: MNC_GET_FVINDS

C     !INTERFACE:
      SUBROUTINE MNC_GET_FVINDS(
     I     fname,
     I     vname,
     O     indf,
     O     ind_fv_ids,
     I     myThid )

C     !DESCRIPTION:
C     Get the variable indicies.

C     !USES:
      implicit none
#include "MNC_COMMON.h"
#include "netcdf.inc"

C     !INPUT PARAMETERS:
      INTEGER  myThid, fid, indf, ind_fv_ids
      character*(*) fname
      character*(*) vname
CEOP

C     !LOCAL VARIABLES:
      integer i,j,k, n, lenv

C     Functions
      integer ILNBLNK

C     Strip trailing spaces
      lenv = ILNBLNK(vname)

C     Check that the file exists
      CALL MNC_GET_IND(MNC_MAX_FID, fname, mnc_f_names, indf, myThid)
      IF (indf .LT. 1) THEN
        ind_fv_ids = -1
        RETURN
      ENDIF
      fid = mnc_f_info(indf,2)

C     Find the vID
      DO i = 1,mnc_fv_ids(indf,1)
        k = 2 + 3*(i - 1)
        j = mnc_fv_ids(indf,k)
        n = ILNBLNK(mnc_v_names(j))
        IF ( n.EQ.lenv ) THEN
         IF ( mnc_v_names(j)(1:n).EQ.vname(1:n) ) THEN
          ind_fv_ids = k
          GOTO 10
         ENDIF
        ENDIF
      ENDDO
      ind_fv_ids = -1
 10   CONTINUE

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C     Here, we determine whether the dimensions (sizes) of a specific
C     variable within the MNC low-level look-up tables matches the
C     dimensions of a Variable Type defined within the upper-level CW
C     layer.
C
C     Return values:
C     .  YES  ==>  ires > 0
C     .  NO   ==>  ires < 0

      SUBROUTINE MNC_CHK_VTYP_R_NCVAR(
     I     ind_vt,
     I     indf,
     I     ind_fv_ids,
     I     indu,
     O     ires,
     I     myThid )

      implicit none
#include "MNC_COMMON.h"
#include "EEPARAMS.h"

C     Arguments
      INTEGER  myThid, ind_vt, indf, ind_fv_ids, indu, ires

C     Functions
      integer ILNBLNK

C     Locals
      integer  ii,k, ind_cw_g, ig,ids,ide,nint, indd, nk
      integer  ndim_vt, ncgt,ncvr,ncvf, npb, sz_min
      character*(MAX_LEN_MBUF) pbuf, msgbuf

      ires = -1

C     grid indicies for the internal (as-read-from-the-file) data
      ig = mnc_fv_ids(indf,ind_fv_ids+2)
      ids = mnc_f_info(indf,ig+1)
      ide = mnc_f_info(indf,ig+2)
      nint = ids - ide + 1

      ind_cw_g = mnc_cw_vgind(ind_vt)
      ncgt = ILNBLNK(mnc_cw_gname(ind_cw_g))
      ncvr = ILNBLNK(mnc_v_names(mnc_fv_ids(indf,ind_fv_ids)))
      ncvf = ILNBLNK(mnc_f_names(indf))
      write(pbuf,'(7a)') 'MNC_CHK_VTYP_R_NCVAR WARNING: var ''',
     &     mnc_v_names(mnc_fv_ids(indf,ind_fv_ids))(1:ncvr),
     &     ''' within file ''', mnc_f_names(indf)(1:ncvf),
     &     ''' does not satisy the size needed by GType ''',
     &     mnc_cw_gname(ind_cw_g)(1:ncgt), ''''
      npb = ILNBLNK(pbuf)
      ndim_vt = mnc_cw_ndim(ind_cw_g)
      nk = nint
      IF (ndim_vt .LT. nk)  nk = ndim_vt
      IF (nint .NE. ndim_vt) THEN
        write(msgbuf,'(2a)') pbuf(1:npb), ' -- too few dims'
        CALL print_error(msgbuf, myThid)
      ENDIF

C     Check that the necessary size exists along each dimension
      DO k = 1,nk
        ii = ids + (k - 1)
        sz_min = mnc_cw_dims(k,ind_cw_g)
        IF (sz_min .EQ. -1)  sz_min = indu
        indd = mnc_fd_ind(indf,ii)
        IF (mnc_d_size(indd) .LT. sz_min) THEN
          write(msgbuf,'(2a,i3,a,i3,a,i3)') pbuf(1:npb), ': dim #',
     &         k, ' is too small: ', mnc_d_size(indd), ' vs ',
     &         mnc_cw_ie(k,ind_cw_g)
          CALL print_error(msgbuf, myThid)
          RETURN
        ENDIF
      ENDDO

C     Reaching this point means all tests passed
      ires = 1

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 1
C     !ROUTINE: MNC_PSNCM

C     !INTERFACE:
      SUBROUTINE MNC_PSNCM(
     O     ostring,
     I     ival, n )

C     !DESCRIPTION:
C     Print a zero-padded integer to a String with an N-Character
C     Minimum length

      IMPLICIT NONE

C     !INPUT PARAMETERS:
C     ostring :: String to contain formatted output
      CHARACTER*(*) ostring
      INTEGER ival, n
CEOP

C     !LOCAL VARIABLES:
      INTEGER i, lens, nmin
      CHARACTER*(25) tmp

      lens = LEN(ostring)
      DO i = 1,lens
        ostring(i:i) = ' '
      ENDDO
      WRITE(tmp,'(I25.25)') ival
      DO i = 1,25
        IF (tmp(i:i) .NE. '0') THEN
          nmin = 26 - i
          GOTO 200
        ENDIF
      ENDDO
 200  CONTINUE
      IF (nmin .LT. n)  nmin = n
      ostring(1:nmin) = tmp((26-nmin):25)

C
      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#include "ATM_CPL_OPTIONS.h"

CBOP 0
C !ROUTINE: CPL_IMPORT_CPLPARMS

C !INTERFACE:
      SUBROUTINE CPL_IMPORT_CPLPARMS( myThid )

C !DESCRIPTION:
C     *==========================================================*
C     | SUBROUTINE CPL_IMPORT_CPLPARMS
C     | o Routine for importing coupling parameters
C     |   from/to the coupler layer
C     *==========================================================*
C     |   this version is specific to 1 component (atmos)
C     *==========================================================*

C !USES:
      IMPLICIT NONE
C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "CPL_PARAMS.h"
#include "ATMIDS.h"

C !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     myThid   :: Thread number for this instance of the routine
      INTEGER myThid
CEOP

C !LOCAL VARIABLES:
C     == Local variables ==
C     i        :: Loop counter
C     parBuf   :: local buffer to receive coupler-params
C     msgBuf   :: Informational/error message buffer
      INTEGER i
      INTEGER parBuf(atmParSize)
      CHARACTER*(MAX_LEN_MBUF) msgBuf

      _BARRIER
      _BEGIN_MASTER( myThid )

C--   Initialise error counter:
      cplErrorCount = 0

C-    Initialise buffer
      DO i=1,atmParSize
        parBuf(i) = 0
      ENDDO

C-    Receive coupler configuration info.

C     o Import coupling exhange-field selectors (coupler params)
      CALL COMPRECV_I4VEC(
     I              atmCplParamsName, atmParSize,
     O              parBuf )

C-dBug:
      WRITE(standardMessageUnit,'(A,10I6)')
     & ' CPL_IMPORT_CPLPARMS: Recv parBuf=', (parBuf(i),i=1,atmParSize)
C-dBug:

C-    o Set options for coupling exchange
      IF ( atmParSize.EQ.6 ) THEN
        atm_cplSequential  = parBuf(1).EQ.1
        atm_cplExch_RunOff = parBuf(2).GE.2
        atm_cplExch1W_sIce = parBuf(3).GE.2
        atm_cplExch2W_sIce = parBuf(4).GE.2
        atm_cplExch_SaltPl = parBuf(5).GE.2
        atm_cplExch_DIC    = parBuf(6).GE.2
C-    save coupler parameter:
        cpl_exchange_RunOff = parBuf(2)
        cpl_exchange1W_sIce = parBuf(3)
        cpl_exchange2W_sIce = parBuf(4)
        cpl_exchange_SaltPl = parBuf(5)
        cpl_exchange_DIC    = parBuf(6)
      ELSE
C-    If not using an up-to-date ATMIDS.h with the wrong atmParSize
        cplErrorCount = cplErrorCount + 1
        WRITE(msgBuf,'(2A,I4,A)') 'CPL_IMPORT_CPLPARMS: ',
     &       'atmParSize=', atmParSize, ' is wrong (expect 6)'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(2A,I4,A)') 'CPL_IMPORT_CPLPARMS: ',
     &       '==> set ErrorCount=', cplErrorCount, ' (Fatal)'
        CALL PRINT_ERROR( msgBuf, myThid )
      ENDIF

      _END_MASTER( myThid )
      _BARRIER

      RETURN
      END

#include "REGRID_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 0
C     !ROUTINE: REGRID_MNC_INIT

C     !INTERFACE:
      SUBROUTINE REGRID_MNC_INIT( myThid )

C     !DESCRIPTION:
C     Initialize MNC lookup tables for REGRID.

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "REGRID_SIZE.h"
#include "REGRID.h"
#ifdef ALLOW_MNC
#include "MNC_COMMON.h"
#endif /* ALLOW_MNC */

C     !INPUT PARAMETERS:
      INTEGER myThid
CEOP

C     !LOCAL VARIABLES:
      INTEGER i, k, ndim
#ifdef ALLOW_MNC
      INTEGER CW_MAX_LOC
      PARAMETER ( CW_MAX_LOC = 6 )
      INTEGER dim(CW_MAX_LOC), ib(CW_MAX_LOC), ie(CW_MAX_LOC)
      CHARACTER*(MNC_MAX_CHAR) name
      character*(MNC_MAX_CHAR) dn(CW_MAX_LOC)
      
      IF (useMNC) THEN

C         DO i = 1,CW_MAX_LOC
C           dn(i)(1:MNC_MAX_CHAR)=mnc_blank_name(1:MNC_MAX_CHAR)
C           dim(i) = 0
C           ib(i) = 0
C           ie(i) = 0
C         ENDDO
C         dn(2)(1:1) = 'T'
C         dim(2)     = -1
C         ib(2)      =  1
C         ie(2)      =  1

C         DO k = 1,regrid_ngrids

C           name(1:MNC_MAX_CHAR) = mnc_blank_name(1:MNC_MAX_CHAR)
C           dn(1)(1:MNC_MAX_CHAR) = mnc_blank_name(1:MNC_MAX_CHAR)
C           write(name,'(a,i3)') 'regrid_', k
C           write(dn(1),'(a,i3)') 'regrid_', k
C           dim(1) = REGRID_nout(k)
C           ib(1)  = 1
C           ie(1)  = REGRID_nout(k)
          
C           CALL MNC_CW_ADD_GNAME(name, ndim, dim, dn, ib, ie, myThid)

C         ENDDO
        
      ENDIF

#endif /* ALLOW_MNC */

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#include "PTRACERS_OPTIONS.h"

CBOP
C !ROUTINE: PTRACERS_DEBUG

C !INTERFACE: ==========================================================
      SUBROUTINE PTRACERS_DEBUG(
     I                           myThid )

C !DESCRIPTION:
C     print passive tracers stats

C !USES: ===============================================================
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PTRACERS_SIZE.h"
#include "PTRACERS_PARAMS.h"
#include "PTRACERS_FIELDS.h"

C !INPUT PARAMETERS: ===================================================
C  myThid      :: thread number
      INTEGER myThid

C !OUTPUT PARAMETERS: ==================================================
C  none

#ifdef ALLOW_PTRACERS
#ifdef ALLOW_DEBUG

C !LOCAL VARIABLES: ====================================================
C  iTracer     :: tracer index
      INTEGER iTracer
      CHARACTER*(12) strng
CEOP

C Loop over tracers
      DO iTracer=1,PTRACERS_num

       WRITE(strng,'(A8,I4.4)') 'PTRACER.', iTracer
       CALL DEBUG_STATS_RL( Nr, pTracer(1-OLx,1-OLy,1,1,1,iTracer),
     &                      strng, myThid )
       WRITE(strng,'(A8,I4.4)') 'GNm1TRC.', iTracer
       CALL DEBUG_STATS_RL( Nr, gpTrNm1(1-OLx,1-OLy,1,1,1,iTracer),
     &                      strng, myThid )

C end of tracer loop
      ENDDO

#endif /* ALLOW_DEBUG */
#endif /* ALLOW_PTRACERS */

      RETURN
      END

#include "FIZHI_OPTIONS.h"
#undef CHECK_GETPWHERE

       subroutine getpwhere(myThid,numpress,pressures,levpressures)
C***********************************************************************
C subroutine getpwhere
C
C Purpose: Approximate (!) the level at which the mid-level pressure
C          is less than (ie, above in the atmosphere) a given value.
C
C Algorithm: Assume surface pressure of 1000 mb, and the pressure
c          thicknesses set in make_phys_grid, with drF thicknesses above
C
C Need:    Information about the dynamics grid vertical spacing
C
C Input:   myThid       - process(or) number
C          numpres      - Number of pressures to process
C          pressures    - Pressure values to find levels for
C
C Output:  levpressures - Array of levels at which pressures are found
C                         These pressure levels correspond to the fizhi
C                         levels, and assume that the levels are counted
C                         from top to bottom (CRITICAL!)
C
C NOTE: The new physics levels specified here MUST correspond to the
C       physics levels specified in make_phys_grid from gridalt package.
C***********************************************************************
       implicit none
c
#include "SIZE.h"
#include "fizhi_SIZE.h"
#include "GRID.h"
#ifdef CHECK_GETPWHERE
#include "EEPARAMS.h"
#include "PARAMS.h"
#endif /* CHECK_GETPWHERE */

       integer myThid,numpress
       _RL pressures(numpress)
       integer levpressures(numpress)
c
#ifdef CHECK_GETPWHERE
       INTEGER ioUnit, upperBnd
c      CHARACTER*(MAX_LEN_MBUF) msgBuf
#endif /* CHECK_GETPWHERE */
       integer n,L,dynlev
C Code that MUST correspond to make_phys_grid in the gridalt package!
C Require 12 bottom levels (300 mb worth) for the physics,
C    Counting from bottom to top, the dp(s) are:
       integer ntry,ntry10,ntry40
       parameter (ntry40=15)
       parameter (ntry10=12)
       _RL dptry(ntry40), dptry10(ntry10), dptry40(ntry40)
       _RL dptry_pedge(ntry40+1)
#ifdef TRY_NEW_GETPWHERE
       _RL rC_dyn(Nr), dpTop
#else
       _RL rF_pmid(Nr),rF_edge(Nr+1)
#endif
       _RL pref(Nrphys)
       integer tmplev
       data dptry10 /3.00, 6.00,10.00,14.00,17.00,25.00,
     .              25.00,25.00,25.00,50.00,50.00,50.00/
       data dptry40 /3.00, 6.00,10.00,14.00,17.00,25.00,
     .              25.00,25.00,25.00,25.00,25.00,25.00,
     .              25.00,25.00,25.00/

       if( (Nr.eq.10).or.(Nr.eq.20) ) then
        ntry = ntry10
        do L = 1,ntry
         dptry(L) = dptry10(L)
        enddo
       elseif ((Nr.eq.40).or.(Nr.eq.70)) then
        ntry = ntry40
        do L = 1,ntry
         dptry(L) = dptry40(L)
        enddo
       else
        print *,' Dont know how to set levels for given pressures '
        stop
       endif

C define the mid pressure for the levels that are specified - bottom 300 mb.
#ifdef TRY_NEW_GETPWHERE
       dptry_pedge(1) = rF(1)*1. _d -2
#else  /* TRY_NEW_GETPWHERE */
       dptry_pedge(1) = 1000.
#endif /* TRY_NEW_GETPWHERE */
       do L = 1,ntry
        dptry_pedge(L+1) = dptry_pedge(L) - dptry(L)
       enddo
       do L = 1,ntry
        pref(L) = (dptry_pedge(L) + dptry_pedge(L+1))/2.
       enddo
#ifdef CHECK_GETPWHERE
       ioUnit = errorMessageUnit
       WRITE(ioUnit,'(A)') '===== GETPWHERE: CHECK start ====='
       WRITE(ioUnit,'(4(A,I6),A)') '  Nr =', Nr,
     &                        ' , Nrphys=', Nrphys,
     &                        ' , ntry  =', ntry,
     &                        ' , pref(1:ntry):'
       WRITE(ioUnit,'(10F10.4)') (pref(L),L=1,ntry)
#endif /* CHECK_GETPWHERE */

#ifdef TRY_NEW_GETPWHERE
C top levels DP of 1 mb (or 0.01 mb for strat version)
       dpTop = 1. _d 0
       IF (Nr.EQ.70) dpTop = 1. _d -2
       DO L = ntry+1,Nrphys
        pref(L) = (Nrphys-L+0.5)*dpTop
       ENDDO
C define the rest of the mid pressures from the dynamics levels
       DO L = 1,Nr
        rC_dyn(L) = rC(L)*1. _d -2
       ENDDO

       dynlev = 0
       DO L = 1,Nr
         IF ( rC_dyn(L).GE.dptry_pedge(ntry+1) ) dynlev = L
       ENDDO
       DO L = ntry+1,MIN(Nrphys,ntry+Nr-dynlev)
         pref(L) = rC_dyn(dynlev+L-ntry)
       ENDDO
#else  /* TRY_NEW_GETPWHERE */
C define the rest of the mid pressures from the dynamics levels
       rF_edge(1) = 1000.
       do L = 2,Nr+1
        rF_edge(L) = rF_edge(L-1) - (drF(L-1)/100.)
       enddo
       do L = 1,Nr
        rF_pmid(L) = (rF_edge(L) + rF_edge(L+1))/2.
       enddo

       dynlev = 0
       do L = 1,Nr
        if(rF_pmid(L).ge.pref(ntry)) dynlev = L
       enddo
#ifdef CHECK_GETPWHERE
       IF ( rF_pmid(dynlev).ge.pref(ntry)-25. ) THEN
         upperBnd = ntry+Nr-dynlev
       ELSE
         upperBnd = ntry+Nr-dynlev-1
       ENDIF
       WRITE(ioUnit,'(1(A,I5),A)') ' Up-Bnd=', upperBnd,
     &                           ' , rF_pmid:'
       WRITE(ioUnit,'(10F10.4)') rF_pmid
       IF ( upperBnd.LT.Nrphys-1 ) THEN
         WRITE(ioUnit,'(A)')
     &   'ERROR: exeeding "rF_pmid" array bounds => pref ill defined'
c        STOP 'ABNORMAL END: S/R GETPWHERE'
       ENDIF
#endif /* CHECK_GETPWHERE */
       if(rF_pmid(dynlev).ge.pref(ntry)-25.) then
        do L = ntry+1,Nrphys-1
         pref(L) = rF_pmid(dynlev+L-ntry)
        enddo
       else
        pref(ntry) = rF_pmid(dynlev)
        do L = ntry+1,Nrphys-1
         pref(L) = rF_pmid(dynlev+L-ntry+1)
        enddo
       endif
C Add top level DP of 1 mb - p mid is at 0.5 mb (or 0.05 mb for strat version)
       pref(Nrphys) = 0.5
       if(Nr.eq.70)pref(Nrphys) = 0.005
#endif /* TRY_NEW_GETPWHERE */

       DO n = 1,numpress
        DO L = 1,Nrphys
         IF ( pref(L).GE.pressures(n) ) tmplev = L
        ENDDO

C and now flip the level numbers for the top down counting in fizhi
        levpressures(n) = Nrphys+1-tmplev
       ENDDO

#ifdef CHECK_GETPWHERE
       WRITE(ioUnit,'(3(A,I5),A)') ' dynlev=', dynlev,
     &                           ' , numpress=', numpress,
     &                           ' , pressures:'
       WRITE(ioUnit,'(10F10.4)') pressures
       WRITE(ioUnit,'(A)') 'pref(ntry:Nrphys):'
       WRITE(ioUnit,'(10F10.4)') (pref(L),L=ntry,Nrphys)
       WRITE(ioUnit,'(A)') 'levpressures:'
       WRITE(ioUnit,'(20I5)') levpressures
       WRITE(ioUnit,'(A)') '===== GETPWHERE: CHECK end   ====='
#endif /* CHECK_GETPWHERE */

       RETURN
       END

#include "SEAICE_OPTIONS.h"
#ifdef ALLOW_OBCS
# include "OBCS_OPTIONS.h"
#endif
#ifdef ALLOW_AUTODIFF
# include "AUTODIFF_OPTIONS.h"
#endif
#undef SEAICE_ALTERNATIVE_MODULUS_U_AND_V

CBOP
C     !ROUTINE: SEAICE_SIDEDRAG
C     !INTERFACE:
      SUBROUTINE SEAICE_SIDEDRAG_STRESS(
     I     uIceArg, vIceArg,
     I     coastRoughUarg, coastRoughVarg, AREAarg,
     O     sideDragUarg,sideDragVarg,
     I     iStep, myTime, myIter, myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE SEAICE_BOTTOMDRAG_COEFFS
C     | o Compute the side drag stress for ice-side drag,
C     |    as a parameterization for island-drag fastice
C     |    (Liu et al 2022)
C     *==========================================================*
C     | written by Yuqing Liu, Jul 2020
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "DYNVARS.h"
#include "SEAICE_SIZE.h"
#include "SEAICE_PARAMS.h"
#include "SEAICE.h"

C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
C     u/vIceArg      :: local copies of the current ice velocity
C     coastRoughUarg :: local copy of normalized coast length
C     coastRoughVarg :: local copy of normalized coast length
C     SideDraXarg    :: side drag in x direction
C     SideDraYarg    :: side drag in y direction
C     iStep     :: current sub-time step iterate
C     myTime    :: Simulation time
C     myIter    :: Simulation timestep number
C     myThid    :: my Thread Id. number
      _RL uIceArg       (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL vIceArg       (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL AREAarg       (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL sideDragUarg  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL sideDragVarg  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL coastRoughUarg(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL coastRoughVarg(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)

      INTEGER iStep
      _RL     myTime
      INTEGER myIter
      INTEGER myThid

#ifdef SEAICE_ALLOW_SIDEDRAG
C     === local variables ===
C     i,j,bi,bj,ksrf :: loop indices
      INTEGER i,j,bi,bj
      _RL    tmpx, tmpy
      _RL    uSpd(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL    u_0

      u_0 = 0.0005 _d 0
      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
C     initialize fields
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          sideDragUarg(i,j,bi,bj) = 0. _d 0
          sideDragVarg(i,j,bi,bj) = 0. _d 0
          uSpd(i,j)               = 0. _d 0
         ENDDO
        ENDDO

        DO j=1-OLy,sNy+OLy-1
         DO i=1-OLx,sNx+OLx-1
          uSpd(i,j) = 0.5 _d 0 *
     &          SQRT((uIceArg(i,  j,bi,bj)+uIceArg(i+1,j,  bi,bj))**2
     &              +(vIceArg(i,  j,bi,bj)+vIceArg(i,  j+1,bi,bj))**2)
         ENDDO
        ENDDO
C     calculate the sidedrag coeff for landfast ice parameterisations
C     (Liu et al 2022 use SEAICEsideDrag 2e-4)
        IF (SEAICEsideDrag .GT. 0. _d 0 ) THEN
         DO j=1-OLy+1,sNy+OLy-1
          DO i=1-OLx+1,sNx+OLx-1
           IF ( AREAarg(i,j,bi,bj) .GT. 0.01 _d 0 ) THEN
# ifndef SEAICE_ALTERNATIVE_MODULUS_U_AND_V
            tmpx = 0.5 _d 0 * ( uSpd(i,j) + uSpd(i-1,j) )
            tmpy = 0.5 _d 0 * ( uSpd(i,j) + uSpd(i,j-1) )
# else /* ifdef SEAICE_ALTERNATIVE_MODULUS_U_AND_V */
C     A different way to compute |u|, |v|, deprecated
            tmpx = sqrt(uIceArg(i,j,bi,bj)**2+ (0.25 _d 0*
     &           (vIceArg(i,  j,  bi,bj)+vIceArg(i-1,j,bi,bj)+
     &            vIceArg(i-1,j+1,bi,bj)+vIceArg(i,  j+1,bi,bj)))**2)
            tmpy = sqrt(vIceArg(i,j,bi,bj)**2+ (0.25 _d 0*
     &           (uIceArg(i,  j,  bi,bj)+uIceArg(i,  j-1,bi,bj)+
     &            uIceArg(i+1,j-1,bi,bj)+uIceArg(i+1,j,bi,bj)))**2)
#endif

            sideDragUarg(i,j,bi,bj) =
     &           SEAICEsideDrag/(tmpx + u_0) * coastRoughUarg(i,j,bi,bj)
     &                                       *    seaiceMassU(i,j,bi,bj)
            sideDragVarg(i,j,bi,bj) =
     &           SEAICEsideDrag/(tmpy + u_0) * coastRoughVarg(i,j,bi,bj)
     &                                       *    seaiceMassV(i,j,bi,bj)
           ENDIF
          ENDDO
         ENDDO
        ELSEIF ( SEAICEsideDrag .LT. 0. _d 0 ) THEN
C     this is the quadratic drag law version, deprecated
         DO j=1-OLy+1,sNy+OLy-1
          DO i=1-OLx+1,sNx+OLx-1
           IF ( AREAarg(i,j,bi,bj) .GT. 0.01 _d 0 ) THEN
# ifndef SEAICE_ALTERNATIVE_MODULUS_U_AND_V
            tmpx = 0.5 _d 0 * ( uSpd(i,j) + uSpd(i-1,j) )
            tmpy = 0.5 _d 0 * ( uSpd(i,j) + uSpd(i,j-1) )
# else /* ifdef SEAICE_ALTERNATIVE_MODULUS_U_AND_V */
C     A different way to compute |u|, |v|, deprecated
            tmpx = sqrt(uIceArg(i,j,bi,bj)**2+ (0.25 _d 0*
     &           (vIceArg(i,  j,  bi,bj)+vIceArg(i-1,j,bi,bj)+
     &            vIceArg(i-1,j+1,bi,bj)+vIceArg(i,  j+1,bi,bj)))**2)
            tmpy = sqrt(vIceArg(i,j,bi,bj)**2+ (0.25 _d 0*
     &           (uIceArg(i,  j,  bi,bj)+uIceArg(i,  j-1,bi,bj)+
     &            uIceArg(i+1,j-1,bi,bj)+uIceArg(i+1,j,bi,bj)))**2)
# endif

            sideDragUarg(i,j,bi,bj) =
     &           - SEAICEsideDrag * tmpx * coastRoughUarg(i,j,bi,bj)
     &                                   *    seaiceMassU(i,j,bi,bj)
            sideDragVarg(i,j,bi,bj) =
     &           - SEAICEsideDrag * tmpy * coastRoughVarg(i,j,bi,bj)
     &                                   *    seaiceMassV(i,j,bi,bj)
           ENDIF
          ENDDO
         ENDDO
        ENDIF
       ENDDO
      ENDDO

#endif /* SEAICE_ALLOW_SIDEDRAG */

      RETURN
      END

#include "SHELFICE_OPTIONS.h"

CBOP
C !ROUTINE: SHELFICE_DIAGNOSTICS_DRAG

C !INTERFACE: ==========================================================
      SUBROUTINE SHELFICE_DIAGNOSTICS_DRAG(
     I        uFld, vFld,
     I        bi, bj, myIter, myThid )

C !DESCRIPTION:
C Finish to calculate Ice-Shelf stress and fill-up corresponding diagnostics

C !USES: ===============================================================
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "SHELFICE.h"

C !INPUT PARAMETERS: ===================================================
C  uFld           :: velocity, zonal component
C  vFld           :: velocity, meridional component
C  bi,bj          :: tile indices
C  myIter         :: current iteration number
C  myThid         :: my Thread Id number
      _RL uFld   (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL vFld   (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      INTEGER bi, bj
      INTEGER myIter, myThid

#ifdef ALLOW_SHELFICE
#ifdef ALLOW_DIAGNOSTICS
C !LOCAL VARIABLES : ====================================================
C  i,j            :: loop indices
C  k              :: vertical level
      INTEGER i, j, k
CEOP

      IF ( selectImplicitDrag.EQ.2 ) THEN
       DO j=1-OLy,sNy+OLy
        DO i=1-OLx+1,sNx+OLx
          k = MAX( 1, kTopC(i-1,j,bi,bj), kTopC(i,j,bi,bj) )
c         IF ( k.GE.1 ) THEN
           shelficeDragU(i,j,bi,bj) = -shelficeDragU(i,j,bi,bj)
     &                              * uFld(i,j,k)
c         ENDIF
        ENDDO
       ENDDO
       DO j=1-OLy+1,sNy+OLy
        DO i=1-OLx,sNx+OLx
          k = MAX( 1, kTopC(i,j-1,bi,bj), kTopC(i,j,bi,bj) )
c         IF ( k.GE.1 ) THEN
           shelficeDragV(i,j,bi,bj) = -shelficeDragV(i,j,bi,bj)
     &                              * vFld(i,j,k)
c         ENDIF
        ENDDO
       ENDDO
      ENDIF

      CALL DIAGNOSTICS_FILL_RS( shelficeDragU, 'SHI_TauX',
     &                          0, 1, 1, bi, bj, myThid )
      CALL DIAGNOSTICS_FILL_RS( shelficeDragV, 'SHI_TauY',
     &                          0, 1, 1, bi, bj, myThid )

#endif /* ALLOW_DIAGNOSTICS */
#endif /* ALLOW_SHELFICE */

      RETURN
      END

#include "PACKAGES_CONFIG.h"
#include "CPP_OPTIONS.h"

CBOP
C     !ROUTINE: INI_CG3D
C     !INTERFACE:
      SUBROUTINE INI_CG3D( myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE INI_CG3D
C     | o Initialise 3d conjugate gradient solver operators.
C     *==========================================================*
C     | These arrays are purely a function of the basin geom.
C     | We set then here once and them use then repeatedly.
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#ifdef ALLOW_NONHYDROSTATIC
# include "PARAMS.h"
# include "GRID.h"
# include "SURFACE.h"
# include "CG3D.h"
#endif /* ALLOW_NONHYDROSTATIC */

C     !INPUT/OUTPUT PARAMETERS:
C     myThid   :: My Thread Id number
      INTEGER myThid

#ifdef ALLOW_NONHYDROSTATIC
C     !LOCAL VARIABLES:
C     bi,bj    :: tile indices
C     i,j,k    :: Loop counters
C     faceArea :: Temporary used to hold cell face areas.
C     myNorm   :: Work variable used in clculating normalisation factor
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      INTEGER bi, bj
      INTEGER i, j, k, ks
      _RL     faceArea
      _RS     myNorm
      _RL     theRecip_Dr
      _RL     cg3dTolerance
      _RL     aU, aL, aW, aE, aN, aS
      _RL     tmpFac, nh_Fac, igwFac
      _RL     locGamma
CEOP

CcnhDebugStarts
c     _RL    phi(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
CcnhDebugEnds

C--   Initialise to zero over the full range of indices
      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        DO k=1,Nr
C-       From common bloc CG3D_R:
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           aW3d(i,j,k,bi,bj) = 0.
           aS3d(i,j,k,bi,bj) = 0.
           aV3d(i,j,k,bi,bj) = 0.
           aC3d(i,j,k,bi,bj) = 0.
           zMC (i,j,k,bi,bj) = 0.
           zML (i,j,k,bi,bj) = 0.
           zMU (i,j,k,bi,bj) = 0.
          ENDDO
         ENDDO
C-       From common bloc CG3D_WK_R:
         DO j=0,sNy+1
          DO i=0,sNx+1
           cg3d_q(i,j,k,bi,bj) = 0.
           cg3d_r(i,j,k,bi,bj) = 0.
           cg3d_s(i,j,k,bi,bj) = 0.
          ENDDO
         ENDDO
        ENDDO
       ENDDO
      ENDDO

      nh_Fac = 0.
      igwFac = 0.
      IF ( nonHydrostatic
     &      .AND. nh_Am2.NE.0. ) nh_Fac = 1. _d 0 / nh_Am2
      IF ( implicitIntGravWave ) igwFac = 1. _d 0

      IF ( use3Dsolver ) THEN
C--   Initialise laplace operator
C     aW3d: Ax/dX
C     aS3d: Ay/dY
C     aV3d: Ar/dR
      myNorm = 0. _d 0
      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        DO k=1,Nr
         DO j=1,sNy
          DO i=1,sNx+1
           faceArea = _dyG(i,j,bi,bj)*drF(k)
     &               *_hFacW(i,j,k,bi,bj)
#ifdef ALLOW_OBCS
     &               *maskInC(i,j,bi,bj)*maskInC(i-1,j,bi,bj)
#endif
           aW3d(i,j,k,bi,bj) = faceArea*recip_dxC(i,j,bi,bj)
     &                        *implicitNHPress*implicDiv2DFlow
           myNorm = MAX(ABS(aW3d(i,j,k,bi,bj)),myNorm)
          ENDDO
         ENDDO
C  deep-model: *deepFacC (faceArea), /deepFacC (recip_dx,y): => no net effect
         DO j=1,sNy+1
          DO i=1,sNx
           faceArea = _dxG(i,j,bi,bj)*drF(k)
     &               *_hFacS(i,j,k,bi,bj)
#ifdef ALLOW_OBCS
     &               *maskInC(i,j,bi,bj)*maskInC(i,j-1,bi,bj)
#endif
           aS3d(i,j,k,bi,bj) = faceArea*recip_dyC(i,j,bi,bj)
     &                        *implicitNHPress*implicDiv2DFlow
           myNorm = MAX(ABS(aS3d(i,j,k,bi,bj)),myNorm)
          ENDDO
         ENDDO
        ENDDO
        DO k=1,1
         DO j=1,sNy
          DO i=1,sNx
           aV3d(i,j,k,bi,bj) =  0.
          ENDDO
         ENDDO
        ENDDO
        DO k=2,Nr
         tmpFac = nh_Fac*rVel2wUnit(k)*rVel2wUnit(k)
     &          + igwFac*dBdrRef(k)*deltaTMom*dTtracerLev(k)
         IF (tmpFac.GT.0. ) tmpFac = 1. _d 0 / tmpFac
         DO j=1,sNy
          DO i=1,sNx
           faceArea = _rA(i,j,bi,bj)*maskC(i,j, k ,bi,bj)
     &                              *maskC(i,j,k-1,bi,bj)
     &                              *deepFac2F(k)
#ifdef ALLOW_OBCS
     &                              *maskInC(i,j,bi,bj)
#endif
           theRecip_Dr = recip_drC(k)
c          theRecip_Dr =
caja &      drF(k  )*_hFacC(i,j,k  ,bi,bj)*0.5
caja &     +drF(k-1)*_hFacC(i,j,k-1,bi,bj)*0.5
c          IF ( theRecip_Dr .NE. 0. )
c    &      theRecip_Dr = 1. _d 0/theRecip_Dr
           aV3d(i,j,k,bi,bj) = faceArea*theRecip_Dr*tmpFac
     &                        *implicitNHPress*implicDiv2DFlow
           myNorm = MAX(ABS(aV3d(i,j,k,bi,bj)),myNorm)
          ENDDO
         ENDDO
        ENDDO
       ENDDO
      ENDDO
      _GLOBAL_MAX_RS( myNorm, myThid )
      IF ( myNorm .NE. 0. _d 0 ) THEN
       myNorm = 1. _d 0/myNorm
      ELSE
       myNorm = 1. _d 0
      ENDIF

      _BEGIN_MASTER( myThid )
C-- set global parameter in common block:
       cg3dNorm = myNorm
C-- Define the solver tolerance in the appropriate Unit :
      cg3dNormaliseRHS = cg3dTargetResWunit.LE.zeroRL
      IF (cg3dNormaliseRHS) THEN
C-  when using a normalisation of RHS, tolerance has no unit => no conversion
        cg3dTolerance = cg3dTargetResidual
      ELSE
C-  convert Target-Residual (in W unit) to cg3d-solver residual unit [m^2/s^2]
        cg3dTolerance = cg3dNorm * cg3dTargetResWunit
     &                           * implicDiv2DFlow / deltaTMom
     &                           * rAc_3dMean * SQRT( n3dWetPts )
      ENDIF
      cg3dTolerance_sq = cg3dTolerance*cg3dTolerance
C-- print param values:
       WRITE(msgBuf,'(2A,1PE23.16)') 'INI_CG3D: ',
     &      'CG3D normalisation factor = ', cg3dNorm
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                     SQUEEZE_RIGHT, myThid )
       IF (.NOT.cg3dNormaliseRHS) THEN
        WRITE(msgBuf,'(2A,1PE22.15,A,1PE16.10,A)') 'INI_CG3D: ',
     &      'cg3dTolerance =', cg3dTolerance,
     &      ' (Area=', rAc_3dMean*SQRT(n3dWetPts), ')'
        CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
       ENDIF
       WRITE(msgBuf,*) '                               '
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                     SQUEEZE_RIGHT, myThid )
      _END_MASTER( myThid )

      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
C-    Set solver main diagonal term
        DO k=1,Nr
         DO j=1,sNy
          DO i=1,sNx
           aW = aW3d( i, j, k, bi,bj)
           aE = aW3d(i+1,j, k, bi,bj)
           aN = aS3d( i,j+1,k, bi,bj)
           aS = aS3d( i, j, k, bi,bj)
           aU = aV3d( i, j, k, bi,bj)
           IF ( k .NE. Nr  ) THEN
            aL = aV3d(i, j,k+1,bi,bj)
           ELSE
            aL = 0.
           ENDIF
           aC3d(i,j,k,bi,bj) = -aW-aE-aN-aS-aU-aL
          ENDDO
         ENDDO
        ENDDO
C-    Add free-surface source term
        IF ( selectNHfreeSurf.GE.1 ) THEN
         DO j=1,sNy
          DO i=1,sNx
           locGamma = drC(1)*recip_Bo(i,j,bi,bj)
     &              /( deltaTMom*deltaTFreeSurf
     &                *implicitNHPress*implicDiv2DFlow )
           ks = 1
c          ks = kSurfC(i,j,bi,bj)
c          IF ( ks.LE.Nr ) THEN
             aC3d(i,j,ks,bi,bj) = aC3d(i,j,ks,bi,bj)
     &         - freeSurfFac*recip_Bo(i,j,bi,bj)
     &          *rA(i,j,bi,bj)*deepFac2F(ks)/deltaTMom/deltaTFreeSurf
     &          / (1. _d 0 + locGamma )
c          ENDIF
          ENDDO
         ENDDO
        ELSE
         DO j=1,sNy
          DO i=1,sNx
           ks = kSurfC(i,j,bi,bj)
           IF ( ks.LE.Nr ) THEN
             aC3d(i,j,ks,bi,bj) = aC3d(i,j,ks,bi,bj)
     &         - freeSurfFac*recip_Bo(i,j,bi,bj)
     &          *rA(i,j,bi,bj)*deepFac2F(ks)/deltaTMom/deltaTFreeSurf
           ENDIF
          ENDDO
         ENDDO
        ENDIF
C-    Matrix solver normalisation
        DO k=1,Nr
         DO j=1,sNy
          DO i=1,sNx
           aW3d(i,j,k,bi,bj) = aW3d(i,j,k,bi,bj)*myNorm
           aS3d(i,j,k,bi,bj) = aS3d(i,j,k,bi,bj)*myNorm
           aV3d(i,j,k,bi,bj) = aV3d(i,j,k,bi,bj)*myNorm
           aC3d(i,j,k,bi,bj) = aC3d(i,j,k,bi,bj)*myNorm
          ENDDO
         ENDDO
        ENDDO
       ENDDO
      ENDDO

C--   Update overlap regions
      CALL EXCH_UV_XYZ_RS(aW3d,aS3d,.FALSE.,myThid)
      _EXCH_XYZ_RS(aV3d, myThid)
      _EXCH_XYZ_RS(aC3d, myThid)
CcnhDebugStarts
C     CALL PLOT_FIELD_XYZRS( aW3d, 'AW3D INI_CG3D.1' , Nr, 1, myThid )
C     CALL PLOT_FIELD_XYZRS( aS3d, 'AS3D INI_CG3D.1' , Nr, 1, myThid )
CcnhDebugEnds

C--   Initialise preconditioner
C     For now PC is just the identity. Change to
C     be LU factorization of d2/dz2 later. Note
C     check for consistency with S/R CG3D before
C     assuming zML is lower and zMU is upper!
      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        DO k=1,Nr
         DO j=1,sNy
          DO i=1,sNx
           IF ( aC3d(i,j,k,bi,bj) .NE. 0. ) THEN
            zMC(i,j,k,bi,bj) = aC3d(i,j,k,bi,bj)
            zML(i,j,k,bi,bj) = aV3d(i,j,k,bi,bj)
            IF ( k.NE.Nr ) THEN
             zMU(i,j,k,bi,bj)= aV3d(i,j,k+1,bi,bj)
            ELSE
             zMU(i,j,k,bi,bj)= 0.
            ENDIF
CcnhDebugStarts
C           zMC(i,j,k,bi,bj) = 1.
C           zMU(i,j,k,bi,bj) = 0.
C           zML(i,j,k,bi,bj) = 0.
CcnhDebugEnds
           ELSE
            zMC(i,j,k,bi,bj) = 1. _d 0
            zMU(i,j,k,bi,bj) = 0.
            zML(i,j,k,bi,bj) = 0.
           ENDIF
          ENDDO
         ENDDO
        ENDDO
        k = 1
         DO j=1,sNy
          DO i=1,sNx
           zMC(i,j,k,bi,bj) = 1. _d 0 / zMC(i,j,k,bi,bj)
           zMU(i,j,k,bi,bj) = zMU(i,j,k,bi,bj)*zMC(i,j,k,bi,bj)
          ENDDO
         ENDDO
        DO k=2,Nr
         DO j=1,sNy
          DO i=1,sNx
           zMC(i,j,k,bi,bj) = 1. _d 0 /
     &     (zMC(i,j,k,bi,bj)-zML(i,j,k,bi,bj)*zMU(i,j,k-1,bi,bj))
           zMU(i,j,k,bi,bj) = zMU(i,j,k,bi,bj)*zMC(i,j,k,bi,bj)
          ENDDO
         ENDDO
        ENDDO
        DO k=1,Nr
         DO j=1,sNy
          DO i=1,sNx
           IF ( aC3d(i,j,k,bi,bj) .EQ. 0. ) THEN
            zMC(i,j,k,bi,bj) = 1.
            zML(i,j,k,bi,bj) = 0.
            zMU(i,j,k,bi,bj) = 0.
CcnhDebugStarts
C          ELSE
C           zMC(i,j,k,bi,bj) = 1.
C           zML(i,j,k,bi,bj) = 0.
C           zMU(i,j,k,bi,bj) = 0.
CcnhDEbugEnds
           ENDIF
          ENDDO
         ENDDO
        ENDDO
       ENDDO
      ENDDO
C--   Update overlap regions
      _EXCH_XYZ_RS(zMC, myThid)
      _EXCH_XYZ_RS(zML, myThid)
      _EXCH_XYZ_RS(zMU, myThid)

      IF ( debugLevel .GE. debLevC ) THEN
        CALL WRITE_FLD_XYZ_RS( 'zMC',' ',zMC, 0, myThid )
        CALL WRITE_FLD_XYZ_RS( 'zML',' ',zML, 0, myThid )
        CALL WRITE_FLD_XYZ_RS( 'zMU',' ',zMU, 0, myThid )
      ENDIF
CcnhDebugStarts
c     DO k=1,Nr
c     DO j=1-OLy,sNy+OLy
c     DO i=1-OLx,sNx+OLx
c      phi(i,j,1,1) = zMc(i,j,k,1,1)
c     ENDDO
c     ENDDO
C     CALL PLOT_FIELD_XYRS( phi, 'zMC INI_CG3D.1' , 1, myThid )
c     ENDDO
C     CALL PLOT_FIELD_XYRS( zMU, 'zMU INI_CG3D.1' , Nr, 1, myThid )
C     CALL PLOT_FIELD_XYRS( zML, 'zML INI_CG3D.1' , Nr, 1, myThid )
CcnhDebugEnds

C--   end if (use3Dsolver)
      ENDIF

#endif /* ALLOW_NONHYDROSTATIC */

      RETURN
      END

#include "BLING_OPTIONS.h"

CBOP
      subroutine BLING_READ_PICKUP(
     O           pH_isLoaded,
     I           myIter, myThid )

C     ==========================================================
C     | subroutine bling_read_pickup
C     | o Read BLING arrays from a pickup file
C     ==========================================================

      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "BLING_VARS.h"

C     == Routine arguments ==
C     myThid  :: my Thread Id number
      LOGICAL pH_isLoaded
      INTEGER myIter
      INTEGER myThid

#ifdef ALLOW_BLING

C     !FUNCTIONS

C     !LOCAL VARIABLES:
      CHARACTER*(10) suff
      CHARACTER*(MAX_LEN_FNAM) fn, filNam
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      LOGICAL useCurrentDir, fileExist
      INTEGER fp, ioUnit
CEOP

      pH_isLoaded =.FALSE.
      ioUnit = errorMessageUnit

C--   pickup file name :
      IF (pickupSuff.EQ.' ') THEN
        IF ( rwSuffixType.EQ.0 ) THEN
          WRITE(fn,'(A,I10.10)') 'pickup_bling.', myIter
        ELSE
          CALL RW_GET_SUFFIX( suff, startTime, myIter, myThid )
          WRITE(fn,'(A,A)') 'pickup_bling.', myIter
        ENDIF
      ELSE
        WRITE(fn,'(A,A10)') 'pickup_bling.', pickupSuff
      ENDIF
      fp = precFloat64

C--   First check if pickup file exist
#ifdef ALLOW_MDSIO
      useCurrentDir = .FALSE.
      CALL MDS_CHECK4FILE(
     I                     fn, '.data', 'BLING_READ_PICKUP',
     O                     filNam, fileExist,
     I                     useCurrentDir, myThid )
#else
      STOP 'ABNORMAL END: S/R BLING_READ_PICKUP: Needs MDSIO pkg'
#endif

      IF ( fileExist ) THEN
C--   Read pickup file
        CALL READ_REC_3D_RL( fn, fp, Nr, pH, 1, myIter, myThid )
        pH_isLoaded = .TRUE.

        CALL READ_REC_3D_RL( fn, fp, Nr, irr_mem, 2, myIter, myThid )
        CALL READ_REC_3D_RL( fn, fp, Nr, chl, 3, myIter, myThid )
        CALL READ_REC_3D_RL( fn, fp, Nr, phyto_sm, 4, myIter, myThid )
        CALL READ_REC_3D_RL( fn, fp, Nr, phyto_lg, 5, myIter, myThid )
#ifndef USE_BLING_V1
        CALL READ_REC_3D_RL( fn, fp, Nr, phyto_diaz, 6, myIter, myThid )
#endif

        _EXCH_XYZ_RL( pH, myThid )
        _EXCH_XYZ_RL( irr_mem, myThid )
        _EXCH_XYZ_RL( chl, myThid )
        _EXCH_XYZ_RL( phyto_sm, myThid )
        _EXCH_XYZ_RL( phyto_lg, myThid )
#ifndef USE_BLING_V1
        _EXCH_XYZ_RL( phyto_diaz, myThid )
#endif

      ELSE
        pH_isLoaded = .FALSE.
        IF ( pickupStrictlyMatch ) THEN
          WRITE(msgBuf,'(4A)') 'BLING_READ_PICKUP: ',
     &      'try with " pickupStrictlyMatch=.FALSE.,"',
     &      ' in file: "data", NameList: "PARM03"'
          CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
          STOP 'ABNORMAL END: S/R BLING_READ_PICKUP'
        ELSE
          WRITE(msgBuf,'(2A)') 'WARNING >> BLING_READ_PICKUP: ',
     &      'will restart from approximated pH'
          CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
        ENDIF
      ENDIF

#endif /*  ALLOW_BLING  */

      RETURN
      END

#include "CPP_EEOPTIONS.h"

C--  File zero_adj.F:
C--   Contents
C--   o G_ZERO_ADJ_1D
C--   o G_ZERO_ADJ_LOC
C--   o G_ZERO_ADJ

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: G_ZERO_ADJ_1D
C     !INTERFACE:
      SUBROUTINE G_ZERO_ADJ_1D(
     I                  NrIn, g_FieldFwd, myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | o zero out a 1D tangent linear field
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     myThid :: my Thread Id number
      INTEGER NrIn, myThid
      _RL g_FieldFwd(NrIn)

C     !LOCAL VARIABLES:
      INTEGER k
CEOP

      DO k=1,NrIn
         g_FieldFwd(k) = 0. _d 0
      ENDDO

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: G_ZERO_ADJ_LOC
C     !INTERFACE:
      SUBROUTINE G_ZERO_ADJ_LOC(
     I                  NrIn, g_FieldFwd, myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | o zero out a local (no nsx,nsy dims.) tangent linear field
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     myThid :: my Thread Id number
      INTEGER NrIn, myThid
      _RL g_FieldFwd(1-OLx:sNx+OLx,1-OLy:sNy+OLy,NrIn)

C     !LOCAL VARIABLES:
      INTEGER i,j,k
CEOP

      DO k=1,NrIn
       DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
         g_FieldFwd(i,j,k) = 0. _d 0
        ENDDO
       ENDDO
      ENDDO

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: G_ZERO_ADJ
C     !INTERFACE:
      SUBROUTINE G_ZERO_ADJ(
     I                  NrIn, g_FieldFwd, myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | o zero out a full (incl. nsx,nsy dims.) tangent linear field
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     myThid :: my Thread Id number
      INTEGER NrIn, myThid
      _RL g_FieldFwd(1-OLx:sNx+OLx,1-OLy:sNy+OLy,NrIn,nSx,nSy)

C     !LOCAL VARIABLES:
      INTEGER bi,bj
      INTEGER i,j,k
CEOP

      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        DO k=1,NrIn
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           g_FieldFwd(i,j,k,bi,bj) = 0. _d 0
          ENDDO
         ENDDO
        ENDDO
       ENDDO
      ENDDO

      RETURN
      END

#include "FIZHI_OPTIONS.h"
      subroutine rayleigh(myid,pres,pkap,pekap,zsurf,u,v,t,s,im,jm,lm,
     .                                                bi,bj,rfu,rfv,rft)
C **********************************************************************
C
C  PURPOSE
C     Rayleigh Friction -- Linear Drag (Strong Damping) Above 70 Km
C
C  ARGUMENTS   DESCRIPTION
C
C  INPUT:
C     MYID .... PROCESS(OR) NUMBER
C     PRES .... MID-LEVEL PRESSURE IN MB
C     PKAP .... MID-LEVEL PRESSURE ** KAPPA
C     PEKAP ... EDGE-LEVEL PRESSURE ** KAPPA
C     ZSURF ... SURFACE ELEVATION IN M
C     U ....... U-WIND
C     V ....... V-WIND
C     TH ...... THETA (ACTUALLY REAL THETA * P0**KAPPA) IN K
C     S  ...... SPECIFIC HUMIDITY (KG/KG)
C     IM ...... NUMBER OF LONGITUDE POINTS
C     JM ...... NUMBER OF LATITUDE  POINTS
C     LM ...... NUMBER OF VERTICAL  LEVELS
C     BI ...... X-DIRECTION PROCESSOR INDEX
C     BJ ...... Y-DIRECTION PROCESSOR INDEX
C  OUTPUT:
C     RFU ..... U-WIND TENDENCY
C     RFV ..... V-WIND TENDENCY
C     RFT ..... THETA  TENDENCY
C
C **********************************************************************

      implicit none

      integer myid,im,jm,lm,bi,bj
      _RL zsurf(im,jm),pres(im,jm,lm),pkap(im,jm,lm)
      _RL pekap(im,jm,lm+1)
      _RL u(im,jm,lm),v(im,jm,lm),t(im,jm,lm),s(im,jm,lm)
      _RL rfu(im,jm,lm),rfv(im,jm,lm),rft(im,jm,lm)

      integer  i,j,L
      _RL rf(im,jm,lm)
      _RL z(im,jm,lm)
      _RL dz(im,jm,lm)
      _RL cpog, cpinv, virtcon, getcon, dampcoef
#ifdef ALLOW_DIAGNOSTICS
      logical  diagnostics_is_on
      external diagnostics_is_on
      _RL tmpdiag(im,jm)
#endif

C **********************************************************************
C ****   APPLY RAYLEIGH FRICTION TO WIND (INCLUDE HEATING)           ***
C **********************************************************************

      cpog = getcon('CP')/getcon('GRAVITY')
      cpinv = 1.0/getcon('CP')
      virtcon = getcon('VIRTCON')
      dampcoef = 2./3.

      do L=1,lm
       do j=1,jm
       do i=1,im
        dz(i,j,L) = cpog * (pekap(i,j,L+1)-pekap(i,j,L)) * t(i,j,L) *
     .                (1.+virtcon*s(i,j,L))
       enddo
       enddo
      enddo

      do j=1,jm
      do i=1,im
       z(i,j,lm) = zsurf(i,j) +  0.5 * dz(i,j,lm)
      enddo
      enddo

      do L=lm-1,1,-1
       do j=1,jm
       do i=1,im
        z(i,j,L) = z(i,j,L+1) + 0.5 * (dz(i,j,L)+dz(i,j,L+1))
       enddo
       enddo
      enddo

      do L=1,lm
       do j=1,jm
       do i=1,im
        rf(i,j,L) = dampcoef*(1+tanh((z(i,j,L)-50000.)/5000.))/86400.
        rfu(i,j,L) = - rf(i,j,L) * u(i,j,L)
        rfv(i,j,L) = - rf(i,j,L) * v(i,j,L)
        rft(i,j,L) = -(u(i,j,L)*rfu(i,j,L) + v(i,j,L)*rfv(i,j,L) )*cpinv
     .                        /pkap(i,j,L)
       enddo
       enddo
      enddo

#ifdef ALLOW_DIAGNOSTICS
      do L=1,lm

      if(diagnostics_is_on('RFU     ',myid) ) then
       do j=1,jm
       do i=1,im
        tmpdiag(i,j) = rfu(i,j,L)*86400
       enddo
       enddo
C      call diagnostics_fill(tmpdiag,'RFU     ',L,1,3,bi,bj,myid)
      endif

      if(diagnostics_is_on('RFV     ',myid) ) then
       do j=1,jm
       do i=1,im
        tmpdiag(i,j) = rfv(i,j,L)*86400
       enddo
       enddo
C      call diagnostics_fill(tmpdiag,'RFV     ',L,1,3,bi,bj,myid)
      endif

      if(diagnostics_is_on('RFT     ',myid) ) then
       do j=1,jm
       do i=1,im
        tmpdiag(i,j) = rft(i,j,L)*86400
       enddo
       enddo
C      call diagnostics_fill(tmpdiag,'RFT     ',L,1,3,bi,bj,myid)
      endif

      enddo
#endif

      return
      end

#include "LAND_OPTIONS.h"

CBOP
C     !ROUTINE: LAND_READPARMS
C     !INTERFACE:
      SUBROUTINE LAND_READPARMS( myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R LAND_READPARMS
C     | o Read Land package parameters from parameter
C     |   file "data.land"
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     == Global variables ===
C-- size for MITgcm & Land package :
#include "LAND_SIZE.h"

#include "EEPARAMS.h"
#include "PARAMS.h"
#include "LAND_PARAMS.h"
#ifdef ALLOW_MNC
# include "MNC_PARAMS.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     myThid     :: my Thread Id number
      INTEGER myThid

#ifdef ALLOW_LAND
C     !LOCAL VARIABLES:
C     msgBuf     :: Informational/error message buffer
C     iUnit      :: Work variable for IO unit number
C     k          :: loop counter
C     land_taveFreq :: retired; Frequency^-1 for time-Aver. output (s)
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      INTEGER iUnit, k
      _RL tmpvar
C-    retired parameters:
      _RL land_taveFreq
      LOGICAL land_timeave_mnc
CEOP

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C--   Land model parameters:
C     land_calc_grT  :: step forward ground Temperature
C     land_calc_grW  :: step forward soil moiture
C     land_impl_grT  :: solve ground Temperature implicitly
C     land_calc_snow :: step forward snow thickness
C     land_calc_alb  :: compute albedo of snow over land
C     land_oldPickup :: restart from an old pickup (= before checkpoint 52j)
C     land_grT_iniFile  :: File containing initial ground Temp.
C     land_grW_iniFile  :: File containing initial ground Water.
C     land_snow_iniFile :: File containing initial snow thickness.
C     land_deltaT    :: land model time-step
C     land_diagFreq  :: Frequency^-1 for diagnostic output (s)
C     land_monFreq   :: Frequency^-1 for monitor    output (s)
C     land_dzF       :: layer thickness
      NAMELIST /LAND_MODEL_PAR/
     &    land_calc_grT, land_calc_grW,
     &    land_impl_grT, land_calc_snow,
     &    land_calc_alb, land_oldPickup,
     &    land_grT_iniFile, land_grW_iniFile, land_snow_iniFile,
     &    land_deltaT, land_taveFreq, land_diagFreq, land_monFreq,
     &    land_dzF,
     &    land_timeave_mnc, land_snapshot_mnc, land_mon_mnc,
     &    land_pickup_write_mnc, land_pickup_read_mnc

C--   Physical constants :
C     land_grdLambda  :: Thermal conductivity of the ground
C     land_heatCs     :: Heat capacity of dry soil (J/m3/K)
C     land_CpWater    :: Heat capacity of water    (J/kg/K)
C     land_wTauDiff   :: soil moisture diffusion time scale
C     land_waterCap   :: field capacity per meter of soil
C     land_fractRunOff:: fraction of water in excess which run-off
C     land_rhoLiqW    :: density of liquid water (kg/m3)
C     land_rhoSnow    :: density of snow (kg/m3)
C     land_Lfreez     :: Latent heat of freezing (J/kg)
C     land_hMaxSnow   :: Maximum snow-thickness  (m)
C     diffKsnow       :: thermal conductivity of snow (W/m/K)
C     timeSnowAge     :: snow aging time scale   (s)
C     hNewSnowAge     :: new snow thickness that refresh the snow-age (by 1/e)
C     albColdSnow     :: albedo of cold (=dry) new snow (Tsfc < -10)
C     albWarmSnow     :: albedo of warm (=wet) new snow (Tsfc = 0)
C     albOldSnow      :: albedo of old snow (snowAge > 35.d)
C     hAlbSnow        :: snow thickness for albedo transition: snow/ground

      NAMELIST /LAND_PHYS_PAR/
     &    land_grdLambda, land_heatCs, land_CpWater,
     &    land_wTauDiff, land_waterCap, land_fractRunOff,
     &    land_rhoLiqW,
     &    land_rhoSnow, land_Lfreez,
     &    land_hMaxSnow, diffKsnow, timeSnowAge, hNewSnowAge,
     &    albColdSnow, albWarmSnow, tempSnowAlbL, albOldSnow, hAlbSnow

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      IF ( .NOT.useLand ) THEN
C-    pkg LAND is not used
        _BEGIN_MASTER(myThid)
C-    Track pkg activation status:
C     print a (weak) warning if data.land is found
         CALL PACKAGES_UNUSED_MSG( 'useLand', ' ', ' ' )
        _END_MASTER(myThid)
        RETURN
      ENDIF

      _BEGIN_MASTER(myThid)

C-    Set default value:
      land_calc_grT = .TRUE.
      land_calc_grW = .TRUE.
      land_impl_grT = .TRUE.
      land_calc_snow= .TRUE.
      land_calc_alb = .TRUE.
      land_oldPickup= .FALSE.
      land_grT_iniFile = ' '
      land_grW_iniFile = ' '
      land_snow_iniFile= ' '
      land_deltaT   = deltaTClock
      land_diagFreq = dumpFreq
      land_monFreq = monitorFreq
#ifdef ALLOW_MNC
      land_snapshot_mnc      = snapshot_mnc .AND. useMNC
      land_mon_mnc           = monitor_mnc .AND. useMNC
      land_pickup_write_mnc  = pickup_write_mnc .AND. useMNC
      land_pickup_read_mnc   = pickup_read_mnc .AND. useMNC
#else
      land_snapshot_mnc      = .FALSE.
      land_mon_mnc           = .FALSE.
      land_pickup_write_mnc  = .FALSE.
      land_pickup_read_mnc   = .FALSE.
#endif
      land_grdLambda= 0.42 _d 0
      land_heatCs   = 1.13 _d 6
      land_CpWater  =  4.2 _d 3
c     land_CpWater  = HeatCapacity_Cp
      land_wTauDiff =  48. _d 0*3600. _d 0
      land_waterCap = 0.24 _d 0
      land_fractRunOff = 0.5 _d 0
      land_rhoLiqW  = rhoConstFresh
C-    snow parameters:
      land_rhoSnow  = 330. _d 0
      land_Lfreez   = 334. _d 3
      land_hMaxSnow = 1. _d 3
      diffKsnow     = 0.30 _d 0
      timeSnowAge   = 50. _d 0 * 86400. _d 0
      hNewSnowAge   = 2. _d -3
      albColdSnow   = 0.85 _d 0
      albWarmSnow   = 0.70 _d 0
      tempSnowAlbL  = -10. _d 0
      albOldSnow    = 0.55 _d 0
      hAlbSnow      = 0.30 _d 0
C-    layer thickness:
      DO k=1,land_nLev
       land_dzF(k) = -1.
       land_rec_dzC(k) = -1.
      ENDDO

C-    retired parms default:
      land_timeave_mnc = .FALSE.
      land_taveFreq = UNSET_RL

      WRITE(msgBuf,'(A)') ' LAND_READPARMS: opening data.land'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     I                    SQUEEZE_RIGHT, myThid )

      CALL OPEN_COPY_DATA_FILE( 'data.land', 'LAND_READPARMS',
     O                          iUnit, myThid )

C--   Read parameters from open data file:

C-    Parameters for Land model:
      READ(UNIT=iUnit,NML=LAND_MODEL_PAR)

C-    Physical Constants for Land package
      READ(UNIT=iUnit,NML=LAND_PHYS_PAR)

      WRITE(msgBuf,'(A)')
     &   ' LAND_READPARMS: finished reading data.land'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     I                    SQUEEZE_RIGHT, myThid )

C--   Close the open data file
#ifdef SINGLE_DISK_IO
      CLOSE(iUnit)
#else
      CLOSE(iUnit,STATUS='DELETE')
#endif /* SINGLE_DISK_IO */

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C--   Check for retired parameters:
      IF ( land_taveFreq .NE. UNSET_RL ) THEN
        WRITE(msgBuf,'(2A)') 'LAND_READPARMS: ',
     &    '"land_taveFreq" is no longer allowed in file "data.land"'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(2A)') 'LAND_READPARMS: ',
     &    ' since "pkg/timeave" has been removed.'
        CALL PRINT_ERROR( msgBuf, myThid )
c       errCount = errCount + 1
        STOP 'ABNORMAL END: S/R LAND_READPARMS'
      ENDIF
      IF ( land_timeave_mnc ) THEN
        WRITE(msgBuf,'(2A)') 'LAND_READPARMS: "land_timeave_mnc"',
     &    ' is no longer allowed in file "data.land"'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(2A)') 'LAND_READPARMS: ',
     &    ' since "pkg/timeave" has been removed.'
        CALL PRINT_ERROR( msgBuf, myThid )
c       errCount = errCount + 1
        STOP 'ABNORMAL END: S/R LAND_READPARMS'
      ENDIF

C--   Derive other parameters:

      land_impl_grT = land_calc_grT .AND. land_impl_grT

      tmpvar = 0. _d 0
      DO k=1,land_nLev
       tmpvar = tmpvar+land_dzF(k)
       IF (tmpvar.GT.0. _d 0) land_rec_dzC(k) = 2. _d 0 / tmpvar
       tmpvar = land_dzF(k)
      ENDDO
      IF ( land_Lfreez.NE. 0. _d 0 ) THEN
        recip_Lfreez = 1. _d 0 / land_Lfreez
      ELSE
        recip_Lfreez = 0. _d 0
      ENDIF

#ifdef ALLOW_MNC
      land_snapshot_mnc     = useMNC .AND. land_snapshot_mnc
      land_mon_mnc          = useMNC .AND. land_mon_mnc
      land_pickup_write_mnc = useMNC .AND. land_pickup_write_mnc
      land_pickup_read_mnc  = useMNC .AND. land_pickup_read_mnc

      land_snapshot_mdsio     = (.NOT.land_snapshot_mnc)
     &                      .OR. outputTypesInclusive
      land_mon_stdio          = (.NOT.land_mon_mnc)
     &                      .OR. outputTypesInclusive
      land_pickup_write_mdsio = (.NOT.land_pickup_write_mnc)
     &                      .OR. outputTypesInclusive
#else
      land_snapshot_mnc       = .FALSE.
      land_mon_mnc            = .FALSE.
      land_pickup_write_mnc   = .FALSE.
      land_pickup_read_mnc    = .FALSE.
      land_snapshot_mdsio     = .TRUE.
      land_mon_stdio          = .TRUE.
      land_pickup_write_mdsio = .TRUE.
#endif

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      _END_MASTER(myThid)

C--   Everyone else must wait for the parameters to be loaded
      _BARRIER

#endif /* ALLOW_LAND */

      RETURN
      END

!=======================================================================
      subroutine MITCOMPONENT_tile_register( num_tiles, iReg )
      implicit none

! MPI variables
#include "mpif.h"
c     integer myid, numprocs, ierr, rc

! Predefined constants/arrays
#include "CPLR_SIG.h"

! Arguments
      integer num_tiles
      integer iReg(6,num_tiles)

! Functions
      integer mitcplr_match_comp
      integer generate_tag
      external mitcplr_match_comp
      external generate_tag

! Local
c     integer bi, bj
      integer n
      integer count, datatype, dest, tag, comm, ierr
      integer ibuf(MAX_IBUF)

!     ------------------------------------------------------------------

      write(LogUnit,'(A,I6,A,2I4)')
     &  'MITCOMPONENT_tile_register (pId=', my_rank_in_local,
     &  '): Starts ; num_tiles=', num_tiles

      if (num_tiles.lt.1)
     & STOP 'MITCOMPONENT_tile_register: num_tiles < 1'
      if (num_tiles.gt.MAX_TILES)
     & STOP 'MITCOMPONENT_tile_register: num_tiles > MAX_TILES'

      my_num_tiles = num_tiles
      do n=1,num_tiles
        my_tile_bi(n) = iReg(1,n)
        my_tile_bj(n) = iReg(2,n)
        my_tile_nx(n) = iReg(3,n)
        my_tile_ny(n) = iReg(4,n)
        my_tile_i0(n) = iReg(5,n)
        my_tile_j0(n) = iReg(6,n)
        write(LogUnit,'(A,I5,A,2I4,A,2I5,A,2I8)')
     &    ' tile #', n,
     &    ' ; bi,bj=', iReg(1,n), iReg(2,n),
     &    ' ; Ni,Nj=', iReg(3,n), iReg(4,n),
     &    ' ; Io,Jo=', iReg(5,n), iReg(6,n)
      enddo

! Set up buffer
      ibuf(1) = num_tiles

! Send message
      count=1
      datatype=MPI_INTEGER
      dest=my_coupler_rank
      tag=generate_tag(112,my_rank_in_global,'Register Tiles')
      comm=MPI_COMM_myglobal

      call MPI_Send( ibuf, count, datatype, dest, tag, comm, ierr )

      if (ierr.ne.0) then
       write(LogUnit,*) 'MITCOMPONENT_tile_register: rank(W,G,L)=',
     &            my_rank_in_world,my_rank_in_global,my_rank_in_local,
     &            ' ierr=',ierr
       STOP 'MITCOMPONENT_tile_register: MPI_Send failed'
      endif

      do n=1,my_num_tiles

! Set up buffer
c      bi = my_tile_bi(n)
c      bj = my_tile_bj(n)
       ibuf(1) = my_tile_nx(n)
       ibuf(2) = my_tile_ny(n)
       ibuf(3) = my_tile_i0(n)
       ibuf(4) = my_tile_j0(n)

! Send message
       count=4
       datatype=MPI_INTEGER
       dest=my_coupler_rank
       tag=generate_tag(113,n,'Register each tile')
       comm=MPI_COMM_myglobal

       call MPI_Send( ibuf, count, datatype, dest, tag, comm, ierr )

       if (ierr.ne.0) then
        write(LogUnit,*) 'MITCOMPONENT_tile_register: rank(W,G,L)=',
     &           my_rank_in_world,my_rank_in_global,my_rank_in_local,
     &           ' ierr=',ierr
        STOP 'MITCOMPONENT_tile_register: MPI_Send failed'
       endif

      enddo

      write(LogUnit,'(A,I6,A,2I4)')
     &  'MITCOMPONENT_tile_register (pId=', my_rank_in_local, '): done'

!     ------------------------------------------------------------------
      call flush(LogUnit)
      return
      end
!=======================================================================

#include "DEBUG_OPTIONS.h"

      SUBROUTINE DEBUG_CALL(
     I                text,
     I                myThid )
C     /==========================================================\
C     | SUBROUTINE DEBUG_CALL                                    |
C     | o Prints to STDOUT the text argument after "CALLING S/R" |
C     |==========================================================|
C     \==========================================================/
      IMPLICIT NONE

C     === Global data ===
#include "SIZE.h"
#include "EEPARAMS.h"

C     === Routine arguments ===
      CHARACTER*(*) text
      INTEGER myThid

C     === Local variables ====
      CHARACTER*(MAX_LEN_MBUF) msgBuf

      WRITE(msgBuf,'(A,A)') 'CALLING S/R ',text
      CALL DEBUG_MSG( msgBuf, myThid )

      RETURN
      END

#include "GGL90_OPTIONS.h"
#ifdef ALLOW_GMREDI
# include "GMREDI_OPTIONS.h"
#endif
#undef GM_EG_PROGNOSTIC

C--  File ggl90_idemix.F:
C--   Contents
C--   o GGL90_IDEMIX
C--   o IDEMIX_gofx2
C--   o IDEMIX_hofx1

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

CBOP
C     !ROUTINE: GGL90_IDEMIX
C     !INTERFACE: ======================================================
      SUBROUTINE GGL90_IDEMIX(
     I     bi, bj, hFacI, recip_hFacI, sigmaR,
     O     gTKE,
     I     myTime, myIter, myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R GGL90_IDEMIX
C     |
C     | IDEMIX1 model as described in
C     | - Olbers, D. and Eden, C. (2013), JPO, doi:10.1175/JPO-D-12-0207.1
C     | in a nutshell:
C     | computes contribution of internal wave field to vertical mixing
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "DYNVARS.h"
#include "GGL90.h"
#include "FFIELDS.h"
#include "GRID.h"

#ifdef ALLOW_GMREDI
# include "GMREDI.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
C     bi, bj :: Current tile indices
C     hFacI  :: thickness factors for w-cells (interface)
C               with reciprocal of hFacI = recip_hFacI
C     sigmaR :: Vertical gradient of iso-neutral density
C     gTKE   :: dissipation of IW energy (output of S/R GGL90_IDEMIX)
C     myTime :: Current time in simulation
C     myIter :: Current time-step number
C     myThid :: My Thread Id number
      INTEGER bi, bj
      _RL       hFacI(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL recip_hFacI(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL        gTKE(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL     sigmaR (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL     myTime
      INTEGER myIter
      INTEGER myThid

#ifdef ALLOW_GGL90_IDEMIX
C     !FUNCTIONS:
      _RL  IDEMIX_gofx2, IDEMIX_hofx1
#ifdef ALLOW_DIAGNOSTICS
      LOGICAL  DIAGNOSTICS_IS_ON
      EXTERNAL DIAGNOSTICS_IS_ON
#endif /* ALLOW_DIAGNOSTICS */

C     !LOCAL VARIABLES:
C     === Local variables ===
      INTEGER iMin ,iMax ,jMin ,jMax
      INTEGER i, j, k, kl, kp1, km1
      INTEGER kSrf, kTop, kBot
      INTEGER errCode
      _RL  deltaTloc
C     cstar :: vertical integral over N, eq (13) in Olbers+Eden (2013)
      _RL  fxa, fxb, fxc, cstar, twoOverPi, pijstar, recip_pijstar
      _RL  coordFac, recip_coordFac
      _RL  dfx        (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL  dfy        (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
c     bN0  :: vertically integrated N
      _RL  bN0        (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL  delta      (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL  Nsquare    (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL  a3d        (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL  b3d        (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL  c3d        (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
C     v0 :: mean lateral group velocity
      _RL  v0         (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
C     c0 ::  mean vertical group velocity, defined at interfaces (wVel-like)
      _RL  c0         (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
C     tau_d :: dissipation parameter (see Olbers and Eden 2013, eq.12)
      _RL  tau_d      (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL  forc       (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL  gm_forc    (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
#ifdef ALLOW_DIAGNOSTICS
      _RL  osborn_diff(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
#endif
CEOP

      iMin = 2-OLx
      iMax = sNx+OLx-1
      jMin = 2-OLy
      jMax = sNy+OLy-1

      IF ( usingPCoords ) THEN
       kSrf = Nr
       kTop = Nr
      ELSE
       kSrf =  1
       kTop =  2
      ENDIF
      deltaTloc = dTtracerLev(kSrf)

      coordFac = 1. _d 0
      IF ( usingPCoords) coordFac = gravity * rhoConst
      recip_coordFac = 1./coordFac

      twoOverPi     = 2. _d 0/PI
      pijstar       = PI*IDEMIX_jstar
      recip_pijstar = 1. _d 0 / pijstar

C     Initialize local fields
      DO k = 1, Nr
       DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
         gTKE(i,j,k)    = 0. _d 0
         Nsquare(i,j,k) = 0. _d 0
         delta(i,j,k)   = 0. _d 0
         a3d(i,j,k)     = 0. _d 0
         b3d(i,j,k)     = 1. _d 0
         c3d(i,j,k)     = 0. _d 0
         c0(i,j,k)      = 0. _d 0
         v0(i,j,k)      = 0. _d 0
         tau_d(i,j,k)   = 0. _d 0
         forc(i,j,k)    = 0. _d 0
#ifdef ALLOW_DIAGNOSTICS
         osborn_diff(i,j,k) = 0. _d 0
#endif
        ENDDO
       ENDDO
      ENDDO
      DO j=1-OLy,sNy+OLy
       DO i=1-OLx,sNx+OLx
         dfx(i,j) = 0. _d 0
         dfy(i,j) = 0. _d 0
         bN0(i,j) = 0. _d 0
         gm_forc(i,j) = 0. _d 0
       ENDDO
      ENDDO
c-----------------------------------------------------------------------
c     allow for IW everywhere by limiting buoyancy freq.
c-----------------------------------------------------------------------
      DO k=2,Nr
       DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
         Nsquare(i,j,k) = gravity*gravitySign*recip_rhoConst
     &                  * sigmaR(i,j,k) * coordFac
#ifdef GGL90_IDEMIX_CVMIX_VERSION
         Nsquare(i,j,k)= MAX( 0. _d 0, Nsquare(i,j,k) )
#else
         fxb = MAX( 1. _d -6, ABS( fCori(i,j,bi,bj) ))
         Nsquare(i,j,k)= MAX( 100.*fxb*fxb, Nsquare(i,j,k) )
     &                 *maskC(i,j,k,bi,bj)*maskC(i,j,k-1,bi,bj)
#endif
        ENDDO
       ENDDO
      ENDDO
c-----------------------------------------------------------------------
c     vertically integrated N
c-----------------------------------------------------------------------
      DO k=2,Nr
       DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
           bN0(i,j)=bN0(i,j)
     &       +SQRT(Nsquare(i,j,k))*drC(k)*recip_coordFac*hFacI(i,j,k)
        ENDDO
       ENDDO
      ENDDO
c-----------------------------------------------------------------------
c     vertical and horizontal group velocities
c     and constant for dissipation
c-----------------------------------------------------------------------
      DO k=2,Nr
       DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
#ifdef GGL90_IDEMIX_CVMIX_VERSION
          fxb   = ABS( fCori(i,j,bi,bj) )
          fxa   = SQRT(Nsquare(i,j,k))/(1. _d -22 + fxb)
          cstar = MAX(1. _d -2, bN0(i,j)*recip_pijstar)
#else
C     cstar is not limited from below (to say 1e-2), instead Nsquare is
C     limited from below to (10 * max(1e-6, fCori))**2
          fxb   = MAX( 1. _d -6, ABS( fCori(i,j,bi,bj) ))
          fxa   = SQRT(Nsquare(i,j,k))/fxb
          cstar = bN0(i,j)*recip_pijstar
#endif
          c0(i,j,k)=MAX(0. _d 0,
     &             cstar*IDEMIX_gamma*IDEMIX_gofx2(fxa,twoOverPI))
          v0(i,j,k)=MAX(0. _d 0,
     &             cstar*IDEMIX_gamma*IDEMIX_hofx1(fxa,twoOverPI))
C     next two lines: fxc = ACOSH( MAX(1,fxa) )
          fxc = MAX( 1. _d 0 , fxa )
          fxc = LOG( fxc + SQRT( fxc*fxc -1.))
#ifdef GGL90_IDEMIX_CVMIX_VERSION
          tau_d(i,j,k) = MAX( 1. _d -4, IDEMIX_mu0*fxb*fxc/cstar**2 )
#else
          tau_d(i,j,k) = IDEMIX_mu0*fxb*fxc
     &         * ( pijstar/(GGL90eps+bN0(i,j)) )**2
#endif
        ENDDO
       ENDDO
      ENDDO
      IF ( IDEMIX_tau_h .GT. 0. _d 0 ) THEN
C     horizontal diffusion of IW energy can become unstable for long
C     time steps, so limit horizontal group velocity to satisfy simple
C     CFL-like criterion:
C     tau_h V0**2 *dt/dx**2 < 0.25 <=> V0 < sqrt( 0.25 * dx**2/(dt*tau_h) )
       DO k=2,Nr
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          fxa = SQRT( 1. _d 0/( deltaTloc * IDEMIX_tau_h ) )
          fxb = 0.5*MIN( _dxF(i,j,bi,bj), _dyF(i,j,bi,bj) )*fxa
          v0(i,j,k) = MIN( v0(i,j,k), fxb )
         ENDDO
        ENDDO
       ENDDO
      ENDIF
c-----------------------------------------------------------------------
c     forcing by mesoscale GM
c-----------------------------------------------------------------------

c     vertically integrated forcing
#ifdef ALLOW_GMREDI
      IF (useGmredi) THEN
#ifdef GM_EG_PROGNOSTIC
       DO k=1,Nr
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
           gm_forc(i,j) = gm_forc(i,j)
     &         +GM_EG_diss(i,j,k,bi,bj)
     &         *drF(k)*recip_coordFac*hFacC(i,j,k,bi,bj)
         ENDDO
        ENDDO
       ENDDO
#else /* GM_EG_PROGNOSTIC */
       DO k=2,Nr
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
           gm_forc(i,j) = gm_forc(i,j)
     &              +MAX( 0. _d 0,Kwz(i,j,k,bi,bj)*Nsquare(i,j,k) )
     &               *drC(k)*recip_coordFac*hFacI(i,j,k)
         ENDDO
        ENDDO
       ENDDO
#endif /* GM_EG_PROGNOSTIC */
      ENDIF

      IF (IDEMIX_include_GM .AND. useGmredi) THEN
c      inject locally
#ifdef GM_EG_PROGNOSTIC
       DO k=2,Nr
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          forc(i,j,k) = forc(i,j,k)
     &              +.5 _d 0*(GM_EG_diss(i,j,k,bi,bj)+
     &                        GM_EG_diss(i,j,k-1,bi,bj))
         ENDDO
        ENDDO
       ENDDO
#else /* GM_EG_PROGNOSTIC */
       DO k=2,Nr
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          forc(i,j,k) = forc(i,j,k)
     &              +MAX( 0. _d 0,Kwz(i,j,k,bi,bj)*Nsquare(i,j,k) )
         ENDDO
        ENDDO
       ENDDO
#endif /* GM_EG_PROGNOSTIC */
      ENDIF

      IF (IDEMIX_include_GM_bottom .AND. useGmredi) THEN
c      inject at bottom box only
       DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
         IF ( usingPCoords ) THEN
          kBot=MIN(kSurfC(i,j,bi,bj)+1,Nr)
         ELSE
          kBot   = MAX(kLowC(i,j,bi,bj),1)
         ENDIF
         forc(i,j,kBot)=forc(i,j,kBot)
     &     + gm_forc(i,j)*recip_drC(kBot)*coordFac
     &                  *recip_hFacI(i,j,kBot)
        ENDDO
       ENDDO
      ENDIF
#endif /* ALLOW_GMREDI */

c-----------------------------------------------------------------------
c     horizontal diffusion of IW energy
c-----------------------------------------------------------------------
       DO k=2,Nr
        kl = k
        IF ( usingPCoords ) kl = k - 1
        DO j=1-OLy,sNy+OLy
         dfx(1-OLx,j)=0. _d 0
         DO i=1-OLx+1,sNx+OLx
          fxa = IDEMIX_tau_h*0.5 _d 0*(
     &        v0(i-1,j,k)*maskC(i-1,j,kl,bi,bj)
     &       +v0(i  ,j,k)*maskC(i  ,j,kl,bi,bj))
          dfx(i,j) = -fxa*_dyG(i,j,bi,bj)*drC(k)
     &                *(MIN(.5 _d 0,_hFacW(i,j,k-1,bi,bj) ) +
     &                  MIN(.5 _d 0,_hFacW(i,j,k  ,bi,bj) ) )
     &      *_recip_dxC(i,j,bi,bj)
     &      *(v0(i  ,j,k)*IDEMIX_E(i  ,j,k,bi,bj)
     &       -v0(i-1,j,k)*IDEMIX_E(i-1,j,k,bi,bj))
     &         *maskW(i,j,kl,bi,bj) ! paranoia setting
         ENDDO
        ENDDO
        DO i=1-OLx,sNx+OLx
         dfy(i,1-OLy)=0. _d 0
        ENDDO
        DO j=1-OLy+1,sNy+OLy
         DO i=1-OLx,sNx+OLx
          fxa = IDEMIX_tau_h*0.5 _d 0*(
     &        v0(i,j  ,k)*maskC(i,j  ,kl,bi,bj)
     &       +v0(i,j-1,k)*maskC(i,j-1,kl,bi,bj) )
          dfy(i,j) = -fxa*_dxG(i,j,bi,bj)*drC(k)
     &                *(MIN(.5 _d 0,_hFacS(i,j,k-1,bi,bj) ) +
     &                  MIN(.5 _d 0,_hFacS(i,j,k  ,bi,bj) ) )
     &      *_recip_dyC(i,j,bi,bj)
     &      *(v0(i,j  ,k)*IDEMIX_E(i,j  ,k,bi,bj)
     &       -v0(i,j-1,k)*IDEMIX_E(i,j-1,k,bi,bj))
     &         *maskS(i,j,kl,bi,bj) ! paranoia setting
         ENDDO
        ENDDO
c-----------------------------------------------------------------------
C     Compute divergence of fluxes, add time tendency
c-----------------------------------------------------------------------
        DO j=jMin,jMax
         DO i=iMin,iMax
          IDEMIX_E(i,j,k,bi,bj) = IDEMIX_E(i,j,k,bi,bj)
     &       + deltaTloc*(-recip_drC(k)*recip_rA(i,j,bi,bj)
     &                   *recip_hFacI(i,j,k)
     &         *((dfx(i+1,j)-dfx(i,j))+(dfy(i,j+1)-dfy(i,j)) )  )
     &         *maskC(i,j,kl,bi,bj) ! paranoia setting
         ENDDO
        ENDDO
       ENDDO ! k loop
c-----------------------------------------------------------------------
c      add interior forcing e.g. by mesoscale GM
c-----------------------------------------------------------------------
      DO k=2,Nr
       DO j=jMin,jMax
        DO i=iMin,iMax
          IDEMIX_E(i,j,k,bi,bj) = IDEMIX_E(i,j,k,bi,bj)
     &                      + forc(i,j,k)*deltaTloc
        ENDDO
       ENDDO
      ENDDO
c-----------------------------------------------------------------------
c      solve vertical diffusion implicitly
c-----------------------------------------------------------------------

C     delta_k = dt tau_v /drF_k (c_k+c_k+1)/2
C     delta(1) and delta(Nr) are zero by initialisation
      DO k=2,Nr-1
       DO j=jMin,jMax
        DO i=iMin,iMax
         delta(i,j,k)  = deltaTloc*IDEMIX_tau_v
     &        *recip_drF(k)*coordFac*recip_hFacC(i,j,k,bi,bj)
     &        *.5 _d 0*(c0(i,j,k)+c0(i,j,k+1))
        ENDDO
       ENDDO
      ENDDO
      IF ( usingPCoords ) THEN
       DO j=jMin,jMax
        DO i=iMin,iMax
         kBot = MIN(kSurfC(i,j,bi,bj),Nr)
         delta(i,j,kBot) = 0. _d 0
        ENDDO
       ENDDO
      ELSE
       DO j=jMin,jMax
        DO i=iMin,iMax
         kBot = MAX(kLowC(i,j,bi,bj),1)
         delta(i,j,kBot) = 0. _d 0
        ENDDO
       ENDDO
      ENDIF

C--   Lower diagonal  for E_(k-1) : -delta_k-1 c_k-1/drC_k
C     but leaving the contribution of c0_k-1 for later
      DO k=2,Nr
       DO j=jMin,jMax
        DO i=iMin,iMax
C-       No need for maskC(k-1) with recip_hFacC(k-1) in delta(k-1)
         a3d(i,j,k) = -delta(i,j,k-1)
     &        *recip_drC(k)*coordFac*recip_hFacI(i,j,k)
     &        *maskC(i,j,k,bi,bj)
        ENDDO
       ENDDO
      ENDDO

C--   Upper diagonal for E_(k+1):  delta_k c_k+1/drC_k
C     but leaving the contribution of c0_k+1 for later
      DO k=2,Nr
       DO j=jMin,jMax
        DO i=iMin,iMax
C-       No need for maskC(k) with recip_hFacC(k) in delta(k)
         c3d(i,j,k) = -delta(i,j,k)
     &        *recip_drC(k)*coordFac*recip_hFacI(i,j,k)
     &        *maskC(i,j,k-1,bi,bj)
        ENDDO
       ENDDO
      ENDDO

C     treat bottom and surface boundaries for coeffients
C     of upper and lower diagonal by masking
      IF ( usingPCoords ) THEN
       DO j=jMin,jMax
        DO i=iMin,iMax
C     a3d at bottom is zero
         kBot=MIN(kSurfC(i,j,bi,bj)+1,Nr)
         a3d(i,j,kBot) = 0. _d 0
C     for p-coords, c3d is zero at the surface, too
         c3d(i,j,Nr)   = 0. _d 0
        ENDDO
       ENDDO
      ELSEIF ( usingZCoords ) THEN
       DO j=jMin,jMax
        DO i=iMin,iMax
C     c3d at bottom is zero
         kBot = MAX(kLowC(i,j,bi,bj),1)
         c3d(i,j,kBot) = 0. _d 0
C     for z-coords, a3d is zero at the surface (level 2), too
         a3d(i,j,kTop) = 0. _d 0
        ENDDO
       ENDDO
      ENDIF
C     For k=1 there is nothing to solve for
      DO j=jMin,jMax
       DO i=iMin,iMax
C     so that both off-diagonal coefficients are zero
        a3d(i,j,1) = 0. _d 0
        c3d(i,j,1) = 0. _d 0
C     and the main diagonal is one (for stability)
        b3d(i,j,1) = 1. _d 0
       ENDDO
      ENDDO

C--   Center diagonal
      DO k=2,Nr
       DO j=jMin,jMax
        DO i=iMin,iMax
         b3d(i,j,k) = 1. _d 0+deltaTloc*tau_d(i,j,k)
     &         *IDEMIX_E(i,j,k,bi,bj)
     &         *maskC(i,j,k,bi,bj)*maskC(i,j,k-1,bi,bj)
     &        - ( a3d(i,j,k) + c3d(i,j,k) ) * c0(i,j,k)
        ENDDO
       ENDDO
      ENDDO

C--   Complete computation of lower and upper diagonal after they have
C     been used for the center diagonal: add the contribution of c0_k+/-1
      DO k=2,Nr
       kp1=MIN(k+1,Nr)
       km1=MAX(k-1,2)
       DO j=jMin,jMax
        DO i=iMin,iMax
         a3d(i,j,k) = a3d(i,j,k)*c0(i,j,km1)
         c3d(i,j,k) = c3d(i,j,k)*c0(i,j,kp1)
        ENDDO
       ENDDO
      ENDDO

C--   Apply flux boundary condition
      kl = kTop
      IF ( usingPCoords ) kl = kTop - 1
      DO j=jMin,jMax
       DO i=iMin,iMax
        IDEMIX_E(i,j,kTop,bi,bj) = IDEMIX_E(i,j,kTop,bi,bj)
     &       +deltaTloc*IDEMIX_F_s(i,j,bi,bj)
     &       *recip_drC(kTop)*coordFac*recip_hFacI(i,j,kTop)
     &       *maskC(i,j,kl,bi,bj)
       ENDDO
      ENDDO
      IF ( usingZCoords) THEN
       DO j=jMin,jMax
        DO i=iMin,iMax
         kBot = MAX(kLowC(i,j,bi,bj),1)
         IDEMIX_E(i,j,kBot,bi,bj) = IDEMIX_E(i,j,kBot,bi,bj)
     &        -deltaTloc*IDEMIX_F_b(i,j,bi,bj)
     &        *recip_drC(kBot)*coordFac*recip_hFacI(i,j,kBot)
     &        *maskC(i,j,kBot,bi,bj)
        ENDDO
       ENDDO
      ELSEIF ( usingPCoords ) THEN
       DO j=jMin,jMax
        DO i=iMin,iMax
         kBot = MIN(kSurfC(i,j,bi,bj)+1,Nr)
         IDEMIX_E(i,j,kBot,bi,bj) = IDEMIX_E(i,j,kBot,bi,bj)
     &        -deltaTloc*IDEMIX_F_b(i,j,bi,bj)
     &        *recip_drC(kBot)*coordFac*recip_hFacI(i,j,kBot)
     &        *maskC(i,j,kBot-1,bi,bj)
        ENDDO
       ENDDO
      ENDIF

C     solve tri-diagonal system
      errCode = -1
      CALL SOLVE_TRIDIAGONAL( iMin,iMax, jMin,jMax,
     I                        a3d, b3d, c3d,
     U                        IDEMIX_E(1-OLx,1-OLy,1,bi,bj),
     O                        errCode,
     I                        bi, bj, myThid )

C     generate TKE tendency due to dissipation of IW energy (output)
      DO k=2,Nr
       DO j=jMin,jMax
        DO i=iMin,iMax
         gTKE(i,j,k) =
     &        tau_d(i,j,k)*IDEMIX_E(i,j,k,bi,bj)*IDEMIX_E(i,j,k,bi,bj)
C-    to reproduce older results (before adding output arguement gTKE)
c    &        tau_d(i,j,k)*IDEMIX_E(i,j,k,bi,bj)**2
        ENDDO
       ENDDO
      ENDDO

#ifdef ALLOW_DIAGNOSTICS
      IF ( useDiagnostics ) THEN
c-----------------------------------------------------------------------
c     compute diffusivity due to internal wave breaking
c     assuming local Osborn-Cox balance model
c     kept for diagnostics only
c-----------------------------------------------------------------------
       IF ( DIAGNOSTICS_IS_ON('IDEMIX_K',myThid) ) THEN
        DO k=2,Nr
         DO j=jMin,jMax
          DO i=iMin,iMax
           osborn_diff(i,j,k) = IDEMIX_mixing_efficiency * gTKE(i,j,k)
     &          /MAX(1. _d -12,Nsquare(i,j,k))*maskC(i,j,k,bi,bj)
           osborn_diff(i,j,k) = MIN(IDEMIX_diff_max,osborn_diff(i,j,k))
          ENDDO
         ENDDO
        ENDDO
        CALL DIAGNOSTICS_FILL( osborn_diff ,'IDEMIX_K',
     &                          0, Nr, 2, bi, bj, myThid )
       ENDIF
       CALL DIAGNOSTICS_FILL( IDEMIX_E ,'IDEMIX_E',0,Nr,1,bi,bj,myThid)
       CALL DIAGNOSTICS_FILL( gTKE ,    'IDEMgTKE',0,Nr,1,bi,bj,myThid)
       CALL DIAGNOSTICS_FILL( tau_d,    'IDEMIX_t',0,Nr,2,bi,bj,myThid)
       CALL DIAGNOSTICS_FILL( v0,       'IDEMIX_v',0,Nr,2,bi,bj,myThid)
       CALL DIAGNOSTICS_FILL( c0 ,      'IDEMIX_c',0,Nr,2,bi,bj,myThid)
       CALL DIAGNOSTICS_FILL( forc,     'IDEMIX_F',0,Nr,2,bi,bj,myThid)
       CALL DIAGNOSTICS_FILL(IDEMIX_F_b,'IDEM_F_b',0, 1,1,bi,bj,myThid)
       CALL DIAGNOSTICS_FILL(IDEMIX_F_s,'IDEM_F_s',0, 1,1,bi,bj,myThid)
# ifdef ALLOW_GMREDI
       IF (useGmredi) THEN
        CALL DIAGNOSTICS_FILL( gm_forc, 'IDEM_F_g',0, 1,2,bi,bj,myThid)
       ENDIF
# endif
      ENDIF
#endif /* ALLOW_DIAGNOSTICS */

#endif /* ALLOW_GGL90_IDEMIX */
      RETURN
      END

#ifdef ALLOW_GGL90_IDEMIX
C     helper functions
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
      _RL FUNCTION IDEMIX_gofx2(xx,toPI)
      IMPLICIT NONE
      _RL xx
      _RL toPI                  ! 2.d0/PI
      _RL x,c
      x=MAX(3.d0,xx)
      c= 1.d0-toPI*ASIN(1.d0/x)
      IDEMIX_gofx2 = toPI/c*0.9d0*x**(-2.d0/3.d0)*(1.-EXP(-x/4.3d0))
      END
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
      _RL FUNCTION IDEMIX_hofx1(x,toPI)
      IMPLICIT NONE
      _RL x
      _RL toPI                  ! 2.d0/PI
      IDEMIX_hofx1 = toPI/(1.d0-toPI*ASIN(1.d0/MAX(1.01d0,x)))
     &     *(x-1.d0)/(x+1.d0)
      END
#endif /* ALLOW_GGL90_IDEMIX */

#include "ECCO_OPTIONS.h"
#include "AD_CONFIG.h"
#ifdef ALLOW_CTRL
# include "CTRL_OPTIONS.h"
#endif

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: ECCO_COST_INIT_VARIA

C     !INTERFACE:
      SUBROUTINE ECCO_COST_INIT_VARIA( myThid )

C     !DESCRIPTION:
c     o Initialise the variable cost function part.

C     !USES:
      IMPLICIT NONE
C     == Global variables ===
#include "EEPARAMS.h"
#include "SIZE.h"
#include "GRID.h"
#include "ECCO_SIZE.h"
#include "ECCO.h"
#ifdef ALLOW_COST
# include "cost.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
      INTEGER myThid

C     !LOCAL VARIABLES:
      INTEGER bi, bj
      INTEGER i, j, k
C     LOGICAL exst
CEOP

C--   Initialise adjoint of monthly mean files calculated
C--   in cost_averagesfields (and their ad...).
      CALL COST_AVERAGESINIT( myThid )
      _BARRIER

#ifndef ALLOW_TANGENTLINEAR_RUN
cph(
cph   The following init. shoud not be applied if in the middle
cph   of a divided adjoint run
cph)
c      INQUIRE( FILE='costfinal', EXIST=exst )
c      IF ( .NOT. exst) THEN
c        CALL ECCO_COST_INIT_BARFILES( myThid )
c      ENDIF
#endif

C--   Initialize the tiled cost function contributions.
      DO bj = myByLo(myThid), myByHi(myThid)
        DO bi = myBxLo(myThid), myBxHi(myThid)

#ifdef ALLOW_GENCOST_CONTRIBUTION
          DO k=1,NGENCOST
            objf_gencost(bi,bj,k) = 0. _d 0
            num_gencost(bi,bj,k)  = 0. _d 0
          ENDDO
#endif

        ENDDO
      ENDDO

      _BEGIN_MASTER( myThid )
      DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
          frame(i,j) = 1. _d 0
        ENDDO
      ENDDO
      _END_MASTER( myThid )

      _BARRIER

      RETURN
      END

!=======================================================================
      subroutine mitcplr_init2a( myTypeStr )

      implicit none
! Predefined constants/arrays
#include "CPLR_SIG.h"
! MPI variables
#include "mpif.h"

! Arguments
      character*(*) myTypeStr
! Local
      integer myid, numprocs, ierr
      integer n,j,lenbuf
      integer ibuf(MAX_IBUF)
!     ------------------------------------------------------------------

! Find-out my position (rank) in the "global" communicator
      call MPI_COMM_RANK( MPI_COMM_myglobal, myid, ierr )
      if (ierr.ne.0) write(LogUnit,*) 'MITCPLR_init2a: ',
     &     ' Rank = ',myid,' MPI_COMM_RANK ierr=',ierr
! How big is the "global" comminicator?
      call MPI_COMM_SIZE( MPI_COMM_myglobal, numprocs, ierr )
      if (ierr.ne.0) write(LogUnit,*) 'MITCPLR_init2a: ',
     &     ' Size = ',numprocs,' MPI_COMM_RANK ierr=',ierr
      if (VERB) write(LogUnit,*) 'MITCPLR_init2a: ',
     &     ' Rank/Size = ',myid,' /',numprocs

!     - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

! Assume nothing again
      num_coupler_procs=0

! Receive a message from each of the other processes in "myglobal"
      do n=0,numprocs-1
       ibuf( 1)=myid
       ibuf( 2)=0
       ibuf( 3)=0
       ibuf( 4)=0
       ibuf( 5)=0
       ibuf( 6)=0
       ibuf( 7)=0
       ibuf( 8)=0
       ibuf( 9)=0
       ibuf(10)=0
       ibuf(11)=0
       ibuf(12)=0
       lenbuf=12
       call MPI_Bcast(
     &               ibuf, lenbuf, MPI_INTEGER,
     &               n,
     &               MPI_COMM_myglobal, ierr )
       if (ierr.ne.0) write(LogUnit,*) 'MITCPLR_init2a: ',
     &    ' MPI_Bcast from ',ibuf(1),ibuf(2),' ierr=',ierr

       if ( ibuf(2).eq.MITCPLR_COUPLER ) then
! If the broadcaster is the "coupler"
        num_coupler_procs=num_coupler_procs + 1
        num_procs_in_global=num_procs_in_global+1
        rank_coupler_procs(num_coupler_procs) = ibuf(1)
       else
! If the broadcaster is a "component"
        num_procs_in_local=num_procs_in_local+1
        num_procs_in_global=num_procs_in_global+1
       endif

      enddo

      if (num_coupler_procs .ne. 1) then
       STOP 'MITCPLR_init2a: I can only handle one coupling process'
      endif

!     - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

! Find-out my position (rank) in the "world" communicator
      call MPI_COMM_RANK( MPI_COMM_World, n, ierr )
      if (ierr.ne.0) write(LogUnit,*) 'MITCPLR_init2a: ',
     &     ' Rank = ',myid,' MPI_COMM_RANK ierr=',ierr
! Find-out my position (rank) in the "local" communicator
      call MPI_COMM_RANK( MPI_COMM_myglobal, j, ierr )
      if (ierr.ne.0) write(LogUnit,*) 'MITCPLR_init2a: ',
     &     ' Rank = ',myid,' MPI_COMM_RANK ierr=',ierr

! Store the information
      my_coupler_rank=rank_coupler_procs(1)
      my_rank_in_world=n
      my_rank_in_global=myid
      my_rank_in_local=j

      if (VERB) write(LogUnit,*) 'MITCPLR_init2a: ',
     &     ' rank (W,G,L) =',
     &     my_rank_in_world,my_rank_in_global,my_rank_in_local,
     &     ' my_coupler_rank =',my_coupler_rank,' /',numprocs

!     ------------------------------------------------------------------
      call flush(LogUnit)
      return
      end
!=======================================================================

#include "RUNCLOCK_OPTIONS.h"

CBOP
C     !ROUTINE: RUNCLOCK_CONTINUE
C     !INTERFACE:
      FUNCTION RUNCLOCK_CONTINUE( myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | FUNCTION RUNCLOCK_CONTINUE
C     | o Function to signal time to termiante run
C     *==========================================================*
C     \ev
C     !USES:
      IMPLICIT NONE

C     === Global variables ===
#include "EEPARAMS.h"
#include "RUNCLOCK.h"

C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
C     myThid ::  my Thread Id number
      LOGICAL RUNCLOCK_CONTINUE
      INTEGER myThid
CEOP

#ifdef ALLOW_RUNCLOCK

C     !LOCAL VARIABLES:
C     === Local variables ===
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      INTEGER RC_now_yr,RC_now_mo,RC_now_dy
      INTEGER RC_now_hr,RC_now_mi,RC_now_sc
      INTEGER dd,dh,dm,ds
      INTEGER elapsed_secs,maxtime_secs
      Real*8 tins,ETmax

      _BEGIN_MASTER(myThid)
      IF (.NOT.RUNCLOCKIsOn) THEN
       WRITE(msgBuf,'(A)') ' RUNCLOCK_CONTINUE: RUNCLOCK not turned on'
       CALL PRINT_ERROR( msgBuf, myThid ) 
      ENDIF
      _END_MASTER(myThid)

C     Get the current wall-clock time
      CALL runclock_gettime(
     &   RC_now_yr,RC_now_mo,RC_now_dy,
     &   RC_now_hr,RC_now_mi,RC_now_sc,
     &   tins)

      CALL GLOBAL_MAX_R8(tins,myThid)

c     write(0,*) 'RUNCLOCK_CONTINUE: yr mo dy hr mi sc tins',
c    &   RC_now_yr,RC_now_mo,RC_now_dy,
c    &   RC_now_hr,RC_now_mi,RC_now_sc,
c    &   tins

      ds=RC_now_sc-RC_start_sc
      dm=RC_now_mi-RC_start_mi
      dh=RC_now_hr-RC_start_hr
      dd=RC_now_dy-RC_start_dy
c     write(0,'(A,4I3)') 'RUNCLOCK_CONTINUE: dy hr mi sc',dd,dh,dm,ds

      ETmax=((dd*24.+dh)*60.+dm)*60.+ds
      CALL GLOBAL_MAX_R8(ETmax,myThid)
      elapsed_secs=ETmax
c     elapsed_secs=((dd*24.+dh)*60.+dm)*60.+ds
      maxtime_secs=(RC_MaxTime_hr*60+RC_MaxTime_mi)*60+RC_MaxTime_sc

      _BEGIN_MASTER(myThid)
c     write(0,*) ' RUNCLOCK_CONTINUE: elapsed=',elapsed_secs,maxtime_secs

c     IF (myProcID.EQ.0)
c    & write(0,'(A,4I3,2I6,F)') 'RUNCLOCK_CONTINUE: dy hr mi sc el mx',
c    &  dd,dh,dm,ds,elapsed_secs,maxtime_secs,tins-RC_start_tins

      WRITE(msgBuf,'(A,G16.6,G24.10)') ' RUNCLOCK: dT,T-To =',
     &  tins-RC_prev_tins,tins-RC_start_tins
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT , 1)
      RC_prev_tins=tins

      IF (maxtime_secs.ne.0 .AND. elapsed_secs.GT.maxtime_secs) THEN
       RUNCLOCK_CONTINUE=.FALSE.
       WRITE(msgBuf,'(A)') 
     & ' RUNCLOCK_CONTINUE: Wall Clock limit reached!'
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT , 1)
       CALL PRINT_ERROR( msgBuf, myThid )
       WRITE(msgBuf,'(A)') ' RUNCLOCK_CONTINUE: Ending run now ...'
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT , 1)
       CALL PRINT_ERROR( msgBuf, myThid )
       RETURN
      ENDIF

      _END_MASTER(myThid)

#endif /* ALLOW_RUNCLOCK */

      RUNCLOCK_CONTINUE=.TRUE.

      RETURN
      END

#include "SBO_OPTIONS.h"

CBOP
C !ROUTINE: SBO_OUTPUT

C !INTERFACE:
      SUBROUTINE SBO_OUTPUT( myTime, myIter, myThid )

C !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE SBO_OUTPUT
C     | o Do SBO diagnostic output.
C     *==========================================================*

C !USES:
      IMPLICIT NONE
C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "SBO.h"

C !INPUT PARAMETERS:
C     myTime    :: my time in simulation ( s )
C     myIter    :: my Iteration number
C     myThid    :: my Thread Id number
      _RL     myTime
      INTEGER myIter
      INTEGER myThid

#ifdef ALLOW_SBO
C !FUNCTIONS:
      LOGICAL  DIFFERENT_MULTIPLE
      EXTERNAL DIFFERENT_MULTIPLE

C !LOCAL VARIABLES:
C     sbo_diag  :: vector of SBO diagnostics contains:
C                  model time (s), xoamc, yoamc, zoamc,
C                  xoamp, yoamp, zoamp, mass, xcom, ycom, zcom
C     fName     :: output file name
C     msgBuf    :: Informational/error message buffer
      CHARACTER*(10) suff
      CHARACTER*(MAX_LEN_FNAM) fName
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      INTEGER narr
      PARAMETER( narr = 24 )
      INTEGER irecord
      INTEGER ioUnit
      _RL     sbo_diag(narr)
      _RS     dummyRS(1)

C-----------------------------------------------------------------
C     Save angular momentum and mass variables at every time step
C-----------------------------------------------------------------

      sbo_diag(1)  = myTime
      sbo_diag(2)  = xoamc
      sbo_diag(3)  = yoamc
      sbo_diag(4)  = zoamc
      sbo_diag(5)  = xoamp
      sbo_diag(6)  = yoamp
      sbo_diag(7)  = zoamp
      sbo_diag(8)  = mass
      sbo_diag(9)  = xcom
      sbo_diag(10) = ycom
      sbo_diag(11) = zcom
      sbo_diag(12) = sboarea

      sbo_diag(13) = xoamc_si
      sbo_diag(14) = yoamc_si
      sbo_diag(15) = zoamc_si
      sbo_diag(16) = mass_si

      sbo_diag(17) = xoamp_fw
      sbo_diag(18) = yoamp_fw
      sbo_diag(19) = zoamp_fw
      sbo_diag(20) = mass_fw
      sbo_diag(21) = xcom_fw
      sbo_diag(22) = ycom_fw
      sbo_diag(23) = zcom_fw

      sbo_diag(24) = mass_gc

      irecord      = myIter - nIter0 + 1

#ifdef ALLOW_MDSIO
      _BEGIN_MASTER(myThid)
C-    multi-threaded: only write it once (by master thread)
       IF ( rwSuffixType.EQ.0 ) THEN
         WRITE(fName,'(A,I10.10)') 'SBO_global.', nIter0
       ELSE
         CALL RW_GET_SUFFIX( suff, startTime, nIter0, myThid )
         WRITE(fName,'(A,A)') 'SBO_global.', suff
       ENDIF
       ioUnit  = 0
       CALL MDS_WRITEVEC_LOC(
     I           fName, precFloat64, ioUnit,
     I           'RL', narr, sbo_diag, dummyRS,
     I           0, 0, irecord, myIter, myThid )
      _END_MASTER(myThid)
#endif /* ALLOW_MDSIO */

      IF ( myIter .EQ. nIter0 .OR.
     &     DIFFERENT_MULTIPLE(sbo_monFreq,myTime,deltaTClock)
     &   ) THEN

        _BEGIN_MASTER(myThid)

        ioUnit = standardMessageUnit
        WRITE(msgBuf,'(A,1PE21.13)')
     &    '%SBO sbo_mass                     = ', mass
        CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
        WRITE(msgBuf,'(A,1PE21.13)')
     &    '%SBO sbo_mass_fw                  = ', mass_fw
        CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
        WRITE(msgBuf,'(A,1PE21.13)')
     &    '%SBO sbo_zoamc                    = ', zoamc
        CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
        WRITE(msgBuf,'(A,1PE21.13)')
     &    '%SBO sbo_zoamp                    = ', zoamp
        CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )

        _END_MASTER(myThid)

      ENDIF

#endif /* ALLOW_SBO */

      RETURN
      END

        program write_float

        double precision npart,xpart,ypart,kpart,kfloat,iup,itop
     &                  ,tstart,tend

        parameter(Nx=80,Ny=42)
        double precision depth(Nx,Ny),xc(Nx),yc(Ny),degX,degY
c
        integer kyear,kpres,kday
        real rtime,rlon,rlat
        integer narg
        logical flag

c
c if float should not be written use flag
c
      flag = .true.
      narg=iargc()
      if ( narg .gt. 0 ) flag = .false.
      print*, flag
      
      if (flag) then
c
c open float file
c
        ilen2=9*8
        open(1,file='float_pos.input',status='new',form='unformatted'
     &       ,access='direct',recl=ilen2)
      endif
c
c read bathymetry
c
        ilen=Nx*Ny*8
        open(2,file='topog.bump',status='old',form='unformatted'
     &,      access='direct',recl=ilen)
        read(2,rec=1) depth
        close(2)
c
c generate axes
c
        degX=5000.
        xc(1)=2500.
        do i=2,Nx
           xc(i)=xc(i-1)+degX
        enddo
c     
        degY=5000.
        yc(1)=2500.
        do j=2,Ny
           yc(j)=yc(j-1)+degY
        enddo

        print*,'xc(1), xc(Nx): ',xc(1), xc(Nx)
        print*,'yc(1), yc(Ny): ',yc(1), yc(Ny)
c     
c preset first line with dummies
                   npart  = 0.
                  tstart  = -1.
                   xpart  = 0.
                   ypart  = 0.
                   kpart  = 0.
                   kfloat = 0.
                   iup    = 0.
                   itop   = 0.
                   tend   = -1.
        if (flag)  write(1,rec=1)    npart,tstart,xpart,ypart,
     &                               kpart,kfloat,iup,itop,tend

 100    continue
c
        print*, '--------------------------------------------------'
        print*, '|         FLOAT CONFIGURATION                    |'
        print*, '--------------------------------------------------'
        print*, ' '
        print*, 'sets over whole basin: '
        ip=0
c
c target depth: level 5
c profiling:    5 days
c surface time: 12, 24  hours
c
        do j=20,30,2
           do i=20,50,2
              if (depth(i,j) .le. -2530.) then
                 ip=ip+1
                   npart  = REAL(ip)
                  tstart  = -1.
                   xpart  = xc(i)
                   ypart  = yc(j)
                   kpart  = 5.
                   kfloat = kpart
                   iup    = 432000.
                   itop   =  43200.
                   tend   = -1.
         if (flag) write(1,rec=ip+1) npart,tstart,xpart,ypart,
     &                               kpart,kfloat,iup,itop,tend
              endif
           enddo
        enddo
        write(6,200) 'ip = ',ip,' kpart,kfloat,iup,itop,tstart,tend: ',
     &                            kpart,kfloat,iup,itop,tstart,tend
 200    format(A,I6,A,2F3.0,4F8.0)
c
        do j=20,30,2
           do i=20,50,2
              if (depth(i,j) .le. -2530.) then
                 ip=ip+1
                   npart  = REAL(ip)
                  tstart  = -1.
                   xpart  = xc(i)
                   ypart  = yc(j)
                   kpart  = 5.
                   kfloat = kpart
                   iup    = 432000.
                   itop   =  86400.
                   tend   = -1.
         if (flag) write(1,rec=ip+1) npart,tstart,xpart,ypart,
     &                               kpart,kfloat,iup,itop,tend
              endif
           enddo
        enddo
        write(6,200) 'ip = ',ip,' kpart,kfloat,iup,itop,tstart,tend: ',
     &                            kpart,kfloat,iup,itop,tstart,tend
c
c
c target depth: level 5
c profiling:    1 day
c surface time: 12 hours
c integrating only day 2-5
c
        do j=20,30,2
           do i=20,50,2
              if (depth(i,j) .le. -2530.) then
                 ip=ip+1
                   npart  = REAL(ip)
                  tstart  = 172800.
                   xpart  = xc(i)
                   ypart  = yc(j)
                   kpart  = 0.
                   kfloat = 5.
                   iup    = 86400.
                   itop   = 43200.
                   tend   = 518400.
         if (flag) write(1,rec=ip+1) npart,tstart,xpart,ypart,
     &                               kpart,kfloat,iup,itop,tend
              endif
           enddo
        enddo
        write(6,200) 'ip = ',ip,' kpart,kfloat,iup,itop,tstart,tend: ',
     &                            kpart,kfloat,iup,itop,tstart,tend
c
c
c target depth: level 5
c no profiling
c integrating starting day 5
c
        do j=20,30,2
           do i=20,50,2
              if (depth(i,j) .le. -2530.) then
                 ip=ip+1
                   npart  = REAL(ip)
                  tstart  = 432000.
                   xpart  = xc(i)
                   ypart  = yc(j)
                   kpart  = 0.
                   kfloat = 5.
                   iup    = 0.
                   itop   = 0.
                   tend   = -1.
         if (flag) write(1,rec=ip+1) npart,tstart,xpart,ypart,
     &                               kpart,kfloat,iup,itop,tend
              endif
           enddo
        enddo
        write(6,200) 'ip = ',ip,' kpart,kfloat,iup,itop,tstart,tend: ',
     &                            kpart,kfloat,iup,itop,tstart,tend
c
c mooring
c
        do j=20,30,2
           i=20
                 ip=ip+1
                   npart  = REAL(ip)
                  tstart  = -1.
                   xpart  = xc(i)
                   ypart  = yc(j)
                   kpart  = 0.
                   kfloat = kpart
                   iup    = -3.
                   itop   = 0.
                   tend   = -1.
         if (flag) write(1,rec=ip+1) npart,tstart,xpart,ypart,
     &                               kpart,kfloat,iup,itop,tend
        enddo
        write(6,200) 'ip = ',ip,' kpart,kfloat,iup,itop,tstart,tend: ',
     &                            kpart,kfloat,iup,itop,tstart,tend
c

        print*, ' '
        print*, '--------------------------------------------------'
        print*, 'total number of floats: npart = ',ip
        print*, '--------------------------------------------------'

c write total number of floats in first line
                   npart  = DBLE(ip)
                  tstart  = -1.
                   xpart  = 0.
                   ypart  = 0.
                   kpart  = 0.
                   kfloat = DBLE(ip)
                   iup    = 0.
                   itop   = 0.
                   tend   = -1.
                   if (flag)
     & write(1,rec=1) npart,tstart,xpart,ypart,kpart,kfloat,iup,itop,tend



        close(1)

        end

#include "DIAG_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 0
C     !ROUTINE: DIAGSTATS_OUTPUT

C     !INTERFACE:
      SUBROUTINE DIAGSTATS_OUTPUT(
     I     listId,
     I     myTime, myIter, myThid )

C     !DESCRIPTION:
C     Write output for diagnostics fields.

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "DIAGNOSTICS_SIZE.h"
#include "DIAGNOSTICS.h"

      INTEGER nLev
      PARAMETER( nLev = numLevels )

C     !INPUT PARAMETERS:
C     listId  :: Diagnostics list number being written
C     myIter  :: current iteration number
C     myTime  :: Current time of simulation (s)
C     myThid  :: my Thread Id number
      _RL     myTime
      INTEGER listId, myIter, myThid
CEOP

C     !FUNCTIONS:
c     INTEGER ILNBLNK
c     EXTERNAL ILNBLNK
#ifdef ALLOW_FIZHI
      _RL   getcon
      EXTERNAL getcon
#endif

C     !LOCAL VARIABLES:
      INTEGER j, m, ndId, iSp, iSm
      CHARACTER*10 gcode
      INTEGER mate
      _RL statGlob(0:nStats,0:nLev,0:nRegions)
      _RL tmp_Glob(0:nStats,0:nLev)
      _RL undef

      INTEGER ioUnit
      CHARACTER*(MAX_LEN_MBUF) msgBuf

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      ioUnit= standardMessageUnit
      undef = UNSET_RL
#ifdef ALLOW_FIZHI
      IF ( useFIZHI ) undef = getcon('UNDEF')
#endif

      DO m = 1,diagSt_nbFlds(listId)
       ndId = jSdiag(m,listId)
       gcode = gdiag(ndId)(1:10)
       IF ( iSdiag(m,listId).NE.0 .AND. gcode(5:5).NE.'D' ) THEN
C--    Start processing 1 Fld :

         IF ( gcode(5:5).EQ.'C' ) THEN
C          Check for Mate of a Counter Diagnostic
C          --------------------------------------
           mate = hdiag(ndId)
         ELSE
           mate = 0
         ENDIF

         DO j=0,nRegions
          IF ( diagSt_region(j,listId).GT.0 ) THEN
            iSp = ABS(iSdiag(m,listId))
            iSm = mSdiag(m,listId)
            CALL DIAGSTATS_GLOBAL(
     O                       statGlob(0,0,j), tmp_Glob,
     I                       undef, nLev, j,
     I                       ndId, mate, iSp, iSm, myThid )

C-          Check for empty Diag (= not filled or using empty mask)
            IF ( tmp_Glob(0,0).EQ.0. ) THEN
             _BEGIN_MASTER( myThid )
             WRITE(msgBuf,'(2A,I10,A,I4)') '- WARNING -',
     &         ' from DIAGSTATS_OUTPUT at iter=', myIter,
     &         ' , region:', j
             CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                           SQUEEZE_RIGHT, myThid )
             WRITE(msgBuf,'(2A,I6,3A,I4,2A)') '- WARNING -',
     &         ' diagSt.#', ndId, ' : ', diagSt_Flds(m,listId),
     &         ' (#', m, ' ) in outp.Stream: ', diagSt_Fname(listId)
             CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                           SQUEEZE_RIGHT, myThid )
             IF ( kdiag(ndId).GT.nLev ) THEN
              WRITE(msgBuf,'(2(A,I4))') '- WARNING - kdiag=',
     &                     kdiag(ndId), ' exceeds local nLev=', nLev
             ELSE
              WRITE(msgBuf,'(2A)') '- WARNING - has not been filled,',
     &                             ' OR using empty mask/region'
             ENDIF
             CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                           SQUEEZE_RIGHT, myThid )
             WRITE(msgBuf,'(A)')
     &         'WARNING DIAGSTATS_OUTPUT  => write UNDEF instead'
             CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                           SQUEEZE_RIGHT, myThid )
             _END_MASTER( myThid )
            ENDIF

            IF ( diag_dBugLevel .GE. debLevB ) THEN
             _BEGIN_MASTER( myThid )
              WRITE(ioUnit,'(A,I6,3A,I3,3A,I3,A,1PE10.3)')
     &          ' Compute Stats, Diag. #', ndId, ' "', cdiag(ndId),
     &          '" (list#', listId, ') Parms "', gdiag(ndId),
     &          '", vol(',j,' )=', statGlob(0,0,j)
             IF ( mate.GT.0 ) THEN
              WRITE(ioUnit,'(A,I6,3A,I3,2(A,1PE10.3))')
     &          '     use Counter Mate #', mate, ' "', cdiag(mate),
     &          '" vol(',j,' )=', tmp_Glob(0,0),
     &          ', integral=', tmp_Glob(1,0)
             ENDIF
             _END_MASTER( myThid )
            ENDIF
          ENDIF
         ENDDO

C--      Write to ASCII file:
         IF (diagSt_Ascii) THEN
           CALL DIAGSTATS_ASCII_OUT( statGlob, nLev, ndId,
     &                               m, listId, myIter, myThid )
         ENDIF

#ifdef ALLOW_MNC
         IF (diagSt_mnc) THEN
           CALL DIAGSTATS_MNC_OUT(
     &          statGlob, nLev, ndId,
     &          m, listId, myTime, myIter, myThid )
         ENDIF
#endif

C--    end of Processing Fld # m
       ENDIF
      ENDDO

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#include "LONGSTEP_OPTIONS.h"
#ifdef ALLOW_GMREDI
# include "GMREDI_OPTIONS.h"
#endif

CBOP
C     !ROUTINE:
C     !INTERFACE: LONGSTEP_RESIDUAL_FLOW
      SUBROUTINE LONGSTEP_RESIDUAL_FLOW(
     U                  uFld, vFld, wFld,
     I                  bi, bj, myIter, myThid )
C     !DESCRIPTION:
C     Add GM-bolus velocity to Eulerian velocity to get Residual Mean velocity.

C     !USES:
      IMPLICIT NONE

C     == GLobal variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "LONGSTEP.h"
#ifdef ALLOW_GMREDI
# include "GMREDI.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     uFld   :: zonal      velocity (updated)
C     vFld   :: meridional velocity (updated)
C     wFld   :: vertical volume transport (updated)
C     bi,bj  :: tile indices
C     myIter :: my Iteration number
C     myThid :: my Thread Id number
      INTEGER bi, bj, myIter, myThid
      _RL uFld  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL vFld  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL wFld  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)

#ifdef ALLOW_GMREDI
C     !LOCAL VARIABLES:
C     == Local variables ==
C     i, j, k :: loop indices
      INTEGER i, j, k
      INTEGER kp1
      _RL maskp1, flipSign4LHCoord
      _RL delPsi
CEOP

C     Since bolus transport is computed as curl of stream-function, needs to
C     flip sign when using Left-Handed Coordinate system such as P-coordinate
      flipSign4LHCoord = -gravitySign

      IF ( GM_AdvForm .AND. .NOT.GM_AdvSeparate
     &     .AND. .NOT.GM_InMomAsStress ) THEN

       DO k=1,Nr
        kp1 = MIN(k+1,Nr)
        maskp1 = 1.
        IF (k.GE.Nr) maskp1 = 0.

        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
           delPsi = LS_PsiX(i,j,kp1,bi,bj)*deepFacF(kp1)*maskp1
     &            - LS_PsiX(i,j, k, bi,bj)*deepFacF(k)
           uFld(i,j,k) = uFld(i,j,k)
     &                 + delPsi*recip_drF(k)*_recip_hFacW(i,j,k,bi,bj)
     &                         *recip_deepFacC(k)*flipSign4LHCoord
         ENDDO
        ENDDO
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
           delPsi = LS_PsiY(i,j,kp1,bi,bj)*deepFacF(kp1)*maskp1
     &            - LS_PsiY(i,j, k, bi,bj)*deepFacF(k)
           vFld(i,j,k) = vFld(i,j,k)
     &                 + delPsi*recip_drF(k)*_recip_hFacS(i,j,k,bi,bj)
     &                         *recip_deepFacC(k)*flipSign4LHCoord
         ENDDO
        ENDDO
C       deep-model: simplify FacF / Fac2F (from dx,y / rA) to: 1/FacF
        DO j=1-OLy,sNy+OLy-1
         DO i=1-OLx,sNx+OLx-1
           delPsi = ( dyG(i+1,j,bi,bj)*LS_PsiX(i+1,j,k,bi,bj)
     &               -dyG( i ,j,bi,bj)*LS_PsiX( i ,j,k,bi,bj)
     &               +dxG(i,j+1,bi,bj)*LS_PsiY(i,j+1,k,bi,bj)
     &               -dxG(i, j ,bi,bj)*LS_PsiY(i, j ,k,bi,bj)
     &              )
           wFld(i,j,k) = wFld(i,j,k)
     &                 + delPsi*recip_rA(i,j,bi,bj)
     &                         *recip_deepFacF(k)*flipSign4LHCoord
         ENDDO
        ENDDO
       ENDDO

      ENDIF
#endif /* ALLOW_GMREDI */

      RETURN
      END

#include "GRIDALT_OPTIONS.h"

      subroutine dyn2phys(qdyn,pedyn,im1,im2,jm1,jm2,lmdyn,Nsx,Nsy,
     . idim1,idim2,jdim1,jdim2,bi,bj,windphy,pephy,Lbot,lmphy,nlperdyn,
     . flg,qphy)
C***********************************************************************
C Purpose:
C   To interpolate an arbitrary quantity from the 'dynamics' eta (pstar)
C               grid to the higher resolution physics grid
C Algorithm:
C   Routine works one layer (edge to edge pressure) at a time.
C   Dynamics -> Physics retains the dynamics layer mean value,
C   weights the field either with the profile of the physics grid
C   wind speed (for U and V fields), or uniformly (T and Q)
C
C Input:
C   qdyn..... [im,jm,lmdyn] Arbitrary Quantity on Input Grid
C   pedyn.... [im,jm,lmdyn+1] Pressures at bottom edges of input levels
C   im1,2 ... Limits for Longitude Dimension of Input
C   jm1,2 ... Limits for Latitude  Dimension of Input
C   lmdyn.... Vertical  Dimension of Input
C   Nsx...... Number of processes in x-direction
C   Nsy...... Number of processes in y-direction
C   idim1,2.. Beginning and ending i-values to calculate
C   jdim1,2.. Beginning and ending j-values to calculate
C   bi....... Index of process number in x-direction
C   bj....... Index of process number in x-direction
C   windphy.. [im,jm,lmphy] Magnitude of the wind on the output levels
C   pephy.... [im,jm,lmphy+1] Pressures at bottom edges of output levels
C   lmphy.... Vertical  Dimension of Output
C   nlperdyn. [im,jm,lmdyn] Highest Physics level in each dynamics level
C   flg...... Flag to indicate field type (0 for T or Q, 1 for U or V)
C
C Output:
C   qphy..... [im,jm,lmphy] Quantity at output grid (physics grid)
C
C Notes:
C   1) This algorithm assumes that the output (physics) grid levels
C      fit exactly into the input (dynamics) grid levels
C***********************************************************************
      implicit none

      integer  im1, im2, jm1, jm2, lmdyn, lmphy, Nsx, Nsy, flg
      integer idim1, idim2, jdim1, jdim2, bi, bj
      _RL qdyn(im1:im2,jm1:jm2,lmdyn,Nsx,Nsy)
      _RL pedyn(im1:im2,jm1:jm2,lmdyn+1,Nsx,Nsy)
      _RL pephy(im1:im2,jm1:jm2,lmphy+1,Nsx,Nsy)
      _RL windphy(im1:im2,jm1:jm2,lmphy,Nsx,Nsy)
      integer nlperdyn(im1:im2,jm1:jm2,lmdyn,Nsx,Nsy)
      _RL qphy(im1:im2,jm1:jm2,lmphy,Nsx,Nsy)
      integer Lbot(im1:im2,jm1:jm2,Nsx,Nsy)

      _RL weights(im1:im2,jm1:jm2,lmphy)
      _RL pphy(im1:im2,jm1:jm2,lmphy)
      _RL dpkedyn, dpkephy, windsum, qd
      integer  i,j,L,Lout1,Lout2,Lphy
cinterp1  _RL kappa
#ifdef ALLOW_FIZHI
cinterp1  _RL getcon
#else
cinterp1 #include 'SIZE.h'
cinterp1 #include 'EEPARAMS.h'
cinterp1 #include 'PARAMS.h'
#endif

#ifdef ALLOW_FIZHI
cinterp1  kappa = getcon('KAPPA')
#else
cinterp1  kappa = atm_kappa
#endif

C define physics grid mid level pressures
      do Lphy = 1,lmphy
       do j = jdim1,jdim2
        do i = idim1,idim2
         pphy(i,j,Lphy) =
     .       (pephy(i,j,Lphy,bi,bj)+pephy(i,j,Lphy+1,bi,bj))/2.
        enddo
       enddo
      enddo

c do loop for all dynamics (input) levels
      do L = 1,lmdyn
c do loop for all grid points
       do j = jdim1,jdim2
        do i = idim1,idim2
         qd = qdyn(i,j,L,bi,bj)
c Check to make sure we are above ground - if not, do nothing
         if(L.ge.Lbot(i,j,bi,bj))then
          if(L.eq.Lbot(i,j,bi,bj)) then
           Lout1 = 0
          else
           Lout1 = nlperdyn(i,j,L-1,bi,bj)
          endif
          Lout2 = nlperdyn(i,j,L,bi,bj)
c for U and V fields, need to compute for the weights:
cinterp1  dpkedyn = (pedyn(i,j,L,bi,bj)**kappa)-
cinterp1                                  (pedyn(i,j,L+1,bi,bj)**kappa)
          dpkedyn = pedyn(i,j,L,bi,bj)-pedyn(i,j,L+1,bi,bj)
          if(flg.eq.1)then
           windsum = 0.
           do Lphy = Lout1+1,Lout2
cinterp1    dpkephy = (pephy(i,j,Lphy,bi,bj)**kappa)-
cinterp1                                (pephy(i,j,Lphy+1,bi,bj)**kappa)
            dpkephy = pephy(i,j,Lphy,bi,bj)-pephy(i,j,Lphy+1,bi,bj)
            windsum = windsum+(windphy(i,j,Lphy,bi,bj)*dpkephy)/dpkedyn
           enddo
          endif
c do loop for all physics levels contained in this dynamics level
          do Lphy = Lout1+1,Lout2
           weights(i,j,Lphy) = 1.
           if( (flg.eq.1).and.(windsum.ne.0.) )
     .                weights(i,j,Lphy)=windphy(i,j,Lphy,bi,bj)/windsum
           if( (flg.eq.2) .and. (pedyn(i,j,L,bi,bj).lt.10000.)) then
            weights(i,j,Lphy) =
     .   (qd-5. + (10.*(pedyn(i,j,L,bi,bj)-pphy(i,j,Lphy))/dpkedyn))/qd
           elseif( (flg.eq.2) .and. (pedyn(i,j,L,bi,bj).ge.10000.)) then
            weights(i,j,Lphy) = 1.
           endif
           qphy(i,j,Lphy,bi,bj) = qd * weights(i,j,Lphy)
          enddo
         endif
        enddo
       enddo
      enddo

      return
      end

#include "PACKAGES_CONFIG.h"
#include "CPP_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: SET_DEFAULTS
C     !INTERFACE:
      SUBROUTINE SET_DEFAULTS(
     O   viscArDefault, diffKrTDefault, diffKrSDefault,
     O   hFacMinDrDefault, delRdefault,
     I   myThid )

C     !DESCRIPTION:
C     Routine to set model "parameter defaults".

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#ifdef ALLOW_EXCH2
# include "W2_EXCH2_SIZE.h"
#endif /* ALLOW_EXCH2 */
#include "SET_GRID.h"

C     !INPUT/OUTPUT PARAMETERS:
C     myThid :: my Thread Id. Number
      INTEGER myThid
      _RL viscArDefault
      _RL diffKrTDefault
      _RL diffKrSDefault
      _RL hFacMinDrDefault
      _RL delRDefault(Nr)

C     !LOCAL VARIABLES:
C     i, j, k :: Loop counters
      INTEGER i, j, k
CEOP

C--   Grid parameters
C-    Vertical gridding
      delRFile            = ' '
      delRcFile           = ' '
      hybSigmFile         = ' '
      seaLev_Z            = UNSET_RL
      top_Pres            = UNSET_RL
      rSigmaBnd           = UNSET_RL
      selectSigmaCoord    = 0
      DO k=1,Nr
       delRdefault(k)     = 0.
      ENDDO
      DO k=1,Nr+1
       delRc(k)           = UNSET_RL
      ENDDO
      useMin4hFacEdges    = .FALSE.
C-    vertical profile
      tRefFile            = ' '
      sRefFile            = ' '
      rhoRefFile          = ' '
      gravityFile         = ' '
      thetaConst          = UNSET_RL
      DO k=1,Nr
       tRef(k)            = UNSET_RL
       sRef(k)            = UNSET_RL
      ENDDO

C-    Horizontal gridding
      delXFile            = ' '
      delYFile            = ' '
      horizGridFile       = ' '
      deepAtmosphere      = .FALSE.
      xgOrigin            = UNSET_RL
      ygOrigin            = UNSET_RL
      DO i=1,grid_maxNx
       delX(i)            = UNSET_RL
      ENDDO
      DO j=1,grid_maxNy
       delY(j)            = UNSET_RL
      ENDDO
C     In cartesian coords distances are in metres
      usingCartesianGrid  = .FALSE.
C     In spherical polar distances are in degrees
      usingSphericalPolarGrid = .FALSE.
      rSphere             = UNSET_RL
C     General curvilinear coordinate system
      usingCurvilinearGrid= .FALSE.
      radius_fromHorizGrid= UNSET_RL
      hasWetCSCorners     = .FALSE.
C     General cylindrical coordinate system
      usingCylindricalGrid= .FALSE.
C     Coriolis map:
      selectCoriMap       = -1
C     grid rotation
      rotateGrid          = .FALSE.
      phiEuler            = 0. _d 0
      thetaEuler          = 0. _d 0
      psiEuler            = 0. _d 0

C--   Set default "physical" parameters
      nh_Am2              = 1. _d 0
      gravity             = 9.81 _d 0
      gBaro               = UNSET_RL
      surf_pRef           = 101325. _d 0
      rhoNil              = 999.8 _d 0
      rhoConst            = UNSET_RL
C-- jmc : the default is to set rhoConstFresh to rhoConst (=rhoNil by default)
C         (so that the default produces same results as before)
c     rhoConstFresh       = 999.8 _d 0
      rhoConstFresh       = UNSET_RL
      convertFW2Salt      = UNSET_RL
      f0                  = 1. _d -4
      beta                = 1. _d -11
      fPrime              = 0. _d 0
C-    Earth rotation period is 86400*365.25/366.25 (use to be 1.day)
      rotationPeriod      = 86164. _d 0
      omega               = UNSET_RL
C-    viscosity and diffusivity default value:
      viscAh              = 0. _d 3
      smag3D_coeff        = 1. _d -2
      smag3D_diffCoeff    = 0. _d 0
      viscAhGrid          = 0. _d 0
      viscAhGridMin       = 0. _d 0
      viscAhGridMax       = 1. _d 21
      viscAhMax           = 1. _d 21
      viscAhReMax         = 0. _d 0
      viscC2leith         = 0. _d 0
      viscC2leithD        = 0. _d 0
      viscC2LeithQG       = 0. _d 0
      viscC2smag          = 0. _d 0
      viscArDefault       = 0. _d -3
      viscFacAdj          = 1. _d 0
      no_slip_sides       = .TRUE.
      no_slip_bottom      = .TRUE.
      bottomVisc_pCell    = .FALSE.
      sideDragFactor      = 2. _d 0
      bottomDragLinear    = 0.
      bottomDragQuadratic = 0.
      zRoughBot           = 0. _d 0
      selectBotDragQuadr  = -1
      viscA4              = 0. _d 11
      viscA4Grid          = 0. _d 0
      viscA4GridMax       = 1. _d 21
      viscA4GridMin       = 0. _d 0
      viscA4Max           = 1. _d 21
      viscA4ReMax         = 0. _d 0
      viscC4leith         = 0. _d 0
      viscC4leithD        = 0. _d 0
      viscC4smag          = 0. _d 0
      DO k=1,Nr
       viscArNr(k)        = UNSET_RL
      ENDDO
      cosPower            = 0.
      diffKhT             = 0. _d 3
      diffKhS             = 0. _d 3
      diffK4T             = 0. _d 11
      diffK4S             = 0. _d 11
      diffKrTDefault      = 0. _d -3
      diffKrSDefault      = 0. _d -3
      diffKrBL79surf      = 0. _d 0
      diffKrBL79deep      = 0. _d 0
      diffKrBL79scl       = 200. _d 0
      diffKrBL79Ho        = -2000. _d 0
      BL79LatVary         = 30.
      diffKrBLEQsurf      = UNSET_RL
      diffKrBLEQdeep      = UNSET_RL
      diffKrBLEQscl       = UNSET_RL
      diffKrBLEQHo        = UNSET_RL
      DO k=1,Nr
       diffKrNrT(k)       = UNSET_RL
       diffKrNrS(k)       = UNSET_RL
       diffKr4T(k)        = 0.
       diffKr4S(k)        = 0.
      ENDDO
      HeatCapacity_Cp     = 3994. _d 0
      eosType             = 'LINEAR'
      buoyancyRelation    = 'OCEANIC'
      selectP_inEOS_Zc    = UNSET_I
      smoothAbsFuncRange  = 0. _d 0
      sIceLoadFac         = 1. _d 0
      hFacMin             = 1. _d 0
      hFacMinDrDefault    = 0. _d 0
      implicitIntGravWave = .FALSE.
      staggerTimeStep     = .FALSE.
      applyExchUV_early   = .FALSE.
      doResetHFactors     = .FALSE.
      momViscosity        = .TRUE.
      momAdvection        = .TRUE.
      momForcing          = .TRUE.
      momTidalForcing     = .TRUE.
      useCoriolis         = .TRUE.
      momPressureForcing  = .TRUE.
      momStepping         = .TRUE.
      vectorInvariantMomentum = .FALSE.
      tempStepping        = .TRUE.
      tempAdvection       = .TRUE.
      tempForcing         = .TRUE.
      temp_stayPositive   = .FALSE.
      saltStepping        = .TRUE.
      saltAdvection       = .TRUE.
      saltForcing         = .TRUE.
      salt_stayPositive   = .FALSE.
      addFrictionHeating  = .FALSE.
      useNHMTerms         = .FALSE.
      selectMetricTerms   = UNSET_I
      useSmag3D           = .FALSE.
      useFullLeith        = .FALSE.
      useAreaViscLength   = .FALSE.
      useStrainTensionVisc= .FALSE.
      implicitDiffusion   = .FALSE.
      implicitViscosity   = .FALSE.
      selectImplicitDrag  = 0
      momImplVertAdv      = .FALSE.
      tempImplVertAdv     = .FALSE.
      saltImplVertAdv     = .FALSE.
      nonHydrostatic      = .FALSE.
      quasiHydrostatic    = .FALSE.
      globalFiles         = .FALSE.
      useSingleCpuIO      = .FALSE.
      useSingleCpuInput   = .FALSE.
      allowFreezing       = .FALSE.
      ivdc_kappa          = 0. _d 0
      hMixCriteria        = -.8 _d 0
      dRhoSmall           = 1. _d -6
      hMixSmooth          = 0. _d 0
      usePickupBeforeC54    = .FALSE.
      tempAdvScheme       = 2
      saltAdvScheme       = 2
      multiDimAdvection   = .TRUE.
      useMultiDimAdvec    = .FALSE.
      useCDscheme         = .FALSE.
      select3dCoriScheme  = UNSET_I
      selectCoriScheme    = UNSET_I
      selectVortScheme    = UNSET_I
      useJamartMomAdv     = .FALSE.
      upwindVorticity     = .FALSE.
      highOrderVorticity  = .FALSE.
      useAbsVorticity     = .FALSE.
      upwindShear         = .FALSE.
      selectKEscheme      = 0
      IF ( debugMode ) THEN
        debugLevel        = debLevD
      ELSE
        debugLevel        = debLevB
#ifdef ALLOW_AUTODIFF
        debugLevel        = debLevA
#endif
      ENDIF

C--   Set (free)surface-related parameters
      implicitFreeSurface = .FALSE.
      rigidLid            = .FALSE.
      implicSurfPress     = 1. _d 0
      implicDiv2DFlow     = 1. _d 0
      exactConserv        = .FALSE.
      linFSConserveTr     = .FALSE.
      uniformLin_PhiSurf  = .TRUE.
      nonlinFreeSurf      = 0
      hFacInf             = 0.2 _d 0
      hFacSup             = 2.0 _d 0
      select_rStar        = 0
      selectNHfreeSurf    = 0
      selectAddFluid      = 0
      useRealFreshWaterFlux = .FALSE.
      temp_EvPrRn = UNSET_RL
      salt_EvPrRn = 0.
      temp_addMass = UNSET_RL
      salt_addMass = UNSET_RL
      selectPenetratingSW = UNSET_I
      selectBalanceEmPmR  = UNSET_I
      balanceQnet         = .FALSE.
      balancePrintMean    = .FALSE.
      balanceThetaClimRelax = .FALSE.
      balanceSaltClimRelax  = .FALSE.

C--   Atmospheric physical parameters (e.g.: EOS)
      celsius2K = 273.15 _d 0
      atm_Po =  1. _d 5
      atm_Cp = 1004. _d 0
      atm_Rd = UNSET_RL
      atm_kappa = 2. _d 0 / 7. _d 0
      atm_Rq = 0. _d 0
      integr_GeoPot = 2
      selectFindRoSurf = 0

C--   Elliptic solver parameters
      cg2dMaxIters       = 150
      cg2dMinItersNSA    = 0
      cg2dTargetResidual = 1. _d -7
      cg2dTargetResWunit = -1.
      cg2dUseMinResSol   = UNSET_I
      cg2dpcOffDFac      = 0.51 _d 0
      cg2dPreCondFreq    = 1
      cg3dMaxIters       = 150
      cg3dTargetResidual = 1. _d -7
      cg3dTargetResWunit = -1.
      useNSACGSolver     = .FALSE.
      useSRCGSolver      = .FALSE.

C--   Time stepping parameters
      deltaT            = 0. _d 0
      deltaTMom         = 0. _d 0
      deltaTFreeSurf    = 0. _d 0
      DO k=1,Nr
        dTtracerLev(k)  = 0. _d 0
      ENDDO
      baseTime          = 0. _d 0
      nIter0            = -1
      startTime         = UNSET_RL
      nTimeSteps        = 0
      nTimeSteps_l2     = 0
      nEndIter          = 0
      endTime           = 0. _d 0
      momForcingOutAB   = UNSET_I
      tracForcingOutAB  = UNSET_I
      momDissip_In_AB   = .TRUE.
      doAB_onGtGs       = .TRUE.
      abEps             = 0.01 _d 0
#ifdef ALLOW_ADAMSBASHFORTH_3
      alph_AB           = 0.5 _d 0
      beta_AB           = 5. _d 0 / 12. _d 0
      startFromPickupAB2= .FALSE.
#else
      alph_AB           = UNSET_RL
      beta_AB           = UNSET_RL
      startFromPickupAB2= .TRUE.
#endif
      cAdjFreq          =  0. _d 0
      tauCD             =  0. _d 0
      tauThetaClimRelax =  0. _d 0
      tauSaltClimRelax  =  0. _d 0
      periodicExternalForcing = .FALSE.
      externForcingPeriod     = 0.
      externForcingCycle      = 0.
      tCylIn            = 0.
      tCylOut           = 20.
C-    I/O params:
      pickupSuff        = ' '
      pickupStrictlyMatch = .TRUE.
      pChkPtFreq        = deltaT*0
      chkPtFreq         = deltaT*0
      outputTypesInclusive = .FALSE.
      pickup_read_mdsio = .TRUE.
      pickup_write_mdsio= .TRUE.
      pickup_write_immed= .FALSE.
      writePickupAtEnd  = .TRUE.
      dumpFreq          = deltaT*0
      adjDumpFreq       = deltaT*0
      diagFreq          = deltaT*0
      dumpInitAndLast   = .TRUE.
      snapshot_mdsio    = .TRUE.
      monitorFreq       = -1.
      adjMonitorFreq    = 0.
      monitorSelect     = UNSET_I
      monitor_stdio     = .TRUE.
      readBinaryPrec    = precFloat32
      writeBinaryPrec   = precFloat32
      rwSuffixType      = 0

C--   Input files
      bathyFile       = ' '
      topoFile        = ' '
      addWwallFile    = ' '
      addSwallFile    = ' '
      hydrogSaltFile  = ' '
      hydrogThetaFile = ' '
      maskIniTemp     = .TRUE.
      maskIniSalt     = .TRUE.
      checkIniTemp    = .TRUE.
      checkIniSalt    = .TRUE.
      diffKrFile      = ' '
      viscAhDfile     = ' '
      viscAhZfile     = ' '
      viscA4Dfile     = ' '
      viscA4Zfile     = ' '
      zonalWindFile   = ' '
      meridWindFile   = ' '
      thetaClimFile   = ' '
      saltClimFile    = ' '
      EmPmRfile       = ' '
      saltFluxFile    = ' '
      surfQfile       = ' '
      surfQnetFile    = ' '
      surfQswFile     = ' '
      uVelInitFile    = ' '
      vVelInitFile    = ' '
      pSurfInitFile   = ' '
      pLoadFile       = ' '
      geoPotAnomFile  = ' '
      addMassFile     = ' '
      eddyPsiXFile    = ' '
      eddyPsiYFile    = ' '
      geothermalFile  = ' '
      lambdaThetaFile = ' '
      lambdaSaltFile  = ' '
      wghtBalanceFile = ' '
      mdsioLocalDir   = ' '
      adTapeDir       = ' '
      the_run_name    = ' '

      RETURN
      END

#include "SMOOTH_OPTIONS.h"

      SUBROUTINE SMOOTH_FILTERVAR3D( smoothOpNb, myThid )

C     *==========================================================*
C     | SUBROUTINE smooth_filtervar3D
C     | o Routine that computes the filter variance
C     |   field associated with a diffusion operator, as part
C     |   a 3D spatial correlation operator (smooth_correld3D.F)
C     |   See Weaver and Courtier 01 for details.
C     *==========================================================*

      IMPLICIT NONE
c     == global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "SMOOTH.h"

      INTEGER smoothOpNb, myThid

c     == external functions ==
      REAL*8   port_rand, port_rand_norm
      EXTERNAL PORT_RAND, PORT_RAND_NORM

c     == local variables ==
      INTEGER i,j,k, bi, bj, ii, jj, kk
      INTEGER diLoc, djLoc,  dkLoc
      INTEGER nbRand, nbt_in
      CHARACTER*(MAX_LEN_FNAM) fnamegeneric
      _RL smoothTmpFld (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      _RL smoothTmpMean(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      _RL smoothTmpVar (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      _RS smooth3Dmask (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)

      INTEGER IL

c     == functions ==
      INTEGER  ILNBLNK
      EXTERNAL ILNBLNK

c     == end of interface ==

      IL = ILNBLNK( smoothDir )

c--   allow a mask other than maskC
      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        DO k = 1,Nr
         DO j = 1-OLy,sNy+OLy
          DO i = 1-OLx,sNx+OLx
           IF (smooth3DmaskName(smoothOpNb)(1:5).EQ.'maskC') THEN
            smooth3Dmask(i,j,k,bi,bj) = maskC(i,j,k,bi,bj)
           ELSEIF (smooth3DmaskName(smoothOpNb)(1:5).EQ.'maskW') THEN
            smooth3Dmask(i,j,k,bi,bj) = maskW(i,j,k,bi,bj)
           ELSEIF (smooth3DmaskName(smoothOpNb)(1:5).EQ.'maskS') THEN
            smooth3Dmask(i,j,k,bi,bj) = maskS(i,j,k,bi,bj)
           ENDIF
          ENDDO
         ENDDO
        ENDDO
       ENDDO
      ENDDO

c if smooth3Dfilter(smoothOpNb)=0: the filter variance field
c has been computed earlier and is already in the run directory
c so this routine does not do anything

      IF (smooth3Dfilter(smoothOpNb).NE.0) THEN

       nbt_in = smooth3Dnbt(smoothOpNb)/2

c read smoothing [i.e diffusion] operator:
       WRITE(fnamegeneric,'(2A,I3.3)')
     &       smoothDir(1:IL),
     &       'smooth3Doperator', smoothOpNb
       CALL READ_REC_3D_RL( fnamegeneric, smoothprec, Nr, smooth3D_Kwx,
     &                      1, 1, myThid )
       CALL READ_REC_3D_RL( fnamegeneric, smoothprec, Nr, smooth3D_Kwy,
     &                      2, 1, myThid )
       CALL READ_REC_3D_RL( fnamegeneric, smoothprec, Nr, smooth3D_Kwz,
     &                      3, 1, myThid )
       CALL READ_REC_3D_RL( fnamegeneric, smoothprec, Nr, smooth3D_Kux,
     &                      4, 1, myThid )
       CALL READ_REC_3D_RL( fnamegeneric, smoothprec, Nr, smooth3D_Kvy,
     &                      5, 1, myThid )
       CALL READ_REC_3D_RL( fnamegeneric, smoothprec, Nr, smooth3D_Kuz,
     &                      6, 1, myThid )
       CALL READ_REC_3D_RL( fnamegeneric, smoothprec, Nr, smooth3D_Kvz,
     &                      7, 1, myThid )
       CALL READ_REC_3D_RL( fnamegeneric, smoothprec, Nr, smooth3D_Kuy,
     &                      8, 1, myThid )
       CALL READ_REC_3D_RL( fnamegeneric, smoothprec, Nr, smooth3D_Kvx,
     &                      9, 1, myThid )
       CALL READ_REC_3D_RL( fnamegeneric, smoothprec, Nr,
     &                      smooth3D_kappaR, 10, 1, myThid )
       CALL EXCH_XYZ_RL( smooth3D_Kwx, myThid )
       CALL EXCH_XYZ_RL( smooth3D_Kwy, myThid )
       CALL EXCH_XYZ_RL( smooth3D_Kwz, myThid )
       CALL EXCH_XYZ_RL( smooth3D_Kux, myThid )
       CALL EXCH_XYZ_RL( smooth3D_Kvy, myThid )
       CALL EXCH_XYZ_RL( smooth3D_Kuz, myThid )
       CALL EXCH_XYZ_RL( smooth3D_Kvz, myThid )
       CALL EXCH_XYZ_RL( smooth3D_Kuy, myThid )
       CALL EXCH_XYZ_RL( smooth3D_Kvx, myThid )
       CALL EXCH_XYZ_RL( smooth3D_kappaR, myThid )

c initialize filter variance field:
       DO bj=myByLo(myThid),myByHi(myThid)
        DO bi=myBxLo(myThid),myBxHi(myThid)
         DO k=1,Nr
          DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
            smooth3Dnorm(i,j,k,bi,bj) = 0.
           ENDDO
          ENDDO
         ENDDO
        ENDDO
       ENDDO

       IF (smooth3Dfilter(smoothOpNb).EQ.2) THEN
c compute the normalization matrix using the approximate method
c
c This method can be quite expensive -- so that the approximate
c method (see below) is usually the prefered one.
c The exact method can be used to check the accuracy
c of the approximate method results (that can be predicted).
c
c note: the exact method requires the adjoint of smooth_diff2D.F (see below)

        diLoc = 15 !int(5*smooth_L/smooth_dx)
        djLoc = 20 !int(5*smooth_L/smooth_dx)
        dkLoc = 8

        DO kk=1,dkLoc
         DO ii=1,diLoc,2
          DO jj=1,djLoc,2

           DO bj=myByLo(myThid),myByHi(myThid)
            DO bi=myBxLo(myThid),myBxHi(myThid)
             DO k=1,Nr
              DO j=1-OLy,sNy+OLy
               DO i=1-OLx,sNx+OLx
                smoothTmpFld(i,j,k,bi,bj) = 0.
               ENDDO
              ENDDO
             ENDDO
             DO k=kk,Nr,dkLoc
              DO j=jj,sNy,djLoc
               DO i=ii,sNx,diLoc
                smoothTmpFld(i,j,k,bi,bj) = 1.
               ENDDO
              ENDDO
             ENDDO
            ENDDO
           ENDDO

c note: as we go to adjoint part, we need to have 0 in overlaps
c       so we must NOT have done an exchange for smoothTmpFld

c adjoint:
           WRITE(errorMessageUnit,'(A,/,A)' )
     &      'you need to have adsmooth_diff3D compiled and then:',
     &      'uncomment the line below and comment the STOP'
           CALL ALL_PROC_DIE( myThid )
           STOP 'ABNORMAL END: S/R smooth_filtervar3D'
c          CALL adsmooth_diff3D( smoothTmpFld, nbt_in, myThid )

c division by sqrt(volume)*sqrt(volume) [1 to end adj, 1 to begin fwd]
           DO bj=myByLo(myThid),myByHi(myThid)
            DO bi=myBxLo(myThid),myBxHi(myThid)
             DO k=1,Nr
              DO j=1,sNy
               DO i=1,sNx
c division by ~sqrt(volume):
                smoothTmpFld(i,j,k,bi,bj) = smoothTmpFld(i,j,k,bi,bj)
     &                     *(recip_rA(i,j,bi,bj)*recip_drF(k))
               ENDDO
              ENDDO
             ENDDO
            ENDDO
           ENDDO

c coming out of adjoint part: overlaps are 0
c going in fwd part: we need to fill them up
           CALL EXCH_XYZ_RL( smoothTmpFld , myThid )

c fwd:
           CALL SMOOTH_DIFF3D( smoothTmpFld, nbt_in, myThid )

c convert variance to normalization factor:
           DO bj=myByLo(myThid),myByHi(myThid)
            DO bi=myBxLo(myThid),myBxHi(myThid)
             DO k=1,Nr,dkLoc
              DO j=jj,sNy,djLoc
               DO i=ii,sNx,diLoc
                IF (smoothTmpFld(i,j,k,bi,bj).NE.0.) THEN
                 smooth3Dnorm(i,j,k,bi,bj) =
     &                    1/SQRT(smoothTmpFld(i,j,k,bi,bj))
                ENDIF
               ENDDO
              ENDDO
             ENDDO
            ENDDO
           ENDDO

          ENDDO      !DO ii=1,diLoc
         ENDDO      !DO jj=1,djLoc
        ENDDO      !DO kk=1,dkLoc

       ELSEIF (smooth3Dfilter(smoothOpNb).EQ.1) THEN
c compute the normalization matrix using the approximate method

        DO bj=myByLo(myThid),myByHi(myThid)
         DO bi=myBxLo(myThid),myBxHi(myThid)
          DO k=1,Nr
           DO j=1-OLy,sNy+OLy
            DO i=1-OLx,sNx+OLx
             smoothTmpMean(i,j,k,bi,bj) = 0. _d 0
             smoothTmpVar(i,j,k,bi,bj)  = 0. _d 0
            ENDDO
           ENDDO
          ENDDO
         ENDDO
        ENDDO

c initialize random number generator
        smoothTmpFld(1,1,1,1,1) = port_rand(1.d0)
        nbRand = 1000

        DO ii=1,nbRand
         WRITE(standardMessageUnit,'(A,I4,A,I4)')
     &   'smooth_filtervar3D: ', ii, ' members done out of ', nbRand

c fill smoothTmpFld with random numbers:
         DO bj=myByLo(myThid),myByHi(myThid)
          DO bi=myBxLo(myThid),myBxHi(myThid)
           DO k=1,Nr
            DO j=1-OLy,sNy+OLy
             DO i=1-OLx,sNx+OLx
              smoothTmpFld(i,j,k,bi,bj) = 0. _d 0
              IF (smooth3dmask(i,j,k,bi,bj).NE.0) THEN
               smoothTmpFld(i,j,k,bi,bj)=port_rand_norm()
              ENDIF
c division by sqrt(volume):
              smoothTmpFld(i,j,k,bi,bj) = smoothTmpFld(i,j,k,bi,bj)
     &                    *SQRT(recip_rA(i,j,bi,bj)*recip_drF(k))
             ENDDO
            ENDDO
           ENDDO
          ENDDO
         ENDDO

         CALL EXCH_XYZ_RL( smoothTmpFld, myThid )

c smooth random number field
         CALL SMOOTH_DIFF3D( smoothTmpFld, nbt_in, myThid )

c accumulate statistics (to compute the variance later)
         DO bj=myByLo(myThid),myByHi(myThid)
          DO bi=myBxLo(myThid),myBxHi(myThid)
           DO k=1,Nr
            DO j=1-OLy,sNy+OLy
             DO i=1-OLx,sNx+OLx
              smoothTmpVar(i,j,k,bi,bj) = smoothTmpVar(i,j,k,bi,bj)
     &         + smoothTmpFld(i,j,k,bi,bj)
     &          *smoothTmpFld(i,j,k,bi,bj)/nbRand
              smoothTmpMean(i,j,k,bi,bj) = smoothTmpMean(i,j,k,bi,bj)
     &         + smoothTmpFld(i,j,k,bi,bj)/nbRand
             ENDDO
            ENDDO
           ENDDO
          ENDDO
         ENDDO

C-      ii loop end
        ENDDO

c compute variance and convert it to normalization factor:
        DO bj=myByLo(myThid),myByHi(myThid)
         DO bi=myBxLo(myThid),myBxHi(myThid)
          DO k=1,Nr
           DO j=1-OLy,sNy+OLy
            DO i=1-OLx,sNx+OLx
             IF (smooth3dmask(i,j,k,bi,bj).NE.0) THEN
              smooth3Dnorm(i,j,k,bi,bj) = 1/SQRT(
     &           nbRand/(nbRand-1)
     &          *( smoothTmpVar(i,j,k,bi,bj)
     &           - smoothTmpMean(i,j,k,bi,bj)*smoothTmpMean(i,j,k,bi,bj)
     &           )                              )
             ENDIF
            ENDDO
           ENDDO
          ENDDO
         ENDDO
        ENDDO

C      end smooth3Dfilter() if block
       ENDIF

c write smooth3Dnorm_3D to file:
       WRITE(fnamegeneric,'(2A,I3.3)')
     &       smoothDir(1:IL),
     &       'smooth3Dnorm', smoothOpNb
       CALL WRITE_REC_3D_RL( fnamegeneric, smoothprec,
     &                       Nr, smooth3Dnorm, 1, 1, myThid )
       CALL EXCH_XYZ_RL( smooth3Dnorm,  myThid )

C     end smooth3Dfilter() <> 0 if block
      ENDIF

      RETURN
      END

#include "SEAICE_OPTIONS.h"

C--   File seaice_fgmres.F: seaice fgmres dynamical (linear) solver S/R:
C--   Contents
C--   o SEAICE_MAP2VEC
C--   o SEAICE_MAP_RS2VEC
C--   o SEAICE_FGMRES
C--   o SEAICE_SCALPROD

CBOP
C     !ROUTINE: SEAICE_MAP2VEC
C     !INTERFACE:

      SUBROUTINE SEAICE_MAP2VEC(
     I     n,
     O     xfld2d, yfld2d,
     U     vector,
     I     map2vec, myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE SEAICE_MAP2VEC
C     | o maps 2 2D-fields to vector and back
C     *==========================================================*
C     | written by Martin Losch, Oct 2012
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
C     === Routine arguments ===
      INTEGER n
      LOGICAL map2vec
      INTEGER myThid
      _RL xfld2d (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL yfld2d (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL vector (n,nSx,nSy)
#if (defined SEAICE_ALLOW_JFNK) || (defined SEAICE_ALLOW_KRYLOV)
C     === local variables ===
      INTEGER I, J, bi, bj
      INTEGER ii, jj, m
CEOP

      m = n/2
      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
#ifdef SEAICE_JFNK_MAP_REORDER
        ii = 0
        IF ( map2vec ) THEN
         DO J=1,sNy
          jj = 2*sNx*(J-1)
          DO I=1,sNx
           ii = jj + 2*I
           vector(ii-1,bi,bj) = xfld2d(I,J,bi,bj)
           vector(ii,  bi,bj) = yfld2d(I,J,bi,bj)
          ENDDO
         ENDDO
        ELSE
         DO J=1,sNy
          jj = 2*sNx*(J-1)
          DO I=1,sNx
           ii = jj + 2*I
           xfld2d(I,J,bi,bj) = vector(ii-1,bi,bj)
           yfld2d(I,J,bi,bj) = vector(ii,  bi,bj)
          ENDDO
         ENDDO
        ENDIF
#else
        IF ( map2vec ) THEN
         DO J=1,sNy
          jj = sNx*(J-1)
          DO I=1,sNx
           ii = jj + I
           vector(ii,  bi,bj) = xfld2d(I,J,bi,bj)
           vector(ii+m,bi,bj) = yfld2d(I,J,bi,bj)
          ENDDO
         ENDDO
        ELSE
         DO J=1,sNy
          jj = sNx*(J-1)
          DO I=1,sNx
           ii = jj + I
           xfld2d(I,J,bi,bj) = vector(ii,  bi,bj)
           yfld2d(I,J,bi,bj) = vector(ii+m,bi,bj)
          ENDDO
         ENDDO
        ENDIF
#endif /* SEAICE_JFNK_MAP_REORDER */
C     bi,bj-loops
       ENDDO
      ENDDO

#endif /* SEAICE_ALLOW_JFNK or SEAICE_ALLOW_KRYLOV */
      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: SEAICE_MAP_RS2VEC
C     !INTERFACE:

      SUBROUTINE SEAICE_MAP_RS2VEC(
     I     n,
     O     xfld2d, yfld2d,
     U     vector,
     I     map2vec, myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE SEAICE_MAP_RS2VEC
C     | o maps 2 2D-RS-fields to vector and back
C     *==========================================================*
C     | written by Martin Losch, Oct 2012
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
C     === Routine arguments ===
      INTEGER n
      LOGICAL map2vec
      INTEGER myThid
      _RS xfld2d (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RS yfld2d (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL vector (n,nSx,nSy)
#if (defined SEAICE_ALLOW_JFNK) || (defined SEAICE_ALLOW_KRYLOV)
C     === local variables ===
      INTEGER I, J, bi, bj
      INTEGER ii, jj, m
CEOP

      m = n/2
      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
#ifdef SEAICE_JFNK_MAP_REORDER
        ii = 0
        IF ( map2vec ) THEN
         DO J=1,sNy
          jj = 2*sNx*(J-1)
          DO I=1,sNx
           ii = jj + 2*I
           vector(ii-1,bi,bj) = xfld2d(I,J,bi,bj)
           vector(ii,  bi,bj) = yfld2d(I,J,bi,bj)
          ENDDO
         ENDDO
        ELSE
         DO J=1,sNy
          jj = 2*sNx*(J-1)
          DO I=1,sNx
           ii = jj + 2*I
           xfld2d(I,J,bi,bj) = vector(ii-1,bi,bj)
           yfld2d(I,J,bi,bj) = vector(ii,  bi,bj)
          ENDDO
         ENDDO
        ENDIF
#else
        IF ( map2vec ) THEN
         DO J=1,sNy
          jj = sNx*(J-1)
          DO I=1,sNx
           ii = jj + I
           vector(ii,  bi,bj) = xfld2d(I,J,bi,bj)
           vector(ii+m,bi,bj) = yfld2d(I,J,bi,bj)
          ENDDO
         ENDDO
        ELSE
         DO J=1,sNy
          jj = sNx*(J-1)
          DO I=1,sNx
           ii = jj + I
           xfld2d(I,J,bi,bj) = vector(ii,  bi,bj)
           yfld2d(I,J,bi,bj) = vector(ii+m,bi,bj)
          ENDDO
         ENDDO
        ENDIF
#endif /* SEAICE_JFNK_MAP_REORDER */
C     bi,bj-loops
       ENDDO
      ENDDO

#endif /* SEAICE_ALLOW_JFNK or SEAICE_ALLOW_KRYLOV */
      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: SEAICE_FGMRES
C     !INTERFACE:
      SUBROUTINE SEAICE_FGMRES (
     I     n,im,rhs,
     U     sol,i,its,vv,w,wk1,wk2,
     I     eps,maxits,iout,
     U     icode,
     I     myThid )

C-----------------------------------------------------------------------
C mlosch Oct 2012: modified the routine further to be compliant with
C MITgcm standards:
C f90 -> F
C !-comment -> C-comment
C add its to list of arguments
C double precision -> _RL
C implicit none
C
C jfl Dec 1st 2006. We modified the routine so that it is double precison.
C Here are the modifications:
C 1) implicit real (a-h,o-z) becomes implicit real*8 (a-h,o-z)
C 2) real bocomes real*8
C 3) subroutine scopy.f has been changed for dcopy.f
C 4) subroutine saxpy.f has been changed for daxpy.f
C 5) function sdot.f has been changed for ddot.f
C 6) 1e-08 becomes 1d-08
C
C Be careful with the dcopy, daxpy and ddot code...there is a slight
C difference with the single precision versions (scopy, saxpy and sdot).
C In the single precision versions, the array are declared sightly differently.
C It is written for single precision:
C
C modified 12/3/93, array(1) declarations changed to array(*)
C-----------------------------------------------------------------------

      implicit none
C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
      integer myThid
      integer i, n, im, its, maxits, iout, icode
      _RL rhs(n,nSx,nSy), sol(n,nSx,nSy)
      _RL vv(n,im+1,nSx,nSy), w(n,im,nSx,nSy)
      _RL wk1(n,nSx,nSy), wk2(n,nSx,nSy), eps
C-----------------------------------------------------------------------
C flexible GMRES routine. This is a version of GMRES which allows a
C a variable preconditioner. Implemented with a reverse communication
C protocole for flexibility -
C DISTRIBUTED VERSION (USES DISTDOT FOR DDOT)
C explicit (exact) residual norms for restarts
C written by Y. Saad, modified by A. Malevsky, version February 1, 1995
C-----------------------------------------------------------------------
C This Is A Reverse Communication Implementation.
C-------------------------------------------------
C USAGE: (see also comments for icode below). FGMRES
C should be put in a loop and the loop should be active for as
C long as icode is not equal to 0. On return fgmres will
C    1) either be requesting the new preconditioned vector applied
C       to wk1 in case icode.eq.1 (result should be put in wk2)
C    2) or be requesting the product of A applied to the vector wk1
C       in case icode.eq.2 (result should be put in wk2)
C    3) or be terminated in case icode .eq. 0.
C on entry always set icode = 0. So icode should be set back to zero
C upon convergence.
C-----------------------------------------------------------------------
C Here is a typical way of running fgmres:
C
C      icode = 0
C 1    continue
C      call fgmres (n,im,rhs,sol,i,vv,w,wk1,wk2,eps,maxits,iout,
C     &             icode,its,mythid)
C
C      if (icode .eq. 1) then
C         call  precon(n, wk1, wk2)    <--- user variable preconditioning
C         goto 1
C      else if (icode .ge. 2) then
C         call  matvec (n,wk1, wk2)    <--- user matrix vector product.
C         goto 1
C      else
C         ----- done ----
C         .........
C-----------------------------------------------------------------------
C list of parameters
C-------------------
C
C n     == integer. the dimension of the problem
C im    == size of Krylov subspace:  should not exceed 50 in this
C          version (can be reset in code. looking at comment below)
C rhs   == vector of length n containing the right hand side
C sol   == initial guess on input, approximate solution on output
C vv    == work space of size n x (im+1)
C w     == work space of length n x im
C wk1,
C wk2,  == two work vectors of length n each used for the reverse
C          communication protocole. When on return (icode .ne. 1)
C          the user should call fgmres again with wk2 = precon * wk1
C          and icode untouched. When icode.eq.1 then it means that
C          convergence has taken place.
C
C eps   == tolerance for stopping criterion. process is stopped
C          as soon as ( ||.|| is the euclidean norm):
C          || current residual||/||initial residual|| <= eps
C
C maxits== maximum number of iterations allowed
C
C i     == internal iteration counter, updated in this routine
C its   == current (Krylov) iteration counter, updated in this routine
C
C iout  == output unit number number for printing intermediate results
C          if (iout .le. 0) no statistics are printed.
C
C icode = integer. indicator for the reverse communication protocole.
C         ON ENTRY : icode should be set to icode = 0.
C         ON RETURN:
C       * icode .eq. 1 value means that fgmres has not finished
C         and that it is requesting a preconditioned vector before
C         continuing. The user must compute M**(-1) wk1, where M is
C         the preconditioing  matrix (may vary at each call) and wk1 is
C         the vector as provided by fgmres upun return, and put the
C         result in wk2. Then fgmres must be called again without
C         changing any other argument.
C       * icode .eq. 2 value means that fgmres has not finished
C         and that it is requesting a matrix vector product before
C         continuing. The user must compute  A * wk1, where A is the
C         coefficient  matrix and wk1 is the vector provided by
C         upon return. The result of the operation is to be put in
C         the vector wk2. Then fgmres must be called again without
C         changing any other argument.
C       * icode .eq. 0 means that fgmres has finished and sol contains
C         the approximate solution.
C         comment: typically fgmres must be implemented in a loop
C         with fgmres being called as long icode is returned with
C         a value .ne. 0.
C-----------------------------------------------------------------------
#if (defined SEAICE_ALLOW_JFNK) || (defined SEAICE_ALLOW_KRYLOV)
C     local variables -- !jfl modif
      integer imax
      parameter ( imax = 50 )
      _RL hh(4*imax+1,4*imax,MAX_NO_THREADS)
      _RL c(4*imax,MAX_NO_THREADS),s(4*imax,MAX_NO_THREADS)
      _RL rs(4*imax+1,MAX_NO_THREADS),t,ro
C-------------------------------------------------------------
C     arnoldi size should not exceed 50 in this version..
C-------------------------------------------------------------
      integer i1Thid(MAX_NO_THREADS)
      integer i1, ii, j, jj, k, k1!, n1
      integer bi, bj
      _RL r0, gam, eps1(MAX_NO_THREADS)
      CHARACTER*(MAX_LEN_MBUF) msgBuf

CEOP
C     local common blocks to replace a save statement in the original code
      COMMON /SEAICE_FMRES_LOC_I/ i1Thid
      COMMON /SEAICE_FMRES_LOC_RL/ hh, c, s, rs, eps1
      _RL epsmac
      parameter ( epsmac =  1.d-16 )
C
C     computed goto
C
      if ( im .gt. imax ) stop 'size of krylov space > 50'
      goto (100,200,300,11) icode +1
 100  continue
      its = 0
C-------------------------------------------------------------
C     **  outer loop starts here..
C--------------compute initial residual vector --------------
C 10   continue
      do bj=myByLo(myThid),myByHi(myThid)
       do bi=myBxLo(myThid),myBxHi(myThid)
        do j=1,n
         wk1(j,bi,bj)=sol(j,bi,bj)
        enddo
       enddo
      enddo
      icode = 3
      RETURN
 11   continue
      do bj=myByLo(myThid),myByHi(myThid)
       do bi=myBxLo(myThid),myBxHi(myThid)
        do j=1,n
         vv(j,1,bi,bj) = rhs(j,bi,bj) - wk2(j,bi,bj)
        enddo
       enddo
      enddo
 20   continue
      call SEAICE_SCALPROD(n, im+1, 1, 1, vv, vv, ro, myThid)
      ro = sqrt(ro)
      if (ro .eq. 0.0 _d 0) goto 999
      t = 1.0 _d 0/ ro
      do bj=myByLo(myThid),myByHi(myThid)
       do bi=myBxLo(myThid),myBxHi(myThid)
        do j=1, n
         vv(j,1,bi,bj) = vv(j,1,bi,bj)*t
        enddo
       enddo
      enddo
      if (its .eq. 0) eps1(myThid)=eps
C     not sure what this is, r0 is never used again
      if (its .eq. 0) r0 = ro
      if (iout .gt. 0) then
       _BEGIN_MASTER( myThid )
       write(msgBuf, 199) its, ro
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &      SQUEEZE_RIGHT, myThid )
C           print *,'chau',its, ro !write(iout, 199) its, ro
       _END_MASTER( myThid )
      endif
C
C     initialize 1-st term  of rhs of hessenberg system..
C
      rs(1,myThid) = ro
      i = 0
 4    continue
      i=i+1
      its = its + 1
      i1Thid(myThid) = i + 1
      do bj=myByLo(myThid),myByHi(myThid)
       do bi=myBxLo(myThid),myBxHi(myThid)
        do k=1, n
         wk1(k,bi,bj) = vv(k,i,bi,bj)
        enddo
       enddo
      enddo
C
C     return
C
      icode = 1
      RETURN
 200  continue
      do bj=myByLo(myThid),myByHi(myThid)
       do bi=myBxLo(myThid),myBxHi(myThid)
        do k=1, n
         w(k,i,bi,bj) = wk2(k,bi,bj)
        enddo
       enddo
      enddo
C
C     call matvec operation
C
      do bj=myByLo(myThid),myByHi(myThid)
       do bi=myBxLo(myThid),myBxHi(myThid)
        do k=1,n
         wk1(k,bi,bj)=wk2(k,bi,bj)
        enddo
       enddo
      enddo
C
C     return
C
      icode = 2
      RETURN
 300  continue
C
C     first call to ope corresponds to intialization goto back to 11.
C
C      if (icode .eq. 3) goto 11
      i1 = i1Thid(myThid)
      do bj=myByLo(myThid),myByHi(myThid)
       do bi=myBxLo(myThid),myBxHi(myThid)
        do k=1,n
         vv(k,i1,bi,bj)=wk2(k,bi,bj)
        enddo
       enddo
      enddo
C
C     modified gram - schmidt...
C
      do j=1, i
       call SEAICE_SCALPROD(n, im+1, j, i1, vv, vv, t, myThid)
       hh(j,i,myThid) = t
       do bj=myByLo(myThid),myByHi(myThid)
        do bi=myBxLo(myThid),myBxHi(myThid)
         do k=1,n
          vv(k,i1,bi,bj) = vv(k,i1,bi,bj) - t*vv(k,j,bi,bj)
         enddo
        enddo
       enddo
      enddo
      call SEAICE_SCALPROD(n, im+1, i1, i1, vv, vv, t, myThid)
      t = sqrt(t)
      hh(i1,i,myThid) = t
      if (t .ne. 0.0 _d 0) then
       t = 1.0 _d 0 / t
       do bj=myByLo(myThid),myByHi(myThid)
        do bi=myBxLo(myThid),myBxHi(myThid)
         do k=1,n
          vv(k,i1,bi,bj) = vv(k,i1,bi,bj)*t
         enddo
        enddo
       enddo
      endif
C
C     done with modified gram schmidt and arnoldi step.
C     now  update factorization of hh
C
      if (i .ne. 1) then
C
C     perfrom previous transformations  on i-th column of h
C
       do k=2,i
        k1 = k-1
        t = hh(k1,i,myThid)
        hh(k1,i,myThid) = c(k1,myThid)*t+s(k1,myThid)*hh(k,i,myThid)
        hh(k,i,myThid) = -s(k1,myThid)*t+c(k1,myThid)*hh(k,i,myThid)
       enddo
      endif
      gam = sqrt(hh(i,i,myThid)**2 + hh(i1,i,myThid)**2)
      if (gam .eq. 0.0 _d 0) gam = epsmac
C-----------#determine next plane rotation  #-------------------
      c(i,myThid)   = hh(i, i,myThid)/gam
      s(i,myThid)   = hh(i1,i,myThid)/gam
C     numerically more stable Givens rotation, but the results
C     are not better
CML      c(i,myThid)=1. _d 0
CML      s(i,myThid)=0. _d 0
CML      if ( abs(hh(i1(myThid,myThid),i)) .gt. 0.0 _d 0) then
CML       if ( abs(hh(i1,i,myThid)) .gt. abs(hh(i,i,myThid)) ) then
CML        gam = hh(i,i,myThid)/hh(i1,i,myThid)
CML        s(i,myThid) = 1./sqrt(1.+gam*gam)
CML        c(i,myThid) = s(i,myThid)*gam
CML       else
CML        gam = hh(i1,i,myThid)/hh(i,i,myThid)
CML        c(i,myThid) = 1./sqrt(1.+gam*gam)
CML        s(i,myThid) = c(i,myThid)*gam
CML       endif
CML      endif
      rs(i1,myThid) = -s(i,myThid)*rs(i,myThid)
      rs(i ,myThid) =  c(i,myThid)*rs(i,myThid)
C
C     determine res. norm. and test for convergence
C
      hh(i,i,myThid) = c(i,myThid)*hh(i, i,myThid)
     &     +           s(i,myThid)*hh(i1,i,myThid)
      ro = abs(rs(i1,myThid))
      if (iout .gt. 0) then
       _BEGIN_MASTER( myThid )
       write(msgBuf, 199) its, ro
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &      SQUEEZE_RIGHT, myThid )
       _END_MASTER( myThid )
      endif
CML   The original code uses only im as the maximum allowed iterations, but
CML   I want no more than maxits iterations, so we change the code here.
CML      if (i .lt. im .and. (ro .gt. eps1(myThid)))  goto 4
      if (i .lt. im .and. its .lt. maxits
     &     .and. (ro .gt. eps1(myThid))) goto 4
C
C     now compute solution. first solve upper triangular system.
C
      rs(i,myThid) = rs(i,myThid)/hh(i,i,myThid)
      do ii=2,i
       k=i-ii+1
       k1 = k+1
       t=rs(k,myThid)
       do j=k1,i
        t = t-hh(k,j,myThid)*rs(j,myThid)
       enddo
       rs(k,myThid) = t/hh(k,k,myThid)
      enddo
C
C     done with back substitution..
C     now form linear combination to get solution
C
      do j=1, i
       t = rs(j,myThid)
       do bj=myByLo(myThid),myByHi(myThid)
        do bi=myBxLo(myThid),myBxHi(myThid)
         do k=1,n
          sol(k,bi,bj) = sol(k,bi,bj) + t*w(k,j,bi,bj)
         enddo
        enddo
       enddo
      enddo
C
C     test for return
C
      if (ro .le. eps1(myThid) .or. its .ge. maxits) goto 999
C
C     else compute residual vector and continue..
C
C       goto 10

      i1 = i1Thid(myThid)
      do j=1,i
       jj = i1-j+1
       rs(jj-1,myThid) = -s(jj-1,myThid)*rs(jj,myThid)
       rs(jj  ,myThid) =  c(jj-1,myThid)*rs(jj,myThid)
      enddo
      do j=1,i1
       t = rs(j,myThid)
       if (j .eq. 1)  t = t - 1.0 _d 0
       do bj=myByLo(myThid),myByHi(myThid)
        do bi=myBxLo(myThid),myBxHi(myThid)
         do k=1,n
          vv(k,1,bi,bj) = vv(k,1,bi,bj) + t*vv(k,j,bi,bj)
         enddo
        enddo
       enddo
      enddo
C
C     restart outer loop.
C
      goto 20
 999  icode = 0

 199  format(' SEAICE_FGMRES: its =', i4, ' res. norm =', d26.16)
C
#endif /* SEAICE_ALLOW_JFNK or SEAICE_ALLOW_KRYLOV */
      RETURN
C-----end-of-fgmres-----------------------------------------------------
C-----------------------------------------------------------------------
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: SEAICE_SCALPROD
C     !INTERFACE:

      subroutine SEAICE_SCALPROD(n,im,i1,i2,dx,dy,t,myThid)

C     forms the dot product of two vectors.
C     uses unrolled loops for increments equal to one.
C     jack dongarra, linpack, 3/11/78.
C     ML: code stolen from BLAS-ddot and adapted for parallel applications

      implicit none
#include "SIZE.h"
#include "EEPARAMS.h"
#include "EESUPPORT.h"
#include "SEAICE_SIZE.h"
#include "SEAICE.h"
      integer n, im, i1, i2
      _RL dx(n,im,nSx,nSy),dy(n,im,nSx,nSy)
      _RL t
      integer myThid
#if (defined SEAICE_ALLOW_JFNK) || (defined SEAICE_ALLOW_KRYLOV)
C     local arrays
      _RL dtemp(nSx,nSy)
      integer i,m,mp1,bi,bj
CEOP

      m = mod(n,5)
      mp1 = m + 1
      t     = 0. _d 0
c     if( m .eq. 0 ) go to 40
      do bj=myByLo(myThid),myByHi(myThid)
       do bi=myBxLo(myThid),myBxHi(myThid)
        dtemp(bi,bj) = 0. _d 0
        if ( m .ne. 0 ) then
         do i = 1,m
          dtemp(bi,bj) = dtemp(bi,bj) + dx(i,i1,bi,bj)*dy(i,i2,bi,bj)
     &         * scalarProductMetric(i,1,bi,bj)
         enddo
        endif
        if ( n .ge. 5 ) then
c     if( n .lt. 5 ) go to 60
c40   mp1 = m + 1
         do i = mp1,n,5
          dtemp(bi,bj) = dtemp(bi,bj)               +
     &        dx(i,    i1,bi,bj)*dy(i,    i2,bi,bj)
     &        * scalarProductMetric(i,    1, bi,bj) +
     &        dx(i + 1,i1,bi,bj)*dy(i + 1,i2,bi,bj)
     &        * scalarProductMetric(i + 1,1, bi,bj) +
     &        dx(i + 2,i1,bi,bj)*dy(i + 2,i2,bi,bj)
     &        * scalarProductMetric(i + 2,1, bi,bj) +
     &        dx(i + 3,i1,bi,bj)*dy(i + 3,i2,bi,bj)
     &        * scalarProductMetric(i + 3,1, bi,bj) +
     &        dx(i + 4,i1,bi,bj)*dy(i + 4,i2,bi,bj)
     &        * scalarProductMetric(i + 4,1, bi,bj)
         enddo
c60   continue
        endif
       enddo
      enddo
      CALL GLOBAL_SUM_TILE_RL( dtemp,t,myThid )

#endif /* SEAICE_ALLOW_JFNK or SEAICE_ALLOW_KRYLOV */
      RETURN
      END

#include "CPP_EEOPTIONS.h"
#include "W2_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 0
C !ROUTINE: W2_SET_F2F_INDEX

C !INTERFACE:
      SUBROUTINE W2_SET_F2F_INDEX( myThid )

C     !DESCRIPTION:
C     Set-up index correspondence matrix for connected Facet-Edges

C     !USES:
      IMPLICIT NONE

C      Tile topology settings data structures
#include "SIZE.h"
#include "EEPARAMS.h"
#include "W2_EXCH2_SIZE.h"
#include "W2_EXCH2_PARAMS.h"
#include "W2_EXCH2_TOPOLOGY.h"

C     !INPUT PARAMETERS:
C     myThid  :: my Thread Id number
C               (Note: not relevant since threading has not yet started)
      INTEGER myThid

C     !LOCAL VARIABLES:
C     === Local variables ===
C     msgBuf     :: Informational/error message buffer
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      CHARACTER*1 edge(4)
      INTEGER i, j, ii, jj, i1, j1, k, lo, ll
      INTEGER errCnt
      INTEGER chk1, chk2, chk3, chk4, chk5, chk6
      LOGICAL prtFlag
CEOP
      DATA edge / 'N' , 'S' , 'E' , 'W' /

      WRITE(msgBuf,'(2A)') 'W2_SET_F2F_INDEX:',
     &       ' index matrix for connected Facet-Edges:'
      CALL PRINT_MESSAGE( msgBuf, W2_oUnit, SQUEEZE_RIGHT, myThid )
      prtFlag = ABS(W2_printMsg).GE.2
     &       .OR. ( W2_printMsg .NE.0 .AND. myProcId.EQ.0 )

C--   Check Topology
      errCnt = 0
      DO j=1,nFacets
       DO i=1,4
C-    connected to:
         jj = INT(facet_link(i,j))
         ii = MOD( NINT(facet_link(i,j)*10.), 10 )
         IF ( facet_link(i,j).EQ. 0. ) THEN
          WRITE(msgBuf,'(3A,I3,A,F6.2,A)')
     &           '** WARNING ** ',  edge(i), '.Edge of facet #',
     &        j, ' disconnected (facet_link=',facet_link(i,j),')'
          CALL PRINT_MESSAGE( msgBuf, W2_oUnit, SQUEEZE_RIGHT, myThid )
          CALL PRINT_MESSAGE( msgBuf,errorMessageUnit,SQUEEZE_RIGHT,1 )
         ELSEIF ( jj.LT.1 .OR. jj.GT.nFacets
     &            .OR. ii.LT.1 .OR. ii.GT.4 ) THEN
          WRITE(msgBuf,'(2A,I3,A,F6.2,A)') edge(i), '.Edge of facet #',
     &      j, ' : bad connection (facet_link=',facet_link(i,j),')'
          CALL PRINT_ERROR( msgBuf, myThid )
          errCnt = errCnt + 1
         ELSE
C-    check connection is set-up both ways:
          j1 = INT(facet_link(ii,jj))
          i1 = MOD( NINT(facet_link(ii,jj)*10.), 10 )
          IF ( j1.NE.j .OR. i1.NE.i ) THEN
           WRITE(msgBuf,'(2(2A,I3,A),F5.2,A)')
     &      edge(i), '.Edge facet #', j,' connect to: ',
     &      edge(ii),'.Edge facet #',jj,' (',facet_link(i,j),' )'
           CALL PRINT_ERROR( msgBuf, myThid )
          IF ( i1.GE.1 .AND. i1.LE.4 ) THEN
           WRITE(msgBuf,'(A,2(2A,I3,A),F5.2,A)') ' but ',
     &      edge(ii),'.Edge facet #',jj,' connect to: ',
     &      edge(i1),'.Edge facet #',j1,' (',facet_link(ii,jj),' )'
          ELSE
           WRITE(msgBuf,'(A,2(2A,I3,A),F5.2,A)') ' but ',
     &      edge(ii),'.Edge facet #',jj,' connect to: ',
     &           '?' ,'.Edge facet #',j1,' (',facet_link(ii,jj),' )'
          ENDIF
           CALL PRINT_ERROR( msgBuf, myThid )
           errCnt = errCnt + 1
          ENDIF
         ENDIF
       ENDDO
      ENDDO
      IF ( errCnt.GT.0 ) THEN
        WRITE(msgBuf,'(A,I3,A)')
     &   ' W2_SET_F2F_INDEX: found', errCnt, ' Topology errors'
        CALL PRINT_ERROR( msgBuf, myThid )
        STOP 'ABNORMAL END: S/R W2_SET_F2F_INDEX'
      ENDIF

C--   Check length of connection (facet size) between connected facet-edges
      errCnt = 0
      DO j=1,nFacets
       DO i=1,4
C-    Length of N or S Edge = x-size, E or W Edge = y-size
        lo = 2*(j-1) + (i+1)/2
        lo = facet_dims( lo )
C-    connected to:
        jj = INT(facet_link(i,j))
        ii = MOD( NINT(facet_link(i,j)*10.), 10 )
        IF ( jj.GE.1 ) THEN
         ll = 2*(jj-1)+(ii+1)/2
         ll = facet_dims( ll )
         IF ( lo.NE.ll ) THEN
           WRITE(msgBuf,'(3A,I3,A,I8,A)') 'Length of connection: ',
     &      edge(i), '.Edge facet #', j,  ' (=',lo,')'
           CALL PRINT_ERROR( msgBuf, myThid )
           WRITE(msgBuf,'(3A,I3,A,I8,A)') '  to: ',
     &      edge(ii),'.Edge facet #', jj, ' (=',ll,') are different'
           CALL PRINT_ERROR( msgBuf, myThid )
           errCnt = errCnt + 1
         ENDIF
C--   Set indices correspondence matrix (facet_pij):
C     suffix "so" for indices of source facet j ;
C     suffix "tg" for indices of target facet jj= INT(facet_link(i,j))
C     pij(:,i,j) : matrix which gives so indices when applied to tg indices
C        iso = pij(1)*itg + pij(2)*jtg + oi
C        jso = pij(3)*itg + pij(4)*jtg + oj

C-    Default: Same orientation (works for N <-> S or E <-> W)
         facet_pij(1,i,j) = 1
         facet_pij(2,i,j) = 0
         facet_pij(3,i,j) = 0
         facet_pij(4,i,j) = 1
C--   1rst: cases with same orientation
         IF ( i.EQ.1 .AND. ii.EQ.2 ) THEN
C-    N <-- S ; [:,jHi]_so <-- [:,0]_tg
           facet_oi(i,j) = 0
           facet_oj(i,j) = +facet_dims(2*j)
         ELSEIF ( i.EQ.2 .AND. ii.EQ.1 ) THEN
C-    S <-- N ; [:, 1 ]_so <-- [:,1+jHi]_tg
           facet_oi(i,j) = 0
           facet_oj(i,j) = -facet_dims(2*jj)
         ELSEIF ( i.EQ.3 .AND. ii.EQ.4 ) THEN
C-    E <-- W ; [iHi,:]_so <-- [0,:]_tg
           facet_oi(i,j) = +facet_dims(2*j-1)
           facet_oj(i,j) = 0
         ELSEIF ( i.EQ.4 .AND. ii.EQ.3 ) THEN
C-    W <-- E  (i=4 & ii=3); [ 1 ,:]_so <-- [iHi,:]_tg
           facet_oi(i,j) = -facet_dims(2*jj-1)
           facet_oj(i,j) = 0
C--   2nd : cases where orientation changes
         ELSEIF ( i.EQ.1 .AND. ii.EQ.4 ) THEN
C-    N <-- W ; mapping W.face target indices to N.face source indices
C-         [:,jHi]_so <-- [0,:]_tg
           facet_pij(1,i,j) = 0
           facet_pij(2,i,j) =-1
           facet_pij(3,i,j) = 1
           facet_pij(4,i,j) = 0
           facet_oi(i,j) = lo+1
           facet_oj(i,j) = +facet_dims(2*j)
         ELSEIF ( i.EQ.2 .AND. ii.EQ.3 ) THEN
C-    S <-- E ; mapping E.face target indices to S.face source indices
C-         [:,1]_so <-- [1+iHi,:]_tg
           facet_pij(1,i,j) = 0
           facet_pij(2,i,j) =-1
           facet_pij(3,i,j) = 1
           facet_pij(4,i,j) = 0
           facet_oi(i,j) = lo+1
           facet_oj(i,j) = -facet_dims(2*jj-1)
         ELSEIF ( i.EQ.3 .AND. ii.EQ.2 ) THEN
C-    E <-- S ; mapping S.face target indices to E.face source indices
C-         [iHi,:]_so <-- [:,0]_tg
           facet_pij(1,i,j) = 0
           facet_pij(2,i,j) = 1
           facet_pij(3,i,j) =-1
           facet_pij(4,i,j) = 0
           facet_oi(i,j) = +facet_dims(2*j-1)
           facet_oj(i,j) = lo+1
         ELSEIF ( i.EQ.4 .AND. ii.EQ.1 ) THEN
C-    W <-- N ; mapping N.face target indices to W.face source indices
C-         [ 1 ,:]_so <-- [:,1+jHi]_tg
           facet_pij(1,i,j) = 0
           facet_pij(2,i,j) = 1
           facet_pij(3,i,j) =-1
           facet_pij(4,i,j) = 0
           facet_oi(i,j) = -facet_dims(2*jj)
           facet_oj(i,j) = lo+1
         ELSE
           WRITE(msgBuf,'(2(3A,I3),A)') ' connect ',
     &      edge(i), '.Edge (facet#', j, ' ) to: ',
     &      edge(ii),'.Edge (facet#', jj,' )'
           CALL PRINT_ERROR( msgBuf, myThid )
           WRITE(msgBuf,'(A)')
     &       ' W2_SET_F2F_INDEX: Connection not supported'
           CALL PRINT_ERROR( msgBuf, myThid )
           errCnt = errCnt + 1
         ENDIF
C--   Print resulting index matrix:
         IF ( prtFlag ) WRITE(W2_oUnit,'(2(3A,I3),A,4I3,A,2I6)')
     &    '  ', edge(i), '.Edge Facet', j, ' <-- ',
     &          edge(ii),'.Edge Facet', jj,
     &    ' : pij=', (facet_pij(k,i,j),k=1,4),
     &    ' ; oi,oj=', facet_oi(i,j), facet_oj(i,j)
        ENDIF
       ENDDO
      ENDDO
      IF ( errCnt.GT.0 ) THEN
        WRITE(msgBuf,'(A,I3,A)')
     &   ' W2_SET_F2F_INDEX: found', errCnt, ' Connection errors'
        CALL PRINT_ERROR( msgBuf, myThid )
        STOP 'ABNORMAL END: S/R W2_SET_F2F_INDEX'
      ENDIF

C--   Check indices correspondence matrix reciprocity :
C     This is not necessary (if code above is right) ; However:
C     a) reciprocity is used later-on => good to check;
C     b) easy to add an error in setting offset => worth to check.
      errCnt = 0
      DO j=1,nFacets
       DO i=1,4
C-    connected to:
        jj = INT(facet_link(i,j))
        ii = MOD( NINT(facet_link(i,j)*10.), 10 )
        IF ( jj.GE.1 ) THEN
C        iso = pij(1)*( Pij(1)*iso + Pij(2)*jso + Oi )
C            + pij(2)*( Pij(3)*iso + Pij(4)*jso + Oj )
C            + oi
C        jso = pij(3)*( Pij(1)*iso + Pij(2)*jso + Oi )
C            + pij(4)*( Pij(3)*iso + Pij(4)*jso + Oj )
C            + oj
C-      Matrix product:
         chk1 = facet_pij(1,i,j)*facet_pij(1,ii,jj)
     &        + facet_pij(2,i,j)*facet_pij(3,ii,jj)
         chk2 = facet_pij(1,i,j)*facet_pij(2,ii,jj)
     &        + facet_pij(2,i,j)*facet_pij(4,ii,jj)
         chk3 = facet_pij(3,i,j)*facet_pij(1,ii,jj)
     &        + facet_pij(4,i,j)*facet_pij(3,ii,jj)
         chk4 = facet_pij(3,i,j)*facet_pij(2,ii,jj)
     &        + facet_pij(4,i,j)*facet_pij(4,ii,jj)
C-      Offsets:
         chk5 = facet_pij(1,i,j)*facet_oi(ii,jj)
     &        + facet_pij(2,i,j)*facet_oj(ii,jj)
     &        + facet_oi(i,j)
         chk6 = facet_pij(3,i,j)*facet_oi(ii,jj)
     &        + facet_pij(4,i,j)*facet_oj(ii,jj)
     &        + facet_oj(i,j)
         IF ( chk1.NE.1 .OR. chk2.NE.0 .OR. chk5.NE.0 .OR.
     &        chk3.NE.0 .OR. chk4.NE.1 .OR. chk6.NE.0 ) THEN
           WRITE(msgBuf,'(2(3A,I3),A)') ' connect ',
     &      edge(i), '.Edge (facet#', j, ' ) to: ',
     &      edge(ii),'.Edge (facet#', jj,' )'
           CALL PRINT_ERROR( msgBuf, myThid )
           WRITE(msgBuf,'(A,4I4,2I8)')
     &      ' Bug in Matrix Product:',chk1,chk2,chk3,chk4,chk5,chk6
           CALL PRINT_ERROR( msgBuf, myThid )
           errCnt = errCnt + 1
         ENDIF
        ENDIF
       ENDDO
      ENDDO
      IF ( errCnt.GT.0 ) THEN
        WRITE(msgBuf,'(A,I3,A)')
     &   ' W2_SET_F2F_INDEX: found', errCnt, ' bugs in Matrix product'
        CALL PRINT_ERROR( msgBuf, myThid )
        STOP 'ABNORMAL END: S/R W2_SET_F2F_INDEX'
      ENDIF

      RETURN
      END

#include "ECCO_OPTIONS.h"

      SUBROUTINE ECCO_SUMMARY( myThid )

c     ==================================================================
c     SUBROUTINE ecco_summary
c     ==================================================================
c
c     o Summarize the setup of the ECCO release.
c
c     ==================================================================
c     SUBROUTINE ecco_summary
c     ==================================================================

      IMPLICIT NONE

c     == global variables ==
#include "EEPARAMS.h"
#include "SIZE.h"
#include "ECCO_SIZE.h"
#include "ECCO.h"

c     == routine arguments ==
c     myThid  :: my Thread Id number
      INTEGER myThid

c     == external ==
#ifdef ALLOW_GENCOST_CONTRIBUTION
      INTEGER  ILNBLNK
      EXTERNAL ILNBLNK
#endif

c     == local variables ==
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      INTEGER msgUnit
#ifdef ALLOW_GENCOST_CONTRIBUTION
      INTEGER k, k2, il
#endif

c     == end of interface ==

      msgUnit = standardMessageUnit
      WRITE(msgBuf,'(A)') ' '
      CALL PRINT_MESSAGE( msgBuf, msgUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)')
     &'// ======================================================='
      CALL PRINT_MESSAGE( msgBuf, msgUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)')
     &'// ECCO configuration >>> START <<<'
      CALL PRINT_MESSAGE( msgBuf, msgUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)')
     &'// ======================================================='
      CALL PRINT_MESSAGE( msgBuf, msgUnit, SQUEEZE_RIGHT, myThid )

      WRITE(msgBuf,'(A)') ' '
      CALL PRINT_MESSAGE( msgBuf, msgUnit, SQUEEZE_RIGHT, myThid )

#ifdef ALLOW_GENCOST_CONTRIBUTION
      DO k = 1, NGENCOST
       IF (using_gencost(k)) THEN

        il = ILNBLNK(gencost_name(k))
        WRITE(msgBuf,'(A,I2,2A)') 'gencost(',k,
     &        ') = ',gencost_name(k)(1:il)
        CALL PRINT_MESSAGE( msgBuf, msgUnit, SQUEEZE_RIGHT, myThid )
        WRITE(msgBuf,'(A)') '-------------'
        CALL PRINT_MESSAGE( msgBuf, msgUnit, SQUEEZE_RIGHT, myThid )

        IF ( gencost_datafile(k) .NE. ' ' ) THEN
         il = ILNBLNK(gencost_datafile(k))
         WRITE(msgBuf,'(2A)') ' data file = ',gencost_datafile(k)(1:il)
         CALL PRINT_MESSAGE( msgBuf, msgUnit, SQUEEZE_RIGHT, myThid )
        ENDIF

        IF (gencost_nrec(k).GT.1) THEN
         WRITE(msgBuf,'(A)') '  starts and ends at : '
         CALL PRINT_MESSAGE( msgBuf, msgUnit, SQUEEZE_RIGHT, myThid )
         CALL CAL_PRINTDATE( gencost_startdate(1,k), myThid )
         CALL CAL_PRINTDATE( gencost_enddate(1,k), myThid )
         WRITE(msgBuf,'(A,I5)') '  number of records = ',
     &                           gencost_nrec(k)
         CALL PRINT_MESSAGE( msgBuf, msgUnit, SQUEEZE_RIGHT, myThid )
        ENDIF

        il = ILNBLNK(gencost_barfile(k))
        WRITE(msgBuf,'(2A)') ' model file = ',gencost_barfile(k)(1:il)
        CALL PRINT_MESSAGE( msgBuf, msgUnit, SQUEEZE_RIGHT, myThid )
        IF ((gencost_barfile(k)(1:9).EQ.'m_ptracer').OR.
     &      (gencost_barfile(k)(1:17).EQ.'m_boxmean_ptracer')) THEN
         WRITE(msgBuf,'(A,I2)') ' gencost_itracer = ',
     &         gencost_itracer(k)
         CALL PRINT_MESSAGE( msgBuf, msgUnit, SQUEEZE_RIGHT, myThid )
        ENDIF
        il = ILNBLNK(gencost_errfile(k))
        WRITE(msgBuf,'(2A)') ' error file = ',gencost_errfile(k)(1:il)
        CALL PRINT_MESSAGE( msgBuf, msgUnit, SQUEEZE_RIGHT, myThid )
        IF (gencost_scalefile(k).NE.' ') THEN
         il = ILNBLNK(gencost_scalefile(k))
         WRITE(msgBuf,'(2A)') ' scale file = ',
     &        gencost_scalefile(k)(1:il)
         CALL PRINT_MESSAGE( msgBuf, msgUnit, SQUEEZE_RIGHT, myThid )
        ENDIF
        DO k2 = 1, NGENPPROC
         IF (gencost_preproc(k2,k).NE.' ') THEN
          il = ILNBLNK(gencost_preproc(k2,k))
          WRITE(msgBuf,'(2A)') ' preprocess = ',
     &                          gencost_preproc(k2,k)(1:il)
          CALL PRINT_MESSAGE( msgBuf, msgUnit, SQUEEZE_RIGHT, myThid )
         ENDIF
         IF (gencost_posproc(k2,k).NE.' ') THEN
          il = ILNBLNK(gencost_posproc(k2,k))
          WRITE(msgBuf,'(2A)') ' posprocess = ',
     &                          gencost_posproc(k2,k)(1:il)
          CALL PRINT_MESSAGE( msgBuf, msgUnit, SQUEEZE_RIGHT, myThid )
         ENDIF
        ENDDO

        WRITE(msgBuf,'(A,I2)') ' gencost_flag = ',gencost_flag(k)
        CALL PRINT_MESSAGE( msgBuf, msgUnit, SQUEEZE_RIGHT, myThid )
        WRITE(msgBuf,'(A,I2)') ' gencost_outputlevel = ',
     &        gencost_outputlevel(k)
        CALL PRINT_MESSAGE( msgBuf, msgUnit, SQUEEZE_RIGHT, myThid )
        WRITE(msgBuf,'(A,I2)') ' gencost_kLev_select = ',
     &        gencost_kLev_select(k)
        CALL PRINT_MESSAGE( msgBuf, msgUnit, SQUEEZE_RIGHT, myThid )

        IF (gencost_is3d(k)) THEN
         WRITE(msgBuf,'(A,I2)') ' gencost_pointer3d = ',
     &         gencost_pointer3d(k)
         CALL PRINT_MESSAGE( msgBuf, msgUnit, SQUEEZE_RIGHT, myThid )
        ENDIF
        IF (gencost_timevaryweight(k)) THEN
         WRITE(msgBuf,'(A,L2)') ' time varia. weight = ',
     &         gencost_timevaryweight(k)
         CALL PRINT_MESSAGE( msgBuf, msgUnit, SQUEEZE_RIGHT, myThid )
        ENDIF
        IF (gencost_barskip(k)) THEN
         WRITE(msgBuf,'(A,L2)') ' skip barfile WRITE = ',
     &         gencost_barskip(k)
         CALL PRINT_MESSAGE( msgBuf, msgUnit, SQUEEZE_RIGHT, myThid )
        ENDIF

        WRITE(msgBuf,'(A)') ' '
        CALL PRINT_MESSAGE( msgBuf, msgUnit, SQUEEZE_RIGHT, myThid )

       ENDIF
      ENDDO
c--
#endif /* ALLOW_GENCOST_CONTRIBUTION */

      WRITE(msgBuf,'(A)')
     &'// ======================================================='
      CALL PRINT_MESSAGE( msgBuf, msgUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)')
     &'// ECCO configuration  >>> END <<<'
      CALL PRINT_MESSAGE( msgBuf, msgUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)')
     &'// ======================================================='
      CALL PRINT_MESSAGE( msgBuf, msgUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)') ' '
      CALL PRINT_MESSAGE( msgBuf, msgUnit, SQUEEZE_RIGHT, myThid )

      RETURN
      END

#include "BLING_OPTIONS.h"

CBOP
      subroutine BLING_INIT_FIXED( myThid )

C     ==========================================================
C     | subroutine bling_init_fixed
C     | o Initialize fixed parameters
C     ==========================================================

      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "BLING_VARS.h"

C     !INPUT PARAMETERS:
C     myThid       :: my Thread Id number
      INTEGER myThid
CEOP

#ifdef ALLOW_BLING
c     CHARACTER*(MAX_LEN_MBUF) msgBuf

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      _BEGIN_MASTER(myThid)

C set up coefficients for DIC chemistry
C define Schmidt no. coefficients for CO2
      sca1 = 2073.1 _d 0
      sca2 = -125.62 _d 0
      sca3 =    3.6276 _d 0
      sca4 =   -0.043219 _d 0
C define Schmidt no. coefficients for O2
C based on Keeling et al [GBC, 12, 141, (1998)]
CAV new Wanninkhof numbers
      sox1 = 1929.7 _d 0
      sox2 = -117.46 _d 0
      sox3 =    3.116 _d 0
      sox4 =   -0.0306 _d 0

C coefficients for determining saturation O2
      oA0=  2.00907 _d 0
      oA1=  3.22014 _d 0
      oA2=  4.05010 _d 0
      oA3=  4.94457 _d 0
      oA4= -2.56847 _d -1
      oA5=  3.88767 _d 0
      oB0= -6.24523 _d -3
      oB1= -7.37614 _d -3
      oB2= -1.03410 _d -2
      oB3= -8.17083 _d -3
      oC0= -4.88682 _d -7

#ifdef ALLOW_EXF
      apco2mask = 'c'
      IF ( useSEAICE ) THEN
       apco2mask = ' '
      ENDIF
#endif

C     Set other constant/flag

      _END_MASTER(myThid)

#ifdef ALLOW_DIAGNOSTICS
      IF ( useDIAGNOSTICS ) THEN
        CALL BLING_DIAGNOSTICS_INIT( myThid )
      ENDIF
#endif /* ALLOW_DIAGNOSTICS */

#endif /* ALLOW_BLING */

      RETURN
      END

#include "BBL_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 0
C !ROUTINE: BBL_INIT_FIXED

C !INTERFACE:
      SUBROUTINE BBL_INIT_FIXED( myThid )

C     !DESCRIPTION:
C     Initialize BBL variables that are kept fixed during the run.

C     !USES:
      IMPLICIT NONE
#include "EEPARAMS.h"
#include "SIZE.h"
#include "PARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     myThid ::  my Thread Id number
      INTEGER myThid
CEOP

C     !LOCAL VARIABLES:
C     === Local variables ===

#ifdef ALLOW_DIAGNOSTICS
      IF ( useDiagnostics ) THEN
        CALL BBL_DIAGNOSTICS_INIT( myThid )
      ENDIF
#endif

      RETURN
      END

!=======================================================================
      subroutine compsend_r8( dataname, Ni,Oi,Nj,Oj, arr )
      implicit none
! Arguments
      character*(*) dataname
      integer Ni,Oi,Nj,Oj
      real*8 arr(1-Oi:Ni+Oi,1-Oj:Nj+Oj)
! Predefined constants/arrays
#include "CPLR_SIG.h"
! MPI variables
#include "mpif.h"
      integer count,datatype,dest,tag,comm,ierr
! Functions
      integer generate_tag
! Local
      integer i,j,ij,Io,Jo
!     ------------------------------------------------------------------

      if (HEADER_SIZE+Ni*Nj.gt.MAX_R8_BUFLEN)
     &    stop 'compsend_r8: Nx*Ny too big'

! Set up buffer
      Io=my_tile_i0(1)
      Jo=my_tile_j0(1)
      r8buf(1)=float(Io)
      r8buf(2)=float(Ni)
      r8buf(3)=float(Jo)
      r8buf(4)=float(Nj)
      call mitcplr_char2dbl( dataname, r8buf(9) )

! Copy interior of tile to buffer
      do j=1,Nj
       do i=1,Ni
        ij=HEADER_SIZE+i+Ni*(j-1)
        r8buf(ij)=arr(i,j)
       enddo
      enddo

! Send message
      count=HEADER_SIZE+Ni*Nj
      datatype=MPI_DOUBLE_PRECISION
      dest=my_coupler_rank
      tag=generate_tag(102,my_rank_in_global,dataname)
      comm=MPI_COMM_myglobal

      if (VERB) then
       write(LogUnit,*) 'compsend_r8: calling MPI_Send dest=',dest
       write(LogUnit,*) 'compsend_r8: dataname=',dataname
       call flush(LogUnit)
      endif
      call MPI_Send( r8buf, count, datatype, dest, tag, comm, ierr )
      if (VERB) then
       write(LogUnit,*) 'compsend_r8: returned ierr=',ierr
       call flush(LogUnit)
      endif

      if (ierr.ne.0) then
       write(LogUnit,*) 'compsend_r8: rank(W,G,L)=',
     &            my_rank_in_world,my_rank_in_global,my_rank_in_local,
     &            ' ierr=',ierr
       stop 'compsend_r8: MPI_Send failed'
      endif

!     ------------------------------------------------------------------
      return
      end
!=======================================================================

#include "PACKAGES_CONFIG.h"
#include "CPP_OPTIONS.h"
#ifdef ALLOW_AUTODIFF
# include "AUTODIFF_OPTIONS.h"
#endif
#if (defined ALLOW_PTRACERS) && (!defined ALLOW_LONGSTEP)
# define DO_PTRACERS_HERE
#endif

#ifdef ALLOW_AUTODIFF
# ifdef ALLOW_GMREDI
#  include "GMREDI_OPTIONS.h"
# endif
# ifdef ALLOW_KPP
#  include "KPP_OPTIONS.h"
# endif
# ifdef ALLOW_SALT_PLUME
#  include "SALT_PLUME_OPTIONS.h"
# endif
#endif /* ALLOW_AUTODIFF */
#ifdef ALLOW_CTRL
# include "CTRL_OPTIONS.h"
#endif

CBOP
C     !ROUTINE: THERMODYNAMICS
C     !INTERFACE:
      SUBROUTINE THERMODYNAMICS(myTime, myIter, myThid)
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE THERMODYNAMICS
C     | o Controlling routine for the prognostic part of the
C     |   thermo-dynamics.
C     *===========================================================
C     \ev

C     !USES:
      IMPLICIT NONE
C     == Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "RESTART.h"
#include "DYNVARS.h"
#include "GRID.h"
#include "SURFACE.h"
#include "FFIELDS.h"
#ifdef ALLOW_GENERIC_ADVDIFF
# include "GAD.h"
#endif
#ifdef DO_PTRACERS_HERE
# include "PTRACERS_SIZE.h"
# include "PTRACERS_PARAMS.h"
# include "PTRACERS_FIELDS.h"
#endif
#ifdef ALLOW_LAYERS
# include "LAYERS_P2SHARE.h"
#endif

#ifdef ALLOW_AUTODIFF
# ifdef ALLOW_AUTODIFF_TAMC
#  include "tamc.h"
# endif
# include "EOS.h"
# ifdef ALLOW_KPP
#  include "KPP.h"
# endif
# ifdef ALLOW_GMREDI
#  include "GMREDI.h"
# endif
# ifdef ALLOW_EBM
#  include "EBM.h"
# endif
# ifdef ALLOW_SALT_PLUME
#  include "SALT_PLUME.h"
# endif
#endif /* ALLOW_AUTODIFF */

#ifdef ALLOW_TAPENADE
# ifdef ALLOW_GENERIC_ADVDIFF
#  include "GAD_SOM_VARS.h"
# endif
#endif /* ALLOW_TAPENADE */

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     myTime :: Current time in simulation
C     myIter :: Current iteration number in simulation
C     myThid :: Thread number for this instance of the routine.
      _RL myTime
      INTEGER myIter
      INTEGER myThid

#ifdef ALLOW_GENERIC_ADVDIFF
# ifdef ALLOW_MONITOR
C     !FUNCTIONS:
      LOGICAL  DIFFERENT_MULTIPLE
      EXTERNAL DIFFERENT_MULTIPLE
# endif /* ALLOW_MONITOR */

C     !LOCAL VARIABLES:
C     == Local variables
C     uFld,vFld,wFld :: Local copy of velocity field (3 components)
C     kappaRk        :: Total diffusion in vertical, all levels, 1 tracer
C     recip_hFacNew  :: reciprocal of futur time-step hFacC
C     bi, bj         :: Tile indices
C     i, j, k        :: loop indices
      _RL uFld    (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL vFld    (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL wFld    (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL kappaRk (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RS recip_hFacNew(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      INTEGER bi, bj
      INTEGER i, j, k
# ifdef ALLOW_MONITOR
      LOGICAL monOutputCFL
      _RL wrTime
      _RL trAdvCFL(3,nSx,nSy)
# endif /* ALLOW_MONITOR */
#ifdef ALLOW_AUTODIFF_TAMC
C     tkey :: tape key (tile dependent)
      INTEGER tkey
#endif
CEOP

#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_ENTER('THERMODYNAMICS',myThid)
#endif

# ifdef ALLOW_MONITOR
      monOutputCFL = .FALSE.
      IF ( monitorSelect.GE.2 ) THEN
        wrTime = myTime
        IF ( .NOT.staggerTimeStep ) wrTime = myTime + deltaTClock
        monOutputCFL =
     &       DIFFERENT_MULTIPLE( monitorFreq, wrTime, deltaTClock )
      ENDIF
# endif /* ALLOW_MONITOR */

#ifdef ALLOW_AUTODIFF_TAMC
C--   dummy statement to end declaration part
      tkey = 1

C--   HPF directive to help TAF
CHPF$ INDEPENDENT
#endif /* ALLOW_AUTODIFF_TAMC */

C-- Compute correction at the surface for Lin Free Surf.
#ifdef ALLOW_AUTODIFF
      TsurfCor = 0. _d 0
      SsurfCor = 0. _d 0
#endif
      IF ( linFSConserveTr ) THEN
#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE theta,salt,wvel = comlev1, key = ikey_dynamics, byte=isbyte
#endif
       CALL CALC_WSURF_TR( theta, salt, wVel,
     &                     myTime, myIter, myThid )
#ifdef ALLOW_LAYERS
       IF ( layers_useThermo ) THEN
        CALL LAYERS_WSURF_TR( theta, salt, wVel,
     &                        myTime, myIter, myThid )
       ENDIF
#endif /* ALLOW_LAYERS */
      ENDIF

#ifdef DO_PTRACERS_HERE
#ifdef ALLOW_AUTODIFF
      DO k=1,PTRACERS_numInUse
        meanSurfCorPTr(k) = 0.0 _d 0
      ENDDO
#endif
      IF ( PTRACERS_calcSurfCor ) THEN
#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE ptracer = comlev1, key = ikey_dynamics, byte=isbyte
#endif
       CALL PTRACERS_CALC_WSURF_TR(wVel,myTime,myIter,myThid)
      ENDIF
#endif /* DO_PTRACERS_HERE */

      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)

#ifdef ALLOW_AUTODIFF_TAMC
        tkey = bi + (bj-1)*nSx + (ikey_dynamics-1)*nSx*nSy
#endif /* ALLOW_AUTODIFF_TAMC */

C--   Set up work arrays with valid (i.e. not NaN) values
C     These inital values do not alter the numerical results. They
C     just ensure that all memory references are to valid floating
C     point numbers. This prevents spurious hardware signals due to
C     uninitialised but inert locations.

        DO k=1,Nr
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           recip_hFacNew(i,j,k) = 0. _d 0
C This is currently also used by IVDC and Diagnostics
           kappaRk(i,j,k)    = 0. _d 0
          ENDDO
         ENDDO
        ENDDO

C--     Compute new reciprocal hFac for implicit calculation
#ifdef NONLIN_FRSURF
        IF ( nonlinFreeSurf.GT.0 ) THEN
         IF ( select_rStar.GT.0 ) THEN
# ifndef DISABLE_RSTAR_CODE
          DO k=1,Nr
           DO j=1-OLy,sNy+OLy
            DO i=1-OLx,sNx+OLx
             recip_hFacNew(i,j,k) = recip_hFacC(i,j,k,bi,bj)
     &                            / rStarExpC(i,j,bi,bj)
            ENDDO
           ENDDO
          ENDDO
# endif /* DISABLE_RSTAR_CODE */
         ELSEIF ( selectSigmaCoord.NE.0 ) THEN
# ifndef DISABLE_SIGMA_CODE
          DO k=1,Nr
           DO j=1-OLy,sNy+OLy
            DO i=1-OLx,sNx+OLx
             recip_hFacNew(i,j,k) = recip_hFacC(i,j,k,bi,bj)
     &        /( 1. _d 0 + dEtaHdt(i,j,bi,bj)*deltaTFreeSurf
     &                    *dBHybSigF(k)*recip_drF(k)
     &                    *recip_hFacC(i,j,k,bi,bj)
     &         )
            ENDDO
           ENDDO
          ENDDO
# endif /* DISABLE_RSTAR_CODE */
         ELSE
          DO k=1,Nr
           DO j=1-OLy,sNy+OLy
            DO i=1-OLx,sNx+OLx
             IF ( k.EQ.kSurfC(i,j,bi,bj) ) THEN
              recip_hFacNew(i,j,k) = 1. _d 0 / hFac_surfC(i,j,bi,bj)
             ELSE
              recip_hFacNew(i,j,k) = recip_hFacC(i,j,k,bi,bj)
             ENDIF
            ENDDO
           ENDDO
          ENDDO
         ENDIF
        ELSE
#endif /* NONLIN_FRSURF */
          DO k=1,Nr
           DO j=1-OLy,sNy+OLy
            DO i=1-OLx,sNx+OLx
             recip_hFacNew(i,j,k) = _recip_hFacC(i,j,k,bi,bj)
            ENDDO
           ENDDO
          ENDDO
#ifdef NONLIN_FRSURF
        ENDIF
#endif /* NONLIN_FRSURF */

C--   Set up 3-D velocity field that we use to advect tracers:
C-    just do a local copy:
        DO k=1,Nr
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           uFld(i,j,k) = uVel(i,j,k,bi,bj)
           vFld(i,j,k) = vVel(i,j,k,bi,bj)
           wFld(i,j,k) = wVel(i,j,k,bi,bj)
          ENDDO
         ENDDO
        ENDDO
#ifdef ALLOW_GMREDI
C-    add Bolus velocity to Eulerian-mean velocity:
        IF (useGMRedi) THEN
          CALL GMREDI_RESIDUAL_FLOW(
     U                  uFld, vFld, wFld,
     I                  bi, bj, myIter, myThid )
        ENDIF
#endif /* ALLOW_GMREDI */
#ifdef ALLOW_MONITOR
        IF ( monOutputCFL  ) THEN
          CALL MON_CALC_ADVCFL_TILE( Nr, bi, bj,
     I                         uFld, vFld, wFld, dTtracerLev,
     O                         trAdvCFL(1,bi,bj),
     I                         myIter, myThid )
c        WRITE(standardMessageUnit,'(A,I8,2I3,A,1P3E14.6)')
c    &     ' trAdv_CFL: it,bi,bj=', myIter,bi,bj,
c    &     ' , CFL =', (trAdvCFL(i,bi,bj),i=1,3)
        ENDIF
#endif /* ALLOW_MONITOR */

C-    Apply AB on T,S : moved inside TEMP/SALT_INTEGRATE

#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE recip_hFacNew(:,:,:) = comlev1_bibj, key=tkey, byte=isbyte
CADJ STORE uFld (:,:,:)         = comlev1_bibj, key=tkey, byte=isbyte
CADJ STORE vFld (:,:,:)         = comlev1_bibj, key=tkey, byte=isbyte
CADJ STORE wFld (:,:,:)         = comlev1_bibj, key=tkey, byte=isbyte
CADJ STORE theta(:,:,:,bi,bj)   = comlev1_bibj, key=tkey, byte=isbyte
CADJ STORE salt (:,:,:,bi,bj)   = comlev1_bibj, key=tkey, byte=isbyte
# ifdef ALLOW_SALT_PLUME
CADJ STORE saltPlumeFlux(:,:,bi,bj)  = comlev1_bibj,key=tkey,kind=isbyte
CADJ STORE saltPlumeDepth(:,:,bi,bj) = comlev1_bibj,key=tkey,kind=isbyte
# endif
# if (defined NONLIN_FRSURF || defined ALLOW_DEPTH_CONTROL) \
        && defined ALLOW_GMREDI
CADJ STORE kux(:,:,:,bi,bj) = comlev1_bibj, key=tkey, byte=isbyte
CADJ STORE kvy(:,:,:,bi,bj) = comlev1_bibj, key=tkey, byte=isbyte
#  ifdef GM_EXTRA_DIAGONAL
CADJ STORE kuz(:,:,:,bi,bj) = comlev1_bibj, key=tkey, byte=isbyte
CADJ STORE kvz(:,:,:,bi,bj) = comlev1_bibj, key=tkey, byte=isbyte
#  endif
# endif
#endif /* ALLOW_AUTODIFF_TAMC */

C--     Calculate active tracer tendencies and step forward in time.
C       Active tracer arrays are updated while adjustments (filters,
C       conv.adjustment) are applied later in TRACERS_CORRECTION_STEP.

        IF ( tempStepping ) THEN
#ifdef ALLOW_DEBUG
          IF (debugMode) CALL DEBUG_CALL('TEMP_INTEGRATE',myThid)
#endif
          CALL TEMP_INTEGRATE(
     I         bi, bj, recip_hFacNew,
     I         uFld, vFld, wFld,
     U         kappaRk,
     I         myTime, myIter, myThid )
        ENDIF

        IF ( saltStepping ) THEN
#ifdef ALLOW_DEBUG
          IF (debugMode) CALL DEBUG_CALL('SALT_INTEGRATE',myThid)
#endif
          CALL SALT_INTEGRATE(
     I         bi, bj, recip_hFacNew,
     I         uFld, vFld, wFld,
     U         kappaRk,
     I         myTime, myIter, myThid )
        ENDIF

#ifdef DO_PTRACERS_HERE
C--     Calculate passive tracer tendencies and step forward in time.
C       Passive tracer arrays are updated while adjustments (filters,
C       conv.adjustment) are applied later in TRACERS_CORRECTION_STEP.
C       Also apply open boundary conditions for each passive tracer
        IF ( usePTRACERS ) THEN
#ifdef ALLOW_DEBUG
          IF (debugMode) CALL DEBUG_CALL('PTRACERS_INTEGRATE',myThid)
#endif
          CALL PTRACERS_INTEGRATE(
     I          bi, bj, recip_hFacNew,
     I          uFld, vFld, wFld,
     U          kappaRk,
     I          myTime, myIter, myThid )
        ENDIF
#endif /* DO_PTRACERS_HERE */

#ifdef   ALLOW_OBCS
C--   Apply open boundary conditions
        IF ( useOBCS ) THEN
          CALL OBCS_APPLY_TS( bi, bj, 0, theta, salt, myThid )
        ENDIF
#endif   /* ALLOW_OBCS */

#ifdef ALLOW_FRICTION_HEATING
#ifdef ALLOW_DIAGNOSTICS
        IF ( addFrictionHeating .AND. useDiagnostics ) THEN
          CALL DIAGNOSTICS_FILL_RS( frictionHeating, 'HeatDiss',
     &                              0, Nr, 1, bi, bj, myThid )
        ENDIF
#endif /* ALLOW_DIAGNOSTICS */
C-    Reset frictionHeating to zero
        IF ( addFrictionHeating .AND. .NOT.staggerTimeStep ) THEN
          DO k=1,Nr
           DO j=1-OLy,sNy+OLy
            DO i=1-OLx,sNx+OLx
              frictionHeating(i,j,k,bi,bj) = 0. _d 0
            ENDDO
           ENDDO
          ENDDO
        ENDIF
#endif /* ALLOW_FRICTION_HEATING */

C--   end bi,bj loops.
       ENDDO
      ENDDO

#ifdef ALLOW_MONITOR
      IF ( monOutputCFL ) THEN
        CALL MON_CALC_ADVCFL_GLOB(
     I                       trAdvCFL, myIter, myThid )
      ENDIF
#endif /* ALLOW_MONITOR */

#ifdef ALLOW_DEBUG
      IF ( debugLevel.GE.debLevD ) THEN
       CALL DEBUG_STATS_RL(Nr,uVel,'Uvel (THERMODYNAMICS)',myThid)
       CALL DEBUG_STATS_RL(Nr,vVel,'Vvel (THERMODYNAMICS)',myThid)
       CALL DEBUG_STATS_RL(Nr,wVel,'Wvel (THERMODYNAMICS)',myThid)
       CALL DEBUG_STATS_RL(Nr,theta,'Theta (THERMODYNAMICS)',myThid)
       CALL DEBUG_STATS_RL(Nr,salt,'Salt (THERMODYNAMICS)',myThid)
#ifndef ALLOW_ADAMSBASHFORTH_3
       CALL DEBUG_STATS_RL(Nr,gtNm1,'GtNm1 (THERMODYNAMICS)',myThid)
       CALL DEBUG_STATS_RL(Nr,gsNm1,'GsNm1 (THERMODYNAMICS)',myThid)
#endif
#ifdef DO_PTRACERS_HERE
       IF ( usePTRACERS ) THEN
         CALL PTRACERS_DEBUG(myThid)
       ENDIF
#endif /* DO_PTRACERS_HERE */
      ENDIF
#endif /* ALLOW_DEBUG */

#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_LEAVE('THERMODYNAMICS',myThid)
#endif

#endif /* ALLOW_GENERIC_ADVDIFF */

      RETURN
      END

#include "AIM_OPTIONS.h"

CBOP
C     !ROUTINE: AIM_DYN2AIM
C     !INTERFACE:
      SUBROUTINE AIM_DYN2AIM(
     O           TA, QA, ThA, Vsurf2, PSA, dpFac,
     O           kGrd,
     I           bi,bj, myTime, myIter, myThid)
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R AIM_DYN2AIM
C     | o Map dynamics conforming arrays to AIM internal arrays.
C     *==========================================================*
C     | this routine transfers grid information
C     | and all dynamical variables (T,Q, ...) to AIM physics
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     === Global variables ===
C-- size for MITgcm & Physics package :
#include "AIM_SIZE.h"

#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "SURFACE.h"
#include "DYNVARS.h"

#include "AIM_GRID.h"
#include "com_physcon.h"

C     !INPUT/OUTPUT PARAMETERS:
C--   Input:
C     bi,bj  :: Tile index
C     myTime :: Current time of simulation ( s )
C     myIter :: Current iteration number in simulation
C     myThid :: Number of this instance of the routine
C--   Output:  TA     :: temperature  [K}                        (3-dim)
C              QA     :: specific humidity [g/kg]                (3-dim)
C              ThA    :: Pot.Temp. [K] (replace dry stat. energy)(3-dim)
C              Vsurf2 :: square of surface wind speed            (2-dim)
C              PSA    :: norm. surface pressure [p/p0]           (2-dim)
C              dpFac  :: cell delta_P fraction                   (3-dim)
C              kGrd   :: Ground level index                      (2-dim)
C--  Updated common blocks: AIM_GRID_R
C             WVSurf  :: weights for near surf interpolation     (2-dim)
C             fOrogr  :: orographic factor (for surface drag)    (2-dim)
C         snLat,csLat :: sin(Lat) & cos(Lat)                     (2-dim)
      _RL TA(NGP,NLEV), QA(NGP,NLEV), ThA(NGP,NLEV)
      _RL Vsurf2(NGP), PSA(NGP), dpFac(NGP,NLEV)
      INTEGER kGrd(NGP)
      INTEGER bi, bj, myIter, myThid
      _RL myTime
CEOP

#ifdef ALLOW_AIM
C     !LOCAL VARIABLES:
C     i, j, I2 :: Loop counters
C     k, Katm  :: Loop counters
C     msgBuf   :: Informational/error message buffer
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      INTEGER i, j, I2, k, Katm
      _RL conv_theta2T, temp1, temp2

c     _RL hInitC(5), hInitF(5)
c     DATA    hInitC / 17338.0,10090.02,5296.88,2038.54,418.038/
c     DATA    hInitF / 15090.4, 8050.96, 4087.75, 1657.54, 0. /

C-    Compute Sin & Cos (Latitude) :
      DO j = 1,sNy
       DO i = 1,sNx
        I2 = i+(j-1)*sNx
        snLat(I2,myThid) = SIN(yC(i,j,bi,bj)*deg2rad)
        csLat(I2,myThid) = COS(yC(i,j,bi,bj)*deg2rad)
       ENDDO
      ENDDO

C-    Set surface level index :
      DO j = 1,sNy
       DO i = 1,sNx
        I2 = i+(j-1)*sNx
        kGrd(I2) = (Nr+1) - kSurfC(i,j,bi,bj)
       ENDDO
      ENDDO

C-    Set (normalized) surface pressure :
      DO j=1,sNy
       DO i=1,sNx
        I2 = i+(j-1)*sNx
        k = kSurfC(i,j,bi,bj)
        IF ( k.LE.Nr ) THEN
c        PSA(I2) = rF(k)/atm_Po
         PSA(I2) = Ro_surf(i,j,bi,bj)/atm_Po
        ELSE
         PSA(I2) = 1.
        ENDIF
       ENDDO
      ENDDO

C-    Set cell delta_P fraction (of the full delta.P = drF_k):
#ifdef NONLIN_FRSURF
      IF ( staggerTimeStep .AND. nonlinFreeSurf.GT.0 ) THEN
       IF ( select_rStar.GT.0 ) THEN
        DO k = 1,Nr
         Katm = _KD2KA( k )
         DO j = 1,sNy
          DO i = 1,sNx
           I2 = i+(j-1)*sNx
           dpFac(I2,Katm) = h0FacC(i,j,k,bi,bj)*rStarFacC(i,j,bi,bj)
c          dpFac(I2,Katm) = 1. _d 0
          ENDDO
         ENDDO
        ENDDO
       ELSE
        DO k = 1,Nr
         Katm = _KD2KA( k )
         DO j = 1,sNy
          DO i = 1,sNx
           I2 = i+(j-1)*sNx
           IF ( k.EQ.kSurfC(i,j,bi,bj) ) THEN
            dpFac(I2,Katm) = hFac_surfC(i,j,bi,bj)
           ELSE
            dpFac(I2,Katm) = hFacC(i,j,k,bi,bj)
           ENDIF
c          dpFac(I2,Katm) = 1. _d 0
          ENDDO
         ENDDO
        ENDDO
       ENDIF
      ELSE
#else /* ndef NONLIN_FRSURF */
      IF (.TRUE.) THEN
#endif /* NONLIN_FRSURF */
        DO k = 1,Nr
         Katm = _KD2KA( k )
         DO j = 1,sNy
          DO i = 1,sNx
           I2 = i+(j-1)*sNx
           dpFac(I2,Katm) = hFacC(i,j,k,bi,bj)
c          dpFac(I2,Katm) = 1. _d 0
          ENDDO
         ENDDO
        ENDDO
      ENDIF

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C     Physics package works with sub-domains 1:sNx,1:sNy,1:Nr.
C     Internal index mapping is linear in X and Y with a second
C     dimension for the vertical.

C-    Dynamical var --> AIM var :
C       note: UA & VA are not used  => removed
      temp1 = lwTemp1
      temp2 = lwTemp2
      DO k = 1,Nr
       conv_theta2T = (rC(k)/atm_Po)**atm_kappa
       Katm = _KD2KA( k )
       DO j = 1,sNy
        DO i = 1,sNx
         I2 = i+(j-1)*sNx
         IF ( maskC(i,j,k,bi,bj).EQ.oneRS ) THEN
c         UA(I2,Katm)  = uVel(i,j,k,bi,bj)
c         VA(I2,Katm)  = vVel(i,j,k,bi,bj)
C     Physics works with temperature - not potential temp.
          TA(I2,Katm)  = theta(i,j,k,bi,bj)*conv_theta2T
c         TA(I2,Katm)  = max(temp1,min(temp2,
c    &                       theta(i,j,k,bi,bj)*conv_theta2T ))
C     In atm.Phys, water vapor must be > 0 :
          QA(I2,Katm)  = MAX( salt(i,j,k,bi,bj), zeroRL )
C     Dry static energy replaced by Pot.Temp:
          ThA(I2,Katm) = theta(i,j,k,bi,bj)
         ELSE
          TA(I2,Katm)  = 300. _d 0
          QA(I2,Katm)  =   0. _d 0
          ThA(I2,Katm) = 300. _d 0
         ENDIF
        ENDDO
       ENDDO
#ifdef NONLIN_FRSURF
       IF ( select_rStar.GE.1 ) THEN
        DO j = 1,sNy
         DO i = 1,sNx
          I2 = i+(j-1)*sNx
          TA(I2,Katm)  = TA(I2,Katm)*pStarFacK(i,j,bi,bj)
         ENDDO
        ENDDO
       ENDIF
#endif /* NONLIN_FRSURF */
      ENDDO

C_jmc: add square of surface wind speed (center of C grid) = 2 * KE_surf
      DO j = 1,sNy
       DO i = 1,sNx
        I2 = i+(j-1)*sNx
        k = kSurfC(i,j,bi,bj)
        IF (k.LE.Nr) THEN
         Vsurf2(I2) = 0.5 * (
     &                uVel(i,j,k,bi,bj)*uVel(i,j,k,bi,bj)
     &              + uVel(i+1,j,k,bi,bj)*uVel(i+1,j,k,bi,bj)
     &              + vVel(i,j,k,bi,bj)*vVel(i,j,k,bi,bj)
     &              + vVel(i,j+1,k,bi,bj)*vVel(i,j+1,k,bi,bj)
     &                        )
        ELSE
         Vsurf2(I2) = 0.
        ENDIF
       ENDDO
      ENDDO

C-    Check that Temp is OK for LW Radiation scheme :
      DO k = 1,Nr
       Katm = _KD2KA( k )
       DO I2=1,NGP
        IF (  TA(I2,Katm).LT.lwTemp1 .OR.
     &        TA(I2,Katm).GT.lwTemp2 ) THEN
         i = 1 + mod((I2-1),sNx)
         j = 1 + int((I2-1)/sNx)
         WRITE(msgBuf,'(A,1PE20.13,A,2I4)')
     &    'AIM_DYN2AIM: Temp=', TA(I2,Katm),
     &    ' out of range ',lwTemp1,lwTemp2
         CALL PRINT_ERROR( msgBuf , myThid)
         WRITE(msgBuf,'(A,3I4,3I3,I6,2F9.3)')
     &    'AIM_DYN2AIM: Pb in i,j,k,bi,bj,myThid,I2,X,Y=',
     &        i,j,k,bi,bj,myThid,I2,xC(i,j,bi,bj),yC(i,j,bi,bj)
         CALL PRINT_ERROR( msgBuf , myThid)
         STOP 'ABNORMAL END: S/R AIM_DYN2AIM'
        ENDIF
       ENDDO
      ENDDO

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C-    Set geopotential surfaces
c     DO Katm=1,NLEV
c      DO I2=1,NGP
c       PHIG1(I2,Katm) = gravity*HinitC(Katm)
c      ENDDO
c     ENDDO

C-    Weights for vertical interpolation down to the surface
C     Fsurf = Ffull(nlev)+WVS*(Ffull(nlev)-Ffull(nlev-1))
      DO j = 1,sNy
       DO i = 1,sNx
        I2 = i+(j-1)*sNx
        WVSurf(I2,myThid) = 0.
        k = kGrd(I2)
        IF (k.GT.1) THEN
C- full cell version of Franco Molteni formula:
c         WVSurf(I2,myThid) = (LOG(SIGH(k))-SIGL(k))*WVI(k-1,2)
C- partial cell version using true log-P extrapolation:
          WVSurf(I2,myThid) = (LOG(PSA(I2))-SIGL(k))*WVI(k-1,1)
C- like in the old code:
c         WVSurf(I2,myThid) = WVI(k,2)
        ENDIF
       ENDDO
      ENDDO
      IF (myIter.EQ.nIter0)
     &  CALL AIM_WRITE_PHYS( 'aim_WeightSurf', '', 1, WVSurf,
     &                       1, bi, bj, 1, myIter, myThid )

#endif /* ALLOW_AIM */

      RETURN
      END

#include "MOM_FLUXFORM_OPTIONS.h"
#ifdef ALLOW_MOM_COMMON
# include "MOM_COMMON_OPTIONS.h"
#endif

CBOP
C !ROUTINE: MOM_U_XVISCFLUX

C !INTERFACE: ==========================================================
      SUBROUTINE MOM_U_XVISCFLUX(
     I        bi,bj,k,
     I        uFld, del2u,
     O        xViscFluxU,
     I        viscAh_D,viscA4_D,
     I        myThid )

C !DESCRIPTION:
C Calculates the area integrated zonal viscous fluxes of U:
C \begin{equation*}
C F^x = - \frac{ \Delta y_f \Delta r_f h_c }{\Delta x_f}
C  ( A_h \delta_i u - A_4 \delta_i \nabla^2 u )
C \end{equation*}

C !USES: ===============================================================
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"

C !INPUT PARAMETERS: ===================================================
C  bi,bj                :: tile indices
C  k                    :: vertical level
C  uFld                 :: zonal flow
C  del2u                :: Laplacian of zonal flow
C  myThid               :: thread number
      INTEGER bi,bj,k
      _RL uFld(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL del2u(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL viscAh_D(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL viscA4_D(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER myThid

C !OUTPUT PARAMETERS: ==================================================
C  xViscFluxU           :: viscous fluxes
      _RL xViscFluxU(1-OLx:sNx+OLx,1-OLy:sNy+OLy)

C !LOCAL VARIABLES: ====================================================
C  i,j                  :: loop indices
      INTEGER i,j
CEOP

C     - Laplacian  and bi-harmonic terms
      DO j=1-OLy,sNy+OLy-1
       DO i=1-OLx,sNx+OLx-1
        xViscFluxU(i,j) =
     &    _dyF(i,j,bi,bj)*drF(k)*_hFacC(i,j,k,bi,bj)
     &     *(
     &       -viscAh_D(i,j)*( uFld(i+1,j)-uFld(i,j) )
     &       *cosFacU(j,bi,bj)
     &       +viscA4_D(i,j)*(del2u(i+1,j)-del2u(i,j))
#ifdef COSINEMETH_III
     &       *sqCosFacU(j,bi,bj)
#else
     &       *cosFacU(j,bi,bj)
#endif
     &      )*_recip_dxF(i,j,bi,bj)
c    &       *deepFacC(k)        ! dyF scaling factor
c    &       *recip_deepFacC(k)  ! recip_dxF scaling factor
       ENDDO
      ENDDO

      RETURN
      END

#include "PTRACERS_OPTIONS.h"
#include "AD_CONFIG.h"
#ifdef ALLOW_AUTODIFF
# include "AUTODIFF_OPTIONS.h"
#endif

CBOP
C     !ROUTINE: ptracers_ad_dump
C     !INTERFACE:
      SUBROUTINE ptracers_ad_dump( myTime, myIter, myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE ptracers_ad_dump
C     *==========================================================*
C     Extract adjoint variable from TAF-generated
C     adjoint common blocks, contained in adcommon.h
C     and write fields to file;
C     Make sure common blocks in adcommon.h are up-to-date
C     w.r.t. current adjoint code.
C     *==========================================================*
C     | SUBROUTINE ptracers_ad_dump
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     == Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "PTRACERS_SIZE.h"
#include "PTRACERS_PARAMS.h"
#ifdef ALLOW_AUTODIFF_MONITOR
# include "AUTODIFF.h"
# include "AUTODIFF_PARAMS.h"
# include "ptracers_adcommon.h"
#endif
#ifdef ALLOW_DIAGNOSTICS
# include "DIAGNOSTICS_P2SHARE.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     myTime :: time counter for this thread
C     myIter :: iteration counter for this thread
C     myThid :: Thread number for this instance of the routine.
      _RL     myTime
      INTEGER myIter
      INTEGER myThid

#if (defined (ALLOW_ADJOINT_RUN) || defined (ALLOW_ADMTLM))
#ifdef ALLOW_AUTODIFF_MONITOR

C     !FUNCTIONS:
      LOGICAL  DIFFERENT_MULTIPLE
      EXTERNAL DIFFERENT_MULTIPLE

C     !LOCAL VARIABLES:
C     msgBuf :: Error message buffer
      INTEGER ip
      CHARACTER*(8)  diagName
      CHARACTER*(MAX_LEN_FNAM) dumpName
      LOGICAL doExch, doDump
      _RS dumRS(1)
CEOP

C     Handle exchange options
      doDump = DIFFERENT_MULTIPLE(adjDumpFreq,myTime,deltaTClock)
      doExch = doDump
#ifdef ALLOW_DIAGNOSTICS
      doExch = doExch.OR.useDiag4AdjOutp
#endif
      IF (doExch) THEN
       IF (dumpAdVarExch.EQ.1) THEN
        DO ip = 1, PTRACERS_numInUse
#ifdef AUTODIFF_TAMC_COMPATIBILITY
         CALL ADEXCH_XYZ_RL(myThid, adptracer(1-OLx,1-OLy,1,1,1,ip))
#else
         CALL ADEXCH_3D_RL(adptracer(1-OLx,1-OLy,1,1,1,ip), Nr, myThid)
#endif
        ENDDO
       ENDIF
      ENDIF

      IF (doDump) THEN
        CALL TIMER_START('I/O (WRITE)        [ADJOINT LOOP]', myThid )
      ENDIF

      DO ip = 1, PTRACERS_numInUse
        WRITE(diagName,'(A6,A2)') 'ADJptr', PTRACERS_ioLabel(ip)
        WRITE(dumpName,'(A10,A2,A1)')
     &        'ADJptracer', PTRACERS_ioLabel(ip), '.'

        CALL DUMP_ADJ_XYZ( dumRS, adptracer(1-OLx,1-OLy,1,1,1,ip),
     &                     diagName, dumpName, 12, doDump,
     &                     dumpAdRecMn, myTime, myIter, myThid )
      ENDDO

      IF (doDump) THEN
        CALL TIMER_STOP( 'I/O (WRITE)        [ADJOINT LOOP]', myThid )
      ENDIF

#endif /* ALLOW_AUTODIFF_MONITOR */
#endif /* ALLOW_ADJOINT_RUN */

      RETURN
      END

#include "CPP_OPTIONS.h"

CBOP
C     !ROUTINE: CPL_SEND_ATM_FIELDS
C     !INTERFACE:
      SUBROUTINE CPL_SEND_ATM_FIELDS( msgUnit, iter )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE CPL_SEND_ATM_FIELDS
C     | o Routine for sending ocean surface fields to atmos.
C     |   component.
C     *==========================================================*
C     | This version talks to the MITgcm general circulation
C     | model.
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     == Global variables ==
#include "CPL_PARAMS.h"
#include "ATMSIZE.h"
#include "ATMVARS.h"
#include "ATMIDS.h"
#include "OCNSIZE.h"
#include "OCNVARS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     msgUnit   :: log-file I/O unit
C     iter      :: current iteration number
      INTEGER msgUnit, iter

C     !LOCAL VARIABLES:
CEOP

C--   Map ocean mixed-layer depth onto atmos. grid
      CALL OCN_TO_ATM_MAPXYR8(
     I         Nx_ocn, Ny_ocn, OcMxlD_ocn, Nx_atm, Ny_atm,
     O                         OcMxlD_atm )
C     Send ocean mixed-layer depth to atmos. component
      CALL COUPSEND_R8TILES( atmCompName, atmMxlDName,
     I                       Nx_atm, Ny_atm, OcMxlD_atm )

C--   Map ocean surface temperature onto atmos. grid
      CALL OCN_TO_ATM_MAPXYR8(
     I         Nx_ocn, Ny_ocn, SST_ocn, Nx_atm, Ny_atm,
     O                         SST_atm )
C     Send SST to atmos. component
      CALL COUPSEND_R8TILES( atmCompName, atmSSTName,
     I                       Nx_atm, Ny_atm, SST_atm )

C--   Map ocean surface salinity onto atmos. grid
      CALL OCN_TO_ATM_MAPXYR8(
     I         Nx_ocn, Ny_ocn, SSS_ocn, Nx_atm, Ny_atm,
     O                         SSS_atm )
C     Send SSS to atmos. component
      CALL COUPSEND_R8TILES( atmCompName, atmSSSName,
     I                       Nx_atm, Ny_atm, SSS_atm )

C--   Map ocean surface velocity square onto atmos. grid
      CALL OCN_TO_ATM_MAPXYR8(
     I         Nx_ocn, Ny_ocn, vSq_ocn, Nx_atm, Ny_atm,
     O                         vSq_atm )
C     Send ocean surface velocity square to atmos. component
      CALL COUPSEND_R8TILES( atmCompName, atmSSVsqName,
     I                       Nx_atm, Ny_atm, vSq_atm )

      IF ( cpl_exchange_DIC.GE.2 ) THEN
C--   Map ocn->atm flux of CO2 onto atmos. grid
        CALL OCN_TO_ATM_MAPXYR8(
     I           Nx_ocn, Ny_ocn, fluxCO2_ocn, Nx_atm, Ny_atm,
     O                           fluxCO2_atm )
C     Send ocn->atm flux of CO2 to atmos. component
        CALL COUPSEND_R8TILES( atmCompName, atmCO2FluxName,
     I                         Nx_atm, Ny_atm, fluxCO2_atm )
      ENDIF

      IF ( cpl_exchange2W_sIce.EQ.3 ) THEN
C--   Map pkg/thsice fields onto atmos. grid:
C     Map seaice fraction from ocean compon.
        CALL OCN_TO_ATM_MAPXYR8(
     I           Nx_ocn, Ny_ocn, SIceFrac_ocn, Nx_atm, Ny_atm,
     O                           SIceFrac_atm )
C     Map seaice thickness
        CALL OCN_TO_ATM_MAPXYR8(
     I           Nx_ocn, Ny_ocn, sIceThick_ocn, Nx_atm, Ny_atm,
     O                           sIceThick_atm )
C     Map snow thickness
        CALL OCN_TO_ATM_MAPXYR8(
     I           Nx_ocn, Ny_ocn, sIceSnowH_ocn, Nx_atm, Ny_atm,
     O                           sIceSnowH_atm )
C     Map seaice enthalpy (layer 1)
        CALL OCN_TO_ATM_MAPXYR8(
     I           Nx_ocn, Ny_ocn, sIceQ1_ocn, Nx_atm, Ny_atm,
     O                           sIceQ1_atm )
C     Map seaice enthalpy (layer 2)
        CALL OCN_TO_ATM_MAPXYR8(
     I           Nx_ocn, Ny_ocn, sIceQ2_ocn, Nx_atm, Ny_atm,
     O                           sIceQ2_atm )
      ENDIF
      IF ( cpl_exchange2W_sIce.GE.2 ) THEN
C--   Send pkg/thsice fields to atmos. component:
C     Send sea-ice fraction
        CALL COUPSEND_R8TILES( atmCompName, atmSIceFracName,
     I                         Nx_atm, Ny_atm, SIceFrac_atm )
C     Send seaice thickness
        CALL COUPSEND_R8TILES( atmCompName, atmSIceThickName,
     I                         Nx_atm, Ny_atm, sIceThick_atm )
C     Send snow thickness
        CALL COUPSEND_R8TILES( atmCompName, atmSIceSnowName,
     I                         Nx_atm, Ny_atm, sIceSnowH_atm )
C     Send seaice enthalpy (layer 1)
        CALL COUPSEND_R8TILES( atmCompName, atmSIceQ1Name,
     I                         Nx_atm, Ny_atm, sIceQ1_atm )
C     Send seaice enthalpy (layer 2)
        CALL COUPSEND_R8TILES( atmCompName, atmSIceQ2Name,
     I                         Nx_atm, Ny_atm, sIceQ2_atm )
      ENDIF

      RETURN
      END

#include "CPP_EEOPTIONS.h"

CBOP
C     !ROUTINE: ILNBLNK

C     !INTERFACE:
      SUBROUTINE oad_s_ILNBLNK( string, index )
      IMPLICIT NONE

C     !DESCRIPTION:
C     *==========================================================*
C     | FUNCTION ILNBLNK                                         |
C     | o Find last non-blank in character string.               |
C     *==========================================================*

C     !INPUT PARAMETERS:
C     string :: string to scan
      CHARACTER*(*) string
      INTEGER index

C     !LOCAL VARIABLES:
C     L  :: Temp. used in scanning string
      INTEGER L
CEOP

      index = 0
      L = LEN(string)
      DO WHILE ( L .GT. 0 )
        IF ( string(L:L) .NE. ' ' ) THEN
          index = L
          L = 0
        ELSE
          L = L - 1
        ENDIF
      ENDDO
      END

#include "OBCS_OPTIONS.h"

C--  File obcs_monitor.F : write statistics of dynamical fields at OB section
C--   Contents
C--   o OBCS_MONITOR
C--   o OBCS_MON_WRITESTATS

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: OBCS_MONITOR

C     !INTERFACE:
      SUBROUTINE OBCS_MONITOR( myTime, myIter, myThid )

C     !DESCRIPTION:
C     *==========================================================*
C     | SUBROUTINE OBCS_MONITOR
C     | o Write out OB statistics
C     *==========================================================*

C     !USES:
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "DYNVARS.h"
#include "OBCS_PARAMS.h"
#include "OBCS_GRID.h"
#ifdef ALLOW_MONITOR
#include "MONITOR.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
      _RL myTime
      INTEGER myIter
      INTEGER myThid
CEOP

#ifdef ALLOW_OBCS
#ifdef ALLOW_MONITOR

C     !FUNCTIONS:
      LOGICAL  DIFFERENT_MULTIPLE
      EXTERNAL DIFFERENT_MULTIPLE
      LOGICAL  MASTER_CPU_IO
      EXTERNAL MASTER_CPU_IO

C     !LOCAL VARIABLES:
C     msgBuf       :: Informational/error message buffer
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      _RL fldStats(0:4,4)

      IF ( DIFFERENT_MULTIPLE( OBCS_monitorFreq,myTime,deltaTClock )
     &   ) THEN

#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_ENTER('OBCS_MONITOR',myThid)
#endif

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C--   OBCS monitor start
        IF ( MASTER_CPU_IO(myThid) ) THEN
C--   only the master thread is allowed to switch On/Off mon_write_stdout
C     & mon_write_mnc (since it is the only thread that uses those flags):

c         IF (monitor_stdio) THEN
            mon_write_stdout = .TRUE.
c         ELSE
c           mon_write_stdout = .FALSE.
c         ENDIF
          mon_write_mnc    = .FALSE.

          IF ( mon_write_stdout ) THEN
            WRITE(msgBuf,'(2A)') '// ==========================',
     &             '============================='
            CALL PRINT_MESSAGE( msgBuf, mon_ioUnit, SQUEEZE_RIGHT , 1)
            WRITE(msgBuf,'(A)')
     &             '// Begin OBCS MONITOR field statistics'
            CALL PRINT_MESSAGE( msgBuf, mon_ioUnit, SQUEEZE_RIGHT , 1)
            WRITE(msgBuf,'(2A)') '// ==========================',
     &             '============================='
            CALL PRINT_MESSAGE( msgBuf, mon_ioUnit, SQUEEZE_RIGHT , 1)
          ENDIF

C--   endif master cpu io
        ENDIF

        IF ( OBCS_monitorFreq .NE. monitorFreq
     &       .OR. .NOT.monitor_stdio ) THEN
         CALL MON_SET_PREF('obc_time_',myThid)
         CALL MON_OUT_I( 'tsnumber', myIter,mon_string_none,myThid)
         CALL MON_OUT_RL('secondsf', myTime,mon_string_none,myThid)
        ENDIF

        CALL MON_SET_PREF('obc_',myThid)

C--     Calculate and print Flow field Stats:
        IF ( OBCS_monSelect.GE.0 ) THEN

         CALL OBCS_MON_STATS_EW_RL(
     I             tileHasOBE, tileHasOBW,
     I             OB_Ie, OB_Iw, OB_indexNone,
     I             Nr, Nr, 1, uVel, hFacW, dyG, drF, maskInC,
     O             fldStats(0,1),
     I             myThid )
         CALL OBCS_MON_STATS_NS_RL(
     I             tileHasOBN, tileHasOBS,
     I             OB_Jn, OB_Js, OB_indexNone,
     I             Nr, Nr, 2, vVel, hFacS, dxG, drF, maskInC,
     O             fldStats(0,3),
     I             myThid )

         CALL OBCS_MON_WRITESTATS(
     I                             fldStats, 'Vel',
     I                             3, myIter, myThid )

        ENDIF

C--     Calculate and print Temp. field Stats:
        IF ( OBCS_monSelect.GE.1 ) THEN

         CALL OBCS_MON_STATS_EW_RL(
     I             tileHasOBE, tileHasOBW,
     I             OB_Ie, OB_Iw, OB_indexNone,
     I             Nr, Nr, 0, theta, hFacW, dyG, drF, maskInC,
     O             fldStats(0,1),
     I             myThid )
         CALL OBCS_MON_STATS_NS_RL(
     I             tileHasOBN, tileHasOBS,
     I             OB_Jn, OB_Js, OB_indexNone,
     I             Nr, Nr, 0, theta, hFacS, dxG, drF, maskInC,
     O             fldStats(0,3),
     I             myThid )

         CALL OBCS_MON_WRITESTATS(
     I                             fldStats, 'theta',
     I                             0, myIter, myThid )

        ENDIF

C--     Calculate and print Salt field Stats:
        IF ( OBCS_monSelect.GE.2 ) THEN

         CALL OBCS_MON_STATS_EW_RL(
     I             tileHasOBE, tileHasOBW,
     I             OB_Ie, OB_Iw, OB_indexNone,
     I             Nr, Nr, 0, salt, hFacW, dyG, drF, maskInC,
     O             fldStats(0,1),
     I             myThid )
         CALL OBCS_MON_STATS_NS_RL(
     I             tileHasOBN, tileHasOBS,
     I             OB_Jn, OB_Js, OB_indexNone,
     I             Nr, Nr, 0, salt, hFacS, dxG, drF, maskInC,
     O             fldStats(0,3),
     I             myThid )

         CALL OBCS_MON_WRITESTATS(
     I                             fldStats, 'salt',
     I                             0, myIter, myThid )

        ENDIF

C--   OBCS monitor finish
        IF ( MASTER_CPU_IO(myThid) ) THEN
C--   only the master thread is allowed to switch On/Off mon_write_stdout
C     & mon_write_mnc (since it is the only thread that uses those flags):

          IF ( mon_write_stdout ) THEN
            WRITE(msgBuf,'(2A)') '// ==========================',
     &             '============================='
            CALL PRINT_MESSAGE( msgBuf, mon_ioUnit, SQUEEZE_RIGHT , 1)
            WRITE(msgBuf,'(A)')
     &             '// End OBCS MONITOR field statistics'
            CALL PRINT_MESSAGE( msgBuf, mon_ioUnit, SQUEEZE_RIGHT , 1)
            WRITE(msgBuf,'(2A)') '// ==========================',
     &             '============================='
            CALL PRINT_MESSAGE( msgBuf, mon_ioUnit, SQUEEZE_RIGHT , 1)
          ENDIF

          mon_write_stdout = .FALSE.
          mon_write_mnc    = .FALSE.

C--   endif master cpu io
        ENDIF
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_LEAVE('OBCS_MONITOR',myThid)
#endif

C     endif different multiple
      ENDIF

#endif /* ALLOW_MONITOR */
#endif /* ALLOW_OBCS */

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: OBCS_MON_WRITESTATS

C     !INTERFACE:
      SUBROUTINE OBCS_MON_WRITESTATS(
     I                               arrStats, arrName,
     I                               prtSelect, myIter, myThid )

C     !DESCRIPTION:
C     *==========================================================*
C     | SUBROUTINE OBCS_MON_WRITESTATS
C     | o Write out OB statistics
C     *==========================================================*

C     !USES:
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#ifdef ALLOW_MONITOR
#include "MONITOR.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
      _RL arrStats(0:4,4)
      CHARACTER*(*) arrName
      INTEGER prtSelect
      INTEGER myIter
      INTEGER myThid
CEOP

#ifdef ALLOW_OBCS
#ifdef ALLOW_MONITOR

C     !LOCAL VARIABLES:
C     msgBuf       :: Informational/error message buffer
      INTEGER j
c     CHARACTER*(MAX_LEN_MBUF) msgBuf
      CHARACTER*(12) fldName
      _RL theMin, theMax, theMean, theSD

        j = 1
        fldName = 'E_'//arrName
        IF ( MOD(prtSelect,2).EQ.1 ) fldName = 'E_u'//arrName
        IF ( arrStats(0,j).GT.0. _d 0 ) THEN
          theMean= arrStats(1,j)/arrStats(0,j)
          theSD  = arrStats(2,j)/arrStats(0,j)
          theSD  = theSD - theMean*theMean
          IF ( theSD.GT.0. _d 0 ) theSD = SQRT(theSD)
          theMin = arrStats(3,j)
          theMax = arrStats(4,j)
          CALL MON_OUT_RL( fldName, theMax,  mon_foot_max,  myThid )
          CALL MON_OUT_RL( fldName, theMin,  mon_foot_min,  myThid )
          CALL MON_OUT_RL( fldName, theMean, mon_foot_mean, myThid )
          CALL MON_OUT_RL( fldName, theSD,   mon_foot_sd,   myThid )
          IF ( prtSelect.GE.2 )
     &    CALL MON_OUT_RL( fldName, arrStats(1,j), '_Int',  myThid )
        ENDIF

        j = 2
        fldName = 'W_'//arrName
        IF ( MOD(prtSelect,2).EQ.1 ) fldName = 'W_u'//arrName
        IF ( arrStats(0,j).GT.0. _d 0 ) THEN
          theMean= arrStats(1,j)/arrStats(0,j)
          theSD  = arrStats(2,j)/arrStats(0,j)
          theSD  = theSD - theMean*theMean
          IF ( theSD.GT.0. _d 0 ) theSD = SQRT(theSD)
          theMin = arrStats(3,j)
          theMax = arrStats(4,j)
          CALL MON_OUT_RL( fldName, theMax,  mon_foot_max,  myThid )
          CALL MON_OUT_RL( fldName, theMin,  mon_foot_min,  myThid )
          CALL MON_OUT_RL( fldName, theMean, mon_foot_mean, myThid )
          CALL MON_OUT_RL( fldName, theSD,   mon_foot_sd,   myThid )
          IF ( prtSelect.GE.2 )
     &    CALL MON_OUT_RL( fldName, arrStats(1,j), '_Int',  myThid )
        ENDIF

        j = 3
        fldName = 'N_'//arrName
        IF ( MOD(prtSelect,2).EQ.1 ) fldName = 'N_v'//arrName
        IF ( arrStats(0,j).GT.0. _d 0 ) THEN
          theMean= arrStats(1,j)/arrStats(0,j)
          theSD  = arrStats(2,j)/arrStats(0,j)
          theSD  = theSD - theMean*theMean
          IF ( theSD.GT.0. _d 0 ) theSD = SQRT(theSD)
          theMin = arrStats(3,j)
          theMax = arrStats(4,j)
          CALL MON_OUT_RL( fldName, theMax,  mon_foot_max,  myThid )
          CALL MON_OUT_RL( fldName, theMin,  mon_foot_min,  myThid )
          CALL MON_OUT_RL( fldName, theMean, mon_foot_mean, myThid )
          CALL MON_OUT_RL( fldName, theSD,   mon_foot_sd,   myThid )
          IF ( prtSelect.GE.2 )
     &    CALL MON_OUT_RL( fldName, arrStats(1,j), '_Int',  myThid )
        ENDIF

        j = 4
        fldName = 'S_'//arrName
        IF ( MOD(prtSelect,2).EQ.1 ) fldName = 'S_v'//arrName
        IF ( arrStats(0,j).GT.0. _d 0 ) THEN
          theMean= arrStats(1,j)/arrStats(0,j)
          theSD  = arrStats(2,j)/arrStats(0,j)
          theSD  = theSD - theMean*theMean
          IF ( theSD.GT.0. _d 0 ) theSD = SQRT(theSD)
          theMin = arrStats(3,j)
          theMax = arrStats(4,j)
          CALL MON_OUT_RL( fldName, theMax,  mon_foot_max,  myThid )
          CALL MON_OUT_RL( fldName, theMin,  mon_foot_min,  myThid )
          CALL MON_OUT_RL( fldName, theMean, mon_foot_mean, myThid )
          CALL MON_OUT_RL( fldName, theSD,   mon_foot_sd,   myThid )
          IF ( prtSelect.GE.2 )
     &    CALL MON_OUT_RL( fldName, arrStats(1,j), '_Int',  myThid )
        ENDIF

#endif /* ALLOW_MONITOR */
#endif /* ALLOW_OBCS */

      RETURN
      END

#include "PROFILES_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C !ROUTINE: PROFILES_READPARMS

C !INTERFACE:
      SUBROUTINE PROFILES_READVECTOR( fNb, vNb, irec,
     & vec_loc_length, vec_loc, bi, bj, myThid )

C     !DESCRIPTION:
C     Reads a profile from a netcdf profiles data file
C     Started: Gael Forget 15-March-2006

C     !USES:
      IMPLICIT NONE
C     == Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "DYNVARS.h"
#ifdef ALLOW_PROFILES
# include "netcdf.inc"
# include "PROFILES_SIZE.h"
# include "profiles.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     myThid :: my Thread Id number
      INTEGER vec_loc_length,vNb,bi,bj
      INTEGER irec,fNb,myThid
      _RL vec_loc(vec_loc_length)
CEOP

C     !LOCAL VARIABLES:
      INTEGER num_var,v1,v2
      INTEGER err,varId1,tmpprofno
#ifdef ALLOW_PROFILES
      INTEGER vec_start(2),vec_count(2)
      _RL vec_tmp1(1000*NLEVELMAX),vec_tmp2(1000*NLEVELMAX)
# ifdef ALLOW_PROFILES_CLIMMASK
      _RL vec_tmp3(1000*NLEVELMAX)
# endif
      CHARACTER*(MAX_LEN_MBUF) msgBuf

      IF ( (irec.LT.profiles_minind_buff(bi,bj)) .OR.
     &     (irec.GT.profiles_maxind_buff(bi,bj)) .OR.
     &     (profiles_curfile_buff(bi,bj).NE.fNb) ) THEN
        err = NF_INQ_DIMID(fiddata(fNb,bi,bj),'iPROF', varId1)
        CALL PROFILES_NF_ERROR(
     &       'READVECTOR: NF_INQ_DIMID fiddata iProf',
     &       err,bi,bj,myThid )
        err = NF_INQ_DIMLEN( fiddata(fNb,bi,bj), varId1, tmpprofno )
        CALL PROFILES_NF_ERROR( 'READVECTOR: NF_INQ_DIMLEN tmpprofno',
     &       err,bi,bj,myThid )

        IF (profiles_curfile_buff(bi,bj).NE.fNb) THEN
C No asumption on whether a forward or a backward loop is calling
          profiles_minind_buff(bi,bj) = MAX(1,irec-500+1)
          profiles_maxind_buff(bi,bj) = MIN(tmpprofno,irec+500)

        ELSEIF (irec.LT.profiles_minind_buff(bi,bj)) THEN
C Implies that a backward loop is calling
          profiles_minind_buff(bi,bj) = MAX(1,irec-999)
          profiles_maxind_buff(bi,bj) = irec

        ELSE
C Implies that a forward loop is calling
          profiles_minind_buff(bi,bj) = irec
          profiles_maxind_buff(bi,bj) = MIN(tmpprofno,irec+999)

        ENDIF !IF (profiles_curfile_buff(bi,bj).NE.fNb)

# ifdef ALLOW_DEBUG
        IF (debugLevel.GE.debLevD) THEN
          WRITE(msgBuf,'(A,5I9)')
     &     'buffer readvector ',
     &     profiles_minind_buff(bi,bj), profiles_maxind_buff(bi,bj),
     &     irec, profNo(fNb,bi,bj), tmpprofno
          CALL PRINT_MESSAGE( msgBuf,
     &         standardMessageUnit, SQUEEZE_RIGHT, myThid )
        ENDIF
# endif

        vec_start(1) = 1
        vec_start(2) = profiles_minind_buff(bi,bj)
        vec_count(1) = vec_loc_length
        vec_count(2) =
     &   profiles_maxind_buff(bi,bj)-profiles_minind_buff(bi,bj)+1

        DO num_var = 1, NVARMAX
          IF ( vec_quantities(fNb,num_var,bi,bj) ) THEN
            err = NF_INQ_VARID( fiddata(fNb,bi,bj),
     &            prof_names(fNb,num_var), varId1 )
            CALL PROFILES_NF_ERROR(
     &           'READVECTOR: NF_INQ_VARID prof_names',
     &           err,bi,bj,myThid )
            err = NF_GET_VARA_DOUBLE( fiddata(fNb,bi,bj), varId1,
     &            vec_start, vec_count, vec_tmp1 )
            CALL PROFILES_NF_ERROR(
     &           'READVECTOR: NF_GET_VARA_DOUBLE vec_tmp1',
     &           err,bi,bj,myThid )

            err = NF_INQ_VARID( fiddata(fNb,bi,bj),
     &            prof_namesweight(fNb,num_var), varId1 )
            CALL PROFILES_NF_ERROR(
     &      'READVECTOR: NF_INQ_VARID '//prof_namesweight(fNb,num_var),
     &           err,bi,bj,myThid )
            err = NF_GET_VARA_DOUBLE( fiddata(fNb,bi,bj),
     &            varId1, vec_start, vec_count, vec_tmp2 )
            CALL PROFILES_NF_ERROR(
     &           'READVECTOR: NF_GET_VARA_DOUBLE vec_tmp2',
     &           err,bi,bj,myThid )

# ifdef ALLOW_PROFILES_CLIMMASK
            err = NF_INQ_VARID( fiddata(fNb,bi,bj),
     &            prof_namesclim(fNb,num_var),varId1 )
            CALL PROFILES_NF_ERROR(
     &           'READVECTOR: NF_INQ_VARID prof_namesclim',
     &           err,bi,bj,myThid )
            err = NF_GET_VARA_DOUBLE( fiddata(fNb,bi,bj),
     &            varId1,vec_start,vec_count, vec_tmp3 )
            CALL PROFILES_NF_ERROR(
     &           'READVECTOR: NF_GET_VARA_DOUBLE vec_tmp3',
     &           err,bi,bj,myThid )
# endif

            IF (err.NE.NF_NOERR) THEN
              WRITE(errorMessageUnit,'(A)')
     &         'WARNING PROFILES_READVECTOR: record not found!!'
            ENDIF

            DO v1 = 1, vec_count(1)
              DO v2 = 1, vec_count(2)
                profiles_data_buff(v1,v2,num_var,bi,bj) =
     &           vec_tmp1((v2-1)*vec_count(1)+v1)

                profiles_weight_buff(v1,v2,num_var,bi,bj) =
     &           vec_tmp2((v2-1)*vec_count(1)+v1)

# ifdef ALLOW_PROFILES_CLIMMAS
                IF (vec_tmp3((v2-1)*vec_count(1)+v1).LE.-990. _d 0)
     &            profiles_weight_buff(v1,v2,num_var,bi,bj) = 0. _d 0

# endif
              ENDDO !DO v2
            ENDDO !DO v1

          ENDIF !IF (vec_quantities
        ENDDO !DO num_var

        profiles_curfile_buff(bi,bj) = fNb
      ENDIF !IF ( (irec.LT.profiles_minid

C Get vec_loc from the buffer
      IF (vNb.LT.0) THEN
        DO v1 = 1, vec_loc_length
          vec_loc(v1) = profiles_weight_buff
     &     (v1,irec-profiles_minind_buff(bi,bj)+1,-vNb,bi,bj)
        ENDDO

      ELSE
        DO v1 = 1, vec_loc_length
          vec_loc(v1) = profiles_data_buff
     &     (v1,irec-profiles_minind_buff(bi,bj)+1,vNb,bi,bj)
        ENDDO

      ENDIF

#endif /* ALLOW_PROFILES */

      RETURN
      END

#include "DIAG_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

CBOP 0
C     !ROUTINE: DIAGNOSTICS_SET_CALC

C     !INTERFACE:
      SUBROUTINE DIAGNOSTICS_SET_CALC( myThid )

C     !DESCRIPTION:
C     *==========================================================*
C     | S/R DIAGNOSTICS_SET_CALC
C     |  Set parameters and variables used in post-processing
C     |      diagnostics
C     *==========================================================*

C     !USES:
      IMPLICIT NONE
#include "EEPARAMS.h"
#include "SIZE.h"
#include "PARAMS.h"
#include "GRID.h"
#include "DIAGNOSTICS_CALC.h"
#ifdef ALLOW_OBCS
# include "OBCS_GRID.h"
#endif /* ALLOW_OBCS */

C     !INPUT PARAMETERS:
C     myThid     ::  my thread Id number
      INTEGER      myThid
CEOP

C     !LOCAL VARIABLES:
      INTEGER bi, bj
      INTEGER i, j
      INTEGER biG, bjG
      _RL     dxLoc, dyLoc, d2Loc, d2Min
      _RL     xLine, xy0, xyLoc, xyMin
      CHARACTER*(MAX_LEN_MBUF) msgBuf
#ifdef ALLOW_OBCS
      LOGICAL kPsi(1:sNx+1,1:sNy+1,nSx,nSy)
#endif /* ALLOW_OBCS */

C--   Set indices of grid-point location where Psi == 0
      IF ( xPsi0.EQ.UNSET_RS .OR. yPsi0.EQ.UNSET_RS ) THEN
C-    Set indices to (-1,0) = disabled value
        DO bj=myByLo(myThid),myByHi(myThid)
         DO bi=myBxLo(myThid),myBxHi(myThid)
           iPsi0(bi,bj) = -1
           jPsi0(bi,bj) =  0
         ENDDO
        ENDDO
      ELSE
#ifdef ALLOW_OBCS
C-     set flag where Psi is computed
        DO bj=myByLo(myThid),myByHi(myThid)
         DO bi=myBxLo(myThid),myBxHi(myThid)
          DO j = 1,sNy+1
           DO i = 1,sNx+1
             kPsi(i,j,bi,bj) = .TRUE.
           ENDDO
          ENDDO
          IF ( useOBCS ) THEN
           DO j = 1,sNy+1
            DO i = 1,sNx+1
             kPsi(i,j,bi,bj) = OBCS_insideMask( i , j ,bi,bj).EQ.oneRS
     &                    .OR. OBCS_insideMask(i-1, j ,bi,bj).EQ.oneRS
     &                    .OR. OBCS_insideMask( i ,j-1,bi,bj).EQ.oneRS
     &                    .OR. OBCS_insideMask(i-1,j-1,bi,bj).EQ.oneRS
            ENDDO
           ENDDO
          ENDIF
         ENDDO
        ENDDO
#endif /* ALLOW_OBCS */
C-      find minimum distance:
        d2Min = -1. _d 0
        DO bj=myByLo(myThid),myByHi(myThid)
         DO bi=myBxLo(myThid),myBxHi(myThid)
          DO j = 1,sNy+1
           DO i = 1,sNx+1
             dxLoc = xG(i,j,bi,bj)-xPsi0
             dyLoc = yG(i,j,bi,bj)-yPsi0
             d2Loc = dxLoc*dxLoc + dyLoc*dyLoc
#ifdef ALLOW_OBCS
             IF ((d2Loc.LT.d2Min .OR. d2Min.EQ.-1. _d 0)
     &                            .AND. kPsi(i,j,bi,bj) ) d2Min = d2Loc
#else
             IF ( d2Loc.LT.d2Min .OR. d2Min.EQ.-1. _d 0 ) d2Min = d2Loc
#endif
           ENDDO
          ENDDO
         ENDDO
        ENDDO
        d2Min = -d2Min
        _GLOBAL_MAX_RL( d2Min, myThid )
        d2Min = -d2Min
C-      find list of grid-points at minimum distance:
        xyMin = 0.
        xLine = (sNx+1)*nSx*nPx
        DO bj=myByLo(myThid),myByHi(myThid)
         DO bi=myBxLo(myThid),myBxHi(myThid)
          iPsi0(bi,bj) = 0
          jPsi0(bi,bj) = 0
          biG = bi-1+(myXGlobalLo-1)/sNx
          bjG = bj-1+(myYGlobalLo-1)/sNy
          xy0 = biG*(sNx+1) + bjG*(sNy+1)*xLine
          DO j = 1,sNy+1
           DO i = 1,sNx+1
             dxLoc = xG(i,j,bi,bj)-xPsi0
             dyLoc = yG(i,j,bi,bj)-yPsi0
             d2Loc = dxLoc*dxLoc + dyLoc*dyLoc
#ifdef ALLOW_OBCS
             IF ( d2Loc.EQ.d2Min .AND. kPsi(i,j,bi,bj) ) THEN
#else
             IF ( d2Loc.EQ.d2Min ) THEN
#endif
               xyLoc = xy0 + i + (j-1)*xLine
               IF ( xyMin.EQ.0. _d 0 ) THEN
                 xyMin = xyLoc
               ELSE
                 xyMin = MIN( xyMin, xyLoc )
               ENDIF
               iPsi0(bi,bj) = i
               jPsi0(bi,bj) = j
             ENDIF
           ENDDO
          ENDDO
         ENDDO
        ENDDO
        xyLoc = (sNx+1)*(sNy+1)*nSx*nSy*nPx*nPy + 2.
        IF ( xyMin.EQ.0. _d 0 ) xyMin = xyLoc
        xyMin = -xyMin
        _GLOBAL_MAX_RL( xyMin, myThid )
        xyMin = -xyMin
C-      select only one (based on minimum global-map index)
        _BARRIER
        _BEGIN_MASTER( myThid )
        WRITE(msgBuf,'(2A)') 'DIAGNOSTICS_SET_CALC: ',
     &    'setting indices iPsi0,jPsi0 where Psi == 0 :'
        CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
        WRITE(msgBuf,'(A,1P1E19.6,A,0PF16.3)')
     &    'DIAGNOSTICS_SET_CALC: d2Min=',d2Min, ', ijMin=',xyMin
        CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
        IF ( xyMin.EQ.xyLoc ) THEN
          WRITE(msgBuf,'(2A)') 'DIAGNOSTICS_SET_CALC: ',
     &      'Fail to find the minimum distance => use Default'
          CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                        SQUEEZE_RIGHT, myThid )
          DO bj=1,nSy
           DO bi=1,nSx
             iPsi0(bi,bj) = -1
             jPsi0(bi,bj) =  0
           ENDDO
          ENDDO
        ELSE
          DO bj=1,nSy
           DO bi=1,nSx
             IF ( iPsi0(bi,bj).GT.0 ) THEN
              biG = bi-1+(myXGlobalLo-1)/sNx
              bjG = bj-1+(myYGlobalLo-1)/sNy
              xy0 = biG*(sNx+1) + bjG*(sNy+1)*xLine
              xyLoc = xy0 + iPsi0(bi,bj) + (jPsi0(bi,bj)-1)*xLine
              d2Loc = ABS( xyLoc - xyMin )
              IF ( d2Loc.GE.0.5 _d 0 ) THEN
               WRITE(msgBuf,'(2(A,2I5),A,F16.3)')
     &          ' discard: bi,bj=',bi,bj,
     &          ' ; i,j=',iPsi0(bi,bj),jPsi0(bi,bj),' ; ijLoc=',xyLoc
               CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                             SQUEEZE_RIGHT, myThid )
               iPsi0(bi,bj) = 0
               jPsi0(bi,bj) = 0
              ELSE
               WRITE(msgBuf,'(2(A,2I5),A,F16.3)')
     &          ' SELECT : bi,bj=',bi,bj,
     &          ' ; i,j=',iPsi0(bi,bj),jPsi0(bi,bj),' ; ijLoc=',xyLoc
               CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                             SQUEEZE_RIGHT, myThid )
              ENDIF
             ENDIF
c            WRITE(standardMessageUnit,'(2(A,2I5))')
c    &        ' bi,bj=',bi,bj,' i,jPsi0=', iPsi0(bi,bj),jPsi0(bi,bj)
           ENDDO
          ENDDO
        ENDIF
        WRITE(msgBuf,'(2A)')
     &   '------------------------------------------------------------'
        CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
        _END_MASTER( myThid )
        _BARRIER
      ENDIF

      RETURN
      END

#include "CPP_OPTIONS.h"

CBOP
C     !ROUTINE: PACKAGES_ERROR_MSG
C     !INTERFACE:
      SUBROUTINE PACKAGES_ERROR_MSG( msg1, msg2, myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE PACKAGES_ERROR_MSG
C     | o Generate error message due to failed package
C     |   dependancies check
C     *==========================================================*
C     |   This routine is called if use_PKG was true but PKG code
C     |   was not compiled (#undef ALLOW_KPG)
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
C     msg1   ::  package name
C     msg2   ::  package On/Off flag
C     myThid ::  My thread Id number
      CHARACTER*(*) msg1, msg2
      INTEGER myThid

C     !LOCAL VARIABLES:
C     === Local variables ===
C     msgBuf :: Informational/error message buffer
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      CHARACTER*(MAX_LEN_MBUF) msgLwc,msgUpc
      INTEGER iLen
CEOP

      iLen = LEN(msg1)
      msgLwc(1:iLen) = msg1
      msgUpc(1:iLen) = msg1
      CALL LCASE(msgLwc(1:iLen))
      CALL UCASE(msgUpc(1:iLen))
      IF ( msg2 .EQ. ' ' ) THEN
       WRITE(msgBuf,'(4A)') 'from PACKAGES_CHECK: ',
     &  'run-time control flag use',msg1,' is set'
      ELSE
       WRITE(msgBuf,'(4A)') 'from PACKAGES_CHECK: ',
     &  'run-time parameter ',msg2,' is used'
      ENDIF
      CALL PRINT_ERROR( msgBuf, myThid )
      WRITE(msgBuf,'(5A)') 'but pkg/',msgLwc(1:iLen),
     &  ' was not compiled (ALLOW_',msgUpc(1:iLen),' undef).'
      CALL PRINT_ERROR( msgBuf, myThid )
      WRITE(msgBuf,'(3A)')
     &  '==> Re-compile with pkg "',msgLwc(1:iLen),
     &  '" in file "packages.conf"'
      CALL PRINT_ERROR( msgBuf, myThid )
      CALL ALL_PROC_DIE( myThid )
      STOP 'ABNORMAL END: S/R PACKAGE_ERROR_MSG'

      RETURN
      END

#include "AUTODIFF_OPTIONS.h"

C     ==================================================================
C     active_file_gen.F: Routines to handle the I/O of the active file
C                        for the adjoint calculations.
C     Routines
C    o  ACTIVE_READ_GEN_RL     - Read  an active RL variable from file.
C    o  ACTIVE_READ_GEN_RS     - Read  an active RS variable from file.
C
C    o  ACTIVE_WRITE_GEN_RL    - Write an active RL variable to a file.
C    o  ACTIVE_WRITE_GEN_RS    - Write an active RS variable to a file.
C
C     Generic version for each array type (_RL or _RS).
C     Note: the _RL version can replace the 4 x 2 shape-specific
C           (_xy,_xyz,_xz,_yz) and standard or "_loc" routines.
C     ==================================================================

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: ACTIVE_READ_GEN_RL
C     !INTERFACE:
      SUBROUTINE ACTIVE_READ_GEN_RL(
     I                               activeVar_file,
     O                               active_var,
     I                               arrShape, myNr,
     I                               iRec,
     I                               globalFile,
     I                               useCurrentDir,
     I                               lAdInit,
     I                               myOptimIter,
     I                               myThid,
     I                               dummy )

C     !DESCRIPTION: \bv
C     ==================================================================
C     SUBROUTINE ACTIVE_READ_GEN_RL
C     ==================================================================
C     o Read an active (_RL) variable from file (generic version).
C     Accept active variable of various (XY,XZ,YZ) shape and level
C     number, according to arguments arrShape and myNr.
C     ==================================================================
C     \ev

C     !USES:
      IMPLICIT NONE

C     == global variables ==
#include "EEPARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     activeVar_file :: filename
C     active_var     :: active variable array
C     arrShape       :: shape of active-var array ('XY','XZ' or 'YZ')
C     myNr           :: number of vertical-levels in active-var array
C     iRec           :: record number in file
C     globalFile     :: used for writing global (if =T) or tiled files
C     useCurrentDir  :: always read from the current directory
C                        (even if "mdsioLocalDir" is set)
C     lAdInit        :: initialisation of corresponding adjoint variable
C                        and write to active file
C     myOptimIter    :: number of optimization iteration (default: 0)
C     myThid         :: my Thread Id number
C     dummy          :: (needed for 2nd derivative code)
      CHARACTER*(*) activeVar_file
      _RL     active_var(*)
      CHARACTER*(2) arrShape
      INTEGER myNr
      INTEGER iRec
      LOGICAL globalFile
      LOGICAL useCurrentDir
      LOGICAL lAdInit
      INTEGER myOptimIter
      INTEGER myThid
      _RL     dummy

C     !LOCAL VARIABLES:
CEOP

      IF ( arrShape.EQ.'XY' ) THEN

        CALL ACTIVE_READ_3D_RL(
     &                 activeVar_file, active_var, globalFile,
     &                 useCurrentDir, lAdInit, iRec, myNr,
     &                 FORWARD_SIMULATION, myOptimIter, myThid )

      ELSEIF ( arrShape.EQ.'XZ' ) THEN

        CALL ACTIVE_READ_XZ_RL(
     &                 activeVar_file, active_var, globalFile,
     &                 useCurrentDir, lAdInit, iRec, myNr,
     &                 FORWARD_SIMULATION, myOptimIter, myThid )

      ELSEIF ( arrShape.EQ.'YZ' ) THEN

        CALL ACTIVE_READ_YZ_RL(
     &                 activeVar_file, active_var, globalFile,
     &                 useCurrentDir, lAdInit, iRec, myNr,
     &                 FORWARD_SIMULATION, myOptimIter, myThid )

      ELSE
        STOP
     &   'ABNORMAL END: S/R ACTIVE_READ_GEN_RL: invalid arrShape'
      ENDIF

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: ACTIVE_READ_GEN_RS
C     !INTERFACE:
      SUBROUTINE ACTIVE_READ_GEN_RS(
     I                               activeVar_file,
     O                               active_var,
     I                               arrShape, myNr,
     I                               iRec,
     I                               globalFile,
     I                               useCurrentDir,
     I                               lAdInit,
     I                               myOptimIter,
     I                               myThid,
     I                               dummy )

C     !DESCRIPTION: \bv
C     ==================================================================
C     SUBROUTINE ACTIVE_READ_GEN_RS
C     ==================================================================
C     o Read an active (_RS) variable from file (generic version).
C     Accept active variable of various (XY,XZ,YZ) shape and level
C     number, according to arguments arrShape and myNr.
C     ==================================================================
C     \ev

C     !USES:
      IMPLICIT NONE

C     == global variables ==
#include "EEPARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     activeVar_file :: filename
C     active_var     :: active variable array
C     arrShape       :: shape of active-var array ('XY','XZ' or 'YZ')
C     myNr           :: number of vertical-levels in active-var array
C     iRec           :: record number in file
C     globalFile     :: used for writing global (if =T) or tiled files
C     useCurrentDir  :: always read from the current directory
C                        (even if "mdsioLocalDir" is set)
C     lAdInit        :: initialisation of corresponding adjoint variable
C                        and write to active file
C     myOptimIter    :: number of optimization iteration (default: 0)
C     myThid         :: my Thread Id number
C     dummy          :: (needed for 2nd derivative code)
      CHARACTER*(*) activeVar_file
      _RS     active_var(*)
      CHARACTER*(2) arrShape
      INTEGER myNr
      INTEGER iRec
      LOGICAL globalFile
      LOGICAL useCurrentDir
      LOGICAL lAdInit
      INTEGER myOptimIter
      INTEGER myThid
      _RS     dummy

C     !LOCAL VARIABLES:
CEOP

      IF ( arrShape.EQ.'XY' ) THEN

        CALL ACTIVE_READ_3D_RS(
     &                 activeVar_file, active_var, globalFile,
     &                 useCurrentDir, lAdInit, iRec, myNr,
     &                 FORWARD_SIMULATION, myOptimIter, myThid )

      ELSEIF ( arrShape.EQ.'XZ' ) THEN

        CALL ACTIVE_READ_XZ_RS(
     &                 activeVar_file, active_var, globalFile,
     &                 useCurrentDir, lAdInit, iRec, myNr,
     &                 FORWARD_SIMULATION, myOptimIter, myThid )

      ELSEIF ( arrShape.EQ.'YZ' ) THEN

        CALL ACTIVE_READ_YZ_RS(
     &                 activeVar_file, active_var, globalFile,
     &                 useCurrentDir, lAdInit, iRec, myNr,
     &                 FORWARD_SIMULATION, myOptimIter, myThid )

      ELSE
        STOP
     &   'ABNORMAL END: S/R ACTIVE_READ_GEN_RS: invalid arrShape'
      ENDIF

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: ACTIVE_WRITE_GEN_RL
C     !INTERFACE:
      SUBROUTINE ACTIVE_WRITE_GEN_RL(
     I                               activeVar_file,
     I                               active_var,
     I                               arrShape, myNr,
     I                               iRec,
     I                               useCurrentDir,
     I                               myOptimIter,
     I                               myThid,
     I                               dummy )

C     !DESCRIPTION: \bv
C     ==================================================================
C     SUBROUTINE ACTIVE_WRITE_GEN_RL
C     ==================================================================
C     o Write an active (_RL) variable from file (generic version).
C     Accept active variable of various (XY,XZ,YZ) shape and level
C     number, according to arguments arrShape and myNr.
C     ==================================================================
C     \ev

C     !USES:
      IMPLICIT NONE

C     == global variables ==
#include "EEPARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     activeVar_file :: filename
C     active_var     :: active variable array
C     arrShape       :: shape of active-var array ('XY','XZ' or 'YZ')
C     myNr           :: number of vertical-levels in active-var array
C     iRec           :: record number in file
C     useCurrentDir  :: always write to the current directory
C                        (even if "mdsioLocalDir" is set)
C     myOptimIter    :: number of optimization iteration (default: 0)
C     myThid         :: my Thread Id number
C     dummy          :: (needed for 2nd derivative code)
      CHARACTER*(*) activeVar_file
      _RL     active_var(*)
      CHARACTER*(2) arrShape
      INTEGER myNr
      INTEGER iRec
      LOGICAL useCurrentDir
      INTEGER myOptimIter
      INTEGER myThid
      _RL     dummy

C     !LOCAL VARIABLES:
C     globalFile     :: used for writing global (if =T) or tiled files
      LOGICAL globalFile
CEOP

      globalFile = .FALSE.
      IF ( arrShape.EQ.'XY' ) THEN

        CALL ACTIVE_WRITE_3D_RL(
     &                 activeVar_file, active_var, globalFile,
     &                 useCurrentDir, iRec, myNr,
     &                 FORWARD_SIMULATION, myOptimIter, myThid )

      ELSEIF ( arrShape.EQ.'XZ' ) THEN

        CALL ACTIVE_WRITE_XZ_RL(
     &                 activeVar_file, active_var, globalFile,
     &                 useCurrentDir, iRec, myNr,
     &                 FORWARD_SIMULATION, myOptimIter, myThid )

      ELSEIF ( arrShape.EQ.'YZ' ) THEN

        CALL ACTIVE_WRITE_YZ_RL(
     &                 activeVar_file, active_var, globalFile,
     &                 useCurrentDir, iRec, myNr,
     &                 FORWARD_SIMULATION, myOptimIter, myThid )

      ELSE
        STOP
     &   'ABNORMAL END: S/R ACTIVE_WRITE_GEN_RL: invalid arrShape'
      ENDIF

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: ACTIVE_WRITE_GEN_RS
C     !INTERFACE:
      SUBROUTINE ACTIVE_WRITE_GEN_RS(
     I                               activeVar_file,
     I                               active_var,
     I                               arrShape, myNr,
     I                               iRec,
     I                               useCurrentDir,
     I                               myOptimIter,
     I                               myThid,
     I                               dummy )

C     !DESCRIPTION: \bv
C     ==================================================================
C     SUBROUTINE ACTIVE_WRITE_GEN_RS
C     ==================================================================
C     o Write an active (_RS) variable from file (generic version).
C     Accept active variable of various (XY,XZ,YZ) shape and level
C     number, according to arguments arrShape and myNr.
C     ==================================================================
C     \ev

C     !USES:
      IMPLICIT NONE

C     == global variables ==
#include "EEPARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     activeVar_file :: filename
C     active_var     :: active variable array
C     arrShape       :: shape of active-var array ('XY','XZ' or 'YZ')
C     myNr           :: number of vertical-levels in active-var array
C     iRec           :: record number in file
C     useCurrentDir  :: always write to the current directory
C                        (even if "mdsioLocalDir" is set)
C     myOptimIter    :: number of optimization iteration (default: 0)
C     myThid         :: my Thread Id number
C     dummy          :: (needed for 2nd derivative code)
      CHARACTER*(*) activeVar_file
      _RS     active_var(*)
      CHARACTER*(2) arrShape
      INTEGER myNr
      INTEGER iRec
      LOGICAL useCurrentDir
      INTEGER myOptimIter
      INTEGER myThid
      _RS     dummy

C     !LOCAL VARIABLES:
C     globalFile     :: used for writing global (if =T) or tiled files
      LOGICAL globalFile
CEOP

      globalFile = .FALSE.
      IF ( arrShape.EQ.'XY' ) THEN

        CALL ACTIVE_WRITE_3D_RS(
     &                 activeVar_file, active_var, globalFile,
     &                 useCurrentDir, iRec, myNr,
     &                 FORWARD_SIMULATION, myOptimIter, myThid )

      ELSEIF ( arrShape.EQ.'XZ' ) THEN

        CALL ACTIVE_WRITE_XZ_RS(
     &                 activeVar_file, active_var, globalFile,
     &                 useCurrentDir, iRec, myNr,
     &                 FORWARD_SIMULATION, myOptimIter, myThid )

      ELSEIF ( arrShape.EQ.'YZ' ) THEN

        CALL ACTIVE_WRITE_YZ_RS(
     &                 activeVar_file, active_var, globalFile,
     &                 useCurrentDir, iRec, myNr,
     &                 FORWARD_SIMULATION, myOptimIter, myThid )

      ELSE
        STOP
     &   'ABNORMAL END: S/R ACTIVE_WRITE_GEN_RS: invalid arrShape'
      ENDIF

      RETURN
      END

#include "RUNCLOCK_OPTIONS.h"

CBOP
C     !ROUTINE: RUNCLOCK_INIT
C     !INTERFACE:
      SUBROUTINE RUNCLOCK_INIT( myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE RUNCLOCK_INIT
C     | o Routine to initialize RUNCLOCK variables
C     *==========================================================*
C     \ev
C     !USES:
      IMPLICIT NONE

C     === Global variables ===
#include "EEPARAMS.h"
#include "RUNCLOCK.h"

C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
C     myThid ::  my Thread Id number
      INTEGER myThid
CEOP

#ifdef ALLOW_RUNCLOCK

C     !LOCAL VARIABLES:
C     === Local variables ===
      CHARACTER*(MAX_LEN_MBUF) msgBuf

      IF (.NOT.RUNCLOCKIsOn) THEN
       WRITE(msgBuf,'(A)') ' RUNCLOCK_INIT: RUNCLOCK not turned on'
       CALL PRINT_ERROR( msgBuf, myThid ) 
      ENDIF


C     Record the wall-clock time
      CALL runclock_gettime(
     &   RC_start_yr,RC_start_mo,RC_start_dy,
     &   RC_start_hr,RC_start_mi,RC_start_sc,
     &   RC_start_tins)

      CALL GLOBAL_MAX_R8(RC_start_tins,myThid)

      RC_prev_tins=RC_start_tins

c     write(0,*) 'RUNCLOCK_INIT: yr mo dy hr mi sc', 
c    &   RC_start_yr,RC_start_mo,RC_start_dy,
c    &   RC_start_hr,RC_start_mi,RC_start_sc,RC_start_tins

#endif /* ALLOW_RUNCLOCK */

      RETURN
      END

#include "STREAMICE_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

CBOP
      SUBROUTINE STREAMICE_INITIALIZE_PETSC
C     *============================================================*
C     | SUBROUTINE                                                 |
C     | o                                                          |
C     *============================================================*

C     === Global variables ===
#ifdef ALLOW_PETSC
#ifdef STREAMICE_PETSC_3_8

C     THE FOLLOWING MODULE AND HEADER FILE ARE PART OF THE PETSC
C     LIBRARY, USED BY STREAMICE WHEN AVAILABLE TO ACCELERATE
C     SOLVES OF LINEAR SYSTEMS

#include "petsc/finclude/petsc.h"
#include "petsc/finclude/petscvec.h"
      use petscvec
      IMPLICIT NONE
#else
      IMPLICIT NONE
#include "finclude/petsc.h"
#endif
#endif

C     !INPUT/OUTPUT ARGUMENTS
c     INTEGER myThid

#ifdef ALLOW_STREAMICE

#ifdef ALLOW_PETSC
      PetscErrorCode ierr
      call petscInitialize(PETSC_NULL_CHARACTER,ierr)
#endif

#endif
      RETURN
      END

#include "CPP_EEOPTIONS.h"

C--   File utils.F: General purpose support routines
C--    Contents
C-- U DATE            - Returns date and time.
C--   IFNBLNK         - Returns index of first non-blank string character.
C--   ILNBLNK         - Returns index of last non-blank string character.
C--   IO_ERRCOUNT     - Reads IO error counter.
C--   LCASE           - Translates to lower case.
C--UM MACHINE         - Returns character string identifying computer.
C--   UCASE           - Translates to upper case.
C--   Routines marked "M" contain specific machine dependent code.
C--   Routines marked "U" contain UNIX OS calls.

CStartOfInterface
      SUBROUTINE DATE ( string , myThreadId )
C     /==========================================================\
C     | SUBROUTINE DATE                                          |
C     | o Return current date                                    |
C     \==========================================================/
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
C
      CHARACTER*(*) string
      INTEGER myThreadId
CEndOfInterface
C
      INTEGER lDate
      CHARACTER*(MAX_LEN_MBUF) msgBuffer
C
      lDate = 24
      IF ( LEN(string) .LT. lDate ) GOTO 901
      string = ' '
#ifdef HAVE_FDATE
      CALL FDATE( string )
#endif
C   
 1000 CONTINUE
      RETURN
  901 CONTINUE
      WRITE(msgBuffer,'(A)')
     &'                                                       '
      CALL PRINT_MESSAGE(msgBuffer,standardMessageUnit,
     &SQUEEZE_RIGHT,myThreadId)
      WRITE(msgBuffer,'(A)')
     &'*** WARNING WARNING WARNING WARNING WARNING WARNING ***'
      CALL PRINT_MESSAGE(msgBuffer,standardMessageUnit,
     &SQUEEZE_RIGHT,myThreadId)
      WRITE(msgBuffer,'(A)')
     &'procedure: "DATE".'
      CALL PRINT_MESSAGE(msgBuffer,standardMessageUnit,
     &SQUEEZE_RIGHT,myThreadId)
      WRITE(msgBuffer,'(A)')
     &'Variable passed to S/R DATE is too small.'
      CALL PRINT_MESSAGE(msgBuffer,standardMessageUnit,
     &SQUEEZE_RIGHT,myThreadId)
      WRITE(msgBuffer,'(A)')
     &' Argument must be at least',lDate,'characters long.'
      CALL PRINT_MESSAGE(msgBuffer,standardMessageUnit,
     &SQUEEZE_RIGHT,myThreadId)
      WRITE(msgBuffer,'(A)')
     &'*******************************************************'
      CALL PRINT_MESSAGE(msgBuffer,standardMessageUnit,
     &SQUEEZE_RIGHT,myThreadId)
      GOTO 1000
      END

CStartOfInterface
      INTEGER FUNCTION IFNBLNK( string )
C     /==========================================================\
C     | FUNCTION IFNBLNK                                         |
C     | o Find first non-blank in character string.              |
C     \==========================================================/
      IMPLICIT NONE
C
      CHARACTER*(*) string
CEndOfInterface
C
      INTEGER L, LS
C
      LS     = LEN(string)
      IFNBLNK = 0
      DO 10 L = 1, LS
       IF ( string(L:L) .EQ. ' ' ) GOTO 10
        IFNBLNK = L
        GOTO 11
   10 CONTINUE
   11 CONTINUE
C
      RETURN
      END

CStartOfInterface
      INTEGER FUNCTION ILNBLNK( string )
C     /==========================================================\
C     | FUNCTION ILNBLNK                                         |
C     | o Find last non-blank in character string.               |
C     \==========================================================/
      IMPLICIT NONE
      CHARACTER*(*) string
CEndOfInterface
      INTEGER L, LS
C
      LS      = LEN(string)
      ILNBLNK = LS
      DO 10 L = LS, 1, -1
        IF ( string(L:L) .EQ. ' ' ) GOTO 10
         ILNBLNK = L
         GOTO 11
   10 CONTINUE
   11 CONTINUE
C
      RETURN
      END

CStartofinterface
      INTEGER FUNCTION IO_ERRCOUNT(myThid)
C     /==========================================================\
C     | FUNCTION IO_ERRCOUNT                                     |
C     | o Reads IO error counter.                                |
C     \==========================================================/
      IMPLICIT NONE
C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"

C     == Routine arguments ==
      INTEGER myThid
CEndofinterface

      IO_ERRCOUNT = ioErrorCount(myThid)

      RETURN
      END

CStartOfInterface
      SUBROUTINE LCASE ( string )
C     /==========================================================\
C     | SUBROUTINE LCASE                                         |
C     | o Convert character string to all lower case.            |
C     \==========================================================/
      IMPLICIT NONE
      CHARACTER*(*) string
CEndOfInterface
      CHARACTER*26  LOWER
      DATA LOWER /'abcdefghijklmnopqrstuvwxyz'/
      SAVE LOWER
      CHARACTER*26  UPPER
      DATA UPPER /'ABCDEFGHIJKLMNOPQRSTUVWXYZ'/
      SAVE UPPER
      INTEGER   I, L
C
      DO 10 I = 1, LEN(string)
        L = INDEX(UPPER,string(I:I))
        IF ( L .EQ. 0 ) GOTO 10
         string(I:I) = LOWER(L:L)
   10 CONTINUE
C   
      RETURN
      END

CStartOfInterface
      SUBROUTINE MACHINE ( string )
C     /==========================================================\
C     | SUBROUTINE MACHINE                                       |
C     | o Return computer identifier in string.                  |
C     \==========================================================/
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
      CHARACTER*(*) string
CEndOfInterface
C
      INTEGER  IFNBLNK
      INTEGER  ILNBLNK
      EXTERNAL IFNBLNK
      EXTERNAL ILNBLNK
C
      INTEGER  iFirst
      INTEGER  iLast 
      INTEGER  iEnd  
      INTEGER  iFree
      INTEGER  idSize
      CHARACTER*1024 strTmp
      CHARACTER*1024 idString

      strTmp = 'UNKNOWN'
      iFree  = 1
      idSize = LEN(string)
#if (defined (TARGET_T3E) || defined (TARGET_CRAY_VECTOR))
      IFirst = 0
      CALL PXFGETENV('USER',iFirst,strTmp,ILast,Iend  )
#else
      CALL GETENV('USER',strTmp  )
#endif
      IF ( strTmp .NE. ' ' ) THEN
        iFirst = IFNBLNK(strTmp)
        iLast  = ILNBLNK(strTmp)
        iEnd   = iLast-iFirst+1
        IF (iEnd .GE. 0 ) THEN
         idString(iFree:) = strTmp(iFirst:iFirst+iEnd)
        ENDIF
        iFree = iFree+iEnd+1
        IF ( iFree .LE. idSize ) THEN
          idString(iFree:iFree) = '@'
          iFree = iFree+1
        ENDIF
      ENDIF
      strTmp = 'UNKNOWN'
#if (defined (TARGET_T3E) || defined (TARGET_CRAY_VECTOR))
      IFirst = 0
      CALL PXFGETENV('HOST',iFirst,strTmp,ILast,Iend  )
#else
      CALL GETENV('HOST',strTmp  )
#endif
      IF ( strTmp .NE. ' ' ) THEN
        iFirst = IFNBLNK(strTmp)
        iLast  = ILNBLNK(strTmp)
        iEnd   = iLast-iFirst+1
        iEnd   = MIN(iEnd,idSize-iFree)
        iEnd   = iEnd-1
        IF (iEnd .GE. 0 ) THEN
          idString(iFree:) = strTmp(iFirst:iFirst+iEnd)
        ENDIF
        iFree = iFree+iEnd+1
      ENDIF
C
      string = idString
C
 1000 CONTINUE
      RETURN
      END
C***********************************************************************
      SUBROUTINE UCASE ( string )
      IMPLICIT NONE
C     Translate string to upper case.
      CHARACTER*(*) string
      CHARACTER*26  LOWER
      DATA LOWER /'abcdefghijklmnopqrstuvwxyz'/
      SAVE LOWER
      CHARACTER*26  UPPER
      DATA UPPER /'ABCDEFGHIJKLMNOPQRSTUVWXYZ'/
      SAVE UPPER
      INTEGER   I, L
C
      DO 10 I = 1, LEN(string)
        L = INDEX(LOWER,string(I:I))
        IF ( L .EQ. 0 ) GOTO 10
          string(I:I) = UPPER(L:L)
   10 CONTINUE
C   
      RETURN
      END
C************************************************************************

      subroutine instore( n, fc, gnorm0, is, m, jmin, jmax,
     &                    cold, ifail )
c
c         arguments
c
      integer n, is, m, jmin, jmax, ifail
      double precision    fc, gnorm0
      logical cold
      integer*8 rectmp, tmp1, tmp2
c----
c
      common /xxstore/ itape, ntape, isize
      integer itape, ntape, isize

      ifail = 0
      itape = 91
      ntape = 92
      isize = is
      cold  = .true.

      print *, 'pathei: in instore '

cc one record = two arrays of real*(isize)

      open(  itape
     $    , file   = 'OPWARMI'
     $    , status = 'unknown'
     $    , form   = 'formatted'
     $    , access = 'sequential'
     $    )

      read( itape, *, end=800, err=900 ) n, fc, gnorm0,
     $                                   isize, m, jmin, jmax
      cold  = .false.

 800  continue
      close(itape)

      print*
      write(*,'(a,i10,a,i2)')
     $        '  opening direct access with recl = ',n,' * ',isize
      print*

      tmp1 = n
      tmp2 = isize
      rectmp = tmp1*tmp2
cph(
      print *, 'pathei rectmp ', rectmp, n, isize
cph)

      open( ntape
     $    , file   = 'OPWARMD'
     $    , status = 'unknown'
     $    , form   = 'unformatted'
     $    , access = 'direct'
     $    , recl   = rectmp
     $    )

      return

 900  continue
      close(itape)
      ifail = 1

      return
      end

#include "PACKAGES_CONFIG.h"
#include "CPP_OPTIONS.h"
#ifdef ALLOW_AUTODIFF
# include "AUTODIFF_OPTIONS.h"
#endif
#ifdef ALLOW_CTRL
# include "CTRL_OPTIONS.h"
#endif
#ifdef ALLOW_ECCO
# include "ECCO_OPTIONS.h"
#endif
#ifdef ALLOW_TAPENADE
# ifdef ALLOW_GMREDI
#  include "GMREDI_OPTIONS.h"
# endif
#endif /* ALLOW_TAPENADE */

CBOP
C     !ROUTINE: PACKAGES_INIT_VARIABLES
C     !INTERFACE:
      SUBROUTINE PACKAGES_INIT_VARIABLES( myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE PACKAGES_INIT_VARIABLES
C     | o Does initialisation of package-related variable data
C     *==========================================================*
C     \ev

C     !CALLING SEQUENCE:
C     PACKAGES_INIT_VARIABLES
C       |
C       |-- DIAGNOSTICS_INIT_VARIA
C       |
C       |-- OFFLINE_INIT_VARIA
C       |
C       |-- GAD_INIT_VARIA
C       |
C       |-- CD_CODE_INI_VARS
C       |
C       |-- PP81_INIT_VARIA
C       |
C       |-- KL10_INIT_VARIA
C       |
C       |-- MY82_INIT_VARIA
C       |
C       |-- GGL90_INIT_VARIA
C       |
C       |-- KPP_INIT_VARIA
C       |
C       |-- GMREDI_INIT_VARIA
C       |
C       |-- BBL_INIT_VARIA
C       |
C       |-- DWNSLP_INIT_VARIA
C       |
C       |-- EXF_INIT_VARIA
C       |
C       |-- BULKF_INIT_VARIA
C       |
C       |-- EBM_INI_VARS
C       |
C       |-- CHEAPAML_INIT_VARIA
C       |
C       |-- FLT_INIT_VARIA
C       |
C       |-- PTRACERS_INIT_VARIA
C       |
C       |-- LONGSTEP_INIT_VARIA
C       |
C       |-- GCHEM_INIT_VARI
C       |
C       |-- RBCS_INIT_VARIA
C       |
C       |-- MATRIX_INIT_VARIA
C       |
C       |-- STREAMICE_INIT_VARIA
C       |
C       |-- SHELFICE_INIT_VARIA
C       |
C       |-- STIC_INIT_VARIA
C       |
C       |-- ICEFRONT_INIT_VARIA
C       |
C       |-- FRAZIL_INIT_VARIA
C       |
C       |-- SEAICE_INIT_VARIA
C       |
C       |-- SALT_PLUME_INIT_VARIA
C       |
C       |-- THSICE_INI_VARS
C       |
C       |-- LAND_INI_VARS
C       |
C       |-- ATM2D_INIT_VARS
C       |
C       |-- ATM_PHYS_INIT_VARIA
C       |
C       |-- FIZHI_INI_VARS
C       |
C       |-- REGRID_INIT_VARIA
C       |
C       |-- LAYERS_INIT_VARIA
C       |
C       |-- NEST_CHILD_INIT_VARIA
C       |-- NEST_PARENT_INIT_VARIA
C       |
C       |-- NEST2W_INIT_VARIA
C       |
C       |-- CPL_INI_VARS
C       |
C       |-- MYPACKAGE_INIT_VARIA
C       |
C       |-- SMOOTH_INIT_VARIA
C       |-- PROFILES_INIT_VARIA
C       |-- OBSFIT_INIT_VARIA
C       |-- ECCO_INIT_VARIA
C       |-- CTRL_INIT_VARIABLES
C       |
C       |-- OBCS_INIT_VARIABLES

C     !USES:
      IMPLICIT NONE
C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#ifdef ALLOW_AUTODIFF
# include "FFIELDS.h"
# include "DYNVARS.h"
# ifdef ALLOW_SEAICE
#  include "SEAICE_SIZE.h"
#  include "SEAICE.h"
# endif
#endif /* ALLOW_AUTODIFF */

#ifdef ALLOW_TAPENADE
# ifdef ALLOW_GMREDI
#  include "GMREDI.h"
# endif
# ifdef ALLOW_CTRL
#  include "CTRL_SIZE.h"
#  include "CTRL.h"
#  include "CTRL_GENARR.h"
#  include "CTRL_DUMMY.h"
# endif
# ifdef ALLOW_PTRACERS
#  include "PTRACERS_SIZE.h"
#  include "PTRACERS_FIELDS.h"
# endif
# ifdef ALLOW_SHELFICE
#  include "SHELFICE.h"
# endif
# ifdef ALLOW_STEEP_ICECAVITY
#  include "STIC.h"
# endif
# ifdef ALLOW_STREAMICE
#  include "STREAMICE.h"
# endif
#endif /* ALLOW_TAPENADE */

C     !INPUT/OUTPUT PARAMETERS:
C     myThid  :: my Thread Id number
      INTEGER myThid
CEOP

#ifdef ALLOW_DEBUG
      IF (debugMode)
     &     CALL DEBUG_ENTER('PACKAGES_INIT_VARIABLES',myThid)
#endif /* ALLOW_DEBUG */

#ifdef ALLOW_DIAGNOSTICS
      IF ( useDiagnostics ) THEN
        CALL DIAGNOSTICS_INIT_VARIA( myThid )
      ENDIF
#endif /* ALLOW_DIAGNOSTICS */

#ifdef ALLOW_OFFLINE
C--   Here we call OFFLINE_INIT_VARIA (which calls OFFLINE_FIELDS_LOAD)
C     before other {PKG}_init_varia, closer to where main pickup-file
C     are usually read-in (but skipped when using pkg/offline)
# ifndef ALLOW_AUTODIFF
      IF ( useOFFLINE ) THEN
# endif
        CALL OFFLINE_INIT_VARIA( myThid )
# ifndef ALLOW_AUTODIFF
      ENDIF
# endif
#endif /* ALLOW_OFFLINE */

#ifdef ALLOW_GENERIC_ADVDIFF
      IF ( useGAD ) THEN
# ifdef ALLOW_DEBUG
        IF (debugMode) CALL DEBUG_CALL('GAD_INIT_VARIA',myThid)
# endif
        CALL GAD_INIT_VARIA( myThid )
      ENDIF
#endif /* ALLOW_GENERIC_ADVDIFF */

#ifdef ALLOW_CD_CODE
C--   Initialize CD_CODE variables:
C- note(jmc): before packaging CD_CODE, was done within ini_fields (=called before),
C             therefore call CD-ini-vars before others pkg.
      IF (useCDscheme) THEN
# ifdef ALLOW_DEBUG
        IF (debugMode) CALL DEBUG_CALL('CD_CODE_INI_VARS',myThid)
# endif
        CALL CD_CODE_INI_VARS( myThid )
      ENDIF
#endif /* ALLOW_CD_CODE */

#ifdef ALLOW_PP81
C--   Initialize PP81 vertical mixing scheme.
      IF (usePP81) THEN
# ifdef ALLOW_DEBUG
       IF (debugMode) CALL DEBUG_CALL('PP81_INIT_VARIA',myThid)
# endif
       CALL PP81_INIT_VARIA( myThid )
      ENDIF
#endif /* ALLOW_PP81 */

#ifdef ALLOW_KL10
C--   Initialize KL10 vertical mixing scheme.
      IF (useKL10) THEN
# ifdef ALLOW_DEBUG
       IF (debugMode) CALL DEBUG_CALL('KL10_INIT_VARIA',myThid)
# endif
       CALL KL10_INIT_VARIA( myThid )
      ENDIF
#endif /* ALLOW_KL10 */

#ifdef ALLOW_MY82
C--   Initialize MY82 vertical mixing scheme.
      IF (useMY82) THEN
       CALL MY82_INIT_VARIA( myThid )
      ENDIF
#endif /* ALLOW_MY82 */

#ifdef ALLOW_GGL90
C--   Initialize GGL90 vertical mixing scheme.
      IF (useGGL90) THEN
#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_CALL('GGL90_INIT_VARIA',myThid)
#endif
       CALL GGL90_INIT_VARIA( myThid )
      ENDIF
#endif /* ALLOW_GGL90 */

#ifdef ALLOW_KPP
C--   Initialize KPP vertical mixing scheme.
      IF (useKPP) THEN
# ifdef ALLOW_DEBUG
       IF (debugMode) CALL DEBUG_CALL('KPP_INIT_VARIA',myThid)
# endif
       CALL KPP_INIT_VARIA( myThid )
      ENDIF
#endif /* ALLOW_KPP */

#ifdef ALLOW_GMREDI
C--   Initialize GM/Redi parameterization
# ifdef ALLOW_AUTODIFF
C- Note: To simplify dependency & avoid recomputations, when compiling
C        pkg/autodiff, we always call GMREDI_INIT_VARIA to initialise control
C        variables (ALLOW_KAPGM/KAPREDI_CONTROL) without condition on useGMRedi
C        (in this case the "If useGMRedi" is added inside gmredi_init_varia.F).
# else
      IF ( useGMRedi ) THEN
# endif
# ifdef ALLOW_DEBUG
        IF (debugMode) CALL DEBUG_CALL('GMREDI_INIT_VARIA',myThid)
# endif
        CALL GMREDI_INIT_VARIA( myThid )
# ifndef ALLOW_AUTODIFF
      ENDIF
# endif
#endif /* ALLOW_GMREDI */

#ifdef ALLOW_BBL
      IF ( useBBL ) THEN
        CALL BBL_INIT_VARIA( myThid )
      ENDIF
#endif /* ALLOW_BBL */

#ifdef ALLOW_DOWN_SLOPE
      IF ( useDOWN_SLOPE ) THEN
        CALL DWNSLP_INIT_VARIA( myThid )
      ENDIF
#endif /* ALLOW_DOWN_SLOPE */

#ifdef ALLOW_EXF
      IF (useEXF) THEN
# ifdef ALLOW_DEBUG
       IF (debugMode) CALL DEBUG_CALL('EXF_INIT_VARIA',myThid)
# endif
       CALL EXF_INIT_VARIA( myThid )
      ENDIF
#endif /* ALLOW_EXF */

#ifdef ALLOW_BULK_FORCE
      IF (useBulkForce) THEN
        CALL BULKF_INIT_VARIA( myThid )
      ENDIF
#endif /* ALLOW_BULK_FORCE */

#ifdef ALLOW_EBM
# ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE theta = tapelev_init, key = 1
# endif
      IF (useEBM) THEN
        CALL EBM_INI_VARS( myThid )
      ENDIF
#endif /* ALLOW_EBM */

#ifdef ALLOW_CHEAPAML
      IF (useCheapAML) THEN
        CALL CHEAPAML_INIT_VARIA( myThid )
      ENDIF
#endif /* ALLOW_CHEAPAML */

#ifdef ALLOW_FLT
C--   Initialise float position
      IF ( useFLT ) THEN
        CALL FLT_INIT_VARIA( myThid )
      ENDIF
#endif /* ALLOW_FLT */

#ifdef ALLOW_PTRACERS
# ifndef ALLOW_AUTODIFF
      IF ( usePTRACERS ) THEN
# endif
# ifdef ALLOW_DEBUG
        IF (debugMode) CALL DEBUG_CALL('PTRACERS_INIT_VARIA',myThid)
# endif
        CALL PTRACERS_INIT_VARIA( myThid )
# ifdef ALLOW_LONGSTEP
#  ifdef ALLOW_DEBUG
        IF (debugMode) CALL DEBUG_CALL('LONGSTEP_INIT_VARIA',myThid)
#  endif
        CALL LONGSTEP_INIT_VARIA( myThid )
# endif /* ALLOW_LONGSTEP */
# ifndef ALLOW_AUTODIFF
      ENDIF
# endif
#endif /* ALLOW_PTRACERS */

#ifdef ALLOW_GCHEM
      IF (useGCHEM) THEN
        CALL GCHEM_INIT_VARI( myThid )
      ENDIF
#endif /* ALLOW_GCHEM */

#ifdef ALLOW_RBCS
      IF ( useRBCS ) THEN
        CALL RBCS_INIT_VARIA( myThid )
      ENDIF
#endif /* ALLOW_RBCS */

#ifdef ALLOW_MATRIX
      IF ( useMATRIX ) THEN
# ifdef ALLOW_DEBUG
        IF (debugMode) CALL DEBUG_CALL('MATRIX_INIT',myThid)
# endif
        CALL MATRIX_INIT_VARIA( myThid )
      ENDIF
#endif /* ALLOW_MATRIX */

#ifdef ALLOW_STREAMICE
      IF (useStreamIce) THEN
# ifdef ALLOW_DEBUG
       IF (debugMode) CALL DEBUG_CALL('STREAMICE_INIT_VARIA',myThid)
# endif
       CALL STREAMICE_INIT_VARIA( myThid )
      ENDIF
#endif /* ALLOW_STREAMICE */

#ifdef ALLOW_SHELFICE
# ifdef ALLOW_AUTODIFF
C- Note: use same trick as for pkg/gmredi (call to GMREDI_INIT_VARIA) when
C  compiling pkg/autodiff (with "If useShelfIce" inside shelfice_init_varia.F)
# else
      IF (useShelfIce) THEN
# endif
# ifdef ALLOW_DEBUG
       IF (debugMode) CALL DEBUG_CALL('SHELFICE_INIT_VARIA',myThid)
# endif
       CALL SHELFICE_INIT_VARIA( myThid )
# ifndef ALLOW_AUTODIFF
      ENDIF
# endif
#endif /* ALLOW_SHELFICE */

#ifdef ALLOW_STEEP_ICECAVITY
# ifdef ALLOW_AUTODIFF
C- Note: use same trick as for pkg/gmredi (call to GMREDI_INIT_VARIA) when
C  compiling pkg/autodiff (with IF-statements inside stic_init_varia.F)
# else
      IF (useSTIC) THEN
# endif
# ifdef ALLOW_DEBUG
       IF (debugMode) CALL DEBUG_CALL('STIC_INIT_VARIA',myThid)
# endif
       CALL STIC_INIT_VARIA( myThid )
# ifndef ALLOW_AUTODIFF
      ENDIF
# endif
#endif /* ALLOW_STEEP_ICECAVITY */

#ifdef ALLOW_ICEFRONT
      IF (useICEFRONT) THEN
# ifdef ALLOW_DEBUG
       IF (debugMode) CALL DEBUG_CALL('ICEFRONT_INIT_VARIA',myThid)
# endif
       CALL ICEFRONT_INIT_VARIA( myThid )
      ENDIF
#endif /* ALLOW_ICEFRONT */

#ifdef ALLOW_FRAZIL
      IF (useFRAZIL) THEN
# ifdef ALLOW_DEBUG
        IF (debugMode) CALL DEBUG_CALL('FRAZIL_INIT_VARIA',myThid)
# endif
        CALL FRAZIL_INIT_VARIA( myThid)
      ENDIF
#endif /* ALLOW_FRAZIL */

#ifdef ALLOW_SEAICE
C--   Initialize SEAICE model.
# ifdef ALLOW_AUTODIFF
C- Note: use same trick as for pkg/gmredi (call to GMREDI_INIT_VARIA) when
C     compiling pkg/autodiff (with "If useSEAICE" inside seaice_init_varia.F)
# else
      IF (useSEAICE) THEN
# endif
# ifdef ALLOW_DEBUG
       IF (debugMode) CALL DEBUG_CALL('SEAICE_INIT_VARIA',myThid)
# endif
       CALL SEAICE_INIT_VARIA( myThid )
# ifndef ALLOW_AUTODIFF
      ENDIF
# endif
#endif /* ALLOW_SEAICE */

#ifdef ALLOW_SALT_PLUME
      IF ( useSALT_PLUME ) THEN
        CALL SALT_PLUME_INIT_VARIA( myThid )
      ENDIF
#endif /* ALLOW_SALT_PLUME */

#ifdef ALLOW_THSICE
      IF (useThSIce) THEN
# ifdef ALLOW_DEBUG
        IF (debugMode) CALL DEBUG_CALL('THSICE_INI_VARS',myThid)
# endif
        CALL THSICE_INI_VARS( myThid)
      ENDIF
#endif /* ALLOW_THSICE */

#ifdef ALLOW_LAND
      IF ( useLAND ) THEN
# ifdef ALLOW_DEBUG
        IF (debugMode) CALL DEBUG_CALL('LAND_INI_VARS',myThid)
# endif
        CALL LAND_INI_VARS( myThid )
      ENDIF
#endif /* ALLOW_LAND */

#ifdef ALLOW_ATM2D
      IF (useAtm2d) THEN
# ifdef ALLOW_DEBUG
        IF (debugMode) CALL DEBUG_CALL('ATM2D_INIT_VARS',myThid)
# endif
        CALL ATM2D_INIT_VARS( myThid )
      ENDIF
#endif /* ALLOW_ATM2D */

#ifdef ALLOW_ATM_PHYS
      IF (useAtm_Phys) THEN
# ifdef ALLOW_DEBUG
        IF (debugMode) CALL DEBUG_CALL('ATM_PHYS_INIT_VARIA',myThid)
# endif
        CALL ATM_PHYS_INIT_VARIA( myThid )
      ENDIF
#endif /* ALLOW_ATM_PHYS */

#ifdef ALLOW_FIZHI
C Initialize FIZHI state variables
      IF (useFIZHI) THEN
# ifdef ALLOW_DEBUG
        IF (debugMode) CALL DEBUG_CALL('FIZHI_INIT_VARS',myThid)
# endif
        CALL FIZHI_INIT_VARS( myThid )
      ENDIF
#endif /* ALLOW_FIZHI */

#ifdef ALLOW_REGRID
      IF ( useREGRID ) THEN
        CALL REGRID_INIT_VARIA( myThid )
      ENDIF
#endif /* ALLOW_REGRID */

#ifdef ALLOW_LAYERS
      IF ( useLayers ) THEN
        CALL LAYERS_INIT_VARIA( myThid )
      ENDIF
#endif /* ALLOW_LAYERS */

#ifdef ALLOW_NEST_CHILD
C--   Initialize NEST in CHILD configuration
      IF (useNEST_CHILD) THEN
#ifdef ALLOW_DEBUG
       IF (debugMode)
     &       CALL DEBUG_CALL('NEST_CHILD_INIT_VARIA',myThid)
#endif
       CALL NEST_CHILD_INIT_VARIA( myThid )
      ENDIF
#endif /* ALLOW_NEST_CHILD */

#ifdef ALLOW_NEST_PARENT
C--   Initialize NEST in PARENT configuration
      IF (useNEST_PARENT) THEN
#ifdef ALLOW_DEBUG
       IF (debugMode)
     &       CALL DEBUG_CALL('NEST_PARENT_INIT',myThid)
#endif
       CALL NEST_PARENT_INIT_VARIA( myThid )
      ENDIF
#endif /* ALLOW_NEST_PARENT */

#ifdef ALLOW_NEST2W_COMMON
C--   Initialise the 2-Way Nesting packages variables
      IF ( useNest2W_parent .OR. useNest2W_child ) THEN
# ifdef ALLOW_DEBUG
        IF (debugMode) CALL DEBUG_CALL('NEST2W_INIT_VARIA',myThid)
# endif
        CALL NEST2W_INIT_VARIA( myThid )
      ENDIF
#endif /* ALLOW_NEST2W_COMMON */

#ifdef COMPONENT_MODULE
      IF (useCoupler) THEN
# ifdef ALLOW_DEBUG
        IF (debugMode) CALL DEBUG_CALL('CPL_INI_VARS',myThid)
# endif
        CALL CPL_INI_VARS( myThid )
      ENDIF
#endif /* COMPONENT_MODULE */

#ifdef ALLOW_MYPACKAGE
      IF ( useMYPACKAGE ) THEN
        CALL MYPACKAGE_INIT_VARIA( myThid )
      ENDIF
#endif /* ALLOW_MYPACKAGE */

#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE theta  = tapelev_init, key = 1
CADJ STORE salt   = tapelev_init, key = 1
CADJ STORE etaN   = tapelev_init, key = 1
# ifdef ALLOW_GEOTHERMAL_FLUX
CADJ STORE geothermalFlux = tapelev_init, key = 1
# endif
# ifdef ALLOW_DIFFKR_CONTROL
CADJ STORE diffkr = tapelev_init, key = 1
# endif
#endif /* ALLOW_AUTODIFF_TAMC */

C--   Initialise pkg/smooth
#ifdef ALLOW_SMOOTH
      IF (useSMOOTH) THEN
        CALL SMOOTH_INIT_VARIA(myThid)
      ENDIF
#endif /* ALLOW_SMOOTH */

C--   Initialise pkg/profiles
#ifdef ALLOW_PROFILES
      IF (usePROFILES) THEN
        CALL PROFILES_INIT_VARIA( myThid )
      ENDIF
#endif /* ALLOW_PROFILES */

C--   Initialise pkg/obsfit
#ifdef ALLOW_OBSFIT
      IF (useOBSFIT) THEN
        CALL OBSFIT_INIT_VARIA( myThid )
      ENDIF
#endif /* ALLOW_OBSFIT */

C--   Initialise pkg/ecco (and related pkgs components)
#ifdef ALLOW_ECCO
# ifdef ALLOW_AUTODIFF_TAMC
#  if (defined (ALLOW_UVEL0_CONTROL) && defined (ALLOW_VVEL0_CONTROL))
CADJ STORE uvel = tapelev_init, key = 1
CADJ STORE vvel = tapelev_init, key = 1
#  endif
#  ifdef ALLOW_PSBAR_STERIC
C     In some set-ups (e.g. lab_sea), this is necessary
CADJ STORE etaN  = tapelev_init, key = 1
CADJ STORE theta = tapelev_init, key = 1
CADJ STORE salt  = tapelev_init, key = 1
#  endif
# endif
      IF ( useECCO ) CALL ECCO_INIT_VARIA( myThid )
#endif

C--   Initialise pkg/ctl (and related pkgs components)
#ifdef ALLOW_CTRL
# ifdef ALLOW_AUTODIFF
#  if defined ALLOW_SEAICE && defined ALLOW_DEPTH_CONTROL \
      && defined ALLOW_AUTODIFF_TAMC
CADJ STORE area, heff = tapelev_init, key = 1
#  endif
C- Note: use same trick as for pkg/gmredi (call to GMREDI_INIT_VARIA) when
C     compiling pkg/autodiff (with "If useOBCS" inside ctrl_init_variables.F)
# else
      IF (useCTRL) THEN
# endif
# ifdef ALLOW_DEBUG
        IF (debugMode) CALL DEBUG_CALL('CTRL_INIT_VARIABLES',myThid)
# endif
        CALL CTRL_INIT_VARIABLES ( myThid )
# ifndef ALLOW_AUTODIFF
      ENDIF
# endif
#endif /* ALLOW_CTRL */

#ifdef ALLOW_OBCS
C--   put this call in last position (needs to come after few {PKG}_init_varia)
      IF (useOBCS) THEN
# ifdef ALLOW_DEBUG
        IF (debugMode) CALL DEBUG_CALL('OBCS_INIT_VARIABLES',myThid)
# endif
        CALL OBCS_INIT_VARIABLES( myThid )
      ENDIF
#endif /* ALLOW_OBCS */

#ifdef ALLOW_DEBUG
      IF (debugMode)
     &     CALL DEBUG_LEAVE('PACKAGES_INIT_VARIABLES',myThid)
#endif /* ALLOW_DEBUG */

      RETURN
      END

#include "ATM_CPL_OPTIONS.h"

CBOP
C     !ROUTINE: CPL_INI_VARS
C     !INTERFACE:
      SUBROUTINE CPL_INI_VARS( myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE CPL_INI_VARS
C     | o Initialisation routine for arrays that are used to
C     |   buffer data that interfaces to the coupling layer.
C     | - Atmospheric version -
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "CPL_PARAMS.h"
#include "ATMCPL.h"

C     !INPUT/OUTPUT PARAMETERS:
C     myThid :: Thread number for this instance of the routine
      INTEGER myThid

#ifdef COMPONENT_MODULE
C     !LOCAL VARIABLES:
C     i,j,bi,bj :: Loop counters
      INTEGER i,j,bi,bj
CEOP

      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
C-        Export field
          atmSLPr       (i,j,bi,bj) = 0.
          HeatFlux      (i,j,bi,bj) = 0.
          qShortWave    (i,j,bi,bj) = 0.
          tauX          (i,j,bi,bj) = 0.
          tauY          (i,j,bi,bj) = 0.
          EvMPrFlux     (i,j,bi,bj) = 0.
#ifdef ALLOW_LAND
          RunOffFlux    (i,j,bi,bj) = 0.
          RunOffEnFx    (i,j,bi,bj) = 0.
#endif /* ALLOW_LAND */
#ifdef ALLOW_THSICE
          iceSaltFlx    (i,j,bi,bj) = 0.
          seaIceMass    (i,j,bi,bj) = 0.
          saltPlmFlx_cpl(i,j,bi,bj) = 0.
#endif /* ALLOW_THSICE */
#ifdef ALLOW_AIM
          airCO2        (i,j,bi,bj) = 0.
          sWSpeed       (i,j,bi,bj) = 0.
#endif /* ALLOW_AIM */
#ifdef ALLOW_THSICE
          sIceFrac_cpl  (i,j,bi,bj) = 0.
          sIceThick_cpl (i,j,bi,bj) = 0.
          sIceSnowH_cpl (i,j,bi,bj) = 0.
          sIceQ1_cpl    (i,j,bi,bj) = 0.
          sIceQ2_cpl    (i,j,bi,bj) = 0.
#endif /* ALLOW_THSICE */
C-        Import field
c         ocMxlD        (i,j,bi,bj) = 0.
          SSTocn        (i,j,bi,bj) = 0.
          SSSocn        (i,j,bi,bj) = 0.
          vSqocn        (i,j,bi,bj) = 0.
#ifdef ALLOW_AIM
          flxCO2ocn     (i,j,bi,bj) = 0.
#endif /* ALLOW_AIM */
         ENDDO
        ENDDO
        atmSLPrTime   (bi,bj) = 0.
        HeatFluxTime  (bi,bj) = 0.
        qShortwaveTime(bi,bj) = 0.
        tauXTime      (bi,bj) = 0.
        tauYTime      (bi,bj) = 0.
        EvMPrTime     (bi,bj) = 0.
#ifdef ALLOW_LAND
        RunOffTime    (bi,bj) = 0.
        ROEnFxTime    (bi,bj) = 0.
#endif
#ifdef ALLOW_THSICE
        saltFxTime    (bi,bj) = 0.
        sIceMassTime  (bi,bj) = 0.
        saltPlmFlxTime(bi,bj) = 0.
#endif
#ifdef ALLOW_AIM
        airCO2Time    (bi,bj) = 0.
        sWSpeedTime   (bi,bj) = 0.
#endif /* ALLOW_AIM */
#ifdef ALLOW_THSICE
        sIceFracTime  (bi,bj) = 0.
        sIceThickTime (bi,bj) = 0.
        sIceSnowHTime (bi,bj) = 0.
        sIceQ1Time    (bi,bj) = 0.
        sIceQ2Time    (bi,bj) = 0.
#endif
       ENDDO
      ENDDO

      IF ( startTime .NE. baseTime .OR. nIter0 .NE. 0 ) THEN
       CALL ATM_CPL_READ_PICKUP( nIter0, myThid )
      ENDIF

#endif /* COMPONENT_MODULE */

      RETURN
      END

#include "SHOWFLOPS_OPTIONS.h"

CBOP
C     !ROUTINE: SHOWFLOPS_INIT
C     !INTERFACE:
      SUBROUTINE SHOWFLOPS_INIT( myThid )

C     !DESCRIPTION: \bv
C     *================================================================*
C     | SUBROUTINE showflops_init
C     | o Initialise runtime timers.
C     *================================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "SHOWFLOPS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     myThid - thread number for this instance of the routine.
      INTEGER myThid 

C     !FUNCTIONS:
C     == Functions ==
#ifdef ALLOW_RUNCLOCK
      LOGICAL RUNCLOCK_CONTINUE
      LOGICAL RC_CONT
#endif

C     !LOCAL VARIABLES:
C     == Local variables ==
      integer iloop

CEOP

#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_ENTER('SHOWFLOPS_INIT',myThid)
#endif

#ifdef TIME_PER_TIMESTEP
CCE107 Initial call for timers
      _BEGIN_MASTER( myThid )
      CALL TIMER_GET_TIME( utold, stold, wtold )
      _END_MASTER( myThid )
#endif
#ifdef USE_PAPI_FLOPS
CCE107 Initial call for PAPI
      _BEGIN_MASTER( myThid )
#ifdef USE_FLIPS
      call PAPIF_flips(real_time, proc_time, flpops, mflops, check)
#else
      call PAPIF_flops(real_time, proc_time, flpops, mflops, check)
#endif
      WRITE(msgBuf,'(A34,F10.6,A,F10.6)')
     $     'Mflop/s before timestepping:', mflops, ' ', mflops*proc_time
     $     /(real_time + 1E-36)
      CALL PRINT_MESSAGE(msgBuf,standardMessageUnit,SQUEEZE_RIGHT,1)
#ifdef PAPI_VERSION
      call PAPIF_ipc(real_time, proc_time, instr, ipc, check)
      WRITE(msgBuf,'(A34,F10.6,A,F10.6)')
     $     'IPC before timestepping:', ipc, ' ', ipc*proc_time
     $     /(real_time + 1E-36)
      CALL PRINT_MESSAGE(msgBuf,standardMessageUnit,SQUEEZE_RIGHT,1)
#endif
      _END_MASTER( myThid )
#else
#ifdef USE_PCL_FLOPS
CCE107 Initial call for PCL
      _BEGIN_MASTER( myThid )
      res = PCLstop(descr, i_result, fp_result, nevents)
      do ipcl = 1, nevents
         WRITE(msgBuf,'(A22,A26,F10.6)'),
     $        pcl_counter_name(pcl_counter_list(ipcl)),
     $        'before timestepping:', fp_result(ipcl)
         CALL PRINT_MESSAGE(msgBuf,standardMessageUnit,SQUEEZE_RIGHT,1)
      enddo
      res = PCLstart(descr, pcl_counter_list, nevents, flags)
      _END_MASTER( myThid )
#endif
#endif

#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_LEAVE('SHOWFLOPS_INIT',myThid)
#endif

      END

#ifdef TIME_PER_TIMESTEP_SFP
CCE107 Initialization of common block for per timestep timing
      BLOCK DATA settimers
C     !TIMING VARIABLES
C     == Timing variables ==
      REAL*8 utnew, utold, stnew, stold, wtnew, wtold
      COMMON /timevars/ utnew, utold, stnew, stold, wtnew, wtold
      DATA utnew, utold, stnew, stold, wtnew, wtold /6*0.0D0/
      END
#endif
#ifdef USE_PAPI_FLOPS_SFP
CCE107 Initialization of common block for PAPI summary performance
      BLOCK DATA setpapis
      INTEGER*8 flpops, instr
      REAL real_time, proc_time, mflops, ipc
      COMMON /papivars/ flpops, instr, real_time, proc_time, mflops, ipc
      DATA flpops, instr, real_time, proc_time, mflops, ipc /2*0,4*0.E0/
      END
#endif

#include "ATM2D_OPTIONS.h"
#ifdef ATM2D_MPI_ON

CStartOfInterface
      SUBROUTINE INITIALISE
C     /==========================================================\
C     | SUBROUTINE INITIALISE                                    |
C     | o Routine to initialise coupling component.              |
C     |==========================================================|
C     | Initialisation involves starting up MPI and then joining |
C     | the coupled configuration as a component with the special|
C     | name "Coupler". With the present MIT Coupler library     |
C     | only one process can register with the name "Coupler".   |
C     | This component is the process responsible for            |
C     | coordinating the transfer of data between other          |
C     | components and for mapping data from one components      |
C     | representation to anothers representation as appropriate.|
C     \==========================================================/
      IMPLICIT NONE
C     === GLobal variables ==
#include "CPLIDS.h"

CEndOfInterface

C     === Local variables ===
C     iErr             - Error code
C     MPI_COMM_Coupler - Communicatior used by this component.
C                        Stored internally by the coupling library.
C     msgUnit          :: log-file I/O unit
      INTEGER iErr
      INTEGER MPI_COMM_Coupler
      INTEGER msgUnit

      CALL MPI_Init(iErr)

C--   Set the running directory (= rank_0 )
      CALL SETDIR( 0 )

C     Register this process as the "coupler" participant. Currently there can
C     only be one coupler participant all others are "component" participants.
      CALL MITCOUPLER_INIT(
     I                      cplCompName,
     O                      MPI_COMM_Coupler, msgUnit )

      CALL MITCOUPLER_INIT( cplCompName, MPI_COMM_Coupler )

      RETURN
      END
#endif

#include "ADMTLM_OPTIONS.h"

      subroutine admtlm_init_fixed( myThid )
C     /==========================================================\
C     | subroutine admtlm_init_fixed                             |
C     | o This routine assigns final T,S to cost function        |
C     \==========================================================/
       implicit none

C     == Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#ifdef ALLOW_ADMTLM
# include "CTRL.h"
# include "ctrl_weights.h"
#endif

C     ======== Routine arguments ======================
C     myThid - Thread number for this instance of the routine.
      integer myThid

#ifdef ALLOW_ADMTLM
C     ========= Local variables =========================
      integer i, j, k
      integer bi, bj
      _RL dummy

      dummy = 0.

      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
c
c N.B. !!!
c Values here should be 1/(std.dev.)^2
c to be consistent with ctrl_set_*pack_xy* routines
c N.B. !!!
c
        DO k=1,Nr
         wtheta(k,bi,bj) = 1. / (1. _d 0)**2
         wsalt (k,bi,bj) = 1. / (0.1 _d 0)**2
         wuvvel(k,bi,bj) = 1. / (0.01 _d 0)**2
        END DO
c
        DO j=1,sNy
         DO i=1,sNx
          wetan(i,j,bi,bj) = 1. / (0.1 _d 0)**2
         END DO
        END DO
c
       END DO
      END DO

      call active_write_xy('wetan',wetan,1,0,mythid,dummy)

#endif

      end

#include "PACKAGES_CONFIG.h"
#include "CPP_OPTIONS.h"

CBOP
C     !ROUTINE: TIMESTEP_TRACER
C     !INTERFACE:
      SUBROUTINE TIMESTEP_TRACER(
     I                     bi, bj, deltaTLev,
     I                     tracer,
     U                     gTracer,
     I                     myTime, myIter, myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R TIMESTEP_TRACER
C     | o Step model tracer field forward in time
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     == Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine Arguments ==
C     bi, bj     :: current tile indices
C     deltaTLev  :: time-step [s] (vertical dimension vector)
C     tracer     :: tracer field
C     gTracer    :: input: tracer tendency ; output: updated tracer
C     myTime     :: current time in simulation
C     myIter     :: current iteration number
C     myThid     :: my Thread Id number
      INTEGER bi, bj
      _RL     deltaTLev(Nr)
      _RL     tracer (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL     gTracer(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL     myTime
      INTEGER myIter, myThid

C     !LOCAL VARIABLES:
C     == Local variables ==
      INTEGER i, j, k
CEOP

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C-    Step tracer forward in time and store provisional value in gTracer array
      DO k=1,Nr
       DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
          gTracer(i,j,k) = tracer(i,j,k)
     &                   + deltaTLev(k)*gTracer(i,j,k)
#ifdef ALLOW_OBCS
CML   For the Stevens open boundary conditions, we need to step forward
CML   the tracer even on the boundary in order to include surface
CML   forcing and (vertical) diffusion contributions. For other cases
CML   this mask was meant to avoid unrealistic values on the open boundaries.
CML   Lets hope that we can live without this safety net.
C    &                      *maskInC(i,j,bi,bj)
#endif
        ENDDO
       ENDDO
      ENDDO

      RETURN
      END

        module w2f__types

        integer :: w2f__4, w2f__8, w2f__16
        parameter (w2f__4 = kind(0.0))
        parameter (w2f__8 = kind(0.0d0))
        parameter (w2f__16 = selected_real_kind(p=30))

        integer :: w2f__i1, w2f__i2, w2f__i4,w2f__i8
        parameter (w2f__i1 = selected_int_kind(r=2))
        parameter (w2f__i2 = selected_int_kind(r=3))
        parameter (w2f__i4 = selected_int_kind(r=8))
        parameter (w2f__i8 = selected_int_kind(r=16))

        end module w2f__types

#include "ECCO_OPTIONS.h"

      subroutine cost_sla_read_yd(
     I                sla_file, sla_startdate, use_mon,
     O                sla_obs, sla_mask,
     I                year, irec, myThid )

c     ==================================================================
c     SUBROUTINE cost_sla_read_yd
c     ==================================================================
c
c     o Read a given record of the SLA data.
c
c     started: Gael Forget 20-Oct-2009
c
c     Apr-2023: argument use_mon, switches read daily to monthly if true
c
c     ==================================================================
c     SUBROUTINE cost_sla_read_yd
c     ==================================================================

      implicit none

c     == global variables ==

#include "EEPARAMS.h"
#include "SIZE.h"
#include "PARAMS.h"
#include "GRID.h"

#include "cal.h"
#include "ECCO_SIZE.h"
#include "ECCO.h"

c     == routine arguments ==
C     use_mon :: switch from using daily to monthly data if true
      character*(MAX_LEN_FNAM) sla_file
      integer sla_startdate(4)
      logical use_mon
      _RL sla_obs (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL sla_mask(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      integer year, irec
      integer myThid

c     == external functions ==
      integer  ilnblnk
      external ilnblnk
      integer  cal_IsLeap
      external cal_IsLeap

c     == local variables ==
      integer bi,bj
      integer i,j,k
      integer itlo,ithi
      integer jtlo,jthi
      integer jmin,jmax
      integer imin,imax
      _RL spval
      _RL factor
cnew(
      integer  il
      character*(MAX_LEN_FNAM) fnametmp
      logical exst
cnew)
      logical read_rec

c     == end of interface ==

      jtlo = myByLo(myThid)
      jthi = myByHi(myThid)
      itlo = myBxLo(myThid)
      ithi = myBxHi(myThid)
      jmin = 1
      jmax = sNy
      imin = 1
      imax = sNx

      factor = 0.01
      spval = -9990.

      read_rec=.FALSE.
      IF (use_mon) THEN
        IF ( (irec.GE.1).AND.(irec.LE.12 ) ) THEN
          read_rec = .TRUE.
        ENDIF
      ELSE

        IF ( (irec.GE.1).AND.( (
     &   (cal_IsLeap(year,myThid).EQ.2).AND.(irec.LE.366)
     &   ).OR.(irec.LE.365) ) ) THEN
          read_rec = .TRUE.
        ENDIF
      ENDIF

      IF (read_rec) THEN
        il=ilnblnk(sla_file)
        WRITE(fnametmp,'(2a,i4)')
     &     sla_file(1:il), '_', year
        inquire( file=fnametmp, exist=exst )
        IF (.NOT. exst) THEN
           STOP
        ENDIF

        CALL READ_REC_3D_RL( fnametmp, cost_iprec, 1,
     &                     sla_obs, irec, 1, myThid )

        DO bj = jtlo,jthi
          DO bi = itlo,ithi
            k = 1
            DO j = jmin,jmax
              DO i = imin,imax

                IF (_hFacC(i,j,k,bi,bj) .EQ. 0.) THEN
                   sla_mask(i,j,bi,bj) = 0. _d 0
                ELSE
                   sla_mask(i,j,bi,bj) = 1. _d 0
                ENDIF
                IF (sla_obs(i,j,bi,bj) .LE. spval) THEN
                  sla_mask(i,j,bi,bj) = 0. _d 0
                ENDIF
                IF (abs(sla_obs(i,j,bi,bj)) .LT. 1.d-8 ) THEN
                   sla_mask(i,j,bi,bj) = 0. _d 0
                ENDIF

#ifndef ALLOW_SHALLOW_ALTIMETRY
                IF ( R_low(i,j,bi,bj) .GT. -200. ) THEN
                  sla_mask(i,j,bi,bj) = 0. _d 0
                ENDIF
#endif
#ifndef ALLOW_HIGHLAT_ALTIMETRY
                IF ( abs(YC(i,j,bi,bj)) .GT. 66. ) THEN
                  sla_mask(i,j,bi,bj) = 0. _d 0
                ENDIF
#endif

                sla_mask(i,j,bi,bj) = sla_mask(i,j,bi,bj)*frame(i,j)
                sla_obs(i,j,bi,bj)  = sla_mask(i,j,bi,bj)*factor*
     &               sla_obs(i,j,bi,bj)

              ENDDO
            ENDDO
          ENDDO
        ENDDO

      ELSE !IF ( (irec.GE.1).AND...

        DO bj = jtlo,jthi
          DO bi = itlo,ithi
            DO j = jmin,jmax
              DO i = imin,imax
                   sla_obs(i,j,bi,bj) = 0. _d 0
                   sla_mask(i,j,bi,bj) = 0. _d 0
              ENDDO
            ENDDO
          ENDDO
        ENDDO

      ENDIF !IF ( (irec.GE.1).AND...

      RETURN
      END

#include "MONITOR_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: MON_CALC_STATS_RS

C     !INTERFACE:
      SUBROUTINE MON_CALC_STATS_RS(
     I               myNr, arr, arrhFac, arrMask, arrArea, arrDr,
     O               theMin, theMax, theMean, theSD, theDel2, theVol,
     I               myThid )

C     Calculate statistics of global array ``\_RS arr''.
C     account for volume and mask

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
      INTEGER myNr
      _RS arr    (1-OLx:sNx+OLx,1-OLy:sNy+OLy,myNr,nSx,nSy)
      _RS arrhFac(1-OLx:sNx+OLx,1-OLy:sNy+OLy,myNr,nSx,nSy)
      _RS arrMask(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RS arrArea(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RS arrDr(myNr)
      _RL theMin, theMax, theMean, theSD, theDel2, theVol
      INTEGER myThid
CEOP

C     !LOCAL VARIABLES:
      INTEGER bi,bj,i,j,k
      LOGICAL noPnts
      _RL tmpVal
      _RL tmpMask
      _RL tmpVol
      _RL ddx, ddy
      _RL theVar
      _RL theNbPt
      _RL tileMean(nSx,nSy)
      _RL tileVar (nSx,nSy)
      _RL tileSD  (nSx,nSy)
      _RL tileDel2(nSx,nSy)
      _RL tileVol (nSx,nSy)
      _RL tileNbPt(nSx,nSy)

      theMin = 0.
      theMax = 0.
      theMean= 0.
      theSD  = 0.
      theVar = 0.
      theDel2= 0.
      theVol = 0.
      theNbPt= 0.
      noPnts = .TRUE.

      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        tileNbPt(bi,bj) = 0.
        tileDel2(bi,bj) = 0.
        tileVol (bi,bj) = 0.
        tileMean(bi,bj) = 0.
        tileVar (bi,bj) = 0.
        DO k=1,myNr
         DO j=1,sNy
          DO i=1,sNx
           tmpVal  = arr(i,j,k,bi,bj)
           tmpMask = arrMask(i,j,bi,bj)*arrhFac(i,j,k,bi,bj)
           IF ( tmpMask.GT.0. _d 0 .AND. noPnts ) THEN
            theMin=tmpVal
            theMax=tmpVal
            noPnts=.FALSE.
           ENDIF
           IF ( tmpMask.GT.0. _d 0 ) THEN
            theMin = MIN(theMin,tmpVal)
            theMax = MAX(theMax,tmpVal)
C--   like old code (but using hFac instead of mask): identical if no partial cell
c           tileDel2(bi,bj) = tileDel2(bi,bj)
c    &       + 0.25*ABS(
c    &          (arr(i+1,j,k,bi,bj)-tmpVal)*arrhFac(i+1,j,k,bi,bj)
c    &         +(arr(i-1,j,k,bi,bj)-tmpVal)*arrhFac(i-1,j,k,bi,bj)
c    &         +(arr(i,j+1,k,bi,bj)-tmpVal)*arrhFac(i,j+1,k,bi,bj)
c    &         +(arr(i,j-1,k,bi,bj)-tmpVal)*arrhFac(i,j-1,k,bi,bj)
c    &                 )
C--   New form:
            ddx = arrhFac(i+1,j,k,bi,bj)*arrhFac(i-1,j,k,bi,bj)
            IF ( ddx.GT.0. _d 0 ) THEN
             ddx = (arr(i+1,j,k,bi,bj)-tmpVal)
     &           + (arr(i-1,j,k,bi,bj)-tmpVal)
            ENDIF
            ddy = arrhFac(i,j+1,k,bi,bj)*arrhFac(i,j-1,k,bi,bj)
            IF ( ddy.GT.0. _d 0 ) THEN
             ddy = (arr(i,j+1,k,bi,bj)-tmpVal)
     &           + (arr(i,j-1,k,bi,bj)-tmpVal)
            ENDIF
            tileDel2(bi,bj) = tileDel2(bi,bj) + ddx*ddx + ddy*ddy

            tileNbPt(bi,bj) = tileNbPt(bi,bj) + oneRL
            tmpVol = arrArea(i,j,bi,bj)*arrDr(k)*tmpMask
            tileVol (bi,bj) = tileVol (bi,bj) + tmpVol
            tileMean(bi,bj) = tileMean(bi,bj) + tmpVol*tmpVal
            tileVar (bi,bj) = tileVar (bi,bj) + tmpVol*tmpVal*tmpVal
           ENDIF
          ENDDO
         ENDDO
        ENDDO
       ENDDO
      ENDDO

      CALL GLOBAL_SUM_TILE_RL( tileNbPt, theNbPt, myThid )
      CALL GLOBAL_SUM_TILE_RL( tileDel2, theDel2, myThid )
      CALL GLOBAL_SUM_TILE_RL( tileVol , theVol , myThid )
      CALL GLOBAL_SUM_TILE_RL( tileMean, theMean, myThid )
c     CALL GLOBAL_SUM_TILE_RL( tileVar , theVar , myThid )

      IF ( theNbPt.GT.zeroRL ) THEN
c      theDel2  = theDel2/theNbPt
       theDel2  = SQRT(theDel2)/theNbPt
      ENDIF

      IF ( theVol.GT.0. _d 0 ) THEN
       theMean= theMean/theVol
       theVar = theVar/theVol
       IF ( noPnts ) theMin = theMean
       theMin = -theMin
       _GLOBAL_MAX_RL(theMin,myThid)
       theMin = -theMin
       IF ( noPnts ) theMax = theMean
       _GLOBAL_MAX_RL(theMax,myThid)

       DO bj=myByLo(myThid),myByHi(myThid)
        DO bi=myBxLo(myThid),myBxHi(myThid)
         tileSD(bi,bj)=0.
         DO k=1,myNr
          DO j=1,sNy
           DO i=1,sNx
            tmpVal=arr(i,j,k,bi,bj)
            tmpMask = arrMask(i,j,bi,bj)*arrhFac(i,j,k,bi,bj)
            IF ( tmpMask.GT.0. _d 0 ) THEN
             tmpVol = arrArea(i,j,bi,bj)*arrDr(k)*tmpMask
             tileSD(bi,bj) = tileSD(bi,bj)
     &                     + tmpVol*(tmpVal-theMean)*(tmpVal-theMean)
            ENDIF
           ENDDO
          ENDDO
         ENDDO
        ENDDO
       ENDDO

       CALL GLOBAL_SUM_TILE_RL( tileSD, theSD, myThid )

       theSD = SQRT(theSD/theVol)
c      theSD = SQRT(theVar-theMean*theMean)
      ENDIF

      RETURN
      END

#include "EXF_OPTIONS.h"

      SUBROUTINE EXF_CHECK_RANGE( myTime, myIter, myThid )

C     ==================================================================
C     SUBROUTINE EXF_CHECK_RANGE
C     ==================================================================

      IMPLICIT NONE

C     == global variables ==
#include "EEPARAMS.h"
#include "SIZE.h"
#include "PARAMS.h"
#include "GRID.h"

#include "EXF_PARAM.h"
c#include "EXF_CONSTANTS.h"
#include "EXF_FIELDS.h"

C     == routine arguments ==
C     myThid - thread number for this instance of the routine.
      _RL myTime
      INTEGER myIter, myThid

C     == local variables ==
      INTEGER i, j, ks, bi, bj
      INTEGER exferr

C     == end of interface ==

      exferr = 0

C--   Only master thread can safely write directly to standard output:
      _BARRIER
      _BEGIN_MASTER( myThid )

      ks = 1
      IF ( usingPCoords ) ks = Nr
c     DO bj = myByLo(myThid), myByHi(myThid)
c      DO bi = myBxLo(myThid), myBxHi(myThid)
      DO bj = 1, nSy
       DO bi = 1, nSx

C Change checking range because some atmospheric fields will
C not always have valid values in the tile edges.
c       DO j = 1-OLy, sNy+OLy
c        DO i = 1-OLx, sNx+OLx
        DO j = 1, sNy
         DO i = 1, sNx

C     Heat flux.
          IF ( ( hflux(i,j,bi,bj) .GT. 1600. .OR.
     &         hflux(i,j,bi,bj) .LT. -500. ) .AND.
     &         maskC(i,j,ks,bi,bj) .NE. 0. ) THEN
           WRITE(standardMessageUnit,'(A,5(1X,I6),2X,D22.15)')
     &          'EXF WARNING: hflux out of range for bi,bj,i,j,it= ',
     &          bi, bj, i, j, myIter, hflux(i,j,bi,bj)
           exferr = 1
          ENDIF

C     Freshwater flux.
          IF ( ABS(sflux(i,j,bi,bj)) .GT. 1.E-6 .AND.
     &         maskC(i,j,ks,bi,bj) .NE. 0. ) THEN
           WRITE(standardMessageUnit,'(A,5(1X,I6),2X,D22.15)')
     &          'EXF WARNING: sflux out of range for bi,bj,i,j,it= ',
     &          bi, bj, i, j, myIter, sflux(i,j,bi,bj)
           exferr = 1
          ENDIF

C     Zonal wind stress.
          IF ( ABS(ustress(i,j,bi,bj)) .GT. 2.7 .AND.
     &         maskW(i,j,ks,bi,bj) .NE. 0. ) THEN
           WRITE(standardMessageUnit,'(A,5(1X,I6),2X,D22.15)')
     &          'EXF WARNING: ustress out of range for bi,bj,i,j,it= ',
     &          bi, bj, i, j, myIter, ustress(i,j,bi,bj)
           exferr = 1
          ENDIF

C     Meridional wind stress.
          IF ( ABS(vstress(i,j,bi,bj)) .GT. 2.3 .AND.
     &         maskS(i,j,ks,bi,bj) .NE. 0. ) THEN
           WRITE(standardMessageUnit,'(A,5(1X,I6),2X,D22.15)')
     &          'EXF WARNING: vstress out of range for bi,bj,i,j,it= ',
     &          bi, bj, i, j, myIter, vstress(i,j,bi,bj)
           exferr = 1
          ENDIF

          IF ( useAtmWind ) THEN
C     zonal wind speed
           IF ( ABS(uwind(i,j,bi,bj)) .GT. 100. .AND.
     &         maskW(i,j,ks,bi,bj) .NE. 0. ) THEN
            WRITE(standardMessageUnit,'(A,5(1X,I6),2X,D22.15)')
     &          'EXF WARNING: uwind out of range for bi,bj,i,j,it= ',
     &          bi, bj, i, j, myIter, uwind(i,j,bi,bj)
            exferr = 1
           ENDIF

C     zonal wind speed
           IF ( ABS(vwind(i,j,bi,bj)) .GT. 100. .AND.
     &         maskS(i,j,ks,bi,bj) .NE. 0. ) THEN
            WRITE(standardMessageUnit,'(A,5(1X,I6),2X,D22.15)')
     &          'EXF WARNING: vwind out of range for bi,bj,i,j,it= ',
     &          bi, bj, i, j, myIter, vwind(i,j,bi,bj)
            exferr = 1
           ENDIF
          ENDIF

C     wind speed modulus
          IF ( ( wspeed(i,j,bi,bj) .LT. 0. .OR.
     &         wspeed(i,j,bi,bj) .GT. 100. ) .AND.
     &         maskS(i,j,ks,bi,bj) .NE. 0. ) THEN
           WRITE(standardMessageUnit,'(A,5(1X,I6),2X,D22.15)')
     &          'EXF WARNING: wspeed out of range for bi,bj,i,j,it= ',
     &          bi, bj, i, j, myIter, wspeed(i,j,bi,bj)
           exferr = 1
          ENDIF

#ifdef ALLOW_ATM_TEMP
C     2-m air temperature
          IF ( (atemp(i,j,bi,bj) .LT. 183 .OR.
     &         atemp(i,j,bi,bj) .GT. 343 ) .AND.
     &         maskC(i,j,ks,bi,bj) .NE. 0. ) THEN
           WRITE(standardMessageUnit,'(2A,5(1X,I6),2X,D22.15)')
     &          'EXF WARNING: atemp + exf_offset_atemp ',
     &          'out of range for bi,bj,i,j,it= ',
     &          bi, bj, i, j, myIter, atemp(i,j,bi,bj)
           exferr = 1
          ENDIF

C     2-m specific humidity
          IF ( (aqh(i,j,bi,bj) .LT. 0. .OR.
     &         aqh(i,j,bi,bj) .GT. 0.1 ) .AND.
     &         maskC(i,j,ks,bi,bj) .NE. 0. ) THEN
           WRITE(standardMessageUnit,'(A,5(1X,I6),2X,D22.15)')
     &          'EXF WARNING: aqh out of range for bi,bj,i,j,it= ',
     &          bi, bj, i, j, myIter, aqh(i,j,bi,bj)
           exferr = 1
          ENDIF

C     precipitation rate
          IF ( (precip(i,j,bi,bj) .LT. 0. .OR.
     &         precip(i,j,bi,bj) .GT. 2.E-6 ) .AND.
     &         maskC(i,j,ks,bi,bj) .NE. 0. ) THEN
           WRITE(standardMessageUnit,'(A,5(1X,I6),2X,D22.15)')
     &          'EXF WARNING: precip out of range for bi,bj,i,j,it= ',
     &          bi, bj, i, j, myIter, precip(i,j,bi,bj)
           exferr = 1
          ENDIF

C     snow
          IF ( (snowprecip(i,j,bi,bj) .LT. 0. .OR.
     &         snowprecip(i,j,bi,bj) .GT. 2.E-6 ) .AND.
     &         maskC(i,j,ks,bi,bj) .NE. 0. ) THEN
           WRITE(standardMessageUnit,'(2A,5(1X,I6),2X,D22.15)')
     &          'EXF WARNING: snowprecip out of range ',
     &          'for bi,bj,i,j,it= ',
     &          bi, bj, i, j, myIter, snowprecip(i,j,bi,bj)
           exferr = 1
          ENDIF
#endif

#ifdef SHORTWAVE_HEATING
C     Short wave radiative flux.
          IF ( (swflux(i,j,bi,bj) .GT. 1. .OR.
     &         swflux(i,j,bi,bj) .LT. -1000. ) .AND.
     &         maskC(i,j,ks,bi,bj) .NE. 0. ) THEN
           WRITE(standardMessageUnit,'(A,5(1X,I6),2X,D22.15)')
     &          'EXF WARNING: swflux out of range for bi,bj,i,j,it= ',
     &          bi, bj, i, j, myIter, swflux(i,j,bi,bj)
           exferr = 1
          ENDIF
#endif

#ifdef ALLOW_RUNOFF
C     Runoff.
          IF ( (runoff(i,j,bi,bj) .LT. 0. .OR.
     &         runoff(i,j,bi,bj) .GT. 1.E-6 ) .AND.
     &         maskC(i,j,ks,bi,bj) .NE. 0. ) THEN
           WRITE(standardMessageUnit,'(A,5(1X,I6),2X,D22.15)')
     &          'EXF WARNING: runoff out of range for bi,bj,i,j,it= ',
     &          bi, bj, i, j, myIter, runoff(i,j,bi,bj)
           WRITE(standardMessageUnit,'(A)')
     &          'Please note that input units for runoff are'
           WRITE(standardMessageUnit,'(A)')
     &          'm/s not m/yr.  If input file is in m/yr, set'
           WRITE(standardMessageUnit,'(A)')
     &          'exf_inscal_runoff=3.170979198E-8'
           WRITE(standardMessageUnit,'(A)')
     &          'in the data.exf input file.'
           exferr = 1
          ENDIF
# ifdef ALLOW_RUNOFTEMP
C     Runoff temperature.
          IF ( (runoftemp(i,j,bi,bj) .LT. -2. .OR.
     &         runoff(i,j,bi,bj) .GT. 36 ) .AND.
     &         maskC(i,j,ks,bi,bj) .NE. 0. ) THEN
           WRITE(standardMessageUnit,'(A,5(1X,I6),2X,D22.15)')
     &          'EXF WARNING: runoftemp out of range at bi,bj,i,j,it= ',
     &          bi, bj, i, j, myIter, runoff(i,j,bi,bj)
           exferr = 1
          ENDIF
# endif /* ALLOW_RUNOFTEMP */
#endif /* ALLOW_RUNOFF */
         ENDDO
        ENDDO

       ENDDO
      ENDDO

      IF ( exferr .NE. 0 ) THEN
       WRITE(standardMessageUnit,'(A)')
     &      'EXF WARNING: If you think these values are OK '
       WRITE(standardMessageUnit,'(A)')
     &      'EXF WARNING: then set useExfCheckRange=.FALSE.'
       STOP 'ABNORMAL END: S/R EXF_CHECK_RANGE'
      ENDIF
      _END_MASTER( myThid )
      _BARRIER

      RETURN
      END

#include "STREAMICE_OPTIONS.h"
#ifdef ALLOW_AUTODIFF
# include "AUTODIFF_OPTIONS.h"
#endif

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

CBOP
      SUBROUTINE STREAMICE_ADV_FRONT (
     & myThid,
     & time_step,
     & hflux_x_si,
     & hflux_y_si )

C     /============================================================\
C     | SUBROUTINE                                                 |
C     | o                                                          |
C     |============================================================|
C     |                                                            |
C     \============================================================/
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "GRID.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "STREAMICE.h"
#include "STREAMICE_ADV.h"
#ifdef ALLOW_AUTODIFF_TAMC
# include "tamc.h"
#endif

      INTEGER myThid
      _RL time_step
      _RL hflux_x_SI (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL hflux_y_SI (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)

#ifdef ALLOW_STREAMICE

      INTEGER i, j, bi, bj, k, iter_count, iter_rpt
      INTEGER Gi, Gj
      INTEGER new_partial(4)
#ifdef ALLOW_AUTODIFF_TAMC
      INTEGER ikey_front, ikey_1
#endif
      _RL iter_flag
      _RL n_flux_1, n_flux_2
      _RL href, rho, partial_vol, tot_flux, hpot
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      _RL hflux_x_SI2 (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL hflux_y_SI2 (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)

      rho = streamice_density
cph      iter_count = 0
      iter_flag = 1. _d 0
      iter_rpt = 0

        DO bj=myByLo(myThid),myByHi(myThid)
         DO bi=myBxLo(myThid),myBxHi(myThid)
          DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
            hflux_x_SI2(i,j,bi,bj) = 0. _d 0
            hflux_y_SI2(i,j,bi,bj) = 0. _d 0
           ENDDO
          ENDDO
         ENDDO
        ENDDO

      DO iter_count = 0, 3

#ifdef ALLOW_AUTODIFF_TAMC
         ikey_front = (ikey_dynamics-1)*4 + iter_count + 1
CADJ STORE area_shelf_streamice
CADJ &     = comlev1_stream_front, key = ikey_front
CADJ STORE h_streamice
CADJ &     = comlev1_stream_front, key = ikey_front
CADJ STORE hflux_x_si
CADJ &     = comlev1_stream_front, key = ikey_front
CADJ STORE hflux_x_si2
CADJ &     = comlev1_stream_front, key = ikey_front
CADJ STORE hflux_y_si
CADJ &     = comlev1_stream_front, key = ikey_front
CADJ STORE hflux_y_si2
CADJ &     = comlev1_stream_front, key = ikey_front
CADJ STORE streamice_hmask
CADJ &     = comlev1_stream_front, key = ikey_front
CADJ STORE iter_flag
CADJ &     = comlev1_stream_front, key = ikey_front
#endif

       IF ( iter_flag .GT. 0. ) THEN

       iter_flag = 0. _d 0

       IF (iter_count .gt. 0) then
        DO bj=myByLo(myThid),myByHi(myThid)
         DO bi=myBxLo(myThid),myBxHi(myThid)
          DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
            hflux_x_SI(i,j,bi,bj)=hflux_x_SI2(i,j,bi,bj)
            hflux_y_SI(i,j,bi,bj)=hflux_y_SI2(i,j,bi,bj)
            hflux_x_SI2(i,j,bi,bj) = 0. _d 0
            hflux_y_SI2(i,j,bi,bj) = 0. _d 0
           ENDDO
          ENDDO
         ENDDO
        ENDDO
       ENDIF

c       iter_count = iter_count + 1
       iter_rpt = iter_rpt + 1

       DO bj=myByLo(myThid),myByHi(myThid)
        DO bi=myBxLo(myThid),myBxHi(myThid)

         DO j=1-1,sNy+1
          Gj = (myYGlobalLo-1)+(bj-1)*sNy+j
          IF ((Gj .ge. 1) .and. (Gj .le. Ny)) THEN
           DO i=1-1,sNx+1
            Gi = (myXGlobalLo-1)+(bi-1)*sNx+i

#ifdef ALLOW_AUTODIFF_TAMC
            ikey_1 = bi + (bj-1)*nSx + (ikey_front-1)*nSx*nSy
            ikey_1 = i + 1  + (j)*(sNx+2) + (ikey_1-1)*(sNx+2)*(sNy+2)
CADJ STORE area_shelf_streamice(i,j,bi,bj)
CADJ &     = comlev1_stream_ij, key = ikey_1
CADJ STORE h_streamice(i,j,bi,bj)
CADJ &     = comlev1_stream_ij, key = ikey_1
CADJ STORE hflux_x_si(i,j,bi,bj)
CADJ &     = comlev1_stream_ij, key = ikey_1
CADJ STORE hflux_y_si(i,j,bi,bj)
CADJ &     = comlev1_stream_ij, key = ikey_1
CADJ STORE streamice_hmask(i,j,bi,bj)
CADJ &     = comlev1_stream_ij, key = ikey_1
#endif

            IF (.not. STREAMICE_calve_to_mask .OR.
     &       STREAMICE_calve_mask (i,j,bi,bj) .eq. 1.0) THEN

            IF ((Gi .ge. 1) .and. (Gi .le. Nx) .and.
     &          (STREAMICE_Hmask(i,j,bi,bj).eq.0.0 .or.
     &           STREAMICE_Hmask(i,j,bi,bj).eq.2.0)) THEN
             n_flux_1 = 0. _d 0
             href = 0. _d 0
             tot_flux = 0. _d 0

#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE hflux_x_SI(i,j,bi,bj) = comlev1_stream_ij, key = ikey_1
#endif
             IF (hflux_x_SI(i,j,bi,bj).gt. 0. _d 0) THEN
              n_flux_1 = n_flux_1 + 1. _d 0
              href = href + H_streamice(i-1,j,bi,bj)
              tot_flux = tot_flux + hflux_x_SI(i,j,bi,bj) *
     &         dxG(i,j,bi,bj) * time_step
              hflux_x_SI(i,j,bi,bj) = 0. _d 0
             ENDIF

#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE hflux_x_SI(i+1,j,bi,bj) = comlev1_stream_ij, key = ikey_1
#endif
             IF (hflux_x_SI(i+1,j,bi,bj).lt. 0. _d 0) THEN
              n_flux_1 = n_flux_1 + 1. _d 0
              href = href + H_streamice(i+1,j,bi,bj)
              tot_flux = tot_flux - hflux_x_SI(i+1,j,bi,bj) *
     &         dxG(i+1,j,bi,bj) * time_step
              hflux_x_SI(i+1,j,bi,bj) = 0. _d 0
             ENDIF

#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE hflux_y_SI(i,j,bi,bj) = comlev1_stream_ij, key = ikey_1
#endif
             IF (hflux_y_SI(i,j,bi,bj).gt. 0. _d 0) THEN
              n_flux_1 = n_flux_1 + 1. _d 0
              href = href + H_streamice(i,j-1,bi,bj)
              tot_flux = tot_flux + hflux_y_SI(i,j,bi,bj) *
     &         dyG(i,j,bi,bj) * time_step
              hflux_y_SI(i,j,bi,bj) = 0. _d 0
             ENDIF

#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE hflux_y_SI(i,j+1,bi,bj) = comlev1_stream_ij, key = ikey_1
#endif
             IF (hflux_y_SI(i,j+1,bi,bj).lt. 0. _d 0) THEN
              n_flux_1 = n_flux_1 + 1. _d 0
              href = href + H_streamice(i,j+1,bi,bj)
              tot_flux = tot_flux - hflux_y_SI(i,j+1,bi,bj) *
     &         dyG(i,j+1,bi,bj) * time_step
              hflux_y_SI(i,j+1,bi,bj) = 0. _d 0
             ENDIF

             IF (n_flux_1 .gt. 0.) THEN

              href = href / n_flux_1
              partial_vol = H_streamice (i,j,bi,bj) *
     &         area_shelf_streamice (i,j,bi,bj) + tot_flux
              hpot = partial_vol * recip_rA(i,j,bi,bj)

              IF (hpot .eq. href) THEN ! cell is exactly covered, no overflow
                STREAMICE_hmask (i,j,bi,bj) = 1.0
                H_streamice (i,j,bi,bj) = href
                area_shelf_streamice(i,j,bi,bj) =
     &           rA(i,j,bi,bj)
              ELSEIF (hpot .lt. href) THEN ! cell still unfilled

               STREAMICE_hmask (i,j,bi,bj) = 2.0
               area_shelf_streamice (i,j,bi,bj) = partial_vol / href
               H_streamice (i,j,bi,bj) = href
              ELSE ! cell is filled - do overflow

               STREAMICE_hmask (i,j,bi,bj) = 1.0
               area_shelf_streamice(i,j,bi,bj) =
     &           rA(i,j,bi,bj)

               PRINT *, "GOT HERE OVERFLOW ", i,j,
     &          area_shelf_streamice(i,j,bi,bj)
               partial_vol = partial_vol - href * rA(i,j,bi,bj)

               iter_flag  = 1. _d 0

               n_flux_2 = 0. _d 0 ;
               DO k=1,4
                new_partial (k) = 0
               ENDDO

               DO k=1,2
                IF ( (STREAMICE_ufacemask(i-1+k,j,bi,bj).eq.2.0) .or.
     &            (STREAMICE_calve_to_mask .and.
     &             STREAMICE_calve_mask(i+2*k-3,j,bi,bj).ne.1.0)
     &             ) THEN  ! at a permanent calving boundary - no advance allowed
                   n_flux_2 = n_flux_2 + 1. _d 0
                ELSEIF (STREAMICE_hmask(i+2*k-3,j,bi,bj).eq.0 _d 0) THEN ! adjacent cell is completely ice free
                   n_flux_2 = n_flux_2 + 1. _d 0
                   new_partial (k) = 1
                ENDIF
               ENDDO
               DO k=1,2
                IF ( (STREAMICE_vfacemask (i,j-1+k,bi,bj).eq.2.0) .or.
     &            (STREAMICE_calve_to_mask .and.
     &             STREAMICE_calve_mask(i,j+2*k-3,bi,bj).ne.1.0)
     &             ) THEN  ! at a permanent calving boundary - no advance allowed
                    n_flux_2 = n_flux_2 + 1. _d 0
                ELSEIF (STREAMICE_hmask(i,j+2*k-3,bi,bj).eq.0 _d 0) THEN
                    n_flux_2 = n_flux_2 + 1. _d 0
                    new_partial (k+2) = 1
                ENDIF
               ENDDO

               IF (n_flux_2 .eq. 0.) THEN ! there is nowhere to put the extra ice!
                H_streamice(i,j,bi,bj) = href + partial_vol *
     &             recip_rA(i,j,bi,bj)
               ELSE
                H_streamice(i,j,bi,bj) = href

                DO k=1,2
                 IF (new_partial(k) .eq. 1) THEN
                  hflux_x_SI2(i-1+k,j,bi,bj) =
     &             partial_vol/time_step/n_flux_2/
     &               dxG(i-1+k,j,bi,bj)
                 ENDIF
                ENDDO

                DO k=1,2
                 IF (new_partial(k+2) .eq. 1) THEN
                  hflux_y_SI2(i,j-1+k,bi,bj) =
     &             partial_vol/time_step/n_flux_2/
     &               dxG(i,j-1+k,bi,bj)
                 ENDIF
                ENDDO

               ENDIF
              ENDIF
             ENDIF

            ENDIF
            ENDIF
           ENDDO
          ENDIF
         ENDDO
c
        ENDDO
       ENDDO
c
      ENDIF
      ENDDO

      IF (iter_rpt.gt.1) THEN
       WRITE(msgBuf,'(A,I5,A)') 'FRONT ADVANCE: ',iter_rpt,
     &  ' ITERATIONS'
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                     SQUEEZE_RIGHT , 1)
      ENDIF

#endif
      RETURN
      END

#include "GAD_OPTIONS.h"

CBOP
C     !ROUTINE: GAD_IMPLICIT_R
C     !INTERFACE:
      SUBROUTINE GAD_IMPLICIT_R(
     I      implicitAdvection, advectionScheme, tracerIdentity,
     I      deltaTLev,
     I      kappaRX, recip_hFac, wFld, tracer,
     U      gTracer,
     I      bi, bj, myTime, myIter, myThid )
C     !DESCRIPTION:
C     Solve implicitly vertical advection and diffusion for one tracer.

C     !USES:
      IMPLICIT NONE
C     == Global data ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "SURFACE.h"
#include "GAD.h"
#ifdef ALLOW_LAYERS
# include "LAYERS_P2SHARE.h"
#endif

C !INPUT/OUTPUT PARAMETERS:
C == Routine Arguments ==
C implicitAdvection :: if True, treat vertical advection implicitly
C advectionScheme   :: advection scheme to use
C tracerIdentity    :: Identifier for the tracer
C kappaRX           :: 3-D array for vertical diffusion coefficient
C recip_hFac        :: inverse of cell open-depth factor
C wFld              :: Advection velocity field, vertical component
C tracer            :: tracer field at current time step
C gTracer           :: future tracer field
C bi,bj             :: tile indices
C myTime            :: current time
C myIter            :: current iteration number
C myThid            :: thread number
      LOGICAL implicitAdvection
      INTEGER advectionScheme
      INTEGER tracerIdentity
      _RL     deltaTLev(Nr)
      _RL kappaRX   (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RS recip_hFac(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL wFld      (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL tracer    (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL gTracer   (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      INTEGER bi, bj
      _RL myTime
      INTEGER myIter, myThid

#ifdef ALLOW_DIAGNOSTICS
C !FUNCTIONS:
      CHARACTER*4 GAD_DIAG_SUFX
      EXTERNAL    GAD_DIAG_SUFX
      LOGICAL     DIAGNOSTICS_IS_ON
      EXTERNAL    DIAGNOSTICS_IS_ON
#endif

C !LOCAL VARIABLES:
C == Local variables ==
C iMin,iMax,jMin,jMax :: computational domain
C i,j,k     :: loop indices
C a5d       :: 2nd  lower diagonal of the pentadiagonal matrix
C b5d       :: 1rst lower diagonal of the pentadiagonal matrix
C c5d       :: main diagonal       of the pentadiagonal matrix
C d5d       :: 1rst upper diagonal of the pentadiagonal matrix
C e5d       :: 2nd  upper diagonal of the pentadiagonal matrix
C rTrans    :: vertical volume transport at interface k
C localTr   :: local copy of tracer (for Non-Lin Adv.Scheme)
C diagonalNumber :: number of non-zero diagonals in the matrix
C errCode   :: > 0 if singular matrix
C msgBuf    :: Informational/error message buffer
      INTEGER iMin,iMax,jMin,jMax
      PARAMETER( iMin = 1, iMax = sNx )
      PARAMETER( jMin = 1, jMax = sNy )
      INTEGER i,j,k
      INTEGER diagonalNumber, errCode
      _RL a5d(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL b5d(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL c5d(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL d5d(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL e5d(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL rTrans (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL localTr(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
#ifdef ALLOW_DIAGNOSTICS
      CHARACTER*8 diagName
      CHARACTER*4 diagSufx
      LOGICAL     diagDif, diagAdv
      INTEGER km1, km2, kp1, kp2
      _RL df (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL af (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL div(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL flx(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
# ifdef SOLVE_DIAGONAL_LOWMEMORY
      CHARACTER*(MAX_LEN_MBUF) msgBuf
# endif /* SOLVE_DIAGONAL_LOWMEMORY */
#endif /* ALLOW_DIAGNOSTICS */
CEOP

C--   no need to solve anything with only 1 level:
      IF (Nr.GT.1) THEN

C--   Initialise
      DO k=1,Nr
       DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
         a5d(i,j,k) = 0. _d 0
         b5d(i,j,k) = 0. _d 0
         c5d(i,j,k) = 1. _d 0
         d5d(i,j,k) = 0. _d 0
         e5d(i,j,k) = 0. _d 0
        ENDDO
       ENDDO
      ENDDO
      diagonalNumber = 1

      IF (implicitDiffusion) THEN
C--   set the tri-diagonal matrix to solve the implicit diffusion problem
       diagonalNumber = 3
C-     1rst lower diagonal :
       DO k=2,Nr
        DO j=jMin,jMax
         DO i=iMin,iMax
           b5d(i,j,k) = -deltaTLev(k)*maskC(i,j,k-1,bi,bj)
     &                  *recip_hFac(i,j,k)*recip_drF(k)
     &                  *recip_deepFac2C(k)*recip_rhoFacC(k)
     &                  *kappaRX(i,j, k )*recip_drC( k )
     &                  *deepFac2F( k )*rhoFacF( k )
         ENDDO
        ENDDO
       ENDDO
C-     1rst upper diagonal :
       DO k=1,Nr-1
        DO j=jMin,jMax
         DO i=iMin,iMax
           d5d(i,j,k) = -deltaTLev(k)*maskC(i,j,k+1,bi,bj)
     &                  *recip_hFac(i,j,k)*recip_drF(k)
     &                  *recip_deepFac2C(k)*recip_rhoFacC(k)
     &                  *kappaRX(i,j,k+1)*recip_drC(k+1)
     &                  *deepFac2F(k+1)*rhoFacF(k+1)
         ENDDO
        ENDDO
       ENDDO
C-     Main diagonal :
       DO k=1,Nr
        DO j=jMin,jMax
         DO i=iMin,iMax
           c5d(i,j,k) = 1. _d 0 - ( b5d(i,j,k) + d5d(i,j,k) )
C      to recover older (prior to 2016-10-05) results:
c          c5d(i,j,k) = 1. _d 0 - b5d(i,j,k) - d5d(i,j,k)
         ENDDO
        ENDDO
       ENDDO

C--   end if implicitDiffusion
      ENDIF

      IF (implicitAdvection) THEN

C--   Non-Linear Advection scheme: keep a local copy of tracer field
       IF ( advectionScheme.EQ.ENUM_FLUX_LIMIT .OR.
     &      advectionScheme.EQ.ENUM_DST3_FLUX_LIMIT ) THEN
        IF ( multiDimAdvection ) THEN
         DO k=1,Nr
          DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
            localTr(i,j,k) = gTracer(i,j,k)
           ENDDO
          ENDDO
         ENDDO
        ELSE
         DO k=1,Nr
          DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
            localTr(i,j,k) = tracer(i,j,k)
           ENDDO
          ENDDO
         ENDDO
        ENDIF
       ENDIF

       DO k=Nr,1,-1

C--    Compute transport
        IF (k.EQ.1) THEN
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
            rTrans(i,j) = 0. _d 0
          ENDDO
         ENDDO
        ELSE
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
            rTrans(i,j) = wFld(i,j,k)*rA(i,j,bi,bj)
     &                               *deepFac2F(k)*rhoFacF(k)
     &                               *maskC(i,j,k-1,bi,bj)
          ENDDO
         ENDDO
        ENDIF

#ifdef ALLOW_AIM
C- a hack to prevent Water-Vapor vert.transport into the stratospheric level Nr
        IF ( k.GE.2 .AND.
     &     (.NOT.useAIM .OR.tracerIdentity.NE.GAD_SALINITY .OR.k.LT.Nr)
     &              ) THEN
#else
        IF ( k.GE.2 ) THEN
#endif

         IF ( advectionScheme.EQ.ENUM_CENTERED_2ND ) THEN
          diagonalNumber = 3
          CALL GAD_C2_IMPL_R( bi,bj,k, iMin,iMax,jMin,jMax,
     I                        deltaTLev, rTrans, recip_hFac,
     U                        b5d, c5d, d5d,
     I                        myThid )
         ELSEIF ( advectionScheme.EQ.ENUM_UPWIND_1RST
     &       .OR. advectionScheme.EQ.ENUM_DST2 ) THEN
          diagonalNumber = 3
          CALL GAD_DST2U1_IMPL_R( bi,bj,k, iMin,iMax,jMin,jMax,
     I                        advectionScheme, deltaTLev,
     I                        rTrans, recip_hFac,
     U                        b5d, c5d, d5d,
     I                        myThid )
         ELSEIF ( advectionScheme.EQ.ENUM_FLUX_LIMIT ) THEN
          diagonalNumber = 3
          CALL GAD_FLUXLIMIT_IMPL_R( bi,bj,k, iMin,iMax,jMin,jMax,
     I                        deltaTLev, rTrans, recip_hFac, localTr,
     U                        b5d, c5d, d5d,
     I                        myThid )
         ELSEIF ( advectionScheme.EQ.ENUM_UPWIND_3RD
     &       .OR. advectionScheme.EQ.ENUM_CENTERED_4TH
     &       .OR. advectionScheme.EQ.ENUM_DST3 ) THEN
          diagonalNumber = 5
          CALL GAD_U3C4_IMPL_R( bi,bj,k, iMin,iMax,jMin,jMax,
     I                        advectionScheme, deltaTLev,
     I                        rTrans, recip_hFac,
     U                        a5d, b5d, c5d, d5d, e5d,
     I                        myThid )
         ELSEIF ( advectionScheme.EQ.ENUM_DST3_FLUX_LIMIT ) THEN
          diagonalNumber = 5
          CALL GAD_DST3FL_IMPL_R( bi,bj,k, iMin,iMax,jMin,jMax,
     I                        deltaTLev, rTrans, recip_hFac, localTr,
     U                        a5d, b5d, c5d, d5d, e5d,
     I                        myThid )
         ELSE
          STOP 'GAD_IMPLICIT_R: Adv.Scheme in Impl form not yet coded'
         ENDIF

        ENDIF

C--     end k loop
       ENDDO

C--   end if implicitAdvection
      ENDIF

      IF ( diagonalNumber .EQ. 3 ) THEN
C--   Solve tri-diagonal system :
        errCode = -1
        CALL SOLVE_TRIDIAGONAL( iMin,iMax, jMin,jMax,
     I                          b5d, c5d, d5d,
     U                          gTracer,
     O                          errCode,
     I                          bi, bj, myThid )
        IF (errCode.GE.1) THEN
          STOP 'GAD_IMPLICIT_R: error when solving 3-Diag problem'
        ENDIF
      ELSEIF ( diagonalNumber .EQ. 5 ) THEN
C--   Solve penta-diagonal system :
        errCode = -1
        CALL SOLVE_PENTADIAGONAL( iMin,iMax, jMin,jMax,
     I                            a5d, b5d, c5d, d5d, e5d,
     U                            gTracer,
     O                            errCode,
     I                            bi, bj, myThid )
        IF (errCode.GE.1) THEN
          STOP 'GAD_IMPLICIT_R: error when solving 5-Diag problem'
        ENDIF
      ELSEIF ( diagonalNumber .NE. 1 ) THEN
        STOP 'GAD_IMPLICIT_R: no solver available'
      ENDIF

#ifdef ALLOW_DIAGNOSTICS
C--   Set diagnostic suffix for the current tracer
      IF ( useDiagnostics ) THEN
        diagSufx = GAD_DIAG_SUFX( tracerIdentity, myThid )
        diagName = 'DFrI'//diagSufx
        diagDif = implicitDiffusion
        IF ( diagDif ) diagDif = DIAGNOSTICS_IS_ON(diagName,myThid)
#ifdef ALLOW_LAYERS
     &                      .OR. layers_useThermo
#endif
        diagName = 'ADVr'//diagSufx
        diagAdv = implicitAdvection
        IF ( diagAdv ) diagAdv = DIAGNOSTICS_IS_ON(diagName,myThid)
#ifdef ALLOW_LAYERS
     &                      .OR. layers_useThermo
#endif

        IF ( diagDif .OR. diagAdv ) THEN
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
            flx(i,j) = 0. _d 0
          ENDDO
         ENDDO
C--      start diagnostics k loop
         DO k= Nr,1,-1

          IF ( implicitDiffusion .AND. k.GE.2 ) THEN
            DO j=jMin,jMax
             DO i=iMin,iMax
               df(i,j) =
cc#ifdef ALLOW_AUTODIFF_OPENAD
cc     &             -rA(i,j,bi,bj)%v
cc#else
     &             -rA(i,j,bi,bj)*deepFac2F(k)*rhoFacF(k)
cc#endif
     &            * kappaRX(i,j,k)*recip_drC(k)*rkSign
     &            * (gTracer(i,j,k) - gTracer(i,j,k-1))
     &            * maskC(i,j,k,bi,bj)
     &            * maskC(i,j,k-1,bi,bj)
             ENDDO
            ENDDO
          ELSE
            DO j=1-OLy,sNy+OLy
             DO i=1-OLx,sNx+OLx
               df(i,j) = 0. _d 0
             ENDDO
            ENDDO
          ENDIF

C-  Note: Needs to explicitly increment counter (call DIAGNOSTICS_COUNT)
C         since skipping k=1 DIAGNOSTICS_FILL call.
          IF ( diagDif .AND. k.GE.2 ) THEN
           diagName = 'DFrI'//diagSufx
           CALL DIAGNOSTICS_FILL(df,diagName, k,1, 2,bi,bj, myThid)
           IF ( k.EQ.2 ) CALL DIAGNOSTICS_COUNT(diagName,bi,bj,myThid)
#ifdef ALLOW_LAYERS
           IF ( layers_useThermo ) THEN
             CALL LAYERS_FILL( df, tracerIdentity, 'DFR',
     &                           k, 1, 2,bi,bj, myThid )
           ENDIF
#endif /* ALLOW_LAYERS */
          ENDIF

          IF ( diagAdv ) THEN
#ifdef SOLVE_DIAGONAL_LOWMEMORY
           diagName = 'ADVr'//diagSufx
           WRITE(msgBuf,'(4A)') 'GAD_IMPLICIT_R: ',
     &      'unable to compute Diagnostic "', diagName, '" with'
           CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                         SQUEEZE_RIGHT, myThid )
           WRITE(msgBuf,'(4A)') 'GAD_IMPLICIT_R: ',
     &      '#define SOLVE_DIAGONAL_LOWMEMORY (in CPP_OPTIONS.h)'
           CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                         SQUEEZE_RIGHT, myThid )
           STOP 'ABNORMAL END: S/R GAD_IMPLICIT_R'
#endif /* SOLVE_DIAGONAL_LOWMEMORY */
           km1=MAX(1,k-1)
           km2=MAX(1,k-2)
           kp1=MIN(Nr,k+1)
           kp2=MIN(Nr,k+2)
C--   Flux_divergence*deltaT = Tr^n - Tr^n+1 = [A-I](Tr^n+1)
C                            = deltaT*rkSign*[ Flx_k+1 - Flx_k ]/dz
           DO j=jMin,jMax
            DO i=iMin,iMax
              div(i,j) = gTracer(i,j,k)*( c5d(i,j,k) - 1. _d 0 )
     &                 + gTracer(i,j,km1)*b5d(i,j,k)
     &                 + gTracer(i,j,kp1)*d5d(i,j,k)
            ENDDO
           ENDDO
           IF ( diagonalNumber .EQ. 5 ) THEN
            DO j=jMin,jMax
             DO i=iMin,iMax
              div(i,j) = div(i,j)
     &                 + gTracer(i,j,km2)*a5d(i,j,k)
     &                 + gTracer(i,j,kp2)*e5d(i,j,k)
             ENDDO
            ENDDO
           ENDIF
#ifdef NONLIN_FRSURF
           IF ( nonlinFreeSurf.GT.0 ) THEN
C--    use future hFac to stay consistent with solver matrix
            IF ( select_rStar.GT.0 ) THEN
             DO j=jMin,jMax
              DO i=iMin,iMax
               div(i,j) = div(i,j)*h0FacC(i,j,k,bi,bj)*drF(k)
     &                            *rStarFacC(i,j,bi,bj)
              ENDDO
             ENDDO
            ELSEIF ( selectSigmaCoord.NE.0 ) THEN
             DO j=jMin,jMax
              DO i=iMin,iMax
               div(i,j) = div(i,j)*(
     &               _hFacC(i,j,k,bi,bj)*drF(k)
     &              + dBHybSigF(k)*dEtaHdt(i,j,bi,bj)*deltaTFreeSurf
     &                             )
              ENDDO
             ENDDO
            ELSE
             DO j=jMin,jMax
              DO i=iMin,iMax
               IF ( k.EQ.kSurfC(i,j,bi,bj) ) THEN
                div(i,j) = div(i,j)*hFac_surfC(i,j,bi,bj)*drF(k)
               ELSE
                div(i,j) = div(i,j)*_hFacC(i,j,k,bi,bj)*drF(k)
               ENDIF
              ENDDO
             ENDDO
            ENDIF
           ELSE
#else /* NONLIN_FRSURF */
           IF ( .TRUE. ) THEN
#endif /* NONLIN_FRSURF */
C--    use current hFac (consistent with solver matrix)
             DO j=jMin,jMax
              DO i=iMin,iMax
               div(i,j) = div(i,j)*_hFacC(i,j,k,bi,bj)*drF(k)
              ENDDO
             ENDDO
           ENDIF
           DO j=jMin,jMax
            DO i=iMin,iMax
              flx(i,j) = flx(i,j)
cc#ifdef ALLOW_AUTODIFF_OPENAD
cc     &                - rkSign*div(i,j)*rA(i,j,bi,bj)%v/deltaTLev(k)
cc#else
     &                - rkSign*div(i,j)*rA(i,j,bi,bj)
     &                        *deepFac2C(k)*rhoFacC(k)/deltaTLev(k)
cc#endif
              af(i,j) = flx(i,j) - df(i,j)
            ENDDO
           ENDDO
           diagName = 'ADVr'//diagSufx
           CALL DIAGNOSTICS_FILL(af,diagName, k,1, 2,bi,bj, myThid)
#ifdef ALLOW_LAYERS
           IF ( layers_useThermo ) THEN
             CALL LAYERS_FILL(af,tracerIdentity,'AFR',
     &                            k,1,2,bi,bj,myThid)
           ENDIF
#endif /* ALLOW_LAYERS */
          ENDIF

C--      end diagnostics k loop
         ENDDO
        ENDIF
      ENDIF
#endif /* ALLOW_DIAGNOSTICS */

C--   end if Nr > 1
      ENDIF

      RETURN
      END

#include "SMOOTH_OPTIONS.h"
#ifdef ALLOW_SHELFICE
# include "SHELFICE_OPTIONS.h"
#endif

      SUBROUTINE SMOOTH_FILTERVAR2D( smoothOpNb, myThid )

C     *==========================================================*
C     | SUBROUTINE smooth_filtervar2D
C     | o Routine that computes the filter variance
C     |   field associated with a diffusion operator, as part
C     |   a 2D spatial correlation operator (smooth_correld2D.F)
C     |   See Weaver and Courtier 01 for details.
C     *==========================================================*

      IMPLICIT NONE

c     == global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "SMOOTH.h"
#ifdef ALLOW_SHELFICE
# include "SHELFICE.h"
#endif

c     == routine arguments ==
      INTEGER smoothOpNb, myThid

c     == external functions ==
      REAL*8   port_rand, port_rand_norm
      EXTERNAL PORT_RAND, PORT_RAND_NORM

c     == local variables ==
      INTEGER i,j,bi, bj, ii, jj
      INTEGER diLoc,djLoc
      INTEGER nbRand, nbt_in
      CHARACTER*(MAX_LEN_FNAM) fnamegeneric
      _RL smoothTmpFld (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL smoothTmpVar (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL smoothTmpMean(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RS smooth2Dmask (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)

      INTEGER IL

c     == functions ==
      INTEGER  ILNBLNK
      EXTERNAL ILNBLNK

c     == end of interface ==

      IL = ILNBLNK( smoothDir )

c --- allow a different mask other than maskC
c     Note: this is essentially a copy of ctrl_get_mask
c     but is repeated here for package independence
c     since this subroutine is typically used simply to get
c     filter variance without actually running the model
      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        DO j = 1-OLy,sNy+OLy
         DO i = 1-OLx,sNx+OLx
          IF (smooth2DmaskName(smoothOpNb)(1:5).EQ.'maskC') THEN
           smooth2Dmask(i,j,bi,bj) = maskC(i,j,1,bi,bj)
          ELSEIF (smooth2DmaskName(smoothOpNb)(1:5).EQ.'maskW') THEN
           smooth2Dmask(i,j,bi,bj) = maskW(i,j,1,bi,bj)
          ELSEIF (smooth2DmaskName(smoothOpNb)(1:5).EQ.'maskS') THEN
           smooth2Dmask(i,j,bi,bj) = maskS(i,j,1,bi,bj)
#ifdef ALLOW_SHELFICE
          ELSEIF (smooth2DmaskName(smoothOpNb)(1:5).EQ.'maskI') THEN
           smooth2Dmask(i,j,bi,bj) = maskSHI(i,j,1,bi,bj)
#endif
          ENDIF
         ENDDO
        ENDDO
       ENDDO
      ENDDO

c if smooth2Dfilter(smoothOpNb)=0: the filter variance field
c has been computed earlier and is already in the run directory
c so this routine does not do anything

      IF (smooth2Dfilter(smoothOpNb).NE.0) THEN

      nbt_in=smooth2Dnbt(smoothOpNb)/2

c read smoothing [i.e diffusion] operator:
      WRITE(fnamegeneric,'(2A,I3.3)')
     &      smoothDir(1:IL),
     &      'smooth2Doperator',smoothOpNb
      CALL READ_REC_3D_RL(fnamegeneric,smoothprec,
     &           1,smooth2D_Kux,1,1,myThid)
      CALL READ_REC_3D_RL(fnamegeneric,smoothprec,
     &           1,smooth2D_Kvy,2,1,myThid)
      CALL EXCH_XY_RL ( smooth2D_Kux, myThid )
      CALL EXCH_XY_RL ( smooth2D_Kvy, myThid )

c initialize filter variance field:
      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           smooth2Dnorm(i,j,bi,bj)=0.
          ENDDO
         ENDDO
       ENDDO
      ENDDO

      IF (smooth2Dfilter(smoothOpNb).EQ.2) THEN
c compute the normalization matrix using the approximate method
c
c This method can be quite expensive -- so that the approximate
c method (see below) is usually the prefered one.
c The exact method can be used to check the accuracy
c of the approximate method results (that can be predicted).
c
c note: the exact method requires the adjoint of smooth_diff2D.F (see below)

      diLoc=15 !int(5*smooth_L/smooth_dx)
      djLoc=20 !int(5*smooth_L/smooth_dx)

      DO ii=1,diLoc
      DO jj=1,djLoc

      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           smoothTmpFld(i,j,bi,bj)=0.
          ENDDO
         ENDDO

         DO j=jj,sNy,djLoc
          DO i=ii,sNx,diLoc
           smoothTmpFld(i,j,bi,bj)=1.
          ENDDO
         ENDDO
       ENDDO
      ENDDO

c note: as we go to adjoint part, we need to have 0 in overlaps
c       so we must NOT have done an exchange for smoothTmpFld

c adjoint:
      WRITE(errorMessageUnit,'(A,/,A)' )
     & "you need to have adsmooth_diff2D compiled and then:",
     & "uncomment the line below and comment the stop"
      CALL ALL_PROC_DIE( myThid )
      STOP 'ABNORMAL END: S/R smooth_filtervar2D'
c      call adsmooth_diff2D(smoothTmpFld,smooth2dmask,nbt_in,myThid)

c division by sqrt(area)*sqrt(area) [1 to end adj, 1 to begin fwd]
      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        DO j = 1,sNy
         DO i = 1,sNx
c division by ~volume:
      smoothTmpFld(i,j,bi,bj)=smoothTmpFld(i,j,bi,bj)
     & *recip_rA(i,j,bi,bj)
         ENDDO
        ENDDO
       ENDDO
      ENDDO

c coming out of adjoint part: overlaps are 0
c going in fwd part: we need to fill them up
      CALL EXCH_XY_RL ( smoothTmpFld,myThid )

c fwd:
      CALL smooth_diff2D(smoothTmpFld,smooth2dmask,nbt_in,myThid)

c convert variance to normalization factor:
      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
         DO j=jj,sNy,djLoc
          DO i=ii,sNx,diLoc
           if (smooth2dmask(i,j,bi,bj).NE.0) then
              smooth2Dnorm(i,j,bi,bj)=
     &        1/sqrt(smoothTmpFld(i,j,bi,bj))
           endif
          ENDDO
         ENDDO
       ENDDO
      ENDDO

      ENDDO      !DO ii=1,diLoc
      ENDDO      !DO jj=1,djLoc

      ELSEIF (smooth2Dfilter(smoothOpNb).EQ.1) then
c compute the normalization matrix using the approximate method

      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           smoothTmpMean(i,j,bi,bj)   = 0. _d 0
           smoothTmpVar(i,j,bi,bj)   = 0. _d 0
          ENDDO
         ENDDO
       ENDDO
      ENDDO

c initialize random number generator
      smoothTmpFld(1,1,1,1)=port_rand(1.d0)
      nbRand=1000

         DO ii=1,nbRand
            WRITE(standardMessageUnit,'(A,I4,A,I4)')
     & 'smooth_filtervar2D: ',ii,' members done out of',nbRand

c fill smoothTmpFld with random numbers:
      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           smoothTmpFld(i,j,bi,bj)   = 0. _d 0
           if (smooth2dmask(i,j,bi,bj).NE.0) then
           smoothTmpFld(i,j,bi,bj)=port_rand_norm()
           endif
c division by sqrt(area):
      smoothTmpFld(i,j,bi,bj)=smoothTmpFld(i,j,bi,bj)
     & *sqrt(recip_rA(i,j,bi,bj))
          ENDDO
         ENDDO
       ENDDO
      ENDDO

      CALL EXCH_XY_RL ( smoothTmpFld, myThid )

c smooth random number field
      CALL SMOOTH_DIFF2D(smoothTmpFld,smooth2dmask,nbt_in,myThid)

c accumulate statistics (to compute the variance later)
      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
      smoothTmpVar(i,j,bi,bj)=smoothTmpVar(i,j,bi,bj)
     & +smoothTmpFld(i,j,bi,bj)*smoothTmpFld(i,j,bi,bj)/nbRand
      smoothTmpMean(i,j,bi,bj)=smoothTmpMean(i,j,bi,bj)
     & +smoothTmpFld(i,j,bi,bj)/nbRand
          ENDDO
         ENDDO
       ENDDO
      ENDDO

      ENDDO

c compute variance and convert it to normalization factor:
      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           if (smooth2dmask(i,j,bi,bj).NE.0) then
           smooth2Dnorm(i,j,bi,bj)=
     & 1/sqrt ( nbRand/(nbRand-1)* ( smoothTmpVar(i,j,bi,bj) -
     & smoothTmpMean(i,j,bi,bj)*smoothTmpMean(i,j,bi,bj)
     &  )  )
           endif
          ENDDO
         ENDDO
       ENDDO
      ENDDO

      ENDIF

c write smooth2Dnorm to file:
      WRITE(fnamegeneric,'(2A,I3.3)')
     &      smoothDir(1:IL),
     &      'smooth2Dnorm',smoothOpNb
      CALL WRITE_REC_3D_RL(fnamegeneric,smoothprec,
     &            1,smooth2Dnorm,1,1,myThid)
      CALL EXCH_XY_RL ( smooth2Dnorm,  myThid )

      ENDIF

      RETURN
      END

#include "CPP_EEOPTIONS.h"

CBOP
C     !ROUTINE: W2_EEBOOT

C     !INTERFACE:
      SUBROUTINE W2_EEBOOT

C     !DESCRIPTION:
C     *==========================================================*
C     | SUBROUTINE W2_EEBOOT
C     | o Setup execution "environment" for WRAPPER2
C     *==========================================================*
C     | WRAPPER2 provides complex topology support. In this routine
C     | we setup the base topology for the default halo operations.
C     *==========================================================*

C     !USES:
      IMPLICIT NONE

#include "SIZE.h"
#include "EEPARAMS.h"
#include "W2_EXCH2_SIZE.h"
#include "W2_EXCH2_TOPOLOGY.h"
#include "W2_EXCH2_PARAMS.h"
CEOP

C     !FUNCTIONS:
      INTEGER  ILNBLNK
      EXTERNAL ILNBLNK

C     !LOCAL VARIABLES:
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      CHARACTER*(MAX_LEN_FNAM) fName
      INTEGER stdUnit, iLen
      INTEGER myThid
      INTEGER ii, I, J
      CHARACTER*(10) fmtStr
      INTEGER iTmp

C     Set dummy myThid value (we are not multi-threaded here)
      myThid = 1

C     Initialise to zero EXCH2_TOPOLOGY common blocks
      exch2_nTiles = 0
      DO I = 1,W2_maxNbTiles
        exch2_tNx(I)    = 0
        exch2_tNy(I)    = 0
        exch2_tBasex(I) = 0
        exch2_tBasey(I) = 0
        exch2_txGlobalo(I) = 0
        exch2_tyGlobalo(I) = 0
        exch2_isWedge(I) = 0
        exch2_isNedge(I) = 0
        exch2_isEedge(I) = 0
        exch2_isSedge(I) = 0
        exch2_myFace(I)  = 0
        exch2_mydNx(I)   = 0
        exch2_mydNy(I)   = 0
        exch2_nNeighbours(I) = 0
        DO J = 1,W2_maxNeighbours
          exch2_neighbourId(J,I)  = 0
          exch2_opposingSend(J,I) = 0
          DO ii = 1,4
           exch2_pij(ii,J,I) = 0
          ENDDO
          exch2_oi(J,I)  = 0
          exch2_oj(J,I)  = 0
          exch2_iLo(J,I) = 0
          exch2_iHi(J,I) = 0
          exch2_jLo(J,I) = 0
          exch2_jHi(J,I) = 0
        ENDDO
      ENDDO
      W2_oUnit = standardMessageUnit

C     Set W2-EXCH2 parameters
      CALL W2_READPARMS( myThid )

      stdUnit = standardMessageUnit
      WRITE(msgBuf,'(A)') '===== Start setting W2 TOPOLOGY:'
      CALL PRINT_MESSAGE( msgBuf, stdUnit, SQUEEZE_RIGHT, myThid )

C     Open message output-file (if needed)
      IF ( W2_printMsg .LT. 0 ) THEN
        iTmp = MAX(4,1 + INT(LOG10(DFLOAT(nPx*nPy))))
        WRITE(fmtStr,'(2(A,I1),A)') '(A,I',iTmp,'.',iTmp,',A)'
        WRITE(fName,fmtStr) 'w2_tile_topology.',myProcId,'.log'
        iLen = ILNBLNK(fName)
        CALL MDSFINDUNIT( W2_oUnit, myThid )
        OPEN( W2_oUnit, file=fName(1:iLen),
     &                  status='unknown', form='formatted')
        WRITE(msgBuf,'(2A)') ' write to log-file: ', fName(1:iLen)
        CALL PRINT_MESSAGE( msgBuf, stdUnit, SQUEEZE_RIGHT, myThid )
      ENDIF

C     Define topology for every tile
      CALL W2_E2SETUP( myThid )

C--   Decide which tiles this process handles;
C     fill also W2_procTileList for Single-CPU-IO and check also tile-size;
C     print tiles connection for this process and set myCommonFlag :
      CALL W2_MAP_PROCS( myThid )

C     Print out the topology communication schedule
      IF ( W2_printMsg .NE. 0 ) THEN
        CALL W2_PRINT_COMM_SEQUENCE( myThid )
      ENDIF

C     Close message output-file (if needed)
      IF ( W2_oUnit.NE.standardMessageUnit ) THEN
        WRITE(msgBuf,'(A)') '===  End TOPOLOGY report ==='
        CALL PRINT_MESSAGE( msgBuf, W2_oUnit, SQUEEZE_BOTH, myThid )
        CLOSE( W2_oUnit )
      ENDIF
      WRITE(msgBuf,'(A)') '=====       setting W2 TOPOLOGY: Done'
      CALL PRINT_MESSAGE( msgBuf, stdUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)') ' '
      CALL PRINT_MESSAGE( msgBuf, stdUnit, SQUEEZE_RIGHT, myThid )

      RETURN
      END

#include "SHAP_FILT_OPTIONS.h"

      SUBROUTINE SHAP_FILT_TRACEROLD( 
     U           field, 
     I           bi, bj, K, myCurrentTime, myThid )
C     /==========================================================\
C     | S/R SHAP_FILT_TRACER                                     |
C     | Applies Shapiro filter to tracer field over one XY slice |
C     | of one tile at a time.                                   |
C     \==========================================================/
      IMPLICIT NONE

C     == Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "SHAP_FILT.h"

C     == Routine arguments
      INTEGER myThid
      _RL     myCurrentTime
      INTEGER bi, bj, K
      _RL field(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)

#ifdef ALLOW_SHAP_FILT

C     == Local variables ==
      _RL tmpFldX(1-OLx:sNx+OLx,1-OLy:sNy+OLy,2)
      _RL tmpFldY(1-OLx:sNx+OLx,1-OLy:sNy+OLy,2)
      INTEGER I,J,N,N1,N2

      DO J=1-OLy,sNy+OLy
       DO I=1-OLx,sNx+OLx
        tmpFldX(i,j,1) = field(i,j,k,bi,bj)
       ENDDO
      ENDDO

C     Extract small-scale noise from tmpFldX (delta_ii^n)
      DO N=1,nShapT
       N1=1+mod(N+1,2)
       N2=1+mod( N ,2)
       DO J=1-OLy,sNy+OLy
        DO I=1-OLx+1,sNx+OLx-1
         tmpFldX(i,j,N2) = -0.25*(
     &    ( tmpFldX(i+1,j,N1)-tmpFldX( i ,j,N1) )
     &        *_maskW(i+1,j,k,bi,bj)
     &   -( tmpFldX( i ,j,N1)-tmpFldX(i-1,j,N1) )
     &        *_maskW(i,j,k,bi,bj) )
        ENDDO
       ENDDO
      ENDDO

#ifdef SEQUENTIAL_2D_SHAP
      DO J=1-OLy,sNy+OLy
       DO I=1-OLx,sNx+OLx
        tmpFldX(i,j,N2) = field(i,j,k,bi,bj) - tmpFldX(i,j,N2)
        tmpFldY(i,j,1) = tmpFldX(i,j,N2)
       ENDDO
      ENDDO
#else
      DO J=1-OLy,sNy+OLy
       DO I=1-OLx,sNx+OLx
        tmpFldY(i,j,1) = field(i,j,k,bi,bj)
       ENDDO
      ENDDO
#endif /* SEQUENTIAL_2D_SHAP */

C     Extract small-scale noise from tmpFldY (delta_jj^n)
      DO N=1,nShapT
       N1=1+mod(N+1,2)
       N2=1+mod( N ,2)
       DO J=1-OLy+1,sNy+OLy-1
        DO I=1-OLx,sNx+OLx
         tmpFldY(i,j,N2) = -0.25*(
     &    ( tmpFldY(i,j+1,N1)-tmpFldY(i, j ,N1) )
     &        *_maskS(i,j+1,k,bi,bj)
     &   -( tmpFldY(i, j ,N1)-tmpFldY(i,j-1,N1) )
     &        *_maskS(i,j,k,bi,bj) )
        ENDDO
       ENDDO
      ENDDO

C     Subtract small-scale noise from field
#ifdef SEQUENTIAL_2D_SHAP
      DO J=1-OLy,sNy+OLy
       DO I=1-OLx,sNx+OLx
        field(i,j,k,bi,bj) = tmpFldX(i,j,N2) - tmpFldY(i,j,N2)
       ENDDO
      ENDDO
#else
      DO J=1-OLy,sNy+OLy
       DO I=1-OLx,sNx+OLx
        field(i,j,k,bi,bj) = field(i,j,k,bi,bj)
     &    -0.5*( tmpFldX(i,j,N2)+tmpFldY(i,j,N2) )
       ENDDO
      ENDDO
#endif /* SEQUENTIAL_2D_SHAP */

#endif /* ALLOW_SHAP_FILT */

      RETURN
      END

#     include "GAD_OPTIONS.h"

      SUBROUTINE GAD_OSC_MUL_X(ix,hh,mask,ohat,scal)
C     |================================================================|
C     | OSC_MUL_X: evaluate WENO oscillation weights in X.             |
C     |================================================================|

          implicit none

C     =============================================== global variables
#         include "SIZE.h"

          integer ix,hh
          _RL mask(1-OLx:sNx+OLx)
          _RL ohat(1:2,
     &             1-OLx:sNx+OLx)
          _RL scal(1:2)

          integer ii
          _RL dels,dfs1,dfs2
          _RL osum,zero,mval
          _RL oval,omin,omax

C     =============================== calc. WENO oscillation weighting
c         omin = +huge(+1. _d 0)
c         omax = -huge(+1. _d 0)
          omin = +1. _d 99
          omax = -1. _d 99

          zero = 1. _d -20
          mval = 1. _d + 0

          do  ii = ix-hh, ix+hh

C     =============================== calc. derivatives centred on II.
              dels = (ii - ix) * 2. _d 0

              dfs1 = ohat(1,ii)
              dfs2 = ohat(2,ii)

              dfs1 = dfs1 + dfs2 * dels

C     =============================== oscl. = NORM(H^N * D^N/DX^N(F)).
              oval = (2. _d 0 * dfs1)**2
     &             + (4. _d 0 * dfs2)**2

              if (oval.lt.omin) omin = oval
              if (oval.gt.omax) omax = oval

C     =============================== any mask across oscil. stencil
              mval = mval * mask(ii)

          end do

          if (mval .gt. 0. _d 0) then

C     =============================== calc. WENO-style profile weights
              scal(1) = 1. _d 5
     &             / (omax + zero)**3
              scal(2) = 1. _d 0
     &             / (omin + zero)**3

              osum = scal(1) + scal(2)
              scal(1) = scal(1) / osum
              scal(2) = scal(2) / osum

          else

C     =============================== default to MONO. profile weights
              scal(1) = 0. _d 0
              scal(2) = 1. _d 0

          end if

          return

c     end subroutine GAD_OSC_MUL_X
      end

#include "CHEAPAML_OPTIONS.h"

CBOP
C     !ROUTINE: CHEAPAML_TIMESTEP
C     !INTERFACE:
      SUBROUTINE CHEAPAML_TIMESTEP(
     I                     bi, bj, iMin, iMax, jMin, jMax,
     I                     deltaTloc,
     I                     gTracer,
     U                     tracer,
     I                     nSubIter, myIter, myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R CHEAPAML_TIMESTEP
C     | o Step cheapaml tracer field forward in time
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     == Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine Arguments ==
      INTEGER bi,bj,iMin,iMax,jMin,jMax
      _RL  gTracer(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL  tracer (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL  deltaTloc
      INTEGER nSubIter, myIter, myThid

C     !LOCAL VARIABLES:
C     == Local variables ==
      INTEGER i,j
CEOP

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C-    Step tracer forward in time
      DO j=jMin,jMax
        DO i=iMin,iMax
          tracer(i,j,bi,bj) = tracer(i,j,bi,bj)
     &            + deltaTloc*gTracer(i,j,bi,bj)
        ENDDO
      ENDDO

      RETURN
      END

#include "PACKAGES_CONFIG.h"
#include "CPP_OPTIONS.h"

#ifdef ALLOW_GMREDI
# include "GMREDI_OPTIONS.h"
#endif

      SUBROUTINE CALC_EDDY_STRESS( bi, bj, myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R CALC_EDDY_STRESS
C     | o Calculates the eddy stress when running a residual
C     |   ocean model
C     *==========================================================*
C     | Calculates the eddy stress.  Later this will be added to
C     | gU the same as external sources (e.g. wind stress, bottom
C     | friction, etc.
C     *==========================================================*
C     \ev

      IMPLICIT NONE

#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "FFIELDS.h"
#ifdef ALLOW_GMREDI
# include "GMREDI.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
      INTEGER bi,bj
      INTEGER myThid
#ifdef ALLOW_EDDYPSI

C     !LOCAL VARIABLES:
C     == Local variables ==
C     Loop counters
      INTEGER i,j,k
C     Interpolated stream function and coriolis
      _RL psix, psiy, coriU, coriV

C     Calculate the eddy stress from the eddy induced streamfunction
#ifdef ALLOW_GMREDI
      IF ( GM_InMomAsStress ) THEN
#endif
        DO k=1,Nr

         DO j=1-OLy,sNy+OLy-1
          DO i=1-OLx+1,sNx+OLx
#ifdef ALLOW_GMREDI
           psiy = op25*(GM_PsiY(i,  j  ,k,bi,bj)
     &                 +GM_PsiY(i,  j+1,k,bi,bj)
     &                 +GM_PsiY(i-1,j  ,k,bi,bj)
     &                 +GM_PsiY(i-1,j+1,k,bi,bj))
#else
           psiy = op25*(eddyPsiY(i,  j  ,k,bi,bj)
     &                 +eddyPsiY(i,  j+1,k,bi,bj)
     &                 +eddyPsiY(i-1,j  ,k,bi,bj)
     &                 +eddyPsiY(i-1,j+1,k,bi,bj))
#endif
           coriU = op5*(fcori(i-1,j,bi,bj)
     &                 +fCori(i  ,j,bi,bj))
           tauxEddy(i,j,k,bi,bj) =  rhoConst*coriU*psiy
          ENDDO
         ENDDO

         DO j=1-OLy+1,sNy+OLy
          DO i=1-OLx,sNx+OLx-1
#ifdef ALLOW_GMREDI
           psix = op25*(GM_PsiX(i,  j  ,k,bi,bj)
     &                 +GM_PsiX(i+1,j  ,k,bi,bj)
     &                 +GM_PsiX(i  ,j-1,k,bi,bj)
     &                 +GM_PsiX(i+1,j-1,k,bi,bj))
#else
           psix = op25*(eddyPsiX(i,  j  ,k,bi,bj)
     &                 +eddyPsiX(i+1,j  ,k,bi,bj)
     &                 +eddyPsiX(i  ,j-1,k,bi,bj)
     &                 +eddyPsiX(i+1,j-1,k,bi,bj))
#endif
           coriV = op5*(fcori(i,j-1,bi,bj)
     &                 +fCori(i,j  ,bi,bj))
           tauyEddy(i,j,k,bi,bj) = -rhoConst*coriV*psix
          ENDDO
         ENDDO

C-    end k loop
        ENDDO

#ifdef ALLOW_DIAGNOSTICS
        IF ( useDiagnostics ) THEN
          CALL DIAGNOSTICS_FILL( tauxEddy, 'TAUXEDDY',
     &                           0, Nr, 1, bi, bj, myThid )
          CALL DIAGNOSTICS_FILL( tauyEddy, 'TAUYEDDY',
     &                           0, Nr, 1, bi, bj, myThid )
        ENDIF
#endif
#ifdef ALLOW_GMREDI
      ENDIF
#endif
#endif /* ALLOW_EDDYPSI */
      RETURN
      END

#include "PACKAGES_CONFIG.h"
#include "CPP_OPTIONS.h"

CBOP
C     !ROUTINE: DO_FIELDS_BLOCKING_EXCHANGES
C     !INTERFACE:
      SUBROUTINE DO_FIELDS_BLOCKING_EXCHANGES(myThid)

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE DO_FIELDS_BLOCKING_EXCHANGES
C     | o Controlling routine for exchanging edge info.
C     *==========================================================*
C     | One key trick used in UV us that we over-compute and
C     | arrange our time-stepping loop so that we only need one
C     | edge exchange for the explicit code per timestep.
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     == Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "DYNVARS.h"
#ifdef ALLOW_LONGSTEP
#include "LONGSTEP.h"
#endif
#ifdef ALLOW_GENERIC_ADVDIFF
# include "GAD.h"
#endif
#ifdef ALLOW_CD_CODE
# include "CD_CODE_VARS.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     myThid :: my Thread Id number
      INTEGER myThid
CEOP

C     !LOCAL VARIABLES:
C     bi, bj :: tile indices
#ifdef ALLOW_OBCS
c     INTEGER bi, bj
#endif /* ALLOW_OBCS */

      IF ( .NOT.useOffLine ) THEN
C-    Apply Exchanges on dynamics state variable, except in Off-Line mode

      IF ( .NOT.staggerTimeStep ) THEN
       IF ( .NOT.applyExchUV_early )
     &  CALL EXCH_UV_XYZ_RL(uVel,vVel,.TRUE.,myThid)
       IF ( .NOT.implicitIntGravWave )
     & _EXCH_XYZ_RL( wVel , myThid )
      ENDIF
c     IF ( exactConserv .AND. implicDiv2Dflow .NE. 0. _d 0)
c    & _EXCH_XY_RL( etaN , myThid )
      IF ( .NOT.implicitIntGravWave ) THEN
       _EXCH_XYZ_RL( theta, myThid )
       _EXCH_XYZ_RL( salt , myThid )
      ENDIF
#ifdef ALLOW_OBCS
c     IF ( useOBCS ) THEN
c      DO bj = myByLo(myThid), myByHi(myThid)
c       DO bi = myBxLo(myThid), myBxHi(myThid)
c        CALL OBCS_COPY_TRACER( theta(1-OLx,1-OLy,1,bi,bj),
c    I                          Nr, bi, bj, myThid )
c        CALL OBCS_COPY_TRACER( salt (1-OLx,1-OLy,1,bi,bj),
c    I                          Nr, bi, bj, myThid )
c       ENDDO
c      ENDDO
c     ENDIF
#endif /* ALLOW_OBCS */

#ifdef ALLOW_GENERIC_ADVDIFF
      IF ( tempSOM_Advection .OR. saltSOM_Advection )
     &  CALL GAD_SOM_EXCHANGES( myThid )
#endif

#ifdef ALLOW_CD_CODE
      CALL EXCH_UV_DGRID_3D_RL( uVelD,vVelD, .TRUE., Nr, myThid )
#endif
      IF ( storePhiHyd4Phys )
     & _EXCH_XYZ_RL( totPhiHyd , myThid )
C-    if not useOffLine: end
      ENDIF

#ifdef ALLOW_PTRACERS
#ifdef ALLOW_LONGSTEP
      IF ( LS_doTimeStep ) THEN
#else
      IF ( .TRUE. ) THEN
#endif
      IF (usePTRACERS)
     &  CALL PTRACERS_FIELDS_BLOCKING_EXCH(myThid)
C     endif LS_doTimeStep
      ENDIF
#endif /* ALLOW PTRACERS */

      RETURN
      END

#include "SHAP_FILT_OPTIONS.h"

CBOP
C     !ROUTINE: SHAP_FILT_DIAGNOSTICS_INIT
C     !INTERFACE:
      SUBROUTINE SHAP_FILT_DIAGNOSTICS_INIT( myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE SHAP_FILT_DIAGNOSTICS_INIT
C     | o Routine to initialize list of all available diagnostics
C     |   for SHAP_FILT package
C     *==========================================================*
C     \ev
C     !USES:
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
C     myThid ::  my thread Id number
      INTEGER myThid
CEOP

#ifdef ALLOW_DIAGNOSTICS
C     ! FUNCTIONS:
      CHARACTER*16 DIAGS_MK_UNITS
      EXTERNAL     DIAGS_MK_UNITS

C     !LOCAL VARIABLES:
C     === Local variables ===
C     diagNum   :: diagnostics number in the (long) list of available diag.
C     diagMate  :: diag. mate number in the (long) list of available diag.
C     diagName  :: local short name (8c) of a diagnostics
C     diagCode  :: local parser field with characteristics of the diagnostics
C              cf head of S/R DIAGNOSTICS_INIT_EARLY or DIAGNOSTICS_MAIN_INIT
C     diagUnits :: local string (16c): physical units of a diagnostic field
C     diagTitle :: local string (80c): description of field in diagnostic
      INTEGER       diagNum
      INTEGER       diagMate
      CHARACTER*8   diagName
      CHARACTER*16  diagCode
      CHARACTER*16  diagUnits
      CHARACTER*(80) diagTitle
      CHARACTER*10  trUnits

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

c     IF ( useDiagnostics ) THEN

C-    Shapiro Filter tendency:

        diagName  = 'SHAP_dT '
        diagTitle = 'Temperature Tendency due to Shapiro Filter'
        diagUnits = 'K/s             '
        diagCode  = 'SMR     MR      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

        trUnits = 'kg/kg'
        IF ( fluidIsWater .OR. useAIM ) trUnits = 'g/kg'
        diagName  = 'SHAP_dS '
        diagTitle = 'Specific Humidity Tendency due to Shapiro Filter'
        diagUnits =  DIAGS_MK_UNITS( trUnits//'/s', myThid )
        diagCode  = 'SMR     MR      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

        diagName  = 'SHAP_dU '
        diagTitle = 'Zonal Wind Tendency due to Shapiro Filter'
        diagUnits = 'm/s^2           '
        diagCode  = 'UUR     MR      '
        diagMate  = diagNum + 2
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I    diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

        diagName  = 'SHAP_dV '
        diagTitle = 'Meridional Wind Tendency due to Shapiro Filter'
        diagUnits = 'm/s^2           '
        diagCode  = 'VVR     MR      '
        diagMate  = diagNum
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I    diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

        diagName  = 'SHAP_dKE'
        diagTitle =
     &  'Kinetic Energy Tendency due to Shapiro Filter (Mass Weighted)'
        diagUnits = 'm^2/s^3         '
        diagCode  = 'SMr     MR      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

c     ENDIF

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#endif /* ALLOW_DIAGNOSTICS */

      RETURN
      END

#include "ECCO_OPTIONS.h"
#ifdef ALLOW_SEAICE
# include "SEAICE_OPTIONS.h"
#endif

C--  File cost_gencost_seaicev4.F:
C--   Contents
C--   o COST_GENCOST_SEAICEV4
C--   o GET_EXCONC_DECONC

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      subroutine cost_gencost_seaicev4(myThid)

c     ==================================================================
c     SUBROUTINE cost_gencost_seaicev4
c     ==================================================================
c
c     o Evaluate cost function contributions of ice concentration.
c
c     ==================================================================
c     SUBROUTINE cost_gencost_seaicev4
c     ==================================================================

      implicit none

c     == global variables ==

#include "EEPARAMS.h"
#include "SIZE.h"
#include "PARAMS.h"
#include "GRID.h"
#ifdef ALLOW_CAL
# include "cal.h"
#endif
#ifdef ALLOW_ECCO
# include "ECCO_SIZE.h"
# include "ECCO.h"
#endif
c#ifdef ALLOW_SEAICE
c# include "SEAICE_SIZE.h"
c# include "SEAICE_COST.h"
c# include "SEAICE_PARAMS.h"
c#endif

c     == routine arguments ==
      integer myThid

#ifdef ALLOW_SEAICE
#ifdef ALLOW_GENCOST_CONTRIBUTION

c     == local variables ==

      integer nrecloc
      integer localstartdate(4)

catn changing names to make more self-explanatory
c old:sst  -> model has deficiency in iceconc -> new:deconc
c old:heff -> model has excess of iceconc     -> new:exconc

      _RL areabar    (1-OLx:sNx+OLx,1-OLy:sNy+OLy,1,nSx,nSy)
      _RL deconcbar  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,1,nSx,nSy)
      _RL exconcbar  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,1,nSx,nSy)
      _RL localweight  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,1,nSx,nSy)
      _RL dummy
      _RL localperiod
      _RL spminloc
      _RL spmaxloc
      _RL spzeroloc

      character*(MAX_LEN_FNAM) areabarfile
      character*(MAX_LEN_FNAM) deconcbarfile
      character*(MAX_LEN_FNAM) exconcbarfile
      character*(MAX_LEN_FNAM) localobsfile

      integer igen_conc, igen_deconc, igen_exconc

      integer bi,bj
      integer k
      integer irec, jrec
      integer  il, k2
      integer localrec
      integer obsrec
      logical dosumsq, dovarwei

      integer preproc_i(NGENPPROC)
      _RL preproc_r(NGENPPROC)
      character*(MAX_LEN_FNAM) preproc(NGENPPROC)
      character*(MAX_LEN_FNAM) preproc_c(NGENPPROC)

      _RL localmask  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,1,nSx,nSy)
      _RL localobs   (1-OLx:sNx+OLx,1-OLy:sNy+OLy,1,nSx,nSy)
      _RL localtmp   (1-OLx:sNx+OLx,1-OLy:sNy+OLy,1,nSx,nSy)
      _RL localdif   (1-OLx:sNx+OLx,1-OLy:sNy+OLy,1,nSx,nSy)
      _RL difmask    (1-OLx:sNx+OLx,1-OLy:sNy+OLy,1,nSx,nSy)
      _RL difmask1   (1-OLx:sNx+OLx,1-OLy:sNy+OLy,1,nSx,nSy)

      character*(128) fname0, fname0w, fname1

      character*(MAX_LEN_FNAM) localobswfile
      logical exst

c     == external functions ==

      integer  ilnblnk
      external ilnblnk

c     == end of interface ==

c=============== PART 0: initilization ===================

c-- detect the relevant gencost indices
      igen_conc=0
      igen_deconc=0
      igen_exconc=0
      do k=1,NGENCOST
        if (gencost_name(k).EQ.'siv4-conc') igen_conc=k
        if (gencost_name(k).EQ.'siv4-deconc') igen_deconc=k
        if (gencost_name(k).EQ.'siv4-exconc') igen_exconc=k
      enddo

c-- Dependency:
c A) igen_conc can exist on its own
c B) igen_deconc needs igen_conc
c C) igen_exconc needs both igen_conc and igen_deconc
      if (igen_conc.NE.0) then

c-- initialize objf and num:
      do bj = myByLo(myThid), myByHi(myThid)
        do bi = myBxLo(myThid), myBxHi(myThid)
          objf_gencost(bi,bj,igen_conc) = 0. _d 0
          num_gencost(bi,bj,igen_conc)  = 0. _d 0
          if(igen_deconc.ne.0) then
            objf_gencost(bi,bj,igen_deconc) = 0. _d 0
            num_gencost(bi,bj,igen_deconc)  = 0. _d 0
          endif
          if(igen_exconc.ne.0) then
            objf_gencost(bi,bj,igen_exconc) = 0. _d 0
            num_gencost(bi,bj,igen_exconc)  = 0. _d 0
          endif
        enddo
      enddo

c--   Initialise local variables.
      nrecloc=0
      localperiod=0.

      areabarfile=gencost_barfile(igen_conc)
      if(igen_deconc.ne.0) deconcbarfile=gencost_barfile(igen_deconc)
      if(igen_exconc.ne.0) exconcbarfile=gencost_barfile(igen_exconc)

      localobsfile=gencost_datafile(igen_conc)
      localobswfile=gencost_errfile(igen_conc)
      dummy=gencost_dummy(igen_conc)
      localstartdate(1)=modelstartdate(1)
      localstartdate(2)=modelstartdate(2)
      localstartdate(3)=modelstartdate(3)
      localstartdate(4)=modelstartdate(4)
      spminloc=gencost_spmin(igen_conc)
      spmaxloc=gencost_spmax(igen_conc)
      spzeroloc=gencost_spzero(igen_conc)

      localperiod=gencost_period(igen_conc)
      nrecloc=gencost_nrec(igen_conc)

c-- flag to add cost: true=(obs-mod)*(obs-mod)*weight
      dosumsq=.TRUE.
      dovarwei=.FALSE.
      do k2 = 1, NGENPPROC
        preproc(k2)=gencost_preproc(k2,igen_conc)
        preproc_i(k2)=gencost_preproc_i(k2,igen_conc)
        preproc_c(k2)=gencost_preproc_c(k2,igen_conc)
        preproc_r(k2)=gencost_preproc_r(k2,igen_conc)
        if (preproc(k2).EQ.'variaweight') dovarwei=.TRUE.
        if (preproc(k2).EQ.'nosumsq') dosumsq=.FALSE.
      enddo

c--   initialize arrays, copy 2D maskInC to 2D localmask; this means
c     that sea ice cost function contributions on open boundary points
c     are masked out, probably something that eccov4 can live
c     with. Alternatively, on has to copy the first level of maskC to
c     localmask explicitly.
      call ecco_zero(localobs,1,spzeroloc,myThid)
      call ecco_zero(localweight,1,zeroRL,myThid)
      call ecco_zero(localmask,1,zeroRL,myThid)
      call ecco_cprsrl(maskInC,localmask,1,1,myThid)

c=============== PART 1: main loop ===================
      if ( .NOT. ( localobsfile.EQ.' ' ) ) then

c--   Loop over records for the second time.
      do irec = 1, nrecloc

c====================================================
c--------- PART 1.1 read weights --------------------
c====================================================
        exst=.FALSE.
        jrec=1
        if( dovarwei ) jrec = irec
        call cost_gencal(areabarfile,gencost_errfile(igen_conc),
     &     jrec, localstartdate, localperiod, fname1,
     &     fname0w, localrec, obsrec, exst, myThid)
        call ecco_zero(localweight,1,zeroRL,myThid)
#ifdef SEAICECOST_JPL
       fname0w=gencost_errfile(igen_conc)
       call ecco_readwei(fname0w,localweight,localrec,
     &      1,1,dosumsq,myThid)
       call ecco_readwei(gencost_errfile(igen_deconc),
     &      gencost_weight(1-OLx,1-OLy,1,1,igen_deconc),localrec,
     &      1,1,dosumsq,myThid)
       call ecco_readwei(gencost_errfile(igen_exconc),
     &      gencost_weight(1-OLx,1-OLy,1,1,igen_exconc),localrec,
     &      1,1,dosumsq,myThid)
#else
        if ( (localrec. GT. 0).AND.(obsrec .GT. 0).AND.(exst) ) then
          call ecco_readwei(fname0w,localweight,localrec,
     &      1,1,dosumsq,myThid)
        else
          WRITE(standardMessageUnit,'(A)')
     &     'siv4cost WARNING: ALL WEIGHTS ZEROS! NO CONTRIBUTION'
        endif
#endif

c====================================================
c--------- PART 1.2 read barfiles ------------------
c====================================================
c-- set all bars to zeros:
        call ecco_zero(areabar,1,zeroRL,myThid)
        call ecco_zero(deconcbar,1,zeroRL,myThid)
        call ecco_zero(exconcbar,1,zeroRL,myThid)

c--1.2.A sea-ice concentration barfile
        exst=.FALSE.
        call cost_gencal(areabarfile,gencost_datafile(igen_conc),
     &   irec,localstartdate,localperiod,fname1,
     &   fname0,localrec,obsrec,exst,myThid)
        call cost_genread(fname1,areabar,localtmp,irec,1,1,
     &       nrecloc,preproc,preproc_c,preproc_i,preproc_r,
     &       dummy,myThid)

c--1.2.B sst as proxy for deconc barfile, needs igen_conc
        if(igen_deconc.ne.0) then
         exst=.FALSE.
         call cost_gencal(deconcbarfile,gencost_datafile(igen_conc),
     &    irec,localstartdate,localperiod,fname1,
     &    fname0,localrec,obsrec,exst,myThid)
         call cost_genread(fname1,deconcbar,localtmp,
     &        irec,1,1,
     &        nrecloc,preproc,preproc_c,preproc_i,preproc_r,
     &        dummy,myThid)
        endif

c--1.2.C heff as proxy for exconc barfile, need igen_conc and igen_exconc
        if(igen_deconc.ne.0 .and. igen_exconc.ne.0) then
         exst=.FALSE.
         call cost_gencal(exconcbarfile,gencost_datafile(igen_conc),
     &    irec,localstartdate,localperiod,fname1,
     &    fname0,localrec,obsrec,exst,myThid)
         call cost_genread(fname1,exconcbar,localtmp,
     &        irec,1,1,
     &        nrecloc,preproc,preproc_c,preproc_i,preproc_r,
     &        dummy,myThid)
        endif

c====================================================
c--------- PART 1.3 read data --------------------
c====================================================
c-- initialize to spzerloc = -9999.
        call ecco_zero(localobs,1,spzeroloc,myThid)
        if ( (localrec .GT. 0).AND.(obsrec .GT. 0).AND.(exst) ) then
         CALL READ_REC_3D_RL( fname0, cost_iprec, 1,
     &                        localobs, localrec, 0, myThid )
        else
          il=ilnblnk( fname0 )
          WRITE(standardMessageUnit,'(2A)')
     &     'siv4cost WARNING: DATA MISING! NO CONTRIBUTION, ',
     &     fname0(1:il)
        endif

c====================================================
c--------- PART 1.4 Cost calculation -------------
c====================================================
c compute obs minus bar (localdif) and mask (difmask)
        call ecco_zero(localdif,1,zeroRL,myThid)
        call ecco_zero(difmask,1,zeroRL,myThid)
        call ecco_diffmsk(
     I     areabar, localobs, localmask,
     I     1, 1, spminloc, spmaxloc, spzeroloc,
     O     localdif, difmask,
     I     myThid )

c---1.4.A area term:
        call ecco_addcost(
     I     localdif,localweight,difmask,1,1,dosumsq,
     O     objf_gencost(1,1,igen_conc),num_gencost(1,1,igen_conc),
     I     myThid)

c---1.4.B defficient ice term: (old: sst term, new: deconc)
c Add ice: model_A==0 but obs_A > 0, calc enthalpy E:
        if(igen_deconc.ne.0) then
         call ecco_zero(difmask1,1,zeroRL,myThid)
         call ecco_zero(localdif,1,zeroRL,myThid)
         call ecco_zero(localtmp,1,zeroRL,myThid)

         call get_exconc_deconc(
     I    localobs,1,areabar,exconcbar,deconcbar,1,
     I    difmask,'de',
     O    localdif,difmask1,localtmp,
     I    myThid )
#ifdef SEAICECOST_JPL
        call ecco_cp( gencost_weight(1-OLx,1-OLy,1,1,igen_deconc),
     O       localtmp,1,1,myThid)
#endif
        call ecco_addcost(
     I      localdif,localtmp,difmask1,1,1,dosumsq,
     O      objf_gencost(1,1,igen_deconc),num_gencost(1,1,igen_deconc),
     I      myThid)
        endif

c---1.4.C excessive ice term:  (old: heff and sst term, new: exconc)
c Removing ice: model_A > 0 but obs_A==0, calc enthalpy E:
        if(igen_deconc.ne.0 .and. igen_exconc.ne.0) then
         call ecco_zero(difmask1,1,zeroRL,myThid)
         call ecco_zero(localdif,1,zeroRL,myThid)
         call ecco_zero(localtmp,1,zeroRL,myThid)

         call get_exconc_deconc(
     I    localobs,1,areabar,exconcbar,deconcbar,1,
     I    difmask,'ex',
     O    localdif,difmask1,localtmp,
     I    myThid )
#ifdef SEAICECOST_JPL
        call ecco_cp( gencost_weight(1-OLx,1-OLy,1,1,igen_exconc),
     O       localtmp,1,1,myThid)
#endif
        call ecco_addcost(
     I      localdif,localtmp,difmask1,1,1,dosumsq,
     O      objf_gencost(1,1,igen_exconc),num_gencost(1,1,igen_exconc),
     I      myThid)
        endif

      enddo

      endif !if ( .NOT. ( localobsfile.EQ.' ' ) ) then
      endif !if (igen_conc.NE.0)

#endif /* ALLOW_GENCOST_CONTRIBUTION */
#endif /* ALLOW_SEAICE */

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      subroutine get_exconc_deconc(
     I    localobs,nnzobs,concbar,exconcbar,deconcbar,nnzbar,
     I    localmask,flag_exconc_deconc,
     O    localfld,localfldmsk,localfldweight,
     I    myThid )

C     !DESCRIPTION: \bv
c     Routine to calculate Enthalpy for the case of
c     defficient/excessive model seaice
C     \ev

C     !USES:
      implicit none

c     == global variables ==
#include "EEPARAMS.h"
#include "SIZE.h"
#include "PARAMS.h"
#include "GRID.h"
#ifdef ALLOW_SEAICE
# include "SEAICE_SIZE.h"
# include "SEAICE_COST.h"
# include "SEAICE_PARAMS.h"
#endif
#ifdef ALLOW_ECCO
# include "ECCO_SIZE.h"
# include "ECCO.h"
#endif

c     == routine arguments ==

      integer myThid, nnzbar, nnzobs
      _RL localmask     (1-OLx:sNx+OLx,1-OLy:sNy+OLy,1,nSx,nSy)

      _RL localobs      (1-OLx:sNx+OLx,1-OLy:sNy+OLy,1,nSx,nSy)
      _RL concbar       (1-OLx:sNx+OLx,1-OLy:sNy+OLy,1,nSx,nSy)
      _RL deconcbar     (1-OLx:sNx+OLx,1-OLy:sNy+OLy,1,nSx,nSy)
      _RL exconcbar     (1-OLx:sNx+OLx,1-OLy:sNy+OLy,1,nSx,nSy)
      _RL localfld      (1-OLx:sNx+OLx,1-OLy:sNy+OLy,1,nSx,nSy)
      _RL localfldmsk   (1-OLx:sNx+OLx,1-OLy:sNy+OLy,1,nSx,nSy)
      _RL localfldweight(1-OLx:sNx+OLx,1-OLy:sNy+OLy,1,nSx,nSy)

      character*2 flag_exconc_deconc

#ifdef ALLOW_SEAICE
#ifdef ALLOW_GENCOST_CONTRIBUTION

c    == local variables ==
      integer bi,bj
      integer i,j,k

C- jmc: params SEAICE_freeze has been retired; set it locally until someone
C       who knows what this cost-cointribution means fix it.
C- atn: also adding 1 normalizing factor same order of magnitude as
C       rhoNil*HeatCapacity_cp*dz = SEAICE_rhoice*SEAICE_lhFusion*heff
C       = 1e3*1e3*1e1=1e7
C- atn: lastly, define 2 cutoff values for cost to be read in from data.seaice
C      and initialized in seaice_readparms: SEAICE_cutoff_[area,heff]
C      Reason: some iceconc data set have "bogus" mask with area>0
C      at climatological max locations -> not real data.  So either need
C      to clean up the data or take SEAICE_cutoff_area>=0.15 for example.
C      Might need to migrate into pkg/ecco instead of in pkg/seaice.
      _RL SEAICE_freeze, epsilonTemp, epsilonHEFF
      _RL localnorm, localnormsq
      _RL const1,const2
CEOP

      SEAICE_freeze  = -1.96  _d 0
      epsilonTemp = 0.0001 _d 0
#ifdef SEAICECOST_JPL
      epsilonHEFF = 0.3 _d 0
#else
      epsilonHEFF = 0.01 _d 0
#endif
      localnorm = 1. _d -07
      localnormsq=localnorm*localnorm

      const1=HeatCapacity_Cp*rhoNil*drF(1)
      const2=SEAICE_lhFusion*SEAICE_rhoIce

c intialize
      call ecco_zero(localfld,nnzobs,zeroRL,myThid)
      call ecco_zero(localfldmsk,nnzobs,zeroRL,myThid)
      call ecco_zero(localfldweight,nnzobs,zeroRL,myThid)

c----------------------DECONC-------------------------------
catn-- old: sst term, new: deconc
c needs localconcbar and localsstbar
c Add ice: model_A==0 but obs_A > 0, calc enthalpy E:
c E_current = (deconcbar(i,j,k,bi,bj)-Tfreeze)
c             *HeatCapacity_Cp*rhoNil*drF(1)
c HEFF_target = epsilon_HEFF [m]
c E_target  = -(HEFF_target*SEAICE_lhFusion*SEAICE_rhoIce)
c cost=(Model-data)^2
      if(flag_exconc_deconc.EQ.'de') then
        do bj = myByLo(myThid), myByHi(myThid)
          do bi = myBxLo(myThid), myBxHi(myThid)
           do k = 1,nnzobs
            do j = 1-OLy,sNy+OLy
             do i = 1-OLx,sNx+OLx

              if ( (concbar(i,j,k,bi,bj) .LE. 0.).AND.
     &               (localobs(i,j,k,bi,bj) .GT. 0.) ) then

               localfldmsk(i,j,k,bi,bj) = localmask(i,j,k,bi,bj)

#ifndef SEAICECOST_JPL
               localfldweight(i,j,k,bi,bj) = localnormsq
#endif
               localfld(i,j,k,bi,bj) =
     &          (deconcbar(i,j,k,bi,bj)-SEAICE_freeze)*const1
     &               - (-1. _d 0 *epsilonHEFF*const2)
              endif
             enddo
            enddo
           enddo
          enddo
        enddo
      endif

c----------------------EXCONC-------------------------------
catn-- old: heff and sst term, new: exconc
c needs localconcbar, localsstbar, and localheffbar
c Removing ice: model_A > 0 but obs_A==0, calc enthalpy E:
c E_current = [(deconcbar-SEAICE_freeze)*HeatCapacity_Cp*rhoNil*drF(1)
c            - (exconcbar * SEAICE_lhFusion * SEAICE_rhoIce)
c            - (HSNOW * SEAICE_lhFusion * SEAICE_rhoSnow)]
c E_target = (epsilonTemp) * HeatCapacity_Cp * rhoNil * drF(1)
c cost(Model-data)^2

      if(flag_exconc_deconc.EQ.'ex') then
        do bj = myByLo(myThid), myByHi(myThid)
          do bi = myBxLo(myThid), myBxHi(myThid)
           do k = 1,nnzobs
            do j = 1-OLy,sNy+OLy
             do i = 1-OLx,sNx+OLx

              if ((localobs(i,j,k,bi,bj) .LE. SEAICE_cutoff_area).AND.
     &        (exconcbar(i,j,k,bi,bj) .GT. SEAICE_cutoff_heff)) then

               localfldmsk(i,j,k,bi,bj) = localmask(i,j,k,bi,bj)
#ifndef SEAICECOST_JPL
               localfldweight(i,j,k,bi,bj) = localnormsq
#endif
               localfld(i,j,k,bi,bj) =
     &        ( (deconcbar(i,j,k,bi,bj)-SEAICE_freeze)*const1
#ifdef SEAICECOST_JPL
     &         - max(exconcbar(i,j,k,bi,bj),epsilonHEFF)*
#else
     &         - exconcbar(i,j,k,bi,bj)*
#endif
     &           const2 ) - (epsilonTemp*const1)
              endif
             enddo
            enddo
           enddo
          enddo
        enddo
      endif

#endif /* ALLOW_GENCOST_CONTRIBUTION */
#endif /* ALLOW_SEAICE */
      RETURN
      END

#include "ECCO_OPTIONS.h"

      subroutine cost_gencost_assignperiod(
     I                    startofday, startofmonth, startofyear,
     I                    inday,      inmonth,      inyear,
     I                    endofday,   endofmonth,   endofyear,
     O                    startofgen, endofgen,     ingen,
     O                    sum1gen,    genrec,
     I                    myiter, mythid )

c     ==================================================================
c     SUBROUTINE cost_gencost_assignperiod
c     ==================================================================

      implicit none

c     == global variables ==

#include "EEPARAMS.h"
#include "SIZE.h"
#include "PARAMS.h"
#ifdef ALLOW_ECCO
# include "ECCO_SIZE.h"
# include "ECCO.h"
#endif

c     == routine arguments ==

      logical startofday
      logical startofmonth
      logical startofyear
      logical inday
      logical inmonth
      logical inyear
      logical endofday
      logical endofmonth
      logical endofyear
      logical startofgen(NGENCOST)
      logical endofgen(NGENCOST)
      logical ingen(NGENCOST)
      integer sum1gen(NGENCOST)
      integer genrec(NGENCOST)

      integer myiter, mythid

#ifdef ALLOW_GENCOST_CONTRIBUTION
c     == local variables ==

      integer k

c     == end of interface ==

      do k = 1, NGENCOST
       if ( (using_gencost(k)).AND.( (gencost_flag(k).GE.1).OR.
     &         (gencost_avgperiod(k).NE.'     ') ) ) then
         if ( gencost_avgperiod(k) .EQ. 'day' .OR.
     &        gencost_avgperiod(k) .EQ. 'DAY' ) then
            startofgen(k) = startofday
            endofgen(k)   = endofday
            ingen(k)      = inday
            sum1gen(k)    = sum1day
            genrec(k)     = dayrec
         else if ( gencost_avgperiod(k) .EQ. 'month' .OR.
     &        gencost_avgperiod(k) .EQ. 'MONTH' ) then
            startofgen(k) = startofmonth
            endofgen(k)   = endofmonth
            ingen(k)      = inmonth
            sum1gen(k)    = sum1mon
            genrec(k)     = monrec
         else if ( gencost_avgperiod(k) .EQ. 'year' .OR.
     &        gencost_avgperiod(k) .EQ. 'YEAR' ) then
            startofgen(k) = startofyear
            endofgen(k)   = endofyear
            ingen(k)      = inyear
            sum1gen(k)    = sum1year
            genrec(k)     = yearrec
         else if ( gencost_avgperiod(k) .EQ. 'step' .OR.
     &        gencost_avgperiod(k) .EQ. 'STEP' ) then
            startofgen(k) = .TRUE.
            endofgen(k)   = .TRUE.
            ingen(k)      = .TRUE.
            sum1gen(k)    = 1
            genrec(k)     = 1+ myiter - niter0
         else if ( gencost_avgperiod(k) .EQ. 'const' .OR.
     &        gencost_avgperiod(k) .EQ. 'CONST' ) then
            startofgen(k) = .TRUE.
            endofgen(k)   = (myiter.EQ.niter0)
            ingen(k)      = (myiter.EQ.niter0)
            sum1gen(k)    = 1
            genrec(k)     = 1
            print*,'gf-const ',startofgen(k),myiter,niter0
         else
            STOP 'gencost_avgperiod wrongly specified'
         end if
       end if
      end do

#endif /* ALLOW_GENCOST_CONTRIBUTION */

      end

#include "CPP_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: CALC_GRID_ANGLES
C     !INTERFACE:
      SUBROUTINE CALC_GRID_ANGLES( skipCalcAngleC, myThid )

C     !DESCRIPTION: \bv
C     *===================================================================*
C     | SUBROUTINE CALC_GRID_ANGLES
C     | o calculate the angle between geographical north and model grid
C     |   north, assuming that yG holds the geographical coordinates
C     *===================================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     skipCalcAngleC :: skip setting of grid-angle at cell-center location
C     myThid  :: my Thread Id Number
      LOGICAL skipCalcAngleC
      INTEGER myThid
CEOP

C     !LOCAL VARIABLES:
C     == Local variables ==
C     bi,bj  :: Tile indices
C     i, j   :: Loop counters
      INTEGER bi, bj
      INTEGER  i,  j
C     pseudo velocities
      _RL uPseudo(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL vPseudo(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL uC, vC, uNorm, tmpVal
CEOP

C-    For each tile ...
      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)

C-    compute pseudo velocities from stream function psi = -yG*deg2rad,
C     that is, zonal flow
        DO j = 1-OLy,sNy+OLy-1
         DO i = 1-OLx,sNx+OLx
          IF ( _dyG(i,j,bi,bj).GT.0. ) THEN
            uPseudo(i,j) =
     &         - ( yG(i,j,bi,bj) - yG(i,j+1,bi,bj) )*deg2rad
     &         / _dyG(i,j,bi,bj)
          ELSE
            uPseudo(i,j) = 0.
          ENDIF
          u2zonDir(i,j,bi,bj) = rSphere*uPseudo(i,j)
         ENDDO
        ENDDO
        DO j = 1-OLy,sNy+OLy
         DO i = 1-OLx,sNx+OLx-1
          IF ( _dxG(i,j,bi,bj).GT.0. ) THEN
            vPseudo(i,j) =
     &         + ( yG(i,j,bi,bj) - yG(i+1,j,bi,bj) )*deg2rad
     &         / _dxG(i,j,bi,bj)
          ELSE
            vPseudo(i,j) = 0.
          ENDIF
          v2zonDir(i,j,bi,bj) = rSphere*vPseudo(i,j)
         ENDDO
        ENDDO
        IF ( .NOT.skipCalcAngleC ) THEN
         DO j = 1-OLy,sNy+OLy-1
          DO i = 1-OLx,sNx+OLx-1
           uC = 0.5*(uPseudo(i,j) + uPseudo(i+1,j))
           vC = 0.5*(vPseudo(i,j) + vPseudo(i,j+1))
           uNorm = SQRT(uC*uC+vC*vC)
           IF ( uNorm .NE. 0. _d 0 ) uNorm = 1. _d 0/uNorm
           angleCosC(i,j,bi,bj) =  uC*uNorm
           angleSinC(i,j,bi,bj) = -vC*uNorm
          ENDDO
         ENDDO
        ENDIF

C-   To check angular momentum conservation, use an alternative definition
C    of grid-angles cosine (@ U pt) & sine (@ V pt) (consistent with
C    stream-function of solid-body velocity field).
        DO j = 1-OLy,sNy+OLy-1
         DO i = 1-OLx,sNx+OLx
C- Note: most natural way would be to divide by dyG (as below); but scaling by
C        dxC/rAw ensures that u2zonDir is exactly =1 with current Lat-Lon grid
c         tmpVal = _dyG(i,j,bi,bj) * COS( deg2rad*
          tmpVal = _rAw(i,j,bi,bj) * COS( deg2rad*
     &             ( yG(i,j,bi,bj) + yG(i,j+1,bi,bj) )*halfRL )
          IF ( tmpVal.GT.0. ) THEN
            u2zonDir(i,j,bi,bj) =  rSphere
     &          *( SIN( yG(i,j+1,bi,bj)*deg2rad )
     &           - SIN( yG(i, j, bi,bj)*deg2rad )
     &           )* _dxC(i,j,bi,bj)/tmpVal
c    &           )/tmpVal
          ELSE
            u2zonDir(i,j,bi,bj) = 1.
          ENDIF
         ENDDO
        ENDDO
        DO j = 1-OLy,sNy+OLy
         DO i = 1-OLx,sNx+OLx-1
C- Note: most natural way would be to divide by dxG (as below); for symetry
C        reason with u2zonDir expression, we use instead dyC/rAs scaling factor
c         tmpVal = _dxG(i,j,bi,bj) * COS( deg2rad*
          tmpVal = _rAs(i,j,bi,bj) * COS( deg2rad*
     &             ( yG(i,j,bi,bj) + yG(i+1,j,bi,bj) )*halfRL )
          IF ( tmpVal.GT.0. ) THEN
            v2zonDir(i,j,bi,bj) = -rSphere
     &          *( SIN( yG(i+1,j,bi,bj)*deg2rad )
     &           - SIN( yG(i,j,bi,bj)*deg2rad )
     &           )* _dyC(i,j,bi,bj)/tmpVal
c    &           )/tmpVal
          ELSE
            v2zonDir(i,j,bi,bj) = 0.
          ENDIF
         ENDDO
        ENDDO

C-    bi,bj-loops
       ENDDO
      ENDDO

      RETURN
      END

#include "MDSIO_OPTIONS.h"

C--  File mdsio_segxtorx_2d.F: Routines to pass segment to/from 2D section array
C--   Contents
C--   o MDS_SEG4toRL_2D
C--   o MDS_SEG4toRS_2D
C--   o MDS_SEG8toRL_2D
C--   o MDS_SEG8toRS_2D

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      SUBROUTINE MDS_SEG4toRL_2D(sn,ol,nNz,bi,bj,k,copyTo,seg,arr)

C IN:
C     sn,ol,nNz  integer :: size of 'arr'. sn,ol can be sNx,oLx OR sNy,oLy
C     k,bi,bj,   integer :: indices to array "arr"
C     copyTo     logical :: flag to indicate tranfer direction.
C                           .TRUE.: seg -> arr, .FALSE.: arr -> seg
C     seg        Real*4  :: 1-D vector of length sn
C OUT:
C     arr         _RL    :: model vertical slice (array)
C
C Created: 06/03/00 spk@ocean.mit.edu

      IMPLICIT NONE
C Global variables / common blocks
#include "SIZE.h"

C Arguments
      INTEGER sn,ol,nNz,bi,bj,k
      LOGICAL copyTo
      Real*4 seg(sn)
      _RL arr(1-ol:sn+ol,nNz,nSx,nSy)

C Local
      INTEGER ii
C     ------------------------------------------------------------------
      IF (copyTo) THEN
       DO ii=1,sn
        arr(ii,k,bi,bj)=seg(ii)
       ENDDO
      ELSE
       DO ii=1,sn
        seg(ii)=arr(ii,k,bi,bj)
       ENDDO
      ENDIF
C     ------------------------------------------------------------------
      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      SUBROUTINE MDS_SEG4toRS_2D(sn,ol,nNz,bi,bj,k,copyTo,seg,arr)

C IN:
C     sn,ol,nNz  integer :: size of 'arr'. sn,ol can be sNx,oLx OR sNy,oLy
C     k,bi,bj,   integer :: indices to array "arr"
C     copyTo     logical :: flag to indicate tranfer direction.
C                           .TRUE.: seg -> arr, .FALSE.: arr -> seg
C     seg        Real*4  :: 1-D vector of length sn
C OUT:
C     arr         _RS    :: model vertical slice (array)
C
C Created: 06/03/00 spk@ocean.mit.edu

      IMPLICIT NONE
C Global variables / common blocks
#include "SIZE.h"

C Arguments
      INTEGER sn,ol,nNz,bi,bj,k
      LOGICAL copyTo
      Real*4 seg(sn)
      _RS arr(1-ol:sn+ol,nNz,nSx,nSy)

C Local
      INTEGER ii
C     ------------------------------------------------------------------
      IF (copyTo) THEN
       DO ii=1,sn
        arr(ii,k,bi,bj)=seg(ii)
       ENDDO
      ELSE
       DO ii=1,sn
        seg(ii)=arr(ii,k,bi,bj)
       ENDDO
      ENDIF
C     ------------------------------------------------------------------
      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      SUBROUTINE MDS_SEG8toRL_2D(sn,ol,nNz,bi,bj,k,copyTo,seg,arr)

C IN:
C     sn,ol,nNz  integer :: size of 'arr'. sn,ol can be sNx,oLx OR sNy,oLy
C     k,bi,bj,   integer :: indices to array "arr"
C     copyTo     logical :: flag to indicate tranfer direction.
C                           .TRUE.: seg -> arr, .FALSE.: arr -> seg
C     seg        Real*8  :: 1-D vector of length sn
C OUT:
C     arr         _RL    :: model vertical slice (array)
C
C Created: 06/03/00 spk@ocean.mit.edu

      IMPLICIT NONE
C Global variables / common blocks
#include "SIZE.h"

C Arguments
      INTEGER sn,ol,nNz,bi,bj,k
      LOGICAL copyTo
      Real*8 seg(sn)
      _RL arr(1-ol:sn+ol,nNz,nSx,nSy)

C Local
      INTEGER ii
C     ------------------------------------------------------------------
      IF (copyTo) THEN
       DO ii=1,sn
        arr(ii,k,bi,bj)=seg(ii)
       ENDDO
      ELSE
       DO ii=1,sn
        seg(ii)=arr(ii,k,bi,bj)
       ENDDO
      ENDIF
C     ------------------------------------------------------------------
      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      SUBROUTINE MDS_SEG8toRS_2D(sn,ol,nNz,bi,bj,k,copyTo,seg,arr)

C IN:
C     sn,ol,nNz  integer :: size of 'arr'. sn,ol can be sNx,oLx OR sNy,oLy
C     k,bi,bj,   integer :: indices to array "arr"
C     copyTo     logical :: flag to indicate tranfer direction.
C                           .TRUE.: seg -> arr, .FALSE.: arr -> seg
C     seg        Real*8  :: 1-D vector of length sn
C OUT:
C     arr         _RS    :: model vertical slice (array)
C
C Created: 06/03/00 spk@ocean.mit.edu

      IMPLICIT NONE
C Global variables / common blocks
#include "SIZE.h"

C Arguments
      INTEGER sn,ol,nNz,bi,bj,k
      LOGICAL copyTo
      Real*8 seg(sn)
      _RS arr(1-ol:sn+ol,nNz,nSx,nSy)

C Local
      INTEGER ii
C     ------------------------------------------------------------------
      IF (copyTo) THEN
       DO ii=1,sn
        arr(ii,k,bi,bj)=seg(ii)
       ENDDO
      ELSE
       DO ii=1,sn
        seg(ii)=arr(ii,k,bi,bj)
       ENDDO
      ENDIF
C     ------------------------------------------------------------------
      RETURN
      END

#include "OBCS_OPTIONS.h"

CBOP
C !ROUTINE: OBCS_U1_ADV_TRACER

C !INTERFACE: ==========================================================
      SUBROUTINE OBCS_U1_ADV_TRACER(
     I           doAdvXdir,
     I           trIdentity, bi, bj, k,
     I           maskLoc, vTrans, tracer,
     U           vT,
     I           myThid )

C !DESCRIPTION:
C  Update advective flux by replacing values at Open-Boundaries
C  with simply 1rst Order upwind advection scheme calculation.
C  Provide the option to do the replacement only in case of outflow
C  or indpendently of the sign of the flow.

C !USES: ===============================================================
      IMPLICIT NONE
C == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
c#include "PARAMS.h"
#include "GRID.h"
#include "OBCS_PARAMS.h"
#ifdef ALLOW_PTRACERS
# include "PTRACERS_SIZE.h"
# include "OBCS_PTRACERS.h"
#endif /* ALLOW_PTRACERS */
#ifdef ALLOW_GENERIC_ADVDIFF
# include "GAD.h"
#endif

C !INPUT/OUTPUT PARAMETERS: ============================================
C  doAdvXdir    :: =T: advection in X-direction ; =F: in Y-direction
C  trIdentity   :: tracer identifier
C  bi,bj        :: tile indices
C  k            :: vertical level
C  maskLoc      :: local mask at velocity location
C  vTrans       :: volume transport
C  tracer       :: tracer field
C  vT           :: advective flux
C  myThid       :: thread number
      LOGICAL doAdvXdir
      INTEGER trIdentity
      INTEGER bi, bj, k
      _RS maskLoc(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL vTrans (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL tracer (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL vT     (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER myThid

#ifdef ALLOW_OBCS
#ifdef ALLOW_GENERIC_ADVDIFF
C !LOCAL VARIABLES: ====================================================
C  i,j          :: loop indices
C  msgBuf       :: message buffer
      INTEGER i,j
      INTEGER updateAdvFlx
      _RL vAbs, tmpVar
      CHARACTER*(MAX_LEN_MBUF) msgBuf
#ifdef ALLOW_PTRACERS
      INTEGER iTr
#endif /* ALLOW_PTRACERS */
CEOP

      updateAdvFlx = 0
      IF ( trIdentity.EQ.GAD_TEMPERATURE ) THEN
        updateAdvFlx = OBCS_u1_adv_T
      ELSEIF ( trIdentity.EQ.GAD_SALINITY) THEN
        updateAdvFlx = OBCS_u1_adv_S
#ifdef ALLOW_PTRACERS
      ELSEIF ( trIdentity.GE.GAD_TR1) THEN
        iTr = trIdentity - GAD_TR1 + 1
        updateAdvFlx = OBCS_u1_adv_Tr(iTr)
#endif /* ALLOW_PTRACERS */
      ELSE
        WRITE(msgBuf,'(A,I4)')
     &       ' OBCS_U1_ADV_TRACER: Invalid tracer Id: ',trIdentity
        CALL PRINT_ERROR(msgBuf, myThid)
        STOP 'ABNORMAL END: S/R OBCS_U1_ADV_TRACER'
      ENDIF

      IF ( updateAdvFlx .GT. 0 ) THEN

#ifdef ALLOW_AUTODIFF_TAMC
         STOP 'ABNORMAL END: S/R OBCS_U1_ADV_TRACER'
#else /* ALLOW_AUTODIFF_TAMC */

        IF ( doAdvXdir ) THEN
C--   Advective flux in X-direction

         IF ( updateAdvFlx .EQ. 1 ) THEN
C-    only if outflow
          DO j=1-OLy,sNy+OLy
           DO i=2-OLx,sNx+OLx
            tmpVar = vTrans(i,j)*maskLoc(i,j)
     &             *( maskInC(i-1,j,bi,bj) - maskInC(i,j,bi,bj) )
            IF ( tmpVar.GT. 0. _d 0 ) THEN
              vAbs = ABS(vTrans(i,j))
              vT(i,j) = ( vTrans(i,j)+vAbs )* 0.5 _d 0 * tracer(i-1,j)
     &                + ( vTrans(i,j)-vAbs )* 0.5 _d 0 * tracer(i,j)
            ENDIF
           ENDDO
          ENDDO
         ELSE
C-    no condition (inflow & outflow)
          DO j=1-OLy,sNy+OLy
           DO i=2-OLx,sNx+OLx
            IF ( maskLoc(i,j).EQ.1. .AND.
     &           maskInC(i-1,j,bi,bj).NE.maskInC(i,j,bi,bj) ) THEN
              vAbs = ABS(vTrans(i,j))
              vT(i,j) = ( vTrans(i,j)+vAbs )* 0.5 _d 0 * tracer(i-1,j)
     &                + ( vTrans(i,j)-vAbs )* 0.5 _d 0 * tracer(i,j)
            ENDIF
           ENDDO
          ENDDO
         ENDIF

        ELSE
C--   Advective flux in Y-direction

         IF ( updateAdvFlx .EQ. 1 ) THEN
C-    only if outflow
          DO j=2-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
            tmpVar = vTrans(i,j)*maskLoc(i,j)
     &             *( maskInC(i,j-1,bi,bj) - maskInC(i,j,bi,bj) )
            IF ( tmpVar.GT. 0. _d 0 ) THEN
              vAbs = ABS(vTrans(i,j))
              vT(i,j) = ( vTrans(i,j)+vAbs )* 0.5 _d 0 * tracer(i,j-1)
     &                + ( vTrans(i,j)-vAbs )* 0.5 _d 0 * tracer(i,j)
            ENDIF
           ENDDO
          ENDDO
         ELSE
C-    no condition (inflow & outflow)
          DO j=2-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
            IF ( maskLoc(i,j).EQ.1. .AND.
     &           maskInC(i,j-1,bi,bj).NE.maskInC(i,j,bi,bj) ) THEN
              vAbs = ABS(vTrans(i,j))
              vT(i,j) = ( vTrans(i,j)+vAbs )* 0.5 _d 0 * tracer(i,j-1)
     &                + ( vTrans(i,j)-vAbs )* 0.5 _d 0 * tracer(i,j)
            ENDIF
           ENDDO
          ENDDO
         ENDIF

C--   end if X-direction / Y-direction
        ENDIF

#endif /* ALLOW_AUTODIFF_TAMC */

C--   end if updateAdvFlx > 0
      ENDIF

#endif /* ALLOW_GENERIC_ADVDIFF */
#endif /* ALLOW_OBCS */

      RETURN
      END

#include "SEAICE_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: SEAICE_COST_ACCUMULATE_MEAN

C     !INTERFACE:
      SUBROUTINE SEAICE_COST_ACCUMULATE_MEAN(
     &           myTime, myIter, myThid )

C     !DESCRIPTION:
C     Accumulate time-mean state for cost evalualtion

C     !USES:
      IMPLICIT NONE
C     == Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "SEAICE_SIZE.h"
#include "SEAICE.h"
#ifdef ALLOW_COST
# include "SEAICE_COST.h"
# include "cost.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     myThid ::  my Thread Id number
      _RL myTime
      INTEGER myIter
      INTEGER myThid
CEOP

#ifdef ALLOW_COST
#ifdef ALLOW_SEAICE_COST_EXPORT

C     !LOCAL VARIABLES:
      INTEGER i, j, bi, bj

      IF ( myTime .GT. (EndTime - lastinterval) ) THEN

C--   Calculate cost function on tile of this instance
       DO bj = myByLo(myThid), myByHi(myThid)
        DO bi = myBxLo(myThid), myBxHi(myThid)
         DO j=1,sNy
          DO i=1,sNx
            uHeffExportCell(i,j,bi,bj) = uHeffExportCell(i,j,bi,bj)
     &      + ( 0.92 _d 0*(HEFF(i,j,bi,bj)+HEFF(i-1,j,bi,bj))*0.5 _d 0
     &        + 0.33 _d 0*(HSNOW(i,j,bi,bj)+HSNOW(i-1,j,bi,bj))*0.5 _d 0
     &        )*UICE(i,j,bi,bj)
     &         *_dyG(i,j,bi,bj)/lastinterval*deltaTClock
            vHeffExportCell(i,j,bi,bj) = vHeffExportCell(i,j,bi,bj)
     &      + ( 0.92 _d 0*(HEFF(i,j,bi,bj)+HEFF(i,j-1,bi,bj))*0.5 _d 0
     &        + 0.33 _d 0*(HSNOW(i,j,bi,bj)+HSNOW(i,j-1,bi,bj))*0.5 _d 0
     &        )*VICE(i,j,bi,bj)
     &         *_dxG(i,j,bi,bj)/lastinterval*deltaTClock
          ENDDO
         ENDDO
        ENDDO
       ENDDO

      ENDIF

#endif /* ALLOW_SEAICE_COST_EXPORT */
#endif /* ALLOW_COST */

      RETURN
      END

#include "MYPACKAGE_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C !ROUTINE: MYPACKAGE_DIAGNOSTICS_INIT

C !INTERFACE:
      SUBROUTINE MYPACKAGE_DIAGNOSTICS_INIT( myThid )

C     !DESCRIPTION:
C     Initialize list of all available diagnostics

C     !USES:
      IMPLICIT NONE
C     == Global variables ===
#include "EEPARAMS.h"
#include "SIZE.h"
#include "PARAMS.h"
#include "MYPACKAGE.h"

C     !INPUT/OUTPUT PARAMETERS:
C     myThid ::  my Thread Id number
      INTEGER myThid
CEOP

#ifdef ALLOW_DIAGNOSTICS
C     !LOCAL VARIABLES:
C     diagNum   :: diagnostics number in the (long) list of available diag.
C     diagMate  :: diag. mate number in the (long) list of available diag.
C     diagName  :: local short name (8c) of a diagnostics
C     diagCode  :: local parser field with characteristics of the diagnostics
C              cf head of S/R DIAGNOSTICS_INIT_EARLY or DIAGNOSTICS_MAIN_INIT
C     diagUnits :: local string (16c): physical units of a diagnostic field
C     diagTitle :: local string (80c): description of field in diagnostic
      INTEGER       diagNum
      INTEGER       diagMate
      CHARACTER*8   diagName
      CHARACTER*16  diagCode
      CHARACTER*16  diagUnits
      CHARACTER*(80) diagTitle

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      IF ( useDiagnostics ) THEN

        diagName  = 'MYPaSta1'
        diagTitle = 'Scalar state variable 1 for package MYPACKAGE'
        diagUnits = 'unit            '
        diagCode  = 'SM      MR      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

        diagName  = 'MYPaSta2'
        diagTitle = 'Scalar state variable 2 for package MYPACKAGE'
        diagUnits = 'unit            '
        diagCode  = 'SM      MR      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

        diagName  = 'MYPaStaU'
        diagTitle = 'uVel-type state variable for package MYPACKAGE'
        diagUnits = 'unit            '
        diagCode  = 'UM      MR      '
        diagMate  = diagNum + 2
        IF ( myPa_StaV_Cgrid ) diagCode(2:2) = 'U'
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I   diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

        diagName  = 'MYPaStaV'
        diagTitle = 'vVel-type state variable for package MYPACKAGE'
        diagUnits = 'unit            '
        diagCode  = 'VM      MR      '
        diagMate  = diagNum
        IF ( myPa_StaV_Cgrid ) diagCode(2:2) = 'V'
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I   diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

        diagName  = 'MYPaSur1'
        diagTitle = 'Surface field 1 for package MYPACKAGE'
        diagUnits = 'unit            '
        diagCode  = 'SM      L1      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

        diagName  = 'MYPaSur2'
        diagTitle = 'Surface field 2 for package MYPACKAGE'
        diagUnits = 'unit            '
        diagCode  = 'SM      L1      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

        diagName  = 'MYPadTdt'
        diagTitle = ' Pot.Temp. tendency from package MYPACKAGE'
        diagUnits = 'K/s             '
        diagCode  = 'SMR     MR      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

        diagName  = 'MYPadSdt'
        diagTitle = ' Salinity  tendency from package MYPACKAGE'
        diagUnits = 'g/kg/s          '
        diagCode  = 'SMR     MR      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

        diagName  = 'MYPadUdt'
        diagTitle = 'u-Velocity tendency from package MYPACKAGE'
        diagUnits = 'm/s^2           '
        diagCode  = 'UMR     MR      '
        diagMate  = diagNum + 2
        IF ( myPa_Tend_Cgrid ) diagCode(2:2) = 'U'
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I   diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

        diagName  = 'MYPadVdt'
        diagTitle = 'v-Velocity tendency from package MYPACKAGE'
        diagUnits = 'm/s^2           '
        diagCode  = 'VMR     MR      '
        diagMate  = diagNum
        IF ( myPa_Tend_Cgrid ) diagCode(2:2) = 'V'
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I   diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

C--     an example of how to set "free levels option" diagnostics
        diagName  = 'MYPaLev3'
        diagTitle = '3-levels field for package MYPACKAGE'
        diagUnits = 'unit            '
        diagCode  = 'SM      MX      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )
        CALL DIAGNOSTICS_SETKLEV( diagName, 3, myThid )

      ENDIF

#endif /* ALLOW_DIAGNOSTICS */

      RETURN
      END

#include "PTRACERS_OPTIONS.h"
#ifdef ALLOW_AUTODIFF
# include "AUTODIFF_OPTIONS.h"
#endif

CBOP
C !ROUTINE: PTRACERS_INTEGRATE

C !INTERFACE: ==========================================================
      SUBROUTINE PTRACERS_INTEGRATE(
     I                    bi, bj, recip_hFac,
     I                    uFld, vFld, wFld,
     U                    KappaRk,
     I                    myTime, myIter, myThid )

C !DESCRIPTION:
C     Calculates tendency for passive tracers and integrates forward in
C     time. The tracer array is updated here while adjustments (filters,
C     conv.adjustment) are applied later, in S/R TRACERS_CORRECTION_STEP

C !USES: ===============================================================
#include "PTRACERS_MOD.h"
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#ifdef ALLOW_LONGSTEP
#include "LONGSTEP_PARAMS.h"
#endif
#include "PTRACERS_SIZE.h"
#include "PTRACERS_PARAMS.h"
#include "PTRACERS_START.h"
#include "PTRACERS_FIELDS.h"
#include "GAD.h"
#ifdef ALLOW_AUTODIFF_TAMC
# include "tamc.h"
#endif

C !INPUT PARAMETERS: ===================================================
C  bi, bj           :: tile indices
C  recip_hFac       :: reciprocal of cell open-depth factor (@ next iter)
C  uFld, vFld, wFld :: Local copy of velocity field (3 components)
C  KappaRk          :: vertical diffusion used for one passive tracer
C  myTime           :: model time
C  myIter           :: time-step number
C  myThid           :: thread number
      INTEGER bi, bj
      _RS recip_hFac(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL uFld      (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL vFld      (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL wFld      (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL KappaRk   (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL myTime
      INTEGER myIter
      INTEGER myThid

C !OUTPUT PARAMETERS: ==================================================
C  none

#ifdef ALLOW_PTRACERS
#ifdef ALLOW_DIAGNOSTICS
C     !FUNCTIONS:
      LOGICAL  DIAGNOSTICS_IS_ON
      EXTERNAL DIAGNOSTICS_IS_ON
      CHARACTER*4 GAD_DIAG_SUFX
      EXTERNAL    GAD_DIAG_SUFX
#endif /* ALLOW_DIAGNOSTICS */

C !LOCAL VARIABLES: ====================================================
C  iTracer          :: tracer index
C  iMin, iMax       :: 1rst index loop range
C  jMin, jMax       :: 2nd  index loop range
C  k                :: vertical level number
C  kUp,kDown        :: toggle indices for even/odd level fluxes
C  kM1              :: =min(1,k-1)
C  GAD_TR           :: passive tracer id (GAD_TR1+iTracer-1)
C  xA               :: face area at U points in level k
C  yA               :: face area at V points in level k
C  maskUp           :: mask for vertical transport
C  uTrans           :: zonal transport in level k
C  vTrans           :: meridional transport in level k
C  rTrans           :: vertical volume transport at interface k
C  rTransKp         :: vertical volume transport at interface k+1
C  fZon             :: passive tracer zonal flux
C  fMer             :: passive tracer meridional flux
C  fVer             :: passive tracer vertical flux
C  gTracer          :: passive tracer tendency
C  gTrForc          :: passive tracer forcing tendency
C  gTr_AB           :: Adams-Bashforth tracer tendency increment
C  gTr_trp          :: passive tracer total transport tendency before gchem
      INTEGER iTracer
      INTEGER iMin,iMax,jMin,jMax
      INTEGER i, j, k
      INTEGER kUp, kDown, kM1
      INTEGER GAD_TR
      _RS xA      (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RS yA      (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RS maskUp  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL uTrans  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL vTrans  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL rTrans  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL rTransKp(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL fZon    (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL fMer    (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL fVer    (1-OLx:sNx+OLx,1-OLy:sNy+OLy,2)
      _RL gTracer (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL gTrForc (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL gTr_AB  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      LOGICAL calcAdvection
      INTEGER iterNb
      _RL dummy(Nr)
#ifdef ALLOW_AUTODIFF_TAMC
C     tkey :: tape key (depends on tiles)
C     ikey :: tape key (depends on tracer and tiles)
C     kkey :: tape key (depends on levels, tracer, and tiles)
      INTEGER  tkey, ikey, kkey
#endif
#ifdef ALLOW_DIAGNOSTICS
      _RL gTr_trp (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL recip_dt
      CHARACTER*8 diagName
      CHARACTER*4 diagSufx
      LOGICAL diagForcing, diagAB_tend, diagTrp_tend
#endif /* ALLOW_DIAGNOSTICS */
CEOP

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C-    Compute iter at beginning of ptracer time step
#ifdef ALLOW_LONGSTEP
      iterNb = myIter - LS_nIter + 1
      IF (LS_whenToSample.GE.2) iterNb = myIter - LS_nIter
#else
      iterNb = myIter
      IF (staggerTimeStep) iterNb = myIter - 1
#endif

C-    Loop ranges for daughter routines
c     iMin = 1
c     iMax = sNx
c     jMin = 1
c     jMax = sNy
C     Regarding model dynamics, only needs to get correct tracer tendency
C     (gTracer) in tile interior (1:sNx,1:sNy);
C     However, for some diagnostics, we may want to get valid tendency
C     extended over 1 point in tile halo region (0:sNx+1,0:sNy=1).
      iMin = 0
      iMax = sNx+1
      jMin = 0
      jMax = sNy+1

C--   Loop over tracers
      DO iTracer=1,PTRACERS_numInUse
       IF ( PTRACERS_StepFwd(iTracer) ) THEN
        GAD_TR = GAD_TR1 + iTracer - 1

C-    Initialise tracer tendency to zero
        DO k=1,Nr
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           gTracer(i,j,k) = 0. _d 0
          ENDDO
         ENDDO
        ENDDO

#ifdef ALLOW_DIAGNOSTICS
        diagForcing = .FALSE.
        diagAB_tend = .FALSE.
        diagTrp_tend = .FALSE.
        IF ( useDiagnostics ) THEN
          diagSufx = GAD_DIAG_SUFX( GAD_TR, myThid )
          diagName = 'Forc'//diagSufx
          diagForcing = DIAGNOSTICS_IS_ON( diagName, myThid )
          diagName = 'AB_g'//diagSufx
          IF ( PTRACERS_AdamsBashGtr(iTracer) )
     &    diagAB_tend = DIAGNOSTICS_IS_ON( diagName, myThid )
          diagName = 'Tp_g'//diagSufx
          diagTrp_tend = DIAGNOSTICS_IS_ON( diagName, myThid )
        ENDIF
#endif

#ifdef ALLOW_AUTODIFF_TAMC
        tkey = bi + (bj-1)*nSx + (ikey_dynamics-1)*nSx*nSy
        ikey = iTracer + (tkey-1)*PTRACERS_num
#endif /* ALLOW_AUTODIFF_TAMC */

C-    Apply AB on Tracer :
        IF ( PTRACERS_AdamsBash_Tr(iTracer) ) THEN
C     compute pTr^n+1/2 (stored in gpTrNm1) extrapolating pTr forward in time
          CALL ADAMS_BASHFORTH2(
     I                      bi, bj, 0, Nr,
     I                      pTracer(1-OLx,1-OLy,1,bi,bj,iTracer),
     U                      gpTrNm1(1-OLx,1-OLy,1,bi,bj,iTracer),
     O                      gTr_AB,
     I                      PTRACERS_startAB(iTracer), iterNb, myThid )
        ENDIF

        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
           fVer(i,j,1) = 0. _d 0
           fVer(i,j,2) = 0. _d 0
         ENDDO
        ENDDO
#ifdef ALLOW_AUTODIFF
        DO k=1,Nr
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           kappaRk(i,j,k) = 0. _d 0
          ENDDO
         ENDDO
        ENDDO
#endif /* ALLOW_AUTODIFF */

C     salt_integrate.F uses INCLUDE_CALC_DIFFUSIVITY_CALL
c#ifdef INCLUDE_CALC_DIFFUSIVITY_CALL
        CALL CALC_3D_DIFFUSIVITY(
     I         bi, bj, iMin,iMax,jMin,jMax,
     I         GAD_TR,
     I         PTRACERS_useGMRedi(iTracer), PTRACERS_useKPP(iTracer),
     O         kappaRk,
     I         myThid)
# ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE kappaRk = comlev1_bibj_ptracers, key = ikey, byte = isbyte
# endif
c#endif /* INCLUDE_CALC_DIFFUSIVITY_CALL */

#ifndef DISABLE_MULTIDIM_ADVECTION
#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE pTracer(:,:,:,bi,bj,iTracer)
CADJ &      = comlev1_bibj_ptracers, key=ikey, byte=isbyte
#endif /* ALLOW_AUTODIFF_TAMC */

#ifdef PTRACERS_ALLOW_DYN_STATE
        IF ( PTRACERS_SOM_Advection(iTracer) ) THEN
# ifdef ALLOW_DEBUG
         IF (debugMode) CALL DEBUG_CALL('GAD_SOM_ADVECT',myThid)
# endif
          CALL GAD_SOM_ADVECT(
     I                        PTRACERS_ImplVertAdv(iTracer),
     I                        PTRACERS_advScheme(iTracer),
     I                        PTRACERS_advScheme(iTracer),
     I                        GAD_TR,
     I                        PTRACERS_dTLev, uFld, vFld, wFld,
     I                        pTracer(1-OLx,1-OLy,1,1,1,iTracer),
     U                        _Ptracers_som(:,:,:,:,:,:,iTracer),
     O                        gTracer,
     I                        bi, bj, myTime, myIter, myThid )
        ELSEIF ( PTRACERS_MultiDimAdv(iTracer) ) THEN
#else /* PTRACERS_ALLOW_DYN_STATE */
        IF ( PTRACERS_MultiDimAdv(iTracer) ) THEN
#endif /* PTRACERS_ALLOW_DYN_STATE */
# ifdef ALLOW_DEBUG
          IF (debugMode) CALL DEBUG_CALL('GAD_ADVECTION',myThid)
# endif
          CALL GAD_ADVECTION(
     I                        PTRACERS_ImplVertAdv(iTracer),
     I                        PTRACERS_advScheme(iTracer),
     I                        PTRACERS_advScheme(iTracer),
     I                        GAD_TR,
     I                        PTRACERS_dTLev, uFld, vFld, wFld,
     I                        pTracer(1-OLx,1-OLy,1,1,1,iTracer),
     O                        gTracer,
     I                        bi, bj, myTime, myIter, myThid )
        ENDIF
#endif /* DISABLE_MULTIDIM_ADVECTION */

C-    Start vertical index (k) loop (Nr:1)
        calcAdvection = .NOT.PTRACERS_MultiDimAdv(iTracer)
     &                  .AND. (PTRACERS_advScheme(iTracer).NE.0)
        DO k=Nr,1,-1
#ifdef ALLOW_AUTODIFF_TAMC
          kkey = k + (ikey-1)*Nr
#endif /* ALLOW_AUTODIFF_TAMC */

          kM1  = MAX(1,k-1)
          kUp  = 1+MOD(k+1,2)
          kDown= 1+MOD(k,2)

#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE fVer(:,:,:)                  = comlev1_bibj_k_ptracers,
CADJ &     key = kkey, kind = isbyte
CADJ STORE gTracer(:,:,k)               = comlev1_bibj_k_ptracers,
CADJ &     key = kkey, kind = isbyte
CADJ STORE gpTrNm1(:,:,k,bi,bj,iTracer) = comlev1_bibj_k_ptracers,
CADJ &     key = kkey, kind = isbyte
#endif /* ALLOW_AUTODIFF_TAMC */
          CALL CALC_ADV_FLOW(
     I                uFld, vFld, wFld,
     U                rTrans,
     O                uTrans, vTrans, rTransKp,
     O                maskUp, xA, yA,
     I                k, bi, bj, myThid )

C--   Collect forcing term in local array gTrForc:
          DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
            gTrForc(i,j) = 0. _d 0
           ENDDO
          ENDDO
          CALL PTRACERS_APPLY_FORCING(
     U                    gTrForc,
     I                    surfaceForcingPTr(1-OLx,1-OLy,bi,bj,iTracer),
     I                    iMin,iMax,jMin,jMax, k, bi, bj,
     I                    iTracer, myTime, myIter, myThid )
#ifdef ALLOW_DIAGNOSTICS
          IF ( diagForcing ) THEN
            diagName = 'Forc'//diagSufx
            CALL DIAGNOSTICS_FILL(gTrForc,diagName,k,1,2,bi,bj,myThid)
          ENDIF
#endif /* ALLOW_DIAGNOSTICS */

C-    Calculate active tracer tendencies (gTracer) due to internal processes
C      (advection, [explicit] diffusion, parameterizations,...)
          CALL GAD_CALC_RHS(
     I             bi,bj, iMin,iMax,jMin,jMax, k,kM1, kUp,kDown,
     I             xA, yA, maskUp, uFld(1-OLx,1-OLy,k),
     I             vFld(1-OLx,1-OLy,k), wFld(1-OLx,1-OLy,k),
     I             uTrans, vTrans, rTrans, rTransKp,
     I             PTRACERS_diffKh(iTracer),
     I             PTRACERS_diffK4(iTracer),
     I             KappaRk(1-OLx,1-OLy,k), dummy,
     I             pTracer(1-OLx,1-OLy,1,bi,bj,iTracer),
     I             gpTrNm1(1-OLx,1-OLy,1,bi,bj,iTracer),
     I             PTRACERS_dTLev, GAD_TR,
     I             PTRACERS_advScheme(iTracer),
     I             PTRACERS_advScheme(iTracer),
     I             calcAdvection, PTRACERS_ImplVertAdv(iTracer),
     I             PTRACERS_AdamsBash_Tr(iTracer), .FALSE.,
     I             PTRACERS_useGMRedi(iTracer),
     I             PTRACERS_useKPP(iTracer),
     I             PTRACERS_stayPositive(iTracer),
     O             fZon, fMer,
     U             fVer, gTracer,
     I             myTime, myIter, myThid )

C-    External forcing term(s) inside Adams-Bashforth:
          IF ( tracForcingOutAB.NE.1 ) THEN
            DO j=1-OLy,sNy+OLy
             DO i=1-OLx,sNx+OLx
              gTracer(i,j,k) = gTracer(i,j,k) + gTrForc(i,j)
             ENDDO
            ENDDO
          ENDIF

C-    If using Adams-Bashforth II, then extrapolate tendencies
C     gTracer is now the tracer tendency for explicit advection/diffusion

C     If matrix is being computed, skip call to S/R ADAMS_BASHFORTH2 to
C     prevent gTracer from being replaced by the average of gTracer and gpTrNm1.
          IF ( .NOT.useMATRIX .AND.
     &         PTRACERS_AdamsBashGtr(iTracer) ) THEN
           CALL ADAMS_BASHFORTH2(
     I                      bi, bj, k, Nr,
     U                      gTracer,
     U                      gpTrNm1(1-OLx,1-OLy,1,bi,bj,iTracer),
     O                      gTr_AB,
     I                      PTRACERS_startAB(iTracer), iterNb, myThid )
#ifdef ALLOW_DIAGNOSTICS
           IF ( diagAB_tend ) THEN
             diagName = 'AB_g'//diagSufx
             CALL DIAGNOSTICS_FILL(gTr_AB,diagName,k,1,2,bi,bj,myThid)
           ENDIF
#endif /* ALLOW_DIAGNOSTICS */
          ENDIF

C-    External forcing term(s) outside Adams-Bashforth:
          IF ( tracForcingOutAB.EQ.1 ) THEN
            DO j=1-OLy,sNy+OLy
             DO i=1-OLx,sNx+OLx
              gTracer(i,j,k) = gTracer(i,j,k) + gTrForc(i,j)
             ENDDO
            ENDDO
          ENDIF

#ifdef NONLIN_FRSURF
# ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE gTracer(:,:,k) = comlev1_bibj_k, key = kkey, kind = isbyte
# endif
C-    Account for change in level thickness
          IF (nonlinFreeSurf.GT.0) THEN
           CALL FREESURF_RESCALE_G(
     I                           bi, bj, k,
     U                           gTracer,
     I                           myThid )
           IF ( PTRACERS_AdamsBashGtr(iTracer) ) THEN
# ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE gpTrNm1(:,:,k,bi,bj,iTracer) = comlev1_bibj_k_ptracers,
CADJ &     key = kkey, kind = isbyte
# endif
            CALL FREESURF_RESCALE_G(
     I                           bi, bj, k,
     U                           gpTrNm1(1-OLx,1-OLy,1,bi,bj,iTracer),
     I                           myThid )
           ENDIF
          ENDIF
#endif /* NONLIN_FRSURF */

C-    end of vertical index (k) loop (Nr:1)
        ENDDO

#ifdef ALLOW_DOWN_SLOPE
        IF ( PTRACERS_useDWNSLP(iTracer) ) THEN
# ifdef ALLOW_AUTODIFF_TAMC
C     Here we can store on comlev1_bibj to save memory, because
C     recip_hfac is the same for all tracers
CADJ STORE recip_hfac = comlev1_bibj, key = tkey, kind = isbyte
# endif
          IF ( usingPCoords ) THEN
            CALL DWNSLP_APPLY(
     I                  GAD_TR, bi, bj, kSurfC,
     I                  pTracer(1-OLx,1-OLy,1,bi,bj,iTracer),
     U                  gTracer,
     I                  recip_hFac, recip_rA, recip_drF,
     I                  PTRACERS_dTLev, myTime, myIter, myThid )
          ELSE
            CALL DWNSLP_APPLY(
     I                  GAD_TR, bi, bj, kLowC,
     I                  pTracer(1-OLx,1-OLy,1,bi,bj,iTracer),
     U                  gTracer,
     I                  recip_hFac, recip_rA, recip_drF,
     I                  PTRACERS_dTLev, myTime, myIter, myThid )
          ENDIF
        ENDIF
#endif /* ALLOW_DOWN_SLOPE */

C-    Integrate forward in time, storing in gTracer:  gTr <= pTr + dt*gTr
        CALL TIMESTEP_TRACER(
     I                bi, bj, PTRACERS_dTLev,
     I                pTracer(1-OLx,1-OLy,1,bi,bj,iTracer),
     U                gTracer,
     I                myTime, myIter, myThid )

C     All explicit advection/diffusion/sources should now be
C     done. The updated tracer field is in gTracer.
#ifdef ALLOW_MATRIX
C       Accumalate explicit tendency and also reset gTracer to initial
C       tracer field for implicit matrix calculation
        IF ( useMATRIX ) THEN
          CALL MATRIX_STORE_TENDENCY_EXP(
     I                      iTracer, bi, bj,
     U                      gTracer,
     I                      myTime, myIter, myThid )
        ENDIF
#endif /* ALLOW_MATRIX */

C--   Vertical advection & diffusion (implicit) for passive tracers

#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE gTracer(:,:,:) = comlev1_bibj_ptracers, key=ikey, byte=isbyte
#endif /* ALLOW_AUTODIFF_TAMC */

#ifdef INCLUDE_IMPLVERTADV_CODE
        IF ( PTRACERS_ImplVertAdv(iTracer) .OR. implicitDiffusion ) THEN
C      to recover older (prior to 2016-10-05) results:
c       IF ( PTRACERS_ImplVertAdv(iTracer) ) THEN
          CALL GAD_IMPLICIT_R(
     I         PTRACERS_ImplVertAdv(iTracer),
     I         PTRACERS_advScheme(iTracer), GAD_TR,
     I         PTRACERS_dTLev, kappaRk, recip_hFac, wFld,
     I         pTracer(1-OLx,1-OLy,1,bi,bj,iTracer),
     U         gTracer,
     I         bi, bj, myTime, myIter, myThid )

        ELSEIF ( implicitDiffusion ) THEN
#else /* INCLUDE_IMPLVERTADV_CODE */
        IF ( implicitDiffusion ) THEN
#endif /* INCLUDE_IMPLVERTADV_CODE */
          CALL IMPLDIFF(
     I         bi, bj, iMin, iMax, jMin, jMax,
     I         GAD_TR, kappaRk, recip_hFac,
     U         gTracer,
     I         myThid )
        ENDIF

#ifdef ALLOW_DIAGNOSTICS
        IF ( diagTrp_tend ) THEN
         diagName = 'Tp_g'//diagSufx
         DO k=1,Nr
          IF ( PTRACERS_dTLev(k).NE.zeroRL ) THEN
            recip_dt = oneRL/PTRACERS_dTLev(k)
          ELSE
            recip_dt = 0. _d 0
          ENDIF
          DO j=1,sNy
           DO i=1,sNx
            gTr_trp(i,j) = ( gTracer(i,j,k)
     &                     - pTracer(i,j,k,bi,bj,iTracer) )*recip_dt
           ENDDO
          ENDDO
          CALL DIAGNOSTICS_FILL( gTr_trp,diagName,k,1,2,bi,bj,myThid )
         ENDDO
        ENDIF
#endif /* ALLOW_DIAGNOSTICS */

        IF ( PTRACERS_AdamsBash_Tr(iTracer) ) THEN
C--   Save current tracer field (for AB on tracer) and then update tracer
          CALL CYCLE_AB_TRACER(
     I               bi, bj, gTracer,
     U               pTracer(1-OLx,1-OLy,1,bi,bj,iTracer),
     O               gpTrNm1(1-OLx,1-OLy,1,bi,bj,iTracer),
     I               myTime, myIter, myThid )
        ELSE
C--   Update tracer fields:  pTr(n) = pTr**
          CALL CYCLE_TRACER(
     I               bi, bj,
     O               pTracer(1-OLx,1-OLy,1,bi,bj,iTracer),
     I               gTracer, myTime, myIter, myThid )
        ENDIF

#ifdef ALLOW_OBCS
C--   Apply open boundary conditions for each passive tracer
        IF ( useOBCS ) THEN
          CALL OBCS_APPLY_PTRACER(
     I         bi, bj, 0, iTracer,
     U         pTracer(1-OLx,1-OLy,1,bi,bj,iTracer),
     I         myThid )
        ENDIF
#endif /* ALLOW_OBCS */

C--   end of tracer loop
       ENDIF
      ENDDO

#endif /* ALLOW_PTRACERS */

      RETURN
      END

#include "GAD_OPTIONS.h"

CBOP
C !ROUTINE: GAD_FLUXLIMIT_ADV_Y

C !INTERFACE: ==========================================================
      SUBROUTINE GAD_FLUXLIMIT_ADV_Y(
     I           bi, bj, k, calcCFL, deltaTloc,
     I           vTrans, vFld,
     I           maskLocS, tracer,
     O           vT,
     I           myThid )

C !DESCRIPTION:
C Calculates the area integrated meridional flux due to advection of a tracer
C using second-order interpolation with a flux limiter:
C \begin{equation*}
C F^y_{adv} = V \overline{ \theta }^j
C - \frac{1}{2} \left(
C     [ 1 - \psi(C_r) ] |V|
C    + V \frac{v \Delta t}{\Delta y_c} \psi(C_r)
C              \right) \delta_j \theta
C \end{equation*}
C where the $\psi(C_r)$ is the limiter function and $C_r$ is
C the slope ratio.

C !USES: ===============================================================
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "GRID.h"

C !INPUT PARAMETERS: ===================================================
C  bi, bj            :: tile indices
C  k                 :: vertical level
C  calcCFL           :: =T: calculate CFL number ; =F: take vFld as CFL
C  deltaTloc         :: local time-step (s)
C  vTrans            :: meridional volume transport
C  vFld              :: meridional flow / CFL number
C  tracer            :: tracer field
C  myThid            :: thread number
      INTEGER bi, bj, k
      LOGICAL calcCFL
      _RL deltaTloc
      _RL vTrans(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL vFld  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RS maskLocS(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL tracer(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER myThid

C !OUTPUT PARAMETERS: ==================================================
C  vT                :: meridional advective flux
      _RL vT    (1-OLx:sNx+OLx,1-OLy:sNy+OLy)

C !LOCAL VARIABLES: ====================================================
C  i, j              :: loop indices
C  Cr                :: slope ratio
C  Rjm, Rj, Rjp      :: differences at j-1,j,j+1
      INTEGER i,j
      _RL Cr, Rjm, Rj, Rjp
      _RL vCFL
      _RL CrMax
      PARAMETER( CrMax = 1.D+6 )

C Statement function provides Limiter(Cr)
#include "GAD_FLUX_LIMITER.h"
CEOP

      DO i=1-OLx,sNx+OLx
       vT(i,1-OLy) = 0. _d 0
       vT(i,2-OLy) = 0. _d 0
       vT(i,sNy+OLy) = 0. _d 0
      ENDDO
      DO j=1-OLy+2,sNy+OLy-1
       DO i=1-OLx,sNx+OLx

        vCFL = vFld(i,j)
        IF ( calcCFL ) vCFL = ABS( vFld(i,j)*deltaTloc
     &                  *recip_dyC(i,j,bi,bj)*recip_deepFacC(k) )
        Rjp = (tracer(i,j+1)-tracer(i, j ))*maskLocS(i,j+1)
        Rj  = (tracer(i, j )-tracer(i,j-1))*maskLocS(i, j )
        Rjm = (tracer(i,j-1)-tracer(i,j-2))*maskLocS(i,j-1)

        IF ( vTrans(i,j).GT.zeroRL ) THEN
          Cr = Rjm
        ELSE
          Cr = Rjp
        ENDIF
        IF ( ABS(Rj)*CrMax .LE. ABS(Cr) ) THEN
          Cr = SIGN( CrMax, Cr )*SIGN( oneRL, Rj )
        ELSE
          Cr = Cr/Rj
        ENDIF

C       calculate Limiter Function:
        Cr = Limiter(Cr)

        vT(i,j) =
     &     vTrans(i,j)*(Tracer(i,j)+Tracer(i,j-1))*0.5 _d 0
     &   - ABS(vTrans(i,j))*( (oneRL-Cr) + vCFL*Cr )
     &                     *Rj*0.5 _d 0
       ENDDO
      ENDDO

      RETURN
      END

C     ECCO_CPPOPTIONS used to affect maxcvars and defined ALLOW_OBCS?_CONTROL
C#include "ECCO_CPPOPTIONS.h"
C     now:
C     CTRL_OPTIONS affects maxcvars and may define ALLOW_OBCS?_CONTROL
#include "CTRL_OPTIONS.h"

      subroutine optim_readdata(
     I                      nn,
     I                      dfile,
     I                      lheaderonly,
     O                      ff,
     O                      vv
     &                    )

c     ==================================================================
c     SUBROUTINE optim_readdata
c     ==================================================================
c
c     o Read the data written by the MITgcmUV state estimation setup and
c       join them to one vector that is subsequently used by the minimi-
c       zation algorithm "lsopt". Depending on the specified file name
c       either the control vector or the gradient vector can be read.
c
c       *dfile* should be the radix of the file: ecco_ctrl or ecco_cost
c
c     started: Christian Eckert eckert@mit.edu 12-Apr-2000
c
c     changed:  Patrick Heimbach heimbach@mit.edu 19-Jun-2000
c               - finished, revised and debugged
c
c     ==================================================================
c     SUBROUTINE optim_readdata
c     ==================================================================

      IMPLICIT NONE

c     == global variables ==

#include "EEPARAMS.h"
#include "SIZE.h"
#include "CTRL_SIZE.h"
#ifdef ALLOW_OBCS_CONTROL
# include "CTRL_OBCS.h"
#endif
#include "CTRL.h"
#include "optim.h"

c     == routine arguments ==

      integer nn
      _RL     ff

#ifdef DYNAMIC
      _RL     vv(nn)
#else
      integer nmax
      parameter( nmax = MAX_INDEPEND )
      _RL   vv(nmax)
#endif

      character*(9) dfile
      logical lheaderonly

c     == local variables ==
#ifdef READ_OLD_CTRL_PACK_FILE
      INTEGER maxLocal
      PARAMETER( maxLocal = old_maxcvars )
      INTEGER file_varIndex(maxLocal)
      INTEGER file_varRecs(maxLocal)
      INTEGER file_varNxMax(maxLocal)
      INTEGER file_varNyMax(maxLocal)
      INTEGER file_varNrMax(maxLocal)
      CHARACTER*( 1) file_varGrid(maxLocal)
      CHARACTER*( 5) file_varType(maxLocal)
#endif

CM      integer bi,bj
      integer biG,bjG
      integer i,j
      integer ii,k
      integer ivar
      integer icvrec
      integer icvcomp
      integer icvoffset
      integer nopt
      integer funit

      integer cbuffindex
      real*4 cbuff( sNx*nSx*nPx*sNy*nSy*nPy )

      character*(128) fname
      character*(17)  prefix
      parameter ( prefix =  " OPTIM_READDATA: " )

      integer         ncvarindex_loc
      integer         filei
      integer         filej
      integer         filek
      integer         fileiG
      integer         filejG
      integer         filensx
      integer         filensy
      integer         filenopt
      _RL             fileff

cgg(
      _RL     gg
      integer igg
      integer iobcs
cgg)

c     == end of interface ==

c--   The reference i/o unit.
      funit = 20

c--   Next optimization cycle.
      nopt = optimcycle

      if      ( dfile .eq. ctrlname ) then
       print*
       print*,' OPTIM_READDATA: Reading control vector'
       print*,'                 for optimization cycle: ',nopt
      else if ( dfile .eq. costname ) then
       print*
       print*,' OPTIM_READDATA: Reading cost function and'//
     &                        ' gradient of cost function'
       print*,'                 for optimization cycle: ',nopt
      else
       print*
       print*,' OPTIM_READDATA: subroutine called by a false *dfile*'
       print*,'                 argument. *dfile* = ',dfile
       print*
       stop   '  ...  stopped in OPTIM_READDATA.'
      endif
      if ( lheaderonly ) then
       print*,'                 ... header only'
      endif
      print*, ' '

c--   Read the data.

      bjG = 1 + (myYGlobalLo - 1)/sNy
      biG = 1 + (myXGlobalLo - 1)/sNx

c--   Generate file name and open the file.
      write(fname(1:128),'(4a,i4.4)')
     &     dfile,'_',yctrlid(1:10),'.opt', nopt
      open( funit, file   = fname,
     &     status = 'old',
     &     form   = 'unformatted',
     &     access = 'sequential'   )
      print*, prefix, 'opened file ', fname

c--   Read the header.
      read( funit ) nvartype
      read( funit ) nvarlength
      read( funit ) yctrlid
      read( funit ) filenopt
      read( funit ) fileff
C     filei/jG are dummy values and not used
      read( funit ) fileiG
      read( funit ) filejG
      read( funit ) filensx
      read( funit ) filensy

      read( funit ) (nWetcGlobal(k), k=1,Nr)
      read( funit ) (nWetsGlobal(k), k=1,Nr)
      read( funit ) (nWetwGlobal(k), k=1,Nr)
c#ifdef ALLOW_CTRL_WETV
c     read( funit ) (nWetvGlobal(k), k=1,Nr)
c#endif
#ifdef ALLOW_SHELFICE
      read(funit) (nWetiGlobal(k), k=1,Nr)
c     read(funit) nWetiGlobal(1)
#endif

cgg(    Add OBCS Mask information into the header section for optimization.
CML#if (defined (ALLOW_CTRL) && defined (ALLOW_OBCS))
#ifdef ALLOW_OBCSN_CONTROL
      read( funit ) ((nWetobcsnGlo(k,iobcs), k=1,Nr),iobcs= 1,nobcs)
#endif
#ifdef ALLOW_OBCSS_CONTROL
      read( funit ) ((nWetobcssGlo(k,iobcs), k=1,Nr),iobcs= 1,nobcs)
#endif
#ifdef ALLOW_OBCSW_CONTROL
      read( funit ) ((nWetobcswGlo(k,iobcs), k=1,Nr),iobcs= 1,nobcs)
#endif
#ifdef ALLOW_OBCSE_CONTROL
      read( funit ) ((nWetobcseGlo(k,iobcs), k=1,Nr),iobcs= 1,nobcs)
#endif
CML#endif /* ALLOW_CTRL and ALLOW_OBCS */
cgg)
#ifdef READ_OLD_CTRL_PACK_FILE
      DO ivar = 1,maxLocal
        file_varType(ivar)  = '     '
      ENDDO
      read( funit ) (file_varIndex(ivar), ivar=1,maxLocal)
      read( funit ) (file_varRecs(ivar),  ivar=1,maxLocal)
      read( funit ) (file_varNxMax(ivar), ivar=1,maxLocal)
      read( funit ) (file_varNyMax(ivar), ivar=1,maxLocal)
      read( funit ) (file_varNrMax(ivar), ivar=1,maxLocal)
      read( funit ) (file_varGrid(ivar),  ivar=1,maxLocal)
      read( funit )
      CALL CTRL_CONVERT_HEADER(
     I              maxLocal, nvartype, 6,
     U              file_varIndex, file_varRecs,
     U              file_varNxMax, file_varNyMax, file_varNrMax,
     U              file_varGrid, file_varType,
     I              1 )
      DO ivar = 1,nvartype
        ncvarindex(ivar) = file_varIndex(ivar)
        ncvarrecs(ivar)  = file_varRecs(ivar)
        ncvarxmax(ivar)  = file_varNxMax(ivar)
        ncvarymax(ivar)  = file_varNyMax(ivar)
        ncvarnrmax(ivar) = file_varNrMax(ivar)
        ncvargrd(ivar)   = file_varGrid(ivar)
        ncvartype(ivar)  = file_varType(ivar)
      ENDDO
#else /* READ_OLD_CTRL_PACK_FILE */
      read( funit ) (ncvarindex(ivar), ivar=1,nvartype)
      read( funit ) (ncvarrecs(ivar),  ivar=1,nvartype)
      read( funit ) (ncvarxmax(ivar),  ivar=1,nvartype)
      read( funit ) (ncvarymax(ivar),  ivar=1,nvartype)
      read( funit ) (ncvarnrmax(ivar), ivar=1,nvartype)
      read( funit ) (ncvargrd(ivar),   ivar=1,nvartype)
      read( funit ) (ncvartype(ivar),  ivar=1,nvartype)
#endif /* READ_OLD_CTRL_PACK_FILE */

      print *, prefix, 'nvartype ', nvartype
      print *, prefix, 'nvarlength ', nvarlength
      print *, prefix, 'yctrlid ', yctrlid
      print *, prefix, 'filenopt ', filenopt
      print *, prefix, 'fileff ', fileff
      print *, prefix, 'fileiG ', fileiG
      print *, prefix, 'filejG ', filejG
      print *, prefix, 'filensx ', filensx
      print *, prefix, 'filensy ', filensy

      if (lheaderonly) then
       print *, prefix, 'nWetcGlobal ', (nWetcGlobal(k), k=1,Nr)
       print *, prefix, 'nWetsGlobal ', (nWetsGlobal(k), k=1,Nr)
       print *, prefix, 'nWetwGlobal ', (nWetwGlobal(k), k=1,Nr)
c      print *, prefix, 'nWetvGlobal ', (nWetvGlobal(k), k=1,Nr)
#ifdef ALLOW_SHELFICE
       print *, prefix, 'nWetiGlobal ', (nWetiGlobal(k), k=1,Nr)
#endif
#ifdef ALLOW_OBCSN_CONTROL
       do iobcs=1,nobcs
        print *, prefix, 'nWetobcsnGlo (iobcs=', iobcs,')',
     &       (nWetobcsnGlo(k,iobcs), k=1,Nr)
       enddo
#endif
#ifdef ALLOW_OBCSS_CONTROL
       do iobcs=1,nobcs
        print *, prefix, 'nWetobcssGlo (iobcs=', iobcs,')',
     &         (nWetobcssGlo(k,iobcs), k=1,Nr)
       enddo
#endif
#ifdef ALLOW_OBCSW_CONTROL
       do iobcs=1,nobcs
        print *, prefix, 'nWetobcswGlo (iobcs=', iobcs,')',
     &       (nWetobcswGlo(k,iobcs), k=1,Nr)
       enddo
#endif
#ifdef ALLOW_OBCSE_CONTROL
       do iobcs=1,nobcs
        print *, prefix, 'nWetobcseGlo (iobcs=', iobcs,')',
     &       (nWetobcseGlo(k,iobcs), k=1,Nr)
       enddo
#endif
       print *, prefix, 'ncvarindex ', (ncvarindex(i), i=1,maxcvars)
       print *, prefix, 'ncvarrecs  ', (ncvarrecs(i),  i=1,maxcvars)
       print *, prefix, 'ncvarxmax  ', (ncvarxmax(i),  i=1,maxcvars)
       print *, prefix, 'ncvarymax  ', (ncvarymax(i),  i=1,maxcvars)
       print *, prefix, 'ncvarnrmax ', (ncvarnrmax(i), i=1,maxcvars)
       print *, prefix, 'ncvargrd   ', (ncvargrd(i), ',',i=1,maxcvars)
       print *, prefix, 'ncvartype  ', (ncvartype(i),',',i=1,maxcvars)
      end if
c--   Check the header information for consistency.

cph      if ( filenopt .ne. nopt ) then
cph       print*
cph       print*,' READ_HEADER: Input data belong to the wrong'
cph       print*,'              optimization cycle.'
cph       print*,'              optimization cycle = ',nopt
cph       print*,'              input optim  cycle = ',filenopt
cph       print*
cph       stop   ' ... stopped in READ_HEADER.'
cph      endif

      if ( (fileiG .ne. biG) .or. (filejG .ne. bjG) ) then
       print*
       print*, prefix, 'Tile indices of loop and data do not match.'
       print*,'                 loop x/y component = ',
     &      biG,bjG
       print*,'                 data x/y component = ',
     &      fileiG,filejG
       print*
       stop   ' ... stopped in OPTIM_READDATA.'
      endif

      if ( (filensx .ne. nSx) .or. (filensy .ne. nSy) ) then
       print*
       print*, prefix, ' Numbers of tiles do not match.'
       print*,'                 parameter x/y no. of tiles = ',
     &      nSx,nSy
       print*,'                 data      x/y no. of tiles = ',
     &      filensx,filensy
       print*
       stop   ' ... stopped in OPTIM_READDATA.'
      endif

ce    Add some more checks. ...

      if (.NOT. lheaderonly) then
c--   Read the data.
       icvoffset = 0
c      do ivar = 1,maxcvars
       do ivar = 1,nvartype
        if ( ncvarindex(ivar) .ne. -1 ) then
         do icvrec = 1,ncvarrecs(ivar)
cph          do bj = 1,nsy
cph           do bi = 1,nsx
            read( funit ) ncvarindex_loc
            read( funit ) filej
            read( funit ) filei
            if ( ncvarindex_loc.NE.ncvarindex(ivar) .AND. icvrec.EQ.1 )
     &       print*, prefix, ' ivar=', ivar, ' , ncvarindex(com,loc)=',
     &               ncvarindex(ivar), ncvarindex_loc
            do k = 1,ncvarnrmax(ivar)
             cbuffindex = 0
             if (ncvargrd(ivar) .eq. 'c') then
              cbuffindex = nWetcGlobal(k)
             else if (ncvargrd(ivar) .eq. 's') then
              cbuffindex = nWetsGlobal(k)
             else if (ncvargrd(ivar) .eq. 'w') then
              cbuffindex = nWetwGlobal(k)
c            else if (ncvargrd(ivar) .eq. 'v') then
c             cbuffindex = nWetvGlobal(k)
#ifdef ALLOW_SHELFICE
             else if (ncvargrd(ivar) .eq. 'i') then
              cbuffindex = nWetiGlobal(k)
#endif
#ifdef ALLOW_OBCS_CONTROL
cgg(   O.B. points have the grid mask "m".
             else if (ncvargrd(ivar) .eq. 'm') then
cgg    From "icvrec", calculate what iobcs must be.
              gg   = (icvrec-1)/nobcs
              igg  = int(gg)
              iobcs= icvrec - igg*nobcs
# ifdef ALLOW_OBCSN_CONTROL
              if (ncvarindex(ivar) .eq. 1)
     &             cbuffindex = nWetobcsnGlo(k,iobcs)
# endif
# ifdef ALLOW_OBCSS_CONTROL
              if (ncvarindex(ivar) .eq. 2)
     &             cbuffindex = nWetobcssGlo(k,iobcs)
# endif
# ifdef ALLOW_OBCSE_CONTROL
              if (ncvarindex(ivar) .eq. 3)
     &             cbuffindex = nWetobcseGlo(k,iobcs)
# endif
# ifdef ALLOW_OBCSW_CONTROL
              if (ncvarindex(ivar) .eq. 4)
     &             cbuffindex = nWetobcswGlo(k,iobcs)
# endif
cgg)
#endif /* ALLOW_OBCS_CONTROL */
             endif
             if ( icvoffset + cbuffindex .gt. nvarlength ) then
              print*
              print *, ' ERROR:'
              print *, ' There are at least ', icvoffset+cbuffindex,
     &             ' records in '//fname(1:28)//'.'
              print *, ' This is more than expected from nvarlength =',
     &             nvarlength, '.'
              print *, ' Something is wrong in the computation of '//
     &             'the wet points or'
              print *, ' in computing the number of records in '//
     &             'some variable(s).'
              print *, '  ...  stopped in OPTIM_READDATA.'
              stop     '  ...  stopped in OPTIM_READDATA.'
             endif
             if (cbuffindex .gt. 0) then
              read( funit ) cbuffindex
              read( funit ) filek
              read( funit ) (cbuff(ii), ii=1,cbuffindex)
              do icvcomp = 1,cbuffindex
               vv(icvoffset+icvcomp) = cbuff(icvcomp)
c     If you want to optimize with respect to just O.B. T and S
c     uncomment the next two lines.
c              if (iobcs .eq. 3) vv(icvoffset+icvcomp)=0.
c              if (iobcs .eq. 4) vv(icvoffset+icvcomp)=0.
              enddo
              icvoffset = icvoffset + cbuffindex
             endif
            enddo
cph           enddo
cph          enddo
         enddo
        endif
       enddo

      else

c--   Assign the number of control variables.
       nn = nvarlength

      endif

      close( funit )

c--   Assign the cost function value in case we read the cost file.

      if      ( dfile .eq. ctrlname ) then
       ff = 0. d 0
      else if ( dfile .eq. costname ) then
       ff = fileff
      endif
c--   Always return the cost function value if lheaderonly
      if ( lheaderonly) ff = fileff

      print *, prefix, 'end of optim_readdata'
      print *, ' '

      return
      end

#include "ATM_PHYS_OPTIONS.h"

CBOP
C !ROUTINE: ATM_PHYS_DRIVER

C !INTERFACE: ==========================================================
      SUBROUTINE ATM_PHYS_DRIVER(
     I                    myTime, myIter, myThid )

C !DESCRIPTION:
C Calculate custom tendency terms outside k-loop in DO_OCEANIC_PHYS

C !USES: ===============================================================
      use radiation_mod
      use lscale_cond_mod
      use dargan_bettsmiller_mod
      use surface_flux_mod
      use vert_turb_driver_mod
      use vert_diff_mod, only: gcm_vert_diff_down,
     &                         gcm_vert_diff_up,
     &                         surf_diff_type
      use mixed_layer_mod, only: mixed_layer
      use constants_mod, only:  HLv

      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "SURFACE.h"
#include "FFIELDS.h"
#include "ATM_PHYS_PARAMS.h"
#include "ATM_PHYS_VARS.h"

C !INPUT PARAMETERS: ===================================================
C  myTime   :: Current time in simulation
C  myIter   :: Current time-step number
C  myThid   :: my Thread Id number
      _RL     myTime
      INTEGER myIter, myThid

C !OUTPUT PARAMETERS: ==================================================

C !LOCAL VARIABLES: ====================================================
C  bi,bj    :: Tile indices
C  lat2d    :: latitude of grid-cell center          [rad]
C pHalf3d   :: pressure at interface between 2 levels [Pa]
C pFull3d   :: pressure at level center               [Pa]
C zHalf3d   :: height of interface between 2 levels   [m]
C zFull3d   :: height of level center                 [m]
C  t3d      :: absolute temperature                   [K]
C  q3d      :: specific humidity                    [kg/kg]
C  u3d      :: wind speed, 1rst component (X-dir)    [m/s]
C  v3d      :: wind speed, 2nd  component (Y-dir)    [m/s]
      INTEGER bi, bj
      _RL lat2d   (sNx,sNy)
      _RL pHalf3d (sNx,sNy,Nr+1)
      _RL pFull3d (sNx,sNy,Nr)
      _RL zHalf3d (sNx,sNy,Nr+1)
      _RL zFull3d (sNx,sNy,Nr)
      _RL t3d     (sNx,sNy,Nr)
      _RL q3d     (sNx,sNy,Nr)
      _RL u3d     (sNx,sNy,Nr)
      _RL v3d     (sNx,sNy,Nr)
      _RL tdt3d   (sNx,sNy,Nr)
      _RL qdt3d   (sNx,sNy,Nr)
      _RL udt3d   (sNx,sNy,Nr)
      _RL vdt3d   (sNx,sNy,Nr)
CEOP
      _RL s_sw_dwn(sNx,sNy)
      _RL s_lw_dwn(sNx,sNy)
      _RL t_surf  (sNx,sNy)
C-- radiation fields:
      _RL albedo_2d (sNx,sNy)
      _RL ozone_3d  (sNx,sNy,Nr)
      _RL ozoneColmn(sNx,sNy,Nr+1)
      _RL dtrans_3d (sNx,sNy,Nr)
      _RL dtrans_win(sNx,sNy,Nr)
      _RL b_3d      (sNx,sNy,Nr)
      _RL b_win     (sNx,sNy,Nr)
      _RL lw_down_3d(sNx,sNy,Nr+1)
      _RL sw_down_3d(sNx,sNy,Nr+1)
      _RL sw_net_3d (sNx,sNy,Nr+1)
      _RL lw_net_3d (sNx,sNy,Nr+1)
      _RL adj_lw_up (sNx,sNy)
      _RL rad_dt_tg (sNx,sNy,Nr)

      LOGICAL coldT (sNx,sNy)
C-- output from convection & LSC :
      _RL t3d_tmp    (sNx,sNy,Nr)
      _RL q3d_tmp    (sNx,sNy,Nr)
      _RL cond_dt_tg (sNx,sNy,Nr)
      _RL cond_dt_qg (sNx,sNy,Nr)
      _RL rain2d     (sNx,sNy)
      _RL snow2d     (sNx,sNy)
      _RL q_ref      (sNx,sNy,Nr)
      _RL t_ref      (sNx,sNy,Nr)
      _RL bmflag     (sNx,sNy)
      _RL klzbs      (sNx,sNy)
      _RL cape       (sNx,sNy)
      _RL cin        (sNx,sNy)
      _RL invtau_bm_t(sNx,sNy)
      _RL invtau_bm_q(sNx,sNy)
      _RL capeflag   (sNx,sNy)
C-- Input/Output for surface flux:
      _RL  q_surf(sNx,sNy)
      _RL  u_surf(sNx,sNy), v_surf(sNx,sNy)
      _RL  rough_mom(sNx,sNy), rough_heat(sNx,sNy)
      _RL  rough_moist(sNx,sNy), gust(sNx,sNy)
      _RL  flux_t(sNx,sNy), flux_q(sNx,sNy), flux_r(sNx,sNy)
      _RL  flux_u(sNx,sNy), flux_v(sNx,sNy)
      _RL  drag_m(sNx,sNy), drag_t(sNx,sNy), drag_q(sNx,sNy)
      _RL  w_atm(sNx,sNy)
      _RL  ustar(sNx,sNy), bstar(sNx,sNy), qstar(sNx,sNy)
      _RL  dhdt_surf(sNx,sNy), dedt_surf(sNx,sNy), dedq_surf(sNx,sNy)
      _RL  drdt_surf(sNx,sNy)
      _RL  dhdt_atm(sNx,sNy), dedq_atm(sNx,sNy), dtaudv_atm(sNx,sNy)
      LOGICAL land(sNx,sNy), avail(sNx,sNy)
C-- Input for turb:
      _RL fracland(sNx,sNy)
      _RL rough(sNx,sNy)
C-- Output from turbulence driver:
      _RL  diff_t(sNx,sNy,Nr), diff_m(sNx,sNy,Nr)
      _RL diff_dt_tg (sNx,sNy,Nr)
      _RL diff_dt_qg (sNx,sNy,Nr)
      _RL diss_heat  (sNx,sNy,Nr)
c     TYPE(surf_diff_type) :: tri_surf ! used by gcm_vert_diff
      _RL tri_surf_dtmass(sNx,sNy)
      _RL tri_surf_dflux_t(sNx,sNy), tri_surf_dflux_q(sNx,sNy)
      _RL tri_surf_delta_t(sNx,sNy), tri_surf_delta_q(sNx,sNy)
      _RL e_global(sNx,sNy,Nr-1)
      _RL f_t_global(sNx,sNy,Nr-1), f_q_global(sNx,sNy,Nr-1)
C-- Mixed Layer fields:
      _RL ocean_qflux(sNx,sNy)
      _RL mixLayDepth(sNx,sNy)
      _RL delta_t_surf(sNx,sNy)
C--
      _RL dpFac(sNx,sNy)
      _RL conv_T2theta
      INTEGER k, kc
c     INTEGER ioUnit
c     _RS     dummyRS(1)
#ifdef COMPONENT_MODULE
      INTEGER i, j
      _RL taux(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL tauy(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
#endif /* COMPONENT_MODULE */

C--   Loops on tile indices bi,bj
      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)

C--   Get surface temperature
        t_surf(:,:) = atmPhys_SST(1:sNx,1:sNy,bi,bj)
#ifdef COMPONENT_MODULE
        IF ( useCoupler ) THEN
C--   take surface data from the ocean component
C     to replace MxL fields (if use sea-ice) or directly atm_phys SST
          CALL ATM_APPLY_IMPORT(
     I             maskInC,
     U             t_surf, taux,
c    U             sst1(1,myThid), oice1,
     I             myTime, myIter, bi, bj, myThid )
        ENDIF
#endif /* COMPONENT_MODULE */
#ifdef ALLOW_DIAGNOSTICS
        IF ( useDiagnostics ) THEN
C--   fill-up Atm_Phys diagnostics for state variables
         CALL DIAGNOSTICS_FILL( t_surf, 'AtPh_SST',
     &                          0, 1, 3, bi, bj, myThid )
        ENDIF
#endif /* ALLOW_DIAGNOSTICS */
c       IF ( myIter.EQ.nIter0 ) THEN
c        ioUnit = 0
c        CALL MDS_WRITEVEC_LOC(
c    I                     'SST.check', writeBinaryPrec, ioUnit,
c    I                     'RL', sNx*sNy, t_surf, dummyRS,
c    I                     bi, bj, 1, myIter, myThid )
c       ENDIF
        ocean_qflux(:,:) = atmPhys_Qflx(1:sNx,1:sNy,bi,bj)
        mixLayDepth(:,:) = atmPhys_MxLD(1:sNx,1:sNy,bi,bj)
        albedo_2d(:,:) = atmPhys_Albedo(1:sNx,1:sNy,bi,bj)
C--   copy atmPhys_Ozone to ozone_3d for rad scheme
        DO k=1,Nr
          kc = Nr-k+1
          ozone_3d(:,:,k) = atmPhys_Ozone(1:sNx,1:sNy,kc,bi,bj)
        ENDDO

C--   Get grid and dynamical fields from main model common blocks
        CALL ATM_PHYS_DYN2PHYS(
     O                    lat2d, pHalf3d, pFull3d,
     O                    zHalf3d, zFull3d,
     O                    t3d, q3d, u3d, v3d,
     I                    bi, bj, myTime, myIter, myThid )

C--   initialise
        coldT(:,:) = .FALSE.
        EmPmR(:,:,bi,bj) = 0.
        rain2d(:,:) = 0.
        snow2d(:,:) = 0.

C--   initialise tendency
        tdt3d = 0.
        qdt3d = 0.
        udt3d = 0.
        vdt3d = 0.
        cond_dt_tg = 0.
        cond_dt_qg = 0.

        IF (lwet_convection) THEN
          CALL DARGAN_BETTSMILLER(
     I                   deltaT, t3d, q3d, pFull3d, pHalf3d, coldT,
     O                   rain2d, snow2d, cond_dt_tg, cond_dt_qg,
     O                   q_ref,      bmflag,
     O                   klzbs,        cape,
     O                   cin,         t_ref,
     O                   invtau_bm_t,     invtau_bm_q,
     O                   capeflag,
     I                   bi,bj,myIter,myThid )

C-    store updated state to pass to LSC (addition from POG)
          t3d_tmp = t3d + cond_dt_tg
          q3d_tmp = q3d + cond_dt_qg

          cond_dt_tg = cond_dt_tg / deltaT
          cond_dt_qg = cond_dt_qg / deltaT
          rain2d = rain2d / deltaT
          EmPmR(1:sNx,1:sNy,bi,bj) = -rain2d(:,:)

          tdt3d = tdt3d + cond_dt_tg
          qdt3d = qdt3d + cond_dt_qg

#ifdef ALLOW_DIAGNOSTICS
          IF ( useDiagnostics ) THEN
           CALL DIAGNOSTICS_FILL( rain2d , 'AtPhCnvP',
     &                            0, 1, 3, bi, bj, myThid )
           CALL DIAGNOSTICS_FILL( cape   , 'AtPhCAPE',
     &                            0, 1, 3, bi, bj, myThid )
           CALL DIAGNOSTICS_FILL( cin    , 'AtPhCnIn',
     &                            0, 1, 3, bi, bj, myThid )
           CALL DIAGNOSTICS_FILL( klzbs  , 'AtPhKlzb',
     &                            0, 1, 3, bi, bj, myThid )
           CALL DIAGNOSTICS_FILL( bmflag , 'AtPhConv',
     &                            0, 1, 3, bi, bj, myThid )
           CALL DIAGNOSTICS_FILL( invtau_bm_t, 'AtPhRlxT',
     &                            0, 1, 3, bi, bj, myThid )
           CALL DIAGNOSTICS_FILL( invtau_bm_q, 'AtPhRlxQ',
     &                            0, 1, 3, bi, bj, myThid )
           CALL DIAGNOSTICS_FILL( t_ref  , 'AtPh_Trf',
     &                           -1,Nr, 3, bi, bj, myThid )
           CALL DIAGNOSTICS_FILL( q_ref  , 'AtPh_Qrf',
     &                           -1,Nr, 3, bi, bj, myThid )
          CALL DIAGNOSTICS_FILL( cond_dt_tg, 'AtPhdTcv',
     &                           -1,Nr, 3, bi, bj, myThid )
c          snow2d = snow2d / deltaT
c          CALL DIAGNOSTICS_FILL( snow2d , 'SDIAG1  ',
c    &                            0, 1, 3, bi, bj, myThid )
          ENDIF
#endif /* ALLOW_DIAGNOSTICS */
        ELSE
          t3d_tmp = t3d
          q3d_tmp = q3d
        ENDIF

        cond_dt_tg = 0.
        cond_dt_qg = 0.
        rain2d(:,:) = 0.
        CALL LSCALE_COND(
     I              t3d_tmp, q3d_tmp, pFull3d, pHalf3d, coldT,
     O              rain2d, snow2d, cond_dt_tg, cond_dt_qg, q_ref,
     I              myThid )
        cond_dt_tg = cond_dt_tg / deltaT
        cond_dt_qg = cond_dt_qg / deltaT
        rain2d = rain2d / deltaT
        EmPmR(1:sNx,1:sNy,bi,bj) = EmPmR(1:sNx,1:sNy,bi,bj)
     &                           - rain2d(:,:)

        tdt3d = tdt3d + cond_dt_tg
        qdt3d = qdt3d + cond_dt_qg

#ifdef ALLOW_DIAGNOSTICS
        IF ( useDiagnostics ) THEN
           CALL DIAGNOSTICS_FILL( rain2d , 'AtPhLscP',
     &                            0, 1, 3, bi, bj, myThid )
C     Re-use "q_ref" array to calculate Relative Humidity (in %)
           q_ref = 100. _d 0 * q3d_tmp/MAX( q_ref, 1. _d -12 )
           CALL DIAGNOSTICS_FILL( q_ref , 'RELHUM  ',
     &                           -1, Nr, 3, bi, bj, myThid )
        ENDIF
#endif /* ALLOW_DIAGNOSTICS */

        IF ( two_stream ) THEN
          CALL RADIATION_DOWN(
     I                   sNx,sNy, myTime, lat2d, pHalf3d, t3d, q3d,
     I                   albedo_2d, ozone_3d,
     O                   ozoneColmn, s_sw_dwn, s_lw_dwn,
     O                   dtrans_3d, dtrans_win, b_3d, b_win,
     O                   lw_down_3d, sw_down_3d, myThid )

c         write(errorMessageUnit,'(A,I5,I3,4F9.3)')
c    &      'it,bj,sw,lw:',myIter,bj,
c    &      sw_down_3d(1,1,15), sw_down_3d(1,sNy,15),
c    &      lw_down_3d(1,1,15), lw_down_3d(1,sNy,15)
        ENDIF

        IF (.TRUE.) THEN
         land = .false.
         avail = .true.
         rough_mom = roughness_mom
         rough_heat = roughness_heat
         rough_moist = roughness_moist
         gust = 1.0
         u_surf = 0.
         v_surf = 0.
         CALL SURFACE_FLUX(
     I            t3d(:,:,Nr), q3d(:,:,Nr), u3d(:,:,Nr), v3d(:,:,Nr),
     I            pFull3d(:,:,Nr), zFull3d(:,:,Nr), pHalf3d(:,:,Nr+1),
     I            t_surf, t_surf,
     U            q_surf,
     I            u_surf, v_surf,
     I            rough_mom, rough_heat, rough_moist, gust,
     O            flux_t, flux_q, flux_r, flux_u, flux_v,
     O            drag_m, drag_t, drag_q, w_atm,
     O            ustar, bstar, qstar,
     O            dhdt_surf, dedt_surf, dedq_surf, drdt_surf,
     O            dhdt_atm, dedq_atm, dtaudv_atm,
     I            deltaT, land(:,:), avail(:,:), myThid  )
        ENDIF

        IF ( two_stream ) THEN
          rad_dt_tg = tdt3d
          CALL RADIATION_UP(
     I                   sNx,sNy, myTime, lat2d, pHalf3d, t_surf, t3d,
     U                   tdt3d, lw_net_3d, sw_net_3d,
     I                   albedo_2d, ozoneColmn, dtrans_3d, dtrans_win,
     I                   b_3d, b_win, lw_down_3d, sw_down_3d, myThid )

c         write(errorMessageUnit,'(A,I5,I3,4F9.3)')
c    &      'it,bj,t,tdt:',myIter,bj,
c    &      t3d(1,1,15), t3d(1,sNy,15),
c    &      tdt3d(1,1,15)*86400., tdt3d(1,sNy,15)*86400.
          rad_dt_tg = tdt3d - rad_dt_tg
        ELSE
          rad_dt_tg = 0.
        ENDIF

        IF (turb) THEN
         fracland = 0.0
         rough = roughness_mom
         CALL VERT_TURB_DRIVER(  1, 1, myTime, myTime+deltaT, deltaT,
     I             fracland(:,:), pHalf3d, pFull3d, zHalf3d, zFull3d,
     I             ustar, bstar, rough,
     I             u3d, v3d, t3d, q3d,
     O             diff_t(:,:,:), diff_m(:,:,:), gust(:,:),
     I             myThid )
        ENDIF

        diff_dt_tg = tdt3d
        diff_dt_qg = qdt3d

        CALL GCM_VERT_DIFF_DOWN( 1, 1, deltaT,
     I           u3d, v3d, t3d, q3d,
     I           diff_m(:,:,:), diff_t(:,:,:),
     I           pHalf3d, pFull3d, zFull3d,
     U           flux_u(:,:),  flux_v(:,:),  dtaudv_atm,
     U           udt3d, vdt3d, tdt3d,
     I           qdt3d,
     O           diss_heat(:,:,:),
     U           tri_surf_dtmass,
     U           tri_surf_dflux_t, tri_surf_dflux_q,
     U           tri_surf_delta_t, tri_surf_delta_q,
     O           e_global, f_t_global, f_q_global,
     I           myThid )

        CALL MIXED_LAYER(
     I                    myTime,
     U                    t_surf(:,:),
     U                    flux_t(:,:), flux_q(:,:), flux_r(:,:),
     I                    deltaT,
     I                    s_sw_dwn(:,:), s_lw_dwn(:,:),
     U                    tri_surf_dtmass,
     U                    tri_surf_dflux_t, tri_surf_dflux_q,
     U                    tri_surf_delta_t, tri_surf_delta_q,
     I                    dhdt_surf(:,:), dedt_surf(:,:),
     I                    dedq_surf(:,:), drdt_surf(:,:),
     I                    dhdt_atm(:,:),  dedq_atm(:,:),
     I                    ocean_qflux, mixLayDepth,
     O                    delta_t_surf(:,:),
     I                    myThid )

        CALL GCM_VERT_DIFF_UP ( 1, 1, deltat,
     I           tri_surf_delta_t, tri_surf_delta_q,
     I           e_global, f_t_global, f_q_global,
     O           tdt3d, qdt3d,
     I           myThid )

        diff_dt_tg = tdt3d - diff_dt_tg
        diff_dt_qg = qdt3d - diff_dt_qg

C-- update Upward LW (assuming adjustment of surf LW emission goes directly to space)
        adj_lw_up = drdt_surf*delta_t_surf
        DO k=1,Nr+1
         lw_net_3d(:,:,k) = lw_net_3d(:,:,k) + adj_lw_up
        ENDDO

        DO k=1,Nr
          kc = Nr-k+1
          conv_T2theta = (atm_po/rC(kc))**atm_kappa
#ifdef NONLIN_FRSURF
          IF ( select_rStar.GE.1 ) THEN
           atmPhys_dT(1:sNx,1:sNy,kc,bi,bj) = tdt3d(:,:,k)
     &                   * conv_T2theta/pStarFacK(1:sNx,1:sNy,bi,bj)
          ELSE
#else /* NONLIN_FRSURF */
          IF ( .TRUE. ) THEN
#endif /* NONLIN_FRSURF */
           atmPhys_dT(1:sNx,1:sNy,kc,bi,bj) = tdt3d(:,:,k)
     &                   * conv_T2theta
          ENDIF
          atmPhys_dQ(1:sNx,1:sNy,kc,bi,bj)  = qdt3d(:,:,k)
C-    Note: multiply A-grid tend. by hFacC (<-> dpFac) here and
C     C-grid average will be divided by hFacW,S when applied to Dynamics
          dpFac(:,:) = ( pHalf3d(:,:,k+1) - pHalf3d(:,:,k)
     &                 )*recip_drF(kc)
          atmPhys_dU(1:sNx,1:sNy,kc,bi,bj) = udt3d(:,:,k)*dpFac(:,:)
          atmPhys_dV(1:sNx,1:sNy,kc,bi,bj) = vdt3d(:,:,k)*dpFac(:,:)
        ENDDO

C--   Update SST
        IF ( atmPhys_stepSST ) THEN
          atmPhys_SST(1:sNx,1:sNy,bi,bj) = t_surf(:,:)
        ENDIF

        EmPmR(1:sNx,1:sNy,bi,bj) = EmPmR(1:sNx,1:sNy,bi,bj)
     &                           + flux_q(:,:)
        Qnet(1:sNx,1:sNy,bi,bj) = flux_t(:,:) + flux_r(:,:)
     &                          - s_lw_dwn(:,:) - s_sw_dwn(:,:)
     &                          + flux_q(:,:)*HLv
        Qsw (1:sNx,1:sNy,bi,bj) = -s_sw_dwn(:,:)
#ifdef COMPONENT_MODULE
C-    surface wind-stress (+ = down) at grid cell center (A-grid):
        taux(1:sNx,1:sNy,bi,bj) = -flux_u
        tauy(1:sNx,1:sNy,bi,bj) = -flux_v
#endif /* COMPONENT_MODULE */

#ifdef ALLOW_DIAGNOSTICS
        IF ( useDiagnostics ) THEN
          CALL DIAGNOSTICS_FILL( atmPhys_dT , 'AtPhdTdt',
     &                           0, Nr, 1, bi, bj, myThid )
          CALL DIAGNOSTICS_FILL( atmPhys_dQ , 'AtPhdQdt',
     &                           0, Nr, 1, bi, bj, myThid )
c         CALL DIAGNOSTICS_FILL( atmPhys_dU , 'AtPhdUdt',
c    &                           0, Nr, 1, bi, bj, myThid )
c         CALL DIAGNOSTICS_FILL( atmPhys_dV , 'AtPhdVdt',
c    &                           0, Nr, 1, bi, bj, myThid )
          CALL DIAGNOSTICS_FILL( udt3d , 'AtPhdUdt',
     &                           -1, Nr, 3, bi, bj, myThid )
          CALL DIAGNOSTICS_FILL( vdt3d , 'AtPhdVdt',
     &                           -1, Nr, 3, bi, bj, myThid )
          CALL DIAGNOSTICS_FILL( diff_t , 'AtPhDifT',
     &                           -1, Nr, 3, bi, bj, myThid )
          CALL DIAGNOSTICS_FILL( diff_m , 'AtPhDifM',
     &                           -1, Nr, 3, bi, bj, myThid )
          CALL DIAGNOSTICS_FILL( rad_dt_tg , 'AtPhdTrd',
     &                           -1, Nr, 3, bi, bj, myThid )
          CALL DIAGNOSTICS_FILL( sw_net_3d , 'AtPhNSR ',
     &                           -1, Nr+1, 3, bi, bj, myThid )
          CALL DIAGNOSTICS_FILL( lw_net_3d , 'AtPhNLR ',
     &                           -1, Nr+1, 3, bi, bj, myThid )
          CALL DIAGNOSTICS_FILL( sw_down_3d, 'AtPhDSR ',
     &                           -1, Nr+1, 3, bi, bj, myThid )
          CALL DIAGNOSTICS_FILL( lw_down_3d, 'AtPhDLR ',
     &                           -1, Nr+1, 3, bi, bj, myThid )
          CALL DIAGNOSTICS_FILL( sw_down_3d, 'AtPhInSR',
     &                           0, 1, 3, bi, bj, myThid )
          CALL DIAGNOSTICS_FILL( sw_net_3d , 'AtPhNTSR',
     &                           0, 1, 3, bi, bj, myThid )
          CALL DIAGNOSTICS_FILL( lw_net_3d , 'AtPhOLR ',
     &                           0, 1, 3, bi, bj, myThid )
          CALL DIAGNOSTICS_FILL( sw_down_3d(:,:,Nr+1),'AtPhDSSR',
     &                           0, 1, 3, bi, bj, myThid )
          CALL DIAGNOSTICS_FILL( s_sw_dwn,  'AtPhNSSR',
     &                           0, 1, 3, bi, bj, myThid )
          CALL DIAGNOSTICS_FILL( s_lw_dwn,  'AtPhDSLR',
     &                           0, 1, 3, bi, bj, myThid )
          CALL DIAGNOSTICS_FILL( flux_r ,   'AtPhUSLR',
     &                           0, 1, 3, bi, bj, myThid )
          CALL DIAGNOSTICS_FILL( flux_t ,   'AtPhSens',
     &                           0, 1, 3, bi, bj, myThid )
          CALL DIAGNOSTICS_FILL( flux_q ,   'AtPhEvap',
     &                           0, 1, 3, bi, bj, myThid )
          CALL DIAGNOSTICS_FILL( flux_u , 'AtPhTauX',
     &                           0, 1, 3, bi, bj, myThid )
          CALL DIAGNOSTICS_FILL( flux_v , 'AtPhTauY',
     &                           0, 1, 3, bi, bj, myThid )
          CALL DIAGNOSTICS_FILL( cond_dt_tg, 'AtPhdTlc',
     &                           -1, Nr, 3, bi, bj, myThid )
          CALL DIAGNOSTICS_FILL( diff_dt_tg, 'AtPhdtTg',
     &                           -1, Nr, 3, bi, bj, myThid )
          CALL DIAGNOSTICS_FILL( diff_dt_qg, 'AtPhdtQg',
     &                           -1, Nr, 3, bi, bj, myThid )
          CALL DIAGNOSTICS_FILL( diss_heat,  'AtPhDisH',
     &                           -1, Nr, 3, bi, bj, myThid )
        ENDIF
#endif /* ALLOW_DIAGNOSTICS */

C--   end bi,bj loops.
       ENDDO
      ENDDO

      CALL EXCH_UV_AGRID_3D_RL( atmPhys_dU, atmPhys_dV,
     &                          .TRUE., Nr, myThid )
#ifdef COMPONENT_MODULE
C-    surface wind-stress at grid cell center (A-grid):
      IF ( useCoupler ) THEN
        CALL EXCH_UV_AGRID_3D_RL( taux, tauy,
     &                           .TRUE., 1, myThid )
       DO bj=myByLo(myThid),myByHi(myThid)
        DO bi=myBxLo(myThid),myBxHi(myThid)
         DO j=2-OLy,sNy+OLy
          DO i=2-OLx,sNx+OLx
            fu(i,j,bi,bj) = halfRL
     &                    *( taux(i-1,j,bi,bj) + taux(i,j,bi,bj) )
            fv(i,j,bi,bj) = halfRL
     &                    *( tauy(i,j-1,bi,bj) + tauy(i,j,bi,bj) )
          ENDDO
         ENDDO
        ENDDO
       ENDDO
       CALL ATM_STORE_MY_DATA( myTime, myIter, myThid )
      ENDIF
#endif /* COMPONENT_MODULE */

      RETURN
      END

#include "SEAICE_OPTIONS.h"
#ifdef ALLOW_SALT_PLUME
# include "SALT_PLUME_OPTIONS.h"
#endif

CStartOfInterface
      SUBROUTINE SEAICE_TRACER_PHYS( myTime, myIter, myThid )
C     *=======================================================*
C     | SUBROUTINE seaice_tracer_phys
C     | o Time step SItr/SItrEFF as a result of
C     |   seaice thermodynamics and specific tracer physics
C     *=======================================================*
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "FFIELDS.h"
#include "DYNVARS.h"
#include "SEAICE_SIZE.h"
#include "SEAICE.h"
#include "SEAICE_GRID.h"
#include "SEAICE_PARAMS.h"
#include "SEAICE_TRACER.h"
#ifdef ALLOW_SALT_PLUME
# include "SALT_PLUME.h"
#endif

C     === Routine arguments ===
C     INPUT:
C     myTime  :: Simulation time
C     myIter  :: Simulation timestep number
C     myThid  :: Thread no. that called this routine.
C     OUTPUT:
      _RL myTime
      INTEGER myIter, myThid
CEndOfInterface

C     === Local variables ===
#ifdef ALLOW_SITRACER

      INTEGER iTr, jTh, i, j, bi, bj, ks
      _RL SItrFromOcean  (1:sNx,1:sNy)
      _RL SItrFromFlood   (1:sNx,1:sNy)
      _RL HEFFprev, HEFFpost, growFact, meltPart, tmpscal1
      _RL SItrExpand  (1:sNx,1:sNy)
      _RL AREAprev, AREApost, expandFact
      CHARACTER*8   diagName

#ifdef ALLOW_SITRACER_DEBUG_DIAG
      _RL DIAGarray     (1:sNx,1:sNy,Nr)
#endif

cgf for now I do not fully account for ocean-ice fluxes of tracer
cgf -> I just prescribe it consistent with age tracer
cgf eventually I will need to handle them as function params

      ks=1

      DO bj=myByLo(myThid),myByHi(myThid)
      DO bi=myBxLo(myThid),myBxHi(myThid)
      DO iTr=1,SItrNumInUse

c 0) set ice-ocean and ice-snow exchange values
c =============================================
      DO j=1,sNy
       DO i=1,sNx
        SItrFromOcean(i,j)=SItrFromOcean0(iTr)
        SItrFromFlood(i,j)=SItrFromFlood0(iTr)
        SItrExpand(i,j)=SItrExpand0(iTr)
       ENDDO
      ENDDO
c salinity tracer:
      if ( (SItrName(iTr).EQ.'salinity').AND.
     &      (SItrFromOceanFrac(iTr).GT.ZERO) ) then
       DO j=1,sNy
        DO i=1,sNx
         SItrFromOcean(i,j)=SItrFromOceanFrac(iTr)*salt(i,j,ks,bi,bj)
         SItrFromFlood(i,j)=SItrFromFloodFrac(iTr)*salt(i,j,ks,bi,bj)
        ENDDO
       ENDDO
      endif
c 1) seaice thermodynamics processes
c ==================================
      if (SItrMate(iTr).EQ.'HEFF') then
      DO j=1,sNy
       DO i=1,sNx
        HEFFprev=SItrHEFF(i,j,bi,bj,1)
#ifdef ALLOW_SITRACER_DEBUG_DIAG
        DIAGarray(i,j,5+(iTr-1)*5) =
     &    HEFFprev*SItracer(i,j,bi,bj,iTr) + SItrBucket(i,j,bi,bj,iTr)
#endif
c apply the sequence of thermodynamics increments to actual tracer
c (see seaice_growth.F)
c (jTh=1 tendency due to ice-ocean interaction)
c (jTh=2 tendency due to the atmosphere, over ice covered part)
c (jTh=3 tendency due to the atmosphere, over open water part)
c (jTh=4 tendency due to flooding)
        DO jTh=1,3
         HEFFprev=SItrHEFF(i,j,bi,bj,jTh)
         HEFFpost=SItrHEFF(i,j,bi,bj,jTh+1)
c compute ratio in [0. 1.] range for either growth or melt
         growFact=1. _d 0
         meltPart=0. _d 0
         if (HEFFpost.GT.HEFFprev) growFact=HEFFprev/HEFFpost
         if (HEFFpost.LT.HEFFprev) meltPart=HEFFprev-HEFFpost
c update SItr accordingly
         SItracer(i,j,bi,bj,iTr)=SItracer(i,j,bi,bj,iTr)*growFact
     &                      +SItrFromOcean(i,j)*(1. _d 0 - growFact)
         SItrBucket(i,j,bi,bj,iTr)=SItrBucket(i,j,bi,bj,iTr)
     &             -HEFFpost*SItrFromOcean(i,j)*(1. _d 0 - growFact)
         SItrBucket(i,j,bi,bj,iTr)=SItrBucket(i,j,bi,bj,iTr)
     &                            +meltPart*SItracer(i,j,bi,bj,iTr)
        ENDDO
c apply flooding term
        growFact=1. _d 0
        HEFFprev=SItrHEFF(i,j,bi,bj,4)
        HEFFpost=SItrHEFF(i,j,bi,bj,5)
        if (HEFFpost.GT.HEFFprev) growFact=HEFFprev/HEFFpost
        SItracer(i,j,bi,bj,iTr)=SItracer(i,j,bi,bj,iTr)*growFact
     &                     +SItrFromFlood(i,j) *(1. _d 0 - growFact)
c rk: flooding can only imply an ocean-ice tracer exchange, as long
c as we dont have snow tracers, so it goes through SItrBucket.
          SItrBucket(i,j,bi,bj,iTr)=SItrBucket(i,j,bi,bj,iTr)
     &             -HEFFpost*SItrFromFlood(i,j)*(1. _d 0 - growFact)
#ifdef ALLOW_SITRACER_DEBUG_DIAG
        DIAGarray(i,j,5+(iTr-1)*5) = HEFFpost*SItracer(i,j,bi,bj,iTr)
     &  +SItrBucket(i,j,bi,bj,iTr)-DIAGarray(i,j,5+(iTr-1)*5)
#endif
       ENDDO
      ENDDO
c TAF?      if (SItrMate(iTr).EQ.'AREA') then
      else
c 1) or seaice cover expansion
c ============================
c this is much simpler than for ice volume/mass tracers, because
c properties of the ice surface are not be conserved across the
c ocean-ice system, the contraction/expansion terms are all
c simultaneous (which is sane), and the only generic effect
c is due to expansion (new cover).
      DO j=1,sNy
       DO i=1,sNx
c apply expansion
        AREAprev=SItrAREA(i,j,bi,bj,2)
        AREApost=SItrAREA(i,j,bi,bj,3)
c compute ratio in [0. 1.] range for expansion/contraction
        expandFact=1. _d 0
        if (AREApost.GT.AREAprev) expandFact=AREAprev/AREApost
c update SItr accordingly
         SItracer(i,j,bi,bj,iTr)=SItracer(i,j,bi,bj,iTr)*expandFact
     &                      +SItrExpand(i,j)*(1. _d 0 - expandFact)
       ENDDO
      ENDDO
      endif
c 2) very ice tracer processes
c ============================
      if (SItrName(iTr).EQ.'age') then
c age tracer: grow old as time passes by
       DO j=1,sNy
        DO i=1,sNx
          if (( (SItrHEFF(i,j,bi,bj,5).GT.0. _d 0).AND.(SItrMate(iTr)
     &     .EQ.'HEFF') ).OR.( (SItrAREA(i,j,bi,bj,3).GT.0. _d 0).AND.
     &     (SItrMate(iTr).EQ.'AREA') )) then
            SItracer(i,j,bi,bj,iTr)=
     &      SItracer(i,j,bi,bj,iTr)+SEAICE_deltaTtherm
          else
            SItracer(i,j,bi,bj,iTr)=0. _d 0
          endif
        ENDDO
       ENDDO
      elseif (SItrName(iTr).EQ.'salinity') then
c salinity tracer: no specific process
      elseif (SItrName(iTr).EQ.'one') then
c "ice concentration" tracer: no specific process
      elseif (SItrName(iTr).EQ.'ridge') then
c simple, made up, ice surface roughness index prototype
       DO j=1,sNy
        DO i=1,sNx
c ridging increases roughness
          SItracer(i,j,bi,bj,iTr)=SItracer(i,j,bi,bj,iTr)+
     &    MAX(0. _d 0, SItrAREA(i,j,bi,bj,1)-SItrAREA(i,j,bi,bj,2))
c ice melt reduces ridges/roughness
          HEFFprev=SItrHEFF(i,j,bi,bj,1)
          HEFFpost=SItrHEFF(i,j,bi,bj,4)
          tmpscal1=1. _d 0
          if (HEFFprev.GT.HEFFpost) tmpscal1=HEFFpost/HEFFprev
          SItracer(i,j,bi,bj,iTr)=SItracer(i,j,bi,bj,iTr)*tmpscal1
        ENDDO
       ENDDO
      endif
c 3) ice-ocean tracer exchange/mapping to external variables
c ==========================================================
#ifdef ALLOW_DIAGNOSTICS
      IF ( useDiagnostics .AND. SItrMate(iTr).EQ.'HEFF') THEN
        WRITE(diagName,'(A4,I2.2,A2)') 'SItr',iTr,'Fx'
        tmpscal1=-ONE/SEAICE_deltaTtherm*SEAICE_rhoIce
        CALL DIAGNOSTICS_SCALE_FILL(SItrBucket(1-OLx,1-OLy,bi,bj,iTr),
     &   tmpscal1, 1, diagName,0,1,2,bi,bj,myThid)
      ENDIF
#endif

      if ( (SItrName(iTr).EQ.'salinity').AND.
     &     (SEAICE_salinityTracer) ) then
c salinity tracer: salt flux
        DO j=1,sNy
         DO i=1,sNx
          saltFlux(i,j,bi,bj) = - SItrBucket(i,j,bi,bj,iTr)
     &      *HEFFM(i,j,bi,bj)/SEAICE_deltaTtherm*SEAICE_rhoIce
c note: at this point of the time step, that is the correct sign
#ifdef ALLOW_SALT_PLUME
c should work for both constant and variable ice salinity -- to be tested
          saltPlumeFlux(i,j,bi,bj) = MAX(zeroRS,saltFlux(i,j,bi,bj))
     &      *SPsalFRAC*(salt(i,j,ks,bi,bj)-SItrFromOcean(i,j))
#endif
         ENDDO
        ENDDO
      endif

      DO j=1,sNy
       DO i=1,sNx
#ifdef ALLOW_SITRACER_DEBUG_DIAG
        DIAGarray(i,j,4+(iTr-1)*5) = - SItrBucket(i,j,bi,bj,iTr)
     &  *HEFFM(i,j,bi,bj)/SEAICE_deltaTtherm*SEAICE_rhoIce
#endif
c empty bucket
c  but not for 'grease' (see seaice_growth.F)
        if (SItrName(iTr).NE.'grease')
     &      SItrBucket(i,j,bi,bj,iTr)=0. _d 0
       ENDDO
      ENDDO

c TAF? elseif (SItrMate(iTr).EQ.'AREA') then

c 4) diagnostics
c ==============
#ifdef ALLOW_SITRACER_DEBUG_DIAG
      if (SItrMate(iTr).EQ.'HEFF') then
      DO j=1,sNy
       DO i=1,sNx
        HEFFpost=SItrHEFF(i,j,bi,bj,5)
        DIAGarray(i,j,1+(iTr-1)*5) = SItracer(i,j,bi,bj,iTr)
        DIAGarray(i,j,2+(iTr-1)*5) = SItracer(i,j,bi,bj,iTr)*HEFFpost
c DIAGarray(:,:,3) is the term of comparison for DIAGarray(:,:,2)
        if (SItrName(iTr).EQ.'salinity') then
          DIAGarray(i,j,3+(iTr-1)*5) = HSALT(i,j,bi,bj)/SEAICE_rhoIce
        elseif (SItrName(iTr).EQ.'one') then
          DIAGarray(i,j,3+(iTr-1)*5) = HEFFpost
        endif
c DIAGarray(:,:,4) allows check of conservation : del(SItrBucket)+del(SItr*HEFF)=0. over do_phys
c DIAGarray(:,:,5) is the tracer flux from the ocean (<0 incr. ocean tracer)
       ENDDO
      ENDDO
      else
      DO j=1,sNy
       DO i=1,sNx
        AREApost=SItrAREA(i,j,bi,bj,3)
        DIAGarray(i,j,1+(iTr-1)*5) = SItracer(i,j,bi,bj,iTr)
        DIAGarray(i,j,2+(iTr-1)*5) = SItracer(i,j,bi,bj,iTr)*AREApost
       ENDDO
      ENDDO
      endif
#endif
      ENDDO
#ifdef ALLOW_SITRACER_DEBUG_DIAG
c     CALL DIAGNOSTICS_FILL(DIAGarray,'UDIAG1  ',0,Nr,3,bi,bj,myThid)
#endif
      ENDDO
      ENDDO

#endif /* ALLOW_SITRACER */

      RETURN
      END

#include "CPP_EEOPTIONS.h"

CBOP 0
C !ROUTINE: EXCH2_GET_SCAL_BOUNDS

C !INTERFACE:
      SUBROUTINE EXCH2_GET_SCAL_BOUNDS(
     I                 fCode, eWdth, updateCorners,
     I                 tgTile, tgNb,
     O                 tIlo, tIhi, tJlo, tJhi,
     O                 tiStride, tjStride,
     I                 myThid )

C !DESCRIPTION:
C     Return the index range & step of the part of the array (overlap-region)
C     which is going to be updated by the exchange with 1 neighbour.
C     Scalar field version (as opposed to 2-components vector field).
C     Note: presently only coded for grid-centered (mass point) scalar.
C           needs to extend it to grid-corner (vorticity point) scalar.

C !USES:
      IMPLICIT NONE

#include "SIZE.h"
#include "W2_EXCH2_SIZE.h"
#include "W2_EXCH2_TOPOLOGY.h"

C !INPUT/OUTPUT PARAMETERS:
C     fCode         :: field code (position on staggered grid)
C     eWdth         :: width of data region to exchange
C     updateCorners :: flag, do update corner halo region if true
C     tgTile        :: target tile
C     tgNb          :: target Neighbour entry
C     tIlo, tIhi    :: index range in I that will be filled in target array
C     tJlo, tJhi    :: index range in J that will be filled in target array
C     tiStride      :: index step  in I that will be filled in target array
C     tjStride      :: index step  in J that will be filled in target array
C     myThid        :: my Thread Id. number

      CHARACTER*2 fCode
      INTEGER     eWdth
      LOGICAL     updateCorners
      INTEGER     tgTile, tgNb
      INTEGER     tIlo, tIhi, tJlo, tJhi
      INTEGER     tiStride, tjStride
      INTEGER     myThid

C !LOCAL VARIABLES:
CEOP

C---  Initialise index range from Topology values:
      tIlo = exch2_iLo(tgNb,tgTile)
      tIhi = exch2_iHi(tgNb,tgTile)
      tJlo = exch2_jLo(tgNb,tgTile)
      tJhi = exch2_jHi(tgNb,tgTile)

C---  Expand index range according to exchange-Width "eWdth"
      IF ( tIlo .EQ. tIhi .AND. tIlo .EQ. 0 ) THEN
C      Filling a west edge overlap
       tIlo = 1-eWdth
       tiStride = 1
       IF ( tJlo .LE. tJhi ) THEN
        tjStride = 1
       ELSE
        tjStride =-1
       ENDIF
       IF ( updateCorners ) THEN
        tJlo = tJlo-tjStride*(eWdth-1)
        tJhi = tJhi+tjStride*(eWdth-1)
       ELSE
        tJlo = tJlo+tjStride
        tJhi = tJhi-tjStride
       ENDIF
      ENDIF
      IF ( tIlo .EQ. tIhi .AND. tIlo .GT. 1 ) THEN
C      Filling an east edge overlap
       tIhi = tIhi+eWdth-1
       tiStride = 1
       IF ( tJlo .LE. tJhi ) THEN
        tjStride = 1
       ELSE
        tjStride =-1
       ENDIF
       IF ( updateCorners ) THEN
        tJlo = tJlo-tjStride*(eWdth-1)
        tJhi = tJhi+tjStride*(eWdth-1)
       ELSE
        tJlo = tJlo+tjStride
        tJhi = tJhi-tjStride
       ENDIF
      ENDIF
      IF ( tJlo .EQ. tJhi .AND. tJlo .EQ. 0 ) THEN
C      Filling a south edge overlap
       tJlo = 1-eWdth
       tjStride = 1
       IF ( tIlo .LE. tIhi ) THEN
        tiStride = 1
       ELSE
        tiStride =-1
       ENDIF
       IF ( updateCorners ) THEN
        tIlo = tIlo-tiStride*(eWdth-1)
        tIhi = tIhi+tiStride*(eWdth-1)
       ELSE
        tIlo = tIlo+tiStride
        tIhi = tIhi-tiStride
       ENDIF
      ENDIF
      IF ( tJlo .EQ. tJhi .AND. tJlo .GT. 1 ) THEN
C      Filling a north edge overlap
       tJhi = tJhi+eWdth-1
       tjStride = 1
       IF ( tIlo .LE. tIhi ) THEN
        tiStride = 1
       ELSE
        tiStride =-1
       ENDIF
       IF ( updateCorners ) THEN
        tIlo = tIlo-tiStride*(eWdth-1)
        tIhi = tIhi+tiStride*(eWdth-1)
       ELSE
        tIlo = tIlo+tiStride
        tIhi = tIhi-tiStride
       ENDIF
      ENDIF

      RETURN
      END

#include "CPP_EEOPTIONS.h"

CBOP
C     !ROUTINE: EXCH2_RL2_CUBE_B

C     !INTERFACE:
      SUBROUTINE EXCH2_RL2_CUBE_B(
     U            array1, array1b,
     U            array2, array2b,
     I            signOption, fieldCode,
     I            myOLw, myOLe, myOLs, myOLn, myNz,
     I            exchWidthX, exchWidthY,
     I            cornerMode, myThid )

C     !DESCRIPTION:
C     Two components vector field AD-Exchange:
C     Tile-edge overlap-region of a 2 component vector field is added to
C     corresponding near-edge interior data point and then zero out.

C     !USES:
      IMPLICIT NONE

C     == Global data ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "EESUPPORT.h"
#include "W2_EXCH2_SIZE.h"
#include "W2_EXCH2_TOPOLOGY.h"
#include "W2_EXCH2_BUFFER.h"

C     !INPUT/OUTPUT PARAMETERS:
C     array1      :: 1rst component array with edges to exchange.
C     array2      :: 2nd  component array with edges to exchange.
C     signOption  :: Flag controlling whether vector is signed.
C     fieldCode   :: field code (position on staggered grid)
C     myOLw,myOLe :: West and East overlap region sizes.
C     myOLs,myOLn :: South and North overlap region sizes.
C     exchWidthX  :: Width of data region exchanged in X.
C     exchWidthY  :: Width of data region exchanged in Y.
C     cornerMode  :: halo-corner-region treatment: update/ignore corner region
C     myThid      :: Thread number of this instance of S/R EXCH...

      INTEGER myOLw, myOLe, myOLs, myOLn, myNz
      _RL array1(1-myOLw:sNx+myOLe,
     &           1-myOLs:sNy+myOLn,
     &           myNz, nSx, nSy)
      _RL array2(1-myOLw:sNx+myOLe,
     &           1-myOLs:sNy+myOLn,
     &           myNz, nSx, nSy)
      _RL array1b(1-myOLw:sNx+myOLe,
     &           1-myOLs:sNy+myOLn,
     &           myNz, nSx, nSy)
      _RL array2b(1-myOLw:sNx+myOLe,
     &           1-myOLs:sNy+myOLn,
     &           myNz, nSx, nSy)
      LOGICAL signOption
      CHARACTER*2 fieldCode
      INTEGER exchWidthX
      INTEGER exchWidthY
      INTEGER cornerMode
      INTEGER myThid

C     !LOCAL VARIABLES:
CEOP
      CALL EXCH2_RL2_CUBE_AD(
     U            array1b, array2b,
     I            signOption, fieldCode,
     I            myOLw, myOLe, myOLs, myOLn, myNz,
     I            exchWidthX, exchWidthY,
     I            cornerMode, myThid )
      RETURN
      END

!=======================================================================
      subroutine MITCOMPONENT_register( nx, ny, i0, j0 )

      implicit none
! MPI variables
#include "mpif.h"

! Predefined constants/arrays
#include "CPLR_SIG.h"

! Arguments
      integer nx,ny,i0,j0

! Functions
      integer mitcplr_match_comp
      integer generate_tag
      external mitcplr_match_comp
      external generate_tag

! Local
      integer ierr
      integer count,datatype,dest,tag,comm
      integer ibuf(MAX_IBUF)

!     ------------------------------------------------------------------

! Set up buffer
      ibuf(1)=1
      ibuf(2)=nx
      ibuf(3)=ny
      ibuf(4)=i0
      ibuf(5)=j0

      my_num_tiles=1
      my_tile_nx(1)=nx
      my_tile_ny(1)=ny
      my_tile_i0(1)=i0
      my_tile_j0(1)=j0

! Send message
      count=5
      datatype=MPI_INTEGER
      dest=my_coupler_rank
      tag=generate_tag(115,my_rank_in_global,'Register')
      comm=MPI_COMM_myglobal

      call MPI_Send( ibuf, count, datatype, dest, tag, comm, ierr )

      if (ierr.ne.0) then
       write(LogUnit,*) 'MITCOMPONENT_register: rank(W,G,L)=',
     &            my_rank_in_world,my_rank_in_global,my_rank_in_local,
     &            ' ierr=',ierr
       STOP 'MITCOMPONENT_register: MPI_Send failed'
      endif

!     ------------------------------------------------------------------
      call flush(LogUnit)
      return
      end
!=======================================================================

#include "PACKAGES_CONFIG.h"
#include "CPP_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: INI_FIELDS

C     !INTERFACE:
      SUBROUTINE INI_FIELDS( myThid )

C     !DESCRIPTION:
C     Initial conditions of the model state variables are set here. For
C     continuation runs a restart file will be used. For original runs
C     custom rules can be included here.

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"

C     !INPUT PARAMETERS:
      INTEGER myThid
CEOP

C     Set model variables to initial/restart conditions
      IF ( startTime .EQ. baseTime .AND.  nIter0 .EQ. 0
     &     .AND. pickupSuff .EQ. ' ' ) THEN
        CALL INI_VEL( myThid )
        CALL INI_THETA( myThid )
        CALL INI_SALT( myThid )
        CALL INI_PSURF( myThid )
        CALL INI_PRESSURE( myThid )
#ifdef INCLUDE_EP_FORCING_CODE
        CALL INI_EP( myThid )
#endif
      ELSEIF ( .NOT.useOffLine .OR. nonlinFreeSurf.GT.0 ) THEN
        CALL READ_PICKUP( nIter0, myThid )
      ENDIF

#ifdef ALLOW_NONHYDROSTATIC
      IF ( nonHydrostatic ) THEN
        CALL INI_NH_FIELDS( myThid )
      ENDIF
#endif /* ALLOW_NONHYDROSTATIC */

#ifdef NONLIN_FRSURF
# ifndef DISABLE_SIGMA_CODE
      IF ( selectSigmaCoord.NE.0 ) THEN
        CALL UPDATE_ETAWS( startTime, nIter0, myThid )
      ENDIF
# endif /* DISABLE_SIGMA_CODE */
#endif /* NONLIN_FRSURF */

      RETURN
      END

#include "CPP_EEOPTIONS.h"

C--   File global_sum_vector.F: Routines that perform global sum
C                               on a tile array, vector field
C--    Contents
C--    o GLB_SUM_VEC           - Global-Sum vector from Master thread
C--    o GLOBAL_SUM_VECTOR_RL  - Global-Sum vector (input: nSx,nSy,nVec)
C--    o GLOBAL_SUM_VECTOR_RS  - Global-Sum vector (input: nSx,nSy,nVec)
C--    o GLOBAL_SUM_VEC_ALT_RL - Global-Sum vector (input: nDim,nSx,nSy)
C--    o GLOBAL_SUM_VEC_ALT_RS - Global-Sum vector (input: nDim,nSx,nSy)
C--    o GLOBAL_SUM_VECTOR_INT - Global-Sum vector (input: nSx,nSy,nVec)

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: GLB_SUM_VEC

C     !INTERFACE:
      SUBROUTINE GLB_SUM_VEC(
     I                        nVec, tiledVec,
     O                        sumVec,
     I                        myThid )

C     !DESCRIPTION:
C     *==========================================================*
C     | SUBROUTINE GLB\_SUM\_VEC
C     | o Handle global sum from master thread
C     *==========================================================*
C     | Apply sum on a shared array of tiled vector
C     |  and operate over all tiles & all the processes.
C     *==========================================================*

C     !USES:
      IMPLICIT NONE

C     == Global data ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "EESUPPORT.h"

C     !INPUT/OUTPUT PARAMETERS:
C     nVec     :: length of input/output vector
C     tiledVec :: Input tiled vector (dims: nSx,nSy,nVec)
C     sumVec   :: Result of sum over all tiles & procs
C     myThid   :: My thread id.
      INTEGER nVec
      Real*8  tiledVec(nSx,nSy,nVec)
      Real*8  sumVec(nVec)
      INTEGER myThid

C     !LOCAL VARIABLES:
C     n, bi,bj :: Loop counters
C     mpiRC    :: MPI return code
C     msgBuf   :: Informational/error message buffer
C- type declaration of: sumMyPr, sumVec, localSum and globalSum
C          all 4 needs to have the same length as MPI_DOUBLE_PRECISION
      INTEGER n, bi, bj
#ifdef ALLOW_USE_MPI
      INTEGER mpiRC
# ifdef GLOBAL_SUM_ORDER_TILES
      INTEGER biG, bjG, fullLength
      Real*8  localSum (nSx*nPx,nSy*nPy,GSVec_size)
      Real*8  globalSum(nSx*nPx,nSy*nPy,GSVec_size)
# endif /* GLOBAL_SUM_ORDER_TILES */
#endif /* ALLOW_USE_MPI */
      Real*8  sumMyPr(GSVec_size)
      CHARACTER*(MAX_LEN_MBUF) msgBuf
CEOP

      IF ( nVec.GT.GSVec_size ) THEN
        WRITE(msgBuf,'(A,2(A,I7))') 'GLB_SUM_VEC: ',
     &       'nVec=', nVec, ' > GSVec_size=', GSVec_size
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(2A)') 'GLB_SUM_VEC: ',
     &       'increase "GSVec_size" in EEPARAMS.h and recompile'
        CALL PRINT_ERROR( msgBuf, myThid )
        STOP 'ABNORMAL END: S/R GLB_SUM_VEC'
      ENDIF

      _BEGIN_MASTER( myThid )

#if ( defined GLOBAL_SUM_ORDER_TILES && defined ALLOW_USE_MPI )
      IF ( usingMPI ) THEN

C--   Initialise local buffer
       DO n = 1,nVec
        DO bjG=1,nSy*nPy
         DO biG=1,nSx*nPx
          localSum(biG,bjG,n) = 0.
         ENDDO
        ENDDO
       ENDDO

C--   Put my own data in local buffer
       DO bj=1,nSy
        bjG = (myYGlobalLo-1)/sNy+bj
        DO bi=1,nSx
         biG = (myXGlobalLo-1)/sNx+bi
         DO n = 1,nVec
          localSum(biG,bjG,n) = tiledVec(bi,bj,n)
         ENDDO
        ENDDO
       ENDDO

C--   Collect data from all procs
       fullLength = nSx*nPx*nSy*nPy*nVec
       CALL MPI_Allreduce( localSum, globalSum, fullLength,
     &          MPI_DOUBLE_PRECISION, MPI_SUM, MPI_COMM_MODEL, mpiRC )

C--   Sum over all tiles:
       DO n = 1,nVec
        sumVec(n) = 0.
       ENDDO
       DO bjG = 1,nSy*nPy
        DO biG = 1,nSx*nPx
         DO n = 1,nVec
          sumVec(n) = sumVec(n) + globalSum(biG,bjG,n)
         ENDDO
        ENDDO
       ENDDO

      ELSE
#else /* not (GLOBAL_SUM_ORDER_TILES & ALLOW_USE_MPI) */
      IF ( .TRUE. ) THEN
#endif /* not (GLOBAL_SUM_ORDER_TILES & ALLOW_USE_MPI) */

C--   Sum over all tiles (of the same process) first
       DO n = 1,nVec
        sumMyPr(n) = 0.
       ENDDO
       DO bj = 1,nSy
        DO bi = 1,nSx
         DO n = 1,nVec
          sumMyPr(n) = sumMyPr(n) + tiledVec(bi,bj,n)
         ENDDO
        ENDDO
       ENDDO

#ifdef ALLOW_USE_MPI
       IF ( usingMPI ) THEN
C--   sum over all procs and put result into shared buffer:
        CALL MPI_Allreduce( sumMyPr, sumVec, nVec,
     &           MPI_DOUBLE_PRECISION, MPI_SUM, MPI_COMM_MODEL, mpiRC )
       ELSE
#else /* ALLOW_USE_MPI */
       IF ( .TRUE. ) THEN
#endif /* ALLOW_USE_MPI */
C--   in case MPI is not used, put result directly in shared buffer:
        DO n = 1,nVec
         sumVec(n) = sumMyPr(n)
        ENDDO
       ENDIF

      ENDIF

      _END_MASTER( myThid )

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: GLOBAL_SUM_VECTOR_RL

C     !INTERFACE:
      SUBROUTINE GLOBAL_SUM_VECTOR_RL(
     I                       nVec, tiledVec,
     O                       sumVec,
     I                       myThid )

C     !DESCRIPTION:
C     *==========================================================*
C     | SUBROUTINE GLOBAL\_SUM\_VECTOR\_RL
C     | o Handle sum for _RL vector.
C     *==========================================================*
C     | Apply sum on an array of tiled vector (input: nSx,nSy,nVec)
C     |  and operate over all tiles & all the processes.
C     | Oversize vector is cut and processed in "nCuts" pieces
C     |  that fit in buffer
C     *==========================================================*

C     !USES:
      IMPLICIT NONE

C     == Global data ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "GLOBAL_SUM.h"

C     !INPUT/OUTPUT PARAMETERS:
C     nVec     :: length of input/output vector
C     tiledVec :: Input tiled vector (dims: nSx,nSy,nVec)
C     sumVec   :: Result of sum over all tiles, threads & procs
C     myThid   :: My thread id.
      INTEGER nVec
      _RL     tiledVec(nSx,nSy,nVec)
      _RL     sumVec(nVec)
      INTEGER myThid

C     !LOCAL VARIABLES:
C     bi, bj   :: tile indices
C     n, j, j0 :: Loop counters
C     nCuts    :: range of outside loop
C     nLoc     :: range of inner loop
      INTEGER bi, bj
      INTEGER n, nCuts
      INTEGER j, j0, nLoc
CEOP

C--   starts outside loop over number of "cuts", each fitting into buffer size
      nCuts = 1 + INT( (nVec-1)/GSVec_size )
      DO n = 1,nCuts
       j0 = (n-1)*GSVec_size
       nLoc = MIN( n*GSVec_size, nVec ) - j0

C--   write local sum into shared-buffer array
       DO j = 1,nLoc
        DO bj = myByLo(myThid), myByHi(myThid)
         DO bi = myBxLo(myThid), myBxHi(myThid)
          shareBufGSVec(bi,bj,j) = tiledVec(bi,bj,j+j0)
         ENDDO
        ENDDO
       ENDDO

C--   Master thread cannot start until everyone is ready:
       CALL BAR2( myThid )
       _BEGIN_MASTER( myThid )

C--   From master-thread, do the global-sum on shared-buffer
       CALL GLB_SUM_VEC(
     I                   nLoc, shareBufGSVec,
     O                   shareGSVector,
     I                   myThid )

       _END_MASTER( myThid )
C--   Everyone wait for Master thread to be ready
       CALL BAR2( myThid )

C--   set result for every threads
       DO j=1,nLoc
        sumVec(j+j0) = shareGSVector(j)
       ENDDO

C--   end outside do-loop over nCuts
      ENDDO

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: GLOBAL_SUM_VECTOR_RS

C     !INTERFACE:
      SUBROUTINE GLOBAL_SUM_VECTOR_RS(
     I                       nVec, tiledVec,
     O                       sumVec,
     I                       myThid )

C     !DESCRIPTION:
C     *==========================================================*
C     | SUBROUTINE GLOBAL\_SUM\_VECTOR\_RS
C     | o Handle sum for _RS vector.
C     *==========================================================*
C     | Apply sum on an array of tiled vector (input: nSx,nSy,nVec)
C     |  and operate over all tiles & all the processes.
C     | Oversize vector is cut and processed in "nCuts" pieces
C     |  that fit in buffer
C     *==========================================================*

C     !USES:
      IMPLICIT NONE

C     == Global data ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "GLOBAL_SUM.h"

C     !INPUT/OUTPUT PARAMETERS:
C     nVec     :: length of input/output vector
C     tiledVec :: Input tiled vector (dims: nSx,nSy,nVec)
C     sumVec   :: Result of sum over all tiles, threads & procs
C     myThid   :: My thread id.
      INTEGER nVec
      _RS     tiledVec(nSx,nSy,nVec)
      _RS     sumVec(nVec)
      INTEGER myThid

C     !LOCAL VARIABLES:
C     bi, bj   :: tile indices
C     n, j, j0 :: Loop counters
C     nCuts    :: range of outside loop
C     nLoc     :: range of inner loop
      INTEGER bi, bj
      INTEGER n, nCuts
      INTEGER j, j0, nLoc
CEOP

C--   starts outside loop over number of "cuts", each fitting into buffer size
      nCuts = 1 + INT( (nVec-1)/GSVec_size )
      DO n = 1,nCuts
       j0 = (n-1)*GSVec_size
       nLoc = MIN( n*GSVec_size, nVec ) - j0

C--   write local sum into shared-buffer array (+ convert _RS to r8)
       DO j = 1,nLoc
        DO bj = myByLo(myThid), myByHi(myThid)
         DO bi = myBxLo(myThid), myBxHi(myThid)
          shareBufGSVec(bi,bj,j) = tiledVec(bi,bj,j+j0)
         ENDDO
        ENDDO
       ENDDO

C--   Master thread cannot start until everyone is ready:
       CALL BAR2( myThid )
       _BEGIN_MASTER( myThid )

C--   From master-thread, do the global-sum on shared-buffer
       CALL GLB_SUM_VEC(
     I                   nLoc, shareBufGSVec,
     O                   shareGSVector,
     I                   myThid )

       _END_MASTER( myThid )
C--   Everyone wait for Master thread to be ready
       CALL BAR2( myThid )

C--   set result for every threads (+ convert back r8 to _RS)
       DO j=1,nLoc
        sumVec(j+j0) = shareGSVector(j)
       ENDDO

C--   end outside do-loop over nCuts
      ENDDO

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: GLOBAL_SUM_VEC_ALT_RL

C     !INTERFACE:
      SUBROUTINE GLOBAL_SUM_VEC_ALT_RL(
     I                       nDim, nVec, vecTile,
     O                       vecSum,
     I                       myThid )

C     !DESCRIPTION:
C     *==========================================================*
C     | SUBROUTINE GLOBAL\_SUM\_VEC\_ALT\_RL
C     | o Handle sum for _RL vector.
C     *==========================================================*
C     | Apply sum on an array of tiled vector (input: nDim,nSx,nSy)
C     |  and operate over all tiles & all the processes.
C     | Oversize vector is cut and processed in "nCuts" pieces
C     |  that fit in buffer
C     *==========================================================*

C     !USES:
      IMPLICIT NONE

C     == Global data ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "GLOBAL_SUM.h"

C     !INPUT/OUTPUT PARAMETERS:
C     nDim     :: dimension of input vector
C     nVec     :: length of input/output vector to process
C     vecTile  :: Input tiled vector (dims: nDim,nSx,nSy)
C     vecSum   :: Result of sum over all tiles, threads & procs
C     myThid   :: My thread id.
      INTEGER nDim, nVec
      _RL     vecTile(nDim,nSx,nSy)
      _RL     vecSum(nVec)
      INTEGER myThid

C     !LOCAL VARIABLES:
C     bi, bj   :: tile indices
C     n, j, j0 :: Loop counters
C     nCuts    :: range of outside loop
C     nLoc     :: range of inner loop
C     msgBuf   :: Informational/error message buffer
      INTEGER bi, bj
      INTEGER n, nCuts
      INTEGER j, j0, nLoc
      CHARACTER*(MAX_LEN_MBUF) msgBuf
CEOP

      IF ( nVec.GT.nDim ) THEN
       WRITE(msgBuf,'(A,2(A,I7))') 'GLOBAL_SUM_VEC_ALT_RL: ',
     &      'nVec=', nVec, ' > nDim =', nDim
       CALL PRINT_ERROR( msgBuf, myThid )
       STOP 'ABNORMAL END: S/R GLOBAL_SUM_VEC_ALT_RL'
      ENDIF

C--   starts outside loop over number of "cuts", each fitting into buffer size
      nCuts = 1 + INT( (nVec-1)/GSVec_size )
      DO n = 1,nCuts
       j0 = (n-1)*GSVec_size
       nLoc = MIN( n*GSVec_size, nVec ) - j0

C--   write local sum into shared-buffer array
       DO j = 1,nLoc
        DO bj = myByLo(myThid), myByHi(myThid)
         DO bi = myBxLo(myThid), myBxHi(myThid)
          shareBufGSVec(bi,bj,j) = vecTile(j+j0,bi,bj)
         ENDDO
        ENDDO
       ENDDO

C--   Master thread cannot start until everyone is ready:
       CALL BAR2( myThid )
       _BEGIN_MASTER( myThid )

C--   From master-thread, do the global-sum on shared-buffer
       CALL GLB_SUM_VEC(
     I                   nLoc, shareBufGSVec,
     O                   shareGSVector,
     I                   myThid )

       _END_MASTER( myThid )
C--   Everyone wait for Master thread to be ready
       CALL BAR2( myThid )

C--   set result for every threads
       DO j=1,nLoc
        vecSum(j+j0) = shareGSVector(j)
       ENDDO

C--   end outside do-loop over nCuts
      ENDDO

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: GLOBAL_SUM_VEC_ALT_RS

C     !INTERFACE:
      SUBROUTINE GLOBAL_SUM_VEC_ALT_RS(
     I                       nDim, nVec, vecTile,
     O                       vecSum,
     I                       myThid )

C     !DESCRIPTION:
C     *==========================================================*
C     | SUBROUTINE GLOBAL\_SUM\_VEC\_ALT\_RS
C     | o Handle sum for _RS vector.
C     *==========================================================*
C     | Apply sum on an array of tiled vector (input: nDim,nSx,nSy)
C     |  and operate over all tiles & all the processes.
C     | Oversize vector is cut and processed in "nCuts" pieces
C     |  that fit in buffer
C     *==========================================================*

C     !USES:
      IMPLICIT NONE

C     == Global data ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "GLOBAL_SUM.h"

C     !INPUT/OUTPUT PARAMETERS:
C     nDim     :: dimension of input vector
C     nVec     :: length of input/output vector to process
C     vecTile  :: Input tiled vector (dims: nDim,nSx,nSy)
C     vecSum   :: Result of sum over all tiles, threads & procs
C     myThid   :: My thread id.
      INTEGER nDim, nVec
      _RS     vecTile(nDim,nSx,nSy)
      _RS     vecSum(nVec)
      INTEGER myThid

C     !LOCAL VARIABLES:
C     bi, bj   :: tile indices
C     n, j, j0 :: Loop counters
C     nCuts    :: range of outside loop
C     nLoc     :: range of inner loop
C     msgBuf   :: Informational/error message buffer
      INTEGER bi, bj
      INTEGER n, nCuts
      INTEGER j, j0, nLoc
      CHARACTER*(MAX_LEN_MBUF) msgBuf
CEOP

      IF ( nVec.GT.nDim ) THEN
       WRITE(msgBuf,'(A,2(A,I7))') 'GLOBAL_SUM_VEC_ALT_RS: ',
     &      'nVec=', nVec, ' > nDim =', nDim
       CALL PRINT_ERROR( msgBuf, myThid )
       STOP 'ABNORMAL END: S/R GLOBAL_SUM_VEC_ALT_RS'
      ENDIF

C--   starts outside loop over number of "cuts", each fitting into buffer size
      nCuts = 1 + INT( (nVec-1)/GSVec_size )
      DO n = 1,nCuts
       j0 = (n-1)*GSVec_size
       nLoc = MIN( n*GSVec_size, nVec ) - j0

C--   write local sum into shared-buffer array (+ convert _RS to r8)
       DO j = 1,nLoc
        DO bj = myByLo(myThid), myByHi(myThid)
         DO bi = myBxLo(myThid), myBxHi(myThid)
          shareBufGSVec(bi,bj,j) = vecTile(j+j0,bi,bj)
         ENDDO
        ENDDO
       ENDDO

C--   Master thread cannot start until everyone is ready:
       CALL BAR2( myThid )
       _BEGIN_MASTER( myThid )

C--   From master-thread, do the global-sum on shared-buffer
       CALL GLB_SUM_VEC(
     I                   nLoc, shareBufGSVec,
     O                   shareGSVector,
     I                   myThid )

       _END_MASTER( myThid )
C--   Everyone wait for Master thread to be ready
       CALL BAR2( myThid )

C--   set result for every threads (+ convert back r8 to _RS)
       DO j=1,nLoc
        vecSum(j+j0) = shareGSVector(j)
       ENDDO

C--   end outside do-loop over nCuts
      ENDDO

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: GLOBAL_SUM_VECTOR_INT

C     !INTERFACE:
      SUBROUTINE GLOBAL_SUM_VECTOR_INT(
     I                       nVec, tiledVec,
     O                       sumVec,
     I                       myThid )

C     !DESCRIPTION:
C     *==========================================================*
C     | SUBROUTINE GLOBAL\_SUM\_VECTOR\_INT
C     | o Handle sum for Integer vector.
C     *==========================================================*
C     | Apply sum on an array of tiled vector (input: nSx,nSy,nVec)
C     |  and operate over all tiles & all the processes.
C     | Oversize vector is cut and processed in "nCuts" pieces
C     |  that fit in buffer
C     *==========================================================*

C     !USES:
      IMPLICIT NONE

C     == Global data ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "EESUPPORT.h"
#include "GLOBAL_SUM.h"

C     !INPUT/OUTPUT PARAMETERS:
C     nVec     :: length of input/output vector
C     tiledVec :: Input tiled vector (dims: nSx,nSy,nVec)
C     sumVec   :: Result of sum over all tiles, threads & procs
C     myThid   :: My thread id.
      INTEGER nVec
      INTEGER tiledVec(nSx,nSy,nVec)
      INTEGER sumVec(nVec)
      INTEGER myThid

C     !LOCAL VARIABLES:
C     bi, bj   :: tile indices
C     n, j, j0 :: Loop counters
C     nCuts    :: range of outside loop
C     nLoc     :: range of inner loop
C     mpiRC    :: MPI return code
      INTEGER bi, bj
      INTEGER n, nCuts
      INTEGER j, j0, nLoc
      INTEGER sumMyPr(GSVec_size)
C- type declaration of: sumMyPr & shareGSVectInt need to have
C                       the same length as MPI_INTEGER
#ifdef ALLOW_USE_MPI
      INTEGER mpiRC
#endif /* ALLOW_USE_MPI */
CEOP

C--   starts outside loop over number of "cuts", each fitting into buffer size
      nCuts = 1 + INT( (nVec-1)/GSVec_size )
      DO n = 1,nCuts
       j0 = (n-1)*GSVec_size
       nLoc = MIN( n*GSVec_size, nVec ) - j0

C--   write local sum into shared-buffer array
       DO j = 1,nLoc
        DO bj = myByLo(myThid), myByHi(myThid)
         DO bi = myBxLo(myThid), myBxHi(myThid)
          shareBufGSVecI(bi,bj,j) = tiledVec(bi,bj,j+j0)
         ENDDO
        ENDDO
       ENDDO

C--   Master thread cannot start until everyone is ready:
       CALL BAR2( myThid )
       _BEGIN_MASTER( myThid )

C--   Sum over all tiles (of the same process) first
        DO j = 1,nLoc
         sumMyPr(n) = 0
        ENDDO
        DO bj = 1,nSy
         DO bi = 1,nSx
          DO j = 1,nLoc
           sumMyPr(j) = sumMyPr(j) + shareBufGSVecI(bi,bj,j)
          ENDDO
         ENDDO
        ENDDO

#ifdef ALLOW_USE_MPI
        IF ( usingMPI ) THEN
C--   sum over all procs and put result into shared buffer:
         CALL MPI_Allreduce( sumMyPr, shareGSVectInt, nLoc,
     &            MPI_INTEGER, MPI_SUM, MPI_COMM_MODEL, mpiRC )
        ELSE
#else /* ALLOW_USE_MPI */
        IF ( .TRUE. ) THEN
#endif /* ALLOW_USE_MPI */
C--   in case MPI is not used, put result directly in shared buffer:
         DO j = 1,nLoc
          shareGSVectInt(j) = sumMyPr(j)
         ENDDO
        ENDIF

       _END_MASTER( myThid )

C--   Everyone wait for Master thread to be ready
       CALL BAR2( myThid )

C--   set result for every threads
       DO j = 1,nLoc
        sumVec(j+j0) = shareGSVectInt(j)
       ENDDO

C--   end outside do-loop over nCuts
      ENDDO

      RETURN
      END

#include "PACKAGES_CONFIG.h"
#include "CPP_OPTIONS.h"
c#ifdef ALLOW_AUTODIFF
c# include "AUTODIFF_OPTIONS.h"
c#endif

CBOP
C     !ROUTINE: UPDATE_SIGMA
C     !INTERFACE:
      SUBROUTINE UPDATE_SIGMA( etaHc, myTime, myIter, myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE UPDATE_SIGMA
C     | o Update the thickness fractions (hFacC,W,S)
C     |   according to the surface r-position = Non-Linear FrSurf
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     == Global variables
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
c #include "DYNVARS.h"
#include "GRID.h"
#include "SURFACE.h"
c#ifdef ALLOW_AUTODIFF_TAMC
c# include "tamc.h"
c#endif

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     etaHc  :: surface r-anomaly at grid cell center
C     myTime :: Current time in simulation
C     myIter :: Current iteration number in simulation
C     myThid :: my Thread Id. number
      _RL etaHc(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL myTime
      INTEGER myIter
      INTEGER myThid

#ifdef NONLIN_FRSURF
c#ifndef DISABLE_SIGMA_CODE
C     !LOCAL VARIABLES:
C     Local variables
C     bi, bj     :: tile indices
C     i, j, k    :: Loop counters
C     rEmpty     :: empty column r-position
C     rFullDepth :: maximum depth of a full column
C     tmpFld     :: Temporary array used to compute & write Total Depth
C     msgBuf     :: Informational/error message buffer
      INTEGER bi, bj
      INTEGER i, j, k
      _RL rFullDepth
      _RL tmpFld(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
c     _RL hFactmp
c     CHARACTER*(MAX_LEN_MBUF) msgBuf
CEOP

      rFullDepth = rF(1)-rF(Nr+1)

      DO bj=myByLo(myThid), myByHi(myThid)
       DO bi=myBxLo(myThid), myBxHi(myThid)

c#ifdef ALLOW_AUTODIFF_TAMC
c        tkey = bi + (bj-1)*nSx + (ikey_dynamics-1)*nSx*nSy
c#endif /* ALLOW_AUTODIFF_TAMC */

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

c#ifdef ALLOW_OBCS
cC-- Apply OBC to rStar_Factor_W,S before updating hFacW,S
c       IF (useOBCS) THEN
c        CALL OBCS_APPLY_R_STAR(
c    I                    bi, bj,
c    U                    rStarFacC, rStarFacW, rStarFacS,
c    I                    myTime, myIter, myThid )
c       ENDIF
c#endif /* ALLOW_OBCS */

C-- Update the fractional thickness hFacC (& "recip_hFac") :
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          IF ( kSurfC(i,j,bi,bj).LE.Nr ) THEN
           tmpFld(i,j) = etaHc(i,j,bi,bj)
     &                 + ( Ro_surf(i,j,bi,bj)-R_low(i,j,bi,bj) )
          ELSE
           tmpFld(i,j) = rFullDepth
          ENDIF
         ENDDO
        ENDDO
        DO k=1,Nr
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
            hFacC(i,j,k,bi,bj) = maskC(i,j,k,bi,bj)
     &                         *( dAHybSigF(k)*rFullDepth
     &                           +dBHybSigF(k)*tmpFld(i,j)
     &                          )*recip_drF(k)
            recip_hFacC(i,j,k,bi,bj) = maskC(i,j,k,bi,bj)*drF(k)
     &                         /( dAHybSigF(k)*rFullDepth
     &                           +dBHybSigF(k)*tmpFld(i,j)
     &                          )
          ENDDO
         ENDDO
        ENDDO

C-- Update the fractional thickness hFacW (& "recip_hFac") :
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          IF ( kSurfW(i,j,bi,bj).LE.Nr ) THEN
           tmpFld(i,j) = etaHw(i,j,bi,bj)
     &                 + ( rSurfW(i,j,bi,bj)-rLowW(i,j,bi,bj) )
          ELSE
           tmpFld(i,j) = rFullDepth
          ENDIF
         ENDDO
        ENDDO
        DO k=1,Nr
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
            hFacW(i,j,k,bi,bj) = maskW(i,j,k,bi,bj)
     &                         *( dAHybSigF(k)*rFullDepth
     &                           +dBHybSigF(k)*tmpFld(i,j)
     &                          )*recip_drF(k)
            recip_hFacW(i,j,k,bi,bj) = maskW(i,j,k,bi,bj)*drF(k)
     &                         /( dAHybSigF(k)*rFullDepth
     &                           +dBHybSigF(k)*tmpFld(i,j)
     &                          )
          ENDDO
         ENDDO
        ENDDO

C-- Update the fractional thickness hFacS (& "recip_hFac") :
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          IF ( kSurfS(i,j,bi,bj).LE.Nr ) THEN
           tmpFld(i,j) = etaHs(i,j,bi,bj)
     &                 + ( rSurfS(i,j,bi,bj)-rLowS(i,j,bi,bj) )
          ELSE
           tmpFld(i,j) = rFullDepth
          ENDIF
         ENDDO
        ENDDO
        DO k=1,Nr
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
            hFacS(i,j,k,bi,bj) = maskS(i,j,k,bi,bj)
     &                         *( dAHybSigF(k)*rFullDepth
     &                           +dBHybSigF(k)*tmpFld(i,j)
     &                          )*recip_drF(k)
            recip_hFacS(i,j,k,bi,bj) = maskS(i,j,k,bi,bj)*drF(k)
     &                         /( dAHybSigF(k)*rFullDepth
     &                           +dBHybSigF(k)*tmpFld(i,j)
     &                          )
          ENDDO
         ENDDO
        ENDDO

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C- end bi,bj loop
       ENDDO
      ENDDO

c     _EXCH_XYZ_RS( hFacC, myThid )
c     _EXCH_XYZ_RS( recip_hFacC, myThid )
c     CALL EXCH_UV_XYZ_RS(hFacW,hFacS,.FALSE.,myThid)
c     CALL EXCH_UV_XYZ_RS(recip_hFacW,recip_hFacS,.FALSE.,myThid)

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
c#endif /* ndef DISABLE_SIGMA_CODE */
#endif /* NONLIN_FRSURF */

      RETURN
      END

#include "AIM_OPTIONS.h"
#ifdef ALLOW_LAND
#include "LAND_OPTIONS.h"
#endif

CBOP
C     !ROUTINE: AIM_LAND2AIM
C     !INTERFACE:
      SUBROUTINE AIM_LAND2AIM(
     I               land_frc, land_veg, grnd_alb, snowFld,
     U               aimTld, aimSWA, aimAlb,
     I               myTime, myIter, bi, bj, myThid ) 

C     !DESCRIPTION: \bv
C     *================================================================*
C     | S/R AIM_LAND2AIM
C     | provide surface Boundary Conditions over land (from land pkg)
C     |  to atmospheric physics package AIM
C     *================================================================*
C     | note: by default, use AIM surf.B.C. fields as initial state
C     |   (myIter=0) for the land model 
C     *================================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     == Global variables ===
C-- size for MITgcm & Physics package :
#include "AIM_SIZE.h"

C-- MITgcm
#include "EEPARAMS.h"
#include "PARAMS.h"

C-- Physics package
#include "AIM_PARAMS.h"
#include "com_forcon.h"

#ifdef ALLOW_LAND
C-- Land package
#include "LAND_SIZE.h"
#include "LAND_PARAMS.h"
#include "LAND_VARS.h"
#endif

C     == Routine arguments ==
C     land_frc :: land fraction [0-1]
C     land_veg :: vegetation fraction [0-1]
C     grnd_alb :: ground albedo [0-1]
C     aimTld   :: land surface temp (K), used in AIM
C     snowFld  :: prescribed snow thickness (from AIM input data) [m]
C     aimSWA   :: soil wetness availability [0-1], used in AIM
C     aimAlb   :: land albedo [0-1], used in AIM
C     myTime   :: Current time of simulation ( s )
C     myIter   :: Current iteration number in simulation
C     bi,bj    :: Tile index 
C     myThid   :: Number of this instance of the routine
      _RS  land_frc(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RS  land_veg(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RS  grnd_alb(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL  snowFld(sNx,sNy)
      _RL  aimTld(sNx,sNy)
      _RL  aimSWA(sNx,sNy)
      _RL  aimAlb(sNx,sNy)
      INTEGER myIter, bi, bj, myThid
      _RL myTime
CEOP

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#ifdef ALLOW_AIM
#ifdef ALLOW_LAND

C     == Local variables ==
C     i,j,k        :: Loop counters
C     grd_HeatCp   :: Heat capacity of the ground [J/m3/K]
C     mWater       :: water content of the ground [kg/m3]
C     recip_hSnWet :: reciprol effective snow depth for wetness (m^-1)
C     recip_mSnWet :: reciprol effective snow cover for wetness (mm^-1)
      INTEGER i,j,k
      INTEGER kFillW
      _RL grd_HeatCp, mWater
      _RL RSD
      _RL recip_hSnWet, recip_mSnWet

c     IF (useLand) THEN

       IF ( land_calc_grT ) THEN
C-    Use land-pkg output instead of prescribed ground Temp
        DO j=1,sNy
         DO i=1,sNx
           aimTld(i,j) = land_skinT(i,j,bi,bj)+celsius2K
         ENDDO
        ENDDO
       ELSE
C-    Fill in land-pkg ground Temp. using AIM surf. fields
        DO k=1,land_nLev
         DO j=1,sNy
          DO i=1,sNx
           land_groundT(i,j,k,bi,bj) = aimTld(i,j)-celsius2K
          ENDDO
         ENDDO
        ENDDO
        DO j=1,sNy
         DO i=1,sNx
           land_skinT(i,j,bi,bj) = land_groundT(i,j,1,bi,bj)
         ENDDO
        ENDDO
       ENDIF

       IF (land_calc_grW) THEN
C-    Use land-pkg output instead of prescribed soil moisture
        IF ( land_calc_snow ) THEN
C        Units: hSnow & hSnowWetness are in meter (of snow)
         recip_hSnWet = 0. _d 0
         IF ( hSnowWetness .NE. 0. _d 0 )
     &   recip_hSnWet = 1. _d 0 / hSnowWetness
         DO j=1,sNy
          DO i=1,sNx
           aimSWA(i,j) = land_groundW(i,j,1,bi,bj)
     &                 + land_hSnow(i,j,bi,bj)*recip_hSnWet
           aimSWA(i,j) = MIN( MAX(0. _d 0, aimSWA(i,j)), 1. _d 0 )
          ENDDO
         ENDDO
        ELSE
C        Units: snowFld is in milimeter of equivalent liquid water
         recip_mSnWet = 0. _d 0
         IF ( hSnowWetness .NE. 0. _d 0 )
     &   recip_mSnWet = land_rhoLiqW 
     &                / (land_rhoSnow*hSnowWetness*1000. _d 0)
         DO j=1,sNy
          DO i=1,sNx
           aimSWA(i,j) = land_groundW(i,j,1,bi,bj)
     &                 + snowFld(i,j)*recip_mSnWet
           aimSWA(i,j) = MIN( MAX(0. _d 0, aimSWA(i,j)), 1. _d 0 )
          ENDDO
         ENDDO
        ENDIF
       ELSE
C-    Fill in land-pkg soil moisture using AIM surf. fields
        kFillW = land_nLev
        IF (land_calc_grT) kFillW = 1
        DO k=1,kFillW
         DO j=1,sNy
          DO i=1,sNx
           land_groundW(i,j,k,bi,bj) = aimSWA(i,j)
          ENDDO
         ENDDO
        ENDDO
c       IF ( land_calc_grT ) THEN
C-      needs to recompute enthalpy since grdW has changed:
C       not a good idea: frozen water in the ground will be lost !
        IF ( .FALSE. ) THEN
         DO j=1,sNy
          DO i=1,sNx
c          IF ( land_frc(i,j,bi,bj).GT.0. ) THEN
            DO k=1,land_nLev
             mWater = land_rhoLiqW*land_waterCap
     &               *land_groundW(i,j,k,bi,bj)
             grd_HeatCp = land_heatCs + land_CpWater*mWater

             land_enthalp(i,j,k,bi,bj) =
     &                     grd_HeatCp*land_groundT(i,j,k,bi,bj)
            ENDDO
c          ENDIF
          ENDDO
         ENDDO
        ENDIF

C- end: if land_calc_grW
       ENDIF

       IF (land_calc_snow) THEN

        IF (land_calc_alb) THEN
C-     Compute albedo of snow ; and replace albedo of land.
         CALL LAND_ALBEDO(
     I                land_frc, grnd_alb,
     O                aimAlb,
     I                bi,bj, myTime, myIter, myThid )

        ELSE
C-    Surface Albedo : (from F.M. FORDATE S/R)
         RSD = 1. _d 0/SDALB
         DO j=1,sNy
          DO i=1,sNx
           aimAlb(i,j) = grnd_alb(i,j,bi,bj)
     &       + MAX( 0. _d 0, ALBSN-grnd_alb(i,j,bi,bj) )
     &        *MIN( 1. _d 0, RSD*snowFld(i,j) )
          ENDDO
         ENDDO
        ENDIF

       ENDIF

c     ENDIF

#endif /* ALLOW_LAND */
#endif /* ALLOW_AIM */

      RETURN
      END

#include "COST_OPTIONS.h"
#ifdef ALLOW_AUTODIFF
# include "AUTODIFF_OPTIONS.h"
#endif

CBOI
C
C !TITLE: COST FUNCTION
C !AUTHORS: mitgcm developers ( support@mitgcm.org )
C !AFFILIATION: Massachussetts Institute of Technology
C !DATE:
C !INTRODUCTION: cost function evaluation
C \bv
c The cost function package is connected to the differntiability
c of the code. Differentiability refers to computing the derivative
c of a cost function with respect to a set of control variables
c (initial state, boundary values, model parameters).
c The cost function may be an element of the final state,
c a diagonstic thereof, a quantity that is integrated over the
c model trajectory, or some model vs. data misfit.
c This routine controls the cost function evaluation
c at each time step.
c Different contributions to the cost function are called from here.
c The present package contains the basic handling of the
c cost function evaluation along with two prototype cost terms.
c The cost package is connected with the mitgcm code as follows:
c
C     !CALLING SEQUENCE:
c    ...
c     |-- initialise_fixed
c         |
c         |-- packages_readparms
c             |
c             |-- cost_readparms
c    ...
c     |-- initialise_varia
c         |
c         |-- packages_init_variables
c             |
c             |-- cost_init
c    ...
c     |-- the_main_loop
c         |
c         |-- do iloop = 1,nTimeSteps
c         |     forward_step
c         |     cost_tile
c         |     |
c         |     |-- cost_tracer
c         |
c         |   enddo
c         |
c         |-- cost_final
C \ev
CEOI

CBOP
C     !ROUTINE: COST_TILE
C     !INTERFACE:
      SUBROUTINE COST_TILE( myTime, myIter, myThid )

C     !DESCRIPTION: \bv
C     *================================================================*
C     | subroutine cost_tile
C     | o this routine computes is called at each time step to
C     |   accumulate the cost function for the tiles of this processor
C     *================================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     == Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "DYNVARS.h"
#include "GRID.h"
#include "cost.h"
#ifdef ALLOW_AUTODIFF
# ifdef ALLOW_AUTODIFF_TAMC
#  include "tamc.h"
# endif
# ifdef ALLOW_PTRACERS
#  include "PTRACERS_SIZE.h"
#  include "PTRACERS_FIELDS.h"
# endif
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     myThid :: my Thread Id number
      _RL myTime
      INTEGER myIter
      INTEGER myThid

#ifdef ALLOW_COST
C     !LOCAL VARIABLES:
#ifdef ALLOW_COST_TRACER
      INTEGER bi, bj
#endif
CEOP

#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE theta         = comlev1, key = ikey_dynamics,
CADJ &     kind = isbyte
CADJ STORE uvel, vvel    = comlev1, key = ikey_dynamics,
CADJ &     kind = isbyte
# ifdef ALLOW_DEPTH_CONTROL
CADJ STORE hfacw, hfacs  = comlev1, key = ikey_dynamics,
CADJ &     kind = isbyte
# endif
# ifdef ALLOW_PTRACERS
#  ifdef NONLIN_FRSURF
CADJ STORE hFacC  = comlev1, key = ikey_dynamics,
CADJ &     kind = isbyte
CADJ STORE ptracer = comlev1, key = ikey_dynamics,
CADJ &     kind = isbyte
#  endif
# endif
#endif

      IF ( myTime .GT. (endTime - lastinterval) ) THEN

#if ( defined ALLOW_COST_TEST || defined ALLOW_COST_ATLANTIC_HEAT || defined ALLOW_COST_TEMP )
        CALL COST_ACCUMULATE_MEAN( myThid )
#endif

#if ( defined ALLOW_SHELFICE && defined ALLOW_COST_SHELFICE )
        IF (useShelfIce) CALL SHELFICE_COST_ACCUMULATE( myThid )
#endif

#if ( defined ALLOW_STREAMICE && defined ALLOW_COST_STREAMICE )
        IF (useStreamIce) CALL STREAMICE_COST_ACCUM( myIter, myThid )
#endif

#if ( defined ALLOW_THSICE && defined ALLOW_THSICE_COST_TEST )
        IF (useThSIce) CALL THSICE_COST_DRIVER( myTime, myIter, myThid )
#endif

      ENDIF

#ifdef ALLOW_COST_TRACER
      DO bj=myByLo(myThid),myByHi(myThid)
        DO bi=myBxLo(myThid),myBxHi(myThid)
           CALL COST_TRACER( bi, bj, myThid )
        ENDDO
      ENDDO
#endif

#endif /* ALLOW_COST */

      RETURN
      END

#include "SEAICE_OPTIONS.h"

C--  File seaice_jfnk.F: seaice jfnk dynamical solver S/R:
C--   Contents
C--   o SEAICE_JFNK
C--   o SEAICE_JFNK_UPDATE

CBOP
C     !ROUTINE: SEAICE_JFNK
C     !INTERFACE:
      SUBROUTINE SEAICE_JFNK( myTime, myIter, myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE SEAICE_JFNK
C     | o Ice dynamics using a Jacobian-free Newton-Krylov solver
C     |   following J.-F. Lemieux et al. Improving the numerical
C     |   convergence of viscous-plastic sea ice models with the
C     |   Jacobian-free Newton-Krylov method. J. Comp. Phys. 229,
C     |   2840-2852 (2010).
C     | o The logic follows JFs code.
C     *==========================================================*
C     | written by Martin Losch, Oct 2012
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "DYNVARS.h"
#include "GRID.h"
#include "SEAICE_SIZE.h"
#include "SEAICE_PARAMS.h"
#include "SEAICE.h"

C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
C     myTime :: Simulation time
C     myIter :: Simulation timestep number
C     myThid :: my Thread Id. number
      _RL     myTime
      INTEGER myIter
      INTEGER myThid

#if ( defined SEAICE_CGRID && defined SEAICE_ALLOW_JFNK )
C     !FUNCTIONS:
      LOGICAL  DIFFERENT_MULTIPLE
      EXTERNAL DIFFERENT_MULTIPLE

C     !LOCAL VARIABLES:
C     === Local variables ===
C     i,j,bi,bj :: loop indices
      INTEGER i,j,bi,bj
C     loop indices
      INTEGER newtonIter
      INTEGER krylovIter, krylovFails
      INTEGER totalKrylovItersLoc, totalNewtonItersLoc
C     FGMRES parameters
C     im      :: size of Krylov space
C     ifgmres :: interation counter
      INTEGER im
      PARAMETER ( im = 50 )
      INTEGER ifgmres
C     FGMRES flag that determines amount of output messages of fgmres
      INTEGER iOutFGMRES
C     FGMRES flag that indicates what fgmres wants us to do next
      INTEGER iCode
      _RL     JFNKresidual
      _RL     JFNKresidualKm1
C     parameters to compute convergence criterion
      _RL     JFNKgamma_lin
      _RL     FGMRESeps
      _RL     JFNKtol
C     backward differences extrapolation factors
      _RL bdfFac, bdfAlpha
C
      _RL     recip_deltaT
      LOGICAL JFNKconverged, krylovConverged
      LOGICAL writeNow
      CHARACTER*(MAX_LEN_MBUF) msgBuf

C     u/vIceRes :: residual of sea-ice momentum equations
      _RL uIceRes(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL vIceRes(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
C     extra time level required for backward difference time stepping
      _RL duIcNm1(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL dvIcNm1(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
C     du/vIce   :: ice velocity increment to be added to u/vIce
      _RL duIce  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL dvIce  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
C     precomputed (= constant per Newton iteration) versions of
C     zeta, eta, and DWATN, press
      _RL zetaPre (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL zetaZPre(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL etaPre  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL etaZPre (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL dwatPre (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
C     work arrays
      _RL rhs(nVec,nSx,nSy), sol(nVec,nSx,nSy)
      _RL vv(nVec,im+1,nSx,nSy), w(nVec,im,nSx,nSy)
      _RL wk1(nVec,nSx,nSy), wk2(nVec,nSx,nSy)
CEOP

C     Initialise
      newtonIter          = 0
      krylovFails         = 0
      totalKrylovItersLoc = 0
      JFNKconverged       = .FALSE.
      JFNKtol             = 0. _d 0
      JFNKresidual        = 0. _d 0
      JFNKresidualKm1     = 0. _d 0
      FGMRESeps           = 0. _d 0
      recip_deltaT        = 1. _d 0 / SEAICE_deltaTdyn

      iOutFGMRES=0
C     with iOutFgmres=1, seaice_fgmres prints the residual at each iteration
      IF ( debugLevel.GE.debLevC .AND.
     &     DIFFERENT_MULTIPLE( SEAICE_monFreq, myTime, deltaTClock ) )
     &     iOutFGMRES=1

C     backward difference extrapolation factors
      bdfFac = 0. _d 0
      IF ( SEAICEuseBDF2 ) THEN
       IF ( myIter.EQ.nIter0 .AND. SEAICEmomStartBDF.EQ.0 ) THEN
        bdfFac = 0. _d 0
       ELSE
        bdfFac = 0.5 _d 0
       ENDIF
      ENDIF
      bdfAlpha = 1. _d 0 + bdfFac

      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        DO J=1-OLy,sNy+OLy
         DO I=1-OLx,sNx+OLx
          uIceRes(I,J,bi,bj) = 0. _d 0
          vIceRes(I,J,bi,bj) = 0. _d 0
          duIce  (I,J,bi,bj) = 0. _d 0
          dvIce  (I,J,bi,bj) = 0. _d 0
         ENDDO
        ENDDO
C     cycle ice velocities
        DO J=1-OLy,sNy+OLy
         DO I=1-OLx,sNx+OLx
          duIcNm1(I,J,bi,bj) = uIce(I,J,bi,bj) * bdfAlpha
     &         + ( uIce(I,J,bi,bj) - uIceNm1(I,J,bi,bj) ) * bdfFac
          dvIcNm1(I,J,bi,bj) = vIce(I,J,bi,bj) * bdfAlpha
     &         + ( vIce(I,J,bi,bj) - vIceNm1(I,J,bi,bj) ) * bdfFac
          uIceNm1(I,J,bi,bj) = uIce(I,J,bi,bj)
          vIceNm1(I,J,bi,bj) = vIce(I,J,bi,bj)
         ENDDO
        ENDDO
C     As long as IMEX is not properly implemented leave this commented out
CML        IF ( .NOT.SEAICEuseIMEX ) THEN
C     Compute things that do no change during the Newton iteration:
C     sea-surface tilt and wind stress:
C     FORCEX/Y0 - mass*(1.5*u/vIceNm1+0.5*(u/vIceNm1-u/vIceNm2))/deltaT
        DO J=1-OLy,sNy+OLy
         DO I=1-OLx,sNx+OLx
          FORCEX(I,J,bi,bj) = FORCEX0(I,J,bi,bj)
     &         + seaiceMassU(I,J,bi,bj)*duIcNm1(I,J,bi,bj)*recip_deltaT
          FORCEY(I,J,bi,bj) = FORCEY0(I,J,bi,bj)
     &         + seaiceMassV(I,J,bi,bj)*dvIcNm1(I,J,bi,bj)*recip_deltaT
         ENDDO
        ENDDO
CML        ENDIF
       ENDDO
      ENDDO
C     Start nonlinear Newton iteration: outer loop iteration
      DO WHILE ( newtonIter.LT.SEAICEnonLinIterMax .AND.
     &     .NOT.JFNKconverged )
       newtonIter = newtonIter + 1
C     Compute initial residual F(u), (includes computation of global
C     variables DWATN, zeta, and eta)
       IF ( newtonIter .EQ. 1 ) CALL SEAICE_JFNK_UPDATE(
     I      duIce, dvIce,
     U      uIce, vIce, JFNKresidual,
     O      uIceRes, vIceRes,
     I      newtonIter, myTime, myIter, myThid )
C     local copies of precomputed coefficients that are to stay
C     constant for the preconditioner
       DO bj=myByLo(myThid),myByHi(myThid)
        DO bi=myBxLo(myThid),myBxHi(myThid)
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           zetaPre(I,J,bi,bj) =  zeta(I,J,bi,bj)
           zetaZPre(I,J,bi,bj)= zetaZ(I,J,bi,bj)
            etaPre(I,J,bi,bj) =   eta(I,J,bi,bj)
           etaZPre(I,J,bi,bj) =  etaZ(I,J,bi,bj)
           dwatPre(I,J,bi,bj) = DWATN(I,J,bi,bj)
          ENDDO
         ENDDO
        ENDDO
       ENDDO
C     compute convergence criterion for linear preconditioned FGMRES
       JFNKgamma_lin = JFNKgamma_lin_max
       IF ( newtonIter.GT.1.AND.newtonIter.LE.SEAICE_JFNK_tolIter
     &      .AND.JFNKresidual.LT.JFNKres_t ) THEN
C     Eisenstat and Walker (1996), eq.(2.6)
        JFNKgamma_lin = SEAICE_JFNKphi
     &       *( JFNKresidual/JFNKresidualKm1 )**SEAICE_JFNKalpha
        JFNKgamma_lin = min(JFNKgamma_lin_max, JFNKgamma_lin)
        JFNKgamma_lin = max(JFNKgamma_lin_min, JFNKgamma_lin)
       ENDIF
C     save the residual for the next iteration
       JFNKresidualKm1 = JFNKresidual

C     The Krylov iteration using FGMRES, the preconditioner is LSOR
C     for now. The code is adapted from SEAICE_LSR, but heavily stripped
C     down.
C     krylovIter is mapped into "its" in seaice_fgmres and is incremented
C     in that routine
       krylovIter    = 0
       iCode         = 0

       JFNKconverged = JFNKresidual.LT.JFNKtol
     &      .OR.JFNKresidual.EQ.0. _d 0

C     do Krylov loop only if convergence is not reached

       IF ( .NOT.JFNKconverged ) THEN

C     start Krylov iteration (FGMRES)

        krylovConverged = .FALSE.
        FGMRESeps = JFNKgamma_lin * JFNKresidual
C     map first guess sol; it is zero because the solution is a correction
       CALL SEAICE_MAP2VEC(nVec,duIce,dvIce,sol,.TRUE.,myThid)
C     map rhs and change its sign because we are solving J*u = -F
        CALL SEAICE_MAP2VEC(nVec,uIceRes,vIceRes,rhs,.TRUE.,myThid)
        DO bj=myByLo(myThid),myByHi(myThid)
         DO bi=myBxLo(myThid),myBxHi(myThid)
          DO j=1,nVec
           rhs(j,bi,bj) = - rhs(j,bi,bj)
          ENDDO
         ENDDO
        ENDDO
        DO WHILE ( .NOT.krylovConverged )
C     solution vector sol = du/vIce
C     residual vector (rhs) Fu = u/vIceRes
C     output work vectors wk1, -> input work vector wk2

C     map preconditioner results or Jacobian times vector,
C     stored in du/vIce to wk2, for iCode=0, wk2 is set to zero,
C     because du/vIce = 0
         CALL SEAICE_MAP2VEC(nVec,duIce,dvIce,wk2,.TRUE.,myThid)

         CALL SEAICE_FGMRES (nVec,im,rhs,sol,ifgmres,krylovIter,
     U        vv,w,wk1,wk2,
     I        FGMRESeps,SEAICElinearIterMax,iOutFGMRES,
     U        iCode,
     I        myThid)

         IF ( iCode .EQ. 0 ) THEN
C     map sol(ution) vector to du/vIce
          CALL SEAICE_MAP2VEC(nVec,duIce,dvIce,sol,.FALSE.,myThid)
         ELSE
C     map work vector to du/vIce to either compute a preconditioner
C     solution (wk1=rhs) or a Jacobian times wk1
          CALL SEAICE_MAP2VEC(nVec,duIce,dvIce,wk1,.FALSE.,myThid)
         ENDIF
C     Fill overlaps in updated fields
         CALL EXCH_UV_XY_RL( duIce, dvIce,.TRUE.,myThid)
C     FGMRES returns iCode either asking for an new preconditioned vector
C     or product of matrix (Jacobian) times vector. For iCode = 0, terminate
C     iteration
         IF (iCode.EQ.1) THEN
C     Call preconditioner
          IF ( SEAICEpreconLinIter .GT. 0 )
     &         CALL SEAICE_PRECONDITIONER(
     U         duIce, dvIce,
     I         zetaPre, etaPre, etaZpre, zetaZpre, dwatPre,
     I         newtonIter, krylovIter, myTime, myIter, myThid )
         ELSEIF (iCode.GE.2) THEN
C     Compute Jacobian times vector
          CALL SEAICE_JACVEC(
     I         uIce, vIce, uIceRes, vIceRes,
     U         duIce, dvIce,
     I         newtonIter, krylovIter, myTime, myIter, myThid )
         ENDIF
         krylovConverged = iCode.EQ.0
C     End of Krylov iterate
        ENDDO
        totalKrylovItersLoc = totalKrylovItersLoc + krylovIter
C     some output diagnostics
        IF ( debugLevel.GE.debLevA ) THEN
         _BEGIN_MASTER( myThid )
         totalNewtonItersLoc =
     &        SEAICEnonLinIterMax*(myIter-nIter0)+newtonIter
         WRITE(msgBuf,'(2A,2(1X,I6),2E12.5)')
     &        ' S/R SEAICE_JFNK: Newton iterate / total, ',
     &        'JFNKgamma_lin, initial norm = ',
     &        newtonIter, totalNewtonItersLoc,
     &        JFNKgamma_lin,JFNKresidual
         CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &        SQUEEZE_RIGHT, myThid )
         WRITE(msgBuf,'(3(A,I6))')
     &        ' S/R SEAICE_JFNK: Newton iterate / total = ',newtonIter,
     &        ' / ', totalNewtonItersLoc,
     &        ', Nb. of FGMRES iterations = ', krylovIter
         CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &        SQUEEZE_RIGHT, myThid )
         _END_MASTER( myThid )
        ENDIF
        IF ( krylovIter.EQ.SEAICElinearIterMax ) THEN
         krylovFails = krylovFails + 1
        ENDIF
C     Set the stopping criterion for the Newton iteration and the
C     criterion for the transition from accurate to approximate FGMRES
        IF ( newtonIter .EQ. 1 ) THEN
         JFNKtol=SEAICEnonLinTol*JFNKresidual
         IF ( JFNKres_tFac .NE. UNSET_RL )
     &        JFNKres_t = JFNKresidual * JFNKres_tFac
        ENDIF
C     Update linear solution vector and return to Newton iteration
C     Do a linesearch if necessary, and compute a new residual.
C     Note that it should be possible to do the following operations
C     at the beginning of the Newton iteration, thereby saving us from
C     the extra call of seaice_jfnk_update, but unfortunately that
C     changes the results, so we leave the stuff here for now.
        CALL SEAICE_JFNK_UPDATE(
     I       duIce, dvIce,
     U       uIce, vIce, JFNKresidual,
     O       uIceRes, vIceRes,
     I       newtonIter, myTime, myIter, myThid )
C     reset du/vIce here instead of setting sol = 0 in seaice_fgmres_driver
        DO bj=myByLo(myThid),myByHi(myThid)
         DO bi=myBxLo(myThid),myBxHi(myThid)
          DO J=1-OLy,sNy+OLy
           DO I=1-OLx,sNx+OLx
            duIce(I,J,bi,bj)= 0. _d 0
            dvIce(I,J,bi,bj)= 0. _d 0
           ENDDO
          ENDDO
         ENDDO
        ENDDO
       ENDIF
C     end of Newton iterate
      ENDDO

C--   Output diagnostics

      IF ( SEAICE_monFreq .GT. 0. _d 0 ) THEN
C     Only Master Thread updates counters in common block:
      _BEGIN_MASTER(myThid)
C     Cumulate some diagnostic counters for the JFNK solver
       totalJFNKtimeSteps = totalJFNKtimeSteps + 1
       totalNewtonIters   = totalNewtonIters + newtonIter
       totalKrylovIters   = totalKrylovIters + totalKrylovItersLoc
C     Record failure
       totalKrylovFails   = totalKrylovFails + krylovFails
       IF ( newtonIter .EQ. SEAICEnonLinIterMax ) THEN
        totalNewtonFails = totalNewtonFails + 1
       ENDIF
       _END_MASTER( myThid )
      ENDIF
C     Decide whether it is time to dump and reset the counter
      writeNow = DIFFERENT_MULTIPLE(SEAICE_monFreq,
     &     myTime+deltaTClock, deltaTClock)
#ifdef ALLOW_CAL
      IF ( useCAL ) THEN
       CALL CAL_TIME2DUMP(
     I      zeroRL, SEAICE_monFreq,  deltaTClock,
     U      writeNow,
     I      myTime+deltaTClock, myIter+1, myThid )
      ENDIF
#endif
      IF ( writeNow ) THEN
       _BEGIN_MASTER( myThid )
       WRITE(msgBuf,'(A)')
     &' // ======================================================='
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &      SQUEEZE_RIGHT, myThid )
       WRITE(msgBuf,'(A)') ' // Begin JFNK statistics'
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &      SQUEEZE_RIGHT, myThid )
       WRITE(msgBuf,'(A)')
     &' // ======================================================='
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &      SQUEEZE_RIGHT, myThid )
       WRITE(msgBuf,'(A,I10)')
     &      ' %JFNK_MON: time step              = ', myIter+1
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &      SQUEEZE_RIGHT, myThid )
       WRITE(msgBuf,'(A,I10)')
     &      ' %JFNK_MON: Nb. of time steps      = ', totalJFNKtimeSteps
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &      SQUEEZE_RIGHT, myThid )
       WRITE(msgBuf,'(A,I10)')
     &      ' %JFNK_MON: Nb. of Newton steps    = ', totalNewtonIters
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &      SQUEEZE_RIGHT, myThid )
       WRITE(msgBuf,'(A,I10)')
     &      ' %JFNK_MON: Nb. of Krylov steps    = ', totalKrylovIters
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &      SQUEEZE_RIGHT, myThid )
       WRITE(msgBuf,'(A,I10)')
     &      ' %JFNK_MON: Nb. of Newton failures = ', totalNewtonFails
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &      SQUEEZE_RIGHT, myThid )
       WRITE(msgBuf,'(A,I10)')
     &      ' %JFNK_MON: Nb. of Krylov failures = ', totalKrylovFails
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &      SQUEEZE_RIGHT, myThid )
       WRITE(msgBuf,'(A)')
     &' // ======================================================='
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &      SQUEEZE_RIGHT, myThid )
       WRITE(msgBuf,'(A)') ' // End JFNK statistics'
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &      SQUEEZE_RIGHT, myThid )
       WRITE(msgBuf,'(A)')
     &' // ======================================================='
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &      SQUEEZE_RIGHT, myThid )
C     Reset and start again
       totalJFNKtimeSteps = 0
       totalNewtonIters   = 0
       totalKrylovIters   = 0
       totalKrylovFails   = 0
       totalNewtonFails   = 0
       _END_MASTER( myThid )
      ENDIF

C     Print more debugging information
      IF ( debugLevel.GE.debLevA ) THEN
       IF ( newtonIter .EQ. SEAICEnonLinIterMax ) THEN
        _BEGIN_MASTER( myThid )
        WRITE(msgBuf,'(A,I10)')
     &       ' S/R SEAICE_JFNK: JFNK did not converge in timestep ',
     &       myIter+1
        CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &       SQUEEZE_RIGHT, myThid )
        _END_MASTER( myThid )
       ENDIF
       IF ( krylovFails .GT. 0 ) THEN
        _BEGIN_MASTER( myThid )
        WRITE(msgBuf,'(A,I4,A,I10)')
     &       ' S/R SEAICE_JFNK: FGMRES did not converge ',
     &       krylovFails, ' times in timestep ', myIter+1
        CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &       SQUEEZE_RIGHT, myThid )
        _END_MASTER( myThid )
       ENDIF
       _BEGIN_MASTER( myThid )
       WRITE(msgBuf,'(A,I6,A,I10)')
     &      ' S/R SEAICE_JFNK: Total number FGMRES iterations = ',
     &      totalKrylovItersLoc, ' in timestep ', myIter+1
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &      SQUEEZE_RIGHT, myThid )
       _END_MASTER( myThid )
      ENDIF

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: SEAICE_JFNK_UPDATE
C     !INTERFACE:

      SUBROUTINE SEAICE_JFNK_UPDATE(
     I     duIce, dvIce,
     U     uIce, vIce, JFNKresidual,
     O     uIceRes, vIceRes,
     I     newtonIter, myTime, myIter, myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE SEAICE_JFNK_UPDATE
C     | o Update velocities with incremental solutions of FGMRES
C     | o compute residual of updated solutions and do
C     | o linesearch:
C     |   reduce update until residual is smaller than previous
C     |   one (input)
C     *==========================================================*
C     | written by Martin Losch, Jan 2013
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "SEAICE_SIZE.h"
#include "SEAICE_PARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
C     myTime :: Simulation time
C     myIter :: Simulation timestep number
C     myThid :: my Thread Id. number
C     newtonIter :: current iterate of Newton iteration
      _RL     myTime
      INTEGER myIter
      INTEGER myThid
      INTEGER newtonIter
C     JFNKresidual :: Residual at the beginning of the FGMRES iteration,
C                     changes with newtonIter (updated)
      _RL     JFNKresidual
C     du/vIce   :: ice velocity increment to be added to u/vIce (input)
      _RL duIce  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL dvIce  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
C     u/vIce    :: ice velocity increment to be added to u/vIce (updated)
      _RL uIce   (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL vIce   (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
C     u/vIceRes :: residual of sea-ice momentum equations (output)
      _RL uIceRes(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL vIceRes(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)

C     !LOCAL VARIABLES:
C     === Local variables ===
C     i,j,bi,bj :: loop indices
      INTEGER i,j,bi,bj
      INTEGER l
      _RL     resLoc, facLS
      LOGICAL doLineSearch
C     nVec    :: size of the input vector(s)
C     resTmp  :: vector version of the residuals
      INTEGER nVec
      PARAMETER ( nVec  = 2*sNx*sNy )
      _RL resTmp (nVec,1,nSx,nSy)

      CHARACTER*(MAX_LEN_MBUF) msgBuf
CEOP

C     Initialise some local variables
      l = 0
      resLoc = JFNKresidual
      facLS = 1. _d 0
      doLineSearch = .TRUE.
      DO WHILE ( doLineSearch )
C     The computation of the line search factor is complicated because
C     we overwrite the solution, so that we have to reconstruct what
C     should be just u_l = u_0 + (1-gamma)**l *du. Instead, after adding
C     du/vIce in the first iteration (l=0), we substract a decreasing
C     part of du/vIce from u/vIce in the next iterations until the
C     residual is smaller than the initial residual.
       IF ( l .GT. 0 ) facLS = - SEAICE_JFNK_lsGamma
     &       *(1. _d 0 - SEAICE_JFNK_lsGamma)**(l-1)
C     Create update
       DO bj=myByLo(myThid),myByHi(myThid)
        DO bi=myBxLo(myThid),myBxHi(myThid)
         DO J=1-OLy,sNy+OLy
          DO I=1-OLx,sNx+OLx
           uIce(I,J,bi,bj) = uIce(I,J,bi,bj)+facLS*duIce(I,J,bi,bj)
           vIce(I,J,bi,bj) = vIce(I,J,bi,bj)+facLS*dvIce(I,J,bi,bj)
          ENDDO
         ENDDO
        ENDDO
       ENDDO
C     Compute current residual F(u), (includes re-computation of global
C     variables DWATN, zeta, and eta, i.e. they are different after this)
       CALL SEAICE_CALC_RESIDUAL(
     I      uIce, vIce,
     O      uIceRes, vIceRes,
     I      newtonIter, 0, myTime, myIter, myThid )
C     Important: Compute the norm of the residual using the same scalar
C     product that SEAICE_FGMRES does
       CALL SEAICE_MAP2VEC(nVec,uIceRes,vIceRes,resTmp,.TRUE.,myThid)
       CALL SEAICE_SCALPROD(nVec,1,1,1,resTmp,resTmp,resLoc,myThid)
       resLoc = SQRT(resLoc)
C     Determine, if we need more iterations
       doLineSearch = resLoc .GE. JFNKresidual
C     Limit the maximum number of iterations arbitrarily to
C     SEAICE_JFNK_lsLmax (default is 4)
       doLineSearch = doLineSearch .AND. l .LE. SEAICE_JFNK_lsLmax
C     For the first iteration du/vIce = 0 and there will be no
C     improvement of the residual possible, so we do only the first
C     iteration
       IF ( newtonIter .EQ. 1 ) doLineSearch = .FALSE.
C     Only start a linesearch after some Newton iterations
       IF ( newtonIter .LE. SEAICE_JFNK_lsIter ) doLineSearch = .FALSE.
C     some output diagnostics
       IF ( debugLevel.GE.debLevA .AND. doLineSearch ) THEN
        _BEGIN_MASTER( myThid )
        WRITE(msgBuf,'(2A,2(1X,I6),1X,3E12.5)')
     &       ' S/R SEAICE_JFNK_UPDATE: Newton iter, LSiter, ',
     &       'facLS, JFNKresidual, resLoc = ',
     &        newtonIter, l, facLS, JFNKresidual, resLoc
        CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &       SQUEEZE_RIGHT, myThid )
        _END_MASTER( myThid )
       ENDIF
C     Increment counter
       l = l + 1
      ENDDO
C     This is the new residual
      JFNKresidual = resLoc

#endif /* SEAICE_CGRID and SEAICE_ALLOW_JFNK */

      RETURN
      END

#include "SEAICE_OPTIONS.h"
#ifdef ALLOW_AUTODIFF
# include "AUTODIFF_OPTIONS.h"
#endif

CBOP
C !ROUTINE: SEAICE_CALC_ICE_STRENGTH
C !INTERFACE: ==========================================================
      SUBROUTINE SEAICE_CALC_ICE_STRENGTH(
     I     bi, bj, myTime, myIter, myThid )

C !DESCRIPTION: \bv
C     *===========================================================*
C     | SUBROUTINE SEAICE_CALC_ICE_STRENGTH
C     | o compute ice strengh PRESS0
C     |   according to
C     |   (a) Hibler (1979)
C     |   (b) Thorndyke et al (1975) and Hibler (1980)
C     |   (c) Bitz et al (2001) and Lipscomb et al (2007)
C     |
C     | Martin Losch, Apr. 2014, Martin.Losch@awi.de
C     *===========================================================*
C \ev

C !USES: ===============================================================
      IMPLICIT NONE

#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "SEAICE_SIZE.h"
#include "SEAICE_PARAMS.h"
#include "SEAICE_GRID.h"
#include "SEAICE.h"

C !INPUT PARAMETERS: ===================================================
C     === Routine arguments ===
C     bi, bj    :: outer loop counters
C     myTime    :: current time
C     myIter    :: iteration number
C     myThid    :: Thread no. that called this routine.
      INTEGER bi,bj
      _RL myTime
      INTEGER myIter
      INTEGER myThid
CEOP

#if ( defined SEAICE_CGRID || defined SEAICE_BGRID_DYNAMICS )
C !LOCAL VARIABLES: ====================================================
C     === Local variables ===
C     i,j,k       :: inner loop counters
C     i/jMin/Max  :: loop boundaries
C
      INTEGER i, j
      INTEGER iMin, iMax, jMin, jMax
      _RL tmpscal1, tmpscal2
#ifdef SEAICE_ITD
C     variables related to ridging schemes
C     ridgingModeNorm :: norm to ensure convervation (N in Lipscomb et al 2007)
C     partFunc   :: participation function (a_n in Lipscomb et al 2007)
C     ridgeRatio :: mean ridge thickness/ thickness of ridging ice
C     hrMin      :: min ridge thickness
C     hrMax      :: max ridge thickness   (SEAICEredistFunc = 0)
C     hrExp      :: ridge e-folding scale (SEAICEredistFunc = 1)
C     hActual    :: HEFFITD/AREAITD
      INTEGER k
      _RL ridgingModeNorm (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL partFunc        (1-OLx:sNx+OLx,1-OLy:sNy+OLy,0:nITD)
      _RL hrMin           (1-OLx:sNx+OLx,1-OLy:sNy+OLy,1:nITD)
      _RL hrMax           (1-OLx:sNx+OLx,1-OLy:sNy+OLy,1:nITD)
      _RL hrExp           (1-OLx:sNx+OLx,1-OLy:sNy+OLy,1:nITD)
      _RL ridgeRatio      (1-OLx:sNx+OLx,1-OLy:sNy+OLy,1:nITD)
      _RL hActual         (1-OLx:sNx+OLx,1-OLy:sNy+OLy,1:nITD)
#endif /* SEAICE_ITD */
#ifdef SEAICE_CGRID
C     compute tensile strength
c     _RL recip_tensilDepth
#endif /* SEAICE_CGRID */
CEOP

C     loop boundaries
      iMin=1-OLx
      iMax=sNx+OLx
      jMin=1-OLy
      jMax=sNy+OLy

#ifdef SEAICE_ITD
C     compute the fraction of open water as early as possible, i.e.
C     before advection, but also before it is used in calculating the ice
C     strength according to Rothrock (1975), hidden in S/R seaice_repare_ridging
      DO j=jMin,jMax
       DO i=iMin,iMax
        opnWtrFrac(i,j,bi,bj) = 1. _d 0 - AREA(i,j,bi,bj)
       ENDDO
      ENDDO

      IF ( useHibler79IceStrength ) THEN
#else
      IF ( .TRUE. ) THEN
#endif /* SEAICE_ITD */
       DO j=jMin,jMax
        DO i=iMin,iMax
C--   now set up ice pressure and viscosities
         IF ( (HEFF(i,j,bi,bj).LE.SEAICEpresH0).AND.
     &        (SEAICEpresPow0.NE.1) ) THEN
          tmpscal1=MAX(HEFF(i,j,bi,bj)/SEAICEpresH0,ZERO)
          tmpscal2=SEAICEpresH0*(tmpscal1**SEAICEpresPow0)
         ELSEIF ( (HEFF(i,j,bi,bj).GT.SEAICEpresH0).AND.
     &         (SEAICEpresPow1.NE.1) ) THEN
          tmpscal1=MAX(HEFF(i,j,bi,bj)/SEAICEpresH0,ZERO)
          tmpscal2=SEAICEpresH0*(tmpscal1**SEAICEpresPow1)
         ELSE
          tmpscal2=HEFF(i,j,bi,bj)
         ENDIF
         PRESS0     (i,j,bi,bj) = SEAICE_strength*tmpscal2
     &        *EXP(-SEAICE_cStar*(SEAICE_area_max-AREA(i,j,bi,bj)))
         SEAICE_zMax(i,j,bi,bj) = SEAICE_zetaMaxFac*PRESS0(i,j,bi,bj)
         SEAICE_zMin(i,j,bi,bj) = SEAICE_zetaMin
         PRESS0     (i,j,bi,bj) = PRESS0(i,j,bi,bj)*HEFFM(i,j,bi,bj)
        ENDDO
       ENDDO
#ifdef SEAICE_ITD
      ELSE
C     not useHiber79IceStrength
       DO j=jMin,jMax
        DO i=iMin,iMax
         PRESS0(i,j,bi,bj) = 0. _d 0
        ENDDO
       ENDDO
       CALL SEAICE_PREPARE_RIDGING(
     O      hActual,
     O      hrMin, hrMax, hrExp, ridgeRatio, ridgingModeNorm, partFunc,
     I      iMin, iMax, jMin, jMax, bi, bj, myTime, myIter, myThid )
       IF ( SEAICEredistFunc .EQ. 0 ) THEN
        tmpscal1 = 1. _d 0 / 3. _d 0
        DO k = 1, nITD
         DO j=jMin,jMax
          DO i=iMin,iMax
C     replace (hrMax**3-hrMin**3)/(hrMax-hrMin) by identical
C     hrMax**2+hrMin**2 + hrMax*hrMin to avoid division by potentially
C     small number
           IF ( partFunc(i,j,k) .GT. 0. _d 0 )
     &          PRESS0(i,j,bi,bj) = PRESS0(i,j,bi,bj)
     &          + partFunc(i,j,k) * ( - hActual(i,j,k)**2
     &          + ( hrMax(i,j,k)**2 + hrMin(i,j,k)**2
     &          + hrMax(i,j,k)*hrMin(i,j,k) )*tmpscal1
     &          / ridgeRatio(i,j,k) )
          ENDDO
         ENDDO
        ENDDO
       ELSEIF ( SEAICEredistFunc .EQ. 1 ) THEN
        DO k = 1, nITD
         DO j=jMin,jMax
          DO i=iMin,iMax
           PRESS0(i,j,bi,bj) = PRESS0(i,j,bi,bj)
     &          + partFunc(i,j,k) * ( - hActual(i,j,k)**2 +
     &          (           hrMin(i,j,k)*hrMin(i,j,k)
     &          + 2. _d 0 * hrMin(i,j,k)*hrExp(i,j,k)
     &          + 2. _d 0 * hrExp(i,j,k)*hrExp(i,j,k)
     &          )/ridgeRatio(i,j,k) )
          ENDDO
         ENDDO
        ENDDO
       ENDIF
C
       tmpscal1 = SEAICE_cf*0.5*gravity*(rhoConst-SEAICE_rhoIce)
     &      * SEAICE_rhoIce/rhoConst
       DO j=jMin,jMax
        DO i=iMin,iMax
         PRESS0(i,j,bi,bj)      = PRESS0(i,j,bi,bj)/ridgingModeNorm(i,j)
     &        *tmpscal1
         SEAICE_zMax(i,j,bi,bj) = SEAICE_zetaMaxFac*PRESS0(i,j,bi,bj)
         SEAICE_zMin(i,j,bi,bj) = SEAICE_zetaMin
         PRESS0     (i,j,bi,bj) = PRESS0(i,j,bi,bj)*HEFFM(i,j,bi,bj)
        ENDDO
       ENDDO
#endif /* SEAICE_ITD */
      ENDIF

CML#ifdef SEAICE_CGRID
CMLC     compute tensile strength factor k: tensileStrength = k*PRESS
CMLC     can be done in initialisation phase as long as it depends only
CMLC     on depth
CML      IF ( SEAICE_tensilFac .NE. 0. _d 0 ) THEN
CML       recip_tensilDepth = 0. _d 0
CML       IF ( SEAICE_tensilDepth .GT. 0. _d 0 )
CML     &      recip_tensilDepth = 1. _d 0 / SEAICE_tensilDepth
CML       DO j=jMin,jMax
CML        DO i=iMin,iMax
CML         tensileStrFac(i,j,bi,bj) = SEAICE_tensilFac
CML     &        *exp(-ABS(R_low(I,J,bi,bj))*recip_tensilDepth)
CML        ENDDO
CML       ENDDO
CML      ENDIF
CML#endif /* SEAICE_CGRID */
#endif /* SEAICE_CGRID or SEAICE_BGRID_DYNAMICS */

      RETURN
      END

#include "MNC_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 0
C     !ROUTINE: MNC_CW_SET_GATTR

C     !INTERFACE:
      SUBROUTINE MNC_CW_SET_GATTR(
     I     fname,
     I     bi, bj, tnum,
     I     myThid )

C     !DESCRIPTION:
C     This subroutine uses the MNC convenience wrapper layer to write
C     per-tile grid (grid.xxxxx.nc) files containing all of the grid
C     information including locations, spacing, areas, \textit{etc}.

C     !USES:
      implicit none
#include "BUILD_INFO.h"
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "MNC_PARAMS.h"
#ifdef ALLOW_EXCH2
#include "W2_EXCH2_SIZE.h"
#include "W2_EXCH2_TOPOLOGY.h"
#endif
C     Functions
      integer ILNBLNK

C     !INPUT PARAMETERS:
      integer myThid, bi,bj, tnum
      character*(*) fname
CEOP

C     !LOCAL VARIABLES:
      integer ilnb

      CALL MNC_FILE_REDEF(fname, myThid)

C     Global attributes
      ilnb = ILNBLNK(the_run_name)
      IF (ilnb .GT. 0) THEN
        CALL MNC_FILE_ADD_ATTR_STR(fname, 'the_run_name',
     &       the_run_name, myThid )
      ENDIF

#ifdef THISVER
      CALL MNC_FILE_ADD_ATTR_STR(fname, 'MITgcm_version',
     &     THISVER ,
     &     myThid )
#endif
#ifdef THISUSER
      CALL MNC_FILE_ADD_ATTR_STR(fname, 'build_user',
     &     THISUSER ,
     &     myThid )
#endif
#ifdef THISHOST
      CALL MNC_FILE_ADD_ATTR_STR(fname, 'build_host',
     &     THISHOST ,
     &     myThid )
#endif
#ifdef THISDATE
      CALL MNC_FILE_ADD_ATTR_STR(fname, 'build_date',
     &     THISDATE ,
     &     myThid )
#endif

      CALL MNC_FILE_ADD_ATTR_STR(fname, 'MITgcm_URL',
     &     'http://mitgcm.org', myThid )
      CALL MNC_FILE_ADD_ATTR_STR(fname, 'MITgcm_tag_id',
     &     MNC_TAG_ID, myThid )
      CALL MNC_FILE_ADD_ATTR_DBL(fname, 'MITgcm_mnc_ver',
     &     1, 0.9D0, myThid )

C     Grid info included as attributes
      CALL MNC_FILE_ADD_ATTR_INT(fname,'tile_number', 1, tnum, myThid)
      CALL MNC_FILE_ADD_ATTR_INT(fname,'bi', 1, bi, myThid)
      CALL MNC_FILE_ADD_ATTR_INT(fname,'bj', 1, bj, myThid)
C jmc: xC0 & yC0 are not initialised + their type does not match (RS type, not DBL)
c     CALL MNC_FILE_ADD_ATTR_DBL(fname,'xC0', 1, xC0, myThid)
c     CALL MNC_FILE_ADD_ATTR_DBL(fname,'yC0', 1, yC0, myThid)
c     CALL MNC_FILE_ADD_ATTR_DBL(fname,'gravitySign',
c    &     1, gravitySign, myThid )
c     CALL MNC_FILE_ADD_ATTR_DBL(fname,'rkFac', 1, rkFac, myThid)

#ifdef ALLOW_EXCH2
C     W2/exch2 information
      CALL MNC_FILE_ADD_ATTR_INT(fname,
     &     'exch2_nNeighbours', 1, exch2_nNeighbours(tnum), myThid)
      CALL MNC_FILE_ADD_ATTR_INT(fname,
     &     'exch2_neighbourId', exch2_nNeighbours(tnum),
     &     exch2_neighbourId(1,tnum), myThid)

      CALL MNC_FILE_ADD_ATTR_INT(fname, 'exch2_pij',
     &     4*exch2_nNeighbours(tnum), exch2_pij(1,1,tnum), myThid)
      CALL MNC_FILE_ADD_ATTR_INT(fname, 'exch2_oi',
     &     exch2_nNeighbours(tnum), exch2_oi(1,tnum), myThid)
      CALL MNC_FILE_ADD_ATTR_INT(fname, 'exch2_oj',
     &     exch2_nNeighbours(tnum), exch2_oj(1,tnum), myThid)

      CALL MNC_FILE_ADD_ATTR_INT(fname,
     &     'exch2_isNedge', 1, exch2_isNedge(tnum), myThid)
      CALL MNC_FILE_ADD_ATTR_INT(fname,
     &     'exch2_isSedge', 1, exch2_isSedge(tnum), myThid)
      CALL MNC_FILE_ADD_ATTR_INT(fname,
     &     'exch2_isEedge', 1, exch2_isEedge(tnum), myThid)
      CALL MNC_FILE_ADD_ATTR_INT(fname,
     &     'exch2_isWedge', 1, exch2_isWedge(tnum), myThid)

      CALL MNC_FILE_ADD_ATTR_INT(fname,
     &     'exch2_myFace', 1, exch2_myFace(tnum), myThid)
      CALL MNC_FILE_ADD_ATTR_INT(fname,
     &     'exch2_txGlobalo', 1, exch2_txGlobalo(tnum), myThid)
      CALL MNC_FILE_ADD_ATTR_INT(fname,
     &     'exch2_tyGlobalo', 1, exch2_tyGlobalo(tnum), myThid)
      CALL MNC_FILE_ADD_ATTR_INT(fname,
     &     'exch2_tBasex', 1, exch2_tBasex(tnum), myThid)
      CALL MNC_FILE_ADD_ATTR_INT(fname,
     &     'exch2_tBasey', 1, exch2_tBasey(tnum), myThid)
#endif

C     Model parameters (SIZE.h) included as attributes
      CALL MNC_FILE_ADD_ATTR_INT(fname, 'sNx', 1, sNx, myThid)
      CALL MNC_FILE_ADD_ATTR_INT(fname, 'sNy', 1, sNy, myThid)
      CALL MNC_FILE_ADD_ATTR_INT(fname, 'OLx', 1, OLx, myThid)
      CALL MNC_FILE_ADD_ATTR_INT(fname, 'OLy', 1, OLy, myThid)
      CALL MNC_FILE_ADD_ATTR_INT(fname, 'nSx', 1, nSx, myThid)
      CALL MNC_FILE_ADD_ATTR_INT(fname, 'nSy', 1, nSy, myThid)
      CALL MNC_FILE_ADD_ATTR_INT(fname, 'nPx', 1, nPx, myThid)
      CALL MNC_FILE_ADD_ATTR_INT(fname, 'nPy', 1, nPy, myThid)
      CALL MNC_FILE_ADD_ATTR_INT(fname, 'Nx', 1, Nx, myThid)
      CALL MNC_FILE_ADD_ATTR_INT(fname, 'Ny', 1, Ny, myThid)
      CALL MNC_FILE_ADD_ATTR_INT(fname, 'Nr', 1, Nr, myThid)

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#include "KPP_OPTIONS.h"
#ifdef ALLOW_GMREDI
#include "GMREDI_OPTIONS.h"
#endif

      SUBROUTINE KPP_TRANSPORT_T (
     I     iMin,iMax,jMin,jMax,bi,bj,k,km1,
     O     df,
     I     myTime, myIter, myThid )
C     *==========================================================*
C     | o SUBROUTINE KPP_TRANSPORT_T
C     |   Add non local KPP transport term (ghat) to diffusive
C     |   temperature flux.
C     *==========================================================*
C     | The nonlocal transport term is nonzero only for scalars
C     | in unstable (convective) forcing conditions.
C     | Note: [surfaceForcingT + Qsw * KPPfrac]
C     |       is the total heat flux penetrating the mixed layer
C     |       from the surface in deg C / s referenced to the
C     |       top layer.
C     | Note: KPPdiffKzT(-,k) is defined at the top of grid cell
C     |       k while KPPghat(i,j,k,bi,bj) is defined at the
C     |       bottom of grid cell k.
C     |       For K=1, KPPdiffKzT(-,k) = 0 which insures no flux
C     |       through the surface.
C     *==========================================================*
      IMPLICIT NONE

C     == GLobal variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "FFIELDS.h"
#include "KPP.h"
#include "KPP_PARAMS.h"
#ifdef ALLOW_GMREDI
#include "GMREDI.h"
#endif

C     == Routine arguments ==
C     iMin,iMax,jMin,  :: Range of points for which calculation
C     jMax,bi,bj,k,km1    results will be set.
C     df               :: Diffusive flux component work array.
C     myTime :: Current time in simulation
C     myIter :: Current iteration number in simulation
C     myThid :: My Thread Id. number
      INTEGER iMin,iMax,jMin,jMax,bi,bj,k,km1
      _RL df     (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL     myTime
      INTEGER myIter
      INTEGER myThid

#if defined(ALLOW_KPP) && defined(KPP_GHAT)

C     == Local variables ==
C     i, j :: Loop counters
      INTEGER i, j
      _RL recip_Cp
#ifdef ALLOW_GMREDI
      _RL tmpFac
#endif

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
      recip_Cp = 1. _d 0 / HeatCapacity_Cp

#ifdef ALLOW_GMREDI

      IF ( useGMRedi .AND. KPP_ghatUseTotalDiffus ) THEN
        tmpFac = 1. _d 0
      ELSE
        tmpFac = 0. _d 0
      ENDIF
      DO j=jMin,jMax
         DO i=iMin,iMax
            df(i,j) = - _rA(i,j,bi,bj)
     &          *( KPPdiffKzT(i,j,k,bi,bj) + tmpFac*Kwz(i,j,k,bi,bj) )
     &          *KPPghat(i,j,km1,bi,bj)
     &          *( surfaceForcingT(i,j,bi,bj)
     &            +adjustColdSST_diag(i,j,bi,bj)
     &            -Qsw(i,j,bi,bj)*recip_Cp*recip_rhoConst
     &            *KPPfrac(i,j,bi,bj)
     &           )
         ENDDO
      ENDDO

#else /* ALLOW_GMREDI */

      DO j=jMin,jMax
         DO i=iMin,iMax
            df(i,j) = - _rA(i,j,bi,bj)
     &          *KPPdiffKzT(i,j,k,bi,bj)
     &          *KPPghat(i,j,km1,bi,bj)
     &          *( surfaceForcingT(i,j,bi,bj)
     &            +adjustColdSST_diag(i,j,bi,bj)
     &            -Qsw(i,j,bi,bj)*recip_Cp*recip_rhoConst
     &            *KPPfrac(i,j,bi,bj)
     &           )
         ENDDO
      ENDDO

#endif /* ALLOW_GMREDI */

#endif /* ALLOW_KPP and KPP_GHAT */

      RETURN
      END

#include "EBM_OPTIONS.h"

CStartOfInterface
      SUBROUTINE EBM_WIND_PERTURB( myTime, myIter, myThid )
C     *==========================================================*
C     | S/R EBM_WIND_PERTURB
C     | o Calculated random wind perturbations.
C     *==========================================================*
      IMPLICIT NONE

C     == Global data ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "DYNVARS.h"
#include "FFIELDS.h"
#ifdef ALLOW_EBM
# include "EBM.h"
#endif

C     == Routine arguments ==
      _RL    myTime
      INTEGER myIter
      INTEGER myThid
CEndOfInterface

#ifdef ALLOW_EBM
# ifdef EBM_WIND_PERT

C     == Local variables ==
C     Loop counters
      INTEGER i, j, bi, bj
      _RS ya(1-OLy:sNy+OLy), ya2(1-OLy:sNy+OLy)
      _RS xa(1-OLx:sNx+OLx), xa2(1-OLx:sNx+OLx)
      _RS y(1-OLy:sNy+OLy), x(1-OLx:sNx+OLx)
      _RS temp(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RS temp2(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RS stdev(1-OLy:sNy+OLy)
      _RS std(1:40)
      data std /0.030, 0.035, 0.045, 0.053, 0.059, 0.060, 0.056,
     &          0.048, 0.041, 0.038, 0.034, 0.029, 0.023, 0.018,
     &          0.016, 0.015, 0.013, 0.011, 0.008, 0.005, 0.005,
     &          0.005, 0.008, 0.011, 0.014, 0.014, 0.017, 0.019,
     &          0.023, 0.029, 0.032, 0.038, 0.048, 0.058, 0.065,
     &          0.067, 0.063, 0.060, 0.062, 0.064 /


      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)

      DO j = 1-OLy, sNy+OLy
         y(j) = 0.0
         ya(j) = 0.0
         ya2(j) =  0.0
         stdev(j) = 0.0
      ENDDO
      DO i = 1-OLx, sNx+OLx
         x(i) = 0.0
         xa(i) = 0.0
         xa2(i) =  0.0
      ENDDO
      DO i = 1-OLx, sNx+OLx
        DO j = 1-OLy, sNy+OLy
         temp(i,j) = 0.0
         temp2(i,j) = 0.0
        ENDDO
      ENDDO
      DO j = 1, sNy
         stdev(j) = std(j)
      ENDDO

cph   Generate random numbers
cph   Need to get this from somewhere!
      call random_number (temp)

C     interpolation in first dimension
C     scaling to get a process with a standard deviation of 1
      DO j = jMin, jMax
       DO i = iMin, iMax
         temp(i,j) = 1.73*(2.0*temp(i,j) - 1.0)
       ENDDO
      ENDDO

      DO j = jMin, jMax
       DO i = iMin, iMax
         x(i) = i
         xa(i) = x(i) - MOD(x(i),10.0)
         xa2(i) = xa(i)+10.0
        if ( xa2(i) .gt. sNx+Olx ) then
           xa2(i) = 0.0
         endif
         temp2(i,j) = 0.1*( (x(i)-xa(i))*temp(INT(xa2(i)),j)+
     &        (10.0-x(i)+xa(i))*temp(INT(xa(i)),j) )
       ENDDO
      ENDDO

C     interpolation in second dimension
C     multiplication with observation zonal wind stress standard deviation
C     add AR1 process
      DO i = iMin, iMax
       DO j = jMin, jMax
         y(j) = j
         ya(j) = y(j) - MOD(y(j),6.0)
         ya2(j) = ya(j)+6.0
         if ( ya2(j) .gt. sNy+Oly ) then
            ya2(j) = 0.0
         endif
c     time lag correlation coefficient, use 0.75 for temperature timescale,
c     0.98 for the momentum timescale.
         winPert(i,j,bi,bj) = maskW(i,j,k,bi,bj)*
     &        (1.0/1.66)*(0.75*winPert(i,j,bi,bj) +
     &        stdev(j)*(1.0/6.0)*
     &        ((y(j)-ya(j))*temp2(i,INT(ya2(j)))+
     &        (6.0-y(j)+ya(j))*temp2(i,INT(ya(j)))))
       ENDDO
      ENDDO

       ENDDO
      ENDDO

C      CALL PLOT_FIELD_XYRS( winPert, 'winPert',1,myThid)

      _EXCH_XY_RS(winPert  , myThid )

      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
         DO j = 1-OLy, sNy+OLy
          DO i = 1-OLx, sNx+OLx
            fu(i,j,bi,bj) = fu(i,j,bi,bj)
     &                    + winPert(i,j,bi,bj)*rUnit2mass
     &                     *drF(1)*hFacW(i,j,1,bi,bj)
          ENDDO
         ENDDO
       ENDDO
      ENDDO

# endif /* EBM_WIND_PERT */
#endif /* ALLOW_EBM */

      RETURN
      END

#include "AIM_OPTIONS.h"
#ifdef ALLOW_THSICE
#include "THSICE_OPTIONS.h"
#endif

CBOP
C     !ROUTINE: AIM_AIM2SIOCE
C     !INTERFACE:
      SUBROUTINE AIM_AIM2SIOCE(
     I               land_frc, siceFrac,
     O               prcAtm, snowPrc,
     I               bi, bj, myTime, myIter, myThid)

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R AIM_AIM2SIOCE
C     | o Interface between AIM and thSIce pkg or (coupled) ocean
C     *==========================================================*
C     | o compute surface fluxes over ocean (ice-free + ice covered)
C     |   for diagnostics, thsice package and (slab, coupled) ocean
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     == Global variables ===
C-- size for MITgcm & Physics package :
#include "AIM_SIZE.h"

#include "EEPARAMS.h"
#include "PARAMS.h"
#include "FFIELDS.h"

C-- Physics package
#include "AIM_PARAMS.h"
#include "com_physcon.h"
#include "com_physvar.h"

#ifdef ALLOW_THSICE
#include "THSICE_SIZE.h"
#include "THSICE_PARAMS.h"
#include "THSICE_VARS.h"
#endif

C updated fields (in commom blocks):
C  if using thSIce:
C      Qsw(inp)   :: SW radiation through the sea-ice down to the ocean (+=up)
C      Qsw(out)   :: SW radiation down to the ocean (ice-free + ice-covered)(+=up)
C      Qnet(out)  :: Net heat flux out of the ocean (ice-free ocean only)(+=up)
C             and the Ice-Covered contribution will be added in S/R THSICE_STEP_FWD
C      EmPmR(out) :: Net fresh water flux out off the ocean (ice-free ocean only)
C             and the Ice-Covered contribution will be added in S/R THSICE_STEP_FWD
C      sHeating(in/out) :: air - seaice surface heat flux left to melt the ice
C      icFrwAtm   :: Evaporation over sea-ice [kg/m2/s] (>0 if evaporate)
C      icFlxSW    :: net SW heat flux through the ice to the ocean [W/m2] (+=dw)
C  if not using thSIce:
C      Qsw(out)   :: SW radiation down to the ocean (ice-free + ice-covered)(+=up)
C      Qnet(out)  :: Net heat flux out of the ocean (ice-free + ice-covered)(+=up)
C      EmPmR(out) :: Net fresh water flux out off the ocean (ice-free + ice-covered)

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     land_frc :: land fraction [0-1]
C     siceFrac :: sea-ice fraction (relative to full grid-cell) [0-1]
C     prcAtm   :: total precip from the atmosphere [kg/m2/s]
C     snowPrc  :: snow precip over sea-ice [kg/m2/s]
C     bi,bj    :: Tile indices
C     myTime   :: Current time of simulation ( s )
C     myIter   :: Current iteration number in simulation
C     myThid   :: My Thread Id number
      _RS land_frc(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL siceFrac(sNx,sNy)
      _RL prcAtm (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL snowPrc(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER bi, bj, myIter, myThid
      _RL myTime
CEOP

#ifdef ALLOW_AIM
C     == Local variables ==
C     i,j,I2      :: loop counters
C     convPrcEvp  :: units conversion factor for Precip & Evap:
C                 :: from AIM units (g/m2/s) to model EmPmR units ( kg/m2/s )
      _RL convPrcEvp
      _RL icFrac, opFrac
      INTEGER i,j,I2

C--   Initialisation :

C--   Atmospheric Physics Fluxes

C     from g/m2/s to kg/m2/s :
      convPrcEvp = 1. _d -3

      DO j=1,sNy
       DO i=1,sNx
        IF ( land_frc(i,j,bi,bj).GE.1. _d 0 ) THEN
C-    Full Land grid-cell: set all fluxes to zero (this has no effect on the
C        model integration and just put this to get meaningfull diagnostics)
         prcAtm(i,j)     = 0. _d 0
         Qnet(i,j,bi,bj) = 0. _d 0
         EmPmR(i,j,bi,bj)= 0. _d 0
         Qsw(i,j,bi,bj)  = 0. _d 0
        ELSE
         I2 = i+(j-1)*sNx

C-    Total Precip (no distinction between ice-covered / ice-free fraction):
         prcAtm(i,j) = ( PRECNV(I2,myThid)
     &                 + PRECLS(I2,myThid) )

C-    Net surface heat flux over ice-free ocean (+=down)
C     note: with aim_splitSIOsFx=F, ice-free & ice covered contribution are
C     already merged together and Qnet is the mean heat flux over the grid box.
         Qnet(i,j,bi,bj) =
     &                         SSR(I2,2,myThid)
     &                       - SLR(I2,2,myThid)
     &                       - SHF(I2,2,myThid)
     &                       - EVAP(I2,2,myThid)*ALHC

C-    E-P over ice-free ocean [m/s]: (same as above is aim_splitSIOsFx=F)
         EmPmR(i,j,bi,bj) = ( EVAP(I2,2,myThid)
     &                      - prcAtm(i,j) ) * convPrcEvp

C-    Net short wave (ice-free ocean) into the ocean (+=down)
         Qsw(i,j,bi,bj) = SSR(I2,2,myThid)

        ENDIF
       ENDDO
      ENDDO

#ifdef ALLOW_THSICE
      IF ( useThSIce ) THEN
       DO j=1,sNy
        DO i=1,sNx
         I2 = i+(j-1)*sNx
C-    Mixed-Layer Ocean: (for thsice slab_ocean and coupler)
C     NOTE: masking is now applied much earlier, during initialisation
c        IF (land_frc(i,j,bi,bj).EQ.1. _d 0) hOceMxL(i,j,bi,bj) = 0.

C-    Evaporation over sea-ice: (for thsice)
         icFrwAtm(i,j,bi,bj) = EVAP(I2,3,myThid)*convPrcEvp

C-    short-wave downward heat flux (ice-free ocean + ice-covered):
C     note: at this point we already called THSICE_IMPL_TEMP to solve for
C     seaice temp and SW flux through the ice. SW is not modified after, and
C     can therefore combine the open-ocean & ice-covered ocean SW fluxes.
         icFrac = iceMask(i,j,bi,bj)
         opFrac = 1. _d 0 - icFrac
         Qsw(i,j,bi,bj) = icFrac*icFlxSW(i,j,bi,bj)
     &                  + opFrac*Qsw(i,j,bi,bj)

        ENDDO
       ENDDO

       IF ( aim_energPrecip ) THEN
C--   Add energy flux related to Precip. (snow, T_rain) over sea-ice
         DO j=1,sNy
          DO i=1,sNx
           IF ( iceMask(i,j,bi,bj).GT.0. _d 0 ) THEN
            I2 = i+(j-1)*sNx
            IF ( EnPrec(I2,myThid).GE.0. _d 0 ) THEN
C-    positive => add to surface heating
              sHeating(i,j,bi,bj) = sHeating(i,j,bi,bj)
     &                            + EnPrec(I2,myThid)*prcAtm(i,j)
              snowPrc(i,j) = 0. _d 0
            ELSE
C-    negative => make snow
              snowPrc(i,j) = prcAtm(i,j)*convPrcEvp
            ENDIF
           ELSE
              snowPrc(i,j) = 0. _d 0
           ENDIF
          ENDDO
         ENDDO
       ENDIF

      ELSEIF ( aim_splitSIOsFx ) THEN
#else /* ALLOW_THSICE */
      IF ( aim_splitSIOsFx ) THEN
#endif /* ALLOW_THSICE */
C-    aim_splitSIOsFx=T: fluxes over sea-ice (3) & ice-free ocean (2) were
C     computed separately and here we merge the 2 fractions
       DO j=1,sNy
        DO i=1,sNx
         I2 = i+(j-1)*sNx
         IF ( siceFrac(i,j) .GT. 0. ) THEN
          icFrac = siceFrac(i,j)/(1. _d 0 - land_frc(i,j,bi,bj))
          opFrac = 1. _d 0 - icFrac

C-    Net surface heat flux over sea-ice + ice-free ocean (+=down)
          Qnet(i,j,bi,bj) = Qnet(i,j,bi,bj)*opFrac
     &                    + (  SSR(I2,3,myThid)
     &                       - SLR(I2,3,myThid)
     &                       - SHF(I2,3,myThid)
     &                       - EVAP(I2,3,myThid)*ALHC
     &                      )*icFrac
C-    E-P over sea-ice + ice-free ocean [m/s]:
          EmPmR(i,j,bi,bj) = EmPmR(i,j,bi,bj)*opFrac
     &                     + ( EVAP(I2,3,myThid)
     &                       - prcAtm(i,j) ) * convPrcEvp * icFrac

C-    Net short wave (ice-free ocean) into the ocean (+=down)
          Qsw(i,j,bi,bj) = opFrac*Qsw(i,j,bi,bj)
     &                   + icFrac*SSR(I2,3,myThid)

         ENDIF
        ENDDO
       ENDDO

C--   end of If useThSIce / elseif aim_splitSIOsFx blocks
      ENDIF

      IF ( aim_energPrecip ) THEN
C--   Ice free fraction: Add energy flux related to Precip. (snow, T_rain):
        DO j=1,sNy
         DO i=1,sNx
          I2 = i+(j-1)*sNx
          Qnet(i,j,bi,bj) = Qnet(i,j,bi,bj)
     &                    + EnPrec(I2,myThid)*prcAtm(i,j)
         ENDDO
        ENDDO
      ENDIF

      DO j=1,sNy
        DO i=1,sNx
C-    Total Precip : convert units
          prcAtm(i,j) = prcAtm(i,j) * convPrcEvp
C-    Oceanic convention: Heat flux are > 0 upward ; reverse sign.
          Qsw(i,j,bi,bj) = -Qsw(i,j,bi,bj)
          Qnet(i,j,bi,bj)= -Qnet(i,j,bi,bj)
        ENDDO
      ENDDO

#endif /* ALLOW_AIM */

      RETURN
      END

#include "BBL_OPTIONS.h"

CBOP
C     !ROUTINE: BBL_INIT_VARIA

C     !INTERFACE:
      SUBROUTINE BBL_INIT_VARIA( myThid )

C     !DESCRIPTION:
C     Initialize BBL variables

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "DYNVARS.h"
#include "BBL.h"

C     !INPUT/OUTPUT PARAMETERS:
C     myThid      :: my Thread Id number
      INTEGER myThid
CEOP

#ifdef ALLOW_BBL

C     !LOCAL VARIABLES:
C     i,j,bi,bj :: loop indices
C     kBot      :: k index of bottommost wet grid
      INTEGER i,j,bi,bj,kBot

C     Initialize arrays in common blocks.
      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          kBot = max(1,kLowC(i,j,bi,bj))
          bbl_theta(i,j,bi,bj)     = theta(i,j,kBot,bi,bj)
          bbl_salt (i,j,bi,bj)     = salt (i,j,kBot,bi,bj)
          bbl_eta(i,j,bi,bj)       = 0. _d 0
          bbl_TendTheta(i,j,bi,bj) = 0. _d 0
          bbl_TendSalt (i,j,bi,bj) = 0. _d 0
         ENDDO
        ENDDO
       ENDDO
      ENDDO

      IF ( startTime.EQ.baseTime .AND. nIter0.EQ.0
     &                           .AND. pickupSuff.EQ.' ' ) THEN

C     Read initialization files, if available.
       IF ( bbl_thetaFile .NE. ' ' ) THEN
         CALL READ_FLD_XY_RL( bbl_thetaFile, ' ',
     &                        bbl_theta, 0, myThid )
         CALL EXCH_XY_RL( bbl_theta, myThid )
       ENDIF
       IF ( bbl_saltFile .NE. ' ' ) THEN
         CALL READ_FLD_XY_RL( bbl_saltFile, ' ',
     &                        bbl_salt, 0, myThid )
         CALL EXCH_XY_RL( bbl_salt, myThid )
       ENDIF
       IF ( bbl_etaFile .NE. ' ' ) THEN
         CALL READ_FLD_XY_RL( bbl_etaFile, ' ',
     &                        bbl_eta, 0, myThid )
         CALL EXCH_XY_RL( bbl_eta, myThid )
       ENDIF

      ELSE

C     Restart from a pickup.
         CALL BBL_READ_PICKUP( nIter0, myThid )

C     End start-from-iter-zero if/else block.
      ENDIF

#endif /* ALLOW_BBL */

      RETURN
      END

#include "BBL_OPTIONS.h"

CBOP
C !ROUTINE: BBL_WRITE_PICKUP

C !INTERFACE: ==========================================================
      SUBROUTINE BBL_WRITE_PICKUP( permPickup,
     &                    suff, myTime, myIter, myThid )

C !DESCRIPTION:
C     Writes current state of passive tracers to a pickup file

C !USES: ===============================================================
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "BBL.h"

C !INPUT PARAMETERS: ===================================================
C     permPickup      :: write a permanent pickup
C     suff            :: suffix for pickup file (eg. ckptA or 0000000010)
C     myTime          :: model time
C     myIter          :: time-step number
C     myThid          :: thread number
      LOGICAL permPickup
      CHARACTER*(*) suff
      _RL myTime
      INTEGER myIter
      INTEGER myThid

C !OUTPUT PARAMETERS: ==================================================
C  none

#ifdef ALLOW_BBL

C     === Functions ====
      INTEGER  ILNBLNK
      EXTERNAL ILNBLNK

C !LOCAL VARIABLES: ====================================================
C     j           :: loop index / field number
C     fp          :: pickup-file precision
C     glf         :: local flag for "globalFiles"
C     fn          :: character buffer for creating filename
C     nWrFlds     :: number of fields being written
C     listDim     :: dimension of "wrFldList" local array
C     wrFldList   :: list of written fields
C     msgBuf      :: Informational/error message buffer
      INTEGER j, fp, lChar
      LOGICAL glf
      _RL     timList(1)
      CHARACTER*(MAX_LEN_FNAM) fn
      INTEGER listDim, nWrFlds
      PARAMETER( listDim = 3 )
      CHARACTER*(8) wrFldList(listDim)
      CHARACTER*(MAX_LEN_MBUF) msgBuf
CEOP

        lChar = ILNBLNK(suff)
        IF ( lChar.EQ.0 ) THEN
          WRITE(fn,'(2A)') 'pickup_bbl'
        ELSE
          WRITE(fn,'(2A)') 'pickup_bbl.',suff(1:lChar)
        ENDIF
        fp = precFloat64
        j  = 0

C     Write 2-D fields
C     record number < 0 : a hack not to write meta files now:

        j = j + 1
        CALL WRITE_REC_3D_RL( fn, fp, 1,
     &                        bbl_theta, -j, myIter, myThid )
        IF (j.LE.listDim) wrFldList(j) = 'bblTheta'

        j = j + 1
        CALL WRITE_REC_3D_RL( fn, fp, 1,
     &                        bbl_salt, -j, myIter, myThid )
        IF (j.LE.listDim) wrFldList(j) = 'bblSalt '

        j = j + 1
        CALL WRITE_REC_3D_RL( fn, fp, 1,
     &                        bbl_eta, -j, myIter, myThid )
        IF (j.LE.listDim) wrFldList(j) = 'bblEta  '

C--------------------------
        nWrFlds = j
        IF ( nWrFlds.GT.listDim ) THEN
          WRITE(msgBuf,'(2A,I5,A)') 'BBL_WRITE_PICKUP: ',
     &     'trying to write ',nWrFlds,' fields'
          CALL PRINT_ERROR( msgBuf, myThid )
          WRITE(msgBuf,'(2A,I5,A)') 'BBL_WRITE_PICKUP: ',
     &     'field-list dimension (listDim=',listDim,') too small'
          CALL PRINT_ERROR( msgBuf, myThid )
          STOP 'ABNORMAL END: S/R BBL_WRITE_PICKUP (list-size Pb)'
        ENDIF
#ifdef ALLOW_MDSIO
C     uses this specific S/R to write meta file
        glf  = globalFiles
        timList(1) = myTime
        CALL MDS_WR_METAFILES( fn, fp, glf, .FALSE.,
     &                         0, 0, 1, ' ',
     &                         nWrFlds, wrFldList,
     &                         1, timList, oneRL,
     &                         j, myIter, myThid )
#endif /* ALLOW_MDSIO */
C--------------------------

#endif /* ALLOW_BBL */

      RETURN
      END

#include "DIC_OPTIONS.h"
#ifdef ALLOW_AUTODIFF
# include "AUTODIFF_OPTIONS.h"
#endif

CBOP
C !ROUTINE: DIC_SURFFORCING

C !INTERFACE: ==========================================================
      SUBROUTINE DIC_SURFFORCING( PTR_CO2 , PTR_ALK, PTR_PO4, GDC,
     I           bi, bj, iMin, iMax, jMin, jMax,
     I           myTime, myIter, myThid )

C !DESCRIPTION:
C  Calculate the carbon air-sea flux terms
C  following external_forcing_dic.F (OCMIP run) from Mick

C !USES: ===============================================================
      IMPLICIT NONE
#include "SIZE.h"
#include "DYNVARS.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "FFIELDS.h"
#include "DIC_VARS.h"
#ifdef ALLOW_AUTODIFF_TAMC
# include "tamc.h"
#endif

C !INPUT PARAMETERS: ===================================================
C  PTR_CO2              :: DIC tracer field
C  myTime               :: current time
C  myIter               :: current timestep
C  myThid               :: thread number
      _RL  PTR_CO2(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL  PTR_ALK(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL  PTR_PO4(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      INTEGER iMin,iMax,jMin,jMax, bi, bj
      _RL myTime
      INTEGER myIter, myThid

C !OUTPUT PARAMETERS: ===================================================
C GDC                   :: tendency due to air-sea exchange
      _RL  GDC(1-OLx:sNx+OLx,1-OLy:sNy+OLy)

#ifdef ALLOW_DIC

C !LOCAL VARIABLES: ====================================================
       INTEGER i,j, kLev
       LOGICAL debugPrt
       _RL co3dummy
C Number of iterations for pCO2 solvers...
C Solubility relation coefficients
      _RL SchmidtNoDIC(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL pCO2sat(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL Kwexch(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL pisvel(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
C local variables for carbon chem
      _RL surfalk(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL surfphos(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL surfsi(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL surftemp(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL surfsalt(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL surfdic(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
#ifdef ALLOW_OLD_VIRTUALFLUX
      _RL VirtualFlux(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
#endif
#ifdef ALLOW_AUTODIFF_TAMC
C     tkey :: tape key (tile dependent)
      INTEGER tkey
#endif
CEOP

      kLev = 1

cC if coupled to atmsopheric model, use the
cC Co2 value passed from the coupler
c#ifndef USE_ATMOSCO2
cC PRE-INDUSTRIAL STEADY STATE pCO2 = 278.0 ppmv
c       DO j=1-OLy,sNy+OLy
c        DO i=1-OLx,sNx+OLx
c           AtmospCO2(i,j,bi,bj)=278.0 _d -6
c        ENDDO
c       ENDDO
c#endif

C =================================================================
C determine inorganic carbon chem coefficients
       DO j=jMin,jMax
        DO i=iMin,iMax
#ifdef DIC_BIOTIC
cQQQQ check ptracer numbers
#ifdef DIC_BOUNDS
          surfalk(i,j)  = MAX( 0.4 _d 0,
     &                         MIN( 10. _d 0, PTR_ALK(i,j,klev) ) )
     &                  * maskC(i,j,kLev,bi,bj)
          surfphos(i,j) = MAX( 1.0 _d -11,
     &                         MIN( 1. _d -1, PTR_PO4(i,j,klev) ) )
     &                  * maskC(i,j,kLev,bi,bj)
#else
          surfalk(i,j)  = PTR_ALK(i,j,klev)*maskC(i,j,kLev,bi,bj)
          surfphos(i,j) = PTR_PO4(i,j,klev)*maskC(i,j,kLev,bi,bj)
#endif
#else /* DIC_BIOTIC */
          surfalk(i,j)  = 2.366595 _d 0 * salt(i,j,kLev,bi,bj)/gsm_s
     &                  * maskC(i,j,kLev,bi,bj)
          surfphos(i,j) = 5.1225 _d -4 * maskC(i,j,kLev,bi,bj)
#endif /* DIC_BIOTIC */
C for non-interactive Si
          surfsi(i,j)   = silicaSurf(i,j,bi,bj)*maskC(i,j,kLev,bi,bj)
#ifdef DIC_BOUNDS
          surftemp(i,j) = MAX( -4. _d 0,
     &                         MIN( 50. _d 0, theta(i,j,kLev,bi,bj) ) )
          surfsalt(i,j) = MAX( 4. _d 0,
     &                         MIN( 50. _d 0, salt(i,j,kLev,bi,bj) ) )
          surfdic(i,j)  = MAX( 0.4 _d 0,
     &                         MIN( 10. _d 0, PTR_CO2(i,j,kLev) ) )
#else
          surftemp(i,j) = theta(i,j,kLev,bi,bj)
          surfsalt(i,j) = salt(i,j,kLev,bi,bj)
          surfdic(i,j)  = PTR_CO2(i,j,kLev)
#endif
        ENDDO
       ENDDO

#ifdef CARBONCHEM_SOLVESAPHE
#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_CALL('DIC_COEFFS_SURF',myThid)
#endif
       CALL DIC_COEFFS_SURF(
     I                       surftemp,surfsalt,
     I                       bi,bj,iMin,iMax,jMin,jMax,myThid)
#else /* CARBONCHEM_SOLVESAPHE */
#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_CALL('CARBON_COEFFS',myThid)
#endif
       CALL CARBON_COEFFS(
     I                       surftemp,surfsalt,
     I                       bi,bj,iMin,iMax,jMin,jMax,myThid)
#endif /* CARBONCHEM_SOLVESAPHE */
C====================================================================

       DO j=jMin,jMax
        DO i=iMin,iMax
C Compute AtmosP and Kwexch_Pre which are re-used for flux of O2

#ifdef USE_PLOAD
C Convert anomalous pressure pLoad (in Pa) from atmospheric model
C to total pressure (in Atm)
C Note: it is assumed the reference atmospheric pressure is 1Atm=1013mb
C       rather than the actual ref. pressure from Atm. model so that on
C       average AtmosP is about 1 Atm.
          AtmosP(i,j,bi,bj)= ( surf_pRef + pLoad(i,j,bi,bj) )/Pa2Atm
#endif

C Pre-compute part of exchange coefficient: pisvel*(1-fice)
C Schmidt number is accounted for later
          pisvel(i,j) = 0.337 _d 0 *wind(i,j,bi,bj)**2/3.6 _d 5
          Kwexch_Pre(i,j,bi,bj) = pisvel(i,j)
     &                          * (1. _d 0 - fIce(i,j,bi,bj))
        ENDDO
       ENDDO

#ifdef ALLOW_AUTODIFF_TAMC
       tkey = bi + (bj-1)*nSx + (ikey_dynamics-1)*nSx*nSy
CADJ STORE pH(:,:,bi,bj) = comlev1_bibj, key = tkey, kind = isbyte
#endif
       debugPrt = debugMode
C pCO2 solver...
C$TAF LOOP = parallel
       DO j=jMin,jMax
C$TAF LOOP = parallel
        DO i=iMin,iMax
          IF ( maskC(i,j,kLev,bi,bj).NE.0. _d 0 ) THEN
#ifdef CARBONCHEM_SOLVESAPHE
            IF ( selectPHsolver.GT.0 ) THEN
C Use Munhoven (2013) Solvesaphe routine to calculate pH and pCO2
#ifdef ALLOW_DEBUG
              IF (debugPrt) CALL DEBUG_CALL(
     &     'CALC_PCO2_SOLVESAPHE from DIC_SURFFORCING',myThid)
#endif
              CALL CALC_PCO2_SOLVESAPHE(
     I          surftemp(i,j),surfsalt(i,j),
     I          surfdic(i,j), surfphos(i,j),
     I          surfsi(i,j),surfalk(i,j),
     U          pH(i,j,bi,bj),pCO2(i,j,bi,bj),co3dummy,
     I          i,j,kLev,bi,bj, debugPrt, myIter, myThid )
              debugPrt = .FALSE.
            ELSE
C Use the original Follows et al. (2006) solver
#endif /* CARBONCHEM_SOLVESAPHE */
#ifdef ALLOW_DEBUG
              IF (debugPrt) CALL DEBUG_CALL(
     &        'CALC_PCO2_APPROX',myThid)
              debugPrt = .FALSE.
#endif
              CALL CALC_PCO2_APPROX(
     I          surftemp(i,j),surfsalt(i,j),
     I          surfdic(i,j), surfphos(i,j),
     I          surfsi(i,j),surfalk(i,j),
     I          ak1(i,j,bi,bj),ak2(i,j,bi,bj),
     I          ak1p(i,j,bi,bj),ak2p(i,j,bi,bj),ak3p(i,j,bi,bj),
     I          aks(i,j,bi,bj),akb(i,j,bi,bj),akw(i,j,bi,bj),
     I          aksi(i,j,bi,bj),akf(i,j,bi,bj),
     I          ak0(i,j,bi,bj), fugf(i,j,bi,bj),
     I          ff(i,j,bi,bj),
     I          bt(i,j,bi,bj),st(i,j,bi,bj),ft(i,j,bi,bj),
     U          pH(i,j,bi,bj),pCO2(i,j,bi,bj),co3dummy,
     I          i,j,kLev,bi,bj,myIter, myThid )
#ifdef CARBONCHEM_SOLVESAPHE
            ENDIF
#endif /* CARBONCHEM_SOLVESAPHE */
          ELSE
            pCO2(i,j,bi,bj)=0. _d 0
          ENDIF
        ENDDO
       ENDDO
#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE pCO2(:,:,bi,bj) = comlev1_bibj, key = tkey, kind = isbyte
#endif

       DO j=jMin,jMax
        DO i=iMin,iMax

          IF ( maskC(i,j,kLev,bi,bj).NE.0. _d 0 ) THEN
C calculate SCHMIDT NO. for CO2
            SchmidtNoDIC(i,j) =
     &            sca1
     &          + sca2 * theta(i,j,kLev,bi,bj)
     &          + sca3 * theta(i,j,kLev,bi,bj)*theta(i,j,kLev,bi,bj)
     &          + sca4 * theta(i,j,kLev,bi,bj)*theta(i,j,kLev,bi,bj)
     &                *theta(i,j,kLev,bi,bj)
C make sure Schmidt number is not negative (will happen if temp>39C)
            SchmidtNoDIC(i,j) = MAX( 1.0 _d -2, SchmidtNoDIC(i,j) )

C Determine surface flux (FDIC)
C first correct pCO2at for surface atmos pressure
            pCO2sat(i,j) =
     &          AtmosP(i,j,bi,bj)*AtmospCO2(i,j,bi,bj)

C then account for Schmidt number
            Kwexch(i,j) = Kwexch_Pre(i,j,bi,bj)
     &                  / SQRT(SchmidtNoDIC(i,j)/660.0 _d 0)

#ifdef WATERVAP_BUG
C Calculate flux in terms of DIC units using K0, solubility
C Flux = Vp * ([CO2sat] - [CO2])
C CO2sat = K0*pCO2atmos*P/P0
C Converting pCO2 to [CO2] using ff, as in CALC_PCO2
            FluxCO2(i,j,bi,bj) =
     &         Kwexch(i,j)*(
     &         ak0(i,j,bi,bj)*pCO2sat(i,j) -
     &         ff(i,j,bi,bj)*pCO2(i,j,bi,bj)
     &         )
#else

C Corrected by Val Bennington Nov 2010 per G.A. McKinley s finding
C of error in application of water vapor correction
C Flux = kw*rho*(ff*pCO2atm-k0*FugFac*pCO2ocean)
            FluxCO2(i,j,bi,bj) =
     &          Kwexch(i,j)*(
     &            ff(i,j,bi,bj)*pCO2sat(i,j) -
     &            pCO2(i,j,bi,bj)*fugf(i,j,bi,bj)
     &            *ak0(i,j,bi,bj) )

#endif
          ELSE
            FluxCO2(i,j,bi,bj) = 0. _d 0
          ENDIF
C convert flux (mol kg-1 m s-1) to (mol m-2 s-1)
          FluxCO2(i,j,bi,bj) = FluxCO2(i,j,bi,bj)/permil

#ifdef ALLOW_OLD_VIRTUALFLUX
          IF (maskC(i,j,kLev,bi,bj).NE.0. _d 0) THEN
C calculate virtual flux
C EminusPforV = dS/dt*(1/Sglob)
C NOTE: Be very careful with signs here!
C Positive EminusPforV => loss of water to atmos and increase
C in salinity. Thus, also increase in other surface tracers
C (i.e. positive virtual flux into surface layer)
C ...so here, VirtualFLux = dC/dt!
              VirtualFlux(i,j)=gsm_DIC*surfaceForcingS(i,j,bi,bj)/gsm_s
C OR
C let virtual flux be zero
C              VirtualFlux(i,j)=0.d0
          ELSE
              VirtualFlux(i,j)=0. _d 0
          ENDIF
#endif /* ALLOW_OLD_VIRTUALFLUX */
        ENDDO
       ENDDO

C update tendency
       DO j=jMin,jMax
        DO i=iMin,iMax
           GDC(i,j)= recip_drF(kLev)*recip_hFacC(i,j,kLev,bi,bj)
     &              *(FluxCO2(i,j,bi,bj)
#ifdef ALLOW_OLD_VIRTUALFLUX
     &              + VirtualFlux(i,j)
#endif
     &               )
        ENDDO
       ENDDO

#endif /* ALLOW_DIC */
      RETURN
      END

#include "ICEFRONT_OPTIONS.h"
#ifdef ALLOW_EXF
# include "EXF_OPTIONS.h"
#endif /* ALLOW_EXF */
#undef ALLOW_ICEFRONT_DEBUG

      SUBROUTINE ICEFRONT_INIT_FIXED( myThid )
C     *============================================================*
C     | SUBROUTINE ICEFRONT_INIT_FIXED
C     | o Routine to initialize ICEFRONT parameters and variables.
C     *============================================================*
C     | Initialize ICEFRONT parameters and variables.
C     *============================================================*
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "ICEFRONT.h"
#ifdef ALLOW_EXF
# include "EXF_PARAM.h"
#endif /* ALLOW_EXF */

C     === Routine arguments ===
C     myThid        :: my Thread Id Number
      INTEGER myThid

#ifdef ALLOW_ICEFRONT
C     === Local variables ===
C     I,J,K,bi,bj   :: Loop counters
C     errCount      :: error counter
      INTEGER I, J, K, bi, bj
#ifdef ALLOW_ICEFRONT_DEBUG
      INTEGER ISinterface
#endif
#ifdef ALLOW_EXF
      INTEGER errCount
      CHARACTER*(MAX_LEN_MBUF) msgBuf
#endif /* ALLOW_EXF */

#ifdef ALLOW_EXF
      IF ( useEXF .AND. SGRunOffFile .NE. ' ' ) THEN
       _BEGIN_MASTER( myThid )
       errCount = 0
# ifdef ALLOW_DEBUG
       IF (debugMode) CALL DEBUG_CALL('GETFIELD_START SGRunOff',myThid)
# endif
       CALL EXF_GETFFIELD_START( useExfYearlyFields,
     I                    'icefront', 'SGRunOff', SGRunOffperiod,
     I                    SGRunOffstartdate1, SGRunOffstartdate2,
     U                    SGRunOffStartTime, errCount,
     I                    myThid )
       IF ( errCount.GE.1 ) THEN
        WRITE(msgBuf,'(A,I3,A)')
     &     'ICEFRONT_INIT_FIXED: detected', errCount,' fatal error(s)'
        CALL PRINT_ERROR( msgBuf, myThid )
        CALL ALL_PROC_DIE( 0 )
        STOP 'ABNORMAL END: S/R ICEFRONT_INIT_FIXED'
       ENDIF
       _END_MASTER( myThid )
       _BARRIER
      ENDIF
#endif /* ALLOW_EXF */

      IF ( ICEFRONTlengthFile .NE. ' ' ) THEN
       CALL READ_FLD_XY_RS( ICEFRONTlengthFile, ' ',
     &      icefrontlength, 0, myThid )
       _EXCH_XY_RS( icefrontlength, myThid )
      ENDIF

      IF ( ICEFRONTdepthFile .NE. ' ' ) THEN
       CALL READ_FLD_XY_RS( ICEFRONTdepthFile, ' ',
     &      R_icefront, 0, myThid )
       _EXCH_XY_RS( R_icefront, myThid )
      ENDIF

C     Make sure that R_icefront is positive
      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
        DO J = 1-OLy, sNy+OLy
         DO I = 1-OLx, sNx+OLx
          R_icefront(I,J,bi,bj) = ABS(R_icefront(I,J,bi,bj))
         ENDDO
        ENDDO
       ENDDO
      ENDDO

      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
        DO J = 1-OLy, sNy+OLy
         DO I = 1-OLx, sNx+OLx
          K_icefront(i,j,bi,bj) = 0
          DO K = 1 , Nr
           IF ( R_icefront(I,J,bi,bj) .GT. ABS(rF(K)))
     &          K_icefront(I,J,bi,bj) = K
          ENDDO
         ENDDO
        ENDDO
       ENDDO
      ENDDO

#ifdef ALLOW_ICEFRONT_DEBUG
      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
         DO J = 1, sNy
          DO I = 1, sNx
C           IsInterface=0
           IF (ICEFRONTlength(I,J,bi,bj) .GT. 0. _d 0) THEN
C              print*, 'IsInterface=', '2' , ',xuyun'
              IsInterface=Isinterface + K_icefront(I,J,bi,bj)
           ENDIF
          ENDDO
         ENDDO
        ENDDO
       ENDDO
       print*, 'Interface # =', IsInterface
#endif /* ALLOW_ICEFRONT_DEBUG */

#ifdef ALLOW_DIAGNOSTICS
      IF ( useDiagnostics ) THEN
       CALL ICEFRONT_DIAGNOSTICS_INIT( myThid )
      ENDIF
#endif /* ALLOW_DIAGNOSTICS */

#endif /* ALLOW_ICEFRONT */

      RETURN
      END

#include "PTRACERS_OPTIONS.h"

CBOP
C     !ROUTINE: PTRACERS_WRITE_STATE

C     !INTERFACE:
      SUBROUTINE PTRACERS_WRITE_STATE(
     I                    myTime, myIter, myThid )

C     !DESCRIPTION:
C     dump to files current passive tracer state

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "PTRACERS_SIZE.h"
#include "PTRACERS_PARAMS.h"
#include "PTRACERS_FIELDS.h"

C     !INPUT PARAMETERS:
C     myTime    :: model time
C     myIter    :: time-step number
C     myThid    :: thread number
      _RL myTime
      INTEGER myIter
      INTEGER myThid
CEOP

#ifdef ALLOW_PTRACERS

C     !FUNCTIONS:
      LOGICAL  DIFFERENT_MULTIPLE
      EXTERNAL DIFFERENT_MULTIPLE
      INTEGER  IO_ERRCOUNT
      EXTERNAL IO_ERRCOUNT

C     !LOCAL VARIABLES:
C     iTracer   :: loop indices
C     pref      :: character buffer for creating prefix in filename
C     iRec      :: record number
      INTEGER iTracer
      CHARACTER*(10) suff
      CHARACTER*(MAX_LEN_FNAM) pref
      INTEGER iRec
#ifdef ALLOW_MNC
      CHARACTER*(1) pf
#endif

      IF ( DIFFERENT_MULTIPLE( PTRACERS_dumpFreq, myTime, deltaTClock )
     &  .OR. dumpInitAndLast.AND.( myTime.EQ.endTime .OR.
     &                             myTime.EQ.startTime  )
     &   ) THEN

C--   Write to files
       _BARRIER

#ifdef ALLOW_MNC
        IF ( writeBinaryPrec .EQ. precFloat64 ) THEN
          pf(1:1) = 'D'
        ELSE
          pf(1:1) = 'R'
        ENDIF

       IF ( PTRACERS_snapshot_mnc ) THEN
        CALL MNC_CW_SET_UDIM('ptracers', -1, myThid)
        CALL MNC_CW_RL_W_S('D','ptracers',0,0,'T',myTime,myThid)
        CALL MNC_CW_SET_UDIM('ptracers', 0, myThid)
        CALL MNC_CW_I_W_S('I','ptracers',0,0,'iter',myIter,myThid)
        DO iTracer = 1,PTRACERS_numInUse
         CALL MNC_CW_RL_W(pf,'ptracers',0,0,PTRACERS_names(iTracer),
     &        pTracer(1-OLx,1-OLy,1,1,1,iTracer),myThid)
        ENDDO
       ENDIF
#endif /*  ALLOW_MNC  */

       IF ( PTRACERS_snapshot_mdsio ) THEN

C       Loop over tracers
        DO iTracer=1,PTRACERS_numInUse

#ifdef MULTIPLE_RECORD_STATE_FILES
C     Write each snap-shot as a record in a time-history file
         IF (PTRACERS_useRecords) THEN
C     Write each passive tracer as a record
          WRITE(pref,'(A)') 'PTRACERS'
          iRec = 1 + NINT( (myTime-startTime) / PTRACERS_dumpFreq )
          iRec = (iRec-1)*PTRACERS_num + iTracer + 1
         ELSE
C     Write each passive tracer in its own file
          WRITE(pref,'(2A)') 'PTRACER',PTRACERS_ioLabel(iTracer)
          iRec = 1 + NINT( (myTime-startTime) / PTRACERS_dumpFreq )
         ENDIF
#else
C     Write each snap-shot as a new file with a 10-digit suffix to
C     indicate time-step number
         IF ( rwSuffixType.EQ.0 ) THEN
          WRITE(suff,'(I10.10)') myIter
         ELSE
          CALL RW_GET_SUFFIX( suff, myTime, myIter, myThid )
         ENDIF
         IF (PTRACERS_useRecords) THEN
C     Write each passive tracer as a record
          WRITE(pref,'(A,A)') 'PTRACERS.', suff
          iRec=iTracer
         ELSE
C     Write each passive tracer in its own file
          WRITE(pref,'(3A,A)')
     &         'PTRACER', PTRACERS_ioLabel(iTracer), '.', suff
          iRec=1
         ENDIF
#endif /* MULTIPLE_RECORD_STATE_FILES */

#ifdef ALLOW_OPENAD
         CALL WRITE_REC_XYZ_RL(pref,
     &        pTracer(:,:,:,:,:,iTracer)%v,iRec,myIter,myThid)
#else
         CALL WRITE_REC_XYZ_RL(pref,
     &        pTracer(1-OLx,1-OLy,1,1,1,iTracer),iRec,myIter,myThid)
#endif

C     End of tracer loop
        ENDDO

       ENDIF

       _BARRIER
C--   Writing to files: end
      ENDIF

#endif /* ALLOW_PTRACERS */

      RETURN
      END

#include "MYPACKAGE_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C !ROUTINE: MYPACKAGE_READPARMS

C !INTERFACE:
      SUBROUTINE MYPACKAGE_READPARMS( myThid )

C     !DESCRIPTION:
C     Initialize MYPACKAGE variables and constants.

C     !USES:
      IMPLICIT NONE
C     == Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "MYPACKAGE.h"

C     !INPUT PARAMETERS:
      INTEGER myThid
CEOP

C     !LOCAL VARIABLES:
C     msgBuf     :: Informational/error message buffer
C     iUnit      :: Work variable for IO unit number
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      INTEGER iUnit

      NAMELIST /MYPACKAGE_PARM01/
     &       myPa_MNC,
     &       myPa_StaV_Cgrid, myPa_Tend_Cgrid,
     &       myPa_applyTendT, myPa_applyTendS,
     &       myPa_applyTendU, myPa_applyTendV,
     &       myPa_doSwitch1,  myPa_doSwitch2,
     &       myPa_index1,     myPa_index2,
     &       myPa_param1,     myPa_param2,
     &       myPa_string1,    myPa_string2,
     &       myPa_Scal1File,  myPa_Scal2File,
     &       myPa_VelUFile,   myPa_VelVFile,
     &       myPa_Surf1File,  myPa_Surf2File

      IF ( .NOT.useMYPACKAGE ) THEN
C-    pkg MYPACKAGE is not used
        _BEGIN_MASTER(myThid)
C-    Track pkg activation status:
C     print a (weak) warning if data.mypackage is found
         CALL PACKAGES_UNUSED_MSG( 'useMYPACKAGE', ' ', ' ' )
        _END_MASTER(myThid)
        RETURN
      ENDIF

      _BEGIN_MASTER(myThid)

C--   Default values for MYPACKAGE
      myPa_MNC         = useMNC
      myPa_StaV_Cgrid  = .TRUE.
      myPa_Tend_Cgrid  = .TRUE.
      myPa_applyTendT  = .FALSE.
      myPa_applyTendS  = .FALSE.
      myPa_applyTendU  = .FALSE.
      myPa_applyTendV  = .FALSE.
C-    additional parameters:
      myPa_doSwitch1   = .FALSE.
      myPa_doSwitch2   = .FALSE.
      myPa_index1      = 0
      myPa_index2      = 0
      myPa_param1      = 0. _d 0
      myPa_param2      = 0. _d 0
      myPa_string1     = ' '
      myPa_string2     = ' '
C-    file names for initial conditions:
      myPa_Scal1File   = ' '
      myPa_Scal2File   = ' '
      myPa_VelUFile    = ' '
      myPa_VelVFile    = ' '
      myPa_Surf1File   = ' '
      myPa_Surf2File   = ' '

      WRITE(msgBuf,'(A)') 'MYPACKAGE_READPARMS: opening data.mypackage'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      CALL OPEN_COPY_DATA_FILE(
     I                     'data.mypackage', 'MYPACKAGE_READPARMS',
     O                     iUnit,
     I                     myThid )

C     Read parameters from open data file
      READ(UNIT=iUnit,NML=MYPACKAGE_PARM01)
      WRITE(msgBuf,'(A)')
     &    'MYPACKAGE_READPARMS: finished reading data.mypackage'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
C     Close the open data file
#ifdef SINGLE_DISK_IO
      CLOSE(iUnit)
#else
      CLOSE(iUnit,STATUS='DELETE')
#endif /* SINGLE_DISK_IO */

C     Make sure that we locally honor the global MNC on/off flag
      myPa_MNC = myPa_MNC .AND. useMNC
#ifndef ALLOW_MNC
C     Fix to avoid running without getting any output:
      myPa_MNC = .FALSE.
#endif
      myPa_MDSIO = (.NOT. myPa_MNC) .OR. outputTypesInclusive

      _END_MASTER(myThid)

C--   Everyone else must wait for the parameters to be loaded
      _BARRIER

      RETURN
      END

#include "SHAP_FILT_OPTIONS.h"
#ifdef ALLOW_AUTODIFF
# include "AUTODIFF_OPTIONS.h"
#endif

CBOP
C     !ROUTINE: SHAP_FILT_UV_S2
C     !INTERFACE:
      SUBROUTINE SHAP_FILT_UV_S2(
     U           uFld, vFld, tmpFldU, tmpFldV,
     I           kSize, myTime, myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R SHAP_FILT_UV_S2
C     | o Applies Shapiro filter to velocity field (u & v).
C     | o use filtering function "S2" = [1 - (d_xx+d_yy)^n]
C     | o Options for computational filter (no grid spacing)
C     |   or physical space filter (with grid spacing) or both.
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     == Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "SHAP_FILT.h"
c#ifdef ALLOW_EXCH2
c#include "W2_EXCH2_SIZE.h"
c#include "W2_EXCH2_TOPOLOGY.h"
c#endif /* ALLOW_EXCH2 */

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments
C     uFld :: velocity field (U component) on which filter applies
C     vFld :: velocity field (V component) on which filter applies
C     tmpFldU :: working temporary array
C     tmpFldV :: working temporary array
C     kSize :: length of 3rd Dim : either =1 (2D field) or =Nr (3D field)
C     myTime :: Current time in simulation
C     myThid :: Thread number for this instance of SHAP_FILT_UV_S2
      INTEGER kSize
      _RL uFld(1-OLx:sNx+OLx,1-OLy:sNy+OLy,kSize,nSx,nSy)
      _RL vFld(1-OLx:sNx+OLx,1-OLy:sNy+OLy,kSize,nSx,nSy)
      _RL tmpFldU(1-OLx:sNx+OLx,1-OLy:sNy+OLy,kSize,nSx,nSy)
      _RL tmpFldV(1-OLx:sNx+OLx,1-OLy:sNy+OLy,kSize,nSx,nSy)
      _RL     myTime
      INTEGER myThid

#ifdef ALLOW_SHAP_FILT

C------
C  Combine computational Filter of Div & Vorticity
C   and Physical Filter of U,V field
C   nShapUVPhys = 0  ==> use only computational Filter
C   nShapUVPhys = 1  ==> compute Div & Vort. with  Grid factors,
C                        Filter Div & Vort. Numerically (power nShapUV-1)
C                        and return filtered U.V in physical space
C   nShapUVPhys = nShapUV  ==> Filter in Physical space only (power nShapUV)
C------

C     !LOCAL VARIABLES:
C     == Local variables ==
      INTEGER bi,bj,k,i,j,n
      _RS hFacZ(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RS r_hFacZ(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL hDiv(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL vort3(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
#ifdef ALLOW_AUTODIFF_TAMC
      INTEGER kkey
#endif
CEOP

#ifdef ALLOW_AUTODIFF_TAMC
CADJ INIT loctape_shapfilt_bibj_k = COMMON, nSx*nSy*Nr
#endif
      IF (nShapUV.GT.0 .AND. Shap_uvtau.GT.0.) THEN

        IF (useCubedSphereExchange) THEN
C-      need to initialise hDiv for MOM_VI_DEL2UV(call FILL_CS_CORNER_TR_RL)
          DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
            hDiv(i,j) = 0. _d 0
           ENDDO
          ENDDO
        ENDIF

        DO bj=myByLo(myThid),myByHi(myThid)
         DO bi=myBxLo(myThid),myBxHi(myThid)
          DO k=1,kSize
           DO j=1-OLy,sNy+OLy
            DO i=1-OLx,sNx+OLx
             tmpFldU(i,j,k,bi,bj)=uFld(i,j,k,bi,bj)
     &                *_maskW(i,j,k,bi,bj)
             tmpFldV(i,j,k,bi,bj)=vFld(i,j,k,bi,bj)
     &                *_maskS(i,j,k,bi,bj)
            ENDDO
           ENDDO
          ENDDO
         ENDDO
        ENDDO

c---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C--   [d_xx+d_yy]^n tmpFld

       DO n=1,nShapUV

        IF ( MOD(n,2).EQ.1 .OR. Shap_alwaysExchUV ) THEN
          CALL EXCH_UV_3D_RL( tmpFldU,tmpFldV, .TRUE., kSize, myThid )
        ENDIF

        DO bj=myByLo(myThid),myByHi(myThid)
         DO bi=myBxLo(myThid),myBxHi(myThid)
          DO k=1,kSize

#ifdef ALLOW_AUTODIFF_TAMC
C     This store uses a wrongly-sized tape and stores the same field
C     nShapUV times, but since this field does not change here, we
C     can do it like this and suppress the recomputation warning
           kkey = k + (bi-1 + (bj-1)*nSx) * Nr
CADJ STORE hFacZ = loctape_shapfilt_bibj_k, key = kkey
#endif
           IF ( n.LE.nShapUVPhys .OR.
     &          n.GT.nShapUV-nShapUVPhys )
     &     CALL MOM_CALC_HFACZ(bi,bj,k,hFacZ,r_hFacZ,myThid)

C-    [d_xx+d_yy] tmpFld
         IF (n.LE.nShapUVPhys) THEN
           CALL MOM_CALC_HDIV(bi,bj,k,2,
     I                    tmpFldU(1-OLx,1-OLy,k,bi,bj),
     I                    tmpFldV(1-OLx,1-OLy,k,bi,bj),
     &                    hDiv,myThid)
#ifdef USE_SHAP_CALC_VORTICITY
           CALL SHAP_FILT_RELVORT3(bi,bj,k,
     I                    tmpFldU(1-OLx,1-OLy,k,bi,bj),
     I                    tmpFldV(1-OLx,1-OLy,k,bi,bj),
     &                    hFacZ,vort3,myThid)
#else
           CALL MOM_CALC_RELVORT3(bi,bj,k,
     I                    tmpFldU(1-OLx,1-OLy,k,bi,bj),
     I                    tmpFldV(1-OLx,1-OLy,k,bi,bj),
     &                    hFacZ,vort3,myThid)
#endif
         ELSE
C-    replace Physical calc Div & Vort by computational one :
           DO j=1-OLy,sNy+OLy-1
            DO i=1-OLx,sNx+OLx-1
             hDiv(i,j)=(tmpFldU(i+1,j,k,bi,bj)-tmpFldU(i,j,k,bi,bj))
     &                +(tmpFldV(i,j+1,k,bi,bj)-tmpFldV(i,j,k,bi,bj))
            ENDDO
           ENDDO
           CALL SHAP_FILT_COMPUTVORT(
     I                    tmpFldU(1-OLx,1-OLy,k,bi,bj),
     I                    tmpFldV(1-OLx,1-OLy,k,bi,bj),
     O                    vort3,
     I                    k,bi,bj,myThid)
         ENDIF

c---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

         IF (n.GT.nShapUV-nShapUVPhys) THEN
           IF (Shap_uvLength.LT.0.) THEN
             DO j=1-OLy,sNy+OLy-1
              DO i=1-OLx,sNx+OLx-1
                hDiv(i,j) = hDiv(i,j) * rA(i,j,bi,bj)
              ENDDO
             ENDDO
             DO j=2-OLy,sNy+OLy
              DO i=2-OLx,sNx+OLx
                vort3(i,j)= vort3(i,j)*rAz(i,j,bi,bj)
              ENDDO
             ENDDO
           ENDIF
           CALL MOM_VI_DEL2UV(
     I                    bi,bj,k,hDiv,vort3,hFacZ,
     O                    tmpFldU(1-OLx,1-OLy,k,bi,bj),
     O                    tmpFldV(1-OLx,1-OLy,k,bi,bj),
     I                    myThid)
           IF (Shap_uvLength.LT.0.) THEN
            DO j=2-OLy,sNy+OLy-1
             DO i=2-OLx,sNx+OLx-1
              tmpFldU(i,j,k,bi,bj) = -0.125 _d 0*tmpFldU(i,j,k,bi,bj)
     &                                          *_maskW(i,j,k,bi,bj)
              tmpFldV(i,j,k,bi,bj) = -0.125 _d 0*tmpFldV(i,j,k,bi,bj)
     &                                          *_maskS(i,j,k,bi,bj)
             ENDDO
            ENDDO
           ELSEIF (Shap_uvLength.EQ.0.) THEN
            DO j=2-OLy,sNy+OLy-1
             DO i=2-OLx,sNx+OLx-1
              tmpFldU(i,j,k,bi,bj) = -0.125 _d 0*tmpFldU(i,j,k,bi,bj)
     &                            *rAw(i,j,bi,bj)*_maskW(i,j,k,bi,bj)
              tmpFldV(i,j,k,bi,bj) = -0.125 _d 0*tmpFldV(i,j,k,bi,bj)
     &                            *rAs(i,j,bi,bj)*_maskS(i,j,k,bi,bj)
             ENDDO
            ENDDO
           ELSE
            DO j=2-OLy,sNy+OLy-1
             DO i=2-OLx,sNx+OLx-1
              tmpFldU(i,j,k,bi,bj) = -0.125 _d 0*tmpFldU(i,j,k,bi,bj)
     &               *Shap_uvLength*Shap_uvLength*_maskW(i,j,k,bi,bj)
              tmpFldV(i,j,k,bi,bj) = -0.125 _d 0*tmpFldV(i,j,k,bi,bj)
     &               *Shap_uvLength*Shap_uvLength*_maskS(i,j,k,bi,bj)
             ENDDO
            ENDDO
           ENDIF
         ELSE
C-       replace derivatives in physical space of Div & Vort by computational ones:
#ifndef ALLOW_AUTODIFF
           IF ( .NOT.Shap_alwaysExchUV
     &          .AND. useCubedSphereExchange ) THEN
C          to compute d/dx(hDiv), fill corners with appropriate values:
             CALL FILL_CS_CORNER_TR_RL( 1, .FALSE.,
     &                                  hDiv, bi,bj, myThid )
           ENDIF
#endif
           DO j=2-OLy,sNy+OLy-1
            DO i=2-OLx,sNx+OLx-1
             tmpFldU(i,j,k,bi,bj) = -0.125 _d 0*
     &                   ( (hDiv(i,j) - hDiv(i-1,j))
     &                    -(vort3(i,j+1)-vort3(i,j))
     &                   )*maskW(i,j,k,bi,bj)
            ENDDO
           ENDDO
#ifndef ALLOW_AUTODIFF
           IF ( .NOT.Shap_alwaysExchUV
     &          .AND. useCubedSphereExchange ) THEN
C          to compute d/dy(hDiv), fill corners with appropriate values:
             CALL FILL_CS_CORNER_TR_RL( 2, .FALSE.,
     &                                  hDiv, bi,bj, myThid )
           ENDIF
#endif
           DO j=2-OLy,sNy+OLy-1
            DO i=2-OLx,sNx+OLx-1
             tmpFldV(i,j,k,bi,bj) = -0.125 _d 0*
     &                   ( (hDiv(i,j) - hDiv(i,j-1))
     &                    +(vort3(i+1,j)-vort3(i,j))
     &                   )*maskS(i,j,k,bi,bj)
            ENDDO
           ENDDO

         ENDIF

C end loops  k / bi / bj
          ENDDO
         ENDDO
        ENDDO
C end loop n=1,nShapUV
       ENDDO

c---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C      F <-  [1 - (d_xx+d_yy)^n *deltaT/tau].F
       DO bj=myByLo(myThid),myByHi(myThid)
        DO bi=myBxLo(myThid),myBxHi(myThid)
         DO k=1,kSize
          DO j=1,sNy
           DO i=1,sNx+1
            uFld(i,j,k,bi,bj)=uFld(i,j,k,bi,bj)
     &                  -tmpFldU(i,j,k,bi,bj)*deltaTMom/Shap_uvtau
            tmpFldU(i,j,k,bi,bj)= -tmpFldU(i,j,k,bi,bj)/Shap_uvtau
           ENDDO
          ENDDO
          DO j=1,sNy+1
           DO i=1,sNx
            vFld(i,j,k,bi,bj)=vFld(i,j,k,bi,bj)
     &                  -tmpFldV(i,j,k,bi,bj)*deltaTMom/Shap_uvtau
            tmpFldV(i,j,k,bi,bj)= -tmpFldV(i,j,k,bi,bj)/Shap_uvtau
           ENDDO
          ENDDO
         ENDDO
        ENDDO
       ENDDO

       IF ( ( OLx.LE.2 .OR. OLy.LE.2 ) .AND.
     &       MOD(nShapUV,2).EQ.0 .AND. .NOT.Shap_alwaysExchUV )
     &  CALL EXCH_UV_3D_RL( uFld, vFld, .TRUE., kSize, myThid )

      ENDIF
#endif /* ALLOW_SHAP_FILT */

      RETURN
      END

module OAD_regular_cp

  implicit none

  private :: cp_file_number, cp_open

  public :: cp_io_unit, cp_init, cp_write_open, cp_read_open, cp_close, cp_fNumber

  integer :: cp_file_number, cp_io_unit

  interface cp_init
     module procedure init_i
  end interface

  interface cp_open
     module procedure open_i
  end interface

  interface cp_write_open
     module procedure write_open_i
     module procedure write_openX_i
  end interface

  interface cp_read_open
     module procedure read_open_i
     module procedure read_openX_i
  end interface

  interface cp_close
     module procedure close_i
  end interface

  interface cp_findunit
     module procedure findunit_i
  end interface
  
contains

  subroutine init_i
    implicit none
    cp_file_number=1
  end subroutine

  subroutine write_open_i()
    implicit none
    call cp_open()
!    print *, 'writing ', cp_file_number
    cp_file_number=cp_file_number+1
  end subroutine 

  subroutine write_openX_i(X)
    implicit none
    integer X
    cp_file_number=X
!    print *, 'writing ', cp_file_number
    call cp_open()
  end subroutine 

  subroutine read_open_i()
    implicit none
    cp_file_number=cp_file_number-1
!    print *, 'reading ', cp_file_number
    call cp_open()
  end subroutine 

  subroutine read_openX_i(X)
    implicit none
    integer X
    cp_file_number=X
!    print *, 'reading ', cp_file_number
    call cp_open()
  end subroutine 

  subroutine open_i()
    implicit none



    integer rank, mpirc
    character*128 fname ! file name
    ! get unit
    rank=0
    call cp_findunit()
!    print *, 'OAD: opening CP file ', cp_file_number
    ! construct the file name



    write(fname,'(A,I3.3,A,I5.5)') 'oad_reg_cp.',rank,'.',cp_file_number
    open( UNIT=cp_io_unit,FILE=TRIM(fname),FORM='unformatted',STATUS='UNKNOWN' )
    !open( UNIT=cp_io_unit,FILE=TRIM(fname),FORM='formatted',STATUS='UNKNOWN' )
  end subroutine 

  subroutine close_i()
    implicit none
    close( UNIT=cp_io_unit)
  end subroutine

  subroutine findunit_i()
    ! returns a valid, unused unit number for Fortran I/O
    ! the routine stops the program if an error occurs in the process
    ! of searching the I/O channels.
    implicit none
    ! Local
    integer ii
    logical op
    integer ios
    character*(1024) msgbuf
    ! Sweep through a valid range of unit numbers
    cp_io_unit=-1
    do ii=9,999
       if (cp_io_unit.eq.-1) then
          inquire(unit=ii,iostat=ios,opened=op)
          if (ios.ne.0) then
             write(msgbuf,'(a,i2.2)')  'OAD_regular_cp:findunit_i: inquiring unit number = ',ii
             print *, msgBuf
             write(msgbuf,'(a)') 'OAD_regular_cp:findunit_i: inquire statement failed!'
             print *, msgBuf
             stop 'ABNORMAL END: S/R OAD_regular_cp:findunit_i'
          endif
          if (.NOT. op) then
             cp_io_unit=ii
          end if
       end if
    end do
    ! Was there an available unit number
    if (cp_io_unit.eq.-1) then
       write(msgbuf,'(a)')  'OAD_regular_cp:findunit_i: could not find an available unit number!'
       print *, msgBuf
       stop 'ABNORMAL END: S/R OAD_regular_cp:findunit_i'
    endif
  end subroutine

  function cp_fNumber()
    integer cp_fNumber
    cp_fNumber=cp_file_number
  end function 

end module 

#include "EXF_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

CBOP
C     !ROUTINE: EXF_GETFFIELD_START
C     !INTERFACE:
       SUBROUTINE EXF_GETFFIELD_START(
     I                useYearlyFields, pkg_name, fld_name,
     I                fld_period, fld_startdate1, fld_startdate2,
     U                fld_start_time, errCount,
     I                myThid )

C !DESCRIPTION: \bv
C  *==========================================================*
C  | SUBROUTINE EXF_GETFFIELD_START
C  | o get forcing-field starting-time (in secs);
C  |   distinguish between using Yearly-Fields or not.
C  *==========================================================*
C \ev

C !USES:
      IMPLICIT NONE
C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
c#include "cal.h"
#include "PARAMS.h"

C !INPUT/OUTPUT PARAMETERS:
C     useYearlyFields :: select if using EXF Yearly-fields or not
C     pkg_name        :: package name from which this S/R is called
C     fld_name        :: field short name (to print mesg)
C     fld_period      :: time period (in sec) between 2 reccords
C     fld_startdate1  :: field starting date (YYYYMMDD)
C     fld_startdate2  :: field starting date (HHMMSS)
C     fld_start_time  :: corresponding starting time (in sec) for this field
C     errCount        :: error counter
C     myThid          :: My Thread Id number
      LOGICAL useYearlyFields
      CHARACTER*(*) pkg_name
      CHARACTER*(*) fld_name
      _RL fld_period
      INTEGER fld_startdate1, fld_startdate2
      _RL fld_start_time
      INTEGER errCount
      INTEGER myThid

C !FUNCTIONS:

C !LOCAL VARIABLES:
C     msgBuf          :: Informational/error message buffer
      CHARACTER*(MAX_LEN_MBUF) msgBuf
#ifdef ALLOW_CAL
      INTEGER date_array(4), difftime(4), yearStartDate(4)
      INTEGER gcm_startdate(4)
#endif /* ALLOW_CAL */
CEOP

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C--   Set default start_time (in case not using Calendar)
      IF ( fld_start_time.EQ.UNSET_RL ) THEN
        fld_start_time = 0.
      ELSEIF ( useCAL ) THEN
C-    Report inconsistent setting:
        WRITE(msgBuf,'(8A)') 'S/R EXF_GETFFIELD_START: ',
     &   'start-time for ', pkg_name, '-field "', fld_name,
     &    '" = ', fld_name, 'StartTime'
        CALL PRINT_ERROR( msgBuf, myThid )
c       WRITE(msgBuf,'(5A)') 'S/R EXF_GETFFIELD_START: ',
        WRITE(msgBuf,'(5A)') '    ',
     &   'is computed (useCAL) from startdate1 & date2',
     &   ' and cannot be set (in data.', pkg_name, ')'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF

C--   Convert start-date to start_time (case using Calendar)
      IF ( useCAL .AND. (fld_period.GT.0. .OR.
     &     (fld_period.EQ.-1. .AND. .NOT.useYearlyFields)) ) THEN
#ifdef ALLOW_CAL
        CALL CAL_FULLDATE( fld_startdate1, fld_startdate2,
     &                     date_array, myThid )
        IF ( useYearlyFields ) THEN
          yearStartDate(1) = INT(date_array(1)/10000.) * 10000 + 101
          yearStartDate(2) = 0
          yearStartDate(3) = date_array(3)
          yearStartDate(4) = date_array(4)
          CALL cal_TimePassed( yearStartDate, date_array, difftime,
     I                         myThid )
          CALL cal_ToSeconds ( difftime, fld_start_time, myThid )
        ELSE
C--   with "cal.h" header file:
c         CALL cal_TimePassed(modelstartdate,date_array,difftime,myThid)
c         CALL cal_ToSeconds ( difftime, fld_start_time, myThid )
c         fld_start_time = modelstart + fld_start_time
C--   with "PARAMS.h" header file:
          CALL cal_getdate( nIter0, startTime, gcm_startdate, myThid )
          CALL cal_TimePassed( gcm_startdate, date_array, difftime,
     I                         myThid )
          CALL cal_ToSeconds ( difftime, fld_start_time, myThid )
          fld_start_time = startTime  + fld_start_time
        ENDIF
#endif /* ALLOW_CAL */
      ELSEIF ( .NOT.useCAL ) THEN

       IF ( ( fld_startdate1.NE.0 .OR. fld_startdate2.NE.0 )
     &      .AND. fld_period.GT.0. ) THEN
C-    Report inconsistent setting:
        IF ( fld_startdate1.NE.0 ) THEN
         WRITE(msgBuf,'(8A)') 'S/R EXF_GETFFIELD_START: ',
     &   'start-date for ', pkg_name, '-field "', fld_name,
     &   '" = ', fld_name, 'startdate1'
         CALL PRINT_ERROR( msgBuf, myThid )
        ENDIF
        IF ( fld_startdate2.NE.0 ) THEN
         WRITE(msgBuf,'(8A)') 'S/R EXF_GETFFIELD_START: ',
     &   'start-date for ', pkg_name, '-field "', fld_name,
     &   '" = ', fld_name, 'startdate2'
         CALL PRINT_ERROR( msgBuf, myThid )
        ENDIF
c       WRITE(msgBuf,'(5A)') 'S/R EXF_GETFFIELD_START: ',
        WRITE(msgBuf,'(5A)') '    ',
     &   'is not allowed (in data.', pkg_name, ')',
     &   ' when pkg/cal is not used (useCAL=F)'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
       ENDIF

       IF ( fld_period.LT.0. ) THEN
        WRITE(msgBuf,'(6A)') 'S/R EXF_GETFFIELD_START: ',
     &   'Invalid record period for ', pkg_name, '-field "',
     &   fld_name, '":'
        CALL PRINT_ERROR( msgBuf, myThid )
c       WRITE(msgBuf,'(3A,F14.2,A)') 'S/R EXF_GETFFIELD_START: ',
        WRITE(msgBuf,'(3A,F14.2,A)') '    ',
     &   fld_name, 'period =', fld_period,
     &   ' but should be >= 0 when useCAL=F'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
       ENDIF

C-    end if fld_period > 0
      ENDIF

      RETURN
      END

#include "STIC_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C !ROUTINE: STIC_INIT_VARIA

C !INTERFACE:
      SUBROUTINE STIC_INIT_VARIA( myThid )

C     !DESCRIPTION:
C     Initialize STEEP_ICECAVITY variables

C     !USES:
      IMPLICIT NONE
C     == Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "STIC.h"
#ifdef ALLOW_SHELFICE
# include "SHELFICE.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     myThid ::  my Thread Id number
      INTEGER myThid
CEOP

C     !LOCAL VARIABLES:
      INTEGER i,j,k,bi,bj

      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)

C     Initialize arrays in common blocks :
C     3-dim.
        DO k=1,Nr
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           icfHeatFlux      (i,j,k,bi,bj) = 0. _d 0
           icfFreshWaterFlux(i,j,k,bi,bj) = 0. _d 0
           stic_gT    (i,j,k,bi,bj) = 0. _d 0
           stic_gS    (i,j,k,bi,bj) = 0. _d 0
          ENDDO
         ENDDO
        ENDDO

C     2-dim.
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          sticfHeatFlux      (i,j,bi,bj) = 0. _d 0
          sticfFreshWaterFlux(i,j,bi,bj) = 0. _d 0
         ENDDO
        ENDDO

C- end bi,bj loops
       ENDDO
      ENDDO

#ifdef ALLOW_SHITRANSCOEFF_3D
      IF ( .NOT. SHELFICEuseGammaFrict ) THEN
       IF ( SHELFICETransCoeffTFile .NE. ' ' ) THEN
        CALL READ_FLD_XYZ_RL( SHELFICETransCoeffTFile, ' ',
     &                       shiTransCoeffT3d, 0, myThid )
        _EXCH_XYZ_RL( shiTransCoeffT3d, myThid )
        DO bj = myByLo(myThid), myByHi(myThid)
         DO bi = myBxLo(myThid), myBxHi(myThid)
          DO k = 1, Nr
           DO j = 1-OLy, sNy+OLy
            DO i = 1-OLx, sNx+OLx
             shiTransCoeffS3d(i,j,k,bi,bj) = SHELFICEsaltToHeatRatio *
     &            shiTransCoeffT3d(i,j,k,bi,bj)
            ENDDO
           ENDDO
          ENDDO
         ENDDO
        ENDDO
       ELSE
C     set coefficients to constant values
        DO bj = myByLo(myThid), myByHi(myThid)
         DO bi = myBxLo(myThid), myBxHi(myThid)
          DO k = 1, Nr
           DO j = 1-OLy, sNy+OLy
            DO i = 1-OLx, sNx+OLx
             shiTransCoeffT3d(i,j,k,bi,bj) = SHELFICEheatTransCoeff
             shiTransCoeffS3d(i,j,k,bi,bj) = SHELFICEsaltTransCoeff
            ENDDO
           ENDDO
          ENDDO
         ENDDO
        ENDDO
       ENDIF
      ENDIF
#endif

      RETURN
      END

#include "CPP_OPTIONS.h"

CBOP
C     !ROUTINE: DIAGS_PHI_RLOW
C     !INTERFACE:
      SUBROUTINE DIAGS_PHI_RLOW(
     I                       k, bi, bj, iMin,iMax, jMin,jMax,
     I                       phiHydF, phiHydC, alphRho,
     I                       myTime, myIter, myThid)
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R DIAGS_PHI_RLOW
C     | o Diagnose Phi-Hydrostatic at r-lower boundary
C     |   = bottom pressure (ocean in z-coord) ;
C     |   = sea surface elevation (ocean in p-coord) ;
C     |   = height at the top of atmosphere (in p-coord) ;
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "SURFACE.h"
#include "DYNVARS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine Arguments ==
C     bi,bj      :: tile index
C     iMin,iMax,jMin,jMax :: Loop counters
C     phiHydF    :: hydrostatic potential anomaly at middle between
C                   2 centers k & k+1 (interface k+1)
C     phiHydC    :: hydrostatic potential anomaly at cell center
C                  (atmos: =Geopotential ; ocean-z: =Pressure/rho)
C     alphRho    :: Density (z-coord) or specific volume (p-coord)
C     myTime     :: Current time
C     myIter     :: Current iteration number
C     myThid     :: my Thread Id number
      INTEGER k, bi,bj, iMin,iMax, jMin,jMax
      _RL phiHydF(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL phiHydC(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL alphRho(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL myTime
      INTEGER myIter, myThid

#ifdef INCLUDE_PHIHYD_CALCULATION_CODE

C     !LOCAL VARIABLES:
C     == Local variables ==
C     i,j :: Loop counters
      INTEGER i,j
      _RL ddRloc, ratioRm, ratioRp
#ifdef NONLIN_FRSURF
      _RL facP, dPhiRef
#endif /* NONLIN_FRSURF */
CEOP

      IF ( usingZCoords ) THEN

C----- Compute bottom pressure deviation from gravity*rho0*H
C      Start from phiHyd at the (bottom) tracer point and add Del_h*g*rho_prime
C      with Del_h = distance from the bottom up to tracer point

C--    Initialise to zero (otherwise phi0surf accumulate over land)
       IF ( k.EQ.1 ) THEN
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
            phiHydLow(i,j,bi,bj) = 0. _d 0
          ENDDO
         ENDDO
       ENDIF

       IF (integr_GeoPot.EQ.1) THEN
C  --  Finite Volume Form

         DO j=jMin,jMax
          DO i=iMin,iMax
           IF ( k .EQ. kLowC(i,j,bi,bj) ) THEN
             ddRloc = rC(k)-R_low(i,j,bi,bj)
             phiHydLow(i,j,bi,bj) = phiHydC(i,j)
     &        + ddRloc*gravFacC(k)*gravity*alphRho(i,j)*recip_rhoConst
           ENDIF
          ENDDO
         ENDDO

       ELSE
C  --  Finite Difference Form

         ratioRm = oneRL
         ratioRp = oneRL
         IF (k.GT.1 ) ratioRm = halfRL*drC(k)/(rF(k)-rC(k))
         IF (k.LT.Nr) ratioRp = halfRL*drC(k+1)/(rC(k)-rF(k+1))
         ratioRm = ratioRm*gravFacF(k)
         ratioRp = ratioRp*gravFacF(k+1)

         DO j=jMin,jMax
          DO i=iMin,iMax
           IF ( k .EQ. kLowC(i,j,bi,bj) ) THEN
             ddRloc = rC(k)-R_low(i,j,bi,bj)
             phiHydLow(i,j,bi,bj) = phiHydC(i,j)
     &                  +( MIN(zeroRL,ddRloc)*ratioRm
     &                    +MAX(zeroRL,ddRloc)*ratioRp
     &                   )*gravity*alphRho(i,j)*recip_rhoConst
           ENDIF
          ENDDO
         ENDDO

C  --  end if integr_GeoPot = ...
       ENDIF

C  -- end usingZCoords
      ENDIF

      IF ( k.EQ.Nr ) THEN
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C  --  last level (bottom): rescale (r*) and add surface contribution

       IF ( usingPCoords ) THEN
C  -- P coordinate : Phi(R_low) is simply at the top :
        DO j=jMin,jMax
         DO i=iMin,iMax
           phiHydLow(i,j,bi,bj) = phiHydF(i,j)
         ENDDO
        ENDDO
       ENDIF

#ifdef NONLIN_FRSURF
c      IF ( select_rStar.GE.2 .AND. nonlinFreeSurf.GE.4 ) THEN
       IF ( select_rStar.GE.1 .AND. nonlinFreeSurf.GE.4 ) THEN
C-    Integral of b.dr = rStarFac * Integral of b.dr* :
        IF ( fluidIsAir ) THEN
C-     Consistent with Phi'= Integr[ theta'.dPi ] :
         DO j=jMin,jMax
          DO i=iMin,iMax
           facP = pStarFacK(i,j,bi,bj)
           dPhiRef = phiRef(2*k+1) - gravity*topoZ(i,j,bi,bj)
     &                             - phi0surf(i,j,bi,bj)
           phiHydLow(i,j,bi,bj) =
     &              phiHydLow(i,j,bi,bj)*facP
     &            + MAX( dPhiRef, zeroRL )*( facP - 1. _d 0 )
     &            + phi0surf(i,j,bi,bj)
          ENDDO
         ENDDO
        ELSEIF ( usingPCoords ) THEN
C- Note: dPhiRef*(rStarFacC -1) = 1/rho*PSo*((eta+PSo)/PSo -1) = Bo_surf*etaN
C     so that this expression is the same as before (same as in "ELSE" block below)
         DO j=jMin,jMax
          DO i=iMin,iMax
           dPhiRef = ( Ro_surf(i,j,bi,bj) - R_low(i,j,bi,bj) )
     &              *recip_rhoConst
           phiHydLow(i,j,bi,bj) =
     &              phiHydLow(i,j,bi,bj)*rStarFacC(i,j,bi,bj)
     &            + dPhiRef*( rStarFacC(i,j,bi,bj) - 1. _d 0 )
     &            + phi0surf(i,j,bi,bj)
          ENDDO
         ENDDO
        ELSE
C- Note: dPhiRef*(rStarFacC -1) = g*H*((eta+H)/H -1) = Bo_surf*etaN
C     so that this expression is the same as before (same as in "ELSE" block below)
         DO j=jMin,jMax
          DO i=iMin,iMax
           dPhiRef = ( Ro_surf(i,j,bi,bj)-R_low(i,j,bi,bj) )
     &              *gravity
           phiHydLow(i,j,bi,bj) =
     &              phiHydLow(i,j,bi,bj)*rStarFacC(i,j,bi,bj)
     &            + dPhiRef*( rStarFacC(i,j,bi,bj) - 1. _d 0 )
     &            + phi0surf(i,j,bi,bj)
          ENDDO
         ENDDO
        ENDIF
       ELSE
#else /* NONLIN_FRSURF */
       IF ( .TRUE. ) THEN
#endif /* NONLIN_FRSURF */

         DO j=jMin,jMax
          DO i=iMin,iMax
           phiHydLow(i,j,bi,bj) = phiHydLow(i,j,bi,bj)
     &            + Bo_surf(i,j,bi,bj)*etaN(i,j,bi,bj)
     &            + phi0surf(i,j,bi,bj)
          ENDDO
         ENDDO
       ENDIF

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C  -- end if k=Nr.
      ENDIF

#endif /* INCLUDE_PHIHYD_CALCULATION_CODE */

      RETURN
      END

#include "ctrparam.h"
#include "ATM2D_OPTIONS.h"

C     !INTERFACE:
      SUBROUTINE SUM_THSICE_OUT( myThid )
C     *==========================================================*
C     | Sum output from temp seaice step for passing to ocean.   |
C     *==========================================================*
        IMPLICIT NONE

#include "ATMSIZE.h"
#include "SIZE.h"
#include "GRID.h"
#include "EEPARAMS.h"

C     === Global SeaIce Variables ===
#include "THSICE_VARS.h"

C     === Atmos/Ocean/Seaice Interface Variables ===
#include "ATM2D_VARS.h"


C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
C     myThid - Thread no. that called this routine.
      INTEGER myThid

C     LOCAL VARIABLES:
      INTEGER i,j

      DO j=1, sNy
        DO i=1,sNx

          IF (iceMask(i,j,1,1) .NE. 0. _d 0) THEN
            sum_sHeat(i,j) = sum_sHeat(i,j) + sHeating(i,j,1,1)
            sum_flxCnB(i,j)= sum_flxCnB(i,j) + flxCndBt(i,j,1,1)

C Add contribution of SW passing through ice
            sum_solarnet(i,j)= sum_solarnet(i,j)
     &                  + icFlxSW(i,j,1,1)*iceMask(i,j,1,1)
C zero out icFlxSw or it will be double counted in thsice_step_fwd
            icFlxSW(i,j,1,1)= 0. _d 0

          ENDIF

        ENDDO
      ENDDO


      RETURN
      END

#include "GAD_OPTIONS.h"

CBOP
C     !ROUTINE: GAD_DIAGNOSTICS_INIT
C     !INTERFACE:
      SUBROUTINE GAD_DIAGNOSTICS_INIT( myThid )
C     !DESCRIPTION:
C     Routine to initialize Generic Advection/Diffusion diagnostics

C     !USES:
      IMPLICIT NONE
C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GAD.h"

C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
C     myThid   :: My Thread Id. number
      INTEGER myThid
CEOP

#ifdef ALLOW_DIAGNOSTICS
C     ! FUNCTIONS:
      CHARACTER*4  GAD_DIAG_SUFX
      CHARACTER*16 DIAGS_MK_UNITS
      CHARACTER*80 DIAGS_MK_TITLE
      EXTERNAL     GAD_DIAG_SUFX
      EXTERNAL     DIAGS_MK_UNITS
      EXTERNAL     DIAGS_MK_TITLE

C     !LOCAL VARIABLES:
C     === Local variables ===
C     msgBuf   :: Informational/error meesage buffer
c     CHARACTER*(MAX_LEN_MBUF) msgBuf

      INTEGER        diagNum
      INTEGER        diagMate
      CHARACTER*8    diagName
      CHARACTER*16   diagCode
      CHARACTER*16   diagUnits
      CHARACTER*(80) diagTitle

      CHARACTER*10  flxUnits, trUnits
      CHARACTER*12  locName
      CHARACTER*4   diagSufx

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C--   Add diagnostics to the (long) list
       IF ( usingPCoords ) THEN
         flxUnits = '.Pa.m^2/s '
       ELSE
         flxUnits = '.m^3/s    '
       ENDIF

C-     add diagnostics of advective & diffusive flux of Temp :
       IF ( fluidIsAir ) THEN
         trUnits = 'K'
       ELSE
         trUnits = 'degC'
       ENDIF
       diagUnits = DIAGS_MK_UNITS( trUnits//flxUnits, myThid )
       diagSufx = GAD_DIAG_SUFX( GAD_TEMPERATURE, myThid )

C-     Advective flux:
       diagName  = 'ADVr'//diagSufx
       diagTitle = 'Vertical   Advective Flux of Pot.Temperature'
       diagCode  = 'WM      LR      '
       CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I      diagName, diagCode, diagUnits, diagTitle, 0, myThid )
       diagName  = 'ADVx'//diagSufx
       diagTitle = 'Zonal      Advective Flux of Pot.Temperature'
       diagCode  = 'UU      MR      '
       diagMate  = diagNum + 2
       CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I      diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )
       diagName  = 'ADVy'//diagSufx
       diagTitle = 'Meridional Advective Flux of Pot.Temperature'
       diagCode  = 'VV      MR      '
       diagMate  = diagNum
       CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I      diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )
C-     Diffusive flux:
       diagName  = 'DFrE'//diagSufx
       diagTitle = 'Vertical Diffusive Flux of Pot.Temperature'
     &           //' (Explicit part)'
       diagCode  = 'WM      LR      '
       CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I      diagName, diagCode, diagUnits, diagTitle, 0, myThid )
       diagName  = 'DFxE'//diagSufx
       diagTitle = 'Zonal      Diffusive Flux of Pot.Temperature'
       diagCode  = 'UU      MR      '
       diagMate  = diagNum + 2
       CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I      diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )
       diagName  = 'DFyE'//diagSufx
       diagTitle = 'Meridional Diffusive Flux of Pot.Temperature'
       diagCode  = 'VV      MR      '
       diagMate  = diagNum
       CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I      diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

       diagName  = 'DFrI'//diagSufx
       diagTitle = 'Vertical Diffusive Flux of Pot.Temperature'
     &           //' (Implicit part)'
       diagCode  = 'WM      LR      '
       CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I      diagName, diagCode, diagUnits, diagTitle, 0, myThid )

#ifdef GAD_ALLOW_TS_SOM_ADV
       diagUnits = DIAGS_MK_UNITS( trUnits, myThid )

       diagName  = 'SM_x'//diagSufx
       diagTitle = 'Pot.Temp.   1rst Order Moment Sx'
       diagCode  = 'UM      MR      '
       diagMate  = diagNum + 2
       CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I      diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )
       diagName  = 'SM_y'//diagSufx
       diagTitle = 'Pot.Temp.   1rst Order Moment Sy'
       diagCode  = 'VM      MR      '
       diagMate  = diagNum
       CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I      diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )
       diagName  = 'SM_z'//diagSufx
       diagTitle = 'Pot.Temp.   1rst Order Moment Sz'
       diagCode  = 'SM      MR      '
       CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I      diagName, diagCode, diagUnits, diagTitle, 0, myThid )

       diagName  = 'SMxx'//diagSufx
       diagTitle = 'Pot.Temp.   2nd Order Moment Sxx'
       diagCode  = 'UM      MR      '
       diagMate  = diagNum + 2
       CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I      diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )
       diagName  = 'SMyy'//diagSufx
       diagTitle = 'Pot.Temp.   2nd Order Moment Syy'
       diagCode  = 'VM      MR      '
       diagMate  = diagNum
       CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I      diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )
       diagName  = 'SMzz'//diagSufx
       diagTitle = 'Pot.Temp.   2nd Order Moment Szz'
       diagCode  = 'SM      MR      '
       CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I      diagName, diagCode, diagUnits, diagTitle, 0, myThid )

       diagName  = 'SMxy'//diagSufx
       diagTitle = 'Pot.Temp.   2nd Order Moment Sxy'
       diagCode  = 'SM      MR      '
       CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I      diagName, diagCode, diagUnits, diagTitle, 0, myThid )
       diagName  = 'SMxz'//diagSufx
       diagTitle = 'Pot.Temp.   2nd Order Moment Sxz'
       diagCode  = 'UM      MR      '
       diagMate  = diagNum + 2
       CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I      diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )
       diagName  = 'SMyz'//diagSufx
       diagTitle = 'Pot.Temp.   2nd Order Moment Syz'
       diagCode  = 'VM      MR      '
       diagMate  = diagNum
       CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I      diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

       diagUnits = DIAGS_MK_UNITS( '('//trUnits//')^2', myThid )
       diagName  = 'SM_v'//diagSufx
       diagTitle = 'Pot.Temp.   sub-grid variance'
       diagCode  = 'SM P    MR      '
       CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I      diagName, diagCode, diagUnits, diagTitle, 0, myThid )
#endif /* GAD_ALLOW_TS_SOM_ADV */

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C-     add diagnostics of advective & diffusive flux of Salt :
       IF ( fluidIsAir ) THEN
         locName = 'Water-Vapor '
         IF ( useAIM ) THEN
           trUnits = 'g/kg'
         ELSE
           trUnits = 'kg/kg'
         ENDIF
       ELSE
         locName = 'Salinity    '
         trUnits = 'g/kg'
       ENDIF
       diagUnits = DIAGS_MK_UNITS( trUnits//flxUnits, myThid )
       diagSufx = GAD_DIAG_SUFX( GAD_SALINITY, myThid )

C-     Advective flux:
       diagName  = 'ADVr'//diagSufx
       diagTitle = 'Vertical   Advective Flux of '//locName
       diagCode  = 'WM      LR      '
       CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I      diagName, diagCode, diagUnits, diagTitle, 0, myThid )
       diagName  = 'ADVx'//diagSufx
       diagTitle = 'Zonal      Advective Flux of '//locName
       diagCode  = 'UU      MR      '
       diagMate  = diagNum + 2
       CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I      diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )
       diagName  = 'ADVy'//diagSufx
       diagTitle = 'Meridional Advective Flux of '//locName
       diagCode  = 'VV      MR      '
       diagMate  = diagNum
       CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I      diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )
C-     Diffusive flux:
       diagName  = 'DFrE'//diagSufx
       diagTitle = 'Vertical Diffusive Flux of '//locName
     &           // '(Explicit part)'
       diagCode  = 'WM      LR      '
       CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I      diagName, diagCode, diagUnits, diagTitle, 0, myThid )
       diagName  = 'DFxE'//diagSufx
       diagTitle = 'Zonal      Diffusive Flux of '//locName
       diagCode  = 'UU      MR      '
       diagMate  = diagNum + 2
       CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I      diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )
       diagName  = 'DFyE'//diagSufx
       diagTitle = 'Meridional Diffusive Flux of '//locName
       diagCode  = 'VV      MR      '
       diagMate  = diagNum
       CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I      diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

       diagName  = 'DFrI'//diagSufx
       diagTitle = 'Vertical Diffusive Flux of '//locName
     &           //'(Implicit part)'
       diagCode  = 'WM      LR      '
       CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I      diagName, diagCode, diagUnits, diagTitle, 0, myThid )

       diagName  = 'SALTFILL'
       diagTitle = 'Filling of Negative Values of '//locName
       diagCode  = 'SM      MR      '
       CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I      diagName, diagCode, diagUnits, diagTitle, 0, myThid )

#ifdef GAD_ALLOW_TS_SOM_ADV

       diagUnits = DIAGS_MK_UNITS( trUnits, myThid )

       diagName  = 'SM_x'//diagSufx
       diagTitle = locName//'1rst Order Moment Sx'
       diagCode  = 'UM      MR      '
       diagMate  = diagNum + 2
       CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I      diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )
       diagName  = 'SM_y'//diagSufx
       diagTitle = locName//'1rst Order Moment Sy'
       diagCode  = 'VM      MR      '
       diagMate  = diagNum
       CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I      diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )
       diagName  = 'SM_z'//diagSufx
       diagTitle = locName//'1rst Order Moment Sz'
       diagCode  = 'SM      MR      '
       CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I      diagName, diagCode, diagUnits, diagTitle, 0, myThid )

       diagName  = 'SMxx'//diagSufx
       diagTitle = locName//'2nd Order Moment Sxx'
       diagCode  = 'UM      MR      '
       diagMate  = diagNum + 2
       CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I      diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )
       diagName  = 'SMyy'//diagSufx
       diagTitle = locName//'2nd Order Moment Syy'
       diagCode  = 'VM      MR      '
       diagMate  = diagNum
       CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I      diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )
       diagName  = 'SMzz'//diagSufx
       diagTitle = locName//'2nd Order Moment Szz'
       diagCode  = 'SM      MR      '
       CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I      diagName, diagCode, diagUnits, diagTitle, 0, myThid )

       diagName  = 'SMxy'//diagSufx
       diagTitle = locName//'2nd Order Moment Sxy'
       diagCode  = 'SM      MR      '
       CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I      diagName, diagCode, diagUnits, diagTitle, 0, myThid )
       diagName  = 'SMxz'//diagSufx
       diagTitle = locName//'2nd Order Moment Sxz'
       diagCode  = 'UM      MR      '
       diagMate  = diagNum + 2
       CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I      diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )
       diagName  = 'SMyz'//diagSufx
       diagTitle = locName//'2nd Order Moment Syz'
       diagCode  = 'VM      MR      '
       diagMate  = diagNum
       CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I      diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

       diagUnits = DIAGS_MK_UNITS( '('//trUnits//')^2', myThid )
       diagName  = 'SM_v'//diagSufx
       diagTitle = locName//'sub-grid variance'
       diagCode  = 'SM P    MR      '
       CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I      diagName, diagCode, diagUnits, diagTitle, 0, myThid )
#endif /* GAD_ALLOW_TS_SOM_ADV */

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#endif /* ALLOW_DIAGNOSTICS */

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

CBOP 0
C     !ROUTINE: GAD_DIAG_SUFX

C     !INTERFACE:
      CHARACTER*4 FUNCTION GAD_DIAG_SUFX( tracerId, myThid )

C     !DESCRIPTION:
C     *==========================================================*
C     | FUNCTION GAD_DIAG_SUFX
C     | o Return diagnostic suffix (4 character long) for the
C     |   "tracerId" tracer (used to build diagnostic names).
C     *==========================================================*

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "GAD.h"
#ifdef ALLOW_PTRACERS
c#include "PARAMS.h"
# include "PTRACERS_SIZE.h"
# include "PTRACERS_PARAMS.h"
#endif /* ALLOW_PTRACERS */

C     !INPUT PARAMETERS:
C     tracerId   ::  tracer identifier
C     myThid     ::  my thread Id number
      INTEGER      tracerId
      INTEGER      myThid
CEOP

C     !LOCAL VARIABLES:

C--   Set diagnostic suffix (4 character long) for the "tracerId" tracer
      IF ( tracerId.EQ.GAD_TEMPERATURE ) THEN
        GAD_DIAG_SUFX = '_TH '
      ELSEIF( tracerId.EQ.GAD_SALINITY ) THEN
        GAD_DIAG_SUFX = '_SLT'
#ifdef ALLOW_PTRACERS
c     ELSEIF( usePTRACERS
c       .AND. tracerId.GE.GAD_TR1
      ELSEIF( tracerId.GE.GAD_TR1
     &  .AND. tracerId.LT.GAD_TR1+PTRACERS_num ) THEN
c       WRITE(GAD_DIAG_SUFX,'(A,A2)')
c    &                  'Tr', PTRACERS_ioLabel( tracerId+1-GAD_TR1 )
        GAD_DIAG_SUFX = 'Tr'//PTRACERS_ioLabel( tracerId+1-GAD_TR1 )
#endif /* ALLOW_PTRACERS */
      ELSE
        GAD_DIAG_SUFX = 'aaaa'
      ENDIF

      RETURN
      END

#include "AUTODIFF_OPTIONS.h"
#ifdef ALLOW_CTRL
# include "CTRL_OPTIONS.h"
#endif

      SUBROUTINE ADAUTODIFF_INADMODE_UNSET( myTime, myIter, myThid )
C     *==========================================================*
C     | SUBROUTINE ADAUTODIFF_INADMODE_UNSET
C     *==========================================================*

C     !USES:
      IMPLICIT NONE
C     == Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "AUTODIFF_PARAMS.h"
#ifdef ALLOW_SEAICE
#include "SEAICE_SIZE.h"
#include "SEAICE_PARAMS.h"
#endif
#ifdef ALLOW_CTRL
# include "CTRL_SIZE.h"
# include "CTRL.h"
#endif
#ifdef ALLOW_AUTODIFF_MONITOR
# ifdef ALLOW_DIAGNOSTICS
#  include "DIAGNOSTICS_P2SHARE.h"
# endif
#endif /* ALLOW_AUTODIFF_MONITOR */

C     !INPUT/OUTPUT PARAMETERS:
C     myTime    :: Current time in simulation
C     myIter    :: Current iteration number
C     myThid    :: my Thread Id number
      _RL     myTime
      INTEGER myIter
      INTEGER myThid

C     !LOCAL VARIABLES:
      CHARACTER*(MAX_LEN_MBUF) msgBuf

#ifdef ALLOW_AUTODIFF_MONITOR
# ifdef ALLOW_DIAGNOSTICS
      LOGICAL modelEnd
C --- Write the fields out here
      IF ( useDiag4AdjOutp ) THEN
C --- Grab modelEnd, necessary input for diagnostics routines
       modelEnd = myTime.EQ.startTime .OR. myIter.EQ.nIter0
       CALL TIMER_START('I/O (WRITE)        [ADJOINT LOOP]', myThid )
       CALL DIAGNOSTICS_WRITE_ADJ( modelEnd, myTime, myIter, myThid )
       CALL TIMER_STOP( 'I/O (WRITE)        [ADJOINT LOOP]', myThid )
      ENDIF
# endif /* ALLOW_DIAGNOSTICS */
#endif /* ALLOW_AUTODIFF_MONITOR */

      inAdMode  = .FALSE.

      useKPP    = useKPPinFwdMode
      useGMRedi = useGMRediInFwdMode
      useSEAICE = useSEAICEinFwdMode
      useGGL90    = useGGL90inFwdMode
      useSALT_PLUME    = useSALT_PLUMEinFwdMode
#ifdef ALLOW_SEAICE
      IF ( SEAICEuseFREEDRIFTswitchInAd ) THEN
        SEAICEuseFREEDRIFT = SEAICEuseFREEDRIFTinFwdMode
        SEAICEuseLSR       = .NOT.SEAICEuseFREEDRIFT
      ENDIF
      IF ( SEAICEuseDYNAMICSswitchInAd ) THEN
        SEAICEuseDYNAMICS  = SEAICEuseDYNAMICSinFwdMode
      ENDIF
      SEAICEadjMODE=0
C     SIregFacInFw = UNSET_RL by default, so we need to check this here
      IF ( SIregFacInFw .NE. UNSET_RL ) SINegFac = SIregFacInFw
#endif /* ALLOW_SEAICE */
      viscFacAdj=viscFacInFw

      IF ( debugLevel.GE.debLevC ) THEN
       WRITE(msgBuf,'(A,L5)')
     &      'S/R ADAUTODIFF_INADMODE_UNSET: useKPP    =', useKPP
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                     SQUEEZE_RIGHT, myThid )
       WRITE(msgBuf,'(A,L5)')
     &      'S/R ADAUTODIFF_INADMODE_UNSET: useGMRedi =', useGMRedi
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                     SQUEEZE_RIGHT, myThid )
       WRITE(msgBuf,'(A,L5)')
     &      'S/R ADAUTODIFF_INADMODE_UNSET: useSEAICE =', useSEAICE
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                     SQUEEZE_RIGHT, myThid )
       WRITE(msgBuf,'(A,L5)')
     &      'S/R ADAUTODIFF_INADMODE_UNSET: useGGL90    =', useGGL90
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                     SQUEEZE_RIGHT, myThid )
       WRITE(msgBuf,'(A,L5)')
     &      'S/R ADAUTODIFF_INADMODE_UNSET: useSALT_PLUME    =',
     &      useSALT_PLUME
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                     SQUEEZE_RIGHT, myThid )

       WRITE(msgBuf,'(A,1PE21.14)')
     &      'S/R ADAUTODIFF_INADMODE_UNSET: viscFacAdj =',viscFacAdj
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                     SQUEEZE_RIGHT, myThid )

#ifdef ALLOW_SEAICE
       IF ( SEAICEuseFREEDRIFTswitchInAd ) THEN
         WRITE(msgBuf,'(2A,L5)') 'S/R ADAUTODIFF_INADMODE_UNSET: ',
     &        'SEAICEuseFREEDRIFT =', SEAICEuseFREEDRIFT
         CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                       SQUEEZE_RIGHT, myThid )
         WRITE(msgBuf,'(2A,L5)') 'S/R ADAUTODIFF_INADMODE_UNSET: ',
     &        'SEAICEuseLSR       =', SEAICEuseLSR
         CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                       SQUEEZE_RIGHT, myThid )
       ENDIF
       IF ( SEAICEuseDYNAMICSswitchInAd ) THEN
         WRITE(msgBuf,'(2A,L5)') 'S/R ADAUTODIFF_INADMODE_UNSET: ',
     &        'SEAICEuseDYNAMICS =', SEAICEuseDYNAMICS
         CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                       SQUEEZE_RIGHT, myThid )
       ENDIF
       IF ( SEAICEapproxLevInAd.NE.0 ) THEN
         WRITE(msgBuf,'(2A,I2)') 'S/R ADAUTODIFF_INADMODE_UNSET: ',
     &        'SEAICEadjMODE =', SEAICEadjMODE
         CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                       SQUEEZE_RIGHT, myThid )
       ENDIF
#endif /* ALLOW_SEAICE */

      ENDIF

      RETURN
      END

#include "PACKAGES_CONFIG.h"
#include "CPP_OPTIONS.h"

CBOP
C     !ROUTINE: CALC_ADV_FLOW
C     !INTERFACE:
      SUBROUTINE CALC_ADV_FLOW(
     I                uFld, vFld, wFld,
     U                rTrans,
     O                uTrans, vTrans, rTransKp,
     O                maskUp, xA, yA,
     I                k, bi, bj, myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE CALC_ADV_FLOW
C     | o Calculate common data (such as volume flux) for use
C     |   by "Right hand side" subroutines.
C     *==========================================================*
C     | Here, we calculate terms or spatially varying factors
C     | that are used at various points in the "RHS" subroutines.
C     | This reduces the amount of total work, total memory
C     | and therefore execution time and is generally a good
C     | idea.
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     == GLobal variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     uFld     :: 3-D local copy of horizontal velocity, zonal  component
C     vFld     :: 3-D local copy of horizontal velocity, merid. component
C     wFld     :: 3-D local copy of vertical velocity
C     rTrans   :: Vertical volume transport through interface k
C     uTrans   :: Zonal volume transport through cell face
C     vTrans   :: Meridional volume transport through cell face
C     rTransKp :: Vertical volume transport through interface k+1
C     maskUp   :: Land/water mask for Wvel points (interface k)
C     xA       :: Tracer cell face area normal to X
C     yA       :: Tracer cell face area normal to X
C     k,bi,bj  :: vertical & tile indices for this calculation
C     myThid   :: my Thread Id. number

      _RL uFld  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL vFld  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL wFld  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL rTrans(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL uTrans(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL vTrans(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL rTransKp(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RS maskUp(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RS xA    (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RS yA    (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER k,bi,bj
      INTEGER myThid

C     !LOCAL VARIABLES:
C     == Local variables ==
C     i, j :: Loop counters
      INTEGER i,j
CEOP

C--   Calculate tracer cell face open areas
      DO j=1-OLy,sNy+OLy
       DO i=1-OLx,sNx+OLx
         xA(i,j) = _dyG(i,j,bi,bj)*deepFacC(k)
     &           *drF(k)*_hFacW(i,j,k,bi,bj)
         yA(i,j) = _dxG(i,j,bi,bj)*deepFacC(k)
     &           *drF(k)*_hFacS(i,j,k,bi,bj)
       ENDDO
      ENDDO

C--   copy previous rTrans (input) to output array rTransKp
      IF ( k.EQ.Nr ) THEN
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          rTransKp(i,j) = 0. _d 0
         ENDDO
        ENDDO
      ELSE
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
#ifdef ALLOW_AUTODIFF
C-    Re-compute vertical transport: this changes "rTrans" to be
C     an output only argument and therefore simplifies dependencies
          rTransKp(i,j) = wFld(i,j,k+1)*rA(i,j,bi,bj)
     &                  * maskC(i,j,k,bi,bj)*maskC(i,j,k+1,bi,bj)
     &                  * deepFac2F(k+1)*rhoFacF(k+1)
#else /* ALLOW_AUTODIFF */
C-    Copy rTrans value from previous call (i.e., k+1):
          rTransKp(i,j) = rTrans(i,j)
#endif /* ALLOW_AUTODIFF */
         ENDDO
        ENDDO
      ENDIF

C--   Calculate "volume transports" through tracer cell faces.
C     anelastic: scaled by rhoFacC (~ mass transport)
      DO j=1-OLy,sNy+OLy
       DO i=1-OLx,sNx+OLx
         uTrans(i,j) = uFld(i,j,k)*xA(i,j)*rhoFacC(k)
         vTrans(i,j) = vFld(i,j,k)*yA(i,j)*rhoFacC(k)
       ENDDO
      ENDDO

C--   Calculate vertical "volume transport" through tracer cell face
      IF (k.EQ.1) THEN
C-      Surface interface :
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
           maskUp(i,j) = 0. _d 0
           rTrans(i,j) = 0. _d 0
         ENDDO
        ENDDO
      ELSE
C-      Interior interface :
C       anelastic: rTrans is scaled by rhoFacF (~ mass transport)
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
           maskUp(i,j) = maskC(i,j,k-1,bi,bj)*maskC(i,j,k,bi,bj)
           rTrans(i,j) = wFld(i,j,k)*rA(i,j,bi,bj)*maskUp(i,j)
     &                              *deepFac2F(k)*rhoFacF(k)
         ENDDO
        ENDDO
      ENDIF

      RETURN
      END

#include "CPP_OPTIONS.h"

CBOP 0
C !ROUTINE: CPL_INIT_OCN_VARS

C !INTERFACE:
      SUBROUTINE CPL_INIT_OCN_VARS( msgUnit )

C !DESCRIPTION:
C     *==========================================================*
C     | SUBROUTINE CPL_INIT_OCN_VARS
C     | o Initialise to zero all OCNVARS.h arrays
C     *==========================================================*

C !USES:
      IMPLICIT NONE
C     == Global variables ==
#include "OCNSIZE.h"
#include "OCNVARS.h"
c#include "OCNIDS.h"

C !INPUT PARAMETERS:
C     msgUnit          :: log-file I/O unit
      INTEGER msgUnit

C !LOCAL VARIABLES:
C     i,j     :: loop index
      INTEGER i, j
CEOP

      WRITE(msgUnit,'(2A)') 'CPL_INIT_OCN_VARS: ',
     &                      'initialise all OCNVARS.h arrays'

      DO j=1,Ny_ocn
        DO i=1,Nx_ocn
          landMask_ocn   (i,j) = 0. _d 0
          OcMxlD_ocn     (i,j) = 0. _d 0
          SST_ocn        (i,j) = 0. _d 0
          SSS_ocn        (i,j) = 0. _d 0
          vSq_ocn        (i,j) = 0. _d 0
          fluxCO2_ocn    (i,j) = 0. _d 0
          atmSLPr_ocn    (i,j) = 0. _d 0
          HeatFlux_ocn   (i,j) = 0. _d 0
          qShortWave_ocn (i,j) = 0. _d 0
          TauX_ocn       (i,j) = 0. _d 0
          TauY_ocn       (i,j) = 0. _d 0
          FWFlux_ocn     (i,j) = 0. _d 0
          SaltFlx_ocn    (i,j) = 0. _d 0
          sIceMass_ocn   (i,j) = 0. _d 0
          saltPlmFlx_ocn (i,j) = 0. _d 0
          RunOff_ocn     (i,j) = 0. _d 0
          aCO2_ocn       (i,j) = 0. _d 0
          wSpeed_ocn     (i,j) = 0. _d 0
          sIceFrac_ocn   (i,j) = 0. _d 0
          sIceThick_ocn  (i,j) = 0. _d 0
          sIceSnowH_ocn  (i,j) = 0. _d 0
          sIceQ1_ocn     (i,j) = 0. _d 0
          sIceQ2_ocn     (i,j) = 0. _d 0
        ENDDO
      ENDDO

      RETURN
      END

#include "FIZHI_OPTIONS.h"

CBOP
C     !ROUTINE: FIZHI_DIAGNOSTICS_INIT
C     !INTERFACE:
      SUBROUTINE FIZHI_DIAGNOSTICS_INIT( myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE FIZHI_DIAGNOSTICS_INIT
C     | o Routine to initialize list of all available diagnostics
C     |   for FIZHI package
C     *==========================================================*
C     \ev
C     !USES:
      IMPLICIT NONE

C     === Global variables ===
#include "EEPARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
C     myThid ::  my Thread Id number
      INTEGER myThid
CEOP

#ifdef ALLOW_DIAGNOSTICS
C     !LOCAL VARIABLES:
C     === Local variables ===
C     diagNum   :: diagnostics number in the (long) list of available diag.
C     diagMate  :: diag. mate number in the (long) list of available diag.
C     diagName  :: local short name (8c) of a diagnostics
C     diagCode  :: local parser field with characteristics of the diagnostics
C              cf head of S/R DIAGNOSTICS_INIT_EARLY or DIAGNOSTICS_MAIN_INIT
C     diagUnits :: local string (16c): physical units of a diagnostic field
C     diagTitle :: local string (80c): description of field in diagnostic
      INTEGER       diagNum
      INTEGER       diagMate
      CHARACTER*8   diagName
      CHARACTER*16  diagCode
      CHARACTER*16  diagUnits
      CHARACTER*(80) diagTitle

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      diagName  = 'HFLUX   '
      diagTitle = 'Sensible Heat Flux (pos.upwrd)  (W/m^2)'
      diagUnits = 'watt/m2         '
      diagCode  = 'SM      L1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'EFLUX   '
      diagTitle = 'Latent   Heat Flux (pos.upwrd)  (W/m^2)'
      diagUnits = 'watt/m2         '
      diagCode  = 'SM      L1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'UFLUX   '
      diagTitle = 'Zonal Wind Surface Stress  (N/m^2)'
      diagUnits = 'N/m2            '
      diagCode  = 'UM      L1      '
      diagMate  = diagNum + 2
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

      diagName  = 'VFLUX   '
      diagTitle = 'Meridional Wind Surface Stress  (N/m^2)'
      diagUnits = 'N/m2            '
      diagCode  = 'VM      L1      '
      diagMate  = diagNum
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

      diagName  = 'QICE    '
      diagTitle = 'Heat Conduction through Sea-Ice  (W/m^2)'
      diagUnits = 'watt/m2         '
      diagCode  = 'SM      L1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'RADLWG  '
      diagTitle = 'Net Upward   Longwave Flux at the Ground  (W/m^2)'
      diagUnits = 'watt/m2         '
      diagCode  = 'SM      L1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'RADSWG  '
      diagTitle = 'Net Downward Shortwave Flux at the Ground  (W/m^2)'
      diagUnits = 'watt/m2         '
      diagCode  = 'SM      L1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'RI      '
      diagTitle = 'Richardson Number  (non-dimensional)'
      diagUnits = 'non-dimensional '
      diagCode  = 'SM      LL      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'CT      '
      diagTitle = 'Surface Drag Coef for Scalars (non-dimensional)'
      diagUnits = 'non-dimensional '
      diagCode  = 'SM      L1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'CU      '
      diagTitle = 'Surface Drag Coef for Winds (non-dimensional)'
      diagUnits = 'non-dimensional '
      diagCode  = 'SM      L1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'KM      '
      diagTitle = 'Eddy Diffusivity Coefficient for Momentum  (m^2/s)'
      diagUnits = 'm2/sec          '
      diagCode  = 'SM      LL      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'KH      '
      diagTitle = 'Eddy Diffusivity Coefficient for Scalars  (m^2/s)'
      diagUnits = 'm2/sec          '
      diagCode  = 'SM      LL      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'TURBU   '
      diagTitle = 'Zonal Wind Tendency from Turbulence  (m/s/day)'
      diagUnits = 'm/s/day         '
      diagCode  = 'UM      ML      '
      diagMate  = diagNum + 2
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

      diagName  = 'TURBV   '
      diagTitle = 'Meridional Wind Tendency from Turbulence  (m/s/day)'
      diagUnits = 'm/s/day         '
      diagCode  = 'VM      ML      '
      diagMate  = diagNum
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

      diagName  = 'TURBT   '
      diagTitle =
     &  'Temperature Tendency from Turbulence  (K/day)'
      diagUnits = 'K/day           '
      diagCode  = 'SM      ML      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'TURBQ   '
      diagTitle =
     &  'Specific Humidity Tendency from Turbulence  (g/kg/day)'
      diagUnits = 'gram/kg/day     '
      diagCode  = 'SM      ML      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'MOISTU  '
      diagTitle = 'Zonal Wind Tendency from Moist Proc  (m/s/day)'
      diagUnits = 'm/s/day         '
      diagCode  = 'UM      ML      '
      diagMate  = diagNum + 2
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

      diagName  = 'MOISTV  '
      diagTitle = 'Meridional Wind Tendency from Moist Proc  (m/s/day)'
      diagUnits = 'm/s/day         '
      diagCode  = 'VM      ML      '
      diagMate  = diagNum
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

      diagName  = 'MOISTT  '
      diagTitle =
     &  'Temperature Tendency due to Moist Processes  (K/day)'
      diagUnits = 'K/day           '
      diagCode  = 'SM      ML      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'MOISTQ  '
      diagTitle =
     &  'Specific Humidity Tendency due to Moist Processes  (g/kg/day)'
      diagUnits = 'gram/kg/day     '
      diagCode  = 'SM      ML      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'RADLW   '
      diagTitle =
     &  'Temperature Tendency due to Longwave Radiation  (K/day)'
      diagUnits = 'K/day           '
      diagCode  = 'SM      ML      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'RADSW   '
      diagTitle =
     &  'Temperature Tendency due to Shortwave Radiation  (K/day)'
      diagUnits = 'K/day           '
      diagCode  = 'SM      ML      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'PREACC  '
      diagTitle = 'Total Precipitation  (mm/day)'
      diagUnits = 'mm/day          '
      diagCode  = 'SM      L1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'PRECON  '
      diagTitle = 'Convective Precipitation  (mm/day)'
      diagUnits = 'mm/day          '
      diagCode  = 'SM      L1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'TUFLUX  '
      diagTitle = 'Turbulent Flux of Zonal Momentum  (N/m^2)'
      diagUnits = 'N/m2            '
      diagCode  = 'UM      LL      '
      diagMate  = diagNum + 2
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

      diagName  = 'TVFLUX  '
      diagTitle = 'Turbulent Flux of Meridional Momentum  (N/m^2)'
      diagUnits = 'N/m2            '
      diagCode  = 'VM      LL      '
      diagMate  = diagNum
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

      diagName  = 'TTFLUX  '
      diagTitle = 'Turbulent Flux of Sensible Heat  (W/m^2)'
      diagUnits = 'watt/m2         '
      diagCode  = 'SM      LL      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'TQFLUX  '
      diagTitle = 'Turbulent Flux of Latent Heat  (W/m^2)'
      diagUnits = 'watt/m2         '
      diagCode  = 'SM      LL      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'CN      '
      diagTitle = 'Neutral Drag Coefficient  (non-dimensional)'
      diagUnits = 'non-dimensional '
      diagCode  = 'SM      L1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'WINDS   '
      diagTitle = 'Surface Wind Speed  (m/s)'
      diagUnits = 'm/sec           '
      diagCode  = 'SM      L1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'DTSRF   '
      diagTitle = 'Air/Surface Virtual Temperature Difference  (deg K)'
      diagUnits = 'K               '
      diagCode  = 'SM      L1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'TGROUND '
      diagTitle = 'Ground Temperature  (deg K)'
      diagUnits = 'K               '
      diagCode  = 'SM      L1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'TS      '
      diagTitle = 'Surface Air Temperature  (deg K)'
      diagUnits = 'K               '
      diagCode  = 'SM      L1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'DTG     '
      diagTitle = 'Ground Temperature Adjustment (deg K)'
      diagUnits = 'K               '
      diagCode  = 'SM      L1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'QG      '
      diagTitle = 'Ground Specific Humidity  (g/kg)'
      diagUnits = 'gram/kg         '
      diagCode  = 'SM P    L1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'QS      '
      diagTitle = 'Saturation Surface Specific Humidity  (g/kg)'
      diagUnits = 'gram/kg         '
      diagCode  = 'SM P    L1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'TGRLW   '
      diagTitle = 'Ground Temperature used by LW Radiation  (deg K)'
      diagUnits = 'K               '
      diagCode  = 'SM      L1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'LWGUP   '
      diagTitle = 'Upward Longwave Radiation at the Ground  (W/m^2)'
      diagUnits = 'watt/m2         '
      diagCode  = 'SM      L1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'OLR     '
      diagTitle = 'Outgoing Longwave Radiation   (W/m^2)'
      diagUnits = 'watt/m2         '
      diagCode  = 'SM      U1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'OLRCLR  '
      diagTitle = 'Clear Sky Outgoing Longwave Radiation  (W/m^2)'
      diagUnits = 'watt/m2         '
      diagCode  = 'SM      U1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'LWGCLR  '
      diagTitle = 'Clear Sky Net Longwave Flux at the Ground  (W/m^2)'
      diagUnits = 'watt/m2         '
      diagCode  = 'SM      L1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'LWCLR   '
      diagTitle = 'Clear Sky Longwave Radiation Heating Rates  (K/day)'
      diagUnits = 'K/day           '
      diagCode  = 'SM      ML      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'TLW     '
      diagTitle = 'Temperature used by Radiation  (deg K)'
      diagUnits = 'K               '
      diagCode  = 'SM      ML      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'SHRAD   '
      diagTitle = 'Specific Humidity used by Radiation  (g/kg)'
      diagUnits = 'gram/kg         '
      diagCode  = 'SM P    ML      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'OZLW    '
      diagTitle =
     & 'Ozone mixing ratio used by Longwave Radiation (non-dimensional)'
      diagUnits = 'non-dimensional '
      diagCode  = 'SM      ML      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'CLDRAS  '
      diagTitle = 'Convective Cloud Fraction  (0-1)'
      diagUnits = '0-1             '
      diagCode  = 'SM P    ML      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'CLDTOT  '
      diagTitle = '3-D Total Cloud Fraction  (0-1)'
      diagUnits = '0-1             '
      diagCode  = 'SM P    ML      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'LWGDOWN '
      diagTitle = 'Downward Longwave Radiation at the Ground  (W/m^2)'
      diagUnits = 'watt/m2         '
      diagCode  = 'SM      L1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'GWDT    '
      diagTitle =
     &  'Temperature Tendency due to Gravity Wave Drag  (K/day)'
      diagUnits = 'K/day           '
      diagCode  = 'SM      ML      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'RADSWT  '
      diagTitle = 'Incident Shortwave Radiation at TOA (W/m^2)'
      diagUnits = 'watt/m2         '
      diagCode  = 'SM      U1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'TAUCLD  '
      diagTitle =
     &  'Counted Cloud Optical Depth (non-dimensional) per 100 mb'
      diagUnits = 'non-dimensional '
      diagCode  = 'SM  C   ML      '
      diagMate  = diagNum + 2
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

      diagName  = 'TAUCLDC '
      diagTitle = 'Cloud Optical Depth Counter'
      diagUnits = 'count           '
      diagCode  = 'SM  D   ML      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'CLDLOW  '
      diagTitle = 'Low-Level ( 1000-700 hPa) Cloud Fraction  (0-1)'
      diagUnits = '0-1             '
      diagCode  = 'SM P    M1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'EVAP    '
      diagTitle = 'Surface Evaporation  (mm/day)'
      diagUnits = 'mm/day          '
      diagCode  = 'SM      L1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'DPDT    '
      diagTitle = 'Surface Pressure Tendency  (hPa/day)'
      diagUnits = 'hPa/day         '
      diagCode  = 'SM      L1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'UAVE    '
      diagTitle = 'Average Zonal Wind (m/s)'
      diagUnits = 'm/s             '
      diagCode  = 'UM      ML      '
      diagMate  = diagNum + 2
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

      diagName  = 'VAVE    '
      diagTitle = 'Average Meridional Wind (m/s)'
      diagUnits = 'm/s             '
      diagCode  = 'VM      ML      '
      diagMate  = diagNum
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

      diagName  = 'TAVE    '
      diagTitle = 'Average Potential Temperature (K)'
      diagUnits = 'K               '
      diagCode  = 'SM      ML      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'QAVE    '
      diagTitle =
     &  'Average Specific Humidity (g/kg)'
      diagUnits = 'gram/kg         '
      diagCode  = 'SM      ML      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'OMEGA   '
      diagTitle = 'Vertical Velocity  (hPa/day)'
      diagUnits = 'hPa/day         '
      diagCode  = 'SM      ML      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'DUDT    '
      diagTitle = 'Total Zonal Wind Tendency  (m/s/day)'
      diagUnits = 'm/s/day         '
      diagCode  = 'UM      ML      '
      diagMate  = diagNum + 2
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

      diagName  = 'DVDT    '
      diagTitle = 'Total Meridional Wind Tendency  (m/s/day)'
      diagUnits = 'm/s/day         '
      diagCode  = 'VM      ML      '
      diagMate  = diagNum
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

      diagName  = 'DTDT    '
      diagTitle = 'Total Temperature Tendency  (K/day)'
      diagUnits = 'K/day           '
      diagCode  = 'SM      ML      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'DQDT    '
      diagTitle = 'Total Specific Humidity Tendency  (g/kg/day)'
      diagUnits = 'gram/kg/day     '
      diagCode  = 'SM      ML      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'VORT    '
      diagTitle = 'Relative Vorticity  (x10^-4  sec^-1)'
      diagUnits = '(e-4 sec-1)     '
      diagCode  = 'SM      ML      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'DTLS    '
      diagTitle =
     &  'Temperature Tendency due to Stratiform Processes  (K/day)'
      diagUnits = 'K/day           '
      diagCode  = 'SM      ML      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'DQLS    '
      diagTitle =
     & 'Specific Humidity Tendency from Stratiform Processes (g/kg/day)'
      diagUnits = 'gram/kg/day     '
      diagCode  = 'SM      ML      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'USTAR   '
      diagTitle = 'Friction Velocity  (m/s)'
      diagUnits = 'm/sec           '
      diagCode  = 'SM      L1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'Z0      '
      diagTitle = 'Surface Roughness Z0  (m)'
      diagUnits = 'm               '
      diagCode  = 'SM      L1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'FRQTRB  '
      diagTitle = 'Frequency of Turbulence  (0-1)'
      diagUnits = '0-1             '
      diagCode  = 'SM P    MM      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'PBL     '
      diagTitle = 'Estimated PBL Depth  (hPa)'
      diagUnits = 'hPa             '
      diagCode  = 'SM P    M1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'SWCLR   '
      diagTitle = 'Clear Sky Shortwave Heating Rates  (K/day)'
      diagUnits = 'K/day           '
      diagCode  = 'SM      ML      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'OSR     '
      diagTitle = 'Outgoing Shortwave Radiation  (W/m^2)'
      diagUnits = 'watt/m2         '
      diagCode  = 'SM      U1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'OSRCLR  '
      diagTitle = 'Clear Sky Outgoing Shortwave Radiation  (W/m^2)'
      diagUnits = 'watt/m2         '
      diagCode  = 'SM      U1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'CLDMAS  '
      diagTitle = 'Cloud Mass Flux  (g/m^2/sec)'
      diagUnits = 'g/m2/sec        '
      diagCode  = 'SM P    LL      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'UWND    '
      diagTitle = 'Time-Averaged Zonal Wind  (m/s)'
      diagUnits = 'm/sec           '
      diagCode  = 'UM      ML      '
      diagMate  = diagNum + 2
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

      diagName  = 'VWND    '
      diagTitle = 'Time-Averaged Meridional Wind  (m/s)'
      diagUnits = 'm/sec           '
      diagCode  = 'VM      ML      '
      diagMate  = diagNum
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

      diagName  = 'TMPU    '
      diagTitle = 'Time-Averaged Temperature  (deg K)'
      diagUnits = 'K               '
      diagCode  = 'SM      ML      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'SPHU    '
      diagTitle = 'Time-Averaged Specific Humidity  (g/kg)'
      diagUnits = 'gram/kg         '
      diagCode  = 'SM P    ML      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'RFT     '
      diagTitle =
     &  'Temperature Tendency due to Rayleigh Friction (K/day)'
      diagUnits = 'K/day           '
      diagCode  = 'SM      ML      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'PS      '
      diagTitle = 'Time-Averaged Surface Pressure  (hPa)'
      diagUnits = 'hPa             '
      diagCode  = 'SM      L1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'SLP     '
      diagTitle = 'Sea Level Pressure (mb)'
      diagUnits = 'mb              '
      diagCode  = 'SM      L1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'TKE     '
      diagTitle = 'Time-Averaged Turbulent Kinetic Energy  (m/s)^2'
      diagUnits = '(m/sec)2        '
      diagCode  = 'SM P    LL      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'SWGCLR  '
      diagTitle =
     &  'Clear Sky Net Downward SW Radiation at the Ground  (W/m^2)'
      diagUnits = 'watt/m2         '
      diagCode  = 'SM      L1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'PAVE    '
      diagTitle = 'Average Surface Pressure (hPa)'
      diagUnits = 'hPa/day         '
      diagCode  = 'SM      L1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'DIABU   '
      diagTitle =
     &  'Zonal Wind Tendency due to Diabatic Forcing  (m/s/day)'
      diagUnits = 'm/s/day         '
      diagCode  = 'UM      ML      '
      diagMate  = diagNum + 2
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

      diagName  = 'DIABV   '
      diagTitle =
     &  'Meridional Wind Tendency due to Diabatic Forcing  (m/s/day)'
      diagUnits = 'm/s/day         '
      diagCode  = 'VM      ML      '
      diagMate  = diagNum
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

      diagName  = 'DIABT   '
      diagTitle =
     &  'Temperature Tendency due to Diabatic Forcing  (K/day)'
      diagUnits = 'K/day           '
      diagCode  = 'SM      ML      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'DIABQ   '
      diagTitle =
     &  'Specific Humidity Tendency due to Diabatic Forcing  (g/kg/day)'
      diagUnits = 'gram/kg/day     '
      diagCode  = 'SM      ML      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'RFU     '
      diagTitle =
     &  'Zonal Wind Tendency due to Rayleigh Friction  (m/s/day)'
      diagUnits = 'm/s/day         '
      diagCode  = 'UM      ML      '
      diagMate  = diagNum + 2
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

      diagName  = 'RFV     '
      diagTitle =
     &  'Meridional Wind Tendency due to Rayleigh Friction  (m/s/day)'
      diagUnits = 'm/s/day         '
      diagCode  = 'VM      ML      '
      diagMate  = diagNum
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

      diagName  = 'GWDU    '
      diagTitle =
     &  'Zonal Wind Tendency due to Gravity Wave Drag  (m/s/day)'
      diagUnits = 'm/s/day         '
      diagCode  = 'UM      ML      '
      diagMate  = diagNum + 2
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

      diagName  = 'GWDV    '
      diagTitle =
     &  'Meridional Wind Tendency due to Gravity Wave Drag  (m/s/day)'
      diagUnits = 'm/s/day         '
      diagCode  = 'VM      ML      '
      diagMate  = diagNum
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

      diagName  = 'GWDUS   '
      diagTitle = 'Zonal Wind Gravity Wave Surface Stress (N/m^2)'
      diagUnits = 'N/m2            '
      diagCode  = 'UM      L1      '
      diagMate  = diagNum + 2
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

      diagName  = 'GWDVS   '
      diagTitle = 'Meridional Wind Gravity Wave Surface Stress (N/m^2)'
      diagUnits = 'N/m2            '
      diagCode  = 'VM      L1      '
      diagMate  = diagNum
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

      diagName  = 'GWDUT   '
      diagTitle = 'Zonal Wind Gravity Wave Stress at Model Top (N/m^2)'
      diagUnits = 'N/m2            '
      diagCode  = 'UM      U1      '
      diagMate  = diagNum + 2
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

      diagName  = 'GWDVT   '
      diagTitle =
     &  'Meridional Wind Gravity Wave Stress at Model Top (N/m^2)'
      diagUnits = 'N/m2            '
      diagCode  = 'VM      U1      '
      diagMate  = diagNum
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

      diagName = 'LZRAD   '
      diagTitle =
     &  'Estimated Cloud Liquid Water used in Radiation (mg/kg)'
      diagUnits = 'mg/kg           '
      diagCode = 'SM      ML      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName = 'VAVEUQ  '
      diagTitle = 'Vertically Averaged UWND*SPHU  (m/s g/kg)'
      diagUnits = 'm/s gram/kg     '
      diagCode  = 'UM      M1      '
      diagMate  = diagNum + 2
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

      diagName = 'VAVEVQ  '
      diagTitle = 'Vertically Averaged VWND*SPHU  (m/s g/kg)'
      diagUnits = 'm/s gram/kg     '
      diagCode  = 'VM      M1      '
      diagMate  = diagNum
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

      diagName = 'VAVEUT  '
      diagTitle = 'Vertically Averaged UWND*TMPU  (m/s deg K)'
      diagUnits = 'm/s K           '
      diagCode  = 'UM      M1      '
      diagMate  = diagNum + 2
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

      diagName = 'VAVEVT  '
      diagTitle = 'Vertically Averaged VWND*TMPU  (m/s deg K)'
      diagUnits = 'm/s K           '
      diagCode  = 'VM      M1      '
      diagMate  = diagNum
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

      diagName = 'CLDFRC  '
      diagTitle = '2-D Total Cloud Fraction  (0-1)'
      diagUnits = '0-1             '
      diagCode = 'SM P    M1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName = 'TPW     '
      diagTitle = 'Total Precipitable Water  (g/cm^2)'
      diagUnits = 'gram/cm2        '
      diagCode = 'SM P    M1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName = 'U2M     '
      diagTitle = 'Zonal Wind Interpolated to 2 Meters (m/s)'
      diagUnits = 'm/sec           '
      diagCode  = 'UM      M1      '
      diagMate  = diagNum + 2
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

      diagName = 'V2M     '
      diagTitle = 'Meridional Wind Interpolated to 2 Meters (m/s)'
      diagUnits = 'm/sec           '
      diagCode  = 'VM      M1      '
      diagMate  = diagNum
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

      diagName = 'T2M     '
      diagTitle = 'Temperature Interpolated to 2 Meters (deg K)'
      diagUnits = 'K               '
      diagCode = 'SM      M1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName = 'Q2M     '
      diagTitle = 'Specific Humidity Interpolated to 2 Meters (g/kg)'
      diagUnits = 'gram/kg         '
      diagCode = 'SM P    M1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName = 'U10M    '
      diagTitle = 'Zonal Wind Interpolated to 10 Meters (m/s)'
      diagUnits = 'm/sec           '
      diagCode  = 'UM      M1      '
      diagMate  = diagNum + 2
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

      diagName = 'V10M    '
      diagTitle = 'Meridional Wind Interpolated to 10 Meters (m/s)'
      diagUnits = 'm/sec           '
      diagCode  = 'VM      M1      '
      diagMate  = diagNum
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

      diagName = 'T10M    '
      diagTitle = 'Temperature Interpolated to 10 Meters (deg K)'
      diagUnits = 'K               '
      diagCode = 'SM      M1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName = 'Q10M    '
      diagTitle = 'Specific Humidity Interpolated to 10 Meters (g/kg)'
      diagUnits = 'gram/kg         '
      diagCode = 'SM P    M1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName = 'DTRAIN  '
      diagTitle = 'Detrainment Cloud Mass Flux  (g/m^2/sec)'
      diagUnits = 'g/m2/sec        '
      diagCode = 'SM P    LL      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName = 'QFILL   '
      diagTitle = 'Filling of Negative Specific Humidity (g/kg/day)'
      diagUnits = 'gram/kg/day     '
      diagCode = 'SM      ML      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName = 'VAVEQAVE'
      diagTitle = 'Vertically Averaged QAVE  (mm/day)'
      diagUnits = 'mm/day          '
      diagCode = 'SM      M1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName = 'VAVEQFIL'
      diagTitle = 'Vertically Averaged QFILL  (mm/day)'
      diagUnits = 'mm/day          '
      diagCode = 'SM P    L1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName = 'CLDMID  '
      diagTitle = 'Mid-Level (700-400 hPa) Cloud Fraction  (0-1)'
      diagUnits = '0-1             '
      diagCode = 'SM P    M1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName = 'CLDHI   '
      diagTitle = 'High-Level (above 400 hPa) Cloud Fraction  (0-1)'
      diagUnits = '0-1             '
      diagCode = 'SM P    M1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName = 'TAULOW  '
      diagTitle = 'Low-Level (1000-700 hPa) Optical Depth'
      diagUnits = 'non-dimensional '
      diagCode  = 'SM PC   M1      '
      diagMate  = diagNum + 2
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

      diagName = 'TAULOWC '
      diagTitle = 'Low-Level Optical Depth Counter'
      diagUnits = 'count           '
      diagCode = 'SM  D   M1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName = 'TAUMID  '
      diagTitle = 'Mid-Level (700-400 hPa) Optical Depth'
      diagUnits = 'non-dimensional '
      diagCode  = 'SM PC   M1      '
      diagMate  = diagNum + 2
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

      diagName = 'TAUMIDC '
      diagTitle = 'Mid-Level Optical Depth Counter'
      diagUnits = 'count           '
      diagCode = 'SM  D   M1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName = 'TAUHI   '
      diagTitle = 'High-Level (above 400 hPa) Optical Depth'
      diagUnits = 'non-dimensional '
      diagCode  = 'SM PC   M1      '
      diagMate  = diagNum + 2
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

      diagName = 'TAUHIC  '
      diagTitle = 'High-Level Optical Depth Counter'
      diagUnits = 'count           '
      diagCode = 'SM  D   M1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName = 'CLDNP   '
      diagTitle = 'Non-Precipitating Cloud Fraction  (0-1)'
      diagUnits = '0-1             '
      diagCode = 'SM      ML      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName = 'CLDPRS  '
      diagTitle = 'Cloud Top Pressure (when cloudy)  (hPa)'
      diagUnits = 'hPa             '
      diagCode  = 'SM PC   M1      '
      diagMate  = diagNum + 2
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

      diagName = 'CTPCNT  '
      diagTitle = 'Cloud Top Pressure Counter'
      diagUnits = 'count           '
      diagCode = 'SM  D   M1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName = 'CLDTMP  '
      diagTitle = 'Cloud Top Temperature (when cloudy)  (deg K)'
      diagUnits = 'K               '
      diagCode  = 'SM PC   M1      '
      diagMate  = diagNum + 2
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

      diagName = 'CTTCNT  '
      diagTitle = 'Cloud Top Temperature Counter'
      diagUnits = 'count           '
      diagCode = 'SM  D   M1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName = 'TCANOPY '
      diagTitle =
     &  'Skin Temperature of the Canopy/Soil (SST over water)  (deg K)'
      diagUnits = 'K               '
      diagCode = 'SM      L1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName = 'TDEEP   '
      diagTitle = 'Deep Soil Temperature  (deg K)'
      diagUnits = 'K               '
      diagCode = 'SM      L1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName = 'QCANOPY '
      diagTitle = 'Specific Humidity of the Canopy  (g/kg)'
      diagUnits = 'gram/kg         '
      diagCode = 'SM      L1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName = 'SMSHAL  '
      diagTitle =
     &  'Soil Moisture Field Capacity Fraction in Shallow (5 mm) Layer'
      diagUnits = '0-1             '
      diagCode = 'SM      L1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName = 'SMROOT  '
      diagTitle = 'Soil Moisture Field Capacity Fraction in Root Zone'
      diagUnits = '0-1             '
      diagCode = 'SM      L1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName = 'SMDEEP  '
      diagTitle =
     &  'Soil Moisture Field Capacity Fraction in Recharge Layer '
      diagUnits = '0-1             '
      diagCode = 'SM      L1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName = 'CAPACITY'
      diagTitle = 'Canopy Interception Reservoir (mm)'
      diagUnits = 'mm              '
      diagCode = 'SM      L1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName = 'SNOW    '
      diagTitle = 'Snow Depth (mm water equivalent)'
      diagUnits = 'mm water equiv  '
      diagCode = 'SM      L1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName = 'RAINCON '
      diagTitle = 'Convective Rainfall (liquid precipitate)  (mm/day)'
      diagUnits = 'mm/day          '
      diagCode = 'SM      L1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName = 'RAINLSP '
      diagTitle = 'Large-scale Rainfall (liquid precipitate)  (mm/day)'
      diagUnits = 'mm/day          '
      diagCode = 'SM      L1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName = 'SNOWFALL'
      diagTitle = 'Total Snowfall (solid precipitate)  (mm/day)'
      diagUnits = 'mm/day          '
      diagCode = 'SM      L1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName = 'RUNOFF  '
      diagTitle =
     &  'Water from precipitation not infiltrated into soil  (mm/s)'
      diagUnits = 'mm/sec          '
      diagCode = 'SM      L1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName = 'FWSOIL  '
      diagTitle = 'Rainwater Infiltration into top soil layer  (mm/s)'
      diagUnits = 'mm/sec          '
      diagCode = 'SM      L1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName = 'GDRAIN  '
      diagTitle =
     &  'Diffusion of Moisture across bottom of root zone  (mm/s)'
      diagUnits = 'mm/sec          '
      diagCode = 'SM      L1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName = 'SNOWMELT'
      diagTitle = 'Rate of Snow Melt  (mm/s)'
      diagUnits = 'mm/sec          '
      diagCode = 'SM      L1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName = 'ERESV   '
      diagTitle =
     &  'Latent Heat Flux from Canopy Interception Reservoir  (W/m^2)'
      diagUnits = 'watt/m2         '
      diagCode = 'SM      L1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName = 'ESOIL   '
      diagTitle = 'Latent Heat Flux from Bare Soil  (W/m^2)'
      diagUnits = 'watt/m2         '
      diagCode = 'SM      L1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName = 'EVEG    '
      diagTitle =
     & 'Latent Heat Flux (Transpiration) from Vegetated Surface (W/m^2)'
      diagUnits = 'watt/m2         '
      diagCode = 'SM      L1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName = 'ESNOW   '
      diagTitle = 'Latent Heat Flux from Snow Pack  (W/m^2)'
      diagUnits = 'watt/m2         '
      diagCode = 'SM      L1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName = 'PARDF   '
      diagTitle =
     &  'Diffuse-beam Photosynthetically Active Radiation  (W/m^2)'
      diagUnits = 'watt/m2         '
      diagCode = 'SM P    L1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName = 'PARDR   '
      diagTitle =
     &  'Direct-beam Photosynthetically Active Radiation  (W/m^2)'
      diagUnits = 'watt/m2         '
      diagCode = 'SM P    L1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName = 'LAI     '
      diagTitle = 'Leaf Area Index  (%)'
      diagUnits = 'percent         '
      diagCode = 'SM      L1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName = 'GREEN   '
      diagTitle = 'Green-ness Index  (%)'
      diagUnits = 'percent         '
      diagCode = 'SM      L1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName = 'DLWDTC  '
      diagTitle =
     &  'Derivative of Upward LW Radiation wrt TCANOPY (W/m^2 /deg K)'
      diagUnits = 'watt/m2/K       '
      diagCode = 'SM      L1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName = 'DHDTC   '
      diagTitle =
     &  'Derivative of Sensible Heat Flux wrt TCANOPY (W/m^2 /deg K)'
      diagUnits = 'watt/m2/K       '
      diagCode = 'SM      L1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName = 'DEDTC   '
      diagTitle =
     &  'Derivative of Latent Heat Flux wrt TCANOPY (W/m^2 /deg K)'
      diagUnits = 'watt/m2/K       '
      diagCode = 'SM      L1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName = 'VDTMOIST'
      diagTitle = 'Vertically Averaged MOISTT  (K/day)'
      diagUnits = 'K/day           '
      diagCode = 'SM      M1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName = 'VDTTURB '
      diagTitle = 'Vertically Averaged TURBT  (K/day)'
      diagUnits = 'K/day           '
      diagCode = 'SM      M1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName = 'VDTLWRAD'
      diagTitle = 'Vertically Averaged RADLW  (K/day)'
      diagUnits = 'K/day           '
      diagCode = 'SM      M1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName = 'VDTSWRAD'
      diagTitle = 'Vertically Averaged RADSW  (K/day)'
      diagUnits = 'K/day           '
      diagCode = 'SM      M1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName = 'VAVETAVE'
      diagTitle = 'Vertically Averaged TAVE  (K/day)'
      diagUnits = 'K/day           '
      diagCode = 'SM      M1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName = 'PSUBCLD '
      diagTitle = 'Pressure Thickness of the RAS Subcloud Layer (mb)'
      diagUnits = 'hPa             '
      diagCode  = 'SM PC   M1      '
      diagMate  = diagNum + 2
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

      diagName = 'PSUBCLDC'
      diagTitle =
     &  'Pressure Thickness of the RAS Subcloud Layer Counter'
      diagUnits = 'count           '
      diagCode = 'SM PD   M1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName = 'LCL     '
      diagTitle = 'Lifting Condensation Level (mb)                 '
      diagUnits = 'hPa             '
      diagCode = 'SM      L1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName = 'EVPOT   '
      diagTitle = 'Potential Evapotranspiration (W/m^2)'
      diagUnits = 'watt/m2         '
      diagCode = 'SM      L1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName = 'RHCHECK '
      diagTitle =
     & 'Net precip due to supersaturation above critical RH  (mm/day)'
      diagUnits = 'mm/day          '
      diagCode = 'SM      L1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName = 'DHDQA   '
      diagTitle =
     &  'Derivative of Sensible Heat wrt Canopy Humidity (W/m^2)'
      diagUnits = 'watt/m2         '
      diagCode = 'SM      L1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName = 'DEDQA   '
      diagTitle =
     &  'Derivative of Latent Heat wrt Canopy Humidity (W/m^2)'
      diagUnits = 'watt/m2         '
      diagCode = 'SM      L1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName = 'DTC     '
      diagTitle = 'Total Change in Canopy Temperature (deg/sec)'
      diagUnits = 'K/sec           '
      diagCode = 'SM      L1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName = 'DQC     '
      diagTitle = 'Change in Canopy Humidity (kg/kg/sec)'
      diagUnits = 'sec-1           '
      diagCode = 'SM      L1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName = 'TCDTC   '
      diagTitle =
     &  'Change in Canopy Temperature - Energy Term (deg/sec)'
      diagUnits = 'K/sec           '
      diagCode = 'SM      L1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName = 'RADDTC  '
      diagTitle =
     &  'Change in Canopy Temperature - Net Radiation Term (deg/sec)'
      diagUnits = 'K/sec           '
      diagCode = 'SM      L1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName = 'SENDDTC '
      diagTitle =
     &  'Change in Canopy Temperature - Sensible Heat Term (deg/sec)'
      diagUnits = 'K/sec           '
      diagCode = 'SM      L1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName = 'LATDTC  '
      diagTitle =
     &  'Change in Canopy Temperature - Latent Heat Term (deg/sec)'
      diagUnits = 'K/sec           '
      diagCode = 'SM      L1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName = 'TDDTC   '
      diagTitle =
     &  'Change in Canopy Temperature - Ground Temp Term (deg/sec)'
      diagUnits = 'K/sec           '
      diagCode = 'SM      L1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName = 'QCDTC   '
      diagTitle =
     &  'Change in Canopy Temperature - Humidity Term (deg/sec)'
      diagUnits = 'K/sec           '
      diagCode = 'SM      L1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName = 'TRBQLIQ '
      diagTitle = 'Cloud Liquid Water Generated in Turbulence (mg/kg)'
      diagUnits = 'mg/kg           '
      diagCode = 'SM      ML      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName = 'TRBFCC  '
      diagTitle = 'Cloud Fraction Generated in Turbulence (fraction)'
      diagUnits = '0-1             '
      diagCode = 'SM      ML      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName = 'ALBEDO  '
      diagTitle = 'Mean Surface Albedo (SW_Up/SW_Down)  0-1 '
      diagUnits = '0-1             '
      diagCode  = 'SM  C   L1      '
      diagMate  = diagNum + 2
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

      diagName = 'ALBEDOC '
      diagTitle = 'Surface Albedo Counter'
      diagUnits = 'count           '
      diagCode = 'SM  D   L1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName = 'ALBVISDR'
      diagTitle = 'Direct  Beam VIS Surface Albedo (0-1)   '
      diagUnits = '0-1             '
      diagCode = 'SM      L1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName = 'ALBVISDF'
      diagTitle = 'Diffuse Beam VIS Surface Albedo (0-1)   '
      diagUnits = '0-1             '
      diagCode = 'SM      L1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName = 'ALBNIRDR'
      diagTitle = 'Direct  Beam NIR Surface Albedo (0-1)   '
      diagUnits = '0-1             '
      diagCode = 'SM      L1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName = 'ALBNIRDF'
      diagTitle = 'Diffuse Beam NIR Surface Albedo (0-1)   '
      diagUnits = '0-1             '
      diagCode = 'SM      L1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName = 'TAUAVE  '
      diagTitle =
     &  'Averaged Cloud Optical Depth (non-dimensional) per 100 mb'
      diagUnits = 'non-dimensional '
      diagCode = 'SM      ML      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName = 'RHCHECKT'
      diagTitle =
     & 'Temperature Change due to humidity above critical RH  (K/day)'
      diagUnits = 'K/day           '
      diagCode = 'SM      ML      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName = 'RHCHECKQ'
      diagTitle =
     & 'Spec.Humid. Change due to humidity above critical RH (g/kg/day)'
      diagUnits = 'g/kg/day        '
      diagCode = 'SM      ML      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName = 'CLDLSP  '
      diagTitle = 'Large-Scale Cloud Fraction  (0-1)'
      diagUnits = '0-1             '
      diagCode = 'SM P    ML      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName = 'LZLOW   '
      diagTitle =
     &  'Vert integrated low-level (below 700mb) cloud water (mg/cm**2)'
      diagUnits = 'mg/cm2          '
      diagCode = 'SM P    L1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName = 'LZMID   '
      diagTitle =
     &  'Vert integrated mid-level (700-400mb) cloud water (mg/cm**2)'
      diagUnits = 'mg/cm2          '
      diagCode = 'SM P    L1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName = 'LZHI    '
      diagTitle =
     & 'Vert integrated high-level (above 400mb) cloud water (mg/cm**2)'
      diagUnits = 'mg/cm2          '
      diagCode = 'SM P    L1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName = 'LZTOT   '
      diagTitle =
     &  'Vertically integrated total suspended cloud water (mg/cm**2)'
      diagUnits = 'mg/cm2          '
      diagCode = 'SM P    L1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName = 'CAPE    '
      diagTitle = 'Convective Available Potential Energy'
      diagUnits = 'mb m2/sec2      '
      diagCode = 'SM P    L1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName = 'HSUBCL  '
      diagTitle = 'Moist Static Energy in RAS subcloud layer'
      diagUnits = 'm2/sec2         '
      diagCode = 'SM      L1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName = 'HSTAR   '
      diagTitle = 'Saturation Moist Static Energy'
      diagUnits = 'm2/sec2         '
      diagCode = 'SM      ML      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName = 'CONT    '
      diagTitle =
     &  'Temperature Tendency due to Convective  Precipitation (K/day)'
      diagUnits = 'K/day           '
      diagCode = 'SM      ML      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName = 'CONQ    '
      diagTitle =
     &  'Moisture Tendency due to Convective Precipitation (g/kg/day)'
      diagUnits = 'g/kg/day        '
      diagCode = 'SM      ML      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName = 'LST     '
      diagTitle =
     &  'Temperature Tendency due to Large Scale Precipitation (K/day)'
      diagUnits = 'K/day           '
      diagCode = 'SM      ML      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName = 'LSQ     '
      diagTitle =
     &  'Moisture Tendency due to Large Scale Precipitation (g/kg/day)'
      diagUnits = 'g/kg/day        '
      diagCode = 'SM      ML      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName = 'CONEVPT '
      diagTitle =
     &  'Temperature Tendency due to Conv Rain Re-evaporation (K/day)'
      diagUnits = 'K/day           '
      diagCode = 'SM      ML      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName = 'CONEVPQ '
      diagTitle =
     &  'Moisture Tendency due to Conv Rain Re-evaporation (g/kg/day)'
      diagUnits = 'g/kg/day        '
      diagCode = 'SM      ML      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName = 'LSEVPT  '
      diagTitle =
     &  'Temperature Tendency due to Large Scale Rain Re-evap (K/day)'
      diagUnits = 'K/day           '
      diagCode = 'SM      ML      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName = 'LSEVPQ  '
      diagTitle =
     &  'Moisture Tendency due to Large Scale Rain Re-evap (g/kg/day)'
      diagUnits = 'g/kg/day        '
      diagCode = 'SM      ML      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName = 'GWCUMID '
      diagTitle =
     &  'Mid-Lev Mean U-Wind for Gravity Wave Drag w/Clouds (m/sec)'
      diagUnits = 'm/sec           '
      diagCode  = 'UM      L1      '
      diagMate  = diagNum + 2
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

      diagName = 'GWCVMID '
      diagTitle =
     &  'Mid-Lev Mean V-Wind for Gravity Wave Drag w/Clouds (m/sec)'
      diagUnits = 'm/sec           '
      diagCode  = 'VM      L1      '
      diagMate  = diagNum
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

      diagName = 'CLDSTD  '
      diagTitle =
     & 'Mid-Lev Cloud Perturb Length for Gravity Wave Drag w/Clouds (m)'
      diagUnits = 'm               '
      diagCode = 'SM      L1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName = 'GWCUBAR '
      diagTitle =
     & 'Mid-Lev Perturb U-Wind for Gravity Wave Drag w/Clouds (m/sec)'
      diagUnits = 'm/sec           '
      diagCode  = 'UM      L1      '
      diagMate  = diagNum + 2
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

      diagName = 'GWCVBAR '
      diagTitle =
     & 'Mid-Lev Perturb V-Wind for Gravity Wave Drag w/Clouds (m/sec)'
      diagUnits = 'm/sec           '
      diagCode  = 'VM      L1      '
      diagMate  = diagNum
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

      diagName = 'GWCUS   '
      diagTitle =
     & 'Mid-Lev U-Wind Stress for Gravity Wave Drag w/Clouds (N/m^2)'
      diagUnits = 'N/m2            '
      diagCode  = 'UM      L1      '
      diagMate  = diagNum + 2
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

      diagName = 'GWCVS   '
      diagTitle =
     & 'Mid-Lev V-Wind Stress for Gravity Wave Drag w/Clouds (N/m^2)'
      diagUnits = 'N/m2            '
      diagCode  = 'VM      L1      '
      diagMate  = diagNum
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

      diagName = 'GWCU    '
      diagTitle =
     & 'U-Wind Tendency due to Gravity Wave Drag w/Clouds (m/s/day)'
      diagUnits = 'm/sec/day       '
      diagCode  = 'UM      ML      '
      diagMate  = diagNum + 2
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

      diagName = 'GWCV    '
      diagTitle =
     & 'V-Wind Tendency due to Gravity Wave Drag w/Clouds (m/s/day)'
      diagUnits = 'm/sec/day       '
      diagCode  = 'VM      ML      '
      diagMate  = diagNum
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

      diagName = 'PLALBEDO'
      diagTitle = 'Planetary Albedo (Fraction)'
      diagUnits = 'Fraction        '
      diagCode = 'SM      L1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName = 'FIZPRES '
      diagTitle = 'Pressures for Fizhi (mb)'
      diagUnits = 'mb  (hPa)       '
      diagCode = 'SM      ML      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'CORRDU  '
      diagTitle =
     &  'Zonal Wind Tendency Gridalt Correction Term (m/s/day)'
      diagUnits = 'm/s/day         '
      diagCode  = 'UM      ML      '
      diagMate  = diagNum + 2
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

      diagName  = 'CORRDV  '
      diagTitle =
     &  'Meridional Wind Tendency Gridalt Correction Term (m/s/day)'
      diagUnits = 'm/s/day         '
      diagCode  = 'VM      ML      '
      diagMate  = diagNum
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

      diagName  = 'CORRDT  '
      diagTitle =
     &  'Temperature Tendency Gridalt Correction Term (K/day)'
      diagUnits = 'K/day           '
      diagCode  = 'SM      ML      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'CORRDQ  '
      diagTitle =
     &  'Specific Humidity Tendency Gridalt Correction Term (g/kg/day)'
      diagUnits = 'gram/kg/day     '
      diagCode  = 'SM      ML      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'DIABUDYN'
      diagTitle =
     &  'Zonal Wind Tend due to Diab Forcing - Dyn Grid (m/s/day)'
      diagUnits = 'm/s/day         '
      diagCode  = 'UM      MR      '
      diagMate  = diagNum + 2
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

      diagName  = 'DIABVDYN'
      diagTitle =
     &  'Meridional Wind Tend due to Diab Forcing - Dyn Grid (m/s/day)'
      diagUnits = 'm/s/day         '
      diagCode  = 'VM      MR      '
      diagMate  = diagNum
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

      diagName  = 'DIABTDYN'
      diagTitle =
     &  'Temperature Tend due to Diab Forcing - Dyn Grid (K/day)'
      diagUnits = 'K/day           '
      diagCode  = 'SM      MR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'DIABQDYN'
      diagTitle =
     &  'Specific Hum Tend due to Diab Forcing - Dyn Grid (g/kg/day)'
      diagUnits = 'gram/kg/day     '
      diagCode  = 'SM      MR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'TENDUFIZ'
      diagTitle =
     &  'Total Zonal Wind Tend - Fizhi Grid (m/s/day)'
      diagUnits = 'm/s/day         '
      diagCode  = 'UM      ML      '
      diagMate  = diagNum + 2
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

      diagName  = 'TENDVFIZ'
      diagTitle =
     &  'Total Meridional Wind Tend - Fizhi Grid (m/s/day)'
      diagUnits = 'm/s/day         '
      diagCode  = 'VM      ML      '
      diagMate  = diagNum
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

      diagName  = 'TENDTFIZ'
      diagTitle =
     &  'Total Temperature Tend - Fizhi Grid (K/day)'
      diagUnits = 'K/day           '
      diagCode  = 'SM      ML      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'TENDQFIZ'
      diagTitle =
     &  'Total Specific Hum Tend - Fizhi Grid (g/kg/day)'
      diagUnits = 'gram/kg/day     '
      diagCode  = 'SM      ML      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

#endif /* ALLOW_DIAGNOSTICS */

      RETURN
      END

#include "CPP_OPTIONS.h"

C--   File plot_field.F: Routines for "formatted" I/O in the MITgcm UV 
C--                      implementation.
C--    Contents
C--    o plot_field_xyrs  - Writes a XY  _RS field
C--    o plot_field_xyrl  - Writes a XY  _RL field
C--    o plot_field_xyzrs - Writes a XYZ _RS field
C--    o plot_field_xyzrl - Writes a XYZ _RL field
      SUBROUTINE PLOT_FIELD_XYRS( 
     I                            fld, fldNam , myIter, myThid )

C     /==========================================================\
C     | SUBROUTINE PLOT_FIELD_XYRS                               |
C     | Print out an XY _RS field using text map.                |
C     |==========================================================|
C     | This routine references "numerical model" parameters like|
C     | like the integration time. It uses these to create a     |
C     | title for the field before calling a generic execution   |
C     | environment support routine.                             |
C     | This routine can also be edited to cause only some region|
C     | of a field to be printed by default, or every other      |
C     | point etc..                                              |
C     | Other plot formats can also be substituted here.         |
C     | _RS is usually REAL*4                                    |
C     \==========================================================/
      IMPLICIT NONE

#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"

C     == Routine arguments ==
C     fld - Field to plot
C     fldNam - Name of field
C     myIter - Iteration number for plot
C     myThid - Thread id of thread instance calling plot_field
      _RS fld(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      CHARACTER*(*) fldNam
      INTEGER myThid
      INTEGER myIter

C     == Local variables ==
      CHARACTER*(MAX_LEN_MBUF) fldTitle
      INTEGER iStart, iEnd, iStride
      INTEGER jStart, jEnd, jStride
      INTEGER kStart, kEnd, kStride
      INTEGER biStart, biEnd, biStride
      INTEGER bjStart, bjEnd, bjStride

C     Temp for per tile plot looping
      INTEGER bi ,bj

C--   To get around synchronisation and multi-threaded I/O issues
C--   thread 1 will do all the writes.
      _BARRIER
      IF ( myThid .EQ. 1 ) THEN
C--    Form name for identifying "plot"
       IF ( myIter .GE. 0 ) THEN
        WRITE(fldTitle,'(A,A,A,I10)') 
     &  '// Field ', fldNam, ' at iteration ',
     &  myIter
       ELSE
        WRITE(fldTitle,'(A,A)') '// Field ', fldNam
       ENDIF
C--    Do "plot" using textual contour map "execution environment" routine
C      Substitute other plotting utilities here!
       DO bj=1,nSy
        DO bi=1,nSx
         iStart   =  1-OLx
         iEnd     =  sNx+OLx
         iStride  =  1
         jStart   =  sNy+OLy
         jEnd     =  1-OLy
         jStride  = -1
         kStart   =  1
         kEnd     =  1
         kStride  =  1
         biStart  =  bi
         biEnd    =  bi
         biStride =  1
         bjStart  =  bj
         bjEnd    =  bj   
         bjStride = -1
         WRITE(fldTitle,'(A,A,A,I6,A,I10)') 
     &   '// Field ', fldNam, 
     &   ' tile ',  bi,
     &   ' at iteration ',  myIter
         CALL PRINT_MAPRS(
     I          fld, fldTitle, PRINT_MAP_XY,
     I           1-OLx,sNx+OLx,1-OLy,sNy+OLy,1,1,  nSx,  nSy,
     I           iStart,   iEnd,  iStride,
     I           jStart,   jEnd,  jStride,
     I           kStart,   kEnd,  kStride,
     I          biStart,  biEnd, biStride,
     I          bjStart,  bjEnd, bjStride )
        ENDDO
       ENDDO
      ENDIF
      _BARRIER

      RETURN
      END
      SUBROUTINE PLOT_FIELD_XYRL( 
     I                            fld, fldNam , myIter, myThid )

C     /==========================================================\
C     | SUBROUTINE PLOT_FIELD_XYRL                               |
C     | Print out an XY _RL field using text map.                |
C     |==========================================================|
C     | This routine references "numerical model" parameters like|
C     | like the integration time. It uses these to create a     |
C     | title for the field before calling a generic execution   |
C     | environment support routine.                             |
C     | This routine can also be edited to cause only some region|
C     | of a field to be printed by default, or every other      |
C     | point etc..                                              |
C     | Other plot formats can also be substituted here.         |
C     | _RL is usually REAL*8                                    |
C     \==========================================================/
      IMPLICIT NONE

#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"

C     == Routine arguments ==
C     fld - Field to plot
C     fldNam - Name of field
C     myIter - Iteration number for plot
C     myThid - Thread id of thread instance calling plot_field
      _RL fld(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      CHARACTER*(*) fldNam
      INTEGER myThid
      INTEGER myIter

C     == Local variables ==
      CHARACTER*(MAX_LEN_MBUF) fldTitle
      INTEGER iStart, iEnd, iStride
      INTEGER jStart, jEnd, jStride
      INTEGER kStart, kEnd, kStride
      INTEGER biStart, biEnd, biStride
      INTEGER bjStart, bjEnd, bjStride

C     Temps for plot that loops over tiles
      INTEGER bi, bj

C--   To get around synchronisation and multi-threaded I/O issues
C--   thread 1 will do all the writes.
      _BARRIER
      IF ( myThid .EQ. 1 ) THEN
C--    Form name for identifying "plot"
       IF ( myIter .GE. 0 ) THEN
        WRITE(fldTitle,'(A,A,A,I10)') 
     &  '// Field ', fldNam, ' at iteration ',
     &  myIter
       ELSE
        WRITE(fldTitle,'(A,A)') '// Field ', fldNam
       ENDIF
C--    Do "plot" using textual contour map "execution environment" routine
C      Substitute other plotting utilities here!
       DO bj=1,nSy
        DO bi=1,nSx
         iStart   =  1-OLx
         iEnd     =  sNx+OLx
         iStride  =  1
         jStart   =  sNy+OLy
         jEnd     =  1-OLy
         jStride  = -1
         kStart   =  1
         kEnd     =  1
         kStride  =  1
         biStart  =  1
         biEnd    =  bi
         biStride =  1
         bjStart  =  bj
         bjEnd    =  1    
         bjStride = -1
         WRITE(fldTitle,'(A,A,A,I6,A,I10)') 
     &   '// Field ', fldNam, 
     &   ' tile ',  bi,
     &   ' at iteration ',  myIter
         CALL PRINT_MAPRL(
     I          fld, fldTitle, PRINT_MAP_XY,
     I         1-OLx,sNx+OLx,1-OLy,sNy+OLy,1,1,  nSx,  nSy,
     I         iStart,   iEnd,  iStride,
     I         jStart,   jEnd,  jStride,
     I         kStart,   kEnd,  kStride,
     I        biStart,  biEnd, biStride,
     I        bjStart,  bjEnd, bjStride )
        ENDDO
       ENDDO
      ENDIF
      _BARRIER

      RETURN
      END
      SUBROUTINE PLOT_FIELD_XYZRS( 
     I                            fld, fldNam , fldNz, myIter, myThid )

C     /==========================================================\
C     | SUBROUTINE PLOT_FIELD_XYZR4                              |
C     | Print out an XYZ _RS field using text map.               |
C     |==========================================================|
C     | This routine references "numerical model" parameters like|
C     | like the integration time. It uses these to create a     |
C     | title for the field before calling a generic execution   |
C     | environment support routine.                             |
C     | This routine can also be edited to cause only some region|
C     | of a field to be printed by default, or every other      |
C     | point etc..                                              |
C     | Other plot formats can also be substituted here.         |
C     | _RS is usually a REAL*4 field                            |
C     \==========================================================/
      IMPLICIT NONE

#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"

C     == Routine arguments ==
C     fld - Field to plot
C     fldNam - Name of field
C     fldNz  - No. of layers in the vertical
C              (Different fields may have different vertical extents)
C              (Under the present implementation all fields have the)
C              (same lateral extents.                               )
C     myIter - Iteration number for plot
C     myThid - Thread id of thread instance calling plot_field
      INTEGER fldNz
      _RS fld(1-OLx:sNx+OLx,1-OLy:sNy+OLy,1:fldNz,nSx,nSy)
      CHARACTER*(*) fldNam
      INTEGER myThid
      INTEGER myIter

C     == Local variables ==
      CHARACTER*(MAX_LEN_MBUF) fldTitle
      INTEGER iStart, iEnd, iStride
      INTEGER jStart, jEnd, jStride
      INTEGER kStart, kEnd, kStride
      INTEGER biStart, biEnd, biStride
      INTEGER bjStart, bjEnd, bjStride

C--   To get around synchronisation and multi-threaded I/O issues
C--   thread 1 will do all the writes.
      _BARRIER
      IF ( myThid .EQ. 1 ) THEN
C--    Form name for identifying "plot"
       IF ( myIter .GE. 0 ) THEN
        WRITE(fldTitle,'(A,A,A,I10)') 
     &  '// Field ', fldNam, ' at iteration ',
     &  myIter
       ELSE
        WRITE(fldTitle,'(A,A)') '// Field ', fldNam
       ENDIF
C--    Do "plot" using textual contour map "execution environment" routine
C      Substitute other plotting utilities here!
       iStart   =  1-OLx
       iEnd     =  sNx+OLx
C      iStart   =  1
C      iEnd     =  sNx
       iStride  =  1
       jStart   =  sNy+OLy
       jEnd     =  1-OLy
C      jStart   =  sNy
C      jEnd     =  1
       jStride  = -1
       kStart   =  1
C      kEnd     =  fldNz
       kEnd     =  1
       kStride  =  1
       biStart  =  1
       biEnd    =  nSx
       biStride =  1
       bjStart  =  nSy
       bjEnd    =  1    
       bjStride = -1
       CALL PRINT_MAPRS(
     I        fld, fldTitle, PRINT_MAP_XY,
     I         1-OLx,sNx+OLx,1-OLy,sNy+OLy,1,fldNz,  nSx,  nSy,
     I         iStart,   iEnd,  iStride,
     I         jStart,   jEnd,  jStride,
     I         kStart,   kEnd,  kStride,
     I        biStart,  biEnd, biStride,
     I        bjStart,  bjEnd, bjStride )
      ENDIF
      _BARRIER

      RETURN
      END
      SUBROUTINE PLOT_FIELD_XYZRL( 
     I                            fld, fldNam , fldNz, myIter, myThid )

C     /==========================================================\
C     | SUBROUTINE PLOT_FIELD_XYZRL                              |
C     | Print out an XYZ _RL field using text map.               |
C     |==========================================================|
C     | This routine references "numerical model" parameters like|
C     | like the integration time. It uses these to create a     |
C     | title for the field before calling a generic execution   |
C     | environment support routine.                             |
C     | This routine can also be edited to cause only some region|
C     | of a field to be printed by default, or every other      |
C     | point etc..                                              |
C     | Other plot formats can also be substituted here.         |
C     | _RL is usually a REAL*8 field                            |
C     \==========================================================/
      IMPLICIT NONE

#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"

C     == Routine arguments ==
C     fld - Field to plot
C     fldNam - Name of field
C     fldNz  - No. of layers in the vertical
C              (Different fields may have different vertical extents)
C              (Under the present implementation all fields have the)
C              (same lateral extents.                               )
C     myIter - Iteration number for plot
C     myThid - Thread id of thread instance calling plot_field
      INTEGER fldNz
      _RL fld(1-OLx:sNx+OLx,1-OLy:sNy+OLy,1:fldNz,nSx,nSy)
      CHARACTER*(*) fldNam
      INTEGER myThid
      INTEGER myIter

C     == Local variables ==
      CHARACTER*(MAX_LEN_MBUF) fldTitle
      INTEGER iStart, iEnd, iStride
      INTEGER jStart, jEnd, jStride
      INTEGER kStart, kEnd, kStride
      INTEGER biStart, biEnd, biStride
      INTEGER bjStart, bjEnd, bjStride

C--   To get around synchronisation and multi-threaded I/O issues
C--   thread 1 will do all the writes.
      _BARRIER
      IF ( myThid .EQ. 1 ) THEN
C--    Form name for identifying "plot"
       IF ( myIter .GE. 0 ) THEN
        WRITE(fldTitle,'(A,A,A,I10)') 
     &  '// Field ', fldNam, ' at iteration ',
     &  myIter
       ELSE
        WRITE(fldTitle,'(A,A)') '// Field ', fldNam
       ENDIF
C--    Do "plot" using textual contour map "execution environment" routine
C      Substitute other plotting utilities here!
       iStart   =  1-OLx
       iEnd     =  sNx+OLx
       iStart   =  1
       iEnd     =  sNx
       iStride  =  1
       jStart   =  sNy+OLy
       jEnd     =  1-OLy
       jStart   =  sNy
       jEnd     =  1
       jStride  = -1
       kStart   =  1
       kEnd     =  fldNz
       kEnd     =  1
       kStride  =  1
       biStart  =  1
       biEnd    =  nSx
       biStride =  1
       bjStart  =  nSy
       bjEnd    =  1    
       bjStride = -1
       CALL PRINT_MAPRL(
     I        fld, fldTitle, PRINT_MAP_XY,
     I         1-OLx,sNx+OLx,1-OLy,sNy+OLy,1,fldNz,  nSx,  nSy,
     I         iStart,   iEnd,  iStride,
     I         jStart,   jEnd,  jStride,
     I         kStart,   kEnd,  kStride,
     I        biStart,  biEnd, biStride,
     I        bjStart,  bjEnd, bjStride )
      ENDIF
      _BARRIER

      RETURN
      END

      SUBROUTINE PLOT_FIELD_XZRS( 
     I                            fld, fldNam , fldNz, myIter, myThid )

C     /==========================================================\
C     | SUBROUTINE PLOT_FIELD_XYZR4                              |
C     | Print out an XYZ _RS field using text map.               |
C     |==========================================================|
C     | This routine references "numerical model" parameters like|
C     | like the integration time. It uses these to create a     |
C     | title for the field before calling a generic execution   |
C     | environment support routine.                             |
C     | This routine can also be edited to cause only some region|
C     | of a field to be printed by default, or every other      |
C     | point etc..                                              |
C     | Other plot formats can also be substituted here.         |
C     | _RS is usually a REAL*4 field                            |
C     \==========================================================/
      IMPLICIT NONE

#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"

C     == Routine arguments ==
C     fld - Field to plot
C     fldNam - Name of field
C     fldNz  - No. of layers in the vertical
C              (Different fields may have different vertical extents)
C              (Under the present implementation all fields have the)
C              (same lateral extents.                               )
C     myIter - Iteration number for plot
C     myThid - Thread id of thread instance calling plot_field
      INTEGER fldNz
      _RS fld(1-OLx:sNx+OLx,1:fldNz,nSx,nSy)
      CHARACTER*(*) fldNam
      INTEGER myThid
      INTEGER myIter

C     == Local variables ==
      CHARACTER*(MAX_LEN_MBUF) fldTitle
      INTEGER iStart, iEnd, iStride
      INTEGER jStart, jEnd, jStride
      INTEGER kStart, kEnd, kStride
      INTEGER biStart, biEnd, biStride
      INTEGER bjStart, bjEnd, bjStride

C--   To get around synchronisation and multi-threaded I/O issues
C--   thread 1 will do all the writes.
      _BARRIER
      IF ( myThid .EQ. 1 ) THEN
C--    Form name for identifying "plot"
       IF ( myIter .GE. 0 ) THEN
        WRITE(fldTitle,'(A,A,A,I10)') 
     &  '// Field ', fldNam, ' at iteration ',
     &  myIter
       ELSE
        WRITE(fldTitle,'(A,A)') '// Field ', fldNam
       ENDIF
C--    Do "plot" using textual contour map "execution environment" routine
C      Substitute other plotting utilities here!
       iStart   =  1
       iEnd     =  sNx
       iStride  =  1
       jStart   =  1
       jEnd     =  1
       jStride  =  1
       kStart   =  1
       kEnd     =  fldNz
       kStride  =  1
       biStart  =  1
       biEnd    =  nSx
       biStride =  1
       bjStart  =  nSy 
       bjEnd    =  1    
       bjStride = -1
       CALL PRINT_MAPRS(
     I        fld, fldTitle, PRINT_MAP_XZ,
     I         1-OLx,sNx+OLx,1,fldNz,1,1,  nSx,  nSy,
     I         iStart,   iEnd,  iStride,
     I         jStart,   jEnd,  jStride,
     I         kStart,   kEnd,  kStride,
     I        biStart,  biEnd, biStride,
     I        bjStart,  bjEnd, bjStride )
      ENDIF
      _BARRIER

      RETURN
      END
      SUBROUTINE PLOT_FIELD_XZRL( 
     I                            fld, fldNam , fldNz, myIter, myThid )

C     /==========================================================\
C     | SUBROUTINE PLOT_FIELD_XYZRL                              |
C     | Print out an XYZ _RL field using text map.               |
C     |==========================================================|
C     | This routine references "numerical model" parameters like|
C     | like the integration time. It uses these to create a     |
C     | title for the field before calling a generic execution   |
C     | environment support routine.                             |
C     | This routine can also be edited to cause only some region|
C     | of a field to be printed by default, or every other      |
C     | point etc..                                              |
C     | Other plot formats can also be substituted here.         |
C     | _RL is usually a REAL*8 field                            |
C     \==========================================================/
      IMPLICIT NONE

#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"

C     == Routine arguments ==
C     fld - Field to plot
C     fldNam - Name of field
C     fldNz  - No. of layers in the vertical
C              (Different fields may have different vertical extents)
C              (Under the present implementation all fields have the)
C              (same lateral extents.                               )
C     myIter - Iteration number for plot
C     myThid - Thread id of thread instance calling plot_field
      INTEGER fldNz
      _RL fld(1-OLx:sNx+OLx,1:fldNz,nSx,nSy)
      CHARACTER*(*) fldNam
      INTEGER myThid
      INTEGER myIter

C     == Local variables ==
      CHARACTER*(MAX_LEN_MBUF) fldTitle
      INTEGER iStart, iEnd, iStride
      INTEGER jStart, jEnd, jStride
      INTEGER kStart, kEnd, kStride
      INTEGER biStart, biEnd, biStride
      INTEGER bjStart, bjEnd, bjStride

C--   To get around synchronisation and multi-threaded I/O issues
C--   thread 1 will do all the writes.
      _BARRIER
      IF ( myThid .EQ. 1 ) THEN
C--    Form name for identifying "plot"
       IF ( myIter .GE. 0 ) THEN
        WRITE(fldTitle,'(A,A,A,I10)') 
     &  '// Field ', fldNam, ' at iteration ',
     &  myIter
       ELSE
        WRITE(fldTitle,'(A,A)') '// Field ', fldNam
       ENDIF
C--    Do "plot" using textual contour map "execution environment" routine
C      Substitute other plotting utilities here!
       iStart   =  1
       iEnd     =  sNx
       iStride  =  1
       jStart   =  1
       jEnd     =  1
       jStride  = -1
       kStart   =  1
       kEnd     =  fldNz
c      kEnd     =  1
       kStride  =  1
       biStart  =  1
       biEnd    =  nSx
       biStride =  1
       bjStart  =  nSy
       bjEnd    =  1    
       bjStride = -1
       CALL PRINT_MAPRL(
     I        fld, fldTitle, PRINT_MAP_XZ,
     I         1-OLx,sNx+OLx,1,1,1,fldNz,  nSx,  nSy,
     I         iStart,   iEnd,  iStride,
     I         jStart,   jEnd,  jStride,
     I         kStart,   kEnd,  kStride,
     I        biStart,  biEnd, biStride,
     I        bjStart,  bjEnd, bjStride )
      ENDIF
      _BARRIER

      RETURN
      END

      SUBROUTINE PLOT_FIELD_YZRS( 
     I                            fld, fldNam , fldNz, myIter, myThid )

C     /==========================================================\
C     | SUBROUTINE PLOT_FIELD_XYZR4                              |
C     | Print out an XYZ _RS field using text map.               |
C     |==========================================================|
C     | This routine references "numerical model" parameters like|
C     | like the integration time. It uses these to create a     |
C     | title for the field before calling a generic execution   |
C     | environment support routine.                             |
C     | This routine can also be edited to cause only some region|
C     | of a field to be printed by default, or every other      |
C     | point etc..                                              |
C     | Other plot formats can also be substituted here.         |
C     | _RS is usually a REAL*4 field                            |
C     \==========================================================/
      IMPLICIT NONE

#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"

C     == Routine arguments ==
C     fld - Field to plot
C     fldNam - Name of field
C     fldNz  - No. of layers in the vertical
C              (Different fields may have different vertical extents)
C              (Under the present implementation all fields have the)
C              (same lateral extents.                               )
C     myIter - Iteration number for plot
C     myThid - Thread id of thread instance calling plot_field
      INTEGER fldNz
      _RS fld(1-OLy:sNy+OLy,1:fldNz,nSx,nSy)
      CHARACTER*(*) fldNam
      INTEGER myThid
      INTEGER myIter

C     == Local variables ==
      CHARACTER*(MAX_LEN_MBUF) fldTitle
      INTEGER iStart, iEnd, iStride
      INTEGER jStart, jEnd, jStride
      INTEGER kStart, kEnd, kStride
      INTEGER biStart, biEnd, biStride
      INTEGER bjStart, bjEnd, bjStride

C--   To get around synchronisation and multi-threaded I/O issues
C--   thread 1 will do all the writes.
      _BARRIER
      IF ( myThid .EQ. 1 ) THEN
C--    Form name for identifying "plot"
       IF ( myIter .GE. 0 ) THEN
        WRITE(fldTitle,'(A,A,A,I10)') 
     &  '// Field ', fldNam, ' at iteration ',
     &  myIter
       ELSE
        WRITE(fldTitle,'(A,A)') '// Field ', fldNam
       ENDIF
C--    Do "plot" using textual contour map "execution environment" routine
C      Substitute other plotting utilities here!
       iStart   =  1
       iEnd     =  1
       iStride  =  1
       jStart   =  sNy
       jEnd     =  1
       jStride  = -1
       kStart   =  1
       kEnd     =  fldNz
C      kEnd     =  1
       kStride  =  1
       biStart  =  1
       biEnd    =  nSx 
       biStride =  1
       bjStart  =  nSy
       bjEnd    =  1    
       bjStride = -1
       CALL PRINT_MAPRS(
     I        fld, fldTitle, PRINT_MAP_YZ,
     I         1,1,1-OLy,sNy+OLy,1,fldNz,  nSx,  nSy,
     I         iStart,   iEnd,  iStride,
     I         jStart,   jEnd,  jStride,
     I         kStart,   kEnd,  kStride,
     I        biStart,  biEnd, biStride,
     I        bjStart,  bjEnd, bjStride )
      ENDIF
      _BARRIER

      RETURN
      END
      SUBROUTINE PLOT_FIELD_YZRL( 
     I                            fld, fldNam , fldNz, myIter, myThid )

C     /==========================================================\
C     | SUBROUTINE PLOT_FIELD_XYZRL                              |
C     | Print out an XYZ _RL field using text map.               |
C     |==========================================================|
C     | This routine references "numerical model" parameters like|
C     | like the integration time. It uses these to create a     |
C     | title for the field before calling a generic execution   |
C     | environment support routine.                             |
C     | This routine can also be edited to cause only some region|
C     | of a field to be printed by default, or every other      |
C     | point etc..                                              |
C     | Other plot formats can also be substituted here.         |
C     | _RL is usually a REAL*8 field                            |
C     \==========================================================/
      IMPLICIT NONE

#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"

C     == Routine arguments ==
C     fld - Field to plot
C     fldNam - Name of field
C     fldNz  - No. of layers in the vertical
C              (Different fields may have different vertical extents)
C              (Under the present implementation all fields have the)
C              (same lateral extents.                               )
C     myIter - Iteration number for plot
C     myThid - Thread id of thread instance calling plot_field
      INTEGER fldNz
      _RL fld(1-OLy:sNy+OLy,1:fldNz,nSx,nSy)
      CHARACTER*(*) fldNam
      INTEGER myThid
      INTEGER myIter

C     == Local variables ==
      CHARACTER*(MAX_LEN_MBUF) fldTitle
      INTEGER iStart, iEnd, iStride
      INTEGER jStart, jEnd, jStride
      INTEGER kStart, kEnd, kStride
      INTEGER biStart, biEnd, biStride
      INTEGER bjStart, bjEnd, bjStride

C--   To get around synchronisation and multi-threaded I/O issues
C--   thread 1 will do all the writes.
      _BARRIER
      IF ( myThid .EQ. 1 ) THEN
C--    Form name for identifying "plot"
       IF ( myIter .GE. 0 ) THEN
        WRITE(fldTitle,'(A,A,A,I10)') 
     &  '// Field ', fldNam, ' at iteration ',
     &  myIter
       ELSE
        WRITE(fldTitle,'(A,A)') '// Field ', fldNam
       ENDIF
C--    Do "plot" using textual contour map "execution environment" routine
C      Substitute other plotting utilities here!
       iStart   =  1
       iEnd     =  1
       iStride  =  1
       jStart   =  sNy
       jEnd     =  1
       jStride  = -1
       kStart   =  1
       kEnd     =  fldNz
c      kEnd     =  1
       kStride  =  1
       biStart  =  1
       biEnd    =  nSx 
       biStride =  1
       bjStart  =  nSy
       bjEnd    =  1    
       bjStride = -1
       CALL PRINT_MAPRL(
     I        fld, fldTitle, PRINT_MAP_YZ,
     I         1,1,1-OLy,sNy+OLy,1,fldNz,  nSx,  nSy,
     I         iStart,   iEnd,  iStride,
     I         jStart,   jEnd,  jStride,
     I         kStart,   kEnd,  kStride,
     I        biStart,  biEnd, biStride,
     I        bjStart,  bjEnd, bjStride )
      ENDIF
      _BARRIER

      RETURN
      END

#include "COST_OPTIONS.h"
#ifdef ALLOW_CTRL
# include "CTRL_OPTIONS.h"
#endif

CBOP
C     !ROUTINE: COST_HFLUX
C     !INTERFACE:
      SUBROUTINE COST_HFLUX( myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE COST_HFLUX
C     | o the subroutine computes the cost function relative to
C     |   mean surface hflux optimization as a simple example.
C     *==========================================================*
C     \ev
C     !USES:
       IMPLICIT NONE
C     == Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "cost.h"
#ifdef ALLOW_OPENAD
# include "FFIELDS.h"
#else
# include "cost_local.h"
# include "CTRL_SIZE.h"
# include "CTRL_GENARR.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     myThid - Thread number for this instance of the routine.
      INTEGER myThid

#ifdef ALLOW_COST_HFLUXM
C     !LOCAL VARIABLES:
      INTEGER i, j
      INTEGER bi, bj
      _RL     locfc, tmpC
#ifndef ALLOW_OPENAD
      INTEGER iarr
#endif
CEOP

#ifndef ALLOW_OPENAD
C     iarr = 1 is set in data.ctrl (xx_gentim2d_file(1) = 'xx_qnet').
      iarr = 1
C     By default xx_gentim2d_period(1)=0, so that control parameter
C     xx_gentim2d(:,:,:,:,1) is the mean heat flux perturbation. Here we
C     penalize deviations from the first guess = 0.
#endif
      tmpC = 0. _d 0
      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        DO j=1,sNy
         DO i=1,sNx
          tmpC = tmpC + maskC(i,j,1,bi,bj)
         ENDDO
        ENDDO
       ENDDO
      ENDDO
      _GLOBAL_SUM_RL( tmpC , myThid )
      IF ( tmpC.GT.0. ) tmpC = 1. _d 0 / tmpC

      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)

        locfc = 0. _d 0
        DO j=1,sNy
         DO i=1,sNx
          locfc = locfc + tmpC*maskC(i,j,1,bi,bj)*
     &        whfluxm(i,j,bi,bj)*
     &       (
#ifdef ALLOW_OPENAD
     &         Qnetm(i,j,bi,bj)
#else
     &         xx_gentim2d(i,j,bi,bj,iarr)
#endif
     &       )**2
         ENDDO
        ENDDO

        objf_hflux_tut(bi,bj) = locfc
c       print*,'objf_hflux_tut =',locfc

       ENDDO
      ENDDO

#endif /* ALLOW_COST_HFLUXM */
      RETURN
      END

#include "EXF_OPTIONS.h"

CBOP
C     !ROUTINE: EXF_GetMonthsRec
C     !INTERFACE:
      SUBROUTINE EXF_GetMonthsRec(
     I                             fldStartTime, useFldYearlyFields,
     O                             fac, first, changed,
     O                             count0, count1, year0, year1,
     I                             myTime, myIter, myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE EXF_GetMonthsRec
C     | o Get flags, counters, and the linear interpolation
C     |   factor for a given field for the case of monthly,
C     |   interannual forcing
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     == Global variables ==

C     !INPUT PARAMETERS:
C     fldStartTime       :: time in seconds of first fld record from the
C                           beginning of the model integration or, if
C                           usefldyearlyfields, from the beginning of year
C     useFldYearlyFields :: when set, use yearly forcing files
C     myTime             :: current time in simulation
C     myIter             :: current iteration number in simulation
C     myThid             :: my thread identification number
      _RL     fldStartTime
      LOGICAL useFldYearlyFields
      _RL     myTime
      INTEGER myIter
      INTEGER myThid

C     !OUTPUT PARAMETERS:
C     fac     :: weight of record count0 for linear interpolation purposes
C     first   :: model initialization flag: read two forcing records
C     changed :: flag indicating that a new forcing record must be read
C     count0  :: record number for forcing field preceding myTime
C     count1  :: record number for forcing field following myTime
C     year0   :: year of forcing file for record preceding myTime
C     year1   :: year of forcing file for record following myTime
      _RL     fac
      LOGICAL first, changed
      INTEGER count0, count1, year0, year1

#ifdef ALLOW_EXF
#ifdef ALLOW_CAL
C     !LOCAL VARIABLES:
      INTEGER startDate(4)
      INTEGER yy, mm, dd, ss, lp, wd
CEOP

      CALL cal_GetMonthsRec(
     O                       fac, first, changed,
     O                       count0, count1, year0, year1,
     I                       myTime, myIter, myThid )
      IF (.NOT.useFldYearlyFields) THEN
        CALL CAL_GETDATE( 0, fldStartTime, startDate, myThid )
        CALL CAL_CONVDATE( startDate, yy, mm, dd, ss, lp, wd, myThid )
        count0 = (year0-yy)*12 + count0 - mm + 1
        count1 = (year1-yy)*12 + count1 - mm + 1
        year0 = 0
        year1 = 0
      ENDIF

#endif /* ALLOW_CAL */
#endif /* ALLOW_EXF */

      RETURN
      END

#include "SMOOTH_OPTIONS.h"

      SUBROUTINE SMOOTH3D(
     &           fld_in, smoothOpNb, myThid )

C     *==========================================================*
C     | SUBROUTINE smooth3D
C     | o Routine that applies 3D spatial smoothing
C     *==========================================================*

      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "GRID.h"
#include "PARAMS.h"
#include "SMOOTH.h"

      _RL fld_in(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      INTEGER smoothOpNb
      INTEGER myThid

      INTEGER nbt_in
      CHARACTER*(MAX_LEN_FNAM) fnamegeneric
      INTEGER IL

c     == functions ==
      INTEGER  ILNBLNK
      EXTERNAL ILNBLNK

      IL = ILNBLNK( smoothDir )

C read smoothing [i.e diffusion] operator:
      WRITE(fnamegeneric,'(2A,I3.3)')
     &      smoothDir(1:IL),
     &      'smooth3Doperator', smoothOpNb
      CALL READ_REC_3D_RL( fnamegeneric, smoothprec,
     &           Nr, smooth3D_Kwx, 1, 1, myThid )
      CALL READ_REC_3D_RL( fnamegeneric, smoothprec,
     &           Nr, smooth3D_Kwy, 2, 1, myThid )
      CALL READ_REC_3D_RL( fnamegeneric, smoothprec,
     &           Nr, smooth3D_Kwz, 3, 1, myThid )
      CALL READ_REC_3D_RL( fnamegeneric, smoothprec,
     &           Nr, smooth3D_Kux, 4, 1, myThid )
      CALL READ_REC_3D_RL( fnamegeneric, smoothprec,
     &           Nr, smooth3D_Kvy, 5, 1, myThid )
      CALL READ_REC_3D_RL( fnamegeneric, smoothprec,
     &           Nr, smooth3D_Kuz, 6, 1, myThid )
      CALL READ_REC_3D_RL( fnamegeneric, smoothprec,
     &           Nr, smooth3D_Kvz, 7, 1, myThid )
      CALL READ_REC_3D_RL( fnamegeneric, smoothprec,
     &           Nr, smooth3D_Kuy, 8, 1, myThid )
      CALL READ_REC_3D_RL( fnamegeneric, smoothprec,
     &           Nr, smooth3D_Kvx, 9, 1, myThid )
      CALL READ_REC_3D_RL( fnamegeneric, smoothprec,
     &           Nr, smooth3D_kappaR, 10, 1, myThid )
      CALL EXCH_XYZ_RL( smooth3D_Kwx, myThid )
      CALL EXCH_XYZ_RL( smooth3D_Kwy, myThid )
      CALL EXCH_XYZ_RL( smooth3D_Kwz, myThid )
      CALL EXCH_XYZ_RL( smooth3D_Kux, myThid )
      CALL EXCH_XYZ_RL( smooth3D_Kvy, myThid )
      CALL EXCH_XYZ_RL( smooth3D_Kuz, myThid )
      CALL EXCH_XYZ_RL( smooth3D_Kvz, myThid )
      CALL EXCH_XYZ_RL( smooth3D_Kuy, myThid )
      CALL EXCH_XYZ_RL( smooth3D_Kvx, myThid )
      CALL EXCH_XYZ_RL( smooth3D_kappaR, myThid )

c do the smoothing:
      nbt_in = smooth3Dnbt(smoothOpNb)
      CALL smooth_diff3D( fld_in, nbt_in, myThid )

      RETURN
      END

#include "OPPS_OPTIONS.h"

CBOP
C !ROUTINE: OPPS_READPARMS

C !INTERFACE: ==========================================================
      SUBROUTINE OPPS_READPARMS( myThid )

C !DESCRIPTION:
C     Initialize OPPS parameters, read in data.opps

C !USES: ===============================================================
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "OPPS.h"
#include "PARAMS.h"

C !INPUT PARAMETERS: ===================================================
C  myThid               :: thread number
      INTEGER myThid

C !OUTPUT PARAMETERS: ==================================================
C  none

#ifdef ALLOW_OPPS

C !LOCAL VARIABLES: ====================================================
C  iUnit                :: unit number for I/O
C  msgBuf               :: message buffer
      INTEGER iUnit
      CHARACTER*(MAX_LEN_MBUF) msgBuf
CEOP

      NAMELIST /OPPS_PARM01/
     &     MAX_ABE_ITERATIONS,
     &     OPPSdebugLevel,
     &     PlumeRadius,
     &     STABILITY_THRESHOLD,
     &     FRACTIONAL_AREA,
     &     MAX_FRACTIONAL_AREA,
     &     VERTICAL_VELOCITY,
     &     ENTRAINMENT_RATE,
     &     useGCMwVel
C     &     , OPPSwriteState, OPPSdumpFreq

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      IF ( .NOT.useOPPS ) THEN
C-    pkg OPPS is not used
        _BEGIN_MASTER(myThid)
C-    Track pkg activation status:
         OPPSisON = .FALSE.
C     print a (weak) warning if data.opps is found
         CALL PACKAGES_UNUSED_MSG( 'useOPPS', ' ', ' ' )
        _END_MASTER(myThid)
        RETURN
      ENDIF

C This routine has been called by the main model so we set our
C internal flag to indicate we are in business
      OPPSisON = .TRUE.

C Set defaults values for parameters in OPPS.h
      MAX_ABE_ITERATIONS   =  1
      OPPSdebugLevel       =  0
      PlumeRadius          = 100.   _d 0
      STABILITY_THRESHOLD  =  -1.   _d -4
      FRACTIONAL_AREA      =    .1  _d 0
      MAX_FRACTIONAL_AREA  =    .8  _d 0
      VERTICAL_VELOCITY    =    .03 _d 0
      ENTRAINMENT_RATE     =   -.05 _d 0
      useGCMwVel           = .FALSE.
C     OPPSdumpFreq         = dumpFreq
C     OPPSwriteState       = .FALSE.

C Open and read the data.opps file
      _BEGIN_MASTER(myThid)
      WRITE(msgBuf,'(A)') ' OPPS_READPARMS: opening data.opps'
      CALL PRINT_MESSAGE(msgBuf, standardMessageUnit,
     &                   SQUEEZE_RIGHT , 1)
      CALL OPEN_COPY_DATA_FILE(
     I                   'data.opps', 'OPPS_READPARMS',
     O                   iUnit,
     I                   myThid )
      READ(UNIT=iUnit,NML=OPPS_PARM01)
      WRITE(msgBuf,'(A)')
     &  ' OPPS_READPARMS: finished reading data.opps'
      CALL PRINT_MESSAGE(msgBuf, standardMessageUnit,
     &                   SQUEEZE_RIGHT , 1)

C Close the open data file
#ifdef SINGLE_DISK_IO
      CLOSE(iUnit)
#else
      CLOSE(iUnit,STATUS='DELETE')
#endif /* SINGLE_DISK_IO */
      _END_MASTER(myThid)

C Everyone else must wait for the parameters to be loaded
      _BARRIER

C Now set-up any remaining parameters that result from the input parameters
      e2    =   2.*ENTRAINMENT_RATE
#endif /* ALLOW_OPPS */

      RETURN
      END

#include "GAD_OPTIONS.h"

CBOP
C !ROUTINE: GAD_DST3_ADV_X

C !INTERFACE: ==========================================================
      SUBROUTINE GAD_DST3_ADV_X(
     I           bi,bj,k, calcCFL, deltaTloc,
     I           uTrans, uFld,
     I           maskLocW, tracer,
     O           uT,
     I           myThid )

C !DESCRIPTION:
C  Calculates the area integrated zonal flux due to advection of a
C  tracer using 3rd-order Direct Space and Time (DST-3) Advection Scheme

C !USES: ===============================================================
      IMPLICIT NONE

C     == GLobal variables ==
#include "SIZE.h"
#ifdef OLD_DST3_FORMULATION
#include "EEPARAMS.h"
#include "PARAMS.h"
#endif
#include "GRID.h"
#include "GAD.h"

C     == Routine arguments ==
C !INPUT PARAMETERS: ===================================================
C  bi,bj             :: tile indices
C  k                 :: vertical level
C  calcCFL           :: =T: calculate CFL number ; =F: take uFld as CFL.
C  deltaTloc         :: local time-step (s)
C  uTrans            :: zonal volume transport
C  uFld              :: zonal flow / CFL number
C  tracer            :: tracer field
C  myThid            :: thread number
      INTEGER bi,bj,k
      LOGICAL calcCFL
      _RL deltaTloc
      _RL uTrans(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL uFld  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RS maskLocW(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL tracer(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER myThid

C !OUTPUT PARAMETERS: ==================================================
C  uT                :: zonal advective flux
      _RL uT    (1-OLx:sNx+OLx,1-OLy:sNy+OLy)

C     == Local variables ==
C !LOCAL VARIABLES: ====================================================
C  i,j               :: loop indices
C  uCFL              :: Courant-Friedrich-Levy number
      INTEGER i,j
      _RL Rjm,Rj,Rjp,uCFL,d0,d1
#ifdef OLD_DST3_FORMULATION
      _RL psiP,psiM,thetaP,thetaM
      _RL smallNo
c     _RL Rjjm,Rjjp

c     IF (inAdMode .AND. useApproxAdvectionInAdMode) THEN
c      smallNo = 1.0D-20
c     ELSE
       smallNo = 1.0D-20
c     ENDIF
#endif

      DO j=1-OLy,sNy+OLy
       uT(1-OLx,j)=0.
       uT(2-OLx,j)=0.
       uT(sNx+OLx,j)=0.
      ENDDO
      DO j=1-OLy,sNy+OLy
       DO i=1-OLx+2,sNx+OLx-1
        Rjp=(tracer(i+1,j)-tracer( i ,j))*maskLocW(i+1,j)
        Rj =(tracer( i ,j)-tracer(i-1,j))*maskLocW( i ,j)
        Rjm=(tracer(i-1,j)-tracer(i-2,j))*maskLocW(i-1,j)

        uCFL = uFld(i,j)
        IF ( calcCFL ) uCFL = ABS( uFld(i,j)*deltaTloc
     &                  *recip_dxC(i,j,bi,bj)*recip_deepFacC(k) )
        d0=(2.-uCFL)*(1.-uCFL)*oneSixth
        d1=(1.-uCFL*uCFL)*oneSixth
#ifdef OLD_DST3_FORMULATION
        IF ( ABS(Rj).LT.smallNo .OR.
     &       ABS(Rjm).LT.smallNo ) THEN
         thetaP=0.
         psiP=0.
        ELSE
         thetaP=(Rjm+smallNo)/(smallNo+Rj)
         psiP=d0+d1*thetaP
        ENDIF
        IF ( ABS(Rj).LT.smallNo .OR.
     &       ABS(Rjp).LT.smallNo ) THEN
         thetaM=0.
         psiM=0.
        ELSE
         thetaM=(Rjp+smallNo)/(smallNo+Rj)
         psiM=d0+d1*thetaM
        ENDIF
        uT(i,j)=
     &   0.5*(uTrans(i,j)+ABS(uTrans(i,j)))
     &      *( Tracer(i-1,j) + psiP*Rj )
     &  +0.5*(uTrans(i,j)-ABS(uTrans(i,j)))
     &      *( Tracer( i ,j) - psiM*Rj )
#else /* OLD_DST3_FORMULATION */
        uT(i,j)=
     &   0.5*(uTrans(i,j)+ABS(uTrans(i,j)))
     &      *( Tracer(i-1,j) + (d0*Rj+d1*Rjm) )
     &  +0.5*(uTrans(i,j)-ABS(uTrans(i,j)))
     &      *( Tracer( i ,j) - (d0*Rj+d1*Rjp) )
#endif /* OLD_DST3_FORMULATION */

       ENDDO
      ENDDO

      RETURN
      END

#include "AUTODIFF_OPTIONS.h"

C--   File global_sum_tile_ad.F: Routines that perform adjoint of
C                          global sum on an array of thread values.
C      Contents
C      o GLOBAL_ADSUM_TILE_RL
C      o GLOBAL_ADSUM_TILE_RS <- not yet coded

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: GLOBAL_ADSUM_TILE_RL

C     !INTERFACE:
      SUBROUTINE GLOBAL_ADSUM_TILE_RL(
     U                        adPhiTile,
     U                        adsumPhi,
     I                        myThid )

C     !DESCRIPTION:
C     *==========================================================*
C     | SUBROUTINE GLOBAL\_ADSUM\_TILE\_RL
C     | o Adjoint version of global_sum_tile which returns
C     |   global sum over all tiles
C     | Note: Assume that adsumPhi is local to this thread
C     | (i.e., is not a shared var. and is not in a common block)
C     *==========================================================*
C     | Apply sum on an array of one value per tile
C     |  and operate over all tiles & all the processes.
C     *==========================================================*

C     !USES:
      IMPLICIT NONE

C     == Global data ==
#include "SIZE.h"
#include "EEPARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     phiTile :: Input array with one value per tile
C     sumPhi  :: Result of sum.
C     myThid  :: My Thread Id.
      _RL     adphiTile(nSx,nSy)
      _RL     adsumPhi
      INTEGER myThid
CEOP

C     !LOCAL VARIABLES:
C     == Local variables ==
C     bi,bj  :: tile indices
      INTEGER bi,bj
      Real*8  tmp

C note: arithmetic has been checked versus TAF generated adjoint
C       of a simplified version of global_sum_tile.F code.

      tmp = adsumPhi

      CALL GLOBAL_SUM_R8( tmp, myThid )

C--   each thread updates its tile adjoint sum
      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
         adphiTile(bi,bj) = adphiTile(bi,bj) + tmp
       ENDDO
      ENDDO

      adsumPhi = 0.

      RETURN
      END

#include "DIAG_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: DIAGNOSTICS_WRITE_PICKUP
C     !INTERFACE:
      SUBROUTINE DIAGNOSTICS_WRITE_PICKUP(
     I     isPerm,
     I     suff,
     I     myTime,
     I     myIter,
     I     myThid )

C     !DESCRIPTION:
C     Writes current state of the diagnostics package.

C     !USES:
      IMPLICIT NONE

C     == Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "DIAGNOSTICS_SIZE.h"
#include "DIAGNOSTICS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     isPerm  :: permanent checkpoint flag
C     suff    :: suffix for pickup file (eg. ckptA or 0000000010)
C     myTime  :: current time
C     myIter  :: time-step number
C     myThid  :: Number of this instance
      LOGICAL isPerm
      CHARACTER*(*) suff
      _RL myTime
      INTEGER myIter
      INTEGER myThid

#ifdef DIAGNOSTICS_HAS_PICKUP

C     !LOCAL VARIABLES:
C     fn      :: character buffer for creating filename
C     prec    :: precision of pickup files
c     INTEGER prec, iChar, lChar, k
      INTEGER prec, lChar, sn
      CHARACTER*(MAX_LEN_FNAM) fn

      INTEGER  ILNBLNK
      EXTERNAL ILNBLNK

      INTEGER dUnit, ndId, n, m

#ifdef ALLOW_MNC
      INTEGER i, ii
      CHARACTER*(MAX_LEN_FNAM) diag_mnc_bn
      INTEGER CW_DIMS, NLEN
      PARAMETER ( CW_DIMS = 10 )
      PARAMETER ( NLEN    = 80 )
      INTEGER dim(CW_DIMS), ib(CW_DIMS), ie(CW_DIMS)
      CHARACTER*(NLEN) dn(CW_DIMS)
      CHARACTER*(NLEN) d_cw_name
      CHARACTER*(NLEN) dn_blnk
#endif /*  ALLOW_MNC  */

CEOP

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      IF (diag_pickup_write) THEN

#ifdef ALLOW_MNC
        IF (diag_pickup_write_mnc) THEN
          DO i = 1,NLEN
            dn_blnk(i:i) = ' '
          ENDDO
          DO i = 1,MAX_LEN_FNAM
            diag_mnc_bn(i:i) = ' '
          ENDDO

          IF ( isPerm ) THEN
            WRITE(diag_mnc_bn,'(A)') 'pickup_diagnostics'
          ELSE
            ii = ILNBLNK(suff)
            WRITE(diag_mnc_bn,'(A,A)')
     &           'pickup_diagnostics.',suff(1:ii)
          ENDIF

          CALL MNC_CW_SET_UDIM(fn, 0, myThid)
          IF ( isPerm ) THEN
            CALL MNC_CW_SET_CITER(fn, 3, 3, myIter, 0, myThid)
          ELSE
            CALL MNC_CW_SET_CITER(fn, 2, -1, -1, -1, myThid)
          ENDIF
C         Then set the actual unlimited dimension
          CALL MNC_CW_SET_UDIM(fn, 1, myThid)

C         Update the record dimension by writing the iteration number
          CALL MNC_CW_RL_W_S('D',diag_mnc_bn,0,0,'T',myTime,myThid)
          CALL MNC_CW_I_W_S('I',diag_mnc_bn,0,0,'iter',myIter,myThid)

C         Write the qdiag() array
          d_cw_name(1:NLEN) = dn_blnk(1:NLEN)
          DO ii = 1,CW_DIMS
            dn(ii)(1:NLEN) = dn_blnk(1:NLEN)
          ENDDO
          d_cw_name(1:10) = 'diag_state'
          dn(1)(1:3) = 'Xp1'
          dim(1)     = sNx + 2*OLx
          ib(1)      = OLx + 1
          ie(1)      = OLx + sNx + 1
          dn(2)(1:3) = 'Yp1'
          dim(2)     = sNy + 2*OLy
          ib(2)      = OLy + 1
          ie(2)      = OLy + sNy + 1
          dn(3)(1:2) = 'Nd'
          dim(3)     = numDiags
          ib(3)      = 1
          ie(3)      = numDiags
          dn(4)(1:1) = 'T'
          dim(4)     = -1
          ib(4)      = 1
          ie(4)      = 1

          CALL MNC_CW_ADD_GNAME(d_cw_name, 4,
     &         dim, dn, ib, ie, myThid)
          CALL MNC_CW_ADD_VNAME(d_cw_name, d_cw_name,
     &         4,5, myThid)
          CALL MNC_CW_ADD_VATTR_TEXT(d_cw_name,'description',
     &         'diagnostics state',myThid)

          CALL MNC_CW_RL_W('D',diag_mnc_bn,0,0,
     &         d_cw_name, qdiag, myThid)

          CALL MNC_CW_DEL_VNAME(d_cw_name, myThid)
          CALL MNC_CW_DEL_GNAME(d_cw_name, myThid)

C         Write the ndiag() array
          d_cw_name(1:NLEN) = dn_blnk(1:NLEN)
          DO ii = 1,CW_DIMS
            dn(ii)(1:NLEN) = dn_blnk(1:NLEN)
          ENDDO
          d_cw_name(1:10) = 'diag_count'
          dn(1)(1:2) = 'Nd'
          dim(1)     = numDiags
          ib(1)      = 1
          ie(1)      = numDiags
          dn(2)(1:1) = 'T'
          dim(2)     = -1
          ib(2)      = 1
          ie(2)      = 1

          CALL MNC_CW_ADD_GNAME(d_cw_name, 2,
     &         dim, dn, ib, ie, myThid)
          CALL MNC_CW_ADD_VNAME(d_cw_name, d_cw_name,
     &         4,5, myThid)
          CALL MNC_CW_ADD_VATTR_TEXT(d_cw_name,'description',
     &         'diagnostics state',myThid)

          CALL MNC_CW_I_W('I',diag_mnc_bn,0,0,
     &         d_cw_name, ndiag, myThid)

          CALL MNC_CW_DEL_VNAME(d_cw_name, myThid)
          CALL MNC_CW_DEL_GNAME(d_cw_name, myThid)

        ENDIF
#endif

        IF (diag_pickup_write_mdsio) THEN

          sn = ILNBLNK(suff)

C         Write qdiag()
          WRITE(fn,'(a,a)') 'pickup_qdiag.', suff(1:sn)
          prec = precFloat64
          CALL WRITE_REC_3D_RL( fn, prec, numDiags, qdiag,
     &                          1, myIter, myThid )

C         Write ndiag()
          _BARRIER
          _BEGIN_MASTER( myThid )
          WRITE(fn,'(a,a)') 'pickup_ndiag.', suff(1:sn)
          CALL MDSFINDUNIT( dUnit, myThid )
          OPEN( dUnit, file=fn )
          DO n = 1,nlists
            DO m = 1,nfields(n)
              ndId = ABS(jdiag(m,n))
              WRITE(dUnit,'(I10)') ndiag(ndId,1,1)
            ENDDO
          ENDDO
          CLOSE( dUnit )
          _END_MASTER( myThid )
          _BARRIER
        ENDIF

      ENDIF

#endif /* DIAGNOSTICS_HAS_PICKUP */

      RETURN
      END

#include "SEAICE_OPTIONS.h"

CBOP
      SUBROUTINE SEAICE_FREEDRIFT( myTime, myIter, myThid )
C     *==========================================================*
C     | SUBROUTINE  SEAICE_FREEDRIFT
C     | o Solve ice approximate momentum equation analytically
C     *==========================================================*
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "DYNVARS.h"
#include "GRID.h"
#include "SEAICE_SIZE.h"
#include "SEAICE_PARAMS.h"
#include "SEAICE_GRID.h"
#include "SEAICE.h"

C     === Routine arguments ===
C     myTime :: Simulation time
C     myIter :: Simulation timestep number
C     myThid :: my Thread Id. number
      _RL     myTime
      INTEGER myIter
      INTEGER myThid
CEOP

#if ( defined SEAICE_CGRID && defined SEAICE_ALLOW_FREEDRIFT )

C     === Local variables ===
      INTEGER i, j, kSrf, bi, bj

      _RL tmpscal1,tmpscal2,tmpscal3,tmpscal4

      _RL taux_onIce_cntr, tauy_onIce_cntr, uvel_cntr, vvel_cntr
      _RL mIceCor, rhs_x, rhs_y, rhs_n, rhs_a, sol_n, sol_a

      _RL uice_cntr(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL vice_cntr(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)

      IF ( usingPCoords ) THEN
       kSrf = Nr
      ELSE
       kSrf = 1
      ENDIF

C initialize fields:
C ==================

      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          uice_fd(i,j,bi,bj)=0. _d 0
          vice_fd(i,j,bi,bj)=0. _d 0
          uice_cntr(i,j,bi,bj)=0. _d 0
          Vice_cntr(i,j,bi,bj)=0. _d 0
         ENDDO
        ENDDO
       ENDDO
      ENDDO

      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        DO j=1,sNy
         DO i=1,sNx

C preliminary computations:
C =========================
C air-ice stress at cell center
          taux_onIce_cntr=HALF*
     &      (FORCEX0(i,j,bi,bj)+FORCEX0(i+1,j,bi,bj))
          tauy_onIce_cntr=HALF*
     &      (FORCEY0(i,j,bi,bj)+FORCEY0(i,j+1,bi,bj))
C mass of ice per unit area (kg/m2) times coriolis f
          mIceCor=SEAICE_rhoIce*HEFF(i,j,bi,bj)*_fCori(i,j,bi,bj)
C ocean velocity at cell center
          uvel_cntr=HALF*(uvel(i,j,kSrf,bi,bj)+uvel(i+1,j,kSrf,bi,bj))
          vvel_cntr=HALF*(vvel(i,j,kSrf,bi,bj)+vvel(i,j+1,kSrf,bi,bj))
C right hand side of free drift equation:
          rhs_x= -taux_onIce_cntr -mIceCor*vvel_cntr
          rhs_y= -tauy_onIce_cntr +mIceCor*uvel_cntr

C norm of angle of rhs
          tmpscal1=rhs_x*rhs_x + rhs_y*rhs_y
          IF ( tmpscal1.GT.ZERO ) THEN
           rhs_n=SQRT( rhs_x*rhs_x + rhs_y*rhs_y )
           rhs_a=ATAN2(rhs_y,rhs_x)
          ELSE
           rhs_n=0. _d 0
           rhs_a=0. _d 0
          ENDIF

C solve for norm:
C ===============
          IF ( YC(i,j,bi,bj) .LT. ZERO ) THEN
           tmpscal1 = 1. _d 0 /rhoConst/SEAICE_waterDrag_south
          ELSE
           tmpscal1 = 1. _d 0 /rhoConst/SEAICE_waterDrag
          ENDIF
C polynomial coefficients
          tmpscal2= tmpscal1*tmpscal1*mIceCor*mIceCor
          tmpscal3= tmpscal1*tmpscal1*rhs_n*rhs_n
C discriminant
          tmpscal4=tmpscal2*tmpscal2+4. _d 0*tmpscal3
          IF ( tmpscal3.GT.ZERO ) THEN
           sol_n=SQRT(HALF*(SQRT(tmpscal4)-tmpscal2))
          ELSE
           sol_n=0. _d 0
          ENDIF

C solve for angle:
C ================
          IF ( YC(i,j,bi,bj) .LT. ZERO ) THEN
           tmpscal1 = SEAICE_waterDrag_south*rhoConst
          ELSE
           tmpscal1 = SEAICE_waterDrag*rhoConst
          ENDIF

          tmpscal2= tmpscal1*sol_n*sol_n
          tmpscal3= mIceCor*sol_n

          tmpscal4=tmpscal2*tmpscal2 + tmpscal3*tmpscal3
          IF ( tmpscal4.GT.ZERO ) THEN
           sol_a=rhs_a-ATAN2(tmpscal3,tmpscal2)
          ELSE
           sol_a=0. _d 0
          ENDIF

C compute uice, vice at cell center:
C ==================================
          uice_cntr(i,j,bi,bj)=uvel_cntr-sol_n*COS(sol_a)
          vice_cntr(i,j,bi,bj)=vvel_cntr-sol_n*SIN(sol_a)

         ENDDO
        ENDDO
       ENDDO
      ENDDO

C interpolated to velocity points:
C ================================

      CALL EXCH_UV_AGRID_3D_RL(uice_cntr,vice_cntr,.TRUE.,1,myThid)

      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        DO j=1,sNy
         DO i=1,sNx
          uice_fd(i,j,bi,bj)=HALF*
     &      (uice_cntr(i-1,j,bi,bj)+uice_cntr(i,j,bi,bj))
          vice_fd(i,j,bi,bj)=HALF*
     &      (vice_cntr(i,j-1,bi,bj)+vice_cntr(i,j,bi,bj))
         ENDDO
        ENDDO
       ENDDO
      ENDDO

      CALL EXCH_UV_XY_RL( uice_fd, vice_fd, .TRUE., myThid )

C     Apply masks (same/similar to seaice_evp.F/seaice_lsr.F)
      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          uIce_fd(i,j,bi,bj)=uIce_fd(i,j,bi,bj)*SIMaskU(i,j,bi,bj)
          vIce_fd(i,j,bi,bj)=vIce_fd(i,j,bi,bj)*SIMaskV(i,j,bi,bj)
         ENDDO
        ENDDO
       ENDDO
      ENDDO

#endif /* SEAICE_CGRID and SEAICE_ALLOW_FREEDRIFT */
      RETURN
      END

#include "DWNSLP_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 0
C !ROUTINE: DWNSLP_DIAGNOSTICS_INIT

C !INTERFACE:
      SUBROUTINE DWNSLP_DIAGNOSTICS_INIT( myThid )

C     !DESCRIPTION:
C     Initialize list of all available diagnostics

C     !USES:
      IMPLICIT NONE
#include "EEPARAMS.h"
#include "SIZE.h"
c#include "DWNSLP_PARAMS.h"
#ifdef ALLOW_GENERIC_ADVDIFF
# include "GAD.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     myThid ::  my Thread Id number
      INTEGER myThid
CEOP

#ifdef ALLOW_DIAGNOSTICS
C     !LOCAL VARIABLES:
C     === Local variables ===
C     diagNum   :: diagnostics number in the (long) list of available diag.
C     diagMate  :: diag. mate number in the (long) list of available diag.
C     diagName  :: local short name (8c) of a diagnostics
C     diagCode  :: local parser field with characteristics of the diagnostics
C              cf head of S/R DIAGNOSTICS_INIT_EARLY or DIAGNOSTICS_MAIN_INIT
C     diagUnits :: local string (16c): physical units of a diagnostic field
C     diagTitle :: local string (80c): description of field in diagnostic
      INTEGER       diagNum
      INTEGER       diagMate
      CHARACTER*4   diagSufx
      CHARACTER*8   diagName
      CHARACTER*16  diagCode
      CHARACTER*16  diagUnits
      CHARACTER*(80) diagTitle
      INTEGER  DIAGS_GET_PARMS_I
      EXTERNAL DIAGS_GET_PARMS_I
#ifdef ALLOW_GENERIC_ADVDIFF
      CHARACTER*4 GAD_DIAG_SUFX
      EXTERNAL    GAD_DIAG_SUFX
#endif

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

c     IF ( useDiagnotics ) THEN

        diagNum   = DIAGS_GET_PARMS_I( 'LAST_DIAG_ID', myThid )

c       diagName  = 'RHOAnExt'
c       diagTitle = 'Density Anomaly (=Rho-rhoConst) + extended inland'
c       diagUnits = 'kg/m^3          '
c       diagCode  = 'SMR     MR      '
c       CALL DIAGNOSTICS_ADDTOLIST( diagNum,
c    I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

        diagName  = 'DSLPuFlw'
        diagTitle = 'Zonal  Down-Sloping Transport (u-component)'
        diagUnits = 'm^3/s           '
        diagCode  = 'UU      M1      '
        diagMate  = diagNum + 2
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I   diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

        diagName  = 'DSLPvFlw'
        diagTitle = 'Merid. Down-Sloping Transport (v-component)'
        diagUnits = 'm^3/s           '
        diagCode  = 'VV      M1      '
        diagMate  = diagNum
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I   diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

        diagSufx  = 'aaaa'
#ifdef ALLOW_GENERIC_ADVDIFF
        diagSufx  = GAD_DIAG_SUFX( GAD_TEMPERATURE, myThid )
#endif
        diagName  = 'DSLP'//diagSufx
        diagTitle = 'Pot.Temp. tendency from Down-Slope package'
        diagUnits = 'K/s             '
        diagCode  = 'SMR     MR      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

#ifdef ALLOW_GENERIC_ADVDIFF
        diagSufx  = GAD_DIAG_SUFX( GAD_SALINITY, myThid )
#endif
        diagName  = 'DSLP'//diagSufx
        diagTitle = 'Salinity  tendency from Down-Slope package'
        diagUnits = 'g/kg/s          '
        diagCode  = 'SMR     MR      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

c     ENDIF

#endif /* ALLOW_DIAGNOSTICS */

      RETURN
      END

module OAD_tape

  implicit none

  private :: increment , dtt, itt, ltt, stt, & 
       init, dump_tapestats, & 
       dt_grow, it_grow, lt_grow, st_grow, &
       push_d0, push_i0, push_d1, push_i1, & 
       pop_d0, pop_i0, pop_d1, pop_i1, & 
       push_d4, push_d6, & 
       pop_d4, pop_d6
    
  public :: &
       oad_dt, oad_dt_ptr, oad_dt_sz, oad_dt_grow, &
       oad_it, oad_it_ptr, oad_it_sz, oad_it_grow, &
       oad_lt, oad_lt_ptr, oad_lt_sz, oad_lt_grow, &
       oad_st, oad_st_ptr, oad_st_sz, oad_st_grow, &
       oad_chunk_size, &
       oad_tape_init, &
       oad_dump_tapestats, & 
       oad_tape_push, oad_tape_pop
       
  double precision, dimension(:), allocatable :: oad_dt, dtt
  integer, dimension(:), allocatable :: oad_it, itt
  logical, dimension(:), allocatable :: oad_lt, ltt
  character(80), dimension(:), allocatable :: oad_st, stt
  integer :: oad_dt_ptr=0, oad_it_ptr=0
  integer :: oad_dt_sz=0, oad_it_sz=0
  integer :: oad_lt_ptr=0, oad_st_ptr=0
  integer :: oad_lt_sz=0, oad_st_sz=0
  integer :: increment
  integer :: oad_chunk_size

  interface oad_tape_init
    module procedure init
  end interface 

  interface oad_dump_tapestats
     module procedure dump_tapestats
  end interface

  interface oad_dt_grow
    module procedure dt_grow
  end interface

  interface oad_it_grow
    module procedure it_grow
  end interface

  interface oad_lt_grow
    module procedure lt_grow
  end interface

  interface oad_st_grow
    module procedure st_grow
  end interface

  interface oad_tape_push
     module procedure push_d0, push_i0
     module procedure push_d1, push_i1
     module procedure push_d4, push_d6
  end interface

  interface oad_tape_pop
     module procedure pop_d0, pop_i0
     module procedure pop_d1, pop_i1
     module procedure pop_d4, pop_d6
  end interface

contains

  subroutine init
    integer :: initialSize=1048576
    increment=16777216
    ! DT
    oad_dt_ptr=1
    if (allocated(oad_dt)) then 
       deallocate(oad_dt)
    end if
    oad_dt_sz=initialSize
    allocate(oad_dt(oad_dt_sz))
    ! IT
    oad_it_ptr=1
    if (allocated(oad_it)) then 
       deallocate(oad_it)
    end if
    oad_it_sz=initialSize
    allocate(oad_it(oad_it_sz))
    ! LT
    oad_lt_ptr=1
    if (allocated(oad_lt)) then 
       deallocate(oad_lt)
    end if
    oad_lt_sz=initialSize
    allocate(oad_lt(oad_lt_sz))
    ! ST
    oad_st_ptr=1
    if (allocated(oad_st)) then 
       deallocate(oad_st)
    end if
    oad_st_sz=initialSize
    allocate(oad_st(oad_st_sz))
  end subroutine init

  subroutine dump_tapestats()
    write(*,'(3(A,I9))',ADVANCE='NO') & 
         ' TD:',oad_dt_ptr,' TI:',oad_it_ptr, ' TS:',oad_st_ptr
  end subroutine dump_tapestats

  subroutine dt_grow
    integer status
    print *, "OAD: DT+ ", oad_dt_sz
    allocate(dtt(oad_dt_sz),STAT=status)
    if (status .gt. 0 ) then
       print *,'OAD: allocation (1)failed with', status
       stop
    end if
    dtt=oad_dt
    deallocate(oad_dt)
    allocate(oad_dt(oad_dt_sz+increment),STAT=status)
    if (status .gt. 0 ) then
       print *,'OAD: allocation (2)failed with', status
       stop
    end if
    oad_dt(1:oad_dt_sz) = dtt
    deallocate(dtt)
    oad_dt_sz=oad_dt_sz+increment
  end subroutine dt_grow

  subroutine it_grow
    integer status
    print *, "OAD: IT+ ", oad_it_sz
    allocate(itt(oad_it_sz),STAT=status)
    if (status .gt. 0 ) then
       print *,'OAD: allocation (1)failed with', status
       stop
    end if
    itt=oad_it
    deallocate(oad_it)
    allocate(oad_it(oad_it_sz+increment),STAT=status)
    if (status .gt. 0 ) then
       print *,'OAD: allocation (2)failed with', status
       stop
    end if
    oad_it(1:oad_it_sz) = itt
    deallocate(itt)
    oad_it_sz=oad_it_sz+increment
  end subroutine it_grow

  subroutine lt_grow
    integer status
    print *, "OAD: LT+ ", oad_lt_sz
    allocate(ltt(oad_lt_sz),STAT=status)
    if (status .gt. 0 ) then
       print *,'OAD: allocation (1)failed wlth', status
       stop
    end if
    ltt=oad_lt
    deallocate(oad_lt)
    allocate(oad_lt(oad_lt_sz+increment),STAT=status)
    if (status .gt. 0 ) then
       print *,'OAD: allocation (2)failed wlth', status
       stop
    end if
    oad_lt(1:oad_lt_sz) = ltt
    deallocate(ltt)
    oad_lt_sz=oad_lt_sz+increment
  end subroutine lt_grow

  subroutine st_grow
    integer status
    print *, "OAD: ST+ ", oad_st_sz
    allocate(stt(oad_st_sz),STAT=status)
    if (status .gt. 0 ) then
       print *,'OAD: allocation (1)failed wsth', status
       stop
    end if
    stt=oad_st
    deallocate(oad_st)
    allocate(oad_st(oad_st_sz+increment),STAT=status)
    if (status .gt. 0 ) then
       print *,'OAD: allocation (2)failed wsth', status
       stop
    end if
    oad_st(1:oad_st_sz) = stt
    deallocate(stt)
    oad_st_sz=oad_st_sz+increment
  end subroutine st_grow

  subroutine push_d0(v)
    implicit none
    double precision :: v
    if(oad_dt_sz .lt. oad_dt_ptr+1) call oad_dt_grow()
    oad_dt(oad_dt_ptr)=v; oad_dt_ptr=oad_dt_ptr+1
  end subroutine push_d0

  subroutine push_i0(v)
    implicit none
    integer :: v
    if(oad_it_sz .lt. oad_it_ptr+1) call oad_it_grow()
    oad_it(oad_it_ptr)=v; oad_it_ptr=oad_it_ptr+1
  end subroutine push_i0

  subroutine push_d1(v)
    implicit none
    double precision :: v(:)
    integer :: chunk
    chunk=size(v,1)
    if(oad_dt_sz .lt. oad_dt_ptr+chunk) call oad_dt_grow()
    oad_dt(oad_dt_ptr:oad_dt_ptr+chunk-1)=v; oad_dt_ptr=oad_dt_ptr+chunk
  end subroutine push_d1

  subroutine push_i1(v)
    implicit none
    integer :: v(:)
    integer :: chunk
    chunk=size(v,1)
    if(oad_it_sz .lt. oad_it_ptr+chunk) call oad_it_grow()
    oad_it(oad_it_ptr:oad_it_ptr+chunk-1)=v; oad_it_ptr=oad_it_ptr+chunk
  end subroutine push_i1

  subroutine push_d4(v)
    implicit none
    double precision :: v(:,:,:,:)
    integer :: chunk(1), dims(4)
    dims=shape(v)
    chunk(1)=dims(1)*dims(2)*dims(3)*dims(4)
    do while (oad_dt_sz .lt. oad_dt_ptr+chunk(1)) 
       call oad_dt_grow()
    end do
    oad_dt(oad_dt_ptr:oad_dt_ptr+chunk(1)-1)=reshape(v,chunk) 
    oad_dt_ptr=oad_dt_ptr+chunk(1)
  end subroutine push_d4

  subroutine push_d6(v)
    implicit none
    double precision :: v(:,:,:,:,:,:)
    integer :: chunk(1), dims(6)
    dims=shape(v)
    chunk(1)=dims(1)*dims(2)*dims(3)*dims(4)*dims(5)*dims(6)
    do while (oad_dt_sz .lt. oad_dt_ptr+chunk(1)) 
       call oad_dt_grow()
    end do
    oad_dt(oad_dt_ptr:oad_dt_ptr+chunk(1)-1)=reshape(v,chunk) 
    oad_dt_ptr=oad_dt_ptr+chunk(1)
  end subroutine push_d6

  subroutine pop_d0(v)
    implicit none
    double precision :: v
    oad_dt_ptr=oad_dt_ptr-1
    v=oad_dt(oad_dt_ptr)
  end subroutine pop_d0

  subroutine pop_i0(v)
    implicit none
    integer :: v
    oad_it_ptr=oad_it_ptr-1
    v=oad_it(oad_it_ptr)
  end subroutine pop_i0

  subroutine pop_d1(v)
    implicit none
    double precision :: v(:)
    integer :: chunk
    chunk=size(v,1)
    oad_dt_ptr=oad_dt_ptr-chunk    
    v=oad_dt(oad_dt_ptr:oad_dt_ptr+chunk-1)
  end subroutine pop_d1
  
  subroutine pop_i1(v)
    implicit none
    integer :: v(:)
    integer :: chunk
    chunk=size(v,1)
    oad_it_ptr=oad_it_ptr-chunk
    v=oad_it(oad_it_ptr:oad_it_ptr+chunk-1)
  end subroutine pop_i1

  subroutine pop_d4(v)
    implicit none
    double precision :: v(:,:,:,:)
    integer :: chunk, dims(4)
    dims=shape(v)
    chunk=dims(1)*dims(2)*dims(3)*dims(4)
    oad_dt_ptr=oad_dt_ptr-chunk
    v=reshape(oad_dt(oad_dt_ptr:oad_dt_ptr+chunk-1),dims) 
  end subroutine pop_d4

  subroutine pop_d6(v)
    implicit none
    double precision :: v(:,:,:,:,:,:)
    integer :: chunk, dims(6)
    dims=shape(v)
    chunk=dims(1)*dims(2)*dims(3)*dims(4)*dims(5)*dims(6)
    oad_dt_ptr=oad_dt_ptr-chunk
    v=reshape(oad_dt(oad_dt_ptr:oad_dt_ptr+chunk-1),dims) 
  end subroutine pop_d6

end module

#include "CTRL_OPTIONS.h"

C--  File ctrl_bound.F:
C--   Contents
C--   o ADCTRL_BOUND_3D
C--   o ADCTRL_BOUND_2D

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: ADCTRL_BOUND_3D
C     !INTERFACE:
      SUBROUTINE ADCTRL_BOUND_3D(
     U                fieldCur, adjFieldCur,
     I                mask3D, boundsVec, myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | started: Gael Forget gforget@mit.edu 20-Aug-2007
C     |
C     | o in forward mode: impose bounds on ctrl vector values
C     | o in adjoint mode: do nothing ... or emulate local minimum
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
      _RL fieldCur   (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      _RL adjFieldCur(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      _RS mask3D     (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      _RL boundsVec(5)
      INTEGER myThid

#ifdef ALLOW_ADCTRLBOUND
C     !LOCAL VARIABLES:
      INTEGER bi,bj,i,j,k
      _RL x0,x0p5,l0p5,x1,x2,x2p5,l2p5,x3
      _RL tmpCur,xCur,adxCur
CEOP

      x0=boundsVec(1)
      x1=boundsVec(2)
        x0p5=(x0+x1)/2.0
        l0p5=(x1-x0)/2.0
      x2=boundsVec(3)
      x3=boundsVec(4)
        x2p5=(x2+x3)/2.0
        l2p5=(x3-x2)/2.0

C  x0<x1<x2<x3  => ctrl_bound and adctrl_bound   act on xx/adxx
C  x0=x3        => ctrl_bound and adctrl_bound   DO nothing
C  otherwise    => error

      IF ( x0.LT.x3 ) THEN
       IF ( (x0.LT.x1).AND.(x1.LT.x2).AND.(x2.LT.x3) ) THEN

        DO bj=myByLo(myThid), myByHi(myThid)
         DO bi=myBxLo(myThid), myBxHi(myThid)

          DO k = 1,Nr
           DO j = 1,sNy
            DO i = 1,sNx
              IF (mask3D(i,j,k,bi,bj).NE.0.) THEN
                xCur=fieldCur(i,j,k,bi,bj)
                adxCur=adjFieldCur(i,j,k,bi,bj)
                IF ( (xCur.GT.x2).AND.(adxCur.LT.0.) ) THEN
                  tmpCur=1.0
                  adjFieldCur(i,j,k,bi,bj)=abs(adxCur)*
     &            min((xCur-x2p5)/l2p5,tmpCur)
                ENDIF
                IF ( (xCur.LT.x1).AND.(adxCur.GT.0.) ) THEN
                  tmpCur=-1.0
                  adjFieldCur(i,j,k,bi,bj)=abs(adxCur)*
     &            max((xCur-x0p5)/l0p5,tmpCur)
                ENDIF
              ENDIF
            ENDDO
           ENDDO
          ENDDO

         ENDDO
        ENDDO

       ELSE
          PRINT*,"boundsVec is not self-consistent"
          STOP 'ABNORMAL END: S/R ADCTRL_BOUND_3D'
       ENDIF
      ENDIF

#endif /* ALLOW_ADCTRLBOUND */

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: ADCTRL_BOUND_2D
C     !INTERFACE:
      SUBROUTINE ADCTRL_BOUND_2D(
     U                fieldCur, adjFieldCur,
     I                mask2D, boundsVec, myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | started: Gael Forget gforget@mit.edu 20-Aug-2007
C     |
C     | o in forward mode: impose bounds on ctrl vector values
C     | o in adjoint mode: DO nothing ... or emulate local minimum
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
      _RL fieldCur   (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL adjFieldCur(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RS mask2D     (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL boundsVec(5)
      INTEGER myThid

#ifdef ALLOW_ADCTRLBOUND
C     !LOCAL VARIABLES:
      INTEGER bi,bj,i,j
      _RL x0,x0p5,l0p5,x1,x2,x2p5,l2p5,x3
      _RL tmpCur,xCur,adxCur
CEOP

      x0=boundsVec(1)
      x1=boundsVec(2)
        x0p5=(x0+x1)/2.0
        l0p5=(x1-x0)/2.0
      x2=boundsVec(3)
      x3=boundsVec(4)
        x2p5=(x2+x3)/2.0
        l2p5=(x3-x2)/2.0

C  x0<x1<x2<x3  => ctrl_bound and adctrl_bound   act on xx/adxx
C  x0=x3        => ctrl_bound and adctrl_bound   DO nothing
C  otherwise    => error

      IF ( x0.LT.x3 ) THEN
       IF ( (x0.LT.x1).AND.(x1.LT.x2).AND.(x2.LT.x3) ) THEN

        DO bj=myByLo(myThid), myByHi(myThid)
         DO bi=myBxLo(myThid), myBxHi(myThid)

           DO j = 1,sNy
            DO i = 1,sNx
              IF (mask2D(i,j,bi,bj).NE.0.) THEN
                xCur=fieldCur(i,j,bi,bj)
                adxCur=adjFieldCur(i,j,bi,bj)
                IF ( (xCur.GT.x2).AND.(adxCur.LT.0.) ) THEN
                  tmpCur=1.0
                  adjFieldCur(i,j,bi,bj)=abs(adxCur)*
     &            min((xCur-x2p5)/l2p5,tmpCur)
                ENDIF
                IF ( (xCur.LT.x1).AND.(adxCur.GT.0.) ) THEN
                  tmpCur=-1.0
                  adjFieldCur(i,j,bi,bj)=abs(adxCur)*
     &            max((xCur-x0p5)/l0p5,tmpCur)
                ENDIF
              ENDIF
            ENDDO
           ENDDO

         ENDDO
        ENDDO

       ELSE
          PRINT*,"boundsVec is not self-consistent"
          STOP 'ABNORMAL END: S/R ADCTRL_BOUND_2D'
       ENDIF
      ENDIF

#endif /* ALLOW_ADCTRLBOUND */

      RETURN
      END

#include "CPP_OPTIONS.h"

CBOP 0
C !ROUTINE: CPL_RECV_ATM_ATMCONFIG

C !INTERFACE:
      SUBROUTINE CPL_RECV_ATM_ATMCONFIG

C !DESCRIPTION:
C     *==========================================================*
C     | SUBROUTINE CPL_RECV_ATM_ATMCONFIG
C     | o Routine for receiving atmos config into coupling level.
C     *==========================================================*
C     | This version talks to the MITgcm general circulation
C     | model. For now just get the models land/sea mask.
C     *==========================================================*

C !USES:
      IMPLICIT NONE
C     == Global variables ==
#include "ATMSIZE.h"
#include "ATMVARS.h"
#include "ATMIDS.h"
#include "CPL_PARAMS.h"

C !INPUT/OUTPUT PARAMETERS:
C !LOCAL VARIABLES:
      INTEGER tmpFld(1)
CEOP

C     Get config from atmos component
C     o receive number of coupler time-steps the atmos will do
      CALL COUPRECV_I4VEC( atmCompName,
     I                     'nCouplingSteps', 1,
     O                     tmpFld )
      nSteps_atm = tmpFld(1)

C     o receive Atmosphere Land/Sea mask
      CALL COUPRECV_R8TILES( atmCompName, atmLandName, Nx_atm, Ny_atm,
     &                       landMask_atm )

      RETURN
      END

#include "CPP_OPTIONS.h"

CBOP
C     !ROUTINE: PRESSURE_FOR_EOS
C     !INTERFACE:
      SUBROUTINE PRESSURE_FOR_EOS(
     I        bi, bj, iMin, iMax, jMin, jMax,  k, dpRef,
     O        locPres,
     I        myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE PRESSURE_FOR_EOS
C     | o Provide a local copy of the total pressure
C     |   at cell center (level k) for use in EOS funct. of P
C     | Note: Since most seawater EOS are formulated as function
C     |   of pressure anomaly relative to a reference P, this
C     |   S/R allows to account for this reference Pressure (or
C     |   different ref P) by adding a pressure shift "dpRef"
C     |   to the output pressure.
C     *==========================================================*
C     \ev

C     !USES:

      IMPLICIT NONE
C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "DYNVARS.h"
#ifdef ALLOW_NONHYDROSTATIC
# include "NH_VARS.h"
#endif /* ALLOW_NONHYDROSTATIC */

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     bi, bj, k :: tile and level indices
C     iMin,iMax :: computational domain, first index range
C     jMin,jMax :: computational domain, second index range
C     dpRef     :: shift applied to output pressure [Pa]
C     locPres   :: total pressure for use in EOS [Pa]
C     myThid    :: my Thread Id number
      INTEGER bi, bj, k
      INTEGER iMin,iMax,jMin,jMax
      _RL dpRef
      _RL locPres(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER myThid

C     !LOCAL VARIABLES:
C     == Local variables ==
C     i,j :: loop index
      INTEGER  i,j
CEOP

C     Provide the pressure for use in the equation of state

      IF ( usingZCoords ) THEN
C     in Z coordinates the pressure is rho0 * (hydrostatic) Potential
#ifdef ALLOW_NONHYDROSTATIC
       IF ( selectP_inEOS_Zc.EQ.3 ) THEN
C-     use full (hydrostatic+non-hydrostatic) dynamical pressure:
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
            locPres(i,j) = rhoConst*(
     &                   totPhiHyd(i,j,k,bi,bj)
     &                 +( phi_nh(i,j,k,bi,bj) - dPhiNH(i,j,bi,bj) )
     &                 + phiRef(2*k) ) + dpRef
          ENDDO
         ENDDO
       ELSEIF ( selectP_inEOS_Zc.EQ.2 ) THEN
#else /* ALLOW_NONHYDROSTATIC */
       IF     ( selectP_inEOS_Zc.EQ.2 ) THEN
#endif /* ALLOW_NONHYDROSTATIC */
C-     use hydrostatic dynamical pressure:
C----------
C     NOTE: For now, totPhiHyd only contains the Potential anomaly
C           since PhiRef has not (yet) been added in S/R DIAGS_PHI_HYD
C----------
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
            locPres(i,j) = rhoConst*(
     &                   totPhiHyd(i,j,k,bi,bj)
     &                 + phiRef(2*k) ) + dpRef
          ENDDO
         ENDDO
c      ELSEIF ( selectP_inEOS_Zc.EQ.1 ) THEN
C note: for the case selectP_inEOS_Zc=0, also use pRef4EOS (set to
C       rhoConst*phiRef(2*k) ) to reproduce same previous machine truncation
       ELSEIF ( selectP_inEOS_Zc.LE.1 ) THEN
C-     use horizontally uniform reference pressure pRef
C      (solution of: pRef = integral{-g*rho(Tref,Sref,pRef)*dz} )
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
            locPres(i,j) = pRef4EOS(k) + dpRef
          ENDDO
         ENDDO
       ELSE
C-     simplest case: -g*rhoConst*z
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
            locPres(i,j) = rhoConst*phiRef(2*k) + dpRef
          ENDDO
         ENDDO
       ENDIF
      ELSEIF ( usingPCoords ) THEN
C     in P coordinates the pressure is just the coordinate of
C     the tracer point
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
            locPres(i,j) = rC(k) + dpRef
          ENDDO
         ENDDO
      ENDIF

      RETURN
      END

#include "AUTODIFF_OPTIONS.h"
#include "MDSIO_OPTIONS.h"

CBOP
C !ROUTINE: ADAUTODIFF_WHTAPEIO_SYNC

C !INTERFACE: ==========================================================
      SUBROUTINE ADAUTODIFF_WHTAPEIO_SYNC(
     I     myLev, myStep, myThid )
C !DESCRIPTION:
C     Handwritten AD-routine of S/R AUTODIFF_WHTAPEIO_SYNC.  Used to set
C     and reseet the common block variable tapeFileUnit,
C     tapeFileCounter, and tapeBufferIO, etc. Only requried for tapes of
C     the initialisation phase

C !USES: ===============================================================
      IMPLICIT NONE
C     == Global variables ===
#include "SIZE.h"
#include "AUTODIFF.h"
#ifdef ALLOW_WHIO_3D
# include "MDSIO_BUFF_WH.h"
#endif

C !INPUT PARAMETERS: ===================================================
C     myLev     :: tape level identifier
C     myStep    :: identifies from where this routine is called
C                  (1,0 = before after ad-routines)
C     myThid    :: my Thread Id number
      INTEGER myThid
      INTEGER myLev
      INTEGER myStep
CEOP

#ifdef ALLOW_AUTODIFF_WHTAPEIO
C     reset
      tapeFileUnit=0
      tapeFileCounter=0
      tapeBufferIO=.FALSE.
# ifdef ALLOW_WHIO_3D
      writeWh=.FALSE.
      iWh=0
      jWh=0
# endif
C     This subroutine is always called first with myStep = 1 and then
C     with myStep = 0, so it is probably safe to always set the
C     tapeFileUnit here.
      IF ( myStep .EQ. 1 ) THEN
       tapeFileUnit = tapeFileUnitS(myLev)
       tapeBufferIO = .TRUE.
      ENDIF
#endif

      RETURN
      END

#include "AIM_OPTIONS.h"

CBOP
C     !ROUTINE: AIM_WRITE_LOCAL
C     !INTERFACE:
      SUBROUTINE AIM_WRITE_LOCAL(
     I               pref, suff, nNr, field,
     I               bi, bj, iRec, myIter, myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE AIM_WRITE_LOCAL
C     | o Write local variable from AIM physics (=> no overlap)
C     |   and reverse K index.
C     *==========================================================*
C     !USES
      IMPLICIT NONE

C     == Global variables ===
#include "AIM_SIZE.h"

#include "EEPARAMS.h"
c #include "PARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     pref   :: Prefix of the output file name
C     suff   :: Suffix of the output file name
C     nNr    :: 3rd dim. of the input field
C     field  :: Field (from aim-physics) to write
C     bi,bj  :: Tile index
C     iRec   :: reccord number in the output file
C     myIter :: Current iteration number in simulation
C     myThid :: my Thread Id number
      CHARACTER*(*) pref,suff
      INTEGER nNr
      _RL field(sNx,sNy,nNr)
      INTEGER bi, bj, iRec, myIter, myThid

#ifdef ALLOW_AIM

C     !FUNCTIONS:
      INTEGER  ILNBLNK
      EXTERNAL ILNBLNK

C     !LOCAL VARIABLES:
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      _RL tmpFld(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      INTEGER iL
      INTEGER i, j, k, Katm
CEOP

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C--   Check for argument list consistency
      IF ( nNr.LT.1 .OR. nNr.GT.Nr ) THEN
          iL = ILNBLNK( pref )
          WRITE(msgBuf,'(A,I10,A,2I5,A,I4,2A)')
     &      'AIM_WRITE_LOCAL (it=', myIter, ' bi,bj=', bi,bj,
     &      ' iRec=', iRec, ' ): try to write: ', pref(1:iL)
          CALL PRINT_ERROR( msgBuf, myThid )
          WRITE(msgBuf,'(A,I4,A,I4)')
     &      'AIM_WRITE_LOCAL: 3rd dim.(field)=',nNr,' has to be <',Nr
          CALL PRINT_ERROR( msgBuf , myThid)
          STOP 'ABNORMAL END: S/R AIM_WRITE_LOCAL'
      ENDIF

C-    Copy the input field into tempo. array:
      IF (nNr.EQ.Nr) THEN
C-     Reverse K index:
       DO k=1,Nr
        Katm = _KD2KA( k )
        DO j=1,sNy
         DO i=1,sNx
          tmpFld(i,j,k) = field(i,j,Katm)
         ENDDO
        ENDDO
       ENDDO
      ELSE
C-     Do simple copy
       DO k=1,nNr
        DO j=1,sNy
         DO i=1,sNx
          tmpFld(i,j,k) = field(i,j,k)
         ENDDO
        ENDDO
       ENDDO
      ENDIF

C-    Write to file:
      CALL WRITE_LOCAL_RL( pref, suff, nNr, tmpFld,
     &                     bi, bj, iRec, myIter, myThid )

#endif /* ALLOW_AIM */
      RETURN
      END

#include "OBSFIT_OPTIONS.h"
C--  File obsfit_active_file.F:
C--   Contents
C--   o active_read_obs_tile
C--   o active_write_obs_tile
C--   o active_read_obs_glob
C--   o active_write_obs_glob

CBOP
C     !ROUTINE: ACTIVE_READ_OBS_TILE

C     !INTERFACE:
      SUBROUTINE ACTIVE_READ_OBS_TILE(
     I                               active_num_file,
     O                               active_var,
     I                               irec,
     I                               lAdInit,
     I                               myOptimIter,
     I                               bi,
     I                               bj,
     I                               myThid,
     I                               dummy )
C     !DESCRIPTION:
C     ==================================================================
C     | Read an active record ("sample-equivalent") from an ObsFit
C     | .equi. tiled file (can be netcdf or binary)
C     ==================================================================

C     !USES:
      IMPLICIT NONE
C     == Global variables ===
#include "EEPARAMS.h"
#include "SIZE.h"
#ifdef ALLOW_OBSFIT
# include "OBSFIT_SIZE.h"
# include "OBSFIT.h"
#endif

C     !INPUT PARAMETERS:
C     active_num_file: file number
C     active_var:      array
C     irec:            record number
C     myOptimIter:     number of optimization iteration (default: 0)
C     myThid:          my thread ID number
C     lAdInit:         initialisation of corresponding adjoint
C                      variable and write to active file
      INTEGER  active_num_file
      _RL      active_var
      INTEGER  irec
      INTEGER  myOptimIter
      INTEGER  bi, bj, myThid
      LOGICAL  lAdInit
      _RL      dummy
CEOP

#ifdef ALLOW_OBSFIT

      CALL ACTIVE_READ_OBS_TILE_RL(
     I     fidfwd_obs(active_num_file,bi,bj), active_num_file,
     O     active_var,
     I     lAdInit, irec, sample_ind_glob(active_num_file,irec,bi,bj),
     I     FORWARD_SIMULATION, myOptimIter, bi, bj, myThid )

#endif

      RETURN
      END

C     ==================================================================

CBOP
C     !ROUTINE: ACTIVE_WRITE_OBS_TILE

C     !INTERFACE:
      SUBROUTINE ACTIVE_WRITE_OBS_TILE(
     I                           active_num_file,
     I                           active_var,
     I                           irec,
     I                           myOptimIter,
     I                           bi,
     I                           bj,
     I                           myThid,
     I                           dummy )

C     !DESCRIPTION:
C     ==================================================================
C     | Write to a file a sampled value during the model run
C     ==================================================================

C     !USES:
      IMPLICIT NONE
C     == Global variables ===
#include "EEPARAMS.h"
#include "SIZE.h"
#ifdef ALLOW_OBSFIT
# include "OBSFIT_SIZE.h"
# include "OBSFIT.h"
#endif

C     !INPUT PARAMETERS:
C     active_num_file: file number
C     active_var:      array
C     irec:            record number
C     myOptimIter:     number of optimization iteration (default: 0)
C     myThid:          my thread ID number
      INTEGER  active_num_file
      _RL      active_var
      INTEGER  irec
      INTEGER  myOptimIter
      INTEGER  bi, bj, myThid
      _RL      dummy
CEOP

#ifdef ALLOW_OBSFIT

      CALL ACTIVE_WRITE_OBS_TILE_RL(
     I     fidfwd_obs(active_num_file,bi,bj),
     I     active_num_file, active_var,
     I     irec, sample_ind_glob(active_num_file,irec,bi,bj),
     I     FORWARD_SIMULATION, myOptimIter, bi, bj, myThid )

#endif

      RETURN
      END

C     ==================================================================

CBOP
C     !ROUTINE: ACTIVE_READ_OBS_GLOB

C     !INTERFACE:
      SUBROUTINE ACTIVE_READ_OBS_GLOB(
     I                               active_num_file,
     O                               active_var,
     O                               active_mask,
     I                               irec,
     I                               lAdInit,
     I                               myOptimIter,
     I                               myThid,
     I                               dummy )

C     !DESCRIPTION:
C     ==================================================================
C     | Read an active record ("observation-equivalent") from a
C     | global file
C     ==================================================================

C     !USES:
      IMPLICIT NONE
C     == Global variables ===
#include "EEPARAMS.h"
#include "SIZE.h"
#ifdef ALLOW_OBSFIT
# include "OBSFIT_SIZE.h"
# include "OBSFIT.h"
#endif

C     !INPUT PARAMETERS:
C     active_num_file: file number
C     active_var:      array
C     active_mask:     array mask
C     irec:            record number
C     myOptimIter:     number of optimization iteration (default: 0)
C     myThid:          my thread ID number
C     lAdInit:         initialisation of corresponding adjoint
C                      variable and write to active file
      INTEGER  active_num_file
      _RL      active_var
      _RL      active_mask
      INTEGER  irec
      INTEGER  myOptimIter
      INTEGER  myThid
      LOGICAL  lAdInit
      _RL      dummy
CEOP

#ifdef ALLOW_OBSFIT
      CALL ACTIVE_READ_OBS_GLOB_RL(
     I     fidglobal(active_num_file), active_num_file,
     O     active_var, active_mask,
     I     lAdInit, irec, obs_ind_glob(active_num_file,irec),
     I     FORWARD_SIMULATION, myOptimIter, myThid )

#endif

      RETURN
      END

C     ==================================================================

CBOP
C     !ROUTINE: ACTIVE_WRITE_OBS_GLOB

C     !INTERFACE:
      SUBROUTINE ACTIVE_WRITE_OBS_GLOB(
     I                           active_num_file,
     I                           active_var,
     I                           active_mask,
     I                           irec,
     I                           myOptimIter,
     I                           myThid,
     I                           dummy )

C     !DESCRIPTION:
C     ==================================================================
C     | Write to a global file a model counterpart to an observation
C     ==================================================================

C     !USES:
      IMPLICIT NONE
C     == Global variables ===
#include "EEPARAMS.h"
#include "SIZE.h"
#ifdef ALLOW_OBSFIT
# include "OBSFIT_SIZE.h"
# include "OBSFIT.h"
#endif

C     !INPUT PARAMETERS:
C     active_num_file: file number
C     active_var:      array
C     active_mask:     array mask
C     irec:            record number
C     myOptimIter:     number of optimization iteration (default: 0)
C     myThid:          my thread ID number
      INTEGER  active_num_file
      _RL      active_var
      _RL      active_mask
      INTEGER  irec
      INTEGER  myOptimIter
      INTEGER  myThid
      _RL      dummy
CEOP

#ifdef ALLOW_OBSFIT
      CALL ACTIVE_WRITE_OBS_GLOB_RL(
     I     fidglobal(active_num_file), active_num_file,
     I     active_var, active_mask,
     I     irec, obs_ind_glob(active_num_file,irec),
     I     FORWARD_SIMULATION, myOptimIter, myThid )

#endif

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#include "SHAP_FILT_OPTIONS.h"

CBOP
C !ROUTINE: SHAP_FILT_APPLY_TS

C !INTERFACE: ==========================================================
      SUBROUTINE SHAP_FILT_APPLY_TS(
     U                     tFld, sFld,
     I                     myTime, myIter, myThid )

C !DESCRIPTION:
C Apply a Shapiro filter on active tracers tFld & sFld

C !USES: ===============================================================
      IMPLICIT NONE

#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "DYNVARS.h"
#include "GRID.h"
#include "SHAP_FILT.h"

C !INPUT PARAMETERS: ===================================================
C  myTime               :: current time
C  myIter               :: iteration number
C  myThid               :: thread number
      _RL myTime
      INTEGER myIter
      INTEGER myThid

C !INPUT/OUTPUT PARAMETERS: ============================================
C tFld                  :: input and filtered temperature field
C sFld                  :: input and filtered salinity field
      _RL  tFld(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      _RL  sFld(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)

#ifdef ALLOW_SHAP_FILT

      LOGICAL  DIFFERENT_MULTIPLE
      EXTERNAL DIFFERENT_MULTIPLE

C !LOCAL VARIABLES: ====================================================
C     == Local variables ==
#ifdef USE_OLD_SHAPIRO_FILTERS
C     bi,bj,k :: loop index
      INTEGER bi, bj, k
#endif /* USE_OLD_SHAPIRO_FILTERS */
      INTEGER exchInOut
      CHARACTER*(10) suff
CEOP

      IF (nShapT.GT.0 .OR. nShapS.GT.0) THEN

C-    Apply Exchanges on Input field, before the filter (but not after):
        exchInOut = 1
C-    Apply Exchanges on Output field, after the filter (but not before):
        IF ( implicitIntGravWave ) exchInOut = 2

#ifdef USE_OLD_SHAPIRO_FILTERS

        IF ( tempStepping ) _EXCH_XYZ_RL( tFld,myThid )
        IF ( saltStepping ) _EXCH_XYZ_RL( sFld,myThid )

        DO bj=myByLo(myThid),myByHi(myThid)
         DO bi=myBxLo(myThid),myBxHi(myThid)
          DO k=1, Nr
            IF ( tempStepping )
     &       CALL SHAP_FILT_TRACEROLD( tFld,bi,bj,k,myTime,myThid )
            IF ( saltStepping )
     &       CALL SHAP_FILT_TRACEROLD( sFld,bi,bj,k,myTime,myThid )
          ENDDO
         ENDDO
        ENDDO

        IF ( tempStepping ) _EXCH_XYZ_RL( tFld,myThid )
        IF ( saltStepping ) _EXCH_XYZ_RL( sFld,myThid )

#else

        IF ( tempStepping .AND. nShapT.GT.0) THEN
          IF (Shap_funct.EQ.1) THEN
            CALL SHAP_FILT_TRACER_S1(
     U           tFld, Shap_tmpFld1,
     I           nShapT, Nr, myTime, myThid )
          ELSEIF (Shap_funct.EQ.2 .OR. Shap_funct.EQ.20
     &                            .OR. Shap_funct.EQ.21) THEN
            CALL SHAP_FILT_TRACER_S2(
     U           tFld, Shap_tmpFld1,
     I           nShapT, exchInOut, Nr, myTime, myIter, myThid )
          ELSEIF (Shap_funct.EQ.4) THEN
            CALL SHAP_FILT_TRACER_S4(
     U           tFld, Shap_tmpFld1,
     I           nShapT, Nr, myTime, myThid )
c         ELSEIF (Shap_funct.EQ.20) THEN
c           CALL SHAP_FILT_TRACER_S2G(
c    U           tFld, Shap_tmpFld1,
c    I           nShapT, Nr, myTime, myThid )
          ELSE
           STOP 'SHAP_FILT_APPLY_TS: Ooops! Bad Shap_funct in T block'
          ENDIF

C-----    Diagnostic of Shapiro Filter effect on temperature :
C         Note: Shap_tmpFld1 from shap_filt_tracer_s2 (and not s1, s4)
C               is directly proportional to Delta-Tr due to the Filter
          IF ( Shap_funct.NE.1 .AND. Shap_funct.NE.4 .AND.
     &     DIFFERENT_MULTIPLE(Shap_diagFreq,myTime,deltaTClock)
     &       ) THEN
           _BARRIER
           IF ( rwSuffixType.EQ.0 ) THEN
             WRITE(suff,'(I10.10)') myIter
           ELSE
             CALL RW_GET_SUFFIX( suff, myTime, myIter, myThid )
           ENDIF
           CALL WRITE_FLD_XYZ_RL( 'shap_dT.', suff, Shap_tmpFld1,
     &                            myIter, myThid)
           _BARRIER
          ENDIF

#ifdef ALLOW_DIAGNOSTICS
          IF ( Shap_funct.NE.1 .AND. Shap_funct.NE.4
     &                         .AND. useDiagnostics ) THEN
            CALL DIAGNOSTICS_FILL(Shap_tmpFld1,'SHAP_dT ',0,Nr,
     &                                                  0,1,1,myThid)
          ENDIF
#endif /* ALLOW_DIAGNOSTICS */

        ENDIF

        IF ( saltStepping .AND. nShapS.GT.0) THEN
          IF (Shap_funct.EQ.1) THEN
            CALL SHAP_FILT_TRACER_S1(
     U           sFld, Shap_tmpFld1,
     I           nShapS, Nr, myTime, myThid )
          ELSEIF (Shap_funct.EQ.2 .OR. Shap_funct.EQ.20
     &                            .OR. Shap_funct.EQ.21) THEN
            CALL SHAP_FILT_TRACER_S2(
     U           sFld, Shap_tmpFld1,
     I           nShapS, exchInOut, Nr, myTime, myIter, myThid )
          ELSEIF (Shap_funct.EQ.4) THEN
            CALL SHAP_FILT_TRACER_S4(
     U           sFld, Shap_tmpFld1,
     I           nShapS, Nr, myTime, myThid )
c         ELSEIF (Shap_funct.EQ.20) THEN
c           CALL SHAP_FILT_TRACER_S2G(
c    U           sFld, Shap_tmpFld1,
c    I           nShapS, Nr, myTime, myThid )
          ELSE
           STOP 'SHAP_FILT_APPLY_TS: Ooops! Bad Shap_funct in S block'
          ENDIF

C-----    Diagnostic of Shapiro Filter effect on salinity :
C         Note: Shap_tmpFld1 from shap_filt_tracer_s2 (and not s1, s4)
C               is directly proportional to Delta-Tr due to the Filter
          IF ( Shap_funct.NE.1 .AND. Shap_funct.NE.4 .AND.
     &     DIFFERENT_MULTIPLE(Shap_diagFreq,myTime,deltaTClock)
     &       ) THEN
           _BARRIER
           IF ( rwSuffixType.EQ.0 ) THEN
             WRITE(suff,'(I10.10)') myIter
           ELSE
             CALL RW_GET_SUFFIX( suff, myTime, myIter, myThid )
           ENDIF
           CALL WRITE_FLD_XYZ_RL( 'shap_dS.', suff, Shap_tmpFld1,
     &                            myIter, myThid)
           _BARRIER
          ENDIF

#ifdef ALLOW_DIAGNOSTICS
          IF ( Shap_funct.NE.1 .AND. Shap_funct.NE.4
     &                         .AND. useDiagnostics ) THEN
            CALL DIAGNOSTICS_FILL(Shap_tmpFld1,'SHAP_dS ',0,Nr,
     &                                                  0,1,1,myThid)
          ENDIF
#endif /* ALLOW_DIAGNOSTICS */

        ENDIF

#endif /* USE_OLD_SHAPIRO_FILTERS */

      ENDIF

#endif /* ALLOW_SHAP_FILT */

      RETURN
      END

#include "MNC_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 1
C     !ROUTINE: MNC_CW_WRITE_CVAR

C     !INTERFACE:
      SUBROUTINE MNC_CW_WRITE_CVAR(
     I     fname,
     I     cvname,
     I     fid,
     I     did,
     I     bi, bj,
     I     myThid )

C     !DESCRIPTION:
C     Write a CF-convention coordinate variable (a vector).

C     !USES:
      implicit none
#include "MNC_COMMON.h"
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#ifdef ALLOW_EXCH2
#include "W2_EXCH2_SIZE.h"
#include "W2_EXCH2_TOPOLOGY.h"
#endif
#include "netcdf.inc"

C     Functions
      integer IFNBLNK, ILNBLNK

C     !INPUT PARAMETERS:
      character*(*) fname
      character*(*) cvname
      integer fid, did, bi,bj
      integer myThid
CEOP

C     !LOCAL VARIABLES:
      integer i, vid, nnf, nnl, doit, err
      integer nids, cv_did(1), xtmin,ytmin
      character*(MAX_LEN_MBUF) msgbuf
      integer cv_start(1), cv_count(1)
      _RS rtmp(sNx + 2*OLx + sNy + 2*OLy + Nr)
C     variables for text attributes
      integer MAX_LEN_NAME, ia
      PARAMETER ( MAX_LEN_NAME = 128 )
      character*(MAX_LEN_NAME) units, long_name, positive

      DO i=1,MAX_LEN_NAME
         units(i:i)     = ' '
         long_name(i:i) = ' '
         positive(i:i)  = ' '
      ENDDO

      nnf = IFNBLNK(cvname)
      nnl = ILNBLNK(cvname)

      xtmin = 0
      ytmin = 0
#ifdef ALLOW_EXCH2
      xtmin = exch2_tbasex(W2_myTileList(bi,bj))
      ytmin = exch2_tbasey(W2_myTileList(bi,bj))
#else
      IF ( .NOT. useCubedSphereExchange ) THEN
C     make sure for a non-cubed-sphere curvi-linear grid,
C     that the X/Y coordinate variables are monotonous
C     bi+(myXGlobalLo-1)/sNx is the i-tile number
C     bj+(myYGlobalLo-1)/sNy is the j-tile number
       xtmin = sNx * ( bi+(myXGlobalLo-1)/sNx - 1 )
       ytmin = sNy * ( bj+(myYGlobalLo-1)/sNy - 1 )
      ENDIF
#endif
      doit = 1
      nids = 1
      cv_did(1)= did

C     Check all the coordinate variables that we know about
      IF (cvname(nnf:nnl) .EQ. 'X') THEN

        cv_start(1) = 1
        cv_count(1) = sNx
#ifdef ALLOW_EXCH2
        DO i = cv_start(1),cv_count(1)
         rtmp(i) = xtmin + i
        ENDDO
#else
        IF ( usingCurvilinearGrid .OR. rotateGrid ) THEN
         DO i = cv_start(1),cv_count(1)
          rtmp(i) = xtmin + i
         ENDDO
        ELSE
         DO i = cv_start(1),cv_count(1)
          rtmp(i) = xC(i,1,bi,bj)
         ENDDO
        ENDIF
#endif
        IF ( usingCartesianGrid ) THEN
         long_name = 'X-coordinate of cell center'
         units     = 'meters'
        ELSEIF ( usingCurvilinearGrid .OR. rotateGrid ) THEN
         long_name = 'i-index of cell center'
         units     = 'none'
        ELSEIF ( usingSphericalPolarGrid ) THEN
         long_name = 'longitude of cell center'
         units     = 'degrees_east'
        ELSEIF ( usingCylindricalGrid ) THEN
         long_name = 'polar angle coordinate of cell center'
         units     = 'degrees'
        ELSE
C       unknown grid type
         print *, 'S/R MNC_CW_CVARS: Ooops, unknown horizontal grid!'
        ENDIF

      ELSEIF (cvname(nnf:nnl) .EQ. 'Xp1') THEN

        cv_start(1) = 1
        cv_count(1) = sNx + 1
#ifdef ALLOW_EXCH2
        DO i = cv_start(1),cv_count(1)
         rtmp(i) = xtmin + i
        ENDDO
#else
        IF ( usingCurvilinearGrid .OR. rotateGrid ) THEN
         DO i = cv_start(1),cv_count(1)
          rtmp(i) = xtmin + i
         ENDDO
        ELSE
         DO i = cv_start(1),cv_count(1)
          rtmp(i) = xG(i,1,bi,bj)
         ENDDO
        ENDIF
#endif
        IF ( usingCartesianGrid ) THEN
         long_name = 'X-Coordinate of cell corner'
         units     = 'meters'
        ELSEIF ( usingCurvilinearGrid .OR. rotateGrid ) THEN
         long_name = 'i-index of cell corner'
         units     = 'none'
        ELSEIF ( usingSphericalPolarGrid ) THEN
         long_name = 'longitude of cell corner'
         units     = 'degrees_east'
        ELSEIF ( usingCylindricalGrid ) THEN
         long_name = 'polar angle  of cell corner'
         units     = 'degrees'
        ELSE
C       unknown grid type
         print *, 'S/R MNC_CW_CVARS: Ooops, unknown horizontal grid!'
        ENDIF

      ELSEIF (cvname(nnf:nnl) .EQ. 'Xwh') THEN

        cv_start(1) = 1
        cv_count(1) = sNx + 2*OLx
#ifdef ALLOW_EXCH2
        DO i = cv_start(1),cv_count(1)
         rtmp(i) = xtmin + i
        ENDDO
#else
        IF ( usingCurvilinearGrid .OR. rotateGrid ) THEN
         DO i = cv_start(1),cv_count(1)
          rtmp(i) = xtmin - OLx + i
         ENDDO
        ELSE
         DO i = cv_start(1),cv_count(1)
          rtmp(i) = xC(i,1,bi,bj)
CML????          rtmp(i) = xC(i-Olx,1,bi,bj)
         ENDDO
        ENDIF
#endif
        IF ( usingCartesianGrid ) THEN
         long_name = 'X-Coordinate of cell center including overlaps'
         units     = 'meters'
        ELSEIF ( usingCurvilinearGrid .OR. rotateGrid ) THEN
         long_name = 'i-index of cell center including overlaps'
         units     = 'none'
        ELSEIF ( usingSphericalPolarGrid ) THEN
         long_name = 'longitude of cell center including overlaps'
         units     = 'degrees_east'
        ELSEIF ( usingCylindricalGrid ) THEN
         long_name =
     &        'polar angle coordinate of cell center including overlaps'
         units     = 'degrees'
        ELSE
C       unknown grid type
         print *, 'S/R MNC_CW_CVARS: Ooops, unknown horizontal grid!'
        ENDIF

      ELSEIF (cvname(nnf:nnl) .EQ. 'Y') THEN

        cv_start(1) = 1
        cv_count(1) = sNy
#ifdef ALLOW_EXCH2
        DO i = cv_start(1),cv_count(1)
         rtmp(i) = ytmin + i
        ENDDO
#else
        IF ( usingCurvilinearGrid .OR. rotateGrid ) THEN
         DO i = cv_start(1),cv_count(1)
          rtmp(i) = ytmin + i
         ENDDO
        ELSE
         DO i = cv_start(1),cv_count(1)
          rtmp(i) = yC(1,i,bi,bj)
         ENDDO
        ENDIF
#endif
        IF ( usingCartesianGrid ) THEN
         long_name = 'Y-Coordinate of cell center'
         units     = 'meters'
        ELSEIF ( usingCurvilinearGrid .OR. rotateGrid ) THEN
         long_name = 'j-index of cell center'
         units     = 'none'
        ELSEIF ( usingSphericalPolarGrid ) THEN
         long_name = 'latitude of cell center'
         units     = 'degrees_north'
        ELSEIF ( usingCylindricalGrid ) THEN
         long_name = 'radial coordinate of cell center'
         units     = 'meters'
        ELSE
C       unknown grid type
         print *, 'S/R MNC_CW_CVARS: Ooops, unknown horizontal grid!'
        ENDIF

      ELSEIF (cvname(nnf:nnl) .EQ. 'Yp1') THEN

        cv_start(1) = 1
        cv_count(1) = sNy + 1
#ifdef ALLOW_EXCH2
        DO i = cv_start(1),cv_count(1)
         rtmp(i) = ytmin + i
        ENDDO
#else
        IF ( usingCurvilinearGrid .OR. rotateGrid ) THEN
         DO i = cv_start(1),cv_count(1)
          rtmp(i) = ytmin + i
         ENDDO
        ELSE
         DO i = cv_start(1),cv_count(1)
          rtmp(i) = yG(1,i,bi,bj)
         ENDDO
        ENDIF
#endif
        IF ( usingCartesianGrid ) THEN
         long_name = 'Y-Coordinate of cell corner'
         units     = 'meters'
        ELSEIF ( usingCurvilinearGrid .OR. rotateGrid ) THEN
         long_name = 'j-index of cell corner'
         units     = 'none'
        ELSEIF ( usingSphericalPolarGrid ) THEN
         long_name = 'latitude of cell corner'
         units     = 'degrees_north'
        ELSEIF ( usingCylindricalGrid ) THEN
         long_name = 'radial coordinate of cell corner'
         units     = 'meters'
        ELSE
C       unknown grid type
         print *, 'S/R MNC_CW_CVARS: Ooops, unknown horizontal grid!'
        ENDIF

      ELSEIF (cvname(nnf:nnl) .EQ. 'Ywh') THEN

        cv_start(1) = 1
        cv_count(1) = sNy + 2*OLy
#ifdef ALLOW_EXCH2
        DO i = cv_start(1),cv_count(1)
         rtmp(i) = ytmin + i
        ENDDO
#else
        IF ( usingCurvilinearGrid .OR. rotateGrid ) THEN
         DO i = cv_start(1),cv_count(1)
          rtmp(i) = ytmin - OLy + i
         ENDDO
        ELSE
         DO i = cv_start(1),cv_count(1)
          rtmp(i) = yC(1,i-OLy,bi,bj)
         ENDDO
        ENDIF
#endif
        IF ( usingCartesianGrid ) THEN
         long_name = 'Y-Coordinate of cell center including overlaps'
         units     = 'meters'
        ELSEIF ( usingCurvilinearGrid .OR. rotateGrid ) THEN
         long_name = 'j-index of cell center including overlaps'
         units     = 'none'
        ELSEIF ( usingSphericalPolarGrid ) THEN
         long_name = 'latitude of cell center including overlaps'
         units     = 'degrees_north'
        ELSEIF ( usingCylindricalGrid ) THEN
         long_name =
     &        'radial coordinate of cell center including overlaps'
         units     = 'meters'
        ELSE
C       unknown grid type
         print *, 'S/R MNC_CW_CVARS: Ooops, unknown horizontal grid!'
        ENDIF

      ELSEIF (cvname(nnf:nnl) .EQ. 'Z') THEN

        cv_start(1) = 1
        cv_count(1) = Nr
        DO i = cv_start(1),cv_count(1)
          rtmp(i) = rC(i)
        ENDDO
C
        long_name = 'vertical coordinate of cell center'
        IF ( usingZCoords ) THEN
         units     = 'meters'
         positive  = 'up'
        ELSEIF ( usingPCoords ) THEN
         units     = 'pascal'
        ELSE
C       unknown grid type
         print *, 'S/R MNC_CW_CVARS: Ooops, unknown vertical grid!'
        ENDIF

      ELSEIF (cvname(nnf:nnl) .EQ. 'Zp1') THEN

        cv_start(1) = 1
        cv_count(1) = Nr + 1
        DO i = cv_start(1),cv_count(1)
          rtmp(i) = rF(i)
        ENDDO
C
        long_name = 'vertical coordinate of cell interface'
        IF ( usingZCoords ) THEN
         units     = 'meters'
         positive  = 'up'
        ELSEIF ( usingPCoords ) THEN
         units     = 'pascal'
        ELSE
C       unknown grid type
         print *, 'S/R MNC_CW_CVARS: Ooops, unknown vertical grid!'
        ENDIF

      ELSEIF (cvname(nnf:nnl) .EQ. 'Zu') THEN

        cv_start(1) = 1
        cv_count(1) = Nr
        DO i = cv_start(1),cv_count(1)
          rtmp(i) = rF(i + 1)
        ENDDO
C
        IF ( usingZCoords ) THEN
         long_name = 'vertical coordinate of lower cell interface'
         units     = 'meters'
         positive  = 'up'
        ELSEIF ( usingPCoords ) THEN
         long_name = 'vertical coordinate of upper cell interface'
         units     = 'pascal'
        ELSE
C       unknown grid type
         print *, 'S/R MNC_CW_CVARS: Ooops, unknown vertical grid!'
        ENDIF

      ELSEIF (cvname(nnf:nnl) .EQ. 'Zl') THEN

        cv_start(1) = 1
        cv_count(1) = Nr
        DO i = cv_start(1),cv_count(1)
          rtmp(i) = rF(i)
        ENDDO
C
        IF ( usingZCoords ) THEN
         long_name = 'vertical coordinate of upper cell interface'
         units     = 'meters'
         positive  = 'up'
        ELSEIF ( usingPCoords ) THEN
         long_name = 'vertical coordinate of lower cell interface'
         units     = 'pascal'
        ELSE
C       unknown grid type
         print *, 'S/R MNC_CW_CVARS: Ooops, unknown vertical grid!'
        ENDIF

      ELSEIF (cvname(nnf:nnl) .EQ. 'Zm1') THEN

        cv_start(1) = 1
        cv_count(1) = Nr - 1
        DO i = cv_start(1),cv_count(1)
          rtmp(i) = rF(i + 1)
        ENDDO
C
        IF ( usingZCoords ) THEN
         long_name = 'vertical coordinate of lower cell interface'
         units     = 'meters'
         positive  = 'up'
        ELSEIF ( usingPCoords ) THEN
         long_name = 'vertical coordinate of upper cell interface'
         units     = 'pascal'
        ELSE
C       unknown grid type
         print *, 'S/R MNC_CW_CVARS: Ooops, unknown vertical grid!'
        ENDIF

      ELSE

        doit = 0

      ENDIF

      IF ( doit .EQ. 1 ) THEN

        CALL MNC_FILE_REDEF(fname, myThid)
#ifdef REAL4_IS_SLOW
        err = NF_DEF_VAR(fid, cvname, NF_DOUBLE,
     &       nids, cv_did, vid)
#else
        err = NF_DEF_VAR(fid, cvname, NF_FLOAT,
     &       nids, cv_did, vid)
#endif /* REAL4_IS_SLOW */
        i = ILNBLNK( fname )
        write(msgbuf,'(5a)') 'defining coordinate variable ''',
     &       cvname(nnf:nnl), ''' in file ''', fname(1:i), ''''
        CALL MNC_HANDLE_ERR(err, msgbuf, myThid)
C     add attributes if set
        ia = ILNBLNK(long_name)
        IF ( ia .GT. 0 ) THEN
         err = NF_PUT_ATT_TEXT(fid, vid, 'long_name', ia, long_name)
         write(msgbuf,'(5a)')
     &     'adding attribute ''long_name'' to coordinate variable ''',
     &     cvname(nnf:nnl), ''' in file ''', fname(1:i), ''''
         CALL MNC_HANDLE_ERR(err, msgbuf, myThid)
        ENDIF
        ia = ILNBLNK(units)
        IF ( ia .GT. 0 ) THEN
         err = NF_PUT_ATT_TEXT(fid, vid, 'units', ia, units)
         write(msgbuf,'(5a)')
     &     'adding attribute ''units'' to coordinate variable ''',
     &     cvname(nnf:nnl), ''' in file ''', fname(1:i), ''''
         CALL MNC_HANDLE_ERR(err, msgbuf, myThid)
        ENDIF
        ia = ILNBLNK(positive)
        IF ( ia .GT. 0 ) THEN
         err = NF_PUT_ATT_TEXT(fid, vid, 'positive', ia, positive)
         write(msgbuf,'(5a)')
     &     'adding attribute ''positive'' to coordinate variable ''',
     &     cvname(nnf:nnl), ''' in file ''', fname(1:i), ''''
         CALL MNC_HANDLE_ERR(err, msgbuf, myThid)
        ENDIF
C
        CALL MNC_FILE_ENDDEF(fname, myThid)
#ifdef REAL4_IS_SLOW
        err = NF_PUT_VARA_DOUBLE(fid, vid,
     &       cv_start, cv_count, rtmp)
#else
        err = NF_PUT_VARA_REAL(fid, vid,
     &       cv_start, cv_count, rtmp)
#endif /* REAL4_IS_SLOW */
        write(msgbuf,'(5a)') 'writing coordinate variable ''',
     &       cvname(nnf:nnl), ''' in file ''', fname(1:i), ''''
        CALL MNC_HANDLE_ERR(err, msgbuf, myThid)

      ENDIF

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#include "AIM_OPTIONS.h"

      SUBROUTINE INPHYS (HSG, myThid)

      IMPLICIT NONE

C--
C--   SUBROUTINE INPHYS (HSG,PPL,RLAT)
C--
C--   Purpose: Initialize common blocks for physical parametrization routines 
C--   Input :  HSG  : sigma at half levels
C--            PPL  : pressure levels for post-processing
C--            RLAT : gaussian-grid latitudes
C--   Initialized common blocks: PHYCON, FSIGLT, FORCON,
C--                              CNVCON, LSCCON, RADCON, SFLCON, VDICON
C--
C     Resolution parameters

C-- size for MITgcm & Physics package :
#include "AIM_SIZE.h" 

#include "GRID.h"
#include "EEPARAMS.h"
#include "PARAMS.h"

c #include "AIM_GRID.h"

C     Physical constants + functions of sigma and latitude

#include "com_physcon.h"

C     Constants for sub-grid-scale physics

#include "com_forcon.h"
#include "com_cnvcon.h"
#include "com_lsccon.h"
#include "com_radcon.h"  
#include "com_sflcon.h"
#include "com_vdicon.h"  

C     == Routine Arguments ==
      INTEGER myThid
c     REAL HSG(0:NLEV), PPL(NLEV), RLAT(NLAT)  
      _RL  HSG(0:NLEV)

#ifdef ALLOW_AIM

C     == Local Variables ==
      INTEGER K

      _BEGIN_MASTER(myThid)  

C---  1. Time independent parameters and arrays
C
C     1.1 Physical constants

c     P0 = 1. _d +5
c     GG = 9.81 _d 0
c     RD = 287. _d 0
c     CP = 1004. _d 0
      P0 = atm_Po
      GG = gravity
      RD = atm_Rd
      CP = atm_Cp
C     Latent heat is in J/g for consistency with spec.hum. in g/Kg
      ALHC = 2501. _d 0
      ALHF =  334. _d 0
      SBC = 5.67 _d -8
C     Heat capacity of rain is also in J/g/K for the same reasons
c     rainCP = HeatCapacity_Cp / 1000. _d 0 
      rainCP = 4200. _d 0 / 1000. _d 0 
      tFreeze= celsius2K
C
C     1.2 Functions of sigma and latitude
C
      SIGH(0)=HSG(0)
C
      DO K=1,NLEV
       SIG(K)  = 0.5*(HSG(K)+HSG(K-1))
       SIGL(K) = LOG(SIG(K))
       SIGH(K) = HSG(K)
       DSIG(K) = HSG(K)-HSG(K-1)
c      POUT(K) = PPL(K)
       GRDSIG(K) = GG/(DSIG(K)*P0)
       GRDSCP(K) = GRDSIG(K)/CP  
      ENDDO
C
C     Weights for vertical interpolation at half-levels(1,nlev) and surface
C     Note that for phys.par. half-lev(k) is between full-lev k and k+1 
C     Fhalf(k) = Ffull(k)+WVI(K,2)*(Ffull(k+1)-Ffull(k))
C     Fsurf = Ffull(nlev)+WVI(nlev,2)*(Ffull(nlev)-Ffull(nlev-1))
C
      DO K=1,NLEV-1
       WVI(K,1)=1./(SIGL(K+1)-SIGL(K))
       WVI(K,2)=(LOG(SIGH(K))-SIGL(K))*WVI(K,1)
      ENDDO
C
      WVI(NLEV,1)=0.
      WVI(NLEV,2)=-SIGL(NLEV)*WVI(NLEV-1,2)
 
c--- jmc: write WVI to check:
      WRITE(standardMessageUnit,'(A)')
     &     '- INPHYS: k,SIG, SIGH,   SIGL,   WVI(1),  WVI(2):'
      DO K=1,NLEV
       WRITE(standardMessageUnit,'(I3,6F9.4)') 
     &      k,SIG(k),SIGH(k),SIGL(k),WVI(K,1),WVI(K,2)
      ENDDO
      WRITE(standardMessageUnit,'(A)') '- INPHYS: end setup WVI.'
c--- jmc.

c- jmc: initialize SLAT & CLAT in aim_dyn2aim.F
c     DO J=1,NLAT
c      SLAT(J)=SIN(RLAT(J))
c      CLAT(J)=COS(RLAT(J))
c     ENDDO

C--   2. Constants for physical parametrization routines:
 
c_FM  include "cls_inphys.h"
#include "phy_const.h"
 
C-     pot. temp. increment for computing stability function derivative
C      note: use the discrete form: F(Ts+dTstab)-F(Ts-dTstab)/2.dTstab 
       dTstab = 1. _d 0

      _END_MASTER(myThid)

#endif /* ALLOW_AIM */ 

      RETURN
      END

#include "OBCS_OPTIONS.h"

CBOP
C     !ROUTINE: OBCS_APPLY_W
C     !INTERFACE:
      SUBROUTINE OBCS_APPLY_W( bi, bj, kArg,
     U                         wFld,
     I                         myThid )

C     !DESCRIPTION:
C     *==========================================================*
C     | S/R OBCS_APPLY_W
C     |   Apply vertical velocity OB values
C     |   to corresponding field array
C     *==========================================================*

C     !USES:
      IMPLICIT NONE
C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "OBCS_PARAMS.h"
#include "OBCS_GRID.h"
#include "OBCS_FIELDS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine Arguments ==
C    bi, bj   :: indices of current tile
C    kArg     :: index of current level which OBC apply to
C                or if zero, apply to all levels
C    wFld     :: vertical velocity field
C    myThid   :: my Thread Id number
      INTEGER bi, bj
      INTEGER kArg
      _RL wFld(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      INTEGER myThid
CEOP

#ifdef ALLOW_NONHYDROSTATIC
C     !LOCAL VARIABLES:
C     == Local variables ==
      INTEGER kLo, kHi
      INTEGER k, km1
      INTEGER i, j
      INTEGER Iobc, Jobc
      _RL obc_mask

      IF ( nonHydrostatic ) THEN

        IF ( kArg.EQ.0 ) THEN
          kLo = 1
          kHi = Nr
        ELSE
          k   = kArg
          km1 = MAX( k-1, 1 )
        ENDIF

C     Set model variables to OB values on North/South Boundaries
#ifdef ALLOW_OBCS_NORTH
        IF ( tileHasOBN(bi,bj) ) THEN
C Northern boundary
         DO i=1-OLx,sNx+OLx
          Jobc = OB_Jn(i,bi,bj)
          IF ( Jobc.NE.OB_indexNone .AND. kArg.EQ.0 ) THEN
           DO k = kLo,kHi
            km1 = MAX( k-1, 1 )
            obc_mask = maskC(i,Jobc,km1,bi,bj)*maskC(i,Jobc,k,bi,bj)
            wFld(i,Jobc,k,bi,bj) = OBNw(i,k,bi,bj)*obc_mask
           ENDDO
          ELSEIF ( Jobc.NE.OB_indexNone ) THEN
            obc_mask = maskC(i,Jobc,km1,bi,bj)*maskC(i,Jobc,k,bi,bj)
            wFld(i,Jobc,k,bi,bj) = OBNw(i,k,bi,bj)*obc_mask
          ENDIF
         ENDDO
        ENDIF
#endif /* ALLOW_OBCS_NORTH */

#ifdef ALLOW_OBCS_SOUTH
        IF ( tileHasOBS(bi,bj) ) THEN
C Southern boundary
         DO i=1-OLx,sNx+OLx
          Jobc = OB_Js(i,bi,bj)
          IF ( Jobc.NE.OB_indexNone .AND. kArg.EQ.0 ) THEN
           DO k = kLo,kHi
            km1 = MAX( k-1, 1 )
            obc_mask = maskC(i,Jobc,km1,bi,bj)*maskC(i,Jobc,k,bi,bj)
            wFld(i,Jobc,k,bi,bj) = OBSw(i,k,bi,bj)*obc_mask
           ENDDO
          ELSEIF ( Jobc.NE.OB_indexNone ) THEN
            obc_mask = maskC(i,Jobc,km1,bi,bj)*maskC(i,Jobc,k,bi,bj)
            wFld(i,Jobc,k,bi,bj) = OBSw(i,k,bi,bj)*obc_mask
          ENDIF
         ENDDO
        ENDIF
#endif /* ALLOW_OBCS_SOUTH */

C     Set model variables to OB values on East/West Boundaries
#ifdef ALLOW_OBCS_EAST
        IF ( tileHasOBE(bi,bj) ) THEN
C Eastern boundary
         DO j=1-OLy,sNy+OLy
          Iobc = OB_Ie(j,bi,bj)
          IF ( Iobc.NE.OB_indexNone .AND. kArg.EQ.0 ) THEN
           DO k = kLo,kHi
            km1 = MAX( k-1, 1 )
            obc_mask = maskC(Iobc,j,km1,bi,bj)*maskC(Iobc,j,k,bi,bj)
            wFld(Iobc,j,k,bi,bj) = OBEw(j,k,bi,bj)*obc_mask
           ENDDO
          ELSEIF ( Iobc.NE.OB_indexNone ) THEN
            obc_mask = maskC(Iobc,j,km1,bi,bj)*maskC(Iobc,j,k,bi,bj)
            wFld(Iobc,j,k,bi,bj) = OBEw(j,k,bi,bj)*obc_mask
          ENDIF
         ENDDO
        ENDIF
#endif /* ALLOW_OBCS_EAST */

#ifdef ALLOW_OBCS_WEST
        IF ( tileHasOBW(bi,bj) ) THEN
C Western boundary
         DO j=1-OLy,sNy+OLy
          Iobc = OB_Iw(j,bi,bj)
          IF ( Iobc.NE.OB_indexNone .AND. kArg.EQ.0 ) THEN
           DO k = kLo,kHi
            km1 = MAX( k-1, 1 )
            obc_mask = maskC(Iobc,j,km1,bi,bj)*maskC(Iobc,j,k,bi,bj)
            wFld(Iobc,j,k,bi,bj) = OBWw(j,k,bi,bj)*obc_mask
           ENDDO
          ELSEIF ( Iobc.NE.OB_indexNone ) THEN
            obc_mask = maskC(Iobc,j,km1,bi,bj)*maskC(Iobc,j,k,bi,bj)
            wFld(Iobc,j,k,bi,bj) = OBWw(j,k,bi,bj)*obc_mask
          ENDIF
         ENDDO
        ENDIF
#endif /* ALLOW_OBCS_WEST */

      ENDIF
#endif /* ALLOW_NONHYDROSTATIC */

      RETURN
      END

#include "CPP_OPTIONS.h"

CBOP 0
C !ROUTINE: CPL_INIT_ATM_VARS

C !INTERFACE:
      SUBROUTINE CPL_INIT_ATM_VARS( msgUnit )

C !DESCRIPTION:
C     *==========================================================*
C     | SUBROUTINE CPL_INIT_ATM_VARS
C     | o Initialise to zero all ATMVARS.h arrays
C     *==========================================================*

C !USES:
      IMPLICIT NONE
C     == Global variables ==
#include "ATMSIZE.h"
#include "ATMVARS.h"
c#include "ATMIDS.h"

C !INPUT PARAMETERS:
C     msgUnit          :: log-file I/O unit
      INTEGER msgUnit

C !LOCAL VARIABLES:
C     i,j     :: loop index
      INTEGER i, j
CEOP

      WRITE(msgUnit,'(2A)') 'CPL_INIT_ATM_VARS: ',
     &                      'initialise all ATMVARS.h arrays'

      DO j=1,Ny_atm
        DO i=1,Nx_atm
          landMask_atm   (i,j) = 0. _d 0
          OcMxlD_atm     (i,j) = 0. _d 0
          SST_atm        (i,j) = 0. _d 0
          SSS_atm        (i,j) = 0. _d 0
          vSq_atm        (i,j) = 0. _d 0
          fluxCO2_atm    (i,j) = 0. _d 0
          atmSLPr_atm    (i,j) = 0. _d 0
          HeatFlux_atm   (i,j) = 0. _d 0
          qShortWave_atm (i,j) = 0. _d 0
          TauX_atm       (i,j) = 0. _d 0
          TauY_atm       (i,j) = 0. _d 0
          EvMPr_atm      (i,j) = 0. _d 0
          RunOff_atm     (i,j) = 0. _d 0
          ROEnFx_atm     (i,j) = 0. _d 0
          SaltFlx_atm    (i,j) = 0. _d 0
          sIceMass_atm   (i,j) = 0. _d 0
          saltPlmFlx_atm (i,j) = 0. _d 0
          aCO2_atm       (i,j) = 0. _d 0
          wSpeed_atm     (i,j) = 0. _d 0
          sIceFrac_atm   (i,j) = 0. _d 0
          sIceThick_atm  (i,j) = 0. _d 0
          sIceSnowH_atm  (i,j) = 0. _d 0
          sIceQ1_atm     (i,j) = 0. _d 0
          sIceQ2_atm     (i,j) = 0. _d 0
        ENDDO
      ENDDO

      RETURN
      END

#include "STREAMICE_OPTIONS.h"
#ifdef ALLOW_COST
#include "COST_OPTIONS.h"
#endif

      subroutine streamice_cost_final( myThid )
C     /==========================================================\
C     | subroutine streamice_cost_final                          |
C     | o this routine computes the cost function contribution   |
C     |   from the STREAMICE package for the tiles of this       |
C     |   processor. Called from cost_final                      |
C     |==========================================================|
C     |                                                          |
C     | Notes                                                    |
C     | =====                                                    |
C     \==========================================================/
      IMPLICIT NONE

C     == Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "DYNVARS.h"
#include "GRID.h"
#ifdef ALLOW_STREAMICE
# include "STREAMICE.h"
#endif

#ifdef ALLOW_COST
#include "cost.h"
#endif

C     == Routine arguments ==
C     myThid - Thread number for this instance of the routine.
      integer myThid

#ifdef ALLOW_COST_STREAMICE
C     == Local variables
      integer bi, bj
      integer i, j
      integer itlo,ithi
      integer jtlo,jthi
C     unused variables
c     integer ig, jg
c     _RL dhdt, dhdt_fac, dmdx, dmdy
      _RL i_numcells, dCdx, dCdy, dBdx, dBdy, idt
      _RL utmp, vtmp, uotmp, votmp, cotmp
      _RL dRdx, dRdy, cfricval, bglenval, cfricvalp1, bglenvalp1
      INTEGER  ILNBLNK
      EXTERNAL ILNBLNK
      CHARACTER*(MAX_LEN_FNAM) STREAMICExvelOptimFile
      CHARACTER*(MAX_LEN_FNAM) STREAMICEyvelOptimFile
      CHARACTER*(MAX_LEN_FNAM) STREAMICEerrvelOptimFile
      LOGICAL calc_prior_cost_bglen
      _RL U_obs (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL V_obs (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL U_err (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL R0 (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)

      _RL smooth_cost_fric  (nSx,nSy)
      _RL smooth_cost_maxmelt (nSx,nSy)
      _RL smooth_cost_prior (nSx,nSy)
      _RL smooth_cost_bglen (nSx,nSy)
      _RL cost_misfit (nSx,nSy)
      _RL cost_misfit_norm (nSx,nSy)

      _RL smooth_cost_fric_gl, smooth_cost_prior_gl,
     &    smooth_cost_bglen_gl, cost_misfit_gl,
     &    cost_thin_gl, cost_misfit_norm_gl,
     &    cost_vel_td_gl, smooth_cost_maxmelt_gl
      _RL rhoi, rhow, r, i_r, h, hf, r_low_tmp, haf

      jtlo = myByLo(myThid)
      jthi = myByHi(myThid)
      itlo = myBxLo(myThid)
      ithi = myBxHi(myThid)

      i_numcells = 1.0/(Nx*Ny)
      idt = 1.0/deltaT*365.0*86400.0

      _BARRIER

       STREAMICExvelOptimFile=
     &  STREAMICEvelOptimSnapBasename(1:
     &  ILNBLNK(STREAMICEvelOptimSnapBasename))//"u.bin"
       STREAMICEyvelOptimFile=
     &  STREAMICEvelOptimSnapBasename(1:
     &  ILNBLNK(STREAMICEvelOptimSnapBasename))//"v.bin"
       STREAMICEerrvelOptimFile=
     &  STREAMICEvelOptimSnapBasename(1:
     &  ILNBLNK(STREAMICEvelOptimSnapBasename))//"err.bin"

      if (streamice_do_snapshot_cost) then
       CALL READ_FLD_XY_RL( STREAMICExvelOptimFile, ' ',
     &      U_obs, 0, myThid )
       print *, 'GOT HERE read velobsu'
       CALL READ_FLD_XY_RL( STREAMICEyvelOptimFile, ' ',
     &      V_obs, 0, myThid )
       print *, 'GOT HERE read velobsv'
       CALL READ_FLD_XY_RL( STREAMICEerrvelOptimFile, ' ',
     &      U_err, 0, myThid )
       print *, 'GOT HERE read uerr'
      endif
      if (STREAMICEBglenCostMaskFile .ne. ' ') then
       calc_prior_cost_bglen = .true.
      else
       calc_prior_cost_bglen = .false.
      endif
      CALL READ_FLD_XY_RL(STREAMICEtopogFile, ' ',
     &      R0, 0, myThid )
      print *, 'GOT HERE read topo file'

      _EXCH_XY_RL(R0, myThid)

C--   Calculate mask for tracer cells  (0 => land, 1 => water)
c       k=1

C--   Calculate cost function on tile of this instance

      rhoi = streamice_density
      rhow = streamice_density_ocean_avg
      r=rhoi/rhow
      i_r = 1/r

      do bj = jtlo,jthi
        do bi = itlo,ithi

          smooth_cost_fric (bi,bj) = 0.0
          smooth_cost_maxmelt (bi,bj) = 0.0
          smooth_cost_bglen (bi,bj) = 0.0
          smooth_cost_prior (bi,bj) = 0.0
          cost_misfit (bi,bj) = 0.0
          cost_misfit_norm (bi,bj) = 0.0

          do j=1,sNy
            do i=1,sNx

#ifdef ALLOW_STREAMICE_TC_COST
             IF ( .not. STREAMICE_do_timedep_cost ) THEN
#endif
              cfricval = C_basal_friction(i,j,bi,bj)
              bglenval = B_glen(i,j,bi,bj)

              cfricvalp1 = C_basal_friction(i+1,j,bi,bj)
              dCdx = (Cfricvalp1-cfricval)/
     &              (dxC(i+1,j,bi,bj))
              cfricvalp1 = C_basal_friction(i,j+1,bi,bj)
              dCdy = (Cfricvalp1-cfricval)/
     &              (dxC(i,j+1,bi,bj))

              bglenvalp1 = B_glen(i+1,j,bi,bj)
              dBdx = (bglenvalp1-
     &               bglenval) /
     &              (dxC(i+1,j,bi,bj))
              bglenvalp1 = B_glen(i,j+1,bi,bj)
              dBdy = (bglenvalp1-
     &               bglenval) /
     &               (dyC(i,j+1,bi,bj))

              dRdx = (R_low_si(i+1,j,bi,bj)-
     &               R_low_si(i,j,bi,bj)) /
     &              (dxC(i+1,j,bi,bj))
              dRdy = (R_low_si(i,j+1,bi,bj)-
     &               R_low_si(i,j,bi,bj)) /
     &               (dyC(i,j+1,bi,bj))

#ifdef ALLOW_STREAMICE_TC_COST
             endif
#endif

             if (STREAMICE_do_snapshot_cost) then

              utmp = streamice_u_surf(i,j,bi,bj)
              vtmp = streamice_v_surf(i,j,bi,bj)
              uotmp = U_obs(i,j,bi,bj)
              votmp = V_obs(i,j,bi,bj)
              cotmp = sqrt(uotmp**2+votmp**2)

              IF((cotmp.ne.0.0) .and.
     &         streamice_hmask(i,j,bi,bj).eq.1.0) THEN

               tile_fc (bi,bj) = tile_fc (bi,bj) +
     &         streamice_wgt_vel *
     &         (
     &         0.5 * (streamice_u_surf(i,j,bi,bj)-
     &                U_obs(i,j,bi,bj))**2 +
     &         0.5 * (streamice_v_surf(i,j,bi,bj)-
     &                V_obs(i,j,bi,bj))**2
     &         ) * I_numcells
     &         / (1.0+U_err(i,j,bi,bj)**2)

               cost_misfit (bi,bj) = cost_misfit (bi,bj) +
     &         streamice_wgt_vel *
     &         (
     &         0.5 * (streamice_u_surf(i,j,bi,bj)-
     &                U_obs(i,j,bi,bj))**2 +
     &         0.5 * (streamice_v_surf(i,j,bi,bj)-
     &                V_obs(i,j,bi,bj))**2
     &         ) * I_numcells
     &         / (1.0+U_err(i,j,bi,bj)**2)

               tile_fc (bi,bj) = tile_fc (bi,bj) +
     &         streamice_wgt_vel_norm *
     &         (
     &         0.5 * (streamice_u_surf(i,j,bi,bj)-
     &                U_obs(i,j,bi,bj))**2 +
     &         0.5 * (streamice_v_surf(i,j,bi,bj)-
     &                V_obs(i,j,bi,bj))**2
     &         ) * I_numcells
     &         / (U_err(i,j,bi,bj)**2+
     &            U_obs(i,j,bi,bj)**2+V_obs(i,j,bi,bj)**2)

               cost_misfit_norm (bi,bj) = cost_misfit_norm (bi,bj) +
     &         streamice_wgt_vel_norm *
     &         (
     &         0.5 * (streamice_u_surf(i,j,bi,bj)-
     &                U_obs(i,j,bi,bj))**2 +
     &         0.5 * (streamice_v_surf(i,j,bi,bj)-
     &                V_obs(i,j,bi,bj))**2
     &         ) * I_numcells
     &         / (U_err(i,j,bi,bj)**2+
     &            U_obs(i,j,bi,bj)**2+V_obs(i,j,bi,bj)**2)

              ENDIF
             endif

#ifdef ALLOW_STREAMICE_TC_COST
             IF ( .not. STREAMICE_do_timedep_cost ) THEN
#endif

              if(streamice_hmask(i,j,bi,bj).eq.1.0) then
               tile_fc (bi,bj) = tile_fc (bi,bj) +
     &         streamice_wgt_tikh_beta * (dCdx**2+dCdy**2) * I_numcells
               smooth_cost_fric (bi,bj) = smooth_cost_fric (bi,bj) +
     &         streamice_wgt_tikh_beta * (dCdx**2+dCdy**2) * I_numcells

               tile_fc (bi,bj) = tile_fc (bi,bj) +
     &         streamice_wgt_tikh_bglen * (dBdx**2+dBdy**2) * I_numcells
               smooth_cost_bglen (bi,bj) = smooth_cost_bglen (bi,bj) +
     &         streamice_wgt_tikh_bglen * (dBdx**2+dBdy**2) * I_numcells

               tile_fc (bi,bj) = tile_fc (bi,bj) +
     &         0.e5 * (dRdx**2+dRdy**2) * I_numcells

               h = H_streamice(i,j,bi,bj)
               hf = -1.0 * i_r * R_low_si (i,j,bi,bj)

               IF ((h-hf) .gt. 5. .AND. B_glen0(i,j,bi,bj).gt.0.0 .and.
     &             calc_prior_cost_bglen) then

                 tile_fc (bi,bj) = tile_fc (bi,bj) +
     &            streamice_wgt_prior_bglen * I_numcells *
     &            (B_glen(i,j,bi,bj)-B_glen0(i,j,bi,bj))**2

                 smooth_cost_prior (bi,bj) = smooth_cost_prior (bi,bj) +
     &            streamice_wgt_prior_bglen * I_numcells *
     &            (B_glen(i,j,bi,bj)-B_glen0(i,j,bi,bj))**2

               ENDIF
              endif

#ifdef ALLOW_STREAMICE_TC_COST
             ENDIF
#endif

             if (streamice_do_verification_cost) then
              if (streamice_hmask(i,j,bi,bj).eq.1.0) then
               tile_fc (bi,bj) = tile_fc (bi,bj) +
     &         u_streamice(i,j,bi,bj)**2+v_streamice(i,j,bi,bj)**2+
     &         h_streamice(i,j,bi,bj)**2
              endif
             endif

             if (streamice_do_vaf_cost) then
              if (streamice_hmask(i,j,bi,bj).eq.1.0) then

               r_low_tmp = R_low_si (i,j,bi,bj)

               if (r_low_tmp .ge. 0.0) then
                HAF = h_streamice (i,j,bi,bj)
               else
                HAF = h_streamice (i,j,bi,bj) +
     &           (streamice_density_ocean_avg / streamice_density
     &           * r_low_tmp)
               endif

               if (HAF .gt. 0.0) then
                tile_fc(bi,bj) = tile_fc(bi,bj) +
     &          HAF * rA (i,j,bi,bj)
               endif

              endif
             endif

            end do
          end do

          tile_fc (bi,bj) =
     &       tile_fc (bi,bj) + cost_func1_streamice(bi,bj)

#ifdef ALLOW_STREAMICE_TC_COST
          if ( STREAMICE_do_timedep_cost ) then
           smooth_cost_prior(bi,bj) = cost_prior_streamice(bi,bj)
           smooth_cost_fric(bi,bj) = cost_smooth_fric_streamice(bi,bj)
           smooth_cost_bglen(bi,bj) = cost_smooth_glen_streamice(bi,bj)
           smooth_cost_maxmelt(bi,bj) =
     &                        cost_smooth_bdotmelt_streamice(bi,bj)
          endif
#endif

        end do
      end do

      CALL GLOBAL_SUM_TILE_RL
     &   ( smooth_cost_fric, smooth_cost_fric_gl, myThid )
      CALL GLOBAL_SUM_TILE_RL
     &   ( smooth_cost_bglen, smooth_cost_bglen_gl, myThid )
      CALL GLOBAL_SUM_TILE_RL
     &   ( smooth_cost_prior, smooth_cost_prior_gl, myThid )
      CALL GLOBAL_SUM_TILE_RL
     &   ( cost_misfit, cost_misfit_gl, myThid )
      CALL GLOBAL_SUM_TILE_RL
     &   ( cost_misfit_norm, cost_misfit_norm_gl, myThid )
      CALL GLOBAL_SUM_TILE_RL
     &   ( cost_surf_streamice, cost_thin_gl, myThid )
      CALL GLOBAL_SUM_TILE_RL
     &   ( cost_vel_streamice, cost_vel_td_gl, myThid )
      CALL GLOBAL_SUM_TILE_RL
     &   ( smooth_cost_maxmelt, smooth_cost_maxmelt_gl, myThid )
       write(standardMessageUnit,'(A,D22.15)') 'maxmlt smooth contr = ',
     &   smooth_cost_maxmelt_gl

      if (STREAMICE_do_timedep_cost .or.
     &    STREAMICE_do_snapshot_cost) then

       write(standardMessageUnit,'(A,D22.15)') 'fric smooth contr = ',
     &   smooth_cost_fric_gl
       write(standardMessageUnit,'(A,D22.15)') 'bglen smooth contr = ',
     &   smooth_cost_bglen_gl
       write(standardMessageUnit,'(A,D22.15)') 'prior smooth contr = ',
     &   smooth_cost_prior_gl
       write(standardMessageUnit,'(A,D22.15)') 'vel misfit = ',
     &   cost_misfit_gl
       write(standardMessageUnit,'(A,D22.15)') 'vel misfit norm = ',
     &   cost_misfit_norm_gl

      endif

      if (STREAMICE_do_timedep_cost) then

       write(standardMessageUnit,'(A,D22.15)') 'thinning contr = ',
     &   cost_thin_gl
       write(standardMessageUnit,'(A,D22.15)') 'td vel misfit = ',
     &   cost_vel_td_gl

      endif

#endif

      RETURN
      END

#include "THSICE_OPTIONS.h"

CBOP
C     !ROUTINE: THSICE_SLAB_OCEAN
C     !INTERFACE:
      SUBROUTINE THSICE_SLAB_OCEAN(
     I                      aim_sWght0, aim_sWght1,
     O                      dTsurf,
     I                      bi, bj, myTime, myIter, myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R  THSICE_SLAB_OCEAN
C     | o Slab ocean for atmosphere (and sea-ice) model
C     *==========================================================*
C     | o add ocean-surface fluxes + restoring term
C     |   and step forward ocean mixed-layer Temp. & Salinity
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     == Global variables ==
C-- MITgcm
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "FFIELDS.h"

C-- Sea-Ice package
#include "THSICE_PARAMS.h"
#include "THSICE_VARS.h"

C-- Physics package
#ifdef ALLOW_AIM
#include "AIM_FFIELDS.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine Arguments ==
C     aim_sWght0 :: weight for time interpolation of surface BC
C     aim_sWght1 :: 0/1 = time period before/after the current time
C     dTsurf     :: diagnostics of slab-ocean temperature change [K/iter]
C     bi,bj      :: tile indices
C     myTime     :: Current time of simulation ( s )
C     myIter     :: Current iteration number in simulation
C     myThid     :: my Thread number Id.
      _RL     aim_sWght0, aim_sWght1
      _RL     dTsurf(sNx,sNy)
      _RL     myTime
      INTEGER bi,bj
      INTEGER myIter, myThid
CEOP

#ifdef ALLOW_THSICE

C     == Local variables ==
C     i,j          :: Loop counters
      _RL dtFac, fwFac, heatFac
#ifdef ALLOW_AIM
      _RL oceTfreez, locTemp, locQflux, dtFacR
#endif
      INTEGER i,j

cph the following structure is not supported by TAF
cph      IF ( .NOT.stepFwd_oceMxL ) RETURN
      IF ( stepFwd_oceMxL ) THEN

C--    add heat flux and fresh-water + salt flux :
       dtFac   = ocean_deltaT/rhosw
       fwFac   = ocean_deltaT*sMxL_default/rhosw
       heatFac = ocean_deltaT/(cpwater*rhosw)
       DO j=1,sNy
        DO i=1,sNx
         IF ( hOceMxL(i,j,bi,bj).NE.0. _d 0 ) THEN
          dTsurf(i,j) = tOceMxL(i,j,bi,bj)
          tOceMxL(i,j,bi,bj) = tOceMxL(i,j,bi,bj)
     &       - heatFac*Qnet(i,j,bi,bj) / hOceMxL(i,j,bi,bj)
          sOceMxL(i,j,bi,bj) = sOceMxL(i,j,bi,bj)
     &       + (fwFac*EmPmR(i,j,bi,bj) - dtFac*saltFlux(i,j,bi,bj))
     &                                 / hOceMxL(i,j,bi,bj)
         ENDIF
        ENDDO
       ENDDO

#ifdef ALLOW_AIM
       IF ( tauRelax_MxL_salt .GT. 0. _d 0 ) THEN
C--    add restoring (backward) toward climatological fixed Salinity
        dtFac   = ocean_deltaT/tauRelax_MxL_salt
        dtFacR  = 1. _d 0 /(1. _d 0 + dtFac)
        DO j=1,sNy
         DO i=1,sNx
          IF ( hOceMxL(i,j,bi,bj).NE.0. _d 0 ) THEN
           sOceMxL(i,j,bi,bj) =
     &         (sOceMxL(i,j,bi,bj) + dtFac*sMxL_default)*dtFacR
          ENDIF
         ENDDO
        ENDDO
       ENDIF
       IF ( tauRelax_MxL .GT. 0. _d 0 ) THEN
C--    add restoring (backward) toward climatological Temp.
        dtFac   = ocean_deltaT/tauRelax_MxL
        dtFacR  = 1. _d 0 /(1. _d 0 + dtFac)
        oceTfreez = - 1.9 _d 0
        DO j=1,sNy
         DO i=1,sNx
          IF ( hOceMxL(i,j,bi,bj).NE.0. _d 0 ) THEN
           oceTfreez = -mu_Tf*sOceMxL(i,j,bi,bj)
           locTemp = ( aim_sWght0*aim_sst0(i,j,bi,bj)
     &               + aim_sWght1*aim_sst1(i,j,bi,bj)
     &               ) - celsius2K
           locTemp = MAX( locTemp , oceTfreez )
           tOceMxL(i,j,bi,bj) =
     &         (tOceMxL(i,j,bi,bj) + dtFac*locTemp)*dtFacR
          ENDIF
         ENDDO
        ENDDO
       ENDIF
       DO j=1,sNy
        DO i=1,sNx
          IF ( hOceMxL(i,j,bi,bj).NE.0. _d 0 ) THEN
           locQflux = ( aim_sWght0*aim_qfx0(i,j,bi,bj)
     &                + aim_sWght1*aim_qfx1(i,j,bi,bj)
     &                )
           tOceMxL(i,j,bi,bj) = tOceMxL(i,j,bi,bj)
     &            + heatFac*locQflux / hOceMxL(i,j,bi,bj)
          ENDIF
        ENDDO
       ENDDO
#endif /* ALLOW_AIM */

C-    Diagnose surf. temp. change
       DO j=1,sNy
        DO i=1,sNx
         IF ( hOceMxL(i,j,bi,bj).NE.0. _d 0 ) THEN
          dTsurf(i,j) = tOceMxL(i,j,bi,bj) - dTsurf(i,j)
         ENDIF
        ENDDO
       ENDDO

c-- End of IF ( stepFwd_oceMxL ) THEN
      ENDIF

C--   Cumulate time-averaged fields and also fill-up flux diagnostics
C     (if not done in THSICE_DO_ADVECT call)
      IF ( thSIceAdvScheme.LE.0 ) THEN
         CALL THSICE_AVE(
     I                    bi, bj, myTime, myIter, myThid )
      ENDIF

#endif  /* ALLOW_THSICE */

      RETURN
      END

#include "OCN_CPL_OPTIONS.h"

CBOP
C     !ROUTINE: CPL_READPARMS
C     !INTERFACE:
      SUBROUTINE CPL_READPARMS( myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R CPL_READPARMS
C     | o Read Coupling parameters that control import/export
C     |   from/to the coupler layer
C     *==========================================================*
C     |   this version is specific to 1 component (ocean)
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     == Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "CPL_PARAMS.h"
#ifdef ALLOW_MNC
#include "MNC_PARAMS.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     myThid     :: my Thread Id. number
      INTEGER myThid
CEOP

#ifdef COMPONENT_MODULE
C     !FUNCTIONS:
c     INTEGER ILNBLNK

C     !LOCAL VARIABLES:
C     msgBuf     :: Informational/error message buffer
C     iUnit      :: Work variable for IO unit number
C     k          :: loop counter
C     iL         :: Work variable for length of file-name
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      INTEGER iUnit
c     INTEGER k, iL

C-    retired parameters:
C     cpl_earlyExpImpCall :: retired; always call coupler early in call sequence
C     cpl_timeave_mnc :: retired;
C     cpl_taveFreq    :: retired; Frequency^-1 for time-Aver. output (s)
      LOGICAL cpl_earlyExpImpCall
      LOGICAL cpl_timeave_mnc
      _RL cpl_taveFreq

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C--   Coupling parameters:
C     useImportHFlx :: True => use the Imported HeatFlux from couler
C     useImportFW   :: True => use the Imported Fresh Water flux fr cpl
C     useImportTau  :: True => use the Imported Wind-Stress from couler
C     useImportSLP  :: True => use the Imported Sea-level Atmos. Pressure
C     useImportRunOff :: True => use the Imported RunOff flux from coupler
C     useImportSIce   :: True => use the Imported Sea-Ice loading from coupler
C     useImportThSIce :: True => use the Imported thSIce state vars from coupler
C     useImportSltPlm :: True => use the Imported Salt-Plume flux from coupler
C     useImportFice   :: True => use the Imported Seaice fraction (DIC-only)
C     useImportCO2    :: True => use the Imported atmos. CO2 from coupler
C     useImportWSpd   :: True => use the Imported surf. Wind speed from coupler
      NAMELIST /CPL_OCN_PARAM/
     &    cpl_earlyExpImpCall,
     &    useImportHFlx, useImportFW, useImportTau,
     &    useImportSLP,  useImportRunOff,
     &    useImportSIce, useImportThSIce, useImportSltPlm,
     &    useImportFice, useImportCO2, useImportWSpd,
     &    cpl_taveFreq, cpl_snapshot_mnc, cpl_timeave_mnc

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      _BEGIN_MASTER(myThid)

C--   Open the data file
      WRITE(msgBuf,'(A)') ' CPL_READPARMS: opening data.cpl'
      CALL PRINT_MESSAGE( msgBuf,standardMessageUnit,SQUEEZE_RIGHT,1 )

      CALL OPEN_COPY_DATA_FILE( 'data.cpl', 'CPL_READPARMS',
     O                          iUnit, myThid )

C-    Set default value:
      useImportHFlx   = .TRUE.
      useImportFW     = .TRUE.
      useImportTau    = .TRUE.
      useImportSLP    = .TRUE.
      useImportRunOff = cpl_exchange_RunOff.EQ.3
      useImportSIce   = cpl_exchange1W_sIce.EQ.3
      useImportThSIce = cpl_exchange2W_sIce.EQ.3
      useImportSltPlm = cpl_exchange_SaltPl.EQ.3
      useImportFice   =( cpl_exchange_DIC .EQ. 3 .AND.
     &                  cpl_exchange1W_sIce.EQ.3 )
c    &             .OR. cpl_exchange2W_sIce.EQ.3
      useImportCO2    =  cpl_exchange_DIC .EQ. 3
      useImportWSpd   =  cpl_exchange_DIC .EQ. 3
#ifdef ALLOW_MNC
      cpl_snapshot_mnc = useMNC .AND. snapshot_mnc
#else
      cpl_snapshot_mnc = .FALSE.
#endif
C-    retired params default:
      cpl_earlyExpImpCall = .TRUE.
      cpl_timeave_mnc = .FALSE.
      cpl_taveFreq    = UNSET_RL

C--   Read parameters from open data file:

C-    Parameters for coupling interface:
      READ(UNIT=iUnit,NML=CPL_OCN_PARAM)

      WRITE(msgBuf,'(A)')
     &   ' CPL_READPARMS: finished reading data.cpl'
      CALL PRINT_MESSAGE( msgBuf,standardMessageUnit,SQUEEZE_RIGHT,1 )

C--   Close the open data file
#ifdef SINGLE_DISK_IO
      CLOSE(iUnit)
#else
      CLOSE(iUnit,STATUS='DELETE')
#endif /* SINGLE_DISK_IO */

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C--   Check for retired parameters:
      IF ( .NOT.cpl_earlyExpImpCall ) THEN
        WRITE(msgBuf,'(2A)') 'CPL_READPARMS: ',
     &   'Parameter "cpl_earlyExpImpCall" has been retired;'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(2A)') 'CPL_READPARMS: ',
     &   '=> always call coupler early in sequence of calls'
        CALL PRINT_ERROR( msgBuf, myThid )
        cplErrorCount = cplErrorCount + 1
      ENDIF
      IF ( cpl_taveFreq .NE. UNSET_RL ) THEN
        WRITE(msgBuf,'(2A)') 'CPL_READPARMS: "cpl_taveFreq"',
     &    ' is no longer allowed in file "data.cpl"'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(2A)') 'CPL_READPARMS: ',
     &    ' since "pkg/timeave" has been removed.'
        CALL PRINT_ERROR( msgBuf, myThid )
        cplErrorCount = cplErrorCount + 1
      ENDIF
      IF ( cpl_timeave_mnc ) THEN
        WRITE(msgBuf,'(2A)') 'CPL_READPARMS: "cpl_timeave_mnc"',
     &    ' is no longer allowed in file "data.cpl"'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(2A)') 'CPL_READPARMS: ',
     &    ' since "pkg/timeave" has been removed.'
        CALL PRINT_ERROR( msgBuf, myThid )
        cplErrorCount = cplErrorCount + 1
      ENDIF

C--   Check parameters and model configuration

#ifndef ALLOW_DIC
      IF ( ocn_cplExch_RunOff ) THEN
        WRITE(msgBuf,'(2A)') 'CPL_READPARMS: needs',
     &    ' to compile pkg/dic to use: ocn_cplExch_RunOff=T'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(2A)') 'CPL_READPARMS: ',
     &    ' (set from Coupler "data.cpl": cpl_exchange_RunOff=1,3)'
        CALL PRINT_ERROR( msgBuf, myThid )
        cplErrorCount = cplErrorCount + 1
      ENDIF
#endif /* ndef ALLOW_DIC */
#ifndef ALLOW_THSICE
      IF ( ocn_cplExch2W_sIce ) THEN
        WRITE(msgBuf,'(2A)') 'CPL_READPARMS: needs',
     &    ' to compile pkg/thsice to use: ocn_cplExch2W_sIce=T'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(2A)') 'CPL_READPARMS: ',
     &    ' (set from Coupler "data.cpl": cpl_exchange2W_sIce=1,3)'
        CALL PRINT_ERROR( msgBuf, myThid )
        cplErrorCount = cplErrorCount + 1
      ENDIF
#endif /* ndef ALLOW_THSICE */
#ifndef ALLOW_SALT_PLUME
      IF ( ocn_cplExch_SaltPl ) THEN
        WRITE(msgBuf,'(2A)') 'CPL_READPARMS: needs',
     &    ' compiled pkg/salt_plume to use: ocn_cplExch_SaltPl=T'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(2A)') 'CPL_READPARMS: ',
     &    ' (set from Coupler "data.cpl": cpl_exchange_SaltPl=1,3)'
        CALL PRINT_ERROR( msgBuf, myThid )
        cplErrorCount = cplErrorCount + 1
      ENDIF
#endif /* ndef ALLOW_SALT_PLUME */
#ifndef ALLOW_DIC
      IF ( ocn_cplExch_DIC ) THEN
        WRITE(msgBuf,'(2A)') 'CPL_READPARMS: needs',
     &    ' to compile pkg/dic to use: ocn_cplExch_DIC = T'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(2A)') 'CPL_READPARMS: ',
     &    ' (set from Coupler "data.cpl": cpl_exchange_DIC = 1,3)'
        CALL PRINT_ERROR( msgBuf, myThid )
        cplErrorCount = cplErrorCount + 1
      ENDIF
#endif /* ndef ALLOW_DIC */

#ifndef ATMOSPHERIC_LOADING
      iUnit = errorMessageUnit
      IF ( useImportSLP ) THEN
        WRITE(msgBuf,'(2A)') '** WARNING ** CPL_READPARMS:',
     &                       ' useImportSLP is set but'
        CALL PRINT_MESSAGE( msgBuf, iUnit, SQUEEZE_RIGHT, myThid )
      ELSEIF ( useImportSIce ) THEN
        WRITE(msgBuf,'(2A)') '** WARNING ** CPL_READPARMS:',
     &                       ' useImportSIce is set but'
        CALL PRINT_MESSAGE( msgBuf, iUnit, SQUEEZE_RIGHT, myThid )
      ENDIF
      IF ( useImportSLP .OR. useImportSIce ) THEN
        WRITE(msgBuf,'(2A)') '** WARNING ** CPL_READPARMS:',
     &                       ' pressure loading code is not active.'
        CALL PRINT_MESSAGE( msgBuf, iUnit, SQUEEZE_RIGHT, myThid )
C        WRITE(msgBuf,'(2A)') '** WARNING **',
C     &              ' Re-compile with:  #define ATMOSPHERIC_LOADING'
C        CALL PRINT_MESSAGE(msgBuf,iUnit,SQUEEZE_RIGHT,myThid)
      ENDIF
#endif /* ATMOSPHERIC_LOADING */

      IF ( useImportRunOff .AND. cpl_exchange_RunOff.NE.3 ) THEN
        WRITE(msgBuf,'(2A)') 'CPL_READPARMS: useImportRunOff',
     &    ' requires setting'
        CALL PRINT_ERROR( msgBuf, myThid)
        WRITE(msgBuf,'(2A)') 'CPL_READPARMS: ',
     &    ' cpl_exchange_RunOff = 3 (in Coupler "data.cpl")'
        CALL PRINT_ERROR( msgBuf, myThid)
        cplErrorCount = cplErrorCount + 1
      ENDIF
      IF ( ( useImportSIce .OR.
     &       useImportFice.AND.cpl_exchange2W_sIce.NE.3 )
     &   .AND. cpl_exchange1W_sIce.NE.3 ) THEN
        WRITE(msgBuf,'(2A)') 'CPL_READPARMS: useImport',
     &    ' SIce-Mass/Frac requires setting'
        CALL PRINT_ERROR( msgBuf, myThid)
        WRITE(msgBuf,'(2A)') 'CPL_READPARMS: ',
     &    ' cpl_exchange1W_sIce = 3 (in Coupler "data.cpl")'
        CALL PRINT_ERROR( msgBuf, myThid)
        cplErrorCount = cplErrorCount + 1
      ENDIF
      IF ( useImportThSIce .AND. .NOT.ocn_cplExch2W_sIce ) THEN
        WRITE(msgBuf,'(2A)') 'CPL_READPARMS: useImportThSIce',
     &    ' requires setting'
        CALL PRINT_ERROR( msgBuf, myThid)
        WRITE(msgBuf,'(2A)') 'CPL_READPARMS: ',
     &    ' cpl_exchange2W_sIce=1,3 (in Coupler "data.cpl")'
        CALL PRINT_ERROR( msgBuf, myThid)
        cplErrorCount = cplErrorCount + 1
      ELSEIF ( useImportThSIce .AND. cpl_exchange2W_sIce.NE.3 ) THEN
        WRITE(msgBuf,'(2A)') '** WARNING ** CPL_READPARMS: ',
     &    'useImportThSIce useless without'
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
        WRITE(msgBuf,'(2A)') '** WARNING ** CPL_READPARMS: ',
     &    ' cpl_exchange2W_sIce = 3 (in Coupler "data.cpl")'
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
      ENDIF
      IF ( useImportSltPlm .AND. cpl_exchange_SaltPl.NE.3 ) THEN
        WRITE(msgBuf,'(2A)') 'CPL_READPARMS: useImportSltPlm',
     &    ' requires setting'
        CALL PRINT_ERROR( msgBuf, myThid)
        WRITE(msgBuf,'(2A)') 'CPL_READPARMS: ',
     &    ' cpl_exchange_SaltPl = 3 (in Coupler "data.cpl")'
        CALL PRINT_ERROR( msgBuf, myThid)
        cplErrorCount = cplErrorCount + 1
      ENDIF
      IF ( ( useImportFice.AND.cpl_exchange2W_sIce.NE.3
     &       .OR. useImportCO2 .OR. useImportWSpd )
     &   .AND. cpl_exchange_DIC.NE.3 ) THEN
        WRITE(msgBuf,'(2A)') 'CPL_READPARMS: useImport',
     &    ' with DIC variables requires setting'
        CALL PRINT_ERROR( msgBuf, myThid)
        WRITE(msgBuf,'(2A)') 'CPL_READPARMS: ',
     &    ' cpl_exchange_DIC = 3 (in Coupler "data.cpl")'
        CALL PRINT_ERROR( msgBuf, myThid)
        cplErrorCount = cplErrorCount + 1
      ENDIF

C     Set IO flags
      cpl_snapshot_mdsio = .TRUE.
#ifdef ALLOW_MNC
      cpl_snapshot_mnc = useMNC .AND. cpl_snapshot_mnc
      cpl_snapshot_mdsio = ( .NOT.cpl_snapshot_mnc )
     &                     .OR. outputTypesInclusive
#endif

C-    derive other parameters:

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C--   Print out set-up summary

      iUnit = standardMessageUnit
      WRITE(msgBuf,'(A)') ' '
      CALL PRINT_MESSAGE( msgBuf, iUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)') '// ==================================='
      CALL PRINT_MESSAGE( msgBuf, iUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)') '// Coupling set-up summary :'
      CALL PRINT_MESSAGE( msgBuf, iUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)') '// ==================================='
      CALL PRINT_MESSAGE( msgBuf, iUnit, SQUEEZE_RIGHT, myThid )

C-    o Print Coupler-Exchange config (set from params in coupler 'data.cpl')
       WRITE(msgBuf,'(A)') '// -------'
       CALL PRINT_MESSAGE( msgBuf, iUnit, SQUEEZE_RIGHT, myThid )
       WRITE(msgBuf,'(A)')
     &        '// Coupler-exchange switch (received from coupler):'
       CALL PRINT_MESSAGE( msgBuf, iUnit, SQUEEZE_RIGHT, myThid )

       CALL WRITE_0D_L( ocn_cplSequential, INDEX_NONE,
     &                 'ocn_cplSequential =',
     &   ' /* use Sequential Coupling Exchange on/off flag */')

       CALL WRITE_0D_L( ocn_cplExch_RunOff, INDEX_NONE,
     &                 'ocn_cplExch_RunOff =',
     &     ' /* exchange RunOff fields with coupler on/off */')
       CALL WRITE_0D_L( ocn_cplExch1W_sIce, INDEX_NONE,
     &                 'ocn_cplExch1W_sIce =',
     &     ' /* 1-way exchange of seaice vars with coupler */')
       CALL WRITE_0D_L( ocn_cplExch2W_sIce, INDEX_NONE,
     &                 'ocn_cplExch2W_sIce =',
     &     ' /* 2-way exchange of ThSIce vars with coupler */')
       CALL WRITE_0D_L( ocn_cplExch_SaltPl, INDEX_NONE,
     &                 'ocn_cplExch_SaltPl =',
     &     ' /* exchange Salt-Plume fields with coupler */')
       CALL WRITE_0D_L( ocn_cplExch_DIC, INDEX_NONE,
     &                 'ocn_cplExch_DIC    =',
     &     ' /* exchange DIC    fields with coupler on/off */')

C-    print namelist parameter value:
       WRITE(msgBuf,'(A)') '// -------'
       CALL PRINT_MESSAGE( msgBuf, iUnit, SQUEEZE_RIGHT, myThid )
       WRITE(msgBuf,'(A)')
     &        '// Coupler parameters (from local param file):'
       CALL PRINT_MESSAGE( msgBuf, iUnit, SQUEEZE_RIGHT, myThid )

       CALL WRITE_0D_L( useImportHFlx, INDEX_NONE,
     &                 'useImportHFlx  =',
     &   ' /* use Imported Heat-Flx fr Coupler on/off flag */')
       CALL WRITE_0D_L( useImportFW  , INDEX_NONE,
     &                 'useImportFW    =',
     &   ' /* use Imported Fresh-Water fr Cpl. on/off flag */')
       CALL WRITE_0D_L( useImportTau , INDEX_NONE,
     &                 'useImportTau   =',
     &   ' /* use Imported Wind-Stress fr Cpl. on/off flag */')
       CALL WRITE_0D_L( useImportSLP , INDEX_NONE,
     &                 'useImportSLP   =',
     &   ' /* use Imported Sea-level Atm Press on/off flag */')
       CALL WRITE_0D_L( useImportRunOff , INDEX_NONE,
     &                 'useImportRunOff=',
     &   ' /* use Imported Run-Off fr Cpl. on/off flag */')
       CALL WRITE_0D_L( useImportSIce , INDEX_NONE,
     &                 'useImportSIce  =',
     &   ' /* use Imported Sea-Ice loading on/off flag */')
       CALL WRITE_0D_L( useImportThSIce , INDEX_NONE,
     &                 'useImportThSIce=',
     &   ' /* use Imported thSIce state-var on/off flag */')
       CALL WRITE_0D_L( useImportSltPlm , INDEX_NONE,
     &                 'useImportSltPlm=',
     &   ' /* use Imported Salt-Plume flux on/off flag */')
       CALL WRITE_0D_L( useImportFice , INDEX_NONE,
     &                 'useImportFice  =',
     &   ' /* use Imported Seaice Frac (DIC-only) flag */')
       CALL WRITE_0D_L( useImportCO2  , INDEX_NONE,
     &                 'useImportCO2   =',
     &   ' /* use Imported Atmos. CO2 fr Cpl. on/off flag */')
       CALL WRITE_0D_L( useImportWSpd , INDEX_NONE,
     &                 'useImportWSpd  =',
     &   ' /* use Imported Windspeed fr Cpl. on/off flag */')

      WRITE(msgBuf,'(A)') '// ==================================='
      CALL PRINT_MESSAGE( msgBuf, iUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)') '// End of Coupling set-up summary'
      CALL PRINT_MESSAGE( msgBuf, iUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)') '// ==================================='
      CALL PRINT_MESSAGE( msgBuf, iUnit, SQUEEZE_RIGHT, myThid )

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      _END_MASTER(myThid)

C--   Everyone else must wait for the parameters to be loaded
      _BARRIER

#endif /* COMPONENT_MODULE */

      RETURN
      END

#include "ATM_CPL_OPTIONS.h"

CBOP 0
C !ROUTINE: ATM_IMPORT_OCNCONFIG

C !INTERFACE:
      SUBROUTINE ATM_IMPORT_OCNCONFIG( myThid )

C !DESCRIPTION:
C     *==========================================================*
C     | SUBROUTINE ATM_IMPORT_OCNCONFIG
C     | o Routine for importing ocean config
C     |   into atmos. component.
C     *==========================================================*
C     | This version talks to the MIT Coupler. It uses the
C     | MIT Coupler "checkpoint 1" library calls.
C     *==========================================================*

C !USES:
      IMPLICIT NONE
C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "ATMIDS.h"
#include "ATMCPL.h"

C !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     myThid :: Thread number for this instance of the routine
      INTEGER myThid
CEOP

#ifdef COMPONENT_MODULE
C !LOCAL VARIABLES:
C     == Local variables ==
C     i,j,bi,bj :: Loop counters
      INTEGER i,j,bi,bj

C-    Initialise mixed-layer depth
      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          ocMxlD (i,j,bi,bj) = 0.
         ENDDO
        ENDDO
       ENDDO
      ENDDO

C-    Receive ocean model configuration info.
      _BARRIER
      _BEGIN_MASTER( myThid )

C     o Import ocean model mixed-layer depth
      CALL COMPRECV_R8TILES(
     I              atmMxlDName, sNx, OLx, sNy, OLy, 1, nSx, nSy,
     O              ocMxlD )

      _END_MASTER( myThid )
      _BARRIER

#endif /* COMPONENT_MODULE */

      RETURN
      END

#include "STREAMICE_OPTIONS.h"
#ifdef ALLOW_AUTODIFF
# include "AUTODIFF_OPTIONS.h"
#endif

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

CBOP
      SUBROUTINE STREAMICE_GET_VEL_FP_ERR ( err_max,
#ifdef ALLOW_AUTODIFF_TAMC
     I     ikey_nl,
#endif
     I     myThid )
C     /============================================================\
C     | SUBROUTINE                                                 |
C     | o                                                          |
C     |============================================================|
C     |                                                            |
C     \============================================================/
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "STREAMICE.h"
#include "STREAMICE_CG.h"

C     !INPUT/OUTPUT ARGUMENTS
      _RL err_max
#ifdef ALLOW_AUTODIFF_TAMC
      INTEGER ikey_nl
#endif
      INTEGER myThid

#ifdef ALLOW_STREAMICE

      INTEGER i, j, bi, bj

      _RL err_tempu, err_tempv

      _RL err_sum
      _RL err_sum_tile (nSx,nSy)

       err_max = 0. _d 0
       err_sum = 0. _d 0

       DO bj = myByLo(myThid), myByHi(myThid)
        DO bi = myBxLo(myThid), myBxHi(myThid)
         err_sum_tile(bi,bj) = 0. _d 0
        ENDDO
       ENDDO

       if (streamice_err_norm .lt. 1.0) then

       DO bj = myByLo(myThid), myByHi(myThid)
        DO bi = myBxLo(myThid), myBxHi(myThid)
         DO j=1,sNy
          DO i=1,sNx
#ifdef ALLOW_AUTODIFF_TAMC
!$TAF STORE err_max = comlev1_stream_nl, key=ikey_nl
#endif
           err_tempu = 0. _d 0
           err_tempv = 0. _d 0
           IF (STREAMICE_umask(i,j,bi,bj).eq.1) THEN
            err_tempu =
#ifdef ALLOW_STREAMICE_FP_ADJ
     &       ABS (U_streamice(i,j,bi,bj)-u_new_SI(i,j,bi,bj))
#else
     &       ABS (U_streamice(i,j,bi,bj)-u_old_SI(i,j,bi,bj))
#endif
           ENDIF
           IF (STREAMICE_vmask(i,j,bi,bj).eq.1) THEN
            err_tempv = MAX( err_tempu,
#ifdef ALLOW_STREAMICE_FP_ADJ
     &       ABS (V_streamice(i,j,bi,bj)-v_new_SI(i,j,bi,bj)))
#else
     &       ABS (V_streamice(i,j,bi,bj)-v_old_SI(i,j,bi,bj)))
#endif
           ENDIF
           IF (err_tempv .ge. err_max) err_max = err_tempv
          ENDDO
         ENDDO
        ENDDO
       ENDDO

       CALL GLOBAL_MAX_R8 (err_max, myThid)

       ELSE

       DO bj = myByLo(myThid), myByHi(myThid)
        DO bi = myBxLo(myThid), myBxHi(myThid)
         DO j=1,sNy
          DO i=1,sNx
           IF (STREAMICE_umask(i,j,bi,bj).eq.1) THEN
            err_sum_tile(bi,bj) = err_sum_tile(bi,bj) +
#ifdef ALLOW_STREAMICE_FP_ADJ
     &       (ABS(U_streamice(i,j,bi,bj)-
     &              u_new_SI(i,j,bi,bj)))**streamice_err_norm
#else
     &       (ABS(U_streamice(i,j,bi,bj)-
     &               u_old_SI(i,j,bi,bj)))**streamice_err_norm
#endif
           ENDIF
           IF (STREAMICE_vmask(i,j,bi,bj).eq.1) THEN
            err_sum_tile(bi,bj) = err_sum_tile(bi,bj) +
#ifdef ALLOW_STREAMICE_FP_ADJ
     &       (ABS(v_streamice(i,j,bi,bj)-
     &              v_new_SI(i,j,bi,bj)))**streamice_err_norm
#else
     &       (ABS(v_streamice(i,j,bi,bj)-
     &               v_old_SI(i,j,bi,bj)))**streamice_err_norm
#endif
           ENDIF
          ENDDO
         ENDDO
        ENDDO
       ENDDO

       CALL GLOBAL_SUM_TILE_RL( err_sum_tile, err_sum, myThid )

       err_max = err_sum ** (1./streamice_err_norm)

       ENDIF

#endif
      RETURN
      END

#include "CPP_OPTIONS.h"

CBOP
C     !ROUTINE: TIMESTEP_WVEL
C     !INTERFACE:
      SUBROUTINE TIMESTEP_WVEL(
     I                          bi,bj, myTime, myIter, myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R TIMESTEP_WVEL
C     | o Step model vertical velocity forward in time
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "DYNVARS.h"
#include "NH_VARS.h"
c #include "SURFACE.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine Arguments ==
C     bi, bj    :: Tile indices
C     myTime    :: Current time in simulation
C     myIter    :: Current iteration number in simulation
C     myThid    :: my Thread Id. number
      INTEGER bi,bj
      _RL     myTime
      INTEGER myIter, myThid

#ifdef ALLOW_NONHYDROSTATIC
C     !LOCAL VARIABLES:
C     == Local variables ==
C     iMin,iMax :: 1rst loop counter range
C     jMin,jMax :: 2nd  loop counter range
C     i,j,k     :: Loop counters
C     gWtmp     :: temporary array for vertical momentum tendency
      INTEGER iMin,iMax,jMin,jMax
      INTEGER i, j, k, km1
      _RL     gWtmp(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL     tmpFac, nh_Fac, igwFac
      PARAMETER( iMin = 1 , iMax = sNx )
      PARAMETER( jMin = 1 , jMax = sNy )
CEOP

      igwFac = 0. _d 0
      IF ( implicitIntGravWave ) igwFac = 1. _d 0

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      IF ( nonHydrostatic ) THEN
        nh_Fac = 0.
        IF ( nh_Am2.NE.0. ) nh_Fac = 1. _d 0 / nh_Am2

        DO k=1,Nr
         km1 = MAX( k-1, 1 )

         IF ( implicitNHPress.NE.1. _d 0 ) THEN
C--   add explicit part of NH pressure gradient:
          tmpFac = pfFacMom*(1. _d 0 - implicitNHPress)
     &           * wUnit2rVel(k)*wUnit2rVel(k)*recip_rhoFacF(k)
          IF ( k.GE.2 ) THEN
           DO j=jMin,jMax
            DO i=iMin,iMax
             gW(i,j,k,bi,bj) = gW(i,j,k,bi,bj)
     &              - tmpFac*rkSign*recip_drC(k)
     &              *( phi_nh(i,j,k,bi,bj) - phi_nh(i,j,k-1,bi,bj) )
            ENDDO
           ENDDO
          ELSEIF ( selectNHfreeSurf.GE.1 ) THEN
           DO j=jMin,jMax
            DO i=iMin,iMax
             gW(i,j,k,bi,bj) = gW(i,j,k,bi,bj)
     &              - tmpFac*rkSign*recip_drC(k)
     &              *( phi_nh(i,j,k,bi,bj) - dPhiNH(i,j,bi,bj) )
            ENDDO
           ENDDO
          ENDIF
         ENDIF
C     apply mask to gW and keep a copy of wVel in gW:
         DO j=1-Oly,sNy+Oly
          DO i=1-Olx,sNx+Olx
            gWtmp(i,j) = gW(i,j,k,bi,bj)
     &             *maskC(i,j,k,bi,bj)*maskC(i,j,km1,bi,bj)
            gW(i,j,k,bi,bj) = wVel(i,j,k,bi,bj)
          ENDDO
         ENDDO
C     Step forward vertical velocity
         tmpFac = nh_Fac + igwFac*wUnit2rVel(k)*wUnit2rVel(k)
     &                           *dBdrRef(k)*deltaTMom*dTtracerLev(k)
         IF (tmpFac.GT.0. ) tmpFac = 1. _d 0 / tmpFac
         DO j=jMin,jMax
          DO i=iMin,iMax
            wVel(i,j,k,bi,bj) = wVel(i,j,k,bi,bj)
     &                        + deltaTmom*tmpFac*gWtmp(i,j)
          ENDDO
         ENDDO

C-    End of k loop
        ENDDO

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      ELSEIF ( implicitIntGravWave ) THEN
C     keep a copy of wVel in gW:
        DO k=1,Nr
         DO j=1-Oly,sNy+Oly
          DO i=1-Olx,sNx+Olx
            gW(i,j,k,bi,bj) = wVel(i,j,k,bi,bj)
          ENDDO
         ENDDO
        ENDDO

C-    End if nonHydrostatic / elseif implicitIntGravWave
      ENDIF

#endif /* ALLOW_NONHYDROSTATIC */

      RETURN
      END

#include "GAD_OPTIONS.h"

CBOP
C     !ROUTINE: GAD_SOM_EXCHANGES
C     !INTERFACE:
      SUBROUTINE GAD_SOM_EXCHANGES( myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE GAD_SOM_EXCHANGES
C     | o Apply exchanges to update overlaps
C     |   for 2nd.Order Moment fields
C     *==========================================================*
C     \ev
C     !USES:
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "GAD.h"
#include "GAD_SOM_VARS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
C     myThid ::  my Thread Id number
      INTEGER myThid
CEOP

#ifdef GAD_ALLOW_TS_SOM_ADV
C     !LOCAL VARIABLES:
C     === Local variables ===

C--   Apply exchanges to Temp. 2nd.O.Moments:
      IF ( tempSOM_Advection ) THEN
       CALL GAD_EXCH_SOM( som_T, Nr, myThid )
      ENDIF

C--   Apply exchanges to Salin. 2nd.O.Moments:
      IF ( saltSOM_Advection ) THEN
       CALL GAD_EXCH_SOM( som_S, Nr, myThid )
      ENDIF

#endif /* GAD_ALLOW_TS_SOM_ADV */

      RETURN
      END

#include "FIZHI_OPTIONS.h"
       SUBROUTINE FIZHI_INIT_VARS (myThid)
c-----------------------------------------------------------------------
c  Routine to initialise the fizhi state.
c
c  Input: myThid       - Process number calling this routine
c
c  Notes:
c   1) For a Cold Start -
c      This routine takes the initial condition on the dynamics grid
c      and interpolates to the physics grid to initialize the state
c      variables that are on both grids. It initializes the variables
c      of the turbulence scheme to 0., and the land state from a model
c      climatology.
c   2) For a Restart, read the fizhi pickup file
c   3) The velocity component physics fields are on an A-Grid
c
c Calls: dyn2phys (x4)
c-----------------------------------------------------------------------
       IMPLICIT NONE
#include "SIZE.h"
#include "fizhi_SIZE.h"
#include "fizhi_land_SIZE.h"
#include "GRID.h"
#include "DYNVARS.h"
#include "gridalt_mapping.h"
#include "fizhi_coms.h"
#include "fizhi_land_coms.h"
#include "fizhi_earth_coms.h"
#include "EEPARAMS.h"
#include "SURFACE.h"
#include "PARAMS.h"
#include "chronos.h"
#ifdef ALLOW_EXCH2
#include "W2_EXCH2_SIZE.h"
#include "W2_EXCH2_TOPOLOGY.h"
#endif /* ALLOW_EXCH2 */

       INTEGER myThid

       INTEGER xySize
#if defined(ALLOW_EXCH2)
       PARAMETER ( xySize = W2_ioBufferSize )
#else
       PARAMETER ( xySize = Nx*Ny )
#endif
       Real*8 globalArr( xySize*8 )

c pe on dynamics and physics grid refers to bottom edge
       _RL pephy(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nrphys+1,nSx,nSy)
       _RL pedyn(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr+1,nSx,nSy)
       _RL windphy(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nrphys,nSx,nSy)
       _RL udyntemp(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
       _RL vdyntemp(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
       _RL tempphy(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nrphys,nSx,nSy)

       INTEGER i, j, L, bi, bj, Lbotij
       INTEGER im1, im2, jm1, jm2, idim1, idim2, jdim1, jdim2
       INTEGER xsize, ysize
       LOGICAL alarm
       EXTERNAL alarm

#if defined(ALLOW_EXCH2)
       xsize = exch2_global_Nx
       ysize = exch2_global_Ny
#else
       xsize = Nx
       ysize = Ny
#endif
       im1 = 1-OLx
       im2 = sNx+OLx
       jm1 = 1-OLy
       jm2 = sNy+OLy
       idim1 = 1
       idim2 = sNx
       jdim1 = 1
       jdim2 = sNy

c   First Check to see if we can start a fizhi experiment at current time
c    All Fizhi alarms must be on for the first time step of a segment

      if( .not.alarm('moist') .or. .not.alarm('turb')   .or.
     &    .not.alarm('radsw') .or. .not.alarm('radlw') ) then
       write(15,*) ' Cant Start Fizhi experiment at ',nymd,' ',nhms
       stop
      endif

C Deal Here with Variables that are on a Fizhi Pickup or need Initialization

      IF ( startTime.EQ.baseTime .AND. nIter0.EQ.0 ) THEN
      print *,' In fizhi_init_vars: Beginning of New Experiment '

       do bj = myByLo(myThid), myByHi(myThid)
       do bi = myBxLo(myThid), myBxHi(myThid)

C Build pressures on dynamics grid
        do j = 1,sNy
        do i = 1,sNx
         do L = 1,Nr
          pedyn(i,j,L,bi,bj) = 0.
         enddo
        enddo
        enddo
        do j = 1,sNy
        do i = 1,sNx
         Lbotij = kSurfC(i,j,bi,bj)
         if(Lbotij.ne.0.)
     &    pedyn(i,j,Lbotij,bi,bj) = Ro_surf(i,j,bi,bj) + etaH(i,j,bi,bj)
        enddo
        enddo
        do j = 1,sNy
        do i = 1,sNx
         Lbotij = kSurfC(i,j,bi,bj)
         do L = Lbotij+1,Nr+1
          pedyn(i,j,L,bi,bj) = pedyn(i,j,L-1,bi,bj) -
     &                        drF(L-1)*hfacC(i,j,L-1,bi,bj)
         enddo
c Do not use a zero field as the top edge pressure for interpolation
         if(pedyn(i,j,Nr+1,bi,bj).lt.1.e-5)
     &                               pedyn(i,j,Nr+1,bi,bj) = 1.e-5
        enddo
        enddo
C Build pressures on physics grid
        do j = 1,sNy
        do i = 1,sNx
         pephy(i,j,1,bi,bj)=Ro_surf(i,j,bi,bj) + etaH(i,j,bi,bj)
         do L = 2,Nrphys+1
          pephy(i,j,L,bi,bj)=pephy(i,j,L-1,bi,bj)-dpphys0(i,j,L-1,bi,bj)
         enddo
c Do not use a zero field as the top edge pressure for interpolation
         if(pephy(i,j,Nrphys+1,bi,bj).lt.1.e-5)
     &                               pephy(i,j,Nrphys+1,bi,bj) = 1.e-5
        enddo
        enddo
c
c Create an initial wind magnitude field on the physics grid -
c   Use a log wind law with z0=1cm, u*=1 cm/sec,
c   do units and get u = .025*ln(dP*10), with dP in pa.
        do L = 1,Nrphys
        do j = 1,sNy
        do i = 1,sNx
         windphy(i,j,L,bi,bj) = 0.025 *
     &             log((pephy(i,j,1,bi,bj)-pephy(i,j,L+1,bi,bj))*10.)
        enddo
        enddo
        enddo

       enddo
       enddo

c Create initial fields on phys. grid - Move Dynamics u and v to A-Grid
       call CtoA(myThid,uvel,vvel,maskW,maskS,im1,im2,jm1,jm2,Nr,
     &                     nSx,nSy,1,sNx,1,sNy,udyntemp,vdyntemp)

       do bj = myByLo(myThid), myByHi(myThid)
       do bi = myBxLo(myThid), myBxHi(myThid)

c Create initial fields on phys. grid - interpolate from dyn. grid
        call dyn2phys(udyntemp,pedyn,im1,im2,jm1,jm2,Nr,nSx,nSy,
     & 1,sNx,1,sNy,bi,bj,windphy,pephy,kSurfC,Nrphys,nlperdyn,1,tempphy)
c   Note: Interpolation gives bottom-up arrays (level 1 is bottom),
c         Physics works top-down. so -> need to flip arrays
        do L = 1,Nrphys
        do j = 1,sNy
        do i = 1,sNx
         uphy(i,j,Nrphys+1-L,bi,bj) = tempphy(i,j,L,bi,bj)
        enddo
        enddo
        enddo
        call dyn2phys(vdyntemp,pedyn,im1,im2,jm1,jm2,Nr,nSx,nSy,
     & 1,sNx,1,sNy,bi,bj,windphy,pephy,kSurfC,Nrphys,nlperdyn,1,tempphy)
        do L = 1,Nrphys
        do j = 1,sNy
        do i = 1,sNx
         vphy(i,j,Nrphys+1-L,bi,bj) = tempphy(i,j,L,bi,bj)
        enddo
        enddo
        enddo
        call dyn2phys(theta,pedyn,im1,im2,jm1,jm2,Nr,nSx,nSy,
     & 1,sNx,1,sNy,bi,bj,windphy,pephy,kSurfC,Nrphys,nlperdyn,2,tempphy)
        do L = 1,Nrphys
        do j = 1,sNy
        do i = 1,sNx
         thphy(i,j,Nrphys+1-L,bi,bj) = tempphy(i,j,L,bi,bj)
        enddo
        enddo
        enddo
        call dyn2phys(salt,pedyn,im1,im2,jm1,jm2,Nr,nSx,nSy,
     & 1,sNx,1,sNy,bi,bj,windphy,pephy,kSurfC,Nrphys,nlperdyn,0,tempphy)
        do L = 1,Nrphys
        do j = 1,sNy
        do i = 1,sNx
         sphy(i,j,Nrphys+1-L,bi,bj) = tempphy(i,j,L,bi,bj)
        enddo
        enddo
        enddo

c Zero out fizhi tendency arrays on the fizhi grid
        do L = 1,Nrphys
        do j = 1,sNy
        do i = 1,sNx
         duphy(i,j,L,bi,bj) = 0.
         dvphy(i,j,L,bi,bj) = 0.
         dthphy(i,j,L,bi,bj) = 0.
         dsphy(i,j,L,bi,bj) = 0.
        enddo
        enddo
        enddo

c Zero out fizhi tendency arrays on the dynamics grid
        do L = 1,Nr
        do j = jm1,jm2
        do i = im1,im2
         guphy(i,j,L,bi,bj) = 0.
         gvphy(i,j,L,bi,bj) = 0.
         gthphy(i,j,L,bi,bj) = 0.
         gsphy(i,j,L,bi,bj) = 0.
        enddo
        enddo
        enddo

c Initialize vegetation tile tke, xlmt, khmt, xxmt, yymt, ctmt, zetamt,
        if( (nhms.eq.nhms0) .and. (nymd.eq.nymd0) ) then
         print *,' Cold Start: Zero out Turb second moments '
         do i = 1,nchp
          ctmt(i,bi,bj) = 0.
          xxmt(i,bi,bj) = 0.
          yymt(i,bi,bj) = 0.
          zetamt(i,bi,bj) = 0.
         enddo
         do L = 1,Nrphys
         do i = 1,nchp
          tke(i,L,bi,bj) = 0.
          xlmt(i,L,bi,bj) = 0.
          khmt(i,L,bi,bj) = 0.
         enddo
         enddo
        else
         print *,' Need initial Values for TKE - dont have them! '
         stop
        endif
        turbStart(bi,bj) = .TRUE.

c Now initialize vegetation tile land state too - tcanopy, etc...
        call fizhi_init_vegsurftiles( globalArr, xsize, ysize,
     &                                nymd,nhms, 'D', myThid )

c Now initialize fizhi arrays that will be on a pickup
        print *,' Initialize fizhi arrays that will be on pickup '
        imstturblw(bi,bj) = 0
        imstturbsw(bi,bj) = 0
        iras(bi,bj) = 0
        nlwcld(bi,bj) = 0
        nlwlz(bi,bj) = 0
        nswcld(bi,bj) = 0
        nswlz(bi,bj) = 0
        do L = 1,Nrphys
        do j = 1,sNy
        do i = 1,sNx
         swlz(i,j,L,bi,bj) = 0.
         lwlz(i,j,L,bi,bj) = 0.
         qliqavesw(i,j,L,bi,bj) = 0.
         qliqavelw(i,j,L,bi,bj) = 0.
         fccavesw(i,j,L,bi,bj) = 0.
         fccavelw(i,j,L,bi,bj) = 0.
         cldtot_sw(i,j,L,bi,bj) = 0.
         cldras_sw(i,j,L,bi,bj) = 0.
         cldlsp_sw(i,j,L,bi,bj) = 0.
         cldtot_lw(i,j,L,bi,bj) = 0.
         cldras_lw(i,j,L,bi,bj) = 0.
         cldlsp_lw(i,j,L,bi,bj) = 0.
        enddo
        enddo
        enddo
        do j = 1,sNy
        do i = 1,sNx
         rainlsp(i,j,bi,bj) = 0.
         raincon(i,j,bi,bj) = 0.
         snowfall(i,j,bi,bj) = 0.
        enddo
        enddo

       enddo
       enddo

      ELSE
      print *,' In fizhi_init_vars: Read from restart '

C--   Read fizhi package state variables from pickup file

       call fizhi_read_pickup( nIter0, myThid )
       CALL FIZHI_READ_VEGTILES( nIter0, 'D', myThid )
       do bj = myByLo(myThid), myByHi(myThid)
       do bi = myBxLo(myThid), myBxHi(myThid)
         turbStart(bi,bj) = .FALSE.
       enddo
       enddo

      ENDIF

      RETURN
      END

      subroutine lsupdxx(
     &     nn, ifail, lphprint
     &     , jmin, jmax, nupdate
     &     , ff, fmin, fold, gnorm0, dotdg
     &     , gg, dd, xx, xdiff
     &     , tmin, tmax, tact, epsx
     &     )

c     ==================================================================
c     SUBROUTINE lsupdxx
c     ==================================================================
c
c     o conceived for variable online/offline version
c       computes - new descent direction dd based on latest 
c                  available gradient
c                - new tact based on new dd
c                - new control vector xx needed for offline run
c
c     o started: Patrick Heimbach, MIT/EAPS
c                29-Feb-2000: 
c
c     o Version 2.1.0, 02-Mar-2000: Patrick Heimbach, MIT/EAPS
c
c     ==================================================================
c     SUBROUTINE lsupdxx
c     ==================================================================
c

#include "blas1.h"

      implicit none

c-----------------------------------------
c declare arguments
c-----------------------------------------
      integer nn, jmin, jmax, nupdate, ifail
      double precision    ff, fmin, fold, gnorm0, dotdg
      double precision    gg(nn), dd(nn), xx(nn), xdiff(nn)
      double precision    tmin, tmax, tact, epsx
      logical lphprint

c-----------------------------------------
C declare local variables
c-----------------------------------------
      integer i
      double precision    fdiff, preco

      double precision     DDOT
      external DDOT

c     ==================================================================

c-----------------------------------------
c use Fletchers scaling
c and initialize diagional to 1.
c-----------------------------------------
c
      if ( ( jmax .eq. 0 ) .or. (nupdate .eq. 0 ) ) then

         if (jmax .eq. 0) then
            fold = fmin
            if (lphprint) 
     &           print *, 'pathei-lsopt: using fold = fmin = ', fmin
         end if
         fdiff = fold - ff
         if (jmax .eq. 0) fdiff = ABS(fdiff)
         
         preco = 2. * fdiff / (gnorm0*gnorm0)
         do i = 1, nn
            dd(i)    = -gg(i)*preco
         end do

         if (lphprint) 
     &        print *, 'pathei-lsopt: first estimate of dd via ',
     &        'fold - ff'

c-----------------------------------------
c use the matrix stored in [diag]
c and the (y,s) pairs
c-----------------------------------------

         else

            do i = 1, nn
               dd(i) = -gg(i)
            end do

            if (jmax .gt. 0) then
               call hessupd( nn, nupdate, dd, jmin, jmax, xdiff, 
     &              lphprint )
            else
               if (lphprint) 
     &              print *, 'pathei-lsopt: no hessupd for first optim.'
            end if

         endif

c-----------------------------------------
c check whether new direction is a descent one
c-----------------------------------------
         dotdg = DDOT( nn, dd, 1, gg, 1 )
         if (dotdg .ge. 0.0) then
            ifail = 4
            goto 999
         end if

c----------------------------------
c declare arguments
c----------------------------------

      tmin = 0.
      do i = 1, nn
         tmin = max( tmin, abs(dd(i)) )
      end do
      tmin = epsx/tmin

c----------------------------------
c make sure that t is between
c tmin and tmax
c----------------------------------

      tact  = 1.0
      tmax = 1.0e+10
      if (tact.le.tmin) then
         tact = tmin
         if (tact.gt.tmax) then
            tmin = tmax
         endif
      endif

      if (tact .gt. tmax) then
          tact = tmax
          ifail = 7
      endif

c----------------------------------
c compute new x
c----------------------------------
      do i = 1, nn
         xdiff(i) = xx(i) + tact*dd(i)
      end do

c----------------------------------
c save new x to file for offline version
c----------------------------------

 999  continue

      return

      end

#include "CPP_OPTIONS.h"

CStartOfInterface
      SUBROUTINE ACCEPT_COMPONENT_REGISTRATIONS
C     /==========================================================\
C     | SUBROUTINE ACCEPT_COMPONENT_REGISTRATIONS                |
C     | o Routine to coordinate registration of component other  |
C     |   component processes.                                   |
C     |==========================================================|
C     | During registration each component process sends its     |
C     | attributes. Currently attributes are the layout of tiles |
C     | that the process owns. The 'Coupler' component (i.e. this|
C     | process) stores these attributes. Subsequent transfers   |
C     | to/from the 'Coupler' process implicitly assume these    |
C     | gridding attributes. Only one set of attributes is       |
C     | allowed per process. The dimension arguments in the      |
C     | 'Coupler' process calls to the registration routine are  |
C     | used to check consistency. The tile interior extents     |
C     | registered by a component have to lie within the global  |
C     | extents set in the 'Coupler' process for that component. |
C     \==========================================================/
      IMPLICIT NONE
C     === GLobal variables ==
#include "CPLIDS.h"
#include "ATMSIZE.h"
#include "OCNSIZE.h"
#include "ATMIDS.h"
#include "OCNIDS.h"

CEndOfInterface

C     === Local variables ===

C     During registration the coupler process collects attributes from each 
C     of the "component" participants. It collects the attributes from each 
C     participating component in turn. Individual components comprise of one 
C     or more processes. Each component process does its own registration call 
C     to report its attributes. The attributes that are collected
C     include information on the grid region that a particular process "owns"
C     and sends out information from.

C     Get attributes for atmosphere component.
      CALL CPL_REGISTER_ATM

C     Get attributes for ocean component.
      CALL CPL_REGISTER_OCN


      RETURN
      END

#include "CPP_OPTIONS.h"

CBOP
C     !ROUTINE: CYCLE_AB_TRACER
C     !INTERFACE:
      SUBROUTINE CYCLE_AB_TRACER(
     I                   bi, bj,
     I                   tracNew,
     U                   tracer,
     O                   tracNm1,
     I                   myTime, myIter, myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R CYCLE_AB_TRACER
C     *==========================================================*
C     | o Cycles the time-stepping arrays for a tracer field
C     *==========================================================*
C     \ev
C     !USES:
      IMPLICIT NONE
C Common
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     bi, bj    :: current tile indices
C     tracNew   :: next     time-step tracer field
C     tracer    :: current  time-step tracer field
C     tracNm1   :: previous time-step tracer field
C     myTime    :: Current simulation time
C     myIter    :: Current time-step number
C     myThid    :: my Thread Id number
      INTEGER bi,bj
      _RL tracNew(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL tracer (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL tracNm1(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL myTime
      INTEGER myIter, myThid

C     !LOCAL VARIABLES:
      INTEGER i,j,k
CEOP

C     Rotate tracNew/tracer/tracNm1
      DO k=1,Nr
       DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
         tracNm1(i,j,k) = tracer(i,j,k)
         tracer(i,j,k) = tracNew(i,j,k)
        ENDDO
       ENDDO
      ENDDO

      RETURN
      END

#include "ctrparam.h"
#include "ATM2D_OPTIONS.h"

C     !INTERFACE:
      SUBROUTINE INIT_SUMVARS( myThid)
C     *==========================================================*
C     | Initialize all the output variables from the atmos and   |
c     | seaice models that are accumulated and passed to the ocn.|
C     *==========================================================*
        IMPLICIT NONE

#include "ATMSIZE.h"
#include "SIZE.h"
#include "EEPARAMS.h"
#include "ATM2D_VARS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
C     myThid - Thread no. that called this routine.
      INTEGER myThid

C     LOCAL VARIABLES:
      INTEGER i,j

      DO i=1-OLx,sNx+OLx
        DO j=1-OLy,sNy+OLy

          sum_runoff(i,j)= 0. _d 0
          sum_precip(i,j)= 0. _d 0
          sum_evap(i,j)= 0. _d 0
          sum_qnet(i,j)= 0. _d 0
          sum_fu(i,j)= 0. _d 0
          sum_fv(i,j)= 0. _d 0
          sum_wspeed(i,j)= 0. _d 0
          sum_solarnet(i,j)= 0. _d 0
          sum_slp(i,j)= 0. _d 0
          sum_pCO2(i,j)= 0. _d 0
          sum_prcIce(i,j)= 0. _d 0
          sum_snowPrc(i,j)= 0. _d 0
          sum_evapIce(i,j)= 0. _d 0
          sum_sHeat(i,j)= 0. _d 0
          sum_flxCnB(i,j)= 0. _d 0

        ENDDO
      ENDDO

      RETURN
      END

C ************************ integer*4 ************************
      BLOCK DATA INTEGERS4
      INTEGER*4 adi4buf(512)
      INTEGER adi4ibuf
      COMMON /adi4fbuf/adi4buf,adi4ibuf
      DATA adi4ibuf/1/
      END

      SUBROUTINE PUSHINTEGER4(x)
      INTEGER*4 x, adi4buf(512)
      INTEGER adi4ibuf
      COMMON /adi4fbuf/adi4buf,adi4ibuf
      CALL addftraffic(4)
      adi4buf(adi4ibuf) = x
      IF (adi4ibuf.eq.512) THEN
         CALL PUSHINTEGER4ARRAY(adi4buf, 512)
         CALL addftraffic(-512*4)
         adi4ibuf = 1
      ELSE
         adi4ibuf = adi4ibuf+1
      ENDIF
      END

      SUBROUTINE POPINTEGER4(x)
      INTEGER*4 x, adi4buf(512)
      INTEGER adi4ibuf
      COMMON /adi4fbuf/adi4buf,adi4ibuf
      IF (adi4ibuf.le.1) THEN
         CALL POPINTEGER4ARRAY(adi4buf, 512)
         adi4ibuf = 512
      ELSE
         adi4ibuf = adi4ibuf-1         
      ENDIF
      x = adi4buf(adi4ibuf)
      END

C ************************ integer*8 ************************
      BLOCK DATA INTEGERS8
      INTEGER*8 adi8buf(512)
      INTEGER adi8ibuf
      COMMON /adi8fbuf/adi8buf,adi8ibuf
      DATA adi8ibuf/1/
      END

      SUBROUTINE PUSHINTEGER8(x)
      INTEGER*8 x, adi8buf(512)
      INTEGER adi8ibuf
      COMMON /adi8fbuf/adi8buf,adi8ibuf
      CALL addftraffic(8)
      adi8buf(adi8ibuf) = x
      IF (adi8ibuf.eq.512) THEN
         CALL PUSHINTEGER8ARRAY(adi8buf, 512)
         CALL addftraffic(-8*512)
         adi8ibuf = 1
      ELSE
         adi8ibuf = adi8ibuf+1
      ENDIF
      END

      SUBROUTINE POPINTEGER8(x)
      INTEGER*8 x, adi8buf(512)
      INTEGER adi8ibuf
      COMMON /adi8fbuf/adi8buf,adi8ibuf
      IF (adi8ibuf.le.1) THEN
         CALL POPINTEGER8ARRAY(adi8buf, 512)
         adi8ibuf = 512
      ELSE
         adi8ibuf = adi8ibuf-1         
      ENDIF
      x = adi8buf(adi8ibuf)
      END

C ************************ real*4 ************************
      BLOCK DATA REALS4
      REAL*4 adr4buf(512)
      INTEGER adr4ibuf
      COMMON /adr4fbuf/adr4buf,adr4ibuf
      DATA adr4ibuf/1/
      END

      SUBROUTINE PUSHREAL4(x)
      REAL*4 x, adr4buf(512)
      INTEGER adr4ibuf
      COMMON /adr4fbuf/adr4buf,adr4ibuf
      CALL addftraffic(4)
      adr4buf(adr4ibuf) = x
      IF (adr4ibuf.eq.512) THEN
         CALL PUSHREAL4ARRAY(adr4buf, 512)
         CALL addftraffic(-4*512)
         adr4ibuf = 1
      ELSE
         adr4ibuf = adr4ibuf+1
      ENDIF
      END

      SUBROUTINE POPREAL4(x)
      REAL*4 x, adr4buf(512)
      INTEGER adr4ibuf
      COMMON /adr4fbuf/adr4buf,adr4ibuf
      IF (adr4ibuf.le.1) THEN
         CALL POPREAL4ARRAY(adr4buf, 512)
         adr4ibuf = 512
      ELSE
         adr4ibuf = adr4ibuf-1         
      ENDIF
      x = adr4buf(adr4ibuf)
      END

C ************************ real*8 ************************
      BLOCK DATA REALS8
      REAL*8 adr8buf(512)
      INTEGER adr8ibuf
      COMMON /adr8fbuf/adr8buf,adr8ibuf
      DATA adr8ibuf/1/
      END

      SUBROUTINE PUSHREAL8(x)
      REAL*8 x, adr8buf(512)
      INTEGER adr8ibuf
      COMMON /adr8fbuf/adr8buf,adr8ibuf
      CALL addftraffic(8)
      adr8buf(adr8ibuf) = x
      IF (adr8ibuf.eq.512) THEN
         CALL PUSHREAL8ARRAY(adr8buf, 512)
         CALL addftraffic(-8*512)
         adr8ibuf = 1
      ELSE
         adr8ibuf = adr8ibuf+1
      ENDIF
      END

      SUBROUTINE POPREAL8(x)
      REAL*8 x, adr8buf(512)
      INTEGER adr8ibuf
      COMMON /adr8fbuf/adr8buf,adr8ibuf
      IF (adr8ibuf.le.1) THEN
         CALL POPREAL8ARRAY(adr8buf, 512)
         adr8ibuf = 512
      ELSE
         adr8ibuf = adr8ibuf-1         
      ENDIF
      x = adr8buf(adr8ibuf)
      END

C ************************ complex*8 ************************
      BLOCK DATA COMPLEXS8
      COMPLEX*8 adc8buf(512)
      INTEGER adc8ibuf
      COMMON /adc8fbuf/adc8buf,adc8ibuf
      DATA adc8ibuf/1/
      END

      SUBROUTINE PUSHCOMPLEX8(x)
      COMPLEX*8 x, adc8buf(512)
      INTEGER adc8ibuf
      COMMON /adc8fbuf/adc8buf,adc8ibuf
      CALL addftraffic(8)
      adc8buf(adc8ibuf) = x
      IF (adc8ibuf.eq.512) THEN
         CALL PUSHCOMPLEX8ARRAY(adc8buf, 512)
         CALL addftraffic(-8*512)
         adc8ibuf = 1
      ELSE
         adc8ibuf = adc8ibuf+1
      ENDIF
      END

      SUBROUTINE POPCOMPLEX8(x)
      COMPLEX*8 x, adc8buf(512)
      INTEGER adc8ibuf
      COMMON /adc8fbuf/adc8buf,adc8ibuf
      IF (adc8ibuf.le.1) THEN
         CALL POPCOMPLEX8ARRAY(adc8buf, 512)
         adc8ibuf = 512
      ELSE
         adc8ibuf = adc8ibuf-1         
      ENDIF
      x = adc8buf(adc8ibuf)
      END

C ************************ complex*16 ************************
      BLOCK DATA COMPLEXS16
      COMPLEX*16 adc16buf(512)
      INTEGER adc16ibuf
      COMMON /adc16fbuf/adc16buf,adc16ibuf
      DATA adc16ibuf/1/
      END

      SUBROUTINE PUSHCOMPLEX16(x)
      COMPLEX*16 x, adc16buf(512)
      INTEGER adc16ibuf
      COMMON /adc16fbuf/adc16buf,adc16ibuf
      CALL addftraffic(16)
      adc16buf(adc16ibuf) = x
      IF (adc16ibuf.eq.512) THEN
         CALL PUSHCOMPLEX16ARRAY(adc16buf, 512)
         CALL addftraffic(-16*512)
         adc16ibuf = 1
      ELSE
         adc16ibuf = adc16ibuf+1
      ENDIF
      END

      SUBROUTINE POPCOMPLEX16(x)
      COMPLEX*16 x, adc16buf(512)
      INTEGER adc16ibuf
      COMMON /adc16fbuf/adc16buf,adc16ibuf
      IF (adc16ibuf.le.1) THEN
         CALL POPCOMPLEX16ARRAY(adc16buf, 512)
         adc16ibuf = 512
      ELSE
         adc16ibuf = adc16ibuf-1         
      ENDIF
      x = adc16buf(adc16ibuf)
      END

C ************************ character ************************
      BLOCK DATA CHARACTERS
      CHARACTER ads1buf(512)
      INTEGER ads1ibuf
      COMMON /ads1fbuf/ads1buf,ads1ibuf
      DATA ads1ibuf/1/
      END

      SUBROUTINE PUSHCHARACTER(x)
      CHARACTER x, ads1buf(512)
      INTEGER ads1ibuf
      COMMON /ads1fbuf/ads1buf,ads1ibuf
      CALL addftraffic(1)
      ads1buf(ads1ibuf) = x
      IF (ads1ibuf.eq.512) THEN
         CALL PUSHNARRAY(ads1buf, 512, 1)
         CALL addftraffic(-512)
         ads1ibuf = 1
      ELSE
         ads1ibuf = ads1ibuf+1
      ENDIF
      END

      SUBROUTINE POPCHARACTER(x)
      CHARACTER x, ads1buf(512)
      INTEGER ads1ibuf
      COMMON /ads1fbuf/ads1buf,ads1ibuf
      IF (ads1ibuf.le.1) THEN
         CALL POPNARRAY(ads1buf, 512, 1)
         ads1ibuf = 512
      ELSE
         ads1ibuf = ads1ibuf-1         
      ENDIF
      x = ads1buf(ads1ibuf)
      END

C ******************* bit (hidden primitives) ***************
      BLOCK DATA BITS
      INTEGER*4 adbitbuf
      INTEGER adbitibuf
      COMMON /adbitfbuf/adbitbuf, adbitibuf
      DATA adbitbuf/0/
      DATA adbitibuf/0/
      END

      SUBROUTINE PUSHBIT(bit)
      LOGICAL bit
      INTEGER*4 adbitbuf
      INTEGER adbitibuf
      COMMON /adbitfbuf/adbitbuf, adbitibuf
      IF (bit) THEN
         adbitbuf = IBSET(adbitbuf, adbitibuf)
      ELSE
         adbitbuf = IBCLR(adbitbuf, adbitibuf)
      ENDIF
      IF (adbitibuf.ge.31) THEN
         CALL PUSHNARRAY(adbitbuf, 4, 1)
         adbitbuf = 0
         adbitibuf = 0
      ELSE
         adbitibuf = adbitibuf+1
      ENDIF
      END

      LOGICAL FUNCTION POPBIT()
      INTEGER*4 adbitbuf
      INTEGER adbitibuf
      COMMON /adbitfbuf/adbitbuf, adbitibuf
      IF (adbitibuf.le.0) THEN
         CALL POPNARRAY(adbitbuf, 4, 1)
         adbitibuf = 31
      ELSE
         adbitibuf = adbitibuf-1
      ENDIF
      POPBIT = BTEST(adbitbuf, adbitibuf)
      END

C *************************** boolean *************************
      SUBROUTINE PUSHBOOLEAN(x)
      LOGICAL x
      CALL PUSHBIT(x)
      END

      SUBROUTINE POPBOOLEAN(x)
      LOGICAL x, POPBIT
      x = POPBIT()
      END

C ************************* control ***********************

      SUBROUTINE PUSHCONTROL1B(cc)
      INTEGER cc
      CALL PUSHBIT(cc.ne.0)
      END

      SUBROUTINE POPCONTROL1B(cc)
      INTEGER cc
      LOGICAL POPBIT
      IF (POPBIT()) THEN
         cc = 1
      ELSE
         cc = 0
      ENDIF
      END

      SUBROUTINE PUSHCONTROL2B(cc)
      INTEGER cc
      CALL PUSHBIT(BTEST(cc,0))
      CALL PUSHBIT(BTEST(cc,1))
      END

      SUBROUTINE POPCONTROL2B(cc)
      INTEGER cc
      LOGICAL POPBIT
      IF (POPBIT()) THEN
         cc = 2
      ELSE
         cc = 0
      ENDIF
      IF (POPBIT()) cc = IBSET(cc,0)
      END

      SUBROUTINE PUSHCONTROL3B(cc)
      INTEGER cc
      CALL PUSHBIT(BTEST(cc,0))
      CALL PUSHBIT(BTEST(cc,1))
      CALL PUSHBIT(BTEST(cc,2))
      END

      SUBROUTINE POPCONTROL3B(cc)
      INTEGER cc
      LOGICAL POPBIT
      IF (POPBIT()) THEN
         cc = 4
      ELSE
         cc = 0
      ENDIF
      IF (POPBIT()) cc = IBSET(cc,1)
      IF (POPBIT()) cc = IBSET(cc,0)
      END

      SUBROUTINE PUSHCONTROL4B(cc)
      INTEGER cc
      CALL PUSHBIT(BTEST(cc,0))
      CALL PUSHBIT(BTEST(cc,1))
      CALL PUSHBIT(BTEST(cc,2))
      CALL PUSHBIT(BTEST(cc,3))
      END

      SUBROUTINE POPCONTROL4B(cc)
      INTEGER cc
      LOGICAL POPBIT
      IF (POPBIT()) THEN
         cc = 8
      ELSE
         cc = 0
      ENDIF
      IF (POPBIT()) cc = IBSET(cc,2)
      IF (POPBIT()) cc = IBSET(cc,1)
      IF (POPBIT()) cc = IBSET(cc,0)
      END

      SUBROUTINE PUSHCONTROL5B(cc)
      INTEGER cc
      CALL PUSHBIT(BTEST(cc,0))
      CALL PUSHBIT(BTEST(cc,1))
      CALL PUSHBIT(BTEST(cc,2))
      CALL PUSHBIT(BTEST(cc,3))
      CALL PUSHBIT(BTEST(cc,4))
      END

      SUBROUTINE POPCONTROL5B(cc)
      INTEGER cc
      LOGICAL POPBIT
      IF (POPBIT()) THEN
         cc = 16
      ELSE
         cc = 0
      ENDIF
      IF (POPBIT()) cc = IBSET(cc,3)
      IF (POPBIT()) cc = IBSET(cc,2)
      IF (POPBIT()) cc = IBSET(cc,1)
      IF (POPBIT()) cc = IBSET(cc,0)
      END

      SUBROUTINE PUSHCONTROL6B(cc)
      INTEGER cc
      CALL PUSHBIT(BTEST(cc,0))
      CALL PUSHBIT(BTEST(cc,1))
      CALL PUSHBIT(BTEST(cc,2))
      CALL PUSHBIT(BTEST(cc,3))
      CALL PUSHBIT(BTEST(cc,4))
      CALL PUSHBIT(BTEST(cc,5))
      END

      SUBROUTINE POPCONTROL6B(cc)
      INTEGER cc
      LOGICAL POPBIT
      IF (POPBIT()) THEN
         cc = 32
      ELSE
         cc = 0
      ENDIF
      IF (POPBIT()) cc = IBSET(cc,4)
      IF (POPBIT()) cc = IBSET(cc,3)
      IF (POPBIT()) cc = IBSET(cc,2)
      IF (POPBIT()) cc = IBSET(cc,1)
      IF (POPBIT()) cc = IBSET(cc,0)
      END

      SUBROUTINE PUSHCONTROL7B(cc)
      INTEGER cc
      CALL PUSHBIT(BTEST(cc,0))
      CALL PUSHBIT(BTEST(cc,1))
      CALL PUSHBIT(BTEST(cc,2))
      CALL PUSHBIT(BTEST(cc,3))
      CALL PUSHBIT(BTEST(cc,4))
      CALL PUSHBIT(BTEST(cc,5))
      CALL PUSHBIT(BTEST(cc,6))
      END

      SUBROUTINE POPCONTROL7B(cc)
      INTEGER cc
      LOGICAL POPBIT
      IF (POPBIT()) THEN
         cc = 64
      ELSE
         cc = 0
      ENDIF
      IF (POPBIT()) cc = IBSET(cc,5)
      IF (POPBIT()) cc = IBSET(cc,4)
      IF (POPBIT()) cc = IBSET(cc,3)
      IF (POPBIT()) cc = IBSET(cc,2)
      IF (POPBIT()) cc = IBSET(cc,1)
      IF (POPBIT()) cc = IBSET(cc,0)
      END

      SUBROUTINE PUSHCONTROL8B(cc)
      INTEGER cc
      CALL PUSHBIT(BTEST(cc,0))
      CALL PUSHBIT(BTEST(cc,1))
      CALL PUSHBIT(BTEST(cc,2))
      CALL PUSHBIT(BTEST(cc,3))
      CALL PUSHBIT(BTEST(cc,4))
      CALL PUSHBIT(BTEST(cc,5))
      CALL PUSHBIT(BTEST(cc,6))
      CALL PUSHBIT(BTEST(cc,7))
      END

      SUBROUTINE POPCONTROL8B(cc)
      INTEGER cc
      LOGICAL POPBIT
      IF (POPBIT()) THEN
         cc = 128
      ELSE
         cc = 0
      ENDIF
      IF (POPBIT()) cc = IBSET(cc,6)
      IF (POPBIT()) cc = IBSET(cc,5)
      IF (POPBIT()) cc = IBSET(cc,4)
      IF (POPBIT()) cc = IBSET(cc,3)
      IF (POPBIT()) cc = IBSET(cc,2)
      IF (POPBIT()) cc = IBSET(cc,1)
      IF (POPBIT()) cc = IBSET(cc,0)
      END

      SUBROUTINE PUSHCONTROL9B(cc)
      INTEGER cc
      CALL PUSHBIT(BTEST(cc,0))
      CALL PUSHBIT(BTEST(cc,1))
      CALL PUSHBIT(BTEST(cc,2))
      CALL PUSHBIT(BTEST(cc,3))
      CALL PUSHBIT(BTEST(cc,4))
      CALL PUSHBIT(BTEST(cc,5))
      CALL PUSHBIT(BTEST(cc,6))
      CALL PUSHBIT(BTEST(cc,7))
      CALL PUSHBIT(BTEST(cc,8))
      END

      SUBROUTINE POPCONTROL9B(cc)
      INTEGER cc
      LOGICAL POPBIT
      IF (POPBIT()) THEN
         cc = 256
      ELSE
         cc = 0
      ENDIF
      IF (POPBIT()) cc = IBSET(cc,7)
      IF (POPBIT()) cc = IBSET(cc,6)
      IF (POPBIT()) cc = IBSET(cc,5)
      IF (POPBIT()) cc = IBSET(cc,4)
      IF (POPBIT()) cc = IBSET(cc,3)
      IF (POPBIT()) cc = IBSET(cc,2)
      IF (POPBIT()) cc = IBSET(cc,1)
      IF (POPBIT()) cc = IBSET(cc,0)
      END

C ************************* pointer ************************
c Don't know how to write a PUSH/POPPOINTER() in Fortran
c Maybe one should always call the C version instead...

C *********************************************************
C         HOW TO CREATE PUSH* POP* SUBROUTINES
C              YET FOR OTHER DATA TYPES
C  Duplicate and uncomment the commented code below.
C  In the duplicated and uncommented code, replace:
C    tttt -> BASIC TAPENADE TYPE NAME
C      (in character, boolean, integer, real, complex, pointer,...)
C    z7   -> LETTERSIZE FOR TYPE
C      (LETTER in s, b, i, r, c, p, ...) (SIZE is type size in bytes)
C    7    -> TYPE SIZE IN BYTES
C *********************************************************/

C ************************* TTTT*7 ************************
c      BLOCK DATA TTTTS7
c      TTTT*7 adz7buf(512)
c      INTEGER adz7ibuf
c      COMMON /adz7fbuf/adz7buf,adz7ibuf
c      DATA adz7ibuf/1/
c      END
c
c      SUBROUTINE PUSHTTTT7(x)
c      TTTT*7 x, adz7buf(512)
c      INTEGER adz7ibuf
c      COMMON /adz7fbuf/adz7buf,adz7ibuf
c      CALL addftraffic(7)
c      adz7buf(adz7ibuf) = x
c      IF (adz7ibuf.eq.512) THEN
c         CALL PUSHTTTT7ARRAY(adz7buf, 512)
c         CALL addftraffic(-7*512)
c         adz7ibuf = 1
c      ELSE
c         adz7ibuf = adz7ibuf+1
c      ENDIF
c      END
c
c      SUBROUTINE POPTTTT7(x)
c      TTTT*7 x, adz7buf(512)
c      INTEGER adz7ibuf
c      COMMON /adz7fbuf/adz7buf,adz7ibuf
c      IF (adz7ibuf.le.1) THEN
c         CALL POPTTTT7ARRAY(adz7buf, 512)
c         adz7ibuf = 512
c      ELSE
c         adz7ibuf = adz7ibuf-1         
c      ENDIF
c      x = adz7buf(adz7ibuf)
c      END

C *************** REPEATED ACCESS MECHANISM *********************
C     5 nested repeat levels should be more than enough!!
      BLOCK DATA BUFFERREPEAT
      INTEGER nbbufrepeat
      INTEGER indexi4repeats(5)
      INTEGER indexi8repeats(5)
      INTEGER indexr4repeats(5)
      INTEGER indexr8repeats(5)
      INTEGER indexc8repeats(5)
      INTEGER indexc16repeats(5)
      INTEGER indexs1repeats(5)
      INTEGER indexbitrepeats(5)
      INTEGER indexptrrepeats(5)
      COMMON /allbufferrepeats/indexi4repeats, indexi8repeats,
     +     indexr4repeats, indexr8repeats, indexc8repeats,
     +     indexc16repeats, indexs1repeats, indexbitrepeats,
     +     indexptrrepeats, nbbufrepeat
      DATA nbbufrepeat/0/
      END

      SUBROUTINE ADSTACK_STARTREPEAT()
      INTEGER nbbufrepeat
      INTEGER indexi4repeats(5)
      INTEGER indexi8repeats(5)
      INTEGER indexr4repeats(5)
      INTEGER indexr8repeats(5)
      INTEGER indexc8repeats(5)
      INTEGER indexc16repeats(5)
      INTEGER indexs1repeats(5)
      INTEGER indexbitrepeats(5)
      INTEGER indexptrrepeats(5)
      COMMON /allbufferrepeats/indexi4repeats, indexi8repeats,
     +     indexr4repeats, indexr8repeats, indexc8repeats,
     +     indexc16repeats, indexs1repeats, indexbitrepeats,
     +     indexptrrepeats, nbbufrepeat
      INTEGER*4 adi4buf(512)
      INTEGER adi4ibuf
      COMMON /adi4fbuf/adi4buf,adi4ibuf
      INTEGER*8 adi8buf(512)
      INTEGER adi8ibuf
      COMMON /adi8fbuf/adi8buf,adi8ibuf
      REAL*4 adr4buf(512)
      INTEGER adr4ibuf
      COMMON /adr4fbuf/adr4buf,adr4ibuf
      REAL*8 adr8buf(512)
      INTEGER adr8ibuf
      COMMON /adr8fbuf/adr8buf,adr8ibuf
      COMPLEX*8 adc8buf(512)
      INTEGER adc8ibuf
      COMMON /adc8fbuf/adc8buf,adc8ibuf
      COMPLEX*16 adc16buf(512)
      INTEGER adc16ibuf
      COMMON /adc16fbuf/adc16buf,adc16ibuf
      CHARACTER ads1buf(512)
      INTEGER ads1ibuf
      COMMON /ads1fbuf/ads1buf,ads1ibuf
      INTEGER*4 adbitbuf
      INTEGER adbitibuf
      COMMON /adbitfbuf/adbitbuf, adbitibuf
c Create a new "buffers" repeat level:
      nbbufrepeat = nbbufrepeat+1
c Also create a new repeat level for the main stack:
      CALL STARTSTACKREPEAT1()
c Push all local buffers on the main stack.
c 3rd arg is 0 to deactivate the check for stack read-only zone:
      if (adi4ibuf.gt.1) CALL PUSHNARRAY(adi4buf, 4*(adi4ibuf-1), 0)
      if (adi8ibuf.gt.1) CALL PUSHNARRAY(adi8buf, 8*(adi8ibuf-1), 0)
      if (adr4ibuf.gt.1) CALL PUSHNARRAY(adr4buf, 4*(adr4ibuf-1), 0)
      if (adr8ibuf.gt.1) CALL PUSHNARRAY(adr8buf, 8*(adr8ibuf-1), 0)
      if (adc8ibuf.gt.1) CALL PUSHNARRAY(adc8buf, 8*(adc8ibuf-1), 0)
      if (adc16ibuf.gt.1)CALL PUSHNARRAY(adc16buf,16*(adc16ibuf-1),0)
      if (ads1ibuf.gt.1) CALL PUSHNARRAY(ads1buf, ads1ibuf-1, 0)
      CALL PUSHNARRAY(adbitbuf, 4, 0)
c      if (adptribuf.gt.1) CALL PUSHNARRAY(adptrbuf, 8*(adptribuf-1), 0)
      indexi4repeats(nbbufrepeat) = adi4ibuf
      indexi8repeats(nbbufrepeat) = adi8ibuf
      indexr4repeats(nbbufrepeat) = adr4ibuf
      indexr8repeats(nbbufrepeat) = adr8ibuf
      indexc8repeats(nbbufrepeat) = adc8ibuf
      indexc16repeats(nbbufrepeat) = adc16ibuf
      indexs1repeats(nbbufrepeat) = ads1ibuf
      indexbitrepeats(nbbufrepeat) = adbitibuf
c      indexptrrepeats(nbbufrepeat) = adptribuf
c Store current location as repeat location of new repeat level.
c Note that this repeat location protects below as read-only.
c Make the new repeat level the current repeat level  for the main stack:
      CALL STARTSTACKREPEAT2()
      END

c Note: ADSTACK_RESETREPEAT() forces exit from any internal checkpointed sequence,
c   i.e. all nested push'es are forced popped.
      SUBROUTINE ADSTACK_RESETREPEAT()
      INTEGER nbbufrepeat
      INTEGER indexi4repeats(5)
      INTEGER indexi8repeats(5)
      INTEGER indexr4repeats(5)
      INTEGER indexr8repeats(5)
      INTEGER indexc8repeats(5)
      INTEGER indexc16repeats(5)
      INTEGER indexs1repeats(5)
      INTEGER indexbitrepeats(5)
      INTEGER indexptrrepeats(5)
      COMMON /allbufferrepeats/indexi4repeats, indexi8repeats,
     +     indexr4repeats, indexr8repeats, indexc8repeats,
     +     indexc16repeats, indexs1repeats, indexbitrepeats,
     +     indexptrrepeats, nbbufrepeat
      INTEGER*4 adi4buf(512)
      INTEGER adi4ibuf
      COMMON /adi4fbuf/adi4buf,adi4ibuf
      INTEGER*8 adi8buf(512)
      INTEGER adi8ibuf
      COMMON /adi8fbuf/adi8buf,adi8ibuf
      REAL*4 adr4buf(512)
      INTEGER adr4ibuf
      COMMON /adr4fbuf/adr4buf,adr4ibuf
      REAL*8 adr8buf(512)
      INTEGER adr8ibuf
      COMMON /adr8fbuf/adr8buf,adr8ibuf
      COMPLEX*8 adc8buf(512)
      INTEGER adc8ibuf
      COMMON /adc8fbuf/adc8buf,adc8ibuf
      COMPLEX*16 adc16buf(512)
      INTEGER adc16ibuf
      COMMON /adc16fbuf/adc16buf,adc16ibuf
      CHARACTER ads1buf(512)
      INTEGER ads1ibuf
      COMMON /ads1fbuf/ads1buf,ads1ibuf
      INTEGER*4 adbitbuf
      INTEGER adbitibuf
      COMMON /adbitfbuf/adbitbuf, adbitibuf
c First stage of reset repeat for the main stack:
      CALL RESETSTACKREPEAT1()
c Restore all local buffers:
      adi4ibuf  = indexi4repeats(nbbufrepeat)
      adi8ibuf  = indexi8repeats(nbbufrepeat)
      adr4ibuf  = indexr4repeats(nbbufrepeat)
      adr8ibuf  = indexr8repeats(nbbufrepeat)
      adc8ibuf  = indexc8repeats(nbbufrepeat)
      adc16ibuf = indexc16repeats(nbbufrepeat)
      ads1ibuf  = indexs1repeats(nbbufrepeat)
      adbitibuf = indexbitrepeats(nbbufrepeat)
c      adptribuf = indexptrrepeats(nbbufrepeat)
c      if (adptribuf.gt.1) CALL POPNARRAY(adptrbuf, 8*(adptribuf-1),0)
      CALL POPNARRAY(adbitbuf, 4, 0)
c 3rd arg is 0 to deactivate the check for stack read-only zone:
      if (ads1ibuf.gt.1) CALL POPNARRAY(ads1buf, ads1ibuf-1, 0)
      if (adc16ibuf.gt.1)CALL POPNARRAY(adc16buf,16*(adc16ibuf-1),0)
      if (adc8ibuf.gt.1) CALL POPNARRAY(adc8buf, 8*(adc8ibuf-1), 0)
      if (adr8ibuf.gt.1) CALL POPNARRAY(adr8buf, 8*(adr8ibuf-1), 0)
      if (adr4ibuf.gt.1) CALL POPNARRAY(adr4buf, 4*(adr4ibuf-1), 0)
      if (adi8ibuf.gt.1) CALL POPNARRAY(adi8buf, 8*(adi8ibuf-1), 0)
      if (adi4ibuf.gt.1) CALL POPNARRAY(adi4buf, 4*(adi4ibuf-1), 0)
c Second stage of reset repeat for the main stack:
      CALL RESETSTACKREPEAT2()
      END

c Note: ADSTACK_ENDREPEAT() forces exit from any internal checkpointed sequence,
c   i.e. all nested push'es are forced popped.
      SUBROUTINE ADSTACK_ENDREPEAT()
      INTEGER nbbufrepeat
      INTEGER indexi4repeats(5)
      INTEGER indexi8repeats(5)
      INTEGER indexr4repeats(5)
      INTEGER indexr8repeats(5)
      INTEGER indexc8repeats(5)
      INTEGER indexc16repeats(5)
      INTEGER indexs1repeats(5)
      INTEGER indexbitrepeats(5)
      INTEGER indexptrrepeats(5)
      COMMON /allbufferrepeats/indexi4repeats, indexi8repeats,
     +     indexr4repeats, indexr8repeats, indexc8repeats,
     +     indexc16repeats, indexs1repeats, indexbitrepeats,
     +     indexptrrepeats, nbbufrepeat
c End repeat for the main stack:
      CALL ENDSTACKREPEAT() ;
c Remove top repeat level:
      nbbufrepeat = nbbufrepeat-1
      END

      SUBROUTINE SHOWI4BUFFERANDREPEATS(xbuf,xibuf,
     +     xrepeats,nbbufrepeat)
      INTEGER*4 xbuf(512)
      INTEGER xibuf, xrepeats(5), nbbufrepeat
      CHARACTER(len=3) seps(513)
      INTEGER i
      DO i=1,513
         seps(i) = ''
      ENDDO
      seps(xibuf) = ' |'
      WRITE (6,991) (seps(i),xbuf(i),i=1,512),
     +     (xrepeats(i),i=1,nbbufrepeat)
 991  FORMAT('      I4:',512(a2,i10.1),' REPEATS:',5i3)
      END

      SUBROUTINE SHOWI8BUFFERANDREPEATS(xbuf,xibuf,
     +     xrepeats,nbbufrepeat)
      INTEGER*8 xbuf(512)
      INTEGER xibuf, xrepeats(5), nbbufrepeat
      CHARACTER(len=3) seps(513)
      INTEGER i
      DO i=1,513
         seps(i) = ''
      ENDDO
      seps(xibuf) = ' |'
      WRITE (6,991) (seps(i),xbuf(i),i=1,512),
     +     (xrepeats(i),i=1,nbbufrepeat)
 991  FORMAT('      I8:',512(a2,i20.1),' REPEATS:',5i3)
      END

      SUBROUTINE SHOWR4BUFFERANDREPEATS(xbuf,xibuf,
     +     xrepeats,nbbufrepeat)
      REAL*4 xbuf(512)
      INTEGER xibuf, xrepeats(5), nbbufrepeat
      CHARACTER(len=3) seps(513)
      INTEGER i
      DO i=1,513
         seps(i) = ''
      ENDDO
      seps(xibuf) = ' |'
      WRITE (6,991) (seps(i),xbuf(i),i=1,512),
     +     (xrepeats(i),i=1,nbbufrepeat)
 991  FORMAT('      R4:',512(a2,e12.5),' REPEATS:',5i3)
      END

      SUBROUTINE SHOWR8BUFFERANDREPEATS(xbuf,xibuf,
     +     xrepeats,nbbufrepeat)
      REAL*8 xbuf(512)
      INTEGER xibuf, xrepeats(5), nbbufrepeat
      CHARACTER(len=3) seps(513)
      INTEGER i
      DO i=1,513
         seps(i) = ''
      ENDDO
      seps(xibuf) = ' |'
      WRITE (6,991) (seps(i),xbuf(i),i=1,512),
     +     (xrepeats(i),i=1,nbbufrepeat)
 991  FORMAT('      R8:',512(a2,d12.5),' REPEATS:',5i3)
      END

      SUBROUTINE SHOWC8BUFFERANDREPEATS(xbuf,xibuf,
     +     xrepeats,nbbufrepeat)
      COMPLEX*8 xbuf(512)
      INTEGER xibuf, xrepeats(5), nbbufrepeat
      CHARACTER(len=3) seps(513)
      INTEGER i
      DO i=1,513
         seps(i) = ''
      ENDDO
      seps(xibuf) = ' |'
      WRITE (6,991) (seps(i),xbuf(i),i=1,512),
     +     (xrepeats(i),i=1,nbbufrepeat)
 991  FORMAT('      C8:',512(a2,'(',e12.5,' i',e12.5,')'),
     +     ' REPEATS:',5i3)
      END

      SUBROUTINE SHOWC16BUFFERANDREPEATS(xbuf,xibuf,
     +     xrepeats,nbbufrepeat)
      COMPLEX*16 xbuf(512)
      INTEGER xibuf, xrepeats(5), nbbufrepeat
      CHARACTER(len=3) seps(513)
      INTEGER i
      DO i=1,513
         seps(i) = ''
      ENDDO
      seps(xibuf) = ' |'
      WRITE (6,991) (seps(i),xbuf(i),i=1,512),
     +     (xrepeats(i),i=1,nbbufrepeat)
 991  FORMAT('      C16:',512(a2,'(',d12.5,' i',d12.5,')'),
     +     ' REPEATS:',5i3)
      END

      SUBROUTINE SHOWS1BUFFERANDREPEATS(xbuf,xibuf,
     +     xrepeats,nbbufrepeat)
      CHARACTER xbuf(512)
      INTEGER xibuf, xrepeats(5), nbbufrepeat
      CHARACTER(len=3) seps(513)
      INTEGER i
      DO i=1,513
         seps(i) = ''
      ENDDO
      seps(xibuf) = ' |'
      WRITE (6,991) (seps(i),xbuf(i),i=1,512),
     +     (xrepeats(i),i=1,nbbufrepeat)
 991  FORMAT('      STR:',512(a2,a1),
     +     ' REPEATS:',5i3)
      END

      SUBROUTINE SHOWBITBUFFERANDREPEATS(xbuf,xibuf,
     +     xrepeats,nbbufrepeat)
      INTEGER*4 xbuf
      INTEGER xibuf, xrepeats(5), nbbufrepeat,i
      WRITE (6,991) xibuf,xbuf,(xrepeats(i),i=1,nbbufrepeat)
 991  FORMAT('      BITS:',i2,' in ',z8,'     REPEATS:',5i3)
      END

      SUBROUTINE SHOWSTACKANDBUFFERS(locationName)
      CHARACTER(*) locationName
      INTEGER nbbufrepeat
      INTEGER indexi4repeats(5)
      INTEGER indexi8repeats(5)
      INTEGER indexr4repeats(5)
      INTEGER indexr8repeats(5)
      INTEGER indexc8repeats(5)
      INTEGER indexc16repeats(5)
      INTEGER indexs1repeats(5)
      INTEGER indexbitrepeats(5)
      INTEGER indexptrrepeats(5)
      COMMON /allbufferrepeats/indexi4repeats, indexi8repeats,
     +     indexr4repeats, indexr8repeats, indexc8repeats,
     +     indexc16repeats, indexs1repeats, indexbitrepeats,
     +     indexptrrepeats, nbbufrepeat
      INTEGER*4 adi4buf(512)
      INTEGER adi4ibuf
      COMMON /adi4fbuf/adi4buf,adi4ibuf
      INTEGER*8 adi8buf(512)
      INTEGER adi8ibuf
      COMMON /adi8fbuf/adi8buf,adi8ibuf
      REAL*4 adr4buf(512)
      INTEGER adr4ibuf
      COMMON /adr4fbuf/adr4buf,adr4ibuf
      REAL*8 adr8buf(512)
      INTEGER adr8ibuf
      COMMON /adr8fbuf/adr8buf,adr8ibuf
      COMPLEX*8 adc8buf(512)
      INTEGER adc8ibuf
      COMMON /adc8fbuf/adc8buf,adc8ibuf
      COMPLEX*16 adc16buf(512)
      INTEGER adc16ibuf
      COMMON /adc16fbuf/adc16buf,adc16ibuf
      CHARACTER ads1buf(512)
      INTEGER ads1ibuf
      COMMON /ads1fbuf/ads1buf,ads1ibuf
      INTEGER*4 adbitbuf
      INTEGER adbitibuf
      COMMON /adbitfbuf/adbitbuf, adbitibuf
      print *,locationName
      CALL SHOWSTACK()
      CALL SHOWI4BUFFERANDREPEATS(adi4buf,adi4ibuf,
     +     indexi4repeats,nbbufrepeat)
      CALL SHOWI8BUFFERANDREPEATS(adi8buf,adi8ibuf,
     +     indexi8repeats,nbbufrepeat)
      CALL SHOWR4BUFFERANDREPEATS(adr4buf,adr4ibuf,
     +     indexr4repeats,nbbufrepeat)
      CALL SHOWR8BUFFERANDREPEATS(adr8buf,adr8ibuf,
     +     indexr8repeats,nbbufrepeat)
      CALL SHOWC8BUFFERANDREPEATS(adc8buf,adc8ibuf,
     +     indexc8repeats,nbbufrepeat)
      CALL SHOWC16BUFFERANDREPEATS(adc16buf,adc16ibuf,
     +     indexc16repeats,nbbufrepeat)
      CALL SHOWS1BUFFERANDREPEATS(ads1buf,ads1ibuf,
     +     indexs1repeats,nbbufrepeat)
      CALL SHOWBITBUFFERANDREPEATS(adbitbuf,adbitibuf,
     +     indexbitrepeats,nbbufrepeat)
c No pointer buffer so far...
      END

      SUBROUTINE SHOWSTACKANDBUFFERSSIZE(pos)
      INTEGER*4 pos
      INTEGER*4 adi4buf(512)
      INTEGER adi4ibuf
      COMMON /adi4fbuf/adi4buf,adi4ibuf
      INTEGER*8 adi8buf(512)
      INTEGER adi8ibuf
      COMMON /adi8fbuf/adi8buf,adi8ibuf
      REAL*4 adr4buf(512)
      INTEGER adr4ibuf
      COMMON /adr4fbuf/adr4buf,adr4ibuf
      REAL*8 adr8buf(512)
      INTEGER adr8ibuf
      COMMON /adr8fbuf/adr8buf,adr8ibuf
      COMPLEX*8 adc8buf(512)
      INTEGER adc8ibuf
      COMMON /adc8fbuf/adc8buf,adc8ibuf
      COMPLEX*16 adc16buf(512)
      INTEGER adc16ibuf
      COMMON /adc16fbuf/adc16buf,adc16ibuf
      CHARACTER ads1buf(512)
      INTEGER ads1ibuf
      COMMON /ads1fbuf/ads1buf,ads1ibuf
      INTEGER*4 adbitbuf
      INTEGER adbitibuf
      COMMON /adbitfbuf/adbitbuf, adbitibuf
      CALL SHOWSTACKSIZE(adi4ibuf-1,adi8ibuf-1,adr4ibuf-1,adr8ibuf-1,
     +     adc8ibuf-1,adc16ibuf-1,ads1ibuf-1,adbitibuf-1,0,pos)
      END

C=========== MEASUREMENT OF PUSH TRAFFIC ==========

      BLOCK DATA BUFTRAFFICBLOCK
      INTEGER*8 buffertraffic
      COMMON /BUFTRAFFIC/buffertraffic
      DATA buffertraffic/0/
      END

      subroutine addftraffic(n)
      INTEGER n
      INTEGER*8 buffertraffic
      COMMON /BUFTRAFFIC/buffertraffic
      buffertraffic = buffertraffic+n
      END

      SUBROUTINE ADSTACK_SHOWTRAFFIC()
      INTEGER*8 buffertraffic
      COMMON /BUFTRAFFIC/buffertraffic
      call SHOWTOTALTRAFFIC(buffertraffic)
      END

#include "DIC_OPTIONS.h"

CBOP
C !ROUTINE: DIC_FIELDS_LOAD

C !INTERFACE: ==========================================================
      SUBROUTINE DIC_FIELDS_LOAD (
     I           myTime, myIter, myThid )

C !DESCRIPTION:
C  Read in fields needed for CO2,O2 fluxterms, silica for pH calculation

C !USES: ===============================================================
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "DIC_VARS.h"
#include "DIC_LOAD.h"

C !INPUT PARAMETERS: ===================================================
C  myTime               :: current time
C  myIter               :: current timestep
C  myThid               :: thread number
      _RL myTime
      INTEGER myIter
      INTEGER myThid

#ifdef ALLOW_DIC

c !LOCAL VARIABLES: ===================================================
      INTEGER bi, bj, i, j
      INTEGER intimeP, intime0, intime1
      _RL aWght,bWght
#ifdef DIC_CALCITE_SAT
      INTEGER k
#endif
CEOP

      IF (  DIC_forcingCycle.GT.0. _d 0 ) THEN

C--   Now calculate whether it is time to update the forcing arrays
       CALL GET_PERIODIC_INTERVAL(
     O                   intimeP, intime0, intime1, bWght, aWght,
     I                   DIC_forcingCycle, DIC_forcingPeriod,
     I                   deltaTClock, myTime, myThid )

       bi = myBxLo(myThid)
       bj = myByLo(myThid)
#ifdef ALLOW_DEBUG
       IF ( debugLevel.GE.debLevB ) THEN
        _BEGIN_MASTER(myThid)
        WRITE(standardMessageUnit,'(A,I10,A,4I5,A,2F14.10)')
     &   ' DIC_FIELDS_LOAD,', myIter,
     &   ' : iP,iLd,i0,i1=', intimeP,DIC_ldRec(bi,bj), intime0,intime1,
     &   ' ; Wght=', bWght, aWght
        _END_MASTER(myThid)
       ENDIF
#endif /* ALLOW_DEBUG */

#ifdef ALLOW_AUTODIFF
C-    assuming that we call S/R DIC_FIELDS_LOAD at each time-step and
C     with increasing time, this will catch when we need to load new records;
C     But with Adjoint run, this is not always the case => might end-up using
C     the wrong time-records
       IF ( intime0.NE.intimeP .OR. myIter.EQ.nIter0 ) THEN
#else /* ALLOW_AUTODIFF */
C-    Make no assumption on sequence of calls to DIC_FIELDS_LOAD ;
C     This is the correct formulation (works in Adjoint run).
C     Unfortunatly, produces many recomputations <== not used until it is fixed
       IF ( intime1.NE.DIC_ldRec(bi,bj) ) THEN
#endif /* ALLOW_AUTODIFF */

C--   If the above condition is met then we need to read in
C     data for the period ahead and the period behind myTime.
        IF ( debugLevel.GE.debLevZero ) THEN
         _BEGIN_MASTER(myThid)
         WRITE(standardMessageUnit,'(A,I10,A,2(2I5,A))')
     &    ' DIC_FIELDS_LOAD, it=', myIter,
     &    ' : Reading new data, i0,i1=', intime0, intime1,
     &    ' (prev=', intimeP, DIC_ldRec(bi,bj), ' )'
         _END_MASTER(myThid)
        ENDIF

        _BARRIER

        IF ( DIC_windFile .NE. ' '  ) THEN
         CALL READ_REC_XY_RS( DIC_windFile,dicwind0,intime0,
     &        myIter,myThid )
         CALL READ_REC_XY_RS( DIC_windFile,dicwind1,intime1,
     &        myIter,myThid )
        ENDIF
        IF ( DIC_atmospFile .NE. ' '  ) THEN
         CALL READ_REC_XY_RS( DIC_atmospFile,atmosp0,intime0,
     &        myIter,myThid )
         CALL READ_REC_XY_RS( DIC_atmospFile,atmosp1,intime1,
     &        myIter,myThid )
        ENDIF
        IF ( DIC_silicaFile .NE. ' '  ) THEN
         CALL READ_REC_XY_RS( DIC_silicaFile,silicaSurf0,intime0,
     &        myIter,myThid )
         CALL READ_REC_XY_RS( DIC_silicaFile,silicaSurf1,intime1,
     &        myIter,myThid )
        ENDIF
#ifdef DIC_CALCITE_SAT
        IF ( DIC_deepSilicaFile .NE. ' '  ) THEN
         CALL READ_REC_XYZ_RS( DIC_deepSilicaFile,silicaDeep0,intime0,
     &        myIter,myThid )
         CALL READ_REC_XYZ_RS( DIC_deepSilicaFile,silicaDeep1,intime1,
     &        myIter,myThid )
        ENDIF
#endif
        IF ( DIC_iceFile .NE. ' '  ) THEN
         CALL READ_REC_XY_RS( DIC_iceFile,ice0,intime0,
     &       myIter,myThid )
         CALL READ_REC_XY_RS( DIC_iceFile,ice1,intime1,
     &       myIter,myThid )
        ENDIF
#ifdef READ_PAR
        IF ( DIC_parFile .NE. ' '  ) THEN
         CALL READ_REC_XY_RS( DIC_parFile,par0,intime0,
     &       myIter,myThid )
         CALL READ_REC_XY_RS( DIC_parFile,par1,intime1,
     &       myIter,myThid )
        ENDIF
#endif
#ifdef LIGHT_CHL
C--   Load chlorophyll climatology data, unit for chlorophyll : mg/m3
        IF ( DIC_chlaFile .NE. ' '  ) THEN
         CALL READ_REC_XY_RS( DIC_chlaFile,chlinput,1,
     &       myIter,myThid )
        ENDIF
#endif
#ifdef ALLOW_FE
        IF ( DIC_ironFile .NE. ' '  ) THEN
         CALL READ_REC_XY_RS( DIC_ironFile,feinput0,intime0,
     &       myIter,myThid )
         CALL READ_REC_XY_RS( DIC_ironFile,feinput1,intime1,
     &       myIter,myThid )
        ENDIF
#endif

C--   fill-in overlap after loading temp arrays:
        _EXCH_XY_RS(dicwind0, myThid )
        _EXCH_XY_RS(dicwind1, myThid )
        _EXCH_XY_RS(atmosp0, myThid )
        _EXCH_XY_RS(atmosp1, myThid )
        _EXCH_XY_RS(silicaSurf0, myThid )
        _EXCH_XY_RS(silicaSurf1, myThid )
#ifdef DIC_CALCITE_SAT
      IF ( DIC_deepSilicaFile .NE. ' '  ) THEN
        _EXCH_XYZ_RS(silicaDeep0, myThid )
        _EXCH_XYZ_RS(silicaDeep1, myThid )
      ENDIF
#endif
        _EXCH_XY_RS(ice0, myThid )
        _EXCH_XY_RS(ice1, myThid )
#ifdef READ_PAR
        _EXCH_XY_RS(par0, myThid )
        _EXCH_XY_RS(par1, myThid )
#endif
#ifdef LIGHT_CHL
        _EXCH_XY_RS(chlinput, myThid )
#endif
#ifdef ALLOW_FE
        _EXCH_XY_RS(feinput0, myThid )
        _EXCH_XY_RS(feinput1, myThid )
#endif

C-    save newly loaded time-record
        DO bj = myByLo(myThid), myByHi(myThid)
         DO bi = myBxLo(myThid), myBxHi(myThid)
           DIC_ldRec(bi,bj) = intime1
         ENDDO
        ENDDO

C-     end if-bloc (time to load new fields)
       ENDIF

       DO bj = myByLo(myThid), myByHi(myThid)
        DO bi = myBxLo(myThid), myBxHi(myThid)
         IF ( DIC_windFile .NE. ' '  ) THEN
           DO j=1-OLy,sNy+OLy
            DO i=1-OLx,sNx+OLx
             WIND(i,j,bi,bj) = bWght*dicwind0(i,j,bi,bj)
     &                       + aWght*dicwind1(i,j,bi,bj)
            ENDDO
           ENDDO

C calculate piston velocity
C QQ: note - we should have wind speed variance in here
C QQ         also need to check units, and conversion factors
c          pisvel(i,j,bi,bj)  =0.337*wind(i,j,bi,bj)**2/3.6d5    !QQQQ
         ENDIF
#ifndef USE_PLOAD
         IF ( DIC_atmospFile .NE. ' '  ) THEN
           DO j=1-OLy,sNy+OLy
            DO i=1-OLx,sNx+OLx
             AtmosP(i,j,bi,bj) = bWght*atmosp0(i,j,bi,bj)
     &                         + aWght*atmosp1(i,j,bi,bj)
            ENDDO
           ENDDO
         ENDIF
#endif
#ifdef DIC_CALCITE_SAT
         IF ( useCalciteSaturation .AND.
     &        DIC_deepSilicaFile .NE. ' '  ) THEN
          DO k=1,Nr
           DO j=1-OLy,sNy+OLy
            DO i=1-OLx,sNx+OLx
             silicaDeep(i,j,k,bi,bj) = bWght*silicaDeep0(i,j,k,bi,bj)
     &                               + aWght*silicaDeep1(i,j,k,bi,bj)
            ENDDO
           ENDDO
          ENDDO
         ENDIF
#endif
         IF ( DIC_silicaFile .NE. ' '  ) THEN
           DO j=1-OLy,sNy+OLy
            DO i=1-OLx,sNx+OLx
C If file provided for surface silicate, read it in
             silicaSurf(i,j,bi,bj) = bWght*silicaSurf0(i,j,bi,bj)
     &                             + aWght*silicaSurf1(i,j,bi,bj)
            ENDDO
           ENDDO
#ifndef ALLOW_AUTODIFF
#ifdef DIC_CALCITE_SAT
         ELSEIF ( DIC_deepSilicaFile .NE. ' '  ) THEN
           DO j=1-OLy,sNy+OLy
            DO i=1-OLx,sNx+OLx
C If no surface silicate file but deep (3d) silicate provided, use top level
             silicaSurf(i,j,bi,bj) = bWght*silicaDeep0(i,j,1,bi,bj)
     &                             + aWght*silicaDeep1(i,j,1,bi,bj)
            ENDDO
           ENDDO
#endif /* DIC_CALCITE_SAT */
#endif /* not ALLOW_AUTODIFF */
         ENDIF

         IF ( DIC_iceFile .NE. ' '  ) THEN
           DO j=1-OLy,sNy+OLy
            DO i=1-OLx,sNx+OLx
             fIce(i,j,bi,bj) = bWght*ice0(i,j,bi,bj)
     &                       + aWght*ice1(i,j,bi,bj)
            ENDDO
           ENDDO
         ENDIF

#ifdef READ_PAR
         IF ( DIC_parFile .NE. ' '  ) THEN
           DO j=1-OLy,sNy+OLy
            DO i=1-OLx,sNx+OLx
             PAR(i,j,bi,bj) = bWght*par0(i,j,bi,bj)
     &                      + aWght*par1(i,j,bi,bj)
            ENDDO
           ENDDO
         ENDIF
#endif
#ifdef LIGHT_CHL
         IF ( DIC_chlaFile .NE. ' '  ) THEN
           DO j=1-OLy,sNy+OLy
            DO i=1-OLx,sNx+OLx
             CHL(i,j,bi,bj) = chlinput(i,j,bi,bj)
            ENDDO
           ENDDO
         ENDIF
#endif
#ifdef ALLOW_FE
         IF ( DIC_ironFile .NE. ' '  ) THEN
           DO j=1-OLy,sNy+OLy
            DO i=1-OLx,sNx+OLx
             InputFe(i,j,bi,bj) = bWght*feinput0(i,j,bi,bj)
     &                          + aWght*feinput1(i,j,bi,bj)
            ENDDO
           ENDDO
         ENDIF
#endif
        ENDDO
       ENDDO

C endif for DIC_forcingCycle
      ENDIF

#endif /* ALLOW_DIC */
      RETURN
      END

#include "CPP_EEOPTIONS.h"
#include "W2_OPTIONS.h"

C--   File w2_cumulsum_z_tile.F: Routines that perform cumulated sum
C                                on a tiled array, corner grid-cell location
C      Contents
C      o W2_CUMULSUM_Z_TILE_RL
C      o W2_CUMULSUM_Z_TILE_RS <- not yet coded

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: W2_CUMULSUM_Z_TILE_RL

C     !INTERFACE:
      SUBROUTINE W2_CUMULSUM_Z_TILE_RL(
     O                       psiZ, psiLoc,
     I                       dPsiX, dPsiY, myThid )

C     !DESCRIPTION:
C     *==========================================================*
C     | SUBROUTINE W2\_CUMULSUM\_Z\_TILE\_RL
C     | o Handle cumulated sum for _RL tile data.
C     *==========================================================*
C     | Cumulate sum on tiled array, corner grid-cell location:
C     |  Starts from 1rst tile and, going through all tiles & all
C     |  the processes, add increment in both directions
C     *==========================================================*

C     !USES:
      IMPLICIT NONE

C     == Global data ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "EESUPPORT.h"
#include "W2_EXCH2_SIZE.h"
#include "W2_EXCH2_PARAMS.h"
#include "W2_EXCH2_TOPOLOGY.h"
#include "CUMULSUM.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     psiZ    :: results of cumulated sum, corresponds to tile South-East corner
C     psiLoc  :: cumulated sum at special locations
C     dPsiX   :: tile increment in X direction
C     dPsiY   :: tile increment in Y direction
C     myThid  :: my Thread Id. number
      _RL     psiZ  (nSx,nSy)
      _RL     psiLoc(2)
      _RL     dPsiX (nSx,nSy)
      _RL     dPsiY (nSx,nSy)
      INTEGER myThid

C     !LOCAL VARIABLES:
C     == Local variables ==
C     bi,bj   :: tile indices
C- type declaration of: loc[1,2]Buf and shareBufCS[1,2]_R8 :
C         all 4 needs to have the same length as MPI_DOUBLE_PRECISION
      INTEGER bi,bj
      INTEGER tN, tS
      Real*8  globalBuf(3,W2_maxNbTiles)
#ifndef W2_CUMSUM_USE_MATRIX
      Real*8 facetXYSum(2,W2_maxNbFacets)
      Real*8 facet_CSum(  W2_maxNbFacets)
      INTEGER fNx, fNy, nbTx, nbTy
      INTEGER i, j
#endif
#ifdef ALLOW_USE_MPI
      INTEGER np, pId
      INTEGER lbuf1, lbuf2, idest, itag, ready_to_receive
      INTEGER istatus(MPI_STATUS_SIZE), ierr
      Real*8  loc1Buf  (nSx,nSy)
      Real*8  loc2Buf(2,nSx,nSy)
#endif /* ALLOW_USE_MPI */
CEOP

C--   Initialise to zero:
      psiLoc(1) = 0.
      psiLoc(2) = 0.
      DO tN = 1,exch2_nTiles
        globalBuf(1,tN) = 0.
        globalBuf(2,tN) = 0.
        globalBuf(3,tN) = 0.
      ENDDO

C--   write input into shared-buffer array
      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
         shareBufCS2_R8(1,bi,bj) = dPsiX(bi,bj)
         shareBufCS2_R8(2,bi,bj) = dPsiY(bi,bj)
       ENDDO
      ENDDO

C--   Master thread cannot start until everyone is ready:
      CALL BAR2( myThid )
      _BEGIN_MASTER( myThid )

#ifdef ALLOW_USE_MPI
      IF ( usingMPI ) THEN

       lbuf1 = nSx*nSy
       lbuf2 = 2*lbuf1
       idest = 0
       itag  = 0
       ready_to_receive = 0

       IF ( mpiMyId.NE.0 ) THEN

C--   All proceses except 0 wait to be polled then send local array
#ifndef DISABLE_MPI_READY_TO_RECEIVE
           CALL MPI_RECV (ready_to_receive, 1, MPI_INTEGER,
     &                    idest, itag, MPI_COMM_MODEL, istatus, ierr)
#endif
           CALL MPI_SEND (shareBufCS2_R8, lbuf2, MPI_DOUBLE_PRECISION,
     &                    idest, itag, MPI_COMM_MODEL, ierr)

C--   All proceses except 0 receive result from process 0
           CALL MPI_RECV (shareBufCS1_R8, lbuf1, MPI_DOUBLE_PRECISION,
     &                    idest, itag, MPI_COMM_MODEL, istatus, ierr)

       ELSE

C--   Process 0 polls and receives data from each process in turn
         DO np = 2, nPx*nPy
           pId = np - 1
#ifndef DISABLE_MPI_READY_TO_RECEIVE
           CALL MPI_SEND (ready_to_receive, 1, MPI_INTEGER,
     &                    pId, itag, MPI_COMM_MODEL, ierr)
#endif
           CALL MPI_RECV (loc2Buf, lbuf2, MPI_DOUBLE_PRECISION,
     &                    pId, itag, MPI_COMM_MODEL, istatus, ierr)

C--   Process 0 gathers the local arrays into a global array.
           DO bj=1,nSy
            DO bi=1,nSx
              tN = W2_procTileList(bi,bj,np)
              globalBuf(1,tN) = loc2Buf(1,bi,bj)
              globalBuf(2,tN) = loc2Buf(2,bi,bj)
            ENDDO
           ENDDO
C-       end loop on np
         ENDDO

C--   end if process not 0 / else = 0
       ENDIF

      ENDIF
#endif /* ALLOW_USE_MPI */

      IF ( myProcId.EQ.0 ) THEN

C--   Process 0 fills-in its local data
         DO bj=1,nSy
          DO bi=1,nSx
            tN = W2_myTileList(bi,bj)
            globalBuf(1,tN) = shareBufCS2_R8(1,bi,bj)
            globalBuf(2,tN) = shareBufCS2_R8(2,bi,bj)
          ENDDO
         ENDDO

C--   Cumulate Sum over all tiles:
#ifdef W2_CUMSUM_USE_MATRIX
C-    Using tile x tile matrix:
         DO tN = 1,exch2_nTiles
           globalBuf(3,tN) = 0.
           DO tS = 1,exch2_nTiles
             globalBuf(3,tN) = globalBuf(3,tN)
     &                       + W2_cumSum_tiles(1,tS,tN)*globalBuf(1,tS)
     &                       + W2_cumSum_tiles(2,tS,tN)*globalBuf(2,tS)
           ENDDO
         ENDDO
#else /* W2_CUMSUM_USE_MATRIX */
C-    Cumulate per facet and then use facet x facet matrix:

         DO j=1,W2_maxNbFacets
           facetXYSum(1,j) = 0
           facetXYSum(2,j) = 0
           facet_CSum(j) = 0
         ENDDO

C-    First within each face:
         DO j=1,nFacets
          fNx = facet_dims(2*j-1)
          fNy = facet_dims( 2*j )
          IF ( fNx*fNy .GE. 1 ) THEN
           nbTx = fNx/sNx
           nbTy = fNy/sNy

           DO bi=1,nbTx-1
             tN = facet_owns(1,j) + bi-1
             globalBuf(3,tN+1) = globalBuf(3,tN) + globalBuf(1,tN)
           ENDDO
           DO bj=1,nbTy-1
            tS = facet_owns(1,j) - 1 + (bj-1)*nbTx
            DO bi=1,nbTx
             tN = tS + bi
             globalBuf(3,tN+nbTx) = globalBuf(3,tN) + globalBuf(2,tN)
            ENDDO
           ENDDO

C-    facet increment in X & Y dir
           DO bi=1,nbTx
            tN = facet_owns(1,j) + bi-1
            facetXYSum(1,j) = facetXYSum(1,j) + globalBuf(1,tN)
           ENDDO
           DO bj=1,nbTy
            tN = facet_owns(1,j) + (bj-1)*nbTx
            facetXYSum(2,j) = facetXYSum(2,j) + globalBuf(2,tN)
           ENDDO

          ENDIF
         ENDDO

C-    Calculate cumulated sum at facet origin using facet matrix:
         DO j=1,nFacets
          DO i=1,nFacets
           facet_CSum(j) = facet_CSum(j)
     &                   + W2_cumSum_facet(1,i,j)*facetXYSum(1,i)
     &                   + W2_cumSum_facet(2,i,j)*facetXYSum(2,i)
          ENDDO
         ENDDO

C-    Finally, add cumulated sum at facet origin:
         DO tN = 1,exch2_nTiles
          j = exch2_myFace(tN)
          IF ( j.NE.0 ) THEN
            globalBuf(3,tN) = globalBuf(3,tN) + facet_CSum(j)
          ENDIF
         ENDDO
#endif /* W2_CUMSUM_USE_MATRIX */

C-    Value at Special location (e.g., Missing-Corner values)
         IF ( W2_tMC1.GE.1 )
     &     psiLoc(1) = globalBuf(3,W2_tMC1) + globalBuf(2,W2_tMC1)
         IF ( W2_tMC2.GE.1 )
     &     psiLoc(2) = globalBuf(3,W2_tMC2) + globalBuf(1,W2_tMC2)

C--   Process 0 fills-in its local data
         DO bj=1,nSy
          DO bi=1,nSx
            tN = W2_myTileList(bi,bj)
            shareBufCS1_R8(bi,bj) = globalBuf(3,tN)
          ENDDO
         ENDDO

#ifdef ALLOW_USE_MPI
        IF ( usingMPI ) THEN
C--   Process 0 sends result to all other processes
         DO np = 2, nPx*nPy
           pId = np - 1
C-    fill local array with relevant portion of global array
           DO bj=1,nSy
            DO bi=1,nSx
              tN = W2_procTileList(bi,bj,np)
              loc1Buf(bi,bj) = globalBuf(3,tN)
            ENDDO
           ENDDO
           CALL MPI_SEND (loc1Buf, lbuf1, MPI_DOUBLE_PRECISION,
     &                    pId, itag, MPI_COMM_MODEL, ierr)
         ENDDO

        ENDIF
#endif /* ALLOW_USE_MPI */

C--   end if process 0
      ENDIF

      _END_MASTER( myThid )
C--   Everyone wait for Master thread to be ready
      CALL BAR2( myThid )

C--   set result for every threads
      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
         psiZ(bi,bj) = shareBufCS1_R8(bi,bj)
       ENDDO
      ENDDO

      RETURN
      END

#include "AUTODIFF_OPTIONS.h"
#ifdef ALLOW_CTRL
# include "CTRL_OPTIONS.h"
#endif
#include "AD_CONFIG.h"

CBOP
C     !ROUTINE: g_dummy_in_dynamics
C     !INTERFACE:
      subroutine g_dummy_in_dynamics( myTime, myIter, myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE g_dummy_in_dynamics                           |
C     *==========================================================*
C     Extract tangent linear variable from TAF-generated
C     tangent linear common blocks, contained in g_common.h
C     and write fields to file;
C     Make sure common blocks in g_common.h are up-to-date
C     w.r.t. current adjoint code.
C     *==========================================================*
C     | SUBROUTINE g_dummy_in_dynamics                           |
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     == Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#ifdef ALLOW_AUTODIFF_MONITOR
# include "g_common.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     myTime :: time counter for this thread
C     myIter :: iteration counter for this thread
C     myThid :: Thread number for this instance of the routine.
      _RL     myTime
      INTEGER myIter
      INTEGER myThid

#ifdef ALLOW_TANGENTLINEAR_RUN
#ifdef ALLOW_AUTODIFF_MONITOR

C     !FUNCTIONS:
      LOGICAL  DIFFERENT_MULTIPLE
      EXTERNAL DIFFERENT_MULTIPLE

C     !LOCAL VARIABLES:
c     == local variables ==
C     suff   :: Hold suffix part of a filename
C     msgBuf :: Error message buffer
      CHARACTER*(10) suff
c     CHARACTER*(MAX_LEN_MBUF) msgBuf
CEOP

      IF (
     &  DIFFERENT_MULTIPLE(adjDumpFreq,myTime,deltaTClock)
     & ) THEN

        CALL TIMER_START('I/O (WRITE)        [ADJOINT LOOP]', myThid )
c       write(*,*) 'myIter= ',myIter

C--     Set suffix for this set of data files.
        IF ( rwSuffixType.EQ.0 ) THEN
          WRITE(suff,'(I10.10)') myIter
        ELSE
          CALL RW_GET_SUFFIX( suff, myTime, myIter, myThid )
        ENDIF

#ifdef ALLOW_AUTODIFF_MONITOR_DIAG
        CALL WRITE_FLD_XYZ_RL(
     &       'G_Jrhoinsitu.',suff, g_rhoinsitu, myIter, myThid)
        CALL WRITE_FLD_XYZ_RL(
     &       'G_Jtotphihyd.',suff, g_totphihyd, myIter, myThid)
#endif

        CALL TIMER_STOP( 'I/O (WRITE)        [ADJOINT LOOP]', myThid )

      ENDIF

#endif /* ALLOW_AUTODIFF_MONITOR */
#endif /* ALLOW_TANGENTLINEAR_RUN */

      RETURN
      END

#include "OBSFIT_OPTIONS.h"
#ifdef ALLOW_COST
#include "COST_OPTIONS.h"
#endif

CBOP
C     !ROUTINE: OBSFIT_COST_FINAL
C     !INTERFACE:
      SUBROUTINE OBSFIT_COST_FINAL( ifc, optimcycle, myThid )

C     !DESCRIPTION:
C     *==========================================================*
C     | SUBROUTINE OBSFIT_COST_FINAL
C     *==========================================================*

C     !USES:
      IMPLICIT NONE

C     == global variables ==
#include "EEPARAMS.h"
#include "SIZE.h"
#include "PARAMS.h"
#ifdef ALLOW_COST
# include "cost.h"
#endif
#include "OBSFIT_SIZE.h"
#include "OBSFIT.h"

C     !INPUT/OUTPUT PARAMETERS:
C     ifc        :: file unit for costfunction_obsfit.XXXX
C     optimcycle :: cycle number of the off-line optimization.
C     myThid     :: my Thread Id number
      INTEGER ifc
      INTEGER optimcycle
      INTEGER myThid

#ifdef ALLOW_COST
C     ! FUNCTIONS:
      INTEGER  ILNBLNK
      EXTERNAL ILNBLNK

C     !LOCAL VARIABLES:
      INTEGER num_file_obs
      _RL f_obsfit(NFILESMAX_OBS)
      _RL no_obsfit(NFILESMAX_OBS)

      CHARACTER*24 cfname
      INTEGER IL
      CHARACTER*(MAX_LEN_MBUF) msgBuf
CEOP

c--   Each process has calculated the global part for itself.
      DO num_file_obs=1,NFILESMAX_OBS
        glofc = glofc + mult_obsfit(num_file_obs)
     &                 *objf_obsfit(num_file_obs)
      ENDDO

C     This is just a copy since obsfit does not have the tile logic of
C     other part of the code
      DO num_file_obs=1,NFILESMAX_OBS
       f_obsfit(num_file_obs) = objf_obsfit(num_file_obs)
       no_obsfit(num_file_obs) = num_obsfit(num_file_obs)
      ENDDO

CML I do not understand, why we do not need this or something like this here
CMLc--   Do global summation for each part of the cost function
CML      DO num_var=1,NVARMAX
CML       DO num_file=1,NFILESPROFMAX
CML        _GLOBAL_SUM_RL(f_obsfit(num_file_obs), myThid )
CML        _GLOBAL_SUM_RL(no_obsfit(num_file_obs), myThid )
CML       ENDDO
CML      ENDDO

C     start printing to STDOUT
      DO num_file_obs=1,NFILESMAX_OBS
       IF ( no_obsfit(num_file_obs).GT.zeroRL ) THEN
        WRITE(msgBuf,'(A,1PE22.14,I2,1X,1PE9.2)')
     &       ' --> f_obsfit =', f_obsfit(num_file_obs), num_file_obs,
     &       mult_obsfit(num_file_obs)
        CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
       ENDIF
      ENDDO

c--   Each process has calculated the global part for itself.

C     only master thread of master CPU open and write to file
      IF ( ifc .NE. -1 ) THEN

       WRITE(cfname,'(A,I4.4)') 'costfunction_obsfit.',optimcycle
       OPEN(unit=ifc,file=cfname)
       WRITE(msgBuf,'(A,A)')
     &      'Writing obsfit cost function info to ', cfname
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                     SQUEEZE_RIGHT, myThid )

       DO num_file_obs=1,NFILESMAX_OBS
        IF ( no_obsfit(num_file_obs).GT.zeroRL ) THEN
         IL = ILNBLNK( obsfitfiles(num_file_obs) )
         IL = MAX(IL,30)
         WRITE(ifc,'(4A,1PE22.14,1PE22.14,1X,1PE9.2)')
     &        obsfitfiles(num_file_obs)(1:IL), ' ', obsfit_nameval,
     &        ' = ', f_obsfit(num_file_obs), no_obsfit(num_file_obs),
     &        mult_obsfit(num_file_obs)
        ENDIF
       ENDDO
       CLOSE(ifc)

      ENDIF

#endif /* ALLOW_COST */

      RETURN
      END

#include "PTRACERS_OPTIONS.h"

CBOP
C     !ROUTINE: PTRACERS_OUTPUT

C     !INTERFACE:
      SUBROUTINE PTRACERS_OUTPUT(
     I     myTime, myIter, myThid )

C     !DESCRIPTION:
C     This is the controlling routine for PTRACERS output. It is
C     called from DO_THE_MODEL_IO.

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "PTRACERS_SIZE.h"
#include "PTRACERS_PARAMS.h"

C     !INPUT PARAMETERS:
C     myIter    :: time-step number
C     myTime    :: model time
C     myThid    :: thread number
      INTEGER myIter
      INTEGER myThid
      _RL myTime
CEOP

#ifdef ALLOW_PTRACERS
C     !LOCAL VARIABLES:

C     Write snapshot output
      CALL PTRACERS_WRITE_STATE( myTime, myIter, myThid )

#ifdef ALLOW_MONITOR
C     Compute and print monitor statistics
      CALL PTRACERS_MONITOR( myIter, myTime, myThid )
#endif /* ALLOW_MONITOR */

#endif /* ALLOW_PTRACERS */

      RETURN
      END

#include "PACKAGES_CONFIG.h"
#include "CPP_OPTIONS.h"
#ifdef ALLOW_EXCH2
# include "W2_OPTIONS.h"
#endif /* ALLOW_EXCH2 */

CBOP
C     !ROUTINE: INI_LOCAL_GRID
C     !INTERFACE:
      SUBROUTINE INI_LOCAL_GRID(
     O                           xGloc, yGloc,
     O                           delXloc, delYloc,
     O                           gridNx, gridNy,
     I                           bi, bj, myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE INI_LOCAL_GRID
C     | o Initialise model tile-local horizontal grid
C     *==========================================================*
C     | Set local grid-point location (xGloc & yGloc) and
C     |  local grid-point spacing (delXloc,delYloc) keeping the
C     |  same units as grid-spacing input parameter (delX,delY
C     |  and xgOrigin,ygOrigin).
C     | This tile-local mesh setting will be used to build
C     |  the horizontal model grid, according to the selected
C     |  grid option (cartesian, spherical_polar or cylindrical)
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#ifdef ALLOW_EXCH2
# include "W2_EXCH2_SIZE.h"
# include "W2_EXCH2_TOPOLOGY.h"
#endif /* ALLOW_EXCH2 */
#include "SET_GRID.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     xGloc   :: mesh corner-point location (local "Long" real array type)
C     yGloc   :: mesh corner-point location (local "Long" real array type)
C     delXloc :: mesh spacing in X direction
C     delYloc :: mesh spacing in Y direction
C     gridNx  :: mesh total grid-point number in X direction
C     gridNy  :: mesh total grid-point number in Y direction
C     bi, bj  :: tile indices
C     myThid  :: my Thread Id Number

C NOTICE the extended range of indices!!
      _RL xGloc(1-OLx:sNx+OLx+1,1-OLy:sNy+OLy+1)
      _RL yGloc(1-OLx:sNx+OLx+1,1-OLy:sNy+OLy+1)
C NOTICE the extended range of indices!!
      _RL delXloc(0-OLx:sNx+OLx)
      _RL delYloc(0-OLy:sNy+OLy)
      INTEGER gridNx, gridNy
      INTEGER bi, bj
      INTEGER myThid

C     !LOCAL VARIABLES:
C     == Local variables ==
C     xG0,yG0 :: coordinate of South-West tile-corner
C     iG0,jG0 :: Tile base X and Y indices within global index space
C     i, j    :: loop counters
      INTEGER iG0, jG0
      INTEGER i, j
      _RL xG0, yG0
#ifdef ALLOW_EXCH2
      INTEGER tN
#endif /* ALLOW_EXCH2 */

C     The functions iGl, jGl return the "global" index with valid values beyond
C     halo regions
C     cnh wrote:
C     >    I dont understand why we would ever have to multiply the
C     >    overlap by the total domain size e.g
C     >    OLx*Nx, OLy*Ny.
C     >    Can anybody explain? Lines are in ini_spherical_polar_grid.F.
C     >    Surprised the code works if its wrong, so I am puzzled.
C     jmc replied:
C     Yes, I can explain this since I put this modification to work
C     with small domain (where OLy > Ny, as for instance, zonal-average
C     case):
C     This has no effect on the acuracy of the evaluation of iGl(I,bi)
C     and jGl(j,bj) since we take mod(a+OLx*Nx,Nx) and mod(b+OLy*Ny,Ny).
C     But in case a or b is negative, then the FORTRAN function "mod"
C     does not return the matematical value of the "modulus" function,
C     and this is not good for your purpose.
C     This is why I add +OLx*Nx and +OLy*Ny to be sure that the 1rst
C     argument of the mod function is positive.
c     INTEGER iGl,jGl
c     iGl(i,bi) = 1+MOD(iG0+i-1+OLx*gridNx,gridNx)
c     jGl(j,bj) = 1+MOD(jG0+j-1+OLy*gridNy,gridNy)
CEOP

#ifdef ALLOW_EXCH2
      gridNx = exch2_mydNx(1)
      gridNy = exch2_mydNy(1)
#else /* ALLOW_EXCH2 */
      gridNx = Nx
      gridNy = Ny
#endif /* ALLOW_EXCH2 */

c     DO bj = myByLo(myThid), myByHi(myThid)
c      DO bi = myBxLo(myThid), myBxHi(myThid)
C     For this tile ...

C--   Set current tile base X and base Y indices within global index space
C     e.g., local indices of tile south-west corner grid point are (1,1)
C           and global indices are 1+iG0, 1+jG0
#ifdef ALLOW_EXCH2
        tN = W2_myTileList(bi,bj)
        iG0 = exch2_tBasex(tN)
        jG0 = exch2_tBasey(tN)
#else  /* ALLOW_EXCH2 */
        iG0 = myXGlobalLo - 1 + (bi-1)*sNx
        jG0 = myYGlobalLo - 1 + (bj-1)*sNy
#endif /* ALLOW_EXCH2 */

C--   First find coordinate of tile corner (meaning outer corner of halo)
        xG0 = xgOrigin
C       Find the X-coordinate of the outer grid-line of the "real" tile
        DO i=1, iG0
         xG0 = xG0 + delX(i)
        ENDDO
C       Back-step to the outer grid-line of the "halo" region
        DO i=1, OLx
         xG0 = xG0 - delX( 1+MOD(iG0-i+OLx*gridNx,gridNx) )
        ENDDO
C       Find the Y-coordinate of the outer grid-line of the "real" tile
        yG0 = ygOrigin
        DO j=1, jG0
         yG0 = yG0 + delY(j)
        ENDDO
C       Back-step to the outer grid-line of the "halo" region
        DO j=1, OLy
         yG0 = yG0 - delY( 1+MOD(jG0-j+OLy*gridNy,gridNy) )
        ENDDO

C--     Make a local copy of current-tile grid-spacing
        DO i=0-OLx,sNx+OLx
          delXloc(i) = delX( 1+MOD(iG0+i-1+OLx*gridNx,gridNx) )
        ENDDO
        DO j=0-OLy,sNy+OLy
          delYloc(j) = delY( 1+MOD(jG0+j-1+OLy*gridNy,gridNy) )
        ENDDO

C--     Calculate coordinates of cell corners for N+1 grid-lines
        DO j=1-OLy,sNy+OLy +1
         xGloc(1-OLx,j) = xG0
         DO i=1-OLx,sNx+OLx
          xGloc(i+1,j) = xGloc(i,j) + delXloc(i)
         ENDDO
        ENDDO
        DO i=1-OLx,sNx+OLx +1
         yGloc(i,1-OLy) = yG0
         DO j=1-OLy,sNy+OLy
          yGloc(i,j+1) = yGloc(i,j) + delYloc(j)
         ENDDO
        ENDDO

C--   end bi,bj loops
c      ENDDO
c     ENDDO

      RETURN
      END

#include "SHELFICE_OPTIONS.h"

CBOP
C     !ROUTINE: SHELFICE_OUTPUT
C     !INTERFACE:
      SUBROUTINE SHELFICE_OUTPUT( myTime, myIter, myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE SHELFICE_OUTPUT
C     | o Do SHELFICE snapshot output
C     |   and compute & write time-average output.
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "SHELFICE.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     myTime :: my time in simulation ( s )
C     myIter :: my Iteration number
C     myThid :: my Thread Id number
      _RL     myTime
      INTEGER myIter
      INTEGER myThid

C     !FUNCTIONS:
      LOGICAL  DIFFERENT_MULTIPLE
      EXTERNAL DIFFERENT_MULTIPLE

C     !LOCAL VARIABLES:
C     == Local variables ==
      CHARACTER*(10) suff
#ifdef ALLOW_MNC
      CHARACTER*(1) pf
#endif
CEOP

      IF (SHELFICEwriteState) THEN

C- note: surf.Fluxes have not yet been computed when called @ nIter0
       IF ( myIter .NE. nIter0 .AND.
     &      DIFFERENT_MULTIPLE(SHELFICE_dumpFreq,myTime,deltaTClock)
     &    ) THEN

#ifdef ALLOW_MNC
        IF ( useMNC .AND. SHELFICE_dump_mnc ) THEN
         IF ( writeBinaryPrec .EQ. precFloat64 ) THEN
           pf(1:1) = 'D'
         ELSE
           pf(1:1) = 'R'
         ENDIF
         CALL MNC_CW_SET_UDIM('shelfice', -1, myThid)
         CALL MNC_CW_RL_W_S('D','shelfice',0,0,'T', myTime, myThid)
         CALL MNC_CW_SET_UDIM('shelfice', 0, myThid)
         CALL MNC_CW_I_W_S('I','shelfice',0,0,'iter', myIter, myThid)
         CALL MNC_CW_RL_W_S('D','shelfice',0,0,'model_time',
     &        myTime,myThid)
         CALL MNC_CW_RS_W(pf,'shelfice',0,0,'fwFlux',
     &        shelfIceFreshWaterFlux,myThid)
         CALL MNC_CW_RS_W(pf,'shelfice',0,0,'heatFlux',
     &        shelfIceHeatFlux,myThid)
        ENDIF
#endif
        IF (SHELFICE_dump_mdsio) THEN
         IF ( rwSuffixType.EQ.0 ) THEN
           WRITE(suff,'(I10.10)') myIter
         ELSE
           CALL RW_GET_SUFFIX( suff, myTime, myIter, myThid )
         ENDIF
         CALL WRITE_FLD_XY_RS( 'SHICE_fwFlux.',suff,
     &        shelficeFreshWaterFlux,myIter,myThid)
         CALL WRITE_FLD_XY_RS( 'SHICE_heatFlux.',suff,
     &        shelficeHeatFlux,myIter,myThid)
        ENDIF

       ENDIF
      ENDIF

      RETURN
      END

#include "GCHEM_OPTIONS.h"

CStartOfInterface
      SUBROUTINE CFC_PARAM( myThid )
C     *==========================================================*
C     | SUBROUTINE CFC_PARAM
C     | o Set parameters needed for CFC runs
C     *==========================================================*
C     *==========================================================*
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
c #include "PARAMS.h"
#include "CFC.h"

C     == Routine arguments ==
C     myThid -  Number of this instance of CFC_PARAM
      INTEGER myThid
CEndOfInterface

#ifdef ALLOW_CFC

C     == Local variables ==

      _BEGIN_MASTER( myThid )
C set up coefficients for CFC11
C define Schmidt no. coefficients for CFC11
      sca_11_1 = 3501.8 _d 0
      sca_11_2 = -210.31 _d 0
      sca_11_3 =    6.1851 _d 0
      sca_11_4 =   -0.075139 _d 0
C coefficients for determining solubility of CFC12
      A1_11=  -229.9261 _d 0
      A2_11=   319.6552 _d 0
      A3_11=   119.4471 _d 0
      A4_11=   -1.39165 _d 0
      B1_11=   -0.142382 _d 0
      B2_11=    0.091459 _d 0
      B3_11=   -0.0157274 _d 0

C set up coefficients for CFC12
C define Schmidt no. coefficients for CFC12
      sca_12_1 = 3845.4 _d 0
      sca_12_2 = -228.95 _d 0
      sca_12_3 =    6.1908 _d 0
      sca_12_4 =   -0.067430 _d 0
C coefficients for determining solubility of CFC12
      A1_12=  -218.0971 _d 0
      A2_12=   298.9702 _d 0
      A3_12=   113.8049 _d 0
      A4_12=   -1.39165 _d 0
      B1_12=   -0.143566 _d 0
      B2_12=    0.091015 _d 0
      B3_12=   -0.0153924 _d 0

      _END_MASTER( myThid )

C--   Everyone else must wait for the parameters to be loaded
      _BARRIER

#endif /* ALLOW_CFC */

      RETURN
      END

#include "MNC_OPTIONS.h"
      
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 0
C     !ROUTINE: MNC_CW_VATTR_MISSING

C     !INTERFACE:
      SUBROUTINE MNC_CW_VATTR_MISSING(
     I     vname,
     I     iflag,
     I     mv_r8,  mv_r4,  mv_int,
     I     myThid )

C     !DESCRIPTION:
C     Set missing values to be associated with a CW variable name.
      
C     !USES:
      implicit none
#include "MNC_COMMON.h"
#include "EEPARAMS.h"

C     !INPUT PARAMETERS:
      integer myThid, iflag
      character*(*) vname
      REAL*8  mv_r8(2)
      REAL*4  mv_r4(2)
      INTEGER mv_int(2)
CEOP

C     !LOCAL VARIABLES:
      integer nvf,nvl, indv, ii
      character*(MAX_LEN_MBUF) msgbuf

C     Functions
      integer IFNBLNK, ILNBLNK

      nvf = IFNBLNK(vname)
      nvl = ILNBLNK(vname)

C     Check that vname is defined
      CALL MNC_GET_IND(MNC_MAX_ID, vname, mnc_cw_vname, indv, myThid)
      IF (indv .LT. 1) THEN
        write(msgbuf,'(3a)') 'MNC_CW_VATTR_MISSING ERROR: ''',
     &       vname(nvf:nvl), ''' is not defined'
        CALL print_error(msgbuf, mythid)
        stop 'ABNORMAL END: S/R MNC_CW_VATTR_MISSING'
      ENDIF

      mnc_cw_vfmv(indv) = iflag
      DO ii = 1,2
        mnc_cw_vmvd(ii,indv) = mv_r8(ii)
        mnc_cw_vmvr(ii,indv) = mv_r4(ii)
        mnc_cw_vmvi(ii,indv) = mv_int(ii)
      ENDDO

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#include "COST_OPTIONS.h"
#ifdef ALLOW_AUTODIFF
# include "AUTODIFF_OPTIONS.h"
#endif

CBOP
C     !ROUTINE: COST_FINAL_STORE

C     !INTERFACE:
      SUBROUTINE COST_FINAL_STORE( lastDiva, myThid )

C     !DESCRIPTION:
C     Store cost function value
C     This is required in conjunction with DIVA
C     heimbach@mit.edu 5-Mar-2003

C     !USES:
      IMPLICIT NONE
C     == Global variables ===
#include "EEPARAMS.h"
#include "SIZE.h"
#include "cost.h"

C     !INPUT/OUTPUT PARAMETERS:
C     lastDiva :: output argument, initialised to False (if DIVA)
C     myThid   :: my Thread Id number
      LOGICAL lastDiva
      INTEGER myThid

#ifdef ALLOW_DIVIDED_ADJOINT
C     !LOCAL VARIABLES:
CEOP

C--   Each process has calculated the global part for itself.
      lastDiva = .FALSE.

      IF ( myProcId .EQ. 0 ) THEN
        _BEGIN_MASTER( myThid )
        OPEN(UNIT=76,FILE='costfinal')
        WRITE(76,*) fc
        CLOSE(76)
        _END_MASTER( myThid )
      ENDIF
      _BARRIER

#endif /* ALLOW_DIVIDED_ADJOINT */

      RETURN
      END

#include "MONITOR_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: MON_SURFCOR

C     !INTERFACE:
      SUBROUTINE MON_SURFCOR(
     I                        myThid )

C     !DESCRIPTION:
C     Compute and write area-mean surface expansion term (also called
C     ``surface correction'' with Linear FS).
C
C     Diagnose mean surface expansion term
C     \begin{equation}
C       \mbox{with r coordinate} = (\mbox{w surf})(\mbox{Tracer})
C     \end{equation}
C     \begin{equation}
C       \mbox{units} = (\mbox{W units})(\mbox{Tracer units})
C       \ ; \ \mbox{+ = out}
C     \end{equation}
C     \begin{equation}
C       \mbox{with r* coord}) = \frac{d\eta}{dt} \frac{dz}{H}
C       (\mbox{Tracer})
C     \end{equation}
C
C     Atmosphere: convert surf.cor(Theta) to surface heating,
C     \begin{equation}
C       \mbox{units} = \frac{W}{m^2}, \mbox{+ = out}
C     \end{equation}
C     compute mean conversion term Temp -> PE , units= W/m2,
C     + = decreasing heat content, increasing PE

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "DYNVARS.h"
#include "SURFACE.h"
#include "GRID.h"
#include "MONITOR.h"

C     !INPUT PARAMETERS:
C     myThid    :: my Thread Id. number
      INTEGER myThid
CEOP

C     !LOCAL VARIABLES:
      INTEGER i,j,k,ks,bi,bj
      _RL theArea, wT_Mean, wS_Mean
      _RL wT_Heat, theta2PE
      _RL tmpVal, ddPI
      _RL tileArea(nSx,nSy)
      _RL tile_wT (nSx,nSy)
      _RL tile_wS (nSx,nSy)
      _RL tileWHeat(nSx,nSy)
      _RL tileTh2pe(nSx,nSy)
#ifdef NONLIN_FRSURF
      _RL tmpVol, conv_th2Heat
      _RL vT_Mean, vS_Mean, vT_Heat
#endif

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

       theArea = 0.
       wT_Mean = 0.
       wS_Mean = 0.
       wT_Heat = 0.
       theta2PE = 0.
       DO bj=myByLo(myThid),myByHi(myThid)
        DO bi=myBxLo(myThid),myBxHi(myThid)
          tileArea(bi,bj) = 0.
          tile_wT(bi,bj) = 0.
          tile_wS(bi,bj) = 0.
          tileWHeat(bi,bj) = 0.
          tileTh2pe(bi,bj) = 0.
C-- Compute surface "expansion" term & do the integral
          DO j=1,sNy
           DO i=1,sNx
            ks = ksurfC(i,j,bi,bj)
            IF (ks.LE.Nr) THEN
             tileArea(bi,bj) = tileArea(bi,bj)
     &                       + rA(i,j,bi,bj)*maskInC(i,j,bi,bj)
             tmpVal = rA(i,j,bi,bj)*maskInC(i,j,bi,bj)
     &               *wVel(i,j,ks,bi,bj)*theta(i,j,ks,bi,bj)
             tile_wT(bi,bj) = tile_wT(bi,bj) + tmpVal
             tile_wS(bi,bj) = tile_wS(bi,bj)
     &                      + rA(i,j,bi,bj)*maskInC(i,j,bi,bj)
     &                       *wVel(i,j,ks,bi,bj)*salt(i,j,ks,bi,bj)
C-  Atmos in Pot.Temp => convert Omega*Theta to heat flux :
             IF ( fluidIsAir ) THEN
               tileWHeat(bi,bj) = tileWHeat(bi,bj)
     &                 + tmpVal*atm_cp*((rC(ks)/atm_po)**atm_kappa)
             ENDIF
            ENDIF
           ENDDO
          ENDDO
#ifdef ALLOW_AIM
          IF ( useAIM ) THEN
           tile_wS(bi,bj) = 0.
           DO j=1,sNy
            DO i=1,sNx
             ks = ksurfC(i,j,bi,bj)
             IF (ks.LE.Nr) THEN
              tmpVal = salt(i,j,ks,bi,bj)
     &               + salt(i,j,Nr,bi,bj)*drF(Nr)*recip_drF(ks)
     &                *hFacC(i,j,Nr,bi,bj)*_recip_hFacC(i,j,ks,bi,bj)
              tile_wS(bi,bj) = tile_wS(bi,bj)
     &                       + rA(i,j,bi,bj)*maskInC(i,j,bi,bj)
     &                        *wVel(i,j,ks,bi,bj)*tmpVal
             ENDIF
            ENDDO
           ENDDO
          ENDIF
#endif /* ALLOW_AIM */


C-- Atmos in Pot.Temp => conmpute energy conversion Temp -> PE
C    = Omega*Theta*DeltaPI
          IF ( fluidIsAir ) THEN
           DO k=2,Nr
            ddPI=atm_cp*( (rC(K-1)/atm_po)**atm_kappa
     &                   -(rC( K )/atm_po)**atm_kappa )
            DO j=1,sNy
             DO i=1,sNx
              tileTh2pe(bi,bj) = tileTh2pe(bi,bj)
     &         - ddPI*rA(i,j,bi,bj)*wVel(i,j,k,bi,bj)
     &           *(theta(i,j,k,bi,bj)+theta(i,j,k-1,bi,bj))*0.5 _d 0
     &           *maskC(i,j,k-1,bi,bj)*maskC(i,j,k,bi,bj)
     &           *maskInC(i,j,bi,bj)
             ENDDO
            ENDDO
           ENDDO
          ENDIF

#ifdef NONLIN_FRSURF
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
        IF (select_rStar.NE.0) THEN
C-- Compute Volume expansion term & do the integral
          vT_Mean = 0.
          vS_Mean = 0.
          vT_Heat = 0.
          conv_th2Heat = 0.
          DO k=1,Nr
           IF (fluidIsAir) conv_th2Heat =
     &                            atm_cp*((rC(k)/atm_po)**atm_kappa)
           DO j=1,sNy
            DO i=1,sNx
              tmpVol  = rA(i,j,bi,bj)*h0FacC(i,j,k,bi,bj)*drF(k)
     &                 *maskInC(i,j,bi,bj)
              tmpVal  = rStarDhCDt(i,j,bi,bj)*theta(i,j,k,bi,bj)
              vT_Mean = vT_Mean + tmpVol*tmpVal
              vS_Mean = vS_Mean
     &          +tmpVol*rStarDhCDt(i,j,bi,bj)*salt(i,j,k,bi,bj)
C-  Atmos in Pot.Temp => convert Omega*Theta to heat flux :
              IF (fluidIsAir) vT_Heat = vT_Heat
     &                                + tmpVol*tmpVal*conv_th2Heat
            ENDDO
           ENDDO
          ENDDO
          tile_wT(bi,bj) = tile_wT(bi,bj) + vT_Mean
          tile_wS(bi,bj) = tile_wS(bi,bj) + vS_Mean
          tileWHeat(bi,bj) = tileWHeat(bi,bj) + vT_Heat
        ENDIF
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
#endif /* NONLIN_FRSURF */

C--    end bi,bj loop
        ENDDO
       ENDDO

       CALL GLOBAL_SUM_TILE_RL( tileArea, theArea, myThid )
       CALL GLOBAL_SUM_TILE_RL( tile_wT , wT_Mean, myThid )
       CALL GLOBAL_SUM_TILE_RL( tile_wS , wS_Mean, myThid )
       IF ( fluidIsAir ) THEN
        CALL GLOBAL_SUM_TILE_RL( tileWHeat , wT_Heat , myThid )
        CALL GLOBAL_SUM_TILE_RL( tileTh2pe , theta2PE, myThid )
       ENDIF
       IF (theArea.GT.0.) THEN
         wT_Mean = wT_Mean / theArea
         wS_Mean = wS_Mean / theArea
         wT_Heat = wT_Heat / theArea
         theta2PE = theta2PE / theArea
         wT_Heat  = wT_Heat  * rUnit2mass
         theta2PE = theta2PE * rUnit2mass
       ENDIF

C-    Print the Average value (monitor type output)

       CALL MON_SET_PREF('surfExpan',myThid)
       CALL MON_OUT_RL( '_theta', wT_Mean, mon_foot_mean ,myThid)
       CALL MON_OUT_RL( '_salt' , wS_Mean, mon_foot_mean ,myThid)
      IF ( fluidIsAir ) THEN
       CALL MON_OUT_RL( '_Heat' , wT_Heat, mon_foot_mean ,myThid)
       CALL MON_SET_PREF('En_Budget',myThid)
       CALL MON_OUT_RL('_T2PE',theta2PE, mon_foot_mean ,myThid)
      ENDIF

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      RETURN
      END

#include "DIC_OPTIONS.h"
#ifdef ALLOW_COST
# include "COST_OPTIONS.h"
#endif

CBOP
C     !ROUTINE: DIC_COST
C     !INTERFACE:
      SUBROUTINE DIC_COST (
     I                      myTime, myIter, myThid )

C     !DESCRIPTION:
C     *==========================================================*
C     | SUBROUTINE DIC_COST
C     *==========================================================*

C     !USES:
      IMPLICIT NONE

C     == GLobal variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "DIC_VARS.h"
#ifdef DIC_BIOTIC
#include "DIC_COST.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
      _RL myTime
      INTEGER myIter
      INTEGER myThid

#ifdef ALLOW_DIC_COST
C     !LOCAL VARIABLES:
      INTEGER i, j, bi, bj
      _RL loc_cost(nSx,nSy), glb_cost
CEOP

C--   Calculate costfunction
       DO bj=myByLo(myThid),myByHi(myThid)
        DO bi=myBxLo(myThid),myBxHi(myThid)
         loc_cost(bi,bj) = 0. _d 0
         DO i=1,sNx
          DO j=1,sNy
            loc_cost(bi,bj) = loc_cost(bi,bj)
     &                      + FluxCO2(i,j,bi,bj)*rA(i,j,bi,bj)
     &                       *maskC(i,j,1,bi,bj)*dTtracerLev(1)
          ENDDO
         ENDDO
        ENDDO
       ENDDO
       CALL GLOBAL_SUM_TILE_RL( loc_cost, glb_cost, myThid )

      _BEGIN_MASTER( myThid )
       totcost = totcost + glb_cost

       WRITE(standardMessageUnit,'(A,I9,1PE23.15)')
     &  ' DIC_COST: iter,totcost =', myIter, totcost
      _END_MASTER( myThid )

#endif /* ALLOW_DIC_COST */

      RETURN
      END

#include "PACKAGES_CONFIG.h"
#include "CPP_OPTIONS.h"

CBOP
C     !ROUTINE: SOLVE_FOR_PRESSURE
C     !INTERFACE:
      SUBROUTINE SOLVE_FOR_PRESSURE( myTime, myIter, myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE SOLVE_FOR_PRESSURE
C     | o Controls inversion of two and/or three-dimensional
C     |   elliptic problems for the pressure field.
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     == Global variables
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "SURFACE.h"
#include "FFIELDS.h"
#include "DYNVARS.h"
#ifdef ALLOW_NONHYDROSTATIC
# include "NH_VARS.h"
#endif
#ifdef ALLOW_CD_CODE
# include "CD_CODE_VARS.h"
#endif
#ifdef ALLOW_AUTODIFF
# include "AUTODIFF_PARAMS.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     myTime :: Current time in simulation
C     myIter :: Current iteration number in simulation
C     myThid :: Thread number for this instance of SOLVE_FOR_PRESSURE
      _RL myTime
      INTEGER myIter
      INTEGER myThid

C     !FUNCTIONS:
      LOGICAL  DIFFERENT_MULTIPLE
      EXTERNAL DIFFERENT_MULTIPLE
#ifdef ALLOW_DIAGNOSTICS
      LOGICAL  DIAGNOSTICS_IS_ON
      EXTERNAL DIAGNOSTICS_IS_ON
#endif /* ALLOW_DIAGNOSTICS */

C     !LOCAL VARIABLES:
      INTEGER i,j,k,bi,bj
      INTEGER ks
      INTEGER numIters, nIterMin
      _RL firstResidual, minResidualSq, lastResidual
      _RL tmpFac
      _RL sumEmP, tileEmP(nSx,nSy)
      LOGICAL putPmEinXvector
      INTEGER ioUnit
      CHARACTER*(MAX_LEN_MBUF) msgBuf
C--   formerly part of header file SOLVE_FOR_PRESSURE.h (but not common block)
C     cg2d_x  :: Solution vector of the 2-D solver equation A.x=B
C     cg2d_b  :: Right Hand side vector of the 2-D solver equation A.x=B
      _RL cg2d_x(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL cg2d_b(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
#ifdef ALLOW_NONHYDROSTATIC
C--   formerly part of header file SOLVE_FOR_PRESSURE3D.h, but do not need
C     to be in common block --> changed to local var.
C     cg3d_x  :: Solution vector of the 3-D solver equation A.x=B
C     cg3d_b  :: Right Hand side vector of the 3-D solver equation A.x=B
c     _RL  cg3d_x(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      _RL  cg3d_b(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      LOGICAL oldFreeSurfTerm
#else /* ALLOW_NONHYDROSTATIC */
      _RL     cg3d_b(1)
#endif /* ALLOW_NONHYDROSTATIC */
#ifdef ALLOW_DIAGNOSTICS
      CHARACTER*8 diagName
      _RL tmpVar (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
#endif /* ALLOW_DIAGNOSTICS */
CEOP

#ifdef ALLOW_NONHYDROSTATIC
        oldFreeSurfTerm = use3Dsolver .AND. .NOT.exactConserv
#else
        cg3d_b(1) = 0.
#endif

C deepAtmosphere & useRealFreshWaterFlux: only valid if deepFac2F(ksurf)=1
C anelastic (always Z-coordinate):
C     1) assume that rhoFacF(1)=1 (and ksurf == 1);
C        (this reduces the number of lines of code to modify)
C     2) (a) 2-D continuity eq. compute div. of mass transport (<- add rhoFac)
C        (b) gradient of surf.Press in momentum eq. (<- add 1/rhoFac)
C       => 2 factors cancel in elliptic eq. for Phi_s ,
C       but 1rst factor(a) remains in RHS cg2d_b.

C--   Initialise the Vector solution with etaN + deltaT*Global_mean_PmE
C     instead of simply etaN ; This can speed-up the solver convergence in
C     the case where |Global_mean_PmE| is large.
      putPmEinXvector = .FALSE.
c     putPmEinXvector = useRealFreshWaterFlux.AND.fluidIsWater

      IF ( myIter.EQ.1+nIter0 .AND. debugLevel .GE. debLevA ) THEN
        _BEGIN_MASTER( myThid )
        ioUnit = standardMessageUnit
        WRITE(msgBuf,'(2A,L5)') 'SOLVE_FOR_PRESSURE:',
     &       ' putPmEinXvector =', putPmEinXvector
        CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
#ifdef ALLOW_NONHYDROSTATIC
        WRITE(msgBuf,'(2A,L5)') 'SOLVE_FOR_PRESSURE:',
     &       ' oldFreeSurfTerm =', oldFreeSurfTerm
        CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
#endif
        _END_MASTER( myThid )
      ENDIF

C--   Save previous solution & Initialise Vector solution and source term :
      sumEmP = 0.
      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
#ifdef ALLOW_CD_CODE
          etaNm1(i,j,bi,bj) = etaN(i,j,bi,bj)
#endif
          cg2d_x(i,j,bi,bj) = Bo_surf(i,j,bi,bj)*etaN(i,j,bi,bj)
          cg2d_b(i,j,bi,bj) = 0. _d 0
         ENDDO
        ENDDO
#ifdef ALLOW_NONHYDROSTATIC
        DO k=1,Nr
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           cg3d_b(i,j,k,bi,bj) = 0. _d 0
          ENDDO
         ENDDO
        ENDDO
#endif /* ALLOW_NONHYDROSTATIC */
        IF (useRealFreshWaterFlux.AND.fluidIsWater) THEN
         tmpFac = freeSurfFac*mass2rUnit*implicDiv2DFlow
         DO j=1,sNy
          DO i=1,sNx
           cg2d_b(i,j,bi,bj) =
     &       tmpFac*_rA(i,j,bi,bj)*EmPmR(i,j,bi,bj)/deltaTMom
          ENDDO
         ENDDO
        ENDIF
        IF ( putPmEinXvector ) THEN
         tileEmP(bi,bj) = 0.
         DO j=1,sNy
          DO i=1,sNx
            tileEmP(bi,bj) = tileEmP(bi,bj)
     &                     + rA(i,j,bi,bj)*EmPmR(i,j,bi,bj)
     &                                    *maskInC(i,j,bi,bj)
          ENDDO
         ENDDO
        ENDIF
       ENDDO
      ENDDO
      IF ( putPmEinXvector ) THEN
        CALL GLOBAL_SUM_TILE_RL( tileEmP, sumEmP, myThid )
      ENDIF

      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        IF ( putPmEinXvector ) THEN
          tmpFac = 0.
          IF (globalArea.GT.0.) tmpFac =
     &      freeSurfFac*deltaTFreeSurf*mass2rUnit*sumEmP/globalArea
          DO j=1,sNy
           DO i=1,sNx
            cg2d_x(i,j,bi,bj) = cg2d_x(i,j,bi,bj)
     &                        - tmpFac*Bo_surf(i,j,bi,bj)
           ENDDO
          ENDDO
        ENDIF
C- RHS: similar to the divergence of the vertically integrated mass transport:
C       del_i { Sum_k [ rhoFac.(dr.hFac).(dy.deepFac).(u*) ] }  / deltaT
        DO k=Nr,1,-1
         CALL CALC_DIV_GHAT(
     I                       bi,bj,k,
     U                       cg2d_b, cg3d_b,
     I                       myThid )
        ENDDO
       ENDDO
      ENDDO

      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
#ifdef ALLOW_NONHYDROSTATIC
        IF ( oldFreeSurfTerm ) THEN
C--   Add source term arising from w=d/dt (p_s + p_nh)
         DO j=1,sNy
          DO i=1,sNx
           ks = kSurfC(i,j,bi,bj)
           IF ( ks.LE.Nr ) THEN
            cg2d_b(i,j,bi,bj) = cg2d_b(i,j,bi,bj)
     &       -freeSurfFac*_rA(i,j,bi,bj)*deepFac2F(ks)
     &         /deltaTMom/deltaTFreeSurf
     &         *( etaN(i,j,bi,bj)
     &           +phi_nh(i,j,ks,bi,bj)*recip_Bo(i,j,bi,bj) )
            cg3d_b(i,j,ks,bi,bj) = cg3d_b(i,j,ks,bi,bj)
     &       -freeSurfFac*_rA(i,j,bi,bj)*deepFac2F(ks)
     &         /deltaTMom/deltaTFreeSurf
     &         *( etaN(i,j,bi,bj)
     &           +phi_nh(i,j,ks,bi,bj)*recip_Bo(i,j,bi,bj) )
           ENDIF
          ENDDO
         ENDDO
        ELSEIF ( exactConserv ) THEN
#else
C--   Add source term arising from w=d/dt (p_s)
        IF ( exactConserv ) THEN
#endif /* ALLOW_NONHYDROSTATIC */
         DO j=1,sNy
          DO i=1,sNx
           ks = kSurfC(i,j,bi,bj)
           cg2d_b(i,j,bi,bj) = cg2d_b(i,j,bi,bj)
     &       -freeSurfFac*_rA(i,j,bi,bj)*deepFac2F(ks)
     &         /deltaTMom/deltaTFreeSurf
     &         * etaH(i,j,bi,bj)
          ENDDO
         ENDDO
        ELSE
         DO j=1,sNy
          DO i=1,sNx
           ks = kSurfC(i,j,bi,bj)
           cg2d_b(i,j,bi,bj) = cg2d_b(i,j,bi,bj)
     &       -freeSurfFac*_rA(i,j,bi,bj)*deepFac2F(ks)
     &         /deltaTMom/deltaTFreeSurf
     &         * etaN(i,j,bi,bj)
          ENDDO
         ENDDO
        ENDIF

#ifdef ALLOW_OBCS
C- Note: solver matrix is trivial outside OB region (main diagonal only)
C     => no real need to reset RHS (=cg2d_b) & cg2d_x, except that:
C    a) normalisation is fct of Max(RHS), which can be large ouside OB region
C      (would be different if we were solving for increment of eta/g
C       instead of directly for eta/g).
C       => need to reset RHS to ensure that interior solution does not depend
C       on ouside OB region.
C    b) provide directly the trivial solution cg2d_x == 0 for outside OB region
C      (=> no residual => no effect on solver convergence and interior solution)
        IF (useOBCS) THEN
         DO j=1,sNy
          DO i=1,sNx
           cg2d_b(i,j,bi,bj) = cg2d_b(i,j,bi,bj)*maskInC(i,j,bi,bj)
           cg2d_x(i,j,bi,bj) = cg2d_x(i,j,bi,bj)*maskInC(i,j,bi,bj)
         ENDDO
         ENDDO
        ENDIF
#endif /* ALLOW_OBCS */
C-    end bi,bj loops
       ENDDO
      ENDDO

#ifdef ALLOW_DEBUG
      IF ( debugLevel .GE. debLevD ) THEN
       CALL DEBUG_STATS_RL(1,cg2d_b,'cg2d_b (SOLVE_FOR_PRESSURE)',
     &                        myThid)
      ENDIF
#endif
      IF ( DIFFERENT_MULTIPLE(diagFreq, myTime, deltaTClock) ) THEN
       CALL WRITE_FLD_XY_RL( 'cg2d_b', 'I10', cg2d_b, myIter, myThid )
      ENDIF

C--   Find the surface pressure using a two-dimensional conjugate
C     gradient solver. See CG2D.h for the interface to this routine.
C     In rare cases of a poor solver convergence, better to select the
C     solver minimum-residual solution (instead of the last-iter solution)
C     by setting cg2dUseMinResSol=1 (<-> nIterMin=0 in input)
      numIters      = cg2dMaxIters
      nIterMin      = cg2dUseMinResSol - 1
c     CALL TIMER_START('CG2D   [SOLVE_FOR_PRESSURE]',myThid)
#ifdef DISCONNECTED_TILES
C--   Call the disconnected-tile (no EXCH) version of cg2d
      CALL CG2D_EX0(
     U           cg2d_b, cg2d_x,
     O           firstResidual, minResidualSq, lastResidual,
     U           numIters, nIterMin,
     I           myThid )
#else /* not DISCONNECTED_TILES = default */
      IF ( useSRCGSolver ) THEN
C--   Call the single reduce CG solver
#ifdef ALLOW_SRCG
       CALL CG2D_SR(
     U           cg2d_b, cg2d_x,
     O           firstResidual, minResidualSq, lastResidual,
     U           numIters, nIterMin,
     I           myThid )
#endif /* ALLOW_SRCG */
#ifdef ALLOW_CG2D_NSA
      ELSEIF ( useNSACGSolver ) THEN
C--   Call the not-self-adjoint version of cg2d
       CALL CG2D_NSA(
     U           cg2d_b, cg2d_x,
     O           firstResidual, minResidualSq, lastResidual,
     U           numIters, nIterMin,
     I           myThid )
#endif
      ELSE
C--   Call the default CG solver
       CALL CG2D(
     U           cg2d_b, cg2d_x,
     O           firstResidual, minResidualSq, lastResidual,
     U           numIters, nIterMin,
     I           myThid )
      ENDIF
#endif /* DISCONNECTED_TILES */
      _EXCH_XY_RL( cg2d_x, myThid )
#ifdef ALLOW_AUTODIFF
#ifndef ALLOW_TAPENADE
      IF (  .NOT. useNSACGSolver .AND. cg2dFullAdjoint )
     &     CALL CG2D_STORE( cg2d_x, .TRUE., myThid )
#endif /* ALLOW_TAPENADE */
#endif
c     CALL TIMER_STOP ('CG2D   [SOLVE_FOR_PRESSURE]',myThid)

#ifdef ALLOW_DEBUG
      IF ( debugLevel .GE. debLevD ) THEN
       CALL DEBUG_STATS_RL(1,cg2d_x,'cg2d_x (SOLVE_FOR_PRESSURE)',
     &                        myThid)
      ENDIF
#endif

C- dump CG2D output at monitorFreq (to reduce size of STD-OUTPUT files) :
      IF ( DIFFERENT_MULTIPLE(monitorFreq,myTime,deltaTClock)
     &   ) THEN
       IF ( debugLevel .GE. debLevA ) THEN
        _BEGIN_MASTER( myThid )
        WRITE(msgBuf,'(A20,1PE23.14)') 'cg2d_init_res =',firstResidual
        CALL PRINT_MESSAGE(msgBuf,standardMessageUnit,SQUEEZE_RIGHT,1)
        WRITE(msgBuf,'(A27,2I8)')
     &       'cg2d_iters(min,last) =', nIterMin, numIters
        CALL PRINT_MESSAGE(msgBuf,standardMessageUnit,SQUEEZE_RIGHT,1)
        IF ( minResidualSq.GE.0. ) THEN
         minResidualSq = SQRT(minResidualSq)
         WRITE(msgBuf,'(A20,1PE23.14)') 'cg2d_min_res  =',minResidualSq
         CALL PRINT_MESSAGE(msgBuf,standardMessageUnit,SQUEEZE_RIGHT,1)
        ENDIF
        WRITE(msgBuf,'(A20,1PE23.14)') 'cg2d_last_res =',lastResidual
        CALL PRINT_MESSAGE(msgBuf,standardMessageUnit,SQUEEZE_RIGHT,1)
        _END_MASTER( myThid )
       ENDIF
      ENDIF

#ifdef ALLOW_DIAGNOSTICS
C--   Fill diagnostics
      IF ( useDiagnostics .AND. implicSurfPress.NE.oneRL ) THEN
        diagName = 'PHI_SURF'
        IF ( DIAGNOSTICS_IS_ON(diagName,myThid) ) THEN
         DO bj=myByLo(myThid),myByHi(myThid)
          DO bi=myBxLo(myThid),myBxHi(myThid)
           DO j=1-OLy,sNy+OLy
            DO i=1-OLx,sNx+OLx
             tmpVar(i,j) = implicSurfPress * cg2d_x(i,j,bi,bj)
     &          + (oneRL - implicSurfPress)* Bo_surf(i,j,bi,bj)
     &                                     * etaN(i,j,bi,bj)
            ENDDO
           ENDDO
           CALL DIAGNOSTICS_FILL( tmpVar,diagName,1,1,2,bi,bj,myThid )
          ENDDO
         ENDDO
        ENDIF
      ELSEIF ( useDiagnostics ) THEN
        CALL DIAGNOSTICS_FILL( cg2d_x,'PHI_SURF', 0,1, 0,1,1, myThid )
      ENDIF
#endif /* ALLOW_DIAGNOSTICS */

C--   Transfert the 2D-solution to "etaN" :
      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          etaN(i,j,bi,bj) = recip_Bo(i,j,bi,bj)*cg2d_x(i,j,bi,bj)
         ENDDO
        ENDDO
       ENDDO
      ENDDO

#ifdef ALLOW_NONHYDROSTATIC
      IF ( use3Dsolver ) THEN
       IF ( DIFFERENT_MULTIPLE(diagFreq, myTime, deltaTClock) ) THEN
        CALL WRITE_FLD_XY_RL( 'cg2d_x','I10', cg2d_x, myIter, myThid )
       ENDIF

C--   Solve for a three-dimensional pressure term (NH or IGW or both ).
C     see CG3D.h for the interface to this routine.

C--   Finish updating cg3d_b: 1) Add EmPmR contribution to top level cg3d_b:
C                             2) Update or Add free-surface contribution
C                             3) increment in horiz velocity due to new cg2d_x
C                             4) add vertical velocity contribution.
       CALL PRE_CG3D(
     I                oldFreeSurfTerm,
     I                cg2d_x,
     U                cg3d_b,
     I                myTime, myIter, myThid )

#ifdef ALLOW_DEBUG
       IF ( debugLevel .GE. debLevD ) THEN
        CALL DEBUG_STATS_RL(Nr,cg3d_b,'cg3d_b (SOLVE_FOR_PRESSURE)',
     &                         myThid)
       ENDIF
#endif
       IF ( DIFFERENT_MULTIPLE( diagFreq, myTime, deltaTClock) ) THEN
        CALL WRITE_FLD_XYZ_RL('cg3d_b','I10', cg3d_b, myIter,myThid )
       ENDIF

       firstResidual=0.
       lastResidual=0.
       numIters=cg3dMaxIters
       CALL TIMER_START('CG3D   [SOLVE_FOR_PRESSURE]',myThid)
#ifdef DISCONNECTED_TILES
       CALL CG3D_EX0(
     U            cg3d_b, phi_nh,
     O            firstResidual, lastResidual,
     U            numIters,
     I            myIter, myThid )
#else /* not DISCONNECTED_TILES = default */
       CALL CG3D(
     U            cg3d_b, phi_nh,
     O            firstResidual, lastResidual,
     U            numIters,
     I            myIter, myThid )
#endif /* DISCONNECTED_TILES */
       _EXCH_XYZ_RL( phi_nh, myThid )
       CALL TIMER_STOP ('CG3D   [SOLVE_FOR_PRESSURE]',myThid)

       IF ( DIFFERENT_MULTIPLE(monitorFreq,myTime,deltaTClock)
     &    ) THEN
        IF ( debugLevel .GE. debLevA ) THEN
         _BEGIN_MASTER( myThid )
         WRITE(msgBuf,'(A20,1PE23.14)') 'cg3d_init_res =',firstResidual
         CALL PRINT_MESSAGE(msgBuf,standardMessageUnit,SQUEEZE_RIGHT,1)
         WRITE(msgBuf,'(A27,I16)') 'cg3d_iters (last) =   ',numIters
         CALL PRINT_MESSAGE(msgBuf,standardMessageUnit,SQUEEZE_RIGHT,1)
         WRITE(msgBuf,'(A20,1PE23.14)') 'cg3d_last_res =',lastResidual
         CALL PRINT_MESSAGE(msgBuf,standardMessageUnit,SQUEEZE_RIGHT,1)
         _END_MASTER( myThid )
        ENDIF
       ENDIF

C--   Separate the Hydrostatic Surface Pressure adjusment (=> put it in dPhiNH)
C     from the Non-hydrostatic pressure (since cg3d_x contains both contribution)
       IF ( nonHydrostatic .AND. exactConserv ) THEN
        IF ( DIFFERENT_MULTIPLE( diagFreq, myTime, deltaTClock) ) THEN
         CALL WRITE_FLD_XYZ_RL('cg3d_x','I10', phi_nh, myIter,myThid )
        ENDIF
        CALL POST_CG3D(
     I                  myTime, myIter, myThid )
       ENDIF

      ENDIF
#endif /* ALLOW_NONHYDROSTATIC */

#ifdef ALLOW_SHOWFLOPS
      CALL SHOWFLOPS_INSOLVE( myThid)
#endif

      RETURN
      END

#include "OCN_CPL_OPTIONS.h"

C     !ROUTINE: OCN_STORE_MY_DATA
C     !INTERFACE:
      SUBROUTINE OCN_STORE_MY_DATA(
     I                     myTime, myIter, myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE OCN_STORE_MY_DATA                             |
C     | o Routine for controlling storage of coupling data to    |
C     |   to the coupling layer.                                 |
C     *==========================================================*
C     | This version talks to the MIT Coupler. It uses the MIT   |
C     | Coupler "checkpoint1" library calls.                     |
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "CPL_PARAMS.h"
#include "GRID.h"
#include "SURFACE.h"
#include "DYNVARS.h"
#include "OCNCPL.h"
#ifdef ALLOW_THSICE
# include "THSICE_VARS.h"
#endif
c#ifdef ALLOW_DIC
c# include "DIC_VARS.h"
c#endif

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine Arguments ==
C     myTime     :: Current time in simulation
C     myIter     :: Current timestep number
C     myThid     :: my Thread Id. number
      _RL     myTime
      INTEGER myIter
      INTEGER myThid
CEOP

C     !FUNCTIONS:
c     INTEGER ILNBLNK

C     !LOCAL VARIABLES:
C     == Local variables ==
C     bi,bj      :: Current tile indices
C     i, j       :: Loop indices
      INTEGER bi,bj
      INTEGER i, j

      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
C--   bi,bj loop over my tiles

         DO j=1,sNy
          DO i=1,sNx
            SSTocn2cpl(i,j,bi,bj) = theta(i,j,1,bi,bj)
            SSSocn2cpl(i,j,bi,bj) = salt (i,j,1,bi,bj)
          ENDDO
         ENDDO
#ifdef NONLIN_FRSURF
        IF ( nonlinFreeSurf.GT.0 .AND. staggerTimeStep ) THEN
         IF ( select_rStar.GT.0 ) THEN
          DO j=1,sNy
           DO i=1,sNx
            ocMxlD2cpl(i,j,bi,bj) =
     &           h0FacC(i,j,1,bi,bj)*rStarFacC(i,j,bi,bj)*drF(1)
           ENDDO
          ENDDO
         ELSE
          DO j=1,sNy
           DO i=1,sNx
            ocMxlD2cpl(i,j,bi,bj) = hFac_surfC(i,j,bi,bj)*drF(1)
           ENDDO
          ENDDO
         ENDIF
        ELSE
#else /* NONLIN_FRSURF */
        IF (.TRUE.) THEN
#endif /* NONLIN_FRSURF */
         DO j=1,sNy
          DO i=1,sNx
            ocMxlD2cpl(i,j,bi,bj) = hFacC(i,j,1,bi,bj)*drF(1)
          ENDDO
         ENDDO
        ENDIF

         DO j=1,sNy
          DO i=1,sNx
            vSqocn2cpl(i,j,bi,bj) =
     &              ( uVel(i , j,1,bi,bj)*uVel(i , j,1,bi,bj)
     &              + uVel(i+1,j,1,bi,bj)*uVel(i+1,j,1,bi,bj)
     &              + vVel(i,j+1,1,bi,bj)*vVel(i,j+1,1,bi,bj)
     &              + vVel(i,j , 1,bi,bj)*vVel(i,j , 1,bi,bj)
     &              )*0.5 _d 0
          ENDDO
         ENDDO

#ifdef ALLOW_THSICE
        IF ( useThSIce .AND. ocn_cplExch2W_sIce  ) THEN
         DO j=1,sNy
          DO i=1,sNx
            sIceFrac_cpl (i,j,bi,bj) = iceMask(i,j,bi,bj)
            sIceThick_cpl(i,j,bi,bj) = iceHeight(i,j,bi,bj)
            sIceSnowH_cpl(i,j,bi,bj) = snowHeight(i,j,bi,bj)
            sIceQ1_cpl   (i,j,bi,bj) = Qice1(i,j,bi,bj)
            sIceQ2_cpl   (i,j,bi,bj) = Qice2(i,j,bi,bj)
          ENDDO
         ENDDO
        ENDIF
#endif /* ALLOW_THSICE */

c#ifdef ALLOW_DIC
c       IF ( ocn_cplExch_DIC ) THEN
c        DO j=1,sNy
c         DO i=1,sNx
c           fluxCO2cpl(i,j,bi,bj) = fluxCO2(i,j,bi,bj)
c         ENDDO
c        ENDDO
c       ENDIF
c#endif

C--   end bi,bj loops
       ENDDO
      ENDDO

      RETURN
      END

#include "EBM_OPTIONS.h"
#ifdef ALLOW_AUTODIFF
# include "AUTODIFF_OPTIONS.h"
#endif

CBOP 0
C !ROUTINE: EBM_ZONALMEAN

C !INTERFACE:
      SUBROUTINE EBM_ZONALMEAN( myTime, myIter, myThid )

C     !DESCRIPTION:
C     *==========================================================*
C     | S/R CALCULATE ZONAL MEAN TEMPERATURE
C     *==========================================================*

C     !USES:
      IMPLICIT NONE
C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "DYNVARS.h"
#include "FFIELDS.h"
#ifdef ALLOW_EBM
# include "EBM.h"
#endif
#ifdef ALLOW_AUTODIFF_TAMC
# include "tamc.h"
#endif

C     !INPUT PARAMETERS:
C     === Routine arguments ===
C     myThid   :: my Thread Id number
      _RL myTime
      INTEGER myIter
      INTEGER myThid
CEOP

#ifdef ALLOW_EBM
C     !LOCAL VARIABLES:
C     i, j, k :: Loop counters
      INTEGER i, j, k, bi, bj
      INTEGER jg
      _RL tileSumMask(nSx,nSy)
      _RL tileSumSST (nSx,nSy)
      _RL locSumMask(Ny)
      _RL locSumSST (Ny)

C--   Top layer only
      k = 1

C--   Calculate the zonal mean
      DO jg = 1,Ny
        DO bj=myByLo(myThid),myByHi(myThid)
         DO bi=myBxLo(myThid),myBxHi(myThid)
          tileSumMask(bi,bj) = 0.
          tileSumSST (bi,bj) = 0.
          j = jg + 1 - myYGlobalLo - (bj-1)*sNy
          IF ( j.GE.1 .AND. j.LE.sNy ) THEN
           DO i = 1,sNx
            tileSumMask(bi,bj) = tileSumMask(bi,bj)
     &                         + maskC(i,j,k,bi,bj)
            tileSumSST (bi,bj) = tileSumSST (bi,bj)
     &                         + maskC(i,j,k,bi,bj)*theta(i,j,k,bi,bj)
           ENDDO
          ENDIF
         ENDDO
        ENDDO
        CALL GLOBAL_SUM_TILE_RL( tileSumMask, locSumMask(jg), myThid )
        CALL GLOBAL_SUM_TILE_RL( tileSumSST,  locSumSST(jg),  myThid )
      ENDDO

#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE CountX = comlev1, key = ikey_dynamics
#endif
      _BEGIN_MASTER(myThid)
      DO bj=1,nSy
       DO j=1-OLy,sNy+OLy
        jg = myYGlobalLo + j-1 + (bj-1)*sNy
C       cyclic domain in Y:
c       jg = 1 + MOD( jg-1+Ny, Ny)
C       closed domain in Y:
        jg = MAX(MIN(jg,Ny),1)
        CountX(j,bj) = locSumMask(jg)
        ZonalMeanSST(j,bj) = locSumSST(jg)
        IF ( CountX(j,bj).GT.0. _d 0 ) THEN
          ZonalMeanSST(j,bj) = ZonalMeanSST(j,bj)/CountX(j,bj)
        ENDIF
       ENDDO
      ENDDO
      _END_MASTER(myThid)
      _BARRIER

      IF ( tauThetaZonRelax .NE. 0. _d 0 ) THEN
C-    replace SST with ZonalMeanSST for relaxation towards Zonal-Mean value
       DO bj=myByLo(myThid),myByHi(myThid)
        DO bi=myBxLo(myThid),myBxHi(myThid)
         DO j = 1-OLy, sNy+OLy
          DO i = 1-OLx, sNx+OLx
            SST(i,j,bi,bj) = ZonalMeanSST(j,bj)
          ENDDO
         ENDDO
        ENDDO
       ENDDO
c      _EXCH_XY_RS( SST, myThid )
      ENDIF

#endif /* ALLOW_EBM */

      RETURN
      END

#include "THSICE_OPTIONS.h"

CBOP
C !ROUTINE: THSICE_DIFFUSION

C !INTERFACE: ==========================================================
      SUBROUTINE THSICE_DIFFUSION(
     I                  maskOc,
     U                  uIce, vIce,
     I                  bi, bj, myTime, myIter, myThid )

C !DESCRIPTION: \bv
C     *===========================================================*
C     | SUBROUTINE THSICE_DIFFUSION
C     | o Account for total (ice+snow) thickness diffusion by
C     |   modifying ice-velocity:
C     |   If no velocity in the first place, and if using 1rst Order
C     |   upwind adv.scheme, this is equivalent to a diffusion of
C     |   ice+snow thichness.
C     *===========================================================*
C \ev

C !USES: ===============================================================
      IMPLICIT NONE

C     === Global variables ===

#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "THSICE_SIZE.h"
#include "THSICE_PARAMS.h"
#include "THSICE_VARS.h"

C !INPUT PARAMETERS: ===================================================
C     === Routine arguments ===
C     maskOc    :: ocean surface mask (0=land ; 1=ocean)
C     uIce/vIce :: current ice velocity on C-grid [m/s]
C     bi,bj     :: Tile indices
C     myTime    :: Current time in simulation (s)
C     myIter    :: Current iteration number
C     myThid    :: My Thread Id number
      _RS     maskOc(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL     uIce  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL     vIce  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER bi,bj
      _RL     myTime
      INTEGER myIter
      INTEGER myThid

#ifdef ALLOW_THSICE
C !LOCAL VARIABLES: ====================================================
C     === Local variables ===
C     i,j,      :: Loop counters
C     iceFld    :: sea-ice + snow mass density
C     msgBuf    :: Informational/error message buffer
      INTEGER i, j
c     CHARACTER*(MAX_LEN_MBUF) msgBuf
      _RL     iceFld(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL     tmpFld, hIceEpsil
      LOGICAL dBugFlag
c#include "THSICE_DEBUG.h"
CEOP

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      dBugFlag = debugLevel.GE.debLevC
      hIceEpsil = 1. _d -10

      IF ( thSIce_diffK .GT. 0. ) THEN
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          iceFld(i,j)  = ( rhos*snowHeight(i,j,bi,bj)
     &                    +rhoi*iceHeight(i,j,bi,bj) )
c                        *iceMask(i,j,bi,bj)
         ENDDO
        ENDDO

        DO j=1-OLy,sNy+OLy
         DO i=1-OLx+1,sNx+OLx
          tmpFld = MAX( iceFld(i-1,j),iceFld(i,j) )
     &                * maskOc(i-1,j)*maskOc(i,j)
          IF ( tmpFld.GT.hIceEpsil )
     &    uIce(i,j) = uIce(i,j)
     &              + thSIce_diffK*( iceFld(i-1,j)-iceFld(i,j) )
     &                            *recip_dxC(i,j,bi,bj)/tmpFld
         ENDDO
        ENDDO

        DO j=1-OLy+1,sNy+OLy
         DO i=1-OLx,sNx+OLx
          tmpFld = MAX( iceFld(i,j-1),iceFld(i,j) )
     &                 *maskOc(i,j-1)*maskOc(i,j)
          IF ( tmpFld.GT.hIceEpsil )
     &    vIce(i,j) = vIce(i,j)
     &              + thSIce_diffK*( iceFld(i,j-1)-iceFld(i,j) )
     &                            *recip_dyC(i,j,bi,bj)/tmpFld
         ENDDO
        ENDDO

      ENDIF

#endif /* ALLOW_THSICE */

      RETURN
      END

#include "STREAMICE_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: STREAMICE_READ_PICKUP

C     !INTERFACE:
      SUBROUTINE STREAMICE_READ_PICKUP( myThid )

C     !DESCRIPTION:
C     Reads current state of STREAMICE from a pickup file

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "STREAMICE.h"

C     !INPUT PARAMETERS:
C     myIter            :: time-step number
C     myThid            :: thread number
      INTEGER myIter
      INTEGER myThid

#ifdef ALLOW_STREAMICE
C     !LOCAL VARIABLES:
C     fn          :: character buffer for creating filename
C     fp          :: precision of pickup files
C     filePrec    :: pickup-file precision (read from meta file)
C     nbFields    :: number of fields in pickup file (read from meta file)
C     missFldList :: List of missing fields   (attempted to read but not found)
C     missFldDim  :: Dimension of missing fields list array: missFldList
C     nMissing    :: Number of missing fields (attempted to read but not found)
C     j           :: loop index
C     nj          :: record number
C     ioUnit      :: temp for writing msg unit
C     msgBuf      :: Informational/error message buffer
      INTEGER fp
      INTEGER filePrec, nbFields
      INTEGER missFldDim, nMissing
      INTEGER j, nj, ioUnit
      PARAMETER( missFldDim = 12 )
      CHARACTER*(MAX_LEN_FNAM) fn
      CHARACTER*(8) missFldList(missFldDim)
      CHARACTER*(MAX_LEN_MBUF) msgBuf
CEOP

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

       IF ( pickupSuff.EQ.' ' ) THEN
        WRITE(fn,'(A,I10.10)') 'pickup_streamice.',nIter0
       ELSE
        WRITE(fn,'(A,A10)')    'pickup_streamice.',pickupSuff
       ENDIF
       fp = precFloat64

       CALL READ_MFLDS_SET(
     I                      fn,
     O                      nbFields, filePrec,
     I                      Nr, nIter0, myThid )

       _BEGIN_MASTER( myThid )
       IF ( nbFields.GE.0 .AND. filePrec.NE.fp ) THEN
         WRITE(msgBuf,'(2A,I4)') 'STREAMICE_READ_PICKUP: ',
     &    'pickup-file binary precision do not match !'
         CALL PRINT_ERROR( msgBuf, myThid )
         WRITE(msgBuf,'(A,2(A,I4))') 'STREAMICE_READ_PICKUP: ',
     &    'file prec.=', filePrec, ' but expecting prec.=', fp
         CALL PRINT_ERROR( msgBuf, myThid )
         CALL ALL_PROC_DIE( 0 )
         STOP 'ABNORMAL END: S/R STREAMICE_READ_PICKUP (data-prec Pb)'
       ENDIF
       _END_MASTER( myThid )

       IF ( nbFields.LE.0 ) THEN
C-      No meta-file or old meta-file without List of Fields
        ioUnit = errorMessageUnit
        IF ( pickupStrictlyMatch ) THEN
          WRITE(msgBuf,'(4A)') 'STREAMICE_READ_PICKUP: ',
     &      'no field-list found in meta-file',
     &      ' => cannot check for strick-matching'
          CALL PRINT_ERROR( msgBuf, myThid )
          WRITE(msgBuf,'(4A)') 'STREAMICE_READ_PICKUP: ',
     &      'try with " pickupStrictlyMatch=.FALSE.,"',
     &      ' in file: "data", NameList: "PARM03"'
          CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
          CALL ALL_PROC_DIE( myThid )
          STOP 'ABNORMAL END: S/R STREAMICE_READ_PICKUP'
        ELSE
          WRITE(msgBuf,'(4A)') 'WARNING >> STREAMICE_READ_PICKUP: ',
     &      ' no field-list found'
          CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
         IF ( nbFields.EQ.-1 ) THEN
C-      No meta-file
          WRITE(msgBuf,'(4A)') 'WARNING >> ',
     &      ' try to read pickup as currently written'
          CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
         ELSE
C-      Old meta-file without List of Fields
c         WRITE(msgBuf,'(4A)') 'WARNING >> ',
c    &      ' try to read pickup as it used to be written'
c         CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
c         WRITE(msgBuf,'(4A)') 'WARNING >> ',
c    &      ' until checkpoint59l (2007 Dec 17)'
c         CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
          WRITE(msgBuf,'(4A)') 'STREAMICE_READ_PICKUP: ',
     &      'no field-list found in meta-file'
          CALL PRINT_ERROR( msgBuf, myThid )
          CALL ALL_PROC_DIE( myThid )
          STOP 'ABNORMAL END: S/R STREAMICE_READ_PICKUP'
         ENDIF
        ENDIF
       ENDIF

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

       IF ( nbFields.EQ.0 ) THEN
C---   Old way to read pickup:

       ELSE
C---   New way to read STREAMICE pickup:
        nj = 0
C---    read STREAMICE 3-D fields for restart
#ifdef STREAMICE_HYBRID_STRESS
        CALL READ_MFLDS_3D_RL( 'visc3d  ', visc_streamice_full,
     &                                 nj, fp, Nr, myIter, myThid )
#endif /* STREAMICE_HYBRID_STRESS */
        nj = nj*Nr
C---    read STREAMICE 2-D fields for restart

        CALL READ_MFLDS_3D_RL( 'SI_area ', area_shelf_streamice,
     &                                 nj, fp, 1 , myIter, myThid )
        CALL READ_MFLDS_LEV_RS('SI_hmask', STREAMICE_hmask,
     &                            nj, fp, 1, 1, 1, myIter, myThid )
        CALL READ_MFLDS_3D_RL( 'SI_uvel ', U_streamice,
     &                                 nj, fp, 1 , myIter, myThid )
        CALL READ_MFLDS_3D_RL( 'SI_vvel ', V_streamice,
     &                                 nj, fp, 1 , myIter, myThid )
        CALL READ_MFLDS_3D_RL( 'SI_thick', H_streamice,
     &                                 nj, fp, 1 , myIter, myThid )
        CALL READ_MFLDS_3D_RL( 'SI_betaF', tau_beta_eff_streamice,
     &                                 nj, fp, 1 , myIter, myThid )
        CALL READ_MFLDS_3D_RL( 'SI_visc ', visc_streamice,
     &                                 nj, fp, 1 , myIter, myThid )

#ifdef STREAMICE_HYBRID_STRESS
        CALL READ_MFLDS_3D_RL( 'SI_taubx', streamice_taubx,
     &                                 nj, fp, 1 , myIter, myThid )
        CALL READ_MFLDS_3D_RL( 'SI_tauby', streamice_tauby,
     &                                 nj, fp, 1 , myIter, myThid )
#endif

C--    end: new way to read pickup file
       ENDIF

C--    Check for missing fields:
       nMissing = missFldDim
       CALL READ_MFLDS_CHECK(
     O                     missFldList,
     U                     nMissing,
     I                     myIter, myThid )
       IF ( nMissing.GT.missFldDim ) THEN
         WRITE(msgBuf,'(2A,I4)') 'STREAMICE_READ_PICKUP: ',
     &     'missing fields list has been truncated to', missFldDim
         CALL PRINT_ERROR( msgBuf, myThid )
         CALL ALL_PROC_DIE( myThid )
         STOP 'ABNORMAL END: S/R STREAMICE_READ_PICKUP (list-size Pb)'
       ENDIF
       IF ( nMissing.GE.1 ) THEN
        ioUnit = errorMessageUnit
        DO j=1,nMissing
         WRITE(msgBuf,'(4A)') 'STREAMICE_READ_PICKUP: ',
     &       'cannot restart without field "',missFldList(nj),'"'
         CALL PRINT_ERROR( msgBuf, myThid )
        ENDDO
        CALL ALL_PROC_DIE( myThid )
        STOP 'ABNORMAL END: S/R STREAMICE_READ_PICKUP'
       ENDIF

C--    Update overlap regions:
#ifdef STREAMICE_HYBRID_STRESS
        CALL EXCH_3D_RL( visc_streamice_full, Nr, myThid )
#endif /* STREAMICE_HYBRID_STRESS */
        CALL EXCH_XY_RL( area_shelf_streamice, myThid )
        CALL EXCH_XY_RL( h_streamice, myThid )
        CALL EXCH_XY_RL( u_streamice, myThid )
        CALL EXCH_XY_RL( v_streamice, myThid )
        CALL EXCH_XY_RS( streamice_hmask, myThid )
        CALL EXCH_XY_RL( tau_beta_eff_streamice, myThid )
        CALL EXCH_XY_RL( visc_streamice, myThid )

c       CALL EXCH_XY_RL( myPa_Surf2, myThid )

#endif /* ALLOW_STREAMICE */

      RETURN
      END

#include "GAD_OPTIONS.h"

CBOP
C !ROUTINE: GAD_BIHARM_R

C !INTERFACE: ==========================================================
      SUBROUTINE GAD_BIHARM_R(
     I           bi, bj, k,
     I           maskUp, diffKr4, tracer,
     U           d4f,
     I           myThid )

C !DESCRIPTION:
C Calculates the vertical flux due to bi-harmonic diffusion of a tracer.
C \begin{equation*}
C F^r_{diff} = \kappa_4 \partial_r ( \partial^2 / \partial_r^2 \theta )
C \end{equation*}

C !USES: ===============================================================
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"

C !INPUT PARAMETERS: ===================================================
C  bi,bj                :: tile indices
C  k                    :: vertical level
C  maskUp               :: 2-D array for mask at W points
C  diffKr4              :: vertical bi-harmonic diffusivity
C  tracer               :: tracer field
C  myThid               :: my thread Id number
      INTEGER bi, bj, k
      _RS maskUp(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL diffKr4(Nr)
      _RL tracer (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      INTEGER myThid

C !OUTPUT PARAMETERS: ==================================================
C  dfy                  :: vertical diffusive flux
      _RL d4f    (1-OLx:sNx+OLx,1-OLy:sNy+OLy)

C !LOCAL VARIABLES: ====================================================
C  i,j,n                :: loop indices
C  del2T                :: vertical 2nd  derivative of tracer
C  gradR                :: vertical 1rst derivative of tracer (*rkSign)
      INTEGER i, j, n
      INTEGER kl, km, kp
      _RL del2T(1-OLx:sNx+OLx,1-OLy:sNy+OLy,1:2)
      _RL gradR(1-OLx:sNx+OLx,1-OLy:sNy+OLy,1:3)
      _RL tmpFac
CEOP

      IF ( k.GE.2 ) THEN

C     Calculate vertical gradient @ interface k-1, k & k+1 (n=1:3)
       DO n=1,3
        km = k+n-3
        kl = k+n-2
        IF ( km.LT.1 .OR. kl.GT.Nr ) THEN
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           gradR(i,j,n) = 0.
          ENDDO
         ENDDO
        ELSE
         tmpFac = recip_drC(kl)*deepFac2F(kl)*rhoFacF(kl)
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           gradR(i,j,n) = ( tracer(i,j,kl)-tracer(i,j,km) )
     &                *tmpFac*maskC(i,j,kl,bi,bj)*maskC(i,j,km,bi,bj)
          ENDDO
         ENDDO
        ENDIF
       ENDDO

C     Calculate vertical 2nd derivative @ level k-1 & k (n=1:2)
       DO n=1,2
        kl = k+n-2
        kp = k+n-1
        tmpFac = recip_drF(kl)*recip_deepFac2C(kl)*recip_rhoFacC(kl)
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
           del2T(i,j,n) = ( gradR(i,j,n+1)-gradR(i,j,n) )
     &                  *_recip_hFacC(i,j,kl,bi,bj)
         ENDDO
        ENDDO
       ENDDO

C     Add bi-harmonic flux (gradient of 2nd derivative)
       tmpFac = rkSign*recip_drC(k)*deepFac2F(k)*rhoFacF(k)
       DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
          d4f(i,j) = d4f(i,j)
     &             + diffKr4(k)*( del2T(i,j,2)-del2T(i,j,1) )
     &              *tmpFac*_rA(i,j,bi,bj)*maskUp(i,j)
        ENDDO
       ENDDO

      ENDIF

      RETURN
      END

#include "SBO_OPTIONS.h"

      SUBROUTINE SBO_CHECK( myThid )
C     *==========================================================*
C     | SUBROUTINE SBO_CHECK                                     |
C     | o Validate basic package setup and inter-package         |
C     | dependencies.                                            |
C     *==========================================================*

      IMPLICIT NONE
C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"

C     === Routine arguments ===
C     myThid   :: my Thread Id number
      INTEGER myThid

#ifdef ALLOW_SBO

C     === Local variables ===
C     msgBuf   :: Informational/error message buffer
      CHARACTER*(MAX_LEN_MBUF) msgBuf

      _BEGIN_MASTER(myThid)

      WRITE(msgBuf,'(A)') 'SBO_CHECK: #define ALLOW_SBO'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )

C     SBO assumes spherical polar coordinates
      IF ( usingCartesianGrid ) THEN
        WRITE(msgBuf,'(A)') 'SBO not implemented for Cartesian Grid'
        CALL PRINT_ERROR( msgBuf, myThid )
        STOP 'ABNORMAL END: S/R SBO_CHECK'
      ENDIF
      IF ( usingCylindricalGrid ) THEN
        WRITE(msgBuf,'(A)') 'SBO not implemented for Cylindrical Grid'
        CALL PRINT_ERROR( msgBuf, myThid )
        STOP 'ABNORMAL END: S/R SBO_CHECK'
      ENDIF

      _END_MASTER(myThid)

#endif /* ALLOW_SBO */

      RETURN
      END

#include "PACKAGES_CONFIG.h"
#include "CPP_OPTIONS.h"

CBOP
C     !ROUTINE: DIAGS_OCEANIC_SURF_FLUX
C     !INTERFACE:
      SUBROUTINE DIAGS_OCEANIC_SURF_FLUX( myTime, myIter, myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE DIAGS_OCEANIC_SURF_FLUX
C     | o Compute Diagnostics of Surface Fluxes (ocean only)
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     == Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "DYNVARS.h"
#include "SURFACE.h"
#include "FFIELDS.h"
#ifdef ALLOW_LAYERS
# include "LAYERS_P2SHARE.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     myTime :: Current time in simulation
C     myIter :: Current iteration number in simulation
C     myThid :: Thread number for this instance of the routine.
      _RL myTime
      INTEGER myIter
      INTEGER myThid
CEOP

#ifdef ALLOW_DIAGNOSTICS
C     !FUNCTIONS:
      LOGICAL  DIAGNOSTICS_IS_ON
      EXTERNAL DIAGNOSTICS_IS_ON

C     !LOCAL VARIABLES:
C     i,j,bi,bj :: loop indices
C     ks        :: surface level index
      INTEGER i,j,bi,bj
      INTEGER ks
      _RL tmp1k(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL tmpFac

C-    Time Averages of surface fluxes
       IF ( usingPCoords ) THEN
        ks=Nr
       ELSE
        ks=1
       ENDIF

C-    net Fresh Water flux into the ocean (+=down), [kg/m2/s]
       tmpFac = -1. _d 0
       CALL DIAGNOSTICS_SCALE_FILL_RS( EmPmR,tmpFac,1,
     &                             'oceFWflx',0, 1,0,1,1,myThid )

C-    net Salt flux into the ocean (+=down), [g/m2/s]
       tmpFac = -1. _d 0
       CALL DIAGNOSTICS_SCALE_FILL_RS( saltFlux,tmpFac,1,
     &                             'oceSflux',0, 1,0,1,1,myThid )

C-    Qnet (= net heat flux into the ocean, +=down, [W/m2])
       tmpFac = -1. _d 0
       CALL DIAGNOSTICS_SCALE_FILL_RS( Qnet,tmpFac,1,
     &                             'oceQnet ',0, 1,0,1,1,myThid )

C-    Qsw (= net short-wave into the ocean, +=down, [W/m2])
       tmpFac = -1. _d 0
       CALL DIAGNOSTICS_SCALE_FILL_RS( Qsw,tmpFac,1,
     &                             'oceQsw  ',0, 1,0,1,1,myThid )

      IF ( fluidIsWater .OR. useAtm_Phys ) THEN
C-    taux (surface momentum flux [Pa=N/m2], +=down = increase u-oce)
       CALL DIAGNOSTICS_SCALE_FILL_RS( fu,foFacMom,1,
     &                             'oceTAUX ',0, 1,0,1,1,myThid )

C-    tauy (surface momentum flux [Pa=N/m2], +=down = increase v-oce)
       CALL DIAGNOSTICS_SCALE_FILL_RS( fv,foFacMom,1,
     &                             'oceTAUY ',0, 1,0,1,1,myThid )
      ENDIF

C-    sea-ice loading (expressed in Mass of ice+snow / area unit, [kg/m2])
       CALL DIAGNOSTICS_FILL_RS( sIceLoad,'sIceLoad',0,1,0,1,1,myThid )

      IF ( fluidIsWater ) THEN
C-    pLoad (Atmospheric pressure anomaly relative to surf_pRef [Pa=N/m2])
       CALL DIAGNOSTICS_FILL_RS( pLoad,   'atmPload',0,1,0,1,1,myThid )

C-    oceFreez (= heating from freezing of sea-water, if allowFreezing=T)
       tmpFac = HeatCapacity_Cp*rUnit2mass
       CALL DIAGNOSTICS_SCALE_FILL( adjustColdSST_diag,tmpFac,1,
     &                             'oceFreez',0, 1,0,1,1,myThid )

C-    surForcT (=model surface forcing for Temperature [W/m2], >0 increases T
       tmpFac = HeatCapacity_Cp*rUnit2mass
       CALL DIAGNOSTICS_SCALE_FILL( surfaceForcingT,tmpFac,1,
     &                             'surForcT',0, 1,0,1,1,myThid )

C-    surForcS (=model surface forcing for Salinity, [g/m2/s], >0 increases S
       tmpFac = rUnit2mass
       CALL DIAGNOSTICS_SCALE_FILL( surfaceForcingS,tmpFac,1,
     &                             'surForcS',0, 1,0,1,1,myThid )
      ENDIF

C-    TFLUX (=total heat flux, match heat-content variations, [W/m2])
      IF ( fluidIsWater .AND. (
     &     DIAGNOSTICS_IS_ON('TFLUX   ',myThid)
#ifdef ALLOW_LAYERS
     &     .OR. layers_useThermo
#endif
     &     ) ) THEN
       DO bj = myByLo(myThid), myByHi(myThid)
        DO bi = myBxLo(myThid), myBxHi(myThid)
         DO j = 1,sNy
          DO i = 1,sNx
           tmp1k(i,j,bi,bj) =
     &      (surfaceForcingT(i,j,bi,bj)+adjustColdSST_diag(i,j,bi,bj))
     &      *HeatCapacity_Cp*rUnit2mass
          ENDDO
         ENDDO
#ifdef SHORTWAVE_HEATING
         IF ( selectPenetratingSW .GE. 1 ) THEN
          DO j = 1,sNy
           DO i = 1,sNx
            tmp1k(i,j,bi,bj) = tmp1k(i,j,bi,bj) - Qsw(i,j,bi,bj)
           ENDDO
          ENDDO
         ENDIF
#endif
#ifdef NONLIN_FRSURF
         IF ( (nonlinFreeSurf.GT.0 .OR. usingPCoords)
     &        .AND. useRealFreshWaterFlux ) THEN
          DO j=1,sNy
           DO i=1,sNx
            tmp1k(i,j,bi,bj) = tmp1k(i,j,bi,bj)
     &       + PmEpR(i,j,bi,bj)*theta(i,j,ks,bi,bj)*HeatCapacity_Cp
           ENDDO
          ENDDO
         ENDIF
#endif /* NONLIN_FRSURF */
        ENDDO
       ENDDO
       CALL DIAGNOSTICS_FILL( tmp1k,'TFLUX   ',0,1,0,1,1,myThid )
#ifdef ALLOW_LAYERS
       IF ( layers_useThermo ) THEN
        CALL LAYERS_FILL( tmp1k, 1, 'SUR', 0,1,0,1,1,myThid )
       ENDIF
#endif /* ALLOW_LAYERS */
      ENDIF

C-    SFLUX (=total salt flux, match salt-content variations [g/m2/s])
      IF ( fluidIsWater .AND. (
     &     DIAGNOSTICS_IS_ON('SFLUX   ',myThid)
#ifdef ALLOW_LAYERS
     &     .OR. layers_useThermo
#endif
     &     ) ) THEN
       DO bj = myByLo(myThid), myByHi(myThid)
        DO bi = myBxLo(myThid), myBxHi(myThid)
         DO j = 1,sNy
          DO i = 1,sNx
           tmp1k(i,j,bi,bj) =
     &      surfaceForcingS(i,j,bi,bj)*rUnit2mass
          ENDDO
         ENDDO

#ifdef NONLIN_FRSURF
         IF ( (nonlinFreeSurf.GT.0 .OR. usingPCoords)
     &        .AND. useRealFreshWaterFlux ) THEN
          DO j=1,sNy
           DO i=1,sNx
            tmp1k(i,j,bi,bj) = tmp1k(i,j,bi,bj)
     &       + PmEpR(i,j,bi,bj)*salt(i,j,ks,bi,bj)
           ENDDO
          ENDDO
         ENDIF
#endif /* NONLIN_FRSURF */

        ENDDO
       ENDDO
       CALL DIAGNOSTICS_FILL( tmp1k,'SFLUX   ',0,1,0,1,1,myThid )
#ifdef ALLOW_LAYERS
       IF ( layers_useThermo ) THEN
        CALL LAYERS_FILL( tmp1k, 2, 'SUR', 0,1,0,1,1,myThid )
       ENDIF
#endif /* ALLOW_LAYERS */
      ENDIF
#endif /* ALLOW_DIAGNOSTICS */

      RETURN
      END

#include "SEAICE_OPTIONS.h"

CBOP
C     !ROUTINE: SEAICE_CALC_LHS
C     !INTERFACE:
      SUBROUTINE SEAICE_CALC_LHS(
     I     uIceLoc, vIceLoc,
     O     uIceLHS, vIceLHS,
     I     newtonIter, myTime, myIter, myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE SEAICE_CALC_LHS
C     | o Left-hand side of momentum equations, i.e. all terms
C     |   that depend on the ice velocities of the current
C     |   iterate of the Newton-Krylov iteration
C     |
C     | o The scheme is backward Euler in time, i.e. the
C     |   rhs-vector contains only terms that are independent
C     |   of u/vIce, except for the time derivative part
C     |   mass*(u/vIce-u/vIceNm1)/deltaT
C     | o Left-hand side contributions
C     |   + mass*(u/vIce)/deltaT
C     |   + Cdrag*(uIce*cosWat - vIce*sinWat)
C     |          /(vIce*cosWat + uIce*sinWat)
C     |   - mass*f*vIce/+mass*f*uIce
C     |   - dsigma/dx / -dsigma/dy, eta and zeta are
C     |                   computed only once per Newton iterate
C     *==========================================================*
C     | written by Martin Losch, Oct 2012
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "SEAICE_SIZE.h"
#include "SEAICE_PARAMS.h"
#include "SEAICE.h"

C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
C     myTime :: Simulation time
C     myIter :: Simulation timestep number
C     myThid :: my Thread Id. number
C     newtonIter :: current iterate of Newton iteration
      _RL     myTime
      INTEGER myIter
      INTEGER myThid
      INTEGER newtonIter
C     u/vIceLoc :: local copies of the current ice velocity
      _RL uIceLoc(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL vIceLoc(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
C     u/vIceLHS :: LHS of momentum equations
      _RL uIceLHS(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL vIceLHS(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)

#if ( defined SEAICE_CGRID \
      && ( defined SEAICE_ALLOW_JFNK || defined SEAICE_ALLOW_KRYLOV ) )
C     i,j,bi,bj,k :: loop indices
      INTEGER i,j,bi,bj
      INTEGER k
      _RS     SINWAT
      _RL     COSWAT, recip_deltaT
C     backward difference extrapolation factor
      _RL bdfAlpha
C     symmetric drag coefficient
      _RL dragSym(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
C     fractional area at velocity points
      _RL areaW(1:sNx,1:sNy)
      _RL areaS(1:sNx,1:sNy)
#ifdef SEAICE_ALLOW_MOM_ADVECTION
C     tendency due to advection of momentum
      _RL gUmom(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL gVmom(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
#endif /*  SEAICE_ALLOW_MOM_ADVECTION */
CEOP

      k=1
      recip_deltaT = 1. _d 0 / SEAICE_deltaTdyn
C--   introduce turning angles
      SINWAT=SIN(SEAICE_waterTurnAngle*deg2rad)
      COSWAT=COS(SEAICE_waterTurnAngle*deg2rad)
C     backward difference extrapolation factor
      bdfAlpha = 1. _d 0
      IF ( SEAICEuseBDF2 ) THEN
       IF ( myIter.EQ.nIter0 .AND. SEAICEmomStartBDF.EQ.0 ) THEN
        bdfAlpha = 1. _d 0
       ELSE
        bdfAlpha = 1.5 _d 0
       ENDIF
      ENDIF

C     initialise fractional areas at velocity points
      DO J=1,sNy
       DO I=1,sNx
        areaW(I,J) = 1. _d 0
        areaS(I,J) = 1. _d 0
       ENDDO
      ENDDO

      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
C     symmetric drag coefficient may include bottomdrag for grounded ice
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          dragSym(I,J) = DWATN(I,J,bi,bj)*COSWAT
#ifdef SEAICE_ALLOW_BOTTOMDRAG
     &         +CbotC(I,J,bi,bj)
#endif /* SEAICE_ALLOW_BOTTOMDRAG */
         ENDDO
        ENDDO
C
C     compute components of stress tensor from current velocity field
C     and compute divergence of stress tensor
C
        CALL SEAICE_CALC_STRESSDIV(
     I       e11, e22, e12, press, zeta, eta, etaZ,
     O       stressDivergenceX, stressDivergenceY,
     I       bi, bj, myTime, myIter, myThid )
C     compute lhs side of momentum equations
        IF ( SEAICEscaleSurfStress ) THEN
         DO J=1,sNy
          DO I=1,sNx
           areaW(I,J) = 0.5 _d 0*(AREA(I,J,bi,bj)+AREA(I-1,J,bi,bj))
           areaS(I,J) = 0.5 _d 0*(AREA(I,J,bi,bj)+AREA(I,J-1,bi,bj))
          ENDDO
         ENDDO
        ENDIF
        DO J=1,sNy
         DO I=1,sNx
C     mass*(uIce)/deltaT - dsigma/dx
          uIceLHS(I,J,bi,bj) =
     &         bdfAlpha*seaiceMassU(I,J,bi,bj)*recip_deltaT
     &         *uIceLoc(I,J,bi,bj) - stressDivergenceX(I,J,bi,bj)
C     mass*(vIce)/deltaT - dsigma/dy
          vIceLHS(I,J,bi,bj) =
     &         bdfAlpha*seaiceMassV(I,J,bi,bj)*recip_deltaT
     &         *vIceLoc(I,J,bi,bj) - stressDivergenceY(I,J,bi,bj)
C     coriols terms: - mass*f*vIce
          uIceLHS(I,J,bi,bj) = uIceLHS(I,J,bi,bj) - 0.5 _d 0*(
     &         seaiceMassC(I  ,J,bi,bj) * _fCori(I  ,J,bi,bj)
     &       * 0.5 _d 0*( vIceLoc(I  ,J,bi,bj)+vIceLoc(I  ,J+1,bi,bj) )
     &       + seaiceMassC(I-1,J,bi,bj) * _fCori(I-1,J,bi,bj)
     &       * 0.5 _d 0*( vIceLoc(I-1,J,bi,bj)+vIceLoc(I-1,J+1,bi,bj) )
     &           )
C                    + mass*f*uIce
          vIceLHS(I,J,bi,bj) = vIceLHS(I,J,bi,bj) + 0.5 _d 0*(
     &         seaiceMassC(I,J  ,bi,bj) * _fCori(I,J  ,bi,bj)
     &       * 0.5 _d 0*( uIceLoc(I,J  ,bi,bj)+uIceLoc(I+1,  J,bi,bj) )
     &       + seaiceMassC(I,J-1,bi,bj) * _fCori(I,J-1,bi,bj)
     &       * 0.5 _d 0*( uIceLoc(I,J-1,bi,bj)+uIceLoc(I+1,J-1,bi,bj) )
     &           )
C     ocean-ice and bottom drag terms: + (Cdrag*cosWat+Cb)*uIce - vIce*sinWat)
          uIceLHS(I,J,bi,bj) = uIceLHS(I,J,bi,bj) + (
     &         0.5 _d 0 * ( dragSym(I,J)+dragSym(I-1,J) )
     &         * uIceLoc(I,J,bi,bj)
     &         - SIGN(SINWAT, _fCori(I,J,bi,bj))* 0.5 _d 0 *
     &         (  DWATN(I  ,J,bi,bj) * 0.5 _d 0 *
     &         (vIceLoc(I  ,J,bi,bj)+vIceLoc(I  ,J+1,bi,bj))
     &         +  DWATN(I-1,J,bi,bj) * 0.5 _d 0 *
     &         (vIceLoc(I-1,J,bi,bj)+vIceLoc(I-1,J+1,bi,bj))
     &         ) ) * areaW(I,J)
C                                      + (Cdrag*cosWat+Cb)*uIce + uIce*sinWat)
          vIceLHS(I,J,bi,bj) = vIceLHS(I,J,bi,bj) + (
     &         0.5 _d 0 * ( dragSym(I,J)+dragSym(I,J-1) )
     &         * vIceLoc(I,J,bi,bj)
     &         + SIGN(SINWAT, _fCori(I,J,bi,bj)) * 0.5 _d 0 *
     &         (  DWATN(I,J  ,bi,bj) * 0.5 _d 0 *
     &         (uIceLoc(I,J  ,bi,bj)+uIceLoc(I+1,J  ,bi,bj))
     &         +  DWATN(I,J-1,bi,bj) * 0.5 _d 0 *
     &         (uIceLoc(I,J-1,bi,bj)+uIceLoc(I+1,J-1,bi,bj))
     &         ) ) * areaS(I,J)
#ifdef SEAICE_ALLOW_SIDEDRAG
C     lateral drag terms: + sideDragU*uIce
          uIceLHS(I,J,bi,bj) = uIceLHS(I,J,bi,bj)
     &         + sideDragU(I,J,bi,bj)*uIceLoc(I,J,bi,bj)
C                         + sideDragV*vIce
          vIceLHS(I,J,bi,bj) = vIceLHS(I,J,bi,bj)
     &         + sideDragV(I,J,bi,bj)*vIceLoc(I,J,bi,bj)
#endif /* SEAICE_ALLOW_SIDEDRAG */
C     apply masks for interior (important when we have open boundaries)
          uIceLHS(I,J,bi,bj) = uIceLHS(I,J,bi,bj)*maskinW(I,J,bi,bj)
          vIceLHS(I,J,bi,bj) = vIceLHS(I,J,bi,bj)*maskinS(I,J,bi,bj)
         ENDDO
        ENDDO
#ifdef SEAICE_ALLOW_MOM_ADVECTION
        IF ( SEAICEmomAdvection ) THEN
         DO J=1-OLy,sNy+OLy
          DO I=1-OLx,sNx+OLx
           gUmom(I,J) = 0. _d 0
           gVmom(I,J) = 0. _d 0
          ENDDO
         ENDDO
         CALL SEAICE_MOM_ADVECTION(
     I        bi,bj,1,sNx,1,sNy,
     I        uIceLoc, vIceLoc,
     O        gUmom, gVmom,
     I        myTime, myIter, myThid )
C     Beware of sign! gU/Vmom is computed for the rhs of the equation;
C     therefore, we need to substract gU/Vmom from the left hand side
         DO J=1,sNy
          DO I=1,sNx
           uIceLHS(I,J,bi,bj) = uIceLHS(I,J,bi,bj) - gUmom(I,J)
           vIceLHS(I,J,bi,bj) = vIceLHS(I,J,bi,bj) - gVmom(I,J)
          ENDDO
         ENDDO
        ENDIF
#endif /* SEAICE_ALLOW_MOM_ADVECTION */
       ENDDO
      ENDDO

#endif /* SEAICE_CGRID, SEAICE_ALLOW_JFNK and KRYLOV */

      RETURN
      END

#include "CTRL_OPTIONS.h"
#ifdef ALLOW_TAPENADE
# ifdef ALLOW_GMREDI
#  include "GMREDI_OPTIONS.h"
# endif
#endif /* ALLOW_TAPENADE */

CBOP
C     !ROUTINE: CTRL_INIT_VARIABLES
C     !INTERFACE:
      SUBROUTINE CTRL_INIT_VARIABLES( myThid )
C     !DESCRIPTION: \bv
c     ==================================================================
c     SUBROUTINE CTRL_INIT_VARIABLES
c     ==================================================================
c
c     o Set parts of the vector of control variables and initialize the
c       rest to zero.
c
c     started: heimbach@mit.edu 25-Mar-2002
c
c     ==================================================================
c     SUBROUTINE CTRL_INIT_VARIABLES
c     ==================================================================
C     \ev
C     !USES:
      IMPLICIT NONE
C     == Global variables ===
#include "EEPARAMS.h"
#include "SIZE.h"
#include "PARAMS.h"
#ifdef ALLOW_CTRL
# include "CTRL_SIZE.h"
# include "CTRL.h"
# include "CTRL_FIELDS.h"
# include "CTRL_GENARR.h"
#endif

#ifdef ALLOW_TAPENADE
# include "DYNVARS.h"
# ifdef ALLOW_GMREDI
#  include "GMREDI.h"
# endif
# ifdef ALLOW_CTRL
#  include "CTRL_DUMMY.h"
# endif
# ifdef ALLOW_PTRACERS
#  include "PTRACERS_SIZE.h"
#  include "PTRACERS_FIELDS.h"
# endif
# ifdef ALLOW_SHELFICE
#  include "SHELFICE.h"
# endif
# ifdef ALLOW_STREAMICE
#  include "STREAMICE.h"
# endif
# ifdef ALLOW_SEAICE
#  include "SEAICE_SIZE.h"
#  include "SEAICE.h"
# endif
#endif /* ALLOW_TAPENADE */

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     myThid :: Thread number for this instance of the routine.
      INTEGER myThid

#ifdef ALLOW_CTRL

C     !LOCAL VARIABLES:
C     == Local variables
      INTEGER bi,bj
      INTEGER k
#ifdef ALLOW_BOTTOMDRAG_CONTROL
      INTEGER i,j
#endif
c     == end of interface ==
CEOP

#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_ENTER('CTRL_INIT_VARIABLES',myThid)
#endif

#ifdef ALLOW_BOTTOMDRAG_CONTROL
      DO bj = myByLo(myThid),myByHi(myThid)
        DO bi = myBxLo(myThid),myBxHi(myThid)
          DO j = 1-OLy,sNy+OLy
            DO i = 1-OLx,sNx+OLx
              bottomDragFld(i,j,bi,bj) = 0. _d 0
            ENDDO
          ENDDO
        ENDDO
      ENDDO
#endif

#ifdef ALLOW_OBCS_CONTROL
      IF (useOBCS) CALL CTRL_INIT_OBCS_VARIABLES( myThid )
#endif

C--   Map the control variables onto the model state.
C-    Needs to be called after few {PKG}_init_varia (e.g., PTRACERS_INIT_VARIA)
#if (defined (ALLOW_GENARR2D_CONTROL) || defined (ALLOW_GENARR3D_CONTROL))
# ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_CALL('CTRL_MAP_INI_GENARR',myThid)
# endif
      CALL CTRL_MAP_INI_GENARR( myThid )
#endif
#ifdef ALLOW_GENTIM2D_CONTROL
# ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_CALL('CTRL_MAP_INI_GENTIM2D',myThid)
# endif
      CALL CTRL_MAP_INI_GENTIM2D( myThid )
#endif

#ifdef ALLOW_COST
# ifdef ALLOW_GENTIM2D_CONTROL
      DO bj = myByLo(myThid),myByHi(myThid)
        DO bi = myBxLo(myThid),myBxHi(myThid)
          DO k=1,maxCtrlTim2D
            objf_gentim2d(bi,bj,k)     = 0. _d 0
            num_gentim2d(bi,bj,k)      = 0. _d 0
          ENDDO
        ENDDO
      ENDDO
# endif
# ifdef ALLOW_GENARR2D_CONTROL
      DO bj = myByLo(myThid),myByHi(myThid)
        DO bi = myBxLo(myThid),myBxHi(myThid)
          DO k=1,maxCtrlArr2D
            objf_genarr2d(bi,bj,k)    = 0. _d 0
            num_genarr2d(bi,bj,k)    = 0. _d 0
          ENDDO
        ENDDO
      ENDDO
# endif
# ifdef ALLOW_GENARR3D_CONTROL
      DO bj = myByLo(myThid),myByHi(myThid)
        DO bi = myBxLo(myThid),myBxHi(myThid)
          DO k=1,maxCtrlArr3D
            objf_genarr3d(bi,bj,k)    = 0. _d 0
            num_genarr3d(bi,bj,k)    = 0. _d 0
          ENDDO
        ENDDO
      ENDDO
# endif
#endif /* ALLOW_COST */

#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_LEAVE('CTRL_INIT_VARIABLES',myThid)
#endif
#endif /* ALLOW_CTRL */

      RETURN
      END

#include "SMOOTH_OPTIONS.h"

      SUBROUTINE SMOOTH_HETERO2D(
     &           fld_in, mask_in, dist_file, nbt_in, myThid )

C     *==========================================================*
C     | SUBROUTINE smooth_hetero2D
C     | o this routine smoothes a 2D field isotropically (except for
C     |   the land mask) to a space variable length scale. It mostly
C     |   calls smooth_diff2D.F.
C     *==========================================================*

      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "GRID.h"
#include "PARAMS.h"
#include "SMOOTH.h"

      _RL fld_in(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RS mask_in(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      CHARACTER*(MAX_LEN_FNAM) dist_file
      INTEGER nbt_in
      INTEGER myThid

      _RL dist_in(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      INTEGER i,j,bi,bj

      smooth2DtotTime = nbt_in*smooth2DdelTime

      CALL READ_REC_3D_RL( dist_file, smoothprec,
     &                     1, dist_in, 1, 1, myThid )

      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          smooth2D_Lx(i,j,bi,bj) = dist_in(i,j,bi,bj)
          smooth2D_Ly(i,j,bi,bj) = dist_in(i,j,bi,bj)
         ENDDO
        ENDDO
       ENDDO
      ENDDO

      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          smooth2D_Kux(i,j,bi,bj) = smooth2D_Lx(i,j,bi,bj)
     &            *smooth2D_Lx(i,j,bi,bj)/smooth2DtotTime/2
          smooth2D_Kvy(i,j,bi,bj) = smooth2D_Ly(i,j,bi,bj)
     &            *smooth2D_Ly(i,j,bi,bj)/smooth2DtotTime/2
         ENDDO
        ENDDO
       ENDDO
      ENDDO

      CALL EXCH_XY_RL( smooth2D_Kux, myThid )
      CALL EXCH_XY_RL( smooth2D_Kvy, myThid )

      CALL SMOOTH_DIFF2D( fld_in, mask_in, nbt_in, myThid )

      CALL EXCH_XY_RL( fld_in, myThid )

      RETURN
      END

#include "SHELFICE_OPTIONS.h"

CBOP
C     !ROUTINE: SHELFICE_REMESH_C_MASK
C     !INTERFACE:
      SUBROUTINE SHELFICE_REMESH_C_MASK(
     O                    k1SurfC, mrgFacC,
     I                    myTime, myIter, myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE SHELFICE_REMESH_C_MASK
C     | o Loops through top level cells and determines those where
C     |   hFac is too large and hence splits into two cells,
C     |   and cells where hFac is too small, and merges cell with
C     |   below.
C     | o Update surface ref position Ro_surf and anomaly Eta
C     |   as well as R_shelfIce.
C     | o Recomputes h0FacC using formula from initialisation
C     |   based on new R_shelfIce
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "SURFACE.h"
#include "DYNVARS.h"
#include "SHELFICE.h"

C     !INPUT/OUTPUT PARAMETERS:
C     k1SurfC   :: surface level index (at cell center) before remeshing
C     mrgFacC   :: merging weight for tracers (cell center)
C     myTime    :: Current time in simulation
C     myIter    :: Current iteration number
C     myThid    :: my Thread Id number
      INTEGER k1SurfC(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL mrgFacC(1-OLx:sNx+OLx,1-OLy:sNy+OLy,2,nSx,nSy)
      _RL myTime
      INTEGER myIter
      INTEGER myThid
CEOP

#ifdef ALLOW_SHELFICE_REMESHING
#ifdef NONLIN_FRSURF
C     !LOCAL VARIABLES:
C     bi,bj   :: tile indices
C     i,j,k   :: Loop counters
C     k1, k2  :: previous and new surface level
C     ioUnit  :: temp for writing msg unit
C     msgBuf  :: Informational/error message buffer
      INTEGER bi, bj
      INTEGER i, j
      INTEGER ks, k1, k2
#ifdef SHELFICE_REMESH_PRINT
      LOGICAL prtFirst, prtPoint
      INTEGER ioUnit
      CHARACTER*(MAX_LEN_MBUF) msgBuf
#endif
      _RL sync_fac, stag_fac
      _RL adjust, r_newDz, tmpVar

#ifdef SHELFICE_REMESH_PRINT
      prtFirst = .TRUE.
      ioUnit = -1
      IF ( debugLevel.GE.debLevB ) ioUnit = standardMessageUnit
#endif
      IF ( staggerTimestep ) THEN
        sync_fac = 0.0
        stag_fac = 1.0
      ELSE
        sync_fac = 1.0
        stag_fac = 0.0
      ENDIF

      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)

        DO j = 1-OLy,sNy+OLy
         DO i = 1-OLx,sNx+OLx
          k1SurfC(i,j,bi,bj) = kSurfC(i,j,bi,bj)
          mrgFacC(i,j,1,bi,bj) = 0.
          mrgFacC(i,j,2,bi,bj) = 0.
          ks = kTopC(i,j,bi,bj)

          IF ( ks.NE.0 ) THEN
C-- SPLIT CELLS
           IF ( ks.GT.1 .AND.
     &          hFac_surfC(i,j,bi,bj).GT.SHELFICEsplitThreshold ) THEN
            IF ( (hFac_surfC(i,j,bi,bj)-1)*drF(ks)*recip_drF(ks-1)
     &           .GT.SHELFICEmergeThreshold ) THEN

             k1 = ks
             k2 = ks-1
             kSurfC(i,j,bi,bj) = k2
             adjust = rF(k2) - R_shelfIce(i,j,bi,bj)
#ifdef SHELFICE_REMESH_PRINT
             prtPoint = ( ioUnit.GE.0 ) .AND.
     &          ( i.GE.1 .AND. i.LE.sNx .AND. j.GE.1 .AND. j.LE.sNy )
             IF ( prtPoint ) THEN
              IF ( prtFirst ) THEN
               WRITE(msgBuf,'(A,I10)') 'SHI_REMESH at it=', myIter
               CALL PRINT_MESSAGE( msgBuf,ioUnit,SQUEEZE_RIGHT,myThid )
               prtFirst = .FALSE.
              ENDIF
              WRITE(msgBuf,'(A,2I5,2I4,A,1P2E12.3)') '--> REMESH in:',
     &            i, j, bi, bj, ' , x,y=', XC(i,j,bi,bj),YC(i,j,bi,bj)
              CALL PRINT_MESSAGE( msgBuf,ioUnit,SQUEEZE_RIGHT,myThid )
              WRITE(msgBuf,'(2A,I4,3(A,1P1E12.3))') ' before:',
     &        '  ks=', k1, ' Ro_s=', Ro_surf(i,j,bi,bj),
     &        ' eta=', etaH(i,j,bi,bj), ' hFac=', hFac_surfC(i,j,bi,bj)
              CALL PRINT_MESSAGE( msgBuf,ioUnit,SQUEEZE_RIGHT,myThid )
             ENDIF
#endif /* SHELFICE_REMESH_PRINT */
C-    decrement eta and increment R_shelfIce and Ro_surf
             etaN(i,j,bi,bj) = etaN(i,j,bi,bj)- adjust
             etaH(i,j,bi,bj) = etaH(i,j,bi,bj)- adjust
             etaHnm1(i,j,bi,bj) = etaHnm1(i,j,bi,bj)- adjust
             R_shelfIce(i,j,bi,bj) = R_shelfIce(i,j,bi,bj)+adjust
             Ro_surf(i,j,bi,bj) = Ro_surf(i,j,bi,bj)+adjust
C     update cell-centered grid factors and mask: maskC, h0FacC, recip_hFacC
             maskC(i,j,k2,bi,bj)  = oneRS
             h0FacC(i,j,k1,bi,bj) = oneRS
             h0FacC(i,j,k2,bi,bj) = oneRS
             recip_hFacC(i,j,k1,bi,bj) = oneRS
             recip_hFacC(i,j,k2,bi,bj) = oneRS
             IF ( k1 .EQ. kLowC(i,j,bi,bj) ) THEN
               h0FacC(i,j,k1,bi,bj) = ( rF(k1) - R_low(i,j,bi,bj) )
     &                              *recip_drF(k1)
               recip_hFacC(i,j,k1,bi,bj) = oneRS / h0FacC(i,j,k1,bi,bj)
             ENDIF
#ifdef SHELFICE_REMESH_PRINT
             IF ( prtPoint ) THEN
              WRITE(msgBuf,'(2A,I4,3(A,1P1E12.3))') ' after :',
     &        '  ks=', k2, ' Ro_s=', Ro_surf(i,j,bi,bj),
     &        ' eta=', etaH(i,j,bi,bj), ' hFac=',
     &           h0FacC(i,j,k2,bi,bj)+etaH(i,j,bi,bj)*recip_drF(k2)
              CALL PRINT_MESSAGE( msgBuf,ioUnit,SQUEEZE_RIGHT,myThid )
             ENDIF
#endif /* SHELFICE_REMESH_PRINT */
            ENDIF
           ENDIF
          ENDIF

C-- MERGE CELLS
          IF ( ks.NE.0 .AND. ks.LT.kLowC (i,j,bi,bj) ) THEN
           IF ( hFac_surfC(i,j,bi,bj).LT.SHELFICEmergeThreshold ) THEN
            IF ( (hFac_surfC(i,j,bi,bj)*drF(ks)*recip_drF(ks+1)+1)
     &           .LT.SHELFICEsplitThreshold ) THEN

             k1 = ks
             k2 = ks+1
             kSurfC(i,j,bi,bj) = k2
             adjust = R_shelfIce(i,j,bi,bj)-rF(k2)
#ifdef SHELFICE_REMESH_PRINT
             prtPoint = ( ioUnit.GE.0 ) .AND.
     &          ( i.GE.1 .AND. i.LE.sNx .AND. j.GE.1 .AND. j.LE.sNy )
             IF ( prtPoint ) THEN
              IF ( prtFirst ) THEN
               WRITE(msgBuf,'(A,I10)') 'SHI_REMESH at it=', myIter
               CALL PRINT_MESSAGE( msgBuf,ioUnit,SQUEEZE_RIGHT,myThid )
               prtFirst = .FALSE.
              ENDIF
              WRITE(msgBuf,'(A,2I5,2I4,A,1P2E12.3)') '--> REMESH in:',
     &            i, j, bi, bj, ' , x,y=', XC(i,j,bi,bj),YC(i,j,bi,bj)
              CALL PRINT_MESSAGE( msgBuf,ioUnit,SQUEEZE_RIGHT,myThid )
              WRITE(msgBuf,'(2A,I4,3(A,1P1E12.3))') ' before:',
     &        '  ks=', k1, ' Ro_s=', Ro_surf(i,j,bi,bj),
     &        ' eta=', etaH(i,j,bi,bj), ' hFac=', hFac_surfC(i,j,bi,bj)
              CALL PRINT_MESSAGE( msgBuf,ioUnit,SQUEEZE_RIGHT,myThid )
             ENDIF
#endif /* SHELFICE_REMESH_PRINT */
C-    increment eta and decrement R_shelfIce and Ro_surf
             etaN(i,j,bi,bj) = etaN(i,j,bi,bj) + adjust
             etaH(i,j,bi,bj) = etaH(i,j,bi,bj) + adjust
             etaHnm1(i,j,bi,bj) = etaHnm1(i,j,bi,bj) + adjust
             R_shelfIce(i,j,bi,bj) = R_shelfIce(i,j,bi,bj)-adjust
             Ro_surf(i,j,bi,bj) = Ro_surf(i,j,bi,bj) - adjust

C-    Compute merging weights for tracer in new (=k2) top cell, accounting
C     for former (=k1) top cell content:
C      Tr(k2) <-- mrgFacC(1)*Tr(k1) + mrgFacC(2)*Tr(k2) ; Tr(k1) <-- 0.
C     first find the inverse thickness of the new top cell:
             IF ( k2 .LT. kLowC(i,j,bi,bj) ) THEN
              r_newDz = oneRL / ( drF(k2) + etaH(i,j,bi,bj) )
             ELSE
              r_newDz = oneRL
     &                / ( rF(k2)-r_low(i,j,bi,bj) + etaH(i,j,bi,bj) )
             ENDIF
             mrgFacC(i,j,1,bi,bj) = ( stag_Fac*hFac_surfC(i,j,bi,bj)
     &                              + sync_fac*hFacC(i,j,k1,bi,bj)
     &                              )*drF(k1)*r_newDz
             mrgFacC(i,j,2,bi,bj) = hFacC(i,j,k2,bi,bj)*drF(k2)*r_newDz
C     update cell-centered grid factors and mask: maskC, h0FacC, recip_hFacC
             maskC(i,j,k1,bi,bj)  = zeroRS
             h0FacC(i,j,k1,bi,bj) = zeroRS
             h0FacC(i,j,k2,bi,bj) = oneRS
             recip_hFacC(i,j,k1,bi,bj) = zeroRS
             recip_hFacC(i,j,k2,bi,bj) = oneRS
             IF ( k2 .EQ. kLowC(i,j,bi,bj) ) THEN
               h0FacC(i,j,k2,bi,bj) = ( rF(k2) - R_low(i,j,bi,bj) )
     &                              * recip_drF(k2)
               recip_hFacC(i,j,k2,bi,bj) = oneRS / h0FacC(i,j,k2,bi,bj)
             ENDIF
#ifdef SHELFICE_REMESH_PRINT
             IF ( prtPoint ) THEN
              WRITE(msgBuf,'(2A,I4,3(A,1P1E12.3))') ' after :',
     &        '  ks=', k2, ' Ro_s=', Ro_surf(i,j,bi,bj),
     &        ' eta=', etaH(i,j,bi,bj), ' hFac=',
     &           h0FacC(i,j,k2,bi,bj)+etaH(i,j,bi,bj)*recip_drF(k2)
              CALL PRINT_MESSAGE( msgBuf,ioUnit,SQUEEZE_RIGHT,myThid )
             ENDIF
#endif /* SHELFICE_REMESH_PRINT */
            ENDIF
           ENDIF
          ENDIF

C-  Update remaining cell-centered grid fields
C   Note: CALC_SURF_DR & UPDATE_SURF_DR will update hFac_surfC and surface hFacC
          IF ( kSurfC(i,j,bi,bj).NE.k1SurfC(i,j,bi,bj) ) THEN
            k1 = k1SurfC(i,j,bi,bj)
            k2 =  kSurfC(i,j,bi,bj)
            hFacC(i,j,k1,bi,bj) = h0FacC(i,j,k1,bi,bj)
            hFacC(i,j,k2,bi,bj) = h0FacC(i,j,k2,bi,bj)
            tmpVar = Ro_surf(i,j,bi,bj) - R_low(i,j,bi,bj)
            recip_Rcol(i,j,bi,bj) = 1. _d 0 / tmpVar
            kTopC(i,j,bi,bj)  = k2
          ENDIF

         ENDDO
        ENDDO
C---
       ENDDO
      ENDDO
#ifdef SHELFICE_REMESH_PRINT
      IF ( ioUnit.GE.0 .AND. .NOT. prtFirst ) THEN
        WRITE(msgBuf,'(A,A)') 'SHI_REMESH :', ' end of report'
        CALL PRINT_MESSAGE( msgBuf,ioUnit,SQUEEZE_RIGHT,myThid )
      ENDIF
#endif /* SHELFICE_REMESH_PRINT */

#endif /* NONLIN_FRSURF */
#endif /* ALLOW_SHELFICE_REMESHING */
      RETURN
      END

#include "KL10_OPTIONS.h"

CBOP
C !ROUTINE: KL10_CALC

C !INTERFACE: =======================================================
      SUBROUTINE KL10_CALC(
     I                bi, bj, sigmaR, myTime, myIter, myThid )

C !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE KL10_CALC                                     |
C     | o Compute all KL10 fields defined in KL10.h              |
C     *==========================================================*
C     | This subroutine is based on SPEM code                    |
C     *==========================================================*
C \ev

C--------------------------------------------------------------------

C JMK
C global parameters updated by kl_calc
C     KLviscAz  :: KL eddy viscosity coefficient              (m^2/s)
C     KLdiffKzT :: KL diffusion coefficient for temperature   (m^2/s)

C !USES: ============================================================
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "EOS.h"
#include "GRID.h"
#include "DYNVARS.h"
#include "FFIELDS.h"
#include "KL10.h"
c#ifdef ALLOW_AUTODIFF_TAMC
c# include "tamc.h"
c#endif /* ALLOW_AUTODIFF_TAMC */

C !INPUT PARAMETERS: ===================================================
c Routine arguments
C     bi, bj :: Current tile indices
C     sigmaR :: Vertical gradient of iso-neutral density
C     myTime :: Current time in simulation
C     myIter :: Current time-step number
C     myThid :: My Thread Id number
      INTEGER bi, bj
      _RL     sigmaR(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL     myTime
      INTEGER myIter
      INTEGER myThid

#ifdef ALLOW_KL10
C !LOCAL VARIABLES: ====================================================
c Local constants
C     iMin, iMax, jMin, jMax :: array computation indices
      INTEGER I, J, K, Km1, JJ
      INTEGER   iMin ,iMax ,jMin ,jMax,di
      _RL     KLviscTmp, tempu
      _RL     b0, buoyFreqf, buoyFreqc, KLviscold,zsum,zsums
C note: rhoS(0) is never used but could be reached when evaluating
C       the "DO WHILE" expression around line 106
      _RL     rhoS(0:Nr), RS(1:Nr)
      _RL     dzp,ec,ep,es,epss(-1:0),epsw(-1:0),dz,KTemp
c     _RL     bF(1:Nr)
c     _RL     theta_mcb(1:Nr),theta_mcb3(1:Nr)
C     === Local variables ===
C     msgBuf     :: Informational/error message buffer
c     CHARACTER*(MAX_LEN_MBUF) msgBuf
CEOP

      iMin = 2-OLx
      iMax = sNx+OLx-1
      jMin = 2-OLy
      jMax = sNy+OLy-1

      DO J=jMin,jMax
         DO I=iMin,iMax
            K=1
            rhoS(1)=rhoInSitu(I,J,K,bi,bj)
            RS(1)=rC(1)

            KLeps(I-1,J-1,1,bi,bj)=0.0
c           eps(k-1) = (dz(k-1)*eps0(k-1) +dz(k)*eps0(k))/(dz(k-1)+dz(k))
            ep = 0.0
            dzp = 0.0

            KLviscAr(I,J,1,bi,bj) = viscArNr(1)
            KLviscold = KLviscAr(I,J,1,bi,bj) ! at previous cell center
C Fill in density profile using vertical gradient of iso-neutral density (SigmaR)
C      (valid also for nonlinear EOS + remove pressure effect)
            DO K=2,Nr
               rhoS(K)= rhoS(K-1) + rkSign*drC(K)*SigmaR(I,J,K)
               RS(K)=rC(K)
            ENDDO
C get sorted densities rhoS, and the array with the depths from which
C the density came from, RS.
            DO K=2,Nr
c$$$               WRITE(msgBuf, '(A,I10.10,A,E10.4,A,E10.4)') 'Hellok ', K
c$$$     &              -1,' ',theta(I,J,K,bi,bj),' ',rhot
c$$$               CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
c$$$     &                             SQUEEZE_RIGHT, myThid )
               IF ( (rhoS(K).LT.rhoS(K-1)).AND.(maskC(I,J,K,bi
     &              ,bj).GT.0)) THEN
                  JJ=K-1
                  DO WHILE ( (JJ.GT.0).AND.(rhoS(K).LT.rhoS(JJ)) )
c                    write(*,*) K,JJ,rhoS(K),rhoS(JJ)
                     JJ=JJ-1
                  ENDDO
                  rhoS(JJ+1:K)=cshift(rhoS(JJ+1:K),-1)
                  RS(JJ+1:K)=cshift(RS(JJ+1:K),-1)
               ENDIF
            ENDDO

C RS-R is dz....
C recip_drC=inverse distanance between centers,
C first is between surface and first center
C diffKrNrS(K) = viscArNr(K) = background value

            KLdiffKr(I,J,1,bi,bj) = MAX(KLviscAr(I,J,1,bi,bj),
#ifdef ALLOW_3D_DIFFKR
     &                                  diffKr(I,J,1,bi,bj) )
#else
     &                                  diffKrNrS(1) )
#endif
C N at surface = zero or uses gradient
            b0 = MAX(-gravity*mass2rUnit*
     &              (rhoS(1) - rhoS(2))*recip_drC(2),0. _d 0)
c           b0 = 0.
            DO di=-1,0
               epss(di)=0.0
               epsw(di)=0.0
            ENDDO

            DO K=1,Nr
               IF (K.LT.Nr) THEN
                  buoyFreqf = -gravity*mass2rUnit*
     &              (rhoS(K) - rhoS(K+1))*recip_drC(K+1)
               ELSE
C N zero OR not zero near bottom (at the end of array)
                  buoyFreqf = -gravity*mass2rUnit*
     &              (rhoS(K-1) - rhoS(K))*recip_drC(K)
C                  buoyFreqf = 0.
               ENDIF
               buoyFreqf = MAX(buoyFreqf,0. _d 0) ! not < 0
               buoyFreqc = (buoyFreqf + b0)*0.5   ! mean at cell center

C viscosity at cell center at K
C = 0.2*dz^2*N.  0.2 is mixing efficiency.
C to derive, note K = 0.2\epsilon/N^2.  Then note that
C \epsilon = dz^2N^3 (Ozmidov scale)
               KLviscTmp = MAX( viscArNr(K), 0.2*(RS(K)-rC(K))*
     &                        (RS(K)-rC(K))*sqrt(buoyFreqc))

               IF (K.GT.1) THEN
                  Km1=K-1

C viscosity at cell face above center at K
                  KTemp = 0.5*(KLviscTmp+KLviscold)
C Put an upper limit on viscosity to prevent instability when
C explicit viscosity is C used (e.g. for nonhydrostatic case) SAL
                  KTemp = MIN(KLviscMax,KTemp)
                  KLviscAr(I,J,K,bi,bj) = MAX(KTemp,viscArNr(K))
                  KLdiffKr(I,J,K,bi,bj) = MAX(KTemp,
#ifdef ALLOW_3D_DIFFKR
     &                                        diffKr(I,J,K,bi,bj) )
#else
     &                                        diffKrNrS(K) )
#endif

C Compute Epsilon for diagnostics:
C
C need to caclulate Im1 and Jm1 epsilon unfortunately...  Here at
C i-1,j-1 we average the west nu(du/dz)^2 at i-1 and i, and the south
C nu(dv/dv)^2 at j-1 and j, and then add them
C
C dz is calculated from the face distances, with the cells assumed to be
C half way.  Note the use of hfacW and hfacS to make these correct near
C bathy.
                  zsum=0.
                  ec=0.0
                  zsums=0.
                  es=0.
                  DO di=-1,0
                     IF (hfacW(I+di,J-1,K,bi,bj).GT.0.000001) THEN
                        dz = 0.5*(drF(K)*hfacW(I+di,J-1,K,bi,bj)
     &                       +drF(Km1)*hfacW(I+di,J-1,Km1,bi,bj))
                        IF (dz.GT.0.00001) THEN
                           tempu = (uVel(I+di,J-1,Km1,bi,bj)-uVel(I+di,J
     &                          -1,K,bi,bj))/dz
                           epsw(di)=tempu*tempu*KLviscAr(I+di,J-1,K,bi
     &                          ,bj)
                           ec=ec+epsw(di)*dz
                           zsum = zsum+dz
                        ENDIF
                     ELSE
C                       This face is on the seafloor.  set epsilon=the
C                       previous and dz = half the face.
                        dz=0.5*(drF(Km1)*hfacW(I+di,J-1,Km1,bi ,bj))
                        ec=ec+epsw(di)*dz
                        zsum = zsum+dz
                     ENDIF
C Now do the v-component
                     IF (hfacS(I-1,J+di,K,bi,bj).GT.0.000001) THEN
                        dz = 0.5*(drF(K)*hfacS(I-1,J+di,K,bi,bj)
     &                       +drF(Km1)*hfacS(I-1,J+di,Km1,bi,bj))
                        IF (dz.GT.0.00001) THEN
                           tempu = (vVel(I-1,J+di,Km1,bi,bj)-vVel(I-1,J
     &                          +di,K,bi,bj))/dz
                           epss(di)=tempu*tempu*KLviscAr(I-1,J+di,K,bi
     &                          ,bj)
                           es = es+epss(di)*dz
                           zsums = zsums+dz
                        ENDIF
                     ELSE
C                       This face is on the seafloor.  set epsilon=the
C                       previous and dz = half the face.
                        dz=+0.5*(drF(Km1)*hfacS(I-1,J+di,Km1 ,bi,bj))
                        es = es+epss(di)*dz
                        zsums = zsums+dz
                     ENDIF
                  ENDDO
C                 take the average of the du/dz terms
                  IF (zsum.GT.0.00001) THEN
                     ec=ec/zsum
                  ENDIF
C                 take the average of the dv/dz terms
                  IF (zsums.GT.0.00001) THEN
                     es=es/zsums
                  ENDIF
C add the u and v dissipations:
                  ec=es+ec

C Note this ec is defined on cell faces K=2..NR at the center of the
C cells (i.e. at XC), so its above the density variables.
C
C So to get at the center of the cells, just average this one and the previous one.
C  And its a true average because the

                  KLeps(I-1,J-1,Km1,bi,bj) = 0.5*(ep+ec)
                  IF (Km1.EQ.1) THEN
                     KLeps(I-1,J-1,Km1,bi,bj) = ec
                  ENDIF
                  ep=ec
               ENDIF
c$$$               WRITE(msgBuf, '(A,I10.10,A,E10.4,A,E10.4)') 'Hellok ', K
c$$$     &              -1,' ',theta(I,J,K,bi,bj),' ',KLeps(I-1,J-1,Km1,bi
c$$$     &              ,bj)
c$$$               CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
c$$$     &                             SQUEEZE_RIGHT, myThid )

               b0        = buoyFreqf ! at previous cell face
               KLviscold = KLviscTmp ! at previous cell center
            ENDDO
C           ENDDO K
C     set on K=Nr
            KLeps(I-1,J-1,Nr,bi,bj) =ep

         ENDDO
C           ENDDO J
      ENDDO
C           ENDDO I

#endif /* ALLOW_KL10 */

      RETURN
      END

#include "AUTODIFF_OPTIONS.h"
#ifdef ALLOW_CTRL
# include "CTRL_OPTIONS.h"
#endif

C     ==================================================================
C     active_file_control.F: Routines to handle the I/O of active
C                            variables for the adjoint calculations.
C                            All files are direct access files.
C     Routines:
C     o  ACTIVE_READ_3D_RL  : Basic routine to handle active 3D read operations
C     o  ACTIVE_READ_3D_RS  : Basic routine to handle active 3D read operations
C     o  ACTIVE_READ_1D_RL  : Basic routine to handle active 1D read operations
C     o  ACTIVE_READ_1D_RS  : Basic routine to handle active 1D read operations
C     o  ACTIVE_WRITE_3D_RL : Basic routine to handle active 3D write operations
C     o  ACTIVE_WRITE_3D_RS : Basic routine to handle active 3D write operations
C     o  ACTIVE_WRITE_1D_RL  : Basic routine to handle active 1D write operations
C     o  ACTIVE_WRITE_1D_RS  : Basic routine to handle active 1D write operations
C
C        changed: Christian Eckert eckert@mit.edu 24-Apr-2000
C        - Added routines that do active writes on tiles
C                   instead of a whole thread.
C     ==================================================================

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: ACTIVE_READ_3D_RL
C     !INTERFACE:
      SUBROUTINE ACTIVE_READ_3D_RL(
     I                          activeVar_file,
     O                          active_var,
     I                          globalFile,
     I                          useCurrentDir,
     I                          lAdInit,
     I                          iRec,
     I                          myNr,
     I                          theSimulationMode,
     I                          myOptimIter,
     I                          myThid )
C     !DESCRIPTION: \bv
C     ==================================================================
C     SUBROUTINE ACTIVE_READ_3D_RL
C     ==================================================================
C     o Read an active 3D _RL variable from file.
C     The variable *globalfile* can be used as a switch, which allows
C     to read from a global file. The adjoint files are, however, always
C     treated as tiled files.
C     started: Christian Eckert eckert@mit.edu    Jan-1999
C     ==================================================================
C     SUBROUTINE ACTIVE_READ_3D_RL
C     ==================================================================
C     \ev

C     !USES:
      IMPLICIT NONE

C     == global variables ==
#include "EEPARAMS.h"
#include "SIZE.h"
#include "PARAMS.h"
#include "CTRL_SIZE.h"
#include "CTRL.h"

C     !INPUT/OUTPUT PARAMETERS:
C     activeVar_file :: filename
C     active_var     :: array
C     globalFile     ::
C     useCurrentDir  :: always read from the current directory
C                        (even if "mdsioLocalDir" is set)
C     lAdInit        :: initialisation of corresponding adjoint variable
C                        and write to active file
C     iRec           :: record number
C     myNr           :: vertical array dimension
C     theSimulationMode :: forward mode or reverse mode simulation
C     myOptimIter    :: number of optimization iteration (default: 0)
C     myThid         :: thread number for this instance
      CHARACTER*(*) activeVar_file
      INTEGER  myNr
      _RL      active_var(1-OLx:sNx+OLx,1-OLy:sNy+OLy,myNr,nSx,nSy)
      LOGICAL  globalFile
      LOGICAL  useCurrentDir
      LOGICAL  lAdInit
      INTEGER  iRec
      INTEGER  theSimulationMode
      INTEGER  myOptimIter
      INTEGER  myThid

C     !LOCAL VARIABLES:
      CHARACTER*(2)  adpref
      CHARACTER*(MAX_LEN_FNAM) adfname
      INTEGER bi,bj
      INTEGER i,j,k
      INTEGER jRec
      INTEGER prec
      LOGICAL w_globFile
      _RS  dummyRS(1)
      _RL  active_data_t(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
CEOP

C     force 64-bit io
      prec = ctrlprec
      jRec = -ABS(iRec)

C     >>>>>>>>>>>>>>>>>>> FORWARD RUN <<<<<<<<<<<<<<<<<<<
      IF (theSimulationMode .EQ. FORWARD_SIMULATION) THEN

C     Read the active variable from file.
        CALL MDS_READ_FIELD(
     I                activeVar_file, prec, useCurrentDir,
     I                'RL', myNr, 1, myNr,
     O                active_var, dummyRS,
     I                iRec, myThid )

        IF ( lAdInit ) THEN
C     Initialise the corresponding adjoint variable on the
C     adjoint variable file. These files are tiled.

          DO bj = myByLo(myThid), myByHi(myThid)
           DO bi = myBxLo(myThid), myBxHi(myThid)
            DO k = 1, myNr
             DO j=1,sNy
              DO i=1,sNx
                active_data_t(i,j,k,bi,bj) = 0. _d 0
              ENDDO
             ENDDO
            ENDDO
           ENDDO
          ENDDO

          adpref = 'ad'
          CALL ADD_PREFIX( adpref, activeVar_file, adfname )
          CALL MDS_WRITE_FIELD(
     I                adfname, prec, globalFile, useCurrentDir,
     I                'RL', Nr, 1, myNr,
     I                active_data_t, dummyRS,
     I                iRec, myOptimIter, myThid )

        ENDIF

      ENDIF

C     >>>>>>>>>>>>>>>>>>> ADJOINT RUN <<<<<<<<<<<<<<<<<<<
      IF (theSimulationMode .EQ. REVERSE_SIMULATION) THEN

        CALL MDS_READ_FIELD(
     I                activeVar_file, prec, useCurrentDir,
     I                'RL', Nr, 1, myNr,
     O                active_data_t, dummyRS,
     I                iRec, myThid )

C     Add active_var from appropriate location to data.
        DO bj = myByLo(myThid), myByHi(myThid)
         DO bi = myBxLo(myThid), myBxHi(myThid)
          DO k = 1, myNr
           DO j=1,sNy
            DO i=1,sNx
              active_data_t(i,j,k,bi,bj) = active_data_t(i,j,k,bi,bj)
     &                                   + active_var(i,j,k,bi,bj)
            ENDDO
           ENDDO
          ENDDO
         ENDDO
        ENDDO

C     Store the result on disk.
        w_globFile = .FALSE.
        CALL MDS_WRITE_FIELD(
     I                activeVar_file, prec, w_globFile, useCurrentDir,
     I                'RL', Nr, 1, myNr,
     I                active_data_t, dummyRS,
     I                jRec, myOptimIter, myThid )

C     Set active_var to zero.
        DO bj = myByLo(myThid), myByHi(myThid)
         DO bi = myBxLo(myThid), myBxHi(myThid)
          DO k = 1, myNr
           DO j=1,sNy
            DO i=1,sNx
              active_var(i,j,k,bi,bj) = 0 _d 0
            ENDDO
           ENDDO
          ENDDO
         ENDDO
        ENDDO

      ENDIF

C     >>>>>>>>>>>>>>>>>>> TANGENT RUN <<<<<<<<<<<<<<<<<<<
      IF (theSimulationMode .EQ. TANGENT_SIMULATION) THEN
C     Read the active variable from file.
        CALL MDS_READ_FIELD(
     I                activeVar_file, prec, useCurrentDir,
     I                'RL', myNr, 1, myNr,
     O                active_var, dummyRS,
     I                iRec, myThid )
      ENDIF

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: ACTIVE_READ_3D_RS
C     !INTERFACE:
      SUBROUTINE ACTIVE_READ_3D_RS(
     I                          activeVar_file,
     O                          active_var,
     I                          globalFile,
     I                          useCurrentDir,
     I                          lAdInit,
     I                          iRec,
     I                          myNr,
     I                          theSimulationMode,
     I                          myOptimIter,
     I                          myThid )

C     !DESCRIPTION: \bv
C     ==================================================================
C     SUBROUTINE ACTIVE_READ_3D_RS
C     ==================================================================
C     o Read an active 3D _RS variable from file.
C     The variable *globalfile* can be used as a switch, which allows
C     to read from a global file. The adjoint files are, however, always
C     treated as tiled files.
C     started: Christian Eckert eckert@mit.edu    Jan-1999
C     ==================================================================
C     SUBROUTINE ACTIVE_READ_3D_RS
C     ==================================================================
C     \ev

C     !USES:
      IMPLICIT NONE

C     == global variables ==
#include "EEPARAMS.h"
#include "SIZE.h"
#include "PARAMS.h"
#include "CTRL_SIZE.h"
#include "CTRL.h"

C     !INPUT/OUTPUT PARAMETERS:
C     activeVar_file :: filename
C     active_var     :: array
C     globalFile     ::
C     useCurrentDir  :: always read from the current directory
C                        (even if "mdsioLocalDir" is set)
C     lAdInit        :: initialisation of corresponding adjoint variable
C                        and write to active file
C     iRec           :: record number
C     myNr           :: vertical array dimension
C     theSimulationMode :: forward mode or reverse mode simulation
C     myOptimIter    :: number of optimization iteration (default: 0)
C     myThid         :: thread number for this instance
      CHARACTER*(*) activeVar_file
      INTEGER  myNr
      _RS      active_var(1-OLx:sNx+OLx,1-OLy:sNy+OLy,myNr,nSx,nSy)
      LOGICAL  globalFile
      LOGICAL  useCurrentDir
      LOGICAL  lAdInit
      INTEGER  iRec
      INTEGER  theSimulationMode
      INTEGER  myOptimIter
      INTEGER  myThid

C     !LOCAL VARIABLES:
      CHARACTER*(2)  adpref
      CHARACTER*(MAX_LEN_FNAM) adfname
      INTEGER bi,bj
      INTEGER i,j,k
      INTEGER jRec
      INTEGER prec
      LOGICAL w_globFile
      _RS  active_data_t(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      _RL  dummyRL(1)
CEOP

C     force 64-bit io
      prec = ctrlprec
      jRec = -ABS(iRec)

C     >>>>>>>>>>>>>>>>>>> FORWARD RUN <<<<<<<<<<<<<<<<<<<
      IF (theSimulationMode .EQ. FORWARD_SIMULATION) THEN

C     Read the active variable from file.
        CALL MDS_READ_FIELD(
     I                activeVar_file, prec, useCurrentDir,
     I                'RS', myNr, 1, myNr,
     O                dummyRL, active_var,
     I                iRec, myThid )

        IF ( lAdInit ) THEN
C     Initialise the corresponding adjoint variable on the
C     adjoint variable file. These files are tiled.

          DO bj = myByLo(myThid), myByHi(myThid)
           DO bi = myBxLo(myThid), myBxHi(myThid)
            DO k = 1, myNr
             DO j=1,sNy
              DO i=1,sNx
                active_data_t(i,j,k,bi,bj) = 0. _d 0
              ENDDO
             ENDDO
            ENDDO
           ENDDO
          ENDDO

          adpref = 'ad'
          CALL ADD_PREFIX( adpref, activeVar_file, adfname )
          CALL MDS_WRITE_FIELD(
     I                adfname, prec, globalFile, useCurrentDir,
     I                'RS', Nr, 1, myNr,
     I                dummyRL, active_data_t,
     I                iRec, myOptimIter, myThid )

        ENDIF

      ENDIF

C     >>>>>>>>>>>>>>>>>>> ADJOINT RUN <<<<<<<<<<<<<<<<<<<
      IF (theSimulationMode .EQ. REVERSE_SIMULATION) THEN

        CALL MDS_READ_FIELD(
     I                activeVar_file, prec, useCurrentDir,
     I                'RS', Nr, 1, myNr,
     O                dummyRL, active_data_t,
     I                iRec, myThid )

C     Add active_var from appropriate location to data.
        DO bj = myByLo(myThid), myByHi(myThid)
         DO bi = myBxLo(myThid), myBxHi(myThid)
          DO k = 1, myNr
           DO j=1,sNy
            DO i=1,sNx
              active_data_t(i,j,k,bi,bj) = active_data_t(i,j,k,bi,bj)
     &                                   + active_var(i,j,k,bi,bj)
            ENDDO
           ENDDO
          ENDDO
         ENDDO
        ENDDO

C     Store the result on disk.
        w_globFile = .FALSE.
        CALL MDS_WRITE_FIELD(
     I                activeVar_file, prec, w_globFile, useCurrentDir,
     I                'RS', Nr, 1, myNr,
     I                dummyRL, active_data_t,
     I                jRec, myOptimIter, myThid )

C     Set active_var to zero.
        DO bj = myByLo(myThid), myByHi(myThid)
         DO bi = myBxLo(myThid), myBxHi(myThid)
          DO k = 1, myNr
           DO j=1,sNy
            DO i=1,sNx
              active_var(i,j,k,bi,bj) = 0 _d 0
            ENDDO
           ENDDO
          ENDDO
         ENDDO
        ENDDO

      ENDIF

C     >>>>>>>>>>>>>>>>>>> TANGENT RUN <<<<<<<<<<<<<<<<<<<
      IF (theSimulationMode .EQ. TANGENT_SIMULATION) THEN
C     Read the active variable from file.
        CALL MDS_READ_FIELD(
     I                activeVar_file, prec, useCurrentDir,
     I                'RS', myNr, 1, myNr,
     O                dummyRL, active_var,
     I                iRec, myThid )
      ENDIF

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: ACTIVE_READ_1D_RL
C     !INTERFACE:
      SUBROUTINE ACTIVE_READ_1D_RL(
     I                          activeVar_file,
     O                          active_var,
     I                          active_var_length,
     I                          lAdInit,
     I                          iRec,
     I                          theSimulationMode,
     I                          myOptimIter,
     I                          myThid )
C     !DESCRIPTION: \bv
C     ==================================================================
C     SUBROUTINE ACTIVE_READ_1D_RL
C     ==================================================================
C     o Read an active 1D _RL vector from file.
C     o Read the same 1D vector to all tiles/processes, so global by
C       nature
C     o Note: rely on implicit dynamical allocation (local array size
C       is an argument of this S/R) for local array "active_data_t"
C     Modified from 3D: Tim Smith tsmith@oden.utexas.edu Oct-2019
C     ==================================================================
C     SUBROUTINE ACTIVE_READ_1D_RL
C     ==================================================================
C     \ev

C     !USES:
      IMPLICIT NONE

C     == global variables ==
#include "EEPARAMS.h"
#include "SIZE.h"
#include "PARAMS.h"
#include "CTRL_SIZE.h"
#include "CTRL.h"

C     !INPUT/OUTPUT PARAMETERS:
C     activeVar_file :: filename
C     active_var     :: vector
C     active_var_length :: number of elements in active variable
C     useCurrentDir  :: always read from the current directory
C                        (even if "mdsioLocalDir" is set)
C     lAdInit        :: initialisation of corresponding adjoint variable
C                        and write to active file
C     theSimulationMode :: forward, tangent linear, or reverse mode simulation
C     myOptimIter    :: number of optimization iteration (default: 0)
C     myThid         :: thread number for this instance
      CHARACTER*(*) activeVar_file
      _RL      active_var(*)
      INTEGER  active_var_length
      LOGICAL  lAdInit
      INTEGER  iRec
      INTEGER  theSimulationMode
      INTEGER  myOptimIter
      INTEGER  myThid

C     !FUNCTIONS:
      INTEGER  ILNBLNK
      EXTERNAL ILNBLNK

C     !LOCAL VARIABLES:
      CHARACTER*(2)  adpref
      CHARACTER*(MAX_LEN_FNAM) adfname
      INTEGER i, bi, bj
      INTEGER jRec
      INTEGER prec
      INTEGER il
      INTEGER ioUnit
      _RS  dummyRS(1)
      _RL  active_data_t(active_var_length)
CEOP

C     force 64-bit io
      prec = ctrlprec
      jRec = -ABS(iRec)

C     set these to zero otherwise looks for tiled file
      bi=0
      bj=0

C     ioUnit = 0 => open, read, and close the file... see mdsio_readvec_loc
      ioUnit = 0

C     >>>>>>>>>>>>>>>>>>> FORWARD RUN <<<<<<<<<<<<<<<<<<<
      IF (theSimulationMode .EQ. FORWARD_SIMULATION) THEN

C     Read the active variable from file.
        CALL MDS_READVEC_LOC(
     I                activeVar_file, prec, ioUnit,
     I                'RL', active_var_length,
     O                active_var, dummyRS,
     I                bi, bj,
     I                iRec, myThid )

        IF ( lAdInit ) THEN
C     Initialise the corresponding adjoint variable on the
C     adjoint variable file. These files are tiled.

          DO i = 1, active_var_length
            active_data_t(i) = 0. _d 0
          ENDDO

          adpref = 'ad'
          il = ILNBLNK( activeVar_file )
          WRITE(adfname,'(2A)') adpref, activeVar_file(1:il)
          IF ( myProcId.EQ.0 ) THEN
            CALL MDS_WRITEVEC_LOC(
     I                adfname, prec, ioUnit,
     I                'RL', active_var_length,
     O                active_data_t, dummyRS,
     I                bi, bj,
     I                iRec, myOptimIter, myThid )

          ENDIF
        ENDIF

      ENDIF

C     >>>>>>>>>>>>>>>>>>> ADJOINT RUN <<<<<<<<<<<<<<<<<<<
      IF (theSimulationMode .EQ. REVERSE_SIMULATION) THEN

        CALL MDS_READVEC_LOC(
     I                activeVar_file, prec, ioUnit,
     I                'RL', active_var_length,
     O                active_data_t, dummyRS,
     I                bi, bj,
     I                iRec, myThid )

C     Add active_var from appropriate location to data.
        DO i = 1, active_var_length
          active_data_t(i) = active_data_t(i) + active_var(i)
        ENDDO

C     Store the result on disk.
        IF ( myProcId.EQ.0 ) THEN
          CALL MDS_WRITEVEC_LOC(
     I                activeVar_file, prec, ioUnit,
     I                'RL', active_var_length,
     O                active_data_t, dummyRS,
     I                bi, bj,
     I                jRec, myOptimIter, myThid )
        ENDIF

C     Set active_var to zero.
        DO i = 1, active_var_length
          active_data_t(i) = 0. _d 0
        ENDDO

      ENDIF

C     >>>>>>>>>>>>>>>>>>> TANGENT RUN <<<<<<<<<<<<<<<<<<<
      IF (theSimulationMode .EQ. TANGENT_SIMULATION) THEN
C     Read the active variable from file.
        CALL MDS_READVEC_LOC(
     I                activeVar_file, prec, ioUnit,
     I                'RL', active_var_length,
     O                active_var, dummyRS,
     I                bi, bj,
     I                iRec, myThid )
      ENDIF

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: ACTIVE_READ_1D_RS
C     !INTERFACE:
      SUBROUTINE ACTIVE_READ_1D_RS(
     I                          activeVar_file,
     O                          active_var,
     I                          active_var_length,
     I                          lAdInit,
     I                          iRec,
     I                          theSimulationMode,
     I                          myOptimIter,
     I                          myThid )
C     !DESCRIPTION: \bv
C     ==================================================================
C     SUBROUTINE ACTIVE_READ_1D_RS
C     ==================================================================
C     o Read an active 1D _RS vector from file.
C     o Read the same 1D vector to all tiles/processes, so global by
C       nature
C     o Note: rely on implicit dynamical allocation (local array size
C       is an argument of this S/R) for local array "active_data_t"
C     Modified from 3D: Tim Smith tsmith@oden.utexas.edu Oct-2019
C     ==================================================================
C     SUBROUTINE ACTIVE_READ_1D_RS
C     ==================================================================
C     \ev

C     !USES:
      IMPLICIT NONE

C     == global variables ==
#include "EEPARAMS.h"
#include "SIZE.h"
#include "PARAMS.h"
#include "CTRL_SIZE.h"
#include "CTRL.h"

C     !INPUT/OUTPUT PARAMETERS:
C     activeVar_file :: filename
C     active_var     :: vector
C     active_var_length :: number of elements in active variable
C     useCurrentDir  :: always read from the current directory
C                        (even if "mdsioLocalDir" is set)
C     lAdInit        :: initialisation of corresponding adjoint variable
C                        and write to active file
C     theSimulationMode :: forward, tangent linear, or reverse mode simulation
C     myOptimIter    :: number of optimization iteration (default: 0)
C     myThid         :: thread number for this instance
      CHARACTER*(*) activeVar_file
      _RS      active_var(*)
      INTEGER  active_var_length
      LOGICAL  lAdInit
      INTEGER  iRec
      INTEGER  theSimulationMode
      INTEGER  myOptimIter
      INTEGER  myThid

C     !FUNCTIONS:
      INTEGER  ILNBLNK
      EXTERNAL ILNBLNK

C     !LOCAL VARIABLES:
      CHARACTER*(2)  adpref
      CHARACTER*(MAX_LEN_FNAM) adfname
      INTEGER i, bi, bj
      INTEGER jRec
      INTEGER prec
      INTEGER il
      INTEGER ioUnit
      _RS  active_data_t(active_var_length)
      _RL  dummyRL(1)
CEOP

C     force 64-bit io
      prec = ctrlprec
      jRec = -ABS(iRec)

C     set these to zero otherwise looks for tiled file
      bi=0
      bj=0

C     ioUnit = 0 => open, read, and close the file... see mdsio_readvec_loc
      ioUnit = 0

C     >>>>>>>>>>>>>>>>>>> FORWARD RUN <<<<<<<<<<<<<<<<<<<
      IF (theSimulationMode .EQ. FORWARD_SIMULATION) THEN

C     Read the active variable from file.
        CALL MDS_READVEC_LOC(
     I                activeVar_file, prec, ioUnit,
     I                'RS', active_var_length,
     O                dummyRL, active_var,
     I                bi, bj,
     I                iRec, myThid )

        IF ( lAdInit ) THEN
C     Initialise the corresponding adjoint variable on the
C     adjoint variable file. These files are tiled.

          DO i = 1, active_var_length
            active_data_t(i) = 0. _d 0
          ENDDO

          adpref = 'ad'
          il = ILNBLNK( activeVar_file )
          WRITE(adfname,'(2A)') adpref, activeVar_file(1:il)
          IF ( myProcId.EQ.0 ) THEN
            CALL MDS_WRITEVEC_LOC(
     I                adfname, prec, ioUnit,
     I                'RS', active_var_length,
     O                dummyRL, active_data_t,
     I                bi, bj,
     I                iRec, myOptimIter, myThid )

          ENDIF
        ENDIF

      ENDIF

C     >>>>>>>>>>>>>>>>>>> ADJOINT RUN <<<<<<<<<<<<<<<<<<<
      IF (theSimulationMode .EQ. REVERSE_SIMULATION) THEN

        CALL MDS_READVEC_LOC(
     I                activeVar_file, prec, ioUnit,
     I                'RS', active_var_length,
     O                dummyRL, active_data_t,
     I                bi, bj,
     I                iRec, myThid )

C     Add active_var from appropriate location to data.
        DO i = 1, active_var_length
          active_data_t(i) = active_data_t(i) + active_var(i)
        ENDDO

C     Store the result on disk.
        IF ( myProcId.EQ.0 ) THEN
          CALL MDS_WRITEVEC_LOC(
     I                activeVar_file, prec, ioUnit,
     I                'RS', active_var_length,
     O                dummyRL, active_data_t,
     I                bi, bj,
     I                jRec, myOptimIter, myThid )

        ENDIF
C     Set active_var to zero.
        DO i = 1, active_var_length
          active_data_t(i) = 0. _d 0
        ENDDO

      ENDIF

C     >>>>>>>>>>>>>>>>>>> TANGENT RUN <<<<<<<<<<<<<<<<<<<
      IF (theSimulationMode .EQ. TANGENT_SIMULATION) THEN
C     Read the active variable from file.
        CALL MDS_READVEC_LOC(
     I                activeVar_file, prec, ioUnit,
     I                'RS', active_var_length,
     O                dummyRL, active_var,
     I                bi, bj,
     I                iRec, myThid )
      ENDIF

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: ACTIVE_WRITE_3D_RL
C     !INTERFACE:
      SUBROUTINE ACTIVE_WRITE_3D_RL(
     I                          activeVar_file,
     I                          active_var,
     I                          globalFile,
     I                          useCurrentDir,
     I                          iRec,
     I                          myNr,
     I                          theSimulationMode,
     I                          myOptimIter,
     I                          myThid )

C     !DESCRIPTION: \bv
C     ==================================================================
C     SUBROUTINE ACTIVE_WRITE_3D_RL
C     ==================================================================
C     o Write an active 3D _RL variable to a file.
C     started: Christian Eckert eckert@mit.edu    Jan-1999
C     ==================================================================
C     SUBROUTINE ACTIVE_WRITE_3D_RL
C     ==================================================================
C     \ev

C     !USES:
      IMPLICIT NONE

C     == global variables ==
#include "EEPARAMS.h"
#include "SIZE.h"
#include "PARAMS.h"
#include "CTRL_SIZE.h"
#include "CTRL.h"

C     !INPUT/OUTPUT PARAMETERS:
C     activeVar_file :: filename
C     active_var     :: array
C     globalFile     ::
C     useCurrentDir  :: always write to the current directory
C                        (even if "mdsioLocalDir" is set)
C     iRec           :: record number
C     myNr           :: vertical array dimension
C     theSimulationMode :: forward mode or reverse mode simulation
C     myOptimIter    :: number of optimization iteration (default: 0)
C     myThid         :: thread number for this instance
      CHARACTER*(*) activeVar_file
      INTEGER  myNr
      _RL      active_var(1-OLx:sNx+OLx,1-OLy:sNy+OLy,myNr,nSx,nSy)
      LOGICAL  globalFile
      LOGICAL  useCurrentDir
      INTEGER  iRec
      INTEGER  theSimulationMode
      INTEGER  myOptimIter
      INTEGER  myThid

C     !LOCAL VARIABLES:
      INTEGER  i,j,k
      INTEGER  bi,bj
      INTEGER  jRec
      INTEGER  prec
      _RS  dummyRS(1)
      _RL  active_data_t(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
CEOP

C     force 64-bit io
      prec = ctrlprec
      jRec = -ABS(iRec)

C     >>>>>>>>>>>>>>>>>>> FORWARD RUN <<<<<<<<<<<<<<<<<<<
      IF (theSimulationMode .EQ. FORWARD_SIMULATION) THEN
        CALL MDS_WRITE_FIELD(
     I                activeVar_file, prec, globalFile, useCurrentDir,
     I                'RL', myNr, 1, myNr,
     I                active_var, dummyRS,
     I                iRec, myOptimIter, myThid )
      ENDIF

C     >>>>>>>>>>>>>>>>>>> ADJOINT RUN <<<<<<<<<<<<<<<<<<<
      IF (theSimulationMode .EQ. REVERSE_SIMULATION) THEN

        CALL MDS_READ_FIELD(
     I                activeVar_file, prec, useCurrentDir,
     I                'RL', Nr, 1, myNr,
     O                active_data_t, dummyRS,
     I                iRec, myThid )

C     Add active_var from appropriate location to data.
        DO bj = myByLo(myThid), myByHi(myThid)
         DO bi = myBxLo(myThid), myBxHi(myThid)
          DO k = 1, myNr
           DO j=1,sNy
            DO i=1,sNx
              active_var(i,j,k,bi,bj) = active_var(i,j,k,bi,bj)
     &                                + active_data_t(i,j,k,bi,bj)
              active_data_t(i,j,k,bi,bj) = 0. _d 0
            ENDDO
           ENDDO
          ENDDO
         ENDDO
        ENDDO
        CALL MDS_WRITE_FIELD(
     I                activeVar_file, prec, globalFile, useCurrentDir,
     I                'RL', Nr, 1, myNr,
     I                active_data_t, dummyRS,
     I                jRec, myOptimIter, myThid )

      ENDIF

C     >>>>>>>>>>>>>>>>>>> TANGENT RUN <<<<<<<<<<<<<<<<<<<
      IF (theSimulationMode .EQ. TANGENT_SIMULATION) THEN
        CALL MDS_WRITE_FIELD(
     I                activeVar_file, prec, globalFile, useCurrentDir,
     I                'RL', myNr, 1, myNr,
     I                active_var, dummyRS,
     I                iRec, myOptimIter, myThid )
      ENDIF

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: ACTIVE_WRITE_3D_RS
C     !INTERFACE:
      SUBROUTINE ACTIVE_WRITE_3D_RS(
     I                          activeVar_file,
     I                          active_var,
     I                          globalFile,
     I                          useCurrentDir,
     I                          iRec,
     I                          myNr,
     I                          theSimulationMode,
     I                          myOptimIter,
     I                          myThid )

C     !DESCRIPTION: \bv
C     ==================================================================
C     SUBROUTINE ACTIVE_WRITE_3D_RS
C     ==================================================================
C     o Write an active 3D _RS variable to a file.
C     started: Christian Eckert eckert@mit.edu    Jan-1999
C     ==================================================================
C     SUBROUTINE ACTIVE_WRITE_3D_RS
C     ==================================================================
C     \ev

C     !USES:
      IMPLICIT NONE

C     == global variables ==
#include "EEPARAMS.h"
#include "SIZE.h"
#include "PARAMS.h"
#include "CTRL_SIZE.h"
#include "CTRL.h"

C     !INPUT/OUTPUT PARAMETERS:
C     activeVar_file :: filename
C     active_var     :: array
C     globalFile     ::
C     useCurrentDir  :: always write to the current directory
C                        (even if "mdsioLocalDir" is set)
C     iRec           :: record number
C     myNr           :: vertical array dimension
C     theSimulationMode :: forward mode or reverse mode simulation
C     myOptimIter    :: number of optimization iteration (default: 0)
C     myThid         :: thread number for this instance
      CHARACTER*(*) activeVar_file
      INTEGER  myNr
      _RS      active_var(1-OLx:sNx+OLx,1-OLy:sNy+OLy,myNr,nSx,nSy)
      LOGICAL  globalFile
      LOGICAL  useCurrentDir
      INTEGER  iRec
      INTEGER  theSimulationMode
      INTEGER  myOptimIter
      INTEGER  myThid

C     !LOCAL VARIABLES:
      INTEGER  i,j,k
      INTEGER  bi,bj
      INTEGER  jRec
      INTEGER  prec
      _RS  active_data_t(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      _RL  dummyRL(1)
CEOP

C     force 64-bit io
      prec = ctrlprec
      jRec = -ABS(iRec)

C     >>>>>>>>>>>>>>>>>>> FORWARD RUN <<<<<<<<<<<<<<<<<<<
      IF (theSimulationMode .EQ. FORWARD_SIMULATION) THEN
        CALL MDS_WRITE_FIELD(
     I                activeVar_file, prec, globalFile, useCurrentDir,
     I                'RS', myNr, 1, myNr,
     I                dummyRL, active_var,
     I                iRec, myOptimIter, myThid )
      ENDIF

C     >>>>>>>>>>>>>>>>>>> ADJOINT RUN <<<<<<<<<<<<<<<<<<<
      IF (theSimulationMode .EQ. REVERSE_SIMULATION) THEN

        CALL MDS_READ_FIELD(
     I                activeVar_file, prec, useCurrentDir,
     I                'RS', Nr, 1, myNr,
     O                dummyRL, active_data_t,
     I                iRec, myThid )

C     Add active_var from appropriate location to data.
        DO bj = myByLo(myThid), myByHi(myThid)
         DO bi = myBxLo(myThid), myBxHi(myThid)
          DO k = 1, myNr
           DO j=1,sNy
            DO i=1,sNx
              active_var(i,j,k,bi,bj) = active_var(i,j,k,bi,bj)
     &                                + active_data_t(i,j,k,bi,bj)
              active_data_t(i,j,k,bi,bj) = 0. _d 0
            ENDDO
           ENDDO
          ENDDO
         ENDDO
        ENDDO
        CALL MDS_WRITE_FIELD(
     I                activeVar_file, prec, globalFile, useCurrentDir,
     I                'RS', Nr, 1, myNr,
     I                dummyRL, active_data_t,
     I                jRec, myOptimIter, myThid )

      ENDIF

C     >>>>>>>>>>>>>>>>>>> TANGENT RUN <<<<<<<<<<<<<<<<<<<
      IF (theSimulationMode .EQ. TANGENT_SIMULATION) THEN
        CALL MDS_WRITE_FIELD(
     I                activeVar_file, prec, globalFile, useCurrentDir,
     I                'RS', myNr, 1, myNr,
     I                dummyRL, active_var,
     I                iRec, myOptimIter, myThid )
      ENDIF

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: ACTIVE_WRITE_1D_RL
C     !INTERFACE:
      SUBROUTINE ACTIVE_WRITE_1D_RL(
     I                          activeVar_file,
     O                          active_var,
     I                          active_var_length,
     I                          iRec,
     I                          theSimulationMode,
     I                          myOptimIter,
     I                          myThid )
C     !DESCRIPTION: \bv
C     ==================================================================
C     SUBROUTINE ACTIVE_WRITE_1D_RL
C     ==================================================================
C     o Write an active 1D _RL vector from file.
C     o Write the same 1D vector to all tiles/processes, so global by
C       nature
C     Modified from 3D: Tim Smith tsmith@oden.utexas.edu Oct-2019
C     ==================================================================
C     SUBROUTINE ACTIVE_WRITE_1D_RL
C     ==================================================================
C     \ev

C     !USES:
      IMPLICIT NONE

C     == global variables ==
#include "EEPARAMS.h"
#include "SIZE.h"
#include "PARAMS.h"
#include "CTRL_SIZE.h"
#include "CTRL.h"

C     !INPUT/OUTPUT PARAMETERS:
C     activeVar_file :: filename
C     active_var     :: vector
C     active_var_length :: number of elements in active variable
C     useCurrentDir  :: always read from the current directory
C                        (even if "mdsioLocalDir" is set)
C     theSimulationMode :: forward, tangent linear, or reverse mode simulation
C     myOptimIter    :: number of optimization iteration (default: 0)
C     myThid         :: thread number for this instance
      CHARACTER*(*) activeVar_file
      _RL      active_var(*)
      INTEGER  active_var_length
      INTEGER  iRec
      INTEGER  theSimulationMode
      INTEGER  myOptimIter
      INTEGER  myThid

C     !LOCAL VARIABLES:
      INTEGER i, bi, bj
      INTEGER jRec
      INTEGER prec
      INTEGER ioUnit
      _RS  dummyRS(1)
      _RL  active_data_t(active_var_length)
CEOP

C     force 64-bit io
      prec = ctrlprec
      jRec = -ABS(iRec)

C     set these to zero otherwise mdsio_read/writevec_loc looks for tiled file
      bi=0
      bj=0

C     ioUnit = 0 => open, read, and close the file... see mdsio_readvec_loc
      ioUnit = 0

C     >>>>>>>>>>>>>>>>>>> FORWARD RUN <<<<<<<<<<<<<<<<<<<
      IF (theSimulationMode .EQ. FORWARD_SIMULATION) THEN

C     Read the active variable from file.
        IF ( myProcId.EQ.0 ) THEN
          CALL MDS_WRITEVEC_LOC(
     I                activeVar_file, prec, ioUnit,
     I                'RL', active_var_length,
     O                active_var, dummyRS,
     I                bi, bj,
     I                iRec, myOptimIter, myThid )

        ENDIF
      ENDIF

C     >>>>>>>>>>>>>>>>>>> ADJOINT RUN <<<<<<<<<<<<<<<<<<<
      IF (theSimulationMode .EQ. REVERSE_SIMULATION) THEN

        CALL MDS_READVEC_LOC(
     I                activeVar_file, prec, ioUnit,
     I                'RL', active_var_length,
     O                active_data_t, dummyRS,
     I                bi, bj,
     I                iRec, myThid )

C     Add active_var from appropriate location to data.
        DO i = 1, active_var_length
          active_var(i) = active_var(i) + active_data_t(i)
          active_data_t(i) = 0. _d 0
        ENDDO

C     Store the result on disk.
        IF ( myProcId.EQ.0 ) THEN
          CALL MDS_WRITEVEC_LOC(
     I                activeVar_file, prec, ioUnit,
     I                'RL', active_var_length,
     O                active_data_t, dummyRS,
     I                bi, bj,
     I                jRec, myOptimIter, myThid )
        ENDIF
      ENDIF

C     >>>>>>>>>>>>>>>>>>> TANGENT RUN <<<<<<<<<<<<<<<<<<<
      IF (theSimulationMode .EQ. TANGENT_SIMULATION) THEN
C     Read the active variable from file.
        IF ( myProcId.EQ.0 ) THEN
          CALL MDS_WRITEVEC_LOC(
     I                activeVar_file, prec, ioUnit,
     I                'RL', active_var_length,
     O                active_var, dummyRS,
     I                bi, bj,
     I                iRec, myOptimIter, myThid )
        ENDIF
      ENDIF

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: ACTIVE_WRITE_1D_RS
C     !INTERFACE:
      SUBROUTINE ACTIVE_WRITE_1D_RS(
     I                          activeVar_file,
     O                          active_var,
     I                          active_var_length,
     I                          iRec,
     I                          theSimulationMode,
     I                          myOptimIter,
     I                          myThid )
C     !DESCRIPTION: \bv
C     ==================================================================
C     SUBROUTINE ACTIVE_WRITE_1D_RS
C     ==================================================================
C     o Write an active 1D _RS vector from file.
C     o Write the same 1D vector to all tiles/processes, so global by
C       nature
C     Modified from 3D: Tim Smith tsmith@oden.utexas.edu Oct-2019
C     ==================================================================
C     SUBROUTINE ACTIVE_WRITE_1D_RS
C     ==================================================================
C     \ev

C     !USES:
      IMPLICIT NONE

C     == global variables ==
#include "EEPARAMS.h"
#include "SIZE.h"
#include "PARAMS.h"
#include "CTRL_SIZE.h"
#include "CTRL.h"

C     !INPUT/OUTPUT PARAMETERS:
C     activeVar_file :: filename
C     active_var     :: vector
C     active_var_length :: number of elements in active variable
C     useCurrentDir  :: always read from the current directory
C                        (even if "mdsioLocalDir" is set)
C     theSimulationMode :: forward, tangent linear, or reverse mode simulation
C     myOptimIter    :: number of optimization iteration (default: 0)
C     myThid         :: thread number for this instance
      CHARACTER*(*) activeVar_file
      _RS      active_var(*)
      INTEGER  active_var_length
      INTEGER  iRec
      INTEGER  theSimulationMode
      INTEGER  myOptimIter
      INTEGER  myThid

C     !LOCAL VARIABLES:
      INTEGER i, bi, bj
      INTEGER jRec
      INTEGER prec
      INTEGER ioUnit
      _RS  active_data_t(active_var_length)
      _RL  dummyRL(1)
CEOP

C     force 64-bit io
      prec = ctrlprec
      jRec = -ABS(iRec)

C     set these to zero otherwise mdsio_read/writevec_loc looks for tiled file
      bi=0
      bj=0

C     ioUnit = 0 => open, read, and close the file... see mdsio_readvec_loc
      ioUnit = 0

C     >>>>>>>>>>>>>>>>>>> FORWARD RUN <<<<<<<<<<<<<<<<<<<
      IF (theSimulationMode .EQ. FORWARD_SIMULATION) THEN

C     Read the active variable from file.
        IF ( myProcId.EQ.0 ) THEN
          CALL MDS_WRITEVEC_LOC(
     I                activeVar_file, prec, ioUnit,
     I                'RS', active_var_length,
     O                dummyRL, active_var,
     I                bi, bj,
     I                iRec, myOptimIter, myThid )

        ENDIF
      ENDIF

C     >>>>>>>>>>>>>>>>>>> ADJOINT RUN <<<<<<<<<<<<<<<<<<<
      IF (theSimulationMode .EQ. REVERSE_SIMULATION) THEN

        CALL MDS_READVEC_LOC(
     I                activeVar_file, prec, ioUnit,
     I                'RL', active_var_length,
     O                dummyRL, active_data_t,
     I                bi, bj,
     I                iRec, myThid )

C     Add active_var from appropriate location to data.
        DO i = 1, active_var_length
          active_var(i) = active_var(i) + active_data_t(i)
          active_data_t(i) = 0. _d 0
        ENDDO

C     Store the result on disk.
        IF ( myProcId.EQ.0 ) THEN
          CALL MDS_WRITEVEC_LOC(
     I                activeVar_file, prec, ioUnit,
     I                'RL', active_var_length,
     O                dummyRL, active_data_t,
     I                bi, bj,
     I                jRec, myOptimIter, myThid )

        ENDIF
      ENDIF

C     >>>>>>>>>>>>>>>>>>> TANGENT RUN <<<<<<<<<<<<<<<<<<<
      IF (theSimulationMode .EQ. TANGENT_SIMULATION) THEN
C     Read the active variable from file.
        IF ( myProcId.EQ.0 ) THEN
          CALL MDS_WRITEVEC_LOC(
     I                activeVar_file, prec, ioUnit,
     I                'RL', active_var_length,
     O                dummyRL, active_var,
     I                bi, bj,
     I                iRec, myOptimIter, myThid )
        ENDIF
      ENDIF

      RETURN
      END

#include "MOM_VECINV_OPTIONS.h"

      SUBROUTINE MOM_VI_HDISSIP(
     I        bi, bj, k,
     I        hDiv, vort3, dStar, zStar, hFacZ,
     I        viscAh_Z, viscAh_D, viscA4_Z, viscA4_D,
     I        harmonic, biharmonic, useVariableViscosity,
     O        uDissip, vDissip,
     I        myThid )

      IMPLICIT NONE

C     Calculate horizontal dissipation terms
C     [del^2 - del^4] (u,v)

C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"

C     == Routine arguments ==
      INTEGER bi, bj, k
      _RL hDiv (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL vort3(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL dStar(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL zStar(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RS hFacZ(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL viscAh_Z(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL viscAh_D(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL viscA4_Z(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL viscA4_D(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      LOGICAL harmonic, biharmonic, useVariableViscosity
      _RL uDissip(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL vDissip(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER myThid

C     == Local variables ==
      INTEGER i, j
      _RL Zip, Zij, Zpj, Dim, Dij, Dmj, uD2, vD2
      _RL uD4(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL vD4(1-OLx:sNx+OLx,1-OLy:sNy+OLy)

C     - Laplacian  terms
      IF ( harmonic ) THEN
C This bit scales the harmonic dissipation operator to be proportional
C to the grid-cell area over the time-step. viscAh is then non-dimensional
C and should be less than 1/8, for example viscAh=0.01
       IF ( useVariableViscosity ) THEN
        DO j=2-OLy,sNy+OLy-1
         DO i=2-OLx,sNx+OLx-1

          Dij=hDiv( i , j )*viscAh_D(i,j)
          Dim=hDiv( i ,j-1)*viscAh_D(i,j-1)
          Dmj=hDiv(i-1, j )*viscAh_D(i-1,j)
          Zij=hFacZ( i , j )*vort3( i , j )*viscAh_Z(i,j)
          Zip=hFacZ( i ,j+1)*vort3( i ,j+1)*viscAh_Z(i,j+1)
          Zpj=hFacZ(i+1, j )*vort3(i+1, j )*viscAh_Z(i+1,j)

          uD2 = (
     &               cosFacU(j,bi,bj)*( Dij-Dmj )*recip_DXC(i,j,bi,bj)
     &     -_recip_hFacW(i,j,k,bi,bj)*( Zip-Zij )*recip_DYG(i,j,bi,bj) )
          vD2 = (
     &      _recip_hFacS(i,j,k,bi,bj)*( Zpj-Zij )*recip_DXG(i,j,bi,bj)
     &                                           *cosFacV(j,bi,bj)
     &                               +( Dij-Dim )*recip_DYC(i,j,bi,bj) )

          uDissip(i,j) = uD2*maskW(i,j,k,bi,bj)*recip_deepFacC(k)
          vDissip(i,j) = vD2*maskS(i,j,k,bi,bj)*recip_deepFacC(k)

         ENDDO
        ENDDO
       ELSE
        DO j=2-OLy,sNy+OLy-1
         DO i=2-OLx,sNx+OLx-1

          Dim=hDiv( i ,j-1)
          Dij=hDiv( i , j )
          Dmj=hDiv(i-1, j )
          Zip=hFacZ( i ,j+1)*vort3( i ,j+1)
          Zij=hFacZ( i , j )*vort3( i , j )
          Zpj=hFacZ(i+1, j )*vort3(i+1, j )

          uD2 = viscAhD*
     &               cosFacU(j,bi,bj)*( Dij-Dmj )*recip_DXC(i,j,bi,bj)
     &        - viscAhZ*_recip_hFacW(i,j,k,bi,bj)*
     &                                ( Zip-Zij )*recip_DYG(i,j,bi,bj)
          vD2 = viscAhZ*_recip_hFacS(i,j,k,bi,bj)*
     &               cosFacV(j,bi,bj)*( Zpj-Zij )*recip_DXG(i,j,bi,bj)
     &        + viscAhD*              ( Dij-Dim )*recip_DYC(i,j,bi,bj)

          uDissip(i,j) = uD2*maskW(i,j,k,bi,bj)*recip_deepFacC(k)
          vDissip(i,j) = vD2*maskS(i,j,k,bi,bj)*recip_deepFacC(k)

         ENDDO
        ENDDO
       ENDIF
#ifdef ALLOW_DIAGNOSTICS
       IF ( useDiagnostics ) THEN
        CALL DIAGNOSTICS_FILL( uDissip,'Um_hDis2', k,1,2,bi,bj, myThid )
        CALL DIAGNOSTICS_FILL( vDissip,'Vm_hDis2', k,1,2,bi,bj, myThid )
       ENDIF
#endif /* ALLOW_DIAGNOSTICS */
      ELSE
       DO j=2-OLy,sNy+OLy-1
        DO i=2-OLx,sNx+OLx-1
         uDissip(i,j) = 0.
         vDissip(i,j) = 0.
        ENDDO
       ENDDO
      ENDIF

C     - Bi-harmonic terms
      IF ( biharmonic ) THEN
C--   initialize local arrays
       DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
         uD4(i,j) = 0. _d 0
         vD4(i,j) = 0. _d 0
        ENDDO
       ENDDO

C This bit scales the harmonic dissipation operator to be proportional
C to the grid-cell area over the time-step. viscAh is then non-dimensional
C and should be less than 1/8, for example viscAh=0.01
       IF ( useVariableViscosity ) THEN
        DO j=2-OLy,sNy+OLy-1
         DO i=2-OLx,sNx+OLx-1

#ifdef MOM_VI_ORIGINAL_VISCA4
          Dim=dyF( i ,j-1,bi,bj)*dStar( i ,j-1)
          Dij=dyF( i , j ,bi,bj)*dStar( i , j )
          Dmj=dyF(i-1, j ,bi,bj)*dStar(i-1, j )

          Zip=dxV( i ,j+1,bi,bj)*hFacZ( i ,j+1)*zStar( i ,j+1)
          Zij=dxV( i , j ,bi,bj)*hFacZ( i , j )*zStar( i , j )
          Zpj=dxV(i+1, j ,bi,bj)*hFacZ(i+1, j )*zStar(i+1, j )
#else
          Dim=dStar( i ,j-1)
          Dij=dStar( i , j )
          Dmj=dStar(i-1, j )

          Zip=hFacZ( i ,j+1)*zStar( i ,j+1)
          Zij=hFacZ( i , j )*zStar( i , j )
          Zpj=hFacZ(i+1, j )*zStar(i+1, j )
#endif
          Dij=Dij*viscA4_D(i,j)
          Dim=Dim*viscA4_D(i,j-1)
          Dmj=Dmj*viscA4_D(i-1,j)
          Zij=Zij*viscA4_Z(i,j)
          Zip=Zip*viscA4_Z(i,j+1)
          Zpj=Zpj*viscA4_Z(i+1,j)

#ifdef MOM_VI_ORIGINAL_VISCA4
          uD4(i,j) = recip_rAw(i,j,bi,bj)*(
     &                             ( (Dij-Dmj)*cosFacU(j,bi,bj) )
     &  -_recip_hFacW(i,j,k,bi,bj)*( Zip-Zij )
     &                                    )
          vD4(i,j) = recip_rAs(i,j,bi,bj)*(
     &   _recip_hFacS(i,j,k,bi,bj)*( (Zpj-Zij)*cosFacV(j,bi,bj) )
     &   +                         ( Dij-Dim )
     &                                    )
#else /* MOM_VI_ORIGINAL_VISCA4 */
          uD4(i,j) = (
     &               cosFacU(j,bi,bj)*( Dij-Dmj )*recip_DXC(i,j,bi,bj)
     &     -_recip_hFacW(i,j,k,bi,bj)*( Zip-Zij )*recip_DYG(i,j,bi,bj)
     &               )
          vD4(i,j) = (
     &      _recip_hFacS(i,j,k,bi,bj)*( Zpj-Zij )*recip_DXG(i,j,bi,bj)
     &                                           *cosFacV(j,bi,bj)
     &                               +( Dij-Dim )*recip_DYC(i,j,bi,bj)
     &               )
#endif  /* MOM_VI_ORIGINAL_VISCA4 */

         ENDDO
        ENDDO
       ELSE
        DO j=2-OLy,sNy+OLy-1
         DO i=2-OLx,sNx+OLx-1

#ifdef MOM_VI_ORIGINAL_VISCA4
          Dim=dyF( i ,j-1,bi,bj)*dStar( i ,j-1)
          Dij=dyF( i , j ,bi,bj)*dStar( i , j )
          Dmj=dyF(i-1, j ,bi,bj)*dStar(i-1, j )

          Zip=dxV( i ,j+1,bi,bj)*hFacZ( i ,j+1)*zStar( i ,j+1)
          Zij=dxV( i , j ,bi,bj)*hFacZ( i , j )*zStar( i , j )
          Zpj=dxV(i+1, j ,bi,bj)*hFacZ(i+1, j )*zStar(i+1, j )
#else
          Dim=dStar( i ,j-1)
          Dij=dStar( i , j )
          Dmj=dStar(i-1, j )

          Zip=hFacZ( i ,j+1)*zStar( i ,j+1)
          Zij=hFacZ( i , j )*zStar( i , j )
          Zpj=hFacZ(i+1, j )*zStar(i+1, j )
#endif

#ifdef MOM_VI_ORIGINAL_VISCA4
          uD4(i,j) = recip_rAw(i,j,bi,bj)*(
     &                             viscA4D*( Dij-Dmj )*cosFacU(j,bi,bj)
     &  -_recip_hFacW(i,j,k,bi,bj)*viscA4Z*( Zip-Zij )
     &                                    )
          vD4(i,j) = recip_rAs(i,j,bi,bj)*(
     &   _recip_hFacS(i,j,k,bi,bj)*viscA4Z*( Zpj-Zij )*cosFacV(j,bi,bj)
     &   +                         viscA4D*( Dij-Dim )
     &                                    )
#else /* MOM_VI_ORIGINAL_VISCA4 */
          uD4(i,j) = viscA4D*
     &               cosFacU(j,bi,bj)*( Dij-Dmj )*recip_DXC(i,j,bi,bj)
     &             - viscA4Z*_recip_hFacW(i,j,k,bi,bj)*
     &                                ( Zip-Zij )*recip_DYG(i,j,bi,bj)
          vD4(i,j) = viscA4Z*_recip_hFacS(i,j,k,bi,bj)*
     &               cosFacV(j,bi,bj)*( Zpj-Zij )*recip_DXG(i,j,bi,bj)
     &             + viscA4D*         ( Dij-Dim )*recip_DYC(i,j,bi,bj)
#endif /* MOM_VI_ORIGINAL_VISCA4 */

         ENDDO
        ENDDO
       ENDIF
       DO j=2-OLy,sNy+OLy-1
        DO i=2-OLx,sNx+OLx-1
          uD4(i,j) = -uD4(i,j)*maskW(i,j,k,bi,bj)*recip_deepFacC(k)
          vD4(i,j) = -vD4(i,j)*maskS(i,j,k,bi,bj)*recip_deepFacC(k)
          uDissip(i,j) = uDissip(i,j) + uD4(i,j)
          vDissip(i,j) = vDissip(i,j) + vD4(i,j)
        ENDDO
       ENDDO
#ifdef ALLOW_DIAGNOSTICS
       IF ( useDiagnostics ) THEN
        CALL DIAGNOSTICS_FILL( uD4, 'Um_hDis4', k,1,2,bi,bj, myThid )
        CALL DIAGNOSTICS_FILL( vD4, 'Vm_hDis4', k,1,2,bi,bj, myThid )
       ENDIF
#endif /* ALLOW_DIAGNOSTICS */
      ENDIF

      RETURN
      END

#include "STREAMICE_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

CBOP
      SUBROUTINE STREAMICE_CG_SOLVE_PETSC(
     U                               cg_Uin,     ! x-velocities
     U                               cg_Vin,     ! y-velocities
     I                               cg_Bu,      ! force in x dir
     I                               cg_Bv,      ! force in y dir
     I                               A_uu,       ! section of matrix that multiplies u and projects on u
     I                               A_uv,       ! section of matrix that multiplies v and projects on u
     I                               A_vu,       ! section of matrix that multiplies u and projects on v
     I                               A_vv,       ! section of matrix that multiplies v and projects on v
     I                               tolerance,
     O                               iters,
     I                               maxIter,
     I                               myThid )

C     *============================================================*
C     | SUBROUTINE                                                 |
C     | o                                                          |
C     *============================================================*

#ifdef ALLOW_PETSC
#ifdef STREAMICE_PETSC_3_8

C     THE FOLLOWING MODULES ARE PART OF THE PETSC
C     LIBRARY, USED BY STREAMICE WHEN AVAILABLE TO ACCELERATE
C     SOLVES OF LINEAR SYSTEMS

C     assumes paths
C     {petsc_dir}/include/petsc/finclude/
C     {petsc_dir}/include
C     in the include statement

#include "petsc/finclude/petsc.h"
#include "petsc/finclude/petscvec.h"
      use petscvec
#include "petsc/finclude/petscmat.h"
      use petscmat
#include "petsc/finclude/petscksp.h"
      use petscksp
#include "petsc/finclude/petscpc.h"
      use petscpc
#include "STREAMICE_PETSC_MOD.h"
      IMPLICIT NONE
# else
      IMPLICIT NONE
#include "finclude/petsc.h"
#include "STREAMICE_PETSC_MOD.h"
#endif
#endif

#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "STREAMICE.h"
#include "STREAMICE_FP.h"
#include "STREAMICE_CG.h"

C     === Global variables ===

C     !INPUT/OUTPUT ARGUMENTS
C     cg_Uin, cg_Vin - input and output velocities
C     cg_Bu, cg_Bv - driving stress
      INTEGER myThid
      INTEGER iters, maxiter
      _RL tolerance
      _RL cg_Uin (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL cg_Vin (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL cg_Bu (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL cg_Bv (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL
     & A_uu (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy,-1:1,-1:1),
     & A_vu (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy,-1:1,-1:1),
     & A_uv (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy,-1:1,-1:1),
     & A_vv (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy,-1:1,-1:1)

#ifdef ALLOW_AUTODIFF
#ifdef ALLOW_STREAMICE_FP_ADJ
       LOGICAL create_mat, destroy_mat
#endif
#endif

#ifdef ALLOW_STREAMICE
#ifdef ALLOW_PETSC
C     LOCAL VARIABLES
      INTEGER i, j, bi, bj, cg_halo, conv_flag
      INTEGER iter, is, js, ie, je, colx, coly, k
      _RL dot_p1, dot_p2, resid, resid_0
      _RL dot_p1_tile (nSx,nSy)
      _RL dot_p2_tile (nSx,nSy)
      CHARACTER*(MAX_LEN_MBUF) msgBuf

      INTEGER indices(2*(sNx*nSx*sNy*nSy))
      INTEGER n_dofs_cum_sum (0:nPx*nPy-1), idx(1)
      _RL rhs_values(2*(sNx*nSx*sNy*nSy))
      _RL solution_values(2*(sNx*nSx*sNy*nSy))
c      _RL mat_values (2*Nx*Ny,2*(sNx*nSx*sNy*nSy))
      _RL mat_values (18,1), mat_val_return(1)
      INTEGER indices_col(18)
      INTEGER local_dofs, global_dofs, dof_index, dof_index_col
      INTEGER local_offset
#ifdef STREAMICE_PETSC_3_8
      INTEGER local_null
#endif
c      Mat matrix
c      KSP ksp
c      PC  pc
      PC  subpc
#ifdef STREAMICE_PETSC_3_8
      KSP subksp
#else
      KSP subksp(1)
#endif
      Vec rhs
      Vec solution
      PetscErrorCode ierr
#ifdef ALLOW_USE_MPI
      integer mpiRC, mpiMyWid
#endif

#ifdef ALLOW_USE_MPI

      CALL MPI_COMM_RANK( MPI_COMM_WORLD, mpiMyWId, mpiRC )
      local_dofs = n_dofs_process (mpiMyWid)
      global_dofs = 0

      n_dofs_cum_sum(0) = 0
      DO i=0,nPx*nPy-1
       global_dofs = global_dofs + n_dofs_process (i)
       if (i.ge.1) THEN
         n_dofs_cum_sum(i) = n_dofs_cum_sum(i-1)+
     &                     n_dofs_process(i-1)
       endif
      ENDDO
      local_offset = n_dofs_cum_sum(mpimywid)

#else

      local_dofs = n_dofs_process (0)
      global_dofs = local_dofs
      local_offset = 0

#endif
c      call petscInitialize(PETSC_NULL_CHARACTER,ierr)

c----------------------

      CALL TIMER_START ('STREAMICE_PETSC_SETUP',myThid)

      call VecCreate(PETSC_COMM_WORLD, rhs, ierr)
      call VecSetSizes(rhs, local_dofs, global_dofs, ierr)
      call VecSetType(rhs, VECMPI, ierr)

      call VecCreate(PETSC_COMM_WORLD, solution, ierr)
      call VecSetSizes(solution, local_dofs, global_dofs, ierr)
      call VecSetType(solution, VECMPI, ierr)

      do i=1,local_dofs
        indices(i) = i-1 + local_offset
      end do
      do i=1,2*nSx*nSy*sNx*sNy
        rhs_values (i) = 0. _d 0
        solution_values (i) = 0. _d 0
      enddo

c gather rhs and initial guess values to populate petsc vectors

      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
        DO j=1,sNy
         DO i=1,sNx

          dof_index = INT(streamice_petsc_dofs_u(i,j,bi,bj))
     &                - local_offset

          if (dof_index.ge.0) THEN

           rhs_values(dof_index+1) = cg_Bu(i,j,bi,bj)
           solution_values(dof_index+1) = cg_Uin(i,j,bi,bj)

          endif

c---------------

          dof_index = INT(streamice_petsc_dofs_v(i,j,bi,bj))
     &                - local_offset

          if (dof_index.ge.0) THEN

           rhs_values(dof_index+1) = cg_Bv(i,j,bi,bj)
           solution_values(dof_index+1) = cg_Vin(i,j,bi,bj)

          endif

         ENDDO
        ENDDO
       ENDDO
      ENDDO

      call VecSetValues(rhs, local_dofs, indices, rhs_values,
     &                  INSERT_VALUES, ierr)
      call VecAssemblyBegin(rhs, ierr)
      call VecAssemblyEnd(rhs, ierr)

      call VecSetValues(solution, local_dofs, indices,
     &                  solution_values, INSERT_VALUES, ierr)
      call VecAssemblyBegin(solution, ierr)
      call VecAssemblyEnd(solution, ierr)

#ifdef ALLOW_AUTODIFF
#ifdef ALLOW_STREAMICE_FP_ADJ
#ifdef ALLOW_PETSC
      if (STREAMICE_need2createmat) then
#endif
#endif
#endif

c     IF USING v3.0 THEN
c     call MatCreateMPIAIJ (PETSC_COMM_WORLD,
      call MatCreateAIJ (PETSC_COMM_WORLD,
     &                      local_dofs, local_dofs,
     &                      global_dofs, global_dofs,
     &                      18, PETSC_NULL_INTEGER,
     &                      18, PETSC_NULL_INTEGER,
     &                      matrix, ierr)

c populate petsc matrix

      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
        DO j=1,sNy
         DO i=1,sNx

          dof_index = INT(streamice_petsc_dofs_u(i,j,bi,bj))
c     &                - local_offset

          IF (dof_index .ge. 0) THEN

           DO k=1,18
            indices_col(k) = 0
            mat_values(k,1) = 0. _d 0
           ENDDO
           k=0

           DO coly=-1,1
            DO colx=-1,1

             dof_index_col = streamice_petsc_dofs_u(i+colx,j+coly,bi,bj)

             if (dof_index_col.ge.0) THEN
c               pscal = A_uu(i,j,bi,bj,colx,coly)
c               CALL MatSetValue (matrix,dof_index, dof_index_col,
c     &              pscal,INSERT_VALUES,ierr)
                k=k+1
                mat_values (k,1) = A_uu(i,j,bi,bj,colx,coly)
                indices_col (k) = dof_index_col
             endif

             dof_index_col = streamice_petsc_dofs_v(i+colx,j+coly,bi,bj)

             if (dof_index_col.ge.0) THEN
c               CALL MatSetValue (matrix,dof_index, dof_index_col,
c     &              A_uv(i,j,bi,bj,colx,coly),INSERT_VALUES,ierr)
                k=k+1
                mat_values (k,1) = A_uv(i,j,bi,bj,colx,coly)
                indices_col (k) = dof_index_col
             endif

            ENDDO
           ENDDO

#ifdef STREAMICE_PETSC_3_8
           call MatSetValues1n (matrix, 1, dof_index, k, indices_col,
#else
           call MatSetValues (matrix, 1, dof_index, k, indices_col,
#endif
     &                        mat_values,INSERT_VALUES,ierr)

          ENDIF

c ----------------------------------------------

          dof_index = INT(streamice_petsc_dofs_v(i,j,bi,bj))
c     &                - local_offset

          IF (dof_index .ge. 0) THEN

           DO k=1,18
            indices_col(k) = 0
            mat_values(k,1) = 0. _d 0
           ENDDO
           k=0

           DO coly=-1,1
            DO colx=-1,1

             dof_index_col = streamice_petsc_dofs_u(i+colx,j+coly,bi,bj)

             if (dof_index_col.ge.0) THEN
c               CALL MatSetValue (matrix,dof_index, dof_index_col,
c     &              A_vu(i,j,bi,bj,colx,coly),INSERT_VALUES,ierr)
                k=k+1
                mat_values (k,1) = A_vu(i,j,bi,bj,colx,coly)
                indices_col (k) = dof_index_col
             endif

             dof_index_col = streamice_petsc_dofs_v(i+colx,j+coly,bi,bj)

             if (dof_index_col.ge.0) THEN
c               CALL MatSetValue (matrix,dof_index, dof_index_col,
c     &              A_vv(i,j,bi,bj,colx,coly),INSERT_VALUES,ierr)
                k=k+1
                mat_values (k,1) = A_vv(i,j,bi,bj,colx,coly)
                indices_col (k) = dof_index_col
             endif

            ENDDO
           ENDDO

#ifdef STREAMICE_PETSC_3_8
           call MatSetValues1n (matrix, 1, dof_index, k, indices_col,
#else
           call MatSetValues (matrix, 1, dof_index, k, indices_col,
#endif
     &                        mat_values,INSERT_VALUES,ierr)
          ENDIF

         ENDDO
        ENDDO
       ENDDO
      ENDDO

      call MatAssemblyBegin(matrix,MAT_FINAL_ASSEMBLY,ierr)
      call MatAssemblyEnd(matrix,MAT_FINAL_ASSEMBLY,ierr)

      call KSPCreate(PETSC_COMM_WORLD, ksp, ierr)
#ifdef STREAMICE_PETSC_3_8
      call KSPSetOperators(ksp, matrix, matrix,
     &                      ierr)
#else
      call KSPSetOperators(ksp, matrix, matrix,
     &                     DIFFERENT_NONZERO_PATTERN,ierr)
#endif

      IF (PETSC_PRECOND_TYPE.eq.'MUMPS') then
       call KSPSetType(ksp,KSPPREONLY,ierr)
      ELSE
       SELECT CASE (PETSC_SOLVER_TYPE)
       CASE ('CG')
       PRINT *, "PETSC SOLVER: SELECTED CG"
       call KSPSetType(ksp, KSPCG, ierr)
       CASE ('GMRES')
       PRINT *, "PETSC SOLVER: SELECTED GMRES"
       call KSPSetType(ksp, KSPGMRES, ierr)
       CASE ('BICG')
       PRINT *, "PETSC SOLVER: SELECTED BICG"
       call KSPSetType(ksp, KSPBCGS, ierr)
       CASE DEFAULT
       PRINT *, "PETSC SOLVER: SELECTED DEFAULT"
       call KSPSetType(ksp, KSPCG, ierr)
       END SELECT
      ENDIF

      call KSPGetPC(ksp, pc, ierr)
      call KSPSetTolerances(ksp,tolerance,
     &     PETSC_DEFAULT_REAL,
     &     PETSC_DEFAULT_REAL,
     &     maxiter,ierr)

      SELECT CASE (PETSC_PRECOND_TYPE)
       CASE ('BLOCKJACOBI')
       PRINT *, "PETSC PRECOND: SELECTED BJACOBI"
       call PCSetType(pc, PCBJACOBI, ierr)
       call kspsetup (ksp, ierr)
#ifdef STREAMICE_PETSC_3_8
       local_null =0 !PETSC_NULL_INTEGER
       call PCBJacobiGetSubKSP1 (pc,local_null,local_null,
#else
       call PCBJacobiGetSubKSP1 (pc,PETSC_NULL_INTEGER,
     &                           PETSC_NULL_INTEGER,
#endif
     &                             subksp,ierr);
       call KSPGetPC (subksp, subpc, ierr)
       call PCSetType (subpc, PCICC, ierr)
       call PCFactorSetLevels(subpc,streamice_petsc_pcfactorlevels,
     &  ierr)
       CASE ('JACOBI')
       PRINT *, "PETSC PRECOND: SELECTED JACOBI"
       call PCSetType(pc, PCJACOBI, ierr)
       CASE ('ILU')
       PRINT *, "PETSC PRECOND: SELECTED ILU"
       call PCSetType(pc, PCILU, ierr)

       CASE ('GAMG')
       PRINT *, "PETSC PRECOND: SELECTED GAMG"
       call PCSetType(pc, PCGAMG, ierr)
       call PCGAMGSetCoarseEqLim(pc,10000,ierr)
C       call PCGAMGSetSymGraph(pc, PETSC_TRUE,ierr)
       call PCGAMGSetNSmooths(pc, 0,ierr)
C       call PCGAMGSetThreshold(pc, .001,ierr)
C       call PCGAMGSetReuseProl(pc,PETSC_FALSE,ierr)
       call kspsetup (ksp, ierr)

       CASE ('MUMPS')
       PRINT *, "PETSC PRECOND: SELECTED MUMPS"
       call PCSetType(pc,PCLU,ierr)
       call PCFactorSetMatSolverType(pc,MATSOLVERMUMPS,ierr)
       call PCFactorSetUpMatSolverType(pc,ierr)
       call PCFactorGetMatrix(pc,mumpsFac,ierr)
       call MatMumpsSetIcntl(mumpsfac,24,1,ierr)
       call kspsetup (ksp, ierr)

       CASE DEFAULT
       PRINT *, "PETSC PRECOND: SELECTED DEFAULT"
       call PCSetType(pc, PCBJACOBI, ierr)
      END SELECT

      CALL TIMER_STOP ('STREAMICE_PETSC_SETUP',myThid)
#ifdef ALLOW_AUTODIFF
#ifdef ALLOW_STREAMICE_FP_ADJ
#ifdef ALLOW_PETSC
      endif
#endif
#endif
#endif

      CALL TIMER_START ('STREAMICE_PETSC_SOLVE',myThid)

      call KSPSolve(ksp, rhs, solution, ierr)

      CALL TIMER_STOP ('STREAMICE_PETSC_SOLVE',myThid)

      call KSPGetIterationNumber(ksp,iters,ierr)

      call VecGetValues(solution,local_dofs,indices,
     &      solution_values,ierr)

      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
        DO j=1,sNy
         DO i=1,sNx

          dof_index = INT(streamice_petsc_dofs_u(i,j,bi,bj))
     &                - local_offset
          if (dof_index.ge.0) THEN
           cg_Uin(i,j,bi,bj) = solution_values(dof_index+1)
          endif

          dof_index = INT(streamice_petsc_dofs_v(i,j,bi,bj))
     &                - local_offset
          if (dof_index.ge.0) THEN
           cg_Vin(i,j,bi,bj) = solution_values(dof_index+1)
          endif

         ENDDO
        ENDDO
       ENDDO
      ENDDO

#ifdef ALLOW_AUTODIFF
#ifdef ALLOW_STREAMICE_FP_ADJ
      if (streamice_need2destroymat) then
#endif
#endif
      call KSPDestroy (ksp, ierr)
      call MatDestroy (matrix, ierr)
#ifdef ALLOW_AUTODIFF
#ifdef ALLOW_STREAMICE_FP_ADJ
      endif
#endif
#endif
      call VecDestroy (rhs, ierr)
      call VecDestroy (solution, ierr)

c      call PetscFinalize(ierr)

#endif /* ALLOW_PETSC */
#endif /* ALLOW_STREAMICE */
      RETURN
      END

#include "BLING_OPTIONS.h"

CBOP
      subroutine BLING_MIN_VAL(
     I           PTR, min_val, adj, bi, bj )

C     =================================================================
C     | subroutine bling_min_val
C     | o replaces tracer values that are too small or negative
C     |   (in a separate routine so can be hidden from adjoint)
C     =================================================================

      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "GRID.h"

C     === Routine arguments ===
      INTEGER bi, bj
C     === Input ===
      _RL     PTR(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL     min_val
      _RL     adj(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
CEOP

C     == Local variables ==
      INTEGER i,j,k

       DO k=1,Nr
         DO i=1,sNx
          DO j=1,sNy
           adj(i,j,k) = PTR(i,j,k)
           PTR(i,j,k) = max( min_val*maskC(i,j,k,bi,bj), PTR(i,j,k) )
           adj(i,j,k) = PTR(i,j,k)-adj(i,j,k)
          ENDDO
         ENDDO
       ENDDO

      RETURN
      END

#include "CTRL_OPTIONS.h"

      subroutine simul(
     I                  indic,
     I                  nn,
     I                  xx,
     O                  objf,
     O                  adxx
     &                )

c     ==================================================================
c     SUBROUTINE simul
c     ==================================================================
c
c     o This routine is called by the large-scale optimization lsopt.
c
c       Input  : indic - Parameter (not used here).
c                nn    - Number of control variables.
c                xx    - Array  of control variables.
c
c       Output : objf  - Value of objective function.
c                adxx  - Gradients of objective function with respect
c                        to the control variables.
c
c
c     started: Christian Eckert eckert@mit.edu 15-Feb-2000
c
c     changed: Christian Eckert eckert@mit.edu 10-Mar-2000
c
c              - Added ECCO layout.
c
c     changed:  Patrick Heimbach heimbach@mit.edu 19-Jun-2000
c               - finished, revised and debugged
c
c     ==================================================================
c     SUBROUTINE simul
c     ==================================================================

      implicit none

c     == global variables ==

#include "EEPARAMS.h"
#include "SIZE.h"
#include "CTRL_SIZE.h"
#include "CTRL.h"

c     == routine arguments ==

      integer indic
      integer nn
      _RL   xx(nn)
      _RL   objf
      _RL   adxx(nn)

c     == local variables ==

      integer i
      _RL   adobjf

      logical lheaderonly

c     == end of interface ==

      print *, 'pathei-lsopt in simul'

c--   Call the combined modified forward model and the adjoint model.
      do i = 1,nn
        adxx(i) = 0.
      enddo

      adobjf = 1.
c
      lheaderonly = .false.

      print *, 'pathei-lsopt vor optim_readdata'

      call optim_readdata( nn, ctrlname, lheaderonly, objf,   xx )
      call optim_readdata( nn, costname, lheaderonly, objf, adxx )

      indic = indic

cph(
      print *, ' leaving simul with nn, objf = ', nn, objf
      print *, ' leaving simul with xx, adxx = ', xx(1), adxx(1)
      do i=1,nn
c         if (xx(i).EQ.'NaN') then
c            print *, 'pathei - out: i = ', i
c         end if
      end do
cph)

      return
      end

#include "COST_OPTIONS.h"

      subroutine cost_tracer( bi, bj, myThid )
C     /==========================================================\
C     | subroutine cost_tracer                                   |
C     | o this routine computes the cost function for the tiles  |
C     |   of this processor                                      |
C     |==========================================================|
C     |                                                          |
C     | Notes                                                    |
C     | =====                                                    |
C     \==========================================================/
      IMPLICIT NONE

C     == Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "DYNVARS.h"
#include "GRID.h"
#ifdef ALLOW_COST_TRACER
# ifdef ALLOW_PTRACERS
#  include "PTRACERS_SIZE.h"
#  include "PTRACERS_PARAMS.h"
#  include "PTRACERS_FIELDS.h"
# endif
#endif
#include "cost.h"

C     == Routine arguments ==
C     myThid - Thread number for this instance of the routine.
      integer bi, bj
      integer myThid

#ifdef ALLOW_COST_TRACER
#ifdef ALLOW_PTRACERS
C     == Local variables
      _RL locfc
      integer i, j, k

      locfc = 0. _d 0
      k=1
      DO j=1,sNy
         DO i=1,sNx
            locfc = locfc + hFacC(i,j,k,bi,bj)*
     &           lambdaTr1ClimRelax*ptracer(i,j,k,bi,bj,1)*
     &           rA(i,j,bi,bj)*drF(k)*dTtracerLev(k)
         ENDDO
      ENDDO

      objf_tracer(bi,bj) = objf_tracer(bi,bj) + locfc

#endif /* ALLOW_PTRACERS */
#endif /* ALLOW_COST_TRACER */

      RETURN
      END

#include "GCHEM_OPTIONS.h"

CBOP
C     !ROUTINE: CFC_CHECK
C     !INTERFACE:
      SUBROUTINE CFC_CHECK( myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R CFC_CHECK
C     | o Print CFC parameter summary and
C     | o Check for consistent CFC pkg setting
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "CFC.h"

C     !INPUT/OUTPUT PARAMETERS:
C     myThid    :: My Thread Id. number
      INTEGER myThid
CEOP

#ifdef ALLOW_CFC
C     !LOCAL VARIABLES:
C     msgBuf    :: Informational/error message buffer
C     ioUnit    :: Work variable for IO unit number
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      INTEGER ioUnit
      INTEGER errCount

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      _BEGIN_MASTER(myThid)

      ioUnit = standardMessageUnit
      WRITE(msgBuf,'(A)') 'CFC_CHECK:   #define ALLOW_CFC'
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )

C---  Print summary:

      WRITE(msgBuf,'(A)')
     &'// ======================================================='
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)') '// CFC pkg configuration summary'
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)')
     &'// ======================================================='
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )

      CALL WRITE_0D_C( atmCFC_inpFile, -1, INDEX_NONE,
     & 'atmCFC_inpFile =', ' /* atmos CFC time-series input file */')
      CALL WRITE_0D_RL( atmCFC_recSepTime, INDEX_NONE,
     &  'atmCFC_recSepTime =', ' /* time record spacing (s) */')
      CALL WRITE_0D_RL( atmCFC_timeOffset, INDEX_NONE,
     &  'atmCFC_timeOffset =', ' /* time offset for atm CFC (s) */')
      CALL WRITE_0D_RL( atmCFC_ySouthBnd, INDEX_NONE,
     &  'atmCFC_ySouthBnd =', ' /* S Lat boundary for atm CFC (s) */')
      CALL WRITE_0D_RL( atmCFC_yNorthBnd, INDEX_NONE,
     &  'atmCFC_yNorthBnd =', ' /* N Lat boundary for atm CFC (s) */')
      CALL WRITE_0D_RL( CFC_monFreq, INDEX_NONE,
     &  'CFC_monFreq =', ' /* frequency for CFC monitor (s) */')

c     CALL WRITE_0D_L( fluidIsAir,   INDEX_NONE,
c    & 'fluidIsAir   =', '  /* fluid major constituent is Air */')

      CALL WRITE_0D_C( CFC_windFile, -1, INDEX_NONE,
     & 'CFC_windFile =', ' /* wind-speed input file */')
      CALL WRITE_0D_C( CFC_atmospFile, -1, INDEX_NONE,
     & 'CFC_atmospFile =', ' /* atmos surf pressure input file */')
      CALL WRITE_0D_C( CFC_iceFile, -1, INDEX_NONE,
     & 'CFC_iceFile =', ' /* seaice fraction input file */')

      CALL WRITE_0D_RL( CFC_forcingPeriod, INDEX_NONE,
     &  'CFC_forcingPeriod =',
     &  ' /* forcing period (s) of input file */')
      CALL WRITE_0D_RL( CFC_forcingCycle, INDEX_NONE,
     &  'CFC_forcingCycle =',
     &  ' /* period of Cycle for input file (s) */')

      WRITE(msgBuf,'(A)')
     &'// ======================================================='
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)') '// End of CFC pkg config summary'
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)')
     &'// ======================================================='
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )

C---  Check CFC pkg settings:
      errCount = 0

      IF ( CFC_windFile .NE. ' ' .AND. useEXF ) THEN
        WRITE(msgBuf,'(A)')
     &    'CFC_CHECK: setting CFC_windFile conflicts with using EXF'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF

      IF ( CFC_iceFile .NE. ' ' .AND.
     &     ( useThSIce .OR. useSEAICE ) ) THEN
        WRITE(msgBuf,'(A)')
     &    'CFC_CHECK: setting CFC_iceFile conflicts with using seaice'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF

      IF ( CFC_forcingCycle.LE.zeroRL .AND.
     &     ( CFC_windFile   .NE. ' '
     &  .OR. CFC_atmospFile .NE. ' '
     &  .OR. CFC_iceFile    .NE. ' ' ) ) THEN
        WRITE(msgBuf,'(A)')
     &       'CFC_CHECK: CFC_forcingCycle=0 but code to load'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(A)')
     &       'CFC_CHECK:  non periodic forcing is missing'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF

      IF ( errCount.GE.1 ) THEN
        WRITE(msgBuf,'(A,I3,A)')
     &       'CFC_CHECK: detected', errCount,' fatal error(s)'
        CALL PRINT_ERROR( msgBuf, myThid )
        CALL ALL_PROC_DIE( 0 )
        STOP 'ABNORMAL END: S/R CFC_CHECK'
      ENDIF

      WRITE(msgBuf,'(A)') 'CFC_CHECK: done'
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )

      _END_MASTER(myThid)

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#endif /* ALLOW_CFC */

      RETURN
      END

#include "THSICE_OPTIONS.h"
#ifdef ALLOW_AUTODIFF
# include "AUTODIFF_OPTIONS.h"
# define ALLOW_AUTODIFF_TAMC_MORE
#endif

CBOP
C     !ROUTINE: THSICE_CALC_THICKN
C     !INTERFACE:
      SUBROUTINE THSICE_CALC_THICKN(
     I                  bi, bj,
     I                  iMin,iMax, jMin,jMax, dBugFlag,
     I                  iceMask, tFrz, tOce, v2oc,
     I                  snowP, prcAtm, sHeat, flxCnB,
     U                  icFrac, hIce, hSnow1, tSrf, qIc1, qIc2,
     U                  frwAtm, fzMlOc, flx2oc,
     O                  frw2oc, fsalt, frzSeaWat,
     I                  myTime, myIter, myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R  THSICE_CALC_THICKN
C     | o Calculate ice & snow thickness changes
C     *==========================================================*
C     \ev
C ADAPTED FROM:
C LANL CICE.v2.0.2
C-----------------------------------------------------------------------
C.. thermodynamics (vertical physics) based on M. Winton 3-layer model
C.. See Bitz, C. M. and W. H. Lipscomb, 1999:  An energy-conserving
C..       thermodynamic sea ice model for climate study.
C..       J. Geophys. Res., 104, 15669 - 15677.
C..     Winton, M., 1999:  "A reformulated three-layer sea ice model."
C..       Submitted to J. Atmos. Ocean. Technol.
C.. authors Elizabeth C. Hunke and William Lipscomb
C..         Fluid Dynamics Group, Los Alamos National Laboratory
C-----------------------------------------------------------------------
Cc****subroutine thermo_winton(n,fice,fsnow,dqice,dTsfc)
C.. Compute temperature change using Winton model with 2 ice layers, of
C.. which only the top layer has a variable heat capacity.

C---------------------------------
C  parameters that control the partitioning between lateral (ice area) and
C    vertical (ice thickness) ice volume changes.
C a) surface melting and bottom melting (runtime parameter: fracEnMelt):
C  frace is the fraction of available heat that is used for
C  lateral melting (and 1-frace reduces the thickness ) when
C o       hi < hThinIce        & frac > lowIcFrac2 : frace=1 (lateral melting only)
C o hThinIce < hi < hThickIce  & frac > lowIcFrac1 : frace=fracEnMelt
C o            hi > hThickIce or frac < lowIcFrac1 : frace=0 (thinning only)
C b) ocean freezing (and ice forming):
C - conductive heat flux (below sea-ice) always increases thickness.
C - under sea-ice, freezing potential (x iceFraction) is used to increase ice
C                  thickness or ice fraction (lateral growth), according to:
C o       hi < hThinIce       : use freezing potential to grow ice vertically;
C o hThinIce < hi < hThickIce : use partition factor fracEnFreez for lateral growth
c                               and (1-fracEnFreez) to increase thickness.
C o            hi > hThickIce : use all freezing potential to grow ice laterally
C                                (up to areaMax)
C - over open ocean, use freezing potential [x(1-iceFraction)] to grow ice laterally
C - lateral growth forms ice of the same or =hNewIceMax thickness, the less of the 2.
C - starts to form sea-ice over fraction iceMaskMin, as minimum ice-volume is reached
C---------------------------------
C     !USES:
      IMPLICIT NONE

C     == Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "THSICE_SIZE.h"
#include "THSICE_PARAMS.h"
#ifdef ALLOW_AUTODIFF_TAMC
# include "tamc.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine Arguments ==
C     bi,bj       :: tile indices
C     iMin,iMax   :: computation domain: 1rst index range
C     jMin,jMax   :: computation domain: 2nd  index range
C     dBugFlag    :: allow to print debugging stuff (e.g. on 1 grid point).
C---  Input:
C         iceMask :: sea-ice fractional mask [0-1]
C  tFrz           :: sea-water freezing temperature [oC] (function of S)
C  tOce           :: surface level oceanic temperature [oC]
C  v2oc           :: square of ocean surface-level velocity [m2/s2]
C  snowP          :: snow precipitation                [kg/m2/s]
C  prcAtm         :: total precip from the atmosphere [kg/m2/s]
C  sHeat          :: surf heating flux left to melt snow or ice (= Atmos-conduction)
C  flxCnB         :: heat flux conducted through the ice to bottom surface
C---  Modified (input&output):
C  icFrac         :: fraction of grid area covered in ice
C  hIce           :: ice height [m]
C  hSnow1          :: snow height [m]
C  tSrf           :: surface (ice or snow) temperature
C  qIc1   (qicen) :: ice enthalpy (J/kg), 1rst level
C  qIc2   (qicen) :: ice enthalpy (J/kg), 2nd level
C  frwAtm (evpAtm):: evaporation to the atmosphere [kg/m2/s] (>0 if evaporate)
C  fzMlOc         :: ocean mixed-layer freezing/melting potential [W/m2]
C  flx2oc         :: net heat flux to ocean    [W/m2]          (> 0 downward)
C---  Output
C  frw2oc         :: Total fresh water flux to ocean [kg/m2/s] (> 0 downward)
C  fsalt          :: salt flux to ocean        [g/m2/s]        (> 0 downward)
C  frzSeaWat      :: seawater freezing rate (expressed as mass flux) [kg/m^2/s]
C---  Input:
C     myTime      :: current Time of simulation [s]
C     myIter      :: current Iteration number in simulation
C     myThid      :: my Thread Id number
      INTEGER bi,bj
      INTEGER iMin, iMax
      INTEGER jMin, jMax
      LOGICAL dBugFlag
      _RL iceMask(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL tFrz   (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL tOce   (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL v2oc   (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL snowP  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL prcAtm (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL sHeat  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL flxCnB (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL icFrac (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL hIce   (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL hSnow1 (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL tSrf   (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL qIc1   (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL qIc2   (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL frwAtm (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL fzMlOc (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL flx2oc (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL frw2oc (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL fsalt  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL frzSeaWat(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL  myTime
      INTEGER myIter
      INTEGER myThid
CEOP

#ifdef ALLOW_THSICE

C     !LOCAL VARIABLES:
C---  local copy of input/output argument list variables (see description above)
      _RL qicen(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nlyr)

C     == Local Variables ==
C     i,j,k      :: loop indices
C     rec_nlyr   :: reciprocal of number of ice layers (real value)
C     evapLoc    :: evaporation over snow/ice [kg/m2/s] (>0 if evaporate)
C     Fbot       :: oceanic heat flux used to melt/form ice [W/m2]
C     etop       :: energy for top melting    (J m-2)
C     ebot       :: energy for bottom melting (J m-2)
C     etope      :: energy (from top)    for lateral melting (J m-2)
C     ebote      :: energy (from bottom) for lateral melting (J m-2)
C     extend     :: total energy for lateral melting (J m-2)
C     hnew(nlyr) :: new ice layer thickness (m)
C     hlyr       :: individual ice layer thickness (m)
C     dhi        :: change in ice thickness
C     dhs        :: change in snow thickness
C     rq         :: rho * q for a layer
C     rqh        :: rho * q * h for a layer
C     qbot       :: enthalpy for new ice at bottom surf (J/kg)
C     dt         :: timestep
C     esurp      :: surplus energy from melting (J m-2)
C     mwater0    :: fresh water mass gained/lost (kg/m^2)
C     msalt0     :: salt gained/lost  (kg/m^2)
C     freshe     :: fresh water gain from extension melting
C     salte      :: salt gained from extension melting
C     lowIcFrac1 :: ice-fraction lower limit above which partial (lowIcFrac1)
C     lowIcFrac2 :: or full (lowIcFrac2) lateral melting is allowed.
C     from THSICE_RESHAPE_LAYERS
C     f1         :: Fraction of upper layer ice in new layer
C     qh1, qh2   :: qice*h for layers 1 and 2
C     qhtot      :: qh1 + qh2
C     q2tmp      :: Temporary value of qice for layer 2
      INTEGER  i,j,k
      _RL rec_nlyr
      _RL evapLoc(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL Fbot   (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL etop   (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL ebot   (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL etope  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL ebote  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL esurp  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL extend
      _RL hnew   (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nlyr)
C     help TAF with these variables
      _RL hnewTmp, icFracTmp, hIceTmp, hSnwTmp
      _RL hlyr
      _RL dhi
      _RL dhs
      _RL rq
      _RL rqh
      _RL qbot
      _RL dt
      _RL mwater0 (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL msalt0  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL freshe
      _RL salte
      _RL lowIcFrac1, lowIcFrac2
      _RL  f1
      _RL  qh1, qh2
      _RL  qhtot
      _RL  q2tmp
#ifdef CHECK_ENERGY_CONSERV
      _RL  qaux(nlyr)
#endif /* CHECK_ENERGY_CONSERV */

      _RL  ustar, cpchr
      _RL  chi
      _RL  frace, rs, hq
#ifdef THSICE_FRACEN_POWERLAW
      INTEGER powerLaw
      _RL rec_pLaw
      _RL c1Mlt, c2Mlt, aMlt, hMlt
      _RL c1Frz, c2Frz, aFrz, hFrz
      _RL enFrcMlt(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL xxMlt
      _RL enFrcFrz(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL xxFrz
# if ( !defined TARGET_NEC_SX && !defined ALLOW_AUTODIFF )
      _RL tmpMlt, tmpFrz
# endif
#endif

#ifdef ALLOW_AUTODIFF_TAMC
C     tkey :: tape key (depends on tiles)
C     kkey :: tape key (depends on levels and tiles)
      INTEGER tkey, kkey
#endif
#ifdef THSICE_REGULARIZE_CALC_THICKN
      _RL kScal
      PARAMETER ( kScal = 1.D0 )
#endif
#ifdef ALLOW_DBUG_THSICE
C-    define grid-point location where to print debugging values
#include "THSICE_DEBUG.h"

 1020 FORMAT(A,1P4E11.3)
#endif

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#ifdef ALLOW_AUTODIFF_TAMC
      tkey = bi + (bj-1)*nSx + (ikey_dynamics-1)*nSx*nSy
#endif /* ALLOW_AUTODIFF_TAMC */

      rec_nlyr = nlyr
      rec_nlyr = 1. _d 0 / rec_nlyr
      dt  = thSIce_deltaT
      cpchr = cpWater*rhosw*bMeltCoef

C     for now, use hard coded threshold (iceMaskMin +1.% and +10.%)
      lowIcFrac1 = iceMaskMin*1.01 _d 0
      lowIcFrac2 = iceMaskMin*1.10 _d 0
#ifdef THSICE_FRACEN_POWERLAW
      IF ( powerLawExp2 .GE. 1 ) THEN
        powerLaw = 1 + 2**powerLawExp2
        rec_pLaw = powerLaw
        rec_pLaw = 1. _d 0 / rec_pLaw
C-    Coef for melting:
C     lateral-melting energy fraction = fracEnMelt - [ aMlt*(hi-hMlt) ]^powerLaw
        c1Mlt = fracEnMelt**rec_pLaw
        c2Mlt = (1. _d 0 - fracEnMelt)**rec_pLaw
        aMlt = (c1Mlt+c2Mlt)/(hThickIce-hThinIce)
        hMlt = hThinIce+c2Mlt/aMlt
C-    Coef for freezing:
C     thickening energy fraction     = fracEnFreez - [ aFrz*(hi-hFrz) ]^powerLaw
        c1Frz = fracEnFreez**rec_pLaw
        c2Frz = (1. _d 0 -fracEnFreez)**rec_pLaw
        aFrz = (c1Frz+c2Frz)/(hThickIce-hThinIce)
        hFrz = hThinIce+c2Frz/aFrz
      ELSE
C-    Linear relation
        powerLaw = 1
        aMlt = -1. _d 0 /(hThickIce-hThinIce)
        hMlt = hThickIce
        aFrz = -1. _d 0 /(hThickIce-hThinIce)
        hFrz = hThickIce
      ENDIF
#endif /* THSICE_FRACEN_POWERLAW */

C     initialise local arrays
      DO j=1-OLy,sNy+OLy
       DO i=1-OLx,sNx+OLx
        evapLoc(i,j) = 0. _d 0
        Fbot   (i,j) = 0. _d 0
        etop   (i,j) = 0. _d 0
        ebot   (i,j) = 0. _d 0
        etope  (i,j) = 0. _d 0
        ebote  (i,j) = 0. _d 0
        esurp  (i,j) = 0. _d 0
        mwater0(i,j) = 0. _d 0
        msalt0 (i,j) = 0. _d 0
#ifdef THSICE_FRACEN_POWERLAW
        enFrcMlt(i,j)= 0. _d 0
        enFrcFrz(i,j)= 0. _d 0
#endif
       ENDDO
      ENDDO
      DO k = 1,nlyr
       DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
         qicen(i,j,k) = 0. _d 0
         hnew (i,j,k) = 0. _d 0
        ENDDO
       ENDDO
      ENDDO

#ifdef ALLOW_AUTODIFF_TAMC
C     The commented store directives ("cCADJ") are not picked up by TAF,
C     that does not mean that under different circumstances they might be,
C     so I leave them here as a reminder.
CADJ STORE hice   = comlev1_bibj, key=tkey, kind=isbyte
CADJ STORE icfrac = comlev1_bibj, key=tkey, kind=isbyte
cCADJ STORE frwatm = comlev1_bibj, key=tkey, kind=isbyte
cCADJ STORE fzmloc = comlev1_bibj, key=tkey, kind=isbyte
cCADJ STORE hSnow1 = comlev1_bibj, key=tkey, kind=isbyte
cCADJ STORE qic1   = comlev1_bibj, key=tkey, kind=isbyte
cCADJ STORE qic2   = comlev1_bibj, key=tkey, kind=isbyte
#endif
      DO j = jMin, jMax
       DO i = iMin, iMax

        IF (iceMask(i,j).GT.0. _d 0) THEN
         qicen(i,j,1)= qIc1(i,j)
         qicen(i,j,2)= qIc2(i,j)
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C     initialize energies
         esurp(i,j) = 0. _d 0

c     make a local copy of evaporation
         evapLoc(i,j) = frwAtm(i,j)

C------------------------------------------------------------------------
C--   Compute growth and/or melting at the top and bottom surfaces
C------------------------------------------------------------------------

#ifdef THSICE_FRACEN_POWERLAW
         xxMlt = aMlt*(hIce(i,j)-hMlt)
         xxFrz = aFrz*(hIce(i,j)-hFrz)
c--
         IF ( powerLawExp2 .GE. 1 ) THEN
#if ( defined TARGET_NEC_SX || defined ALLOW_AUTODIFF )
C     avoid the short inner loop that cannot be vectorized
          xxMlt = xxMlt**powerLaw
          xxFrz = xxFrz**powerLaw
#else
          tmpMlt = xxMlt
          tmpFrz = xxFrz
          DO k=1,powerLawExp2
           tmpMlt = tmpMlt*tmpMlt
           tmpFrz = tmpFrz*tmpFrz
          ENDDO
          xxMlt = xxMlt*tmpMlt
          xxFrz = xxFrz*tmpFrz
#endif /* TARGET_NEC_SX */
          xxMlt = fracEnMelt -xxMlt
          xxFrz = fracEnFreez-xxFrz
         ENDIF
         enFrcMlt(i,j) = MAX( 0. _d 0, MIN( xxMlt, 1. _d 0 ) )
         enFrcFrz(i,j) = MAX( 0. _d 0, MIN( xxFrz, 1. _d 0 ) )
#endif /* THSICE_FRACEN_POWERLAW */

         IF (fzMlOc(i,j).GE. 0. _d 0) THEN
C     !-----------------------------------------------------------------
C     ! freezing conditions
C     !-----------------------------------------------------------------
          Fbot(i,j) = fzMlOc(i,j)
          IF ( icFrac(i,j).LT.iceMaskMax ) THEN
#ifdef THSICE_FRACEN_POWERLAW
           Fbot(i,j) = enFrcFrz(i,j)*fzMlOc(i,j)
#else /* THSICE_FRACEN_POWERLAW */
           IF (hIce(i,j).GT.hThickIce) THEN
C if higher than hThickIce, use all fzMlOc energy to grow extra ice
            Fbot(i,j) = 0. _d 0
           ELSEIF (hIce(i,j).GE.hThinIce) THEN
C between hThinIce & hThickIce, use partition factor fracEnFreez
            Fbot(i,j) = (1. _d 0 - fracEnFreez)*fzMlOc(i,j)
           ENDIF
#endif /* THSICE_FRACEN_POWERLAW */
          ENDIF
         ELSE
C     !-----------------------------------------------------------------
C     ! melting conditions
C     !-----------------------------------------------------------------
#ifdef THSICE_REGULARIZE_CALC_THICKN
C     smooth regulatization
          ustar = SQRT(0.00536 _d 0 *v2oc(i,j) + 25. _d -6)
#else
C     for no currents:
          ustar = 5. _d -3
C frictional velocity between ice and water
          IF (v2oc(i,j) .NE. 0.)
     &     ustar = SQRT(0.00536 _d 0*v2oc(i,j))
          ustar = MAX(5. _d -3,ustar)
#endif
c         cpchr =cpWater*rhosw*bMeltCoef
          Fbot(i,j) = cpchr*(tFrz(i,j)-tOce(i,j))*ustar
C     fzMlOc < Fbot < 0
#ifdef THSICE_REGULARIZE_CALC_THICKN
C     smooth regulatization
C     we want to have some soft maximum for better differentiability:
C     max(a,b;k) = (a*exp(k*a)+b*exp(k*b))/(exp(k*a)+exp(k*b))
          Fbot(i,j) = (
     &             Fbot(i,j) * EXP(kScal*  Fbot(i,j))
     &         + fzMlOc(i,j) * EXP(kScal*fzMlOc(i,j))
     &         )/( EXP(kScal*Fbot(i,j)) + EXP(kScal*fzMlOc(i,j)) )
#else
          Fbot(i,j) = MAX(Fbot(i,j),fzMlOc(i,j))
#endif
          Fbot(i,j) = MIN(Fbot(i,j),0. _d 0)
         ENDIF

C  mass of fresh water and salt initially present in ice
         mwater0(i,j) = rhos*hSnow1(i,j) + rhoi*hIce(i,j)
         msalt0 (i,j) = rhoi*hIce(i,j)*saltIce

#ifdef ALLOW_DBUG_THSICE
         IF (dBug(i,j,bi,bj) ) WRITE(6,1020)
     &        'ThSI_CALC_TH: evpAtm, fzMlOc, Fbot =',
     &        frwAtm(i,j),fzMlOc(i,j),Fbot(i,j)
#endif
C     endif iceMask > 0
        ENDIF
C     end i/j-loops
       ENDDO
      ENDDO
#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE icFrac = comlev1_bibj, key = tkey, kind = isbyte
#endif
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
      DO j = jMin, jMax
       DO i = iMin, iMax
        IF (iceMask(i,j).GT.0. _d 0) THEN

C     Compute energy available for melting/growth.

#ifdef THSICE_FRACEN_POWERLAW
         IF ( fracEnMelt.EQ.0. _d 0 ) THEN
          frace = 0. _d 0
         ELSE
          frace = (icFrac(i,j) - lowIcFrac1)/(lowIcFrac2-iceMaskMin)
          frace = MIN( enFrcMlt(i,j), MAX( 0. _d 0, frace ) )
         ENDIF
#else /* THSICE_FRACEN_POWERLAW */
         IF ( hIce(i,j).GT.hThickIce .OR. fracEnMelt.EQ.0. _d 0 ) THEN
C above certain height (or when no ice fractionation), only melt from top
          frace = 0. _d 0
         ELSEIF (hIce(i,j).LT.hThinIce) THEN
C below a certain height, all energy goes to changing ice extent
          frace = 1. _d 0
         ELSE
          frace = fracEnMelt
         ENDIF
C     Reduce lateral melting when ice fraction is low : the purpose is to avoid
C     disappearing of (up to hThinIce thick) sea-ice by over doing lateral melting
C     (which would bring icFrac below iceMaskMin).
         IF ( icFrac(i,j).LE.lowIcFrac1 ) THEN
          frace = 0. _d 0
         ELSEIF (icFrac(i,j).LE.lowIcFrac2 ) THEN
          frace = MIN( frace, fracEnMelt )
         ENDIF
#endif /* THSICE_FRACEN_POWERLAW */

c     IF (tSrf(i,j) .EQ. 0. _d 0 .AND. sHeat(i,j).GT.0. _d 0) THEN
         IF ( sHeat(i,j).GT.0. _d 0 ) THEN
          etop(i,j) = (1. _d 0-frace)*sHeat(i,j) * dt
          etope(i,j) = frace*sHeat(i,j) * dt
         ELSE
          etop(i,j) =  0. _d 0
          etope(i,j) = 0. _d 0
C jmc: found few cases where tSrf=0 & sHeat < 0 : add this line to conserv energy:
          esurp(i,j) = sHeat(i,j) * dt
         ENDIF
C--   flux at the base of sea-ice:
C     conduction H.flx= flxCnB (+ =down); oceanic turbulent H.flx= Fbot (+ =down).
C-    ==> energy available(+ => melt)= (flxCnB-Fbot)*dt
c     IF (fzMlOc(i,j).LT.0. _d 0) THEN
c         ebot(i,j) = (1. _d 0-frace)*(flxCnB-Fbot(i,j)) * dt
c         ebote(i,j) = frace*(flxCnB-Fbot(i,j)) * dt
c     ELSE
c         ebot(i,j) = (flxCnB-Fbot(i,j)) * dt
c         ebote(i,j) = 0. _d 0
c     ENDIF
C- original formulation(above): Loose energy when flxCnB < Fbot < 0
         ebot(i,j) = (flxCnB(i,j)-Fbot(i,j)) * dt
         IF (ebot(i,j).GT.0. _d 0) THEN
          ebote(i,j) = frace*ebot(i,j)
          ebot(i,j)  = ebot(i,j)-ebote(i,j)
         ELSE
          ebote(i,j) = 0. _d 0
         ENDIF
#ifdef ALLOW_DBUG_THSICE
         IF (dBug(i,j,bi,bj) ) WRITE(6,1020)
     &        'ThSI_CALC_TH: etop,etope,ebot,ebote=',
     &        etop(i,j),etope(i,j),ebot(i,j),ebote(i,j)
#endif
C     endif iceMask > 0
        ENDIF
C     end i/j-loops
       ENDDO
      ENDDO

C     Initialize layer thicknesses. Divide total thickness equally between
C     layers
      DO k = 1, nlyr
       DO j = jMin, jMax
        DO i = iMin, iMax
         hnew(i,j,k) = hIce(i,j) * rec_nlyr
        ENDDO
       ENDDO
      ENDDO

#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE hSnow1 = comlev1_bibj, key = tkey, kind = isbyte
CADJ STORE etop   = comlev1_bibj, key = tkey, kind = isbyte
#endif
      DO j = jMin, jMax
       DO i = iMin, iMax
        IF (iceMask(i,j) .GT. 0. _d 0 .AND.
     &         etop(i,j) .GT. 0. _d 0 .AND.
     &       hSnow1(i,j) .GT. 0. _d 0) THEN

C     Make sure internal ice temperatures do not exceed Tmlt.
C     If they do, then eliminate the layer.  (Dont think this will happen
C     for reasonable values of i0.)
C     Top melt: snow, then ice.
         rq =  rhos * qsnow
         rqh = rq * hSnow1(i,j)
         IF (etop(i,j) .LT. rqh) THEN
          hSnow1(i,j) = hSnow1(i,j) - etop(i,j)/rq
          etop(i,j) = 0. _d 0
         ELSE
          etop(i,j) = etop(i,j) - rqh
          hSnow1(i,j) = 0. _d 0
         ENDIF
C     endif iceMask > 0, etc.
        ENDIF
C     end i/j-loops
       ENDDO
      ENDDO
#ifdef ALLOW_AUTODIFF_TAMC_MORE
CADJ STORE hSnow1 = comlev1_bibj, key = tkey, kind = isbyte
#endif
C     two layers of ice
      DO k = 1, nlyr
#ifdef ALLOW_AUTODIFF_TAMC
       kkey = k + (tkey-1)*nlyr
CADJ STORE etop         = comlev1_thsice_nlyr, key=kkey, kind=isbyte
CADJ STORE hnew (:,:,k) = comlev1_thsice_nlyr, key=kkey, kind=isbyte
CADJ STORE qicen(:,:,k) = comlev1_thsice_nlyr, key=kkey, kind=isbyte
#endif
       DO j = jMin, jMax
        DO i = iMin, iMax
         IF (iceMask(i,j).GT.0. _d 0) THEN
          IF (etop(i,j) .GT. 0. _d 0) THEN
           rq =  rhoi * qicen(i,j,k)
           rqh = rq * hnew(i,j,k)
           IF (etop(i,j) .LT. rqh) THEN
            hnew(i,j,k) = hnew(i,j,k) - etop(i,j) / rq
            etop(i,j) = 0. _d 0
           ELSE
            etop(i,j) = etop(i,j) - rqh
            hnew(i,j,k) = 0. _d 0
           ENDIF
          ELSE
           etop(i,j)=0. _d 0
          ENDIF
C If ice is gone and melting energy remains
c     IF (etop(i,j) .GT. 0. _d 0) THEN
c        WRITE (6,*)  'QQ All ice melts from top  ', i,j
c        hIce(i,j)=0. _d 0
c        go to 200
c     ENDIF

C     endif iceMask > 0
         ENDIF
C     end i/j-loops
        ENDDO
       ENDDO
C     end k-loop
      ENDDO
#ifdef ALLOW_AUTODIFF_TAMC_MORE
C     if isbyte=4, these change the AD-monitor output a little (11-14
C     digits of agreement)
CADJ STORE ebot  = comlev1_bibj, key = tkey, kind = isbyte
CADJ STORE hnew  = comlev1_bibj, key = tkey, kind = isbyte
CADJ STORE qicen = comlev1_bibj, key = tkey, kind = isbyte
#endif

C Bottom growth:
      DO j = jMin, jMax
       DO i = iMin, iMax
        IF (iceMask(i,j).GT.0. _d 0 .AND. ebot(i,j) .LT. 0. _d 0) THEN
C Compute enthalpy of new ice growing at bottom surface.
         qbot =  -cpIce *tFrz(i,j) + Lfresh
         dhi = -ebot(i,j) / (qbot * rhoi)
         ebot(i,j) = 0. _d 0
         qicen(i,j,nlyr) =
     &        (hnew(i,j,nlyr)*qicen(i,j,nlyr)+dhi*qbot) /
     &        (hnew(i,j,nlyr)+dhi)
         hnew(i,j,nlyr) = hnew(i,j,nlyr) + dhi
         frzSeaWat(i,j) = rhoi*dhi/dt

C     endif iceMask > 0 and ebot < 0
        ENDIF
C     end i/j-loops
       ENDDO
      ENDDO

#ifdef ALLOW_AUTODIFF_TAMC_MORE
C     these change the results (increase gradient error sligthly);
C     they do not improve performance too much, so we leave commented
cCADJ STORE hnew (:,:,nlyr) = comlev1_bibj, key = tkey, kind = isbyte
cCADJ STORE qicen(:,:,nlyr) = comlev1_bibj, key = tkey, kind = isbyte
#endif

C Bottom melt:
      DO k = nlyr, 1, -1
#ifdef ALLOW_AUTODIFF_TAMC
       kkey = k + (tkey-1)*nlyr
CADJ STORE ebot = comlev1_thsice_nlyr, key=kkey, kind = isbyte
#endif
       DO j = jMin, jMax
        DO i = iMin, iMax
         IF (iceMask(i,j) .GT. 0. _d 0 .AND.
     &        ebot(i,j)   .GT. 0. _d 0 .AND.
     &        hnew(i,j,k) .GT. 0. _d 0) THEN
          rq =  rhoi * qicen(i,j,k)
          rqh = rq * hnew(i,j,k)
          IF (ebot(i,j) .LT. rqh) THEN
           hnew(i,j,k) = hnew(i,j,k) - ebot(i,j) / rq
           ebot(i,j) = 0. _d 0
          ELSE
           ebot(i,j) = ebot(i,j) - rqh
           hnew(i,j,k) = 0. _d 0
          ENDIF
C     endif iceMask > 0 etc.
         ENDIF
C     end i/j-loops
        ENDDO
       ENDDO
C     end k-loop
      ENDDO
#ifdef ALLOW_AUTODIFF_TAMC_MORE
C     if isbyte=4, these change the AD-monitor output a little (10-11
C     digits of agreement)
CADJ STORE hnew = comlev1_bibj, key = tkey, kind = isbyte
CADJ STORE ebot = comlev1_bibj, key = tkey, kind = isbyte
#endif
C     If ice melts completely and snow is left, remove the snow with
C     energy from the mixed layer
      DO j = jMin, jMax
       DO i = iMin, iMax
        IF (iceMask(i,j) .GT. 0. _d 0 .AND.
     &       ebot(i,j)   .GT. 0. _d 0 .AND.
     &       hSnow1(i,j) .GT. 0. _d 0) THEN
         rq =  rhos * qsnow
         rqh = rq * hSnow1(i,j)
         IF (ebot(i,j) .LT. rqh) THEN
          hSnow1(i,j) = hSnow1(i,j) - ebot(i,j) / rq
          ebot(i,j) = 0. _d 0
         ELSE
          ebot(i,j) = ebot(i,j) - rqh
          hSnow1(i,j) = 0. _d 0
         ENDIF
c        IF (ebot(i,j) .GT. 0. _d 0) THEN
c           IF (dBug) WRITE(6,*) 'All ice (& snow) melts from bottom'
c           hIce(i,j)=0. _d 0
c           go to 200
c        ENDIF

C     endif iceMask > 0, etc.
        ENDIF
C     end i/j-loops
       ENDDO
      ENDDO
#ifdef ALLOW_AUTODIFF_TAMC_MORE
CADJ STORE hSnow1 = comlev1_bibj, key = tkey, kind = isbyte
#endif
      DO j = jMin, jMax
       DO i = iMin, iMax
        IF (iceMask(i,j).GT.0. _d 0) THEN
C Compute new total ice thickness.
         hIce(i,j) = hnew(i,j,1) + hnew(i,j,2)
#ifdef ALLOW_DBUG_THSICE
         IF (dBug(i,j,bi,bj) ) WRITE(6,1020)
     &        'ThSI_CALC_TH:   etop, ebot, hIce, hSnow1 =',
     &        etop(i,j), ebot(i,j), hIce(i,j), hSnow1(i,j)
#endif

C If hIce < hIceMin, melt the ice.
         IF ( hIce(i,j).LT.hIceMin
     &        .AND. (hIce(i,j)+hSnow1(i,j)).GT.0. _d 0 ) THEN
          esurp(i,j) = esurp(i,j) - rhos*qsnow*hSnow1(i,j)
     &         - rhoi*qicen(i,j,1)*hnew(i,j,1)
     &         - rhoi*qicen(i,j,2)*hnew(i,j,2)
          hIce(i,j)   = 0. _d 0
          hSnow1(i,j)  = 0. _d 0
          tSrf(i,j)   = 0. _d 0
          icFrac(i,j) = 0. _d 0
          qicen(i,j,1) = 0. _d 0
          qicen(i,j,2) = 0. _d 0
#ifdef ALLOW_DBUG_THSICE
          IF (dBug(i,j,bi,bj) ) WRITE(6,1020)
     &         'ThSI_CALC_TH: -1 : esurp=',esurp(i,j)
#endif
         ENDIF

C     endif iceMask > 0
        ENDIF
C     end i/j-loops
       ENDDO
      ENDDO

      DO j = jMin, jMax
       DO i = iMin, iMax
        IF (iceMask(i,j).GT.0. _d 0) THEN

C--   do a mass-budget of sea-ice to compute "fresh" = the fresh-water flux
C     that is returned to the ocean ; needs to be done before snow/evap
         frw2oc(i,j) = (mwater0(i,j)
     &        - (rhos*hSnow1(i,j)+rhoi*hIce(i,j)))/dt

         IF ( hIce(i,j) .LE. 0. _d 0 ) THEN
C-    return  snow to the ocean (account for Latent heat of freezing)
          frw2oc(i,j) = frw2oc(i,j) + snowP(i,j)
          flx2oc(i,j) = flx2oc(i,j) - snowP(i,j)*Lfresh
         ENDIF

C     endif iceMask > 0
        ENDIF
C     end i/j-loops
       ENDDO
      ENDDO
C-    else: hIce > 0
      DO j = jMin, jMax
       DO i = iMin, iMax
        IF (iceMask(i,j).GT.0. _d 0) THEN

         IF ( hIce(i,j) .GT. 0. _d 0 ) THEN
C Let it snow
          hSnow1(i,j) = hSnow1(i,j) + dt*snowP(i,j)/rhos
C If ice evap is used to sublimate surface snow/ice or
C if no ice pass on to ocean
          IF (hSnow1(i,j).GT.0. _d 0) THEN
           IF (evapLoc(i,j)/rhos *dt.GT.hSnow1(i,j)) THEN
            evapLoc(i,j)=evapLoc(i,j)-hSnow1(i,j)*rhos/dt
            hSnow1(i,j)=0. _d 0
           ELSE
            hSnow1(i,j) = hSnow1(i,j) - evapLoc(i,j)/rhos *dt
            evapLoc(i,j)=0. _d 0
           ENDIF
          ENDIF
C     endif hice > 0
         ENDIF
C     endif iceMask > 0
        ENDIF
C     end i/j-loops
       ENDDO
      ENDDO

C-    else: hIce > 0
      DO k = 1, nlyr
#ifdef ALLOW_AUTODIFF_TAMC
       kkey = k + (tkey-1)*nlyr
CADJ STORE evaploc      = comlev1_thsice_nlyr, key=kkey, kind=isbyte
#endif
       DO j = jMin, jMax
        DO i = iMin, iMax
         IF (iceMask(i,j).GT.0. _d 0 ) THEN

           hnewTmp = hnew(i,j,k)
           IF (hIce(i,j).GT.0. _d 0.AND.evapLoc(i,j).GT.0. _d 0) THEN
C            IF (evapLoc(i,j) .GT. 0. _d 0) THEN
C-- original scheme, does not care about ice temp.
C-  this can produce small error (< 1.W/m2) in the Energy budget
c              IF (evapLoc(i,j)/rhoi *dt.GT.hnewTmp) THEN
c                evapLoc(i,j)=evapLoc(i,j)-hnewTmp*rhoi/dt
c                hnew(i,j,k)=0. _d 0
c              ELSE
c                hnew(i,j,k) = hnewTmp - evapLoc(i,j)/rhoi *dt
c                evapLoc(i,j)=0. _d 0
c              ENDIF
C-- modified scheme. taking into account Ice enthalpy
             dhi = evapLoc(i,j)/rhoi*dt
             IF (dhi.GE.hnewTmp) THEN
              evapLoc(i,j)=evapLoc(i,j)-hnewTmp*rhoi/dt
              esurp(i,j) = esurp(i,j)
     &             - hnewTmp*rhoi*(qicen(i,j,k)-Lfresh)
              hnew(i,j,k)=0. _d 0
             ELSE
              hq = hnewTmp*qicen(i,j,k)-dhi*Lfresh
              hnew(i,j,k) = hnewTmp - dhi
              qicen(i,j,k)=hq/hnew(i,j,k)
              evapLoc(i,j)=0. _d 0
             ENDIF
C-------
c     IF (evapLoc(i,j) .GT. 0. _d 0) THEN
c           WRITE (6,*)  'BB All ice sublimates', i,j
c           hIce(i,j)=0. _d 0
c           go to 200
c     ENDIF
C     endif hice > 0 and evaploc > 0
          ENDIF
C     endif iceMask > 0
         ENDIF
C     end i/j-loops
        ENDDO
       ENDDO
C     end k-loop
      ENDDO

#ifdef ALLOW_AUTODIFF_TAMC_MORE
C     if isbyte=4, these change the AD-monitor output a little (8-10
C     digits of agreement)
CADJ STORE evapLoc = comlev1_bibj, key = tkey, kind = isbyte
CADJ STORE hSnow1  = comlev1_bibj, key = tkey, kind = isbyte
CADJ STORE hIce    = comlev1_bibj, key = tkey, kind = isbyte
CADJ STORE hnew    = comlev1_bibj, key = tkey, kind = isbyte
CADJ STORE qicen   = comlev1_bibj, key = tkey, kind = isbyte
#endif

C     still else: hice > 0
      DO j = jMin, jMax
       DO i = iMin, iMax
        IF (iceMask(i,j).GT.0. _d 0) THEN
         IF (hIce(i,j) .GT. 0. _d 0) THEN
C Compute new total ice thickness.
          hIce(i,j) = hnew(i,j,1) + hnew(i,j,2)
C If hIce < hIceMin, melt the ice.
          IF ( hIce(i,j).GT.0. _d 0 .AND. hIce(i,j).LT.hIceMin ) THEN
           frw2oc(i,j) = frw2oc(i,j)
     &          + (rhos*hSnow1(i,j) + rhoi*hIce(i,j))/dt
           esurp(i,j) = esurp(i,j) - rhos*qsnow*hSnow1(i,j)
     &          - rhoi*qicen(i,j,1)*hnew(i,j,1)
     &          - rhoi*qicen(i,j,2)*hnew(i,j,2)
           hIce(i,j)   = 0. _d 0
           hSnow1(i,j)  = 0. _d 0
           tSrf(i,j)   = 0. _d 0
           icFrac(i,j) = 0. _d 0
           qicen(i,j,1) = 0. _d 0
           qicen(i,j,2) = 0. _d 0
#ifdef ALLOW_DBUG_THSICE
           IF (dBug(i,j,bi,bj) ) WRITE(6,1020)
     &          'ThSI_CALC_TH: -2 : esurp,frw2oc=',
     &          esurp(i,j), frw2oc(i,j)
#endif
          ENDIF

C--   else hIce > 0: end
         ENDIF

C     endif iceMask > 0
        ENDIF
C     end i/j-loops
       ENDDO
      ENDDO

      DO j = jMin, jMax
       DO i = iMin, iMax
C     These helper variables avoid TAF recomputation warnings
        hIceTmp = hIce(i,j)
        hSnwTmp = hSnow1(i,j)
        hnewTmp = hnew(i,j,1)
        IF (iceMask(i,j).GT.0. _d 0) THEN

         IF ( hIceTmp .GT. 0. _d 0 ) THEN

C If there is enough snow to lower the ice/snow interface below
C freeboard, convert enough snow to ice to bring the interface back
C to sea-level OR if snow height is larger than hsMax, snow is
C converted to ice to bring hSnow1 down to hsMax. Largest change is
C applied and enthalpy of top ice layer adjusted accordingly.

          IF ( hSnwTmp .GT. hIceTmp*floodFac
     &         .OR. hSnwTmp .GT. hsMax ) THEN
cBB               WRITE (6,*)  'Freeboard adjusts'
c          dhi = (hSnwTmp * rhos - hIceTmp * rhoiw) / rhosw
c          dhs = dhi * rhoi / rhos
           dhs = (hSnwTmp - hIceTmp*floodFac) * rhoi / rhosw
           dhs = MAX( hSnwTmp - hsMax, dhs )
           dhi = dhs * rhos / rhoi
           rqh = rhoi*qicen(i,j,1)*hnewTmp + rhos*qsnow*dhs
           hnew(i,j,1)  = hnewTmp + dhi
           qicen(i,j,1) = rqh / (rhoi*hnew(i,j,1))
           hIce(i,j)    = hIceTmp + dhi
           hSnow1(i,j)  = hSnwTmp - dhs
          ENDIF
#ifdef ALLOW_AUTODIFF
C     This is awkward, but makes storing a few variables (hIce, hnew,
C     qicen) unnecessary. Splitting the loop also changes the condition
C     hIce>0 because hIce has been modified above. This could be handled
C     more cleanly, but because hIce>0 is required for the previous
C     block to be executed where snow is turned into ice hIce>0 is still
C     unchanged, so splitting this loop with the if conditions should be
C     safe. If this turns out to be robust, we can use this code also
C     for non-AD simulation.

C-    if hIce > 0 : end
         ENDIF
C     endif iceMask > 0
        ENDIF
C     end i/j-loops
       ENDDO
      ENDDO
#ifdef ALLOW_AUTODIFF_TAMC_MORE
C     if isbyte=4, these change the AD-monitor output a little (8-10
C     digits of agreement), but avoid quite a few recomputations
CADJ STORE qicen       = comlev1_bibj, key = tkey, kind = isbyte
CADJ STORE hice        = comlev1_bibj, key = tkey, kind = isbyte
CADJ STORE hnew(:,:,1) = comlev1_bibj, key = tkey, kind = isbyte
#endif
      DO j = jMin, jMax
       DO i = iMin, iMax
C     This helper variable avoids TAF recomputation warnings
        hIceTmp = hIce(i,j)
        IF (iceMask(i,j).GT.0. _d 0) THEN
         IF ( hIceTmp .GT. 0. _d 0 ) THEN
C limit ice height
C- NOTE: this part does not conserve Energy ;
C        but surplus of fresh water and salt are taken into account.
          IF (hIceTmp.GT.hiMax) THEN
cBB      print*,'BBerr, hIce>hiMax',i,j,hIce(i,j)
           chi=hIceTmp-hiMax
#else /* ndef ALLOW_AUTODIFF */
C limit ice height
C- NOTE: this part does not conserve Energy ;
C        but surplus of fresh water and salt are taken into account.
          IF (hIce(i,j).GT.hiMax) THEN
cBB      print*,'BBerr, hIce>hiMax',i,j,hIce(i,j)
           chi=hIce(i,j)-hiMax
#endif /* ALLOW_AUTODIFF */
           hnew(i,j,1)=hnew(i,j,1)-chi/2. _d 0
           hnew(i,j,2)=hnew(i,j,2)-chi/2. _d 0
           frw2oc(i,j) = frw2oc(i,j) + chi*rhoi/dt
          ENDIF
c       IF (hSnow1(i,j).GT.hsMax) THEN
cc        print*,'BBerr, hSnow1>hsMax',i,j,hSnow1(i,j)
c         chs=hSnow1(i,j)-hsMax
c         hSnow1(i,j)=hsMax
c         frw2oc(i,j) = frw2oc(i,j) + chs*rhos/dt
c       ENDIF

C Compute new total ice thickness.
          hIce(i,j) = hnew(i,j,1) + hnew(i,j,2)

#ifdef ALLOW_DBUG_THSICE
          IF (dBug(i,j,bi,bj) ) WRITE(6,1020)
     &         'ThSI_CALC_TH: b-Winton: hnew, qice =',
     &         hnew(i,j,1), hnew(i,j,2),
     &         qicen(i,j,1), qicen(i,j,2)
#endif

          hlyr = hIce(i,j) * rec_nlyr
CML          CALL THSICE_RESHAPE_LAYERS(
CML     U         qicen(i,j,:),
CML     I         hlyr, hnew(i,j,:), myThid )
C     inlined version of S/R THSICE_RESHAPE_LAYERS
C     | Repartition into equal-thickness layers, conserving energy.
C     *==========================================================*
C     | This is the 2-layer version (formerly "NEW_LAYERS_WINTON")
C     |  from M. Winton 1999, JAOT, sea-ice model.
          if (hnew(i,j,1).gt.hnew(i,j,2)) then
C--   Layer 1 gives ice to layer 2
           f1 = (hnew(i,j,1)-hlyr)/hlyr
           q2tmp = f1*qicen(i,j,1) + (1. _d 0-f1)*qicen(i,j,2)
           if (q2tmp.gt.Lfresh) then
            qicen(i,j,2) = q2tmp
           else
C-    Keep q2 fixed to avoid q2<Lfresh and T2>0
            qh2 = hlyr*qicen(i,j,2)
            qhtot = hnew(i,j,1)*qicen(i,j,1) + hnew(i,j,2)*qicen(i,j,2)
            qh1 = qhtot - qh2
            qicen(i,j,1) = qh1/hlyr
           endif
          else
C-    Layer 2 gives ice to layer 1
           f1 = hnew(i,j,1)/hlyr
           qicen(i,j,1) = f1*qicen(i,j,1) + (1. _d 0-f1)*qicen(i,j,2)
          endif
C     end of inlined S/R THSICE_RESHAPE_LAYERS

#ifdef ALLOW_DBUG_THSICE
          IF (dBug(i,j,bi,bj) ) WRITE(6,1020)
     &         'ThSI_CALC_TH: icFrac,hIce, qtot, hSnow1 =',
     &         icFrac(i,j),hIce(i,j), (qicen(i,j,1)+qicen(i,j,2))*0.5,
     &         hSnow1(i,j)
#endif

C-    if hIce > 0 : end
         ENDIF
c200     CONTINUE

C     endif iceMask > 0
        ENDIF
C     end i/j-loops
       ENDDO
      ENDDO
#ifdef ALLOW_AUTODIFF_TAMC_MORE
CADJ STORE qicen = comlev1_bibj, key = tkey, kind = isbyte
CADJ STORE hnew  = comlev1_bibj, key = tkey, kind = isbyte
#endif

      DO j = jMin, jMax
       DO i = iMin, iMax
        IF (iceMask(i,j).GT.0. _d 0) THEN
C-  Compute surplus energy left over from melting.

         IF (hIce(i,j).LE.0. _d 0) icFrac(i,j)=0. _d 0

C.. heat fluxes left over for ocean
         flx2oc(i,j) = flx2oc(i,j)
     &        + (Fbot(i,j)+(esurp(i,j)+etop(i,j)+ebot(i,j))/dt)
#ifdef ALLOW_DBUG_THSICE
         IF (dBug(i,j,bi,bj) ) WRITE(6,1020)
     &        'ThSI_CALC_TH: [esurp,etop+ebot]/dt =',
     &        esurp(i,j)/dt,etop(i,j)/dt,ebot(i,j)/dt
#endif

C--   Evaporation left to the ocean :
         frw2oc(i,j) = frw2oc(i,j) - evapLoc(i,j)
C--   Correct Atmos. fluxes for this different latent heat:
C     evap was computed over freezing surf.(tSrf<0), latent heat = Lvap+Lfresh
C     but should be Lvap only for the fraction "evap" that is left to the ocean.
         flx2oc(i,j) = flx2oc(i,j) + evapLoc(i,j)*Lfresh

C fresh and salt fluxes
c     frw2oc(i,j) = (mwater0(i,j) - (rhos*(hSnow1(i,j))
c    &              + rhoi*(hIce(i,j))))/dt-evapLoc(i,j)
c     fsalt = (msalt0(i,j) - rhoi*hIce(i,j)*saltIce)/35. _d 0/dt  ! for same units as frw2oc
C     note (jmc): frw2oc is computed from a sea-ice mass budget that already
C     contains, at this point, snow & evaporation (of snow & ice)
C     but are not meant to be part of ice/ocean fresh-water flux.
C     fix: a) like below or b) by making the budget before snow/evap is added
c     frw2oc(i,j) = (mwater0(i,j) - (rhos*(hSnow1(i,j)) + rhoi*(hIce(i,j))))/dt
c    &      + snow(i,j,bi,bj)*rhos - frwAtm
         fsalt(i,j) = (msalt0(i,j) - rhoi*hIce(i,j)*saltIce)/dt

#ifdef ALLOW_DBUG_THSICE
         IF (dBug(i,j,bi,bj) ) THEN
          WRITE(6,1020)'ThSI_CALC_TH:dH2O,Ev[kg],frw2oc,fsalt',
     &         (mwater0(i,j)-(rhos*hSnow1(i,j)+rhoi*hIce(i,j)))/dt,
     &         evapLoc(i,j),frw2oc(i,j),fsalt(i,j)
          WRITE(6,1020)'ThSI_CALC_TH: flx2oc,Fbot,extend/dt =',
     &         flx2oc(i,j),Fbot(i,j),(etope(i,j)+ebote(i,j))/dt
         ENDIF
#endif

C--   add remaining liquid Precip (rain+RunOff) directly to ocean:
         frw2oc(i,j) = frw2oc(i,j) + (prcAtm(i,j)-snowP(i,j))

C     endif iceMask > 0
        ENDIF
C     end i/j-loops
       ENDDO
      ENDDO

      DO j = jMin, jMax
       DO i = iMin, iMax
C     this copy really only helps TAF
        icFracTmp = icFrac(i,j)
        IF (iceMask(i,j).GT.0. _d 0) THEN
C--   note: at this point, icFrac has not been changed (unless reset to zero)
C     and it can only be reduced by lateral melting in the following part:

C     calculate extent changes
         extend=etope(i,j)+ebote(i,j)
         IF (icFracTmp.GT.0. _d 0.AND.extend.GT.0. _d 0) THEN
          rq =  rhoi * 0.5 _d 0*(qicen(i,j,1)+qicen(i,j,2))
          rs =  rhos * qsnow
          rqh = rq * hIce(i,j) + rs * hSnow1(i,j)
          freshe=(rhos*hSnow1(i,j)+rhoi*hIce(i,j))/dt
          salte=(rhoi*hIce(i,j)*saltIce)/dt
          IF ( extend.LT.rqh ) THEN
           icFrac(i,j)=(1. _d 0-extend/rqh)*icFracTmp
          ENDIF
          IF ( extend.LT.rqh .AND. icFrac(i,j).GE.iceMaskMin ) THEN
           frw2oc(i,j)=frw2oc(i,j)+extend/rqh*freshe
           fsalt(i,j)=fsalt(i,j)+extend/rqh*salte
          ELSE
           icFrac(i,j)=0. _d 0
           hIce(i,j)  =0. _d 0
           hSnow1(i,j) =0. _d 0
           flx2oc(i,j)=flx2oc(i,j)+(extend-rqh)/dt
           frw2oc(i,j)=frw2oc(i,j)+freshe
           fsalt(i,j)=fsalt(i,j)+salte
          ENDIF
         ELSEIF (extend.GT.0. _d 0) THEN
          flx2oc(i,j)=flx2oc(i,j)+extend/dt
         ENDIF
C     endif iceMask > 0
        ENDIF
C     end i/j-loops
       ENDDO
      ENDDO
      DO j = jMin, jMax
       DO i = iMin, iMax
        IF (iceMask(i,j).GT.0. _d 0) THEN
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C--   Update output variables :

C--   Diagnostic of Atmos. fresh water flux (E-P) over sea-ice :
C     substract precip from Evap (<- stored in frwAtm array)
         frwAtm(i,j) = frwAtm(i,j) - prcAtm(i,j)

C--   update Mixed-Layer Freezing potential heat flux by substracting the
C     part which has already been accounted for (Fbot):
         fzMlOc(i,j) = fzMlOc(i,j) - Fbot(i,j)*iceMask(i,j)

C-- Update Sea-Ice state output:
         qIc1(i,j)   = qicen(i,j,1)
         qIc2(i,j)   = qicen(i,j,2)
#ifdef ALLOW_DBUG_THSICE
         IF (dBug(i,j,bi,bj) ) WRITE(6,1020)
     &        'ThSI_CALC_TH: icFrac,flx2oc,fsalt,frw2oc=',
     &        icFrac(i,j), flx2oc(i,j), fsalt(i,j), frw2oc(i,j)
#endif
C     endif iceMask > 0
        ENDIF
       ENDDO
      ENDDO

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
#ifdef CHECK_ENERGY_CONSERV
      DO j = jMin, jMax
       DO i = iMin, iMax
        IF (iceMask(i,j).GT.0. _d 0) THEN
         qaux(1)=qIc1(i,j)
         qaux(2)=qIc2(i,j)
         CALL THSICE_CHECK_CONSERV( dBugFlag, i, j, bi, bj, 0,
     I        iceMask(i,j), icFrac(i,j), hIce(i,j), hSnow1(i,j),
     I        qaux,
     I        flx2oc(i,j), frw2oc(i,j), fsalt,
     I        myTime, myIter, myThid )
C     endif iceMask > 0
        ENDIF
C     end i/j-loops
       ENDDO
      ENDDO
#endif /* CHECK_ENERGY_CONSERV */

#endif  /* ALLOW_THSICE */

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      RETURN
      END

#include "SALT_PLUME_OPTIONS.h"

CBOP 0
C     !ROUTINE: SALT_PLUME_TENDENCY_APPLY_S
C     !INTERFACE:
      SUBROUTINE SALT_PLUME_TENDENCY_APPLY_S(
     U                      gS_arr,
     I                      iMin,iMax,jMin,jMax, k, bi, bj,
     I                      myTime, myIter, myThid )

C     !DESCRIPTION:
C     Add salt_plume tendency terms to S tendency.
C     Routine works for one level at a time.
C     SaltPlume is the amount of salt rejected by ice while freezing;
C     it is here redistributed to multiple vertical levels as per
C     Duffy et al. (GRL 1999).

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
c#include "DYNVARS.h"
#include "SALT_PLUME.h"

C     !INPUT/OUTPUT PARAMETERS:
C     gS_arr    :: the tendency array
C     iMin,iMax :: Working range of x-index for applying forcing.
C     jMin,jMax :: Working range of y-index for applying forcing.
C     k         :: Current vertical level index
C     bi,bj     :: Current tile indices
C     myTime    :: Current time in simulation
C     myIter    :: Current iteration number
C     myThid    :: my Thread Id number
      _RL     gS_arr(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER iMin, iMax, jMin, jMax
      INTEGER k, bi, bj
      _RL     myTime
      INTEGER myIter
      INTEGER myThid
CEOP

#ifdef ALLOW_SALT_PLUME
C#ifndef SALT_PLUME_VOLUME

C     !LOCAL VARIABLES:
      INTEGER i, j
      _RL minusone
      parameter(minusone = -1.)
      _RL plumefrac(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL plumetend(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
#ifdef TARGET_NEC_SX
      integer imt
      parameter( imt=(sNx+2*OLx)*(sNy+2*OLy) )
      _RL plumekb2D(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
#else
      integer two2
      parameter(two2 = 2)
      _RL plumekb(two2), SPdepth(two2)
#ifdef SALT_PLUME_SPLIT_BASIN
      _RL lon(two2), lat(two2)
#endif /* SALT_PLUME_SPLIT_BASIN */
#endif

#ifdef TARGET_NEC_SX
C     The vector version computes plumekb2D at each grid point, but this
C     is still faster than non-vector code.
      IF ( k .LT. Nr ) THEN
#ifndef SALT_PLUME_VOLUME
       DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
         plumekb2D(i,j)=ABS(rF(k))
        ENDDO
       ENDDO
       CALL SALT_PLUME_FRAC(
     I      imt,minusone,SaltPlumeDepth(1-OLx,1-OLy,bi,bj),
#ifdef SALT_PLUME_SPLIT_BASIN
     I      XC(1-OLx,1-OLy,bi,bj),YC(1-OLx,1-OLy,bi,bj),
#endif /* SALT_PLUME_SPLIT_BASIN */
     U      plumekb2D,
     I      myTime, 1, myThid )
       DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
         plumefrac(I,J) = plumekb2D(i,j)
         plumekb2D(i,j) = ABS(rF(k+1))
        ENDDO
       ENDDO
       CALL SALT_PLUME_FRAC(
     I      imt,minusone,SaltPlumeDepth(1-OLx,1-OLy,bi,bj),
#ifdef SALT_PLUME_SPLIT_BASIN
     I      XC(1-OLx,1-OLy,bi,bj),YC(1-OLx,1-OLy,bi,bj),
#endif /* SALT_PLUME_SPLIT_BASIN */
     U      plumekb2D,
     I      myTime, 1, myThid )
#endif /* SALT_PLUME_VOLUME */
       DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
C     Penetrating saltplume fraction:cumSP(k+1)-cumSP(k)
         IF ( SaltPlumeDepth(i,j,bi,bj) .GT. ABS(rF(k)) ) THEN
#ifndef SALT_PLUME_VOLUME
          plumefrac(i,j) = ( plumekb2D(i,j)-plumefrac(i,j) )
     &                     *maskC(i,j,k,bi,bj)
          plumetend(I,J) = saltPlumeFlux(i,j,bi,bj)*plumefrac(I,J)
#else /* SALT_PLUME_VOLUME */
          plumetend(I,J) = SPforcingS(i,j,k,bi,bj)
#endif /* SALT_PLUME_VOLUME */
          gS_arr(i,j) = gS_arr(i,j) + plumetend(I,J)
     &        *recip_drF(k)*mass2rUnit*_recip_hFacC(i,j,k,bi,bj)
         ELSE
          plumefrac(i,j) = 0. _d 0
          plumetend(I,J) = 0. _d 0
         ENDIF
        ENDDO
       ENDDO
      ENDIF
#else
      DO j=jMin,jMax
       DO i=iMin,iMax
C Penetrating saltplume fraction:cumulativeSP(k+1)-cumulativeSP(k)
        IF ( SaltPlumeDepth(i,j,bi,bj) .GT. ABS(rF(k)) ) THEN
         plumefrac(I,J) = 0. _d 0
#ifndef SALT_PLUME_VOLUME
         plumekb(1)=ABS(rF(k))
         plumekb(2)=ABS(rF(k+1))
         SPdepth(1)=SaltPlumeDepth(i,j,bi,bj)
         SPdepth(2)=SaltPlumeDepth(i,j,bi,bj)
#ifdef SALT_PLUME_SPLIT_BASIN
         lon(1) = XC(i,j,bi,bj)
         lon(2) = XC(i,j,bi,bj)
         lat(1) = YC(i,j,bi,bj)
         lat(2) = YC(i,j,bi,bj)
#endif /* SALT_PLUME_SPLIT_BASIN */
         CALL SALT_PLUME_FRAC(
     I                   two2,minusone,SPdepth,
#ifdef SALT_PLUME_SPLIT_BASIN
     I                   lon,lat,
#endif /* SALT_PLUME_SPLIT_BASIN */
     U                   plumekb,
     I                   myTime, 1, myThid )
         plumefrac(I,J) = (plumekb(2)-plumekb(1))*maskC(i,j,k,bi,bj)
         plumetend(I,J) = saltPlumeFlux(i,j,bi,bj)*plumefrac(I,J)
#else /* SALT_PLUME_VOLUME */
         plumetend(i,j) = SPforcingS(i,j,k,bi,bj)
#endif /* SALT_PLUME_VOLUME */
         gS_arr(i,j) = gS_arr(i,j) + plumetend(I,J)
     &        *recip_drF(k)*mass2rUnit*_recip_hFacC(i,j,k,bi,bj)
        ELSE
         plumefrac(I,J) = 0. _d 0
         plumetend(I,J) = 0. _d 0
        ENDIF
       ENDDO
      ENDDO
#endif /* TARGET_NEC_SX */

#ifdef ALLOW_DIAGNOSTICS
      IF ( useDiagnostics ) THEN
       CALL DIAGNOSTICS_FILL (
     &      plumefrac,'PLUMEKB ',k,1,2,bi,bj,myThid )
       CALL DIAGNOSTICS_FILL (
     &      plumetend,'oceSPtnd',k,1,2,bi,bj,myThid )
      ENDIF
#endif /* ALLOW_DIAGNOSTICS */

C#endif /* SALT_PLUME_VOLUME */
#endif /* ALLOW_SALT_PLUME */

      RETURN
      END

#include "ctrparam.h"
#include "ATM2D_OPTIONS.h"

C     !INTERFACE:
      SUBROUTINE SUM_OCN_FLUXES( myThid )
C     *==========================================================*
C     | Sums the atmos-> ocn fluxes. Note the stress reduction   |
c     | (wind forcing) which occurs as icefract > windice_thres  |
C     *==========================================================*
        IMPLICIT NONE

#include "ATMSIZE.h"
#include "SIZE.h"
#include "GRID.h"
#include "EEPARAMS.h"

C     === Global SeaIce Variables ===
#include "THSICE_VARS.h"

C     === Atmos/Ocean/Seaice Interface Variables ===
#include "ATM2D_VARS.h"

c start phasing out wind stress to ocean at this ice fraction
      _RS windice_thres
      PARAMETER ( windice_thres= 0.5 )

C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
C     myThid - Thread no. that called this routine.
      INTEGER myThid

C     LOCAL VARIABLES:
      INTEGER i,j

      DO j=1, sNy
        DO i=1,sNx

          IF (maskC(i,j,1,1,1) .EQ. 1.) THEN

C         Ad hoc phase out wind stress if sufficient ice coverage
C         similar idea as stressReduction used in thsice_main
          IF (iceMask(i,j,1,1) .GT. windice_thres) THEN

           fu_2D(i,j)= fu_2D(i,j) * (1. _d 0 -
     &          (iceMask(i,j,1,1) + iceMask(i-1,j,1,1)) * 0.5 _d 0 )
     &                 / (1. _d 0 - windice_thres)
           fv_2D(i,j)= fv_2D(i,j) * (1. _d 0 -
     &          (iceMask(i,j,1,1) + iceMask(i,j-1,1,1)) * 0.5 _d 0 )
     &                 / (1. _d 0 - windice_thres)
           wspeed_2D(i,j)= wspeed_2D(i,j)
     &                    * (1. _d 0 - iceMask(i,j,1,1))
     &                    / (1. _d 0 - windice_thres)
          ENDIF

          sum_runoff(i,j)= sum_runoff(i,j) + runoff_2D(i,j)
          sum_precip(i,j)= sum_precip(i,j) +
     &                     precipo_2D(i,j)*(1. _d 0-iceMask(i,j,1,1))
          sum_evap(i,j)= sum_evap(i,j) +
     &                   evapo_2D(i,j)*(1. _d 0-iceMask(i,j,1,1))
          sum_qnet(i,j)= sum_qnet(i,j) +
     &                   qneto_2D(i,j)*(1. _d 0-iceMask(i,j,1,1))
          sum_fu(i,j)= sum_fu(i,j) + fu_2D(i,j)
          sum_fv(i,j)= sum_fv(i,j) + fv_2D(i,j)
          sum_wspeed(i,j)= sum_wspeed(i,j) + wspeed_2D(i,j)
          sum_solarnet(i,j)= sum_solarnet(i,j) +
     &               solarnet_ocn_2D(i,j)*(1. _d 0-iceMask(i,j,1,1))
          sum_slp(i,j)= sum_slp(i,j) + slp_2D(i,j)
          sum_pCO2(i,j)= sum_pCO2(i,j) + pCO2_2D(i,j)
          ENDIF
        ENDDO
      ENDDO

C      PRINT *,'Sum_ocn_fluxes:',JBUGI,JBUGJ,fu_2D(JBUGI,JBUGJ),
C     &       fv_2D(JBUGI,JBUGJ), runoff_2D(JBUGI,JBUGJ),
C     &       precipo_2D(JBUGI,JBUGJ), evapo_2D(JBUGI,JBUGJ),
C     &       qneto_2D(JBUGI,JBUGJ)

      RETURN
      END

#include "EXF_OPTIONS.h"
#ifdef ALLOW_AUTODIFF
# include "AUTODIFF_OPTIONS.h"
#endif

CBOP 0
C     !ROUTINE: EXF_MAPFIELDS

C     !INTERFACE:
      SUBROUTINE EXF_MAPFIELDS( myTime, myIter, myThid )

C     !DESCRIPTION:
C     ==================================================================
C     SUBROUTINE EXF_MAPFIELDS
C     ==================================================================
C
C     o Map external forcing fields (ustress, vstress, hflux, sflux,
C       swflux, apressure, climsss, climsst, etc.) onto ocean model
C       arrays (fu, fv, Qnet, EmPmR, Qsw, pLoad, SSS, SST, etc.).
C       This routine is included to separate the ocean state estimation
C       tool as much as possible from the ocean model.  Unit and sign
C       conventions can be customized using variables exf_outscal_*,
C       which are set in exf_readparms.F.  See the header files
C       EXF_FIELDS.h and FFIELDS.h for definitions of the various input
C       and output fields and for default unit and sign convetions.
C
C     started: Christian Eckert eckert@mit.edu  09-Aug-1999
C
C     changed: Christian Eckert eckert@mit.edu  11-Jan-2000
C              - Restructured the code in order to create a package
C                for the MITgcmUV.
C
C              Christian Eckert eckert@mit.edu  12-Feb-2000
C              - Changed Routine names (package prefix: exf_)
C
C              Patrick Heimbach, heimbach@mit.edu  06-May-2000
C              - added and changed CPP flag structure for
C                ALLOW_BULKFORMULAE, ALLOW_ATM_TEMP
C
C              Patrick Heimbach, heimbach@mit.edu  23-May-2000
C              - sign change of ustress/vstress incorporated into
C                scaling factors exf_outscal_ust, exf_outscal_vst
C
C     mods for pkg/seaice: menemenlis@jpl.nasa.gov 20-Dec-2002
C
C     ==================================================================
C     SUBROUTINE EXF_MAPFIELDS
C     ==================================================================

C     !USES:
      IMPLICIT NONE

C     == global variables ==
#include "EEPARAMS.h"
#include "SIZE.h"
#include "PARAMS.h"
#include "FFIELDS.h"
#include "GRID.h"
#include "DYNVARS.h"

#include "EXF_PARAM.h"
#include "EXF_CONSTANTS.h"
#include "EXF_FIELDS.h"
#ifdef ALLOW_AUTODIFF_TAMC
# include "tamc.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     myTime  :: Current time in simulation
C     myIter  :: Current iteration number
C     myThid  :: my Thread Id number
      _RL     myTime
      INTEGER myIter
      INTEGER myThid

C     !LOCAL VARIABLES:
      INTEGER bi,bj
      INTEGER i,j,ks
      INTEGER imin, imax
      INTEGER jmin, jmax
      PARAMETER ( imin = 1-OLx , imax = sNx+OLx )
      PARAMETER ( jmin = 1-OLy , jmax = sNy+OLy )
#ifdef ALLOW_AUTODIFF_TAMC
      INTEGER ikey
#endif
CEOP

C--   set surface level index:
      ks = 1
      IF ( usingPCoords ) ks = Nr

      DO bj = myByLo(myThid),myByHi(myThid)
       DO bi = myBxLo(myThid),myBxHi(myThid)

#ifdef ALLOW_AUTODIFF_TAMC
          ikey = bi + (bj-1)*nSx + (ikey_dynamics-1)*nSx*nSy
#endif /* ALLOW_AUTODIFF_TAMC */

C     Heat flux.
          DO j = jmin,jmax
            DO i = imin,imax
             Qnet(i,j,bi,bj) = exf_outscal_hflux*hflux(i,j,bi,bj)
            ENDDO
          ENDDO
          IF ( hfluxfile .EQ. ' ' ) THEN
           DO j = jmin,jmax
            DO i = imin,imax
             Qnet(i,j,bi,bj) = Qnet(i,j,bi,bj) -
     &            exf_outscal_hflux * ( hflux_exfremo_intercept +
     &            hflux_exfremo_slope*(myTime-startTime) )
            ENDDO
           ENDDO
          ENDIF

C     Freshwater flux.
          DO j = jmin,jmax
            DO i = imin,imax
             EmPmR(i,j,bi,bj)= exf_outscal_sflux*sflux(i,j,bi,bj)
     &                                          *rhoConstFresh
            ENDDO
          ENDDO
          IF ( sfluxfile .EQ. ' ' ) THEN
           DO j = jmin,jmax
            DO i = imin,imax
             EmPmR(i,j,bi,bj) = EmPmR(i,j,bi,bj) - rhoConstFresh*
     &            exf_outscal_sflux * ( sflux_exfremo_intercept +
     &            sflux_exfremo_slope*(myTime-startTime) )
            ENDDO
           ENDDO
          ENDIF

#ifdef ALLOW_ATM_TEMP
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
          IF ( temp_EvPrRn .NE. UNSET_RL ) THEN
C--   Account for energy content of Precip + RunOff & Evap. Assumes:
C     1) Rain has same temp as Air
C     2) Snow has no heat capacity (consistent with seaice & thsice pkgs)
C     3) No distinction between sea-water Cp and fresh-water Cp
C     4) By default, RunOff comes at the temp of surface water (with same Cp);
C        ifdef ALLOW_RUNOFTEMP, RunOff temp can be specified in runoftempfile.
C     5) Evap is released to the Atmos @ surf-temp (=SST); should be using
C        the water-vapor heat capacity here and consistently in Bulk-Formulae;
C        Could also be put directly into Latent Heat flux.
           IF ( snowPrecipFile .NE. ' ' ) THEN
C--   Melt snow (if provided) into the ocean and account for rain-temp
            DO j = 1, sNy
             DO i = 1, sNx
              Qnet(i,j,bi,bj) = Qnet(i,j,bi,bj)
     &              + flami*snowPrecip(i,j,bi,bj)*rhoConstFresh
     &              - HeatCapacity_Cp
     &               *( atemp(i,j,bi,bj) - cen2kel - temp_EvPrRn )
     &               *( precip(i,j,bi,bj)- snowPrecip(i,j,bi,bj) )
     &               *rhoConstFresh
             ENDDO
            ENDDO
           ELSE
C--   Make snow (according to Air Temp) and melt it in the ocean
C     note: here we just use the same criteria as over seaice but would be
C           better to consider a higher altitude air temp, e.g., 850.mb
            DO j = 1, sNy
             DO i = 1, sNx
              IF ( atemp(i,j,bi,bj).LT.cen2kel ) THEN
               Qnet(i,j,bi,bj) = Qnet(i,j,bi,bj)
     &              + flami*precip(i,j,bi,bj)*rhoConstFresh
              ELSE
C--   Account for rain-temp
               Qnet(i,j,bi,bj) = Qnet(i,j,bi,bj)
     &              - HeatCapacity_Cp
     &               *( atemp(i,j,bi,bj) - cen2kel - temp_EvPrRn )
     &               *precip(i,j,bi,bj)*rhoConstFresh
              ENDIF
             ENDDO
            ENDDO
           ENDIF
#ifdef ALLOW_RUNOFF
C--   Account for energy content of RunOff:
           DO j = 1, sNy
            DO i = 1, sNx
              Qnet(i,j,bi,bj) = Qnet(i,j,bi,bj)
     &              - HeatCapacity_Cp
     &               *( theta(i,j,ks,bi,bj) - temp_EvPrRn )
     &               *runoff(i,j,bi,bj)*rhoConstFresh
            ENDDO
           ENDDO
#endif
C--   Account for energy content of Evap:
           DO j = 1, sNy
            DO i = 1, sNx
              Qnet(i,j,bi,bj) = Qnet(i,j,bi,bj)
     &              + HeatCapacity_Cp
     &               *( theta(i,j,ks,bi,bj) - temp_EvPrRn )
     &               *evap(i,j,bi,bj)*rhoConstFresh
              Qnet(i,j,bi,bj) = Qnet(i,j,bi,bj)*maskC(i,j,ks,bi,bj)
            ENDDO
           ENDDO
          ENDIF
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
#endif /* ALLOW_ATM_TEMP */
#if defined(ALLOW_RUNOFF) && defined(ALLOW_RUNOFTEMP)
          IF ( runoftempfile .NE. ' ' ) THEN
C--   Add energy content of RunOff
           DO j = 1, sNy
            DO i = 1, sNx
               Qnet(i,j,bi,bj) = Qnet(i,j,bi,bj)
     &              + HeatCapacity_Cp
     &              *( theta(i,j,ks,bi,bj) - runoftemp(i,j,bi,bj) )
     &              *runoff(i,j,bi,bj)*rhoConstFresh
            ENDDO
           ENDDO
          ENDIF
#endif

#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE ustress(:,:,bi,bj) = comlev1_bibj, key=ikey, byte=isbyte
#endif
          DO j = jmin,jmax
            DO i = imin,imax
C             Zonal wind stress.
              IF (ustress(i,j,bi,bj).GT.windstressmax) THEN
                ustress(i,j,bi,bj)=windstressmax
              ENDIF
            ENDDO
          ENDDO
#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE ustress(:,:,bi,bj) = comlev1_bibj, key=ikey, byte=isbyte
#endif
          DO j = jmin,jmax
            DO i = imin,imax
              IF (ustress(i,j,bi,bj).LT.-windstressmax) THEN
                ustress(i,j,bi,bj)=-windstressmax
              ENDIF
            ENDDO
          ENDDO
          IF ( stressIsOnCgrid ) THEN
           DO j = jmin,jmax
            DO i = imin+1,imax
              fu(i,j,bi,bj) = exf_outscal_ustress*ustress(i,j,bi,bj)
            ENDDO
           ENDDO
          ELSE
           DO j = jmin,jmax
            DO i = imin+1,imax
C     Shift wind stresses calculated at Grid-center to W/S points
              fu(i,j,bi,bj) = exf_outscal_ustress*
     &              (ustress(i,j,bi,bj)+ustress(i-1,j,bi,bj))
     &              *exf_half*maskW(i,j,ks,bi,bj)
            ENDDO
           ENDDO
          ENDIF

#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE vstress(:,:,bi,bj) = comlev1_bibj, key=ikey, byte=isbyte
#endif
          DO j = jmin,jmax
            DO i = imin,imax
C             Meridional wind stress.
              IF (vstress(i,j,bi,bj).GT.windstressmax) THEN
                vstress(i,j,bi,bj)=windstressmax
              ENDIF
            ENDDO
          ENDDO
#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE vstress(:,:,bi,bj) = comlev1_bibj, key=ikey, byte=isbyte
#endif
          DO j = jmin,jmax
            DO i = imin,imax
              IF (vstress(i,j,bi,bj).LT.-windstressmax) THEN
                vstress(i,j,bi,bj)=-windstressmax
              ENDIF
            ENDDO
          ENDDO
          IF ( stressIsOnCgrid ) THEN
           DO j = jmin+1,jmax
            DO i = imin,imax
              fv(i,j,bi,bj) = exf_outscal_vstress*vstress(i,j,bi,bj)
            ENDDO
           ENDDO
          ELSE
           DO j = jmin+1,jmax
            DO i = imin,imax
C     Shift wind stresses calculated at C-points to W/S points
              fv(i,j,bi,bj) = exf_outscal_vstress*
     &              (vstress(i,j,bi,bj)+vstress(i,j-1,bi,bj))
     &              *exf_half*maskS(i,j,ks,bi,bj)
            ENDDO
           ENDDO
          ENDIF

#if defined(ALLOW_ATM_TEMP) || defined(SHORTWAVE_HEATING)
C             Short wave radiative flux.
          DO j = jmin,jmax
            DO i = imin,imax
             Qsw(i,j,bi,bj)  = exf_outscal_swflux*swflux(i,j,bi,bj)
            ENDDO
          ENDDO
#endif

#ifdef ALLOW_CLIMSST_RELAXATION
          DO j = jmin,jmax
            DO i = imin,imax
             SST(i,j,bi,bj)  = exf_outscal_sst*climsst(i,j,bi,bj)
            ENDDO
          ENDDO
#endif

#ifdef ALLOW_CLIMSSS_RELAXATION
          DO j = jmin,jmax
            DO i = imin,imax
             SSS(i,j,bi,bj)  = exf_outscal_sss*climsss(i,j,bi,bj)
            ENDDO
          ENDDO
#endif

#ifdef ATMOSPHERIC_LOADING
C-    subtract "surf_pRef" to fill in atmos. pressure anomaly "pLoad"
          DO j = jmin,jmax
            DO i = imin,imax
             pLoad(i,j,bi,bj) =
     &          exf_outscal_apressure*apressure(i,j,bi,bj) - surf_pRef
            ENDDO
          ENDDO
#endif

#ifdef EXF_ALLOW_TIDES
          DO j = jmin,jmax
            DO i = imin,imax
             phiTide2d(i,j,bi,bj)=exf_outscal_tidePot*tidePot(i,j,bi,bj)
            ENDDO
          ENDDO
#endif /* EXF_ALLOW_TIDES */

#ifdef ALLOW_SALTFLX
          DO j = jmin,jmax
            DO i = imin,imax
              saltFlux(i,j,bi,bj) = saltflx(i,j,bi,bj)
            ENDDO
          ENDDO
#endif

#ifdef EXF_SEAICE_FRACTION
          DO j = jmin,jmax
            DO i = imin,imax
              exf_iceFraction(i,j,bi,bj) =
     &           exf_outscal_areamask*areamask(i,j,bi,bj)
              exf_iceFraction(i,j,bi,bj) =
     &           MIN( MAX(exf_iceFraction(i,j,bi,bj),zeroRS), oneRS )
            ENDDO
          ENDDO
#endif

       ENDDO
      ENDDO

C--   Update the tile edges.
      _EXCH_XY_RS(  Qnet, myThid )
      _EXCH_XY_RS( EmPmR, myThid )
       CALL EXCH_UV_XY_RS(fu, fv, .TRUE., myThid)
c#if defined(ALLOW_ATM_TEMP) || defined(SHORTWAVE_HEATING)
#ifdef SHORTWAVE_HEATING
C     Qsw used in SHORTWAVE_HEATING code & for diagnostics (<- EXCH not needed)
      _EXCH_XY_RS(   Qsw, myThid )
#endif
#ifdef ALLOW_CLIMSST_RELAXATION
      _EXCH_XY_RS(   SST, myThid )
#endif
#ifdef ALLOW_CLIMSSS_RELAXATION
      _EXCH_XY_RS(   SSS, myThid )
#endif
#ifdef ATMOSPHERIC_LOADING
      _EXCH_XY_RS( pLoad, myThid )
#endif
#ifdef EXF_ALLOW_TIDES
      _EXCH_XY_RS( phiTide2d, myThid )
#endif
#ifdef EXF_SEAICE_FRACTION
      _EXCH_XY_RS( exf_iceFraction, myThid )
#endif

      RETURN
      END

#include "THSICE_OPTIONS.h"

CBOP
C     !ROUTINE: THSICE_AVE
C     !INTERFACE:
      SUBROUTINE THSICE_AVE(
     I                       bi, bj, myTime, myIter, myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R  THSICE_AVE
C     | o fill some thsice diagnostics
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "FFIELDS.h"
#include "THSICE_PARAMS.h"
#include "THSICE_VARS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     frwAtm  :: net fresh-water flux (E-P) to the atmosphere [kg/m2/s]
C     flxAtm  :: net heat flux from the atmosphere (+=down) [W/m2]
C     bi,bj   :: tile indices
C     myTime  :: time counter for this thread
C     myIter  :: iteration counter for this thread
C     myThid  :: thread number for this instance of the routine.
c     _RL frwAtm(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
c     _RL flxAtm(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER bi,bj
      _RL  myTime
      INTEGER myIter
      INTEGER myThid
CEOP

#ifdef ALLOW_THSICE
C     !FUNCTIONS:
c     LOGICAL  DIFFERENT_MULTIPLE
c     EXTERNAL DIFFERENT_MULTIPLE

C     !LOCAL VARIABLES:
c     INTEGER wrtIter

c     IF ( DIFFERENT_MULTIPLE(thSIce_diagFreq,
c    &                        myTime+deltaTClock,deltaTClock)
c    &     .AND. fluidIsWater ) THEN
c       wrtIter = myIter+1
c       CALL WRITE_LOCAL_RL('ice_flxAtm','I10',1,flxAtm,
c    &                      bi,bj,1,wrtIter,myThid)
c       CALL WRITE_LOCAL_RL('ice_frwAtm','I10',1,frwAtm,
c    &                      bi,bj,1,wrtIter,myThid)
c     ENDIF

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#ifdef ALLOW_DIAGNOSTICS
      IF ( useDiagnostics ) THEN

C-- Atmospheric fluxes :
       IF ( fluidIsWater ) THEN
        CALL DIAGNOSTICS_FILL(icFlxAtm,'SIflxAtm',0,1,1,bi,bj,myThid)
        CALL DIAGNOSTICS_FILL(icFrwAtm,'SIfrwAtm',0,1,1,bi,bj,myThid)
       ENDIF

C-- Oceanic fluxes :
c #ifndef CHECK_ENERGY_CONSERV
       CALL DIAGNOSTICS_FILL_RS(Qnet,    'SIflx2oc',0,1,1,bi,bj,myThid)
       CALL DIAGNOSTICS_FILL_RS(EmPmR,   'SIfrw2oc',0,1,1,bi,bj,myThid)
       CALL DIAGNOSTICS_FILL_RS(saltFlux,'SIsaltFx',0,1,1,bi,bj,myThid)
c #endif /* CHECK_ENERGY_CONSERV */

      ENDIF
#endif /* ALLOW_DIAGNOSTICS */

#endif  /* ALLOW_THSICE */

      RETURN
      END

#include "SHAP_FILT_OPTIONS.h"
 
CBOP
C     !ROUTINE: SHAP_FILT_TRACER_S1
C     !INTERFACE:
      SUBROUTINE SHAP_FILT_TRACER_S1( 
     U           field, tmpFld,
     I           nShapTr, kSize, myTime, myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R SHAP_FILT_TRACER_S1
C     | o Applies Shapiro filter to tracer field (cell center).
C     | o use filtering function "S1" = [1 - d_xx^n - d_yy^n]
C     |     with no grid spacing (computational Filter)
C     *==========================================================*
C     \ev
 
C     !USES:
      IMPLICIT NONE
 
C     == Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "SHAP_FILT.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments
C     field :: cell-centered 2D field on which filter applies
C     tmpFld :: working temporary array
C     nShapTr :: (total) power of the filter for this tracer
C     kSize :: length of 3rd Dim : either =1 (2D field) or =Nr (3D field)
C     myTime :: Current time in simulation
C     myThid :: Thread number for this instance of SHAP_FILT_TRACER_S1
      INTEGER nShapTr, kSize
      _RL field(1-OLx:sNx+OLx,1-OLy:sNy+OLy,kSize,nSx,nSy)
      _RL tmpFld(1-OLx:sNx+OLx,1-OLy:sNy+OLy,kSize,nSx,nSy)
      _RL     myTime
      INTEGER myThid
 
#ifdef ALLOW_SHAP_FILT

C     !LOCAL VARIABLES:
C     == Local variables ==
      INTEGER bi,bj,K,I,J,N
      _RL tmpGrd(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL tmpScal
CEOP

      IF (nShapTr.gt.0) THEN

        DO bj=myByLo(myThid),myByHi(myThid)
         DO bi=myBxLo(myThid),myBxHi(myThid)
          DO K=1,kSize
           DO J=1-OLy,sNy+OLy
            DO I=1-OLx,sNx+OLx
             tmpFld(i,j,k,bi,bj)=field(i,j,k,bi,bj)
            ENDDO
           ENDDO
          ENDDO
         ENDDO
        ENDDO


C      d_xx^n tmpFld 

       DO N=1,nShapTr

        IF (kSize.EQ.Nr) THEN
          _EXCH_XYZ_RL( tmpFld, myThid )
        ELSE
          _EXCH_XY_RL( tmpFld, myThid )
        ENDIF

        DO bj=myByLo(myThid),myByHi(myThid)
         DO bi=myBxLo(myThid),myBxHi(myThid)
          DO K=1,kSize

           DO J=1,sNy
            DO I=1,sNx
             tmpGrd(i,j) = -0.25*(
     &        ( tmpFld(i+1,j,k,bi,bj)-tmpFld( i ,j,k,bi,bj) )
     &            *_maskW(i+1,j,k,bi,bj)
     &       -( tmpFld( i ,j,k,bi,bj)-tmpFld(i-1,j,k,bi,bj) )
     &            *_maskW(i,j,k,bi,bj) )
            ENDDO
           ENDDO

           DO J=1,sNy
            DO I=1,sNx
             tmpFld(i,j,k,bi,bj) = tmpGrd(i,j)
            ENDDO
           ENDDO

          ENDDO
         ENDDO
        ENDDO

       ENDDO

C      F <-  [1 - d_xx^n *deltaT/tau].F
       DO bj=myByLo(myThid),myByHi(myThid)
        DO bi=myBxLo(myThid),myBxHi(myThid)
         DO K=1,kSize
          DO J=1,sNy
           DO I=1,sNx
            tmpScal=field(i,j,k,bi,bj)
            field(i,j,k,bi,bj)=field(i,j,k,bi,bj)
     &          -0.5*tmpFld(i,j,k,bi,bj)*dTtracerLev(1)/Shap_Trtau
            tmpFld(i,j,k,bi,bj)=tmpScal
           ENDDO
          ENDDO
         ENDDO
        ENDDO
       ENDDO


C      d_yy^n tmpFld 

       DO N=1,nShapTr

        IF (kSize.EQ.Nr) THEN
          _EXCH_XYZ_RL( tmpFld, myThid )
        ELSE
          _EXCH_XY_RL( tmpFld, myThid )
        ENDIF

        DO bj=myByLo(myThid),myByHi(myThid)
         DO bi=myBxLo(myThid),myBxHi(myThid)
          DO K=1,kSize

           DO J=1,sNy
            DO I=1,sNx
             tmpGrd(i,j) = -0.25*(
     &        ( tmpFld(i,j+1,k,bi,bj)-tmpFld(i, j ,k,bi,bj) )
     &            *_maskS(i,j+1,k,bi,bj)
     &       -( tmpFld(i, j ,k,bi,bj)-tmpFld(i,j-1,k,bi,bj) )
     &            *_maskS(i,j,k,bi,bj) )
            ENDDO
           ENDDO

           DO J=1,sNy
            DO I=1,sNx
             tmpFld(i,j,k,bi,bj) = tmpGrd(i,j)
            ENDDO
           ENDDO

          ENDDO
         ENDDO
        ENDDO

       ENDDO

C      F <-  [1 - d_yy^n *deltaT/tau].F
       DO bj=myByLo(myThid),myByHi(myThid)
        DO bi=myBxLo(myThid),myBxHi(myThid)
         DO K=1,kSize
          DO J=1,sNy
           DO I=1,sNx
            field(i,j,k,bi,bj)=field(i,j,k,bi,bj)
     &          -0.5*tmpFld(i,j,k,bi,bj)*dTtracerLev(1)/Shap_Trtau
           ENDDO
          ENDDO
         ENDDO
        ENDDO
       ENDDO

        IF (kSize.EQ.Nr) THEN
          _EXCH_XYZ_RL( field, myThid )
        ELSEIF (kSize.EQ.1) THEN
          _EXCH_XY_RL( field, myThid )
        ELSE
          STOP 'S/R SHAP_FILT_TRACER_S1: kSize is wrong'
        ENDIF

      ENDIF
#endif /* ALLOW_SHAP_FILT */

      RETURN
      END

#include "MOM_COMMON_OPTIONS.h"

CBOP
C !ROUTINE: MOM_W_SIDEDRAG

C !INTERFACE: ==========================================================
      SUBROUTINE MOM_W_SIDEDRAG(
     I        bi,bj,k,
     I        wFld, del2w, 
     I        rThickC, recip_rThickC,
     I        viscAh_W, viscA4_W,
     O        gwSideDrag,
     I        myThid)

C !DESCRIPTION:
C Calculates the drag terms due to the no-slip condition on viscous stresses:
C \begin{equation*}
C G^w_{drag} = - \frac{2}{\Delta x_w} (A_h w - A_4 \nabla^2 w)
C \end{equation*}

C !USES: ===============================================================
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "SURFACE.h"

C !INPUT PARAMETERS: ===================================================
C  bi,bj                :: tile indices
C  k                    :: vertical level
C  wFld                 :: vertical velocity
C  del2w                :: Laplacian of vertical velocity
C  rThickC              :: thickness of W-cell
C  recip_rThickC        :: reciprol of W-cell thickness
C  viscAh_W             :: harmonic   horizontal viscosity (at W-Cell center)
C  viscA4_W             :: biharmonic horizontal viscosity (at W-Cell center)
C  myThid               :: my Thread Id number
      INTEGER bi,bj,k
      _RL  wFld    (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      _RL  del2w   (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL  rThickC (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL recip_rThickC(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL  viscAh_W(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      _RL  viscA4_W(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      INTEGER myThid

C !OUTPUT PARAMETERS: ==================================================
C  gwSideDrag           :: side drag tendency
      _RL gwSideDrag(1-OLx:sNx+OLx,1-OLy:sNy+OLy)

#ifdef ALLOW_NONHYDROSTATIC
C !LOCAL VARIABLES: ====================================================
C  i,j                  :: loop indices
C  heightStepW          :: height of topographic step to West
C  heightStepE          :: height of topographic step to East
C  heightStepS          :: height of topographic step to South
C  heightStepN          :: height of topographic step to North
      INTEGER i,j
      _RL heightStepW, heightStepE
      _RL heightStepS, heightStepN
CEOP

C--   Laplacian and bi-harmonic terms: using variable-Viscosity coeff.
C     from MOM_CALC_VISC, consistent with dissipation in the interior

      DO j=2-Oly,sNy+Oly-1
       DO i=2-Olx,sNx+Olx-1
C-      this will not give any side-drag along thin wall.
C       (but this might just be what we want ...)
        heightStepW = MAX( 0. _d 0, rThickC(i,j) - rThickC(i-1,j) )
        heightStepE = MAX( 0. _d 0, rThickC(i,j) - rThickC(i+1,j) )
        heightStepS = MAX( 0. _d 0, rThickC(i,j) - rThickC(i,j-1) )
        heightStepN = MAX( 0. _d 0, rThickC(i,j) - rThickC(i,j+1) )
C- jmc: take directly viscAh_W & viscA4_W (no bar_i, bar_j) since
C       they are already at the center (and not above u,v point).
        gwSideDrag(i,j) = 
     &   -sideDragFactor
     &    *( heightStepW*_dyG( i ,j,bi,bj)*_recip_dxC( i ,j,bi,bj)
     &         *( viscAh_W(i,j,k,bi,bj)*wFld(i,j,k,bi,bj)
     &                                 *cosFacV(j,bi,bj)
     &           -viscA4_W(i,j,k,bi,bj)*del2w(i,j)
#ifdef COSINEMETH_III
     &                                 *sqCosFacU(j,bi,bj)
#else
     &                                 *cosFacU(j,bi,bj)
#endif
     &          )
     &     +heightStepE*_dyG(i+1,j,bi,bj)*_recip_dxC(i+1,j,bi,bj)
     &         *( viscAh_W(i,j,k,bi,bj)*wFld(i,j,k,bi,bj)
     &                                 *cosFacV(j,bi,bj)
     &           -viscA4_W(i,j,k,bi,bj)*del2w(i,j)
#ifdef COSINEMETH_III
     &                                 *sqCosFacU(j,bi,bj)
#else
     &                                 *cosFacU(j,bi,bj)
#endif
     &          )
     &     +heightStepS*_dxG(i,j,bi,bj)*_recip_dyC(i,j,bi,bj)
     &         *( viscAh_W(i,j,k,bi,bj)*wFld(i,j,k,bi,bj)
#ifdef ISOTROPIC_COS_SCALING
     &                                 *cosFacV(j,bi,bj)
#endif
     &           -viscA4_W(i,j,k,bi,bj)*del2w(i,j)
#ifdef ISOTROPIC_COS_SCALING
# ifdef COSINEMETH_III
     &                                 *sqCosFacV(j,bi,bj)
# else
     &                                 *cosFacV(j,bi,bj)
# endif
#endif
     &          )
     &     +heightStepN*_dxG(i,j+1,bi,bj)*_recip_dyC(i,j+1,bi,bj)
     &         *( viscAh_W(i,j,k,bi,bj)*wFld(i,j,k,bi,bj)
#ifdef ISOTROPIC_COS_SCALING
     &                                 *cosFacV(j+1,bi,bj)
#endif
     &           -viscA4_W(i,j,k,bi,bj)*del2w(i,j)
#ifdef ISOTROPIC_COS_SCALING
# ifdef COSINEMETH_III
     &                                 *sqCosFacV(j+1,bi,bj)
# else
     &                                 *cosFacV(j+1,bi,bj)
# endif
#endif
     &          )
     &    )*recip_rThickC(i,j)*recip_rA(i,j,bi,bj)
       ENDDO
      ENDDO

#ifdef ALLOW_DIAGNOSTICS
      IF (useDiagnostics) THEN
        CALL DIAGNOSTICS_FILL(gwSideDrag,'WSidDrag',k,1,2,bi,bj,myThid)
      ENDIF
#endif /* ALLOW_DIAGNOSTICS */

#endif /* ALLOW_NONHYDROSTATIC */

      RETURN
      END

#include "SHELFICE_OPTIONS.h"
#ifdef ALLOW_COST
# include "COST_OPTIONS.h"
#endif
#ifdef ALLOW_CTRL
# include "CTRL_OPTIONS.h"
#endif
#ifdef ALLOW_MOM_COMMON
# include "MOM_COMMON_OPTIONS.h"
#endif

      SUBROUTINE SHELFICE_INIT_FIXED( myThid )
C     *============================================================*
C     | SUBROUTINE SHELFICE_INIT_FIXED
C     | o Routine to initialize SHELFICE parameters and variables.
C     *============================================================*
C     | Initialize SHELFICE parameters and variables.
C     *============================================================*
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "SHELFICE.h"
#ifdef ALLOW_COST
# include "cost.h"
# include "SHELFICE_COST.h"
#endif /* ALLOW_COST */

C     === Routine arguments ===
C     myThid ::  Number of this instance of SHELFICE_INIT_FIXED
      INTEGER myThid

#ifdef ALLOW_SHELFICE
C     === Local variables ===
C     i, j, bi, bj :: Loop counters
C     SHI_minDepth :: minimum Ice-Shelf depth
C     msgBuf       :: Informational/error message buffer
      INTEGER i, j, bi, bj
      _RS SHI_minDepth
      CHARACTER*(MAX_LEN_MBUF) msgBuf
#ifdef ALLOW_DIAGNOSTICS
      INTEGER       diagNum
      INTEGER       diagMate
      CHARACTER*8   diagName
      CHARACTER*16  diagCode
      CHARACTER*16  diagUnits
      CHARACTER*(80) diagTitle
#endif /* ALLOW_DIAGNOSTICS */
#if defined ALLOW_CTRL || defined ALLOW_ECCO
      INTEGER k
#endif

#ifdef ALLOW_MNC
C     Initialize MNC variable information for SHELFICE
      IF ( useMNC .AND. shelfice_dump_mnc ) THEN
        CALL SHELFICE_MNC_INIT( myThid )
      ENDIF
#endif /* ALLOW_MNC */

      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
        DO j = 1-OLy, sNy+OLy
         DO i = 1-OLx, sNx+OLx
          shelficeMassInit   (i,j,bi,bj) = 0. _d 0
          shelficeLoadAnomaly(i,j,bi,bj) = 0. _d 0
          shelfIceMassDynTendency(i,j,bi,bj) = 0. _d 0
         ENDDO
        ENDDO
       ENDDO
      ENDDO

      IF ( SHELFICEloadAnomalyFile .NE. ' ' ) THEN
       CALL READ_FLD_XY_RL( SHELFICEloadAnomalyFile, ' ',
     &                      shelficeLoadAnomaly, 0, myThid )
      ENDIF
      IF ( SHELFICEmassFile.NE.' ' ) THEN
       CALL READ_FLD_XY_RL( SHELFICEmassFile, ' ',
     &                      shelficeMassInit, 0, myThid )
      ELSE
       DO bj = myByLo(myThid), myByHi(myThid)
        DO bi = myBxLo(myThid), myBxHi(myThid)
         DO j = 1, sNy
          DO i = 1, sNx
           shelficeMassInit(i,j,bi,bj) =
     &         shelficeLoadAnomaly(i,j,bi,bj)*recip_gravity
     &       - rhoConst*Ro_surf(i,j,bi,bj)
          ENDDO
         ENDDO
        ENDDO
       ENDDO
      ENDIF
      _EXCH_XY_RL( shelficeMassInit, myThid )

C-----------------------------------------------------------------------
C--   Initialize SHELFICE variables kTopC
C--   kTopC is the same as kSurfC, except outside ice-shelf area:
C--   kTop = 0 where there is no ice-shelf (where kSurfC=1)
C--   and over land (completely dry column) where kSurfC = Nr+1
C-----------------------------------------------------------------------

C--   Currently, there is no specific pkg/shelfice criteria to decide when very
C     thin ice-shelf vanishes: some limits come from ocean hFacMin/hFacMinDr;
C     but should depend on shelficeMass if SHELFICEMassStepping is used.
C     Here the SHI_minDepth threshold is just to get around machine round-off
C     isssues so does not need to be a run-time params.
      SHI_minDepth = 1. _d -6
      SHI_minDepth = rF(1) - drF(1)*SHI_minDepth
      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
        IF ( SHELFICEMassStepping ) THEN
C-      In this case, it is recommended to initialise ice-shelf Mass (from file)
C       And if updating "kTopC" is permitted (SHI_update_kTopC=T), kTopC will
C       be reset in SHELFICE_INIT_VARIA after loading shelficeMass from pickup
         DO j = 1-OLy, sNy+OLy
          DO i = 1-OLx, sNx+OLx
           IF ( kSurfC(i,j,bi,bj).LE.Nr .AND.
     &          shelficeMassInit(i,j,bi,bj).GT.zeroRL ) THEN
            kTopC(i,j,bi,bj) = kSurfC(i,j,bi,bj)
           ELSE
            kTopC(i,j,bi,bj) = 0
           ENDIF
          ENDDO
         ENDDO
        ELSE
C-      no time-evolving Ice-Shelf: set kTopC according to Ro_surf
C       Note: use Ro_surf instead of R_shelfIce to stay consistent
C             with ocean mask & hFac, see issue #99
         DO j = 1-OLy, sNy+OLy
          DO i = 1-OLx, sNx+OLx
           IF ( kSurfC(i,j,bi,bj).LE.Nr .AND.
     &          Ro_surf(i,j,bi,bj).LT.SHI_minDepth ) THEN
c    &          R_shelfIce(i,j,bi,bj).LT.rF(1) ) THEN
            kTopC(i,j,bi,bj) = kSurfC(i,j,bi,bj)
           ELSE
            kTopC(i,j,bi,bj) = 0
           ENDIF
          ENDDO
         ENDDO
        ENDIF
       ENDDO
      ENDDO

#if defined ALLOW_CTRL || defined ALLOW_ECCO
C     maskSHI is a hack to play along with the general ctrl-package
C     infrastructure, where only the k=1 layer of a 3D mask is used
C     for 2D fields. We cannot use maskInC instead, because routines
C     like ctrl_get_gen and ctrl_set_unpack_xy require 3D masks.
      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
        DO k=1,Nr
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           maskSHI(i,j,k,bi,bj) = 0. _d 0
          ENDDO
         ENDDO
        ENDDO
        DO k=1,Nr
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           IF ( kTopC(i,j,bi,bj).GE.1
     &          .AND. maskC(i,j,k,bi,bj).NE.zeroRS ) THEN
            maskSHI(i,j,k,bi,bj) = 1. _d 0
            maskSHI(i,j,1,bi,bj) = 1. _d 0
           ENDIF
          ENDDO
         ENDDO
        ENDDO
       ENDDO
      ENDDO
#endif /* ALLOW_CTRL */

      IF ( debugLevel.GE.debLevC ) THEN
       WRITE(msgBuf,'(A)')
     &  'SHELFICE_INIT_FIXED: checking Ice-Shelf extension & kTopC'
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                     SQUEEZE_RIGHT, myThid )
       WRITE(msgBuf,'(A,1PE18.10)')
     &  'SHELFICE_INIT_FIXED:  SHI_minDepth =', SHI_minDepth
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                     SQUEEZE_RIGHT, myThid )
       DO bj = myByLo(myThid), myByHi(myThid)
        DO bi = myBxLo(myThid), myBxHi(myThid)
c        DO j = 1-OLy, sNy+OLy
c         DO i = 1-OLx, sNx+OLx
         DO j = 1, sNy
          DO i = 1, sNx
           IF ( kTopC(i,j,bi,bj).NE.0 .AND.
     &          ( shelficeMassInit(i,j,bi,bj).LE.zeroRL
     &            .OR. R_shelfIce(i,j,bi,bj).GE.rF(1) ) ) THEN
             WRITE(standardMessageUnit,'(A,2I4,2I3,A,1P3E17.9)')
     &        ' Ice-Shelf (kTopC>0) in i,j,bi,bj=', i, j, bi, bj,
     &        ' but R_shelf,Ro_surf,MassIni=', R_shelfIce(i,j,bi,bj),
     &         Ro_surf(i,j,bi,bj), shelficeMassInit(i,j,bi,bj)
           ELSEIF ( kTopC(i,j,bi,bj).EQ.0 .AND.
     &          ( shelficeMassInit(i,j,bi,bj).GT.zeroRL
     &            .OR. R_shelfIce(i,j,bi,bj).LT.rF(1) ) ) THEN
             WRITE(standardMessageUnit,'(A,2I4,2I3,A,1P3E17.9)')
     &        ' no Ice-Shelf (kTopC=0) i,j,bi,bj=', i, j, bi, bj,
     &        ' but R_shelf,Ro_surf,MassIni=', R_shelfIce(i,j,bi,bj),
     &         Ro_surf(i,j,bi,bj), shelficeMassInit(i,j,bi,bj)
           ENDIF
          ENDDO
         ENDDO
        ENDDO
       ENDDO
       WRITE(msgBuf,'(A)')
     &  'SHELFICE_INIT_FIXED: checking Ice-Shelf extension: done'
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                     SQUEEZE_RIGHT, myThid )
      ENDIF
c     IF ( SHELFICEloadAnomalyFile .EQ. ' ' ) THEN
C-   In case we need shelficeLoadAnomaly in phi0surf for initial pressure
C    calculation (if using selectP_inEOS_Zc=2 or 3)
       DO bj = myByLo(myThid), myByHi(myThid)
        DO bi = myBxLo(myThid), myBxHi(myThid)
         DO j = 1-OLy, sNy+OLy
          DO i = 1-OLx, sNx+OLx
           IF ( kTopC(i,j,bi,bj).EQ.0 ) THEN
            R_shelfIce         (i,j,bi,bj) = rF(1)
            shelficeMassInit   (i,j,bi,bj) = 0. _d 0
            shelficeLoadAnomaly(i,j,bi,bj) = 0. _d 0
           ELSE
            shelficeLoadAnomaly(i,j,bi,bj) = gravity
     &      *(shelficeMassInit(i,j,bi,bj)+rhoConst*Ro_surf(i,j,bi,bj))
           ENDIF
          ENDDO
         ENDDO
        ENDDO
       ENDDO
c     ELSE
c      _EXCH_XY_RS( shelficeLoadAnomaly, myThid )
c     ENDIF
      CALL WRITE_FLD_XY_RL ( 'shelficemassinit', ' ',
     &                       shelficeMassInit, 0, myThid )
      IF ( debugLevel.GE.debLevC ) THEN
       CALL WRITE_FLD_XY_RL( 'SHICE_pLoadAnom', ' ',
     I                       shelficeLoadAnomaly, -1, myThid )
      ENDIF

      IF ( SHELFICEMassStepping .AND.
     &     SHELFICEMassDynTendFile .NE. ' ' ) THEN
       CALL READ_FLD_XY_RS( SHELFICEMassDynTendFile, ' ',
     &                      shelfIceMassDynTendency, 0, myThid )
      ENDIF

#ifdef ALLOW_DIAGNOSTICS
      IF ( useDiagnostics ) THEN
       diagName  = 'SHIfwFlx'
       diagTitle = 'Ice shelf fresh water flux (positive upward)'
       diagUnits = 'kg/m^2/s        '
       diagCode  = 'SM      L1      '
       CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I      diagName, diagCode, diagUnits, diagTitle, 0, myThid )

       diagName  = 'SHIhtFlx'
       diagTitle = 'Ice shelf heat flux  (positive upward)'
       diagUnits = 'W/m^2           '
       diagCode  = 'SM      L1      '
       CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I      diagName, diagCode, diagUnits, diagTitle, 0, myThid )

       diagName  = 'SHI_TauX'
       diagTitle =
     &     'Ice shelf bottom stress, zonal  comp., >0 increases uVel'
       diagUnits = 'N/m^2           '
       diagCode  = 'UU      L1      '
       diagMate  = diagNum + 2
       CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I      diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

       diagName  = 'SHI_TauY'
       diagTitle =
     &     'Ice shelf bottom stress, merid. comp., >0 increases vVel'
       diagUnits = 'N/m^2           '
       diagCode  = 'VV      L1      '
       diagMate  = diagNum
       CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I      diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

       diagName  = 'SHIForcT'
       diagTitle = 'Ice shelf forcing for theta, >0 increases theta'
       diagUnits = 'W/m^2           '
       diagCode  = 'SM      L1      '
       CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I      diagName, diagCode, diagUnits, diagTitle, 0, myThid )

       diagName  = 'SHIForcS'
       diagTitle = 'Ice shelf forcing for salt, >0 increases salt'
       diagUnits = 'g/m^2/s         '
       diagCode  = 'SM      L1      '
       CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I      diagName, diagCode, diagUnits, diagTitle, 0, myThid )

       diagName  = 'SHIgammT'
       diagTitle = 'Ice shelf exchange coefficient for theta'
       diagUnits = 'm/s             '
       diagCode  = 'SM      L1      '
       CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I      diagName, diagCode, diagUnits, diagTitle, 0, myThid )

       diagName  = 'SHIgammS'
       diagTitle = 'Ice shelf exchange coefficient for salt'
       diagUnits = 'm/s             '
       diagCode  = 'SM      L1      '
       CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I      diagName, diagCode, diagUnits, diagTitle, 0, myThid )

       diagName  = 'SHI_mass'
       diagTitle = 'dynamic ice shelf mass for surface load anomaly'
       diagUnits = 'kg/m^2          '
       diagCode  = 'SM      L1      '
       CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I      diagName, diagCode, diagUnits, diagTitle, 0, myThid )

#if ( defined ALLOW_MOM_COMMON && defined ALLOW_MOM_TEND_EXTRA_DIAGS )
cHP adding diagnostic for drag from ice shelf to allow exp. dissip decomp
      diagName  = 'UShIDrag'
      diagTitle = 'U momentum tendency from ice shelf Drag'
      diagCode  = 'UUR     MR      '
      diagMate  = diagNum + 2
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I   diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )
      diagName  = 'VShIDrag'
      diagTitle = 'V momentum tendency from ice shelf Drag'
      diagCode  = 'VVR     MR      '
      diagMate  = diagNum
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I   diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )
#endif

#ifdef SHI_ALLOW_GAMMAFRICT
       diagName  = 'SHIuStar'
       diagTitle = 'Friction velocity at bottom of ice shelf'
       diagUnits = 'm/s             '
       diagCode  = 'SM      L1      '
       CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I      diagName, diagCode, diagUnits, diagTitle, 0, myThid )

       diagName  = 'SHICDrag'
       diagTitle = 'Shelfice drag coefficient for u* parameterization'
       diagUnits = '1               '
       diagCode  = 'SM      L1      '
       CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )
#endif

#ifdef ALLOW_SHELFICE_REMESHING
       diagName  = 'SHIRshel'
       diagTitle = 'depth of shelfice'
       diagUnits = 'm               '
       diagCode  = 'SM      L1      '
       CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I      diagName, diagCode, diagUnits, diagTitle, 0, myThid )
#endif

# ifdef ALLOW_AUTODIFF
#  ifndef SHI_ALLOW_GAMMAFRICT
       diagName  = 'ADJshict'
       diagTitle = 'dJ/dgammaT: Sens. to shelfice heat transfer coeff'
       diagUnits = 'dJ/(m/s)        '
       diagCode  = 'SM A    M1      '
       CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

       diagName  = 'ADJshics'
       diagTitle = 'dJ/dgammaS: Sens. to shelfice salt transfer coeff'
       diagUnits = 'dJ/(m/s)        '
       diagCode  = 'SM A    M1      '
       CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

#  else
       diagName  = 'ADJshicd'
       diagTitle = 'dJ/dcDrag: Sensitivity to shelfice u* drag coeff'
       diagUnits = 'dJ/1            '
       diagCode  = 'SM A    M1      '
       CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )
#  endif
# endif
      ENDIF
#endif /* ALLOW_DIAGNOSTICS */
#endif /* ALLOW_SHELFICE */

      RETURN
      END

#include "CAL_OPTIONS.h"

      subroutine cal_WeekDay(
     I                        indate,
     O                        daystring,
     I                        mythid
     &                      )

c     ==================================================================
c     SUBROUTINE cal_WeekDay
c     ==================================================================
c
c     o Given a calendar date return the weekday as a string.
c
c     started: Christian Eckert eckert@mit.edu  19-Jan-1999
c
c     changed: Christian Eckert eckert@mit.edu  03-Feb-2000
c
c              - Introduced new routine and function names, cal_<NAME>,
c                for verion 0.1.3.
c
c     ==================================================================
c     SUBROUTINE cal_WeekDay
c     ==================================================================

      implicit none

c     == global variables ==

#include "cal.h"

c     == routine arguments ==

      integer indate(4)
      character*(3) daystring
      integer mythid

c     == local variables ==

      integer nweekday
      integer numberofdays(4)

c     == end of interface ==

c     Determine the day of the week.
      call cal_TimePassed( refdate, indate, numberofdays, mythid )
      nweekday = mod(numberofdays(1),7)+1

      daystring = dayofweek(nweekday)

      return
      end

#include "CPP_OPTIONS.h"
#include "STREAMICE_OPTIONS.h"

      SUBROUTINE STREAMICE_INVERT_SURF_FORTHICK (
     O            H,
     I            S,
     I            R,
     I            delta,
     I            myThid)

c      This S/R finds a thickness (H) that gives surf elev S with bed R

#include "SIZE.h"
#include "GRID.h"
#include "SET_GRID.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "STREAMICE.h"

#ifdef ALLOW_OPENAD
      use OAD_tape
      use OAD_rev
      use OAD_cp
#endif

      _RL H(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL S(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL R(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL DELTA
      INTEGER myThid
#ifdef ALLOW_OPENAD
      type(active) :: ETA_GL_STREAMICE
      type(active) :: X,Y0
      type(modeType) :: our_orig_mode
#endif

#ifdef ALLOW_STREAMICE

      _RL resid, fp, hf, htmp
      INTEGER  i, j, bi, bj, ITER
      _RL ETA_GL_PRIME_STREAMICE
#ifndef ALLOW_OPENAD
      _RL ETA_GL_STREAMICE
      EXTERNAL ETA_GL_STREAMICE
#endif
c      EXTERNAL PHI_GL_STREAMICE_PRIME

        DO bj=myByLo(myThid), myByHi(myThid)
         DO bi=myBxLo(myThid), myBxHi(myThid)
          DO j = 1,sNy
           DO i = 1,sNx
            IF (STREAMICE_hmask(i,j,bi,bj).eq.1.0) THEN
             hf = (-1. _d 0) * R(i,j,bi,bj) /
     &           (1. _d 0 - delta)

             IF (S(i,j,bi,bj) .gt. delta*HF) THEN
              htmp = S(i,j,bi,bj)-R(i,j,bi,bj)
             ELSE
              htmp = S(i,j,bi,bj)/delta
             ENDIF

             IF (streamice_smooth_gl_width.gt.0.) THEN

              RESID=1. _d 0

              DO ITER=1,20
               IF ((RESID .gt. .005) .and.
     &           ( STREAMICE_hmask(i,j,bi,bj).eq.1.0)) THEN

                hf = (-1. _d 0) * R(i,j,bi,bj) /
     &           (1. _d 0 - delta)

                IF (S(i,j,bi,bj) .gt. delta*HF) THEN
                 htmp = S(i,j,bi,bj)-R(i,j,bi,bj)
                ELSE
                 htmp = S(i,j,bi,bj)/delta
                ENDIF

#ifdef ALLOW_OPENAD

                our_orig_mode = our_rev_mode
                our_rev_mode%arg_store=.FALSE.
                our_rev_mode%arg_restore=.FALSE.
                our_rev_mode%plain=.TRUE.
                our_rev_mode%tape=.FALSE.
                our_rev_mode%adjoint=.FALSE.

                X%v = htmp-HF
                Y0%v = delta*HF

                CALL OpenAD_oad_s_eta_gl_streamice(
     &             X,
     &             delta,
     &             1. _d 0,
     &             Y0,
     &             streamice_smooth_gl_width,
     &             ETA_GL_STREAMICE)

                RESID = ETA_GL_STREAMICE%v
                our_rev_mode = our_orig_mode

#else
                RESID = ETA_GL_STREAMICE (
     &             htmp-HF,
     &             delta,
     &             1. _d 0,
     &             delta*HF,
     &             streamice_smooth_gl_width)
#endif
                RESID = RESID - S(i,j,bi,bj)
                FP = ETA_GL_PRIME_STREAMICE (
     &             htmp-HF,
     &             delta,
     &             1. _d 0,
     &             delta*HF,
     &             streamice_smooth_gl_width)
                Htmp = HTMP-RESID/FP
               ENDIF
              ENDDO
             ENDIF
             H(i,j,bi,bj) = Htmp
            ENDIF
           ENDDO
          ENDDO
         ENDDO
        ENDDO

#endif
      RETURN
      END

#include "CPP_OPTIONS.h"

CBOP
C     !ROUTINE: CALC_GRAD_PHI_FV
C     !INTERFACE:
      SUBROUTINE CALC_GRAD_PHI_FV(
     I                       k, bi, bj, iMin,iMax, jMin,jMax,
     I                       phiHydF, phiHydU, pKappaF, pKappaU,
     O                       dPhiHydX, dPhiHydY,
     I                       myTime, myIter, myThid)
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R CALC_GRAD_PHI_FV
C     | o Calculate the gradient of Hydrostatic pressure anomaly
C     |   using Finite-Volume method from S.-J. Lin (QJRMS, 1997)
C     *==========================================================*
C     | o used with sigma-coords - might be useful also with r*
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "SURFACE.h"
c#include "DYNVARS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine Arguments ==
C     bi,bj      :: tile index
C     iMin,iMax,jMin,jMax :: Loop counters
C     phiHydF    :: hydrostatic potential anomaly at interface k
C                  (atmos: =Geopotential ; ocean-z: =Pressure/rho)
C     phiHydU    :: hydrostatic potential anomaly at interface k+1 (Upper k)
C     pKappaF    :: (p/Po)^kappa at interface k
C     pKappaU    :: (p/Po)^kappa at interface k+1 (Upper k)
C     dPhiHydX,Y :: Gradient (X & Y directions) of Hyd. Potential
C     myTime :: Current time
C     myIter :: Current iteration number
C     myThid :: Instance number for this call of the routine.
      INTEGER k, bi,bj, iMin,iMax, jMin,jMax
      _RL phiHydF(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL phiHydU(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL pKappaF(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL pKappaU(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL dPhiHydX(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL dPhiHydY(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL myTime
      INTEGER myIter, myThid

#ifdef INCLUDE_PHIHYD_CALCULATION_CODE

C     !LOCAL VARIABLES:
C     == Local variables ==
C     i,j :: Loop counters
      INTEGER i,j
      _RL dpk_dip, dpk_dim
      _RL dpk_djp, dpk_djm
c     CHARACTER*(MAX_LEN_MBUF) msgBuf
CEOP

C--   Zonal & Meridional gradient of potential anomaly
      DO j=1-OLy,sNy+OLy
       DO i=1-OLx,sNx+OLx
        dPhiHydX(i,j)  = 0. _d 0
        dPhiHydY(i,j)  = 0. _d 0
       ENDDO
      ENDDO
      DO j=jMin,jMax
       DO i=iMin+1,iMax
        dpk_dip = pKappaF( i ,j) - pKappaU(i-1,j)
        dpk_dim = pKappaF(i-1,j) - pKappaU( i ,j)
        dPhiHydX(i,j) = ( phi0surf(i,j,bi,bj) - phi0surf(i-1,j,bi,bj) )
     &                + (  dpk_dip*( phiHydU(i,j) - phiHydF(i-1,j) )
     &                   + dpk_dim*( phiHydF(i,j) - phiHydU(i-1,j) )
     &                  )/( dpk_dip + dpk_dim )
        dPhiHydX(i,j) = _recip_dxC(i,j,bi,bj)*dPhiHydX(i,j)
c    &                * recip_deepFacC(k)*recip_rhoFacC(k)
       ENDDO
      ENDDO
      DO j=jMin+1,jMax
       DO i=iMin,iMax
        dpk_djp = pKappaF(i, j ) - pKappaU(i,j-1)
        dpk_djm = pKappaF(i,j-1) - pKappaU(i, j )
        dPhiHydY(i,j) = ( phi0surf(i,j,bi,bj) - phi0surf(i,j-1,bi,bj) )
     &                + (  dpk_djp*( phiHydU(i,j) - phiHydF(i,j-1) )
     &                   + dpk_djm*( phiHydF(i,j) - phiHydU(i,j-1) )
     &                  )/( dpk_djp + dpk_djm )
        dPhiHydY(i,j) = _recip_dyC(i,j,bi,bj)*dPhiHydY(i,j)
c    &                * recip_deepFacC(k)*recip_rhoFacC(k)
       ENDDO
      ENDDO

C--   Apply mask:
      DO j=1-OLy,sNy+OLy
       DO i=1-OLx,sNx+OLx
         dPhiHydX(i,j) = dPhiHydX(i,j)*_maskW(i,j,k,bi,bj)
         dPhiHydY(i,j) = dPhiHydY(i,j)*_maskS(i,j,k,bi,bj)
       ENDDO
      ENDDO

#endif /* INCLUDE_PHIHYD_CALCULATION_CODE */

      RETURN
      END

#include "MOM_VECINV_OPTIONS.h"

CBOP
C     !ROUTINE: MOM_VI_V_CORIOLIS_C4
C     !INTERFACE:
      SUBROUTINE MOM_VI_V_CORIOLIS_C4(
     I        bi,bj,k,
     I        selectVortScheme,highOrderVorticity,upwindVorticity,
     I        uFld,omega3,r_hFacZ,
     O        vCoriolisTerm,
     I        myThid)
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R MOM_VI_V_CORIOLIS_C4
C     |==========================================================*
C     | o Calculate flux (in X-dir.) of vorticity at V point
C     |   using 4th order (or 1rst order) interpolation
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "GRID.h"
#ifdef ALLOW_EXCH2
#include "W2_EXCH2_SIZE.h"
#include "W2_EXCH2_TOPOLOGY.h"
#endif /* ALLOW_EXCH2 */

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
      INTEGER bi,bj,k
      _RL uFld(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL omega3(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RS r_hFacZ(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL vCoriolisTerm(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER selectVortScheme
      LOGICAL highOrderVorticity,upwindVorticity
      INTEGER myThid
CEOP

C     == Local variables ==
C     msgBuf :: Informational/error meesage buffer
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      INTEGER i,j
      _RL vort3r(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL uBarXY,vort3v,Rjp,Rjm,Rj
      _RL uBarYm,uBarYp

      LOGICAL northWestCorner, northEastCorner,
     &        southWestCorner, southEastCorner
      INTEGER myFace
#ifdef ALLOW_EXCH2
      INTEGER myTile
#endif /* ALLOW_EXCH2 */
      _RL oneSixth, oneTwelve
      LOGICAL fourthVort3
C jmc: not sure about these 1/6 & 1/12 factors (should use the same)
      PARAMETER(oneSixth=1.D0/6.D0 , oneTwelve=1.D0/12.D0)
      PARAMETER(fourthVort3=.TRUE. )

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      DO j=1-Oly,sNy+Oly
       DO i=1-Olx,sNx+Olx
         vort3r(i,j) = r_hFacZ(i,j)*omega3(i,j)
       ENDDO
      ENDDO

C--   Special stuff for Cubed Sphere
      IF ( useCubedSphereExchange.AND.highOrderVorticity ) THEN

#ifdef ALLOW_EXCH2
       myTile = W2_myTileList(bi,bj)
       myFace = exch2_myFace(myTile)
       southWestCorner = exch2_isWedge(myTile).EQ.1
     &             .AND. exch2_isSedge(myTile).EQ.1
       southEastCorner = exch2_isEedge(myTile).EQ.1
     &             .AND. exch2_isSedge(myTile).EQ.1
       northEastCorner = exch2_isEedge(myTile).EQ.1
     &             .AND. exch2_isNedge(myTile).EQ.1
       northWestCorner = exch2_isWedge(myTile).EQ.1
     &             .AND. exch2_isNedge(myTile).EQ.1
#else
       myFace = bi
       southWestCorner = .TRUE.
       southEastCorner = .TRUE.
       northWestCorner = .TRUE.
       northEastCorner = .TRUE.
#endif /* ALLOW_EXCH2 */
       IF ( southWestCorner ) THEN
         i = 1
         j = 1
         vort3r(i-1,j) = ( vort3r(i-1,j) + vort3r(i,j+1) )*0.5 _d 0
       ENDIF
       IF ( southEastCorner ) THEN
         i = sNx+1
         j = 1
         vort3r(i+1,j) = ( vort3r(i+1,j) + vort3r(i,j+1) )*0.5 _d 0
       ENDIF
       IF ( northWestCorner ) THEN
         i = 1
         j = sNy+1
         vort3r(i-1,j) = ( vort3r(i-1,j) + vort3r(i,j-1) )*0.5 _d 0
       ENDIF
       IF ( northEastCorner ) THEN
         i = sNx+1
         j = sNy+1
         vort3r(i+1,j) = ( vort3r(i+1,j) + vort3r(i,j-1) )*0.5 _d 0
       ENDIF

C--   End of special stuff for Cubed Sphere.
      ENDIF

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      IF ( selectVortScheme.EQ.0 ) THEN
C--   using Sadourny Enstrophy conserving discretization:

c      DO j=2-Oly,sNy+Oly
c       DO i=2-Olx,sNx+Olx-2
       DO j=1,sNy+1
        DO i=1,sNx

         uBarXY=0.25*(
     &      (uFld( i , j )*dyG( i , j ,bi,bj)*_hFacW( i , j ,k,bi,bj)
     &      +uFld( i ,j-1)*dyG( i ,j-1,bi,bj)*_hFacW( i ,j-1,k,bi,bj))
     &     +(uFld(i+1, j )*dyG(i+1, j ,bi,bj)*_hFacW(i+1, j ,k,bi,bj)
     &      +uFld(i+1,j-1)*dyG(i+1,j-1,bi,bj)*_hFacW(i+1,j-1,k,bi,bj))
     &               )
         IF (upwindVorticity) THEN
          IF (uBarXY.GT.0.) THEN
           vort3v=vort3r(i,j)
          ELSE
           vort3v=vort3r(i+1,j)
          ENDIF
         ELSEIF (fourthVort3) THEN
#ifdef ALLOW_OBCS
          Rjp = ( vort3r(i+2,j) - vort3r(i+1,j) )*maskInS(i+1,j,bi,bj)
          Rjm = ( vort3r( i ,j) - vort3r(i-1,j) )*maskInS(i-1,j,bi,bj)
#else
          Rjp =   vort3r(i+2,j) - vort3r(i+1,j)
          Rjm =   vort3r( i ,j) - vort3r(i-1,j)
#endif
          vort3v=0.5*( (vort3r(i,j) + vort3r(i+1,j))
     &                 -oneTwelve*(Rjp-Rjm)
     &               )
         ELSE
          vort3v=0.5*( vort3r(i,j) + vort3r(i+1,j) )
         ENDIF

         vCoriolisTerm(i,j) = -vort3v*uBarXY*recip_dyC(i,j,bi,bj)
     &                               * _maskS(i,j,k,bi,bj)

        ENDDO
       ENDDO

      ELSEIF ( selectVortScheme.EQ.2 ) THEN
C--   using Energy conserving discretization:

c      DO j=2-Oly,sNy+Oly
c       DO i=2-Olx,sNx+Olx-2
       DO j=1,sNy+1
        DO i=1,sNx

         uBarYm=0.5*(
     &       uFld( i , j )*dyG( i , j ,bi,bj)*_hFacW( i , j ,k,bi,bj)
     &      +uFld( i ,j-1)*dyG( i ,j-1,bi,bj)*_hFacW( i ,j-1,k,bi,bj) )
         uBarYp=0.5*(
     &       uFld(i+1, j )*dyG(i+1, j ,bi,bj)*_hFacW(i+1, j ,k,bi,bj)
     &      +uFld(i+1,j-1)*dyG(i+1,j-1,bi,bj)*_hFacW(i+1,j-1,k,bi,bj) )
         IF (upwindVorticity) THEN
          IF ( (uBarYm+uBarYp) .GT.0.) THEN
           vort3v=uBarYm*vort3r( i ,j)
          ELSE
           vort3v=uBarYp*vort3r(i+1,j)
          ENDIF
         ELSEIF (fourthVort3) THEN
#ifdef ALLOW_OBCS
          Rjp = ( vort3r(i+2,j) - vort3r(i+1,j) )*maskInS(i+1,j,bi,bj)
          Rjm = ( vort3r( i ,j) - vort3r(i-1,j) )*maskInS(i-1,j,bi,bj)
#else
          Rjp =   vort3r(i+2,j) - vort3r(i+1,j)
          Rjm =   vort3r( i ,j) - vort3r(i-1,j)
#endif
          Rj  =   vort3r(i+1,j) - vort3r( i ,j)
          Rjp = vort3r(i+1,j) -oneSixth*( Rjp-Rj )
          Rjm = vort3r( i ,j) -oneSixth*( Rj-Rjm )
c         Rjp = vort3r(i+1,j) -oneSixth*( vort3r(i+2,j)-vort3r( i ,j) )
c         Rjm = vort3r( i ,j) +oneSixth*( vort3r(i+1,j)-vort3r(i-1,j) )
          vort3v=0.5*( uBarYm*Rjm + uBarYp*Rjp )
         ELSE
          vort3v=0.5*( uBarYm*vort3r( i ,j) + uBarYp*vort3r(i+1,j) )
         ENDIF

         vCoriolisTerm(i,j) = -vort3v*recip_dyC(i,j,bi,bj)
     &                               * _maskS(i,j,k,bi,bj)

        ENDDO
       ENDDO

      ELSE
        WRITE(msgBuf,'(A,I5,A)')
     &   'MOM_VI_V_CORIOLIS_C4: selectVortScheme=', selectVortScheme,
     &   ' not implemented'
        CALL PRINT_ERROR( msgBuf, myThid )
        STOP 'ABNORMAL END: S/R MOM_VI_V_CORIOLIS_C4'

      ENDIF

      RETURN
      END

#include "SEAICE_OPTIONS.h"

CBOP
C     !ROUTINE: SEAICE_JACVEC
C     !INTERFACE:
      SUBROUTINE SEAICE_JACVEC(
     I     uIceLoc, vIceLoc, uIceRes, vIceRes,
     U     duIce, dvIce,
     I     newtonIter, krylovIter, myTime, myIter, myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE SEAICE_JACVEC
C     | o For Jacobian-free Newton-Krylov solver compute
C     |   Jacobian times vector by finite difference approximation
C     *==========================================================*
C     | written by Martin Losch, Oct 2012
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "DYNVARS.h"
#include "GRID.h"
#include "SEAICE_SIZE.h"
#include "SEAICE_PARAMS.h"
#include "SEAICE.h"

C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
C     myTime :: Simulation time
C     myIter :: Simulation timestep number
C     myThid :: my Thread Id. number
C     newtonIter :: current iterate of Newton iteration
C     krylovIter :: current iterate of Krylov iteration
      _RL     myTime
      INTEGER myIter
      INTEGER myThid
      INTEGER newtonIter
      INTEGER krylovIter
C     u/vIceLoc :: local copies of the current ice velocity
      _RL uIceLoc(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL vIceLoc(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
C     u/vIceRes :: initial residual of this Newton iterate
      _RL uIceRes(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL vIceRes(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
C     du/vIce   :: correction of ice velocities
      _RL duIce  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL dvIce  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)

#ifdef SEAICE_ALLOW_JFNK
C     Local variables:
      _RL utp     (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL vtp     (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
C     u/vIceResP :: residual computed with u/vtp
      _RL uIceResP(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL vIceResP(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)

C     i,j,bi,bj :: loop indices
      INTEGER i,j,bi,bj
      _RL epsilon, reps
CEOP
C     Instructions for using TAF or TAMC to generate exact Jacobian times
C     vector operations (if SEAICE_ALLOW_MOM_ADVECTION is defined, the
C     file list also needs to include seaice_mom_advection.f,
C     mom_calc_hfacz.f, mom_calc_ke.f, mom_calc_relvort3.f,
C     mom_vi_u_coriolis.f, mom_vi_u_coriolis_c4.f, mom_vi_u_grad_ke.f,
C     mom_vi_v_coriolis.f, mom_vi_v_coriolis_c4.f, mom_vi_v_grad_ke.f
C     plus flow information for diagnostics_fill.f:
CCCCCCCADJ SUBROUTINE DIAGNOSTICS_FILL INPUT  = 1,2,3,4,5,6,7,8
CCCCCCCADJ SUBROUTINE DIAGNOSTICS_FILL OUTPUT =
C     )
C
C     1. make small_f
C     2. cat seaice_calc_residual.f seaice_oceandrag_coeffs.f \
C        seaice_bottomdrag_coeffs.f seaice_calc_stressdiv.f \
C        seaice_calc_strainrates.f seaice_calc_viscosities.f \
C        seaice_calc_rhs.f seaice_calc_lhs.f > taf_input.f
C     3. staf -v1 -forward -toplevel seaice_calc_residual \
C             -input uIceLoc,viceLoc -output uIceRes,vIceRes taf_input.f
C     4. insert content of taf_input_ftl.f at the end of this file
C     5. add the following code and comment out the finite difference code
C
C     Instruction for using TAF 2.4 and higher (or staf with default -v2
C     starting with version 2.0):
C
C     1. make small_f
C     2. files="seaice_calc_residual.f seaice_oceandrag_coeffs.f \
C               seaice_bottomdrag_coeffs.f seaice_calc_stressdiv.f \
C               seaice_calc_strainrates.f seaice_calc_viscosities.f \
C               seaice_calc_rhs.f seaice_calc_lhs.f"
C     3. staf -forward -toplevel seaice_calc_residual \
C             -input uIceLoc,viceLoc -output uIceRes,vIceRes $files
C     4. copy files seaice_*_tl.f to the corresponding seaice_*.f files,
C        e.g. with this bash script:
C     for file in $files; do
C       nfile=`echo $file | awk -F. '{printf "%s_tl.f", $1}'`;
C       \cp -f $nfile $file
C     done
C     5. add the following code, change "call g_seaice_calc_residual"
C        to "call seaice_calc_residual_tl", and comment out the finite
C        difference code
CML      _RL g_duIce(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
CML      _RL g_dvIce(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
CML      _RL g_uIceRes(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
CML      _RL g_vIceRes(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
CML
CMLC     Initialise
CML      DO bj=myByLo(myThid),myByHi(myThid)
CML       DO bi=myBxLo(myThid),myBxHi(myThid)
CML        DO J=1-Oly,sNy+Oly
CML         DO I=1-Olx,sNx+Olx
CML          g_duIce(I,J,bi,bj) = duice(I,J,bi,bj)
CML          g_dvIce(I,J,bi,bj) = dvice(I,J,bi,bj)
CML          g_uIceRes(I,J,bi,bj) = 0. _d 0
CML          g_vIceRes(I,J,bi,bj) = 0. _d 0
CML          uIceResP(I,J,bi,bj) = 0. _d 0
CML          vIceResP(I,J,bi,bj) = 0. _d 0
CML         ENDDO
CML        ENDDO
CML       ENDDO
CML      ENDDO
CML
CML      CALL G_SEAICE_CALC_RESIDUAL( uIce, g_duice, vIce,
CML     $g_dvice, uiceresp, g_uiceres, viceresp, g_viceres, newtoniter,
CML     $kryloviter, mytime, myiter, mythid )
CMLCML      For staf -v2 replace the above with the below call
CMLCML      CALL SEAICE_CALC_RESIDUAL_TL( uIce, g_duice, vIce,
CMLCML     $g_dvice, uiceresp, g_uiceres, viceresp, g_viceres, newtoniter,
CMLCML     $kryloviter, mytime, myiter, mythid )
CML
CML      DO bj=myByLo(myThid),myByHi(myThid)
CML       DO bi=myBxLo(myThid),myBxHi(myThid)
CML        DO J=1-Oly,sNy+Oly
CML         DO I=1-Olx,sNx+Olx
CML          duice(I,J,bi,bj)=g_uiceres(I,J,bi,bj)
CML          dvice(I,J,bi,bj)=g_viceres(I,J,bi,bj)
CML         ENDDO
CML        ENDDO
CML       ENDDO
CML      ENDDO

C     Initialise
      epsilon = SEAICE_JFNKepsilon
      reps    = 1. _d 0/epsilon

      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        DO J=1-Oly,sNy+Oly
         DO I=1-Olx,sNx+Olx
          utp(I,J,bi,bj) = uIce(I,J,bi,bj) + epsilon * duIce(I,J,bi,bj)
          vtp(I,J,bi,bj) = vIce(I,J,bi,bj) + epsilon * dvIce(I,J,bi,bj)
         ENDDO
        ENDDO
       ENDDO
      ENDDO

C     Compute new residual F(u)
      CALL SEAICE_CALC_RESIDUAL(
     I     utp, vtp,
     O     uIceResP, vIceResP,
     I     newtonIter, krylovIter, myTime, myIter, myThid )

C     approximate Jacobian times vector by one-sided finite differences
C     and store in du/vIce
      DO bj = myByLo(myThid),myByHi(myThid)
       DO bi = myBxLo(myThid),myBxHi(myThid)
        DO I = 1, sNx
         DO J = 1, sNy
          duIce(I,J,bi,bj) =
     &         (uIceResP(I,J,bi,bj)-uIceRes(I,J,bi,bj))*reps
          dvIce(I,J,bi,bj) =
     &         (vIceResP(I,J,bi,bj)-vIceRes(I,J,bi,bj))*reps
         ENDDO
        ENDDO
       ENDDO
      ENDDO

#endif /* SEAICE_ALLOW_JFNK */

      RETURN
      END

#include "PACKAGES_CONFIG.h"
#include "CPP_OPTIONS.h"

CBOP
C     !ROUTINE: INI_LINEAR_PHISURF
C     !INTERFACE:
      SUBROUTINE INI_LINEAR_PHISURF( myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE INI_LINEAR_PHISURF
C     | o Initialise the Linear Relation Phi_surf(eta)
C     *==========================================================*
C     | Initialise -Buoyancy at surface level (Bo_surf)
C     |  to setup the Linear relation: Phi_surf(eta)=Bo_surf*eta
C     | Initialise phi0surf = starting point for integrating
C     |                       phiHyd (= phiHyd at r=RoSurf)
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "SURFACE.h"

C     !INPUT/OUTPUT PARAMETERS:
C     myThid :: my Thread Id number
      INTEGER myThid

C     == Local variables in common ==
C     topoHloc had to be in common for multi threading but no longer
C     needed since MDSIO now allows (2009/06/07) to write local arrays

C     !LOCAL VARIABLES:
C     topoHloc  :: Temporary array used to write surface topography
C     bi,bj  :: tile indices
C     i,j,k  :: Loop counters
#ifndef ALLOW_AUTODIFF
      _RS topoHloc(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
#endif
      INTEGER bi, bj
      INTEGER i, j, k
      _RL     pLoc, rhoLoc
      _RL     dPIdp
CEOP

C--   Initialisation
#ifdef ALLOW_AUTODIFF
      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
           Bo_surf(i,j,bi,bj)  = 0. _d 0
           recip_Bo(i,j,bi,bj) = 0. _d 0
         ENDDO
        ENDDO
       ENDDO
      ENDDO
#endif /* ALLOW_AUTODIFF */

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C-- Initialise -Buoyancy at surface level : Bo_surf
C   Bo_surf is defined as d/dr(Phi_surf) and set to g/z2rUnit with
C     z2rUnit = conversion factor from z-unit to r-unit: [z] * z2rUnit = [r]
C   an accurate formulation includes P_surf and T,S_ref effects on rho_surf:
C    (setting uniformLin_PhiSurf=.FALSE.):
C    z-coord (z2rUnit=1): Bo_surf = - Buoyancy
C                                 = g * rho_surf(Tref,Sref,pSurf_0)/rho_0
C    p-coord (z2rUnit=rho*g): Bo_surf = 1/rho(Tref(ksurf),pSurf_0)
C   Note: on Phi_surf splitting : Non-linear Time-dependent effects on B_surf
C   [through eta & (T-tRef)_surf] are included in PhiHyd rather than in Bo_surf
C--
      IF ( usingZCoords ) THEN
C-  gBaro = gravity (except for External mode test with reduced gravity)
        DO bj=myByLo(myThid),myByHi(myThid)
         DO bi=myBxLo(myThid),myBxHi(myThid)
          DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
             Bo_surf(i,j,bi,bj) = gBaro
             recip_Bo(i,j,bi,bj) = 1. _d 0 / gBaro
           ENDDO
          ENDDO
         ENDDO
        ENDDO
      ELSEIF ( uniformLin_PhiSurf ) THEN
C-  use a linear (in ps) uniform relation : Phi'_surf = 1/rhoConst * ps'_surf
        DO bj=myByLo(myThid),myByHi(myThid)
         DO bi=myBxLo(myThid),myBxHi(myThid)
          DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
c            Bo_surf(i,j,bi,bj)  = rVel2wUnit(1)*gravity
c            recip_Bo(i,j,bi,bj) = wUnit2rVel(1)*recip_gravity
             Bo_surf(i,j,bi,bj)  = recip_rhoConst
             recip_Bo(i,j,bi,bj) = rhoConst
           ENDDO
          ENDDO
         ENDDO
        ENDDO
      ELSEIF ( fluidIsWater ) THEN
C--   More precise than uniformLin_PhiSurf case but inconsistent
C     with nonlinFreeSurf=4 in CALC_PHI_HYD (eta contribution to phiHyd)
        DO bj=myByLo(myThid),myByHi(myThid)
         DO bi=myBxLo(myThid),myBxHi(myThid)
          DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
            IF ( Ro_surf(i,j,bi,bj).GT.0. _d 0
     &          .AND. kSurfC(i,j,bi,bj).LE.Nr ) THEN
             pLoc = Ro_surf(i,j,bi,bj)
#ifdef ALLOW_OPENAD
             CALL FIND_RHO_SCALAR(
     I            tRef(kSurfC(i,j,bi,bj)),
     I            sRef(kSurfC(i,j,bi,bj)),
     I            pLoc,
     O            rhoLoc, myThid )
#else /* ALLOW_OPENAD */
             k = kSurfC(i,j,bi,bj)
             CALL FIND_RHO_SCALAR(
     I            tRef(k), sRef(k), pLoc,
     O            rhoLoc, myThid )
#endif /* ALLOW_OPENAD */
             IF ( rhoLoc .EQ. 0. _d 0 ) THEN
              Bo_surf(i,j,bi,bj) = 0. _d 0
             ELSE
              Bo_surf(i,j,bi,bj) = 1. _d 0/rhoLoc
             ENDIF
             recip_Bo(i,j,bi,bj) =  rhoLoc
            ELSE
              Bo_surf(i,j,bi,bj)  = 0. _d 0
              recip_Bo(i,j,bi,bj) = 0. _d 0
            ENDIF
           ENDDO
          ENDDO
         ENDDO
        ENDDO
      ELSEIF ( fluidIsAir ) THEN
C-  use a linearized (in ps) Non-uniform relation : Bo_surf(Po_surf,tRef_surf)
C    Bo = d/d_p(Phi_surf) = tRef_surf*d/d_p(PI) ; PI = Cp*(p/Po)^kappa
C   and atm_Cp*atm_kappa = atm_Rd
        DO bj=myByLo(myThid),myByHi(myThid)
         DO bi=myBxLo(myThid),myBxHi(myThid)
          IF ( select_rStar.GE.1 .OR. selectSigmaCoord.GE.1 ) THEN
C-      isothermal (theta=const) reference state
           DO j=1-OLy,sNy+OLy
            DO i=1-OLx,sNx+OLx
             IF ( Ro_surf(i,j,bi,bj).GT.0. _d 0
     &          .AND. kSurfC(i,j,bi,bj).LE.Nr ) THEN
              dPIdp = (atm_Rd/atm_Po)*
     &         (Ro_surf(i,j,bi,bj)/atm_Po)**(atm_kappa-1. _d 0)
              Bo_surf(i,j,bi,bj) = dPIdp*thetaConst
              recip_Bo(i,j,bi,bj) = 1. _d 0 / Bo_surf(i,j,bi,bj)
             ELSE
              Bo_surf(i,j,bi,bj) = 0.
              recip_Bo(i,j,bi,bj) = 0.
             ENDIF
            ENDDO
           ENDDO
          ELSE
C-      horizontally uniform (tRef) reference state
           DO j=1-OLy,sNy+OLy
            DO i=1-OLx,sNx+OLx
             IF ( Ro_surf(i,j,bi,bj).GT.0. _d 0
     &          .AND. kSurfC(i,j,bi,bj).LE.Nr ) THEN
              dPIdp = (atm_Rd/atm_Po)*
     &         (Ro_surf(i,j,bi,bj)/atm_Po)**(atm_kappa-1. _d 0)
              Bo_surf(i,j,bi,bj) = dPIdp*tRef(kSurfC(i,j,bi,bj))
              recip_Bo(i,j,bi,bj) = 1. _d 0 / Bo_surf(i,j,bi,bj)
             ELSE
              Bo_surf(i,j,bi,bj) = 0.
              recip_Bo(i,j,bi,bj) = 0.
             ENDIF
            ENDDO
           ENDDO
          ENDIF
         ENDDO
        ENDDO
      ELSE
        STOP 'INI_LINEAR_PHISURF: We should never reach this point!'
      ENDIF

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C--   Update overlap regions (jmc: is it really needed ?)
c     _EXCH_XY_RL(Bo_surf, myThid)
c     _EXCH_XY_RL(recip_Bo, myThid)

      IF ( usingPCoords .AND. .NOT.uniformLin_PhiSurf ) THEN
        CALL WRITE_FLD_XY_RL( 'Bo_surf',' ',Bo_surf,0,myThid)
      ENDIF

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C--   Initialise phi0surf: used for atmos. surf. P-loading (ocean, z-coord)
C                               or topographic geopotential anom. (p-coord)

      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          phi0surf(i,j,bi,bj) = 0.
         ENDDO
        ENDDO
       ENDDO
      ENDDO

      IF ( geoPotAnomFile .NE. ' '  ) THEN
       CALL READ_FLD_XY_RS( geoPotAnomFile, ' ', phi0Surf, 0, myThid )
      ENDIF
      CALL EXCH_XY_RS( phi0Surf  , myThid )

      IF ( fluidIsAir .AND. topoFile.NE.' ' ) THEN

#ifdef ALLOW_AUTODIFF
         STOP 'CANNOT PRESENTLY USE THIS OPTION WITH ADJOINT'
#else

C--   Compute topoH = PhiRef(Po_surf)/g ; is different from original
C      topoZ(read from file) because of truncation of Po_surf.
C     NOTE: not clear for now which topoZ needs to be saved in common block
C--   AND set phi0surf = starting point for integrating Geopotential;

        CALL INI_P_GROUND( -2,
     O                     topoHloc,
     I                     Ro_surf, myThid )

       IF (selectFindRoSurf.NE.0) THEN
        _EXCH_XY_RS(phi0surf, myThid)
        CALL WRITE_FLD_XY_RS( 'phi0surf',' ',phi0surf,0,myThid)
       ENDIF

        CALL WRITE_FLD_XY_RS( 'topo_H',' ',topoHloc,0,myThid)

#endif /* ALLOW_AUTODIFF */

      ENDIF

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
      RETURN
      END

#include "CTRL_OPTIONS.h"

      subroutine optim_sub(
     I                 nn
     &               )

c     ==================================================================
c     SUBROUTINE optim_sub
c     ==================================================================
c
c     o Initialization of optimization run.
c
c     started: Christian Eckert eckert@mit.edu 15-Feb-2000
c
c     changed: Christian Eckert eckert@mit.edu 10-Mar-2000
c
c              - Added ECCO layout.
c
c     changed:  Patrick Heimbach heimbach@mit.edu 19-Jun-2000
c               - finished, revised and debugged
c
c     ==================================================================
c     SUBROUTINE optim_sub
c     ==================================================================

      IMPLICIT NONE

c     == global variables ==

#include "EEPARAMS.h"
#include "SIZE.h"

#include "CTRL_SIZE.h"
#include "CTRL.h"
#include "optim.h"

c     == routine arguments ==

      integer nn

c     == local variables ==

      _RL   objf

#if defined (DYNAMIC)
      _RL   xx(nn)
      _RL   adxx(nn)
      _RL   dd(nn)
      _RL   gold(nn)
      _RL   xdiff(nn)
#elif defined (USE_POINTER) || (MAX_INDEPEND == 0)
      _RL   xx
      _RL   adxx
      _RL   dd(1)
      _RL   gold(1)
      _RL   xdiff(1)
      pointer (pxx,xx(1))
      pointer (padxx,adxx(1))
      pointer (pdd,dd)
      pointer (pgold,gold)
      pointer (pxdiff,xdiff)
#else
      integer nmax
      parameter( nmax = MAX_INDEPEND )
      _RL   xx(nmax)
      _RL   adxx(nmax)
      _RL   dd(nmax)
      _RL   gold(nmax)
      _RL   xdiff(nmax)
#endif

c--   Allocate memory for the control variables and the gradient vector.
#if defined(DYNAMIC)
#elif defined(USE_POINTER) || (MAX_INDEPEND == 0)
      call myalloc( pxx  ,  nn*REAL_BYTE )
      call myalloc( padxx,  nn*REAL_BYTE )
      call myalloc( pdd,    nn*REAL_BYTE )
      call myalloc( pgold,  nn*REAL_BYTE )
      call myalloc( pxdiff, nn*REAL_BYTE )
#endif

      integer ifail
      integer itmax
      logical loffline

c     == external ==

      external simul
      external lsline

c     == end of interface ==

c--   Initialisize the model and set a first guess of the control
c--   variables.
      call optim_initmod( nn, xx )

#if defined (DYNAMIC)
#elif defined(USE_POINTER) || (MAX_INDEPEND == 0)
#else
      if (nn .gt. nmax) then
        print*,' OPTIMUM: Not enough space.'
        print*,'          nmax = ',nmax
        print*,'            nn = ',nn
        print*
        print*,'          Set MAX_INDEPEND in Makefile .ge. ',nn
        print*
        stop   ' ... stopped in OPTIMUM.'
      endif
#endif

      print*, ' OPTIMUM: Calling lsopt for iteration: ',optimcycle
      print*, ' OPTIMUM: with nn, REAL_BYTE = ', nn, REAL_BYTE

      loffline = .true.
      itmax    = numiter

c--   Large scale optimization --> Gilbert & Lemarechal.
#ifdef EXCLUDE_LSOPT_TO_CHECK
      ifail = 0
      call simul( ifail, nn, xx, objf, adxx )
#else /* EXCLUDE_LSOPT_TO_CHECK */
      call lsopt_top( nn, xx, objf, adxx
     &              , simul, lsline
     &              , epsx, fmin, epsg
     &              , iprint
     &              , itmax, nfunc, nupdate
     &              , dd, gold, xdiff
     &              , loffline
     &              , ifail )
#endif /* EXCLUDE_LSOPT_TO_CHECK */

      RETURN
      END

#include "BULK_FORCE_OPTIONS.h"

CBOP
C     !ROUTINE: BULKF_FORMULA_AIM
C     !INTERFACE:
      SUBROUTINE BULKF_FORMULA_AIM(
     I                   Tsurf, SLRD,
     I                   T1, T0, Q0, Vsurf,
     O                   SHF, EVAP, SLRU,
     O                   dEvp, sFlx,
     I                   iceornot, myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R BULKF_FORMULA_AIM
C     | o compute surface flux over ocean and sea-ice,
C     |   using AIM surface flux formulation
C     *==========================================================*
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     Resolution parameters

#include "EEPARAMS.h"
#include "SIZE.h"
#include "PARAMS.h"
#include "BULKF_PARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine Arguments ==
C--   Input:
C    FMASK  :: fractional land-sea mask        (2-dim)
C    Tsurf  :: surface temperature        (2-dim)
C    SSR    :: sfc sw radiation (net flux)     (2-dim)
C    SLRD   :: sfc lw radiation (downward flux)(2-dim)
C    T1     :: near-surface air temperature (from Pot.temp)
C    T0     :: near-surface air temperature    (2-dim)
C    Q0     :: near-surface sp. humidity [g/kg](2-dim)
C    Vsurf  :: surface wind speed        [m/s] (2-dim,input)
C--   Output:
C    SHF    :: sensible heat flux              (2-dim)
C    EVAP   :: evaporation [g/(m^2 s)]         (2-dim)
C    SLRU   :: sfc lw radiation (upward flux)  (2-dim)
C    Shf0   :: sensible heat flux over freezing surf.
C    dShf   :: sensible heat flux derivative relative to surf. temp
C    Evp0   :: evaporation computed over freezing surface (Ts=0.oC)
C    dEvp   :: evaporation derivative relative to surf. temp
C    Slr0   :: upward long wave radiation over freezing surf.
C    dSlr   :: upward long wave rad. derivative relative to surf. temp
C    sFlx   :: net heat flux (+=down) except SW, function of surf. temp Ts:
C              0: Flux(Ts=0.oC) ; 1: Flux(Ts^n) ; 2: d.Flux/d.Ts(Ts^n)
C    TSFC   :: surface temperature (clim.)     (2-dim)
C    TSKIN  :: skin surface temperature        (2-dim)
C--   Input:
C    iceornot :: 0=open water, 1=ice cover
C    myThid :: Thread number for this instance of the routine
C--
      INTEGER NGP
      PARAMETER ( NGP = 1 )
c     _RL  PSA(NGP), FMASK(NGP), EMISloc
      _RL  Tsurf(NGP)
c     _RL  SSR(NGP)
      _RL  SLRD(NGP)
      _RL  T1(NGP), T0(NGP), Q0(NGP), Vsurf(NGP)

      _RL  SHF(NGP), EVAP(NGP), SLRU(NGP)
      _RL  dEvp(NGP), sFlx(NGP,0:2)
c     _RL  Shf0(NGP), dShf(NGP), Evp0(NGP), dEvp(NGP)
c     _RL  Slr0(NGP), dSlr(NGP), sFlx(NGP,0:2)
c     _RL  TSFC(NGP), TSKIN(NGP)

      INTEGER iceornot
      INTEGER myThid
CEOP

#ifdef ALLOW_FORMULA_AIM

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C      FWIND0 = ratio of near-sfc wind to lowest-level wind
C      CHS    = heat exchange coefficient over sea
C      VGUST  = wind speed for sub-grid-scale gusts
C      DTHETA = Potential temp. gradient for stability correction
C      dTstab = potential temp. increment for stability function derivative
C      FSTAB  = Amplitude of stability correction (fraction)
C       P0    = reference pressure                 [Pa=N/m2]
C       GG    = gravity accel.                     [m/s2]
C       RD    = gas constant for dry air           [J/kg/K]
C       CP    = specific heat at constant pressure [J/kg/K]
C       ALHC  = latent heat of condensation        [J/g]
C       ALHF  = latent heat of freezing            [J/g]
C       SBC   = Stefan-Boltzmann constant
C      EMISloc :: longwave surface emissivity
c     _RL FWIND0, CHS, VGUST, DTHETA, dTstab, FSTAB
      _RL P0, ALHC, ALHF, RD, CP, SBC, EMISloc
      EQUIVALENCE ( ocean_emissivity , EMISloc )
      EQUIVALENCE ( Lvap   , ALHC )
      EQUIVALENCE ( Lfresh , ALHF )
      EQUIVALENCE ( Rgas   , RD )
      EQUIVALENCE ( cpair  , CP )
      EQUIVALENCE ( stefan , SBC )

C-- Local variables:
C    PSA     :: norm. surface pressure [p/p0]   (2-dim)
C    DENVV   :: surface flux (sens,lat.) coeff. (=Rho*|V|) [kg/m2/s]
C    CDENVV  :: surf. heat flux (sens.,lat.) coeff including stability effect
C    ALHevp  :: Latent Heat of evaporation
      _RL PSA(NGP)
      _RL DENVV(NGP), PRD
      _RL  Shf0(NGP), dShf(NGP), Evp0(NGP)
      _RL  Slr0(NGP), dSlr(NGP)
      _RL  TSFC(NGP), TSKIN(NGP)
      _RL CDENVV(NGP), RDTH, FSSICE
      _RL ALHevp, Fstb0, dTstb, dFstb
      _RL QSAT0(NGP,2)
      _RL QDUMMY(1), RDUMMY(1), TS2
      INTEGER J
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      PSA(1) = 1. _d 0
      P0 = 1. _d +5
C---

      ALHevp = ALHC
C     Evap of snow/ice: account for Latent Heat of freezing :
c     IF ( aim_energPrecip .OR. useThSIce ) ALHevp = ALHC + ALHF
      IF ( iceornot.GE.1 ) ALHevp = ALHC + ALHF

C     1.4 Density * wind speed (including gustiness factor)

      PRD = P0/RD
c     VG2 = VGUST*VGUST
c     factWind2 = FWIND0*FWIND0

      DO J=1,NGP
c       SPEED0(J)=SQRT(factWind2*Vsurf2(J)+VG2)
c       DENVV(J)=(PRD*PSA(J)/T0(J))*SPEED0(J)
C-- assuming input file "WspeedFile" contains the time-average "SPEED0"
C     from AIM output ( aimDiag: WINDS ) :
        DENVV(J)=(PRD*PSA(J)/T0(J))*Vsurf(J)
      ENDDO

C     1.5 Define effective skin temperature to compensate for
C         non-linearity of heat/moisture fluxes during the daily cycle

      DO J=1,NGP
        TSKIN(J) = Tsurf(J) + celsius2K
        TSFC(J)=273.16 _d 0
      ENDDO

C--   2. Computation of fluxes over land and sea

C     2.1 Stability correction

      RDTH = FSTAB/DTHETA

      DO J=1,NGP
        FSSICE=1.+MIN(DTHETA,MAX(-DTHETA,TSKIN(J)-T1(J)))*RDTH
        CDENVV(J)=CHS*DENVV(J)*FSSICE
      ENDDO

      IF ( dTstab.GT.0. _d 0 ) THEN
C-    account for stability function derivative relative to Tsurf:
C note: to avoid discontinuity in the derivative (because of min,max), compute
C   the derivative using the discrete form: F(Ts+dTstab)-F(Ts-dTstab)/2.dTstab
       DO J=1,NGP
        Fstb0 = 1.+MIN(DTHETA,MAX(-DTHETA,TSFC(J) -T1(J)))*RDTH
        Shf0(J) = CHS*DENVV(J)*Fstb0
        dTstb = ( DTHETA+dTstab-ABS(TSKIN(J)-T1(J)) )/dTstab
        dFstb = RDTH*MIN(1. _d 0, MAX(0. _d 0, dTstb*0.5 _d 0))
        dShf(J) = CHS*DENVV(J)*dFstb
       ENDDO
      ENDIF

C     2.2 Evaporation

      CALL BULKF_SH2RH_AIM( 2, NGP, TSKIN, PSA, 1. _d 0,
     &                      QDUMMY, dEvp,  QSAT0(1,1), myThid )
      CALL BULKF_SH2RH_AIM( 0, NGP, TSFC,  PSA, 1. _d 0,
     &                      QDUMMY, RDUMMY,QSAT0(1,2), myThid )

      IF ( dTstab.GT.0. _d 0 ) THEN
C-    account for stability function derivative relative to Tsurf:
       DO J=1,NGP
        EVAP(J) = CDENVV(J)*(QSAT0(J,1)-Q0(J))
        Evp0(J) =   Shf0(J)*(QSAT0(J,2)-Q0(J))
        dEvp(J) = CDENVV(J)*dEvp(J)
     &            + dShf(J)*(QSAT0(J,1)-Q0(J))
       ENDDO
      ELSE
       DO J=1,NGP
        EVAP(J) = CDENVV(J)*(QSAT0(J,1)-Q0(J))
        Evp0(J) = CDENVV(J)*(QSAT0(J,2)-Q0(J))
        dEvp(J) = CDENVV(J)*dEvp(J)
       ENDDO
      ENDIF

C     2.3 Sensible heat flux

      IF ( dTstab.GT.0. _d 0 ) THEN
C-    account for stability function derivative relative to Tsurf:
       DO J=1,NGP
        SHF(J)  = CDENVV(J)*CP*(TSKIN(J)-T0(J))
        Shf0(J) =   Shf0(J)*CP*(TSFC(J) -T0(J))
        dShf(J) = CDENVV(J)*CP
     &            + dShf(J)*CP*(TSKIN(J)-T0(J))
        dShf(J) = MAX( dShf(J), 0. _d 0 )
C--   do not allow negative derivative vs Ts of Sensible+Latent H.flux:
C     a) quiet unrealistic ;
C     b) garantee positive deriv. of total H.flux (needed for implicit solver)
        dEvp(J) = MAX( dEvp(J), -dShf(J)/ALHevp )
       ENDDO
      ELSE
       DO J=1,NGP
        SHF(J)  = CDENVV(J)*CP*(TSKIN(J)-T0(J))
        Shf0(J) = CDENVV(J)*CP*(TSFC(J) -T0(J))
        dShf(J) = CDENVV(J)*CP
       ENDDO
      ENDIF

C     2.4 Emission of lw radiation from the surface

      DO J=1,NGP
        TS2     = TSFC(J)*TSFC(J)
        Slr0(J) = SBC*TS2*TS2
        TS2     = TSKIN(J)*TSKIN(J)
        SLRU(J) = SBC*TS2*TS2
        dSlr(J)  = 4. _d 0 *SBC*TS2*TSKIN(J)
      ENDDO

C--   Compute net surface heat flux and its derivative ./. surf. temp.
      DO J=1,NGP
        sFlx(J,0)= ( SLRD(J) - EMISloc*Slr0(J) )
     &           - ( Shf0(J) + ALHevp*Evp0(J) )
        sFlx(J,1)= ( SLRD(J) - EMISloc*SLRU(J) )
     &           - ( SHF(J)  + ALHevp*EVAP(J) )
        sFlx(J,2)=            -EMISloc*dSlr(J)
     &           - ( dShf(J) + ALHevp*dEvp(J) )
      ENDDO

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
#endif /* ALLOW_FORMULA_AIM */

      RETURN
      END

#include "DIC_OPTIONS.h"

C--  File carbon_chem.F:
C--   Contents
C--   o CALC_PCO2
C--   o CALC_PCO2_APPROX
C--   o CARBON_COEFFS
C--   o CARBON_COEFFS_PRESSURE_DEP

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

CBOP
C !ROUTINE: CALC_PCO2

C !INTERFACE: ==========================================================
       SUBROUTINE CALC_PCO2(
     I                       donewt,inewtonmax,ibrackmax,
     I                       t,s,diclocal,pt,sit,ta,
     I                       k1local,k2local,
     I                       k1plocal,k2plocal,k3plocal,
     I                       kslocal,kblocal,kwlocal,
     I                       ksilocal,kflocal,
     I                       k0local, fugflocal,
     I                       fflocal,btlocal,stlocal,ftlocal,
     U                       pHlocal,pCO2surfloc,
     I                       i,j,k,bi,bj,myIter,myThid )

C !DESCRIPTION:
C  surface ocean inorganic carbon chemistry to OCMIP2
C  regulations modified from OCMIP2 code;
C  Mick Follows, MIT, Oct 1999.

C Apr 2011: fix vapour bug (following Bennington)

C !USES: ===============================================================
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "DIC_VARS.h"

C     == Routine arguments ==
C       diclocal = total inorganic carbon (mol/m^3)
C             where 1 T = 1 metric ton = 1000 kg
C       ta  = total alkalinity (eq/m^3)
C       pt  = inorganic phosphate (mol/^3)
C       sit = inorganic silicate (mol/^3)
C       t   = temperature (degrees C)
C       s   = salinity (g/kg)
        INTEGER donewt
        INTEGER inewtonmax
        INTEGER ibrackmax
        _RL  t, s, pt, sit, ta
        _RL  pCO2surfloc, diclocal, pHlocal
        _RL  fflocal, btlocal, stlocal, ftlocal
        _RL  k1local, k2local
        _RL  k1plocal, k2plocal, k3plocal
        _RL  kslocal, kblocal, kwlocal, ksilocal, kflocal
        _RL  k0local, fugflocal
        INTEGER i,j,k,bi,bj,myIter
        INTEGER myThid
CEOP

C     == Local variables ==
C INPUT
C       phlo= lower limit of pH range
C       phhi= upper limit of pH range
C       atmpres = atmospheric pressure in atmospheres (1 atm==1013.25mbar)
C OUTPUT
C       co2star  = CO2*water (mol/m^3)
C       pco2surf = oceanic pCO2 (ppmv)
C ---------------------------------------------------------------------
C OCMIP NOTE: Some words about units - (JCO, 4/4/1999)
C     - Models carry tracers in mol/m^3 (on a per volume basis)
C     - Conversely, this routine, which was written by
C       observationalists (C. Sabine and R. Key), passes input
C       arguments in umol/kg (i.e., on a per mass basis)
C     - I have changed things slightly so that input arguments are in
C       mol/m^3,
C     - Thus, all input concentrations (diclocal, ta, pt, and st) should be
C       given in mol/m^3; output arguments "co2star" and "dco2star"
C       are likewise be in mol/m^3.
C ---------------------------------------------------------------------

        _RL  phhi
        _RL  phlo
        _RL  c
        _RL  a
        _RL  a2
        _RL  da
        _RL  b
        _RL  b2
        _RL  db
        _RL  fn
        _RL  df
        _RL  deltax
        _RL  x
        _RL  x2
        _RL  x3
        _RL  xmid
        _RL  ftest
        _RL  htotal
        _RL  htotal2
        _RL  co2star
        _RL  phguess
        _RL  fco2
        INTEGER inewton
        INTEGER ibrack
        INTEGER hstep
        _RL  fni(3)
        _RL  xlo
        _RL  xhi
        _RL  xguess
        _RL  k123p
        _RL  k12p
        _RL  k12
c ---------------------------------------------------------------------
c import donewt flag
c set donewt = 1 for newton-raphson iteration
c set donewt = 0 for bracket and bisection
c ---------------------------------------------------------------------
C Change units from the input of mol/m^3 -> mol/kg:
c (1 mol/m^3)  x (1 m^3/1024.5 kg)
c where the ocean mean surface density is 1024.5 kg/m^3
c Note: mol/kg are actually what the body of this routine uses
c for calculations.  Units are reconverted back to mol/m^3 at the
c end of this routine.
c ---------------------------------------------------------------------
c To convert input in mol/m^3 -> mol/kg
        pt=pt*permil
        sit=sit*permil
        ta=ta*permil
        diclocal=diclocal*permil
c ---------------------------------------------------------------------
c set first guess and brackets for [H+] solvers
c first guess (for newton-raphson)
        phguess = phlocal

c bracketing values (for bracket/bisection)
        phhi = 10.0
        phlo = 5.0
c convert to [H+]...
        xguess = 10.0**(-phguess)
        xlo = 10.0**(-phhi)
        xhi = 10.0**(-phlo)
        xmid = (xlo + xhi)*0.5

c----------------------------------------------------------------
c iteratively solve for [H+]
c (i) Newton-Raphson method with fixed number of iterations,
c     use previous [H+] as first guess

c select newton-raphson, inewt=1
c else select bracket and bisection

cQQQQQ
        if( donewt .eq. 1)then
c.........................................................
c NEWTON-RAPHSON METHOD
c.........................................................
          x = xguess
cdiags
c         WRITE(0,*)'xguess ',xguess
cdiags
          do inewton = 1, inewtonmax
c set some common combinations of parameters used in
c the iterative [H+] solvers
            x2=x*x
            x3=x2*x
            k12 = k1local*k2local
            k12p = k1plocal*k2plocal
            k123p = k12p*k3plocal
            c = 1.0 + stlocal/kslocal
            a = x3 + k1plocal*x2 + k12p*x + k123p
            a2=a*a
            da = 3.0*x2 + 2.0*k1plocal*x + k12p
            b = x2 + k1local*x + k12
            b2=b*b
            db = 2.0*x + k1local

c Evaluate f([H+]) and f_prime([H+])
c fn = hco3+co3+borate+oh+hpo4+2*po4+silicate+hfree
c      +hso4+hf+h3po4-ta
            fn = k1local*x*diclocal/b +
     &        2.0*diclocal*k12/b +
     &        btlocal/(1.0 + x/kblocal) +
     &        kwlocal/x +
     &        pt*k12p*x/a +
     &        2.0*pt*k123p/a +
     &        sit/(1.0 + x/ksilocal) -
     &        x/c -
     &        stlocal/(1.0 + kslocal/x/c) -
     &        ftlocal/(1.0 + kflocal/x) -
     &        pt*x3/a -
     &        ta

c df = dfn/dx
cdiags
c      WRITE(0,*)'values',b2,kblocal,x2,a2,c,x
cdiags
            df = ((k1local*diclocal*b) - k1local*x*diclocal*db)/b2 -
     &        2.0*diclocal*k12*db/b2 -
     &        btlocal/kblocal/(1.0+x/kblocal)**2. -
     &        kwlocal/x2 +
     &        (pt*k12p*(a - x*da))/a2 -
     &        2.0*pt*k123p*da/a2 -
     &        sit/ksilocal/(1.0+x/ksilocal)**2. +
     &        1.0/c +
     &        stlocal*(1.0 + kslocal/x/c)**(-2.0)*(kslocal/c/x2) +
     &        ftlocal*(1.0 + kflocal/x)**(-2.)*kflocal/x2 -
     &        pt*x2*(3.0*a-x*da)/a2
c evaluate increment in [H+]
            deltax = - fn/df
c update estimate of [H+]
            x = x + deltax
cdiags
c write value of x to check convergence....
c           write(0,*)'inewton, x, deltax ',inewton, x, deltax
c           write(6,*)
cdiags

          end do
c end of newton-raphson method
c....................................................
        else
c....................................................
C BRACKET AND BISECTION METHOD
c....................................................
c (ii) If first step use Bracket and Bisection method
c      with fixed, large number of iterations
          do ibrack = 1, ibrackmax
            do hstep = 1,3
              if(hstep .eq. 1)x = xhi
              if(hstep .eq. 2)x = xlo
              if(hstep .eq. 3)x = xmid
c set some common combinations of parameters used in
c the iterative [H+] solvers

              x2=x*x
              x3=x2*x
              k12 = k1local*k2local
              k12p = k1plocal*k2plocal
              k123p = k12p*k3plocal
              c = 1.0 + stlocal/kslocal
              a = x3 + k1plocal*x2 + k12p*x + k123p
              a2=a*a
              da = 3.0*x2 + 2.0*k1plocal*x + k12p
              b = x2 + k1local*x + k12
              b2=b*b
              db = 2.0*x + k1local
c evaluate f([H+]) for bracketing and mid-value cases
              fn = k1local*x*diclocal/b +
     &          2.0*diclocal*k12/b +
     &          btlocal/(1.0 + x/kblocal) +
     &          kwlocal/x +
     &          pt*k12p*x/a +
     &          2.0*pt*k123p/a +
     &          sit/(1.0 + x/ksilocal) -
     &          x/c -
     &          stlocal/(1.0 + kslocal/x/c) -
     &          ftlocal/(1.0 + kflocal/x) -
     &          pt*x3/a -
     &          ta
              fni(hstep) = fn
            end do
c now bracket solution within two of three
            ftest = fni(1)/fni(3)
            if(ftest .gt. 0.0)then
              xhi = xmid
            else
              xlo = xmid
            end if
            xmid = (xlo + xhi)*0.5

cdiags
c write value of x to check convergence....
c           WRITE(0,*)'bracket-bisection iteration ',ibrack, xmid
cdiags
          end do
c last iteration gives value
          x = xmid
c end of bracket and bisection method
c....................................
        end if
c iterative [H+] solver finished
c----------------------------------------------------------------

c now determine pCO2 etc...
c htotal = [H+], hydrogen ion conc
        htotal = x
C Calculate [CO2*] as defined in DOE Methods Handbook 1994 Ver.2,
C ORNL/CDIAC-74, dickson and Goyet, eds. (Ch 2 p 10, Eq A.49)
        htotal2=htotal*htotal
        co2star=diclocal*htotal2/(htotal2 + k1local*htotal
     &            + k1local*k2local)
        phlocal=-log10(htotal)

c ---------------------------------------------------------------
c Add two output arguments for storing pCO2surf
c Should we be using K0 or ff for the solubility here?
c ---------------------------------------------------------------
#ifdef WATERVAP_BUG
        pCO2surfloc = co2star / fflocal
#else
c Corrected by Val Bennington (Nov 2010)
        fco2 = co2star / k0local
        pCO2surfloc = fco2/fugflocal
#endif

C ----------------------------------------------------------------
C Reconvert units back to original values for input arguments
C no longer necessary????
C ----------------------------------------------------------------
c       Reconvert from mol/kg -> mol/m^3
        pt=pt/permil
        sit=sit/permil
        ta=ta/permil
        diclocal=diclocal/permil

        RETURN
        END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

CBOP
C !ROUTINE: CALC_PCO2_APPROX

C !INTERFACE: ==========================================================
       SUBROUTINE CALC_PCO2_APPROX(
     I                       t,s,diclocal,pt,sit,ta,
     I                       k1local,k2local,
     I                       k1plocal,k2plocal,k3plocal,
     I                       kslocal,kblocal,kwlocal,
     I                       ksilocal,kflocal,
     I                       k0local, fugflocal,
     I                       fflocal,btlocal,stlocal,ftlocal,
     U                       pHlocal,pCO2surfloc,co3local,
     I                       i,j,k,bi,bj,myIter,myThid )

C !DESCRIPTION:
C     *==========================================================*
C     | SUBROUTINE CALC_PCO2_APPROX                              |
C     *==========================================================*
C     CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C     C  New efficient pCO2 solver, Mick Follows         CC
C     C                             Taka Ito             CC
C     C                             Stephanie Dutkiewicz CC
C     C  20 April 2003                                   CC
C     CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
C      Apr 2011: fix vapour bug (following Bennington)
C      Oct 2011: add CO3 extimation and pass out

C !USES: ===============================================================
      IMPLICIT NONE

C     == GLobal variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "DIC_VARS.h"

C     == Routine arguments ==
C       diclocal = total inorganic carbon (mol/m^3)
C             where 1 T = 1 metric ton = 1000 kg
C       ta  = total alkalinity (eq/m^3)
C       pt  = inorganic phosphate (mol/^3)
C       sit = inorganic silicate (mol/^3)
C       t   = temperature (degrees C)
C       s   = salinity (g/kg)
        _RL  t, s, pt, sit, ta
        _RL  pCO2surfloc, diclocal, pHlocal
        _RL  fflocal, btlocal, stlocal, ftlocal
        _RL  k1local, k2local
        _RL  k1plocal, k2plocal, k3plocal
        _RL  kslocal, kblocal, kwlocal, ksilocal, kflocal
        _RL  k0local, fugflocal
        _RL  co3local
        INTEGER i,j,k,bi,bj,myIter
        INTEGER myThid
CEOP

C     == Local variables ==
        _RL  phguess
        _RL  cag
        _RL  bohg
        _RL  hguess
        _RL  stuff
        _RL  gamm
        _RL  hnew
        _RL  co2s
        _RL  h3po4g, h2po4g, hpo4g, po4g
        _RL  siooh3g
        _RL  fco2

c ---------------------------------------------------------------------
C Change units from the input of mol/m^3 -> mol/kg:
c (1 mol/m^3)  x (1 m^3/1024.5 kg)
c where the ocean mean surface density is 1024.5 kg/m^3
c Note: mol/kg are actually what the body of this routine uses
c for calculations.  Units are reconverted back to mol/m^3 at the
c end of this routine.
c To convert input in mol/m^3 -> mol/kg
        pt=pt*permil
        sit=sit*permil
        ta=ta*permil
        diclocal=diclocal*permil
c ---------------------------------------------------------------------
c set first guess and brackets for [H+] solvers
c first guess (for newton-raphson)
        phguess = phlocal
cmick - new approx method
cmick - make estimate of htotal (hydrogen ion conc) using
cmick   appromate estimate of CA, carbonate alkalinity
        hguess = 10.0**(-phguess)
cmick - first estimate borate contribution using guess for [H+]
        bohg = btlocal*kblocal/(hguess+kblocal)

cmick - first estimate of contribution from phosphate
cmick based on Dickson and Goyet
        stuff = hguess*hguess*hguess
     &           + (k1plocal*hguess*hguess)
     &           + (k1plocal*k2plocal*hguess)
     &           + (k1plocal*k2plocal*k3plocal)
        h3po4g = (pt*hguess*hguess*hguess) / stuff
        h2po4g = (pt*k1plocal*hguess*hguess) / stuff
        hpo4g  = (pt*k1plocal*k2plocal*hguess) / stuff
        po4g   = (pt*k1plocal*k2plocal*k3plocal) / stuff

cmick - estimate contribution from silicate
cmick based on Dickson and Goyet
        siooh3g = sit*ksilocal / (ksilocal + hguess)

cmick - now estimate carbonate alkalinity
        cag = ta - bohg - (kwlocal/hguess) + hguess
     &           - hpo4g - 2.0 _d 0*po4g + h3po4g
     &           - siooh3g

cmick - now evaluate better guess of hydrogen ion conc
cmick   htotal = [H+], hydrogen ion conc
        gamm  = diclocal/cag
        stuff = (1.0 _d 0-gamm)*(1.0 _d 0-gamm)*k1local*k1local
     &          - 4.0 _d 0*k1local*k2local*(1.0 _d 0-2.0 _d 0*gamm)
        hnew  = 0.5 _d 0*( (gamm-1.0 _d 0)*k1local + sqrt(stuff) )
cmick - now determine [CO2*]
        co2s  = diclocal/
     &   (1.0 _d 0 + (k1local/hnew) + (k1local*k2local/(hnew*hnew)))
cmick - return update pH to main routine
        phlocal = -log10(hnew)

c NOW EVALUATE CO32-, carbonate ion concentration
c used in determination of calcite compensation depth
c Karsten Friis & Mick - Sep 2004
        co3local = k1local*k2local*diclocal /
     &         (hnew*hnew + k1local*hnew + k1local*k2local)

c ---------------------------------------------------------------
c surface pCO2 (following Dickson and Goyet, DOE...)
#ifdef WATERVAP_BUG
        pCO2surfloc = co2s/fflocal
#else
c bug fix by Bennington
        fco2 = co2s/k0local
        pco2surfloc = fco2/fugflocal
#endif

C ----------------------------------------------------------------
c Reconvert from mol/kg -> mol/m^3
        pt=pt/permil
        sit=sit/permil
        ta=ta/permil
        diclocal=diclocal/permil

        RETURN
        END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C !ROUTINE: CARBON_COEFFS

C !INTERFACE: ==========================================================
      SUBROUTINE CARBON_COEFFS(
     I                   ttemp,stemp,
     I                   bi,bj,iMin,iMax,jMin,jMax,myThid)

C !DESCRIPTION:
C     *==========================================================*
C     | SUBROUTINE CARBON_COEFFS                                 |
C     | determine coefficients for surface carbon chemistry      |
C     | adapted from OCMIP2:  SUBROUTINE CO2CALC                 |
C     | mick follows, oct 1999                                   |
C     | minor changes to tidy, swd aug 2002                      |
C     *==========================================================*
C INPUT
C       diclocal = total inorganic carbon (mol/m^3)
C             where 1 T = 1 metric ton = 1000 kg
C       ta  = total alkalinity (eq/m^3)
C       pt  = inorganic phosphate (mol/^3)
C       sit = inorganic silicate (mol/^3)
C       t   = temperature (degrees C)
C       s   = salinity (g/kg)
C OUTPUT
C IMPORTANT: Some words about units - (JCO, 4/4/1999)
C     - Models carry tracers in mol/m^3 (on a per volume basis)
C     - Conversely, this routine, which was written by observationalists
C       (C. Sabine and R. Key), passes input arguments in umol/kg
C       (i.e., on a per mass basis)
C     - I have changed things slightly so that input arguments are in mol/m^3,
C     - Thus, all input concentrations (diclocal, ta, pt, and st) should be
C       given in mol/m^3; output arguments "co2star" and "dco2star"
C       are likewise be in mol/m^3.
C
C Apr 2011: fix vapour bug (following Bennington)
C--------------------------------------------------------------------------

C !USES: ===============================================================
        IMPLICIT NONE
C     == GLobal variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "DIC_VARS.h"

C     == Routine arguments ==
C ttemp and stemp are local theta and salt arrays
C dont really need to pass T and S in, could use theta, salt in
C common block in DYNVARS.h, but this way keeps subroutine more
C general
        _RL  ttemp(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
        _RL  stemp(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
        INTEGER bi,bj,iMin,iMax,jMin,jMax
        INTEGER myThid
CEOP

C LOCAL VARIABLES
        _RL  t
        _RL  s
        _RL  tk
        _RL  tk100
        _RL  tk1002
        _RL  dlogtk
        _RL  sqrtis
        _RL  sqrts
        _RL  s15
        _RL  scl
        _RL  s2
        _RL  invtk
        _RL  is
        _RL  is2
c add Bennington
        _RL  P1atm
        _RL  Rgas
        _RL  RT
        _RL  delta
        _RL  B1
        _RL  B
#ifdef CARBONCHEM_TOTALPHSCALE
c pH scale converstions
        _RL total2free
        _RL free2total
        _RL free2sw
        _RL sw2free
        _RL total2sw
        _RL sw2total
#endif
        INTEGER i
        INTEGER j

C.....................................................................
C OCMIP note:
C Calculate all constants needed to convert between various measured
C carbon species. References for each equation are noted in the code.
C Once calculated, the constants are
C stored and passed in the common block "const". The original version
C of this code was based on the code by dickson in Version 2 of
C  Handbook of Methods C for the Analysis of the Various Parameters of
C the Carbon Dioxide System in Seawater , DOE, 1994 (SOP No. 3, p25-26).
C....................................................................

        do i=imin,imax
         do j=jmin,jmax
          IF ( maskC(i,j,1,bi,bj).EQ.oneRS ) THEN
           t = ttemp(i,j)
           s = stemp(i,j)
C terms used more than once for:
C temperature
           tk = 273.15 _d 0 + t
           tk100 = tk/100. _d 0
           tk1002=tk100*tk100
           invtk=1.0 _d 0/tk
           dlogtk=log(tk)
C ionic strength
           is=19.924 _d 0*s/(1000. _d 0-1.005 _d 0*s)
           is2=is*is
           sqrtis=sqrt(is)
C salinity
           s2=s*s
           sqrts=sqrt(s)
           s15=s**1.5 _d 0
           scl=s/1.80655 _d 0
C -----------------------------------------------------------------------
C added by Val Bennington Nov 2010
C Fugacity Factor needed for non-ideality in ocean
C ff used for atmospheric correction for water vapor and pressure
C Weiss (1974) Marine Chemistry
           P1atm = 1.01325 _d 0 ! bars
           Rgas = 83.1451 _d 0 ! bar*cm3/(mol*K)
           RT = Rgas*tk
           delta = (57.7 _d 0 - 0.118 _d 0*tk)
           B1 = -1636.75 _d 0 + 12.0408 _d 0*tk - 0.0327957 _d 0*tk*tk
           B = B1 + 3.16528 _d 0*tk*tk*tk*(0.00001 _d 0)
           fugf(i,j,bi,bj) = exp( (B+2. _d 0*delta) * P1atm / RT)
C------------------------------------------------------------------------
C f = k0(1-pH2O)*correction term for non-ideality
C Weiss & Price (1980, Mar. Chem., 8, 347-359; Eq 13 with table 6 values)
           ff(i,j,bi,bj) = exp(-162.8301 _d 0 + 218.2968 _d 0/tk100  +
     &          90.9241 _d 0*log(tk100) - 1.47696 _d 0*tk1002 +
     &          s * (.025695 _d 0 - .025225 _d 0*tk100 +
     &          0.0049867 _d 0*tk1002))
C------------------------------------------------------------------------
C K0 from Weiss 1974
C Independent of pH scale
           ak0(i,j,bi,bj) = exp(93.4517 _d 0/tk100 - 60.2409 _d 0 +
     &        23.3585 _d 0 * log(tk100) +
     &        s * (0.023517 _d 0 - 0.023656 _d 0*tk100 +
     &        0.0047036 _d 0*tk1002))
C------------------------------------------------------------------------
C k1 = [H][HCO3]/[H2CO3]
C k2 = [H][CO3]/[HCO3]
C Millero p.664 (1995) using Mehrbach et al. data
C Both on seawater pH scale
           ak1(i,j,bi,bj)=10.**(-1. _d 0*(3670.7 _d 0*invtk -
     &          62.008 _d 0 + 9.7944 _d 0*dlogtk -
     &          0.0118 _d 0 * s + 0.000116 _d 0*s2))
           ak2(i,j,bi,bj)=10.**(-1. _d 0*(1394.7 _d 0*invtk+ 4.777 _d 0-
     &          0.0184 _d 0*s + 0.000118 _d 0*s2))
C------------------------------------------------------------------------
C kb = [H][BO2]/[HBO2]
C Millero p.669 (1995) using data from dickson (1990)
C On total pH scale
           akb(i,j,bi,bj)=exp((-8966.90 _d 0- 2890.53 _d 0*sqrts -
     &          77.942 _d 0*s + 1.728 _d 0*s15 - 0.0996 _d 0*s2)*invtk +
     &          (148.0248 _d 0 + 137.1942 _d 0*sqrts + 1.62142 _d 0*s) +
     &          (-24.4344 _d 0 - 25.085 _d 0*sqrts - 0.2474 _d 0*s) *
     &          dlogtk + 0.053105 _d 0*sqrts*tk)
C------------------------------------------------------------------------
C k1p = [H][H2PO4]/[H3PO4]
C DOE(1994) eq 7.2.20 with footnote using data from Millero (1974)
C The constant 115.525 is an approximation to convert to the total pH scale
C  (Dickson et al., 2007). Use Millero's 115.540 constant to stay on the seawater
C  pH scale (everything else is the same).
           ak1p(i,j,bi,bj) = exp(-4576.752 _d 0*invtk + 115.525 _d 0 -
     &          18.453 _d 0*dlogtk +
     &          (-106.736 _d 0*invtk + 0.69171 _d 0)*sqrts +
     &          (-0.65643 _d 0*invtk - 0.01844 _d 0)*s)
C------------------------------------------------------------------------
C k2p = [H][HPO4]/[H2PO4]
C DOE(1994) eq 7.2.23 with footnote using data from Millero (1974))
C The constant 172.0833 is an approximation to convert to the total pH scale
C  (Dickson et al., 2007). Use Millero's 172.1033 constant to stay on the seawater
C  pH scale (everything else is the same).
           ak2p(i,j,bi,bj) = exp(-8814.715 _d 0*invtk + 172.0883 _d 0 -
     &          27.927 _d 0*dlogtk +
     &          (-160.340 _d 0*invtk + 1.3566 _d 0) * sqrts +
     &          (0.37335 _d 0*invtk - 0.05778 _d 0) * s)
C------------------------------------------------------------------------
C k3p = [H][PO4]/[HPO4]
C DOE(1994) eq 7.2.26 with footnote using data from Millero (1974)
C The constant 18.141 is an approximation to convert to the total pH scale
C  (Dickson et al., 2007). Use Millero's 18.126 constant to stay on the seawater
C  pH scale (everything else is the same).
           ak3p(i,j,bi,bj) = exp(-3070.75 _d 0*invtk - 18.141 _d 0 +
     &          (17.27039 _d 0*invtk + 2.81197 _d 0) *
     &          sqrts + (-44.99486 _d 0*invtk - 0.09984 _d 0) * s)
C------------------------------------------------------------------------
C ksi = [H][SiO(OH)3]/[Si(OH)4]
C Millero p.671 (1995) using data from Yao and Millero (1995)
C The constant 117.385 is an approximation to convert to the total pH scale
C  (Dickson et al., 2007). Use Millero's 117.400 constant to stay on the seawater
C  pH scale (everything else is the same).
C  Note: converted here from mol/kg-H2O to mol/kg-SW
           aksi(i,j,bi,bj) = exp(-8904.2 _d 0*invtk + 117.385 _d 0 -
     &          19.334 _d 0*dlogtk +
     &          (-458.79 _d 0*invtk + 3.5913 _d 0) * sqrtis +
     &          (188.74 _d 0*invtk - 1.5998 _d 0) * is +
     &          (-12.1652 _d 0*invtk + 0.07871 _d 0) * is2 +
     &          log(1.0 _d 0-0.001005 _d 0*s))
C------------------------------------------------------------------------
C kw = [H][OH]
C Millero p.670 (1995) using composite data
C The constant 148.9652 is an approximation to convert to the total pH scale
C  (Dickson et al., 2007). Use Millero's 148.9802 constant to stay on the seawater
C  pH scale (everything else is the same).
           akw(i,j,bi,bj) = exp(-13847.26 _d 0*invtk + 148.9652 _d 0 -
     &          23.6521 _d 0*dlogtk +
     &          (118.67 _d 0*invtk - 5.977 _d 0 + 1.0495 _d 0 * dlogtk)
     &          * sqrts - 0.01615 _d 0 * s)
C------------------------------------------------------------------------
C ks = [H][SO4]/[HSO4]
C dickson (1990, J. chem. Thermodynamics 22, 113)
C On the free pH scale
C Note: converted here from mol/kg-H2O to mol/kg-SW
           aks(i,j,bi,bj)=exp(-4276.1 _d 0*invtk + 141.328 _d 0 -
     &          23.093 _d 0*dlogtk +
     &   (-13856. _d 0*invtk + 324.57 _d 0 - 47.986 _d 0*dlogtk)*sqrtis+
     &   (35474. _d 0*invtk - 771.54 _d 0 + 114.723 _d 0*dlogtk)*is -
     &          2698. _d 0*invtk*is**1.5 _d 0 + 1776. _d 0*invtk*is2 +
     &          log(1.0 _d 0 - 0.001005 _d 0*s))
C------------------------------------------------------------------------
C kf = [H][F]/[HF]
C dickson and Riley (1979) -- change pH scale to total (following Dickson & Goyet, 1994)
C Note: converted here from mol/kg-H2O to mol/kg-SW
           akf(i,j,bi,bj)=exp(1590.2 _d 0*invtk - 12.641 _d 0 +
     &   1.525 _d 0*sqrtis + log(1.0 _d 0 - 0.001005 _d 0*s) +
     &   log(1.0 _d 0 + (0.1400 _d 0/96.062 _d 0)*(scl)/aks(i,j,bi,bj)))
C------------------------------------------------------------------------
C Calculate concentrations for borate, sulfate, and fluoride
C Uppstrom (1974)
           bt(i,j,bi,bj) = 0.000232 _d 0 * scl/10.811 _d 0
C Morris & Riley (1966)
           st(i,j,bi,bj) = 0.14 _d 0 * scl/96.062 _d 0
C Riley (1965)
           ft(i,j,bi,bj) = 0.000067 _d 0 * scl/18.9984 _d 0
C------------------------------------------------------------------------
#ifdef CARBONCHEM_TOTALPHSCALE
C Convert between pH scales, we want everything to end up on the total scale
C ak1 and ak2 are on seawater scale and aks is on the free scale
           total2free = 1. _d 0/
     &                 (1. _d 0 + st(i,j,bi,bj)/aks(i,j,bi,bj))

           free2total = (1. _d 0 + st(i,j,bi,bj)/aks(i,j,bi,bj))

           free2sw = 1. _d 0
     &                 + st(i,j,bi,bj)/ aks(i,j,bi,bj)
     &                 + ft(i,j,bi,bj)/(akf(i,j,bi,bj)*total2free)

           sw2free = 1. _d 0 / free2sw

           total2sw = total2free * free2sw

           sw2total = 1. _d 0 / total2sw

           ak1(i,j,bi,bj)  = ak1(i,j,bi,bj)*sw2total
           ak2(i,j,bi,bj)  = ak2(i,j,bi,bj)*sw2total
           aks(i,j,bi,bj)  = aks(i,j,bi,bj)*free2total
#endif
          ELSE
c add Bennington
           fugf(i,j,bi,bj)=0. _d 0
           ff(i,j,bi,bj)=0. _d 0
           ak0(i,j,bi,bj)= 0. _d 0
           ak1(i,j,bi,bj)= 0. _d 0
           ak2(i,j,bi,bj)= 0. _d 0
           akb(i,j,bi,bj)= 0. _d 0
           ak1p(i,j,bi,bj) = 0. _d 0
           ak2p(i,j,bi,bj) = 0. _d 0
           ak3p(i,j,bi,bj) = 0. _d 0
           aksi(i,j,bi,bj) = 0. _d 0
           akw(i,j,bi,bj) = 0. _d 0
           aks(i,j,bi,bj)= 0. _d 0
           akf(i,j,bi,bj)= 0. _d 0
           bt(i,j,bi,bj) = 0. _d 0
           st(i,j,bi,bj) = 0. _d 0
           ft(i,j,bi,bj) = 0. _d 0
          ENDIF
         enddo
        enddo

        RETURN
        END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

CBOP
C !ROUTINE: CARBON_COEFFS_PRESSURE_DEP

C !INTERFACE: ==========================================================
      SUBROUTINE CARBON_COEFFS_PRESSURE_DEP(
     I                   ttemp,stemp,
     I                   bi,bj,iMin,iMax,jMin,jMax,
     I                   Klevel,myThid)

C !DESCRIPTION:
C     *==========================================================*
C     | SUBROUTINE CARBON_COEFFS                                 |
C     | determine coefficients for surface carbon chemistry      |
C     | adapted from OCMIP2:  SUBROUTINE CO2CALC                 |
C     | mick follows, oct 1999                                   |
C     | minor changes to tidy, swd aug 2002                      |
C     | MODIFIED FOR PRESSURE DEPENDENCE                         |
C     | Karsten Friis and Mick Follows 2004                      |
C     *==========================================================*
C INPUT
C       diclocal = total inorganic carbon (mol/m^3)
C             where 1 T = 1 metric ton = 1000 kg
C       ta  = total alkalinity (eq/m^3)
C       pt  = inorganic phosphate (mol/^3)
C       sit = inorganic silicate (mol/^3)
C       t   = temperature (degrees C)
C       s   = salinity (g/kg)
C OUTPUT
C IMPORTANT: Some words about units - (JCO, 4/4/1999)
C     - Models carry tracers in mol/m^3 (on a per volume basis)
C     - Conversely, this routine, which was written by observationalists
C       (C. Sabine and R. Key), passes input arguments in umol/kg
C       (i.e., on a per mass basis)
C     - I have changed things slightly so that input arguments are in mol/m^3,
C     - Thus, all input concentrations (diclocal, ta, pt, and st) should be
C       given in mol/m^3; output arguments "co2star" and "dco2star"
C       are likewise be in mol/m^3.
C
C NOW INCLUDES:
C PRESSURE DEPENDENCE of K1, K2, solubility product of calcite
C based on Takahashi, GEOSECS Atlantic Report, Vol. 1 (1981)
C
C--------------------------------------------------------------------------

C !USES: ===============================================================
        IMPLICIT NONE
C     == GLobal variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "DIC_VARS.h"

C     == Routine arguments ==
C ttemp and stemp are local theta and salt arrays
C dont really need to pass T and S in, could use theta, salt in
C common block in DYNVARS.h, but this way keeps subroutine more
C general
        _RL  ttemp(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
        _RL  stemp(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
        INTEGER bi,bj,iMin,iMax,jMin,jMax
C K is depth index
        INTEGER Klevel
        INTEGER myThid
CEOP

C LOCAL VARIABLES
        _RL  t
        _RL  s
        _RL  tk
        _RL  tk100
        _RL  tk1002
        _RL  dlogtk
        _RL  sqrtis
        _RL  sqrts
        _RL  s15
        _RL  scl
        _RL  s2
        _RL  invtk
        _RL  is
        _RL  is2
        INTEGER i
        INTEGER j
        INTEGER k
        _RL  bdepth
        _RL  cdepth
        _RL  pressc
        _RL  Ksp_T_Calc
        _RL  xvalue
        _RL  zdum
        _RL  tmpa1
        _RL  tmpa2
        _RL  tmpa3
        _RL  logKspc
        _RL  dv
        _RL  dk
        _RL  pfactor
        _RL  bigR
#ifdef CARBONCHEM_TOTALPHSCALE
c pH scale converstions
        _RL total2free_surf
        _RL free2sw_surf
        _RL total2sw_surf
        _RL total2free
        _RL free2total
        _RL free2sw
        _RL sw2free
        _RL total2sw
        _RL sw2total
#endif
C.....................................................................
C OCMIP note:
C Calculate all constants needed to convert between various measured
C carbon species. References for each equation are noted in the code.
C Once calculated, the constants are
C stored and passed in the common block "const". The original version
C of this code was based on the code by dickson in Version 2 of
C  Handbook of Methods C for the Analysis of the Various Parameters of
C the Carbon Dioxide System in Seawater , DOE, 1994 (SOP No. 3, p25-26).
C....................................................................

c determine pressure (bar) from depth
c 1 BAR at z=0m (atmos pressure)
c use UPPER surface of cell so top layer pressure = 0 bar
c for surface exchange coeffs

cmick..............................
c        write(6,*)'Klevel ',klevel

        bdepth = 0. _d 0
        cdepth = 0. _d 0
        pressc = 1. _d 0
        do k = 1,Klevel
            cdepth = bdepth + 0.5 _d 0*drF(k)
            bdepth = bdepth + drF(k)
            pressc = 1. _d 0 + 0.1 _d 0*cdepth
        enddo
cmick...................................................
c        write(6,*)'depth,pressc ',cdepth,pressc
cmick....................................................

        do i=imin,imax
         do j=jmin,jmax
          IF ( maskC(i,j,Klevel,bi,bj).EQ.oneRS ) THEN
           t = ttemp(i,j)
           s = stemp(i,j)
C terms used more than once for:
C temperature
           tk = 273.15 _d 0 + t
           tk100 = tk/100. _d 0
           tk1002=tk100*tk100
           invtk=1.0 _d 0/tk
           dlogtk=log(tk)
C ionic strength
           is=19.924 _d 0*s/(1000. _d 0-1.005 _d 0*s)
           is2=is*is
           sqrtis=sqrt(is)
C salinity
           s2=s*s
           sqrts=sqrt(s)
           s15=s**1.5 _d 0
           scl=s/1.80655 _d 0

           bigR = 83.14472 _d 0
C------------------------------------------------------------------------
C f = k0(1-pH2O)*correction term for non-ideality
C Weiss & Price (1980, Mar. Chem., 8, 347-359;  Eq 13 with table 6 values)
           ff(i,j,bi,bj) = exp(-162.8301 _d 0 + 218.2968 _d 0/tk100  +
     &          90.9241 _d 0*log(tk100) - 1.47696 _d 0*tk1002 +
     &          s * (.025695 _d 0 - .025225 _d 0*tk100 +
     &          0.0049867 _d 0*tk1002))
C------------------------------------------------------------------------
C K0 from Weiss 1974
C Independent of pH scale
           ak0(i,j,bi,bj) = exp(93.4517 _d 0/tk100 - 60.2409 _d 0 +
     &        23.3585 _d 0 * log(tk100) +
     &        s * (0.023517 _d 0 - 0.023656 _d 0*tk100 +
     &        0.0047036 _d 0*tk1002))
C------------------------------------------------------------------------
C k1 = [H][HCO3]/[H2CO3]
C k2 = [H][CO3]/[HCO3]
C Millero p.664 (1995) using Mehrbach et al. data
C Both on seawater pH scale
           ak1(i,j,bi,bj)=10**(-1 _d 0*(3670.7 _d 0*invtk -
     &          62.008 _d 0 + 9.7944 _d 0*dlogtk -
     &          0.0118 _d 0 * s + 0.000116 _d 0*s2))
           ak2(i,j,bi,bj)=10**(-1*(1394.7 _d 0*invtk + 4.777 _d 0 -
     &          0.0184 _d 0*s + 0.000118 _d 0*s2))
C NOW PRESSURE DEPENDENCE:
c Following Takahashi (1981) GEOSECS report - quoting Culberson and
c Pytkowicz (1968)
c pressc = pressure in bars
           ak1(i,j,bi,bj) = ak1(i,j,bi,bj)*
     &         exp( (24.2 _d 0-0.085 _d 0*t)
     &             *(pressc-1.0 _d 0)/(83.143 _d 0*tk) )
c FIRST GO FOR K2: According to GEOSECS (1982) report
c          ak2(i,j,bi,bj) = ak2(i,j,bi,bj)*
c    &             exp( (26.4-0.040*t)*(pressc-1.0)/(83.143*tk) )
c SECOND GO FOR K2: corrected coeff according to CO2sys documentation
c                   E. Lewis and D. Wallace (1998) ORNL/CDIAC-105
           ak2(i,j,bi,bj) = ak2(i,j,bi,bj)*
     &         exp( (16.4 _d 0-0.040 _d 0*t)
     &             *(pressc-1.0 _d 0)/(83.143 _d 0*tk) )
C------------------------------------------------------------------------
C kb = [H][BO2]/[HBO2]
C Millero p.669 (1995) using data from dickson (1990)
C On total pH scale
           akb(i,j,bi,bj)=exp((-8966.90 _d 0- 2890.53 _d 0*sqrts -
     &          77.942 _d 0*s + 1.728 _d 0*s15 - 0.0996 _d 0*s2)*invtk +
     &          (148.0248 _d 0 + 137.1942 _d 0*sqrts + 1.62142 _d 0*s) +
     &          (-24.4344 _d 0 - 25.085 _d 0*sqrts - 0.2474 _d 0*s) *
     &          dlogtk + 0.053105 _d 0*sqrts*tk)
#ifdef CARBONCHEM_TOTALPHSCALE
C JML Not yet, need to account for pH scale conversions
C    (pressure correct on the seawater scale, not the total scale)
C Mick and Karsten - Dec 04
C ADDING pressure dependence based on Millero (1995), p675
C with additional info from CO2sys documentation (E. Lewis and
C D. Wallace, 1998 - see endnotes for commentary on Millero, 95)
C           bigR = 83.145
C           dv = -29.48 + 0.1622*t + 2.608d-3*t*t
C           dk = -2.84d-3
C           pfactor = - (dv/(bigR*tk))*pressc
C     &               + (0.5*dk/(bigR*tk))*pressc*pressc
C           akb(i,j,bi,bj) = akb(i,j,bi,bj)*exp(pfactor)
#else
C Mick and Karsten - Dec 04
C ADDING pressure dependence based on Millero (1995), p675
C with additional info from CO2sys documentation (E. Lewis and
C D. Wallace, 1998 - see endnotes for commentary on Millero, 95)
           bigR = 83.145 _d 0
           dv = -29.48 _d 0 + 0.1622 _d 0*t + 2.608 _d -3*t*t
           dk = -2.84 _d -3
           pfactor = - (dv/(bigR*tk))*pressc
     &               + (0.5 _d 0*dk/(bigR*tk))*pressc*pressc
           akb(i,j,bi,bj) = akb(i,j,bi,bj)*exp(pfactor)
#endif
C------------------------------------------------------------------------
C k1p = [H][H2PO4]/[H3PO4]
C DOE(1994) eq 7.2.20 with footnote using data from Millero (1974)
C The constant 115.525 is an approximation to convert to the total pH scale
C  (Dickson et al., 2007). Use Millero's 115.540 constant to stay on the seawater
C  pH scale (everything else is the same).
           ak1p(i,j,bi,bj) = exp(-4576.752 _d 0*invtk + 115.525 _d 0 -
     &          18.453 _d 0*dlogtk +
     &          (-106.736 _d 0*invtk + 0.69171 _d 0)*sqrts +
     &          (-0.65643 _d 0*invtk - 0.01844 _d 0)*s)
C------------------------------------------------------------------------
C k2p = [H][HPO4]/[H2PO4]
C DOE(1994) eq 7.2.23 with footnote using data from Millero (1974)
C The constant 172.0833 is an approximation to convert to the total pH scale
C  (Dickson et al., 2007). Use Millero's 172.1033 constant to stay on the seawater
C  pH scale (everything else is the same).
           ak2p(i,j,bi,bj) = exp(-8814.715 _d 0*invtk + 172.0883 _d 0 -
     &          27.927 _d 0*dlogtk +
     &          (-160.34 _d 00*invtk + 1.3566 _d 0) * sqrts +
     &          (0.37335 _d 0*invtk - 0.05778 _d 0) * s)
C------------------------------------------------------------------------
C k3p = [H][PO4]/[HPO4]
C DOE(1994) eq 7.2.26 with footnote using data from Millero (1974)
C The constant 18.141 is an approximation to convert to the total pH scale
C  (Dickson et al., 2007). Use Millero's 18.126 constant to stay on the seawater
C  pH scale (everything else is the same).
           ak3p(i,j,bi,bj) = exp(-3070.75 _d 0*invtk - 18.141 _d 0 +
     &          (17.27039 _d 0*invtk + 2.81197 _d 0) *
     &          sqrts + (-44.99486 _d 0*invtk - 0.09984 _d 0) * s)
C------------------------------------------------------------------------
C ksi = [H][SiO(OH)3]/[Si(OH)4]
C Millero p.671 (1995) using data from Yao and Millero (1995)
C The constant 117.385 is an approximation to convert to the total pH scale
C  (Dickson et al., 2007). Use Millero's 117.400 constant to stay on the seawater
C  pH scale (everything else is the same).
C Note: converted here from mol/kg-H2O to mol/kg-SW
           aksi(i,j,bi,bj) = exp(-8904.2 _d 0*invtk + 117.385 _d 0 -
     &          19.334 _d 0*dlogtk +
     &          (-458.79 _d 0*invtk + 3.5913 _d 0) * sqrtis +
     &          (188.74 _d 0*invtk - 1.5998 _d 0) * is +
     &          (-12.1652 _d 0*invtk + 0.07871 _d 0) * is2 +
     &          log(1.0 _d 0-0.001005 _d 0*s))
C------------------------------------------------------------------------
C kw = [H][OH]
C Millero p.670 (1995) using composite data
C The constant 148.9652 is an approximation to convert to the total pH scale
C  (Dickson et al., 2007). Use Millero's 148.9802 constant to stay on the seawater
C  pH scale (everything else is the same).
           akw(i,j,bi,bj) = exp(-13847.26 _d 0*invtk + 148.9652 _d 0 -
     &          23.6521 _d 0*dlogtk + (118.67 _d 0*invtk
     &          - 5.977 _d 0 + 1.0495 _d 0 * dlogtk) *
     &          sqrts - 0.01615 _d 0 * s)
C------------------------------------------------------------------------
C ks = [H][SO4]/[HSO4]
C dickson (1990, J. chem. Thermodynamics 22, 113)
C On the free pH scale
C Note: converted here from mol/kg-H2O to mol/kg-SW
           aks(i,j,bi,bj)=exp(-4276.1 _d 0*invtk + 141.328 _d 0 -
     &          23.093 _d 0*dlogtk +
     &          (-13856 _d 0*invtk + 324.57 _d 0 - 47.986 _d 0*dlogtk)
     &          *sqrtis +
     &          (35474 _d 0*invtk - 771.54 _d 0 + 114.723 _d 0*dlogtk)
     &          *is -
     &          2698 _d 0*invtk*is**1.5 _d 0 + 1776 _d 0*invtk*is2 +
     &          log(1.0 _d 0 - 0.001005 _d 0*s))
C------------------------------------------------------------------------
C kf = [H][F]/[HF]
C dickson and Riley (1979) -- change pH scale to total (following Dickson & Goyet, 1994)
C Note: converted here from mol/kg-H2O to mol/kg-SW
           akf(i,j,bi,bj)=exp(1590.2 _d 0*invtk - 12.641 _d 0
     &          + 1.525 _d 0*sqrtis
     &          + log(1.0 _d 0 - 0.001005 _d 0*s)
     &          + log(1.0 _d 0 + (0.1400 _d 0/96.062 _d 0)
     &          *(scl)/aks(i,j,bi,bj)))
C------------------------------------------------------------------------
C Calculate concentrations for borate, sulfate, and fluoride
C Uppstrom (1974)
           bt(i,j,bi,bj) = 0.000232 _d 0 * scl/10.811 _d 0
C Morris & Riley (1966)
           st(i,j,bi,bj) = 0.14 _d 0 * scl/96.062 _d 0
C Riley (1965)
           ft(i,j,bi,bj) = 0.000067 _d 0 * scl/18.9984 _d 0
C------------------------------------------------------------------------

#ifdef CARBONCHEM_TOTALPHSCALE
C JML Convert between pH scales, we want everything to end up on the total scale
C ak1 and ak2 are on seawater scale and are pressure corrected, so they just need converting.
C aks is on the free scale, it needs pressure correcting then converting to the total scale.
C akf needs pressure correcting too, but is on the right (total) pH scale.
C akb, ak1p, ak2p, ak3p, aksi and akw are on the total scale. Convert to the seawater
C  scale before pressure correction, and then convert back to the total scale.

C All the terms for pressure correction are from Table 9, Millero (1995), p675
C Info about pH conversions from Munhoven (2013) and Orr and Epitalon (2015)
           total2free_surf = 1. _d 0/
     &                 (1. _d 0 + st(i,j,bi,bj)/aks(i,j,bi,bj))

           free2sw_surf = 1. _d 0
     &                 + st(i,j,bi,bj)/ aks(i,j,bi,bj)
     &                 + ft(i,j,bi,bj)/(akf(i,j,bi,bj)*total2free_surf)

           total2sw_surf = total2free_surf * free2sw_surf

C------------------------------------------------------------------------
C Pressure correct aks on native free pH scale
           dv=-18.03 _d 0 + 0.0466 _d 0*t + 0.316 _d -3 *t*t
           dk=-4.53 _d -3 + 0.09 _d -3 *t
           pfactor = -(dv/(bigR*tk))*pressc
     &            +(0.5*dk/(bigR*tk))*pressc*pressc
           aks(i,j,bi,bj) = aks(i,j,bi,bj)*exp(pfactor)

           total2free = 1. _d 0/
     &                 (1. _d 0 + st(i,j,bi,bj)/aks(i,j,bi,bj))

           free2total = (1. _d 0 + st(i,j,bi,bj)/aks(i,j,bi,bj))

C free2sw has an additional component from fluoride
           free2sw    = 1. _d 0
     &                 + st(i,j,bi,bj)/ aks(i,j,bi,bj)

           aks(i,j,bi,bj) = aks(i,j,bi,bj)*free2total

C------------------------------------------------------------------------
C Pressure correct akf on the free scale before converting back to total
           akf(i,j,bi,bj) = akf(i,j,bi,bj) * total2free_surf
           dv  =  -9.78 _d 0 -0.0090 _d 0 *t -0.942 _d -3 *t*t
           dk  =  -3.91 _d -3 + 0.054 _d -3 *t
           pfactor = -(dv/(bigR*tk))*pressc
     &               +(0.5*dk/(bigR*tk))*pressc*pressc
           akf(i,j,bi,bj) = akf(i,j,bi,bj) * exp(pfactor)
           akf(i,j,bi,bj) = akf(i,j,bi,bj)*free2total

C free2sw has an additional component from fluoride, add it here
           free2sw = free2sw
     &               + ft(i,j,bi,bj)/(akf(i,j,bi,bj)*total2free)

           sw2free  = 1. _d 0 / free2sw

           total2sw = total2free * free2sw

           sw2total = 1. _d 0 / total2sw

C------------------------------------------------------------------------
C Convert pressure corrected ak1 and ak2 from the seawater pH scale to the total scale
           ak1(i,j,bi,bj)  = ak1(i,j,bi,bj)*sw2total
           ak2(i,j,bi,bj)  = ak2(i,j,bi,bj)*sw2total

C------------------------------------------------------------------------
C Pressure correct akb on the seawater scale before converting back to total scale
            dv = -29.48 _d 0 + 0.1622 _d 0*t + 2.608 _d -3*t*t
            dk = -2.84 _d -3
            pfactor = - (dv/(bigR*tk))*pressc
     &                + (0.5*dk/(bigR*tk))*pressc*pressc
            akb(i,j,bi,bj) = total2sw_surf*akb(i,j,bi,bj)*exp(pfactor)
            akb(i,j,bi,bj) = akb(i,j,bi,bj)*sw2total

C------------------------------------------------------------------------
C Pressure correct ak1p on the seawater scale before converting back to total scale
            dv = -14.51 _d 0 + 0.1211 _d 0*t -0.321 _d -3*t*t
            dk = -2.67 _d -3 + 0.0427 _d -3*t
            pfactor = - (dv/(bigR*tk))*pressc
     &                + (0.5*dk/(bigR*tk))*pressc*pressc
            ak1p(i,j,bi,bj) = total2sw_surf*ak1p(i,j,bi,bj)*exp(pfactor)
            ak1p(i,j,bi,bj) = ak1p(i,j,bi,bj)*sw2total

C------------------------------------------------------------------------
C Pressure correct ak2p on the seawater scale before converting back to total scale
            dv = -23.12 _d 0 + 0.1758 _d 0*t -2.647 _d -3*t*t
            dk = -5.15 _d -3 + 0.09 _d -3*t
            pfactor = - (dv/(bigR*tk))*pressc
     &                + (0.5*dk/(bigR*tk))*pressc*pressc
            ak2p(i,j,bi,bj) = total2sw_surf*ak2p(i,j,bi,bj)*exp(pfactor)
            ak2p(i,j,bi,bj) = ak2p(i,j,bi,bj)*sw2total

C------------------------------------------------------------------------
C Pressure correct ak3p on the seawater scale before converting back to total scale
            dv = -26.57 _d 0 + 0.2020 _d 0*t -3.042 _d -3*t*t
            dk = -4.08 _d -3 + 0.0714 _d -3*t
            pfactor = - (dv/(bigR*tk))*pressc
     &                + (0.5*dk/(bigR*tk))*pressc*pressc
            ak3p(i,j,bi,bj) = total2sw_surf*ak3p(i,j,bi,bj)*exp(pfactor)
            ak3p(i,j,bi,bj) = ak3p(i,j,bi,bj)*sw2total

C------------------------------------------------------------------------
C Pressure correct akw on the seawater scale before converting back to total scale
            dv = -20.02 _d 0 + 0.1119 _d 0*t -1.409 _d -3*t*t
            dk = -5.13 _d -3 + 0.0794 _d -3 *t
            pfactor = - (dv/(bigR*tk))*pressc
     &                + (0.5*dk/(bigR*tk))*pressc*pressc
            akw(i,j,bi,bj) = total2sw_surf*akw(i,j,bi,bj)*exp(pfactor)
            akw(i,j,bi,bj) = akw(i,j,bi,bj)*sw2total

C------------------------------------------------------------------------
C Pressure correct aksi on the seawater scale before converting back to total scale
C Estimated from the effect on akb
            dv = -29.48 _d 0 + 0.1622 _d 0*t + 2.608 _d -3*t*t
            dk = -2.84 _d -3
            pfactor = - (dv/(bigR*tk))*pressc
     &                + (0.5*dk/(bigR*tk))*pressc*pressc
            aksi(i,j,bi,bj) = total2sw_surf*aksi(i,j,bi,bj)*exp(pfactor)
            aksi(i,j,bi,bj) = aksi(i,j,bi,bj)*sw2total
#endif

C------------------------------------------------------------------------
C Solubility product for calcite
C
c Following Takahashi (1982) GEOSECS handbook
C NOT SURE THIS IS WORKING???
C Ingle et al. (1973)
c          Ksp_T_Calc = ( -34.452 - 39.866*(s**0.333333)
c    &                  + 110.21*log(s) - 7.5752d-6 * (tk**2.0)
c    &                  ) * 1.0d-7
c with pressure dependence Culberson and Pytkowicz (1968)
c          xvalue  =  (36-0.20*t)*(pressc-1.0)/(83.143*tk)
c          Ksp_TP_Calc(i,j,bi,bj) = Ksp_T_Calc*exp(xvalue)
c
c
C Following Mucci (1983) - from Zeebe/Wolf-Gladrow equic.m
            tmpa1 = - 171.9065 _d 0 - (0.077993 _d 0*tk)
     &            + (2839.319 _d 0/tk) + (71.595 _d 0*log10(tk))
            tmpa2 = +(-0.77712 _d 0 + (0.0028426 _d 0*tk)
     &           + (178.34 _d 0/tk) )*sqrts
            tmpa3 = -(0.07711 _d 0*s) + (0.0041249 _d 0*s15)
            logKspc = tmpa1 + tmpa2 + tmpa3
            Ksp_T_Calc = 10.0 _d 0**logKspc
c        write(6,*)i,j,k,tmpa1,tmpa2,tmpa3,logkspc,Ksp_T_Calc
c with pressure dependence Culberson and Pytkowicz (1968)
c        xvalue  =  (36.0-0.20*t)*(pressc-1.0)/(83.143*tk)
c        Ksp_TP_Calc(i,j,bi,bj) = Ksp_T_Calc*exp(xvalue)

c alternative pressure depdendence
c following Millero (1995) but using info from Appendix A11 of
c Zeebe and Wolf-Gladrow (2001) book
c          dv = -48.6 - 0.5304*t
c          dk = -11.76d-3 - 0.3692*t
c          xvalue = - (dv/(bigR*tk))*pressc
c    &               + (0.5*dk/(bigR*tk))*pressc*pressc
c          Ksp_TP_Calc(i,j,bi,bj) = Ksp_T_Calc*exp(xvalue)

c alternative pressure dependence from Ingle (1975)

            zdum   = (pressc*10. _d 0 - 10. _d 0)/10. _d 0
            xvalue = ( (48.8 _d 0 - 0.53 _d 0*t)*zdum
     &                 + (-0.00588 _d 0 + 0.0001845 _d 0*t)*zdum*zdum)
     &            / (188.93 _d 0*(t + 273.15 _d 0))

            Ksp_TP_Calc(i,j,bi,bj) = Ksp_T_Calc*10**(xvalue)

C------------------------------------------------------------------------
          ELSE
            ff(i,j,bi,bj)=0. _d 0
            ak0(i,j,bi,bj)= 0. _d 0
            ak1(i,j,bi,bj)= 0. _d 0
            ak2(i,j,bi,bj)= 0. _d 0
            akb(i,j,bi,bj)= 0. _d 0
            ak1p(i,j,bi,bj) = 0. _d 0
            ak2p(i,j,bi,bj) = 0. _d 0
            ak3p(i,j,bi,bj) = 0. _d 0
            aksi(i,j,bi,bj) = 0. _d 0
            akw(i,j,bi,bj) = 0. _d 0
            aks(i,j,bi,bj)= 0. _d 0
            akf(i,j,bi,bj)= 0. _d 0
            bt(i,j,bi,bj) = 0. _d 0
            st(i,j,bi,bj) = 0. _d 0
            ft(i,j,bi,bj) = 0. _d 0
            Ksp_TP_Calc(i,j,bi,bj) = 0. _d 0
          ENDIF
         enddo
        enddo

        RETURN
        END

#include "CTRL_OPTIONS.h"

      subroutine optim_write_control(
     I                          nv,
     I                          xx
     &                        )

c     ==================================================================
c     SUBROUTINE optim_write_control
c     ==================================================================
c
c     o Interface routine for writing the next estimate of the control
c       vector that is to be used by the ocean state estimation program.
c
c     started: Christian Eckert eckert@mit.edu 12-Apr-2000
c
c     changed:  Patrick Heimbach heimbach@mit.edu 19-Jun-2000
c               - finished, revised and debugged
c
c     ==================================================================
c     SUBROUTINE optim_write_control
c     ==================================================================

      implicit none

c     == global variables ==

#include "EEPARAMS.h"
#include "SIZE.h"
#include "CTRL_SIZE.h"
#include "CTRL.h"

c     == routine arguments ==

      integer nv
      _RL     xx(nv)

c     == local variables ==

      _RL           ff

      logical lheaderonly

c     == end of interface ==

      ff       = -9999.

      print *,'pathei: writing ', nv,' sized control to file',
     &     ctrlname

      lheaderonly = .false.
      call optim_writedata( nv, ctrlname, lheaderonly, ff, xx )

      return
      end

#include "ADMTLM_OPTIONS.h"

      subroutine admtlm_bypassad( myThid )
C     /==========================================================\
C     | subroutine admtlm_bypassad                               |
C     | o This routine assigns final T,S to cost function        |
C     \==========================================================/
       implicit none

C     == Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#if (defined (ALLOW_ADMTLM) && defined (ALLOW_BYPASSAD))
# include "CTRL.h"
# include "CTRL_DUMMY.h"
# include "OPTIMCYCLE.h"
# include "adcost.h"
# include "g_cost.h"
# include "adcommon.h"
#endif

C     ======== Routine arguments ======================
C     myThid - Thread number for this instance of the routine.
      integer myThid

#if (defined (ALLOW_ADMTLM) && defined (ALLOW_BYPASSAD))

C     ========= Local variables =========================
      integer i, j, k
      integer bi, bj
      integer imin, imax
      integer jmin, jmax
      integer itlo, ithi
      integer jtlo, jthi
      integer il

      logical ladinit
      logical doglobalread
      logical equal
      double precision fac
      character*(80) fnamegeneric

      _RL tmpfld2d (1-olx:snx+olx,1-oly:sny+oly,   nsx,nsy)
      _RL tmpfld3d (1-olx:snx+olx,1-oly:sny+oly,nr,nsx,nsy)

C     ==============================================
C     declare external procedures and functions
C     ==============================================
      integer ilnblnk
      external ilnblnk

C     ===================================================

      jtlo = mybylo(mythid)
      jthi = mybyhi(mythid)
      itlo = mybxlo(mythid)
      ithi = mybxhi(mythid)
      jmin = 1
      jmax = sny
      imin = 1
      imax = snx
      doglobalread =  .false.
      ladinit =  .false.
      equal =  .true.
      if (equal) then
        fac = 1.d0
      else
        fac = 0.d0
      endif

      DO bj = jtlo, jthi
       DO bi = itlo, ithi
        DO j = jmin, jmax
         DO i = imin, imax
          DO k=1,Nr
            adtheta(i,j,k,bi,bj) =
     &       g_objf_state_final(i,j,bi,bj,k)
            adsalt(i,j,k,bi,bj) =
     &       g_objf_state_final(i,j,bi,bj,1*Nr+k)
            aduvel(i,j,k,bi,bj) =
     &       g_objf_state_final(i,j,bi,bj,2*Nr+k)
            advvel(i,j,k,bi,bj) =
     &       g_objf_state_final(i,j,bi,bj,3*Nr+k)
          END DO
          adetan(i,j,bi,bj) =
     &       g_objf_state_final(i,j,bi,bj,4*Nr+1)
         END DO
        END DO
       END DO
      END DO

c---------------------------------------------------------------------

      do bj = jtlo, jthi
        do bi = itlo, ithi
          do j = jmin, jmax
            do i = imin, imax
              tmpfld2d(i,j,bi,bj) = tmpfld2d(i,j,bi,bj)
     &              + adetan(i,j,bi,bj)
            end do
          end do
        end do
      end do
      il = ilnblnk(xx_etan_file)
      write(unit=fnamegeneric(1:80),fmt='(2a,i10.10)')
     &     xx_etan_file(1:il),'.',optimcycle
      call adactive_read_xy_loc( fnamegeneric,1,doglobalread,ladinit,
     &     optimcycle,mythid,tmpfld2d )
c--
      do bj = jtlo, jthi
        do bi = itlo, ithi
          do k = 1, nr
            do j = jmin, jmax
              do i = imin, imax
                tmpfld3d(i,j,k,bi,bj) = tmpfld3d(i,j,k,bi,bj)
     &                + advvel(i,j,k,bi,bj)
              end do
            end do
          end do
        end do
      end do
      il = ilnblnk(xx_vvel_file)
      write(unit=fnamegeneric(1:80),fmt='(2a,i10.10)')
     &     xx_vvel_file(1:il),'.',optimcycle
      call adactive_read_xyz( fnamegeneric,1,doglobalread,ladinit,
     &     optimcycle,mythid,tmpfld3d )
c--
      do bj = jtlo, jthi
        do bi = itlo, ithi
          do k = 1, nr
            do j = jmin, jmax
              do i = imin, imax
                tmpfld3d(i,j,k,bi,bj) = tmpfld3d(i,j,k,bi,bj)
     &                + aduvel(i,j,k,bi,bj)
              end do
            end do
          end do
        end do
      end do
      il = ilnblnk(xx_uvel_file)
      write(unit=fnamegeneric(1:80),fmt='(2a,i10.10)')
     &     xx_uvel_file(1:il),'.',optimcycle
      call adactive_read_xyz( fnamegeneric,1,doglobalread,ladinit,
     &     optimcycle,mythid,tmpfld3d )
c--
      do bj = jtlo, jthi
        do bi = itlo, ithi
          do k = 1, nr
            do j = jmin, jmax
              do i = imin, imax
                tmpfld3d(i,j,k,bi,bj) = tmpfld3d(i,j,k,bi,bj)
     &                + adsalt(i,j,k,bi,bj)*fac
              end do
            end do
          end do
        end do
      end do
      il = ilnblnk(xx_salt_file)
      write(unit=fnamegeneric(1:80),fmt='(2a,i10.10)')
     &     xx_salt_file(1:il),'.',optimcycle
      call adactive_read_xyz_loc( fnamegeneric,1,doglobalread,ladinit,
     &     optimcycle,mythid,tmpfld3d )
c--
      do bj = jtlo, jthi
        do bi = itlo, ithi
          do k = 1, nr
            do j = jmin, jmax
              do i = imin, imax
                tmpfld3d(i,j,k,bi,bj) = tmpfld3d(i,j,k,bi,bj)
     &                + adtheta(i,j,k,bi,bj)*fac
              end do
            end do
          end do
        end do
      end do
      il = ilnblnk(xx_theta_file)
      write(unit=fnamegeneric(1:80),fmt='(2a,i10.10)')
     &     xx_theta_file(1:il),'.',optimcycle
      call adactive_read_xyz_loc( fnamegeneric,1,doglobalread,ladinit,
     &     optimcycle,mythid,tmpfld3d )

#endif

      end

#include "THSICE_OPTIONS.h"

CBOP
C     !ROUTINE: THSICE_MONITOR
C     !INTERFACE
      SUBROUTINE THSICE_MONITOR( myTime, myIter, myThid )

C     !DESCRIPTION:
C     Do ICE global and Hemispheric monitor output

C     !USES:
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "THSICE_PARAMS.h"
#include "THSICE_VARS.h"
#ifdef ALLOW_MONITOR
# include "MONITOR.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     myTime :: Current time of simulation ( s )
C     myIter :: Iteration number
C     myThid :: my Thread Id. number
      _RL     myTime
      INTEGER myIter
      INTEGER myThid
CEOP

#ifdef ALLOW_THSICE
#ifdef ALLOW_MONITOR

C     === Functions ====
      LOGICAL  DIFFERENT_MULTIPLE
      EXTERNAL DIFFERENT_MULTIPLE
      LOGICAL  MASTER_CPU_IO
      EXTERNAL MASTER_CPU_IO

C     == Local variables ==
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      CHARACTER*10 mon_var
      CHARACTER*2 mon_sufx(0:2)
      _RS locMask(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RS yBand(2), locDr(1)
      _RL theMin(2), theMax(2)
      _RL theMean(2), theVar(2), theVol(2)
      _RL theMeanG, theVolG
      _RL theMean1, theMean2, theEnergy
      _RL theMin0, theMax0, theSD, theDel2
c     _RL dummyRL(6)
      INTEGER i,j,bi,bj
#ifdef ALLOW_MNC
      INTEGER k
#endif

      DATA yBand / 0. , 0. /
      DATA locDr / 1. /
      DATA mon_sufx / '_G' , '_S' , '_N' /

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      IF (
     &   DIFFERENT_MULTIPLE(thSIce_monFreq,myTime,deltaTclock)
     &   .OR. myIter.EQ.nIter0 ) THEN

        IF ( MASTER_CPU_IO(myThid) ) THEN
C--   only the master thread is allowed to switch On/Off mon_write_stdout
C     & mon_write_mnc (since it is the only thread that uses those flags):

          IF ( thSIce_mon_stdio ) THEN
            mon_write_stdout = .TRUE.
          ELSE
            mon_write_stdout = .FALSE.
          ENDIF
          mon_write_mnc    = .FALSE.
#ifdef ALLOW_MNC
          IF (useMNC .AND. thSIce_mon_mnc) THEN
            DO k = 1,MAX_LEN_MBUF
              mon_fname(k:k) = ' '
            ENDDO
            mon_fname(1:12) = 'monitor_sice'
            CALL MNC_CW_SET_UDIM(mon_fname, -1, myThid)
            CALL MNC_CW_I_W_S(
     &          'I',mon_fname,1,1,'iter', myIter, myThid)
            CALL MNC_CW_SET_UDIM(mon_fname, 0, myThid)
            CALL MNC_CW_RL_W_S(
     &          'D',mon_fname,1,1,'T', myTime, myThid)
            mon_write_mnc = .TRUE.
          ENDIF
#endif /* ALLOW_MNC */

          IF (mon_write_stdout) THEN
            WRITE(msgBuf,'(2A)') '// ==========================',
     &             '============================='
            CALL PRINT_MESSAGE( msgBuf, mon_ioUnit, SQUEEZE_RIGHT , 1)
            WRITE(msgBuf,'(A)')
     &             '// Begin MONITOR Therm.SeaIce statistics'
            CALL PRINT_MESSAGE( msgBuf, mon_ioUnit, SQUEEZE_RIGHT , 1)
            WRITE(msgBuf,'(2A)') '// ==========================',
     &             '============================='
            CALL PRINT_MESSAGE( msgBuf, mon_ioUnit, SQUEEZE_RIGHT , 1)
          ENDIF

C--   endif master cpu io
        ENDIF

C--   make a local copy of iceMask into "RS" array:
        DO bj = myByLo(myThid), myByHi(myThid)
         DO bi = myBxLo(myThid), myBxHi(myThid)
          DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
            locMask(i,j,bi,bj) = iceMask(i,j,bi,bj)
           ENDDO
          ENDDO
         ENDDO
        ENDDO

        CALL MON_SET_PREF('thSI_',myThid)
        CALL MON_OUT_RL('time_sec', myTime,mon_string_none,myThid)

C-- Ice area and Ice thickness :
        CALL MON_STATS_LATBND_RL(
     I                1, 1, 1, 2, yBand,
     I                iceHeight, locMask, maskInC, rA, yC, locDr,
     O                theMin, theMax, theMean, theVar, theVol,
     I                myThid )
        theVolG= theVol(1)+theVol(2)
        theMeanG= theMean(1)*theVol(1)+theMean(2)*theVol(2)
        IF (theVolG.GT.0.) theMeanG = theMeanG / theVolG

        mon_var='Ice_Area'
        CALL MON_OUT_RL(mon_var, theVolG  , mon_sufx(0), myThid)
        CALL MON_OUT_RL(mon_var, theVol(1), mon_sufx(1), myThid)
        CALL MON_OUT_RL(mon_var, theVol(2), mon_sufx(2), myThid)
        mon_var='IceH_ave'
        CALL MON_OUT_RL(mon_var,theMeanG  , mon_sufx(0), myThid)
        CALL MON_OUT_RL(mon_var,theMean(1), mon_sufx(1), myThid)
        CALL MON_OUT_RL(mon_var,theMean(2), mon_sufx(2), myThid)
        mon_var='IceH_max'
        CALL MON_OUT_RL(mon_var, theMax(1), mon_sufx(1), myThid)
        CALL MON_OUT_RL(mon_var, theMax(2), mon_sufx(2), myThid)

C-- Snow thickness :
        CALL MON_STATS_LATBND_RL(
     I                1, 1, 1, 2, yBand,
     I                snowHeight, locMask, maskInC, rA, yC, locDr,
     O                theMin, theMax, theMean, theVar, theVol,
     I                myThid )
        theVolG= theVol(1)+theVol(2)
        theMeanG= theMean(1)*theVol(1)+theMean(2)*theVol(2)
        theEnergy = -rhos*Lfresh*theMeanG
        IF (theVolG.GT.0.) theMeanG = theMeanG / theVolG

        mon_var='SnwH_ave'
        CALL MON_OUT_RL(mon_var,theMeanG  , mon_sufx(0), myThid)
        CALL MON_OUT_RL(mon_var,theMean(1), mon_sufx(1), myThid)
        CALL MON_OUT_RL(mon_var,theMean(2), mon_sufx(2), myThid)
        mon_var='SnwH_max'
        CALL MON_OUT_RL(mon_var, theMax(1), mon_sufx(1), myThid)
        CALL MON_OUT_RL(mon_var, theMax(2), mon_sufx(2), myThid)

C-- Surface Temp. :
        CALL MON_STATS_LATBND_RL(
     I                1, 1, 1, 2, yBand,
     I                Tsrf, locMask, maskInC, rA, yC, locDr,
     O                theMin, theMax, theMean, theVar, theVol,
     I                myThid )
        theVolG= theVol(1)+theVol(2)
        theMeanG= theMean(1)*theVol(1)+theMean(2)*theVol(2)
        IF (theVolG.GT.0.) theMeanG = theMeanG / theVolG

        mon_var='Tsrf_ave'
        CALL MON_OUT_RL(mon_var,theMeanG  , mon_sufx(0), myThid)
        CALL MON_OUT_RL(mon_var,theMean(1), mon_sufx(1), myThid)
        CALL MON_OUT_RL(mon_var,theMean(2), mon_sufx(2), myThid)
        mon_var='Tsrf_min'
        CALL MON_OUT_RL(mon_var, theMin(1), mon_sufx(1), myThid)
        CALL MON_OUT_RL(mon_var, theMin(2), mon_sufx(2), myThid)
        mon_var='Tsrf_max'
        CALL MON_OUT_RL(mon_var, theMax(1), mon_sufx(1), myThid)
        CALL MON_OUT_RL(mon_var, theMax(2), mon_sufx(2), myThid)

C--   make a local copy of iceMask*iceHeight into "RS" array:
        DO bj = myByLo(myThid), myByHi(myThid)
         DO bi = myBxLo(myThid), myBxHi(myThid)
          DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
            locMask(i,j,bi,bj)=iceMask(i,j,bi,bj)*iceHeight(i,j,bi,bj)
           ENDDO
          ENDDO
         ENDDO
        ENDDO

C-- 1rst level (volume-mean) Temp. :
        CALL MON_STATS_LATBND_RL(
     I                1, 1, 1, 2, yBand,
     I                Tice1, locMask, maskInC, rA, yC, locDr,
     O                theMin, theMax, theMean, theVar, theVol,
     I                myThid )
        theVolG = theVol(1)+theVol(2)
        theMeanG= theMean(1)*theVol(1)+theMean(2)*theVol(2)
        IF (theVolG.GT.0.) theMeanG = theMeanG / theVolG

c       mon_var='IceVolum'
c       CALL MON_OUT_RL(mon_var, theVolG  , mon_sufx(0), myThid)
c       CALL MON_OUT_RL(mon_var, theVol(1), mon_sufx(1), myThid)
c       CALL MON_OUT_RL(mon_var, theVol(2), mon_sufx(2), myThid)
        mon_var='Tic1_ave'
        CALL MON_OUT_RL(mon_var,theMeanG  , mon_sufx(0), myThid)
        CALL MON_OUT_RL(mon_var,theMean(1), mon_sufx(1), myThid)
        CALL MON_OUT_RL(mon_var,theMean(2), mon_sufx(2), myThid)
        mon_var='Tic1_min'
        CALL MON_OUT_RL(mon_var, theMin(1), mon_sufx(1), myThid)
        CALL MON_OUT_RL(mon_var, theMin(2), mon_sufx(2), myThid)
        mon_var='Tic1_max'
        CALL MON_OUT_RL(mon_var, theMax(1), mon_sufx(1), myThid)
        CALL MON_OUT_RL(mon_var, theMax(2), mon_sufx(2), myThid)

C-- 2nd  level (volume-mean) Temp. :
        CALL MON_STATS_LATBND_RL(
     I                1, 1, 1, 2, yBand,
     I                Tice2, locMask, maskInC, rA, yC, locDr,
     O                theMin, theMax, theMean, theVar, theVol,
     I                myThid )
        theMeanG= theMean(1)*theVol(1)+theMean(2)*theVol(2)
        IF (theVolG.GT.0.) theMeanG = theMeanG / theVolG

        mon_var='Tic2_ave'
        CALL MON_OUT_RL(mon_var,theMeanG  , mon_sufx(0), myThid)
        CALL MON_OUT_RL(mon_var,theMean(1), mon_sufx(1), myThid)
        CALL MON_OUT_RL(mon_var,theMean(2), mon_sufx(2), myThid)
        mon_var='Tic2_min'
        CALL MON_OUT_RL(mon_var, theMin(1), mon_sufx(1), myThid)
        CALL MON_OUT_RL(mon_var, theMin(2), mon_sufx(2), myThid)
        mon_var='Tic2_max'
        CALL MON_OUT_RL(mon_var, theMax(1), mon_sufx(1), myThid)
        CALL MON_OUT_RL(mon_var, theMax(2), mon_sufx(2), myThid)

C-- Total Energy :
        CALL MON_CALC_STATS_RL(
     I                1, Qice1, locMask, maskInC, rA, locDr,
     O                theMin0,theMax0,theMean1,theSD,theDel2,theVolG,
     I                myThid )
        CALL MON_CALC_STATS_RL(
     I                1, Qice2, locMask, maskInC, rA, locDr,
     O                theMin0,theMax0,theMean2,theSD,theDel2,theVolG,
     I                myThid )
        theEnergy = theEnergy -rhoi*(theMean1+theMean2)*theVolG/2
        mon_var='TotEnerg'
        CALL MON_OUT_RL(mon_var, theEnergy, mon_sufx(0), myThid)

C-- Surface fluxes
c       IF ( fluidIsWater .AND. monitorSelect.GE.3 ) THEN
c          CALL MON_WRITESTATS_RL( 1, icFrwAtm,'atmFrW',
c    &            maskInC, maskInC, rA , drF, dummyRL, myThid )
c       ENDIF
        IF ( thSIceBalanceAtmFW.NE.0 ) THEN
         CALL MON_OUT_RL('adjustFrW',adjustFrW,mon_string_none,myThid)
        ENDIF

        IF ( MASTER_CPU_IO(myThid) ) THEN
C--   only the master thread is allowed to switch On/Off mon_write_stdout
C     & mon_write_mnc (since it is the only thread that uses those flags):

          IF (mon_write_stdout) THEN
            WRITE(msgBuf,'(2A)') '// ==========================',
     &             '============================='
            CALL PRINT_MESSAGE( msgBuf, mon_ioUnit, SQUEEZE_RIGHT , 1)
            WRITE(msgBuf,'(A)')
     &             '// End MONITOR Therm.SeaIce statistics'
            CALL PRINT_MESSAGE( msgBuf, mon_ioUnit, SQUEEZE_RIGHT , 1)
            WRITE(msgBuf,'(2A)') '// ==========================',
     &             '============================='
            CALL PRINT_MESSAGE( msgBuf, mon_ioUnit, SQUEEZE_RIGHT , 1)
          ENDIF

          mon_write_stdout = .FALSE.
          mon_write_mnc    = .FALSE.

C--   endif master cpu io
        ENDIF

C     endif different multiple
      ENDIF

#endif /* ALLOW_MONITOR */
#endif /* ALLOW_THSICE */

      RETURN
      END

#include "OCN_CPL_OPTIONS.h"

CBOP
C     !ROUTINE: OCN_APPLY_IMPORT
C     !INTERFACE:
      SUBROUTINE OCN_APPLY_IMPORT(
     I               apply2AllFields, myTime, myIter, myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE OCN_APPLY_IMPORT
C     | o Apply imported coupling data to forcing fields
C     *==========================================================*
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "CPL_PARAMS.h"
#include "SURFACE.h"
#include "FFIELDS.h"
#include "OCNCPL.h"
#ifdef ALLOW_THSICE
# include "THSICE_VARS.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
C     apply2AllFields - flag: T= apply import to all coupling fields
C                 F= only forcing fields relevant for eta variations
C     myTime - Simulation time
C     myIter - Simulation timestep number
C     myThid - Thread no. that called this routine.
      LOGICAL apply2AllFields
      _RL     myTime
      INTEGER myIter
      INTEGER myThid

C     !LOCAL VARIABLES:
C     === Local arrays ===
      INTEGER bi,bj,i,j
CEOP

C--  Use imported coupling data in place of input files data:
      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)

C--     Aplly import to all coupling fields (standard way)
        IF ( apply2AllFields ) THEN

C-   Dynamical forcing
         IF ( useImportTau ) THEN
           DO j=1-OLy,sNy+OLy
            DO i=1-OLx,sNx+OLx
              fu(i,j,bi,bj) = tauX(i,j,bi,bj)
              fv(i,j,bi,bj) = tauY(i,j,bi,bj)
            ENDDO
           ENDDO
         ENDIF
         IF ( useImportSLP ) THEN
           DO j=1-OLy,sNy+OLy
            DO i=1-OLx,sNx+OLx
              pLoad(i,j,bi,bj) = atmSLPr(i,j,bi,bj)
            ENDDO
           ENDDO
         ENDIF
         IF ( useImportSIce ) THEN
           DO j=1-OLy,sNy+OLy
            DO i=1-OLx,sNx+OLx
              sIceLoad(i,j,bi,bj) = seaIceMass(i,j,bi,bj)
            ENDDO
           ENDDO
         ENDIF

C-   Fresh-Water & Salinity forcing
         IF ( useImportFW ) THEN
           DO j=1-OLy,sNy+OLy
            DO i=1-OLx,sNx+OLx
              EmPmR(i,j,bi,bj) = FWFlux    (i,j,bi,bj)
            ENDDO
           ENDDO
         ENDIF
         IF ( useImportFW ) THEN
           DO j=1-OLy,sNy+OLy
            DO i=1-OLx,sNx+OLx
              saltFlux(i,j,bi,bj)= iceSaltFlx(i,j,bi,bj)
            ENDDO
           ENDDO
         ENDIF

C-   Heat Flux forcing
         IF ( useImportHFlx ) THEN
           DO j=1-OLy,sNy+OLy
            DO i=1-OLx,sNx+OLx
              Qnet(i,j,bi,bj)= HeatFlux  (i,j,bi,bj)
            ENDDO
           ENDDO
#ifdef SHORTWAVE_HEATING
           DO j=1-OLy,sNy+OLy
            DO i=1-OLx,sNx+OLx
             Qsw(i,j,bi,bj) = qShortWave(i,j,bi,bj)
            ENDDO
           ENDDO
#endif
         ENDIF

#ifdef ALLOW_THSICE
         IF ( useImportThSIce .AND. useThSIce ) THEN
           DO j=1-OLy,sNy+OLy
            DO i=1-OLx,sNx+OLx
             iceMask   (i,j,bi,bj) = sIceFrac_cpl (i,j,bi,bj)
             iceHeight (i,j,bi,bj) = sIceThick_cpl(i,j,bi,bj)
             snowHeight(i,j,bi,bj) = sIceSnowH_cpl(i,j,bi,bj)
             Qice1     (i,j,bi,bj) = sIceQ1_cpl   (i,j,bi,bj)
             Qice2     (i,j,bi,bj) = sIceQ2_cpl   (i,j,bi,bj)
            ENDDO
           ENDDO
         ENDIF
#endif /* ALLOW_THSICE */

C--     Apply only to forcings relevant for eta/surf.press variations
        ELSE

         IF ( useImportSIce .AND. useImportSLP ) THEN
           DO j=1-OLy,sNy+OLy
            DO i=1-OLx,sNx+OLx
              phi0surf(i,j,bi,bj) = atmSLPr(i,j,bi,bj)*recip_rhoConst
     &                 + gravity*seaIceMass(i,j,bi,bj)*recip_rhoConst
            ENDDO
           ENDDO
         ELSEIF ( useImportSIce ) THEN
           DO j=1-OLy,sNy+OLy
            DO i=1-OLx,sNx+OLx
              phi0surf(i,j,bi,bj) = pLoad(i,j,bi,bj)*recip_rhoConst
     &                 + gravity*seaIceMass(i,j,bi,bj)*recip_rhoConst
            ENDDO
           ENDDO
         ELSEIF ( useImportSLP ) THEN
           DO j=1-OLy,sNy+OLy
            DO i=1-OLx,sNx+OLx
              phi0surf(i,j,bi,bj) = atmSLPr(i,j,bi,bj)*recip_rhoConst
            ENDDO
           ENDDO
         ENDIF

         IF ( useImportFW ) THEN
           DO j=1-OLy,sNy+OLy
            DO i=1-OLx,sNx+OLx
              EmPmR(i,j,bi,bj) = FWFlux    (i,j,bi,bj)
            ENDDO
           ENDDO
         ENDIF

C--     end if apply2AllFields / else blocks
        ENDIF

C--  end bi,bj loop
       ENDDO
      ENDDO

C--  Fill in Halo region with valid values

#ifdef ATMOSPHERIC_LOADING
      IF ( useImportSLP . AND.
     &    ( ocn_cplExch_DIC .OR. apply2AllFields ) )
     &   _EXCH_XY_RS( pLoad,    myThid )
      IF ( apply2AllFields ) THEN
        IF ( useImportSIce ) _EXCH_XY_RS( sIceLoad, myThid )
      ELSEIF ( useImportSLP .OR. useImportSIce ) THEN
         _EXCH_XY_RS( phi0surf, myThid )
      ENDIF
#else
      IF ( useImportSLP . AND. ocn_cplExch_DIC )
     &   _EXCH_XY_RS( pLoad,    myThid )
#endif

      IF ( useImportFW  ) _EXCH_XY_RS( EmPmR, myThid )
      IF ( apply2AllFields ) THEN
        IF ( useImportTau  ) CALL EXCH_UV_XY_RS(fu,fv,.TRUE.,myThid)
        IF ( useImportFW   ) _EXCH_XY_RS( saltFlux, myThid )
        IF ( useImportHFlx ) _EXCH_XY_RS( Qnet , myThid )
#ifdef SHORTWAVE_HEATING
        IF ( useImportHFlx ) _EXCH_XY_RS( Qsw ,  myThid )
#endif
#ifdef ALLOW_THSICE
        IF ( useImportThSIce .AND. useThSIce ) THEN
          _EXCH_XY_RL( iceMask   , myThid )
          _EXCH_XY_RL( iceHeight , myThid )
          _EXCH_XY_RL( snowHeight, myThid )
          _EXCH_XY_RL( Qice1     , myThid )
          _EXCH_XY_RL( Qice2     , myThid )
        ENDIF
#endif /* ALLOW_THSICE */
      ENDIF

      RETURN
      END

#include "MATRIX_OPTIONS.h"

C     !ROUTINE: MATRIX_READPARMS

      SUBROUTINE MATRIX_READPARMS( myThid )

C     !DESCRIPTION:
C     Initialize MATRIX parameters, read in data.matrix

      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "PTRACERS_SIZE.h"
#include "MATRIX.h"

C     !INPUT PARAMETERS:
C     myThid            :: thread number
      INTEGER myThid

C     !OUTPUT PARAMETERS:
C     none

#ifdef ALLOW_MATRIX
C     !LOCAL VARIABLES:
C     iUnit  :: unit number for I/O
C     msgBuf :: message buffer
      INTEGER iUnit
      CHARACTER*(MAX_LEN_MBUF) msgBuf

C     Open and read the data.matrix file

      NAMELIST /MATRIX_PARM01/ expMatrixWriteTime, impMatrixWriteTime

      IF ( .NOT.useMATRIX ) THEN
C-    pkg MATRIX is not used
        _BEGIN_MASTER(myThid)
C-    Track pkg activation status:
C     print a (weak) warning if data.matrix is found
         CALL PACKAGES_UNUSED_MSG( 'useMATRIX', ' ', ' ' )
        _END_MASTER(myThid)
        RETURN
      ENDIF

      _BEGIN_MASTER(myThid)

      expMatrixWriteTime = 10. _d 10
      impMatrixWriteTime = 10. _d 10

      WRITE(msgBuf,'(A)') ' MATRIX_READPARMS: opening data.matrix'
      CALL PRINT_MESSAGE(msgBuf, standardMessageUnit,
     &                   SQUEEZE_RIGHT , 1)
      CALL OPEN_COPY_DATA_FILE(
     I                   'data.matrix', 'MATRIX_READPARMS',
     O                   iUnit,
     I                   myThid )
      READ(UNIT=iUnit,NML=MATRIX_PARM01)
      WRITE(msgBuf,'(A)')
     &  ' MATRIX_READPARMS: finished reading data.matrix'
      CALL PRINT_MESSAGE(msgBuf, standardMessageUnit,
     &                   SQUEEZE_RIGHT , 1)

C Close the open data file
#ifdef SINGLE_DISK_IO
      CLOSE(iUnit)
#else
      CLOSE(iUnit,STATUS='DELETE')
#endif /* SINGLE_DISK_IO */
      _END_MASTER(myThid)

C Everyone else must wait for the parameters to be loaded
      _BARRIER

#endif /* ALLOW_MATRIX */
      RETURN
      END

#include "EXF_OPTIONS.h"

CBOP
C !ROUTINE: EXF_INTERP_READ
C !INTERFACE:
       SUBROUTINE EXF_INTERP_READ(
     I                infile, filePrec,
     O                arrayin,
     I                irecord, nx_in, ny_in, myThid )

C !DESCRIPTION:

C !USES:
      IMPLICIT NONE

C Global variables / common blocks
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "EXF_INTERP_SIZE.h"
#include "EXF_PARAM.h"
#ifdef ALLOW_USE_MPI
# include "EESUPPORT.h"
#endif /* ALLOW_USE_MPI */

C !INPUT/OUTPUT PARAMETERS:
C  infile      (string)  :: name of the binary input file (direct access)
C  filePrec    (integer) :: number of bits per word in file (32 or 64)
C  arrayin     ( _RL )   :: array to read file into
C  irecord     (integer) :: record number to read
C  nx_in,ny_in (integer) :: size in x & y direction of input file to read
C  myThid      (integer) :: My Thread Id number
      CHARACTER*(*) infile
      INTEGER       filePrec, irecord, nx_in, ny_in
       _RL          arrayin( -1:nx_in+2 , -1:ny_in+2 )
      INTEGER       myThid
CEOP

C !FUNCTIONS
      INTEGER  ILNBLNK
      INTEGER MDS_RECLEN
      LOGICAL MASTER_CPU_IO
      EXTERNAL ILNBLNK
      EXTERNAL MDS_RECLEN
      EXTERNAL MASTER_CPU_IO

C !LOCAL VARIABLES
      INTEGER  i, j
      INTEGER  ioUnit, length_of_rec, IL
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      LOGICAL  exst
#ifdef EXF_INTERP_USE_DYNALLOC
#ifdef EXF_IREAD_USE_GLOBAL_POINTER
C     When using threads the address of the local automatic array
C     "buffer" is not visible to the other threads. So we create
C     a pointer to share that address here. This is presently
C     in an ifdef because it won't go through g77 and I'm not
C     currently sure what TAF would do with this.
      COMMON /EXF_IOPTR8/ glPtr8
      REAL*8, POINTER :: glPtr8(:,:)
      COMMON /EXF_IOPTR4/ glPtr4
      REAL*4, POINTER :: glPtr4(:,:)

      Real*8, target ::  buffer_r8(nx_in,ny_in)
      Real*4, target ::  buffer_r4(nx_in,ny_in)
#else  /* ndef EXF_IREAD_USE_GLOBAL_POINTER */
      Real*8   buffer_r8(nx_in,ny_in)
      Real*4   buffer_r4(nx_in,ny_in)
#endif /* ndef EXF_IREAD_USE_GLOBAL_POINTER */
#else  /* ndef EXF_INTERP_USE_DYNALLOC */
      Real*8   buffer_r8(exf_interp_bufferSize)
      Real*4   buffer_r4(exf_interp_bufferSize)
      COMMON /EXF_INTERP_BUFFER/ buffer_r8, buffer_r4
      INTEGER ijs
#endif /* ndef EXF_INTERP_USE_DYNALLOC */
#ifdef ALLOW_USE_MPI
      INTEGER  ierr
#endif

C--   Check for consistency:
#ifdef EXF_INTERP_USE_DYNALLOC
#ifndef EXF_IREAD_USE_GLOBAL_POINTER
C     The CPP symbol EXF_IREAD_USE_GLOBAL_POINTER must be defined for the
C     case of nThreads > 1. Stop IF it isnt.
      IF ( nThreads .GT. 1 ) THEN
      STOP
     &'EXF_INTERP_READ: nThreads > 1 needs EXF_IREAD_USE_GLOBAL_POINTER'
      ENDIF
#endif
#else  /* ndef EXF_INTERP_USE_DYNALLOC */
#ifdef EXF_IREAD_USE_GLOBAL_POINTER
      STOP
     &'EXF_INTERP_READ: USE_GLOBAL_POINTER needs INTERP_USE_DYNALLOC'
#endif
      IF ( nx_in*ny_in .GT. exf_interp_bufferSize ) THEN
        STOP 'EXF_INTERP_READ: exf_interp_bufferSize too small'
      ENDIF
#endif /* ndef EXF_INTERP_USE_DYNALLOC */

C--   before starting to read, wait for everyone to finish
      _BARRIER

C---  read in input data

      IF ( MASTER_CPU_IO(myThid) ) THEN
C--   master thread of process 0, only, opens a global file

        IL  = ILNBLNK( infile )
        INQUIRE( file=infile, exist=exst )
        IF (exst) THEN
         IF ( debugLevel.GE.debLevB ) THEN
          WRITE(msgBuf,'(A,A)')
     &         ' EXF_INTERP_READ: opening file: ',infile(1:IL)
          CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &         SQUEEZE_RIGHT , myThid)
         ENDIF
        ELSE
         WRITE(msgBuf,'(2A)')
     &        ' EXF_INTERP_READ: filename: ', infile(1:IL)
         CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                       SQUEEZE_RIGHT , myThid)
         CALL PRINT_ERROR( msgBuf, myThid )
         WRITE(msgBuf,'(A)')
     &        ' EXF_INTERP_READ: File does not exist'
         CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                       SQUEEZE_RIGHT , myThid)
         CALL PRINT_ERROR( msgBuf, myThid )
         STOP 'ABNORMAL END: S/R EXF_INTERP_READ'
        ENDIF

        CALL MDSFINDUNIT( ioUnit, myThid )
        length_of_rec=MDS_RECLEN( filePrec, nx_in*ny_in, myThid )
        OPEN( ioUnit, file=infile, status='old', _READONLY_ACTION
     &       access='direct', recl=length_of_rec )
        IF ( filePrec .EQ. 32 ) THEN
#ifdef EXF_INTERP_USE_DYNALLOC
          READ(ioUnit,rec=irecord)  buffer_r4
#else
          READ(ioUnit,rec=irecord) (buffer_r4(i),i=1,nx_in*ny_in)
#endif
#ifdef _BYTESWAPIO
          CALL MDS_BYTESWAPR4(nx_in*ny_in,buffer_r4)
#endif /* _BYTESWAPIO */
        ELSE
#ifdef EXF_INTERP_USE_DYNALLOC
          READ(ioUnit,rec=irecord)  buffer_r8
#else
          READ(ioUnit,rec=irecord) (buffer_r8(i),i=1,nx_in*ny_in)
#endif
#ifdef _BYTESWAPIO
          CALL MDS_BYTESWAPR8(nx_in*ny_in,buffer_r8)
#endif /* _BYTESWAPIO */
        ENDIF
        CLOSE( ioUnit )
C--   end if MASTER_CPU_IO
      ENDIF

      _BEGIN_MASTER( myThid )
#ifdef ALLOW_USE_MPI
C--   broadcast to all processes
       IF ( useSingleCpuInput ) THEN
         IF ( filePrec .EQ. 32 ) THEN
           CALL MPI_BCAST(buffer_r4,nx_in*ny_in,MPI_REAL,
     &          0,MPI_COMM_MODEL,ierr)
         ELSE
           CALL MPI_BCAST(buffer_r8,nx_in*ny_in,MPI_DOUBLE_PRECISION,
     &          0,MPI_COMM_MODEL,ierr)
         ENDIF
       ENDIF
#endif /* ALLOW_USE_MPI */

#ifdef EXF_IREAD_USE_GLOBAL_POINTER
       IF ( filePrec .EQ. 32 ) THEN
         glPtr4 => buffer_r4
       ELSE
         glPtr8 => buffer_r8
       ENDIF
#endif
      _END_MASTER( myThid )
      _BARRIER

C---  Transfer buffer to "arrayin" array:
#ifdef EXF_INTERP_USE_DYNALLOC
#ifdef EXF_IREAD_USE_GLOBAL_POINTER
      IF ( filePrec .EQ. 32 ) THEN
        DO j=1,ny_in
          DO i=1,nx_in
            arrayin(i,j)=glPtr4(i,j)
          ENDDO
        ENDDO
      ELSE
        DO j=1,ny_in
          DO i=1,nx_in
            arrayin(i,j)=glPtr8(i,j)
          ENDDO
        ENDDO
      ENDIF
#else /* ndef EXF_IREAD_USE_GLOBAL_POINTER */
      IF ( filePrec .EQ. 32 ) THEN
        DO j=1,ny_in
          DO i=1,nx_in
            arrayin(i,j)=buffer_r4(i,j)
          ENDDO
        ENDDO
      ELSE
        DO j=1,ny_in
          DO i=1,nx_in
            arrayin(i,j)=buffer_r8(i,j)
          ENDDO
        ENDDO
      ENDIF
#endif /* ndef EXF_IREAD_USE_GLOBAL_POINTER */
#else  /* ndef EXF_INTERP_USE_DYNALLOC */
      IF ( filePrec .EQ. 32 ) THEN
        DO j=1,ny_in
          ijs = (j-1)*nx_in
          DO i=1,nx_in
            arrayin(i,j)=buffer_r4(i+ijs)
          ENDDO
        ENDDO
      ELSE
        DO j=1,ny_in
          ijs = (j-1)*nx_in
          DO i=1,nx_in
            arrayin(i,j)=buffer_r8(i+ijs)
          ENDDO
        ENDDO
      ENDIF
#endif /* ndef EXF_INTERP_USE_DYNALLOC */

      RETURN
      END

#include "SEAICE_OPTIONS.h"
#ifdef ALLOW_EXF
# include "EXF_OPTIONS.h"
#endif

C     StartOfInterface
      SUBROUTINE SEAICE_FAKE( myTime, myIter, myThid )
C     *==========================================================*
C     | SUBROUTINE seaice_fake (for adjoint purpose only)        |
C     *==========================================================*
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "DYNVARS.h"
#include "GRID.h"
#include "FFIELDS.h"
#include "SEAICE_SIZE.h"
#include "SEAICE_PARAMS.h"
#include "SEAICE.h"
#ifdef ALLOW_EXF
# include "EXF_FIELDS.h"
# include "EXF_PARAM.h"
# ifdef ALLOW_ATM_TEMP
#  include "SEAICE_GRID.h"
# endif
#endif
C     === Routine arguments ===
C     myTime - Simulation time
C     myIter - Simulation timestep number
C     myThid - Thread no. that called this routine.
      _RL myTime
      INTEGER myIter, myThid
C     EndOfInterface(global-font-lock-mode 1)

C     === Local variables ===
C     i,j,bi,bj - Loop counters

      INTEGER i, j, bi, bj
      _RL fac, tempFrz
      CHARACTER*(MAX_LEN_MBUF) msgBuf

      WRITE(msgBuf,'(2A)') 'SEAICE_FAKE:',
     &  ' forward code is not meant to be used (adj only)'
      CALL PRINT_ERROR( msgBuf, myThid )
      STOP 'ABNORMAL END: S/R SEAICE_FAKE'

      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        DO j=1,sNy
         DO i=1,sNx
c shielding effect
            fac=MIN(1. _d 0, MAX(0. _d 0 , 1. _d 0 - area(i,j,bi,bj)))
            fu(i,j,bi,bj) = fu(i,j,bi,bj) * fac
            fv(i,j,bi,bj) = fv(i,j,bi,bj) * fac
            qnet(i,j,bi,bj) = qnet(i,j,bi,bj) * fac
            qsw(i,j,bi,bj) = qsw(i,j,bi,bj) * fac
#if (defined ALLOW_EXF) && (defined ALLOW_ATM_TEMP)
c the fresh water flux at the top of the ice
            EmPmR(i,j,bi,bj)  = HEFFM(i,j,bi,bj)*(
     &         fac * EVAP(i,j,bi,bj)
     &             - PRECIP(i,j,bi,bj)
#ifdef ALLOW_RUNOFF
     &             - RUNOFF(i,j,bi,bj)
#endif /* ALLOW_RUNOFF */
     &         )*rhoConstFresh
#endif
c relaxation to freezing point
            fac=MIN(1. _d 0, MAX(0. _d 0 , area(i,j,bi,bj)))
            tempFrz = SEAICE_tempFrz0 +
     &                SEAICE_dTempFrz_dS *salt(i,j,1,bi,bj)
            theta(i,j,1,bi,bj)=theta(i,j,1,bi,bj) + fac *
     &        ( tempFrz-theta(i,j,1,bi,bj) ) *
     &        SEAICE_mcPheePiston/drF(1)*SEAICE_deltaTtherm
         ENDDO
        ENDDO
       ENDDO
      ENDDO

       CALL EXCH_UV_XY_RS(fu,fv,.TRUE.,myThid)
       _EXCH_XY_RS( qnet,  myThid )
       _EXCH_XY_RS( qsw,  myThid )
       _EXCH_XY_RS( empmr,  myThid )

      RETURN
      END

#include "CHEAPAML_OPTIONS.h"
#undef ALLOW_THSICE

CBOP
C     !ROUTINE: CHEAPAML_LANL_FLUX
C     !INTERFACE:
      SUBROUTINE CHEAPAML_LANL_FLUX(
     I                    i,j,bi,bj,
     O                    fsha, flha, evp, xolw, ssqt, q100 )

C     !DESCRIPTION:
C     ==================================================================
C     SUBROUTINE cheapaml_LANL_flux
C     ==================================================================
C     o compute surface fluxes using LANL algorithms

C     !USES:
      IMPLICIT NONE
C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "DYNVARS.h"
#include "GRID.h"
c#include "FFIELDS.h"
c#ifdef ALLOW_THSICE
c#include "THSICE_VARS.h"
c#endif
#include "CHEAPAML.h"

C     !INPUT PARAMETERS:
      INTEGER i,j,bi,bj
C     !OUTPUT PARAMETERS:
      _RL fsha, flha, evp, xolw, ssqt, q100
CEOP

C       Output:
C       ustress, vstress - wind stress
C       fsha - sensible heat flux
C       flha - latent heat flux
C       xolw - oceanic upwelled long wave radiation
C       ssqt - sat. specific humidity at atm layer top

C       Input:
C       uwind, vwind  - mean wind speed (m/s)
C       Tair  - mean air temperature (K)  at height ht (m)
C       theta(k=1) - sea surface temperature (C)
C       Qair - Specific humidity kg/kg
C       Solar - short wave net solar flux at surface (W/m^2)
C       Tr - relaxation profile for temperature on boundaries (C)
C       qr - relaxation profile for specific humidity (kg/kg)
C       i,j,bi,bj - indices of data

C     !LOCAL VARIABLES:
C     iceornot :: variables to include seaice effect
      INTEGER iceornot
      _RL deltaTm
      _RL uss,usm,uw,vw
      _RL cheapaml_BulkCdn
      _RL to
      _RL t
      _RL t0,QaR
      _RL ssq, q
      _RL deltap, delq, pt, psx100, z100ol
      _RL rdn,ren,rhn,zice,zref
      _RL rd,re,rh,tta,ttas,toa,ttt
      _RL ustar,tstar,qstar,ht,hu,hq
      _RL aln,cdalton,czol,psim_fac
      _RL huol,stable,xsq,x,psimh,psixh
      _RL clha, csha
      INTEGER niter_bulk,iter

C useful values
C hardwire atmospheric relative humidity at 80%
        QaR=0.8 _d 0
C factor to compute rainfall from specific humidity
C inverse of time step
        deltaTm=1. _d 0/deltaT
C reference values to compute turbulent flux
              ht=zt
              hq=zq
              hu=zu
              zref = zt
              zice=.0005 _d 0
              aln = log(ht/zref)
C for iterating on turbulence
              niter_bulk = 5
              cdalton = 0.0346000 _d 0
              czol = zref*xkar*gravity
              psim_fac=5. _d 0

C     determine wind stress
        IF(.NOT.useStressOption)THEN

             if (maskC(i,j,1,bi,bj).ne.0. _d 0) then
#ifdef ALLOW_THSICE
               if (ICEMASK(i,j,bi,bj).gt.0. _d 0) then
                if (snowheight(i,j,bi,bj).gt.3. _d -1) then
                   iceornot=2
                 else
                   iceornot=1
                 endif
               else
                 iceornot=0
               endif
#else
               iceornot=0
#endif
                       uw=uwind(i,j,bi,bj)
                       vw=vwind(i,j,bi,bj)
                       uss=sqrt(uw**2+vw**2)
                       usm=max(uss,1. _d 0)
                  cheapaml_BulkCdn = cdrag_1/usm + cdrag_2 + cdrag_3*usm
                       ustress(i,j,bi,bj)= rhoa*cheapaml_BulkCdn*uss*uw
                       vstress(i,j,bi,bj)= rhoa*cheapaml_BulkCdn*uss*vw
             else
               usm=0. _d 0
               ustress(i,j,bi,bj) = 0. _d 0
               vstress(i,j,bi,bj) = 0. _d 0
                endif
C wind stress computed
                ENDIF
C diabatic and freshwater flux forcing
        to=theta(i,j,1,bi,bj)
        t=Tair(i,j,bi,bj)
        toa=to+Celsius2K
        tta=t+Celsius2K
        ttas=tta+gamma_blk*zref
        ttt=tta-( cheaphgrid(i,j,bi,bj)- zref)*gamma_blk
        pt=p0*(1-gamma_blk*cheaphgrid(i,j,bi,bj)/ttas)
     &     **(gravity/gamma_blk/gasR)

C specific humidities
              ssq= ssq0*exp( lath*(ssq1-ssq2/toa) ) / p0
              ssqt = ssq0*exp( lath*(ssq1-ssq2/ttt) ) / pt
C     saturation no more at the top:
              ssqt = 0.7 _d 0*ssq

            if (useFreshWaterFlux) then
            q=qair(i,j,bi,bj)
            else
            q=QaR * ssq
            endif

C adjust temperature from reference height to formula height
            deltap = t  - to + gamma_blk*(zref-ht)
            delq   = q - ssq
            ttas   = tta+gamma_blk*(zref-ht)
            t0     = ttas*(1. _d 0 + humid_fac*q)

C initialize estimate exchange coefficients
              rdn=xkar/(log(zref/zice))
              rhn=rdn
              ren=rdn
C calculate turbulent scales
              ustar=rdn*usm
              tstar=rhn*deltap
              qstar=ren*delq

C iteration with psi-functions to find transfer coefficients
              do iter=1,niter_bulk
                 huol   = czol/ustar**2 *(tstar/t0 +
     &                    qstar/(1. _d 0/humid_fac+q))
                 huol   = sign( min(abs(huol),10. _d 0), huol)
                 stable = 5. _d -1 + sign(5. _d -1 , huol)
                 xsq = max(sqrt(abs(1. _d 0 - 16. _d 0*huol)),1. _d 0)
                 x      = sqrt(xsq)
                 psimh = -5. _d 0*huol*stable + (1. _d 0-stable)*
     &                    (2. _d 0*log(5. _d -1*(1. _d 0+x)) +
     &                     2. _d 0*log(5. _d -1*(1. _d 0+xsq)) -
     &                     2. _d 0*atan(x) + pi*.5 _d 0)
                 psixh  = -5. _d 0*huol*stable + (1. _d 0-stable)*
     &                     (2. _d 0*log(5. _d -1*(1. _d 0+xsq)))

C Update the transfer coefficients

                 rd = rdn/(1. _d 0 + rdn*(aln-psimh)/xkar)
                 rh = rhn/(1. _d 0 + rhn*(aln-psixh)/xkar)
                 re = rh
C  Update ustar, tstar, qstar using updated, shifted coefficients.
                 ustar = rd*usm
                 qstar = re*delq
                 tstar = rh*deltap
              enddo

                        usm=max(uss,0.5 _d 0)
                csha   = rhoa*cpair*usm*rh*rd
                clha   = rhoa*lath*usm*re*rd

                fsha  = csha*deltap
                flha  = clha*delq
                evp   = -flha/lath

C the sensible and latent heat fluxes, fsha and flha,
C are computed so that positive values are downward.
C the convention for cheapaml is upward fluxes are positive,
C so they must be multiplied by -1
        fsha=-fsha
        flha=-flha

C oceanic upwelled long wave
        xolw=stefan*(toa)**4
C compute specific humidity at 100m
                 huol   = czol/ustar**2 *(tstar/t0 +
     &                    qstar/(1. _d 0/humid_fac+q))
                 huol   = sign( min(abs(huol),10. _d 0), huol)
                 stable = 5. _d -1 + sign(5. _d -1 , huol)
                 z100ol   = 100. _d 0 *xkar*gravity/ustar**2 *(tstar/t0
     &                    + qstar/(1. _d 0/humid_fac+q))
                 xsq = max(sqrt(abs(1. _d 0 - 16. _d 0*z100ol)),1. _d 0)
                 x      = sqrt(xsq)
                 psx100  = -5. _d 0*z100ol*stable + (1. _d 0-stable)*
     &                     (2. _d 0*log(5. _d -1*(1. _d 0+xsq)))
                 q100=ssq+qstar*(dlog(100. _d 0/zice)-psx100)

      RETURN
      END

#include "OBCS_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: OBCS_SET_CONNECT

C     !INTERFACE:
      SUBROUTINE OBCS_SET_CONNECT( myThid )

C     !DESCRIPTION:
C     *==========================================================*
C     | SUBROUTINE OBCS_SET_CONNECT
C     | o Set OB connected piece Id for each level
C     *==========================================================*

C     !USES:
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "OBCS_PARAMS.h"
#include "OBCS_GRID.h"

C     !INPUT/OUTPUT PARAMETERS:
C     myThid   :: my Thread Id. number
      INTEGER myThid
CEOP

#ifdef ALLOW_OBCS
C     !LOCAL VARIABLES:
C     msgBuf   :: Informational/error message buffer
C     bi,bj    :: tile indices
C     i, j, k  :: Loop counters
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      INTEGER bi, bj
      INTEGER i, j, k
      INTEGER idN, idS, idE, idW
      INTEGER fp, prtMsg
      INTEGER n, newConnect, maxConnect
      INTEGER numConnect, listConnect(OBCS_maxConnect)
      INTEGER numLocal(nSx,nSy), listLocal(OBCS_maxConnect,nSx,nSy)
      INTEGER tmpConnect(sNx+sNx+sNy+sNy)
      _RS tmpXZ(1-OLx:sNx+OLx,Nr,nSx,nSy)
      _RS tmpYZ(1-OLy:sNy+OLy,Nr,nSx,nSy)
      _RL tmpRL

#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_ENTER('OBCS_SET_CONNECT',myThid)
#endif

C--   Initialise domain connected-piece Id for OB grid points:
      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
        idN = 0
        idS = 0
        idE = 0
        idW = 0
        IF ( tileHasOBN(bi,bj) ) idN = 1
        IF ( tileHasOBS(bi,bj) ) idS = 1
        IF ( tileHasOBE(bi,bj) ) idE = 1
        IF ( tileHasOBW(bi,bj) ) idW = 1
        DO k=1,Nr
         DO i=1,sNx
          OBN_connect(i,k,bi,bj) = idN
          OBS_connect(i,k,bi,bj) = idS
         ENDDO
         DO j=1,sNy
          OBE_connect(j,k,bi,bj) = idE
          OBW_connect(j,k,bi,bj) = idW
         ENDDO
        ENDDO
       ENDDO
      ENDDO

C--   Read from files domain connected-piece Id for OB grid points:
C-    Note: current Section READ routines (MDS_READ_SEC_XZ,_YZ) are
C     single (Master) thread (output only available to Master Thread)
      prtMsg = 0
      fp = readBinaryPrec
      _BARRIER
      IF ( OBNconnectFile.NE.' ' ) THEN
        CALL READ_REC_XZ_RS( OBNconnectFile, fp,Nr, tmpXZ, 1,0,myThid )
        _BEGIN_MASTER(myThid)
        DO bj = 1,nSy
         DO bi = 1,nSx
          IF ( tileHasOBN(bi,bj) ) THEN
           DO k=1,Nr
            DO i=1,sNx
             OBN_connect(i,k,bi,bj) = NINT( tmpXZ(i,k,bi,bj) )
            ENDDO
           ENDDO
          ENDIF
         ENDDO
        ENDDO
        _END_MASTER(myThid)
        prtMsg = 1
      ENDIF
      IF ( OBSconnectFile.NE.' ' ) THEN
        CALL READ_REC_XZ_RS( OBSconnectFile, fp,Nr, tmpXZ, 1,0,myThid )
        _BEGIN_MASTER(myThid)
        DO bj = 1,nSy
         DO bi = 1,nSx
          IF ( tileHasOBS(bi,bj) ) THEN
           DO k=1,Nr
            DO i=1,sNx
             OBS_connect(i,k,bi,bj) = NINT( tmpXZ(i,k,bi,bj) )
            ENDDO
           ENDDO
          ENDIF
         ENDDO
        ENDDO
        _END_MASTER(myThid)
        prtMsg = 1
      ENDIF
      IF ( OBEconnectFile.NE.' ' ) THEN
        CALL READ_REC_YZ_RS( OBEconnectFile, fp,Nr, tmpYZ, 1,0,myThid )
        _BEGIN_MASTER(myThid)
        DO bj = 1,nSy
         DO bi = 1,nSx
          IF ( tileHasOBE(bi,bj) ) THEN
           DO k=1,Nr
            DO j=1,sNy
             OBE_connect(j,k,bi,bj) = NINT( tmpYZ(j,k,bi,bj) )
            ENDDO
           ENDDO
          ENDIF
         ENDDO
        ENDDO
        _END_MASTER(myThid)
        prtMsg = 1
      ENDIF
      IF ( OBWconnectFile.NE.' ' ) THEN
        CALL READ_REC_YZ_RS( OBWconnectFile, fp,Nr, tmpYZ, 1,0,myThid )
        _BEGIN_MASTER(myThid)
        DO bj = 1,nSy
         DO bi = 1,nSx
          IF ( tileHasOBW(bi,bj) ) THEN
           DO k=1,Nr
            DO j=1,sNy
             OBW_connect(j,k,bi,bj) = NINT( tmpYZ(j,k,bi,bj) )
            ENDDO
           ENDDO
          ENDIF
         ENDDO
        ENDDO
        _END_MASTER(myThid)
        prtMsg = 1
      ENDIF
      _BARRIER

      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
        DO k=1,Nr
         DO i=1,sNx
          IF (OB_Jn(i,bi,bj).EQ.OB_indexNone) OBN_connect(i,k,bi,bj)=0
          IF (OB_Js(i,bi,bj).EQ.OB_indexNone) OBS_connect(i,k,bi,bj)=0
         ENDDO
         DO j=1,sNy
          IF (OB_Ie(j,bi,bj).EQ.OB_indexNone) OBE_connect(j,k,bi,bj)=0
          IF (OB_Iw(j,bi,bj).EQ.OB_indexNone) OBW_connect(j,k,bi,bj)=0
         ENDDO
        ENDDO
       ENDDO
      ENDDO

C--   Count how many connected parts there are  for each level:
      prtMsg = prtMsg*debugLevel
      DO k=1,Nr

        maxConnect = 0
        DO bj = myByLo(myThid), myByHi(myThid)
         DO bi = myBxLo(myThid), myBxHi(myThid)

C-    make a local copy
          DO i=1,sNx
            tmpConnect(i) = OBN_connect(i,k,bi,bj)
            tmpConnect(sNx+i) = OBS_connect(i,k,bi,bj)
          ENDDO
          DO j=1,sNy
            tmpConnect(sNx*2+j) = OBW_connect(j,k,bi,bj)
            tmpConnect(sNx*2+sNy+j) = OBE_connect(j,k,bi,bj)
          ENDDO

C-   make a list for each tile
          numLocal(bi,bj) = 0
          DO n=1,OBCS_maxConnect
            listLocal(n,bi,bj) = 0
          ENDDO
          newConnect = 1
          DO WHILE ( newConnect.NE. 0 )
           newConnect = 0
           DO i=1,(sNx+sNy)*2
            IF ( tmpConnect(i).GE.1 ) THEN
              IF ( newConnect.EQ.0 ) THEN
               newConnect = tmpConnect(i)
               numLocal(bi,bj) = numLocal(bi,bj) + 1
               IF ( numLocal(bi,bj).LE.OBCS_maxConnect )
     &           listLocal(numLocal(bi,bj),bi,bj) = newConnect
              ENDIF
              IF ( tmpConnect(i).EQ.newConnect )
     &          tmpConnect(i) = 0
            ENDIF
           ENDDO
          ENDDO
          IF ( numLocal(bi,bj).GT.OBCS_maxConnect ) THEN
            WRITE(msgBuf,'(A,3(A,I4),2(A,I10))') 'OBCS_SET_CONNECT: ',
     &       'k=', k, ' numLocal(', bi,',',bj,')=', numLocal(bi,bj),
     &       ' exceeds OBCS_maxConnect=', OBCS_maxConnect
            CALL PRINT_ERROR( msgBuf, myThid )
            STOP 'ABNORMAL END: S/R OBCS_SET_CONNECT'
          ENDIF
          IF ( prtMsg.GE.debLevC ) THEN
           IF ( numLocal(bi,bj).EQ.0 ) THEN
            WRITE(msgBuf,'(A,2I4,A,I8)') 'OBCS_SET_CONNECT: bi,bj=',
     &       bi, bj, ' , numLocal=', numLocal(bi,bj)
           ELSE
            WRITE(msgBuf,'(A,2I4,2(A,I8))') 'OBCS_SET_CONNECT: bi,bj=',
     &       bi, bj, ' , numLocal=', numLocal(bi,bj),
     &           ' , listLocal:', listLocal(1,bi,bj)
           ENDIF
            CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                          SQUEEZE_RIGHT, myThid )
            DO j=2,numLocal(bi,bj),15
              n = MIN(numLocal(bi,bj),j+14)
              WRITE(msgBuf,'(A,15I8)')
     &            ' ... ', (listLocal(i,bi,bj),i=j,n)
              CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                            SQUEEZE_RIGHT, myThid )
            ENDDO
          ENDIF
          DO n=1,numLocal(bi,bj)
            maxConnect = MAX( maxConnect, listLocal(n,bi,bj) )
          ENDDO

         ENDDO
        ENDDO

        tmpRL = maxConnect
        _GLOBAL_MAX_RL( tmpRL, myThid )
        maxConnect = NINT( tmpRL )

C-   combine set of list (1 per tile) into 1 global list
        numConnect = 0
        DO j=1,maxConnect
          tmpRL = zeroRL
          DO bj = myByLo(myThid), myByHi(myThid)
           DO bi = myBxLo(myThid), myBxHi(myThid)
            DO n=1,numLocal(bi,bj)
             IF ( listLocal(n,bi,bj).EQ.j ) tmpRL = oneRL
            ENDDO
           ENDDO
          ENDDO
          _GLOBAL_MAX_RL( tmpRL, myThid )
          IF ( tmpRL.EQ.oneRL ) THEN
            numConnect = numConnect + 1
            IF ( numConnect.LE.OBCS_maxConnect )
     &        listConnect(numConnect) = j
          ENDIF
        ENDDO
        IF ( numConnect.GT.OBCS_maxConnect ) THEN
          WRITE(msgBuf,'(A,I4,2(A,I10))') 'OBCS_SET_CONNECT: @ k=', k,
     &     ' numConnect=', numConnect,
     &     ' exceeds OBCS_maxConnect=', OBCS_maxConnect
          CALL PRINT_ERROR( msgBuf, myThid )
          STOP 'ABNORMAL END: S/R OBCS_SET_CONNECT'
        ENDIF
        IF ( prtMsg.GE.debLevA ) THEN
          _BEGIN_MASTER(myThid)
          WRITE(msgBuf,'(A,I4,2(A,I10))') 'OBCS_SET_CONNECT: @ k=', k,
     &     ', maxConnect=', maxConnect, ' , numConnect=', numConnect
          CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                        SQUEEZE_RIGHT, myThid )
          DO j=1,numConnect,15
            n = MIN(numConnect,j+14)
            WRITE(msgBuf,'(A,15I8)')
     &          ' listConnect:', (listConnect(i),i=j,n)
            CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                          SQUEEZE_RIGHT, myThid )
          ENDDO
          _END_MASTER(myThid)
        ENDIF

C-   reset connected Id in order to use all number from 1 to numConnect
        DO bj = myByLo(myThid), myByHi(myThid)
         DO bi = myBxLo(myThid), myBxHi(myThid)

C-    make a local copy
          DO i=1,sNx
            tmpConnect(i) = OBN_connect(i,k,bi,bj)
            tmpConnect(sNx+i) = OBS_connect(i,k,bi,bj)
          ENDDO
          DO j=1,sNy
            tmpConnect(sNx*2+j) = OBW_connect(j,k,bi,bj)
            tmpConnect(sNx*2+sNy+j) = OBE_connect(j,k,bi,bj)
          ENDDO
          DO n=1,numConnect
C-    change Id value: listConnect(n) to n
           IF ( listConnect(n).NE.n ) THEN
            DO i=1,(sNx+sNy)*2
             IF ( tmpConnect(i).EQ.listConnect(n) ) tmpConnect(i) = n
            ENDDO
           ENDIF
          ENDDO
C-    copy back into OB[N,S,E,W]_connect arrays
          DO i=1,sNx
            OBN_connect(i,k,bi,bj) = tmpConnect(i)
            OBS_connect(i,k,bi,bj) = tmpConnect(sNx+i)
          ENDDO
          DO j=1,sNy
            OBW_connect(j,k,bi,bj) = tmpConnect(sNx*2+j)
            OBE_connect(j,k,bi,bj) = tmpConnect(sNx*2+sNy+j)
          ENDDO

         ENDDO
        ENDDO

C-    store numConnect in common block
        _BEGIN_MASTER(myThid)
        OB_connectNumber(k) = numConnect
        _END_MASTER(myThid)

C--   end k loop
      ENDDO

      _BARRIER

#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_LEAVE('OBCS_SET_CONNECT',myThid)
#endif

#endif /* ALLOW_OBCS */
      RETURN
      END

C$Id$
      program testmemsize
      external countsetbits
      integer countsetbits
      integer i, j, ti(10), ci0(10), ci1(10)
      integer*8 i8, ti8(10), ci80(10), ci81(10)
      real r, tr(10), cr0(10), cr1(10)
      real*4 r4, tr4(10), cr40(10), cr41(10)
      real(4) rp4, trp4(10), crp40(10), crp41(10)
      real*8 r8, tr8(10), cr80(10), cr81(10)
      real(8) rp8, trp8(10), crp80(10), crp81(10)
c      real*16 r16, tr16(10), cr160(10), cr161(10)
      double precision d, td(10), cd0(10), cd1(10)
      complex cx, tcx(10), ccx0(10), ccx1(10)
      complex*8 cx8, tcx8(10), ccx80(10), ccx81(10)
      complex(8) cxp8, tcxp8(10), ccxp80(10), ccxp81(10)
      complex*16 cx16, tcx16(10), ccx160(10), ccx161(10)
      double complex cxd, tcxd(10), ccxd0(10), ccxd1(10)
      logical l, tl(10), cl0(10), cl1(10)
      character c, tc(10), cc0(10), cc1(10)
c
      integer tci0(10000)
      common /cbuf0/ tci0
      equivalence (tci0(1),ci0(1))
      equivalence (tci0(1),ci80(1))
      equivalence (tci0(1),cr0(1))
      equivalence (tci0(1),cr40(1))
      equivalence (tci0(1),crp40(1))
      equivalence (tci0(1),cr80(1))
      equivalence (tci0(1),crp80(1))
c      equivalence (tci0(1),cr160(1))
      equivalence (tci0(1),cd0(1))
      equivalence (tci0(1),ccx0(1))
      equivalence (tci0(1),ccx80(1))
      equivalence (tci0(1),ccxp80(1))
      equivalence (tci0(1),ccx160(1))
      equivalence (tci0(1),ccxd0(1))
      equivalence (tci0(1),cl0(1))
      equivalence (tci0(1),cc0(1))
c
      integer tci1(10000)
      common /cbuf1/ tci1
      equivalence (tci1(1),ci1(1))
      equivalence (tci1(1),ci81(1))
      equivalence (tci1(1),cr1(1))
      equivalence (tci1(1),cr41(1))
      equivalence (tci1(1),crp41(1))
      equivalence (tci1(1),cr81(1))
      equivalence (tci1(1),crp81(1))
c      equivalence (tci1(1),cr161(1))
      equivalence (tci1(1),cd1(1))
      equivalence (tci1(1),ccx1(1))
      equivalence (tci1(1),ccx81(1))
      equivalence (tci1(1),ccxp81(1))
      equivalence (tci1(1),ccx161(1))
      equivalence (tci1(1),ccxd1(1))
      equivalence (tci1(1),cl1(1))
      equivalence (tci1(1),cc1(1))
c
      integer nb
c
      do i = 1,10
         ti(i) = (i-1)*i*i*i*i*i*i*i*i*i
         ti8(i) = (i-1)*i*i*i*i*i*i*i*i*i
         tr(i) = (i-1)*i*exp(2.0*i+0.001)
         tr4(i) = (i-1)*i*exp(2.0*i+0.001)
         trp4(i) = (i-1)*i*exp(2.0*i+0.001)
         tr8(i) = (i-1)*i*exp(2.0*i+0.001)
         trp8(i) = (i-1)*i*exp(2.0*i+0.001)
c         tr16(i) = (i-1)*i*exp(2.0*i+0.001)
         td(i) = (i-1)*i*exp(2.d0*i+1.d-3)
         tcx(i) = cmplx(tr(i),tr(i)+12.3)
         tcxp8(i) = cmplx(trp8(i),tr(i)+12.3)
         tcx8(i) = cmplx(tr8(i),tr(i)+12.3)
         tcx16(i) = cmplx(tr8(i),tr(i)+12.3)
         tcxd(i) = cmplx(td(i),td(i)+12.3d0)
         tl(i) = (((i/3)*3).eq.i)
      enddo
      tc(1) = 'a'
      tc(2) = 'b'
      tc(3) = 'c'
      tc(4) = 'd'
      tc(5) = 'e'
      tc(6) = 'f'
      tc(7) = 'g'
      tc(8) = 'h'
      tc(9) = 'i'
      tc(10) = 'j'
      
      i = 12345
      i8 = 12345
      r = sqrt(12345.0)
      r4 = sqrt(12345.0)
      rp4 = sqrt(12345.0)
      r8 = sqrt(12345.0)
      rp8 = sqrt(12345.0)
c      r16 = sqrt(12345.0)
      d = sqrt(12345.d0)
      cx = cmplx(-12.34,56.78)
      cx8 = cmplx(-12.34,56.78)
      cxp8 = cmplx(-12.34,56.78)
      cx16 = cmplx(-12.34,56.78)
      cxd = cmplx(-12.34d0,56.78d0)
      l = .true.
      c = 'z'
c
      call allzero(tci0(1))
      call allones(tci1(1))
c      call displaybits(tci0(1), 3)
c      call displaybits(tci1(1), 3)
      print *, ' '
c
      call allzero(tci0(1))
      call allones(tci1(1))
      do j=1,8
         ci0(j) = ti(j+2)
         ci1(j) = ti(j+2)
      enddo
      nb = countsetbits(tci0(1), tci1(1), 8, 100)
      print 100, 'INTEGER:', nb, ' bytes'
c
      call allzero(tci0(1))
      call allones(tci1(1))
      do j=1,8
         ci80(j) = ti8(j+2)
         ci81(j) = ti8(j+2)
      enddo
      nb = countsetbits(tci0(1), tci1(1), 8, 100)
      print 100, 'INTEGER*8:', nb, ' bytes'
c
      call allzero(tci0(1))
      call allones(tci1(1))
      do j=1,8
         cr0(j) = tr(j+2)
         cr1(j) = tr(j+2)
      enddo
      nb = countsetbits(tci0(1), tci1(1), 8, 100)
      print 100, 'REAL:', nb, ' bytes'
c
      call allzero(tci0(1))
      call allones(tci1(1))
      do j=1,8
         cr40(j) = tr4(j+2)
         cr41(j) = tr4(j+2)
      enddo
      nb = countsetbits(tci0(1), tci1(1), 8, 100)
      print 100, 'REAL*4:', nb, ' bytes'
c
      call allzero(tci0(1))
      call allones(tci1(1))
      do j=1,8
         crp40(j) = trp4(j+2)
         crp41(j) = trp4(j+2)
      enddo
      nb = countsetbits(tci0(1), tci1(1), 8, 100)
      print 100, 'REAL(4):', nb, ' bytes'
c
      call allzero(tci0(1))
      call allones(tci1(1))
      do j=1,8
         cr80(j) = tr8(j+2)
         cr81(j) = tr8(j+2)
      enddo
      nb = countsetbits(tci0(1), tci1(1), 8, 100)
      print 100, 'REAL*8:', nb, ' bytes'
c
      call allzero(tci0(1))
      call allones(tci1(1))
      do j=1,8
         crp80(j) = trp8(j+2)
         crp81(j) = trp8(j+2)
      enddo
      nb = countsetbits(tci0(1), tci1(1), 8, 100)
      print 100, 'REAL(8):', nb, ' bytes'
c
      call allzero(tci0(1))
      call allones(tci1(1))
      do j=1,8
         cd0(j) = td(j+2)
         cd1(j) = td(j+2)
      enddo
      nb = countsetbits(tci0(1), tci1(1), 8, 100)
      print 100, 'DOUBLE PRECISION:', nb, ' bytes'
c
      call allzero(tci0(1))
      call allones(tci1(1))
      do j=1,8
         ccx0(j) = tcx(j+2)
         ccx1(j) = tcx(j+2)
      enddo
      nb = countsetbits(tci0(1), tci1(1), 8, 100)
      print 100, 'COMPLEX:', nb, ' bytes'
c
      call allzero(tci0(1))
      call allones(tci1(1))
      do j=1,8
         ccx80(j) = tcx8(j+2)
         ccx81(j) = tcx8(j+2)
      enddo
      nb = countsetbits(tci0(1), tci1(1), 8, 100)
      print 100, 'COMPLEX*8:', nb, ' bytes'
c
      call allzero(tci0(1))
      call allones(tci1(1))
      do j=1,8
         ccxp80(j) = tcxp8(j+2)
         ccxp81(j) = tcxp8(j+2)
      enddo
      nb = countsetbits(tci0(1), tci1(1), 8, 100)
      print 100, 'COMPLEX(8):', nb, ' bytes'
c
      call allzero(tci0(1))
      call allones(tci1(1))
      do j=1,8
         ccx160(j) = tcx16(j+2)
         ccx161(j) = tcx16(j+2)
      enddo
      nb = countsetbits(tci0(1), tci1(1), 8, 100)
      print 100, 'COMPLEX*16:', nb, ' bytes'
c
      call allzero(tci0(1))
      call allones(tci1(1))
      do j=1,8
         ccxd0(j) = tcxd(j+2)
         ccxd1(j) = tcxd(j+2)
      enddo
      nb = countsetbits(tci0(1), tci1(1), 8, 100)
      print 100, 'DOUBLE COMPLEX:', nb, ' bytes'
c
      call allzero(tci0(1))
      call allones(tci1(1))
      do j=1,8
         cl0(j) = tl(j+2)
         cl1(j) = tl(j+2)
      enddo
      nb = countsetbits(tci0(1), tci1(1), 8, 100)
      print 100, 'LOGICAL:', nb, ' bytes'
c
      call allzero(tci0(1))
      call allones(tci1(1))
      do j=1,8
         cc0(j) = tc(j+2)
         cc1(j) = tc(j+2)
      enddo
      nb = countsetbits(tci0(1), tci1(1), 8, 100)
      print 100, 'CHARACTER:', nb, ' bytes'
c
 100  format(a18,i3,a6)
      end

#undef STAND_ALONE_IOLABEL_TESTING
C     to test the S/R above, #define the above C-PreProcessor flag
C     and compile this fortran source code alone.

#ifdef STAND_ALONE_IOLABEL_TESTING
      PROGRAM MAIN
      INTEGER NLL, I
      PARAMETER (NLL=62*62)
      CHARACTER*2 LL(NLL)

      CALL PTRACERS_SET_IOLABEL( LL, NLL, 1 )
      DO I=1, NLL
       PRINT *, LL(I)
      ENDDO
      END
#endif /* STAND_ALONE_IOLABEL_TESTING */

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

CBOP
C !ROUTINE: PTRACERS_SET_IOLABEL

C !INTERFACE: ==========================================================
      SUBROUTINE PTRACERS_SET_IOLABEL(
     O                    ioLbl,
     I                    nbLbl, myThid )

C !DESCRIPTION:
C   S/R  PTRACERS_SET_IOLABEL
C   Set pTracers IO & diagnostics label (2 characters long)
C
C   Set sequenced label list 00, 02, 03, ... 99, 0a...0Z...9a...9Z,a0...ZZ
C    to more than 99 TRACERS but without requiring more than two digit labels.
C   Sequence below allows 3843 (=62**2 -1) tracers.
C   First 99 are numbered in decimal ;
C   Then, from 100 to 619, analog to base 52 counting:
C    0-9 1rst digit , a-z,A-Z (=52 id) 2nd digit ;
C   And from 620 to 3843, analog to base 62 counting:
C    a-z,A-Z 1rst digit ; 0-9,a-z,A-Z (=62 id) 2nd digit ;
C ======================================================================

C !USES:
      IMPLICIT NONE

C !INPUT PARAMETERS: ===================================================
C     nbLbl       :: number of labels to define
C     myThid      :: my Thread Id number
      INTEGER     nbLbl
      INTEGER     myThid

C !OUTPUT PARAMETERS: ==================================================
C     ioLbl       :: io-label
      CHARACTER*2 ioLbl(nbLbl)

C !LOCAL VARIABLES: ====================================================
C     c1Set1      :: 1rst digit (from left) of 1rst set of labels
C     c2Set1      ::  2nd digit (from left) of 1rst set of labels
C     c1Set2      :: 1rst digit (from left) of  2nd set of labels
C     c2Set2      ::  2nd digit (from left) of  2nd set of labels
C     c1Set3      :: 1rst digit (from left) of  3rd set of labels
C     c2Set3      ::  2nd digit (from left) of  3rd set of labels
C     l1Set       :: length of 1rst digit list
C     l2Set       :: length of  2nd digit list
C     i,j,n       :: loop indices
      CHARACTER*10 c1Set1
      CHARACTER*10 c2Set1
      CHARACTER*10 c1Set2
      CHARACTER*52 c2Set2
      CHARACTER*52 c1Set3
      CHARACTER*62 c2Set3
      INTEGER l1Set, l2Set
      INTEGER i,j,n
CEOP

      c1Set1 = '0123456789'
      c2Set1 = c1Set1

      c1Set2 = c1Set1
      c2Set2 = 'abcdefghijklmnopqrstuvwxyz'
     &       //'ABCDEFGHIJKLMNOPQRSTUVWXYZ'

      c1Set3 = c2Set2
      c2Set3 = c1Set1//c2Set2

C--   Set a default.
C     This should not show up unless there is a problem
C     where nbLbl is equal or greater than 10*10 + 10*52 + 52*62 = 62**2
      DO n=1,nbLbl
       ioLbl(n) = '--'
      ENDDO

      n = 0
C--   First set of labels:
      l1Set = LEN(c1Set1)
      l2Set = LEN(c2Set1)
      DO j=1,l1Set
       DO i=1,l2Set
C-    skip label "00" (since we start tracer numberi from 1)
        IF ( i.NE.1 .OR. j.NE.1 ) THEN
         n=n+1
         IF ( n.LE.nbLbl ) THEN
          ioLbl(n)(1:1) = c1Set1(j:j)
          ioLbl(n)(2:2) = c2Set1(i:i)
         ENDIF
        ENDIF
       ENDDO
      ENDDO

C--   2nd set of labels:
      l1Set = LEN(c1Set2)
      l2Set = LEN(c2Set2)
      DO j=1,l1Set
       DO i=1,l2Set
        n=n+1
        IF ( n.LE.nbLbl ) THEN
          ioLbl(n)(1:1) = c1Set2(j:j)
          ioLbl(n)(2:2) = c2Set2(i:i)
        ENDIF
       ENDDO
      ENDDO

C--   3rd set of labels:
      l1Set = LEN(c1Set3)
      l2Set = LEN(c2Set3)
      DO j=1,l1Set
       DO i=1,l2Set
        n=n+1
        IF ( n.LE.nbLbl ) THEN
          ioLbl(n)(1:1) = c1Set3(j:j)
          ioLbl(n)(2:2) = c2Set3(i:i)
        ENDIF
       ENDDO
      ENDDO

      RETURN
      END

#include "CPP_EEOPTIONS.h"

CBOP
C     !ROUTINE: EESET_PARMS

C     !INTERFACE:
      SUBROUTINE EESET_PARMS( procId, doReport )

C     !DESCRIPTION:
C     *==========================================================*
C     | SUBROUTINE EESET\_PARMS
C     | o Routine to set model "parameters"
C     *==========================================================*
C     | This routine is called from the high-level wrapper
C     | after multi-process paralle processing has started but
C     | before multi-threaded parallelism. THe routine reads an
C     | an "execution environment" input parameter file holding
C     | information about the number of threads at run-time.
C     *==========================================================*

C     !USES:
      IMPLICIT NONE

C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "EESUPPORT.h"
#include "EXCH.h"

C     !INPUT PARAMETERS:
C     procId   :: this process id. number (either in World or in Model)
C     doReport :: if false, skip error stop and any report to std-out/err
      INTEGER  procId
      LOGICAL  doReport

C     !FUNCTIONS:
      INTEGER  IFNBLNK
      EXTERNAL IFNBLNK
      INTEGER  ILNBLNK
      EXTERNAL ILNBLNK

C     !LOCAL VARIABLES:
C     == Local variables ==
C     iUnit  :: Work variable for IO unit number
C     errIO  :: IO unit error flag
C     IL     :: Temp. for index strings
C     msgBuf :: Temp. for textual I/O
C     record :: Temp. for textual I/O
      INTEGER IL
      INTEGER errIO
      INTEGER iUnit
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      CHARACTER*(MAX_LEN_PREC) record
# if !defined(USE_FORTRAN_SCRATCH_FILES) || defined(SINGLE_DISK_IO)
      CHARACTER*(MAX_LEN_FNAM) scratchFile1
#endif
#ifdef SINGLE_DISK_IO
C     mpiRC  :: Error code reporting variable used with MPI.
      INTEGER mpiRC
#endif
#ifdef USE_PDAF
      INTEGER mpi_task_id
#endif
CEOP

      NAMELIST /EEPARMS/
     & nTx, nTy, usingMPI,
     & useCubedSphereExchange,
     & useCoupler, useNEST_PARENT, useNEST_CHILD,
     & useNest2W_parent, useNest2W_child, useOASIS,
     & useSETRLSTK, useSIGREG,
     & debugMode, printMapIncludesZeros, maxLengthPrt1D

C--   For now these options are fixed as the code does not fully support
C     features for overlapping communication and computation.
      usingSyncMessages          = .TRUE.

C--   The remaining parameters here are set to default values; and then
C--   any different values are read from an input file called "eedata".
C     The defaults set here are for serial execution.
C
C     nTx and nTy are the number of threads in the X and Y directions.
C     nSx/nTx and nSy/nTy be whole numbers at present.
C
C     notUsingXPeriodicity and notUsingYPeriodicity affect the identifying
C     of neighbor processes in a multi-process mode.
C     On the whole the numerical model code should not customise itself based
C     on these numbers as they may be removed if they do not prove useful.
C
C     usingMPI is a flag which controls whether MPI message passing library
C     calls are actually made. Note that under MPI it is necessary to start
C     a program a special way - normally using a command of the form
C     % mpirun program_name
C     If usingMPI is set to TRUE but % mpirun .... was not used to launch
C     the program then an internal MPI error may be generated when the first
C     MPI call ( CALL MPI_Init ) is made.
C
C     useCoupler is a flag which controls communications with other
C     model components through a coupler interface.
C
C     useSETRLSTK is a flag which toggles calling a small C routine
C     which sets the stack size to "unlimited" using setrlimit()

      notUsingXPeriodicity       = .FALSE.
      notUsingYPeriodicity       = .FALSE.
      useCubedSphereExchange     = .FALSE.
#ifdef ALLOW_USE_MPI
      usingMPI                   = .TRUE.
#else
      usingMPI                   = .FALSE.
#endif
      useCoupler                 = .FALSE.
      useNEST_PARENT             = .FALSE.
      useNEST_CHILD              = .FALSE.
      useNest2W_parent           = .FALSE.
      useNest2W_child            = .FALSE.
      useOASIS                   = .FALSE.
      nTx                        = 1
      nTy                        = 1
      useSETRLSTK                = .FALSE.
      useSIGREG                  = .FALSE.

C--   Parameter for printing (ascii) to Std-Oupt:
C     Print debug msg (sequence of S/R calls)
      debugMode = .FALSE.
C     Text map plots of fields ignore exact zero values
      printMapIncludesZeros = .FALSE.
C     Maximum length for printing (to Std-Msg-Unit) 1-D array
      maxLengthPrt1D = 65

C     To write output to global-files and from Master MPI process only
C     NOTE: read from main parameter file "data"
      useSingleCpuIO = .FALSE.

C--   Read in data from eedata file

C     Make a scratch copy of input eedata file without comments
#ifdef SINGLE_DISK_IO
C     Stop if called from eeboot_minimal.F before myProcId is set
      IF ( .NOT.doReport )
     &     STOP 'ABNORMAL END: S/R EESET_PARMS: myProcId unset'
      WRITE(scratchFile1,'(A)') 'scratch1'
      IF( myProcId .EQ. 0 ) THEN
       OPEN( UNIT=scrUnit1, FILE=scratchFile1, STATUS='UNKNOWN' )
      ENDIF
#else /* ifndef SINGLE_DISK_IO */
# ifdef USE_FORTRAN_SCRATCH_FILES
C     this is the old default, which can cause filename conflicts on some
C     multi-node/multi-processor systems
      OPEN( UNIT=scrUnit1, STATUS='SCRATCH' )
# else
C     this definition will go into CPP_EEMACROS.h, once this method is
C     properly established
C     After opening regular files here, they are closed with STATUS='DELETE'
#ifdef USE_PDAF
      CALL GET_TASKID_PDAF(mpi_task_id)
      WRITE(scratchFile1,'(A,'//FMT_PROC_ID//',A,'//FMT_TSK_ID//')')
     &     'scratch1.', procId, '.', mpi_task_id
#else
      WRITE(scratchFile1,'(A,'//FMT_PROC_ID//')') 'scratch1.', procId
#endif
      OPEN( UNIT=scrUnit1, FILE=scratchFile1, STATUS='UNKNOWN' )
# endif
#endif /* SINGLE_DISK_IO */

#ifdef SINGLE_DISK_IO
      IF( myProcId .EQ. 0 ) THEN
#endif

C--   Open the parameter file eedata
      OPEN( UNIT=eeDataUnit, FILE='eedata', STATUS='OLD',
     &      err=1, IOSTAT=errIO )
      IF ( errIO .GE. 0 ) GOTO 2
    1 CONTINUE
      IF ( doReport ) THEN
        WRITE(msgBuf,'(2A)') 'EESET_PARMS: ',
     &       'Unable to open parameter file "eedata"'
        CALL PRINT_ERROR( msgBuf, 1 )
        CALL EEDATA_EXAMPLE
C note: At this early stage, MPI might not be yet fully set-up; for this reason
C       set error flag and return (to avoid a call to ALL_PROC_DIE before stop)
c       STOP 'ABNORMAL END: S/R EESET_PARMS'
        eeBootError = .TRUE.
      ELSE
        RETURN
      ENDIF
    2 CONTINUE

C--   Read parameter eedata file, make a scratch copy without comments
C     and report contents of parameter file to STDOUT
      IF ( doReport ) THEN
       WRITE(msgBuf,'(A)')
     & '// ======================================================='
       CALL PRINT_MESSAGE(msgBuf, standardMessageUnit, SQUEEZE_RIGHT, 1)
       WRITE(msgBuf,'(A)')
     & '// Execution Environment parameter file "eedata"'
       CALL PRINT_MESSAGE(msgBuf, standardMessageUnit, SQUEEZE_RIGHT, 1)
       WRITE(msgBuf,'(A)')
     & '// ======================================================='
       CALL PRINT_MESSAGE(msgBuf, standardMessageUnit, SQUEEZE_RIGHT, 1)
      ENDIF

C     Read file, remove comments and apply specific syntax changes:
 1000 CONTINUE
       READ(eeDataUnit,FMT='(A)',END=1001) RECORD
       IL = MAX(ILNBLNK(RECORD),1)
       IF ( RECORD(1:1) .NE. commentCharacter ) THEN
         CALL NML_SET_TERMINATOR( RECORD )
         WRITE(UNIT=scrUnit1,FMT='(A)') RECORD(:IL)
       ENDIF
       IF ( doReport ) THEN
        WRITE(msgBuf,'(A,A)') '>',RECORD(:IL)
        CALL PRINT_MESSAGE( msgBuf,standardMessageUnit,SQUEEZE_RIGHT,1 )
       ENDIF
       GOTO 1000
 1001 CONTINUE
      CLOSE(eeDataUnit)
      IF ( doReport ) THEN
       WRITE(msgBuf,'(A)') ' '
       CALL PRINT_MESSAGE(msgBuf,standardMessageUnit, SQUEEZE_RIGHT, 1)
      ENDIF

#ifdef SINGLE_DISK_IO
      CALL FLUSH(scrUnit1)
      CLOSE(scrUnit1)
      ENDIF
# ifdef ALLOW_USE_MPI
C--   all processes must wait for process 0 to complete
C     writing scratchFile1 before opening it
      IF ( usingMPI ) THEN
        CALL MPI_BARRIER( MPI_COMM_MODEL, mpiRC )
      ENDIF
# endif
#ifdef HAVE_SYSTEM
      CALL SYSTEM('sleep 1')
#endif
      OPEN( UNIT=scrUnit1, FILE=scratchFile1, STATUS='OLD' )
#endif /* SINGLE_DISK_IO */

C--   Read namelist
      iUnit = scrUnit1
      REWIND(iUnit)
      READ(UNIT=iUnit,NML=EEPARMS,IOSTAT=errIO,err=3)
      IF ( errIO .GE. 0 ) GOTO 4
    3 CONTINUE
#ifndef TARGET_PWR3
      IF ( doReport ) THEN
       WRITE(msgBuf,'(2A)') 'EESET_PARMS: ',
     &      'Error reading parameter file "eedata"'
       CALL PRINT_ERROR( msgBuf, 1 )
       CALL EEDATA_EXAMPLE
       eeBootError = .TRUE.
      ENDIF
#endif
   4  CONTINUE

C--   Execution Environment parameter file read
#ifdef SINGLE_DISK_IO
      CLOSE(iUnit)
#else
      CLOSE(iUnit,STATUS='DELETE')
#endif /* SINGLE_DISK_IO */

#ifdef ALLOW_USE_MPI
#ifdef ALWAYS_USE_MPI
      IF ( doReport .AND. .NOT.usingMPI ) THEN
       WRITE(msgBuf,'(2A)') 'EESET_PARMS: ',
     &                      'in eedata: usingMPI=F conflicts'
       CALL PRINT_ERROR( msgBuf, 1 )
       WRITE(msgBuf,'(A)') 'EESET_PARMS:  with #define ALWAYS_USE_MPI'
       CALL PRINT_ERROR( msgBuf, 1 )
       eeBootError = .TRUE.
      ENDIF
      usingMPI = .TRUE.
#endif
#else /* ALLOW_USE_MPI */
      IF ( doReport .AND. usingMPI ) THEN
       WRITE(msgBuf,'(2A)') 'EESET_PARMS: ',
     &                      'in eedata: usingMPI=T conflicts'
       CALL PRINT_ERROR( msgBuf, 1 )
       WRITE(msgBuf,'(A)') 'EESET_PARMS:  with #undef ALLOW_USE_MPI'
       CALL PRINT_ERROR( msgBuf, 1 )
       eeBootError = .TRUE.
      ENDIF
      usingMPI = .FALSE.
#endif /* ALLOW_USE_MPI */

Cdbg  eeDataUnit = 42
Cdbg  OPEN(UNIT=eeDataUnit,FILE='eedata',STATUS='OLD',IOSTAT=errIO)
Cdbg  IF ( errIO .LT. 0 ) GOTO 11
Cdbg  DO K=1, 10
Cdbg   READ(eedataUnit,IOSTAT=errIO)
Cdbg   IF ( errIO .LT. 0 ) GOTO 11
Cdbg  ENDDO
Cdbg  READ(eedataUnit,FMT='(30X,1X,L23)',IOSTAT=errIO) notUsingXPeriodicity
Cdbg  IF ( errIO .LT. 0 ) GOTO 11
Cdbg  READ(eedataUnit,FMT='(30X,1X,L23)',IOSTAT=errIO) notUsingYPeriodicity
Cdbg  IF ( errIO .LT. 0 ) GOTO 11
Cdbg  READ(eedataUnit,FMT='(30X,1X,L23)',IOSTAT=errIO) usingMPI
Cdbg  IF ( errIO .LT. 0 ) GOTO 11
Cdbg  READ(eedataUnit,FMT='(30X,1X,I3)',IOSTAT=errIO) nTx
Cdbg  IF ( errIO .LT. 0 ) GOTO 11
Cdbg  READ(eedataUnit,FMT='(30X,1X,I3)',IOSTAT=errIO) nTy

Cdbg  IF (errIO .LT. 0 ) eeBootError = .TRUE.
Cdbg  CLOSE(eeDataUnit,IOSTAT=errIO)
Cdbg  IF ( eeBootError .OR. errIO .LT. 0 ) THEN
C--    Report that an error occured
Cdbg   eeBootError = .TRUE.
Cdbg   WRITE(msgBuf,'(A)' )
Cdbg &  'S/R EESET_PARMS: Error reading "eedata" execution environment file'
Cdbg   CALL PRINT_ERROR( msgBuf , 1)
Cdbg  ELSE
C--    Write summary of settings that were selected
Cdbg  ENDIF

      IF ( doReport ) THEN
C--   Set parameters for EXCH communication routines
C     Note: only done once when called with doReport=T

        exchCollectStatistics = .TRUE.
C--   Turn off memsync by default (e.g. needed for threads on SUNs)
        exchNeedsMemsync = .TRUE.
        exchUsesBarrier  = .TRUE.
        IF ( usingMPI ) THEN
C--   ... except that MPI needs this until some counter problem is fixed.
          exchNeedsMemsync = .FALSE.
          exchUsesBarrier  = .FALSE.
        ENDIF

C--   End setting parameters for EXCH communication routines
      ENDIF

      RETURN
      END

#include "AIM_OPTIONS.h"

CBOP
C     !ROUTINE: SUFLUX_SICE
C     !INTERFACE:
      SUBROUTINE SUFLUX_SICE(
     I                   PSA, FMASK, EMISloc,
     I                   Tsurf, dTskin, SSR, SLRD,
     I                   T1, T0, Q0, DENVV,
     O                   SHF, EVAP, SLRU,
     O                   Shf0, dShf, Evp0, dEvp, Slr0, dSlr, sFlx,
     O                   TSFC, TSKIN,
     I                   bi,bj,myThid)

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R SUFLUX_SICE
C     | o compute surface flux over sea-ice
C     *==========================================================*
C     | o contains part of original S/R SUFLUX (Speedy code)
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     Resolution parameters

C-- size for MITgcm & Physics package :
#include "AIM_SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"

C-- Physics package
#include "AIM_PARAMS.h"

C     Physical constants + functions of sigma and latitude
#include "com_physcon.h"

C     Surface flux constants
#include "com_sflcon.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine Arguments ==
C--   Input:
C    PSA    :: norm. surface pressure [p/p0]   (2-dim)
C    FMASK  :: fractional land-sea mask        (2-dim)
C    EMISloc:: longwave surface emissivity
C    Tsurf  :: surface temperature        (2-dim)
C    dTskin :: temp. correction for daily-cycle heating [K]
C    SSR    :: sfc sw radiation (net flux)     (2-dim)
C    SLRD   :: sfc lw radiation (downward flux)(2-dim)
C    T1     :: near-surface air temperature (from Pot.temp)
C    T0     :: near-surface air temperature    (2-dim)
C    Q0     :: near-surface sp. humidity [g/kg](2-dim)
C    DENVV  :: surface flux (sens,lat.) coeff. (=Rho*|V|) [kg/m2/s]
C--   Output:
C    SHF    :: sensible heat flux              (2-dim)
C    EVAP   :: evaporation [g/(m^2 s)]         (2-dim)
C    SLRU   :: sfc lw radiation (upward flux)  (2-dim)
C    Shf0   :: sensible heat flux over freezing surf.
C    dShf   :: sensible heat flux derivative relative to surf. temp
C    Evp0   :: evaporation computed over freezing surface (Ts=0.oC)
C    dEvp   :: evaporation derivative relative to surf. temp
C    Slr0   :: upward long wave radiation over freezing surf.
C    dSlr   :: upward long wave rad. derivative relative to surf. temp
C    sFlx   :: net heat flux (+=down) except SW, function of surf. temp Ts:
C              0: Flux(Ts=0.oC) ; 1: Flux(Ts^n) ; 2: d.Flux/d.Ts(Ts^n)
C    TSFC   :: surface temperature (clim.)     (2-dim)
C    TSKIN  :: skin surface temperature        (2-dim)
C--   Input:
C    bi,bj  :: tile index
C    myThid :: Thread number for this instance of the routine
C--
      _RL  PSA(NGP), FMASK(NGP), EMISloc
      _RL  Tsurf(NGP), dTskin(NGP)
      _RL  SSR(NGP), SLRD(NGP)
      _RL  T1(NGP), T0(NGP), Q0(NGP), DENVV(NGP)

      _RL  SHF(NGP), EVAP(NGP), SLRU(NGP)
      _RL  Shf0(NGP), dShf(NGP), Evp0(NGP), dEvp(NGP)
      _RL  Slr0(NGP), dSlr(NGP), sFlx(NGP,0:2)
      _RL  TSFC(NGP), TSKIN(NGP)

      INTEGER bi,bj,myThid
CEOP

#ifdef ALLOW_AIM

C-- Local variables:
C    CDENVV :: surf. heat flux (sens.,lat.) coeff including stability effect
C    ALHevp :: Latent Heat of evaporation
      _RL CDENVV(NGP), RDTH, FSSICE
      _RL ALHevp, Fstb0, dTstb, dFstb
      _RL QSAT0(NGP,2)
      _RL QDUMMY(1), RDUMMY(1), TS2
      INTEGER J

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      ALHevp = ALHC
C     Evap of snow/ice: account for Latent Heat of freezing :
      IF ( aim_energPrecip .OR. useThSIce ) ALHevp = ALHC + ALHF

C     1.5 Define effective skin temperature to compensate for
C         non-linearity of heat/moisture fluxes during the daily cycle

      DO J=1,NGP
c       TSKIN(J) = Tsurf(J) + dTskin(J)
c       TSFC(J)=273.16 _d 0 + dTskin(J)
        TSKIN(J) = Tsurf(J)
        TSFC(J)=273.16 _d 0
      ENDDO

C--   2. Computation of fluxes over land and sea

C     2.1 Stability correction

      RDTH = FSTAB/DTHETA

      DO J=1,NGP
        FSSICE=1.+MIN(DTHETA,MAX(-DTHETA,TSKIN(J)-T1(J)))*RDTH
        CDENVV(J)=CHS*DENVV(J)*FSSICE
      ENDDO

      IF ( dTstab.GT.0. _d 0 ) THEN
C-    account for stability function derivative relative to Tsurf:
C note: to avoid discontinuity in the derivative (because of min,max), compute
C   the derivative using the discrete form: F(Ts+dTstab)-F(Ts-dTstab)/2.dTstab
       DO J=1,NGP
        Fstb0 = 1.+MIN(DTHETA,MAX(-DTHETA,TSFC(J) -T1(J)))*RDTH
        Shf0(J) = CHS*DENVV(J)*Fstb0
        dTstb = ( DTHETA+dTstab-ABS(TSKIN(J)-T1(J)) )/dTstab
        dFstb = RDTH*MIN(1. _d 0, MAX(0. _d 0, dTstb*0.5 _d 0))
        dShf(J) = CHS*DENVV(J)*dFstb
       ENDDO
C-    deBug part:
c      J = 6 + (17-1)*sNx
c      IF ( bi.EQ.3 .AND. J.LE.NGP )
c    &  WRITE(6,1020)'SUFLUX_SICE: Stab=',Shf0(J),CDENVV(J),dShf(J)
      ENDIF

C     2.2 Evaporation

      CALL SHTORH (2, NGP, TSKIN, PSA, 1. _d 0, QDUMMY, dEvp,
     &                QSAT0(1,1), myThid)
      CALL SHTORH (0, NGP, TSFC, PSA, 1. _d 0, QDUMMY, RDUMMY,
     &                QSAT0(1,2), myThid)

      IF ( dTstab.GT.0. _d 0 ) THEN
C-    account for stability function derivative relative to Tsurf:
       DO J=1,NGP
        EVAP(J) = CDENVV(J)*(QSAT0(J,1)-Q0(J))
        Evp0(J) =   Shf0(J)*(QSAT0(J,2)-Q0(J))
        dEvp(J) = CDENVV(J)*dEvp(J)
     &            + dShf(J)*(QSAT0(J,1)-Q0(J))
       ENDDO
      ELSE
       DO J=1,NGP
        EVAP(J) = CDENVV(J)*(QSAT0(J,1)-Q0(J))
        Evp0(J) = CDENVV(J)*(QSAT0(J,2)-Q0(J))
        dEvp(J) = CDENVV(J)*dEvp(J)
       ENDDO
      ENDIF

C     2.3 Sensible heat flux

      IF ( dTstab.GT.0. _d 0 ) THEN
C-    account for stability function derivative relative to Tsurf:
       DO J=1,NGP
        SHF(J)  = CDENVV(J)*CP*(TSKIN(J)-T0(J))
        Shf0(J) =   Shf0(J)*CP*(TSFC(J) -T0(J))
        dShf(J) = CDENVV(J)*CP
     &            + dShf(J)*CP*(TSKIN(J)-T0(J))
        dShf(J) = MAX( dShf(J), 0. _d 0 )
C--   do not allow negative derivative vs Ts of Sensible+Latent H.flux:
C     a) quiet unrealistic ;
C     b) garantee positive deriv. of total H.flux (needed for implicit solver)
        dEvp(J) = MAX( dEvp(J), -dShf(J)/ALHevp )
       ENDDO
      ELSE
       DO J=1,NGP
        SHF(J)  = CDENVV(J)*CP*(TSKIN(J)-T0(J))
        Shf0(J) = CDENVV(J)*CP*(TSFC(J) -T0(J))
        dShf(J) = CDENVV(J)*CP
       ENDDO
      ENDIF

C     2.4 Emission of lw radiation from the surface

      DO J=1,NGP
        TS2     = TSFC(J)*TSFC(J)
        Slr0(J) = SBC*TS2*TS2
        TS2     = TSKIN(J)*TSKIN(J)
        SLRU(J) = SBC*TS2*TS2
        dSlr(J)  = 4. _d 0 *SBC*TS2*TSKIN(J)
      ENDDO

C--   Compute net surface heat flux and its derivative ./. surf. temp.
      DO J=1,NGP
        sFlx(J,0)= ( SLRD(J) - EMISloc*Slr0(J) )
     &           - ( Shf0(J) + ALHevp*Evp0(J) )
        sFlx(J,1)= ( SLRD(J) - EMISloc*SLRU(J) )
     &           - ( SHF(J)  + ALHevp*EVAP(J) )
        sFlx(J,2)=            -EMISloc*dSlr(J)
     &           - ( dShf(J) + ALHevp*dEvp(J) )
      ENDDO

C-    deBug part:   -----------------
c1010 FORMAT(A,I3,2F10.3,F10.4)
c1020 FORMAT(A,1P4E11.3)
c     J = 6 + (17-1)*sNx
c     IF ( bi.EQ.3 .AND. J.LE.NGP ) THEN
c       WRITE(6,1010) 'SUFLUX_SICE: 1,sFlx=', 1,
c    &                                    sFlx(J,0),sFlx(J,1),sFlx(J,2)
c       WRITE(6,1010) 'SUFLUX_SICE: 0,Evap=', 0,Evp0(J),EVAP(J),dEvp(J)
c       WRITE(6,1010) 'SUFLUX_SICE: -,LWup=',-1,Slr0(J),SLRU(J),dSlr(J)
c       WRITE(6,1010) 'SUFLUX_SICE: -, SHF=',-1,Shf0(J),SHF(J), dShf(J)
c       WRITE(6,1010) 'SUFLUX_SICE: -, LAT=',-1,
c    &                     ALHevp*Evp0(J),ALHevp*EVAP(J),ALHevp*dEvp(J)
c     ENDIF

C--   3. Adjustment of skin temperature and fluxes over land
C--      based on energy balance (to be implemented)
C        <= done separately for each surface type (land,ocean,sea-ice)

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
#endif /* ALLOW_AIM */

      RETURN
      END

#include "OBSFIT_OPTIONS.h"
#ifdef ALLOW_CTRL
# include "CTRL_OPTIONS.h"
#endif
#ifdef ALLOW_AUTODIFF
# include "AUTODIFF_OPTIONS.h"
#endif

CBOP
C     !ROUTINE: OBSFIT_COST

C     !INTERFACE:
      SUBROUTINE OBSFIT_COST( myTime, myIter, myThid )

C     !DESCRIPTION:
C     ==================================================================
C     | Computes the cost function for ObsFit data
C     ==================================================================

C     !USES:
      IMPLICIT NONE
C     == Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "DYNVARS.h"
#ifdef ALLOW_CAL
# include "cal.h"
#endif
#ifdef ALLOW_OBSFIT
# include "OBSFIT_SIZE.h"
# include "OBSFIT.h"
# include "netcdf.inc"
#endif
#ifdef ALLOW_CTRL
# include "OPTIMCYCLE.h"
#endif
#ifdef ALLOW_AUTODIFF
# include "tamc.h"
#endif

C     !INPUT PARAMETERS:
C     myTime  :: Current time in simulation
C     myIter  :: Current iteration number in simulation
C     myThid  :: my thread ID number
      _RL     myTime
      INTEGER myIter
      INTEGER myThid
CEOP

#ifdef ALLOW_OBSFIT
C     !FUNCTIONS
      INTEGER  ILNBLNK
      EXTERNAL ILNBLNK

C     !LOCAL VARIABLES:
      INTEGER num_file,sample_num
      INTEGER bi,bj
      _RL sample_modval
      _RL obs_modval, obs_modmask
      _RL obs_data, obs_uncert, obs_weight
#ifndef ALLOW_CTRL
      INTEGER optimcycle
#endif
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      CHARACTER*(MAX_LEN_FNAM) obsfitfile
      CHARACTER*(MAX_LEN_FNAM) fnamemisfit
      INTEGER IL, JL, err
      INTEGER irec, ii, varID
      INTEGER obs_num, num_valid_samples
      _RL sample_mask_sum
      _RL objf_obsfit_glo
      _RL num_obsfit_glo
      _RL samples_buff(NSAMPLES_MAX_GLO)
      _RL samples_mask_buff(NSAMPLES_MAX_GLO)
      _RL samples_modval_glob(NSAMPLES_MAX_GLO)
      _RL samples_mask_glob(NSAMPLES_MAX_GLO)
      _RL tmpgs
      INTEGER nobsmean
      _RL offset, mod_mean, obs_mean, misfit
      _RL spval
      PARAMETER ( spval = -9999. _d 0 )

#ifndef ALLOW_CTRL
      optimcycle = 0
#endif

      WRITE( msgBuf,'(A)' ) ' '
      CALL PRINT_MESSAGE( msgBuf,
     &     standardMessageUnit,SQUEEZE_RIGHT, myThid )
      WRITE( msgBuf,'(A)' ) '== obsfit_cost: begin =='
      CALL PRINT_MESSAGE( msgBuf,
     &     standardMessageUnit,SQUEEZE_RIGHT, myThid )

C Initialise local storage
#ifdef ALLOW_AUTODIFF_TAMC
CADJ INIT tapelev_obsfit = COMMON, NFILESMAX_OBS
#endif

      _BEGIN_MASTER( myThid )

      DO num_file = 1, NFILESMAX_OBS

C File maintenance
        DO bj = 1, nSy
          DO bi= 1, nSx

            IF ( ( sampleNo(num_file,bi,bj).GT.0 ).AND.
     &           (obsfitDoNcOutput) ) THEN
C Need to sync the file so that the data is not lost when run finishes
              err = NF_SYNC( fidfwd_obs(num_file,bi,bj) )
              CALL OBSFIT_NF_ERROR( 'COST: NF_SYNC fidfwd_obs',
     &             err,bi,bj,myThid )
            ENDIF

          ENDDO
        ENDDO

C Loop over samples
        DO ii = 1, NSAMP_PER_TILE_MAX
          samples_buff(ii)      = zeroRL
          samples_mask_buff(ii) = zeroRL
        ENDDO

        DO bj = 1, nSy
          DO bi = 1, nSx

C Open tiled files and read to buffer
            DO sample_num = 1, NSAMP_PER_TILE_MAX
              IF ( sample_num.LE.sampleNo(num_file,bi,bj) ) THEN

                sample_modval = zeroRL

                CALL ACTIVE_READ_OBS_TILE(
     I               num_file,
     O               sample_modval,
     I               sample_num,.false.,
     I               optimcycle,bi,bj,myThid,
     I               obsfit_dummy(num_file,bi,bj) )

C Save model equi (of samples) and masks in buffer
C Combine all threads here
                irec = sample_ind_glob(num_file,sample_num,bi,bj)
                samples_buff(irec) = samples_buff(irec)+sample_modval
                samples_mask_buff(irec) = samples_mask_buff(irec)
     &           +sample_modmask(bi,bj)

              ENDIF !IF (sample_num.LE.sampleNo(num_file,bi,bj))
            ENDDO !DO sample_num

          ENDDO !DO bj
        ENDDO !DO bi

C Combine all processes
        DO ii = 1, NSAMP_PER_TILE_MAX
          tmpgs = samples_buff(ii)
          _GLOBAL_SUM_RL(tmpgs, myThid)
          samples_modval_glob(ii) = tmpgs
          tmpgs = samples_mask_buff(ii)
          _GLOBAL_SUM_RL(tmpgs, myThid)
          samples_mask_glob(ii) = tmpgs
        ENDDO

#ifdef ALLOW_AUTODIFF_TAMC
C     Not really necessary, but cheap (for small NFILESMAX_OBS)
C     and avoids some hidden recomputations.
CADJ STORE samples_modval_glob, samples_mask_glob
CADJ &     = tapelev_obsfit, key = num_file, kind = isbyte
#endif

        IF ( myProcId .EQ. 0 ) THEN

C Loop over obs
          DO obs_num = 1, NOBSMAX_OBS
            IF ( obs_num.LE.ObsNo(num_file) ) THEN

              obs_modval        = zeroRL
              sample_mask_sum   = zeroRL
              num_valid_samples = 0

C Calculate model equi of each obs by averaging NP samples
              DO sample_num = 1, NSAMP_PER_OBS_MAX
                IF ( sample_num.LE.obs_np(num_file,obs_num) ) THEN
                  irec = obs_sample1_ind(num_file,obs_num)+sample_num-1
                  obs_modval = obs_modval+samples_modval_glob(irec)
     &             *samples_mask_glob(irec)
                  sample_mask_sum = sample_mask_sum
     &             +samples_mask_glob(irec)
                  IF ( samples_mask_glob(irec).GT.zeroRL ) THEN
                    num_valid_samples = num_valid_samples+1
                  ENDIF

                ENDIF
              ENDDO

C Time averaging
              IF ( obsfitOperation(num_file).EQ.1 ) THEN
                obs_modval = obs_modval/obs_delT(num_file, obs_num)
              ENDIF

C Spatial averaging
              IF (sample_mask_sum.GT.zeroRL) THEN
                obs_modval = obs_modval/sample_mask_sum
                obs_modmask = oneRL
              ELSE
                obs_modval = spval
                obs_modmask = zeroRL
              ENDIF

C Write to global netcdf file
              CALL ACTIVE_WRITE_OBS_GLOB(
     I             num_file, obs_modval, obs_modmask, obs_num,
     I             optimcycle, myThid, obsfit_globaldummy(num_file) )

            ENDIF !IF (obs_num.LE.ObsNo(num_file))
          ENDDO !DO obs_num
#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE obsfit_globaldummy(num_file)
CADJ &     = tapelev_obsfit, key = num_file, kind = isbyte
#endif

C Need to sync the file so that the data is not lost when run finishes
          IF ( ObsNo(num_file).GT.0 ) THEN
            err = NF_SYNC( fidglobal(num_file) )
            CALL OBSFIT_NF_ERROR(
     &           'COST: NF_SYNC fidglobal',err,0,0,myThid )
          ENDIF
          IF ( obs_is_ssh(num_file).GT.0 ) THEN
C Read data to calculate the mean offset between model and obs
            offset   = zeroRL
            mod_mean = zeroRL
            obs_mean = zeroRL
            nobsmean = 0

C Loop over obs
            DO obs_num = 1, NOBSMAX_OBS
              IF ( obs_num.LE.ObsNo(num_file) ) THEN

                obs_modval = zeroRL
                obs_data   = zeroRL
                obs_uncert = zeroRL

C Read model equivalent from global file
                CALL ACTIVE_READ_OBS_GLOB(
     I               num_file,
     O               obs_modval, obs_modmask,
     I               obs_num, .FALSE., optimcycle, myThid,
     I               obsfit_globaldummy(num_file) )

C Read observation and uncertainty
                CALL OBSFIT_READ_OBS(
     I               num_file,1,obs_ind_glob(num_file,obs_num),
     O               obs_data,
     I               myThid )

                IF ( obs_data.GT.spval .AND. obs_modval.GT.spval ) THEN
                  obs_mean = obs_mean + obs_data
                  mod_mean = mod_mean + obs_modval
                  nobsmean = nobsmean + 1
                ENDIF

              ENDIF !IF (obs_num.LE.ObsNo(num_file))
            ENDDO !DO obs_num

            obs_mean = obs_mean/nobsmean
            mod_mean = mod_mean/nobsmean
            offset   = mod_mean-obs_mean

          ELSE
            offset = zeroRL
          ENDIF

C Read data to calculate the cost
C and write misfits to global file

C Global file for misfits
          IF (ObsNo(num_file).GT.0) THEN
            IL = ILNBLNK( obsfitfiles(num_file) )
            WRITE( obsfitfile,'(1A)' ) obsfitfiles(num_file)(1:IL)
            IL = ILNBLNK( obsfitfile )
            JL = ILNBLNK( obsfitDir )
            WRITE( fnamemisfit,'(3A)' )
     &       obsfitDir(1:JL),obsfitfile(1:IL),'.misfit.nc'
            err = NF_OPEN( fnamemisfit,NF_WRITE,fidmisfit(num_file) )
            err = NF_INQ_VARID( fidmisfit(num_file),'misfit',varID )
            CALL OBSFIT_NF_ERROR(
     &           'COST: NF_INQ_VARID misfit',err,0,0,myThid )
          ENDIF
C Loop over obs
          DO obs_num = 1, NOBSMAX_OBS
            IF ( obs_num.LE.ObsNo(num_file) ) THEN

              obs_modval = zeroRL
              obs_data   = zeroRL
              obs_uncert = zeroRL

C Read observation and uncertainty
              CALL OBSFIT_READ_OBS(
     I             num_file, 1, obs_ind_glob(num_file,obs_num),
     O             obs_data,
     I             myThid )

              CALL OBSFIT_READ_OBS(
     I             num_file, -1, obs_ind_glob(num_file,obs_num),
     O             obs_uncert,
     I             myThid )

              IF ( obs_data .EQ. spval ) obs_uncert = zeroRL

C Read model equivalent from global file
              CALL ACTIVE_READ_OBS_GLOB(
     I             num_file,
     O             obs_modval,obs_modmask,
     I             obs_num,.FALSE.,optimcycle,myThid,
     I             obsfit_globaldummy(num_file) )

              IF ( obs_uncert.GT.zeroRL ) THEN
                obs_weight = 1. _d 0 / (obs_uncert*obs_uncert)
                misfit = obs_modval-obs_data-offset
                objf_obsfit(num_file) = objf_obsfit(num_file)
     &           + obs_modmask* obs_weight * misfit * misfit
                num_obsfit(num_file)  = num_obsfit(num_file)
     &           + obs_modmask
C Write misfit to global netcdf file
                err = NF_PUT_VARA_DOUBLE( fidmisfit(num_file),varID,
     &                obs_ind_glob(num_file,obs_num),1,misfit )
                CALL OBSFIT_NF_ERROR(
     &               'COST: NF_PUT_VARA_DOUBLE misfit',
     &               err,0,0,myThid )
              ENDIF

            ENDIF !IF (obs_num.LE.ObsNo(num_file))
          ENDDO !DO obs_num

        ENDIF !IF myprocid = 0
      ENDDO !DO num_file

      _END_MASTER( myThid )

C Print cost function values
      DO num_file = 1, NFILESMAX_OBS

        objf_obsfit_glo = objf_obsfit(num_file)
        num_obsfit_glo = num_obsfit(num_file)

        WRITE( msgBuf,'(A,I2,A,E20.13,1X,D12.5)' )
     &       'obsfit_cost(',num_file,') = ',
     &       objf_obsfit_glo, num_obsfit_glo

        IF ( num_obsfit_glo.GT.zeroRL )
     &    CALL PRINT_MESSAGE( msgBuf,
     &         standardMessageUnit,SQUEEZE_RIGHT, myThid )

      ENDDO

      WRITE( msgBuf,'(A)') '== obsfit_cost: end   =='
      CALL PRINT_MESSAGE( msgBuf,
     &     standardMessageUnit,SQUEEZE_RIGHT, myThid )
      WRITE( msgBuf,'(A)' ) ' '
      CALL PRINT_MESSAGE( msgBuf,
     &     standardMessageUnit,SQUEEZE_RIGHT, myThid )

#endif /* ALLOW_OBSFIT */

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#include "GRDCHK_OPTIONS.h"
#include "AD_CONFIG.h"
#ifdef ALLOW_COST
# include "COST_OPTIONS.h"
#endif
#ifdef ALLOW_CTRL
# include "CTRL_OPTIONS.h"
#endif

CBOI
C
C !TITLE: GRADIENT CHECK
C !AUTHORS: mitgcm developers ( support@mitgcm.org )
C !AFFILIATION: Massachussetts Institute of Technology
C !DATE:
C !INTRODUCTION: gradient check package
C \bv
C Compare the gradients calculated by the adjoint model with
C finite difference approximations.
C
C     !CALLING SEQUENCE:
C
C the_model_main
C |
C |-- ctrl_unpack
C |-- adthe_main_loop          - unperturbed cost function and
C |-- ctrl_pack                  adjoint gradient are computed here
C |
C |-- grdchk_main
C     |
C     |-- grdchk_get_mask
C     |-- do icomp=...        - loop over control vector elements
C         |
C         |-- grdchk_loc      - determine location of icomp on grid
C         |
C         |-- grdchk_getadxx  - get gradient component calculated
C         |                     via adjoint
C         |-- grdchk_getxx    - get control vector component from file
C         |                     perturb it and write back to file
C         |-- the_main_loop   - forward run and cost evaluation
C         |                     with perturbed control vector element
C         |-- calculate ratio of adj. vs. finite difference gradient
C         |
C         |-- grdchk_setxx    - Reset control vector element
C     |
C     |-- grdchk_print    - print results
C \ev
CEOI

CBOP
C     !ROUTINE: GRDCHK_MAIN
C     !INTERFACE:
      SUBROUTINE GRDCHK_MAIN( myThid )

C     !DESCRIPTION: \bv
C     ==================================================================
C     SUBROUTINE GRDCHK_MAIN
C     ==================================================================
C     o Compare the gradients calculated by the adjoint model with
C       finite difference approximations.
C     started: Christian Eckert eckert@mit.edu 24-Feb-2000
C     continued&finished: heimbach@mit.edu: 13-Jun-2001
C     changed: mlosch@ocean.mit.edu: 09-May-2002
C              - added centered difference vs. 1-sided difference option
C              - improved output format for readability
C              - added control variable hFacC
C              heimbach@mit.edu 24-Feb-2003
C              - added tangent linear gradient checks
C              - fixes for multiproc. gradient checks
C              - added more control variables
C     ==================================================================
C     SUBROUTINE GRDCHK_MAIN
C     ==================================================================
C     \ev

C     !USES:
      IMPLICIT NONE

C     == global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "cost.h"
#include "g_cost.h"
#include "CTRL_SIZE.h"
#include "CTRL.h"
#ifdef ALLOW_OBCS_CONTROL
C     CTRL_OBCS.h must be included before GRDCHK.h
# include "CTRL_OBCS.h"
#endif
#include "GRDCHK.h"

#ifdef ALLOW_TAPENADE
# include "COST_TAP_TLM.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
      INTEGER myThid

#ifdef ALLOW_GRDCHK
C     !LOCAL VARIABLES:
      INTEGER myIter
      _RL     myTime
      INTEGER bi, bj
      INTEGER i, j, k
      INTEGER iMin, iMax, jMin, jMax
      PARAMETER( iMin = 1 , iMax = sNx , jMin = 1 , jMax = sNy )
      INTEGER ioUnit
      CHARACTER*(MAX_LEN_MBUF) msgBuf

      INTEGER icomp
      INTEGER ichknum
      INTEGER icvrec
      INTEGER jtile
      INTEGER itile
      INTEGER layer
      INTEGER obcspos
      INTEGER itilepos
      INTEGER jtilepos
      INTEGER icglo
      INTEGER itest
      INTEGER ierr
      INTEGER ierr_grdchk
      _RL     gfd
      _RL     fcref
      _RL     fcpertplus, fcpertminus
      _RL     ratio_ad
      _RL     ratio_ftl
      _RL     xxmemo_ref
      _RL     xxmemo_pert
      _RL     adxxmemo
      _RL     ftlxxmemo
      _RL     localEps
      _RL     grdchk_epsfac
      _RL tmpplot1(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      _RL tmpplot2(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      _RL tmpplot3(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
CEOP

      ioUnit = standardMessageUnit
      WRITE(msgBuf,'(A)')
     &'// ======================================================='
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)') '// Gradient-check starts (grdchk_main)'
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)')
     &'// ======================================================='
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )

#ifdef ALLOW_TANGENTLINEAR_RUN
C--   prevent writing output multiple times
C     note: already called in AD run so that only needed for TLM run
      CALL TURNOFF_MODEL_IO( 0, myThid )
#endif

C--   initialise variables
      CALL GRDCHK_GET_MASK( myThid )

C--   Compute the adjoint model gradients.
C--   Compute the unperturbed cost function.
Cph   Gradient via adjoint has already been computed,
Cph   and so has unperturbed cost function,
Cph   assuming all xx_ fields are initialised to zero.

      ierr      = 0
      ierr_grdchk = 0
      adxxmemo  = 0.
      ftlxxmemo = 0.

#ifdef ALLOW_TAPENADE
C--   forward run with unperturbed control vector
      myTime = startTime
      myIter = nIter0
      CALL THE_MAIN_LOOP( myTime, myIter, myThid )
#endif

#if (defined  (ALLOW_ADMTLM))
      fcref = objf_state_final(idep,jdep,1,1,1)
#elif (defined (ALLOW_OPENAD))
      fcref = fc%v
#else
      fcref = fc
#endif
      WRITE(msgBuf,'(A,1PE22.14)')
     &         'grdchk reference fc: fcref       =', fcref
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )

      DO bj = myByLo(myThid), myByHi(myThid)
        DO bi = myBxLo(myThid), myBxHi(myThid)
          DO k = 1, Nr
            DO j = jMin, jMax
              DO i = iMin, iMax
                tmpplot1(i,j,k,bi,bj) = 0. _d 0
                tmpplot2(i,j,k,bi,bj) = 0. _d 0
                tmpplot3(i,j,k,bi,bj) = 0. _d 0
              ENDDO
            ENDDO
          ENDDO
        ENDDO
      ENDDO

      IF ( useCentralDiff ) THEN
         grdchk_epsfac = 2. _d 0
      ELSE
         grdchk_epsfac = 1. _d 0
      ENDIF

      WRITE(standardMessageUnit,'(A)')
     &    'grad-res -------------------------------'
      WRITE(standardMessageUnit,'(2a)')
     &    ' grad-res  proc    #    i    j    k   bi   bj iobc',
     &    '       fc ref            fc + eps           fc - eps'
#ifdef ALLOW_TANGENTLINEAR_RUN
      WRITE(standardMessageUnit,'(2a)')
     &    ' grad-res  proc    #    i    j    k   bi   bj iobc',
     &    '      tlm grad            fd grad          1 - fd/tlm'
#else
      WRITE(standardMessageUnit,'(2a)')
     &    ' grad-res  proc    #    i    j    k   bi   bj iobc',
     &    '      adj grad            fd grad          1 - fd/adj'
#endif

C--   Compute the finite difference approximations.
C--   Cycle through all processes doing NINT(nend-nbeg+1)/nstep
C--   gradient checks.

      IF ( nbeg .EQ. 0 ) CALL GRDCHK_GET_POSITION( myThid )

      DO icomp = nbeg, nend, nstep

        adxxmemo  = 0.
        ichknum = (icomp - nbeg)/nstep + 1

        IF ( ichknum .LE. maxgrdchecks ) THEN
          WRITE(msgBuf,'(A,I4,A)')
     &      '====== Starts gradient-check number', ichknum,
     &                                         ' (=ichknum) ======='
          CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )

C--       Determine the location of icomp on the grid.
          IF ( myProcId .EQ. grdchkwhichproc ) THEN
            CALL grdchk_loc( icomp, ichknum,
     &              icvrec, itile, jtile, layer, obcspos,
     &              itilepos, jtilepos, icglo, itest, ierr,
     &              myThid )
          ELSE
            icvrec   = 0
            itile    = 0
            jtile    = 0
            layer    = 0
            obcspos  = 0
            itilepos = 0
            jtilepos = 0
            icglo    = 0
            itest    = 0
          ENDIF

C make sure that all procs have correct file records, so that useSingleCpuIO works
          CALL GLOBAL_SUM_INT( icvrec , myThid )
          CALL GLOBAL_SUM_INT( layer , myThid )
          CALL GLOBAL_SUM_INT( ierr , myThid )

          WRITE(msgBuf,'(A,3I5,A,2I4,A,I3,A,I4)')
     &     'grdchk pos: i,j,k=', itilepos, jtilepos, layer,
     &              ' ; bi,bj=', itile, jtile, ' ; iobc=', obcspos,
     &              ' ; rec=', icvrec
          CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )

C******************************************************
C--   (A): get gradient component calculated via adjoint
C******************************************************

C--   get gradient component calculated via adjoint
          CALL GRDCHK_GETADXX( icvrec,
     &              itilepos, jtilepos,
     &              layer, itile, jtile,
     &              grdchkwhichproc, grdchkvarindex,
     &              adxxmemo, myThid )
C--   Add a global-sum call so that all proc will get the adjoint gradient
          _GLOBAL_SUM_RL( adxxmemo, myThid )

#ifdef ALLOW_TANGENTLINEAR_RUN
C******************************************************
C--   (B): Get gradient component g_fc from tangent linear run:
C******************************************************

C--   1. perturb control vector component: xx(i)=1.

          localEps = 1. _d 0
          CALL GRDCHK_GETXX( icvrec, TANGENT_SIMULATION,
     &              itilepos, jtilepos,
     &              layer, itile, jtile,
     &              grdchkwhichproc, grdchkvarindex,
     &              xxmemo_ref, xxmemo_pert, localEps,
     &              myThid )

C--   2. perform tangent linear run
          myTime = startTime
          myIter = nIter0
# ifdef ALLOW_ADMTLM
          DO k=1,4*Nr+1
            DO j=1,sNy
              DO i=1,sNx
                g_objf_state_final(i,j,1,1,k) = 0.
              ENDDO
            ENDDO
          ENDDO
# else
          g_fc = 0.
# endif

# ifdef ALLOW_TAPENADE
          CALL THE_MAIN_LOOP_D( myTime, myIter, myThid )
#  ifdef ALLOW_ADMTLM
          ftlxxmemo = objf_state_finald(idep,jdep,1,1,1)
#  else
          ftlxxmemo = fcd
#  endif
# else /* ALLOW_TAPENADE */
          CALL G_THE_MAIN_LOOP( myTime, myIter, myThid )
#  ifdef ALLOW_ADMTLM
          ftlxxmemo = g_objf_state_final(idep,jdep,1,1,1)
#  else
          ftlxxmemo = g_fc
#  endif
# endif /* ALLOW_TAPENADE */

C--   3. reset control vector
          CALL GRDCHK_SETXX( icvrec, TANGENT_SIMULATION,
     &              itilepos, jtilepos,
     &              layer, itile, jtile,
     &              grdchkwhichproc, grdchkvarindex,
     &              xxmemo_ref, myThid )

#endif /* ALLOW_TANGENTLINEAR_RUN */

C******************************************************
C--   (C): Get gradient via finite difference perturbation
C******************************************************

C--   (C-1) positive perturbation:
          localEps = ABS(grdchk_eps)

C--   get control vector component from file
C--   perturb it and write back to file
          CALL GRDCHK_GETXX( icvrec, FORWARD_SIMULATION,
     &              itilepos, jtilepos,
     &              layer, itile, jtile,
     &              grdchkwhichproc, grdchkvarindex,
     &              xxmemo_ref, xxmemo_pert, localEps,
     &              myThid )

C--   forward run with perturbed control vector
          myTime = startTime
          myIter = nIter0
#ifdef ALLOW_OPENAD
          CALL OpenAD_THE_MAIN_LOOP( myTime, myIter, myThid )
#else
          CALL THE_MAIN_LOOP( myTime, myIter, myThid )
#endif

#ifdef ALLOW_ADMTLM
          fcpertplus = objf_state_final(idep,jdep,1,1,1)
#elif (defined (ALLOW_OPENAD))
          fcpertplus = fc%v
#else
          fcpertplus = fc
#endif
          WRITE(msgBuf,'(A,1PE22.14)')
     &         'grdchk perturb(+)fc: fcpertplus  =', fcpertplus
          CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )

C--   Reset control vector.
          CALL GRDCHK_SETXX( icvrec, FORWARD_SIMULATION,
     &              itilepos, jtilepos,
     &              layer, itile, jtile,
     &              grdchkwhichproc, grdchkvarindex,
     &              xxmemo_ref, myThid )

          fcpertminus = fcref
          IF ( useCentralDiff ) THEN
C--   (C-2) repeat the proceedure for a negative perturbation:
            localEps = - ABS(grdchk_eps)

C--   get control vector component from file
C--   perturb it and write back to file
            CALL GRDCHK_GETXX( icvrec, FORWARD_SIMULATION,
     &              itilepos, jtilepos,
     &              layer, itile, jtile,
     &              grdchkwhichproc, grdchkvarindex,
     &              xxmemo_ref, xxmemo_pert, localEps,
     &              myThid )

C--   forward run with perturbed control vector
            myTime = startTime
            myIter = nIter0
#ifdef ALLOW_OPENAD
            CALL OpenAD_THE_MAIN_LOOP( myTime, myIter, myThid )
#else
            CALL THE_MAIN_LOOP( myTime, myIter, myThid )
#endif

#if (defined (ALLOW_ADMTLM))
            fcpertminus = objf_state_final(idep,jdep,1,1,1)
#elif (defined (ALLOW_OPENAD))
            fcpertminus = fc%v
#else
            fcpertminus = fc
#endif
            WRITE(msgBuf,'(A,1PE22.14)')
     &         'grdchk perturb(-)fc: fcpertminus =', fcpertminus
            CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )

C--   Reset control vector.
            CALL GRDCHK_SETXX( icvrec, FORWARD_SIMULATION,
     &              itilepos, jtilepos,
     &              layer, itile, jtile,
     &              grdchkwhichproc, grdchkvarindex,
     &              xxmemo_ref, myThid )

C-- end of if useCentralDiff ...
          ENDIF

C******************************************************
C--   (D): calculate relative differences between gradients
C******************************************************

          IF ( grdchk_eps .EQ. 0. ) THEN
            gfd = (fcpertplus-fcpertminus)
          ELSE
            gfd = (fcpertplus-fcpertminus) /(grdchk_epsfac*grdchk_eps)
          ENDIF

          IF ( adxxmemo .EQ. 0. ) THEN
            ratio_ad = ABS( adxxmemo - gfd )
          ELSE
            ratio_ad = 1. - gfd/adxxmemo
          ENDIF

          IF ( ftlxxmemo .EQ. 0. ) THEN
            ratio_ftl = ABS( ftlxxmemo - gfd )
          ELSE
            ratio_ftl = 1. - gfd/ftlxxmemo
          ENDIF

          IF ( myProcId .EQ. grdchkwhichproc .AND. ierr .EQ. 0 ) THEN
            tmpplot1(itilepos,jtilepos,layer,itile,jtile) = gfd
            tmpplot2(itilepos,jtilepos,layer,itile,jtile) = ratio_ad
            tmpplot3(itilepos,jtilepos,layer,itile,jtile) = ratio_ftl
          ENDIF

          IF ( ierr .EQ. 0 ) THEN
            fcrmem      ( ichknum ) = fcref
            fcppmem     ( ichknum ) = fcpertplus
            fcpmmem     ( ichknum ) = fcpertminus
            xxmemref    ( ichknum ) = xxmemo_ref
            xxmempert   ( ichknum ) = xxmemo_pert
            gfdmem      ( ichknum ) = gfd
            adxxmem     ( ichknum ) = adxxmemo
            ftlxxmem    ( ichknum ) = ftlxxmemo
            ratioadmem  ( ichknum ) = ratio_ad
            ratioftlmem ( ichknum ) = ratio_ftl

            irecmem   ( ichknum ) = icvrec
            bimem     ( ichknum ) = itile
            bjmem     ( ichknum ) = jtile
            ilocmem   ( ichknum ) = itilepos
            jlocmem   ( ichknum ) = jtilepos
            klocmem   ( ichknum ) = layer
            iobcsmem  ( ichknum ) = obcspos
            icompmem  ( ichknum ) = icomp
            ichkmem   ( ichknum ) = ichknum
            itestmem  ( ichknum ) = itest
            ierrmem   ( ichknum ) = ierr
            icglomem  ( ichknum ) = icglo
          ENDIF

          IF ( myProcId .EQ. grdchkwhichproc .AND. ierr .EQ. 0 ) THEN
            WRITE(standardMessageUnit,'(A)')
     &          'grad-res -------------------------------'
            WRITE(standardMessageUnit,'(A,8I5,1x,1P3E19.11)')
     &           ' grad-res ',myprocid,ichknum,itilepos,jtilepos,
     &             layer,itile,jtile,obcspos,
     &             fcref, fcpertplus, fcpertminus
#ifdef ALLOW_TANGENTLINEAR_RUN
            WRITE(standardMessageUnit,'(A,8I5,1x,1P3E19.11)')
     &           ' grad-res ',myprocid,ichknum,ichkmem(ichknum),
     &             icompmem(ichknum),itestmem(ichknum),
     &             bimem(ichknum),bjmem(ichknum),iobcsmem(ichknum),
     &             ftlxxmemo, gfd, ratio_ftl
#else
            WRITE(standardMessageUnit,'(A,8I5,1x,1P3E19.11)')
     &           ' grad-res ',myprocid,ichknum,ichkmem(ichknum),
     &             icompmem(ichknum),itestmem(ichknum),
     &             bimem(ichknum),bjmem(ichknum),iobcsmem(ichknum),
     &             adxxmemo, gfd, ratio_ad
#endif
          ENDIF
#ifdef ALLOW_TANGENTLINEAR_RUN
          WRITE(msgBuf,'(A30,1PE22.14)')
     &              ' TLM  ref_cost_function      =', fcref
          CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
          WRITE(msgBuf,'(A30,1PE22.14)')
     &              ' TLM  tangent-lin_grad       =', ftlxxmemo
          CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
          WRITE(msgBuf,'(A30,1PE22.14)')
     &              ' TLM  finite-diff_grad       =', gfd
          CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
#else
          WRITE(msgBuf,'(A30,1PE22.14)')
     &              ' ADM  ref_cost_function      =', fcref
          CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
          WRITE(msgBuf,'(A30,1PE22.14)')
     &              ' ADM  adjoint_gradient       =', adxxmemo
          CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
          WRITE(msgBuf,'(A30,1PE22.14)')
     &              ' ADM  finite-diff_grad       =', gfd
          CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
#endif

          WRITE(msgBuf,'(A,I4,A,I3,A)')
     &      '====== End of gradient-check number', ichknum,
     &                      ' (ierr=', ierr, ') ======='
          CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )

C-- else of if ichknum < ...
        ELSE
          ierr_grdchk = -1

C-- end of if ichknum < ...
        ENDIF

C-- end of do icomp = ...
      ENDDO

      CALL WRITE_REC_XYZ_RL( 'grd_findiff'  , tmpplot1, 1, 0, myThid )
# ifdef ALLOW_ADJOINT_RUN
      CALL WRITE_REC_XYZ_RL( 'grd_ratio_ad' , tmpplot2, 1, 0, myThid )
# endif
# ifdef  ALLOW_TANGENTLINEAR_RUN
      CALL WRITE_REC_XYZ_RL( 'grd_ratio_ftl', tmpplot3, 1, 0, myThid )
# endif

C--   Print the results of the gradient check.
      CALL GRDCHK_PRINT( ichknum, ierr_grdchk, myThid )

#endif /* ALLOW_GRDCHK */

      RETURN
      END

#include "CPP_EEOPTIONS.h"

CBOP
C     !ROUTINE: WRITE_FULLARRAY_RS
C     !INTERFACE:
      SUBROUTINE WRITE_FULLARRAY_RS( fnam, fld, kSize,
     I                               biArg, bjArg,
     I                               iRec, myIter, myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE WRITE_FULLARRAY
C     | write full array (including the overlap) to binary files
C     *==========================================================*
C     | Only used for debugging purpose.
C     |  can write local array (with no bi,bj) corresponding to
C     |      tile biArg,bjArg
C     |  or global array (with bi,bj) (called with biArg=bjArg=0)
C     | Warning:
C     |   1) does not explicitly do the byte-swapping unless
C     |      specified by compiler option.
C     |   2) ignores writeBinaryPrec and just write output with
C     |      same precision as input array (float32/float64)
C     *==========================================================*
C     \ev
C     !USES:
      IMPLICIT NONE

C     == Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
      CHARACTER*(*) fnam
      INTEGER kSize
      INTEGER biArg, bjArg
      INTEGER iRec
      INTEGER myIter
      INTEGER myThid
      _RS fld(1-OLx:sNx+OLx,1-OLy:sNy+OLy,kSize,nSx,nSy)

C     !FUNCTIONS:
C     ==  Functions ==
      INTEGER  ILNBLNK, IFNBLNK, MDS_RECLEN
      EXTERNAL ILNBLNK, IFNBLNK, MDS_RECLEN

C     !LOCAL VARIABLES:
C     == Local variables ==
      INTEGER i,j,k,bi,bj,iG,jG
      INTEGER s1Lo,s1Hi, dUnit, filePrec, length_of_rec, kRec
      CHARACTER*(MAX_LEN_FNAM) fullName
CEOP

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C--   Only do I/O if I am the master thread
      _BEGIN_MASTER( myThid )

C--   to Build file name
      s1Lo = IFNBLNK(fnam)
      s1Hi = ILNBLNK(fnam)
      CALL MDSFINDUNIT( dUnit, myThid )

C--   file precision has to match array type (no copy to buffer)
#ifdef RS_IS_REAL4
      filePrec = precFloat32
#else
      filePrec = precFloat64
#endif

      IF ( biArg.EQ.0 .AND. bjArg.EQ.0 ) THEN
C--   Write full global array:
       DO bj = 1,nSy
        DO bi = 1,nSx
         iG=bi+(myXGlobalLo-1)/sNx
         jG=bj+(myYGlobalLo-1)/sNy

         IF ( myIter.GE.0 ) THEN
           WRITE( fullName, '(2A,I10.10,2(A,I3.3),A)' )
     &      fnam(s1Lo:s1Hi),'.',myIter,'.',iG,'.',jG,'.data'
         ELSE
           WRITE( fullName, '(A,2(A,I3.3),A)' )
     &      fnam(s1Lo:s1Hi),'.',iG,'.',jG,'.data'
         ENDIF

c        OPEN( dUnit, file=fullName, status='unknown',
c    &         form='unformatted')
c        WRITE(dUnit) ((( fld(i,j,k,bi,bj),
c    &                        i=1-OLx,sNx+OLx),
c    &                        j=1-OLy,sNy+OLy),
c    &                        k=1,kSize)
         length_of_rec = MDS_RECLEN(
     &                   filePrec, (sNx+2*OLx)*(sNy+2*OLy), myThid )
         OPEN( dUnit, file=fullName, status='unknown',
     &         access='direct', recl=length_of_rec )
         DO k = 1,kSize
           kRec = k + (iRec-1)*kSize
           WRITE(dUnit,rec=kRec) (( fld(i,j,k,bi,bj),
     &                                i=1-OLx,sNx+OLx),
     &                                j=1-OLy,sNy+OLy )
         ENDDO
         CLOSE(dUnit)

        ENDDO
       ENDDO

      ELSE
C--   Write local array:
         iG=biArg+(myXGlobalLo-1)/sNx
         jG=bjArg+(myYGlobalLo-1)/sNy

         IF ( myIter.GE.0 ) THEN
           WRITE( fullName, '(2A,I10.10,2(A,I3.3),A)' )
     &      fnam(s1Lo:s1Hi),'.',myIter,'.',iG,'.',jG,'.data'
         ELSE
           WRITE( fullName, '(A,2(A,I3.3),A)' )
     &      fnam(s1Lo:s1Hi),'.',iG,'.',jG,'.data'
         ENDIF

c        OPEN( dUnit, file=fullName, status='unknown',
c    &         form='unformatted')
c        WRITE(dUnit) ((( fld(i,j,k,1,1),
c    &                       i=1-OLx,sNx+OLx),
c    &                       j=1-OLy,sNy+OLy),
c    &                       k=1,kSize)
         length_of_rec = MDS_RECLEN(
     &                   filePrec, (sNx+2*OLx)*(sNy+2*OLy), myThid )
         OPEN( dUnit, file=fullName, status='unknown',
     &         access='direct', recl=length_of_rec )
         DO k = 1,kSize
           kRec = k + (iRec-1)*kSize
           WRITE(dUnit,rec=kRec) (( fld(i,j,k,1,1),
     &                                i=1-OLx,sNx+OLx),
     &                                j=1-OLy,sNy+OLy )
         ENDDO
         CLOSE(dUnit)

      ENDIF

      _END_MASTER( myThid )

      RETURN
      END

#include "FLT_OPTIONS.h"

      SUBROUTINE FLT_INIT_FIXED( myThid  )

C     ==================================================================
C     SUBROUTINE FLT_INIT_FIXED
C     ==================================================================
C     o initializes Fixed array
C     ==================================================================

C     !USES:
      IMPLICIT NONE

#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#ifdef ALLOW_EXCH2
#include "W2_EXCH2_SIZE.h"
#include "W2_EXCH2_PARAMS.h"
#endif
#include "FLT_SIZE.h"
#include "FLT.h"

C     == routine arguments ==
C     myThid - thread number for this instance of the routine.
      INTEGER myThid

C     == local variables ==
      INTEGER bi, bj
      _RL xLo, xHi, yLo, yHi
      CHARACTER*(MAX_LEN_MBUF) msgBuf

C     == end of interface ==

C Set domain dependent constants:
      xLo = -xG( 1,  1,1,1)
      xHi = xG(sNx+1,1,1,1)
      yLo = -yG(1, 1,  1,1)
      yHi = yG(1,sNy+1,1,1)
      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
         xLo = MAX( xLo, -xG(1,1,bi,bj) )
         xHi = MAX( xHi, xG(sNx+1,1,bi,bj) )
         yLo = MAX( yLo, -yG(1,1,bi,bj) )
         yHi = MAX( yHi, yG(1,sNy+1,bi,bj) )
       ENDDO
      ENDDO
      _GLOBAL_MAX_RL( xLo, myThid )
      _GLOBAL_MAX_RL( xHi, myThid )
      _GLOBAL_MAX_RL( yLo, myThid )
      _GLOBAL_MAX_RL( yHi, myThid )

      _BEGIN_MASTER(myThid)
       flt_xLo = -xLo
       flt_xHi =  xHi
       flt_yLo = -yLo
       flt_yHi =  yHi
       WRITE(msgBuf,'(A,2F18.8)')
     &    '  FLT_xLo,xHi=', xLo, xHi
         CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                       SQUEEZE_RIGHT, myThid )
         WRITE(msgBuf,'(A,2F18.8)')
     &    '  FLT_yLo,yHi=', yLo, yHi
         CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                       SQUEEZE_RIGHT, myThid )
      _END_MASTER(myThid)

#ifndef DEVEL_FLT_EXCH2
#ifdef ALLOW_EXCH2
        WRITE(msgBuf,'(2A)') 'FLT_INIT_FIXED:',
     &    ' exch2 is not yet fully supported in pkg/flt;'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(2A)') 'FLT_INIT_FIXED:',
     &    ' if you want to try using it anyway then recompile with'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(2A)') 'FLT_INIT_FIXED:',
     &    ' "#define DEVEL_FLT_EXCH2" added in FLT_OPTIONS.h'
        CALL PRINT_ERROR( msgBuf, myThid )
        STOP 'ABNORMAL END: S/R FLT_INIT_FIXED'
#endif
#endif

      RETURN
      END

#include "CPP_OPTIONS.h"

CBOP
C     !ROUTINE: FREESURF_RESCALE_G
C     !INTERFACE:
      SUBROUTINE FREESURF_RESCALE_G(
     I                     bi, bj, k,
     U                     gTracer,
     I                     myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R FREESURF_RESCALE_G
C     | o Re-scale Gs to account for change in free-surface
C     |   hieght. Only meaningful with non-linear free-surface.
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     == Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "SURFACE.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine Arguments ==
      INTEGER bi,bj,k
      _RL  gTracer(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      INTEGER myThid
#ifdef NONLIN_FRSURF
C     == Local variables ==
      INTEGER i,j
CEOP

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      IF ( nonlinFreeSurf.GT.0 ) THEN
       IF ( select_rStar.GT.0 ) THEN
# ifndef DISABLE_RSTAR_CODE
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
           gTracer(i,j,k) = gTracer(i,j,k)
     &                    / rStarExpC(i,j,bi,bj)
         ENDDO
        ENDDO
# endif /* DISABLE_RSTAR_CODE */
       ELSEIF ( selectSigmaCoord.NE.0 ) THEN
# ifndef DISABLE_SIGMA_CODE
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
           gTracer(i,j,k) = gTracer(i,j,k)
     &        /( 1. _d 0 + dEtaHdt(i,j,bi,bj)*deltaTFreeSurf
     &                    *dBHybSigF(k)*recip_drF(k)
     &                    *recip_hFacC(i,j,k,bi,bj)
     &         )
         ENDDO
        ENDDO
# endif /* DISABLE_SIGMA_CODE */
       ELSE
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          IF (k.EQ.kSurfC(i,j,bi,bj)) THEN
           gTracer(i,j,k) = gTracer(i,j,k)
     &            *_hFacC(i,j,k,bi,bj)/hFac_surfC(i,j,bi,bj)
          ENDIF
         ENDDO
        ENDDO
       ENDIF
      ENDIF

#endif /* NONLIN_FRSURF */

      RETURN
      END

#include "CPP_OPTIONS.h"

CBOP
C     !ROUTINE: ADAMS_BASHFORTH3
C     !INTERFACE:
      SUBROUTINE ADAMS_BASHFORTH3(
     I                     bi, bj, kArg, kSize,
     U                     gTracer, gTrNm,
     O                     AB_gTr,
     I                     startAB, myIter, myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R ADAMS_BASHFORTH3
C     | o Extrapolate forward in time using third order
C     |   Adams-Bashforth method.
C     *==========================================================*
C     | Either apply to tendency (kArg>0) at level k=kArg,
C     |     or apply to state variable (kArg=0) for all levels
C     *==========================================================*
C     \ev
C Extrapolate forward in time using 2 A.B. parameters (alpha,beta),
C either tendency gX :
C \begin{equation*}
C gX^{n+1/2} = (1 + \alpha + \beta) gX^{n}
C              - (\alpha + 2 \beta) gX^{n-1}
C                          + \beta  gX^{n-2}
C \end{equation*}
C     or state variable X :
C \begin{equation*}
C  X^{n+1/2} = (1 + \alpha + \beta) X^{n}
C              - (\alpha + 2 \beta) X^{n-1}
C                          + \beta  X^{n-2}
C \end{equation*}
C with:
C (alpha,beta)=(1/2,5/12) : AB-3, stable until CFL = 0.724
C     (note: beta=0.281105 give the Max stability: 0.78616)
C (alpha,beta)=(1/2+abEps,0) : return to previous quasi AB-2.
C (alpha,beta)=(0,0)         : 1rst.Order forward time stepping

C     !USES:
      IMPLICIT NONE
C     == Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine Arguments ==
C     bi,bj   :: Tile indices
C     kArg    :: if >0: apply AB on tendency at level k=kArg
C             :: if =0: apply AB on state variable and process all levels
C     kSize   :: 3rd dimension of gTracer
C     gTracer ::  in: Tendency/State at current time
C             :: out(kArg >0): Extrapolated Tendency at current time
C     gTrNm   ::  in: Tendency/State at previous time
C             :: out(kArg >0): Save tendency at current time
C             :: out(kArg =0): Extrapolated State at current time
C     AB_gTr  :: Adams-Bashforth tendency increment
C     startAB :: number of previous time level available to start/restart AB
C     myIter  :: Current time step number
C     myThid  :: my Thread Id. number
      INTEGER bi, bj, kArg, kSize
      _RL  gTracer(1-OLx:sNx+OLx,1-OLy:sNy+OLy,kSize)
      _RL  gTrNm  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy,2)
      _RL  AB_gTr (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER startAB
      INTEGER myIter, myThid

#ifdef ALLOW_ADAMSBASHFORTH_3
C     !LOCAL VARIABLES:
C     == Local variables ==
C     i, j        :: Loop counters
C     k, kl       :: level indices
C     m1,m2       :: indices for the 2 previous time-step Tendency
C     ab1,ab2,ab3 :: Adams bashforth extrapolation weights.
      INTEGER i,j, k, kl, m1,m2
      _RL ab0, ab1, ab2
CEOP

      m1 = 1 + MOD(myIter+1,2)
      m2 = 1 + MOD( myIter ,2)

C     Adams-Bashforth timestepping weights
      IF ( myIter.EQ.nIter0 .AND. startAB.EQ.0 ) THEN
       ab0 = 0. _d 0
       ab1 = 0. _d 0
       ab2 = 0. _d 0
      ELSEIF ( (myIter.EQ.nIter0   .AND. startAB.EQ.1)
     &    .OR. (myIter.EQ.1+nIter0 .AND. startAB.EQ.0) ) THEN
       ab0 =  alph_AB
       ab1 = -alph_AB
       ab2 = 0. _d 0
      ELSE
       ab0 =  alph_AB + beta_AB
       ab1 = -alph_AB - 2.*beta_AB
       ab2 =  beta_AB
      ENDIF

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      IF ( kArg.EQ.0 ) THEN
C-    Extrapolate forward in time the state variable, with AB weights:
        DO k=1,kSize
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           AB_gTr(i,j) = ab0*gTracer(i,j,k)
     &                 + ab1*gTrNm(i,j,k,bi,bj,m1)
     &                 + ab2*gTrNm(i,j,k,bi,bj,m2)
           gTrNm(i,j,k,bi,bj,m2) = gTracer(i,j,k) + AB_gTr(i,j)
          ENDDO
         ENDDO
        ENDDO
      ELSE
C-    Extrapolate forward in time the tendency, with AB weights:
        kl = kArg
        k = MIN( kArg, kSize )
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
           AB_gTr(i,j) = ab0*gTracer(i,j,k)
     &                 + ab1*gTrNm(i,j,kl,bi,bj,m1)
     &                 + ab2*gTrNm(i,j,kl,bi,bj,m2)
           gTrNm(i,j,kl,bi,bj,m2) = gTracer(i,j,k)
           gTracer(i,j,k) = gTracer(i,j,k) + AB_gTr(i,j)
         ENDDO
        ENDDO
C---
      ENDIF

#endif /* ALLOW_ADAMSBASHFORTH_3 */

      RETURN
      END

#include "CTRL_OPTIONS.h"

CBOP
C     !ROUTINE: CTRL_SET_FNAME
C     !INTERFACE:
      SUBROUTINE CTRL_SET_FNAME( xx_fname, fname, myThid )

C     !DESCRIPTION:
C     ==================================================================
C     SUBROUTINE CTRL_SET_FNAME
C     ==================================================================
C     o get filename for control variable and adjoint thereof
C     started: heimbach@mit.edu, 16-Aug-2001
C     ==================================================================

C     !USES:
      IMPLICIT NONE

C     == global variables ==
#include "EEPARAMS.h"
#include "SIZE.h"
#include "PARAMS.h"
#include "CTRL_SIZE.h"
#include "CTRL.h"
#include "OPTIMCYCLE.h"

C     !INPUT/OUTPUT PARAMETERS
      CHARACTER*(*) xx_fname
      CHARACTER*(MAX_LEN_FNAM) fname(3)
      INTEGER myThid

C     !FUNCTIONS:
      INTEGER  ILNBLNK
      EXTERNAL ILNBLNK

C     !LOCAL VARIABLES:
      INTEGER il, ic, l
CEOP

      il = ILNBLNK( xx_fname )

      IF ( il .GT. 0 .AND. (il+13) .LE. MAX_LEN_FNAM ) THEN
        ic = 0
        l = il
        DO WHILE ( ic .EQ. 0 .AND. l .GE. 1 )
          IF ( xx_fname(l:l) .EQ. '/' ) ic = l
          l = l -1
        ENDDO

        WRITE(fname(1),'(2A,I10.10)')
     &        xx_fname(1:il), '.', optimcycle
        WRITE(fname(2),'(4A,I10.10)')
     &        xx_fname(1:ic), yadprefix, xx_fname(ic+1:il), '.',
     &        optimcycle
        WRITE(fname(3),'(4A,I10.10)')
     &        xx_fname(1:ic), 'hn', xx_fname(ic+1:il), '.',
     &        optimcycle

      ELSE
        STOP 'ABNORMAL END: S/R CTRL_SET_FNAME'
      ENDIF

      RETURN
      END

#include "PACKAGES_CONFIG.h"
#include "CPP_OPTIONS.h"

CBOP
C     !ROUTINE: FORCING_SURF_RELAX
C     !INTERFACE:
      SUBROUTINE FORCING_SURF_RELAX(
     I                   iMin, iMax, jMin, jMax,
     I                   myTime, myIter, myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE FORCING_SURF_RELAX
C     | o Calculate relaxation surface forcing terms
C     |   for temperature and salinity
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "FFIELDS.h"
#include "DYNVARS.h"
#include "GRID.h"
#include "SURFACE.h"
#ifdef ALLOW_SEAICE
# include "SEAICE_SIZE.h"
# include "SEAICE_PARAMS.h"
# include "SEAICE.h"
#endif /* ALLOW_SEAICE */

C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
C     iMin,iMax, jMin,jMax :: Range of points for calculation
C     myTime  :: Current time in simulation
C     myIter  :: Current iteration number in simulation
C     myThid  :: Thread no. that called this routine.
      INTEGER iMin, iMax
      INTEGER jMin, jMax
      _RL myTime
      INTEGER myIter
      INTEGER myThid

C     !LOCAL VARIABLES:
C     === Local variables ===
C     bi,bj  :: tile indices
C     i,j    :: loop indices
C     ks     :: index of surface interface layer
      INTEGER bi,bj
      INTEGER i,j
      INTEGER ks
CEOP
#ifdef ALLOW_DIAGNOSTICS
      _RL tmpFac
#endif /* ALLOW_DIAGNOSTICS */
#ifdef ALLOW_BALANCE_RELAX
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      _RL sumTile(nSx,nSy), sumGlob, globAver
#endif /* ALLOW_BALANCE_RELAX */

      IF ( usingPCoords ) THEN
       ks        = Nr
      ELSE
       ks        = 1
      ENDIF

      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#ifdef ALLOW_SEAICE
       IF ( useSEAICE .AND. (.NOT. SEAICErestoreUnderIce) ) THEN
C     Do not restore under sea-ice
        DO j = jMin, jMax
         DO i = iMin, iMax
C     Heat Flux (restoring term) :
          surfaceForcingT(i,j,bi,bj) =
     &      -lambdaThetaClimRelax(i,j,bi,bj)*(1.-AREA(i,j,bi,bj))
     &         *(theta(i,j,ks,bi,bj)-SST(i,j,bi,bj))
     &         *drF(ks)*_hFacC(i,j,ks,bi,bj)
C     Salt Flux (restoring term) :
          surfaceForcingS(i,j,bi,bj) =
     &      -lambdaSaltClimRelax(i,j,bi,bj) *(1.-AREA(i,j,bi,bj))
     &         *(salt(i,j,ks,bi,bj)-SSS(i,j,bi,bj))
     &         *drF(ks)*_hFacC(i,j,ks,bi,bj)
         ENDDO
        ENDDO
       ELSE
#endif /* ALLOW_SEAICE */
        DO j = jMin, jMax
         DO i = iMin, iMax
C     Heat Flux (restoring term) :
          surfaceForcingT(i,j,bi,bj) =
     &      -lambdaThetaClimRelax(i,j,bi,bj)
     &         *(theta(i,j,ks,bi,bj)-SST(i,j,bi,bj))
     &         *drF(ks)*_hFacC(i,j,ks,bi,bj)
C     Salt Flux (restoring term) :
          surfaceForcingS(i,j,bi,bj) =
     &      -lambdaSaltClimRelax(i,j,bi,bj)
     &         *(salt(i,j,ks,bi,bj)-SSS(i,j,bi,bj))
     &         *drF(ks)*_hFacC(i,j,ks,bi,bj)
         ENDDO
        ENDDO
#ifdef ALLOW_SEAICE
       ENDIF
#endif /* ALLOW_SEAICE */

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
#ifdef NONLIN_FRSURF
C-    T,S surface forcing will be applied (thermodynamics) after the update
C     of surf.thickness (hFac): account for change in surf.thickness
       IF (staggerTimeStep.AND.nonlinFreeSurf.GT.0) THEN
        IF ( select_rStar.GT.0 ) THEN
# ifndef DISABLE_RSTAR_CODE
         DO j=jMin,jMax
          DO i=iMin,iMax
            surfaceForcingT(i,j,bi,bj) = surfaceForcingT(i,j,bi,bj)
     &                                  * rStarExpC(i,j,bi,bj)
            surfaceForcingS(i,j,bi,bj) = surfaceForcingS(i,j,bi,bj)
     &                                  * rStarExpC(i,j,bi,bj)
          ENDDO
         ENDDO
# endif /* DISABLE_RSTAR_CODE */
        ELSEIF ( selectSigmaCoord.NE.0 ) THEN
# ifndef DISABLE_SIGMA_CODE
         DO j=jMin,jMax
          DO i=iMin,iMax
            surfaceForcingT(i,j,bi,bj) = surfaceForcingT(i,j,bi,bj)
     &        *( 1. _d 0 + dEtaHdt(i,j,bi,bj)*deltaTFreeSurf
     &                    *dBHybSigF(ks)*recip_drF(ks)
     &                    *recip_hFacC(i,j,ks,bi,bj)
     &         )
            surfaceForcingS(i,j,bi,bj) = surfaceForcingS(i,j,bi,bj)
     &        *( 1. _d 0 + dEtaHdt(i,j,bi,bj)*deltaTFreeSurf
     &                    *dBHybSigF(ks)*recip_drF(ks)
     &                    *recip_hFacC(i,j,ks,bi,bj)
     &         )
          ENDDO
         ENDDO
# endif /* DISABLE_SIGMA_CODE */
        ELSE
         DO j=jMin,jMax
          DO i=iMin,iMax
           IF (ks.EQ.kSurfC(i,j,bi,bj)) THEN
            surfaceForcingT(i,j,bi,bj) = surfaceForcingT(i,j,bi,bj)
     &             *_recip_hFacC(i,j,ks,bi,bj)*hFac_surfC(i,j,bi,bj)
            surfaceForcingS(i,j,bi,bj) = surfaceForcingS(i,j,bi,bj)
     &             *_recip_hFacC(i,j,ks,bi,bj)*hFac_surfC(i,j,bi,bj)
           ENDIF
          ENDDO
         ENDDO
        ENDIF
       ENDIF
#endif /* NONLIN_FRSURF */

C--   end bi,bj loops.
       ENDDO
      ENDDO

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#ifdef ALLOW_BALANCE_RELAX

      IF ( balanceThetaClimRelax ) THEN
        DO bj=myByLo(myThid),myByHi(myThid)
         DO bi=myBxLo(myThid),myBxHi(myThid)
          sumTile(bi,bj) = 0. _d 0
          DO j=1,sNy
           DO i=1,sNx
             sumTile(bi,bj) = sumTile(bi,bj)
     &                      + surfaceForcingT(i,j,bi,bj)
     &                       *rA(i,j,bi,bj)*maskInC(i,j,bi,bj)
           ENDDO
          ENDDO
         ENDDO
        ENDDO
        CALL GLOBAL_SUM_TILE_RL( sumTile, sumGlob, myThid )
        globAver = sumGlob
        IF ( globalArea.GT.zeroRL ) globAver = globAver / globalArea
        DO bj=myByLo(myThid),myByHi(myThid)
         DO bi=myBxLo(myThid),myBxHi(myThid)
          DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
             surfaceForcingT(i,j,bi,bj) = surfaceForcingT(i,j,bi,bj)
     &                                  - globAver
           ENDDO
          ENDDO
         ENDDO
        ENDDO
        IF ( balancePrintMean ) THEN
         _BEGIN_MASTER( myThid )
         WRITE(msgBuf,'(2A,1PE21.14,A,I10)') 'rm Global mean of',
     &                ' SSTrelax= ', globAver, '  @ it=', myIter
         CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                       SQUEEZE_RIGHT, myThid )
         _END_MASTER( myThid )
        ENDIF
      ENDIF

      IF ( balanceSaltClimRelax ) THEN
        DO bj=myByLo(myThid),myByHi(myThid)
         DO bi=myBxLo(myThid),myBxHi(myThid)
          sumTile(bi,bj) = 0. _d 0
          DO j=1,sNy
           DO i=1,sNx
             sumTile(bi,bj) = sumTile(bi,bj)
     &                      + surfaceForcingS(i,j,bi,bj)
     &                       *rA(i,j,bi,bj)*maskInC(i,j,bi,bj)
           ENDDO
          ENDDO
         ENDDO
        ENDDO
        CALL GLOBAL_SUM_TILE_RL( sumTile, sumGlob, myThid )
        globAver = sumGlob
        IF ( globalArea.GT.zeroRL ) globAver = globAver / globalArea
        DO bj=myByLo(myThid),myByHi(myThid)
         DO bi=myBxLo(myThid),myBxHi(myThid)
          DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
             surfaceForcingS(i,j,bi,bj) = surfaceForcingS(i,j,bi,bj)
     &                                  - globAver
           ENDDO
          ENDDO
         ENDDO
        ENDDO
        IF ( balancePrintMean ) THEN
         _BEGIN_MASTER( myThid )
         WRITE(msgBuf,'(2A,1PE21.14,A,I10)') 'rm Global mean of',
     &                ' SSSrelax= ', globAver, '  @ it=', myIter
         CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                       SQUEEZE_RIGHT, myThid )
         _END_MASTER( myThid )
        ENDIF
      ENDIF

#endif /* ALLOW_BALANCE_RELAX */

#ifdef ALLOW_DIAGNOSTICS
      IF ( useDiagnostics ) THEN

C     tRelax (temperature relaxation [W/m2], positive <-> increasing Theta)
        tmpFac = HeatCapacity_Cp*rUnit2mass
        CALL DIAGNOSTICS_SCALE_FILL( surfaceForcingT, tmpFac, 1,
     &                              'TRELAX  ', 0, 1, 0,1,1, myThid )

C     sRelax (salt relaxation [g/m2/s], positive <-> increasing Salt)
        tmpFac = rUnit2mass
        CALL DIAGNOSTICS_SCALE_FILL( surfaceForcingS, tmpFac, 1,
     &                              'SRELAX  ', 0, 1, 0,1,1, myThid )

      ENDIF
#endif /* ALLOW_DIAGNOSTICS */

      RETURN
      END

#undef ALLOW_AIM_TAVE
#include "AIM_OPTIONS.h"

CBOP
C     !ROUTINE: AIM_READPARMS
C     !INTERFACE:
      SUBROUTINE AIM_READPARMS( myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R AIM_READPARMS
C     | o Read AIM physics package parameters
C     *==========================================================*
C     | Initialized parameter in common blocks:
C     |  FORCON, SFLCON, CNVCON, LSCCON, RADCON, VDICON
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     == Global variables ===
#include "AIM_SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "AIM_PARAMS.h"
#include "AIM_CO2.h"
#ifdef ALLOW_MNC
#include "MNC_PARAMS.h"
#endif

C-   Physical constants + functions of sigma and latitude
c #include "com_physcon.h"
C-   Constants for sub-grid-scale physics
#include "com_forcon.h"
#include "com_sflcon.h"
#include "com_cnvcon.h"
#include "com_lsccon.h"
#include "com_radcon.h"
#include "com_vdicon.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine Arguments ==
C     myThid :: my Thread Id number
      INTEGER myThid
CEOP

#ifdef ALLOW_AIM

C     == Local Variables ==
C     msgBuf         :: Informational/error message buffer
C     iUnit          :: Work variable for IO unit number
C     errCount       :: error counter
C     aim_fixed_pCO2 :: fixed and uniform pCO2 value for AIM radiation
C     atmpCO2init    :: Atmospheric pCO2 initial value of well-mixed atm. box
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      CHARACTER*10 endList
      INTEGER buffI(1)
      INTEGER iUnit
      INTEGER errCount
      _RL aim_fixed_pCO2
      _RL atmpCO2init
C-    retired parameters:
C     aim_taveFreq :: retired; Frequency^-1 for time-average output (s)
      _RL aim_taveFreq
      LOGICAL aim_timeave_mnc

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C--   AIM interface parameter (common AIM_PARM_?):
C     aim_useFMsurfBC :: select surface B.C. from Franco Molteni
C     aim_useMMsurfFc :: select Monthly Mean surface forcing (e.g., NCEP)
C     aim_surfForc_TimePeriod :: Length of forcing time period (e.g. 1 month)
C     aim_surfForc_NppCycle   :: Number of time period per Cycle (e.g. 12)
C     aim_surfForc_TransRatio :: transition ratio from one month to the next
C     aim_surfPotTemp :: surf.Temp input file is in Pot.Temp (aim_useMMsurfFc)
C     aim_energPrecip :: account for energy of precipitation (snow & rain temp)
C     aim_splitSIOsFx :: compute separately Sea-Ice & Ocean surf. Flux
C                 (also land SW & LW) ; default=F as in original version
C     aim_MMsufx   :: sufix for all Monthly Mean surface forcing files
C     aim_MMsufxLength :: Length of sufix (Monthly Mean surf. forc. files)
C     aim_LandFile :: file name for Land fraction       (F.M. surfBC)
C     aim_albFile  :: file name for Albedo input file   (F.M. surfBC)
C     aim_vegFile  :: file name for vegetation fraction (F.M. surfBC)
C     aim_sstFile  :: file name for  Sea.Surf.Temp      (F.M. surfBC)
C     aim_lstFile  :: file name for Land.Surf.Temp      (F.M. surfBC)
C     aim_oiceFile :: file name for Sea Ice fraction    (F.M. surfBC)
C     aim_snowFile :: file name for Snow depth          (F.M. surfBC)
C     aim_swcFile  :: file name for Soil Water content  (F.M. surfBC)
C     aim_dragStrato  :: stratospheric-drag damping time scale (s)
C     aim_select_pCO2 :: select AIM CO2 formulation (= 0,1,2 or 3)
C     aim_selectOceAlbedo :: Ocean albedo(latitude) scheme (integer)
C                     :: 0 = constant (default); 1 = Briegleb et al. 1986
C     aim_clrSkyDiag :: compute clear-sky radiation for diagnostics
C     aim_diagFreq :: Frequency^-1 for diagnostic output (s)
C     aim_tendFreq :: Frequency^-1 for tendencies output (s)
      NAMELIST /AIM_PARAMS/
     &    aim_useFMsurfBC, aim_useMMsurfFc,
     &    aim_surfForc_TimePeriod, aim_surfForc_NppCycle,
     &    aim_surfForc_TransRatio, aim_surfPotTemp,
     &    aim_energPrecip, aim_splitSIOsFx,
     &    aim_MMsufx, aim_MMsufxLength,
     &    aim_LandFile, aim_albFile, aim_vegFile,
     &    aim_sstFile, aim_lstFile, aim_oiceFile, aim_snowFile,
     &    aim_swcFile, aim_qfxFile,
     &    aim_dragStrato, aim_selectOceAlbedo,
     &    aim_select_pCO2, aim_abs_pCO2, aim_fixed_pCO2, atmpCO2init,
     &    aim_clrSkyDiag, aim_taveFreq, aim_diagFreq, aim_tendFreq,
     &    aim_timeave_mnc, aim_snapshot_mnc,
     &    aim_pickup_write_mnc, aim_pickup_read_mnc

C--   Physical constants (common PHYCON) :
C       P0    = reference pressure                 [Pa=N/m2]
C       GG    = gravity accel.                     [m/s2]
C       RD    = gas constant for dry air           [J/kg/K]
C       CP    = specific heat at constant pressure [J/kg/K]
C       ALHC  = latent heat of condensation        [J/g]
C       ALHF  = latent heat of freezing            [J/g]
C       SBC   = Stefan-Boltzmann constant
C     rainCP  = heat capacity of liquid water      [J/g/K]
C     tFreeze = freezing temperature of pure water [K]

C--   Constants for forcing fields (common FORCON) :
C      SOLC   = Solar constant (area averaged) in W/m^2
C      OBLIQ  = Obliquity (in degree) only used if #define ALLOW_INSOLATION
C      ALBSEA = Albedo over sea
C      ALBICE = Albedo over sea ice (for ice fraction = 1)
C      ALBSN  = Albedo over snow (for snow depth > SDALB)
C      SDALB  = Snow depth (mm water) corresponding to maximum albedo
C      SWCAP  = Soil wetness at field capacity (volume fraction)
C      SWWIL  = Soil wetness at wilting point  (volume fraction)
C      hSnowWetness :: snow depth (m) corresponding to maximum wetness
      NAMELIST /AIM_PAR_FOR/
     &    SOLC, ALBSEA, ALBICE, ALBSN,
     &    SDALB, SWCAP, SWWIL, hSnowWetness, OBLIQ

C--   Constants for surface fluxes (common SFLCON) :
C      FWIND0 = ratio of near-sfc wind to lowest-level wind
C      FTEMP0 = weight for near-sfc temperature extrapolation (0-1) :
C               1 : linear extrapolation from two lowest levels
C               0 : constant potential temperature ( = lowest level)
C      FHUM0  = weight for near-sfc specific humidity extrapolation (0-1) :
C               1 : extrap. with constant relative hum. ( = lowest level)
C               0 : constant specific hum. ( = lowest level)
C      CDL    = drag coefficient for momentum over land
C      CDS    = drag coefficient for momentum over sea
C      CHL    = heat exchange coefficient over land
C      CHS    = heat exchange coefficient over sea
C      VGUST  = wind speed for sub-grid-scale gusts
C      CTDAY  = daily-cycle correction (dTskin/dSSRad)
C      DTHETA = Potential temp. gradient for stability correction
C      dTstab = potential temp. increment for stability function derivative
C      FSTAB  = Amplitude of stability correction (fraction)
C      HDRAG  = Height scale for orographic correction
C      FHDRAG = Amplitude of orographic correction (fraction)
      NAMELIST /AIM_PAR_SFL/
     &    FWIND0, FTEMP0, FHUM0,
     &    CDL, CDS, CHL, CHS, VGUST, CTDAY,
     &    DTHETA, dTstab, FSTAB, HDRAG, FHDRAG

C--   Convection constants (common CNVCON) :
C      PSMIN  = minimum (norm.) sfc. pressure for the occurrence of convection
C      TRCNV  = time of relaxation (in hours) towards reference state
C      QBL    = specific hum. threshold in the boundary layer
C      RHBL   = relative hum. threshold in the boundary layer
C      RHIL   = rel. hum. threshold in intermed. layers for secondary mass flux
C      ENTMAX = max. entrainment as a fraction of cloud-base mass flux
C      SMF    = ratio between secondary and primary mass flux at cloud-base
      NAMELIST /AIM_PAR_CNV/
     &    PSMIN, TRCNV, QBL, RHBL, RHIL, ENTMAX, SMF

C--   Constants for large-scale condendation (common LSCCON) :
C      TRLSC  = Relaxation time (in hours) for specific humidity
C      RHLSC  = Maximum relative humidity threshold (at sigma=1)
C      DRHLSC = Vertical range of relative humidity threshold
C      QSMAX  = used to define the maximum latent heat release
      NAMELIST /AIM_PAR_LSC/
     &    TRLSC, RHLSC, DRHLSC, QSMAX

C--    Radiation constants (common RADCON) :
C      RHCL1  = relative hum. corresponding to cloud cover = 0
C      RHCL2  = relative hum. corresponding to cloud cover = 1
C      QACL1  = specific hum. threshold for cloud cover in the upper troposphere
C      QACL2  = specific hum. threshold for cloud cover in the upper troposphere
C      ALBCL  = cloud albedo (for cloud cover = 1)
C      EPSSW  = fraction of incoming solar radiation absorbed by ozone
C      EPSLW  = fraction of surface LW radiation emitted directly to space
C      EMISFC = longwave surface emissivity
C--:            shortwave absorptivities (for dp = 10^5 Pa) :
C      ABSDRY = abs. of dry air      (visible band)
C      ABSAER = abs. of aerosols     (visible band)
C      ABSWV1 = abs. of water vapour (visible band, for dq = 1 g/kg)
C      ABSWV2 = abs. of water vapour (near IR band, for dq = 1 g/kg)
C      ABSCL1 = abs. of clouds       (visible band, constant term)
C      ABSCL2 = abs. of clouds       (visible band, for dw = 1 g/kg)
C--:            longwave absorptivities (per dp = 10^5 Pa) :
C      ABLWIN = abs. of air in "window" band
C      ABLCO2 = abs. of air in CO2 band
C      ABLWV1 = abs. of water vapour in H2O band 1 (weak),   for dq = 1 g/kg
C      ABLWV2 = abs. of water vapour in H2O band 2 (strong), for dq = 1 g/kg
C      ABLCL1 = abs. of clouds       in "window" band,       constant term
C      ABLCL2 = abs. of clouds       in "window" band,       for dw = 1 g/kg
      NAMELIST /AIM_PAR_RAD/
     &    RHCL1,  RHCL2,  QACL1,  QACL2,  ALBCL,
     &    EPSSW,  EPSLW,  EMISFC,
     &    ABSDRY, ABSAER, ABSWV1, ABSWV2, ABSCL1, ABSCL2,
     &    ABLWIN, ABLCO2, ABLWV1, ABLWV2, ABLCL1, ABLCL2

C--   Constants for vertical dif. and sh. conv. (common VDICON) :
C      TRSHC  = relaxation time (in hours) for shallow convection
C      TRVDI  = relaxation time (in hours) for moisture diffusion
C      TRVDS  = relaxation time (in hours) for super-adiab. conditions
C      RHGRAD = maximum gradient of relative humidity (d_RH/d_sigma)
C      SEGRAD = minimum gradient of dry static energy (d_DSE/d_phi)
      NAMELIST /AIM_PAR_VDI/
     &    TRSHC, TRVDI, TRVDS, RHGRAD, SEGRAD

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      _BEGIN_MASTER(myThid)

C--  Set default value for AIM interface code (AIM_PARAMS.h):
      aim_useFMsurfBC = .TRUE.
      aim_useMMsurfFc = .FALSE.
      aim_surfPotTemp = .FALSE.
      aim_energPrecip = .FALSE.
      aim_splitSIOsFx = .FALSE.
      aim_clrSkyDiag  = .FALSE.
#ifdef ALLOW_MNC
      aim_snapshot_mnc      = snapshot_mnc .AND. useMNC
      aim_pickup_write_mnc  = pickup_write_mnc .AND. useMNC
      aim_pickup_read_mnc   = pickup_read_mnc .AND. useMNC
#else
      aim_snapshot_mnc      = .FALSE.
      aim_pickup_write_mnc  = .FALSE.
      aim_pickup_read_mnc   = .FALSE.
#endif
      aim_MMsufx = '.bin'
      aim_MMsufxLength = 4
C-    Length (s) of one time period:
      aim_surfForc_TimePeriod = 30.*86400.
C-    Number of time period per Cycle:
      aim_surfForc_NppCycle   = 12
C-    define how fast the (linear) transition is from one month to the next
C      = 1                 -> linear between 2 midle month
C      > TimePeriod/deltaT -> jump from one month to the next one
      aim_surfForc_TransRatio = 1.
      aim_LandFile = ' '
      aim_albFile  = ' '
      aim_vegFile  = ' '
      aim_sstFile  = ' '
      aim_lstFile  = ' '
      aim_oiceFile = ' '
      aim_snowFile = ' '
      aim_swcFile  = ' '
      aim_qfxFile  = ' '
      aim_dragStrato = 0.
      aim_selectOceAlbedo = 0
      aim_select_pCO2 = 0
      aim_ref_pCO2   = 320. _d -6
C- Note: aim_abs_pCO2 default value has been calibrated (David Ferreira)
C        for pCO2 values within [ 100.ppm, 1000.ppm ]
      aim_abs_pCO2   = 1.2616 _d 0
      aim_fixed_pCO2 = UNSET_RL
      atmpCO2init    = UNSET_RL
C-
      aim_diagFreq = dumpFreq
      aim_tendFreq = 0.
      OBLIQ = 23.45 _d 0

C-    retired params default:
      aim_taveFreq    = UNSET_RL
      aim_timeave_mnc = .FALSE.

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      WRITE(msgBuf,'(A)') ' AIM_READPARMS: opening data.aimphys'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )

      CALL OPEN_COPY_DATA_FILE( 'data.aimphys', 'AIM_READPARMS',
     O                          iUnit, myThid )

C--   Read parameters from open data file:

C-    Parameters for AIM interface code:
      READ(UNIT=iUnit,NML=AIM_PARAMS)

C-    Constants for boundary forcing
      READ(UNIT=iUnit,NML=AIM_PAR_FOR)

C-    Constants for surface fluxes
      READ(UNIT=iUnit,NML=AIM_PAR_SFL)

C-    Constants for convection
      READ(UNIT=iUnit,NML=AIM_PAR_CNV)

C-    Constants for large-scale condensation
      READ(UNIT=iUnit,NML=AIM_PAR_LSC)

C-    Constants for radiation
      READ(UNIT=iUnit,NML=AIM_PAR_RAD)

C-    Constants for vertical diffusion and sh. conv.
      READ(UNIT=iUnit,NML=AIM_PAR_VDI)

      WRITE(msgBuf,'(A)')
     &   ' AIM_READPARMS: finished reading data.aimphys'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )

C--   Close the open data file
#ifdef SINGLE_DISK_IO
      CLOSE(iUnit)
#else
      CLOSE(iUnit,STATUS='DELETE')
#endif /* SINGLE_DISK_IO */

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C--   Check parameters and model configuration
      errCount = 0

C-    Retired params:
      IF ( aim_taveFreq .NE. UNSET_RL ) THEN
        WRITE(msgBuf,'(2A)') 'AIM_READPARMS: ',
     &    '"aim_taveFreq" is no longer allowed in file "data.aimphys"'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(2A)') 'AIM_READPARMS: ',
     &    ' since "pkg/timeave" has been removed.'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF
      IF ( aim_timeave_mnc ) THEN
        WRITE(msgBuf,'(2A)') 'AIM_READPARMS: "aim_timeave_mnc"',
     &    ' is no longer allowed in file "data.aimphys"'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(2A)') 'AIM_READPARMS: ',
     &    ' since "pkg/timeave" has been removed.'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF
#ifdef ALLOW_AIM_TAVE
        WRITE(msgBuf,'(2A)') 'AIM_READPARMS: :'
     &    '#define ALLOW_AIM_TAVE not allowed in AIM_OPTIONS.h'
        CALL PRINT_ERROR( msgBuf, myThid)
        WRITE(msgBuf,'(2A)') 'AIM_READPARMS: :'
     &    ' since "pkg/timeave" has been removed.'
        CALL PRINT_ERROR( msgBuf, myThid)
        errCount = errCount + 1
#endif /* ALLOW_AIM_TAVE */

C-    Consistency check:
      IF ( aim_select_pCO2.LT.0 .OR. aim_select_pCO2.GT.3 ) THEN
        WRITE(msgBuf,'(2A)') 'AIM_READPARMS: ',
     &       'Invalid value for "aim_select_pCO2"'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF
#ifndef ALLOW_AIM_CO2
      IF ( aim_select_pCO2.GE.2 .AND. aim_select_pCO2.LE.3 ) THEN
        WRITE(msgBuf,'(2A)') 'AIM_READPARMS: ',
     &       'aim_select_pCO2 > 1 but ALLOW_AIM_CO2 undef'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(2A)')
     &       'Re-compile with: #define ALLOW_AIM_CO2 (AIM_OPTIONS.h)'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF
#endif /* ndef ALLOW_AIM_CO2 */

      IF ( aim_fixed_pCO2.EQ.UNSET_RL ) THEN
        aim_fixed_pCO2 = aim_ref_pCO2
      ELSEIF ( aim_select_pCO2.NE.1 .AND.
     &         aim_select_pCO2.GE.0 .AND. aim_select_pCO2.LE.3 ) THEN
        WRITE(msgBuf,'(2A)') 'AIM_READPARMS: ',
     &       'aim_fixed_pCO2 only used if aim_select_pCO2=1'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF
      IF ( atmpCO2init.EQ.UNSET_RL ) THEN
        atmpCO2init = aim_ref_pCO2
      ELSEIF ( aim_select_pCO2.GE.0 .AND. aim_select_pCO2.LT.2 ) THEN
        WRITE(msgBuf,'(2A)') '** WARNING ** AIM_READPARMS: ',
     &       'atmpCO2init only used if aim_select_pCO2 > 1'
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
      ENDIF

#ifndef ALLOW_CLR_SKY_DIAG
C-    If aim_clrSkyDiag is set, then must compile the Clear-Sky Diagnostic code
      IF ( aim_clrSkyDiag ) THEN
        WRITE(msgBuf,'(2A)') 'AIM_READPARMS: ',
     &       'aim_clrSkyDiag=T but ALLOW_CLR_SKY_DIAG undef'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(2A)')
     &  'Re-compile with: #define ALLOW_CLR_SKY_DIAG (AIM_OPTIONS.h)'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF
#endif

#ifdef ALLOW_MNC
      aim_snapshot_mnc       = useMNC .AND. aim_snapshot_mnc
      aim_pickup_write_mnc   = useMNC .AND. aim_pickup_write_mnc
      aim_pickup_read_mnc    = useMNC .AND. aim_pickup_read_mnc
#else /* ALLOW_MNC */
      aim_snapshot_mnc       = .FALSE.
      aim_pickup_write_mnc   = .FALSE.
      aim_pickup_read_mnc    = .FALSE.
#endif /* ALLOW_MNC */
      aim_snapshot_mdsio     = (.NOT. aim_snapshot_mnc)
     &                     .OR. outputTypesInclusive
      aim_pickup_write_mdsio = (.NOT. aim_pickup_write_mnc)
     &                     .OR. outputTypesInclusive
      aim_pickup_read_mdsio  = (.NOT. aim_pickup_read_mnc)
     &                     .OR. outputTypesInclusive

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C--   Print out parameter values :
      iUnit = standardMessageUnit
      endList = '    ;     '

      WRITE(msgBuf,'(A)') ' '
      CALL PRINT_MESSAGE( msgBuf, iUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)') '// ==================================='
      CALL PRINT_MESSAGE( msgBuf, iUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)') '// AIM physics parameters :'
      CALL PRINT_MESSAGE( msgBuf, iUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)') '// ==================================='
      CALL PRINT_MESSAGE( msgBuf, iUnit, SQUEEZE_RIGHT, myThid )

       CALL WRITE_0D_L( useLand, INDEX_NONE,
     &                 'useLand =',
     &'   /* use Land package for surf.BC over land  */')

C- namelist AIM_PARAMS:
       CALL WRITE_0D_L( aim_useFMsurfBC, INDEX_NONE,
     &                 'aim_useFMsurfBC =',
     &'   /* F.Molteni surf. BC scheme on/off flag */')
       CALL WRITE_0D_L( aim_useMMsurfFc, INDEX_NONE,
     &                 'aim_useMMsurfFc =',
     &'   /* Monthly Mean surf. Forcing on/off flag */')
       CALL WRITE_0D_RL(aim_surfForc_TimePeriod, INDEX_NONE,
     &                 'aim_surfForc_TimePeriod =',
     &  ' /* Length of forcing time period (s) */')
       CALL WRITE_0D_I( aim_surfForc_NppCycle, INDEX_NONE,
     &                 'aim_surfForc_NppCycle   =',
     &  ' /* Number of time period per Cycle */')
       CALL WRITE_0D_RL(aim_surfForc_TransRatio, INDEX_NONE,
     &                 'aim_surfForc_TransRatio =',
     &  ' /* transition ratio from one month to the next */')
       CALL WRITE_0D_L( aim_surfPotTemp, INDEX_NONE,
     &                 'aim_surfPotTemp =',
     &'   /* Surf Temp file in Pot.Temp on/off flag */')
       CALL WRITE_0D_L( aim_energPrecip, INDEX_NONE,
     &                 'aim_energPrecip =',
     &  ' /* account for energy of precip. on/off flag */')
       CALL WRITE_0D_L( aim_splitSIOsFx, INDEX_NONE,
     &                 'aim_splitSIOsFx =',
     &  ' /* separate Sea-Ice & Ocean Flux on/off flag */')
       CALL WRITE_0D_RL(aim_dragStrato,INDEX_NONE,'aim_dragStrato=',
     &    ' /* stratospheric-drag damping time scale (s) */')
       CALL WRITE_0D_I( aim_selectOceAlbedo, INDEX_NONE,
     &  'aim_selectOceAlbedo =', ' /* Ocean albedo(latitude) flag */')
C-
       WRITE(msgBuf,'(2A)') 'aim_select_pCO2=',
     &              ' /* select AIM CO2 option */'
       CALL PRINT_MESSAGE( msgBuf, iUnit, SQUEEZE_RIGHT, myThid )
       buffI(1) = aim_select_pCO2
       CALL PRINT_LIST_I( buffI, 1, 1, INDEX_NONE,
     &                    .FALSE., .TRUE., iUnit )
       WRITE(msgBuf,'(2A)')
     &      '   =0: prescribed LW absorption in CO2 band (=ABLCO2)'
       CALL PRINT_MESSAGE( msgBuf, iUnit, SQUEEZE_RIGHT, myThid )
       WRITE(msgBuf,'(2A)')
     &      '   =1: absorption fct of prescribed pCO2 (=aim_fixed_pCO2)'
       CALL PRINT_MESSAGE( msgBuf, iUnit, SQUEEZE_RIGHT, myThid )
       WRITE(msgBuf,'(2A)')
     &      '   =2: same as 0 with passive,  well-mixed pCO2 atm box'
       CALL PRINT_MESSAGE( msgBuf, iUnit, SQUEEZE_RIGHT, myThid )
       WRITE(msgBuf,'(2A)')
     &      '   =3: same as 1 with evolving, well-mixed pCO2 atm-box'
       CALL PRINT_MESSAGE( msgBuf, iUnit, SQUEEZE_RIGHT, myThid )
       CALL PRINT_MESSAGE(endList, iUnit, SQUEEZE_RIGHT, myThid )
       IF ( aim_select_pCO2.EQ.1 .OR. aim_select_pCO2.EQ.3 )
     & CALL WRITE_0D_RL( aim_abs_pCO2, INDEX_NONE,
     &  'aim_abs_pCO2 =', ' /* pCO2 dep. coeff. of CO2 absortion */')
       IF ( aim_select_pCO2.EQ.1 )
     & CALL WRITE_0D_RL( aim_fixed_pCO2, INDEX_NONE,
     &  'aim_fixed_pCO2 =', ' /* fixed pCO2 for AIM radiation */')
#ifdef ALLOW_AIM_CO2
       CALL WRITE_0D_RL( atmpCO2init, INDEX_NONE,
     &  'atmpCO2init =', ' /* Initial atm-box pCO2 */')
#endif
       CALL WRITE_0D_L( aim_clrSkyDiag, INDEX_NONE,
     &                 'aim_clrSkyDiag =',
     &  ' /* do clear-sky radiation diagnostics */')
       CALL WRITE_0D_RL( aim_diagFreq, INDEX_NONE,'aim_diagFreq =',
     &  '   /* Frequency^-1 for diagnostic output (s) */')
       CALL WRITE_0D_RL( aim_tendFreq, INDEX_NONE,'aim_tendFreq =',
     &  '   /* Frequency^-1 for tendencies output (s) */')

C- namelist AIM_PAR_FOR:
       CALL WRITE_0D_RL( SOLC,  INDEX_NONE,'AIM_FOR:   SOLC =',
     &  '   /* Solar constant (area averaged) in W/m2 */')
       CALL WRITE_0D_RL( OBLIQ, INDEX_NONE,'AIM_FOR:  OBLIQ =',
     &  '   /* Obliquity (degree) used with ALLOW_INSOLATION */')
       CALL WRITE_0D_RL( ALBSEA,INDEX_NONE,'AIM_FOR: ALBSEA =',
     &  '   /* Albedo over sea [0-1]      */')
       CALL WRITE_0D_RL( ALBICE,INDEX_NONE,'AIM_FOR: ALBICE =',
     &  '   /* Albedo over sea ice (for ice fraction =1) */')
       CALL WRITE_0D_RL( ALBSN, INDEX_NONE,'AIM_FOR:  ALBSN =',
     &  '   /* Albedo over snow (for snow depth > SDALB) */')
       CALL WRITE_0D_RL( SDALB, INDEX_NONE,'AIM_FOR:  SDALB =',
     &  '   /* Snow depth (mm H2O) corresp. maximum albedo */')
       CALL WRITE_0D_RL( SWCAP, INDEX_NONE,'AIM_FOR:  SWCAP =',
     &  '   /* Soil wetness at field capacity (Vol.fract.) */')
       CALL WRITE_0D_RL( SWWIL, INDEX_NONE,'AIM_FOR:  SWWIL =',
     &  '   /* Soil wetness at wilting point  (Vol.fract.) */')
       CALL WRITE_0D_RL( hSnowWetness, INDEX_NONE,
     &  'AIM_FOR: hSnowWetness=',
     &  '   /* snow depth corresp. maximum wetness (m) */')

C- namelist AIM_PAR_SFL:
       CALL WRITE_0D_RL( FWIND0,INDEX_NONE,'AIM_SFL: FWIND0 =',
     &  '   /* ratio of near-sfc wind to lowest-level wind */')
       CALL WRITE_0D_RL( FTEMP0,INDEX_NONE,'AIM_SFL: FTEMP0 =',
     &  '  /* weight for near-sfc temp. extrapolation (0-1)*/')
       CALL WRITE_0D_RL( FHUM0, INDEX_NONE,'AIM_SFL:  FHUM0 =',
     &  '  /* weight for near-sfc spec.humid. extrap. (0-1)*/')
       CALL WRITE_0D_RL( CDL,   INDEX_NONE,'AIM_SFL:    CDL =',
     &  '   /* drag coefficient for momentum over land */')
       CALL WRITE_0D_RL( CDS,   INDEX_NONE,'AIM_SFL:    CDS =',
     &  '   /* drag coefficient for momentum over sea  */')
       CALL WRITE_0D_RL( CHL,   INDEX_NONE,'AIM_SFL:    CHL =',
     &  '   /* heat exchange coefficient over land */')
       CALL WRITE_0D_RL( CHS,   INDEX_NONE,'AIM_SFL:    CHS =',
     &  '   /* heat exchange coefficient over sea  */')
       CALL WRITE_0D_RL( VGUST, INDEX_NONE,'AIM_SFL:  VGUST =',
     &  '   /* wind speed [m/s] for sub-grid-scale gusts */')
       CALL WRITE_0D_RL( CTDAY, INDEX_NONE,'AIM_SFL:  CTDAY =',
     &  '   /* daily-cycle correction (dTskin/dSSRad) */')
       CALL WRITE_0D_RL( DTHETA,INDEX_NONE,'AIM_SFL: DTHETA =',
     &  '   /* Pot.Temp. gradient for stability correction */')
       CALL WRITE_0D_RL( dTstab,INDEX_NONE,'AIM_SFL: dTstab =',
     &  '   /* Pot.Temp. increment for stab.funct. derivative */')
       CALL WRITE_0D_RL( FSTAB, INDEX_NONE,'AIM_SFL:  FSTAB =',
     &  '   /* Amplitude of stability correction (fract.) */')
       CALL WRITE_0D_RL( HDRAG, INDEX_NONE,'AIM_SFL:  HDRAG =',
     &  '   /* Height scale for orographic correction */')
       CALL WRITE_0D_RL( FHDRAG,INDEX_NONE,'AIM_SFL: FHDRAG =',
     &  '   /* Amplitude of orographic correction (fract.)*/')

C- namelist AIM_PAR_CNV:
       CALL WRITE_0D_RL( PSMIN, INDEX_NONE,'AIM_CNV:  PSMIN =',
     &  '   /* min norm.sfc.P. for occurrence of convect. */')
       CALL WRITE_0D_RL( TRCNV, INDEX_NONE,'AIM_CNV:  TRCNV =',
     &  '   /* time of relaxation [h] towards ref state */')
       CALL WRITE_0D_RL( QBL,   INDEX_NONE,'AIM_CNV:    QBL =',
     &  '   /* specific hum. threshold in the Bound.layer */')
       CALL WRITE_0D_RL( RHBL,  INDEX_NONE,'AIM_CNV:   RHBL =',
     &  '   /* relative hum. threshold in the Bound.layer */')
       CALL WRITE_0D_RL( RHIL,  INDEX_NONE,'AIM_CNV:   RHIL =',
     &  '   /* rel.hum. threshold (intern) for 2nd mass.Flx*/')
       CALL WRITE_0D_RL( ENTMAX,INDEX_NONE,'AIM_CNV: ENTMAX =',
     &  '   /* time of relaxation [h] towards neutral eq. */')
       CALL WRITE_0D_RL( SMF,   INDEX_NONE,'AIM_CNV:    SMF =',
     &  '   /* ratio 2ndary/primary mass.Flx at cloud-base*/')

C- namelist AIM_PAR_LSC:
       CALL WRITE_0D_RL( TRLSC, INDEX_NONE,'AIM_LSC:  TRLSC =',
     &  '   /* relaxation time [h] for supersat. spec.hum. */')
       CALL WRITE_0D_RL( RHLSC, INDEX_NONE,'AIM_LSC:  RHLSC =',
     &  '   /* Max rel.humidity threshold (at sigma=1) */')
       CALL WRITE_0D_RL( DRHLSC,INDEX_NONE,'AIM_LSC: DRHLSC =',
     &  '   /* Vertical range of rel.humidity threshold */')
       CALL WRITE_0D_RL( QSMAX, INDEX_NONE,'AIM_LSC:  QSMAX =',
     &  '   /* Define the maximum latent heat release */')

C- namelist AIM_PAR_RAD:
       CALL WRITE_0D_RL( RHCL1, INDEX_NONE,'AIM_RAD:  RHCL1 =',
     &  '   /*  rel.hum. corresponding to cloud cover = 0 */')
       CALL WRITE_0D_RL( RHCL2, INDEX_NONE,'AIM_RAD:  RHCL2 =',
     &  '   /*  rel.hum. corresponding to cloud cover = 1 */')
       CALL WRITE_0D_RL( QACL1, INDEX_NONE,'AIM_RAD:  QACL1 =',
     &  '   /* spec.hum. threshold for cloud, upper trop. */')
       CALL WRITE_0D_RL( QACL2, INDEX_NONE,'AIM_RAD:  QACL2 =',
     &  '   /* spec.hum. threshold for cloud, upper trop. */')
       CALL WRITE_0D_RL( ALBCL, INDEX_NONE,'AIM_RAD:  ALBCL =',
     &  '   /*  cloud albedo (for cloud cover = 1) */')
       CALL WRITE_0D_RL( EPSSW, INDEX_NONE,'AIM_RAD:  EPSSW =',
     &  '   /*  fract. of inc.solar rad. absorbed by ozone */')
       CALL WRITE_0D_RL( EPSLW, INDEX_NONE,'AIM_RAD:  EPSLW =',
     &  '   /*  fract. of sfc LW emitted directly to space */')
       CALL WRITE_0D_RL( EMISFC,INDEX_NONE,'AIM_RAD: EMISFC =',
     &  '   /*  longwave surface emissivity */')

       WRITE(msgBuf,'(A)')
     &  ' AIM_RAD : ShortWave absorptivities (for dp = 10^5 Pa) :'
      CALL PRINT_MESSAGE( msgBuf, iUnit, SQUEEZE_RIGHT, myThid )
       CALL WRITE_0D_RL( ABSDRY,INDEX_NONE,'AIM_RAD: ABSDRY =',
     &  '   /* abs. of dry air (visible band) */')
       CALL WRITE_0D_RL( ABSAER,INDEX_NONE,'AIM_RAD: ABSAER =',
     &  '   /* abs. of aerosols (visible band) */')
       CALL WRITE_0D_RL( ABSWV1,INDEX_NONE,'AIM_RAD: ABSWV1 =',
     &  '   /* abs. of water vap. (vis. band)(/dq, 1g/kg) */')
       CALL WRITE_0D_RL( ABSWV2,INDEX_NONE,'AIM_RAD: ABSWV2 =',
     &  '   /* abs. of water vap.(near IR bd)(/dq, 1g/kg) */')
       CALL WRITE_0D_RL( ABSCL1,INDEX_NONE,'AIM_RAD: ABSCL1 =',
     &  '   /* abs. of clouds (vis.band)(constant term) */')
       CALL WRITE_0D_RL( ABSCL2,INDEX_NONE,'AIM_RAD: ABSCL2 =',
     &  '   /* abs. of clouds (vis.band) (/dw, 1g/kg) */')

       WRITE(msgBuf,'(A)')
     &  ' AIM_RAD : LongWave absorptivities (per dp = 10^5 Pa) :'
       CALL WRITE_0D_RL( ABLWIN,INDEX_NONE,'AIM_RAD: ABLWIN =',
     &  '   /* abs. of air in "window" band */')
       CALL WRITE_0D_RL( ABLCO2,INDEX_NONE,'AIM_RAD: ABLCO2 =',
     &  '   /* abs. of air in CO2 band */')
       CALL WRITE_0D_RL( ABLWV1,INDEX_NONE,'AIM_RAD: ABLWV1 =',
     &  '   /* abs. of Water vap. H2O bd-1(weak)(/dq,1g/kg)*/')
       CALL WRITE_0D_RL( ABLWV2,INDEX_NONE,'AIM_RAD: ABLWV2 =',
     &  '   /* abs. of W. vap., H2O bd-2(strong)(/dq,1g/kg)*/')
       CALL WRITE_0D_RL( ABLCL1,INDEX_NONE,'AIM_RAD: ABLCL1 =',
     &  '   /* abs. of clouds in window band (const term) */')
       CALL WRITE_0D_RL( ABLCL2,INDEX_NONE,'AIM_RAD: ABLCL2 =',
     &  '   /* abs. of clouds in window band (/dw, 1g/kg) */')

C- namelist AIM_PAR_VDI:
       CALL WRITE_0D_RL( TRSHC, INDEX_NONE,'AIM_VDI:  TRSHC =',
     &  '   /* relaxation time [h] for shallow convection */')
       CALL WRITE_0D_RL( TRVDI, INDEX_NONE,'AIM_VDI:  TRVDI =',
     &  '   /* relaxation time [h] for moisture diffusion */')
       CALL WRITE_0D_RL( TRVDS, INDEX_NONE,'AIM_VDI:  TRVDS =',
     &  '   /* relaxation time [h] for super-adiab. cond. */')
       CALL WRITE_0D_RL( RHGRAD,INDEX_NONE,'AIM_VDI: RHGRAD =',
     &  '   /* max gradient of rel.humidity (d_RH/d_sigma)*/')
       CALL WRITE_0D_RL( SEGRAD,INDEX_NONE,'AIM_VDI: SEGRAD =',
     &  '   /* max grad. of dry static Energy(d_DSE/d_phi)*/')

      IF ( errCount.GE.1 ) THEN
        WRITE(msgBuf,'(A,I3,A)')
     &       'AIM_READPARMS: detected', errCount,' fatal error(s)'
        CALL PRINT_ERROR( msgBuf, myThid )
        CALL ALL_PROC_DIE( 0 )
        STOP 'ABNORMAL END: S/R AIM_READPARMS'
      ENDIF

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C- Initialise CO2 concentration (a better place would be from AIM_INIT_VARIA):
      aim_pCO2 = aim_fixed_pCO2
#ifdef ALLOW_AIM_CO2
      atm_pCO2 = atmpCO2init
#endif /* ALLOW_AIM_CO2 */

      _END_MASTER(myThid)

C--   Everyone else must wait for the parameters to be loaded
      _BARRIER

#endif /* ALLOW_AIM */

      RETURN
      END

#include "BLING_OPTIONS.h"

CBOP
C     !ROUTINE: BLING_TR_REGISTER
C     !INTERFACE:
      SUBROUTINE BLING_TR_REGISTER(
     U           tracer_num, sepFTr_num,
     I           myThid )

C     !DESCRIPTION:
C     *==========================================================*
C     | SUBROUTINE BLING_TR_REGISTER
C     | o Register BLING tracer indices
C     *==========================================================*

C     !USES:
      IMPLICIT NONE

C     == GLobal variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
c#include "PARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     tracer_num :: current number of registered tracers
C     sepFTr_num :: number of registered tracers that use Separate Forcing
C     myThid     :: my Thread Id number
      INTEGER tracer_num
      INTEGER sepFTr_num
      INTEGER myThid

C     !LOCAL VARIABLES:
C     msgBuf     :: message buffer
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      INTEGER BLING_Tr_num
CEOP

#ifndef USE_BLING_V1
# ifdef USE_SIBLING
      BLING_Tr_num = 9
# else
      BLING_Tr_num = 8
# endif
#else
      BLING_Tr_num = 6
#endif
#ifdef ADVECT_PHYTO
      BLING_Tr_num = BLING_Tr_num+1
#endif

      WRITE(msgBuf,'(2A,2I5)') ' BLING_TR_REGISTER:',
     &     ' number of BLING tracers=', BLING_Tr_num
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(2A,2I5)') ' BLING_TR_REGISTER:',
     &     '   starting at pTrc num =', tracer_num + 1
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )

      tracer_num = tracer_num + BLING_Tr_num
      sepFTr_num = sepFTr_num + BLING_Tr_num

      WRITE(msgBuf,'(2A,2I5)') ' BLING_TR_REGISTER:',
     &     ' Numb. Trac & SepForc Trac:', tracer_num, sepFTr_num
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )

      RETURN
      END

#include "CHEAPAML_OPTIONS.h"

CBOP
C !ROUTINE: CHEAPAML_WRITE_PICKUP

C !INTERFACE: ==========================================================
      SUBROUTINE CHEAPAML_WRITE_PICKUP( permPickup,
     &                    suff, myTime, myIter, myThid )

C !DESCRIPTION:
C     Writes current state of cheapaml variables  to a pickup file

C !USES: ===============================================================
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "FFIELDS.h"
#include "CHEAPAML.h"

C !INPUT PARAMETERS: ===================================================
C     permPickup      :: write a permanent pickup
C     suff            :: suffix for pickup file (eg. ckptA or 0000000010)
C     myTime          :: model time
C     myIter          :: time-step number
C     myThid          :: thread number
      LOGICAL permPickup
      CHARACTER*(*) suff
      _RL myTime
      INTEGER myIter
      INTEGER myThid

C !OUTPUT PARAMETERS: ==================================================
C  none

#ifdef ALLOW_CHEAPAML

C     === Functions ====
      INTEGER  ILNBLNK
      EXTERNAL ILNBLNK

C !LOCAL VARIABLES: ====================================================
C     j           :: loop index / field number
C     nj          :: record number
C     fp          :: pickup-file precision
C     glf         :: local flag for "globalFiles"
C     fn          :: character buffer for creating filename
C     nWrFlds     :: number of fields being written
C     listDim     :: dimension of "wrFldList" local array
C     wrFldList   :: list of written fields
C     msgBuf      :: Informational/error message buffer
      INTEGER j, nj, fp, lChar
      LOGICAL glf
      _RL     timList(1)
      CHARACTER*(MAX_LEN_FNAM) fn
      INTEGER listDim, nWrFlds
      PARAMETER( listDim = 12 )
      CHARACTER*(8) wrFldList(listDim)
      CHARACTER*(MAX_LEN_MBUF) msgBuf
CEOP

        lChar = ILNBLNK(suff)
        IF ( lChar.EQ.0 ) THEN
          WRITE(fn,'(2A)') 'pickup_cheapaml'
        ELSE
          WRITE(fn,'(2A)') 'pickup_cheapaml.',suff(1:lChar)
        ENDIF
        fp = precFloat64
        j  = 0

C       Firstly, write 3-D fields as consecutive records,

C     record number < 0 : a hack not to write meta files now:

C-    switch to 2-D fields:
        nj = -j*Nr

        j = j + 1
        nj = nj-1
        CALL WRITE_REC_3D_RL( fn, fp, 1,
     &                        Tair, nj, myIter, myThid )
        IF (j.LE.listDim) wrFldList(j) = 'Tair    '
        j = j + 1
        nj = nj-1
        CALL WRITE_REC_3D_RL( fn, fp, 1,
     &                        gTairm, nj, myIter, myThid )
        IF (j.LE.listDim) wrFldList(j) = 'gTairNm1'

       IF (useFreshWaterFlux) THEN
        j = j + 1
        nj = nj-1
        CALL WRITE_REC_3D_RL( fn, fp, 1,
     &                        qair, nj, myIter, myThid )
        IF (j.LE.listDim) wrFldList(j) = 'Qair    '
        j = j + 1
        nj = nj-1
        CALL WRITE_REC_3D_RL( fn, fp, 1,
     &                        gqairm, nj, myIter, myThid )
        IF (j.LE.listDim) wrFldList(j) = 'gQairNm1'
       ENDIF

       IF (useCheapTracer) THEN
        j = j + 1
        nj = nj-1
        CALL WRITE_REC_3D_RL( fn, fp, 1,
     &                        Cheaptracer, nj, myIter, myThid )
        IF (j.LE.listDim) wrFldList(j) = 'cTracer '
        j = j + 1
        nj = nj-1
        CALL WRITE_REC_3D_RL( fn, fp, 1,
     &                        gCheaptracerm, nj, myIter, myThid )
        IF (j.LE.listDim) wrFldList(j) = 'gTracNm1'
       ENDIF

C--------------------------
       nWrFlds = j
       IF ( nWrFlds.GT.listDim ) THEN
          WRITE(msgBuf,'(2A,I5,A)') 'CHEAPAML_WRITE_PICKUP: ',
     &     'trying to write ',nWrFlds,' fields'
          CALL PRINT_ERROR( msgBuf, myThid )
          WRITE(msgBuf,'(2A,I5,A)') 'CHEAPAML_WRITE_PICKUP: ',
     &     'field-list dimension (listDim=',listDim,') too small'
          CALL PRINT_ERROR( msgBuf, myThid )
          STOP 'ABNORMAL END: S/R CHEAPAML_WRITE_PICKUP (list-size Pb)'
       ENDIF
#ifdef ALLOW_MDSIO
C     uses this specific S/R to write (with more informations) only meta files
        j  = 1
        nj = ABS(nj)
        IF ( nWrFlds*Nr .EQ. nj ) THEN
          j  = Nr
          nj = nWrFlds
        ENDIF
        glf  = globalFiles
        timList(1) = myTime
        CALL MDS_WR_METAFILES( fn, fp, glf, .FALSE.,
     &                         0, 0, j, ' ',
     &                         nWrFlds, wrFldList,
     &                         1, timList, oneRL,
     &                         nj, myIter, myThid )
#endif /* ALLOW_MDSIO */
C--------------------------

#endif /* ALLOW_CHEAPAML */

      RETURN
      END

#include "ECCO_OPTIONS.h"
#ifdef ALLOW_CTRL
# include "CTRL_OPTIONS.h"
#endif

      SUBROUTINE ECCO_COST_FINAL( ifc, optimcycle, myThid )

c     ==================================================================
c     SUBROUTINE cost_final
c     ==================================================================
c
c     o Sum of all cost function contributions.
c
c     ==================================================================
c     SUBROUTINE cost_final
c     ==================================================================

      IMPLICIT NONE

c     == global variables ==

#include "EEPARAMS.h"
#include "SIZE.h"
#include "PARAMS.h"

#ifdef ALLOW_COST
# include "cost.h"
#endif
#ifdef ALLOW_ECCO
# include "ECCO_SIZE.h"
# include "ECCO.h"
#endif

c     == routine arguments ==

C     ifc        :: file unit for costfunction_ecco.XXXX
C     optimcycle :: cycle number of the off-line optimization (same as eccoiter)
C     myThid     :: my Thread Id number
      INTEGER ifc
      INTEGER optimcycle
      INTEGER myThid

#ifdef ALLOW_COST
C     === Functions ====
      INTEGER  ILNBLNK
      EXTERNAL ILNBLNK

c     == local variables ==

      INTEGER bi,bj
      INTEGER num_var

#ifdef ECCO_VERBOSE
      _RL locfc
#endif
#ifdef ALLOW_GENCOST_CONTRIBUTION
      _RL f_gencost(NGENCOST)
      _RL no_gencost(NGENCOST)
#endif
      INTEGER IL
      CHARACTER*23 cfname
      CHARACTER*(MAX_LEN_MBUF) msgBuf

c     == end of interface ==

#ifdef ALLOW_GENCOST_CONTRIBUTION
      DO num_var=1,NGENCOST
       f_gencost(num_var) = 0. _d 0
       no_gencost(num_var)= 0. _d 0
      ENDDO

c--   Sum up all contributions.
      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)

        DO num_var=1,NGENCOST
         tile_fc(bi,bj) = tile_fc(bi,bj)
     &            + mult_gencost(num_var)
     &            *objf_gencost(bi,bj,num_var)
         f_gencost(num_var)=f_gencost(num_var)
     &            +objf_gencost(bi,bj,num_var)
         no_gencost(num_var)=no_gencost(num_var)
     &            +num_gencost(bi,bj,num_var)
        ENDDO

C-   end bi,bj loops
       ENDDO
      ENDDO

c--   Do global summation for each part of the cost function
      DO num_var=1,NGENCOST
       _GLOBAL_SUM_RL(f_gencost(num_var), myThid )
       _GLOBAL_SUM_RL(no_gencost(num_var), myThid )
      ENDDO

C     start printing to STDOUT
      DO num_var=1,NGENCOST
       IF (no_gencost(num_var).GT.0) THEN
        IL  = ILNBLNK( gencost_name(num_var) )
        WRITE(msgBuf,'(A,1PE22.14,I3,1X,1PE9.2,3A)')
     &     ' --> f_gencost  =', f_gencost(num_var), num_var,
     &     mult_gencost(num_var),
     &     ' (', gencost_name(num_var)(1:IL), ')'
        CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
       ENDIF
      ENDDO
#endif

C     only master thread of master CPU open and write to file with file unit > 0
      IF ( ifc .NE. -1 ) THEN

C     For consistency we use variable optimcycle rather than eccoiter,
C     but they have the same value.
C       WRITE(cfname,'(A,i4.4)') 'costfunction_ecco.',eccoiter
        WRITE(cfname,'(A,i4.4)') 'costfunction_ecco.',optimcycle
        WRITE(msgBuf,'(A,A)')
     &           'Writing ecco cost function info to ', cfname
        CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                     SQUEEZE_RIGHT, myThid )
        OPEN(unit=ifc,file=cfname)

#ifdef ALLOW_GENCOST_CONTRIBUTION
        DO num_var=1,NGENCOST
         IF (no_gencost(num_var).GT.0) THEN
          IL  = ILNBLNK( gencost_name(num_var) )
          IL  = max (IL,15)
          WRITE(ifc,'(2A,I3.0,A,1PE22.14,1PE22.14,1X,1PE9.2)')
     &    gencost_name(num_var)(1:IL),' (gencost ', num_var, ') = ',
     &    f_gencost(num_var),
     &    no_gencost(num_var), mult_gencost(num_var)
         ENDIF
        ENDDO
#endif

        CLOSE(ifc)

      ELSE
        WRITE(msgBuf,'(A)') ' skip writing to costfunction_ecco.XXXX'
        CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )

C     ifc .ne. -1
      ENDIF

#ifdef ECCO_VERBOSE
c local copy used in print statements, for
c which we always want to do the global sum.
      locfc = 0. _d 0
      CALL GLOBAL_SUM_TILE_RL( tile_fc, locfc, myThid )

      WRITE(msgBuf,'(a,1PE22.14)')
     &  ' cost_Final: ecco cost function = ',locfc
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(a)') ' '
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(a)')
     &  '             cost function evaluation finished.'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(a)') ' '
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
#endif

#endif /*  ALLOW_COST */

      RETURN
      END

#include "OBCS_OPTIONS.h"
#ifdef ALLOW_CTRL
# include "CTRL_OPTIONS.h"
#endif

      SUBROUTINE OBCS_COST_WEIGHTS( myThid )

c     ==================================================================
c     SUBROUTINE OBCS_COST_WEIGHTS
c     ==================================================================
c
c     o Read the weights used for the obcs cost function evaluation.
C       based on obsolete pkg/ecco/ecco_cost_weights.F
c
c     ==================================================================
c     SUBROUTINE OBCS_COST_WEIGHTS
c     ==================================================================

      IMPLICIT NONE

c     == global variables ==
#include "EEPARAMS.h"
#include "SIZE.h"
#ifdef ALLOW_CTRL
# include "CTRL_OBCS.h"
#endif

c     == routine arguments ==
      INTEGER  myThid

#ifdef ALLOW_OBCS_CONTROL
c     == external ==
      INTEGER  IFNBLNK
      EXTERNAL IFNBLNK
      INTEGER  ILNBLNK
      EXTERNAL ILNBLNK

c     == local variables ==
      INTEGER k
      INTEGER gwUnit
      INTEGER ilo,ihi
      INTEGER iobcs
      _RL ratio
      _RL weights(Nr,4)
      _RL dummy
      logical  exst

c     == end of interface ==

c--   Initialize variance (weight) fields.
      DO iobcs = 1, nobcs
       DO k = 1, Nr
        weights(k,iobcs)= 0. _d 0
CML#ifdef ALLOW_OBCSN_CONTROL
CML        wobcsN(k,iobcs) = 0. _d 0
CML#endif
CML#ifdef ALLOW_OBCSS_CONTROL
CML        wobcsS(k,iobcs) = 0. _d 0
CML#endif
CML#ifdef ALLOW_OBCSE_CONTROL
CML        wobcsE(k,iobcs) = 0. _d 0
CML#endif
CML#ifdef ALLOW_OBCSW_CONTROL
CML        wobcsW(k,iobcs) = 0. _d 0
CML#endif
       ENDDO
      ENDDO

c--   Read error information and set up weight matrices.
      _BEGIN_MASTER(myThid)
      ilo = IFNBLNK(obcs_data_errfile)
      ihi = ILNBLNK(obcs_data_errfile)

      INQUIRE( file=obcs_data_errfile, exist=exst )
      IF (exst) THEN
        CALL OPEN_COPY_DATA_FILE(
     I                          obcs_data_errfile(ilo:ihi),
     I                          'OBCS_COST_WEIGHTS',
     O                          gwUnit,
     I                          myThid )

        READ(gwUnit,*) ratio, dummy
        DO k = 1, Nr
         READ(gwUnit,*) weights(k,1), weights(k,2), weights(k,3)
         weights(k,4) = weights(k,3)
        ENDDO
#ifdef SINGLE_DISK_IO
        CLOSE(gwUnit)
#else
        CLOSE(gwUnit,STATUS='DELETE')
#endif /* SINGLE_DISK_IO */
      ENDIF

      _END_MASTER(myThid)

      _BARRIER

      DO iobcs = 1,nobcs
       DO k = 1, Nr
# ifdef ALLOW_OBCSN_CONTROL
        wobcsN(k,iobcs) = weights(k,iobcs)
        IF (wobcsN(k,iobcs) .NE. 0.) THEN
         wobcsN(k,iobcs) =
     &        ratio/wobcsN(k,iobcs)/wobcsN(k,iobcs)
        ELSE
         wobcsN(k,iobcs) = 0.0 _d 0
        ENDIF
# endif
# ifdef ALLOW_OBCSS_CONTROL
        wobcsS(k,iobcs) = weights(k,iobcs)
        IF (wobcsS(k,iobcs) .NE. 0.) THEN
         wobcsS(k,iobcs) =
     &        ratio/wobcsS(k,iobcs)/wobcsS(k,iobcs)
        ELSE
         wobcsS(k,iobcs) = 0.0 _d 0
        ENDIF
# endif
# ifdef ALLOW_OBCSE_CONTROL
        wobcsE(k,iobcs) = weights(k,iobcs)
        IF (wobcsE(k,iobcs) .NE. 0.) THEN
         wobcsE(k,iobcs) =
     &        ratio/wobcsE(k,iobcs)/wobcsE(k,iobcs)
        ELSE
         wobcsE(k,iobcs) = 0.0 _d 0
        ENDIF
# endif
# ifdef ALLOW_OBCSW_CONTROL
        wobcsW(k,iobcs) = weights(k,iobcs)
        IF (wobcsW(k,iobcs) .NE. 0.) THEN
         wobcsW(k,iobcs) =
     &        ratio/wobcsW(k,iobcs)/wobcsW(k,iobcs)
        ELSE
         wobcsW(k,iobcs) = 0.0 _d 0
        ENDIF
# endif
       ENDDO
      ENDDO

#endif /* ALLOW_OBCS_CONTROL */

      RETURN
      END

#include "SEAICE_OPTIONS.h"
#ifdef ALLOW_EXF
# include "EXF_OPTIONS.h"
#endif

CBOP
C     !ROUTINE: SEAICE_GET_DYNFORCING
C     !INTERFACE:
      SUBROUTINE SEAICE_GET_DYNFORCING(
     I     uIce, vIce, icFrac, SIMaskU, SIMaskV,
     O     taux, tauy,
     I     myTime, myIter, myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE SEAICE_GET_DYNFORCING
C     |   compute surface stress from atmopheric forcing fields
C     *==========================================================*
C     | started by Martin Losch, April 2007
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "FFIELDS.h"
#include "SEAICE_SIZE.h"
#include "SEAICE_PARAMS.h"
#ifdef HACK_FOR_GMAO_CPL
# include "SEAICE_LAYERS.h"
#endif
#ifdef ALLOW_EXF
# include "DYNVARS.h"
# include "EXF_FIELDS.h"
# include "EXF_PARAM.h"
#endif

#ifdef ALLOW_DIAGNOSTICS
C     !FUNCTIONS:
      LOGICAL  DIAGNOSTICS_IS_ON
      EXTERNAL DIAGNOSTICS_IS_ON
#endif /* ALLOW_DIAGNOSTICS */

C     !INPUT/OUTPUT PARAMETERS:
C   uIce   (inp) :: zonal      ice velocity (input)
C   vIce   (inp) :: meridional ice velocity (input)
C   icFrac (inp) :: seaice fraction (input)
C   SImaskU(inp) :: mask at U-point
C   SImaskV(inp) :: mask at V-point
C   taux   (out) :: zonal      wind stress over ice at U point
C   tauy   (out) :: meridional wind stress over ice at V point
C   myTime (inp) :: current time in simulation
C   myIter (inp) :: iteration number in simulation
C   myThid (inp) :: my Thread Id. number
      _RL uIce   (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL vIce   (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL icFrac (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL SImaskU(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL SImaskV(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL taux   (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL tauy   (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL     myTime
      INTEGER myIter
      INTEGER myThid
CEOP

C     !LOCAL VARIABLES:
C     i,j,bi,bj :: Loop counters
C     ks        :: vertical index of surface layer
      INTEGER bi, bj, i, j
      INTEGER ks
      _RL  COSWIN
      _RS  SINWIN
C     CDAIR   :: local wind stress coefficient (used twice)
C     oceTauX :: wind-stress over open-ocean (on Arakawa A-grid), X direction
C     oceTauY :: wind-stress over open-ocean (on Arakawa A-grid), Y direction
      _RL CDAIR  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
#ifdef ALLOW_EXF
      _RL AAA
      _RL uTmp   (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL vTmp   (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
# ifndef SEAICE_EXTERNAL_FLUXES
      _RL U1, V1
      _RL oceTauX(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL oceTauY(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
# endif
#endif /* ALLOW_EXF */
#ifdef ALLOW_DIAGNOSTICS
      _RL locVar (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL locFrac
#endif /* ALLOW_DIAGNOSTICS */

C--   surface level
      ks = 1
      IF ( usingPcoords ) ks = Nr
C--   introduce turning angle (default is zero)
      SINWIN=SIN(SEAICE_airTurnAngle*deg2rad)
      COSWIN=COS(SEAICE_airTurnAngle*deg2rad)

C--   NOW SET UP FORCING FIELDS

      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)

#ifdef ALLOW_EXF
C--   Wind stress is computed on center of C-grid cell
C     and interpolated to U and V points later

#ifndef SEAICE_EXTERNAL_FLUXES
C--   First compute wind-stress over open ocean: this will results in
C     over-writing fu and fv that were computed or read-in by pkg/exf.
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          U1=UWIND(i,j,bi,bj)
          V1=VWIND(i,j,bi,bj)
          AAA=U1**2+V1**2
          IF ( AAA .LE. SEAICE_EPS_SQ ) THEN
             AAA=SEAICE_EPS
          ELSE
             AAA=SQRT(AAA)
          ENDIF
          CDAIR(i,j)=SEAICE_rhoAir*OCEAN_drag
     &         *(2.70 _d 0+0.142 _d 0*AAA+0.0764 _d 0*AAA*AAA)
          oceTauX(i,j)=CDAIR(i,j)*
     &         (COSWIN*U1-SIGN(SINWIN, _fCori(i,j,bi,bj))*V1)
          oceTauY(i,j)=CDAIR(i,j)*
     &         (SIGN(SINWIN, _fCori(i,j,bi,bj))*U1+COSWIN*V1)
         ENDDO
        ENDDO
C--   Interpolate wind stress over open ocean (N/m^2)
C     from A-grid to U and V points of C-grid
        DO j=1-OLy+1,sNy+OLy
         DO i=1-OLx+1,sNx+OLx
          fu(i,j,bi,bj) = 0.5 _d 0*( oceTauX(i,j) + oceTauX(i-1,j) )
     &                            * SIMaskU(i,j,bi,bj)
          fv(i,j,bi,bj) = 0.5 _d 0*( oceTauY(i,j) + oceTauY(i,j-1) )
     &                            * SIMaskV(i,j,bi,bj)
         ENDDO
        ENDDO
#endif /* ndef SEAICE_EXTERNAL_FLUXES */

# ifdef SEAICE_EXTERNAL_FLUXES
        IF ( useEXF .AND. useAtmWind ) THEN
# else  /* SEAICE_EXTERNAL_FLUXES */
        IF ( useEXF ) THEN
# endif /* SEAICE_EXTERNAL_FLUXES */
C     make local copies of wind field
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           uTmp(i,j)=uwind(i,j,bi,bj)
           vTmp(i,j)=vwind(i,j,bi,bj)
          ENDDO
         ENDDO
         IF ( useRelativeWind ) THEN
C     subtract ice velocities from each component wind-speed
          DO j=1-OLy,sNy+OLy-1
           DO i=1-OLx,sNx+OLx-1
            uTmp(i,j)=uwind(i,j,bi,bj)
     &          - 0.5 _d 0 * (uIce(i,j,bi,bj)+uIce(i+1,j,bi,bj))
            vTmp(i,j)=vwind(i,j,bi,bj)
     &          - 0.5 _d 0 * (vIce(i,j,bi,bj)+vIce(i,j+1,bi,bj))
           ENDDO
          ENDDO
         ENDIF
C--   Now compute ice surface stress
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           AAA=uTmp(i,j)**2+vTmp(i,j)**2
           IF ( AAA .LE. SEAICE_EPS_SQ ) THEN
            AAA=SEAICE_EPS
           ELSE
            AAA=SQRT(AAA)
           ENDIF
           IF ( yC(i,j,bi,bj) .LT. ZERO ) THEN
            CDAIR(i,j) = SEAICE_rhoAir*SEAICE_drag_south*AAA
           ELSE
            CDAIR(i,j) = SEAICE_rhoAir*SEAICE_drag*AAA
           ENDIF
          ENDDO
         ENDDO
         DO j=1-OLy+1,sNy+OLy
          DO i=1-OLx+1,sNx+OLx
C     interpolate to U points
           taux(i,j,bi,bj)=0.5 _d 0 *
     &         (  CDAIR(i  ,j)*(
     &          COSWIN                            *uTmp(i  ,j)
     &          -SIGN(SINWIN, _fCori(i  ,j,bi,bj))*vTmp(i  ,j) )
     &          + CDAIR(i-1,j)*(
     &          COSWIN                            *uTmp(i-1,j)
     &          -SIGN(SINWIN, _fCori(i-1,j,bi,bj))*vTmp(i-1,j) )
     &         )*SIMaskU(i,j,bi,bj)
C     interpolate to V points
           tauy(i,j,bi,bj)=0.5 _d 0 *
     &         (  CDAIR(i,j  )*(
     &          SIGN(SINWIN, _fCori(i,j  ,bi,bj))*uTmp(i,j  )
     &          +COSWIN                          *vTmp(i,j  ) )
     &          + CDAIR(i,j-1)*(
     &          SIGN(SINWIN, _fCori(i,j-1,bi,bj))*uTmp(i,j-1)
     &          +COSWIN                          *vTmp(i,j-1) )
     &         )*SIMaskV(i,j,bi,bj)
          ENDDO
         ENDDO

        ELSE
#else  /* ALLOW_EXF */
        IF (.TRUE.) THEN
#endif /* ALLOW_EXF */

C--   Wind stress is available on U and V points, copy it to seaice variables.
#ifdef HACK_FOR_GMAO_CPL
         DO j=2-OLy,sNy+OLy
          DO i=2-OLx,sNx+OLx
           taux(i,j,bi,bj) = SIwindTauX(i,j,bi,bj)*SIMaskU(i,j,bi,bj)
           tauy(i,j,bi,bj) = SIwindTauY(i,j,bi,bj)*SIMaskV(i,j,bi,bj)
          ENDDO
         ENDDO
#else /* HACK_FOR_GMAO_CPL */
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
C now ice surface stress
           IF ( yC(i,j,bi,bj) .LT. ZERO ) THEN
            CDAIR(i,j) = SEAICE_drag_south/OCEAN_drag
           ELSE
            CDAIR(i,j) = SEAICE_drag      /OCEAN_drag
           ENDIF
           taux(i,j,bi,bj) = CDAIR(i,j)*fu(i,j,bi,bj)
     &                     *SIMaskU(i,j,bi,bj)
           tauy(i,j,bi,bj) = CDAIR(i,j)*fv(i,j,bi,bj)
     &                     *SIMaskV(i,j,bi,bj)
          ENDDO
         ENDDO
#endif /* HACK_FOR_GMAO_CPL */

        ENDIF

C--   end bi,bj loops
       ENDDO
      ENDDO

#ifdef ALLOW_DIAGNOSTICS
      IF ( useDiagnostics ) THEN
       CALL DIAGNOSTICS_FILL( taux, 'SItaux  ', 0,1, 0,1,1, myThid )
       CALL DIAGNOSTICS_FILL( tauy, 'SItauy  ', 0,1, 0,1,1, myThid )
       IF ( DIAGNOSTICS_IS_ON( 'SIatmTx ', myThid ) ) THEN
        DO bj=myByLo(myThid),myByHi(myThid)
         DO bi=myBxLo(myThid),myBxHi(myThid)
           DO j=2-OLy,sNy+OLy
            DO i=2-OLx,sNx+OLx
              locFrac = ( icFrac( i, j,bi,bj)
     &                  + icFrac(i-1,j,bi,bj) )*halfRL
              locVar(i,j) = taux(i,j,bi,bj)*locFrac
     &                      + fu(i,j,bi,bj)*(oneRL-locFrac)
            ENDDO
           ENDDO
           CALL DIAGNOSTICS_FILL(locVar,'SIatmTx ',0,1,2,bi,bj,myThid)
         ENDDO
        ENDDO
       ENDIF
       IF ( DIAGNOSTICS_IS_ON( 'SIatmTy ', myThid ) ) THEN
        DO bj=myByLo(myThid),myByHi(myThid)
         DO bi=myBxLo(myThid),myBxHi(myThid)
           DO j=2-OLy,sNy+OLy
            DO i=2-OLx,sNx+OLx
              locFrac = ( icFrac(i, j, bi,bj)
     &                  + icFrac(i,j-1,bi,bj) )*halfRL
              locVar(i,j) = tauy(i,j,bi,bj)*locFrac
     &                      + fv(i,j,bi,bj)*(oneRL-locFrac)
            ENDDO
           ENDDO
           CALL DIAGNOSTICS_FILL(locVar,'SIatmTy ',0,1,2,bi,bj,myThid)
         ENDDO
        ENDDO
       ENDIF
      ENDIF
#endif /* ALLOW_DIAGNOSTICS */

      RETURN
      END

#include "PP81_OPTIONS.h"

CBOP
C !ROUTINE: PP81_READPARMS

C !INTERFACE: ==========================================================
      SUBROUTINE PP81_READPARMS( myThid )

C !DESCRIPTION:
C     Initialize PP81 parameters, read in data.pp81

C !USES: ===============================================================
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PP81.h"
#include "PARAMS.h"

C !INPUT PARAMETERS: ===================================================
C  myThid               :: thread number
      INTEGER myThid

C !OUTPUT PARAMETERS: ==================================================
C  none

#ifdef ALLOW_PP81

C !LOCAL VARIABLES: ====================================================
C  iUnit                :: unit number for I/O
C  msgBuf               :: message buffer
      INTEGER iUnit
      CHARACTER*(MAX_LEN_MBUF) msgBuf
CEOP

      NAMELIST /PP81_PARM01/
     &     PPnRi,
     &     PPviscMin,
     &     PPdiffMin,
     &     PPviscMax,
     &     PPnu0,
     &     PPalpha,
     &     PPdumpFreq,
     &     PPMixingMaps,
     &     PPwriteState

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      IF ( .NOT.usePP81 ) THEN
C-    pkg PP81 is not used
        _BEGIN_MASTER(myThid)
C-    Track pkg activation status:
         PP81isON = .FALSE.
C     print a (weak) warning if data.pp81 is found
         CALL PACKAGES_UNUSED_MSG( 'usePP81', ' ', ' ' )
        _END_MASTER(myThid)
        RETURN
      ENDIF

C This routine has been called by the main model so we set our
C internal flag to indicate we are in business
      PP81isON = .TRUE.

C Set defaults values for parameters in PP81.h
      PPnRi        = 2
      PPviscMin    = 0. _d 0
      PPdiffMin    = 0. _d 0
      PPviscMax    = 1. _d 0
      PPnu0        = 1. _d -02
      PPalpha      = 5. _d 0
      RiLimit      = UNSET_RL
      PPdumpFreq   = dumpFreq
      PPMixingMaps = .FALSE.
      PPwriteState = .FALSE.

C Open and read the data.pp81 file
      _BEGIN_MASTER(myThid)
      WRITE(msgBuf,'(A)') ' PP81_READPARMS: opening data.pp81'
      CALL PRINT_MESSAGE(msgBuf, standardMessageUnit,
     &                   SQUEEZE_RIGHT , 1)
      CALL OPEN_COPY_DATA_FILE(
     I                   'data.pp81', 'PP81_READPARMS',
     O                   iUnit,
     I                   myThid )
      READ(UNIT=iUnit,NML=PP81_PARM01)
      WRITE(msgBuf,'(A)')
     &  ' PP81_READPARMS: finished reading data.pp81'
      CALL PRINT_MESSAGE(msgBuf, standardMessageUnit,
     &                   SQUEEZE_RIGHT , 1)

C Close the open data file
#ifdef SINGLE_DISK_IO
      CLOSE(iUnit)
#else
      CLOSE(iUnit,STATUS='DELETE')
#endif /* SINGLE_DISK_IO */
      _END_MASTER(myThid)

C Everyone else must wait for the parameters to be loaded
      _BARRIER

C Now set-up any remaining parameters that result from the input parameters
      IF ( PPviscMax .LE. 0. ) THEN
       WRITE(msgBuf,'(A)') 'PPviscMax must be greater than zero'
       CALL PRINT_ERROR( msgBuf , 1)
       STOP 'ABNORMAL END: S/R PP81_READPARMS'
      ENDIF
      IF ( PPalpha .EQ. 0. ) THEN
       WRITE(msgBuf,'(A)') 'PPalpha must not be zero'
       CALL PRINT_ERROR( msgBuf , 1)
       STOP 'ABNORMAL END: S/R PP81_READPARMS'
      ENDIF
      IF ( PPnRi .EQ. 0 ) THEN
       WRITE(msgBuf,'(A)') 'PPnRi must not be zero'
       CALL PRINT_ERROR( msgBuf , 1)
       STOP 'ABNORMAL END: S/R PP81_READPARMS'
      ENDIF
      IF ( RiLimit .EQ. UNSET_RL ) THEN
       RiLimit = PPnRi
       RiLimit = (
     &             ((PPnu0+viscArNr(1))/PPviscMax)**(1. _d 0/RiLimit)
     &            -1. _d 0
     &           )/PPalpha
      ENDIF
#endif /* ALLOW_PP81 */

      RETURN
      END

#include "SEAICE_OPTIONS.h"
#ifdef ALLOW_GENERIC_ADVDIFF
# include "GAD_OPTIONS.h"
#endif

CBOP
C     !ROUTINE: DIFFUS
C     !INTERFACE:
      SUBROUTINE DIFFUS(
     U                   fld,
     I                   DIFFA, iceMsk, myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R DIFFUS
C     | o Calculate laplacian of input field
C     |   and return the result in the same array
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     == Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "GRID.h"
#include "SEAICE_SIZE.h"
#include "SEAICE_PARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine Arguments ==
C     fld        :: In: input ice-field ; Out: laplacian of input field
C     DIFFA      :: grid length scale
C     iceMsk     :: Ocean/Land mask
C     myThid     :: my Thread Id. number
      _RL fld    (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL DIFFA  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL iceMsk (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      INTEGER myThid
CEOP

C     !LOCAL VARIABLES:
C     == Local variables ==
C     i,j,bi,bj :: Loop counters
      INTEGER i, j, bi, bj
      _RL DELTXX, DELTYY
      _RL tmpFld  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL dfx     (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL dfy     (1-OLx:sNx+OLx,1-OLy:sNy+OLy)

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        IF ( SEAICEuseFluxForm ) THEN
C--   Use flux form for MITgcm compliance, unfortunately changes results

          DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
            dfx(i,j) = 0. _d 0
            dfy(i,j) = 0. _d 0
           ENDDO
          ENDDO
C--   first compute fluxes across cell faces
          DO j=1,sNy+1
           DO i=1,sNx+1
            dfx(i,j) = _dyG(i,j,bi,bj) * _recip_dxC(i,j,bi,bj)
     &         * (fld(i,j,bi,bj)-fld(i-1,j,bi,bj))
     &         * cosFacU(j,bi,bj)
     &         * iceMsk(i,j,bi,bj)*iceMsk(i-1,j,bi,bj)
     &         * ( DIFFA(i,j,bi,bj)+DIFFA(i-1,j,bi,bj) )*HALF
#ifdef ALLOW_OBCS
     &         * maskInW(i,j,bi,bj)
#endif
            dfy(i,j) = _dxG(i,j,bi,bj) * _recip_dyC(i,j,bi,bj)
     &         * (fld(i,j,bi,bj)-fld(i,j-1,bi,bj))
#ifdef ISOTROPIC_COS_SCALING
     &         * cosFacV(j,bi,bj)
#endif
     &         * iceMsk(i,j,bi,bj)*iceMsk(i,j-1,bi,bj)
     &         * ( DIFFA(i,j,bi,bj)+DIFFA(i,j-1,bi,bj) )*HALF
#ifdef ALLOW_OBCS
     &         * maskInS(i,j,bi,bj)
#endif
           ENDDO
          ENDDO
          DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
            fld(i,j,bi,bj) = 0. _d 0
           ENDDO
          ENDDO
C--   compute Laplacian as flux divergence
          DO j=1,sNy
           DO i=1,sNx
            fld(i,j,bi,bj) = (
     &                         ( dfx(i+1,j) - dfx(i,j) )
     &                       + ( dfy(i,j+1) - dfy(i,j) )
     &                       ) * recip_rA(i,j,bi,bj)
           ENDDO
          ENDDO

        ELSE
C NOW DO DIFFUSION WITH NUIT CONVERSION

          DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
            tmpFld(i,j) = 0.0 _d 0
           ENDDO
          ENDDO

          DO j=1,sNy
           DO i=1,sNx
            DELTXX = DIFFA(i,j,bi,bj)
     &             * _recip_dxF(i,j,bi,bj)*_recip_dxF(i,j,bi,bj)
            DELTYY = DIFFA(i,j,bi,bj)
     &             * _recip_dyF(i,j,bi,bj)*_recip_dyF(i,j,bi,bj)
     &             * _recip_dxF(i,j,bi,bj)
            tmpFld(i,j) =
     &        DELTXX*(
     &                 (fld(i+1,j,bi,bj)-fld(i,  j,bi,bj))
     &                 *iceMsk(i+1,j,bi,bj)
#ifdef ALLOW_OBCS
     &                 *maskInW(i+1,j,bi,bj)
#endif
     &                -(fld(i,  j,bi,bj)-fld(i-1,j,bi,bj))
     &                 *iceMsk(i-1,j,bi,bj)
#ifdef ALLOW_OBCS
     &                 *maskInW(i,j,bi,bj)
#endif
     &               )
     &       +DELTYY*(
     &                 (fld(i,j+1,bi,bj)-fld(i,j,  bi,bj))
     &                 * _dxG(i,j+1,bi,bj)*iceMsk(i,j+1,bi,bj)
#ifdef ALLOW_OBCS
     &                 *maskInS(i,j+1,bi,bj)
#endif
     &                -(fld(i,j,  bi,bj)-fld(i,j-1,bi,bj))
     &                 * _dxG(i,j,  bi,bj)*iceMsk(i,j-1,bi,bj)
#ifdef ALLOW_OBCS
     &                 *maskInS(i,j,bi,bj)
#endif
     &               )
           ENDDO
          ENDDO
          DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
            fld(i,j,bi,bj) = tmpFld(i,j)
           ENDDO
          ENDDO

C--  end flux-form / non flux-form
        ENDIF
       ENDDO
      ENDDO

      RETURN
      END

#include "RUNCLOCK_OPTIONS.h"

      SUBROUTINE RUNCLOCK_READPARMS( myThid )
C     *==========================================================*
C     | SUBROUTINE RUNCLOCK_READPARMS                            |
C     *==========================================================*
      IMPLICIT NONE

C     === Global variables ===
#include "EEPARAMS.h"
#include "SIZE.h"
#include "PARAMS.h"
#include "RUNCLOCK.h"

C     === Routine arguments ===
      INTEGER myThid

#ifdef ALLOW_RUNCLOCK
C     === Local variables ===
C     msgBuf      - Informational/error message buffer
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      INTEGER iUnit
      INTEGER tSecs

C--   RUNCLOCK parameters
      NAMELIST /RUNCLOCK/
     &    RC_maxtime_hr,
     &    RC_maxtime_mi,
     &    RC_maxtime_sc

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      IF ( .NOT.useRunClock ) THEN
C-    pkg RUNCLOCK is not used
        _BEGIN_MASTER(myThid)
C-    Track pkg activation status:
         RUNCLOCKIsOn = .FALSE.
C     print a (weak) warning if data.runclock is found
         CALL PACKAGES_UNUSED_MSG( 'useRunClock', ' ', ' ' )
        _END_MASTER(myThid)
        RETURN
      ENDIF

      RUNCLOCKIsOn = .TRUE.

      _BEGIN_MASTER(myThid)

      WRITE(msgBuf,'(A)') ' RUNCLOCK_READPARMS: opening data.runclock'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT , 1)

      CALL OPEN_COPY_DATA_FILE(
     I                          'data.runclock', 'RUNCLOCK_READPARMS',
     O                          iUnit,
     I                          myThid )

C--   Default values for RUNCLOCK
      RC_maxtime_hr=0
      RC_maxtime_mi=0
      RC_maxtime_sc=0

C--   Read parameters from open data file
      READ(UNIT=iUnit,NML=RUNCLOCK)

      WRITE(msgBuf,'(A)') ' RUNCLOCK_READPARMS: read data.runclock done'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT , 1)

C--   Close the open data file
#ifdef SINGLE_DISK_IO
      CLOSE(iUnit)
#else
      CLOSE(iUnit,STATUS='DELETE')
#endif /* SINGLE_DISK_IO */

      IF (RC_maxtime_hr.LT.0) THEN
      WRITE(msgBuf,'(A)') ' RUNCLOCK_READPARMS: ERR! RC_maxtime_hr<0'
      CALL PRINT_ERROR( msgBuf, myThid )
      ENDIF
      IF (RC_maxtime_mi.LT.0) THEN
      WRITE(msgBuf,'(A)') ' RUNCLOCK_READPARMS: ERR! RC_maxtime_mi<0'
      CALL PRINT_ERROR( msgBuf, myThid )
      ENDIF
      IF (RC_maxtime_sc.LT.0) THEN
      WRITE(msgBuf,'(A)') ' RUNCLOCK_READPARMS: ERR! RC_maxtime_sc<0'
      CALL PRINT_ERROR( msgBuf, myThid )
      ENDIF
      IF (RC_maxtime_sc.GT.59 .AND. RC_maxtime_mi.NE.0) THEN
      WRITE(msgBuf,'(A)') ' RUNCLOCK_READPARMS: ERR! RC_maxtime_sc>59'
      CALL PRINT_ERROR( msgBuf, myThid )
      ENDIF
      IF (RC_maxtime_mi.GT.59 .AND. RC_maxtime_hr.NE.0) THEN
      WRITE(msgBuf,'(A)') ' RUNCLOCK_READPARMS: ERR! RC_maxtime_mi>59'
      CALL PRINT_ERROR( msgBuf, myThid )
      ENDIF

      tSecs=(RC_maxtime_hr*60+RC_maxtime_mi)*60+RC_maxtime_sc
      IF (tSecs.EQ.0) THEN
      WRITE(msgBuf,'(A)') ' RUNCLOCK_READPARMS: no Wall Clock limit set'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT , 1)
c     write(0,*) ' RUNCLOCK_READPARMS: no Wall Clock limit set'
      ELSE
      WRITE(msgBuf,'(A,I7)')
     &  ' RUNCLOCK_READPARMS: Wall Clock limit set to ',tSecs
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT , 1)
c     write(0,*) ' RUNCLOCK_READPARMS: Wall Clock limit set to ',tSecs
      ENDIF

      _END_MASTER(myThid)

C--   Everyone else must wait for the parameters to be loaded
      _BARRIER

#endif /* ALLOW_RUNCLOCK */

      RETURN
      END

#include "GMREDI_OPTIONS.h"

CBOP
C     !ROUTINE: GMREDI_DIAGNOSTICS_INIT
C     !INTERFACE:
      SUBROUTINE GMREDI_DIAGNOSTICS_INIT( myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE GMREDI_DIAGNOSTICS_INIT
C     | o Routine to initialize list of all available diagnostics
C     |   for GM/Redi package
C     *==========================================================*
C     \ev
C     !USES:
      IMPLICIT NONE

C     === Global variables ===
#include "EEPARAMS.h"
c #include "SIZE.h"
c #include "PARAMS.h"
c #include "GMREDI.h"

C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
C     myThid ::  my Thread Id number
      INTEGER myThid
CEOP

#ifdef ALLOW_DIAGNOSTICS
C     !LOCAL VARIABLES:
C     === Local variables ===
C     diagNum   :: diagnostics number in the (long) list of available diag.
C     diagMate  :: diag. mate number in the (long) list of available diag.
C     diagName  :: local short name (8c) of a diagnostics
C     diagCode  :: local parser field with characteristics of the diagnostics
C              cf head of S/R DIAGNOSTICS_INIT_EARLY or DIAGNOSTICS_MAIN_INIT
C     diagUnits :: local string (16c): physical units of a diagnostic field
C     diagTitle :: local string (80c): description of field in diagnostic
      INTEGER       diagNum
      INTEGER       diagMate
      CHARACTER*8   diagName
      CHARACTER*16  diagCode
      CHARACTER*16  diagUnits
      CHARACTER*(80) diagTitle

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

c     IF ( useDiagnotics ) THEN

        diagName  = 'GM_hTrsL'
        diagTitle = 'Base depth (>0) of the Transition Layer'
        diagUnits = 'm               '
        diagCode  = 'SM P    M1      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

        diagName  = 'GM_baseS'
        diagTitle = 'Slope at the base of the Transition Layer'
        diagUnits = '1               '
        diagCode  = 'SM P    M1      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

        diagName  = 'GM_rLamb'
        diagTitle =
     &    'Slope vertical gradient at Trans. Layer Base (=recip.Lambda)'
        diagUnits = '1/m             '
        diagCode  = 'SM P    M1      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

#ifndef GM_EXCLUDE_SUBMESO
        diagName  = 'SubMesLf'
        diagTitle = 'Sub-Meso horiz. Length Scale (Lf)'
        diagUnits = 'm               '
        diagCode  = 'SM P    M1      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

        diagName  = 'SubMpsiX'
        diagTitle =
     &    'Sub-Meso transp.stream-funct. magnitude (Psi0): U component'
        diagUnits = 'm^2/s           '
        diagCode  = 'UU      M1      '
        diagMate  = diagNum + 2
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I    diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

        diagName  = 'SubMpsiY'
        diagTitle =
     &    'Sub-Meso transp.stream-funct. magnitude (Psi0): V component'
        diagUnits = 'm^2/s           '
        diagCode  = 'VV      M1      '
        diagMate  = diagNum
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I    diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )
#endif /* ndef GM_EXCLUDE_SUBMESO */

        diagName  = 'GM_Kux  '
        diagTitle = 'K_11 element (U.point, X.dir) of GM-Redi tensor'
        diagUnits = 'm^2/s           '
        diagCode  = 'UU P    MR      '
        diagMate  = diagNum + 2
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I    diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

        diagName  = 'GM_Kvy  '
        diagTitle = 'K_22 element (V.point, Y.dir) of GM-Redi tensor'
        diagUnits = 'm^2/s           '
        diagCode  = 'VV P    MR      '
        diagMate  = diagNum
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I    diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

        diagName  = 'GM_Kuz  '
        diagTitle = 'K_13 element (U.point, Z.dir) of GM-Redi tensor'
        diagUnits = 'm^2/s           '
        diagCode  = 'UU      MR      '
        diagMate  = diagNum + 2
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I    diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

        diagName  = 'GM_Kvz  '
        diagTitle = 'K_23 element (V.point, Z.dir) of GM-Redi tensor'
        diagUnits = 'm^2/s           '
        diagCode  = 'VV      MR      '
        diagMate  = diagNum
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I    diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

        diagName  = 'GM_Kwx  '
        diagTitle = 'K_31 element (W.point, X.dir) of GM-Redi tensor'
        diagUnits = 'm^2/s           '
        diagCode  = 'UM      LR      '
        diagMate  = diagNum + 2
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I    diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

        diagName  = 'GM_Kwy  '
        diagTitle = 'K_32 element (W.point, Y.dir) of GM-Redi tensor'
        diagUnits = 'm^2/s           '
        diagCode  = 'VM      LR      '
        diagMate  = diagNum
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I    diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

        diagName  = 'GM_Kwz  '
        diagTitle = 'K_33 element (W.point, Z.dir) of GM-Redi tensor'
        diagUnits = 'm^2/s           '
        diagCode  = 'WM P    LR      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

        diagName  = 'GM_PsiX '
        diagTitle = 'GM Bolus transport stream-function : U component'
        diagUnits = 'm^2/s           '
        diagCode  = 'UU      LR      '
        diagMate  = diagNum + 2
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I    diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

        diagName  = 'GM_PsiY '
        diagTitle = 'GM Bolus transport stream-function : V component'
        diagUnits = 'm^2/s           '
        diagCode  = 'VV      LR      '
        diagMate  = diagNum
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I    diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

        diagName  = 'GM_KuzTz'
        diagTitle = 'Redi Off-diagonal Temperature flux: X component'
        diagUnits = 'degC.m^3/s      '
        diagCode  = 'UU      MR      '
        diagMate  = diagNum + 2
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I    diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

        diagName  = 'GM_KvzTz'
        diagTitle = 'Redi Off-diagonal Temperature flux: Y component'
        diagUnits = 'degC.m^3/s      '
        diagCode  = 'VV      MR      '
        diagMate  = diagNum
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I    diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

        diagName  = 'GM_KwzTz'
        diagTitle = 'Redi main-diagonal vertical Temperature flux'
        diagUnits = 'degC.m^3/s      '
        diagCode  = 'WM      LR      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

        diagName  = 'GM_ubT  '
        diagTitle = 'Zonal Mass-Weight Bolus Transp of Pot Temp'
        diagUnits = 'degC.m^3/s      '
        diagCode  = 'UUr     MR      '
        diagMate  = diagNum + 2
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I    diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

        diagName  = 'GM_vbT  '
        diagTitle = 'Meridional Mass-Weight Bolus Transp of Pot Temp'
        diagUnits = 'degC.m^3/s      '
        diagCode  = 'VVr     MR      '
        diagMate  = diagNum
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I    diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

#ifdef ALLOW_EDDYPSI
        diagName  = 'GMEdTauX'
        diagTitle = 'eddy-induced stress X-comp.'
        diagUnits = 'N/m^2           '
        diagCode  = 'UM      LR      '
        diagMate  = diagNum + 2
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I    diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

        diagName  = 'GMEdTauY'
        diagTitle = 'eddy-induced stress Y-comp.'
        diagUnits = 'N/m^2           '
        diagCode  = 'VM      LR      '
        diagMate  = diagNum
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I    diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )
#endif /* ALLOW_EDDYPSI */

#ifdef GM_BOLUS_BVP
        diagName  = 'GM_BVPcW'
        diagTitle = 'WKB wave speed (at Western edge location)'
        diagUnits = 'm/s             '
        diagCode  = 'SU P    M1      '
        diagMate  = diagNum + 2
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I    diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

        diagName  = 'GM_BVPcS'
        diagTitle = 'WKB wave speed (at Southern edge location)'
        diagUnits = 'm/s             '
        diagCode  = 'SV P    M1      '
        diagMate  = diagNum
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I    diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )
#endif /* GM_BOLUS_BVP */

#ifdef GM_VISBECK_VARIABLE_K
        diagName  = 'GM_VisbK'
        diagTitle =
     &     'Mixing coefficient from Visbeck etal parameterization'
        diagUnits = 'm^2/s           '
        diagCode  = 'SM P    M1      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )
#endif /* GM_VISBECK_VARIABLE_K */

#ifdef GM_GEOM_VARIABLE_K
        diagName  = 'GM_GEOMK'
        diagTitle = 'GEOM 3d kgm field'
        diagUnits = 'm/s^2           '
        diagCode  = 'SMRP    LR      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

        diagName  = 'GEOMeE  '
        diagTitle = 'GEOM parameterised depth-int eddy energy'
        diagUnits = 'm^3/s^2         '
        diagCode  = 'SM P    M1      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

        diagName  = 'GEOMstru'
        diagTitle = 'spatial structure function'
        diagUnits = '                '
        diagCode  = 'SMRP    LR      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

        diagName  = 'GEOMEgen'
        diagTitle = 'GEOM eddy energy generation tendency'
        diagUnits = 'm^3/s^3         '
        diagCode  = 'SM P    M1      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

        diagName  = 'GEOMEdis'
        diagTitle = 'GEOM eddy energy dissipation tendency'
        diagUnits = 'm^3/s^3         '
        diagCode  = 'SM      M1      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

        diagName  = 'GEOMEadv'
        diagTitle = 'GEOM eddy energy advective tendency'
        diagUnits = 'm^3/s^3         '
        diagCode  = 'SM      M1      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

        diagName  = 'GEOMEwav'
        diagTitle = 'GEOM eddy energy wave advection tendency'
        diagUnits = 'm^3/s^3         '
        diagCode  = 'SM      M1      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

        diagName  = 'GEOMElap'
        diagTitle = 'GEOM eddy energy diffusion tendency'
        diagUnits = 'm^3/s^3         '
        diagCode  = 'SM      M1      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

        diagName  = 'GEOM_c1 '
        diagTitle = 'first baroclinic wave phase speed'
        diagUnits = 'm/s             '
        diagCode  = 'SM P    M1      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )
#endif /* GM_GEOM_VARIABLE_K */

#ifdef GM_BATES_K3D
        diagName  = 'GM_BaK  '
        diagTitle = '3D diffusivity'
        diagUnits = 'm^2/s           '
        diagCode  = 'SM P    MR      '
        diagMate  = diagNum
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I    diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

        diagName  = 'GM_KPV  '
        diagTitle = '3D eddy transport diffusivity'
        diagUnits = 'm^2/s           '
        diagCode  = 'SM P    MR      '
        diagMate  = diagNum
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I    diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

        diagName  = 'GM_BaK_T'
        diagTitle = '3D Redi diffusivity'
        diagUnits = 'm^2/s           '
        diagCode  = 'SM P    MR      '
        diagMate  = diagNum
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I    diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

# ifdef HAVE_LAPACK
        diagName  = 'GM_A3D'
        diagTitle = '3D lower diagona'
        diagUnits = '1/m^2           '
        diagCode  = 'SM      MR      '
        diagMate  = diagNum
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I    diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

        diagName  = 'GM_B3D'
        diagTitle = '3D lower diagona'
        diagUnits = '1/m^2           '
        diagCode  = 'SM      MR      '
        diagMate  = diagNum
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I    diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

        diagName  = 'GM_C3D'
        diagTitle = '3D lower diagona'
        diagUnits = '1/m^2           '
        diagCode  = 'SM      MR      '
        diagMate  = diagNum
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I    diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )
# endif /* HAVE_LAPACK */

        diagName  = 'GM_MODEC'
        diagTitle = 'Eigen vector for the first barcolinic mode'
        diagUnits = 'dimensionless   '
        diagCode  = 'SM      MR      '
        diagMate  = diagNum
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I    diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

        diagName  = 'GM_URMS'
        diagTitle = 'rms Eddy Velocity'
        diagUnits = 'm/s             '
        diagCode  = 'SM P    MR      '
        diagMate  = diagNum
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I    diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

        diagName  = 'GM_UMC  '
        diagTitle = 'ubar-c'
        diagUnits = 'm/s             '
        diagCode  = 'SM      MR      '
        diagMate  = diagNum
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I    diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

        diagName  = 'GM_SFLYR'
        diagTitle = 'mixed layer depth'
        diagUnits = 'm               '
        diagCode  = 'SM P    MR      '
        diagMate  = diagNum
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I    diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

        diagName  = 'GM_USTAR'
        diagTitle = 'u^*'
        diagUnits = 'm/s         '
        diagCode  = 'UU      MR      '
        diagMate  = diagNum
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I    diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

        diagName  = 'GM_VSTAR'
        diagTitle = 'v^*'
        diagUnits = 'm/s         '
        diagCode  = 'VV      MR      '
        diagMate  = diagNum
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I    diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

        diagName  = 'GM_RDEF'
        diagTitle = 'Deformation Radius'
        diagUnits = 'm               '
        diagCode  = 'SM P    M1      '
        diagMate  = diagNum
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I    diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

        diagName  = 'GM_RURMS'
        diagTitle =
     I      'Mixing length for calculating u_rms: MIN(Rdef,Bates_Rmax)'
        diagUnits = 'm               '
        diagCode  = 'SM P    M1      '
        diagMate  = diagNum
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I    diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

        diagName  = 'GM_RRHNS'
        diagTitle = 'Rhines scale: sqrt(urms/beta)'
        diagUnits = 'm               '
        diagCode  = 'SM P    M1      '
        diagMate  = diagNum
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I    diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

        diagName  = 'GM_RMIX'
        diagTitle = 'Unmodulated Mixing Length: MIN(Rdef, RRhines)'
        diagUnits = 'm               '
        diagCode  = 'SM P    M1      '
        diagMate  = diagNum
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I    diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

        diagName  = 'GM_SUPP'
        diagTitle = 'Suppression Factor for BatesK3d'
        diagUnits = 'none            '
        diagCode  = 'SM P    MR      '
        diagMate  = diagNum
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I    diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

        diagName  = 'GM_dqdx '
        diagTitle = 'dq/dx'
        diagUnits = '1/(m*s)         '
        diagCode  = 'UU      MR      '
        diagMate  = diagNum
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I    diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

        diagName  = 'GM_dqdy '
        diagTitle = 'dq/dy'
        diagUnits = '1/(m*s)         '
        diagCode  = 'VV      MR      '
        diagMate  = diagNum
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I    diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

        diagName  = 'GM_Kdqdx'
        diagTitle = 'K*dq/dx'
        diagUnits = 'm/s^2           '
        diagCode  = 'UU      MR      '
        diagMate  = diagNum
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I    diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

        diagName  = 'GM_Kdqdy'
        diagTitle = 'K*dq/dy'
        diagUnits = 'm/s^2           '
        diagCode  = 'VV      MR      '
        diagMate  = diagNum
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I    diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

        diagName  = 'GM_Xix  '
        diagTitle = '-k dq/dx expansion'
        diagUnits = 'm/s^2           '
        diagCode  = 'UU      MR      '
        diagMate  = diagNum
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I    diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

        diagName  = 'GM_Xiy  '
        diagTitle = '-k dq/dy expansion'
        diagUnits = 'm/s^2           '
        diagCode  = 'VV      MR      '
        diagMate  = diagNum
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I    diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

        diagName  = 'GM_Sx   '
        diagTitle = 'Zonal isopycnal slope'
        diagUnits = 'none            '
        diagCode  = 'UU      LR      '
        diagMate  = diagNum
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I    diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

        diagName  = 'GM_Sy   '
        diagTitle = 'Meridional isopycnal slope'
        diagUnits = 'none            '
        diagCode  = 'VV      LR      '
        diagMate  = diagNum
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I    diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

        diagName  = 'GM_TFLXX'
        diagTitle = 'Zonal thickness flux'
        diagUnits = '1/(m*s)         '
        diagCode  = 'UU      MR      '
        diagMate  = diagNum
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I    diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

        diagName  = 'GM_TFLXY'
        diagTitle = 'meridional thickness flux'
        diagUnits = '1/(m*s)         '
        diagCode  = 'VV      MR      '
        diagMate  = diagNum
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I    diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

        diagName  = 'GM_C'
        diagTitle = 'Doppler shifted long Rossby wave speed'
        diagUnits = 'm/s             '
        diagCode  = 'SM      M1      '
        diagMate  = diagNum
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I    diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

        diagName  = 'GM_UBARO'
        diagTitle = 'Barotropic velocity'
        diagUnits = 'm/s             '
        diagCode  = 'SM      M1      '
        diagMate  = diagNum
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I    diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

        diagName  = 'GM_EADY '
        diagTitle = 'Eady Growth rate'
        diagUnits = '1/s             '
        diagCode  = 'SM      M1      '
        diagMate  = diagNum
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I    diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

        diagName  = 'GM_UBAR '
        diagTitle = 'Mean zonal velocity'
        diagUnits = 'm/s             '
        diagCode  = 'SM      MR      '
        diagMate  = diagNum
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I    diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

        diagName  = 'GM_M4   '
        diagTitle = 'M**4'
        diagUnits = '1/s^4           '
        diagCode  = 'SM      MR      '
        diagMate  = diagNum
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I    diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

        diagName  = 'GM_N2   '
        diagTitle = 'N**2'
        diagUnits = '1/s^2           '
        diagCode  = 'SM      MR      '
        diagMate  = diagNum
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I    diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

        diagName  = 'GM_M4_N2'
        diagTitle = 'M**4/N**2'
        diagUnits = '1/s^2           '
        diagCode  = 'SM      MR      '
        diagMate  = diagNum
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I    diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

        diagName  = 'GM_SLOPE'
        diagTitle = 'SLOPE'
        diagUnits = 'm/m             '
        diagCode  = 'SM      MR      '
        diagMate  = diagNum
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I    diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

        diagName  = 'GM_RENRM'
        diagTitle = 'renormalisation factor'
        diagUnits = 'none            '
        diagCode  = 'SM      M1      '
        diagMate  = diagNum
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I    diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

# ifdef GM_BATES_PASSIVE
        diagName  = 'GM_PSTAR'
        diagTitle = 'Diagnosed bolus streamfunction: V component'
        diagUnits = 'm^2/s           '
        diagCode  = 'VV      LR      '
        diagMate  = diagNum
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I    diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )
# endif
#endif /* GM_BATES_K3D */

#ifdef ALLOW_GM_LEITH_QG
        diagName  = 'GM_LTHQG'
        diagTitle = 'QGLeith viscosity used as kappa_GM in GMRedi'
        diagUnits = 'm^2/s           '
        diagCode  = 'SM      MR      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I    diagName, diagCode, diagUnits, diagTitle, 0, myThid )
#endif /* ALLOW_GM_LEITH_QG */

c     ENDIF
# ifdef ALLOW_AUTODIFF
      diagName  = 'ADJkapgm'
      diagTitle = 'dJ/dKgm: Sensitivity to GM Intensity'
      diagUnits = 'dJ/d[m^2/s]'
      diagCode  = 'SMRA    MR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'ADJkapre'
      diagTitle = 'dJ/dKredi: Sensitivity to Redi Coefficient'
      diagUnits = 'dJ/d[m^2/s]'
      diagCode  = 'SMRA    MR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )
# endif

#endif /* ALLOW_DIAGNOSTICS */

      RETURN
      END

#include "DEBUG_OPTIONS.h"

      SUBROUTINE DEBUG_ENTER(
     I                text,
     I                myThid )
C     /==========================================================\
C     | SUBROUTINE DEBUG_ENTER                                   |
C     | o Prints to STDOUT the text argument after "ENTERED S/R" |
C     |==========================================================|
C     \==========================================================/
      IMPLICIT NONE

C     === Global data ===
#include "SIZE.h"
#include "EEPARAMS.h"

C     === Routine arguments ===
      CHARACTER*(*) text
      INTEGER myThid

C     === Local variables ====
      CHARACTER*(MAX_LEN_MBUF) msgBuf

      WRITE(msgBuf,'(A,A)') 'ENTERED S/R ',text
      CALL DEBUG_MSG( msgBuf, myThid )

      RETURN
      END

#include "CPP_OPTIONS.h"

CStartOfInterface
      SUBROUTINE ATM_TO_OCN_MAPXYR8(
     I           aNx, aNy,
     I           fld_atm,
     I           oNx, oNy,
     O           fld_ocn )
C     /==========================================================\
C     | SUBROUTINE ATM_TO_OCN_MAPXYR8                            |
C     | o Maps atmos. field to ocean field for XY 64-bit float   |
C     |   field.                                                 |
C     \==========================================================/
      IMPLICIT NONE

C     == Routine arguments ==
C     fld_atm - Atmos. grid field
C     aNx     - Atmos. grid global extent in X
C     aNy     - Atmos. grid global extent in Y
C     fld_ocn - Ocean grid field (atmos field will be mapped to this
C                                 field).
C     oNx     - Ocean grid global extent in X
C     oNy     - Ocean grid global extent in Y
      INTEGER aNx
      INTEGER aNy
      Real*8 fld_atm(aNx, aNy)
      INTEGER oNx
      INTEGER oNy
      Real*8 fld_ocn(oNx, oNy)
CEndOfInterface

C     == Local variables ==
      INTEGER I,J

C     Set to zero everywhere
      DO J=1,oNy
       DO I=1,oNx
        fld_ocn(I,J)=0.
       ENDDO
      ENDDO
C     Now copy intersection of _atm and _ocn into
C     _ocn.
      DO J=1,MIN(aNy,oNy)
       DO I=1,MIN(aNx,oNx)
        fld_ocn(I,J)=fld_atm(I,J)
       ENDDO
      ENDDO

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#include "AUTODIFF_OPTIONS.h"
#ifdef ALLOW_CTRL
# include "CTRL_OPTIONS.h"
#endif
#ifdef ALLOW_EXF
# include "EXF_OPTIONS.h"
#endif
#ifdef ALLOW_SEAICE
# include "SEAICE_OPTIONS.h"
#endif
#include "MDSIO_OPTIONS.h"

CBOP
C     !ROUTINE: AUTODIFF_INI_MODEL_IO
C     !INTERFACE:
      SUBROUTINE AUTODIFF_INI_MODEL_IO( myThid )

C     !DESCRIPTION: \bv
C     autodiff_ini_model_io() is where run-time/experiment specific data are
C     passed to any I/O packages ready that will be used for I/O of model state
C     variables.
C     This is specifically for setting up once only information such as
C     shape/size of variables, units, etc... and is only for state variables.
C     \ev

      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#ifdef ALLOW_EXF
# include "EXF_PARAM.h"
#endif
#include "GRID.h"
#include "AUTODIFF.h"
#ifdef ALLOW_WHIO
#include "MDSIO_BUFF_WH.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     myThid  :: my Thread Id number
      INTEGER myThid

C     !FUNCTIONS
      INTEGER  ILNBLNK
      EXTERNAL ILNBLNK

C     !LOCAL VARIABLES:
#ifndef HAVE_SYSTEM
      CHARACTER*(MAX_LEN_MBUF) msgBuf
#endif
      CHARACTER*(MAX_LEN_FNAM) namBuf
      INTEGER iL, pIL
#ifdef ALLOW_AUTODIFF_WHTAPEIO
      INTEGER myLev
#endif
CEOP

c     initialize ad dump record number (used only if dumpAdByRec is true)
      dumpAdRecMn=0
      dumpAdRecDy=0
      dumpAdRecSi=0
      dumpAdRecEt=0

      _BEGIN_MASTER( myThid )

      IF ( adTapeDir .NE. ' ' ) THEN
       iL = ILNBLNK( adTapeDir )
C      append "/", if necessary
       IF ( iL.LT.MAX_LEN_FNAM .AND. adTapeDir(iL:iL).NE.'/' ) THEN
        namBuf(1:iL) = adTapeDir(1:iL)
        WRITE(adTapeDir(1:iL+1),'(2A)') namBuf(1:iL),'/'
       ENDIF
#ifdef HAVE_SYSTEM
C      create directory
       iL = ILNBLNK( adTapeDir ) -1
       WRITE(namBuf,'(2A)') ' mkdir -p ', adTapeDir(1:iL)
       pIL = 1 + ILNBLNK( namBuf )
       WRITE(standardMessageUnit,'(3A)')
     &  '==> SYSTEM CALL (from AUTODIFF_INI_MODEL_IO): >',
     &                                 namBuf(1:pIL), '<'
       CALL SYSTEM( namBuf(1:pIL) )
#else
       WRITE(msgBuf,'(2A)') '** WARNING ** AUTODIFF_INI_MODEL_IO: ',
     &       'cannot call mkdir -> please create adTapeDir manually'
       CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                     SQUEEZE_RIGHT, myThid )
#endif
      ENDIF

      _END_MASTER( myThid )

#ifdef ALLOW_AUTODIFF_WHTAPEIO

      tapeFileUnit=0
      do myLev=1,4
        tapeFileUnitS(myLev)=0
      enddo

      tapeFileCounter=0
      tapeMaxCounter=nWh

      tapeConcatIO=.TRUE.
      tapeSingleCpuIO=useSingleCpuIO
      tapeBufferIO=.FALSE.

#ifdef EXCLUDE_WHIO_GLOBUFF_2D
      tapeSingleCpuIO=.FALSE.
#endif
#ifdef ALLOW_WHIO_3D
#ifndef INCLUDE_WHIO_GLOBUFF_3D
      tapeSingleCpuIO=.FALSE.
#endif
#endif

#endif /* ALLOW_AUTODIFF_WHTAPEIO */

#if (defined (ALLOW_MNC) && defined (ALLOW_AUTODIFF_MONITOR))

      IF (useMNC) THEN

      CALL MNC_CW_ADD_VNAME('adU', 'U_xy_Hn__C__t', 4,5, myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('adU','units','[cost]/[m/s]', myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('adU','long_name',
     &     'adjoint zonal velocity', myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('adU',
     &     'coordinates','XU YU RC iter', myThid)

      CALL MNC_CW_ADD_VNAME('adV', 'V_xy_Hn__C__t', 4,5, myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('adV','units','[cost]/[m/s]', myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('adV','long_name',
     &     'adjoint merid. velocity', myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('adV',
     &     'coordinates','XV YV RC iter', myThid)

      CALL MNC_CW_ADD_VNAME('adT', 'Cen_xy_Hn__C__t', 4,5, myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('adT','units','[cost]/[degC]', myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('adT','long_name',
     &     'adjoint potential_temperature', myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('adT',
     &     'coordinates','XC YC RC iter', myThid)

      CALL MNC_CW_ADD_VNAME('adS', 'Cen_xy_Hn__C__t', 4,5, myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('adS','units','[cost]/[g/kg]', myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('adS','long_name',
     &     'adjoint salinity', myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('adS',
     &     'coordinates','XC YC RC iter', myThid)

      CALL MNC_CW_ADD_VNAME('adEta', 'Cen_xy_Hn__-__t', 3,4, myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('adEta','units','[cost]/[m]', myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('adEta','long_name',
     &     'adjoint free-surface_r-anomaly', myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('adEta',
     &     'coordinates','XC YC RC iter', myThid)

      CALL MNC_CW_ADD_VNAME('adW', 'Cen_xy_Hn__C__t', 4,5, myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('adW','units','[cost]/[m/s]', myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('adW','long_name',
     &     'adjoint vertical velocity', myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('adW',
     &     'coordinates','XC YC RC iter', myThid)

      CALL MNC_CW_ADD_VNAME('adQnet', 'Cen_xy_Hn__-__t', 3,4, myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('adQnet',
     &     'units','[cost]/[W/m^2]', myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('adQnet','long_name',
     &     'adjoint net upward heat flux', myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('adQnet',
     &     'coordinates','XC YC RC iter', myThid)

      CALL MNC_CW_ADD_VNAME('adEmpmr', 'Cen_xy_Hn__-__t', 3,4, myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('adEmpmr',
     &     'units','[cost]/[m/s]', myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('adEmpmr','long_name',
     &     'adjoint net upward freshwater flux', myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('adEmpmr',
     &     'coordinates','XC YC RC iter', myThid)

      CALL MNC_CW_ADD_VNAME(    'adFu', 'Cen_xy_Hn__-__t', 3,4, myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('adFu',
     &     'units','[cost]/[N/m^2]', myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('adFu','long_name',
     &     'adjoint zonal wind stress', myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('adFu',
     &     'coordinates','XC YC RC iter', myThid)

      CALL MNC_CW_ADD_VNAME(    'adFv', 'Cen_xy_Hn__-__t', 3,4, myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('adFv',
     &     'units','[cost]/[N/m^2]', myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('adFv','long_name',
     &     'adjoint zonal meridional stress', myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('adFv',
     &     'coordinates','XC YC RC iter', myThid)

#ifdef ALLOW_BOTTOMDRAG_CONTROL
      CALL MNC_CW_ADD_VNAME('adBottomDrag', 'Cen_xy_Hn__-__t',
     &                       3,4, myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('adBottomDrag',
     &     'units','[cost]/[N/m^2]', myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('adBottomDrag','long_name',
     &     'adjoint bottom drag', myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('adBottomDrag',
     &     'coordinates','XC YC RC iter', myThid)
#endif

#ifdef ALLOW_DIFFKR_CONTROL
      CALL MNC_CW_ADD_VNAME('adDiffkr', 'Cen_xy_Hn__C__t', 4,5, myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('adDiffkr',
     & 'units','[cost]/[m^2/s]', myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('adDiffkr',
     & 'long_name','adjoint vertical diffusion', myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('adDiffkr',
     &     'coordinates','XC YC RC iter', myThid)
#endif

#ifdef ALLOW_KAPGM_CONTROL
      CALL MNC_CW_ADD_VNAME('adkapgm', 'Cen_xy_Hn__C__t', 4,5, myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('adkapgm',
     & 'units','[cost]/[m^2/s]', myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('adkapgm',
     & 'long_name','adjoint isopycnal diffusion', myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('adkapgm',
     &     'coordinates','XC YC RC iter', myThid)
#endif

#ifdef ALLOW_KAPREDI_CONTROL
      CALL MNC_CW_ADD_VNAME('adkapredi', 'Cen_xy_Hn__C__t', 4,5, myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('adkapredi',
     & 'units','[cost]/[m^2/s]', myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('adkapredi',
     & 'long_name','adjoint isopycnal diffusion', myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('adkapredi',
     &     'coordinates','XC YC RC iter', myThid)
#endif

#ifdef ALLOW_EXF
c
      CALL MNC_CW_ADD_VNAME('adustress', 'Cen_xy_Hn__-__t', 3,4, myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('adustress',
     &     'units','[cost]/[N/m^2]', myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('adustress','long_name',
     &     'adjoint zonal wind stress', myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('adustress',
     &     'coordinates','XC YC RC iter', myThid)
c
      CALL MNC_CW_ADD_VNAME('advstress', 'Cen_xy_Hn__-__t', 3,4, myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('advstress',
     &     'units','[cost]/[N/m^2]', myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('advstress','long_name',
     &     'adjoint meridional wind stress', myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('advstress',
     &     'coordinates','XC YC RC iter', myThid)
c
      CALL MNC_CW_ADD_VNAME('adhflux', 'Cen_xy_Hn__-__t', 3,4, myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('adhflux',
     &     'units','[cost]/[W/m^2]', myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('adhflux','long_name',
     &     'adjoint net upward heat flux', myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('adhflux',
     &     'coordinates','XC YC RC iter', myThid)
c
      CALL MNC_CW_ADD_VNAME('adsflux', 'Cen_xy_Hn__-__t', 3,4, myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('adsflux',
     &     'units','[cost]/[m/s]', myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('adsflux','long_name',
     &     'adjoint net upward freshwater flux', myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('adsflux',
     &     'coordinates','XC YC RC iter', myThid)
c
# ifdef ALLOW_ATM_TEMP
      CALL MNC_CW_ADD_VNAME('adatemp', 'Cen_xy_Hn__-__t', 3,4, myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('adatemp',
     &     'units','[cost]/[degK]', myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('adatemp','long_name',
     &     'adjoint surface air temperature', myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('adatemp',
     &     'coordinates','XC YC RC iter', myThid)
c
      CALL MNC_CW_ADD_VNAME('adaqh', 'Cen_xy_Hn__-__t', 3,4, myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('adaqh',
     &     'units','[cost]/[kg/kg]', myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('adaqh','long_name',
     &     'adjoint specific humidity', myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('adaqh',
     &     'coordinates','XC YC RC iter', myThid)
c
      CALL MNC_CW_ADD_VNAME('adprecip', 'Cen_xy_Hn__-__t', 3,4, myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('adprecip',
     &     'units','[cost]/[m/s]', myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('adprecip','long_name',
     &     'adjoint precipitation', myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('adprecip',
     &     'coordinates','XC YC RC iter', myThid)
# endif
# ifdef ALLOW_RUNOFF
      CALL MNC_CW_ADD_VNAME('adrunoff', 'Cen_xy_Hn__-__t', 3,4, myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('adrunoff',
     &     'units','[cost]/[m/s]', myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('adrunoff','long_name',
     &     'adjoint runoff', myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('adrunoff',
     &     'coordinates','XC YC RC iter', myThid)
# endif
# ifdef ALLOW_ATM_WIND
      IF ( useAtmWind ) THEN
      CALL MNC_CW_ADD_VNAME('aduwind', 'Cen_xy_Hn__-__t', 3,4, myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('aduwind',
     &     'units','[cost]/[m/s]', myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('aduwind','long_name',
     &     'adjoint zonal wind speed', myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('aduwind',
     &     'coordinates','XC YC RC iter', myThid)
c
      CALL MNC_CW_ADD_VNAME('advwind', 'Cen_xy_Hn__-__t', 3,4, myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('advwind',
     &     'units','[cost]/[m/s]', myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('advwind','long_name',
     &     'adjoint meridional wind speed', myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('advwind',
     &     'coordinates','XC YC RC iter', myThid)
      ENDIF
# endif
# ifdef ALLOW_DOWNWARD_RADIATION
      CALL MNC_CW_ADD_VNAME('adswdown', 'Cen_xy_Hn__-__t', 3,4, myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('adswdown',
     &     'units','[cost]/[W/m^2]', myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('adswdown','long_name',
     &     'adjoint downward shortwave radiation', myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('adswdown',
     &     'coordinates','XC YC RC iter', myThid)
      CALL MNC_CW_ADD_VNAME('adlwdown', 'Cen_xy_Hn__-__t', 3,4, myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('adlwdown',
     &     'units','[cost]/[W/m^2]', myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('adlwdown','long_name',
     &     'adjoint downward wave radiation', myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('adlwdown',
     &     'coordinates','XC YC RC iter', myThid)
# endif
# ifdef ALLOW_CLIMSST_RELAXATION
      CALL MNC_CW_ADD_VNAME('adclimsst', 'Cen_xy_Hn__-__t', 3,4, myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('adclimsst',
     &     'units','[cost]/[degC]', myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('adclimsst','long_name',
     &     'adjoint sea surface temperature', myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('adclimsst',
     &     'coordinates','XC YC RC iter', myThid)
# endif
# ifdef ALLOW_CLIMSSS_RELAXATION
      CALL MNC_CW_ADD_VNAME('adclimsss', 'Cen_xy_Hn__-__t', 3,4, myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('adclimsss',
     &     'units','[cost]/[g/kg]', myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('adclimsss','long_name',
     &     'adjoint sea surface salinity', myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('adclimsss',
     &     'coordinates','XC YC RC iter', myThid)
# endif
c
#endif

#ifdef ALLOW_SEAICE
c
      CALL MNC_CW_ADD_VNAME('adarea', 'Cen_xy_Hn__-__t', 3,4, myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('adarea',
     &     'units','[cost]/[m^2/m^2]', myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('adarea','long_name',
     &     'adjoint fractional ice-covered area', myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('adarea',
     &     'coordinates','XC YC RC iter', myThid)
c
      CALL MNC_CW_ADD_VNAME('adheff', 'Cen_xy_Hn__-__t', 3,4, myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('adheff',
     &     'units','[cost]/[m]', myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('adheff','long_name',
     &     'adjoint effective ice thickness', myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('adheff',
     &     'coordinates','XC YC RC iter', myThid)
c
      CALL MNC_CW_ADD_VNAME('adhsnow', 'Cen_xy_Hn__-__t', 3,4, myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('adhsnow',
     &     'units','[cost]/[m]', myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('adhsnow','long_name',
     &     'adjoint snow thickness', myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('adhsnow',
     &     'coordinates','XC YC RC iter', myThid)
c
# ifdef SEAICE_CGRID
      CALL MNC_CW_ADD_VNAME('aduice', 'U_xy_Hn__-__t', 3,4, myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('aduice',
     &     'units','[cost]/[m/s]', myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('aduice','long_name',
     &     'adjoint zonal ice velocity', myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('aduice',
     &     'coordinates','XG YG RC iter', myThid)
c
      CALL MNC_CW_ADD_VNAME('advice', 'V_xy_Hn__-__t', 3,4, myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('advice',
     &     'units','[cost]/[m/s]', myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('advice','long_name',
     &     'adjoint meridional ice velocity', myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('advice',
     &     'coordinates','XG YG RC iter', myThid)
# endif
c
#endif

CC     Write coordinates to "adstate" file
C      CALL MNC_CW_SET_UDIM('adstate', 0, myThid)
C      CALL MNC_CW_RS_W('R','adstate',0,0,'XC',xC, myThid)
C      CALL MNC_CW_RS_W('R','adstate',0,0,'YC',yC, myThid)
C      CALL MNC_CW_RS_W('R','adstate',0,0,'XU',xG, myThid)
C      CALL MNC_CW_RS_W('R','adstate',0,0,'YU',yC, myThid)
C      CALL MNC_CW_RS_W('R','adstate',0,0,'XV',xC, myThid)
C      CALL MNC_CW_RS_W('R','adstate',0,0,'YV',yG, myThid)
C      CALL MNC_CW_RS_W('R','adstate',0,0,'XG',xG, myThid)
C      CALL MNC_CW_RS_W('R','adstate',0,0,'YG',yG, myThid)
C      CALL MNC_CW_RS_W('R','adstate',0,0,'RC',rC, myThid)
C      CALL MNC_CW_RS_W('R','adstate',0,0,'RF',rF, myThid)
C
C#ifdef ALLOW_EXF
C      CALL MNC_CW_SET_UDIM('adexf', 0, myThid)
C      CALL MNC_CW_RS_W('R','adexf',0,0,'XC',xC, myThid)
C      CALL MNC_CW_RS_W('R','adexf',0,0,'YC',yC, myThid)
C      CALL MNC_CW_RS_W('R','adexf',0,0,'XU',xG, myThid)
C      CALL MNC_CW_RS_W('R','adexf',0,0,'YU',yC, myThid)
C      CALL MNC_CW_RS_W('R','adexf',0,0,'XV',xC, myThid)
C      CALL MNC_CW_RS_W('R','adexf',0,0,'YV',yG, myThid)
C      CALL MNC_CW_RS_W('R','adexf',0,0,'XG',xG, myThid)
C      CALL MNC_CW_RS_W('R','adexf',0,0,'YG',yG, myThid)
C      CALL MNC_CW_RS_W('R','adexf',0,0,'RC',rC, myThid)
C      CALL MNC_CW_RS_W('R','adexf',0,0,'RF',rF, myThid)
C#endif
C
C#ifdef ALLOW_SEAICE
C      CALL MNC_CW_SET_UDIM('adseaice', 0, myThid)
C      CALL MNC_CW_RS_W('R','adseaice',0,0,'XC',xC, myThid)
C      CALL MNC_CW_RS_W('R','adseaice',0,0,'YC',yC, myThid)
C      CALL MNC_CW_RS_W('R','adseaice',0,0,'XU',xG, myThid)
C      CALL MNC_CW_RS_W('R','adseaice',0,0,'YU',yC, myThid)
C      CALL MNC_CW_RS_W('R','adseaice',0,0,'XV',xC, myThid)
C      CALL MNC_CW_RS_W('R','adseaice',0,0,'YV',yG, myThid)
C      CALL MNC_CW_RS_W('R','adseaice',0,0,'XG',xG, myThid)
C      CALL MNC_CW_RS_W('R','adseaice',0,0,'YG',yG, myThid)
C      CALL MNC_CW_RS_W('R','adseaice',0,0,'RC',rC, myThid)
C      CALL MNC_CW_RS_W('R','adseaice',0,0,'RF',rF, myThid)
C#endif

      ENDIF
#endif /* ALLOW_MNC and ALLOW_AUTODIFF_MONITOR */

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      RETURN
      END

#include "OPENAD_OPTIONS.h"
#ifdef ALLOW_STREAMICE
#include "STREAMICE_OPTIONS.h"
#endif

C ###########################################################
      SUBROUTINE DUMMY_IN_STEPPING( myTime, myIter, myThid )

      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "DYNVARS.h"
      _RL     myTime
      INTEGER myIter
      INTEGER myThid
C dummy self dependence (nontrivial so mfef90 doesn't kill it)
      theta(1,1,1,1,1)=2*theta(1,1,1,1,1)
      end subroutine
C ###########################################################
      SUBROUTINE EXCH1_RL(
     U                 array,
     I                 myOLw, myOLe, myOLs, myOLn, myNz,
     I                 exchWidthX, exchWidthY,
     I                 cornerMode, myThid )

      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "EXCH.h"
      INTEGER myOLw, myOLe, myOLs, myOLn, myNz
      _RL     array( 1-myOLw:sNx+myOLe,
     &               1-myOLs:sNy+myOLn,
     &               myNz, nSx, nSy )
      INTEGER exchWidthX
      INTEGER exchWidthY
      INTEGER cornerMode
      INTEGER myThid
C dummy self dependence (nontrivial so mfef90 doesn't kill it)
      array(1,1,1,1,1)=2*array(1,1,1,1,1)
      end subroutine
C ###########################################################
C      SUBROUTINE EXCH1_RS(
C     U                 array,
C     I                 myOLw, myOLe, myOLs, myOLn, myNz,
C     I                 exchWidthX, exchWidthY,
C     I                 cornerMode, myThid )
C
C      IMPLICIT NONE
C#include "SIZE.h"
C#include "EEPARAMS.h"
C#include "EXCH.h"
C      INTEGER myOLw, myOLe, myOLs, myOLn, myNz
C      _RS     array( 1-myOLw:sNx+myOLe,
C     &               1-myOLs:sNy+myOLn,
C     &               myNz, nSx, nSy )
C      INTEGER exchWidthX
C      INTEGER exchWidthY
C      INTEGER cornerMode
C      INTEGER myThid
C      end subroutine
C ###########################################################
C      SUBROUTINE GLOBAL_MAX_R8(
C     U                       maxphi,
C     I                       myThid )
C      IMPLICIT NONE
C#include "SIZE.h"
C#include "EEPARAMS.h"
C#include "EESUPPORT.h"
C#include "EXCH.h"
C      Real*8 maxPhi
C      INTEGER myThid
C      maxPhi=2*maxPhi
C      end subroutine
C ###########################################################
C      SUBROUTINE GLOBAL_SUM_R8(
C     U                       sumphi,
C     I                       myThid )
C      IMPLICIT NONE
C#include "SIZE.h"
C#include "EEPARAMS.h"
C#include "EESUPPORT.h"
C#include "EXCH.h"
C      Real*8 sumPhi
C      INTEGER myThid
CC dummy self dependence (nontrivial so mfef90 doesn't kill it)
C      sumPhi=2*sumPhi
C      end subroutine
C ###########################################################
      SUBROUTINE GLOBAL_SUM_TILE_RL(
     U                       phiTile,
     U                       sumphi,
     I                       myThid )
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "EESUPPORT.h"
#include "EXCH.h"
      _RL phiTile(nSx,nSy)
      _RL sumPhi
      INTEGER myThid
C dummy self dependence (nontrivial so mfef90 doesn't kill it)
      sumPhi=2*phiTile(1,1)
      end subroutine
C ###########################################################
#ifndef ALLOW_STREAMICE
      SUBROUTINE CG2D(
     I                cg2d_b,
     U                cg2d_x,
     O                firstResidual,
     O                minResidualSq,
     O                lastResidual,
     U                numIters,
     O                nIterMin,
     I                myThid )
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "CG2D.h"
      Real*8  cg2d_b(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      Real*8  cg2d_x(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      Real*8  firstResidual
      Real*8  minResidualSq
      Real*8  lastResidual
      INTEGER numIters
      INTEGER nIterMin
      INTEGER myThid
C dummy self dependence (nontrivial so mfef90 doesn't kill it)
      cg2d_x(1,1,1,1)=2*cg2d_b(1,1,1,1)
      end subroutine
#endif
C ###########################################################
#ifdef ALLOW_STREAMICE
      SUBROUTINE STREAMICE_CG_SOLVE(
     U                               cg_Uin,     ! x-velocities
     U                               cg_Vin,     ! y-velocities
     I                               cg_Bu,      ! force in x dir
     I                               cg_Bv,      ! force in y dir
     I                               A_uu,       ! section of matrix that multiplies u and projects on u
     I                               A_uv,       ! section of matrix that multiplies v and projects on u
     I                               A_vu,       ! section of matrix that multiplies u and projects on v
     I                               A_vv,       ! section of matrix that multiplies v and projects on v
     I                               tolerance,
     O                               iters,
     I                               maxiter,
     I                               myThid )
      IMPLICIT NONE

#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "STREAMICE.h"
#include "STREAMICE_CG.h"
      INTEGER myThid
      INTEGER iters
      INTEGER maxiter
      _RL tolerance
      _RL cg_Uin (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL cg_Vin (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL cg_Bu (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL cg_Bv (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL
     & A_uu (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy,-1:1,-1:1),
     & A_vu (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy,-1:1,-1:1),
     & A_uv (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy,-1:1,-1:1),
     & A_vv (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy,-1:1,-1:1)

      cg_Uin(1,1,1,1) = A_uu(1,1,1,1,1,1) + A_uv(1,1,1,1,1,1) +
     & A_vu(1,1,1,1,1,1) + A_vv(1,1,1,1,1,1) + cg_Bu(1,1,1,1)

      cg_Vin(1,1,1,1) = A_uu(1,1,1,1,1,1) + A_uv(1,1,1,1,1,1) +
     & A_vu(1,1,1,1,1,1) + A_vv(1,1,1,1,1,1) + cg_Bv(1,1,1,1)

      end subroutine
#endif /* ALLOW_STREAMICE */
C ###########################################################
#ifdef ALLOW_STREAMICE
       SUBROUTINE STREAMICE_INVERT_SURF_FORTHICK (
     O            H,
     I            s,
     I            R,
     I            delta,
     I            myThid)

#include "SIZE.h"
#include "GRID.h"
#include "SET_GRID.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "STREAMICE.h"

      _RL H(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL S(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL R(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL DELTA
      INTEGER myThid
#ifdef STREAMICE_ALLOW_DEPTH_CONTROL
      H(1,1,1,1) = s(1,1,1,1) +
     &  R(1,1,1,1)
#endif

      end subroutine
#endif /* ALLOW_STREAMICE */
C ###########################################################
#ifdef ALLOW_STREAMICE
       SUBROUTINE STREAMICE_SMOOTH_ADJOINT_FIELD (
     O            X,
     I            myThid)

#include "SIZE.h"
#include "GRID.h"
#include "EEPARAMS.h"

      _RL X(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      INTEGER myThid

      INTEGER i, j, bi, bj, k
      _RL q_int1 (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL q_int2 (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)

      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx

          q_int1(i,j,bi,bj) = 0.0
          q_int2(i,j,bi,bj) = 0.0
          X(i,j,bi,bj) = X(i,j,bi,bj) * 1.0
          k=0
         ENDDO
        ENDDO
       ENDDO
      ENDDO


      end subroutine
#endif /* ALLOW_STREAMICE */
C ###########################################################
      subroutine active_read_xyz(
     I                           active_var_file,
     O                           active_var,
     I                           iRec,
     I                           doglobalread,
     I                           lAdInit,
     I                           myOptimIter,
     I                           myThid,
     I                           dummy
     &                         )
! xxx template ad_template.active_read_xyz.f90
        implicit none
!     == global variables ==
#include "EEPARAMS.h"
#include "SIZE.h"
      CHARACTER*(*) active_var_file
      _RL     active_var(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      INTEGER iRec
      INTEGER myOptimIter
      INTEGER myThid
      LOGICAL doglobalread
      LOGICAL lAdInit
      _RL     dummy
#ifdef ALLOW_OPENAD_ACTIVE_READ_XYZ
      active_var = dummy + active_var
      dummy = active_var(1,1,1,1,1) + dummy
#endif /* ALLOW_OPENAD_ACTIVE_READ_XYZ */
      end subroutine
C ###########################################################
      subroutine active_read_xy(
     I                           active_var_file,
     O                           active_var,
     I                           iRec,
     I                           doglobalread,
     I                           lAdInit,
     I                           myOptimIter,
     I                           myThid,
     I                           dummy
     &                         )
! xxx template ad_template.active_read_xy.f90
        implicit none
!     == global variables ==
#include "EEPARAMS.h"
#include "SIZE.h"
      CHARACTER*(*) active_var_file
      _RL     active_var(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      INTEGER iRec
      INTEGER myOptimIter
      INTEGER myThid
      LOGICAL doglobalread
      LOGICAL lAdInit
      _RL     dummy
#ifdef ALLOW_OPENAD_ACTIVE_READ_XY
      active_var = dummy + active_var
      dummy = active_var(1,1,1,1) + dummy
#endif /* ALLOW_OPENAD_ACTIVE_READ_XY */
      end subroutine
C ###########################################################
      subroutine active_write_xy(
     I                           active_var_file,
     I                           active_var,
     I                           iRec,
     I                           myOptimIter,
     I                           myThid,
     I                           dummy
     &                         )
! xxx template ad_template.active_write_xy.f90
        implicit none
!     == global variables ==
#include "EEPARAMS.h"
#include "SIZE.h"
      CHARACTER*(*) active_var_file
      _RL     active_var(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      INTEGER iRec
      INTEGER myOptimIter
      INTEGER myThid
      _RL     dummy
#ifdef ALLOW_OPENAD_ACTIVE_WRITE
      active_var = dummy + active_var
      dummy = active_var(1,1,1,1) + dummy
#endif /* ALLOW_OPENAD_ACTIVE_WRITE */
      end subroutine
C ###########################################################

#include "EXF_OPTIONS.h"
#ifdef ALLOW_AUTODIFF
# include "AUTODIFF_OPTIONS.h"
#endif

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: ADEXF_MONITOR

C     !INTERFACE:
      SUBROUTINE ADEXF_MONITOR(
     I     iwhen, myTime, myIter, myThid )

C     !DESCRIPTION:
C     Print some statistics about input forcing fields.

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "EXF_PARAM.h"
#include "EXF_FIELDS.h"
#ifdef ALLOW_MONITOR
# include "MONITOR.h"
#endif
#ifdef ALLOW_MNC
# include "MNC_PARAMS.h"
#endif
#ifdef ALLOW_AUTODIFF
# ifdef ALLOW_AUTODIFF_MONITOR
#  include "adcommon.h"
# endif
#endif

C     !INPUT PARAMETERS:
      INTEGER iwhen
      _RL myTime
      INTEGER myIter
      INTEGER myThid
CEOP

#if ( defined (ALLOW_MONITOR) && defined (ALLOW_AUTODIFF_MONITOR) )

C     === Functions ====
      LOGICAL  DIFFERENT_MULTIPLE
      EXTERNAL DIFFERENT_MULTIPLE
      LOGICAL  MASTER_CPU_IO
      EXTERNAL MASTER_CPU_IO

C     == Local variables ==
      _RL dummyRL(6)
      CHARACTER*(MAX_LEN_MBUF) msgBuf
#ifdef ALLOW_MNC
      INTEGER k
#endif
      LOGICAL printMonitorHeader

      IF ( exf_adjMonSelect .GT. 0 .AND.
     &     DIFFERENT_MULTIPLE(exf_adjMonFreq,myTime,deltaTClock) ) THEN

       IF ( MASTER_CPU_IO(myThid) ) THEN
C--   only the master thread is allowed to switch On/Off mon_write_stdout
C     & mon_write_mnc (since it is the only thread that uses those flags):

        printMonitorHeader = ( iwhen .EQ. 3 )
     &       .OR. ( iwhen .EQ. 1 .AND. exf_adjMonSelect .GE. 3 )
     &       .OR. ( iwhen .EQ. 2 .AND. exf_adjMonSelect .GE. 2 )

        IF ( printMonitorHeader ) THEN

          IF (monitor_stdio) THEN
            mon_write_stdout = .TRUE.
          ELSE
            mon_write_stdout = .FALSE.
          ENDIF
          mon_write_mnc = .FALSE.
#ifdef ALLOW_MNC
          IF (useMNC .AND. monitor_mnc) THEN
            DO k = 1,MAX_LEN_MBUF
              mon_fname(k:k) = ' '
            ENDDO
            mon_fname(1:13) = 'admonitor_exf'
            CALL MNC_CW_APPEND_VNAME(
     &           'T', '-_-_--__-__t', 0,0, myThid)
            CALL MNC_CW_SET_UDIM(mon_fname, -1, myThid)
            CALL MNC_CW_RL_W_S(
     &          'D',mon_fname,1,1,'T', myTime, myThid)
            CALL MNC_CW_SET_UDIM(mon_fname, 0, myThid)
            mon_write_mnc = .TRUE.
          ENDIF
#endif /* ALLOW_MNC */

          IF ( mon_write_stdout ) THEN
            WRITE(msgBuf,'(2A)') '// ===========================',
     &           '============================'
            CALL PRINT_MESSAGE(msgBuf, mon_ioUnit, SQUEEZE_RIGHT, 1)
            WRITE(msgBuf,'(A,I2)')
     &           '// Begin AD_MONITOR EXF statistics for iwhen = ',
     &           iwhen
            CALL PRINT_MESSAGE(msgBuf, mon_ioUnit, SQUEEZE_RIGHT, 1)
            WRITE(msgBuf,'(2A)') '// ===========================',
     &           '============================'
            CALL PRINT_MESSAGE(msgBuf, mon_ioUnit, SQUEEZE_RIGHT, 1)
          ENDIF

C--   endif printMonitorHeader
        ENDIF
C--   endif master cpu io
       ENDIF

        CALL MON_SET_PREF('ad_exf',myThid)
        CALL MON_OUT_I ('_tsnumber', myIter,mon_string_none,myThid)
        CALL MON_OUT_RL('_time_sec', myTime,mon_string_none,myThid)

       IF ( iwhen .EQ. 1 .AND. exf_adjMonSelect .GE. 3 ) THEN

C       Print some statistics about input forcing fields
        IF ( stressIsOnCgrid ) THEN
          CALL MON_WRITESTATS_RL( 1, adustress, '_adustress',
     &             maskInW, maskInW, rAw, drF, dummyRL, myThid )
          CALL MON_WRITESTATS_RL( 1, advstress, '_advstress',
     &             maskInS, maskInS, rAs, drF, dummyRL, myThid )
        ELSE
          CALL MON_WRITESTATS_RL( 1, adustress, '_adustress',
     &             maskInC, maskInC, rA , drF, dummyRL, myThid )
          CALL MON_WRITESTATS_RL( 1, advstress, '_advstress',
     &             maskInC, maskInC, rA , drF, dummyRL, myThid )
        ENDIF
        CALL MON_WRITESTATS_RL( 1, adhflux,   '_adhflux',
     &           maskInC, maskInC, rA , drF, dummyRL, myThid )
        CALL MON_WRITESTATS_RL( 1, adsflux,   '_adsflux',
     &           maskInC, maskInC, rA , drF, dummyRL, myThid )
#ifdef SHORTWAVE_HEATING
        CALL MON_WRITESTATS_RL( 1, adswflux,  '_adswflux',
     &           maskInC, maskInC, rA , drF, dummyRL, myThid )
#endif
        CALL MON_WRITESTATS_RL( 1, adwspeed,  '_adwspeed',
     &           maskInC, maskInC, rA , drF, dummyRL, myThid )

       ELSEIF ( iwhen .EQ. 2 .AND. exf_adjMonSelect .GE. 2 ) THEN

        IF ( useAtmWind ) THEN
         CALL MON_WRITESTATS_RL( 1, aduwind,  '_aduwind',
     &            maskInC, maskInC, rA , drF, dummyRL, myThid )
         CALL MON_WRITESTATS_RL( 1, advwind,  '_advwind',
     &            maskInC, maskInC, rA , drF, dummyRL, myThid )
        ENDIF
#ifdef ALLOW_ATM_TEMP
        CALL MON_WRITESTATS_RL( 1, adatemp,   '_adatemp',
     &           maskInC, maskInC, rA , drF, dummyRL, myThid )
        CALL MON_WRITESTATS_RL( 1, adaqh,     '_adaqh',
     &           maskInC, maskInC, rA , drF, dummyRL, myThid )
        CALL MON_WRITESTATS_RL( 1, adprecip,  '_adprecip',
     &           maskInC, maskInC, rA , drF, dummyRL, myThid )
        IF ( lwfluxfile.NE.' ' .OR. lwdownfile.EQ.' ' ) THEN
         CALL MON_WRITESTATS_RL( 1, adlwflux, '_adlwflux',
     &           maskInC, maskInC, rA , drF, dummyRL, myThid )
        ENDIF
#endif /* ALLOW_ATM_TEMP */
#if defined(ALLOW_ATM_TEMP) || defined(SHORTWAVE_HEATING)
        IF ( swfluxfile.NE.' ' .OR. swdownfile.EQ.' ' ) THEN
         CALL MON_WRITESTATS_RL( 1, adswflux, '_adswflux',
     &           maskInC, maskInC, rA , drF, dummyRL, myThid )
        ENDIF
#endif
#ifdef ALLOW_DOWNWARD_RADIATION
        CALL MON_WRITESTATS_RL( 1, adlwdown,  '_adlwdown',
     &           maskInC, maskInC, rA , drF, dummyRL, myThid )
        CALL MON_WRITESTATS_RL( 1, adswdown,  '_adswdown',
     &           maskInC, maskInC, rA , drF, dummyRL, myThid )
#endif
#ifdef ALLOW_RUNOFF
        CALL MON_WRITESTATS_RL( 1, adrunoff,  '_adrunoff',
     &           maskInC, maskInC, rA , drF, dummyRL, myThid )
#endif
#ifdef ATMOSPHERIC_LOADING
cph        CALL MON_WRITESTATS_RL( 1,adapressure,'_adapressure',
cph     &           maskInC, maskInC, rA , drF, dummyRL, myThid )
#endif
#ifdef EXF_SEAICE_FRACTION
cph        CALL MON_WRITESTATS_RL( 1, areamask,'_areamask',
cph     &           maskInC, maskInC, rA , drF, dummyRL, myThid )
#endif
#ifdef ALLOW_CLIMSST_RELAXATION
cph        CALL MON_WRITESTATS_RL( 1, climsst, '_climsst',
cph     &           maskInC, maskInC, rA , drF, dummyRL, myThid )
#endif
#ifdef ALLOW_CLIMSSS_RELAXATION
cph        CALL MON_WRITESTATS_RL( 1, climsss, '_climsss',
cph     &           maskInC, maskInC, rA , drF, dummyRL, myThid )
#endif
#ifdef ALLOW_CLIMSTRESS_RELAXATION
cph          CALL MON_WRITESTATS_RL( 1, climustr, '_climustr',
cph     &             maskInW, maskInW, rAw, drF, dummyRL, myThid )
cph          CALL MON_WRITESTATS_RL( 1, climvstr, '_climvstr',
cph     &             maskInS, maskInS, rAs, drF, dummyRL, myThid )
#endif

       ELSEIF ( iwhen .EQ. 3 ) THEN

          CALL MON_WRITESTATS_RS( 1, adfu, '_adfu',
     &             maskInC, maskInC, rA , drF, dummyRL, myThid )
          CALL MON_WRITESTATS_RS( 1, adfv, '_adfv',
     &             maskInC, maskInC, rA , drF, dummyRL, myThid )
          CALL MON_WRITESTATS_RS( 1, adqnet, '_adqnet',
     &           maskInC, maskInC, rA , drF, dummyRL, myThid )
          CALL MON_WRITESTATS_RS( 1, adempmr, '_adempmr',
     &           maskInC, maskInC, rA , drF, dummyRL, myThid )
#ifdef SHORTWAVE_HEATING
          CALL MON_WRITESTATS_RS( 1, adqsw, '_adqsw',
     &           maskInC, maskInC, rA , drF, dummyRL, myThid )
#endif

       ENDIF

       IF ( MASTER_CPU_IO(myThid) ) THEN
C--   only the master thread is allowed to switch On/Off mon_write_stdout
C     & mon_write_mnc (since it is the only thread that uses those flags):

        IF ( printMonitorHeader ) THEN

          IF ( mon_write_stdout ) THEN
            WRITE(msgBuf,'(2A)') '// ===========================',
     &           '============================'
            CALL PRINT_MESSAGE(msgBuf, mon_ioUnit, SQUEEZE_RIGHT, 1)
            WRITE(msgBuf,'(A,I2)')
     &           '// End AD_MONITOR EXF statistics for iwhen = ',
     &           iwhen
            CALL PRINT_MESSAGE(msgBuf, mon_ioUnit, SQUEEZE_RIGHT, 1)
            WRITE(msgBuf,'(2A)') '// ===========================',
     &           '============================'
            CALL PRINT_MESSAGE(msgBuf, mon_ioUnit, SQUEEZE_RIGHT, 1)
          ENDIF

          mon_write_stdout = .FALSE.
          mon_write_mnc    = .FALSE.

C--   endif printMonitorHeader
        ENDIF
C--   endif master cpu io
       ENDIF

C     endif different multiple
      ENDIF

#endif /* ALLOW_MONITOR */

      RETURN
      END

#include "FLT_OPTIONS.h"

      SUBROUTINE FLT_DOWN (
     I                      myTime, myIter, myThid )

C     ==================================================================
C     SUBROUTINE FLT_DOWN
C     ==================================================================
C     o This routine moves particles vertical from the surface to
C       the target depth
C     ==================================================================

C     !USES:
      IMPLICIT NONE

C     == global variables ==
#include "EEPARAMS.h"
#include "SIZE.h"
#include "FLT_SIZE.h"
#include "FLT.h"

C     == routine arguments ==
      _RL myTime
      INTEGER myIter, myThid

C     == local variables ==
      INTEGER bi, bj
      INTEGER ip

C     == end of interface ==

      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)

        DO ip=1,npart_tile(bi,bj)

         IF (
     &  (                             myTime.GE.tstart(ip,bi,bj))
     &   .AND.
     &  (  tend(ip,bi,bj).EQ.-1. .OR. myTime.LE.  tend(ip,bi,bj))
     &   .AND.
     &  (kpart(ip,bi,bj) .LE. flt_surf)
     &   .AND.
     &  (iup(ip,bi,bj)   .GT. 0.)
     &      ) THEN

c         IF (tstart(ip,bi,bj) .NE. -1.              .AND.
c     &      myTime    .GE. tstart(ip,bi,bj) .AND.
c     &      myTime    .LE.   tend(ip,bi,bj) .AND.
c     &      kpart(ip,bi,bj) .EQ. flt_surf .AND.
c     &      iup(ip,bi,bj)   .GT. 0.) THEN

C     move float to the target depth

           IF (mod(myTime,iup(ip,bi,bj)).EQ.itop(ip,bi,bj))
     &      kpart(ip,bi,bj) = kfloat(ip,bi,bj)

         ENDIF
        ENDDO

       ENDDO
      ENDDO

      RETURN
      END

#include "DEBUG_OPTIONS.h"

      SUBROUTINE DEBUG_CS_CORNER_UV(
     I                 word2print,
     I                 uFld, vFld,
     I                 k, ioUnit, bi,bj, myThid )
C     *==========================================================*
C     | S/R DEBUG_CS_CORNER_UV                                   |
C     | o check UV fields at Egdes of CS grid, near corners.     |
C     *==========================================================*
C     | Values of U,V fields at the Edges of the CS grid         |
C     |  are common to 2 faces, and are stored + used in 2       |
C     |  places (2 tiles): one in the interior of the 1rst tile, |
C     |  the other in the halo of the 2nd one.                   |
C     | This S/R print the 2 values and  check that they are     |
C     |  identical (print the difference).                       |
C     | This is specially usefull for checking that gU,gV are    |
C     |  correct before entering solve_for_pressure.             |
C     *==========================================================*
C     | Note: only works on a 1.cpu set up with square tiles     |
C     *==========================================================*
      IMPLICIT NONE

C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#ifdef ALLOW_EXCH2
#include "W2_EXCH2_SIZE.h"
#include "W2_EXCH2_TOPOLOGY.h"
#endif
c #include "PARAMS.h"
c #include "GRID.h"

C     == Routine arguments ==
C     word2print :: a string to print
C     uFld   :: u component of 2D vector
C     vFld   :: v component of 2D vector
C     k      :: current level
C     ioUnit :: I/O unit number
C     bi,bj  :: tile indices
C     myThid :: Instance number for this invocation of
      CHARACTER*(*) word2print
      _RL uFld(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL vFld(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER k, ioUnit
      INTEGER bi, bj
      INTEGER myThid

#ifdef ALLOW_DEBUG

C     == Local variables in common block :
      COMMON / DEBUG_CS_CORNER_UV_LOCAL / tmpU, tmpV
      _RL tmpU(4,Nr,nSx*nSy)
      _RL tmpV(4,Nr,nSx*nSy)

C     == Local variables ==
C     edgeIndex :: index (in X or Y) from the W. or S. edge of the tile
C               :: of the U,V field to write
C     n1        :: combined bi,bj index for current tile
C     n2, n3    :: combined bi,bj index for W. and S. neigbour tile
C     t1        :: current tile id
C     t2, t3    :: tile id of W. and S. neigbour tile
#ifdef ALLOW_EXCH2
      INTEGER t1, t2, t3
#endif
      INTEGER n1, n2, n3
      INTEGER edgeIndex
      INTEGER ic, i, j

      EXTERNAL ILNBLNK
      INTEGER  ILNBLNK

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

       edgeIndex = 1

       j = MIN(MAX(1-Olx,edgeIndex),Olx)
       n1 = bi + (bj-1)*nSx
 1010 FORMAT(2A,I2,1PE12.4,I3,1P2E12.4)
c     IF (k.EQ.4 .AND. myIter.EQ.nIter0 ) THEN
       tmpU(1,k,n1)= uFld(1,j)
       tmpU(2,k,n1)= uFld(1,sNy+1-j)
       tmpU(3,k,n1)= uFld(sNx+1,j)
       tmpU(4,k,n1)= uFld(sNx+1,sNy+1-j)
       tmpV(1,k,n1)= vFld(j,1)
       tmpV(2,k,n1)= vFld(sNx+1-j,1)
       tmpV(3,k,n1)= vFld(j,sNy+1)
       tmpV(4,k,n1)= vFld(sNx+1-j,sNy+1)
       _BARRIER
#ifdef ALLOW_EXCH2
       IF (bi.EQ.nSx .AND. bj.EQ.nSy .AND. sNx.EQ.sNy) THEN
#else /* ALLOW_EXCH2 */
       IF (bi.EQ.nSx .AND. nSy.EQ.1  .AND. nSx.EQ.6) THEN
#endif /* ALLOW_EXCH2 */
        WRITE(ioUnit,'(2A)') 'DEBUG_CS_CORNER_UV: ',
     &   '------------------------------------------------------------'
        ic = MAX(1,ILNBLNK(word2print))
        WRITE(ioUnit,'(3A,I3)') 'DEBUG_CS_CORNER_UV: ',
     &        word2print(1:ic), ' , index=', j
        WRITE(ioUnit,'(2A,I4)') 'DEBUG_CS_CORNER_UV: ',
     &       ' Edges values near a corner, lev=',k
        WRITE(ioUnit,'(2A)') 'DEBUG_CS_CORNER_UV: ',
     &     '      tile_1, value_1, tile_2, value_2, difference v1-v2:'
        DO j=1,nSy
         DO i=1,nSx
#ifdef ALLOW_EXCH2
          n1 = i + (j-1)*nSx
          n2 = 0
          n3 = 0
          t1 = W2_myTileList(i,j)
          t2 = exch2_neighbourId(4,t1)
          t3 = exch2_neighbourId(2,t1)
          IF ( W2_tileProc(t2).EQ.myProcId+1 ) n2 = W2_tileIndex(t2)
          IF ( W2_tileProc(t3).EQ.myProcId+1 ) n3 = W2_tileIndex(t3)

          IF ( n2.GE.1 .AND. exch2_pij(3,4,t1).EQ.-1 ) THEN
           WRITE(ioUnit,1010) 'DEBUG_CS_CORNER_UV: ', 'W edge, S:',
     &       t1,tmpU(1,k,n1), t2,tmpV(4,k,n2),
     &          tmpU(1,k,n1)  -  tmpV(4,k,n2)
           WRITE(ioUnit,1010) 'DEBUG_CS_CORNER_UV: ', 'W edge, N:',
     &       t1,tmpU(2,k,n1), t2,tmpV(3,k,n2),
     &          tmpU(2,k,n1)  -  tmpV(3,k,n2)
          ENDIF
          IF ( n2.GE.1 .AND. exch2_pij(4,4,t1).EQ.1 ) THEN
           WRITE(ioUnit,1010) 'DEBUG_CS_CORNER_UV: ', 'W edge, S:',
     &       t1,tmpU(1,k,n1), t2,tmpU(3,k,n2),
     &          tmpU(1,k,n1)  -  tmpU(3,k,n2)
           WRITE(ioUnit,1010) 'DEBUG_CS_CORNER_UV: ', 'W edge, N:',
     &       t1,tmpU(2,k,n1), t2,tmpU(4,k,n2),
     &          tmpU(2,k,n1)  -  tmpU(4,k,n2)
          ENDIF
          IF ( n3.GE.1 .AND. exch2_pij(1,2,t1).EQ.1 ) THEN
           WRITE(ioUnit,1010) 'DEBUG_CS_CORNER_UV: ', 'S edge, W:',
     &       t1,tmpV(1,k,n1), t3,tmpV(3,k,n3),
     &          tmpV(1,k,n1)  -  tmpV(3,k,n3)
           WRITE(ioUnit,1010) 'DEBUG_CS_CORNER_UV: ', 'S edge, E:',
     &       t1,tmpV(2,k,n1), t3,tmpV(4,k,n3),
     &          tmpV(2,k,n1)  -  tmpV(4,k,n3)
          ENDIF
          IF (  n3.GE.1 .AND. exch2_pij(2,2,t1).EQ.-1 ) THEN
           WRITE(ioUnit,1010) 'DEBUG_CS_CORNER_UV: ', 'S edge, W:',
     &       t1,tmpV(1,k,n1), t3,tmpU(4,k,n3),
     &          tmpV(1,k,n1)  -  tmpU(4,k,n3)
           WRITE(ioUnit,1010) 'DEBUG_CS_CORNER_UV: ', 'S edge, E:',
     &       t1,tmpV(2,k,n1), t3,tmpU(3,k,n3),
     &          tmpV(2,k,n1)  -  tmpU(3,k,n3)
          ENDIF
#else /* ALLOW_EXCH2 */
          n1 = i
          IF (MOD(n1,2).EQ.1 ) THEN
c          n1=1 n2=5,+v,-
c          n1=1 n3=6,+v,+
c          n1=3 n2=1,+v,-
c          n1=3 n3=2,+v,+
c          n1=5 n2=3,+v,-
c          n1=5 n3=4,+v,+
           n2 = 1+MOD(n1-2+5,6)
           n3 = 1+MOD(n1-1+5,6)
           WRITE(ioUnit,1010) 'DEBUG_CS_CORNER_UV: ', 'W edge, S:',
     &       n1,tmpU(1,k,n1), n2,tmpV(4,k,n2),
     &          tmpU(1,k,n1)  -  tmpV(4,k,n2)
           WRITE(ioUnit,1010) 'DEBUG_CS_CORNER_UV: ', 'W edge, N:',
     &       n1,tmpU(2,k,n1), n2,tmpV(3,k,n2),
     &          tmpU(2,k,n1)  -  tmpV(3,k,n2)
           WRITE(ioUnit,1010) 'DEBUG_CS_CORNER_UV: ', 'S edge, W:',
     &       n1,tmpV(1,k,n1), n3,tmpV(3,k,n3),
     &          tmpV(1,k,n1)  -  tmpV(3,k,n3)
           WRITE(ioUnit,1010) 'DEBUG_CS_CORNER_UV: ', 'S edge, E:',
     &       n1,tmpV(2,k,n1), n3,tmpV(4,k,n3),
     &          tmpV(2,k,n1)  -  tmpV(4,k,n3)
          ELSE
c          n1=2 n2=1,+u,+
c          n1=2 n3=6,+u,-
c          n1=4 n2=3,+u,+
c          n1=4 n3=2,+u,-
c          n1=6 n2=5,+u,+
c          n1=6 n3=4,+u,-
           n2 = 1+MOD(n1-1+5,6)
           n3 = 1+MOD(n1-2+5,6)
           WRITE(ioUnit,1010) 'DEBUG_CS_CORNER_UV: ', 'W edge, S:',
     &       n1,tmpU(1,k,n1), n2,tmpU(3,k,n2),
     &          tmpU(1,k,n1)  -  tmpU(3,k,n2)
           WRITE(ioUnit,1010) 'DEBUG_CS_CORNER_UV: ', 'W edge, N:',
     &       n1,tmpU(2,k,n1), n2,tmpU(4,k,n2),
     &          tmpU(2,k,n1)  -  tmpU(4,k,n2)
           WRITE(ioUnit,1010) 'DEBUG_CS_CORNER_UV: ', 'S edge, W:',
     &       n1,tmpV(1,k,n1), n3,tmpU(4,k,n3),
     &          tmpV(1,k,n1)  -  tmpU(4,k,n3)
           WRITE(ioUnit,1010) 'DEBUG_CS_CORNER_UV: ', 'S edge, E:',
     &       n1,tmpV(2,k,n1), n3,tmpU(3,k,n3),
     &          tmpV(2,k,n1)  -  tmpU(3,k,n3)
          ENDIF
#endif /* ALLOW_EXCH2 */
         ENDDO
        ENDDO
        WRITE(ioUnit,'(2A)') 'DEBUG_CS_CORNER_UV: ',
     &   '------------------------------------------------------------'
       ENDIF
c     ENDIF

#endif /* ALLOW_DEBUG */

      RETURN
      END

#include "EXF_OPTIONS.h"

C--  File exf_check.F: Routines to check EXF settings
C--   Contents
C--   o EXF_CHECK
C--   o EXF_CHECK_INTERP

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: EXF_CHECK
C     !INTERFACE:

      SUBROUTINE EXF_CHECK( myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R EXF_CHECK
C     | o Check parameters and other package dependences
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     == Global variables ===
#include "EEPARAMS.h"
#include "SIZE.h"
#include "PARAMS.h"

#include "EXF_PARAM.h"
#include "EXF_CONSTANTS.h"
#include "EXF_INTERP_SIZE.h"
#include "EXF_INTERP_PARAM.h"

C     !INPUT/OUTPUT PARAMETERS:
C     myThid   :: my Thread Id number
      INTEGER myThid

C     !LOCAL VARIABLES:
C     msgBuf   :: Informational/error message buffer
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      INTEGER errCount
CEOP

      _BEGIN_MASTER(myThid)
      errCount = 0

      WRITE(msgBuf,'(A)') 'EXF_CHECK: #define ALLOW_EXF'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C--   Check for consistency, main parameters
      IF (.NOT.
     &     (exf_iprec.EQ.precFloat32 .OR. exf_iprec.EQ.precFloat64)
     &     ) THEN
       WRITE(msgBuf,'(A)')
     &      'S/R EXF_CHECK: value of exf_iprec not allowed'
       CALL PRINT_ERROR( msgBuf, myThid )
       errCount = errCount + 1
      ENDIF

      IF ( repeatPeriod.LT.0. ) THEN
C- Note: should check all {fld}RepCycle (not just common defaut repeatPeriod)
       WRITE(msgBuf,'(A)')
     &      'S/R EXF_CHECK: repeatPeriod must be positive'
       CALL PRINT_ERROR( msgBuf, myThid )
       errCount = errCount + 1
      ENDIF

      IF ( useExfYearlyFields ) THEN
       IF ( .NOT.useCAL ) THEN
        WRITE(msgBuf,'(2A)') 'EXF_CHECK: ',
     &       'useExfYearlyFields requires to use pkg/cal (useCAL=T)'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
       ENDIF
       IF ( repeatPeriod.NE.0. ) THEN
C- Note: should check all obcs{N,S,E,W}repCycle (not just default repeatPeriod)
        WRITE(msgBuf,'(2A)') 'EXF_CHECK: The use of ',
     &       'useExfYearlyFields AND repeatPeriod is not implemented'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
       ENDIF
      ENDIF
      IF ( useOBCS .AND. useOBCSYearlyFields ) THEN
       IF ( .NOT.useCAL ) THEN
        WRITE(msgBuf,'(2A)') 'EXF_CHECK: ',
     &       'useOBCSYearlyFields requires to use pkg/cal (useCAL=T)'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
       ENDIF
       IF ( repeatPeriod.NE.0. .AND. (OBCSNperiod.GE.0 .OR.
     &      OBCSSperiod.GE.0 .OR. OBCSWperiod.GE.0 .OR.
     &      OBCSEperiod.GE.0)) THEN
C- Note: should check all siob{N,S,E,W}repCycle (not just default repeatPeriod)
        WRITE(msgBuf,'(2A)') 'EXF_CHECK: ',
     &       'useOBCSYearlyFields not implemented for repeatPeriod <> 0'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
       ENDIF
      ENDIF

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C--   For each field, check for parameter consistency:
C     a) stop when file is specified but not read-in;
C     b) print warning when file is read-in but not used within pkg/exf

C-    Check wind parameters:
      IF ( useAtmWind ) THEN
       IF ( ustressfile .NE. ' ' .OR. vstressfile .NE. ' ' ) THEN
        WRITE(msgBuf,'(A)')
     &   'EXF_CHECK: use u,v_wind components but not wind-stress'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
       ENDIF
      ENDIF

      IF ( .NOT.useAtmWind ) THEN
       IF ( uwindfile .NE. ' ' .OR. vwindfile .NE. ' ' ) THEN
        WRITE(msgBuf,'(A)')
     &   'EXF_CHECK: read-in wind-stress but not u,v_wind components'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
       ENDIF
      ENDIF

#if !(defined ALLOW_ATM_TEMP) || !(defined ALLOW_BULKFORMULAE)
      IF ( wspeedfile.NE.' ' .AND. .NOT.useAtmWind ) THEN
        WRITE(msgBuf,'(3A)') '** WARNING ** EXF_CHECK: "wspeed" ',
     &    'field is loaded from file but not used within pkg/exf'
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
      ENDIF
#endif

C-    Check other field parameters:

#ifdef ALLOW_ATM_TEMP
      IF ( hfluxfile.NE.' ' ) THEN
        WRITE(msgBuf,'(3A)') '** WARNING ** EXF_CHECK: "hflux" ',
     &    'field is loaded from file but not used within pkg/exf'
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
      ENDIF
      IF ( sfluxfile.NE.' ' ) THEN
        WRITE(msgBuf,'(3A)') '** WARNING ** EXF_CHECK: "sflux" ',
     &    'field is loaded from file but not used within pkg/exf'
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
      ENDIF

# ifndef ALLOW_BULKFORMULAE
C-    atemp might be used (outside Bulk-Formulae), e.g. to make snow
c     IF ( atempfile.NE.' ' ) THEN
c       WRITE(msgBuf,'(2A)') '** WARNING ** EXF_CHECK: "atemp" ',
c    &    'field is loaded from file but not used within pkg/exf'
c       CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
c    &                      SQUEEZE_RIGHT, myThid )
c     ENDIF
      IF ( aqhfile.NE.' ' ) THEN
        WRITE(msgBuf,'(2A)') '** WARNING ** EXF_CHECK: "aqh" ',
     &    'field is loaded from file but not used within pkg/exf'
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
      ENDIF
# endif /* ndef ALLOW_BULKFORMULAE */
#else /* ALLOW_ATM_TEMP */
      IF ( atempfile.NE.' ' ) THEN
        WRITE(msgBuf,'(3A)') 'EXF_CHECK: Cannot read-in field ',
     &    '"atemp" with #undef ALLOW_ATM_TEMP'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF
      IF ( aqhfile.NE.' ' ) THEN
        WRITE(msgBuf,'(3A)') 'EXF_CHECK: Cannot read-in field ',
     &    '"aqh" with #undef ALLOW_ATM_TEMP'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF
#endif /* ALLOW_ATM_TEMP */

#if (defined ALLOW_ATM_TEMP) && (defined ALLOW_READ_TURBFLUXES)
# ifdef ALLOW_BULKFORMULAE
      IF ( hs_file.NE.' ' ) THEN
        WRITE(msgBuf,'(2A)') '** WARNING ** EXF_CHECK: "hs" ',
     &    'field is loaded from file but not used within pkg/exf'
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
      ENDIF
      IF ( hl_file.NE.' ' ) THEN
        WRITE(msgBuf,'(2A)') '** WARNING ** EXF_CHECK: "hl" ',
     &    'field is loaded from file but not used within pkg/exf'
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
      ENDIF
# endif /* ALLOW_BULKFORMULAE */
#else /* ALLOW_ATM_TEMP and ALLOW_READ_TURBFLUXES */
      IF ( hs_file.NE.' ' ) THEN
        WRITE(msgBuf,'(3A)') 'EXF_CHECK: Cannot read-in field ',
     &    '"hs" without ALLOW_ATM_TEMP and ALLOW_READ_TURBFLUXES'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF
      IF ( hl_file.NE.' ' ) THEN
        WRITE(msgBuf,'(3A)') 'EXF_CHECK: Cannot read-in field ',
     &    '"hl" without ALLOW_ATM_TEMP and ALLOW_READ_TURBFLUXES'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF
#endif /* ALLOW_ATM_TEMP and ALLOW_READ_TURBFLUXES */

#if !(defined ALLOW_ATM_TEMP) || !(defined EXF_READ_EVAP)
      IF ( evapfile.NE.' ' ) THEN
        WRITE(msgBuf,'(3A)') 'EXF_CHECK: Cannot read-in field ',
     &    '"evap" without ALLOW_ATM_TEMP and EXF_READ_EVAP'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF
#endif /* ndef ALLOW_ATM_TEMP or ndef EXF_READ_EVAP */

#ifndef ALLOW_ATM_TEMP
      IF ( precipfile.NE.' ' ) THEN
        WRITE(msgBuf,'(3A)') 'EXF_CHECK: Cannot read-in field ',
     &    '"precip" with #undef ALLOW_ATM_TEMP'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF
      IF ( snowprecipfile.NE.' ' ) THEN
        WRITE(msgBuf,'(3A)') 'EXF_CHECK: Cannot read-in field ',
     &    '"snowprecip" with #undef ALLOW_ATM_TEMP'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF
# ifndef SHORTWAVE_HEATING
      IF ( swfluxfile.NE.' ' ) THEN
        WRITE(msgBuf,'(3A)') 'EXF_CHECK: Cannot read-in field ',
     &    '"swflux" without ALLOW_ATM_TEMP or SHORTWAVE_HEATING'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF
      IF ( swdownfile.NE.' ' ) THEN
        WRITE(msgBuf,'(3A)') 'EXF_CHECK: Cannot read-in field ',
     &    '"swdown" without ALLOW_ATM_TEMP or SHORTWAVE_HEATING'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF
# endif /* ndef SHORTWAVE_HEATING */
      IF ( lwfluxfile.NE.' ' ) THEN
        WRITE(msgBuf,'(3A)') 'EXF_CHECK: Cannot read-in field ',
     &    '"lwflux" with #undef ALLOW_ATM_TEMP'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF
      IF ( lwdownfile.NE.' ' ) THEN
        WRITE(msgBuf,'(3A)') 'EXF_CHECK: Cannot read-in field ',
     &    '"lwdown" with #undef ALLOW_ATM_TEMP'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF
#endif /* ndef ALLOW_ATM_TEMP */

#ifdef ALLOW_DOWNWARD_RADIATION
# if defined(ALLOW_ATM_TEMP) || defined(SHORTWAVE_HEATING)
      IF ( swdownfile.NE.' ' .AND. swfluxfile.NE.' ' ) THEN
        WRITE(msgBuf,'(2A)') '** WARNING ** EXF_CHECK: "swdown" ',
     &    'field is loaded from file but not used within pkg/exf'
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
      ENDIF
# endif /* ALLOW_ATM_TEMP or SHORTWAVE_HEATING */
# ifdef ALLOW_ATM_TEMP
      IF ( lwdownfile.NE.' ' .AND. lwfluxfile.NE.' ' ) THEN
        WRITE(msgBuf,'(2A)') '** WARNING ** EXF_CHECK: "lwdown" ',
     &    'field is loaded from file but not used within pkg/exf'
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
      ENDIF
# endif /* ALLOW_ATM_TEMP or SHORTWAVE_HEATING */
#else /* ALLOW_DOWNWARD_RADIATION */
      IF ( swdownfile.NE.' ' ) THEN
        WRITE(msgBuf,'(3A)') 'EXF_CHECK: Cannot read-in field ',
     &    '"swdown" with #undef ALLOW_DOWNWARD_RADIATION'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF
      IF ( lwdownfile.NE.' ' ) THEN
        WRITE(msgBuf,'(3A)') 'EXF_CHECK: Cannot read-in field ',
     &    '"lwdown" with #undef ALLOW_DOWNWARD_RADIATION'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF
#endif /* ALLOW_DOWNWARD_RADIATION */

#ifndef ATMOSPHERIC_LOADING
      IF ( apressurefile.NE.' ' ) THEN
        WRITE(msgBuf,'(3A)') 'EXF_CHECK: Cannot read-in field ',
     &    '"apressure" with #undef ATMOSPHERIC_LOADING'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF
#endif /* ndef ATMOSPHERIC_LOADING */

#ifndef EXF_ALLOW_TIDES
      IF ( tidePotFile.NE.' ' ) THEN
        WRITE(msgBuf,'(3A)') 'EXF_CHECK: Cannot read-in field ',
     &    '"tidePot" with #undef EXF_ALLOW_TIDES'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF
#endif /* ndef EXF_SEAICE_FRACTION */

#ifndef EXF_SEAICE_FRACTION
      IF ( areamaskfile.NE.' ' ) THEN
        WRITE(msgBuf,'(3A)') 'EXF_CHECK: Cannot read-in field ',
     &    '"areamask" with #undef EXF_SEAICE_FRACTION'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF
#endif /* ndef EXF_SEAICE_FRACTION */

#ifndef ALLOW_RUNOFF
      IF ( runofffile.NE.' ' ) THEN
        WRITE(msgBuf,'(3A)') 'EXF_CHECK: Cannot read-in field ',
     &    '"runoff" with #undef ALLOW_RUNOFF'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF
#endif /* ndef ALLOW_RUNOFF */

      IF ( runoftempfile.NE.' ' ) THEN
#ifndef ALLOW_RUNOFTEMP
        WRITE(msgBuf,'(3A)') 'EXF_CHECK: Cannot read-in field ',
     &    '"runoftemp" with #undef ALLOW_RUNOFTEMP'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
#endif /* ndef ALLOW_RUNOFTEMP */
       IF ( runofffile.EQ.' ' ) THEN
        WRITE(msgBuf,'(2A)') '** WARNING ** EXF_CHECK: "runoftemp" ',
     &    'field is loaded from file but not used within pkg/exf'
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
       ENDIF
      ENDIF

      IF ( saltflxfile.NE.' ' ) THEN
#ifndef ALLOW_SALTFLX
        WRITE(msgBuf,'(3A)') 'EXF_CHECK: Cannot read-in field ',
     &    '"saltflx" with #undef ALLOW_SALTFLX'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
#endif /* ndef ALLOW_SALTFLX */
       IF ( useSEAICE .OR. useThSIce )  THEN
        WRITE(msgBuf,'(2A)') 'EXF_CHECK: exf salt flux is not',
     &       ' allowed when using either pkg/seaice or pkg/thsice'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
       ENDIF
      ENDIF

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#ifdef ALLOW_ZENITHANGLE
      IF ( ( useExfZenIncoming .OR. select_ZenAlbedo.NE.0 ) .AND.
     &     ( usingCartesianGrid .OR. usingCylindricalGrid ) ) THEN
       WRITE(msgBuf,'(A,A)') 'EXF_CHECK: ZENITHANGLE code ',
     &      'does not work for cartesian and cylindrical grids'
       CALL PRINT_ERROR( msgBuf, myThid )
       errCount = errCount + 1
      ENDIF
      IF ( select_ZenAlbedo.LT.0 .OR. select_ZenAlbedo.GT.3 ) THEN
       WRITE(msgBuf,'(A,A)') 'EXF_CHECK: unsupported ',
     &      'select_ZenAlbedo choice'
       CALL PRINT_ERROR( msgBuf, myThid )
       errCount = errCount + 1
      ENDIF
      IF ( select_ZenAlbedo.EQ.2 ) THEN
       WRITE(msgBuf,'(A,A)')
     &      '** WARNING ** EXF_CHECK: for daily mean albedo, ',
     &      'it is advised to use select_ZenAlbedo.EQ.1 instead of 2'
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                     SQUEEZE_RIGHT, myThid )
      ENDIF
      IF ( select_ZenAlbedo.EQ.3 .AND. swdownperiod.GT.21600. ) THEN
       WRITE(msgBuf,'(A,A)') 'EXF_CHECK: using diurnal albedo ',
     &        'formula requires diurnal downward shortwave forcing'
       CALL PRINT_ERROR( msgBuf, myThid )
       errCount = errCount + 1
      ENDIF
      IF ( select_ZenAlbedo.EQ.3 .AND. swdownperiod.GT.3600. ) THEN
       WRITE(msgBuf,'(3A)') '** WARNING ** EXF_CHECK: ',
     &      'the diurnal albedo formula is likely not safe for such ',
     &      'coarse temporal resolution downward shortwave forcing'
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                     SQUEEZE_RIGHT, myThid )
      ENDIF
#else /* ALLOW_ZENITHANGLE */
      IF ( useExfZenIncoming .OR. select_ZenAlbedo.NE.0 ) THEN
        WRITE(msgBuf,'(A,A)') 'EXF_CHECK: unsupported option',
     &        ' when ALLOW_ZENITHANGLE is not defined'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF
#endif /* ALLOW_ZENITHANGLE */

#ifdef USE_EXF_INTERPOLATION
      IF ( usingCartesianGrid ) THEN
       WRITE(msgBuf,'(A,A)') 'EXF_CHECK: ',
     &      'USE_EXF_INTERPOLATION assumes latitude/longitude'
       CALL PRINT_ERROR( msgBuf, myThid )
       WRITE(msgBuf,'(A,A)') 'EXF_CHECK: ',
     &      'input and output coordinates. Trivial to extend to'
       CALL PRINT_ERROR( msgBuf, myThid )
       WRITE(msgBuf,'(A,A)') 'EXF_CHECK: ',
     &      'cartesian coordinates, but has not yet been done.'
       CALL PRINT_ERROR( msgBuf, myThid )
       errCount = errCount + 1
      ENDIF

      CALL EXF_CHECK_INTERP( 'ustress', ustressfile,
     &         ustress_interpMethod, ustress_nlat,
     &         ustress_nlon, ustress_lon_inc, errCount, myThid )
      CALL EXF_CHECK_INTERP( 'vstress', vstressfile,
     &         vstress_interpMethod, vstress_nlat,
     &         vstress_nlon, vstress_lon_inc, errCount, myThid )
      CALL EXF_CHECK_INTERP( 'hflux', hfluxfile, hflux_interpMethod,
     &     hflux_nlat, hflux_nlon, hflux_lon_inc, errCount, myThid )
      CALL EXF_CHECK_INTERP( 'sflux', sfluxfile, sflux_interpMethod,
     &     sflux_nlat, sflux_nlon, sflux_lon_inc, errCount, myThid )
      CALL EXF_CHECK_INTERP( 'swflux', swfluxfile, swflux_interpMethod,
     &     swflux_nlat, swflux_nlon, swflux_lon_inc, errCount, myThid )
      CALL EXF_CHECK_INTERP( 'runoff', runofffile, runoff_interpMethod,
     &     runoff_nlat, runoff_nlon, runoff_lon_inc, errCount, myThid )
      CALL EXF_CHECK_INTERP( 'saltflx', saltflxfile,
     &         saltflx_interpMethod, saltflx_nlat,
     &         saltflx_nlon, saltflx_lon_inc, errCount, myThid )
      CALL EXF_CHECK_INTERP( 'atemp', atempfile, atemp_interpMethod,
     &     atemp_nlat, atemp_nlon, atemp_lon_inc, errCount, myThid )
      CALL EXF_CHECK_INTERP( 'aqh', aqhfile, aqh_interpMethod,
     &     aqh_nlat, aqh_nlon, aqh_lon_inc, errCount, myThid )
      CALL EXF_CHECK_INTERP( 'hs', hs_file, hs_interpMethod,
     &     hs_nlat, hs_nlon, hs_lon_inc, errCount, myThid )
      CALL EXF_CHECK_INTERP( 'hl', hl_file, hl_interpMethod,
     &     hl_nlat, hl_nlon, hl_lon_inc, errCount, myThid )
      CALL EXF_CHECK_INTERP( 'evap', evapfile, evap_interpMethod,
     &     evap_nlat, evap_nlon, evap_lon_inc, errCount, myThid )
      CALL EXF_CHECK_INTERP( 'precip', precipfile, precip_interpMethod,
     &     precip_nlat, precip_nlon, precip_lon_inc, errCount, myThid )
      CALL EXF_CHECK_INTERP( 'snowprecip', snowprecipfile,
     &         snowprecip_interpMethod, snowprecip_nlat,
     &         snowprecip_nlon, snowprecip_lon_inc, errCount, myThid )
      CALL EXF_CHECK_INTERP( 'uwind', uwindfile, uwind_interpMethod,
     &     uwind_nlat, uwind_nlon, uwind_lon_inc, errCount, myThid )
      CALL EXF_CHECK_INTERP( 'vwind', vwindfile, vwind_interpMethod,
     &     vwind_nlat, vwind_nlon, vwind_lon_inc, errCount, myThid )
      CALL EXF_CHECK_INTERP( 'wspeed', wspeedfile, wspeed_interpMethod,
     &     wspeed_nlat, wspeed_nlon, wspeed_lon_inc, errCount, myThid )
      CALL EXF_CHECK_INTERP( 'lwflux', lwfluxfile, lwflux_interpMethod,
     &     lwflux_nlat, lwflux_nlon, lwflux_lon_inc, errCount, myThid )
      CALL EXF_CHECK_INTERP( 'swdown', swdownfile, swdown_interpMethod,
     &     swdown_nlat, swdown_nlon, swdown_lon_inc, errCount, myThid )
      CALL EXF_CHECK_INTERP( 'lwdown', lwdownfile, lwdown_interpMethod,
     &     lwdown_nlat, lwdown_nlon, lwdown_lon_inc, errCount, myThid )
      CALL EXF_CHECK_INTERP( 'apressure', apressurefile,
     &         apressure_interpMethod, apressure_nlat,
     &         apressure_nlon, apressure_lon_inc, errCount, myThid )
      CALL EXF_CHECK_INTERP( 'tidePot', tidePotFile,
     &         tidePot_interpMethod, tidePot_nlat,
     &         tidePot_nlon, tidePot_lon_inc, errCount, myThid )
      CALL EXF_CHECK_INTERP( 'areamask', areamaskfile,
     &         areamask_interpMethod, areamask_nlat,
     &         areamask_nlon, areamask_lon_inc, errCount, myThid )
      CALL EXF_CHECK_INTERP( 'climsst', climsstfile,
     &         climsst_interpMethod,  climsst_nlat,
     &         climsst_nlon, climsst_lon_inc, errCount, myThid )
      CALL EXF_CHECK_INTERP( 'climsss', climsssfile,
     &         climsss_interpMethod, climsss_nlat,
     &         climsss_nlon, climsss_lon_inc, errCount, myThid )
      CALL EXF_CHECK_INTERP( 'climustr', climustrfile,
     &         climustr_interpMethod, climustr_nlat,
     &         climustr_nlon, climustr_lon_inc, errCount,myThid )
      CALL EXF_CHECK_INTERP( 'climvstr', climvstrfile,
     &         climvstr_interpMethod, climvstr_nlat,
     &         climvstr_nlon, climvstr_lon_inc,  errCount, myThid )

C-    some restrictions on 2-component vector field (might be relaxed later on)
      IF ( ( uwind_interpMethod.GE.1 .AND. uwindfile.NE.' ' ) .OR.
     &     ( vwind_interpMethod.GE.1 .AND. vwindfile.NE.' ' ) ) THEN
       IF ( usingCurvilinearGrid .OR. rotateGrid ) THEN
        IF ( uwind_interpMethod.EQ.0 .OR. uwindfile.EQ.' ' .OR.
     &       vwind_interpMethod.EQ.0 .OR. vwindfile.EQ.' ' ) THEN
C-    stop if one expects interp+rotation (Curvilin-G) which will not happen
         WRITE(msgBuf,'(A)')
     &        'EXF_CHECK: interp. needs 2 components (wind)'
         CALL PRINT_ERROR( msgBuf, myThid )
         errCount = errCount + 1
        ENDIF
        IF ( uwindStartTime .NE. vwindStartTime .OR.
     &       uwindperiod    .NE. vwindperiod    .OR.
     &       uwindRepCycle  .NE. vwindRepCycle  ) THEN
         WRITE(msgBuf,'(A,A)') 'EXF_CHECK: ',
     &        'For CurvilinearGrid/RotatedGrid, the u and v wind '
         CALL PRINT_ERROR( msgBuf, myThid )
         WRITE(msgBuf,'(A,A,A)') 'EXF_CHECK: ',
     &        'files have to have the same StartTime,period & Cycle ',
     &        'because S/R EXF_SET_UV assumes that.'
         CALL PRINT_ERROR( msgBuf, myThid )
         errCount = errCount + 1
        ENDIF
       ENDIF
      ENDIF
      IF ( (ustress_interpMethod.GE.1 .AND. ustressfile.NE.' ') .OR.
     &     (vstress_interpMethod.GE.1 .AND. vstressfile.NE.' ') ) THEN
       IF ( readStressOnCgrid ) THEN
        WRITE(msgBuf,'(A,A)')
     &       'EXF_CHECK: readStressOnCgrid=.TRUE. ',
     &       'and interp wind-stress (=A-grid) are not compatible'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
       ENDIF
       IF ( usingCurvilinearGrid .OR. rotateGrid ) THEN
        IF ( ustress_interpMethod.EQ.0 .OR. ustressfile.EQ.' ' .OR.
     &       vstress_interpMethod.EQ.0 .OR. vstressfile.EQ.' ' ) THEN
C-    stop if one expects interp+rotation (Curvilin-G) which will not happen
         WRITE(msgBuf,'(A)')
     &        'EXF_CHECK: interp. needs 2 components (wind-stress)'
         CALL PRINT_ERROR( msgBuf, myThid )
         errCount = errCount + 1
        ENDIF
        IF ( ustressStartTime .NE. vstressStartTime .OR.
     &       ustressperiod    .NE. vstressperiod    .OR.
     &       ustressRepCycle  .NE. vstressRepCycle ) THEN
         WRITE(msgBuf,'(A,A)') 'EXF_CHECK: ',
     &    'For CurvilinearGrid/RotatedGrid, the u and v wind stress '
         CALL PRINT_ERROR( msgBuf, myThid )
         WRITE(msgBuf,'(A,A,A)') 'EXF_CHECK: ',
     &        'have to have the same StartTime,period & Cycle ',
     &        'because S/R EXF_SET_UV assumes that.'
         CALL PRINT_ERROR( msgBuf, myThid )
         errCount = errCount + 1
        ENDIF
       ENDIF
      ENDIF

      IF ( (ustress_interpMethod.EQ.0 .AND. ustressfile.NE.' ') .OR.
     &     (vstress_interpMethod.EQ.0 .AND. vstressfile.NE.' ') ) THEN
#else /* ndef USE_EXF_INTERPOLATION */
      IF     ( ustressfile .NE. ' ' .OR. vstressfile .NE. ' ' ) THEN
#endif /* USE_EXF_INTERPOLATION */
       IF (     (readStressOnAgrid.AND.readStressOnCgrid) .OR.
     &      .NOT.(readStressOnAgrid.OR.readStressOnCgrid) ) THEN
        WRITE(msgBuf,'(A)')
     & 'EXF_CHECK: Select 1 wind-stress position: A or C-grid'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
       ENDIF
       IF (rotateStressOnAgrid.AND..NOT.readStressOnAgrid) THEN
        WRITE(msgBuf,'(2A)') 'EXF_CHECK: rotateStressOnAgrid ',
     &       'only applies to cases readStressOnAgrid is true'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
       ENDIF
       IF ( rotateStressOnAgrid .AND.
     &      ( ustressfile .EQ. ' ' .OR. ustressperiod .EQ. 0. .OR.
     &        vstressfile .EQ. ' ' .OR. vstressperiod .EQ. 0. ) ) THEN
        WRITE(msgBuf,'(2A)') 'EXF_CHECK: rotateStressOnAgrid ',
     &       'requires to update u/vstress'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
       ENDIF

      ELSE
       IF ( readStressOnAgrid .OR. readStressOnCgrid .OR.
     &      rotateStressOnAgrid ) THEN
        WRITE(msgBuf,'(2A)') '** WARNING ** EXF_CHECK: ',
     &       'wind-stress position irrelevant'
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
       ENDIF
      ENDIF

#ifdef USE_NO_INTERP_RUNOFF
      WRITE(msgBuf,'(A)')
     &     'EXF_CHECK: USE_NO_INTERP_RUNOFF code has been removed;'
      CALL PRINT_ERROR( msgBuf, myThid )
      WRITE(msgBuf,'(A,A)')
     &     'EXF_CHECK: use instead "runoff_interpMethod=0"',
     &      ' in "data.exf" (EXF_NML_04)'
      CALL PRINT_ERROR( msgBuf, myThid )
      errCount = errCount + 1
#endif /* USE_NO_INTERP_RUNOFF */

#ifdef ALLOW_CLIMTEMP_RELAXATION
      WRITE(msgBuf,'(A,A)') 'EXF_CHECK: ',
     &     'ALLOW_CLIMTEMP_RELAXATION no longer supported. Use pkg/rbcs'
      CALL PRINT_ERROR( msgBuf, myThid )
      errCount = errCount + 1
#endif /* ALLOW_CLIMTEMP_RELAXATION */

#ifdef ALLOW_CLIMSALT_RELAXATION
      WRITE(msgBuf,'(A,A)') 'EXF_CHECK: ',
     &     'ALLOW_CLIMSALT_RELAXATION no longer supported. Use pkg/rbcs'
      CALL PRINT_ERROR( msgBuf, myThid )
      errCount = errCount + 1
#endif /* ALLOW_CLIMSALT_RELAXATION */

      IF ( climsstTauRelax.NE.0. ) THEN
#ifndef ALLOW_CLIMSST_RELAXATION
       WRITE(msgBuf,'(A)') 'EXF_CHECK: climsstTauRelax > 0'
       CALL PRINT_ERROR( msgBuf, myThid )
       WRITE(msgBuf,'(A)')
     &      'EXF_CHECK: but ALLOW_CLIMSST_RELAXATION is not defined'
       CALL PRINT_ERROR( msgBuf, myThid )
       errCount = errCount + 1
#endif /* ndef ALLOW_CLIMSST_RELAXATION */
       IF ( climsstfile.EQ.' ' ) THEN
        WRITE(msgBuf,'(A)') 'EXF_CHECK: climsstTauRelax > 0 but'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(A)') 'EXF_CHECK: climsstfile is not set'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
       ENDIf
      ENDIf

      IF ( climsssTauRelax.NE.0. ) THEN
#ifndef ALLOW_CLIMSSS_RELAXATION
       WRITE(msgBuf,'(A)') 'EXF_CHECK: climsssTauRelax > 0'
       CALL PRINT_ERROR( msgBuf, myThid )
       WRITE(msgBuf,'(A)')
     &      'EXF_CHECK: but ALLOW_CLIMSSS_RELAXATION is not defined'
       CALL PRINT_ERROR( msgBuf, myThid )
       errCount = errCount + 1
#endif /* ALLOW_CLIMSSS_RELAXATION */
       IF ( climsssfile.EQ.' ' ) THEN
        WRITE(msgBuf,'(A)') 'EXF_CHECK: climsssTauRelax > 0 but'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(A)') 'EXF_CHECK: climsssfile is not set'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
       ENDIF
      ENDIF

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      IF ( errCount.GE.1 ) THEN
        WRITE(msgBuf,'(A,I3,A)')
     &       'EXF_CHECK: detected', errCount,' fatal error(s)'
        CALL PRINT_ERROR( msgBuf, myThid )
        CALL ALL_PROC_DIE( 0 )
        STOP 'ABNORMAL END: S/R EXF_CHECK'
      ENDIF

      _END_MASTER(myThid)

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

CBOP
C     !ROUTINE: EXF_CHECK_INTERP
C     !INTERFACE:

      SUBROUTINE EXF_CHECK_INTERP(
     I               loc_name, loc_file, loc_interpMethod,
     I               loc_nlat, loc_nlon, loc_lon_inc,
     U               errCount,
     I               myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R EXF_CHECK_INTERP
C     | o Check parameters for one of the pkg/exf variable
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     == Global variables ===
#include "EEPARAMS.h"
#include "EXF_INTERP_SIZE.h"

C     !INPUT/OUTPUT PARAMETERS:
C     fldName          :: field short name (to print mesg)
C     fldFile          :: file-name for this field
C     loc_interpMethod :: select interpolation method
C     loc_nlat         :: size in y direction of original input grid
C     loc_nlon         :: size in x direction of original input grid
C     fld_lon_inc      :: scalar x-grid increment
C     errCount         :: error counter
C     myThid           :: my Thread Id number
      CHARACTER*(*) loc_name
      CHARACTER*(*) loc_file
      INTEGER loc_interpMethod
      INTEGER loc_nlat
      INTEGER loc_nlon
      _RL     loc_lon_inc
      INTEGER errCount
      INTEGER myThid

C     !LOCAL VARIABLES:
C     msgBuf   :: Informational/error message buffer
      CHARACTER*(MAX_LEN_MBUF) msgBuf
CEOP

      IF ( loc_interpMethod.GE.1 .AND. loc_file.NE.' ' ) THEN
       IF ( loc_nlat .GT. (MAX_LAT_INC+1) ) THEN
        WRITE(msgBuf,'(3A)') 'EXF_CHECK_INTERP: ',loc_name,
     &                      '_nlat > (MAX_LAT_INC+1)'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
       ENDIF
#ifndef EXF_INTERP_USE_DYNALLOC
C-     Check buffer size:
       IF ( loc_nlon.GT.exf_max_nLon ) THEN
        WRITE(msgBuf,'(3A)') 'EXF_CHECK_INTERP: ',loc_name,
     &                      '_nlon > exf_max_nLon'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
       ENDIF
       IF ( loc_nlat.GT.exf_max_nLat ) THEN
        WRITE(msgBuf,'(3A)') 'EXF_CHECK_INTERP: ',loc_name,
     &                      '_nlat > exf_max_nLat'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
       ENDIF
       IF ( (loc_nlon+4)*(loc_nlat+4).GT.exf_interp_bufferSize ) THEN
        WRITE(msgBuf,'(6A)') 'EXF_CHECK_INTERP: ',
     &    'exf_interp_bufferSize too small for ',
     &     loc_name, '_nlon & ', loc_name, '_nlat'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
       ENDIF
#endif /* ndef EXF_INTERP_USE_DYNALLOC */
       IF ( loc_lon_inc.GT.500. ) THEN
        WRITE(msgBuf,'(4A,1PE16.8)') 'EXF_CHECK_INTERP: ',
     &    'Invalid value for: ',loc_name,'_lon_inc =', loc_lon_inc
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(4A)') 'EXF_CHECK_INTERP: Fix it ',
     &    'or Turn off ',loc_name,'-interp (interpMethod=0)'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
       ENDIF
      ENDIF

      RETURN
      END

#include "THSICE_OPTIONS.h"
c#ifdef ALLOW_AUTODIFF
c# include "AUTODIFF_OPTIONS.h"
c#endif
#ifdef ALLOW_COST
# include "COST_OPTIONS.h"
#endif

      SUBROUTINE THSICE_COST_DRIVER( myTime, myIter, myThid )

c     ==================================================================
c     SUBROUTINE thsice_cost_driver
c     ==================================================================
c
c     o Evaluate cost function contributions of
c       thsice observations
c
c     ==================================================================
c     SUBROUTINE thsice_cost_driver
c     ==================================================================

      IMPLICIT NONE

c     == global variables ==
#include "EEPARAMS.h"
#include "SIZE.h"
#include "PARAMS.h"
c#include "GRID.h"

c#ifdef ALLOW_COST
c# include "CTRL_SIZE.h"
c# include "CTRL.h"
c# include "CTRL_DUMMY.h"
c#endif

c     == routine arguments ==
      _RL     myTime
      INTEGER myIter
      INTEGER myThid

c     == end of interface ==

#ifdef ALLOW_THSICE_COST_TEST
       CALL THSICE_COST_TEST( myTime, myIter, myThid )
#endif

      RETURN
      END

#include "MOM_COMMON_OPTIONS.h"

CBOP
C     !ROUTINE: MOM_DIAGNOSTICS_INIT
C     !INTERFACE:
      SUBROUTINE MOM_DIAGNOSTICS_INIT( myThid )

C     !DESCRIPTION:
C     Routine to initialize Momentum diagnostics
C      (from mom_common, mom_fluxform & mom_vecinv packages)

C     !USES:
      IMPLICIT NONE
C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
C     myThid :: my Thread Id. number
      INTEGER myThid
CEOP

#ifdef ALLOW_DIAGNOSTICS
#ifdef ALLOW_MOM_COMMON
C     !LOCAL VARIABLES:
C     === Local variables ===
C     msgBuf      :: Informational/error message buffer
c     CHARACTER*(MAX_LEN_MBUF) msgBuf

      INTEGER       diagNum
      INTEGER       diagMate
      CHARACTER*8   diagName
      CHARACTER*16  diagCode
      CHARACTER*16  diagUnits
      CHARACTER*(80) diagTitle

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C---  Add diagnostics to the (long) list of available diagnostics:

C--   add diagnostics for viscosity coefficients:
      diagName  = 'VISCAHZ '
      diagTitle = 'Harmonic Visc Coefficient (m2/s) (Zeta Pt)'
      diagUnits = 'm^2/s           '
      diagCode  = 'SZ      MR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'VISCA4Z '
      diagTitle = 'Biharmonic Visc Coefficient (m4/s) (Zeta Pt)'
      diagUnits = 'm^4/s           '
      diagCode  = 'SZ      MR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'VISCAHD '
      diagTitle = 'Harmonic Viscosity Coefficient (m2/s) (Div Pt)'
      diagUnits = 'm^2/s           '
      diagCode  = 'SM      MR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'VISCA4D '
      diagTitle = 'Biharmonic Viscosity Coefficient (m4/s) (Div Pt)'
      diagUnits = 'm^4/s           '
      diagCode  = 'SM      MR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'VISCAHW '
      diagTitle = 'Harmonic Viscosity Coefficient (m2/s) (W Pt)'
      diagUnits = 'm^2/s           '
      diagCode  = 'WM      LR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'VISCA4W '
      diagTitle = 'Biharmonic Viscosity Coefficient (m4/s) (W Pt)'
      diagUnits = 'm^4/s           '
      diagCode  = 'WM      LR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'VAHZMAX '
      diagTitle = 'CFL-MAX Harm Visc Coefficient (m2/s) (Zeta Pt)'
      diagUnits = 'm^2/s           '
      diagCode  = 'SZ      MR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'VA4ZMAX '
      diagTitle = 'CFL-MAX Biharm Visc Coefficient (m4/s) (Zeta Pt)'
      diagUnits = 'm^4/s           '
      diagCode  = 'SZ      MR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'VAHDMAX '
      diagTitle = 'CFL-MAX Harm Visc Coefficient (m2/s) (Div Pt)'
      diagUnits = 'm^2/s           '
      diagCode  = 'SM      MR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'VA4DMAX '
      diagTitle = 'CFL-MAX Biharm Visc Coefficient (m4/s) (Div Pt)'
      diagUnits = 'm^4/s           '
      diagCode  = 'SM      MR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'VAHZMIN '
      diagTitle = 'RE-MIN Harm Visc Coefficient (m2/s) (Zeta Pt)'
      diagUnits = 'm^2/s           '
      diagCode  = 'SZ      MR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'VA4ZMIN '
      diagTitle = 'RE-MIN Biharm Visc Coefficient (m4/s) (Zeta Pt)'
      diagUnits = 'm^4/s           '
      diagCode  = 'SZ      MR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'VAHDMIN '
      diagTitle = 'RE-MIN Harm Visc Coefficient (m2/s) (Div Pt)'
      diagUnits = 'm^2/s           '
      diagCode  = 'SM      MR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'VA4DMIN '
      diagTitle = 'RE-MIN Biharm Visc Coefficient (m4/s) (Div Pt)'
      diagUnits = 'm^4/s           '
      diagCode  = 'SM      MR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'VAHZLTH '
      diagTitle = 'Leith Harm Visc Coefficient (m2/s) (Zeta Pt)'
      diagUnits = 'm^2/s           '
      diagCode  = 'SZ      MR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'VA4ZLTH '
      diagTitle = 'Leith Biharm Visc Coefficient (m4/s) (Zeta Pt)'
      diagUnits = 'm^4/s           '
      diagCode  = 'SZ      MR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'VAHDLTH '
      diagTitle = 'Leith Harm Visc Coefficient (m2/s) (Div Pt)'
      diagUnits = 'm^2/s           '
      diagCode  = 'SM      MR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'VA4DLTH '
      diagTitle = 'Leith Biharm Visc Coefficient (m4/s) (Div Pt)'
      diagUnits = 'm^4/s           '
      diagCode  = 'SM      MR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'VAHZLTHD'
      diagTitle = 'LeithD Harm Visc Coefficient (m2/s) (Zeta Pt)'
      diagUnits = 'm^2/s           '
      diagCode  = 'SZ      MR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'VA4ZLTHD'
      diagTitle = 'LeithD Biharm Visc Coefficient (m4/s) (Zeta Pt)'
      diagUnits = 'm^4/s           '
      diagCode  = 'SZ      MR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'VAHDLTHD'
      diagTitle = 'LeithD Harm Visc Coefficient (m2/s) (Div Pt)'
      diagUnits = 'm^2/s           '
      diagCode  = 'SM      MR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'VA4DLTHD'
      diagTitle = 'LeithD Biharm Visc Coefficient (m4/s) (Div Pt)'
      diagUnits = 'm^4/s           '
      diagCode  = 'SM      MR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

#ifdef ALLOW_LEITH_QG
      diagName  = 'VAHZLTHQ'
      diagTitle = 'LeithQG Harm Visc Coefficient (m2/s) (Zeta Pt)'
      diagUnits = 'm^2/s           '
      diagCode  = 'SZ      MR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'VAHDLTHQ'
      diagTitle = 'LeithQG Harm Visc Coefficient (m2/s) (Div Pt)'
      diagUnits = 'm^2/s           '
      diagCode  = 'SM      MR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )
#endif

      diagName  = 'VAHZSMAG'
      diagTitle = 'Smagorinsky Harm Visc Coefficient (m2/s) (Zeta Pt)'
      diagUnits = 'm^2/s           '
      diagCode  = 'SZ      MR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'VA4ZSMAG'
      diagTitle = 'Smagorinsky Biharm Visc Coeff. (m4/s) (Zeta Pt)'
      diagUnits = 'm^4/s           '
      diagCode  = 'SZ      MR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'VAHDSMAG'
      diagTitle = 'Smagorinsky Harm Visc Coefficient (m2/s) (Div Pt)'
      diagUnits = 'm^2/s           '
      diagCode  = 'SM      MR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'VA4DSMAG'
      diagTitle = 'Smagorinsky Biharm Visc Coeff. (m4/s) (Div Pt)'
      diagUnits = 'm^4/s           '
      diagCode  = 'SM      MR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

C--   add diagnostics of simple derivative quantities:
      diagName  = 'momKE   '
      diagTitle = 'Kinetic Energy (in momentum Eq.)'
      diagCode  = 'SMR     MR      '
      diagUnits = 'm^2/s^2         '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

#ifdef ALLOW_MOM_VECINV
      diagName  = 'momHDiv '
      diagTitle = 'Horizontal Divergence (in momentum Eq.)'
      diagCode  = 'SMR     MR      '
      diagUnits = '1/s             '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'momVort3'
      diagTitle = '3rd component (vertical) of Vorticity'
      diagCode  = 'SZR     MR      '
      diagUnits = '1/s             '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'Strain  '
      diagTitle = 'Horizontal Strain of Horizontal Velocities'
      diagCode  = 'SZR     MR      '
      diagUnits = '1/s             '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'Tension '
      diagTitle = 'Horizontal Tension of Horizontal Velocities'
      diagCode  = 'SMR     MR      '
      diagUnits = '1/s             '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )
#endif /* ALLOW_MOM_VECINV */

      diagName  = 'Stretch '
      diagTitle = 'Vortex stretching from QG Leith dynamic viscosity'
      diagCode  = 'SM      MR      '
      diagUnits = '1/s             '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

C--   add diagnostics of tendencies from each terms
      diagUnits = 'm/s^2           '

      diagName  = 'USidDrag'
      diagTitle = 'U momentum tendency from Side Drag'
      diagCode  = 'UUR     MR      '
      diagMate  = diagNum + 2
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I   diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )
      diagName  = 'VSidDrag'
      diagTitle = 'V momentum tendency from Side Drag'
      diagCode  = 'VVR     MR      '
      diagMate  = diagNum
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I   diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

      diagName  = 'Um_Diss '
      diagTitle = 'U momentum tendency from Dissipation'
     &          //' (Explicit part)'
      diagCode  = 'UUR     MR      '
      diagMate  = diagNum + 2
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I   diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )
      diagName  = 'Vm_Diss '
      diagTitle = 'V momentum tendency from Dissipation'
     &          //' (Explicit part)'
      diagCode  = 'VVR     MR      '
      diagMate  = diagNum
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I   diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

      diagName  = 'Um_ImplD'
      diagTitle = 'U momentum tendency from Dissipation'
     &          //' (Implicit part)'
      diagCode  = 'UUR     MR      '
      diagMate  = diagNum + 2
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I   diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )
      diagName  = 'Vm_ImplD'
      diagTitle = 'V momentum tendency from Dissipation'
     &          //' (Implicit part)'
      diagCode  = 'VVR     MR      '
      diagMate  = diagNum
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I   diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

      diagName  = 'Um_Advec'
      diagTitle = 'U momentum tendency from Advection terms'
      diagCode  = 'UUR     MR      '
      diagMate  = diagNum + 2
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I   diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )
      diagName  = 'Vm_Advec'
      diagTitle = 'V momentum tendency from Advection terms'
      diagCode  = 'VVR     MR      '
      diagMate  = diagNum
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I   diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

      diagName  = 'Um_Cori '
      diagTitle = 'U momentum tendency from Coriolis term'
      diagCode  = 'UUR     MR      '
      diagMate  = diagNum + 2
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I   diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )
      diagName  = 'Vm_Cori '
      diagTitle = 'V momentum tendency from Coriolis term'
      diagCode  = 'VVR     MR      '
      diagMate  = diagNum
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I   diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

      diagName  = 'Um_dPhiX'
      diagTitle = 'U momentum tendency from Pressure/Potential grad'
      diagCode  = 'UUR     MR      '
      diagMate  = diagNum + 2
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I   diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )
      diagName  = 'Vm_dPhiY'
      diagTitle = 'V momentum tendency from Pressure/Potential grad'
      diagCode  = 'VVR     MR      '
      diagMate  = diagNum
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I   diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

      diagName  = 'Um_Ext  '
      diagTitle = 'U momentum tendency from external forcing'
      diagCode  = 'UUR     MR      '
      diagMate  = diagNum + 2
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I   diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )
      diagName  = 'Vm_Ext  '
      diagTitle = 'V momentum tendency from external forcing'
      diagCode  = 'VVR     MR      '
      diagMate  = diagNum
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I   diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

#ifdef ALLOW_MOM_VECINV
      diagName  = 'Um_hDis2'
      diagTitle = 'U momentum tendency from harmonic visc alone'
      diagCode  = 'UUR     MR      '
      diagMate  = diagNum + 2
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I   diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )
      diagName  = 'Vm_hDis2'
      diagTitle = 'V momentum tendency from harmonic visc alone'
      diagCode  = 'VVR     MR      '
      diagMate  = diagNum
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I   diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

      diagName  = 'Um_hDis4'
      diagTitle = 'U momentum tendency from biharmonic visc alone'
      diagCode  = 'UUR     MR      '
      diagMate  = diagNum + 2
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I   diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )
      diagName  = 'Vm_hDis4'
      diagTitle = 'V momentum tendency from biharmonic visc alone'
      diagCode  = 'VVR     MR      '
      diagMate  = diagNum
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I   diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

      diagName  = 'Um_AdvZ3'
      diagTitle = 'U momentum tendency from Vorticity Advection'
      diagCode  = 'UUR     MR      '
      diagMate  = diagNum + 2
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I   diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )
      diagName  = 'Vm_AdvZ3'
      diagTitle = 'V momentum tendency from Vorticity Advection'
      diagCode  = 'VVR     MR      '
      diagMate  = diagNum
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I   diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

      diagName  = 'Um_AdvRe'
      diagTitle = 'U momentum tendency from vertical Advection'
     &          //' (Explicit part)'
      diagCode  = 'UUR     MR      '
      diagMate  = diagNum + 2
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I   diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )
      diagName  = 'Vm_AdvRe'
      diagTitle = 'V momentum tendency from vertical Advection'
     &          //' (Explicit part)'
      diagCode  = 'VVR     MR      '
      diagMate  = diagNum
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I   diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

#endif /* ALLOW_MOM_VECINV */

C-    diagnostics of metric-terms tendencies:
      diagName  = 'Um_Metr '
      diagTitle = 'U momentum tendency from Metric terms'
      diagCode  = 'UUR     MR      '
      diagMate  = diagNum + 2
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I   diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )
      diagName  = 'Vm_Metr '
      diagTitle = 'V momentum tendency from Metric terms'
      diagCode  = 'VVR     MR      '
      diagMate  = diagNum
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I   diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

#ifdef ALLOW_NONHYDROSTATIC
C-    vertical momentum tendencies
      IF ( usingPCoords ) THEN
        diagUnits = 'Pa/s^2          '
      ELSE
        diagUnits = 'm/s^2           '
      ENDIF
      diagName  = 'WSidDrag'
      diagTitle = 'Vertical momentum tendency from Side Drag'
      diagCode  = 'WMr     LR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )
      diagName  = 'Wm_Diss '
      diagTitle = 'W momentum tendency from Dissipation'
      diagCode  = 'WMr     LR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'Wm_Advec'
      diagTitle = 'W momentum tendency from Advection terms'
      diagCode  = 'WMr     LR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )
      diagName  = 'Wm_Metr '
      diagTitle = 'W momentum tendency from Metric terms'
      diagCode  = 'WMr     LR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )
#endif /* ALLOW_NONHYDROSTATIC */

#ifdef ALLOW_MOM_TEND_EXTRA_DIAGS
cHP putting this back in
      diagName  = 'UBotDrag'
      diagTitle = 'U momentum tendency from Bottom Drag'
      diagCode  = 'UUR     MR      '
      diagMate  = diagNum + 2
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I   diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )
      diagName  = 'VBotDrag'
      diagTitle = 'V momentum tendency from Bottom Drag'
      diagCode  = 'VVR     MR      '
      diagMate  = diagNum
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I   diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )
#endif

C--   add diagnostics of advective & viscous flux :
C-    bottom fluxes:
      diagName  = 'botTauX '
      diagTitle = 'zonal bottom stress, >0 increases uVel'
      diagUnits = 'N/m^2           '
      diagCode  = 'UU      U1      '
      diagMate  = diagNum + 2
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I   diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )
      diagName  = 'botTauY '
      diagTitle = 'meridional bottom stress, >0 increases vVel'
      diagUnits = 'N/m^2           '
      diagCode  = 'VV      U1      '
      diagMate  = diagNum
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I   diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

      IF ( usingPCoords ) THEN
        diagUnits = 'Pa.m^3/s^2      '
      ELSE
        diagUnits = 'm^4/s^2         '
      ENDIF

C-     Advective flux of Zonal momentum:
#ifdef ALLOW_MOM_FLUXFORM
      diagName  = 'ADVx_Um '
      diagTitle = 'Zonal      Advective Flux of U momentum'
      diagCode  = 'UM      MR      '
      diagMate  = diagNum + 2
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I   diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )
      diagName  = 'ADVy_Um '
      diagTitle = 'Meridional Advective Flux of U momentum'
      diagCode  = 'VZ      MR      '
      diagMate  = diagNum
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I   diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )
      diagName  = 'ADVrE_Um'
      diagTitle = 'Vertical   Advective Flux of U momentum'
     &          //' (Explicit part)'
      diagCode  = 'WU      LR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )
#endif /* ALLOW_MOM_FLUXFORM */
c     diagName  = 'ADVrI_Um'
c     diagTitle = 'Vertical   Advective Flux of U momentum'
c    &          //' (Implicit part)'
c     diagCode  = 'WU      LR      '
c     CALL DIAGNOSTICS_ADDTOLIST( diagNum,
c    I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

C-    Advective flux of Meridional momentum:
#ifdef ALLOW_MOM_FLUXFORM
      diagName  = 'ADVx_Vm '
      diagTitle = 'Zonal      Advective Flux of V momentum'
      diagCode  = 'UZ      MR      '
      diagMate  = diagNum + 2
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I   diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )
      diagName  = 'ADVy_Vm '
      diagTitle = 'Meridional Advective Flux of V momentum'
      diagCode  = 'VM      MR      '
      diagMate  = diagNum
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I   diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )
      diagName  = 'ADVrE_Vm'
      diagTitle = 'Vertical   Advective Flux of V momentum'
     &          //' (Explicit part)'
      diagCode  = 'WV      LR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )
#endif /* ALLOW_MOM_FLUXFORM */
c     diagName  = 'ADVrI_Vm'
c     diagTitle = 'Vertical   Advective Flux of V momentum'
c    &          //' (Implicit part)'
c     diagCode  = 'WV      LR      '
c     CALL DIAGNOSTICS_ADDTOLIST( diagNum,
c    I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

C-    Viscous flux of Zonal momentum :
#ifdef ALLOW_MOM_FLUXFORM
      diagName  = 'VISCx_Um'
      diagTitle = 'Zonal      Viscous Flux of U momentum'
      diagCode  = 'UM      MR      '
      diagMate  = diagNum + 2
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I   diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )
      diagName  = 'VISCy_Um'
      diagTitle = 'Meridional Viscous Flux of U momentum'
      diagCode  = 'VZ      MR      '
      diagMate  = diagNum
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I   diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )
      diagName  = 'VISrE_Um'
      diagTitle = 'Vertical   Viscous Flux of U momentum'
     &          //' (Explicit part)'
      diagCode  = 'WU      LR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )
#endif /* ALLOW_MOM_FLUXFORM */
      diagName  = 'VISrI_Um'
      diagTitle = 'Vertical   Viscous Flux of U momentum'
     &          //' (Implicit part)'
      diagCode  = 'WU      LR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

C-    Viscous flux of Meridional momentum :
#ifdef ALLOW_MOM_FLUXFORM
      diagName  = 'VISCx_Vm'
      diagTitle = 'Zonal      Viscous Flux of V momentum'
      diagCode  = 'UZ      MR      '
      diagMate  = diagNum + 2
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I   diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )
      diagName  = 'VISCy_Vm'
      diagTitle = 'Meridional Viscous Flux of V momentum'
      diagCode  = 'VM      MR      '
      diagMate  = diagNum
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I   diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )
      diagName  = 'VISrE_Vm'
      diagTitle = 'Vertical   Viscous Flux of V momentum'
     &          //' (Explicit part)'
      diagCode  = 'WV      LR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )
#endif /* ALLOW_MOM_FLUXFORM */
      diagName  = 'VISrI_Vm'
      diagTitle = 'Vertical   Viscous Flux of V momentum'
     &          //' (Implicit part)'
      diagCode  = 'WV      LR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#endif /* ALLOW_MOM_COMMON */
#endif /* ALLOW_DIAGNOSTICS */

      RETURN
      END

#include "LAYERS_OPTIONS.h"
#ifdef ALLOW_GMREDI
#include "GMREDI_OPTIONS.h"
#endif

CBOP 0
C !ROUTINE: LAYERS_CALC

C !INTERFACE:
      SUBROUTINE LAYERS_CALC(
     I                        myTime, myIter, myThid )

C !DESCRIPTION:
C ===================================================================
C     Calculate the transport in isopycnal layers.
C     This was the meat of the LAYERS package, which
C     has been moved to S/R LAYERS_FLUXCALC.F
C ===================================================================

C !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "DYNVARS.h"
#include "LAYERS_SIZE.h"
#include "LAYERS.h"
#ifdef ALLOW_GMREDI
# include "GMREDI.h"
#endif

C !INPUT PARAMETERS:
C     myTime :: Current time in simulation
C     myIter :: Current iteration number
C     myThid :: my Thread Id number
      _RL     myTime
      INTEGER myIter
      INTEGER myThid
CEOP

#ifdef ALLOW_LAYERS
C !FUNCTIONS:
      LOGICAL  DIFFERENT_MULTIPLE
      EXTERNAL DIFFERENT_MULTIPLE

C !LOCAL VARIABLES:
C --  3D Layers fields. The vertical dimension in these fields is Nlayers,
C     i.e. the isopycnal coordinate.
C      layers_UH  :: U integrated over layer (m^2/s)
C      layers_VH  :: V integrated over layer (m^2/s)
C      layers_Hw  :: Layer thickness at the U point (m)
C      layers_Hs  :: Layer thickness at the V point (m)
C      layers_PIw :: 1 if layer exists, 0 otherwise
C      layers_PIs :: 1 if layer exists, 0 otherwise
C      layers_U   :: mean zonal velocity in layer (only if layer exists) (m/s)
C      layers_V   :: mean meridional velocity in layer (only if layer exists) (m/s)
#ifdef LAYERS_UFLUX
      _RL layers_UH (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nlayers,nSx,nSy)
# ifdef LAYERS_THICKNESS
      _RL layers_Hw (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nlayers,nSx,nSy)
      _RL layers_PIw(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nlayers,nSx,nSy)
      _RL layers_U  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nlayers,nSx,nSy)
# endif /* LAYERS_THICKNESS */
#endif /* LAYERS_UFLUX */
#ifdef LAYERS_VFLUX
      _RL layers_VH (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nlayers,nSx,nSy)
# ifdef LAYERS_THICKNESS
      _RL layers_Hs (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nlayers,nSx,nSy)
      _RL layers_PIs(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nlayers,nSx,nSy)
      _RL layers_V  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nlayers,nSx,nSy)
# endif /* LAYERS_THICKNESS */
#endif /* LAYERS_VFLUX */
#if (defined LAYERS_PRHO_REF) || (defined LAYERS_MSE)
      _RL prho(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
#endif
#ifdef LAYERS_PRHO_REF
      _RL rhoShift
#endif
#ifdef LAYERS_MSE
      _RL conv_theta2T
#endif
C --  other local variables:
C     bi, bj   :: tile indices
C     i,j      :: horizontal indices
C     iLa      :: layer-type index
C     k        :: vertical index for model grid
      INTEGER bi, bj, iLa
      CHARACTER*(10) sufx
      CHARACTER*(13) suff
      INTEGER i, j, k

#ifdef LAYERS_THERMODYNAMICS
      INTEGER iTracer
#endif
#ifdef ALLOW_DIAGNOSTICS
      CHARACTER*8    diagName
#endif
c#ifdef ALLOW_MNC
c      CHARACTER*(1) pf
c#endif

#ifndef LAYERS_UFLUX
      _RL layers_UH(1)
#endif
#ifndef LAYERS_VFLUX
      _RL layers_VH(1)
#endif
#if !(defined LAYERS_THICKNESS) || !(defined LAYERS_UFLUX)
      _RL layers_Hw(1), layers_PIw(1), layers_U(1)
#endif
#if !(defined LAYERS_THICKNESS) || !(defined LAYERS_VFLUX)
      _RL layers_Hs(1), layers_PIs(1), layers_V(1)
#endif

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      IF ( myIter.EQ.nIter0 ) RETURN

#ifdef LAYERS_THERMODYNAMICS
      CALL LAYERS_CALC_RHS(myThid)
#endif

      DO iLa=1,layers_maxNum

       IF ( layers_num(iLa) .EQ. 1 ) THEN
        CALL LAYERS_FLUXCALC( uVel,vVel,theta,iLa,
     &              layers_UH, layers_VH,
     &              layers_Hw, layers_Hs,
     &              layers_PIw,layers_PIs,
     &              layers_U,  layers_V,
     &              myThid )
#ifdef LAYERS_THERMODYNAMICS
        CALL LAYERS_DIAPYCNAL( theta,iLa,
     &              layers_TtendSurf,
     &              layers_TtendDiffh, layers_TtendDiffr,
     &              layers_TtendAdvh, layers_TtendAdvr,
     &              layers_Ttendtot,
     &              layers_StendSurf,
     &              layers_StendDiffh, layers_StendDiffr,
     &              layers_StendAdvh, layers_StendAdvr,
     &              layers_Stendtot,
     &              layers_Hc, layers_PIc,
     &              myThid)
#endif
       ELSEIF ( layers_num(iLa) .EQ. 2 ) THEN
        CALL LAYERS_FLUXCALC( uVel,vVel,salt,iLa,
     &              layers_UH, layers_VH,
     &              layers_Hw, layers_Hs,
     &              layers_PIw,layers_PIs,
     &              layers_U,  layers_V,
     &              myThid )
#ifdef LAYERS_THERMODYNAMICS
        CALL LAYERS_DIAPYCNAL( salt,iLa,
     &              layers_TtendSurf,
     &              layers_TtendDiffh, layers_TtendDiffr,
     &              layers_TtendAdvh, layers_TtendAdvr,
     &              layers_Ttendtot,
     &              layers_StendSurf,
     &              layers_StendDiffh, layers_StendDiffr,
     &              layers_StendAdvh, layers_StendAdvr,
     &              layers_Stendtot,
     &              layers_Hc, layers_PIc,
     &              myThid)
#endif
       ELSEIF ( layers_num(iLa) .EQ. 3 ) THEN
#ifdef LAYERS_PRHO_REF
C     For layers_num(iLa) = 3, calculate the potential density (minus 1000)
C     referenced to the model level given by layers_krho.
        rhoShift = rhoConst - 1000. _d 0
        DO bj=myByLo(myThid),myByHi(myThid)
         DO bi=myBxLo(myThid),myBxHi(myThid)
C     Initialise layers variable prho:
          DO k=1,Nr
           DO j=1-OLy,sNy+OLy
            DO i=1-OLx,sNx+OLx
             prho(i,j,k,bi,bj) = 0. _d 0
            ENDDO
           ENDDO
          ENDDO
          DO k = 1,Nr
           CALL FIND_RHO_2D( 1-OLx, sNx+OLx, 1-OLy, sNy+OLy,
     &                       layers_krho(iLa),
     &                       theta(1-OLx,1-OLy,k,bi,bj),
     &                       salt(1-OLx,1-OLy,k,bi,bj),
     &                       prho(1-OLx,1-OLy,k,bi,bj),
     &                       k, bi, bj, myThid )
#ifdef LAYERS_THERMODYNAMICS
C -- it might be more memory efficient not to store alpha and beta
C    but to multiply the fluxes in place here
           CALL FIND_ALPHA( bi, bj, 1-OLx, sNx+OLx, 1-OLy, sNy+OLy,
     &                      k, layers_krho(iLa),
     &                      layers_alpha(1-OLx,1-OLy,k,bi,bj), myThid )
           CALL FIND_BETA(  bi, bj, 1-OLx, sNx+OLx, 1-OLy, sNy+OLy,
     &                      k, layers_krho(iLa),
     &                      layers_beta(1-OLx,1-OLy,k,bi,bj), myThid )
#endif /* LAYERS_THERMODYNAMICS */
           DO j = 1-OLy,sNy+OLy
            DO i = 1-OLx,sNx+OLx
             prho(i,j,k,bi,bj) = prho(i,j,k,bi,bj) + rhoShift
            ENDDO
           ENDDO
          ENDDO
         ENDDO
        ENDDO
        CALL LAYERS_FLUXCALC( uVel,vVel, prho, iLa,
     &              layers_UH, layers_VH,
     &              layers_Hw, layers_Hs,
     &              layers_PIw,layers_PIs,
     &              layers_U,  layers_V,
     &              myThid )
#ifdef LAYERS_THERMODYNAMICS
        CALL LAYERS_DIAPYCNAL( prho,iLa,
     &              layers_TtendSurf,
     &              layers_TtendDiffh, layers_TtendDiffr,
     &              layers_TtendAdvh, layers_TtendAdvr,
     &              layers_Ttendtot,
     &              layers_StendSurf,
     &              layers_StendDiffh, layers_StendDiffr,
     &              layers_StendAdvh, layers_StendAdvr,
     &              layers_Stendtot,
     &              layers_Hc, layers_PIc,
     &              myThid)
#endif
#endif /* LAYERS_PRHO_REF */
       ELSEIF ( layers_num(iLa) .EQ. 4 ) THEN
#ifdef LAYERS_MSE
C     For layers_num(iLa) = 4, calculate the absolute temperature referenced to 1000 mb
        DO bj=myByLo(myThid),myByHi(myThid)
         DO bi=myBxLo(myThid),myBxHi(myThid)
          DO k = 1,Nr
           conv_theta2T = (rC(k)/atm_Po)**atm_kappa
           DO j = 1-OLy,sNy+OLy
            DO i = 1-OLx,sNx+OLx
             prho(i,j,k,bi,bj) = atm_Cp*conv_theta2T*theta(i,j,k,bi,bj)
     &                         +  totPhiHyd(i,j,k,bi,bj) +  phiRef(2*k)
     &                         +  2501. _d 0 * salt(i,j,k,bi,bj)
            ENDDO
           ENDDO
          ENDDO
         ENDDO
        ENDDO
        CALL LAYERS_FLUXCALC( uVel,vVel, prho, iLa,
     &              layers_UH, layers_VH,
     &              layers_Hw, layers_Hs,
     &              layers_PIw,layers_PIs,
     &              layers_U,  layers_V,
     &              myThid )
#endif /* LAYERS_MSE */
       ENDIF

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C--   Direct Snap-shot output
       IF ( DIFFERENT_MULTIPLE(layers_diagFreq,myTime,deltaTClock)
     &    .AND. layers_num(iLa).NE.0 ) THEN

        IF ( layers_MDSIO ) THEN
          IF ( rwSuffixType.EQ.0 ) THEN
            WRITE(suff,'(I2.2,A1,I10.10)') iLa, '.', myIter
          ELSE
            CALL RW_GET_SUFFIX( sufx, myTime, myIter, myThid )
            WRITE(suff,'(I2.2,A1,A)') iLa, '.', sufx
          ENDIF
#ifdef LAYERS_UFLUX
          CALL WRITE_FLD_3D_RL( 'layers_UH.', suff, Nlayers,
     &                           layers_UH, myIter, myThid )
#ifdef LAYERS_THICKNESS
          CALL WRITE_FLD_3D_RL( 'layers_Hw.', suff, Nlayers,
     &                           layers_Hw, myIter, myThid )
#endif /* LAYERS_THICKNESS */
#endif /* LAYERS_UFLUX */
#ifdef LAYERS_VFLUX
          CALL WRITE_FLD_3D_RL( 'layers_VH.', suff, Nlayers,
     &                           layers_VH, myIter, myThid )
#ifdef LAYERS_THICKNESS
          CALL WRITE_FLD_3D_RL( 'layers_Hs.', suff, Nlayers,
     &                           layers_Hs, myIter, myThid )
#endif /* LAYERS_THICKNESS */
#endif /* LAYERS_VFLUX */
#ifdef LAYERS_PRHO_REF
          IF ( layers_num(iLa).EQ.3 ) THEN
           CALL WRITE_FLD_3D_RL( 'layers_prho.', suff, Nr,
     &                           prho, myIter, myThid )
          ENDIF
#endif /* LAYERS_PRHO_REF */

#ifdef LAYERS_THERMODYNAMICS
          CALL WRITE_FLD_3D_RL( 'layers_Ttottend.', suff, 2*Nr,
     &       layers_tottend, myIter, myThid )
#ifdef SHORTWAVE_HEATING
          CALL WRITE_FLD_3D_RL( 'layers_sw.', suff, Nr,
     &       layers_sw, myIter, myThid )
#endif /* LAYERS_SHORTWAVE */
          CALL WRITE_FLD_3D_RL( 'layers_surfflux.', suff, 2,
     &                           layers_surfflux, myIter, myThid )
          CALL WRITE_FLD_3D_RL( 'layers_dfx.', suff, 2*Nr,
     &                           layers_dfx, myIter, myThid )
          CALL WRITE_FLD_3D_RL( 'layers_dfy.', suff, 2*Nr,
     &                           layers_dfy, myIter, myThid )
          CALL WRITE_FLD_3D_RL( 'layers_dfr.', suff, 2*Nr,
     &                           layers_dfr, myIter, myThid )
          CALL WRITE_FLD_3D_RL( 'layers_afx.', suff, 2*Nr,
     &                           layers_afx, myIter, myThid )
          CALL WRITE_FLD_3D_RL( 'layers_afy.', suff, 2*Nr,
     &                           layers_afy, myIter, myThid )
          CALL WRITE_FLD_3D_RL( 'layers_afr.', suff, 2*Nr,
     &                           layers_afr, myIter, myThid )
#endif /* LAYERS_THERMODYNAMICS */
        ENDIF

c#ifdef ALLOW_MNC
c#ifdef LAYERS_MNC
c      IF ( writeBinaryPrec .EQ. precFloat64 ) THEN
c        pf(1:1) = 'D'
c      ELSE
c        pf(1:1) = 'R'
c      ENDIF
c        IF ( layers_MNC) THEN
C           Do MNC output...  But how?
c        ENDIF
c#endif /* LAYERS_MNC */
c#endif /* ALLOW_MNC */

       ENDIF

#ifdef ALLOW_DIAGNOSTICS
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C--   Fill-in diagnostics
       IF ( useDiagnostics .AND. layers_num(iLa).NE.0 ) THEN

#ifdef LAYERS_PRHO_REF
         IF ( layers_num(iLa).EQ.3 ) THEN
          WRITE(diagName,'(A4,I1,A3)') 'LaTr',iLa,layers_name(iLa)
          CALL DIAGNOSTICS_FILL( prho,
     &                           diagName, 0, Nr, 0, 1, 1, myThid )
         ENDIF
#endif /* LAYERS_PRHO_REF */

#ifdef LAYERS_UFLUX
         WRITE(diagName,'(A4,I1,A3)') 'LaUH',iLa,layers_name(iLa)
         CALL DIAGNOSTICS_FILL( layers_UH,
     &                          diagName,0,Nlayers, 0, 1, 1, myThid )
# ifdef LAYERS_THICKNESS
         WRITE(diagName,'(A4,I1,A3)') 'LaHw',iLa,layers_name(iLa)
         CALL DIAGNOSTICS_FILL( layers_Hw,
     &                          diagName,0,Nlayers, 0, 1, 1, myThid )
         WRITE(diagName,'(A4,I1,A3)') 'LaPw',iLa,layers_name(iLa)
         CALL DIAGNOSTICS_FILL( layers_PIw,
     &                          diagName,0,Nlayers, 0, 1, 1, myThid )
         WRITE(diagName,'(A4,I1,A3)') 'LaUa',iLa,layers_name(iLa)
         CALL DIAGNOSTICS_FILL( layers_U,
     &                          diagName,0,Nlayers, 0, 1, 1, myThid )
# endif
#endif /* LAYERS_UFLUX */

#ifdef LAYERS_VFLUX
         WRITE(diagName,'(A4,I1,A3)') 'LaVH',iLa,layers_name(iLa)
         CALL DIAGNOSTICS_FILL( layers_VH,
     &                          diagName,0,Nlayers, 0, 1, 1, myThid )
# ifdef LAYERS_THICKNESS
         WRITE(diagName,'(A4,I1,A3)') 'LaHs',iLa,layers_name(iLa)
         CALL DIAGNOSTICS_FILL( layers_Hs,
     &                          diagName,0,Nlayers, 0, 1, 1, myThid )
         WRITE(diagName,'(A4,I1,A3)') 'LaPs',iLa,layers_name(iLa)
         CALL DIAGNOSTICS_FILL( layers_PIs,
     &                          diagName,0,Nlayers, 0, 1, 1, myThid )
         WRITE(diagName,'(A4,I1,A3)') 'LaVa',iLa,layers_name(iLa)
         CALL DIAGNOSTICS_FILL( layers_V,
     &                          diagName,0,Nlayers, 0, 1, 1, myThid )
# endif
#endif /* LAYERS_VFLUX */

#ifdef LAYERS_THERMODYNAMICS
         WRITE(diagName,'(A4,I1,A3)') 'LaHc',iLa,layers_name(iLa)
         CALL DIAGNOSTICS_FILL( layers_Hc,
     &                          diagName,0,Nlayers, 0, 1, 1, myThid )
         WRITE(diagName,'(A4,I1,A3)') 'LaPc',iLa,layers_name(iLa)
         CALL DIAGNOSTICS_FILL( layers_PIc,
     &                          diagName,0,Nlayers, 0, 1, 1, myThid )
         WRITE(diagName,'(A4,I1,A3)') 'LaTs',iLa,layers_name(iLa)
         CALL DIAGNOSTICS_FILL( layers_TtendSurf,
     &                          diagName,0,Nlayers-1, 0, 1, 1, myThid )
         WRITE(diagName,'(A4,I1,A3)') 'LaTh',iLa,layers_name(iLa)
         CALL DIAGNOSTICS_FILL( layers_TtendDiffh,
     &                          diagName,0,Nlayers-1, 0, 1, 1, myThid )
         WRITE(diagName,'(A4,I1,A3)') 'LaTz',iLa,layers_name(iLa)
         CALL DIAGNOSTICS_FILL( layers_TtendDiffr,
     &                          diagName,0,Nlayers-1, 0, 1, 1, myThid )
         WRITE(diagName,'(A4,I1,A3)') 'LTha',iLa,layers_name(iLa)
         CALL DIAGNOSTICS_FILL( layers_TtendAdvh,
     &                          diagName,0,Nlayers-1, 0, 1, 1, myThid )
         WRITE(diagName,'(A4,I1,A3)') 'LTza',iLa,layers_name(iLa)
         CALL DIAGNOSTICS_FILL( layers_TtendAdvr,
     &                          diagName,0,Nlayers-1, 0, 1, 1, myThid )
         WRITE(diagName,'(A4,I1,A3)') 'LTto',iLa,layers_name(iLa)
         CALL DIAGNOSTICS_FILL( layers_Ttendtot,
     &                          diagName,0,Nlayers-1, 0, 1, 1, myThid )
         WRITE(diagName,'(A4,I1,A3)') 'LaSs',iLa,layers_name(iLa)
         CALL DIAGNOSTICS_FILL( layers_StendSurf,
     &                          diagName,0,Nlayers-1, 0, 1, 1, myThid )
         WRITE(diagName,'(A4,I1,A3)') 'LaSh',iLa,layers_name(iLa)
         CALL DIAGNOSTICS_FILL( layers_StendDiffh,
     &                          diagName,0,Nlayers-1, 0, 1, 1, myThid )
         WRITE(diagName,'(A4,I1,A3)') 'LaSz',iLa,layers_name(iLa)
         CALL DIAGNOSTICS_FILL( layers_StendDiffr,
     &                          diagName,0,Nlayers-1, 0, 1, 1, myThid )
         WRITE(diagName,'(A4,I1,A3)') 'LSha',iLa,layers_name(iLa)
         CALL DIAGNOSTICS_FILL( layers_StendAdvh,
     &                          diagName,0,Nlayers-1, 0, 1, 1, myThid )
         WRITE(diagName,'(A4,I1,A3)') 'LSza',iLa,layers_name(iLa)
         CALL DIAGNOSTICS_FILL( layers_StendAdvr,
     &                          diagName,0,Nlayers-1, 0, 1, 1, myThid )
         WRITE(diagName,'(A4,I1,A3)') 'LSto',iLa,layers_name(iLa)
         CALL DIAGNOSTICS_FILL( layers_Stendtot,
     &                          diagName,0,Nlayers-1, 0, 1, 1, myThid )
#endif /* LAYERS_THERMODYNAMICS */

       ENDIF
#endif /* ALLOW_DIAGNOSTICS */

      ENDDO !DO iLa=1,layers_maxNum

#ifdef LAYERS_THERMODYNAMICS
C--   Reset temporary flux arrays to zero
      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
        DO iTracer = 1,2
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           layers_surfflux(i,j,1,iTracer,bi,bj) = 0. _d 0
          ENDDO
         ENDDO
         DO k=1,Nr
          DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
            layers_dfx     (i,j,k,iTracer,bi,bj) = 0. _d 0
            layers_dfy     (i,j,k,iTracer,bi,bj) = 0. _d 0
            layers_dfr     (i,j,k,iTracer,bi,bj) = 0. _d 0
            layers_afx     (i,j,k,iTracer,bi,bj) = 0. _d 0
            layers_afy     (i,j,k,iTracer,bi,bj) = 0. _d 0
            layers_afr     (i,j,k,iTracer,bi,bj) = 0. _d 0
            layers_tottend (i,j,k,iTracer,bi,bj) = 0. _d 0
#ifdef SHORTWAVE_HEATING
            layers_sw       (i,j,k,1      ,bi,bj) = 0. _d 0
#endif /* SHORTWAVE_HEATING */
           ENDDO
          ENDDO
         ENDDO
        ENDDO
       ENDDO
      ENDDO
#endif /* LAYERS_THERMODYNAMICS */

#endif /* ALLOW_LAYERS */

      RETURN
      END

#include "FIZHI_OPTIONS.h"
       subroutine step_physics(uphy,vphy,thphy,sphy,dt,
     .  idim1,idim2,jdim1,jdim2,Nrphys,Nsx,Nsy,im1,im2,jm1,jm2,bi,bj,
     .                                         duphy,dvphy,dthphy,dsphy)
c-----------------------------------------------------------------------
c Routine to step physics state forward using the increments 
c
c-----------------------------------------------------------------------
       implicit none
       integer im1,im2,jm1,jm2,idim1,idim2,jdim1,jdim2
       integer Nrphys,Nsx,Nsy,bi,bj
       _RL uphy(idim1:idim2,jdim1:jdim2,Nrphys,Nsx,Nsy)
       _RL vphy(idim1:idim2,jdim1:jdim2,Nrphys,Nsx,Nsy)
       _RL thphy(idim1:idim2,jdim1:jdim2,Nrphys,Nsx,Nsy)
       _RL sphy(idim1:idim2,jdim1:jdim2,Nrphys,Nsx,Nsy)
       _RL duphy(idim1:idim2,jdim1:jdim2,Nrphys,Nsx,Nsy)
       _RL dvphy(idim1:idim2,jdim1:jdim2,Nrphys,Nsx,Nsy)
       _RL dthphy(idim1:idim2,jdim1:jdim2,Nrphys,Nsx,Nsy)
       _RL dsphy(idim1:idim2,jdim1:jdim2,Nrphys,Nsx,Nsy)
       _RL dt
c
       integer i,j,L

       do L = 1,Nrphys
        do j = jm1,jm2
        do i = im1,im2
         uphy(i,j,L,bi,bj) = uphy(i,j,L,bi,bj) + duphy(i,j,L,bi,bj) * dt
         vphy(i,j,L,bi,bj) = vphy(i,j,L,bi,bj) + dvphy(i,j,L,bi,bj) * dt
         thphy(i,j,L,bi,bj)=thphy(i,j,L,bi,bj) + dthphy(i,j,L,bi,bj)* dt
         sphy(i,j,L,bi,bj) = sphy(i,j,L,bi,bj) + dsphy(i,j,L,bi,bj) * dt
        enddo
        enddo
       enddo

       return
       end

#include "EXF_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C     !ROUTINE: EXF_SET_FLD
C     !INTERFACE:
      SUBROUTINE EXF_SET_FLD(
     I     fldName, fldFile, fldMask,
     I     fldStartTime, fldPeriod, fldRepeatCycle,
     I     fld_inScale, fldRemove_intercept, fldRemove_slope,
     U     fldArr, fld0, fld1,
#ifdef USE_EXF_INTERPOLATION
     I     fld_lon0, fld_lon_inc, fld_lat0, fld_lat_inc,
     I     fld_nlon, fld_nlat, fld_xout, fld_yout, interp_method,
#endif
     I     myTime, myIter, myThid )

C !DESCRIPTION: \bv
C  *=================================================================*
C  | SUBROUTINE EXF_SET_FLD
C  | o Set value of one generic external forcing field
C  *=================================================================*
C  |  started: Ralf.Giering@FastOpt.de 25-Mai-2000
C  |  changed: heimbach@mit.edu 10-Jan-02
C  |        20-Dec-02: mods for pkg/seaice, menemenlis@jpl.nasa.gov
C  |           heimbach@mit.edu: totally re-organized exf_set_...
C  |           replaced all routines by one generic routine
C  |        5-Aug-03: added USE_EXF_INTERPOLATION for arbitrary
C  |                    input grid capability
C  |  11-Dec-06 added time-mean and monthly-mean climatology options
C  |     fldPeriod=0 means input file is one time-constant field
C  |     fldPeriod=-12 means input file contains 12 monthly means
C  *=================================================================*
C \ev

C !USES:
      IMPLICIT NONE
C     == global variables ==
#include "EEPARAMS.h"
#include "SIZE.h"
#include "PARAMS.h"
#include "EXF_PARAM.h"
#include "EXF_CONSTANTS.h"
#include "EXF_INTERP_SIZE.h"
#include "EXF_INTERP_PARAM.h"

C !INPUT/OUTPUT PARAMETERS:
C     fldName        :: field short name (to print mesg)
C     fldFile        :: file-name for this field
C     fldStartTime   :: corresponding starting time (in sec) for this field
C     fldPeriod      :: time period (in sec) between 2 reccords
C     fldRepeatCycle :: time duration of a repeating cycle
C     fld_inScale    :: input field scaling factor
C     fldRemove_intercept  ::
C     fldRemove_slope      ::
C     fldArr         :: field array containing current time values
C     fld0           :: field array holding previous reccord
C     fld1           :: field array holding next     reccord
#ifdef USE_EXF_INTERPOLATION
C     fld_lon0, fld_lat0   :: longitude and latitude of SouthWest
C                          :: corner of global input grid
C     fld_nlon, fld_nlat   :: input x-grid and y-grid size
C     fld_lon_inc          :: scalar x-grid increment
C     fld_lat_inc          :: vector y-grid increments
C     fld_xout, fld_yout   :: coordinates for output grid
C     fld_xout, fld_yout   :: coordinates for output grid
C     interp_method        :: select interpolation method (integer)
#endif /* USE_EXF_INTERPOLATION */
C     myTime         :: Current time (in sec) in simulation
C     myIter         :: Current iteration number
C     myThid         :: My Thread Id number
      CHARACTER*(*) fldName
      CHARACTER*(128) fldFile
      CHARACTER*1 fldMask
      _RL fldStartTime, fldPeriod, fldRepeatCycle
      _RL fld_inScale
      _RL fldRemove_intercept, fldRemove_slope
      _RL fldArr(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL fld0  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL fld1  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
#ifdef USE_EXF_INTERPOLATION
      _RL fld_lon0, fld_lon_inc
      _RL fld_lat0, fld_lat_inc(MAX_LAT_INC)
      INTEGER fld_nlon, fld_nlat
      _RS fld_xout  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RS fld_yout  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      INTEGER interp_method
#endif /* USE_EXF_INTERPOLATION */
      _RL     myTime
      INTEGER myIter
      INTEGER myThid

C !FUNCTIONS:
      INTEGER  ILNBLNK
      EXTERNAL ILNBLNK

C !LOCAL VARIABLES:
C     msgBuf     :: Informational/error message buffer
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      LOGICAL first, changed
      INTEGER count0, count1
      INTEGER year0, year1
      INTEGER bi, bj, i, j
      _RL     fac
      CHARACTER*(128) locFile0, locFile1
#ifdef USE_EXF_INTERPOLATION
      CHARACTER*(MAX_LEN_FNAM) out_file
# ifndef EXF_INTERP_USE_DYNALLOC
      _RL     bufArr( exf_interp_bufferSize )
# endif
#endif /* USE_EXF_INTERPOLATION */
CEOP

      IF ( fldFile .NE. ' ' .AND. fldPeriod .NE. 0. ) THEN

         IF ( exf_debugLev.GE.debLevD ) THEN
           _BEGIN_MASTER( myThid )
           j = ILNBLNK(fldFile)
           WRITE(msgBuf,'(5A)') 'EXF_SET_FLD: ',
     &       'processing field "', fldName, '",  file: ', fldFile(1:j)
           CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                         SQUEEZE_RIGHT, myThid )
           _END_MASTER( myThid )
         ENDIF

         IF ( useCAL .AND. fldPeriod .EQ. -12. ) THEN
#ifdef ALLOW_CAL
C-    fldPeriod=-12 means input file contains 12 monthly means
C     records, corresponding to Jan. (rec=1) through Dec. (rec=12)
            CALL cal_GetMonthsRec(
     O           fac, first, changed,
     O           count0, count1, year0, year1,
     I           myTime, myIter, myThid )
#endif /* ALLOW_CAL */
         ELSEIF ( useCal .AND. fldperiod .EQ. -1.) THEN
C-    fldPeriod=-1 means fields are monthly means.
C     With useExfYearlyFields=.TRUE., each yearly input file contains
C     12 monthly mean records.  Otherwise, a single input file contains
C     monthly mean records starting at the month fldStartTime falls in.
#ifdef ALLOW_CAL
            CALL EXF_GetMonthsRec(
     I           fldStartTime, useExfYearlyFields,
     O           fac, first, changed,
     O           count0, count1, year0, year1,
     I           myTime, myIter, myThid )
#endif /* ALLOW_CAL */
         ELSEIF ( fldPeriod .LT. 0. ) THEN
           j = ILNBLNK(fldFile)
           WRITE(msgBuf,'(4A,1PE16.8,2A)') 'EXF_SET_FLD: ',
     &       '"', fldName, '", Invalid fldPeriod=', fldPeriod,
     &       ' for file: ', fldFile(1:j)
           CALL PRINT_ERROR( msgBuf, myThid )
           STOP 'ABNORMAL END: S/R EXF_SET_FLD'
         ELSE
C-    get record numbers and interpolation factor for this field
            CALL EXF_GetFFieldRec(
     I           fldStartTime, fldPeriod, fldRepeatCycle,
     I           fldName, useExfYearlyFields,
     O           fac, first, changed,
     O           count0, count1, year0, year1,
     I           myTime, myIter, myThid )

         ENDIF
         IF ( exf_debugLev.GE.debLevD ) THEN
           _BEGIN_MASTER( myThid )
           WRITE(msgBuf,'(2A,I10,2I7)') 'EXF_SET_FLD: ',
     &       '  myIter, count0, count1:', myIter, count0, count1
           CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                         SQUEEZE_RIGHT, myThid )
           WRITE(msgBuf,'(2A,2(L2,2X),F21.17)') 'EXF_SET_FLD: ',
     &       '  first, changed, fac:  ', first, changed, fac
           CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                         SQUEEZE_RIGHT, myThid )
           _END_MASTER( myThid )
         ENDIF

         IF ( first ) THEN
            CALL exf_GetYearlyFieldName(
     I         useExfYearlyFields, twoDigitYear, fldPeriod, year0,
     I         fldFile,
     O         locFile0,
     I         myTime, myIter, myThid )
            IF ( exf_debugLev.GE.debLevC ) THEN
              _BEGIN_MASTER(myThid)
              j = ILNBLNK(locFile0)
              WRITE(msgBuf,'(4A,I10,A,I6)') 'EXF_SET_FLD: ',
     &          'field "', fldName, '", it=', myIter,
     &          ', loading rec=', count0
              CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                            SQUEEZE_RIGHT, myThid )
              WRITE(msgBuf,'(4A)') 'EXF_SET_FLD: ',
     &          '  from file: "', locFile0(1:j), '"'
              CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                            SQUEEZE_RIGHT, myThid )
              _END_MASTER(myThid)
            ENDIF

#ifdef USE_EXF_INTERPOLATION
            IF ( interp_method.GE.1 ) THEN
              CALL EXF_INTERP(
     I             locFile0, exf_iprec,
#ifdef EXF_INTERP_USE_DYNALLOC
     O             fld1,
#else
     O             fld1, bufArr,
#endif
     I             count0, fld_xout, fld_yout,
     I             fld_lon0, fld_lon_inc, fld_lat0, fld_lat_inc,
     I             fld_nlon, fld_nlat, interp_method, myIter, myThid )

              IF ( exf_output_interp ) THEN
               j = ILNBLNK(locFile0)
               WRITE(out_file,'(2A)') locFile0(1:j), '_out'
               IF ( count0.NE.1 )
     &         CALL WRITE_REC_XY_RL( out_file, fld1, 1,
     &                                         myIter, myThid )
               CALL WRITE_REC_XY_RL( out_file, fld1, count0,
     &                                         myIter, myThid )
              ENDIF

            ELSE
#endif /* USE_EXF_INTERPOLATION */
              CALL READ_REC_3D_RL( locFile0, exf_iprec, 1,
     &                             fld1, count0, myIter, myThid )
#ifdef USE_EXF_INTERPOLATION
            ENDIF
#endif /* USE_EXF_INTERPOLATION */

C-    apply mask
            CALL EXF_FILTER_RL( fld1, fldMask, myThid )

C-    end if ( first ) block
         ENDIF

         IF ( first .OR. changed ) THEN
            CALL exf_SwapFFields( fld0, fld1, myThid )

            CALL exf_GetYearlyFieldName(
     I         useExfYearlyFields, twoDigitYear, fldPeriod, year1,
     I         fldFile,
     O         locFile1,
     I         myTime, myIter, myThid )
            IF ( exf_debugLev.GE.debLevC ) THEN
              _BEGIN_MASTER(myThid)
              j = ILNBLNK(locFile1)
              WRITE(msgBuf,'(4A,I10,A,I6)') 'EXF_SET_FLD: ',
     &          'field "', fldName, '", it=', myIter,
     &          ', loading rec=', count1
              CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                            SQUEEZE_RIGHT, myThid )
              WRITE(msgBuf,'(4A)') 'EXF_SET_FLD: ',
     &          '  from file: "', locFile1(1:j), '"'
              CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                            SQUEEZE_RIGHT, myThid )
              _END_MASTER(myThid)
            ENDIF

#ifdef USE_EXF_INTERPOLATION
            IF ( interp_method.GE.1 ) THEN
              CALL EXF_INTERP(
     I             locFile1, exf_iprec,
#ifdef EXF_INTERP_USE_DYNALLOC
     O             fld1,
#else
     O             fld1, bufArr,
#endif
     I             count1, fld_xout, fld_yout,
     I             fld_lon0, fld_lon_inc, fld_lat0, fld_lat_inc,
     I             fld_nlon, fld_nlat, interp_method, myIter, myThid )

              IF ( exf_output_interp ) THEN
               j = ILNBLNK(locFile1)
               WRITE(out_file,'(2A)') locFile1(1:j), '_out'
               CALL WRITE_REC_XY_RL( out_file, fld1, count1,
     &                                         myIter, myThid )
              ENDIF

            ELSE
#endif /* USE_EXF_INTERPOLATION */
              CALL READ_REC_3D_RL( locFile1, exf_iprec, 1,
     &                             fld1, count1, myIter, myThid )
#ifdef USE_EXF_INTERPOLATION
            ENDIF
#endif /* USE_EXF_INTERPOLATION */

C-    apply mask
            CALL EXF_FILTER_RL( fld1, fldMask, myThid )

C-    end if ( first or changed ) block
         ENDIF

C     Loop over tiles.
         DO bj = myByLo(myThid),myByHi(myThid)
          DO bi = myBxLo(myThid),myBxHi(myThid)
           DO j = 1,sNy
            DO i = 1,sNx
C     Interpolate linearly onto the  time.
             fldArr(i,j,bi,bj) =     fld_inScale * (
     &                       fac * fld0(i,j,bi,bj)
     &          + (exf_one - fac)* fld1(i,j,bi,bj) )
             fldArr(i,j,bi,bj) = fldArr(i,j,bi,bj)
     &         - fld_inScale*( fldRemove_intercept
     &                         + fldRemove_slope*(myTime-startTime) )
            ENDDO
           ENDDO
          ENDDO
         ENDDO

      ENDIF

      RETURN
      END

#include "BLING_OPTIONS.h"

CBOP
      subroutine BLING_DIAGNOSTICS_INIT(myThid )

C     =================================================================
C     | subroutine bling_diagnostics_init
C     | o Define diagnostics for bling pkg
C     =================================================================

      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"

C  myThid               :: thread number
      INTEGER myThid
CEOP

#ifdef ALLOW_DIAGNOSTICS

C     !LOCAL VARIABLES:
      INTEGER       diagNum
      CHARACTER*8   diagName
      CHARACTER*16  diagCode
      CHARACTER*16  diagUnits
      CHARACTER*(80) diagTitle

C     Define diagnostics Names :

c biology

      diagName  = 'BLGPSM  '
      diagTitle = 'Small phytoplankton biomass (mol C/m3/s)'
      diagUnits = 'mol C/m3        '
      diagCode  = 'SM P    MR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'BLGPLG  '
      diagTitle = 'Large phytoplankton biomass (mol C/m3/s)'
      diagUnits = 'mol C/m3        '
      diagCode  = 'SM P    MR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

#ifndef USE_BLING_V1
      diagName  = 'BLGPDIA '
      diagTitle = 'Diazotroph phytoplankton biomass (mol C/m3/s)'
      diagUnits = 'mol C/m3        '
      diagCode  = 'SM P    MR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )
#endif

      diagName  = 'BLGCHL  '
      diagTitle = 'Chlorophyll concentration'
      diagUnits = 'mg/m3           '
      diagCode  = 'SM P    MR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'BLGCHLSA'
      diagTitle = 'Chlorophyll concentration as seen by satellite'
      diagUnits = 'mg/m3           '
      diagCode  = 'SM P    M1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'BLGCHL2C'
      diagTitle = 'Chlorophyll to Carbon ratio'
      diagUnits = 'mol Chl/mol C   '
      diagCode  = 'SM P    MR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'BLGC2CHL'
      diagTitle = 'Carbon to Chlorophyll ratio'
      diagUnits = 'g C/g Chl       '
      diagCode  = 'SM P    MR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'BLGPOC  '
      diagTitle = 'Particulate Organic Carbon concentration'
      diagUnits = 'mol C/m3        '
      diagCode  = 'SM P    MR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'BLGPOCF '
      diagTitle = 'Particulate Organic Carbon Flux'
      diagUnits = 'mol C/m3/s      '
      diagCode  = 'SM P    MR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'BLGNPP  '
      diagTitle = 'Net Primary Production'
      diagUnits = 'mol C/m3/s      '
      diagCode  = 'SM P    MR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'BLGNCP  '
      diagTitle = 'Net Community Production'
      diagUnits = 'mol C/m3/s      '
      diagCode  = 'SM P    MR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'BLGPCM  '
      diagTitle = 'Maximum photosynthesis rate'
      diagUnits = '1/s             '
      diagCode  = 'SM P    MR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'BLGMU   '
      diagTitle = 'Phytoplankton growth rate'
      diagUnits = '1/s             '
      diagCode  = 'SM P    MR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

#ifndef USE_BLING_V1
      diagName  = 'BLGMUDIA'
      diagTitle = 'Diazotroph growth rate'
      diagUnits = '1/s             '
      diagCode  = 'SM P    MR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )
#endif

      diagName  = 'BLGIRRK '
      diagTitle = 'Nutrient-limited photosynthesis efficiency'
      diagUnits = 'W/m2            '
      diagCode  = 'SM P    MR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'BLGLLIM '
      diagTitle = 'Light limitation'
      diagUnits = '-               '
      diagCode  = 'SM P    MR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

#ifndef USE_BLING_V1
      diagName  = 'BLGNLIM '
      diagTitle = 'N limitation'
      diagUnits = '-               '
      diagCode  = 'SM P    MR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )
#endif

      diagName  = 'BLGPLIM '
      diagTitle = 'P limitation'
      diagUnits = '-               '
      diagCode  = 'SM P    MR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'BLGFELIM'
      diagTitle = 'Fe limitation'
      diagUnits = '-               '
      diagCode  = 'SM P    MR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

#ifdef USE_SIBLING
      diagName  = 'BLGSILIM'
      diagTitle = 'Si limitation'
      diagUnits = '-               '
      diagCode  = 'SM P    MR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'BLGSIUP '
      diagTitle = 'Silica uptake by bio'
      diagUnits = 'mol Si/m3/s     '
      diagCode  = 'SM P    MR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'BLGSIREM'
      diagTitle = 'Silica remin of sinking org matter'
      diagUnits = 'mol Si/m3/s     '
      diagCode  = 'SM P    MR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'BLGSIREC'
      diagTitle = 'Silica recycling'
      diagUnits = 'mol Si/m3/s     '
      diagCode  = 'SM P    MR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'BLGSIDIS'
      diagTitle = 'Silica dissolution fraction'
      diagUnits = 'mol Si/m3/s     '
      diagCode  = 'SM P    MR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'BLGSI2N  '
      diagTitle = 'Si to N stoichiometric ratio'
      diagUnits = '-               '
      diagCode  = 'SM P    MR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

#endif

#ifndef USE_BLING_V1
      diagName  = 'BLGP2N  '
      diagTitle = 'P to N stoichiometric ratio'
      diagUnits = '-               '
      diagCode  = 'SM P    MR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'BLGFE2N '
      diagTitle = 'Fe to N stoichiometric ratio'
      diagUnits = '-               '
      diagCode  = 'SM P    MR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )
#endif

c carbon system

      diagName  = 'BLGPCO2 '
      diagTitle = 'Surface ocean partial pressure of CO2'
      diagUnits = 'atm             '
      diagCode  = 'SM P    M1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'BLGPH3D '
      diagTitle = 'pH'
      diagUnits = 'dimensionless   '
      diagCode  = 'SM P    MR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'BLGOMAR '
      diagTitle = 'Aragonite saturation'
      diagUnits = 'dimensionless   '
      diagCode  = 'SM P    MR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'BLGCFLX '
      diagTitle = 'Flux of CO2 due to air-sea exch (mol/m2/s)'
      diagUnits = 'mol/m2/sec      '
      diagCode  = 'SM P    L1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'BLGapco2'
      diagTitle = 'Atmospheric partial pressure of CO2'
      diagUnits = '10^-6 ppm       '
      diagCode  = 'SM      U1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

c oxygen

      diagName  = 'BLGOFLX '
      diagTitle = 'Flux of O2 due to air-sea exch (mol/m2/s)'
      diagUnits = 'mol/m2/sec      '
      diagCode  = 'SM P    L1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'BLGO2SAT'
      diagTitle = 'surface O2 saturation (percent)'
      diagUnits = 'percent         '
      diagCode  = 'SM P    L1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

c iron

      diagName  = 'BLGSURFE'
      diagTitle = 'Surface deposition of Fe (mol/m2/s)'
      diagUnits = 'mol/m2/sec      '
      diagCode  = 'SM P    L1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'BLGFEUP '
      diagTitle = 'Iron uptake by bio'
      diagUnits = 'mol Fe/m3/s     '
      diagCode  = 'SM P    MR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'BLGFESPM'
      diagTitle = 'Iron sinking particle flux'
      diagUnits = 'mol Fe/m3/s     '
      diagCode  = 'SM P    MR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'BLGFEREM'
      diagTitle = 'Iron remin of sinking organic matter'
      diagUnits = 'mol Fe/m3/s     '
      diagCode  = 'SM P    MR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'BLGFERD '
      diagTitle = 'Iron remin from Diel Vertical Migration'
      diagUnits = 'mol Fe/m3/s     '
      diagCode  = 'SM P    MR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'BLGFEREC'
      diagTitle = 'Iron recycling'
      diagUnits = 'mol Fe/m3/s     '
      diagCode  = 'SM P    MR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'BLGFEADI'
      diagTitle = 'Iron inorganic adsorption'
      diagUnits = 'mol Fe/m3/s     '
      diagCode  = 'SM P    MR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'BLGFEADO'
      diagTitle = 'Iron organic adsorption'
      diagUnits = 'mol Fe/m3/s     '
      diagCode  = 'SM P    MR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'BLGFESED'
      diagTitle = 'Iron sediment source'
      diagUnits = 'mol Fe/m3/s     '
      diagCode  = 'SM P    MR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'BLGFEBUR'
      diagTitle = 'Iron burial into sediment'
      diagUnits = 'mol Fe/m3/s     '
      diagCode  = 'SM P    M1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

c nitrogen

#ifndef USE_BLING_V1
      diagName  = 'BLGNUP  '
      diagTitle = 'Nitrogen uptake by bio'
      diagUnits = 'mol N/m3/s      '
      diagCode  = 'SM P    MR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'BLGNFIX '
      diagTitle = 'Nitrogen fixation'
      diagUnits = 'mol N/m3/s      '
      diagCode  = 'SM P    MR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'BLGNSPM '
      diagTitle = 'Nitrogen sinking particle flux'
      diagUnits = 'mol N/m3/s      '
      diagCode  = 'SM P    MR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'BLGNREM '
      diagTitle = 'Nitrogen remin of sinking org matter'
      diagUnits = 'mol N/m3/s      '
      diagCode  = 'SM P    MR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'BLGNDVM '
      diagTitle = 'Nitrogen vertical flux due to DVM'
      diagUnits = 'mol N/m3/s      '
      diagCode  = 'SM P    MR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'BLGNRD  '
      diagTitle = 'Nitrogen remin by Diel Vertical Migration'
      diagUnits = 'mol N/m3/s      '
      diagCode  = 'SM P    MR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'BLGNREC '
      diagTitle = 'Nitrogen recycling'
      diagUnits = 'mol N/m3/s      '
      diagCode  = 'SM P    MR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'BLGNDENB'
      diagTitle = 'Benthic denitrification'
      diagUnits = 'mol N/m3/s      '
      diagCode  = 'SM P    MR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'BLGNDENP'
      diagTitle = 'Pelagic denitrification'
      diagUnits = 'mol N/m3/s      '
      diagCode  = 'SM P    MR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'BLGDONP '
      diagTitle = 'Dissolved Organic Nitrogen Production'
      diagUnits = 'mol N/m3/s      '
      diagCode  = 'SM P    MR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'BLGDONR '
      diagTitle = 'Dissolved Organic Nitrogen Remineralization'
      diagUnits = 'mol N/m3/s      '
      diagCode  = 'SM P    MR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'BLGNONEN'
      diagTitle = 'NO3 no neg'
      diagUnits = '-               '
      diagCode  = 'SM P    MR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

#endif

c phosphorus

      diagName  = 'BLGPUP  '
      diagTitle = 'Phosphorus uptake by bio'
      diagUnits = 'mol P/m3/s      '
      diagCode  = 'SM P    MR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'BLGPSPM '
      diagTitle = 'Phosphorus sinking particle flux'
      diagUnits = 'mol P/m3/s      '
      diagCode  = 'SM P    MR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'BLGPREM '
      diagTitle = 'Phosphorus remin of sinking org matter'
      diagUnits = 'mol P/m3/s      '
      diagCode  = 'SM P    MR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'BLGPDVM '
      diagTitle = 'Phosphorus vertical flux due to DVM'
      diagUnits = 'mol P/m3/s      '
      diagCode  = 'SM P    MR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'BLGPRD  '
      diagTitle = 'Phosphorus remin by Diel Vertical Migration'
      diagUnits = 'mol P/m3/s      '
      diagCode  = 'SM P    MR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'BLGPREC '
      diagTitle = 'Phosphorus recycling'
      diagUnits = 'mol P/m3/s      '
      diagCode  = 'SM P    MR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'BLGDOPP '
      diagTitle = 'Dissolved Organic Phosphorus Production'
      diagUnits = 'mol P/m3/s      '
      diagCode  = 'SM P    MR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'BLGDOPR '
      diagTitle = 'Dissolved Organic Phosphorus Remineralization'
      diagUnits = 'mol P/m3/s      '
      diagCode  = 'SM P    MR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

c mld

      diagName  = 'BLGMLD  '
      diagTitle = 'Diagnosed mixed layer depth'
      diagUnits = 'm               '
      diagCode  = 'SM P    L1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

c light

      diagName  = 'BLGIRRIS'
      diagTitle = 'Local irradiance'
      diagUnits = 'W/m2            '
      diagCode  = 'SM P    MR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'BLGIEFF '
      diagTitle = 'Effective irradiance'
      diagUnits = 'W/m2            '
      diagCode  = 'SM P    MR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'BLGIMEM '
      diagTitle = 'Irradiance memory'
      diagUnits = 'W/m2            '
      diagCode  = 'SM P    MR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

c bgc

      diagName  = 'BLGBIOC '
      diagTitle = 'Tendency of DIC due to biology (mol C/m3/s)'
      diagUnits = 'mol C/m3/sec    '
      diagCode  = 'SMRP    MR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'BLGBIOAL'
      diagTitle = 'Tendency of alkalinity due to biology (mol alk/m3/s)'
      diagUnits = 'mol alk/m3/sec  '
      diagCode  = 'SMRP    MR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'BLGBIOO2'
      diagTitle = 'Tendency of oxygen due to biology (mol O/m3/s)'
      diagUnits = 'mol O/m3/sec    '
      diagCode  = 'SMRP    MR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'BLGBION '
      diagTitle = 'Tendency of nitrate due to biology (mol N/m3/s)'
      diagUnits = 'mol N/m3/sec    '
      diagCode  = 'SMRP    MR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'BLGBIOP '
      diagTitle = 'Tendency of phosphate due to biology (mol P/m3/s)'
      diagUnits = 'mol P/m3/sec    '
      diagCode  = 'SMRP    MR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'BLGBIOFE'
      diagTitle = 'Tendency of iron due to biology (mol Fe/m3/s)'
      diagUnits = 'mol Fe/m3/sec   '
      diagCode  = 'SMRP    MR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'BLGNSED '
      diagTitle = 'Nitrogen flux in/out of sediments'
      diagUnits = 'mol N/m3/s      '
      diagCode  = 'SM P    M1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'BLGPSED '
      diagTitle = 'Phosphorus flux in/out of sediments'
      diagUnits = 'mol P/m3/s      '
      diagCode  = 'SM P    M1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'BLGOSED '
      diagTitle = 'Oxygen flux in/out of sediments'
      diagUnits = 'mol O/m3/s      '
      diagCode  = 'SM P    M1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'BLGCCdis'
      diagTitle = 'Calcium carbonate dissolution'
      diagUnits = 'mol C/m3/s      '
      diagCode  = 'SM P    MR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'BLGCCpro'
      diagTitle = 'Calcium carbonate production'
      diagUnits = 'mol C/m3/s      '
      diagCode  = 'SM P    MR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

#endif /* ALLOW_DIAGNOSTICS */

      RETURN
      END

#include "CPP_EEOPTIONS.h"
#include "W2_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 0
C !ROUTINE: W2_PRINT_E2SETUP

C !INTERFACE:
      SUBROUTINE W2_PRINT_E2SETUP( myThid )

C     !DESCRIPTION:
C     Print out Wrapper-Exch2 Set-Up as defined by matlab generated source
C     files (W2_EXCH2_SIZE.h & W2_E2SETUP). Allows a direct comparison
C     with standard Fortran src generated topology.

C     !USES:
      IMPLICIT NONE

C      Tile topology settings data structures
#include "SIZE.h"
#include "EEPARAMS.h"
#include "W2_EXCH2_SIZE.h"
#include "W2_EXCH2_PARAMS.h"
#include "W2_EXCH2_TOPOLOGY.h"

C     !INPUT PARAMETERS:
C     myThid  :: my Thread Id number
C               (Note: not relevant since threading has not yet started)
      INTEGER myThid

C     !LOCAL VARIABLES:
C     === Local variables ===
C     msgBuf     :: Informational/error message buffer
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      CHARACTER*1 edge(0:4)
      INTEGER tNx, tNy, fNx, fNy
      INTEGER nbTx, nbTy
      INTEGER ip(4), np(4)
      INTEGER i, j, js, jp, jt, ii, is, it, ns, nt, k, tx, ty
      LOGICAL prtFlag
CEOP
      DATA edge / '?' , 'N' , 'S' , 'E' , 'W' /

      tNx = sNx
      tNy = sNy
      prtFlag = ABS(W2_printMsg).GE.2
     &       .OR. ( W2_printMsg .NE.0 .AND. myProcId.EQ.0 )

C=================== from W2_SET_F2F_INDEX :
c     WRITE(msgBuf,'(2A)') 'W2_SET_F2F_INDEX:',
      WRITE(msgBuf,'(2A)') 'W2_PRINT_E2SETUP:',
     &       ' index matrix for connected Facet-Edges:'
      CALL PRINT_MESSAGE( msgBuf, W2_oUnit, SQUEEZE_RIGHT, myThid )

      jp = 0
      IF ( prtFlag ) THEN
       DO is=1,exch2_nTiles
        js  = exch2_myFace(is)
        IF ( js.NE.0 ) THEN
C--     tile is is active
         fNx = exch2_mydNx(is)
         fNy = exch2_mydNy(is)
         nbTx = fNx/tNx
         nbTy = fNy/tNy
         IF ( js.NE.jp ) THEN
           IF ( jp.NE.0 ) THEN
C---     write
         DO i=1,4
          IF ( ip(i).NE.0 ) THEN
            j  = exch2_myFace(ip(i))
            it = exch2_neighbourId (np(i),ip(i))
            nt = exch2_opposingSend(np(i),ip(i))
            jt = exch2_myFace(it)
            ii = 0
            IF ( exch2_jLo(nt,it).EQ.exch2_jHi(nt,it) )
     &        ii = 2 - MIN(1,exch2_jHi(nt,it))
            IF ( exch2_iLo(nt,it).EQ.exch2_iHi(nt,it) )
     &        ii = 4 - MIN(1,exch2_iHi(nt,it))
            WRITE(W2_oUnit,'(2(3A,I3),A,4I3,A,2I6)')
     &      '  ', edge(i), '.Edge Facet', j, ' <-- ',
     &           edge(ii), '.Edge Facet', jt,
     &      ' : pij=', (exch2_pij(k,np(i),ip(i)),k=1,4),
     &      ' ; oi,oj=',exch2_oi(np(i),ip(i)),exch2_oj(np(i),ip(i))
          ENDIF
         ENDDO
C---
           ENDIF
           jp = js
           DO i=1,4
            ip(i) = 0
            np(i) = 0
           ENDDO
         ENDIF
         DO ns=1,exch2_nNeighbours(is)
          IF ( ip(1).EQ.0 .AND. exch2_isNedge(is).EQ.1
     &                    .AND. exch2_jLo(ns,is).EQ.(tNy+1)
     &                    .AND. exch2_jHi(ns,is).EQ.(tNy+1) ) THEN
            ip(1) = is
            np(1) = ns
          ENDIF
          IF ( ip(2).EQ.0 .AND. exch2_isSedge(is).EQ.1
     &                    .AND. exch2_jLo(ns,is).EQ. 0
     &                    .AND. exch2_jHi(ns,is).EQ. 0 ) THEN
            ip(2) = is
            np(2) = ns
          ENDIF
          IF ( ip(3).EQ.0 .AND. exch2_isEedge(is).EQ.1
     &                    .AND. exch2_iLo(ns,is).EQ.(tNx+1)
     &                    .AND. exch2_iHi(ns,is).EQ.(tNx+1) ) THEN
            ip(3) = is
            np(3) = ns
          ENDIF
          IF ( ip(4).EQ.0 .AND. exch2_isWedge(is).EQ.1
     &                    .AND. exch2_iLo(ns,is).EQ. 0
     &                    .AND. exch2_iHi(ns,is).EQ. 0 ) THEN
            ip(4) = is
            np(4) = ns
          ENDIF
         ENDDO

C--     end if active tile
        ENDIF
       ENDDO
C---   write the last one:
         DO i=1,4
          IF ( ip(i).NE.0 ) THEN
            j  = exch2_myFace(ip(i))
            it = exch2_neighbourId (np(i),ip(i))
            nt = exch2_opposingSend(np(i),ip(i))
            jt = exch2_myFace(it)
            ii = 0
            IF ( exch2_jLo(nt,it).EQ.exch2_jHi(nt,it) )
     &        ii = 2 - MIN(1,exch2_jHi(nt,it))
            IF ( exch2_iLo(nt,it).EQ.exch2_iHi(nt,it) )
     &        ii = 4 - MIN(1,exch2_iHi(nt,it))
            WRITE(W2_oUnit,'(2(3A,I3),A,4I3,A,2I6)')
     &      '  ', edge(i), '.Edge Facet', j, ' <-- ',
     &           edge(ii), '.Edge Facet', jt,
     &      ' : pij=', (exch2_pij(k,np(i),ip(i)),k=1,4),
     &      ' ; oi,oj=',exch2_oi(np(i),ip(i)),exch2_oj(np(i),ip(i))
          ENDIF
         ENDDO
C---
      ENDIF

C=================== from W2_SET_MAP_TILES :

C     Set-up tiles mapping and IO global mapping
c     WRITE(msgBuf,'(2A)') 'W2_SET_MAP_TILES:',
      WRITE(msgBuf,'(2A)') 'W2_PRINT_E2SETUP:',
     &       ' tile mapping within facet and global Map:'
      CALL PRINT_MESSAGE( msgBuf, W2_oUnit, SQUEEZE_RIGHT, myThid )

C--   Check that tile dims divide facet dims
C--   Check that domain size and (SIZE.h + blankList) match:
C--   Compact IO map (mostly in Y dir): search for Greatest Common Divisor
C     of all x-size (faster to apply GCD to Nb of Tiles in X):

      WRITE(msgBuf,'(A,2(A,I8))') ' Global Map (IO):',
     &  ' X-size=', exch2_global_Nx, ' , Y-size=', exch2_global_Ny
      CALL PRINT_MESSAGE( msgBuf, W2_oUnit, SQUEEZE_RIGHT, myThid )

C--   Set tiles mapping within facet (sub-domain) and within Global Map
c     WRITE(msgBuf,'(2A)') 'W2_SET_MAP_TILES:',
      WRITE(msgBuf,'(2A)') 'W2_PRINT_E2SETUP:',
     &       ' tile offset within facet and global Map:'
      CALL PRINT_MESSAGE( msgBuf, W2_oUnit, SQUEEZE_RIGHT, myThid )
      jp = 0
      DO is=1,exch2_nTiles
       js  = exch2_myFace(is)
       IF ( js.NE.0 ) THEN
         fNx = exch2_mydNx(is)
         fNy = exch2_mydNy(is)
         nbTx = fNx/tNx
         nbTy = fNy/tNy
         IF ( js .NE. jp )
     &   WRITE(W2_oUnit,'(A,I3,2(A,I6),A,I5,2(A,I4),A)')
     &    '- facet', js, ' : X-size=', fNx, ' , Y-size=', fNy,
     &    ' ;', nbTx*nbTy, ' tiles (Tx,Ty=', nbTx,',',nbTy,')'
         jp = js
         IF ( prtFlag ) THEN
           tx = 1 + exch2_tBasex(is)/tNx
           ty = 1 + exch2_tBasey(is)/tNy
          WRITE(W2_oUnit,'(A,I5,3(A,I3),2A,2I5,2A,2I8)') '  tile',is,
     &    ' on facet', exch2_myFace(is),' (',tx,',',ty,'):',
     &         ' offset=', exch2_tBasex(is), exch2_tBasey(is),' ;',
     &    ' on Glob.Map=', exch2_txGlobalo(is),exch2_tyGlobalo(is)
         ENDIF
       ENDIF
      ENDDO

C=================== from W2_SET_TILE2TILES :
c     WRITE(msgBuf,'(2A)') 'W2_SET_TILE2TILES:',
      WRITE(msgBuf,'(2A)') 'W2_PRINT_E2SETUP:',
     &       ' tile neighbours and index connection:'
      CALL PRINT_MESSAGE( msgBuf, W2_oUnit, SQUEEZE_RIGHT, myThid )

      it = 1
      DO is=1,exch2_nTiles
       js  = exch2_myFace(is)
       IF ( js.NE.0 ) THEN
        IF ( exch2_nNeighbours(is).GT.exch2_nNeighbours(it) ) it = is
        IF ( prtFlag ) THEN
         WRITE(W2_oUnit,'(A,I8,A,I3,A,4(A,I2))') 'Tile',is,
     &    ' : nbNeighb=',exch2_nNeighbours(is),' ; is-at-Facet-Edge:',
     &        ' N=', exch2_isNedge(is), ' , S=', exch2_isSedge(is),
     &      ' , E=', exch2_isEedge(is), ' , W=', exch2_isWedge(is)
         DO ns=1,exch2_nNeighbours(is)
          WRITE(W2_oUnit,'(A,I3,A,I8,2(A,2I6),A,4I3,A,2I6,A)')
     &     ' ns:',ns,' it=',exch2_neighbourId(ns,is),
     &     ', iLo,iHi=', exch2_iLo(ns,is), exch2_iHi(ns,is),
     &     ', jLo,jHi=', exch2_jLo(ns,is), exch2_jHi(ns,is)
c    &     , ' (pij=',(exch2_pij(k,ns,is),k=1,4),
c    &     ', oi,oj=', exch2_oi(ns,is), exch2_oj(ns,is),')'
         ENDDO
        ENDIF
       ENDIF
      ENDDO
      IF ( it.NE.0 ) THEN
       WRITE(msgBuf,'(A,I5,A,I3)')
     &  'current Max.Nb.Neighbours (e.g., on tile',it,
     &  ' ) =', exch2_nNeighbours(it)
       CALL PRINT_MESSAGE( msgBuf, W2_oUnit, SQUEEZE_RIGHT, myThid )
      ENDIF

      RETURN
      END

#include "REGRID_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 0
C     !ROUTINE: REGRID_CHECK

C     !INTERFACE:
      SUBROUTINE REGRID_CHECK( myThid )

C     !DESCRIPTION:
C     Check dependances with other packages

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "REGRID_SIZE.h"
#include "REGRID.h"

C     !INPUT PARAMETERS:
C     myThid -  Number of this instances
      INTEGER myThid
CEOP

C     !LOCAL VARIABLES:
C     msgBuf      - Informational/error meesage buffer
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      

#ifdef ALLOW_REGRID
      
      WRITE(msgBuf,'(A)') 'REGRID_CHECK: #define REGRID'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &     SQUEEZE_RIGHT , 1)

      _BEGIN_MASTER(myThid)
      
      IF (.NOT. useMNC) THEN
        WRITE(msgBuf,'(A)') 'Regrid needs useMNC=.true.'
        CALL PRINT_ERROR( msgBuf , 1)
        STOP 'ABNORMAL END: S/R REGRID_CHECK'
      ENDIF
      
      _END_MASTER(myThid)
      
#endif /* ALLOW_REGRID */
      
      RETURN
      END

#include "SMOOTH_OPTIONS.h"

      SUBROUTINE SMOOTH_DIFF2D(
     &           fld_in, smooth2Dmask, nbt_in, myThid )

C     *==========================================================*
C     | SUBROUTINE smooth_diff2D
C     | o Routine that smoothes a 2D field, using diffusion
C     *==========================================================*

      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "GRID.h"
#include "PARAMS.h"
#include "SMOOTH.h"

      _RL fld_in      (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RS smooth2Dmask(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      INTEGER nbt_in
      INTEGER myThid

      INTEGER i, j, bi, bj
      INTEGER myIter(nSx,nSy), iloop
      _RL ab15, ab05
      _RL gt_tmp
      _RL gt_in  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL gtm1_in(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)

      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        DO j = 1,sNy
         DO i = 1,sNx
           gt_in(i,j,bi,bj)   = 0. _d 0
           gtm1_in(i,j,bi,bj) = 0. _d 0
         ENDDO
        ENDDO
       ENDDO
      ENDDO

      CALL EXCH_XY_RL( fld_in,  myThid )
      CALL EXCH_XY_RL( gt_in,   myThid )
      CALL EXCH_XY_RL( gtm1_in, myThid )

      DO iloop=1,nbt_in

        DO bj=myByLo(myThid),myByHi(myThid)
         DO bi=myBxLo(myThid),myBxHi(myThid)
          DO j = 1,sNy
           DO i = 1,sNx

            gt_in(i,j,bi,bj)=0.

            IF (smooth2Dmask(i,j,bi,bj).NE.0.) THEN

             gt_in(i,j,bi,bj) = gt_in(i,j,bi,bj)
     &         + smooth2D_Kux(i,j,bi,bj)*dyG(i,j,bi,bj)
     &          *smooth2Dmask(i,j,bi,bj)*smooth2Dmask(i-1,j,bi,bj)
     &          *( fld_in(i,j,bi,bj) - fld_in(i-1,j,bi,bj) )
     &          *recip_dxC(i,j,bi,bj)

             gt_in(i,j,bi,bj) = gt_in(i,j,bi,bj)
     &         + smooth2D_Kux(i+1,j,bi,bj)*dyG(i+1,j,bi,bj)
     &          *smooth2Dmask(i,j,bi,bj)*smooth2Dmask(i+1,j,bi,bj)
     &          *( fld_in(i,j,bi,bj) - fld_in(i+1,j,bi,bj) )
     &          *recip_dxC(i+1,j,bi,bj)

             gt_in(i,j,bi,bj) = gt_in(i,j,bi,bj)
     &         + smooth2D_Kvy(i,j,bi,bj)*dxG(i,j,bi,bj)
     &          *smooth2Dmask(i,j,bi,bj)*smooth2Dmask(i,j-1,bi,bj)
     &          *( fld_in(i,j,bi,bj) - fld_in(i,j-1,bi,bj) )
     &          *recip_dyC(i,j,bi,bj)

             gt_in(i,j,bi,bj) = gt_in(i,j,bi,bj)
     &         + smooth2D_Kvy(i,j+1,bi,bj)*dxG(i,j+1,bi,bj)
     &          *smooth2Dmask(i,j,bi,bj)*smooth2Dmask(i,j+1,bi,bj)
     &          *( fld_in(i,j,bi,bj) - fld_in(i,j+1,bi,bj) )
     &          *recip_dyC(i,j+1,bi,bj)

            ENDIF

           ENDDO
          ENDDO
         ENDDO
        ENDDO

        DO bj=myByLo(myThid),myByHi(myThid)
         DO bi=myBxLo(myThid),myBxHi(myThid)
c Adams-Bashforth timestepping
          myIter(bi,bj)=iloop-1
          IF ( myIter(bi,bj).EQ.0 ) THEN
           ab15 = 1.0
           ab05 = 0.0
          ELSE
           ab15 =   1.5 + abEps
           ab05 = -(0.5 + abEps)
          ENDIF
          DO j = 1,sNy
           DO i = 1,sNx
c Compute effective G-term with Adams-Bashforth
            gt_tmp = ab15*gt_in(i,j,bi,bj) + ab05*gtm1_in(i,j,bi,bj)
            gtm1_in(i,j,bi,bj) = gt_in(i,j,bi,bj)
            gt_in(i,j,bi,bj) = gt_tmp
c time step:
            fld_in(i,j,bi,bj) = fld_in(i,j,bi,bj)
     &        - gt_in(i,j,bi,bj)*recip_rA(i,j,bi,bj)*smooth2DdelTime
            gt_in(i,j,bi,bj) = 0.
           ENDDO
          ENDDO
         ENDDO
        ENDDO

        CALL EXCH_XY_RL( gt_in,   myThid )
        CALL EXCH_XY_RL( fld_in,  myThid )
        CALL EXCH_XY_RL( gtm1_in, myThid )

      ENDDO

      RETURN
      END

#include "SHOWFLOPS_OPTIONS.h"

CBOP
C     !ROUTINE: SHOWFLOPS_INSOLVE
C     !INTERFACE:
      SUBROUTINE SHOWFLOPS_INSOLVE( myThid )

C     !DESCRIPTION: \bv
C     *================================================================*
C     | SUBROUTINE showflops_insolve
C     | o Do runtime timing
C     *================================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "SHOWFLOPS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     note: under the multi-threaded model myiter and
C           mytime are local variables passed around as routine
C           arguments. Although this is fiddly it saves the need to
C           impose additional synchronisation points when they are
C           updated.
C     myThid - thread number for this instance of the routine.
      integer iloop
      INTEGER myThid

C     !FUNCTIONS:
C     == Functions ==
#ifdef ALLOW_RUNCLOCK
      LOGICAL RUNCLOCK_CONTINUE
      LOGICAL RC_CONT
#endif

C     !LOCAL VARIABLES:
C     == Local variables ==

CEOP

#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_ENTER('SHOWFLOPS_INSOLVE',myThid)
#endif

#ifdef TIME_PER_TIMESTEP_SFP
CCE107 Time per timestep information
      _BEGIN_MASTER( myThid )
      CALL TIMER_GET_TIME( utnew, stnew, wtnew )
C Only output timing information after the 1st timestep
      IF ( wtold .NE. 0.0D0 ) THEN
        WRITE(msgBuf,'(A34,3F10.6)')
     $        'User, system and wallclock time:', utnew - utold,
     $        stnew - stold, wtnew - wtold
         CALL PRINT_MESSAGE(msgBuf,standardMessageUnit,SQUEEZE_RIGHT,1)
      ENDIF
      utold = utnew
      stold = stnew
      wtold = wtnew
      _END_MASTER( myThid )
#endif
#ifdef USE_PAPI_FLOPS_SFP
CCE107 PAPI summary performance
      _BEGIN_MASTER( myThid )
#ifdef USE_FLIPS
      call PAPIF_flips(real_time, proc_time, flpops, mflops, check)
#else
      call PAPIF_flops(real_time, proc_time, flpops, mflops, check)
#endif
      WRITE(msgBuf,'(A34,F12.6,A,F12.6)')
     $     'Mflop/s during this timestep:', mflops, ' ', mflops
     $     *proc_time/(real_time + 1E-36)
      CALL PRINT_MESSAGE(msgBuf,standardMessageUnit,SQUEEZE_RIGHT,1)
#ifdef PAPI_VERSION
      call PAPIF_ipc(real_time, proc_time, instr, ipc, check)
      WRITE(msgBuf,'(A34,F12.6,A,F12.6)')
     $     'IPC during this timestep:', ipc, ' ', ipc*proc_time
     $     /(real_time + 1E-36)
      CALL PRINT_MESSAGE(msgBuf,standardMessageUnit,SQUEEZE_RIGHT,1)
#endif
      _END_MASTER( myThid )
#else
#ifdef USE_PCL_FLOPS_SFP
CCE107 PCL summary performance
      _BEGIN_MASTER( myThid )
      PCLstop(descr, i_result, fp_result, nevents)
      do ipcl = 1, nevents
         WRITE(msgBuf,'(A22,A26,F12.6)'),
     $        pcl_counter_name(pcl_counter_list(ipcl)),
     $        'during this timestep:', fp_results(ipcl)
         CALL PRINT_MESSAGE(msgBuf,standardMessageUnit,SQUEEZE_RIGHT,1)
      enddo
      PCLstart(descr, pcl_counter_list, nevents, flags)
      _END_MASTER( myThid )
#endif
#endif

#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_LEAVE('SHOWFLOPS_INSOLVE',myThid)
#endif

      END

#include "CPP_OPTIONS.h"
#ifdef TARGET_NEC_SX
C     set a sensible default for the outer loop unrolling parameter that can
C     be overriden in the Makefile with the DEFINES macro or in CPP_OPTIONS.h
#ifndef CG3D_OUTERLOOPITERS
# define CG3D_OUTERLOOPITERS 10
#endif
#endif /* TARGET_NEC_SX */

CBOP
C     !ROUTINE: CG3D_EX0
C     !INTERFACE:
      SUBROUTINE CG3D_EX0(
     U                cg3d_b, cg3d_x,
     O                firstResidual, lastResidual,
     U                numIters,
     I                myIter, myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE CG3D_EX0
C     | o Three-dimensional grid problem conjugate-gradient
C     |   inverter (with preconditioner).
C     | This is the disconnected-tile version (each tile treated
C     |   independently as a small domain, with locally periodic
C     |   BC at the edges.
C     *==========================================================*
C     | Con. grad is an iterative procedure for solving Ax = b.
C     | It requires the A be symmetric.
C     | This implementation assumes A is a seven-diagonal matrix
C     | of the form that arises in the discrete representation of
C     | the del^2 operator in a three-dimensional space.
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     === Global data ===
#include "SIZE.h"
#include "EEPARAMS.h"
#ifdef ALLOW_NONHYDROSTATIC
# include "PARAMS.h"
# include "GRID.h"
# include "SURFACE.h"
# include "CG3D.h"
#endif /* ALLOW_NONHYDROSTATIC */

C     !INPUT/OUTPUT PARAMETERS:
C     cg3d_b    :: The source term or "right hand side" (output: normalised RHS)
C     cg3d_x    :: The solution (input: first guess)
C     firstResidual :: the initial residual before any iterations
C     minResidualSq :: the lowest residual reached (squared)
CC    lastResidual  :: the actual residual reached
C     numIters  :: Inp: the maximum number of iterations allowed
C                  Out: the actual number of iterations used
CC    nIterMin  :: Inp: decide to store (if >=0) or not (if <0) lowest res. sol.
CC                 Out: iteration number corresponding to lowest residual
C     myIter    :: Current iteration number in simulation
C     myThid    :: my Thread Id number
      _RL     cg3d_b(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      _RL     cg3d_x(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      _RL     firstResidual
      _RL     lastResidual
      INTEGER numIters
      INTEGER myIter
      INTEGER myThid

#ifdef ALLOW_NONHYDROSTATIC
C     !LOCAL VARIABLES:
C     bi, bj     :: tile index in X and Y.
C     i, j, k    :: Loop counters
C     it3d       :: Loop counter for CG iterations
C     actualIts  :: actual CG iteration number
C     err_sq     :: Measure of the square of the residual of Ax - b.
C     eta_qrN    :: Used in computing search directions; suffix N and NM1
C     eta_qrNM1     denote current and previous iterations respectively.
C     cgBeta     :: coeff used to update conjugate direction vector "s".
C     alpha      :: coeff used to update solution & residual
C     sumRHS     :: Sum of right-hand-side. Sometimes this is a useful
C                   debugging/trouble shooting diagnostic. For neumann problems
C                   sumRHS needs to be ~0 or it converge at a non-zero residual.
C     cg2d_min   :: used to store solution corresponding to lowest residual.
C     msgBuf     :: Informational/error message buffer
      INTEGER bi, bj
      INTEGER i, j, k, it3d
      INTEGER actualIts(nSx,nSy)
      INTEGER km1, kp1
      _RL     maskM1, maskP1
      _RL     err_sq,  errTile(nSx,nSy)
      _RL     eta_qrNtile(nSx,nSy)
      _RL     eta_qrNM1(nSx,nSy)
      _RL     cgBeta
      _RL     alpha ,  alphaTile(nSx,nSy)
      _RL     sumRHS,  sumRHStile(nSx,nSy)
      _RL     rhsMax, rhsMaxLoc
      _RL     rhsNorm(nSx,nSy)
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      LOGICAL printResidual
      _RL     surfFac
#ifdef NONLIN_FRSURF
      INTEGER ks
      _RL     surfTerm(sNx,sNy)
#endif /* NONLIN_FRSURF */
CEOP

C--   Initialise auxiliary constant, some output variable
      IF ( select_rStar .NE. 0 ) THEN
        surfFac = freeSurfFac
      ELSE
        surfFac = 0.
      ENDIF
#ifdef NONLIN_FRSURF
      DO j=1,sNy
       DO i=1,sNx
         surfTerm(i,j) = 0.
       ENDDO
      ENDDO
#endif /* NONLIN_FRSURF */

C--   Initialise inverter and   Normalise RHS
      rhsMax = 0. _d 0
      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)

        actualIts(bi,bj) = 0
        eta_qrNM1(bi,bj) =  1. _d 0
        rhsMaxLoc = 0. _d 0
        DO k=1,Nr
         DO j=1,sNy
          DO i=1,sNx
           cg3d_b(i,j,k,bi,bj) = cg3d_b(i,j,k,bi,bj)*cg3dNorm
     &                          * maskC(i,j,k,bi,bj)
           rhsMaxLoc = MAX(ABS(cg3d_b(i,j,k,bi,bj)),rhsMaxLoc)
          ENDDO
         ENDDO
        ENDDO
        rhsNorm(bi,bj) = 1. _d 0
        IF ( rhsMaxLoc .NE. 0. ) rhsNorm(bi,bj) = 1. _d 0 / rhsMaxLoc
        DO k=1,Nr
         DO j=1,sNy
          DO i=1,sNx
           cg3d_b(i,j,k,bi,bj) = cg3d_b(i,j,k,bi,bj)*rhsNorm(bi,bj)
           cg3d_x(i,j,k,bi,bj) = cg3d_x(i,j,k,bi,bj)*rhsNorm(bi,bj)
          ENDDO
         ENDDO
        ENDDO
        rhsMax = MAX( rhsMaxLoc, rhsMax )

       ENDDO
      ENDDO
      _GLOBAL_MAX_RL( rhsMax, myThid )

C--   Update overlaps
      _EXCH_XYZ_RL( cg3d_x, myThid )

C--   Initial residual calculation (with free-Surface term)
      err_sq = 0.
      sumRHS = 0.
      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        errTile(bi,bj)    = 0. _d 0
        sumRHStile(bi,bj) = 0. _d 0
#ifdef NONLIN_FRSURF
        IF ( select_rStar .NE. 0 ) THEN
          DO j=1,sNy
           DO i=1,sNx
             surfTerm(i,j) = 0.
           ENDDO
          ENDDO
          DO k=1,Nr
           DO j=1,sNy
            DO i=1,sNx
             surfTerm(i,j) = surfTerm(i,j)
     &         +cg3d_x(i,j,k,bi,bj)*drF(k)*h0FacC(i,j,k,bi,bj)
            ENDDO
           ENDDO
          ENDDO
          DO j=1,sNy
           DO i=1,sNx
             ks = kSurfC(i,j,bi,bj)
             surfTerm(i,j) = surfTerm(i,j)*cg3dNorm
     &              *recip_Rcol(i,j,bi,bj)*recip_Rcol(i,j,bi,bj)
     &              *rA(i,j,bi,bj)*deepFac2F(ks)
     &              *recip_Bo(i,j,bi,bj)/deltaTMom/deltaTFreeSurf
           ENDDO
          ENDDO
        ENDIF
#endif /* NONLIN_FRSURF */
        DO k=1,Nr
         km1 = MAX(k-1, 1 )
         kp1 = MIN(k+1, Nr)
         maskM1 = 1. _d 0
         maskP1 = 1. _d 0
         IF ( k .EQ. 1 ) maskM1 = 0. _d 0
         IF ( k .EQ. Nr) maskP1 = 0. _d 0
#ifdef TARGET_NEC_SX
!CDIR OUTERUNROLL=CG3D_OUTERLOOPITERS
#endif /* TARGET_NEC_SX */
         DO j=1,sNy
          DO i=1,sNx
           cg3d_r(i,j,k,bi,bj) = cg3d_b(i,j,k,bi,bj)
     &     -( 0.
     &       +aW3d( i, j, k, bi,bj)*cg3d_x(i-1,j, k, bi,bj)
     &       +aW3d(i+1,j, k, bi,bj)*cg3d_x(i+1,j, k, bi,bj)
     &       +aS3d( i, j, k, bi,bj)*cg3d_x( i,j-1,k, bi,bj)
     &       +aS3d( i,j+1,k, bi,bj)*cg3d_x( i,j+1,k, bi,bj)
     &       +aV3d( i, j, k, bi,bj)*cg3d_x( i, j,km1,bi,bj)*maskM1
     &       +aV3d( i, j,kp1,bi,bj)*cg3d_x( i, j,kp1,bi,bj)*maskP1
     &       +aC3d( i, j, k, bi,bj)*cg3d_x( i, j, k, bi,bj)
#ifdef NONLIN_FRSURF
     &       -surfFac*surfTerm(i,j)*drF(k)*h0FacC(i,j,k,bi,bj)
#endif /* NONLIN_FRSURF */
     &      )
           errTile(bi,bj) = errTile(bi,bj)
     &                    +cg3d_r(i,j,k,bi,bj)*cg3d_r(i,j,k,bi,bj)
           sumRHStile(bi,bj) = sumRHStile(bi,bj)+cg3d_b(i,j,k,bi,bj)
          ENDDO
         ENDDO
         DO j=0,sNy+1
          DO i=0,sNx+1
           cg3d_s(i,j,k,bi,bj) = 0.
          ENDDO
         ENDDO
        ENDDO
        err_sq = MAX( errTile(bi,bj), err_sq )
        sumRHS = MAX( ABS(sumRHStile(bi,bj)), sumRHS )
       ENDDO
      ENDDO
       CALL EXCH_S3D_RL( cg3d_r, Nr, myThid )
      _GLOBAL_MAX_RL( err_sq, myThid )
      _GLOBAL_MAX_RL( sumRHS, myThid )
      IF ( debugLevel.GE.debLevC .AND. diagFreq.GT.0. ) THEN
        CALL WRITE_FLD_S3D_RL(
     I        'cg3d_r_I', 'I10', 1, Nr, cg3d_r, myIter, myThid )
      ENDIF
      firstResidual = SQRT(err_sq)

      printResidual = .FALSE.
      IF ( debugLevel .GE. debLevZero ) THEN
        _BEGIN_MASTER( myThid )
        printResidual = printResidualFreq.GE.1
        WRITE(standardMessageUnit,'(A,1P2E22.14)')
     &     ' cg3d: Sum(rhs),rhsMax = ',sumRHS,rhsMax
        _END_MASTER( myThid )
      ENDIF

c     IF ( err_sq .LT. cg3dTolerance_sq ) GOTO 11

C     >>>>>>>>>>>>>>> BEGIN SOLVER <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
      DO it3d=1, numIters
      IF ( err_sq.GE.cg3dTolerance_sq ) THEN
       err_sq = 0. _d 0

       DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        IF ( errTile(bi,bj).GE.cg3dTolerance_sq ) THEN

C--    Solve preconditioning equation and update
C--    conjugate direction vector "s".
C      Note. On the next two loops over all tiles the inner loop ranges
C            in sNx and sNy are expanded by 1 to avoid a communication
C            step. However this entails a bit of gynamastics because we only
C            want eta_qrN for the interior points.
         eta_qrNtile(bi,bj) = 0. _d 0
         DO k=1,1
#ifdef TARGET_NEC_SX
!CDIR OUTERUNROLL=CG3D_OUTERLOOPITERS
#endif /* TARGET_NEC_SX */
          DO j=0,sNy+1
           DO i=0,sNx+1
            cg3d_q(i,j,k,bi,bj) = zMC(i,j,k,bi,bj)
     &                        *cg3d_r(i,j,k,bi,bj)
           ENDDO
          ENDDO
         ENDDO
         DO k=2,Nr
#ifdef TARGET_NEC_SX
!CDIR OUTERUNROLL=CG3D_OUTERLOOPITERS
#endif /* TARGET_NEC_SX */
          DO j=0,sNy+1
           DO i=0,sNx+1
            cg3d_q(i,j,k,bi,bj) = zMC(i,j,k,bi,bj)
     &                      *( cg3d_r(i,j,k,bi,bj)
     &                         -zML(i,j,k,bi,bj)*cg3d_q(i,j,k-1,bi,bj)
     &                       )
           ENDDO
          ENDDO
         ENDDO
         DO k=Nr,Nr
#ifdef TARGET_NEC_SX
!CDIR OUTERUNROLL=CG3D_OUTERLOOPITERS
#endif /* TARGET_NEC_SX */
          DO j=1,sNy
           DO i=1,sNx
            eta_qrNtile(bi,bj) = eta_qrNtile(bi,bj)
     &                        +cg3d_q(i,j,k,bi,bj)*cg3d_r(i,j,k,bi,bj)
           ENDDO
          ENDDO
         ENDDO
         DO k=Nr-1,1,-1
#ifdef TARGET_NEC_SX
!CDIR OUTERUNROLL=CG3D_OUTERLOOPITERS
#endif /* TARGET_NEC_SX */
          DO j=0,sNy+1
           DO i=0,sNx+1
            cg3d_q(i,j,k,bi,bj) = cg3d_q(i,j,k,bi,bj)
     &                         -zMU(i,j,k,bi,bj)*cg3d_q(i,j,k+1,bi,bj)
           ENDDO
          ENDDO
#ifdef TARGET_NEC_SX
!CDIR OUTERUNROLL=CG3D_OUTERLOOPITERS
#endif /* TARGET_NEC_SX */
          DO j=1,sNy
           DO i=1,sNx
            eta_qrNtile(bi,bj) = eta_qrNtile(bi,bj)
     &                        +cg3d_q(i,j,k,bi,bj)*cg3d_r(i,j,k,bi,bj)
           ENDDO
          ENDDO
         ENDDO

         cgBeta   = eta_qrNtile(bi,bj)/eta_qrNM1(bi,bj)
         eta_qrNM1(bi,bj) = eta_qrNtile(bi,bj)

         DO k=1,Nr
          DO j=0,sNy+1
           DO i=0,sNx+1
            cg3d_s(i,j,k,bi,bj) = cg3d_q(i,j,k,bi,bj)
     &                   + cgBeta*cg3d_s(i,j,k,bi,bj)
           ENDDO
          ENDDO
         ENDDO

C==    Evaluate laplace operator on conjugate gradient vector
C==    q = A.s
         alphaTile(bi,bj) = 0. _d 0
#ifdef NONLIN_FRSURF
         IF ( select_rStar .NE. 0 ) THEN
          DO j=1,sNy
           DO i=1,sNx
             surfTerm(i,j) = 0.
           ENDDO
          ENDDO
          DO k=1,Nr
           DO j=1,sNy
            DO i=1,sNx
             surfTerm(i,j) = surfTerm(i,j)
     &         +cg3d_s(i,j,k,bi,bj)*drF(k)*h0FacC(i,j,k,bi,bj)
            ENDDO
           ENDDO
          ENDDO
          DO j=1,sNy
           DO i=1,sNx
             ks = kSurfC(i,j,bi,bj)
             surfTerm(i,j) = surfTerm(i,j)*cg3dNorm
     &              *recip_Rcol(i,j,bi,bj)*recip_Rcol(i,j,bi,bj)
     &              *rA(i,j,bi,bj)*deepFac2F(ks)
     &              *recip_Bo(i,j,bi,bj)/deltaTMom/deltaTFreeSurf
           ENDDO
          ENDDO
         ENDIF
#endif /* NONLIN_FRSURF */
         IF ( Nr .GT. 1 ) THEN
          k=1
#ifdef TARGET_NEC_SX
!CDIR OUTERUNROLL=CG3D_OUTERLOOPITERS
#endif /* TARGET_NEC_SX */
          DO j=1,sNy
           DO i=1,sNx
            cg3d_q(i,j,k,bi,bj) =
     &        aW3d( i, j, k, bi,bj)*cg3d_s(i-1,j, k, bi,bj)
     &       +aW3d(i+1,j, k, bi,bj)*cg3d_s(i+1,j, k, bi,bj)
     &       +aS3d( i, j, k, bi,bj)*cg3d_s( i,j-1,k, bi,bj)
     &       +aS3d( i,j+1,k, bi,bj)*cg3d_s( i,j+1,k, bi,bj)
     &       +aV3d( i, j,k+1,bi,bj)*cg3d_s( i, j,k+1,bi,bj)
     &       +aC3d( i, j, k, bi,bj)*cg3d_s( i, j, k, bi,bj)
#ifdef NONLIN_FRSURF
     &       -surfFac*surfTerm(i,j)*drF(k)*h0FacC(i,j,k,bi,bj)
#endif /* NONLIN_FRSURF */
            alphaTile(bi,bj) = alphaTile(bi,bj)
     &             +cg3d_s(i,j,k,bi,bj)*cg3d_q(i,j,k,bi,bj)
           ENDDO
          ENDDO
         ELSE
          k=1
#ifdef TARGET_NEC_SX
!CDIR OUTERUNROLL=CG3D_OUTERLOOPITERS
#endif /* TARGET_NEC_SX */
          DO j=1,sNy
           DO i=1,sNx
            cg3d_q(i,j,k,bi,bj) =
     &        aW3d( i, j, k, bi,bj)*cg3d_s(i-1,j, k, bi,bj)
     &       +aW3d(i+1,j, k, bi,bj)*cg3d_s(i+1,j, k, bi,bj)
     &       +aS3d( i, j, k, bi,bj)*cg3d_s( i,j-1,k, bi,bj)
     &       +aS3d( i,j+1,k, bi,bj)*cg3d_s( i,j+1,k, bi,bj)
     &       +aC3d( i, j, k, bi,bj)*cg3d_s( i, j, k, bi,bj)
#ifdef NONLIN_FRSURF
     &       -surfFac*surfTerm(i,j)*drF(k)*h0FacC(i,j,k,bi,bj)
#endif /* NONLIN_FRSURF */
            alphaTile(bi,bj) = alphaTile(bi,bj)
     &             +cg3d_s(i,j,k,bi,bj)*cg3d_q(i,j,k,bi,bj)
           ENDDO
          ENDDO
         ENDIF
         DO k=2,Nr-1
#ifdef TARGET_NEC_SX
!CDIR OUTERUNROLL=CG3D_OUTERLOOPITERS
#endif /* TARGET_NEC_SX */
          DO j=1,sNy
           DO i=1,sNx
            cg3d_q(i,j,k,bi,bj) =
     &        aW3d( i, j, k, bi,bj)*cg3d_s(i-1,j, k, bi,bj)
     &       +aW3d(i+1,j, k, bi,bj)*cg3d_s(i+1,j, k, bi,bj)
     &       +aS3d( i, j, k, bi,bj)*cg3d_s( i,j-1,k, bi,bj)
     &       +aS3d( i,j+1,k, bi,bj)*cg3d_s( i,j+1,k, bi,bj)
     &       +aV3d( i, j, k, bi,bj)*cg3d_s( i, j,k-1,bi,bj)
     &       +aV3d( i, j,k+1,bi,bj)*cg3d_s( i, j,k+1,bi,bj)
     &       +aC3d( i, j, k, bi,bj)*cg3d_s( i, j, k, bi,bj)
#ifdef NONLIN_FRSURF
     &       -surfFac*surfTerm(i,j)*drF(k)*h0FacC(i,j,k,bi,bj)
#endif /* NONLIN_FRSURF */
            alphaTile(bi,bj) = alphaTile(bi,bj)
     &             +cg3d_s(i,j,k,bi,bj)*cg3d_q(i,j,k,bi,bj)
           ENDDO
          ENDDO
         ENDDO
         IF ( Nr .GT. 1 ) THEN
          k=Nr
#ifdef TARGET_NEC_SX
!CDIR OUTERUNROLL=CG3D_OUTERLOOPITERS
#endif /* TARGET_NEC_SX */
          DO j=1,sNy
           DO i=1,sNx
            cg3d_q(i,j,k,bi,bj) =
     &        aW3d( i, j, k, bi,bj)*cg3d_s(i-1,j, k, bi,bj)
     &       +aW3d(i+1,j, k, bi,bj)*cg3d_s(i+1,j, k, bi,bj)
     &       +aS3d( i, j, k, bi,bj)*cg3d_s( i,j-1,k, bi,bj)
     &       +aS3d( i,j+1,k, bi,bj)*cg3d_s( i,j+1,k, bi,bj)
     &       +aV3d( i, j, k, bi,bj)*cg3d_s( i, j,k-1,bi,bj)
     &       +aC3d( i, j, k, bi,bj)*cg3d_s( i, j, k, bi,bj)
#ifdef NONLIN_FRSURF
     &       -surfFac*surfTerm(i,j)*drF(k)*h0FacC(i,j,k,bi,bj)
#endif /* NONLIN_FRSURF */
            alphaTile(bi,bj) = alphaTile(bi,bj)
     &             +cg3d_s(i,j,k,bi,bj)*cg3d_q(i,j,k,bi,bj)
           ENDDO
          ENDDO
         ENDIF
         alpha = eta_qrNtile(bi,bj)/alphaTile(bi,bj)

C==    Update simultaneously solution and residual vectors (and Iter number)
C      Now compute "interior" points.
         errTile(bi,bj) = 0. _d 0
         DO k=1,Nr
#ifdef TARGET_NEC_SX
!CDIR OUTERUNROLL=CG3D_OUTERLOOPITERS
#endif /* TARGET_NEC_SX */
          DO j=1,sNy
           DO i=1,sNx
            cg3d_x(i,j,k,bi,bj)=cg3d_x(i,j,k,bi,bj)
     &            +alpha*cg3d_s(i,j,k,bi,bj)
            cg3d_r(i,j,k,bi,bj)=cg3d_r(i,j,k,bi,bj)
     &            -alpha*cg3d_q(i,j,k,bi,bj)
            errTile(bi,bj) = errTile(bi,bj)
     &            +cg3d_r(i,j,k,bi,bj)*cg3d_r(i,j,k,bi,bj)
           ENDDO
          ENDDO
         ENDDO
         actualIts(bi,bj) = it3d

         IF ( printResidual ) THEN
          IF ( MOD( it3d-1, printResidualFreq ).EQ.0 ) THEN
           WRITE(msgBuf,'(A,2I4,A,I6,A,1PE21.14)') ' cg3d(bi,bj=', bi,
     &      bj, '): iter=', it3d, ' ; resid.= ', SQRT(errTile(bi,bj))
           CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                         SQUEEZE_RIGHT, myThid )
          ENDIF
         ENDIF

         CALL FILL_HALO_LOCAL_RL(
     U                  cg3d_r(0,0,1,bi,bj),
     I                  1, 1, 1, 1, Nr,
     I                  EXCH_IGNORE_CORNERS, bi, bj, myThid )

        ENDIF
        err_sq = MAX( errTile(bi,bj), err_sq )
C-    end bi,bj loops
       ENDDO
       ENDDO
C-    end cg-2d iteration loop
      ENDIF
      ENDDO

c  11 CONTINUE

      IF ( debugLevel.GE.debLevC .AND. diagFreq.GT.0. ) THEN
        CALL WRITE_FLD_S3D_RL(
     I        'cg3d_r_F', 'I10', 1, Nr, cg3d_r, myIter, myThid )
      ENDIF

C--   Un-normalise the answer
      numIters = 0
      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        DO k=1,Nr
         DO j=1,sNy
          DO i=1,sNx
           cg3d_x(i,j,k,bi,bj) = cg3d_x(i,j,k,bi,bj)/rhsNorm(bi,bj)
          ENDDO
         ENDDO
        ENDDO
        numIters = MAX( actualIts(bi,bj), numIters )
       ENDDO
      ENDDO

C--   Return parameters to caller
C     return largest Iter # and Max residual     in numIters and lastResidual
      _GLOBAL_MAX_RL( err_sq, myThid )
      lastResidual = SQRT(err_sq)
      alpha = numIters
      _GLOBAL_MAX_RL( alpha, myThid )
      numIters = NINT( alpha )

#endif /* ALLOW_NONHYDROSTATIC */

      RETURN
      END

#include "CTRL_OPTIONS.h"
#ifdef ALLOW_AUTODIFF
# include "AUTODIFF_OPTIONS.h"
#endif

CBOP
C     !ROUTINE: CTRL_MAP_INI_GENTIM2D
C     !INTERFACE:
      SUBROUTINE CTRL_MAP_INI_GENTIM2D( myThid )

C     !DESCRIPTION: \bv
C     *================================================================
C     | SUBROUTINE CTRL_MAP_INI_GENTIM2D
C     | Dimensionalize and preprocess time variable controls.
C     *================================================================
C     \ev

C     !USES:
      IMPLICIT NONE

C     == global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "DYNVARS.h"
#include "FFIELDS.h"
#include "CTRL_SIZE.h"
#include "CTRL.h"
#include "OPTIMCYCLE.h"
#include "CTRL_DUMMY.h"
#include "CTRL_GENARR.h"
#ifdef ALLOW_PTRACERS
# include "PTRACERS_SIZE.h"
# include "PTRACERS_FIELDS.h"
#endif
#ifdef ALLOW_AUTODIFF_TAMC
# include "tamc.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     == routine arguments ==
      INTEGER myThid

#ifdef ALLOW_GENTIM2D_CONTROL
C     !FUNCTIONS:
      INTEGER  ILNBLNK
      EXTERNAL ILNBLNK

C     !LOCAL VARIABLES:
C     == local variables ==
      integer iarr
      integer numsmo
C     Tapenade requires these 4 variables to be declared as arrays of
C     size maxCtrlTim2D. If declared as scalars, it does not store their
C     temporary values in the do loop during reverse pass.
      CHARACTER*(MAX_LEN_FNAM) fnamegenIn(1:maxCtrlTim2D)
      CHARACTER*(MAX_LEN_FNAM) fnamegenOut(1:maxCtrlTim2D)
      CHARACTER*(MAX_LEN_FNAM) fnamegenTmp(1:maxCtrlTim2D)
      CHARACTER*(MAX_LEN_FNAM) temp_genarr_fnamA
      CHARACTER*(MAX_LEN_FNAM) temp_genarr_fnamB
      integer startrec
      integer endrec
      integer diffrec
      integer iRec, jrec, kRec, lRec
      integer replicated_nrec
      integer replicated_ntimes
      logical doglobalread
      logical ladinit
      logical dowc01
      logical dosmooth
      logical doscaling
      _RL     xx_gen(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RS     mask2D(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
#ifdef ALLOW_ECCO
      _RL     xx_gen_tmp(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      integer nyearsINT
      _RL     recip_nyearsRL
#endif
      integer bi,bj
      integer i,j,k2
      integer ilgen
      integer ilDir
CEOP

#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_ENTER('CTRL_MAP_INI_GENTIM2D',myThid)
#endif /* ALLOW_DEBUG */

C--   Now, read the control vector.
      doglobalread = .false.
      ladinit      = .false.

C     Find ctrlDir (w/o trailing blanks) length
      ilDir = ilnblnk(ctrlDir)

      DO bj=myByLo(myThid), myByHi(myThid)
       DO bi=myBxLo(myThid), myBxHi(myThid)
        DO j = 1-OLy,sNy+OLy
         DO i = 1-OLx,sNx+OLx
          xx_gen(i,j,bi,bj)=0. _d 0
#ifdef ALLOW_ECCO
          xx_gen_tmp(i,j,bi,bj)=0. _d 0
#endif
         ENDDO
        ENDDO
       ENDDO
      ENDDO

C--   generic 2D control variables
      DO iarr = 1, maxCtrlTim2D

       diffrec=0
       startrec=0
       endrec=0

#ifndef ALLOW_OPENAD
       if (xx_gentim2d_weight(iarr).NE.' ') then
#endif

        ilgen=ilnblnk( xx_gentim2d_file(iarr) )
        temp_genarr_fnamA = xx_gentim2d_file(iarr)

        call ctrl_init_rec ( temp_genarr_fnamA(1:ilgen),
     I       xx_gentim2d_startdate1(iarr),
     I       xx_gentim2d_startdate2(iarr),
     I       xx_gentim2d_period(iarr),
     I       1,
     O       xx_gentim2d_startdate(1,iarr),
     O       diffrec, startrec, endrec,
     I       myThid )

C From CTRL_INIT_REC one gets [start,end,diff]rec.
C Below, file xx_*.$iter.data is read in from records startrec to endrec,
C followed by a write to file xx_*.effective.$iter.data of record 1 to diffrec
C (see TAF-generated S/R ctrl_map_ini_gentim2dmd).

#ifdef ALLOW_CTRL_DEBUG
C Note: In the "md" (i.e. TAF modified) version of this fwd S/R, DEBUG calls and
C print statements are removed. See "Automatic Differentiation" chap. in the doc
        write(*,*) 'AA: iarr,xx_gentim2d_startdate(1,iarr): ',
     &              iarr,xx_gentim2d_startdate(1,iarr)
#endif
        dosmooth=.false.
        dowc01  = .false.
        doscaling=.true.

        numsmo=1
        do k2 = 1, maxCtrlProc
         if (xx_gentim2d_preproc(k2,iarr).EQ.'WC01') then
          dowc01=.TRUE.
          if (xx_gentim2d_preproc_i(k2,iarr).NE.0)
     &         numsmo=xx_gentim2d_preproc_i(k2,iarr)
         endif
         if ((.NOT.dowc01).AND.
     &        (xx_gentim2d_preproc(k2,iarr).EQ.'smooth')) then
          dosmooth=.TRUE.
          if (xx_gentim2d_preproc_i(k2,iarr).NE.0)
     &         numsmo=xx_gentim2d_preproc_i(k2,iarr)
         endif
         if (xx_gentim2d_preproc(k2,iarr).EQ.'noscaling') then
          doscaling=.FALSE.
         endif
        enddo

        write(temp_genarr_fnamB,'(2a,i10.10)')
     &   ctrlDir(1:ilDir)//temp_genarr_fnamA(1:ilgen),'.',optimcycle
        fnamegenIn(iarr) = temp_genarr_fnamB
        write(temp_genarr_fnamB,'(2a,i10.10)')
     &   ctrlDir(1:ilDir)//temp_genarr_fnamA(1:ilgen)
     &   ,'.effective.',optimcycle
        fnamegenOut(iarr) = temp_genarr_fnamB
        write(temp_genarr_fnamB,'(2a,i10.10)')
     &   ctrlDir(1:ilDir)//temp_genarr_fnamA(1:ilgen),'.tmp.',optimcycle
        fnamegenTmp(iarr) = temp_genarr_fnamB

C--   docycle

        replicated_nrec=diffrec
        replicated_ntimes=0
        do k2 = 1, maxCtrlProc
         if (xx_gentim2d_preproc(k2,iarr).EQ.'docycle') then
          if (xx_gentim2d_preproc_i(k2,iarr).NE.0) then
           replicated_nrec=min(diffrec,xx_gentim2d_preproc_i(k2,iarr))
           replicated_ntimes=
     &          int(float(diffrec)/float(replicated_nrec))
           if (replicated_ntimes*replicated_nrec.LT.diffrec)
     &          replicated_ntimes=replicated_ntimes+1
           if (replicated_ntimes*replicated_nrec.GT.diffrec)
     &          replicated_ntimes=replicated_ntimes-1
          endif
         endif
        enddo

#ifdef ALLOW_CTRL_DEBUG
        write(*,'(A,1x,5I6)')
     &   'AD:[start,end,diff]rec, replicated_[nrec,ntimes]: ',
     &              startrec, endrec, diffrec,
     &              replicated_nrec,replicated_ntimes
#endif
        DO jrec = 1, replicated_ntimes+1
         DO iRec = 1, replicated_nrec
#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE xx_gentim2d_dummy = dummytape, key = 1 , kind = isbyte
#endif
          kRec=replicated_nrec*(jrec-1)+iRec
          lRec=startrec+iRec-1
          IF (kRec.LE.endrec) THEN
#ifdef ALLOW_CTRL_DEBUG
           ilgen=ilnblnk( fnamegenIn(iarr) )
           temp_genarr_fnamA = fnamegenIn(iarr)
           write(*,*) 'AE: iarr,[i,j,k,l]rec: ',iarr,iRec,jrec,lRec
           write(*,*) 'AF: fnamegenIn: ', temp_genarr_fnamA(1:ilgen)
#endif
C fnamegenIn is xx_*.$iter.data, so the required access records starts at
C startrec+iRec-1 instead of iRec in the read call below. In adjoint mode, S/R
C ADACTIVE_READ_XY reads adxx_*.$iter.data in reverse order, with required
C access from endrec back to startrec. This requires creating adxx_*.$iter.data
C file of size endrec, with valid gradients from records startrec to endrec
C but all zeros from 1 to startrec-1. See documentation:
C https://mitgcm.readthedocs.io/en/latest/ocean_state_est/ocean_state_est.html#ctrl-model-parameter-adjustment-capability
#ifdef ALLOW_AUTODIFF
           CALL ACTIVE_READ_XY( fnamegenIn(iarr), xx_gen, lRec,
     &          doglobalread, ladinit, optimcycle,
     &          myThid, xx_gentim2d_dummy(iarr) )
#else
           CALL READ_REC_XY_RL( fnamegenIn(iarr), xx_gen, lRec,
     &                          1, myThid )
#endif
C Here, we write record kRec (from 1 to diffrec) to file xx_*.effective.$iter
#ifdef ALLOW_AUTODIFF
#ifdef ALLOW_CTRL_DEBUG
           ilgen=ilnblnk( fnamegenOut(iarr) )
           temp_genarr_fnamA = fnamegenOut(iarr)
           write(*,*) 'AG: iarr,[i,j,k]rec: ',iarr,iRec,jrec,kRec
           write(*,*) 'AH: fnamegenOut: ', temp_genarr_fnamA(1:ilgen)
#endif
           CALL ACTIVE_WRITE_XY( fnamegenOut(iarr), xx_gen, kRec,
     &          optimcycle, myThid, xx_gentim2d_dummy(iarr) )
#else
           CALL WRITE_REC_XY_RL( fnamegenOut(iarr), xx_gen, kRec,
     &          1 , myThid )
#endif
          ENDIF
         ENDDO
        ENDDO

C--   rmcycle
#ifdef ALLOW_ECCO
        replicated_nrec=diffrec
        replicated_ntimes=0
        do k2 = 1, maxCtrlProc
         if (xx_gentim2d_preproc(k2,iarr).EQ.'rmcycle') then
          if (xx_gentim2d_preproc_i(k2,iarr).NE.0) then
           replicated_nrec=min(diffrec,xx_gentim2d_preproc_i(k2,iarr))
           replicated_ntimes=
     &          int(float(diffrec)/float(replicated_nrec))
           if (replicated_ntimes*replicated_nrec.LT.diffrec)
     &          replicated_ntimes=replicated_ntimes+1
           if (replicated_ntimes*replicated_nrec.GT.diffrec)
     &          replicated_ntimes=replicated_ntimes-1
          endif
         endif
        enddo

#ifdef ALLOW_CTRL_DEBUG
        write(*,'(A,1x,5I6)')
     &  'AI:[start,end,diff]rec, replicated_[nrec,ntimes]: ',
     &      startrec,endrec,diffrec,replicated_nrec,replicated_ntimes
#endif

        IF (replicated_ntimes.GT.0) THEN

C     create cyclic average

         nyearsINT=1+int((diffrec-replicated_nrec)/replicated_nrec)
         recip_nyearsRL=1. _d 0/float(nyearsINT)

#ifdef ALLOW_CTRL_DEBUG
         write(*,*) 'AJ: nyears[INT,RL]: ',nyearsINT,recip_nyearsRL
#endif

         DO iRec = 1, replicated_nrec

          DO bj=myByLo(myThid),myByHi(myThid)
           DO bi=myBxLo(myThid),myBxHi(myThid)
            DO j = 1-OLy,sNy+OLy
             DO i = 1-OLx,sNx+OLx
              xx_gen(i,j,bi,bj) = zeroRL
             ENDDO
            ENDDO
           ENDDO
          ENDDO

          DO jrec=1,nyearsINT
#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE xx_gentim2d_dummy = dummytape, key = 1 , kind = isbyte
#endif
           kRec=iRec+(jrec-1)*replicated_nrec
#ifdef ALLOW_CTRL_DEBUG
           write(*,*) 'AK: iarr,[i,j,k]rec: ',iarr,iRec,jrec,kRec
           ilgen=ilnblnk( fnamegenOut(iarr) )
           temp_genarr_fnamA = fnamegenOut(iarr)
           write(*,*) 'AL: fnamegenOut: ',temp_genarr_fnamA(1:ilgen)
#endif
#ifdef ALLOW_AUTODIFF
           CALL ACTIVE_READ_XY( fnamegenOut(iarr), xx_gen_tmp, kRec,
     &          doglobalread, ladinit, optimcycle,
     &          myThid, xx_gentim2d_dummy(iarr) )
#else
           CALL READ_REC_XY_RL( fnamegenOut(iarr), xx_gen_tmp, kRec,
     &          1, myThid )
#endif
           DO bj=myByLo(myThid),myByHi(myThid)
            DO bi=myBxLo(myThid),myBxHi(myThid)
             DO j = 1,sNy
              DO i = 1,sNx
               xx_gen(i,j,bi,bj) = xx_gen(i,j,bi,bj)
     &              +xx_gen_tmp(i,j,bi,bj)
              ENDDO
             ENDDO
            ENDDO
           ENDDO
C     end jrec
          ENDDO

          DO bj=myByLo(myThid),myByHi(myThid)
           DO bi=myBxLo(myThid),myBxHi(myThid)
            DO j = 1,sNy
             DO i = 1,sNx
              xx_gen(i,j,bi,bj) = xx_gen(i,j,bi,bj) * recip_nyearsRL
             ENDDO
            ENDDO
           ENDDO
          ENDDO

#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE xx_gentim2d_dummy = dummytape, key = 1 , kind = isbyte
#endif

#ifdef ALLOW_AUTODIFF
          CALL ACTIVE_WRITE_XY( fnamegenTmp(iarr), xx_gen, iRec,
     &         optimcycle, myThid, xx_gentim2d_dummy(iarr) )
#else
          CALL WRITE_REC_XY_RL( fnamegenTmp(iarr), xx_gen, iRec,
     &         1, myThid )
#endif

         ENDDO

C     subtract cyclic average
         DO jrec = 1, replicated_ntimes+1
          DO iRec = 1, replicated_nrec
#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE xx_gentim2d_dummy = dummytape, key = 1 , kind = isbyte
#endif
           kRec=replicated_nrec*(jrec-1)+iRec
#ifdef ALLOW_CTRL_DEBUG
           write(*,*) 'AM: iarr,[i,j,k]rec: ',iarr,iRec,jrec,kRec
           ilgen=ilnblnk( fnamegenOut(iarr) )
           temp_genarr_fnamA = fnamegenOut(iarr)
           write(*,*) 'AN: fnamegenOut: ',temp_genarr_fnamA(1:ilgen)
#endif
           IF (kRec.LE.diffrec) THEN
#ifdef ALLOW_AUTODIFF
            CALL ACTIVE_READ_XY( fnamegenOut(iarr), xx_gen, kRec,
     &           doglobalread, ladinit, optimcycle,
     &           myThid, xx_gentim2d_dummy(iarr) )
#else
            CALL READ_REC_XY_RL( fnamegenOut(iarr), xx_gen, kRec,
     &           1, myThid )
#endif
#ifdef ALLOW_AUTODIFF
            CALL ACTIVE_READ_XY( fnamegenTmp(iarr), xx_gen_tmp, iRec,
     &           doglobalread, ladinit, optimcycle,
     &           myThid, xx_gentim2d_dummy(iarr) )
#else
            CALL READ_REC_XY_RL( fnamegenTmp(iarr), xx_gen_tmp, iRec,
     &           1, myThid )
#endif
            DO bj=myByLo(myThid),myByHi(myThid)
             DO bi=myBxLo(myThid),myBxHi(myThid)
              DO j = 1,sNy
               DO i = 1,sNx
                xx_gen(i,j,bi,bj)=xx_gen(i,j,bi,bj)
     &              -xx_gen_tmp(i,j,bi,bj)
               ENDDO
              ENDDO
             ENDDO
            ENDDO
#ifdef ALLOW_AUTODIFF
            CALL ACTIVE_WRITE_XY( fnamegenOut(iarr), xx_gen, kRec,
     &           optimcycle, myThid, xx_gentim2d_dummy(iarr) )
#else
            CALL WRITE_REC_XY_RL( fnamegenOut(iarr), xx_gen, kRec,
     &           1, myThid )
#endif
           ENDIF
          ENDDO
         ENDDO

        ENDIF
#endif /* ifdef ALLOW_ECCO */

C--   scaling and smoothing

C The access of records startrec to endrec in  xx_*.*iter was already
C done correctly above. From here, we read in xx_*.effective.$iter.data
C of size diffrec, so no more fix of record is needed from here on out.
        DO iRec = 1, diffrec
#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE xx_gentim2d_dummy = dummytape, key = 1 , kind = isbyte
#endif

#ifdef ALLOW_CTRL_DEBUG
         ilgen=ilnblnk( fnamegenOut(iarr) )
         temp_genarr_fnamA = fnamegenOut(iarr)
         lRec=startrec+iRec-1
         write(*,'(A,1x,A,1x,2I6)') 'AO: fnamegenOut, iRec,lRec ',
     &       temp_genarr_fnamA(1:ilgen),iRec,lRec
#endif
#ifdef ALLOW_AUTODIFF
         CALL ACTIVE_READ_XY( fnamegenOut(iarr), xx_gen, iRec,
     &        doglobalread, ladinit, optimcycle,
     &        myThid, xx_gentim2d_dummy(iarr) )
#else
         CALL READ_REC_XY_RL( fnamegenOut(iarr), xx_gen, iRec,
     &        1, myThid )
#endif

#ifndef ALLOW_OPENAD
         jrec=1
C Not clear which record to use for timevariable weights ;
C For now, just assumes records from startrec to endrec are available in file
         do k2 = 1, maxCtrlProc
          if (xx_gentim2d_preproc(k2,iarr).EQ.'variaweight') then
            jrec=startrec+iRec-1
          endif
         enddo
         CALL READ_REC_3D_RL( xx_gentim2d_weight(iarr), ctrlprec, 1,
     &             wgentim2d(1-OLx,1-OLy,1,1,iarr), jrec, 1, myThid )

C--   Get appropriate mask
         call ctrl_get_mask2D(xx_gentim2d_file(iarr), mask2D, myThid)

#ifdef ALLOW_SMOOTH
         IF (useSMOOTH) THEN
          IF (dowc01) call smooth_correl2d(xx_gen,mask2D,numsmo,myThid)
          IF (dosmooth) call smooth2d(xx_gen,mask2D,numsmo,myThid)
         ENDIF
#endif /* ALLOW_SMOOTH */

         DO bj=myByLo(myThid), myByHi(myThid)
          DO bi=myBxLo(myThid), myBxHi(myThid)
           DO j = 1,sNy
            DO i = 1,sNx
             if ((mask2D(i,j,bi,bj).NE.0.).AND.
     &            (wgentim2d(i,j,bi,bj,iarr).GT.0.)) then
              IF (doscaling) then
               xx_gen(i,j,bi,bj)=xx_gen(i,j,bi,bj)
     &              /sqrt(wgentim2d(i,j,bi,bj,iarr))
              ENDIF             ! IF (doscaling) then
             else
              xx_gen(i,j,bi,bj)=0. _d 0
             endif
            ENDDO
           ENDDO
          ENDDO
         ENDDO
#endif /* ALLOW_OPENAD */

         CALL CTRL_BOUND_2D(xx_gen,mask2D,
     &        xx_gentim2d_bounds(1,iarr),myThid)

         CALL EXCH_XY_RL ( xx_gen , myThid )

#ifdef ALLOW_CTRL_DEBUG
         ilgen=ilnblnk( fnamegenOut(iarr) )
         temp_genarr_fnamA = fnamegenOut(iarr)
         write(*,'(A,1x,I6,1x,A)')
     &      'AQ: iRec,fnamegenOut: ',iRec,temp_genarr_fnamA(1:ilgen)
#endif
#ifdef ALLOW_AUTODIFF
         CALL ACTIVE_WRITE_XY( fnamegenOut(iarr), xx_gen, iRec,
     &        optimcycle, myThid, xx_gentim2d_dummy(iarr) )
#else
         CALL WRITE_REC_XY_RL( fnamegenOut(iarr), xx_gen, iRec,
     &        1, myThid )
#endif
C--   end iRec loop
        ENDDO

#ifndef ALLOW_OPENAD
       endif
#endif

C--   end iarr loop
      ENDDO

#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_LEAVE('CTRL_MAP_INI_GENTIM2D',myThid)
#endif /* ALLOW_DEBUG */
#endif /* ALLOW_GENTIM2D_CONTROL */

      RETURN
      END

#include "GGL90_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 0
C !ROUTINE: GGL90_INIT_FIXED
C !INTERFACE:
      SUBROUTINE GGL90_INIT_FIXED( myThid )

C     !DESCRIPTION: \bv
C     *================================================================*
C     | S/R GGL90_INIT_FIXED
C     | Initialize GGL90 variables that are kept fixed during the run.
C     *================================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
#include "EEPARAMS.h"
#include "SIZE.h"
#include "PARAMS.h"
#include "GGL90.h"

C     !INPUT/OUTPUT PARAMETERS:
C     myThid ::  my Thread Id number
      INTEGER myThid

C     !LOCAL VARIABLES:
C     === Local variables ===
#ifdef ALLOW_GGL90_SMOOTH
      INTEGER i, j, bi, bj
#endif
CEOP

C#ifdef ALLOW_MNC
C      IF (useMNC) THEN
C        CALL GGL90_MNC_INIT( myThid )
C      ENDIF
C#endif /* ALLOW_MNC */

#ifdef ALLOW_DIAGNOSTICS
      IF ( useDiagnostics ) THEN
        CALL GGL90_DIAGNOSTICS_INIT( myThid )
      ENDIF
#endif

#ifdef ALLOW_GGL90_SMOOTH
      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          mskCor(i,j,bi,bj) = 1. _d 0
         ENDDO
        ENDDO
C- for now, hide this call from OpenAD:
# if ( !(defined ALLOW_OPENAD) || (defined ALLOW_EXCH2) )
        IF ( useCubedSphereExchange ) THEN
          CALL FILL_CS_CORNER_TR_RL( 0, .FALSE.,
     U                               mskCor(1-OLx,1-OLy,bi,bj),
     I                               bi, bj, myThid )
        ENDIF
# endif
       ENDDO
      ENDDO
#endif /* ALLOW_GGL90_SMOOTH */

      RETURN
      END

#include "CTRL_OPTIONS.h"
#ifdef ALLOW_GMREDI
# include "GMREDI_OPTIONS.h"
#endif
#ifdef ALLOW_SEAICE
# include "SEAICE_OPTIONS.h"
#endif
#ifdef ALLOW_SHELFICE
# include "SHELFICE_OPTIONS.h"
#endif
#ifdef ALLOW_STEEP_ICECAVITY
# include "STIC_OPTIONS.h"
#endif
#ifdef ALLOW_STREAMICE
# include "STREAMICE_OPTIONS.h"
#endif
#ifdef ALLOW_DIC
# include "DIC_OPTIONS.h"
#endif

CBOP
C     !ROUTINE: CTRL_MAP_INI_GENARR
C     !INTERFACE:
      SUBROUTINE CTRL_MAP_INI_GENARR( myThid )

C     !DESCRIPTION: \bv
C     *=================================================================
C     | SUBROUTINE CTRL_MAP_INI_GENARR
C     | Add the generic arrays of the
C     | control vector to the model state and update the tile halos.
C     | The control vector is defined in the header file "CTRL.h".
C     *=================================================================
C     \ev

C     !USES:
      IMPLICIT NONE

C     == global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "DYNVARS.h"
#include "FFIELDS.h"
#include "CTRL_SIZE.h"
#include "CTRL.h"
#include "CTRL_DUMMY.h"
#include "CTRL_FIELDS.h"
#include "CTRL_GENARR.h"
#ifdef ALLOW_GMREDI
# include "GMREDI.h"
#endif
#ifdef ALLOW_PTRACERS
# include "PTRACERS_SIZE.h"
# include "PTRACERS_PARAMS.h"
# include "PTRACERS_FIELDS.h"
#endif
#ifdef ALLOW_SEAICE
# include "SEAICE_SIZE.h"
# include "SEAICE.h"
#endif
#ifdef ALLOW_SHELFICE
# include "SHELFICE.h"
#endif
#ifdef ALLOW_STEEP_ICECAVITY
# include "STIC.h"
#endif
#ifdef ALLOW_STREAMICE
# include "STREAMICE.h"
#endif
#if (defined ALLOW_DIC && defined DIC_BIOTIC)
# include "DIC_VARS.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     == routine arguments ==
      INTEGER myThid

#if (defined (ALLOW_GENARR3D_CONTROL) && defined(ALLOW_PTRACERS))
C     !FUNCTIONS:
      INTEGER  ILNBLNK
      EXTERNAL ILNBLNK
#endif

C     !LOCAL VARIABLES:
C     == local variables ==
#if (defined (ALLOW_GENARR2D_CONTROL) || defined(ALLOW_GENARR3D_CONTROL))
      INTEGER iarr
      CHARACTER*(MAX_LEN_FNAM) temp_genarr_fnam
#endif
#ifdef ALLOW_GENARR2D_CONTROL
      INTEGER igen_etan, igen_bdrag, igen_geoth
# ifdef ALLOW_SEAICE
      INTEGER igen_siarea, igen_siheff
# endif
# ifdef ALLOW_SHELFICE
      INTEGER igen_shiCoeffT, igen_shiCoeffS, igen_shiCDrag
      INTEGER i, j, bi, bj
#  ifdef SHI_ALLOW_GAMMAFRICT
      INTEGER k2
      LOGICAL dragThermoEqualMom
#  endif
# endif
#ifdef ALLOW_STREAMICE
      INTEGER igen_b_glen, igen_rlow_streamice
      INTEGER igen_beta, igen_bdot_streamice
      INTEGER igen_bdot_max_streamice
      INTEGER igen_h_streamice
# endif
# if (defined ALLOW_DIC && defined DIC_BIOTIC)
      INTEGER igen_alpha
# endif
#endif /* ALLOW_GENARR2D_CONTROL */
#ifdef ALLOW_GENARR3D_CONTROL
      INTEGER igen_theta0, igen_salt0
      INTEGER igen_kapgm, igen_kapredi, igen_diffkr
# if (defined (ALLOW_UVEL0_CONTROL) && defined (ALLOW_VVEL0_CONTROL))
      INTEGER igen_uvel0, igen_vvel0
# endif
# ifdef ALLOW_PTRACERS
      INTEGER iPtr, iLen
      INTEGER igen_ptr(PTRACERS_num)
# endif
#endif /* ALLOW_GENARR3D_CONTROL */
CEOP

#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_ENTER('CTRL_MAP_INI_GENARR', myThid )
#endif
#ifdef ALLOW_GENARR2D_CONTROL
C--   generic 2D control variables

      igen_etan=0
      igen_bdrag=0
      igen_geoth=0
#ifdef ALLOW_SEAICE
      igen_siarea=0
      igen_siheff=0
#endif
#ifdef ALLOW_SHELFICE
      igen_shiCoeffT=0
      igen_shiCoeffS=0
      igen_shiCDrag=0
#endif
#ifdef ALLOW_STREAMICE
      igen_b_glen=0
      igen_rlow_streamice=0
      igen_beta=0
      igen_bdot_streamice=0
      igen_bdot_max_streamice=0
      igen_h_streamice=0
#endif
      DO iarr = 1, maxCtrlArr2D
       IF (xx_genarr2d_weight(iarr).NE.' ') THEN
        temp_genarr_fnam = xx_genarr2d_file(iarr)
        IF (temp_genarr_fnam(1:7).EQ.'xx_etan')
     &     igen_etan=iarr
        IF (temp_genarr_fnam(1:13).EQ.'xx_bottomdrag')
     &     igen_bdrag=iarr
        IF (temp_genarr_fnam(1:13).EQ.'xx_geothermal')
     &     igen_geoth=iarr
#ifdef ALLOW_SEAICE
        IF (temp_genarr_fnam(1:9).EQ.'xx_siarea')
     &     igen_siarea=iarr
        IF (temp_genarr_fnam(1:9).EQ.'xx_siheff')
     &     igen_siheff=iarr
#endif
#ifdef ALLOW_SHELFICE
# ifndef SHI_ALLOW_GAMMAFRICT
        IF (temp_genarr_fnam(1:12).EQ.'xx_shicoefft')
     &     igen_shiCoeffT=iarr
        IF (temp_genarr_fnam(1:12).EQ.'xx_shicoeffs')
     &     igen_shiCoeffS=iarr
# else
        IF (temp_genarr_fnam(1:11).EQ.'xx_shicdrag')
     &     igen_shiCDrag=iarr
# endif
#endif
#ifdef ALLOW_STREAMICE
        IF (temp_genarr_fnam(1:8).EQ.'xx_bglen')
     &     igen_b_glen=iarr
        IF (temp_genarr_fnam(1:17).EQ.'xx_rlow_streamice')
     &     igen_h_streamice=iarr
        IF (temp_genarr_fnam(1:7).EQ.'xx_beta')
     &     igen_beta=iarr
        IF (temp_genarr_fnam(1:7).EQ.'xx_bdot')
     &     igen_bdot_streamice=iarr
        IF (temp_genarr_fnam(1:11).EQ.'xx_bdot_max')
     &     igen_bdot_max_streamice=iarr
        IF (temp_genarr_fnam(1:11).EQ.'xx_h_streamice')
     &     igen_h_streamice=iarr
#endif
#if (defined ALLOW_DIC && defined DIC_BIOTIC)
        IF (temp_genarr_fnam(1:11).EQ.'xx_alpha')
     &     igen_alpha=iarr
#endif
       ENDIF
      ENDDO

      IF (igen_etan.GT.0) THEN
        CALL CTRL_MAP_GENARR2D( etaN, igen_etan, myThid )
      ENDIF
#ifdef ALLOW_BOTTOMDRAG_CONTROL
      IF (igen_bdrag.GT.0)
     &  CALL CTRL_MAP_GENARR2D( bottomDragFld, igen_bdrag, myThid )
#endif
#ifdef ALLOW_GEOTHERMAL_FLUX
      IF (igen_geoth.GT.0)
     &  CALL CTRL_MAP_GENARR2D( geothermalFlux, igen_geoth, myThid )
#endif

#ifdef ALLOW_SEAICE
      IF (igen_siarea.GT.0)
     &  CALL CTRL_MAP_GENARR2D(AREA,igen_siarea,myThid)
      IF (igen_siheff.GT.0)
     &  CALL CTRL_MAP_GENARR2D(HEFF,igen_siheff,myThid)
#endif
#ifdef ALLOW_SHELFICE
# ifndef SHI_ALLOW_GAMMAFRICT
      IF (igen_shiCoeffT.GT.0)
     &  CALL CTRL_MAP_GENARR2D(shiTransCoeffT,igen_shiCoeffT,myThid)

      IF (igen_shiCoeffS.GT.0)
     &  CALL CTRL_MAP_GENARR2D(shiTransCoeffS,igen_shiCoeffS,myThid)

C--   xx_shiCoeffS not used, but shiCoeffT is adjusted by xx_shicoefft
      IF ((igen_shiCoeffS.EQ.0).AND.(igen_shiCoeffT.GT.0)) THEN
       DO bj = myByLo(myThid), myByHi(myThid)
        DO bi = myBxLo(myThid), myBxHi(myThid)
         DO j = 1-OLy,sNy+OLy
          DO i = 1-OLx,sNx+OLx
           shiTransCoeffS(i,j,bi,bj) =
     &       SHELFICEsaltToHeatRatio*shiTransCoeffT(i,j,bi,bj)
          ENDDO
         ENDDO
        ENDDO
       ENDDO
C--   xx_shiCoeffT not used, but shiCoeffS is adjusted by xx_shicoeffs
      ELSEIF ((igen_shiCoeffT.EQ.0).AND.(igen_shiCoeffS.GT.0)) THEN
       DO bj = myByLo(myThid), myByHi(myThid)
        DO bi = myBxLo(myThid), myBxHi(myThid)
         DO j = 1-OLy,sNy+OLy
          DO i = 1-OLx,sNx+OLx
           shiTransCoeffT(i,j,bi,bj) =
     &       shiTransCoeffS(i,j,bi,bj)/SHELFICEsaltToHeatRatio
          ENDDO
         ENDDO
        ENDDO
       ENDDO
      ENDIF
# else /* SHI_ALLOW_GAMMAFRICT */
      dragThermoEqualMom = .FALSE.
      IF (igen_shiCDrag.GT.0) THEN
        CALL CTRL_MAP_GENARR2D(shiCDragFld,igen_shiCDrag,myThid)
C--     Set drag coefficient used in momentum equal to thermodynamic,
C--      u* drag coefficient
        DO k2 = 1, maxCtrlProc
         IF (xx_genarr2d_preproc_c(k2,igen_shiCDrag)(1:3).EQ.'mom')
     &      dragThermoEqualMom = .TRUE.
        ENDDO
      ENDIF
      IF (dragThermoEqualMom) THEN
       DO bj = myByLo(myThid), myByHi(myThid)
        DO bi = myBxLo(myThid), myBxHi(myThid)
         DO j = 1-OLy,sNy+OLy
          DO i = 1-OLx,sNx+OLx
           shiDragQuadFld(i,j,bi,bj) = shiCDragFld(i,j,bi,bj)
          ENDDO
         ENDDO
        ENDDO
       ENDDO
      ENDIF
# endif /* SHI_ALLOW_GAMMAFRICT */
#endif /* ALLOW_SHELFICE */

#ifdef ALLOW_STREAMICE
      IF (igen_bdot_max_streamice.GT.0) THEN
#ifdef ALLOW_OPENAD
       streamice_bdot_maxmelt_v(1,1,1,1) =
     &  streamice_bdot_maxmelt_v(1,1,1,1) +
     &  0.0 * xx_genarr2d_dummy(igen_bdot_max_streamice)
#endif
       CALL CTRL_MAP_GENARR2D( streamice_bdot_maxmelt_v,
     &  igen_bdot_max_streamice, myThid )
      ENDIF
      IF (igen_bdot_streamice.GT.0) THEN
#ifdef ALLOW_OPENAD
       bdot_streamice(1,1,1,1) = bdot_streamice(1,1,1,1) +
     &  0.0 * xx_genarr2d_dummy(igen_bdot_streamice)
#endif
       CALL CTRL_MAP_GENARR2D( bdot_streamice, igen_bdot_streamice,
     &  myThid )
      ENDIF
      IF (igen_beta.GT.0) THEN
#ifdef ALLOW_OPENAD
       C_basal_friction(1,1,1,1) = C_basal_friction(1,1,1,1) +
     &  0.0 * xx_genarr2d_dummy(igen_beta)
#endif
       CALL CTRL_MAP_GENARR2D( C_basal_friction, igen_beta, myThid )
      ENDIF
      IF (igen_rlow_streamice.GT.0) THEN
#ifdef ALLOW_OPENAD
       r_low_si(1,1,1,1) = r_low_si(1,1,1,1) +
     &  0.0 * xx_genarr2d_dummy(igen_rlow_streamice)
#endif
       CALL CTRL_MAP_GENARR2D( r_low_si, igen_rlow_streamice, myThid )
      ENDIF
      IF (igen_b_glen.GT.0) THEN
#ifdef ALLOW_OPENAD
       B_glen(1,1,1,1) = B_glen(1,1,1,1) +
     &  0.0 * xx_genarr2d_dummy(igen_b_glen)
#endif
       CALL CTRL_MAP_GENARR2D( B_glen, igen_b_glen, myThid )
      ENDIF
      IF (igen_h_streamice.GT.0) THEN
#ifdef ALLOW_OPENAD
       h_streamice(1,1,1,1) = h_streamice(1,1,1,1) +
     &  0.0 * xx_genarr2d_dummy(igen_h_streamice)
#endif
       CALL CTRL_MAP_GENARR2D( h_streamice, igen_h_streamice, myThid )
      ENDIF
#endif /* ALLOW_STREAMICE */

#if (defined ALLOW_DIC && defined DIC_BIOTIC)
      IF (igen_alpha.GT.0)
     &  CALL CTRL_MAP_GENARR2D( alpha, igen_alpha, myThid )
#endif

#endif /* ALLOW_GENARR2D_CONTROL */

#ifdef ALLOW_GENARR3D_CONTROL
C--   generic 3D control variables

      igen_theta0=0
      igen_salt0=0
      igen_kapgm=0
      igen_kapredi=0
      igen_diffkr=0
# if (defined (ALLOW_UVEL0_CONTROL) && defined (ALLOW_VVEL0_CONTROL))
      igen_uvel0=0
      igen_vvel0=0
# endif
# ifdef ALLOW_PTRACERS
      DO iPtr = 1, PTRACERS_num
        igen_ptr(iPtr) = 0
      ENDDO
# endif /* ALLOW_PTRACERS */
      DO iarr = 1, maxCtrlArr3D
       IF (xx_genarr3d_weight(iarr).NE.' ') THEN
        IF (xx_genarr3d_file(iarr)(1:8).EQ.'xx_theta')
     &     igen_theta0=iarr
        IF (xx_genarr3d_file(iarr)(1:7).EQ.'xx_salt')
     &     igen_salt0=iarr
        IF (xx_genarr3d_file(iarr)(1:8).EQ.'xx_kapgm')
     &     igen_kapgm=iarr
        IF (xx_genarr3d_file(iarr)(1:10).EQ.'xx_kapredi')
     &     igen_kapredi=iarr
        IF (xx_genarr3d_file(iarr)(1:9).EQ.'xx_diffkr')
     &     igen_diffkr=iarr
#if ( defined ALLOW_SHELFICE && defined ALLOW_SHITRANSCOEFF_3D )
# ifndef SHI_ALLOW_GAMMAFRICT
        IF (xx_genarr3d_file(iarr)(1:17).EQ.'xx_shiTransCoeffT')
     &     igen_shiCoeffT=iarr
# endif
#endif

# if (defined (ALLOW_UVEL0_CONTROL) && defined (ALLOW_VVEL0_CONTROL))
        IF (xx_genarr3d_file(iarr)(1:7).EQ.'xx_uvel')
     &     igen_uvel0=iarr
        IF (xx_genarr3d_file(iarr)(1:7).EQ.'xx_vvel')
     &     igen_vvel0=iarr
# endif
# ifdef ALLOW_PTRACERS
        IF ( usePTRACERS ) THEN
          iLen = ILNBLNK(xx_genarr3d_file(iarr))
          IF ( iLen.EQ.7 .AND.
     &         xx_genarr3d_file(iarr)(1:6).EQ.'xx_ptr' ) THEN
            READ(xx_genarr3d_file(iarr)(7:7),*) iPtr
            IF ( iPtr.GE.1 .AND. iPtr.LE.PTRACERS_numInUse )
     &                  igen_ptr(iPtr) = iarr
          ENDIF
        ENDIF
# endif /* ALLOW_PTRACERS */
       ENDIF
      ENDDO

      IF (igen_theta0.GT.0)
     &  CALL CTRL_MAP_GENARR3D( theta, igen_theta0, myThid )
      IF (igen_salt0.GT.0)
     &  CALL CTRL_MAP_GENARR3D( salt, igen_salt0, myThid )
# if ( defined ALLOW_KAPGM_CONTROL && defined GM_READ_K3D_GM )
      IF (igen_kapgm.GT.0)
     &  CALL CTRL_MAP_GENARR3D( GM_inpK3dGM, igen_kapgm, myThid )
# endif
# if ( defined ALLOW_KAPREDI_CONTROL && defined GM_READ_K3D_REDI )
      IF (igen_kapredi.GT.0)
     &  CALL CTRL_MAP_GENARR3D( GM_inpK3dRedi, igen_kapredi, myThid )
# endif
# if ( defined ALLOW_DIFFKR_CONTROL && defined ALLOW_3D_DIFFKR )
      IF (igen_diffkr.GT.0)
     &  CALL CTRL_MAP_GENARR3D( diffKr, igen_diffkr, myThid )
# endif
#if ( defined ALLOW_SHELFICE && defined ALLOW_SHITRANSCOEFF_3D )
      IF (igen_shiCoeffT.GT.0)
     &  CALL CTRL_MAP_GENARR3D(shiTransCoeffT3d, igen_shiCoeffT, myThid)
#endif

# ifdef ALLOW_PTRACERS
CADJ loop = parallel
      DO iPtr = 1, PTRACERS_num
        IF ( igen_ptr(iPtr).GT.0 ) THEN
          CALL CTRL_MAP_GENARR3D( pTracer(1-OLx,1-OLy,1,1,1,iPtr),
     &                            igen_ptr(iPtr), myThid )
        ENDIF
      ENDDO
# endif /* ALLOW_PTRACERS */

# if (defined (ALLOW_UVEL0_CONTROL) && defined (ALLOW_VVEL0_CONTROL))
      IF (igen_uvel0.GT.0 .AND. igen_vvel0.GT.0) THEN
        CALL CTRL_MAP_GENARR3D( uVel, igen_uvel0, myThid )
        CALL CTRL_MAP_GENARR3D( vVel, igen_vvel0, myThid )
        CALL EXCH_UV_XYZ_RL( uVel, vVel, .TRUE., myThid )
      ENDIF
# endif

#endif /* ALLOW_GENARR3D_CONTROL */

#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_LEAVE('CTRL_MAP_INI_GENARR', myThid )
#endif

      RETURN
      END

#include "ECCO_OPTIONS.h"

      subroutine cost_averagesfields( mytime, mythid )

c     ==================================================================
c     SUBROUTINE cost_averagesfields
c     ==================================================================
c
c     o Compute time averages of etaN, theta, and salt. The counters
c       are explicitly calculated instead of being incremented. This
c       reduces dependencies. The latter is useful for the adjoint code
c       generation.
c
c     started: Christian Eckert eckert@mit.edu 30-Jun-1999
c
c     changed: Christian Eckert eckert@mit.edu 24-Feb-2000
c
c              - Restructured the code in order to create a package
c                for the MITgcmUV.
c
c     ==================================================================
c     SUBROUTINE cost_averagesfields
c     ==================================================================

      implicit none

c     == global variables ==

#include "EEPARAMS.h"
#include "SIZE.h"
#include "PARAMS.h"

#include "ECCO_SIZE.h"
#include "ECCO.h"

c     == routine arguments ==

      _RL     mytime
      integer mythid

c     == local variables ==

      integer myiter
      integer k
      logical first
      logical startofday
      logical startofmonth
      logical startofyear
      logical inday
      logical inmonth
      logical inyear
      logical last
      logical endofday
      logical endofmonth
      logical endofyear
#ifdef ALLOW_GENCOST_CONTRIBUTION
      logical startofgen(NGENCOST)
      logical endofgen(NGENCOST)
      logical ingen(NGENCOST)
      integer sum1gen(NGENCOST)
      integer genrec(NGENCOST)
      integer kk
#endif

c     == external functions ==

c     == end of interface ==

      myiter = niter0 + INT((mytime-starttime)/deltaTClock+0.5)

c--   Get the time flags and record numbers for the time averaging.

#ifdef ALLOW_DEBUG
      IF ( debugMode ) CALL DEBUG_CALL('cost_averagesflags',myThid)
#endif
      call cost_averagesflags(
     I                    myiter,     mytime,       mythid,
     O                    first,      last,
     O                    startofday, startofmonth, startofyear,
     O                    inday,      inmonth,      inyear,
     O                    endofday,   endofmonth,   endofyear,
     O                    sum1day,    dayrec,
     O                    sum1mon,    monrec,
     O                    sum1year,   yearrec
     &                  )

#ifdef ALLOW_GENCOST_CONTRIBUTION
      call cost_gencost_assignperiod(
     I                    startofday, startofmonth, startofyear,
     I                    inday,      inmonth,      inyear,
     I                    endofday,   endofmonth,   endofyear,
     O                    startofgen, endofgen,     ingen,
     O                    sum1gen,    genrec,
     I                    myiter, mythid )
      call cost_gencost_customize( mythid )

      do k = 1, NGENCOST
      if ( (using_gencost(k)).AND.(.NOT.gencost_barskip(k)) ) then
      if ( .NOT.gencost_is3d(k) ) then
        call cost_averagesgeneric(
     &       gencost_barfile(k),
     &       gencost_barfld(1-Olx,1-Oly,1,1,k),
     &       gencost_modfld(1-Olx,1-Oly,1,1,k),
     &       gencost_dummy(k),
     &       first, last,
     &       startofgen(k), endofgen(k), ingen(k),
     &       sum1gen(k), genrec(k), 1, mythid )
#ifdef ALLOW_GENCOST3D
      else
        kk=gencost_pointer3d(k)
        call cost_averagesgeneric(
     &     gencost_barfile(k),
     &     gencost_bar3d(1-Olx,1-Oly,1,1,1,kk),
     &     gencost_mod3d(1-Olx,1-Oly,1,1,1,kk),
     &     gencost_dummy(k),
     &     first, last,
     &     startofgen(k), endofgen(k), ingen(k),
     &     sum1gen(k), genrec(k), nr, mythid )
#endif
      endif

      endif
      end do
#endif /* ALLOW_GENCOST_CONTRIBUTION */

#ifdef ALLOW_DEBUG
      IF ( debugMode ) CALL DEBUG_LEAVE('cost_averagesfields',myThid)
#endif

      return
      end

#include "SEAICE_OPTIONS.h"

CBOP
C !ROUTINE: SEAICE_ITD_PICKUP

C !INTERFACE: ==========================================================
      SUBROUTINE SEAICE_ITD_PICKUP(
     I     myIter, myThid )

C !DESCRIPTION: \bv
C     *===========================================================*
C     | SUBROUTINE SEAICE_ITD_PICKUP
C     | o called in case pickup file does not contain
C     |   ITD variables but mean ice thickness and concentration
C     |
C     | o choose between two schemes:
C     |
C     |   a) a simple scheme where the mean values are just put
C     |      into the first ITD category and then redustributed
C     |      into the correct category by SEAICE_ITD_REDIST
C     |      -> simpleSchemeFlag = .TRUE.
C     |
C     |   b) a scheme that assumes a log-normal distribution based
C     |      on the mean ice thickness and a standard decviation
C     |      of LND_sigma=0.25
C     |      -> simpleSchemeFlag = .FALSE.
C     |
C     | Torge Martin, Mai 2012, torge@mit.edu
C     *===========================================================*
C \ev

C !USES: ===============================================================
      IMPLICIT NONE

C     === Global variables needed ===
C     AREA      :: total sea ice area fraction
C     HEFF      :: mean in-situ sea ice thickness
C     HSNOW     :: mean in-situ snow layer depth
C
C     === Global variables to be changed ===
C     AREAITD   :: sea ice area      by category
C     HEFFITD   :: sea ice thickness by category
C     HSNOWITD  :: snow thickness    by category
C
#include "SIZE.h"
#include "EEPARAMS.h"
c#include "PARAMS.h"
#include "SEAICE_SIZE.h"
#include "SEAICE_PARAMS.h"
#include "SEAICE.h"

C !INPUT PARAMETERS: ===================================================
C     === Routine arguments ===
C     myIter    :: iteration number
C     myThid    :: Thread no. that called this routine.
      INTEGER myIter
      INTEGER myThid
CEOP

#ifdef SEAICE_ITD

C !LOCAL VARIABLES: ====================================================
C     === Local variables ===
C     i,j,bi,bj,k :: Loop counters
C     nITD        :: number of sea ice thickness categories
C
      INTEGER i, j, bi, bj, k
      _RL dummyTime

C     local variables for picking up ITD from single category pickup file
      INTEGER LND_i, LND_iend
C     parameters for log-normal distribution (LND)
      _RL LND_sigma, LND_mu
      PARAMETER(LND_sigma=0.25)
      _RL LND_dx
      _RL LND_tmp
C     bin width of distribution
      PARAMETER( LND_iend = 1000 )
      PARAMETER( LND_dx = 100.D0 / LND_iend )
c     PARAMETER(LND_dx=0.1)
c     PARAMETER(LND_iend=INT(100./LND_dx))
      _RL LND_x  (LND_iend)
      _RL LND_pdf(LND_iend)
C     flag for pickup scheme
      LOGICAL simpleSchemeFlag

      simpleSchemeFlag = .TRUE.
      dummyTime = 1.0

C---+-|--1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C     reset ITD variables to zero for safety
      DO k = 1, nITD
       DO bj=myByLo(myThid),myByHi(myThid)
        DO bi=myBxLo(myThid),myBxHi(myThid)
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           AREAITD(i,j,k,bi,bj)  = 0. _d 0
           HEFFITD(i,j,k,bi,bj)  = 0. _d 0
           HSNOWITD(i,j,k,bi,bj) = 0. _d 0
          ENDDO
         ENDDO
        ENDDO
       ENDDO
      ENDDO
      IF (simpleSchemeFlag) THEN
C--      Put all ice into one bin:
C
       DO bj=myByLo(myThid),myByHi(myThid)
        DO bi=myBxLo(myThid),myBxHi(myThid)
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           AREAITD(i,j,1,bi,bj)  = AREA(i,j,bi,bj)
           HEFFITD(i,j,1,bi,bj)  = HEFF(i,j,bi,bj)
           HSNOWITD(i,j,1,bi,bj) = HSNOW(i,j,bi,bj)
          ENDDO
         ENDDO
        ENDDO
       ENDDO

C---+-|--1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
      ELSE
C--      Assume log-normal ITD:

         DO bj=myByLo(myThid),myByHi(myThid)
          DO bi=myBxLo(myThid),myBxHi(myThid)
           DO j=1-OLy,sNy+OLy
            DO i=1-OLx,sNx+OLx
C
C            initialize log-normal distribution
             LND_mu = log(HEFF(i,j,bi,bj)/AREA(i,j,bi,bj))
     &                - 0.5*LND_sigma*LND_sigma
             LND_x(1) = 0.+LND_dx/2.
C            make thickness bins
             DO LND_i=2,LND_iend
              LND_x(LND_i)=LND_x(LND_i-1)+LND_dx
             ENDDO
C            log-normal distribution:
             DO LND_i=2,LND_iend
              LND_tmp = log(LND_x(LND_i))-LND_mu
              LND_pdf(LND_i)= 1.
     &             / (LND_x(LND_i)*LND_sigma*sqrt(2*3.1416))
     &             * exp( -(LND_tmp*LND_tmp)
     &             /       (2*LND_sigma*LND_sigma) )
     &             * AREA(i,j,bi,bj)
             ENDDO
C            assign bins to ice thickness categories
             k=1
             DO LND_i=1,LND_iend
              IF ( LND_x(LND_i).GT.Hlimit(k) ) k=k+1
              AREAITD(i,j,k,bi,bj) = AREAITD(i,j,k,bi,bj)
     &                             + LND_pdf(LND_i)*LND_dx
              HEFFITD(i,j,k,bi,bj) = HEFFITD(i,j,k,bi,bj)
     &                             + LND_pdf(LND_i)*LND_x(LND_i)*LND_dx
             ENDDO
C
            ENDDO
           ENDDO
          ENDDO
         ENDDO

      ENDIF

C---+-|--1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C     finally sort into correct ice thickness category
C      and compute bulk variables
C      (needed for dynamic solver at beginning of seaice_model.F)
      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        CALL SEAICE_ITD_REDIST( bi, bj, dummyTime, myIter, myThid)
        CALL SEAICE_ITD_SUM( bi, bj, dummyTime, myIter, myThid)
       ENDDO
      ENDDO

C---+-|--1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
#endif /* SEAICE_ITD */
      RETURN
      END

#include "CPP_EEOPTIONS.h"

CBOP
C     !ROUTINE: OPEN_COPY_DATA_FILE
C     !INTERFACE:
      SUBROUTINE OPEN_COPY_DATA_FILE(
     I                                data_file, caller_sub,
     O                                iUnit,
     I                                myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE OPEN_COPY_DATA_FILE
C     | o Routine to open and copy a data.* file to STDOUT
C     |   and return the open unit in iUnit
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#ifdef SINGLE_DISK_IO
# include "EESUPPORT.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
C     data_file  :: parameter file to open and copy
C     caller_sub :: name of subroutine which is calling this S/R
C     iUnit      :: IO unit of parameter-file copy (already opened)
C     myThid     :: my Thread Id number
      CHARACTER*(*) data_file
      CHARACTER*(*) caller_sub
      INTEGER iUnit
      INTEGER myThid

C     !FUNCTIONS:
      INTEGER  ILNBLNK
      EXTERNAL ILNBLNK

C     !LOCAL VARIABLES:
C     === Local variables ===
C     msgBuf    :: Informational/error message buffer
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      CHARACTER*(MAX_LEN_PREC) record
#if !defined(USE_FORTRAN_SCRATCH_FILES) || defined(SINGLE_DISK_IO)
      CHARACTER*(MAX_LEN_FNAM) scratchFile1
#endif
      INTEGER  errIO,IL
      LOGICAL  exst
#ifdef SINGLE_DISK_IO
C     mpiRC  :: Error code reporting variable used with MPI.
      INTEGER mpiRC
#endif
#ifdef USE_PDAF
      INTEGER mpi_task_id
#endif
CEOP

      _BEGIN_MASTER(myThid)

C--   Check for parameter file
      INQUIRE( FILE=data_file, EXIST=exst )
      IF (exst) THEN
       WRITE(msgBuf,'(A,A)')
     &   ' OPEN_COPY_DATA_FILE: opening file ',data_file
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                     SQUEEZE_RIGHT, myThid )
      ELSE
       WRITE(msgBuf,'(A,A,A)')
     &  'File ',data_file,' does not exist!'
       CALL PRINT_ERROR( msgBuf, myThid )
       WRITE(msgBuf,'(A,A)') 'S/R CALLED BY ',caller_sub
       CALL PRINT_ERROR( msgBuf, myThid )
       STOP 'ABNORMAL END: S/R OPEN_COPY_DATA_FILE'
      ENDIF

C     Make a scratch copy of parameter file without comments
#ifdef SINGLE_DISK_IO
      WRITE(scratchFile1,'(A,A)') 'scratch1_', data_file
      IF ( myProcId .EQ. 0 ) THEN
       OPEN( UNIT=scrUnit1, FILE=scratchFile1, STATUS='UNKNOWN' )
      ENDIF
#else /* ifndef SINGLE_DISK_IO */
#ifdef USE_FORTRAN_SCRATCH_FILES
C     this is the old default, which can cause filename conflicts on some
C     multi-node/multi-processor systems
      OPEN( UNIT=scrUnit1, STATUS='SCRATCH' )
#else
C     After opening regular files here, they are closed with STATUS='DELETE'
#ifdef USE_PDAF
      CALL GET_TASKID_PDAF(mpi_task_id)
      WRITE(scratchFile1,'(A,'//FMT_PROC_ID//',A,'//FMT_TSK_ID//')')
     &     'scratch1.', myProcId, '.', mpi_task_id
#else
      WRITE(scratchFile1,'(A,'//FMT_PROC_ID//')') 'scratch1.', myProcId
#endif
      OPEN( UNIT=scrUnit1, FILE=scratchFile1, STATUS='UNKNOWN' )
#endif /* USE_FORTRAN_SCRATCH_FILES */
#endif /* SINGLE_DISK_IO */

#ifdef SINGLE_DISK_IO
      IF ( myProcId .EQ. 0 ) THEN
#endif

C--   Open the parameter file
      OPEN( UNIT=modelDataUnit, FILE=data_file,
     &      _READONLY_ACTION STATUS='OLD', IOSTAT=errIO )
      IF ( errIO .LT. 0 ) THEN
       WRITE(msgBuf,'(A,A)')
     &  'Unable to open parameter file: ',data_file
       CALL PRINT_ERROR( msgBuf, myThid )
       WRITE(msgBuf,'(A,A)') 'S/R CALLED BY ',caller_sub
       CALL PRINT_ERROR( msgBuf, myThid )
       STOP 'ABNORMAL END: S/R OPEN_COPY_DATA_FILE'
      ENDIF

C--   Read parameter file, make a scratch copy without comments
C     and report contents of parameter file to STDOUT
      WRITE(msgBuf,'(A)')
     &'// ======================================================='
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A,A,A)') '// Parameter file "',data_file,'"'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)')
     &'// ======================================================='
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )

C     Read file, remove comments and apply specific syntax changes:
      DO WHILE ( .TRUE. )
       READ(modelDataUnit,FMT='(A)',END=1001) RECORD
       IL = MAX(ILNBLNK(RECORD),1)
       IF ( RECORD(1:1) .NE. commentCharacter ) THEN
c        CALL NML_SET_TERMINATOR( RECORD )
         CALL NML_CHANGE_SYNTAX( RECORD, data_file, myThid )
         WRITE(UNIT=scrUnit1,FMT='(A)') RECORD(:IL)
       ENDIF
       WRITE(msgBuf,'(A,A)') '>',RECORD(:IL)
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                     SQUEEZE_RIGHT, myThid )
      ENDDO
 1001 CONTINUE
      CLOSE(modelDataUnit)
      WRITE(msgBuf,'(A)') ' '
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )

#ifdef SINGLE_DISK_IO
      CALL FLUSH(scrUnit1)
      CLOSE(scrUnit1)
      ENDIF
# ifdef ALLOW_USE_MPI
C--   all processes must wait for process 0 to complete
C     writing scratchFile1 before opening it
      IF ( usingMPI ) THEN
        CALL MPI_BARRIER( MPI_COMM_MODEL, mpiRC )
      ENDIF
# endif
#ifdef HAVE_SYSTEM
      CALL SYSTEM('sleep 1')
#endif
      OPEN( UNIT=scrUnit1, FILE=scratchFile1,
     &      _READONLY_ACTION STATUS='OLD' )
#endif /* SINGLE_DISK_IO */

C--   Return open unit to caller
      iUnit = scrUnit1
      REWIND(iUnit)

      _END_MASTER(myThid)

      RETURN
      END

#include "GCHEM_OPTIONS.h"

CBOP
C     !ROUTINE: CFC12_SURFFORCING
C     !INTERFACE:
      SUBROUTINE CFC12_SURFFORCING(
     I                          pTr_CFC12, AtmosCFC12,
     O                          fluxCFC12,
     I                          bi, bj, iMin, iMax, jMin, jMax,
     I                          myTime, myIter, myThid )

C     !DESCRIPTION:
C     *==========================================================*
C     | SUBROUTINE CFC12_SURFFORCING
C     | o Calculate the CFC12 air-sea fluxes
C     *==========================================================*

C     !USES:
      IMPLICIT NONE

C     == GLobal variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "DYNVARS.h"
#include "CFC.h"

C     !INPUT/OUTPUT PARAMETERS:
C     pTr_CFC12  :: ocean CFC12 concentration
C     AtmosCFC12 :: atmospheric CFC12 field
C     fluxCFC12  :: air-sea CFC12 fluxes
C     bi, bj     :: current tile indices
C     iMin,iMax  :: computation domain, 1rst index bounds
C     jMin,jMax  :: computation domain, 2nd  index bounds
C     myTime     :: current time in simulation
C     myIter     :: current iteration number
C     myThid     :: my Thread Id number
      _RL  pTr_CFC12 (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL  AtmosCFC12(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL  fluxCFC12 (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER bi, bj
      INTEGER iMin, iMax, jMin, jMax
      _RL myTime
      INTEGER myIter, myThid
CEOP

#ifdef ALLOW_PTRACERS
#ifdef ALLOW_CFC

C     !LOCAL VARIABLES:
C i, j, k - Loop counters
      INTEGER i,j,k
C Solubility relation coefficients
      _RL SchmidtNocfc12(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL SolCFC12(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
c     _RL cfc12sat(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL Kwexch(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL Csat(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL ttemp, ttemp2

      k=1

C calculate SCHMIDT NO. for O2
        DO j=jMin,jMax
         DO i=iMin,iMax
           IF ( maskC(i,j,k,bi,bj).NE.zeroRS ) THEN
C calculate SCHMIDT NO. for CFC12
             SchmidtNocfc12(i,j) =
     &            sca_12_1
     &          + sca_12_2 * theta(i,j,k,bi,bj)
     &          + sca_12_3 * theta(i,j,k,bi,bj)*theta(i,j,k,bi,bj)
     &          + sca_12_4 * theta(i,j,k,bi,bj)*theta(i,j,k,bi,bj)
     &                *theta(i,j,k,bi,bj)
c calculate solubility for CFC12
             ttemp=( theta(i,j,k,bi,bj) + 273.16 _d 0)* 0.01 _d 0
             ttemp2=( B3_12 * ttemp + B2_12 )*ttemp + B1_12
             SolCFC12(i,j) =
     &           EXP ( A1_12
     &           +  A2_12 / ttemp
     &           +  A3_12 * log( ttemp )
     &           +  A4_12 * ttemp * ttemp
     &           +  Salt(i,j,k,bi,bj)* ttemp2 )
c     conversion from mol/(l * atm) to mol/(m^3 * atm)
             SolCFC12(i,j) = 1000. _d 0 * SolCFC12(i,j)
c     conversion from mol/(m^3 * atm) to mol/(m3 * pptv)
             SolCFC12(i,j) = 1. _d -12 * SolCFC12(i,j)
C Determine surface flux (Fcfc12)
             Csat(i,j) = SolCFC12(i,j)*AtmosP(i,j,bi,bj)
     &                     *AtmosCFC12(i,j)
             Kwexch(i,j) = (1. _d 0 - fIce(i,j,bi,bj))
     &                   * pisVel(i,j,bi,bj)
     &                   / SQRT(SchmidtNoCFC12(i,j)/660. _d 0)
             fluxCFC12(i,j) =
     &           Kwexch(i,j)*(Csat(i,j) - pTr_CFC12(i,j,1))

           ELSE
             fluxCFC12(i,j) = 0. _d 0
           ENDIF

         ENDDO
        ENDDO

#endif /* ALLOW_CFC */
#endif /* ALLOW_PTRACERS */

      RETURN
      END

#include "DEBUG_OPTIONS.h"

      SUBROUTINE DEBUG_STATS_RS(
     I                myNr, arr, arrName,
     I                myThid )
C     *==========================================================*
C     | SUBROUTINE DEBUG_STATS_RS                                |
C     | o Prints to STDOUT the bare statistics of global array   |
C     |   "_RS arr" with label "arrName"                         |
C     | o This routine is similar to MON_WRITESTATS_RS but with  |
C     |   a different label at left of screen                    |
C     *==========================================================*
      IMPLICIT NONE

C     === Global data ===
#include "SIZE.h"
#include "EEPARAMS.h"

C     === Routine arguments ===
      INTEGER myNr
      _RS arr(1-OLx:sNx+OLx,1-OLy:sNy+OLy,myNr,nSx,nSy)
      CHARACTER*(*) arrName
      INTEGER myThid

C     === Local variables ====
      _RL theMin
      _RL theMax
      _RL theMean
      _RL theSD

      CALL DEBUG_FLD_STATS_RS(
     I                myNr, arr, zeroRS,
     O                theMin, theMax, theMean, theSD,
     I                myThid )

      _BEGIN_MASTER( myThid )
      WRITE(standardmessageunit,'(A,A30,A,1PE22.14)')
     &      'DEBUG_STATS_RS: ',arrName,'  min=',theMin
      WRITE(standardmessageunit,'(A,A30,A,1PE22.14)')
     &      'DEBUG_STATS_RS: ',arrName,'  max=',theMax
      WRITE(standardmessageunit,'(A,A30,A,1PE22.14)')
     &      'DEBUG_STATS_RS: ',arrName,' mean=',theMean
      WRITE(standardmessageunit,'(A,A30,A,1PE22.14)')
     &      'DEBUG_STATS_RS: ',arrName,' S.D.=',theSD
      _END_MASTER( myThid )

      RETURN
      END

#include "CTRL_OPTIONS.h"

      subroutine ctrl_init_obcs_variables( myThid )

c     ==================================================================
c     SUBROUTINE ctrl_init_obcs_variables
c     ==================================================================
c
c     o Set parts of the vector of control variables and initialize the
c       rest to zero.
c
c     started: heimbach@mit.edu 25-Mar-2002
c
c     ==================================================================
c     SUBROUTINE ctrl_init_obcs_variables
c     ==================================================================

      IMPLICIT NONE

c     == global variables ==

#include "EEPARAMS.h"
#include "SIZE.h"
#include "PARAMS.h"
c#include "GRID.h"
#include "CTRL_SIZE.h"
#include "CTRL.h"
#include "CTRL_OBCS.h"

c     == routine arguments ==
      integer myThid

#ifdef ALLOW_OBCS
c     == local variables ==
      integer bi,bj
      integer i,j,k
      integer iobcs

c     == end of interface ==

#ifdef ALLOW_OBCSN_CONTROL
      do iobcs = 1, nobcs
        do bj = myByLo(myThid), myByHi(myThid)
          do bi = myBxLo(myThid), myBxHi(myThid)
            do k = 1,Nr
              do i = 1-OLx, sNx+OLx
                xx_obcsN0(i,k,bi,bj,iobcs) = 0. _d 0
                xx_obcsN1(i,k,bi,bj,iobcs) = 0. _d 0
              enddo
            enddo
          enddo
        enddo
      enddo
#endif

#ifdef ALLOW_OBCSS_CONTROL
      do iobcs = 1, nobcs
        do bj = myByLo(myThid), myByHi(myThid)
          do bi = myBxLo(myThid), myBxHi(myThid)
            do k = 1,Nr
              do i = 1-OLx, sNx+OLx
                xx_obcsS0(i,k,bi,bj,iobcs) = 0. _d 0
                xx_obcsS1(i,k,bi,bj,iobcs) = 0. _d 0
              enddo
            enddo
          enddo
        enddo
      enddo
#endif

#ifdef ALLOW_OBCSE_CONTROL
      do iobcs = 1, nobcs
        do bj = myByLo(myThid), myByHi(myThid)
          do bi = myBxLo(myThid), myBxHi(myThid)
            do k = 1,Nr
              do j = 1-OLy, sNy+OLy
                xx_obcsE0(j,k,bi,bj,iobcs) = 0. _d 0
                xx_obcsE1(j,k,bi,bj,iobcs) = 0. _d 0
              enddo
            enddo
          enddo
        enddo
      enddo
#endif

#ifdef ALLOW_OBCSW_CONTROL
      do iobcs = 1, nobcs
        do bj = myByLo(myThid), myByHi(myThid)
          do bi = myBxLo(myThid), myBxHi(myThid)
            do k = 1,Nr
              do j = 1-OLy, sNy+OLy
                xx_obcsW0(j,k,bi,bj,iobcs) = 0. _d 0
                xx_obcsW1(j,k,bi,bj,iobcs) = 0. _d 0
              enddo
            enddo
          enddo
        enddo
      enddo
#endif

#ifdef ALLOW_COST
      do bj = myByLo(myThid), myByHi(myThid)
        do bi = myBxLo(myThid), myBxHi(myThid)
          do k = 1,Nr
            do i = 1-OLx, sNx+OLx
              objf_obcsN(bi,bj) = 0. _d 0
              objf_obcsS(bi,bj) = 0. _d 0
              objf_obcsE(bi,bj) = 0. _d 0
              objf_obcsW(bi,bj) = 0. _d 0
              objf_ageos(bi,bj) = 0. _d 0
              num_obcsN(bi,bj)  = 0. _d 0
              num_obcsS(bi,bj)  = 0. _d 0
              num_obcsE(bi,bj)  = 0. _d 0
              num_obcsW(bi,bj)  = 0. _d 0
              num_ageos(bi,bj)  = 0. _d 0
            enddo
          enddo
        enddo
      enddo

C--   Initialise the "global" parts of the cost function.
      _BEGIN_MASTER( myThid )
        objf_obcsvol = 0. _d 0
        num_obcsvol  = 0. _d 0
      _END_MASTER( myThid )
#endif /* ALLOW_COST */

#endif /* ALLOW_OBCS */

      return
      end

#include "CTRL_OPTIONS.h"
#ifdef ALLOW_COST
# include "COST_OPTIONS.h"
#endif
#ifdef ALLOW_ECCO
# include "ECCO_OPTIONS.h"
#endif

      subroutine ctrl_pack( first, mythid )

c     ==================================================================
c     SUBROUTINE ctrl_pack
c     ==================================================================
c
c     o Compress the control vector such that only ocean points are
c       written to file.
c
c     started: Christian Eckert eckert@mit.edu  10-Mar=2000
c
c     changed: Patrick Heimbach heimbach@mit.edu 06-Jun-2000
c              - Transferred some filename declarations
c                from here to namelist in ctrl_init_fixed
c
c              Patrick Heimbach heimbach@mit.edu 16-Jun-2000
c              - single file name convention with or without
c                ALLOW_ECCO_OPTIMIZATION
c
c              G. Gebbie, added open boundary control packing,
c                  gebbie@mit.edu  18 -Mar- 2003
c
c              heimbach@mit.edu totally restructured 28-Oct-2003
c
c     ==================================================================
c     SUBROUTINE ctrl_pack
c     ==================================================================

      IMPLICIT NONE

c     == global variables ==

#include "EEPARAMS.h"
#include "SIZE.h"
#include "PARAMS.h"
#include "GRID.h"

#ifdef ALLOW_CTRL
# include "CTRL_SIZE.h"
# include "CTRL.h"
# include "CTRL_GENARR.h"
# include "OPTIMCYCLE.h"
# include "CTRL_OBCS.h"
#endif
#ifdef ALLOW_COST
# include "cost.h"
#endif

c     == routine arguments ==
      logical first
      integer mythid

#ifndef EXCLUDE_CTRL_PACK
c     == external functions ==

      integer  ilnblnk
      external ilnblnk

c     == local variables ==

      logical doglobalread
      logical ladinit
      logical lxxadxx

      integer k, ivar, iarr
      integer cunit
      integer ictrlgrad
      _RL    fcloc

      character*(128) cfile
      integer il, ilDir

      character*(MAX_LEN_FNAM) fname_local(3)

#if ( defined ALLOW_GENARR2D_CONTROL || defined ALLOW_GENTIM2D_CONTROL )
C 9 character limit set by set_(un)pack
      character*(9) mskNameForSetPack
#endif

#ifdef ALLOW_OBCS
      integer iobcs
#endif

c     == end of interface ==

c--   Tiled files are used.
      doglobalread = .false.

c--   Initialise adjoint variables on active files.
      ladinit = .false.

c--   Initialise global buffer index
      nbuffglobal = 0

c--   Initialise local cost function value
      fcloc     = zeroRL

c--   Find ctrlDir (w/o trailing blanks) length
      ilDir = ilnblnk(ctrlDir)

c--   Only the master thread will do I/O.
      _BEGIN_MASTER( mythid )

      if ( first ) then
c     >>> Initialise control vector for optimcycle=0 <<<
          lxxadxx   = .TRUE.
          ictrlgrad = 1
          fcloc     = zeroRL
          write(cfile(1:128),'(4a,i4.4)')
     &         ctrlname(1:9),'_',yctrlid(1:10),
     &         yctrlpospack, optimcycle
          write(standardMessageUnit,*) 'ph-pack: packing ',ctrlname(1:9)
      else
c     >>> Write gradient vector <<<
          lxxadxx   = .FALSE.
          ictrlgrad = 2
#ifdef ALLOW_COST
# ifdef ALLOW_OPENAD
          fcloc     = fc%v
# else
          fcloc     = fc
# endif
#endif
          write(cfile(1:128),'(4a,i4.4)')
     &         costname(1:9),'_',yctrlid(1:10),
     &         yctrlpospack, optimcycle
          write(standardMessageUnit,*) 'ph-pack: packing ',costname(1:9)
       endif

c--   Only Proc 0 will do I/O.
      IF ( myProcId .eq. 0 ) THEN

       call mdsfindunit( cunit, mythid )
       open( cunit, file   = cfile,
     &      status = 'unknown',
     &      form   = 'unformatted',
     &      access  = 'sequential'   )

c--       Header information.
          write(cunit) nvartype
          write(cunit) nvarlength
          write(cunit) yctrlid
          write(cunit) optimCycle
          write(cunit) fcloc
C     place holder of obsolete variable iG
          write(cunit) 1
C     place holder of obsolete variable jG
          write(cunit) 1
          write(cunit) nSx
          write(cunit) nSy
          write(cunit) (nWetcGlobal(k), k=1,Nr)
          write(cunit) (nWetsGlobal(k), k=1,Nr)
          write(cunit) (nWetwGlobal(k), k=1,Nr)
c#ifdef ALLOW_CTRL_WETV
c         write(cunit) (nWetvGlobal(k), k=1,Nr)
c#endif
#ifdef ALLOW_SHELFICE
          write(cunit) (nWetiGlobal(k), k=1,Nr)
c          write(cunit) nWetiGlobal(1)
#endif

#ifdef ALLOW_OBCS
# ifdef ALLOW_OBCSN_CONTROL
          write(cunit) ((nWetobcsnGlo(k,iobcs), k=1,Nr),iobcs= 1,nobcs)
# endif
# ifdef ALLOW_OBCSS_CONTROL
          write(cunit) ((nWetobcssGlo(k,iobcs), k=1,Nr),iobcs= 1,nobcs)
# endif
# ifdef ALLOW_OBCSW_CONTROL
          write(cunit) ((nWetobcswGlo(k,iobcs), k=1,Nr),iobcs= 1,nobcs)
# endif
# ifdef ALLOW_OBCSE_CONTROL
          write(cunit) ((nWetobcseGlo(k,iobcs), k=1,Nr),iobcs= 1,nobcs)
# endif
#endif

          write(cunit) (ncvarindex(ivar), ivar=1,nvartype)
          write(cunit) (ncvarrecs(ivar),  ivar=1,nvartype)
          write(cunit) (ncvarxmax(ivar),  ivar=1,nvartype)
          write(cunit) (ncvarymax(ivar),  ivar=1,nvartype)
          write(cunit) (ncvarnrmax(ivar), ivar=1,nvartype)
          write(cunit) (ncvargrd(ivar),   ivar=1,nvartype)
          write(cunit) (ncvartype(ivar),  ivar=1,nvartype)

#ifdef ALLOW_PACKUNPACK_METHOD2
      ENDIF
      _END_MASTER( mythid )
      _BARRIER
#endif

c     do ivar = 1, maxcvars
      do ivar = 1, nvartype
       if ( ncvarindex(ivar) .GE. 0 ) THEN
        il = ilnblnk(ncvarfname(ivar))
        iarr = ncvarindex(ivar)
        call ctrl_set_fname(ctrlDir(1:ilDir)//ncvarfname(ivar),
     &                      fname_local, mythid )
        if ( ncvargrd(ivar).EQ.'m' ) then
#ifdef ALLOW_OBCS
         if ( iarr.EQ.1 ) then
# ifdef ALLOW_OBCSN_CONTROL
          call ctrl_set_pack_xz( cunit, ivar, fname_local(ictrlgrad),
     &               'maskobcsn', 'wobcsn', wobcsn, lxxadxx, mythid )
# endif
         elseif ( iarr.EQ.2 ) then
# ifdef ALLOW_OBCSS_CONTROL
          call ctrl_set_pack_xz( cunit, ivar, fname_local(ictrlgrad),
     &               'maskobcss', 'wobcss', wobcss, lxxadxx, mythid )
# endif
         elseif ( iarr.EQ.3 ) then
# ifdef ALLOW_OBCSE_CONTROL
          call ctrl_set_pack_yz( cunit, ivar, fname_local(ictrlgrad),
     &               'maskobcse', 'wobcse', wobcse, lxxadxx, mythid )
# endif
         elseif ( iarr.EQ.4 ) then
# ifdef ALLOW_OBCSW_CONTROL
          call ctrl_set_pack_yz( cunit, ivar, fname_local(ictrlgrad),
     &               'maskobcsw', 'wobcsw', wobcsw, lxxadxx, mythid )
# endif
         endif
#endif /* ALLOW_OBCS */

#ifdef ALLOW_GENARR2D_CONTROL
        elseif ( ncvartype(ivar).EQ.'Arr2D' ) then
         if ( xx_genarr2d_weight(iarr).NE.' ') then
          mskNameForSetPack='maskCtrlC'
# ifdef ALLOW_SHELFICE
          if ( ncvargrd(ivar).EQ.'i' ) mskNameForSetPack='maskCtrlI'
# endif
          call ctrl_set_pack_xy(
     &         cunit, ivar, genarr2dPrecond(iarr),
     &         fname_local(ictrlgrad), mskNameForSetPack,
     &         xx_genarr2d_weight(iarr),
     &         lxxadxx, mythid )
         endif
#endif /* ALLOW_GENARR2D_CONTROL */

#ifdef ALLOW_GENARR3D_CONTROL
        elseif ( ncvartype(ivar).EQ.'Arr3D' ) then
         if ( xx_genarr3d_weight(iarr).NE.' ') then
          call ctrl_set_pack_xyz(
     &         cunit, ivar, fname_local(ictrlgrad), 'maskCtrlC',
     &         xx_genarr3d_weight(iarr),
     &         wunit, lxxadxx, mythid )
         endif
#endif /* ALLOW_GENARR3D_CONTROL */

#ifdef ALLOW_GENTIM2D_CONTROL
        elseif ( ncvartype(ivar).EQ.'Tim2D' ) then
         if ( xx_gentim2d_weight(iarr).NE.' ') then
          mskNameForSetPack='maskCtrlC'
# ifdef ALLOW_SHELFICE
          if ( ncvargrd(ivar).EQ.'i' ) mskNameForSetPack='maskCtrlI'
# endif
          call ctrl_set_pack_xy(
     &         cunit, ivar, gentim2dPrecond(iarr),
     &         fname_local(ictrlgrad), mskNameForSetPack,
     &         xx_gentim2d_weight(iarr),
     &         lxxadxx, mythid )
         endif
#endif /* ALLOW_GENTIM2D_CONTROL */
        endif
C     if ( ncvarindex(ivar) .ge. 0 ) then
       endif
C     do ivar = 1, maxcvars
      enddo

#ifdef ALLOW_PACKUNPACK_METHOD2
      _BEGIN_MASTER( mythid )
      IF ( myProcId .eq. 0 ) THEN
#endif

       close ( cunit )
       ENDIF !IF ( myProcId .eq. 0 )
       _END_MASTER( mythid )
      _BARRIER
#endif /* EXCLUDE_CTRL_PACK */

      return
      end

#include "PACKAGES_CONFIG.h"
#include "CPP_OPTIONS.h"
#include "W2_OPTIONS.h"

CBOP
C     !ROUTINE: EXCH2_CHECK_DEPTHS

C     !INTERFACE:
      SUBROUTINE EXCH2_CHECK_DEPTHS( rLow, rHigh, myThid )

C     !DESCRIPTION: \bc
C     *==========================================================*
C     | SUBROUTINE EXCH2_CHECK_DEPTHS
C     | o Check that disconnected tile edges (when using blank
C     |   tiles) correspond to a closed (= zero depth) boundary.
C     | Note: no check if using OBCs
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
c#include "EESUPPORT.h"
#include "W2_EXCH2_SIZE.h"
#include "W2_EXCH2_TOPOLOGY.h"
#ifdef ALLOW_OBCS
# include "PARAMS.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
C     rLow    :: Lower  "r" boundary
C     rHigh   :: Higher "r" boundary
C     myThid  :: my Thread Id number
      _RS     rLow (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RS     rHigh(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      INTEGER myThid
CEOP

C     == Local variables ==
      _RS     tmpFld(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      INTEGER bi, bj, tId
      INTEGER i, j, n
      INTEGER errN, errS, errE, errW
      LOGICAL errFlag

#ifdef ALLOW_OBCS
C-    For now, do nothing if OBCs is used
      IF ( useOBCs ) RETURN
#endif

      errFlag = .FALSE.
      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)

C-    Fill E,W & N,S edges with total depth from the interior
         i = sNx+1
         DO j=1,sNy
           tmpFld(0,j) = rHigh( 1 ,j,bi,bj) - rLow( 1 ,j,bi,bj)
           tmpFld(i,j) = rHigh(sNx,j,bi,bj) - rLow(sNx,j,bi,bj)
         ENDDO
         j = sNy+1
         DO i=1,sNx
           tmpFld(i,0) = rHigh(i, 1 ,bi,bj) - rLow(i, 1 ,bi,bj)
           tmpFld(i,j) = rHigh(i,sNy,bi,bj) - rLow(i,sNy,bi,bj)
         ENDDO

C-    Reset to zero if connected
         tId = W2_myTileList(bi,bj)
         DO n= 1,exch2_nNeighbours(tId)
          DO j=exch2_jLo(n,tId),exch2_jHi(n,tId)
           DO i=exch2_iLo(n,tId),exch2_iHi(n,tId)
            tmpFld(i,j) = 0.
           ENDDO
          ENDDO
         ENDDO

C- North:
         errN = 0
         j = sNy+1
         DO i=1,sNx
           IF ( tmpFld(i,j).GT.0. ) errN = errN + 1
         ENDDO
C- South:
         errS = 0
         j = 0
         DO i=1,sNx
           IF ( tmpFld(i,j).GT.0. ) errS = errS + 1
         ENDDO
C- East :
         errE = 0
         i = sNx+1
         DO j=1,sNy
           IF ( tmpFld(i,j).GT.0. ) errE = errE + 1
         ENDDO
C- West :
         errW = 0
         i = 0
         DO j=1,sNy
           IF ( tmpFld(i,j).GT.0. ) errW = errW + 1
         ENDDO

         IF ( errN+errS+errW+errE .GE. 1 ) THEN
          WRITE(msgBuf,'(2A,I8,A,2(I4,A))')
     &        '** WARNING ** EXCH2_CHECK_DEPTHS: ',
     &        'tile #', tId, ' (bi,bj=', bi, ',', bj, ' ):'
          CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                        SQUEEZE_RIGHT, myThid )
          IF ( errN.GE.1 ) THEN
           WRITE(msgBuf,'(A,I5,A)') ' N.Edge has', errN,
     &        ' unconnected points with non-zero depth.'
           CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                         SQUEEZE_RIGHT, myThid )
          ENDIF
          IF ( errS.GE.1 ) THEN
           WRITE(msgBuf,'(A,I5,A)') ' S.Edge has', errS,
     &        ' unconnected points with non-zero depth.'
           CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                         SQUEEZE_RIGHT, myThid )
          ENDIF
          IF ( errE.GE.1 ) THEN
           WRITE(msgBuf,'(A,I5,A)') ' E.Edge has', errE,
     &        ' unconnected points with non-zero depth.'
           CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                         SQUEEZE_RIGHT, myThid )
          ENDIF
          IF ( errW.GE.1 ) THEN
           WRITE(msgBuf,'(A,I5,A)') ' W.Edge has', errW,
     &        ' unconnected points with non-zero depth.'
           CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                         SQUEEZE_RIGHT, myThid )
          ENDIF
          WRITE( msgBuf,'(A)') 'S/R EXCH2_CHECK_DEPTHS: Fatal Error'
          errFlag = .TRUE.
         ENDIF

       ENDDO
      ENDDO

#ifdef USE_ERROR_STOP
c     CALL STOP_IF_ERROR( errFlag, msgBuf, myThid )
#else  /* USE_ERROR_STOP */
c     IF ( errFlag ) STOP 'ABNORMAL END: S/R EXCH2_CHECK_DEPTHS'
#endif /* USE_ERROR_STOP */
      IF ( errFlag ) THEN
          WRITE( msgBuf,'(2A)') '** WARNING ** EXCH2_CHECK_DEPTHS:',
     &        ' some algorithm implementation might not be'
          CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                        SQUEEZE_RIGHT, myThid )
          WRITE( msgBuf,'(2A)') '** WARNING ** EXCH2_CHECK_DEPTHS:',
     &        ' safe with non-zero depth next to blank-tile'
          CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                        SQUEEZE_RIGHT, myThid )
      ENDIF

      RETURN
      END

#include "ctrparam.h"
#include "ATM2D_OPTIONS.h"

C     !INTERFACE:
      SUBROUTINE PUT_OCNVARS(  myTime, myIter, myThid )
C     *==========================================================*
C     | Put fluxes for the ocean where needed: MPI mode, into    |
c     | common block for passing; single-proc, into FFIELDS.h    |
C     *==========================================================*
        IMPLICIT NONE

C     === Global Atmosphere Variables ===
#include "ATMSIZE.h"
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "THSICE_VARS.h"
#include "ATM2D_VARS.h"

#ifdef ATM2D_MPI_ON
#  include "OCNSIZE.h"
#  include "OCNVARS.h"
#  include "OCNIDS.h"
#else
#  include "FFIELDS.h"
#  include "SURFACE.h"
#  ifdef ALLOW_DIC
#    include "DIC_VARS.h"
#  endif
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
C     myTime - current simulation time (ocean model time)
C     myIter - iteration number (ocean model)
C     myThid - Thread no. that called this routine.
      _RL     myTime
      INTEGER myIter
      INTEGER myThid

C     LOCAL VARIABLES:
      INTEGER i,j

      DO j=1,sNy
        DO i=1,sNx

#ifdef ATM2D_MPI_ON

C OCNVARS common set from ATM2D common
          atmSLPr_ocn(i,j)= pass_slp(i,j)
          HeatFlux_ocn(i,j)= pass_qnet(i,j)
          qShortWave_ocn(i,j)= pass_solarnet(i,j)
          TauX_ocn(i,j)= pass_fu(i,j)
          TauY_ocn(i,j)= pass_fv(i,j)
C         convert FW to MITGCM units kg/m2/s for passing
          FWFlux_ocn(i,j)= (pass_precip(i,j) + pass_evap(i,j)
     &                     + pass_runoff(i,j)) * rhoConstFresh
          SaltFlx_ocn(i,j) = sFluxFromIce(i,j)
#  ifdef ATMOSPHERIC_LOADING
          sIceMass_ocn(i,j) = pass_sIceLoad(i,j)
#  endif /* ATMOSPHERIC_LOADING */
          IF ( ocnCpl_exchange_DIC ) THEN
            aCO2_ocn(i,j) = pass_pCO2(i,j)
            wSpeed_ocn(i,j) = pass_wspeed(i,j)
            sIceFrac_ocn(i,j) = iceMask(i,j,1,1)
          ENDIF

#else
C FFIELDS.h common block set from ATM2D common

          pLoad(i,j,1,1)= pass_slp(i,j)
          Qnet(i,j,1,1)= pass_qnet(i,j)
          Qsw(i,j,1,1)= pass_solarnet(i,j)
          fu(i,j,1,1)= pass_fu(i,j)
          fv(i,j,1,1)= pass_fv(i,j)
          EmPmR(i,j,1,1)= (pass_precip(i,j) + pass_evap(i,j)
     &                     + pass_runoff(i,j)) * rhoConstFresh
          saltFlux(i,j,1,1)= sFluxFromIce(i,j)

          CALL EXCH_UV_XY_RS(fu,fv,.TRUE.,myThid)
          _EXCH_XY_RS(EmPmR, myThid )   !for NL Free surf?
          _EXCH_XY_RS(saltFlux, myThid )
          _EXCH_XY_RS(Qnet, myThid )
          _EXCH_XY_RS(Qsw, myThid )

#  ifdef ATMOSPHERIC_LOADING
          sIceLoad(i,j,1,1) = pass_sIceLoad(i,j)
          _EXCH_XY_RS(pLoad, myThid )
          _EXCH_XY_RS( sIceLoad, myThid )
C          phi0surf(i,j,1,1) = pass_slp(i,j)*recip_rhoConst
C     &                 + gravity*seaIceMass(i,j,1,1)*recip_rhoConst
#  endif /* ATMOSPHERIC_LOADING */

#  ifdef ALLOW_DIC
C          icemask should be imported in DIC code
           AtmospCO2(i,j,1,1)=  pass_pCO2(i,j)
           wind(i,j,1,1)= pass_wspeed(i,j)
           _EXCH_XY_RL(AtmospCO2 ,  myThid )
           _EXCH_XY_RL(wind ,  myThid )
#  endif /* ALLOW_DIC */

#endif /* ATM2D_MPI_ON */

        ENDDO
      ENDDO

      RETURN
      END

#include "MYPACKAGE_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: MYPACKAGE_MNC_INIT

C     !INTERFACE:
      SUBROUTINE MYPACKAGE_MNC_INIT( myThid )

C     !DESCRIPTION:
C     Initialize MNC lookup tables for Mypackage.

C     !USES:
      IMPLICIT NONE
C     == Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "MYPACKAGE.h"

C     !INPUT PARAMETERS:
      INTEGER myThid
CEOP

#ifdef ALLOW_MNC

      IF (useMNC) THEN

        CALL MNC_CW_ADD_VNAME('myPa_StatScal1',
     &      'Cen_xy_Hn__L__t', 4,5,myThid)
        CALL MNC_CW_ADD_VATTR_TEXT('myPa_StatScal1',
     &      'units','[unit]', myThid)
        CALL MNC_CW_ADD_VATTR_TEXT('myPa_StatScal1','description',
     &      'scalar state variable myPa_StatScal1',myThid)

        CALL MNC_CW_ADD_VNAME('myPa_StatScal2',
     &      'Cen_xy_Hn__L__t', 4,5,myThid)
        CALL MNC_CW_ADD_VATTR_TEXT('myPa_StatScal2',
     &      'units','[unit]', myThid)
        CALL MNC_CW_ADD_VATTR_TEXT('myPa_StatScal2','description',
     &      'scalar state variable myPa_StatScal2',myThid)

        CALL MNC_CW_ADD_VNAME('myPa_StatVelU',
     &      'U_xy_Hn__C__t', 4,5,myThid)
        CALL MNC_CW_ADD_VATTR_TEXT('myPa_StatVelU',
     &      'units','[unit]', myThid)
        CALL MNC_CW_ADD_VATTR_TEXT('myPa_StatVelU','description',
     &       'uVel-type state variable myPa_StatVelU',myThid)

        CALL MNC_CW_ADD_VNAME('myPa_StatVelV',
     &      'V_xy_Hn__C__t', 4,5,myThid)
        CALL MNC_CW_ADD_VATTR_TEXT('myPa_StatVelV',
     &      'units','[unit]', myThid)
        CALL MNC_CW_ADD_VATTR_TEXT('myPa_StatVelV','description',
     &       'vVel-type state variable myPa_StatVelV',myThid)

        CALL MNC_CW_ADD_VNAME('myPa_Surf1',
     &      'Cen_xy_Hn__-__t', 3,4,myThid)
        CALL MNC_CW_ADD_VATTR_TEXT('myPa_Surf1',
     &      'units','[unit]', myThid)
        CALL MNC_CW_ADD_VATTR_TEXT('myPa_Surf1','description',
     &       'Surface scalar field myPa_Surf1',myThid)

        CALL MNC_CW_ADD_VNAME('myPa_Surf2',
     &      'Cen_xy_Hn__-__t', 3,4,myThid)
        CALL MNC_CW_ADD_VATTR_TEXT('myPa_Surf2',
     &      'units','[unit]', myThid)
        CALL MNC_CW_ADD_VATTR_TEXT('myPa_Surf2','description',
     &       'Surface scalar field myPa_Surf2',myThid)

      ENDIF

#endif /* ALLOW_MNC */

      RETURN
      END

#include "AIM_OPTIONS.h"

CBOP
C     !ROUTINE: AIM_AIM2DYN
C     !INTERFACE:
      SUBROUTINE AIM_AIM2DYN(
     I                        bi, bj, myTime, myIter, myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R AIM_AIM2DYN
C     | o Remap AIM outputs to dynamics conforming arrays.
C     |==========================================================*
C     | Currently AIM exports to the dynmaics
C     |  - PBL drag coefficient
C     |  - Net tendency for temperature
C     |  - Net tendency for water vapor
C     | Exporting drag has the nice property that it is a scalar.
C     | This means that the exchanges on the AIM exported fields
C     | do not need special piaring on the cube. It may not be
C     | a good idea in the long term as it makes assumptions
C     | about the momentum schemes within AIM.
C     *==========================================================*
C     \ev
C-------
C  Note: Except LSC tendency, all others need to be /dpFac.
C-------

C     !USES:
      IMPLICIT NONE

C     == Global variables ===
C-- size for MITgcm & Physics package :
#include "AIM_SIZE.h"

#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "SURFACE.h"

#include "AIM2DYN.h"
#include "com_physvar.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     bi,bj  :: Tile index
C     myTime :: Current time of simulation ( s )
C     myIter :: Current iteration number in simulation
C     myThid :: Number of this instance of the routine
      INTEGER bi, bj
      _RL     myTime
      INTEGER myIter, myThid
CEOP

#ifdef ALLOW_AIM
C     !LOCAL VARIABLES:
C     == Local variables ==
C     i,j,k        :: loop counters
C     I2,Katm      :: loop counters
C     conv_T2theta :: conversion factor from (absolute) Temp. to Pot.Temp.
      _RL conv_T2theta
      INTEGER i,j,k
      INTEGER I2, Katm
#ifdef ALLOW_DIAGNOSTICS
      LOGICAL  physTendDiag
      LOGICAL  DIAGNOSTICS_IS_ON
      EXTERNAL DIAGNOSTICS_IS_ON
#endif

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C--   Physics tendency term

#ifdef ALLOW_DIAGNOSTICS
      physTendDiag = .FALSE.
      IF (useDiagnostics) THEN
        physTendDiag = DIAGNOSTICS_IS_ON( 'DIABT   ', myThid )
     &            .OR. DIAGNOSTICS_IS_ON( 'DIABQ   ', myThid )
      ENDIF
#endif

C-    Planetary boundary layer drag coeff.
      DO j=1,sNy
        DO i=1,sNx
         I2 = i+(j-1)*sNx
         aim_drag(i,j,bi,bj) = DRAG(I2,0,myThid)
        ENDDO
      ENDDO
#ifdef COMPONENT_MODULE
      IF ( useCoupler ) THEN
C-    Near surface wind speed
       DO j=1,sNy
        DO i=1,sNx
         I2 = i+(j-1)*sNx
         aim_surfWind(i,j,bi,bj) = SPEED0(I2,myThid)
        ENDDO
       ENDDO
      ENDIF
#endif /* COMPONENT_MODULE */

      DO k=1,Nr
       Katm = _KD2KA( k )
       conv_T2theta = (atm_Po/rC(k))**atm_kappa

C-     Add all tendencies (ignoring partial cell factor) for T & Q
C          and convert Temp. tendency to Pot.Temp. tendency
       DO j=1,sNy
        DO i=1,sNx
         I2 = i+(j-1)*sNx
C        temperature tendency
         aim_dTdt(i,j,k,bi,bj) = ( TT_CNV(I2,Katm,myThid)
     &                            +TT_PBL(I2,Katm,myThid)
     &                            +TT_RSW(I2,Katm,myThid)
     &                            +TT_RLW(I2,Katm,myThid)
     &                            +TT_LSC(I2,Katm,myThid)
     &                           )*conv_T2theta
C        water vapor tendency
         aim_dSdt(i,j,k,bi,bj) =   QT_CNV(I2,Katm,myThid)
     &                            +QT_PBL(I2,Katm,myThid)
     &                            +QT_LSC(I2,Katm,myThid)
        ENDDO
       ENDDO
#ifdef NONLIN_FRSURF
       IF ( select_rStar.GE.1 ) THEN
         DO j=1,sNy
          DO i=1,sNx
            aim_dTdt(i,j,k,bi,bj) = aim_dTdt(i,j,k,bi,bj)
     &                            / pStarFacK(i,j,bi,bj)
          ENDDO
         ENDDO
       ENDIF
#endif /* NONLIN_FRSURF */

#ifdef ALLOW_DIAGNOSTICS
       IF ( physTendDiag ) THEN
         CALL DIAGNOSTICS_FILL( aim_dTdt, 'DIABT   ',
     &                          k, Nr, 1,bi,bj, myThid )
         CALL DIAGNOSTICS_FILL( aim_dSdt, 'DIABQ   ',
     &                          k, Nr, 1,bi,bj, myThid )
       ENDIF
#endif /* ALLOW_DIAGNOSTICS */

C-     Account for partial cell filling:
#ifdef NONLIN_FRSURF
       IF ( staggerTimeStep .AND. nonlinFreeSurf.GT.0 ) THEN
        IF ( select_rStar.GT.0 ) THEN
         DO j=1,sNy
          DO i=1,sNx
            aim_dTdt(i,j,k,bi,bj) = aim_dTdt(i,j,k,bi,bj)
     &                          *recip_hFacC(i,j,k,bi,bj)
     &                              /rStarExpC(i,j,bi,bj)
            aim_dSdt(i,j,k,bi,bj) = aim_dSdt(i,j,k,bi,bj)
     &                          *recip_hFacC(i,j,k,bi,bj)
     &                              /rStarExpC(i,j,bi,bj)
          ENDDO
         ENDDO
        ELSE
         DO j=1,sNy
          DO i=1,sNx
           IF ( k.EQ.kSurfC(i,j,bi,bj) ) THEN
            aim_dTdt(i,j,k,bi,bj) = aim_dTdt(i,j,k,bi,bj)
     &                             /hFac_surfC(i,j,bi,bj)
            aim_dSdt(i,j,k,bi,bj) = aim_dSdt(i,j,k,bi,bj)
     &                             /hFac_surfC(i,j,bi,bj)
           ELSE
            aim_dTdt(i,j,k,bi,bj) = aim_dTdt(i,j,k,bi,bj)
     &                          *recip_hFacC(i,j,k,bi,bj)
            aim_dSdt(i,j,k,bi,bj) = aim_dSdt(i,j,k,bi,bj)
     &                          *recip_hFacC(i,j,k,bi,bj)
           ENDIF
          ENDDO
         ENDDO
        ENDIF
       ELSE
#else /* ndef NONLIN_FRSURF */
       IF (.TRUE.) THEN
#endif /* NONLIN_FRSURF */
         DO j=1,sNy
          DO i=1,sNx
            aim_dTdt(i,j,k,bi,bj) =  aim_dTdt(i,j,k,bi,bj)
     &                           *recip_hFacC(i,j,k,bi,bj)
            aim_dSdt(i,j,k,bi,bj) =  aim_dSdt(i,j,k,bi,bj)
     &                           *recip_hFacC(i,j,k,bi,bj)
          ENDDO
         ENDDO
       ENDIF

C--- end of k loop.
      ENDDO

#endif /* ALLOW_AIM */

      RETURN
      END

#include "PACKAGES_CONFIG.h"
#include "CPP_OPTIONS.h"

CBOP
C     !ROUTINE: PACKAGES_CHECK
C     !INTERFACE:
      SUBROUTINE PACKAGES_CHECK( myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE PACKAGES_CHECK
C     | o Check runtime activated packages have been built in.
C     *==========================================================*
C     | All packages can be selected/deselected at build time
C     | ( when code is compiled ) and activated/deactivated at
C     | runtime. This routine does a quick check to trap packages
C     | that were activated at runtime but that were not compiled
C     | in at build time.
C     *==========================================================*
C     \ev

C     !CALLING SEQUENCE:
C     PACKAGES_CHECK
C       |
C       |-- OBCS_CHECK
C       |
C       |-- OPPS_CHECK
C       |
C       |-- PP81_CHECK
C       |
C       |-- KL10_CHECK
C       |
C       |-- MY82_CHECK
C       |
C       |-- GGL90_CHECK
C       |
C       |-- KPP_CHECK
C       |
C       |-- GMREDI_CHECK
C       |
C       |-- BBL_CHECK
C       |
C       |-- EXF_CHECK
C       |
C       |-- LONGSTEP_CHECK
C       |
C       |-- PTRACERS_CHECK
C       |
C       |-- GCHEM_CHECK
C       |
C       |-- OFFLINE_CHECK
C       |
C       |-- SEAICE_CHECK
C       |
C       |-- SHELFICE_CHECK
C       |
C       |-- STIC_CHECK
C       |
C       |-- SMOOTH_CHECK
C       |
C       |-- STREAMICE_CHECK
C       |
C       |-- ICEFRONT_CHECK
C       |
C       |-- THSICE_CHECK
C       |
C       |-- LAND_CHECK
C       |
C       |-- ATM_PHYS_CHECK
C       |
C       |-- AUTODIFF_CHECK
C       |
C       |-- CTRL_CHECK
C       |
C       |-- COST_CHECK
C       |
C       |-- ECCO_CHECK
C       |
C       |-- GRDCHK_CHECK
C       |
C       |-- SBO_CHECK
C       |
C       |-- DIAGNOSTICS_CHECK
C       |
C       |-- REGRID_CHECK
C       |
C       |-- LAYERS_CHECK
C       |
C       |-- NEST_CHILD_CHECK
C       |
C       |-- NEST_PARENT_CHECK
C       |
C       |-- OASIS_CHECK
C       |
C       |-- RUNCLOCK_CHECK
C       |
C       |-- MYPACKAGE_CHECK
C       |
C       |-- GAD_CHECK

C     !USES:
      IMPLICIT NONE
C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
C     myThid :: my Thread Id number
      INTEGER myThid

C     !LOCAL VARIABLES:
C     === Local variables ===
C     msgBuf :: Informational/error message buffer
      CHARACTER*(MAX_LEN_MBUF) msgBuf
CEOP

      _BEGIN_MASTER(myThid)
      WRITE(msgBuf,'(A)')
     &'== Packages configuration : Check & print summary =='
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)') ' '
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      _END_MASTER(myThid)

C---  Start with non-standard packages (without or with non standard flag)

#ifndef ALLOW_MNC
      IF ( useMNC ) THEN
        _BEGIN_MASTER(myThid)
        WRITE(msgBuf,'(2A)') '** WARNING **',
     &   ' PACKAGES_CHECK: useMNC is TRUE'
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
        WRITE(msgBuf,'(2A)') '** WARNING **',
     &   ' but pkg/mnc has not been compiled (#undef ALLOW_MNC)'
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
        _END_MASTER(myThid)
      ENDIF
#endif

#ifndef ALLOW_MOM_VECINV
      IF ( momStepping .AND. vectorInvariantMomentum ) THEN
        WRITE(msgBuf,'(2A)')
     &   'PACKAGES_CHECK: cannot step forward Momentum',
     &   ' without pkg/mom_vecinv'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(2A)') 'PACKAGES_CHECK: ',
     &   'Re-compile with pkg "mom_vecinv" in packages.conf'
        CALL PRINT_ERROR( msgBuf, myThid )
        CALL ALL_PROC_DIE( myThid )
        STOP 'ABNORMAL END: S/R PACKAGES_CHECK'
      ENDIF
#endif
#ifndef ALLOW_MOM_FLUXFORM
      IF ( momStepping .AND. .NOT.vectorInvariantMomentum ) THEN
        WRITE(msgBuf,'(2A)')
     &   'PACKAGES_CHECK: cannot step forward Momentum',
     &   ' without pkg/mom_fluxform'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(2A)') 'PACKAGES_CHECK: ',
     &   'Re-compile with pkg "mom_fluxform" in packages.conf'
        CALL PRINT_ERROR( msgBuf, myThid )
        CALL ALL_PROC_DIE( myThid )
        STOP 'ABNORMAL END: S/R PACKAGES_CHECK'
      ENDIF
#endif

#ifndef ALLOW_GENERIC_ADVDIFF
      IF ( tempStepping .OR. saltStepping ) THEN
        WRITE(msgBuf,'(2A)')
     &  'PACKAGES_CHECK: cannot step forward Temp or Salt',
     &  ' without pkg/generic_advdiff'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(2A)') 'PACKAGES_CHECK: ',
     &  'Re-compile with pkg "generic_advdiff" in packages.conf'
        CALL PRINT_ERROR( msgBuf, myThid )
        CALL ALL_PROC_DIE( myThid )
        STOP 'ABNORMAL END: S/R PACKAGES_CHECK'
      ENDIF
#endif

#ifndef ALLOW_MONITOR
C     If monitorFreq is finite, make sure the pkg/monitor is being compiled
      IF ( monitorFreq.NE.zeroRL ) CALL PACKAGES_ERROR_MSG(
     &                  'MONITOR', 'monitorFreq <> 0', myThid )
#endif

#ifndef ALLOW_CD_CODE
       IF ( useCDscheme ) CALL PACKAGES_ERROR_MSG(
     &                  'CD_CODE', 'useCDscheme=.T.', myThid )
#endif

C---  Continue with standard packages (with standard usePKG flag)

#ifdef ALLOW_OBCS
      IF ( useOBCS ) CALL OBCS_CHECK( myThid )
#else
      IF ( useOBCS ) CALL PACKAGES_ERROR_MSG( 'OBCS', ' ', myThid )
#endif

#ifndef ALLOW_SHAP_FILT
      IF ( useSHAP_FILT ) CALL PACKAGES_ERROR_MSG(
     &                  'SHAP_FILT', ' ', myThid )
#endif

#ifndef ALLOW_ZONAL_FILT
      IF ( useZONAL_FILT )
     &   CALL PACKAGES_ERROR_MSG( 'ZONAL_FILT', ' ', myThid )
#endif

#ifdef ALLOW_OPPS
      IF ( useOPPS ) CALL OPPS_CHECK( myThid )
#else
      IF ( useOPPS ) CALL PACKAGES_ERROR_MSG( 'OPPS', ' ', myThid )
#endif

#ifdef ALLOW_PP81
      IF ( usePP81 ) CALL PP81_CHECK( myThid )
#else
      IF ( usePP81 ) CALL PACKAGES_ERROR_MSG( 'PP81', ' ', myThid )
#endif

#ifdef ALLOW_KL10
      IF ( useKL10 ) CALL KL10_CHECK( myThid )
#else
      IF ( useKL10 ) CALL PACKAGES_ERROR_MSG( 'KL10', ' ', myThid )
#endif

#ifdef ALLOW_MY82
      IF ( useMY82 ) CALL MY82_CHECK( myThid )
#else
      IF ( useMY82 ) CALL PACKAGES_ERROR_MSG( 'MY82', ' ', myThid )
#endif

#ifdef ALLOW_GGL90
      IF ( useGGL90 ) CALL GGL90_CHECK( myThid )
#else
      IF ( useGGL90 ) CALL PACKAGES_ERROR_MSG( 'GGL90', ' ', myThid )
#endif

#ifdef ALLOW_KPP
      IF ( useKPP ) CALL KPP_CHECK( myThid )
#else
      IF ( useKPP ) CALL PACKAGES_ERROR_MSG( 'KPP', ' ', myThid )
#endif

#ifdef ALLOW_GMREDI
      IF ( useGMRedi ) CALL GMREDI_CHECK( myThid )
#else
      IF ( useGMRedi ) CALL PACKAGES_ERROR_MSG( 'GMRedi', ' ', myThid )
#endif

#ifdef ALLOW_BBL
      IF ( useBBL ) CALL BBL_CHECK( myThid )
#else
      IF ( useBBL ) CALL PACKAGES_ERROR_MSG( 'BBL', ' ', myThid )
#endif

#ifndef ALLOW_DOWN_SLOPE
      IF ( useDOWN_SLOPE ) CALL PACKAGES_ERROR_MSG(
     &                  'DOWN_SLOPE', ' ', myThid )
#endif

#ifndef ALLOW_CAL
      IF ( useCAL ) CALL PACKAGES_ERROR_MSG( 'CAL', ' ', myThid )
#endif

#ifdef ALLOW_EXF
      IF ( useEXF ) CALL EXF_CHECK( myThid )
#else
      IF ( useEXF ) CALL PACKAGES_ERROR_MSG( 'EXF', ' ', myThid )
#endif

#ifndef ALLOW_BULK_FORCE
      IF ( useBulkForce ) CALL PACKAGES_ERROR_MSG(
     &                  'BULK_FORCE', 'useBulkForce=.T.', myThid )
#endif

#ifndef ALLOW_EBM
      IF ( useEBM ) CALL PACKAGES_ERROR_MSG( 'EBM', ' ', myThid )
#endif

#ifndef ALLOW_CHEAPAML
      IF ( useCheapAML ) CALL PACKAGES_ERROR_MSG(
     &                  'CheapAML', ' ', myThid )
#endif

#ifndef ALLOW_FLT
      IF ( useFLT ) CALL PACKAGES_ERROR_MSG( 'FLT', ' ', myThid )
#endif

#ifdef ALLOW_LONGSTEP
      IF ( usePTRACERS ) CALL LONGSTEP_CHECK( myThid )
#endif

#ifdef ALLOW_PTRACERS
      IF ( usePTRACERS ) CALL PTRACERS_CHECK( myThid )
#else
      IF ( usePTRACERS ) CALL PACKAGES_ERROR_MSG(
     &                  'PTRACERS', ' ', myThid )
#endif

#ifdef ALLOW_GCHEM
      IF ( useGCHEM ) CALL GCHEM_CHECK( myThid )
#else
      IF ( useGCHEM ) CALL PACKAGES_ERROR_MSG( 'GCHEM', ' ', myThid )
#endif

#ifndef ALLOW_RBCS
      IF ( useRBCS ) CALL PACKAGES_ERROR_MSG( 'RBCS', ' ', myThid )
#endif

#ifdef ALLOW_OFFLINE
      IF ( useOffLine ) CALL OFFLINE_CHECK( myThid )
#else
      IF ( useOffLine ) CALL PACKAGES_ERROR_MSG(
     &                  'OffLine', ' ', myThid )
#endif

#ifndef ALLOW_MATRIX
      IF ( useMATRIX ) CALL PACKAGES_ERROR_MSG( 'MATRIX', ' ', myThid )
#endif

#ifndef ALLOW_FRAZIL
      IF ( useFRAZIL ) CALL PACKAGES_ERROR_MSG( 'FRAZIL', ' ', myThid )
#endif

#ifdef ALLOW_SEAICE
      IF ( useSEAICE ) CALL SEAICE_CHECK( myThid )
#else
      IF ( useSEAICE ) CALL PACKAGES_ERROR_MSG( 'SEAICE', ' ', myThid )
#endif

#ifdef ALLOW_SALT_PLUME
      IF ( useSALT_PLUME ) CALL SALT_PLUME_CHECK( myThid )
#else
      IF ( useSALT_PLUME ) CALL PACKAGES_ERROR_MSG(
     &                  'SALT_PLUME', ' ', myThid )
#endif

#ifdef ALLOW_SHELFICE
      IF ( useShelfIce ) CALL SHELFICE_CHECK( myThid )
#else
      IF ( useShelfIce ) CALL PACKAGES_ERROR_MSG(
     &                    'ShelfIce', ' ', myThid )
#endif

#ifdef ALLOW_STEEP_ICECAVITY
      IF ( useSTIC ) CALL STIC_CHECK( myThid )
#else
      IF ( useSTIC ) CALL PACKAGES_ERROR_MSG(
     &                  'STEEP_ICECAVITY', 'useSTIC=.T.', myThid )
#endif

#ifdef ALLOW_SMOOTH
      IF ( useSmooth ) CALL SMOOTH_CHECK( myThid )
#else
      IF ( useSmooth ) CALL PACKAGES_ERROR_MSG( 'Smooth', ' ', myThid )
#endif

#ifdef ALLOW_STREAMICE
      IF ( useStreamIce ) CALL STREAMICE_CHECK( myThid )
#else
      IF ( useStreamIce ) CALL PACKAGES_ERROR_MSG(
     &                  'StreamIce', ' ', myThid )
#endif

#ifdef ALLOW_ICEFRONT
      IF ( useICEFRONT ) CALL ICEFRONT_CHECK( myThid )
#else
      IF ( useICEFRONT ) CALL PACKAGES_ERROR_MSG(
     &                  'ICEFRONT', ' ', myThid )
#endif

#ifdef ALLOW_THSICE
      IF ( useThSIce ) CALL THSICE_CHECK( myThid )
#else
      IF ( useThSIce ) CALL PACKAGES_ERROR_MSG( 'ThSIce', ' ', myThid )
#endif

#ifdef ALLOW_LAND
      IF ( useLand ) CALL LAND_CHECK( myThid )
#else
      IF ( useLand ) CALL PACKAGES_ERROR_MSG( 'Land', ' ', myThid )
#endif

#ifndef ALLOW_ATM2D
      IF ( useATM2d ) CALL PACKAGES_ERROR_MSG( 'ATM2d', ' ', myThid )
#endif

#ifndef ALLOW_AIM
      IF ( useAIM ) CALL PACKAGES_ERROR_MSG( 'AIM', ' ', myThid )
#endif

#ifdef ALLOW_ATM_PHYS
      IF ( useAtm_Phys ) CALL ATM_PHYS_CHECK( myThid )
#else
      IF ( useAtm_Phys ) CALL PACKAGES_ERROR_MSG(
     &                  'Atm_Phys', ' ', myThid )
#endif

#ifndef ALLOW_FIZHI
      IF ( useFizhi ) CALL PACKAGES_ERROR_MSG( 'Fizhi', ' ', myThid )
#endif

#ifndef ALLOW_GRIDALT
      IF ( useGridAlt ) CALL PACKAGES_ERROR_MSG(
     &                  'GridAlt', ' ', myThid )
#endif

#ifdef ALLOW_AUTODIFF
      IF ( useAUTODIFF ) CALL AUTODIFF_CHECK( myThid )
#endif

#ifdef ALLOW_CTRL
      IF ( useCTRL ) CALL CTRL_CHECK( myThid )
#endif

#ifdef ALLOW_COST
      CALL COST_CHECK( myThid )
#endif

#ifdef ALLOW_ECCO
      IF ( useECCO ) CALL ECCO_CHECK( myThid )
#endif

#ifndef ALLOW_SMOOTH
      IF ( useSMOOTH ) CALL PACKAGES_ERROR_MSG( 'SMOOTH', ' ', myThid )
#endif

#ifndef ALLOW_PROFILES
      IF ( usePROFILES ) CALL PACKAGES_ERROR_MSG(
     &                  'PROFILES', ' ', myThid )
#endif

#ifndef ALLOW_OBSFIT
      IF ( useOBSFIT ) CALL PACKAGES_ERROR_MSG( 'OBSFIT', ' ', myThid )
#endif

#ifdef ALLOW_GRDCHK
      IF ( useGrdChk ) CALL GRDCHK_CHECK( myThid )
#else
      IF ( useGrdChk ) CALL PACKAGES_ERROR_MSG( 'GrdChk', ' ', myThid )
#endif

#ifdef ALLOW_SBO
      IF ( useSBO ) CALL SBO_CHECK( myThid )
#else
      IF ( useSBO ) CALL PACKAGES_ERROR_MSG( 'SBO', ' ', myThid )
#endif

#ifdef ALLOW_DIAGNOSTICS
      IF ( useDiagnostics ) CALL DIAGNOSTICS_CHECK( myThid )
#else
      IF ( useDiagnostics )
     &   CALL PACKAGES_ERROR_MSG( 'Diagnostics', ' ', myThid )
#endif

#ifdef ALLOW_REGRID
      IF ( useREGRID ) CALL REGRID_CHECK( myThid )
#else
      IF ( useREGRID ) CALL PACKAGES_ERROR_MSG( 'REGRID', ' ', myThid )
#endif

#ifdef ALLOW_LAYERS
      IF ( useLayers ) CALL LAYERS_CHECK( myThid )
#else
      IF ( useLayers ) CALL PACKAGES_ERROR_MSG( 'LAYERS', ' ', myThid )
#endif /* ALLOW_LAYERS */

#ifdef ALLOW_NEST_CHILD
      IF ( useNEST_CHILD ) CALL NEST_CHILD_CHECK( myThid )
#else
      IF ( useNEST_CHILD ) CALL PACKAGES_ERROR_MSG(
     &                  'NEST_CHILD', ' ', myThid )
#endif

#ifdef ALLOW_NEST_PARENT
      IF ( useNEST_PARENT ) CALL NEST_PARENT_CHECK( myThid )
#else
      IF ( useNEST_PARENT ) CALL PACKAGES_ERROR_MSG(
     &                  'NEST_PARENT', ' ', myThid )
#endif

#ifdef ALLOW_OASIS
      IF ( useOASIS ) CALL OASIS_CHECK( myThid )
#else
      IF ( useOASIS ) CALL PACKAGES_ERROR_MSG( 'OASIS', ' ', myThid )
#endif

#ifdef ALLOW_RUNCLOCK
      IF ( useRunClock ) CALL RUNCLOCK_CHECK( myThid )
#else
      IF ( useRunClock ) CALL PACKAGES_ERROR_MSG(
     &                  'RunClock', ' ', myThid )
#endif

#ifndef ALLOW_EMBED_FILES
      IF ( useEMBED_FILES ) CALL PACKAGES_ERROR_MSG(
     &                  'EMBED_FILES', ' ', myThid )
#endif

#ifdef ALLOW_MYPACKAGE
      IF ( useMYPACKAGE ) CALL MYPACKAGE_CHECK( myThid )
#else
      IF ( useMYPACKAGE ) CALL PACKAGES_ERROR_MSG(
     &                  'MYPACKAGE', ' ', myThid )
#endif

#ifdef ALLOW_GENERIC_ADVDIFF
C-    Check generic AdvDiff setting and related overlap minimum size:
C     for this reason, called after other ${pkg}_check S/R
      IF ( useGAD ) CALL GAD_CHECK( myThid )
#endif

C---  Exclusive packages (which cannot be used together):
      IF ( useEXF .AND. useBulkForce ) THEN
        WRITE(msgBuf,'(2A)') 'PACKAGES_CHECK: ',
     &  'both useEXF and useBulkForce are set'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(2A)') 'PACKAGES_CHECK: ',
     &  ' but cannot be used together => need to select only one.'
        CALL PRINT_ERROR( msgBuf, myThid )
        CALL ALL_PROC_DIE( myThid )
        STOP 'ABNORMAL END: S/R PACKAGES_CHECK'
      ENDIF

C---  Exclusive packages (which cannot be used together):
      IF ( useDOWN_SLOPE .AND. useBBL ) THEN
        WRITE(msgBuf,'(2A)') 'PACKAGES_CHECK: ',
     &  'both useDOWN_SLOPE and useBBL are set'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(2A)') 'PACKAGES_CHECK: ',
     &  ' but cannot be used together => need to select only one.'
        CALL PRINT_ERROR( msgBuf, myThid )
        CALL ALL_PROC_DIE( myThid )
        STOP 'ABNORMAL END: S/R PACKAGES_CHECK'
      ENDIF

      RETURN
      END

#include "DIAG_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

CBOP 0
C     !ROUTINE: DIAGNOSTICS_IS_ON

C     !INTERFACE:
      LOGICAL FUNCTION DIAGNOSTICS_IS_ON( diagName, myThid )

C     !DESCRIPTION:
C     *==========================================================*
C     | FUNCTION DIAGNOSTIC_IS_ON
C     | o Return TRUE if diagnostics "diagName" is Active
C     *==========================================================*

C     !USES:
      IMPLICIT NONE
#include "EEPARAMS.h"
#include "SIZE.h"
#include "DIAGNOSTICS_SIZE.h"
#include "DIAGNOSTICS.h"

C     !INPUT PARAMETERS:
C     diagName   ::  diagnostic identificator name (8 characters long)
C     myThid     ::  my thread Id number
      CHARACTER*8  diagName
      INTEGER      myThid
CEOP

C     !LOCAL VARIABLES:
      INTEGER n,m
      INTEGER ip,iSp
      INTEGER bi,bj

      DIAGNOSTICS_IS_ON = .FALSE.
      bi = myBxLo(myThid)
      bj = myByLo(myThid)

C-    search for this diag. in the active 2D/3D diagnostics list
      DO n=1,nlists
       DO m=1,nActive(n)
        IF ( diagName.EQ.flds(m,n) .AND. idiag(m,n).NE.0 ) THEN
          ip = ABS(idiag(m,n))
          IF ( ndiag(ip,bi,bj).GE.0 ) DIAGNOSTICS_IS_ON = .TRUE.
        ENDIF
       ENDDO
      ENDDO

      IF ( .NOT.DIAGNOSTICS_IS_ON ) THEN
C-    search for this diag. in the active statistics-diagnostics list
       DO n=1,diagSt_nbLists
        DO m=1,diagSt_nbActv(n)
         IF ( diagName.EQ.diagSt_Flds(m,n)
     &               .AND.iSdiag(m,n).NE.0 ) THEN
           iSp = ABS(iSdiag(m,n))
           IF (qSdiag(0,0,iSp,bi,bj).GE.0.) DIAGNOSTICS_IS_ON = .TRUE.
         ENDIF
        ENDDO
       ENDDO
      ENDIF

      RETURN
      END

#include "FIZHI_OPTIONS.h"

C--  File fizhi_turb.F:
C--   Contents
C--   o TURBIO
C--   o TRBFLX
C--   o SFCFLX
C--   o PHI
C--   o PSI
C--   o TRBLEN
C--   o TRBITP
C--   o TRBL20
C--   o TRBL25
C--   o TRBDIF
C--   o VTRI0
C--   o VTRI1
C--   o VTRI2
C--   o LINADJ
C--   o ZCSUB
C--   o SEAICE

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      SUBROUTINE TURBIO (im,jm,nlay,istrip,nymd,nhms,bi,bj, qbeg
     1 ,ndturb,nltop,ptop, pz, uz, vz, tz, qz, ntracers,ptracers
     2 ,plz,plze,dpres,pkht,pkz,ctmt,xxmt,yymt,zetamt,xlmt,khmt,tke
     3 ,tgz,fracland,landtype
     4 ,tcanopy,ecanopy,tdeep,swetshal,swetroot,swetdeep,snodep,capac
     5 ,nchp,nchptot,nchplnd,chfr,chlt,chlon,igrd,ityp,alai,agrn,thkz
     6 ,tprof
     8 ,duturb, dvturb, dtturb,dqturb,radlwg,st4,dst4,radswg,radswt
     9 ,fdifpar,fdirpar,rainlsp,rainconv,snowfall,tempref
     1 ,imstturblw,imstturbsw,qliqavelw,qliqavesw,fccavelw,fccavesw
     2 ,qqgrid,myid)
C-----------------------------------------------------------------------
C subroutine turbio - model interface routine to trbflx, the turbulence
C        parameterization, and tile, the land surface parameterization
C  input:
C      im      - number of points in the longitude direction
C      jm      - number of points in the latitude direction
C      nlay    - number of vertical levels
C      istrip  - number of horizontal points to be handled at a time on
C      nymd    - year and date integer in YYMMDD format (ie, 790212)
C      nhms    - date and time integer in HHMMSS format (ie, 123000)
C      qbeg    - set to true to indicate a cold start for turbulence
C      ndturb  - turbulence time step integer in HHMMSS format
C      nltop   - Top level at which to allow turbulence
C      ptop    - model top pressure - rigid lid assumed - real
C      pz      - surface pressure minus ptop in mb - real[lon,lat]
C      uz      - zonal wind in m/sec - real[lon,lat,level]
C      vz      - meridional wind in m/sec - real[lon,lat,level]
C      tz      - model theta (theta [deg K]/p0**k) - real[lon,lat,level]
C      qz      - specific humidity in kg/kg - real[lon,lat,level]
C      ntracers- total number of tracers - integer
C      ptracers- number of permanent tracers - integer
C      pkht    - pressure[mb]**k at bottom edges of levels - real[lon,lat,level]
C      fracland- not being used - real[lon,lat]
C      landtype- not being used - integer[lon,lat]
C      nchp    - nchplnd<nchp - total no chips (ocean too) - integer
C      nchplnd - <=nchp - number of land chips - integer
C      chfr    - chip fraction - real[nchp]
C      chlt    - tile space latitude array - real[nchp]
C      chlon   - tile space longitude array - real[nchp]
C      igrd    - tile space grid number - integer[nchp]
C      ityp    - tile space vegetation type - integer[nchp]
C      alai    - leaf area index - real[nchp]
C      agrn    - greenness fraction - real[nchp]
C      thkz    - sea ice thickness in m (0. for no ice) - real[lon,lat]
C      tprof   - logical flag for point by point diagnostic output
C      radlwg  - net longwave flux at ground (up-down) in w/m**2 - real[lon,lat]
C      st4     - upward longwave flux at ground in w/m**2 - real[lon,lat]
C      dst4    - delta-sigma-T**4, ie, derivative of upward lw flux at
C                ground with respect to ground Temperature - real[lon,lat]
C      radswg  - net shortwave flux at ground (down-up) NON-DIM - real[lon,lat]
C                  {NOTE: this field is divided by the incident shortwave
C                     at the top of the atmosphere to non-dimensionalize]
C      radswt  - incident shortwave at top of atmos in W/m**2 - real[lon,lat]
C      fdifpar - incident diffuse-beam PAR at surface in W/m**2 - real[lon,lat]
C      fdirpar - incident direct-beam PAR at surface in W/m**2 - real[lon,lat]
C      rainlsp - large-scale (frontal,supersat) rainfall in mm/sec - real[lon,lat]
C      rainconv- convective rainfall rate in mm/sec - real[lon,lat]
C      snowfall- total snowfall rate in mm/sec - real[lon,lat]
C updated:
C      tke     - turbulent k.e. in m**2/s**2 - real[tiles,levels]
C      tgz     - surface skin temperature in deg K - real[lon,lat]
C      tcanopy - canopy temperature in deg K real[tiles]
C                 (sea surface temp over the ocean tiles)
C      ecanopy - canopy vapor pressure in mb real[tiles]
C                 (qstar at tground over the sea ice and ocean tiles)
C      tdeep   - deep soil temp in deg K real[tiles]
C      swetshal- shallow level moisture field capacity fraction real[tiles]
C      swetroot- root level moisture field capacity fraction real[tiles]
C      swetdeep- deep soil level moisture field capacity fraction real[tiles]
C      snodep  - depth of snow pack in cm liquid water equiv real[tiles]
C      capac   - leaf canopy water reservoir in cm real[tiles]
C output:
C      duturb  - change in zonal wind component due to turbulent processes
C                per unit time in m/sec**2 - real[lon,lat,levels]
C      dvturb  - change in meridional wind component due to turbulent processes
C                per unit time in m/sec**2 - real[lon,lat,levels]
C      dtturb  - change in (model theta*pi) due to turbulent processes
C                per unit time  - real[lon,lat,levels] !! pi is pressure-ptop
C      dqturb  - change in (specific humidity*pi) due to turbulent processes
C                per unit time  - real[lon,lat,levels] !! pi is pressure-ptop
C      qliqavelw - Moist   Turbulence Liquid Water   for Longwave  - real[lon,lat,levels]
C      qliqavesw - Moist   Turbulence Liquid Water   for Shortwave - real[lon,lat,levels]
C      fccavelw  - Moist   Turbulence Cloud Fraction for Longwave  - real[lon,lat,levels]
C      fccavesw  - Moist   Turbulence Cloud Fraction for Shortwave - real[lon,lat,levels]
C      qqgrid    - Gridded Turbulent Kinetic Energy                - real[lon,lat,levels]
C-----------------------------------------------------------------------
      implicit none

      integer im,jm,nlay,istrip,nymd,nhms,bi,bj,ndturb,nltop
      integer ntracers, ptracers
      integer nchp,nchptot,nchplnd
      logical qbeg
      _RL ptop
      _RL pz(im*jm,1),uz(im*jm,1,nlay),vz(im*jm,1,nlay)
      _RL tz(im*jm,1,nlay),qz(im*jm,1,nlay,ntracers)
      _RL plz(im*jm,1,nlay),plze(im*jm,1,nlay+1),dpres(im*jm,1,nlay)
      _RL pkht(im*jm,1,nlay+1),pkz(im*jm,1,nlay)
      _RL ctmt(nchp),xxmt(nchp),yymt(nchp),zetamt(nchp)
      _RL xlmt(nchp,nlay),khmt(nchp,nlay),tke(nchp,nlay)
      _RL tgz(im*jm,1),fracland(im*jm,1)
      integer landtype(im*jm,1)
      _RL tcanopy(nchp),tdeep(nchp),ecanopy(nchp),swetshal(nchp)
      _RL swetroot(nchp),swetdeep(nchp),snodep(nchp),capac(nchp)
      _RL chfr(nchp),chlt(nchp),chlon(nchp)
      integer igrd(nchp),ityp(nchp)
      _RL alai(nchp),agrn(nchp),thkz(im*jm,1)
      logical tprof
      _RL duturb(im*jm,1,nlay),dvturb(im*jm,1,nlay)
      _RL dtturb(im*jm,1,nlay),dqturb(im*jm,1,nlay,ntracers)
      _RL st4(im*jm,1),dst4(im*jm,1)
      _RL radswg(im*jm,1),radswt(im*jm,1),radlwg(im*jm,1)
      _RL fdifpar(im*jm,1),fdirpar(im*jm,1)
      _RL rainlsp(im*jm,1),rainconv(im*jm,1),snowfall(im*jm,1)
      _RL tempref (im*jm,1)
      integer imstturblw, imstturbsw
      _RL qliqavesw(im*jm,1,nlay),qliqavelw(im*jm,1,nlay)
      _RL fccavelw (im*jm,1,nlay),fccavesw (im*jm,1,nlay)
      _RL qqgrid   (im*jm,1,nlay)
      integer myid

C Local Variables

      integer numstrips
      integer ijall
      _RL fmu,hice,tref,pref,cti,ed
C Set fmu and ed to zero for no background diffusion
      parameter ( fmu    = 0.00000    )
      parameter ( hice   =   300.     )
      parameter ( tref   =   258.     )
      parameter ( pref   =   500.     )
      parameter ( cti    =   0.0052   )
      parameter ( ed     =   0.0      )

      _RL qliqtmp(im*jm,1,nlay)
      _RL  fcctmp(im*jm,1,nlay)
      _RL tmpdiag(im*jm,1), tmpFac
      _RL   thtgz(im*jm)
      logical  diagnostics_is_on
      external diagnostics_is_on

      integer nland
      _RL alwcoeff(nchp),blwcoeff(nchp)
      _RL netsw(nchp)
      _RL cnvprec(nchp),lsprec(nchp)
      _RL snowprec(nchp)
      _RL pardiff(nchp),pardirct(nchp)
      _RL pmsc(nchp)
      _RL netlw(nchp)
      _RL sqscat(nchp), rsoil1(nchp)
      _RL rsoil2(nchp)
      _RL rdc(nchp),u2fac(nchp)
      _RL z2ch(nchp)
      _RL zoch(nchp),cdrc(nchp)
      _RL cdsc(nchp)
      _RL dqsdt(nchp)
      _RL tground(nchp),qground(nchp)
      _RL utility(nchp)
      _RL    qice(nchp)
      _RL   dqice(nchp)

      _RL dumsc(nchp,nlay),dvmsc(nchp,nlay)
      _RL dtmsc(nchp,nlay),dqmsc(nchp,nlay,ntracers)

      _RL shg(nchp),z0(nchp),icethk(nchp)
      integer water(nchp)

      _RL lats(istrip),lons(istrip),cosz(istrip),icest(istrip)
      _RL rainls(istrip),raincon(istrip),newsnow(istrip)
      _RL pardf(istrip),pardr(istrip),swnet(istrip)
      _RL hlwdwn(istrip),alwrad(istrip),blwrad(istrip)
      _RL tmpnlay(istrip)
      _RL laistrip(istrip),grnstrip(istrip),z2str(istrip),cd(istrip)
      _RL scatstr(istrip), rs1str(istrip), rs2str(istrip)
      _RL rdcstr(istrip),u2fstr(istrip),dqsdtstr(istrip)
      _RL eturb(istrip),dedqa(istrip),dedtc(istrip)
      _RL hsturb(istrip),dhsdqa(istrip),dhsdtc(istrip)
      _RL savetc(istrip),saveqa(istrip),lwstrip(istrip)
      _RL chfrstr(istrip),psurf(istrip),shgstr(istrip)
      integer types(istrip),igrdstr(istrip)
      _RL evap(istrip),shflux(istrip),runoff(istrip),bomb(istrip)
      _RL eint(istrip),esoi(istrip),eveg(istrip),esno(istrip)
      _RL smelt(istrip),hlatn(istrip),hlwup(istrip),gdrain(istrip)
      _RL runsrf(istrip),fwsoil(istrip),evpot(istrip)
      _RL strdg1(istrip),strdg2(istrip),strdg3(istrip),strdg4(istrip)
      _RL strdg5(istrip),strdg6(istrip),strdg7(istrip),strdg8(istrip)
      _RL strdg9(istrip),tmpstrip(istrip),qicestr(istrip)
      _RL dqicestr(istrip)

      _RL u(istrip,nlay+1), v(istrip,nlay+1), th(istrip,nlay+1)
      _RL sh(istrip,nlay+1), thv(istrip,nlay+1), pe(istrip,nlay+1)
      _RL tracers(istrip,nlay+1,ntracers)
      _RL dpstr(istrip,nlay),pke(istrip,nlay+1)
      _RL pk(istrip,nlay), qq(istrip,nlay),   p(istrip,nlay)
      _RL sri(istrip,nlay), skh(istrip,nlay), skm(istrip,nlay)
      _RL stuflux(istrip,nlay), stvflux(istrip,nlay)
      _RL sttflux(istrip,nlay), stqflux(istrip,nlay)
      _RL frqtrb(istrip,nlay-1)
      _RL dshdthg(istrip,nlay),dthdthg(istrip,nlay)
      _RL dshdshg(istrip,nlay),dthdshg(istrip,nlay)
      _RL transth(istrip,nlay), transsh(istrip,nlay)

      _RL tc(istrip),td(istrip),qa(istrip)
      _RL swet1(istrip),swet2(istrip),swet3(istrip)
      _RL capacity(istrip),snowdepth(istrip)
      _RL stz0(istrip)
      _RL stdiag(istrip)
      _RL tends(istrip),sustar(istrip), sz0(istrip),pbldpth(istrip)
      _RL sct(istrip), scu(istrip), swinds(istrip)
      _RL stu2m(istrip),stv2m(istrip),stt2m(istrip),stq2m(istrip)
      _RL stu10m(istrip),stv10m(istrip),stt10m(istrip),stq10m(istrip)
      integer  stwatr(istrip)
      _RL  wspeed(istrip)

      _RL ctsave(istrip),xxsave(istrip),yysave(istrip)
      _RL zetasave(istrip)
      _RL xlsave(istrip,nlay),khsave(istrip,nlay)
      _RL qliq(istrip,nlay),turbfcc(istrip,nlay)
      _RL qliqmsc(nchp,nlay),fccmsc(nchp,nlay)

      _RL pi,secday,sdayopi2,rgas,akap,cp,alhl
      _RL faceps,grav,caltoj,virtcon,getcon
      _RL heatw,undef,timstp,delttrb,dttrb,ra
      _RL edle,rmu,cltj10,atimstp,tice,const
      integer istnp1,istnlay,itrtrb,i,L,nn,nt
      integer nocean, nice
      integer ndmoist,time_left, ndum0,ndum1
      integer ntracedim
      _RL    dtfac,timstp2

      integer n,nsecf,nmonf,ndayf
      nsecf(n) = n/10000*3600 + mod(n,10000)/100* 60 + mod(n,100)
      nmonf(n) = mod(n,10000)/100
      ndayf(n) = mod(n,100)

#ifdef FIZHI_CRAY
#ifdef FIZHI_F77_COMPIL
cfpp$ expand (qsat)
#endif
#endif

C   compute variables that do not change

       pi = 4.*atan(1.)
       secday   = getcon('SDAY')
       sdayopi2 = getcon('SDAY') / (pi*2.)
       rgas     = getcon('RGAS')
       akap     = getcon('KAPPA')
       cp       = getcon('CP')
       alhl     = getcon('LATENT HEAT COND')
       faceps   = getcon('EPSFAC')
       grav     = getcon('GRAVITY')
       caltoj   = getcon('CALTOJ')
       virtcon  = getcon('VIRTCON')
       heatw    = getcon('HEATW')
       undef    = getcon('UNDEF')
       ntracedim= max(ntracers-ptracers,1)

       call get_alarm ( 'moist',ndum0,ndum1,ndmoist,time_left )
       timstp   = nsecf(ndturb)
       timstp2  = nsecf(ndmoist)
       dtfac    = min( 1.0 _d 0, timstp/timstp2 )

C delttrb is the internal turbulence time step
C a value equal to ndturb means one internal iteration
       delttrb = nsecf(ndturb)

       ijall    =   im * jm
       istnp1   =   istrip * (nlay+1)
       istnlay  =   istrip * nlay
       itrtrb   = ( timstp / delttrb ) + 0.1
       dttrb    =   timstp / float(itrtrb)
       edle     =   ed * 0.2

C   coefficient of viscosity (background momentum diffusion)

       rmu     = fmu * tref * rgas / pref
       cltj10  = 10. * caltoj
       atimstp = 1. / timstp
       tice = getcon('FREEZING-POINT')

C **********************************************************************
C                            Initialization
C **********************************************************************

C Initialize diagnostic for ground temperature change
C ---------------------------------------------------
      tmpFac = -1.
      CALL DIAGNOSTICS_SCALE_FILL( tgz,tmpFac,1,
     &                             'DTG     ',0,1,-3,bi,bj,myid)

C **********************************************************************
C  entire turbulence and land surface package will run in 'tile space'
C       do conversion of model state variables to tile space
C        (ocean points appended to tile space land point arrays)
C **********************************************************************

      numstrips   = ((nchptot-1)/istrip) + 1

      call grd2msc(pz(1,1),im,jm,igrd,pmsc,nchp,nchptot)

      call grd2msc(tgz,im,jm,igrd,tground,nchp,nchptot)
      do i = 1,ijall
       tmpdiag(i,1) = st4(i,1) + dst4(i,1)*(tgz(i,1)-tempref(i,1))
     1                         - dst4(i,1)* tgz(i,1)
      enddo
      call grd2msc(tmpdiag,im,jm,igrd,alwcoeff,nchp,nchptot)
      do i = 1,ijall
       tmpdiag(i,1) = dst4(i,1)
      enddo
      call grd2msc(tmpdiag,im,jm,igrd,blwcoeff,nchp,nchptot)
      do i = 1,ijall
       tmpdiag(i,1) = fdifpar(i,1) * radswt(i,1)
      enddo
      call grd2msc(tmpdiag,im,jm,igrd,pardiff,nchp,nchptot)
      do i = 1,ijall
       tmpdiag(i,1) = fdirpar(i,1) * radswt(i,1)
      enddo
      call grd2msc(tmpdiag,im,jm,igrd,pardirct,nchp,nchptot)
      do i = 1,ijall
       tmpdiag(i,1) = radswg(i,1) * radswt(i,1)
      enddo
      call grd2msc(tmpdiag,im,jm,igrd,netsw,nchp,nchptot)
      do i = 1,ijall
       tmpdiag(i,1) = radlwg(i,1) + dst4(i,1)*(tgz(i,1)-tempref(i,1))
      enddo
      call grd2msc(tmpdiag,im,jm,igrd,netlw,nchp,nchptot)
      call grd2msc(thkz,im,jm,igrd,icethk,nchp,nchptot)
      call grd2msc(rainlsp,im,jm,igrd,lsprec,nchp,nchptot)
      call grd2msc(rainconv,im,jm,igrd,cnvprec,nchp,nchptot)
      call grd2msc(snowfall,im,jm,igrd,snowprec,nchp,nchptot)

C Call chpprm to get non-varying vegetation and soil characteristics

      call chpprm(nymd,nhms,nchp,nchplnd,chlt,ityp,alai,
     1       agrn,zoch,z2ch,cdrc,cdsc,sqscat,u2fac,rsoil1,rsoil2,rdc)

C **********************************************************************
C ****                surface specification                         ****
C **********************************************************************

C   set water

      do i = 1,nchptot
       water(i) = 0
       if((ityp(i).eq.100).and.(icethk(i).eq.0. ))water(i) = 1
      enddo

C   roughness length z0

      do i =1,nchptot
       if (icethk(i).gt.0.) then
        z0(i) = 1.e-4
       else if (ityp(i).eq.100) then
        z0(i) = 3.e-4
       else
        z0(i) = zoch(i)
       endif
      enddo

C Fill Array Tground with canopy temperatures over land tiles
C  (it has sst from the tgz array over the sea ice and ocean tiles)

      do i = 1,nchplnd
       tground(i) = tcanopy(i)
      enddo

C value of sh at ground
C ---------------------
      do I =1,nchptot
      utility(I) = pmsc(i) + ptop
      call qsat ( tground(i),utility(i),shg(i),dqsdt(i),.true. )
      enddo

C Fill Array Qground with canopy air specific humidity over land tiles
C  (it has qstar at tground over the sea ice and ocean tiles)

      do i = 1,nchplnd
       qground(i) = ecanopy(i)
      enddo
      do i = nchplnd+1,nchptot
       qground(i) = shg(i)
      enddo

C Fill Array Swetshal with Value 1. over oceans and sea ice
      do i = nchplnd+1,nchptot
       swetshal(i) = 1.
      enddo

C compute heat conduction through ice
C -----------------------------------
      const = ( cti / hice ) * cltj10
      do i =1,nchptot
             qice(i) =  0.0
            dqice(i) =  0.0
       if( icethk(i).gt.0.0 ) then
             qice(i) =  const*(tice-tground(i))
            dqice(i) = -const
       endif
      enddo

      if(diagnostics_is_on('QICE    ',myid) ) then
       do i =1,ijall
        tmpdiag(i,1) = 0.0
       enddo
       call msc2grd (igrd,chfr,qice,nchp,nchptot,fracland,tmpdiag,im,jm)
       call diagnostics_fill(tmpdiag,'QICE    ',0,1,3,bi,bj,myid)
      endif

C***********************************************************************
C                        loop over regions
C***********************************************************************

      do 2000 nn = 1, numstrips

       call strip2tile(uz,igrd,u,nchp,ijall,istrip,nlay,nn)
       call strip2tile(vz,igrd,v,nchp,ijall,istrip,nlay,nn)
       call strip2tile(tz,igrd,th,nchp,ijall,istrip,nlay,nn)
       call strip2tile(qz(1,1,1,1),igrd,sh,nchp,ijall,istrip,nlay,nn)
       call strip2tile(dpres,igrd,dpstr,nchp,ijall,istrip,nlay,nn)
       call strip2tile(plz,igrd,p,nchp,ijall,istrip,nlay,nn)
       call strip2tile(plze,igrd,pe,nchp,ijall,istrip,nlay+1,nn)
       call strip2tile(pkz,igrd,pk,nchp,ijall,istrip,nlay,nn)
       call strip2tile(pkht,igrd,pke,nchp,ijall,istrip,nlay+1,nn)
c      do nt = 1,ntracers-ptracers
c      call strip2tile(qz(1,1,1,ptracers+nt),igrd,tracers(1,1,nt),nchp,
c    1                                             ijall,istrip,nlay,nn)
c      enddo

       call stripit  (z0,stz0,nchptot,nchp,istrip,1,nn)
       call stripit  (tground,th(1,nlay+1),nchptot,nchp,istrip,1,nn)
       call stripit  (pmsc,pe(1,nlay+1),nchptot,nchp,istrip,1,nn)
       call stripit  (tke,qq,nchptot,nchp,istrip,nlay-1,nn)
       call stripit  (ctmt,ctsave,nchptot,nchp,istrip,1,nn)
       call stripit  (xxmt,xxsave,nchptot,nchp,istrip,1,nn)
       call stripit  (yymt,yysave,nchptot,nchp,istrip,1,nn)
       call stripit  (zetamt,zetasave,nchptot,nchp,istrip,1,nn)
       call stripit  (xlmt,xlsave,nchptot,nchp,istrip,nlay,nn)
       call stripit  (khmt,khsave,nchptot,nchp,istrip,nlay,nn)
       call stripitint (water,stwatr,nchptot,nchp,istrip,1,nn)

       call stripitint (igrd,igrdstr,nchptot,nchp,istrip,1,nn)
       call stripit  (chfr,chfrstr,nchptot,nchp,istrip,1,nn)
       call stripit  (icethk,icest,nchptot,nchp,istrip,1,nn)
       call stripit  (pardiff,pardf,nchptot,nchp,istrip,1,nn)
       call stripit  (pardirct,pardr,nchptot,nchp,istrip,1,nn)
       call stripit  (chlt,lats,nchptot,nchp,istrip,1,nn)
       call stripit  (chlon,lons,nchptot,nchp,istrip,1,nn)
       call stripit  (lsprec,rainls,nchptot,nchp,istrip,1,nn)
       call stripit  (cnvprec,raincon,nchptot,nchp,istrip,1,nn)
       call stripit  (snowprec,newsnow,nchptot,nchp,istrip,1,nn)
       call stripit  (netsw,swnet,nchptot,nchp,istrip,1,nn)
       call stripit  (netlw,lwstrip,nchptot,nchp,istrip,1,nn)
       call stripit  (alwcoeff,alwrad,nchptot,nchp,istrip,1,nn)
       call stripit  (blwcoeff,blwrad,nchptot,nchp,istrip,1,nn)
       call stripit  (alai,laistrip,nchptot,nchp,istrip,1,nn)
       call stripit  (agrn,grnstrip,nchptot,nchp,istrip,1,nn)
       call stripit  (z2ch,z2str,nchptot,nchp,istrip,1,nn)
       call stripit  (sqscat,scatstr,nchptot,nchp,istrip,1,nn)
       call stripit  (rsoil1,rs1str,nchptot,nchp,istrip,1,nn)
       call stripit  (rsoil2,rs2str,nchptot,nchp,istrip,1,nn)
       call stripit  (rdc,rdcstr,nchptot,nchp,istrip,1,nn)
       call stripit  (u2fac,u2fstr,nchptot,nchp,istrip,1,nn)
       call stripit  (shg,shgstr,nchptot,nchp,istrip,1,nn)
       call stripit  (dqsdt,dqsdtstr,nchptot,nchp,istrip,1,nn)
       call stripit  ( qice, qicestr,nchptot,nchp,istrip,1,nn)
       call stripit  (dqice,dqicestr,nchptot,nchp,istrip,1,nn)
       call stripitint (ityp,types,nchptot,nchp,istrip,1,nn)

       call stripit  (tground,tc,nchptot,nchp,istrip,1,nn)
       call stripit  (tdeep,td,nchptot,nchp,istrip,1,nn)
       call stripit  (qground,qa,nchptot,nchp,istrip,1,nn)
       call stripit  (swetshal,swet1,nchptot,nchp,istrip,1,nn)
       call stripit  (swetroot,swet2,nchptot,nchp,istrip,1,nn)
       call stripit  (swetdeep,swet3,nchptot,nchp,istrip,1,nn)
       call stripit  (snodep,snowdepth,nchptot,nchp,istrip,1,nn)
       call stripit  (capac,capacity,nchptot,nchp,istrip,1,nn)

#ifdef FIZHI_USE_FIXED_DAY
       call astro ( 20040321,nhms,lats,lons,istrip,cosz,ra )
#else
       call astro ( nymd,nhms,lats,lons,istrip,cosz,ra )
#endif

C we need to count up the land, sea ice and ocean points
      nocean = 0
      nland  = 0
      nice   = 0
      do i = 1,istrip
       if( types(i).lt.100 ) nland  = nland  + 1
       if( types(i).eq.100 ) nocean = nocean + 1
       if( types(i).eq.100 .and. icest(i).gt.0.0 ) nice = nice + 1
      enddo

C Zero out velocities at the bottom edge of the model
C ---------------------------------------------------
      do i =1,istrip
       u(i,nlay+1) = 0.
       v(i,nlay+1) = 0.
      enddo

C convert temperature of level nlay+1 to theta & value of sh at ground
C --------------------------------------------------------------------
      do i =1,istrip
      th(i,nlay+1) = th(i,nlay+1) / pke(i,nlay+1)
      sh(i,nlay+1) = qa(i)
      enddo

      if(diagnostics_is_on('QG      ',myid) ) then
      do i=1,istrip
      tmpstrip(i) = sh(i,nlay+1)*1000
      enddo
      call diag_vegtile_fill (tmpstrip,igrd,chfrstr,istrip,nchp,nn,
     & .false., 'QG      ', 1, 1, bi, bj, myid)
      endif

C value of tracers at the ground
C ------------------------------
c     do nt = 1,ntracers-ptracers
c      do i = 1,istrip
c       tracers(i,nlay+1,nt) = 0.
c      enddo
c     enddo

C compute virtual potential temperatures
C --------------------------------------
      do L = 1,nlay+1
      do i =1,istrip
      thv(i,L) = 1. + virtcon * sh(i,L)
      thv(i,L) = th(i,L) * thv(i,L)
      enddo
      enddo
      do i =1,istrip
      sh(i,nlay+1) = qa(i)
      enddo

C zero out arrays for output of qliq and fcc
      do L =1,nlay
      do i =1,istrip
      qliq(i,L) = 0.
      turbfcc(i,L) = 0.
      enddo
      enddo

C zero out fluxes and derivatives
C -------------------------------
      do i = 1,istrip
       eturb(i) = 0.
       scu(i) = 0.
       dedqa(i) = 0.
       dedtc(i) = 0.
       hsturb(i) = 0.
       dhsdqa(i) = 0.
       dhsdtc(i) = 0.
      enddo

C increment diagnostic arrays for quantities calculated before trbfl
C ------------------------------------------------------------------
      if(diagnostics_is_on('DTSRF   ',myid) ) then
       do i=1,istrip
        stdiag(i) = ( thv(i,nlay+1)-thv(i,nlay) ) / pke(i,nlay+1)
       enddo
       call diag_vegtile_fill (stdiag,igrd,chfrstr,istrip,nchp,nn,
     & .false., 'DTSRF   ', 1, 1, bi, bj, myid)
      endif

C call trbflx
C -----------
      call trbflx(nn,th,thv,sh,u,v,qq,p,pe,pk,pke,dpstr,stwatr,stz0,
     1 tracers,ntracers-ptracers,ntracedim,dttrb,itrtrb,rmu,edle,qbeg,
     2 tprof,stuflux,stvflux,sri,skh,skm,swinds,sustar,sz0,frqtrb,
     3 pbldpth,sct,scu,stu2m,stv2m,stt2m,stq2m,stu10m,stv10m,stt10m,
     4 stq10m,istrip,nlay,nltop,nymd,nhms,grav,cp,rgas,faceps,virtcon,
     5 undef,dshdthg,dshdshg,dthdthg,dthdshg,eturb,dedqa,dedtc,
     6 hsturb,dhsdqa,dhsdtc,transth,transsh,
     7 ctsave,xxsave,yysave,zetasave,xlsave,khsave,qliq,turbfcc)

      call pastit (qq,tke,istrip,nchp,nchptot,nlay,nn)
      call pastit (ctsave,ctmt,istrip,nchp,nchptot,1,nn)
      call pastit (xxsave,xxmt,istrip,nchp,nchptot,1,nn)
      call pastit (yysave,yymt,istrip,nchp,nchptot,1,nn)
      call pastit (zetasave,zetamt,istrip,nchp,nchptot,1,nn)
      call pastit (xlsave,xlmt,istrip,nchp,nchptot,nlay,nn)
      call pastit (khsave,khmt,istrip,nchp,nchptot,nlay,nn)

      call pastit (qliq  ,qliqmsc,istrip,nchp,nchptot,nlay,nn)
      call pastit (turbfcc,fccmsc,istrip,nchp,nchptot,nlay,nn)

C  New diagnostic: potential evapotranspiration
      do i = 1,istrip
       evpot(i) = transsh(i,nlay) * (shgstr(i) - sh(i,nlay))
      enddo

C**********************************************************************
C   Call Land Surface Module
C**********************************************************************

      do i = 1,istrip
       savetc(i) = tc(i)
       saveqa(i) = qa(i)
      enddo
      do i = 1,istrip
       cosz(i) = max(cosz(i),0.0001 _d 0)
       cd(i) = scu(i)*scu(i)
       tmpnlay(i) = th(i,nlay)*pk(i,nlay)
       hlwdwn(i) = alwrad(i)+blwrad(i)*tc(i)-lwstrip(i)
       psurf(i) = pe(i,nlay+1)
       wspeed(i) = sqrt(u(i,nlay)*u(i,nlay) + v(i,nlay)*v(i,nlay))
       if(wspeed(i) .lt. 1.e-20) wspeed(i) = 1.e-20
C Note: This LSM precip bug needs to be cleaned up
c      newsnow(i) = newsnow(i)*dtfac
c      raincon(i) = raincon(i)*dtfac
c      rainls (i) = rainls (i)*dtfac
      enddo

      do i = 1,istrip
       eturb(i) = eturb(i) * pke(i,nlay+1)
       dedqa(i) = dedqa(i) * pke(i,nlay+1)
       hsturb(i) = hsturb(i) * pke(i,nlay+1)
      enddo

      do i = 1,istrip
       strdg1(i) = 0.
       strdg2(i) = 0.
       strdg3(i) = 0.
       strdg4(i) = 0.
       strdg5(i) = 0.
       strdg6(i) = 0.
       strdg7(i) = 0.
       strdg8(i) = 0.
       strdg9(i) = 0.
       bomb(i)   = 0.
       runoff(i) = 0.
       eint(i)   = 0.
       esoi(i)   = 0.
       eveg(i)   = 0.
       esno(i)   = 0.
       smelt(i)  = 0.
       hlatn(i)  = 0.
       hlwup(i)  = 0.
       gdrain(i) = 0.
       runsrf(i) = 0.
       fwsoil(i) = 0.
      enddo

C**********************************************************************
C   diagnostics: fill arrays for lsm input fields
C**********************************************************************
      if(diagnostics_is_on('SNOWFALL',myid) ) then
      do i = 1,istrip
      tmpstrip(i) = newsnow(i)*86400
      enddo
      call diag_vegtile_fill (tmpstrip,igrd,chfrstr,istrip,nchp,nn,
     & .false., 'SNOWFALL', 1, 1, bi, bj, myid)
      endif
      if(diagnostics_is_on('RAINCON ',myid) ) then
      do i = 1,istrip
      tmpstrip(i) = raincon(i)*86400
      enddo
      call diag_vegtile_fill (tmpstrip,igrd,chfrstr,istrip,nchp,nn,
     & .false., 'RAINCON ', 1, 1, bi, bj, myid)
      endif
      if(diagnostics_is_on('RAINLSP ',myid) ) then
      do i = 1,istrip
      tmpstrip(i) = rainls(i)*86400
      enddo
      call diag_vegtile_fill (tmpstrip,igrd,chfrstr,istrip,nchp,nn,
     & .false., 'RAINLSP ', 1, 1, bi, bj, myid)
      endif
      if(diagnostics_is_on('GREEN   ',myid) ) then
      call diag_vegtile_fill (grnstrip,igrd,chfrstr,istrip,nchp,nn,
     & .false., 'GREEN   ', 1, 1, bi, bj, myid)
      endif
      if(diagnostics_is_on('LAI     ',myid) ) then
      call diag_vegtile_fill (laistrip,igrd,chfrstr,istrip,nchp,nn,
     & .false., 'LAI     ', 1, 1, bi, bj, myid)
      endif
      if(diagnostics_is_on('PARDR   ',myid) ) then
      call diag_vegtile_fill (pardr,igrd,chfrstr,istrip,nchp,nn,
     & .false., 'PARDR   ', 1, 1, bi, bj, myid)
      endif
      if(diagnostics_is_on('PARDF   ',myid) ) then
      call diag_vegtile_fill (pardf,igrd,chfrstr,istrip,nchp,nn,
     & .false., 'PARDF   ', 1, 1, bi, bj, myid)
      endif
      if(diagnostics_is_on('DLWDTC  ',myid) ) then
      call diag_vegtile_fill (blwrad,igrd,chfrstr,istrip,nchp,nn,
     & .false., 'DLWDTC  ', 1, 1, bi, bj, myid)
      endif
      if(diagnostics_is_on('DHDTC   ',myid) ) then
      call diag_vegtile_fill (dhsdtc,igrd,chfrstr,istrip,nchp,nn,
     & .false., 'DHDTC   ', 1, 1, bi, bj, myid)
      endif
      if(diagnostics_is_on('DEDTC   ',myid) ) then
      call diag_vegtile_fill (dedtc,igrd,chfrstr,istrip,nchp,nn,
     & .false., 'DEDTC   ', 1, 1, bi, bj, myid)
      endif
      if(diagnostics_is_on('DHDQA   ',myid) ) then
      call diag_vegtile_fill (dhsdqa,igrd,chfrstr,istrip,nchp,nn,
     & .false., 'DHDQA   ', 1, 1, bi, bj, myid)
      endif
      if(diagnostics_is_on('DEDQA   ',myid) ) then
      call diag_vegtile_fill (dedqa,igrd,chfrstr,istrip,nchp,nn,
     & .false., 'DEDQA   ', 1, 1, bi, bj, myid)
      endif
      if(diagnostics_is_on('LWGDOWN ',myid) ) then
      call diag_vegtile_fill (hlwdwn,igrd,chfrstr,istrip,nchp,nn,
     & .false., 'LWGDOWN ', 1, 1, bi, bj, myid)
      endif
C**********************************************************************

      if(nland.gt.0)then

       call tile (
     I   nland, timstp, types, rainls, raincon,  newsnow,  wspeed,
     I   eturb,  dedqa,  dedtc,  hsturb, dhsdqa, dhsdtc,
     I   tmpnlay, sh(1,nlay), cd, cosz, pardr, pardf,
     I   swnet,  hlwdwn, psurf, laistrip, grnstrip,  z2str,
     I   scatstr, rs1str, rs2str, rdcstr, u2fstr,
     I   shgstr, dqsdtstr, alwrad, blwrad,
     U   tc, td, qa, swet1, swet2, swet3, capacity, snowdepth,
     O   evap, shflux, runoff, bomb,
     O   eint, esoi, eveg, esno, smelt, hlatn,
     O   hlwup, gdrain, runsrf, fwsoil,
     O   strdg1, strdg2, strdg3, strdg4,
     O   strdg5, strdg6, strdg7, strdg8, strdg9)
      endif

      if( nice.gt.0 ) then
       call seaice ( nocean, timstp,     hice,
     &               eturb(nland+1),    dedtc(nland+1),
     &              hsturb(nland+1),   dhsdtc(nland+1),
     &             qicestr(nland+1), dqicestr(nland+1),
     &               swnet(nland+1),  lwstrip(nland+1), blwrad(nland+1),
     &          pke(nland+1,nlay+1),    icest(nland+1),
     &                  tc(nland+1),       qa(nland+1) )
      endif

C***********************************************************************
C   diagnostics: fill arrays for lsm output fields
C***********************************************************************

      if(diagnostics_is_on('RUNOFF  ',myid) ) then
      call diag_vegtile_fill (runoff,igrd,chfrstr,istrip,nchp,nn,
     & .false., 'RUNOFF  ', 1, 1, bi, bj, myid)
      endif
      if(diagnostics_is_on('FWSOIL  ',myid) ) then
      call diag_vegtile_fill (fwsoil,igrd,chfrstr,istrip,nchp,nn,
     & .false., 'FWSOIL  ', 1, 1, bi, bj, myid)
      endif
      if(diagnostics_is_on('GDRAIN  ',myid) ) then
      call diag_vegtile_fill (gdrain,igrd,chfrstr,istrip,nchp,nn,
     & .false., 'GDRAIN  ', 1, 1, bi, bj, myid)
      endif
      if(diagnostics_is_on('SNOWMELT',myid) ) then
      call diag_vegtile_fill (smelt,igrd,chfrstr,istrip,nchp,nn,
     & .false., 'SNOWMELT', 1, 1, bi, bj, myid)
      endif
      if(diagnostics_is_on('EVEG    ',myid) ) then
      call diag_vegtile_fill (eveg,igrd,chfrstr,istrip,nchp,nn,
     & .false., 'EVEG    ', 1, 1, bi, bj, myid)
      endif
      if(diagnostics_is_on('ESNOW   ',myid) ) then
      call diag_vegtile_fill (esno,igrd,chfrstr,istrip,nchp,nn,
     & .false., 'ESNOW   ', 1, 1, bi, bj, myid)
      endif
      if(diagnostics_is_on('ESOIL   ',myid) ) then
      call diag_vegtile_fill (esoi,igrd,chfrstr,istrip,nchp,nn,
     & .false., 'ESOIL   ', 1, 1, bi, bj, myid)
      endif
      if(diagnostics_is_on('ERESV   ',myid) ) then
      call diag_vegtile_fill (eint,igrd,chfrstr,istrip,nchp,nn,
     & .false., 'ERESV   ', 1, 1, bi, bj, myid)
      endif
      if(diagnostics_is_on('EVPOT   ',myid) ) then
      call diag_vegtile_fill (evpot,igrd,chfrstr,istrip,nchp,nn,
     & .false., 'EVPOT   ', 1, 1, bi, bj, myid)
      endif
      if(diagnostics_is_on('DTC     ',myid) ) then
      call diag_vegtile_fill (strdg1,igrd,chfrstr,istrip,nchp,nn,
     & .false., 'DTC     ', 1, 1, bi, bj, myid)
      endif
      if(diagnostics_is_on('DQC     ',myid) ) then
      call diag_vegtile_fill (strdg2,igrd,chfrstr,istrip,nchp,nn,
     & .false., 'DQC     ', 1, 1, bi, bj, myid)
      endif
      if(diagnostics_is_on('TCDTC   ',myid) ) then
      call diag_vegtile_fill (strdg3,igrd,chfrstr,istrip,nchp,nn,
     & .false., 'TCDTC   ', 1, 1, bi, bj, myid)
      endif
      if(diagnostics_is_on('RADDTC  ',myid) ) then
      call diag_vegtile_fill (strdg4,igrd,chfrstr,istrip,nchp,nn,
     & .false., 'RADDTC  ', 1, 1, bi, bj, myid)
      endif
      if(diagnostics_is_on('SENSDTC ',myid) ) then
      call diag_vegtile_fill (strdg5,igrd,chfrstr,istrip,nchp,nn,
     & .false., 'SENSDTC ', 1, 1, bi, bj, myid)
      endif
      if(diagnostics_is_on('LATDTC  ',myid) ) then
      call diag_vegtile_fill (strdg6,igrd,chfrstr,istrip,nchp,nn,
     & .false., 'LATDTC  ', 1, 1, bi, bj, myid)
      endif
      if(diagnostics_is_on('TDDTC   ',myid) ) then
      call diag_vegtile_fill (strdg7,igrd,chfrstr,istrip,nchp,nn,
     & .false., 'TDDTC   ', 1, 1, bi, bj, myid)
      endif
      if(diagnostics_is_on('QCDTC   ',myid) ) then
      call diag_vegtile_fill (strdg8,igrd,chfrstr,istrip,nchp,nn,
     & .false., 'QCDTC   ', 1, 1, bi, bj, myid)
      endif
C***********************************************************************

      call pastit (tc,tground,istrip,nchp,nchptot,1,nn)
      call pastit (td,tdeep,istrip,nchp,nchptot,1,nn)
      call pastit (qa,qground,istrip,nchp,nchptot,1,nn)
      call pastit (swet1,swetshal,istrip,nchp,nchptot,1,nn)
      call pastit (swet2,swetroot,istrip,nchp,nchptot,1,nn)
      call pastit (swet3,swetdeep,istrip,nchp,nchptot,1,nn)
      call pastit (capacity,capac,istrip,nchp,nchptot,1,nn)
      call pastit (snowdepth,snodep,istrip,nchp,nchptot,1,nn)

C**********************************************************************
C  Now update the theta and sh profiles with the new ground temperature
C**********************************************************************

      do i =1,istrip
      th(i,nlay+1) = tc(i) / pke(i,nlay+1)
      enddo
      do L = 1,nlay
      do i =1,istrip
      th(i,L) = th(i,L) + dthdthg(i,L)*(tc(i)-savetc(i))/pke(i,nlay+1)
      enddo
      enddo

      do i =1,istrip
      sh(i,nlay+1) = qa(i)
      enddo
      do L = 1,nlay
      do i =1,istrip
      sh(i,L) = sh(i,L) + dshdshg(i,L)*(qa(i)-saveqa(i))
      enddo
      enddo

      do L = 1,nlay
      do i =1,istrip
       sttflux(i,L) = transth(i,L) * (th(i,L+1)-th(i,L))
       stqflux(i,L) = transsh(i,L) * (sh(i,L+1)-sh(i,L))
      enddo
      enddo

C tendency updates
C ----------------
      do  l=1,nlay
      call strip2tile(uz(1,1,l),igrd,tmpstrip,nchp,ijall,
     1                                                 istrip,1,nn)
      do i =1,istrip
      tends(i) = ( u(i,l)-tmpstrip(i) )
      enddo
      call pastit (tends,dumsc(1,l),istrip,nchp,nchptot,1,nn)

      call strip2tile(vz(1,1,l),igrd,tmpstrip,nchp,ijall,
     1                                                 istrip,1,nn)
      do i =1,istrip
      tends(i) = ( v(i,l)-tmpstrip(i) )
      enddo
      call pastit (tends,dvmsc(1,l),istrip,nchp,nchptot,1,nn)

      call strip2tile(tz(1,1,l),igrd,tmpstrip,nchp,ijall,
     1                                                 istrip,1,nn)
      do i =1,istrip
      tends(i) = ( th(i,l)-tmpstrip(i) )
      enddo

      call pastit (tends,dtmsc(1,l),istrip,nchp,nchptot,1,nn)

      call strip2tile(qz(1,1,l,1),igrd,tmpstrip,nchp,ijall,
     1                                                 istrip,1,nn)
      do i =1,istrip
      tends(i) = ( sh(i,l)-tmpstrip(i) )
      enddo

      call pastit (tends,dqmsc(1,l,1),istrip,nchp,nchptot,1,nn)

c     do nt = 1,ntracers-ptracers
c      call strip2tile(qz(1,1,L,ptracers+nt),igrd,tmpstrip,nchp,
c    1                                             ijall,istrip,1,nn)
c      do i =1,istrip
c       tends(i) = ( tracers(i,L,nt)-tmpstrip(i) )
c      enddo
c      call pastit(tends,dqmsc(1,L,ptracers+nt),istrip,nchp,
c    .                                     nchptot,1,nn)
c     enddo

      enddo
C *********************************************************************
C **** increment diagnostic arrays for quantities saved in trbflx
C *********************************************************************

C note: the order, logic, and scaling of the heat and moisture flux
C       diagnostics is critical!
C ------------------------------

      if(diagnostics_is_on('EVAP    ',myid) ) then
      do i=1,istrip
      tmpstrip(i) = stqflux(i,nlay) * 86400
      enddo
      call diag_vegtile_fill (tmpstrip,igrd,chfrstr,istrip,nchp,nn,
     & .false., 'EVAP    ', 1, 1, bi, bj, myid)
      endif
      if(diagnostics_is_on('EFLUX   ',myid) ) then
      do i=1,istrip
      tmpstrip(i) = stqflux(i,nlay) * alhl
      enddo
      call diag_vegtile_fill (tmpstrip,igrd,chfrstr,istrip,nchp,nn,
     & .false., 'EFLUX   ', 1, 1, bi, bj, myid)
      endif
      if(diagnostics_is_on('HFLUX   ',myid) ) then
      do i=1,istrip
      tmpstrip(i) = sttflux(i,nlay) * cp
      enddo
      call diag_vegtile_fill (tmpstrip,igrd,chfrstr,istrip,nchp,nn,
     & .false., 'HFLUX   ', 1, 1, bi, bj, myid)
      endif
      if(diagnostics_is_on('TUFLUX  ',myid) ) then
      call diag_vegtile_fill (stuflux,igrd,chfrstr,istrip,nchp,nn,
     & .false., 'TUFLUX  ', 0, nlay, bi, bj, myid)
      endif
      if(diagnostics_is_on('TVFLUX  ',myid) ) then
      call diag_vegtile_fill (stvflux,igrd,chfrstr,istrip,nchp,nn,
     & .false., 'TVFLUX  ', 0, nlay, bi, bj, myid)
      endif
      if(diagnostics_is_on('TTFLUX  ',myid) ) then
      do l=1,nlay
      do i=1,istrip
      sttflux(i,l) = sttflux(i,l) * cp
      enddo
      enddo
      call diag_vegtile_fill (sttflux,igrd,chfrstr,istrip,nchp,nn,
     & .false., 'TTFLUX  ', 0, nlay, bi, bj, myid)
      endif
      if(diagnostics_is_on('TQFLUX  ',myid) ) then
      do l=1,nlay
      do i=1,istrip
      stqflux(i,l) = stqflux(i,l) * alhl
      enddo
      enddo
      call diag_vegtile_fill (stqflux,igrd,chfrstr,istrip,nchp,nn,
     & .false., 'TQFLUX  ', 0, nlay, bi, bj, myid)
      endif
      if(diagnostics_is_on('RI      ',myid) ) then
      call diag_vegtile_fill (sri,igrd,chfrstr,istrip,nchp,nn,
     & .false., 'RI      ', 0, nlay, bi, bj, myid)
      endif
      if(diagnostics_is_on('KH      ',myid) ) then
      call diag_vegtile_fill (skh,igrd,chfrstr,istrip,nchp,nn,
     & .false., 'KH      ', 0, nlay, bi, bj, myid)
      endif
      if(diagnostics_is_on('KM      ',myid) ) then
      call diag_vegtile_fill (skm,igrd,chfrstr,istrip,nchp,nn,
     & .false., 'KM      ', 0, nlay, bi, bj, myid)
      endif
      if(diagnostics_is_on('CT      ',myid) ) then
      call diag_vegtile_fill (sct,igrd,chfrstr,istrip,nchp,nn,
     & .false., 'CT      ', 1, 1, bi, bj, myid)
      endif
      if(diagnostics_is_on('CU      ',myid) ) then
      call diag_vegtile_fill (scu,igrd,chfrstr,istrip,nchp,nn,
     & .false., 'CU      ', 1, 1, bi, bj, myid)
      endif
      if(diagnostics_is_on('WINDS   ',myid) ) then
      call diag_vegtile_fill (swinds,igrd,chfrstr,istrip,nchp,nn,
     & .false., 'WINDS   ', 1, 1, bi, bj, myid)
      endif
      if(diagnostics_is_on('UFLUX   ',myid) ) then
      call diag_vegtile_fill (stuflux(1,nlay),igrd,chfrstr,istrip,nchp,
     & nn,.false., 'UFLUX   ', 1, 1, bi, bj, myid)
      endif
      if(diagnostics_is_on('VFLUX   ',myid) ) then
      call diag_vegtile_fill (stvflux(1,nlay),igrd,chfrstr,istrip,nchp,
     & nn,.false., 'VFLUX   ', 1, 1, bi, bj, myid)
      endif
      if(diagnostics_is_on('USTAR   ',myid) ) then
      call diag_vegtile_fill (sustar,igrd,chfrstr,istrip,nchp,nn,
     & .false., 'USTAR   ', 1, 1, bi, bj, myid)
      endif
      if(diagnostics_is_on('Z0      ',myid) ) then
      call diag_vegtile_fill (sz0,igrd,chfrstr,istrip,nchp,nn,
     & .false., 'Z0      ', 1, 1, bi, bj, myid)
      endif
      if(diagnostics_is_on('FRQTRB  ',myid) ) then
      call diag_vegtile_fill (frqtrb,igrd,chfrstr,istrip,nchp,nn,
     & .false., 'FRQTRB  ', 0, nlay-1, bi, bj, myid)
      endif
      if(diagnostics_is_on('PBL     ',myid) ) then
      call diag_vegtile_fill (pbldpth,igrd,chfrstr,istrip,nchp,nn,
     & .false., 'PBL     ', 1, 1, bi, bj, myid)
      endif
      if(diagnostics_is_on('U2M     ',myid) ) then
      call diag_vegtile_fill (stu2m,igrd,chfrstr,istrip,nchp,nn,
     & .false., 'U2M     ', 1, 1, bi, bj, myid)
      endif
      if(diagnostics_is_on('V2M     ',myid) ) then
      call diag_vegtile_fill (stv2m,igrd,chfrstr,istrip,nchp,nn,
     & .false., 'V2M     ', 1, 1, bi, bj, myid)
      endif
      if(diagnostics_is_on('T2M     ',myid) ) then
      call diag_vegtile_fill (stt2m,igrd,chfrstr,istrip,nchp,nn,
     & .false., 'T2M     ', 1, 1, bi, bj, myid)
      endif
      if(diagnostics_is_on('Q2M     ',myid) ) then
      do i=1,istrip
         if( stq2m(i).ne.undef ) then
             tmpstrip(i) = stq2m(i) * 1000
         else
             tmpstrip(i) = undef
         endif
      enddo
      call diag_vegtile_fill (tmpstrip,igrd,chfrstr,istrip,nchp,nn,
     & .false., 'Q2M     ', 1, 1, bi, bj, myid)
      endif
      if(diagnostics_is_on('U10M    ',myid) ) then
      call diag_vegtile_fill (stu10m,igrd,chfrstr,istrip,nchp,nn,
     & .false., 'U10M    ', 1, 1, bi, bj, myid)
      endif
      if(diagnostics_is_on('V10M    ',myid) ) then
      call diag_vegtile_fill (stv10m,igrd,chfrstr,istrip,nchp,nn,
     & .false., 'V10M    ', 1, 1, bi, bj, myid)
      endif
      if(diagnostics_is_on('T10M    ',myid) ) then
      call diag_vegtile_fill (stt10m,igrd,chfrstr,istrip,nchp,nn,
     & .false., 'T10M    ', 1, 1, bi, bj, myid)
      endif
      if(diagnostics_is_on('Q10M    ',myid) ) then
      do i=1,istrip
         if( stq10m(i).ne.undef ) then
             tmpstrip(i) = stq10m(i) * 1000
         else
             tmpstrip(i) = undef
         endif
      enddo
      call diag_vegtile_fill (tmpstrip,igrd,chfrstr,istrip,nchp,nn,
     & .false., 'Q10M    ', 1, 1, bi, bj, myid)
      endif

C**********************************************************************
C   more diagnostics: land surface model parameters
C**********************************************************************

      if(diagnostics_is_on('TDEEP   ',myid) ) then
      call diag_vegtile_fill (td,igrd,chfrstr,istrip,nchp,nn,
     & .false., 'TDEEP   ', 1, 1, bi, bj, myid)
      endif
      if(diagnostics_is_on('QCANOPY ',myid) ) then
      call diag_vegtile_fill (qa,igrd,chfrstr,istrip,nchp,nn,
     & .false., 'QCANOPY ', 1, 1, bi, bj, myid)
      endif
      if(diagnostics_is_on('SMSHAL  ',myid) ) then
      call diag_vegtile_fill (swet1,igrd,chfrstr,istrip,nchp,nn,
     & .false., 'SMSHAL  ', 1, 1, bi, bj, myid)
      endif
      if(diagnostics_is_on('SMROOT  ',myid) ) then
      call diag_vegtile_fill (swet2,igrd,chfrstr,istrip,nchp,nn,
     & .false., 'SMROOT  ', 1, 1, bi, bj, myid)
      endif
      if(diagnostics_is_on('SMDEEP  ',myid) ) then
      call diag_vegtile_fill (swet3,igrd,chfrstr,istrip,nchp,nn,
     & .false., 'SMDEEP  ', 1, 1, bi, bj, myid)
      endif
      if(diagnostics_is_on('CAPACITY',myid) ) then
      call diag_vegtile_fill (capacity,igrd,chfrstr,istrip,nchp,nn,
     & .false., 'CAPACITY', 1, 1, bi, bj, myid)
      endif
      if(diagnostics_is_on('SNOW    ',myid) ) then
      call diag_vegtile_fill (snowdepth,igrd,chfrstr,istrip,nchp,nn,
     & .false., 'SNOW    ', 1, 1, bi, bj, myid)
      endif
C**********************************************************************
C end regions loop

 2000 continue

C**********************************************************************

C increment the counter for the accumulated fcc and qliq arrays
C ---------------------------------------------------------------------
      imstturblw = imstturblw + 1
      imstturbsw = imstturbsw + 1

C prevent ice or snow from melting
C ---------------------------------------------------------------------
      do i =1,nchptot
      if( (icethk(i).gt.0.).and.(tground(i).gt.tice) ) tground(i)=tice
      enddo

C Update tcanopy and ecanopy from the points of the
C           tground and qground arrays
C ---------------------------------------------------------------------
      do i =1,nchptot
       tcanopy(i) = tground(i)
       ecanopy(i) = qground(i)
      enddo

C Initialize Tendencies and Couplings
C -----------------------------------
      do L = 1,nlay
       do i = 1,ijall
           duturb(i,1,L) = 0.
           dvturb(i,1,L) = 0.
           dtturb(i,1,L) = 0.
           qqgrid(i,1,L) = 0.
          qliqtmp(i,1,L) = 0.
           fcctmp(i,1,L) = 0.
       enddo
       do nt = 1,ntracers
        do i = 1,ijall
           dqturb(i,1,L,nt) = 0.
        enddo
       enddo
      enddo

C Return Tendencies and Couplings to Grid Space
C ---------------------------------------------
      do l = 1,nlay
      call msc2grd(igrd,chfr,dumsc(1,L),nchp,nchptot,fracland,
     &                                              duturb(1,1,L),im,jm)
      call msc2grd(igrd,chfr,dvmsc(1,L),nchp,nchptot,fracland,
     &                                              dvturb(1,1,L),im,jm)
      call msc2grd(igrd,chfr,dtmsc(1,L),nchp,nchptot,fracland,
     &                                              dtturb(1,1,L),im,jm)
      do nt = 1,ntracers
      call msc2grd(igrd,chfr,dqmsc(1,L,nt),nchp,nchptot,fracland,
     &                                           dqturb(1,1,L,nt),im,jm)
      enddo
      call msc2grd(igrd,chfr,  tke(1,L),nchp,nchptot,fracland,
     &                                              qqgrid(1,1,L),im,jm)

      call msc2grd(igrd,chfr, fccmsc(1,L),nchp,nchptot,fracland,
     &                                              fcctmp(1,1,L),im,jm)
      call msc2grd(igrd,chfr,qliqmsc(1,L),nchp,nchptot,fracland,
     &                                             qliqtmp(1,1,L),im,jm)
      enddo

C Reduce clouds from conditionally unstable layer
C -----------------------------------------------
      call ctei ( tz,qz,fcctmp,qliqtmp,plz,pkz,pkht,im*jm,nlay )

C Bump Total Cloud Liquid Water and Fraction by Instantaneous Values
C ------------------------------------------------------------------
      do l = 1,nlay
       do i = 1,ijall
         fccavesw(i,1,L) =  fccavesw(i,1,L) +  fcctmp(i,1,L)
         fccavelw(i,1,L) =  fccavelw(i,1,L) +  fcctmp(i,1,L)
        qliqavelw(i,1,L) = qliqavelw(i,1,L) + qliqtmp(i,1,L)
        qliqavesw(i,1,L) = qliqavesw(i,1,L) + qliqtmp(i,1,L)
       enddo
      enddo
      tmpFac = 1.e6
      CALL DIAGNOSTICS_FILL(fcctmp,'TRBFCC  ',0,nlay,3,bi,bj,myid)
      CALL DIAGNOSTICS_SCALE_FILL( qliqtmp,tmpFac,1,
     &                             'TRBQLIQ ',0,nlay,3,bi,bj,myid)
C**********************************************************************
C And some other variables to be transformed back to grid space:
C Ground Temperature, snow depth and shallow layer ground wetness
      do i = 1,ijall
         tgz(i,1) = 0.
      enddo
      call msc2grd(igrd,chfr,tground ,nchp,nchptot,fracland,tgz ,im,jm)

C *********************************************************************
C **** increment diagnostic array for ground and surface temperatures,
C ***       ground temp tendency, and ground humidity
C *********************************************************************

      call diagnostics_fill(tgz,'TGROUND ',0,1,3,bi,bj,myid)
      call diagnostics_fill(tgz,'TCANOPY ',0,1,3,bi,bj,myid)

      if(diagnostics_is_on('TS      ',myid) ) then
       do i = 1,ijall
        tmpdiag(i,1) = tz(i,1,nlay) * pkht(i,1,nlay)
       enddo
       call diagnostics_fill(tmpdiag,'TS      ',0,1,3,bi,bj,myid)
      endif

      call diagnostics_fill(tgz,'DTG     ',0,1,3,bi,bj,myid)

C *********************************************************************
C ****           increment diagnostic arrays for tendencies        ****
C *********************************************************************
      tmpFac = atimstp * secday
      CALL DIAGNOSTICS_SCALE_FILL(dvturb,tmpFac,1,
     &                            'TURBV   ',0,nlay,3,bi,bj,myid)
      CALL DIAGNOSTICS_SCALE_FILL(duturb,tmpFac,1,
     &                            'TURBU   ',0,nlay,3,bi,bj,myid)
      tmpFac = atimstp * secday * 1000.
      CALL DIAGNOSTICS_SCALE_FILL(dqturb,tmpFac,1,
     &                            'TURBQ   ',0,nlay,3,bi,bj,myid)

      if(diagnostics_is_on('TURBT   ',myid) ) then
       do L = 1,nlay
        do i = 1,ijall
          tmpdiag(i,1) = dtturb(i,1,l) * pkz(i,1,l)*atimstp*secday
        enddo
        call diagnostics_fill(tmpdiag,'TURBT   ',L,1,3,bi,bj,myid)
       enddo
      endif

C pi-weight the theta and moisture tendencies
C -------------------------------------------
      do i =1,ijall
      thtgz(i) = pz(i,1) * atimstp
      enddo
      do l =1,nlay
       do i =1,ijall
        duturb(i,1,l) = duturb(i,1,l)*atimstp
        dvturb(i,1,l) = dvturb(i,1,l)*atimstp
        dtturb(i,1,l) = dtturb(i,1,l)*thtgz(i)
       enddo
       do nt = 1,ntracers
        do i =1,ijall
         dqturb(i,1,l,nt) = dqturb(i,1,l,nt)*thtgz(i)
        enddo
       enddo
      enddo

C *********************************************************************
C ****   zero out the accumulating rainfall and snowfall arrays     ***
C *********************************************************************

      if( time_left.lt.timstp ) then
       do i =1,ijall
         rainlsp(i,1) = 0.
        rainconv(i,1) = 0.
        snowfall(i,1) = 0.
       enddo
      endif

      return
      end

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      SUBROUTINE TRBFLX (NN,TH,THV,SH,U,V,QQ,PL,PLE,PLK,PLKE,DPSTR,
     1 IWATER,Z0,tracers,ntrace,ntracedim,DTAU,ITRTRB,KMBG,KHBG,QBEG,
     2 TPROF,WU,WV,SRI,ET,EU,SWINDS,sustar,sz0,freqdg,pbldpth,
     3 sct,scu,stu2m,stv2m,stt2m,stq2m,stu10m,stv10m,stt10m,stq10m,
     4 irun,nlev,nltop,NYMD,NHMS,grav,cp,rgas,faceps,virtcon,undef,
     5 dshdthg,dshdshg,dthdthg,dthdshg,eturb,dedqa,dedtc,
     6 hsturb,dhsdqa,dhsdtc,transth,transsh,
     7 ctsave,xxsave,yysave,zetasave,xlsave,khsave,qliq,turbfcc)
C**********************************************************************
C  SUBROUTINE TRBFLX - COMPUTES TURBULENT ADJUSTMENTS TO ATMOSPHERIC
C                       PROFILE
C                    - CALLED FROM PBL DRIVER
C   ARGUMENTS ::
C     INPUT:
C     ------
C    TH            -         POTENTIAL TEMPERATURE PROFILE
C    THV           -         VIRTUAL POTENTIAL TEMPERATURE PROFILE
C    SH            -         SPECIFIC HUMIDITY PROFILE
C    U             -         U - COMPONENT OF WIND PROFILE
C    V             -         V - COMPONENT OF WIND PROFILE
C    QQ            -         TURBULENT KINETIC ENERGY
C    PL            -         EVEN LEVEL PRESSURES
C    PLE           -         EDGE LEVEL PRESSURES
C    PLK           -         EVEN LEVEL PRESSURES ** KAPPA
C    PLKE          -         EDGE LEVEL PRESSURES ** KAPPA
C    DPSTR         -         PRESSURE INTERVALS
C    WATER         -         BIT ARRAY - '1' OVER OCEANS
C    Z0            -         SURFACE ROUGHNESS
C    tracers       -         array of passive tracers
C    ntrace        -         number of tracers to be diffused
C    ntracedim     -         outer dimension of tracers array
C    DTAU          -         TIME CHANGE PER ITERATION OF TRBFLX
C    ITRTRB        -         NUMBER OF ITERATIONS OF TRBFLX
C    KMBG          -         BACKGROUND VALUE OF MOMENTUM TRANSFER COEF
C    KHBG          -         BACKGROUND VALUE OF HEAT TRANSFER COEF
C    NLEV          -         NUMBER OF ATMOSPHERIC LEVELS TO CALCULATE
C    nltop         -         Top level allowed for turbulence
C    QBEG          -         LOGICAL .TRUE. FOR INITIAL START OF GCM
C    TPROF         -         LOGICAL .TRUE. TO CALCULATE PT BY PT DIAGS
C
C     OUTPUT:
C     -------
C    PROFILES RETURNED WITH UPDATED VALUES
C**********************************************************************
      implicit none

C Argument list declarations
      integer nn,irun,nlev,nltop,ntrace,ntracedim,itrtrb,nhms,nymd
      _RL TH(irun,NLEV+1),THV(irun,NLEV+1),SH(irun,NLEV+1)
      _RL U(irun,NLEV+1),V(irun,NLEV+1),QQ(irun,NLEV)
      _RL PL(irun,NLEV),PLE(irun,NLEV+1),PLK(irun,NLEV)
      _RL PLKE(irun,NLEV+1),DPSTR(irun,NLEV)
      integer IWATER(irun)
      _RL Z0(irun)
      _RL tracers(irun,nlev+1,ntracedim)
      _RL dtau,KMBG,KHBG
      LOGICAL QBEG,TPROF
      _RL SWINDS(irun)
      _RL SRI(irun,nlev), ET(irun,nlev)
      _RL EU (irun,nlev)
      _RL WU(irun,nlev)
      _RL WV (irun,nlev), pbldpth(irun)
      _RL sustar(irun), sz0(irun)
      _RL freqdg(irun,nlev-1)
      _RL sct(irun), scu(irun)
      _RL stu2m(irun),stv2m(irun),stt2m(irun),stq2m(irun)
      _RL stu10m(irun),stv10m(irun),stt10m(irun),stq10m(irun)
      _RL grav,cp,rgas,faceps,virtcon,undef
      _RL eturb(irun),dedqa(irun),dedtc(irun)
      _RL hsturb(irun),dhsdqa(irun),dhsdtc(irun)
      _RL dshdthg(irun,nlev),dthdthg(irun,nlev)
      _RL dshdshg(irun,nlev),dthdshg(irun,nlev)
      _RL transth(irun,nlev),transsh(irun,nlev)
      _RL ctsave(irun),xxsave(irun),yysave(irun)
      _RL zetasave(irun),xlsave(irun,nlev),khsave(irun,nlev)
      _RL qliq(irun,nlev),turbfcc(irun,nlev)

C Local Variables
      _RL b1,b3,alpha,halpha,qqmin,qbustr
      PARAMETER ( B1      =   16.6    )
      PARAMETER ( B3      = 1. / B1  )
      PARAMETER ( ALPHA   = 0.1       )
      PARAMETER ( HALPHA = ALPHA * 0.5 )
      PARAMETER ( QQMIN  = 0.005      )
      PARAMETER ( QBUSTR = 2.550952   )
      _RL    argmax, onethrd, z1pem25, b2, two
      PARAMETER (ARGMAX = 30.)
      PARAMETER (ONETHRD = 1./3. )
      PARAMETER (Z1PEM25 = 1.E-25)
      PARAMETER ( B2    =  10.1 )
      PARAMETER ( two   =   2.0 )

      _RL AHS (irun), HS(irun)
      _RL XX  (irun), YY(irun), CU(irun)
      _RL CT(irun),  USTAR(irun)
      _RL RIB(irun),   ZETA(irun), WS(irun)
      _RL DTHS(irun), DELTHS(irun)
      _RL DTHL(irun), DELTHL(irun)
      _RL RIBIN(irun),CUIN(irun)
      _RL CTIN(irun),ZETAIN(irun)
      _RL USTARIN(irun),RHOSIN(irun),Z0IN(irun)
      _RL qqcolmin(irun),qqcolmax(irun),levpbl(irun)

      _RL ADZ1(irun,nlev), DZ1TMP(irun,nlev)
      _RL DZ3(irun,nlev), TEMP(irun,nlev)
      _RL DV(irun,nlev), DTHV(irun,nlev)
      _RL DPK(irun,nlev), STRT(irun,nlev)
      _RL DW2(irun,nlev), RI(irun,nlev)
      _RL RHOZPK(irun,nlev), Q(irun,nlev)
      _RL RIINIT(irun,nlev), DU(irun,nlev)
      _RL QQINIT(irun,nlev), RHOKDZ(irun,nlev)
      _RL RHODZ2(irun,nlev)
      _RL KM(irun,nlev), KH(irun,nlev)

      _RL DELTH  (irun,nlev+1), DELSH (irun,nlev+1)
      _RL FLXFAC (irun,nlev+1)
      _RL FLXFPK (irun,nlev+1)

      _RL ADZ2   (irun,nlev-1), RHODZ1(irun,nlev-1)
      _RL VKZE   (irun,nlev-1), VKZM  (irun,nlev-1)
      _RL XL     (irun,nlev-1), QXLM  (irun,nlev-1)
      _RL QQE    (irun,nlev-1), QE    (irun,nlev-1)
      _RL P3     (irun,nlev-1), XQ    (irun,nlev-1)
      _RL XLDIAG (irun,nlev-1), FLXFCE(irun,nlev-1)

      LOGICAL FIRST,LAST
      integer IBITSTB(irun,nlev),INTQ(irun,nlev)

C arrays for use by moist bouyancy calculation
C -----------------
      _RL TL(irun,NLEV),DTH(irun,NLEV)
      _RL DSH(irun,NLEV)
      _RL SHL(irun,NLEV)
      _RL AA(irun,NLEV),BB(irun,NLEV),SSDEV(irun,NLEV)
      _RL ARG(irun,NLEV),XXZETA(irun),QBYU(irun)
      _RL SVAR(irun,NLEV),Q1M(irun,NLEV)
      _RL FCC(irun,NLEV)
      _RL BETAT(irun,NLEV),BETAW(irun,NLEV)
      _RL BETAL(irun,NLEV),BETAT1(irun,NLEV)
      _RL BETAW1(irun,NLEV),SBAR(irun,NLEV)
      _RL SHSAT(irun,NLEV)

C Some space for variables to be used in called routines
      logical LWATER
      integer IVBITRIB(irun)
      _RL VHZ(irun)
      _RL VH0(irun)
      _RL VPSIM(irun),VAPSIM(irun)
      _RL VPSIG(irun),VPSIHG(irun)
      _RL VTEMP(irun),VDZETA(irun)
      _RL VDZ0(irun),VDPSIM(irun)
      _RL VDPSIH(irun),VZH(irun)
      _RL VXX0(irun),VYY0(irun)
      _RL VAPSIHG(irun),VRIB1(irun),VWS1(irun)
      _RL VPSIH(irun),VZETAL(irun)
      _RL VZ0L(irun),VPSIH2(irun)
      _RL VX0PSIM(irun),VG(irun),VG0(irun),VR1MG0(irun)
      _RL VZ2(irun),VDZSEA(irun),VAZ0(irun),VXNUM1(irun)
      _RL VPSIGB2(irun),VDX(irun),VDXPSIM(irun),VDY(irun)
      _RL VXNUM2(irun),VDEN(irun),VAWS1(irun),VXNUM3(irun)
      _RL VXNUM(irun),VDZETA1(irun),VDZETA2(irun)
      _RL VZCOEF2(irun),VZCOEF1(irun),VTEMPLIN(irun)
      _RL VDPSIMC(irun),VDPSIHC(irun)

      _RL DZITRP(irun,nlev-1),STBFCN(irun,nlev)
      _RL XL0(irun,nlev),Q1(irun,nlev-1)
      _RL WRKIT1(irun,nlev-1)
      _RL WRKIT2(irun,nlev-1)
      _RL WRKIT3(irun,nlev-1)
      _RL WRKIT4(irun,nlev-1)
      INTEGER INT1(irun,nlev), INT2(irun,nlev-1)

      _RL vrt1con,pi,rsq2pi,p5sr,clh,vk,rvk,aitr,gbycp,fac1,fac2
      _RL getcon,dum,errf
      integer istnlv,nlevm1,nlevm2,nlevml,nlevp1,istnm1,istnm2,istnp1
      integer istnml,istnmq,istlmq,nlevmq
      integer i,iter,init,n,LL,L,Lp,Lp1,lmin,lminq,lminq1,ibit

      vk = getcon('VON KARMAN')
      rvk = 1./vk
      AITR   = 1. / FLOAT(ITRTRB)
      ISTNLV = irun * NLEV
      NLEVM1 = NLEV - 1
      NLEVM2 = NLEV - 2
      NLEVP1 = NLEV + 1
      ISTNM1 = irun * NLEVM1
      ISTNM2 = irun * NLEVM2
      ISTNP1 = irun * NLEVP1
      GBYCP  = GRAV / CP

      VRT1CON = 1. + VIRTCON
      PI   = 4. * ATAN(1.)
      RSQ2PI = 1./ ((2.*PI)**0.5)
      P5SR = 0.5**0.5
      CLH = GETCON('LATENT HEAT COND') / CP

C SET INITIAL NUMBER OF ITERATIONS OF SFCFLX
C ------------------------------------------
      N = 6
C DETERMINE IF INITIAL START
C --------------------------
      INIT = 0
      IF(QBEG) INIT = 1
C SET DIAGNOSTIC LOGICALS AND INITIALIZE DIAGNOSTIC ARRAYS
C --------------------------------------------------------
      DO L =1,NLEV
        DO I =1,irun
         wu(I,L) = 0.
         wv(I,L) = 0.
         eu(I,L) = 0.
         et(I,L) = 0.
        ENDDO
      ENDDO
      if (tprof) then
       DO L =1,NLEVM1
        DO I =1,irun
         XLDIAG(I,L) = 0.
        ENDDO
       ENDDO
      endif
      DO L =1,NLEVM1
        DO I =1,irun
         FREQDG(I,L) = 0.
        ENDDO
      ENDDO
      do I =1,irun
      scu(i) = 0.
      enddo
      do I =1,irun
      sct(i) = 0.
      enddo
      do I =1,irun
      pbldpth(i) = 0.
      enddo
      do I =1,irun
      sustar(i) = 0.
      enddo
      do I =1,irun
      sz0(i) = 0.
      enddo
c     do I =1,ISTNM1
c     FREQDG(I,1) = 0.
c     enddo
      do I =1,irun
      stu2m(i) = 0.
      enddo
      do I =1,irun
      stv2m(i) = 0.
      enddo
      do I =1,irun
      stt2m(i) = 0.
      enddo
      do I =1,irun
      stq2m(i) = 0.
      enddo
      do I =1,irun
      stu10m(i) = 0.
      enddo
      do I =1,irun
      stv10m(i) = 0.
      enddo
      do I =1,irun
      stt10m(i) = 0.
      enddo
      do I =1,irun
      stq10m(i) = 0.
      enddo

      IF (INIT.EQ.1) THEN
       DO L =1,NLEVM1
        DO I =1,irun
        XLSAVE(I,L) = 0.
        KHSAVE(I,L) = 0.
        ENDDO
       ENDDO
       DO I = 1,irun
        CTSAVE(I) = 0.
        XXSAVE(I) = 0.
        YYSAVE(I) = 0.
        ZETASAVE(I) = 0.
       ENDDO
      ENDIF

C COMPUTE VERTICAL GRID
C ---------------------
      DO L =1,NLEV
       DO I =1,irun
        ADZ1(I,L) = (CP/GRAV)*(PLKE(I,L+1)-PLKE(I,L))
        ADZ1(I,L) = THV(I,L) * ADZ1(I,L)
        DZ1TMP(I,L) = ADZ1(I,L)
       ENDDO
      ENDDO
      DO L =1,NLEVM1
       DO I =1,irun
        ADZ2(I,L) = 0.5 * (ADZ1(I,L)+ADZ1(I,L+1))
       ENDDO
      ENDDO
C DEPTH HS OF SURFACE LAYER
C -------------------------
      DO 9042 I =1,irun
      HS(I) = 0.5 * ADZ1(I,NLEV)
9042  CONTINUE
C ALPHA * LAYER DEPTHS FOR TRBLEN
C -------------------------------
      DO 9044 I =1,irun
      DZ3(I,1) = HALPHA * ADZ1(I,1)
9044  CONTINUE
      DO L =2,NLEVM1
       DO I =1,irun
        DZ3(I,L) = ALPHA * ADZ1(I,L)
       ENDDO
      ENDDO
      DO 9048 I =1,irun
      DZ3(I,NLEV) = ALPHA * HS(I)
9048  CONTINUE

C VK * HEIGHTS AT MID AND EDGE LEVELS
C -----------------------------------
      DO L =2,NLEV
       DO I =1,irun
        TEMP(I,L) = VK * ADZ1(I,L)
       ENDDO
      ENDDO
      DO 9052 I =1,irun
      VKZE(I,NLEVM1) = TEMP(I,NLEV)
9052  CONTINUE
      DO 100 LL = 2,NLEVM1
      L = NLEV - LL
      LP1 = L + 1
      DO 9054 I =1,irun
      VKZE(I,L) = VKZE(I,LP1) + TEMP(I,LP1)
9054  CONTINUE
 100  CONTINUE
      DO L =1,NLEVM1
       DO I =1,irun
        VKZM(I,L) = VKZE(I,L) - 0.5 * TEMP(I,L+1)
       ENDDO
      ENDDO
C COMPUTE RHO BY DZ AT MID AND EDGE LEVELS
C ----------------------------------------
      DO 200 L = 1,NLEVM1
       LP1 = L + 1
      DO 9058 I =1,irun
       FAC1 = DPSTR(I,L) / ( DPSTR(I,L) + DPSTR(I,LP1) )
       FAC2 = 1. - FAC1
       RHODZ2(I,L) = FAC1 * THV(I,LP1)
       RHODZ2(I,L) = RHODZ2(I,L) + FAC2 * THV(I,L)
9058  CONTINUE
 200  CONTINUE
      DO L =1,NLEVM1
       DO I =1,irun
        RHODZ2(I,L) = (RGAS*0.01) * RHODZ2(I,L)
        TEMP(I,L)   = PLKE(I,L+1) * ADZ2(I,L)
        RHODZ2(I,L) = TEMP(I,L) * RHODZ2(I,L)
        RHODZ2(I,L) = PLE(I,L+1) / RHODZ2(I,L)
        RHOZPK(I,L) = RHODZ2(I,L) * PLKE(I,L+1)
        RHODZ1(I,L) = (RGAS*0.01) * THV(I,L+1)
        TEMP(I,L)   = PLK(I,L+1) * ADZ1(I,L+1)
        RHODZ1(I,L) = TEMP(I,L) * RHODZ1(I,L)
        RHODZ1(I,L) = PL(I,L+1) / RHODZ1(I,L)
       ENDDO
      ENDDO
C COMPUTE FLXFAC FOR LAYERS AND EDGES
C COMPUTE DTG / DT DUE TO RADIATION AND HEAT CONDUCTION THROUGH ICE
C -----------------------------------------------------------------
      DO L =1,NLEV
       DO I =1,irun
        FLXFPK(I,L) = PLE(I,L+1) - PLE(I,L)
        FLXFPK(I,L) = FLXFPK(I,L) * PLK(I,L)
        FLXFPK(I,L) = (GRAV*DTAU*0.01) / FLXFPK(I,L)
       ENDDO
      ENDDO
      DO 9064 I =1,irun
      FLXFPK(I,NLEVP1) = 0.
9064  CONTINUE
      DO 9066 I =1,irun
      IF (IWATER(I).EQ.0 ) FLXFPK(I,NLEVP1) = 1. / PLKE(I,NLEVP1)
9066  CONTINUE
      DO L =1,NLEV
       DO I =1,irun
        FLXFAC(I,L) = FLXFPK(I,L) * PLK(I,L)
       ENDDO
      ENDDO
      DO 9070 I =1,irun
      FLXFAC(I,NLEVP1) = FLXFPK(I,NLEVP1)
9070  CONTINUE
      DO 9074 I =1,irun
      FLXFPK(I,NLEVP1) = CP * FLXFPK(I,NLEVP1)
9074  CONTINUE
      DO L =1,NLEVM1
       DO I =1,irun
        FLXFCE(I,L) = PL(I,L+1) - PL(I,L)
        FLXFCE(I,L) = (GRAV*DTAU*0.01) / FLXFCE(I,L)
       ENDDO
      ENDDO
C COMPUTE RECIPROCALS OF DZ1, DZ2, HS
C -----------------------------------
      DO L =1,NLEV
       DO I =1,irun
        ADZ1(I,L) = 1. / ADZ1(I,L)
       ENDDO
      ENDDO
      DO L =1,NLEVM1
       DO I =1,irun
        ADZ2(I,L) = 1. / ADZ2(I,L)
       ENDDO
      ENDDO
      DO 9088 I =1,irun
      AHS(I) = 1. / HS(I)
9088  CONTINUE
C COMPUTE GRADIENTS OF P**KAPPA
C -----------------------------
      DO L =1,NLEVM1
       DO I =1,irun
        DPK(I,L) = ( PLK(I,L+1)-PLK(I,L) ) * ADZ2(I,L)
       ENDDO
      ENDDO
      DO 9092 I =1,irun
      DPK(I,NLEV) = GBYCP / THV(I,NLEV)
9092  CONTINUE
C INITIALIZE Q ARRAY
C ------------------
      DO L =1,NLEVM1
       DO I =1,irun
        Q(I,L) = 2. * QQ(I,L)
        Q(I,L) = SQRT( Q(I,L) )
       ENDDO
      ENDDO
      FIRST = .TRUE.
      LAST = .FALSE.
C**********************************************************************
C**********************************************************************
C                              MAIN LOOP

      DO 2000 ITER = 1, ITRTRB

      IF ( ITER .GE. ITRTRB ) LAST = .TRUE.

C  CODE FOR MOIST BOUNDARY LAYER - NEW CALCULATION OF DTHV

      IF(ITER.EQ.1) THEN
       DO I = 1,irun
        CT(I) = CTSAVE(I)
        XX(I) = XXSAVE(I)
        YY(I) = YYSAVE(I)
        ZETA(I) = ZETASAVE(I)
       ENDDO
      ENDIF

      DO I = 1,irun
       TL(I,NLEV) = TH(I,NLEV)*PLK(I,NLEV)
       call qsat ( tl(i,nlev),pl(i,nlev),shsat(i,nlev),dum,.false. )
      ENDDO

      DO I = 1,irun
       BB(I,NLEV) = FACEPS*SHSAT(I,NLEV)/(TL(I,NLEV)*TL(I,NLEV))
       AA(I,NLEV) = 1. / (1. + CLH * BB(I,NLEV) )
       BB(I,NLEV) = BB(I,NLEV) * AA(I,NLEV) * plk(I,nlev)
       DTH(I,NLEV) = TH(I,NLEV)-TH(I,NLEVP1)
       DSH(I,NLEV) = SH(I,NLEV)-SH(I,NLEVP1)
       SBAR(I,NLEV) = AA(I,NLEV) * (SH(I,NLEV) - SHSAT(I,NLEV))
       SSDEV(I,NLEV)=CT(I)*(AA(I,NLEV)*DSH(I,NLEV)
     1                  -BB(I,NLEV)*DTH(I,NLEV))
       XXZETA(I) = XX(I)-ZETA(I)
       IF(XXZETA(I).LT.0.1*XX(I)) XXZETA(I)=0.1*XX(I)
       IF(XXZETA(I).LE.0.) XXZETA(I)=0.1
       QBYU(I) =QBUSTR * XXZETA(I)  ** ONETHRD
       SSDEV(I,NLEV) = B2*YY(I)*SSDEV(I,NLEV)*SSDEV(I,NLEV)/QBYU(I)
       SVAR(I,NLEV) = SQRT(SSDEV(I,NLEV))
       IF ( SVAR(I,NLEV).LT.Z1PEM25) SVAR(I,NLEV) = Z1PEM25
       Q1M(I,NLEV) = SBAR(I,NLEV) / SVAR(I,NLEV)
       FCC(I,NLEV) = (1./2.) * ( 1. + ERRF( P5SR*Q1M(I,NLEV) ) )
       SHL(I,NLEV) =  FCC(I,NLEV) * SBAR(I,NLEV)
       ARG(I,NLEV)  = (1./2.)*Q1M(I,NLEV)*Q1M(I,NLEV)
       IF(ARG(I,NLEV).LE.ARGMAX)
     1 SHL(I,NLEV) =  SHL(I,NLEV)+RSQ2PI*SVAR(I,NLEV)*EXP(-ARG(I,NLEV))
       BETAT(I,NLEV) = 1. + VIRTCON*SH(I,NLEV) - VRT1CON*SHL(I,NLEV)
       BETAW(I,NLEV) = VIRTCON *
     1         ( TH(I,NLEV) + CLH * SHL(I,NLEV) * (1./plk(i,nlev)) )
       BETAL(I,NLEV) = (1.+VIRTCON*SH(I,NLEV)-TWO*VRT1CON*SHL(I,NLEV))
     1  * (1./plk(i,nlev)) * CLH - VRT1CON * TH(I,NLEV)
       BETAT1(I,NLEV) = BETAT(I,NLEV) - BB(I,NLEV)*FCC(I,NLEV)
     1        * BETAL(I,NLEV)
       BETAW1(I,NLEV) = BETAW(I,NLEV) + AA(I,NLEV) * FCC(I,NLEV)
     1        * BETAL(I,NLEV)
       DTHV(I,NLEV) = BETAT1(I,NLEV)*DTH(I,NLEV) +
     1       BETAW1(I,NLEV)*DSH(I,NLEV)
       THV(I,NLEVP1) = THV(I,NLEV) - DTHV(I,NLEV)
      ENDDO

C   SURFACE FLUX TRANSFER COEFFICIENTS

       CALL SFCFLX(NN,U(1,NLEV),V(1,NLEV),
     1   THV(1,NLEV),
     2   THV(1,NLEVP1),TH(1,NLEV),TH(1,NLEVP1),
     3   SH(1,NLEV),SH(1,NLEVP1),PLK(1,NLEV),
     4   PLKE(1,NLEVP1),PLE(1,NLEVP1),Z0,
     5   IWATER,HS,AHS,
     6   FIRST,LAST,N,irun,aitr,RHODZ2(1,NLEV),RHOZPK(1,NLEV),
     7   KH(1,NLEV),KM(1,NLEV),USTAR,
     8   XX,YY,CU,
     9   CT,RIB,ZETA,WS,
     1   stu2m,stv2m,stt2m,stq2m,stu10m,stv10m,stt10m,stq10m,
     2   cp,rgas,undef,
     3   lwater, ivbitrib,
     4   VHZ,VPSIM,VAPSIM,VPSIG,VPSIHG,VTEMP,VDZETA,VDZ0,VDPSIM,
     5   VDPSIH,VZH,VXX0,VYY0,VAPSIHG,VRIB1,VWS1,VPSIH,
     9   VZETAL,VZ0L,VPSIH2,VH0,
     1   VX0PSIM,VG,VG0,VR1MG0,VZ2,VDZSEA,VAZ0,VXNUM1,VPSIGB2,VDX,
     2   VDXPSIM,VDY,VXNUM2,VDEN,VAWS1,VXNUM3,VXNUM,VDZETA1,VDZETA2,
     3   VZCOEF2,VZCOEF1,VTEMPLIN,VDPSIMC,VDPSIHC)
CI

       N = 1

C   SET VALUES OF TURBULENT VELOCITY AND KINETIC ENERGY AT THE GROUND

CB
      DO 9098 I =1,irun
      Q(I,NLEV) = QBUSTR * USTAR(I)
      QQ(I,NLEV) = 0.5 * Q(I,NLEV) * Q(I,NLEV)
9098  CONTINUE
CE

C GRADIENTS
C ---------
      DO L =1,NLEVM1
       DO I =1,irun
        DU(I,L) = (   U(I,L)-  U(I,L+1) ) * ADZ2(I,L)
        DV(I,L) = (   V(I,L)-  V(I,L+1) ) * ADZ2(I,L)
       ENDDO
      ENDDO

C    NEW CODE FOR MOIST BOUNDARY LAYER - NEW CALCULATION OF DTHV

      IF(ITER.EQ.1) THEN
       DO L =1,NLEVM1
        DO I =1,irun
         XL(I,L) = XLSAVE(I,L)
        ENDDO
       ENDDO
      ENDIF

      DO L =1,NLEVM1
       DO I =1,irun
        DTH(I,L) = ( TH(I,L)-TH(I,L+1) ) * ADZ2(I,L)
        DSH(I,L) = ( SH(I,L)-SH(I,L+1) ) * ADZ2(I,L)
        TL(I,L) = TH(I,L)*PLK(I,L)
       ENDDO
      ENDDO
      DO LL = 1,NLEVM1
      DO I = 1,irun
       call qsat ( tl(i,LL),pl(i,LL),shsat(i,LL),dum,.false. )
      ENDDO
      ENDDO
      DO L =1,NLEVM1
       DO I =1,irun
        BB(I,L) = FACEPS*SHSAT(I,L)/(TL(I,L)*TL(I,L))
        AA(I,L) = 1. / (1. + CLH * BB(I,L) )
COMMM   BB(I,L) = BB(I,L) * AA(I,L) * plke(I,L+1)
        BB(I,L) = BB(I,L) * AA(I,L)
        SBAR(I,L) = AA(I,L) * (SH(I,L) - SHSAT(I,L))
       ENDDO
      ENDDO
      DO I = 1,irun
COMMM  SSDEV(I,1) = XL(I,1)*(AA(I,1)*DSH(I,1)-BB(I,1)*DTH(I,1))
       SSDEV(I,1) = XL(I,1)*(AA(I,1)*DSH(I,1)-
     1              BB(I,1)*plke(I,2)*DTH(I,1))
       SSDEV(I,1) = B2 * KHSAVE(I,1) * SSDEV(I,1) * SSDEV(I,1)
       SVAR(I,1) = SQRT(SSDEV(I,1))
       IF ( SVAR(I,1).LT.Z1PEM25) SVAR(I,1) = Z1PEM25
      ENDDO
      DO L =2,NLEVM1
       DO I =1,irun
COMMM   SSDEV(I,L) = XL(I,L-1)*(AA(I,L)*DSH(I,L-1)-BB(I,L)*DTH(I,L-1))
        SSDEV(I,L) = XL(I,L-1)*(AA(I,L)*DSH(I,L-1)-
     1               BB(I,L)*plke(I,L)*DTH(I,L-1))
        SSDEV(I,L) = B2 * KHSAVE(I,L-1) * SSDEV(I,L-1) * SSDEV(I,L-1)
        SVAR(I,L) = SQRT(SSDEV(I,L))
COMMM   SSDEV(I,L) = XL(I,L)*(AA(I,L)*DSH(I,L)-BB(I,L)*DTH(I,L))
        SSDEV(I,L) = XL(I,L)*(AA(I,L)*DSH(I,L)-
     1               BB(I,L)*plke(I,L+1)*DTH(I,L))
        SSDEV(I,L) = B2 * KHSAVE(I,L) * SSDEV(I,L) * SSDEV(I,L)
        TEMP(I,L) = SQRT(SSDEV(I,L))
        SVAR(I,L) = (1./2.) * (SVAR(I,L) + TEMP(I,L))
        IF ( SVAR(I,L).LT.Z1PEM25) SVAR(I,L) = Z1PEM25
       ENDDO
      ENDDO
      DO L =1,NLEVM1
       DO I =1,irun
        Q1M(I,L) = SBAR(I,L) / SVAR(I,L)
        FCC(I,L) = (1./2.) * ( 1. + ERRF( P5SR*Q1M(I,L) ) )
        SHL(I,L) =  FCC(I,L) * SBAR(I,L)
        ARG(I,L)  = (1./2.)*Q1M(I,L)*Q1M(I,L)
        IF(ARG(I,L).LE.ARGMAX)
     1        SHL(I,L) =  SHL(I,L)+RSQ2PI*SVAR(I,L)*EXP(-ARG(I,L))
        BETAT(I,L) = 1. + VIRTCON * SH(I,L) - VRT1CON * SHL(I,L)
        BETAW(I,L) = VIRTCON *
     1                ( TH(I,L) + (CLH/plk(I,L)) * SHL(I,L) )
        BETAL(I,L) = ( 1. + VIRTCON*SH(I,L) - TWO*VRT1CON*SHL(I,L) )
     1     * (CLH/plke(I,L+1)) - VRT1CON * TH(I,L)
COMMM   BETAT1(I,L) = BETAT(I,L) - BB(I,L) * FCC(I,L) * BETAL(I,L)
        BETAT1(I,L) = BETAT(I,L) -
     1               BB(I,L)*plk(i,L) * FCC(I,L) * BETAL(I,L)
        BETAW1(I,L) = BETAW(I,L) + AA(I,L) * FCC(I,L) * BETAL(I,L)
       ENDDO
      ENDDO
      DO L =1,NLEVM1
       DO I =1,irun
        DTHV(I,L) =  (1./2.)*((BETAT1(I,L)+BETAT1(I,L+1))*DTH(I,L)
     1               + (BETAW1(I,L)+BETAW1(I,L+1))*DSH(I,L))
       ENDDO
      ENDDO

C GRADIENTS AT THE TOP OF THE SURFACE LAYER
C -----------------------------------------
      DO 9102 I =1,irun
      DU(I,NLEV) = CU(I)*XX(I)*AHS(I)*RVK
      DV(I,NLEV) = V(I,NLEV) * DU(I,NLEV)
      DU(I,NLEV) = U(I,NLEV) * DU(I,NLEV)
      DTHV(I,NLEV) = CT(I) * YY(I) *
     1 ((THV(I,NLEV)-THV(I,NLEVP1)) * RVK)* AHS(I)
9102  CONTINUE

C CALCULATE BRUNT-VAISALA FREQUENCIES, SHEARS, RICHARDSON NUMBERS
C ---------------------------------------------------------------
      DO L =1,NLEV
       DO I =1,irun
        STRT(I,L) = CP * DTHV(I,L) * DPK(I,L)
        DW2(I,L) = DU(I,L) * DU(I,L) + DV(I,L) * DV(I,L)
        IF ( DW2(I,L) .LE. 1.e-4 ) DW2(I,L) = 1.e-4
        RI(I,L) = STRT(I,L) / DW2(I,L)
       ENDDO
      ENDDO
C FILL RICHARDSON NUMBER AND SURFACE WIND DIAGNOSTICS
C       (THOSE NEEDED FROM FIRST TRBFLX ITERATION)
C ---------------------------------------------------
      DO L =1,NLEVM1
       DO I =1,irun
        SRI(I,L) = RI(I,L)
       ENDDO
      ENDDO
      DO 9108 I =1,irun
      SRI(I,NLEV) = RIB(I)
9108  CONTINUE
      DO 9110 I =1,irun
      SWINDS(I) = WS(I)
9110  CONTINUE
C INITIALIZE KH, KM, QE AND P3 AND ELIMINATE SMALL QQ
C ---------------------------------------------------
      DO L =1,NLEVM1
       DO I =1,irun
        KH(I,L) = 0.
        KM(I,L) = 0.
        QQE(I,L) = 0.
        QE(I,L) = 0.
        P3(I,L) = 0.
        IBITSTB(I,L) = 0
        IF ( QQ(I,L) .GT. 1.e-8 ) THEN
         INTQ(I,L) = 1
        ELSE
         INTQ(I,L) = 0
        ENDIF
        IF ( QQ(I,L).LE.1.e-8 ) THEN
         QQ(I,L) = 0.
         Q(I,L) = 0.
        ENDIF
       ENDDO
      ENDDO

       DO 300 LMINQ = 1,NLEVM1
        IBIT = 0
        DO 9116 I = 1,irun
         IF ( QQ(I,LMINQ).GT.1.e-8 ) IBIT = IBIT + 1
 9116   CONTINUE
        IF(IBIT.GE.1)GO TO 310
 300   CONTINUE
       LMINQ = NLEV-1
 310   CONTINUE
       LMINQ  = 1
       LMINQ1 = 1
       IF(LMINQ.GT.1)LMINQ1 = LMINQ - 1
C LENGTH SCALE
C ------------
       CALL TRBLEN(STRT,DW2,DZ3,Q,VKZE,VKZM,DTHV,DPK,DU,DV,XL,QXLM,
     1  NLEV,INIT,LMIN,LMINQ,LMINQ1,CP,INT1,INT2,
     2  DZITRP,STBFCN,XL0,Q1,WRKIT1,WRKIT2,WRKIT3,WRKIT4,irun)
C QE AND DIMENSIONLESS COEFFS FROM LEVEL 2 MODEL
C ----------------------------------------------
      IF( LMIN .LT. NLEV ) THEN
       NLEVML = NLEV - LMIN
        CALL TRBL20(RI(1,LMIN),STRT(1,LMIN),DW2(1,LMIN),XL(1,LMIN),
     1   KM(1,LMIN),KH(1,LMIN),QE(1,LMIN),QQE(1,LMIN),IBITSTB(1,LMIN),
     2   NLEVML,nlev,irun)
      ENDIF
C FOR INITIAL START ONLY : USE EQUILIBRIUM MODEL
C ----------------------------------------------
      IF ( INIT .EQ. 1 ) THEN
      DO L =1,NLEVM1
       DO I =1,irun
        QQ(I,L) = QQE(I,L)
        Q(I,L) = QE(I,L)
       ENDDO
      ENDDO
       INIT = 2
        CALL TRBLEN(STRT,DW2,DZ3,Q,VKZE,VKZM,DTHV,DPK,DU,DV,XL,QXLM,
     1    NLEV,INIT,LMIN,LMINQ,LMINQ1,CP,INT1,INT2,
     2  DZITRP,STBFCN,XL0,Q1,WRKIT1,WRKIT2,WRKIT3,WRKIT4,irun)
       INIT = 0
       GO TO 550
      ENDIF
C DIMENSIONLESS COEFFS AND P3 (Q LE QE)
C -------------------------------------
      IF( LMIN .LT. NLEV ) THEN
       ISTNML = irun * NLEVML
       DO L =LMIN,NLEVM1
        DO I =1,irun
         IF (  (IBITSTB(I,L).EQ.1)  .AND.
     1             ( Q(I,L) .LE. QE(I,L) ) ) THEN
          IBITSTB(I,L) = 1
         ELSE
          IBITSTB(I,L) = 0
         ENDIF
        ENDDO
       ENDDO
       DO L =LMIN,NLEVM1
        DO I =1,irun
         IF(IBITSTB(I,L).EQ.1 ) THEN
          TEMP(I,L) = Q(I,L) / QE(I,L)
          KH(I,L) = TEMP(I,L) * KH(I,L)
          KM(I,L) = TEMP(I,L) * KM(I,L)
         ENDIF
         TEMP(I,L) = 0.01 * QQE(I,L)
         IF((IBITSTB(I,L).EQ.1) .AND.
     1         ( QQ(I,L) .LE. TEMP(I,L) )) THEN
          QQ(I,L) = TEMP(I,L)
          Q(I,L) = 0.1 * QE(I,L)
         ENDIF
         IF(IBITSTB(I,L).EQ.1 ) P3(I,L) = (2.*B3) *
     1             ( QE(I,L) - Q(I,L) )
        ENDDO
       ENDDO
      ENDIF
C DIMENSIONLESS COEFFS AND P3 (Q GT QE)
C -------------------------------------
       NLEVML = NLEV - LMINQ
       CALL TRBL25(Q(1,LMINQ),XL(1,LMINQ),STRT(1,LMINQ),DW2(1,LMINQ),
     1    IBITSTB(1,LMINQ),INTQ(1,LMINQ),KM(1,LMINQ),KH(1,LMINQ),
     2    P3(1,LMINQ),NLEVML,nlev,irun)
C CALCULATE SOURCE TERM P3
C ------------------------
      IF ( LMINQ .LT. LMIN ) THEN
       LMIN = LMINQ
       ISTNML = irun * ( NLEV - LMIN )
      ENDIF
      IF( LMIN .LT. NLEV ) THEN
       DO L =LMIN,NLEVM1
        DO I =1,irun
         P3(I,L) = P3(I,L) * DTAU / XL(I,L)
         TEMP(I,L) = QQE(I,L) * P3(I,L)
         XQ(I,L) = QQE(I,L) - QQ(I,L)
        ENDDO
       ENDDO
       DO L =LMIN,NLEVM1
        DO I =1,irun
         IF( ( (IBITSTB(I,L).EQ.1) .AND.
     1             ( XQ(I,L) .LT. TEMP(I,L) ) )
     2                  .OR.
     3       ( (IBITSTB(I,L).EQ.0) .AND.
     4             ( XQ(I,L) .GT. TEMP(I,L) ) ) )
     5   P3(I,L) = XQ(I,L) / QQE(I,L)
        ENDDO
       ENDDO
      ENDIF
 550  CONTINUE
C DIAGNOSTIC PROFILES : INITIAL RI AND QQ
C ---------------------------------------
      IF ( TPROF .AND. FIRST ) THEN
      DO 9118 I =1,irun
       RIBIN(I) = RIB(I)
       CUIN(I) = CU(I)
       CTIN(I) = CT(I)
       USTARIN(I) = USTAR(I)
       RHOSIN(I) = RHODZ2(I,NLEV)
       Z0IN(I) = Z0(I)
       ZETAIN(I) = ZETA(I)
9118  CONTINUE
      DO L =1,NLEV
       DO I =1,irun
        RIINIT(I,L) = RI(I,L)
        QQINIT(I,L) = QQ(I,L)
       ENDDO
      ENDDO
      ENDIF

C Zero diffusion of TKE above 10 mb
      do L = 1,nlev-1
        do i = 1,irun
c        if(pl(i,L).le.10.) then
c         qxlm(i,L) = 0.
c        endif
         if(pl(i,L).le.150.) then
          qxlm(i,L) = min(qxlm(i,L),5. _d 0)
         endif
        enddo
      enddo

C UPDATE TURBULENT KINETIC ENERGY QQ
C ----------------------------------
      NLEVMQ = NLEV - LMINQ1
      ISTNMQ = irun * NLEVMQ
      DO L =LMINQ1,NLEVM1
       DO I =1,irun
        RHOKDZ(I,L) = RHODZ1(I,L) * QXLM(I,L)
       ENDDO
      ENDDO
       CALL TRBDIF(QQ(1,LMINQ1),P3(1,LMINQ1),RHOKDZ(1,LMINQ1),
     1       FLXFCE(1,LMINQ1),DTHS,DELTHS,NLEVMQ,1,1.0 _d -20,irun)

C SAVE KH BEFORE ADDING DIMENSIONS FOR USE BY MOIST BOUYANCY CALCULATION

      DO L =1,NLEVM1
       DO I =1,irun
        KHSAVE(I,L) = KH(I,L)
       ENDDO
      ENDDO

C   DIMENSIONAL DIFFUSION COEFFS INCLUDING BACKGROUND AMOUNTS

      IF(LMINQ1.GT.1)THEN
       ISTLMQ = irun * (LMINQ1-1)
CB
       DO L =1,LMINQ1-1
        DO I =1,irun
         KM(I,L) = KMBG
         KH(I,L) = KHBG
        ENDDO
       ENDDO
CE
      ENDIF

CB
      DO L =LMINQ1,NLEVM1
       DO I =1,irun
        Q(I,L) = 2. * QQ(I,L)
        Q(I,L) = SQRT(Q(I,L))
        XQ(I,L)= XL(I,L) * Q(I,L)
        KM(I,L)=XQ(I,L)*KM(I,L)+KMBG
        KH(I,L)=XQ(I,L)*KH(I,L)+KHBG
       ENDDO
      ENDDO
CE
C Zero diffusion of u,v,t,q above 10 mb
      do L = 1,nlev-1
        do i = 1,irun
c        if(pl(i,L).le.10.) then
c         kh(i,L) = 0.
c         km(i,L) = 0.
c        endif
         if(pl(i,L).le.150.) then
          kh(i,L) = min(kh(i,L),5. _d 0)
          km(i,L) = min(km(i,L),5. _d 0)
         endif
        enddo
      enddo

C   CALCULATE INTERNAL FLUXES AND UPDATE PROGNOSTIC VARIABLES: TH AND S

      DO L =1,NLEV
       DO I =1,irun
        TEMP(I,L) = RHOZPK(I,L) * KH(I,L)
        DELTH(I,L) = 0.
       ENDDO
      ENDDO
      DO 9132 I =1,irun
      DELTH(I,NLEVP1) = 1.
9132  CONTINUE
       CALL TRBDIF(TH,DELTH,TEMP,FLXFPK,DTHS,DELTHS,NLEV,2,0. _d 0,irun)
      do i = 1,irun
       hsturb(i) = -1.* dths(i)
       dhsdtc(i) = -1.* delths(i)
      enddo
      do L = 1,nlev
       do i = 1,irun
        dthdthg(i,L) = delth(i,L)
       enddo
      enddo
      do L = 1,nlev
       do i = 1,irun
        transth(i,L) = temp(i,L)
       enddo
      enddo

      DO L =1,NLEV
       DO I =1,irun
        RHOKDZ(I,L) = RHODZ2(I,L) * KH(I,L)
        DELSH(I,L) = 0.
       ENDDO
      ENDDO
      DO 9140 I =1,irun
      DELSH(I,NLEVP1) = 1.
9140  CONTINUE

       CALL TRBDIF(SH,DELSH,RHOKDZ,FLXFAC,DTHL,DELTHL,NLEV,
     &                                     2,0. _d 0,irun)
      do i = 1,irun
       eturb(i) = -1.* dthl(i)
       dedqa(i) = -1.* delthl(i)
      enddo
      do L = 1,nlev
       do i = 1,irun
        dshdshg(i,L) = delsh(i,L)
       enddo
      enddo
      do L = 1,nlev
       do i = 1,irun
        transsh(i,L) = rhokdz(i,L)
       enddo
      enddo

C   Update Tracers Due to Turbulent Diffusion

      do i = 1,irun
      rhokdz(i,nlev) = 0.0
      enddo

c     do nt = 1,ntrace
c     do  i = 1,irun
c     tracers(i,nlev+1,nt) = tracers(i,nlev,nt)
c     enddo
c     CALL TRBDIF(tracers(1,1,nt),DELSH,RHOKDZ,FLXFAC,DTHL,DELTHL,
c    .                                         NLEV,4,0. _d 0,irun)
c     enddo

C   CALCULATE INTERNAL FLUXES AND UPDATE PROGNOSTIC VARIABLES: U AND V

      DO L =1,NLEV
       DO I =1,irun
        RHOKDZ(I,L) = RHODZ2(I,L) * KM(I,L)
       ENDDO
      ENDDO
       CALL TRBDIF(U,V,RHOKDZ,FLXFAC,DTHS,DELTHS,NLEV,3,0. _d 0,irun)
C ( FILL DIAGNOSTIC ARRAYS IF REQUIRED )
      DO L =1,NLEV
       DO I =1,irun
        WU(I,L) = WU(I,L) + RHOKDZ(I,L) * ( U(I,L+1) - U(I,L) )
        WV(I,L) = WV(I,L) + RHOKDZ(I,L) * ( V(I,L+1) - V(I,L) )
       ENDDO
      ENDDO
      DO L =1,NLEVM1
       DO I =1,irun
        IF ( QQ(I,L) .GT. QQMIN ) THEN
         IBITSTB(I,L) = 1
        ELSE
         IBITSTB(I,L) = 0
        ENDIF
        IF( IBITSTB(I,L).EQ.1 ) FREQDG(I,L) = FREQDG(I,L) + aitr
       ENDDO
      ENDDO
       do i = 1,irun
        qqcolmin(i) = qq(i,nlev)*0.1
        qqcolmax(i) = qq(i,nlev)
        levpbl(i) = nlev
       enddo
       DO L = nlev-1,1,-1
        DO I = 1,irun
         IF ( (qq(i,l).gt.qqcolmax(I)).and.(levpbl(i).eq.nlev))then
          qqcolmax(i) = qq(i,l)
          qqcolmin(i) = 0.1*qqcolmax(I)
         endif
         if((qq(i,l).lt.qqcolmin(i)).and.(levpbl(i).eq.nlev))
     1                                                levpbl(i)=l
        enddo
       enddo
       do i = 1,irun
        lp = levpbl(i)
        if(lp.lt.nlev)then
         pbldpth(I) = pbldpth(I) + ( (PLE(I,nlev+1)-PLE(I,Lp+2)) +
     1    ( (ple(i,lp+2)-ple(i,lp+1))*(qq(i,lp+1)-qqcolmin(i))
     2          / (qq(i,lp+1)-qq(i,lp)) ) ) * aitr
        else
         pbldpth(I) = pbldpth(I) + ( (PLE(I,nlev+1)-PLE(I,2)) +
     1    ( (ple(i,2)-ple(i,1))*(qq(i,1)-qqcolmin(i))
     2          / qq(i,1) ) ) * aitr
        endif
       enddo
      do i=1,irun
      sustar(i) = sustar(i) + aitr*ustar(i)
      enddo
      do i=1,irun
      sz0(i) = sz0(i) + aitr*z0(i)
      enddo
      DO L =1,NLEV
       DO I =1,irun
        EU(I,L) = EU(I,L) + AITR*KM(I,L)
        ET(I,L) = ET(I,L) + AITR*KH(I,L)
       ENDDO
      ENDDO
      DO I =1,irun
      scu(I) = scu(I) + AITR*cu(I)
      enddo
      DO I =1,irun
      sct(I) = sct(I) + AITR*ct(I)
      enddo
      IF(tprof) then
       DO L =1,NLEVM1
        DO I =1,irun
         XLDIAG(I,L) = XLDIAG(I,L) + AITR*XL(I,L)
        ENDDO
       ENDDO
      endif
      FIRST = .FALSE.

C SAVE XL,CT,XX,YY,ZETA FOR USE BY MOIST BOUYANCY CALCULATION

      IF(ITER.EQ.ITRTRB)THEN
       DO L =1,NLEVM1
        DO I =1,irun
         XLSAVE(I,L) = XL(I,L)
        ENDDO
       ENDDO
       DO I = 1,irun
        CTSAVE(I) = CT(I)
        XXSAVE(I) = XX(I)
        YYSAVE(I) = YY(I)
        ZETASAVE(I) = ZETA(I)
       ENDDO
      ENDIF

      DO L =1,NLEV
       DO I =1,irun
        turbfcc(I,L) = turbfcc(I,L) + fcc(I,L) * aitr
        qliq(I,L) = qliq(I,L) + shl(I,L) * aitr
       ENDDO
      ENDDO

C   END OF MAIN LOOP

 2000 CONTINUE
      DO L =1,NLEV
       DO I =1,irun
        WU(I,L) =  WU(I,L) * AITR
        WV(I,L) =  WV(I,L) * AITR
       ENDDO
      ENDDO

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

       SUBROUTINE SFCFLX(NN,VUS,VVS,VTHV1,VTHV2,VTH1,VTH2,VSH1,
     1      VSH2,VPK,VPKE,VPE,VZ0,IVWATER,VHS,
     2      VAHS,FIRST,LAST,N,IRUN,aitr,VRHO,VRHOZPK,VKH,VKM,
     3      VUSTAR,VXX,VYY,VCU,VCT,VRIB,VZETA,VWS,
     4      stu2m,stv2m,stt2m,stq2m,stu10m,stv10m,stt10m,stq10m,
     5      cp,rgas,undef,
     6      lwater, ivbitrib,
     7      VHZ,VPSIM,VAPSIM,VPSIG,VPSIHG,VTEMP,VDZETA,VDZ0,VDPSIM,
     8      VDPSIH,VZH,VXX0,VYY0,VAPSIHG,VRIB1,VWS1,VPSIH,VZETAL,
     9      VZ0L,VPSIH2,VH0,
     3 VX0PSIM,VG,VG0,VR1MG0,VZ2,VDZSEA,VAZ0,VXNUM1,VPSIGB2,VDX,
     4 VDXPSIM,VDY,VXNUM2,VDEN,VAWS1,VXNUM3,VXNUM,VDZETA1,VDZETA2,
     5 VZCOEF2,VZCOEF1,VTEMPLIN,VDPSIMC,VDPSIHC)
C**********************************************************************
C  SUBROUTINE SFCFLX - COMPUTES SURFACE TRANSFER COEFFICIENTS
C                    - CALLED FROM TRBFLX
C   ARGUMENTS ::
C     INPUT:
C     ------
C    US            -         U - COMPONENT OF SURFACE WIND
C    VS            -         V - COMPONENT OF SURFACE WIND
C    THV1          -         VIRTUAL POTENTIAL TEMPERATURE AT NLAY
C    THV2          -         VIRTUAL POTENTIAL TEMPERATURE AT GROUND
C    TH1           -         POTENTIAL TEMPERATURE AT NLAY
C    TH2           -         POTENTIAL TEMPERATURE AT GROUND
C    SH1           -         SPECIFIC HUMIDITY AT NLAY
C    SH2           -         SPECIFIC HUMIDITY AT GROUND
C    PK            -         EVEN LEVEL PRESSURE ** KAPPA AT LEVEL NLAY
C    PKE           -         EDGE LEVEL PRESSURE ** KAPPA AT GROUND
C    PE            -         SURFACE PRESSURE
C    Z0            -         SURFACE ROUGHNESS
C    WATER         -         BIT ARRAY - '1' OVER OCEANS
C    HS            -         DEPTH OF SURFACE LAYER
C    AHS           -         ONE / HS
C    FIRST         -         LOGICAL .TRUE. FOR FIRST TRBFLX ITERATION
C    LAST          -         LOGICAL .TRUE. FOR LAST TRBFLX ITERATION
C    N             -         NUMBER OF SFCFLX ITERATIONS
C     OUTPUT:
C     -------
C    RHO           -         DENSITY AT 10M HEIGHT
C    RHOZPK        -         RHO * P**K AT THE SURFACE
C    KH            -         HEAT TRANSFER COEFFICIENT (CT*USTAR)
C    KM            -         MOMENTUM TRANSFER COEFFICIENT (CU*USTAR)
C    USTAR         -         FRICTION VELOCITY
C    XX            -         PHIM(ZETA) - DIMENSIONLESS WIND SHEAR
C    YY            -         PHIH(ZETA) - DIMENSIONLESS TEMP GRADIENT
C    CU            -         MOMENTUM TRANSPORT COEFFICIENT
C    CT            -         HEAT TRANSPORT COEFFICIENT
C**********************************************************************
      implicit none

C Argument List Declarations
      integer nn,n,irun
      _RL aitr,cp,rgas,undef
      _RL VUS(IRUN),VVS(IRUN),VTHV1(IRUN),VTHV2(IRUN)
      _RL VTH1(IRUN),VTH2(IRUN),VSH1(IRUN),VSH2(IRUN)
      _RL VPK(IRUN),VPKE(IRUN),VPE(IRUN)
      _RL VZ0(IRUN),VHS(IRUN),VAHS(IRUN)
      integer IVWATER(IRUN)
      LOGICAL FIRST,LAST
      _RL VRHO(IRUN),VRHOZPK(IRUN)
      _RL VKM(IRUN),VKH(IRUN),VUSTAR(IRUN),VXX(IRUN)
      _RL VYY(IRUN),VCU(IRUN),VCT(IRUN),VRIB(IRUN)
      _RL VZETA(IRUN),VWS(IRUN)
      _RL stu2m(irun),stv2m(irun),stt2m(irun),stq2m(irun)
      _RL stu10m(irun),stv10m(irun),stt10m(irun),stq10m(irun)
      LOGICAL LWATER
      integer IVBITRIB(irun)
      _RL VHZ(irun),VPSIM(irun),VAPSIM(irun),VPSIG(irun),VPSIHG(irun)
      _RL VTEMP(irun),VDZETA(irun),VDZ0(irun),VDPSIM(irun)
      _RL VDPSIH(irun),VZH(irun),VXX0(irun),VYY0(irun)
      _RL VAPSIHG(irun),VRIB1(irun),VWS1(irun)
      _RL VPSIH(irun),VZETAL(irun),VZ0L(irun),VPSIH2(irun),VH0(irun)
      _RL VX0PSIM(irun),VG(irun),VG0(irun),VR1MG0(irun)
      _RL VZ2(irun),VDZSEA(irun),VAZ0(irun),VXNUM1(irun)
      _RL VPSIGB2(irun),VDX(irun),VDXPSIM(irun),VDY(irun)
      _RL VXNUM2(irun),VDEN(irun),VAWS1(irun),VXNUM3(irun)
      _RL VXNUM(irun),VDZETA1(irun),VDZETA2(irun)
      _RL VZCOEF2(irun),VZCOEF1(irun),VTEMPLIN(irun)
      _RL VDPSIMC(irun),VDPSIHC(irun)

C Local Variables
      _RL USTMX3,USTZ0S,Z0MIN,H0BYZ0,USTH0S,H0VEG,Z0VEGM,PRFAC
      _RL XPFAC,DIFSQT
      PARAMETER ( USTMX3 =   0.0632456)
      PARAMETER ( USTZ0S =   0.2030325E-5)
      PARAMETER ( Z0MIN  =  USTZ0S/USTMX3)
      PARAMETER ( H0BYZ0 =    30.0    )
      PARAMETER ( USTH0S =  H0BYZ0*USTZ0S )
      PARAMETER ( H0VEG  =   0.01     )
      PARAMETER ( Z0VEGM =   0.005    )
      PARAMETER ( PRFAC  = 0.595864   )
      PARAMETER ( XPFAC  = .55        )
      PARAMETER ( DIFSQT  = 3.872983E-3)

      _RL psihdiag(irun),psimdiag(irun)
      _RL getcon,vk,rvk,vk2,bmdl
      integer iwater,itype
      integer i,iter

      vk = getcon('VON KARMAN')
      rvk = 1./vk
      vk2 = vk*vk
      BMDL    = VK * XPFAC * PRFAC / DIFSQT

C     DETERMINE SURFACE WIND MAGNITUDE AND BULK RICHARDSON NUMBER

      DO 9000 I = 1,IRUN
       VWS(I) = VUS(I) * VUS(I) + VVS(I) * VVS(I)
       IF ( VWS(I) .LE. 1.e-4) VWS(I) = 1.e-4
       VRIB(I) = ( CP * (VPKE(I)-VPK(I)) ) *
     1       (VTHV1(I) - VTHV2(I)) / VWS(I)
       VWS(I) = SQRT( VWS(I) )
 9000 CONTINUE

C     INITIALIZATION (FIRST TRBFLX ITERATION)
C  INITIAL GUESS FOR ROUGHNESS LENGTH Z0 OVER WATER

      IF (.NOT. FIRST) GO TO 100

      IWATER = 0
      DO 9002 I = 1,IRUN
       IF (IVWATER(I).EQ.1)  IWATER = IWATER + 1
 9002 CONTINUE
      LWATER = .FALSE.
      IF(IWATER.GE.1)LWATER = .TRUE.

      IF(LWATER)THEN
       DO 9004 I = 1,IRUN
        IF (IVWATER(I).EQ.1) VZ0(I) = 0.0003
 9004  CONTINUE
      ENDIF
      do i = 1,irun
       vh0(i) = h0byz0 * vz0(i)
       if(vz0(i).ge.z0vegm)vh0(i) = h0veg
       enddo

C     CU AND PSIHG FOR NEUTRALLY STRATIFIED FLOW

      DO 9006 I = 1,IRUN
       VHZ(I) = VHS(I) / VZ0(I)
       VPSIM(I) = LOG( VHZ(I) )
       VAPSIM(I) = 1. / VPSIM(I)
       VCU(I) = VK * VAPSIM(I)
       VUSTAR(I) = VCU(I) * VWS(I)

       VPSIG(I) = VH0(I) * VUSTAR(I) - USTH0S
       if(VPSIG(I).lt.0.)  VPSIG(I) = 0.
       VPSIG(I) = SQRT( VPSIG(I) )
       VPSIG(I) = BMDL * VPSIG(I)
       VPSIHG(I) = VPSIM(I) + VPSIG(I)
 9006 CONTINUE

C     LINEAR CORRECTION FOR ERROR IN ROUGHNESS LENGTH Z0

      IF(LWATER)THEN
       DO 9008 I = 1,IRUN
        VTEMP(I) = 0.
 9008  CONTINUE
       CALL LINADJ(NN,VRIB,VRIB,VWS,
     1  VWS,VZ0,VUSTAR,IVWATER,
     2  VAPSIM,VTEMP,VTEMP,
     3  VTEMP,VTEMP,VTEMP,
     4  VTEMP,VTEMP,1,.TRUE.,IRUN,VDZETA,
     5  VDZ0,VDPSIM,VDPSIH,
     6  IVBITRIB,
     3 VX0PSIM,VG,VG0,VR1MG0,VZ2,VDZSEA,VAZ0,VXNUM1,VPSIGB2,VDX,
     4 VDXPSIM,VDY,VXNUM2,VDEN,VAWS1,VXNUM3,VXNUM,VDZETA1,VDZETA2,
     5 VZCOEF2,VZCOEF1,VTEMPLIN,VDPSIMC,VDPSIHC)
       DO 9010 I = 1,IRUN
        IF ( IVWATER(I).EQ.1 ) THEN
         VCU(I) = VCU(I) * (1. - VDPSIM(I)*VAPSIM(I))
         VZ0(I) = VZ0(I) + VDZ0(I)
         ENDIF
         IF ( IVWATER(I).EQ.1) THEN
         IF ( VZ0(I) .LE. Z0MIN ) VZ0(I) = Z0MIN
         vh0(i) = h0byz0 * vz0(i)
         VPSIG(I) = VH0(I) * VCU(I) * VWS(I) - USTH0S
         if(VPSIG(I).lt.0.)  VPSIG(I) = 0.
         VPSIG(I) = SQRT( VPSIG(I) )
         VPSIG(I) = BMDL * VPSIG(I)
         VPSIHG(I) = VPSIM(I) + VDPSIH(I) + VPSIG(I)
        ENDIF
 9010  CONTINUE
      ENDIF

C  INITIAL GUESS FOR STABILITY PARAMETER ZETA

      DO 9012 I = 1,IRUN
       VZETA(I) = VK2 * VRIB(I) / (VCU(I) * VCU(I) * VPSIHG(I))
 9012 CONTINUE

C  RECOMPUTE CU, ESTIMATE PSIHG AND UPDATE ZETA AND Z0

      DO 9014 I = 1,IRUN
       VZH(I) = VZ0(I) * VAHS(I)
 9014 CONTINUE
      CALL PSI (VZETA,VZH,VPSIM,
     1    VTEMP,IRUN,VXX,VXX0,VYY,
     2    VYY0,2)
      DO 9016 I = 1,IRUN
       VCU(I) = VK / VPSIM(I)
       VPSIG(I) = VH0(I) * VCU(I) * VWS(I) - USTH0S
       if(VPSIG(I).lt.0.)  VPSIG(I) = 0.
       VPSIG(I) = SQRT(VPSIG(I))
       VPSIG(I) = BMDL * VPSIG(I)
       VPSIHG(I) = VPSIM(I) + VPSIG(I)
       VZETA(I) = VK2 * VRIB(I) / (VCU(I) * VCU(I) * VPSIHG(I))
 9016 CONTINUE

      IF(LWATER)THEN
CCCOOOMMMM ADDED 'WHERE WATER'
       DO 9018 I = 1,IRUN
        IF (IVWATER(I).EQ.1) VUSTAR(I) = VCU(I) * VWS(I)
 9018  CONTINUE
        CALL ZCSUB ( VUSTAR,VHZ,IVWATER,.FALSE.,IRUN,VTEMP)
       DO 9020 I = 1,IRUN
        IF (IVWATER(I).EQ.1 ) then
         VZ0(I) = VTEMP(I)
         IF ( VZ0(I) .LE. Z0MIN ) VZ0(I) = Z0MIN
         vh0(i) = h0byz0 * vz0(i)
        endif
 9020  CONTINUE
      ENDIF

      GO TO 125

C  LINEARLY UPDATE ZETA AND Z0 FOR SECOND OR GREATER TRBFLX ITERATION

 100  CONTINUE

      CALL LINADJ(NN,VRIB1,VRIB,VWS1,
     1  VWS,VZ0,VUSTAR,IVWATER,
     2  VAPSIM,VAPSIHG,VPSIH,
     3  VPSIG,VXX,VXX0,
     4  VYY,VYY0,2,LWATER,IRUN,VDZETA,
     5  VDZ0,VDPSIM,VDPSIH,
     6  IVBITRIB,
     3 VX0PSIM,VG,VG0,VR1MG0,VZ2,VDZSEA,VAZ0,VXNUM1,VPSIGB2,VDX,
     4 VDXPSIM,VDY,VXNUM2,VDEN,VAWS1,VXNUM3,VXNUM,VDZETA1,VDZETA2,
     5 VZCOEF2,VZCOEF1,VTEMPLIN,VDPSIMC,VDPSIHC)

      DO 9022 I = 1,IRUN
       VZETA(I) = VZETA(I) + VZETAL(I) * VDZETA(I)
       IF (IVBITRIB(I).EQ.1 )VZETA(I) =
     1       VPSIM(I) * VPSIM(I) * VRIB(I) * VCT(I) * RVK
 9022 CONTINUE

      IF ( LWATER ) THEN
       DO 9024 I = 1,IRUN
        IF (IVWATER(I).EQ.1 ) then
         VZ0(I) = VZ0(I) + VZ0L(I) * VDZ0(I)
         IF (VZ0(I) .LE. Z0MIN ) VZ0(I) = Z0MIN
         vh0(i) = h0byz0 * vz0(i)
        endif
 9024  CONTINUE
      ENDIF

 125  CONTINUE

C  ITERATIVE LOOP - N ITERATIONS
C     COMPUTE CU AND CT

      DO 200 ITER = 1,N
       DO 9026 I = 1,IRUN
        VZH(I) = VZ0(I) * VAHS(I)
 9026  CONTINUE
       CALL PSI (VZETA,VZH,VPSIM,
     1    VPSIH,IRUN,VXX,VXX0,VYY,
     2    VYY0,1)
       DO 9028 I = 1,IRUN
        VCU(I) = VK / VPSIM(I)
        VUSTAR(I) = VCU(I) * VWS(I)

        VPSIG(I) = VH0(I) * VUSTAR(I) - USTH0S
        if(VPSIG(I).lt.0.)  VPSIG(I) = 0.
        VPSIG(I) = SQRT(VPSIG(I))
        VPSIG(I) = BMDL * VPSIG(I)
        VPSIHG(I) = VPSIH(I) + VPSIG(I)

C  LINEAR CORRECTIONS FOR CU, CT, ZETA, AND Z0

        VAPSIM(I) = VCU(I) * RVK
        VAPSIHG(I) = 1. / VPSIHG(I)
        VRIB1(I) = VAPSIM(I) * VAPSIM(I) * VPSIHG(I) * VZETA(I)
 9028  CONTINUE

       ITYPE = 3
       IF(ITER.EQ.N) ITYPE = 4
       IF( (ITYPE.EQ.4) .AND. (.NOT.LAST) ) ITYPE = 5

       CALL LINADJ(NN,VRIB1,VRIB,VWS,
     1  VWS,VZ0,VUSTAR,IVWATER,
     2  VAPSIM,VAPSIHG,VPSIH,
     3  VPSIG,VXX,VXX0,
     4  VYY,VYY0,ITYPE,LWATER,IRUN,VDZETA,
     5  VDZ0,VDPSIM,VDPSIH,
     6  IVBITRIB,
     3 VX0PSIM,VG,VG0,VR1MG0,VZ2,VDZSEA,VAZ0,VXNUM1,VPSIGB2,VDX,
     4 VDXPSIM,VDY,VXNUM2,VDEN,VAWS1,VXNUM3,VXNUM,VDZETA1,VDZETA2,
     5 VZCOEF2,VZCOEF1,VTEMPLIN,VDPSIMC,VDPSIHC)

C  UPDATES OF ZETA, Z0, CU AND CT

       IF (ITYPE.EQ.5) THEN
        DO 9030 I = 1,IRUN
         VZETAL(I) = VZETA(I)
         VZ0L(I) = VZ0(I)
 9030   CONTINUE
       ENDIF

       DO 9032 I = 1,IRUN
        VZETA(I) = VZETA(I) * ( 1. + VDZETA(I) )
        IF (IVBITRIB(I).EQ.1 ) VZETA(I) =
     1        VPSIM(I) * VPSIM(I) * VRIB(I) * VAPSIHG(I)
 9032  CONTINUE

       IF ( LWATER ) THEN
        DO 9034 I = 1,IRUN
         IF (IVWATER(I).EQ.1 ) then
          VZ0(I) = VZ0(I) * ( 1. + VDZ0(I) )
          IF (VZ0(I) .LE. Z0MIN ) VZ0(I) = Z0MIN
          vh0(i) = h0byz0 * vz0(i)
         endif
 9034   CONTINUE
       ENDIF

       IF ( ITER .EQ. N ) THEN
        DO 9036 I = 1,IRUN
         VPSIM(I) = VPSIM(I) + VDPSIM(I)
         VCU(I) = VK / VPSIM(I)
         VUSTAR(I) = VCU(I) * VWS(I)

         VPSIG(I) = VH0(I) * VUSTAR(I) - USTH0S
         if(VPSIG(I).lt.0.)  VPSIG(I) = 0.
         VPSIG(I) = SQRT(VPSIG(I))
         VPSIG(I) = BMDL * VPSIG(I)
         VPSIHG(I) = VPSIH(I) + VDPSIH(I) + VPSIG(I)
         VCT(I) = VK / VPSIHG(I)
 9036   CONTINUE
       ENDIF

C  SAVE VALUES OF RIB AND WS FOR NEXT ITERATION OF TRBFLX

       IF (ITYPE.EQ.5) THEN
        DO 9038 I = 1,IRUN
         VRIB1(I) = VRIB(I)
         VWS1(I) = VWS(I)
 9038   CONTINUE
       ENDIF

 200  CONTINUE

C  CALCULATE RHO-SURFACE ( KG / M**3 )

      IF (FIRST) THEN
       DO I = 1,IRUN
        VTEMP(I) =  10. * VAHS(I) * VZETA(I)
        VZH(I) = VZ0(I) * 0.1
       ENDDO
       CALL PSI (VTEMP,VZH,VHZ,
     1    VPSIH2,IRUN,VHZ,VHZ,VHZ,
     2    VHZ,3)
       DO I = 1,IRUN
        VTEMP(I) = ( VPSIH2(I) + VPSIG(I) ) / VPSIHG(I)
        VRHO(I) = VPKE(I)*( VTH2(I) + VTEMP(I) * (VTH1(I)-VTH2(I)) )
        VRHO(I) = VPE(I)*100. / ( RGAS * VRHO(I) )
       ENDDO
      ENDIF

C interpolate uvtq to 2m and to 10 meters for diagnostic output
C  use psih and psim which represent non-dim change from ground
C                 to specified level
C and multiply theta by surface p**kappa to get temperatures

        do i = 1,irun
         vtemp(i) = 2. * vahs(i) * vzeta(i)
         vzh(i) = vz0(i) * 0.5
         if(vz0(i).ge.2.)vzh(i) = 0.9
        enddo
        call psi(vtemp,vzh,psimdiag,psihdiag,irun,vhz,vhz,vhz,vhz,1)
        do i = 1,irun
         stu2m(i) = (psimdiag(i)/vpsim(i) * vus(i))
         stv2m(i) = (psimdiag(i)/vpsim(i) * vvs(i))
         stt2m(i) = ( (vth2(i) + ((psihdiag(i)+vpsig(i))/vpsihg(i))*
     1                             (vth1(i)-vth2(i))) ) * vpke(i)
         stq2m(i) = (vsh2(i) + ((psihdiag(i)+vpsig(i))/vpsihg(i))*
     1                                             (vsh1(i)-vsh2(i)))
         if(vz0(i).ge.2.)then
          stu2m(i) = UNDEF
          stv2m(i) = UNDEF
          stt2m(i) = UNDEF
          stq2m(i) = UNDEF
         endif
        enddo
        do i = 1,irun
         vtemp(i) = 10. * vahs(i) * vzeta(i)
         vzh(i) = vz0(i) * 0.1
        enddo
        call psi(vtemp,vzh,psimdiag,psihdiag,irun,vhz,vhz,vhz,vhz,1)
        do i = 1,irun
         stu10m(i) = (psimdiag(i)/vpsim(i) * vus(i))
         stv10m(i) = (psimdiag(i)/vpsim(i) * vvs(i))
         stt10m(i) = ( (vth2(i) + ((psihdiag(i)+vpsig(i))/vpsihg(i))*
     1                            (vth1(i)-vth2(i))) ) * vpke(i)
         stq10m(i) = (vsh2(i) + ((psihdiag(i)+vpsig(i))/vpsihg(i))*
     1                                             (vsh1(i)-vsh2(i)))
        enddo

C  EVALUATE TURBULENT TRANSFER COEFFICIENTS

      DO 9044 I = 1,IRUN
       VRHOZPK(I) = VRHO(I) * VPKE(I)
       VKH(I) = VUSTAR(I) * VCT(I)
       VKM(I) = VUSTAR(I) * VCU(I)
 9044 CONTINUE

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      SUBROUTINE PHI(Z,PHIM,PHIH,IFLAG,N)
C**********************************************************************
C  FUNCTION PHI - SOLVES KEYPS EQUATIONS
C               - CALLED FROM PSI
C  DESCRIPTION OF PARAMETERS
C     Z     -  INPUTED VALUE OF MONIN- OBUKHOV STABILITY PARAMETER ZETA
C               TIMES APPROPRIATE CONSTANT
C     PHIM  -  OUTPUTED SOLUTION OF KEYPS EQUATION FOR MOMENTUM
C     PHIH  -  OUTPUTED SOLUTION OF KEYPS EQUATION FOR SCALARS
C     IFLAG -  FLAG TO DETERMINE IF X IS NEEDED (IFLAG=2), Y IS NEEDED
C                  (IFLAG=3), OR BOTH (IFLAG=1)
C     N     -  LENGTH OF VECTOR TO BE SOLVED
C**********************************************************************
      implicit none

C Argument List Declarations
      integer n,iflag
      _RL PHIM(N),PHIH(N),Z(N)

C Local Variables
      integer I1(N),I2(N)
      _RL ZSTAR(N),E1(N),E2(N),TEMP1(N)

      _RL PHIM0(385),ZLINM1(75),ZLINM2(75),ZLINM3(36)
      _RL ZLOGM1(74),ZLOGM2(75),ZLOGM3(50)
      _RL PHIH0(385),ZLINH1(75),ZLINH2(75),ZLINH3(36)
      _RL ZLOGH1(74),ZLOGH2(75),ZLOGH3(50)
      EQUIVALENCE (PHIM0(1),ZLINM1(1)),(PHIM0(76),ZLINM2(1))
      EQUIVALENCE (PHIM0(151),ZLINM3(1))
      EQUIVALENCE (PHIM0(187),ZLOGM1(1)),(PHIM0(261),ZLOGM2(1))
      EQUIVALENCE (PHIM0(336),ZLOGM3(1))
      EQUIVALENCE (PHIH0(1),ZLINH1(1)),(PHIH0(76),ZLINH2(1))
      EQUIVALENCE (PHIH0(151),ZLINH3(1))
      EQUIVALENCE (PHIH0(187),ZLOGH1(1)),(PHIH0(261),ZLOGH2(1))
      EQUIVALENCE (PHIH0(336),ZLOGH3(1))

       DATA ZLOGM1/
     &             0.697894,0.678839,0.659598,0.640260,
     &  0.620910,0.601628,0.582486,0.563550,0.544877,
     &  0.526519,0.508516,0.490903,0.473708,0.456951,
     &  0.440649,0.424812,0.409446,0.394553,0.380133,
     &  0.366182,0.352695,0.339664,0.327082,0.314938,
     &  0.303222,0.291923,0.281029,0.270528,0.260409,
     &  0.250659,0.241267,0.232221,0.223509,0.215119,
     &  0.207041,0.199264,0.191776,0.184568,0.177628,
     &  0.170949,0.164519,0.158331,0.152374,0.146641,
     &  0.141123,0.135813,0.130702,0.125783,0.121048,
     &  0.116492,0.112107,0.107887,0.103826,0.0999177,
     &  0.0961563,0.0925364,0.0890528,0.0857003,0.0824739,
     &  0.0793690,0.0763810,0.0735054,0.0707380,0.0680749,
     &  0.0655120,0.0630455,0.0606720,0.0583877,0.0561895,
     &  0.0540740,0.0520382,0.0500790,0.0481936,0.0463791/
       DATA ZLOGM2/
     &  0.0446330,0.0429526,0.0413355,0.0397792,0.0382816,
     &  0.0368403,0.0354533,0.0341185,0.0328340,0.0315978,
     &  0.0304081,0.0292633,0.0281616,0.0271013,0.0260809,
     &  0.0250990,0.0241540,0.0232447,0.0223695,0.0215273,
     &  0.0207168,0.0199369,0.0191862,0.0184639,0.0177687,
     &  0.0170998,0.0164560,0.0158364,0.0152402,0.0146664,
     &  0.0141142,0.0135828,0.0130714,0.0125793,0.0121057,
     &  0.0116499,0.0112113,0.0107892,0.0103830,0.999210E-2,
     &  0.961590E-2,0.925387E-2,0.890547E-2,0.857018E-2,0.824752E-2,
     &  0.793701E-2,0.763818E-2,0.735061E-2,0.707386E-2,0.680754E-2,
     &  0.655124E-2,0.630459E-2,0.606722E-2,0.583880E-2,0.561897E-2,
     &  0.540742E-2,0.520383E-2,0.500791E-2,0.481937E-2,0.463792E-2,
     &  0.446331E-2,0.429527E-2,0.413355E-2,0.397793E-2,0.382816E-2,
     &  0.368403E-2,0.354533E-2,0.341185E-2,0.328340E-2,0.315978E-2,
     &  0.304082E-2,0.292633E-2,0.281616E-2,0.271013E-2,0.260809E-2/
       DATA ZLOGM3/
     &  0.250990E-2,0.241541E-2,0.232447E-2,0.223695E-2,0.215273E-2,
     &  0.207168E-2,0.199369E-2,0.191862E-2,0.184639E-2,0.177687E-2,
     &  0.170998E-2,0.164560E-2,0.158364E-2,0.152402E-2,0.146664E-2,
     &  0.141142E-2,0.135828E-2,0.130714E-2,0.125793E-2,0.121057E-2,
     &  0.116499E-2,0.112113E-2,0.107892E-2,0.103830E-2,0.999210E-3,
     &  0.961590E-3,0.925387E-3,0.890547E-3,0.857018E-3,0.824752E-3,
     &  0.793701E-3,0.763818E-3,0.735061E-3,0.707386E-3,0.680754E-3,
     &  0.655124E-3,0.630459E-3,0.606722E-3,0.583880E-3,0.561897E-3,
     &  0.540742E-3,0.520383E-3,0.500791E-3,0.481937E-3,0.463792E-3,
     &  0.446331E-3,0.429527E-3,0.413355E-3,0.397793E-3,0.382816E-3/
       DATA ZLOGH1/
     &             0.640529,0.623728,0.606937,0.590199,
     &  0.573552,0.557032,0.540672,0.524504,0.508553,
     &  0.492843,0.477397,0.462232,0.447365,0.432809,
     &  0.418574,0.404670,0.391103,0.377878,0.364999,
     &  0.352468,0.340284,0.328447,0.316954,0.305804,
     &  0.294992,0.284514,0.274364,0.264538,0.255028,
     &  0.245829,0.236933,0.228335,0.220026,0.211999,
     &  0.204247,0.196762,0.189537,0.182564,0.175837,
     &  0.169347,0.163088,0.157051,0.151231,0.145620,
     &  0.140211,0.134998,0.129974,0.125133,0.120469,
     &  0.115975,0.111645,0.107475,0.103458,0.995895E-1,
     &  0.958635E-1,0.922753E-1,0.888199E-1,0.854925E-1,0.822886E-1,
     &  0.792037E-1,0.762336E-1,0.733739E-1,0.706208E-1,0.679704E-1,
     &  0.654188E-1,0.629625E-1,0.605979E-1,0.583217E-1,0.561306E-1,
     &  0.540215E-1,0.519914E-1,0.500373E-1,0.481564E-1,0.463460E-1/
       DATA ZLOGH2/
     &  0.446034E-1,0.429263E-1,0.413120E-1,0.397583E-1,0.382629E-1,
     &  0.368237E-1,0.354385E-1,0.341053E-1,0.328222E-1,0.315873E-1,
     &  0.303988E-1,0.292550E-1,0.281541E-1,0.270947E-1,0.260750E-1,
     &  0.250937E-1,0.241494E-1,0.232405E-1,0.223658E-1,0.215240E-1,
     &  0.207139E-1,0.199342E-1,0.191839E-1,0.184618E-1,0.177669E-1,
     &  0.170981E-1,0.164545E-1,0.158351E-1,0.152390E-1,0.146653E-1,
     &  0.141133E-1,0.135820E-1,0.130707E-1,0.125786E-1,0.121051E-1,
     &  0.116494E-1,0.112108E-1,0.107888E-1,0.103826E-1,0.999177E-2,
     &  0.961561E-2,0.925360E-2,0.890523E-2,0.856997E-2,0.824733E-2,
     &  0.793684E-2,0.763803E-2,0.735048E-2,0.707375E-2,0.680743E-2,
     &  0.655114E-2,0.630450E-2,0.606715E-2,0.583873E-2,0.561891E-2,
     &  0.540737E-2,0.520379E-2,0.500787E-2,0.481933E-2,0.463789E-2,
     &  0.446328E-2,0.429524E-2,0.413353E-2,0.397790E-2,0.382814E-2,
     &  0.368401E-2,0.354532E-2,0.341184E-2,0.328338E-2,0.315977E-2,
     &  0.304081E-2,0.292632E-2,0.281615E-2,0.271012E-2,0.260809E-2/
       DATA ZLOGH3/
     &  0.250990E-2,0.241540E-2,0.232446E-2,0.223695E-2,0.215273E-2,
     &  0.207168E-2,0.199368E-2,0.191862E-2,0.184639E-2,0.177687E-2,
     &  0.170997E-2,0.164559E-2,0.158364E-2,0.152402E-2,0.146664E-2,
     &  0.141142E-2,0.135828E-2,0.130714E-2,0.125793E-2,0.121057E-2,
     &  0.116499E-2,0.112113E-2,0.107892E-2,0.103830E-2,0.999209E-3,
     &  0.961590E-3,0.925387E-3,0.890546E-3,0.857018E-3,0.824752E-3,
     &  0.793700E-3,0.763818E-3,0.735061E-3,0.707386E-3,0.680754E-3,
     &  0.655124E-3,0.630459E-3,0.606722E-3,0.583880E-3,0.561897E-3,
     &  0.540742E-3,0.520383E-3,0.500791E-3,0.481937E-3,0.463792E-3,
     &  0.446331E-3,0.429527E-3,0.413355E-3,0.397793E-3,0.382816E-3/

       DATA ZLINM1/
     &  0.964508,0.962277,0.960062,0.957863,0.955680,
     &  0.953512,0.951359,0.949222,0.947100,0.944992,
     &  0.942899,0.940821,0.938758,0.936709,0.934673,
     &  0.932652,0.930645,0.928652,0.926672,0.924706,
     &  0.922753,0.920813,0.918886,0.916973,0.915072,
     &  0.913184,0.911308,0.909445,0.907594,0.905756,
     &  0.903930,0.902115,0.900313,0.898522,0.896743,
     &  0.894975,0.893219,0.891475,0.889741,0.888019,
     &  0.886307,0.884607,0.882917,0.881238,0.879569,
     &  0.877911,0.876264,0.874626,0.872999,0.871382,
     &  0.869775,0.868178,0.866591,0.865013,0.863445,
     &  0.861887,0.860338,0.858798,0.857268,0.855747,
     &  0.854235,0.852732,0.851238,0.849753,0.848277,
     &  0.846809,0.845350,0.843900,0.842458,0.841025,
     &  0.839599,0.838182,0.836774,0.835373,0.833980/
       DATA ZLINM2/
     &  0.832596,0.831219,0.829850,0.828489,0.827136,
     &  0.825790,0.824451,0.823121,0.821797,0.820481,
     &  0.819173,0.817871,0.816577,0.815289,0.814009,
     &  0.812736,0.811470,0.810210,0.808958,0.807712,
     &  0.806473,0.805240,0.804015,0.802795,0.801582,
     &  0.800376,0.799176,0.797982,0.796794,0.795613,
     &  0.794438,0.793269,0.792106,0.790949,0.789798,
     &  0.788652,0.787513,0.786380,0.785252,0.784130,
     &  0.783014,0.781903,0.780798,0.779698,0.778604,
     &  0.777516,0.776432,0.775354,0.774282,0.773215,
     &  0.772153,0.771096,0.770044,0.768998,0.767956,
     &  0.766920,0.765888,0.764862,0.763840,0.762824,
     &  0.761812,0.760805,0.759803,0.758805,0.757813,
     &  0.756824,0.755841,0.754862,0.753888,0.752918,
     &  0.751953,0.750992,0.750035,0.749083,0.748136/
       DATA ZLINM3/
     &  0.747192,0.746253,0.745318,0.744388,0.743462,
     &  0.742539,0.741621,0.740707,0.739798,0.738892,
     &  0.737990,0.737092,0.736198,0.735308,0.734423,
     &  0.733540,0.732662,0.731788,0.730917,0.730050,
     &  0.729187,0.728328,0.727472,0.726620,0.725772,
     &  0.724927,0.724086,0.723248,0.722414,0.721584,
     &  0.720757,0.719933,0.719113,0.718296,0.717483,
     &  0.716673/
       DATA ZLINH1/
     &  0.936397,0.932809,0.929287,0.925827,0.922429,
     &  0.919089,0.915806,0.912579,0.909405,0.906284,
     &  0.903212,0.900189,0.897214,0.894284,0.891399,
     &  0.888558,0.885759,0.883001,0.880283,0.877603,
     &  0.874962,0.872357,0.869788,0.867255,0.864755,
     &  0.862288,0.859854,0.857452,0.855081,0.852739,
     &  0.850427,0.848144,0.845889,0.843662,0.841461,
     &  0.839287,0.837138,0.835014,0.832915,0.830841,
     &  0.828789,0.826761,0.824755,0.822772,0.820810,
     &  0.818869,0.816949,0.815050,0.813170,0.811310,
     &  0.809470,0.807648,0.805845,0.804060,0.802293,
     &  0.800543,0.798811,0.797095,0.795396,0.793714,
     &  0.792047,0.790396,0.788761,0.787141,0.785535,
     &  0.783945,0.782369,0.780807,0.779259,0.777724,
     &  0.776204,0.774696,0.773202,0.771720,0.770251/
       DATA ZLINH2/
     &  0.768795,0.767351,0.765919,0.764499,0.763091,
     &  0.761694,0.760309,0.758935,0.757571,0.756219,
     &  0.754878,0.753547,0.752226,0.750916,0.749616,
     &  0.748326,0.747045,0.745775,0.744514,0.743262,
     &  0.742020,0.740787,0.739563,0.738348,0.737141,
     &  0.735944,0.734755,0.733574,0.732402,0.731238,
     &  0.730083,0.728935,0.727795,0.726664,0.725539,
     &  0.724423,0.723314,0.722213,0.721119,0.720032,
     &  0.718952,0.717880,0.716815,0.715756,0.714704,
     &  0.713660,0.712621,0.711590,0.710565,0.709547,
     &  0.708534,0.707529,0.706529,0.705536,0.704549,
     &  0.703567,0.702592,0.701623,0.700660,0.699702,
     &  0.698750,0.697804,0.696863,0.695928,0.694998,
     &  0.694074,0.693155,0.692241,0.691333,0.690430,
     &  0.689532,0.688639,0.687751,0.686868,0.685990/
       DATA ZLINH3/
     &  0.685117,0.684249,0.683386,0.682527,0.681673,
     &  0.680824,0.679979,0.679139,0.678303,0.677472,
     &  0.676645,0.675823,0.675005,0.674191,0.673381,
     &  0.672576,0.671775,0.670978,0.670185,0.669396,
     &  0.668611,0.667830,0.667054,0.666281,0.665512,
     &  0.664746,0.663985,0.663227,0.662473,0.661723,
     &  0.660977,0.660234,0.659495,0.658759,0.658027,
     &  0.657298/

      integer ibit1,ibit2,i

      IBIT1 = 0
      IBIT2 = 0

      DO 9000 I = 1,N
       IF(Z(I).GE.0.15)IBIT1 = IBIT1 + 1
       IF(Z(I).GT.2. )IBIT2 = IBIT2 + 1
 9000 CONTINUE

      IF( IBIT1 .LE. 0 ) GO TO 200

      DO 9002 I = 1,N
       ZSTAR(I)    = 100. * Z(I) - 14.
 9002 CONTINUE

      IF( IBIT2 .LE. 0 ) GO TO 60
      DO 9004 I = 1,N
       TEMP1(I) = Z(I)*0.5
       IF( Z(I) .LE. 2. )TEMP1(I) = 1.
       TEMP1(I) = LOG10(TEMP1(I))
       TEMP1(I) = (TEMP1(I) + 9.3) * 20.
       IF( Z(I) .GT. 2. ) ZSTAR(I) = TEMP1(I)
       IF( Z(I).GT.1.78e10 ) ZSTAR(I) = 384.9999
 9004  CONTINUE

 60    CONTINUE

      DO 9006 I = 1,N
       I1(I) = ZSTAR(I)
       I2(I) = I1(I) + 1
       TEMP1(I) = ZSTAR(I) - I1(I)

 9006  CONTINUE

      IF( IFLAG .GT. 2 ) GO TO 100
       DO 9008 I = 1,N
       if( z(i).ge.0.15 ) then
       E1(I) = PHIM0( I1(I) )
       E2(I) = PHIM0( I2(I) )
       PHIM(I)  = TEMP1(I) * ( E2(I)-E1(I) )
       PHIM(I)  = PHIM(I) +   E1(I)
       endif
 9008  CONTINUE

  100 CONTINUE

      IF( IFLAG .EQ. 2 ) GO TO 200
       DO 9010 I = 1,N
       if( z(i).ge.0.15 ) then
       E1(I) = PHIH0( I1(I) )
       E2(I) = PHIH0( I2(I) )
       PHIH(I)  = TEMP1(I) * ( E2(I)-E1(I) )
       PHIH(I)  = PHIH(I) +   E1(I)
       endif
 9010  CONTINUE

  200 CONTINUE
      IF( IBIT1 .GE. N ) GO TO 500

       DO 9012 I = 1,N
       ZSTAR(I) = -Z(I)
 9012  CONTINUE

      IF( IFLAG .GT. 2 ) GO TO 300
       DO 9014 I = 1,N
       IF( Z(I) .LT. 0.15 ) PHIM(I) = 1. + ZSTAR(I)
     2     *(0.25+ZSTAR(I)*(0.09375+ZSTAR(I)*
     3     (0.03125+0.00732422 * ZSTAR(I))))
 9014  CONTINUE

  300 CONTINUE
      IF( IFLAG .EQ. 2 ) GO TO 500
       DO 9016 I = 1,N
       IF( Z(I) .LT. 0.15 ) THEN
       PHIH(I) =1.+ Z(I) * (0.5+ZSTAR(I)*(0.375+ZSTAR(I)*
     1     (0.5+ZSTAR(I)*(0.8203125+ZSTAR(I)*
     2     (1.5+2.93262*ZSTAR(I))))))
       PHIH(I) = 1. / PHIH(I)
      ENDIF
 9016  CONTINUE

  500 CONTINUE
      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      SUBROUTINE PSI(VZZ,VZH,VPSIM,VPSIH,IRUN,VX,VXS,VY,VYS,IFLAG)
C**********************************************************************
C  SUBROUTINE PSI - DETERMINES DIMENSIONLESS WIND AND
C                    SCALAR PROFILES IN SURFACE LAYER
C                 - CALLED FROM SFCFLX
C  DESCRIPTION OF PARAMETERS
C     ZZ   -  INPUTED VALUE OF MONIN- OBUKHOV STABILITY PARAMETER ZETA
C     ZH   -  INPUTED VALUE OF PBL HEIGHT DIVIDED BY Z0
C     PSIM -  OUTPUTED VALUE OF DIMENSIONLESS WIND
C     PSIH -  OUTPUTED VALUE OF DIMENSIONLESS SCALAR
C     X    -  OUTPUTED VALUE OF PHIM(ZETA)
C     XS   -  OUTPUTED VALUE OF PHIM(ZETA0)
C     Y    -  OUTPUTED VALUE OF PHIH(ZETA)
C     YS   -  OUTPUTED VALUE OF PHIH(ZETA0)
C     IFLAG-  FLAG TO DETERMINE IF CU IS NEEDED (IFLAG=2),
C                  IF CT IS NEEDED (IFLAG=3), OR BOTH (IFLAG=1)
C  SUBPROGRAMS NEEDED
C     PHI  -  COMPUTES SIMILARITY FUNCTION FOR MOMENTUM AND SCALARS
C**********************************************************************
      implicit none

C Argument List Declarations
      integer irun,iflag
      _RL VZZ(IRUN),VZH(IRUN),VPSIM(IRUN),VPSIH(IRUN),
     1     VX(IRUN),VXS(IRUN),VY(IRUN),VYS(IRUN)

C Local Variables
      _RL ZWM,RZWM,Z0M,ZCM,RZCM,CM1,CM2,CM6,CM7,CM8ARG,YCM
      PARAMETER ( ZWM     =    1.    )
      PARAMETER ( RZWM    =  1./ZWM  )
      PARAMETER ( Z0M     =    0.2    )
      PARAMETER ( ZCM     =    42.    )
      PARAMETER ( RZCM    =  1./ZCM  )
      PARAMETER ( CM1     =  1./126. )
      PARAMETER ( CM2     =  1./(6.*CM1)  )
      PARAMETER ( CM6     =  6. / ( 1. + 6.*CM1 )  )
      PARAMETER ( CM7     =  CM2 + ZWM  )
      PARAMETER ( CM8ARG  =  CM7*ZCM*RZWM / (CM2+ZCM)  )
      PARAMETER ( YCM     =  6. / ( 1. + 6.*CM1*ZCM )  )

      integer INTSTB(irun),INTZ0(irun)
      _RL ZZ0(irun),Z(irun),Z2(irun),Z1(irun),Z0(irun)
      _RL X0(irun),X1(irun),Y0(irun),Y1(irun)
      _RL PSI2(irun),TEMP(irun)
      _RL HZ(irun),ARG0(irun),ARG1(irun),DX(irun)
      _RL X0NUM(irun),X1NUM(irun),X0DEN(irun)
      _RL X1DEN(irun),Y1DEN(irun),Z2ZWM(irun)
      _RL cm3,cm4,cm5,cm8
      integer ibit,indx
      integer i

      CM3 =   sqrt( 0.2/CM1-0.01 )
      CM4 =   1./CM3
      CM5 =  (10.-CM1) / (10.*CM1*CM3)
      CM8 =   6. * LOG(CM8ARG)

      DO 9000 I = 1,IRUN
       VPSIM(I) = 0.
       VPSIH(I) = 0.
       VX(I) = 0.
       VXS(I) = 0.
       VY(I) = 0.
       VYS(I) = 0.
       ZZ0(I) = VZH(I)*VZZ(I)
 9000 CONTINUE
      IBIT = 0
      DO 9122 I = 1,IRUN
       IF(VZZ(I).LE.-1.e-7)IBIT = IBIT + 1
 9122 CONTINUE
      DO 9022 I = 1,IRUN
       IF(VZZ(I).LE.-1.e-7)THEN
        INTSTB(I) = 1
       ELSE
        INTSTB(I) = 0
       ENDIF
 9022 CONTINUE

C ****************************************
C *****    UNSTABLE SURFACE LAYER    *****
C ****************************************

      IF(IBIT.LE.0)  GO TO 100

      indx = 0
      DO 9002 I = 1,IRUN
       IF (INTSTB(I).EQ.1)THEN
        indx = indx + 1
        Z(indx) = VZZ(I)
        Z0(indx) = ZZ0(I)
       ENDIF
 9002 CONTINUE

      DO 9004 I = 1,IBIT
       Z(I) = -18. * Z(I)
       Z0(I) = -18. * Z0(I)
 9004 CONTINUE

      CALL PHI( Z,X1,Y1,IFLAG,IBIT )
      CALL PHI( Z0,X0,Y0,IFLAG,IBIT )

C ****************************
C *****    COMPUTE PSIM  *****
C ****************************

      IF(IFLAG.GE.3) GO TO 75

      DO 9006 I = 1,IBIT
       ARG1(I) = 1. - X1(I)
       IF ( Z(I) .LT. 0.013 ) ARG1(I) =
     1        Z(I) * ( 0.25 -  0.09375 * Z(I) )

       ARG0(I)  = 1. - X0(I)
       IF ( Z0(I) .LT. 0.013 ) ARG0(I) =
     1       Z0(I) * ( 0.25 -  0.09375 * Z0(I) )

       ARG1(I) = ARG1(I) * ( 1.+X0(I) )
       ARG0(I) = ARG0(I) * ( 1.+X1(I) )
       DX(I) = X1(I) - X0(I)
       ARG1(I) = ARG1(I) / ARG0(I)
       ARG0(I) = -DX(I) / ( 1. + X1(I)*X0(I) )
       ARG0(I) = ATAN( ARG0(I) )
       ARG1(I) = LOG( ARG1(I) )
       PSI2(I) = 2. * ARG0(I) + ARG1(I)
       PSI2(I) = PSI2(I) + DX(I)
 9006 CONTINUE

      indx = 0
      DO 9008 I = 1,IRUN
       IF( INTSTB(I).EQ.1 ) THEN
        indx = indx + 1
        VPSIM(I) = PSI2(indx)
        VX(I) = X1(indx)
        VXS(I) = X0(indx)
       ENDIF
 9008 CONTINUE

C ****************************
C *****    COMPUTE PSIH  *****
C ****************************

      IF(IFLAG.EQ.2) GO TO 100

  75  CONTINUE
      DO 9010 I = 1,IBIT
       ARG1(I) = 1. - Y1(I)
       IF( Z(I) .LT. 0.0065 ) ARG1(I) =
     1       Z(I) * ( 0.5 -  0.625 * Z(I) )

       ARG0(I)  = 1. - Y0(I)
       IF( Z0(I) .LT. 0.0065 ) ARG0(I) =
     1       Z0(I) * ( 0.5 -  0.625 * Z0(I) )

       ARG1(I) = ARG1(I) * ( 1. + Y0(I) )
       ARG0(I) = ARG0(I) * ( 1. + Y1(I) )
       ARG1(I) = ARG1(I) / ARG0(I)
       PSI2(I) = LOG( ARG1(I) )
       PSI2(I) = PSI2(I) - Y1(I) + Y0(I)
 9010 CONTINUE

      indx = 0
      DO 9012 I = 1,IRUN
       IF( INTSTB(I).EQ.1 ) THEN
       indx = indx + 1
       VPSIH(I) = PSI2(indx)
       VY(I) = Y1(indx)
       VYS(I) = Y0(indx)
       ENDIF
 9012 CONTINUE

C **************************************
C *****    STABLE SURFACE LAYER    *****
C **************************************

  100 CONTINUE
      IBIT = 0
      DO 9114 I = 1,IRUN
       IF(VZZ(I).GT.-1.e-7)THEN
        IBIT = IBIT + 1
       ENDIF
 9114 CONTINUE
      DO 9014 I = 1,IRUN
       IF(VZZ(I).GT.-1.e-7)THEN
        INTSTB(I) = 1
       ELSE
        INTSTB(I) = 0
       ENDIF
 9014 CONTINUE
      IF(IBIT.LE.0)  GO TO 300
      indx = 0
#ifdef FIZHI_CRAY
CDIR$ NOVECTOR
#endif
      DO 9016 I = 1,IRUN
       IF (INTSTB(I).EQ.1)THEN
        indx = indx + 1
        Z(indx) = VZZ(I)
        Z0(indx) = ZZ0(I)
        ARG1(indx) = VZH(I)
       ENDIF
 9016 CONTINUE
#ifdef FIZHI_CRAY
CDIR$ VECTOR
#endif

      DO 9018 I = 1,IBIT
       HZ(I) = 1. / ARG1(I)
       Z1(I) = Z(I)
       Z2(I) = ZWM

       IF ( Z(I) .GT. ZWM ) THEN
        Z1(I) = ZWM
        Z2(I) = Z(I)
       ENDIF

       IF ( Z0(I) .GT. Z0M ) THEN
        Z0(I) = Z0M
        INTZ0(I) = 1
       ELSE
        INTZ0(I) = 0
       ENDIF

       X1NUM(I) = 1. + 5. * Z1(I)
       X0NUM(I) = 1. + 5. * Z0(I)
       X1DEN(I) = 1. / (1. + CM1 * (X1NUM(I) * Z1(I)) )
       X0DEN(I) = 1. + CM1 * (X0NUM(I) * Z0(I))

       IF ( (INTZ0(I).EQ.1) .OR. (Z(I).GT.ZWM) )
     1      HZ(I) = Z1(I) / Z0(I)
       ARG1(I) = HZ(I)*HZ(I)*X0DEN(I)*X1DEN(I)
       ARG1(I) = LOG( ARG1(I) )
       ARG1(I) = 0.5 * ARG1(I)
       ARG0(I) = (Z1(I) + 0.1) * (Z0(I) + 0.1)
       ARG0(I) = CM3 + ARG0(I) * CM4
       ARG0(I) = ( Z1(I) - Z0(I) ) / ARG0(I)
       ARG0(I) = ATAN( ARG0(I) )
       TEMP(I) = ARG1(I) + CM5 * ARG0(I)

       X0(I) = X0NUM(I) / X0DEN(I)
       IF ( INTZ0(I).EQ.1 ) X0(I) = 0.
       Z2ZWM(I) = Z2(I) * RZWM
 9018 CONTINUE

C ****************************
C *****    COMPUTE PSIM  *****
C ****************************

      IF( IFLAG.GE.3 ) GO TO 225

      DO 9020 I = 1,IBIT
       X1(I) = X1NUM(I) * X1DEN(I)
       ARG1(I) = LOG( Z2ZWM(I) )
       PSI2(I) = TEMP(I) + CM6 * ARG1(I)
 9020 CONTINUE

      indx = 0
      DO 9030 I = 1,IRUN
       IF( INTSTB(I).EQ.1 ) THEN
       indx = indx + 1
       VPSIM(I) = PSI2(indx)
       VX(I) = X1(indx)
       VXS(I) = X0(indx)
       ENDIF
 9030 CONTINUE

C ****************************
C *****    COMPUTE PSIH  *****
C ****************************

       IF(IFLAG.EQ.2)GO TO 300

  225 CONTINUE
      DO 9024 I = 1,IBIT
       Y1DEN(I) = 1. + CM1 * ( X1NUM(I) * Z(I) )
       Y1(I) = X1NUM(I) / Y1DEN(I)
       ARG1(I) = CM7 * Z2ZWM(I) / ( CM2 + Z2(I) )
       ARG0(I) = 6.
       IF ( Z2(I) .GT. ZCM ) THEN
        Y1(I) = YCM
        ARG1(I) = Z2(I) * RZCM
        ARG0(I) = YCM
        TEMP(I) = TEMP(I) + CM8
       ENDIF
       ARG1(I) = LOG( ARG1(I) )
       PSI2(I) = TEMP(I) + ARG0(I) * ARG1(I)
 9024 CONTINUE

      indx = 0
      DO 9026 I = 1,IRUN
       IF( INTSTB(I).EQ.1 ) THEN
       indx = indx + 1
       VPSIH(I) = PSI2(indx)
       VY(I) = Y1(indx)
       VYS(I) = X0(indx)
       ENDIF
 9026 CONTINUE

  300 CONTINUE

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      SUBROUTINE TRBLEN (STRT,DW2,DZ3,Q,VKZE,VKZM,DTHV,DPK,DU,DV,XL,
     1                   QXLM,NLEV,INIT,LMIN,LMINQ,LMINQ1,CP,INT1,INT2,
     2  DZITRP,STBFCN,XL0,Q1,WRKIT1,WRKIT2,WRKIT3,WRKIT4,irun)
C**********************************************************************
C  SUBROUTINE TRBLEN - COMPUTES TURBULENT LENGTH SCALE
C                    - CALLED FROM TRBFLX
C   ARGUMENTS ::
C     INPUT:
C     ------
C    STRT          -         BRUNT VAISALA FREQUENCY
C    DW2           -         SQUARED SHEAR
C    DZ3           -         LAYER THICKNESS FOR LENGTH SCALE CALC.
C    Q             -         TURBULENCE VELOCITY
C    VKZE          -         VK * Z AT LAYER EDGES
C    VKZM          -         VK * Z AT LAYER CENTERS
C    DTHV          -         VERTICAL GRADIENT OF THV
C    DPK           -         VERTICAL GRADIENT OF PK
C    DU            -         VERTICAL GRADIENT OF U
C    DV            -         VERTICAL GRADIENT OF V
C    NLEV          -         NUMBER OF ATMOSPHERIC LEVELS
C    INIT          -         INPUT FLAG : 1 = INITIAL START
C                                         2 = 2ND CALL FOR INITIAL STAR
C                                         0 = NON-INITIAL START
C     OUTPUT:
C     -------
C    XL            -         TURBULENT LENGTH SCALE
C    QXLM          -         TURBULENT LENGTH SCALE * Q AT LAYER CENTER
C    LMIN          -         HIGHEST LAYER WHERE INSTABILITY OCCURS
C    LMINQ         -         HIGHEST LAYER WHERE TURBULENCE OCCURS
C
C   SUBPROGRAMS NEEDED ::
C     TRBITP -  INTERPOLATES TO HEIGHT WHERE RI = RICR
C**********************************************************************
      implicit none

C Argument List Declarations
      integer irun,nlev,init,lmin,lminq,lminq1
      _RL cp
      _RL STRT(irun,NLEV),DW2(irun,NLEV),DZ3(irun,NLEV)
      _RL Q(irun,NLEV),VKZM(irun,NLEV-1),VKZE(irun,NLEV-1)
      _RL DTHV(irun,NLEV),DPK(irun,NLEV),DU(irun,NLEV)
      _RL DV(irun,NLEV)
      _RL QXLM(irun,NLEV-1),XL(irun,NLEV-1)
      _RL DZITRP(irun,nlev-1),STBFCN(irun,nlev)
      _RL XL0(irun,nlev),Q1(irun,nlev-1)
      _RL WRKIT1(irun,nlev-1),WRKIT2(irun,nlev-1)
      _RL WRKIT3(irun,nlev-1)
      _RL WRKIT4(irun,nlev-1)
      INTEGER INT1(irun,nlev), INT2(irun,nlev-1)

C Local Variables
      _RL rf1,rf2,e5,d4,d1,rfc,ricr,alpha,dzcnv,xl0cnv,xl0min
      _RL clmt,clmt53
      PARAMETER ( RF1     = 0.2340678 )
      PARAMETER ( RF2     = 0.2231172 )
      PARAMETER ( E5      = 49.66     )
      PARAMETER ( D4      = 2.6532122E-2 )
      PARAMETER ( D1      = D4 * E5   )
      PARAMETER ( RFC     = 0.1912323 )
      PARAMETER ( RICR    = ( (RF1-RFC)*RFC ) / ( (RF2-RFC)*D1 )  )
      PARAMETER ( ALPHA   = 0.1       )
      PARAMETER ( DZCNV   = 100.      )
      PARAMETER ( XL0CNV  = DZCNV * ALPHA )
      PARAMETER ( XL0MIN  = 1.        )
      PARAMETER ( CLMT    = 0.23      )
      PARAMETER ( CLMT53  = 5. * CLMT / 3. )

      integer ibit,nlevm1,nlevp1,istnlv,istnm1,nlevml,istnml,Lp1
      integer istnmq,istlmq,lminp,lm1,lmin1
      integer i,L,LL

      NLEVM1 = NLEV - 1
      NLEVP1 = NLEV + 1
      ISTNLV = irun * NLEV
      ISTNM1 = irun * NLEVM1

      IF ( INIT.EQ.2 ) GO TO 1200

C COMPUTE DEPTHS OF UNSTABLE LAYERS
C =================================
      DO L =1,NLEV
       DO I =1,irun
         STBFCN(I,L) = STRT(I,L) - RICR * DW2(I,L)
         INT1(I,L) = 0
         IF( STBFCN(I,L).LE.0. ) INT1(I,L) = 1
       ENDDO
      ENDDO

      DO L =1,NLEVM1
       DO I =1,irun
        INT2(I,L) = 0
        IF( (INT1(I,L).EQ.1) .NEQV. (INT1(I,L+1).EQ.1) ) INT2(I,L) = 1
       ENDDO
      ENDDO

      DO 40 LMIN = 1,NLEV
      IBIT = 0
      DO 30 I=1,irun
      IBIT = IBIT + INT1(I,LMIN)
   30 CONTINUE
      IF(IBIT.GE.1) GO TO 50
   40 CONTINUE
      LMIN = NLEVP1
   50 CONTINUE
      LMIN = 1

      DO L =1,NLEVM1
       DO I =1,irun
        XL0(I,L) = 0.
       ENDDO
      ENDDO
      DO 70 I=1,irun
      XL0(I,NLEV) = DZ3(I,NLEV)
   70 CONTINUE

      IF(LMIN.GE.NLEVP1) GOTO 1100
                         LMIN1 = LMIN - 1
      IF(LMIN1.EQ.0)     LMIN1 = 1
         NLEVML = NLEV - LMIN1
         ISTNML = irun*NLEVML
      CALL TRBITP ( STBFCN(1,LMIN1),INT2(1,LMIN1),DTHV(1,LMIN1),
     &                 DPK(1,LMIN1),  DU(1,LMIN1),  DV(1,LMIN1),
     &              DZITRP(1,LMIN1),  NLEVML,
     &              WRKIT1,WRKIT2,WRKIT3,WRKIT4,CP,irun )
      LP1 = LMIN1 + 1

      DO L =LMIN1,NLEVM1
       DO I =1,irun
        INT2(I,L) = 0
        IF ( INT1(I,L).EQ.1 .OR. INT1(I,L+1).EQ.1 ) INT2(I,L) = 1
        IF ( INT2(I,L).EQ.1 )
     &       XL0(I,L) = (0.5+DZITRP(I,L)) * DZ3(I,L+1)
       ENDDO
      ENDDO
      DO 90 I=1,irun
      INT2(I,NLEVM1) = INT1(I,NLEV)
   90 CONTINUE

      DO L =LMIN1,NLEVM1
       DO I =1,irun
        IF ( INT2(I,L).EQ.1 ) THEN
         XL0(I,L+1) = XL0(I,L+1) + ( (0.5-DZITRP(I,L)) * DZ3(I,L+1) )
        ENDIF
       ENDDO
      ENDDO
      IF (LMIN.GT.1) GOTO 400
      DO 110 I=1,irun
      IF( INT1(I,1).EQ.1 ) XL0(I,1) = XL0(I,1) + DZ3(I,1)
  110 CONTINUE
  400 CONTINUE

      LMINP = LMIN + 1
      IF(LMINP.GT.NLEVM1) GOTO 550
      DO 500 L = LMINP,NLEVM1
           LM1 = L-1
      DO 120 I = 1,irun
      IF( INT1(I,LM1).EQ.1 ) XL0(I,L) = XL0(I,L) + XL0(I,LM1)
  120 CONTINUE
  500 CONTINUE
  550 CONTINUE
      IF(LMIN.GT.NLEVM1) GOTO 600
      DO 130 I = 1,irun
      IF( INT1(I,NLEVM1).EQ.1 .AND. INT1(I,NLEV).EQ.1 ) THEN
      XL0(I,NLEV) = XL0(I,NLEV) + XL0(I,NLEVM1)
      ENDIF
  130 CONTINUE
      IF(LMIN.GT.NLEV) GOTO 1100
  600 CONTINUE
      DO 1000 LL  = LMIN,NLEV-1
              L   = NLEVM1 + LMIN - LL
              LP1 = L+1
      DO 140 I = 1,irun
      IF( INT1(I,LP1).EQ.1 ) THEN
      IF( INT1(I,L)  .EQ.1 ) THEN
      XL0(I,L) = XL0(I,LP1)
      ELSE
      XL0(I,L) = XL0(I,L) + XL0(I,LP1)
      ENDIF
      ENDIF
  140 CONTINUE
 1000 CONTINUE
 1100 CONTINUE

      DO L =1,NLEV
       DO I =1,irun
        IF ( XL0(I,L).LT.XL0CNV ) XL0(I,L) = XL0CNV
       ENDDO
      ENDDO

C *********************************************************************
C ****          DETERMINE MIXING LENGTHS FOR STABLE LAYERS          ***
C *********************************************************************

      IF(INIT.EQ.1) GOTO 1400

      IF(LMINQ.GT.1) THEN
                    ISTLMQ = irun * LMINQ1
      DO L =1,LMINQ1
       DO I =1,irun
        INT2(I,L) = 1 - INT1(I,L)
       ENDDO
      ENDDO
      ENDIF
      IF(LMINQ.LT.NLEV) THEN
        ISTNMQ = irun * (NLEV-LMINQ)
       DO L =LMINQ,NLEVM1
        DO I =1,irun
         IF( INT1(I,L).EQ.0 ) THEN
           XL0(I,L) =         Q(I,L) / XL0(I,L)
           XL0(I,L) =       XL0(I,L) * XL0(I,L) + 1.0E-20
           XL0(I,L) =    STBFCN(I,L) + XL0(I,L)
           XL0(I,L) = SQRT( XL0(I,L) )
           XL0(I,L) =         Q(I,L) / XL0(I,L)
         ENDIF
         INT2(I,L)  = 0
         IF( XL0(I,L).LT.XL0MIN ) INT2(I,L)  = 1
        ENDDO
       ENDDO
      ENDIF

 1200 CONTINUE

      IF(INIT.EQ.2) THEN
       DO L =1,NLEVM1
        DO I =1,irun
         INT2(I,L) = 1 - INT1(I,L)
         IF ( INT2(I,L).EQ.1 ) XL0(I,L) = XL0MIN
        ENDDO
       ENDDO
      ENDIF
      DO L =1,NLEVM1
       DO I =1,irun
        IF ( INT2(I,L).EQ.1 ) XL0(I,L) = XL0MIN
       ENDDO
      ENDDO

C *********************************************************************
C ****             LENGTH SCALE XL FROM XL0 AND VKZE              ****
C *********************************************************************

 1400 CONTINUE

      DO L =1,NLEVM1
       DO I =1,irun
        XL(I,L) = XL0(I,L) * VKZE(I,L) / ( XL0(I,L)+VKZE(I,L) )
       ENDDO
      ENDDO

C *********************************************************************
C ****       CLMT53 TIMES Q TIMES LENGTH SCALE AT MID LEVELS        ***
C *********************************************************************

      IF(INIT.EQ.1) GOTO 1700
                   ISTNMQ = irun * (NLEV-LMINQ1)
      DO L =LMINQ1,NLEVM1
       DO I =1,irun
        Q1(I,L) = Q(I,L)
        INT1(I,L) = 0
        IF (    Q(I,L).LE.Q(I,L+1) ) INT1(I,L) = 1
        IF ( INT1(I,L).EQ.1 )  THEN
           XL0(I,L) = XL0(I,L+1)
            Q1(I,L) =   Q(I,L+1)
        ENDIF
       ENDDO
      ENDDO

      DO L =LMINQ1,NLEVM1
       DO I =1,irun
        QXLM(I,L) =   XL0(I,L)*VKZM(I,L)
     &                 / ( XL0(I,L)+VKZM(I,L) )
        QXLM(I,L) = CLMT53 * Q1(I,L)*QXLM(I,L)
       ENDDO
      ENDDO

 1700 CONTINUE

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      SUBROUTINE TRBITP ( STBFCN,INTCHG,DTHV,DPK,DU,DV,DZITRP,NLEV,
     &                    AAA,BBB,CCC,DDD,CP,irun )
C**********************************************************************
C  SUBROUTINE TRBITP - INTERPOLATES TO THE HEIGHT WHERE RI EQUALS RICR
C                    - CALLED FROM TRBLEN
C   ARGUMENTS ::
C     INPUT:
C     ------
C    STBFCN        -         DTHV * DPK - RICR*( DU*DU + DV*DV)
C    INTCHG        -         INT '1' AT LEVELS WHERE STBFCN CHANGES SIG
C    DTHV          -         VERTICAL GRADIENT OF THV
C    DPK           -         VERTICAL GRADIENT OF PK
C    DU            -         VERTICAL GRADIENT OF U
C    DV            -         VERTICAL GRADIENT OF V
C    NLEV          -         NUMBER OF LEVELS TO BE PROCESSED
C     OUTPUT:
C     -------
C    DZITRP        -         INTERPOLATION COEFFICIENT
C**********************************************************************
      implicit none

C Argument List Declarations
      integer irun,nlev
      _RL cp
      _RL STBFCN(irun,NLEV+1)
      integer INTCHG(irun,NLEV)
      _RL DTHV(irun,NLEV+1),DPK(irun,NLEV+1)
      _RL DU(irun,NLEV+1),DV(irun,NLEV+1)
      _RL DZITRP(irun,NLEV+1)
      _RL AAA(irun,NLEV),BBB(irun,NLEV)
      _RL CCC(irun,NLEV),DDD(irun,NLEV)

C Local Variables
      _RL rf1,rf2,e5,d4,d1,rfc,ricr
      PARAMETER ( RF1     = 0.2340678 )
      PARAMETER ( RF2     = 0.2231172 )
      PARAMETER ( E5      = 49.66     )
      PARAMETER ( D4      = 2.6532122E-2 )
      PARAMETER ( D1      = D4 * E5   )
      PARAMETER ( RFC     = 0.1912323 )
      PARAMETER ( RICR    = ( (RF1-RFC)*RFC ) / ( (RF2-RFC)*D1 )  )

      integer istnlv
      integer I,L

C *********************************************************************
C ****           QUADRATIC INTERPOLATION OF RI TO RICR VIA          ***
C ****           LINEAR INTERPOLATION OF DTHV, DPK, DU & DV         ***
C *********************************************************************

      ISTNLV = irun*NLEV
      DO L =1,NLEV
       DO I =1,irun
        DZITRP(I,L) = 0.
       ENDDO
      ENDDO
      DO L =1,NLEV
       DO I =1,irun
        IF ( INTCHG(I,L).EQ.1 ) THEN
         DDD(I,L) = (         CP  *(DTHV(I,L+1)*DPK(I,L)
     &                            + DTHV(I,L)*DPK(I,L+1)) )
     &            - ( (2.*RICR)  * ( DU(I,L+1)* DU(I,L)
     &                            +   DV(I,L+1)* DV(I,L)) )
         AAA(I,L) = STBFCN(I,L) + STBFCN(I,L+1)
         BBB(I,L) = STBFCN(I,L) - STBFCN(I,L+1)
         CCC(I,L) =            1. / BBB(I,L)
         DZITRP(I,L) = AAA(I,L) * CCC(I,L)
         AAA(I,L) = AAA(I,L) - DDD(I,L)
         DDD(I,L) =        (   DDD(I,L) *    DDD(I,L) )
     &            - 4. * (STBFCN(I,L+1) * STBFCN(I,L) )
         DDD(I,L) = DDD(I,L)*CCC(I,L)*CCC(I,L)
         DDD(I,L) =    SQRT( DDD(I,L) )
        ENDIF

        IF( INTCHG(I,L).EQ.1 .AND. AAA(I,L).NE.0. ) THEN
         DZITRP(I,L) = ( BBB(I,L)*(1.-DDD(I,L)) ) / AAA(I,L)
        ENDIF

        DZITRP(I,L) = 0.5 * DZITRP(I,L)
       ENDDO
      ENDDO

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      SUBROUTINE TRBL20 (RI,STRT,DW2,XL,ZKM,ZKH,QE,QQE,INTSTB,NLEV,
     1                        nlay,irun)
C**********************************************************************
C  SUBROUTINE TRBL20 - COMPUTES QE AND DIMLESS COEFS FROM
C                       MELLOR-YAMADA LEVEL 2 MODEL
C                    - CALLED FROM AND FROM TRBFLX
C   ARGUMENTS ::
C     INPUT:
C     ------
C    RI            -         RICHARDSON NUMBER
C    STRT          -         BRUNT VAISALA FREQUENCY
C    DW2           -         SQUARED SHEAR
C    XL            -         TURBULENT LENGTH SCALE
C    NLEV          -         NUMBER OF LEVELS TO BE PROCESSED
C     OUTPUT:
C     -------
C    ZKM           -         MOMENTUM TRANSPORT COEFFICIENT
C    ZKH           -         HEAT TRANSPORT COEFFICIENT
C    QE            -         EQUILIBRIUM TURBULENT VELOCITY SCALE
C    QQE           -         EQUILIBRIUM TURBULENT KINETIC ENERGY
C    BITSTB        -         BIT '1' WHERE QE GREATER THAN ZERO
C**********************************************************************
      implicit none

C Argument List Declarations
      integer nlev,nlay,irun
      _RL RI(irun*NLEV,1),STRT(irun*NLEV,1),DW2(irun*NLEV,1)
      _RL XL(irun*NLEV,1),ZKM(irun*NLEV,1), ZKH(irun*NLEV,1)
      _RL QE(irun*NLEV,1),QQE(irun*NLEV,1)
      INTEGER INTSTB(irun*NLEV,1)
      _RL EE(irun*(nlay-1),1),RF(irun*(nlay-1),1)

C Local Variables
      _RL b1,b2,d3,rf1,rf2,d3b2,d2,e5,d4,d1,d1half,d2half
      _RL rfc,ricr,ch,cm
      PARAMETER ( B1      =   16.6    )
      PARAMETER ( B2      =   10.1    )
      PARAMETER ( D3      = 0.29397643 )
      PARAMETER ( RF1     = 0.2340678 )
      PARAMETER ( RF2     = 0.2231172 )
      PARAMETER ( D3B2    = D3 / RF1  )
      PARAMETER ( D2      = RF1       )
      PARAMETER ( E5      = 49.66     )
      PARAMETER ( D4      = 2.6532122E-2 )
      PARAMETER ( D1      = D4 * E5   )
      PARAMETER ( D1HALF = 0.5 * D1 )
      PARAMETER ( D2HALF = 0.5 * D2 )
      PARAMETER ( RFC     = 0.1912323 )
      PARAMETER ( RICR    = ( (RF1-RFC)*RFC ) / ( (RF2-RFC)*D1 )  )
      PARAMETER ( CH      = 2.5828674 )
      PARAMETER ( CM      = CH / D1   )

      integer istnlv
      integer i

      ISTNLV = irun * NLEV

C *********************************************************************
C ****               COMPUTE FLUX RICHARDSON NUMBER                 ***
C *********************************************************************

      DO 10 I=1,ISTNLV
      EE(I,1) = D1HALF * RI(I,1) + D2HALF
      RF(I,1) = EE(I,1)* EE(I,1)
      RF(I,1) = RF(I,1)- D3*RI(I,1)
      RF(I,1) = SQRT( RF(I,1) )
      RF(I,1) = EE(I,1) - RF(I,1)

      IF( RI(I,1).LE.1.e-4 .AND. RI(I,1).GE.-1.e-4 ) THEN
          RF(I,1) = D3B2*RI(I,1)
      ENDIF

C *********************************************************************
C ****           QE AND DIMENSIONLESS DIFFUSION COEFICIENTS         ***
C ****                   FROM LEVEL 2 CLOSURE MODEL                 ***
C *********************************************************************

      IF( RI(I,1).LT.RICR .AND. RF(I,1).LT.RFC ) THEN
      ZKH(I,1) =   ( RFC-RF(I,1) ) / (1.-RF(I,1))
      ZKM(I,1) =                CM * (RF1-RF(I,1))
      ZKM(I,1) = ZKH(I,1)*ZKM(I,1) / (RF2-RF(I,1))
      ZKH(I,1) = CH      *ZKH(I,1)
       QE(I,1) = ZKM(I,1)*DW2(I,1) - ZKH(I,1)*STRT(I,1)
      ENDIF

      IF( QE(I,1).LT.1.e-14 ) THEN
      INTSTB(I,1) = 0
          QE(I,1) = 0.
      ELSE
      INTSTB(I,1) = 1
          QE(I,1) = B1*QE(I,1)
          QE(I,1) = SQRT( QE(I,1) )
          QE(I,1) = XL(I,1)*QE(I,1)
      ENDIF
      QQE(I,1) = 0.5 * QE(I,1) * QE(I,1)
   10 CONTINUE

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      SUBROUTINE TRBL25(Q,XL,STRT,DW2,INTSTB,INTQ,ZKM,ZKH,P3,NLEV,
     1                      nlay,irun)
C**********************************************************************
C  SUBROUTINE TRBL25 - COMPUTES P3 AND DIMLESS COEFS FROM
C                       MELLOR-YAMADA LEVEL 2.5 MODEL
C                    - CALLED FROM TRBFLX
C   ARGUMENTS ::
C     INPUT:
C     ------
C    Q             -         TURBULENCE VELOCITY
C    XL            -         TURBULENT LENGTH SCALE
C    STRT          -         BRUNT VAISALA FREQUENCY
C    DW2           -         SQUARED SHEAR
C    BITSTB        -         BIT '1' WHERE QE GREATER THAN ZERO
C    NLEV          -         NUMBER OF LEVELS TO BE PROCESSED
C     OUTPUT:
C     -------
C    ZKM           -         MOMENTUM TRANSPORT COEFFICIENT
C    ZKH           -         HEAT TRANSPORT COEFFICIENT
C    P3            -         PRODUCTION RATE OF TURBULENT KINETIC ENERG
C**********************************************************************
      implicit none

C Argument list Declarations
      integer nlev,nlay,irun
      _RL Q(irun*NLEV,1),XL(irun*NLEV,1),STRT(irun*NLEV,1)
      _RL DW2(irun*NLEV,1)
      INTEGER INTSTB(irun*nlay,1), INTQ(irun*nlay,1)
      _RL ZKM(irun*NLEV,1),ZKH(irun*NLEV,1),P3(irun*NLEV,1)

C Local Variables
      _RL a1,a2,a4,c1,a5,a3,b1,b2,b3,ff2,ff3,ff4
      PARAMETER ( A1      =   0.92    )
      PARAMETER ( A2      =   0.74    )
      PARAMETER ( A4      = 6. * A1 * A1)
      PARAMETER ( C1      =   0.08    )
      PARAMETER ( A5      = 3.*C1*(-1.) )
      PARAMETER ( A3      = A4 * A5*(-1.) )
      PARAMETER ( B1      =   16.6    )
      PARAMETER ( B2      =   10.1    )
      PARAMETER ( B3      = 1. / B1  )
      PARAMETER ( FF2     = 9. * A1 * A2 )
      PARAMETER ( FF3     = (3.*A2*B2) - (9.*A2*A2 )  )
      PARAMETER ( FF4     = (3.*A2*B2) + (12.*A1*A2 )  )

      _RL F2(irun*(nlay-1),1),F3(irun*(nlay-1),1)
      _RL F4(irun*(nlay-1),1),XQ(irun*(nlay-1),1)

      integer istnlv
      integer i

      ISTNLV = irun * NLEV

C *********************************************************************
C ****           P3 AND DIMENSIONLESS DIFFUSION COEFICIENTS         ***
C ****                  FROM LEVEL 2.5 CLOSURE MODEL                ***
C *********************************************************************

      DO 10 I=1,ISTNLV
      IF( INTQ(I,1).EQ.1 .AND. INTSTB(I,1).EQ.0 ) THEN
        XQ(I,1) = XL(I,1)  /      Q(I,1)
        XQ(I,1) = XQ(I,1)  *     XQ(I,1)
      STRT(I,1) = XQ(I,1)  *   STRT(I,1)
       DW2(I,1) = XQ(I,1)  *    DW2(I,1)
        F2(I,1) = 1.+FF2  *   STRT(I,1)
        F3(I,1) = 1.+FF3  *   STRT(I,1)
        F4(I,1) = 1.+FF4  *   STRT(I,1)
       ZKH(I,1) = (F4(I,1) *     F2(I,1))
     &     + A4 * (F3(I,1) *    DW2(I,1))
       ZKH(I,1) = (F2(I,1) + A3*DW2(I,1))
     &          / ZKH(I,1)
       ZKM(I,1) = A1 * (F3(I,1)*ZKH(I,1)+A5)
     &               /  F2(I,1)
       ZKH(I,1) = A2 * ZKH(I,1)
        P3(I,1) = ZKH(I,1)*STRT(I,1) + B3
        P3(I,1) = 2. * ( ZKM(I,1)*DW2(I,1) - P3(I,1) )
        P3(I,1) = P3(I,1)*Q(I,1)

      ENDIF
   10 CONTINUE

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      SUBROUTINE TRBDIF ( XX1,XX2,RHOKDZ,FLXFAC,DXX1G,DXX2G,NLEV,
     &                    ITYPE,EPSL,irun )

C**********************************************************************
C   ARGUMENTS ::
C     INPUT:
C     ------
C    XX1           -         FIRST PROPERTY TO BE DIFFUSED
C                              (INPUT INCLUDES FORWARD PRODUCTION TERM)
C    XX2           -         SECOND PROPERTY TO BE DIFFUSED (V-WIND)
C                              (INPUT INCLUDES FORWARD PRODUCTION TERM)
C                                             -OR-
C                            CHANGE IN XX1 DUE TO UNIT CHANGE IN THG
C                               (TH OR SH PROFILES)
C                                             -OR-
C                            BACKWARD PRODUCTION TERM (QQ)
C    RHOKDZ        -         RHO * K * WEIGHT / DZ AT INTERFACES
C    FLXFAC        -         G * DT / (DP*WEIGHT) AT EDGES
C    NLEV          -         NUMBER OF ATMOSPHERIC LEVELS
C    ITYPE         -         INTEGER FLAG FOR INPUT TYPE
C                              1 = QQ: COMPUTE BACKWARD PRODUCTION AND
C                                  USE UNDERFLOW CUTOFF
C                              2 = TH OR SH: COMPUTE TENDENCY DUE TO
C                                  SURFACE PERTURBATION
C                              3 = U AND V: COMPUTE BOTH FIELDS
C    EPSL          -         UNDERFLOW CUTOFF CRITERION (QQ ONLY)
C     OUTPUT:
C     ------
C    XX1           -         NEW VALUE RETURNED
C    XX2           -         NEW VALUE RETURNED
C    DXX1G         -         SOURCE TERM FOR XX1 AT GROUND
C    DXX1G         -         SOURCE TERM FOR XX2 AT GROUND
C**********************************************************************
      implicit none

C Argument List Declarations
      integer nlev,itype,irun
      _RL XX1(irun,NLEV+1),XX2(irun,NLEV+1)
      _RL RHOKDZ(irun,NLEV),FLXFAC(irun,NLEV+1)
      _RL DXX1G(irun),DXX2G(irun)
      _RL epsl

      _RL AA(irun,nlev), BB(irun,nlev), CC(irun,nlev+1)
      integer NLEVP1,NLEVX
      integer I,L

      NLEVP1 = NLEV + 1
      NLEVX =  NLEV - 1
      IF(ITYPE.EQ.2) NLEVX =  NLEV

C   DEFINE MATRIX

      DO 10 I=1,irun
      CC(I,1) = 0.
   10 CONTINUE
      DO L =1,NLEVX
       DO I =1,irun
        CC(I,L+1) = RHOKDZ(I,L) * FLXFAC(I,L+1)
       ENDDO
      ENDDO
      DO L =1,NLEV
       DO I =1,irun
        BB(I,L) =   RHOKDZ(I,L) * FLXFAC(I,L)
        AA(I,L) = 1. + CC(I,L) + BB(I,L)
       ENDDO
      ENDDO

C     ADD IMPLICIT BACKWARD FORCING FOR QQ
      IF(ITYPE.EQ.1) THEN
       DO L =1,NLEV
        DO I =1,irun
         AA(I,L) = AA(I,L) - XX2(I,L)
        ENDDO
       ENDDO
      ENDIF

C     SOLVE MATRIX EQUATION FOR XX1
      CALL VTRI0(AA,BB,CC,XX1,XX1,NLEV,irun)

      IF(ITYPE.EQ.2) THEN
C     COMPUTE CHANGE AT SURFACE

      DO 50 I=1,irun
      DXX1G(I) = CC(I,NLEVP1) * ( XX1(I,NLEV)-XX1(I,NLEVP1) )
   50 CONTINUE

C     SOLVE MATRIX FOR SURFACE PERTURBATION
      CALL VTRI1(AA,BB,XX2,NLEV,irun)
      DO 60 I=1,irun
      DXX2G(I) = CC(I,NLEVP1) * ( XX2(I,NLEV)-XX2(I,NLEVP1) )
   60 CONTINUE
      ENDIF

C     SOLVE MATRIX EQUATION FOR XX2

      IF(ITYPE.EQ.3) CALL VTRI2 (AA,BB,CC,XX2,XX2,NLEV,irun)

C     ELIMINATE UNDERFLOW
      IF(ITYPE.EQ.1) THEN
       DO L =1,NLEV
        DO I =1,irun
         IF ( XX1(I,L).LT.EPSL ) XX1(I,L) = 0.
        ENDDO
       ENDDO
      ENDIF

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      SUBROUTINE VTRI0 ( A,B,C,F,Y,K,irun)
      implicit none

      integer k,irun
      _RL A(irun,K),B(irun,K),C(irun,K),Y(irun,K+1)
      _RL F(irun,K)

      integer i,L,Lm1

      DO 9000 I = 1,irun
       A(I,1) = 1. / A(I,1)
 9000 CONTINUE

      DO 100 L = 2,K
       LM1 = L - 1
       DO 9002 I = 1,irun
        C(I,L) = C(I,L) * A(I,LM1)
        A(I,L) = 1. / ( A(I,L) - B(I,LM1) * C(I,L) )
        F(I,L) = F(I,L) + F(I,LM1) * C(I,L)
 9002  CONTINUE
 100  CONTINUE

      DO 200 L = K,1,-1
       DO 9004 I = 1,irun
       Y(I,L) = (F(I,L) + B(I,L) * Y(I,L+1)) * A(I,L)
 9004  CONTINUE
 200  CONTINUE

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      SUBROUTINE VTRI1 ( A,B,Y,K,irun)
      implicit none

      integer k,irun
      _RL A(irun,K),B(irun,K),Y(irun,K+1)

      integer i,L

      DO 200 L = K,1,-1
       DO 9000 I = 1,irun
        Y(I,L) = B(I,L) * Y(I,L+1) * A(I,L)
 9000  CONTINUE
 200  CONTINUE

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      SUBROUTINE VTRI2 ( A,B,C,F,Y,K,irun)
      implicit none

      integer k,irun
      _RL A(irun,K),B(irun,K),C(irun,K),F(irun,K)
      _RL Y(irun,K+1)

      integer i,L

      DO 100 L = 2,K
       DO 9000 I = 1,irun
        F(I,L) = F(I,L) + F(I,L-1) * C(I,L)
 9000  CONTINUE
 100  CONTINUE

      DO 200 L = K,1,-1
       DO 9002 I = 1,irun
        Y(I,L) = (F(I,L) + B(I,L) * Y(I,L+1)) *  A(I,L)
 9002  CONTINUE
 200  CONTINUE

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      SUBROUTINE LINADJ ( NN,VRIB1,VRIB2,VWS1,VWS2,VZ1,VUSTAR,IWATER,
     1 VAPSIM, VAPSIHG,VPSIH,VPSIG,VX,VX0,VY,VY0,ITYPE,LWATER,IRUN,
     2 VDZETA,VDZ0,VDPSIM,VDPSIH,INTRIB,
     3 VX0PSIM,VG,VG0,VR1MG0,VZ2,VDZSEA,VAZ0,VXNUM1,VPSIGB2,VDX,
     4 VDXPSIM,VDY,VXNUM2,VDEN,VAWS1,VXNUM3,VXNUM,VDZETA1,VDZETA2,
     5 VZCOEF2,VZCOEF1,VTEMPLIN,VDPSIMC,VDPSIHC)

C**********************************************************************
C  ARGUMENTS ::
C     INPUT:
C     ------
C    RIB1          -         BULK RICHARDSON NUMBER OF INPUT STATE
C    RIB2          -         DESIRED BULK RICH NUMBER OF OUTPUT STATE
C    WS1           -         SURFACE WIND SPEED OF INPUT STATE
C    WS2           -         DESIRED SURFACE WIND SPEED OF OUTPUT STATE
C    Z1            -         INPUT VALUE OF ROUGHNESS HEIGHT
C    USTAR         -         INPUT VALUE OF CU * WS
C    WATER         -         BIT ARRAY - '1' WHERE OCEAN
C    APSIM         -         (1/PSIM)
C    APSIHG        -         ( 1 / (PSIH+PSIG) )
C    PSIH          -         NON-DIM TEMP GRADIENT
C    PSIG          -         PSIH FOR THE MOLECULAR LAYER
C    X             -         PHIM(ZETA) - DERIVATIVE OF PSIM
C    X0            -         PHIM(ZETA0)
C    Y             -         PHIH(ZETA) - DERIVATIVE OF PSIH
C    Y0            -         PHIH(ZETA0)
C    ITYPE         -         INTEGER FLAG :
C                               1 = NEUTRAL ADJUSTMENT
C                               2 = ADJ FOR 2ND OR GREATER TRBFLX ITER
C                               3 - 5 = ADJUSTMENT INSIDE LOOP
C                               4 - 5 = ADJUST CU AND CT
C                               5 = PREPARATION FOR ITYPE = 2
C    LWATER        -         LOGICAL - .TRUE. IF THERE ARE WATER POINTS
C     OUTPUT:
C     -------
C    DZETA         -         D LOG ZETA
C    DZ0           -         D Z0 (ITYPE 1) OR D LOG Z0 (ITYPE 2-5)
C    DPSIM         -         D PSIM
C    DPSIH         -         D PSIH
C    BITRIB        -         BIT ARRAY - '1' WHERE RIB1 = 0
C**********************************************************************
      implicit none

C Argument List Declarations
      integer nn,irun,itype
      _RL VRIB1(IRUN),VRIB2(IRUN)
      _RL VWS1(IRUN),VWS2(IRUN),VZ1(IRUN),VUSTAR(IRUN)
      integer IWATER(IRUN)
      _RL VAPSIM(IRUN),VAPSIHG(IRUN)
      _RL VPSIH(IRUN),VPSIG(IRUN),VX(IRUN)
      _RL VX0(IRUN),VY(IRUN),VY0(IRUN)
      LOGICAL LWATER
      _RL VDZETA(IRUN),VDZ0(IRUN),VDPSIM(IRUN)
      _RL VDPSIH(IRUN)
      integer INTRIB(IRUN)
      _RL VX0PSIM(irun),VG(irun),VG0(irun),VR1MG0(irun)
      _RL VZ2(irun),VDZSEA(irun),VAZ0(irun),VXNUM1(irun)
      _RL VPSIGB2(irun),VDX(irun),VDXPSIM(irun),VDY(irun)
      _RL VXNUM2(irun),VDEN(irun),VAWS1(irun),VXNUM3(irun)
      _RL VXNUM(irun),VDZETA1(irun),VDZETA2(irun)
      _RL VZCOEF2(irun),VZCOEF1(irun),VTEMPLIN(irun)
      _RL VDPSIMC(irun),VDPSIHC(irun)

C Local Variables
      _RL xx0max,prfac,xpfac,difsqt,ustz0s,h0byz0,usth0s
      PARAMETER ( XX0MAX  =   1.49821 )
      PARAMETER ( PRFAC  = 0.595864   )
      PARAMETER ( XPFAC  = .55        )
      PARAMETER ( DIFSQT  = 3.872983E-3)
      PARAMETER ( USTZ0S =   0.2030325E-5)
      PARAMETER ( H0BYZ0 =    30.0    )
      PARAMETER ( USTH0S =  H0BYZ0*USTZ0S )

      integer VINT1(irun),VINT2(irun)
      _RL getcon,vk,bmdl,b2uhs
      integer i

      vk = getcon('VON KARMAN')
      BMDL    = VK * XPFAC * PRFAC / DIFSQT
      B2UHS   = BMDL * BMDL * USTH0S

C   COMPUTE X0/PSIM, 1/Z0, G, G0, 1/(1-G0),
C     DEL LOG Z0, D LOG ZO / D USTAR

CCCOOOMMMM ADDED 'WHERE WATER'
      IF ( (ITYPE.EQ.1) .AND. LWATER ) THEN
       DO 9000 I = 1,IRUN
        IF (IWATER(I).EQ.1) VX0PSIM(I) = VAPSIM(I)
 9000  CONTINUE
      ENDIF
      IF ( ITYPE .GE. 3 ) THEN
       DO 9002 I = 1,IRUN
        VX0PSIM(I) = VX0(I) * VAPSIM(I)
 9002  CONTINUE
      ENDIF
      IF ( ITYPE .NE. 2 ) THEN

       DO 9004 I = 1,IRUN
        VDZ0(I) = 0.
        VG(I) = 0.
        VG0(I) = 0.
        VR1MG0(I) = 1.
 9004  CONTINUE

       IF ( LWATER ) THEN
        CALL ZCSUB ( VUSTAR,VDZSEA,IWATER,.TRUE.,IRUN,VZ2)

        DO 9006 I = 1,IRUN
         IF ( IWATER(I).EQ.1) THEN
          VAZ0(I) = 1. / VZ1(I)
          VG(I) = VDZSEA(I) * VAZ0(I)
          VG0(I) = VX0PSIM(I) * VG(I)
          VR1MG0(I) = 1. / ( 1. - VG0(I) )
          VDZ0(I) = ( VZ2(I) - VZ1(I) ) * VR1MG0(I)
         ENDIF
 9006   CONTINUE
       ENDIF
      ENDIF

      IF ( LWATER .AND. (ITYPE.GE.3) ) THEN
       DO 9008 I = 1,IRUN
        IF (IWATER(I).EQ.1) VDZ0(I) = VDZ0(I) * VAZ0(I)
 9008  CONTINUE
      ENDIF

C   COMPUTE NUM1,NUM2,NUM3, DEN

      IF (ITYPE.GE.3) THEN
       DO 9010 I = 1,IRUN
        VXNUM1(I) = 0.
        IF (VRIB1(I).EQ.0.) THEN
         INTRIB(I) = 1
        ELSE
         INTRIB(I) = 0
        ENDIF
        IF ( INTRIB(I).EQ.0 ) VXNUM1(I) = 1. / VRIB1(I)
        VPSIGB2(I) = 0.
        if(vpsig(i).gt.0.)VPSIGB2(I) =
     1        0.5 * ( vpsig(i)*vpsig(i) + b2uhs ) / vpsig(i)
        VDX(I) = VX(I) - VX0(I)
        VDXPSIM(I) = VDX(I) * VAPSIM(I)
        VDY(I) = VY(I) - VY0(I)
        VXNUM3(I) = - VPSIGB2(I)

        IF ( LWATER ) THEN
CCCOOOMMMM ADDED 'WHERE WATER'
         IF (IWATER(I).EQ.1) THEN
          VDXPSIM(I) = VDXPSIM(I) * VR1MG0(I)
          VXNUM3(I) = VXNUM3(I) + VG(I) * ( VY0(I) - VPSIGB2(I) )
          VXNUM2(I) = VY0(I) - VPSIGB2(I) - VX0PSIM(I) * VPSIGB2(I)
          VXNUM2(I) = (VXNUM2(I) * VAPSIHG(I)) - 2. * VX0PSIM(I)
          VXNUM2(I) = VXNUM2(I) * VDZ0(I)
         ENDIF
        ENDIF

        VDEN(I) = VDY(I) + VDXPSIM(I) * VXNUM3(I)
        VDEN(I) = ( 1. + VDEN(I) * VAPSIHG(I) ) - 2. * VDXPSIM(I)
 9010  CONTINUE
      ENDIF

      IF (ITYPE.EQ.5) THEN
       DO 9012 I = 1,IRUN
        VAWS1(I) = VR1MG0(I) / VWS1(I)
        VXNUM3(I) = VXNUM3(I) * VAPSIHG(I)

        IF ( LWATER ) THEN
CCCOOOMMMM ADDED 'WHERE WATER'
         IF(IWATER(I).EQ.1) THEN
          VXNUM3(I) = VXNUM3(I) - 2. * VG0(I)
          VXNUM3(I) = VAWS1(I) * VXNUM3(I)
         ENDIF
        ENDIF
 9012  CONTINUE
      ENDIF

C   COMPUTE D LOG ZETA

      IF (ITYPE.GE.2) THEN
       DO 9014 I = 1,IRUN
        VXNUM(I) = VRIB2(I) - VRIB1(I)
        IF( (VX0(I).GT.XX0MAX).AND.(VXNUM(I).GE.0.) )VXNUM(I) = 0.
        VXNUM(I) = VXNUM1(I) * VXNUM(I)
 9014  CONTINUE
      ENDIF

      IF ( ITYPE.EQ.2 )THEN
       DO 9016 I = 1,IRUN
        VDZETA1(I) = VDZETA(I)
        VXNUM(I) = VXNUM(I) + VXNUM3(I) * ( VWS2(I) - VWS1(I) )
 9016  CONTINUE
      ENDIF

      IF (ITYPE.GE.3) THEN
       DO 9018 I = 1,IRUN
        VDZETA1(I) = VXNUM(I)
        IF(LWATER.AND.(IWATER(I).EQ.1)) VXNUM(I) = VXNUM(I) + VXNUM2(I)
        IF ( VDEN(I) .LT.0.1 ) VDEN(I) = 0.1
 9018  CONTINUE
      ENDIF

      IF (ITYPE.GE.2) THEN
       DO 9020 I = 1,IRUN
        VDZETA(I) = VXNUM(I) / VDEN(I)
 9020  CONTINUE
      ENDIF
      IF (ITYPE.GE.3) THEN
       DO 9022 I = 1,IRUN
        IF ( (VRIB2(I).EQ.0.) .OR. (VDZETA(I).LE.-1.) ) THEN
         VINT1(I) = 1
        ELSE
         VINT1(I) = 0
        ENDIF
        IF ( VINT1(I).EQ.1 ) VDZETA(I) = VDZETA1(I)
 9022  CONTINUE
      ENDIF
      IF (ITYPE.EQ.2) THEN
       DO 9024 I = 1,IRUN
        VDZETA2(I) = VDZETA(I) + VDZETA1(I)
        IF ( (VRIB2(I).EQ.0.) .OR. (VDZETA2(I).LE.-1.) ) THEN
         VINT1(I) = 1
        ELSE
         VINT1(I) = 0
        ENDIF
        IF(VINT1(I).EQ.1)VDZETA(I)=VXNUM1(I)*VRIB2(I) - 1. - VDZETA1(I)
 9024  CONTINUE
      ENDIF

C   COMPUTE D LOG Z0

      IF ( LWATER .AND. (ITYPE.GE.3) )THEN
       DO 9026 I = 1,IRUN
        IF( IWATER(I).EQ.1 ) THEN
         VZCOEF2(I) = VG(I) * VDXPSIM(I)
         VDZ0(I) = VDZ0(I) - VZCOEF2(I) * VDZETA(I)
        ENDIF
 9026  CONTINUE
      ENDIF

      IF ( LWATER .AND. (ITYPE.EQ.5) ) THEN
       DO 9028 I = 1,IRUN
        IF(IWATER(I).EQ.1) VZCOEF1(I) = VG(I) * VAWS1(I)
 9028  CONTINUE
      ENDIF

      IF ( LWATER .AND. (ITYPE.EQ.2) ) THEN
       DO 9030 I = 1,IRUN
        IF (IWATER(I).EQ.1) VDZ0(I) =
     1   VZCOEF1(I) * ( VWS2(I) - VWS1(I) ) - VZCOEF2(I) * VDZETA(I)
 9030  CONTINUE
      ENDIF

C   CALCULATE D PSIM AND D PSIH

      IF ( (ITYPE.EQ.1) .AND. LWATER ) THEN
       DO 9032 I = 1,IRUN
        IF (IWATER(I).EQ.1) THEN
         VDPSIM(I) = - VDZ0(I) * VAZ0(I)
         VDPSIH(I) = VDPSIM(I)
        ENDIF
 9032  CONTINUE
      ENDIF

      IF (ITYPE.GE.3) THEN
       DO 9034 I = 1,IRUN
        VDPSIM(I) = VDX(I) * VDZETA(I)
        VDPSIH(I) = VDY(I) * VDZETA(I)
        IF ( LWATER ) THEN
         IF (IWATER(I).EQ.1 ) THEN
          VDPSIM(I) = VDPSIM(I) - VX0(I) * VDZ0(I)
          VDPSIH(I) = VDPSIH(I) - VY0(I) * VDZ0(I)
         ENDIF
        ENDIF
 9034  CONTINUE
      ENDIF

C   PREVENT OVERCORRECTION OF PSIM OR PSIH FOR UNSTABLE CASE

      IF (ITYPE.GE.4) THEN
       DO 9036 I = 1,IRUN
        VDPSIMC(I) = -0.9 - VDPSIM(I) * VAPSIM(I)
        VDPSIHC(I) = -0.9 *  VPSIH(I) - VDPSIH(I)
        IF ( VDPSIMC(I).GT.0.  ) THEN
         VINT1(I) = 1
        ELSE
         VINT1(I) = 0
        ENDIF
        IF ( VDPSIHC(I).GT.0.  ) THEN
         VINT2(I) = 1
        ELSE
         VINT2(I) = 0
        ENDIF
        VDZETA1(I) = 0.
        IF(VINT1(I).EQ.1) VDZETA1(I) = VDPSIMC(I) / VDXPSIM(I)
        IF((VINT1(I).EQ.1).OR.(VINT2(I).EQ.1)) VTEMPLIN(I) =
     1        VDY(I) + VY0(I) * VG(I) * VDXPSIM(I)
        IF (VINT2(I).EQ.1) then
             VDZETA2(I) =  VDPSIHC(I) / VTEMPLIN(I)
        IF ( VDZETA2(I).LT.VDZETA1(I) ) VDZETA1(I) = VDZETA2(I)
        endif
        IF((VINT1(I).EQ.1).OR.(VINT2(I).EQ.1)) THEN
         VDZETA(I) = VDZETA1(I) + VDZETA(I)
         VDPSIM(I) = VDPSIM(I) + VDX(I) * VR1MG0(I) * VDZETA1(I)
         VDPSIH(I) = VDPSIH(I) + VTEMPLIN(I) * VDZETA1(I)
         IF ( IWATER(I).EQ.1 )
     1     VDZ0(I) = VDZ0(I) - VG(I) * VDXPSIM(I) * VDZETA1(I)
        ENDIF
 9036  CONTINUE
      ENDIF

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      SUBROUTINE ZCSUB (VUSTAR,VDZSEA,IWATER,LDZSEA,IRUN,VZSEA)
C**********************************************************************
C  FUNCTION ZSEA
C  PURPOSE
C     COMPUTES Z0 AS A FUNCTION OF USTAR OVER WATER SURFACES
C  USAGE
C     CALLED BY SFCFLX
C  DESCRIPTION OF PARAMETERS
C     USTAR -  INPUTED VALUE OF SURFACE-STRESS VELOCITY
C     DZSEA -  OUTPUTED VALUE OF DERIVATIVE  D(ZSEA)/D(USTAR)
C     WATER -  INPUTED BIT VECTOR TO DETERMINE WATER POINTS
C     LDZSEA-  LOGICAL FLAG TO DETERMINE IF DZSEA SHOULD BE COMPUTED
C     ZSEA  -  OUTPUTED VALUE OF ROUGHNESS LENGTH
C  SUBPROGRAMS NEEDED
C     NONE
C  RECORD OF MODIFICATIONS
C  REMARKS:
C        COMPUTE ROUGHNESS LENGTH FOR OCEAN POINTS
C          BASED ON FUNCTIONS OF LARGE AND POND
C          AND OF KONDO --- DESIGNED FOR K = .4
C *********************************************************************
      implicit none

C Argument List Delcarations
      integer irun
      _RL VZSEA(IRUN),VUSTAR(IRUN),VDZSEA(IRUN)
      integer IWATER(IRUN)
      LOGICAL LDZSEA

C Local Variables
      _RL USTMX1,USTMX2,USTMX3
      PARAMETER ( USTMX1 =   1.14973  )
      PARAMETER ( USTMX2 =   0.381844 )
      PARAMETER ( USTMX3 =   0.0632456)

      _RL AA(IRUN,5),TEMP(IRUN)
      integer INT2(IRUN),INT3(IRUN),INT4(IRUN)
      integer i,k

      _RL AA1(5),AA2(5),AA3(5),AA4(5)
      DATA AA1/.2030325E-5,0.0,0.0,0.0,0.0/
      DATA AA2/-0.402451E-08,0.239597E-04,0.117484E-03,0.191918E-03,
     1         0.395649E-04/
      DATA AA3/-0.237910E-04,0.228221E-03,-0.860810E-03,0.176543E-02,
     1         0.784260E-04/
      DATA AA4/-0.343228E-04,0.552305E-03,-0.167541E-02,0.250208E-02,
     1         -0.153259E-03/

C**********************************************************************
C*****              LOWER CUTOFF CONDITION FOR USTAR                ***
C**********************************************************************

      DO 9000 I = 1,IRUN
       IF(VUSTAR(I) .LT. 1.e-6)THEN
        INT3(I) = 1
       ELSE
        INT3(I) = 0
       ENDIF
 9000 CONTINUE
      DO 9002 I = 1,IRUN
       IF(INT3(I).EQ.1) VUSTAR(I) = 1.e-6
 9002 CONTINUE

C***********************************
C*****  LOAD THE ARRAY A(I,K)  *****
C***********************************

      DO 9004 I = 1,IRUN
       IF( (VUSTAR(I) .GT. USTMX1) .AND. (IWATER(I).EQ.1) ) THEN
        INT4(I) = 1
       ELSE
        INT4(I) = 0
       ENDIF
 9004 CONTINUE
      DO 9006 I = 1,IRUN
       IF(VUSTAR(I) .GT. USTMX2) THEN
        INT3(I) = 1
       ELSE
        INT3(I) = 0
       ENDIF
 9006 CONTINUE
      DO 9008 I = 1,IRUN
       IF(VUSTAR(I) .GE. USTMX3) THEN
        INT2(I) = 1
       ELSE
        INT2(I) = 0
       ENDIF
 9008 CONTINUE

      DO 100 K=1,5
       DO 9010 I = 1,IRUN
        AA(I,K) = AA1(K)
        IF( INT2(I).EQ.1 )  AA(I,K) = AA2(K)
        IF( INT3(I).EQ.1 )  AA(I,K) = AA3(K)
        IF( INT4(I).EQ.1 )  AA(I,K) = AA4(K)
 9010  CONTINUE
  100 CONTINUE

C********************************************************
C*****  EVALUATE THE ENHANCED POLYNOMIAL FOR ZSEA  *****
C********************************************************

      DO 9012 I = 1,IRUN
       VDZSEA(I)  =  ( AA(I,4) + AA(I,5) * VUSTAR(I) ) * VUSTAR(I)
       VZSEA(I)  =  AA(I,2) + ( AA(I,3) + VDZSEA(I) ) * VUSTAR(I)
       TEMP(I) = AA(I,1) / VUSTAR(I)
       VZSEA(I)  =  VZSEA(I) + TEMP(I)
 9012 CONTINUE

C**********************************************************************
C*****        EVALUATE THE DERIVATIVE DZSEA IF LDZSEA IS TRUE       ***
C**********************************************************************

      IF( LDZSEA ) THEN
       DO 9014 I = 1,IRUN
        VDZSEA(I)  =  3. * VDZSEA(I) -(AA(I,4)*VUSTAR(I) - AA(I,3))
        VDZSEA(I)  =  VDZSEA(I) * VUSTAR(I) - TEMP(I)
 9014  CONTINUE
      ENDIF

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      SUBROUTINE SEAICE ( nocean, timstp, hice,
     &                     eturb,  dedtc,
     &                    hsturb, dhsdtc,
     &                      qice,  dqice,
     &                     swnet,  lwnet, dst4,
     &                       pke,  seaic, tc, qa )
      implicit none
      integer  nocean
      _RL timstp
      _RL eturb(nocean),dedtc(nocean),hsturb(nocean),dhsdtc(nocean)
      _RL swnet(nocean),lwnet(nocean),  dst4(nocean)
      _RL  qice(nocean),dqice(nocean)
      _RL   pke(nocean),   tc(nocean),    qa(nocean)
      _RL seaic(nocean)

C  rho*C = 1.93e6 J/(m**3 K) ; Peixoto & Oort
      _RL rhoC
      parameter (rhoC = 1.93e6)

      _RL faceps,getcon,latent,codt,deltg,hice
      integer i

      faceps = getcon('EPSFAC')
      latent = getcon('HEATI') * getcon('CALTOJ')
C Note hice is in centimeters
      codt   = rhoC * (hice/100) / timstp

C Update TC and QA
C ----------------
      do i =1,nocean
       if( seaic(i).gt.0.0 ) then
        deltg = ( swnet(i)-lwnet(i)-latent*eturb(i)-hsturb(i)+qice(i) )
     &          / ( codt+dst4(i)+latent*dedtc(i)+dhsdtc(i)-dqice(i) )
        qa(i) = qa(i) + (faceps*qa(i)/(tc(i)*tc(i)))*deltg
        tc(i) = tc(i) + deltg
       endif
      enddo

      return
      end

#include "CPP_EEOPTIONS.h"

CBOP
C     !ROUTINE: COMM_STATS

C     !INTERFACE:
      SUBROUTINE COMM_STATS
      IMPLICIT NONE

C     !DESCRIPTION:
C     *==========================================================
C     | SUBROUTINE COMM\_STATS                                    
C     | o Print out statistics from communication routines.      
C     *==========================================================

C     !USES:
C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "EESUPPORT.h"
#include "EXCH.h"
#include "BAR2.h"

C     !LOCAL VARIABLES:
C     == Local variables ==
C     bi, bj, I :: Loop counters
C     msgBuf    :: Temp. for building text messages.
      INTEGER bi, bj, I
      CHARACTER*(MAX_LEN_MBUF) msgBuf
CEOP
    
C      o For each tile print its excange statistics
       WRITE(msgBuf,'(A)')
     & '// ======================================================'
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &   SQUEEZE_RIGHT , 1)
       WRITE(msgBuf,'(A)') '// Tile <-> Tile communication statistics'
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &   SQUEEZE_RIGHT , 1)
       WRITE(msgBuf,'(A)')
     & '// ======================================================'
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &   SQUEEZE_RIGHT , 1)
      
      IF ( exchCollectStatistics ) THEN
       DO bj=1,nSy
        DO bi=1,nSx
         WRITE(msgBuf,'(A,A,I6.6)')
     &    '//',' o Tile number: ',tileNo(bi,bj)
         CALL PRINT_MESSAGE(msgBuf,standardMessageUnit,
     &                      SQUEEZE_RIGHT , 1)
C        o X exchange stats.
         WRITE(msgBuf,'(A,A,I15)')
     &    '//','         No. X exchanges =',exchRecvXExchCount(1,bi,bj)
         CALL PRINT_MESSAGE(msgBuf,standardMessageUnit,
     &                     SQUEEZE_RIGHT , 1)
         WRITE(msgBuf,'(A,A,I15)')
     &    '//','            Max. X spins =',exchRecvXSpinMax  (1,bi,bj)
         CALL PRINT_MESSAGE(msgBuf,standardMessageUnit,
     &                     SQUEEZE_RIGHT , 1)
         WRITE(msgBuf,'(A,A,I15)')
     &    '//','            Min. X spins =',exchRecvXSpinMin  (1,bi,bj)
         CALL PRINT_MESSAGE(msgBuf,standardMessageUnit,
     &                     SQUEEZE_RIGHT , 1)
         WRITE(msgBuf,'(A,A,I15)')
     &    '//','          Total. X spins =',exchRecvXSpinCount(1,bi,bj)
         CALL PRINT_MESSAGE(msgBuf,standardMessageUnit,
     &                     SQUEEZE_RIGHT , 1)
         IF ( FLOAT(exchRecvXExchCount(1,bi,bj)) .NE. 0. ) THEN
          WRITE(msgBuf,'(A,A,1PE15.2)')
     &    '//','            Avg. X spins =',
     &    FLOAT(exchRecvXSpinCount(1,bi,bj))/
     &    FLOAT(exchRecvXExchCount(1,bi,bj))
         ELSE
          WRITE(msgBuf,'(A,A,1PE15.2)')
     &    '//','            Avg. X spins =',
     &    0.
         ENDIF
         CALL PRINT_MESSAGE(msgBuf,standardMessageUnit,
     &                     SQUEEZE_RIGHT , 1)
C        o Y exchange stats.
         WRITE(msgBuf,'(A,A,I15)')
     &    '//','         No. Y exchanges =',exchRecvYExchCount(1,bi,bj)
         CALL PRINT_MESSAGE(msgBuf,standardMessageUnit,
     &                     SQUEEZE_RIGHT , 1)
         WRITE(msgBuf,'(A,A,I15)')
     &    '//','            Max. Y spins =',exchRecvYSpinMax  (1,bi,bj)
         CALL PRINT_MESSAGE(msgBuf,standardMessageUnit,
     &                     SQUEEZE_RIGHT , 1)
         WRITE(msgBuf,'(A,A,I15)')
     &    '//','            Min. Y spins =',exchRecvYSpinMin  (1,bi,bj)
         CALL PRINT_MESSAGE(msgBuf,standardMessageUnit,
     &                     SQUEEZE_RIGHT , 1)
         WRITE(msgBuf,'(A,A,I15)')
     &    '//','          Total. Y spins =',exchRecvYSpinCount(1,bi,bj)
         CALL PRINT_MESSAGE(msgBuf,standardMessageUnit,
     &                     SQUEEZE_RIGHT , 1)
         IF ( FLOAT(exchRecvYExchCount(1,bi,bj)) .NE. 0. ) THEN
          WRITE(msgBuf,'(A,A,1PE15.2)')
     &    '//','            Avg. Y spins =',
     &    FLOAT(exchRecvYSpinCount(1,bi,bj))/
     &    FLOAT(exchRecvYExchCount(1,bi,bj))
         ELSE
          WRITE(msgBuf,'(A,A,1PE15.2)')
     &    '//','            Avg. Y spins =',
     &    0.
         ENDIF
         CALL PRINT_MESSAGE(msgBuf,standardMessageUnit,
     &                     SQUEEZE_RIGHT , 1)
       
        ENDDO
       ENDDO
      ENDIF
 
      IF ( bar2CollectStatistics ) THEN
       DO I=1,nThreads
         WRITE(msgBuf,'(A,A,I6.6)')
     &    '//',' o Thread number: ',I
         CALL PRINT_MESSAGE(msgBuf,standardMessageUnit,
     &                      SQUEEZE_RIGHT , 1)
         WRITE(msgBuf,'(A,A,I15)')
     &    '//','            No. barriers =',BAR2_barrierCount(1,I)
         CALL PRINT_MESSAGE(msgBuf,standardMessageUnit,
     &                     SQUEEZE_RIGHT , 1)
         WRITE(msgBuf,'(A,A,I15)')
     &    '//','      Max. barrier spins =',BAR2_spinsMax(1,I)
         CALL PRINT_MESSAGE(msgBuf,standardMessageUnit,
     &                     SQUEEZE_RIGHT , 1)
         WRITE(msgBuf,'(A,A,I15)')
     &    '//','      Min. barrier spins =',BAR2_spinsMin(1,I)
         CALL PRINT_MESSAGE(msgBuf,standardMessageUnit,
     &                     SQUEEZE_RIGHT , 1)
         WRITE(msgBuf,'(A,A,I15)')
     &    '//','     Total barrier spins =',BAR2_spinsCount(1,I)
         CALL PRINT_MESSAGE(msgBuf,standardMessageUnit,
     &                     SQUEEZE_RIGHT , 1)
         IF ( FLOAT(BAR2_spinsCount(1,I)) .NE. 0. ) THEN
          WRITE(msgBuf,'(A,A,1PE15.2)')
     &    '//','      Avg. barrier spins =',
     &    FLOAT(BAR2_spinsCount(1,I))/FLOAT(BAR2_barrierCount(1,I))
         ELSE
          WRITE(msgBuf,'(A,A,1PE15.2)')
     &    '//','      Avg. barrier spins =',
     &    0.
         ENDIF
         CALL PRINT_MESSAGE(msgBuf,standardMessageUnit,
     &                     SQUEEZE_RIGHT , 1)
       ENDDO
      ENDIF

C
      RETURN
      END

#include "ZONAL_FILT_OPTIONS.h"

      SUBROUTINE ZONAL_FILT_READPARMS( myThid )
C     *==========================================================*
C     | SUBROUTINE ZONAL_FILT_READPARMS                          |
C     | o Routine to initialize Zonal Filter (=FFT) parameters   |
C     *==========================================================*

      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "ZONAL_FILT.h"

C     === Routine arguments ===
      INTEGER myThid

#ifdef ALLOW_ZONAL_FILT
C     === Local variables ===
C     msgBuf     :: Informational/error message buffer
C     iUnit      :: Work variable for IO unit number
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      INTEGER iUnit

      NAMELIST /ZONFILT_PARM01/
     &          zonal_filt_uvStar, zonal_filt_TrStagg,
     &          zonal_filt_lat,
     &          zonal_filt_cospow, zonal_filt_sinpow,
     &          zonal_filt_mode2dx

      IF ( .NOT.useZONAL_FILT ) THEN
C-    pkg ZONAL_FILT is not used
        _BEGIN_MASTER(myThid)
C-    Track pkg activation status:
c        ZONFILTisOn = .FALSE.
C     print a (weak) warning if data.zonfilt is found
          CALL PACKAGES_UNUSED_MSG( 'useZONAL_FILT', ' ', 'zonfilt' )
        _END_MASTER(myThid)
        RETURN
      ENDIF

C--   ZONAL_FILT_READPARMS has been called so we know that
C     the package is active.
c     ZONFILTisOn = .TRUE.

      _BEGIN_MASTER(myThid)

      WRITE(msgBuf,'(A)')' ZONAL_FILT_READPARMS: opening data.zonfilt'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT , 1)

      CALL OPEN_COPY_DATA_FILE(
     I                         'data.zonfilt', 'ZONAL_FILT_READPARMS',
     O                         iUnit,
     I                         myThid )

C--   Default flags and values for Zonal Filter
      zonal_filt_uvStar   = .TRUE.
      zonal_filt_TrStagg  = .TRUE.
      zonal_filt_lat      = 90.
      zonal_filt_sinpow   = 2
      zonal_filt_cospow   = 2
      zonal_filt_mode2dx  = 0

C--   Read parameters from open data file
      READ(UNIT=iUnit,NML=ZONFILT_PARM01)

      WRITE(msgBuf,'(A)')
     &   ' ZONAL_FILT_READPARMS: finished reading data.zonfilt'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT , 1)

c     write(*,*) 'Shap_funct, nShap_Tr,UV _Phys=',
c    &    Shap_funct, nShapT, nShapUV, nShapTrPhys, nShapUVPhys
c     write(*,*) 'Shap_Trtau,Shap_uvtau=',Shap_Trtau,Shap_uvtau

C--   Close the open data file
#ifdef SINGLE_DISK_IO
      CLOSE(iUnit)
#else
      CLOSE(iUnit,STATUS='DELETE')
#endif /* SINGLE_DISK_IO */
      _END_MASTER(myThid)

C--   Everyone else must wait for the parameters to be loaded
      _BARRIER

C--   Check the parameters :

       IF ( .NOT.zonal_filt_uvStar ) THEN

C- Notes: applying the filter at the end of the time step (after SOLVE_FOR_P)
C    affects the barotropic flow divergence ; this might not be consistent
C    with some option of the code.

        IF ( rigidLid ) THEN
         WRITE(msgBuf,'(2A)') 'ZONAL_FILT with rigidLid ',
     &                         'needs zonal_filt_uvStar=.true.'
         CALL PRINT_ERROR( msgBuf , 1)
         STOP 'ABNORMAL END: S/R ZONAL_FILT_READPARMS'
        ELSEIF ( .NOT.exactConserv ) THEN
         WRITE(msgBuf,'(2A)') 'S/R ZONAL_FILT_READPARMS: WARNING <<< ',
     &    'applying Filter after SOLVE_FOR_P (zonal_filt_uvStar=FALSE)'
         CALL PRINT_MESSAGE(msgBuf, errorMessageUnit, SQUEEZE_RIGHT,1)
         WRITE(msgBuf,'(2A)') 'S/R ZONAL_FILT_READPARMS: WARNING <<< ',
     &    'requires to recompute Eta after ==> turn on exactConserv !'
         CALL PRINT_MESSAGE(msgBuf, errorMessageUnit, SQUEEZE_RIGHT,1)
        ENDIF

       ENDIF

#endif /* ALLOW_ZONAL_FILT */

      RETURN
      END

C this needs changes

#include "STREAMICE_OPTIONS.h"
#ifdef ALLOW_COST
# include "COST_OPTIONS.h"
#endif

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 0
      SUBROUTINE STREAMICE_READPARMS( myThid )

C     !DESCRIPTION:
C     Initialize STREAMICE variables and constants.

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "STREAMICE.h"
#include "STREAMICE_FP.h"
#include "STREAMICE_BDRY.h"
c#ifdef ALLOW_STREAMICE_FLUX_CONTROL
c#include "STREAMICE_CTRL_FLUX.h"
c#endif

C     !INPUT PARAMETERS:
      INTEGER myThid
CEOP

#ifdef ALLOW_STREAMICE
C     !LOCAL VARIABLES:
C     msgBuf     :: Informational/error message buffer
C     iUnit      :: Work variable for IO unit number
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      INTEGER iUnit
# ifdef ALLOW_STREAMICE_TC_COST
      INTEGER iarr
# endif

c      _RL streamice_bdot_depth_nomelt
c      _RL streamice_bdot_depth_maxmelt
c      _RL streamice_bdot_maxmelt

      NAMELIST /STREAMICE_PARM01/
     &     streamice_density, streamice_density_ocean_avg,
     &     streamice_density_firn,
     &     B_glen_isothermal, n_glen, eps_glen_min, eps_u_min,
     &     C_basal_fric_const, n_basal_friction,
     &     streamice_vel_update,streamice_cg_tol,streamice_nonlin_tol,
     &     streamice_nonlin_tol_fp, streamice_err_norm,
     &     streamice_max_cg_iter, streamice_max_nl_iter,
     &     streamice_maxcgiter_cpl, streamice_maxnliter_cpl,
     &     STREAMICEthickInit,
     &     STREAMICEsigcoordInit,
     &     STREAMICEsigcoordFile,
     &     STREAMICEthickFile,
     &     STREAMICEcalveMaskFile,
     &     STREAMICEcostMaskFile,
     &     STREAMICE_dump_mdsio, STREAMICE_tave_mdsio,
     &     STREAMICE_dump_mnc, STREAMICE_tave_mnc,
     &     STREAMICE_move_front,
     &     STREAMICE_calve_to_mask,
     &     STREAMICE_diagnostic_only,
     &     STREAMICE_lower_cg_tol,
     &     streamice_CFL_factor,
     &     streamice_adjDump,
     &     streamice_bg_surf_slope_x, streamice_bg_surf_slope_y,
     &     streamice_kx_b_init, streamice_ky_b_init,
     &     STREAMICEbasalTracConfig,
     &     STREAMICEBdotConfig,
     &     STREAMICEAdotConfig,
     &     STREAMICEbasalTracFile,
     &     STREAMICEBdotFile,
     &     STREAMICEAdotFile,
     &     STREAMICEBdotTimeDepFile,
     &     streamice_bdot_depth_nomelt,
     &     streamice_bdot_depth_maxmelt,
     &     streamice_bdot_maxmelt,
     &     streamice_bdot_exp,
     &     STREAMICEtopogFile,
     &     STREAMICEhmaskFile,
     &     STREAMICEHBCyFile,
     &     STREAMICEHBCxFile,
     &     STREAMICEuFaceBdryFile,
     &     STREAMICEvFaceBdryFile,
     &     STREAMICEuDirichValsFile,
     &     STREAMICEvDirichValsFile,
     &     STREAMICEuMassFluxFile,
     &     STREAMICEvMassFluxFile,
     &     STREAMICEuNormalStressFile,
     &     STREAMICEvNormalStressFile,
     &     STREAMICEuShearStressFile,
     &     STREAMICEvShearStressFile,
     &     STREAMICEuNormalTimeDepFile,
     &     STREAMICEvNormalTimeDepFile,
     &     STREAMICEuShearTimeDepFile,
     &     STREAMICEvShearTimeDepFile,
     &     STREAMICEuFluxTimeDepFile, STREAMICEvFluxTimeDepFile,
     &     bdotMaxmeltTimeDepFile,
     &     bglenTimeDepFile,
     &     cfricTimeDepFile,
     &     STREAMICEGlenConstFile, STREAMICEGlenConstConfig,
     &     STREAMICE_ppm_driving_stress,
     &     STREAMICE_h_ctrl_const_surf,
     &     streamice_addl_backstress,
     &     streamice_smooth_gl_width,
     &     streamice_adot_uniform,
     &     streamice_firn_correction,
     &     STREAMICE_apply_firn_correction,
     &     STREAMICE_ADV_SCHEME, streamice_forcing_period,
     &     STREAMICE_chkfixedptconvergence,
     &     STREAMICE_chkresidconvergence,
     &     STREAMICE_alt_driving_stress,
     &     STREAMICE_allow_reg_coulomb,
     &     STREAMICE_use_log_ctrl,
     &     STREAMICE_vel_ext,
     &     STREAMICE_vel_ext_cgrid,
     &     STREAMICE_uvel_ext_file,
     &     STREAMICE_vvel_ext_file,
     &     STREAMICEBdotDepthFile,
     &     STREAMICEBdotMaxMeltFile,
     &      STREAMICE_shelf_dhdt_ctrl,
#ifdef STREAMICE_FLOWLINE_BUTTRESS
     &     streamice_buttr_width,
     &     useStreamiceFlowlineButtr,
#endif
     &     STREAMICE_allow_cpl
#ifdef ALLOW_OPENAD
     &     ,streamice_smooth_thick_adjoint
#endif

#ifdef ALLOW_STREAMICE_2DTRACER
      NAMELIST /STREAMICE_PARMTRACER/
     &     STREAMICETrac2DBCxFile,
     &     STREAMICETrac2DBCyFile,
     &     STREAMICETrac2DINITFile
#endif

#ifdef ALLOW_PETSC
      NAMELIST /STREAMICE_PARMPETSC/
     &     PETSC_PRECOND_TYPE, PETSC_SOLVER_TYPE,
     &     streamice_use_petsc, streamice_maxnliter_petsc,
     &     streamice_petsc_pcfactorlevels
#endif

#ifdef ALLOW_STREAMICE_FP_ADJ
      NAMELIST /STREAMICE_PARMOAD/
     &     streamice_nonlin_tol_adjoint,
     &     streamice_nonlin_tol_adjoint_rl
#ifdef ALLOW_PETSC
     &     ,STREAMICE_OAD_petsc_reuse,
     &     PETSC_PRECOND_OAD
#endif
#endif

#ifdef ALLOW_COST_STREAMICE
      NAMELIST /STREAMICE_COST/
     &     STREAMICEvelOptimSnapBasename,
     &     STREAMICEvelOptimTCBasename,
     &     STREAMICEsurfOptimTCBasename,
     &     STREAMICEBglenCostMaskFile,
     &     streamice_wgt_drift,
     &     streamice_wgt_vel,
     &     streamice_wgt_vel_norm,
     &     streamice_wgt_surf,
     &     streamice_wgt_tikh_beta,
     &     streamice_wgt_tikh_bglen,
     &     streamice_wgt_tikh_gen,
     &     streamice_wgt_prior_bglen,
     &     streamice_wgt_prior_gen,
     &     STREAMICE_do_snapshot_cost,
     &     STREAMICE_do_timedep_cost,
     &     STREAMICE_do_verification_cost,
     &     STREAMICE_do_vaf_cost
#ifdef ALLOW_STREAMICE_TC_COST
     &     ,streamice_vel_cost_timesteps,
     &     streamice_surf_cost_timesteps
#endif
#endif

c#ifdef ALLOW_STREAMICE_FLUX_CONTROL
c      NAMELIST /STREAMICE_PARMFLUXCTRL/
c     &     n_fluxes, n_epochs,
c     &     streamice_ctrl_flux_id,
c     &     streamice_ctrl_flux_scaleVel
c#endif

      NAMELIST /STREAMICE_PARM02/
     &     shelf_max_draft,
     &     shelf_min_draft,
     &     shelf_edge_pos,
     &     shelf_slope_scale,
     &     shelf_flat_width,
     &     flow_dir

      NAMELIST /STREAMICE_PARM03/
     &     min_x_noflow_NORTH, max_x_noflow_NORTH,
     &     min_x_noflow_SOUTH, max_x_noflow_SOUTH,
     &     min_y_noflow_WEST, max_y_noflow_WEST,
     &     min_y_noflow_EAST, max_y_noflow_EAST,
     &     min_x_noStress_NORTH, max_x_noStress_NORTH,
     &     min_x_noStress_SOUTH, max_x_noStress_SOUTH,
     &     min_y_noStress_WEST, max_y_noStress_WEST,
     &     min_y_noStress_EAST, max_y_noStress_EAST,
     &     min_x_FluxBdry_NORTH, max_x_FluxBdry_NORTH,
     &     min_x_FluxBdry_SOUTH, max_x_FluxBdry_SOUTH,
     &     min_y_FluxBdry_WEST, max_y_FluxBdry_WEST,
     &     min_y_FluxBdry_EAST, max_y_FluxBdry_EAST,
     &     min_x_Dirich_NORTH, max_x_Dirich_NORTH,
     &     min_x_Dirich_SOUTH, max_x_Dirich_SOUTH,
     &     min_y_Dirich_WEST, max_y_Dirich_WEST,
     &     min_y_Dirich_EAST, max_y_Dirich_EAST,
     &     min_x_CFBC_NORTH, max_x_CFBC_NORTH,
     &     min_x_CFBC_SOUTH, max_x_CFBC_SOUTH,
     &     min_y_CFBC_WEST, max_y_CFBC_WEST,
     &     min_y_CFBC_EAST, max_y_CFBC_EAST,
     &     flux_bdry_val_SOUTH, flux_bdry_val_NORTH,
     &     flux_bdry_val_WEST, flux_bdry_val_EAST,
     &     STREAMICE_NS_periodic, STREAMICE_EW_periodic

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      IF ( .NOT.useStreamIce ) THEN
C-    pkg STREAMICE is not used
        _BEGIN_MASTER(myThid)
C-    Track pkg activation status:
         STREAMICEisOn = .FALSE.
C     print a (weak) warning if data.streamice is found
         CALL PACKAGES_UNUSED_MSG( 'useStreamIce', ' ', ' ' )
        _END_MASTER(myThid)
        RETURN
      ENDIF

      _BEGIN_MASTER(myThid)

C This routine has been called by the main model so we set our
C internal flag to indicate we are in business
      STREAMICEisOn = .TRUE.

C--   Default values for STREAMICE

      streamice_density = 917.
      streamice_density_ocean_avg = 1024.
      streamice_density_firn = streamice_density
      B_glen_isothermal = 9.461e-18   !  Pa (-1/3) a
      n_glen = 3.
      eps_glen_min = 1.0e-12
      eps_u_min = 1.0e-6
      C_basal_fric_const = 31.71 ! Pa (m/a)-1n
      n_basal_friction = -1.
      streamice_vel_update = deltaT ! seconds
      streamice_cg_tol = 1e-6
      streamice_nonlin_tol = 1e-6
      streamice_nonlin_tol_fp = 1.e-14
      streamice_err_norm = 0.
#ifdef ALLOW_STREAMICE_FP_ADJ
      streamice_nonlin_tol_adjoint = 1.e-14
      streamice_nonlin_tol_adjoint_rl = 1.e-14
#ifdef ALLOW_PETSC
      PETSC_PRECOND_OAD = 'MUMPS'
      STREAMICE_OAD_petsc_reuse =.false.
#endif
#endif
      streamice_max_cg_iter = 2000
      streamice_max_nl_iter = 100
      streamice_maxnliter_petsc = -1
      streamice_maxcgiter_cpl = 0
      streamice_maxnliter_cpl = 0
      streamice_petsc_pcfactorlevels = 0
#ifdef ALLOW_OPENAD
      streamice_smooth_thick_adjoint = 0
#endif
c      streamice_n_sub_regularize = 4
      streamice_CFL_factor = .5
      streamice_adjDump = 0.
      streamice_bg_surf_slope_x = .0
      streamice_bg_surf_slope_y = 0.
      streamice_kx_b_init = 1.
      streamice_ky_b_init = 1.
      streamice_addl_backstress = 0.0
      streamice_smooth_gl_width = 0.0
      streamice_adot_uniform = 0.0
      streamice_forcing_period = 0
      streamice_firn_correction = 0.
      streamice_bdot_depth_nomelt = 0.
      streamice_bdot_depth_maxmelt = 0.
      streamice_bdot_maxmelt = 0.
      streamice_bdot_exp = 1.

#ifdef STREAMICE_FLOWLINE_BUTTRESS
      streamice_buttr_width = 1000000000.
#endif
      STREAMICE_apply_firn_correction = .false.

      STREAMICEthickInit = 'FILE'
      STREAMICEthickFile = ' '
      STREAMICEcalveMaskFile = ' '
      STREAMICEsigcoordInit = 'UNIFORM'
      STREAMICEsigcoordFile = ' '
      STREAMICEbasalTracConfig = 'UNIFORM'
      STREAMICEBdotConfig = ''
      STREAMICEAdotConfig = ''
      STREAMICEBdotFile = ''
      STREAMICEAdotFile = ''
      STREAMICEBdotTimeDepFile = ' '
      STREAMICEbasalTracFile = ' '
      STREAMICEtopogFile = ''
      STREAMICEhmaskFile = ''
      STREAMICEHBCyFile = ''
      STREAMICEHBCxFile = ''
      STREAMICEuNormalStressFile = ''
      STREAMICEvNormalStressFile = ''
      STREAMICEuShearStressFile = ''
      STREAMICEvShearStressFile = ''
      STREAMICEuNormalTimeDepFile = ' '
      STREAMICEvNormalTimeDepFile = ' '
      STREAMICEuShearTimeDepFile = ' '
      STREAMICEvShearTimeDepFile = ' '
      STREAMICEuFluxTimeDepFile = ' '
      STREAMICEvFluxTimeDepFile = ' '
      STREAMICE_vvel_ext_file = ' '
      STREAMICE_uvel_ext_file = ' '
      bdotMaxmeltTimeDepFile = ' '
      bglenTimeDepFile = ' '
      cfricTimeDepFile = ' '

#ifdef ALLOW_STREAMICE_2DTRACER
      STREAMICETrac2DBCxFile = ''
      STREAMICETrac2DBCyFile = ''
      STREAMICETrac2DInitFile = ''
#endif
      STREAMICEuFaceBdryFile = ''
      STREAMICEvFaceBdryFile = ''
      STREAMICEuDirichValsFile = ''
      STREAMICEvDirichValsFile = ''
      STREAMICEuMassFluxFile = ''
      STREAMICEvMassFluxFile = ''
      STREAMICEGlenConstFile = ''
      STREAMICEcostMaskFile = ''
      STREAMICEGlenConstConfig = 'UNIFORM'
#ifdef ALLOW_PETSC
      PETSC_PRECOND_TYPE = 'PCBJACOBI'
      PETSC_SOLVER_TYPE = 'KSPCG'
      streamice_use_petsc = .false.
#endif
      STREAMICE_ADV_SCHEME = ''
      STREAMICEBdotDepthFile = ''
      STREAMICEBdotMaxMeltFile = ''

c#ifdef ALLOW_STREAMICE_FLUX_CONTROL
c      n_fluxes = 0
c      n_epochs = 0
c      DO iarr=1,n_fluxes_max
c       streamice_ctrl_flux_id(iarr) = 0
c       DO tarr=1,n_epochs_max
c        streamice_ctrl_flux_scaleVel(iarr,tarr) = 0. _d 0
c       ENDDO
c      ENDDO
c#endif

      STREAMICE_tave_mdsio = .TRUE.
      STREAMICE_dump_mdsio = .TRUE.
      STREAMICE_dump_mnc = .FALSE.
      STREAMICE_tave_mnc = .FALSE.
c      STREAMICE_GL_regularize = .FALSE.
      STREAMICE_move_front = .FALSE.
      STREAMICE_calve_to_mask = .FALSE.
c       STREAMICE_geom_file_setup = .FALSE.
c      STREAMICE_construct_matrix = .TRUE.
      STREAMICE_lower_cg_tol = .FALSE.
      STREAMICE_diagnostic_only = .FALSE.
#ifdef STREAMICE_FLOWLINE_BUTTRESS
      useStreamiceFlowlineButtr=.FALSE.
#endif
      STREAMICE_ppm_driving_stress = .FALSE.
      STREAMICE_chkfixedptconvergence = .true.
      STREAMICE_chkresidconvergence = .true.
      STREAMICE_alt_driving_stress = .FALSE.
      STREAMICE_allow_reg_coulomb = .FALSE.
      STREAMICE_h_ctrl_const_surf = .FALSE.
      STREAMICE_shelf_dhdt_ctrl = .FALSE.
      STREAMICE_allow_cpl = .false.
      STREAMICE_use_log_ctrl = .false.
      STREAMICE_vel_ext = .FALSE.
      STREAMICE_vel_ext_cgrid = .FALSE.
c       STREAMICE_hybrid_stress= .FALSE.

      STREAMICEvelOptimSnapBasename = ''
      STREAMICEvelOptimTCBasename = ''
      STREAMICEsurfOptimTCBasename = ''
      STREAMICEBglenCostMaskFile = ''
      streamice_wgt_drift = 0.
      streamice_wgt_tikh_beta = 0.
      streamice_wgt_vel_norm = 0.
      streamice_wgt_tikh_bglen = 0.
      streamice_wgt_tikh_gen = 0.
      streamice_wgt_prior_bglen = 0.
      streamice_wgt_prior_gen = 0.
      STREAMICE_do_snapshot_cost = .false.
      STREAMICE_do_timedep_cost = .false.
      STREAMICE_do_verification_cost = .false.
      STREAMICE_do_vaf_cost = .false.
#ifdef ALLOW_STREAMICE_TC_COST
      do iarr = 1, streamiceMaxCostLevel
       streamice_vel_cost_timesteps(iarr) = -1
       streamice_surf_cost_timesteps(iarr) = -1
      enddo
#endif

      min_x_noflow_NORTH = 0.
      max_x_noflow_NORTH = 0.
      min_x_noflow_SOUTH = 0.
      max_x_noflow_SOUTH = 0.
      min_y_noflow_WEST = 0.
      max_y_noflow_WEST = 0.
      min_y_noflow_EAST = 0.
      max_y_noflow_EAST = 0.
      min_x_noStress_NORTH = 0.
      max_x_noStress_NORTH = 0.
      min_x_noStress_SOUTH = 0.
      max_x_noStress_SOUTH = 0.
      min_y_noStress_WEST = 0.
      max_y_noStress_WEST = 0.
      min_y_noStress_EAST = 0.
      max_y_noStress_EAST = 0.
      min_x_FluxBdry_NORTH = 0.
      max_x_FluxBdry_NORTH = 0.
      min_x_FluxBdry_SOUTH = 0.
      max_x_FluxBdry_SOUTH = 0.
      min_y_FluxBdry_WEST = 0.
      max_y_FluxBdry_WEST = 0.
      min_y_FluxBdry_EAST = 0.
      max_y_FluxBdry_EAST = 0.
      min_x_Dirich_NORTH = 0.
      max_x_Dirich_NORTH = 0.
      min_x_Dirich_SOUTH = 0.
      max_x_Dirich_SOUTH = 0.
      min_y_Dirich_WEST = 0.
      max_y_Dirich_WEST = 0.
      min_y_Dirich_EAST = 0.
      max_y_Dirich_EAST = 0.
      min_y_CFBC_WEST = 0.
      max_y_CFBC_WEST = 0.
      min_y_CFBC_EAST = 0.
      max_y_CFBC_EAST = 0.
      flux_bdry_val_SOUTH = 0.
      flux_bdry_val_NORTH = 0.
      flux_bdry_val_WEST = 0.
      flux_bdry_val_EAST = 0.

      STREAMICE_NS_periodic = .FALSE.
      STREAMICE_EW_periodic = .FALSE.

      WRITE(msgBuf,'(A)') 'STREAMICE_READPARMS: opening data.streamice'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT , 1)
      CALL OPEN_COPY_DATA_FILE(
     I                     'data.streamice', 'STREAMICE_READPARMS',
     O                     iUnit,
     I                     myThid )

C     Read parameters from open data file
      READ(UNIT=iUnit,NML=STREAMICE_PARM01)
      WRITE(msgBuf,'(A)')
     &    'STREAMICE_READPARMS: read first param block'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &    SQUEEZE_RIGHT , 1)

      IF (TRIM(STREAMICEthickInit) .eq. "PARAM") THEN
       READ(UNIT=iUnit,NML=STREAMICE_PARM02)
        WRITE(msgBuf,'(A)')
     &    'STREAMICE_READPARMS: read second param block'
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &    SQUEEZE_RIGHT , 1)
      ENDIF

#ifdef ALLOW_STREAMICE_2DTRACER
      READ(UNIT=iUnit,NML=STREAMICE_PARMTRACER)
      WRITE(msgBuf,'(A)')
     &    'STREAMICE_READPARMS: read tracer param block'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &    SQUEEZE_RIGHT , 1)
#endif

#ifdef ALLOW_PETSC
      READ(UNIT=iUnit,NML=STREAMICE_PARMPETSC)
      WRITE(msgBuf,'(A)')
     &    'STREAMICE_READPARMS: read petsc param block'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &    SQUEEZE_RIGHT , 1)
#endif

#ifdef ALLOW_STREAMICE_FP_ADJ
      READ(UNIT=iUnit,NML=STREAMICE_PARMOAD)
      WRITE(msgBuf,'(A)')
     &    'STREAMICE_READPARMS: read oad parm block'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &    SQUEEZE_RIGHT , 1)
#endif

#if (defined (ALLOW_COST_STREAMICE))

      READ(UNIT=iUnit,NML=STREAMICE_COST)
      WRITE(msgBuf,'(A)')
     &    'STREAMICE_READPARMS: read cost param block'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &    SQUEEZE_RIGHT , 1)
#endif

#ifndef STREAMICE_GEOM_FILE_SETUP
      READ(UNIT=iUnit,NML=STREAMICE_PARM03)
      WRITE(msgBuf,'(A)')
     &    'STREAMICE_READPARMS: read bound condn block'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &    SQUEEZE_RIGHT , 1)
#endif
#ifdef SINGLE_DISK_IO
      CLOSE(iUnit)
#else
      CLOSE(iUnit,STATUS='DELETE')
#endif /* SINGLE_DISK_IO */

c#ifdef ALLOW_STREAMICE_FLUX_CONTROL
c
c      CALL OPEN_COPY_DATA_FILE(
c     I                     'data.strmctrlflux', 'STREAMICE_READPARMS',
c     O                     iUnit,
c     I                     myThid )
c
c      READ(UNIT=iUnit,NML=STREAMICE_PARMFLUXCTRL)
c      WRITE(msgBuf,'(A)')
c     &    'STREAMICE_READPARMS: read flux_ctrl param block'
c      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
c     &    SQUEEZE_RIGHT , 1)
c#ifdef SINGLE_DISK_IO
c      CLOSE(iUnit)
c#else
c      CLOSE(iUnit,STATUS='DELETE')
c#endif /* SINGLE_DISK_IO */
c#endif

      streamice_nstep_velocity = NINT (streamice_vel_update / deltaT)

C-    Set Output type flags :

#ifdef ALLOW_MNC
      IF (useMNC) THEN
        IF ( .NOT.outputTypesInclusive
     &       .AND. STREAMICE_tave_mnc ) STREAMICE_tave_mdsio = .FALSE.
        IF ( .NOT.outputTypesInclusive
     &       .AND. STREAMICE_dump_mnc ) STREAMICE_dump_mdsio = .FALSE.
      ENDIF
#endif

#ifdef ALLOW_PETSC
      IF (streamice_maxnliter_petsc.eq.-1) then
       streamice_maxnliter_petsc = streamice_max_nl_iter
      ENDIF
#endif

      _END_MASTER(myThid)

C--   Everyone else must wait for the parameters to be loaded
      _BARRIER

#endif /* ALLOW_STREAMICE */

      RETURN
      END

#include "DIC_OPTIONS.h"

CBOP
C !ROUTINE: DIC_FIELDS_UPDATE

C !INTERFACE: ==========================================================
      SUBROUTINE DIC_FIELDS_UPDATE(
     I                      bi, bj, myTime, myIter, myThid )

C !DESCRIPTION:
C     Update fields (needed for fluxterms or pH calculation)
C       with value imported from other pkgs or components

C !USES: ===============================================================
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "DIC_VARS.h"
#ifdef ALLOW_THSICE
# include "THSICE_VARS.h"
#endif
#ifdef ALLOW_SEAICE
# include "SEAICE_SIZE.h"
# include "SEAICE.h"
#endif
#ifdef ALLOW_OCN_COMPON_INTERF
# include "CPL_PARAMS.h"
# include "OCNCPL.h"
#endif /* ALLOW_OCN_COMPON_INTERF */

C !INPUT PARAMETERS: ===================================================
C     bi, bj       :: tile indices
C     myTime       :: Current time in simulation
C     myIter       :: Current timestep number
C     myThid       :: my Thread Id number
      INTEGER bi, bj
      _RL myTime
      INTEGER myIter
      INTEGER myThid

#ifdef ALLOW_DIC

c !LOCAL VARIABLES: ===================================================
#if defined(ALLOW_THSICE) || defined(ALLOW_SEAICE) || defined(COMPONENT_MODULE)
      INTEGER i, j
#endif
c     CHARACTER*(MAX_LEN_MBUF) msgBuf
CEOP

        IF ( useThSIce ) THEN
#ifdef ALLOW_THSICE
          DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
             fIce(i,j,bi,bj) = iceMask(i,j,bi,bj)
           ENDDO
          ENDDO
#endif /* ALLOW_THSICE */
        ELSEIF ( useSEAICE ) THEN
#ifdef ALLOW_SEAICE
          DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
             fIce(i,j,bi,bj) = AREA(i,j,bi,bj)
           ENDDO
          ENDDO
#endif /* ALLOW_SEAICE */
        ELSEIF ( useCoupler ) THEN
#ifdef ALLOW_OCN_COMPON_INTERF
         IF ( useImportFice ) THEN
           DO j=1-OLy,sNy+OLy
            DO i=1-OLx,sNx+OLx
             fIce(i,j,bi,bj) = sIceFrac_cpl(i,j,bi,bj)
            ENDDO
           ENDDO
         ENDIF
#endif /* ALLOW_OCN_COMPON_INTERF */
        ENDIF

#ifdef ALLOW_OCN_COMPON_INTERF
        IF ( useCoupler ) THEN
         IF ( useImportCO2 ) THEN
           DO j=1-OLy,sNy+OLy
            DO i=1-OLx,sNx+OLx
             AtmospCO2(i,j,bi,bj) = airCO2(i,j,bi,bj)
            ENDDO
           ENDDO
         ENDIF
         IF ( useImportWSpd ) THEN
           DO j=1-OLy,sNy+OLy
            DO i=1-OLx,sNx+OLx
             wind(i,j,bi,bj) = surfWSpeed(i,j,bi,bj)
            ENDDO
           ENDDO
         ENDIF
        ENDIF
#endif /* ALLOW_OCN_COMPON_INTERF */

#endif /* ALLOW_DIC */
      RETURN
      END

#include "THSICE_OPTIONS.h"

CBOP
C     !ROUTINE: THSICE_OUTPUT
C     !INTERFACE:
      SUBROUTINE THSICE_OUTPUT( myTime, myIter, myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R THSICE_OUTPUT
C     | o general routine for ThSIce output
C     *==========================================================*
C     | - write time-average & snap-shot output
C     | - call monitor to write global quantities
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "THSICE_PARAMS.h"
#include "THSICE_VARS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     myTime :: Current time of simulation ( s )
C     myIter :: Iteration number
C     myThid :: my Thread Id number
      _RL     myTime
      INTEGER myIter
      INTEGER myThid
CEOP

#ifdef ALLOW_THSICE

C     !FUNCTIONS:
      LOGICAL  DIFFERENT_MULTIPLE
      EXTERNAL DIFFERENT_MULTIPLE

C     !LOCAL VARIABLES:
      CHARACTER*(10) suff
#ifdef ALLOW_MNC
      INTEGER i
      CHARACTER*(MAX_LEN_MBUF) mncf
      CHARACTER*(1) pf
#endif

C     Dump a snap-shot of main state variables:
      IF (
     &     DIFFERENT_MULTIPLE( thSIce_diagFreq, myTime, deltaTClock )
     &  .OR. dumpInitAndLast.AND.( myTime.EQ.endTime .OR.
     &                             myTime.EQ.startTime  )
     &   ) THEN

        IF ( thSIce_snapshot_mdsio .AND.
     &       ( myTime.NE.startTime .OR. .NOT.thSIce_skipThermo
     &                             .OR. .NOT.useCoupler )
     &     ) THEN

          IF ( rwSuffixType.EQ.0 ) THEN
            WRITE(suff,'(I10.10)') myIter
          ELSE
            CALL RW_GET_SUFFIX( suff, myTime, myIter, myThid )
          ENDIF

          CALL WRITE_FLD_XY_RL('ice_fract.',  suff,iceMask,
     &         myIter,myThid)
          CALL WRITE_FLD_XY_RL('ice_iceH.',   suff,iceHeight,
     &         myIter,myThid)
          CALL WRITE_FLD_XY_RL('ice_snowH.',  suff,snowHeight,
     &         myIter,myThid)
          CALL WRITE_FLD_XY_RL('ice_Tsrf.',   suff,Tsrf,
     &         myIter,myThid)
          CALL WRITE_FLD_XY_RL('ice_Tice1.',  suff,Tice1,
     &         myIter,myThid)
          CALL WRITE_FLD_XY_RL('ice_Tice2.',  suff,Tice2,
     &         myIter,myThid)
          CALL WRITE_FLD_XY_RL('ice_Qice1.',  suff,Qice1,
     &         myIter,myThid)
          CALL WRITE_FLD_XY_RL('ice_Qice2.',  suff,Qice2,
     &         myIter,myThid)
          CALL WRITE_FLD_XY_RL('ice_snowAge.',suff,snowAge,
     &         myIter,myThid)
          IF ( myTime.NE.startTime ) THEN
            CALL WRITE_FLD_XY_RL('ice_flxAtm.',suff,icFlxAtm,
     &           myIter,myThid)
            CALL WRITE_FLD_XY_RL('ice_frwAtm.',suff,icFrwAtm,
     &           myIter,myThid)
          ENDIF
          IF ( stepFwd_oceMxL ) THEN
            CALL WRITE_FLD_XY_RL('ice_tOceMxL.', suff, tOceMxL,
     &           myIter,myThid)
            CALL WRITE_FLD_XY_RL('ice_sOceMxL.', suff, sOceMxL,
     &           myIter,myThid)
          ENDIF

        ENDIF

#ifdef ALLOW_MNC
        IF ( thSIce_snapshot_mnc ) THEN
          _BARRIER
          IF ( writeBinaryPrec .EQ. precFloat64 ) THEN
            pf(1:1) = 'D'
          ELSE
            pf(1:1) = 'R'
          ENDIF
          DO i = 1,MAX_LEN_MBUF
            mncf(i:i) = ' '
          ENDDO
C         C             123456789 12345
          mncf(1:15) = 'thsice_snapshot'
          CALL MNC_CW_SET_UDIM(mncf, -1, myThid)
          CALL MNC_CW_I_W_S('I',mncf,0,0,'iter', myIter, myThid)
          CALL MNC_CW_SET_UDIM(mncf, 0, myThid)
          CALL MNC_CW_RL_W_S('D',mncf,0,0,'T', myTime, myThid)
          CALL MNC_CW_RL_W(pf,mncf,0,0,'iceMask',   iceMask,   myThid)
          CALL MNC_CW_RL_W(pf,mncf,0,0,'iceHeight', iceHeight, myThid)
          CALL MNC_CW_RL_W(pf,mncf,0,0,'snowHeight',snowHeight,myThid)
          CALL MNC_CW_RL_W(pf,mncf,0,0,'Tsrf',      Tsrf,      myThid)
          CALL MNC_CW_RL_W(pf,mncf,0,0,'Tice1',     Tice1,     myThid)
          CALL MNC_CW_RL_W(pf,mncf,0,0,'Tice2',     Tice1,     myThid)
          CALL MNC_CW_RL_W(pf,mncf,0,0,'Qice1',     Qice1,     myThid)
          CALL MNC_CW_RL_W(pf,mncf,0,0,'Qice2',     Qice2,     myThid)
          CALL MNC_CW_RL_W(pf,mncf,0,0,'snowAge',   snowAge,   myThid)
          IF ( stepFwd_oceMxL ) THEN
            CALL MNC_CW_RL_W(pf,mncf,0,0,'tOceMxL',tOceMxL,myThid)
            CALL MNC_CW_RL_W(pf,mncf,0,0,'sOceMxL',sOceMxL,myThid)
          ENDIF
          _BARRIER
        ENDIF
#endif  /* ALLOW_MNC */

      ENDIF

      IF ( thSIce_monFreq.GT. 0. _d 0 )
     &    CALL THSICE_MONITOR( myTime, myIter, myThid )

#endif /* ALLOW_THSICE */

      RETURN
      END

#include "EXF_OPTIONS.h"

CBOP
C !ROUTINE: exf_GetYearlyFieldName

C !INTERFACE:
      SUBROUTINE exf_GetYearlyFieldName(
     I     useYearlyFields, twoDigitYear, genperiod, year, genfile,
     O     genfileout,
     I     myTime, myIter, myThid )

C     !DESCRIPTION:
C     ==================================================================
C     o Determine actual name of forcing file including year extension
C
C     started: Martin Losch  24-Jan-2008
C     ==================================================================

C     !USES:
      IMPLICIT NONE
C     == Global variables ===

C     !INPUT PARAMETERS:
      LOGICAL useYearlyFields
      LOGICAL twoDigitYear
      _RL     genperiod
      INTEGER year
      CHARACTER*(128) genfile
      _RL     myTime
      INTEGER myIter
      INTEGER myThid

C     !OUTPUT PARAMETERS:
      CHARACTER*(128) genfileout

#ifdef ALLOW_EXF
C     !FUNCTIONS:
      INTEGER  ILNBLNK
      EXTERNAL ILNBLNK

C     !LOCAL VARIABLES:
      INTEGER yearLoc
      INTEGER il
CEOP

      IF ( useYearlyFields .AND. genperiod.NE.-12 ) THEN
C     Complete filename with YR or _YEAR extension
       il = ILNBLNK( genfile )
       IF ( twoDigitYear) THEN
        yearLoc = year-1900
        IF ( year.GE.2000 ) yearLoc = year - 2000
        WRITE(genfileout(1:128),'(A,I2.2)') genfile(1:il), yearLoc
       ELSE
        WRITE(genfileout(1:128),'(2A,I4.4)') genfile(1:il), '_', year
       ENDIF
      ELSE
       genfileout = genfile
      ENDIF

#endif /* ALLOW_EXF */
      RETURN
      END

#include "BBL_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 0
C !ROUTINE: BBL_DIAGNOSTICS_INIT

C !INTERFACE:
      SUBROUTINE BBL_DIAGNOSTICS_INIT( myThid )

C     !DESCRIPTION:
C     Initialize list of all available diagnostics

C     !USES:
      IMPLICIT NONE
#include "EEPARAMS.h"
#include "SIZE.h"
#include "BBL.h"

C     !INPUT/OUTPUT PARAMETERS:
C     myThid ::  my Thread Id number
      INTEGER myThid
CEOP

#ifdef ALLOW_DIAGNOSTICS
C     !LOCAL VARIABLES:
C     === Local variables ===
C     diagNum   :: diagnostics number in the (long) list of available diag.
C     diagMate  :: diag. mate number in the (long) list of available diag.
C     diagName  :: local short name (8c) of a diagnostics
C     diagCode  :: local parser field with characteristics of the diagnostics
C              cf head of S/R DIAGNOSTICS_INIT_EARLY or DIAGNOSTICS_MAIN_INIT
C     diagUnits :: local string (16c): physical units of a diagnostic field
C     diagTitle :: local string (80c): description of field in diagnostic
      INTEGER       diagNum
c     INTEGER       diagMate
      CHARACTER*8   diagName
      CHARACTER*16  diagCode
      CHARACTER*16  diagUnits
      CHARACTER*(80) diagTitle

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

        diagName  = 'BBLtheta'
        diagTitle = 'Bottom boundary layer theta'
        diagUnits = 'degC            '
        diagCode  = 'SM      M1      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

        diagName  = 'BBLsalt '
        diagTitle = 'Bottom boundary layer salinity'
        diagUnits = 'g/kg            '
        diagCode  = 'SM      M1      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

        diagName  = 'BBLeta  '
        diagTitle = 'Bottom boundary layer thickness'
        diagUnits = 'm               '
        diagCode  = 'SM      M1      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

        diagName  = 'BBLtendT'
        diagTitle = 'Bottom temperature tendency due to BBL'
        diagUnits = 'degC/s          '
        diagCode  = 'SM      M1      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

        diagName  = 'BBLtendS'
        diagTitle = 'Bottom salt tendency due to BBL'
        diagUnits = 'g/kg/s          '
        diagCode  = 'SM      M1      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

#endif /* ALLOW_DIAGNOSTICS */

      RETURN
      END

#include "ADMTLM_OPTIONS.h"

CBOP

C     !ROUTINE: ADMTLM_DRIVER

C     !INTERFACE:
      SUBROUTINE ADMTLM_DRIVER( myThid )
      IMPLICIT NONE

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE ADMTLM_DRIVER
C     | o Master controlling routine for model using the MITgcm
C     |   UV parallel wrapper.
C     *==========================================================*
C     \ev

C     !USES:
C     == Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "DYNVARS.h"

#ifdef ALLOW_ADMTLM
# ifdef ALLOW_AUTODIFF_TAMC
#  include "tamc.h"
# endif
# include "CTRL.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
      INTEGER myThid

C     == Local ==
      INTEGER myCurrentIter
      _RL     myCurrentTime
C
CEOP

#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_ENTER('ADMTLM_DRIVER',myThid)
#endif

#if ( defined (ALLOW_ADMTLM) )

      myCurrentTime = startTime
      myCurrentIter = nIter0
      yadprefix = 'g_'

      CALL CTRL_INIT( mythid )
c
      CALL TIMER_START('ADMTLM_DRIVER             [TANGENT RUN]',mythid)
      CALL G_THE_MAIN_LOOP ( myCurrentTime, myCurrentIter, myThid )
      CALL TIMER_STOP ('ADMTLM_DRIVER             [TANGENT RUN]',mythid)
c
      myCurrentTime = startTime
      myCurrentIter = nIter0
      yadprefix = 'ad'
c
      CALL CTRL_INIT( mythid )
c
      if ( doAdmtlmBypassAD ) then
c
#ifdef ALLOW_BYPASSAD
         CALL TIMER_START('ADMTLM_DRIVER             [BYPASSAD]',mythid)
         CALL ADMTLM_BYPASSAD( mythid )
         CALL TIMER_STOP ('ADMTLM_DRIVER             [BYPASSAD]',mythid)
#endif
c
      else
c
         CALL ADMTLM_METRIC ( mythid )
         CALL ADMTLM_MAP ( mythid )
c
         CALL TIMER_START('ADMTLM_DRIVER          [ADJOINT RUN]',mythid)
         CALL ADTHE_MAIN_LOOP (  myCurrentTime, myCurrentIter, mythid )
         CALL TIMER_STOP ('ADMTLM_DRIVER          [ADJOINT RUN]',mythid)
c
      endif
c
#endif

#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_LEAVE('ADMTLM_DRIVER',myThid)
#endif

      RETURN
      END

#include "DIC_OPTIONS.h"

CBOP
C !ROUTINE: DIC_WRITE_PICKUP

C !INTERFACE: ==========================================================
      SUBROUTINE DIC_WRITE_PICKUP( permPickup,
     I                             suff, myTime, myIter, myThid )

C !DESCRIPTION:
C     Writes DIC arrays (needed for a restart) to a pickup file

C !USES: ===============================================================
      IMPLICIT NONE
C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "DIC_VARS.h"
#include "DIC_ATMOS.h"

C !INPUT PARAMETERS: ===================================================
C     permPickup :: write a permanent pickup
C     suff       :: suffix for pickup file (eg. ckptA or 0000000010)
C     myTime     :: Current time in simulation
C     myIter     :: Current iteration number in simulation
C     myThid     :: My Thread Id number
      LOGICAL permPickup
      CHARACTER*(*) suff
      _RL     myTime
      INTEGER myIter
      INTEGER myThid
CEOP

#ifdef ALLOW_DIC

C     !LOCAL VARIABLES:
C     == Local variables ==
      CHARACTER*(MAX_LEN_FNAM) fn
      INTEGER prec
      INTEGER ioUnit
      _RL tmpFld(2)
      _RS dummyRS(1)
#ifdef DIC_BIOTIC
      LOGICAL glf
      _RL     timList(1)
      INTEGER j, nj
      INTEGER listDim, nWrFlds
      PARAMETER( listDim = 2 )
      CHARACTER*(8) wrFldList(listDim)
      CHARACTER*(MAX_LEN_MBUF) msgBuf
#endif

c     IF ( DIC_pickup_write_mdsio ) THEN
        prec = precFloat64

        IF ( dic_int1.EQ.3 ) THEN
          WRITE(fn,'(A,A)') 'pickup_dic_co2atm.',suff
          ioUnit = 0
#ifdef ALLOW_OPENAD
          tmpFld(1) = total_atmos_carbon%v
          tmpFld(2) = atpco2%v
#else /* ALLOW_OPENAD */
          tmpFld(1) = total_atmos_carbon
          tmpFld(2) = atpco2
#endif /* ALLOW_OPENAD */
#ifdef ALLOW_MDSIO
          CALL MDS_WRITEVEC_LOC(
     I                         fn, prec, ioUnit,
     I                         'RL', 2, tmpFld, dummyRS,
     I                         0, 0, 1, myIter, myThid )
#endif
        ENDIF

#ifdef DIC_BIOTIC
        WRITE(fn,'(A,A)') 'pickup_dic.',suff
        j = 0

C--   write DIC 3-D fields for restart
#ifdef DIC_CALCITE_SAT
        IF ( useCalciteSaturation ) THEN
         j = j + 1
C       record number < 0 : a hack not to write meta files now:
         CALL WRITE_REC_3D_RL( fn, prec, Nr, pH3D, -j, myIter, myThid )
         IF (j.LE.listDim) wrFldList(j) = 'DIC_pH3d'
        ENDIF
#endif

C-    switch to 2-D fields:
        nj = -j*Nr

C--   write DIC 2-D fields for restart
        j = j + 1
        nj = nj-1
        CALL WRITE_REC_3D_RL( fn, prec, 1, pH, nj, myIter, myThid )
        IF (j.LE.listDim) wrFldList(j) = 'DIC_pH2d'

C--------------------------
        nWrFlds = j
        IF ( nWrFlds.GT.listDim ) THEN
          WRITE(msgBuf,'(2A,I5,A)') 'DIC_WRITE_PICKUP: ',
     &     'trying to write ',nWrFlds,' fields'
          CALL PRINT_ERROR( msgBuf, myThid )
          WRITE(msgBuf,'(2A,I5,A)') 'DIC_WRITE_PICKUP: ',
     &     'field-list dimension (listDim=',listDim,') too small'
          CALL PRINT_ERROR( msgBuf, myThid )
          STOP 'ABNORMAL END: S/R DIC_WRITE_PICKUP (list-size Pb)'
        ENDIF

#ifdef ALLOW_MDSIO
C     uses this specific S/R to write (with more informations) only meta
C     files
        j  = 1
        nj = ABS(nj)
        IF ( nWrFlds*Nr .EQ. nj ) THEN
          j  = Nr
          nj = nWrFlds
        ENDIF
        glf  = globalFiles
        timList(1) = myTime
        CALL MDS_WR_METAFILES( fn, prec, glf, .FALSE.,
     &                         0, 0, j, ' ',
     &                         nWrFlds, wrFldList,
     &                         1, timList, oneRL,
     &                         nj, myIter, myThid )
#endif /* ALLOW_MDSIO */
C--------------------------

#endif /* DIC_BIOTIC  */

c     ENDIF /* DIC_pickup_write_mdsio */

#endif /* ALLOW_DIC  */

      RETURN
      END

#include "MONITOR_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: MON_VORT3

C     !INTERFACE:
      SUBROUTINE MON_VORT3(
     I     myIter, myThid )

C     !DESCRIPTION:
C     Calculates stats for Vorticity (z-component).

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "DYNVARS.h"
#include "MONITOR.h"
#include "GRID.h"
#ifdef ALLOW_EXCH2
#include "W2_EXCH2_SIZE.h"
#include "W2_EXCH2_TOPOLOGY.h"
#endif /* ALLOW_EXCH2 */

C     !INPUT PARAMETERS:
      INTEGER myIter, myThid
CEOP

C     !LOCAL VARIABLES:
      INTEGER bi,bj,i,j,k
      INTEGER iMax,jMax
      _RL theVol, theArea, tmpVal, tmpAre, tmpVol
      _RL theMin, theMax, theMean, theVar, volMean, volVar, theSD
c     _RL areaTile, volTile, sumTile, sqsTile, vSumTile, vSqsTile
      _RL tileArea(nSx,nSy)
      _RL tileVol (nSx,nSy)
      _RL tileSum (nSx,nSy)
      _RL tileVar (nSx,nSy)
      _RL tileVSum(nSx,nSy)
      _RL tileVSq (nSx,nSy)
      _RL vort3(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RS hFacZ(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL AZcorner
#ifdef MONITOR_TEST_HFACZ
      _RL tmpFac
      _RL etaFld(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
#endif
      LOGICAL northWestCorner, northEastCorner
      LOGICAL southWestCorner, southEastCorner
      INTEGER iG
#ifdef ALLOW_EXCH2
      INTEGER myTile
#endif

      theMin = 1. _d 20
      theMax =-1. _d 20
      theArea= 0. _d 0
      theMean= 0. _d 0
      theVar = 0. _d 0
      theVol = 0. _d 0
      volMean= 0. _d 0
      volVar = 0. _d 0
      theSD  = 0. _d 0
      AZcorner = 1. _d 0

      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
         tileArea(bi,bj)= 0. _d 0
         tileVol(bi,bj) = 0. _d 0
         tileSum(bi,bj) = 0. _d 0
         tileVar(bi,bj) = 0. _d 0
         tileVSum(bi,bj)= 0. _d 0
         tileVSq(bi,bj) = 0. _d 0
#ifdef MONITOR_TEST_HFACZ
         tmpFac = 0.
         IF( implicDiv2Dflow.GT.0 .AND. abEps.GT.-0.5 )
     &    tmpFac = (0.5+abEps) / implicDiv2Dflow
         DO j=1-Oly,sNy+Oly
          DO i=1-Olx,sNx+Olx
            etaFld(i,j) = etaH(i,j,bi,bj)
     &          + tmpFac*(etaN(i,j,bi,bj)-etaH(i,j,bi,bj))
          ENDDO
         ENDDO
#endif
        DO k=1,Nr

         iMax = sNx
         jMax = sNy
         DO j=1,sNy
          DO i=1,sNx
#ifdef MONITOR_TEST_HFACZ
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C-    Test various definitions of hFacZ (for 1 layer, flat bottom ocean):
c          hFacZ(i,j) = 1. +
c    &           0.25 _d 0*( etaFld(i-1,j-1)
c    &                     + etaFld( i ,j-1)
c    &                     + etaFld(i-1, j )
c    &                     + etaFld( i , j )
c    &                     )*recip_drF(k)
c          hFacZ(i,j) = 1. +
c    &           0.25 _d 0*( etaFld(i-1,j-1)*rA(i-1,j-1,bi,bj)
c    &                     + etaFld( i ,j-1)*rA( i ,j-1,bi,bj)
c    &                     + etaFld(i-1, j )*rA(i-1, j ,bi,bj)
c    &                     + etaFld( i , j )*rA( i , j ,bi,bj)
c    &                     )*recip_drF(k)*recip_rAz(i,j,bi,bj)
           hFacZ(i,j) = 1. + 0.125 _d 0*
     &                   ( ( etaFld(i-1,j-1)*rA(i-1,j-1,bi,bj)
     &                      +etaFld( i ,j-1)*rA( i ,j-1,bi,bj)
     &                     )*recip_rAw(i,j-1,bi,bj)
     &                   + ( etaFld(i-1, j )*rA(i-1, j ,bi,bj)
     &                      +etaFld( i , j )*rA( i , j ,bi,bj)
     &                     )*recip_rAw(i, j ,bi,bj)
     &                   + ( etaFld(i-1,j-1)*rA(i-1,j-1,bi,bj)
     &                      +etaFld(i-1, j )*rA(i-1, j ,bi,bj)
     &                     )*recip_rAs(i-1,j,bi,bj)
     &                   + ( etaFld( i ,j-1)*rA( i ,j-1,bi,bj)
     &                     + etaFld( i , j )*rA( i , j ,bi,bj)
     &                     )*recip_rAs( i ,j,bi,bj)
     &                   )*recip_drF(k)
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
#else
C-    Standard definition of hFac at vorticity point:
           hFacZ(i,j) =
     &           0.25 _d 0*( _hFacW(i,j-1,k,bi,bj)
     &                     + _hFacW(i, j ,k,bi,bj)
     &                     + _hFacS(i-1,j,k,bi,bj)
     &                     + _hFacS( i ,j,k,bi,bj)
     &                     )
#endif /* MONITOR_TEST_HFACZ */
           vort3(i,j) = recip_rAz(i,j,bi,bj)*(
     &       vVel( i ,j,k,bi,bj)*dyC( i ,j,bi,bj)
     &      -vVel(i-1,j,k,bi,bj)*dyC(i-1,j,bi,bj)
     &      -uVel(i, j ,k,bi,bj)*dxC(i, j ,bi,bj)
     &      +uVel(i,j-1,k,bi,bj)*dxC(i,j-1,bi,bj)
     &                                       )
          ENDDO
         ENDDO

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C     Special stuff for Cubed Sphere:
         IF (useCubedSphereExchange) THEN
c          AZcorner = 0.75 _d 0
           iMax = sNx+1
           jMax = sNy+1
           DO i=1,iMax
            hFacZ(i,jMax)=0.
            vort3(i,jMax)=0.
           ENDDO
           DO j=1,jMax
            hFacZ(iMax,j)=0.
            vort3(iMax,j)=0.
           ENDDO

           southWestCorner = .TRUE.
           southEastCorner = .TRUE.
           northWestCorner = .TRUE.
           northEastCorner = .TRUE.
           iG = bi+(myXGlobalLo-1)/sNx
#ifdef ALLOW_EXCH2
           myTile = W2_myTileList(bi,bj)
           iG = exch2_myFace(myTile)
           southWestCorner = exch2_isWedge(myTile).EQ.1
     &                 .AND. exch2_isSedge(myTile).EQ.1
           southEastCorner = exch2_isEedge(myTile).EQ.1
     &                 .AND. exch2_isSedge(myTile).EQ.1
           northEastCorner = exch2_isEedge(myTile).EQ.1
     &                 .AND. exch2_isNedge(myTile).EQ.1
           northWestCorner = exch2_isWedge(myTile).EQ.1
     &                 .AND. exch2_isNedge(myTile).EQ.1
#endif /* ALLOW_EXCH2 */

C--        avoid to count 3 times the same corner:
           southEastCorner = southEastCorner .AND. iG.EQ.2
           northWestCorner = northWestCorner .AND. iG.EQ.1
           northEastCorner = .FALSE.

C--       S.W. corner:
          IF ( southWestCorner ) THEN
           i=1
           j=1
           vort3(i,j)=
     &       +recip_rAz(i,j,bi,bj)/AZcorner*(
     &        vVel(i,j,k,bi,bj)*dyC(i,j,bi,bj)
     &       -uVel(i,j,k,bi,bj)*dxC(i,j,bi,bj)
     &       +uVel(i,j-1,k,bi,bj)*dxC(i,j-1,bi,bj)
     &       )
           hFacZ(i,j) = ( _hFacW(i,j-1,k,bi,bj)
     &                  + _hFacW(i, j ,k,bi,bj)
     &                  + _hFacS( i ,j,k,bi,bj)
     &                  )/3. _d 0
          ENDIF
          IF ( southEastCorner ) THEN
C--        S.E. corner:
           i=iMax
           j=1
           vort3(i,j)=
     &       +recip_rAz(i,j,bi,bj)/AZcorner*(
     &       -vVel(i-1,j,k,bi,bj)*dyC(i-1,j,bi,bj)
     &       -uVel(i,j,k,bi,bj)*dxC(i,j,bi,bj)
     &       +uVel(i,j-1,k,bi,bj)*dxC(i,j-1,bi,bj)
     &       )
           hFacZ(i,j) = ( _hFacW(i,j-1,k,bi,bj)
     &                  + _hFacW(i, j ,k,bi,bj)
     &                  + _hFacS(i-1,j,k,bi,bj)
     &                  )/3. _d 0
          ENDIF
          IF ( northWestCorner ) THEN
C--        N.W. corner:
           i=1
           j=jMax
           vort3(i,j)=
     &       +recip_rAz(i,j,bi,bj)/AZcorner*(
     &        vVel(i,j,k,bi,bj)*dyC(i,j,bi,bj)
     &       -uVel(i,j,k,bi,bj)*dxC(i,j,bi,bj)
     &       +uVel(i,j-1,k,bi,bj)*dxC(i,j-1,bi,bj)
     &       )
           hFacZ(i,j) = ( _hFacW(i,j-1,k,bi,bj)
     &                  + _hFacW(i, j ,k,bi,bj)
     &                  + _hFacS( i ,j,k,bi,bj)
     &                  )/3. _d 0
          ENDIF
          IF ( northEastCorner ) THEN
C--        N.E. corner:
           i=iMax
           j=jMax
           vort3(i,j)=
     &       +recip_rAz(i,j,bi,bj)/AZcorner*(
     &       -vVel(i-1,j,k,bi,bj)*dyC(i-1,j,bi,bj)
     &       -uVel(i,j,k,bi,bj)*dxC(i,j,bi,bj)
     &       +uVel(i,j-1,k,bi,bj)*dxC(i,j-1,bi,bj)
     &       )
           hFacZ(i,j) = ( _hFacW(i,j-1,k,bi,bj)
     &                  + _hFacW(i, j ,k,bi,bj)
     &                  + _hFacS(i-1,j,k,bi,bj)
     &                  )/3. _d 0
          ENDIF
         ENDIF

C-    Special stuff for North & South Poles, LatLon grid
         IF ( usingSphericalPolarGrid ) THEN
          IF (yG(1,sNy+1,bi,bj).EQ.90.) THEN
           jMax = sNy+1
           j = jMax
           DO i=1,sNx
            vort3(i,j) = 0.
            vort3(1,j) = vort3(1,j)
     &                 + uVel(i,j-1,k,bi,bj)*dxC(i,j-1,bi,bj)
            hFacZ(i,j) = 0.
#ifndef MONITOR_TEST_HFACZ
            hFacZ(1,j) = hFacZ(1,j) + _hFacW(i,j-1,k,bi,bj)
           ENDDO
#else
            hFacZ(1,j) = hFacZ(1,j) + etaFld(i,j-1)
           ENDDO
            hFacZ(1,j) = sNx + hFacZ(1,j)*recip_drF(k)
#endif
            hFacZ(1,j) = hFacZ(1,j) / FLOAT(sNx)
            vort3(1,j) = vort3(1,j)*recip_rAz(1,j,bi,bj)
          ENDIF
          IF (yG(1,1,bi,bj).EQ.-90.) THEN
           j = 1
           DO i=1,sNx
            vort3(i,j) = 0.
            vort3(1,j) = vort3(1,j)
     &                 - uVel(i,j,k,bi,bj)*dxC(i,j,bi,bj)
            hFacZ(i,j) = 0.
#ifndef MONITOR_TEST_HFACZ
            hFacZ(1,j) = hFacZ(1,j) + _hFacW(i,j,k,bi,bj)
           ENDDO
#else
            hFacZ(1,j) = hFacZ(1,j) + etaFld(i,j)
           ENDDO
            hFacZ(1,j) = sNx + hFacZ(1,j)*recip_drF(k)
#endif
            hFacZ(1,j) = hFacZ(1,j) / FLOAT(sNx)
            vort3(1,j) = vort3(1,j)*recip_rAz(1,j,bi,bj)
          ENDIF
         ENDIF

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

         DO j=1,jMax
          DO i=1,iMax
           IF (hFacZ(i,j).GT.0. _d 0) THEN
            tmpVal = vort3(i,j)
            tmpAre = rAz(i,j,bi,bj)*drF(k)
            tmpVol = rAz(i,j,bi,bj)*drF(k)*hFacZ(i,j)
            tileArea(bi,bj)  = tileArea(bi,bj)  + tmpAre
C-       min,max of relative vorticity ("r")
            theMin = MIN(theMin,tmpVal)
            theMax = MAX(theMax,tmpVal)
C-       average & std.dev of absolute vorticity ("a")
            tmpVal = tmpVal + fCoriG(i,j,bi,bj)
            tileSum(bi,bj) = tileSum(bi,bj) + tmpAre*tmpVal
            tileVar(bi,bj) = tileVar(bi,bj) + tmpAre*tmpVal*tmpVal
C-       average & std.dev of potential vorticity ("p")
            tmpVal = tmpVal / hFacZ(i,j)
            tileVol(bi,bj) = tileVol(bi,bj) + tmpVol
            tileVSum(bi,bj)= tileVSum(bi,bj)+ tmpVol*tmpVal
            tileVSq(bi,bj) = tileVSq(bi,bj) + tmpVol*tmpVal*tmpVal
           ENDIF
          ENDDO
         ENDDO

        ENDDO
c       theArea= theArea + tileArea(bi,bj)
c       theVol = theVol  + tileVol (bi,bj)
c       theMean= theMean + tileSum(bi,bj)
c       theVar = theVar  + tileVar(bi,bj)
c       volMean= volMean + tileVSum(bi,bj)
c       volVar = volVar  + tileVSq(bi,bj)
       ENDDO
      ENDDO

      theMin = -theMin
      _GLOBAL_MAX_RL(theMin, myThid)
      _GLOBAL_MAX_RL(theMax, myThid)
      theMin = -theMin
c     _GLOBAL_SUM_RL(theArea,myThid)
c     _GLOBAL_SUM_RL(theVol, myThid)
c     _GLOBAL_SUM_RL(theMean,myThid)
c     _GLOBAL_SUM_RL(theVar, myThid)
c     _GLOBAL_SUM_RL(volMean,myThid)
c     _GLOBAL_SUM_RL(volVar ,myThid)
      CALL GLOBAL_SUM_TILE_RL( tileArea, theArea, myThid )
      CALL GLOBAL_SUM_TILE_RL( tileVol,  theVol,  myThid )
      CALL GLOBAL_SUM_TILE_RL( tileSum,  theMean, myThid )
      CALL GLOBAL_SUM_TILE_RL( tileVar,  theVar,  myThid )
      CALL GLOBAL_SUM_TILE_RL( tileVSum, volMean, myThid )
      CALL GLOBAL_SUM_TILE_RL( tileVSq,  volVar,  myThid )
      IF (theArea.GT.0.) THEN
        theMean= theMean/theArea
        theVar = theVar /theArea
        theVar = theVar - theMean*theMean
c       IF (theVar.GT.0.) theSD = SQRT(theVar)
        IF (theVar.GT.0.) theVar = SQRT(theVar)
      ENDIF
      IF (theVol.GT.0.) THEN
        volMean= volMean/theVol
        volVar = volVar /theVol
        volVar = volVar - volMean*volMean
        IF (volVar.GT.0.) theSD = SQRT(volVar)
      ENDIF

C-    Print stats for (relative/absolute) Vorticity AND Pot.Vort.
      CALL MON_SET_PREF('vort',myThid)
      CALL MON_OUT_RL(mon_string_none,theMin, '_r_min',  myThid)
      CALL MON_OUT_RL(mon_string_none,theMax, '_r_max',  myThid)
      CALL MON_OUT_RL(mon_string_none,theMean,'_a_mean', myThid)
      CALL MON_OUT_RL(mon_string_none,theVar, '_a_sd',   myThid)
      CALL MON_OUT_RL(mon_string_none,volMean,'_p_mean', myThid)
      CALL MON_OUT_RL(mon_string_none,theSD,  '_p_sd',   myThid)
c     CALL MON_OUT_RL(mon_string_none,theVol,mon_foot_vol,myThid)

      RETURN
      END

#include "PACKAGES_CONFIG.h"
#include "CPP_OPTIONS.h"

CBOP
C     !ROUTINE: INI_FORCING
C     !INTERFACE:
      SUBROUTINE INI_FORCING( myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE INI_FORCING
C     | o Set model initial forcing fields.
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "SURFACE.h"
#include "FFIELDS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     myThid :: my Thread Id number
      INTEGER myThid

C     !LOCAL VARIABLES:
C     == Local variables ==
C     bi,bj  :: Tile indices
C     i, j   :: Loop counters
      INTEGER bi, bj
      INTEGER  i, j
#ifdef SHORTWAVE_HEATING
      INTEGER  k, km
      _RL SWFracK(Nr+1), swfac
#endif
CEOP

C-    Initialise all arrays in common blocks
C     <-- moved to new S/R INI_FFIELDS

      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          IF ( doThetaClimRelax .AND.
     &         ABS(yC(i,j,bi,bj)).LE.latBandClimRelax ) THEN
           lambdaThetaClimRelax(i,j,bi,bj) = 1. _d 0/tauThetaClimRelax
          ELSE
           lambdaThetaClimRelax(i,j,bi,bj) = 0. _d 0
          ENDIF
          IF ( doSaltClimRelax .AND.
     &         ABS(yC(i,j,bi,bj)).LE.latBandClimRelax ) THEN
           lambdaSaltClimRelax(i,j,bi,bj) = 1. _d 0/tauSaltClimRelax
          ELSE
           lambdaSaltClimRelax(i,j,bi,bj) = 0. _d 0
          ENDIF
         ENDDO
        ENDDO
       ENDDO
      ENDDO

C-    every-one waits before master thread loads from file
C     this is done within IO routines => no longer needed
c     _BARRIER

      IF ( zonalWindFile .NE. ' '  ) THEN
       CALL READ_FLD_XY_RS( zonalWindFile, ' ', fu, 0, myThid )
      ENDIF
      IF ( meridWindFile .NE. ' '  ) THEN
       CALL READ_FLD_XY_RS( meridWindFile, ' ', fv, 0, myThid )
      ENDIF
      IF ( surfQFile .NE. ' '  ) THEN
       CALL READ_FLD_XY_RS( surfQFile, ' ', Qnet, 0, myThid )
      ELSEIF ( surfQnetFile .NE. ' '  ) THEN
       CALL READ_FLD_XY_RS( surfQnetFile, ' ', Qnet, 0, myThid )
      ENDIF
      IF ( EmPmRfile .NE. ' '  ) THEN
       CALL READ_FLD_XY_RS( EmPmRfile, ' ', EmPmR, 0, myThid )
c      IF ( convertEmP2rUnit.EQ.mass2rUnit ) THEN
C-     EmPmR is now (after c59h) expressed in kg/m2/s (fresh water mass flux)
        DO bj = myByLo(myThid), myByHi(myThid)
         DO bi = myBxLo(myThid), myBxHi(myThid)
          DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
            EmPmR(i,j,bi,bj) = EmPmR(i,j,bi,bj)*rhoConstFresh
           ENDDO
          ENDDO
         ENDDO
        ENDDO
c      ENDIF
      ENDIF
      IF ( saltFluxFile .NE. ' '  ) THEN
       CALL READ_FLD_XY_RS( saltFluxFile, ' ', saltFlux, 0, myThid )
      ENDIF
      IF ( thetaClimFile .NE. ' '  ) THEN
       CALL READ_FLD_XY_RS( thetaClimFile, ' ', SST, 0, myThid )
      ENDIF
      IF ( saltClimFile .NE. ' '  ) THEN
       CALL READ_FLD_XY_RS( saltClimFile, ' ', SSS, 0, myThid )
      ENDIF
      IF ( lambdaThetaFile .NE. ' '  ) THEN
       CALL READ_FLD_XY_RS( lambdaThetaFile, ' ',
     &  lambdaThetaClimRelax, 0, myThid )
      ENDIF
      IF ( lambdaSaltFile .NE. ' '  ) THEN
       CALL READ_FLD_XY_RS( lambdaSaltFile, ' ',
     &  lambdaSaltClimRelax, 0, myThid )
      ENDIF
#ifdef SHORTWAVE_HEATING
      IF ( surfQswFile .NE. ' ' ) THEN
       CALL READ_FLD_XY_RS( surfQswFile, ' ', Qsw, 0, myThid )
       IF ( surfQFile .NE. ' '  ) THEN
C-     Qnet is now (after c54) the net Heat Flux (including SW)
        DO bj = myByLo(myThid), myByHi(myThid)
         DO bi = myBxLo(myThid), myBxHi(myThid)
          DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
            Qnet(i,j,bi,bj) = Qnet(i,j,bi,bj) + Qsw(i,j,bi,bj)
           ENDDO
          ENDDO
         ENDDO
        ENDDO
       ENDIF
      ENDIF
C--   initialisation for the case of no shortwave penetration
C--   (shortwave radiation only heats the top layer)
      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
        DO k = 1,Nr+1
         swfac = 0. _d 0
         IF ( usingZCoords ) THEN
          IF ( k .EQ. 1 ) swfac = 1. _d 0
         ELSE
          IF ( k .EQ. Nr+1 ) swfac = 1. _d 0
         ENDIF
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           SWFrac3D(i,j,k,bi,bj) = swfac
          ENDDO
         ENDDO
        ENDDO
       ENDDO
      ENDDO
      IF ( selectPenetratingSW .GT. 0 ) THEN
C     For now SWFrac3D is held fixed throughout the simulation, so it is
C     initialised here instead of somewhere in S/R INITIALISE_VARIA
       DO k=1,Nr+1
        IF ( usingZCoords ) THEN
         SWFracK(k) = rF(k) - rF(1)
        ELSE
C     this is the oceanic pressure coordinate case
         SWFracK(k) = ( rF(Nr+1) - rF(k) )
     &              * recip_rhoConst*recip_gravity
C     valid also with Mass-Coordinate (but not with variable gravity):
c        SWFracK(k) = ( phiRef(2*k-1) - phiRef(2*Nr+1) )*recip_gravity
        ENDIF
       ENDDO
       CALL SWFRAC(
     I             Nr+1, oneRL,
     U             SWFracK,
     I             zeroRL, 0, myThid )
       DO bj = myByLo(myThid), myByHi(myThid)
        DO bi = myBxLo(myThid), myBxHi(myThid)
         DO k = 1,Nr+1
          swfac = 1. _d 0
C     Here, km is the index for the mask physically below the interface k.
          IF ( usingZCoords ) THEN
           km = MIN(k,Nr)
           IF ( k .EQ. Nr+1 ) swfac = 0. _d 0
          ELSE
           km = MAX(k-1,1)
           IF ( k .EQ. 1 ) swfac = 0. _d 0
          ENDIF
          DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
            SWFrac3D(i,j,k,bi,bj) = SWFracK(k)*swfac
     &           *maskC(i,j,km,bi,bj)
           ENDDO
          ENDDO
         ENDDO
        ENDDO
       ENDDO
C     endif selectPenetratingSW
      ENDIF
#endif /* SHORTWAVE_HEATING */
#ifdef ATMOSPHERIC_LOADING
      IF ( pLoadFile .NE. ' '  ) THEN
       CALL READ_FLD_XY_RS( pLoadFile, ' ', pLoad, 0, myThid )
      ENDIF
#endif /* ATMOSPHERIC_LOADING */
#ifdef ALLOW_ADDFLUID
      IF ( addMassFile .NE. ' ' ) THEN
       CALL READ_FLD_XYZ_RL( addMassFile, ' ', addMass, 0, myThid )
       CALL EXCH_XYZ_RL( addMass, myThid )
      ENDIF
#endif /* ALLOW_ADDFLUID */
#ifdef ALLOW_GEOTHERMAL_FLUX
      IF ( geothermalFile .NE. ' ' ) THEN
       CALL READ_FLD_XY_RS( geothermalFile, ' ',
     &  geothermalFlux, 0, myThid )
       CALL EXCH_XY_RS( geothermalFlux, myThid )
# ifdef ALLOW_MONITOR
       CALL MON_PRINTSTATS_RS(
     &  1,geothermalFlux,'geothermalFlux',myThid)
# endif
      ENDIF
#endif /* ALLOW_GEOTHERMAL_FLUX */
#ifdef ALLOW_BALANCE_FLUXES
      IF ( selectBalanceEmPmR.EQ.2 ) THEN
C-    set default weight to 1 (i.e., same correction as selectBalanceEmPmR=1 )
       DO bj = myByLo(myThid), myByHi(myThid)
        DO bi = myBxLo(myThid), myBxHi(myThid)
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
            weight2BalanceFlx(i,j,bi,bj) = oneRS
          ENDDO
         ENDDO
        ENDDO
       ENDDO
      ENDIF
      IF ( wghtBalanceFile .NE. ' ' ) THEN
       CALL READ_FLD_XY_RS( wghtBalanceFile, ' ',
     &                      weight2BalanceFlx, 0, myThid )
       CALL EXCH_XY_RS( weight2BalanceFlx, myThid )
      ENDIF
#endif /* ALLOW_GEOTHERMAL_FLUX */

      CALL EXCH_UV_XY_RS( fu,fv, .TRUE., myThid )
      CALL EXCH_XY_RS( Qnet , myThid )
      CALL EXCH_XY_RS( EmPmR, myThid )
      CALL EXCH_XY_RS( saltFlux, myThid )
      CALL EXCH_XY_RS( SST  , myThid )
      CALL EXCH_XY_RS( SSS  , myThid )
      CALL EXCH_XY_RS( lambdaThetaClimRelax, myThid )
      CALL EXCH_XY_RS( lambdaSaltClimRelax , myThid )
#ifdef SHORTWAVE_HEATING
      IF ( surfQswFile .NE. ' ' )
     &     CALL EXCH_XY_RS( Qsw  , myThid )
#endif
#ifdef ATMOSPHERIC_LOADING
      CALL EXCH_XY_RS( pLoad  , myThid )
C     CALL PLOT_FIELD_XYRS( pLoad, 'S/R INI_FORCING pLoad',1,myThid)
#endif
C     CALL PLOT_FIELD_XYRS( fu, 'S/R INI_FORCING FU',1,myThid)
C     CALL PLOT_FIELD_XYRS( fv, 'S/R INI_FORCING FV',1,myThid)

      RETURN
      END

#include "DIAG_OPTIONS.h"

CBOP
C     !ROUTINE: DIAG_VEGTILE_FILL
C     !INTERFACE:
      SUBROUTINE DIAG_VEGTILE_FILL(
     &                field,indx,chfr,ib,numpts,npeice,
     &                check, chardiag, kLev, nLevs, bi, bj, myThid )
C     !DESCRIPTION:
C***********************************************************************
C Increment the diagnostics array with a vegetation tile space field
C***********************************************************************
C     !USES:
      IMPLICIT NONE

C     == Global variables ===
#include "EEPARAMS.h"
#include "SIZE.h"
#include "DIAGNOSTICS_SIZE.h"
#include "DIAGNOSTICS.h"

C     !INPUT PARAMETERS:
C***********************************************************************
C   field    :: array to be mapped to grid space [ib,levs] and added to qdiag
C   indx     :: array of horizontal indices of grid points to convert to
C               tile space[numpts]
C   chfr     :: fractional area covered by the tile [ib]
C   ib       :: inner dimension of source array and number of points in
C               array a that need to be pasted
C   numpts   :: total number of points which were stripped
C   npeice   :: the current strip number to be filled
C   check    :: logical to check for undefined values
C   chardiag :: Character expression for diag to fill
C   kLev     :: Integer flag for vertical levels:
C                > 0 (any integer): which single level to increment
C                0,-1 to increment "nLevs" levels in qdiag:
C                  0 : fill-in in the same order as the input array
C                 -1 : fill-in in reverse order.
C   nLevs    :: indicates Number of levels of the input field array
C   bi       :: X-direction tile number
C   bj       :: Y-direction tile number
C   myThid   :: my thread Id number
C***********************************************************************
      CHARACTER*8 chardiag
      INTEGER kLev, nLevs, bi, bj
      INTEGER myThid
      INTEGER ib,numpts,npeice
      INTEGER indx(numpts)
      _RL field(ib,nlevs), chfr(ib)
      LOGICAL check
CEOP

C     !LOCAL VARIABLES:
C ===============
      INTEGER m, n
      INTEGER ndiagnum, ipointer
      INTEGER k, kFirst, kLast
      INTEGER kd, kd0, ksgn, kStore
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      INTEGER offset, Lena
      INTEGER ivt, ij, i
      _RL undef
      INTEGER iSp, ndId, j,l
      INTEGER region2fill(0:nRegions)
      _RL     scaleFact
      _RL     gridField(sNx*sNy,nlevs), gridFrac(sNx*sNy)
#ifndef REAL4_IS_SLOW
      _RS     dummyRS(1)
#endif

#ifdef ALLOW_FIZHI
      _RL   getcon
      EXTERNAL getcon
#endif

C Run through list of active diagnostics to make sure
C we are trying to fill a valid diagnostic

      undef = UNSET_RL
#ifdef ALLOW_FIZHI
      IF ( check ) undef = getcon('UNDEF')
#endif
      ndiagnum = 0
      ipointer = 0
      DO n=1,nlists
       DO m=1,nActive(n)
        IF ( chardiag.EQ.flds(m,n) .AND. idiag(m,n).GT.0 ) THEN
         ndiagnum = ABS(jdiag(m,n))
         ipointer = idiag(m,n)
         IF ( ndiagnum.NE.0 .AND. ndiag(ipointer,1,1).GE.0 ) THEN
C--   do the filling: start here:

          IF ( (ABS(kLev).LE.1) .AND. (npeice.EQ.1) ) THEN
C Increment the counter for the diagnostic
            ndiag(ipointer,bi,bj) = ndiag(ipointer,bi,bj) + 1
          ENDIF

          offset = ib*(npeice-1)
          Lena   = MIN(ib,numpts-offset)

C-      Which part of field to add : k = 3rd index,
C         and do the loop >> do k=kFirst,kLast <<
          IF (kLev.LE.0) THEN
           kFirst = 1
           kLast  = nLevs
          ELSEIF ( nLevs.EQ.1 ) THEN
           kFirst = 1
           kLast  = 1
          ELSEIF ( kLev.LE.nLevs ) THEN
           kFirst = kLev
           kLast  = kLev
          ELSE
           STOP 'ABNORMAL END: S/R DIAGNOSTICS_FILL kLev > nLevs > 0'
          ENDIF
C-      Which part of qdiag to update: kd = 3rd index,
C         and do the loop >> do k=kFirst,kLast ; kd = kd0 + k*ksgn <<
          IF ( kLev.EQ.-1 ) THEN
           ksgn = -1
           kd0 = ipointer + nLevs
          ELSEIF ( kLev.EQ.0 ) THEN
           ksgn = 1
           kd0 = ipointer - 1
          ELSE
           ksgn = 0
           kd0 = ipointer + kLev - 1
          ENDIF

C-      Check for consistency with Nb of levels reserved in storage array
          kStore = kd0 + MAX(ksgn*kFirst,ksgn*kLast) - ipointer + 1
          IF ( kStore.GT.kdiag(ndiagnum) ) THEN
           _BEGIN_MASTER(myThid)
           WRITE(msgBuf,'(2A,I4,A)') 'DIAGNOSTICS_FILL: ',
     &      'exceed Nb of levels(=',kdiag(ndiagnum),' ) reserved '
           CALL PRINT_ERROR( msgBuf , myThid )
           WRITE(msgBuf,'(2A,I6,2A)') 'DIAGNOSTICS_FILL: ',
     &      'for Diagnostics #', ndiagnum, ' : ', chardiag
           CALL PRINT_ERROR( msgBuf , myThid )
           WRITE(msgBuf,'(2A,2I4,I3)') 'calling DIAGNOSTICS_FILL ',
     &      'with kLev,nLevs=', kLev,nLevs
           CALL PRINT_ERROR( msgBuf , myThid )
           WRITE(msgBuf,'(2A,I6,A)') 'DIAGNOSTICS_FILL: ',
     &      '==> trying to store up to ', kStore, ' levels'
           CALL PRINT_ERROR( msgBuf , myThid )
           STOP 'ABNORMAL END: S/R DIAGNOSTICS_FILL'
           _END_MASTER(myThid)
          ENDIF

          DO k = kFirst,kLast
           kd = kd0 + ksgn*k
           IF ( check ) THEN
            DO ivt = 1,Lena
             ij = indx(ivt+offset) - 1
             j = 1 + INT(ij/sNx)
             i = 1 + MOD(ij,sNx)
             IF ( field(ivt,k).EQ.undef ) THEN
              qdiag(i,j,kd,bi,bj) = undef
             ELSEIF ( qdiag(i,j,kd,bi,bj).NE.undef ) THEN
              qdiag(i,j,kd,bi,bj) = qdiag(i,j,kd,bi,bj)
     &                            + field(ivt,k)*chfr(ivt)
             ENDIF
            ENDDO
           ELSE
            DO ivt = 1,Lena
              ij = indx(ivt+offset) - 1
              j = 1 + INT(ij/sNx)
              i = 1 + MOD(ij,sNx)
              qdiag(i,j,kd,bi,bj) = qdiag(i,j,kd,bi,bj)
     &                            + field(ivt,k)*chfr(ivt)
            ENDDO
           ENDIF
          ENDDO

C--   do the filling: ends here.
         ENDIF
        ENDIF
       ENDDO
      ENDDO

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C--   Global/Regional Statistics :
      scaleFact = 1. _d 0

C Run through list of active statistics-diagnostics to make sure
C we are trying to compute & fill a valid diagnostic

      DO n=1,diagSt_nbLists
       DO m=1,diagSt_nbActv(n)
        IF ( chardiag.EQ.diagSt_Flds(m,n) .AND. iSdiag(m,n).GT.0 ) THEN
         iSp = iSdiag(m,n)
         IF ( qSdiag(0,0,iSp,bi,bj).GE.0. ) THEN
           ndId = jSdiag(m,n)
C-    Find list of regions to fill:
           DO j=0,nRegions
            region2fill(j) = diagSt_region(j,n)
           ENDDO
C-    if this diagnostics appears in several lists (with same freq)
C     then add regions from other lists
           DO l=1,diagSt_nbLists
            DO k=1,diagSt_nbActv(l)
             IF ( iSdiag(k,l).EQ.-iSp ) THEN
              DO j=0,nRegions
               region2fill(j) = MAX(region2fill(j),diagSt_region(j,l))
              ENDDO
             ENDIF
            ENDDO
           ENDDO

C-      Which part of field to add : k = 3rd index,
C         and do the loop >> do k=kFirst,kLast <<
           IF (kLev.LE.0) THEN
            kFirst = 1
            kLast  = nLevs
           ELSE
            kFirst = 1
            kLast  = 1
           ENDIF

C-    Fill local array with grid-space field after conversion.
           offset = ib*(npeice-1)
           Lena    = MIN(ib,numpts-offset)

           DO ij = 1,sNx*sNy
             gridFrac(ij)= 0.
           ENDDO
           DO ivt = 1,Lena
             ij = indx(ivt+offset)
             gridFrac(ij)=gridFrac(ij)+chfr(ivt)
           ENDDO

           DO k = kFirst,kLast
            DO ij = 1,sNx*sNy
             gridField(ij,k)= 0.
            ENDDO
            IF ( check ) THEN
             DO ivt = 1,Lena
              ij = indx(ivt+offset)
              IF ( field(ivt,k).EQ.undef ) THEN
               gridField(ij,k) = undef
              ELSEIF ( gridFrac(ij).GT.0. _d 0 ) THEN
               gridField(ij,k) = gridField(ij,k)
     &                         + field(ivt,k)*chfr(ivt)/gridFrac(ij)
              ENDIF
             ENDDO
            ELSE
             DO ivt = 1,Lena
              ij = indx(ivt+offset)
              IF ( gridFrac(ij).GT.0. _d 0 ) THEN
               gridField(ij,k) = gridField(ij,k)
     &                         + field(ivt,k)*chfr(ivt)/gridFrac(ij)
              ENDIF
             ENDDO
            ENDIF
           ENDDO

C-    diagnostics is valid and Active: Now do the filling
           CALL DIAGSTATS_FILL(
     I              gridField, gridFrac,
#ifndef REAL4_IS_SLOW
     I               dummyRS, dummyRS,
#endif
     I              scaleFact, 1, 0, 1,
     I              ndId, iSp, region2fill, kLev, nLevs,
     I              3, bi, bj, myThid )
         ENDIF
        ENDIF
       ENDDO
      ENDDO

      RETURN
      END

#include "CPP_EEOPTIONS.h"
#undef EXCH_USE_SPINNING
#undef DBUG_EXCH_VEC

C--   Contents
C--   o EXCH_RECV_GET_VEC_X_RL
C--   o EXCH_RECV_GET_VEC_Y_RL

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 0
C !ROUTINE: EXCH_RECV_GET_VEC_X_RL

C !INTERFACE:
      SUBROUTINE EXCH_RECV_GET_VEC_X_RL(
     U                        arrayE, arrayW,
     I                        myd1, myThid )
C     !DESCRIPTION:
C     *==========================================================*
C     | SUBROUTINE EXCH_RECV_GET_VEC_X_RL
C     | o "Receive" or "Get" X edges for RL array.
C     *==========================================================*
C     | Routine that invokes actual message passing receive
C     | of data to update buffer in X direction
C     *==========================================================*

C     !USES:
      IMPLICIT NONE

C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "EESUPPORT.h"
#include "EXCH.h"

C     !INPUT/OUTPUT PARAMETERS:
C     arrayE        :: buffer array to collect Eastern Neighbour values
C     arrayW        :: buffer array to collect Western Neighbour values
C     myd1          :: size
C     myThid        :: my Thread Id. number
      INTEGER myd1
      _RL arrayE(myd1, nSx, nSy), arrayW(myd1, nSx, nSy)
      INTEGER myThid
CEOP

C     !LOCAL VARIABLES:
C     bi, bj        :: tile indices
C     biW, bjW      :: West tile indices
C     biE, bjE      :: East tile indices
C     theProc       :: Variables used in message building
C     theTag        :: Variables used in message building
C     theType       :: Variables used in message building
C     theSize       :: Variables used in message building
C     westCommMode  :: variables holding type of communication
C     eastCommMode  ::  a particular tile face uses.
      INTEGER bi, bj
c     INTEGER biW, bjW, biE, bjE
      INTEGER westCommMode
      INTEGER eastCommMode
      INTEGER ioUnit
#ifdef EXCH_USE_SPINNING
      INTEGER spinCount
#endif
#ifdef ALLOW_USE_MPI
      INTEGER theProc, theTag, theType, theSize
      INTEGER mpiStatus(MPI_STATUS_SIZE,4), mpiRc
#endif

C--   Under a "put" scenario we
C--     i. set completetion signal for buffer we put into.
C--    ii. wait for completetion signal indicating data has been put in
C--        our buffer.
C--   Under a messaging mode we "receive" the message.
C--   Under a "get" scenario <= not implemented, we
C--     i. Check that the data is ready.
C--    ii. Read the data.
C--   iii. Set data read flag + memory sync.

      ioUnit = errorMessageUnit

      _BEGIN_MASTER(myThid)

      DO bj=1,nSy
       DO bi=1,nSx
        westCommMode  = _tileCommModeW(bi,bj)
        eastCommMode  = _tileCommModeE(bi,bj)
#ifdef DBUG_EXCH_VEC
        write(ioUnit,'(A,5I6)') 'RECV_X,0 :',myProcId,bi,bj
#endif
c       biE =  _tileBiE(bi,bj)
c       bjE =  _tileBjE(bi,bj)
c       biW =  _tileBiW(bi,bj)
c       bjW =  _tileBjW(bi,bj)
        IF ( westCommMode .EQ. COMM_MSG ) THEN
#ifdef ALLOW_USE_MPI
         IF ( usingMPI ) THEN
          theProc = tilePidW(bi,bj)
          theTag  = _tileTagRecvW(bi,bj)
          theType = _MPI_TYPE_RL
          theSize = myd1
#ifdef DBUG_EXCH_VEC
          write(ioUnit,'(A,5I5,I8)') 'qq2xW: ',myProcId,bi,bj,
     &          theProc,theTag,theSize
#endif
          CALL MPI_Recv( arrayW(1,bi,bj), theSize, theType,
     &                   theProc, theTag, MPI_COMM_MODEL,
     &                   mpiStatus, mpiRc )
c         if (theProc .eq. 0 .or. theProc .eq. 2) then
c         if (arrayW(1,bi,bj) .ne. 0.) then
c            write(errormessageunit,*) 'qq2y: ',myProcId,
c     &      theProc,theTag,theSize,(arrayW(i,bi,bj),i=1,32)
c         else
c            write(errormessageunit,*) 'qq2n: ',myProcId,
c     &      theProc,theTag,theSize,(arrayW(i,bi,bj),i=1,32)
c         endif
c         endif
         ENDIF
#endif /* ALLOW_USE_MPI */
        ENDIF
#ifdef DBUG_EXCH_VEC
        write(ioUnit,'(A,5I6)') 'RECV_X,1 :',myProcId,bi,bj
#endif

        IF ( eastCommMode .EQ. COMM_MSG ) THEN
#ifdef ALLOW_USE_MPI
         IF ( usingMPI ) THEN
          theProc = tilePidE(bi,bj)
          theTag  = _tileTagRecvE(bi,bj)
          theType = _MPI_TYPE_RL
          theSize = myd1
#ifdef DBUG_EXCH_VEC
          write(ioUnit,'(A,5I5,I8)') 'qq2xE: ',myProcId,bi,bj,
     &          theProc,theTag,theSize
#endif
          CALL MPI_Recv( arrayE(1,bi,bj), theSize, theType,
     &                   theProc, theTag, MPI_COMM_MODEL,
     &                   mpiStatus, mpiRc )
         ENDIF
#endif /* ALLOW_USE_MPI */
        ENDIF
#ifdef DBUG_EXCH_VEC
        write(ioUnit,'(A,5I6)') 'RECV_X,2 :',myProcId,bi,bj
#endif
       ENDDO
      ENDDO
#ifdef DBUG_EXCH_VEC
      write(ioUnit,'(A,5I6,I12)') 'RECV_X:',myProcId
#endif

      IF ( .NOT.exchUsesBarrier  ) THEN
       DO bj=1,nSy
        DO bi=1,nSx
         IF ( exchNReqsX(1,bi,bj) .GT. 0 ) THEN
#ifdef ALLOW_USE_MPI
          IF ( usingMPI )
     &    CALL MPI_Waitall( exchNReqsX(1,bi,bj), exchReqIdX(1,1,bi,bj),
     &                      mpiStatus, mpiRC )
#endif /* ALLOW_USE_MPI */
         ENDIF
C        Clear outstanding requests counter
         exchNReqsX(1,bi,bj) = 0
        ENDDO
       ENDDO
      ENDIF

      _END_MASTER(myThid)

C--   need to sync threads after master has received data ;
C     (done after mpi waitall in case waitall is really needed)
      _BARRIER

C--   Threads wait for buffers I am going to read to be ready.
C     note: added BARRIER in exch_send_put S/R and here above (message
C     mode) so that we no longer needs this (undef EXCH_USE_SPINNING)
#ifdef EXCH_USE_SPINNING
      IF ( exchUsesBarrier  ) THEN
C      o On some machines ( T90 ) use system barrier rather than spinning.
       CALL BARRIER( myThid )
      ELSE
C      o Spin waiting for completetion flag. This avoids a global-lock
C        i.e. we only lock waiting for data that we need.
       DO bj=myByLo(myThid),myByHi(myThid)
        DO bi=myBxLo(myThid),myBxHi(myThid)
         spinCount = 0
         westCommMode = _tileCommModeW(bi,bj)
         eastCommMode = _tileCommModeE(bi,bj)
#ifdef DBUG_EXCH_VEC
          write(ioUnit,'(A,5I6,I12)') 'spin:', myProcId,bi,bj,
     &          westRecvAck(1,bi,bj), eastRecvAck(1,bi,bj), spinCount
#endif
   10    CONTINUE
          CALL FOOL_THE_COMPILER( spinCount )
          spinCount = spinCount+1
#ifdef DBUG_EXCH_VEC
          write(ioUnit,'(A,5I6,I12)') 'spin:', myProcId,bi,bj,
     &          westRecvAck(1,bi,bj), eastRecvAck(1,bi,bj), spinCount
          IF ( myThid.EQ.1 .AND. spinCount.GT. _EXCH_SPIN_LIMIT ) THEN
           STOP ' S/R EXCH_RECV_GET_X: spinCount > _EXCH_SPIN_LIMIT'
          ENDIF
#endif
          IF ( westRecvAck(1,bi,bj) .EQ. 0 ) GOTO 10
          IF ( eastRecvAck(1,bi,bj) .EQ. 0 ) GOTO 10
C        Clear outstanding requests
         westRecvAck(1,bi,bj) = 0
         eastRecvAck(1,bi,bj) = 0
        ENDDO
       ENDDO
      ENDIF
#endif /* EXCH_USE_SPINNING */

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 0
C !ROUTINE: EXCH_RECV_GET_VEC_Y_RL

C !INTERFACE:
      SUBROUTINE EXCH_RECV_GET_VEC_Y_RL(
     U                        arrayN, arrayS,
     I                        myd1, myThid )
C     !DESCRIPTION:
C     *==========================================================*
C     | SUBROUTINE EXCH_RECV_GET_VEC_Y_RL
C     | o "Receive" or "Get" Y edges for RL array.
C     *==========================================================*
C     | Routine that invokes actual message passing receive
C     | of data to update buffer in Y direction
C     *==========================================================*

C     !USES:
      IMPLICIT NONE

C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "EESUPPORT.h"
#include "EXCH.h"

C     !INPUT/OUTPUT PARAMETERS:
C     arrayN        :: buffer array to collect Northern Neighbour values
C     arrayS        :: buffer array to collect Southern Neighbour values
C     myd1          :: size
C     myThid        :: my Thread Id. number
      INTEGER myd1
      _RL arrayN(myd1, nSx, nSy), arrayS(myd1, nSx, nSy)
      INTEGER myThid
CEOP

C     !LOCAL VARIABLES:
C     bi, bj        :: tile indices
C     biS, bjS      :: South tile indices
C     biN, bjN      :: North tile indices
C     theProc       :: Variables used in message building
C     theTag        :: Variables used in message building
C     theType       :: Variables used in message building
C     theSize       :: Variables used in message building
C     southCommMode :: variables holding type of communication
C     northCommMode ::  a particular tile face uses.
      INTEGER bi, bj
c     INTEGER biS, bjS, biN, bjN
      INTEGER southCommMode
      INTEGER northCommMode
      INTEGER ioUnit
#ifdef EXCH_USE_SPINNING
      INTEGER spinCount
#endif
#ifdef ALLOW_USE_MPI
      INTEGER theProc, theTag, theType, theSize
      INTEGER mpiStatus(MPI_STATUS_SIZE,4), mpiRc
#endif

C--   Under a "put" scenario we
C--     i. set completetion signal for buffer we put into.
C--    ii. wait for completetion signal indicating data has been put in
C--        our buffer.
C--   Under a messaging mode we "receive" the message.
C--   Under a "get" scenario <= not implemented, we
C--     i. Check that the data is ready.
C--    ii. Read the data.
C--   iii. Set data read flag + memory sync.

      ioUnit = errorMessageUnit

      _BEGIN_MASTER(myThid)

      DO bj=1,nSy
       DO bi=1,nSx
        southCommMode  = _tileCommModeS(bi,bj)
        northCommMode  = _tileCommModeN(bi,bj)
#ifdef DBUG_EXCH_VEC
        write(ioUnit,'(A,5I6)') 'RECV_Y,0 :',myProcId,bi,bj
#endif
c       biN =  _tileBiN(bi,bj)
c       bjN =  _tileBjN(bi,bj)
c       biS =  _tileBiS(bi,bj)
c       bjS =  _tileBjS(bi,bj)
        IF ( southCommMode .EQ. COMM_MSG ) THEN
#ifdef ALLOW_USE_MPI
         IF ( usingMPI ) THEN
          theProc = tilePidS(bi,bj)
          theTag  = _tileTagRecvS(bi,bj)
          theType = _MPI_TYPE_RL
          theSize = myd1
          CALL MPI_Recv( arrayS(1,bi,bj), theSize, theType,
     &                   theProc, theTag, MPI_COMM_MODEL,
     &                   mpiStatus, mpiRc )
         ENDIF
#endif /* ALLOW_USE_MPI */
        ENDIF
#ifdef DBUG_EXCH_VEC
        write(ioUnit,'(A,5I6)') 'RECV_Y,1 :',myProcId,bi,bj
#endif

        IF ( northCommMode .EQ. COMM_MSG ) THEN
#ifdef ALLOW_USE_MPI
         IF ( usingMPI ) THEN
          theProc = tilePidN(bi,bj)
          theTag  = _tileTagRecvN(bi,bj)
          theType = _MPI_TYPE_RL
          theSize = myd1
          CALL MPI_Recv( arrayN(1,bi,bj), theSize, theType,
     &                   theProc, theTag, MPI_COMM_MODEL,
     &                   mpiStatus, mpiRc )
         ENDIF
#endif /* ALLOW_USE_MPI */
        ENDIF
#ifdef DBUG_EXCH_VEC
        write(ioUnit,'(A,5I6)') 'RECV_Y,2 :',myProcId,bi,bj
#endif
       ENDDO
      ENDDO
#ifdef DBUG_EXCH_VEC
      write(ioUnit,'(A,5I6,I12)') 'RECV_Y:',myProcId
#endif

C--   Processes wait for buffers I am going to read to be ready.
      IF ( .NOT.exchUsesBarrier  ) THEN
       DO bj=1,nSy
        DO bi=1,nSx
         IF ( exchNReqsY(1,bi,bj) .GT. 0 ) THEN
#ifdef ALLOW_USE_MPI
          IF ( usingMPI )
     &    CALL MPI_Waitall( exchNReqsY(1,bi,bj), exchReqIdY(1,1,bi,bj),
     &                      mpiStatus, mpiRC )
#endif /* ALLOW_USE_MPI */
         ENDIF
C        Clear outstanding requests counter
         exchNReqsY(1,bi,bj) = 0
        ENDDO
       ENDDO
      ENDIF

      _END_MASTER(myThid)

C--   need to sync threads after master has received data ;
C     (done after mpi waitall in case waitall is really needed)
      _BARRIER

C--   Threads wait for buffers I am going to read to be ready.
C     note: added BARRIER in exch_send_put S/R and here above (message
C     mode) so that we no longer needs this (undef EXCH_USE_SPINNING)
#ifdef EXCH_USE_SPINNING
      IF ( exchUsesBarrier  ) THEN
C      o On some machines ( T90 ) use system barrier rather than spinning.
       CALL BARRIER( myThid )
      ELSE
C      o Spin waiting for completetion flag. This avoids a global-lock
C        i.e. we only lock waiting for data that we need.
       DO bj=myByLo(myThid),myByHi(myThid)
        DO bi=myBxLo(myThid),myBxHi(myThid)
         spinCount = 0
         southCommMode = _tileCommModeS(bi,bj)
         northCommMode = _tileCommModeN(bi,bj)
#ifdef DBUG_EXCH_VEC
          write(ioUnit,'(A,5I6,I12)') 'spin:', myProcId,bi,bj,
     &          southRecvAck(1,bi,bj), northRecvAck(1,bi,bj), spinCount
#endif
   10    CONTINUE
          CALL FOOL_THE_COMPILER( spinCount )
          spinCount = spinCount+1
#ifdef DBUG_EXCH_VEC
          write(ioUnit,'(A,5I6,I12)') 'spin:', myProcId,bi,bj,
     &          southRecvAck(1,bi,bj), northRecvAck(1,bi,bj), spinCount
          IF ( myThid.EQ.1 .AND. spinCount.GT. _EXCH_SPIN_LIMIT ) THEN
           STOP ' S/R EXCH_RECV_GET_X: spinCount > _EXCH_SPIN_LIMIT'
          ENDIF
#endif
          IF ( southRecvAck(1,bi,bj) .EQ. 0 ) GOTO 10
          IF ( northRecvAck(1,bi,bj) .EQ. 0 ) GOTO 10
C        Clear outstanding requests
         southRecvAck(1,bi,bj) = 0
         northRecvAck(1,bi,bj) = 0
        ENDDO
       ENDDO
      ENDIF
#endif /* EXCH_USE_SPINNING */

      RETURN
      END

#include "CTRL_OPTIONS.h"

CBOP
C     !ROUTINE: CTRL_MAP_GENTIM2D
C     !INTERFACE:
      SUBROUTINE CTRL_MAP_GENTIM2D(
     I                        myTime, myIter, myThid )
C     !DESCRIPTION: \bv
C     *=============================================================*
C     | S/R  CTRL_MAP_GENTIM2D
C     *=============================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "CTRL_SIZE.h"
#include "CTRL.h"
#include "CTRL_GENARR.h"
#include "CTRL_DUMMY.h"

C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
C     myTime    :: Current time in simulation
C     myIter    :: Current iteration number
C     myThid    :: my Thread Id number
      _RL  myTime
      INTEGER myIter
      INTEGER myThid

#ifdef ALLOW_GENTIM2D_CONTROL
C     !LOCAL VARIABLES:
C     == Local variables ==
      INTEGER bi, bj
      INTEGER i, j
      INTEGER iarr
      _RL xx_gentim2d_loc(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RS mask2D         (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      _RL LOCsumTile(nSx,nSy), LOCsumGlob
CEOP

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C--   generic - user-defined control vars
      DO iarr = 1, maxCtrlTim2D

       IF (xx_gentim2d_weight(iarr).NE.' ') THEN

        DO bj = myByLo(myThid),myByHi(myThid)
         DO bi = myBxLo(myThid),myBxHi(myThid)
          DO j = 1-OLy,sNy+OLy
           DO i = 1-OLx,sNx+OLx
            xx_gentim2d_loc(i,j,bi,bj) = 0. _d 0
           ENDDO
          ENDDO
         ENDDO
        ENDDO

        CALL CTRL_GET_MASK2D( xx_gentim2d_file(iarr), mask2D, myThid )
        CALL CTRL_GET_GEN (
     I      xx_gentim2d_file(iarr),
     I      xx_gentim2d_startdate(1,iarr),
     I      xx_gentim2d_period(iarr),
     I      mask2D,
     O      xx_gentim2d_loc,
     I      xx_gentim2d0(1-OLx,1-OLy,1,1,iarr),
     I      xx_gentim2d1(1-OLx,1-OLy,1,1,iarr),
     I      xx_gentim2d_dummy(iarr),
     I      zeroRL, zeroRL,
     I      wgentim2d(1-OLx,1-OLy,1,1,iarr),
     I      myTime, myIter, myThid )

        IF (xx_gentim2d_cumsum(iarr)) THEN
         DO bj=myByLo(myThid),myByHi(myThid)
          DO bi=myBxLo(myThid),myBxHi(myThid)
           DO j = 1,sNy
            DO i = 1,sNx
             xx_gentim2d(i,j,bi,bj,iarr)=xx_gentim2d(i,j,bi,bj,iarr)
     &            + xx_gentim2d_loc(i,j,bi,bj)
            ENDDO
           ENDDO
          ENDDO
         ENDDO
        ELSE
         DO bj=myByLo(myThid),myByHi(myThid)
          DO bi=myBxLo(myThid),myBxHi(myThid)
           DO j = 1,sNy
            DO i = 1,sNx
             xx_gentim2d(i,j,bi,bj,iarr)=xx_gentim2d_loc(i,j,bi,bj)
            ENDDO
           ENDDO
          ENDDO
         ENDDO
        ENDIF

        IF (xx_gentim2d_glosum(iarr)) THEN

         DO bj=myByLo(myThid),myByHi(myThid)
          DO bi=myBxLo(myThid),myBxHi(myThid)
           LOCsumTile(bi,bj)=0. _d 0
           DO j = 1,sNy
            DO i = 1,sNx
             LOCsumTile(bi,bj) = LOCsumTile(bi,bj)
     &          + xx_gentim2d(i,j,bi,bj,iarr)*rA(i,j,bi,bj)
     &           *maskC(i,j,1,bi,bj)*maskInC(i,j,bi,bj)
            ENDDO
           ENDDO
          ENDDO
         ENDDO

         CALL GLOBAL_SUM_TILE_RL( LOCsumTile, LOCsumGlob, myThid )

         LOCsumGlob = LOCsumGlob/globalArea
         DO bj = myByLo(myThid),myByHi(myThid)
          DO bi = myBxLo(myThid),myBxHi(myThid)
           DO j = 1-OLy,sNy+OLy
            DO i = 1-OLx,sNx+OLx
             xx_gentim2d(i,j,bi,bj,iarr) =
     &                   LOCsumGlob*maskC(i,j,1,bi,bj)
            ENDDO
           ENDDO
          ENDDO
         ENDDO

         IF (xx_gentim2d_file(iarr).EQ.'xx_gen_precip') THEN

          WRITE(msgBuf,'(A,I6,A,1PE21.14)')
     &         ' iter=', myIter, ' ; genprecipGloH= ',
     &         LOCsumGlob*rhoConstFresh*recip_rhoConst*deltaTClock
          CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                        SQUEEZE_RIGHT, myThid )

         ENDIF !IF (xx_gentim2d_file(iarr).EQ.'xx_gen_precip') THEN

        ENDIF !IF (xx_gentim2d_glosum(iarr)) THEN

       ENDIF !IF (xx_gentim2d_weight(iarr).NE.' ') THEN

      ENDDO !DO iarr = 1, maxCtrlTim2D

#endif /* ALLOW_GENTIM2D_CONTROL */

      RETURN
      END

#include "PACKAGES_CONFIG.h"
#include "CPP_OPTIONS.h"

CBOP
C     !ROUTINE: DIAGS_PHI_HYD
C     !INTERFACE:
      SUBROUTINE DIAGS_PHI_HYD(
     I                       k, bi, bj, iMin,iMax, jMin,jMax,
     I                       phiHydC,
     I                       myTime, myIter, myThid)
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R DIAGS_PHI_HYD
C     | o Diagnose full hydrostatic Potential at cell center ;
C     |   used for output & with EOS funct. of P
C     *==========================================================*
C     | NOTE: For now, only contains the (total) Potential anomaly
C     |  since phiRef (for Atmos) is not available (not in common)
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "SURFACE.h"
#include "DYNVARS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine Arguments ==
C     k, bi,bj      :: level & tile indices
C     iMin,iMax,jMin,jMax :: Loop counters
C     phiHydC    :: hydrostatic potential anomaly at cell center
C                  (atmos: =Geopotential ; ocean-z: =Pressure/rho)
C     myTime :: Current time
C     myIter :: Current iteration number
C     myThid :: Instance number for this call of the routine.
      INTEGER k, bi,bj, iMin,iMax, jMin,jMax
      _RL phiHydC(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL myTime
      INTEGER myIter, myThid

#ifdef INCLUDE_PHIHYD_CALCULATION_CODE

C     !LOCAL VARIABLES:
C     == Local variables ==
C     i,j        :: Loop counters
C     phiHydCstR :: total hydrostatic Potential (anomaly, for now),
C                   at fixed r-position, cell center level location.
      INTEGER i,j
#ifdef NONLIN_FRSURF
      _RL facP, dPhiRef
      _RL phiHydCstR(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
#endif /* NONLIN_FRSURF */
CEOP

        DO j=jMin,jMax
         DO i=iMin,iMax
           totPhiHyd(i,j,k,bi,bj) = phiHydC(i,j)
     &            + Bo_surf(i,j,bi,bj)*etaN(i,j,bi,bj)
     &            + phi0surf(i,j,bi,bj)
#ifdef NONLIN_FRSURF
           phiHydCstR(i,j) = totPhiHyd(i,j,k,bi,bj)
#endif /* NONLIN_FRSURF */
         ENDDO
        ENDDO

#ifdef NONLIN_FRSURF
c     IF (select_rStar.GE.2 .AND. nonlinFreeSurf.GE.4 ) THEN
      IF (select_rStar.GE.1 .AND. nonlinFreeSurf.GE.4 ) THEN
c# ifndef DISABLE_RSTAR_CODE
C-    Integral of b.dr = rStarFac * Integral of b.dr* :
       IF ( fluidIsAir ) THEN
C-     Consistent with Phi'= Integr[ theta'.dPi ] :
        DO j=jMin,jMax
         DO i=iMin,iMax
           facP = pStarFacK(i,j,bi,bj)
           dPhiRef = phiRef(2*k) - gravity*topoZ(i,j,bi,bj)
     &                           - phi0surf(i,j,bi,bj)
           totPhiHyd(i,j,k,bi,bj) =
     &              phiHydC(i,j)*facP
     &            + MAX( dPhiRef, 0. _d 0 )*( facP - 1. _d 0 )
     &            + phi0surf(i,j,bi,bj)
c          phiHydCstR(i,j) = phiHydCstR(i,j)
c    &            + phiHydC(i,j)*( facP - 1. _d 0 )
         ENDDO
        ENDDO
       ELSEIF ( usingPCoords ) THEN
        DO j=jMin,jMax
         DO i=iMin,iMax
c    &     dPhiRef = phiRef(2*k) - gravity*topoZ(i,j,bi,bj)
c    &                           - phi0surf(i,j,bi,bj)
C--    assume PhiRef is just (ps0 - p)/rhoConst :
           dPhiRef =( Ro_surf(i,j,bi,bj)-rC(k) )*recip_rhoConst
           totPhiHyd(i,j,k,bi,bj) =
     &              phiHydC(i,j)*rStarFacC(i,j,bi,bj)
     &            + MAX( dPhiRef, 0. _d 0 )
     &                *( rStarFacC(i,j,bi,bj) - 1. _d 0 )
     &            + phi0surf(i,j,bi,bj)
c          totPhiHyd(i,j,k,bi,bj) = phiHydCstR(i,j)
         ENDDO
        ENDDO
       ELSE
        DO j=jMin,jMax
         DO i=iMin,iMax
           dPhiRef =( Ro_surf(i,j,bi,bj)-rC(k) )*gravity
           totPhiHyd(i,j,k,bi,bj) =
     &              phiHydC(i,j)*rStarFacC(i,j,bi,bj)
     &            + MAX( dPhiRef, 0. _d 0 )
     &                *( rStarFacC(i,j,bi,bj) - 1. _d 0 )
     &            + phi0surf(i,j,bi,bj)
c          totPhiHyd(i,j,k,bi,bj) = phiHydCstR(i,j)
         ENDDO
        ENDDO
       ENDIF
#ifdef ALLOW_DIAGNOSTICS
C--    skip diagnostics if called from INI_PRESSURE
       IF ( useDiagnostics .AND. myIter.GE.0 ) THEN
        CALL DIAGNOSTICS_FILL(phiHydCstR,'PHIHYDcR',k,1,2,bi,bj,myThid)
       ENDIF
#endif /* ALLOW_DIAGNOSTICS */

c# endif /* DISABLE_RSTAR_CODE */
      ENDIF
#endif /* NONLIN_FRSURF */

#endif /* INCLUDE_PHIHYD_CALCULATION_CODE */

      RETURN
      END

#include "GAD_OPTIONS.h"

CBOP
C !ROUTINE: GAD_DIFF_R

C !INTERFACE: ==========================================================
      SUBROUTINE GAD_DIFF_R(
     I           bi, bj, k,
     I           maskUp, KappaR, tracer,
     O           dfr,
     I           myThid )

C !DESCRIPTION:
C Calculates the area integrated vertical flux due to down-gradient
C diffusion of a tracer:
C \begin{equation*}
C F^r_{diff} = - A^r \kappa_r \frac{1}{\Delta r_c} \delta_k \theta
C \end{equation*}

C !USES: ===============================================================
      IMPLICIT NONE
#include "SIZE.h"
#include "GRID.h"
#include "EEPARAMS.h"
#include "PARAMS.h"

C !INPUT PARAMETERS: ===================================================
C  bi,bj                :: tile indices
C  k                    :: vertical level
C  maskUp               :: 2-D array for mask at W points
C  KappaR               :: vertical diffusivity
C  tracer               :: tracer field
C  myThid               :: thread number
      INTEGER bi,bj,k
      _RS maskUp(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL KappaR(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL tracer(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      INTEGER myThid

C !OUTPUT PARAMETERS: ==================================================
C  dfr                  :: vertical diffusive flux
      _RL dfr   (1-OLx:sNx+OLx,1-OLy:sNy+OLy)

C !LOCAL VARIABLES: ====================================================
C  i,j                  :: loop indices
C  km1                  :: =k+1 for k<Nr, =Nr for k>-Nr
      INTEGER i,j,km1
CEOP

      km1=MAX(1,k-1)

      IF (k.EQ.1 .OR. k.GT.Nr) THEN
       DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
         dfr(i,j) = 0.
        ENDDO
       ENDDO
      ELSE
       DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
         dfr(i,j) = -KappaR(i,j)*maskUp(i,j)
     &            *_rA(i,j,bi,bj)*deepFac2F(k)*rhoFacF(k)
     &            *recip_drC(k)
     &            *(tracer(i,j,k)-tracer(i,j,km1))*rkSign
        ENDDO
       ENDDO
      ENDIF

      RETURN
      END

#include "BLING_OPTIONS.h"

CBOP
      SUBROUTINE BLING_SGS(
     I           bi, bj, imin, imax, jmin, jmax,
     I           myTime, myIter, myThid)

C     =================================================================
C     | subroutine bling_sgs
C     | o Placeholder for sub-grid scale sediment stuff
C     =================================================================

      IMPLICIT NONE

C     === Global variables ===

#include "SIZE.h"
#include "DYNVARS.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "BLING_VARS.h"
#include "PTRACERS_SIZE.h"
#include "PTRACERS_PARAMS.h"

C     === Routine arguments ===
C     bi,bj         :: tile indices
C     iMin,iMax     :: computation domain: 1rst index range
C     jMin,jMax     :: computation domain: 2nd  index range
C     myTime        :: current time
C     myIter        :: current timestep
C     myThid        :: thread Id. number
      INTEGER bi, bj, imin, imax, jmin, jmax
      _RL     myTime
      INTEGER myIter
      INTEGER myThid
C     === Input ===
C     === Output ===

#ifdef ALLOW_BLING
C     === Local variables ===
C     i,j,k         :: loop indices
c     INTEGER i,j,k

CEOP

c ---------------------------------------------------------------------
c  Initialize output and diagnostics

c---------------------------------------------------------------------
c SUBGRIDSCALE SEDIMENT FLUXES
c
c The subgridscale sediment produces remineralization fluxes from sinking particles
c throughout the water column, and leads to 3-dimensional fields for benthic
c iron fluxes and benthic denitrification.
c Note that the remineralization of particle flux intercepting the subgridscale
c sediment is implicit in the reminp terms.

c#ifdef use_sgs_sed
c!!
c#endif

c ---------------------------------------------------------------------

#ifdef ALLOW_DIAGNOSTICS
      IF ( useDiagnostics ) THEN

      ENDIF
#endif /* ALLOW_DIAGNOSTICS */

#endif /* ALLOW_BLING */

      RETURN
      END

#include "CAL_OPTIONS.h"

      SUBROUTINE CAL_FULLDATE(
     I                         yymmdd,
     I                         hhmmss,
     O                         date,
     I                         myThid )

C     ==================================================================
C     SUBROUTINE cal_FullDate
C     ==================================================================
C
C     o Set a date array given the year, month, day, hour, minute,
C       and second. Check the input for errors.
C
C     started: Christian Eckert eckert@mit.edu  30-Jun-1999
C     changed: Christian Eckert eckert@mit.edu  29-Dec-1999
C              - restructured the original version in order to have a
C                better interface to the MITgcmUV.
C              Christian Eckert eckert@mit.edu  03-Feb-2000
C              - Introduced new routine and function names, cal_<NAME>,
C                for verion 0.1.3.
C
C     ==================================================================
C     SUBROUTINE cal_FullDate
C     ==================================================================

      IMPLICIT NONE

C     == global variables ==
#include "EEPARAMS.h"
#include "cal.h"

C     == routine arguments ==
C     myThid - thread number for this instance of the routine.
      INTEGER yymmdd
      INTEGER hhmmss
      INTEGER date(4)
      INTEGER myThid

C     == functions ==
      INTEGER  cal_IsLeap
      EXTERNAL cal_IsLeap

C     == local variables ==
      INTEGER theyear
      INTEGER numberOfDays(4)
      INTEGER calerr
      LOGICAL valid
      CHARACTER*(MAX_LEN_MBUF) msgBuf
C     == end of interface ==

      date(1) = yymmdd
      date(2) = hhmmss
      date(3) = 1
      date(4) = 1

      IF ( cal_setStatus .LT. 1 ) THEN
        WRITE( msgBuf,'(A,2(A,I9))')  'CAL_FULLDATE: ',
     &          'yymmdd=',yymmdd,' , hhmmss=',hhmmss
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE( msgBuf,'(2A,I2,A)') 'CAL_FULLDATE: ',
     &    'called too early (cal_setStatus=',cal_setStatus,' )'
        CALL PRINT_ERROR( msgBuf, myThid )
        STOP 'ABNORMAL END: S/R CAL_FULLDATE'
      ENDIF

C     Check the input for obvious errors.
      CALL CAL_CHECKDATE( date, valid, calerr, myThid )
      IF ( calerr.NE.0 ) THEN
        WRITE( msgBuf,'(A,2(A,I9))')  'CAL_FULLDATE: ',
     &          'yymmdd=',yymmdd,' , hhmmss=',hhmmss
        CALL PRINT_ERROR( msgBuf, myThid )
        CALL CAL_PRINTERROR( calerr, myThid )
      ENDIF

      IF (valid) THEN
C       Determine whether we are in a leap year or not.
        theyear = yymmdd/10000
        date(3) = cal_IsLeap( theyear, myThid )

C       Determine the day of the week.
        CALL CAL_TIMEPASSED( refDate, date, numberOfDays, myThid )
        IF ( numberOfDays(1).LT.0 ) THEN
C-      when numberOfDays < 0 ,  TIMEPASSED output is not very logical (print);
C       in addition, in this case, formula below is wrong (skipped).
          WRITE(errorMessageUnit,'(2A,4I9)') ' in CAL_FULLDATE: ',
     &     'refDate=', refDate(1), refDate(2), refDate(3), refDate(4)
          WRITE(errorMessageUnit,'(2A,4I9)') ' in CAL_FULLDATE: ',
     &     '   date=', date(1), date(2), date(3), date(4)
          WRITE(errorMessageUnit,'(2A,4I9)') ' in CAL_FULLDATE: ',
     &     'numDays=', numberOfDays(1), numberOfDays(2),
     &                 numberOfDays(3), numberOfDays(4)
        ELSE
          date(4) = MOD(numberOfDays(1),7)+1
        ENDIF
      ELSE
        WRITE( msgBuf,'(2A)') 'CAL_FULLDATE: ',
     &    'fatal error from cal_CheckDate'
        CALL PRINT_ERROR( msgBuf, myThid )
        STOP 'ABNORMAL END: S/R CAL_FULLDATE'
      ENDIF

      RETURN
      END

#include "MONITOR_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: MON_SET_IOUNIT

C     !INTERFACE:
      SUBROUTINE MON_SET_IOUNIT( monUnit, myThid )

C     !DESCRIPTION:
C     Set default monitor unit for I/O.

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "MONITOR.h"

C     !INPUT PARAMETERS:
C     monUnit :: Unit number to use for monitor output
C     myThid  :: Instance number of this call to monitor
      INTEGER monUnit
      INTEGER myThid
CEOP

C     Dont change before everyone is ready
      CALL BAR2( myThid )

C     Set monitor I/O unit
      _BEGIN_MASTER(myThid)
      mon_ioUnit = monUnit
      _END_MASTER(myThid)

C     Make sure everyone sees the change
      CALL BAR2( myThid )

      RETURN
      END

#include "GMREDI_OPTIONS.h"

CBOP
C     !ROUTINE: GMREDI_CALC_PSI_BVP
C     !INTERFACE:
      SUBROUTINE GMREDI_CALC_PSI_BVP(
     I             bi, bj, iMin, iMax, jMin, jMax,
     I             sigmaX, sigmaY, sigmaR,
     I             myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE GMREDI_CALC_PSI_BVP
C     | o Calculate stream-functions for GM bolus velocity using
C     |   the BVP in Ferrari et al. (OM, 2010)
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "GMREDI.h"

C     !INPUT/OUTPUT PARAMETERS:
C     bi,bj   :: Tile indices
C   iMin,iMax :: computation domain 1rst index bounds
C   jMin,jMax :: computation domain 2nd  index bounds
C     sigmaX  :: Zonal      gradient of density
C     sigmaY  :: Meridional gradient of density
C     sigmaR  :: Vertical   gradient of Pot.density (locally referenced)
C     myThid  :: My Thread Id number
      INTEGER bi,bj,iMin,iMax,jMin,jMax
      _RL sigmaX(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL sigmaY(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL sigmaR(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      INTEGER myThid
CEOP

#ifdef GM_BOLUS_ADVEC
#ifdef GM_BOLUS_BVP

C     !LOCAL VARIABLES:
      INTEGER i,j,k, km1
      INTEGER errCode
      _RL half_K
      _RL sigmaX_W
      _RL sigmaY_W
      _RL dSigmaDrW
      _RL dSigmaDrS
      _RL wkb_cW(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL wkb_cS(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL rPI, c2
#ifdef ALLOW_DIAGNOSTICS
      _RL tmpFac
#endif
      CHARACTER*(MAX_LEN_MBUF) msgBuf

      PARAMETER ( rPI    = 0.318309886183791 _d 0 )

C-    Matrix elements for tri-diagonal solver
      _RL GM_a3d(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL GM_b3d(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL GM_c3d(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)

C-    Initialization : <= done in S/R gmredi_init
      IF (GM_UseBVP) THEN

C     Initialize the WKB wave speeds to zero
C     We use c = int_{-H}^0 N dz/(GM_BVP_ModeNumber*PI) and have absorbed
C     a factor of g/rhoConst
       DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
          wkb_cW(i,j) = 0. _d 0
          wkb_cS(i,j) = 0. _d 0
        ENDDO
       ENDDO

C      Surface BC : set to zero
       DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
          GM_PsiX(i,j,1,bi,bj) = 0. _d 0
          GM_PsiY(i,j,1,bi,bj) = 0. _d 0
        ENDDO
       ENDDO

C      Initialise matrix to identity
       DO k=1,Nr
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          GM_a3d(i,j,k) = 0. _d 0
          GM_b3d(i,j,k) = 1. _d 0
          GM_c3d(i,j,k) = 0. _d 0
         ENDDO
        ENDDO
       ENDDO

       DO k=2,Nr
        km1 = k-1
        half_K = GM_background_K
     &         *(GM_bolFac1d(km1)+GM_bolFac1d(k))*op25
C      Gradient of Sigma below U and V points
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx+1,sNx+OLx
          sigmaX_W = op5*( sigmaX(i,j,km1)+sigmaX(i,j,k) )
     &                  *maskW(i,j,km1,bi,bj)*maskW(i,j,k,bi,bj)
          dSigmaDrW = op5*( sigmaR(i-1,j,k)+sigmaR(i,j,k) )
     &                  *maskW(i,j,km1,bi,bj)*maskW(i,j,k,bi,bj)

          wkb_cW(i,j) = wkb_cW(i,j)
     &                + SQRT(MAX( -dSigmaDrW, 0. _d 0 ))
     &                 *drC(k)*GM_BVP_rModeNumber*rPI

C      Part of main diagonal coming from zeroth order derivative
          GM_b3d(i,j,k) = MAX( -dSigmaDrW, GM_Small_Number )

C      This is initially the RHS
          GM_PsiX(i,j,k,bi,bj) = half_K*sigmaX_W
     &       *(GM_bolFac2d(i-1,j,bi,bj)+GM_bolFac2d(i,j,bi,bj))
         ENDDO
        ENDDO
       ENDDO

C Note: Use Dirichlet BC @ Surface & Bottom (whereas we use Neumann BC for
C       implicit diffusion/advection Pb).
C     Surface BC implementation: => keep non zero coeff @ k=2
C                               and set Psi=1 with Identity coeff @ k=1
C     Same for bottom, except if kBottom=Nr (solver only process k=1:Nr)
C       should substract c3d(k=Nr)*Psi(k=Nr+1) to RHS @ k=Nr ;
C       However in our case this term is zero since Psi(k=Nr+1)=0
       DO k=2,Nr
        km1 = k-1
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx+1,sNx+OLx
          IF ( maskW(i,j,km1,bi,bj).NE.zeroRS .AND.
     &         maskW(i,j, k, bi,bj).NE.zeroRS ) THEN
            c2 = MAX( wkb_cW(i,j)*wkb_cW(i,j), GM_BVP_cHat2Min )
            GM_a3d(i,j,k) = -c2*recip_drC(k)
     &                      *recip_drF(km1)*recip_hFacW(i,j,km1,bi,bj)
            GM_b3d(i,j,k) = GM_b3d(i,j,k)
     &                    + c2*recip_drC(k)
     &                     *(recip_drF(km1)*recip_hFacW(i,j,km1,bi,bj)
     &                      +recip_drF(k)*recip_hFacW(i,j,k,bi,bj) )
            GM_c3d(i,j,k) = -c2*recip_drC(k)
     &                      *recip_drF(k)*recip_hFacW(i,j,k,bi,bj)
          ELSE
            GM_b3d(i,j,k) = 1. _d 0
          ENDIF
         ENDDO
        ENDDO
       ENDDO

       errCode = -1
       CALL SOLVE_TRIDIAGONAL( iMin+1, iMax, jMin, jMax,
     &                         GM_a3d, GM_b3d, GM_c3d,
     &                         GM_PsiX(1-OLx,1-OLy,1,bi,bj),
     &                         errCode, bi, bj, myThid )

       IF ( errCode .GT. 0 ) THEN
        WRITE(msgBuf,'(A)')
     &  'S/R GMREDI_CALC_PSI_BVP: matrix singular for PsiX'
        CALL PRINT_ERROR( msgBuf, myThid )
        STOP 'ABNORMAL END: S/R GMREDI_CALC_PSI_BVP'
       ENDIF

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C      Reset matrix to identity
       DO k=2,Nr
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          GM_a3d(i,j,k) = 0. _d 0
          GM_b3d(i,j,k) = 1. _d 0
          GM_c3d(i,j,k) = 0. _d 0
         ENDDO
        ENDDO
       ENDDO
C      cut k loop in 2 to prevent bad optimisation with some compilers
       DO k=2,Nr
        km1 = k-1
        half_K = GM_background_K
     &         *(GM_bolFac1d(km1)+GM_bolFac1d(k))*op25
        DO j=1-OLy+1,sNy+OLy
         DO i=1-OLx,sNx+OLx
          sigmaY_W = op5*( sigmaY(i,j,km1)+sigmaY(i,j,k) )
     &                  *maskS(i,j,km1,bi,bj)*maskS(i,j,k,bi,bj)
          dSigmaDrS = op5*( sigmaR(i,j-1,k)+sigmaR(i,j,k) )
     &                  *maskS(i,j,km1,bi,bj)*maskS(i,j,k,bi,bj)

          wkb_cS(i,j) = wkb_cS(i,j)
     &                + SQRT(MAX( -dSigmaDrS, 0. _d 0 ))
     &                 *drC(k)*GM_BVP_rModeNumber*rPI

C      Part of main diagonal coming from zeroth order derivative
          GM_b3d(i,j,k) = MAX( -dSigmaDrS, GM_Small_Number )

C      This is initially the RHS
          GM_PsiY(i,j,k,bi,bj) = half_K*sigmaY_W
     &       *(GM_bolFac2d(i,j-1,bi,bj)+GM_bolFac2d(i,j,bi,bj))
         ENDDO
        ENDDO
       ENDDO

       DO k=2,Nr
        km1 = k-1
        DO j=1-OLy+1,sNy+OLy
         DO i=1-OLx,sNx+OLx
          IF ( maskS(i,j,km1,bi,bj).NE.zeroRS .AND.
     &         maskS(i,j, k, bi,bj).NE.zeroRS ) THEN
            c2 = MAX( wkb_cS(i,j)*wkb_cS(i,j), GM_BVP_cHat2Min )
            GM_a3d(i,j,k) = -c2*recip_drC(k)
     &                      *recip_drF(km1)*recip_hFacS(i,j,km1,bi,bj)
            GM_b3d(i,j,k) = GM_b3d(i,j,k)
     &                    + c2*recip_drC(k)
     &                     *(recip_drF(km1)*recip_hFacS(i,j,km1,bi,bj)
     &                      +recip_drF(k)*recip_hFacS(i,j,k,bi,bj) )
            GM_c3d(i,j,k) = -c2*recip_drC(k)
     &                      *recip_drF(k)*recip_hFacS(i,j,k,bi,bj)
          ELSE
            GM_b3d(i,j,k) = 1. _d 0
          ENDIF
         ENDDO
        ENDDO
       ENDDO

       errCode = -1
       CALL SOLVE_TRIDIAGONAL( iMin, iMax, jMin+1, jMax,
     &                         GM_a3d, GM_b3d, GM_c3d,
     &                         GM_PsiY(1-OLx,1-OLy,1,bi,bj),
     &                         errCode, bi, bj, myThid )

       IF ( errCode .GT. 0 ) THEN
        WRITE(msgBuf,'(A)')
     &  'S/R GMREDI_CALC_PSI_BVP: matrix singular for PsiY'
        CALL PRINT_ERROR( msgBuf, myThid )
        STOP 'ABNORMAL END: S/R GMREDI_CALC_PSI_BVP'
       ENDIF

#ifdef ALLOW_DIAGNOSTICS
C     Write some diagnostics
       IF ( useDiagnostics ) THEN
        tmpFac = SQRT(gravity/rhoConst)
        CALL DIAGNOSTICS_SCALE_FILL( wkb_cW, tmpFac, 1, 'GM_BVPcW',
     &                               0, 1, 2, bi, bj, myThid )
        CALL DIAGNOSTICS_SCALE_FILL( wkb_cS, tmpFac, 1, 'GM_BVPcS',
     &                               0, 1, 2, bi, bj, myThid )
       ENDIF
#endif

      ENDIF
#endif /* GM_BOLUS_BVP */
#endif /* GM_BOLUS_ADVEC */

      RETURN
      END

#include "MDSIO_OPTIONS.h"

CBOP
C !ROUTINE: MDS_WRITE_FIELD
C !INTERFACE:
      SUBROUTINE MDS_WRITE_FIELD(
     I   fName,
     I   filePrec,
     I   globalFile,
     I   useCurrentDir,
     I   arrType,
     I   kSize,kLo,kHi,
     I   fldRL, fldRS,
     I   jrecord,
     I   myIter,
     I   myThid )

C !DESCRIPTION:
C Arguments:
C
C fName     (string)  :: base name for file to write
C filePrec  (integer) :: number of bits per word in file (32 or 64)
C globalFile (logical):: selects between writing a global or tiled file
C useCurrentDir(logic):: always write to the current directory (even if
C                        "mdsioLocalDir" is set)
C arrType   (char(2)) :: which array (fldRL/RS) to write, either "RL" or "RS"
C kSize     (integer) :: size of third dimension: normally either 1 or Nr
C kLo       (integer) :: 1rst vertical level (of array fldRL/RS) to write
C kHi       (integer) :: last vertical level (of array fldRL/RS) to write
C fldRL       ( RL )  :: array to write if arrType="RL", fldRL(:,:,kSize,:,:)
C fldRS       ( RS )  :: array to write if arrType="RS", fldRS(:,:,kSize,:,:)
C irecord   (integer) :: record number to write
C myIter    (integer) :: time step number
C myThid    (integer) :: thread identifier
C
C MDS_WRITE_FIELD creates either a file of the form "fName.data" and
C  "fName.meta" if the logical flag "globalFile" is set true. Otherwise
C  it creates MDS tiled files of the form "fName.xxx.yyy.data" and
C  "fName.xxx.yyy.meta". If jrecord > 0, a meta-file is created.
C Currently, the meta-files are not read because it is difficult
C  to parse files in fortran. We should read meta information before
C  adding records to an existing multi-record file.
C The precision of the file is described by filePrec, set either
C  to floatPrec32 or floatPrec64. The char*(2) string arrType, either
C  "RL" or "RS", selects which array is written, either fldRL or fldRS.
C (kSize,kLo,kHi) allows for both 2-D and 3-D arrays to be handled, with
C  the option to only write a sub-set of consecutive vertical levels (from
C  kLo to kHi); (kSize,kLo,kHi)=(1,1,1) implies a 2-D model field and
C  (kSize,kLo,kHi)=(Nr,1,Nr) implies a 3-D model field.
C irecord=|jrecord| is the record number to be written and must be >= 1.
C NOTE: It is currently assumed that the highest record number in the file
C  was the last record written. Nor is there a consistency check between the
C  routine arguments and file, i.e., if you write record 2 after record 4
C  the meta information will record the number of records to be 2. This,
C  again, is because we have read the meta information. To be fixed.
C
C- Multi-threaded: Only Master thread does IO (and MPI calls) and get data
C   from a shared buffer that any thread can copy to.
C- Convention regarding thread synchronisation (BARRIER):
C  A per-thread (or per tile) partition of the 2-D shared-buffer (sharedLocBuf_r4/r8)
C   is readily available => any access (e.g., by master-thread) to a portion
C   owned by an other thread is put between BARRIER (protected).
C  No thread partition exist for the 3-D shared buffer (shared3dBuf_r4/r8);
C   Therefore, the 3-D buffer is considered to be owned by master-thread and
C   any access by other than master thread is put between BARRIER (protected).
C
C Created: 03/16/99 adcroft@mit.edu
C Changed: 01/06/02 menemenlis@jpl.nasa.gov
C          added useSingleCpuIO hack
C changed:  1/23/04 afe@ocean.mit.edu
C          added exch2 handling -- yes, the globalfile logic is nuts
CEOP

C !USES:
      IMPLICIT NONE
C Global variables / common blocks
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#ifdef ALLOW_EXCH2
# include "W2_EXCH2_SIZE.h"
# include "W2_EXCH2_TOPOLOGY.h"
# include "W2_EXCH2_PARAMS.h"
#endif /* ALLOW_EXCH2 */
#include "EEBUFF_SCPU.h"
#ifdef ALLOW_FIZHI
# include "fizhi_SIZE.h"
#endif /* ALLOW_FIZHI */
#include "MDSIO_BUFF_3D.h"

C !INPUT PARAMETERS:
      CHARACTER*(*) fName
      INTEGER filePrec
      LOGICAL globalFile
      LOGICAL useCurrentDir
      CHARACTER*(2) arrType
      INTEGER kSize, kLo, kHi
      _RL fldRL(*)
      _RS fldRS(*)
      INTEGER jrecord
      INTEGER myIter
      INTEGER myThid
C !OUTPUT PARAMETERS:

C !FUNCTIONS
      INTEGER  ILNBLNK
      INTEGER  MDS_RECLEN
      LOGICAL  MASTER_CPU_IO
      EXTERNAL ILNBLNK
      EXTERNAL MDS_RECLEN
      EXTERNAL MASTER_CPU_IO

C !LOCAL VARIABLES:
C     bBij  :: base shift in Buffer index for tile bi,bj
      CHARACTER*(MAX_LEN_FNAM) dataFName,metaFName,pfName
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      LOGICAL fileIsOpen
      LOGICAL iAmDoingIO
      LOGICAL writeMetaF
      LOGICAL useExch2ioLayOut
      LOGICAL zeroBuff
      INTEGER xSize, ySize
      INTEGER irecord
      INTEGER iG,jG,bi,bj
      INTEGER i1,i2,i,j,k,nNz
      INTEGER irec,dUnit,IL,pIL
      INTEGER dimList(3,3), nDims, map2gl(2)
      INTEGER length_of_rec
      INTEGER bBij
      INTEGER tNx, tNy, global_nTx
      INTEGER tBx, tBy, iGjLoc, jGjLoc
#ifdef ALLOW_EXCH2
      INTEGER tN
#endif /* ALLOW_EXCH2 */
      _RL dummyRL(1)
      CHARACTER*8 blank8c

      DATA dummyRL(1) / 0. _d 0 /
      DATA blank8c / '        ' /

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C Set dimensions:
      xSize = Nx
      ySize = Ny
      useExch2ioLayOut = .FALSE.
#ifdef ALLOW_EXCH2
      IF ( W2_useE2ioLayOut ) THEN
        xSize = exch2_global_Nx
        ySize = exch2_global_Ny
        useExch2ioLayOut = .TRUE.
      ENDIF
#endif /* ALLOW_EXCH2 */

C-    default:
      iGjLoc = 0
      jGjLoc = 1

C Assume nothing
      fileIsOpen = .FALSE.
      IL  = ILNBLNK( fName )
      pIL = ILNBLNK( mdsioLocalDir )
      nNz = 1 + kHi - kLo
      irecord = ABS(jrecord)
      writeMetaF = jrecord.GT.0

C Only do I/O if I am the master thread (and mpi process 0 IF useSingleCpuIO):
      iAmDoingIO = MASTER_CPU_IO(myThid)

C File name should not be too long:
C    IL(+pIL if not useCurrentDir)(+5: '.data')(+8: bi,bj) =< MAX_LEN_FNAM
C    and shorter enough to be written to msgBuf with other informations
      IF ( useCurrentDir .AND. (90+IL).GT.MAX_LEN_MBUF ) THEN
        WRITE(msgBuf,'(2A,2(I4,A))') 'MDS_WRITE_FIELD: ',
     &   'Too long (IL=',IL,') file name:'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(errorMessageUnit,'(3A)')'file: >',fName(1:IL),'<'
        CALL ALL_PROC_DIE( myThid )
        STOP 'ABNORMAL END: S/R MDS_WRITE_FIELD'
      ELSEIF ( (90+IL+pIL).GT.MAX_LEN_MBUF ) THEN
        WRITE(msgBuf,'(2A,2(I4,A))') 'MDS_WRITE_FIELD: ',
     &   'Too long (pIL=',pIL,', IL=',IL,') pfix + file name:'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(errorMessageUnit,'(3A)')'pfix: >',mdsioLocalDir(1:pIL),'<'
        WRITE(errorMessageUnit,'(3A)')'file: >',fName(1:IL),'<'
        CALL ALL_PROC_DIE( myThid )
        STOP 'ABNORMAL END: S/R MDS_WRITE_FIELD'
      ENDIF
C Record number must be >= 1
      IF (irecord .LT. 1) THEN
        WRITE(msgBuf,'(3A,I10)')
     &    ' MDS_WRITE_FIELD: file="', fName(1:IL), '" , iter=', myIter
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
        WRITE(msgBuf,'(A,I9.8)')
     &    ' MDS_WRITE_FIELD: argument irecord = ',irecord
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
        WRITE(msgBuf,'(A)')
     &    ' MDS_WRITE_FIELD: invalid value for irecord'
        CALL PRINT_ERROR( msgBuf, myThid )
        CALL ALL_PROC_DIE( myThid )
        STOP 'ABNORMAL END: S/R MDS_WRITE_FIELD'
      ENDIF
C check for valid sub-set of levels:
      IF ( kLo.LT.1 .OR. kHi.GT.kSize ) THEN
        WRITE(msgBuf,'(3A,I10)')
     &    ' MDS_WRITE_FIELD: file="', fName(1:IL), '" , iter=', myIter
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
        WRITE(msgBuf,'(3(A,I6))')
     &    ' MDS_WRITE_FIELD: arguments kSize=', kSize,
     &    ' , kLo=', kLo, ' , kHi=', kHi
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
        WRITE(msgBuf,'(A)')
     &    ' MDS_WRITE_FIELD: invalid sub-set of levels'
        CALL PRINT_ERROR( msgBuf, myThid )
        CALL ALL_PROC_DIE( myThid )
        STOP 'ABNORMAL END: S/R MDS_WRITE_FIELD'
      ENDIF
C check for 3-D Buffer size:
      IF ( .NOT.useSingleCpuIO .AND. nNz.GT.size3dBuf ) THEN
        WRITE(msgBuf,'(3A,I10)')
     &    ' MDS_WRITE_FIELD: file="', fName(1:IL), '" , iter=', myIter
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
        WRITE(msgBuf,'(3(A,I6))')
     &    ' MDS_WRITE_FIELD: Nb Lev to write =', nNz,
     &    ' >', size3dBuf, ' = buffer 3rd Dim'
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
        WRITE(msgBuf,'(A)')
     &    ' MDS_WRITE_FIELD: buffer 3rd Dim. too small'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(A)')
     &    ' increase "size3dBuf" in "MDSIO_BUFF_3D.h" and recompile'
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                      SQUEEZE_RIGHT, myThid)
        CALL ALL_PROC_DIE( myThid )
        STOP 'ABNORMAL END: S/R MDS_WRITE_FIELD'
      ENDIF

C Only do I/O if I am the master thread
      IF ( iAmDoingIO ) THEN

C Assign special directory
        IF ( useCurrentDir .OR. pIL.EQ.0 ) THEN
         pfName = fName
        ELSE
         WRITE(pfName,'(2A)') mdsioLocalDir(1:pIL), fName(1:IL)
        ENDIF
        pIL=ILNBLNK( pfName )
        IF ( debugLevel .GE. debLevC ) THEN
          WRITE(msgBuf,'(A,I8,I6,3I4,2A)')
     &      ' MDS_WRITE_FIELD: it,rec,kS,kL,kH=', myIter, jrecord,
     &      kSize, kLo, kHi, ' file=', pfName(1:pIL)
          CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                        SQUEEZE_RIGHT, myThid )
        ENDIF

C Assign a free unit number as the I/O channel for this routine
        CALL MDSFINDUNIT( dUnit, myThid )

C- endif iAmDoingIO
      ENDIF

C If option globalFile is desired but does not work or if
C globalFile is too slow, then try using single-CPU I/O.
      IF (useSingleCpuIO) THEN

C Master thread of process 0, only, opens a global file
       IF ( iAmDoingIO ) THEN
         WRITE(dataFName,'(2a)') fName(1:IL),'.data'
         length_of_rec = MDS_RECLEN( filePrec, xSize*ySize, myThid )
         IF (irecord .EQ. 1) THEN
          OPEN( dUnit, file=dataFName, status=_NEW_STATUS,
     &        access='direct', recl=length_of_rec )
         ELSE
          OPEN( dUnit, file=dataFName, status=_OLD_STATUS,
     &        access='direct', recl=length_of_rec )
         ENDIF
       ENDIF

C Gather array and write it to file, one vertical level at a time
       DO k=kLo,kHi
        zeroBuff = k.EQ.kLo
C-      copy from fldRL/RS(level=k) to 2-D "local":
        IF ( filePrec.EQ.precFloat32 ) THEN
          IF ( arrType.EQ.'RS' ) THEN
            CALL MDS_PASS_R4toRS( sharedLocBuf_r4, fldRS,
     I                 0, 0, 1, k, kSize, 0, 0, .FALSE., myThid )
          ELSEIF ( arrType.EQ.'RL' ) THEN
            CALL MDS_PASS_R4toRL( sharedLocBuf_r4, fldRL,
     I                 0, 0, 1, k, kSize, 0, 0, .FALSE., myThid )
          ELSE
            WRITE(msgBuf,'(2A)')
     &      ' MDS_WRITE_FIELD: illegal value for arrType=', arrType
            CALL PRINT_ERROR( msgBuf, myThid )
            CALL ALL_PROC_DIE( myThid )
            STOP 'ABNORMAL END: S/R MDS_WRITE_FIELD'
          ENDIF
C Wait for all threads to finish filling shared buffer
          CALL BAR2( myThid )
          CALL GATHER_2D_R4(
     O                       xy_buffer_r4,
     I                       sharedLocBuf_r4,
     I                       xSize, ySize,
     I                       useExch2ioLayOut, zeroBuff, myThid )
        ELSEIF ( filePrec.EQ.precFloat64 ) THEN
          IF ( arrType.EQ.'RS' ) THEN
            CALL MDS_PASS_R8toRS( sharedLocBuf_r8, fldRS,
     I                 0, 0, 1, k, kSize, 0, 0, .FALSE., myThid )
          ELSEIF ( arrType.EQ.'RL' ) THEN
            CALL MDS_PASS_R8toRL( sharedLocBuf_r8, fldRL,
     I                 0, 0, 1, k, kSize, 0, 0, .FALSE., myThid )
          ELSE
            WRITE(msgBuf,'(2A)')
     &      ' MDS_WRITE_FIELD: illegal value for arrType=', arrType
            CALL PRINT_ERROR( msgBuf, myThid )
            CALL ALL_PROC_DIE( myThid )
            STOP 'ABNORMAL END: S/R MDS_WRITE_FIELD'
          ENDIF
C Wait for all threads to finish filling shared buffer
          CALL BAR2( myThid )
          CALL GATHER_2D_R8(
     O                       xy_buffer_r8,
     I                       sharedLocBuf_r8,
     I                       xSize, ySize,
     I                       useExch2ioLayOut, zeroBuff, myThid )
        ELSE
          WRITE(msgBuf,'(A,I6)')
     &      ' MDS_WRITE_FIELD: illegal value for filePrec=',filePrec
          CALL PRINT_ERROR( msgBuf, myThid )
          CALL ALL_PROC_DIE( myThid )
          STOP 'ABNORMAL END: S/R MDS_WRITE_FIELD'
        ENDIF
C Make other threads wait for "gather" completion so that after this,
C  shared buffer can again be modified by any thread
        CALL BAR2( myThid )

        IF ( iAmDoingIO ) THEN
          irec = 1 + k-kLo + (irecord-1)*nNz
          IF ( filePrec.EQ.precFloat32 ) THEN
#ifdef _BYTESWAPIO
           CALL MDS_BYTESWAPR4( xSize*ySize, xy_buffer_r4 )
#endif
           WRITE(dUnit,rec=irec) ( xy_buffer_r4(i),i=1,xSize*ySize )
          ELSE
#ifdef _BYTESWAPIO
           CALL MDS_BYTESWAPR8( xSize*ySize, xy_buffer_r8 )
#endif
           WRITE(dUnit,rec=irec) ( xy_buffer_r8(i),i=1,xSize*ySize )
          ENDIF
C-      end if iAmDoingIO
        ENDIF
C-     end of k loop
       ENDDO

C Close data-file
       IF ( iAmDoingIO ) THEN
         CLOSE( dUnit )
       ENDIF

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C---  else .NOT.useSingleCpuIO
      ELSE

C Wait for all thread to finish. This prevents other threads (e.g., master)
C  to continue to acces 3-D buffer while this thread is filling it.
        CALL BAR2( myThid )

C---    Copy from fldRL/RS to 3-D buffer (multi-threads):
        IF ( filePrec.EQ.precFloat32 ) THEN
          IF ( arrType.EQ.'RS' ) THEN
            CALL MDS_PASS_R4toRS( shared3dBuf_r4, fldRS,
     I              0, 0, nNz, kLo, kSize, 0,0, .FALSE., myThid )
          ELSEIF ( arrType.EQ.'RL' ) THEN
            CALL MDS_PASS_R4toRL( shared3dBuf_r4, fldRL,
     I              0, 0, nNz, kLo, kSize, 0,0, .FALSE., myThid )
          ELSE
            WRITE(msgBuf,'(2A)')
     &      ' MDS_WRITE_FIELD: illegal value for arrType=', arrType
            CALL PRINT_ERROR( msgBuf, myThid )
            CALL ALL_PROC_DIE( myThid )
            STOP 'ABNORMAL END: S/R MDS_WRITE_FIELD'
          ENDIF
        ELSEIF ( filePrec.EQ.precFloat64 ) THEN
          IF ( arrType.EQ.'RS' ) THEN
            CALL MDS_PASS_R8toRS( shared3dBuf_r8, fldRS,
     I              0, 0, nNz, kLo, kSize, 0,0, .FALSE., myThid )
          ELSEIF ( arrType.EQ.'RL' ) THEN
            CALL MDS_PASS_R8toRL( shared3dBuf_r8, fldRL,
     I              0, 0, nNz, kLo, kSize, 0,0, .FALSE., myThid )
          ELSE
            WRITE(msgBuf,'(2A)')
     &      ' MDS_WRITE_FIELD: illegal value for arrType=', arrType
            CALL PRINT_ERROR( msgBuf, myThid )
            CALL ALL_PROC_DIE( myThid )
            STOP 'ABNORMAL END: S/R MDS_WRITE_FIELD'
          ENDIF
        ELSE
          WRITE(msgBuf,'(A,I6)')
     &      ' MDS_WRITE_FIELD: illegal value for filePrec=',filePrec
          CALL PRINT_ERROR( msgBuf, myThid )
          CALL ALL_PROC_DIE( myThid )
          STOP 'ABNORMAL END: S/R MDS_WRITE_FIELD'
        ENDIF

C Wait for all threads to finish filling shared buffer
       CALL BAR2( myThid )

C Only do I/O if I am the master thread
       IF ( iAmDoingIO ) THEN

#ifdef _BYTESWAPIO
        IF ( filePrec.EQ.precFloat32 ) THEN
          CALL MDS_BYTESWAPR4( sNx*sNy*nNz*nSx*nSy, shared3dBuf_r4 )
        ELSE
          CALL MDS_BYTESWAPR8( sNx*sNy*nNz*nSx*nSy, shared3dBuf_r8 )
        ENDIF
#endif

C If we are writing to a global file then we open it here
        IF (globalFile) THEN
          WRITE(dataFName,'(2a)') fName(1:IL),'.data'
          length_of_rec = MDS_RECLEN( filePrec, sNx, myThid )
          IF (irecord .EQ. 1) THEN
           OPEN( dUnit, file=dataFName, status=_NEW_STATUS,
     &             access='direct', recl=length_of_rec )
          ELSE
           OPEN( dUnit, file=dataFName, status=_OLD_STATUS,
     &             access='direct', recl=length_of_rec )
          ENDIF
          fileIsOpen=.TRUE.
        ENDIF

C Loop over all tiles
        DO bj=1,nSy
         DO bi=1,nSx
          bBij = sNx*sNy*nNz*( bi-1 + (bj-1)*nSx )

          tNx = sNx
          tNy = sNy
          global_nTx = xSize/sNx
          tBx = myXGlobalLo-1 + (bi-1)*sNx
          tBy = myYGlobalLo-1 + (bj-1)*sNy
#ifdef ALLOW_EXCH2
          IF ( useExch2ioLayOut ) THEN
            tN = W2_myTileList(bi,bj)
c           tNx = exch2_tNx(tN)
c           tNy = exch2_tNy(tN)
c           global_nTx = exch2_global_Nx/tNx
            tBx = exch2_txGlobalo(tN) - 1
            tBy = exch2_tyGlobalo(tN) - 1
            IF   ( exch2_mydNx(tN) .GT. xSize ) THEN
C-          face x-size larger than glob-size : fold it
              iGjLoc = 0
              jGjLoc = exch2_mydNx(tN) / xSize
            ELSEIF ( exch2_tNy(tN) .GT. ySize ) THEN
C-          tile y-size larger than glob-size : make a long line
              iGjLoc = exch2_mydNx(tN)
              jGjLoc = 0
            ELSE
C-          default (face fit into global-IO-array)
              iGjLoc = 0
              jGjLoc = 1
            ENDIF
          ENDIF
#endif /* ALLOW_EXCH2 */

          IF (globalFile) THEN
C--- Case of 1 Global file:

           DO k=kLo,kHi
            DO j=1,tNy
             irec = 1 + ( tBx + (j-1)*iGjLoc )/tNx
     &                + ( tBy + (j-1)*jGjLoc )*global_nTx
     &            +( k-kLo + (irecord-1)*nNz )*global_nTx*ySize
             i1 = bBij + 1 + (j-1)*sNx + (k-kLo)*sNx*sNy
             i2 = bBij +         j*sNx + (k-kLo)*sNx*sNy
             IF ( filePrec.EQ.precFloat32 ) THEN
              WRITE(dUnit,rec=irec) (shared3dBuf_r4(i),i=i1,i2)
             ELSE
              WRITE(dUnit,rec=irec) (shared3dBuf_r8(i),i=i1,i2)
             ENDIF
C End of j,k loops
            ENDDO
           ENDDO

          ELSE
C--- Case of 1 file per tile (globalFile=F):

C If we are writing to a tiled MDS file then we open each one here
           iG=bi+(myXGlobalLo-1)/sNx
           jG=bj+(myYGlobalLo-1)/sNy
           WRITE(dataFName,'(2A,I3.3,A,I3.3,A)')
     &            pfName(1:pIL),'.',iG,'.',jG,'.data'
           length_of_rec = MDS_RECLEN( filePrec, sNx*sNy*nNz, myThid )
           IF (irecord .EQ. 1) THEN
            OPEN( dUnit, file=dataFName, status=_NEW_STATUS,
     &            access='direct', recl=length_of_rec )
           ELSE
            OPEN( dUnit, file=dataFName, status=_OLD_STATUS,
     &            access='direct', recl=length_of_rec )
           ENDIF
           fileIsOpen=.TRUE.

           irec = irecord
           i1 = bBij + 1
           i2 = bBij + sNx*sNy*nNz
           IF ( filePrec.EQ.precFloat32 ) THEN
             WRITE(dUnit,rec=irec) (shared3dBuf_r4(i),i=i1,i2)
           ELSE
             WRITE(dUnit,rec=irec) (shared3dBuf_r8(i),i=i1,i2)
           ENDIF

C here We close the tiled MDS file
           IF ( fileIsOpen ) THEN
             CLOSE( dUnit )
             fileIsOpen = .FALSE.
           ENDIF

C--- End Global File / tile-file cases
          ENDIF

C Create meta-file for each tile if we are tiling
          IF ( .NOT.globalFile .AND. writeMetaF ) THEN
           iG=bi+(myXGlobalLo-1)/sNx
           jG=bj+(myYGlobalLo-1)/sNy
           WRITE(metaFname,'(2A,I3.3,A,I3.3,A)')
     &              pfName(1:pIL),'.',iG,'.',jG,'.meta'
           dimList(1,1) = xSize
           dimList(2,1) = tBx + 1
           dimList(3,1) = tBx + tNx
           dimList(1,2) = ySize
           dimList(2,2) = tBy + 1
           dimList(3,2) = tBy + tNy
           dimList(1,3) = nNz
           dimList(2,3) = 1
           dimList(3,3) = nNz
c          dimList(1,3) = kSize
c          dimList(2,3) = kLo
c          dimList(3,3) = kHi
           nDims = 3
           IF ( nNz.EQ.1 ) nDims = 2
           map2gl(1) = iGjLoc
           map2gl(2) = jGjLoc
           CALL MDS_WRITE_META(
     I              metaFName, dataFName, the_run_name, ' ',
     I              filePrec, nDims, dimList, map2gl, 0, blank8c,
     I              0, dummyRL, oneRL, irecord, myIter, myThid )
          ENDIF

C End of bi,bj loops
         ENDDO
        ENDDO

C If global file was opened then close it
        IF (fileIsOpen .AND. globalFile) THEN
          CLOSE( dUnit )
          fileIsOpen = .FALSE.
        ENDIF

C- endif iAmDoingIO
       ENDIF

C Make other threads wait for I/O completion so that after this,
C  3-D buffer can again be modified by any thread
c      CALL BAR2( myThid )

C     if useSingleCpuIO / else / end
      ENDIF

C Create meta-file for the global-file (also if useSingleCpuIO)
      IF ( writeMetaF .AND. iAmDoingIO .AND.
     &    (globalFile .OR. useSingleCpuIO) ) THEN
         WRITE(metaFName,'(2A)') fName(1:IL),'.meta'
         dimList(1,1) = xSize
         dimList(2,1) = 1
         dimList(3,1) = xSize
         dimList(1,2) = ySize
         dimList(2,2) = 1
         dimList(3,2) = ySize
         dimList(1,3) = nNz
         dimList(2,3) = 1
         dimList(3,3) = nNz
c        dimList(1,3) = kSize
c        dimList(2,3) = kLo
c        dimList(3,3) = kHi
         nDims = 3
         IF ( nNz.EQ.1 ) nDims = 2
         map2gl(1) = 0
         map2gl(2) = 1
         CALL MDS_WRITE_META(
     I              metaFName, dataFName, the_run_name, ' ',
     I              filePrec, nDims, dimList, map2gl, 0, blank8c,
     I              0, dummyRL, oneRL, irecord, myIter, myThid )
c    I              metaFName, dataFName, the_run_name, titleLine,
c    I              filePrec, nDims, dimList, map2gl, nFlds,  fldList,
c    I              nTimRec, timList, misVal, irecord, myIter, myThid )
      ENDIF

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
      RETURN
      END

#include "CPP_EEOPTIONS.h"

CBOP
C     !ROUTINE: EXCH_INIT

C     !INTERFACE:
      SUBROUTINE EXCH_INIT

C     !DESCRIPTION:
C     *==========================================================*
C     | SUBROUTINE EXCH\_INIT
C     | o Initialise WRAPPER exchange data structures.
C     *==========================================================*

C     !USES:
      IMPLICIT NONE
C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "EESUPPORT.h"
#include "EXCH.h"

C     !LOCAL VARIABLES:
C     == Local variables ==
C     bi, bj :: Tile indices
      INTEGER bi, bj
CEOP

      DO bj=1,nSy
       DO bi=1,nSx
        exchangeBufLevel  (1,bi,bj) = 1
        exchRecvXSpinCount(1,bi,bj) = 0
        exchRecvXSpinMax  (1,bi,bj) = 0
        exchRecvXSpinMin  (1,bi,bj) = 1000000000
        exchRecvYSpinCount(1,bi,bj) = 0
        exchRecvYSpinMax  (1,bi,bj) = 0
        exchRecvYSpinMin  (1,bi,bj) = 1000000000
       ENDDO
      ENDDO

      RETURN
      END

#include "CAL_OPTIONS.h"

      subroutine cal_CopyDate(
     I                         indate,
     O                         outdate,
     I                         mythid
     &                       )

c     ==================================================================
c     SUBROUTINE cal_CopyDate
c     ==================================================================
c
c     o Copy a date array or a time interval array to another date array
c       or time interval array.
c              
c     started: Christian Eckert eckert@mit.edu  03-Jan-1999
c
c              - Introduced to calendar version 0.1.1
c
c     changed: Christian Eckert eckert@mit.edu  03-Feb-2000
c
c              - Introduced new routine and function names, cal_<NAME>,
c                for verion 0.1.3.
c
c     ==================================================================
c     SUBROUTINE cal_CopyDate
c     ==================================================================

      implicit none

c     == global variables ==

#include "cal.h"

c     == routine arguments ==

      integer indate(4)
      integer outdate(4)
      integer mythid

c     == local variables ==

c     == end of interface ==

      outdate(1) = indate(1)
      outdate(2) = indate(2)
      outdate(3) = indate(3)
      outdate(4) = indate(4)

      return
      end

#include "MOM_FLUXFORM_OPTIONS.h"

CBOP
C !ROUTINE: MOM_U_CORIOLIS

C !INTERFACE: ==========================================================
      SUBROUTINE MOM_U_CORIOLIS(
     I        bi, bj, k, vFld,
     U        uCoriolisTerm,
     I        myThid )

C !DESCRIPTION:
C Calculates the horizontal Coriolis term in the zonal equation:
C \begin{equation*}
C \overline{f}^i \overline{v}^{ij}
C \end{equation*}

C !USES: ===============================================================
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "SURFACE.h"

C !INPUT PARAMETERS: ===================================================
C  bi, bj               :: tile indices
C  k                    :: vertical level
C  vFld                 :: meridional flow
C  myThid               :: thread number
      INTEGER bi, bj, k
      _RL vFld(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER myThid

C !OUTPUT PARAMETERS: ==================================================
C  uCoriolisTerm        :: Coriolis term
      _RL uCoriolisTerm(1-OLx:sNx+OLx,1-OLy:sNy+OLy)

C !LOCAL VARIABLES: ====================================================
C  i,j                  :: loop indices
      INTEGER i, j
CEOP

      IF ( selectCoriScheme.LE.1 ) THEN
C-    Original discretization
       DO j=1-OLy,sNy+OLy-1
        DO i=1-OLx+1,sNx+OLx
         uCoriolisTerm(i,j) = halfRL
     &   *( _fCori( i ,j,bi,bj) + _fCori(i-1,j,bi,bj) )
     &   *0.25 _d 0*( vFld( i ,j) + vFld( i ,j+1)
     &              + vFld(i-1,j) + vFld(i-1,j+1)
     &              )
        ENDDO
       ENDDO
      ELSEIF ( selectCoriScheme.LE.3 ) THEN
C-    Energy conserving discretization
       DO j=1-OLy,sNy+OLy-1
        DO i=1-OLx+1,sNx+OLx
         uCoriolisTerm(i,j) = halfRL
     &        *( _fCori( i ,j,bi,bj)
     &          *halfRL*( vFld( i ,j) + vFld( i ,j+1) )
     &         + _fCori(i-1,j,bi,bj)
     &          *halfRL*( vFld(i-1,j) + vFld(i-1,j+1) ) )
        ENDDO
       ENDDO
      ELSE
C-    Using averaged transport:
       DO j=1-OLy,sNy+OLy-1
        DO i=1-OLx+1,sNx+OLx
         uCoriolisTerm(i,j) = halfRL
     &   *( _fCori( i ,j,bi,bj) + _fCori(i-1,j,bi,bj) )
     &   *( vFld( i , j )*dxG( i , j ,bi,bj)*hFacS( i , j ,k,bi,bj)
     &    + vFld( i ,j+1)*dxG( i ,j+1,bi,bj)*hFacS( i ,j+1,k,bi,bj)
     &    + vFld(i-1, j )*dxG(i-1, j ,bi,bj)*hFacS(i-1, j ,k,bi,bj)
     &    + vFld(i-1,j+1)*dxG(i-1,j+1,bi,bj)*hFacS(i-1,j+1,k,bi,bj)
     &    )*0.25 _d 0*recip_dxC(i,j,bi,bj)*recip_hFacW(i,j,k,bi,bj)
        ENDDO
       ENDDO
      ENDIF

      IF ( selectCoriScheme.EQ.1 .OR. selectCoriScheme.EQ.3 ) THEN
C-    Scale term so that only "wet" points are used
C     Due to: Jamart and Ozer, 1986, JGR 91 (C9), 10,621-10,631
C         "Numerical Boundary Layers and Spurious Residual Flows"
       DO j=1-OLy,sNy+OLy-1
        DO i=1-OLx+1,sNx+OLx
         uCoriolisTerm(i,j) = uCoriolisTerm(i,j)
     &   *4. _d 0/MAX( oneRS,
     &                 maskS( i , j ,k,bi,bj)+maskS( i ,j+1,k,bi,bj)
     &                +maskS(i-1, j ,k,bi,bj)+maskS(i-1,j+1,k,bi,bj) )
        ENDDO
       ENDDO
      ENDIF

      RETURN
      END

#include "AUTODIFF_OPTIONS.h"
#ifdef ALLOW_CTRL
# include "CTRL_OPTIONS.h"
#endif

C--  File dummy_in_hfac.F:
C--   Contents
C--   o DUMMY_IN_HFAC
C--   o ADDUMMY_IN_HFAC

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: DUMMY_IN_HFAC
C     !INTERFACE:
      SUBROUTINE DUMMY_IN_HFAC( myName, myIter, myThid )

C     !DESCRIPTION: \bv
C     Forward S/R is empty
C     \ev

C     !USES:
      IMPLICIT NONE
C     == Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     myThid :: Thread number for this instance of the routine.
      CHARACTER*(*) myName
      INTEGER myIter
      INTEGER myThid
CEOP

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: ADDUMMY_IN_HFAC
C     !INTERFACE:
      SUBROUTINE ADDUMMY_IN_HFAC( myName, myIter, myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE addummy_in_hfac
C     *==========================================================*
C     Extract adjoint variable from TAMC/TAF-generated
C     adjoint common blocks, contained in adcommon.h
C     and write fields to file;
C     Make sure common blocks in adcommon.h are up-to-date
C     w.r.t. current adjoint code.
C     *==========================================================*
C     | SUBROUTINE addummy_in_hfac
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     == Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#ifdef ALLOW_AUTODIFF_MONITOR
#include "adcommon.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     myThid :: Thread number for this instance of the routine.
      CHARACTER*(1) myName
      INTEGER myIter
      INTEGER myThid

#ifdef ALLOW_AUTODIFF_MONITOR
#ifdef ALLOW_DEPTH_CONTROL
C     !FUNCTIONS:
      LOGICAL  DIFFERENT_MULTIPLE
      EXTERNAL DIFFERENT_MULTIPLE
      INTEGER  IO_ERRCOUNT
      EXTERNAL IO_ERRCOUNT

C     !LOCAL VARIABLES:
C     suff            :: Hold suffix part of a filename
C     beginIOErrCount :: Begin IO error counts
C     endIOErrCount   :: End IO error counts
C     msgBuf          :: Error message buffer
      CHARACTER*(MAX_LEN_FNAM) suff
      INTEGER beginIOErrCount
      INTEGER endIOErrCount
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      _RL myTime
      CHARACTER*(5) myFullName
CEOP

      myTime = 0.

      IF ( DIFFERENT_MULTIPLE( dumpFreq, myTime, myTime-deltaTClock )
     &   ) THEN

        CALL TIMER_START('I/O (WRITE)        [ADJOINT LOOP]', myThid )

C--     Set suffix for this set of data files.
        WRITE(suff,'(I10.10)') myIter

C--     Read IO error counter
        beginIOErrCount = IO_ERRCOUNT(myThid)

        IF ( myName .EQ. 'C' ) THEN
          myFullName = 'hFacC'
          CALL WRITE_FLD_XYZ_RL( 'ADJhFacC.', suff, adhfacc,
     &                           myIter, myThid )
        ELSE IF ( myName .EQ. 'W' ) THEN
          myFullName = 'hFacW'
          CALL WRITE_FLD_XYZ_RL( 'ADJhFacW.', suff, adhfacw,
     &                           myIter, myThid )
        ELSE IF ( myName .EQ. 'S' ) THEN
          myFullName = 'hFacS'
          CALL WRITE_FLD_XYZ_RL( 'ADJhFacS.', suff, adhfacs,
     &                           myIter, myThid )
        ELSE
          WRITE(*,*) 'addummy_in_hfac: no valid myName specified'
        END IF
C--     Reread IO error counter
        endIOErrCount = IO_ERRCOUNT(myThid)

C--     Check for IO errors
        IF ( endIOErrCount .NE. beginIOErrCount ) THEN
          WRITE(msgBuf,'(A)')  'S/R WRITE_STATE'
          CALL PRINT_ERROR( msgBuf, myThid )
          WRITE(msgBuf,'(A)')  'Error writing out model state'
          CALL PRINT_ERROR( msgBuf, myThid )
          WRITE(msgBuf,'(A,I10)') 'Timestep ',myIter
          CALL PRINT_ERROR( msgBuf, myThid )
        ELSE
          WRITE(msgBuf,'(A,I10)')
     &     '// ad'//myFullName//' written, timestep', myIter
          CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                        SQUEEZE_RIGHT, myThid )
          WRITE(msgBuf,'(A)')  ' '
          CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                        SQUEEZE_RIGHT, myThid )
        ENDIF

        CALL TIMER_STOP( 'I/O (WRITE)        [ADJOINT LOOP]', myThid )

      ENDIF

#endif /* ALLOW_DEPTH_CONTROL */
#endif /* ALLOW_AUTODIFF_MONITOR */

      RETURN
      END

#include "CHEAPAML_OPTIONS.h"

C     !ROUTINE: CHEAPAML_FIELDS_LOAD
C     !INTERFACE:
      SUBROUTINE CHEAPAML_FIELDS_LOAD( myTime, myIter, myThid )
C     *==========================================================*
C     | SUBROUTINE CHEAPAML_FIELDS_LOAD
C     | o Control reading of fields from external source.
C     *==========================================================*

C     !USES:
      IMPLICIT NONE
C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "FFIELDS.h"
#include "CHEAPAML.h"

C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
C     myIter :: Simulation timestep number
C     myTime :: Simulation time
C     myThid :: Thread no. that called this routine.
      _RL     myTime
      INTEGER myIter
      INTEGER myThid

C     !LOCAL VARIABLES:
C     === in common block ===
C     trair[01]   :: Relaxation temp. profile for air temperature
C     qrair[01]   :: Relaxation specific humidity profile for air
C     solar[01]   :: short wave flux
C     uWind[01]   :: wind speed [m/s], u-component (on C-grid)
C     vWind[01]   :: wind speed [m/s], v-component (on C-grid)
C     ustress[01] :: wind stress [N/m2], u-component (on A-grid)
C     vstress[01] :: wind stress [N/m2], v-component (on A-grid)
C     wavesh[01]  ::
C     wavesp[01]  ::
C     rair[01]    ::
C     CheaptracerR[01] :: Relaxation profile for passive tracer

      COMMON /BULKFFIELDS/
     &         trair0,   trair1,
     &         qrair0,   qrair1,
     &         Solar0,   Solar1,
     &         uWind0,   uWind1,
     &         vWind0,   vWind1,
     &         ustress0, ustress1,
     &         vstress0, vstress1,
     &         wavesh0,  wavesh1,
     &         wavesp0,  wavesp1,
c    &         rair0,    rair1,
     &         CheaptracerR0, CheaptracerR1,
     &         cheaph0, cheaph1,
     &         cheapcl0, cheapcl1,
     &         cheaplw0, cheaplw1,
     &         cheappr0, cheappr1

      _RL  trair0    (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL  trair1    (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL  qrair0    (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL  qrair1    (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL  Solar0    (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL  Solar1    (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL  uWind0    (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL  uWind1    (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL  vWind0    (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL  vWind1    (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL  ustress0  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL  ustress1  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL  vstress0  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL  vstress1  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL  wavesh0  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL  wavesh1  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL  wavesp0  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL  wavesp1  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
c     _RL  rair0  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
c     _RL  rair1  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL  CheaptracerR0 (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL  CheaptracerR1 (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL  cheaph0   (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL  cheaph1   (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL  cheapcl0   (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL  cheapcl1   (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL  cheaplw0   (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL  cheaplw1   (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL  cheappr0   (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL  cheappr1   (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)

C     === Local arrays ===
C     cheaph[01]  ::
C     cheapcl[01] ::
C     cheaplw[01] ::
C     aWght,bWght :: Interpolation weights

      _RL aWght, bWght

      INTEGER bi, bj
      INTEGER i, j, iG, jG
      INTEGER intimeP, intime0, intime1
      _RL recipNym1, local, u, ssqa

      recipNym1 = Ny - 1
      IF ( Ny.GT.1 ) recipNym1 = 1. _d 0 / recipNym1

      IF ( periodicExternalForcing_cheap ) THEN

C the objective here is to give cheapaml a default periodic forcing
C consisting only of annually varying solar forcing, and thus Trelaxation
C variation.  everything else, relative humidity, wind, are fixed.  This
C keys off of solardata.  if a solar data file exists, the model will
C assume there are files to be read and interpolated between, as is standard
C for the MITgcm.

        IF ( useStressOption ) THEN
          WRITE(*,*)' stress option is turned on.  this is not ',
     &       'consistent with the default time dependent forcing option'
          STOP
        ENDIF

C here for usual interpolative forcings
C First call requires that we initialize everything to zero for safety
        IF ( myIter .EQ. nIter0 ) THEN
         DO bj = myByLo(myThid), myByHi(myThid)
          DO bi = myBxLo(myThid), myBxHi(myThid)
           DO j=1-OLy,sNy+OLy
            DO i=1-OLx,sNx+OLx
             trair0  (i,j,bi,bj) = 0.
             trair1  (i,j,bi,bj) = 0.
             qrair0  (i,j,bi,bj) = 0.
             qrair1  (i,j,bi,bj) = 0.
             solar0  (i,j,bi,bj) = 0.
             solar1  (i,j,bi,bj) = 0.
             uWind0  (i,j,bi,bj) = 0.
             uWind1  (i,j,bi,bj) = 0.
             vWind0  (i,j,bi,bj) = 0.
             vWind1  (i,j,bi,bj) = 0.
             cheaph0 (i,j,bi,bj) = 0.
             cheaph1 (i,j,bi,bj) = 0.
             cheapcl0(i,j,bi,bj) = 0.5
             cheapcl1(i,j,bi,bj) = 0.5
             cheaplw0(i,j,bi,bj) = 0.
             cheaplw1(i,j,bi,bj) = 0.
             cheappr0(i,j,bi,bj) = 0.
             cheappr1(i,j,bi,bj) = 0.
             ustress0(i,j,bi,bj) = 0.
             ustress1(i,j,bi,bj) = 0.
             vstress0(i,j,bi,bj) = 0.
             vstress1(i,j,bi,bj) = 0.
             wavesh0 (i,j,bi,bj) = 0.
             wavesh1 (i,j,bi,bj) = 0.
             wavesp0 (i,j,bi,bj) = 0.
             wavesp1 (i,j,bi,bj) = 0.
c            rair0   (i,j,bi,bj) = 0.
c            rair1   (i,j,bi,bj) = 0.
             CheaptracerR0 (i,j,bi,bj) = 0.
             CheaptracerR1 (i,j,bi,bj) = 0.
            ENDDO
           ENDDO
          ENDDO
         ENDDO
        ENDIF

C--   Now calculate whether it is time to update the forcing arrays
        CALL GET_PERIODIC_INTERVAL(
     O           intimeP, intime0, intime1, bWght, aWght,
     I           externForcingCycle_cheap, externForcingPeriod_cheap,
     I           deltaTclock, myTime, myThid )

        IF ( intime0.NE.intimeP .OR. myIter.EQ.nIter0 ) THEN

C      If the above condition is met then we need to read in
C      data for the period ahead and the period behind myTime.
         WRITE(*,*) 'S/R CHEAPAML_FIELDS_LOAD'
         IF ( SolarFile .NE. ' ' ) THEN
          CALL READ_REC_XY_RL( SolarFile,solar0,intime0,
     &                         myIter, myThid )
          CALL READ_REC_XY_RL( SolarFile,solar1,intime1,
     &                         myIter, myThid )
        ELSE
          DO bj = myByLo(myThid), myByHi(myThid)
            DO bi = myBxLo(myThid), myBxHi(myThid)
              DO j=1,sNy
                DO i=1,sNx
                  Solar(i,j,bi,bj) = 0.0 _d 0
                ENDDO
              ENDDO
            ENDDO
         ENDDO
         _EXCH_XY_RL( solar, myThid )

        ENDIF
         IF ( TrFile .NE. ' ' ) THEN
          CALL READ_REC_XY_RL( TRFile,trair0,intime0,
     &                         myIter, myThid )
          CALL READ_REC_XY_RL( TRFile,trair1,intime1,
     &                         myIter, myThid )
        ELSE
         DO bj = myByLo(myThid), myByHi(myThid)
          DO bi = myBxLo(myThid), myBxHi(myThid)
           DO j=1,sNy
            DO i=1,sNx
              TR(i,j,bi,bj) = 0.0 _d 0
            ENDDO
           ENDDO
          ENDDO
         ENDDO
         _EXCH_XY_RL( TR, myThid )

        ENDIF
         IF ( QrFile .NE. ' ' ) THEN
          CALL READ_REC_XY_RL( QrFile,qrair0,intime0,
     &                         myIter, myThid )
          CALL READ_REC_XY_RL( QrFile,qrair1,intime1,
     &                         myIter, myThid )
        ELSE
          DO bj = myByLo(myThid), myByHi(myThid)
            DO bi = myBxLo(myThid), myBxHi(myThid)
              DO j=1,sNy
                DO i=1,sNx
                  qr(i,j,bi,bj) = 0.0 _d 0
                ENDDO
              ENDDO
            ENDDO
          ENDDO
         _EXCH_XY_RL( qr, myThid )

        ENDIF
        IF ( UWindFile .NE. ' ' ) THEN
          CALL READ_REC_XY_RL( UWindFile,uWind0,intime0,
     &       myIter, myThid )
          CALL READ_REC_XY_RL( UWindFile,uWind1,intime1,
     &       myIter, myThid )
        ELSE
          DO bj = myByLo(myThid), myByHi(myThid)
          DO bi = myBxLo(myThid), myBxHi(myThid)
           DO j=1,sNy
            DO i=1,sNx
              uWind(i,j,bi,bj) = 0.0 _d 0
            ENDDO
           ENDDO
          ENDDO
         ENDDO

         _EXCH_XY_RL( uWind, myThid )
!         CALL EXCH_UV_XY_RL( uWind, vWind, .TRUE., myThid )

       ENDIF

         IF ( VWindFile .NE. ' ' ) THEN
          CALL READ_REC_XY_RL( VWindFile,vWind0,intime0,
     &                         myIter, myThid )
          CALL READ_REC_XY_RL( VWindFile,vWind1,intime1,
     &                         myIter, myThid )
        ELSE
          DO bj = myByLo(myThid), myByHi(myThid)
          DO bi = myBxLo(myThid), myBxHi(myThid)
           DO j=1,sNy
            DO i=1,sNx
              vWind(i,j,bi,bj) = 0. _d 0
            ENDDO
           ENDDO
          ENDDO
         ENDDO

         _EXCH_XY_RL( vWind, myThid )
!         CALL EXCH_UV_XY_RL( uWind, vWind, .TRUE., myThid )

        ENDIF
         IF ( useTimeVarBLH .AND. cheap_hFile .NE. ' ' ) THEN
          CALL READ_REC_XY_RL( cheap_hFile,cheaph0,intime0,
     &                         myIter, myThid )
          CALL READ_REC_XY_RL( cheap_hFile,cheaph1,intime1,
     &                         myIter, myThid )
         ENDIF
         IF ( useClouds .AND. cheap_clFile .NE. ' ' ) THEN
          CALL READ_REC_XY_RL( cheap_clFile,cheapcl0,intime0,
     &                         myIter, myThid )
          CALL READ_REC_XY_RL( cheap_clFile,cheapcl1,intime1,
     &                         myIter, myThid )
         ENDIF
         IF ( useDLongWave .AND. cheap_dlwFile .NE. ' ' ) THEN
          CALL READ_REC_XY_RL( cheap_dlwFile,cheaplw0,intime0,
     &                         myIter, myThid )
          CALL READ_REC_XY_RL( cheap_dlwFile,cheaplw1,intime1,
     &                         myIter, myThid )
         ENDIF
         IF ( (usePrecip) .AND. cheap_prFile .NE. ' ' ) THEN
          CALL READ_REC_XY_RL( cheap_prFile,cheappr0,intime0,
     &                         myIter, myThid )
          CALL READ_REC_XY_RL( cheap_prFile,cheappr1,intime1,
     &                         myIter, myThid )
         ENDIF
         IF ( useStressOption .AND. UStressFile .NE. ' ' ) THEN
          CALL READ_REC_XY_RL( UStressFile,ustress0,intime0,
     &                         myIter, myThid )
          CALL READ_REC_XY_RL( UStressFile,ustress1,intime1,
     &                         myIter, myThid )
         ENDIF
         IF ( useStressOption .AND. VStressFile .NE. ' ' ) THEN
          CALL READ_REC_XY_RL( VStressFile,vstress0,intime0,
     &                         myIter, myThid )
          CALL READ_REC_XY_RL( VStressFile,vstress1,intime1,
     &                         myIter, myThid )
         ENDIF
         IF ( FluxFormula.EQ.'COARE3' .AND. WaveHFile.NE.' ' ) THEN
          CALL READ_REC_XY_RL( WaveHFile,wavesh0,intime0,
     &                         myIter, myThid )
          CALL READ_REC_XY_RL( WaveHFile,wavesh1,intime1,
     &                         myIter, myThid )
         ENDIF
         IF ( FluxFormula.EQ.'COARE3' .AND. WavePFile.NE.' ' ) THEN
          CALL READ_REC_XY_RL( WavePFile,wavesp0,intime0,
     &                         myIter, myThid )
          CALL READ_REC_XY_RL( WavePFile,wavesp1,intime1,
     &                         myIter, myThid )
         ENDIF
         IF ( useCheapTracer .AND. TracerRFile .NE. ' ' ) THEN
           CALL READ_REC_XY_RL( TracerRFile,CheaptracerR0,intime0,
     &                         myIter, myThid )
           CALL READ_REC_XY_RL( TracerRFile,CheaptracerR1,intime1,
     &                         myIter, myThid )
         ELSEIF( useCheapTracer ) THEN
           DO bj = myByLo(myThid), myByHi(myThid)
             DO bi = myBxLo(myThid), myBxHi(myThid)
               DO j=1,sNy
                 DO i=1,sNx
                   CheaptracerR(i,j,bi,bj) = 0. _d 0
                 ENDDO
               ENDDO
             ENDDO
           ENDDO
          _EXCH_XY_RL( CheaptracerR, myThid )

         ENDIF
         _EXCH_XY_RL( trair0 , myThid )
         _EXCH_XY_RL( trair1 , myThid )
         _EXCH_XY_RL( qrair0 , myThid )
         _EXCH_XY_RL( qrair1 , myThid )
         _EXCH_XY_RL( solar0 , myThid )
         _EXCH_XY_RL( solar1 , myThid )
         CALL EXCH_UV_XY_RL( uWind0, vWind0, .TRUE., myThid )
         CALL EXCH_UV_XY_RL( uWind1, vWind1, .TRUE., myThid )
         IF ( useTimeVarBLH ) THEN
         _EXCH_XY_RL( cheaph0, myThid )
         _EXCH_XY_RL( cheaph1 , myThid )
         ENDIF
         IF ( useClouds ) THEN
         _EXCH_XY_RL( cheapcl0, myThid )
         _EXCH_XY_RL( cheapcl1 , myThid )
         ENDIF
         IF ( useDLongWave ) THEN
         _EXCH_XY_RL( cheaplw0, myThid )
         _EXCH_XY_RL( cheaplw1 , myThid )
         ENDIF
         IF ( usePrecip ) THEN
         _EXCH_XY_RL( cheappr0, myThid )
         _EXCH_XY_RL( cheappr1 , myThid )
         ENDIF
         IF ( useStressOption ) THEN
         CALL EXCH_UV_AGRID_3D_RL(ustress0,vstress0, .TRUE.,1,myThid )
         CALL EXCH_UV_AGRID_3D_RL(ustress1,vstress1, .TRUE.,1,myThid )
         ENDIF
         IF ( FluxFormula.EQ.'COARE3' ) THEN
         _EXCH_XY_RL( wavesp0 , myThid )
         _EXCH_XY_RL( wavesp1 , myThid )
         _EXCH_XY_RL( wavesh0 , myThid )
         _EXCH_XY_RL( wavesh1 , myThid )
         ENDIF
         IF ( useCheapTracer ) THEN
         _EXCH_XY_RL( CheaptracerR0 , myThid )
         _EXCH_XY_RL( CheaptracerR1, myThid )
         ENDIF

C     end of loading new fields block
        ENDIF

C--   Interpolate TR, QR, SOLAR
        DO bj = myByLo(myThid), myByHi(myThid)
         DO bi = myBxLo(myThid), myBxHi(myThid)
          DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
            TR(i,j,bi,bj)           = bWght*trair0(i,j,bi,bj)
     &                              + aWght*trair1(i,j,bi,bj)   !+273.15
            qr(i,j,bi,bj)           = bWght*qrair0(i,j,bi,bj)
     &                              + aWght*qrair1(i,j,bi,bj)
            uWind(i,j,bi,bj)        = bWght*uWind0(i,j,bi,bj)
     &                              + aWght*uWind1(i,j,bi,bj)
            vWind(i,j,bi,bj)        = bWght*vWind0(i,j,bi,bj)
     &                              + aWght*vWind1(i,j,bi,bj)
            solar(i,j,bi,bj)        = bWght*solar0(i,j,bi,bj)
     &                              + aWght*solar1(i,j,bi,bj)
            IF ( useStressOption ) THEN
             ustress(i,j,bi,bj)     = bWght*ustress0(i,j,bi,bj)
     &                              + aWght*ustress1(i,j,bi,bj)
             vstress(i,j,bi,bj)     = bWght*vstress0(i,j,bi,bj)
     &                              + aWght*vstress1(i,j,bi,bj)
            ENDIF
            IF ( useTimeVarBLH ) THEN
             CheapHgrid(i,j,bi,bj)  = bWght*cheaph0(i,j,bi,bj)
     &                              + aWght*cheaph1(i,j,bi,bj)
            ENDIF
            IF ( useClouds ) THEN
             cheapclouds(i,j,bi,bj) = bWght*cheapcl0(i,j,bi,bj)
     &                              + aWght*cheapcl1(i,j,bi,bj)
            ENDIF
            IF ( useDLongWave ) THEN
             cheapdlongwave(i,j,bi,bj) = bWght*cheaplw0(i,j,bi,bj)
     &                                 + aWght*cheaplw1(i,j,bi,bj)
            ENDIF
            IF ( usePrecip ) THEN
             cheapPrecip(i,j,bi,bj) = bWght*cheappr0(i,j,bi,bj)
     &                                 + aWght*cheappr1(i,j,bi,bj)
            ENDIF
            IF ( useCheapTracer ) THEN
             CheaptracerR(i,j,bi,bj) = bWght*CheaptracerR0(i,j,bi,bj)
     &                               + aWght*CheaptracerR1(i,j,bi,bj)
            ENDIF
            IF ( FluxFormula.EQ.'COARE3' ) THEN
             IF ( WaveHFile.NE.' ' ) THEN
              wavesh(i,j,bi,bj)     = bWght*wavesh0(i,j,bi,bj)
     &                              + aWght*wavesh1(i,j,bi,bj)
             ENDIF
             IF ( WavePFile.NE.' ' ) THEN
              wavesp(i,j,bi,bj)     = bWght*wavesp0(i,j,bi,bj)
     &                              + aWght*wavesp1(i,j,bi,bj)
             ENDIF
            ELSE
             u = uWind(i,j,bi,bj)**2 + vWind(i,j,bi,bj)**2
             u = SQRT(u)
             wavesp(i,j,bi,bj) = 0.729 _d 0 * u
             wavesh(i,j,bi,bj) = 0.018 _d 0 * u*u*(1. + .015 _d 0 *u)
            ENDIF
           ENDDO
          ENDDO
         ENDDO
        ENDDO

C end of periodic forcing options, on to steady option
      ELSE

       IF ( myIter .EQ. nIter0 ) THEN

        IF ( SolarFile .NE. ' ' ) THEN
         CALL READ_FLD_XY_RL( SolarFile,' ',solar,0,myThid )
        ELSE
         DO bj = myByLo(myThid), myByHi(myThid)
          DO bi = myBxLo(myThid), myBxHi(myThid)
           DO j=1,sNy
            DO i=1,sNx
              jG = myYGlobalLo-1+(bj-1)*sNy+j
              local = 225. _d 0 - (jG-1)*recipNym1*37.5 _d 0
              Solar(i,j,bi,bj) = local
            ENDDO
           ENDDO
          ENDDO
         ENDDO
        ENDIF
        _EXCH_XY_RL( solar, myThid )

        IF ( TrFile .NE. ' '  ) THEN
         CALL READ_FLD_XY_RL( TrFile,' ',tr,0,myThid )
        ELSE
         DO bj = myByLo(myThid), myByHi(myThid)
          DO bi = myBxLo(myThid), myBxHi(myThid)
           DO j=1,sNy
            DO i=1,sNx
              local = solar(i,j,bi,bj)
              local = (2. _d 0*local/stefan)**(0.25 _d 0) - celsius2K
              TR(i,j,bi,bj) = local
            ENDDO
           ENDDO
          ENDDO
         ENDDO
        ENDIF
        _EXCH_XY_RL( TR, myThid )

C do specific humidity
        IF ( QrFile .NE. ' ') THEN
         CALL READ_FLD_XY_RL( QrFile,' ',qr,0,myThid )
        ELSE
C default specific humidity profile to 80% relative humidity
         DO bj = myByLo(myThid), myByHi(myThid)
          DO bi = myBxLo(myThid), myBxHi(myThid)
           DO j=1,sNy
            DO i=1,sNx
              local = Tr(i,j,bi,bj) + celsius2K
              ssqa = ssq0*EXP( lath*(ssq1-ssq2/local)) / p0
              qr(i,j,bi,bj) = 0.8 _d 0*ssqa
            ENDDO
           ENDDO
          ENDDO
         ENDDO
        ENDIF
        _EXCH_XY_RL( qr, myThid )

        IF ( UWindFile .NE. ' '  ) THEN
         CALL READ_FLD_XY_RL( UWindFile,' ',uWind,0,myThid )
        ELSE
         DO bj = myByLo(myThid), myByHi(myThid)
          DO bi = myBxLo(myThid), myBxHi(myThid)
           DO j=1,sNy
            DO i=1,sNx
              jG = myYGlobalLo-1+(bj-1)*sNy+j
C mod for debug
C to return  to original code, uncomment following line
C comment out 2nd line
              local = -5. _d 0*COS( 2. _d 0*PI*(jG-1)*recipNym1 )
c             local =  0. _d 0*COS( 2. _d 0*PI*(jG-1)*recipNym1 )
              uWind(i,j,bi,bj) = local
            ENDDO
           ENDDO
          ENDDO
         ENDDO
        ENDIF

        IF ( VWindFile .NE. ' '  ) THEN
         CALL READ_FLD_XY_RL( VWindFile,' ',vWind,0,myThid )
        ELSE
         DO bj = myByLo(myThid), myByHi(myThid)
          DO bi = myBxLo(myThid), myBxHi(myThid)
           DO j=1,sNy
            DO i=1,sNx
              vWind(i,j,bi,bj) = 0. _d 0
            ENDDO
           ENDDO
          ENDDO
         ENDDO
        ENDIF
        CALL EXCH_UV_XY_RL( uWind, vWind, .TRUE., myThid )

        IF ( useStressOption ) THEN
         IF ( UStressFile .NE. ' '  ) THEN
          CALL READ_FLD_XY_RL( UStressFile,' ',ustress,0,myThid )
         ELSE
          WRITE(*,*)' U Stress File absent with stress option'
          STOP
         ENDIF
         IF ( VStressFile .NE. ' '  ) THEN
          CALL READ_FLD_XY_RL( VStressFile,' ',vstress,0,myThid )
         ELSE
          WRITE(*,*)' V Stress File absent with stress option'
          STOP
         ENDIF
         CALL EXCH_UV_AGRID_3D_RL( ustress,vstress, .TRUE.,1,myThid )
        ENDIF
        IF ( useCheapTracer ) THEN
         IF ( TracerRFile .NE. ' ' ) THEN
          CALL READ_FLD_XY_RL( TracerRFile,' ',CheaptracerR,0,myThid )
         ELSE
           DO bj = myByLo(myThid), myByHi(myThid)
            DO bi = myBxLo(myThid), myBxHi(myThid)
             DO j=1,sNy
              DO i=1,sNx
               CheaptracerR(i,j,bi,bj)=290. _d 0
              ENDDO
             ENDDO
            ENDDO
           ENDDO
         ENDIF
         _EXCH_XY_RL( CheaptracerR, myThid )
        ENDIF
        IF ( FluxFormula.EQ.'COARE3' ) THEN
         IF ( WaveHFile.NE.' ' ) THEN
          CALL READ_FLD_XY_RL( WaveHFile,' ',wavesh,0,myThid )
         ENDIF
         IF ( WavePFile.NE.' ' ) THEN
          CALL READ_FLD_XY_RL( WavePFile,' ',wavesp,0,myThid )
         ELSE
          DO bj = myByLo(myThid), myByHi(myThid)
           DO bi = myBxLo(myThid), myBxHi(myThid)
            DO j=1,sNy
             DO i=1,sNx
              u = uWind(i,j,bi,bj)**2 + vWind(i,j,bi,bj)**2
              u = SQRT(u)
              wavesp(i,j,bi,bj)=0.729 _d 0 * u
              wavesh(i,j,bi,bj)=0.018 _d 0 * u*u*(1. + .015 _d 0 *u)
             ENDDO
            ENDDO
           ENDDO
          ENDDO
         ENDIF
         _EXCH_XY_RL( wavesp, myThid )
         _EXCH_XY_RL( wavesh, myThid )
        ENDIF

C     BL height is done in cheapaml_ini_varia

        IF ( useClouds ) THEN
         IF ( cheap_clFile .NE. ' ' ) THEN
          CALL READ_FLD_XY_RL( cheap_clFile,' ',Cheapclouds,0,myThid )
         ELSE
          DO bj = myByLo(myThid), myByHi(myThid)
           DO bi = myBxLo(myThid), myBxHi(myThid)
            DO j=1,sNy
             DO i=1,sNx
               Cheapclouds(i,j,bi,bj)=0.5
             ENDDO
            ENDDO
           ENDDO
          ENDDO
         ENDIF
         _EXCH_XY_RL( Cheapclouds, myThid )
        ENDIF

        IF ( useDLongWave ) THEN
         IF ( cheap_dlwFile .NE. ' ' ) THEN
          CALL READ_FLD_XY_RL(cheap_dlwFile,' ',Cheapdlongwave,0,myThid)
         ELSE
          WRITE(*,*) 'with useDLongWave = true,  you must provide',
     $               ' a downward longwave file'
          STOP
         ENDIF
         _EXCH_XY_RL( Cheapdlongwave, myThid )
        ENDIF

        IF ( usePrecip ) THEN
         IF ( cheap_prFile .NE. ' ' ) THEN
          CALL READ_FLD_XY_RL(cheap_prFile,' ',CheapPrecip,0,myThid)
         ELSE
          DO bj = myByLo(myThid), myByHi(myThid)
           DO bi = myBxLo(myThid), myBxHi(myThid)
            DO j=1,sNy
             DO i=1,sNx
               CheapPrecip(i,j,bi,bj)=0.0
             ENDDO
            ENDDO
           ENDDO
          ENDDO

        ENDIF
         _EXCH_XY_RL( CheapPrecip, myThid )
        ENDIF

C--    endif myIter = nIter0
       ENDIF

C endif for Steady Option
      ENDIF

C fill in outer edges

      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
         DO j=1-OLy,sNy+OLy
          jG = myYGlobalLo-1+(bj-1)*sNy+j
          DO i=1-OLx,sNx+OLx
           iG=myXGlobalLo-1+(bi-1)*sNx+i

           IF ( .NOT.cheapamlXperiodic .AND. iG.LT.1 ) THEN

            Tr(i,j,bi,bj)=Tr(1,j,bi,bj)
            qr(i,j,bi,bj)=qr(1,j,bi,bj)
            uWind(i,j,bi,bj)=uWind(2,j,bi,bj)
            vWind(i,j,bi,bj)=vWind(1,j,bi,bj)
            Solar(i,j,bi,bj)=Solar(1,j,bi,bj)
            IF ( useStressOption ) THEN
              ustress(i,j,bi,bj)=ustress(1,j,bi,bj)
              vstress(i,j,bi,bj)=vstress(1,j,bi,bj)
            ENDIF
            IF ( useCheapTracer ) THEN
              CheaptracerR(i,j,bi,bj)=CheaptracerR(1,j,bi,bj)
            ENDIF
            IF ( FluxFormula.EQ.'COARE3' ) THEN
              wavesp(i,j,bi,bj)=wavesp(1,j,bi,bj)
              wavesh(i,j,bi,bj)=wavesh(1,j,bi,bj)
            ENDIF
            IF ( useClouds ) THEN
              Cheapclouds(i,j,bi,bj)=Cheapclouds(1,j,bi,bj)
            ENDIF
            IF ( useDLongWave ) THEN
              Cheapdlongwave(i,j,bi,bj)=Cheapdlongwave(1,j,bi,bj)
            ENDIF

           ELSEIF ( .NOT.cheapamlXperiodic .AND. iG.EQ.1 ) THEN

            uWind(i,j,bi,bj)=uWind(2,j,bi,bj)

           ELSEIF ( .NOT.cheapamlXperiodic .AND. iG.GT.Nx ) THEN

            Tr(i,j,bi,bj)=Tr(sNx,j,bi,bj)
            qr(i,j,bi,bj)=qr(sNx,j,bi,bj)
            uWind(i,j,bi,bj)=uWind(sNx,j,bi,bj)
            vWind(i,j,bi,bj)=vWind(sNx,j,bi,bj)
            Solar(i,j,bi,bj)=Solar(sNx,j,bi,bj)
            IF ( useStressOption ) THEN
              ustress(i,j,bi,bj)=ustress(sNx,j,bi,bj)
              vstress(i,j,bi,bj)=vstress(sNx,j,bi,bj)
            ENDIF
            IF ( useCheapTracer ) THEN
              CheaptracerR(i,j,bi,bj)=CheaptracerR(sNx,j,bi,bj)
            ENDIF
            IF ( FluxFormula.EQ.'COARE3' ) THEN
              wavesp(i,j,bi,bj)=wavesp(sNx,j,bi,bj)
              wavesh(i,j,bi,bj)=wavesh(sNx,j,bi,bj)
            ENDIF
            IF ( useClouds ) THEN
              Cheapclouds(i,j,bi,bj)=Cheapclouds(sNx,j,bi,bj)
            ENDIF
            IF ( useDLongWave ) THEN
              Cheapdlongwave(i,j,bi,bj)=Cheapdlongwave(sNx,j,bi,bj)
            ENDIF

           ELSEIF ( .NOT.cheapamlYperiodic .AND. jG.LT.1 ) THEN

            Tr(i,j,bi,bj)=Tr(i,1,bi,bj)
            qr(i,j,bi,bj)=qr(i,1,bi,bj)
            uWind(i,j,bi,bj)=uWind(i,1,bi,bj)
            vWind(i,j,bi,bj)=vWind(i,2,bi,bj)
            Solar(i,j,bi,bj)=Solar(i,1,bi,bj)
            IF ( useStressOption ) THEN
              ustress(i,j,bi,bj)=ustress(i,1,bi,bj)
              vstress(i,j,bi,bj)=vstress(i,1,bi,bj)
            ENDIF
            IF ( useCheapTracer ) THEN
              CheaptracerR(i,j,bi,bj)=CheaptracerR(i,1,bi,bj)
            ENDIF
            IF ( useClouds ) THEN
              Cheapclouds(i,j,bi,bj)=Cheapclouds(i,1,bi,bj)
            ENDIF
            IF ( useDLongWave ) THEN
              Cheapdlongwave(i,j,bi,bj)=Cheapdlongwave(i,1,bi,bj)
            ENDIF
            IF ( FluxFormula.EQ.'COARE3' ) THEN
              wavesp(i,j,bi,bj)=wavesp(i,1,bi,bj)
              wavesh(i,j,bi,bj)=wavesh(i,1,bi,bj)
            ENDIF

           ELSEIF ( .NOT.cheapamlYperiodic .AND. jG.EQ.1 ) THEN

            vWind(i,j,bi,bj)=vWind(i,2,bi,bj)

           ELSEIF ( .NOT.cheapamlYperiodic .AND. jG.GT.Ny ) THEN

            Tr(i,j,bi,bj)=Tr(i,sNy,bi,bj)
            qr(i,j,bi,bj)=qr(i,sNy,bi,bj)
            uWind(i,j,bi,bj)=uWind(i,sNy,bi,bj)
            vWind(i,j,bi,bj)=vWind(i,sNy,bi,bj)
            Solar(i,j,bi,bj)=Solar(i,sNy,bi,bj)
            IF ( useStressOption ) THEN
              ustress(i,j,bi,bj)=ustress(i,sNy,bi,bj)
              vstress(i,j,bi,bj)=vstress(i,sNy,bi,bj)
            ENDIF
            IF ( useCheapTracer ) THEN
              CheaptracerR(i,j,bi,bj)=CheaptracerR(i,sNy,bi,bj)
            ENDIF
            IF ( FluxFormula.EQ.'COARE3' ) THEN
              wavesp(i,j,bi,bj)=wavesp(i,sNy,bi,bj)
              wavesh(i,j,bi,bj)=wavesh(i,sNy,bi,bj)
            ENDIF
            IF ( useClouds ) THEN
              Cheapclouds(i,j,bi,bj)=Cheapclouds(i,sNy,bi,bj)
            ENDIF
            IF ( useDLongWave ) THEN
              Cheapdlongwave(i,j,bi,bj)=Cheapdlongwave(i,sNy,bi,bj)
            ENDIF

           ENDIF
          ENDDO
         ENDDO
       ENDDO
      ENDDO

      RETURN
      END

#include "ctrparam.h"
#ifdef OCEAN_3D
#  include "ATM2D_OPTIONS.h"
#endif
C
      SUBROUTINE ATM2D_FINISH( myThid)
C     |==========================================================|
C     | Called from forward_step_atm2d the last time through the |
C     | main loop -- thus, and opportunity to shut down MPI, do  |
C     | cleanup/finish routines.                                 |
C     \==========================================================/
      IMPLICIT NONE

#  ifdef ATM2D_MPI_ON
#    include "mpif.h"
#  endif

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     myIter - iteration counter for this thread
C     myTime - time counter for this thread
C     myThid - thread number for this instance of the routine.
      INTEGER myThid

C     === Local variables ===

#ifdef OCEAN_3D
      INTEGER rc
#endif

#ifdef CLM35
C     next line is hack to call clm one more time step
C     as CLM35 writes end-of-year file at start of next year
      CALL clm4mit2d 
#endif

#ifdef ATM2D_MPI_ON
      CALL MPI_BARRIER( MPI_COMM_WORLD, rc )
      CALL MPI_FINALIZE(rc)
#endif

      RETURN
      END

c#include "PACKAGES_CONFIG.h"
#include "CPP_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: CHECK_PICKUP
C     !INTERFACE:
      SUBROUTINE CHECK_PICKUP(
     I                 missFldList,
     I                 nMissing, nbFields,
     I                 myIter, myThid )

C     !DESCRIPTION:
C     Check that fields that are needed to restart have been read.
C     In case some fields are missing, stop if pickupStrictlyMatch=T
C     or try, if possible, to restart without the missing field.

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "RESTART.h"
c#ifdef ALLOW_GENERIC_ADVDIFF
c# include "GAD.h"
c#endif

C     !INPUT/OUTPUT PARAMETERS:
C     missFldList :: List of missing fields   (attempted to read but not found)
C     nMissing    :: Number of missing fields (attempted to read but not found)
C     nbFields    :: number of fields in pickup file (read from meta file)
C     myIter      :: Iteration number
C     myThid      :: my Thread Id. number
      CHARACTER*(8) missFldList(*)
      INTEGER nMissing
      INTEGER nbFields
      INTEGER myIter
      INTEGER myThid
CEOP

C     !FUNCTIONS
      INTEGER  ILNBLNK
      EXTERNAL ILNBLNK

C     !LOCAL VARIABLES:
      INTEGER j
      INTEGER ioUnit
      INTEGER warnCnts
      LOGICAL stopFlag
      CHARACTER*(MAX_LEN_MBUF) msgBuf

      ioUnit = errorMessageUnit

c     IF (pickup_read_mdsio) THEN
      _BEGIN_MASTER( myThid )

       IF ( nbFields.GE.1 ) THEN
C-     flag startFromPickupAB2 is becoming obsolete with new way to read
C      pickup file: cancel its effect (from initialisation) by resetting
C      start-AB parameters:
         tempStartAB = nIter0
         saltStartAB = nIter0
         mom_StartAB = nIter0
         nHydStartAB = nIter0
       ENDIF
       IF ( selectNHfreeSurf.GE.1 ) THEN
         IF ( nbFields.EQ.0 ) THEN
           WRITE(msgBuf,'(4A)') '** WARNING ** CHECK_PICKUP: ',
     &      'restart like hydrostatic free-surf (dPhiNH missing)'
           CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
         ELSE
C-     assume reading dPhiNH was OK (otherwise expected in missing field list)
           dPhiNHstatus = 1
         ENDIF
       ENDIF

       IF ( nMissing.GE.1 ) THEN
        stopFlag = .FALSE.
        warnCnts = nMissing
        DO j=1,nMissing
C-    Case where missing field is not essential or can be recomputed
         IF     ( missFldList(j).EQ.'dEtaHdt '
     &        .AND. .NOT.useRealFreshWaterFlux ) THEN
          warnCnts = warnCnts - 1
          IF ( .NOT.pickupStrictlyMatch ) THEN
           WRITE(msgBuf,'(4A)') ' CHECK_PICKUP: ',
     &      'no RealFreshWaterFlux => can restart without "dEtaHdt "'
           CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
          ENDIF
         ELSEIF ( missFldList(j).EQ.'dPhiNH  '
     &        .AND. implicitNHPress.EQ.1. _d 0 ) THEN
          warnCnts = warnCnts - 1
          dPhiNHstatus = 0
          IF ( .NOT.pickupStrictlyMatch ) THEN
           WRITE(msgBuf,'(4A)') ' CHECK_PICKUP: ',
     &      'fully Implic.NH-Press => can restart without "dPhiNH  "'
           CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
          ENDIF
C-    Old pickup for which special code takes care of missing fields
         ELSEIF ( missFldList(j).EQ.'dEtaHdt '
     &                 .AND.usePickupBeforeC54 ) THEN
C-    with RealFreshWaterFlux, needs dEtaHdt to restart when:
C     * synchronousTimeStep & usingPCoords => needs PmEpR for surf-forcing
C         <- present code might be wrong if usePickupBeforeC54 and LinFS
C     * synchronousTimeStep & nonlinFreeSurf > 0 => needs PmEpR for surf-forcing
C     * select_rStar <> 0 => needs dEtaHdt for 1rst Integr_continuity
          IF ( .NOT.pickupStrictlyMatch ) THEN
           WRITE(msgBuf,'(4A)') '** WARNING ** CHECK_PICKUP: ',
     &      'restart as before C54 without "dEtaHdt "'
           CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
          ENDIF

C-    fields used only to speed-up solver(s) convergence:
C     (no serious problems expected if missing, but get a non-perfect restart)
         ELSEIF ( missFldList(j).EQ.'EtaN    '
     &                          .AND. rigidLid ) THEN
          IF ( .NOT.pickupStrictlyMatch ) THEN
           WRITE(msgBuf,'(4A)') '** WARNING ** CHECK_PICKUP: ',
     &      'restart with 1rst guess == 0 for CG2D solver'
           CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
          ENDIF
         ELSEIF ( missFldList(j).EQ.'Phi_NHyd' ) THEN
          IF ( .NOT.pickupStrictlyMatch ) THEN
           WRITE(msgBuf,'(4A)') '** WARNING ** CHECK_PICKUP: ',
     &      'restart with 1rst guess == 0 for CG3D solver'
           CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
          ENDIF
         ELSEIF ( missFldList(j).EQ.'dPhiNH  ' ) THEN
          dPhiNHstatus = 0
          IF ( .NOT.pickupStrictlyMatch ) THEN
           WRITE(msgBuf,'(4A)') '** WARNING ** CHECK_PICKUP: ',
     &      'restart like hydrostatic free-surf (dPhiNH missing)'
           CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
          ENDIF
         ELSEIF ( missFldList(j).EQ.'AddMass '
     &               .AND. selectAddFluid.EQ.2 ) THEN
          IF ( .NOT.pickupStrictlyMatch ) THEN
           WRITE(msgBuf,'(4A)') '** WARNING ** CHECK_PICKUP: ',
     &      'restart with AddMass == 0'
           CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
          ENDIF
         ELSEIF ( missFldList(j).EQ.'SmagDiff' ) THEN
          IF ( .NOT.pickupStrictlyMatch ) THEN
           WRITE(msgBuf,'(4A)') '** WARNING ** CHECK_PICKUP: ',
     &      'restart with zero Smag-3D Diffusivity for first time-step'
           CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
          ENDIF
         ELSEIF ( missFldList(j).EQ.'FricHeat' ) THEN
          IF ( .NOT.pickupStrictlyMatch ) THEN
           WRITE(msgBuf,'(4A)') '** WARNING ** CHECK_PICKUP: ',
     &      'restart with Frictional Dissipation Heating == 0'
           CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
          ENDIF

C-    Absolutely needed fields:
         ELSEIF ( missFldList(j).EQ.'Uvel    ' .OR.
     &            missFldList(j).EQ.'Vvel    ' .OR.
     &            missFldList(j).EQ.'Theta   ' .OR.
     &            missFldList(j).EQ.'Salt    ' .OR.
     &            missFldList(j).EQ.'EtaN    ' ) THEN
           stopFlag = .TRUE.
           WRITE(msgBuf,'(4A)') 'CHECK_PICKUP: ',
     &       'cannot restart without field "',missFldList(j),'"'
           CALL PRINT_ERROR( msgBuf, myThid )

C-    fields needed for restart (alternative not presently implemented)
         ELSEIF ( missFldList(j).EQ.'PhiHyd  ' .OR.
     &            missFldList(j).EQ.'Phi_rLow' .OR.
     &            missFldList(j).EQ.'AddMass ' .OR.
     &            missFldList(j).EQ.'dEtaHdt ' .OR.
     &            missFldList(j).EQ.'EtaH    ' ) THEN
           stopFlag = .TRUE.
           WRITE(msgBuf,'(4A)') 'CHECK_PICKUP: ',
     &     'cannot currently restart without field "',missFldList(j),'"'
           CALL PRINT_ERROR( msgBuf, myThid )

C-    fields with alternative in place to restart without:
C-    (but get a non-perfect restart)
         ELSEIF ( missFldList(j).EQ.'GuNm1   ' .OR.
     &            missFldList(j).EQ.'GvNm1   ' ) THEN
           mom_StartAB = 0
         ELSEIF ( missFldList(j).EQ.'GuNm2   ' .OR.
     &            missFldList(j).EQ.'GvNm2   ' ) THEN
           mom_StartAB = MIN( mom_startAB, 1 )
         ELSEIF ( missFldList(j).EQ.'GtNm1   ' .OR.
     &            missFldList(j).EQ.'TempNm1 ' ) THEN
           tempStartAB = 0
         ELSEIF ( missFldList(j).EQ.'GtNm2   ' .OR.
     &            missFldList(j).EQ.'TempNm2 ' ) THEN
           tempStartAB = MIN( tempStartAB, 1 )
         ELSEIF ( missFldList(j).EQ.'GsNm1   ' .OR.
     &            missFldList(j).EQ.'SaltNm1 ' ) THEN
           saltStartAB = 0
         ELSEIF ( missFldList(j).EQ.'GsNm2   ' .OR.
     &            missFldList(j).EQ.'SaltNm2 ' ) THEN
           saltStartAB = MIN( saltStartAB, 1 )
         ELSEIF ( missFldList(j).EQ.'GwNm1   ' ) THEN
           nHydStartAB = 0
         ELSEIF ( missFldList(j).EQ.'GwNm2   ' ) THEN
           nHydStartAB = MIN( nHydStartAB, 1 )
         ELSEIF ( missFldList(j).EQ.'QH_GwNm1' ) THEN
           qHydStartAB = 0
         ELSEIF ( missFldList(j).EQ.'QH_GwNm2' ) THEN
           qHydStartAB = MIN( qHydStartAB, 1 )

         ELSE
C-    not recognized fields:
           stopFlag = .TRUE.
           WRITE(msgBuf,'(4A)') 'CHECK_PICKUP: ',
     &       'missing field "',missFldList(j),'" not recognized'
           CALL PRINT_ERROR( msgBuf, myThid )
         ENDIF
        ENDDO

        IF ( stopFlag ) THEN
         STOP 'ABNORMAL END: S/R CHECK_PICKUP'
        ELSEIF ( pickupStrictlyMatch ) THEN
         WRITE(msgBuf,'(4A)') 'CHECK_PICKUP: ',
     &      'try with " pickupStrictlyMatch=.FALSE.,"',
     &      ' in file: "data", NameList: "PARM03"'
         CALL PRINT_ERROR( msgBuf, myThid )
         STOP 'ABNORMAL END: S/R CHECK_PICKUP'
        ELSEIF ( warnCnts .GT. 0 ) THEN
         WRITE(msgBuf,'(4A)') '** WARNING ** CHECK_PICKUP: ',
     &     'Will get only an approximated Restart'
         CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
         IF ( mom_StartAB.LT.nIter0 .OR.
     &        nHydStartAB.LT.nIter0 .OR.
     &        tempStartAB.LT.nIter0 .OR.
     &        saltStartAB.LT.nIter0 ) THEN
          WRITE(msgBuf,'(2(A,I10))')
     &     ' Continue with mom_StartAB =', mom_StartAB,
     &                 ' ; nHydStartAB =', nHydStartAB
          CALL PRINT_MESSAGE(msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
          WRITE(msgBuf,'(2(A,I10))')
     &     '          with tempStartAB =', tempStartAB,
     &                 ' ; saltStartAB =', saltStartAB
          CALL PRINT_MESSAGE(msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
         ENDIF
         IF ( qHydStartAB.LT.nIter0 ) THEN
          WRITE(msgBuf,'(2(A,I10))')
     &     ' Continue with qHydStartAB =', qHydStartAB
          CALL PRINT_MESSAGE(msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
         ENDIF
        ENDIF

       ENDIF

      _END_MASTER( myThid )
c     ENDIF

      RETURN
      END

#include "SEAICE_OPTIONS.h"

CBOP
C !ROUTINE: SEAICE_MOM_ADVECTION

C !INTERFACE: ==========================================================
      SUBROUTINE SEAICE_MOM_ADVECTION(
     I        bi,bj,iMin,iMax,jMin,jMax,
     I        uIceLoc, vIceLoc,
     O        gU, gV,
     I        myTime, myIter, myThid )
C     *==========================================================*
C     | S/R SEAICE_MOM_ADVECTION                                 |
C     | o Form the advection of sea ice momentum to be added to  |
C     |   the right hand-side of the momentum equation.          |
C     *==========================================================*
C     | Most of the code is take from S/R MOM_VECINV and reuses  |
C     | code from mom_vecinv and mom_common                      |
C     *==========================================================*
      IMPLICIT NONE

C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "SEAICE_SIZE.h"
#include "SEAICE_PARAMS.h"

C     == Routine arguments ==
C     bi,bj   :: current tile indices
C     iMin,iMax,jMin,jMax :: loop ranges
C     uIceLoc ::
C     vIceLoc ::

C     gU      :: advection tendency (all explicit terms), u component
C     gV      :: advection tendency (all explicit terms), v component
C     myTime  :: current time
C     myIter  :: current time-step number
C     myThid  :: my Thread Id number
      INTEGER bi,bj
      INTEGER iMin,iMax,jMin,jMax
      _RL uIceLoc(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL vIceLoc(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL gU(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL gV(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL     myTime
      INTEGER myIter
      INTEGER myThid
CEOP

#ifdef SEAICE_ALLOW_MOM_ADVECTION

C     == Functions ==
      LOGICAL  DIFFERENT_MULTIPLE
      EXTERNAL DIFFERENT_MULTIPLE

C     == Local variables ==
      _RL      uCf(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL      vCf(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RS hFacZ   (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RS r_hFacZ (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL uFld    (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL vFld    (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL KE      (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL vort3   (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
C     i,j    :: Loop counters
C     k      :: surface level index
      INTEGER i,j,k
C     later these will be run time parameters
CML      LOGICAL SEAICEhighOrderVorticity, SEAICEupwindVorticity
CML      LOGICAL SEAICEuseAbsVorticity,
      LOGICAL vorticityFlag

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

CML      SEAICEselectKEscheme     = selectKEscheme
CML      SEAICEselectVortScheme   = selectVortScheme
CML      SEAICEhighOrderVorticity = highOrderVorticity
CML      SEAICEupwindVorticity    = upwindVorticity
CML      SEAICEuseAbsVorticity    = useAbsVorticity
CML      SEAICEuseJamartMomAdv    = useJamartMomAdv

C--   Initialise intermediate terms
      DO j=1-OLy,sNy+OLy
       DO i=1-OLx,sNx+OLx
        uCf(i,j)   = 0.
        vCf(i,j)   = 0.
        gU(i,j)    = 0.
        gV(i,j)    = 0.
        vort3(i,j) = 0.
        KE(i,j)    = 0.
#ifdef ALLOW_AUTODIFF
        hFacZ(i,j)   = 0. _d 0
#endif
       ENDDO
      ENDDO

      k = 1
C--   Calculate open water fraction at vorticity points
      CALL MOM_CALC_HFACZ(bi,bj,k,hFacZ,r_hFacZ,myThid)

C     Make local copies of horizontal flow field
      DO j=1-OLy,sNy+OLy
       DO i=1-OLx,sNx+OLx
        uFld(i,j) = uIceLoc(i,j,bi,bj)
        vFld(i,j) = vIceLoc(i,j,bi,bj)
       ENDDO
      ENDDO

      CALL MOM_CALC_KE(bi,bj,k,SEAICEselectKEscheme,uFld,vFld,KE,myThid)

      CALL MOM_CALC_RELVORT3(bi,bj,k,uFld,vFld,hFacZ,vort3,myThid)

CMLC-    calculate absolute vorticity
CML      IF (useAbsVorticity) THEN
CML       DO j=1-Oly,sNy+Oly
CML        DO i=1-Olx,sNx+Olx
CML         vort3(i,j) = vort3(i,j) + fCoriG(i,j,bi,bj)
CML        ENDDO
CML       ENDDO
CML      ENDIF

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C--   Horizontal advection of relative (or absolute) vorticity
      vorticityFlag = SEAICEhighOrderVorticity.OR.SEAICEupwindVorticity
      IF ( vorticityFlag ) THEN
       CALL MOM_VI_U_CORIOLIS_C4(bi,bj,k,SEAICEselectVortScheme,
     &                           SEAICEhighOrderVorticity,
     &                           SEAICEupwindVorticity,
     &                           vFld,vort3,r_hFacZ,
     &                           uCf,myThid)
      ELSE
       CALL MOM_VI_U_CORIOLIS(bi,bj,k,SEAICEselectVortScheme,
     &                        SEAICEuseJamartMomAdv,
     &                        vFld,vort3,hFacZ,r_hFacZ,
     &                        uCf,myThid)
      ENDIF
      DO j=jMin,jMax
       DO i=iMin,iMax
        gU(i,j) = gU(i,j)+uCf(i,j)
       ENDDO
      ENDDO
      IF ( vorticityFlag ) THEN
       CALL MOM_VI_V_CORIOLIS_C4(bi,bj,k,SEAICEselectVortScheme,
     &                           SEAICEhighOrderVorticity,
     &                           SEAICEupwindVorticity,
     &                           uFld,vort3,r_hFacZ,
     &                           vCf,myThid)
      ELSE
       CALL MOM_VI_V_CORIOLIS(bi,bj,k,SEAICEselectVortScheme,
     &                        SEAICEuseJamartMomAdv,
     &                        uFld,vort3,hFacZ,r_hFacZ,
     &                        vCf,myThid)
      ENDIF
      DO j=jMin,jMax
       DO i=iMin,iMax
        gV(i,j) = gV(i,j)+vCf(i,j)
       ENDDO
      ENDDO

#ifdef ALLOW_DIAGNOSTICS
      IF ( useDiagnostics ) THEN
       CALL DIAGNOSTICS_FILL(uCf,'SIuAdvZ3',k,1,2,bi,bj,myThid)
       CALL DIAGNOSTICS_FILL(vCf,'SIvAdvZ3',k,1,2,bi,bj,myThid)
      ENDIF
#endif /* ALLOW_DIAGNOSTICS */

C--   Bernoulli term
      CALL MOM_VI_U_GRAD_KE(bi,bj,k,KE,uCf,myThid)
      DO j=jMin,jMax
       DO i=iMin,iMax
        gU(i,j) = gU(i,j)+uCf(i,j)
       ENDDO
      ENDDO
      CALL MOM_VI_V_GRAD_KE(bi,bj,k,KE,vCf,myThid)
      DO j=jMin,jMax
       DO i=iMin,iMax
        gV(i,j) = gV(i,j)+vCf(i,j)
       ENDDO
      ENDDO
#ifdef ALLOW_DIAGNOSTICS
      IF ( useDiagnostics ) THEN
       CALL DIAGNOSTICS_FILL(uCf,'SIKEx   ',k,1,2,bi,bj,myThid)
       CALL DIAGNOSTICS_FILL(vCf,'SIKEy   ',k,1,2,bi,bj,myThid)
      ENDIF
#endif /* ALLOW_DIAGNOSTICS */

C--   Set du/dt & dv/dt on boundaries to zero
C     apply masks for interior (important when we have open boundaries)
      DO j=jMin,jMax
       DO i=iMin,iMax
        gU(i,j) = gU(i,j)*maskInW(i,j,bi,bj)
        gV(i,j) = gV(i,j)*maskInS(i,j,bi,bj)
       ENDDO
      ENDDO

#ifdef ALLOW_DIAGNOSTICS
      IF ( useDiagnostics ) THEN
       CALL DIAGNOSTICS_FILL(KE,     'SImomKE ',k,1,2,bi,bj,myThid)
       CALL DIAGNOSTICS_FILL(gU,     'SIuMmAdv',k,1,2,bi,bj,myThid)
       CALL DIAGNOSTICS_FILL(gV,     'SIvMmAdv',k,1,2,bi,bj,myThid)
      ENDIF
#endif /* ALLOW_DIAGNOSTICS */

#endif /* SEAICE_ALLOW_MOM_ADVECTION */

      RETURN
      END

#include "GMREDI_OPTIONS.h"

CBOP
C     !ROUTINE: SUBMESO_CALC_PSI
C     !INTERFACE:
      SUBROUTINE SUBMESO_CALC_PSI(
     I             bi, bj, iMin, iMax, jMin, jMax,
     I             sigmaX, sigmaY, sigmaR,
     I             locMixLayer,
     I             myIter, myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE SUBMESO_CALC_PSI
C     | o Calculate stream-functions for Sub-Meso bolus velocity
C     *==========================================================*
C     | Ref: B. Fox-Kemper etal, Oce.Model., 39:61-78, 2011
C     |      B. Fox-Kemper etal, JPO, 38(6):1145-1165, 2008
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     == Global variables ==
#include "SIZE.h"
#include "GRID.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GMREDI.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
      _RL sigmaX(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL sigmaY(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL sigmaR(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL locMixLayer(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER bi,bj,iMin,iMax,jMin,jMax
      INTEGER myIter
      INTEGER myThid
CEOP

#ifndef GM_EXCLUDE_SUBMESO

C     !LOCAL VARIABLES:
C     == Local variables ==
      INTEGER i,j,k
      _RL mixLayerU   (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL mixLayerV   (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL dBuoyX_Hu   (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL dBuoyY_Hv   (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL NHmixLay    (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL MsquareH    (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL lengthScaleF(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL fcorLoc     (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL PsiLoc      (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL dzLoc
#ifdef GM_BOLUS_ADVEC
      _RL z2H, mu_z
#endif
      _RL five_ov21
      PARAMETER( five_ov21 = 5. _d 0 / 21. _d 0 )

C--   parameter to move to GMREDI.h
c     _RL subMeso_invTau, subMeso_LfMin, subMeso_Ceff
c     _RS subMeso_Lmax

c     subMeso_invTau = 1.6 _d -6  ! ~ 1/(7.2 days)
c     subMeso_LfMin  = 1000. _d 0
c     subMeso_Ceff   = 0.07 _d 0
c     subMeso_Lmax   = 111. _d 3

C-    Initialization : <= done in S/R gmredi_init

c     IF ( GM_useSubMeso ) THEN
       DO j=1-OLy,sNy+OLy
        DO i=1-OLx+1,sNx+OLx
         mixLayerU(i,j) = op5*( locMixLayer(i-1,j)+locMixLayer(i,j) )
         mixLayerU(i,j) = MIN( mixLayerU(i,j), -rLowW(i,j,bi,bj) )
        ENDDO
       ENDDO
       DO j=1-OLy+1,sNy+OLy
        DO i=1-OLx,sNx+OLx
         mixLayerV(i,j)=op5*( locMixLayer(i,j-1)+locMixLayer(i,j) )
         mixLayerV(i,j) = MIN( mixLayerV(i,j), -rLowS(i,j,bi,bj) )
        ENDDO
       ENDDO

C--    Integrate buoyancy gradient over the Mixed-Layer
       DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
          dBuoyX_Hu(i,j)= 0.
          dBuoyY_Hv(i,j)= 0.
          NHmixLay(i,j) = 0.
          fcorLoc(i,j) = SQRT( fCori(i,j,bi,bj)*fCori(i,j,bi,bj)
     &                       + subMeso_invTau*subMeso_invTau )
        ENDDO
       ENDDO
       DO k=1,Nr
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx+1,sNx+OLx
          dzLoc = MAX( 0. _d 0, MIN( drF(k), mixLayerU(i,j)+rF(k) ) )
          dBuoyX_Hu(i,j) = dBuoyX_Hu(i,j) + sigmaX(i,j,k)*dzLoc
         ENDDO
        ENDDO
        DO j=1-OLy+1,sNy+OLy
         DO i=1-OLx,sNx+OLx
          dzLoc = MAX( 0. _d 0, MIN( drF(k), mixLayerV(i,j)+rF(k) ) )
          dBuoyY_Hv(i,j) = dBuoyY_Hv(i,j) + sigmaY(i,j,k)*dzLoc
         ENDDO
        ENDDO
       ENDDO
       DO k=2,Nr
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          dzLoc = 0.
          IF ( locMixLayer(i,j)+rC(k-1).GE.0. ) dzLoc = drC(k)
          NHmixLay(i,j) = NHmixLay(i,j)
     &                  + dzLoc*MAX( -sigmaR(i,j,k), 0. _d 0 )
         ENDDO
        ENDDO
       ENDDO
       DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
          dBuoyX_Hu(i,j)= -dBuoyX_Hu(i,j)*gravity*recip_rhoConst
          dBuoyY_Hv(i,j)= -dBuoyY_Hv(i,j)*gravity*recip_rhoConst
          NHmixLay(i,j) = SQRT( NHmixLay(i,j)*gravity*recip_rhoConst
     &                         *locMixLayer(i,j) )
        ENDDO
       ENDDO
       DO j=2-OLy,sNy+OLy-1
        DO i=2-OLx,sNx+OLx-1
          MsquareH(i,j)= SQRT( op25*(
     &            (dBuoyX_Hu(i,j) + dBuoyX_Hu(i+1,j))**2
     &          + (dBuoyY_Hv(i,j) + dBuoyY_Hv(i,j+1))**2
     &                     ) )
        ENDDO
       ENDDO
C-     Compute Lf at grid-cell center
       DO j=2-OLy,sNy+OLy-1
        DO i=2-OLx,sNx+OLx-1
          lengthScaleF(i,j)= MAX(
     &        MsquareH(i,j)/(fcorLoc(i,j)*fcorLoc(i,j)) ,
     &        NHmixLay(i,j)/fcorLoc(i,j) ,
     &        subMeso_LfMin )
        ENDDO
       ENDDO

C      Mix-Layer Eddies contribution to Bolus Transport in X dir.
       DO j=2-OLy,sNy+OLy-1
        DO i=3-OLx,sNx+OLx-1
         PsiLoc(i,j) = -subMeso_Ceff*dBuoyX_Hu(i,j)
     &                 *mixLayerU(i,j)
     &                 *MIN( dxC(i,j,bi,bj), subMeso_Lmax )
     &                 *2. _d 0/(lengthScaleF(i-1,j)+lengthScaleF(i,j))
     &                 *2. _d 0/(fcorLoc(i-1,j)+fcorLoc(i,j))
        ENDDO
       ENDDO
#ifdef GM_BOLUS_ADVEC
       DO k=2,Nr
        DO j=2-OLy,sNy+OLy-1
         DO i=3-OLx,sNx+OLx-1
          IF ( mixLayerU(i,j).GT.0. _d 0 ) THEN
            z2H = 2. _d 0*rF(k)/mixLayerU(i,j)
          ELSE
            z2H = 0. _d 0
          ENDIF
          mu_z = ( z2H + 1. _d 0 )*( z2H + 1. _d 0 )
          mu_z = ( 1. _d 0 - mu_z )*(1. _d 0 + mu_z*five_ov21 )
          mu_z = MAX( 0. _d 0, mu_z )
          GM_PsiX(i,j,k,bi,bj) = GM_PsiX(i,j,k,bi,bj)
     &                         + mu_z*PsiLoc(i,j)
         ENDDO
        ENDDO
       ENDDO
#endif /* GM_BOLUS_ADVEC */
#ifdef ALLOW_DIAGNOSTICS
       IF ( useDiagnostics ) THEN
         CALL DIAGNOSTICS_FILL( lengthScaleF, 'SubMesLf',
     &                           0, 1, 2, bi, bj, myThid )
         CALL DIAGNOSTICS_FILL( PsiLoc, 'SubMpsiX',
     &                          0, 1, 2, bi, bj, myThid )
       ENDIF
#endif
       IF ( debugLevel.GE.debLevD ) THEN
         CALL WRITE_LOCAL_RL( 'subMeso_Lf','I10',1,lengthScaleF,
     &                         bi,bj,1,myIter,myThid )
         CALL WRITE_LOCAL_RL( 'subMeso_psiX','I10',1,PsiLoc,
     &                         bi,bj,1,myIter,myThid )
       ENDIF

C      Mix-Layer Eddies contribution to Bolus Transport in Y dir.
       DO j=3-OLy,sNy+OLy-1
        DO i=2-OLx,sNx+OLx-1
         PsiLoc(i,j) = -subMeso_Ceff*dBuoyY_Hv(i,j)
     &                 *mixLayerV(i,j)
     &                 *MIN( dyC(i,j,bi,bj), subMeso_Lmax )
     &                 *2. _d 0/(lengthScaleF(i,j-1)+lengthScaleF(i,j))
     &                 *2. _d 0/(fcorLoc(i,j-1)+fcorLoc(i,j))
        ENDDO
       ENDDO
#ifdef GM_BOLUS_ADVEC
       DO k=2,Nr
        DO j=3-OLy,sNy+OLy-1
         DO i=2-OLx,sNx+OLx-1
          IF ( mixLayerV(i,j).GT.0. _d 0 ) THEN
            z2H = 2. _d 0*rF(k)/mixLayerV(i,j)
          ELSE
            z2H = 0. _d 0
          ENDIF
          mu_z = ( z2H + 1. _d 0 )*( z2H + 1. _d 0 )
          mu_z = ( 1. _d 0 - mu_z )*(1. _d 0 + mu_z*five_ov21 )
          mu_z = MAX( 0. _d 0, mu_z )
          GM_PsiY(i,j,k,bi,bj) = GM_PsiY(i,j,k,bi,bj)
     &                         + mu_z*PsiLoc(i,j)
         ENDDO
        ENDDO
       ENDDO
#endif /* GM_BOLUS_ADVEC */
#ifdef ALLOW_DIAGNOSTICS
       IF ( useDiagnostics ) THEN
         CALL DIAGNOSTICS_FILL( PsiLoc, 'SubMpsiY',
     &                          0, 1, 2, bi, bj, myThid )
       ENDIF
#endif
       IF ( debugLevel.GE.debLevD ) THEN
         CALL WRITE_LOCAL_RL( 'subMeso_psiY','I10',1,PsiLoc,
     &                         bi,bj,1,myIter,myThid )
       ENDIF

c     ENDIF
#endif /* ndef GM_EXCLUDE_SUBMESO */

      RETURN
      END

#include "GAD_OPTIONS.h"

CBOP
C     !ROUTINE: GAD_INIT_VARIA
C     !INTERFACE:
      SUBROUTINE GAD_INIT_VARIA( myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE GAD_INIT_VARIA
C     | o Routine to initialize GAD variables
C     *==========================================================*
C     \ev
C     !USES:
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
c #include "GRID.h"
#include "GAD.h"
#include "GAD_SOM_VARS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
C     myThid ::  my Thread Id number
      INTEGER myThid
CEOP

#ifdef GAD_ALLOW_TS_SOM_ADV
C     !LOCAL VARIABLES:
C     === Local variables ===
      INTEGER i,j,k,bi,bj
      INTEGER n

      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)

C--   Initialize 1rst Order (3:x,y,z) and 2nd Order (6:xx,yy,zz,xy,xz,yz) moments
        DO n=1,nSOM
         DO k=1,Nr
          DO j=1-Oly,sNy+OLy
           DO i=1-Olx,sNx+Olx
C       pot.temp field:
            som_T(i,j,k,bi,bj,n) = 0. _d 0
C       salinity field:
            som_S(i,j,k,bi,bj,n) = 0. _d 0
           ENDDO
          ENDDO
         ENDDO
        ENDDO

C- end bi,bj loops
       ENDDO
      ENDDO

      IF ( tempSOM_Advection .OR. saltSOM_Advection ) THEN
       IF ( startTime.EQ.baseTime .AND. nIter0.EQ.0
     &                      .AND. pickupSuff.EQ.' ' ) THEN
C-     Need to synchronize here before doing master-thread IO
c        _BARRIER
C-     Read-in initial conditions:
C        --- not yet coded ---
c        CALL GAD_SOM_EXCHANGES( myThid )
       ELSE
C-     Read 2nd-O moments state from pickup files
         CALL GAD_READ_PICKUP( nIter0, myThid )
         CALL GAD_SOM_EXCHANGES( myThid )
       ENDIF
      ENDIF

#endif /* GAD_ALLOW_TS_SOM_ADV */

      RETURN
      END

#include "DIAG_OPTIONS.h"

CBOP
C     !ROUTINE: DIAGNOSTICS_SETDIAG
C     !INTERFACE:
      SUBROUTINE DIAGNOSTICS_SETDIAG(
     O                      mate,
     U                      ndiagmx,
     I                      mId, listId, ndId, myThid )

C     !DESCRIPTION: \bv
C     *==================================================================
C     | S/R DIAGNOSTICS_SETDIAG
C     | o activate diagnostic "ndId":
C     |   set pointer locations for this diagnostic ;
C     |   look for a counter mate and set it
C     *==================================================================
C     \ev

C     !USES:
      IMPLICIT NONE

C     == Global variables ===
#include "EEPARAMS.h"
#include "SIZE.h"
#include "DIAGNOSTICS_SIZE.h"
#include "DIAGNOSTICS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     mate    :: counter-mate number in available diagnostics list
C     ndiagmx :: current space allocated in storage array
C     mId     :: current field index in list "listId"
C     listId  :: current list number that contains field "mId"
C     ndId    :: diagnostic number in available diagnostics list
C     myThid  :: Thread number for this instance of the routine.
      INTEGER mate
      INTEGER ndiagmx
      INTEGER mId, listId, ndId
      INTEGER myThid
CEOP

C     !LOCAL VARIABLES:
C     == Local variables ==
      INTEGER stdUnit, errUnit
      INTEGER nn, k, l, no_hFac
      LOGICAL diagIsPP, flagD, flagP, flagM, use_hFac

      CHARACTER*10 gcode
      CHARACTER*12 tmpMsg
      CHARACTER*(MAX_LEN_MBUF) msgBuf

C **********************************************************************
C ****                SET POINTERS FOR DIAGNOSTIC ndId              ****
C **********************************************************************

      stdUnit = standardMessageUnit
      errUnit = errorMessageUnit

C-    Case of Post-Procesed diag, not filled up but computed from other diags:
      diagIsPP = gdiag(ndId)(5:5).EQ.'P'

C-    Register negative "jdiag" when cumulating thickness (hFac) weighted field
      no_hFac = 1
      IF ( fflags(listId)(3:3).EQ.'h' ) THEN
        gcode = gdiag(ndId)(1:10)
        use_hFac = ( gcode(2:2).EQ.'U' .OR. gcode(2:2).EQ.'V'
     &                                 .OR. gcode(2:2).EQ.'M' )
        use_hFac = use_hFac .AND. gcode(9:10).EQ.'MR'
     &                      .AND. gcode(3:3).EQ.'R'
     &                      .AND. gcode(5:5).EQ.' '
        IF ( use_hFac ) no_hFac = -1
      ENDIF

C---  Seach for the same diag (with same freq) to see if already set
C     do it recursively on Post-Processed diag dependance (=mate)
C     until we find either one already set or a non Post-Processed diag
      flagD = .TRUE.
      flagP = .TRUE.
      nn = ndId
      DO WHILE ( flagP )
        DO l=1,listId
         IF (flagD .AND. freq(l) .EQ. freq(listId)
     &             .AND. phase(l).EQ.phase(listId)
     &             .AND. averageFreq(l) .EQ.averageFreq(listId)
     &             .AND. averagePhase(l).EQ.averagePhase(listId)
     &             .AND. averageCycle(l).EQ.averageCycle(listId) ) THEN
          DO k=1,MIN(nActive(l),numperList)
           IF ( flagD .AND. no_hFac*jdiag(k,l).GT.0 ) THEN
            IF ( cdiag(nn).EQ.cdiag(ABS(jdiag(k,l))) ) THEN
C-    diagnostics already set ; use the same slot:
             flagD = .FALSE.
             idiag(mId,listId) = -ABS(idiag(k,l))
             mdiag(mId,listId) = mdiag(k,l)
            ENDIF
           ENDIF
          ENDDO
         ENDIF
        ENDDO
        flagP = flagD .AND. gdiag(nn)(5:5).EQ.'P'
        IF ( flagP ) nn = hdiag(nn)
      ENDDO
      jdiag(mId,listId) = no_hFac*ndId

C---  Set pointer if not already set, otherwise just print a message

      IF ( diagIsPP ) THEN
        WRITE(msgBuf,'(2(A,I6,1X,A))')
     &    'SETDIAG: Diag #', ndId, cdiag(ndId),
     &    ' processed from Diag #',nn,cdiag(nn)
        CALL PRINT_MESSAGE(msgBuf, stdUnit, SQUEEZE_RIGHT, myThid)
      ENDIF
      gcode   = gdiag(nn)(1:10)
      IF ( flagD ) THEN
        IF ( diagIsPP ) THEN
C-      Add this diag with negative idiag pointer (since those 2 diags
C        share the same pointer and "nn" will get the positive pointer).
          idiag(mId,listId) = -(ndiagmx+1)
C-      Also add "nn" to the Active list
          k = nActive(listId) + 1
          IF ( k.LE.numperList ) THEN
            jdiag(k,listId) = nn
            idiag(k,listId) = ndiagmx + 1
            flds (k,listId) = cdiag(nn)
          ENDIF
          nActive(listId) = k
        ELSE
          idiag(mId,listId) = ndiagmx + 1
        ENDIF
        ndiagmx = ndiagmx + kdiag(nn)*averageCycle(listId)
        IF ( ndiagmx.GT.numDiags ) THEN
         WRITE(msgBuf,'(A,I6,1X,A)')
     &    'SETDIAG: Not enough space for Diagnostic #',nn,cdiag(nn)
         CALL PRINT_MESSAGE(msgBuf, errUnit, SQUEEZE_RIGHT, myThid)
        ELSE
         WRITE(msgBuf,'(A,2(I3,A),I6,1X,A)') 'SETDIAG: Allocate',
     &                   kdiag(nn), ' x', averageCycle(listId),
     &                ' Levels for Diagnostic #', nn, cdiag(nn)
         CALL PRINT_MESSAGE(msgBuf, stdUnit, SQUEEZE_RIGHT, myThid)
        ENDIF
      ELSE
        tmpMsg = ' Diagnostic '
        WRITE(msgBuf,'(3A,I6,1X,2A)') '- NOTE - SETDIAG: ',tmpMsg,
     &           ' #', nn, cdiag(nn), ' is already set'
        CALL PRINT_MESSAGE(msgBuf, stdUnit, SQUEEZE_RIGHT, myThid)
      ENDIF

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C---  Check for Counter Diagnostic
      mate = 0

C-    if Post-Processed diag, activate 2nd components of vector field
      tmpMsg = ' Vector-mate'
      IF ( diagIsPP .AND. gcode(5:5).NE.'P' .AND.
     &    (gcode(1:1).EQ.'U' .OR. gcode(1:1).EQ.'V') ) mate = hdiag(nn)
C-    activate mate if this is a Counter Diagnostic
      IF ( gcode(5:5).EQ.'C') THEN
        mate = hdiag(nn)
        tmpMsg = 'Counter-mate'
      ENDIF

      IF ( mate.GT.0 ) THEN
C--     Seach for the same diag (with same freq) to see if already set
        flagM = .TRUE.
        DO l=1,listId
         IF (flagM .AND. freq(l) .EQ.freq(listId)
     &             .AND. phase(l).EQ.phase(listId)
     &             .AND. averageFreq(l) .EQ.averageFreq(listId)
     &             .AND. averagePhase(l).EQ.averagePhase(listId)
     &             .AND. averageCycle(l).EQ.averageCycle(listId) ) THEN
          DO k=1,MIN(nActive(l),numperList)
           IF (flagM .AND. jdiag(k,l).GT.0) THEN
            IF (cdiag(mate).EQ.cdiag(jdiag(k,l)) ) THEN
C-    diagnostics already set ; use the same slot:
             flagM = .FALSE.
             mdiag(mId,listId) = ABS(idiag(k,l))
            ENDIF
           ENDIF
          ENDDO
         ENDIF
        ENDDO

C---  Set pointer if not already set, otherwise just print a message
        IF ( flagM ) THEN
          mdiag(mId,listId) = ndiagmx + 1
          k = nActive(listId) + 1
          IF ( k.LE.numperList ) THEN
C-      Also add mate to the Active list
            jdiag(k,listId) = mate
            idiag(k,listId) = ndiagmx + 1
            flds (k,listId) = cdiag(mate)
          ENDIF
          nActive(listId) = k
          ndiagmx = ndiagmx + kdiag(mate)*averageCycle(listId)
          IF ( ndiagmx.GT.numDiags ) THEN
           WRITE(msgBuf,'(3A,I6,1X,A)')
     &      'SETDIAG: Not enough space for ',tmpMsg,' #',
     &      mate, cdiag(mate)
           CALL PRINT_MESSAGE(msgBuf, errUnit, SQUEEZE_RIGHT, myThid)
          ELSE
           WRITE(msgBuf,'(A,2(I3,A),I6,1X,A)') 'SETDIAG: Allocate',
     &                     kdiag(mate), ' x', averageCycle(listId),
     &                  ' Levels for Mate Diag. #', mate, cdiag(mate)
           CALL PRINT_MESSAGE(msgBuf, stdUnit, SQUEEZE_RIGHT, myThid)
          ENDIF
        ELSE
          WRITE(msgBuf,'(3A,I6,1X,2A)') '- NOTE - SETDIAG: ',tmpMsg,
     &    ' #', mate, cdiag(mate), ' is already set'
          CALL PRINT_MESSAGE(msgBuf, stdUnit, SQUEEZE_RIGHT, myThid)
        ENDIF
      ENDIF

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
      RETURN
      END

#include "GMREDI_OPTIONS.h"
#ifdef ALLOW_AUTODIFF
# include "AUTODIFF_OPTIONS.h"
#endif
#ifdef ALLOW_CTRL
# include "CTRL_OPTIONS.h"
#endif
#ifdef ALLOW_KPP
# include "KPP_OPTIONS.h"
#endif
#if ( defined GM_READ_K3D_REDI || defined GM_VISBECK_VARIABLE_K \
      || defined ALLOW_GM_LEITH_QG || defined GM_BATES_K3D )
# define GM_USE_K3D_REDI
#endif
C no GM_GEOM_VARIABLE here since it is at a different location
#if ( defined GM_READ_K3D_GM   || defined GM_VISBECK_VARIABLE_K \
      || defined ALLOW_GM_LEITH_QG || defined GM_BATES_K3D )
# define GM_USE_K3D_GM
#endif

CBOP
C     !ROUTINE: GMREDI_CALC_TENSOR
C     !INTERFACE:
      SUBROUTINE GMREDI_CALC_TENSOR(
     I             iMin, iMax, jMin, jMax,
     I             sigmaX, sigmaY, sigmaR,
     I             bi, bj, myTime, myIter, myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE GMREDI_CALC_TENSOR
C     | o Calculate tensor elements for GM/Redi tensor.
C     *==========================================================*
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     == Global variables ==
#include "SIZE.h"
#include "GRID.h"
#include "DYNVARS.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GMREDI.h"
#ifdef ALLOW_CTRL
# include "CTRL_FIELDS.h"
#endif
#ifdef ALLOW_KPP
# include "KPP.h"
#endif

#ifdef ALLOW_AUTODIFF_TAMC
# include "tamc.h"
#endif /* ALLOW_AUTODIFF_TAMC */

C     !INPUT/OUTPUT PARAMETERS:
C     bi, bj    :: tile indices
C     myTime    :: Current time in simulation
C     myIter    :: Current iteration number in simulation
C     myThid    :: My Thread Id. number
C
      INTEGER iMin,iMax,jMin,jMax
      _RL sigmaX(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL sigmaY(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL sigmaR(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      INTEGER bi, bj
      _RL     myTime
      INTEGER myIter
      INTEGER myThid
CEOP

#ifdef ALLOW_GMREDI
C     !LOCAL VARIABLES:
C     maskFk    :: 2-D mask for vertical interface k (between level k-1 & k)
      INTEGER i,j,k
      _RS maskFk(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL SlopeX(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL SlopeY(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL dSigmaDx(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL dSigmaDy(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL dSigmaDr(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL SlopeSqr(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL taperFct(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL ldd97_LrhoC(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL ldd97_LrhoW(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL ldd97_LrhoS(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL Cspd, LrhoInf, LrhoSup, fCoriLoc, rDepth
      _RL Kgm_tmp, Kredi_tmp, isopycK, bolus_K

      INTEGER kLow_W (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER kLow_S (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL locMixLayer(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL baseSlope  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL hTransLay  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL recipLambda(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER km1
#if ( defined GM_NON_UNITY_DIAGONAL || defined GM_EXTRA_DIAGONAL )
      INTEGER kp1
      _RL maskp1
#endif
#ifdef GM_USE_K3D_REDI
      _RL locK3dRedi(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
#endif
#ifdef GM_USE_K3D_GM
      _RL locK3dGM(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
#else
      _RL locK3dGM(1)
#endif

#ifdef GM_VISBECK_VARIABLE_K
      INTEGER ks
      _RL dSigmaH, dSigmaR, Sloc, rTop
c     _RL M2loc
      _RL recipMaxSlope
      _RL deltaH, integrDepth
      _RL N2loc, SNloc
#endif /* GM_VISBECK_VARIABLE_K */

#ifdef ALLOW_DIAGNOSTICS
      LOGICAL  doDiagRediFlx
      LOGICAL  DIAGNOSTICS_IS_ON
      EXTERNAL DIAGNOSTICS_IS_ON
# if ( defined GM_NON_UNITY_DIAGONAL || defined GM_EXTRA_DIAGONAL )
      _RL dTdz
      _RL tmp1k(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
# endif
#endif /* ALLOW_DIAGNOSTICS */
#ifdef ALLOW_AUTODIFF_TAMC
C     tkey :: tape key (depends on tiles)
C     kkey :: tape key (depends on levels and tiles)
      INTEGER tkey, kkey
#endif

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#ifdef ALLOW_AUTODIFF_TAMC
      tkey = bi + (bj-1)*nSx + (ikey_dynamics-1)*nSx*nSy
#endif /* ALLOW_AUTODIFF_TAMC */

#ifdef ALLOW_DIAGNOSTICS
      doDiagRediFlx = .FALSE.
      IF ( useDiagnostics ) THEN
        doDiagRediFlx = DIAGNOSTICS_IS_ON('GM_KuzTz', myThid )
        doDiagRediFlx = doDiagRediFlx .OR.
     &                  DIAGNOSTICS_IS_ON('GM_KvzTz', myThid )
      ENDIF
#endif

#ifdef GM_VISBECK_VARIABLE_K
      recipMaxSlope = 0. _d 0
      IF ( GM_Visbeck_maxSlope.GT.0. _d 0 ) THEN
        recipMaxSlope = 1. _d 0 / GM_Visbeck_maxSlope
      ENDIF
      DO j=1-OLy,sNy+OLy
       DO i=1-OLx,sNx+OLx
        VisbeckK(i,j,bi,bj) = 0. _d 0
       ENDDO
      ENDDO
#endif

C--   set ldd97_Lrho (for tapering scheme ldd97):
      IF ( GM_taper_scheme.EQ.'ldd97' .OR.
     &     GM_taper_scheme.EQ.'fm07' ) THEN
       Cspd = 2. _d 0
       LrhoInf = 15. _d 3
       LrhoSup = 100. _d 3
C-     Tracer point location (center):
       DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
         IF (fCori(i,j,bi,bj).NE.0.) THEN
           ldd97_LrhoC(i,j) = Cspd/ABS(fCori(i,j,bi,bj))
         ELSE
           ldd97_LrhoC(i,j) = LrhoSup
         ENDIF
         ldd97_LrhoC(i,j) = MAX(LrhoInf,MIN(ldd97_LrhoC(i,j),LrhoSup))
        ENDDO
       ENDDO
C-     U point location (West):
       DO j=1-OLy,sNy+OLy
        kLow_W(1-OLx,j) = 0
        ldd97_LrhoW(1-OLx,j) = LrhoSup
        DO i=1-OLx+1,sNx+OLx
         kLow_W(i,j) = MIN(kLowC(i-1,j,bi,bj),kLowC(i,j,bi,bj))
         fCoriLoc = op5*(fCori(i-1,j,bi,bj)+fCori(i,j,bi,bj))
         IF ( fCoriLoc.NE.zeroRL ) THEN
           ldd97_LrhoW(i,j) = Cspd/ABS(fCoriLoc)
         ELSE
           ldd97_LrhoW(i,j) = LrhoSup
         ENDIF
         ldd97_LrhoW(i,j) = MAX(LrhoInf,MIN(ldd97_LrhoW(i,j),LrhoSup))
        ENDDO
       ENDDO
C-     V point location (South):
       DO i=1-OLx+1,sNx+OLx
         kLow_S(i,1-OLy) = 0
         ldd97_LrhoS(i,1-OLy) = LrhoSup
       ENDDO
       DO j=1-OLy+1,sNy+OLy
        DO i=1-OLx,sNx+OLx
         kLow_S(i,j) = MIN(kLowC(i,j-1,bi,bj),kLowC(i,j,bi,bj))
         fCoriLoc = op5*(fCori(i,j-1,bi,bj)+fCori(i,j,bi,bj))
         IF ( fCoriLoc.NE.zeroRL ) THEN
           ldd97_LrhoS(i,j) = Cspd/ABS(fCoriLoc)
         ELSE
           ldd97_LrhoS(i,j) = LrhoSup
         ENDIF
         ldd97_LrhoS(i,j) = MAX(LrhoInf,MIN(ldd97_LrhoS(i,j),LrhoSup))
        ENDDO
       ENDDO
      ELSE
C-    Just initialize to zero (not use anyway)
       DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
          ldd97_LrhoC(i,j) = 0. _d 0
          ldd97_LrhoW(i,j) = 0. _d 0
          ldd97_LrhoS(i,j) = 0. _d 0
        ENDDO
       ENDDO
      ENDIF

#ifdef GM_BOLUS_ADVEC
      DO k=1,Nr
       DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
         GM_PsiX(i,j,k,bi,bj)  = 0. _d 0
         GM_PsiY(i,j,k,bi,bj)  = 0. _d 0
        ENDDO
       ENDDO
      ENDDO
#endif /* GM_BOLUS_ADVEC */
#ifdef GM_USE_K3D_REDI
      DO k=1,Nr
       DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
         locK3dRedi(i,j,k) =
# ifdef GM_READ_K3D_REDI
     &       GM_inpK3dRedi(i,j,k,bi,bj)
# else
     &       GM_isopycK*GM_isoFac1d(k)*GM_isoFac2d(i,j,bi,bj)
# endif
        ENDDO
       ENDDO
      ENDDO
#endif /* GM_USE_K3D_REDI */
#ifdef GM_USE_K3D_GM
      DO k=1,Nr
       DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
         locK3dGM(i,j,k) =
# ifdef GM_READ_K3D_GM
     &       GM_inpK3dGM(i,j,k,bi,bj)
# else
     &       GM_background_K*GM_bolFac1d(k)*GM_bolFac2d(i,j,bi,bj)
# endif
        ENDDO
       ENDDO
      ENDDO
#else
      locK3dGM(1) = 0. _d 0
#endif /* GM_USE_K3D_GM */
#ifdef ALLOW_AUTODIFF
      DO k=1,Nr
       DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
         Kwx(i,j,k,bi,bj)  = 0. _d 0
         Kwy(i,j,k,bi,bj)  = 0. _d 0
         Kwz(i,j,k,bi,bj)  = 0. _d 0
         Kux(i,j,k,bi,bj)  = 0. _d 0
         Kvy(i,j,k,bi,bj)  = 0. _d 0
# ifdef GM_EXTRA_DIAGONAL
         Kuz(i,j,k,bi,bj)  = 0. _d 0
         Kvz(i,j,k,bi,bj)  = 0. _d 0
# endif
        ENDDO
       ENDDO
      ENDDO
#endif /* ALLOW_AUTODIFF */

C--   Initialise Mixed Layer related array:
      DO j=1-OLy,sNy+OLy
       DO i=1-OLx,sNx+OLx
         hTransLay(i,j) = R_low(i,j,bi,bj)
         baseSlope(i,j) =  0. _d 0
         recipLambda(i,j) = 0. _d 0
         locMixLayer(i,j) = 0. _d 0
       ENDDO
      ENDDO
#ifdef ALLOW_KPP
      IF ( useKPP ) THEN
       DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
         locMixLayer(i,j) = KPPhbl(i,j,bi,bj)
        ENDDO
       ENDDO
      ELSE
#else
      IF ( .TRUE. ) THEN
#endif
       DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
         locMixLayer(i,j) = hMixLayer(i,j,bi,bj)
        ENDDO
       ENDDO
      ENDIF

#ifdef GM_BATES_K3D
      IF (GM_useBatesK3d) THEN
C     Calculate the 3D diffusivity as per Bates et al. (JPO, 2014)
        CALL TIMER_START('GMREDI_CALC_BATES_K [GMREDI_CALC_TENSOR]',
     &                    myThid)
        CALL GMREDI_CALC_BATES_K(
     I       iMin, iMax, jMin, jMax,
     I       sigmaX, sigmaY, sigmaR,
     I       bi, bj, myTime, myIter, myThid )
        CALL TIMER_STOP('GMREDI_CALC_BATES_K [GMREDI_CALC_TENSOR]',
     &                  myThid)
# ifndef GM_BATES_PASSIVE
        DO k=1,Nr
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           locK3dRedi(i,j,k) = locK3dRedi(i,j,k)
     &          + GM_BatesK3d(i,j,k,bi,bj)*GM_isoFac_calcK
           locK3dGM(i,j,k)   = locK3dGM(i,j,k)
     &          + GM_BatesK3d(i,j,k,bi,bj)
          ENDDO
         ENDDO
        ENDDO
# endif
      ENDIF
#endif

#ifdef ALLOW_GM_LEITH_QG
# ifdef ALLOW_AUTODIFF
      DO k=1,Nr
       DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
          GM_LeithQG_K(i,j,k,bi,bj) = 0. _d 0
        ENDDO
       ENDDO
      ENDDO
# endif
      IF ( GM_useLeithQG ) THEN
C   Use Leith QG viscosity in GMRedi scheme
        CALL GMREDI_CALC_QGLEITH(
     O                GM_LeithQG_K(1-OLx,1-OLy,1,bi,bj),
     I                bi, bj, myTime, myIter, myThid )
        DO k=1,Nr
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           locK3dRedi(i,j,k) = locK3dRedi(i,j,k)
     &          + GM_LeithQG_K(i,j,k,bi,bj)*GM_isoFac_calcK
           locK3dGM(i,j,k)   = locK3dGM(i,j,k)
     &          + GM_LeithQG_K(i,j,k,bi,bj)
          ENDDO
         ENDDO
        ENDDO
      ENDIF
#endif /* ALLOW_GM_LEITH_QG */

#ifdef GM_GEOM_VARIABLE_K
C     Calculate the kgm as per the GEOMETRIC formulation
C        (e.g. Mak et al, 2018; see also Marshall et al, 2012)
      IF ( GM_useGEOM ) THEN
        DO k=1,Nr
          DO j=1-OLy,sNy+OLy
            DO i=1-OLx,sNx+OLx
              GEOM_K3d(i,j,k,bi,bj) = 0. _d 0
            ENDDO
          ENDDO
        ENDDO
        CALL GMREDI_CALC_GEOM(
     I              sigmaX, sigmaY, sigmaR,
     I              bi, bj, myTime, myIter, myThid )
      ENDIF
#endif /* GM_GEOM_VARIABLE_K */

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C-- 1rst loop on k : compute Tensor Coeff. at W points.

      DO k=Nr,2,-1

       DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
#ifdef ALLOW_AUTODIFF
         SlopeX(i,j)       = 0. _d 0
         SlopeY(i,j)       = 0. _d 0
         dSigmaDx(i,j)    = 0. _d 0
         dSigmaDy(i,j)     = 0. _d 0
         dSigmaDr(i,j)     = 0. _d 0
         SlopeSqr(i,j)     = 0. _d 0
         taperFct(i,j)     = 0. _d 0
#endif /* ALLOW_AUTODIFF */
         maskFk(i,j)       = maskC(i,j,k-1,bi,bj)*maskC(i,j,k,bi,bj)
        ENDDO
       ENDDO

       DO j=1-OLy+1,sNy+OLy-1
        DO i=1-OLx+1,sNx+OLx-1
C      Gradient of Sigma at rVel points
         dSigmaDx(i,j)=op25*( sigmaX(i+1,j,k-1)+sigmaX(i,j,k-1)
     &                       +sigmaX(i+1,j, k )+sigmaX(i,j, k )
     &                      )*maskFk(i,j)
         dSigmaDy(i,j)=op25*( sigmaY(i,j+1,k-1)+sigmaY(i,j,k-1)
     &                       +sigmaY(i,j+1, k )+sigmaY(i,j, k )
     &                      )*maskFk(i,j)
c        dSigmaDr(i,j)=sigmaR(i,j,k)
        ENDDO
       ENDDO

#ifdef GM_VISBECK_VARIABLE_K
# ifdef ALLOW_AUTODIFF_TAMC
CADJ INCOMPLETE dSigmaDr
# endif
       IF ( GM_Visbeck_alpha.GT.zeroRL .AND.
     &      -rC(k-1).LT.GM_Visbeck_depth ) THEN

        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          dSigmaDr(i,j) = MAX( gravitySign*sigmaR(i,j,k), zeroRL )
         ENDDO
        ENDDO

C--     Depth average of f/sqrt(Ri) = M^2/N^2 * N
C       M^2 and N^2 are horizontal & vertical gradient of buoyancy.

C       Calculate terms for mean Richardson number which is used
C       in the "variable K" parameterisaton:
C       compute depth average from surface down to the bottom or
C       GM_Visbeck_depth, whatever is the shallower.

        rTop = rF(1)
        DO j=1-OLy+1,sNy+OLy-1
         DO i=1-OLx+1,sNx+OLx-1
          IF ( maskFk(i,j).NE.zeroRS ) THEN
           ks = kSurfC(i,j,bi,bj)
C-      If dry-cell @ top (e.g., under ice-shelf), integrate over Visbeck_depth
C       as relative to top solid BC (as below) or stop integral if deeper (in
C       absolute sense) than Visbeck_depth (just comment "rTop =" line below):
           rTop = Ro_surf(i,j,bi,bj)
           integrDepth = rTop - rC( kLowC(i,j,bi,bj) )
C-      in 2 steps to avoid mix of RS & RL type in min fct. arguments
           integrDepth = MIN( integrDepth, GM_Visbeck_depth )
C-      to recover "old-visbeck" form with Visbeck_minDepth = Visbeck_depth
           integrDepth = MAX( integrDepth, GM_Visbeck_minDepth )
C       Distance between level center above and the integration depth
           deltaH = integrDepth - rTop + rC(k-1)
C       If negative then we are below the integration level
C       (cannot be the case with 2 conditions on maskC & -rC(k-1))
C       If positive we limit this to the distance from center above
           deltaH = MIN( deltaH, drC(k) )
C       Now we convert deltaH to a non-dimensional fraction
           deltaH = deltaH/( integrDepth - rTop + rC(ks) )

C--      compute: ( M^2 * S )^1/2   (= S*N since S=M^2/N^2 )
C        a 5 points average gives a more "homogeneous" formulation
C        (same stencil and same weights as for dSigmaH calculation)
           dSigmaR = ( dSigmaDr(i,j)*4. _d 0
     &               + dSigmaDr(i-1,j)
     &               + dSigmaDr(i+1,j)
     &               + dSigmaDr(i,j-1)
     &               + dSigmaDr(i,j+1)
     &               )/( 4. _d 0
     &                 + maskFk(i-1,j)
     &                 + maskFk(i+1,j)
     &                 + maskFk(i,j-1)
     &                 + maskFk(i,j+1)
     &                 )
           dSigmaH = dSigmaDx(i,j)*dSigmaDx(i,j)
     &             + dSigmaDy(i,j)*dSigmaDy(i,j)
           IF ( dSigmaH .GT. 0. _d 0 ) THEN
             dSigmaH = SQRT( dSigmaH )
# ifdef ALLOW_AUTODIFF_TAMC
C     This gets rid of a TAF-recomputation warning for dSigmaH that is
C     not associated with any actual recomputations. TAF is probably
C     just confused by the cascade of if-statements.
           ENDIF
           IF ( dSigmaH .GT. 0. _d 0 ) THEN
# endif
C-       compute slope, limited by GM_Visbeck_maxSlope:
             IF ( dSigmaR.GT.dSigmaH*recipMaxSlope ) THEN
              Sloc = dSigmaH / dSigmaR
             ELSE
              Sloc = GM_Visbeck_maxSlope
             ENDIF
c            M2loc = gravity*recip_rhoConst*dSigmaH
             N2loc = gravity*recip_rhoConst*dSigmaR
             IF ( N2loc.GT.0. _d 0 ) THEN
               SNloc = Sloc*SQRT(N2loc)
             ELSE
               SNloc = 0. _d 0
             ENDIF
           ELSE
             SNloc = 0. _d 0
           ENDIF
           VisbeckK(i,j,bi,bj) = VisbeckK(i,j,bi,bj)
     &       +deltaH*GM_Visbeck_alpha
     &              *GM_Visbeck_length*GM_Visbeck_length*SNloc
          ENDIF
         ENDDO
        ENDDO
       ENDIF
#endif /* GM_VISBECK_VARIABLE_K */
C     Z-Coords: change sign of vertical Sigma gradient (always downward)
C     to match stratification sign (i.e., positive if stratified)
       DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
         dSigmaDr(i,j) = gravitySign*sigmaR(i,j,k)
        ENDDO
       ENDDO

#ifdef ALLOW_AUTODIFF_TAMC
       kkey = k + (tkey-1)*Nr
CADJ STORE dSigmaDx(:,:)       = comlev1_bibj_k, key=kkey, byte=isbyte
CADJ STORE dSigmaDy(:,:)       = comlev1_bibj_k, key=kkey, byte=isbyte
CADJ STORE dSigmaDr(:,:)       = comlev1_bibj_k, key=kkey, byte=isbyte
# ifndef GM_EXCLUDE_FM07_TAP
CADJ STORE baseSlope(:,:)      = comlev1_bibj_k, key=kkey, byte=isbyte
CADJ STORE hTransLay(:,:)      = comlev1_bibj_k, key=kkey, byte=isbyte
CADJ STORE recipLambda(:,:)    = comlev1_bibj_k, key=kkey, byte=isbyte
# endif
#endif /* ALLOW_AUTODIFF_TAMC */

C     set "rDepth" (= depth from the surface, in rUnit) for 'ldd97' tapering
       IF ( usingZcoords ) THEN
        rDepth = rF(1) - rF(k)
       ELSE
        rDepth = rF(k) - rF(Nr+1)
       ENDIF
C     Calculate slopes for use in tensor, taper and/or clip
       CALL GMREDI_SLOPE_LIMIT(
     O             SlopeX, SlopeY,
     O             SlopeSqr, taperFct,
     U             hTransLay, baseSlope, recipLambda,
     U             dSigmaDr,
     I             dSigmaDx, dSigmaDy,
     I             ldd97_LrhoC, locMixLayer, rDepth, rF,
     I             kLowC(1-OLx,1-OLy,bi,bj),
     I             3, k, bi, bj, myTime, myIter, myThid )

#ifdef GMREDI_MASK_SLOPES
       DO j=1-OLy+1,sNy+OLy-1
        DO i=1-OLx+1,sNx+OLx-1
C      Mask Iso-neutral slopes
         SlopeX(i,j)   = SlopeX(i,j)*maskFk(i,j)
         SlopeY(i,j)   = SlopeY(i,j)*maskFk(i,j)
         SlopeSqr(i,j) = SlopeSqr(i,j)*maskFk(i,j)
        ENDDO
       ENDDO
#endif

#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE SlopeX(:,:)       = comlev1_bibj_k, key=kkey, byte=isbyte
CADJ STORE SlopeY(:,:)       = comlev1_bibj_k, key=kkey, byte=isbyte
CADJ STORE SlopeSqr(:,:)     = comlev1_bibj_k, key=kkey, byte=isbyte
CADJ STORE dSigmaDr(:,:)     = comlev1_bibj_k, key=kkey, byte=isbyte
CADJ STORE taperFct(:,:)     = comlev1_bibj_k, key=kkey, byte=isbyte
#endif /* ALLOW_AUTODIFF_TAMC */

C     Components of Redi/GM tensor, first step with just the slope:
C     P-Coords: since slope comp. have same sign as in Z-coord, need to
C     flip sign of extra-diagonal component (see manual sec. 8.4.1.2.4)
       DO j=1-OLy+1,sNy+OLy-1
        DO i=1-OLx+1,sNx+OLx-1
          Kwx(i,j,k,bi,bj) = -gravitySign*SlopeX(i,j)*taperFct(i,j)
          Kwy(i,j,k,bi,bj) = -gravitySign*SlopeY(i,j)*taperFct(i,j)
          Kwz(i,j,k,bi,bj) = SlopeSqr(i,j)*taperFct(i,j)
        ENDDO
       ENDDO

C-- end 1rst loop on vertical level index k
      ENDDO

#ifdef GM_VISBECK_VARIABLE_K
# ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE VisbeckK(:,:,bi,bj) = comlev1_bibj, key=tkey, byte=isbyte
# endif
      IF ( GM_Visbeck_alpha.GT.zeroRL ) THEN
C-     Limit range that Kappa-GM can take
       DO j=1-OLy+1,sNy+OLy-1
        DO i=1-OLx+1,sNx+OLx-1
         VisbeckK(i,j,bi,bj)=
     &       MIN( MAX( VisbeckK(i,j,bi,bj), GM_Visbeck_minVal_K ),
     &            GM_Visbeck_maxVal_K )
        ENDDO
       ENDDO
       DO k=1,Nr
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          locK3dRedi(i,j,k) = locK3dRedi(i,j,k)
     &         + VisbeckK(i,j,bi,bj)*GM_isoFac_calcK
          locK3dGM(i,j,k)   = locK3dGM(i,j,k)
     &         + VisbeckK(i,j,bi,bj)
         ENDDO
        ENDDO
       ENDDO
      ENDIF
C     If you want to avoid recomputing the above loop, you can uncomment
C     the following lines.
c# ifdef ALLOW_AUTODIFF_TAMC
cCADJ STORE VisbeckK(:,:,bi,bj) = comlev1_bibj, key=tkey, byte=isbyte
c# endif
#endif /* GM_VISBECK_VARIABLE_K */

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C--   Calculate Stream-Functions used in Advective Form:

#ifdef GM_BOLUS_ADVEC
      IF (GM_AdvForm) THEN
# ifdef GM_BOLUS_BVP
       IF (GM_UseBVP) THEN
        CALL GMREDI_CALC_PSI_BVP(
     I             bi, bj, iMin, iMax, jMin, jMax,
     I             sigmaX, sigmaY, sigmaR,
     I             myThid )
       ELSE
# endif
# ifndef GM_BATES_PASSIVE
         IF ( .NOT.GM_useBatesK3d ) THEN
# endif
C          If using BatesK3d PsiX and PsiY are calculated in GMREDI_CALC_BATES_K
           CALL GMREDI_CALC_PSI_BOLUS(
     I              bi, bj, iMin, iMax, jMin, jMax,
     I              sigmaX, sigmaY, sigmaR, locK3dGM,
     I              ldd97_LrhoW, ldd97_LrhoS,
     I              myThid )
# ifndef GM_BATES_PASSIVE
         ENDIF
# endif
# ifdef GM_BOLUS_BVP
       ENDIF
# endif
      ENDIF
#endif /* GM_BOLUS_ADVEC */

#ifndef GM_EXCLUDE_SUBMESO
      IF ( GM_useSubMeso .AND. GM_AdvForm ) THEN
        CALL SUBMESO_CALC_PSI(
     I              bi, bj, iMin, iMax, jMin, jMax,
     I              sigmaX, sigmaY, sigmaR,
     I              locMixLayer,
     I              myIter, myThid )
c    U              locK3dRedi
      ENDIF
#endif /* ndef GM_EXCLUDE_SUBMESO */

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C     Update components of Redi/GM tensor, second step: multiply by Diffusivity
      DO k=1,Nr
#ifdef ALLOW_AUTODIFF_TAMC
C to avoid few minor recomputations (with KAPREDI_CONTROL, KAPGM_CONTROL ?)
       kkey = k + (tkey-1)*Nr
CADJ STORE Kwx(:,:,k,bi,bj) = comlev1_bibj_k, key=kkey, byte=isbyte
CADJ STORE Kwy(:,:,k,bi,bj) = comlev1_bibj_k, key=kkey, byte=isbyte
CADJ STORE Kwz(:,:,k,bi,bj) = comlev1_bibj_k, key=kkey, byte=isbyte
#endif
       km1 = MAX(k-1,1)
       isopycK = GM_isopycK
     &         *(GM_isoFac1d(km1)+GM_isoFac1d(k))*op5
       bolus_K = GM_background_K
     &         *(GM_bolFac1d(km1)+GM_bolFac1d(k))*op5
       DO j=1-OLy+1,sNy+OLy-1
        DO i=1-OLx+1,sNx+OLx-1
         Kredi_tmp =
#ifdef GM_USE_K3D_REDI
     &      op5*( locK3dRedi(i,j,km1) + locK3dRedi(i,j,k) )
#else
     &      isopycK*GM_isoFac2d(i,j,bi,bj)
#endif
         Kgm_tmp = Kredi_tmp
#ifdef GM_USE_K3D_GM
     &    + GM_skewflx*op5*( locK3dGM(i,j,km1)+locK3dGM(i,j,k) )
#else
     &    + GM_skewflx*bolus_K*GM_bolFac2d(i,j,bi,bj)
#endif
#ifdef GM_GEOM_VARIABLE_K
     &    + GM_skewflx*GEOM_K3d(i,j,k,bi,bj)
#endif
         Kwx(i,j,k,bi,bj) = Kgm_tmp*Kwx(i,j,k,bi,bj)
         Kwy(i,j,k,bi,bj) = Kgm_tmp*Kwy(i,j,k,bi,bj)
         Kwz(i,j,k,bi,bj) = Kredi_tmp*Kwz(i,j,k,bi,bj)
        ENDDO
       ENDDO
      ENDDO

#ifdef ALLOW_DIAGNOSTICS
      IF ( useDiagnostics .AND. GM_taper_scheme.EQ.'fm07' ) THEN
       CALL DIAGNOSTICS_FILL( hTransLay, 'GM_hTrsL', 0,1,2,bi,bj,myThid)
       CALL DIAGNOSTICS_FILL( baseSlope, 'GM_baseS', 0,1,2,bi,bj,myThid)
       CALL DIAGNOSTICS_FILL(recipLambda,'GM_rLamb', 0,1,2,bi,bj,myThid)
      ENDIF
#endif /* ALLOW_DIAGNOSTICS */

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
#if ( defined GM_NON_UNITY_DIAGONAL || defined GM_EXTRA_DIAGONAL )

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C-- 2nd  k loop : compute Tensor Coeff. at U point

# ifdef ALLOW_KPP
      IF ( useKPP ) THEN
       DO j=1-OLy,sNy+OLy
        DO i=2-OLx,sNx+OLx
         locMixLayer(i,j) = ( KPPhbl(i-1,j,bi,bj)
     &                      + KPPhbl( i ,j,bi,bj) )*op5
        ENDDO
       ENDDO
      ELSE
# else
      IF ( .TRUE. ) THEN
# endif
       DO j=1-OLy,sNy+OLy
        DO i=2-OLx,sNx+OLx
         locMixLayer(i,j) = ( hMixLayer(i-1,j,bi,bj)
     &                      + hMixLayer( i ,j,bi,bj) )*op5
        ENDDO
       ENDDO
      ENDIF
      DO j=1-OLy,sNy+OLy
       DO i=1-OLx,sNx+OLx
         hTransLay(i,j) =  0.
         baseSlope(i,j) =  0.
         recipLambda(i,j)= 0.
       ENDDO
       DO i=2-OLx,sNx+OLx
         hTransLay(i,j) = MAX( R_low(i-1,j,bi,bj), R_low(i,j,bi,bj) )
       ENDDO
      ENDDO

      DO k=Nr,1,-1
       kp1 = MIN(Nr,k+1)
       maskp1 = 1. _d 0
       IF (k.GE.Nr) maskp1 = 0. _d 0
# ifdef ALLOW_AUTODIFF_TAMC
       kkey = k + (tkey-1)*Nr
# endif

C     Gradient of Sigma at U points
       DO j=1-OLy+1,sNy+OLy-1
        DO i=1-OLx+1,sNx+OLx-1
         dSigmaDx(i,j)=sigmaX(i,j,k)
     &                       *_maskW(i,j,k,bi,bj)
         dSigmaDy(i,j)=op25*( sigmaY(i-1,j+1,k)+sigmaY(i,j+1,k)
     &                       +sigmaY(i-1, j ,k)+sigmaY(i, j ,k)
     &                      )*_maskW(i,j,k,bi,bj)
         dSigmaDr(i,j)=op25*( sigmaR(i-1,j, k )+sigmaR(i,j, k )
     &                      +(sigmaR(i-1,j,kp1)+sigmaR(i,j,kp1))*maskp1
     &                      )*_maskW(i,j,k,bi,bj)*gravitySign
        ENDDO
       ENDDO

# ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE dSigmaDx(:,:)       = comlev1_bibj_k, key=kkey, byte=isbyte
CADJ STORE dSigmaDy(:,:)       = comlev1_bibj_k, key=kkey, byte=isbyte
CADJ STORE dSigmaDr(:,:)       = comlev1_bibj_k, key=kkey, byte=isbyte
#  ifndef GM_EXCLUDE_FM07_TAP
CADJ STORE baseSlope(:,:)      = comlev1_bibj_k, key=kkey, byte=isbyte
CADJ STORE hTransLay(:,:)      = comlev1_bibj_k, key=kkey, byte=isbyte
CADJ STORE recipLambda(:,:)    = comlev1_bibj_k, key=kkey, byte=isbyte
#  endif
# endif /* ALLOW_AUTODIFF_TAMC */

C     set "rDepth" (= depth from the surface, in rUnit) for 'ldd97' tapering
       IF ( usingZcoords ) THEN
        rDepth = rF(1) - rC(k)
       ELSE
        rDepth = rC(k) - rF(Nr+1)
       ENDIF
C     Calculate slopes for use in tensor, taper and/or clip
       CALL GMREDI_SLOPE_LIMIT(
     O             SlopeX, SlopeY,
     O             SlopeSqr, taperFct,
     U             hTransLay, baseSlope, recipLambda,
     U             dSigmaDr,
     I             dSigmaDx, dSigmaDy,
     I             ldd97_LrhoW, locMixLayer, rDepth, rC,
     I             kLow_W,
     I             1, k, bi, bj, myTime, myIter, myThid )

# ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE taperFct(:,:)       = comlev1_bibj_k, key=kkey, byte=isbyte
# endif /* ALLOW_AUTODIFF_TAMC */

# ifdef GM_NON_UNITY_DIAGONAL
c      IF ( GM_nonUnitDiag ) THEN
        DO j=1-OLy+1,sNy+OLy-1
         DO i=1-OLx+1,sNx+OLx-1
          Kux(i,j,k,bi,bj) =
#  ifdef GM_USE_K3D_REDI
     &      op5*( locK3dRedi(i-1,j,k) + locK3dRedi(i,j,k) )
#  else
     &      GM_isopycK*GM_isoFac1d(k)
     &        *op5*(GM_isoFac2d(i-1,j,bi,bj)+GM_isoFac2d(i,j,bi,bj))
#  endif
     &     *taperFct(i,j)
         ENDDO
        ENDDO
#  if ( defined ALLOW_AUTODIFF_TAMC && defined GM_EXCLUDE_CLIPPING )
CADJ STORE Kux(:,:,k,bi,bj)  = comlev1_bibj_k, key=kkey, byte=isbyte
#  endif
        DO j=1-OLy+1,sNy+OLy-1
         DO i=1-OLx+1,sNx+OLx-1
          Kux(i,j,k,bi,bj) = MAX( Kux(i,j,k,bi,bj), GM_Kmin_horiz )
         ENDDO
        ENDDO
c      ENDIF
# endif /* GM_NON_UNITY_DIAGONAL */

# ifdef GM_EXTRA_DIAGONAL

#  ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE SlopeX(:,:)       = comlev1_bibj_k, key=kkey, byte=isbyte
#  endif /* ALLOW_AUTODIFF_TAMC */
       IF ( GM_ExtraDiag ) THEN
        DO j=1-OLy+1,sNy+OLy-1
         DO i=1-OLx+1,sNx+OLx-1
          Kuz(i,j,k,bi,bj) = -gravitySign*
#  ifdef GM_USE_K3D_REDI
     &     ( op5*( locK3dRedi(i-1,j,k) + locK3dRedi(i,j,k) )
#  else
     &     ( GM_isopycK*GM_isoFac1d(k)
     &        *op5*(GM_isoFac2d(i-1,j,bi,bj)+GM_isoFac2d(i,j,bi,bj))
#  endif
#  ifdef GM_USE_K3D_GM
     &     - GM_skewflx*op5*( locK3dGM(i-1,j,k) + locK3dGM(i,j,k) )
#  else
     &     - GM_skewflx*GM_background_K*GM_bolFac1d(k)
     &        *op5*(GM_bolFac2d(i-1,j,bi,bj)+GM_bolFac2d(i,j,bi,bj))
#  endif
#  ifdef GM_GEOM_VARIABLE_K
     &     - GM_skewflx*op25*( ( GEOM_K3d(i-1,j, k, bi,bj)
     &                         + GEOM_K3d( i, j, k, bi,bj) )
     &                       + ( GEOM_K3d(i-1,j,kp1,bi,bj)
     &                         + GEOM_K3d( i, j,kp1,bi,bj) ) )
#  endif
     &     )*SlopeX(i,j)*taperFct(i,j)
         ENDDO
        ENDDO
c      ELSE
c       DO j=1-OLy+1,sNy+OLy-1
c        DO i=1-OLx+1,sNx+OLx-1
c         Kuz(i,j,k,bi,bj) = 0. _d 0
c        ENDDO
c       ENDDO
       ENDIF
# endif /* GM_EXTRA_DIAGONAL */

# ifdef ALLOW_DIAGNOSTICS
       IF (doDiagRediFlx) THEN
        km1 = MAX(k-1,1)
        DO j=1,sNy
         DO i=1,sNx+1
C         store in tmp1k Kuz_Redi
          tmp1k(i,j) = -gravitySign*
#  ifdef GM_USE_K3D_REDI
     &      op5*( locK3dRedi(i-1,j,k)+ locK3dRedi(i,j,k) )
#  else
     &      GM_isopycK*GM_isoFac1d(k)
     &       *op5*(GM_isoFac2d(i-1,j,bi,bj)+GM_isoFac2d(i,j,bi,bj))
#  endif
     &     *SlopeX(i,j)*taperFct(i,j)
         ENDDO
        ENDDO
        DO j=1,sNy
         DO i=1,sNx+1
C-        Vertical gradients interpolated to U points
          dTdz = (
     &     +recip_drC(k)*
     &       ( maskC(i-1,j,km1,bi,bj)*maskC(i-1,j,k,bi,bj)*
     &           (theta(i-1,j,km1,bi,bj)-theta(i-1,j,k,bi,bj))
     &        +maskC( i ,j,km1,bi,bj)*maskC( i ,j,k,bi,bj)*
     &           (theta( i ,j,km1,bi,bj)-theta( i ,j,k,bi,bj))
     &       )
     &     +recip_drC(kp1)*
     &       ( maskC(i-1,j,k,bi,bj)*maskC(i-1,j,kp1,bi,bj)*
     &           (theta(i-1,j,k,bi,bj)-theta(i-1,j,kp1,bi,bj))
     &        +maskC( i ,j,k,bi,bj)*maskC( i ,j,kp1,bi,bj)*
     &           (theta( i ,j,k,bi,bj)-theta( i ,j,kp1,bi,bj))
     &       )      ) * 0.25 _d 0
           tmp1k(i,j) = dyG(i,j,bi,bj) * deepFacC(k)
     &                * drF(k) * _hFacW(i,j,k,bi,bj)
     &                * tmp1k(i,j) * dTdz
         ENDDO
        ENDDO
        CALL DIAGNOSTICS_FILL(tmp1k, 'GM_KuzTz', k,1,2,bi,bj,myThid)
       ENDIF
# endif /* ALLOW_DIAGNOSTICS */

C-- end 2nd  loop on vertical level index k
      ENDDO

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C-- 3rd  k loop : compute Tensor Coeff. at V point

# ifdef ALLOW_KPP
      IF ( useKPP ) THEN
       DO j=2-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
         locMixLayer(i,j) = ( KPPhbl(i,j-1,bi,bj)
     &                      + KPPhbl(i, j ,bi,bj) )*op5
        ENDDO
       ENDDO
      ELSE
# else
      IF ( .TRUE. ) THEN
# endif
       DO j=2-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
         locMixLayer(i,j) = ( hMixLayer(i,j-1,bi,bj)
     &                      + hMixLayer(i, j ,bi,bj) )*op5
        ENDDO
       ENDDO
      ENDIF
      DO j=1-OLy,sNy+OLy
       DO i=1-OLx,sNx+OLx
         hTransLay(i,j) =  0.
         baseSlope(i,j) =  0.
         recipLambda(i,j)= 0.
       ENDDO
      ENDDO
      DO j=2-OLy,sNy+OLy
       DO i=1-OLx,sNx+OLx
         hTransLay(i,j) = MAX( R_low(i,j-1,bi,bj), R_low(i,j,bi,bj) )
       ENDDO
      ENDDO

C     Gradient of Sigma at V points
      DO k=Nr,1,-1
       kp1 = MIN(Nr,k+1)
       maskp1 = 1. _d 0
       IF (k.GE.Nr) maskp1 = 0. _d 0
# ifdef ALLOW_AUTODIFF_TAMC
       kkey = k + (tkey-1)*Nr
# endif

       DO j=1-OLy+1,sNy+OLy-1
        DO i=1-OLx+1,sNx+OLx-1
         dSigmaDx(i,j)=op25*( sigmaX(i, j ,k) +sigmaX(i+1, j ,k)
     &                       +sigmaX(i,j-1,k) +sigmaX(i+1,j-1,k)
     &                      )*_maskS(i,j,k,bi,bj)
         dSigmaDy(i,j)=sigmaY(i,j,k)
     &                       *_maskS(i,j,k,bi,bj)
         dSigmaDr(i,j)=op25*( sigmaR(i,j-1, k )+sigmaR(i,j, k )
     &                      +(sigmaR(i,j-1,kp1)+sigmaR(i,j,kp1))*maskp1
     &                      )*_maskS(i,j,k,bi,bj)*gravitySign
        ENDDO
       ENDDO

# ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE dSigmaDx(:,:)       = comlev1_bibj_k, key=kkey, byte=isbyte
CADJ STORE dSigmaDy(:,:)       = comlev1_bibj_k, key=kkey, byte=isbyte
CADJ STORE dSigmaDr(:,:)       = comlev1_bibj_k, key=kkey, byte=isbyte
#  ifndef GM_EXCLUDE_FM07_TAP
CADJ STORE baseSlope(:,:)      = comlev1_bibj_k, key=kkey, byte=isbyte
CADJ STORE hTransLay(:,:)      = comlev1_bibj_k, key=kkey, byte=isbyte
CADJ STORE recipLambda(:,:)    = comlev1_bibj_k, key=kkey, byte=isbyte
#  endif
# endif /* ALLOW_AUTODIFF_TAMC */

C     set "rDepth" (= depth from the surface, in rUnit) for 'ldd97' tapering
       IF ( usingZcoords ) THEN
        rDepth = rF(1) - rC(k)
       ELSE
        rDepth = rC(k) - rF(Nr+1)
       ENDIF
C     Calculate slopes for use in tensor, taper and/or clip
       CALL GMREDI_SLOPE_LIMIT(
     O             SlopeX, SlopeY,
     O             SlopeSqr, taperFct,
     U             hTransLay, baseSlope, recipLambda,
     U             dSigmaDr,
     I             dSigmaDx, dSigmaDy,
     I             ldd97_LrhoS, locMixLayer, rDepth, rC,
     I             kLow_S,
     I             2, k, bi, bj, myTime, myIter, myThid )

# ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE taperFct(:,:)       = comlev1_bibj_k, key=kkey, byte=isbyte
# endif /* ALLOW_AUTODIFF_TAMC */

# ifdef GM_NON_UNITY_DIAGONAL
c      IF ( GM_nonUnitDiag ) THEN
        DO j=1-OLy+1,sNy+OLy-1
         DO i=1-OLx+1,sNx+OLx-1
          Kvy(i,j,k,bi,bj) =
#  ifdef GM_USE_K3D_REDI
     &      op5*( locK3dRedi(i,j-1,k) + locK3dRedi(i,j,k) )
#  else
     &      GM_isopycK*GM_isoFac1d(k)
     &        *op5*(GM_isoFac2d(i,j-1,bi,bj)+GM_isoFac2d(i,j,bi,bj))
#  endif
     &     *taperFct(i,j)
         ENDDO
        ENDDO
#  if ( defined ALLOW_AUTODIFF_TAMC && defined GM_EXCLUDE_CLIPPING )
CADJ STORE Kvy(:,:,k,bi,bj)  = comlev1_bibj_k, key=kkey, byte=isbyte
#  endif
        DO j=1-OLy+1,sNy+OLy-1
         DO i=1-OLx+1,sNx+OLx-1
          Kvy(i,j,k,bi,bj) = MAX( Kvy(i,j,k,bi,bj), GM_Kmin_horiz )
         ENDDO
        ENDDO
c      ENDIF
# endif /* GM_NON_UNITY_DIAGONAL */

# ifdef GM_EXTRA_DIAGONAL

#  ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE SlopeY(:,:)       = comlev1_bibj_k, key=kkey, byte=isbyte
#  endif /* ALLOW_AUTODIFF_TAMC */
       IF ( GM_ExtraDiag ) THEN
        DO j=1-OLy+1,sNy+OLy-1
         DO i=1-OLx+1,sNx+OLx-1
          Kvz(i,j,k,bi,bj) = -gravitySign*
#  ifdef GM_USE_K3D_REDI
     &     ( op5*( locK3dRedi(i,j-1,k) + locK3dRedi(i,j,k) )
#  else
     &     ( GM_isopycK*GM_isoFac1d(k)
     &        *op5*(GM_isoFac2d(i,j-1,bi,bj)+GM_isoFac2d(i,j,bi,bj))
#  endif
#  ifdef GM_USE_K3D_GM
     &     - GM_skewflx*op5*( locK3dGM(i,j-1,k) + locK3dGM(i,j,k) )
#  else
     &     - GM_skewflx*GM_background_K*GM_bolFac1d(k)
     &        *op5*(GM_bolFac2d(i,j-1,bi,bj)+GM_bolFac2d(i,j,bi,bj))
#  endif
#  ifdef GM_GEOM_VARIABLE_K
     &     - GM_skewflx*op25*( ( GEOM_K3d(i,j-1, k, bi,bj)
     &                         + GEOM_K3d(i, j,  k, bi,bj) )
     &                       + ( GEOM_K3d(i,j-1,kp1,bi,bj)
     &                         + GEOM_K3d(i, j, kp1,bi,bj) ) )
#  endif
     &     )*SlopeY(i,j)*taperFct(i,j)
         ENDDO
        ENDDO
c      ELSE
c       DO j=1-OLy+1,sNy+OLy-1
c        DO i=1-OLx+1,sNx+OLx-1
c         Kvz(i,j,k,bi,bj) = 0. _d 0
c        ENDDO
c       ENDDO
       ENDIF
# endif /* GM_EXTRA_DIAGONAL */

# ifdef ALLOW_DIAGNOSTICS
       IF (doDiagRediFlx) THEN
        km1 = MAX(k-1,1)
        DO j=1,sNy+1
         DO i=1,sNx
C         store in tmp1k Kvz_Redi
          tmp1k(i,j) = -gravitySign*
#  ifdef GM_USE_K3D_REDI
     &      op5*( locK3dRedi(i,j-1,k) + locK3dRedi(i,j,k) )
#  else
     &      GM_isopycK*GM_isoFac1d(k)
     &       *op5*(GM_isoFac2d(i,j-1,bi,bj)+GM_isoFac2d(i,j,bi,bj))
#  endif
     &     *SlopeY(i,j)*taperFct(i,j)
         ENDDO
        ENDDO
        DO j=1,sNy+1
         DO i=1,sNx
C-        Vertical gradients interpolated to U points
          dTdz = (
     &     +recip_drC(k)*
     &       ( maskC(i,j-1,km1,bi,bj)*maskC(i,j-1,k,bi,bj)*
     &           (theta(i,j-1,km1,bi,bj)-theta(i,j-1,k,bi,bj))
     &        +maskC(i, j ,km1,bi,bj)*maskC(i, j ,k,bi,bj)*
     &           (theta(i, j ,km1,bi,bj)-theta(i, j ,k,bi,bj))
     &       )
     &     +recip_drC(kp1)*
     &       ( maskC(i,j-1,kp1,bi,bj)*maskC(i,j-1,k,bi,bj)*
     &           (theta(i,j-1,k,bi,bj)-theta(i,j-1,kp1,bi,bj))
     &        +maskC(i, j ,kp1,bi,bj)*maskC(i, j ,k,bi,bj)*
     &           (theta(i, j ,k,bi,bj)-theta(i, j ,kp1,bi,bj))
     &       )      ) * 0.25 _d 0
           tmp1k(i,j) = dxG(i,j,bi,bj) * deepFacC(k)
     &                * drF(k) * _hFacS(i,j,k,bi,bj)
     &                * tmp1k(i,j) * dTdz
         ENDDO
        ENDDO
        CALL DIAGNOSTICS_FILL(tmp1k, 'GM_KvzTz', k,1,2,bi,bj,myThid)
       ENDIF
# endif /* ALLOW_DIAGNOSTICS */

C-- end 3rd  loop on vertical level index k
      ENDDO

#endif /* GM_NON_UNITY_DIAGONAL || GM_EXTRA_DIAGONAL */
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#ifndef GM_NON_UNITY_DIAGONAL
C--   keep a simplified setting here (used to be inside gmredi_x/ytransport)
C     for backeard compatibility + for trying to generate a simpler adjoint code
      DO k=1,Nr
       DO j=1-OLy+1,sNy+OLy-1
        DO i=1-OLx+1,sNx+OLx-1
          Kux(i,j,k,bi,bj) =
# ifdef GM_USE_K3D_REDI
     &      op5*( locK3dRedi(i-1,j,k) + locK3dRedi(i,j,k) )
# else
     &      GM_isopycK
# endif
        ENDDO
       ENDDO
       DO j=1-OLy+1,sNy+OLy-1
        DO i=1-OLx+1,sNx+OLx-1
          Kvy(i,j,k,bi,bj) =
# ifdef GM_USE_K3D_REDI
     &      op5*( locK3dRedi(i,j-1,k) + locK3dRedi(i,j,k) )
# else
     &      GM_isopycK
# endif
        ENDDO
       ENDDO
      ENDDO
#endif /* ndef GM_NON_UNITY_DIAGONAL */

#ifdef ALLOW_DIAGNOSTICS
      IF ( useDiagnostics ) THEN
        CALL GMREDI_DIAGNOSTICS_FILL( bi, bj, myThid )
      ENDIF
#endif /* ALLOW_DIAGNOSTICS */

#endif /* ALLOW_GMREDI */

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

CBOP
C     !ROUTINE: GMREDI_CALC_TENSOR_DUMMY
C     !INTERFACE:
      SUBROUTINE GMREDI_CALC_TENSOR_DUMMY(
     I             iMin, iMax, jMin, jMax,
     I             sigmaX, sigmaY, sigmaR,
     I             bi, bj, myTime, myIter, myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE GMREDI_CALC_TENSOR_DUMMY
C     | o Calculate tensor elements for GM/Redi tensor.
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "GMREDI.h"

C     !INPUT/OUTPUT PARAMETERS:
      _RL sigmaX(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL sigmaY(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL sigmaR(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      INTEGER iMin,iMax,jMin,jMax
      INTEGER bi, bj
      _RL     myTime
      INTEGER myIter
      INTEGER myThid
CEOP

#ifdef ALLOW_GMREDI
C     !LOCAL VARIABLES:
      INTEGER i, j, k

      DO k=1,Nr
       DO j=1-OLy+1,sNy+OLy-1
        DO i=1-OLx+1,sNx+OLx-1
         Kwx(i,j,k,bi,bj) = 0. _d 0
         Kwy(i,j,k,bi,bj) = 0. _d 0
         Kwz(i,j,k,bi,bj) = 0. _d 0
         Kux(i,j,k,bi,bj) = 0. _d 0
         Kvy(i,j,k,bi,bj) = 0. _d 0
# ifdef GM_EXTRA_DIAGONAL
         Kuz(i,j,k,bi,bj) = 0. _d 0
         Kvz(i,j,k,bi,bj) = 0. _d 0
# endif
        ENDDO
       ENDDO
      ENDDO
#endif /* ALLOW_GMREDI */

      RETURN
      END

#include "SEAICE_OPTIONS.h"
#ifdef ALLOW_EXF
# include "EXF_OPTIONS.h"
#endif

CStartOfInterface
      SUBROUTINE SEAICE_BUDGET_OCEAN(
     I     UG,
     I     TSURF,
     O     netHeatFlux, SWHeatFlux,
     I     bi, bj, myTime, myIter, myThid )
C     *================================================================*
C     | SUBROUTINE seaice_budget_ocean
C     | o Calculate surface heat fluxes over open ocean
C     |   see Hibler, MWR, 108, 1943-1973, 1980
C     |   If SEAICE_EXTERNAL_FLUXES is defined this routine simply
C     |   copies the global fields to the seaice-local fields.
C     *================================================================*
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "FFIELDS.h"
#ifndef SEAICE_EXTERNAL_FLUXES
# include "PARAMS.h"
# include "GRID.h"
# include "SEAICE_SIZE.h"
# include "SEAICE_PARAMS.h"
# ifdef ALLOW_EXF
#  include "EXF_FIELDS.h"
# endif
#endif

C     === Routine arguments ===
C     INPUT:
C     UG      :: thermal wind of atmosphere
C     TSURF   :: ocean surface temperature in Kelvin
C     bi,bj   :: loop indices
C     myTime  :: Simulation time
C     myIter  :: Simulation timestep number
C     myThid  :: Thread no. that called this routine.
C     OUTPUT:
C     netHeatFlux :: net surface heat flux over open water or under ice
C     SWHeatFlux  :: short wave heat flux over open water or under ice
      _RL UG         (1:sNx,1:sNy)
      _RL TSURF      (1:sNx,1:sNy)
      _RL netHeatFlux(1:sNx,1:sNy)
      _RL SWHeatFlux (1:sNx,1:sNy)
      _RL myTime
      INTEGER bi, bj, myIter, myThid
CEndOfInterface

C     === Local variables ===
C     i,j - Loop counters
      INTEGER i, j
#ifndef SEAICE_EXTERNAL_FLUXES
      _RL  QS1, D1, D1W, D3, TMELT

C     local copies of global variables
      _RL tsurfLoc   (1:sNx,1:sNy)
      _RL atempLoc   (1:sNx,1:sNy)
      _RL lwdownLoc  (1:sNx,1:sNy)

C     auxiliary variable
      _RL ssq, sstdegC
      _RL recip_rhoConstFresh, recip_lhEvap

C NOW DEFINE ASSORTED CONSTANTS
C SATURATION VAPOR PRESSURE CONSTANT
      QS1=0.622 _d 0/1013.0 _d 0
C SENSIBLE HEAT CONSTANT
      D1=SEAICE_dalton*SEAICE_cpAir*SEAICE_rhoAir
C WATER LATENT HEAT CONSTANT
      D1W=SEAICE_dalton*SEAICE_lhEvap*SEAICE_rhoAir
C STEFAN BOLTZMAN CONSTANT TIMES EMISSIVITY
      D3=SEAICE_emissivity*SEAICE_boltzmann
C MELTING TEMPERATURE OF ICE
      TMELT = celsius2K
C
      recip_lhEvap = 1./SEAICE_lhEvap
      recip_rhoConstFresh = 1./rhoConstFresh

      DO j=1,sNy
       DO i=1,sNx
        netHeatFlux(i,j) = 0. _d 0
        SWHeatFlux (i,j) = 0. _d 0
C
C     MAX_TICE does not exist anly longer, lets see if it works without
C       tsurfLoc (I,J) = MIN(celsius2K+MAX_TICE,TSURF(I,J))
        tsurfLoc (i,j) = TSURF(i,j)
# ifdef ALLOW_ATM_TEMP
C     Is this necessary?
        atempLoc (i,j) = MAX(celsius2K+MIN_ATEMP,ATEMP(i,j,bi,bj))
# endif
# ifdef ALLOW_DOWNWARD_RADIATION
        lwdownLoc(i,j) = MAX(MIN_LWDOWN,LWDOWN(i,j,bi,bj))
# endif
       ENDDO
      ENDDO
#endif /* SEAICE_EXTERNAL_FLUXES */

C NOW DETERMINE OPEN WATER HEAT BUD. ASSUMING TSURF=WATER TEMP.
C WATER ALBEDO IS ASSUMED TO BE THE CONSTANT SEAICE_waterAlbedo
      DO j=1,sNy
       DO i=1,sNx
#ifdef SEAICE_EXTERNAL_FLUXES
        netHeatFlux(i,j) = Qnet(i,j,bi,bj)
        SWHeatFlux (i,j) =  Qsw(i,j,bi,bj)
#else /* SEAICE_EXTERNAL_FLUXES undefined */
C     This is an example of how one could implement surface fluxes
C     over the ocean (if one dislikes the fluxes computed in pkg/exf).
C     In this example, the exf-fields are re-used so that they no longer
C     have the same values as at the time when they are saved for
C     diagnostics (e.g., hl, hs, lwflux, sflux). To properly
C     diagnose them, one has to save them again as different (SI-)fields.
# ifdef ALLOW_DOWNWARD_RADIATION
C     net upward short wave heat flux
        SWHeatFlux(i,j) = (SEAICE_waterAlbedo - 1. _d 0)
     &       *swdown(i,j,bi,bj)
C     lwup = emissivity*stefanBoltzmann*Tsrf^4 + (1-emissivity)*lwdown
C     the second terms is the reflected incoming long wave radiation
C     so that the net upward long wave heat flux is:
        lwflux(i,j,bi,bj) = - lwdownLoc(i,j)*SEAICE_emissivity
     &       + D3*tsurfLoc(i,j)**4
        sstdegC = tsurfLoc(i,j) - TMELT
C     downward sensible heat
        hs(i,j,bi,bj) = D1*UG(i,j)*(atempLoc(i,j)-tsurfLoc(i,j))
C     saturation humidity
        ssq = QS1*6.11 _d 0 *EXP( 17.2694 _d 0
     &                           *sstdegC/(sstdegC+237.3 _d 0) )
C     downward latent heat
        hl(i,j,bi,bj) = D1W*UG(i,j)*(AQH(i,j,bi,bj)-ssq)
C     net heat is positive upward
        netHeatFlux(i,j)=SWHeatFlux(i,j)
     &       + lwflux(i,j,bi,bj)
     &       - hs(i,j,bi,bj) - hl(i,j,bi,bj)
C     compute evaporation here again because latent heat is different
C     from its previous value
        evap(i,j,bi,bj) = -hl(i,j,bi,bj)
     &       *recip_lhEvap*recip_rhoConstFresh
C     Salt flux from Precipitation and Evaporation.
        sflux(i,j,bi,bj) = evap(i,j,bi,bj) - precip(i,j,bi,bj)
#  ifdef ALLOW_RUNOFF
        sflux(i,j,bi,bj) = sflux(i,j,bi,bj) - runoff(i,j,bi,bj)
#  endif
        sflux(i,j,bi,bj) = sflux(i,j,bi,bj)!*HEFFM(i,j,bi,bj)
        empmr(i,j,bi,bj) = sflux(i,j,bi,bj)*rhoConstFresh
# endif /* ALLOW_DOWNWARD_RADIATION */
#endif /* SEAICE_EXTERNAL_FLUXES */
       ENDDO
      ENDDO

      RETURN
      END

#include "ctrparam.h"
#include "ATM2D_OPTIONS.h"

C     !INTERFACE:
      SUBROUTINE CALC_ZONAL_MEANS(doAll, myTime, myIter, myThid )
C     *==========================================================*
C     | Calculate zonal mean ocean quantities (at a specific     |
C     | point in time). If first argument is false, only seaice  |
C     | means are calculated, i.e. called after an atm timestep. |
C     *==========================================================*
        IMPLICIT NONE

C     === Global Atmosphere Variables ===
#include "ATMSIZE.h"
#include "AGRID.h"

C     === Global Ocean Variables ===
#include "SIZE.h"
#include "GRID.h"
#include "EEPARAMS.h"

C     === Global SeaIce Variables ===
#include "THSICE_VARS.h"
      INTEGER siLo, siHi, sjLo, sjHi
      PARAMETER ( siLo = 1-OLx , siHi = sNx+OLx )
      PARAMETER ( sjLo = 1-OLy , sjHi = sNy+OLy )

C     === Atmos/Ocean/Seaice Interface Variables ===
#include "ATM2D_VARS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
C     doAll   - boolean, false -> only vars changed after atm step
C     myTime - current simulation time (ocean model time)
C     myIter - iteration number (ocean model)
C     myThid  - Thread no. that called this routine.
      LOGICAL doAll
      _RL     myTime
      INTEGER myIter
      INTEGER myThid

C     LOCAL VARIABLES:
      _RL mWgt       ! weight of ocean point j+1
      INTEGER i,j    ! loop counters for the ocean grid
      INTEGER j_atm  ! loop counter for the atm grid

      DO j_atm=1,jm0
        IF (doAll) THEN
          ctocn(j_atm)=0. _d 0
          cfice(j_atm)=0. _d 0
          cco2flux(j_atm)=0. _d 0
        ENDIF
        ctice(j_atm)=0. _d 0
        csAlb(j_atm)=0. _d 0
        csAlbNIR(j_atm)=0. _d 0
      ENDDO

       CALL THSICE_ALBEDO(
     I          1, 1, siLo, siHi, sjLo, sjHi,
     I          1, sNx, 1, sNy,
     I          iceMask(siLo,sjLo,1,1), iceHeight(siLo,sjLo,1,1),
     I          snowHeight(siLo,sjLo,1,1), Tsrf(siLo,sjLo,1,1),
     I          snowAge(siLo,sjLo,1,1),
     O          siceAlb(siLo,sjLo,1,1), icAlbNIR(siLo,sjLo,1,1),
     I          myTime, myIter, myThid )

      DO j=1,sNy
       DO i=1,sNx

         IF (maskC(i,j,1,1,1).EQ.1.) THEN

           IF (doAll) THEN
             ctocn(atm_oc_ind(j))= ctocn(atm_oc_ind(j)) +
     &                             sstFromOcn(i,j) * rA(i,j,1,1) *
     &                      (1. _d 0-iceMask(i,j,1,1))*atm_oc_wgt(j)
             cfice(atm_oc_ind(j))=cfice(atm_oc_ind(j)) +
     &              rA(i,j,1,1)*iceMask(i,j,1,1)*atm_oc_wgt(j)
             cco2flux(atm_oc_ind(j))=cco2flux(atm_oc_ind(j)) +
     &                  oFluxCO2(i,j)*rA(i,j,1,1)*atm_oc_wgt(j)
           ENDIF
           ctice(atm_oc_ind(j))=ctice(atm_oc_ind(j)) + Tsrf(i,j,1,1)
     &             *rA(i,j,1,1)*iceMask(i,j,1,1)*atm_oc_wgt(j)
           csAlb(atm_oc_ind(j))=csAlb(atm_oc_ind(j)) + siceAlb(i,j,1,1)
     &             *rA(i,j,1,1)*iceMask(i,j,1,1)*atm_oc_wgt(j)
           csAlbNIR(atm_oc_ind(j))=csAlbNIR(atm_oc_ind(j)) + 
     &             icAlbNIR(i,j,1,1)
     &             *rA(i,j,1,1)*iceMask(i,j,1,1)*atm_oc_wgt(j)


           IF (atm_oc_wgt(j).LT.1. _d 0) THEN
             mWgt= 1. _d 0-atm_oc_wgt(j)
             IF (doAll) THEN
               ctocn(atm_oc_ind(j)+1)= ctocn(atm_oc_ind(j)+1) +
     &                                 sstFromOcn(i,j) * rA(i,j,1,1) *
     &                                 (1. _d 0-iceMask(i,j,1,1))*mWgt
               cfice(atm_oc_ind(j)+1)= cfice(atm_oc_ind(j)+1) +
     &             rA(i,j,1,1)*iceMask(i,j,1,1)*mWgt
               cco2flux(atm_oc_ind(j)+1)= cco2flux(atm_oc_ind(j)+1) +
     &                  oFluxCO2(i,j)*rA(i,j,1,1)*mWgt
             ENDIF
             ctice(atm_oc_ind(j)+1)= ctice(atm_oc_ind(j)+1) +
     &             Tsrf(i,j,1,1)*rA(i,j,1,1)*iceMask(i,j,1,1)*mWgt
             csAlb(atm_oc_ind(j)+1)= csAlb(atm_oc_ind(j)+1) +
     &             siceAlb(i,j,1,1)*rA(i,j,1,1)*iceMask(i,j,1,1)*mWgt
             csAlbNIR(atm_oc_ind(j)+1)= csAlbNIR(atm_oc_ind(j)+1) + 
     &             icAlbNIR(i,j,1,1)*rA(i,j,1,1)*iceMask(i,j,1,1)*mWgt
           ENDIF

         ENDIF

       ENDDO
      ENDDO

      DO j_atm=2,jm0-1

        IF (ocnArea(j_atm).GT.1. _d -32) THEN

          IF (doAll)
     &      cfice(j_atm)= cfice(j_atm)/ocnArea(j_atm)
          IF (cfice(j_atm).GT.1. _d -32) THEN
            ctice(j_atm)= ctice(j_atm)/ocnArea(j_atm)/cfice(j_atm)
            csAlb(j_atm)= csAlb(j_atm)/ocnArea(j_atm)/cfice(j_atm)
            csAlbNIR(j_atm)= csAlbNIR(j_atm)/ocnArea(j_atm)/cfice(j_atm)
          ENDIF

          IF ((1. _d 0-cfice(j_atm).GT.1. _d -32).AND.doAll)
     &        ctocn(j_atm)= ctocn(j_atm)/ocnArea(j_atm)
     &                        /(1. _d 0-cfice(j_atm))

        ENDIF

C       At present, keeping separate variables in AGRID.h and ATM2D_VARS.h

        IF (doALL) THEN
          mmsst(j_atm)= ctocn(j_atm)
          mmfice(j_atm)= cfice(j_atm)
          mmco2flux(j_atm)= cco2flux(j_atm)
        ENDIF
        mmtice(j_atm)= ctice(j_atm)
        mmsAlb(j_atm)= csAlb(j_atm)
        mmsAlbNIR(j_atm)= csAlbNIR(j_atm)

      ENDDO

C     Copy data to atmosphere polar points
      IF (doALL) THEN
          mmsst(1)= ctocn(2)
          mmsst(jm0)= ctocn(jm0-1)
          mmfice(1)= cfice(2)
          mmfice(jm0)= cfice(jm0-1)
          mmco2flux(1)= 0. _d 0
          mmco2flux(jm0)= 0. _d 0 ! converted to mol/s; pole point contribution in jm0-1
      ENDIF
        mmtice(1)= ctice(2)
        mmtice(jm0)= ctice(jm0-1)
        mmsAlb(1)= csAlb(2)
        mmsAlb(jm0)= csAlb(jm0-1)
        mmsAlbNIR(1)= csAlbNIR(2)
        mmsAlbNIR(jm0)= csAlbNIR(jm0-1)

      RETURN
      END

#include "CAL_OPTIONS.h"

      logical function cal_CompDates(
     I                                date_a,
     I                                date_b,
     I                                mythid
     &                              )

c     ==================================================================
c     FUNCTION cal_CompDates
c     ==================================================================
c
c     o Compare two calendar dates or time interval.
c              
c     started: Christian Eckert eckert@mit.edu  24-Feb-2000
c
c              - Introduced to calendar version 0.1.4
c
c     changed: 
c
c     ==================================================================
c     FUNCTION cal_CompDates
c     ==================================================================

      implicit none

c     == global variables ==

#include "cal.h"

c     == routine arguments ==

      integer date_a(4)
      integer date_b(4)
      integer mythid

c     == local variables ==

c     == end of interface ==

      if ( ( date_a(1) .eq. date_b(1) ) .and.
     &     ( date_a(2) .eq. date_b(2) ) .and.
     &     ( date_a(3) .eq. date_b(3) ) .and.
     &     ( date_a(4) .eq. date_b(4) )       ) then
        cal_CompDates = .true.
      else
        cal_CompDates = .false.
      endif

      return
      end

#include "CPP_EEOPTIONS.h"
#ifdef USE_LIBHPM
# include "f_hpm.h"
#endif

C--   File utils.F: General purpose support routines
C--    Contents
C--   TIMER_INDEX     - Returns index associated with timer name.
C-- M TIMER_CONTROL   - Implements timer functions for given machine.
C--   TIMER_PRINT     - Print CPU timer statitics.
C--   TIMER_PRINTALL  - Prints all CPU timers statistics.
C--   TIMER_START     - Starts CPU timer for code section.
C--   TIMER_STOP      - Stop CPU tier for code section.
C--   Routines marked "M" contain specific machine dependent code.
C--   Routines marked "U" contain UNIX OS calls.

CGG   Modified following A. Biastoch for use with SP3. Is backwards
CGG   compatible. G. Gebbie, gebbie@mit.edu, 20 Oct 2001, Scripps.

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: TIMER_INDEX

C     !INTERFACE:
      INTEGER FUNCTION TIMER_INDEX (
     I        name,timerNames,maxTimers,nTimers )
      IMPLICIT NONE

C     !DESCRIPTION:
C     *==========================================================*
C     | FUNCTION TIMER\_INDEX
C     | o Timing support routine.
C     *==========================================================*
C     | Return index in timer data structure of timer named
C     | by the function argument "name".
C     *==========================================================*

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguements ==
C     maxTimers  :: Total number of timers allowed
C     nTimers    :: Current number of timers
C     name       :: Name of timer to find
C     timerNames :: List of valid timer names
      INTEGER maxTimers
      INTEGER nTimers
      CHARACTER*(*) name
      CHARACTER*(*) timerNames(maxTimers)

C     !LOCAL VARIABLES:
C     == Local variables ==
C     I :: Index variable
      INTEGER I
CEOP
C
      TIMER_INDEX = 0
      IF ( name .EQ. ' ' ) THEN
        TIMER_INDEX = -1
      ELSE
        DO 10 I = 1, nTimers
          IF ( name .NE. timerNames(I) ) GOTO 10
            TIMER_INDEX = I
            GOTO 11
   10   CONTINUE
   11   CONTINUE
      ENDIF
      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: TIMER_CONTROL

C     !INTERFACE:
      SUBROUTINE TIMER_CONTROL ( name , action , callProc , myThreadId )
      IMPLICIT NONE

C     !DESCRIPTION:
C     *==========================================================*
C     | SUBROUTINE TIMER\_CONTROL                                 |
C     | o Timing routine.                                        |
C     *==========================================================*
C     | User callable interface to timing routines. Timers are   |
C     | created, stopped, started and queried only through this  |
C     | rtouine.                                                 |
C     *==========================================================*

C     !USES:
#include "SIZE.h"
#include "EEPARAMS.h"
#include "EESUPPORT.h"
      INTEGER  TIMER_INDEX
      INTEGER  IFNBLNK
      INTEGER  ILNBLNK
      EXTERNAL TIMER_INDEX
      EXTERNAL IFNBLNK
      EXTERNAL ILNBLNK

C     !INPUT/OUTPUT PARAMETERS:
C     name       :: name of the timer
C     action     :: operation to perform with this timer
C     callProc   :: procedure calling this routine
C     myThreadId :: instance number of this thread
      CHARACTER*(*) name
      CHARACTER*(*) action
      CHARACTER*(*) callProc
      INTEGER myThreadId
C
C     !LOCAL VARIABLES:
C     maxTimers :: Total numer of timer allowed
C     maxString :: Max length of a timer name
      INTEGER maxTimers
      INTEGER maxString
      PARAMETER ( maxTimers = 50 )
      PARAMETER ( maxString = 80 )
C     timerStarts :: Timer counters for each timer and each thread
C     timerStops
C     timerUser
C     timerWall
C     timerSys
C     timerT0User
C     timerT0Wall
C     timerT0Sys
C     timerStatus  :: START/STOP/RUNNING Status of the timer
C     timerNameLen :: Length of timer name
C     timerNames   :: Table of timer names
C     nTimers      :: Number of active timers
      INTEGER timerStarts( maxTimers , MAX_NO_THREADS)
      SAVE    timerStarts
      INTEGER timerStops ( maxTimers , MAX_NO_THREADS)
      SAVE    timerStops
      Real*8 timerUser  ( maxTimers , MAX_NO_THREADS)
      SAVE timerUser
      Real*8 timerWall  ( maxTimers , MAX_NO_THREADS)
      SAVE timerWall
      Real*8 timerSys   ( maxTimers , MAX_NO_THREADS)
      SAVE timerSys
      Real*8 timerT0User( maxTimers , MAX_NO_THREADS)
      SAVE timerT0User
      Real*8 timerT0Wall( maxTimers , MAX_NO_THREADS)
      SAVE timerT0Wall
      Real*8 timerT0Sys ( maxTimers , MAX_NO_THREADS)
      SAVE timerT0Sys
      INTEGER timerStatus( maxTimers , MAX_NO_THREADS)
      SAVE    timerStatus
      INTEGER timerNameLen( maxTimers , MAX_NO_THREADS)
      SAVE    timerNameLen
      CHARACTER*(maxString) timerNames( maxTimers , MAX_NO_THREADS)
      SAVE                  timerNames
      INTEGER nTimers(MAX_NO_THREADS)
      CHARACTER*(maxString) tmpName
      CHARACTER*(maxString) tmpAction
      INTEGER iTimer
      INTEGER ISTART
      INTEGER IEND
      INTEGER STOPPED
      PARAMETER ( STOPPED = 0 )
      INTEGER RUNNING
      PARAMETER ( RUNNING = 1 )
      CHARACTER*(*) STOP
      PARAMETER ( STOP = 'STOP' )
      CHARACTER*(*) START
      PARAMETER ( START = 'START' )
      CHARACTER*(*) PRINT
      PARAMETER ( PRINT = 'PRINT' )
      CHARACTER*(*) PRINTALL
      PARAMETER ( PRINTALL = 'PRINTALL' )
#if defined(USE_PAPI) || defined(USE_PCL_FLOPS_SFP) || defined(USE_PCL_FLOPS) || defined (USE_PCL)
      CHARACTER*(*) INIT
      PARAMETER ( INIT = 'INIT' )
#ifdef USE_PAPI
      INTEGER nmaxevents
      PARAMETER (nmaxevents = 18)
      INTEGER neventsmax, nevents
      SAVE neventsmax, nevents
      INTEGER*8 values(nmaxevents, maxTimers , MAX_NO_THREADS),
     $     values1(nmaxevents, maxTimers, MAX_NO_THREADS),
     $     values2(nmaxevents, maxTimers, MAX_NO_THREADS)
      COMMON /papivalues/ values, values1, values2
#include <fpapi.h>
      CHARACTER(13) EventName
      INTEGER EventCode(nmaxevents)
      INTEGER Check, EventSet
      INTEGER papiunit
      SAVE EventCode, EventSet
      INTEGER j
#else
#if defined(USE_PCL_FLOPS_SFP) || defined(USE_PCL_FLOPS) || defined(USE_PCL)
#include <pclh.f>
      INTEGER nmaxevents
      PARAMETER (nmaxevents = 61)
      INTEGER flags, res, nevents
      INTEGER*8 descr
      CHARACTER*22 pcl_counter_name(0:nmaxevents-1)
#ifdef USE_PCL
      INTEGER pcl_counter_list(nmaxevents)
      INTEGER*8 i_result(nmaxevents, maxTimers, MAX_NO_THREADS)
      INTEGER*8 i_result1(nmaxevents, maxTimers, MAX_NO_THREADS)
      INTEGER*8 i_result2(nmaxevents, maxTimers, MAX_NO_THREADS)
      REAL*8 fp_result(nmaxevents, maxTimers, MAX_NO_THREADS)
      INTEGER j
#else
      INTEGER pcl_counter_list(5), alt_counter_list(5)
      INTEGER*8 i_result(5)
      REAL*8 fp_result(5)
      SAVE alt_counter_list
      DATA alt_counter_list /PCL_MFLOPS, PCL_IPC, PCL_L1DCACHE_MISSRATE,
     $     PCL_L2DCACHE_MISSRATE, PCL_MEM_FP_RATIO/
#endif
      COMMON /pclvars/ i_result, descr, fp_result, pcl_counter_list,
     $     flags, nevents
      COMMON /pclnames/ pcl_counter_name
      INTEGER pclunit
#endif
#endif
#endif
      INTEGER I
      Real*8 userTime
      Real*8 systemTime
      Real*8 wallClockTime
      CHARACTER*(MAX_LEN_MBUF) msgBuffer
      DATA nTimers  /MAX_NO_THREADS*0/
      SAVE nTimers
CEOP
C
      ISTART = IFNBLNK(name)
      IEND   = ILNBLNK(name)
      IF ( IEND - ISTART + 1 .GT. maxString ) GOTO 901
      IF ( ISTART .NE. 0 ) THEN
        tmpName = name(ISTART:IEND)
        CALL UCASE( tmpName )
      ELSE
        tmpName = ' '
      ENDIF
      ISTART = IFNBLNK(action)
      IEND   = ILNBLNK(action)
      IF ( ISTART            .EQ. 0         ) GOTO 902
      IF ( IEND - ISTART + 1 .GT. maxString ) GOTO 903
      tmpAction = action(ISTART:IEND)
      CALL UCASE( tmpAction )
C
      iTimer=TIMER_INDEX(tmpName,timerNames(1,myThreadId),
     &       maxTimers,nTimers(myThreadId))
C
      IF     ( tmpAction .EQ. START ) THEN
        IF ( iTimer .EQ. 0 ) THEN
          IF ( nTimers(myThreadId) .EQ. maxTimers ) GOTO 904
            nTimers(myThreadId) = nTimers(myThreadId) + 1
            iTimer  = nTimers(myThreadId)
            timerNames(iTimer,myThreadId)    = tmpName
            timerNameLen(iTimer,myThreadId)  =
     &       ILNBLNK(tmpName)-IFNBLNK(tmpName)+1
            timerUser(iTimer,myThreadId)     = 0.
            timerSys (iTimer,myThreadId)     = 0.
            timerWall(iTimer,myThreadId)     = 0.
            timerStarts(iTimer,myThreadId)   = 0
            timerStops (iTimer,myThreadId)   = 0
            timerStatus(iTimer,myThreadId)   = STOPPED
        ENDIF
        IF ( timerStatus(iTimer,myThreadId) .NE. RUNNING ) THEN
          CALL TIMER_GET_TIME( userTime, systemTime, wallClockTime )
          timerT0User(iTimer,myThreadId) = userTime
          timerT0Sys(iTimer,myThreadId)  = systemTime
          timerT0Wall(iTimer,myThreadId) = wallClockTime
          timerStatus(iTimer,myThreadId) = RUNNING
          timerStarts(iTimer,myThreadId) =
     &       timerStarts(iTimer,myThreadId)+1
#ifdef USE_PAPI
CCE107 PAPI - Read event counts
          call PAPIF_read(EventSet, values1(1,iTimer,myThreadId), Check)
#else
#ifdef USE_PCL
CCE107 PCL - Read event counts
          res = PCLread(descr, i_result1(1,iTimer,myThreadId),
     $         fp_result(1,iTimer,myThreadId), nevents)
#endif
#endif
        ENDIF
#ifdef USE_LIBHPM
#ifdef TARGET_BGL
        CALL f_hpmstart((myThreadId-1)*100+iTimer,tmpName)
#else
        CALL f_hpmtstart((myThreadId-1)*100+iTimer,tmpName)
#endif
#endif
      ELSEIF ( tmpAction .EQ. STOP ) THEN
        IF ( iTimer .EQ. 0 ) GOTO 905
#ifdef USE_LIBHPM
#ifdef TARGET_BGL
        CALL f_hpmstop((myThreadId-1)*100+iTimer)
#else
        CALL f_hpmtstop((myThreadId-1)*100+iTimer)
#endif
#endif
        IF ( timerStatus(iTimer,myThreadId) .EQ. RUNNING ) THEN
#ifdef USE_PAPI
CCE107 PAPI - Read event counts
          call PAPIF_read(EventSet, values2(1,iTimer,myThreadId), Check)
#else
#ifdef USE_PCL
CCE107 PCL - Read event counts
          res = PCLread(descr, i_result2(1,iTimer,myThreadId),
     $         fp_result(1,iTimer,myThreadId), nevents)
#endif
#endif
          CALL TIMER_GET_TIME( userTime, systemTime, wallClockTime )
          timerUser(iTimer,myThreadId)    =
     &       timerUser(iTimer,myThreadId) +
     &                           userTime          -
     &                           timerT0User(iTimer,myThreadId)
          timerSys (iTimer,myThreadId)    =
     &       timerSys(iTimer,myThreadId) +
     &                           systemTime -
     &                           timerT0Sys(iTimer,myThreadId)
          timerWall(iTimer,myThreadId)    =
     &       timerWall(iTimer,myThreadId) +
     &                           wallClockTime -
     &                           timerT0Wall(iTimer,myThreadId)
#ifdef USE_PAPI
          do i=1,nevents
             values(i,iTimer,myThreadId) = values(i,iTimer,myThreadId) +
     $       values2(i,iTimer,myThreadId) - values1(i,iTimer,myThreadId)
          enddo
#else
#ifdef USE_PCL
          do i=1,nevents
             i_result(i,iTimer,myThreadId) = i_result(i,iTimer
     $            ,myThreadId) + i_result2(i,iTimer,myThreadId) -
     $            i_result1(i,iTimer,myThreadId)
          enddo
#endif
#endif
          timerStatus(iTimer,myThreadId)  = STOPPED
          timerStops (iTimer,myThreadId)  =
     &    timerStops (iTimer,myThreadId)+1
        ENDIF
#if defined (USE_PAPI) || defined (USE_PCL_FLOPS_SFP) || defined(USE_PCL_FLOPS) || defined(USE_PCL)
      ELSEIF ( tmpAction .EQ. INIT ) THEN
#ifdef USE_PAPI
CCE107 PAPI - Check PAPI version, find the maximum number of events and
C      initialize the library, read the suggested events and create
C      EventSet, prepare counter for use
         Check = PAPI_VER_CURRENT
         call PAPIF_library_init(Check)
         if (Check .NE. PAPI_VER_CURRENT) then
            WRITE(msgBuffer,*) "PAPI Library Version is out of Date"
            CALL PRINT_MESSAGE(msgBuffer,errorMessageUnit,
     &           SQUEEZE_RIGHT,myThreadId)
            CALL ABORT
         endif
         call PAPIF_num_counters(neventsmax)
         if (neventsmax .GT. nmaxevents) then
            WRITE(msgBuffer,*) "Fix the nmaxevents in the code to ",
     $           neventsmax
            CALL PRINT_MESSAGE(msgBuffer,errorMessageUnit,
     &           SQUEEZE_RIGHT,myThreadId)
            CALL ABORT
         endif
         _BEGIN_MASTER(myThreadId)
         CALL mdsFindUnit (papiunit, myThreadId)
         OPEN(UNIT=papiunit,FILE='data.papi',STATUS='OLD')
        read(papiunit,*) nevents
C       reset to reasonable values
        if (nevents .gt. neventsmax) then
           nevents = neventsmax
           WRITE(msgBuffer,*)
     $          "resetting the number of PAPI events to the maximum"
           CALL PRINT_MESSAGE(msgBuffer,errorMessageUnit,
     &          SQUEEZE_RIGHT,myThreadId)
        endif
        do i = 1,nevents
           read(papiunit,*) EventName
           if ((EventName .eq. 'PAPI_FLOPS') .or.
     $          (EventName .eq. 'PAPI_IPS')) then
              WRITE(msgBuffer,*) "Abort! Rate events are not supported:"
     $             ,EventName
              CALL PRINT_MESSAGE(msgBuffer,errorMessageUnit,
     &             SQUEEZE_RIGHT,myThreadId)
              CALL ABORT
           endif

           call PAPIF_event_name_to_code(EventName, EventCode(i), Check)
        end do
        close(papiunit)
        _END_MASTER(myThid)
        EventSet = PAPI_NULL
        call PAPIF_create_eventset(EventSet, Check)
        do i = 1,nevents
           call PAPIF_add_event(EventSet, EventCode(i), Check)
           if (Check .NE. PAPI_OK) then
              CALL PAPIF_event_code_to_name(EventCode(i), EventName,
     $             Check)
              WRITE(msgBuffer,*) "Abort After PAPIF_add_event: ",
     $             EventName
              CALL PRINT_MESSAGE(msgBuffer,errorMessageUnit,
     &             SQUEEZE_RIGHT,myThreadId)
              CALL ABORT
           endif
        enddo
CCE107 - Start counting events
        call PAPIF_start(EventSet, Check)
#else
#if defined(USE_PCL_FLOPS_SFP) || defined(USE_PCL_FLOPS) || defined(USE_PCL)
CCE107 PCL - initialize the library, read the suggested events
C      and check them
        res = PCLinit(descr)

#ifdef USE_PCL
        _BEGIN_MASTER(myThreadId)
        CALL mdsFindUnit (pclunit, myThreadId)
        OPEN(UNIT=pclunit,FILE='data.pcl',STATUS='OLD')
        read(pclunit,*) nevents
C     reset to reasonable values
        if (nevents .gt. nmaxevents) then
           nevents = nmaxevents
           WRITE(msgBuffer,*)
     $          "resetting the number of PCL events to the maximum"
           CALL PRINT_MESSAGE(msgBuffer,errorMessageUnit,
     &          SQUEEZE_RIGHT,myThreadId)
        endif
        do i = 1,nevents
           read(pclunit,*) pcl_counter_list(i)
           if ((pcl_counter_list(i) .ge. PCL_MFLOPS) .or.
     $          (pcl_counter_list(i) .lt. 1)) then
              if ((pcl_counter_list(i) .ge. PCL_MFLOPS) .and.
     $             (pcl_counter_list(i) .le. nmaxevents)) then
                 WRITE(msgBuffer,*)
     $                "Abort! Rate events are not relevant:",
     $                pcl_counter_name(pcl_counter_list(i))
              else
                 WRITE(msgBuffer,*)
     $                "Abort! Events are not defined:",
     $                pcl_counter_list(i)
              endif
              CALL PRINT_MESSAGE(msgBuffer,errorMessageUnit,
     &             SQUEEZE_RIGHT,myThreadId)
              CALL ABORT
           endif
        enddo
        close(pclunit)
        _END_MASTER(myThid)

        do i = 1,nevents
CCE107 check to see that event are supported in the order asked
           res = PCLquery(descr, pcl_counter_list, i, flags)
           IF(res .NE. PCL_SUCCESS) THEN
              WRITE(msgBuffer,*) "Abort! No support when adding event: "
     $             , pcl_counter_name(pcl_counter_list(i))
              CALL PRINT_MESSAGE(msgBuffer,errorMessageUnit,
     &             SQUEEZE_RIGHT,myThreadId)
              CALL ABORT
           endif
        enddo
#else
        do i = 1,5
CCE107 check to see which rate events are supported.
           res = PCLquery(descr, pcl_counter_list, nevents+1, flags)
           if ((res .ne. PCL_SUCCESS) .and. (i .lt. 5)) then
              pcl_counter_list(nevents+1) = alt_counter_list(i+1)
           else
              if (i .lt. 5) then
                 nevents = nevents + 1
              endif
           endif
        enddo
        if (nevents .eq. 0) then
           WRITE(msgBuffer,*)
     $          "No PCL rate events supported: Please recompile!"
           CALL PRINT_MESSAGE(msgBuffer,errorMessageUnit,
     &          SQUEEZE_RIGHT,myThreadId)
           CALL ABORT
        endif
#endif

CCE107 - Start counting events
        res = PCLstart(descr, pcl_counter_list, nevents, flags)
        IF(res .NE. PCL_SUCCESS) THEN
           WRITE(msgBuffer,*) "PCL counting failed - please recompile!"
           CALL PRINT_MESSAGE(msgBuffer,errorMessageUnit,
     &          SQUEEZE_RIGHT,myThreadId)
           CALL ABORT
        ENDIF
#endif
#endif
#endif
      ELSEIF ( tmpAction .EQ. PRINT ) THEN
        IF ( iTimer .EQ. 0 ) GOTO 905
        WRITE(msgBuffer,*)
     &  ' Seconds in section "',
     &  timerNames(iTimer,myThreadId)(1:timerNameLen(iTimer,myThreadId))
     &  ,'":'
        CALL PRINT_MESSAGE(msgBuffer,standardMessageUnit,
     &  SQUEEZE_RIGHT,myThreadId)
        WRITE(msgBuffer,*) '         User time:',
     &  timerUser(iTimer,myThreadId)
        CALL PRINT_MESSAGE(msgBuffer,standardMessageUnit,
     &  SQUEEZE_RIGHT,myThreadId)
        WRITE(msgBuffer,*) '       System time:',
     &  timerSys(iTimer,myThreadId)
        CALL PRINT_MESSAGE(msgBuffer,standardMessageUnit,
     &  SQUEEZE_RIGHT,myThreadId)
        WRITE(msgBuffer,*) '   Wall clock time:',
     &  timerWall(iTimer,myThreadId)
        CALL PRINT_MESSAGE(msgBuffer,standardMessageUnit,
     &  SQUEEZE_RIGHT,myThreadId)
        WRITE(msgBuffer,*) '        No. starts:',
     &  timerStarts(iTimer,myThreadId)
        CALL PRINT_MESSAGE(msgBuffer,standardMessageUnit,
     &  SQUEEZE_RIGHT,myThreadId)
        WRITE(msgBuffer,*) '         No. stops:',
     &  timerStops(iTimer,myThreadId)
        CALL PRINT_MESSAGE(msgBuffer,standardMessageUnit,
     &  SQUEEZE_RIGHT,myThreadId)
#ifdef USE_PAPI
        do i = 1,nevents
           call PAPIF_event_code_to_name(EventCode(i), EventName, Check)
           WRITE(msgBuffer,71) Eventname,
     $          values(i,iTimer,myThreadId)/timerUser(iTimer,myThreadId)
     $          ,values(i,iTimer,myThreadId)/timerWall(iTimer,myThreadId
     $          ),1.D0*values(i,iTimer,myThreadId)
           CALL PRINT_MESSAGE(msgBuffer,standardMessageUnit,
     &          SQUEEZE_RIGHT,myThreadId)
        enddo
#else
#ifdef USE_PCL
        do i = 1,nevents
           WRITE(msgBuffer,71) pcl_counter_name(pcl_counter_list(i)),
     $          i_result(i,iTimer,myThreadId)/timerUser(iTimer
     $          ,myThreadId),i_result(i,iTimer,myThreadId)
     $          /timerWall(iTimer,myThreadId),1.D0*i_result(i,iTimer
     $          ,myThreadId)
           CALL PRINT_MESSAGE(msgBuffer,standardMessageUnit,
     &          SQUEEZE_RIGHT,myThreadId)
        enddo
#endif
#endif
      ELSEIF ( tmpAction .EQ. PRINTALL ) THEN
        DO 10 I = 1, nTimers(myThreadId)
         WRITE(msgBuffer,*) ' Seconds in section "',
     &            timerNames(I,myThreadId)(1:timerNameLen(I,myThreadId))
     &  ,'":'
         CALL PRINT_MESSAGE(msgBuffer,standardMessageUnit,
     &  SQUEEZE_RIGHT,myThreadId)
         WRITE(msgBuffer,*) '         User time:',
     &  timerUser(I,myThreadId)
         CALL PRINT_MESSAGE(msgBuffer,standardMessageUnit,
     &  SQUEEZE_RIGHT,myThreadId)
         WRITE(msgBuffer,*) '       System time:',
     &  timerSys(I,myThreadId)
         CALL PRINT_MESSAGE(msgBuffer,standardMessageUnit,
     &  SQUEEZE_RIGHT,myThreadId)
         WRITE(msgBuffer,*) '   Wall clock time:',
     &  timerWall(I,myThreadId)
         CALL PRINT_MESSAGE(msgBuffer,standardMessageUnit,
     &  SQUEEZE_RIGHT,myThreadId)
         WRITE(msgBuffer,*) '        No. starts:',
     &  timerStarts(I,myThreadId)
         CALL PRINT_MESSAGE(msgBuffer,standardMessageUnit,
     &  SQUEEZE_RIGHT,myThreadId)
         WRITE(msgBuffer,*) '         No. stops:',
     &  timerStops(I,myThreadId)
         CALL PRINT_MESSAGE(msgBuffer,standardMessageUnit,
     &  SQUEEZE_RIGHT,myThreadId)
#ifdef USE_PAPI
        do j = 1,nevents
           call PAPIF_event_code_to_name(EventCode(j), EventName, Check)
           WRITE(msgBuffer,71) Eventname,
     $          values(j,I,myThreadId)/timerUser(I,myThreadId),
     $          values(j,I,myThreadId)/timerWall(I,myThreadId),
     $          1.D0*values(j,I,myThreadId)
           CALL PRINT_MESSAGE(msgBuffer,standardMessageUnit,
     &          SQUEEZE_RIGHT,myThreadId)
        enddo
#else
#ifdef USE_PCL
        do j = 1,nevents
           WRITE(msgBuffer,71) pcl_counter_name(pcl_counter_list(j)),
     $          i_result(j,I,myThreadId)/timerUser(I,myThreadId)
     $          ,i_result(j,I,myThreadId)/timerWall(I,myThreadId),1.D0
     $          *i_result(j,I,myThreadId)
           CALL PRINT_MESSAGE(msgBuffer,standardMessageUnit,
     &          SQUEEZE_RIGHT,myThreadId)
        enddo
#endif
#endif
   10   CONTINUE
      ELSE
        GOTO 903
      ENDIF
C
 1000 CONTINUE
C
      RETURN
  901 CONTINUE
      WRITE(msgBuffer,'(A)')
     &'                                                       '
      CALL PRINT_MESSAGE(msgBuffer,errorMessageUnit,
     &  SQUEEZE_RIGHT,myThreadId)
      WRITE(msgBuffer,*)
     &'*** WARNING WARNING WARNING WARNING WARNING WARNING ***'
      CALL PRINT_MESSAGE(msgBuffer,errorMessageUnit,
     &  SQUEEZE_RIGHT,myThreadId)
      WRITE(msgBuffer,*)
     &'procedure: "',callProc,'".'
      CALL PRINT_MESSAGE(msgBuffer,errorMessageUnit,
     &  SQUEEZE_RIGHT,myThreadId)
      WRITE(msgBuffer,*)
     &'Timer name "',name(ISTART:IEND),'" is invalid.'
      CALL PRINT_MESSAGE(msgBuffer,errorMessageUnit,
     &  SQUEEZE_RIGHT,myThreadId)
      WRITE(msgBuffer,*)
     &' Names must have fewer than',maxString+1,' characters.'
      CALL PRINT_MESSAGE(msgBuffer,errorMessageUnit,
     &  SQUEEZE_RIGHT,myThreadId)
      WRITE(msgBuffer,*)
     &'*******************************************************'
      CALL PRINT_MESSAGE(msgBuffer,errorMessageUnit,
     &  SQUEEZE_RIGHT,myThreadId)
      GOTO 1000
  902 CONTINUE
      WRITE(msgBuffer,*)
     &'                                                       '
      CALL PRINT_MESSAGE(msgBuffer,errorMessageUnit,
     &  SQUEEZE_RIGHT,myThreadId)
      WRITE(msgBuffer,*)
     &'*** WARNING WARNING WARNING WARNING WARNING WARNING ***'
      CALL PRINT_MESSAGE(msgBuffer,errorMessageUnit,
     &  SQUEEZE_RIGHT,myThreadId)
      WRITE(msgBuffer,*)
     &'procedure: "',callProc,'".'
      CALL PRINT_MESSAGE(msgBuffer,errorMessageUnit,
     &  SQUEEZE_RIGHT,myThreadId)
      WRITE(msgBuffer,*)
     &' No timer action specified.'
      CALL PRINT_MESSAGE(msgBuffer,errorMessageUnit,
     &  SQUEEZE_RIGHT,myThreadId)
      WRITE(msgBuffer,*)
     &' Valid actions are:'
      CALL PRINT_MESSAGE(msgBuffer,errorMessageUnit,
     &  SQUEEZE_RIGHT,myThreadId)
      WRITE(msgBuffer,*)
     &' "START", "STOP", "PRINT" and "PRINTALL".'
      CALL PRINT_MESSAGE(msgBuffer,errorMessageUnit,
     &  SQUEEZE_RIGHT,myThreadId)
      WRITE(msgBuffer,*)
     &'*******************************************************'
      CALL PRINT_MESSAGE(msgBuffer,errorMessageUnit,
     &  SQUEEZE_RIGHT,myThreadId)
      GOTO 1000
  903 CONTINUE
      WRITE(msgBuffer,*)
     &'                                                       '
      CALL PRINT_MESSAGE(msgBuffer,errorMessageUnit,
     &  SQUEEZE_RIGHT,myThreadId)
      WRITE(msgBuffer,*)
     &'*** WARNING WARNING WARNING WARNING WARNING WARNING ***'
      CALL PRINT_MESSAGE(msgBuffer,errorMessageUnit,
     &  SQUEEZE_RIGHT,myThreadId)
      WRITE(msgBuffer,*)
     &'procedure: "',callProc,'".'
      CALL PRINT_MESSAGE(msgBuffer,errorMessageUnit,
     &  SQUEEZE_RIGHT,myThreadId)
      WRITE(msgBuffer,*)
     &'Timer action"',name(ISTART:IEND),'" is invalid.'
      CALL PRINT_MESSAGE(msgBuffer,errorMessageUnit,
     &  SQUEEZE_RIGHT,myThreadId)
      WRITE(msgBuffer,*)
     &' Valid actions are:'
      CALL PRINT_MESSAGE(msgBuffer,errorMessageUnit,
     &  SQUEEZE_RIGHT,myThreadId)
      WRITE(msgBuffer,*)
     &' "START", "STOP", "PRINT" and "PRINTALL".'
      CALL PRINT_MESSAGE(msgBuffer,errorMessageUnit,
     &  SQUEEZE_RIGHT,myThreadId)
      WRITE(msgBuffer,*)
     &'*******************************************************'
      CALL PRINT_MESSAGE(msgBuffer,errorMessageUnit,
     &  SQUEEZE_RIGHT,myThreadId)
      GOTO 1000
  904 CONTINUE
      WRITE(msgBuffer,*)
     &'                                                       '
      CALL PRINT_MESSAGE(msgBuffer,errorMessageUnit,
     &  SQUEEZE_RIGHT,myThreadId)
      WRITE(msgBuffer,*)
     &'*** WARNING WARNING WARNING WARNING WARNING WARNING ***'
      CALL PRINT_MESSAGE(msgBuffer,errorMessageUnit,
     &  SQUEEZE_RIGHT,myThreadId)
      WRITE(msgBuffer,*)
     &'procedure: "',callProc,'".'
      CALL PRINT_MESSAGE(msgBuffer,errorMessageUnit,
     &  SQUEEZE_RIGHT,myThreadId)
      WRITE(msgBuffer,*)
     &'Timer "',name(ISTART:IEND),'" cannot be created.'
      CALL PRINT_MESSAGE(msgBuffer,errorMessageUnit,
     &  SQUEEZE_RIGHT,myThreadId)
      WRITE(msgBuffer,*)
     &' Only ',maxTimers,' timers are allowed.'
      CALL PRINT_MESSAGE(msgBuffer,errorMessageUnit,
     &  SQUEEZE_RIGHT,myThreadId)
      WRITE(msgBuffer,*)
     &'*******************************************************'
      CALL PRINT_MESSAGE(msgBuffer,errorMessageUnit,
     &  SQUEEZE_RIGHT,myThreadId)
      GOTO 1000
  905 CONTINUE
      WRITE(msgBuffer,*)
     &'                                                       '
      CALL PRINT_MESSAGE(msgBuffer,errorMessageUnit,
     &  SQUEEZE_RIGHT,myThreadId)
      WRITE(msgBuffer,*)
     &'*** WARNING WARNING WARNING WARNING WARNING WARNING ***'
      CALL PRINT_MESSAGE(msgBuffer,errorMessageUnit,
     &  SQUEEZE_RIGHT,myThreadId)
      WRITE(msgBuffer,*)
     &'procedure: "',callProc,'".'
      CALL PRINT_MESSAGE(msgBuffer,errorMessageUnit,
     &  SQUEEZE_RIGHT,myThreadId)
      WRITE(msgBuffer,*)
     &'Timer name is blank.'
      CALL PRINT_MESSAGE(msgBuffer,errorMessageUnit,
     &  SQUEEZE_RIGHT,myThreadId)
      WRITE(msgBuffer,*)
     &' A name must be used with "START", "STOP" or  "PRINT".'
      CALL PRINT_MESSAGE(msgBuffer,errorMessageUnit,
     &  SQUEEZE_RIGHT,myThreadId)
      WRITE(msgBuffer,*)
     &'*******************************************************'
      CALL PRINT_MESSAGE(msgBuffer,errorMessageUnit,
     &  SQUEEZE_RIGHT,myThreadId)
      GOTO 1000

#if (defined USE_PAPI) || (defined USE_PCL)
 71   FORMAT(A,' per sec ',D13.7,' ',D13.7,', number ', D13.7)
#endif
c72   FORMAT(A,D13.7)
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: TIMER_GET_TIME

C     !INTERFACE:
      SUBROUTINE TIMER_GET_TIME(
     O                           userTime,
     O                           systemTime,
     O                           wallClockTime )
      IMPLICIT NONE

C     !DESCRIPTION:
C     *==========================================================*
C     | SUBROUTINE TIMER\_GET\_TIME
C     | o Query system timer routines.
C     *==========================================================*
C     | Routine returns total elapsed time for program so far.
C     | Three times are returned that conventionally are used as
C     | user time, system time and wall-clock time. Not all these
C     | numbers are available on all machines.
C     *==========================================================*

C     !INPUT/OUTPUT PARAMETERS:
C     userTime      :: User time returned
C     systemTime    :: System time returned
C     wallClockTime :: Wall clock time returned

      Real*8 userTime
      Real*8 systemTime
      Real*8 wallClockTime

C     The following was seriously hacked around by Mark Hadfield
C     October 2006

#ifdef IGNORE_TIME

      userTime = 0.
      systemTime = 0.
      wallClockTime = 0.

#else

C     Declarations follow the same preprocessor structure as the
C     executable code below.

# if defined (TARGET_AIX) || defined (TARGET_BGL)
      Real*4 etime_
      Real*8 timenow
      external etime_, timenow
      Real*4 actual, tarray(2)
# elif (defined TARGET_T3E || defined TARGET_CRAY_VECTOR)
      real second, secondr
      external second, secondr
# else
#  ifdef HAVE_ETIME_FCT
      Real*4 etime
      EXTERNAL etime
      Real*4 actual, tarray(2)
#  elif (defined HAVE_ETIME_SBR)
      Real*4 actual, tarray(2)
#  else
      Real*8 csystemtime, cusertime
      external csystemtime, cusertime
#  endif
#  if defined HAVE_CLOC
      Real*8 wtime
#  elif (defined (ALLOW_USE_MPI) && defined (USE_MPI_WTIME))
C     No declarations necessary
#  else
      Real*8 timenow
      external timenow
#  endif /* HAVE_CLOC */
# endif
CEOP

C     Executable code

CCE107 Fixed for AIX and UNICOS
# if defined(TARGET_AIX) || defined(TARGET_BGL)
      ACTUAL = ETIME_(TARRAY)
      userTime      = TARRAY(1)
      systemTime    = TARRAY(2)
      wallClockTime = timenow()
# elif (defined (TARGET_T3E) || defined (TARGET_CRAY_VECTOR))
      userTime      = SECOND()
      systemTime    = 0.
      wallClockTime = SECONDR()
# else
#  ifdef HAVE_ETIME_FCT
      actual = etime(tarray)
      userTime = tarray(1)
      systemTime = tarray(2)
#  elif (defined HAVE_ETIME_SBR)
      call etime(tarray,actual)
      userTime = tarray(1)
      systemTime = tarray(2)
#  else
      userTime   = cusertime()
      systemTime = csystemtime()
#  endif
#  if defined HAVE_CLOC
      CALL cloc(wTime)
      wallClockTime = wtime
#  elif (defined (ALLOW_USE_MPI) && defined (USE_MPI_WTIME))
      wallClockTime = MPI_Wtime()
#  else
      wallClockTime = timenow()
#  endif
# endif
#endif

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: TIMER_PRINTALL

C     !INTERFACE:
      SUBROUTINE TIMER_PRINTALL( myThreadId )
      IMPLICIT NONE

C     !DESCRIPTION:
C     *==========================================================*
C     | SUBROUTINE TIMER\_PRINTALL
C     | o Print timer information
C     *==========================================================*
C     | Request print out of table of timing from all timers.
C     *==========================================================*

C     !INPUT PARAMETERS:
C     myThreadId :: This threads number
      INTEGER myThreadId
CEOP

      CALL TIMER_CONTROL( ' ', 'PRINTALL', 'TIMER_PRINTALL' ,
     &                   myThreadId )
C
      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: TIMER_START

C     !INTERFACE:
      SUBROUTINE TIMER_START ( string , myThreadId )
      IMPLICIT NONE

C     !DESCRIPTION:
C     Start timer named "string".

C     !INPUT PARAMETERS:
C     string     :: Name of timer
C     myThreadId :: My thread number
      CHARACTER*(*) string
      INTEGER myThreadId
CEOP
C
      CALL TIMER_CONTROL( string, 'START', 'TIMER_START' , myThreadId)
C
      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: TIMER_STOP

C     !INTERFACE:
      SUBROUTINE TIMER_STOP  ( string , myThreadId )
      IMPLICIT NONE

C     !DESCRIPTION:
C     Stop timer named "string".

C     !INPUT PARAMETERS:
C     string     :: Name of timer
C     myThreadId :: My thread number
      CHARACTER*(*) string
      INTEGER myThreadId
CEOP
C
      CALL TIMER_CONTROL( string, 'STOP', 'TIMER_STOP' , myThreadId )
C
      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#ifdef USE_PAPI
CCE107 Initialization of common block for PAPI timers
      BLOCK DATA setpapivalues
#include "EEPARAMS.h"
      INTEGER maxTimers
      PARAMETER (maxTimers = 50)
      INTEGER nmaxevents
      PARAMETER (nmaxevents = 18)
      INTEGER size
      PARAMETER (size = 3*nmaxevents*maxTimers*MAX_NO_THREADS)
      INTEGER*8 values(nmaxevents, maxTimers , MAX_NO_THREADS),
     $     values1(nmaxevents, maxTimers, MAX_NO_THREADS),
     $     values2(nmaxevents, maxTimers, MAX_NO_THREADS)
      COMMON /papivalues/ values, values1, values2
      DATA values, values1, values2 /size*0/
      END
#endif
#if defined(USE_PCL_FLOPS_SFP) || defined(USE_PCL_FLOPS) || defined(USE_PCL)
CCE107 Initialization of common block for PCL event names
      BLOCK DATA setpclnames
      INTEGER nmaxevents
      PARAMETER (nmaxevents = 61)
      CHARACTER*22 pcl_counter_name(0:nmaxevents-1)
      COMMON /pclnames/ pcl_counter_name
      DATA pcl_counter_name(0) /'PCL_L1CACHE_READ'/
      DATA pcl_counter_name(1) /'PCL_L1CACHE_WRITE'/
      DATA pcl_counter_name(2) /'PCL_L1CACHE_READWRITE'/
      DATA pcl_counter_name(3) /'PCL_L1CACHE_HIT'/
      DATA pcl_counter_name(4) /'PCL_L1CACHE_MISS'/
      DATA pcl_counter_name(5) /'PCL_L1DCACHE_READ'/
      DATA pcl_counter_name(6) /'PCL_L1DCACHE_WRITE'/
      DATA pcl_counter_name(7) /'PCL_L1DCACHE_READWRITE'/
      DATA pcl_counter_name(8) /'PCL_L1DCACHE_HIT'/
      DATA pcl_counter_name(9) /'PCL_L1DCACHE_MISS'/
      DATA pcl_counter_name(10) /'PCL_L1ICACHE_READ'/
      DATA pcl_counter_name(11) /'PCL_L1ICACHE_WRITE'/
      DATA pcl_counter_name(12) /'PCL_L1ICACHE_READWRITE'/
      DATA pcl_counter_name(13) /'PCL_L1ICACHE_HIT'/
      DATA pcl_counter_name(14) /'PCL_L1ICACHE_MISS'/
      DATA pcl_counter_name(15) /'PCL_L2CACHE_READ'/
      DATA pcl_counter_name(16) /'PCL_L2CACHE_WRITE'/
      DATA pcl_counter_name(17) /'PCL_L2CACHE_READWRITE'/
      DATA pcl_counter_name(18) /'PCL_L2CACHE_HIT'/
      DATA pcl_counter_name(19) /'PCL_L2CACHE_MISS'/
      DATA pcl_counter_name(20) /'PCL_L2DCACHE_READ'/
      DATA pcl_counter_name(21) /'PCL_L2DCACHE_WRITE'/
      DATA pcl_counter_name(22) /'PCL_L2DCACHE_READWRITE'/
      DATA pcl_counter_name(23) /'PCL_L2DCACHE_HIT'/
      DATA pcl_counter_name(24) /'PCL_L2DCACHE_MISS'/
      DATA pcl_counter_name(25) /'PCL_L2ICACHE_READ'/
      DATA pcl_counter_name(26) /'PCL_L2ICACHE_WRITE'/
      DATA pcl_counter_name(27) /'PCL_L2ICACHE_READWRITE'/
      DATA pcl_counter_name(28) /'PCL_L2ICACHE_HIT'/
      DATA pcl_counter_name(29) /'PCL_L2ICACHE_MISS'/
      DATA pcl_counter_name(30) /'PCL_TLB_HIT'/
      DATA pcl_counter_name(31) /'PCL_TLB_MISS'/
      DATA pcl_counter_name(32) /'PCL_ITLB_HIT'/
      DATA pcl_counter_name(33) /'PCL_ITLB_MISS'/
      DATA pcl_counter_name(34) /'PCL_DTLB_HIT'/
      DATA pcl_counter_name(35) /'PCL_DTLB_MISS'/
      DATA pcl_counter_name(36) /'PCL_CYCLES'/
      DATA pcl_counter_name(37) /'PCL_ELAPSED_CYCLES'/
      DATA pcl_counter_name(38) /'PCL_INTEGER_INSTR'/
      DATA pcl_counter_name(39) /'PCL_FP_INSTR'/
      DATA pcl_counter_name(40) /'PCL_LOAD_INSTR'/
      DATA pcl_counter_name(41) /'PCL_STORE_INSTR'/
      DATA pcl_counter_name(42) /'PCL_LOADSTORE_INSTR'/
      DATA pcl_counter_name(43) /'PCL_INSTR'/
      DATA pcl_counter_name(44) /'PCL_JUMP_SUCCESS'/
      DATA pcl_counter_name(45) /'PCL_JUMP_UNSUCCESS'/
      DATA pcl_counter_name(46) /'PCL_JUMP'/
      DATA pcl_counter_name(47) /'PCL_ATOMIC_SUCCESS'/
      DATA pcl_counter_name(48) /'PCL_ATOMIC_UNSUCCESS'/
      DATA pcl_counter_name(49) /'PCL_ATOMIC'/
      DATA pcl_counter_name(50) /'PCL_STALL_INTEGER'/
      DATA pcl_counter_name(51) /'PCL_STALL_FP'/
      DATA pcl_counter_name(52) /'PCL_STALL_JUMP'/
      DATA pcl_counter_name(53) /'PCL_STALL_LOAD'/
      DATA pcl_counter_name(54) /'PCL_STALL_STORE'/
      DATA pcl_counter_name(55) /'PCL_STALL'/
      DATA pcl_counter_name(56) /'PCL_MFLOPS'/
      DATA pcl_counter_name(57) /'PCL_IPC'/
      DATA pcl_counter_name(58) /'PCL_L1DCACHE_MISSRATE'/
      DATA pcl_counter_name(59) /'PCL_L2DCACHE_MISSRATE'/
      DATA pcl_counter_name(60) /'PCL_MEM_FP_RATIO'/
      END

#ifdef USE_PCL
CCE107 Initialization of common block for PCL summary performance
      BLOCK DATA setpcls
#include "EEPARAMS.h"
      INTEGER maxTimers
      PARAMETER (maxTimers = 50)
      INTEGER nmaxevents
      PARAMETER (nmaxevents = 61)
      INTEGER size
      PARAMETER (size = nmaxevents*maxTimers*MAX_NO_THREADS)
      INTEGER PCL_CYCLES, PCL_MODE_USER_SYSTEM
      PARAMETER (PCL_CYCLES=36, PCL_MODE_USER_SYSTEM=3)
      INTEGER pcl_counter_list(nmaxevents)
      INTEGER flags, nevents
      INTEGER*8 i_result(nmaxevents, maxTimers, MAX_NO_THREADS)
      INTEGER*8 i_result1(nmaxevents, maxTimers, MAX_NO_THREADS)
      INTEGER*8 i_result2(nmaxevents, maxTimers, MAX_NO_THREADS)
      INTEGER*8 descr
      REAL*8 fp_result(nmaxevents, maxTimers, MAX_NO_THREADS)
      COMMON /pclvars/ i_result, descr, fp_result, pcl_counter_list,
     $     flags, nevents
      DATA fp_result /size*0.0D0/
      DATA i_result /size*0/
      DATA i_result1 /size*0/
      DATA i_result2 /size*0/
      DATA descr /0/
      DATA nevents /nmaxevents/
      DATA pcl_counter_list /nmaxevents*PCL_CYCLES/
      DATA flags /PCL_MODE_USER_SYSTEM/
      END
#else
CCE107 Initialization of common block for PCL summary performance
      BLOCK DATA setpcls
      INTEGER PCL_MFLOPS, PCL_IPC, PCL_L1DCACHE_MISSRATE,
     $     PCL_L2DCACHE_MISSRATE, PCL_MEM_FP_RATIO
      PARAMETER (PCL_MFLOPS=56, PCL_IPC=57, PCL_L1DCACHE_MISSRATE=58,
     $     PCL_L2DCACHE_MISSRATE=59, PCL_MEM_FP_RATIO=60)
      INTEGER PCL_MODE_USER_SYSTEM
      PARAMETER (PCL_MODE_USER_SYSTEM=3)
      INTEGER pcl_counter_list(5), flags, nevents
      INTEGER*8 i_result(5), descr
      REAL*8 fp_result(5)
      COMMON /pclvars/ i_result, descr, fp_result, pcl_counter_list,
     $     flags, nevents
      DATA fp_result /5*0.0D0/
      DATA i_result /5*0/
      DATA descr /0/
      DATA nevents /0/
      DATA pcl_counter_list /PCL_MFLOPS, PCL_IPC, PCL_L1DCACHE_MISSRATE,
     $     PCL_L2DCACHE_MISSRATE, PCL_MEM_FP_RATIO/
      DATA flags /PCL_MODE_USER_SYSTEM/
      END
#endif
#endif

#include "AIM_OPTIONS.h"

CBOP
C     !ROUTINE: SUFLUX_POST
C     !INTERFACE:
      SUBROUTINE SUFLUX_POST(
     I                   FMASK, EMISloc, 
     I                   TLAND, TSEA, TSICE, dTskin, SLRD,
     I                   T0, Q0, DENVV,
     U                   DRAG, SHF, EVAP, SLRup,
     O                   SLRU, TSFC, TSKIN,
     I                   bi,bj,myThid)

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R SUFLUX_POST
C     | o finish surface flux calculation
C     *==========================================================*
C     | o contain 2nd part of original S/R SUFLUX (Speedy code)
C     *==========================================================*
C--
C--   SUBROUTINE SUFLUX (PSA,UA,VA,TA,QA,RH,PHI,
C--  &                   PHI0,FMASK,TLAND,TSEA,SWAV,SSR,SLRD,
C--  &                   USTR,VSTR,SHF,EVAP,SLRU,
C--  &                   TSFC,TSKIN,U0,V0,T0,Q0)
C--
C--   Purpose: Compute surface fluxes of momentum, energy and moisture,
C--            and define surface skin temperature from energy balance
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     Resolution parameters

C-- size for MITgcm & Physics package :
#include "AIM_SIZE.h"

#include "EEPARAMS.h"
#include "GRID.h"

C     Physical constants + functions of sigma and latitude
#include "com_physcon.h"

C     Surface flux constants
#include "com_sflcon.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine Arguments ==
C--   Input:
C    FMASK  :: fraction land - sea - sea-ice (2.5-dim)
C    EMISloc:: longwave surface emissivity
C    TLAND  :: land-surface temperature        (2-dim)
C    TSEA   ::  sea-surface temperature        (2-dim)
C    TSICE  ::  sea-ice surface temperature    (2-dim)
C    dTskin :: temp. correction for daily-cycle heating [K]
C    SLRD   :: sfc lw radiation (downward flux)(2-dim)
C    SSR    :: sfc sw radiation (net flux)     (2-dim)
C    T0     :: near-surface air temperature    (2-dim)
C    Q0     :: near-surface sp. humidity [g/kg](2-dim)
C    DENVV  :: surface flux (sens,lat.) coeff. (=Rho*|V|) [kg/m2/s]
C--   Output:
C    DRAG   :: surface Drag term (= Cd*Rho*|V|)(2-dim)
C    SHF    :: sensible heat flux              (2-dim)
C    EVAP   :: evaporation [g/(m^2 s)]         (2-dim)
C    SLRU   :: sfc lw radiation (upward flux)  (2-dim)
C    SLRup  :: same, for each surface type     (2-dim)
C    TSFC   :: surface temperature (clim.)     (2-dim)
C    TSKIN  :: skin surface temperature        (2-dim)
C--   Input:
C    bi,bj  :: tile index
C    myThid :: Thread number for this instance of the routine
C--
      _RL  FMASK(NGP,3), EMISloc 
      _RL  TLAND(NGP), TSEA(NGP), TSICE(NGP), dTskin(NGP), SLRD(NGP)
      _RL  T0(NGP), Q0(NGP), DENVV(NGP)

      _RL  DRAG(NGP,0:3), SHF(NGP,0:3), EVAP(NGP,0:3), SLRup(NGP,3)
      _RL  SLRU(NGP), TSFC(NGP), TSKIN(NGP)

      INTEGER bi,bj,myThid
CEOP

#ifdef ALLOW_AIM

C-- Local variables:
C     J,i1,j1 :: Loop counters
C     msgBuf  :: Informational/error message buffer
      INTEGER J,i1,j1
      CHARACTER*(MAX_LEN_MBUF) msgBuf

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C--   1. Extrapolation of wind, temp, hum. and density to the surface

C--   2. Computation of fluxes over land and sea

C--   3. Adjustment of skin temperature and fluxes over land
C--      based on energy balance (to be implemented)


C--   4. Weighted average of surface fluxes and temperatures
C--      according to land-sea mask

      DO J=1,NGP
c       USTR(J,3) = USTR(J,2)+FMASK(J,1)*(USTR(J,1)-USTR(J,2))
c       VSTR(J,3) = VSTR(J,2)+FMASK(J,1)*(VSTR(J,1)-VSTR(J,2))
c       DRAG(J,0) = DRAG(J,2)+FMASK(J,1)*(DRAG(J,1)-DRAG(J,2))
c        SHF(J,0) =  SHF(J,2)+FMASK(J,1)*( SHF(J,1)- SHF(J,2))
c       EVAP(J,0) = EVAP(J,2)+FMASK(J,1)*(EVAP(J,1)-EVAP(J,2))
c       SLRU(J)  = SLRup(J,2)+FMASK(J,1)*(SLRup(J,1)-SLRup(J,2))
        DRAG(J,0) = (FMASK(J,1)*DRAG(J,1)+FMASK(J,2)*DRAG(J,2)
     &                                   +FMASK(J,3)*DRAG(J,3))
        SHF (J,0) = (FMASK(J,1)*SHF(J,1) +FMASK(J,2)*SHF(J,2)
     &                                   +FMASK(J,3)*SHF(J,3) )
        EVAP(J,0) = (FMASK(J,1)*EVAP(J,1)+FMASK(J,2)*EVAP(J,2)
     &                                   +FMASK(J,3)*EVAP(J,3))
        SLRU(J)  = (FMASK(J,1)*SLRup(J,1)+FMASK(J,2)*SLRup(J,2)
     &                                   +FMASK(J,3)*SLRup(J,3))
      ENDDO

      DO J=1,NGP
c       TSFC(J)  = TSEA(J)+FMASK(J,1)*(TLAND(J)-TSEA(J))
        TSFC(J)  = (FMASK(J,1)*TLAND(J) + FMASK(J,2)*TSEA(J)
     &                                  + FMASK(J,3)*TSICE(J))
        TSKIN(J) = TSFC(J)+FMASK(J,1)*dTskin(J)
      ENDDO

C-    Compute Net LW surf flux (+=upward) for each surface type:
C      (for diagnostic only)
      DO J=1,NGP
        SLRup(J,1)=EMISloc*SLRup(J,1)-SLRD(J)
        SLRup(J,2)=EMISloc*SLRup(J,2)-SLRD(J)
        SLRup(J,3)=EMISloc*SLRup(J,3)-SLRD(J)
        SLRU(J)   =EMISloc*SLRU(J)
      ENDDO

C-    Check that Temp is OK for LW Radiation scheme :
       DO J=1,NGP
        IF (  TSFC(J).LT.lwTemp1 .OR.
     &        TSFC(J).GT.lwTemp2 ) THEN
         i1 = 1 + mod((J-1),sNx)
         j1 = 1 + int((J-1)/sNx)
         WRITE(msgBuf,'(A,1PE20.13,A,2I4)')
     &    'SUFLUX_POST: TS=', TSFC(J),
     &    ' out of range ',lwTemp1,lwTemp2
         CALL PRINT_ERROR( msgBuf , myThid)
         WRITE(msgBuf,'(A,1P3E10.3,A,0P3F8.5)')
     &    'SUFLUX_POST: T_Lnd,Sea,Sic=',TLAND(J),TSEA(J),TSICE(J),
     &                ' Mask:',FMASK(J,1),FMASK(J,2),FMASK(J,3)
         CALL PRINT_ERROR( msgBuf , myThid)
         WRITE(msgBuf,'(A,2I4,3I3,I6,2F9.3)')
     &    'SUFLUX_POST: Pb in i,j,bi,bj,myThid,IJ,X,Y=',
     &        i1,j1,bi,bj,myThid,J,xC(i1,j1,bi,bj),yC(i1,j1,bi,bj)
         CALL PRINT_ERROR( msgBuf , myThid)
         STOP 'ABNORMAL END: S/R SUFLUX_POST'
        ENDIF
       ENDDO

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
#endif /* ALLOW_AIM */

      RETURN
      END

#include "CPP_EEOPTIONS.h"
#include "W2_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 0
C !ROUTINE: W2_SET_CS6_FACETS( myThid )

C !INTERFACE:
      SUBROUTINE W2_SET_CS6_FACETS( myThid )

C     !DESCRIPTION:
C     Set-up multi facets(=sub-domains) topology : 6 facets Cube case
C     Facet Dimension taken from the 1rst 3 facet_dims (nRed, nGreen, nBlue)
C     if provided in "data.exch2"; if not, assume regular Cube (equal size)
C     and derive single dimension from "SIZE.h".

C     !USES:
      IMPLICIT NONE

C      Tile topology settings data structures
#include "SIZE.h"
#include "EEPARAMS.h"
#include "W2_EXCH2_SIZE.h"
#include "W2_EXCH2_PARAMS.h"
#include "W2_EXCH2_TOPOLOGY.h"

C     !INPUT PARAMETERS:
C     myThid  :: my Thread Id number
C               (Note: not relevant since threading has not yet started)
      INTEGER myThid

C     !LOCAL VARIABLES:
C     === Local variables ===
C     msgBuf     :: Informational/error message buffer
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      CHARACTER*1 edge(4)
      INTEGER i, j, ii, jj, lo, ll
      INTEGER nRd, nGr, nBl
      INTEGER setDims, addDims
      LOGICAL prtFlag
      Real*4  tmpVar
CEOP
      DATA edge / 'N' , 'S' , 'E' , 'W' /

      WRITE(msgBuf,'(2A,I3,A)') 'W2_SET_CS6_FACETS:',
     &              ' preDefTopol=', preDefTopol, ' selected'
      CALL PRINT_MESSAGE( msgBuf, W2_oUnit,SQUEEZE_RIGHT,myThid )
      prtFlag = ABS(W2_printMsg).GE.2
     &       .OR. ( W2_printMsg .NE.0 .AND. myProcId.EQ.0 )

C--   Number of facets:
      nFacets = 6
      IF ( nfacets.GT.W2_maxNbFacets ) THEN
       CALL ALL_PROC_DIE( 0 )
       STOP 'ABNORMAL END: S/R W2_SET_CS6_FACETS (nFacets>maxNbFacets)'
      ENDIF

C--   Facet Edge connections ( edges order: N,S,E,W <==> 1,2,3,4 )
      DO j=1,nFacets
       IF ( MOD(j,2).EQ.1 ) THEN
         jj = j+2
         facet_link(1,j) = 0.4 + FLOAT( 1+MOD(jj+5,6) )
         jj = j-1
         facet_link(2,j) = 0.1 + FLOAT( 1+MOD(jj+5,6) )
         jj = j+1
         facet_link(3,j) = 0.4 + FLOAT( 1+MOD(jj+5,6) )
         jj = j-2
         facet_link(4,j) = 0.1 + FLOAT( 1+MOD(jj+5,6) )
       ELSE
         jj = j+1
         facet_link(1,j) = 0.2 + FLOAT( 1+MOD(jj+5,6) )
         jj = j-2
         facet_link(2,j) = 0.3 + FLOAT( 1+MOD(jj+5,6) )
         jj = j+2
         facet_link(3,j) = 0.2 + FLOAT( 1+MOD(jj+5,6) )
         jj = j-1
         facet_link(4,j) = 0.3 + FLOAT( 1+MOD(jj+5,6) )
       ENDIF
      ENDDO

C--   facet dimension: take the 1rst 3 numbers from facet_dims
      nRd = facet_dims(1)
      nGr = facet_dims(2)
      nBl = facet_dims(3)
      DO j=4,W2_maxNbFacets*2
        IF ( facet_dims(j).NE.0 ) THEN
         WRITE(msgBuf,'(2A,I5)') 'W2_SET_CS6_FACETS:',
     &     ' no more than 3 dims (nRd,nGr,nBl) expected for CS-6 Topol'
         CALL PRINT_MESSAGE( msgBuf, W2_oUnit,SQUEEZE_RIGHT,myThid )
         CALL PRINT_ERROR( msgBuf, myThid )
         CALL ALL_PROC_DIE( 0 )
         STOP 'ABNORMAL END: S/R W2_SET_CS6_FACETS: allows 3 dims only'
        ENDIF
      ENDDO
      IF ( nRd.GT.0 .AND. nGr+nBl.EQ.0 ) THEN
C-    Only 1rst dim is set: assuming a regular Cube
        nGr = nRd
        nBl = nRd
      ELSEIF ( nRd+nGr+nBl.EQ.0 ) THEN
C-    try to get cube size from number of tiles, assuming a regular Cube
        nGr = exch2_nTiles*sNx*sNy
        tmpVar = FLOAT(nGr)/6.
        tmpVar = SQRT(tmpVar)
        nRd = NINT(tmpVar)
        IF ( nRd*nRd*6 .EQ. nGr ) THEN
          nGr = nRd
          nBl = nRd
          WRITE(msgBuf,'(2A,I5)') 'W2_SET_CS6_FACETS:',
     &     ' facet-dims Unset; assume nRd=nGr=nBl=', nRd
          CALL PRINT_MESSAGE( msgBuf, W2_oUnit,SQUEEZE_RIGHT,myThid )
        ELSE
          WRITE(msgBuf,'(A,I8,2(A,I4),A,I10,A,I6,A)')
     &     ' nTiles*sNx*sNy=', exch2_nTiles,' x',sNx,' x',sNy,' =',nGr
          CALL PRINT_MESSAGE( msgBuf, W2_oUnit,SQUEEZE_RIGHT,myThid )
          WRITE(msgBuf,'(A,I6,A,I10)')
     &     '       not equal to: 6 x',nRd,'^2 =', nRd*nRd*6
          CALL PRINT_MESSAGE( msgBuf, W2_oUnit,SQUEEZE_RIGHT,myThid )
          WRITE(msgBuf,'(2A,I5)') 'W2_SET_CS6_FACETS:',
     &     ' facet-dims Unset; attempt to fit single dim FAIL'
          CALL PRINT_MESSAGE( msgBuf, W2_oUnit,SQUEEZE_RIGHT,myThid )
          CALL PRINT_ERROR( msgBuf, myThid )
        ENDIF
      ENDIF
      IF ( nRd*nGr*nBl.EQ.0 ) THEN
       CALL ALL_PROC_DIE( 0 )
       STOP 'ABNORMAL END: S/R W2_SET_CS6_FACETS (Dims are missing)'
      ENDIF

C--   Set facet dimension : 1rst 3 are known:
      facet_dims(1) = nRd
      facet_dims(2) = nGr
      facet_dims(3) = nBl
C-    Derive the other using from connection graph (topology):
      setDims = 3
      addDims = 1
      DO WHILE ( addDims.GT.0 )
        addDims = 0
        DO j=2,nFacets
         DO i=1,4
C-    connected to:
          jj = INT(facet_link(i,j))
          ii = MOD( NINT(facet_link(i,j)*10.), 10 )
          IF ( jj.GE.1 .AND. jj.LE.nFacets
     &         .AND.  ii.GE.1 .AND. ii.LE.4 ) THEN
C-    Length of N or S Edge = x-size, E or W Edge = y-size
           lo = 2*(j-1) + (i+1)/2
C-    Corresponding Edge length
           ll = 2*(jj-1)+(ii+1)/2
           IF ( facet_dims(lo).EQ.0 .AND. facet_dims(ll).GT.0 ) THEN
             addDims = addDims + 1
             facet_dims(lo) = facet_dims(ll)
             IF ( prtFlag ) THEN
              WRITE(msgBuf,'(A,I3,3A,2(I4,A),I3,3A,I8)')
     &         ' facet',j,'.',edge(i), ' set dim', lo, ' = dim', ll,
     &         ' from',jj,'.',edge(ii),' :',facet_dims(ll)
              CALL PRINT_MESSAGE(msgBuf,W2_oUnit,SQUEEZE_RIGHT,myThid)
             ENDIF
           ENDIF
          ENDIF
         ENDDO
        ENDDO
        setDims = setDims + addDims
      ENDDO

      IF ( setDims.NE.nFacets*2 ) THEN
        WRITE(msgBuf,'(A,I3,A)') ' W2_SET_CS6_FACETS:',
     &     nFacets*2-setDims, ' facet-dims left Unset'
        CALL PRINT_MESSAGE( msgBuf, W2_oUnit, SQUEEZE_RIGHT, myThid )
        CALL PRINT_ERROR( msgBuf, myThid )
        DO j=1,nFacets
         IF ( facet_dims(2*j-1)*facet_dims(2*j).EQ.0 ) THEN
          WRITE(W2_oUnit,'(A,I3,2(A,I8))')
     &        ' facets #', j, ' , x-size=', facet_dims(2*j-1),
     &                        ' , y-size=', facet_dims(2*j)
          CALL PRINT_MESSAGE( msgBuf, W2_oUnit,SQUEEZE_RIGHT,myThid )
          CALL PRINT_ERROR( msgBuf, myThid )
         ENDIF
        ENDDO
        CALL ALL_PROC_DIE( 0 )
        STOP 'ABNORMAL END: S/R W2_SET_CS6_FACETS (unset facet dims)'
      ENDIF

      RETURN
      END

#include "CAL_OPTIONS.h"

      SUBROUTINE CAL_READPARMS( myThid )

C     ==================================================================
C     SUBROUTINE cal_readparms
C     ==================================================================
C     o This routine initialises the calendar according to the user
C       specifications in "data.calendar".
C
C     started: Christian Eckert eckert@mit.edu  30-Jun-1999
C     changed: Christian Eckert eckert@mit.edu  29-Dec-1999
C              - restructured the original version in order to have a
C                better interface to the MITgcmUV.
C
C              Christian Eckert eckert@mit.edu  10-Jan-2000
C              - Modified namelist input. The data file is first copied
C                to scrunit1 with the comment lines being left out.
C                After this, scrunit1 is used to read the namelist data.
C
C              Christian Eckert eckert@mit.edu  19-Jan-2000
C              - Changed the role of the routine arguments. Chris Hill
C                proposed to make the calendar less "invasive". The tool
C                now assumes that the MITgcmUV already provides an ade-
C                quate set of time stepping parameters. The calendar
C                only associates a date with the given starttime of the
C                numerical model. startdate corresponds to zero start-
C                time. So, given niter0 or startdate .ne. zero the actual
C                startdate of the current integration is shifted by the
C                time interval correponding to niter0, startdate respec-
C                tively.
C
C              Christian Eckert eckert@mit.edu  03-Feb-2000
C              - Introduced new routine and function names, cal_<NAME>,
C                for verion 0.1.3.
C     ==================================================================
C     SUBROUTINE cal_readparms
C     ==================================================================

      IMPLICIT NONE

C     == global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "cal.h"

C     == routine arguments ==
C     myThid       :: my Thread Id number
      INTEGER myThid

C     == local variables ==
      INTEGER       iUnit
      CHARACTER*(MAX_LEN_MBUF) msgBuf

C     == end of interface ==

C     Calendar parameters
      NAMELIST /CAL_NML/
     & TheCalendar,
     & startDate_1, startDate_2,
     & calendarDumps

#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_ENTER('CAL_READPARMS',myThid)
#endif

      IF ( .NOT.useCAL ) THEN
C-    pkg CAL is not used
        _BEGIN_MASTER(myThid)
C-    Track pkg activation status:
         cal_setStatus = -1
C     print a (weak) warning if data.cal is found
         CALL PACKAGES_UNUSED_MSG( 'useCAL', ' ', ' ' )
        _END_MASTER(myThid)
        RETURN
      ENDIF

      _BEGIN_MASTER(myThid)

C       Initialise the calendar parameters
        cal_setStatus = 0
        TheCalendar = ' '
        startdate_1 = 0
        startdate_2 = 0
        calendarDumps = .FALSE.

C       Next, read the calendar data file.
        WRITE(msgBuf,'(A)') 'CAL_READPARMS: opening data.cal'
        CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT , 1)

        CALL OPEN_COPY_DATA_FILE(
     I                          'data.cal', 'CAL_READPARMS',
     O                          iUnit,
     I                          myThid )
        READ(unit = iUnit, nml = cal_nml)
        WRITE(msgBuf,'(A)')
     &     'CAL_READPARMS: finished reading data.cal'
        CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                SQUEEZE_RIGHT , 1)
#ifdef SINGLE_DISK_IO
        CLOSE(iUnit)
#else
        CLOSE(iUnit,STATUS='DELETE')
#endif /* SINGLE_DISK_IO */

      _END_MASTER(myThid)

C     Everyone else must wait for the parameters to be loaded
      _BARRIER

#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_LEAVE('CAL_READPARMS',myThid)
#endif

      RETURN
      END

#include "RUNCLOCK_OPTIONS.h"

CBOP
C     !ROUTINE: RUNCLOCK_GETTIME
C     !INTERFACE:
      SUBROUTINE RUNCLOCK_GETTIME( yr,mo,dy,hr,mi,sc,tins )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE RUNCLOCK_GETTIME
C     | o Routine to get wall clock time
C     *==========================================================*
C     \ev
C     !USES:
      IMPLICIT NONE

C     === Global variables ===
#include "RUNCLOCK.h"

C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
      INTEGER yr,mo,dy,hr,mi,sc
      Real*8  tins

C     !LOCAL VARIABLES:
C     == Local variables ==
C     For use with DATE_AND_TIME
      CHARACTER*(8)  DAT_DATE
      CHARACTER*(10) DAT_TIME
      CHARACTER*(5)  DAT_ZONE
      INTEGER        DAT_VALS(10)
C     For use with TIMER_GET_TIME
      Real*8 TM_userTime
      Real*8 TM_systemTime
      Real*8 TM_wallClockTime
      INTEGER ms
CEOP

#ifdef ALLOW_RUNCLOCK

C     !LOCAL VARIABLES:
C     === Local variables ===
      INTEGER tm

#ifdef RUNCLOCK_USES_DATE_AND_TIME
      CALL date_and_time(DAT_DATE,DAT_TIME,DAT_ZONE,DAT_VALS)
      ms=DAT_VALS(8)
      sc=DAT_VALS(7)
      mi=DAT_VALS(6)
      hr=DAT_VALS(5)
      dy=DAT_VALS(3)
      mo=DAT_VALS(3)
      yr=DAT_VALS(3)
      tins=(((((yr-05)*12+mo)*30.+dy)*24.+hr)*60.+mi)*60.+sc+0.001*ms
#else
      CALL timer_get_time(TM_userTime,TM_systemTime,TM_wallClockTime)
      tm=int( TM_wallClockTime )
       sc=mod(tm,60)
      tm=(tm-sc)/60
       mi=mod(tm,60)
      tm=(tm-mi)/60
       hr=mod(tm,24)
      tm=(tm-hr)/24
       dy=mod(tm,30)
      tm=(tm-dy)/30
       mo=mod(tm,12)
       yr=(tm-mo)/12
      ms=TM_wallClockTime-int( TM_wallClockTime )
      tins=TM_wallClockTime
#endif /* RUNCLOCK_USES_DATE_AND_TIME */

c     write(0,*) 'RUNCLOCK_GETTIME: yr ... =',yr,mo,dy,hr,mi,sc,ms,tins

#endif /* ALLOW_RUNCLOCK */

      RETURN
      END

#include "OCN_CPL_OPTIONS.h"

CBOP 0
C !ROUTINE: OCN_IMPORT_FIELDS

C !INTERFACE:
      SUBROUTINE OCN_IMPORT_FIELDS( myIter, myThid )

C !DESCRIPTION:
C     *==========================================================*
C     | SUBROUTINE OCN_IMPORT_FIELDS
C     | o Routine for importing fields (e.g. surface fluxes)
C     |   from coupling layer.
C     *==========================================================*
C     | This version talks to the MIT Coupler. It uses the
C     | MIT Coupler "checkpoint 1" library calls.
C     *==========================================================*

C !USES:
      IMPLICIT NONE
C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "CPL_PARAMS.h"
#include "OCNIDS.h"
#include "OCNCPL.h"

C !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     myIter  :: Current timestep number.
C     myThid  :: Thread number for this instance of the routine
      INTEGER myIter
      INTEGER myThid
CEOP

#ifdef COMPONENT_MODULE
C !LOCAL VARIABLES:

C  Note: 1) all fields will have been gridded onto ocean grid.
C        2) MIT Coupler checkpoint1 does not allow asynchronous posting of
C          data, so ordering has to be consistent with coupling layer ordering

      _BARRIER
      _BEGIN_MASTER( myThid )

C-    Receive Atmospheric Sea-Level pressure from coupling layer.
      CALL COMPRECV_R8TILES( ocnSLPrName,
     I                       sNx, OLx, sNy, OLy, 1, nSx, nSy,
     O                       atmSLPr )

C-    Receive surface heatflux from coupling layer.
      CALL COMPRECV_R8TILES( ocnHeatFluxName,
     I                       sNx, OLx, sNy, OLy, 1, nSx, nSy,
     O                       HeatFlux )

C-    Receive net shortwave radiation from coupling layer.
      CALL COMPRECV_R8TILES( ocnQshortWaveName,
     I                       sNx, OLx, sNy, OLy, 1, nSx, nSy,
     O                       qShortWave )

C-    Receive Zonal surface wind-stress from coupling layer.
      CALL COMPRECV_R8TILES( ocnTauXName,
     I                       sNx, OLx, sNy, OLy, 1, nSx, nSy,
     O                       tauX )

C-    Receive Meridional surface wind-stress from coupling layer.
      CALL COMPRECV_R8TILES( ocnTauYName,
     I                       sNx, OLx, sNy, OLy, 1, nSx, nSy,
     O                       tauY )

C-    Receive fresh water flux from coupling layer.
      CALL COMPRECV_R8TILES( ocnFWFluxName,
     I                       sNx, OLx, sNy, OLy, 1, nSx, nSy,
     O                       FWFlux )

      IF ( ocn_cplExch1W_sIce ) THEN
C-    Receive salt flux (sea-ice model) from coupling layer.
        CALL COMPRECV_R8TILES( ocnSaltFxName,
     I                       sNx, OLx, sNy, OLy, 1, nSx, nSy,
     O                       iceSaltFlx )

C-    Receive sea-ice mass (sea-ice model) from coupling layer.
        CALL COMPRECV_R8TILES( ocnSIceMassName,
     I                       sNx, OLx, sNy, OLy, 1, nSx, nSy,
     O                       seaIceMass )
      ENDIF

#ifdef ALLOW_SALT_PLUME
      IF ( ocn_cplExch_SaltPl ) THEN
C-      Receive salt-plume flux (for pkg/salt_plume) from coupling layer.
        CALL COMPRECV_R8TILES( ocnSaltPlmFlxName,
     I                       sNx, OLx, sNy, OLy, 1, nSx, nSy,
     O                       saltPlmFlx_cpl )
      ENDIF
#endif
#ifdef ALLOW_DIC
      IF ( ocn_cplExch_RunOff ) THEN
C-      Receive Run-Off from coupling layer.
        CALL COMPRECV_R8TILES( ocnRunOffName,
     I                       sNx, OLx, sNy, OLy, 1, nSx, nSy,
     O                       RunOff_cpl )
      ENDIF
      IF ( ocn_cplExch_DIC ) THEN
C-      Receive atmos CO2 level from coupling layer.
        CALL COMPRECV_R8TILES( ocnAirCO2Name,
     I                       sNx, OLx, sNy, OLy, 1, nSx, nSy,
     O                       airCO2 )

C-      Receive surface windspeed from coupling layer.
        CALL COMPRECV_R8TILES( ocnWindSpdName,
     I                       sNx, OLx, sNy, OLy, 1, nSx, nSy,
     O                       surfWSpeed )
      ENDIF
#endif /* ALLOW_DIC */
#if (defined ALLOW_DIC) || (defined ALLOW_THSICE)
      IF ( ( ocn_cplExch1W_sIce.AND.ocn_cplExch_DIC )
     &  .OR. ocn_cplExch2W_sIce ) THEN
C-      Receive seaice fraction from coupling layer.
        CALL COMPRECV_R8TILES( ocnSIceFracName,
     I                       sNx, OLx, sNy, OLy, 1, nSx, nSy,
     O                       sIceFrac_cpl )
      ENDIF
#endif /* ALLOW_DIC or ALLOW_THSICE */
#ifdef ALLOW_THSICE
      IF ( ocn_cplExch2W_sIce ) THEN
C-      Receive thSIce state-vars from coupling layer.
        CALL COMPRECV_R8TILES( ocnSIceThickName,
     I                       sNx, OLx, sNy, OLy, 1, nSx, nSy,
     O                       sIceThick_cpl )
        CALL COMPRECV_R8TILES( ocnSIceSnowName,
     I                       sNx, OLx, sNy, OLy, 1, nSx, nSy,
     O                       sIceSnowH_cpl )
        CALL COMPRECV_R8TILES( ocnSIceQ1Name,
     I                       sNx, OLx, sNy, OLy, 1, nSx, nSy,
     O                       sIceQ1_cpl )
        CALL COMPRECV_R8TILES( ocnSIceQ2Name,
     I                       sNx, OLx, sNy, OLy, 1, nSx, nSy,
     O                       sIceQ2_cpl )
      ENDIF
#endif /* ALLOW_THSICE */

      _END_MASTER( myThid )
      _BARRIER

#endif /* COMPONENT_MODULE */

      RETURN
      END

#include "SEAICE_OPTIONS.h"
#ifdef ALLOW_AUTODIFF
# include "AUTODIFF_OPTIONS.h"
#endif

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: ADSEAICE_MONITOR

C     !INTERFACE:
      SUBROUTINE ADSEAICE_MONITOR(
     I                  myTime, myIter, myThid )

C     !DESCRIPTION:
C     Print some statistics about input forcing fields.

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "SEAICE_SIZE.h"
#include "SEAICE_PARAMS.h"
#include "SEAICE.h"
#include "SEAICE_TRACER.h"
#ifdef ALLOW_MONITOR
# include "MONITOR.h"
#endif
#ifdef ALLOW_AUTODIFF
# ifdef ALLOW_AUTODIFF_MONITOR
#  include "adcommon.h"
# endif
#endif

C     !INPUT PARAMETERS:
      INTEGER myIter
      _RL myTime
      INTEGER myThid
CEOP

#if ( defined (ALLOW_MONITOR) && defined (ALLOW_AUTODIFF_MONITOR) )

C     === Functions ====
      LOGICAL  DIFFERENT_MULTIPLE
      EXTERNAL DIFFERENT_MULTIPLE
      LOGICAL  MASTER_CPU_IO
      EXTERNAL MASTER_CPU_IO

C     == Local variables ==
      CHARACTER*(MAX_LEN_MBUF) msgBuf
#ifdef ALLOW_SITRACER
      INTEGER iTracer
      CHARACTER*(MAX_LEN_MBUF) suff
#endif
#ifdef ALLOW_MNC
      INTEGER i
#endif /* ALLOW_MNC */
      _RL dummyRL(6)

      IF ( DIFFERENT_MULTIPLE(adjmonitorFreq,myTime,deltaTClock)
     &   ) THEN

        IF ( MASTER_CPU_IO(myThid) ) THEN
C--   only the master thread is allowed to switch On/Off mon_write_stdout
C     & mon_write_mnc (since it is the only thread that uses those flags):

          IF (SEAICE_mon_stdio) THEN
            mon_write_stdout = .TRUE.
          ELSE
            mon_write_stdout = .FALSE.
          ENDIF
          mon_write_mnc = .FALSE.
#ifdef ALLOW_MNC
          IF (useMNC .AND. SEAICE_mon_mnc) THEN
            DO i = 1,MAX_LEN_MBUF
              mon_fname(i:i) = ' '
            ENDDO
            mon_fname(1:14) = 'admonitor_seaice'
            CALL MNC_CW_APPEND_VNAME(
     &           'T', '-_-_--__-__t', 0,0, myThid)
            CALL MNC_CW_SET_UDIM(mon_fname, -1, myThid)
            CALL MNC_CW_RL_W_S(
     &          'D',mon_fname,1,1,'T', myTime, myThid)
            CALL MNC_CW_SET_UDIM(mon_fname, 0, myThid)
            mon_write_mnc = .TRUE.
          ENDIF
#endif /* ALLOW_MNC */

          IF ( mon_write_stdout ) THEN
            WRITE(msgBuf,'(2A)') '// ===========================',
     &             '============================'
            CALL PRINT_MESSAGE(msgBuf, mon_ioUnit, SQUEEZE_RIGHT, 1)
            WRITE(msgBuf,'(A)') '// Begin AD_MONITOR SEAICE statistics'
            CALL PRINT_MESSAGE(msgBuf, mon_ioUnit, SQUEEZE_RIGHT, 1)
            WRITE(msgBuf,'(2A)') '// ===========================',
     &             '============================'
            CALL PRINT_MESSAGE(msgBuf, mon_ioUnit, SQUEEZE_RIGHT, 1)
          ENDIF

C--   endif master cpu io
        ENDIF

        CALL MON_SET_PREF('ad_seaice',myThid)
        CALL MON_OUT_I ('_tsnumber', myIter,mon_string_none,myThid)
        CALL MON_OUT_RL('_time_sec', myTime,mon_string_none,myThid)

C       Print some statistics about input forcing fields
#ifdef SEAICE_CGRID
        CALL MON_WRITESTATS_RL( 1, ADUICE, '_aduice',
     &           maskInW, maskInW, rAw, drF, dummyRL, myThid )
        CALL MON_WRITESTATS_RL( 1, ADVICE, '_advice',
     &           maskInS, maskInS, rAs, drF, dummyRL, myThid )
#endif
#ifdef SEAICE_BGRID_DYNAMICS
        CALL MON_WRITESTATS_RL( 1, ADUICE, '_aduice',
     &                   UVM, UVM, rAz, drF, dummyRL, myThid )
        CALL MON_WRITESTATS_RL( 1, ADVICE, '_advice',
     &                   UVM, UVM, rAz, drF, dummyRL, myThid )
#endif
        CALL MON_WRITESTATS_RL( 1, ADAREA, '_adarea',
     &           maskInC, maskInC, rA , drF, dummyRL, myThid )
        CALL MON_WRITESTATS_RL( 1, ADHEFF, '_adheff',
     &           maskInC, maskInC, rA , drF, dummyRL, myThid )
        CALL MON_WRITESTATS_RL( 1, ADHSNOW,'_adhsnow',
     &           maskInC, maskInC, rA , drF, dummyRL, myThid )
#ifdef SEAICE_VARIABLE_SALINITY
        CALL MON_WRITESTATS_RL( 1, ADHSALT,'_adhsalt',
     &           maskInC, maskInC, rA , drF, dummyRL, myThid )
#endif /* SEAICE_VARIABLE_SALINITY */

        IF ( MASTER_CPU_IO(myThid) ) THEN
C--   only the master thread is allowed to switch On/Off mon_write_stdout
C     & mon_write_mnc (since it is the only thread that uses those flags):

          IF ( mon_write_stdout ) THEN
            WRITE(msgBuf,'(2A)') '// ===========================',
     &           '============================'
            CALL PRINT_MESSAGE(msgBuf, mon_ioUnit, SQUEEZE_RIGHT, 1)
            WRITE(msgBuf,'(A)') '// End AD_MONITOR SEAICE statistics'
            CALL PRINT_MESSAGE(msgBuf, mon_ioUnit, SQUEEZE_RIGHT, 1)
            WRITE(msgBuf,'(2A)') '// ===========================',
     &           '============================'
            CALL PRINT_MESSAGE(msgBuf, mon_ioUnit, SQUEEZE_RIGHT, 1)
          ENDIF

          mon_write_stdout = .FALSE.
          mon_write_mnc    = .FALSE.

C--   endif master cpu io
        ENDIF

C     endif different multiple
      ENDIF

#endif /* ALLOW_MONITOR */

      RETURN
      END

#include "CPP_OPTIONS.h"

CBOP
C     !ROUTINE: INI_FFIELDS
C     !INTERFACE:
      SUBROUTINE INI_FFIELDS( myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE INI_FFIELDS
C     | o Initialise to zero FFLIEDS.h arrays
C     *==========================================================*
C     | Sets all forcing fields to zero.
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "FFIELDS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     myThid  :: my Thread Id number
      INTEGER myThid

C     !LOCAL VARIABLES:
C     == Local variables ==
C     bi,bj   :: Tile indices
C     i, j, k :: Loop counters
      INTEGER bi, bj
      INTEGER i, j, k
CEOP

C--   Initialise all arrays in common blocks
      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)

C-    2-D forcing fields
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          fu              (i,j,bi,bj) = 0. _d 0
          fv              (i,j,bi,bj) = 0. _d 0
          Qnet            (i,j,bi,bj) = 0. _d 0
          Qsw             (i,j,bi,bj) = 0. _d 0
          EmPmR           (i,j,bi,bj) = 0. _d 0
          saltFlux        (i,j,bi,bj) = 0. _d 0
          SST             (i,j,bi,bj) = 0. _d 0
          SSS             (i,j,bi,bj) = 0. _d 0
          phiTide2d       (i,j,bi,bj) = 0. _d 0
          pLoad           (i,j,bi,bj) = 0. _d 0
          sIceLoad        (i,j,bi,bj) = 0. _d 0
          gcmSST          (i,j,bi,bj) = 0. _d 0
#ifdef ALLOW_GEOTHERMAL_FLUX
          geothermalFlux  (i,j,bi,bj) = 0. _d 0
#endif
#ifndef EXCLUDE_FFIELDS_LOAD
C-    Time reccord loaded from file:
          taux0           (i,j,bi,bj) = 0. _d 0
          taux1           (i,j,bi,bj) = 0. _d 0
          tauy0           (i,j,bi,bj) = 0. _d 0
          tauy1           (i,j,bi,bj) = 0. _d 0
          Qnet0           (i,j,bi,bj) = 0. _d 0
          Qnet1           (i,j,bi,bj) = 0. _d 0
          EmPmR0          (i,j,bi,bj) = 0. _d 0
          EmPmR1          (i,j,bi,bj) = 0. _d 0
          saltFlux0       (i,j,bi,bj) = 0. _d 0
          saltFlux1       (i,j,bi,bj) = 0. _d 0
          SST0            (i,j,bi,bj) = 0. _d 0
          SST1            (i,j,bi,bj) = 0. _d 0
          SSS0            (i,j,bi,bj) = 0. _d 0
          SSS1            (i,j,bi,bj) = 0. _d 0
#ifdef SHORTWAVE_HEATING
          Qsw0            (i,j,bi,bj) = 0. _d 0
          Qsw1            (i,j,bi,bj) = 0. _d 0
#endif
#ifdef ALLOW_GEOTHERMAL_FLUX
          geothFlux0      (i,j,bi,bj) = 0. _d 0
          geothFlux1      (i,j,bi,bj) = 0. _d 0
#endif
#ifdef ATMOSPHERIC_LOADING
          pLoad0          (i,j,bi,bj) = 0. _d 0
          pLoad1          (i,j,bi,bj) = 0. _d 0
#endif
#endif /* EXCLUDE_FFIELDS_LOAD */
         ENDDO
        ENDDO
#ifndef EXCLUDE_FFIELDS_LOAD
        loadedRec(bi,bj) = 0
#endif /* EXCLUDE_FFIELDS_LOAD */

C-    3-D forcing fields
        DO k=1,Nr
#ifdef ALLOW_ADDFLUID
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           addMass(i,j,k,bi,bj) = 0. _d 0
          ENDDO
         ENDDO
#endif /* ALLOW_ADDFLUID */
#ifdef ALLOW_FRICTION_HEATING
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           frictionHeating(i,j,k,bi,bj) = 0. _d 0
          ENDDO
         ENDDO
#endif /* ALLOW_FRICTION_HEATING */
#ifdef ALLOW_EDDYPSI
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           eddyPsiX  (i,j,k,bi,bj) = 0. _d 0
           eddyPsiY  (i,j,k,bi,bj) = 0. _d 0
           tauxEddy  (i,j,k,bi,bj) = 0. _d 0
           tauyEddy  (i,j,k,bi,bj) = 0. _d 0
           uEulerMean(i,j,k,bi,bj) = 0. _d 0
           vEulerMean(i,j,k,bi,bj) = 0. _d 0
          ENDDO
         ENDDO
#endif /* ALLOW_EDDYPSI */
        ENDDO

C-    Intermediate surface forcing arrays
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          surfaceForcingU (i,j,bi,bj) = 0. _d 0
          surfaceForcingV (i,j,bi,bj) = 0. _d 0
          surfaceForcingT (i,j,bi,bj) = 0. _d 0
          surfaceForcingS (i,j,bi,bj) = 0. _d 0
          adjustColdSST_diag  (i,j,bi,bj) = 0. _d 0
          lambdaThetaClimRelax(i,j,bi,bj) = 0. _d 0
          lambdaSaltClimRelax (i,j,bi,bj) = 0. _d 0
#ifdef ALLOW_BALANCE_FLUXES
          weight2BalanceFlx(i,j,bi,bj) = 0. _d 0
#endif
          botDragU        (i,j,bi,bj) = 0. _d 0
          botDragV        (i,j,bi,bj) = 0. _d 0
         ENDDO
        ENDDO

C--   end bi,bj loops
       ENDDO
      ENDDO

      RETURN
      END

#include "CPP_EEOPTIONS.h"
#include "W2_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 0
C !ROUTINE: W2_READPARMS

C !INTERFACE:
      SUBROUTINE W2_READPARMS( myThid )

C     !DESCRIPTION:
C     Initialize W2_EXCH2 variables and constants.

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "W2_EXCH2_SIZE.h"
#include "W2_EXCH2_TOPOLOGY.h"
#include "W2_EXCH2_PARAMS.h"

C     !INPUT PARAMETERS:
C     myThid  :: my Thread Id number
C               (Note: not relevant since threading has not yet started)
      INTEGER myThid
CEOP

C     !LOCAL VARIABLES:
C     === Local variables ===
C     msgBuf     :: Informational/error message buffer
C     iUnit      :: Work variable for IO unit number
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      LOGICAL fileExist, errFlag
      INTEGER i, j, iUnit, stdUnit, errCnt
C--   Note: To avoid error in reading the namelist,
C     use larger local array to read-in lists dimsFacets & facetEdgeLink,
C     store only W2_maxNbFacets values, and stop if more values are found.
      INTEGER namList_NbFacets
      PARAMETER ( namList_NbFacets = W2_maxNbFacets*2 )
      INTEGER dimsFacets( 2*namList_NbFacets )
      Real*4  facetEdgeLink( 4, namList_NbFacets )

C--   topology defined from processing "data.exch2" (selectTopol=0):
C     dimsFacets    :: facet pair of dimensions (n1x,n1y,n2x,n2y ...)
C     facetEdgeLink :: Face-Edge connectivity map:
C       facetEdgeLink(i,j)=XX.1 : face(j)-edge(i) (i=1,2,3,4 <==> N,S,E,W)
C       is connected to Northern edge of face "XX" ; similarly,
C       = XX.2 : to Southern.E, XX.3 = Eastern.E, XX.4 = Western.E of face "XX".
C--
C     edges order: N,S,E,W <==> 1,2,3,4

      NAMELIST /W2_EXCH2_PARM01/
     &       preDefTopol,
     &       dimsFacets, facetEdgeLink,
     &       blankList,
     &       W2_mapIO,
     &       W2_printMsg,
     &       W2_useE2ioLayOut

      stdUnit  = standardMessageUnit

C--   Default values for W2_EXCH2
      W2_printMsg = -1
      W2_mapIO = -1
      W2_useE2ioLayOut = .TRUE.
      IF ( useCubedSphereExchange ) THEN
        preDefTopol = 3
      ELSE
        preDefTopol = 1
      ENDIF
      DO i=1,W2_maxNbTiles
        blankList(i) = 0
      ENDDO

C--   Initialise other params in namelist
      DO j=1,W2_maxNbFacets*2
        dimsFacets(2*j-1) = 0
        dimsFacets( 2*j ) = 0
        DO i=1,4
          facetEdgeLink(i,j) = 0.
        ENDDO
      ENDDO

C-    Initialise other parameters:
      nFacets = 0
      nBlankTiles = 0
      DO j=1,W2_maxNbFacets
        facet_dims(2*j-1) = 0
        facet_dims( 2*j ) = 0
        DO i=1,4
          facet_link(i,j) = 0.
        ENDDO
      ENDDO

C     Set filling value for face-corner halo regions
      e2FillValue_RL = 0. _d 0
      e2FillValue_RS = 0. _d 0
      e2FillValue_R4 = 0.e0
      e2FillValue_R8 = 0.d0
C-    for testing only: put a large value (should not affects the results)
c     e2FillValue_RL = 1. _d+20
c     e2FillValue_RS = 1. _d+20
c     e2FillValue_R4 = 1.e+20
c     e2FillValue_R8 = 1.d+20

C-    Check for file "data.ech2":
      fileExist = .FALSE.
      INQUIRE( FILE='data.exch2', EXIST=fileExist )

      IF ( fileExist ) THEN
        WRITE(msgBuf,'(A)') 'W2_READPARMS: opening data.exch2'
        CALL PRINT_MESSAGE( msgBuf, stdUnit, SQUEEZE_RIGHT , myThid )
        CALL OPEN_COPY_DATA_FILE(
     I                      'data.exch2', 'W2_READPARMS',
     O                      iUnit,
     I                      myThid )

C     Read parameters from open data file
        READ(UNIT=iUnit,NML=W2_EXCH2_PARM01)
        WRITE(msgBuf,'(A)')
     &    'W2_READPARMS: finished reading data.exch2'
        CALL PRINT_MESSAGE( msgBuf, stdUnit, SQUEEZE_RIGHT , myThid )
C     Close the open data file
#ifdef SINGLE_DISK_IO
        CLOSE(iUnit)
#else
        CLOSE(iUnit,STATUS='DELETE')
#endif /* SINGLE_DISK_IO */
      ELSE
        WRITE(msgBuf,'(A)') 'W2_READPARMS: file data.exch2 not found'
        CALL PRINT_MESSAGE( msgBuf, stdUnit, SQUEEZE_RIGHT , myThid )
        IF ( preDefTopol.EQ.1 ) THEN
          WRITE(msgBuf,'(2A,I3)') '=> use W2_EXCH2 default:',
     &      ' Single sub-domain (nFacets=1)'
        ELSEIF ( preDefTopol .EQ. 3 ) THEN
          WRITE(msgBuf,'(2A,I3)') '=> use W2_EXCH2 default:',
     &      ' regular 6-facets Cube'
        ELSE
          WRITE(msgBuf,'(2A,I3)') '=> use W2_EXCH2 default:',
     &      ' preDefTopol=', preDefTopol
        ENDIF
        CALL PRINT_MESSAGE( msgBuf, stdUnit, SQUEEZE_RIGHT , myThid )
      ENDIF

C--   copy local arrays dimsFacets & facetEdgeLink to var in common block
      DO j=1,2*W2_maxNbFacets
c       write(0,*) j, dimsFacets(j)
        facet_dims(j) = dimsFacets(j)
      ENDDO
      DO j=1,W2_maxNbFacets
       DO i=1,4
        facet_link(i,j) = facetEdgeLink(i,j)
       ENDDO
      ENDDO

C--   Check if too many values are specified in data.exch2:
      errCnt = 0
      DO j=W2_maxNbFacets+1,namList_NbFacets
       errFlag = .FALSE.
       DO i=1,4
        IF ( facetEdgeLink(i,j).NE.0. ) errFlag = .TRUE.
       ENDDO
       IF ( errFlag ) errCnt = errCnt + 1
      ENDDO
      IF ( errCnt.GT.0 ) THEN
        WRITE(msgBuf,'(2A)') ' W2_READPARMS:',
     &    ' Number of "facetEdgeLink" list in "data.exch2"'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(A,2(A,I3))') ' W2_READPARMS:',
     &    ' exceeds maxNbFacets(=',W2_maxNbFacets,') by', errCnt
        CALL PRINT_ERROR( msgBuf, myThid )
        errFlag = .TRUE.
      ELSE
        errFlag = .FALSE.
      ENDIF

      errCnt = 0
      DO j=2*W2_maxNbFacets+1,2*namList_NbFacets
        IF ( dimsFacets(j).NE.0 ) errCnt = errCnt + 1
      ENDDO
      IF ( errCnt.GT.0 ) THEN
        WRITE(msgBuf,'(2A)') ' W2_READPARMS:',
     &    ' Number of "dimsFacets" in "data.exch2"'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(A,2(A,I3))') ' W2_READPARMS:',
     &    ' exceeds 2*maxNbFacets(=',W2_maxNbFacets*2,') by', errCnt
        CALL PRINT_ERROR( msgBuf, myThid )
      ENDIF
      IF ( errFlag .OR. errCnt.GT.0 ) THEN
        STOP 'ABNORMAL END: S/R W2_READPARMS'
      ENDIF

C--   Print some Exch2 parameters:
      WRITE(msgBuf,'(A,L5,A)') 'W2_useE2ioLayOut=', W2_useE2ioLayOut,
     &  ' ;/* T: use Exch2 glob IO map; F: use model default */'
      CALL PRINT_MESSAGE( msgBuf, stdUnit, SQUEEZE_RIGHT , myThid )
      WRITE(msgBuf,'(A,I4,A)') 'W2_mapIO        =', W2_mapIO,
     & ' ; /* select option for Exch2 global-IO map */'
      CALL PRINT_MESSAGE( msgBuf, stdUnit, SQUEEZE_RIGHT , myThid )
      WRITE(msgBuf,'(A,I4,A)') 'W2_printMsg     =', W2_printMsg,
     & ' ; /* select option for printing information */'
      CALL PRINT_MESSAGE( msgBuf, stdUnit, SQUEEZE_RIGHT , myThid )

      RETURN
      END

#include "MNC_OPTIONS.h"
      
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 0
C !ROUTINE: MNC_CW_SET_UDIM

C !INTERFACE:
      SUBROUTINE MNC_CW_SET_UDIM( 
     I     fgname, 
     I     nudim, 
     I     myThid ) 

C     !DESCRIPTION:
C     For a specified file group name, set the size of the NetCDF
C     unlimited (or record) dimension.  The options are:
C     \begin{equation}
C       \label{eq:yo}
C       \mbox{\bf nudim} = \left\{
C         \begin{array}[htb]{cl}
C           >0,  &  \mbox{\small use the specified value} \\
C           0,   &  \mbox{\small use the largest currently defined value} \\
C           -1,  &  \mbox{\small increment the largest value and then use it} \\
C         \end{array}
C         \right.
C     \end{equation}

C     !USES:
      implicit none
#include "MNC_COMMON.h"
#include "EEPARAMS.h"

C     !INPUT PARAMETERS:
      integer nudim, myThid
      character*(*) fgname
CEOP

C     !LOCAL VARIABLES:
      integer fgf,fgl, indfg
      character*(MAX_LEN_MBUF) msgbuf

C     Functions
      integer IFNBLNK, ILNBLNK

C     Check that this name is not already defined
      fgf = IFNBLNK(fgname)
      fgl = ILNBLNK(fgname)
      CALL MNC_GET_IND(MNC_MAX_ID, fgname, mnc_cw_fgnm, indfg, myThid)
      IF (indfg .LT. 1) THEN
        CALL MNC_GET_NEXT_EMPTY_IND(
     &       MNC_MAX_ID, mnc_cw_fgnm, 'mnc_cw_fgnm', indfg, myThid)
        mnc_cw_fgnm(indfg)(1:(fgl-fgf+1)) = fgname(fgf:fgl)
        mnc_cw_fgud(indfg) = 0
        mnc_cw_fgig(indfg) = 0
      ENDIF
      IF (nudim .GT. 0) THEN
        mnc_cw_fgig(indfg) = 0
        mnc_cw_fgud(indfg) = nudim
        RETURN
      ENDIF
      IF (nudim .EQ. 0) THEN
        mnc_cw_fgig(indfg) = 0
        RETURN
      ENDIF
      IF (nudim .EQ. -1) THEN
        mnc_cw_fgig(indfg) = 1
        mnc_cw_fgud(indfg) = mnc_cw_fgud(indfg) + 1
        RETURN
      ENDIF
      write(msgbuf,'(3a,i10,a)') 
     &     'MNC_CW_SET_UDIM ERROR: for file group name ''', 
     &     fgname(fgf:fgl), ''' the unlim dim ''', nudim, 
     &     ''' is not allowed'
      CALL print_error(msgbuf, mythid)
      STOP 'ABNORMAL END: S/R MNC_CW_SET_UDIM'

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 0
C !ROUTINE: MNC_CW_GET_UDIM

C !INTERFACE:
      SUBROUTINE MNC_CW_GET_UDIM( 
     I     fgname, 
     O     nudim, 
     I     myThid ) 

C     !DESCRIPTION:
C     For a specified file group name, get the size of the NetCDF
C     unlimited (or record) dimension.

C     !USES:
      implicit none
#include "MNC_COMMON.h"
#include "EEPARAMS.h"

C     !INPUT PARAMETERS:
      integer nudim, myThid
      character*(*) fgname
CEOP

C     !LOCAL VARIABLES:
      integer fgf,fgl, indfg
      character*(MAX_LEN_MBUF) msgbuf

C     Functions
      integer IFNBLNK, ILNBLNK

      fgf = IFNBLNK(fgname)
      fgl = ILNBLNK(fgname)
      CALL MNC_GET_IND(MNC_MAX_ID, fgname, mnc_cw_fgnm, indfg, myThid)
      IF (indfg .LT. 1) THEN
        write(msgbuf,'(3a)') 
     &       'MNC_CW_GET_UDIM ERROR: file group name ''', 
     &       fgname(fgf:fgl), ''' is not defined'
        CALL print_error(msgbuf, mythid)
        STOP 'ABNORMAL END: S/R MNC_CW_GET_UDIM'
      ENDIF
      nudim = mnc_cw_fgud(indfg)

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#include "DIC_OPTIONS.h"

CBOP
C !ROUTINE: DIC_INI_FORCING

C !INTERFACE: ==========================================================
      SUBROUTINE DIC_INI_FORCING( myThid )

C !DESCRIPTION:
c initializes forcing fields to zero
c (or to reasonable values)

C !USES: ===============================================================
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "DIC_VARS.h"
#include "DIC_LOAD.h"

C !INPUT PARAMETERS: ===================================================
C  myThid               :: thread number
      INTEGER myThid
CEOP

#ifdef ALLOW_DIC

c !LOCAL VARIABLES: ====================================================
       INTEGER bi, bj, i, j
       INTEGER intimeP, intime0, intime1
       _RL aWght, bWght
#ifdef DIC_CALCITE_SAT
      INTEGER k
#endif

C--   Initialise forcing arrays in common blocks
      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)

C-    Initialise DIC_VARS.h forcing-field arrays:
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
           wind      (i,j,bi,bj) = 0. _d 0
           fIce      (i,j,bi,bj) = 0. _d 0
           AtmosP    (i,j,bi,bj) = 0. _d 0
           silicaSurf(i,j,bi,bj) = 0. _d 0
#ifdef DIC_BIOTIC
           par       (i,j,bi,bj) = 0. _d 0
           CHL       (i,j,bi,bj) = 0. _d 0
           InputFe   (i,j,bi,bj) = 0. _d 0
#endif
         ENDDO
        ENDDO
#ifdef DIC_CALCITE_SAT
        DO k=1,Nr
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           silicaDeep(i,j,k,bi,bj) = 0. _d 0
          ENDDO
         ENDDO
        ENDDO
#endif

C-    Initialise DIC_LOAD.h arrays:
        DIC_ldRec(bi,bj) = 0
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
           dicwind0(i,j,bi,bj) = 0. _d 0
           dicwind1(i,j,bi,bj) = 0. _d 0
           atmosp0 (i,j,bi,bj) = 0. _d 0
           atmosp1 (i,j,bi,bj) = 0. _d 0
           silicaSurf0(i,j,bi,bj) = 0. _d 0
           silicaSurf1(i,j,bi,bj) = 0. _d 0
           ice0    (i,j,bi,bj) = 0. _d 0
           ice1    (i,j,bi,bj) = 0. _d 0
#ifdef READ_PAR
           par0    (i,j,bi,bj) = 0. _d 0
           par1    (i,j,bi,bj) = 0. _d 0
#endif
#ifdef ALLOW_FE
           feinput0(i,j,bi,bj) = 0. _d 0
           feinput1(i,j,bi,bj) = 0. _d 0
#endif
#ifdef LIGHT_CHL
           chlinput(i,j,bi,bj) = 0. _d 0
#endif
         ENDDO
        ENDDO
#ifdef DIC_CALCITE_SAT
        DO k=1,Nr
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           silicaDeep0(i,j,k,bi,bj) = 0. _d 0
           silicaDeep1(i,j,k,bi,bj) = 0. _d 0
          ENDDO
         ENDDO
        ENDDO
#endif
C-   end bi,bj loops:
       ENDDO
      ENDDO

C ======================================================================

C--   Set reasonable values to those that need at least something
      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
            wind(i,j,bi,bj)       = 5. _d 0*maskC(i,j,1,bi,bj)
            AtmosP(i,j,bi,bj)     = 1. _d 0*maskC(i,j,1,bi,bj)
            silicaSurf(i,j,bi,bj) = 7.6838 _d -3*maskC(i,j,1,bi,bj)
            fIce(i,j,bi,bj)       = 0. _d 0
#ifdef READ_PAR
            par(i,j,bi,bj)        = 100. _d 0*maskC(i,j,1,bi,bj)
#endif
#ifdef LIGHT_CHL
C If the chlorophyll climatology is not provided, use this default value.
            CHL(i,j,bi,bj)        = 1. _d -2*maskC(i,j,1,bi,bj)
#endif
#ifdef ALLOW_FE
            InputFe(i,j,bi,bj)    = 1. _d -11*maskC(i,j,1,bi,bj)
#endif
          ENDDO
         ENDDO
#ifdef DIC_CALCITE_SAT
         IF ( useCalciteSaturation ) THEN
          DO k=1,Nr
           DO j=1-OLy,sNy+OLy
            DO i=1-OLx,sNx+OLx
              silicaDeep(i,j,k,bi,bj) = 3. _d -2*maskC(i,j,k,bi,bj)
            ENDDO
           ENDDO
          ENDDO
         ENDIF
#endif
C-    end bi,bj loops
       ENDDO
      ENDDO

C ======================================================================

C--   Load constant forcing-file (used if DIC_forcingCycle=0 )
c     IF ( DIC_forcingCycle .LE. zeroRL ) THEN
       IF ( DIC_windFile .NE. ' '  ) THEN
         CALL READ_REC_XY_RL( DIC_windFile, wind,
     &                        1, nIter0, myThid )
         _EXCH_XY_RL( wind, myThid )
       ENDIF
       IF ( DIC_atmospFile .NE. ' '  ) THEN
         CALL READ_REC_XY_RL( DIC_atmospFile, AtmosP,
     &                        1, nIter0, myThid )
         _EXCH_XY_RL( AtmosP, myThid )
       ENDIF
       IF ( DIC_silicaFile .NE. ' '  ) THEN
         CALL READ_REC_XY_RL( DIC_silicaFile, silicaSurf,
     &                        1, nIter0, myThid )
         _EXCH_XY_RL( silicaSurf, myThid )
       ENDIF
       IF ( DIC_iceFile .NE. ' '  ) THEN
         CALL READ_REC_XY_RL( DIC_iceFile, fIce,
     &                        1, nIter0, myThid )
         _EXCH_XY_RL( fIce, myThid )
       ENDIF
#ifdef DIC_BIOTIC
c#ifdef READ_PAR
       IF ( DIC_parFile .NE. ' '  ) THEN
         CALL READ_REC_XY_RL( DIC_parFile, par,
     &                        1, nIter0, myThid )
         _EXCH_XY_RL( par, myThid )
       ENDIF
c#endif
c#ifdef LIGHT_CHL
C--   Load chlorophyll climatology data, unit for chlorophyll : mg/m3
       IF ( DIC_chlaFile .NE. ' '  ) THEN
         CALL READ_REC_XY_RL( DIC_chlaFile, CHL,
     &                        1, nIter0, myThid )
         _EXCH_XY_RL( CHL, myThid )
       ENDIF
c#endif
c#ifdef ALLOW_FE
       IF ( DIC_ironFile .NE. ' '  ) THEN
         CALL READ_REC_XY_RL( DIC_ironFile, InputFe,
     &                        1, nIter0, myThid )
         _EXCH_XY_RL( InputFe, myThid )
       ENDIF
c#endif
#endif /* DIC_BIOTIC */
#ifdef DIC_CALCITE_SAT
       IF ( useCalciteSaturation .AND.
     &      DIC_deepSilicaFile .NE. ' '  ) THEN
         CALL READ_REC_XYZ_RL( DIC_deepSilicaFile, silicaDeep,
     &                        1, nIter0, myThid )
         _EXCH_XYZ_RL( silicaDeep, myThid )
       ENDIF
#endif
c     ENDIF

C ======================================================================

      IF ( DIC_forcingCycle .GT. zeroRL ) THEN
C--   Load some initial forcing from file

C-    Read in surface silica field (used to compute initial surf. pH)
C     Note: For this purpose, might be accurate enough to use first record
C           in silica file (already loaded) and skip all this block.

C-    Get reccord number and weight for time interpolation:
       CALL GET_PERIODIC_INTERVAL(
     O                   intimeP, intime0, intime1, bWght, aWght,
     I                   DIC_forcingCycle, DIC_forcingPeriod,
     I                   deltaTClock, startTime, myThid )

       _BARRIER
       _BEGIN_MASTER(myThid)
        WRITE(standardMessageUnit,'(A,I10,A,2(2I5,A))')
     &   ' DIC_INI_FORCING, it=', nIter0,
     &   ' : Reading new data, i0,i1=', intime0, intime1
       _END_MASTER(myThid)

       IF ( DIC_silicaFile .NE. ' '  ) THEN
C-    If file provided for surface silicate, read it in
         CALL READ_REC_XY_RS( DIC_silicaFile,silicaSurf0,intime0,
     &        nIter0,myThid )
         CALL READ_REC_XY_RS( DIC_silicaFile,silicaSurf1,intime1,
     &        nIter0,myThid )
         DO bj = myByLo(myThid), myByHi(myThid)
          DO bi = myBxLo(myThid), myBxHi(myThid)
           DO j=1-OLy,sNy+OLy
            DO i=1-OLx,sNx+OLx
              silicaSurf(i,j,bi,bj) = bWght*silicaSurf0(i,j,bi,bj)
     &                              + aWght*silicaSurf1(i,j,bi,bj)
            ENDDO
           ENDDO
          ENDDO
         ENDDO
#ifndef ALLOW_AUTODIFF
#ifdef DIC_CALCITE_SAT
       ELSEIF ( DIC_deepSilicaFile .NE. ' '  ) THEN
C-    If no surface silicate file but deep (3d) silicate provided, use top level
         k = 1
         CALL READ_REC_XYZ_RS( DIC_deepSilicaFile, silicaDeep0,
     &                         intime0, nIter0, myThid )
         CALL READ_REC_XYZ_RS( DIC_deepSilicaFile, silicaDeep1,
     &                         intime1, nIter0, myThid )
         DO bj = myByLo(myThid), myByHi(myThid)
          DO bi = myBxLo(myThid), myBxHi(myThid)
           DO j=1-OLy,sNy+OLy
            DO i=1-OLx,sNx+OLx
              silicaSurf(i,j,bi,bj) = bWght*silicaDeep0(i,j,k,bi,bj)
     &                              + aWght*silicaDeep1(i,j,k,bi,bj)
            ENDDO
           ENDDO
          ENDDO
         ENDDO
#endif /* DIC_CALCITE_SAT */
#endif /* ndef ALLOW_AUTODIFF */
       ENDIF
       _EXCH_XY_RL( silicaSurf, myThid )

C end if DIC_forcingCycle > 0
      ENDIF

#endif /* ALLOW_DIC */
      RETURN
      END

#include "OBCS_OPTIONS.h"

CBOP
C     !ROUTINE: OBCS_PRESCRIBE_READ
C     !INTERFACE:
      SUBROUTINE OBCS_PRESCRIBE_READ (
     I                          myTime, myIter, myThid )

C     !DESCRIPTION: \bv
C     *============================================================*
C     | SUBROUTINE OBCS_PRESCRIBE_READ
C     *============================================================*
C     | read open boundary conditions from file
C     | N.B.: * uses exf and cal routines for file/record handling
C     |       * uses ctrl routines for control variable handling
C     *============================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     == global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     myTime :: Simulation time
C     myIter :: Simulation timestep number
C     myThid :: my Thread Id. number
      _RL     myTime
      INTEGER myIter
      INTEGER myThid

#ifdef ALLOW_OBCS_PRESCRIBE

C     !LOCAL VARIABLES:
CEOP

# ifdef ALLOW_EXF
      IF ( useEXF ) THEN
        CALL OBCS_EXF_LOAD( myTime, myIter, myThid )
      ENDIF
# endif /* ALLOW_EXF */

# ifndef EXCLUDE_FFIELDS_LOAD
      IF ( .NOT. useEXF ) THEN
        CALL OBCS_FIELDS_LOAD( myTime, myIter, myThid )
      ENDIF
# endif

#endif /* ALLOW_OBCS_PRESCRIBE */

      RETURN
      END

#include "CTRL_OPTIONS.h"

      subroutine ctrl_get_gen(
     I          xx_gen_file, xx_genstartdate, xx_genperiod,
     I          genmask, genfld, xx_gen0, xx_gen1, xx_gen_dummy,
     I          xx_gen_remo_intercept, xx_gen_remo_slope,
     I          genweight,
     I          myTime, myIter, myThid )

c     ==================================================================
c     SUBROUTINE ctrl_get_gen
c     ==================================================================
c
c     o new generic routine for reading time dependent control variables
c       heimbach@mit.edu 12-Jun-2003
c
c     ==================================================================
c     SUBROUTINE ctrl_get_gen
c     ==================================================================

      implicit none

c     == global variables ==

#include "EEPARAMS.h"
#include "SIZE.h"
#include "PARAMS.h"
#include "CTRL_SIZE.h"
#include "CTRL.h"
#include "OPTIMCYCLE.h"

c     == routine arguments ==
      character*(MAX_LEN_FNAM) xx_gen_file
      integer xx_genstartdate(4)
      _RL     xx_genperiod
      _RS     genmask(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL     genfld(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL     xx_gen0(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL     xx_gen1(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL     xx_gen_dummy
      _RL     xx_gen_remo_intercept
      _RL     xx_gen_remo_slope
      _RL     genweight(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL     myTime
      integer myIter
      integer myThid

c     == external functions ==
      integer  ilnblnk
      external ilnblnk

c     == local variables ==
      integer bi,bj
      integer i,j
      integer jmin,jmax
      integer imin,imax
      integer ilgen

      _RL     gensign
      _RL     genfac
      logical doCtrlUpdate
      logical genfirst
      logical genchanged
      integer gencount0
      integer gencount1

      logical doglobalread
      logical ladinit

      character*(MAX_LEN_FNAM) fnamegen
#if ( defined ALLOW_SMOOTH && defined ALLOW_SMOOTH_CTRL2D )
      character*(MAX_LEN_FNAM) fnamegeneric
#endif
      character*(MAX_LEN_FNAM) xx_tauu_file
      character*(MAX_LEN_FNAM) xx_tauv_file
      character*(MAX_LEN_FNAM) xx_aqh_file
      character*(MAX_LEN_FNAM) xx_atemp_file
      character*(MAX_LEN_FNAM) xx_precip_file
      character*(MAX_LEN_FNAM) xx_lwdown_file
      character*(MAX_LEN_FNAM) xx_swdown_file

      INTEGER il

c     == end of interface ==

      jmin = 1-OLy
      jmax = sNy+OLy
      imin = 1-OLx
      imax = sNx+OLx

c--   Now, read the control vector.
      doglobalread = .false.
      ladinit      = .false.
      il   =ilnblnk( ctrlDir )

      if ( optimcycle .ge. 0 ) then
        ilgen=ilnblnk( xx_gen_file )
        write(fnamegen,'(2a,i10.10)')
     &    ctrlDir(1:il)//xx_gen_file(1:ilgen),'.effective.',optimcycle
      endif

c--   Get the counters, flags, and the interpolation factor.
      call ctrl_get_gen_rec(
     I                       xx_genstartdate, xx_genperiod,
     O                       genfac, genfirst, genchanged,
     O                       gencount0,gencount1,
     I                       myTime, myIter, myThid )

      if ( genfirst ) then
cc#ifdef ALLOW_OPENAD
cc        call oad_active_read_xy( fnamegen, xx_gen1, gencount0,
cc     &                       doglobalread, ladinit, optimcycle,
cc     &                       myThid, xx_gen_dummy )
cc#else
#ifdef ALLOW_AUTODIFF
        call active_read_xy( fnamegen, xx_gen1, gencount0,
     &                       doglobalread, ladinit, optimcycle,
     &                       myThid, xx_gen_dummy )
       if (.false.) then
        call active_read_xy( fnamegen, xx_gen0, gencount0,
     &                       doglobalread, ladinit, optimcycle,
     &                       myThid, xx_gen_dummy )
       endif
#else
        CALL READ_REC_XY_RL( fnamegen, xx_gen1, gencount0, 1, myThid )
#endif
cc#endif /* ALLOW_OPENAD */

#ifdef ALLOW_SMOOTH
#ifdef ALLOW_SMOOTH_CTRL2D
        if (useSMOOTH) call smooth2D(xx_gen1,genmask,1,myThid)
        write(fnamegeneric,'(2a,i10.10)')
     &    ctrlDir(1:il)//xx_gen_file(1:ilgen),'.smooth.',optimcycle
        CALL WRITE_REC_3D_RL( fnamegeneric, ctrlprec, 1,
     &             xx_gen1, gencount1, optimcycle, myThid )
#endif /* ALLOW_SMOOTH_CTRL2D */
#endif /* ALLOW_SMOOTH */

        endif

      if (( genfirst ) .or. ( genchanged )) then
        call CTRL_SWAPFFIELDS( xx_gen0, xx_gen1, myThid )

cc#ifdef ALLOW_OPENAD
cc        call oad_active_read_xy( fnamegen, xx_gen1 , gencount1,
cc     &                       doglobalread, ladinit, optimcycle,
cc     &                       myThid, xx_gen_dummy )
cc#else
#ifdef ALLOW_AUTODIFF
        call active_read_xy( fnamegen, xx_gen1 , gencount1,
     &                       doglobalread, ladinit, optimcycle,
     &                       myThid, xx_gen_dummy )
#else
        CALL READ_REC_XY_RL( fnamegen, xx_gen1, gencount1, 1, myThid )
#endif
cc#endif /* ALLOW_OPENAD */

#ifdef ALLOW_SMOOTH
#ifdef ALLOW_SMOOTH_CTRL2D
        if (useSMOOTH) call smooth2D(xx_gen1,genmask,1,myThid)
        write(fnamegeneric,'(2a,i10.10)')
     &     ctrlDir(1:il)//xx_gen_file(1:ilgen),'.smooth.',optimcycle
        CALL WRITE_REC_3D_RL( fnamegeneric, ctrlprec, 1,
     &             xx_gen1, gencount0, optimcycle, myThid )
#endif /* ALLOW_SMOOTH_CTRL2D */
#endif /* ALLOW_SMOOTH */

      endif

c--   Add control to model variable.
cph(
cph this flag ported from the SIO code
cph Initial wind stress adjustments are too vigorous.

      xx_tauu_file       = 'xx_tauu'
      xx_tauv_file       = 'xx_tauv'
      xx_aqh_file        = 'xx_aqh'
      xx_atemp_file      = 'xx_atemp'
      xx_precip_file     = 'xx_precip'
      xx_lwdown_file     = 'xx_lwdown'
      xx_swdown_file     = 'xx_swdown'

      if ( gencount0 .LE. 2 .AND. (
#ifdef CTRL_SKIP_FIRST_TWO_ATM_REC_ALL
     &       xx_gen_file(1:6) .EQ. xx_aqh_file  .OR.
     &       xx_gen_file(1:8) .EQ. xx_atemp_file .OR.
     &       xx_gen_file(1:9) .EQ. xx_precip_file .OR.
     &       xx_gen_file(1:9) .EQ. xx_lwdown_file .OR.
     &       xx_gen_file(1:9) .EQ. xx_swdown_file .OR.
#endif
     &       xx_gen_file(1:7) .EQ. xx_tauu_file .OR.
     &       xx_gen_file(1:7) .EQ. xx_tauv_file ) .AND.
     &     ( xx_genperiod .NE. zeroRL ) ) then
         doCtrlUpdate = .FALSE.
      else
         doCtrlUpdate = .TRUE.
      endif
      if ( xx_gen_file(1:7) .EQ. xx_tauu_file .OR.
     &     xx_gen_file(1:7) .EQ. xx_tauv_file ) then
         gensign = -1.
      else
         gensign = 1.
      endif

cph since the above is ECCO specific, we undo it here:
cph      doCtrlUpdate = .TRUE.
      if ( doCtrlUpdate ) then
cph)
       do bj = myByLo(myThid), myByHi(myThid)
        do bi = myBxLo(myThid), myBxHi(myThid)
c--       Calculate mask for tracer cells (0 => land, 1 => water).
          do j = 1,sNy
            do i = 1,sNx
              genfld(i,j,bi,bj) = genfld (i,j,bi,bj)
     &              + gensign*genfac            *xx_gen0(i,j,bi,bj)
     &              + gensign*(1. _d 0 - genfac)*xx_gen1(i,j,bi,bj)
              genfld(i,j,bi,bj) =
     &             genmask(i,j,bi,bj)*( genfld (i,j,bi,bj) -
     &             ( xx_gen_remo_intercept +
     &               xx_gen_remo_slope*(myTime-starttime) ) )
            enddo
          enddo
        enddo
       enddo
cph(
      endif
cph)

      RETURN
      END

#include "GAD_OPTIONS.h"

CBOP
C !ROUTINE: GAD_FLUXLIMIT_ADV_X

C !INTERFACE: ==========================================================
      SUBROUTINE GAD_FLUXLIMIT_ADV_X(
     I           bi, bj, k, calcCFL, deltaTloc,
     I           uTrans, uFld,
     I           maskLocW, tracer,
     O           uT,
     I           myThid )

C !DESCRIPTION:
C Calculates the area integrated zonal flux due to advection of a tracer
C using second-order interpolation with a flux limiter:
C \begin{equation*}
C F^x_{adv} = U \overline{ \theta }^i
C - \frac{1}{2} \left(
C     [ 1 - \psi(C_r) ] |U|
C    + U \frac{u \Delta t}{\Delta x_c} \psi(C_r)
C              \right) \delta_i \theta
C \end{equation*}
C where the $\psi(C_r)$ is the limiter function and $C_r$ is
C the slope ratio.

C !USES: ===============================================================
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "GRID.h"

C !INPUT PARAMETERS: ===================================================
C  bi, bj            :: tile indices
C  k                 :: vertical level
C  calcCFL           :: =T: calculate CFL number ; =F: take uFld as CFL
C  deltaTloc         :: local time-step (s)
C  uTrans            :: zonal volume transport
C  uFld              :: zonal flow / CFL number
C  tracer            :: tracer field
C  myThid            :: thread number
      INTEGER bi, bj, k
      LOGICAL calcCFL
      _RL deltaTloc
      _RL uTrans(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL uFld  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RS maskLocW(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL tracer(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER myThid

C !OUTPUT PARAMETERS: ==================================================
C  uT                :: zonal advective flux
      _RL uT    (1-OLx:sNx+OLx,1-OLy:sNy+OLy)

C !LOCAL VARIABLES: ====================================================
C  i, j              :: loop indices
C  Cr                :: slope ratio
C  Rjm, Rj, Rjp      :: differences at i-1,i,i+1
      INTEGER i,j
      _RL Cr, Rjm, Rj, Rjp
      _RL uCFL
      _RL CrMax
      PARAMETER( CrMax = 1.D+6 )

C Statement function provides Limiter(Cr)
#include "GAD_FLUX_LIMITER.h"
CEOP

      DO j=1-OLy,sNy+OLy
       uT(1-OLx,j) = 0. _d 0
       uT(2-OLx,j) = 0. _d 0
       uT(sNx+OLx,j) = 0. _d 0
      ENDDO
      DO j=1-OLy,sNy+OLy
       DO i=1-OLx+2,sNx+OLx-1

        uCFL = uFld(i,j)
        IF ( calcCFL ) uCFL = ABS( uFld(i,j)*deltaTloc
     &                  *recip_dxC(i,j,bi,bj)*recip_deepFacC(k) )
        Rjp = (tracer(i+1,j)-tracer( i ,j))*maskLocW(i+1,j)
        Rj  = (tracer( i ,j)-tracer(i-1,j))*maskLocW( i ,j)
        Rjm = (tracer(i-1,j)-tracer(i-2,j))*maskLocW(i-1,j)

        IF ( uTrans(i,j).GT.zeroRL ) THEN
          Cr = Rjm
        ELSE
          Cr = Rjp
        ENDIF
        IF ( ABS(Rj)*CrMax .LE. ABS(Cr) ) THEN
          Cr = SIGN( CrMax, Cr )*SIGN( oneRL, Rj )
        ELSE
          Cr = Cr/Rj
        ENDIF

C       calculate Limiter Function:
        Cr = Limiter(Cr)

        uT(i,j) =
     &     uTrans(i,j)*(Tracer(i,j)+Tracer(i-1,j))*0.5 _d 0
     &   - ABS(uTrans(i,j))*( (oneRL-Cr) + uCFL*Cr )
     &                     *Rj*0.5 _d 0
       ENDDO
      ENDDO

      RETURN
      END

#include "CPP_EEOPTIONS.h"

C--  File printf.F: Routines for performing formatted textual I/O
C--                 in the MITgcm UV implementation environment.
C--   Contents
C--   o PRINT_MESSAGE  Does IO with unhighlighted header
C--   o PRINT_ERROR    Does IO with **ERROR** highlighted header
C--   o PRINT_LIST_I   Prints one-dimensional list of INTEGER
C--                    numbers.
C--   o PRINT_LIST_L   Prints one-dimensional list of LOGICAL
C--                    variables.
C--   o PRINT_LIST_RL  Prints one-dimensional list of Real(_RL)
C--                    numbers.
C--   o PRINT_MAPRS    Formats ABCD... contour map of a Real(_RS) field
C--                    Uses print_message for writing
C--   o PRINT_MAPRL    Formats ABCD... contour map of a Real(_RL) field
C--                    Uses print_message for writing

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: PRINT_MESSAGE
C     !INTERFACE:
      SUBROUTINE PRINT_MESSAGE( message, unit, sq , myThid )

C     !DESCRIPTION:
C     *============================================================*
C     | SUBROUTINE PRINT\_MESSAGE
C     | o Write out informational message using "standard" format.
C     *============================================================*
C     | Notes
C     | =====
C     | o Some system   I/O is not "thread-safe". For this reason
C     |   without the FMTFTN\_IO\_THREAD\_SAFE directive set a
C     |   critical region is defined around the write here. In some
C     |   cases  BEGIN\_CRIT() is approximated by only doing writes
C     |   for thread number 1 - writes for other threads are
C     |   ignored!
C     | o In a non-parallel form these routines can still be used.
C     |   to produce pretty printed output!
C     *============================================================*

C     !USES:
      IMPLICIT NONE

C     == Global data ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "EESUPPORT.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     message :: Message to write
C     unit    :: Unit number to write to
C     sq      :: Justification option
      CHARACTER*(*) message
      INTEGER       unit
      CHARACTER*(*) sq
      INTEGER  myThid

C     !FUNCTIONS:
      INTEGER  IFNBLNK
      EXTERNAL IFNBLNK
      INTEGER  ILNBLNK
      EXTERNAL ILNBLNK

C     !LOCAL VARIABLES:
C     == Local variables ==
C     iStart, iEnd :: String indexing variables
C     idString     :: Temp. for building prefix.
C     fmtStr, iTmp :: Temp. for building prefix.
C     iTmpThid     :: Temp. for building prefix.
      INTEGER iStart
      INTEGER iEnd
      INTEGER iTmp, iTmpThid
      CHARACTER*13 fmtStr
      CHARACTER*13 idString
CEOP

C--   Find beginning and end of message
      IF ( sq .EQ. SQUEEZE_BOTH .OR.
     &     sq .EQ. SQUEEZE_LEFT ) THEN
       iStart = IFNBLNK( message )
      ELSE
       iStart = 1
      ENDIF
      IF ( sq .EQ. SQUEEZE_BOTH .OR.
     &     sq .EQ. SQUEEZE_RIGHT ) THEN
       iEnd   = ILNBLNK( message )
      ELSE
       iEnd   = LEN(message)
      ENDIF
C--   Test to see if in multi-process ( or multi-threaded ) mode.
C     If so include process or thread identifier.
      IF ( numberOfProcs .EQ. 0 .AND. nThreads .EQ. 1 ) THEN
C--    Write single process format
       IF ( message .EQ. ' ' ) THEN
        WRITE(unit,'(A)') ' '
       ELSE
        WRITE(unit,'(A)') message(iStart:iEnd)
       ENDIF
      ELSEIF ( pidIO .EQ. myProcId ) THEN
C--    Write multi-process format
C      PRINT can be called by several threads simultaneously.
C      The write statement may need to be marked as a critical section.
#ifndef FMTFTN_IO_THREAD_SAFE
# ifdef USE_OMP_THREADING
C$OMP CRITICAL
# else
       _BEGIN_CRIT(myThid)
# endif
#endif
       fmtStr = '(I4.4,A,I4.4)'
       IF ( nPx*nPy .GE. 10000 ) THEN
         iTmp     = 1 + INT(LOG10(DFLOAT(nPx*nPy)))
         iTmpThid = 1 + INT(LOG10(DFLOAT(MAX_NO_THREADS)))
         iTmpThid = MAX( iTmpThid, 2, 8-iTmp )
         WRITE(fmtStr,'(4(A,I1),A)')
     &        '(I',iTmp,'.',iTmp,',A,I',iTmpThid,'.',iTmpThid,')'
       ENDIF
       WRITE(idString,fmtStr) myProcId,'.',myThid
       iTmp = ILNBLNK( idString )
       IF ( message .EQ. ' ' ) THEN
        WRITE(unit,'(A,A,A,A,A,A)',ERR=999)
     &   '(',PROCESS_HEADER,' ',idString(1:iTmp),')',' '
       ELSE
        WRITE(unit,'(A,A,A,A,A,A,A)',ERR=999)
     &   '(',PROCESS_HEADER,' ',idString(1:iTmp),')',' ',
     &   message(iStart:iEnd)
       ENDIF
       IF ( debugMode ) THEN
        CALL MDS_FLUSH( unit, myThid )
       ENDIF
       GOTO 1000
  999  CONTINUE
       ioErrorCount(myThid) = ioErrorCount(myThid)+1
 1000  CONTINUE
#ifndef FMTFTN_IO_THREAD_SAFE
# ifdef USE_OMP_THREADING
C$OMP END CRITICAL
# else
       _END_CRIT(myThid)
# endif
#endif
      ENDIF

#ifndef DISABLE_WRITE_TO_UNIT_ZERO
C--   if error message, also write directly to unit 0 :
      IF ( numberOfProcs .EQ. 1 .AND. myThid .EQ. 1
     &     .AND. unit.EQ.errorMessageUnit
     &     .AND. message .NE. ' ' ) THEN
        IF ( nThreads.LE.1 ) THEN
          WRITE(0,'(A)') message(iStart:iEnd)
        ELSE
          WRITE(0,'(A,I4.4,A,A)') '(TID ', myThid, ') ',
     &                   message(iStart:iEnd)
        ENDIF
      ENDIF
#endif

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: PRINT_ERROR
C     !INTERFACE:
      SUBROUTINE PRINT_ERROR( message , myThid )

C     !DESCRIPTION:
C     *============================================================*
C     | SUBROUTINE PRINT\_ERROR
C     | o Write out error message using "standard" format.
C     *============================================================*
C     | Notes
C     | =====
C     | o Some system   I/O is not "thread-safe". For this reason
C     |   without the FMTFTN\_IO\_THREAD\_SAFE directive set a
C     |   critical region is defined around the write here. In some
C     |   cases  BEGIN\_CRIT() is approximated by only doing writes
C     |   for thread number 1 - writes for other threads are
C     |   ignored!
C     | o In a non-parallel form these routines are still used
C     |   to produce pretty printed output. The process and thread
C     |   id prefix is omitted in this case.
C     *============================================================*

C     !USES:
      IMPLICIT NONE

C     == Global data ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "EESUPPORT.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     message :: Text string to print
C     myThid  :: Thread number of this instance
      CHARACTER*(*) message
      INTEGER       myThid

C     !FUNCTIONS:
c     INTEGER  IFNBLNK
c     EXTERNAL IFNBLNK
      INTEGER  ILNBLNK
      EXTERNAL ILNBLNK

C     !LOCAL VARIABLES:
C     == Local variables ==
C     iStart, iEnd :: Temps. for string indexing
C     idString     :: Temp. for building message prefix
C     fmtStr, iTmp :: Temp. for building prefix.
C     iTmpThid     :: Temp. for building prefix.
c     INTEGER iStart
      INTEGER iEnd
      INTEGER iTmp, iTmpThid
      CHARACTER*13 fmtStr
      CHARACTER*13 idString
CEOP

C--   Find beginning and end of message
c     iStart = IFNBLNK( message )
      iEnd   = ILNBLNK( message )
C--   Test to see if in multi-process ( or multi-threaded ) mode.
C     If so include process or thread identifier.
      IF ( numberOfProcs .EQ. 0 .AND. nThreads .EQ. 1 ) THEN
C--    Write single process format
       IF ( iEnd.EQ.0 ) THEN
        WRITE(errorMessageUnit,'(A,1X,A)') ERROR_HEADER, ' '
       ELSE
        WRITE(errorMessageUnit,'(A,1X,A)') ERROR_HEADER,
     &        message(1:iEnd)
c    &    message(iStart:iEnd)
       ENDIF
      ELSE
C       PRINT_ERROR can be called by several threads simulataneously.
C       The write statement may need to be marked as a critical section.
#ifndef FMTFTN_IO_THREAD_SAFE
# ifdef USE_OMP_THREADING
C$OMP CRITICAL
# else
       _BEGIN_CRIT(myThid)
# endif
#endif
       IF ( pidIO .EQ. myProcId ) THEN
C--    Write multi-process format
         fmtStr = '(I4.4,A,I4.4)'
         IF ( nPx*nPy .GE. 10000 ) THEN
           iTmp     = 1 + INT(LOG10(DFLOAT(nPx*nPy)))
           iTmpThid = 1 + INT(LOG10(DFLOAT(MAX_NO_THREADS)))
           iTmpThid = MAX( iTmpThid, 2, 8-iTmp )
           WRITE(fmtStr,'(4(A,I1),A)')
     &          '(I',iTmp,'.',iTmp,',A,I',iTmpThid,'.',iTmpThid,')'
         ENDIF
         WRITE(idString,fmtStr) myProcId,'.',myThid
         iTmp = ILNBLNK( idString )

         IF ( iEnd.EQ.0 ) THEN
          WRITE(errorMessageUnit,'(A,A,1X,A,A,A,A,A)',ERR=999)
     &    '(',PROCESS_HEADER,idString(1:iTmp),')',ERROR_HEADER,' ',
     &    ' '
         ELSE
          WRITE(errorMessageUnit,'(A,A,1X,A,A,A,A,A)',ERR=999)
     &    '(',PROCESS_HEADER,idString(1:iTmp),')',ERROR_HEADER,' ',
     &        message(1:iEnd)
c    &    message(iStart:iEnd)
         ENDIF
       ENDIF
       IF ( debugMode ) THEN
        CALL MDS_FLUSH( errorMessageUnit, myThid )
       ENDIF
       GOTO 1000
  999  CONTINUE
       ioErrorCount(myThid) = ioErrorCount(myThid)+1
 1000  CONTINUE

#ifndef DISABLE_WRITE_TO_UNIT_ZERO
C--    also write directly to unit 0 :
       IF ( numberOfProcs.EQ.1 .AND. iEnd.NE.0 ) THEN
        IF ( nThreads.LE.1 ) THEN
          WRITE(0,'(A)') message(1:iEnd)
        ELSE
          WRITE(0,'(A,I4.4,A,A)') '(TID ', myThid, ') ',
     &                   message(1:iEnd)
        ENDIF
       ENDIF
#endif

#ifndef FMTFTN_IO_THREAD_SAFE
# ifdef USE_OMP_THREADING
C$OMP END CRITICAL
# else
        _END_CRIT(myThid)
# endif
#endif
      ENDIF

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: PRINT_LIST_I
C     !INTERFACE:
      SUBROUTINE PRINT_LIST_I( fld, iFirst, iLast, index_type,
     &                         markEnd, compact, ioUnit )

C     !DESCRIPTION:
C     *==========================================================*
C     | o SUBROUTINE PRINT\_LIST\_I
C     *==========================================================*
C     | Routine for producing list of values for a field with
C     | duplicate values collected into
C     |    n \@ value
C     | record.
C     *==========================================================*

C     !USES:
      IMPLICIT NONE

C     == Global data ==
#include "SIZE.h"
#include "EEPARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     fld     :: Data to be printed
C     iFirst  :: First element to print
C     iLast   :: Last element to print
C  index_type :: Flag indicating which type of index to print
C                  INDEX_K    => /* K = nnn */
C                  INDEX_I    => /* I = nnn */
C                  INDEX_J    => /* J = nnn */
C                  INDEX_NONE =>
C     markEnd :: Flag to control whether there is a separator after the
C                last element
C     compact :: Flag to control use of repeat symbol for same valued
C                fields.
C     ioUnit  :: Unit number for IO.
      INTEGER iFirst, iLast
      INTEGER fld(iFirst:iLast)
      INTEGER index_type
      LOGICAL markEnd
      LOGICAL compact
      INTEGER ioUnit

C     !LOCAL VARIABLES:
C     == Local variables ==
C     iLo  - Range index holders for selecting elements with
C     iHi    with the same value
C     nDup - Number of duplicates
C     xNew, xOld - Hold current and previous values of field
C     punc - Field separator
C     msgBuf - IO buffer
C     index_lab - Index for labelling elements
C     K    - Loop counter
      INTEGER iLo
      INTEGER iHi
      INTEGER nDup
      INTEGER xNew, xOld
      CHARACTER punc
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      CHARACTER*2 commOpen,commClose
      CHARACTER*3 index_lab
      CHARACTER*25 fmt1, fmt2
      INTEGER K
CEOP

      IF     ( index_type .EQ. INDEX_I ) THEN
       index_lab = 'I ='
      ELSEIF ( index_type .EQ. INDEX_J ) THEN
       index_lab = 'J ='
      ELSEIF ( index_type .EQ. INDEX_K ) THEN
       index_lab = 'K ='
      ELSE
       index_lab = '?='
      ENDIF
C-    fortran format to write 1 or 2 indices:
      fmt1='(A,1X,A,I3,1X,A)'
      fmt2='(A,1X,A,I3,A,I3,1X,A)'
      IF ( iLast.GE.1000 ) THEN
        K = 1+INT(LOG10(FLOAT(iLast)))
        WRITE(fmt1,'(A,I1,A)')      '(A,1X,A,I',K,',1X,A)'
        WRITE(fmt2,'(A,I1,A,I1,A)') '(A,1X,A,I',K,',A,I',K,',1X,A)'
      ENDIF
      commOpen  = '/*'
      commClose = '*/'
      iLo = iFirst
      iHi = iFirst
      punc = ','
      xOld = fld(iFirst)
      DO K = iFirst+1,iLast
       xNew = fld(K  )
       IF ( .NOT. compact .OR. (xNew .NE. xOld) ) THEN
        nDup = iHi-iLo+1
        IF ( nDup .EQ. 1 ) THEN
         WRITE(msgBuf,'(A,I9,A)') '              ',xOld,punc
         IF ( index_type .NE. INDEX_NONE )
     &    WRITE(msgBuf(45:),fmt1)
     &    commOpen,index_lab,iLo,commClose
        ELSE
         WRITE(msgBuf,'(I5,'' '',A,I9,A)') nDup,'@',xOld,punc
         IF ( index_type .NE. INDEX_NONE )
     &    WRITE(msgBuf(45:),fmt2)
     &    commOpen,index_lab,iLo,':',iHi,commClose
        ENDIF
        CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT , 1)
        iLo  = K
        iHi  = K
        xOld = xNew
       ELSE
        iHi = K
       ENDIF
      ENDDO
      punc = ' '
      IF ( markEnd ) punc = ','
      nDup = iHi-iLo+1
      IF    ( nDup .EQ. 1 ) THEN
       WRITE(msgBuf,'(A,I9,A)') '              ',xOld,punc
       IF ( index_type .NE. INDEX_NONE )
     &    WRITE(msgBuf(45:),fmt1)
     &    commOpen,index_lab,iLo,commClose
      ELSEIF( nDup .GT. 1 ) THEN
       WRITE(msgBuf,'(I5,'' '',A,I9,A)') nDup,'@',xOld,punc
       IF ( index_type .NE. INDEX_NONE )
     &    WRITE(msgBuf(45:),fmt2)
     &    commOpen,index_lab,iLo,':',iHi,commClose
      ENDIF
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT , 1)

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: PRINT_LIST_L
C     !INTERFACE:
      SUBROUTINE PRINT_LIST_L( fld, iFirst, iLast, index_type,
     &                         markEnd, compact, ioUnit )

C     !DESCRIPTION:
C     *==========================================================*
C     | o SUBROUTINE PRINT\_LIST\_L
C     *==========================================================*
C     | Routine for producing list of values for a field with
C     | duplicate values collected into
C     |    n \@ value
C     | record.
C     *==========================================================*

C     !USES:
      IMPLICIT NONE

C     == Global data ==
#include "SIZE.h"
#include "EEPARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     fld     :: Data to be printed
C     iFirst  :: First element to print
C     iLast   :: Last element to print
C  index_type :: Flag indicating which type of index to print
C                  INDEX_K    => /* K = nnn */
C                  INDEX_I    => /* I = nnn */
C                  INDEX_J    => /* J = nnn */
C                  INDEX_NONE =>
C     markEnd :: Flag to control whether there is a separator after the
C                last element
C     compact :: Flag to control use of repeat symbol for same valued
C                fields.
C     ioUnit  :: Unit number for IO.
      INTEGER iFirst, iLast
      LOGICAL fld(iFirst:iLast)
      INTEGER index_type
      LOGICAL markEnd
      LOGICAL compact
      INTEGER ioUnit

C     !LOCAL VARIABLES:
C     == Local variables ==
C     iLo  - Range index holders for selecting elements with
C     iHi    with the same value
C     nDup - Number of duplicates
C     xNew, xOld - Hold current and previous values of field
C     punc - Field separator
C     msgBuf - IO buffer
C     index_lab - Index for labelling elements
C     K    - Loop counter
      INTEGER iLo
      INTEGER iHi
      INTEGER nDup
      LOGICAL xNew, xOld
      CHARACTER punc
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      CHARACTER*2 commOpen,commClose
      CHARACTER*3 index_lab
      CHARACTER*25 fmt1, fmt2
      INTEGER K
CEOP

      IF     ( index_type .EQ. INDEX_I ) THEN
       index_lab = 'I ='
      ELSEIF ( index_type .EQ. INDEX_J ) THEN
       index_lab = 'J ='
      ELSEIF ( index_type .EQ. INDEX_K ) THEN
       index_lab = 'K ='
      ELSE
       index_lab = '?='
      ENDIF
C-    fortran format to write 1 or 2 indices:
      fmt1='(A,1X,A,I3,1X,A)'
      fmt2='(A,1X,A,I3,A,I3,1X,A)'
      IF ( iLast.GE.1000 ) THEN
        K = 1+INT(LOG10(FLOAT(iLast)))
        WRITE(fmt1,'(A,I1,A)')      '(A,1X,A,I',K,',1X,A)'
        WRITE(fmt2,'(A,I1,A,I1,A)') '(A,1X,A,I',K,',A,I',K,',1X,A)'
      ENDIF
      commOpen  = '/*'
      commClose = '*/'
      iLo = iFirst
      iHi = iFirst
      punc = ','
      xOld = fld(iFirst)
      DO K = iFirst+1,iLast
       xNew = fld(K  )
       IF ( .NOT. compact .OR. (xNew .NEQV. xOld) ) THEN
        nDup = iHi-iLo+1
        IF ( nDup .EQ. 1 ) THEN
         WRITE(msgBuf,'(A,L5,A)') '              ',xOld,punc
         IF ( index_type .NE. INDEX_NONE )
     &    WRITE(msgBuf(45:),fmt1)
     &    commOpen,index_lab,iLo,commClose
        ELSE
         WRITE(msgBuf,'(I5,'' '',A,L5,A)') nDup,'@',xOld,punc
         IF ( index_type .NE. INDEX_NONE )
     &    WRITE(msgBuf(45:),fmt2)
     &    commOpen,index_lab,iLo,':',iHi,commClose
        ENDIF
        CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT , 1)
        iLo  = K
        iHi  = K
        xOld = xNew
       ELSE
        iHi = K
       ENDIF
      ENDDO
      punc = ' '
      IF ( markEnd ) punc = ','
      nDup = iHi-iLo+1
      IF    ( nDup .EQ. 1 ) THEN
       WRITE(msgBuf,'(A,L5,A)') '              ',xOld,punc
       IF ( index_type .NE. INDEX_NONE )
     &  WRITE(msgBuf(45:),'(A,1X,A,I3,1X,A)')
     &    commOpen,index_lab,iLo,commClose
      ELSEIF( nDup .GT. 1 ) THEN
       WRITE(msgBuf,'(I5,'' '',A,L5,A)') nDup,'@',xOld,punc
       IF ( index_type .NE. INDEX_NONE )
     &  WRITE(msgBuf(45:),'(A,1X,A,I3,A,I3,1X,A)')
     &  commOpen,index_lab,iLo,':',iHi,commClose
      ENDIF
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT , 1)

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: PRINT_LIST_RL
C     !INTERFACE:
      SUBROUTINE PRINT_LIST_RL( fld, iFirst, iLast, index_type,
     &                          markEnd, compact, ioUnit )

C     !DESCRIPTION:
C     *==========================================================*
C     | o SUBROUTINE PRINT\_LIST\_RL
C     *==========================================================*
C     | Routine for producing list of values for a field with
C     | duplicate values collected into
C     |    n \@ value
C     | record.
C     *==========================================================*

C     !USES:
      IMPLICIT NONE

C     == Global data ==
#include "SIZE.h"
#include "EEPARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     fld     :: Data to be printed
C     iFirst  :: First element to print
C     iLast   :: Last element to print
C  index_type :: Flag indicating which type of index to print
C                  INDEX_K    => /* K = nnn */
C                  INDEX_I    => /* I = nnn */
C                  INDEX_J    => /* J = nnn */
C                  INDEX_NONE =>
C     markEnd :: Flag to control whether there is a separator after the
C                last element
C     compact :: Flag to control use of repeat symbol for same valued
C                fields.
C     ioUnit  :: Unit number for IO.
      INTEGER iFirst, iLast
      _RL     fld(iFirst:iLast)
      INTEGER index_type
      LOGICAL markEnd
      LOGICAL compact
      INTEGER ioUnit

C     !LOCA VARIABLES:
C     == Local variables ==
C     iLo  - Range index holders for selecting elements with
C     iHi    with the same value
C     nDup - Number of duplicates
C     xNew, xOld - Hold current and previous values of field
C     punc - Field separator
C     msgBuf - IO buffer
C     index_lab - Index for labelling elements
C     K    - Loop counter
      INTEGER iLo
      INTEGER iHi
      INTEGER nDup
      _RL     xNew, xOld
      CHARACTER punc
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      CHARACTER*2 commOpen,commClose
      CHARACTER*3 index_lab
      CHARACTER*25 fmt1, fmt2
      INTEGER K
CEOP

      IF     ( index_type .EQ. INDEX_I ) THEN
       index_lab = 'I ='
      ELSEIF ( index_type .EQ. INDEX_J ) THEN
       index_lab = 'J ='
      ELSEIF ( index_type .EQ. INDEX_K ) THEN
       index_lab = 'K ='
      ELSE
       index_lab = '?='
      ENDIF
C-    fortran format to write 1 or 2 indices:
      fmt1='(A,1X,A,I3,1X,A)'
      fmt2='(A,1X,A,I3,A,I3,1X,A)'
      IF ( iLast.GE.1000 ) THEN
        K = 1+INT(LOG10(FLOAT(iLast)))
        WRITE(fmt1,'(A,I1,A)')      '(A,1X,A,I',K,',1X,A)'
        WRITE(fmt2,'(A,I1,A,I1,A)') '(A,1X,A,I',K,',A,I',K,',1X,A)'
      ENDIF
      commOpen  = '/*'
      commClose = '*/'
      iLo = iFirst
      iHi = iFirst
      punc = ','
      xOld = fld(iFirst)
      DO K = iFirst+1,iLast
       xNew = fld(K  )
       IF ( .NOT. compact .OR. (xNew .NE. xOld) ) THEN
        nDup = iHi-iLo+1
        IF ( nDup .EQ. 1 ) THEN
         WRITE(msgBuf,'(A,1PE23.15,A)') '              ',xOld,punc
         IF ( index_type .NE. INDEX_NONE )
     &    WRITE(msgBuf(45:),fmt1)
     &    commOpen,index_lab,iLo,commClose
        ELSE
         WRITE(msgBuf,'(I5,'' '',A,1PE23.15,A)') nDup,'@',xOld,punc
         IF ( index_type .NE. INDEX_NONE )
     &    WRITE(msgBuf(45:),fmt2)
     &    commOpen,index_lab,iLo,':',iHi,commClose
        ENDIF
        CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT , 1)
        iLo  = K
        iHi  = K
        xOld = xNew
       ELSE
        iHi = K
       ENDIF
      ENDDO
      punc = ' '
      IF ( markEnd ) punc = ','
      nDup = iHi-iLo+1
      IF    ( nDup .EQ. 1 ) THEN
       WRITE(msgBuf,'(A,1PE23.15,A)') '              ',xOld,punc
       IF ( index_type .NE. INDEX_NONE )
     &  WRITE(msgBuf(45:),fmt1)
     &    commOpen,index_lab,iLo,commClose
      ELSEIF( nDup .GT. 1 ) THEN
       WRITE(msgBuf,'(I5,'' '',A,1PE23.15,A)') nDup,'@',xOld,punc
       IF ( index_type .NE. INDEX_NONE )
     &  WRITE(msgBuf(45:),fmt2)
     &  commOpen,index_lab,iLo,':',iHi,commClose
      ENDIF
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT , 1)

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: PRINT_MAPRS
C     !INTERFACE:
      SUBROUTINE PRINT_MAPRS ( fld, fldTitle, plotMode,
     I        iLo,   iHi,   jLo,   jHi,  kLo,  kHi, nBx, nBy,
     I       iMin,  iMax,  iStr,
     I       jMin,  jMax,  jStr,
     I       kMin, kMax,   kStr,
     I      bxMin, bxMax,  bxStr,
     I      byMin, byMax,  byStr )

C     !DESCRIPTION:
C     *==========================================================*
C     | SUBROUTINE PRINT\_MAPRS
C     | o Does textual mapping printing of a field.
C     *==========================================================*
C     | This routine does the actual formatting of the data
C     | and printing to a file. It assumes an array using the
C     | MITgcm UV indexing scheme and base index variables.
C     | User code should call an interface routine like
C     | PLOT\_FIELD\_XYRS( ... ) rather than this code directly.
C     | Text plots can be oriented XY, YZ, XZ. An orientation
C     | is specficied through the "plotMode" argument. All the
C     | plots made by a single call to this routine will use the
C     | same contour interval. The plot range (iMin,...,byStr)
C     | can be three-dimensional. A separate plot is made for
C     | each point in the plot range normal to the orientation.
C     | e.g. if the orientation is XY (plotMode = PRINT\_MAP\_XY).
C     |      kMin =1, kMax = 5 and kStr = 2 will produce three XY
C     |      plots - one for K=1, one for K=3 and one for K=5.
C     |      Each plot would have extents iMin:iMax step iStr
C     |      and jMin:jMax step jStr.
C     *==========================================================*

C     !USES:
      IMPLICIT NONE

C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     fld        - Real*4 array holding data to be plotted
C     fldTitle   - Name of field to be plotted
C     plotMode   - Text string indicating plot orientation
C                  ( see - EEPARAMS.h for valid values ).
C     iLo, iHi,  - Dimensions of array fld. fld is assumed to
C     jLo, jHi     be five-dimensional.
C     kLo, kHi
C     nBx, nBy
C     iMin, iMax - Indexing for points to plot. Points from
C     iStr         iMin -> iMax in steps of iStr are plotted
C     jMin. jMax   and similarly for jMin, jMax, jStr and
C     jStr         kMin, kMax, kStr and bxMin, bxMax, bxStr
C     kMin, kMax   byMin, byMax, byStr.
C     kStr
      CHARACTER*(*) fldTitle
      CHARACTER*(*) plotMode
      INTEGER iLo, iHi
      INTEGER jLo, jHi
      INTEGER kLo, kHi
      INTEGER nBx, nBy
      _RS fld(iLo:iHi,jLo:jHi,kLo:kHi,nBx,nBy)
      INTEGER iMin, iMax, iStr
      INTEGER jMin, jMax, jStr
      INTEGER kMin, kMax, kStr
      INTEGER bxMin, bxMax, bxStr
      INTEGER byMin, byMax, byStr

C     !FUNCTIONS:
      INTEGER  IFNBLNK
      EXTERNAL IFNBLNK
      INTEGER  ILNBLNK
      EXTERNAL ILNBLNK

C     !LOCAL VARIABLES:
C     == Local variables ==
C     plotBuf - Buffer for building plot record
C     chList  - Character string used for plot
C     fMin, fMax - Contour min, max and range
C     fRange
C     val     - Value of element to be "plotted"
C     small   - Lowest range for which contours are plotted
C     accXXX  - Variables used in indexing accross page records.
C     dwnXXX    Variables used in indexing down the page.
C     pltXXX    Variables used in indexing multiple plots ( multiple
C               plots use same contour range).
C               Lab  - Label
C               Base - Base number for element indexing
C                      The process bottom, left coordinate in the
C                      global domain.
C               Step - Block size
C               Blo  - Start block
C               Bhi  - End block
C               Bstr - Block stride
C               Min  - Start index within block
C               Max  - End index within block
C               Str  - stride within block
      INTEGER MAX_LEN_PLOTBUF
      PARAMETER ( MAX_LEN_PLOTBUF = MAX_LEN_MBUF-20 )
      CHARACTER*(MAX_LEN_PLOTBUF) plotBuf
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      INTEGER lChList
      PARAMETER ( lChList = 28 )
      CHARACTER*(lChList) chList
      _RL  fMin
      _RL  fMax
      _RL  fRange
      _RL  val
      _RL  small
      CHARACTER*2  accLab
      CHARACTER*7  dwnLab
      CHARACTER*3  pltLab
      INTEGER     accBase, dwnBase, pltBase
      INTEGER     accStep, dwnStep, pltStep
      INTEGER     accBlo,  dwnBlo,  pltBlo
      INTEGER     accBhi,  dwnBhi,  pltBhi
      INTEGER     accBstr, dwnBstr, pltBstr
      INTEGER     accMin,  dwnMin,  pltMin
      INTEGER     accMax,  dwnMax,  pltMax
      INTEGER     accStr,  dwnStr,  pltStr
      INTEGER I, J, K, iStrngLo, iStrngHi, iBuf, iDx
      INTEGER bi, bj, bk
      LOGICAL validRange
CEOP

      chList = '-abcdefghijklmnopqrstuvwxyz+'
      small  =  1. _d -15
      fMin   =  1. _d  32
      fMax   = -1. _d  32
      validRange = .FALSE.

C--   Calculate field range
      DO bj=byMin, byMax, byStr
       DO bi=bxMin, bxMax, bxStr
        DO K=kMin, kMax, kStr
         DO J=jMin, jMax, jStr
          DO I=iMin, iMax, iStr
           IF (printMapIncludesZeros .OR. fld(I,J,K,bi,bj) .NE. 0.) THEN
            IF ( fld(I,J,K,bi,bj) .LT. fMin )
     &       fMin = fld(I,J,K,bi,bj)
            IF ( fld(I,J,K,bi,bj) .GT. fMax )
     &       fMax = fld(I,J,K,bi,bj)
           ENDIF
          ENDDO
         ENDDO
        ENDDO
       ENDDO
      ENDDO
      fRange = fMax-fMin
      IF ( fRange .GT. small ) validRange = .TRUE.

C--   Write field title and statistics
      msgBuf =
     & '// ======================================================='
      CALL PRINT_MESSAGE(msgBuf, standardMessageUnit,
     &                   SQUEEZE_RIGHT, 1)
      iStrngLo = IFNBLNK(fldTitle)
      iStrngHi = ILNBLNK(fldTitle)
      IF ( iStrngLo .LE. iStrngHi ) THEN
       WRITE(msgBuf,'(A)') fldTitle(iStrngLo:iStrngHi)
      ELSE
       msgBuf = '// UNKNOWN FIELD'
      ENDIF
      CALL PRINT_MESSAGE(msgBuf, standardMessageUnit,
     &                   SQUEEZE_RIGHT, 1)
      WRITE(msgBuf,'(A,1PE30.15)')
     & '// CMIN = ', fMin
      CALL PRINT_MESSAGE(msgBuf, standardMessageUnit,
     &                   SQUEEZE_RIGHT, 1)
      WRITE(msgBuf,'(A,1PE30.15)')
     & '// CMAX = ', fMax
      CALL PRINT_MESSAGE(msgBuf, standardMessageUnit,
     &                   SQUEEZE_RIGHT, 1)
      IF ( validRange ) THEN
       WRITE(msgBuf,'(A,1PE30.15)')
     &  '// CINT = ', fRange/FLOAT(lChlist-1)
      ELSE
       WRITE(msgBuf,'(A,1PE30.15)')
     &  '// CINT = ', 0.
      ENDIF
      CALL PRINT_MESSAGE(msgBuf, standardMessageUnit,
     &                   SQUEEZE_RIGHT, 1)
      WRITE(msgBuf,'(A,1024A1)')
     & '// SYMBOLS (CMIN->CMAX): ',(chList(I:I),I=1,lChList)
      CALL PRINT_MESSAGE(msgBuf, standardMessageUnit,
     &                   SQUEEZE_RIGHT, 1)
      WRITE(msgBuf,'(A,1024A1)')
     & '//                  0.0: ','.'
      CALL PRINT_MESSAGE(msgBuf, standardMessageUnit,
     &                   SQUEEZE_RIGHT, 1)
       WRITE(msgBuf,'(A,3(A,I6),A)')
     & '// RANGE I (Lo:Hi:Step):',
     &  '(',myXGlobalLo-1+(bxMin-1)*sNx+iMin,
     &  ':',myXGlobalLo-1+(bxMax-1)*sNx+iMax,
     &  ':',iStr,')'
      CALL PRINT_MESSAGE(msgBuf, standardMessageUnit,
     &                   SQUEEZE_RIGHT, 1)
       WRITE(msgBuf,'(A,3(A,I6),A)')
     & '// RANGE J (Lo:Hi:Step):',
     &  '(',myYGlobalLo-1+(byMin-1)*sNy+jMin,
     &  ':',myYGlobalLo-1+(byMax-1)*sNy+jMax,
     &  ':',jStr,')'
      CALL PRINT_MESSAGE(msgBuf, standardMessageUnit,
     &                   SQUEEZE_RIGHT, 1)
       WRITE(msgBuf,'(A,3(A,I4),A)')
     & '// RANGE K (Lo:Hi:Step):',
     &  '(',kMin,
     &  ':',kMax,
     &  ':',kStr,')'
      CALL PRINT_MESSAGE(msgBuf, standardMessageUnit,
     &                   SQUEEZE_RIGHT, 1)
      msgBuf =
     & '// ======================================================='
      CALL PRINT_MESSAGE(msgBuf, standardMessageUnit,
     &                   SQUEEZE_RIGHT, 1)

c     if (Nx.gt.MAX_LEN_PLOTBUF-20) THEN
c      msgBuf =
c    &  'Model domain too big to print to terminal - skipping I/O'
c      CALL PRINT_MESSAGE(msgBuf, standardMessageUnit,
c    &                   SQUEEZE_RIGHT, 1)
c      RETURN
c     endif

C--   Write field
C     Figure out slice type and set plotting parameters appropriately
C     acc = accross the page
C     dwn = down the page
      IF ( plotMode .EQ. PRINT_MAP_XY ) THEN
C      X across, Y down slice
       accLab  = 'I='
       accBase = myXGlobalLo
       accStep = sNx
       accBlo  = bxMin
       accBhi  = bxMax
       accBStr = bxStr
       accMin  = iMin
       accMax  = iMax
       accStr  = iStr
       dwnLab  = '|--J--|'
       dwnBase = myYGlobalLo
       dwnStep = sNy
       dwnBlo  = byMin
       dwnBhi  = byMax
       dwnBStr = byStr
       dwnMin  = jMin
       dwnMax  = jMax
       dwnStr  = jStr
       pltBlo  = 1
       pltBhi  = 1
       pltBstr = 1
       pltMin  = kMin
       pltMax  = kMax
       pltStr  = kStr
       pltBase = 1
       pltStep = 1
       pltLab  = 'K ='
      ELSEIF ( plotMode .EQ. PRINT_MAP_YZ ) THEN
C      Y across, Z down slice
       accLab  = 'J='
       accBase = myYGlobalLo
       accStep = sNy
       accBlo  = byMin
       accBhi  = byMax
       accBStr = byStr
       accMin  = jMin
       accMax  = jMax
       accStr  = jStr
       dwnLab  = '|--K--|'
       dwnBase = 1
       dwnStep = 1
       dwnBlo  = 1
       dwnBhi  = 1
       dwnBStr = 1
       dwnMin  = kMin
       dwnMax  = kMax
       dwnStr  = kStr
       pltBlo  = bxMin
       pltBhi  = bxMax
       pltBstr = bxStr
       pltMin  = iMin
       pltMax  = iMax
       pltStr  = iStr
       pltBase = myXGlobalLo
       pltStep = sNx
       pltLab  = 'I ='
      ELSEIF ( plotMode .EQ. PRINT_MAP_XZ ) THEN
C      X across, Z down slice
       accLab  = 'I='
       accBase = myXGlobalLo
       accStep = sNx
       accBlo  = bxMin
       accBhi  = bxMax
       accBStr = bxStr
       accMin  = iMin
       accMax  = iMax
       accStr  = iStr
       dwnLab  = '|--K--|'
       dwnBase = 1
       dwnStep = 1
       dwnBlo  = 1
       dwnBhi  = 1
       dwnBStr = 1
       dwnMin  = kMin
       dwnMax  = kMax
       dwnStr  = kStr
       pltBlo  = byMin
       pltBhi  = byMax
       pltBstr = byStr
       pltMin  = jMin
       pltMax  = jMax
       pltStr  = jStr
       pltBase = myYGlobalLo
       pltStep = sNy
       pltLab  = 'J ='
      ENDIF
C-    check if it fits into buffer (-10 should be enough but -12 is safer):
      IF ( (accMax-accMin+1)*(accBhi-accBlo+1).GT.MAX_LEN_PLOTBUF-12
     &     .AND. validRange ) THEN
       msgBuf =
     &  'Model domain too big to print to terminal - skipping I/O'
       CALL PRINT_MESSAGE(msgBuf, standardMessageUnit,
     &                   SQUEEZE_RIGHT, 1)
       validRange = .FALSE.
      ENDIF
      IF ( validRange ) THEN
C      Header
C      Data
       DO bk=pltBlo, pltBhi, pltBstr
        DO K=pltMin,pltMax,pltStr
         WRITE(plotBuf,'(A,I4,I4,I4,I4)') pltLab,
     &   pltBase-1+(bk-1)*pltStep+K
         CALL PRINT_MESSAGE(plotBuf, standardMessageUnit,
     &                      SQUEEZE_RIGHT, 1)
         plotBuf = ' '
         iBuf = 6
         DO bi=accBlo, accBhi, accBstr
          DO I=accMin, accMax, accStr
           iDx = accBase-1+(bi-1)*accStep+I
           iBuf = iBuf + 1
           IF ( 10*((iBuf-6)/10) .EQ. iBuf-6 ) THEN
            IF ( iDx .LT. 10 ) THEN
             WRITE(plotBuf(iBuf:),'(A,I1)') accLab,iDx
            ELSEIF ( iDx .LT. 100 ) THEN
             WRITE(plotBuf(iBuf:),'(A,I2)') accLab,iDx
            ELSEIF ( iDx .LT. 1000 ) THEN
             WRITE(plotBuf(iBuf:),'(A,I3)') accLab,iDx
            ELSEIF ( iDx .LT. 10000 ) THEN
             WRITE(plotBuf(iBuf:),'(A,I4)') accLab,iDx
            ENDIF
           ENDIF
          ENDDO
         ENDDO
         WRITE(msgBuf,'(A,A)') '// ',plotBuf
         CALL PRINT_MESSAGE(msgBuf, standardMessageUnit,
     &                      SQUEEZE_RIGHT, 1)
         plotBuf = dwnLab
         iBuf = 7
         DO bi=accBlo, accBhi, accBstr
          DO I=accMin, accMax, accStr
           iDx = accBase-1+(bi-1)*accStep+I
           iBuf = iBuf+1
           IF ( 10*((iBuf-7)/10) .EQ. iBuf-7 ) THEN
            WRITE(plotBuf(iBuf:),'(A)')  '|'
           ELSE
            WRITE(plotBuf(iBuf:iBuf),'(I1)') MOD(ABS(iDx),10)
           ENDIF
          ENDDO
         ENDDO
         WRITE(msgBuf,'(A,A)') '// ',plotBuf
         CALL PRINT_MESSAGE(msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, 1)
         DO bj=dwnBlo, dwnBhi, dwnBStr
          DO J=dwnMin, dwnMax, dwnStr
           WRITE(plotBuf,'(1X,I5,1X)')
     &      dwnBase-1+(bj-1)*dwnStep+J
           iBuf = 7
           DO bi=accBlo,accBhi,accBstr
            DO I=accMin,accMax,accStr
             iBuf = iBuf + 1
             IF     ( plotMode .EQ. PRINT_MAP_XY ) THEN
              val = fld(I,J,K,bi,bj)
             ELSEIF ( plotMode .EQ. PRINT_MAP_XZ ) THEN
              val = fld(I,K,J,bi,bk)
             ELSEIF ( plotMode .EQ. PRINT_MAP_YZ ) THEN
              val = fld(K,I,J,bk,bi)
             ENDIF
             IF ( validRange .AND. val .NE. 0. ) THEN
              IDX = NINT(
     &              FLOAT( lChList-1 )*( val-fMin ) / (fRange)
     &             )+1
             ELSE
              IDX = 1
             ENDIF
             IF ( iBuf .LE. MAX_LEN_PLOTBUF )
     &        plotBuf(iBuf:iBuf) = chList(IDX:IDX)
             IF ( val .EQ. 0. ) THEN
              IF ( iBuf .LE. MAX_LEN_PLOTBUF )
     &         plotBuf(iBuf:iBuf) = '.'
             ENDIF
            ENDDO
           ENDDO
           WRITE(msgBuf,'(A,A)') '// ',plotBuf
           CALL PRINT_MESSAGE(msgBuf, standardMessageUnit,
     &                        SQUEEZE_RIGHT, 1)
          ENDDO
         ENDDO
        ENDDO
       ENDDO
      ENDIF
C--   Write delimiter
      msgBuf =
     & '// ======================================================='
      CALL PRINT_MESSAGE(msgBuf, standardMessageUnit,
     &                   SQUEEZE_RIGHT, 1)
      msgBuf =
     & '// END OF FIELD                                          ='
      CALL PRINT_MESSAGE(msgBuf, standardMessageUnit,
     &                   SQUEEZE_RIGHT, 1)
      msgBuf =
     & '// ======================================================='
      CALL PRINT_MESSAGE(msgBuf, standardMessageUnit,
     &                   SQUEEZE_RIGHT, 1)
      msgBuf = ' '
      CALL PRINT_MESSAGE(msgBuf, standardMessageUnit,
     &                   SQUEEZE_RIGHT, 1)

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: PRINT_MAPRL
C     !INTERFACE:
      SUBROUTINE PRINT_MAPRL ( fld, fldTitle, plotMode,
     I        iLo,   iHi,   jLo,   jHi,  kLo,  kHi, nBx, nBy,
     I       iMin,  iMax,  iStr,
     I       jMin,  jMax,  jStr,
     I       kMin, kMax,   kStr,
     I      bxMin, bxMax,  bxStr,
     I      byMin, byMax,  byStr )

C     !DESCRIPTION:
C     *==========================================================*
C     | SUBROUTINE PRINT\_MAPRL
C     | o Does textual mapping printing of a field.
C     *==========================================================*
C     | This routine does the actual formatting of the data
C     | and printing to a file. It assumes an array using the
C     | MITgcm UV indexing scheme and base index variables.
C     | User code should call an interface routine like
C     | PLOT\_FIELD\_XYRL( ... ) rather than this code directly.
C     | Text plots can be oriented XY, YZ, XZ. An orientation
C     | is specficied through the "plotMode" argument. All the
C     | plots made by a single call to this routine will use the
C     | same contour interval. The plot range (iMin,...,byStr)
C     | can be three-dimensional. A separate plot is made for
C     | each point in the plot range normal to the orientation.
C     | e.g. if the orientation is XY (plotMode = PRINT\_MAP\_XY).
C     |      kMin =1, kMax = 5 and kStr = 2 will produce three XY
C     |      plots - one for K=1, one for K=3 and one for K=5.
C     |      Each plot would have extents iMin:iMax step iStr
C     |      and jMin:jMax step jStr.
C     *==========================================================*

C     !USES:
      IMPLICIT NONE

C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     fld        - Real*8 array holding data to be plotted
C     fldTitle   - Name of field to be plotted
C     plotMode   - Text string indicating plot orientation
C                  ( see - EEPARAMS.h for valid values ).
C     iLo, iHi,  - Dimensions of array fld. fld is assumed to
C     jLo, jHi     be five-dimensional.
C     kLo, kHi
C     nBx, nBy
C     iMin, iMax - Indexing for points to plot. Points from
C     iStr         iMin -> iMax in steps of iStr are plotted
C     jMin. jMax   and similarly for jMin, jMax, jStr and
C     jStr         kMin, kMax, kStr and bxMin, bxMax, bxStr
C     kMin, kMax   byMin, byMax, byStr.
C     kStr
      CHARACTER*(*) fldTitle
      CHARACTER*(*) plotMode
      INTEGER iLo, iHi
      INTEGER jLo, jHi
      INTEGER kLo, kHi
      INTEGER nBx, nBy
      _RL fld(iLo:iHi,jLo:jHi,kLo:kHi,nBx,nBy)
      INTEGER iMin, iMax, iStr
      INTEGER jMin, jMax, jStr
      INTEGER kMin, kMax, kStr
      INTEGER bxMin, bxMax, bxStr
      INTEGER byMin, byMax, byStr

C     !FUNCTIONS:
      INTEGER  IFNBLNK
      EXTERNAL IFNBLNK
      INTEGER  ILNBLNK
      EXTERNAL ILNBLNK

C     !LOCAL VARIABLES:
C     == Local variables ==
C     plotBuf - Buffer for building plot record
C     chList  - Character string used for plot
C     fMin, fMax - Contour min, max and range
C     fRange
C     val     - Value of element to be "plotted"
C     small   - Lowest range for which contours are plotted
C     accXXX  - Variables used in indexing accross page records.
C     dwnXXX    Variables used in indexing down the page.
C     pltXXX    Variables used in indexing multiple plots ( multiple
C               plots use same contour range).
C               Lab  - Label
C               Base - Base number for element indexing
C                      The process bottom, left coordinate in the
C                      global domain.
C               Step - Block size
C               Blo  - Start block
C               Bhi  - End block
C               Bstr - Block stride
C               Min  - Start index within block
C               Max  - End index within block
C               Str  - stride within block
      INTEGER MAX_LEN_PLOTBUF
      PARAMETER ( MAX_LEN_PLOTBUF = MAX_LEN_MBUF-20 )
      CHARACTER*(MAX_LEN_PLOTBUF) plotBuf
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      INTEGER lChList
      PARAMETER ( lChList = 28 )
      CHARACTER*(lChList) chList
      _RL  fMin
      _RL  fMax
      _RL  fRange
      _RL  val
      _RL  small
      CHARACTER*2  accLab
      CHARACTER*7  dwnLab
      CHARACTER*3  pltLab
      INTEGER     accBase, dwnBase, pltBase
      INTEGER     accStep, dwnStep, pltStep
      INTEGER     accBlo,  dwnBlo,  pltBlo
      INTEGER     accBhi,  dwnBhi,  pltBhi
      INTEGER     accBstr, dwnBstr, pltBstr
      INTEGER     accMin,  dwnMin,  pltMin
      INTEGER     accMax,  dwnMax,  pltMax
      INTEGER     accStr,  dwnStr,  pltStr
      INTEGER I, J, K, iStrngLo, iStrngHi, iBuf, iDx
      INTEGER bi, bj, bk
      LOGICAL validRange
CEOP

      chList = '-abcdefghijklmnopqrstuvwxyz+'
      small  = 1. _d -15
      fMin   =  1. _d 32
      fMax   = -1. _d 32
      validRange = .FALSE.

C--   Calculate field range
      DO bj=byMin, byMax, byStr
       DO bi=bxMin, bxMax, bxStr
        DO K=kMin, kMax, kStr
         DO J=jMin, jMax, jStr
          DO I=iMin, iMax, iStr
           IF ( printMapIncludesZeros .OR. fld(I,J,K,bi,bj) .NE. 0. )
     &     THEN
            IF ( fld(I,J,K,bi,bj) .LT. fMin )
     &       fMin = fld(I,J,K,bi,bj)
            IF ( fld(I,J,K,bi,bj) .GT. fMax )
     &       fMax = fld(I,J,K,bi,bj)
           ENDIF
          ENDDO
         ENDDO
        ENDDO
       ENDDO
      ENDDO
      fRange = fMax-fMin
      IF ( fRange .GT. small ) validRange = .TRUE.

C--   Write field title and statistics
      msgBuf =
     & '// ======================================================='
      CALL PRINT_MESSAGE(msgBuf, standardMessageUnit,
     &                   SQUEEZE_RIGHT, 1)
      iStrngLo = IFNBLNK(fldTitle)
      iStrngHi = ILNBLNK(fldTitle)
      IF ( iStrngLo .LE. iStrngHi ) THEN
       WRITE(msgBuf,'(A)') fldTitle(iStrngLo:iStrngHi)
      ELSE
       msgBuf = '// UNKNOWN FIELD'
      ENDIF
      CALL PRINT_MESSAGE(msgBuf, standardMessageUnit,
     &                   SQUEEZE_RIGHT, 1)
      WRITE(msgBuf,'(A,1PE30.15)')
     & '// CMIN = ', fMin
      CALL PRINT_MESSAGE(msgBuf, standardMessageUnit,
     &                   SQUEEZE_RIGHT, 1)
      WRITE(msgBuf,'(A,1PE30.15)')
     & '// CMAX = ', fMax
      CALL PRINT_MESSAGE(msgBuf, standardMessageUnit,
     &                   SQUEEZE_RIGHT, 1)
      IF ( validRange ) THEN
       WRITE(msgBuf,'(A,1PE30.15)')
     & '// CINT = ', fRange/FLOAT(lChlist-1)
      ELSE
       WRITE(msgBuf,'(A,1PE30.15)')
     & '// CINT = ', 0.
      ENDIF
      CALL PRINT_MESSAGE(msgBuf, standardMessageUnit,
     &                   SQUEEZE_RIGHT, 1)
      WRITE(msgBuf,'(A,1024A1)')
     & '// SYMBOLS (CMIN->CMAX): ',(chList(I:I),I=1,lChList)
      CALL PRINT_MESSAGE(msgBuf, standardMessageUnit,
     &                   SQUEEZE_RIGHT, 1)
      WRITE(msgBuf,'(A,1024A1)')
     & '//                  0.0: ','.'
      CALL PRINT_MESSAGE(msgBuf, standardMessageUnit,
     &                   SQUEEZE_RIGHT, 1)
       WRITE(msgBuf,'(A,3(A,I6),A)')
     & '// RANGE I (Lo:Hi:Step):',
     &  '(',myXGlobalLo-1+(bxMin-1)*sNx+iMin,
     &  ':',myXGlobalLo-1+(bxMax-1)*sNx+iMax,
     &  ':',iStr,')'
      CALL PRINT_MESSAGE(msgBuf, standardMessageUnit,
     &                   SQUEEZE_RIGHT, 1)
       WRITE(msgBuf,'(A,3(A,I6),A)')
     & '// RANGE J (Lo:Hi:Step):',
     &  '(',myYGlobalLo-1+(byMin-1)*sNy+jMin,
     &  ':',myYGlobalLo-1+(byMax-1)*sNy+jMax,
     &  ':',jStr,')'
      CALL PRINT_MESSAGE(msgBuf, standardMessageUnit,
     &                   SQUEEZE_RIGHT, 1)
       WRITE(msgBuf,'(A,3(A,I4),A)')
     & '// RANGE K (Lo:Hi:Step):',
     &  '(',kMin,
     &  ':',kMax,
     &  ':',kStr,')'
      CALL PRINT_MESSAGE(msgBuf, standardMessageUnit,
     &                   SQUEEZE_RIGHT, 1)
      msgBuf =
     & '// ======================================================='
      CALL PRINT_MESSAGE(msgBuf, standardMessageUnit,
     &                   SQUEEZE_RIGHT, 1)

c     if (Nx.gt.MAX_LEN_PLOTBUF-20) THEN
c      msgBuf =
c    &  'Model domain too big to print to terminal - skipping I/O'
c      CALL PRINT_MESSAGE(msgBuf, standardMessageUnit,
c    &                   SQUEEZE_RIGHT, 1)
c      RETURN
c     endif

C--   Write field
C     Figure out slice type and set plotting parameters appropriately
C     acc = accross the page
C     dwn = down the page
      IF ( plotMode .EQ. PRINT_MAP_XY ) THEN
C      X across, Y down slice
       accLab  = 'I='
       accBase = myXGlobalLo
       accStep = sNx
       accBlo  = bxMin
       accBhi  = bxMax
       accBStr = bxStr
       accMin  = iMin
       accMax  = iMax
       accStr  = iStr
       dwnLab  = '|--J--|'
       dwnBase = myYGlobalLo
       dwnStep = sNy
       dwnBlo  = byMin
       dwnBhi  = byMax
       dwnBStr = byStr
       dwnMin  = jMin
       dwnMax  = jMax
       dwnStr  = jStr
       pltBlo  = 1
       pltBhi  = 1
       pltBstr = 1
       pltMin  = kMin
       pltMax  = kMax
       pltStr  = kStr
       pltBase = 1
       pltStep = 1
       pltLab  = 'K ='
      ELSEIF ( plotMode .EQ. PRINT_MAP_YZ ) THEN
C      Y across, Z down slice
       accLab  = 'J='
       accBase = myYGlobalLo
       accStep = sNy
       accBlo  = byMin
       accBhi  = byMax
       accBStr = byStr
       accMin  = jMin
       accMax  = jMax
       accStr  = jStr
       dwnLab  = '|--K--|'
       dwnBase = 1
       dwnStep = 1
       dwnBlo  = 1
       dwnBhi  = 1
       dwnBStr = 1
       dwnMin  = kMin
       dwnMax  = kMax
       dwnStr  = kStr
       pltBlo  = bxMin
       pltBhi  = bxMax
       pltBstr = bxStr
       pltMin  = iMin
       pltMax  = iMax
       pltStr  = iStr
       pltBase = myXGlobalLo
       pltStep = sNx
       pltLab  = 'I ='
      ELSEIF ( plotMode .EQ. PRINT_MAP_XZ ) THEN
C      X across, Z down slice
       accLab  = 'I='
       accBase = myXGlobalLo
       accStep = sNx
       accBlo  = bxMin
       accBhi  = bxMax
       accBStr = bxStr
       accMin  = iMin
       accMax  = iMax
       accStr  = iStr
       dwnLab  = '|--K--|'
       dwnBase = 1
       dwnStep = 1
       dwnBlo  = 1
       dwnBhi  = 1
       dwnBStr = 1
       dwnMin  = kMin
       dwnMax  = kMax
       dwnStr  = kStr
       pltBlo  = byMin
       pltBhi  = byMax
       pltBstr = byStr
       pltMin  = jMin
       pltMax  = jMax
       pltStr  = jStr
       pltBase = myYGlobalLo
       pltStep = sNy
       pltLab  = 'J ='
      ENDIF
C-    check if it fits into buffer (-10 should be enough but -12 is safer):
      IF ( (accMax-accMin+1)*(accBhi-accBlo+1).GT.MAX_LEN_PLOTBUF-12
     &     .AND. validRange ) THEN
       msgBuf =
     &  'Model domain too big to print to terminal - skipping I/O'
       CALL PRINT_MESSAGE(msgBuf, standardMessageUnit,
     &                   SQUEEZE_RIGHT, 1)
       validRange = .FALSE.
      ENDIF
      IF ( validRange ) THEN
C      Header
C      Data
       DO bk=pltBlo, pltBhi, pltBstr
        DO K=pltMin,pltMax,pltStr
         WRITE(plotBuf,'(A,I4,I4,I4,I4)') pltLab,
     &   pltBase-1+(bk-1)*pltStep+K
         CALL PRINT_MESSAGE(plotBuf, standardMessageUnit,
     &                      SQUEEZE_RIGHT, 1)
         plotBuf = ' '
         iBuf = 6
         DO bi=accBlo, accBhi, accBstr
          DO I=accMin, accMax, accStr
           iDx = accBase-1+(bi-1)*accStep+I
           iBuf = iBuf + 1
           IF ( 10*((iBuf-6)/10) .EQ. iBuf-6 ) THEN
            IF ( iDx .LT. 10 ) THEN
             WRITE(plotBuf(iBuf:),'(A,I1)') accLab,iDx
            ELSEIF ( iDx .LT. 100 ) THEN
             WRITE(plotBuf(iBuf:),'(A,I2)') accLab,iDx
            ELSEIF ( iDx .LT. 1000 ) THEN
             WRITE(plotBuf(iBuf:),'(A,I3)') accLab,iDx
            ELSEIF ( iDx .LT. 10000 ) THEN
             WRITE(plotBuf(iBuf:),'(A,I4)') accLab,iDx
            ENDIF
           ENDIF
          ENDDO
         ENDDO
         CALL PRINT_MESSAGE(plotBuf, standardMessageUnit,
     &                      SQUEEZE_RIGHT, 1)
         plotBuf = dwnLab
         iBuf = 7
         DO bi=accBlo, accBhi, accBstr
          DO I=accMin, accMax, accStr
           iDx = accBase-1+(bi-1)*accStep+I
           iBuf = iBuf+1
           IF ( 10*((iBuf-7)/10) .EQ. iBuf-7 ) THEN
            WRITE(plotBuf(iBuf:),'(A)')  '|'
           ELSE
            WRITE(plotBuf(iBuf:iBuf),'(I1)') MOD(ABS(iDx),10)
           ENDIF
          ENDDO
         ENDDO
         CALL PRINT_MESSAGE(plotBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, 1)
         DO bj=dwnBlo, dwnBhi, dwnBStr
          DO J=dwnMin, dwnMax, dwnStr
           WRITE(plotBuf,'(1X,I5,1X)')
     &      dwnBase-1+(bj-1)*dwnStep+J
           iBuf = 7
           DO bi=accBlo,accBhi,accBstr
            DO I=accMin,accMax,accStr
             iBuf = iBuf + 1
             IF     ( plotMode .EQ. PRINT_MAP_XY ) THEN
              val = fld(I,J,K,bi,bj)
             ELSEIF ( plotMode .EQ. PRINT_MAP_XZ ) THEN
              val = fld(I,K,J,bi,bk)
             ELSEIF ( plotMode .EQ. PRINT_MAP_YZ ) THEN
              val = fld(K,I,J,bk,bi)
             ENDIF
             IF ( validRange .AND. val .NE. 0. ) THEN
              IDX = NINT(
     &               FLOAT( lChList-1 )*( val-fMin ) / (fRange)
     &              )+1
             ELSE
              IDX = 1
             ENDIF
             IF ( iBuf .LE. MAX_LEN_PLOTBUF )
     &        plotBuf(iBuf:iBuf) = chList(IDX:IDX)
             IF ( val .EQ. 0. ) THEN
              IF ( iBuf .LE. MAX_LEN_PLOTBUF )
     &         plotBuf(iBuf:iBuf) = '.'
             ENDIF
            ENDDO
           ENDDO
           CALL PRINT_MESSAGE(plotBuf, standardMessageUnit,
     &                        SQUEEZE_RIGHT, 1)
          ENDDO
         ENDDO
        ENDDO
       ENDDO
      ENDIF
C--   Write delimiter
      msgBuf =
     & '// ======================================================='
      CALL PRINT_MESSAGE(msgBuf, standardMessageUnit,
     &                   SQUEEZE_RIGHT, 1)
      msgBuf =
     & '// END OF FIELD                                          ='
      CALL PRINT_MESSAGE(msgBuf, standardMessageUnit,
     &                   SQUEEZE_RIGHT, 1)
      msgBuf =
     & '// ======================================================='
      CALL PRINT_MESSAGE(msgBuf, standardMessageUnit,
     &                   SQUEEZE_RIGHT, 1)
      msgBuf = ' '
      CALL PRINT_MESSAGE(msgBuf, standardMessageUnit,
     &                   SQUEEZE_RIGHT, 1)

      RETURN
      END

#include "CPP_EEOPTIONS.h"
#include "W2_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 0
C !ROUTINE: W2_SET_TILE2TILES

C !INTERFACE:
      SUBROUTINE W2_SET_TILE2TILES( myThid )

C     !DESCRIPTION:
C     Set-up tile neighbours and index relations for EXCH2.

C     !USES:
      IMPLICIT NONE

C      Tile topology settings data structures
#include "SIZE.h"
#include "EEPARAMS.h"
#include "W2_EXCH2_SIZE.h"
#include "W2_EXCH2_PARAMS.h"
#include "W2_EXCH2_TOPOLOGY.h"

C     !INPUT PARAMETERS:
C     myThid  :: my Thread Id number
C               (Note: not relevant since threading has not yet started)
      INTEGER myThid

C     !LOCAL VARIABLES:
C     === Local variables ===
C     msgBuf  :: Informational/error message buffer
C     tile_edge2edge(nId,tId) :: Tile edge to edge connection (of tile "tId"
C                                and neighbour "nId"):
C                1rst digit gives local tile Edge (10,20,30,40 <==> N,S,E,W)
C                2nd  digit gives remote tile Edge (1,2,3,4 <==> N,S,E,W)
C                corresponding to this neighbour connection.
      INTEGER tile_edge2edge( W2_maxNeighbours, W2_maxNbTiles )
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      INTEGER tNx, tNy, nbTx, nbNeighb
      INTEGER i, k, ii, nn
      INTEGER is, js, ns, it, jt, nt, tx, ty
      INTEGER iLo, iHi, jLo, jHi
      INTEGER ii1, ii2, jj1, jj2, ddi, ddj
      INTEGER ibnd1, ibnd2, jbnd1, jbnd2
      INTEGER itbd1, itbd2, jtbd1, jtbd2
      INTEGER isbd1, isbd2, jsbd1, jsbd2
      INTEGER txbnd1, txbnd2, tybnd1, tybnd2
      INTEGER errCnt
      LOGICAL internConnect, prtFlag
CEOP

      WRITE(msgBuf,'(2A)') 'W2_SET_TILE2TILES:',
     &       ' tile neighbours and index connection:'
      CALL PRINT_MESSAGE( msgBuf, W2_oUnit, SQUEEZE_RIGHT, myThid )
      prtFlag = ABS(W2_printMsg).GE.2
     &       .OR. ( W2_printMsg .NE.0 .AND. myProcId.EQ.0 )

C--   Initialise local arrays
      DO is=1,W2_maxNbTiles
       DO ns=1,W2_maxNeighbours
        tile_edge2edge(ns,is) = 0
        exch2_neighbourDir(ns,is) = 0
       ENDDO
      ENDDO

      tNx = sNx
      tNy = sNy
      DO is=1,exch2_nTiles
       js  = exch2_myFace(is)
C     test "myFace" for blank tile; no need for connection if tile is blank
       IF ( js.NE.0 ) THEN
        js  = exch2_myFace(is)
        iLo = exch2_tBasex(is)+1
        iHi = exch2_tBasex(is)+exch2_tNx(is)
        jLo = exch2_tBasey(is)+1
        jHi = exch2_tBasey(is)+exch2_tNy(is)

        nbNeighb = 0
        DO i=1,4
         ii1 = iLo
         ii2 = iHi
         jj1 = jLo
         jj2 = jHi
         IF ( i.EQ.1 ) THEN
C--   Northern Edge: [iLo:iHi,jHi]
          jj1 = jHi+1
          jj2 = jHi+1
          internConnect = jHi.LT.exch2_mydNy(is)
          IF ( .NOT.internConnect ) exch2_isNedge(is) = 1
         ELSEIF ( i.EQ.2 ) THEN
C--   Southern Edge: [iLo:iHi,jLo]
          jj1 = jLo-1
          jj2 = jLo-1
          internConnect = jLo.GT.1
          IF ( .NOT.internConnect ) exch2_isSedge(is) = 1
         ELSEIF ( i.EQ.3 ) THEN
C--   Eastern Edge: [iHi,jLo:jHi]
          ii1 = iHi+1
          ii2 = iHi+1
          internConnect = iHi.LT.exch2_mydNx(is)
          IF ( .NOT.internConnect ) exch2_isEedge(is) = 1
         ELSE
C--   Western Edge: [iLo,jLo:jHi]
          ii1 = iLo-1
          ii2 = iLo-1
          internConnect = iLo.GT.1
          IF ( .NOT.internConnect ) exch2_isWedge(is) = 1
         ENDIF
         ddi = MIN( ii2-ii1, 1)
         ddj = MIN( jj2-jj1, 1)

         IF ( internConnect ) THEN
C---  Internal (from the same facet)
C-    N(i=1) -> S(ii=2); S(i=2) -> N(ii=1); E(i=3) -> W(ii=4); W(i=4) -> E(ii=3)
C-    get tile neighbour Id "it":
            nbTx = facet_dims(2*js-1)/tNx
            ii = 1 + MOD(i,2)
            it = 2*ii - 3
            IF ( i.LE.2 ) THEN
               it = is + it*nbTx
            ELSE
               it = is + it
               ii = ii + 2
            ENDIF
            IF ( exch2_myFace(it).NE.0 ) THEN
               nbNeighb = nbNeighb + 1
               ns = MIN(nbNeighb,W2_maxNeighbours)
               exch2_neighbourId(ns,is) = it
               tile_edge2edge(ns,is) = 10*i + ii
               exch2_pij(1,ns,is) = 1
               exch2_pij(2,ns,is) = 0
               exch2_pij(3,ns,is) = 0
               exch2_pij(4,ns,is) = 1
               exch2_oi(ns,is) = 0
               exch2_oj(ns,is) = 0
               exch2_iLo(ns,is) = ii1 - ddi - exch2_tBasex(is)
               exch2_iHi(ns,is) = ii2 + ddi - exch2_tBasex(is)
               exch2_jLo(ns,is) = jj1 - ddj - exch2_tBasey(is)
               exch2_jHi(ns,is) = jj2 + ddj - exch2_tBasey(is)
            ENDIF

         ELSE

C---  External (from an other facet)
          jt = INT(facet_link(i,js))
          ii = MOD( NINT(facet_link(i,js)*10.), 10 )
          IF ( jt.GT.0 ) THEN
C--   needs to find list of tiles in target facet "jt" which connect to "is"
C-    index range on target facet:
           ibnd1 = facet_pij(1,ii,jt)*ii1
     &           + facet_pij(2,ii,jt)*jj1 + facet_oi(ii,jt)
           ibnd2 = facet_pij(1,ii,jt)*ii2
     &           + facet_pij(2,ii,jt)*jj2 + facet_oi(ii,jt)
           jbnd1 = facet_pij(3,ii,jt)*ii1
     &           + facet_pij(4,ii,jt)*jj1 + facet_oj(ii,jt)
           jbnd2 = facet_pij(3,ii,jt)*ii2
     &           + facet_pij(4,ii,jt)*jj2 + facet_oj(ii,jt)
C-    at least 1 index bnd is common (either ibnd1=ibnd2 or jbnd1=jbnd2)
           IF ( ibnd1.LE.ibnd2 ) THEN
             txbnd1 = ( ibnd1 -1 )/tNx
             txbnd2 = ( ibnd2 -1 )/tNx
           ELSE
             txbnd1 = ( ibnd2 -1 )/tNx
             txbnd2 = ( ibnd1 -1 )/tNx
           ENDIF
           IF ( jbnd1.LE.jbnd2 ) THEN
             tybnd1 = ( jbnd1 -1 )/tNy
             tybnd2 = ( jbnd2 -1 )/tNy
           ELSE
             tybnd1 = ( jbnd2 -1 )/tNy
             tybnd2 = ( jbnd1 -1 )/tNy
           ENDIF
           nbTx = facet_dims(2*jt-1)/tNx
           DO ty=tybnd1,tybnd2
            DO tx=txbnd1,txbnd2
             it = facet_owns(1,jt) + tx + ty*nbTx
             IF ( exch2_myFace(it).NE.0 ) THEN
C-    Save to common block this neighbour connection :
               nbNeighb = nbNeighb + 1
               ns = MIN(nbNeighb,W2_maxNeighbours)
               exch2_neighbourId(ns,is)  = it
               tile_edge2edge(ns,is) = 10*i + ii
               DO k=1,4
                 exch2_pij(k,ns,is) = facet_pij(k,i,js)
               ENDDO
               exch2_oi(ns,is) = facet_oi(i,js)
               exch2_oj(ns,is) = facet_oj(i,js)
C     Edge length to be exchanged between tiles is & it:
               itbd1 = MIN( MAX( ibnd1, exch2_tBasex(it)+1 ),
     &                                  exch2_tBasex(it)+tNx )
               itbd2 = MIN( MAX( ibnd2, exch2_tBasex(it)+1 ),
     &                                  exch2_tBasex(it)+tNx )
               jtbd1 = MIN( MAX( jbnd1, exch2_tBasey(it)+1 ),
     &                                  exch2_tBasey(it)+tNy )
               jtbd2 = MIN( MAX( jbnd2, exch2_tBasey(it)+1 ),
     &                                  exch2_tBasey(it)+tNy )
               isbd1 = facet_pij(1,i,js)*itbd1
     &               + facet_pij(2,i,js)*jtbd1 + facet_oi(i,js)
               isbd2 = facet_pij(1,i,js)*itbd2
     &               + facet_pij(2,i,js)*jtbd2 + facet_oi(i,js)
               jsbd1 = facet_pij(3,i,js)*itbd1
     &               + facet_pij(4,i,js)*jtbd1 + facet_oj(i,js)
               jsbd2 = facet_pij(3,i,js)*itbd2
     &               + facet_pij(4,i,js)*jtbd2 + facet_oj(i,js)
               exch2_iLo(ns,is) = isbd1 - ddi - exch2_tBasex(is)
               exch2_iHi(ns,is) = isbd2 + ddi - exch2_tBasex(is)
               exch2_jLo(ns,is) = jsbd1 - ddj - exch2_tBasey(is)
               exch2_jHi(ns,is) = jsbd2 + ddj - exch2_tBasey(is)
C-           end active tile "it"
             ENDIF
C-         end loops on tile indices tx,ty
            ENDDO
           ENDDO
C-        end active connection (it > 0)
          ENDIF
C-       end internal/external connection
         ENDIF
C-      end N,S,E,W Edge loop
        ENDDO
        exch2_nNeighbours(is) = nbNeighb
        IF ( prtFlag ) THEN
         WRITE(W2_oUnit,'(A,I8,A,I3,A,4(A,I2))')
     &    'Tile',is,' : nbNeighb=',nbNeighb,' ; is-at-Facet-Edge:',
     &        ' N=', exch2_isNedge(is), ' , S=', exch2_isSedge(is),
     &      ' , E=', exch2_isEedge(is), ' , W=', exch2_isWedge(is)
         DO ns=1,MIN(nbNeighb,W2_maxNeighbours)
          WRITE(W2_oUnit,'(A,I3,A,I8,2(A,2I6),A,4I3,A,2I6,A)')
     &     ' ns:',ns,' it=',exch2_neighbourId(ns,is),
     &     ', iLo,iHi=', exch2_iLo(ns,is), exch2_iHi(ns,is),
     &     ', jLo,jHi=', exch2_jLo(ns,is), exch2_jHi(ns,is)
c    &     , ' (pij=',(exch2_pij(k,ns,is),k=1,4),
c    &     ', oi,oj=', exch2_oi(ns,is), exch2_oj(ns,is),')'
         ENDDO
        ENDIF
C-     end active tile "is"
       ENDIF
C-    end loop on tile "is"
      ENDDO

C-  Check nbNeighb =< W2_maxNeighbours
      nbNeighb = 0
      it = 0
      DO is=1,exch2_nTiles
        IF ( exch2_nNeighbours(is).GT.nbNeighb ) THEN
          nbNeighb = exch2_nNeighbours(is)
          it = is
        ENDIF
      ENDDO
      WRITE(msgBuf,'(A,I5,A,I3)')
     &  'current Max.Nb.Neighbours (e.g., on tile',it,' ) =',nbNeighb
      CALL PRINT_MESSAGE( msgBuf, W2_oUnit, SQUEEZE_RIGHT, myThid )
      IF ( nbNeighb.GT.W2_maxNeighbours ) THEN
        WRITE(msgBuf,'(2(A,I4),A)')
     &           'W2_SET_TILE2TILES: Max.Nb.Neighbours=', nbNeighb,
     &           ' >', W2_maxNeighbours,' =W2_maxNeighbours'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(2A)') 'Must increase "W2_maxNeighbours"',
     &                       ' in "W2_EXCH2_SIZE.h" + recompile'
        CALL PRINT_ERROR( msgBuf, myThid )
        STOP 'ABNORMAL END: S/R W2_SET_TILE2TILES (W2_maxNeighbours)'
      ENDIF

C-    Set exch2_opposingSend(ns,is) = Neighbour Id (in list of neighbours
C     of tile exch2_neighbourId(ns,is)) which is connected to tile "is"
C     neighbour Id "ns" with matching edge <-> edge connection (ii==i).
      errCnt = 0
      DO is=1,exch2_nTiles
       DO ns=1,exch2_nNeighbours(is)
        i  = tile_edge2edge(ns,is)/10
        ii = MOD(tile_edge2edge(ns,is),10)
        IF ( ii .NE. 0) THEN
          exch2_neighbourDir(ns,is) = i
        ENDIF
        it = exch2_neighbourId(ns,is)
        DO nt=1,exch2_nNeighbours(it)
c         i  = tile_edge2edge(nt,it)/10
          ii = MOD(tile_edge2edge(nt,it),10)
          IF ( exch2_neighbourId(nt,it).EQ.is .AND. ii.EQ.i ) THEN
           IF ( exch2_opposingSend(ns,is).EQ.0 ) THEN
            exch2_opposingSend(ns,is) = nt
           ELSE
            nn = exch2_opposingSend(ns,is)
            WRITE(msgBuf,'(A,I8,2(A,I3),A)') 'Tile',is,' neighb:',
     &      ns,' (',tile_edge2edge(ns,is),' ) has multiple connections'
            CALL PRINT_ERROR( msgBuf, myThid )
            WRITE(msgBuf,'(A,I8,5(A,I3))') ' with tile', it, ' :',
     &      nn,' (',tile_edge2edge(nn,it),' ) and',
     &      nt,' (',tile_edge2edge(nt,it),' )'
            CALL PRINT_ERROR( msgBuf, myThid )
            errCnt = errCnt + 1
           ENDIF
          ENDIF
        ENDDO
        IF ( exch2_opposingSend(ns,is).EQ.0 ) THEN
            WRITE(msgBuf,'(A,I8,2(A,I3),A,I8)') 'Tile',is,' neighb:',
     &      ns,' (',tile_edge2edge(ns,is),' ) no connection from',it
            CALL PRINT_ERROR( msgBuf, myThid )
            errCnt = errCnt + 1
        ENDIF

       ENDDO
      ENDDO
      IF ( errCnt.GT.0 ) THEN
        WRITE(msgBuf,'(A,I3,A)')
     &   ' W2_SET_TILE2TILES: found', errCnt, ' Dbl/No connection'
        CALL PRINT_ERROR( msgBuf, myThid )
        STOP 'ABNORMAL END: S/R W2_SET_TILE2TILES (tile connection)'
      ENDIF
C--  Check opposingSend reciprocity:
      errCnt = 0
      DO is=1,exch2_nTiles
       DO ns=1,exch2_nNeighbours(is)
        it = exch2_neighbourId(ns,is)
        nt = exch2_opposingSend(ns,is)
        ii = exch2_neighbourId(nt,it)
        nn = exch2_opposingSend(nt,it)
        IF ( ii.NE.is .OR. nn.NE.ns ) THEN
          WRITE(msgBuf,'(A,I8,2(A,I3),A)') 'Tile',is,' neighb:',
     &      ns,' (',tile_edge2edge(ns,is),' ) connected'
          CALL PRINT_ERROR( msgBuf, myThid )
          WRITE(msgBuf,'(A,I8,5(A,I3))') ' with tile', it, ' :',
     &      nt,' (',tile_edge2edge(nt,it),' )'
          CALL PRINT_ERROR( msgBuf, myThid )
          WRITE(msgBuf,'(A,I8,2(A,I3),A)') ' but',it,' neighb:',
     &      nt,' (',tile_edge2edge(nt,it),' ) connected'
          CALL PRINT_ERROR( msgBuf, myThid )
          WRITE(msgBuf,'(A,I8,3(A,I3))') ' with tile', ii, ' :',
     &      nn,' (',tile_edge2edge(nn,ii),' )'
          CALL PRINT_ERROR( msgBuf, myThid )
          errCnt = errCnt + 1
        ENDIF
       ENDDO
      ENDDO
      IF ( errCnt.GT.0 ) THEN
        WRITE(msgBuf,'(A,I3,A)')
     &   ' W2_SET_TILE2TILES: found', errCnt, ' opposingSend error'
        CALL PRINT_ERROR( msgBuf, myThid )
        STOP 'ABNORMAL END: S/R W2_SET_TILE2TILES (opposingSend)'
      ENDIF

      RETURN
      END

#include "SEAICE_OPTIONS.h"
#ifdef ALLOW_EXF
# include "EXF_OPTIONS.h"
#endif

CBOP 0
C !ROUTINE: SEAICE_OUTPUT

C !INTERFACE:
      SUBROUTINE SEAICE_OUTPUT( myTime, myIter, myThid )

C     !DESCRIPTION:
C     *==========================================================*
C     | SUBROUTINE SEAICE_OUTPUT
C     | o Do SEAICE output (including Monitor and OBCS output)
C     *==========================================================*

C     !USES:
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "FFIELDS.h"
#include "SEAICE_SIZE.h"
#include "SEAICE_PARAMS.h"
#include "SEAICE.h"
#include "SEAICE_TRACER.h"
#ifdef ALLOW_EXF
# include "EXF_FIELDS.h"
#endif

C     !INPUT PARAMETERS:
C     myTime :: my time in simulation ( s )
C     myIter :: my Iteration number
C     myThid :: my Thread Id number
      _RL     myTime
      INTEGER myIter
      INTEGER myThid

C     !FUNCTIONS:
      LOGICAL  DIFFERENT_MULTIPLE
      EXTERNAL DIFFERENT_MULTIPLE

C     !LOCAL VARIABLES:
      CHARACTER*(10) suff
#ifdef ALLOW_SITRACER
      CHARACTER*(13) pref
      INTEGER iTracer
#endif
#ifdef ALLOW_MNC
      CHARACTER*(1) pf
#endif /* ALLOW_MNC */
CEOP

      IF (SEAICEwriteState) THEN

        IF ( DIFFERENT_MULTIPLE(SEAICE_dumpFreq,myTime,deltaTClock)
     &    .OR. dumpInitAndLast.AND.( myTime.EQ.endTime .OR.
     &                               myTime.EQ.startTime  )
     &       ) THEN

#ifdef ALLOW_MNC
          IF ( useMNC .AND. SEAICE_dump_mnc ) THEN
            IF ( writeBinaryPrec .EQ. precFloat64 ) THEN
              pf(1:1) = 'D'
            ELSE
              pf(1:1) = 'R'
            ENDIF
            CALL MNC_CW_SET_UDIM('sice', -1, myThid)
            CALL MNC_CW_RL_W_S('D','sice',0,0,'T', myTime, myThid)
            CALL MNC_CW_SET_UDIM('sice', 0, myThid)
            CALL MNC_CW_I_W_S('I','sice',0,0,'iter', myIter, myThid)
            CALL MNC_CW_RL_W_S('D','sice',0,0,'model_time',
     &           myTime,myThid)
#if ( defined(SEAICE_CGRID) && defined(SEAICE_ALLOW_EVP) )
            IF ( SEAICEuseEVP ) THEN
             CALL MNC_CW_RL_W(pf,'sice',0,0,'si_sigma1',
     &            seaice_sigma1,myThid)
             CALL MNC_CW_RL_W(pf,'sice',0,0,'si_sigma2',
     &            seaice_sigma2,myThid)
             CALL MNC_CW_RL_W(pf,'sice',0,0,'si_sigma12',
     &            seaice_sigma12,myThid)
            ENDIF
#endif /* SEAICE_CGRID and SEAICE_ALLOW_EVP */
            CALL MNC_CW_RL_W(pf,'sice',0,0,'si_UICE',uIce,myThid)
            CALL MNC_CW_RL_W(pf,'sice',0,0,'si_VICE',vIce,myThid)
            IF ( .NOT.useThSIce ) THEN
             CALL MNC_CW_RL_W(pf,'sice',0,0,'si_HEFF',hEff,myThid)
             CALL MNC_CW_RL_W(pf,'sice',0,0,'si_AREA',area,myThid)
#ifdef SEAICE_ITD
c           CALL MNC_CW_RL_W(pf,'sice',0,0,'si_HEFFITD',HEFFITD,myThid)
c           CALL MNC_CW_RL_W(pf,'sice',0,0,'si_AREAITD',AREAITD,myThid)
#endif
            ENDIF
#ifdef ALLOW_EXF
            CALL MNC_CW_RL_W(pf,'sice',0,0,'si_UWIND',uwind,myThid)
            CALL MNC_CW_RL_W(pf,'sice',0,0,'si_VWIND',vwind,myThid)
#endif
            CALL MNC_CW_RS_W(pf,'sice',0,0,'fu',fu,myThid)
            CALL MNC_CW_RS_W(pf,'sice',0,0,'fv',fv,myThid)
            CALL MNC_CW_RS_W(pf,'sice',0,0,'EmPmR',EmPmR,myThid)
            CALL MNC_CW_RS_W(pf,'sice',0,0,'Qnet',Qnet,myThid)
            CALL MNC_CW_RS_W(pf,'sice',0,0,'Qsw',Qsw,myThid)
          ENDIF
#endif /* ALLOW_MNC */
          IF (SEAICE_dump_mdsio) THEN
            IF ( rwSuffixType.EQ.0 ) THEN
              WRITE(suff,'(I10.10)') myIter
            ELSE
              CALL RW_GET_SUFFIX( suff, myTime, myIter, myThid )
            ENDIF
            IF ( myIter.NE.nIter0 ) THEN
#ifdef ALLOW_EXF
             CALL WRITE_FLD_XY_RL('UWIND.',suff,uwind,myIter,myThid)
             CALL WRITE_FLD_XY_RL('VWIND.',suff,vwind,myIter,myThid)
#endif
             CALL WRITE_FLD_XY_RS('FU.',suff,fu,myIter,myThid)
             CALL WRITE_FLD_XY_RS('FV.',suff,fv,myIter,myThid)
             CALL WRITE_FLD_XY_RS('EmPmR.',suff,EmPmR,myIter,myThid)
             CALL WRITE_FLD_XY_RS('Qnet.',suff,Qnet,myIter,myThid)
             CALL WRITE_FLD_XY_RS('Qsw.',suff,Qsw,myIter,myThid)
            ENDIF
            CALL WRITE_FLD_XY_RL( 'UICE.',suff,uIce,myIter,myThid)
            CALL WRITE_FLD_XY_RL( 'VICE.',suff,vIce,myIter,myThid)
            IF ( .NOT.useThSIce ) THEN
             CALL WRITE_FLD_XY_RL( 'HEFF.',suff,hEff,myIter,myThid)
             CALL WRITE_FLD_XY_RL( 'AREA.',suff,area,myIter,myThid)
             CALL WRITE_FLD_XY_RL( 'HSNOW.',suff,HSNOW,myIter,myThid)
#ifdef SEAICE_ITD
             CALL WRITE_FLD_3D_RL( 'HEFFITD.', suff, nITD, HEFFITD,
     &                             myIter, myThid )
             CALL WRITE_FLD_3D_RL( 'AREAITD.', suff, nITD, AREAITD,
     &                             myIter, myThid )
             CALL WRITE_FLD_3D_RL('HSNOWITD.', suff, nITD, HSNOWITD,
     &                             myIter, myThid )
#endif
#ifdef SEAICE_VARIABLE_SALINITY
             CALL WRITE_FLD_XY_RL( 'HSALT.',suff,HSALT,myIter,myThid)
#endif
#ifdef ALLOW_SITRACER
             DO iTracer = 1, SItrNumInUse
              WRITE(pref,'(A8,I2.2,A1)') 'SITRACER', iTracer, '.'
              CALL WRITE_FLD_XY_RL(
     &             pref,suff,
     &             SItracer(1-OLx,1-OLy,1,1,iTracer),
     &             myIter, myThid )
             ENDDO
#endif
            ENDIF
#if ( defined(SEAICE_CGRID) && defined(SEAICE_ALLOW_EVP) )
            IF ( SEAICEuseEVP ) THEN
             CALL WRITE_FLD_XY_RL('SIGMA1.',suff,seaice_sigma1,
     &            myIter,myThid)
             CALL WRITE_FLD_XY_RL('SIGMA2.',suff,seaice_sigma2,
     &            myIter,myThid)
             CALL WRITE_FLD_XY_RL('SIGMA12.',suff,seaice_sigma12,
     &            myIter,myThid)
            ENDIF
#endif /* SEAICE_CGRID and SEAICE_ALLOW_EVP */
C--   end SEAICE_dump_mdsio block
          ENDIF

        ENDIF
      ENDIF

C----------------------------------------------------------------

C--   do SEAICE monitor output : print some statistics about seaice fields
      CALL SEAICE_MONITOR( myTime, myIter, myThid )

C--   do SEAICE Open-Boundary output
      IF ( useOBCS ) CALL SEAICE_OBCS_OUTPUT( myTime, myIter, myThid )

      RETURN
      END

#include "STREAMICE_OPTIONS.h"
#ifdef ALLOW_AUTODIFF
# include "AUTODIFF_OPTIONS.h"
#endif

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

CBOP
#ifndef ALLOW_OPENAD
      SUBROUTINE STREAMICE_VEL_PHISTAGE (
     I                   myThid,
     I                   maxNLIter,
     I                   maxCGiter,
     O                   cgtol,
     O                   nL_iter,
     O                   CONVERGED,
     O                   err_last_change,
     O                   err_init,
     I                   isinloop)
#else
      SUBROUTINE STREAMICE_VEL_PHISTAGE (
     I                   myThid,
     I                   maxNLIter,
     I                   maxCGiter,
     O                   cgtol,
     O                   nL_iter,
     O                   adj_iter,
     O                   CONVERGED,
     O                   ADJ_CONVERGED,
     O                   err_last_change,
     O                   err_init,
     I                   isinloop)
#endif

C     /============================================================\
C     | SUBROUTINE                                                 |
C     | o                                                          |
C     |============================================================|
C     |                                                            |
C     \============================================================/
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "STREAMICE.h"
#include "STREAMICE_FP.h"
#include "STREAMICE_CG.h"

C     !INPUT/OUTPUT ARGUMENTS
      INTEGER myThid
      INTEGER maxNLIter
      INTEGER maxCGiter
      _RL     cgtol
      _RL     err_last_change
      _RL     err_init
      INTEGER nL_iter
      LOGICAL CONVERGED
      INTEGER isinloop
#ifdef ALLOW_OPENAD
      INTEGER adj_iter
      LOGICAL adj_CONVERGED
#endif

#ifdef ALLOW_STREAMICE_FP_ADJ

C     LOCAL VARIABLES

      INTEGER i, j, bi, bj, cg_iters, m
      _RL     err_max, err_max_fp
      CHARACTER*(MAX_LEN_MBUF) msgBuf

#ifdef ALLOW_OPENAD
      adj_iter=0
      adj_CONVERGED=.false.
#endif

      IF (ISINLOOP .ne. 0) THEN
#ifdef ALLOW_OPENAD
        IF (.NOT. CONVERGED) THEN
#endif
          NL_ITER = (NL_ITER + 1)
          CALL streamice_vel_phi(MYTHID,MAXNLITER,MAXCGITER,CGTOL
     +,CG_ITERS,err_max)

          WRITE(msgBuf,'(A,I5,A,I4,A)') 'streamice linear solve number',
     +NL_ITER,' ',CG_ITERS,' iterations '
          CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     +         SQUEEZE_RIGHT, 1)

C!!!!!!!!!!! conv check

          IF (STREAMICE_chkresidconvergence) THEN

           WRITE(msgBuf,'(A,E15.7)') 'err/err_init', err_max/err_init
           CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     +         SQUEEZE_RIGHT, 1)

           IF (err_max .LE. streamice_nonlin_tol * err_init) THEN
            CONVERGED = .TRUE.
           ENDIF

           IF (err_max<err_last_change*1.e-2 .and. STREAMICE_lower_cg_to
     +l) THEN
            cgtol = cgtol * 5.e-2
            err_last_change = err_max
            WRITE(msgBuf,'(A,E15.7)') 'new cg tol: ', cgtol
            CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     +           SQUEEZE_RIGHT, 1)
           ENDIF

          ENDIF

          IF (STREAMICE_chkfixedptconvergence) THEN

           CALL STREAMICE_GET_FP_ERR_OAD ( err_max_fp, myThid )

           WRITE(msgBuf,'(A,1PE22.14)') 'STREAMICE_FP_ERROR =', err_max_
     +fp
           CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     +          SQUEEZE_RIGHT, 1)

           IF (err_max_fp .LE. streamice_nonlin_tol_fp) THEN
            CONVERGED = .TRUE.
           ENDIF

          ENDIF

          DO bj = myByLo(myThid), myByHi(myThid)
           DO bi = myBxLo(myThid), myBxHi(myThid)
            DO j=1-OLy,sNy+OLy
             DO i=1-OLx,sNx+OLx
              U_streamice (i,j,bi,bj)=u_new_SI (i,j,bi,bj)
              V_streamice (i,j,bi,bj)=v_new_SI (i,j,bi,bj)
#ifdef STREAMICE_HYBRID_STRESS
              streamice_taubx(i,j,bi,bj)=taubx_new_si(i,j,bi,bj)
              streamice_tauby(i,j,bi,bj)=tauby_new_si(i,j,bi,bj)
              DO m=Nr,1,-1
               visc_streamice_full(i,j,m,bi,bj)= visc_full_new_si(i,j,m,
     +bi,bj)
              ENDDO
#endif
             ENDDO
            ENDDO
           ENDDO
          ENDDO

C!!!!!!!!!!! end conv check
#ifdef ALLOW_OPENAD
        ENDIF
#endif
      ENDIF

#endif /* ALLOW_STREAMICE_FP_ADJ */
      RETURN
      END

#include "STREAMICE_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 0
C !ROUTINE: STREAMICE_CHECK

C !INTERFACE:
      SUBROUTINE STREAMICE_CHECK( myThid )

C     !DESCRIPTION:
C     Check dependances with other packages

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "GRID.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "STREAMICE.h"
#include "STREAMICE_CG.h"
#include "STREAMICE_BDRY.h"

C     !INPUT PARAMETERS:
      INTEGER myThid
CEOP

#ifdef ALLOW_STREAMICE
C     !LOCAL VARIABLES:
C     msgBuf   :: Informational/error message buffer
      CHARACTER*(MAX_LEN_MBUF) msgBuf
c     CHARACTER*(10) fname
c     INTEGER m,n,k

      _BEGIN_MASTER(myThid)

       WRITE(msgBuf,'(A)') 'STREAMICE_CHECK: #define STREAMICE'
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                     SQUEEZE_RIGHT , 1)

#ifndef STREAMICE_COULOMB_SLIDING

      IF (STREAMICE_allow_reg_coulomb) THEN

       WRITE(msgBuf,'(A)')
     &   'STREAMICE_CHECK: STREAMICE_COULOMB_SLIDING must be defined'
        CALL PRINT_ERROR( msgBuf, myThid )

      ENDIF

#endif

      IF(n_basal_friction .lt. 0.0) THEN
       WRITE(msgBuf,'(A)')
     &   'STREAMICE_CHECK: n_basal_friction must be nonnegative number'
        CALL PRINT_ERROR( msgBuf, myThid )
      ENDIF

C-   write out integer parameters

       CALL WRITE_0D_I( streamice_max_cg_iter, INDEX_NONE,
     &  ' max cg interations =',
     &  ' /* user defined parameter */')
       CALL WRITE_0D_I( streamice_max_nl_iter, INDEX_NONE,
     &  ' max nonlin interations =',
     &  ' /* user defined parameter */')
       CALL WRITE_0D_I( streamice_nstep_velocity, INDEX_NONE,
     &  ' # of timesteps per velocity solve  =',
     &  ' /* user defined parameter */')

C-   write out real parameters

       CALL WRITE_0D_RL( streamice_density, INDEX_NONE,
     & ' streamice_density =', ' /* user defined parameter */')
       CALL WRITE_0D_RL( streamice_density_ocean_avg, INDEX_NONE,
     & ' streamice_density_ocean_avg =',
     & ' /* user defined parameter */')
       CALL WRITE_0D_RL( B_glen_isothermal, INDEX_NONE,
     & ' glens law stifness =',
     & ' /* user defined parameter */')
       CALL WRITE_0D_RL( n_glen, INDEX_NONE,
     & ' glens law exponent =',
     & ' /* user defined parameter */')
       CALL WRITE_0D_RL( C_basal_fric_const, INDEX_NONE,
     & ' basal trac coeff =',
     & ' /* user defined parameter */')
       CALL WRITE_0D_RL( n_basal_friction, INDEX_NONE,
     & ' basal exponent =',
     & ' /* user defined parameter */')
       CALL WRITE_0D_RL( streamice_input_flux_unif, INDEX_NONE,
     & ' uniform input flux (m^2/a) =',
     & ' /* user defined parameter */')
       CALL WRITE_0D_RL( streamice_vel_update, INDEX_NONE,
     & ' time for ice vel update (sec) =',
     & ' /* user defined parameter */')
       CALL WRITE_0D_RL( streamice_cg_tol, INDEX_NONE,
     & ' conj grad tolerance =',
     & ' /* user defined parameter */')
       CALL WRITE_0D_RL( streamice_nonlin_tol, INDEX_NONE,
     & ' ice velocity nonlinear iter tol =',
     & ' /* user defined parameter */')
       CALL WRITE_0D_RL( shelf_max_draft, INDEX_NONE,
     & ' max shelf draft for analytic init (m) =',
     & ' /* user defined parameter */')
       CALL WRITE_0D_RL( shelf_min_draft, INDEX_NONE,
     & ' min shelf draft for analytic init (m) =',
     & ' /* user defined parameter */')
       CALL WRITE_0D_RL( shelf_edge_pos, INDEX_NONE,
     & ' shelf extent for analytic init (km) =',
     & ' /* user defined parameter */')
       CALL WRITE_0D_RL( shelf_slope_scale, INDEX_NONE,
     & ' slope scale for analytic init (km) =',
     & ' /* user defined parameter */')
       CALL WRITE_0D_RL( shelf_flat_width, INDEX_NONE,
     & ' flat shelf width for analytic init (km) =',
     & ' /* user defined parameter */')
       CALL WRITE_0D_RL( flow_dir, INDEX_NONE,
     & ' flow direction for analytic init =',
     & ' /* user defined parameter */')

       CALL WRITE_0D_RL( min_x_noflow_NORTH, INDEX_NONE,
     & ' min range on no bd for no-slip (km) =',
     & ' /* user defined parameter */')
       CALL WRITE_0D_RL( max_x_noflow_NORTH, INDEX_NONE,
     & ' max range on no bd for no-slip (km) =',
     & ' /* user defined parameter */')
       CALL WRITE_0D_RL( min_x_noflow_SOUTH, INDEX_NONE,
     & ' min range on so bd for no-slip (km) =',
     & ' /* user defined parameter */')
       CALL WRITE_0D_RL( max_x_noflow_SOUTH, INDEX_NONE,
     & ' max range on so bd for no-slip (km) =',
     & ' /* user defined parameter */')
       CALL WRITE_0D_RL( min_y_noflow_EAST, INDEX_NONE,
     & ' min range on east bd for no-slip (km) =',
     & ' /* user defined parameter */')
       CALL WRITE_0D_RL( max_y_noflow_EAST, INDEX_NONE,
     & ' max range on east bd for no-slip (km) =',
     & ' /* user defined parameter */')
       CALL WRITE_0D_RL( min_y_noflow_WEST, INDEX_NONE,
     & ' min range on west bd for no-slip (km) =',
     & ' /* user defined parameter */')
       CALL WRITE_0D_RL( max_y_noflow_WEST, INDEX_NONE,
     & ' max range on west bd for no-slip (km) =',
     & ' /* user defined parameter */')

       CALL WRITE_0D_RL( min_x_noStress_NORTH, INDEX_NONE,
     & ' min range on no bd for no-stress (km) =',
     & ' /* user defined parameter */')
       CALL WRITE_0D_RL( max_x_noStress_NORTH, INDEX_NONE,
     & ' max range on no bd for no-stress (km) =',
     & ' /* user defined parameter */')
       CALL WRITE_0D_RL( min_x_noStress_SOUTH, INDEX_NONE,
     & ' min range on so bd for no-stress (km) =',
     & ' /* user defined parameter */')
       CALL WRITE_0D_RL( max_x_noStress_SOUTH, INDEX_NONE,
     & ' max range on so bd for no-stress (km) =',
     & ' /* user defined parameter */')
       CALL WRITE_0D_RL( min_y_noStress_EAST, INDEX_NONE,
     & ' min range on east bd for no-stress (km) =',
     & ' /* user defined parameter */')
       CALL WRITE_0D_RL( max_y_noStress_EAST, INDEX_NONE,
     & ' max range on east bd for no-stress (km) =',
     & ' /* user defined parameter */')
       CALL WRITE_0D_RL( min_y_noStress_WEST, INDEX_NONE,
     & ' min range on west bd for no-stress (km) =',
     & ' /* user defined parameter */')
       CALL WRITE_0D_RL( max_y_noStress_WEST, INDEX_NONE,
     & ' max range on west bd for no-stress (km) =',
     & ' /* user defined parameter */')

       CALL WRITE_0D_RL( min_x_FluxBdry_NORTH, INDEX_NONE,
     & ' min range on no bd for FluxBdry (km) =',
     & ' /* user defined parameter */')
       CALL WRITE_0D_RL( max_x_FluxBdry_NORTH, INDEX_NONE,
     & ' max range on no bd for FluxBdry (km) =',
     & ' /* user defined parameter */')
       CALL WRITE_0D_RL( min_x_FluxBdry_SOUTH, INDEX_NONE,
     & ' min range on so bd for FluxBdry (km) =',
     & ' /* user defined parameter */')
       CALL WRITE_0D_RL( max_x_FluxBdry_SOUTH, INDEX_NONE,
     & ' max range on so bd for FluxBdry (km) =',
     & ' /* user defined parameter */')
       CALL WRITE_0D_RL( min_y_FluxBdry_EAST, INDEX_NONE,
     & ' min range on east bd for FluxBdry (km) =',
     & ' /* user defined parameter */')
       CALL WRITE_0D_RL( max_y_FluxBdry_EAST, INDEX_NONE,
     & ' max range on east bd for FluxBdry (km) =',
     & ' /* user defined parameter */')
       CALL WRITE_0D_RL( min_y_FluxBdry_WEST, INDEX_NONE,
     & ' min range on west bd for FluxBdry (km) =',
     & ' /* user defined parameter */')
       CALL WRITE_0D_RL( max_y_FluxBdry_WEST, INDEX_NONE,
     & ' max range on west bd for FluxBdry (km) =',
     & ' /* user defined parameter */')

       CALL WRITE_0D_RL( min_x_Dirich_NORTH, INDEX_NONE,
     & ' min range on no bd for Dirich (km) =',
     & ' /* user defined parameter */')
       CALL WRITE_0D_RL( max_x_Dirich_NORTH, INDEX_NONE,
     & ' max range on no bd for Dirich (km) =',
     & ' /* user defined parameter */')
       CALL WRITE_0D_RL( min_x_Dirich_SOUTH, INDEX_NONE,
     & ' min range on so bd for Dirich (km) =',
     & ' /* user defined parameter */')
       CALL WRITE_0D_RL( max_x_Dirich_SOUTH, INDEX_NONE,
     & ' max range on so bd for Dirich (km) =',
     & ' /* user defined parameter */')
       CALL WRITE_0D_RL( min_y_Dirich_EAST, INDEX_NONE,
     & ' min range on east bd for Dirich (km) =',
     & ' /* user defined parameter */')
       CALL WRITE_0D_RL( max_y_Dirich_EAST, INDEX_NONE,
     & ' max range on east bd for Dirich (km) =',
     & ' /* user defined parameter */')
       CALL WRITE_0D_RL( min_y_Dirich_WEST, INDEX_NONE,
     & ' min range on west bd for Dirich (km) =',
     & ' /* user defined parameter */')
       CALL WRITE_0D_RL( max_y_Dirich_WEST, INDEX_NONE,
     & ' max range on west bd for Dirich (km) =',
     & ' /* user defined parameter */')

       CALL WRITE_0D_RL( min_x_CFBC_NORTH, INDEX_NONE,
     & ' min range on no bd for CFBC (km) =',
     & ' /* user defined parameter */')
       CALL WRITE_0D_RL( max_x_CFBC_NORTH, INDEX_NONE,
     & ' max range on no bd for CFBC (km) =',
     & ' /* user defined parameter */')
       CALL WRITE_0D_RL( min_x_CFBC_SOUTH, INDEX_NONE,
     & ' min range on so bd for CFBC (km) =',
     & ' /* user defined parameter */')
       CALL WRITE_0D_RL( max_x_CFBC_SOUTH, INDEX_NONE,
     & ' max range on so bd for CFBC (km) =',
     & ' /* user defined parameter */')
       CALL WRITE_0D_RL( min_y_CFBC_EAST, INDEX_NONE,
     & ' min range on east bd for CFBC (km) =',
     & ' /* user defined parameter */')
       CALL WRITE_0D_RL( max_y_CFBC_EAST, INDEX_NONE,
     & ' max range on east bd for CFBC (km) =',
     & ' /* user defined parameter */')
       CALL WRITE_0D_RL( min_y_CFBC_WEST, INDEX_NONE,
     & ' min range on west bd for CFBC (km) =',
     & ' /* user defined parameter */')
       CALL WRITE_0D_RL( max_y_CFBC_WEST, INDEX_NONE,
     & ' max range on west bd for CFBC (km) =',
     & ' /* user defined parameter */')

       CALL WRITE_0D_RL( flux_bdry_val_NORTH, INDEX_NONE,
     & ' val (m^2/a) for north flux bdry =',
     & ' /* user defined parameter */')
       CALL WRITE_0D_RL( flux_bdry_val_SOUTH, INDEX_NONE,
     & ' val (m^2/a) for south flux bdry =',
     & ' /* user defined parameter */')
       CALL WRITE_0D_RL( flux_bdry_val_EAST, INDEX_NONE,
     & ' val (m^2/a) for east flux bdry =',
     & ' /* user defined parameter */')
       CALL WRITE_0D_RL( flux_bdry_val_WEST, INDEX_NONE,
     & ' val (m^2/a) for west flux bdry =',
     & ' /* user defined parameter */')

C-   write out logical parameters

       CALL WRITE_0D_L( STREAMICE_dump_mdsio, INDEX_NONE,
     & ' streamice_dump_mdsio =', ' /* user defined parameter */')
       CALL WRITE_0D_L( STREAMICE_dump_mdsio, INDEX_NONE,
     & ' streamice_dump_mdsio =', ' /* user defined parameter */')
       CALL WRITE_0D_L( STREAMICE_dump_mnc, INDEX_NONE,
     & ' streamice_dump_mnc =', ' /* user defined parameter */')
       CALL WRITE_0D_L( STREAMICE_tave_mnc, INDEX_NONE,
     & ' streamice_tave_mnc =', ' /* user defined parameter */')
c       CALL WRITE_0D_L( STREAMICE_GL_regularize, INDEX_NONE,
c     & ' streamice_GL_regularize =', ' /* user defined parameter */')
       CALL WRITE_0D_L( STREAMICE_move_front, INDEX_NONE,
     & ' streamice_move_front =', ' /* user defined parameter */')
       CALL WRITE_0D_L( STREAMICE_calve_to_mask, INDEX_NONE,
     & ' streamice_calve_to_mask =', ' /* user defined parameter */')

C-   write out string parameters

       CALL WRITE_0D_C( STREAMICEthickInit,-1,INDEX_NONE,
     & 'STREAMICEthickInit =',
     & ' /* user defined parameter */')
       CALL WRITE_0D_C( STREAMICEthickFile,-1,INDEX_NONE,
     & 'STREAMICEthickFile =',
     & ' /* user defined parameter */')
       CALL WRITE_0D_C( STREAMICEcalveMaskFile,-1,INDEX_NONE,
     & 'STREAMICEcalveMaskFile =',
     & ' /* user defined parameter */')

C-     Put stops here if some flags are wrongly chosen.
C-     For example, require this package to use tempStepping

      _END_MASTER(myThid)

C    write init_thickness array to a binary file

c        CALL WRITE_FLD_XY_RL ( "H_streamIce", "init",
c      & H_streamIce, 0, myThid )
c        CALL WRITE_FLD_XY_RL ( "area_shelf_streamice", "init",
c      & area_shelf_streamice, 0, myThid )
c        CALL WRITE_FLD_XY_RL ( "STREAMICE_hmask", "init",
c      & STREAMICE_hmask, 0, myThid )
c        CALL WRITE_FLD_XY_RL ( "base_el_streamice", "init",
c      & base_el_streamice, 0, myThid )
c        CALL WRITE_FLD_XY_RL ( "ssurf_el_streamice", "init",
c      & surf_el_streamice, 0, myThid )

c       DO m=1,4
c        DO n=1,4
c         DO k=1,2
c          WRITE(fname,'(A,I1,A,I1,A,I1)')
c     &     "Dphi_", m, "_", n, "_", k
c          CALL WRITE_FLD_XY_RL (fname, "",
c     &     Dphi(:,:,:,:,m,n,k),0,myThid)
c         ENDDO
c        ENDDO
c       ENDDO

       CALL WRITE_FLD_XY_RL ( "k1AtC_str", "out",
     & k1AtC_str, 0, myThid )
       CALL WRITE_FLD_XY_RL ( "k2AtC_str", "out",
     & k2AtC_str, 0, myThid )
       CALL WRITE_FLD_XY_RS ( "STREAMICE_ufacemask_bdry", "out",
     & STREAMICE_ufacemask_bdry, 0, myThid )
       CALL WRITE_FLD_XY_RS ( "STREAMICE_vfacemask_bdry", "out",
     & STREAMICE_vfacemask_bdry, 0, myThid )
       CALL WRITE_FLD_XY_RL ( "u_bdry_values_SI", "out",
     & u_bdry_values_SI, 0, myThid )
       CALL WRITE_FLD_XY_RL ( "v_bdry_values_SI", "out",
     & v_bdry_values_SI, 0, myThid )
       CALL WRITE_FLD_XY_RL ( "u_flux_bdry_SI", "out",
     & u_flux_bdry_SI, 0, myThid )
       CALL WRITE_FLD_XY_RL ( "v_flux_bdry_SI", "out",
     & v_flux_bdry_SI, 0, myThid )

#endif /* ALLOW_STREAMICE */

      RETURN
      END

#include "DIAG_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: DIAGNOSTICS_READ_PICKUP
C     !INTERFACE:
      SUBROUTINE DIAGNOSTICS_READ_PICKUP(
     I     myThid )

C     !DESCRIPTION:
C     Reads previously saved state for the diagnostics package.

C     !USES:
      IMPLICIT NONE

C     == Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "DIAGNOSTICS_SIZE.h"
#include "DIAGNOSTICS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     myThid  :: Number of this instance
      INTEGER myThid

#ifdef DIAGNOSTICS_HAS_PICKUP

C     !LOCAL VARIABLES:
C     fn      :: character buffer for creating filename
C     prec    :: precision of pickup files
c     INTEGER prec, iChar, lChar, k
      INTEGER bi,bj
      INTEGER prec, sn
      CHARACTER*(MAX_LEN_FNAM) fn

      INTEGER  ILNBLNK
      EXTERNAL ILNBLNK

      INTEGER dUnit, ndId, n, m

#ifdef ALLOW_MNC
      INTEGER i, ii
      CHARACTER*(MAX_LEN_FNAM) diag_mnc_bn
      INTEGER CW_DIMS, NLEN
      PARAMETER ( CW_DIMS = 10 )
      PARAMETER ( NLEN    = 80 )
      INTEGER dim(CW_DIMS), ib(CW_DIMS), ie(CW_DIMS)
      CHARACTER*(NLEN) dn(CW_DIMS)
      CHARACTER*(NLEN) d_cw_name
      CHARACTER*(NLEN) dn_blnk
#endif /*  ALLOW_MNC  */

C     Add pickup capability
      IF (diag_pickup_read) THEN

#ifdef ALLOW_MNC
        IF (diag_pickup_read_mnc) THEN
          DO i = 1,NLEN
            dn_blnk(i:i) = ' '
          ENDDO
          DO i = 1,MAX_LEN_FNAM
            diag_mnc_bn(i:i) = ' '
          ENDDO
          WRITE(diag_mnc_bn,'(A)') 'pickup_diagnostics'

C         Update the record dimension by writing the iteration number
          CALL MNC_FILE_CLOSE_ALL_MATCHING(diag_mnc_bn, myThid)
          CALL MNC_CW_SET_UDIM(diag_mnc_bn, 1, myThid)

C         Read the qdiag() array
          d_cw_name(1:NLEN) = dn_blnk(1:NLEN)
          DO ii = 1,CW_DIMS
            dn(ii)(1:NLEN) = dn_blnk(1:NLEN)
          ENDDO
          d_cw_name(1:10) = 'diag_state'
          dn(1)(1:3) = 'Xp1'
          dim(1)     = sNx + 2*OLx
          ib(1)      = OLx + 1
          ie(1)      = OLx + sNx + 1
          dn(2)(1:3) = 'Yp1'
          dim(2)     = sNy + 2*OLy
          ib(2)      = OLy + 1
          ie(2)      = OLy + sNy + 1
          dn(3)(1:2) = 'Zd'
          dim(3)     = numDiags
          ib(3)      = 1
          ie(3)      = numDiags
          dn(4)(1:1) = 'T'
          dim(4)     = -1
          ib(4)      = 1
          ie(4)      = 1
          CALL MNC_CW_ADD_GNAME(d_cw_name, 4,
     &         dim, dn, ib, ie, myThid)
          CALL MNC_CW_ADD_VNAME(d_cw_name, d_cw_name,
     &         4,5, myThid)
          CALL MNC_CW_RL_R('D',diag_mnc_bn,0,0,
     &         d_cw_name, qdiag, myThid)
          CALL MNC_CW_DEL_VNAME(d_cw_name, myThid)
          CALL MNC_CW_DEL_GNAME(d_cw_name, myThid)

C         Read the ndiag() array
          d_cw_name(1:NLEN) = dn_blnk(1:NLEN)
          DO ii = 1,CW_DIMS
            dn(ii)(1:NLEN) = dn_blnk(1:NLEN)
          ENDDO
          d_cw_name(1:10) = 'diag_count'
          dn(1)(1:2) = 'Nd'
          dim(1)     = numDiags
          ib(1)      = 1
          ie(1)      = numDiags
          dn(2)(1:1) = 'T'
          dim(2)     = -1
          ib(2)      = 1
          ie(2)      = 1
          CALL MNC_CW_ADD_GNAME(d_cw_name, 2,
     &         dim, dn, ib, ie, myThid)
          CALL MNC_CW_ADD_VNAME(d_cw_name, d_cw_name,
     &         4,5, myThid)
          CALL MNC_CW_ADD_VATTR_TEXT(d_cw_name,'description',
     &         'diagnostics state',myThid)
C- jmc: get warnings when I compile this S/R because something is not right
C       in the type or one or more arguments. commented out for now
c         CALL MNC_CW_RL_R('I',diag_mnc_bn,0,0,
c    &         d_cw_name, ndiag, myThid)
          CALL MNC_CW_DEL_VNAME(d_cw_name, myThid)
          CALL MNC_CW_DEL_GNAME(d_cw_name, myThid)

        ENDIF
#endif /* ALLOW_MNC */

        IF (diag_pickup_read_mdsio) THEN

C         Read qdiag()
          prec = precFloat64
          WRITE(fn,'(A,I10.10)') 'pickup_qdiag.', nIter0
          CALL READ_REC_3D_RL( fn, prec,
     &                         numDiags, qdiag, nIter0, myThid )

C         Read ndiag()
          _BARRIER
          _BEGIN_MASTER(myThid)

C--    jmc: should really write 1 file per tile
          WRITE(fn,'(A,I10.10)') 'pickup_ndiag.', nIter0
          CALL MDSFINDUNIT( dUnit, myThid )
          OPEN( dUnit, file=fn )
          DO n = 1,nlists
            DO m = 1,nfields(n)
              ndId = ABS(jdiag(m,n))
              READ(dUnit,'(I10)') ndiag(ndId,1,1)
            ENDDO
          ENDDO
          CLOSE( dUnit )
C-        Need to fill-in ndiag for other tiles
          DO bj=1,nSy
           DO bi=1,nSx
            DO n=1,ndiagt
             ndiag(n,bi,bj) = ndiag(n,1,1)
            ENDDO
           ENDDO
          ENDDO
          _END_MASTER(myThid)
          _BARRIER
        ENDIF

      ENDIF

#endif /* DIAGNOSTICS_HAS_PICKUP */

      RETURN
      END

#include "STREAMICE_OPTIONS.h"

      SUBROUTINE template()
      use OAD_cp
      use OAD_tape
      use OAD_rev


!      integer :: cp_loop_variable_1,cp_loop_variable_2, cp_loop_variable
!     +_3,cp_loop_variable_4


      if (our_rev_mode%plain) then
      CALL OpenAD_exch_xy_rl (X, mythid)
      end if
      if (our_rev_mode%tape .and..not.our_rev_mode%strictAnonymous) then
      CALL OpenAD_exch_xy_rl (X, mythid)
      end if
      if (our_rev_mode%tape .and. our_rev_mode%strictAnonymous) then
      CALL OpenAD_exch_xy_rl (X, mythid)
      end if
      if (our_rev_mode%adjoint) then

      CALL OpenAD_exch_xy_rl (X, mythid)

      

      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
        DO j=0,sNy+1
         DO i=1,sNx
          q_int1(i,j,bi,bj) = .25 * X(i-1,j,bi,bj)%d + 
     &                        .50 * X(i,j,bi,bj)%d +
     &                        .25 * X(i+1,j,bi,bj)%d
         ENDDO
        ENDDO
       ENDDO
      ENDDO

      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
        DO j=1,sNy
         DO i=1,sNx
          q_int2(i,j,bi,bj) = .25 * q_int1(i,j+1,bi,bj) +  
     &                        .50 * q_int1(i,j,bi,bj) +
     &                        .25 * q_int1(i,j+1,bi,bj)
         ENDDO
        ENDDO
       ENDDO
      ENDDO

      CALL EXCH_XY_RL (q_int2, mythid)

      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
        DO j=1,sNy
         DO i=1,sNx
          X(i,j,bi,bj)%d = .25 * q_int2(i,j+1,bi,bj) +  
     &                        .50 * q_int2(i,j,bi,bj) +
     &                        .25 * q_int2(i,j+1,bi,bj)
         ENDDO
        ENDDO
       ENDDO
      ENDDO

      
      end if
      end subroutine template

#include "CPP_OPTIONS.h"

CBOP
C     !ROUTINE: CPL_RECV_ATM_FIELDS
C     !INTERFACE:
      SUBROUTINE CPL_RECV_ATM_FIELDS( msgUnit, iter )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE CPL_RECV_ATM_FIELDS
C     | o Routine for receiving fluxes from atmos. component
C     *==========================================================*
C     | This version talks to the MITgcm general circulation
C     | model.
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     == Global variables ==
#include "CPL_PARAMS.h"
#include "ATMSIZE.h"
#include "ATMVARS.h"
#include "ATMIDS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     msgUnit   :: log-file I/O unit
C     iter      :: current iteration number
      INTEGER msgUnit, iter

C     !LOCAL VARIABLES:
CEOP

C-    Receive Sea Level atmos. pressure from atmos. component
      CALL COUPRECV_R8TILES( atmCompName, atmSLPrName,
     I                       Nx_atm, Ny_atm,
     O                       atmSLPr_atm )

C-    Receive (net) Heat Flux from atmos. component
      CALL COUPRECV_R8TILES( atmCompName, atmHeatFluxName,
     I                       Nx_atm, Ny_atm,
     O                       HeatFlux_atm )

C-    Receive net shortwave radiation from atmos. component
      CALL COUPRECV_R8TILES( atmCompName, atmQshortWaveName,
     I                       Nx_atm, Ny_atm,
     O                       qShortwave_atm   )

C-    Receive Zonal momentum flux from atmos. component
      CALL COUPRECV_R8TILES( atmCompName, atmTauXName,
     I                       Nx_atm, Ny_atm,
     O                       TauX_atm )

C-    Receive Meridional momentum flux from atmos. component
      CALL COUPRECV_R8TILES( atmCompName, atmTauYName,
     I                       Nx_atm, Ny_atm,
     O                       TauY_atm )

C-    Receive fresh water flux (=Evap-Precip) from atmos. component
      CALL COUPRECV_R8TILES( atmCompName, atmEvMPrName,
     I                       Nx_atm, Ny_atm,
     O                       EvMPr_atm )

      IF ( cpl_exchange_RunOff.GE.2 ) THEN
C-    Receive fresh water flux (=RunOff) from atmos. component
        CALL COUPRECV_R8TILES( atmCompName, atmRunOffName,
     I                         Nx_atm, Ny_atm,
     O                         RunOff_atm )

C-    Receive Energy carried by RunOff from atmos. component
        CALL COUPRECV_R8TILES( atmCompName, atmROEnFxName,
     I                         Nx_atm, Ny_atm,
     O                         ROEnFx_atm )
      ENDIF

      IF ( cpl_exchange1W_sIce.GE.2 ) THEN
C-    Receive salt flux (<- sea-ice) from atmos. component
        CALL COUPRECV_R8TILES( atmCompName, atmSaltFxName,
     I                         Nx_atm, Ny_atm,
     O                         SaltFlx_atm )

C-    Receive sea-ice mass from atmos. component
        CALL COUPRECV_R8TILES( atmCompName, atmSIceMassName,
     I                         Nx_atm, Ny_atm,
     O                         sIceMass_atm )
      ENDIF

      IF ( cpl_exchange_SaltPl.GE.2 ) THEN
C-    Receive Salt-Plume flux from atmos. component
        CALL COUPRECV_R8TILES( atmCompName, atmSaltPlmFlxName,
     I                         Nx_atm, Ny_atm,
     O                         saltPlmFlx_atm )
      ENDIF

      IF ( cpl_exchange_DIC.GE.2 ) THEN
C-    Receive atmos CO2 from atmos. component
        CALL COUPRECV_R8TILES( atmCompName, atmAirCO2Name,
     I                         Nx_atm, Ny_atm,
     O                         aCO2_atm )

C-    Receive surface wind speed from atmos. component
        CALL COUPRECV_R8TILES( atmCompName, atmWindSpdName,
     I                         Nx_atm, Ny_atm,
     O                         wSpeed_atm )
      ENDIF

      IF ( ( cpl_exchange1W_sIce.GE.2
     &     .AND.cpl_exchange_DIC.GE.2 )
     &  .OR. cpl_exchange2W_sIce.GE.2 ) THEN
C-    Receive seaice fraction from atmos. component
        CALL COUPRECV_R8TILES( atmCompName, atmSIceFracName,
     I                         Nx_atm, Ny_atm,
     O                         sIceFrac_atm )
      ENDIF

      IF ( cpl_exchange2W_sIce.GE.2 ) THEN
C-    Receive seaice thickness from atmos. component
        CALL COUPRECV_R8TILES( atmCompName, atmSIceThickName,
     I                         Nx_atm, Ny_atm,
     O                         sIceThick_atm )

C-    Receive snow thickness from atmos. component
        CALL COUPRECV_R8TILES( atmCompName, atmSIceSnowName,
     I                         Nx_atm, Ny_atm,
     O                         sIceSnowH_atm )

C-    Receive seaice enthalpy (layer 1) from atmos. component
        CALL COUPRECV_R8TILES( atmCompName, atmSIceQ1Name,
     I                         Nx_atm, Ny_atm,
     O                         sIceQ1_atm )

C-    Receive seaice enthalpy (layer 2) from atmos. component
        CALL COUPRECV_R8TILES( atmCompName, atmSIceQ2Name,
     I                         Nx_atm, Ny_atm,
     O                         sIceQ2_atm )
      ENDIF

      RETURN
      END

#include "GGL90_OPTIONS.h"

CBOP
C     !ROUTINE: GGL90_CALC_DIFF

C     !INTERFACE:
      SUBROUTINE GGL90_CALC_DIFF(
     I        bi, bj, iMin, iMax, jMin, jMax, kArg, kSize,
     U        KappaRx,
     I        myThid )

C     !DESCRIPTION:
C     *==========================================================*
C     | SUBROUTINE GGL90_CALC_DIFF                               |
C     | o Add contribution to net diffusivity from GGL90 mixing  |
C     *==========================================================*

C     !USES:
      IMPLICIT NONE
C     == GLobal variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
c#include "DYNVARS.h"
c#include "GRID.h"
#include "GGL90.h"

C     !INPUT/OUTPUT PARAMETERS:
C     bi, bj    :: current tile indices
C     iMin,iMax :: Range of points for which calculation is done
C     jMin,jMax :: Range of points for which calculation is done
C     kArg      :: = 0 -> do the k-loop here and treat all levels
C                  > 0 -> k-loop is done outside and treat only level k=kArg
C     kSize     :: 3rd Dimension of the vertical diffusivity array KappaRx
C     KappaRx   :: vertical diffusivity array
C     myThid    :: my Thread Id number
      INTEGER bi, bj, iMin, iMax, jMin, jMax, kArg, kSize
      _RL KappaRx(1-OLx:sNx+OLx,1-OLy:sNy+OLy,kSize)
      INTEGER myThid

#ifdef ALLOW_GGL90
C     !LOCAL VARIABLES:
C     i, j, k   :: Loop counters
      INTEGER i, j, k
CEOP

C--   Add Vertical diffusivity contribution from GGL90
      IF ( kArg .EQ. 0 ) THEN
C-    do all levels :
        DO k=1,MIN(Nr,kSize)
         DO j=jMin,jMax
          DO i=iMin,iMax
            KappaRx(i,j,k) = KappaRx(i,j,k)
     &                  +( GGL90diffKr(i,j,k,bi,bj)
     &                     - diffKrNrS(k) )
          ENDDO
         ENDDO
        ENDDO
      ELSE
C-    do level k=kArg only :
         k = MIN(kArg,kSize)
         DO j=jMin,jMax
          DO i=iMin,iMax
            KappaRx(i,j,k) = KappaRx(i,j,k)
     &                  +( GGL90diffKr(i,j,kArg,bi,bj)
     &                     - diffKrNrS(kArg) )
          ENDDO
         ENDDO
      ENDIF

#endif /* ALLOW_GGL90 */

      RETURN
      END

#include "PACKAGES_CONFIG.h"
#include "CPP_OPTIONS.h"
#ifdef ALLOW_AUTODIFF
# include "AUTODIFF_OPTIONS.h"
#endif

CBOP
C     !ROUTINE: CONVECTIVE_ADJUSTMENT_INI
C     !INTERFACE:
      SUBROUTINE CONVECTIVE_ADJUSTMENT_INI(
     I                      bi, bj, myTime, myIter, myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE CONVECTIVE_ADJUSTMENT_INI
C     | o Driver for vertical mixing or similar parameterization
C     *==========================================================*
C     | Same prognostic code logic as S/R CONVECTIVE_ADJUSTMENT,
C     | but different time history behavior in forward-reverse
C     | adjoint operation.
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     == Global data ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "DYNVARS.h"
#include "GRID.h"
#ifdef ALLOW_AUTODIFF_TAMC
# include "tamc.h"
#endif /* ALLOW_AUTODIFF */

#ifdef ALLOW_TAPENADE
# ifdef ALLOW_PTRACERS
# include "PTRACERS_SIZE.h"
# include "PTRACERS_FIELDS.h"
# endif
#endif /* ALLOW_TAPENADE */

C     !INPUT/OUTPUT PARAMETERS:
C     bi,bj  :: tile indices
C     myTime :: Current time in simulation
C     myIter :: Current iteration in simulation
C     myThid :: My Thread Id number
      INTEGER bi,bj
      _RL     myTime
      INTEGER myIter
      INTEGER myThid

#ifdef INCLUDE_CONVECT_INI_CALL

C     !FUNCTIONS:
c     EXTERNAL DIFFERENT_MULTIPLE
c     LOGICAL  DIFFERENT_MULTIPLE

C     !LOCAL VARIABLES:
C     iMin,iMax,jMin,jMax :: computation domain
C     i,j,k        :: Loop counters
C     rhoKm1, rhoK :: Density at adjacent levels (common ref. level)
C     ConvectCount :: Convection mixing freq. counter.
      INTEGER iMin,iMax,jMin,jMax
      INTEGER i, j, k, kTop, kBottom, kDir, deltaK
#ifdef ALLOW_AUTODIFF_TAMC
      INTEGER tkey, kkey
#endif
      _RL rhoKm1(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL rhoK  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL ConvectCount(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL weightA(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL weightB(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
CEOP

C--   Check to see if should convect now
c     IF ( DIFFERENT_MULTIPLE(cAdjFreq,myTime,deltaTClock)
c    &   ) THEN

C--   Define computation domain
        iMin=1-OLx
        iMax=sNx+OLx
        jMin=1-OLy
        jMax=sNy+OLy

C--   Initialise counters
        kTop    = 0
        kBottom = 0
        kDir    = 0
        deltaK  = 0

C-      Initialisation of Convection Counter
        DO k=1,Nr
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           ConvectCount(i,j,k) = 0.
          ENDDO
         ENDDO
        ENDDO

#ifdef ALLOW_AUTODIFF_TAMC
        tkey = bi + (bj-1)*nSx
#endif /* ALLOW_AUTODIFF_TAMC */

        IF ( rkSign*gravitySign .GT. 0. ) THEN
C-          <=> usingZCoords:
         kTop    =  2
         kBottom = Nr
         kDir    =  1
         deltaK  = -1
        ELSE
C-          <=> usingPCoords:
         kTop    = Nr
         kBottom =  2
         kDir    = -1
         deltaK  =  0
        ENDIF

C--       Loop over all *interior* layers
        DO k=kTop,kBottom,kDir

#ifdef ALLOW_AUTODIFF_TAMC
         kkey = k + (tkey-1)*Nr
C     It is important that the two k-levels of these fields are stored
C     in one statement because otherwise taf will only store one, which
C     is wrong (i.e. was wrong in previous versions).
CADJ STORE theta(:,:,k-1,bi,bj), theta(:,:,k,bi,bj) =
CADJ &     tapelev_ini_bibj_k, key=kkey, kind=isbyte
CADJ STORE salt(:,:,k-1,bi,bj), salt(:,:,k,bi,bj) =
CADJ &     tapelev_ini_bibj_k, key=kkey, kind=isbyte
#endif /* ALLOW_AUTODIFF_TAMC */
C-          Density of k-1 layer (above W(k)) reference to k-1 T-level
         CALL FIND_RHO_2D(
     I           iMin, iMax, jMin, jMax, k+deltaK,
     I           theta(1-OLx,1-OLy,k-1,bi,bj),
     I           salt (1-OLx,1-OLy,k-1,bi,bj),
     O           rhoKm1,
     I           k-1, bi, bj, myThid )

C-          Density of k layer (below W(k)) reference to k-1 T-level.
         CALL FIND_RHO_2D(
     I           iMin, iMax, jMin, jMax, k+deltaK,
     I           theta(1-OLx,1-OLy,k,bi,bj),
     I           salt (1-OLx,1-OLy,k,bi,bj),
     O           rhoK,
     I           k, bi, bj, myThid )
#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE rhoKm1 = tapelev_ini_bibj_k, key=kkey, kind=isbyte
CADJ STORE rhoK   = tapelev_ini_bibj_k, key=kkey, kind=isbyte
#endif /* ALLOW_AUTODIFF_TAMC */

C-          Pre-calculate mixing weights for interface k
         CALL CONVECTIVE_WEIGHTS(
     I           bi,bj,k,rhoKm1,rhoK,
     O           weightA,weightB,ConvectCount,
     I           myThid)

C-          Convectively mix heat across interface k
         CALL CONVECTIVELY_MIXTRACER(
     I                               bi,bj,k,weightA,weightB,
     U                               theta,
     I                               myThid)

C-          Convectively mix salt across interface k
         CALL CONVECTIVELY_MIXTRACER(
     I                               bi,bj,k,weightA,weightB,
     U                               salt,
     I                               myThid)

#ifdef ALLOW_PTRACERS
C-          Convectively mix passive tracers across interface k
         IF ( usePTRACERS ) THEN
          CALL PTRACERS_CONVECT(
     I                          bi,bj,k,weightA,weightB,myThid)
         ENDIF
#endif /* ALLOW_PTRACERS */

C--       End DO k=1,Nr
        ENDDO

C--   End IF (DIFFERENT_MULTIPLE)
c     ENDIF

#endif /* INCLUDE_CONVECT_INI_CALL */

      RETURN
      END

#include "CHEAPAML_OPTIONS.h"

      SUBROUTINE CHEAPAML_READPARMS( myThid )
C     *==========================================================*
C     | SUBROUTINE CHEAPAML_READPARMS                            |
C     | o Routine to initialize CHEAPAML variables and consts.   |
C     *==========================================================*
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "CHEAPAML.h"

C     === Routine arguments ===
      INTEGER myThid

C     === Local variables ===
C     msgBuf      :: Informational/error message buffer
C     iUnit       :: Work variable for IO unit number
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      INTEGER iUnit
C-    retired parameters:
C     nRetired    :: Count number of "retired" parameters found in namelist.
      INTEGER nRetired
      _RL cheapaml_taurelax, cheapaml_taurelaxocean

C--   Bulk Formula parameter
      NAMELIST /CHEAPAML_CONST/
     &  cheapaml_ntim, cheapaml_mask_width,
     &  cheapaml_h, cheapaml_kdiff,
     &  cheap_tauRelax, cheap_tauRelaxOce,
     &  cdrag_1,cdrag_2,cdrag_3,
     &  rhoa, cpair, stefan, gasR, xkar,
     &   dsolms,dsolmn,zu,zt,zq,
     &   xphaseinit,gamma_blk,humid_fac,p0,
     &   cheap_pr1, cheap_pr2,
     &  cheapaml_taurelax, cheapaml_taurelaxocean

      NAMELIST /CHEAPAML_PARM01/
     &         periodicExternalForcing_cheap,
     &         externForcingPeriod_cheap,
     &         externForcingCycle_cheap,
     &         AirTempFile,
     &         SolarFile,
     &         UWindFile,
     &         VWindFile,
     &         TrFile,
     &         QrFile,
     &         AirQFile,
     &         UStressFile, VStressFile,
     &         WaveHFile,WavePFile,
     &         TracerFile,TracerRfile,
     &         cheapMaskFile,cheap_hFile,
     &         cheap_clFile,cheap_dlwFile,
     &         cheap_prFile

      NAMELIST /CHEAPAML_PARM02/
     &         cheapamlXperiodic,
     &         cheapamlYperiodic,
     &         useFreshWaterFlux,
     &         useFluxLimit,
     &         FluxFormula,WaveModel,
     &         useStressOption,
     &         useCheapTracer ,
     &         useTimeVarBLH,
     &         useClouds,
     &         useDLongWave,
     &         usePrecip,
     &         useRelativeWind

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      IF ( .NOT.useCheapAML ) THEN
C-    pkg CHEAPAML is not used
        _BEGIN_MASTER(myThid)
C-    Track pkg activation status:
C     print a (weak) warning if data.cheapaml is found
         CALL PACKAGES_UNUSED_MSG( 'useCheapAML', ' ', ' ' )
        _END_MASTER(myThid)
        RETURN
      ENDIF

      _BEGIN_MASTER(myThid)

      WRITE(msgBuf,'(A)') ' BULKF_READPARMS: opening data.cheapaml'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )

      CALL OPEN_COPY_DATA_FILE(
     I                          'data.cheapaml', 'CHEAPAML_READPARMS',
     O                          iUnit,
     I                          myThid )

C--   Hard-coded values (not in any namelist):
C     coeff. used to compute saturation specific humidity (not in namelist)
      ssq0 = 3.797915 _d 0
      ssq1 = 7.93252  _d -6
      ssq2 = 2.166847 _d -3

C--   Default values
C-    Physical constant :
      cheapaml_ntim = 5
      cheapaml_h=1000. _d 0
      cheapaml_kdiff=1. _d 4
      cheap_tauRelax    = 8640. _d 0
      cheap_tauRelaxOce = 0. _d 0
      cheapaml_mask_width = 0
      rhoa   = 1.3 _d 0
      cpair  = 1004. _d 0
      stefan = 5.67 _d -8
      dsolms = 50. _d 0
      dsolmn = 25. _d 0
C heights of variables
      zu=10. _d 0
      zt=zu
      zq=zu
      xphaseinit = 0. _d 0
      cdrag_1=0.0027 _d 0
      cdrag_2=0.000142 _d 0
      cdrag_3=0.0000764 _d 0
C gas constant
      gasR=287.04 _d 0
C atmospheric adiabatic lapse rate
      gamma_blk=0.0098 _d 0
C humidity factor for computing virtual potential temperature
      humid_fac=0.606 _d 0
C surface pressure in mb
      p0=1000. _d 0
C latent heat (J/kg)
      lath=2.5 _d 6
C von Karman constant
      xkar=0.4 _d 0
C periodic forcing
      periodicExternalForcing_cheap = periodicExternalForcing
      externForcingPeriod_cheap = externForcingPeriod
      externForcingCycle_cheap = externForcingCycle
C precipitation time constant
      cheap_pr1 = 2*3600.0 _d 0
      cheap_pr2 = 36*3600.0 _d 0

C-    Retired parameters: initialised to unlikely value:
      nRetired = 0
      cheapaml_taurelax = UNSET_RL
      cheapaml_taurelaxocean = UNSET_RL

C-    Input data files names :
      AirTempFile=' '
      AirQFile=' '
      SolarFile=' '
      UWindFile=' '
      VWindFile=' '
      TrFile=' '
      QrFile=' '
      WaveHFile=' '
      WavePFile=' '
      TracerFile=' '
      TracerRFile=' '
      cheapMaskFile=' '
      cheap_hFile =' '
      cheap_prFile =' '
      cheap_clFile =' '
      cheap_dlwFile =' '
      FluxFormula='COARE3'
      WaveModel='Smith'

C-    Assumes domain (with land) is periodic in both direction
C      (consitent with default EXCH setting)
c     cheapamlXperiodic = .TRUE.
c     cheapamlYperiodic = .TRUE.
C note: for backward compatibility, switch to non periodic domain:
      cheapamlXperiodic = .FALSE.
      cheapamlYperiodic = .FALSE.

C-    e-p option turned off by default
      useFreshWaterFlux=.TRUE.

C-    turn off flux limiting advection by default
      useFluxLimit=.FALSE.

C-    turn off stress option by default
      useStressOption=.FALSE.

C-    turn off passive tracer option by default
      useCheapTracer=.FALSE.

C-    turn off time varying BL height option by default
      useTimeVarBLH=.FALSE.

C-    turn off clouds option by default
      useClouds=.FALSE.

C-    use imported downward longwave
      useDLongWave=.FALSE.

C-    use imported precip
      usePrecip=.FALSE.

C-    use relative wind
      useRelativeWind=.FALSE.

C--   Read parameters from open data file
      READ(UNIT=iUnit,NML=CHEAPAML_CONST)
      WRITE(msgBuf,'(A)') ' CHEAPAML_READPARMS: read CHEAPAML_CONST'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )

C--   Read parameters from open data file
      READ(UNIT=iUnit,NML=CHEAPAML_PARM01)
      WRITE(msgBuf,'(A)') ' CHEAPAML_READPARMS: read CHEAPAML_PARM01'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )

C--   Read parameters from open data file
      READ(UNIT=iUnit,NML=CHEAPAML_PARM02)
      WRITE(msgBuf,'(A)') ' CHEAPAML_READPARMS: read CHEAPAML_PARM02'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )

C--   Close the open data file
#ifdef SINGLE_DISK_IO
      CLOSE(iUnit)
#else
      CLOSE(iUnit,STATUS='DELETE')
#endif /* SINGLE_DISK_IO */
C compute derivative values
C energy flux conversion factor
        xef=1. _d 0 /rhoa/cpair
C inverse of layer thickness
        hm=1. _d 0/cheapaml_h

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
      iUnit = standardMessageUnit
      WRITE(iUnit,*) 'Caml: ntim     =',cheapaml_ntim
      WRITE(iUnit,*) 'Caml: mask_w   =',cheapaml_mask_width
      WRITE(iUnit,*) 'Caml: h        =',cheapaml_h
      WRITE(iUnit,*) 'Caml: kdiff    =',cheapaml_kdiff
      WRITE(iUnit,*) 'Caml: tauRelax =', cheap_tauRelax, ' (s)'
      WRITE(iUnit,*) 'Caml: tRelaxOce=', cheap_tauRelaxOce,' (s)'
      WRITE(iUnit,*) 'Caml: rhoa     =',rhoa
      WRITE(iUnit,*) 'Caml: cpair    =',cpair
      WRITE(iUnit,*) 'Caml: stefan   =',stefan
      WRITE(iUnit,*) 'Caml: cheapamlXperiodic  =',cheapamlXperiodic
      WRITE(iUnit,*) 'Caml: cheapamlYperiodic  =',cheapamlYperiodic
      WRITE(iUnit,*) 'Caml: useFreshWaterFlux  =',useFreshWaterFlux
      WRITE(iUnit,*) 'Caml: useFluxLimit       =',useFluxLimit
      WRITE(iUnit,*) 'Caml: useStressOption    =',useStressOption
      WRITE(iUnit,*) 'Caml: useCheapTracer     =',useCheapTracer
      WRITE(iUnit,*) 'Caml: useTimeVarBLH      =',useTimeVarBLH
      WRITE(iUnit,*) 'Caml: useClouds          =',useClouds
      WRITE(iUnit,*) 'Caml: useDlongwave       =',useDLongWave
      WRITE(iUnit,*) 'Caml: usePrecip          =',usePrecip
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      IF ( cheapaml_taurelax .NE. UNSET_RL ) THEN
        nRetired = nRetired + 1
        WRITE(msgBuf,'(2A)')
     &   'S/R CHEAPAML_READPARMS: "cheapaml_taurelax" no longer'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(2A)')
     &   'S/R CHEAPAML_READPARMS:  allowed in file "data.cheapaml"'
        CALL PRINT_ERROR( msgBuf, myThid )
      ENDIF
      IF ( cheapaml_taurelaxocean .NE. UNSET_RL ) THEN
        nRetired = nRetired + 1
        WRITE(msgBuf,'(2A)')
     &   'S/R CHEAPAML_READPARMS: "cheapaml_taurelaxocean" no longer'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(2A)')
     &   'S/R CHEAPAML_READPARMS:  allowed in file "data.cheapaml"'
        CALL PRINT_ERROR( msgBuf, myThid )
      ENDIF

      IF ( nRetired .GT. 0 ) THEN
       WRITE(msgBuf,'(2A)') 'S/R CHEAPAML_READPARMS: ',
     &  'Error reading file "data.cheapaml":'
       CALL PRINT_ERROR( msgBuf, myThid )
       WRITE(msgBuf,'(I4,A)') nRetired,
     &      ' out-of-date parameters were found in the namelist(s)'
       CALL PRINT_ERROR( msgBuf, myThid )
c      errCount = errCount + 1
       CALL ALL_PROC_DIE( 0 )
       STOP 'ABNORMAL END: S/R CHEAPAML_READPARMS'
      ENDIF

      _END_MASTER(myThid)

C--   Everyone else must wait for the parameters to be loaded
      _BARRIER

      RETURN
      END

#include "PACKAGES_CONFIG.h"
#include "CPP_EEOPTIONS.h"

C--   File global_sum_singlecpu.F: Routines that perform global sum
C                                  on a single CPU
C--    Contents
C--    o GLOBAL_SUM_SINGLECPU_RL
C--    o GLOBAL_SUM_SINGLECPU_RS <- not yet coded

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: GLOBAL_SUM_SINGLECPU_RL

C     !INTERFACE:
      SUBROUTINE GLOBAL_SUM_SINGLECPU_RL(
     I                       phiLocal,
     O                       sumPhi,
     I                       oLi, oLj, myThid )
      IMPLICIT NONE
C     !DESCRIPTION:
C     *==========================================================*
C     | SUBROUTINE GLOBAL\_SUM\_SINGLECPU\_RL
C     | o Handle sum for _RL data.
C     *==========================================================*
C     | Global sum of 2d array
C     | independent of tiling as sum is performed on a single CPU
C     | sum is performed in REAL*8
C     *==========================================================*

C     !USES:
C     == Global data ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "EESUPPORT.h"
#include "GLOBAL_SUM.h"
#ifdef ALLOW_EXCH2
#include "W2_EXCH2_SIZE.h"
#include "W2_EXCH2_TOPOLOGY.h"
#endif
#include "EEBUFF_SCPU.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     phiLocal :: local input array without overlap regions.
C     sumPhi   :: Result of sum.
C     oLi, oLj :: overlap size of input array in I & J direction.
C     myThid   :: My thread id.
      INTEGER oLi, oLj
      _RL    phiLocal(1-oLi:sNx+oLi,1-oLj:sNy+oLj,nSx,nSy)
      _RL     sumPhi
      INTEGER myThid

C     !LOCAL VARIABLES:
C     == Local variables ==
C- type declaration of: sumAll, globalBuf :
C         sumAll needs to have the same length as MPI_DOUBLE_PRECISION
      LOGICAL useExch2GlobLayOut, zeroBuff
      INTEGER xSize, ySize
      INTEGER i, j, ij
      INTEGER bi, bj
      Real*8  sumAll
#ifdef ALLOW_USE_MPI
      INTEGER pId, idest, itag
      INTEGER istatus(MPI_STATUS_SIZE), ierr
#endif /* ALLOW_USE_MPI */
CEOP

#ifdef ALLOW_EXCH2
      zeroBuff = .TRUE.
      useExch2GlobLayOut = .TRUE.
      xSize = exch2_global_Nx
      ySize = exch2_global_Ny
#else /* ALLOW_EXCH2 */
      zeroBuff = .FALSE.
      useExch2GlobLayOut = .FALSE.
      xSize = Nx
      ySize = Ny
#endif /* ALLOW_EXCH2 */
#ifdef ALLOW_USE_MPI
      idest = 0
      itag  = 0
#endif

C--   copy (and conversion to real*8) to Shared buffer:
      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
        DO j=1,sNy
         DO i=1,sNx
           sharedLocBuf_r8(i,j,bi,bj) = phiLocal(i,j,bi,bj)
         ENDDO
        ENDDO
       ENDDO
      ENDDO

C--   Master thread does the communications and the global sum
C--   Master thread cannot start until everyone is ready:
      CALL BAR2( myThid )
      _BEGIN_MASTER( myThid )

C--   Gather local arrays
      CALL GATHER_2D_R8(
     O                       xy_buffer_r8,
     I                       sharedLocBuf_r8,
     I                       xSize, ySize,
     I                       useExch2GlobLayOut, zeroBuff, myThid )

      IF ( myProcId.EQ.0 ) THEN

C--   Process 0 sums the global array
        sumAll = 0. _d 0
        DO ij=1,xSize*ySize
          sumAll = sumAll + xy_buffer_r8(ij)
        ENDDO

#ifdef ALLOW_USE_MPI
C--   Process 0 sends result to all other processes
        IF ( usingMPI ) THEN
         DO pId = 1, (nPx*nPy)-1
          CALL MPI_SEND (sumAll, 1, MPI_DOUBLE_PRECISION,
     &                   pId, itag, MPI_COMM_MODEL, ierr)
         ENDDO
        ENDIF

      ELSEIF ( usingMPI ) THEN

C--   All proceses except 0 receive result from process 0
          CALL MPI_RECV (sumAll, 1, MPI_DOUBLE_PRECISION,
     &         idest, itag, MPI_COMM_MODEL, istatus, ierr)

#endif /* ALLOW_USE_MPI */

      ENDIF

C--   Write solution to shared buffer (all threads can see it)
      phiGSR8(1,0) = sumAll

      _END_MASTER( myThid )
C--   Everyone wait for Master thread to be ready
      CALL BAR2( myThid )

C--   set result for every threads
      sumPhi = phiGSR8(1,0)

      RETURN
      END

!=======================================================================
      subroutine couprecv_i4vec( component, dataname, length, vecFld )
      implicit none
! Predefined constants/arrays
#include "CPLR_SIG.h"
! MPI variables
#include "mpif.h"
! Arguments
      character*(*) component
      character*(*) dataname
      integer length
      integer vecFld(length)
! Functions
      integer mitcplr_match_comp
      integer generate_tag
      external mitcplr_match_comp
      external generate_tag
! Local
      integer count,dtype,rank,tag,comm,ierr
      integer stat(MPI_STATUS_SIZE)
      integer compind, numprocs
      integer i, j, n, ndiff
      integer ibuf(MAX_IBUF)
!     ------------------------------------------------------------------

      if ( 1+length .gt. MAX_IBUF )
     &    STOP 'couprecv_i4vec: length exceeds MAX_IBUF'

! Establish who I am communicating with
      compind = mitcplr_match_comp( component )
      if (compind.le.0) STOP 'couprecv_i4vec: Bad component id'
      comm = MPI_COMM_compcplr( compind )
      numprocs = num_component_procs(compind)
      if (numprocs.lt.1) then
        write(LogUnit,*) 'couprecv_i4vec: compind = ',compind
        STOP 'couprecv_i4vec: numprocs < 1'
      endif
      if (VERB)
     &  write(LogUnit,*) 'couprecv_i4vec: ',component_Name(compind)
      if (VERB)
     &  write(LogUnit,*) 'couprecv_i4vec: dataname=',dataname

! Foreach component process
      do n=1,numprocs

! Receive message
       count = MAX_IBUF
       dtype = MPI_INTEGER
       tag = generate_tag( 115, n, dataname)
       rank = rank_component_procs(n,compind)

       if (VERB) then
        write(LogUnit,*)
     &    'couprecv_i4vec: calling MPI_Recv rank=',rank,
     &    ' proc=',n,'/',numprocs
        call flush(LogUnit)
       endif
       call MPI_Recv(ibuf, count, dtype, rank, tag, comm, stat, ierr)
       if (VERB) then
        write(LogUnit,*) 'couprecv_i4vec: returned ierr=',ierr
        call flush(LogUnit)
       endif

       if (ierr.ne.0) then
        write(LogUnit,*) 'couprecv_i4vec: rank(W,G)=',
     &            my_rank_in_world,my_rank_in_global,
     &            ' ierr=',ierr
        STOP 'couprecv_i4vec: MPI_Recv failed'
       endif

! Check header
       j = ibuf(1)

       if ( j.ne.length ) then
        write(LogUnit,*) 'couprecv_i4vec: length,header=', length, j
        STOP 'couprecv_i4vec: Incompatible header'
       endif

! Extract data
       if ( n.eq.1 ) then
         do i=1,length
           vecFld(i) = ibuf(i+1)
         enddo
       else
         ndiff = 0
         do i=1,length
           if  ( vecFld(i) .ne. ibuf(i+1) ) ndiff = ndiff + 1
         enddo
         if ( ndiff.gt.0 ) then
           write(LogUnit,'(A,I8,2A)')
     &      ' couprecv_i4vec: length=', length, ' name=', dataname
           write(LogUnit,'(A,I6,A,I8,A)')
     &      ' from proc=', n ,' : found', ndiff, ' differences (vs 1)'
         endif
       endif

      enddo ! n

!     ------------------------------------------------------------------
      return
      end
!=======================================================================

#include "CPP_EEOPTIONS.h"

CBOP
C     !ROUTINE: GET_PERIODIC_INTERVAL

C     !INTERFACE:
      SUBROUTINE GET_PERIODIC_INTERVAL(
     O               tRec0, tRec1, tRec2, wght1, wght2,
     I               cycleLength, recSpacing, deltaT,
     I               currentTime, myThid )

C     !DESCRIPTION:
C     *==========================================================*
C     | SUBROUTINE GET\_PERIODIC\_INTERVAL
C     | o Provide time-record indices arround current time
C     |   from a periodic, regularly spaced, time sequence
C     | o Extended to non-periodic, regularly spaced, time
C     |   sequence (case cycleLength=0) as in pkg/rbcs
C     *==========================================================*
C     | From a regularly-spaced sequence of time records
C     | this routine returns the index of the two records
C     | surrounding the current time and the record index of
C     | corresponding to the previous time-step ; also provides
C     | the weighting factor for a linear interpolation
C     *==========================================================*

C     !USES:
      IMPLICIT NONE
#include "EEPARAMS.h"

C     !INPUT PARAMETERS:
C     cycleLength :: length of the periodic cycle (in s), zero if non-periodic
C     recSpacing  :: time record spacing
C     deltaT      :: time-step
C     currentTime :: current time
C     myThid      :: my Thread Id number
      _RL      cycleLength, recSpacing, deltaT, currentTime
      INTEGER  myThid
C     !OUTPUT PARAMETERS:
C     tRec0       :: time-record intex corresponding to the previous time-step
C     tRec1       :: 1rst time-record intex just before current time
C     tRec2       ::  2nd time-record intex just after current time
C     wght1       :: linear interpolation weight (applies to 1rst record)
C     wght2       :: linear interpolation weight (applies to 2nd  record)
      INTEGER  tRec0, tRec1, tRec2
      _RL      wght1, wght2

C     !LOCAL VARIABLES:
C     == Local variables ==
C     nbRec       :: number of time-records
C     msgBuf      :: Informational/error message buffer
      INTEGER  nbRec
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      _RL      locTime, modTime, tmpTime
CEOP

C     Implicit function:
      _RL F90MODULO, arg1, arg2
C statement function to emulate Fortran 90 MODULO
C this modulo has the same sign as arg2 (and absolute value < |arg2|)
      F90MODULO(arg1,arg2) = MOD(MOD(arg1,arg2)+arg2,arg2)

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      tRec0 = 0
      tRec1 = 0
      tRec2 = 0
      wght1 = 0.
      wght2 = 0.

      IF ( cycleLength.LT.0. .OR.
     &     recSpacing .LE.0. ) THEN
        IF ( cycleLength.LT.0. ) WRITE(msgBuf,'(A)')
     &      'GET_PERIODIC_INTERVAL requires cycleLength >= 0'
        IF ( recSpacing .LE.0. ) WRITE(msgBuf,'(A)')
     &      'GET_PERIODIC_INTERVAL requires recSpacing > 0'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(A,2(A,1PE16.8))') 'GET_PERIODIC_INTERVAL: ',
     &     'cycleLength=', cycleLength, ' , recSpacing=', recSpacing
        CALL PRINT_ERROR( msgBuf, myThid )
        STOP 'ABNORMAL END: S/R GET_PERIODIC_INTERVAL'
      ELSE
        nbRec = NINT(cycleLength/recSpacing)
      ENDIF
      tmpTime = nbRec*recSpacing
      IF ( cycleLength.NE.tmpTime ) THEN
        WRITE(msgBuf,'(2A,I5,A)') 'GET_PERIODIC_INTERVAL: ',
     &     'cycleLength not multiple of recSpacing:'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(A,2(A,1PE16.8))') 'GET_PERIODIC_INTERVAL: ',
     &     'cycleLength=', cycleLength, ' , recSpacing=', recSpacing
        CALL PRINT_ERROR( msgBuf, myThid )
        STOP 'ABNORMAL END: S/R GET_PERIODIC_INTERVAL'
      ENDIF

      IF ( cycleLength.EQ.0. _d 0 ) THEN
C--   Non-periodic time-record sequence:

        locTime = currentTime - recSpacing*0.5
        modTime = F90MODULO(locTime,recSpacing)

C-    time-record before (tRec1) and after (tRec2) current time:
        tRec1 = 1 + NINT( (locTime-modTime)/recSpacing )
        tRec2 = 1 + tRec1

C-    linear interpolation weights:
        wght2 = modTime / recSpacing
        wght1 = 1. _d 0 - wght2

C-    previous time-step record:
        locTime = locTime-deltaT
        modTime = F90MODULO( locTime, recSpacing )
        tRec0 = 1 + NINT( (locTime-modTime)/recSpacing )

      ELSE
C--   Periodic time-record sequence:

        locTime = currentTime - recSpacing*0.5
     &          + cycleLength*( 2 - NINT(currentTime/cycleLength) )

C-    time-record before (tRec1) and after (tRec2) current time:
        tmpTime = MOD( locTime, cycleLength )
        tRec1 = 1 + INT( tmpTime/recSpacing )
        tRec2 = 1 + MOD( tRec1, nbRec )

C-    linear interpolation weights:
        wght2 = ( tmpTime - recSpacing*(tRec1 - 1) )/recSpacing
        wght1 = 1. _d 0 - wght2

C-    previous time-step record:
        tmpTime = MOD( locTime-deltaT, cycleLength )
        tRec0 = 1 + INT(tmpTime/recSpacing)

      ENDIF

      RETURN
      END

#include "CPP_EEOPTIONS.h"
#include "W2_OPTIONS.h"

CBOP 0
C !ROUTINE: W2_SET_MAP_CUMSUM

C !INTERFACE:
      SUBROUTINE W2_SET_MAP_CUMSUM( myThid )

C     !DESCRIPTION:
C     Set-up mapping for global cumulated sum.

C     !USES:
      IMPLICIT NONE

C      Tile topology settings data structures
#include "SIZE.h"
#include "EEPARAMS.h"
#include "W2_EXCH2_SIZE.h"
#include "W2_EXCH2_PARAMS.h"
#include "W2_EXCH2_TOPOLOGY.h"

C     !INPUT PARAMETERS:
C     myThid  :: my Thread Id number
C               (Note: not relevant since threading has not yet started)
      INTEGER myThid

C     !LOCAL VARIABLES:
C     === Local variables ===
C     facetXYSum   :: Tile to Facet Matrix for facet-Increment in X & Y dir.
C     facet_CSum   :: Tile to Facet Matrix for CumSum @ facet-origin
C     msgBuf       :: Informational/error message buffer
      INTEGER fNx, fNy, nbTx, nbTy
      INTEGER nActiveFacets
      INTEGER fCnt, prev_fCnt
      INTEGER npass, nType
      LOGICAL prtFlag
      LOGICAL fIsSet(0:W2_maxNbFacets)
      INTEGER tN, i, j, k, ii, jj
#ifdef W2_CUMSUM_USE_MATRIX
      INTEGER tS, bi, bj, l, is, ie
      INTEGER facetXYSum(2,W2_maxNbTiles,W2_maxNbFacets)
      INTEGER facet_CSum(2,W2_maxNbTiles,W2_maxNbFacets)
#endif
      CHARACTER*(MAX_LEN_MBUF) msgBuf
CEOP
c      DATA edge / 'N' , 'S' , 'E' , 'W' /

      WRITE(msgBuf,'(2A)') 'W2_SET_MAP_CUMSUM: ',
     &       'setting Facet Matrix for CUMUL-SUM'
      CALL PRINT_MESSAGE( msgBuf, W2_oUnit, SQUEEZE_RIGHT, myThid )
      prtFlag = ABS(W2_printMsg).GE.2
     &       .OR. ( W2_printMsg .NE.0 .AND. myProcId.EQ.0 )

C--   Initialise Common-block
      W2_tMC1 = 0
      W2_tMC2 = 0
      DO j=1,W2_maxNbFacets
       DO i=1,W2_maxNbFacets
         W2_cumSum_facet(1,i,j) = 0
         W2_cumSum_facet(2,i,j) = 0
       ENDDO
      ENDDO
#ifdef W2_CUMSUM_USE_MATRIX
      DO j=1,W2_maxNbTiles
       DO i=1,W2_maxNbTiles
         W2_cumSum_tiles(1,i,j) = 0
         W2_cumSum_tiles(2,i,j) = 0
       ENDDO
      ENDDO
#endif /* W2_CUMSUM_USE_MATRIX */

C--   Start setting cumul-sum Face mapping
      fCnt = 0
      fIsSet(0) = .TRUE.
      DO j=1,nFacets
        fIsSet(j) = .FALSE.
      ENDDO

C--   Start with first non-empty face:
      nActiveFacets = 0
      DO j=1,nFacets
        IF ( facet_dims(2*j-1)*facet_dims(2*j).GE.1 ) THEN
          nActiveFacets = nActiveFacets + 1
          IF ( fCnt.EQ.0 ) THEN
            fIsSet(j) = .TRUE.
            fCnt = 1
            IF ( ABS(W2_printMsg).GE.2 ) WRITE(W2_oUnit,'(A,I4)')
     &        ' CumSum starts @ SW.corner of facet #', j
          ENDIF
        ENDIF
      ENDDO

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C--   Go through list of connections:
      prev_fCnt = 0
      npass = 0
      DO WHILE ( fCnt.GT.prev_fCnt )
       npass = npass + 1
       prev_fCnt = fCnt
       DO nType=1,3
        IF ( fCnt.EQ.prev_fCnt ) THEN
         DO j=1,nFacets
          IF ( fIsSet(j) ) THEN
           DO i=1,4
C-    connected to:
            jj = INT(facet_link(i,j))
            ii = MOD( NINT(facet_link(i,j)*10.), 10 )
C--   1) with same orientation ( N <-> S or E <-> W ), forward progression
            IF ( .NOT.fIsSet(jj) .AND. nType.EQ.1 ) THEN
C-    N <-- S ;
             IF ( i.EQ.W2_NORTH .AND. ii.EQ.W2_SOUTH ) THEN
              DO k=1,nFacets
               W2_cumSum_facet(1,k,jj) = W2_cumSum_facet(1,k,j)
               W2_cumSum_facet(2,k,jj) = W2_cumSum_facet(2,k,j)
              ENDDO
              W2_cumSum_facet(2,j,jj) = W2_cumSum_facet(2,j,jj) + 1
              fCnt = fCnt + 1
              fIsSet(jj) = .TRUE.
              IF ( ABS(W2_printMsg).GE.2 ) WRITE(W2_oUnit,'(5(A,I4))')
     &         ' CumSum SW.corner of facet #', jj,' set from facet',j,
     &         ' (pass,type=', npass,',', nType,')'
             ENDIF
C-    E <-- W ;
             IF ( i.EQ.W2_EAST .AND. ii.EQ.W2_WEST ) THEN
              DO k=1,nFacets
               W2_cumSum_facet(1,k,jj) = W2_cumSum_facet(1,k,j)
               W2_cumSum_facet(2,k,jj) = W2_cumSum_facet(2,k,j)
              ENDDO
              W2_cumSum_facet(1,j,jj) = W2_cumSum_facet(1,j,jj) + 1
              fCnt = fCnt + 1
              fIsSet(jj) = .TRUE.
              IF ( ABS(W2_printMsg).GE.2 ) WRITE(W2_oUnit,'(5(A,I4))')
     &         ' CumSum SW.corner of facet #', jj,' set from facet',j,
     &         ' (pass,type=', npass,',', nType,')'
             ENDIF
            ENDIF
C--   2) with same orientation ( N <-> S or E <-> W ), backward progression
            IF ( .NOT.fIsSet(jj) .AND. nType.EQ.2 ) THEN
C-    S <-- N ;
             IF ( i.EQ.W2_SOUTH .AND. ii.EQ.W2_NORTH ) THEN
              DO k=1,nFacets
               W2_cumSum_facet(1,k,jj) = W2_cumSum_facet(1,k,j)
               W2_cumSum_facet(2,k,jj) = W2_cumSum_facet(2,k,j)
              ENDDO
              W2_cumSum_facet(2,jj,jj) = W2_cumSum_facet(2,jj,jj) - 1
              fCnt = fCnt + 1
              fIsSet(jj) = .TRUE.
              IF ( ABS(W2_printMsg).GE.2 ) WRITE(W2_oUnit,'(5(A,I4))')
     &         ' CumSum SW.corner of facet #', jj,' set from facet',j,
     &         ' (pass,type=', npass,',', nType,')'
             ENDIF
C-    W <-- E ;
             IF ( i.EQ.W2_WEST .AND. ii.EQ.W2_EAST ) THEN
              DO k=1,nFacets
               W2_cumSum_facet(1,k,jj) = W2_cumSum_facet(1,k,j)
               W2_cumSum_facet(2,k,jj) = W2_cumSum_facet(2,k,j)
              ENDDO
              W2_cumSum_facet(1,jj,jj) = W2_cumSum_facet(1,jj,jj) - 1
              fCnt = fCnt + 1
              fIsSet(jj) = .TRUE.
              IF ( ABS(W2_printMsg).GE.2 ) WRITE(W2_oUnit,'(5(A,I4))')
     &         ' CumSum SW.corner of facet #', jj,' set from facet',j,
     &         ' (pass,type=', npass,',', nType,')'
             ENDIF
            ENDIF
C--   3) with different orientation ( N <-> W or S <-> E )
C- Note: cannot rely on these connections for Cumul-Sum @ grid-cell center
            IF ( .NOT.fIsSet(jj) .AND. nType.EQ.3
     &                           .AND. fCnt.EQ.prev_fCnt ) THEN
C-    N <-- W or W <-- N ;
             IF (  ( i.EQ.W2_NORTH .AND. ii.EQ.W2_WEST  ) .OR.
     &             ( i.EQ.W2_WEST  .AND. ii.EQ.W2_NORTH ) ) THEN
              DO k=1,nFacets
               W2_cumSum_facet(1,k,jj) = W2_cumSum_facet(1,k,j)
               W2_cumSum_facet(2,k,jj) = W2_cumSum_facet(2,k,j)
              ENDDO
              W2_cumSum_facet(2,j, jj) = W2_cumSum_facet(2,j, jj) + 1
              W2_cumSum_facet(2,jj,jj) = W2_cumSum_facet(2,jj,jj) - 1
              fCnt = fCnt + 1
              fIsSet(jj) = .TRUE.
              IF ( ABS(W2_printMsg).GE.2 ) WRITE(W2_oUnit,'(5(A,I4))')
     &         ' CumSum SW.corner of facet #', jj,' set from facet',j,
     &         ' (pass,type=', npass,',', nType,')'
             ENDIF
C-    E <-- S or S <-- E ;
             IF (  ( i.EQ.W2_EAST  .AND. ii.EQ.W2_SOUTH ) .OR.
     &             ( i.EQ.W2_SOUTH .AND. ii.EQ.W2_EAST  ) ) THEN
              DO k=1,nFacets
               W2_cumSum_facet(1,k,jj) = W2_cumSum_facet(1,k,j)
               W2_cumSum_facet(2,k,jj) = W2_cumSum_facet(2,k,j)
              ENDDO
              W2_cumSum_facet(1,j, jj) = W2_cumSum_facet(1,j, jj) + 1
              W2_cumSum_facet(1,jj,jj) = W2_cumSum_facet(1,jj,jj) - 1
              fCnt = fCnt + 1
              fIsSet(jj) = .TRUE.
              IF ( ABS(W2_printMsg).GE.2 ) WRITE(W2_oUnit,'(5(A,I4))')
     &         ' CumSum SW.corner of facet #', jj,' set from facet',j,
     &         ' (pass,type=', npass,',', nType,')'
             ENDIF
            ENDIF
C          end i loop
           ENDDO
          ENDIF
C        end facets loop
         ENDDO
         IF ( fCnt.GT.prev_fCnt ) THEN
          WRITE(msgBuf,'(2A,3(I4,A),I2,A)') 'W2_SET_MAP_CUMSUM: ',
     &     'set ', fCnt - prev_fCnt, ' /', nActiveFacets,
     &     ' active facets (pass,type=', npass, ',', nType, ')'
          CALL PRINT_MESSAGE( msgBuf, W2_oUnit, SQUEEZE_RIGHT, myThid )
         ENDIF
        ENDIF
C      end nType loop
       ENDDO
C-    end do while (npass count)
      ENDDO
      IF ( fCnt.LT.nActiveFacets ) THEN
        WRITE(msgBuf,'(2A,2(I4,A))') 'W2_SET_MAP_CUMSUM: ',
     &  'Only get', fCnt, ' /', nActiveFacets,' active facets done'
        CALL PRINT_MESSAGE( msgBuf, W2_oUnit, SQUEEZE_RIGHT, myThid )
        WRITE(msgBuf,'(2A)') '** WARNING ** W2_SET_MAP_CUMSUM: ',
     &    ' missing connections in Cumulated Sum'
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
      ENDIF
      IF ( myProcId.EQ.0 ) THEN
        WRITE(W2_oUnit,'(2A,2(I4,A))')' Facet Matrix for CUMUL-SUM (',
     &         'nFacets=',nFacets, ', nActive=', nActiveFacets, ' ):'
        DO j=1,nFacets
          WRITE(W2_oUnit,'(A,I3,A,30(2I3,A))') '- facet', j, ' :',
     &         (W2_cumSum_facet(1,i,j),W2_cumSum_facet(2,i,j),' ,',
     &                                 i=1,nFacets)
        ENDDO
      ENDIF

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C--   record "missing corner" tile

      IF ( useCubedSphereExchange ) THEN
       DO j=1,nFacets
        fNx = facet_dims(2*j-1)
        fNy = facet_dims( 2*j )
        IF ( fNx*fNy .GE. 1 ) THEN
         nbTx = fNx/sNx
         nbTy = fNy/sNy
         tN = facet_owns(1,j) - 1 + nbTx
         IF ( W2_tMC2.EQ.0 .AND. MOD(j,2).EQ.0
     &                     .AND. exch2_myFace(tN).NE.0 ) W2_tMC2 = tN
         tN = facet_owns(1,j) + (nbTy-1)*nbTx
         IF ( W2_tMC1.EQ.0 .AND. MOD(j,2).EQ.1
     &                     .AND. exch2_myFace(tN).NE.0 ) W2_tMC1 = tN
        ENDIF
       ENDDO
       IF ( myProcId.EQ.0 ) WRITE(W2_oUnit,'(3(A,I8))')
     &   ' missing-corner Tile for CUMUL-SUM (nTiles=', exch2_nTiles,
     &   ' ): W2_tMC1=', W2_tMC1, ' , W2_tMC2=', W2_tMC2
      ENDIF

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C--   Now Set cumul-sum Tile mapping

#ifdef W2_CUMSUM_USE_MATRIX
      DO j=1,W2_maxNbFacets
       DO i=1,W2_maxNbTiles
        facetXYSum(1,i,j) = 0
        facetXYSum(2,i,j) = 0
        facet_CSum(1,i,j) = 0
        facet_CSum(2,i,j) = 0
       ENDDO
      ENDDO

C-    First within each face:
      DO j=1,nFacets
       fNx = facet_dims(2*j-1)
       fNy = facet_dims( 2*j )
       IF ( fNx*fNy .GE. 1 ) THEN
        nbTx = fNx/sNx
        nbTy = fNy/sNy

        DO bj=1,nbTy
         DO bi=1,nbTx-1
           tS = facet_owns(1,j) - 1 + bi
           tN = tS + 1 + (bj-1)*nbTx
           DO k=facet_owns(1,j),tS
            W2_cumSum_tiles(1,k,tN) = 1
           ENDDO
         ENDDO
        ENDDO
        tN = facet_owns(1,j) - 1 + nbTx
        facetXYSum(1,tN,j) = 1
        DO k=facet_owns(1,j),tN-1
          facetXYSum(1,k,j) = W2_cumSum_tiles(1,k,tN)
        ENDDO

        DO bj=1,nbTy-1
         DO bi=1,nbTx
          tS = facet_owns(1,j) - 1 + bi
          tN = tS + bj*nbTx
          DO k=1,bj
           l = tS + (k-1)*nbTx
           W2_cumSum_tiles(2,l,tN) = 1
          ENDDO
         ENDDO
        ENDDO
        tN = facet_owns(1,j) + (nbTy-1)*nbTx
        facetXYSum(2,tN,j) = 1
        DO k=facet_owns(1,j),tN-1
          facetXYSum(2,k,j) = W2_cumSum_tiles(2,k,tN)
        ENDDO

       ENDIF
      ENDDO

C-    Then across facet:
      DO j=1,nFacets
       DO k=1,exch2_nTiles
        DO i=1,nFacets
        facet_CSum(1,k,j) = facet_CSum(1,k,j)
     &                    + W2_cumSum_facet(1,i,j)*facetXYSum(1,k,i)
        facet_CSum(2,k,j) = facet_CSum(2,k,j)
     &                    + W2_cumSum_facet(2,i,j)*facetXYSum(2,k,i)
        ENDDO
       ENDDO
      ENDDO

C-    Finally, account for cumulated sum at facet origin:
      DO j=1,nFacets
       DO tN=facet_owns(1,j),facet_owns(2,j)
        DO k=1,exch2_nTiles
         W2_cumSum_tiles(1,k,tN) = W2_cumSum_tiles(1,k,tN)
     &                           + facet_CSum(1,k,j)
         W2_cumSum_tiles(2,k,tN) = W2_cumSum_tiles(2,k,tN)
     &                           + facet_CSum(2,k,j)
        ENDDO
       ENDDO
      ENDDO

      IF (prtFlag) THEN
       WRITE(W2_oUnit,'(A,I8,A)')
     &    ' Tile Matrix for CUMUL-SUM (nTiles=', exch2_nTiles, ' ):'
       DO j=1,exch2_nTiles
        DO is=1,exch2_nTiles,10
         ie = MIN(is+9,exch2_nTiles)
         IF ( is.EQ.1 ) THEN
          WRITE(W2_oUnit,'(3(I8,A),10(2I3,A))') j,' ,',is,' ->',ie,' :',
     &     (W2_cumSum_tiles(1,i,j),W2_cumSum_tiles(2,i,j),' ,',i=is,ie)
         ELSE
          WRITE(W2_oUnit,'(8X,2(I8,A),10(2I3,A))') is,' ->',ie,' :',
     &     (W2_cumSum_tiles(1,i,j),W2_cumSum_tiles(2,i,j),' ,',i=is,ie)
         ENDIF
        ENDDO
       ENDDO
      ENDIF

      WRITE(msgBuf,'(2A)') 'W2_SET_MAP_CUMSUM: ',
     &  'setting Tile Matrix for CUMUL-SUM : done'
      CALL PRINT_MESSAGE( msgBuf, W2_oUnit, SQUEEZE_RIGHT, myThid )

#else /* W2_CUMSUM_USE_MATRIX */
      WRITE(msgBuf,'(2A)') 'W2_SET_MAP_CUMSUM: ',
     &  'done (skip Tile Matrix setting)'
      CALL PRINT_MESSAGE( msgBuf, W2_oUnit, SQUEEZE_RIGHT, myThid )
#endif /* W2_CUMSUM_USE_MATRIX */

      RETURN
      END

#include "BBL_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: BBL_READ_PICKUP

C     !INTERFACE:
      SUBROUTINE BBL_READ_PICKUP( myIter, myThid )

C     !DESCRIPTION:
C     Reads current state of BBL from a pickup file

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "BBL.h"

C     !INPUT PARAMETERS:
C     myIter            :: time-step number
C     myThid            :: thread number
      INTEGER myIter
      INTEGER myThid

#ifdef ALLOW_BBL

C     !LOCAL VARIABLES:
C     fn          :: character buffer for creating filename
C     fp          :: precision of pickup files
C     filePrec    :: pickup-file precision (read from meta file)
C     nbFields    :: number of fields in pickup file (read from meta file)
C     missFldList :: List of missing fields   (attempted to read but not found)
C     missFldDim  :: Dimension of missing fields list array: missFldList
C     nMissing    :: Number of missing fields (attempted to read but not found)
C     j           :: loop index
C     nj          :: record number
C     ioUnit      :: temp for writing msg unit
C     msgBuf      :: Informational/error message buffer
      INTEGER fp
      INTEGER filePrec, nbFields
      INTEGER missFldDim, nMissing
      INTEGER j, nj, ioUnit
      PARAMETER( missFldDim = 3 )
      CHARACTER*(10) suff
      CHARACTER*(MAX_LEN_FNAM) fn
      CHARACTER*(8) missFldList(missFldDim)
      CHARACTER*(MAX_LEN_MBUF) msgBuf
CEOP

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

       IF ( pickupSuff.EQ.' ' ) THEN
        IF ( rwSuffixType.EQ.0 ) THEN
          WRITE(fn,'(A,I10.10)') 'pickup_bbl.', myIter
        ELSE
          CALL RW_GET_SUFFIX( suff, startTime, myIter, myThid )
          WRITE(fn,'(A,A)') 'pickup_bbl.', suff
        ENDIF
       ELSE
        WRITE(fn,'(A,A10)') 'pickup_bbl.', pickupSuff
       ENDIF
       fp = precFloat64

       CALL READ_MFLDS_SET(
     I                      fn,
     O                      nbFields, filePrec,
     I                      Nr, myIter, myThid )
       _BEGIN_MASTER( myThid )
c      IF ( filePrec.NE.0 .AND. filePrec.NE.fp ) THEN
       IF ( nbFields.GE.0 .AND. filePrec.NE.fp ) THEN
         WRITE(msgBuf,'(2A,I4)') 'BBL_READ_PICKUP: ',
     &    'pickup-file binary precision do not match !'
         CALL PRINT_ERROR( msgBuf, myThid )
         WRITE(msgBuf,'(A,2(A,I4))') 'BBL_READ_PICKUP: ',
     &    'file prec.=', filePrec, ' but expecting prec.=', fp
         CALL PRINT_ERROR( msgBuf, myThid )
         STOP 'ABNORMAL END: S/R BBL_READ_PICKUP (data-prec Pb)'
       ENDIF
       _END_MASTER( myThid )

       IF ( nbFields.LE.0 ) THEN
C-      No meta-file or old meta-file without List of Fields
        ioUnit = errorMessageUnit
        IF ( pickupStrictlyMatch ) THEN
          WRITE(msgBuf,'(4A)') 'BBL_READ_PICKUP: ',
     &      'no field-list found in meta-file',
     &      ' => cannot check for strick-matching'
          CALL PRINT_ERROR( msgBuf, myThid )
          WRITE(msgBuf,'(4A)') 'BBL_READ_PICKUP: ',
     &      'try with " pickupStrictlyMatch=.FALSE.,"',
     &      ' in file: "data", NameList: "PARM03"'
          CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
          STOP 'ABNORMAL END: S/R BBL_READ_PICKUP'
        ELSE
          WRITE(msgBuf,'(4A)') 'WARNING >> BBL_READ_PICKUP: ',
     &      ' no field-list found'
          CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
         IF ( nbFields.EQ.-1 ) THEN
C-      No meta-file
          WRITE(msgBuf,'(4A)') 'WARNING >> ',
     &      ' try to read pickup as currently written'
          CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
         ELSE
          WRITE(msgBuf,'(4A)') 'BBL_READ_PICKUP: ',
     &      'no field-list found in meta-file'
          CALL PRINT_ERROR( msgBuf, myThid )
          STOP 'ABNORMAL END: S/R BBL_READ_PICKUP'
         ENDIF
        ENDIF
       ENDIF

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

       IF ( nbFields.EQ.0 ) THEN
C---   Old way to read pickup:

       ELSE
C---   New way to read BBL pickup:
        nj = 0
C---    read BBL 2-D fields for restart
        CALL READ_MFLDS_3D_RL( 'bblTheta', bbl_theta,
     &                                 nj, fp, 1 , myIter, myThid )
        CALL READ_MFLDS_3D_RL( 'bblSalt ', bbl_salt,
     &                                 nj, fp, 1 , myIter, myThid )
        CALL READ_MFLDS_3D_RL( 'bblEta  ', bbl_eta,
     &                                 nj, fp, 1 , myIter, myThid )

C--    end: new way to read pickup file
       ENDIF

C--    Check for missing fields:
       nMissing = missFldDim
       CALL READ_MFLDS_CHECK(
     O                     missFldList,
     U                     nMissing,
     I                     myIter, myThid )
       IF ( nMissing.GT.missFldDim ) THEN
         WRITE(msgBuf,'(2A,I4)') 'BBL_READ_PICKUP: ',
     &     'missing fields list has been truncated to', missFldDim
         CALL PRINT_ERROR( msgBuf, myThid )
         STOP 'ABNORMAL END: S/R BBL_READ_PICKUP (list-size Pb)'
       ENDIF
       IF ( nMissing.GE.1 ) THEN
        ioUnit = errorMessageUnit
        DO j=1,nMissing
         WRITE(msgBuf,'(4A)') 'BBL_READ_PICKUP: ',
     &       'cannot restart without field "',missFldList(nj),'"'
         CALL PRINT_ERROR( msgBuf, myThid )
        ENDDO
        STOP 'ABNORMAL END: S/R BBL_READ_PICKUP'
       ENDIF

C--    Update overlap regions:
        CALL EXCH_XY_RL( bbl_theta, myThid )
        CALL EXCH_XY_RL( bbl_salt, myThid )
        CALL EXCH_XY_RL( bbl_eta, myThid )

#endif /* ALLOW_BBL */

      RETURN
      END

#include "FIZHI_OPTIONS.h"
       subroutine AtoC(myThid,fieldin1,fieldin2,mask,idim1,idim2,
     .  jdim1,jdim2,numlevs,Nsx,Nsy,im1,im2,jm1,jm2,fieldout1,fieldout2)
c----------------------------------------------------------------------
c  Subroutine AtoC - Routine to map a velocity component quantity
c         from the A-Grid to the C-Grid. 
c         This includes doing an exchange to fill the halo region, and 
c         then a linear average with the appropriate topography mask.
c         Also: Set up "bi, bj loop" here.
c
c  Input: myThid
c         fieldin1    Field on a-grid to move to a-grid (1st component)
c         fieldin2    Field on a-grid to move to a-grid (2nd component)
c         mask        Topography [0,1] mask - 1 to indicate above ground
c         idim1,idim2,jdim1,jdim2   Indeces in x and y for computations
c         numlevs     Number of vertical levels
c         Nsx, Nsy    
c         im1,im2,jm1,jm2   Span of fields in x and y
c
c Output: fieldout1   Field mapped to C-Grid (1st component)
c         fieldout2   Field mapped to C-Grid (2nd component)
c
c Call:   exch_uv_agrid_3d_RL - exchange on a-grid
c-----------------------------------------------------------------------
       implicit none
#include "EEPARAMS.h"

       integer myThid, numlevs
       integer Nsx, Nsy
       integer idim1, idim2, jdim1, jdim2, im1, im2, jm1, jm2
       _RS mask(idim1:idim2,jdim1:jdim2,numlevs,Nsx,Nsy)
       _RL fieldin1(idim1:idim2,jdim1:jdim2,numlevs,Nsx,Nsy)
       _RL fieldin2(idim1:idim2,jdim1:jdim2,numlevs,Nsx,Nsy)
       _RL fieldout1(idim1:idim2,jdim1:jdim2,numlevs,Nsx,Nsy)
       _RL fieldout2(idim1:idim2,jdim1:jdim2,numlevs,Nsx,Nsy)

       integer i, j, L, bi, bj
       _RL tmpfld1(idim1:idim2,jdim1:jdim2)
       _RL tmpfld2(idim1:idim2,jdim1:jdim2)

c Call the exchange routine to fill in the halo regions
       CALL EXCH_UV_AGRID_3D_RL(
     U                           fieldin1, fieldin2,
     I                           .TRUE., numlevs, myThid )

c Now take average 
       do bj = myByLo(myThid), myByHi(myThid)
       do bi = myBxLo(myThid), myBxHi(myThid)

        do L = 1,numlevs
         do j = jdim1,jdim2
          do i = idim1,idim2
           tmpfld1(i,j) = fieldin1(i,j,L,bi,bj)*mask(i,j,L,bi,bj)
           tmpfld2(i,j) = fieldin2(i,j,L,bi,bj)*mask(i,j,L,bi,bj)
          enddo
         enddo
         do j = jm1,jm2
         do i = im1,im2
c        do j = jm2,jm1,-1
c        do i = im2,im1,-1
          if( (mask(i-1,j,L,bi,bj).ne.0.) .or.
     .                                  (mask(i,j,L,bi,bj).ne.0.) ) then
c          fieldout1(i,j,L,bi,bj) = 
c    .       ( fieldin1(i-1,j,L,bi,bj)*mask(i-1,j,L,bi,bj) +
c    .         fieldin1(i,j,L,bi,bj)*mask(i,j,L,bi,bj) ) /
c    .           ( mask(i-1,j,L,bi,bj) + mask(i,j,L,bi,bj) )
           fieldout1(i,j,L,bi,bj) = 
     .           ( tmpfld1(i-1,j) + tmpfld1(i,j) ) /
     .           ( mask(i-1,j,L,bi,bj) + mask(i,j,L,bi,bj) )
          else
           fieldout1(i,j,L,bi,bj) = 0.
          endif
          if( (mask(i,j-1,L,bi,bj).ne.0.) .or.
     .                                  (mask(i,j,L,bi,bj).ne.0.) ) then
c          fieldout2(i,j,L,bi,bj) = 
c    .       ( fieldin2(i,j-1,L,bi,bj)*mask(i,j-1,L,bi,bj) +
c    .         fieldin2(i,j,L,bi,bj)*mask(i,j,L,bi,bj) ) /
c    .           ( mask(i,j,L,bi,bj) + mask(i,j-1,L,bi,bj) )
           fieldout2(i,j,L,bi,bj) = 
     .           ( tmpfld2(i,j-1) + tmpfld2(i,j) ) /
     .           ( mask(i,j,L,bi,bj) + mask(i,j-1,L,bi,bj) )
          else
           fieldout2(i,j,L,bi,bj) = 0.
          endif
         enddo
         enddo
        enddo

       enddo
       enddo

       return
       end

#undef _USE_INTEGERS

C--  File port_rand.F: Portable random number generator functions
C--   Contents
C--   o PORT_RAND
C--   o PORT_RANARR
C--   o PORT_RAND_NORM

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: PORT_RAND
C     !INTERFACE:
      real*8 FUNCTION PORT_RAND(seed)

C     !DESCRIPTION:
C     Portable random number generator
C      seed >=0 :: initialise using this seed ; and return 0
C      seed < 0 :: if first call then initialise using the default seed (=mseed)
C                  and always return a random number

C     !USES:
      IMPLICIT NONE

C     !INPUT PARAMETERS:
#ifdef _USE_INTEGERS
      INTEGER seed
#else
      real*8  seed
#endif
CEOP

C     !LOCAL VARIABLES:
      INTEGER nff,idum
      PARAMETER(nff=55)
      PARAMETER(idum=-2)
      real*8 fac
#ifdef _USE_INTEGERS
      INTEGER mbig,mseed,mZ
      PARAMETER (mbig=1000000000,mz=0,fac=1.d0/mbig)
      INTEGER mj,mk,ma(nff)
      DATA mseed/161803398/
#else
      real*8 mbig,mseed,mz
      PARAMETER (mbig=4000000.,mz=0.,fac=1.d0/mbig)
      real*8 mj,mk,ma(nff)
      DATA mseed/1618033./
#endif
      LOGICAL firstCall
      INTEGER i,ii,inext,inextp,k
      DATA firstCall /.true./
      SAVE firstCall,inext,inextp,ma

C-    Initialise the random number generator
      IF (firstCall .OR. seed.GE.mz) THEN
        IF (seed.GE.mz) mseed = seed
        firstCall=.false.
        mj=mseed-iabs(idum)
        mj=mod(mj,mbig)
        ma(nff)=mj
        mk=1
        DO i=1,nff-1
          ii=mod(21*i,nff)
          ma(ii)=mk
          mk=mj-mk
          IF (mk.LT.mz) mk=mk+mbig
          mj=ma(ii)
        ENDDO
        DO k=1,4
          DO i=1,nff
            ma(i)=ma(i)-ma(1+mod(i+30,nff))
            IF (ma(i).LT.mz) ma(i)=ma(i)+mbig
          ENDDO
        ENDDO
        inext=0
        inextp=31
      ENDIF

C-    Compute a random number (only if seed < 0)
      IF (seed.GE.mz) THEN
        port_rand=0.d0
      ELSE
        inext=mod(inext,nff)+1
        inextp=mod(inextp,nff)+1
        mj=ma(inext)-ma(inextp)
        IF (mj.LT.mz) mj=mj+mbig
        ma(inext)=mj
        port_rand=mj*fac
      ENDIF

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

CBOP
C     !ROUTINE: PORT_RANARR
C     !INTERFACE:
      SUBROUTINE PORT_RANARR(n,arr)

C     !DESCRIPTION:
C     Portable random number array generator

C     !USES:
      IMPLICIT NONE

C     !INPUT PARAMETERS:
      INTEGER n
      real*8 arr(n)
CEOP

C     !LOCAL VARIABLES:
      INTEGER i
      real*8 port_rand
#ifdef _USE_INTEGERS
      INTEGER seed
      seed=-1
#else
      real*8  seed
      seed=-1.d0
#endif
c     seed=1618033.0d0
      DO i=1,n
       arr(i)=port_rand(seed)
      ENDDO

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: PORT_RAND_NORM
C     !INTERFACE:
      real*8 FUNCTION PORT_RAND_NORM()

C     !DESCRIPTION:
C     This function generates a normally distributed random number with
C     the so called polar algorithm. The algorithm actually generates 2
C     numbers, but only 1 is returned for maximum compatibility with old
C     code.  The most obvious way to improve this function would be to
C     make sure that the second number is not wasted.

C     Changed: 2004.09.06 antti.westerlund@fimr.fi

C     !USES:
      IMPLICIT NONE
CEOP

C     !LOCAL VARIABLES:
      real*8 port_rand
      real*8 x1, x2, xs, t

#ifdef _USE_INTEGERS
      INTEGER seed
      seed=-1
#else
      real*8  seed
      seed=-1.d0
#endif
c     seed=1618033.0d0

C     first generate 2 equally distributed random numbers (-1,1)
      xs = 0.0
      DO WHILE ( xs.GE.1.0 .OR. xs.EQ.0.0 )
         x1=2.0*port_rand(seed)-1.0
         x2=2.0*port_rand(seed)-1.0
         xs=x1**2+x2**2
      ENDDO

      t = SQRT(-2.0*LOG(xs)/xs)
      port_rand_norm = t*x1

C     also t*x2 would be a gaussian random number and could be returned

      RETURN
      END

#include "CPP_OPTIONS.h"

CBOP
C     !ROUTINE: SET_REF_STATE
C     !INTERFACE:
      SUBROUTINE SET_REF_STATE(
     I                          myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE SET_REF_STATE
C     | o Set reference potential at level center and
C     |   level interface, using tRef,sRef profiles.
C     | note: use same discretisation as in calc_phi_hyd
C     | o Set also reference stratification here (for implicit
C     |   Internal Gravity Waves) and units conversion factor
C     |   for vertical velocity (for Non-Hydrostatic in p)
C     |   since both use also the same reference density.
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "EOS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     myThid   :: my Thread Id number
      INTEGER myThid

C     !LOCAL VARIABLES:
C     msgBuf   :: Informational/error message buffer
C     pRefIntF :: reference pressure at level interface
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      INTEGER k, ks, stdUnit
      _RL rHalf(2*Nr+1), pRefIntF(Nr+1)
      _RL tLoc(Nr)
      _RL pLoc, rhoUp, rhoDw, rhoLoc
      _RL ddPI, conv_theta2T, thetaLoc
C--
      _RL     maxResid
      INTEGER maxIterNb, belowCritNb
CEOP

      _BEGIN_MASTER( myThid )

C--   Initialise:
      DO k=1,2*Nr
        phiRef(k) = 0.
      ENDDO
      stdUnit = standardMessageUnit

      DO k=1,Nr
        rUnit2z(k) = 1. _d 0
        z2rUnit(k) = 1. _d 0
        rhoRef(k)  = rhoConst
        dBdrRef(k) = 0. _d 0
        pRef4EOS(k)  = 0. _d 0
        rHalf(2*k)   = rC(k)
      ENDDO

      DO k=1,Nr+1
        pRefIntF(k)  = 0. _d 0
        rHalf(2*k-1) = rF(k)
        rVel2wUnit(k) = 1. _d 0
        wUnit2rVel(k) = 1. _d 0
      ENDDO

C-    Initialise density factor for anelastic formulation:
      DO k=1,Nr
        rhoFacC(k) = 1. _d 0
        recip_rhoFacC(k) = 1. _d 0
      ENDDO
      DO k=1,Nr+1
        rhoFacF(k) = 1. _d 0
        recip_rhoFacF(k) = 1. _d 0
      ENDDO

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C--   Oceanic: define reference pressure/geo-potential vertical scale:
      IF ( buoyancyRelation.EQ.'OCEANIC' ) THEN
        phiRef(1)   = top_Pres*recip_rhoConst
        pRefIntF(1) = top_Pres
        IF ( gravityFile.EQ.' ' ) THEN
         DO k=1,Nr
          phiRef(2*k)   = phiRef(1)
     &                  + (rC(k) - rF(1))*gravity*gravitySign
          phiRef(2*k+1) = phiRef(1)
     &                  + (rF(k+1)-rF(1))*gravity*gravitySign
c         pRef4EOS(k)   = rhoConst*phiRef(2*k)
c         pRefIntF(k+1) = rhoConst*phiRef(2*k+1)
C note: just to get the same previous machine truncation:
          pRef4EOS(k)   = pRefIntF(1)
     &                  + rhoConst*(rC(k) - rF(1))*gravity*gravitySign
          pRefIntF(k+1) = pRefIntF(1)
     &                  + rhoConst*(rF(k+1)-rF(1))*gravity*gravitySign
         ENDDO
        ELSEIF ( integr_GeoPot.EQ.1 ) THEN
         DO k=1,Nr
          phiRef(2*k)   = phiRef(2*k-1)
     &                           + halfRL*drF(k)*gravity*gravFacC(k)
          phiRef(2*k+1) = phiRef(2*k-1) + drF(k)*gravity*gravFacC(k)
          pRef4EOS(k)   = rhoConst*phiRef(2*k)
          pRefIntF(k+1) = rhoConst*phiRef(2*k+1)
         ENDDO
        ELSE
         phiRef(2)   = phiRef(1) + drC(1)*gravity*gravFacF(1)
         DO k=2,Nr
          phiRef(2*k-1) = phiRef(2*k-2)
     &                           + halfRL*drC(k)*gravity*gravFacF(k)
          phiRef(2*k)   = phiRef(2*k-2) + drC(k)*gravity*gravFacF(k)
         ENDDO
         k = Nr
         phiRef(2*k+1) = phiRef(2*k) + drC(k+1)*gravity*gravFacF(k+1)
         DO k=1,Nr
          pRef4EOS(k)   = rhoConst*phiRef(2*k)
          pRefIntF(k+1) = rhoConst*phiRef(2*k+1)
         ENDDO
        ENDIF
      ELSEIF ( buoyancyRelation.EQ.'OCEANICP' ) THEN
        phiRef(2*Nr+1) = seaLev_Z*gravity
        DO k=1,Nr
          phiRef(2*k)   = phiRef(2*Nr+1)
     &                  - recip_rhoConst*( rC(k) - rF(Nr+1) )
          phiRef(2*k-1) = phiRef(2*Nr+1)
     &                  - recip_rhoConst*( rF(k) - rF(Nr+1) )
          pRef4EOS(k)   = rC(k)
          pRefIntF(k)   = rF(k)
        ENDDO
        pRefIntF(Nr+1) = rF(Nr+1)
c     ELSEIF (buoyancyRelation .EQ. 'ATMOSPHERIC') THEN
C     phiRef is computed later (see below)
      ENDIF

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
      IF ( eosType.EQ.'POLY3' ) THEN
       IF ( implicitIntGravWave ) THEN
         WRITE(msgBuf,'(2A)') 'SET_REF_STATE:',
     &    ' need to compute reference density for Impl.IGW'
         CALL PRINT_ERROR( msgBuf , myThid )
         WRITE(msgBuf,'(2A)') 'SET_REF_STATE:',
     &    ' but FIND_RHO_SCALAR(EOS="POLY3") not (yet) implemented'
         CALL PRINT_ERROR( msgBuf , myThid )
         STOP 'ABNORMAL END: S/R SET_REF_STATE'
       ELSEIF ( nonHydrostatic .AND.
     &          buoyancyRelation.EQ.'OCEANICP' ) THEN
         WRITE(msgBuf,'(2A)') 'SET_REF_STATE:',
     &    ' need to compute reference density for Non-Hyd'
         CALL PRINT_ERROR( msgBuf , myThid )
         WRITE(msgBuf,'(2A)') 'SET_REF_STATE:',
     &    ' but FIND_RHO_SCALAR(EOS="POLY3") not (yet) implemented'
         CALL PRINT_ERROR( msgBuf , myThid )
         STOP 'ABNORMAL END: S/R SET_REF_STATE'
       ELSE
         WRITE(msgBuf,'(2A)') 'SET_REF_STATE:',
     &    ' Unable to compute reference stratification'
         CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                       SQUEEZE_RIGHT , myThid )
         WRITE(msgBuf,'(2A)') 'SET_REF_STATE:',
     &    '  with EOS="POLY3" ; set dBdrRef(1:Nr) to zeros'
         CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                       SQUEEZE_RIGHT , myThid)
       ENDIF
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
      ELSEIF ( buoyancyRelation.EQ.'OCEANIC' ) THEN

C--   Compute reference density profile
        DO k=1,Nr
          pLoc = pRef4EOS(k)
          CALL FIND_RHO_SCALAR(
     I                          tRef(k), sRef(k), pLoc,
     O                          rhoRef(k), myThid )
        ENDDO

        IF ( selectP_inEOS_Zc.GE.1 ) THEN
C--   Find reference pressure in hydrostatic balance with updated ref density
          maxResid = rhoConst* 1. _d -14
          belowCritNb = 5
          maxIterNb = 10*Nr
          CALL FIND_HYD_PRESS_1D(
     O                            pRef4EOS, pRefIntF,
     U                            rhoRef,
     I                            tRef, sRef, maxResid,
     I                            belowCritNb, maxIterNb, myThid )
        ENDIF

C--   Compute reference stratification: N^2 = -(g/rho_c) * d.rho/dz @ const. p
        dBdrRef(1) = 0. _d 0
        DO k=2,Nr
          pLoc = pRefIntF(k)
          CALL FIND_RHO_SCALAR(
     I                          tRef(k-1), sRef(k-1), pLoc,
     O                          rhoUp, myThid )
          CALL FIND_RHO_SCALAR(
     I                          tRef(k), sRef(k), pLoc,
     O                          rhoDw, myThid )
          dBdrRef(k) = (rhoDw - rhoUp)*recip_drC(k)
     &               *recip_rhoConst*gravity*gravFacF(k)
          IF ( eosType.EQ.'LINEAR' ) THEN
C- get more precise values (differences from above are due to machine round-off)
            dBdrRef(k) = ( sBeta *(sRef(k)-sRef(k-1))
     &                    -tAlpha*(tRef(k)-tRef(k-1))
     &                   )*recip_drC(k)
     &                 *rhoNil*recip_rhoConst*gravity*gravFacF(k)
          ENDIF
        ENDDO

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
      ELSEIF ( buoyancyRelation.EQ.'OCEANICP' ) THEN

C--   Compute reference density profile (from tRef,sRef):
        DO k=1,Nr
          pLoc = pRef4EOS(k)
          CALL FIND_RHO_SCALAR(
     I                          tRef(k), sRef(k), pLoc,
     O                          rhoRef(k), myThid )
C-    set units convertion factor @ level center:
C       z2rUnit = gravity*rhoRef : dr [Pa] = dz [m] * z2rUnit
C       rUnit2z = 1/z2rUnit      : dz [m] = dr [Pa] * rUnit2z
          z2rUnit(k) = gravity*rhoRef(k)
          rUnit2z(k) = 1. _d 0 / z2rUnit(k)
        ENDDO

C--   Compute reference stratification: -d.alpha/dp @ constant p
        dBdrRef(1) = 0. _d 0
        DO k=1,Nr+1
          pLoc = pRefIntF(k)
          IF ( k.GE.2 )  CALL FIND_RHO_SCALAR(
     I                             tRef(k-1), sRef(k-1), pLoc,
     O                             rhoDw, myThid )
          IF ( k.LE.Nr ) CALL FIND_RHO_SCALAR(
     I                             tRef(k), sRef(k), pLoc,
     O                             rhoUp, myThid )
          IF ( k.GE.2 .AND. k.LE.Nr ) THEN
            dBdrRef(k) = (rhoDw - rhoUp)*recip_drC(k)
     &                 / (rhoDw*rhoUp)
            rhoLoc = ( rhoDw + rhoUp )*0.5 _d 0
          ELSEIF ( k.EQ.1 ) THEN
            rhoLoc = rhoUp
          ELSE
            rhoLoc = rhoDw
          ENDIF
C--   Units convertion factor for vertical velocity:
C       wUnit2rVel = gravity*rhoRef : rVel  [Pa/s] = wSpeed [m/s] * wUnit2rVel
C       rVel2wUnit = 1/rVel2wUnit   : wSpeed [m/s] = rVel  [Pa/s] * rVel2wUnit
C     note: wUnit2rVel & rVel2wUnit replace horiVertRatio & recip_horiVertRatio
          wUnit2rVel(k) = gravity*rhoLoc
          rVel2wUnit(k) = 1. _d 0 / wUnit2rVel(k)
        ENDDO

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
      ELSEIF ( buoyancyRelation.EQ.'ATMOSPHERIC' ) THEN

C--   Compute reference stratification: -d.alpha/dp @ constant p
        dBdrRef(1) = 0. _d 0
        DO k=2,Nr
          conv_theta2T = (rF(k)/atm_Po)**atm_kappa
c         dBdrRef(k) = (tRef(k) - tRef(k-1))*recip_drC(k)
c    &               * conv_theta2T*atm_Rd/rF(k)
          ddPI=atm_Cp*( ((rC(k-1)/atm_Po)**atm_kappa)
     &                 -((rC( k )/atm_Po)**atm_kappa) )
          dBdrRef(k) = (tRef(k) - tRef(k-1))*recip_drC(k)
     &               * ddPI*recip_drC(k)
        ENDDO

C--   Set units convertion factor @ level center:
C       z2rUnit = gravity/alpha : dr [Pa] = dz [m] * z2rUnit
C       rUnit2z = alpha/gravity : dz [m] = dr [Pa] * rUnit2z
        DO k=1,Nr
          pRef4EOS(k)  = rC(k)
          thetaLoc = tRef(k)
          IF ( thetaLoc.GT.0. _d 0 .AND. rC(k).GT.0. _d 0 ) THEN
            conv_theta2T = (rC(k)/atm_Po)**atm_kappa
            z2rUnit(k) = gravity
     &                 * rC(k)/(atm_Rd*conv_theta2T*thetaLoc)
            rUnit2z(k) = 1. _d 0 / z2rUnit(k)
          ENDIF
        ENDDO

C--   Units convertion factor for vertical velocity:
C       wUnit2rVel = gravity/alpha : rVel  [Pa/s] = wSpeed [m/s] * wUnit2rVel
C       rVel2wUnit = alpha/gravity : wSpeed [m/s] = rVel  [Pa/s] * rVel2wUnit
C       with alpha = 1/rhoRef = (R.T/p) (ideal gas)
C     note: wUnit2rVel & rVel2wUnit replace horiVertRatio & recip_horiVertRatio
        DO k=1,Nr+1
          pRefIntF(k)  = rF(k)
          IF ( k.EQ.1 ) THEN
            thetaLoc = tRef(k)
          ELSEIF ( k.GT.Nr ) THEN
            thetaLoc = tRef(k-1)
          ELSE
            thetaLoc = (tRef(k) + tRef(k-1))*0.5 _d 0
          ENDIF
          IF ( thetaLoc.GT.0. _d 0 .AND. rF(k).GT.0. _d 0 ) THEN
            conv_theta2T  = (rF(k)/atm_Po)**atm_kappa
            wUnit2rVel(k) = gravity
     &                    * rF(k)/(atm_Rd*conv_theta2T*thetaLoc)
            rVel2wUnit(k) = 1. _d 0 / wUnit2rVel(k)
          ENDIF
        ENDDO

C-    Compute Reference Geopotential at Half levels :
C      Tracer level k: phiRef(2k)  ;  Interface_W level k: phiRef(2k-1)

       phiRef(1) = seaLev_Z*gravity
       IF ( select_rStar.GE.1 .OR. selectSigmaCoord.GE.1 ) THEN
C-      isothermal (theta=const) reference state
        DO k=1,Nr
         tLoc(k) = thetaConst
        ENDDO
       ELSE
C-      horizontally uniform (tRef) reference state
        DO k=1,Nr
         tLoc(k) = tRef(k)
        ENDDO
       ENDIF

       IF (integr_GeoPot.EQ.1) THEN
C-    Finite Volume Form, linear by half level :
        DO k=1,2*Nr
          ks = (k+1)/2
          ddPI=atm_Cp*( ((rHalf( k )/atm_Po)**atm_kappa)
     &                 -((rHalf(k+1)/atm_Po)**atm_kappa) )
          phiRef(k+1) = phiRef(k)+ddPI*tLoc(ks)
        ENDDO
C------
       ELSE
C-    Finite Difference Form, linear between Tracer level :
C      works with integr_GeoPot = 0, 2 or 3
        k = 1
          ddPI=atm_Cp*( ((rF(k)/atm_Po)**atm_kappa)
     &                 -((rC(k)/atm_Po)**atm_kappa) )
          phiRef(2*k)   = phiRef(1) + ddPI*tLoc(k)
        DO k=1,Nr-1
          ddPI=atm_Cp*( ((rC( k )/atm_Po)**atm_kappa)
     &                 -((rC(k+1)/atm_Po)**atm_kappa) )
          phiRef(2*k+1) = phiRef(2*k) + ddPI*0.5*tLoc(k)
          phiRef(2*k+2) = phiRef(2*k)
     &                  + ddPI*0.5*(tLoc(k)+tLoc(k+1))
        ENDDO
        k = Nr
          ddPI=atm_Cp*( ((rC( k )/atm_Po)**atm_kappa)
     &                 -((rF(k+1)/atm_Po)**atm_kappa) )
          phiRef(2*k+1) = phiRef(2*k) + ddPI*tLoc(k)
C------
       ENDIF

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
      ELSE
        STOP 'SET_REF_STATE: Bad value of buoyancyRelation !'
C--   endif buoyancyRelation
      ENDIF

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      IF ( usingZCoords .AND. rhoRefFile .NE. ' ' ) THEN
C--   anelastic formulation : set density factor from reference density profile
C       surface-interface rho-factor has to be 1:
        rhoFacF(1)   = 1. _d 0
C       rhoFac(k) = density ratio between layer k and top interface
        DO k=1,Nr
          rhoFacC(k) = rho1Ref(k)/rhoConst
c         rhoFacC(k) = rho1Ref(k)*recip_rhoConst
        ENDDO
        DO k=2,Nr
C       since rkSign=-1, recip_drC(k) = 1./(rC(k-1)-rC(k))
          rhoFacF(k) = ( rhoFacC(k-1)*(rF(k)-rC(k))
     &                 + rhoFacC(k)*(rC(k-1)-rF(k)) )*recip_drC(k)
        ENDDO
C       extrapolate down to the bottom:
        rhoFacF(Nr+1) = ( rhoFacC(Nr)*(rF(Nr+1)-rF(Nr))
     &                  + rhoFacF(Nr)*(rC(Nr)-rF(Nr+1))
     &                  ) / (rC(Nr)-rF(Nr))
C-      set reciprocal rho-factor:
        DO k=1,Nr
          recip_rhoFacC(k) = 1. _d 0/rhoFacC(k)
        ENDDO
        DO k=1,Nr+1
          recip_rhoFacF(k) = 1. _d 0/rhoFacF(k)
        ENDDO
      ENDIF

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C--   Write to check :
      IF ( gravityFile .NE. ' ' ) THEN
C-    write gravity vertical profile factor to binary file:
        CALL WRITE_GLVEC_RL( 'GravFacC',' ',gravFacC, Nr, -1, myThid )
        CALL WRITE_GLVEC_RL( 'GravFacF',' ',gravFacF,Nr+1,-1, myThid )
      ENDIF
      IF ( selectP_inEOS_Zc.GE.1 ) THEN
C-    write (to binary file) Hyd-Pressure used in EOS:
        CALL WRITE_GLVEC_RL( 'PRef4EOS',' ',pRef4EOS, Nr, -1, myThid )
c       CALL WRITE_GLVEC_RL( 'PRefIntF',' ',pRefIntF,Nr+1,-1, myThid )
      ENDIF
      IF ( buoyancyRelation.EQ.'ATMOSPHERIC' ) THEN
       WRITE(msgBuf,'(A)') ' '
       CALL PRINT_MESSAGE( msgBuf, stdUnit, SQUEEZE_RIGHT, myThid )
       WRITE(msgBuf,'(A)')
     &  'SET_REF_STATE: PhiRef/g [m] at level Center (integer)'
       CALL PRINT_MESSAGE( msgBuf, stdUnit, SQUEEZE_RIGHT, myThid )
       WRITE(msgBuf,'(A)')
     &  '                     and at level Interface (half-int.) :'
       CALL PRINT_MESSAGE( msgBuf, stdUnit, SQUEEZE_RIGHT, myThid )
       DO k=1,2*Nr+1
        WRITE(msgBuf,'(A,F5.1,A,F15.1,A,F13.3)')
     &    ' K=',k*0.5,'  ;  r=',rHalf(k),'  ;  phiRef/g=',
     &    phiRef(k)*recip_gravity
        CALL PRINT_MESSAGE(msgBuf, stdUnit, SQUEEZE_RIGHT, myThid )
       ENDDO
      ELSE
C-    Write reference density to binary file :
        CALL WRITE_GLVEC_RL( 'RhoRef', ' ', rhoRef, Nr, -1, myThid )
      ENDIF
      IF ( usingZCoords .AND. rhoRefFile .NE. ' ' ) THEN
C-    Write Anelastic density factor to binary file :
        CALL WRITE_GLVEC_RL( 'RhoFacC',' ',rhoFacC, Nr ,  -1, myThid )
        CALL WRITE_GLVEC_RL( 'RhoFacF',' ',rhoFacF, Nr+1, -1, myThid )
      ENDIF

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      _END_MASTER( myThid )
      _BARRIER

      RETURN
      END

#include "KPP_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 0
C     !ROUTINE: KPP_READPARMS

C     !INTERFACE:
      SUBROUTINE KPP_READPARMS( myThid )

C     !DESCRIPTION:
C     Routine to read in file data.kpp

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "KPP_PARAMS.h"

C     !INPUT PARAMETERS:
      INTEGER myThid
CEOP

C     !LOCAL VARIABLES:
#ifdef ALLOW_KPP
C     msgBuf     :: Informational/error message buffer
C     errIO      :: IO error flag
C     iUnit      :: Work variable for IO unit number
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      INTEGER errIO, iUnit
C-    retired parameters:
C     nRetired   :: Count number of "retired" parameters found in namelist.
      INTEGER nRetired
      LOGICAL KPPmixingMaps
      INTEGER num_v_smooth_BV, num_z_smooth_sh, num_m_smooth_sh
      _RL kpp_taveFreq

C--   KPP vertical mixing parameters
      NAMELIST /KPP_PARM01/
     & kpp_freq, kpp_dumpFreq, kpp_taveFreq,
     & KPPwriteState, KPP_ghatUseTotalDiffus,
     & KPPuseDoubleDiff, LimitHblStable, KPPuseSWfrac3D,
     & minKPPhbl,
     & epsln, phepsi, epsilon, vonk, dB_dz,
     & conc1, conam, concm, conc2, zetam,
     & conas, concs, conc3, zetas,
     & Ricr, cekman, cmonob, concv, hbf,
     & zmin, zmax, umin, umax,
     & num_v_smooth_Ri,
     & Riinfty, BVSQcon, difm0, difs0, dift0,
     & difmcon, difscon, diftcon,
     & Rrho0, dsfmax,
     & cstar,
     & KPPmixingMaps,
     & num_v_smooth_BV, num_z_smooth_sh, num_m_smooth_sh

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      IF ( .NOT.useKPP ) THEN
C-    pkg KPP is not used
        _BEGIN_MASTER(myThid)
C-    Track pkg activation status:
C     print a (weak) warning if data.kpp is found
         CALL PACKAGES_UNUSED_MSG( 'useKPP', ' ', ' ' )
        _END_MASTER(myThid)
        RETURN
      ENDIF

      _BEGIN_MASTER(myThid)

      WRITE(msgBuf,'(A)') ' KPP_READPARMS: opening data.kpp'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      errIO = 0
      CALL OPEN_COPY_DATA_FILE(
     I                          'data.kpp', 'KPP_READPARMS',
     O                          iUnit,
     I                          myThid )

C--   set default KPP vertical mixing parameters
      kpp_freq               = deltaTClock
      kpp_dumpFreq           = dumpFreq
      KPPwriteState          = .FALSE.
      KPPuseDoubleDiff       = .FALSE.
      LimitHblStable         = .TRUE.
      KPP_ghatUseTotalDiffus = .FALSE.
      KPPuseSWfrac3D         = .FALSE.
      minKPPhbl = UNSET_RL

C-----------------------------------------------------------------------
C define some non-dimensional constants and
C the vertical mixing coefficients in m-k-s units
C-----------------------------------------------------------------------

      epsln   =   1. _d -20
      phepsi  =   1. _d -10
      epsilon =   1. _d -1
      vonk    =   0.4 _d 0
      dB_dz   =   5.2 _d -5
      conc1   =   5. _d 0
      conam   =   1.257 _d 0
      concm   =   8.380 _d 0
      conc2   =  16. _d 0
      zetam   =  -0.2 _d 0
      conas   = -28.86 _d 0
      concs   =  98.96 _d 0
      conc3   =  16. _d 0
      zetas   =  -1. _d 0

C     parameters for subroutine "bldepth"

      Ricr    = 0.3 _d 0
      cekman  = 0.7 _d 0
      cmonob  = 1.  _d 0
      concv   = 1.8 _d 0
      hbf     = 1.  _d 0

C     parameters and common arrays for subroutines
C     "kmixinit" and "wscale"

      zmin    = -4. _d -7
      zmax    =  0. _d 0
      umin    =  0. _d 0
      umax    =  4. _d -2

C     parameters for subroutine "Ri_iwmix"

      num_v_smooth_Ri = 0
      Riinfty =  0.7 _d 0
      BVSQcon = -0.2 _d -4

      difm0   = 5. _d -3
      difs0   = 5. _d -3
      dift0   = 5. _d -3

      difmcon = 0.1 _d 0
      difscon = 0.1 _d 0
      diftcon = 0.1 _d 0

C     parameters for double diffusion routine "KPP_DOUBLEDIFF"

      Rrho0   = 1.9 _d 0
      dsfmax  = 10. _d -3

C     parameters for subroutine "blmix"

      cstar   = 10.

C-    Retired parameters: initialised to unlikely value:
      nRetired = 0
      KPPmixingMaps   = .FALSE.
      num_v_smooth_BV = UNSET_I
      num_z_smooth_sh = UNSET_I
      num_m_smooth_sh = UNSET_I
      kpp_taveFreq    = UNSET_RL

C-----------------------------------------------------------------------

C--   Read settings from model parameter file "data.kpp".
      WRITE(msgBuf,'(A)') ' KPP_READPARMS ; starts to read KPP_PARM01'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      READ( UNIT=iUnit, NML=KPP_PARM01 )
c     READ( UNIT=iUnit, NML=KPP_PARM01, IOSTAT=errIO )
c     WRITE(msgBuf,'(A,I6,A)')
c    & ' KPP_READPARMS ; read KPP_PARM01 (', errIO, ' )'
c     CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
c    &                    SQUEEZE_RIGHT, myThid )
      IF ( errIO .LT. 0 ) THEN
       WRITE(msgBuf,'(A)')
     &  'S/R KPP_READPARMS: Error reading parameter file "data.kpp"'
       CALL PRINT_ERROR( msgBuf, myThid )
       WRITE(msgBuf,'(A)')
     &  'S/R KPP_READPARMS: Problem in namelist KPP_PARM01'
       CALL PRINT_ERROR( msgBuf, myThid )
       STOP 'ABNORMAL END: S/R KPP_READPARMS'
      ELSE
       WRITE(msgBuf,'(A)') ' KPP_READPARMS ; read KPP_PARM01 : OK'
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                     SQUEEZE_RIGHT, myThid )
      ENDIF

#ifdef SINGLE_DISK_IO
      CLOSE(iUnit)
#else
      CLOSE(iUnit,STATUS='DELETE')
#endif /* SINGLE_DISK_IO */

      WRITE(msgBuf,'(A)') ' KPP_READPARMS: finished reading data.kpp'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )

C--   Check for retired parameters:
C     print message and stop when retired parameters were found in namelist
      IF ( KPPmixingMaps ) THEN
        nRetired = nRetired + 1
        WRITE(msgBuf,'(2A)') 'S/R KPP_READPARMS: "KPPmixingMaps"',
     &                       ' no longer allowed in file "data.kpp"'
        CALL PRINT_ERROR( msgBuf, myThid )
      ENDIF
      IF ( num_v_smooth_BV .NE. UNSET_I ) THEN
        nRetired = nRetired + 1
        WRITE(msgBuf,'(2A)') 'S/R KPP_READPARMS: "num_v_smooth_BV"',
     &                       ' no longer allowed in file "data.kpp"'
        CALL PRINT_ERROR( msgBuf, myThid )
      ENDIF
      IF ( num_z_smooth_sh .NE. UNSET_I ) THEN
        nRetired = nRetired + 1
        WRITE(msgBuf,'(2A)') 'S/R KPP_READPARMS: "num_z_smooth_sh"',
     &                       ' no longer allowed in file "data.kpp"'
        CALL PRINT_ERROR( msgBuf, myThid )
      ENDIF
      IF ( num_m_smooth_sh .NE. UNSET_I ) THEN
        nRetired = nRetired + 1
        WRITE(msgBuf,'(2A)') 'S/R KPP_READPARMS: "num_m_smooth_sh"',
     &                       ' no longer allowed in file "data.kpp"'
        CALL PRINT_ERROR( msgBuf, myThid )
      ENDIF
      IF ( kpp_taveFreq .NE. UNSET_RL ) THEN
        WRITE(msgBuf,'(2A)') 'KPP_READPARMS: "kpp_taveFreq"',
     &    ' is no longer allowed in file "data.kpp"'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(2A)') 'KPP_READPARMS: ',
     &    ' since "pkg/timeave" has been removed.'
        CALL PRINT_ERROR( msgBuf, myThid )
        nRetired = nRetired + 1
      ENDIF

      IF ( nRetired .GT. 0 ) THEN
       WRITE(msgBuf,'(2A)') 'S/R KPP_READPARMS: ',
     &  'Error reading file "data.kpp":'
       CALL PRINT_ERROR( msgBuf, myThid )
       WRITE(msgBuf,'(I4,A)') nRetired,
     &      ' out-of-date parameters were found in the namelist(s)'
       CALL PRINT_ERROR( msgBuf, myThid )
c      errCount = errCount + 1
       CALL ALL_PROC_DIE( 0 )
       STOP 'ABNORMAL END: S/R KPP_READPARMS'
      ENDIF

      _END_MASTER(myThid)

C--   Everyone else must wait for the parameters to be loaded
      _BARRIER

#endif /* ALLOW_KPP */

      RETURN
      END

#include "FRAZIL_OPTIONS.h"
C--  File frazil_tendency_apply.F: Routines to apply FRAZIL tendencies
C--   Contents
C--   o FRAZIL_TENDENCY_APPLY_T

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 0

C !INTERFACE:
      SUBROUTINE FRAZIL_TENDENCY_APPLY_T(
     U                     gT_arr,
     I                     iMin,iMax,jMin,jMax, k, bi, bj,
     I                     myTime, myIter, myThid )

C     !DESCRIPTION:
C     Add frazil tendency terms to T (theta) tendency.
C     Routine works for one level at a time.

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
c#include "DYNVARS.h"
#ifdef ALLOW_FRAZIL
# include "FRAZIL.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     gT_arr    :: the tendency array
C     iMin,iMax :: Working range of x-index for applying forcing.
C     jMin,jMax :: Working range of y-index for applying forcing.
C     k         :: Current vertical level index
C     bi,bj     :: Current tile indices
C     myTime    :: Current time in simulation
C     myIter    :: Current iteration number
C     myThid    :: my Thread Id number
      _RL     gT_arr(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER iMin, iMax, jMin, jMax
      INTEGER k, bi, bj
      _RL     myTime
      INTEGER myIter
      INTEGER myThid
CEOP

#ifdef ALLOW_FRAZIL

C     !LOCAL VARIABLES:
      INTEGER i, j
      _RL recip_Cp

      recip_Cp = 1. _d 0 / HeatCapacity_Cp
      DO j=jMin,jMax
       DO i=iMin,iMax
        gT_arr(i,j) = gT_arr(i,j)
     &       + FrazilForcingT(i,j,k,bi,bj)
     &       * recip_Cp * mass2rUnit
     &       * recip_drF(k) * _recip_hFacC(i,j,k,bi,bj)
       ENDDO
      ENDDO

#endif /* ALLOW_FRAZIL */

      RETURN
      END

#include "PACKAGES_CONFIG.h"
#include "CPP_OPTIONS.h"

CStartOfInterface
CBOP
C     !ROUTINE: PACKAGES_READPARMS
C     !INTERFACE:
      SUBROUTINE PACKAGES_READPARMS(myThid)

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE PACKAGES_READPARMS
C     | o Read runtime package configuration parameters
C     *==========================================================*
C     |   Packages can have internal runtime configuration
C     |   parameters. A package provides a routine
C     |   ${PKGNAME}_READ_PARMS to read these parameters. In
C     |   general this routine should read parameters from a file
C     |   called data.${pkgname}.
C     |   This routine (S/R PACKAGES_READPARMS) calls per-package
C     |   parameter reading routines.
C     *==========================================================*
C     \ev

C     !CALLING SEQUENCE:
C     PACKAGES_READPARMS
C       |
C       |-- MNC_READPARMS
C       |
C       |-- CAL_READPARMS
C       |
C       |-- EXF_READPARMS
C       |
C       |-- OBCS_READPARMS
C       |
C       |-- SHAP_FILT_READPARMS
C       |
C       |-- ZONAL_FILT_READPARMS
C       |
C       |-- OPPS_READPARMS
C       |
C       |-- PP81_READPARMS
C       |
C       |-- KL10_READPARMS
C       |
C       |-- MY82_READPARMS
C       |
C       |-- GGL90_READPARMS
C       |
C       |-- KPP_READPARMS
C       |
C       |-- GMREDI_READPARMS
C       |
C       |-- BBL_READPARMS
C       |
C       |-- DWNSLP_READPARMS
C       |
C       |-- BULKF_READPARMS
C       |
C       |-- EBM_READPARMS
C       |
C       |-- CHEAPAML_READPARMS
C       |
C       |-- FLT_READPARMS
C       |
C       |-- LONGSTEP_READPARMS
C       |-- PTRACERS_READPARMS
C       |
C       |-- GCHEM_READPARMS
C       |
C       |-- RBCS_READPARMS
C       |
C       |-- OFFLINE_READPARMS
C       |
C       |-- MATRIX_READPARMS
C       |
C       |-- STREAMICE_READPARMS
C       |
C       |-- SHELFICE_READPARMS
C       |
C       |-- STIC_READPARMS
C       |
C       |-- ICEFRONT_READPARMS
C       |
C       |-- SEAICE_READPARMS
C       |
C       |-- SALT_PLUME_READPARMS
C       |
C       |-- THSICE_READPARMS
C       |
C       |-- LAND_READPARMS
C       |
C       |-- AUTODIFF_READPARMS
C       |
C       |-- OPTIM_READPARMS
C       |
C       |-- CTRL_READPARMS
C       |
C       |-- COST_READPARMS
C       |
C       |-- GRDCHK_READPARMS
C       |
C       |-- SMOOTH_READPARMS
C       |
C       |-- ECCO_READPARMS
C       |
C       |-- PROFILES_READPARMS
C       |
C       |-- OBSFIT_READPARMS
C       |
C       |-- SBO_READPARMS
C       |
C       |-- ATM_PHYS_READPARMS
C       |
C       |-- FIZHI_READPARMS
C       |
C       |-- DIAGNOSTICS_READPARMS
C       |
C       |-- REGRID_READPARMS
C       |
C       |-- LAYERS_READPARMS
C       |
C       |-- NEST_CHILD_READPARMS
C       |-- NEST_PARENT_READPARMS
C       |
C       |-- NEST2W_C_READPARMS
C       |-- NEST2W_P_READPARMS
C       |
C       |-- CPL_READPARMS
C       |
C       |-- OASIS_READPARMS
C       |
C       |-- RUNCLOCK_READPARMS
C       |
C       |-- MYPACKAGE_READPARMS

C     !USES:
      IMPLICIT NONE
C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"

C     == Routine arguments ==
      INTEGER myThid
CEOP

#ifdef ALLOW_MNC
C--   if useMNC=T, read run-time flags for MNC; otherwise just return
      CALL MNC_READPARMS( myThid )
#endif

#ifdef ALLOW_CAL
C--   if useCAL=T, set the calendar package parameters.
C      otherwise, just set cal_setStatus=-1 and return
      CALL CAL_READPARMS( myThid )
#endif

#ifdef ALLOW_EXF
C--   if useEXF=T, set EXF parameters; otherwise just return
      CALL EXF_READPARMS  ( myThid )
#endif

#ifdef ALLOW_OBCS
C--   if useOBCS=T, set OBCS parameters; otherwise just return
      CALL OBCS_READPARMS( myThid )
#endif

#ifdef ALLOW_SHAP_FILT
C--   if useSHAP_FILT=T, set Shapiro-Filter parameters; otherwise just return
      CALL SHAP_FILT_READPARMS( myThid )
#endif

#ifdef ALLOW_ZONAL_FILT
C--   if useZONAL_FILT=T, set Zonal-Filter parameters; otherwise just return
      CALL ZONAL_FILT_READPARMS( myThid )
#endif

#ifdef ALLOW_OPPS
C--   if useOPPS=T, set OPPS parameters; otherwise just return
      CALL OPPS_READPARMS( myThid )
#endif

#ifdef ALLOW_PP81
C--   if usePP81=T, set PP81 parameters; otherwise just return
      CALL PP81_READPARMS( myThid )
#endif

#ifdef ALLOW_KL10
C--   if useKL10=T, set KL10 parameters; otherwise just return
      CALL KL10_READPARMS( myThid )
#endif

#ifdef ALLOW_MY82
C--   if useMY82=T, set MY82 parameters; otherwise just return
      CALL MY82_READPARMS( myThid )
#endif

#ifdef ALLOW_GGL90
C--   if useGGL90=T, set GGL90 parameters; otherwise just return
      CALL GGL90_READPARMS( myThid )
#endif

#ifdef ALLOW_KPP
C--   if useKPP=T, set KPP parameters; otherwise just return
      CALL KPP_READPARMS( myThid )
#endif

#ifdef ALLOW_GMREDI
C--   if useGMRedi=T, set GM/Redi parameters; otherwise just return
      CALL GMREDI_READPARMS( myThid )
#endif

#ifdef ALLOW_BBL
C--   if useBBL=T, set BBL parameters; otherwise just return
      CALL BBL_READPARMS( myThid )
#endif

#ifdef ALLOW_DOWN_SLOPE
C--   if useDOWN_SLOPE=T, set Down-Slope flow parameters; otherwise just return
      CALL DWNSLP_READPARMS( myThid )
#endif

#ifdef ALLOW_BULK_FORCE
C--   if useBulkForce=T, set BULKF parameters; otherwise just return
      CALL BULKF_READPARMS( myThid )
#endif

#ifdef ALLOW_EBM
C--   if useEBM=T, set EBM parameters; otherwise just return
      CALL EBM_READPARMS( myThid )
#endif

#ifdef ALLOW_CHEAPAML
C--   if useCheapAML=T, set CheapAML parameters; otherwise just return
      CALL CHEAPAML_READPARMS( myThid )
#endif

#ifdef ALLOW_FLT
C--   if useFLT=T, set Floats (FLT) parameters; otherwise just return
      CALL FLT_READPARMS( myThid )
#endif /* ALLOW_FLT */

#ifdef ALLOW_LONGSTEP
C--   if usePTRACERS=T, set Long-Step parameters; otherwise just return
C- note : need to call LONGSTEP_READPARMS before PTRACERS_READPARMS
      CALL LONGSTEP_READPARMS( myThid )
#endif
#ifdef ALLOW_PTRACERS
C--   if usePTRACERS=T, set Passive-Traces parameters; otherwise just return
      CALL PTRACERS_READPARMS( myThid )
#endif

#ifdef ALLOW_GCHEM
C--   if useGCHEM=T, set GCHEM parameters; otherwise just return
      CALL GCHEM_READPARMS( myThid )
#endif

#ifdef ALLOW_RBCS
C--   if useRBCS=T, set RBCS parameters; otherwise just return
      CALL RBCS_READPARMS( myThid )
#endif

#ifdef ALLOW_OFFLINE
C--   if useOffLine=T, set OFFLINE parameters; otherwise just return
      CALL OFFLINE_READPARMS( myThid )
#endif

#ifdef ALLOW_MATRIX
C--   if useMATRIX=T, set MATRIX parameters; otherwise just return
      CALL MATRIX_READPARMS( myThid )
#endif

#ifdef ALLOW_STREAMICE
C--   if useStreamIce=T, set STREAMICE parameters; otherwise just return
      CALL STREAMICE_READPARMS( myThid )
#endif

#ifdef ALLOW_SHELFICE
C--   if useShelfIce=T, set SHELFICE parameters; otherwise just return
      CALL SHELFICE_READPARMS( myThid )
#endif

#ifdef ALLOW_STEEP_ICECAVITY
C--   if useSTIC=T, set STEEP_ICECAVITY parameters; otherwise just return
      CALL STIC_READPARMS( myThid )
#endif

#ifdef ALLOW_ICEFRONT
C--   if useICEFRONT=T, set ICEFRONT parameters; otherwise just return
      CALL ICEFRONT_READPARMS( myThid )
#endif

#ifdef ALLOW_SEAICE
C--   if useSEAICE=T, set SEAICE parameters; otherwise just return
      CALL SEAICE_READPARMS( myThid )
#endif

#ifdef ALLOW_SALT_PLUME
C--   if useSALT_PLUME=T, set SALT_PLUME parameters; otherwise just return
      CALL SALT_PLUME_READPARMS( myThid )
#endif

#ifdef ALLOW_THSICE
C--   if useThSIce=T, set Therm.Sea-Ice parameters; otherwise just return
      CALL THSICE_READPARMS( myThid )
#endif

#ifdef ALLOW_LAND
C--   if useLand=T, set LAND pkg parameters; otherwise just return
      CALL LAND_READPARMS( myThid )
#endif

#ifdef ALLOW_AUTODIFF
C--   Initialise autodiff parameters
      CALL AUTODIFF_READPARMS( myThid )
#endif

#ifdef ALLOW_CTRL
C--   Initialise the optim. parameters.
      CALL OPTIM_READPARMS( myThid )
C--   Initialise the control parameters
      CALL CTRL_READPARMS( myThid )
#endif

#ifdef ALLOW_COST
C--   Initialise the cost parameters
      CALL COST_READPARMS( myThid )
#endif

#ifdef ALLOW_GRDCHK
C--   if useGrdChk=T, set gradient-check parameters; otherwise just return
      CALL GRDCHK_READPARMS( myThid )
#endif

#ifdef ALLOW_SMOOTH
C--   if useSMOOTH=T, set SMOOTH parameters; otherwise just return
      CALL SMOOTH_READPARMS( myThid )
#endif

#ifdef ALLOW_ECCO
c--   Initialize ECCO package parameters
      CALL ECCO_READPARMS( myThid )
#endif

#ifdef ALLOW_PROFILES
C--   if usePROFILES=T, set PROFILES parameters; otherwise just return
      CALL PROFILES_READPARMS( myThid )
#endif

#ifdef ALLOW_OBSFIT
C--   if useOBSFIT=T, set OBSFIT parameters; otherwise just return
      CALL OBSFIT_READPARMS( myThid )
#endif

#ifdef ALLOW_SBO
C--   if useSBO=T, set SBO parameters; otherwise just return
      CALL SBO_READPARMS( myThid )
#endif

#ifdef ALLOW_ATM_PHYS
C--   if useAtm_Phys=T, set Atm_Phys parameters; otherwise just return
      CALL ATM_PHYS_READPARMS( myThid )
#endif

#ifdef ALLOW_FIZHI
C--   if useFizhi=T, set fizhi parameters; otherwise just return
      CALL FIZHI_READPARMS( myThid )
#endif /* ALLOW_FIZHI */

#ifdef ALLOW_DIAGNOSTICS
C--   if useDiagnostics=T, set diagnostics choices
C      otherwise, just set pkgStatus=-1 and return
      CALL DIAGNOSTICS_READPARMS( myThid )
#endif /* ALLOW_DIAGNOSTICS */

#ifdef ALLOW_REGRID
C--   if useREGRID=T, set REGRID parameters; otherwise just return
      CALL REGRID_READPARMS( myThid )
#endif /* ALLOW_REGRID */

#ifdef ALLOW_LAYERS
C--   if useLayers=T, set layers parameters; otherwise just return
      CALL LAYERS_READPARMS( myThid )
#endif /* ALLOW_LAYERS */

#ifdef ALLOW_NEST_CHILD
C--    Initialize nest(ing) package parameters x CHILD
       IF (useNEST_CHILD) CALL NEST_CHILD_READPARMS( myThid )
#endif /* ALLOW_NEST_CHILD */
C
#ifdef ALLOW_NEST_PARENT
C--    Initialize nest(ing) package parameters x PARENT
       IF (useNEST_PARENT) CALL NEST_PARENT_READPARMS( myThid )
#endif /* ALLOW_NEST_PARENT */

#ifdef ALLOW_NEST2W_CHILD
C--    Initialize Child 2-way nest(ing) package parameters
       IF (useNest2W_child) CALL NEST2W_C_READPARMS( myThid )
#endif /* ALLOW_NEST2W_CHILD */
C
#ifdef ALLOW_NEST2W_PARENT
C--    Initialize Parent 2-way nest(ing) package parameters
       IF (useNest2W_parent) CALL NEST2W_P_READPARMS( myThid )
#endif /* ALLOW_NEST2W_PARENT */

#ifdef COMPONENT_MODULE
C--   set Coupling parameters
      IF ( useCoupler ) CALL CPL_READPARMS( myThid )
#endif /* COMPONENT_MODULE */

#ifdef ALLOW_OASIS
       IF (useOASIS) CALL OASIS_READPARMS( myThid )
#endif

#ifdef ALLOW_RUNCLOCK
C--   if useRunClock=T, set RUNCLOCK parameters; otherwise just return
      CALL RUNCLOCK_READPARMS( myThid )
#endif

#ifdef ALLOW_MYPACKAGE
C--   if useMYPACKAGE=T, set mypackage parameters; otherwise just return
      CALL MYPACKAGE_READPARMS( myThid )
#endif

      RETURN
      END

#include "AUTODIFF_OPTIONS.h"

C     ==================================================================
C     active_file_g.F: Routines to handle the I/O of the active file for
C                      the tangent linear calculations. All files are
C                      direct access files.
C     Routines
C    o  g_active_read_xy         - Read  an active 2D variable from file.
C    o  g_active_read_xyz        - Read  an active 3D variable from file.
C    o  g_active_read_xz         - Read  an active 2D xz-slice from file.
C    o  g_active_read_yz         - Read  an active 2D yz-slice from file.
C    o  g_active_read_1d         - Read  an active 1D vector from file.
C
C    o  g_active_write_xy        - Write an active 2D variable to a file.
C    o  g_active_write_xyz       - Write an active 3D variable to a file.
C    o  g_active_write_xz        - Write an active 2D xz-slice to a file.
C    o  g_active_write_yz        - Write an active 2D yz-slice to a file.
C    o  g_active_write_1d        - Write an active 1D vector to a file.
C
C        changed: Christian Eckert eckert@mit.edu 24-Apr-2000
C                 - Added routines that do active writes on tiles
C                   instead of a whole thread.
C        changed: heimbach@mit.edu 05-Mar-2001
C                 - added active file handling of xz-/yz-arrays
C        changed: tsmith@oden.utexas.edu 22-Oct-2019
C                 - added 1D vectors
C     ==================================================================

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: g_active_read_xy
C     !INTERFACE:
      subroutine g_active_read_xy(
     I                           active_var_file,
     O                           active_var,
     I                           g_active_var,
     I                           iRec,
     I                           doglobalread,
     I                           lAdInit,
     I                           myOptimIter,
     I                           myThid,
     I                           dummy,
     I                           g_dummy
     &                         )

C     !DESCRIPTION: \bv
C     ==================================================================
C     SUBROUTINE g_active_read_xy
C     ==================================================================
C     o Read an active 2D (XY) variable from file.
C     started: Christian Eckert eckert@mit.edu 30-Jun-1999
C     ==================================================================
C     SUBROUTINE g_active_read_xy
C     ==================================================================
C     \ev

C     !USES:
      IMPLICIT NONE

C     == global variables ==
#include "EEPARAMS.h"
#include "SIZE.h"

C     !INPUT/OUTPUT PARAMETERS:
C     active_var_file:: filename
C     active_var     :: array
C     g_active_var   :: tangent linear  array
C     iRec           :: record number
C     doglobalread   :: flag for global or local read/write
C                       (default: .false.)
C     lAdInit        :: initialisation of corresponding adjoint
C                       variable and write to active file
C     myOptimIter    :: number of optimization iteration (default: 0)
C     myThid         :: thread number for this instance
      CHARACTER*(*) active_var_file
      _RL     active_var(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL     g_active_var(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      INTEGER iRec
      LOGICAL doglobalread
      LOGICAL lAdInit
      INTEGER myOptimIter
      INTEGER myThid
      _RL     dummy, g_dummy

C     !LOCAL VARIABLES:
      CHARACTER*(2) pref
      CHARACTER*(MAX_LEN_FNAM) fname
      INTEGER myNr
      LOGICAL useCurrentDir
CEOP

      pref = 'g_'
      CALL ADD_PREFIX( pref, active_var_file, fname )
      myNr = 1
      useCurrentDir = .FALSE.

      CALL ACTIVE_READ_3D_RL(
     &                 active_var_file, active_var, doglobalread,
     &                 useCurrentDir, lAdInit, iRec, myNr,
     &                 FORWARD_SIMULATION, myOptimIter, myThid )

      CALL ACTIVE_READ_3D_RL(
     &                 fname, g_active_var, doglobalread,
     &                 useCurrentDir, lAdInit, iRec, myNr,
     &                 TANGENT_SIMULATION, myOptimIter, myThid )

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: g_active_read_xyz
C     !INTERFACE:
      subroutine g_active_read_xyz(
     I                            active_var_file,
     O                            active_var,
     I                            g_active_var,
     I                            iRec,
     I                            doglobalread,
     I                            lAdInit,
     I                            myOptimIter,
     I                            myThid,
     I                            dummy,
     I                            g_dummy
     &                           )

C     !DESCRIPTION: \bv
C     ==================================================================
C     SUBROUTINE g_active_read_xyz
C     ==================================================================
C     o Read an active 3D variable from file.
C     started: Christian Eckert eckert@mit.edu 30-Jun-1999
C     ==================================================================
C     SUBROUTINE g_active_read_xyz
C     ==================================================================
C     \ev

C     !USES:
      IMPLICIT NONE

C     == global variables ==
#include "EEPARAMS.h"
#include "SIZE.h"

C     !INPUT/OUTPUT PARAMETERS:
C     active_var_file:: filename
C     active_var     :: array
C     g_active_var   :: tangent linear  array
C     iRec           :: record number
C     doglobalread   :: flag for global or local read/write
C                       (default: .false.)
C     lAdInit        :: initialisation of corresponding adjoint
C                       variable and write to active file
C     myOptimIter    :: number of optimization iteration (default: 0)
C     myThid         :: thread number for this instance
      CHARACTER*(*) active_var_file
      _RL active_var(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      _RL g_active_var(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      INTEGER iRec
      LOGICAL doglobalread
      LOGICAL lAdInit
      INTEGER myOptimIter
      INTEGER myThid
      _RL     dummy, g_dummy

C     !LOCAL VARIABLES:
      CHARACTER*(2) pref
      CHARACTER*(MAX_LEN_FNAM) fname
      INTEGER myNr
      LOGICAL useCurrentDir
CEOP

      pref = 'g_'
      CALL ADD_PREFIX( pref, active_var_file, fname )
      myNr = Nr
      useCurrentDir = .FALSE.

      CALL ACTIVE_READ_3D_RL(
     &                 active_var_file, active_var, doglobalread,
     &                 useCurrentDir, lAdInit, iRec, myNr,
     &                 FORWARD_SIMULATION, myOptimIter, myThid )

      CALL ACTIVE_READ_3D_RL(
     &                 fname, g_active_var, doglobalread,
     &                 useCurrentDir, lAdInit, iRec, myNr,
     &                 TANGENT_SIMULATION, myOptimIter, myThid )

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: g_active_read_xz
C     !INTERFACE:
      subroutine g_active_read_xz(
     I                           active_var_file,
     O                           active_var,
     I                           g_active_var,
     I                           iRec,
     I                           doglobalread,
     I                           lAdInit,
     I                           myOptimIter,
     I                           myThid,
     I                           dummy,
     I                           g_dummy
     &                         )

C     !DESCRIPTION: \bv
C     ==================================================================
C     SUBROUTINE g_active_read_xz
C     ==================================================================
C     o Read an active 2D xz-slice from file.
C     started: heimbach@mit.edu 05-Mar-2001
C     ==================================================================
C     SUBROUTINE g_active_read_xz
C     ==================================================================
C     \ev

C     !USES:
      IMPLICIT NONE

C     == global variables ==
#include "EEPARAMS.h"
#include "SIZE.h"

C     !INPUT/OUTPUT PARAMETERS:
C     active_var_file:: filename
C     active_var     :: array
C     g_active_var   :: tangent linear  array
C     iRec           :: record number
C     doglobalread   :: flag for global or local read/write
C                       (default: .false.)
C     lAdInit        :: initialisation of corresponding adjoint
C                       variable and write to active file
C     myOptimIter    :: number of optimization iteration (default: 0)
C     myThid         :: thread number for this instance
      CHARACTER*(*) active_var_file
      _RL     active_var(1-OLx:sNx+OLx,Nr,nSx,nSy)
      _RL     g_active_var(1-OLx:sNx+OLx,Nr,nSx,nSy)
      INTEGER iRec
      LOGICAL doglobalread
      LOGICAL lAdInit
      INTEGER myOptimIter
      INTEGER myThid
      _RL     dummy, g_dummy

C     !LOCAL VARIABLES:
      CHARACTER*(2) pref
      CHARACTER*(MAX_LEN_FNAM) fname
      INTEGER myNr
      LOGICAL useCurrentDir
CEOP

      pref = 'g_'
      CALL ADD_PREFIX( pref, active_var_file, fname )
      myNr = Nr
      useCurrentDir = .FALSE.

      CALL ACTIVE_READ_XZ_RL(
     &                 active_var_file, active_var, doglobalread,
     &                 useCurrentDir, lAdInit, iRec, myNr,
     &                 FORWARD_SIMULATION, myOptimIter, myThid )

      CALL ACTIVE_READ_XZ_RL(
     &                 fname, g_active_var, doglobalread,
     &                 useCurrentDir, lAdInit, iRec, myNr,
     &                 TANGENT_SIMULATION, myOptimIter, myThid )

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: g_active_read_yz
C     !INTERFACE:
       subroutine g_active_read_yz(
     I                           active_var_file,
     O                           active_var,
     I                           g_active_var,
     I                           iRec,
     I                           doglobalread,
     I                           lAdInit,
     I                           myOptimIter,
     I                           myThid,
     I                           dummy,
     I                           g_dummy
     &                         )

C     !DESCRIPTION: \bv
C     ==================================================================
C     SUBROUTINE g_active_read_yz
C     ==================================================================
C     o Read an active 2D yz-slice from file.
C     started: heimbach@mit.edu 05-Mar-2001
C     ==================================================================
C     SUBROUTINE g_active_read_yz
C     ==================================================================
C     \ev

C     !USES:
      IMPLICIT NONE

C     == global variables ==
#include "EEPARAMS.h"
#include "SIZE.h"

C     !INPUT/OUTPUT PARAMETERS:
C     active_var_file:: filename
C     active_var     :: array
C     g_active_var   :: tangent linear  array
C     iRec           :: record number
C     doglobalread   :: flag for global or local read/write
C                       (default: .false.)
C     lAdInit        :: initialisation of corresponding adjoint
C                       variable and write to active file
C     myOptimIter    :: number of optimization iteration (default: 0)
C     myThid         :: thread number for this instance
      CHARACTER*(*) active_var_file
      _RL     active_var(1-OLy:sNy+OLy,Nr,nSx,nSy)
      _RL     g_active_var(1-OLy:sNy+OLy,Nr,nSx,nSy)
      INTEGER iRec
      LOGICAL doglobalread
      LOGICAL lAdInit
      INTEGER myOptimIter
      INTEGER myThid
      _RL     dummy, g_dummy

C     !LOCAL VARIABLES:
      CHARACTER*(2) pref
      CHARACTER*(MAX_LEN_FNAM) fname
      INTEGER myNr
      LOGICAL useCurrentDir
CEOP

      pref = 'g_'
      CALL ADD_PREFIX( pref, active_var_file, fname )
      myNr = Nr
      useCurrentDir = .FALSE.

      CALL ACTIVE_READ_YZ_RL(
     &                 active_var_file, active_var, doglobalread,
     &                 useCurrentDir, lAdInit, iRec, myNr,
     &                 FORWARD_SIMULATION, myOptimIter, myThid )

      CALL ACTIVE_READ_YZ_RL(
     &                 fname, g_active_var, doglobalread,
     &                 useCurrentDir, lAdInit, iRec, myNr,
     &                 TANGENT_SIMULATION, myOptimIter, myThid )

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: g_active_read_1d
C     !INTERFACE:
      subroutine g_active_read_1d(
     I                           active_var_file,
     O                           active_var,
     I                           g_active_var,
     I                           active_var_length,
     I                           iRec,
     I                           lAdInit,
     I                           myOptimIter,
     I                           myThid,
     I                           dummy,
     I                           g_dummy
     &                         )

C     !DESCRIPTION: \bv
C     ==================================================================
C     SUBROUTINE g_active_read_1d
C     ==================================================================
C     o Read an active 1D vector from file.
C     started: Tim Smith tsmith@oden.utexas.edu 22-Oct-2019
C     ==================================================================
C     SUBROUTINE active_read_1d
C     ==================================================================
C     \ev

C     !USES:
      IMPLICIT NONE

C     == global variables ==
#include "EEPARAMS.h"
#include "SIZE.h"

C     !INPUT/OUTPUT PARAMETERS:
C     active_var_file:: filename
C     active_var     :: array
C     g_active_var   :: tangent linear  array
C     active_var_length :: array length
C     iRec           :: record number
C     lAdInit        :: initialisation of corresponding adjoint
C                       variable and write to active file
C     myOptimIter    :: number of optimization iteration (default: 0)
C     myThid         :: thread number for this instance
      CHARACTER*(*) active_var_file
      _RL     active_var(*)
      _RL     g_active_var(*)
      INTEGER active_var_length
      INTEGER iRec
      LOGICAL lAdInit
      INTEGER myOptimIter
      INTEGER myThid
      _RL     dummy
      _RL     g_dummy

C     !FUNCTIONS:
      INTEGER  ILNBLNK
      EXTERNAL ILNBLNK

C     !LOCAL VARIABLES:
      CHARACTER*(2) pref
      CHARACTER*(MAX_LEN_FNAM) fname
      INTEGER il
CEOP

      pref = 'g_'
      il   = ILNBLNK( active_var_file )
      WRITE(fname,'(2A)') pref, active_var_file(1:il)

      CALL ACTIVE_READ_1D_RL(
     &                 active_var_file, active_var, active_var_length,
     &                 lAdInit, iRec,
     &                 FORWARD_SIMULATION, myOptimIter, myThid )

      CALL ACTIVE_READ_1D_RL(
     &                 fname, g_active_var, active_var_length,
     &                 lAdInit, iRec,
     &                 TANGENT_SIMULATION, myOptimIter, myThid )

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: g_active_write_xy
C     !INTERFACE:
      subroutine g_active_write_xy(
     I                            active_var_file,
     I                            active_var,
     I                            g_active_var,
     I                            iRec,
     I                            myOptimIter,
     I                            myThid,
     I                            dummy,
     I                            g_dummy
     &                          )

C     !DESCRIPTION: \bv
C     ==================================================================
C     SUBROUTINE g_active_write_xy
C     ==================================================================
C     o Write an active 2D variable to a file.
C     started: Christian Eckert eckert@mit.edu 30-Jun-1999
C     ==================================================================
C     SUBROUTINE g_active_write_xy
C     ==================================================================
C     \ev

C     !USES:
      IMPLICIT NONE

C     == global variables ==
#include "EEPARAMS.h"
#include "SIZE.h"

C     !INPUT/OUTPUT PARAMETERS:
C     active_var_file:: filename
C     active_var     :: array
C     g_active_var   :: tangent linear  array
C     iRec           :: record number
C     myOptimIter    :: number of optimization iteration (default: 0)
C     myThid         :: thread number for this instance
      CHARACTER*(*) active_var_file
      _RL     active_var(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL     g_active_var(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      INTEGER iRec
      INTEGER myOptimIter
      INTEGER myThid
      _RL     dummy
      _RL     g_dummy

C     !LOCAL VARIABLES:
      CHARACTER*(2) pref
      CHARACTER*(MAX_LEN_FNAM) fname
      INTEGER myNr
      LOGICAL globalFile
      LOGICAL useCurrentDir
CEOP

      pref = 'g_'
      CALL ADD_PREFIX( pref, active_var_file, fname )
      myNr = 1
      globalFile = .FALSE.
      useCurrentDir = .FALSE.

      CALL ACTIVE_WRITE_3D_RL(
     &                 active_var_file, active_var, globalFile,
     &                 useCurrentDir, iRec, myNr,
     &                 FORWARD_SIMULATION, myOptimIter, myThid )

      CALL ACTIVE_WRITE_3D_RL(
     &                 fname, g_active_var, globalFile,
     &                 useCurrentDir, iRec, myNr,
     &                 TANGENT_SIMULATION, myOptimIter, myThid )

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: g_active_write_xyz
C     !INTERFACE:
      subroutine g_active_write_xyz(
     I                             active_var_file,
     I                             active_var,
     I                             g_active_var,
     I                             iRec,
     I                             myOptimIter,
     I                             myThid,
     I                             dummy,
     I                             g_dummy
     &                           )

C     !DESCRIPTION: \bv
C     ==================================================================
C     SUBROUTINE g_active_write_xyz
C     ==================================================================
C     o Write an active 3D variable to a file.
C     started: Christian Eckert eckert@mit.edu 30-Jun-1999
C     ==================================================================
C     SUBROUTINE g_active_write_xyz
C     ==================================================================
C     \ev

C     !USES:
      IMPLICIT NONE

C     == global variables ==
#include "EEPARAMS.h"
#include "SIZE.h"

C     !INPUT/OUTPUT PARAMETERS:
C     active_var_file:: filename
C     active_var     :: array
C     g_active_var   :: tangent linear  array
C     iRec           :: record number
C     myOptimIter    :: number of optimization iteration (default: 0)
C     myThid         :: thread number for this instance
      CHARACTER*(*) active_var_file
      _RL active_var(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      _RL g_active_var(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      INTEGER iRec
      INTEGER myOptimIter
      INTEGER myThid
      _RL     dummy
      _RL     g_dummy

C     !LOCAL VARIABLES:
      CHARACTER*(2) pref
      CHARACTER*(MAX_LEN_FNAM) fname
      INTEGER myNr
      LOGICAL globalFile
      LOGICAL useCurrentDir
CEOP

      pref = 'g_'
      CALL ADD_PREFIX( pref, active_var_file, fname )
      myNr = Nr
      globalFile = .FALSE.
      useCurrentDir = .FALSE.

      CALL ACTIVE_WRITE_3D_RL(
     &                 active_var_file, active_var, globalFile,
     &                 useCurrentDir, iRec, myNr,
     &                 FORWARD_SIMULATION, myOptimIter, myThid )

      CALL ACTIVE_WRITE_3D_RL(
     &                 fname, g_active_var, globalFile,
     &                 useCurrentDir, iRec, myNr,
     &                 TANGENT_SIMULATION, myOptimIter, myThid )

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: g_active_write_xz
C     !INTERFACE:
      subroutine g_active_write_xz(
     I                            active_var_file,
     I                            active_var,
     I                            g_active_var,
     I                            iRec,
     I                            myOptimIter,
     I                            myThid,
     I                            dummy,
     I                            g_dummy
     &                          )

C     !DESCRIPTION: \bv
C     ==================================================================
C     SUBROUTINE g_active_write_xz
C     ==================================================================
C     o Write an active 2D xz-slice to a file.
C     started: heimbach@mit.edu 05-Mar-2001
C     ==================================================================
C     SUBROUTINE g_active_write_xz
C     ==================================================================
C     \ev

C     !USES:
      IMPLICIT NONE

C     == global variables ==
#include "EEPARAMS.h"
#include "SIZE.h"

C     !INPUT/OUTPUT PARAMETERS:
C     active_var_file:: filename
C     active_var     :: array
C     g_active_var   :: tangent linear  array
C     iRec           :: record number
C     myOptimIter    :: number of optimization iteration (default: 0)
C     myThid         :: thread number for this instance
      CHARACTER*(*) active_var_file
      _RL     active_var(1-OLx:sNx+OLx,Nr,nSx,nSy)
      _RL     g_active_var(1-OLx:sNx+OLx,Nr,nSx,nSy)
      INTEGER iRec
      INTEGER myOptimIter
      INTEGER myThid
      _RL     dummy
      _RL     g_dummy

C     !LOCAL VARIABLES:
      CHARACTER*(2) pref
      CHARACTER*(MAX_LEN_FNAM) fname
      INTEGER myNr
      LOGICAL globalFile
      LOGICAL useCurrentDir
CEOP

      pref = 'g_'
      CALL ADD_PREFIX( pref, active_var_file, fname )
      myNr = Nr
      globalFile = .FALSE.
      useCurrentDir = .FALSE.

      CALL ACTIVE_WRITE_XZ_RL(
     &                 active_var_file, active_var, globalFile,
     &                 useCurrentDir, iRec, myNr,
     &                 FORWARD_SIMULATION, myOptimIter, myThid )

      CALL ACTIVE_WRITE_XZ_RL(
     &                 fname, g_active_var, globalFile,
     &                 useCurrentDir, iRec, myNr,
     &                 TANGENT_SIMULATION, myOptimIter, myThid )

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: g_active_write_yz
C     !INTERFACE:
      subroutine g_active_write_yz(
     I                            active_var_file,
     I                            active_var,
     I                            g_active_var,
     I                            iRec,
     I                            myOptimIter,
     I                            myThid,
     I                            dummy,
     I                            g_dummy
     &                          )

C     !DESCRIPTION: \bv
C     ==================================================================
C     SUBROUTINE g_active_write_yz
C     ==================================================================
C     o Write an active 2D variable to a file.
C     started: heimbach@mit.edu 05-Mar-2001
C     ==================================================================
C     SUBROUTINE g_active_write_yz
C     ==================================================================
C     \ev

C     !USES:
      IMPLICIT NONE

C     == global variables ==
#include "EEPARAMS.h"
#include "SIZE.h"

C     !INPUT/OUTPUT PARAMETERS:
C     active_var_file:: filename
C     active_var     :: array
C     g_active_var   :: tangent linear  array
C     iRec           :: record number
C     myOptimIter    :: number of optimization iteration (default: 0)
C     myThid         :: thread number for this instance
      CHARACTER*(*) active_var_file
      _RL     active_var(1-OLy:sNy+OLy,Nr,nSx,nSy)
      _RL     g_active_var(1-OLy:sNy+OLy,Nr,nSx,nSy)
      INTEGER iRec
      INTEGER myOptimIter
      INTEGER myThid
      _RL     dummy
      _RL     g_dummy

C     !LOCAL VARIABLES:
      CHARACTER*(2) pref
      CHARACTER*(MAX_LEN_FNAM) fname
      INTEGER myNr
      LOGICAL globalFile
      LOGICAL useCurrentDir
CEOP

      pref = 'g_'
      CALL ADD_PREFIX( pref, active_var_file, fname )
      myNr = Nr
      globalFile = .FALSE.
      useCurrentDir = .FALSE.

      CALL ACTIVE_WRITE_YZ_RL(
     &                 active_var_file, active_var, globalFile,
     &                 useCurrentDir, iRec, myNr,
     &                 FORWARD_SIMULATION, myOptimIter, myThid )

      CALL ACTIVE_WRITE_YZ_RL(
     &                 fname, g_active_var, globalFile,
     &                 useCurrentDir, iRec, myNr,
     &                 TANGENT_SIMULATION, myOptimIter, myThid )

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: g_active_write_1d
C     !INTERFACE:
      subroutine g_active_write_1d(
     I                           active_var_file,
     I                           active_var,
     I                           g_active_var,
     I                           active_var_length,
     I                           iRec,
     I                           myOptimIter,
     I                           myThid,
     I                           dummy,
     I                           g_dummy
     &                         )

C     !DESCRIPTION: \bv
C     ==================================================================
C     SUBROUTINE g_active_write_1d
C     ==================================================================
C     o Write an active 1D vector to file.
C     started: Tim Smith tsmith@oden.utexas.edu 22-Oct-2019
C     ==================================================================
C     SUBROUTINE active_write_1d
C     ==================================================================
C     \ev

C     !USES:
      IMPLICIT NONE

C     == global variables ==
#include "EEPARAMS.h"
#include "SIZE.h"

C     !INPUT/OUTPUT PARAMETERS:
C     active_var_file:: filename
C     active_var     :: array
C     g_active_var   :: tangent linear  array
C     active_var_length :: array length
C     iRec           :: record number
C     myOptimIter    :: number of optimization iteration (default: 0)
C     myThid         :: thread number for this instance
      CHARACTER*(*) active_var_file
      _RL     active_var(*)
      _RL     g_active_var(*)
      INTEGER active_var_length
      INTEGER iRec
      INTEGER myOptimIter
      INTEGER myThid
      _RL     dummy
      _RL     g_dummy

C     !FUNCTIONS:
      INTEGER  ILNBLNK
      EXTERNAL ILNBLNK

C     !LOCAL VARIABLES:
      CHARACTER*(2) pref
      CHARACTER*(MAX_LEN_FNAM) fname
      INTEGER il
CEOP

      pref = 'g_'
      il   = ILNBLNK( active_var_file )
      WRITE(fname,'(2A)') pref, active_var_file(1:il)

      CALL ACTIVE_WRITE_1D_RL(
     &                 active_var_file, active_var, active_var_length,
     &                 iRec, FORWARD_SIMULATION, myOptimIter, myThid )

      CALL ACTIVE_WRITE_1D_RL(
     &                 fname, g_active_var, active_var_length,
     &                 iRec, TANGENT_SIMULATION, myOptimIter, myThid )

      RETURN
      END

#include "AIM_OPTIONS.h"

      SUBROUTINE VDIFSC (dpFac,SE,RH,QA,QSAT,
     O                   TTENVD,QTENVD,
     I                   kGrd,bi,bj,myThid)
C--
C--   SUBROUTINE VDIFSC (UA,VA,SE,RH,QA,QSAT,PHI,
C--  &                   UTENVD,VTENVD,TTENVD,QTENVD)
C--
C--   Purpose: Compute tendencies of momentum, energy and moisture
C--            due to vertical diffusion and shallow convection
C--   Input:   UA     = u-wind                           (3-dim)
C--            VA     = v-wind                           (3-dim)
C              dpFac  = cell delta_P fraction            (3-dim)
C--            SE     = dry static energy                (3-dim)
C--            RH     = relative humidity [0-1]          (3-dim)
C--            QA     = specific humidity [g/kg]         (3-dim)
C--            QSAT   = saturation sp. humidity [g/kg]   (3-dim)
C--            PHI    = geopotential                     (3-dim)
C--   Output:  UTENVD = u-wind tendency                  (3-dim)
C--            VTENVD = v-wind tendency                  (3-dim)
C--            TTENVD = temperature tendency             (3-dim)
C--            QTENVD = sp. humidity tendency [g/(kg s)] (3-dim)
C    Input:    kGrd   = Ground level index               (2-dim)
C              bi,bj  = tile index
C           myThid    = Thread number for this instance of the routine
C-------
C  Note: a) dry static energy (SE,input) has been replaced by Pot.Temp.
C        b) UA,VA & U,V_TENVD not used => removed 
C-------
C In contrast to other Physics S/R, VDIFSC return a real tendency (dQ/dt,dT/dt)
C  nevertheless /dpFac is not applied here but later in AIM_AIM2DYN
C-------

      IMPLICIT NONE

C     Resolution parameters

C-- size for MITgcm & Physics package :
#include "AIM_SIZE.h"

#include "EEPARAMS.h"

C     Physical constants + functions of sigma and latitude
#include "com_physcon.h"

C     Vertical diffusion constants
#include "com_vdicon.h"

C-- Routine arguments:
c     _RL  UA(NGP,NLEV), VA(NGP,NLEV)
      _RL  dpFac(NGP,NLEV)
      _RL  SE(NGP,NLEV), RH(NGP,NLEV), QA(NGP,NLEV), QSAT(NGP,NLEV)
c     _RL  PHI(NGP,NLEV)

c     _RL  UTENVD(NGP,NLEV), VTENVD(NGP,NLEV)
      _RL  TTENVD(NGP,NLEV), QTENVD(NGP,NLEV)

      INTEGER  kGrd(NGP)
      INTEGER  bi,bj,myThid

#ifdef ALLOW_AIM

C-- Local variables:
      INTEGER J, K, Ktmp, NL1
      _RL  RSIG(NLEV)
      _RL  dSEdp(NGP,NLEV-1), DeltaPI(NLEV-1), factP

C- jmc: declare all local variables:
      _RL  CVDI(NGP), FSHCQ
      _RL  DRH0, DRH, DMSE, FLUXSE, FLUXQ
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C--   1. Initalization

C     N.B. In this routine, fluxes of dry static energy and humidity
C          are scaled in such a way that:
C          d_T/dt = d_F'(SE)/d_sigma,  d_Q/dt = d_F'(Q)/d_sigma

c_FM  NL1  = NLEV-1
c_FM  CSHC = DSIG(NLEV)/3600.
c_FM  CVDI = (SIGH(NL1)-SIGH(1))/((NL1-1)*3600.)

c_FM  FSHCQ  = CSHC/TRSHC
c_FM  FSHCSE = CSHC/(TRSHC*CP)

c_FM  FVDIQ  = CVDI/TRVDI
c_FM  FVDISE = CVDI/(TRVDS*CP)

      DO J=1,NGP
        NL1 = kGrd(J)-1
        CVDI(J) = 0.
        IF (NL1.GE.2) THEN
          CVDI(J) = (SIGH(NL1)-SIGH(1))/((NL1-1)*3600. _d 0)
        ENDIF
      ENDDO

      DO K=1,NLEV
        RSIG(K)=1./DSIG(K)
      ENDDO

      DO K=1,NLEV
        DO J=1,NGP
c         UTENVD(J,K) = 0.
c         VTENVD(J,K) = 0.
          TTENVD(J,K) = 0.
          QTENVD(J,K) = 0.
        ENDDO
      ENDDO

C ---------------------------------------------
C    Write Conditional stability based on Pot.Temp :
C    dSEdp(K) = Delta[Static-Energy] between 2 Plevels(k,k+1)
C    and corresponds to SE(K+1)-SE(K) in the original code
C -------
      DO K=1,NLEV-1
       factP = CP*SIGH(K)**(RD/CP)
       DO J=1,NGP
         dSEdp(J,K)=(SE(J,K+1)-SE(J,K))*factP
       ENDDO
       DeltaPI(K) = SIG(K+1)**(RD/CP) - SIG(K)**(RD/CP)
      ENDDO

C--   2. Shallow convection

      DO J=1,NGP
        Ktmp = kGrd(J)
        NL1 = Ktmp - 1
       IF (Ktmp.GE.2) THEN

        DRH0=RHGRAD*(SIG(Ktmp)-SIG(NL1))
        FSHCQ = DSIG(Ktmp)*dpFac(J,Ktmp)/(TRSHC*3600. _d 0)

c_FM    DMSE = (SE(J,NLEV)-SE(J,NL1))+ALHC*(QA(J,NLEV)-QSAT(J,NL1))
        DMSE = dSEdp(J,NL1)         + ALHC*(QA(J,Ktmp)-QSAT(J,NL1))
        DRH  = RH(J,Ktmp)-RH(J,NL1)

        IF (DMSE.GE.0.0) THEN

c_FM      FLUXSE         = FSHCSE*DMSE
          FLUXSE         = FSHCQ *DMSE/CP
          TTENVD(J,NL1)  = FLUXSE*RSIG(NL1)
          TTENVD(J,Ktmp) =-FLUXSE*RSIG(Ktmp)

          IF (DRH.GE.0.0) THEN
            FLUXQ          = FSHCQ*QSAT(J,Ktmp)*DRH
            QTENVD(J,NL1)  = FLUXQ*RSIG(NL1)
            QTENVD(J,Ktmp) =-FLUXQ*RSIG(Ktmp)
          ENDIF

        ELSE IF (DRH.GE.DRH0) THEN

c_FM      FLUXQ          = FVDIQ*QSAT(J,NL1)*DRH
          FLUXQ          = QSAT(J,NL1)*DRH*CVDI(J)/TRVDI
          QTENVD(J,NL1)  = FLUXQ*RSIG(NL1)
          QTENVD(J,Ktmp) =-FLUXQ*RSIG(Ktmp)

        ENDIF

       ENDIF
      ENDDO

C--   3. Vertical diffusion of moisture above the PBL

      DO J=1,NGP

        DO K=3,kGrd(J)-2

          DRH0=RHGRAD*(SIG(K+1)-SIG(K))

          DRH=RH(J,K+1)-RH(J,K)

          IF (DRH.GE.DRH0) THEN
c_FM        FLUXQ        = FVDIQ*QSAT(J,K)*DRH
            FLUXQ        = QSAT(J,K)*DRH*CVDI(J)/TRVDI
            QTENVD(J,K)  = QTENVD(J,K)  +FLUXQ*RSIG(K)
            QTENVD(J,K+1)= QTENVD(J,K+1)-FLUXQ*RSIG(K+1)
          ENDIF

        ENDDO

      ENDDO

C--   4. Damping of super-adiabatic lapse rate

      DO J=1,NGP
       DO K=1,kGrd(J)-1

c_FM     SE0 = SE(J,K+1)+SEGRAD*(PHI(J,K)-PHI(J,K+1))
         DMSE = dSEdp(J,K)
     &        +SEGRAD*CP*DeltaPI(K)*(SE(J,K+1)+SE(J,K))*0.5 _d 0

c_FM     IF (SE(J,K).LT.SE0) THEN
c_FM       FLUXSE        = FVDISE*(SE0-SE(J,K))
         IF (DMSE.GT.0.) THEN
           FLUXSE        = DMSE*CVDI(J)/(TRVDS*CP)
           TTENVD(J,K  ) = TTENVD(J,K  )+FLUXSE*RSIG(K)
           TTENVD(J,K+1) = TTENVD(J,K+1)-FLUXSE*RSIG(K+1)
         ENDIF

       ENDDO
      ENDDO
C--
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
#endif /* ALLOW_AIM */

      RETURN
      END

#include "CPP_OPTIONS.h"

C--  File apply_forcing.F:
C--   Contents
C--   o APPLY_FORCING_U
C--   o APPLY_FORCING_V
C--   o APPLY_FORCING_T
C--   o APPLY_FORCING_S

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: APPLY_FORCING_U
C     !INTERFACE:
      SUBROUTINE APPLY_FORCING_U(
     U                     gU_arr,
     I                     iMin,iMax,jMin,jMax, k, bi, bj,
     I                     myTime, myIter, myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R APPLY_FORCING_U
C     | o Contains problem specific forcing for zonal velocity.
C     *==========================================================*
C     | Adds terms to gU for forcing by external sources
C     | e.g. wind stress, bottom friction etc ...
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     == Global data ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "SURFACE.h"
#include "DYNVARS.h"
#include "FFIELDS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     gU_arr    :: the tendency array
C     iMin,iMax :: Working range of x-index for applying forcing.
C     jMin,jMax :: Working range of y-index for applying forcing.
C     k         :: Current vertical level index
C     bi,bj     :: Current tile indices
C     myTime    :: Current time in simulation
C     myIter    :: Current iteration number
C     myThid    :: my Thread Id number
      _RL     gU_arr(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER iMin, iMax, jMin, jMax
      INTEGER k, bi, bj
      _RL     myTime
      INTEGER myIter
      INTEGER myThid

C     !LOCAL VARIABLES:
C     i,j       :: Loop counters
      INTEGER i, j
CEOP
      _RL recip_P0g, termP, rFullDepth
      _RL kV, kF, sigma_b

C--   Forcing term
      kF = 1. _d 0/86400. _d 0
      sigma_b = 0.7 _d 0
      rFullDepth = rF(1)-rF(Nr+1)
c     DO j=1,sNy
C-jmc: Without CD-scheme, this is OK ; but with CD-scheme, needs to cover [0:sNy+1]
      DO j=0,sNy+1
       DO i=1,sNx+1
        IF ( maskW(i,j,k,bi,bj).EQ.oneRS ) THEN
         IF ( selectSigmaCoord.EQ.0 ) THEN
          recip_P0g = MAX(recip_Rcol(i,j,bi,bj),recip_Rcol(i-1,j,bi,bj))
          termP = 0.5 _d 0*( MIN( rF(k)*recip_P0g, oneRL )
     &                      +rF(k+1)*recip_P0g )
c         termP = 0.5 _d 0*( rF(k) + rF(k+1) )*recip_P0g
         ELSE
C-- Pressure at U.point :
c         midP = rLowW(i,j,bi,bj) + aHybSigmC(k)*rFullDepth
c    &         + bHybSigmC(k)
c    &          *(etaHw(i,j,bi,bj)+rSurfW(i,j,bi,bj)-rLowW(i,j,bi,bj))
C-- Sigma at U.point :
c         termP = ( midP - rLowW(i,j,bi,bj))
c    &          /(etaHw(i,j,bi,bj)+rSurfW(i,j,bi,bj)-rLowW(i,j,bi,bj))
C-  which simplifies to:
          termP = aHybSigmC(k)*rFullDepth
#ifdef NONLIN_FRSURF
     &          /(etaHw(i,j,bi,bj)+rSurfW(i,j,bi,bj)-rLowW(i,j,bi,bj))
#else
     &          /(rSurfW(i,j,bi,bj)-rLowW(i,j,bi,bj))
#endif
     &          + bHybSigmC(k)
         ENDIF
         kV = kF*MAX( zeroRL, (termP-sigma_b)/(1. _d 0-sigma_b) )
         gU_arr(i,j) = gU_arr(i,j)
     &               - kV*uVel(i,j,k,bi,bj)
        ENDIF
       ENDDO
      ENDDO

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: APPLY_FORCING_V
C     !INTERFACE:
      SUBROUTINE APPLY_FORCING_V(
     U                     gV_arr,
     I                     iMin,iMax,jMin,jMax, k, bi, bj,
     I                     myTime, myIter, myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R APPLY_FORCING_V
C     | o Contains problem specific forcing for merid velocity.
C     *==========================================================*
C     | Adds terms to gV for forcing by external sources
C     | e.g. wind stress, bottom friction etc ...
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     == Global data ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "SURFACE.h"
#include "DYNVARS.h"
#include "FFIELDS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     gV_arr    :: the tendency array
C     iMin,iMax :: Working range of x-index for applying forcing.
C     jMin,jMax :: Working range of y-index for applying forcing.
C     k         :: Current vertical level index
C     bi,bj     :: Current tile indices
C     myTime    :: Current time in simulation
C     myIter    :: Current iteration number
C     myThid    :: my Thread Id number
      _RL     gV_arr(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER iMin, iMax, jMin, jMax
      INTEGER k, bi, bj
      _RL     myTime
      INTEGER myIter
      INTEGER myThid

C     !LOCAL VARIABLES:
C     i,j       :: Loop counters
      INTEGER i, j
CEOP
      _RL recip_P0g, termP, rFullDepth
      _RL kV, kF, sigma_b

C--   Forcing term
      kF = 1. _d 0/86400. _d 0
      sigma_b = 0.7 _d 0
      rFullDepth = rF(1)-rF(Nr+1)
      DO j=1,sNy+1
c      DO i=1,sNx
C-jmc: Without CD-scheme, this is OK ; but with CD-scheme, needs to cover [0:sNx+1]
       DO i=0,sNx+1
        IF ( maskS(i,j,k,bi,bj).EQ.oneRS ) THEN
         IF ( selectSigmaCoord.EQ.0 ) THEN
          recip_P0g = MAX(recip_Rcol(i,j,bi,bj),recip_Rcol(i,j-1,bi,bj))
          termP = 0.5 _d 0*( MIN( rF(k)*recip_P0g, oneRL )
     &                      +rF(k+1)*recip_P0g )
c         termP = 0.5 _d 0*( rF(k) + rF(k+1) )*recip_P0g
         ELSE
C-- Pressure at V.point :
c         midP = rLowS(i,j,bi,bj) + aHybSigmC(k)*rFullDepth
c    &         + bHybSigmC(k)
c    &          *(etaHs(i,j,bi,bj)+rSurfS(i,j,bi,bj)-rLowS(i,j,bi,bj))
C-- Sigma at V.point :
c         termP = ( midP - rLowS(i,j,bi,bj))
c    &          /(etaHs(i,j,bi,bj)+rSurfS(i,j,bi,bj)-rLowS(i,j,bi,bj))
C-  which simplifies to:
          termP = aHybSigmC(k)*rFullDepth
#ifdef NONLIN_FRSURF
     &          /(etaHs(i,j,bi,bj)+rSurfS(i,j,bi,bj)-rLowS(i,j,bi,bj))
#else
     &          /(rSurfS(i,j,bi,bj)-rLowS(i,j,bi,bj))
#endif
     &          + bHybSigmC(k)
         ENDIF
         kV = kF*MAX( zeroRL, (termP-sigma_b)/(1. _d 0-sigma_b) )
         gV_arr(i,j) = gV_arr(i,j)
     &               - kV*vVel(i,j,k,bi,bj)
        ENDIF
       ENDDO
      ENDDO

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: APPLY_FORCING_T
C     !INTERFACE:
      SUBROUTINE APPLY_FORCING_T(
     U                     gT_arr,
     I                     iMin,iMax,jMin,jMax, k, bi, bj,
     I                     myTime, myIter, myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R APPLY_FORCING_T
C     | o Contains problem specific forcing for temperature.
C     *==========================================================*
C     | Adds terms to gT for forcing by external sources
C     | e.g. heat flux, climatalogical relaxation, etc ...
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     == Global data ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "DYNVARS.h"
#include "FFIELDS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     gT_arr    :: the tendency array
C     iMin,iMax :: Working range of x-index for applying forcing.
C     jMin,jMax :: Working range of y-index for applying forcing.
C     k         :: Current vertical level index
C     bi,bj     :: Current tile indices
C     myTime    :: Current time in simulation
C     myIter    :: Current iteration number
C     myThid    :: my Thread Id number
      _RL     gT_arr(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER iMin, iMax, jMin, jMax
      INTEGER k, bi, bj
      _RL     myTime
      INTEGER myIter
      INTEGER myThid

C     !LOCAL VARIABLES:
C     i,j       :: Loop counters
C     kSurface  :: index of surface level
      INTEGER i, j
CEOP
      _RL thetaLim, kT, ka, ks, sigma_b, term1, term2, thetaEq
      _RL termP, rFullDepth

C--   Forcing term
      ka = 1. _d 0/(40. _d 0*86400. _d 0)
      ks = 1. _d 0/(4. _d 0 *86400. _d 0)
      sigma_b = 0.7 _d 0
      rFullDepth = rF(1)-rF(Nr+1)
      DO j=0,sNy+1
       DO i=0,sNx+1
         term1 = 60. _d 0*(SIN(yC(i,j,bi,bj)*deg2rad)**2)
         termP = 0.5 _d 0*( rF(k) + rF(k+1) )
         term2 = 10. _d 0*LOG(termP/atm_po)
     &            *(COS(yC(i,j,bi,bj)*deg2rad)**2)
         thetaLim = 200. _d 0/ ((termP/atm_po)**atm_kappa)
         thetaEq = 315. _d 0 - term1 - term2
         thetaEq = MAX(thetaLim,thetaEq)
         IF ( selectSigmaCoord.EQ.0 ) THEN
          termP = 0.5 _d 0*( MIN(rF(k),Ro_surf(i,j,bi,bj))
     &                     + rF(k+1) )
     &                    *recip_Rcol(i,j,bi,bj)
         ELSE
C-- Pressure at T.point :
c         midP = R_low(i,j,bi,bj) + aHybSigmC(k)*rFullDepth
c    &         + bHybSigmC(k)
c    &          *(etaH(i,j,bi,bj)+Ro_surf(i,j,bi,bj)-R_low(i,j,bi,bj))
C-- Sigma at T.point :
c         termP = ( midP - R_low(i,j,bi,bj))
c    &          /(etaH(i,j,bi,bj)+Ro_surf(i,j,bi,bj)-R_low(i,j,bi,bj))
C-  which simplifies to:
          termP = aHybSigmC(k)*rFullDepth
#ifdef NONLIN_FRSURF
     &          /(etaH(i,j,bi,bj)+Ro_surf(i,j,bi,bj)-R_low(i,j,bi,bj))
#else
     &          /(Ro_surf(i,j,bi,bj)-R_low(i,j,bi,bj))
#endif
     &          + bHybSigmC(k)
         ENDIF
         kT = ka+(ks-ka)
     &      *MAX( zeroRL, (termP-sigma_b)/(1. _d 0-sigma_b) )
     &      *COS((yC(i,j,bi,bj)*deg2rad))**4
         gT_arr(i,j) = gT_arr(i,j)
     &               - kT*( theta(i,j,k,bi,bj)-thetaEq )
     &                *maskC(i,j,k,bi,bj)
       ENDDO
      ENDDO

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: APPLY_FORCING_S
C     !INTERFACE:
      SUBROUTINE APPLY_FORCING_S(
     U                     gS_arr,
     I                     iMin,iMax,jMin,jMax, k, bi, bj,
     I                     myTime, myIter, myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R APPLY_FORCING_S
C     | o Contains problem specific forcing for merid velocity.
C     *==========================================================*
C     | Adds terms to gS for forcing by external sources
C     | e.g. fresh-water flux, climatalogical relaxation, etc ...
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     == Global data ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "DYNVARS.h"
#include "FFIELDS.h"
#include "SURFACE.h"

C     !INPUT/OUTPUT PARAMETERS:
C     gS_arr    :: the tendency array
C     iMin,iMax :: Working range of x-index for applying forcing.
C     jMin,jMax :: Working range of y-index for applying forcing.
C     k         :: Current vertical level index
C     bi,bj     :: Current tile indices
C     myTime    :: Current time in simulation
C     myIter    :: Current iteration number
C     myThid    :: my Thread Id number
      _RL     gS_arr(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER iMin, iMax, jMin, jMax
      INTEGER k, bi, bj
      _RL     myTime
      INTEGER myIter
      INTEGER myThid

C     !LOCAL VARIABLES:
C     i,j       :: Loop counters
c     INTEGER i, j
CEOP

C--   Forcing term

      RETURN
      END

#include "PROFILES_OPTIONS.h"
#include "AD_CONFIG.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C !ROUTINE: PROFILES_INIT_NCFILE

C !INTERFACE:
      SUBROUTINE PROFILES_INIT_NCFILE(
     & num_file,fid1,file2,fid2,length,Zlength,bi,bj,myThid)

C     !DESCRIPTION:
C     Initialization of model counterparts files
C     for netcdf profiles data
C     Started: Gael Forget 15-March-2006

C     !USES:
      IMPLICIT NONE
C     == Global variables ===
#include "EEPARAMS.h"
#include "SIZE.h"
#include "GRID.h"
#include "DYNVARS.h"
#ifdef ALLOW_PROFILES
# include "PROFILES_SIZE.h"
# include "profiles.h"
# include "netcdf.inc"
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     myThid: my thread ID number
      INTEGER num_file, fid1
      CHARACTER*(*) file2
      INTEGER fid2, length, Zlength
      INTEGER bi, bj, myThid
CEOP

#ifdef ALLOW_PROFILES
C     !LOCAL VARIABLES:
      INTEGER k,err,vecid(2)
      INTEGER irec,num_var,dimId1,dimId2,varId(2*NVARMAX),varId0
      _RL tmp_vec(Zlength+1)
      CHARACTER*(MAX_LEN_MBUF) msgBuf

      IF (profilesDoNcOutput) THEN
C1) Creation :
        err = NF_CREATE( file2, NF_CLOBBER, fid2 )
        CALL PROFILES_NF_ERROR( 'INIT_NCFILE: NF_CREATE fid2',
     &       err,bi,bj,myThid )
        err = NF_DEF_DIM( fid2,'iDEPTH', Zlength, dimId1 )
        CALL PROFILES_NF_ERROR( 'INIT_NCFILE: NF_DEF_DIM Zlength',
     &       err,bi,bj,myThid )
        err = NF_DEF_DIM( fid2,'iPROF', length, dimId2 )
        CALL PROFILES_NF_ERROR( 'INIT_NCFILE: NF_DEF_DIM length',
     &       err,bi,bj,myThid )

        vecid(1)=dimId1
        vecid(2)=dimId2

        err = NF_DEF_VAR( fid2, 'prof_ind_glob',
     &        NF_INT, 1, vecid(2), varId(1) )
        CALL PROFILES_NF_ERROR(
     &       'INIT_NCFILE: NF_DEF_VAR prof_ind_glob',
     &       err,bi,bj,myThid )
        err = NF_PUT_ATT_INT( fid2, varId(1),
     &        '_FillValue', NF_INT, 1, 0 )
        CALL PROFILES_NF_ERROR(
     &       'INIT_NCFILE: NF_PUT_ATT_INT varId(1)',
     &       err,bi,bj,myThid )

        DO num_var = 1, NVARMAX
          err = NF_INQ_VARID( fid1,
     &          prof_names(num_file,num_var), varId0 )
          IF (err.EQ.NF_NOERR) THEN
            WRITE(msgBuf,'(2A)')
     &       'S/R PROFILES_INIT_NCFILE: defining new variable ',
     &       prof_names(num_file,num_var)
            CALL PRINT_MESSAGE( msgBuf,
     &           standardMessageUnit, SQUEEZE_RIGHT, myThid )

            err = NF_DEF_VAR( fid2, prof_names(num_file,num_var),
     &            NF_DOUBLE, 2, vecid, varId(2+(num_var-1)*2) )
            CALL PROFILES_NF_ERROR(
     &           'INIT_NCFILE: NF_DEF_VAR prof_names',
     &           err,bi,bj,myThid )
            err = NF_PUT_ATT_DOUBLE( fid2, varId(2+(num_var-1)*2),
     &           '_FillValue', NF_DOUBLE, 1, 0. _d 0 )
            CALL PROFILES_NF_ERROR(
     &           'INIT_NCFILE: NF_PUT_ATT_DOUBLE varId(2',
     &           err,bi,bj,myThid )

            err = NF_DEF_VAR( fid2, prof_namesmask(num_file,num_var),
     &            NF_DOUBLE, 2, vecid, varId(3+(num_var-1)*2) )
            CALL PROFILES_NF_ERROR(
     &           'INIT_NCFILE: NF_DEF_VAR prof_namesmask',
     &           err,bi,bj,myThid )
            err = NF_PUT_ATT_DOUBLE( fid2, varId(3+(num_var-1)*2),
     &            '_FillValue', NF_DOUBLE, 1, 0. _d 0 )
            CALL PROFILES_NF_ERROR(
     &           'INIT_NCFILE: NF_PUT_ATT_DOUBLE varId(3',
     &           err,bi,bj,myThid )

          ELSE
            WRITE(msgBuf,'(2A)')
     &          'S/R PROFILES_INIT_NCFILE: no variable ',
     &          prof_names(num_file,num_var)
            CALL PRINT_MESSAGE( msgBuf,
     &           standardMessageUnit, SQUEEZE_RIGHT, myThid )
            WRITE(msgBuf,'(2A)')
     &           'INIT_NCFILE: NF_INQ_VARID prof_names = ',
     &           prof_names(num_file,num_var)
            CALL PROFILES_NF_ERROR( msgBuf, err, bi, bj, myThid )

          ENDIF
        ENDDO !DO num_var

        err = NF_ENDDEF( fid2 )
        CALL PROFILES_NF_ERROR( 'INIT_NCFILE: NF_ENDDEF fid2',
     &       err,bi,bj,myThid )
        err = NF_CLOSE( fid2 )
        CALL PROFILES_NF_ERROR( 'INIT_NCFILE: NF_CLOSE fid2',
     &       err,bi,bj,myThid )

        err = NF_OPEN( file2, NF_WRITE, fid2 )
        CALL PROFILES_NF_ERROR( 'INIT_NCFILE: NF_OPEN'//file2//')',
     &       err,bi,bj,myThid )

      ELSE !IF (profilesDoNcOutput)
        OPEN( fid2, FILE = file2, FORM = 'unformatted',
     &   STATUS = 'unknown', ACCESS = 'direct',
     &   RECL = (Zlength + 1)*WORDLENGTH*2 )

        DO k = 1, Zlength+1
          tmp_vec(k) = zeroRL
        ENDDO

# ifdef _BYTESWAPIO
        CALL MDS_BYTESWAPR8(Zlength+1,tmp_vec)
# endif
        DO irec = length, 1, -1
          DO num_var = prof_num_var_tot(num_file,bi,bj), 1, -1
            WRITE(fid2,rec=((irec-1)*prof_num_var_tot(num_file,bi,bj)
     &       +num_var-1)*2 +1) tmp_vec
            WRITE(fid2,rec=((irec-1)*prof_num_var_tot(num_file,bi,bj)
     &       +num_var-1)*2 +2) tmp_vec
          ENDDO
        ENDDO

      ENDIF !IF (profilesNoNcOutput)
#endif /* ALLOW_PROFILES */

      RETURN
      END

#include "FIZHI_OPTIONS.h"
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: FIZHI_INIT_VEGSURFTILES
C     !INTERFACE:
      subroutine fizhi_init_vegsurftiles(globalArr,xsize,ysize,
     &                                   nymd,nhms,prec,myThid)


C     !DESCRIPTION:
C      Read in grid space values of the land state
C      and then convert to vegetation tile space

C     !USES:
C      Calls routine grd2msc to do grid to tile space for each bi bj
      implicit none
#include "SIZE.h"
#include "fizhi_SIZE.h"
#include "fizhi_land_SIZE.h"
#include "fizhi_coms.h"
#include "fizhi_land_coms.h"
#include "fizhi_earth_coms.h"
#include "EEPARAMS.h"
#include "PARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
      integer xsize, ysize
      Real*8 globalArr(xsize,ysize,8)
      CHARACTER*1 prec
      INTEGER nhms,nymd
      INTEGER myThid

CEOP
C     !LOCAL VARIABLES:
      integer n,bi,bj

      DO bj = myByLo(myThid), myByHi(myThid)
      DO bi = myBxLo(myThid), myBxHi(myThid)

       do n = 1,nchp
        tcanopy(n,bi,bj) = 300.
        ecanopy(n,bi,bj) = 0.
        tdeep(n,bi,bj) = 295.
        swetshal(n,bi,bj) = 0.1
        swetroot(n,bi,bj) = 0.1
        swetdeep(n,bi,bj) = 0.1
        snodep(n,bi,bj) = 0.
        capac(n,bi,bj) = 0.
       enddo

      enddo
      enddo

      RETURN
      END

#include "MOM_COMMON_OPTIONS.h"

CBOP
C !ROUTINE: MOM_U_SIDEDRAG

C !INTERFACE: ==========================================================
      SUBROUTINE MOM_U_SIDEDRAG(
     I        bi, bj, k,
     I        uFld, del2u, hFacZ,
     I        viscAh_Z, viscA4_Z,
     I        harmonic, biharmonic, useVariableViscosity,
     O        uDragTerms,
     I        myThid )

C !DESCRIPTION:
C Calculates the drag terms due to the no-slip condition on viscous stresses:
C \begin{equation*}
C G^u_{drag} = - \frac{2}{\Delta y_u} (A_h u - A_4 \nabla^2 u)
C \end{equation*}

C !USES: ===============================================================
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "SURFACE.h"

C !INPUT PARAMETERS: ===================================================
C  bi,bj                :: tile indices
C  k                    :: vertical level
C  uFld                 :: zonal flow
C  del2u                :: Laplacian of zonal flow
C  hFacZ                :: fractional open water at vorticity points
C  myThid               :: my Thread Id number
      INTEGER bi, bj, k
      _RL uFld(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL del2u(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RS hFacZ(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL viscAh_Z(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL viscA4_Z(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      LOGICAL harmonic, biharmonic, useVariableViscosity
      INTEGER myThid

C !OUTPUT PARAMETERS: ==================================================
C  uDragTerms           :: drag term
      _RL uDragTerms(1-OLx:sNx+OLx,1-OLy:sNy+OLy)

C !LOCAL VARIABLES: ====================================================
C  i,j                  :: loop indices
C  hFacZClosedN         :: fractional open water to north
C  hFacZClosedS         :: fractional open water to south
      INTEGER i,j
      _RL hFacZClosedS, hFacZClosedN
      _RL Ahtmp, A4tmp
CEOP

      IF ( sideDragFactor.LE.0. ) THEN
C--   Laplacian and bi-harmonic terms: variable-Viscosity coeff. from
C     MOM_CALC_VISC are not used here (corresponds to the "old" version).

      DO j=2-OLy,sNy+OLy-1
       DO i=2-OLx,sNx+OLx-1
#ifdef NONLIN_FRSURF
        hFacZClosedS = h0FacW(i,j,k,bi,bj) - hFacZ(i,j)
        hFacZClosedN = h0FacW(i,j,k,bi,bj) - hFacZ(i,j+1)
#else
        hFacZClosedS = _hFacW(i,j,k,bi,bj) - hFacZ(i,j)
        hFacZClosedN = _hFacW(i,j,k,bi,bj) - hFacZ(i,j+1)
#endif
        Ahtmp=MIN(viscAh+viscAhGrid*rAw(i,j,bi,bj)/deltaTmom,
     &            viscAhMax)
        A4tmp=MIN(viscA4+viscA4Grid*(rAw(i,j,bi,bj)**2)/deltaTmom,
     &            viscA4Max)
        A4tmp=MIN(A4tmp,viscA4GridMax*(rAw(i,j,bi,bj)**2)/deltaTmom)
        A4tmp=MAX(A4tmp,viscA4GridMin*(rAw(i,j,bi,bj)**2)/deltaTmom)
        uDragTerms(i,j) =
     &   -_recip_hFacW(i,j,k,bi,bj)
     &   *recip_drF(k)*recip_rAw(i,j,bi,bj)
     &   *( hFacZClosedS*_dxV(i, j ,bi,bj)
     &      *_recip_dyU(i, j ,bi,bj)
     &     +hFacZClosedN*_dxV(i,j+1,bi,bj)
     &      *_recip_dyU(i,j+1,bi,bj) )
     &   *drF(k)*2.*(
#ifdef ISOTROPIC_COS_SCALING
     &                viscAh*uFld(i,j)*cosFacU(j,bi,bj)
#ifdef COSINEMETH_III
     &               -viscA4*del2u(i,j)*sqcosFacU(j,bi,bj)
#else
     &               -viscA4*del2u(i,j)*cosFacU(j,bi,bj)
#endif
#else
     &                Ahtmp*uFld(i,j)
     &               -A4tmp*del2u(i,j)
#endif
     &              )
       ENDDO
      ENDDO

      ELSE
C--   Laplacian and bi-harmonic terms: using variable-Viscosity coeff.
C     from MOM_CALC_VISC, consistent with dissipation in the interior

      DO j=2-OLy,sNy+OLy-1
       DO i=2-OLx,sNx+OLx-1
#ifdef NONLIN_FRSURF
        hFacZClosedS = h0FacW(i,j,k,bi,bj) - hFacZ(i,j)
        hFacZClosedN = h0FacW(i,j,k,bi,bj) - hFacZ(i,j+1)
#else
        hFacZClosedS = _hFacW(i,j,k,bi,bj) - hFacZ(i,j)
        hFacZClosedN = _hFacW(i,j,k,bi,bj) - hFacZ(i,j+1)
#endif
        uDragTerms(i,j) =
     &   -_recip_hFacW(i,j,k,bi,bj)
     &   *recip_drF(k)*recip_rAw(i,j,bi,bj)
     &   *( hFacZClosedS*_dxV(i, j ,bi,bj)*_recip_dyU(i, j ,bi,bj)
#ifdef ISOTROPIC_COS_SCALING
     &         *( viscAh_Z(i,j  )*uFld(i,j)*cosFacU(j,bi,bj)
#ifdef COSINEMETH_III
     &           -viscA4_Z(i,j  )*del2u(i,j)*sqcosFacU(j,bi,bj) )
#else
     &           -viscA4_Z(i,j  )*del2u(i,j)*cosFacU(j,bi,bj) )
#endif
#else
     &         *( viscAh_Z(i,j  )*uFld(i,j)
     &           -viscA4_Z(i,j  )*del2u(i,j) )
#endif
     &     +hFacZClosedN*_dxV(i,j+1,bi,bj)*_recip_dyU(i,j+1,bi,bj)
#ifdef ISOTROPIC_COS_SCALING
     &         *( viscAh_Z(i,j+1)*uFld(i,j)*cosFacU(j,bi,bj)
#ifdef COSINEMETH_III
     &           -viscA4_Z(i,j+1)*del2u(i,j)*sqcosFacU(j,bi,bj) )
#else
     &           -viscA4_Z(i,j+1)*del2u(i,j)*cosFacU(j,bi,bj) )
#endif
#else
     &         *( viscAh_Z(i,j+1)*uFld(i,j)
     &           -viscA4_Z(i,j+1)*del2u(i,j) )
#endif
     &    )*drF(k)*sideDragFactor
       ENDDO
      ENDDO

C--   end old-version / new-version IF blocks
      ENDIF

#ifdef ALLOW_DIAGNOSTICS
      IF (useDiagnostics) THEN
        CALL DIAGNOSTICS_FILL(uDragTerms,'USidDrag',k,1,2,bi,bj,myThid)
      ENDIF
#endif /* ALLOW_DIAGNOSTICS */

      RETURN
      END

#include "DIC_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: DIC_INIT_FIXED

C     !INTERFACE:
      SUBROUTINE DIC_INIT_FIXED( myThid )

C     !DESCRIPTION:
C     Initialize fixed quantities

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "DIC_VARS.h"
#include "DIC_ATMOS.h"

C     !INPUT PARAMETERS:
C     myThid       :: my Thread Id number
      INTEGER myThid
CEOP

#ifdef ALLOW_DIC
      INTEGER k
      INTEGER iUnit
#if ( defined DIC_BIOTIC || defined READ_PAR )
      CHARACTER*(MAX_LEN_MBUF) msgBuf
#endif

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      _BEGIN_MASTER(myThid)

C--   Set up coefficients for DIC chemistry
C define Schmidt no. coefficients for CO2
      sca1 = 2073.1 _d 0
      sca2 = -125.62 _d 0
      sca3 =    3.6276 _d 0
      sca4 =   -0.043219 _d 0
C define Schmidt no. coefficients for O2
C based on Keeling et al [GBC, 12, 141, (1998)]
      sox1 = 1638.0 _d 0
      sox2 = -81.83 _d 0
      sox3 =    1.483 _d 0
      sox4 =   -0.008004 _d 0

C coefficients for determining saturation O2
      oA0=  2.00907 _d 0
      oA1=  3.22014 _d 0
      oA2=  4.05010 _d 0
      oA3=  4.94457 _d 0
      oA4= -2.56847 _d -1
      oA5=  3.88767 _d 0
      oB0= -6.24523 _d -3
      oB1= -7.37614 _d -3
      oB2= -1.03410 _d -2
      oB3= -8.17083 _d -3
      oC0= -4.88682 _d -7

C--   Set other constant/flag

      IF ( dic_int1.EQ.2 ) THEN
        CALL MDSFINDUNIT( iUnit, myThid )
        OPEN(UNIT=iUnit,FILE='co2atmos.dat',STATUS='old')
        DO k=1,dic_int2
          READ(iUnit,*) co2atmos(k)
          WRITE(standardMessageUnit,*) 'co2atmos',co2atmos(k)
        ENDDO
        CLOSE(iUnit)
      ENDIF

#ifdef DIC_BIOTIC
#ifdef ALLOW_AUTODIFF
cph nlev=Nr used in TAF store directive
      nlev=Nr
#else
      k = 1
      DO WHILE ( k .LT. Nr .AND. rC(k) .GE. -zcrit )
        k = k+1
      ENDDO
      nlev = k
#endif
C--   Print out nlev values :
      iUnit = standardMessageUnit
      WRITE(msgBuf,'(A)') ' '
      CALL PRINT_MESSAGE(msgBuf,iUnit,SQUEEZE_RIGHT,myThid)
      WRITE(msgBuf,'(A)') '// ==================================='
      CALL PRINT_MESSAGE(msgBuf,iUnit,SQUEEZE_RIGHT,myThid)
      WRITE(msgBuf,'(A)') '//  DIC_INIT_FIXED parameters :'
      CALL PRINT_MESSAGE(msgBuf,iUnit,SQUEEZE_RIGHT,myThid)

      CALL WRITE_0D_I( nlev, INDEX_NONE, 'nlev =',
     &   ' /* Number of level over which Bio act is computed */')
#endif /* DIC_BIOTIC */

      _END_MASTER(myThid)

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C--  Check some option & parameter combinations:

C    for now, just collect here few check & stop from various places:
#ifdef READ_PAR
#ifdef USE_QSW
c     WRITE(msgBuf,'(2A)') ' DIC_INI_FORCING: ',
      WRITE(msgBuf,'(2A)') 'DIC_INIT_FIXED: ',
     &     'You can not use READ_PAR  and USE_QSW together'
      CALL PRINT_ERROR( msgBuf, myThid )
      STOP 'ABNORMAL END: S/R DIC_INIT_FIXED'
#endif
      IF ( DIC_forcingCycle.GT.0. _d 0
     &     .AND. DIC_parFile .EQ. ' '  ) THEN
c       WRITE(msgBuf,'(2A)') ' DIC_FIELDS_LOAD: ',
        WRITE(msgBuf,'(2A)') 'DIC_INIT_FIXED: ',
     &     'You need to provide a file if you want to use READ_PAR'
           CALL PRINT_ERROR( msgBuf, myThid )
           STOP 'ABNORMAL END: S/R DIC_INIT_FIXED'
      ENDIF
#endif /* READ_PAR */

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#ifdef ALLOW_MNC
      IF ( useMNC ) THEN
        CALL DIC_MNC_INIT( myThid )
      ENDIF
#endif /* ALLOW_MNC */

#ifdef ALLOW_DIAGNOSTICS
      IF ( useDIAGNOSTICS ) THEN
        CALL DIC_DIAGNOSTICS_INIT( myThid )
      ENDIF
#endif /* ALLOW_DIAGNOSTICS */

#endif /* ALLOW_DIC */

      RETURN
      END

#include "GAD_OPTIONS.h"

CBOP
C !ROUTINE: GAD_DST2U1_ADV_Y

C !INTERFACE: ==========================================================
      SUBROUTINE GAD_DST2U1_ADV_Y(
     I           bi,bj,k, advectionScheme, calcCFL,
     I           deltaTloc, vTrans, vFld,
     I           tracer,
     O           vT,
     I           myThid )

C !DESCRIPTION:
C  Calculates the area integrated meridional flux due to advection
C  of a tracer using second-order Direct Space and Time (DST-2)
C  interpolation (=Lax-Wendroff) or simple 1rst order upwind scheme.

C !USES: ===============================================================
      IMPLICIT NONE
#include "SIZE.h"
#include "GRID.h"
#include "GAD.h"

C !INPUT PARAMETERS: ===================================================
C  bi,bj             :: tile indices
C  k                 :: vertical level
C  advectionScheme   :: advection scheme to use: either 2nd Order DST
C                                                or 1rst Order Upwind
C  calcCFL           :: =T: calculate CFL number ; =F: take vFld as CFL
C  deltaTloc         :: local time-step (s)
C  vTrans            :: meridional volume transport
C  vFld              :: meridional flow / CFL number
C  tracer            :: tracer field
C  myThid            :: thread number
      INTEGER bi,bj, k, advectionScheme
      LOGICAL calcCFL
      _RL deltaTloc
      _RL vTrans(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL vFld  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL tracer(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER myThid

C !OUTPUT PARAMETERS: ==================================================
C  vT                :: meridional advective flux
      _RL vT    (1-OLx:sNx+OLx,1-OLy:sNy+OLy)

C !LOCAL VARIABLES: ====================================================
C  i,j               :: loop indices
C  yLimit            :: centered (vs upwind) fraction
C  vCFL              :: Courant-Friedrich-Levy number
      INTEGER i,j
      _RL vCFL, yLimit, vAbs
CEOP

      yLimit = 0. _d 0
      IF ( advectionScheme.EQ.ENUM_DST2 ) yLimit = 1. _d 0

      DO i=1-Olx,sNx+Olx
       vT(i,1-Oly)=0.
      ENDDO
      DO j=1-Oly+1,sNy+Oly
       DO i=1-Olx,sNx+Olx

        vCFL = vFld(i,j)
        IF ( calcCFL ) vCFL = ABS( vFld(i,j)*deltaTloc
     &                  *recip_dyC(i,j,bi,bj)*recip_deepFacC(k) )

c       vT(i,j) =
c    &     vTrans(i,j)*(tracer(i,j-1)+tracer(i,j))*0.5 _d 0
c    &   + ( 1. _d 0 - yLimit*(1. _d 0 - vCFL) )*ABS(vTrans(i,j))
c    &                *(tracer(i,j-1)-tracer(i,j))*0.5 _d 0
C-- above formulation produces large truncation error when:
C    1rst.O upWind and   v > 0 & |tracer(i,j-1)| << |tracer(i,j)|
C                   or   v < 0 & |tracer(i,j-1)| >> |tracer(i,j)|
C-- change to a more robust expression:
        vAbs = ABS(vTrans(i,j))
     &       *( 1. _d 0 - yLimit*(1. _d 0 - vCFL) )
        vT(i,j) = ( vTrans(i,j)+vAbs )* 0.5 _d 0 * tracer(i,j-1)
     &          + ( vTrans(i,j)-vAbs )* 0.5 _d 0 * tracer(i,j)

       ENDDO
      ENDDO

      RETURN
      END

#include "CAL_OPTIONS.h"

      SUBROUTINE CAL_ADDTIME(
     I                        date,
     I                        interval,
     O                        added,
     I                        myThid )

C     ==================================================================
C     SUBROUTINE cal_AddTime
C     ==================================================================
C
C     o Add a time interval either to a calendar date or to a time
C       interval.
C
C     started: Christian Eckert eckert@mit.edu  30-Jun-1999
C     changed: Christian Eckert eckert@mit.edu  29-Dec-1999
C              - restructured the original version in order to have a
C                better interface to the MITgcmUV.
C              Christian Eckert eckert@mit.edu  03-Feb-2000
C              - Introduced new routine and function names, cal_<NAME>,
C                for verion 0.1.3.
C              ralf.giering@fastopt.de 31-May-2000
C                datesecs was computed at wrong place (cph)
C              menemenlis@jpl.nasa.gov 8-Oct-2003
C              speed-up computations for long integration interval
C
C     ==================================================================
C     SUBROUTINE cal_AddTime
C     ==================================================================

      IMPLICIT NONE

C     == global variables ==
#include "EEPARAMS.h"
#include "cal.h"

C     == routine arguments ==
      INTEGER date(4)
      INTEGER interval(4)
      INTEGER added(4)
      INTEGER myThid

C     == external ==
      INTEGER  cal_IsLeap
      EXTERNAL cal_IsLeap

C     == local variables ==
      INTEGER intsecs
      INTEGER datesecs
      INTEGER nsecs
      INTEGER hhmmss
      INTEGER yi,mi,di,si,li,wi
      INTEGER ndays, ndays_left, days_in_year
      INTEGER date_1,date_2
      INTEGER intv_1,intv_2
      INTEGER fac
      INTEGER iday
      INTEGER switch
      INTEGER ndayssub
      INTEGER ierr
      CHARACTER*(MAX_LEN_MBUF) msgBuf
C     == end of interface ==

      IF ( cal_setStatus .LT. 1 ) THEN
        WRITE( msgBuf,'(2A,4I9)')  'CAL_ADDTIME: ',
     &       'date=',date(1),date(2),date(3),date(4)
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE( msgBuf,'(2A,4I9)')  'CAL_ADDTIME: ',
     &   'interval=',interval(1),interval(2),interval(3),interval(4)
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE( msgBuf,'(2A,I2,A)') 'CAL_ADDTIME: ',
     &    'called too early (cal_setStatus=',cal_setStatus,' )'
        CALL PRINT_ERROR( msgBuf, myThid )
        STOP 'ABNORMAL END: S/R CAL_ADDTIME'
      ENDIF

      if (interval(4) .ne. -1) then
        ierr = 601
        call cal_PrintError( ierr, myThid)
        stop ' stopped in cal_AddTime.'
      endif

      date_1 = 0
      date_2 = 0
      fac    = 1

      if (date(4) .eq. -1) then
         if (date(1) .ge. 0) then
            date_1 = date(1)
            date_2 = date(2)
            intv_1 = interval(1)
            intv_2 = interval(2)
         else
            if (interval(1) .lt. 0) then
               date_1 = -date(1)
               date_2 = -date(2)
               intv_1 = -interval(1)
               intv_2 = -interval(2)
               fac    = -1
            else
               date_1 = interval(1)
               date_2 = interval(2)
               intv_1 = date(1)
               intv_2 = date(2)
               fac    = 1
            endif
         endif
      else
         if (interval(1) .ge. 0) then
            intv_1 = interval(1)
            intv_2 = interval(2)
         else
            intv_1 = -interval(1)
            intv_2 = -interval(2)
            fac    = -1
         endif
      endif

      intsecs  = fac*(intv_2/10000*secondsperhour +
     &     (mod(intv_2/100,100)*secondsperminute +
     &     mod(intv_2,100)))

      if (date(4) .eq. -1) then
         datesecs = date_2/10000*secondsperhour +
     &        mod(date_2/100,100)*secondsperminute +
     &        mod(date_2,100)
         date_1 = date_1 + intv_1
         nsecs  = datesecs + intsecs
         if ((date_1 .gt. 0) .and.
     &        (nsecs  .lt. 0)) then
            date_1 = date_1 - 1
            nsecs  = nsecs + secondsperday
         endif
         nsecs = fac*nsecs
         yi     = 0
         mi     = 0
         di     = fac*date_1
         li     = 0
         wi     = -1
      else
         call cal_ConvDate( date,yi,mi,di,si,li,wi,myThid )
         if ((interval(1) .ge. 0) .and.
     &        (interval(2) .ge. 0)) then
            nsecs = si + intsecs
            ndays = interval(1)+nsecs/secondsperday
            nsecs = mod(nsecs,secondsperday)

C     This used to be called by exf_getffieldrec -> cal_GetDate
C     and was very slow for a long integration interval.
c           do iday = 1,ndays
c             di = di + 1
c             if (di .gt. ndaymonth(mi,li)) then
c               di = 1
c               mi = mi + 1
c             endif
c             switch = (mi-1)/nmonthyear
c             yi = yi + switch
c             mi = mod(mi-1,nmonthyear)+1
c             if (switch .eq. 1) li = cal_IsLeap( yi, myThid )
c           enddo

C     Set start value
            ndays_left=ndays

C     First take care of February 29
            if ( usingGregorianCalendar ) then
               if ( mi.eq.2 .and. di.eq.29 .and. ndays_left.gt.1 ) then
                  mi = 3
                  di = 1
                  ndays_left = ndays_left - 1
               endif
            endif

C     Next compute year
            days_in_year=ndaysnoleap
            if ((mi.gt.2.and.cal_IsLeap(yi+1,myThid).eq.2).or.
     &           (mi.le.2.and.cal_IsLeap(yi,myThid).eq.2) )
     &           days_in_year=ndaysleap
            do while (ndays_left .ge. days_in_year)
               ndays_left = ndays_left - days_in_year
               yi = yi + 1
               days_in_year=ndaysnoleap
               if ((mi.gt.2.and.cal_IsLeap(yi+1,myThid).eq.2).or.
     &              (mi.le.2.and.cal_IsLeap(yi,myThid).eq.2) )
     &              days_in_year=ndaysleap
            enddo
            li = cal_IsLeap( yi, myThid )

C     Finally compute day and month
            do iday = 1,ndays_left
               di = di + 1
               if (di .gt. ndaymonth(mi,li)) then
                  di = 1
                  mi = mi + 1
               endif
               switch = (mi-1)/nmonthyear
               yi = yi + switch
               mi = mod(mi-1,nmonthyear)+1
               if (switch .eq. 1) li = cal_IsLeap( yi, myThid )
            enddo
            wi = mod(wi+ndays-1,7)+1

         else
            nsecs = si + intsecs
            if (nsecs .ge. 0) then
               ndayssub = intv_1
            else
               nsecs = nsecs + secondsperday
               ndayssub = intv_1 + 1
            endif
            do iday = 1,ndayssub
               di = di - 1
               if (di .eq. 0) then
                  mi = mod(mi+10,nmonthyear)+1
                  switch = mi/nmonthyear
                  yi = yi - switch
                  if (switch .eq. 1) li = cal_IsLeap( yi, myThid )
                  di = ndaymonth(mi,li)
               endif
            enddo
            wi = mod(wi+6-mod(ndayssub,7),7)+1
         endif
      endif

C     Convert to calendar format.
      added(1) = yi*10000 + mi*100 + di
      hhmmss   = nsecs/secondsperminute
      added(2) = hhmmss/minutesperhour*10000 +
     &     (mod(fac*hhmmss,minutesperhour)*100 +
     &     mod(fac*nsecs,secondsperminute))*fac
      added(3) = li
      added(4) = wi

      RETURN
      END

#include "STREAMICE_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

CBOP
      SUBROUTINE STREAMICE_DRIVING_STRESS_PPM( myThid ) 
!      O taudx, 
!      O taudy )

C     /============================================================\
C     | SUBROUTINE                                                 |   
C     | o                                                          |
C     |============================================================|
C     |                                                            |
C     \============================================================/
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "STREAMICE.h"
#include "STREAMICE_CG.h"

C     !INPUT/OUTPUT ARGUMENTS
      INTEGER myThid
!       _RL taudx (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
!       _RL taudx (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)

#ifdef ALLOW_STREAMICE


C     LOCAL VARIABLES
      INTEGER i, j, bi, bj, k, l,
     &        Gi, Gj
      LOGICAL at_west_bdry, at_east_bdry, 
     &        at_north_bdry, at_south_bdry
      _RL sx, sy, diffx, diffy, neu_val
      
      IF (myXGlobalLo.eq.1) at_west_bdry = .true.
      IF (myYGlobalLo.eq.1) at_south_bdry = .true.
      IF (myXGlobalLo-1+sNx*nSx.eq.Nx) 
     & at_east_bdry = .false.
      IF (myYGlobalLo-1+sNy*nSy.eq.Ny) 
     & at_north_bdry = .false.

      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          taudx_SI(i,j,bi,bj) = 0. _d 0
          taudy_SI(i,j,bi,bj) = 0. _d 0
         ENDDO
        ENDDO
       ENDDO
      ENDDO

      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
        
        DO i=0,sNx+1
         DO j=0,sNy+1

          diffx = 0. _d 0
          diffy = 0. _d 0
          sx = 0. _d 0
          sy = 0. _d 0

          Gi = (myXGlobalLo-1)+(bi-1)*sNx+i
          Gj = (myYGlobalLo-1)+(bj-1)*sNy+j

          IF (STREAMICE_hmask(i,j,bi,bj).eq.1.0) THEN

           ! we are in an "active" cell

           IF (Gi.eq.1.AND..NOT.STREAMICE_EW_periodic) THEN

            ! western boundary - only one sided possible

            IF (STREAMICE_hmask(i+1,j,bi,bj).eq.1.0) THEN

             ! cell to east is active

             sx = (surf_el_streamice(i+1,j,bi,bj)-
     &             surf_el_streamice(i,j,bi,bj))/dxC(i+1,j,bi,bj)
            ELSE

             ! cell to east is empty

             sx = 0. _d 0
            ENDIF

            DO k=0,1
             DO l=0,1
              IF (STREAMICE_umask(i+k,j+l,bi,bj).eq.1.0) THEN
               taudx_SI(i+k,j+l,bi,bj) = taudx_SI(i+k,j+l,bi,bj) -
     &          0.25 * streamice_density * gravity * 
     &          (streamice_bg_surf_slope_x+sx) * 
     &          H_streamice(i,j,bi,bj) * rA(i,j,bi,bj)
              ENDIF
             ENDDO
            ENDDO

           ELSEIF (Gi.eq.Nx.AND..NOT.STREAMICE_EW_periodic) THEN

            ! eastern boundary - only one sided possible

            IF (STREAMICE_hmask(i-1,j,bi,bj).eq.1.0) THEN

             ! cell to west is active

             sx = (surf_el_streamice(i,j,bi,bj)-
     &             surf_el_streamice(i-1,j,bi,bj))/dxC(i,j,bi,bj)
            ELSE

             ! cell to west is inactive

             sx = 0. _d 0
            ENDIF

            DO k=0,1
             DO l=0,1
              IF (STREAMICE_umask(i+k,j+l,bi,bj).eq.1.0) THEN
               taudx_SI(i+k,j+l,bi,bj) = taudx_SI(i+k,j+l,bi,bj) -
     &          0.25 * streamice_density * gravity * 
     &          (streamice_bg_surf_slope_x+sx) * 
     &          H_streamice(i,j,bi,bj) * rA(i,j,bi,bj)
              ENDIF
             ENDDO
            ENDDO

           ELSE

            ! interior (west-east) cell

            IF (STREAMICE_hmask(i+1,j,bi,bj).eq.1.0 .and.
     &          STREAMICE_hmask(i-1,j,bi,bj).eq.1.0) THEN

             k = 0
             DO l=0,1
              IF (STREAMICE_umask(i+k,j+l,bi,bj).eq.1.0) THEN
               taudx_SI(i+k,j+l,bi,bj) = taudx_SI(i+k,j+l,bi,bj) -
     &          streamice_density * gravity * (1./6.) *
     &          (-2.*surf_el_streamice(i-1,j,bi,bj) + 
     &           surf_el_streamice(i,j,bi,bj) + 
     &           surf_el_streamice(i+1,j,bi,bj) +
     &           3.*streamice_bg_surf_slope_x * dxF(i,j,bi,bj)) *
     &          H_streamice(i,j,bi,bj) * .5 * dyF(i,j,bi,bj)
              ENDIF
             ENDDO

             k = 1
             DO l=0,1
              IF (STREAMICE_umask(i+k,j+l,bi,bj).eq.1.0) THEN
               taudx_SI(i+k,j+l,bi,bj) = taudx_SI(i+k,j+l,bi,bj) -
     &          streamice_density * gravity * (1./6.) *
     &          (-surf_el_streamice(i-1,j,bi,bj) - 
     &           surf_el_streamice(i,j,bi,bj) + 
     &           2*surf_el_streamice(i+1,j,bi,bj) +
     &           3.*streamice_bg_surf_slope_x * dxF(i,j,bi,bj)) *
     &          H_streamice(i,j,bi,bj) * .5 * dyF(i,j,bi,bj)
              ENDIF
             ENDDO


            ELSE 

             IF (STREAMICE_hmask(i+1,j,bi,bj).eq.1.0) THEN

              sx = (surf_el_streamice(i+1,j,bi,bj)-
     &             surf_el_streamice(i,j,bi,bj))/dxC(i+1,j,bi,bj)

             ELSEIF (STREAMICE_hmask(i-1,j,bi,bj).eq.1.0) THEN

              sx = (surf_el_streamice(i,j,bi,bj)-
     &             surf_el_streamice(i-1,j,bi,bj))/dxC(i,j,bi,bj)

             ELSE

              sx = 0. _d 0

             ENDIF

             DO k=0,1
              DO l=0,1
               IF (STREAMICE_umask(i+k,j+l,bi,bj).eq.1.0) THEN
                taudx_SI(i+k,j+l,bi,bj) = taudx_SI(i+k,j+l,bi,bj) -
     &           0.25 * streamice_density * gravity * 
     &           (streamice_bg_surf_slope_x+sx) * 
     &           H_streamice(i,j,bi,bj) * rA(i,j,bi,bj)
               ENDIF
              ENDDO
             ENDDO

            ENDIF

           ENDIF

!!!!!!!! DONE WITH X-GRADIENT

           IF (Gj.eq.1.AND..NOT.STREAMICE_NS_periodic) THEN

            ! western boundary - only one sided possible

            IF (STREAMICE_hmask(i,j+1,bi,bj).eq.1.0) THEN

             ! cell to east is active

             sy = (surf_el_streamice(i,j+1,bi,bj)-
     &             surf_el_streamice(i,j,bi,bj))/dyC(i,j+1,bi,bj)
            ELSE

             ! cell to east is empty

             sy = 0. _d 0
            ENDIF

            DO k=0,1
             DO l=0,1
              IF (STREAMICE_umask(i+k,j+l,bi,bj).eq.1.0) THEN
               taudy_SI(i+k,j+l,bi,bj) = taudy_SI(i+k,j+l,bi,bj) -
     &          0.25 * streamice_density * gravity * 
     &          (streamice_bg_surf_slope_y+sy) * 
     &          H_streamice(i,j,bi,bj) * rA(i,j,bi,bj)
              ENDIF
             ENDDO
            ENDDO

           ELSEIF (Gj.eq.Ny.AND..NOT.STREAMICE_NS_periodic) THEN

            ! eastern boundary - only one sided possible

            IF (STREAMICE_hmask(i,j-1,bi,bj).eq.1.0) THEN

             ! cell to west is active

             sy = (surf_el_streamice(i,j,bi,bj)-
     &             surf_el_streamice(i,j-1,bi,bj))/dyC(i,j,bi,bj)

            ELSE

             ! cell to west is inactive

             sy = 0. _d 0
            ENDIF

            DO k=0,1
             DO l=0,1
              IF (STREAMICE_umask(i+k,j+l,bi,bj).eq.1.0) THEN
               taudy_SI(i+k,j+l,bi,bj) = taudy_SI(i+k,j+l,bi,bj) -
     &          0.25 * streamice_density * gravity * 
     &          (streamice_bg_surf_slope_y+sy) * 
     &          H_streamice(i,j,bi,bj) * rA(i,j,bi,bj)
              ENDIF
             ENDDO
            ENDDO

           ELSE

            ! interior (west-east) cell

            IF (STREAMICE_hmask(i,j+1,bi,bj).eq.1.0 .and.
     &          STREAMICE_hmask(i,j-1,bi,bj).eq.1.0) THEN

             l = 0
             DO k=0,1
              IF (STREAMICE_umask(i+k,j+l,bi,bj).eq.1.0) THEN
               taudy_SI(i+k,j+l,bi,bj) = taudy_SI(i+k,j+l,bi,bj) -
     &          streamice_density * gravity * (1./6.) *
     &          (-2.*surf_el_streamice(i,j-1,bi,bj) + 
     &           surf_el_streamice(i,j,bi,bj) + 
     &           surf_el_streamice(i,j+1,bi,bj) +
     &           3.*streamice_bg_surf_slope_y * dyF(i,j,bi,bj)) *
     &          H_streamice(i,j,bi,bj) * .5 * dxF(i,j,bi,bj)
              ENDIF
             ENDDO

             l = 1
             DO k=0,1
              IF (STREAMICE_umask(i+k,j+l,bi,bj).eq.1.0) THEN
               taudy_SI(i+k,j+l,bi,bj) = taudy_SI(i+k,j+l,bi,bj) -
     &          streamice_density * gravity * (1./6.) *
     &          (-surf_el_streamice(i,j-1,bi,bj) - 
     &           surf_el_streamice(i,j,bi,bj) + 
     &           2*surf_el_streamice(i,j+1,bi,bj) +
     &           3.*streamice_bg_surf_slope_y * dyF(i,j,bi,bj)) *
     &          H_streamice(i,j,bi,bj) * .5 * dxF(i,j,bi,bj)
              ENDIF
             ENDDO


            ELSE 

             IF (STREAMICE_hmask(i,j+1,bi,bj).eq.1.0) THEN

              sy = (surf_el_streamice(i,j+1,bi,bj)-
     &             surf_el_streamice(i,j,bi,bj))/dxC(i,j+1,bi,bj)

             ELSEIF (STREAMICE_hmask(i,j-1,bi,bj).eq.1.0) THEN

              sy = (surf_el_streamice(i,j,bi,bj)-
     &             surf_el_streamice(i,j-1,bi,bj))/dxC(i,j,bi,bj)

             ELSE

              sy = 0. _d 0

             ENDIF

             DO k=0,1
              DO l=0,1
               IF (STREAMICE_umask(i+k,j+l,bi,bj).eq.1.0) THEN
                taudy_SI(i+k,j+l,bi,bj) = taudy_SI(i+k,j+l,bi,bj) -
     &           0.25 * streamice_density * gravity * 
     &           (streamice_bg_surf_slope_y+sy) * 
     &           H_streamice(i,j,bi,bj) * rA(i,j,bi,bj)
               ENDIF
              ENDDO
             ENDDO

            ENDIF

           ENDIF

!            DO k=0,1
!             DO l=0,1
!              IF (STREAMICE_umask(i+k,j+l,bi,bj).eq.1.0) THEN
!               taudx_SI(i+k,j+l,bi,bj) = taudx_SI(i+k,j+l,bi,bj) -
!      &         0.25 * streamice_density * gravity * 
!      &         (streamice_bg_surf_slope_x+sx) * 
!      &         H_streamice(i,j,bi,bj) * rA(i,j,bi,bj)
!               taudy_SI(i+k,j+l,bi,bj) = taudy_SI(i+k,j+l,bi,bj) -
!      &         0.25 * streamice_density * gravity * 
!      &         (streamice_bg_surf_slope_y+sy) * 
!      &         H_streamice(i,j,bi,bj) * rA(i,j,bi,bj)
!               
!              ENDIF
!             ENDDO
!            ENDDO

           IF (float_frac_streamice(i,j,bi,bj) .eq. 1.0) then
#ifdef USE_ALT_RLOW
            neu_val = .5 * gravity * 
     &       (streamice_density * H_streamice (i,j,bi,bj) ** 2 - 
     &        streamice_density_ocean_avg * R_low_si(i,j,bi,bj) ** 2)
#else
            neu_val = .5 * gravity * 
     &       (streamice_density * H_streamice (i,j,bi,bj) ** 2 - 
     &        streamice_density_ocean_avg * R_low(i,j,bi,bj) ** 2)
#endif
           ELSE
            neu_val = .5 * gravity * 
     &       (1-streamice_density/streamice_density_ocean_avg) * 
     &        streamice_density * H_streamice(i,j,bi,bj) ** 2 
           ENDIF

           IF ((STREAMICE_ufacemask(i,j,bi,bj) .eq. 2) 
     &      .OR. (STREAMICE_hmask(i-1,j,bi,bj) .eq. 0)
     &      .OR. (STREAMICE_hmask(i-1,j,bi,bj) .eq. 2) ) THEN ! left face of the cell is at a stress boundary
          ! the depth-integrated longitudinal stress is equal to the difference of depth-integrated pressure on either side of the face
          ! on the ice side, it is rho g h^2 / 2
          ! on the ocean side, it is rhow g (delta OD)^2 / 2
          ! OD can be zero under the ice; but it is ASSUMED on the ice-free side of the face, topography elevation is not above the base of the 
          !     ice in the current cell
             
             taudx_SI(i,j,bi,bj) = taudx_SI(i,j,bi,bj) - 
     &        .5 * dyG(i,j,bi,bj)*(neu_val+streamice_addl_backstress)
             taudx_SI(i,j+1,bi,bj) = taudx_SI(i,j+1,bi,bj) - 
     &        .5 * dyG(i,j,bi,bj)*(neu_val+streamice_addl_backstress)
           ENDIF

           IF ((STREAMICE_ufacemask(i+1,j,bi,bj) .eq. 2) 
     &      .OR. (STREAMICE_hmask(i+1,j,bi,bj) .eq. 0)
     &      .OR. (STREAMICE_hmask(i+1,j,bi,bj) .eq. 2) ) THEN 
             
             taudx_SI(i+1,j,bi,bj) = taudx_SI(i+1,j,bi,bj) + 
     &        .5 * dyG(i+1,j,bi,bj)*(neu_val+streamice_addl_backstress)  ! note negative sign is due to direction of normal vector
             taudx_SI(i+1,j+1,bi,bj) = taudx_SI(i+1,j+1,bi,bj) +
     &        .5 * dyG(i+1,j,bi,bj)*(neu_val+streamice_addl_backstress)
           ENDIF

           IF ((STREAMICE_vfacemask(i,j,bi,bj) .eq. 2) 
     &      .OR. (STREAMICE_hmask(i,j-1,bi,bj) .eq. 0)
     &      .OR. (STREAMICE_hmask(i,j-1,bi,bj) .eq. 2) ) THEN 
             
             taudy_SI(i,j,bi,bj) = taudy_SI(i,j,bi,bj) - 
     &        .5 * dxG(i,j,bi,bj)*(neu_val+streamice_addl_backstress)
             taudy_SI(i+1,j,bi,bj) = taudy_SI(i+1,j,bi,bj) - 
     &        .5 * dxG(i,j,bi,bj)*(neu_val+streamice_addl_backstress)
           ENDIF

           IF ((STREAMICE_vfacemask(i,j+1,bi,bj) .eq. 2) 
     &      .OR. (STREAMICE_hmask(i,j+1,bi,bj) .eq. 0)
     &      .OR. (STREAMICE_hmask(i,j+1,bi,bj) .eq. 2) ) THEN 
             
             taudy_SI(i,j+1,bi,bj) = taudy_SI(i,j+1,bi,bj) +
     &        .5 * dxG(i,j+1,bi,bj)*(neu_val+streamice_addl_backstress)
             taudy_SI(i+1,j+1,bi,bj) = taudy_SI(i+1,j+1,bi,bj) +
     &        .5 * dxG(i,j+1,bi,bj)*(neu_val+streamice_addl_backstress)
           ENDIF

          ENDIF
         ENDDO
        ENDDO
       ENDDO
      ENDDO



#endif
      RETURN
      END
       
      

#include "PACKAGES_CONFIG.h"
#include "CPP_EEOPTIONS.h"

C--   File cumulsum_z_tile.F: Routines that perform cumulated sum
C                             on a tiled array, corner grid-cell location
C      Contents
C      o CUMULSUM_Z_TILE_RL
C      o CUMULSUM_Z_TILE_RS <- not yet coded

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: CUMULSUM_Z_TILE_RL

C     !INTERFACE:
      SUBROUTINE CUMULSUM_Z_TILE_RL(
     O                       psiZ, psiLoc,
     I                       dPsiX, dPsiY, myThid )

C     !DESCRIPTION:
C     *==========================================================*
C     | SUBROUTINE CUMULSUM\_Z\_TILE\_RL
C     | o Handle cumulated sum for _RL tile data.
C     *==========================================================*
C     | Cumulate sum on tiled array, corner grid-cell location:
C     |  Starts from 1rst tile and, going through all tiles & all
C     |  the processes, add increment in both directions
C     *==========================================================*

C     !USES:
      IMPLICIT NONE

C     == Global data ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "EESUPPORT.h"
#include "CUMULSUM.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     psiZ    :: results of cumulated sum, corresponds to tile South-East corner
C     psiLoc  :: cumulated sum at special locations
C     dPsiX   :: tile increment in X direction
C     dPsiY   :: tile increment in Y direction
C     myThid  :: my Thread Id. number
      _RL     psiZ  (nSx,nSy)
      _RL     psiLoc(2)
      _RL     dPsiX (nSx,nSy)
      _RL     dPsiY (nSx,nSy)
      INTEGER myThid

C     !LOCAL VARIABLES:
#ifndef ALLOW_EXCH2
C     == Local variables ==
C     bi,bj   :: tile indices
C- type declaration of: loc[1,2]Buf and shareBufCS[1,2]_R8 :
C         all 4 needs to have the same length as MPI_DOUBLE_PRECISION
      INTEGER bi,bj
      INTEGER nf
#ifdef ALLOW_USE_MPI
      INTEGER biG, bjG, npe, np1
      INTEGER lbuf1, lbuf2, idest, itag, ready_to_receive
      INTEGER istatus(MPI_STATUS_SIZE), ierr
      Real*8  loc1Buf  (nSx,nSy)
      Real*8  loc2Buf(2,nSx,nSy)
      Real*8  globalBuf(3,nSx*nPx,nSy*nPy)
#endif /* ALLOW_USE_MPI */
#endif /* ALLOW_EXCH2 */
CEOP

#ifdef ALLOW_EXCH2
      CALL W2_CUMULSUM_Z_TILE_RL(
     O                       psiZ, psiLoc,
     I                       dPsiX, dPsiY, myThid )

#else /* ALLOW_EXCH2 */
C--   write input into shared-buffer array
      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
         shareBufCS2_R8(1,bi,bj) = dPsiX(bi,bj)
         shareBufCS2_R8(2,bi,bj) = dPsiY(bi,bj)
       ENDDO
      ENDDO
      psiLoc(1) = 0.
      psiLoc(2) = 0.

C--   Master thread cannot start until everyone is ready:
      CALL BAR2( myThid )
      _BEGIN_MASTER( myThid )

#ifdef ALLOW_USE_MPI
      IF ( usingMPI ) THEN

        lbuf1 = nSx*nSy
        lbuf2 = 2*lbuf1
        idest = 0
        itag  = 0
        ready_to_receive = 0

        IF ( mpiMyId.NE.0 ) THEN

C--   All proceses except 0 wait to be polled then send local array
#ifndef DISABLE_MPI_READY_TO_RECEIVE
            CALL MPI_RECV (ready_to_receive, 1, MPI_INTEGER,
     &           idest, itag, MPI_COMM_MODEL, istatus, ierr)
#endif
            CALL MPI_SEND (shareBufCS2_R8, lbuf2, MPI_DOUBLE_PRECISION,
     &           idest, itag, MPI_COMM_MODEL, ierr)

C--   All proceses except 0 receive result from process 0
            CALL MPI_RECV (shareBufCS1_R8, lbuf1, MPI_DOUBLE_PRECISION,
     &           idest, itag, MPI_COMM_MODEL, istatus, ierr)

        ELSE

C--   Process 0 fills-in its local data
          np1 = 1
          DO bj=1,nSy
            DO bi=1,nSx
              biG = (mpi_myXGlobalLo(np1)-1)/sNx+bi
              bjG = (mpi_myYGlobalLo(np1)-1)/sNy+bj
              globalBuf(1,biG,bjG) = shareBufCS2_R8(1,bi,bj)
              globalBuf(2,biG,bjG) = shareBufCS2_R8(2,bi,bj)
            ENDDO
          ENDDO

C--   Process 0 polls and receives data from each process in turn
          DO npe = 1, numberOfProcs-1
#ifndef DISABLE_MPI_READY_TO_RECEIVE
            CALL MPI_SEND (ready_to_receive, 1, MPI_INTEGER,
     &             npe, itag, MPI_COMM_MODEL, ierr)
#endif
            CALL MPI_RECV (loc2Buf, lbuf2, MPI_DOUBLE_PRECISION,
     &             npe, itag, MPI_COMM_MODEL, istatus, ierr)

C--   Process 0 gathers the local arrays into a global array.
            np1 = npe + 1
            DO bj=1,nSy
             DO bi=1,nSx
              biG = (mpi_myXGlobalLo(np1)-1)/sNx+bi
              bjG = (mpi_myYGlobalLo(np1)-1)/sNy+bj
              globalBuf(1,biG,bjG) = loc2Buf(1,bi,bj)
              globalBuf(2,biG,bjG) = loc2Buf(2,bi,bj)
             ENDDO
            ENDDO
          ENDDO

C--   Cumulate Sum over all tiles:
          globalBuf(3,1,1) = 0.
          bj = 1
          DO bi = 1,nSx*nPx-1
            globalBuf(3,1+bi,bj) = globalBuf(3,bi,bj)
     &                           + globalBuf(1,bi,bj)
          ENDDO
          DO bj = 1,nSy*nPy-1
           DO bi = 1,nSx*nPx
            globalBuf(3,bi,1+bj) = globalBuf(3,bi,bj)
     &                           + globalBuf(2,bi,bj)
           ENDDO
          ENDDO

C--   Process 0 fills-in its local data
          np1 = 1
          DO bj=1,nSy
            DO bi=1,nSx
              biG = (mpi_myXGlobalLo(np1)-1)/sNx+bi
              bjG = (mpi_myYGlobalLo(np1)-1)/sNy+bj
              shareBufCS1_R8(bi,bj) = globalBuf(3,biG,bjG)
            ENDDO
          ENDDO

C--   Process 0 sends result to all other processes
          DO npe = 1, numberOfProcs-1
C-    fill local array with relevant portion of global array
            np1 = npe + 1
            DO bj=1,nSy
             DO bi=1,nSx
              biG = (mpi_myXGlobalLo(np1)-1)/sNx+bi
              bjG = (mpi_myYGlobalLo(np1)-1)/sNy+bj
              loc1Buf(bi,bj) = globalBuf(3,biG,bjG)
             ENDDO
            ENDDO
            CALL MPI_SEND (loc1Buf, lbuf1, MPI_DOUBLE_PRECISION,
     &                     npe, itag, MPI_COMM_MODEL, ierr)

          ENDDO

        ENDIF

      ELSEIF (useCubedSphereExchange) THEN
#else /* not USE_MPI */
      IF     (useCubedSphereExchange) THEN
#endif /* ALLOW_USE_MPI */

C--   assume 1 tile / face, from bi=1 to 6, no MPI
        shareBufCS1_R8(1,1) = 0.
        bj = 1
        DO bi = 1,nSx-1
           nf = 1 + MOD(1+bi,2)
           shareBufCS1_R8(1+bi,bj) = shareBufCS1_R8(bi,bj)
     &                             + shareBufCS2_R8(nf,bi,bj)
        ENDDO
C-    fill in missing corner: 1 = North-West corner of face 1
C-                            2 = South-East corner of face 2
        bi = 1
        psiLoc(1) = shareBufCS1_R8(bi,bj) + shareBufCS2_R8(2,bi,bj)
        bi = MIN(2,nSx)
        psiLoc(2) = shareBufCS1_R8(bi,bj) + shareBufCS2_R8(1,bi,bj)

      ELSE

C--   Cumulate Sum over all tiles:
        shareBufCS1_R8(1,1) = 0.
        bj = 1
        DO bi = 1,nSx-1
           shareBufCS1_R8(1+bi,bj) = shareBufCS1_R8(bi,bj)
     &                             + shareBufCS2_R8(1,bi,bj)
        ENDDO
        DO bj = 1,nSy-1
         DO bi = 1,nSx
           shareBufCS1_R8(bi,1+bj) = shareBufCS1_R8(bi,bj)
     &                             + shareBufCS2_R8(2,bi,bj)
         ENDDO
        ENDDO

      ENDIF

      _END_MASTER( myThid )
C--   Everyone wait for Master thread to be ready
      CALL BAR2( myThid )

C--   set result for every threads
      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
         psiZ(bi,bj) = shareBufCS1_R8(bi,bj)
       ENDDO
      ENDDO

#endif /* ALLOW_EXCH2 */
      RETURN
      END

CBOP
C     !INTERFACE:
      SUBROUTINE MITCPLR_ALL_CHECK( errFlag, errMsg )

C     !DESCRIPTION:
C     *==========================================================*
C     | SUBROUTINE MITCPLR_ALL_CHECK
C     | o Stop every Processes in World if flag is true
C     *==========================================================*
C     | Gather error-flag from all processes in World and
C     |  stop if one is in error. This assumes that every-one
C     | (all coupler procs and all components) call this routine
C     *==========================================================*

      IMPLICIT NONE

C Predefined constants/arrays
#include "CPLR_SIG.h"
C MPI variables
#include "mpif.h"

C !INPUT/OUTPUT PARAMETERS:
C     errFlag :: stop if this logical flag is true
C     errMsg  :: error message to print in case it stops
      LOGICAL errFlag
      CHARACTER*(*) errMsg

C !LOCAL VARIABLES:
C     msgBuf       :: I/O Buffer
C     errCount     :: error counter
c     CHARACTER*(MAX_LEN_MBUF) msgBuf
      INTEGER errCount, errLoc, mpiRC
CEOP

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C--   Collect error from all Procs
      errLoc = 0
      IF ( errFlag ) THEN
        errLoc = 1
      ENDIF
      CALL MPI_Allreduce( errLoc, errCount, 1, MPI_INTEGER, MPI_SUM,
     &                    MPI_COMM_WORLD, mpiRC )

      IF ( errCount.GE.1 ) THEN
C--   Print message
        IF ( errFlag .AND. errMsg.NE.' ' ) THEN
          WRITE(LogUnit,'(2A)') ' *** ERROR *** ', errMsg
        ENDIF
        WRITE(LogUnit,'(A,I8,A)')
     &   'FATAL ERROR for ', errCount, ' Proc(s) ==> Stop here'
C--   Finishes
c       CALL ALL_PROC_DIE( myThid )
        CALL MPI_FINALIZE( mpiRC )
        STOP 'ABNORMAL END: S/R MITCPLR_ALL_CHECK'
      ENDIF

      RETURN
      END

#include "THSICE_OPTIONS.h"
#ifdef ALLOW_AUTODIFF
# include "AUTODIFF_OPTIONS.h"
#endif

CBOP
C     !ROUTINE: THSICE_DO_ADVECT
C     !INTERFACE:
      SUBROUTINE THSICE_DO_ADVECT(
     I                  biArg, bjArg, myTime, myIter, myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE THSICE_DO_ADVECT
C     | o wraper for pkg/thSIce advection-diffusion calls
C     *==========================================================*
C     \ev
C     !USES:
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "FFIELDS.h"
#include "THSICE_SIZE.h"
#include "THSICE_PARAMS.h"
#include "THSICE_VARS.h"
#ifdef ALLOW_AUTODIFF_TAMC
# include "tamc.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
C     biArg     :: Tile 1rst index argument
C     bjArg     :: Tile 2nd  index argument
C     myTime    :: Current time in simulation (s)
C     myIter    :: Current iteration number
C     myThid    :: My Thread Id. number
      INTEGER biArg, bjArg
      _RL     myTime
      INTEGER myIter
      INTEGER myThid
CEOP

C     !LOCAL VARIABLES:
C     === Local variables ===
C     bi, bj    :: Tile indices
C     uIce/vIce :: ice velocity on C-grid [m/s]
      INTEGER bi, bj
      INTEGER i, j
      INTEGER iMin, iMax, jMin, jMax
#ifdef ALLOW_AUTODIFF_TAMC
C     tkey :: tape key (depends on tiles)
      INTEGER tkey
#endif
      _RL  uIce(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL  vIce(1-OLx:sNx+OLx,1-OLy:sNy+OLy)

      IF ( thSIceAdvScheme.GT.0 .AND. biArg.EQ.0 .AND. bjArg.EQ.0 ) THEN
c      iMin = 1
c      iMax = sNx
c      jMin = 1
c      jMax = sNy
       iMin = 1-OLx
       iMax = sNx+OLx-1
       jMin = 1-OLy
       jMax = sNy+OLy-1
       DO bj = myByLo(myThid), myByHi(myThid)
        DO bi = myBxLo(myThid), myBxHi(myThid)
#ifdef ALLOW_AUTODIFF_TAMC
         tkey = bi + (bj-1)*nSx + (ikey_dynamics-1)*nSx*nSy
#endif /* ALLOW_AUTODIFF_TAMC */

         CALL THSICE_GET_VELOCITY(
     O                        uIce, vIce,
     I                        bi,bj, myTime, myIter, myThid )
#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE icemask(:,:,bi,bj) = comlev1_bibj, key=tkey, byte=isbyte
CADJ STORE qice1(:,:,bi,bj)   = comlev1_bibj, key=tkey, byte=isbyte
CADJ STORE hOceMxL(:,:,bi,bj) = comlev1_bibj, key=tkey, byte=isbyte
#endif
         CALL THSICE_ADVDIFF(
     U                        uIce, vIce,
     I                        bi,bj, myTime, myIter, myThid )
#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE hOceMxL(:,:,bi,bj)    = comlev1_bibj, key=tkey, byte=isbyte
CADJ STORE snowHeight(:,:,bi,bj) = comlev1_bibj, key=tkey, byte=isbyte
CADJ STORE iceHeight(:,:,bi,bj)  = comlev1_bibj, key=tkey, byte=isbyte
CADJ STORE iceMask(:,:,bi,bj)    = comlev1_bibj, key=tkey, byte=isbyte
#endif
         DO j = jMin, jMax
          DO i = iMin, iMax
           IF ( hOceMxL(i,j,bi,bj).GT.0. _d 0 ) THEN
            Qnet(i,j,bi,bj) = Qnet(i,j,bi,bj) - oceQnet(i,j,bi,bj)
            EmPmR(i,j,bi,bj)= EmPmR(i,j,bi,bj)- oceFWfx(i,j,bi,bj)
            saltFlux(i,j,bi,bj)=saltFlux(i,j,bi,bj) - oceSflx(i,j,bi,bj)
           ENDIF
C--     Compute Sea-Ice Loading (= mass of sea-ice + snow / area unit)
           sIceLoad(i,j,bi,bj) = ( snowHeight(i,j,bi,bj)*rhos
     &                           + iceHeight(i,j,bi,bj)*rhoi
     &                           )*iceMask(i,j,bi,bj)
          ENDDO
         ENDDO

C--     cumulate time-averaged fields and also fill-up flux diagnostics
         CALL THSICE_AVE(
     I                     bi,bj, myTime, myIter, myThid )

        ENDDO
       ENDDO

       IF ( stressReduction.GT. 0. _d 0 )
     &   _EXCH_XY_RL( iceMask, myThid )
       IF ( useRealFreshWaterFlux )
     &  _EXCH_XY_RS( sIceLoad, myThid )

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      ENDIF

      RETURN
      END

#include "OCN_CPL_OPTIONS.h"

CBOP
C     !ROUTINE: OCN_EXPORT_DATA

C     !INTERFACE:
      SUBROUTINE OCN_EXPORT_DATA(
     I                      myTime, myIter, myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE OCN_EXPORT_DATA
C     | o Routine for controlling
C     |   - export of ocean coupling data to coupler layer
C     |     but only if using Sequential coupling.
C     *==========================================================*
C     | This version talks to the MIT Coupler. It uses the MIT
C     | Coupler "checkpoint1" library calls.
C     *==========================================================*
C     \ev

C     !USES
      IMPLICIT NONE
C     == GLobal variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "CPL_PARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     myTime  :: Current time in simulation.
C     myIter  :: Current timestep number.
C     myThid  :: Thread number for this instance of the routine.
      _RL     myTime
      INTEGER myIter
      INTEGER myThid
CEOP

#ifdef COMPONENT_MODULE
C     !LOCAL VARIABLES:
C     msgBuf  :: Informational/error message buffer
      CHARACTER*(MAX_LEN_MBUF) msgBuf

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C     Note MIT Coupler checkpoint1 does not allow asynchronous posting of
C     data, so ordering has to be consistent with coupling layer ordering.
C--------------------------------------------------------------------------
C     Sequential coupling: Send data to coupling layer

      IF ( ocn_cplSequential ) THEN
        IF ( debugMode ) THEN
         _BEGIN_MASTER( myThid )
         WRITE(msgBuf,'(A,I10)')
     &    '  Exporting  oceanic surface fields at iter=', myIter
         CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                       SQUEEZE_RIGHT, myThid )
         _END_MASTER( myThid )
        ENDIF

        CALL OCN_STORE_MY_DATA(
     I           myTime, myIter, myThid )

        CALL OCN_EXPORT_FIELDS ( myIter, myThid )

      ENDIF

#endif /* COMPONENT_MODULE */

      RETURN
      END

#include "PACKAGES_CONFIG.h"
#include "CPP_OPTIONS.h"
#ifdef ALLOW_AUTODIFF
# include "AUTODIFF_OPTIONS.h"
#endif
#ifdef ALLOW_GENERIC_ADVDIFF
# include "GAD_OPTIONS.h"
#endif

CBOP
C     !ROUTINE: TEMP_INTEGRATE
C     !INTERFACE:
      SUBROUTINE TEMP_INTEGRATE(
     I           bi, bj, recip_hFac,
     I           uFld, vFld, wFld,
     U           KappaRk,
     I           myTime, myIter, myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE TEMP_INTEGRATE
C     | o Calculate tendency for temperature and integrates
C     |   forward in time. The temperature array is updated here
C     |   while adjustments (filters, conv.adjustment) are applied
C     |   later, in S/R TRACERS_CORRECTION_STEP.
C     *==========================================================*
C     | A procedure called APPLY_FORCING_T is called from
C     | here. These procedures can be used to add per problem
C     | heat flux source terms.
C     | Note: Although it is slightly counter-intuitive the
C     |       EXTERNAL_FORCING routine is not the place to put
C     |       file I/O. Instead files that are required to
C     |       calculate the external source terms are generally
C     |       read during the model main loop. This makes the
C     |       logistics of multi-processing simpler and also
C     |       makes the adjoint generation simpler. It also
C     |       allows for I/O to overlap computation where that
C     |       is supported by hardware.
C     | Aside from the problem specific term the code here
C     | forms the tendency terms due to advection and mixing
C     | The baseline implementation here uses a centered
C     | difference form for the advection term and a tensorial
C     | divergence of a flux form for the diffusive term. The
C     | diffusive term is formulated so that isopycnal mixing
C     | and GM-style subgrid-scale terms can be incorporated by
C     | simply setting the diffusion tensor terms appropriately.
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     == GLobal variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "DYNVARS.h"
#include "RESTART.h"
#ifdef ALLOW_GENERIC_ADVDIFF
# include "GAD.h"
# include "GAD_SOM_VARS.h"
#endif
#ifdef ALLOW_AUTODIFF_TAMC
# include "tamc.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     bi, bj,    :: tile indices
C     recip_hFac :: reciprocal of cell open-depth factor (@ next iter)
C     uFld,vFld  :: Local copy of horizontal velocity field
C     wFld       :: Local copy of vertical velocity field
C     KappaRk    :: Vertical diffusion for Tempertature
C     myTime     :: current time
C     myIter     :: current iteration number
C     myThid     :: my Thread Id. number
      INTEGER bi, bj
      _RS recip_hFac(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL uFld      (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL vFld      (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL wFld      (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL KappaRk   (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL     myTime
      INTEGER myIter
      INTEGER myThid
CEOP

#ifdef ALLOW_GENERIC_ADVDIFF
#ifdef ALLOW_DIAGNOSTICS
C     !FUNCTIONS:
      LOGICAL  DIAGNOSTICS_IS_ON
      EXTERNAL DIAGNOSTICS_IS_ON
#endif /* ALLOW_DIAGNOSTICS */

C     !LOCAL VARIABLES:
C     iMin, iMax :: 1rst index loop range
C     jMin, jMax :: 2nd  index loop range
C     k          :: vertical index
C     kM1        :: =k-1 for k>1, =1 for k=1
C     kUp        :: index into 2 1/2D array, toggles between 1|2
C     kDown      :: index into 2 1/2D array, toggles between 2|1
C     xA         :: Tracer cell face area normal to X
C     yA         :: Tracer cell face area normal to X
C     maskUp     :: Land/water mask for Wvel points (interface k)
C     uTrans     :: Zonal volume transport through cell face
C     vTrans     :: Meridional volume transport through cell face
C     rTrans     ::   Vertical volume transport at interface k
C     rTransKp   :: Vertical volume transport at inteface k+1
C     fZon       :: Flux of temperature (T) in the zonal direction
C     fMer       :: Flux of temperature (T) in the meridional direction
C     fVer       :: Flux of temperature (T) in the vertical direction
C                   at the upper(U) and lower(D) faces of a cell.
C     gT_loc     :: Temperature tendency (local to this S/R)
C     gtForc     :: Temperature forcing tendency
C     gt_AB      :: Adams-Bashforth temperature tendency increment
C   useVariableK :: T when vertical diffusion is not constant
      INTEGER iMin, iMax, jMin, jMax
      INTEGER i, j, k
      INTEGER kUp, kDown, kM1
      _RS xA      (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RS yA      (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RS maskUp  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL uTrans  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL vTrans  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL rTrans  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL rTransKp(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL fZon    (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL fMer    (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL fVer    (1-OLx:sNx+OLx,1-OLy:sNy+OLy,2)
      _RL gT_loc  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL gtForc  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL gt_AB   (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
#ifdef ALLOW_DIAGNOSTICS
      LOGICAL diagForcing, diagAB_tend
#endif
      LOGICAL calcAdvection
      INTEGER iterNb
#ifdef ALLOW_ADAMSBASHFORTH_3
      INTEGER m2
#endif
#ifdef ALLOW_AUTODIFF_TAMC
C     tkey :: tape key (tile dependent)
C     kkey :: tape key (level and tile dependent)
      INTEGER tkey, kkey
#endif

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      iterNb = myIter
      IF (staggerTimeStep) iterNb = myIter - 1

C-    Loop ranges for daughter routines:
c     iMin = 1
c     iMax = sNx
c     jMin = 1
c     jMax = sNy
C     Regarding model dynamics, only needs to get correct tracer tendency
C     (gT_loc) in tile interior (1:sNx,1:sNy);
C     However, for some diagnostics, we may want to get valid tendency
C     extended over 1 point in tile halo region (0:sNx+1,0:sNy=1).
      iMin = 0
      iMax = sNx+1
      jMin = 0
      jMax = sNy+1

#ifdef ALLOW_DIAGNOSTICS
      diagForcing = .FALSE.
      diagAB_tend = .FALSE.
      IF ( useDiagnostics .AND. tempForcing )
     &     diagForcing = DIAGNOSTICS_IS_ON( 'gT_Forc ', myThid )
      IF ( useDiagnostics .AND. AdamsBashforthGt )
     &     diagAB_tend = DIAGNOSTICS_IS_ON( 'AB_gT   ', myThid )
#endif

#ifdef ALLOW_AUTODIFF_TAMC
      tkey = bi + (bj-1)*nSx + (ikey_dynamics-1)*nSx*nSy
#endif /* ALLOW_AUTODIFF_TAMC */

C-    Apply AB on T :
      IF ( AdamsBashforth_T ) THEN
C     compute T^n+1/2 (stored in gtNm) extrapolating T forward in time
#ifdef ALLOW_ADAMSBASHFORTH_3
c         m1 = 1 + MOD(iterNb+1,2)
c         m2 = 1 + MOD( iterNb ,2)
          CALL ADAMS_BASHFORTH3(
     I                           bi, bj, 0, Nr,
     I                           theta(1-OLx,1-OLy,1,bi,bj),
     U                           gtNm, gt_AB,
     I                           tempStartAB, iterNb, myThid )
#else /* ALLOW_ADAMSBASHFORTH_3 */
          CALL ADAMS_BASHFORTH2(
     I                           bi, bj, 0, Nr,
     I                           theta(1-OLx,1-OLy,1,bi,bj),
     U                           gtNm1(1-OLx,1-OLy,1,bi,bj), gt_AB,
     I                           tempStartAB, iterNb, myThid )
#endif /* ALLOW_ADAMSBASHFORTH_3 */
      ENDIF

C-    Tracer tendency needs to be set to zero (moved here from gad_calc_rhs):
      DO k=1,Nr
       DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
         gT_loc(i,j,k) = 0. _d 0
        ENDDO
       ENDDO
      ENDDO
      DO j=1-OLy,sNy+OLy
       DO i=1-OLx,sNx+OLx
         fVer(i,j,1) = 0. _d 0
         fVer(i,j,2) = 0. _d 0
       ENDDO
      ENDDO
#ifdef ALLOW_AUTODIFF
      DO k=1,Nr
       DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
         kappaRk(i,j,k) = 0. _d 0
        ENDDO
       ENDDO
      ENDDO
#endif /* ALLOW_AUTODIFF */
#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE wFld(:,:,:)         = comlev1_bibj, key=tkey, kind=isbyte
CADJ STORE theta(:,:,:,bi,bj)  = comlev1_bibj, key=tkey, kind=isbyte
# ifdef ALLOW_ADAMSBASHFORTH_3
CADJ STORE gtNm(:,:,:,bi,bj,1) = comlev1_bibj, key=tkey, kind=isbyte
CADJ STORE gtNm(:,:,:,bi,bj,2) = comlev1_bibj, key=tkey, kind=isbyte
# else
CADJ STORE gtNm1(:,:,:,bi,bj)  = comlev1_bibj, key=tkey, kind=isbyte
# endif
#endif /* ALLOW_AUTODIFF_TAMC */

#ifdef INCLUDE_CALC_DIFFUSIVITY_CALL
      CALL CALC_3D_DIFFUSIVITY(
     I         bi, bj, iMin, iMax, jMin, jMax,
     I         GAD_TEMPERATURE, useGMredi, useKPP,
     O         kappaRk,
     I         myThid )
# ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE kappaRk = comlev1_bibj, key = tkey, kind = isbyte
# endif
#endif /* INCLUDE_CALC_DIFFUSIVITY_CALL */

#ifndef DISABLE_MULTIDIM_ADVECTION
C--     Some advection schemes are better calculated using a multi-dimensional
C       method in the absence of any other terms and, if used, is done here.
C
C The CPP flag DISABLE_MULTIDIM_ADVECTION is currently unset in GAD_OPTIONS.h
C The default is to use multi-dimensinal advection for non-linear advection
C schemes. However, for the sake of efficiency of the adjoint it is necessary
C to be able to exclude this scheme to avoid excessive storage and
C recomputation. It *is* differentiable, if you need it.
C Edit GAD_OPTIONS.h and #define DISABLE_MULTIDIM_ADVECTION to
C disable this section of code.
#ifdef GAD_ALLOW_TS_SOM_ADV
# ifdef ALLOW_AUTODIFF_TAMC
C This looks awkward from an F77 point of view, but TAF does the right thing.
CADJ STORE som_T(:,:,:,bi,bj,:) = comlev1_bibj, key=tkey, kind=isbyte
# endif
      IF ( tempSOM_Advection ) THEN
# ifdef ALLOW_DEBUG
        IF (debugMode) CALL DEBUG_CALL('GAD_SOM_ADVECT',myThid)
# endif
        CALL GAD_SOM_ADVECT(
     I             tempImplVertAdv,
     I             tempAdvScheme, tempVertAdvScheme, GAD_TEMPERATURE,
     I             dTtracerLev, uFld, vFld, wFld, theta,
     U             som_T,
     O             gT_loc,
     I             bi, bj, myTime, myIter, myThid )
      ELSEIF (tempMultiDimAdvec) THEN
#else /* GAD_ALLOW_TS_SOM_ADV */
      IF (tempMultiDimAdvec) THEN
#endif /* GAD_ALLOW_TS_SOM_ADV */
# ifdef ALLOW_DEBUG
        IF (debugMode) CALL DEBUG_CALL('GAD_ADVECTION',myThid)
# endif
        CALL GAD_ADVECTION(
     I             tempImplVertAdv,
     I             tempAdvScheme, tempVertAdvScheme, GAD_TEMPERATURE,
     I             dTtracerLev, uFld, vFld, wFld, theta,
     O             gT_loc,
     I             bi, bj, myTime, myIter, myThid )
      ENDIF
#endif /* DISABLE_MULTIDIM_ADVECTION */

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C-    Start vertical index (k) loop (Nr:1)
      calcAdvection = tempAdvection .AND. .NOT.tempMultiDimAdvec
      DO k=Nr,1,-1
#ifdef ALLOW_AUTODIFF_TAMC
        kkey = k + (tkey-1)*Nr
#endif /* ALLOW_AUTODIFF_TAMC */
        kM1  = MAX(1,k-1)
        kUp  = 1+MOD(k+1,2)
        kDown= 1+MOD(k,2)

#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE fVer(:,:,:)         = comlev1_bibj_k, key=kkey, kind = isbyte
CADJ STORE gT_loc(:,:,k)       = comlev1_bibj_k, key=kkey, kind = isbyte
# ifdef ALLOW_ADAMSBASHFORTH_3
CADJ STORE gtNm(:,:,k,bi,bj,1) = comlev1_bibj_k, key=kkey, kind = isbyte
CADJ STORE gtNm(:,:,k,bi,bj,2) = comlev1_bibj_k, key=kkey, kind = isbyte
# else
CADJ STORE gtNm1(:,:,k,bi,bj)  = comlev1_bibj_k, key=kkey, kind = isbyte
# endif
#endif /* ALLOW_AUTODIFF_TAMC */
        CALL CALC_ADV_FLOW(
     I                uFld, vFld, wFld,
     U                rTrans,
     O                uTrans, vTrans, rTransKp,
     O                maskUp, xA, yA,
     I                k, bi, bj, myThid )

C--   Collect forcing term in local array gtForc:
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          gtForc(i,j) = 0. _d 0
         ENDDO
        ENDDO
        IF ( tempForcing ) THEN
          CALL APPLY_FORCING_T(
     U                        gtForc,
     I                        iMin,iMax,jMin,jMax, k, bi,bj,
     I                        myTime, myIter, myThid )
#ifdef ALLOW_DIAGNOSTICS
          IF ( diagForcing ) THEN
            CALL DIAGNOSTICS_FILL(gtForc,'gT_Forc ',k,1,2,bi,bj,myThid)
          ENDIF
#endif /* ALLOW_DIAGNOSTICS */
        ENDIF

#ifdef ALLOW_ADAMSBASHFORTH_3
c       m1 = 1 + MOD(iterNb+1,2)
        m2 = 1 + MOD( iterNb ,2)
        CALL GAD_CALC_RHS(
     I           bi, bj, iMin,iMax,jMin,jMax, k, kM1, kUp, kDown,
     I           xA, yA, maskUp, uFld(1-OLx,1-OLy,k),
     I           vFld(1-OLx,1-OLy,k), wFld(1-OLx,1-OLy,k),
     I           uTrans, vTrans, rTrans, rTransKp,
     I           diffKhT, diffK4T, KappaRk(1-OLx,1-OLy,k), diffKr4T,
     I           theta(1-OLx,1-OLy,1,bi,bj),
     I           gtNm(1-OLx,1-OLy,1,bi,bj,m2), dTtracerLev,
     I           GAD_TEMPERATURE, tempAdvScheme, tempVertAdvScheme,
     I           calcAdvection, tempImplVertAdv, AdamsBashforth_T,
     I           tempVertDiff4, useGMRedi, useKPP, temp_stayPositive,
     O           fZon, fMer,
     U           fVer, gT_loc,
     I           myTime, myIter, myThid )
#else /* ALLOW_ADAMSBASHFORTH_3 */
        CALL GAD_CALC_RHS(
     I           bi, bj, iMin,iMax,jMin,jMax, k, kM1, kUp, kDown,
     I           xA, yA, maskUp, uFld(1-OLx,1-OLy,k),
     I           vFld(1-OLx,1-OLy,k), wFld(1-OLx,1-OLy,k),
     I           uTrans, vTrans, rTrans, rTransKp,
     I           diffKhT, diffK4T, KappaRk(1-OLx,1-OLy,k), diffKr4T,
     I           theta(1-OLx,1-OLy,1,bi,bj),
     I           gtNm1(1-OLx,1-OLy,1,bi,bj), dTtracerLev,
     I           GAD_TEMPERATURE, tempAdvScheme, tempVertAdvScheme,
     I           calcAdvection, tempImplVertAdv, AdamsBashforth_T,
     I           tempVertDiff4, useGMRedi, useKPP, temp_stayPositive,
     O           fZon, fMer,
     U           fVer, gT_loc,
     I           myTime, myIter, myThid )
#endif /* ALLOW_ADAMSBASHFORTH_3 */

C--   External thermal forcing term(s) inside Adams-Bashforth:
        IF ( tempForcing .AND. tracForcingOutAB.NE.1 ) THEN
          DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
            gT_loc(i,j,k) = gT_loc(i,j,k) + gtForc(i,j)
           ENDDO
          ENDDO
        ENDIF

        IF ( AdamsBashforthGt ) THEN
#ifdef ALLOW_ADAMSBASHFORTH_3
          CALL ADAMS_BASHFORTH3(
     I                          bi, bj, k, Nr,
     U                          gT_loc, gtNm,
     O                          gt_AB,
     I                          tempStartAB, iterNb, myThid )
#else
          CALL ADAMS_BASHFORTH2(
     I                          bi, bj, k, Nr,
     U                          gT_loc, gtNm1(1-OLx,1-OLy,1,bi,bj),
     O                          gt_AB,
     I                          tempStartAB, iterNb, myThid )
#endif
#ifdef ALLOW_DIAGNOSTICS
          IF ( diagAB_tend ) THEN
            CALL DIAGNOSTICS_FILL(gt_AB,'AB_gT   ',k,1,2,bi,bj,myThid)
          ENDIF
#endif /* ALLOW_DIAGNOSTICS */
        ENDIF

C--   External thermal forcing term(s) outside Adams-Bashforth:
        IF ( tempForcing .AND. tracForcingOutAB.EQ.1 ) THEN
          DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
            gT_loc(i,j,k) = gT_loc(i,j,k) + gtForc(i,j)
           ENDDO
          ENDDO
        ENDIF

#ifdef NONLIN_FRSURF
# ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE gT_loc(:,:,k) = comlev1_bibj_k, key = kkey, kind = isbyte
# endif
        IF (nonlinFreeSurf.GT.0) THEN
          CALL FREESURF_RESCALE_G(
     I                            bi, bj, k,
     U                            gT_loc,
     I                            myThid )
         IF ( AdamsBashforthGt ) THEN
#ifdef ALLOW_ADAMSBASHFORTH_3
# ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE gtNm(:,:,k,bi,bj,1) = comlev1_bibj_k, key=kkey, kind=isbyte
CADJ STORE gtNm(:,:,k,bi,bj,2) = comlev1_bibj_k, key=kkey, kind=isbyte
# endif
          CALL FREESURF_RESCALE_G(
     I                            bi, bj, k,
     U                            gtNm(1-OLx,1-OLy,1,bi,bj,1),
     I                            myThid )
          CALL FREESURF_RESCALE_G(
     I                            bi, bj, k,
     U                            gtNm(1-OLx,1-OLy,1,bi,bj,2),
     I                            myThid )
#else
# ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE gtNm1(:,:,k,bi,bj) = comlev1_bibj_k, key=kkey, kind = isbyte
# endif
          CALL FREESURF_RESCALE_G(
     I                            bi, bj, k,
     U                            gtNm1(1-OLx,1-OLy,1,bi,bj),
     I                            myThid )
#endif
         ENDIF
        ENDIF
#endif /* NONLIN_FRSURF */

C-    end of vertical index (k) loop (Nr:1)
      ENDDO

#ifdef ALLOW_DOWN_SLOPE
      IF ( useDOWN_SLOPE ) THEN
# ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE recip_hFac = comlev1_bibj, key = tkey, kind = isbyte
# endif
        IF ( usingPCoords ) THEN
          CALL DWNSLP_APPLY(
     I                  GAD_TEMPERATURE, bi, bj, kSurfC,
     I                  theta(1-OLx,1-OLy,1,bi,bj),
     U                  gT_loc,
     I                  recip_hFac, recip_rA, recip_drF,
     I                  dTtracerLev, myTime, myIter, myThid )
        ELSE
          CALL DWNSLP_APPLY(
     I                  GAD_TEMPERATURE, bi, bj, kLowC,
     I                  theta(1-OLx,1-OLy,1,bi,bj),
     U                  gT_loc,
     I                  recip_hFac, recip_rA, recip_drF,
     I                  dTtracerLev, myTime, myIter, myThid )
        ENDIF
      ENDIF
#endif /* ALLOW_DOWN_SLOPE */

C-    Integrate forward in time, storing in gT_loc:  gT <= T + dt*gT
      CALL TIMESTEP_TRACER(
     I                  bi, bj, dTtracerLev,
     I                  theta(1-OLx,1-OLy,1,bi,bj),
     U                  gT_loc,
     I                  myTime, myIter, myThid )

C--   Implicit vertical advection & diffusion

#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE gT_loc (:,:,:)     = comlev1_bibj, key = tkey, kind = isbyte
#endif /* ALLOW_AUTODIFF_TAMC */
#ifdef INCLUDE_IMPLVERTADV_CODE
      IF ( tempImplVertAdv .OR. implicitDiffusion ) THEN
C     to recover older (prior to 2016-10-05) results:
c     IF ( tempImplVertAdv ) THEN
#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE wFld(:,:,:)        = comlev1_bibj, key = tkey, kind = isbyte
CADJ STORE theta(:,:,:,bi,bj) = comlev1_bibj, key = tkey, kind = isbyte
CADJ STORE recip_hFac(:,:,:)  = comlev1_bibj, key = tkey, kind = isbyte
#endif /* ALLOW_AUTODIFF_TAMC */
        CALL GAD_IMPLICIT_R(
     I         tempImplVertAdv, tempVertAdvScheme, GAD_TEMPERATURE,
     I         dTtracerLev, kappaRk, recip_hFac, wFld,
     I         theta(1-OLx,1-OLy,1,bi,bj),
     U         gT_loc,
     I         bi, bj, myTime, myIter, myThid )
      ELSEIF ( implicitDiffusion ) THEN
#else /* INCLUDE_IMPLVERTADV_CODE */
      IF     ( implicitDiffusion ) THEN
#endif /* INCLUDE_IMPLVERTADV_CODE */
        CALL IMPLDIFF(
     I         bi, bj, iMin, iMax, jMin, jMax,
     I         GAD_TEMPERATURE, kappaRk, recip_hFac,
     U         gT_loc,
     I         myThid )
      ENDIF

      IF ( AdamsBashforth_T ) THEN
C-    Save current tracer field (for AB on tracer) and then update tracer
#ifdef ALLOW_ADAMSBASHFORTH_3
        CALL CYCLE_AB_TRACER(
     I             bi, bj, gT_loc,
     U             theta(1-OLx,1-OLy,1,bi,bj),
     O             gtNm(1-OLx,1-OLy,1,bi,bj,m2),
     I             myTime, myIter, myThid )
#else /* ALLOW_ADAMSBASHFORTH_3 */
        CALL CYCLE_AB_TRACER(
     I             bi, bj, gT_loc,
     U             theta(1-OLx,1-OLy,1,bi,bj),
     O             gtNm1(1-OLx,1-OLy,1,bi,bj),
     I             myTime, myIter, myThid )
#endif /* ALLOW_ADAMSBASHFORTH_3 */
      ELSE
C-    Update tracer fields:  T(n) = T**
        CALL CYCLE_TRACER(
     I             bi, bj,
     O             theta(1-OLx,1-OLy,1,bi,bj),
     I             gT_loc, myTime, myIter, myThid )
      ENDIF

#endif /* ALLOW_GENERIC_ADVDIFF */

      RETURN
      END

#include "ECCO_OPTIONS.h"

      SUBROUTINE COST_GENCOST_TRANSP( myThid )

C     ==================================================================
C     SUBROUTINE COST_GENCOST_TRANSP
C     ==================================================================
C     o Evaluate cost function contributions of section transport.

      IMPLICIT NONE

C     == global variables ==
#include "EEPARAMS.h"
#include "SIZE.h"
#include "PARAMS.h"
#include "GRID.h"
#ifdef ALLOW_CAL
# include "cal.h"
#endif
#ifdef ALLOW_ECCO
# include "ECCO_SIZE.h"
# include "ECCO.h"
#endif

C     == routine arguments ==
      INTEGER myThid

#ifdef ALLOW_GENCOST_CONTRIBUTION
C     == external functions ==
      INTEGER  ILNBLNK
      EXTERNAL ILNBLNK

C     == local variables ==
      INTEGER nrecloc, localrec
      INTEGER localstartdate(4)

      _RL myobs   (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      _RL mybar   (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      _RL localdif(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      _RL difmask (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      _RL localtmp(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)

      _RL dummy, facCost, facNum
      _RL localperiod
      _RL spminloc, spmaxloc, spzeroloc
      _RL tmpMeanTile(nSx,nSy), tmpNumTile(nSx,nSy)
      _RL tmpMeanGlo, tmpNumGlo

      INTEGER kgen(NGENCOST3D)
      INTEGER bi, bj
      INTEGER k
      INTEGER obsrec, irec
      INTEGER il,k2
      INTEGER icount, icount_transp
      LOGICAL dosumsq, dovarwei, doreadobs
      LOGICAL exst

      INTEGER preproc_i(NGENPPROC)
      _RL preproc_r(NGENPPROC)
      CHARACTER*(MAX_LEN_FNAM) mybarfile
      CHARACTER*(MAX_LEN_FNAM) preproc(NGENPPROC)
      CHARACTER*(MAX_LEN_FNAM) preproc_c(NGENPPROC)
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      CHARACTER*(128) fname1, fname0
C     == end of interface ==

C=============== PART 0: initilization ===================

C- facNum is 1 divided by the number of tiles in SIZE dot h
      facNum = nSx*nPx
      facNum = 1. _d 0 / facNum

C-- detect the relevant gencost indices
      do k=1,NGENCOST3D
        kgen(k)=0
      enddo

C-- write a report of how many transport costs
      write(msgbuf,'(A)') 'Inside cost_gencost_transp:'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )

      icount_transp=0
      do k=1,NGENCOST
        if ( (gencost_name(k)(1:6).EQ.'transp').AND.
     &     (using_gencost(k)) ) then
          icount_transp=icount_transp+1
          kgen(icount_transp)=k
          il=ILNBLNK(gencost_barfile(kgen(icount_transp)))
          write(msgbuf,'(A,i4,A,A)') 'Cost ',kgen(icount_transp),
     &    ': ',gencost_barfile(kgen(icount_transp))(1:il)
          CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                        SQUEEZE_RIGHT, myThid )

        endif
      enddo

C-- write a report of how many transport costs

      do icount=1,icount_transp
       if (kgen(icount).NE.0) then

C ========

C-- initialize objf and num:
        DO bj = myByLo(myThid), myByHi(myThid)
         DO bi = myBxLo(myThid), myBxHi(myThid)
            objf_gencost(bi,bj,kgen(icount))=0. _d 0
            num_gencost(bi,bj,kgen(icount))=0. _d 0
         ENDDO
        ENDDO

C--   Initialise local variables.
        nrecloc=0
        nrecloc=gencost_nrec(kgen(icount))

C-- only enters if there is at least 1 record
        if(nrecloc.gt.0) then

          facCost = nrecloc
          facCost = 1. _d 0 / facCost

          localperiod=0.
          localperiod=gencost_period(kgen(icount))
          dummy=gencost_dummy(kgen(icount))
          spminloc=gencost_spmin(kgen(icount))
          spmaxloc=gencost_spmax(kgen(icount))
          spzeroloc=gencost_spzero(kgen(icount))

C prefer to have preproc match nosumsq but can not seem to get syntax
C to work for comparison of characters so match dosumsq for now.
          dosumsq=.FALSE.
          dovarwei=.FALSE.
          do k2 = 1, NGENPPROC
            preproc(k2)=gencost_preproc(k2,kgen(icount))
            preproc_i(k2)=gencost_preproc_i(k2,kgen(icount))
            preproc_c(k2)=gencost_preproc_c(k2,kgen(icount))
            preproc_r(k2)=gencost_preproc_r(k2,kgen(icount))
            if (preproc(k2).EQ.'variaweight') dovarwei=.TRUE.
            if (preproc(k2)(1:7).EQ.'dosumsq') dosumsq=.TRUE.
          enddo

C-- report of dosumsq flag to make sure it is false
          il=ILNBLNK(gencost_name(kgen(icount)))
          write(msgBuf,'(3A,L5,2A)')
     &    'Cost ',gencost_name(kgen(icount))(1:il),
     &    ' dosumsq: ',dosumsq,' preproc(1): ',preproc(1)(1:7)
          CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                        SQUEEZE_RIGHT, myThid )

C-- set mybarfile
          mybarfile=gencost_barfile(kgen(icount))

C-- set obsfile if defined. Not use for now. send warning
          doreadobs=.FALSE.
          if( .not. gencost_datafile(kgen(icount)).eq.' ') then
c            doreadobs=.TRUE.
            write(msgBuf,'(A)')
     &      '**WARNING** S/R COST_GENCOST_TRANSP: gencost_datafile '
            CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                          SQUEEZE_RIGHT, myThid )
            write(msgBuf,'(A)')
     &      'are currently ignored. Adjust the S/R to add code.'
            CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                          SQUEEZE_RIGHT, myThid )
          endif

C model mask[W,S]: already included in transp calc in ecco_phys

C--------- PART 0.1 read weights --------------------

C-- read mask in gencost_mask
C-- for now, assume non-time-variable mask

C=============== PART 1: main loop ===================
          do irec = 1,nrecloc

C--------- PART 1.1 read barfiles ------------------

C-- set all bars to zeros:
            call ecco_zero(mybar,Nr,zeroRL,myThid)

C gencost_mask and fname0 are dummy, get fname1 from mybarfile
            exst=.FALSE.
            call ecco_zero(localtmp,Nr,zeroRL,myThid)
            call cost_gencal(mybarfile,gencost_mask(kgen(icount)),
     &       irec,localstartdate,localperiod,fname1,
     &       fname0,localrec,obsrec,exst,myThid)
            call cost_genread(fname1,mybar,localtmp,irec,Nr,Nr,
     &       nrecloc,preproc,preproc_c,preproc_i,preproc_r,
     &       dummy,myThid)

C--------- PART 1.2 read data --------------------

C-- ignore for now, but use doreadobs flag if needed
C-- be careful of recomputation when put inside if-end block
c            if(doreadobs) then
            call ecco_zero(myobs,Nr,zeroRL,myThid)
c            endif

C--------- PART 1.3 Cost calculation -------------

C-- keep total at each irec to print out for time-series
            DO bj = myByLo(myThid), myByHi(myThid)
             DO bi = myBxLo(myThid), myBxHi(myThid)
               tmpMeanTile(bi,bj) = 0. _d 0
               tmpNumTile(bi,bj) = 0. _d 0
             ENDDO
            ENDDO

C compute obs minus bar (localdif) and mask (difmask)
C note localtmp is set to 1.
            call ecco_zero(localtmp,Nr,oneRL,myThid)
            call ecco_zero(localdif,Nr,zeroRL,myThid)
            call ecco_zero(difmask,Nr,zeroRL,myThid)

C take care to set sp[min,max,zero]loc carefully to not
C filter out signal.  Can consider skip diffmsk step
            call ecco_diffmsk(
     I       mybar, myobs, localtmp,
     I       Nr, Nr,spminloc, spmaxloc, spzeroloc,
     O       localdif, difmask,
     I       myThid )

            call ecco_zero(localtmp,Nr,oneRL,myThid)
            call ecco_addcost(
     I       localdif,localtmp,difmask,Nr,Nr,dosumsq,
     O       tmpMeanTile,tmpNumTile,
     I       myThid)

cC either use ecco_diffmsk and ecco_addcost from above or simplify
cC to call below. For now keep syntax consistent with gencost
c            call ecco_zero(localtmp,Nr,oneRL,myThid)
c            call ecco_addcost(
c     I       mybar,localtmp,localtmp,Nr,Nr,dosumsq,
c     O       tmpMeanTile,tmpNumTile,
c     I       myThid)

C global sums for display of time series
C note tmpNumGlo is the constant total wet points in the gencost_mask[W,S]
            tmpMeanGlo = 0. _d 0
            tmpNumGlo = 0. _d 0
            il=ILNBLNK(gencost_barfile(kgen(icount)))
            CALL GLOBAL_SUM_TILE_RL( tmpMeanTile, tmpMeanGlo, myThid )
            CALL GLOBAL_SUM_TILE_RL( tmpNumTile, tmpNumGlo, myThid )
            WRITE(msgBuf,'(2A,I3,A,1PE21.14,1PE21.14)')
     &        'globalsum transp ',gencost_barfile(kgen(icount))(1:il),
     &        irec,' ',tmpMeanGlo,tmpNumGlo
            CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                          SQUEEZE_RIGHT, myThid )

C sum that is actually be used in cost function
            DO bj = myByLo(myThid), myByHi(myThid)
             DO bi = myBxLo(myThid), myBxHi(myThid)
               objf_gencost(bi,bj,kgen(icount))=
     &            objf_gencost(bi,bj,kgen(icount))+tmpMeanTile(bi,bj)
             ENDDO
            ENDDO

          enddo !irec

C-- last step:
C-- divide by number of record to get mean transport:
C-- make num_gencost equals number of months/days used
          DO bj = myByLo(myThid), myByHi(myThid)
           DO bi = myBxLo(myThid), myBxHi(myThid)
             objf_gencost(bi,bj,kgen(icount))=
     &          objf_gencost(bi,bj,kgen(icount))*facCost
             num_gencost(bi,bj,kgen(icount))=nrecloc*facNum
           ENDDO
          ENDDO

        endif !if (nrecloc.gt.0)
       endif !if (kgen.NE.0)
      enddo !icount_transp

#endif /* ALLOW_GENCOST_CONTRIBUTION */

      RETURN
      END

#include "AIM_OPTIONS.h"
#ifdef ALLOW_LAND
#include "LAND_OPTIONS.h"
#endif

CBOP
C     !ROUTINE: AIM_AIM2LAND
C     !INTERFACE:
      SUBROUTINE AIM_AIM2LAND(
     I               land_frc, bi, bj, myTime, myIter, myThid)

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R AIM_AIM2LAND
C     | o Export land surface fluxes to Land package
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     == Global variables ===
C-- size for MITgcm & Physics package :
#include "AIM_SIZE.h" 

#include "EEPARAMS.h"
#include "PARAMS.h"

C-- Physics package
#include "AIM_PARAMS.h"
#include "com_physcon.h"
#include "com_physvar.h"

#ifdef ALLOW_LAND
#include "LAND_SIZE.h" 
#include "LAND_PARAMS.h"
#include "LAND_VARS.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     land_frc :: land fraction [0-1]
C     bi,bj    :: Tile index
C     myTime   :: Current time of simulation ( s )
C     myIter   :: Current iteration number in simulation
C     myThid   :: Number of this instance of the routine
      _RS land_frc(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      INTEGER bi, bj, myIter, myThid
      _RL myTime
CEOP

#ifdef ALLOW_AIM
#ifdef ALLOW_LAND
C     == Local variables ==
C     i,j,k,I2     :: loop counters
C     conv_precip  :: conversion factor for precip: from g/m2/s to kg/m2/s
      _RL conv_precip
      INTEGER i,j,k,I2

C--   Initialisation :
      IF ( .NOT.land_impl_grT ) THEN
       DO j=1,sNy
        DO i=1,sNx
         land_Pr_m_Ev(i,j,bi,bj) = 0. _d 0
         land_EnWFlux(i,j,bi,bj) = 0. _d 0
        ENDDO
       ENDDO
      ENDIF

C--   Atmospheric Physics Fluxes

c     IF ( useLand ) THEN

C      from g/m2/s to kg/m2/s :
       conv_Precip = 1. _d -3

      IF ( land_calc_grT .AND. .NOT.land_impl_grT ) THEN
C--   Surface heat flux to compute ground temperature explicitely:
       k = 0
       IF (aim_splitSIOsFx) k = 1 
       DO j=1,sNy
        DO i=1,sNx
         I2 = i+(j-1)*sNx

C-    total surface downward heat flux :
         land_HeatFlx(i,j,bi,bj) = 
     &                         SSR(I2,k,myThid)
     &                       - SLR(I2,k,myThid)
     &                       - SHF(I2,1,myThid)
     &                       - EVAP(I2,1,myThid)*ALHC
        ENDDO
       ENDDO

       IF ( land_calc_snow ) THEN
C-     Evap of snow: substract Latent Heat of freezing from heatFlux
        DO j=1,sNy
         DO i=1,sNx
          I2 = i+(j-1)*sNx
          IF ( land_skinT(i,j,bi,bj).LT. 0. _d 0 .OR.
     &         land_hSnow(i,j,bi,bj).GT. 0. _d 0 ) THEN
           land_HeatFlx(i,j,bi,bj) = land_HeatFlx(i,j,bi,bj)
     &                       - EVAP(I2,1,myThid)*ALHF
           land_EnWFlux(i,j,bi,bj) = 
     &                         EVAP(I2,1,myThid)*ALHF
          ENDIF
         ENDDO
        ENDDO
       ENDIF

C--   to compute ground temperature explicitely: end
      ENDIF
 
C--   Fresh water fluxes
       DO j=1,sNy
        DO i=1,sNx
         I2 = i+(j-1)*sNx

C-    total Precip minus Evap surface flux :
C        convert from g.m-2.s-1 to kg/m2/s
         land_Pr_m_Ev(i,j,bi,bj) = land_Pr_m_Ev(i,j,bi,bj)
     &       + conv_precip*(   PRECNV(I2,myThid)
     &                       + PRECLS(I2,myThid)
     &                       - EVAP(I2,1,myThid)
     &                     )

        ENDDO
       ENDDO

      IF ( aim_energPrecip ) THEN
C-     Compute energy flux related to Precip. (snow, T_rain)
C      Evap of snow: add Latent Heat of freezing
       DO j=1,sNy
        DO i=1,sNx
         I2 = i+(j-1)*sNx
         land_EnWFlux(i,j,bi,bj) = land_EnWFlux(i,j,bi,bj)
     &       + EnPrec(I2,myThid)*( PRECNV(I2,myThid)
     &                            +PRECLS(I2,myThid) )
        ENDDO
       ENDDO
      ENDIF

C- end (if useLand)
c     ENDIF

#endif /* ALLOW_LAND */
#endif /* ALLOW_AIM */

      RETURN
      END

#include "MOM_COMMON_OPTIONS.h"

CBOP
C !ROUTINE: MOM_U_CORIOLIS_NH

C !INTERFACE: ==========================================================
      SUBROUTINE MOM_U_CORIOLIS_NH(
     I               bi, bj, k, wFld,
     O               uCoriolisTerm,
     I               myThid )

C !DESCRIPTION:
C Calculates the 3.D Coriolis term in the zonal momentum equation:
C \begin{equation*}
C - \overline{ f_prime \overline{w}^{k} }^{i}
C \end{equation*}
C consistent with Non-Hydrostatic (or quasi-hydrostatic) formulation

C !USES: ===============================================================
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"

C !INPUT PARAMETERS: ===================================================
C  bi, bj               :: tile indices
C  k                    :: vertical level
C  wFld                 :: vertical flow
C  myThid               :: thread number
      INTEGER bi, bj, k
      _RL wFld(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      INTEGER myThid

C !OUTPUT PARAMETERS: ==================================================
C  uCoriolisTerm        :: Coriolis term
      _RL uCoriolisTerm(1-OLx:sNx+OLx,1-OLy:sNy+OLy)

C !LOCAL VARIABLES: ====================================================
C  i, j                 :: loop indices
      INTEGER i, j, kp1
      _RL wMsk
CEOP

      kp1 = MIN(k+1,Nr)
      wMsk = 1.
      IF (k.EQ.Nr) wMsk = 0.

      IF ( select3dCoriScheme.EQ.1 ) THEN
C-    Original discretization of 2*Omega*cos(phi)*w
C     documented as Energy conserving
       DO j=1-OLy,sNy+OLy
        DO i=2-OLx,sNx+OLx
         uCoriolisTerm(i,j) = gravitySign*halfRL
     &       *( fCoriCos( i ,j,bi,bj)*angleCosC( i ,j,bi,bj)*halfRL
     &           *( wFld( i ,j, k ,bi,bj)*rVel2wUnit( k )
     &            + wFld( i ,j,kp1,bi,bj)*rVel2wUnit(kp1)*wMsk )
     &        + fCoriCos(i-1,j,bi,bj)*angleCosC(i-1,j,bi,bj)*halfRL
     &           *( wFld(i-1,j, k ,bi,bj)*rVel2wUnit( k )
     &            + wFld(i-1,j,kp1,bi,bj)*rVel2wUnit(kp1)*wMsk )
     &        )
        ENDDO
       ENDDO
      ELSE
C-    Using averaged transport:
       DO j=1-OLy,sNy+OLy
        DO i=2-OLx,sNx+OLx
         uCoriolisTerm(i,j) = gravitySign*halfRL
     &    *( fCoriCos( i ,j,bi,bj)*angleCosC( i ,j,bi,bj)
     &      *( wFld( i ,j, k ,bi,bj)*rVel2wUnit( k )*deepFac2F( k )
     &       + wFld( i ,j,kp1,bi,bj)*rVel2wUnit(kp1)*deepFac2F(kp1)*wMsk
     &       )*rA( i ,j,bi,bj)*halfRL
     &     + fCoriCos(i-1,j,bi,bj)*angleCosC(i-1,j,bi,bj)
     &      *( wFld(i-1,j, k ,bi,bj)*rVel2wUnit( k )*deepFac2F( k )
     &       + wFld(i-1,j,kp1,bi,bj)*rVel2wUnit(kp1)*deepFac2F(kp1)*wMsk
     &       )*rA(i-1,j,bi,bj)*halfRL
     &     )*recip_rAw(i,j,bi,bj)*recip_deepFac2C(k)
     &      *recip_hFacW(i,j,k,bi,bj)
        ENDDO
       ENDDO
      ENDIF

      RETURN
      END

#include "CTRL_OPTIONS.h"

      subroutine ctrl_mask_set_xz(
     &     jp1, jNone, OB_J, nwetobcs, ymaskobcs, myThid )

c     ==================================================================
c     SUBROUTINE ctrl_mask_set_xz
c     ==================================================================
c
c     o count sliced (xz) wet points and set xz masks
c
c     heimbach@mit.edu, 30-Aug-2001
c     gebbie@mit.edu, corrected array bounds
c
c     ==================================================================

      implicit none

c     == global variables ==

#include "EEPARAMS.h"
#include "SIZE.h"
#include "PARAMS.h"
#include "GRID.h"
#include "CTRL_SIZE.h"
#include "CTRL.h"
#include "CTRL_OBCS.h"

c     == routine arguments ==

      integer jp1, jNone
      integer OB_J     (1-OLx:sNx+OLx,nSx,nSy)
      integer nwetobcs (nSx,nSy,Nr,nobcs)
      character*(MAX_LEN_FNAM)   ymaskobcs
      integer myThid

c     == local variables ==

      integer bi,bj
      integer i,j,k
      integer itlo,ithi
      integer jtlo,jthi

      integer iobcs
      integer il
      _RL     dummy
      _RL     maskxz   (1-OLx:sNx+OLx,Nr,nSx,nSy,nobcs)
      _RL     gg       (1-OLx:sNx+OLx,Nr,nSx,nSy)

      character*(MAX_LEN_FNAM)   fname

c     == external ==

      integer  ilnblnk
      external ilnblnk

c     == end of interface ==

      jtlo = myByLo(myThid)
      jthi = myByHi(myThid)
      itlo = myBxLo(myThid)
      ithi = myBxHi(myThid)

      _BEGIN_MASTER( myThid )

c--   Count wet points at Northern boundary.
c--   mask conventions are adopted from obcs_apply_ts, obcs_apply_uv
      do iobcs = 1,nobcs
        do bj = jtlo,jthi
          do bi = itlo,ithi
            do k = 1,Nr
              do i = 1-OLx,sNx+OLx
                maskxz(i,k,bi,bj,iobcs) = 0. _d 0
              enddo
            enddo
          enddo
        enddo
      enddo

      do iobcs = 1,nobcs
        do bj = jtlo,jthi
          do bi = itlo,ithi
            do k = 1,Nr
              do i = 1,sNx
                j = OB_J(i,bi,bj)
                if ( j .NE. jNone ) then
c--               South mask for T, S, V
                  if (iobcs.eq.1 .or. iobcs .eq.2 .or. iobcs.eq.3) then
                    if (maskS(i,j+jp1,k,bi,bj) .ne. 0.) then
                      nwetobcs(bi,bj,k,iobcs) =nwetobcs(bi,bj,k,iobcs)+1
                      maskxz(i,k,bi,bj,iobcs) = 1
                    endif
                  endif
c--               West mask for U
                  if (iobcs .eq. 4) then
                    if (maskW(i,j,k,bi,bj) .eq. 1.) then
                      nwetobcs(bi,bj,k,iobcs) =nwetobcs(bi,bj,k,iobcs)+1
                      maskxz(i,k,bi,bj,iobcs) = 1
                    endif
                  endif
                endif
              enddo
            enddo
          enddo
        enddo
      enddo

#ifdef ALLOW_AUTODIFF
      il=ilnblnk( ymaskobcs )
      write(fname,'(a)') ymaskobcs

      do iobcs = 1,nobcs
        do bj = jtlo,jthi
          do bi = itlo,ithi
            do k = 1,Nr
              do i = 1,sNx
                 gg(i,k,bi,bj) = maskxz(i,k,bi,bj,iobcs)
              enddo
            enddo
          enddo
        enddo
        call active_write_xz( fname, gg, iobcs, 0, myThid, dummy )
      enddo
#endif

      _END_MASTER( myThid )

      return
      end

#include "AIM_OPTIONS.h"
#ifdef ALLOW_THSICE
#include "THSICE_OPTIONS.h"
#endif

CBOP
C     !ROUTINE: AIM_SICE2AIM
C     !INTERFACE:
      SUBROUTINE AIM_SICE2AIM(
     I               land_frc,
     U               aimTsoce, aimSIfrc,
     O               aimTsice, aimAlb,
     I               myTime, myIter, bi, bj, myThid )

C     !DESCRIPTION: \bv
C     *================================================================*
C     | S/R AIM_SICE2AIM
C     | provide surface Boundary Conditions over sea-ice
C     | (from thsice pkg) to atmospheric physics package AIM
C     *================================================================*
C     *================================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     == Global variables ===
C-- size for MITgcm & Physics package :
#include "AIM_SIZE.h"

C-- MITgcm
#include "EEPARAMS.h"
#include "PARAMS.h"

C-- Physics package
#include "AIM_PARAMS.h"
#include "com_forcon.h"

#ifdef ALLOW_THSICE
C-- Sea-Ice package
#include "THSICE_SIZE.h"
#include "THSICE_PARAMS.h"
#include "THSICE_VARS.h"
      INTEGER siLo, siHi, sjLo, sjHi
      PARAMETER ( siLo = 1-OLx , siHi = sNx+OLx )
      PARAMETER ( sjLo = 1-OLy , sjHi = sNy+OLy )
#endif /* ALLOW_THSICE */

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     land_frc :: land fraction [0-1]
C     aimTsoce :: sea surface temp [K], used in AIM
C     aimSIfrc :: sea-ice fraction [0-1]
C     aimTsice :: sea-ice (or snow) surface temp (K), used in AIM
C     aimAlb   :: sea-ice albedo [0-1], used in AIM
C     myTime   :: Current time of simulation ( s )
C     myIter   :: Current iteration number in simulation
C     bi,bj    :: Tile index
C     myThid   :: Number of this instance of the routine
      _RS  land_frc(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL  aimTsoce(sNx,sNy)
      _RL  aimSIfrc(sNx,sNy)
      _RL  aimTsice(sNx,sNy)
      _RL  aimAlb(sNx,sNy)
      INTEGER myIter, bi, bj, myThid
      _RL myTime
CEOP

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#ifdef ALLOW_AIM
#ifdef ALLOW_THSICE

C     == Local variables ==
C     i,j          :: Loop counters
      INTEGER i,j

      IF ( .TRUE. ) THEN
C-    Use thsice-pkg output instead of prescribed Temp & ice fraction
        DO j=1,sNy
         DO i=1,sNx
           aimTsice(i,j) = Tsrf(i,j,bi,bj)+celsius2K
           aimSIfrc(i,j) = iceMask(i,j,bi,bj)
         ENDDO
        ENDDO
      ELSE
C-    Fill in thsice-pkg Temp. using AIM surf. fields
        DO j=1,sNy
         DO i=1,sNx
           Tsrf (i,j,bi,bj) = aimTsice(i,j)-celsius2K
           Tice1(i,j,bi,bj) = Tsrf (i,j,bi,bj)
           Tice2(i,j,bi,bj) = Tsrf (i,j,bi,bj)
           iceMask(i,j,bi,bj) = aimSIfrc(i,j)
         ENDDO
        ENDDO
      ENDIF

      IF ( .TRUE. ) THEN
C-     Compute albedo over sea-ice
        CALL THSICE_ALBEDO(
     I          bi, bj, siLo, siHi, sjLo, sjHi,
     I          1, sNx, 1, sNy,
     I          iceMask(siLo,sjLo,bi,bj), iceHeight(siLo,sjLo,bi,bj),
     I          snowHeight(siLo,sjLo,bi,bj), Tsrf(siLo,sjLo,bi,bj),
     I          snowAge(siLo,sjLo,bi,bj),
     O          siceAlb(siLo,sjLo,bi,bj), icAlbNIR(siLo,sjLo,bi,bj),
     I          myTime, myIter, myThid )
        DO j=1,sNy
         DO i=1,sNx
          aimAlb(i,j) = siceAlb(i,j,bi,bj)
         ENDDO
        ENDDO
      ELSE
C-    Surface Albedo : (from F.M. FORDATE S/R)
        DO j=1,sNy
         DO i=1,sNx
           aimAlb(i,j) = ALBICE
         ENDDO
        ENDDO
      ENDIF

C-- fill in ocean mixed layer variables
C   notes: this replace reading initial conditions from files.
C          needs to be done before call to phy_driver (since freezing
C          temp. is fct of salinity) ; but would be better somewhere else.
      IF ( tauRelax_MxL .EQ. -1. _d 0
     &     .OR. ( stepFwd_oceMxL  .AND. StartIceModel.NE.0
     &                            .AND. myIter.EQ.nIter0   )
     &     .OR. ( myIter.EQ.0 .AND. myTime.EQ.baseTime
     &                        .AND. .NOT.useCoupler )
     &   ) THEN
        DO j=1,sNy
         DO i=1,sNx
          IF ( land_frc(i,j,bi,bj) .LT. 1. _d 0 ) THEN
           tOceMxL(i,j,bi,bj) = aimTsoce(i,j)-celsius2K
           sOceMxL(i,j,bi,bj) = sMxL_default
          ENDIF
         ENDDO
        ENDDO
        IF ( myIter.EQ.nIter0 ) THEN
C-- Over-write the initial T,S_MxL files with the correct fields
          CALL WRITE_LOCAL_RL( 'ice_tOceMxL', 'I10', 1,
     &                         tOceMxL(1-OLx,1-OLy,bi,bj),
     &                         bi, bj, 1, myIter, myThid )
          CALL WRITE_LOCAL_RL( 'ice_sOceMxL', 'I10', 1,
     &                         sOceMxL(1-OLx,1-OLy,bi,bj),
     &                         bi, bj, 1, myIter, myThid )
        ENDIF
      ELSE
C-- Use ocean mixed layer Temp as Atmos. SST (instead of prescribed Temp)
        DO j=1,sNy
         DO i=1,sNx
          IF ( land_frc(i,j,bi,bj) .LT. 1. _d 0 ) THEN
           aimTsoce(i,j) = tOceMxL(i,j,bi,bj)+celsius2K
          ENDIF
         ENDDO
        ENDDO
      ENDIF

#endif /* ALLOW_THSICE */
#endif /* ALLOW_AIM */

      RETURN
      END

#include "GAD_OPTIONS.h"

CBOP
C !ROUTINE: GAD_DIFF_Y

C !INTERFACE: ==========================================================
      SUBROUTINE GAD_DIFF_Y(
     I           bi,bj,k,
     I           yA, diffKh,
     I           tracer,
     O           dfy,
     I           myThid )

C !DESCRIPTION:
C Calculates the area integrated meridional flux due to down-gradient
C diffusion of a tracer:
C \begin{equation*}
C F^y_{diff} = - A^y \kappa_h \frac{1}{\Delta y_c} \delta_j \theta
C \end{equation*}

C !USES: ===============================================================
      IMPLICIT NONE
#include "SIZE.h"
#include "GRID.h"
#ifdef ALLOW_SMAG_3D_DIFFUSIVITY
# include "EEPARAMS.h"
# include "PARAMS.h"
# include "DYNVARS.h"
#endif

C !INPUT PARAMETERS: ===================================================
C  bi,bj                :: tile indices
C  k                    :: vertical level
C  yA                   :: area of face at V points
C  diffKh               :: horizontal diffusivity
C  tracer               :: tracer field
C  myThid               :: thread number
      INTEGER bi,bj,k
      _RS yA    (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL diffKh
      _RL tracer(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER myThid

C !OUTPUT PARAMETERS: ==================================================
C  dfx                  :: meridional diffusive flux
      _RL dfy   (1-OLx:sNx+OLx,1-OLy:sNy+OLy)

C !LOCAL VARIABLES: ====================================================
C  i,j                  :: loop indices
      INTEGER i,j
CEOP

      DO i=1-OLx,sNx+OLx
       dfy(i,1-OLy) = 0.
      ENDDO
#ifdef ALLOW_SMAG_3D_DIFFUSIVITY
      IF ( smag3D_diffCoeff.GT.zeroRL ) THEN
        DO j=1-OLy+1,sNy+OLy
         DO i=1-OLx,sNx+OLx
          dfy(i,j) = -( diffKh
     &                + halfRL*( smag3D_diffK(i,j-1,k,bi,bj)
     &                         + smag3D_diffK(i, j, k,bi,bj) )
     &                )*yA(i,j)
     &             *_recip_dyC(i,j,bi,bj)*recip_deepFacC(k)
     &             *( tracer(i,j) - tracer(i,j-1) )
#ifdef ISOTROPIC_COS_SCALING
     &             *cosFacV(j,bi,bj)
#endif
         ENDDO
        ENDDO
      ELSE
#endif /* ALLOW_SMAG_3D_DIFFUSIVITY */
        DO j=1-OLy+1,sNy+OLy
         DO i=1-OLx,sNx+OLx
          dfy(i,j) = -diffKh*yA(i,j)
     &             *_recip_dyC(i,j,bi,bj)*recip_deepFacC(k)
     &             *( tracer(i,j) - tracer(i,j-1) )
#ifdef ISOTROPIC_COS_SCALING
     &             *cosFacV(j,bi,bj)
#endif
         ENDDO
        ENDDO
#ifdef ALLOW_SMAG_3D_DIFFUSIVITY
      ENDIF
#endif /* ALLOW_SMAG_3D_DIFFUSIVITY */

      RETURN
      END

#include "OBSFIT_OPTIONS.h"

CBOP
C !ROUTINE: OBSFIT_INIT_VARIA

C !INTERFACE:
      SUBROUTINE OBSFIT_INIT_VARIA( myThid )

C     !DESCRIPTION:
C     ==================================================================
C     | Initialize ObsFit variables (for cost function)
C     ==================================================================

C     !USES:
      IMPLICIT NONE
C     == Global variables ===
#include "EEPARAMS.h"
#include "SIZE.h"
#include "GRID.h"

#ifdef ALLOW_OBSFIT
# include "OBSFIT_SIZE.h"
# include "OBSFIT.h"
#endif

#ifdef ALLOW_GRDCHK
# include "netcdf.inc"
#endif

C     !INPUT PARAMETERS:
C     myThid :: my thread ID number
      INTEGER myThid
CEOP

C     !LOCAL VARIABLES:
      INTEGER bi,bj
      INTEGER num_file
#ifdef ALLOW_GRDCHK
      INTEGER err
#endif /* ALLOW_GRDCHK */

C Initialize tiled cost function variables
      DO bj = myByLo(myThid), myByHi(myThid)
        DO bi = myBxLo(myThid), myBxHi(myThid)
          DO num_file = 1, NFILESMAX_OBS
            obsfit_dummy(num_file,bi,bj) = 0. _d 0
          ENDDO
        ENDDO
      ENDDO

C Initialize global cost function variables
      _BEGIN_MASTER(myThid)

      DO num_file = 1, NFILESMAX_OBS
        objf_obsfit(num_file) = 0. _d 0
        num_obsfit(num_file) = 0. _d 0
        obsfit_globaldummy(num_file) = 0. _d 0
      ENDDO

      _END_MASTER(myThid)

#ifdef ALLOW_GRDCHK
      IF ( obsfitDoNcOutput ) THEN
        DO bj = myByLo(myThid), myByHi(myThid)
          DO bi = myBxLo(myThid), myBxHi(myThid)
            DO num_file = 1, NFILESMAX_OBS
              IF ( sampleNo(num_file,bi,bj).GT.0 ) THEN
C Write data from buffer to .nc file
                err = NF_SYNC( fidfwd_obs(num_file,bi,bj) )
                CALL OBSFIT_NF_ERROR(
     &               'INIT_VARIA: NF_SYNC fidfwd_obs',
     &               err,bi,bj,myThid )

# ifdef ALLOW_TANGENTLINEAR_RUN
                IF ( TANGENT_SIMULATION ) THEN
                  err = NF_SYNC( fidtan_obs(num_file,bi,bj) )
                  CALL OBSFIT_NF_ERROR(
     &                 'INIT_VARIA: NF_SYNC fidtan_obs',
     &                 err,bi,bj,myThid )
                ENDIF
# endif /* ALLOW_TANGENTLINEAR_RUN */

              ENDIF !IF (sampleNo)
            ENDDO !DO num_file
          ENDDO !DO bi
        ENDDO! DO bj
      ENDIF !IF (obsfitDoNcOutput)
#endif /* ALLOW_GRDCHK */

      _BARRIER

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#include "CAL_OPTIONS.h"

      SUBROUTINE CAL_SUMMARY(
     I                        myThid )

C     ==================================================================
C     SUBROUTINE cal_Summary
C     ==================================================================
C
C     o List all the settings of the calendar tool.
C
C     started: Christian Eckert eckert@mit.edu  30-Jun-1999
C     changed: Christian Eckert eckert@mit.edu  10-Jan-2000
C              - corrected typo: nIterEnd --> nEndIter.
C              Christian Eckert eckert@mit.edu  03-Feb-2000
C              - Introduced new routine and function names, cal_<NAME>,
C                for verion 0.1.3.
C
C     ==================================================================
C     SUBROUTINE cal_Summary
C     ==================================================================

      IMPLICIT NONE

C     == global variables ==
#include "EEPARAMS.h"
#include "cal.h"

C     == routine arguments ==
C     myThid  - thread number for this instance of the routine.
      INTEGER myThid

C     == local variables ==
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      INTEGER numcaldays
      INTEGER numcalmonths
      INTEGER numcalyears

C     == Functions ==
      INTEGER  cal_IntYears
      EXTERNAL cal_IntYears
      INTEGER  cal_IntMonths
      EXTERNAL cal_IntMonths
      INTEGER  cal_IntDays
      EXTERNAL cal_IntDays

C     == end of interface ==

      _BEGIN_MASTER(myThid)

      numcalyears  = cal_IntYears ( myThid )
      numcalmonths = cal_IntMonths( myThid )
      numcaldays   = cal_IntDays  ( myThid )

      WRITE(msgBuf,'(A)') ' '
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)')
     &'// ======================================================='
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)')
     &'// Calendar configuration >>> START <<<'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)')
     &'// ======================================================='
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)') ' '
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
c     WRITE(msgBuf,'(A,A)')
c    &'Calendar version: ',calendarversion
c     CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
c    &                    SQUEEZE_RIGHT, myThid )
c     WRITE(msgBuf,'(A)') ' '
c     CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
c    &                    SQUEEZE_RIGHT, myThid )

      CALL WRITE_0D_RL( modelstart, INDEX_NONE,'modelstart =',
     &  ' /* Start time of the model integration [s] */')
      CALL WRITE_0D_RL( modelend, INDEX_NONE, 'modelend  =',
     &  ' /* End time of the model integration [s] */')
      CALL WRITE_0D_RL( modelStep, INDEX_NONE,'modelStep =',
     &  ' /* Time interval for a model forward step [s] */')
      CALL WRITE_0D_L( usingGregorianCalendar, INDEX_NONE,
     &                'usingGregorianCalendar=',
     &  ' /* Calendar Type: Gregorian Calendar */')
      CALL WRITE_0D_L( usingJulianCalendar, INDEX_NONE,
     &                'usingJulianCalendar =',
     &  ' /* Calendar Type: Julian Calendar */')
      CALL WRITE_0D_L( usingNoLeapYearCal, INDEX_NONE,
     &                'usingNoLeapYearCal  =',
     &  ' /* Calendar Type: without Leap Year */')
      CALL WRITE_0D_L( usingModelCalendar, INDEX_NONE,
     &                'usingModelCalendar  =',
     &  ' /* Calendar Type: Model Calendar */')
      CALL WRITE_0D_I( modelStartDate(1), INDEX_NONE,
     &                'modelStartDate YYYYMMDD =',
     &  ' /* Model start date YYYY-MM-DD */')
      CALL WRITE_0D_I( modelStartDate(2), INDEX_NONE,
     &                '  modelStartDate HHMMSS =',
     &  ' /* Model start date HH-MM-SS  */')
      CALL WRITE_0D_I( modelEndDate(1), INDEX_NONE,
     &                'modelEndDate   YYYYMMDD =',
     &  ' /* Model end date YYYY-MM-DD */')
      CALL WRITE_0D_I( modelEndDate(2), INDEX_NONE,
     &                '  modelEndDate   HHMMSS =',
     &  ' /* Model end date HH-MM-SS  */')
      CALL WRITE_0D_I( numcalyears, INDEX_NONE,
     &                'intyears =',
     &  ' /* Number of calendar years affected by the integration */')
      CALL WRITE_0D_I( numcalmonths, INDEX_NONE,
     &                'intmonths=',
     &  ' /* Number of calendar months affected by the integration */')
      CALL WRITE_0D_I( numcaldays, INDEX_NONE,
     &                'intdays =',
     &  ' /* Number of calendar days affected by the integration */')
      CALL WRITE_0D_I( modelIter0, INDEX_NONE,
     &                'modelIter0 =',
     &  ' /* Base timestep number  */')
      CALL WRITE_0D_I( modelIterEnd, INDEX_NONE,
     &                'modelIterEnd =',
     &  ' /* Final timestep number  */')
      CALL WRITE_0D_I( modelIntSteps, INDEX_NONE,
     &                'modelIntSteps=',
     &  ' /* Number of model timesteps  */')
      WRITE(msgBuf,'(A)') ' '
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)')
     &'// ======================================================='
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)')
     &'// Calendar configuration  >>> END <<<'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)')
     &'// ======================================================='
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)') ' '
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )

      _END_MASTER(myThid)

      RETURN
      END

#include "CPP_OPTIONS.h"

CBOP 0
C !ROUTINE: INITIALISE

C !INTERFACE:
      SUBROUTINE INITIALISE(
     O                       msgUnit )

C !DESCRIPTION:
C     *==========================================================*
C     | SUBROUTINE INITIALISE
C     | o Routine to initialise coupling component.
C     *==========================================================*
C     | Initialisation involves starting up MPI and then joining
C     | the coupled configuration as a component with the special
C     | name "Coupler". With the present MIT Coupler library
C     | only one process can register with the name "Coupler".
C     | This component is the process responsible for
C     | coordinating the transfer of data between other
C     | components and for mapping data from one components
C     | representation to anothers representation as appropriate.
C     *==========================================================*

C !USES:
      IMPLICIT NONE
C     === GLobal variables ==
#include "CPLIDS.h"

C !INPUT/OUTPUT PARAMETERS:
C     msgUnit          :: log-file I/O unit
      INTEGER msgUnit

C !LOCAL VARIABLES:
C     iErr             :: Error code
C     MPI_COMM_Coupler :: Communicatior used by this component.
C                         Stored internally by the coupling library.
      INTEGER iErr
      INTEGER MPI_COMM_Coupler
CEOP

      CALL MPI_Init(iErr)

C--   Set the running directory (= rank_0 )
      CALL SETDIR( 0 )

C     Register this process as the "coupler" participant. Currently there can
C     only be one coupler participant all others are "component" participants.
      CALL MITCOUPLER_INIT(
     I                      cplCompName,
     O                      MPI_COMM_Coupler, msgUnit )

      CALL CPL_READ_PARAMS( msgUnit )

      CALL SET_RUNOFFMAP( msgUnit )

C--   Initialise Coupler field arrays
      CALL CPL_INIT_ATM_VARS( msgUnit )
      CALL CPL_INIT_OCN_VARS( msgUnit )

      RETURN
      END

#include "GAD_OPTIONS.h"
#ifdef ALLOW_PTRACERS
# include "PTRACERS_OPTIONS.h"
#endif
#ifdef ALLOW_AUTODIFF
# include "AUTODIFF_OPTIONS.h"
#endif

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C !ROUTINE: GAD_SOM_ADVECT

C !INTERFACE: ==========================================================
      SUBROUTINE GAD_SOM_ADVECT(
     I     implicitAdvection, advectionScheme, vertAdvecScheme,
     I     tracerIdentity, deltaTLev,
     I     uFld, vFld, wFld, tracer,
     U     smTr,
     O     gTracer,
     I     bi,bj, myTime,myIter,myThid)

C !DESCRIPTION:
C Calculates the tendency of a tracer due to advection.
C It uses the 2nd-Order moment advection scheme with multi-dimensional method
C  see Prather, 1986, JGR, v.91, D-6, pp.6671-6681.
C
C The tendency (output) is over-written by this routine.

C !USES: ===============================================================
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "GAD.h"
#ifdef ALLOW_AUTODIFF_TAMC
# include "tamc.h"
# ifdef ALLOW_PTRACERS
#  include "PTRACERS_SIZE.h"
# endif
#endif
#ifdef ALLOW_LAYERS
# include "LAYERS_P2SHARE.h"
#endif
#ifdef ALLOW_EXCH2
# include "W2_EXCH2_SIZE.h"
# include "W2_EXCH2_TOPOLOGY.h"
#endif /* ALLOW_EXCH2 */

C !INPUT PARAMETERS: ===================================================
C  implicitAdvection :: implicit vertical advection (later on)
C  advectionScheme   :: advection scheme to use (Horizontal plane)
C  vertAdvecScheme   :: advection scheme to use (vertical direction)
C  tracerIdentity    :: tracer identifier (required only for OBCS)
C  uFld              :: Advection velocity field, zonal component
C  vFld              :: Advection velocity field, meridional component
C  wFld              :: Advection velocity field, vertical component
C  tracer            :: tracer field
C  bi,bj             :: tile indices
C  myTime            :: current time
C  myIter            :: iteration number
C  myThid            :: thread number
      LOGICAL implicitAdvection
      INTEGER advectionScheme, vertAdvecScheme
      INTEGER tracerIdentity
      _RL deltaTLev(Nr)
      _RL uFld  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL vFld  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL wFld  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL tracer(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      INTEGER bi,bj
      _RL myTime
      INTEGER myIter
      INTEGER myThid

C !OUTPUT PARAMETERS: ==================================================
C  smTr              :: tracer 1rst & 2nd Order moments
C  gTracer           :: tendency array
      _RL smTr   (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy,nSOM)
      _RL gTracer(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)

#if ( defined GAD_ALLOW_TS_SOM_ADV || defined PTRACERS_ALLOW_DYN_STATE )
C !LOCAL VARIABLES: ====================================================
C  maskUp        :: 2-D array mask for W points
C  i,j,k         :: loop indices
C  kUp           :: index into 2 1/2D array, toggles between 1 and 2
C  kDown         :: index into 2 1/2D array, toggles between 2 and 1
C  xA,yA         :: areas of X and Y face of tracer cells
C  uTrans,vTrans :: 2-D arrays of volume transports at U,V points
C  rTrans        :: 2-D arrays of volume transports at W points
C  afx           :: 2-D array for horizontal advective flux, x direction
C  afy           :: 2-D array for horizontal advective flux, y direction
C  afr           :: 2-D array for vertical advective flux
C  fVerT         :: 2 1/2D arrays for vertical advective flux
C  calc_fluxes_X :: logical to indicate to calculate fluxes in X dir
C  calc_fluxes_Y :: logical to indicate to calculate fluxes in Y dir
C  interiorOnly  :: only update the interior of myTile, but not the edges
C  overlapOnly   :: only update the edges of myTile, but not the interior
C  npass         :: number of passes in multi-dimensional method
C  ipass         :: number of the current pass being made
C  myTile        :: variables used to determine which cube face
C  nCFace        :: owns a tile for cube grid runs using
C                :: multi-dim advection.
C [N,S,E,W]_edge :: true if N,S,E,W edge of myTile is an Edge of the cube
C  msgBuf        :: Informational/error message buffer
      _RS maskUp  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER i,j,k,km1,kUp,kDown
      _RS xA      (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RS yA      (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL uTrans  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL vTrans  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL rTrans  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL afx     (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL afy     (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL afr     (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL  smVol  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL  smTr0  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL  alp    (1-OLx:sNx+OLx,1-OLy:sNy+OLy,2)
      _RL  aln    (1-OLx:sNx+OLx,1-OLy:sNy+OLy,2)
      _RL  fp_v   (1-OLx:sNx+OLx,1-OLy:sNy+OLy,2)
      _RL  fn_v   (1-OLx:sNx+OLx,1-OLy:sNy+OLy,2)
      _RL  fp_o   (1-OLx:sNx+OLx,1-OLy:sNy+OLy,2)
      _RL  fn_o   (1-OLx:sNx+OLx,1-OLy:sNy+OLy,2)
      _RL  fp_x   (1-OLx:sNx+OLx,1-OLy:sNy+OLy,2)
      _RL  fn_x   (1-OLx:sNx+OLx,1-OLy:sNy+OLy,2)
      _RL  fp_y   (1-OLx:sNx+OLx,1-OLy:sNy+OLy,2)
      _RL  fn_y   (1-OLx:sNx+OLx,1-OLy:sNy+OLy,2)
      _RL  fp_z   (1-OLx:sNx+OLx,1-OLy:sNy+OLy,2)
      _RL  fn_z   (1-OLx:sNx+OLx,1-OLy:sNy+OLy,2)
      _RL  fp_xx  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,2)
      _RL  fn_xx  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,2)
      _RL  fp_yy  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,2)
      _RL  fn_yy  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,2)
      _RL  fp_zz  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,2)
      _RL  fn_zz  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,2)
      _RL  fp_xy  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,2)
      _RL  fn_xy  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,2)
      _RL  fp_xz  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,2)
      _RL  fn_xz  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,2)
      _RL  fp_yz  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,2)
      _RL  fn_yz  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,2)
      _RL  smCorners(OLx,OLy,4,-1:nSOM)
c     _RL  localTr
      LOGICAL calc_fluxes_X, calc_fluxes_Y
      LOGICAL interiorOnly, overlapOnly
      INTEGER limiter
      INTEGER npass, ipass
      INTEGER nCFace, n
      LOGICAL N_edge, S_edge, E_edge, W_edge
      LOGICAL noFlowAcrossSurf
      CHARACTER*(MAX_LEN_MBUF) msgBuf
#ifdef ALLOW_AUTODIFF_TAMC
      INTEGER ipasskey
#endif
#ifdef ALLOW_EXCH2
      INTEGER myTile
#endif
#ifdef ALLOW_DIAGNOSTICS
      CHARACTER*8 diagName
      CHARACTER*4 diagSufx
      LOGICAL     doDiagAdvX, doDiagAdvY, doDiagAdvR
C-    Functions:
      CHARACTER*4 GAD_DIAG_SUFX
      EXTERNAL    GAD_DIAG_SUFX
      LOGICAL  DIAGNOSTICS_IS_ON
      EXTERNAL DIAGNOSTICS_IS_ON
#endif
CEOP

#ifdef ALLOW_DIAGNOSTICS
C--   Set diagnostics flags and suffix for the current tracer
      doDiagAdvX = .FALSE.
      doDiagAdvY = .FALSE.
      doDiagAdvR = .FALSE.
      IF ( useDiagnostics ) THEN
        diagSufx = GAD_DIAG_SUFX( tracerIdentity, myThid )
        diagName = 'ADVx'//diagSufx
        doDiagAdvX = DIAGNOSTICS_IS_ON( diagName, myThid )
        diagName = 'ADVy'//diagSufx
        doDiagAdvY = DIAGNOSTICS_IS_ON( diagName, myThid )
        diagName = 'ADVr'//diagSufx
        doDiagAdvR = DIAGNOSTICS_IS_ON( diagName, myThid )
      ENDIF
#endif

C--   Set up work arrays with valid (i.e. not NaN) values
C     These inital values do not alter the numerical results. They
C     just ensure that all memory references are to valid floating
C     point numbers. This prevents spurious hardware signals due to
C     uninitialised but inert locations.
      DO j=1-OLy,sNy+OLy
       DO i=1-OLx,sNx+OLx
         afx(i,j) = 0.
         afy(i,j) = 0.
C-    xA,yA,uTrans,vTrans are set over the full domain
C      => no need for extra initialisation
c       xA(i,j)      = 0. _d 0
c       yA(i,j)      = 0. _d 0
c       uTrans(i,j)  = 0. _d 0
c       vTrans(i,j)  = 0. _d 0
C-    rTrans is set over the full domain: no need for extra initialisation
c       rTrans(i,j)  = 0. _d 0
       ENDDO
      ENDDO
      DO n=-1,nSOM
       DO k=1,4
        DO j=1,OLy
         DO i=1,OLx
          smCorners(i,j,k,n) = 0.
         ENDDO
        ENDDO
       ENDDO
      ENDDO

      IF ( implicitAdvection ) THEN
        WRITE(msgBuf,'(2A)') 'S/R GAD_SOM_ADVECT: ',
     &     'not coded for implicit-vertical Advection'
        CALL PRINT_ERROR( msgBuf, myThid )
        STOP 'ABNORMAL END: S/R GAD_SOM_ADVECT'
      ENDIF
      IF ( vertAdvecScheme .NE. advectionScheme ) THEN
        WRITE(msgBuf,'(2A)') 'S/R GAD_SOM_ADVECT: ',
     &     'not coded for different vertAdvecScheme'
        CALL PRINT_ERROR( msgBuf, myThid )
        STOP 'ABNORMAL END: S/R GAD_SOM_ADVECT'
      ENDIF

C--   Set tile-specific parameters for horizontal fluxes
      IF (useCubedSphereExchange) THEN
       npass  = 3
#ifdef ALLOW_EXCH2
       myTile = W2_myTileList(bi,bj)
       nCFace = exch2_myFace(myTile)
       N_edge = exch2_isNedge(myTile).EQ.1
       S_edge = exch2_isSedge(myTile).EQ.1
       E_edge = exch2_isEedge(myTile).EQ.1
       W_edge = exch2_isWedge(myTile).EQ.1
#else
       nCFace = bi
       N_edge = .TRUE.
       S_edge = .TRUE.
       E_edge = .TRUE.
       W_edge = .TRUE.
#endif
      ELSE
       npass  = 2
       nCFace = 0
       N_edge = .FALSE.
       S_edge = .FALSE.
       E_edge = .FALSE.
       W_edge = .FALSE.
      ENDIF

      limiter = MOD(advectionScheme, 10)

#ifdef ALLOW_AUTODIFF_TAMC
      IF ( npass.GT.maxcube ) THEN
        WRITE(msgBuf,'(A,2(I3,A))') 'S/R GAD_SOM_ADVECT: npass =',
     &     npass, ' >', maxcube, ' = maxcube, ==> check "tamc.h"'
        CALL PRINT_ERROR( msgBuf, myThid )
        STOP 'ABNORMAL END: S/R GAD_SOM_ADVECT'
      ENDIF
CADJ INIT somtape = COMMON, 1
CADJ INIT somtape_k = COMMON, Nr
CADJ INIT somtape_k_pass = COMMON, maxcube*Nr
#endif
C--   Start of k loop for horizontal fluxes
      DO k=1,Nr

C--   Get temporary terms used by tendency routines
       DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
          xA(i,j) = _dyG(i,j,bi,bj)*deepFacC(k)
     &            *drF(k)*_hFacW(i,j,k,bi,bj)
          yA(i,j) = _dxG(i,j,bi,bj)*deepFacC(k)
     &            *drF(k)*_hFacS(i,j,k,bi,bj)
        ENDDO
       ENDDO
C--   Calculate "volume transports" through tracer cell faces.
C     anelastic: scaled by rhoFacC (~ mass transport)
       DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
          uTrans(i,j) = uFld(i,j,k)*xA(i,j)*rhoFacC(k)
          vTrans(i,j) = vFld(i,j,k)*yA(i,j)*rhoFacC(k)
        ENDDO
       ENDDO

C--   grid-box volume and tracer content (zero order moment)
       DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
         smVol(i,j,k) = rA(i,j,bi,bj)*deepFac2C(k)
     &                *drF(k)*hFacC(i,j,k,bi,bj)
     &                *rhoFacC(k)
         smTr0(i,j,k) = tracer(i,j,k,bi,bj)*smVol(i,j,k)
C-    fill empty grid-box:
         smVol(i,j,k) = smVol(i,j,k)
     &                + (1. _d 0 - maskC(i,j,k,bi,bj))
        ENDDO
       ENDDO

#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE smtr(:,:,k,bi,bj,:) = somtape_k, key=k, kind=isbyte
CADJ STORE smtr0(:,:,k)        = somtape_k, key=k, kind=isbyte
CADJ STORE smVol(:,:,k)        = somtape_k, key=k, kind=isbyte
CADJ STORE smcorners           = somtape_k, key=k, kind=isbyte
#endif
C--   Multiple passes for different directions on different tiles
C--   For cube need one pass for each of red, green and blue axes.
       DO ipass=1,npass
#ifdef ALLOW_AUTODIFF_TAMC
        ipasskey = ipass + (k-1) * maxcube
#endif /* ALLOW_AUTODIFF_TAMC */

        interiorOnly = .FALSE.
        overlapOnly  = .FALSE.
        IF (useCubedSphereExchange) THEN
C-    CubedSphere : pass 3 times, with partial update of local tracer field
         IF (ipass.EQ.1) THEN
          overlapOnly   = MOD(nCFace,3).EQ.0
          interiorOnly  = MOD(nCFace,3).NE.0
          calc_fluxes_X = nCFace.EQ.6 .OR. nCFace.EQ.1 .OR. nCFace.EQ.2
          calc_fluxes_Y = nCFace.EQ.3 .OR. nCFace.EQ.4 .OR. nCFace.EQ.5
         ELSEIF (ipass.EQ.2) THEN
          overlapOnly   = MOD(nCFace,3).EQ.2
          interiorOnly  = MOD(nCFace,3).EQ.1
          calc_fluxes_X = nCFace.EQ.2 .OR. nCFace.EQ.3 .OR. nCFace.EQ.4
          calc_fluxes_Y = nCFace.EQ.5 .OR. nCFace.EQ.6 .OR. nCFace.EQ.1
         ELSE
          interiorOnly  = .TRUE.
          calc_fluxes_X = nCFace.EQ.5 .OR. nCFace.EQ.6
          calc_fluxes_Y = nCFace.EQ.2 .OR. nCFace.EQ.3
         ENDIF
        ELSE
C-    not CubedSphere
          calc_fluxes_X = MOD(ipass,2).EQ.1
          calc_fluxes_Y = .NOT.calc_fluxes_X
        ENDIF
#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE smtr(:,:,k,bi,bj,:) =somtape_k_pass,key=ipasskey,kind=isbyte
CADJ STORE smtr0(:,:,k)        =somtape_k_pass,key=ipasskey,kind=isbyte
CADJ STORE smVol(:,:,k)        =somtape_k_pass,key=ipasskey,kind=isbyte
CADJ STORE smcorners           =somtape_k_pass,key=ipasskey,kind=isbyte
#endif

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C--   X direction
C-     Do not compute fluxes if
C       a) needed in overlap only
C   and b) the overlap of myTile are not cube-face Edges
        IF ( calc_fluxes_X .AND.
     &      (.NOT.overlapOnly .OR. N_edge .OR. S_edge)
     &     ) THEN

C-     Internal exchange for calculations in X
          IF ( useCubedSphereExchange .AND. .NOT.interiorOnly ) THEN
           CALL GAD_SOM_PREP_CS_CORNER(
     U                     smVol, smTr0, smTr, smCorners,
     I                     .TRUE., overlapOnly, interiorOnly,
     I                     N_edge, S_edge, E_edge, W_edge,
     I                     ipass, k, Nr, bi, bj, myThid )
          ENDIF

C-     Solve advection in X and update moments
          IF ( advectionScheme.EQ.ENUM_SOM_PRATHER
     &       .OR. advectionScheme.EQ.ENUM_SOM_LIMITER ) THEN
           CALL GAD_SOM_ADV_X(
     I                     bi,bj,k, limiter,
     I                     overlapOnly, interiorOnly,
     I                     N_edge, S_edge, E_edge, W_edge,
     I                     deltaTLev(k), uTrans,
     I                     maskInC(1-OLx,1-OLy,bi,bj),
     U                     smVol(1-OLx,1-OLy,k),
     U                     smTr0(1-OLx,1-OLy,k),
     U                     smTr(1-OLx,1-OLy,k,bi,bj,1),
     U                     smTr(1-OLx,1-OLy,k,bi,bj,2),
     U                     smTr(1-OLx,1-OLy,k,bi,bj,3),
     U                     smTr(1-OLx,1-OLy,k,bi,bj,4),
     U                     smTr(1-OLx,1-OLy,k,bi,bj,5),
     U                     smTr(1-OLx,1-OLy,k,bi,bj,6),
     U                     smTr(1-OLx,1-OLy,k,bi,bj,7),
     U                     smTr(1-OLx,1-OLy,k,bi,bj,8),
     U                     smTr(1-OLx,1-OLy,k,bi,bj,9),
     O                     afx, myThid )
          ELSE
           STOP 'GAD_SOM_ADVECT: adv. scheme incompatibale with SOM'
          ENDIF

C--   End of X direction
        ENDIF

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C--   Y direction
C-     Do not compute fluxes if
C       a) needed in overlap only
C   and b) the overlap of myTile are not cube-face edges
        IF ( calc_fluxes_Y .AND.
     &      (.NOT.overlapOnly .OR. E_edge .OR. W_edge)
     &     ) THEN

C-     Internal exchange for calculations in Y
          IF ( useCubedSphereExchange .AND. .NOT.interiorOnly ) THEN
           CALL GAD_SOM_PREP_CS_CORNER(
     U                     smVol, smTr0, smTr, smCorners,
     I                     .FALSE., overlapOnly, interiorOnly,
     I                     N_edge, S_edge, E_edge, W_edge,
     I                     iPass, k, Nr, bi, bj, myThid )
          ENDIF

C-     Solve advection in Y and update moments
          IF ( advectionScheme.EQ.ENUM_SOM_PRATHER
     &       .OR. advectionScheme.EQ.ENUM_SOM_LIMITER ) THEN
           CALL GAD_SOM_ADV_Y(
     I                     bi,bj,k, limiter,
     I                     overlapOnly, interiorOnly,
     I                     N_edge, S_edge, E_edge, W_edge,
     I                     deltaTLev(k), vTrans,
     I                     maskInC(1-OLx,1-OLy,bi,bj),
     U                     smVol(1-OLx,1-OLy,k),
     U                     smTr0(1-OLx,1-OLy,k),
     U                     smTr(1-OLx,1-OLy,k,bi,bj,1),
     U                     smTr(1-OLx,1-OLy,k,bi,bj,2),
     U                     smTr(1-OLx,1-OLy,k,bi,bj,3),
     U                     smTr(1-OLx,1-OLy,k,bi,bj,4),
     U                     smTr(1-OLx,1-OLy,k,bi,bj,5),
     U                     smTr(1-OLx,1-OLy,k,bi,bj,6),
     U                     smTr(1-OLx,1-OLy,k,bi,bj,7),
     U                     smTr(1-OLx,1-OLy,k,bi,bj,8),
     U                     smTr(1-OLx,1-OLy,k,bi,bj,9),
     O                     afy, myThid )
          ELSE
           STOP 'GAD_SOM_ADVECT: adv. scheme incompatibale with SOM'
          ENDIF

C--   End of Y direction
        ENDIF
C--   End of ipass loop
       ENDDO

       IF ( implicitAdvection ) THEN
C-    explicit advection is done ; store tendency in gTracer:
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
C--  without rescaling of tendencies:
c         localTr = smTr0(i,j,k)/smVol(i,j,k)
c         gTracer(i,j,k) = ( localTr - tracer(i,j,k,bi,bj) )
c    &                   / deltaTLev(k)
C--  consistent with rescaling of tendencies (in FREESURF_RESCALE_G):
          gTracer(i,j,k) =
     &          ( smTr0(i,j,k) - tracer(i,j,k,bi,bj)*smVol(i,j,k) )
     &            *recip_rA(i,j,bi,bj)*recip_deepFac2C(k)
     &            *recip_drF(k)*_recip_hFacC(i,j,k,bi,bj)
     &            *recip_rhoFacC(k)
     &            /deltaTLev(k)
         ENDDO
        ENDDO
       ENDIF

#ifdef ALLOW_DIAGNOSTICS
       IF ( doDiagAdvX ) THEN
         diagName = 'ADVx'//diagSufx
         CALL DIAGNOSTICS_FILL(afx,diagName, k,1, 2,bi,bj, myThid )
       ENDIF
       IF ( doDiagAdvY ) THEN
         diagName = 'ADVy'//diagSufx
         CALL DIAGNOSTICS_FILL(afy,diagName, k,1, 2,bi,bj, myThid )
       ENDIF
#ifdef ALLOW_LAYERS
       IF ( layers_useThermo ) THEN
         CALL LAYERS_FILL(afx,tracerIdentity,'AFX',k,1,2,bi,bj,myThid)
         CALL LAYERS_FILL(afy,tracerIdentity,'AFY',k,1,2,bi,bj,myThid)
       ENDIF
#endif /* ALLOW_LAYERS */
#endif

#ifdef ALLOW_DEBUG
       IF ( debugLevel .GE. debLevC
     &   .AND. tracerIdentity.EQ.GAD_TEMPERATURE
     &   .AND. k.LE.3 .AND. myIter.EQ.1+nIter0
     &   .AND. nPx.EQ.1 .AND. nPy.EQ.1
     &   .AND. useCubedSphereExchange ) THEN
        CALL DEBUG_CS_CORNER_UV( ' afx,afy from GAD_SOM_ADVECT',
     &             afx,afy, k, standardMessageUnit,bi,bj,myThid )
       ENDIF
#endif /* ALLOW_DEBUG */

C--   End of K loop for horizontal fluxes
      ENDDO

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      noFlowAcrossSurf = rigidLid .OR. nonlinFreeSurf.GE.1
     &                            .OR. select_rStar.NE.0

      IF ( .NOT.implicitAdvection ) THEN
C--   Apply limiter (if any):
#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE smtr(:,:,:,bi,bj,:) = somtape, key=1, kind=isbyte
CADJ STORE smtr0               = somtape, key=1, kind=isbyte
#endif
       CALL GAD_SOM_LIM_R( bi,bj, limiter,
     U                     smVol,
     U                     smTr0,
     U                     smTr(1-OLx,1-OLy,1,bi,bj,1),
     U                     smTr(1-OLx,1-OLy,1,bi,bj,2),
     U                     smTr(1-OLx,1-OLy,1,bi,bj,3),
     U                     smTr(1-OLx,1-OLy,1,bi,bj,4),
     U                     smTr(1-OLx,1-OLy,1,bi,bj,5),
     U                     smTr(1-OLx,1-OLy,1,bi,bj,6),
     U                     smTr(1-OLx,1-OLy,1,bi,bj,7),
     U                     smTr(1-OLx,1-OLy,1,bi,bj,8),
     U                     smTr(1-OLx,1-OLy,1,bi,bj,9),
     I                     myThid )

C--   Start of k loop for vertical flux
       DO k=Nr,1,-1
#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE smtr(:,:,k,bi,bj,:) = somtape_k, key=k, kind=isbyte
CADJ STORE smtr0(:,:,k)        = somtape_k, key=k, kind=isbyte
CADJ STORE smVol(:,:,k)        = somtape_k, key=k, kind=isbyte
CADJ STORE alp, aln   = somtape_k, key=k, kind=isbyte
CADJ STORE fp_v,fn_v,fp_o,fn_o,fp_x,fn_x,fp_y,fn_y,fp_z,fn_z
CADJ &                         = somtape_k, key=k, kind=isbyte
CADJ STORE fp_xx, fn_xx, fp_yy, fn_yy, fp_zz, fn_zz
CADJ &                         = somtape_k, key=k, kind=isbyte
CADJ STORE fp_xy, fn_xy, fp_xz, fn_xz, fp_yz, fn_yz
CADJ &                         = somtape_k, key=k, kind=isbyte
#endif
C--   kUp    Cycles through 1,2 to point to w-layer above
C--   kDown  Cycles through 2,1 to point to w-layer below
        kUp  = 1+MOD(Nr-k,2)
        kDown= 1+MOD(Nr-k+1,2)
        IF (k.EQ.Nr) THEN
C--   Set advective fluxes at the very bottom:
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           alp  (i,j,kDown) = 0. _d 0
           aln  (i,j,kDown) = 0. _d 0
           fp_v (i,j,kDown) = 0. _d 0
           fn_v (i,j,kDown) = 0. _d 0
           fp_o (i,j,kDown) = 0. _d 0
           fn_o (i,j,kDown) = 0. _d 0
           fp_x (i,j,kDown) = 0. _d 0
           fn_x (i,j,kDown) = 0. _d 0
           fp_y (i,j,kDown) = 0. _d 0
           fn_y (i,j,kDown) = 0. _d 0
           fp_z (i,j,kDown) = 0. _d 0
           fn_z (i,j,kDown) = 0. _d 0
           fp_xx(i,j,kDown) = 0. _d 0
           fn_xx(i,j,kDown) = 0. _d 0
           fp_yy(i,j,kDown) = 0. _d 0
           fn_yy(i,j,kDown) = 0. _d 0
           fp_zz(i,j,kDown) = 0. _d 0
           fn_zz(i,j,kDown) = 0. _d 0
           fp_xy(i,j,kDown) = 0. _d 0
           fn_xy(i,j,kDown) = 0. _d 0
           fp_xz(i,j,kDown) = 0. _d 0
           fn_xz(i,j,kDown) = 0. _d 0
           fp_yz(i,j,kDown) = 0. _d 0
           fn_yz(i,j,kDown) = 0. _d 0
          ENDDO
         ENDDO
        ENDIF

C-- Compute Vertical transport
#ifdef ALLOW_AIM
C- a hack to prevent Water-Vapor vert.transport into the stratospheric level Nr
c       IF ( k.EQ.1 .OR.
c    &     (useAIM .AND. tracerIdentity.EQ.GAD_SALINITY .AND. k.EQ.Nr)
c    &              ) THEN
#else
c       IF ( k.EQ.1 ) THEN
#endif
        IF ( noFlowAcrossSurf .AND. k.EQ.1 ) THEN
C- Surface interface :
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           rTrans(i,j) = 0.
           maskUp(i,j) = 0.
          ENDDO
         ENDDO

        ELSEIF ( noFlowAcrossSurf ) THEN
C- Interior interface :
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           rTrans(i,j) = wFld(i,j,k)*rA(i,j,bi,bj)
     &                 *deepFac2F(k)*rhoFacF(k)
     &                 *maskC(i,j,k-1,bi,bj)
           maskUp(i,j) = 1.
          ENDDO
         ENDDO

        ELSE
C- Linear Free-Surface: do not mask rTrans :
         km1= MAX(k-1,1)
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           rTrans(i,j) = wFld(i,j,k)*rA(i,j,bi,bj)
     &                 *deepFac2F(k)*rhoFacF(k)
           maskUp(i,j) = maskC(i,j,km1,bi,bj)*maskC(i,j,k,bi,bj)
          ENDDO
         ENDDO

C- end Surface/Interior if bloc
        ENDIF

C-    Compute vertical advective flux in the interior:
        IF ( vertAdvecScheme.EQ.ENUM_SOM_PRATHER
     &     .OR. vertAdvecScheme.EQ.ENUM_SOM_LIMITER ) THEN
           CALL GAD_SOM_ADV_R(
     I                     bi,bj,k, kUp, kDown,
     I                     deltaTLev(k), rTrans, maskUp,
     I                     maskInC(1-OLx,1-OLy,bi,bj),
     U                     smVol,
     U                     smTr0,
     U                     smTr(1-OLx,1-OLy,1,bi,bj,1),
     U                     smTr(1-OLx,1-OLy,1,bi,bj,2),
     U                     smTr(1-OLx,1-OLy,1,bi,bj,3),
     U                     smTr(1-OLx,1-OLy,1,bi,bj,4),
     U                     smTr(1-OLx,1-OLy,1,bi,bj,5),
     U                     smTr(1-OLx,1-OLy,1,bi,bj,6),
     U                     smTr(1-OLx,1-OLy,1,bi,bj,7),
     U                     smTr(1-OLx,1-OLy,1,bi,bj,8),
     U                     smTr(1-OLx,1-OLy,1,bi,bj,9),
     U                     alp,   aln,   fp_v,  fn_v,  fp_o,  fn_o,
     U                     fp_x,  fn_x,  fp_y,  fn_y,  fp_z,  fn_z,
     U                     fp_xx, fn_xx, fp_yy, fn_yy, fp_zz, fn_zz,
     U                     fp_xy, fn_xy, fp_xz, fn_xz, fp_yz, fn_yz,
     O                     afr, myThid )
        ELSE
           STOP 'GAD_SOM_ADVECT: adv. scheme incompatibale with SOM'
        ENDIF

C--   Compute new tracer value and store tracer tendency
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
C--  without rescaling of tendencies:
c         localTr = smTr0(i,j,k)/smVol(i,j,k)
c         gTracer(i,j,k) = ( localTr - tracer(i,j,k,bi,bj) )
c    &                   / deltaTLev(k)
C--  Non-Lin Free-Surf: consistent with rescaling of tendencies
C     (in FREESURF_RESCALE_G) and RealFreshFlux/addMass.
C    Also valid for linear Free-Surf (r & r* coords) except that surf tracer
C    loss/gain is computed (in GAD_SOM_ADV_R) from partially updated tracer
C     (instead of from Tr^n as fresh-water dilution effect) resulting in
C    inaccurate linFSConserveTr and "surfExpan_" monitor.
          gTracer(i,j,k) =
     &          ( smTr0(i,j,k) - tracer(i,j,k,bi,bj)*smVol(i,j,k) )
     &            *recip_rA(i,j,bi,bj)*recip_deepFac2C(k)
     &            *recip_drF(k)*_recip_hFacC(i,j,k,bi,bj)
     &            *recip_rhoFacC(k)
     &            /deltaTLev(k)
         ENDDO
        ENDDO

#ifdef ALLOW_DIAGNOSTICS
        IF ( doDiagAdvR ) THEN
         diagName = 'ADVr'//diagSufx
         CALL DIAGNOSTICS_FILL( afr,
     &                          diagName, k,1, 2,bi,bj, myThid )
        ENDIF
#ifdef ALLOW_LAYERS
        IF ( layers_useThermo ) THEN
          CALL LAYERS_FILL(afr,tracerIdentity,'AFR',
     &                     k,1,2,bi,bj,myThid)
        ENDIF
#endif /* ALLOW_LAYERS */
#endif

C--   End of k loop for vertical flux
       ENDDO
C--   end of if not.implicitAdvection block
      ENDIF
#endif /* GAD_ALLOW_TS_SOM_ADV or PTRACERS_ALLOW_DYN_STATE */

      RETURN
      END

#include "PACKAGES_CONFIG.h"
#include "CPP_OPTIONS.h"

CBOP
C     !ROUTINE: TRACERS_CORRECTION_STEP
C     !INTERFACE:
      SUBROUTINE TRACERS_CORRECTION_STEP( myTime, myIter, myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE TRACERS_CORRECTION_STEP
C     *==========================================================*
C     |1rst Part : Update T,S.
C     |part2: Adjustments & Diagnostics
C     |   o Filter  T,S (Shapiro Filter, Zonal_Filter)
C     |   o Convective Adjustment
C     |   o Diagmnostic of state variables (Time average)
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     == Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "DYNVARS.h"
#ifdef ALLOW_GENERIC_ADVDIFF
# include "GAD.h"
#endif
#ifdef ALLOW_TAPENADE
# ifdef ALLOW_PTRACERS
#  include "PTRACERS_SIZE.h"
#  include "PTRACERS_FIELDS.h"
# endif
#endif /* ALLOW_TAPENADE */

C     !INPUT/OUTPUT PARAMETERS:
C     myTime :: Current time in simulation
C     myIter :: Current iteration number in simulation
C     myThid :: my Thread Id number
      _RL myTime
      INTEGER myIter
      INTEGER myThid

#ifdef ALLOW_GENERIC_ADVDIFF
C     !LOCAL VARIABLES:
      INTEGER bi, bj
#ifdef ALLOW_OPPS
      INTEGER iMin,iMax
      INTEGER jMin,jMax
#endif
CEOP

#ifdef ALLOW_NONHYDROSTATIC
      IF ( implicitIntGravWave ) THEN
       DO bj=myByLo(myThid),myByHi(myThid)
        DO bi=myBxLo(myThid),myBxHi(myThid)
          CALL TRACERS_IIGW_CORRECTION(bi,bj, myTime,myIter,myThid)
        ENDDO
       ENDDO
      ENDIF
#endif /* ALLOW_NONHYDROSTATIC */

C--- 2nd Part : Adjustment.
C
C       Static stability is calculated and the tracers are
C       convective adjusted where statically unstable.

C--   Filter (and exchange)
#ifdef ALLOW_SHAP_FILT
      IF (useSHAP_FILT) THEN
        CALL TIMER_START('SHAP_FILT_TS       [TRC_CORR_STEP]',myThid)
        CALL SHAP_FILT_APPLY_TS( theta,salt, myTime, myIter, myThid )
        CALL TIMER_STOP ('SHAP_FILT_TS       [TRC_CORR_STEP]',myThid)
      ENDIF
#endif
#ifdef ALLOW_ZONAL_FILT
      IF (useZONAL_FILT) THEN
        CALL TIMER_START('ZONAL_FILT_TS      [TRC_CORR_STEP]',myThid)
        CALL ZONAL_FILT_APPLY_TS( theta, salt, myThid )
        CALL TIMER_STOP ('ZONAL_FILT_TS      [TRC_CORR_STEP]',myThid)
# ifdef ALLOW_PTRACERS
C-      apply to passive tracer fields
        IF (usePTRACERS) THEN
          CALL PTRACERS_ZONAL_FILT_APPLY( myThid )
        ENDIF
# endif
      ENDIF
#endif /* ALLOW_ZONAL_FILT */
C -- Fill negative tracer values (for now, only if Fizhi is running)
#ifdef ALLOW_FIZHI
      IF (useFIZHI .and. saltAdvScheme.eq.2) THEN
        CALL TIMER_START('SALT_FILL       [TRC_CORR_STEP]',myThid)
        CALL SALT_FILL( uVel,vVel,salt,1,myTime,myIter,myThid )
        CALL TIMER_STOP ('SALT_FILL       [TRC_CORR_STEP]',myThid)
      ENDIF
#endif

      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)

C--     Convectively adjust new fields to be statically stable
#ifdef ALLOW_OPPS
        IF ( useOPPS ) THEN
         iMin = 1
         iMax = sNx
         jMin = 1
         jMax = sNy
         CALL OPPS_INTERFACE(
     I        bi, bj, iMin, iMax, jMin, jMax,
     I        myTime, myIter, myThid )
        ENDIF
#endif /* ALLOW_OPPS */
#ifdef INCLUDE_CONVECT_CALL
        IF ( .NOT. useOPPS .AND. cAdjFreq .NE. 0. ) THEN
         CALL CONVECTIVE_ADJUSTMENT(
     I        bi, bj, myTime, myIter, myThid )
        ENDIF
#endif /* INCLUDE_CONVECT_CALL */

#ifdef ALLOW_MATRIX
        IF (useMATRIX)
     &  CALL MATRIX_STORE_TENDENCY_IMP( bi, bj, myTime, myIter, myThid )
#endif

C--    End of 2nd bi,bj loop
       ENDDO
      ENDDO

#endif /* ALLOW_GENERIC_ADVDIFF */

      RETURN
      END

#include "GAD_OPTIONS.h"

CBOP
C     !ROUTINE: GAD_EXCH_SOM
C     !INTERFACE:
      SUBROUTINE GAD_EXCH_SOM(
     U                         smTr,
     I                         myNz, myThid )


C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE GAD_EXCH_SOM
C     | o Apply exchanges to update overlaps of 1srt & 2nd.Order
C     |   Moments array, corresponding to 1 tracer
C     *==========================================================*
C     \ev
C     !USES:
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "GAD.h"

C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
C     smTr   :: tracer 1rst & 2nd Order moments
C     myNz   ::  3rd dimension of array to exchange
C     myThid ::  my Thread Id number
      INTEGER myNz
      _RL     smTr(1-OLx:sNx+OLx,1-OLy:sNy+OLy,myNz,nSx,nSy,nSOM)
      INTEGER myThid
CEOP

C     !LOCAL VARIABLES:
C     === Local variables ===

C--   Apply exchanges to 1rst.O.Moments:
C-    Sx,Sy :
      CALL EXCH_UV_AGRID_3D_RL(
     U                 smTr(1-OLx,1-OLy,1,1,1,1),
     U                 smTr(1-OLx,1-OLy,1,1,1,2),
     I                 .TRUE., myNz, myThid )
C-    Sz :
      CALL EXCH_3D_RL(
     U                 smTr(1-OLx,1-OLy,1,1,1,3),
     I                 myNz, myThid )

C--   Apply exchanges to 2nd.O.Moments:
C-    Sxx,Syy :
      CALL EXCH_UV_AGRID_3D_RL(
     U                 smTr(1-OLx,1-OLy,1,1,1,4),
     U                 smTr(1-OLx,1-OLy,1,1,1,5),
     I                 .FALSE., myNz, myThid )
C-    Szz :
      CALL EXCH_3D_RL(
     U                 smTr(1-OLx,1-OLy,1,1,1,6),
     I                 myNz, myThid )
C-    Sxy :
      CALL EXCH_SM_3D_RL(
     U                 smTr(1-OLx,1-OLy,1,1,1,7),
     I                 .TRUE., myNz, myThid )
C-    Sxz,Syz :
      CALL EXCH_UV_AGRID_3D_RL(
     U                 smTr(1-OLx,1-OLy,1,1,1,8),
     U                 smTr(1-OLx,1-OLy,1,1,1,9),
     I                 .TRUE., myNz, myThid )

      RETURN
      END

#include "AIM_OPTIONS.h"

CBOP
C     !ROUTINE: AIM_INITIALISE
C     !INTERFACE:
      SUBROUTINE AIM_INITIALISE( myThid )

C     !DESCRIPTION: \bv
C     *==================================================================*
C     | S/R AIM_INITIALISE
C     *==================================================================*
C     | Initialisation of AIM atmospheric physics package :
C     | 1) call iniphys (=> set parameters to default value)
C     | 2) read AIM parameters
C     *==================================================================*
C     \ev
C     !USES:
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "SURFACE.h"
#include "AIM_PARAMS.h"
#include "AIM_FFIELDS.h"
c #include "AIM_GRID.h"
c #include "AIM_DIAGS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     myThid :: my Thread Id. number
      INTEGER myThid

#ifdef ALLOW_AIM
C     !LOCAL VARIABLES:
C     == Local variables ==
C     HSG     :: Cell face in vertical
C     pGround :: Lower boundary pressure
C     bi,bj   :: Tile indices
C     i, j, k :: Loop counters
      _RL HSG(0:Nr)
      _RL pGround, tmpPgrnd, tmpVar
      INTEGER bi, bj
      INTEGER i, j, k
      INTEGER Katm
CEOP

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      _BEGIN_MASTER(myThid )

C--  Set default value for atmos. physics parameters:
      pGround = atm_Po
      DO k=1,Nr
       Katm = _KD2KA( k )
       HSG(Katm) = rF(k)/pGround
      ENDDO
       k=Nr+1
       Katm = _KD2KA( k )
       HSG(Katm) = rF(k)/pGround

      _END_MASTER( myThid )

C--   set default value for all atmos. physics parameter:
      CALL INPHYS( HSG, myThid )

C--   Read AIM parameters (from file data.aimphys):
      CALL AIM_READPARMS( myThid )

C--   set energy fractions in LW bands as a function of temperature:
C     initialize common block RADFIX (originally called from FORDATE in SPEEDY)
      _BEGIN_MASTER(myThid )
       CALL RADSET( myThid )
      _END_MASTER( myThid )

C--   Set truncSurfP : used to correct for truncation (because of hFacMin)
C      of surface reference pressure Ro_surf that affects Surf.Temp.
      CALL INI_P_GROUND(1, topoZ, truncSurfP, myThid )
      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
        DO j=1,sNy
         DO i=1,sNx
          tmpPgrnd = truncSurfP(i,j,bi,bj)
          tmpVar   = Ro_surf(i,j,bi,bj)
          tmpPgrnd = MIN( tmpPgrnd, atm_Po )
          truncSurfP(i,j,bi,bj) = ( tmpVar/tmpPgrnd )**atm_kappa
         ENDDO
        ENDDO
        IF (aim_useMMsurfFc .AND. aim_surfPotTemp) THEN
         DO j=1,sNy
          DO i=1,sNx
           tmpVar   = Ro_surf(i,j,bi,bj)
           truncSurfP(i,j,bi,bj) = ( tmpVar/atm_Po )**atm_kappa
          ENDDO
         ENDDO
        ENDIF
       ENDDO
      ENDDO

C--   Initialise Land Fraction (in AIM_FFIELDS.h):
      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
        DO j=1-Oly,sNy+Oly
         DO i=1-Olx,sNx+Olx
          aim_landFr   (i,j,bi,bj) = 0.
         ENDDO
        ENDDO
       ENDDO
      ENDDO

      IF ( aim_LandFile .NE. ' '  ) THEN
         _BARRIER
         CALL READ_REC_XY_RS(aim_LandFile,aim_landFr,1,nIter0,myThid)
C-    better to fill land fraction overlap (likely to be needed for sea-ice)
         CALL EXCH_XY_RS( aim_landFr, myThid )
      ENDIF

#ifdef ALLOW_MNC
      IF (useMNC) THEN
        CALL AIM_MNC_INIT( myThid )
      ENDIF
#endif /*  ALLOW_MNC  */

#ifdef ALLOW_DIAGNOSTICS
      IF ( useDiagnostics ) THEN
        CALL AIM_DIAGNOSTICS_INIT( myThid )
      ENDIF
#endif

C--   Everyone else must wait for the parameters to be set
      _BARRIER

#endif /* ALLOW_AIM */

      RETURN
      END

#include "PROFILES_OPTIONS.h"
#ifdef ALLOW_CTRL
# include "CTRL_OPTIONS.h"
#endif

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C !ROUTINE: PROFILES_INLOOP

C !INTERFACE:
      SUBROUTINE PROFILES_INLOOP( myTime, myThid )

C     !DESCRIPTION:
C     Computes and writes model counterparts
C     for netcdf profiles data
C     Started: Gael Forget 15-March-2006

C     !USES:
      IMPLICIT NONE
C     == Global variables ===
#include "EEPARAMS.h"
#include "SIZE.h"
#include "GRID.h"
#include "DYNVARS.h"
#include "PARAMS.h"
#ifdef ALLOW_CAL
# include "cal.h"
#endif
#ifdef ALLOW_CTRL
# include "OPTIMCYCLE.h"
#endif
#ifdef ALLOW_PROFILES
# include "PROFILES_SIZE.h"
# include "profiles.h"
# include "netcdf.inc"
#endif

C     !INPUT PARAMETERS:
C     myTime: time counter for this thread
C     myThid: my thread ID number
      _RL     myTime
      INTEGER myThid
C     !OUTPUT PARAMETERS:
CEOP

C     !LOCAL VARIABLES:
#ifdef ALLOW_PROFILES
      INTEGER kLev, iq
      INTEGER bi,bj,prof_num, num_file, num_var
      _RL prof_traj1D(NLEVELMAX),prof_mask1D(NLEVELMAX)
      INTEGER prof_i1D(NUM_INTERP_POINTS),prof_j1D(NUM_INTERP_POINTS)
      _RL prof_w1D(NUM_INTERP_POINTS)
# ifndef ALLOW_CTRL
      INTEGER optimcycle
# endif
# ifndef ALLOW_ECCO
      INTEGER i,j,k
# endif

# ifndef ALLOW_CTRL
      optimcycle = 0
# endif

# ifndef ALLOW_ECCO
      DO bj = myByLo(myThid), myByHi(myThid)
        DO bi = myBxLo(myThid), myBxHi(myThid)
          DO k = 1, Nr
            DO j = 1, sNy
              DO i =  1, sNx
                m_UE(i,j,k,bi,bj)=0. _d 0
                m_VN(i,j,k,bi,bj)=0. _d 0
              ENDDO
            ENDDO
          ENDDO
        ENDDO
      ENDDO

      CALL ROTATE_UV2EN_RL(
     U     uVel, vVel, m_UE, m_VN,
     I     .TRUE., .TRUE., .FALSE., Nr, myThid )
# endif /* not ALLOW_ECCO */

      _BEGIN_MASTER( myThid )

      DO bj = 1, nSy
        DO bi = 1, nSx
          DO num_file = 1, NFILESPROFMAX
            DO prof_num = 1, NOBSGLOB
              IF (prof_num.LE.ProfNo(num_file,bi,bj)) THEN
                IF (
     &           (prof_time(num_file,prof_num,bi,bj).GE.myTime) .AND.
     &           (prof_time(num_file,prof_num,bi,bj).LT.
     &            (myTime+deltaTClock)) ) THEN
                  DO iq = 1, NUM_INTERP_POINTS
                    prof_i1D(iq) =
     &               prof_interp_i(num_file,prof_num,iq,bi,bj)
                    prof_j1D(iq) =
     &               prof_interp_j(num_file,prof_num,iq,bi,bj)
                    prof_w1D(iq) =
     &               prof_interp_weights(num_file,prof_num,iq,bi,bj)

                  ENDDO

                  DO num_var = 1, NVARMAX
                    DO kLev = 1, NLEVELMAX
                      prof_traj1D(kLev) = 0
                      prof_mask1D(kLev) = 0
                    ENDDO

                    IF (vec_quantities(num_file,num_var,bi,bj)) THEN
                      CALL PROFILES_INTERP( prof_traj1D,
     &                     prof_i1D,prof_j1D,prof_w1D,
     &                     prof_namesmod(num_file,num_var),
     &                     prof_itracer(num_file,num_var),
     &                     num_file,myTime,bi,bj,myThid )

                      DO kLev = 1, NLEVELMAX
                        prof_traj1D(kLev) = prof_traj1D(kLev)*
     &                   prof_facmod(num_file,num_var)
                      ENDDO

                      CALL ACTIVE_WRITE_PROFILE( num_file,
     &                     ProfDepthNo(num_file,bi,bj),prof_traj1D,
     &                     num_var,prof_num,optimcycle,bi,bj,myThid,
     &                     profiles_dummy(num_file,num_var,bi,bj) )

                    ENDIF !IF (vec_quantities(num_file,num_var,bi,bj)

                  ENDDO !DO num_var

                ENDIF !IF ((prof_time
              ENDIF !IF (ProfNo(num_file,bi,bj).NE.0)
            ENDDO !DO prof_num
          ENDDO !DO num_file
        ENDDO !DO bi
      ENDDO !DO bj

      _END_MASTER( myThid )

#endif /* ALLOW_PROFILES */

      RETURN
      END

#include "ZONAL_FILT_OPTIONS.h"

C     SUBROUTINE RFFTB (N,R,WSAVE)
C     DIMENSION       R(1)       ,WSAVE(1)
C     IF (N .EQ. 1) RETURN
C     CALL RFFTB1 (N,R,WSAVE,WSAVE(N+1),WSAVE(2*N+1))
C     RETURN
C     END
      SUBROUTINE RADB2 (IDO,L1,CC,CH,WA1)

      IMPLICIT REAL*8 (A-H,O-Z) 
      IMPLICIT INTEGER (I-N)

#ifdef ALLOW_ZONAL_FILT

      DIMENSION       CC(IDO,2,L1)           ,CH(IDO,L1,2)           ,
     1                WA1(*)
      DO 101 K=1,L1
         CH(1,K,1) = CC(1,1,K)+CC(IDO,2,K)
         CH(1,K,2) = CC(1,1,K)-CC(IDO,2,K)
  101 CONTINUE
      IF (IDO-2) 107,105,102
  102 IDP2 = IDO+2
      DO 104 K=1,L1
         DO 103 I=3,IDO,2
            IC = IDP2-I
            CH(I-1,K,1) = CC(I-1,1,K)+CC(IC-1,2,K)
            TR2 = CC(I-1,1,K)-CC(IC-1,2,K)
            CH(I,K,1) = CC(I,1,K)-CC(IC,2,K)
            TI2 = CC(I,1,K)+CC(IC,2,K)
            CH(I-1,K,2) = WA1(I-2)*TR2-WA1(I-1)*TI2
            CH(I,K,2) = WA1(I-2)*TI2+WA1(I-1)*TR2
  103    CONTINUE
  104 CONTINUE
      IF (MOD(IDO,2) .EQ. 1) RETURN
  105 DO 106 K=1,L1
         CH(IDO,K,1) = CC(IDO,1,K)+CC(IDO,1,K)
         CH(IDO,K,2) = -(CC(1,2,K)+CC(1,2,K))
  106 CONTINUE
  107 RETURN
      END
      SUBROUTINE RADB3 (IDO,L1,CC,CH,WA1,WA2)

      IMPLICIT REAL*8 (A-H,O-Z) 
      IMPLICIT INTEGER (I-N)

      DIMENSION       CC(IDO,3,L1)           ,CH(IDO,L1,3)           ,
     1                WA1(*)     ,WA2(*)
      DATA TAUR,TAUI /-.5D0,.866025403784439D0/
      DO 101 K=1,L1
         TR2 = CC(IDO,2,K)+CC(IDO,2,K)
         CR2 = CC(1,1,K)+TAUR*TR2
         CH(1,K,1) = CC(1,1,K)+TR2
         CI3 = TAUI*(CC(1,3,K)+CC(1,3,K))
         CH(1,K,2) = CR2-CI3
         CH(1,K,3) = CR2+CI3
  101 CONTINUE
      IF (IDO .EQ. 1) RETURN
      IDP2 = IDO+2
      DO 103 K=1,L1
         DO 102 I=3,IDO,2
            IC = IDP2-I
            TR2 = CC(I-1,3,K)+CC(IC-1,2,K)
            CR2 = CC(I-1,1,K)+TAUR*TR2
            CH(I-1,K,1) = CC(I-1,1,K)+TR2
            TI2 = CC(I,3,K)-CC(IC,2,K)
            CI2 = CC(I,1,K)+TAUR*TI2
            CH(I,K,1) = CC(I,1,K)+TI2
            CR3 = TAUI*(CC(I-1,3,K)-CC(IC-1,2,K))
            CI3 = TAUI*(CC(I,3,K)+CC(IC,2,K))
            DR2 = CR2-CI3
            DR3 = CR2+CI3
            DI2 = CI2+CR3
            DI3 = CI2-CR3
            CH(I-1,K,2) = WA1(I-2)*DR2-WA1(I-1)*DI2
            CH(I,K,2) = WA1(I-2)*DI2+WA1(I-1)*DR2
            CH(I-1,K,3) = WA2(I-2)*DR3-WA2(I-1)*DI3
            CH(I,K,3) = WA2(I-2)*DI3+WA2(I-1)*DR3
  102    CONTINUE
  103 CONTINUE
      RETURN
      END
      SUBROUTINE RADB4 (IDO,L1,CC,CH,WA1,WA2,WA3)

      IMPLICIT REAL*8 (A-H,O-Z) 
      IMPLICIT INTEGER (I-N)

      DIMENSION       CC(IDO,4,L1)           ,CH(IDO,L1,4)           ,
     1                WA1(*)     ,WA2(*)     ,WA3(*)
      DATA SQRT2 /1.414213562373095D0/
      DO 101 K=1,L1
         TR1 = CC(1,1,K)-CC(IDO,4,K)
         TR2 = CC(1,1,K)+CC(IDO,4,K)
         TR3 = CC(IDO,2,K)+CC(IDO,2,K)
         TR4 = CC(1,3,K)+CC(1,3,K)
         CH(1,K,1) = TR2+TR3
         CH(1,K,2) = TR1-TR4
         CH(1,K,3) = TR2-TR3
         CH(1,K,4) = TR1+TR4
  101 CONTINUE
      IF (IDO-2) 107,105,102
  102 IDP2 = IDO+2
      DO 104 K=1,L1
         DO 103 I=3,IDO,2
            IC = IDP2-I
            TI1 = CC(I,1,K)+CC(IC,4,K)
            TI2 = CC(I,1,K)-CC(IC,4,K)
            TI3 = CC(I,3,K)-CC(IC,2,K)
            TR4 = CC(I,3,K)+CC(IC,2,K)
            TR1 = CC(I-1,1,K)-CC(IC-1,4,K)
            TR2 = CC(I-1,1,K)+CC(IC-1,4,K)
            TI4 = CC(I-1,3,K)-CC(IC-1,2,K)
            TR3 = CC(I-1,3,K)+CC(IC-1,2,K)
            CH(I-1,K,1) = TR2+TR3
            CR3 = TR2-TR3
            CH(I,K,1) = TI2+TI3
            CI3 = TI2-TI3
            CR2 = TR1-TR4
            CR4 = TR1+TR4
            CI2 = TI1+TI4
            CI4 = TI1-TI4
            CH(I-1,K,2) = WA1(I-2)*CR2-WA1(I-1)*CI2
            CH(I,K,2) = WA1(I-2)*CI2+WA1(I-1)*CR2
            CH(I-1,K,3) = WA2(I-2)*CR3-WA2(I-1)*CI3
            CH(I,K,3) = WA2(I-2)*CI3+WA2(I-1)*CR3
            CH(I-1,K,4) = WA3(I-2)*CR4-WA3(I-1)*CI4
            CH(I,K,4) = WA3(I-2)*CI4+WA3(I-1)*CR4
  103    CONTINUE
  104 CONTINUE
      IF (MOD(IDO,2) .EQ. 1) RETURN
  105 CONTINUE
      DO 106 K=1,L1
         TI1 = CC(1,2,K)+CC(1,4,K)
         TI2 = CC(1,4,K)-CC(1,2,K)
         TR1 = CC(IDO,1,K)-CC(IDO,3,K)
         TR2 = CC(IDO,1,K)+CC(IDO,3,K)
         CH(IDO,K,1) = TR2+TR2
         CH(IDO,K,2) = SQRT2*(TR1-TI1)
         CH(IDO,K,3) = TI2+TI2
         CH(IDO,K,4) = -SQRT2*(TR1+TI1)
  106 CONTINUE
  107 RETURN
      END
      SUBROUTINE RADB5 (IDO,L1,CC,CH,WA1,WA2,WA3,WA4)

      IMPLICIT REAL*8 (A-H,O-Z) 
      IMPLICIT INTEGER (I-N)

      DIMENSION       CC(IDO,5,L1)           ,CH(IDO,L1,5)           ,
     1                WA1(*)     ,WA2(*)     ,WA3(*)     ,WA4(*)
      DATA TR11,TI11,TR12,TI12 /.309016994374947D0,.951056516295154D0,
     1-.809016994374947D0,.587785252292473D0/
      DO 101 K=1,L1
         TI5 = CC(1,3,K)+CC(1,3,K)
         TI4 = CC(1,5,K)+CC(1,5,K)
         TR2 = CC(IDO,2,K)+CC(IDO,2,K)
         TR3 = CC(IDO,4,K)+CC(IDO,4,K)
         CH(1,K,1) = CC(1,1,K)+TR2+TR3
         CR2 = CC(1,1,K)+TR11*TR2+TR12*TR3
         CR3 = CC(1,1,K)+TR12*TR2+TR11*TR3
         CI5 = TI11*TI5+TI12*TI4
         CI4 = TI12*TI5-TI11*TI4
         CH(1,K,2) = CR2-CI5
         CH(1,K,3) = CR3-CI4
         CH(1,K,4) = CR3+CI4
         CH(1,K,5) = CR2+CI5
  101 CONTINUE
      IF (IDO .EQ. 1) RETURN
      IDP2 = IDO+2
      DO 103 K=1,L1
         DO 102 I=3,IDO,2
            IC = IDP2-I
            TI5 = CC(I,3,K)+CC(IC,2,K)
            TI2 = CC(I,3,K)-CC(IC,2,K)
            TI4 = CC(I,5,K)+CC(IC,4,K)
            TI3 = CC(I,5,K)-CC(IC,4,K)
            TR5 = CC(I-1,3,K)-CC(IC-1,2,K)
            TR2 = CC(I-1,3,K)+CC(IC-1,2,K)
            TR4 = CC(I-1,5,K)-CC(IC-1,4,K)
            TR3 = CC(I-1,5,K)+CC(IC-1,4,K)
            CH(I-1,K,1) = CC(I-1,1,K)+TR2+TR3
            CH(I,K,1) = CC(I,1,K)+TI2+TI3
            CR2 = CC(I-1,1,K)+TR11*TR2+TR12*TR3
            CI2 = CC(I,1,K)+TR11*TI2+TR12*TI3
            CR3 = CC(I-1,1,K)+TR12*TR2+TR11*TR3
            CI3 = CC(I,1,K)+TR12*TI2+TR11*TI3
            CR5 = TI11*TR5+TI12*TR4
            CI5 = TI11*TI5+TI12*TI4
            CR4 = TI12*TR5-TI11*TR4
            CI4 = TI12*TI5-TI11*TI4
            DR3 = CR3-CI4
            DR4 = CR3+CI4
            DI3 = CI3+CR4
            DI4 = CI3-CR4
            DR5 = CR2+CI5
            DR2 = CR2-CI5
            DI5 = CI2-CR5
            DI2 = CI2+CR5
            CH(I-1,K,2) = WA1(I-2)*DR2-WA1(I-1)*DI2
            CH(I,K,2) = WA1(I-2)*DI2+WA1(I-1)*DR2
            CH(I-1,K,3) = WA2(I-2)*DR3-WA2(I-1)*DI3
            CH(I,K,3) = WA2(I-2)*DI3+WA2(I-1)*DR3
            CH(I-1,K,4) = WA3(I-2)*DR4-WA3(I-1)*DI4
            CH(I,K,4) = WA3(I-2)*DI4+WA3(I-1)*DR4
            CH(I-1,K,5) = WA4(I-2)*DR5-WA4(I-1)*DI5
            CH(I,K,5) = WA4(I-2)*DI5+WA4(I-1)*DR5
  102    CONTINUE
  103 CONTINUE
      RETURN
      END
      SUBROUTINE RADBG (IDO,IP,L1,IDL1,CC,C1,C2,CH,CH2,WA)

      IMPLICIT REAL*8 (A-H,O-Z) 
      IMPLICIT INTEGER (I-N)

      DIMENSION       CH(IDO,L1,IP)          ,CC(IDO,IP,L1)          ,
     1                C1(IDO,L1,IP)          ,C2(IDL1,IP),
     2                CH2(IDL1,IP)           ,WA(*)
      DATA TPI/6.28318530717959D0/
      ARG = TPI/FLOAT(IP)
      DCP = COS(ARG)
      DSP = SIN(ARG)
      IDP2 = IDO+2
      NBD = (IDO-1)/2
      IPP2 = IP+2
      IPPH = (IP+1)/2
      IF (IDO .LT. L1) GO TO 103
      DO 102 K=1,L1
         DO 101 I=1,IDO
            CH(I,K,1) = CC(I,1,K)
  101    CONTINUE
  102 CONTINUE
      GO TO 106
  103 DO 105 I=1,IDO
         DO 104 K=1,L1
            CH(I,K,1) = CC(I,1,K)
  104    CONTINUE
  105 CONTINUE
  106 DO 108 J=2,IPPH
         JC = IPP2-J
         J2 = J+J
         DO 107 K=1,L1
            CH(1,K,J) = CC(IDO,J2-2,K)+CC(IDO,J2-2,K)
            CH(1,K,JC) = CC(1,J2-1,K)+CC(1,J2-1,K)
  107    CONTINUE
  108 CONTINUE
      IF (IDO .EQ. 1) GO TO 116
      IF (NBD .LT. L1) GO TO 112
      DO 111 J=2,IPPH
         JC = IPP2-J
         DO 110 K=1,L1
            DO 109 I=3,IDO,2
               IC = IDP2-I
               CH(I-1,K,J) = CC(I-1,2*J-1,K)+CC(IC-1,2*J-2,K)
               CH(I-1,K,JC) = CC(I-1,2*J-1,K)-CC(IC-1,2*J-2,K)
               CH(I,K,J) = CC(I,2*J-1,K)-CC(IC,2*J-2,K)
               CH(I,K,JC) = CC(I,2*J-1,K)+CC(IC,2*J-2,K)
  109       CONTINUE
  110    CONTINUE
  111 CONTINUE
      GO TO 116
  112 DO 115 J=2,IPPH
         JC = IPP2-J
         DO 114 I=3,IDO,2
            IC = IDP2-I
            DO 113 K=1,L1
               CH(I-1,K,J) = CC(I-1,2*J-1,K)+CC(IC-1,2*J-2,K)
               CH(I-1,K,JC) = CC(I-1,2*J-1,K)-CC(IC-1,2*J-2,K)
               CH(I,K,J) = CC(I,2*J-1,K)-CC(IC,2*J-2,K)
               CH(I,K,JC) = CC(I,2*J-1,K)+CC(IC,2*J-2,K)
  113       CONTINUE
  114    CONTINUE
  115 CONTINUE
  116 AR1 = 1.D0
      AI1 = 0.D0
      DO 120 L=2,IPPH
         LC = IPP2-L
         AR1H = DCP*AR1-DSP*AI1
         AI1 = DCP*AI1+DSP*AR1
         AR1 = AR1H
         DO 117 IK=1,IDL1
            C2(IK,L) = CH2(IK,1)+AR1*CH2(IK,2)
            C2(IK,LC) = AI1*CH2(IK,IP)
  117    CONTINUE
         DC2 = AR1
         DS2 = AI1
         AR2 = AR1
         AI2 = AI1
         DO 119 J=3,IPPH
            JC = IPP2-J
            AR2H = DC2*AR2-DS2*AI2
            AI2 = DC2*AI2+DS2*AR2
            AR2 = AR2H
            DO 118 IK=1,IDL1
               C2(IK,L) = C2(IK,L)+AR2*CH2(IK,J)
               C2(IK,LC) = C2(IK,LC)+AI2*CH2(IK,JC)
  118       CONTINUE
  119    CONTINUE
  120 CONTINUE
      DO 122 J=2,IPPH
         DO 121 IK=1,IDL1
            CH2(IK,1) = CH2(IK,1)+CH2(IK,J)
  121    CONTINUE
  122 CONTINUE
      DO 124 J=2,IPPH
         JC = IPP2-J
         DO 123 K=1,L1
            CH(1,K,J) = C1(1,K,J)-C1(1,K,JC)
            CH(1,K,JC) = C1(1,K,J)+C1(1,K,JC)
  123    CONTINUE
  124 CONTINUE
      IF (IDO .EQ. 1) GO TO 132
      IF (NBD .LT. L1) GO TO 128
      DO 127 J=2,IPPH
         JC = IPP2-J
         DO 126 K=1,L1
            DO 125 I=3,IDO,2
               CH(I-1,K,J) = C1(I-1,K,J)-C1(I,K,JC)
               CH(I-1,K,JC) = C1(I-1,K,J)+C1(I,K,JC)
               CH(I,K,J) = C1(I,K,J)+C1(I-1,K,JC)
               CH(I,K,JC) = C1(I,K,J)-C1(I-1,K,JC)
  125       CONTINUE
  126    CONTINUE
  127 CONTINUE
      GO TO 132
  128 DO 131 J=2,IPPH
         JC = IPP2-J
         DO 130 I=3,IDO,2
            DO 129 K=1,L1
               CH(I-1,K,J) = C1(I-1,K,J)-C1(I,K,JC)
               CH(I-1,K,JC) = C1(I-1,K,J)+C1(I,K,JC)
               CH(I,K,J) = C1(I,K,J)+C1(I-1,K,JC)
               CH(I,K,JC) = C1(I,K,J)-C1(I-1,K,JC)
  129       CONTINUE
  130    CONTINUE
  131 CONTINUE
  132 CONTINUE
      IF (IDO .EQ. 1) RETURN
      DO 133 IK=1,IDL1
         C2(IK,1) = CH2(IK,1)
  133 CONTINUE
      DO 135 J=2,IP
         DO 134 K=1,L1
            C1(1,K,J) = CH(1,K,J)
  134    CONTINUE
  135 CONTINUE
      IF (NBD .GT. L1) GO TO 139
      IS = -IDO
      DO 138 J=2,IP
         IS = IS+IDO
         IDIJ = IS
         DO 137 I=3,IDO,2
            IDIJ = IDIJ+2
            DO 136 K=1,L1
               C1(I-1,K,J) = WA(IDIJ-1)*CH(I-1,K,J)-WA(IDIJ)*CH(I,K,J)
               C1(I,K,J) = WA(IDIJ-1)*CH(I,K,J)+WA(IDIJ)*CH(I-1,K,J)
  136       CONTINUE
  137    CONTINUE
  138 CONTINUE
      GO TO 143
  139 IS = -IDO
      DO 142 J=2,IP
         IS = IS+IDO
         DO 141 K=1,L1
            IDIJ = IS
            DO 140 I=3,IDO,2
               IDIJ = IDIJ+2
               C1(I-1,K,J) = WA(IDIJ-1)*CH(I-1,K,J)-WA(IDIJ)*CH(I,K,J)
               C1(I,K,J) = WA(IDIJ-1)*CH(I,K,J)+WA(IDIJ)*CH(I-1,K,J)
  140       CONTINUE
  141    CONTINUE
  142 CONTINUE
  143 RETURN
      END
      SUBROUTINE RFFTB1 (N,C,CH,WA,IFAC)

      IMPLICIT REAL*8 (A-H,O-Z) 
      IMPLICIT INTEGER (I-N)

      DIMENSION       CH(*)      ,C(*)       ,WA(*)      ,IFAC(*)
      NF = IFAC(2)
      NA = 0
      L1 = 1
      IW = 1
      DO 116 K1=1,NF
         IP = IFAC(K1+2)
         L2 = IP*L1
         IDO = N/L2
         IDL1 = IDO*L1
         IF (IP .NE. 4) GO TO 103
         IX2 = IW+IDO
         IX3 = IX2+IDO
         IF (NA .NE. 0) GO TO 101
         CALL RADB4 (IDO,L1,C,CH,WA(IW),WA(IX2),WA(IX3))
         GO TO 102
  101    CALL RADB4 (IDO,L1,CH,C,WA(IW),WA(IX2),WA(IX3))
  102    NA = 1-NA
         GO TO 115
  103    IF (IP .NE. 2) GO TO 106
         IF (NA .NE. 0) GO TO 104
         CALL RADB2 (IDO,L1,C,CH,WA(IW))
         GO TO 105
  104    CALL RADB2 (IDO,L1,CH,C,WA(IW))
  105    NA = 1-NA
         GO TO 115
  106    IF (IP .NE. 3) GO TO 109
         IX2 = IW+IDO
         IF (NA .NE. 0) GO TO 107
         CALL RADB3 (IDO,L1,C,CH,WA(IW),WA(IX2))
         GO TO 108
  107    CALL RADB3 (IDO,L1,CH,C,WA(IW),WA(IX2))
  108    NA = 1-NA
         GO TO 115
  109    IF (IP .NE. 5) GO TO 112
         IX2 = IW+IDO
         IX3 = IX2+IDO
         IX4 = IX3+IDO
         IF (NA .NE. 0) GO TO 110
         CALL RADB5 (IDO,L1,C,CH,WA(IW),WA(IX2),WA(IX3),WA(IX4))
         GO TO 111
  110    CALL RADB5 (IDO,L1,CH,C,WA(IW),WA(IX2),WA(IX3),WA(IX4))
  111    NA = 1-NA
         GO TO 115
  112    IF (NA .NE. 0) GO TO 113
         CALL RADBG (IDO,IP,L1,IDL1,C,C,C,CH,CH,WA(IW))
         GO TO 114
  113    CALL RADBG (IDO,IP,L1,IDL1,CH,CH,CH,C,C,WA(IW))
  114    IF (IDO .EQ. 1) NA = 1-NA
  115    L1 = L2
         IW = IW+(IP-1)*IDO
  116 CONTINUE
      IF (NA .EQ. 0) RETURN
      DO 117 I=1,N
         C(I) = CH(I)
  117 CONTINUE
      RETURN
      END
C     SUBROUTINE RFFTF (N,R,WSAVE)

C     IMPLICIT REAL*8 (A-H,O-Z) 

C     DIMENSION       R(1)       ,WSAVE(1)
C     IF (N .EQ. 1) RETURN
C     CALL RFFTF1 (N,R,WSAVE,WSAVE(N+1),WSAVE(2*N+1))
C     RETURN
C     END
      SUBROUTINE RADF2 (IDO,L1,CC,CH,WA1)

      IMPLICIT REAL*8 (A-H,O-Z) 
      IMPLICIT INTEGER (I-N)

      DIMENSION       CH(IDO,2,L1)           ,CC(IDO,L1,2)           ,
     1                WA1(*)
      DO 101 K=1,L1
         CH(1,1,K) = CC(1,K,1)+CC(1,K,2)
         CH(IDO,2,K) = CC(1,K,1)-CC(1,K,2)
  101 CONTINUE
      IF (IDO-2) 107,105,102
  102 IDP2 = IDO+2
      DO 104 K=1,L1
         DO 103 I=3,IDO,2
            IC = IDP2-I
            TR2 = WA1(I-2)*CC(I-1,K,2)+WA1(I-1)*CC(I,K,2)
            TI2 = WA1(I-2)*CC(I,K,2)-WA1(I-1)*CC(I-1,K,2)
            CH(I,1,K) = CC(I,K,1)+TI2
            CH(IC,2,K) = TI2-CC(I,K,1)
            CH(I-1,1,K) = CC(I-1,K,1)+TR2
            CH(IC-1,2,K) = CC(I-1,K,1)-TR2
  103    CONTINUE
  104 CONTINUE
      IF (MOD(IDO,2) .EQ. 1) RETURN
  105 DO 106 K=1,L1
         CH(1,2,K) = -CC(IDO,K,2)
         CH(IDO,1,K) = CC(IDO,K,1)
  106 CONTINUE
  107 RETURN
      END
      SUBROUTINE RADF3 (IDO,L1,CC,CH,WA1,WA2)

      IMPLICIT REAL*8 (A-H,O-Z) 
      IMPLICIT INTEGER (I-N)

      DIMENSION       CH(IDO,3,L1)           ,CC(IDO,L1,3)           ,
     1                WA1(*)     ,WA2(*)
      DATA TAUR,TAUI /-.5D0,.866025403784439D0/
      DO 101 K=1,L1
         CR2 = CC(1,K,2)+CC(1,K,3)
         CH(1,1,K) = CC(1,K,1)+CR2
         CH(1,3,K) = TAUI*(CC(1,K,3)-CC(1,K,2))
         CH(IDO,2,K) = CC(1,K,1)+TAUR*CR2
  101 CONTINUE
      IF (IDO .EQ. 1) RETURN
      IDP2 = IDO+2
      DO 103 K=1,L1
         DO 102 I=3,IDO,2
            IC = IDP2-I
            DR2 = WA1(I-2)*CC(I-1,K,2)+WA1(I-1)*CC(I,K,2)
            DI2 = WA1(I-2)*CC(I,K,2)-WA1(I-1)*CC(I-1,K,2)
            DR3 = WA2(I-2)*CC(I-1,K,3)+WA2(I-1)*CC(I,K,3)
            DI3 = WA2(I-2)*CC(I,K,3)-WA2(I-1)*CC(I-1,K,3)
            CR2 = DR2+DR3
            CI2 = DI2+DI3
            CH(I-1,1,K) = CC(I-1,K,1)+CR2
            CH(I,1,K) = CC(I,K,1)+CI2
            TR2 = CC(I-1,K,1)+TAUR*CR2
            TI2 = CC(I,K,1)+TAUR*CI2
            TR3 = TAUI*(DI2-DI3)
            TI3 = TAUI*(DR3-DR2)
            CH(I-1,3,K) = TR2+TR3
            CH(IC-1,2,K) = TR2-TR3
            CH(I,3,K) = TI2+TI3
            CH(IC,2,K) = TI3-TI2
  102    CONTINUE
  103 CONTINUE
      RETURN
      END
      SUBROUTINE RADF4 (IDO,L1,CC,CH,WA1,WA2,WA3)

      IMPLICIT REAL*8 (A-H,O-Z) 
      IMPLICIT INTEGER (I-N)

      DIMENSION       CC(IDO,L1,4)           ,CH(IDO,4,L1)           ,
     1                WA1(*)     ,WA2(*)     ,WA3(*)
      DATA HSQT2 /.7071067811865475D0/
      DO 101 K=1,L1
         TR1 = CC(1,K,2)+CC(1,K,4)
         TR2 = CC(1,K,1)+CC(1,K,3)
         CH(1,1,K) = TR1+TR2
         CH(IDO,4,K) = TR2-TR1
         CH(IDO,2,K) = CC(1,K,1)-CC(1,K,3)
         CH(1,3,K) = CC(1,K,4)-CC(1,K,2)
  101 CONTINUE
      IF (IDO-2) 107,105,102
  102 IDP2 = IDO+2
      DO 104 K=1,L1
         DO 103 I=3,IDO,2
            IC = IDP2-I
            CR2 = WA1(I-2)*CC(I-1,K,2)+WA1(I-1)*CC(I,K,2)
            CI2 = WA1(I-2)*CC(I,K,2)-WA1(I-1)*CC(I-1,K,2)
            CR3 = WA2(I-2)*CC(I-1,K,3)+WA2(I-1)*CC(I,K,3)
            CI3 = WA2(I-2)*CC(I,K,3)-WA2(I-1)*CC(I-1,K,3)
            CR4 = WA3(I-2)*CC(I-1,K,4)+WA3(I-1)*CC(I,K,4)
            CI4 = WA3(I-2)*CC(I,K,4)-WA3(I-1)*CC(I-1,K,4)
            TR1 = CR2+CR4
            TR4 = CR4-CR2
            TI1 = CI2+CI4
            TI4 = CI2-CI4
            TI2 = CC(I,K,1)+CI3
            TI3 = CC(I,K,1)-CI3
            TR2 = CC(I-1,K,1)+CR3
            TR3 = CC(I-1,K,1)-CR3
            CH(I-1,1,K) = TR1+TR2
            CH(IC-1,4,K) = TR2-TR1
            CH(I,1,K) = TI1+TI2
            CH(IC,4,K) = TI1-TI2
            CH(I-1,3,K) = TI4+TR3
            CH(IC-1,2,K) = TR3-TI4
            CH(I,3,K) = TR4+TI3
            CH(IC,2,K) = TR4-TI3
  103    CONTINUE
  104 CONTINUE
      IF (MOD(IDO,2) .EQ. 1) RETURN
  105 CONTINUE
      DO 106 K=1,L1
         TI1 = -HSQT2*(CC(IDO,K,2)+CC(IDO,K,4))
         TR1 = HSQT2*(CC(IDO,K,2)-CC(IDO,K,4))
         CH(IDO,1,K) = TR1+CC(IDO,K,1)
         CH(IDO,3,K) = CC(IDO,K,1)-TR1
         CH(1,2,K) = TI1-CC(IDO,K,3)
         CH(1,4,K) = TI1+CC(IDO,K,3)
  106 CONTINUE
  107 RETURN
      END
      SUBROUTINE RADF5 (IDO,L1,CC,CH,WA1,WA2,WA3,WA4)

      IMPLICIT REAL*8 (A-H,O-Z) 
      IMPLICIT INTEGER (I-N)

      DIMENSION       CC(IDO,L1,5)           ,CH(IDO,5,L1)           ,
     1                WA1(*)     ,WA2(*)     ,WA3(*)     ,WA4(*)
      DATA TR11,TI11,TR12,TI12 /.309016994374947D0,.951056516295154D0,
     1-.809016994374947D0,.587785252292473D0/
      DO 101 K=1,L1
         CR2 = CC(1,K,5)+CC(1,K,2)
         CI5 = CC(1,K,5)-CC(1,K,2)
         CR3 = CC(1,K,4)+CC(1,K,3)
         CI4 = CC(1,K,4)-CC(1,K,3)
         CH(1,1,K) = CC(1,K,1)+CR2+CR3
         CH(IDO,2,K) = CC(1,K,1)+TR11*CR2+TR12*CR3
         CH(1,3,K) = TI11*CI5+TI12*CI4
         CH(IDO,4,K) = CC(1,K,1)+TR12*CR2+TR11*CR3
         CH(1,5,K) = TI12*CI5-TI11*CI4
  101 CONTINUE
      IF (IDO .EQ. 1) RETURN
      IDP2 = IDO+2
      DO 103 K=1,L1
         DO 102 I=3,IDO,2
            IC = IDP2-I
            DR2 = WA1(I-2)*CC(I-1,K,2)+WA1(I-1)*CC(I,K,2)
            DI2 = WA1(I-2)*CC(I,K,2)-WA1(I-1)*CC(I-1,K,2)
            DR3 = WA2(I-2)*CC(I-1,K,3)+WA2(I-1)*CC(I,K,3)
            DI3 = WA2(I-2)*CC(I,K,3)-WA2(I-1)*CC(I-1,K,3)
            DR4 = WA3(I-2)*CC(I-1,K,4)+WA3(I-1)*CC(I,K,4)
            DI4 = WA3(I-2)*CC(I,K,4)-WA3(I-1)*CC(I-1,K,4)
            DR5 = WA4(I-2)*CC(I-1,K,5)+WA4(I-1)*CC(I,K,5)
            DI5 = WA4(I-2)*CC(I,K,5)-WA4(I-1)*CC(I-1,K,5)
            CR2 = DR2+DR5
            CI5 = DR5-DR2
            CR5 = DI2-DI5
            CI2 = DI2+DI5
            CR3 = DR3+DR4
            CI4 = DR4-DR3
            CR4 = DI3-DI4
            CI3 = DI3+DI4
            CH(I-1,1,K) = CC(I-1,K,1)+CR2+CR3
            CH(I,1,K) = CC(I,K,1)+CI2+CI3
            TR2 = CC(I-1,K,1)+TR11*CR2+TR12*CR3
            TI2 = CC(I,K,1)+TR11*CI2+TR12*CI3
            TR3 = CC(I-1,K,1)+TR12*CR2+TR11*CR3
            TI3 = CC(I,K,1)+TR12*CI2+TR11*CI3
            TR5 = TI11*CR5+TI12*CR4
            TI5 = TI11*CI5+TI12*CI4
            TR4 = TI12*CR5-TI11*CR4
            TI4 = TI12*CI5-TI11*CI4
            CH(I-1,3,K) = TR2+TR5
            CH(IC-1,2,K) = TR2-TR5
            CH(I,3,K) = TI2+TI5
            CH(IC,2,K) = TI5-TI2
            CH(I-1,5,K) = TR3+TR4
            CH(IC-1,4,K) = TR3-TR4
            CH(I,5,K) = TI3+TI4
            CH(IC,4,K) = TI4-TI3
  102    CONTINUE
  103 CONTINUE
      RETURN
      END
      SUBROUTINE RADFG (IDO,IP,L1,IDL1,CC,C1,C2,CH,CH2,WA)

      IMPLICIT REAL*8 (A-H,O-Z) 
      IMPLICIT INTEGER (I-N)

      DIMENSION       CH(IDO,L1,IP)          ,CC(IDO,IP,L1)          ,
     1                C1(IDO,L1,IP)          ,C2(IDL1,IP),
     2                CH2(IDL1,IP)           ,WA(*)
      DATA TPI/6.28318530717959D0/
      ARG = TPI/FLOAT(IP)
      DCP = COS(ARG)
      DSP = SIN(ARG)
      IPPH = (IP+1)/2
      IPP2 = IP+2
      IDP2 = IDO+2
      NBD = (IDO-1)/2
      IF (IDO .EQ. 1) GO TO 119
      DO 101 IK=1,IDL1
         CH2(IK,1) = C2(IK,1)
  101 CONTINUE
      DO 103 J=2,IP
         DO 102 K=1,L1
            CH(1,K,J) = C1(1,K,J)
  102    CONTINUE
  103 CONTINUE
      IF (NBD .GT. L1) GO TO 107
      IS = -IDO
      DO 106 J=2,IP
         IS = IS+IDO
         IDIJ = IS
         DO 105 I=3,IDO,2
            IDIJ = IDIJ+2
            DO 104 K=1,L1
               CH(I-1,K,J) = WA(IDIJ-1)*C1(I-1,K,J)+WA(IDIJ)*C1(I,K,J)
               CH(I,K,J) = WA(IDIJ-1)*C1(I,K,J)-WA(IDIJ)*C1(I-1,K,J)
  104       CONTINUE
  105    CONTINUE
  106 CONTINUE
      GO TO 111
  107 IS = -IDO
      DO 110 J=2,IP
         IS = IS+IDO
         DO 109 K=1,L1
            IDIJ = IS
            DO 108 I=3,IDO,2
               IDIJ = IDIJ+2
               CH(I-1,K,J) = WA(IDIJ-1)*C1(I-1,K,J)+WA(IDIJ)*C1(I,K,J)
               CH(I,K,J) = WA(IDIJ-1)*C1(I,K,J)-WA(IDIJ)*C1(I-1,K,J)
  108       CONTINUE
  109    CONTINUE
  110 CONTINUE
  111 IF (NBD .LT. L1) GO TO 115
      DO 114 J=2,IPPH
         JC = IPP2-J
         DO 113 K=1,L1
            DO 112 I=3,IDO,2
               C1(I-1,K,J) = CH(I-1,K,J)+CH(I-1,K,JC)
               C1(I-1,K,JC) = CH(I,K,J)-CH(I,K,JC)
               C1(I,K,J) = CH(I,K,J)+CH(I,K,JC)
               C1(I,K,JC) = CH(I-1,K,JC)-CH(I-1,K,J)
  112       CONTINUE
  113    CONTINUE
  114 CONTINUE
      GO TO 121
  115 DO 118 J=2,IPPH
         JC = IPP2-J
         DO 117 I=3,IDO,2
            DO 116 K=1,L1
               C1(I-1,K,J) = CH(I-1,K,J)+CH(I-1,K,JC)
               C1(I-1,K,JC) = CH(I,K,J)-CH(I,K,JC)
               C1(I,K,J) = CH(I,K,J)+CH(I,K,JC)
               C1(I,K,JC) = CH(I-1,K,JC)-CH(I-1,K,J)
  116       CONTINUE
  117    CONTINUE
  118 CONTINUE
      GO TO 121
  119 DO 120 IK=1,IDL1
         C2(IK,1) = CH2(IK,1)
  120 CONTINUE
  121 DO 123 J=2,IPPH
         JC = IPP2-J
         DO 122 K=1,L1
            C1(1,K,J) = CH(1,K,J)+CH(1,K,JC)
            C1(1,K,JC) = CH(1,K,JC)-CH(1,K,J)
  122    CONTINUE
  123 CONTINUE
C
      AR1 = 1.D0
      AI1 = 0.D0
      DO 127 L=2,IPPH
         LC = IPP2-L
         AR1H = DCP*AR1-DSP*AI1
         AI1 = DCP*AI1+DSP*AR1
         AR1 = AR1H
         DO 124 IK=1,IDL1
            CH2(IK,L) = C2(IK,1)+AR1*C2(IK,2)
            CH2(IK,LC) = AI1*C2(IK,IP)
  124    CONTINUE
         DC2 = AR1
         DS2 = AI1
         AR2 = AR1
         AI2 = AI1
         DO 126 J=3,IPPH
            JC = IPP2-J
            AR2H = DC2*AR2-DS2*AI2
            AI2 = DC2*AI2+DS2*AR2
            AR2 = AR2H
            DO 125 IK=1,IDL1
               CH2(IK,L) = CH2(IK,L)+AR2*C2(IK,J)
               CH2(IK,LC) = CH2(IK,LC)+AI2*C2(IK,JC)
  125       CONTINUE
  126    CONTINUE
  127 CONTINUE
      DO 129 J=2,IPPH
         DO 128 IK=1,IDL1
            CH2(IK,1) = CH2(IK,1)+C2(IK,J)
  128    CONTINUE
  129 CONTINUE
C
      IF (IDO .LT. L1) GO TO 132
      DO 131 K=1,L1
         DO 130 I=1,IDO
            CC(I,1,K) = CH(I,K,1)
  130    CONTINUE
  131 CONTINUE
      GO TO 135
  132 DO 134 I=1,IDO
         DO 133 K=1,L1
            CC(I,1,K) = CH(I,K,1)
  133    CONTINUE
  134 CONTINUE
  135 DO 137 J=2,IPPH
         JC = IPP2-J
         J2 = J+J
         DO 136 K=1,L1
            CC(IDO,J2-2,K) = CH(1,K,J)
            CC(1,J2-1,K) = CH(1,K,JC)
  136    CONTINUE
  137 CONTINUE
      IF (IDO .EQ. 1) RETURN
      IF (NBD .LT. L1) GO TO 141
      DO 140 J=2,IPPH
         JC = IPP2-J
         J2 = J+J
         DO 139 K=1,L1
            DO 138 I=3,IDO,2
               IC = IDP2-I
               CC(I-1,J2-1,K) = CH(I-1,K,J)+CH(I-1,K,JC)
               CC(IC-1,J2-2,K) = CH(I-1,K,J)-CH(I-1,K,JC)
               CC(I,J2-1,K) = CH(I,K,J)+CH(I,K,JC)
               CC(IC,J2-2,K) = CH(I,K,JC)-CH(I,K,J)
  138       CONTINUE
  139    CONTINUE
  140 CONTINUE
      RETURN
  141 DO 144 J=2,IPPH
         JC = IPP2-J
         J2 = J+J
         DO 143 I=3,IDO,2
            IC = IDP2-I
            DO 142 K=1,L1
               CC(I-1,J2-1,K) = CH(I-1,K,J)+CH(I-1,K,JC)
               CC(IC-1,J2-2,K) = CH(I-1,K,J)-CH(I-1,K,JC)
               CC(I,J2-1,K) = CH(I,K,J)+CH(I,K,JC)
               CC(IC,J2-2,K) = CH(I,K,JC)-CH(I,K,J)
  142       CONTINUE
  143    CONTINUE
  144 CONTINUE
      RETURN
      END
      SUBROUTINE RFFTF1 (N,C,CH,WA,IFAC)

      IMPLICIT REAL*8 (A-H,O-Z) 
      IMPLICIT INTEGER (I-N)

      DIMENSION       CH(*)      ,C(*)       ,WA(*)      ,IFAC(*)
      NF = IFAC(2)
      NA = 1
      L2 = N
      IW = N
      DO 111 K1=1,NF
         KH = NF-K1
         IP = IFAC(KH+3)
         L1 = L2/IP
         IDO = N/L2
         IDL1 = IDO*L1
         IW = IW-(IP-1)*IDO
         NA = 1-NA
         IF (IP .NE. 4) GO TO 102
         IX2 = IW+IDO
         IX3 = IX2+IDO
         IF (NA .NE. 0) GO TO 101
         CALL RADF4 (IDO,L1,C,CH,WA(IW),WA(IX2),WA(IX3))
         GO TO 110
  101    CALL RADF4 (IDO,L1,CH,C,WA(IW),WA(IX2),WA(IX3))
         GO TO 110
  102    IF (IP .NE. 2) GO TO 104
         IF (NA .NE. 0) GO TO 103
         CALL RADF2 (IDO,L1,C,CH,WA(IW))
         GO TO 110
  103    CALL RADF2 (IDO,L1,CH,C,WA(IW))
         GO TO 110
  104    IF (IP .NE. 3) GO TO 106
         IX2 = IW+IDO
         IF (NA .NE. 0) GO TO 105
         CALL RADF3 (IDO,L1,C,CH,WA(IW),WA(IX2))
         GO TO 110
  105    CALL RADF3 (IDO,L1,CH,C,WA(IW),WA(IX2))
         GO TO 110
  106    IF (IP .NE. 5) GO TO 108
         IX2 = IW+IDO
         IX3 = IX2+IDO
         IX4 = IX3+IDO
         IF (NA .NE. 0) GO TO 107
         CALL RADF5 (IDO,L1,C,CH,WA(IW),WA(IX2),WA(IX3),WA(IX4))
         GO TO 110
  107    CALL RADF5 (IDO,L1,CH,C,WA(IW),WA(IX2),WA(IX3),WA(IX4))
         GO TO 110
  108    IF (IDO .EQ. 1) NA = 1-NA
         IF (NA .NE. 0) GO TO 109
         CALL RADFG (IDO,IP,L1,IDL1,C,C,C,CH,CH,WA(IW))
         NA = 1
         GO TO 110
  109    CALL RADFG (IDO,IP,L1,IDL1,CH,CH,CH,C,C,WA(IW))
         NA = 0
  110    L2 = L1
  111 CONTINUE
      IF (NA .EQ. 1) RETURN
      DO 112 I=1,N
         C(I) = CH(I)
  112 CONTINUE
      RETURN
      END
C     SUBROUTINE RFFTI (N,WSAVE)

C     IMPLICIT REAL*8 (A-H,O-Z) 
C     IMPLICIT INTEGER (I-N)

C     DIMENSION       WSAVE(1)
C     IF (N .EQ. 1) RETURN
C     CALL RFFTI1 (N,WSAVE(N+1),WSAVE(2*N+1))
C     RETURN
C     END
      SUBROUTINE RFFTI1 (N,WA,IFAC)

      IMPLICIT REAL*8 (A-H,O-Z) 
      IMPLICIT INTEGER (I-N)

      DIMENSION       WA(*)      ,IFAC(*)    ,NTRYH(4)
      DATA NTRYH(1),NTRYH(2),NTRYH(3),NTRYH(4)/4,2,3,5/
      NL = N
      NF = 0
      J = 0
  101 J = J+1
      IF (J-4) 102,102,103
  102 NTRY = NTRYH(J)
      GO TO 104
  103 NTRY = NTRY+2
  104 NQ = NL/NTRY
      NR = NL-NTRY*NQ
      IF (NR) 101,105,101
  105 NF = NF+1
      IFAC(NF+2) = NTRY
      NL = NQ
      IF (NTRY .NE. 2) GO TO 107
      IF (NF .EQ. 1) GO TO 107
      DO 106 I=2,NF
         IB = NF-I+2
         IFAC(IB+2) = IFAC(IB+1)
  106 CONTINUE
      IFAC(3) = 2
  107 IF (NL .NE. 1) GO TO 104
      IFAC(1) = N
      IFAC(2) = NF
      TPI = 6.28318530717959D0
      ARGH = TPI/FLOAT(N)
      IS = 0
      NFM1 = NF-1
      L1 = 1
      IF (NFM1 .EQ. 0) RETURN
      DO 110 K1=1,NFM1
         IP = IFAC(K1+2)
         LD = 0
         L2 = L1*IP
         IDO = N/L2
         IPM = IP-1
         DO 109 J=1,IPM
            LD = LD+L1
            I = IS
            ARGLD = FLOAT(LD)*ARGH
            FI = 0.D0
            DO 108 II=3,IDO,2
               I = I+2
               FI = FI+1.D0
               ARG = FI*ARGLD
               WA(I-1) = COS(ARG)
               WA(I) = SIN(ARG)
  108       CONTINUE
            IS = IS+IDO
  109    CONTINUE
         L1 = L2
  110 CONTINUE
      RETURN
      END
C     SUBROUTINE R8FFTB (N,R,WSAVE)
C     implicit real*8 (A-H,O-Z)
C     DIMENSION       R(1)       ,WSAVE(1)
C     IF (N .EQ. 1) RETURN
C     CALL R8FFTB1 (N,R,WSAVE,WSAVE(N+1),WSAVE(2*N+1))
C     RETURN
C     END
      SUBROUTINE R8ADB2 (IDO,L1,CC,CH,WA1)
      implicit real*8 (A-H,O-Z)
      IMPLICIT INTEGER (I-N)
      DIMENSION       CC(IDO,2,L1)           ,CH(IDO,L1,2)           ,
     1                WA1(*)
      DO 101 K=1,L1
         CH(1,K,1) = CC(1,1,K)+CC(IDO,2,K)
         CH(1,K,2) = CC(1,1,K)-CC(IDO,2,K)
  101 CONTINUE
      IF (IDO-2) 107,105,102
  102 IDP2 = IDO+2
      DO 104 K=1,L1
         DO 103 I=3,IDO,2
            IC = IDP2-I
            CH(I-1,K,1) = CC(I-1,1,K)+CC(IC-1,2,K)
            TR2 = CC(I-1,1,K)-CC(IC-1,2,K)
            CH(I,K,1) = CC(I,1,K)-CC(IC,2,K)
            TI2 = CC(I,1,K)+CC(IC,2,K)
            CH(I-1,K,2) = WA1(I-2)*TR2-WA1(I-1)*TI2
            CH(I,K,2) = WA1(I-2)*TI2+WA1(I-1)*TR2
  103    CONTINUE
  104 CONTINUE
      IF (MOD(IDO,2) .EQ. 1) RETURN
  105 DO 106 K=1,L1
         CH(IDO,K,1) = CC(IDO,1,K)+CC(IDO,1,K)
         CH(IDO,K,2) = -(CC(1,2,K)+CC(1,2,K))
  106 CONTINUE
  107 RETURN
      END
      SUBROUTINE R8ADB3 (IDO,L1,CC,CH,WA1,WA2)
      implicit real*8 (A-H,O-Z)
      IMPLICIT INTEGER (I-N)
      DIMENSION       CC(IDO,3,L1)           ,CH(IDO,L1,3)           ,
     1                WA1(*)     ,WA2(*)
      DATA TAUR,TAUI /-.5D0,.866025403784439D0/
      DO 101 K=1,L1
         TR2 = CC(IDO,2,K)+CC(IDO,2,K)
         CR2 = CC(1,1,K)+TAUR*TR2
         CH(1,K,1) = CC(1,1,K)+TR2
         CI3 = TAUI*(CC(1,3,K)+CC(1,3,K))
         CH(1,K,2) = CR2-CI3
         CH(1,K,3) = CR2+CI3
  101 CONTINUE
      IF (IDO .EQ. 1) RETURN
      IDP2 = IDO+2
      DO 103 K=1,L1
         DO 102 I=3,IDO,2
            IC = IDP2-I
            TR2 = CC(I-1,3,K)+CC(IC-1,2,K)
            CR2 = CC(I-1,1,K)+TAUR*TR2
            CH(I-1,K,1) = CC(I-1,1,K)+TR2
            TI2 = CC(I,3,K)-CC(IC,2,K)
            CI2 = CC(I,1,K)+TAUR*TI2
            CH(I,K,1) = CC(I,1,K)+TI2
            CR3 = TAUI*(CC(I-1,3,K)-CC(IC-1,2,K))
            CI3 = TAUI*(CC(I,3,K)+CC(IC,2,K))
            DR2 = CR2-CI3
            DR3 = CR2+CI3
            DI2 = CI2+CR3
            DI3 = CI2-CR3
            CH(I-1,K,2) = WA1(I-2)*DR2-WA1(I-1)*DI2
            CH(I,K,2) = WA1(I-2)*DI2+WA1(I-1)*DR2
            CH(I-1,K,3) = WA2(I-2)*DR3-WA2(I-1)*DI3
            CH(I,K,3) = WA2(I-2)*DI3+WA2(I-1)*DR3
  102    CONTINUE
  103 CONTINUE
      RETURN
      END
      SUBROUTINE R8ADB4 (IDO,L1,CC,CH,WA1,WA2,WA3)
      implicit real*8 (A-H,O-Z)
      IMPLICIT INTEGER (I-N)
      DIMENSION       CC(IDO,4,L1)           ,CH(IDO,L1,4)           ,
     1                WA1(*)     ,WA2(*)     ,WA3(*)
      DATA SQRT2 /1.414213562373095D0/
      DO 101 K=1,L1
         TR1 = CC(1,1,K)-CC(IDO,4,K)
         TR2 = CC(1,1,K)+CC(IDO,4,K)
         TR3 = CC(IDO,2,K)+CC(IDO,2,K)
         TR4 = CC(1,3,K)+CC(1,3,K)
         CH(1,K,1) = TR2+TR3
         CH(1,K,2) = TR1-TR4
         CH(1,K,3) = TR2-TR3
         CH(1,K,4) = TR1+TR4
  101 CONTINUE
      IF (IDO-2) 107,105,102
  102 IDP2 = IDO+2
      DO 104 K=1,L1
         DO 103 I=3,IDO,2
            IC = IDP2-I
            TI1 = CC(I,1,K)+CC(IC,4,K)
            TI2 = CC(I,1,K)-CC(IC,4,K)
            TI3 = CC(I,3,K)-CC(IC,2,K)
            TR4 = CC(I,3,K)+CC(IC,2,K)
            TR1 = CC(I-1,1,K)-CC(IC-1,4,K)
            TR2 = CC(I-1,1,K)+CC(IC-1,4,K)
            TI4 = CC(I-1,3,K)-CC(IC-1,2,K)
            TR3 = CC(I-1,3,K)+CC(IC-1,2,K)
            CH(I-1,K,1) = TR2+TR3
            CR3 = TR2-TR3
            CH(I,K,1) = TI2+TI3
            CI3 = TI2-TI3
            CR2 = TR1-TR4
            CR4 = TR1+TR4
            CI2 = TI1+TI4
            CI4 = TI1-TI4
            CH(I-1,K,2) = WA1(I-2)*CR2-WA1(I-1)*CI2
            CH(I,K,2) = WA1(I-2)*CI2+WA1(I-1)*CR2
            CH(I-1,K,3) = WA2(I-2)*CR3-WA2(I-1)*CI3
            CH(I,K,3) = WA2(I-2)*CI3+WA2(I-1)*CR3
            CH(I-1,K,4) = WA3(I-2)*CR4-WA3(I-1)*CI4
            CH(I,K,4) = WA3(I-2)*CI4+WA3(I-1)*CR4
  103    CONTINUE
  104 CONTINUE
      IF (MOD(IDO,2) .EQ. 1) RETURN
  105 CONTINUE
      DO 106 K=1,L1
         TI1 = CC(1,2,K)+CC(1,4,K)
         TI2 = CC(1,4,K)-CC(1,2,K)
         TR1 = CC(IDO,1,K)-CC(IDO,3,K)
         TR2 = CC(IDO,1,K)+CC(IDO,3,K)
         CH(IDO,K,1) = TR2+TR2
         CH(IDO,K,2) = SQRT2*(TR1-TI1)
         CH(IDO,K,3) = TI2+TI2
         CH(IDO,K,4) = -SQRT2*(TR1+TI1)
  106 CONTINUE
  107 RETURN
      END
      SUBROUTINE R8ADB5 (IDO,L1,CC,CH,WA1,WA2,WA3,WA4)
      implicit real*8 (A-H,O-Z)
      IMPLICIT INTEGER (I-N)
      DIMENSION       CC(IDO,5,L1)           ,CH(IDO,L1,5)           ,
     1                WA1(*)     ,WA2(*)     ,WA3(*)     ,WA4(*)
      DATA TR11,TI11,TR12,TI12 /.309016994374947D0,.951056516295154D0,
     1-.809016994374947D0,.587785252292473D0/
      DO 101 K=1,L1
         TI5 = CC(1,3,K)+CC(1,3,K)
         TI4 = CC(1,5,K)+CC(1,5,K)
         TR2 = CC(IDO,2,K)+CC(IDO,2,K)
         TR3 = CC(IDO,4,K)+CC(IDO,4,K)
         CH(1,K,1) = CC(1,1,K)+TR2+TR3
         CR2 = CC(1,1,K)+TR11*TR2+TR12*TR3
         CR3 = CC(1,1,K)+TR12*TR2+TR11*TR3
         CI5 = TI11*TI5+TI12*TI4
         CI4 = TI12*TI5-TI11*TI4
         CH(1,K,2) = CR2-CI5
         CH(1,K,3) = CR3-CI4
         CH(1,K,4) = CR3+CI4
         CH(1,K,5) = CR2+CI5
  101 CONTINUE
      IF (IDO .EQ. 1) RETURN
      IDP2 = IDO+2
      DO 103 K=1,L1
         DO 102 I=3,IDO,2
            IC = IDP2-I
            TI5 = CC(I,3,K)+CC(IC,2,K)
            TI2 = CC(I,3,K)-CC(IC,2,K)
            TI4 = CC(I,5,K)+CC(IC,4,K)
            TI3 = CC(I,5,K)-CC(IC,4,K)
            TR5 = CC(I-1,3,K)-CC(IC-1,2,K)
            TR2 = CC(I-1,3,K)+CC(IC-1,2,K)
            TR4 = CC(I-1,5,K)-CC(IC-1,4,K)
            TR3 = CC(I-1,5,K)+CC(IC-1,4,K)
            CH(I-1,K,1) = CC(I-1,1,K)+TR2+TR3
            CH(I,K,1) = CC(I,1,K)+TI2+TI3
            CR2 = CC(I-1,1,K)+TR11*TR2+TR12*TR3
            CI2 = CC(I,1,K)+TR11*TI2+TR12*TI3
            CR3 = CC(I-1,1,K)+TR12*TR2+TR11*TR3
            CI3 = CC(I,1,K)+TR12*TI2+TR11*TI3
            CR5 = TI11*TR5+TI12*TR4
            CI5 = TI11*TI5+TI12*TI4
            CR4 = TI12*TR5-TI11*TR4
            CI4 = TI12*TI5-TI11*TI4
            DR3 = CR3-CI4
            DR4 = CR3+CI4
            DI3 = CI3+CR4
            DI4 = CI3-CR4
            DR5 = CR2+CI5
            DR2 = CR2-CI5
            DI5 = CI2-CR5
            DI2 = CI2+CR5
            CH(I-1,K,2) = WA1(I-2)*DR2-WA1(I-1)*DI2
            CH(I,K,2) = WA1(I-2)*DI2+WA1(I-1)*DR2
            CH(I-1,K,3) = WA2(I-2)*DR3-WA2(I-1)*DI3
            CH(I,K,3) = WA2(I-2)*DI3+WA2(I-1)*DR3
            CH(I-1,K,4) = WA3(I-2)*DR4-WA3(I-1)*DI4
            CH(I,K,4) = WA3(I-2)*DI4+WA3(I-1)*DR4
            CH(I-1,K,5) = WA4(I-2)*DR5-WA4(I-1)*DI5
            CH(I,K,5) = WA4(I-2)*DI5+WA4(I-1)*DR5
  102    CONTINUE
  103 CONTINUE
      RETURN
      END
      SUBROUTINE R8ADBG (IDO,IP,L1,IDL1,CC,C1,C2,CH,CH2,WA)
      implicit real*8 (A-H,O-Z)
      IMPLICIT INTEGER (I-N)
      DIMENSION       CH(IDO,L1,IP)          ,CC(IDO,IP,L1)          ,
     1                C1(IDO,L1,IP)          ,C2(IDL1,IP),
     2                CH2(IDL1,IP)           ,WA(*)
      DATA TPI/6.28318530717959D0/
      ARG = TPI/FLOAT(IP)
      DCP = COS(ARG)
      DSP = SIN(ARG)
      IDP2 = IDO+2
      NBD = (IDO-1)/2
      IPP2 = IP+2
      IPPH = (IP+1)/2
      IF (IDO .LT. L1) GO TO 103
      DO 102 K=1,L1
         DO 101 I=1,IDO
            CH(I,K,1) = CC(I,1,K)
  101    CONTINUE
  102 CONTINUE
      GO TO 106
  103 DO 105 I=1,IDO
         DO 104 K=1,L1
            CH(I,K,1) = CC(I,1,K)
  104    CONTINUE
  105 CONTINUE
  106 DO 108 J=2,IPPH
         JC = IPP2-J
         J2 = J+J
         DO 107 K=1,L1
            CH(1,K,J) = CC(IDO,J2-2,K)+CC(IDO,J2-2,K)
            CH(1,K,JC) = CC(1,J2-1,K)+CC(1,J2-1,K)
  107    CONTINUE
  108 CONTINUE
      IF (IDO .EQ. 1) GO TO 116
      IF (NBD .LT. L1) GO TO 112
      DO 111 J=2,IPPH
         JC = IPP2-J
         DO 110 K=1,L1
            DO 109 I=3,IDO,2
               IC = IDP2-I
               CH(I-1,K,J) = CC(I-1,2*J-1,K)+CC(IC-1,2*J-2,K)
               CH(I-1,K,JC) = CC(I-1,2*J-1,K)-CC(IC-1,2*J-2,K)
               CH(I,K,J) = CC(I,2*J-1,K)-CC(IC,2*J-2,K)
               CH(I,K,JC) = CC(I,2*J-1,K)+CC(IC,2*J-2,K)
  109       CONTINUE
  110    CONTINUE
  111 CONTINUE
      GO TO 116
  112 DO 115 J=2,IPPH
         JC = IPP2-J
         DO 114 I=3,IDO,2
            IC = IDP2-I
            DO 113 K=1,L1
               CH(I-1,K,J) = CC(I-1,2*J-1,K)+CC(IC-1,2*J-2,K)
               CH(I-1,K,JC) = CC(I-1,2*J-1,K)-CC(IC-1,2*J-2,K)
               CH(I,K,J) = CC(I,2*J-1,K)-CC(IC,2*J-2,K)
               CH(I,K,JC) = CC(I,2*J-1,K)+CC(IC,2*J-2,K)
  113       CONTINUE
  114    CONTINUE
  115 CONTINUE
  116 AR1 = 1.D0
      AI1 = 0.D0
      DO 120 L=2,IPPH
         LC = IPP2-L
         AR1H = DCP*AR1-DSP*AI1
         AI1 = DCP*AI1+DSP*AR1
         AR1 = AR1H
         DO 117 IK=1,IDL1
            C2(IK,L) = CH2(IK,1)+AR1*CH2(IK,2)
            C2(IK,LC) = AI1*CH2(IK,IP)
  117    CONTINUE
         DC2 = AR1
         DS2 = AI1
         AR2 = AR1
         AI2 = AI1
         DO 119 J=3,IPPH
            JC = IPP2-J
            AR2H = DC2*AR2-DS2*AI2
            AI2 = DC2*AI2+DS2*AR2
            AR2 = AR2H
            DO 118 IK=1,IDL1
               C2(IK,L) = C2(IK,L)+AR2*CH2(IK,J)
               C2(IK,LC) = C2(IK,LC)+AI2*CH2(IK,JC)
  118       CONTINUE
  119    CONTINUE
  120 CONTINUE
      DO 122 J=2,IPPH
         DO 121 IK=1,IDL1
            CH2(IK,1) = CH2(IK,1)+CH2(IK,J)
  121    CONTINUE
  122 CONTINUE
      DO 124 J=2,IPPH
         JC = IPP2-J
         DO 123 K=1,L1
            CH(1,K,J) = C1(1,K,J)-C1(1,K,JC)
            CH(1,K,JC) = C1(1,K,J)+C1(1,K,JC)
  123    CONTINUE
  124 CONTINUE
      IF (IDO .EQ. 1) GO TO 132
      IF (NBD .LT. L1) GO TO 128
      DO 127 J=2,IPPH
         JC = IPP2-J
         DO 126 K=1,L1
            DO 125 I=3,IDO,2
               CH(I-1,K,J) = C1(I-1,K,J)-C1(I,K,JC)
               CH(I-1,K,JC) = C1(I-1,K,J)+C1(I,K,JC)
               CH(I,K,J) = C1(I,K,J)+C1(I-1,K,JC)
               CH(I,K,JC) = C1(I,K,J)-C1(I-1,K,JC)
  125       CONTINUE
  126    CONTINUE
  127 CONTINUE
      GO TO 132
  128 DO 131 J=2,IPPH
         JC = IPP2-J
         DO 130 I=3,IDO,2
            DO 129 K=1,L1
               CH(I-1,K,J) = C1(I-1,K,J)-C1(I,K,JC)
               CH(I-1,K,JC) = C1(I-1,K,J)+C1(I,K,JC)
               CH(I,K,J) = C1(I,K,J)+C1(I-1,K,JC)
               CH(I,K,JC) = C1(I,K,J)-C1(I-1,K,JC)
  129       CONTINUE
  130    CONTINUE
  131 CONTINUE
  132 CONTINUE
      IF (IDO .EQ. 1) RETURN
      DO 133 IK=1,IDL1
         C2(IK,1) = CH2(IK,1)
  133 CONTINUE
      DO 135 J=2,IP
         DO 134 K=1,L1
            C1(1,K,J) = CH(1,K,J)
  134    CONTINUE
  135 CONTINUE
      IF (NBD .GT. L1) GO TO 139
      IS = -IDO
      DO 138 J=2,IP
         IS = IS+IDO
         IDIJ = IS
         DO 137 I=3,IDO,2
            IDIJ = IDIJ+2
            DO 136 K=1,L1
               C1(I-1,K,J) = WA(IDIJ-1)*CH(I-1,K,J)-WA(IDIJ)*CH(I,K,J)
               C1(I,K,J) = WA(IDIJ-1)*CH(I,K,J)+WA(IDIJ)*CH(I-1,K,J)
  136       CONTINUE
  137    CONTINUE
  138 CONTINUE
      GO TO 143
  139 IS = -IDO
      DO 142 J=2,IP
         IS = IS+IDO
         DO 141 K=1,L1
            IDIJ = IS
            DO 140 I=3,IDO,2
               IDIJ = IDIJ+2
               C1(I-1,K,J) = WA(IDIJ-1)*CH(I-1,K,J)-WA(IDIJ)*CH(I,K,J)
               C1(I,K,J) = WA(IDIJ-1)*CH(I,K,J)+WA(IDIJ)*CH(I-1,K,J)
  140       CONTINUE
  141    CONTINUE
  142 CONTINUE
  143 RETURN
      END
      SUBROUTINE R8FFTB1 (N,C,CH,WA,IFAC)
      implicit real*8 (A-H,O-Z)
      IMPLICIT INTEGER (I-N)
      DIMENSION       CH(*)      ,C(*)       ,WA(*)      ,IFAC(*)
      NF = IFAC(2)
      NA = 0
      L1 = 1
      IW = 1
      DO 116 K1=1,NF
         IP = IFAC(K1+2)
         L2 = IP*L1
         IDO = N/L2
         IDL1 = IDO*L1
         IF (IP .NE. 4) GO TO 103
         IX2 = IW+IDO
         IX3 = IX2+IDO
         IF (NA .NE. 0) GO TO 101
         CALL R8ADB4 (IDO,L1,C,CH,WA(IW),WA(IX2),WA(IX3))
         GO TO 102
  101    CALL R8ADB4 (IDO,L1,CH,C,WA(IW),WA(IX2),WA(IX3))
  102    NA = 1-NA
         GO TO 115
  103    IF (IP .NE. 2) GO TO 106
         IF (NA .NE. 0) GO TO 104
         CALL R8ADB2 (IDO,L1,C,CH,WA(IW))
         GO TO 105
  104    CALL R8ADB2 (IDO,L1,CH,C,WA(IW))
  105    NA = 1-NA
         GO TO 115
  106    IF (IP .NE. 3) GO TO 109
         IX2 = IW+IDO
         IF (NA .NE. 0) GO TO 107
         CALL R8ADB3 (IDO,L1,C,CH,WA(IW),WA(IX2))
         GO TO 108
  107    CALL R8ADB3 (IDO,L1,CH,C,WA(IW),WA(IX2))
  108    NA = 1-NA
         GO TO 115
  109    IF (IP .NE. 5) GO TO 112
         IX2 = IW+IDO
         IX3 = IX2+IDO
         IX4 = IX3+IDO
         IF (NA .NE. 0) GO TO 110
         CALL R8ADB5 (IDO,L1,C,CH,WA(IW),WA(IX2),WA(IX3),WA(IX4))
         GO TO 111
  110    CALL R8ADB5 (IDO,L1,CH,C,WA(IW),WA(IX2),WA(IX3),WA(IX4))
  111    NA = 1-NA
         GO TO 115
  112    IF (NA .NE. 0) GO TO 113
         CALL R8ADBG (IDO,IP,L1,IDL1,C,C,C,CH,CH,WA(IW))
         GO TO 114
  113    CALL R8ADBG (IDO,IP,L1,IDL1,CH,CH,CH,C,C,WA(IW))
  114    IF (IDO .EQ. 1) NA = 1-NA
  115    L1 = L2
         IW = IW+(IP-1)*IDO
  116 CONTINUE
      IF (NA .EQ. 0) RETURN
      DO 117 I=1,N
         C(I) = CH(I)
  117 CONTINUE
      RETURN
      END
C     SUBROUTINE R8FFTF (N,R,WSAVE)
C     implicit real*8 (A-H,O-Z)
C     DIMENSION       R(1)       ,WSAVE(1)
C     IF (N .EQ. 1) RETURN
C     CALL R8FFTF1 (N,R,WSAVE,WSAVE(N+1),WSAVE(2*N+1))
C     RETURN
C     END
      SUBROUTINE R8ADF2 (IDO,L1,CC,CH,WA1)
      implicit real*8 (A-H,O-Z)
      IMPLICIT INTEGER (I-N)
      DIMENSION       CH(IDO,2,L1)           ,CC(IDO,L1,2)           ,
     1                WA1(*)
      DO 101 K=1,L1
         CH(1,1,K) = CC(1,K,1)+CC(1,K,2)
         CH(IDO,2,K) = CC(1,K,1)-CC(1,K,2)
  101 CONTINUE
      IF (IDO-2) 107,105,102
  102 IDP2 = IDO+2
      DO 104 K=1,L1
         DO 103 I=3,IDO,2
            IC = IDP2-I
            TR2 = WA1(I-2)*CC(I-1,K,2)+WA1(I-1)*CC(I,K,2)
            TI2 = WA1(I-2)*CC(I,K,2)-WA1(I-1)*CC(I-1,K,2)
            CH(I,1,K) = CC(I,K,1)+TI2
            CH(IC,2,K) = TI2-CC(I,K,1)
            CH(I-1,1,K) = CC(I-1,K,1)+TR2
            CH(IC-1,2,K) = CC(I-1,K,1)-TR2
  103    CONTINUE
  104 CONTINUE
      IF (MOD(IDO,2) .EQ. 1) RETURN
  105 DO 106 K=1,L1
         CH(1,2,K) = -CC(IDO,K,2)
         CH(IDO,1,K) = CC(IDO,K,1)
  106 CONTINUE
  107 RETURN
      END
      SUBROUTINE R8ADF3 (IDO,L1,CC,CH,WA1,WA2)
      implicit real*8 (A-H,O-Z)
      IMPLICIT INTEGER (I-N)
      DIMENSION       CH(IDO,3,L1)           ,CC(IDO,L1,3)           ,
     1                WA1(*)     ,WA2(*)
      DATA TAUR,TAUI /-.5D0,.866025403784439D0/
      DO 101 K=1,L1
         CR2 = CC(1,K,2)+CC(1,K,3)
         CH(1,1,K) = CC(1,K,1)+CR2
         CH(1,3,K) = TAUI*(CC(1,K,3)-CC(1,K,2))
         CH(IDO,2,K) = CC(1,K,1)+TAUR*CR2
  101 CONTINUE
      IF (IDO .EQ. 1) RETURN
      IDP2 = IDO+2
      DO 103 K=1,L1
         DO 102 I=3,IDO,2
            IC = IDP2-I
            DR2 = WA1(I-2)*CC(I-1,K,2)+WA1(I-1)*CC(I,K,2)
            DI2 = WA1(I-2)*CC(I,K,2)-WA1(I-1)*CC(I-1,K,2)
            DR3 = WA2(I-2)*CC(I-1,K,3)+WA2(I-1)*CC(I,K,3)
            DI3 = WA2(I-2)*CC(I,K,3)-WA2(I-1)*CC(I-1,K,3)
            CR2 = DR2+DR3
            CI2 = DI2+DI3
            CH(I-1,1,K) = CC(I-1,K,1)+CR2
            CH(I,1,K) = CC(I,K,1)+CI2
            TR2 = CC(I-1,K,1)+TAUR*CR2
            TI2 = CC(I,K,1)+TAUR*CI2
            TR3 = TAUI*(DI2-DI3)
            TI3 = TAUI*(DR3-DR2)
            CH(I-1,3,K) = TR2+TR3
            CH(IC-1,2,K) = TR2-TR3
            CH(I,3,K) = TI2+TI3
            CH(IC,2,K) = TI3-TI2
  102    CONTINUE
  103 CONTINUE
      RETURN
      END
      SUBROUTINE R8ADF4 (IDO,L1,CC,CH,WA1,WA2,WA3)
      implicit real*8 (A-H,O-Z)
      IMPLICIT INTEGER (I-N)
      DIMENSION       CC(IDO,L1,4)           ,CH(IDO,4,L1)           ,
     1                WA1(*)     ,WA2(*)     ,WA3(*)
      DATA HSQT2 /.7071067811865475D0/
      DO 101 K=1,L1
         TR1 = CC(1,K,2)+CC(1,K,4)
         TR2 = CC(1,K,1)+CC(1,K,3)
         CH(1,1,K) = TR1+TR2
         CH(IDO,4,K) = TR2-TR1
         CH(IDO,2,K) = CC(1,K,1)-CC(1,K,3)
         CH(1,3,K) = CC(1,K,4)-CC(1,K,2)
  101 CONTINUE
      IF (IDO-2) 107,105,102
  102 IDP2 = IDO+2
      DO 104 K=1,L1
         DO 103 I=3,IDO,2
            IC = IDP2-I
            CR2 = WA1(I-2)*CC(I-1,K,2)+WA1(I-1)*CC(I,K,2)
            CI2 = WA1(I-2)*CC(I,K,2)-WA1(I-1)*CC(I-1,K,2)
            CR3 = WA2(I-2)*CC(I-1,K,3)+WA2(I-1)*CC(I,K,3)
            CI3 = WA2(I-2)*CC(I,K,3)-WA2(I-1)*CC(I-1,K,3)
            CR4 = WA3(I-2)*CC(I-1,K,4)+WA3(I-1)*CC(I,K,4)
            CI4 = WA3(I-2)*CC(I,K,4)-WA3(I-1)*CC(I-1,K,4)
            TR1 = CR2+CR4
            TR4 = CR4-CR2
            TI1 = CI2+CI4
            TI4 = CI2-CI4
            TI2 = CC(I,K,1)+CI3
            TI3 = CC(I,K,1)-CI3
            TR2 = CC(I-1,K,1)+CR3
            TR3 = CC(I-1,K,1)-CR3
            CH(I-1,1,K) = TR1+TR2
            CH(IC-1,4,K) = TR2-TR1
            CH(I,1,K) = TI1+TI2
            CH(IC,4,K) = TI1-TI2
            CH(I-1,3,K) = TI4+TR3
            CH(IC-1,2,K) = TR3-TI4
            CH(I,3,K) = TR4+TI3
            CH(IC,2,K) = TR4-TI3
  103    CONTINUE
  104 CONTINUE
      IF (MOD(IDO,2) .EQ. 1) RETURN
  105 CONTINUE
      DO 106 K=1,L1
         TI1 = -HSQT2*(CC(IDO,K,2)+CC(IDO,K,4))
         TR1 = HSQT2*(CC(IDO,K,2)-CC(IDO,K,4))
         CH(IDO,1,K) = TR1+CC(IDO,K,1)
         CH(IDO,3,K) = CC(IDO,K,1)-TR1
         CH(1,2,K) = TI1-CC(IDO,K,3)
         CH(1,4,K) = TI1+CC(IDO,K,3)
  106 CONTINUE
  107 RETURN
      END
      SUBROUTINE R8ADF5 (IDO,L1,CC,CH,WA1,WA2,WA3,WA4)
      implicit real*8 (A-H,O-Z)
      IMPLICIT INTEGER (I-N)
      DIMENSION       CC(IDO,L1,5)           ,CH(IDO,5,L1)           ,
     1                WA1(*)     ,WA2(*)     ,WA3(*)     ,WA4(*)
      DATA TR11,TI11,TR12,TI12 /.309016994374947D0,.951056516295154D0,
     1-.809016994374947D0,.587785252292473D0/
      DO 101 K=1,L1
         CR2 = CC(1,K,5)+CC(1,K,2)
         CI5 = CC(1,K,5)-CC(1,K,2)
         CR3 = CC(1,K,4)+CC(1,K,3)
         CI4 = CC(1,K,4)-CC(1,K,3)
         CH(1,1,K) = CC(1,K,1)+CR2+CR3
         CH(IDO,2,K) = CC(1,K,1)+TR11*CR2+TR12*CR3
         CH(1,3,K) = TI11*CI5+TI12*CI4
         CH(IDO,4,K) = CC(1,K,1)+TR12*CR2+TR11*CR3
         CH(1,5,K) = TI12*CI5-TI11*CI4
  101 CONTINUE
      IF (IDO .EQ. 1) RETURN
      IDP2 = IDO+2
      DO 103 K=1,L1
         DO 102 I=3,IDO,2
            IC = IDP2-I
            DR2 = WA1(I-2)*CC(I-1,K,2)+WA1(I-1)*CC(I,K,2)
            DI2 = WA1(I-2)*CC(I,K,2)-WA1(I-1)*CC(I-1,K,2)
            DR3 = WA2(I-2)*CC(I-1,K,3)+WA2(I-1)*CC(I,K,3)
            DI3 = WA2(I-2)*CC(I,K,3)-WA2(I-1)*CC(I-1,K,3)
            DR4 = WA3(I-2)*CC(I-1,K,4)+WA3(I-1)*CC(I,K,4)
            DI4 = WA3(I-2)*CC(I,K,4)-WA3(I-1)*CC(I-1,K,4)
            DR5 = WA4(I-2)*CC(I-1,K,5)+WA4(I-1)*CC(I,K,5)
            DI5 = WA4(I-2)*CC(I,K,5)-WA4(I-1)*CC(I-1,K,5)
            CR2 = DR2+DR5
            CI5 = DR5-DR2
            CR5 = DI2-DI5
            CI2 = DI2+DI5
            CR3 = DR3+DR4
            CI4 = DR4-DR3
            CR4 = DI3-DI4
            CI3 = DI3+DI4
            CH(I-1,1,K) = CC(I-1,K,1)+CR2+CR3
            CH(I,1,K) = CC(I,K,1)+CI2+CI3
            TR2 = CC(I-1,K,1)+TR11*CR2+TR12*CR3
            TI2 = CC(I,K,1)+TR11*CI2+TR12*CI3
            TR3 = CC(I-1,K,1)+TR12*CR2+TR11*CR3
            TI3 = CC(I,K,1)+TR12*CI2+TR11*CI3
            TR5 = TI11*CR5+TI12*CR4
            TI5 = TI11*CI5+TI12*CI4
            TR4 = TI12*CR5-TI11*CR4
            TI4 = TI12*CI5-TI11*CI4
            CH(I-1,3,K) = TR2+TR5
            CH(IC-1,2,K) = TR2-TR5
            CH(I,3,K) = TI2+TI5
            CH(IC,2,K) = TI5-TI2
            CH(I-1,5,K) = TR3+TR4
            CH(IC-1,4,K) = TR3-TR4
            CH(I,5,K) = TI3+TI4
            CH(IC,4,K) = TI4-TI3
  102    CONTINUE
  103 CONTINUE
      RETURN
      END
      SUBROUTINE R8ADFG (IDO,IP,L1,IDL1,CC,C1,C2,CH,CH2,WA)
      implicit real*8 (A-H,O-Z)
      IMPLICIT INTEGER (I-N)
      DIMENSION       CH(IDO,L1,IP)          ,CC(IDO,IP,L1)          ,
     1                C1(IDO,L1,IP)          ,C2(IDL1,IP),
     2                CH2(IDL1,IP)           ,WA(*)
      DATA TPI/6.28318530717959D0/
      ARG = TPI/FLOAT(IP)
      DCP = COS(ARG)
      DSP = SIN(ARG)
      IPPH = (IP+1)/2
      IPP2 = IP+2
      IDP2 = IDO+2
      NBD = (IDO-1)/2
      IF (IDO .EQ. 1) GO TO 119
      DO 101 IK=1,IDL1
         CH2(IK,1) = C2(IK,1)
  101 CONTINUE
      DO 103 J=2,IP
         DO 102 K=1,L1
            CH(1,K,J) = C1(1,K,J)
  102    CONTINUE
  103 CONTINUE
      IF (NBD .GT. L1) GO TO 107
      IS = -IDO
      DO 106 J=2,IP
         IS = IS+IDO
         IDIJ = IS
         DO 105 I=3,IDO,2
            IDIJ = IDIJ+2
            DO 104 K=1,L1
               CH(I-1,K,J) = WA(IDIJ-1)*C1(I-1,K,J)+WA(IDIJ)*C1(I,K,J)
               CH(I,K,J) = WA(IDIJ-1)*C1(I,K,J)-WA(IDIJ)*C1(I-1,K,J)
  104       CONTINUE
  105    CONTINUE
  106 CONTINUE
      GO TO 111
  107 IS = -IDO
      DO 110 J=2,IP
         IS = IS+IDO
         DO 109 K=1,L1
            IDIJ = IS
            DO 108 I=3,IDO,2
               IDIJ = IDIJ+2
               CH(I-1,K,J) = WA(IDIJ-1)*C1(I-1,K,J)+WA(IDIJ)*C1(I,K,J)
               CH(I,K,J) = WA(IDIJ-1)*C1(I,K,J)-WA(IDIJ)*C1(I-1,K,J)
  108       CONTINUE
  109    CONTINUE
  110 CONTINUE
  111 IF (NBD .LT. L1) GO TO 115
      DO 114 J=2,IPPH
         JC = IPP2-J
         DO 113 K=1,L1
            DO 112 I=3,IDO,2
               C1(I-1,K,J) = CH(I-1,K,J)+CH(I-1,K,JC)
               C1(I-1,K,JC) = CH(I,K,J)-CH(I,K,JC)
               C1(I,K,J) = CH(I,K,J)+CH(I,K,JC)
               C1(I,K,JC) = CH(I-1,K,JC)-CH(I-1,K,J)
  112       CONTINUE
  113    CONTINUE
  114 CONTINUE
      GO TO 121
  115 DO 118 J=2,IPPH
         JC = IPP2-J
         DO 117 I=3,IDO,2
            DO 116 K=1,L1
               C1(I-1,K,J) = CH(I-1,K,J)+CH(I-1,K,JC)
               C1(I-1,K,JC) = CH(I,K,J)-CH(I,K,JC)
               C1(I,K,J) = CH(I,K,J)+CH(I,K,JC)
               C1(I,K,JC) = CH(I-1,K,JC)-CH(I-1,K,J)
  116       CONTINUE
  117    CONTINUE
  118 CONTINUE
      GO TO 121
  119 DO 120 IK=1,IDL1
         C2(IK,1) = CH2(IK,1)
  120 CONTINUE
  121 DO 123 J=2,IPPH
         JC = IPP2-J
         DO 122 K=1,L1
            C1(1,K,J) = CH(1,K,J)+CH(1,K,JC)
            C1(1,K,JC) = CH(1,K,JC)-CH(1,K,J)
  122    CONTINUE
  123 CONTINUE
C
      AR1 = 1.D0
      AI1 = 0.D0
      DO 127 L=2,IPPH
         LC = IPP2-L
         AR1H = DCP*AR1-DSP*AI1
         AI1 = DCP*AI1+DSP*AR1
         AR1 = AR1H
         DO 124 IK=1,IDL1
            CH2(IK,L) = C2(IK,1)+AR1*C2(IK,2)
            CH2(IK,LC) = AI1*C2(IK,IP)
  124    CONTINUE
         DC2 = AR1
         DS2 = AI1
         AR2 = AR1
         AI2 = AI1
         DO 126 J=3,IPPH
            JC = IPP2-J
            AR2H = DC2*AR2-DS2*AI2
            AI2 = DC2*AI2+DS2*AR2
            AR2 = AR2H
            DO 125 IK=1,IDL1
               CH2(IK,L) = CH2(IK,L)+AR2*C2(IK,J)
               CH2(IK,LC) = CH2(IK,LC)+AI2*C2(IK,JC)
  125       CONTINUE
  126    CONTINUE
  127 CONTINUE
      DO 129 J=2,IPPH
         DO 128 IK=1,IDL1
            CH2(IK,1) = CH2(IK,1)+C2(IK,J)
  128    CONTINUE
  129 CONTINUE
C
      IF (IDO .LT. L1) GO TO 132
      DO 131 K=1,L1
         DO 130 I=1,IDO
            CC(I,1,K) = CH(I,K,1)
  130    CONTINUE
  131 CONTINUE
      GO TO 135
  132 DO 134 I=1,IDO
         DO 133 K=1,L1
            CC(I,1,K) = CH(I,K,1)
  133    CONTINUE
  134 CONTINUE
  135 DO 137 J=2,IPPH
         JC = IPP2-J
         J2 = J+J
         DO 136 K=1,L1
            CC(IDO,J2-2,K) = CH(1,K,J)
            CC(1,J2-1,K) = CH(1,K,JC)
  136    CONTINUE
  137 CONTINUE
      IF (IDO .EQ. 1) RETURN
      IF (NBD .LT. L1) GO TO 141
      DO 140 J=2,IPPH
         JC = IPP2-J
         J2 = J+J
         DO 139 K=1,L1
            DO 138 I=3,IDO,2
               IC = IDP2-I
               CC(I-1,J2-1,K) = CH(I-1,K,J)+CH(I-1,K,JC)
               CC(IC-1,J2-2,K) = CH(I-1,K,J)-CH(I-1,K,JC)
               CC(I,J2-1,K) = CH(I,K,J)+CH(I,K,JC)
               CC(IC,J2-2,K) = CH(I,K,JC)-CH(I,K,J)
  138       CONTINUE
  139    CONTINUE
  140 CONTINUE
      RETURN
  141 DO 144 J=2,IPPH
         JC = IPP2-J
         J2 = J+J
         DO 143 I=3,IDO,2
            IC = IDP2-I
            DO 142 K=1,L1
               CC(I-1,J2-1,K) = CH(I-1,K,J)+CH(I-1,K,JC)
               CC(IC-1,J2-2,K) = CH(I-1,K,J)-CH(I-1,K,JC)
               CC(I,J2-1,K) = CH(I,K,J)+CH(I,K,JC)
               CC(IC,J2-2,K) = CH(I,K,JC)-CH(I,K,J)
  142       CONTINUE
  143    CONTINUE
  144 CONTINUE
      RETURN
      END
      SUBROUTINE R8FFTF1 (N,C,CH,WA,IFAC)
      implicit real*8 (A-H,O-Z)
      IMPLICIT INTEGER (I-N)
      DIMENSION       CH(*)      ,C(*)       ,WA(*)      ,IFAC(*)
      NF = IFAC(2)
      NA = 1
      L2 = N
      IW = N
      DO 111 K1=1,NF
         KH = NF-K1
         IP = IFAC(KH+3)
         L1 = L2/IP
         IDO = N/L2
         IDL1 = IDO*L1
         IW = IW-(IP-1)*IDO
         NA = 1-NA
         IF (IP .NE. 4) GO TO 102
         IX2 = IW+IDO
         IX3 = IX2+IDO
         IF (NA .NE. 0) GO TO 101
         CALL R8ADF4 (IDO,L1,C,CH,WA(IW),WA(IX2),WA(IX3))
         GO TO 110
  101    CALL R8ADF4 (IDO,L1,CH,C,WA(IW),WA(IX2),WA(IX3))
         GO TO 110
  102    IF (IP .NE. 2) GO TO 104
         IF (NA .NE. 0) GO TO 103
         CALL R8ADF2 (IDO,L1,C,CH,WA(IW))
         GO TO 110
  103    CALL R8ADF2 (IDO,L1,CH,C,WA(IW))
         GO TO 110
  104    IF (IP .NE. 3) GO TO 106
         IX2 = IW+IDO
         IF (NA .NE. 0) GO TO 105
         CALL R8ADF3 (IDO,L1,C,CH,WA(IW),WA(IX2))
         GO TO 110
  105    CALL R8ADF3 (IDO,L1,CH,C,WA(IW),WA(IX2))
         GO TO 110
  106    IF (IP .NE. 5) GO TO 108
         IX2 = IW+IDO
         IX3 = IX2+IDO
         IX4 = IX3+IDO
         IF (NA .NE. 0) GO TO 107
         CALL R8ADF5 (IDO,L1,C,CH,WA(IW),WA(IX2),WA(IX3),WA(IX4))
         GO TO 110
  107    CALL R8ADF5 (IDO,L1,CH,C,WA(IW),WA(IX2),WA(IX3),WA(IX4))
         GO TO 110
  108    IF (IDO .EQ. 1) NA = 1-NA
         IF (NA .NE. 0) GO TO 109
         CALL R8ADFG (IDO,IP,L1,IDL1,C,C,C,CH,CH,WA(IW))
         NA = 1
         GO TO 110
  109    CALL R8ADFG (IDO,IP,L1,IDL1,CH,CH,CH,C,C,WA(IW))
         NA = 0
  110    L2 = L1
  111 CONTINUE
      IF (NA .EQ. 1) RETURN
      DO 112 I=1,N
         C(I) = CH(I)
  112 CONTINUE
      RETURN
      END
C     SUBROUTINE R8FFTI (N,WSAVE)
C     implicit real*8 (A-H,O-Z)
C     DIMENSION       WSAVE(1)
C     IF (N .EQ. 1) RETURN
C     CALL R8FFTI1 (N,WSAVE(N+1),WSAVE(2*N+1))
C     RETURN
C     END
      SUBROUTINE R8FFTI1 (N,WA,IFAC)
      implicit real*8 (A-H,O-Z)
      IMPLICIT INTEGER (I-N)
      DIMENSION       WA(*)      ,IFAC(*)    ,NTRYH(4)
      DATA NTRYH(1),NTRYH(2),NTRYH(3),NTRYH(4)/4,2,3,5/
      NL = N
      NF = 0
      J = 0
  101 J = J+1
      IF (J-4) 102,102,103
  102 NTRY = NTRYH(J)
      GO TO 104
  103 NTRY = NTRY+2
  104 NQ = NL/NTRY
      NR = NL-NTRY*NQ
      IF (NR) 101,105,101
  105 NF = NF+1
      IFAC(NF+2) = NTRY
      NL = NQ
      IF (NTRY .NE. 2) GO TO 107
      IF (NF .EQ. 1) GO TO 107
      DO 106 I=2,NF
         IB = NF-I+2
         IFAC(IB+2) = IFAC(IB+1)
  106 CONTINUE
      IFAC(3) = 2
  107 IF (NL .NE. 1) GO TO 104
      IFAC(1) = N
      IFAC(2) = NF
      TPI = 6.28318530717959D0
      ARGH = TPI/FLOAT(N)
      IS = 0
      NFM1 = NF-1
      L1 = 1
      IF (NFM1 .EQ. 0) RETURN
      DO 110 K1=1,NFM1
         IP = IFAC(K1+2)
         LD = 0
         L2 = L1*IP
         IDO = N/L2
         IPM = IP-1
         DO 109 J=1,IPM
            LD = LD+L1
            I = IS
            ARGLD = FLOAT(LD)*ARGH
            FI = 0.D0
            DO 108 II=3,IDO,2
               I = I+2
               FI = FI+1.D0
               ARG = FI*ARGLD
               WA(I-1) = COS(ARG)
               WA(I) = SIN(ARG)
  108       CONTINUE
            IS = IS+IDO
  109    CONTINUE
         L1 = L2
  110 CONTINUE
      RETURN

#endif /* ALLOW_ZONAL_FILT */

      END

#include "ATM_CPL_OPTIONS.h"

CBOP
C     !ROUTINE: ATM_EXPORT_FIELDS
C     !INTERFACE:
      SUBROUTINE ATM_EXPORT_FIELDS( myIter, myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE ATM_EXPORT_FIELDS
C     | o Routine for exporting atmos. surface coupling fields
C     |   to coupling layer.
C     *==========================================================*
C     | This version talks to the MIT Coupler. It uses the MIT
C     | Coupler "checkpoint1" library calls.
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "CPL_PARAMS.h"
#include "ATMCPL.h"
#include "ATMIDS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     myIter  :: Current timestep number.
C     myThid  :: Thread number for this instance of the routine.
      INTEGER myIter
      INTEGER myThid
CEOP

#ifdef COMPONENT_MODULE
C     !LOCAL VARIABLES:
C     == Local variables ==
C     msgBuf  :: Informational/error message buffer
c     CHARACTER*(MAX_LEN_MBUF) msgBuf

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C-    Send Atmospheric fields to coupling layer
C  Note: 1) Information is sent on the atmos. model grid.
C        2) MIT Coupler checkpoint1 does not allow asynchronous posting of
C          data, so ordering has to be consistent with coupling layer ordering

C-    export Sea-Level pressure:
      CALL ATM_EXPORT_FLD( atmSLPrName,
     U                     atmSLPr, atmSLPrTime, myThid )
C-    export Net surface heat flux:
      CALL ATM_EXPORT_FLD( atmHeatFluxName,
     U                     heatFlux, HeatFluxTime, myThid )
C-    export Net Short-Wave surface heat flux:
      CALL ATM_EXPORT_FLD( atmQshortWaveName,
     U                     qShortWave, qShortWaveTime, myThid )
C-    export surface wind stress, Zonal & Meridional components:
      CALL ATM_EXPORT_FLD( atmTauXName,
     U                     tauX, tauXTime, myThid )
      CALL ATM_EXPORT_FLD( atmTauYName,
     U                     tauY, tauYTime, myThid )
C-    export Net fresh water flux (Evap - Precip):
      CALL ATM_EXPORT_FLD( atmEvMPrName,
     U                     EvMPrFlux, EvMPrTime, myThid )
#ifdef ALLOW_LAND
      IF ( atm_cplExch_RunOff ) THEN
C-    export Run Off fresh water flux:
       CALL ATM_EXPORT_FLD( atmRunOffName,
     U                      RunOffFlux, RunOffTime, myThid )
C-    export Energy flux associated with Run Off:
       CALL ATM_EXPORT_FLD( atmROEnFxName,
     U                      RunOffEnFx, ROEnFxTime, myThid )
      ENDIF
#endif /* ALLOW_LAND */
#ifdef ALLOW_THSICE
      IF ( atm_cplExch1W_sIce ) THEN
C-    export Salt flux (related to sea-ice melting/freezing):
       CALL ATM_EXPORT_FLD( atmSaltFxName,
     U                      iceSaltFlx, saltFxTime, myThid )
C-    export Sea-Ice Mass:
       CALL ATM_EXPORT_FLD( atmSIceMassName,
     U                      seaIceMass, sIceMassTime, myThid )
      ENDIF
      IF ( atm_cplExch_SaltPl ) THEN
C-    export Salt-Plume flux:
       CALL ATM_EXPORT_FLD( atmSaltPlmFlxName,
     U                      saltPlmFlx_cpl, saltPlmFlxTime, myThid )
      ENDIF
#endif /* ALLOW_THSICE */

#ifdef ALLOW_AIM
      IF ( atm_cplExch_DIC ) THEN
C-    export atmospheric CO2:
       CALL ATM_EXPORT_FLD( atmAirCO2Name,
     U                      airCO2, airCO2Time, myThid )

C-    export surface wind speed:
       CALL ATM_EXPORT_FLD( atmWindSpdName,
     U                      sWSpeed, sWSpeedTime, myThid )
      ENDIF
#endif /* ALLOW_AIM */

#ifdef ALLOW_THSICE
      IF ( ( atm_cplExch1W_sIce.AND.atm_cplExch_DIC )
     &  .OR. atm_cplExch2W_sIce ) THEN
C-    export seaice fraction:
       CALL ATM_EXPORT_FLD( atmSIceFracName,
     U                      sIceFrac_cpl, sIceFracTime, myThid )
      ENDIF
      IF ( atm_cplExch2W_sIce ) THEN
C-    export seaice thickness:
       CALL ATM_EXPORT_FLD( atmSIceThickName,
     U                      sIceThick_cpl, sIceThickTime, myThid )
C-    export snow thickness:
       CALL ATM_EXPORT_FLD( atmSIceSnowName,
     U                      sIceSnowH_cpl, sIceSnowHTime, myThid )
C-    export seaice enthalpy (layer 1):
       CALL ATM_EXPORT_FLD( atmSIceQ1Name,
     U                      sIceQ1_cpl, sIceQ1Time, myThid )
C-    export seaice enthalpy (layer 2):
       CALL ATM_EXPORT_FLD( atmSIceQ2Name,
     U                      sIceQ2_cpl, sIceQ2Time, myThid )
      ENDIF
#endif /* ALLOW_THSICE */

#endif /* COMPONENT_MODULE */

      RETURN
      END

#include "CPP_OPTIONS.h"

CBOP
C     !ROUTINE: CALC_DIV_GHAT
C     !INTERFACE:
      SUBROUTINE CALC_DIV_GHAT(
     I                bi,bj,k,
     U                cg2d_b, cg3d_b,
     I                myThid)
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R CALC_DIV_GHAT
C     | o Form the right hand-side of the surface pressure eqn.
C     *==========================================================*
C     | Right hand side of pressure equation is divergence
C     | of veclocity tendency (GHAT) term along with a relaxation
C     | term equal to the barotropic flow field divergence.
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "DYNVARS.h"
#ifdef ALLOW_ADDFLUID
# include "FFIELDS.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     bi, bj  :: tile indices
C     k       :: Index of layer.
C     cg2d_b  :: Conjugate Gradient 2-D solver : Right-hand side vector
C     cg3d_b  :: Conjugate Gradient 3-D solver : Right-hand side vector
C     myThid  :: Instance number for this call of CALC_DIV_GHAT
      INTEGER bi,bj
      INTEGER k
      _RL cg2d_b(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
#ifdef ALLOW_NONHYDROSTATIC
      _RL cg3d_b(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
#else
      _RL cg3d_b(1)
#endif
      INTEGER myThid

C     !LOCAL VARIABLES:
C     == Local variables ==
C     i,j    :: Loop counters
C     xA, yA :: Cell vertical face areas
C     pf     :: Intermediate array for building RHS source term.
      INTEGER i,j
      _RS xA (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RS yA (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL pf (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
#ifdef ALLOW_ADDFLUID
      _RL unitsFac
#endif
CEOP

C     Calculate vertical face areas
      DO j=1,sNy+1
        DO i=1,sNx+1
          xA(i,j) = _dyG(i,j,bi,bj)*deepFacC(k)
     &              *drF(k)*_hFacW(i,j,k,bi,bj)*rhoFacC(k)
          yA(i,j) = _dxG(i,j,bi,bj)*deepFacC(k)
     &              *drF(k)*_hFacS(i,j,k,bi,bj)*rhoFacC(k)
        ENDDO
      ENDDO

C--   Pressure equation source term
C     Term is the vertical integral of the divergence of the
C     time tendency terms along with a relaxation term that
C     pulls div(U) + dh/dt back toward zero.

C     Implicit treatment of the Barotropic Flow Divergence
      DO j=1,sNy
       DO i=1,sNx+1
        pf(i,j) = implicDiv2Dflow*xA(i,j)*gU(i,j,k,bi,bj) / deltaTMom
       ENDDO
      ENDDO
      DO j=1,sNy
       DO i=1,sNx
        cg2d_b(i,j,bi,bj) = cg2d_b(i,j,bi,bj) +
     &   pf(i+1,j)-pf(i,j)
       ENDDO
      ENDDO

#ifdef ALLOW_NONHYDROSTATIC
      IF (use3Dsolver) THEN
       DO j=1,sNy
        DO i=1,sNx
         cg3d_b(i,j,k,bi,bj) = ( pf(i+1,j)-pf(i,j) )
        ENDDO
       ENDDO
      ENDIF
#endif

C     Implicit treatment of the Barotropic Flow Divergence
      DO j=1,sNy+1
       DO i=1,sNx
        pf(i,j) = implicDiv2Dflow*yA(i,j)*gV(i,j,k,bi,bj) / deltaTMom
       ENDDO
      ENDDO
      DO j=1,sNy
       DO i=1,sNx
        cg2d_b(i,j,bi,bj) = cg2d_b(i,j,bi,bj) +
     &   pf(i,j+1)-pf(i,j)
       ENDDO
      ENDDO

#ifdef ALLOW_NONHYDROSTATIC
      IF (use3Dsolver) THEN
       DO j=1,sNy
        DO i=1,sNx
         cg3d_b(i,j,k,bi,bj) = cg3d_b(i,j,k,bi,bj)
     &                       + ( pf(i,j+1)-pf(i,j) )
        ENDDO
       ENDDO
      ENDIF
#endif

#ifdef ALLOW_ADDFLUID
      unitsFac = mass2rUnit/deltaTMom
      IF ( exactConserv ) unitsFac = unitsFac*implicDiv2Dflow
      IF ( selectAddFluid.GE.1 ) THEN
        DO j=1,sNy
         DO i=1,sNx
          cg2d_b(i,j,bi,bj) = cg2d_b(i,j,bi,bj)
     &         - addMass(i,j,k,bi,bj)*unitsFac
         ENDDO
        ENDDO
#ifdef ALLOW_NONHYDROSTATIC
       IF (use3Dsolver) THEN
        DO j=1,sNy
         DO i=1,sNx
          cg3d_b(i,j,k,bi,bj) = cg3d_b(i,j,k,bi,bj)
     &         - addMass(i,j,k,bi,bj)*unitsFac
         ENDDO
        ENDDO
       ENDIF
#endif
      ENDIF
#endif /* ALLOW_ADDFLUID */

      RETURN
      END

#include "GCHEM_OPTIONS.h"

CBOP
C !ROUTINE: GCHEM_ADD_TENDENCY

C !INTERFACE: ==========================================================
      SUBROUTINE GCHEM_ADD_TENDENCY(
     U                     gPtracer,
     I                     iMin,iMax,jMin,jMax, k, bi, bj,
     I                     iTr, myTime, myIter, myThid )

C !DESCRIPTION:
C     In the case of a tracer not using GCHEM_SEPARATE_FORCING,
C     GCHEM_ADD_TENDENCY will update passive tracer tendencies gPtr with
C     gchemTendency, the latter having been computed in GCHEM_CALC_TENDENDY,
C     so that they will be incorporated into regular timestepping in
C     PTRACERS_INTERGRATE.

C !USES: ===============================================================
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GCHEM.h"
#include "GCHEM_SIZE.h"
#include "GCHEM_FIELDS.h"

C !INPUT/OUTPUT PARAMETERS: ============================================
C  gPtracer     :: the tendency array
C  k            :: vertical level
C  bi,bj        :: tile indices
C  iTr          :: ptracer number
C  myTime       :: current time
C  myIter       :: current timestep
C  myThid       :: thread number
      _RL gPtracer   (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER iMin,iMax,jMin,jMax
      INTEGER k, bi, bj, iTr
      _RL myTime
      INTEGER myIter, myThid
CEOP

#ifdef GCHEM_ADD2TR_TENDENCY
C !LOCAL VARIABLES: ====================================================
C  jTr          :: number of corresponding tracer tendency (in gchemTendency)
C  i,j          :: loop indices
      INTEGER jTr
      INTEGER i,j

C     Apply the tendencies computed in GCHEM_CALC_TENDENCY to the passive
C     tracers tendendy terms. The part of the code could also go into
C     ptracers_forcing and replace the call to gchem_add_tendency there,
C     but this way, no gchem-related header files and CPP-flags are required
C     within ptracers_forcing.
      IF ( iTr.GT.gchem_sepFTr_num .AND.
     &     iTr.LE.gchem_Tracer_num ) THEN
       jTr = iTr - gchem_sepFTr_num
       DO j=jMin,jMax
        DO i=iMin,iMax
         gPtracer(i,j) = gPtracer(i,j)
     &                 + gchemTendency(i,j,k,bi,bj,jTr)
        ENDDO
       ENDDO
      ENDIF
#endif /* GCHEM_ADD2TR_TENDENCY */

      RETURN
      END

#include "CTRL_OPTIONS.h"

      subroutine ctrl_set_pack_xyz(
     &     cunit, ivar, fname, masktype, weighttype,
     &     weightfld, lxxadxx, myThid )

c     ==================================================================
c     SUBROUTINE ctrl_set_pack_xyz
c     ==================================================================
c
c     o Compress the control vector such that only ocean points are
c       written to file.
c
c     o Use a more precise nondimensionalization that depends on (x,y)
c       Added weighttype to the argument list so that I can geographically
c       vary the nondimensionalization.
c       gebbie@mit.edu, 18-Mar-2003
c
c     ==================================================================

      implicit none

c     == global variables ==

#include "EEPARAMS.h"
#include "SIZE.h"
#include "PARAMS.h"
#include "GRID.h"

#include "CTRL_SIZE.h"
#include "CTRL.h"
#include "OPTIMCYCLE.h"

c     == routine arguments ==

      integer cunit
      integer ivar
      character*(MAX_LEN_FNAM) fname
      character*(  9) masktype
      character*(MAX_LEN_FNAM) weighttype
      _RL     weightfld( Nr,nSx,nSy )
      logical lxxadxx
      integer myThid

#ifndef EXCLUDE_CTRL_PACK
c     == external ==
      integer  ilnblnk
      external ilnblnk

c     == local variables ==
      integer bi,bj
      integer i,j,k
      integer ii, irec
      integer cbuffindex
      real*4 cbuff( sNx*nSx*nPx*sNy*nSy*nPy )
      character*(MAX_LEN_FNAM) cfile2, cfile3
C========================================================================
# ifndef ALLOW_PACKUNPACK_METHOD2
      integer ip,jp
      integer itlo,ithi
      integer jtlo,jthi
      integer jmin,jmax
      integer imin,imax
      _RL     globmsk  ( sNx,nSx,nPx,sNy,nSy,nPy,Nr )
      _RL     globfld3d( sNx,nSx,nPx,sNy,nSy,nPy,Nr )
#ifdef CTRL_PACK_PRECISE
      integer il
      character*(MAX_LEN_FNAM) weightname
      _RL   weightfld3d( sNx,nSx,nPx,sNy,nSy,nPy,Nr )
#endif
      real*4 globfldtmp2( sNx,nSx,nPx,sNy,nSy,nPy )
      real*4 globfldtmp3( sNx,nSx,nPx,sNy,nSy,nPy )
      _RL delZnorm
      integer reclen, irectrue
      integer cunit2, cunit3
# else /* ALLOW_PACKUNPACK_METHOD2 */
      integer il
      _RL msk3d(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      real*8 msk2d_buf(sNx,sNy,nSx,nSy)
      real*8 msk2d_buf_glo(Nx,Ny)
      real*8 fld2d_buf(sNx,sNy,nSx,nSy)
      real*8 fld2d_buf_glo(Nx,Ny)
      _RL fld3dDim(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      _RL fld3dNodim(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
#ifdef CTRL_PACK_PRECISE
      _RL wei3d(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
#endif
      _RL delZnorm
      _RL dummy
# endif /* ALLOW_PACKUNPACK_METHOD2 */
c     == end of interface ==

# ifndef ALLOW_PACKUNPACK_METHOD2
      jtlo = 1
      jthi = nSy
      itlo = 1
      ithi = nSx
      jmin = 1
      jmax = sNy
      imin = 1
      imax = sNx

#ifdef CTRL_DELZNORM
      delZnorm = 0.
      do k = 1, Nr
         delZnorm = delZnorm + delR(k)/FLOAT(Nr)
      enddo
#endif

c     Initialise temporary file
      do k = 1,Nr
       do jp = 1,nPy
        do bj = jtlo,jthi
         do j = jmin,jmax
          do ip = 1,nPx
           do bi = itlo,ithi
            do i = imin,imax
             globfld3d  (i,bi,ip,j,bj,jp,k) = 0. _d 0
             globmsk    (i,bi,ip,j,bj,jp,k) = 0. _d 0
             globfldtmp2(i,bi,ip,j,bj,jp)   = 0. _d 0
             globfldtmp3(i,bi,ip,j,bj,jp)   = 0. _d 0
            enddo
           enddo
          enddo
         enddo
        enddo
       enddo
      enddo

c--   Only the master thread will do I/O.
      _BEGIN_MASTER( myThid )

      if ( doPackDiag ) then
         if ( lxxadxx ) then
            write(cfile2,'(a,I3.3,a,I4.4,a)')
     &           'diag_pack_nonout_ctrl_',
     &           ivar, '_', optimcycle, '.bin'
            write(cfile3,'(a,I3.3,a,I4.4,a)')
     &           'diag_pack_dimout_ctrl_',
     &           ivar, '_', optimcycle, '.bin'
         else
            write(cfile2,'(a,I3.3,a,I4.4,a)')
     &           'diag_pack_nonout_grad_',
     &           ivar, '_', optimcycle, '.bin'
            write(cfile3,'(a,I3.3,a,I4.4,a)')
     &           'diag_pack_dimout_grad_',
     &           ivar, '_', optimcycle, '.bin'
         endif

         reclen = FLOAT(sNx*nSx*nPx*sNy*nSy*nPy*4)
         call mdsfindunit( cunit2, myThid )
         open( cunit2, file=cfile2, status='unknown',
     &        access='direct', recl=reclen )
         call mdsfindunit( cunit3, myThid )
         open( cunit3, file=cfile3, status='unknown',
     &        access='direct', recl=reclen )
      endif

#ifdef CTRL_PACK_PRECISE
      if (weighttype.NE.' ') then
       il=ilnblnk( weighttype)
       write(weightname,'(a)') weighttype(1:il)
       call MDSREADFIELD_3D_GL(
     &     weightname, ctrlprec, 'RL',
     &     Nr, weightfld3d, 1, myThid)
      else
       do k = 1,Nr
        do jp = 1,nPy
         do bj = jtlo,jthi
          do j = jmin,jmax
           do ip = 1,nPx
            do bi = itlo,ithi
             do i = imin,imax
              weightfld3d(i,bi,ip,j,bj,jp,k) = 1. _d 0
             enddo
            enddo
           enddo
          enddo
         enddo
        enddo
       enddo
      endif
#endif

      call MDSREADFIELD_3D_GL(
     &     masktype, ctrlprec, 'RL',
     &     Nr, globmsk, 1, myThid)

      do irec = 1, ncvarrecs(ivar)

       call MDSREADFIELD_3D_GL( fname, ctrlprec, 'RL',
     &      Nr, globfld3d, irec, myThid)

#ifndef ALLOW_ADMTLM
       write(cunit) ncvarindex(ivar)
       write(cunit) 1
       write(cunit) 1
#endif
       do k = 1, Nr
        irectrue = (irec-1)*Nr + k
        if ( doZscalePack ) then
         delZnorm = (delR(1)/delR(k))**delZexp
        else
         delZnorm = 1. _d 0
        endif
        cbuffindex = 0
        do jp = 1,nPy
         do bj = jtlo,jthi
          do j = jmin,jmax
           do ip = 1,nPx
            do bi = itlo,ithi
             do i = imin,imax
              if (globmsk(i,bi,ip,j,bj,jp,k) .ne. 0. ) then
               cbuffindex = cbuffindex + 1
cph(
               globfldtmp3(i,bi,ip,j,bj,jp) =
     &              globfld3d(i,bi,ip,j,bj,jp,k)
cph)
               cbuff(cbuffindex) = globfld3d(i,bi,ip,j,bj,jp,k)
#ifdef ALLOW_ADMTLM
               nveccount = nveccount + 1
               phtmpadmtlm(nveccount) = cbuff(cbuffindex)
#endif
              endif
             enddo
            enddo
           enddo
          enddo
         enddo
        enddo
c           --> check cbuffindex.
        if ( cbuffindex .gt. 0) then
#ifndef ALLOW_ADMTLM
         write(cunit) cbuffindex
         write(cunit) k
cph#endif
         write(cunit) (cbuff(ii), ii=1,cbuffindex)
#endif
        endif
c
        if ( doPackDiag ) then
         write(cunit2,rec=irectrue) globfldtmp2
         write(cunit3,rec=irectrue) globfldtmp3
        endif
c
       enddo
c
c     -- end of irec loop --
      enddo

      if ( doPackDiag ) then
       close ( cunit2 )
       close ( cunit3 )
      endif

      _END_MASTER( myThid )

# else /* ALLOW_PACKUNPACK_METHOD2 */

c-- part 1: preliminary reads and definitions

#ifdef CTRL_PACK_PRECISE
#ifdef ALLOW_AUTODIFF
      call active_read_xyz(weighttype, wei3d, 1,
     &    .FALSE., .FALSE., 0 , myThid, dummy)
#else
      CALL READ_REC_XYZ_RL( weighttype, wei3d, 1, 1, myThid )
#endif
#endif

#ifdef ALLOW_AUTODIFF
      call active_read_xyz(masktype, msk3d, 1,
     &    .FALSE., .FALSE., 0 , myThid, dummy)
#else
      CALL READ_REC_XYZ_RL( masktype, msk3d, 1, 1, myThid )
#endif

      if ( doPackDiag ) then
         il = ilnblnk( fname )
         if ( lxxadxx ) then
            write(cfile2,'(2a)') fname(1:il),'.pack_ctrl_adim'
            write(cfile3,'(2a)') fname(1:il),'.pack_ctrl_dim'
         else
            write(cfile2,'(2a)') fname(1:il),'.pack_grad_adim'
            write(cfile3,'(2a)') fname(1:il),'.pack_grad_dim'
         endif
      endif

c-- part 2: loop over records

      do irec = 1, ncvarrecs(ivar)

c-- 2.1:
       CALL READ_REC_3D_RL( fname, ctrlprec,
     &        Nr, fld3dDim, irec, 0, myThid)

c-- 2.2: normalize field if needed
       DO bj = myByLo(myThid), myByHi(myThid)
        DO bi = myBxLo(myThid), myBxHi(myThid)
         DO k=1,Nr
          if ( doZscalePack ) then
           delZnorm = (delR(1)/delR(k))**delZexp
          else
           delZnorm = 1. _d 0
          endif
          DO j=1,sNy
           DO i=1,sNx
            if (msk3d(i,j,k,bi,bj).EQ.0. _d 0) then
             fld3dDim(i,j,k,bi,bj)=0. _d 0
             fld3dNodim(i,j,k,bi,bj)=0. _d 0
            else
             fld3dNodim(i,j,k,bi,bj)=fld3dDim(i,j,k,bi,bj)
            endif
           ENDDO
          ENDDO
         ENDDO
        ENDDO
       ENDDO

c-- 2.3:
       if ( doPackDiag ) then
c error: twice the same one
        call WRITE_REC_3D_RL( cfile2, ctrlprec,
     &       Nr, fld3dNodim, irec, 0, myThid)
        call WRITE_REC_3D_RL( cfile3, ctrlprec,
     &       Nr, fld3dDim, irec, 0, myThid)
       endif

c-- 2.4: array -> buffer -> global buffer -> global file

#ifndef ALLOW_ADMTLM
       _BEGIN_MASTER( myThid )
       IF ( myProcId .eq. 0 ) THEN
        write(cunit) ncvarindex(ivar)
        write(cunit) 1
        write(cunit) 1
       ENDIF
       _END_MASTER( myThid )
       _BARRIER
#endif

       do k = 1, Nr

        CALL MDS_PASS_R8toRL( fld2d_buf, fld3dNodim,
     &                        0, 0, 1, k, Nr, 0, 0, .FALSE., myThid )
        CALL BAR2( myThid )
        CALL GATHER_2D_R8( fld2d_buf_glo, fld2d_buf,
     &       Nx,Ny,.FALSE.,.TRUE.,myThid)
        CALL BAR2( myThid )

        CALL MDS_PASS_R8toRL( msk2d_buf, msk3d,
     &                        0, 0, 1, k, Nr, 0, 0, .FALSE., myThid )
        CALL BAR2( myThid )
        CALL GATHER_2D_R8( msk2d_buf_glo, msk2d_buf,
     &                     Nx,Ny,.FALSE.,.TRUE.,myThid)
        CALL BAR2( myThid )

        _BEGIN_MASTER( myThid )
        cbuffindex = 0
        IF ( myProcId .eq. 0 ) THEN

         DO j=1,Ny
          DO i=1,Nx
           if (msk2d_buf_glo(i,j) .ne. 0. ) then
            cbuffindex = cbuffindex + 1
            cbuff(cbuffindex) = fld2d_buf_glo(i,j)
#ifdef ALLOW_ADMTLM
            nveccount = nveccount + 1
            phtmpadmtlm(nveccount) = cbuff(cbuffindex)
#endif
           endif
          ENDDO
         ENDDO

#ifndef ALLOW_ADMTLM
         if ( cbuffindex .gt. 0) then
          write(cunit) cbuffindex
          write(cunit) k
          write(cunit) (cbuff(ii), ii=1,cbuffindex)
         endif
#endif

        ENDIF
        _END_MASTER( myThid )
        _BARRIER

       enddo
      enddo

# endif /* ALLOW_PACKUNPACK_METHOD2 */
# endif /* EXCLUDE_CTRL_PACK */

      return
      end

#include "OPPS_OPTIONS.h"

      SUBROUTINE OPPS_CHECK( myThid )
C     *==========================================================*
C     | SUBROUTINE OPPS_CHECK                                    |
C     | o Validate basic package setup and inter-package         |
C     |   dependencies.                                          |
C     *==========================================================*
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"

C     === Routine arguments ===
C     myThid  :: my Thread Id number
      INTEGER myThid

#ifdef ALLOW_OPPS
C     === Local variables ===
C     msgBuf  :: Informational/error message buffer
      CHARACTER*(MAX_LEN_MBUF) msgBuf

      _BEGIN_MASTER(myThid)

      WRITE(msgBuf,'(A)') 'OPPS_CHECK: #define ALLOW_OPPS'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )

C     So far, OPPS works only with oceanic z-coordinates
      IF ( buoyancyRelation .NE. 'OCEANIC' ) THEN
         WRITE(msgBuf,'(A)')
     &      'OPPS works only with buoyancyRelation = ''OCEANIC'''
         CALL PRINT_ERROR( msgBuf, myThid )
         STOP 'ABNORMAL END: S/R OPPS_CHECK'
      ENDIF

C     OPPS needs convection turned off (will be packaged later)
      IF ( cAdjFreq.NE.0. .OR.
     &     ivdc_kappa.NE.0. ) THEN
         WRITE(msgBuf,'(A)') 'Some form of convection has been enabled'
         CALL PRINT_ERROR( msgBuf, myThid )
         STOP 'ABNORMAL END: S/R OPPS_CHECK'
      ENDIF

      IF ( useKPP ) THEN
         WRITE(msgBuf,'(A)')
     &      'OPPS and KPP cannot be turned on at the same time'
         CALL PRINT_ERROR( msgBuf, myThid )
         STOP 'ABNORMAL END: S/R OPPS_CHECK'
      ENDIF

      IF ( usePP81 ) THEN
         WRITE(msgBuf,'(A)')
     &      'OPPS and PP81 cannot be turned on at the same time'
         CALL PRINT_ERROR( msgBuf, myThid )
         STOP 'ABNORMAL END: S/R OPPS_CHECK'
      ENDIF

      IF ( useMY82 ) THEN
         WRITE(msgBuf,'(A)')
     &      'OPPS and MY82 cannot be turned on at the same time'
         CALL PRINT_ERROR( msgBuf, myThid )
         STOP 'ABNORMAL END: S/R OPPS_CHECK'
      ENDIF

      IF ( useGGL90 ) THEN
         WRITE(msgBuf,'(A)')
     &      'OPPS and GGL90 cannot be turned on at the same time'
         CALL PRINT_ERROR( msgBuf , 1)
         STOP 'ABNORMAL END: S/R OPPS_CHECK'
      ENDIF

      _END_MASTER(myThid)
#endif /* ALLOW_OPPS */

      RETURN
      END

#include "MNC_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 1
C !ROUTINE: MNC_CW_WRITE_GRID_INFO

C !INTERFACE:
      SUBROUTINE MNC_CW_WRITE_GRID_INFO(
     I     bfname,
     I     myThid )

C     !DESCRIPTION:
C     This subroutine writes all the grid information (\textit{eg.}
C     locations, spacings, areas, \textit{etc.}) to one grid file
C     (\texttt{grid.xxxxx.nc}) per tile.

C===================================================================
C  WARNING: This routine is not maintained since it is never called
C===================================================================

C     !USES:
      implicit none
#include "MNC_COMMON.h"
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"

C     !INPUT PARAMETERS:
      integer myThid
      character*(*) bfname
CEOP

C     !LOCAL VARIABLES:
      integer nf,nl

C     Functions
      integer IFNBLNK, ILNBLNK

      nf = IFNBLNK(bfname)
      nl = ILNBLNK(bfname)

C===================================================================
C  WARNING: This routine is not maintained since it is never called
C===================================================================
      STOP 'MNC_CW_WRITE_GRID_INFO is not maintained'

C     Create MNC definitions for GRID.h variables
      CALL MNC_CW_ADD_VNAME('rC', '-_-_--__C__-', 0,0, myThid)
      CALL MNC_CW_ADD_VNAME('rF', '-_-_--__I__-', 0,0, myThid)
      CALL MNC_CW_ADD_VNAME('drC', '-_-_--__C__-', 0,0, myThid)
      CALL MNC_CW_ADD_VNAME('drF', '-_-_--__C__-', 0,0, myThid)

      CALL MNC_CW_ADD_VNAME('xC', 'Cen_xy_Hn__-__-', 3,4, myThid)
      CALL MNC_CW_ADD_VNAME('yC', 'Cen_xy_Hn__-__-', 3,4, myThid)
      CALL MNC_CW_ADD_VNAME('xG', 'Cor_xy_Hn__-__-', 3,4, myThid)
      CALL MNC_CW_ADD_VNAME('yG', 'Cor_xy_Hn__-__-', 3,4, myThid)
      CALL MNC_CW_ADD_VNAME('dxC', 'Cen_xy_Hn__-__-', 3,4, myThid)
      CALL MNC_CW_ADD_VNAME('dyC', 'Cen_xy_Hn__-__-', 3,4, myThid)
      CALL MNC_CW_ADD_VNAME('dxF', 'Cen_xy_Hn__-__-', 3,4, myThid)
      CALL MNC_CW_ADD_VNAME('dyF', 'Cen_xy_Hn__-__-', 3,4, myThid)
      CALL MNC_CW_ADD_VNAME('dxG', 'Cen_xy_Hn__-__-', 3,4, myThid)
      CALL MNC_CW_ADD_VNAME('dyG', 'Cen_xy_Hn__-__-', 3,4, myThid)
      CALL MNC_CW_ADD_VNAME('dxV', 'U_xy_Hn__-__-', 3,4, myThid)
      CALL MNC_CW_ADD_VNAME('dyU', 'V_xy_Hn__-__-', 3,4, myThid)
      CALL MNC_CW_ADD_VNAME('rA', 'Cen_xy_Hn__-__-', 3,4, myThid)
      CALL MNC_CW_ADD_VNAME('rAw', 'Cen_xy_Hn__-__-', 3,4, myThid)
      CALL MNC_CW_ADD_VNAME('rAs', 'Cen_xy_Hn__-__-', 3,4, myThid)
      CALL MNC_CW_ADD_VNAME('rAz', 'Cen_xy_Hn__-__-', 3,4, myThid)
      CALL MNC_CW_ADD_VNAME('fCori', 'Cen_xy_Hn__-__-', 3,4, myThid)
      CALL MNC_CW_ADD_VNAME('fCoriG', 'Cen_xy_Hn__-__-', 3,4, myThid)
      CALL MNC_CW_ADD_VNAME('R_low', 'Cen_xy_Hn__-__-', 3,4, myThid)
      CALL MNC_CW_ADD_VNAME('Ro_surf', 'Cen_xy_Hn__-__-', 3,4, myThid)
      CALL MNC_CW_ADD_VNAME('HFacC', 'Cen_xy_Hn__C__-', 4,5, myThid)
      CALL MNC_CW_ADD_VNAME('HFacW', 'Cen_xy_Hn__C__-', 4,5, myThid)
      CALL MNC_CW_ADD_VNAME('HFacS', 'Cen_xy_Hn__C__-', 4,5, myThid)

      CALL MNC_CW_ADD_VATTR_TEXT('rC','description',
     &     'r of cell center',myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('rF','description',
     &     'r of cell face',myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('drC','description',
     &     'r cell center separation',myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('drF','description',
     &     'r cell face separation',myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('xC','description',
     &     'x of cell center',myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('yC','description',
     &     'y of cell center',myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('xG','description',
     &     'x of cell corner',myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('yG','description',
     &     'y of cell corner',myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('dxC','description',
     &     'x cell center separation',myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('dyC','description',
     &     'y cell center separation',myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('dxF','description',
     &     'x cell face separation',myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('dyF','description',
     &     'y cell face separation',myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('dxG','description',
     &     'x cell face separation',myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('dyG','description',
     &     'y cell face separation',myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('dxV','description',
     &     'x v-velocity separation',myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('dyU','description',
     &     'y u-velocity separation',myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('rA','description',
     &     'r-face area',myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('rAw','description',
     &     '',myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('rAs','description',
     &     '',myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('rAz','description',
     &     '',myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('fCori','description',
     &     'Coriolis f',myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('fCoriG','description',
     &     'Coriolis f',myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('R_low','description',
     &     'base of fluid in r-units',myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('Ro_surf','description',
     &     'surface reference (at rest,myThid) position',myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('HFacC','description',
     &     'C-facing vertical fraction of open cell',myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('HFacW','description',
     &     'W-facing vertical fraction of open cell',myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('HFacS','description',
     &     'S-facing vertical fraction of open cell',myThid)

C     Write the GRID.h variables
      CALL MNC_CW_SET_UDIM(bfname(nf:nl), 0, myThid)
      CALL MNC_CW_RS_W('D',bfname(nf:nl),0,0,'rC',rC,myThid)
      CALL MNC_CW_RS_W('D',bfname(nf:nl),0,0,'rF',rF,myThid)
      CALL MNC_CW_RS_W('D',bfname(nf:nl),0,0,'drC',drC,myThid)
      CALL MNC_CW_RS_W('D',bfname(nf:nl),0,0,'drF',drF,myThid)
      CALL MNC_CW_RS_W('D',bfname(nf:nl),0,0,'xC',xC,myThid)
      CALL MNC_CW_RS_W('D',bfname(nf:nl),0,0,'yC',yC,myThid)
      CALL MNC_CW_RS_W('D',bfname(nf:nl),0,0,'xG',xG,myThid)
      CALL MNC_CW_RS_W('D',bfname(nf:nl),0,0,'yG',yG,myThid)
      CALL MNC_CW_RS_W('D',bfname(nf:nl),0,0,'dxC',dxC,myThid)
      CALL MNC_CW_RS_W('D',bfname(nf:nl),0,0,'dyC',dyC,myThid)
      CALL MNC_CW_RS_W('D',bfname(nf:nl),0,0,'dxF',dxF,myThid)
      CALL MNC_CW_RS_W('D',bfname(nf:nl),0,0,'dyF',dyF,myThid)
      CALL MNC_CW_RS_W('D',bfname(nf:nl),0,0,'dxG',dxG,myThid)
      CALL MNC_CW_RS_W('D',bfname(nf:nl),0,0,'dyG',dyG,myThid)
      CALL MNC_CW_RS_W('D',bfname(nf:nl),0,0,'dxV',dxV,myThid)
      CALL MNC_CW_RS_W('D',bfname(nf:nl),0,0,'dyU',dyU,myThid)
      CALL MNC_CW_RS_W('D',bfname(nf:nl),0,0,'rA',rA,myThid)
      CALL MNC_CW_RS_W('D',bfname(nf:nl),0,0,'rAw',rAw,myThid)
      CALL MNC_CW_RS_W('D',bfname(nf:nl),0,0,'rAs',rAs,myThid)
      CALL MNC_CW_RS_W('D',bfname(nf:nl),0,0,'rAz',rAz,myThid)
      CALL MNC_CW_RS_W('D',bfname(nf:nl),0,0,'fCori',fCori,myThid)
      CALL MNC_CW_RS_W('D',bfname(nf:nl),0,0,'fCoriG',fCoriG,myThid)
      CALL MNC_CW_RS_W('D',bfname(nf:nl),0,0,'R_low',R_low,myThid)
      CALL MNC_CW_RS_W('D',bfname(nf:nl),0,0,'Ro_surf',Ro_surf,myThid)
      CALL MNC_CW_RS_W('D',bfname(nf:nl),0,0,'HFacC',HFacC,myThid)
      CALL MNC_CW_RS_W('D',bfname(nf:nl),0,0,'HFacW',HFacW,myThid)
      CALL MNC_CW_RS_W('D',bfname(nf:nl),0,0,'HFacS',HFacS,myThid)

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

CBOP
C !ROUTINE: MNC_CW_WRITE_GRID_COORD

C !INTERFACE:
      SUBROUTINE MNC_CW_WRITE_GRID_COORD(
     I     fname,
     I     myThid )

C     !DESCRIPTION:
C     This subroutine writes coordinates to one netcdf file
C     (\texttt{fname.xxxxx.nc}) per tile.

C     !USES:
      implicit none
#include "SIZE.h"
#include "GRID.h"

C     !INPUT PARAMETERS:
      integer myThid
      character*(*) fname
CEOP
C     Write coordinates to file "fname"
      _BEGIN_MASTER( myThid )

      CALL MNC_CW_SET_UDIM(fname, 0, myThid)
      CALL MNC_CW_RS_W('R',fname,0,0,'xC',xC, myThid)
      CALL MNC_CW_RS_W('R',fname,0,0,'yC',yC, myThid)
      CALL MNC_CW_RS_W('R',fname,0,0,'xG',xG, myThid)
      CALL MNC_CW_RS_W('R',fname,0,0,'yG',yG, myThid)
C--   Here we can add as much grid information as we like, but this
C--   will increase the size of each of the affected files. It is
C--   a matter of taste, but here are some candidates:
C--   Probably it is enough to write the coordinates of the
C--   center points and the corners.
C     CALL MNC_CW_RS_W('R',fname,0,0,'XU',xG, myThid)
C     CALL MNC_CW_RS_W('R',fname,0,0,'YU',yC, myThid)
C     CALL MNC_CW_RS_W('R',fname,0,0,'XV',xC, myThid)
C     CALL MNC_CW_RS_W('R',fname,0,0,'YV',yG, myThid)
C--   Only required for diagnostics files, but unclear what the vertical
C--   coordinate means in this case, so do not write anything for now
C     CALL MNC_CW_RS_W('R',fname,0,0,'RC',rC, myThid)
C     CALL MNC_CW_RS_W('R',fname,0,0,'RF',rF, myThid)
C--   If required write mask information.
C     CALL MNC_CW_RS_W('R',fname,0,0,'HFacC',HFacC,myThid)

      _END_MASTER(myThid)

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#include "CTRL_OPTIONS.h"

CBOP
C     !ROUTINE: CTRL_CONVERT_HEADER
C     !INTERFACE:
      SUBROUTINE CTRL_CONVERT_HEADER(
     I              maxLocal, numVar, errMsgUnit,
     U              varIndex, varRecs,
     U              varNxMax, varNyMax, varNrMax,
     U              varGrid, varType,
     I              myThid )

C     !DESCRIPTION: \bv
C     *=================================================================
C     | SUBROUTINE CTRL_CONVERT_HEADER
C     | o Convert header of old ctrl-pack file to current one
C     *=================================================================
C     \ev

C     !USES:
      IMPLICIT NONE

C     == Global variables ==
#include "EEPARAMS.h"
c#include "SIZE.h"
#include "CTRL_SIZE.h"
c#include "PARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     myThid     :: my Thread Id number
      INTEGER maxLocal, numVar, errMsgUnit
      INTEGER varIndex(maxLocal)
      INTEGER varRecs (maxLocal)
      INTEGER varNxMax(maxLocal)
      INTEGER varNyMax(maxLocal)
      INTEGER varNrMax(maxLocal)
      CHARACTER*(1) varGrid(maxLocal)
      CHARACTER*(5) varType(maxLocal)
      INTEGER myThid

#ifdef READ_OLD_CTRL_PACK_FILE
C     !LOCAL VARIABLES:
C     msgBuf     :: Informational/error message buffer
      INTEGER i, j, k
      INTEGER iarr, jarr
      CHARACTER*(5) allType(5)
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      INTEGER errCount
CEOP

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      errCount = 0
      allType(1) = 'SecXZ'
      allType(2) = 'SecYZ'
      allType(3) = 'Arr2D'
      allType(4) = 'Arr3D'
      allType(5) = 'Tim2D'

      j = 0
      DO i=1,maxLocal
        iarr = varIndex(i)
        IF ( iarr.NE. -1 ) THEN
          IF ( ( iarr.GE.111 .AND. iarr.LE.114 ).OR.
     &         ( iarr.GE.201 .AND. iarr.LE.200+maxCtrlArr2D ) .OR.
     &         ( iarr.GE.301 .AND. iarr.LE.300+maxCtrlArr3D ) .OR.
     &         ( iarr.GE.401 .AND. iarr.LE.400+maxCtrlTim2D ) ) THEN
            j = j + 1
            k = ( iarr - 1 ) / 100 + 1
            IF ( k.LE.2 ) THEN
              jarr = iarr - 110
              IF ( iarr.LE.112 ) THEN
                k = 1
              ELSE
C             switch 3 <-> 4 ( obE was 114 now #3 ; obW was 113 now #4 )
                jarr = 7 - jarr
              ENDIF
            ELSE
              jarr = MOD( iarr, 100 )
            ENDIF
C- copy i -> j :
            varIndex(j) = jarr
            varRecs(j)  = varRecs(i)
            varNxMax(j) = varNxMax(i)
            varNyMax(j) = varNyMax(i)
            varNrMax(j) = varNrMax(i)
            varGrid(j)  = varGrid(i)
c           varType(j)  = varType(i)
            varType(j)  = allType(k)
          ELSE
            WRITE(msgBuf,'(A,2(A,I4))') '*** ERROR *** ',
     &      'CTRL_CONVERT_HEADER: invalid varIndex(i=', i, ')=', iarr
            WRITE(errMsgUnit,'(A)') msgBuf
c           CALL PRINT_ERROR( msgBuf, myThid )
            errCount = errCount + 1
          ENDIF
        ENDIF
      ENDDO

      IF ( errCount.GE.1 ) THEN
        WRITE(msgBuf,'(2A,I3,A)') '*** ERROR *** ',
     &      'CTRL_CONVERT_HEADER: detected', errCount,' fatal error(s)'
        WRITE(errMsgUnit,'(A)') msgBuf
c       CALL PRINT_ERROR( msgBuf, myThid )
c       CALL ALL_PROC_DIE( 0 )
        STOP 'ABNORMAL END: S/R CTRL_CONVERT_HEADER'
      ENDIF
      IF ( j .NE. numVar ) THEN
        WRITE(msgBuf,'(2A,I4)') '*** ERROR *** ',
     &      'CTRL_CONVERT_HEADER: number of ctrl-vars counted =', j
        WRITE(errMsgUnit,'(A)') msgBuf
        WRITE(msgBuf,'(2A,I4)') '*** ERROR *** ',
     &      'CTRL_CONVERT_HEADER: inconsitent with numVar=', numVar
        WRITE(errMsgUnit,'(A)') msgBuf
        STOP 'ABNORMAL END: S/R CTRL_CONVERT_HEADER'
      ENDIF

#endif /* READ_OLD_CTRL_PACK_FILE */
      RETURN
      END

#include "ECCO_OPTIONS.h"

      subroutine cost_gencost_bpv4(
     I                     myThid )

c     ==================================================================
c     SUBROUTINE cost_gencost_bpv4
c     ==================================================================
c
c     o Evaluate cost function contribution of bottom pressure anoamlies
c       => GRACE data
c
c     started: Gael Forget Oct-2009
c
c     ==================================================================
c     SUBROUTINE cost_bp
c     ==================================================================

      implicit none

c     == global variables ==

#include "EEPARAMS.h"
#include "SIZE.h"
#include "PARAMS.h"
#include "GRID.h"
#include "DYNVARS.h"

#ifdef ALLOW_ECCO
# include "ECCO_SIZE.h"
# include "ECCO.h"
#endif

c     == routine arguments ==
      integer myThid

#ifdef ALLOW_ECCO
#ifdef ALLOW_GENCOST_CONTRIBUTION

c     == external functions ==
      integer  ilnblnk
      external ilnblnk

c     == local variables ==
      integer bi,bj
      integer i,j
      integer irec
      integer il
      logical doglobalread
      logical ladinit
      _RL locbpbar(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL locbpdat(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL locbpmask(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL locwbp(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL bpdifmean ( 1-OLx:sNx+OLx, 1-OLy:sNy+OLy, nSx, nSy )
      _RL bpdifanom ( 1-OLx:sNx+OLx, 1-OLy:sNy+OLy, nSx, nSy )
      _RL bpdatmean ( 1-OLx:sNx+OLx, 1-OLy:sNy+OLy, nSx, nSy )
      _RL bpdatanom ( 1-OLx:sNx+OLx, 1-OLy:sNy+OLy, nSx, nSy )
      _RL bpcount ( 1-OLx:sNx+OLx, 1-OLy:sNy+OLy, nSx, nSy )
      _RL junk
      character*(MAX_LEN_FNAM) fname
      character*(MAX_LEN_FNAM) fname4test
      _RL fac
      _RL offset
      _RL offset_sum
      integer k, kgen
      logical dosumsq
#ifdef ALLOW_SMOOTH
      integer k2_bp
      logical exst
#endif
#ifdef ECCO_VERBOSE
      CHARACTER*(MAX_LEN_MBUF) msgBuf
#endif
c     == end of interface ==

      kgen=0
      do k=1,NGENCOST
        if ( (gencost_name(k).EQ.'bpv4-grace').AND.
     &       (.NOT.gencost_is1d(k)).AND.
     &       (using_gencost(k)) ) kgen=k
      enddo

      if (kgen.GT.0) then

#ifdef ALLOW_SMOOTH
       k2_bp=0
       if ( useSMOOTH) then
          do k = 1,ngenpproc
            if (gencost_posproc(k,kgen).eq.'smooth') k2_bp=k
          enddo
       endif
#endif

       dosumsq=.TRUE.
       call ecco_zero( gencost_weight(1-OLx,1-OLy,1,1,kgen),
     &                 1, zeroRL, myThid )
       if ( gencost_errfile(kgen) .NE. ' ' )
     &   call ecco_readwei( gencost_errfile(kgen),
     &     gencost_weight(1-OLx,1-OLy,1,1,kgen),
     &     1, 1, 1, dosumsq, myThid )

c-- initialise local variables
cgf convert phibot from m2/s2 to cm
       fac = 1. _d 2 / 9.81 _d 0
       DO bj = myByLo(myThid), myByHi(myThid)
        DO bi = myBxLo(myThid), myBxHi(myThid)
          do j = 1,sNy
           do i = 1,sNx
             bpdifmean(i,j,bi,bj) = 0. _d 0
             bpdifanom(i,j,bi,bj) = 0. _d 0
             bpdatmean(i,j,bi,bj) = 0. _d 0
             bpdatanom(i,j,bi,bj) = 0. _d 0
             bpcount(i,j,bi,bj) = 0. _d 0
             locwbp(i,j,bi,bj) = 0. _d 0
             locbpbar(i,j,bi,bj) = 0. _d 0
             locbpdat(i,j,bi,bj) = 0. _d 0
             locbpmask(i,j,bi,bj) = 0. _d 0
           enddo
          enddo
        ENDDO
       ENDDO

       doglobalread = .false.
       ladinit      = .false.

c-- map global variable to local variables

       DO bj = myByLo(myThid), myByHi(myThid)
        DO bi = myBxLo(myThid), myBxHi(myThid)
          do j = 1,sNy
           do i = 1,sNx
             locwbp(i,j,bi,bj) = gencost_weight(i,j,bi,bj,kgen)
           enddo
          enddo
        ENDDO
       ENDDO

#ifdef ALLOW_CTRL
       il=ilnblnk( gencost_barfile(kgen) )
       write(fname,'(2a,i10.10)')
     &     gencost_barfile(kgen)(1:il),'.',eccoiter
#endif

c--   ============
c--   Mean values.
c--   ============

#ifdef ECCO_VERBOSE
       WRITE(msgBuf,'(A,1x,i5,1x,i10)')
     &      ' bpv4, kgen, nmonsrec: ',kgen, nmonsrec
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                     SQUEEZE_RIGHT, myThid )
#endif
       do irec = 1, nmonsrec

c--     Compute the mean over all bpdat records.
#ifdef ALLOW_AUTODIFF
        call active_read_xy( fname, locbpbar, irec, doglobalread,
     &                       ladinit, eccoiter, myThid,
     &                       gencost_dummy(kgen) )
#else
        CALL READ_REC_XY_RL( fname, locbpbar,
     &                       iRec, 1, myThid )
#endif

        call cost_bp_read( gencost_datafile(kgen),
     &       gencost_startdate(1,kgen),
     &       locbpdat, locbpmask, irec, myThid )

#ifdef ECCO_VERBOSE
        il=ilnblnk( gencost_datafile(kgen) )
        WRITE(msgBuf,'(A,1x,A,1x,i10)') ' bpv4, datafile, irec: ',
     &        gencost_datafile(kgen)(1:il), irec
        CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
        write(fname4test,'(2a,i4.4)')
     &       gencost_datafile(kgen)(1:il),'.',irec
        call write_rec_xy_rl( fname4test, locbpdat, 1, 1, myThid)
#endif

        DO bj = myByLo(myThid), myByHi(myThid)
         DO bi = myBxLo(myThid), myBxHi(myThid)
           do j = 1,sNy
            do i = 1,sNx
              if ( (locbpmask(i,j,bi,bj).NE. 0. _d 0).AND.
     &             (maskc(i,j,1,bi,bj).NE. 0. _d 0) ) then
                bpdifmean(i,j,bi,bj) = bpdifmean(i,j,bi,bj) +
     &              ( fac*locbpbar(i,j,bi,bj) - locbpdat(i,j,bi,bj) )
                bpdatmean(i,j,bi,bj) = bpdatmean(i,j,bi,bj) +
     &              locbpdat(i,j,bi,bj)
                bpcount(i,j,bi,bj) = bpcount(i,j,bi,bj) + 1. _d 0
              endif
            enddo
           enddo
         ENDDO
        ENDDO

       enddo

       DO bj = myByLo(myThid), myByHi(myThid)
        DO bi = myBxLo(myThid), myBxHi(myThid)
          do j = 1,sNy
           do i = 1,sNx
             if (bpcount(i,j,bi,bj).GT. 0. _d 0) then
               bpdifmean(i,j,bi,bj) =
     &              bpdifmean(i,j,bi,bj)/bpcount(i,j,bi,bj)
               bpdatmean(i,j,bi,bj) =
     &              bpdatmean(i,j,bi,bj)/bpcount(i,j,bi,bj)
             endif
           enddo
          enddo
        ENDDO
       ENDDO

c--   ==========
c--   Anomalies.
c--   ==========

c--   Loop over records for the second time.
       do irec = 1, nmonsrec
#ifdef ALLOW_AUTODIFF
        call active_read_xy( fname, locbpbar, irec, doglobalread,
     &                       ladinit, eccoiter, myThid,
     &                       gencost_dummy(kgen) )
#else
        CALL READ_REC_XY_RL( fname, locbpbar,
     &                       iRec, 1, myThid )
#endif

        call cost_bp_read( gencost_datafile(kgen),
     &       gencost_startdate(1,kgen),
     &       locbpdat, locbpmask, irec, myThid )

c--    Compute field of anomalies
        DO bj = myByLo(myThid), myByHi(myThid)
         DO bi = myBxLo(myThid), myBxHi(myThid)
           do j = 1,sNy
            do i = 1,sNx
              if ( (locbpmask(i,j,bi,bj).NE. 0. _d 0).AND.
     &             (maskc(i,j,1,bi,bj).NE. 0. _d 0) ) then
                bpdifanom(i,j,bi,bj) =
     &              ( fac*locbpbar(i,j,bi,bj) - locbpdat(i,j,bi,bj) )
     &              - bpdifmean(i,j,bi,bj)
                bpdatanom(i,j,bi,bj) =
     &              locbpdat(i,j,bi,bj) - bpdatmean(i,j,bi,bj)
              else
                bpdifanom(i,j,bi,bj) = 0. _d 0
                bpdatanom(i,j,bi,bj) = 0. _d 0
              endif
            enddo
           enddo
         ENDDO
        ENDDO

c--    Remove global mean value
        offset     = 0. _d 0
        offset_sum = 0. _d 0

        DO bj = myByLo(myThid), myByHi(myThid)
         DO bi = myBxLo(myThid), myBxHi(myThid)
           do j = 1,sNy
            do i = 1,sNx
              if ( (locbpmask(i,j,bi,bj).NE. 0. _d 0).AND.
     &             (maskc(i,j,1,bi,bj).NE. 0. _d 0) ) then
                offset  = offset + RA(i,j,bi,bj)*bpdifanom(i,j,bi,bj)
                offset_sum = offset_sum + RA(i,j,bi,bj)
              endif
            enddo
           enddo
         ENDDO
        ENDDO

        _GLOBAL_SUM_RL( offset     , myThid )
        _GLOBAL_SUM_RL( offset_sum , myThid )

        DO bj = myByLo(myThid), myByHi(myThid)
         DO bi = myBxLo(myThid), myBxHi(myThid)
           do j = 1,sNy
            do i = 1,sNx
              if ( (offset_sum.GT. 0. _d 0).AND.
     &             (locbpmask(i,j,bi,bj).NE. 0. _d 0).AND.
     &             (maskc(i,j,1,bi,bj).NE. 0. _d 0) ) then
                bpdifanom(i,j,bi,bj) = bpdifanom(i,j,bi,bj)
     &                               - offset/offset_sum
              endif
            enddo
           enddo
         ENDDO
        ENDDO

c--    Smooth field of anomalies
        if (gencost_outputlevel(kgen).GT.0) then
         write(fname4test,'(1a)') 'bpdifanom_raw'
         CALL WRITE_REC_3D_RL( fname4test, precFloat32, 1,
     &                         bpdifanom, irec, 1, myThid )
         write(fname4test,'(1a)') 'bpdatanom_raw'
         CALL WRITE_REC_3D_RL( fname4test, precFloat32, 1,
     &                         bpdatanom, irec, 1, myThid )
        endif

#ifdef ALLOW_SMOOTH
        IF ( k2_bp.GE.1 ) THEN
C- Note: Unlike all other generic-cost smoothing, original code was using
C  "smooth_basic2D" with hard-coded smoothing length (3.e+5) and time
C  multiplicator (3000). Keep original call (now using run-time params setting)
C  when the scaling file gencost_posproc_c is missing:
         il=ilnblnk( gencost_posproc_c(k2_bp,kgen) )
         inquire(file=gencost_posproc_c(k2_bp,kgen)(1:il), exist=exst)
         IF ( il .gt. 1 .and. exst ) THEN
           call smooth_hetero2d(bpdifanom,maskc,
     &      gencost_posproc_c(k2_bp,kgen),
     &      gencost_posproc_i(k2_bp,kgen),myThid)
         ELSE
           call smooth_basic2D(bpdifanom,maskInC,
     &      gencost_posproc_r(k2_bp,kgen),
     &      gencost_posproc_i(k2_bp,kgen),myThid)
         ENDIF
        ENDIF
#endif

        if (gencost_outputlevel(kgen).GT.0) then
#ifdef ALLOW_SMOOTH
         IF ( k2_bp.GE.1 ) THEN
C--   Skip second evaluation of "il" & "exst" (unchanged since first one above)
c         il=ilnblnk( gencost_posproc_c(k2_bp,kgen) )
c         inquire(file=gencost_posproc_c(k2_bp,kgen)(1:il), exist=exst)
          IF ( il .gt. 1 .and. exst ) THEN
           call smooth_hetero2d(bpdatanom,maskc,
     &      gencost_posproc_c(k2_bp,kgen),
     &      gencost_posproc_i(k2_bp,kgen),myThid)
          ELSE
           call smooth_basic2D(bpdatanom,maskInC,
     &      gencost_posproc_r(k2_bp,kgen),
     &      gencost_posproc_i(k2_bp,kgen),myThid)
          ENDIF
         ENDIF
#endif

         write(fname4test,'(1a)') 'bpdifanom_smooth'
         CALL WRITE_REC_3D_RL( fname4test, precFloat32, 1,
     &                         bpdifanom, irec, 1, myThid )
         write(fname4test,'(1a)') 'bpdatanom_smooth'
         CALL WRITE_REC_3D_RL( fname4test, precFloat32, 1,
     &                         bpdatanom, irec, 1, myThid )
        endif

c--    Compute cost function
        DO bj = myByLo(myThid), myByHi(myThid)
         DO bi = myBxLo(myThid), myBxHi(myThid)
           do j = 1,sNy
            do i = 1,sNx
c-- map to global cost variables
              if ( (locwbp(i,j,bi,bj).NE. 0. _d 0).AND.
     &             (locbpmask(i,j,bi,bj).NE. 0. _d 0).AND.
     &             (maskc(i,j,1,bi,bj).NE. 0. _d 0) ) then
                 junk = bpdifanom(i,j,bi,bj)
                 objf_gencost(bi,bj,kgen) = objf_gencost(bi,bj,kgen)
     &               + junk*junk*locwbp(i,j,bi,bj)
                 num_gencost(bi,bj,kgen) = num_gencost(bi,bj,kgen)
     &               + 1. _d 0
              endif
            enddo
           enddo
         ENDDO
        ENDDO

       enddo

      endif !if (kgen.GT.0) then

#endif /* ifdef ALLOW_GENCOST_CONTRIBUTION */
#endif /* ifdef ALLOW_ECCO */

      RETURN
      END

#include "OBCS_OPTIONS.h"
#ifdef ALLOW_CTRL
# include "CTRL_OPTIONS.h"
#endif
#ifdef ALLOW_ECCO
# include "ECCO_OPTIONS.h"
#endif

C     This routine is not called from anywhere and likely not maintained

      subroutine obcs_cost_ageos( mytime, myiter, mythid )

c     ==================================================================
c     SUBROUTINE obcs_cost_ageos
c     ==================================================================
c
c     o cost function contribution obc -- Ageostrophic boundary flow.
c
c     started: G. Gebbie gebbie@mit.edu 4-Feb-2003
c
c     warning: masks redundantly assume no gradient of topography at
c              boundary.
c
c     ==================================================================
c     SUBROUTINE obcs_cost_ageos
c     ==================================================================

      implicit none

c     == global variables ==

#ifdef OBCS_AGEOS_COST_CONTRIBUTION
#include "EEPARAMS.h"
#include "SIZE.h"
#include "GRID.h"
#include "DYNVARS.h"
#include "PARAMS.h"
#ifdef ALLOW_OBCS
# include "OBCS_GRID.h"
#endif

#ifdef ALLOW_CAL
# include "cal.h"
#endif
#ifdef ALLOW_ECCO
# include "ecco_cost.h"
#endif
#ifdef ALLOW_CTRL
# include "CTRL_SIZE.h"
# include "CTRL.h"
# include "CTRL_DUMMY.h"
# include "OPTIMCYCLE.h"
# include "CTRL_OBCS.h"
#endif
#endif

c     == routine arguments ==
      _RL     mytime
      integer myiter
      integer mythid

#if (defined (ALLOW_CTRL) && \
     defined (ALLOW_OBCS) && \
     defined (ALLOW_ECCO))

#ifdef OBCS_AGEOS_COST_CONTRIBUTION
c     == local variables ==

      integer bi,bj
      integer i,j,k
      integer itlo,ithi
      integer jtlo,jthi
      integer jmin,jmax
      integer imin,imax
      integer irec
      integer levmon
      integer levoff
      integer iltheta
      integer ilsalt
      integer iluvel
      integer ilvvel
      integer ip1, jp1

      _RL fctile
      _RL fcthread

      _RL rholoc (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL xzgrdrho(1-OLx:sNx+OLx,Nr,nSx,nSy)
      _RL yzgrdrho(1-OLy:sNy+OLy,Nr,nSx,nSy)
      _RL xzdvel1   (1-OLx:sNx+OLx,Nr,nSx,nSy)
      _RL xzdvel2   (1-OLx:sNx+OLx,Nr,nSx,nSy)
      _RL yzdvel1   (1-OLy:sNy+OLy,Nr,nSx,nSy)
      _RL yzdvel2   (1-OLy:sNy+OLy,Nr,nSx,nSy)
      _RL maskxzageos   (1-OLx:sNx+OLx,Nr,nSx,nSy)
      _RL maskyzageos   (1-OLy:sNy+OLy,Nr,nSx,nSy)
      _RL dummy

      character*(MAX_LEN_FNAM) fnametheta
      character*(MAX_LEN_FNAM) fnamesalt
      character*(MAX_LEN_FNAM) fnameuvel
      character*(MAX_LEN_FNAM) fnamevvel

      logical doglobalread
      logical ladinit

      character*(MAX_LEN_MBUF) msgbuf

c     == external functions ==

      integer  ilnblnk
      external ilnblnk

c     == end of interface ==

      jtlo = myByLo(mythid)
      jthi = myByHi(mythid)
      itlo = myBxLo(mythid)
      ithi = myBxHi(mythid)
      jmin = 1
      jmax = sNy
      imin = 1
      imax = sNx

c--   Read tiled data.
      doglobalread = .false.
      ladinit      = .false.

#ifdef ECCO_VERBOSE
      _BEGIN_MASTER( mythid )
        write(msgbuf,'(a)') ' '
        call print_message( msgbuf, standardmessageunit,
     &                      SQUEEZE_RIGHT , mythid)
        write(msgbuf,'(a,i8.8)')
     &    ' obcs_cost_ageos: number of records to process = ',nmonsrec
        call print_message( msgbuf, standardmessageunit,
     &                      SQUEEZE_RIGHT , mythid)
        write(msgbuf,'(a)') ' '
        call print_message( msgbuf, standardmessageunit,
     &                      SQUEEZE_RIGHT , mythid)
      _END_MASTER( mythid )
#endif /* ECCO_VERBOSE */

      if (optimcycle .ge. 0) then
        iltheta = ilnblnk( tbarfile )
        write(fnametheta,'(2a,i10.10)')
     &    tbarfile(1:iltheta),'.',optimcycle
        ilsalt = ilnblnk( sbarfile )
        write(fnamesalt,'(2a,i10.10)')
     &    sbarfile(1:ilsalt),'.',optimcycle
        iluvel = ilnblnk( ubarfile )
        write(fnameuvel,'(2a,i10.10)')
     &    ubarfile(1:iluvel),'.',optimcycle
        ilvvel = ilnblnk( vbarfile )
        write(fnamevvel,'(2a,i10.10)')
     &    vbarfile(1:ilvvel),'.',optimcycle
      endif

      fcthread = 0. _d 0
      fctile   = 0. _d 0

cgg   Code safe: always initialize to zero.
      do bj = jtlo,jthi
        do bi = itlo,ithi
          do k = 1,Nr
            do i = 1-OLx,sNx+OLx
              maskxzageos(i,k,bi,bj) = 0. _d 0
              xzdvel1(i,k,bi,bj)     = 0. _d 0
              xzdvel2(i,k,bi,bj)     = 0. _d 0
              xzgrdrho(i,k,bi,bj)    = 0. _d 0
            enddo
            do j = 1-OLy,sNy+OLy
              maskyzageos(j,k,bi,bj) = 0. _d 0
              yzdvel1(j,k,bi,bj)     = 0. _d 0
              yzdvel2(j,k,bi,bj)     = 0. _d 0
              yzgrdrho(j,k,bi,bj)    = 0. _d 0
            enddo
          enddo
        enddo
      enddo

      do bj = jtlo,jthi
        do bi = itlo,ithi
          do j = 1-OLy,sNy+OLy
            do i = 1-OLx,sNx+OLx
              rholoc(i,j,bi,bj) = 0. _d 0
            enddo
          enddo
        enddo
      enddo

c--   Loop over records.
      do irec = 1,nmonsrec

c--     Read time averages and the monthly mean data.
#ifdef ALLOW_AUTODIFF
        call active_read_xyz( fnametheta, tbar, irec,
     &                        doglobalread, ladinit,
     &                        optimcycle, mythid,
     &                        xx_tbar_mean_dummy )

        call active_read_xyz( fnamesalt, sbar, irec,
     &                        doglobalread, ladinit,
     &                        optimcycle, mythid,
     &                        xx_sbar_mean_dummy )

        call active_read_xyz( fnameuvel, ubar, irec,
     &                        doglobalread, ladinit,
     &                        optimcycle, mythid,
     &                        xx_ubar_mean_dummy )

        call active_read_xyz( fnamevvel, vbar, irec,
     &                        doglobalread, ladinit,
     &                        optimcycle, mythid,
     &                        xx_vbar_mean_dummy )
#else
        call read_rec_xyz_rl( fnametheta, tbar, irec, 1, myThid )

        call read_rec_xyz_rl( fnamesalt, sbar, irec, 1, myThid )

        call read_rec_xyz_rl( fnameuvel, ubar, irec, 1, myThid )

        call read_rec_xyz_rl( fnamevvel, vbar, irec, 1, myThid )
#endif

cgg     Minor problem : grad T,S needs overlap values.
        _BARRIER
        _EXCH_XYZ_RL(tbar,myThid)
        _EXCH_XYZ_RL(sbar,myThid)

        do bj = jtlo,jthi
          do bi = itlo,ithi

#ifdef ALLOW_OBCSN_CONTROL
            jp1 = 0

cgg    Make a mask for the velocity shear comparison.
            do k = 1,Nr-1
              do i = imin, imax
                j = OB_Jn(i,bi,bj)
cgg    All these points need to be wet.
                if ( j.eq.OB_indexNone ) then
                  maskxzageos(i,k,bi,bj) = 0.
                else
                  maskxzageos(i,k,bi,bj) =
     &       hfacC(i,j+jp1,k,bi,bj)*hfacC(i+1,j+jp1,k,bi,bj) *
     &       hfacC(i-1,j+jp1,k,bi,bj)*hfacC(i,j+jp1,k+1,bi,bj)*
     &       hfacC(i-1,j+jp1,k+1,bi,bj)*hfacC(i+1,j+jp1,k+1,bi,bj)*
     &       hfacS(i,j+jp1,k,bi,bj)*hfacS(i,j+jp1,k+1,bi,bj)
                endif
              enddo
            enddo

            do k = 1,Nr

C-- jmc: both calls below are wrong if more than 1 tile => stop here
       IF ( bi.NE.1 .OR. bj.NE.1 )
     &  STOP 'OBCS_COST_AGEOS wrong with more than 1 tile/proc'
              call find_rho_2d(
     I                         iMin, iMax, jMin, jMax, k,
     I                         tbar(1-OLx,1-OLy,k,bi,bj),
     I                         sbar(1-OLx,1-OLy,k,bi,bj),
     O                         rholoc,
     I                         k, bi, bj, myThid )
              _EXCH_XY_RL(rholoc , myThid)

cgg   Compute centered difference horizontal gradient on bdy.
              do i = imin, imax
                j = OB_Jn(i,bi,bj)
                if ( j.eq.OB_indexNone ) j = 1
                  xzgrdrho(i,k,bi,bj) =
     &            (rholoc(i-1,j+jp1,bi,bj)-rholoc(i+1,j+jp1,bi,bj))
     &            /(2.*dxc(i,j+jp1,bi,bj))
              enddo
            enddo

cgg         Compute vertical shear from geostrophy/thermal wind.
cgg         Above level 4 needs not be geostrophic.
cgg         Please get rid of the "4" ASAP. Ridiculous.
            do k = 4,Nr-1
              do i = imin,imax
                j = OB_Jn(i,bi,bj)
                if ( j.eq.OB_indexNone ) j = 1
                  xzdvel1(i,k,bi,bj) = vbar(i,j+jp1,k  ,bi,bj)
     &                               - vbar(i,j+jp1,k+1,bi,bj)
                 xzdvel2(i,k,bi,bj)=((xzgrdrho(i,k,bi,bj)*delz(k)/2.)+
     &                             (xzgrdrho(i,k+1,bi,bj)*delz(k+1)/2.))
     &                        * gravity / f0 / rhonil

                  fctile = fctile + 100*wcurrent(k,bi,bj) *
     &            maskxzageos(i,k,bi,bj)*
     &          (xzdvel2(i,k,bi,bj) - xzdvel1(i,k,bi,bj))*
     &          (xzdvel2(i,k,bi,bj) - xzdvel1(i,k,bi,bj))
      if (maskxzageos(i,k,bi,bj) .ne. 0) then
cgg      print*,'XX shear,geos shear',xzdvel1(i,k,bi,bj),xzdvel2(i,k,bi,bj)
cgg      print*,'i,j,k,fctile N',i,j,k,fctile
      endif
              enddo
            enddo
c--         End of loop over layers.
#endif /* ALLOW_OBCSN_CONTROL */

#ifdef ALLOW_OBCSS_CONTROL
            jp1 = 1

cgg    Make a mask for the velocity shear comparison.
            do k = 1,Nr-1
              do i = imin, imax
                j = OB_Js(i,bi,bj)
                if ( j.eq.OB_indexNone ) then
                  maskxzageos(i,k,bi,bj) = 0.
                else
cgg    All these points need to be wet.
                  maskxzageos(i,k,bi,bj) =
     &       hfacC(i,j+jp1,k,bi,bj)*hfacC(i+1,j+jp1,k,bi,bj) *
     &       hfacC(i-1,j+jp1,k,bi,bj)*hfacC(i,j+jp1,k+1,bi,bj)*
     &       hfacC(i-1,j+jp1,k+1,bi,bj)*hfacC(i+1,j+jp1,k+1,bi,bj)*
     &       hfacS(i,j+jp1,k,bi,bj)*hfacS(i,j+jp1,k+1,bi,bj)
                endif
              enddo
            enddo

            do k = 1,Nr

C-- jmc: both calls below are wrong if more than 1 tile => stop here
       IF ( bi.NE.1 .OR. bj.NE.1 )
     &  STOP 'OBCS_COST_AGEOS wrong with more than 1 tile/proc'
              call find_rho_2d(
     I                         iMin, iMax, jMin, jMax, k,
     I                         tbar(1-OLx,1-OLy,k,bi,bj),
     I                         sbar(1-OLx,1-OLy,k,bi,bj),
     O                         rholoc,
     I                         k, bi, bj, myThid )

              _EXCH_XY_RL(rholoc , myThid)

cgg   Compute centered difference horizontal gradient on bdy.
               do i = imin, imax
                 j = OB_Js(i,bi,bj)
                 if ( j.eq.OB_indexNone ) j = 1
                 xzgrdrho(i,k,bi,bj) =
     &            (rholoc(i-1,j+jp1,bi,bj)-rholoc(i+1,j+jp1,bi,bj))
     &            /(2.*dxc(i,j+jp1,bi,bj))
               enddo
             enddo

cgg         Compute vertical shear from geostrophy/thermal wind.
             do k = 4,Nr-1
               do i = imin,imax
                 j = OB_Js(i,bi,bj)
                 if ( j.eq.OB_indexNone ) j = 1
cgg         Retrieve the model vertical shear.
                 xzdvel1(i,k,bi,bj) = vbar(i,j+jp1,k  ,bi,bj)
     &                               - vbar(i,j+jp1,k+1,bi,bj)

cgg         Compute vertical shear from geostrophy/thermal wind.
                 xzdvel2(i,k,bi,bj) =((xzgrdrho(i,k,bi,bj)*delz(k)/2.)+
     &                             (xzgrdrho(i,k+1,bi,bj)*delz(k+1)/2.))
     &                        * gravity / f0 /rhonil

cgg   Make a comparison.
                  fctile = fctile + 100*wcurrent(k,bi,bj) *
     &          maskxzageos(i,k,bi,bj)*
     &          (xzdvel2(i,k,bi,bj) - xzdvel1(i,k,bi,bj))*
     &          (xzdvel2(i,k,bi,bj) - xzdvel1(i,k,bi,bj))
cgg        print*,'fctile S',fctile
              enddo
            enddo
c--         End of loop over layers.
#endif /* ALLOW_OBCSS_CONTROL */

#ifdef ALLOW_OBCSW_CONTROL
            ip1 = 1

cgg    Make a mask for the velocity shear comparison.
            do k = 1,Nr-1
              do j = jmin, jmax
                i = OB_Iw(j,bi,bj)
cgg    All these points need to be wet.
                if ( i.eq.OB_indexNone ) then
                  maskyzageos(j,k,bi,bj) = 0.
                else
                  maskyzageos(j,k,bi,bj) =
     &       hfacC(i+ip1,j,k,bi,bj)*hfacC(i+ip1,j+1,k,bi,bj) *
     &       hfacC(i+ip1,j-1,k,bi,bj)*hfacC(i+ip1,j,k+1,bi,bj)*
     &       hfacC(i+ip1,j-1,k+1,bi,bj)*hfacC(i+ip1,j+1,k+1,bi,bj)*
     &       hfacW(i+ip1,j,k,bi,bj)*hfacW(i+ip1,j,k+1,bi,bj)
                endif
              enddo
            enddo

            do k = 1,Nr

       IF ( bi.NE.1 .OR. bj.NE.1 )
     &  STOP 'OBCS_COST_AGEOS wrong with more than 1 tile/proc'
              call find_rho_2d(
     I                         iMin, iMax, jMin, jMax, k,
     I                         tbar(1-OLx,1-OLy,k,bi,bj),
     I                         sbar(1-OLx,1-OLy,k,bi,bj),
     O                         rholoc,
     I                         k, bi, bj, myThid )
              _EXCH_XY_RL(rholoc , myThid)

cgg   Compute centered difference horizontal gradient on bdy.
              do j = jmin, jmax
                i = OB_Iw(j,bi,bj)
                if ( i.eq.OB_indexNone ) i = 1
cgg             Negative sign due to geostrophy.
                yzgrdrho(j,k,bi,bj) =
     &            (rholoc(i+ip1,j+1,bi,bj)-rholoc(i+ip1,j-1,bi,bj))
     &            /(2.*dyc(i+ip1,j,bi,bj))
              enddo
            enddo

cgg         Compute vertical shear from geostrophy/thermal wind.
            do k = 4,Nr-1
              do j = jmin,jmax
                i = OB_Iw(j,bi,bj)
                if ( i.eq.OB_indexNone ) i = 1
cgg         Retrieve the model vertical shear.
                yzdvel1(j,k,bi,bj) = ubar(i+ip1,j,k  ,bi,bj)
     &                               - ubar(i+ip1,j,k+1,bi,bj)

cgg         Compute vertical shear from geostrophy/thermal wind.
                yzdvel2(j,k,bi,bj) =((yzgrdrho(j,k  ,bi,bj)*delz(k)/2.)+
     &                             (yzgrdrho(j,k+1,bi,bj)*delz(k+1)/2.))
     &                        * gravity / f0 / rhonil

cgg   Make a comparison.
                fctile = fctile + 100*wcurrent(k,bi,bj) *
     &           maskyzageos(j,k,bi,bj) *
     &          (yzdvel2(j,k,bi,bj) - yzdvel1(j,k,bi,bj))*
     &          (yzdvel2(j,k,bi,bj) - yzdvel1(j,k,bi,bj))
              enddo
            enddo
c--         End of loop over layers.
#endif /* ALLOW_OBCSW_CONTROL */

#ifdef ALLOW_OBCSE_CONTROL
            ip1 = 0

cgg    Make a mask for the velocity shear comparison.
            do k = 1,Nr-1
              do j = jmin, jmax
                i = OB_Ie(j,bi,bj)
                if ( i.eq.OB_indexNone ) then
                  maskyzageos(j,k,bi,bj) =0.
                else
cgg    All these points need to be wet.
                  maskyzageos(j,k,bi,bj) =
     &       hfacC(i+ip1,j,k,bi,bj)*hfacC(i+ip1,j+1,k,bi,bj) *
     &       hfacC(i+ip1,j-1,k,bi,bj)*hfacC(i+ip1,j,k+1,bi,bj)*
     &       hfacC(i+ip1,j-1,k+1,bi,bj)*hfacC(i+ip1,j+1,k+1,bi,bj)*
     &       hfacW(i+ip1,j,k,bi,bj)*hfacW(i+ip1,j,k+1,bi,bj)
                endif
              enddo
            enddo

            do k = 1,Nr

       IF ( bi.NE.1 .OR. bj.NE.1 )
     &  STOP 'OBCS_COST_AGEOS wrong with more than 1 tile/proc'
              call find_rho_2d(
     I                         iMin, iMax, jMin, jMax, k,
     I                         tbar(1-OLx,1-OLy,k,bi,bj),
     I                         sbar(1-OLx,1-OLy,k,bi,bj),
     O                         rholoc,
     I                         k, bi, bj, myThid )
              _EXCH_XY_RL(rholoc , myThid)

cgg   Compute centered difference horizontal gradient on bdy.
              do j = jmin, jmax
                i = OB_Ie(j,bi,bj)
                if ( i.eq.OB_indexNone ) i = 1
cgg             Negative sign due to geostrophy.
                yzgrdrho(j,k,bi,bj) =
     &            (rholoc(i+ip1,j+1,bi,bj)-rholoc(i+ip1,j-1,bi,bj))
     &            /(2.*dyc(i+ip1,j,bi,bj))
              enddo
            enddo

cgg         Compute vertical shear from geostrophy/thermal wind.
            do k = 4,Nr-1
              do j = jmin,jmax
                i = OB_Ie(j,bi,bj)
                if ( i.eq.OB_indexNone ) i = 1
cgg         Retrieve the model vertical shear.
                yzdvel1(j,k,bi,bj) = ubar(i+ip1,j,k  ,bi,bj)
     &                             - ubar(i+ip1,j,k+1,bi,bj)

cgg         Compute vertical shear from geostrophy/thermal wind.
                yzdvel2(j,k,bi,bj) =((yzgrdrho(j,k  ,bi,bj)*delz(k)/2.)+
     &                             (yzgrdrho(j,k+1,bi,bj)*delz(k+1)/2.))
     &                        * gravity / f0 /rhonil

cgg   Make a comparison.
                fctile = fctile + 100*wcurrent(k,bi,bj) *
     &           maskyzageos(j,k,bi,bj) *
     &          (yzdvel2(j,k,bi,bj) - yzdvel1(j,k,bi,bj))*
     &          (yzdvel2(j,k,bi,bj) - yzdvel1(j,k,bi,bj))

              enddo
            enddo
c--         End of loop over layers.
#endif /* ALLOW_OBCSE_CONTROL */

            fcthread          = fcthread          + fctile
            objf_ageos(bi,bj) = objf_ageos(bi,bj) + fctile

#ifdef ECCO_VERBOSE
c--         Print cost function for each tile in each thread.
            write(msgbuf,'(a)') ' '
            call print_message( msgbuf, standardmessageunit,
     &                          SQUEEZE_RIGHT , mythid)
            write(msgbuf,'(a,i8.8,1x,i3.3,1x,i3.3)')
     &        ' cost_Theta: irec,bi,bj          =  ',irec,bi,bj
            call print_message( msgbuf, standardmessageunit,
     &                          SQUEEZE_RIGHT , mythid)
            write(msgbuf,'(a,d22.15)')
     &        '     cost function (temperature) = ',
     &        fctile
            call print_message( msgbuf, standardmessageunit,
     &                      SQUEEZE_RIGHT , mythid)
            write(msgbuf,'(a)') ' '
            call print_message( msgbuf, standardmessageunit,
     &                          SQUEEZE_RIGHT , mythid)
#endif /* ECCO_VERBOSE */

          enddo
        enddo

#ifdef ECCO_VERBOSE
c--     Print cost function for all tiles.
        _GLOBAL_SUM_RL( fcthread , myThid )
        write(msgbuf,'(a)') ' '
        call print_message( msgbuf, standardmessageunit,
     &                      SQUEEZE_RIGHT , mythid)
        write(msgbuf,'(a,i8.8)')
     &    ' cost_Theta: irec = ',irec
        call print_message( msgbuf, standardmessageunit,
     &                      SQUEEZE_RIGHT , mythid)
        write(msgbuf,'(a,a,d22.15)')
     &    ' global cost function value',
     &    ' (temperature) = ',fcthread
        call print_message( msgbuf, standardmessageunit,
     &                      SQUEEZE_RIGHT , mythid)
        write(msgbuf,'(a)') ' '
        call print_message( msgbuf, standardmessageunit,
     &                      SQUEEZE_RIGHT , mythid)
#endif /* ECCO_VERBOSE */

      enddo
c--   End of loop over records.

#endif /* OBCS_AGEOS_COST_CONTRIBUTION */

#endif /* ALLOW_CTRL, ALLOW_OBCS and ALLOW_ECCO */

      return
      end

#include "GGL90_OPTIONS.h"

CBOP
C     !ROUTINE: GGL90_WRITE_PICKUP
C     !INTERFACE:
      SUBROUTINE GGL90_WRITE_PICKUP( permPickup, suff,
     I                               myTime, myIter, myThid )

C     !DESCRIPTION: \bv
C     *================================================================*
C     | SUBROUTINE GGL90_WRITE_PICKUP
C     | o write ggl90 pickups
C     *================================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GGL90.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     permPickup :: write a permanent pickup
C     suff    :: suffix for pickup file (eg. ckptA or 0000000010)
C     myTime  :: Current time in simulation
C     myIter  :: Current iteration number in simulation
C     myThid  :: My Thread Id number
      LOGICAL permPickup
      CHARACTER*(*) suff
      _RL     myTime
      INTEGER myIter
      INTEGER myThid

#ifdef ALLOW_GGL90

C     !LOCAL VARIABLES:
C     == Local variables ==
      CHARACTER*(MAX_LEN_FNAM) fn
      INTEGER prec
c     CHARACTER*(MAX_LEN_MBUF) msgBuf
CEOP

      prec = precFloat64
      WRITE(fn,'(A,A)') 'pickup_ggl90.',suff

      CALL WRITE_REC_3D_RL( fn, prec, Nr, GGL90TKE, 1, myIter, myThid )

#ifdef ALLOW_GGL90_IDEMIX
      IF (useIDEMIX) THEN
       CALL WRITE_REC_3D_RL( fn, prec, Nr, IDEMIX_E, 2, myIter, myThid )
      ENDIF
#endif

#endif /*  ALLOW_GGL90  */

      RETURN
      END

module radiation_mod

! ==================================================================================
! ==================================================================================

!  use fms_mod,               only: open_file, check_nml_error, &
!                                   mpp_pe, close_file

   use    gcm_params_mod,     only: gcm_LEN_MBUF, gcm_SQZ_R, gcm_stdMsgUnit
   use    constants_mod,      only: stefan, cp_air, grav, pstd_mks

!  use    diag_manager_mod,   only: register_diag_field, send_data

!  use    time_manager_mod,   only: time_type, &
!                                   operator(+), operator(-), operator(/=)

!==================================================================================
implicit none
private
!==================================================================================

! version information

character(len=128) :: version='$Id: radiation_mod.F90,v 1.7 2017/08/11 20:48:51 jmc Exp $'
character(len=128) :: tag='homemade'

!==================================================================================

! public interfaces

public :: radiation_init, radiation_down, radiation_up, radiation_end
!==================================================================================

! module variables
! select_incSW :: select expression for Incoming SW radiation @ the top
!              :: =0 : no season ; =1 : circular orbit planet (obliquity only)
! ozone_in_SW  :: =1 : account for Ozone in downward SW absorption ; =0: ignore it
! two_stream_SW :: =1 : also accont for Ozone in upward SW absorption ; =0: ignore
!                 Note: requires ozone_in_SW=1 to use two_stream_SW=1
! yearLength   :: length of solar year in seconds
! yearPhase    :: phase in solar year [0-1] relative to NH winter solstice
! obliquity    :: obliquity of Earth rotation axis in degre
logical :: initialized =.false.
integer :: select_incSW    = 0
! MK added switches for O3 scheme (default off):
integer :: ozone_in_SW     = 0
integer :: two_stream_SW   = 0

real    :: solar_constant  = 1360.0
real    :: del_sol         = 1.4
! modif omp: winter/summer hemisphere
real    :: del_sw          = 0.0
real    :: yearLength = 86400.*360.
real    :: yearPhase  = 10./365.    ! winter solstice = 22.Dec.h00
real    :: obliquity  = 23.45
real    :: atm_abs         = 0.0
real    :: sw_diff         = 0.0
real    :: albedo_value    = 0.06
real    :: solar_exponent  = 4.0
real    :: sw_co2          = 0.0596
real    :: wv_exponent     = 4.0
! only used with wv_exponent > 0:
real    :: ir_tau_eq       = 6.0
real    :: ir_tau_pole     = 1.5
real    :: linear_tau      = 0.1
! only used with wv_exponent=-1 :
real    :: ir_tau_co2_win  = 0.2150
real    :: ir_tau_wv_win1  = 147.11
real    :: ir_tau_wv_win2  = 1.0814e4
! default value set later (according to wv_exponent):
real    :: ir_tau_co2      = -999.
real    :: ir_tau_wv       = -999.
real    :: ir_tau_wv2      = -999.
real    :: window          = -999.
!RG: added carbon dioxide concentration to namelist
real    :: carbon_conc     = 360.0

real, save :: pi, deg_to_rad , rad_to_deg

namelist/radiation_nml/ select_incSW, solar_constant, del_sol, &
           ir_tau_eq, ir_tau_pole, linear_tau, ir_tau_co2, ir_tau_wv,   &
           ir_tau_wv2, atm_abs, sw_diff, del_sw, albedo_value, window,  &
           wv_exponent, solar_exponent, yearLength, yearPhase, obliquity, &
           sw_co2, ir_tau_co2_win, ir_tau_wv_win1, ir_tau_wv_win2, &
           carbon_conc, ozone_in_SW, two_stream_SW

!==================================================================================
!-------------------- diagnostics fields -------------------------------

!integer :: id_olr, id_swdn_sfc, id_swdn_toa, id_lwdn_sfc, id_lwup_sfc, &
!           id_tdt_rad, id_flux_rad, id_flux_lw, id_flux_sw, id_entrop_rad, id_tdt_sw

character(len=10), parameter :: mod_name = 'two_stream'

real :: missing_value = -999.

contains

! ==================================================================================
! ==================================================================================

!subroutine radiation_init(is, ie, js, je, num_levels, axes, Time)
subroutine radiation_init( is, ie, js, je, num_levels, nSx,nSy, axes,   &
                           Time, cst_albedo, myThid )

!-------------------------------------------------------------------------------------
integer, intent(in)               :: is, ie, js, je, num_levels
integer, intent(in)               :: nSx, nSy
integer, intent(in), dimension(4) :: axes
!type(time_type), intent(in)       :: Time
real, intent(in)                  :: Time
real, intent(out)                 :: cst_albedo
integer, intent(in)               :: myThid
!-------------------------------------------------------------------------------------
!integer, dimension(3) :: half = (/1,2,4/)
!integer :: ierr, io
integer         :: iUnit
CHARACTER*(gcm_LEN_MBUF) :: msgBuf
!-----------------------------------------------------------------------------------------
! read namelist and copy to logfile

!    _BARRIER
!    _BEGIN_MASTER(myThid)
     CALL BARRIER(myThid)
     IF ( myThid.EQ.1 ) THEN

     WRITE(msgBuf,'(A)') 'RADIATION_INIT: opening data.atm_gray'
     CALL PRINT_MESSAGE( msgBuf, gcm_stdMsgUnit, gcm_SQZ_R, myThid )
     CALL OPEN_COPY_DATA_FILE(                                      &
                           'data.atm_gray', 'RADIATION_INIT',       &
                           iUnit,                                   &
                           myThid )
!    Read parameters from open data file
     READ(UNIT=iUnit,NML=radiation_nml)
     WRITE(msgBuf,'(A)')                                            &
          'RADIATION_INIT: finished reading data.atm_gray'
     CALL PRINT_MESSAGE( msgBuf, gcm_stdMsgUnit, gcm_SQZ_R, myThid )
!    Close the open data file
#ifdef SINGLE_DISK_IO
     CLOSE(iUnit)
#else
     CLOSE(iUnit,STATUS='DELETE')
#endif /* SINGLE_DISK_IO */

pi    = 4.0*atan(1.)
deg_to_rad = 2.*pi/360.
rad_to_deg = 360.0/2./pi

if ( wv_exponent .eq. -1. ) then
! default value for wv_exponent=-1:
   if ( ir_tau_co2.eq. -999. ) ir_tau_co2 =   3.14
   if ( ir_tau_wv .eq. -999. ) ir_tau_wv  = 199.25
   if ( ir_tau_wv2.eq. -999. ) ir_tau_wv2 =  14.78
   if ( window    .eq. -999. ) window     = 0.3732 ! spectral window for Water Vapour
else
! default value for wv_exponent= 0:
   if ( ir_tau_co2.eq. -999. ) ir_tau_co2 = 0.8678
   if ( ir_tau_wv .eq. -999. ) ir_tau_wv  = 1.9979e+3
   if ( window    .eq. -999. ) window     = 0.0    ! spectral window transparent to LW
endif

initialized = .true.

     ENDIF
     CALL BARRIER(myThid)
     cst_albedo = albedo_value

!-----------------------------------------------------------------------
!------------ initialize diagnostic fields ---------------

!   id_olr = &
!   register_diag_field ( mod_name, 'olr', axes(1:2), Time, &
!              'outgoing longwave radiation', &
!              'watts/m2', missing_value=missing_value               )
!   id_swdn_sfc = &
!   register_diag_field ( mod_name, 'swdn_sfc', axes(1:2), Time, &
!              'SW flux down at surface', &
!              'watts/m2', missing_value=missing_value               )
!   id_swdn_toa = &
!   register_diag_field ( mod_name, 'swdn_toa', axes(1:2), Time, &
!              'SW flux down at TOA', &
!              'watts/m2', missing_value=missing_value               )
!   id_lwup_sfc = &
!   register_diag_field ( mod_name, 'lwup_sfc', axes(1:2), Time, &
!              'LW flux up at surface', &
!              'watts/m2', missing_value=missing_value               )
!   id_lwdn_sfc = &
!   register_diag_field ( mod_name, 'lwdn_sfc', axes(1:2), Time, &
!              'LW flux down at surface', &
!              'watts/m2', missing_value=missing_value               )
!   id_tdt_rad = &
!       register_diag_field ( mod_name, 'tdt_rad', axes(1:3), Time, &
!              'Temperature tendency due to radiation', &
!              'K/s', missing_value=missing_value               )
!   id_tdt_sw  = &
!       register_diag_field ( mod_name, 'tdt_sw', axes(1:3), Time, &
!              'Temperature tendency due to SW radiation', &
!              'K/s', missing_value=missing_value               )
!   id_flux_rad = &
!       register_diag_field ( mod_name, 'flux_rad', axes(half), Time, &
!              'Total radiative flux (positive up)', &
!              'W/m^2', missing_value=missing_value               )
!   id_flux_lw = &
!       register_diag_field ( mod_name, 'flux_lw', axes(half), Time, &
!              'Net longwave radiative flux (positive up)', &
!              'W/m^2', missing_value=missing_value               )
!   id_flux_sw = &
!       register_diag_field ( mod_name, 'flux_sw', axes(half), Time, &
!              'Net shortwave radiative flux (positive up)', &
!              'W/m^2', missing_value=missing_value               )
!   id_entrop_rad = &
!           register_diag_field ( mod_name, 'entrop_rad', axes(1:3), Time, &
!              'Entropy production by radiation', &
!              '1/s', missing_value=missing_value               )

return
end subroutine radiation_init

! ==================================================================================

subroutine radiation_down (is, js, Time_diag, lat, p_half, t, q,      &
                           albedo, o3conc, ozone_column,              &
                           net_surf_sw_down, surf_lw_down,            &
                           dtrans, dtrans_win, b, b_win,              &
                           down, solar_down,                          &
                           myThid )

! Begin the radiation calculation by computing downward fluxes.
! This part of the calculation does not depend on the surface temperature.

integer, intent(in)                 :: is, js
!type(time_type), intent(in)         :: Time_diag
real, intent(in)                    :: Time_diag
real, intent(in) , dimension(:,:)   :: lat
real, intent(out), dimension(:,:)   :: net_surf_sw_down
real, intent(out), dimension(:,:)   :: surf_lw_down
real, intent(in) , dimension(:,:,:) :: t, q, p_half
real, intent(in) , dimension(:,:)   :: albedo
real, intent(in) , dimension(:,:,:) :: o3conc
real, intent(out), dimension(:,:,:) :: ozone_column
real, intent(out), dimension(:,:,:) :: dtrans
real, intent(out), dimension(:,:,:) :: dtrans_win
real, intent(out), dimension(:,:,:) :: b
real, intent(out), dimension(:,:,:) :: b_win
real, intent(out), dimension(:,:,:) :: down
real, intent(out), dimension(:,:,:) :: solar_down
integer, intent(in)                 :: myThid

!integer :: i, j
integer :: k, n
integer :: im, jm
! Variables for seasonal Incoming SW
real    :: tYear, largeTan, cDecl, sDecl, tanDecl
real    :: lgCO2conc

!logical :: used

! -------------------------------------------------------------------------
!real, allocatable, dimension(:,:)   :: swin
real, allocatable, dimension(:,:)   :: ss, solar, solar_tau_0, p2
real, allocatable, dimension(:,:)   :: solar_tau_k, sw_wv, del_sol_tau, mag_fac
real, allocatable, dimension(:,:,:) :: solar_tau, dtrans_sol, down_win
real, allocatable, dimension(:,:)   :: del_tau, tau_0, tau_km, tau_kp, del_tau_win
! MK: Variables for Lacis & Hansen ozone SW scheme
real, allocatable, dimension(:,:,:) :: ozone_mag, ozone_dF0_down
real, allocatable, dimension(:,:)   :: abs_uv_LH, abs_uv_LH_FS
real, allocatable, dimension(:,:)   :: abs_vis_LH, abs_vis_LH_FS
! Variables for seasonal Incoming SW
real, allocatable, dimension(:,:)   :: cLat, sLat, cos_H, HourAng
! -------------------------------------------------------------------------

n = size(t,3)
im = size(t,1)
jm = size(t,2)

! -------------------------------------------------------------------------
!allocate (swin             (im, jm))
allocate (ss               (im, jm))
allocate (solar            (im, jm))
if ( select_incSW .eq. 0 ) then
  allocate (p2             (im, jm))
else
! Variables for seasonal Incoming SW
  allocate (cLat           (im, jm))
  allocate (sLat           (im, jm))
  allocate (cos_H          (im, jm))
  allocate (HourAng        (im, jm))
endif
if ( ozone_in_SW .eq. 1 ) then
  allocate (ozone_mag      (im, jm, n+1))
  allocate (ozone_dF0_down (im, jm, n+1))
  allocate (abs_uv_LH      (im, jm))
  allocate (abs_vis_LH     (im, jm))
  allocate (abs_uv_LH_FS   (im, jm))
  allocate (abs_vis_LH_FS  (im, jm))
endif
if ( solar_exponent .eq. 0. ) then
  allocate (solar_tau_k    (im, jm))
  allocate (sw_wv          (im, jm))
  allocate (del_sol_tau    (im, jm))
  allocate (mag_fac        (im, jm))
  allocate (dtrans_sol     (im, jm, n))
else
  allocate (solar_tau_0    (im, jm))
  allocate (solar_tau      (im, jm, n+1))
endif
if ( wv_exponent .eq. -1. ) then
  allocate (del_tau        (im, jm))
  allocate (del_tau_win    (im, jm))
  allocate (down_win       (im, jm, n+1))
elseif ( wv_exponent .eq. 0. ) then
  allocate (del_tau        (im, jm))
else
  allocate (tau_0          (im, jm))
  allocate (tau_km         (im, jm))
  allocate (tau_kp         (im, jm))
endif
! -------------------------------------------------------------------------

ss  = sin(lat)

if ( select_incSW .eq. 1 .or. ozone_in_SW .eq. 1 ) then
! daily-mean Incoming SW with simple seasonal cycle accounting
!  only for obliquity (i.e., circular orbit planet)

! tYear = time in the solar year, in [0-1]
   tYear = MOD( Time_diag/yearLength + yearPhase , 1.0 )

! Compute the declination angle
! a) approximate estimate of declination angle: relative error is less
!    than 0.03 for current obliq but as large as 0.21 for obliq=60^o
!    xDecl = - obliquity*deg_to_rad * cos(2.*pi*tYear)
! b) unapproximate expression:
   sDecl = -sin( obliquity*deg_to_rad ) * cos(2.*pi*tYear)
   cDecl =  cos( asin( sDecl ) )
endif

if ( select_incSW .eq. 0 ) then
! Original Incoming SW (no seasonal cycle):
   p2 = (1. - 3.*ss*ss)/4.
   solar = 0.25*solar_constant*(1.0 + del_sol*p2 + del_sw * ss)

elseif ( select_incSW .eq. 1 ) then

   largeTan = 1.e+16
   if ( cDecl.EQ.0. ) then
    tanDecl = sign( largeTan, sDecl )
   else
    tanDecl = sDecl / cDecl
   endif

! Compute Insolation
   cLat = cos(lat)
!  sLat = sin(lat)
   sLat = ss
   cos_H = sign( largeTan, sLat )
   where ( cLat .ne. 0. )
     cos_H = sLat/cLat
   endwhere
   cos_H = max( min( - cos_H * tanDecl, 1. ) , -1. )
   HourAng = acos( cos_H )
   solar = (solar_constant/pi)                             &
         *( HourAng*sLat*sDecl + cLat*cDecl*sin(HourAng) )
else
  stop 'invalid select_incSW'
endif

! set the log of CO2 concentration
lgCO2conc = log(carbon_conc/360.)

! set a constant albedo for testing
!albedo(:,:) = albedo_value

if ( solar_exponent .eq. 0. ) then
! (RG) scheme based on dtau/dsigma = bq + amu where b is a function of solar_tau
! ref: Ruth Geen etal, GRL 2016 (supp. information).
! RG: added carbon dioxide log function
  solar_tau_k = 0.
  mag_fac(:,:) = 1. ! 35.0 / sqrt(1224 * (cos(lat(:,:))) ** 2 + 1)

  do k = 1, n
!   sw_wv = exp( 0.01887 / (solar_tau_k + 0.009522)                            &
!              + 1.603 / ( (solar_tau_k + 0.5194)**2 ) )
    sw_wv = solar_tau_k + 0.5194
    sw_wv = exp( 0.01887 / (solar_tau_k + 0.009522)                            &
                 + 1.603 / ( sw_wv*sw_wv ) )
    del_sol_tau(:,:) = ( sw_co2 + 0.0029 * lgCO2conc                           &
                                + sw_wv(:,:) * q(:,:,k) ) * mag_fac(:,:)       &
                     * ( p_half(:,:,k+1) - p_half(:,:,k) ) / p_half(:,:,n+1)
    dtrans_sol(:,:,k) = exp( - del_sol_tau(:,:) )
    solar_tau_k = solar_tau_k + del_sol_tau(:,:)
  end do

  solar_down(:,:,1) = solar(:,:)
  do k = 1,n
    solar_down(:,:,k+1) = solar_down(:,:,k)*dtrans_sol(:,:,k)
  end do

else
! tau proportional to p^solar_exponent, scaled by atm_abs

  solar_tau_0 = (1.0 - sw_diff*ss*ss)*atm_abs

  do k = 1, n+1
    solar_tau(:,:,k) = solar_tau_0(:,:)                                        &
                     *(p_half(:,:,k)/p_half(:,:,n+1))**solar_exponent
  end do

  do k = 1,n+1
    solar_down(:,:,k) = solar(:,:)*exp(-solar_tau(:,:,k))
  end do

endif

if ( ozone_in_SW .eq. 1 ) then
!-------
! MK 2017: Add Lacis and Hansen (JAS, 1974) absorption by ozone,
! and apply Forster and Shine (JGR, 1997) correction.
!-------
! Computes broadband absorption, as fraction of total solar flux at TOA.
! However, O3 band does not significantly overlap with water vapour SW absorption,
! so can safely add O3 heating on top of water vapour heating without changing the
! radiation seen by the water vapour optical depths in Ruth's scheme above.

! o3conc = Ozone VMR on pressure levels.  Need to convert to centimetre of ozone
! to use with Lacis and Hansen scheme.  Make ozone_column array containing
! ozone amount in cm from TOA down to top of level k

! ozone_column(:,:,1:n+1) = Column O3 in cm above level 1 <= k <= n+1

  ozone_column(:,:,1) = 0.
  do k = 1, n
    ozone_column(:,:,k+1) = ozone_column(:,:,k) + (                            &
                          ( 287.1 / (1.38065e-23 * grav) )                     &
                          * ( p_half(:,:,k+1) - p_half(:,:,k) )                &
                          * o3conc(:,:,k) / 2.687e+23                          &
                                                  )
  end do

! Apply magnification factor:
  ozone_mag(:,:,:) = ozone_column(:,:,:) * 35.                                  &
                   / sqrt( 1224.*cDecl*cDecl + 1. )

! Parameterization for fraction of total flux absorbed from LH74:
  do k = 1, n+1

    abs_vis_LH(:,:)   = ( 0.02118 * ozone_mag(:,:,k) ) / (                     &
                          1. + 0.042 * ozone_mag(:,:,k)                        &
                             + 0.000323*ozone_mag(:,:,k)*ozone_mag(:,:,k)      &
                                                         )
  ! FS97 correction:
    abs_vis_LH_FS(:,:) = ( -0.002894 * ozone_mag(:,:,k) + 1.0663 )             &
                       * abs_vis_LH(:,:)

    abs_uv_LH(:,:)   = ( 1.082 * ozone_mag(:,:,k) ) / (                        &
                         ( 1. + 138.6 * ozone_mag(:,:,k) )**0.805              &
                                                      )                        &
                     + ( 0.0658 * ozone_mag(:,:,k) ) / (                       &
                         1. + ( 103.6 * ozone_mag(:,:,k) )**3                  &
                                                       )
  ! FS97 correction:
    abs_uv_LH_FS(:,:) = ( -0.01632 * ozone_mag(:,:,k) + 1.08964 )              &
                      * abs_uv_LH(:,:)

  ! Total downward SW flux absorbed above level k due to ozone heating.
  ! N.B. Flux absorbed in level k = ozone_dF0_down(:,:,k+1) - ozone_dF0_down(:,:,k)
    ozone_dF0_down(:,:,k) = solar(:,:) * ( abs_vis_LH_FS(:,:)                  &
                                         + abs_uv_LH_FS(:,:)                   &
                                         )

  ! Subtract off ozone absorption from total SW flux:
    solar_down(:,:,k) = solar_down(:,:,k) - ozone_dF0_down(:,:,k)

  end do

endif

if ( wv_exponent .eq. -1. ) then
! split LW in 2 bands: water-vapour window and remaining = non-window:
! ref: Ruth Geen etal, GRL 2016 (supp. information).
! RG: added carbon dioxide log function
  do k = 1, n
    del_tau    = ( ir_tau_co2 + 0.2023 * lgCO2conc                             &
                    + ir_tau_wv*log(ir_tau_wv2*q(:,:,k) + 1) )                 &
               * ( p_half(:,:,k+1)-p_half(:,:,k) ) / p_half(:,:,n+1)
    dtrans(:,:,k) = exp( - del_tau )
    del_tau_win   = ( ir_tau_co2_win + 0.0954 * lgCO2conc                      &
                                     + ir_tau_wv_win1*q(:,:,k)                 &
                                     + ir_tau_wv_win2*q(:,:,k)*q(:,:,k) )      &
                  * ( p_half(:,:,k+1)-p_half(:,:,k) ) / p_half(:,:,n+1)
    dtrans_win(:,:,k) = exp( - del_tau_win )
  end do

elseif ( wv_exponent .eq. 0. ) then
  dtrans_win = 1.
! longwave optical thickness function of specific humidity (M.Byrne & P.O'Gorman):
  do k = 1, n
    del_tau    = ( ir_tau_co2 + ir_tau_wv * q(:,:,k) )                         &
               * ( p_half(:,:,k+1)-p_half(:,:,k) ) / p_half(:,:,n+1)
    dtrans(:,:,k) = exp( - del_tau )
  end do

else
  dtrans_win = 1.
! longwave optical thickness function of latitude and pressure
  tau_0 = ir_tau_eq + (ir_tau_pole - ir_tau_eq)*ss*ss

  k = 1
  tau_kp =   tau_0(:,:) * (                                                    &
                  linear_tau * p_half(:,:,k)/p_half(:,:,n+1)                   &
         + (1.0 - linear_tau)*(p_half(:,:,k)/p_half(:,:,n+1))**wv_exponent     &
                          )
  do k = 1, n
    tau_km = tau_kp
    tau_kp = tau_0(:,:) * (                                                    &
                  linear_tau * p_half(:,:,k+1)/p_half(:,:,n+1)                 &
         + (1.0 - linear_tau)*(p_half(:,:,k+1)/p_half(:,:,n+1))**wv_exponent   &
                          )
    dtrans(:,:,k) = exp( -(tau_kp - tau_km) )
  end do

endif

! no radiation from spectral window
b = stefan*t*t*t*t
b_win = window*b
b = (1.0-window)*b

down(:,:,1) = 0.0
do k = 1,n
  down(:,:,k+1)     = down(:,:,k)*dtrans(:,:,k)                        &
                    + b(:,:,k)*(1.0 - dtrans(:,:,k))
end do

if ( wv_exponent .eq. -1. ) then
  down_win(:,:,1) = 0.0
  do k = 1,n
    down_win(:,:,k+1) = down_win(:,:,k)*dtrans_win(:,:,k)              &
                      + b_win(:,:,k)*(1.0 - dtrans_win(:,:,k))
  end do
  down = down + down_win
endif

surf_lw_down     = down(:,:,n+1)
net_surf_sw_down = solar_down(:,:,n+1)*(1. - albedo(:,:))
!swin = solar_down(:,:,1)

!------- downward sw flux surface -------
!     if ( id_swdn_sfc > 0 ) then
!         used = send_data ( id_swdn_sfc, net_surf_sw_down, Time_diag)
!     endif
!------- incoming sw flux toa -------
!     if ( id_swdn_toa > 0 ) then
!         used = send_data ( id_swdn_toa, swin, Time_diag)
!     endif
!------- downward lw flux surface -------
!     if ( id_lwdn_sfc > 0 ) then
!         used = send_data ( id_lwdn_sfc, surf_lw_down, Time_diag)
!     endif

! -------------------------------------------------------------------------
!deallocate (swin)
deallocate (ss, solar)
if ( select_incSW .eq. 0 ) then
  deallocate (p2)
else
! Variables for seasonal Incoming SW
  deallocate (cLat, sLat)
  deallocate (cos_H, HourAng)
endif
if ( solar_exponent .eq. 0. ) then
  deallocate (solar_tau_k, sw_wv, del_sol_tau, mag_fac, dtrans_sol)
else
  deallocate (solar_tau_0, solar_tau)
endif
if ( ozone_in_SW .eq. 1 ) then
  deallocate (ozone_mag, ozone_dF0_down)
  deallocate (abs_uv_LH, abs_vis_LH, abs_uv_LH_FS, abs_vis_LH_FS)
endif
if ( wv_exponent .eq. -1. ) then
  deallocate (del_tau, del_tau_win, down_win)
elseif ( wv_exponent .eq. 0. ) then
  deallocate (del_tau)
else
  deallocate (tau_0, tau_km, tau_kp)
endif
! -------------------------------------------------------------------------

return
end subroutine radiation_down

! ==================================================================================

!subroutine radiation_up (is, js, Time_diag, lat, p_half, t_surf, t, tdt)
subroutine radiation_up ( is, js, Time_diag, lat, p_half, t_surf, t, tdt,      &
                          flux_lw, flux_sw, albedo, ozone_column,              &
                          dtrans, dtrans_win, b, b_win, down, solar_down,      &
                          myThid )

! Now complete the radiation calculation by computing the upward and net fluxes.

integer, intent(in)                 :: is, js
!type(time_type), intent(in)         :: Time_diag
real, intent(in)                    :: Time_diag
real, intent(in) , dimension(:,:)   :: lat
real, intent(in) , dimension(:,:)   :: t_surf
real, intent(in) , dimension(:,:,:) :: t, p_half
real, intent(inout), dimension(:,:,:) :: tdt
real, intent(out), dimension(:,:,:) :: flux_lw
real, intent(out), dimension(:,:,:) :: flux_sw
real, intent(in),  dimension(:,:)   :: albedo
real, intent(in) , dimension(:,:,:) :: ozone_column
real, intent(in),  dimension(:,:,:) :: dtrans
real, intent(in),  dimension(:,:,:) :: dtrans_win
real, intent(in),  dimension(:,:,:) :: b
real, intent(in),  dimension(:,:,:) :: b_win
real, intent(in),  dimension(:,:,:) :: down
real, intent(in),  dimension(:,:,:) :: solar_down
integer, intent(in)                 :: myThid

!integer :: i, j
integer :: k, n
integer :: im, jm
! Variables for seasonal Incoming SW
real    :: tYear, cDecl, sDecl

!logical :: used

! -------------------------------------------------------------------------
real, allocatable, dimension(:,:)   :: solar, b_surf
real, allocatable, dimension(:,:,:) :: tdt_rad, up, up_win, solar_up
!real, allocatable, dimension(:,:,:) :: tdt_sw, flux_rad   ! not used
! MK: Variables for Lacis & Hansen ozone SW scheme
real, allocatable, dimension(:,:,:) :: ozone_mag_up, ozone_dF0_up
real, allocatable, dimension(:,:)   :: abs_uv_LH_up, abs_uv_LH_FS_up
real, allocatable, dimension(:,:)   :: abs_vis_LH_up, abs_vis_LH_FS_up
real, allocatable, dimension(:,:)   :: r_bar
! -------------------------------------------------------------------------

n = size(t,3)
im = size(t,1)
jm = size(t,2)

! -------------------------------------------------------------------------
if( two_stream_SW .eq. 1 ) then
  allocate (solar            (im, jm))
  if ( ozone_in_SW .eq. 1 ) then
    allocate (ozone_mag_up    (im, jm, n+1))
    allocate (ozone_dF0_up    (im, jm, n+1))
    allocate (abs_uv_LH_up    (im, jm))
    allocate (abs_vis_LH_up   (im, jm))
    allocate (abs_uv_LH_FS_up (im, jm))
    allocate (abs_vis_LH_FS_up(im, jm))
    allocate (r_bar           (im, jm))
  endif
endif
allocate (tdt_rad          (im, jm, n))
allocate (up               (im, jm, n+1))
allocate (up_win           (im, jm, n+1))
allocate (solar_up         (im, jm, n+1))
!allocate (tdt_sw           (im, jm, n))    ! not used
!allocate (flux_rad         (im, jm, n+1))  ! not used
allocate (b_surf           (im, jm))
! -------------------------------------------------------------------------

! MK add in solar_up variables
do k = 1,n+1
  solar_up(:,:,k) = albedo(:,:) * solar_down(:,:,n+1)
end do

if ( two_stream_SW .eq. 1 ) then
! MK do upward SW for ozone

! Need solar variables again:
  solar = solar_down(:,:,1)

  if ( ozone_in_SW .eq. 1 ) then
  ! tYear = time in the solar year, in [0-1]
    tYear = MOD( Time_diag/yearLength + yearPhase , 1.0 )

  ! Compute the declination angle
  ! a) approximate estimate of declination angle: relative error is less
  !    than 0.03 for current obliq but as large as 0.21 for obliq=60^o
  !    xDecl = - obliquity*deg_to_rad * cos(2.*pi*tYear)
  ! b) unapproximate expression:
    sDecl = -sin(  obliquity*deg_to_rad ) * cos(2.*pi*tYear)
    cDecl =  cos( asin( sDecl ) )

  ! Lacis and Hansen scheme for absorption of upward SW flux by O3:
  ! Apply magnification factor:

    do k = n+1,1,-1
      ozone_mag_up(:,:,k) = ozone_column(:,:,n+1) * 35. /                      &
                            sqrt( 1224.*cDecl*cDecl + 1. )                     &
                          + 1.9 * ( ozone_column(:,:,n+1)                      &
                                    - ozone_column(:,:,k)                      &
                                  )
    end do

    r_bar(:,:) = ( 0.291 / ( 1. + 0.816*cDecl ) ) + (                          &
                   ( 1. - ( 0.291 / ( 1. + 0.816*cDecl ) ) )                   &
                   * 0.856 * albedo(:,:) / ( 1. - 0.144*albedo(:,:) )          &
                                                    )
  ! LH74 parameterisation for fraction of total solar flux absorbed:

    do k = n+1,1,-1

      abs_vis_LH_up(:,:) = r_bar(:,:) * (0.02118 * ozone_mag_up(:,:,k)) / (    &
                         1. + 0.042 * ozone_mag_up(:,:,k)                      &
                            + 0.000323*ozone_mag_up(:,:,k)*ozone_mag_up(:,:,k) &
                                                                          )
    ! FS97 correction
      abs_vis_LH_FS_up(:,:) = ( -0.002894 * ozone_mag_up(:,:,k) + 1.0663 )     &
                              * abs_vis_LH_up(:,:)

      abs_uv_LH_up(:,:) = r_bar(:,:) * (1.082 * ozone_mag_up(:,:,k)) / (       &
                            ( 1. + 138.6 * ozone_mag_up(:,:,k) )**0.805        &
                                                                       )       &
                        + ( 0.0658 * ozone_mag_up(:,:,k) ) / (                 &
                            1. + ( 103.6 * ozone_mag_up(:,:,k) )**3            &
                                                             )
    ! FS97 correction
      abs_uv_LH_FS_up(:,:) = ( -0.01632 * ozone_mag_up(:,:,k) + 1.08964 )      &
                             * abs_uv_LH_up(:,:)

    ! Total SW flux absorbed along path by reflected radiation up till and including level k.
    ! N.B. Flux absorbed in level k = ozone_dF0_up(:,:,k) - ozone_dF0_up(:,:,k+1)
      ozone_dF0_up(:,:,k) = solar(:,:) * ( abs_vis_LH_FS_up(:,:)               &
                                         + abs_uv_LH_FS_up(:,:)                &
                                         )

    end do

    do k = n,1,-1
    ! Subtract off ozone absorption from total SW flux:
      solar_up(:,:,k) = solar_up(:,:,k)                                        &
                      - ( ozone_dF0_up(:,:,k) - ozone_dF0_up(:,:,n+1) )
    end do

  endif   ! ozone_in_SW

endif   ! two_stream_SW

! total flux from surface
b_surf = stefan*t_surf*t_surf*t_surf*t_surf

! first deal with non-window upward flux
up(:,:,n+1) = b_surf*(1.0-window)
up_win(:,:,n+1) = b_surf*window
do k = n,1,-1
  up(:,:,k) = up(:,:,k+1)*dtrans(:,:,k) + b(:,:,k)*(1.0 - dtrans(:,:,k))
  up_win(:,:,k) = up_win(:,:,k+1)*dtrans_win(:,:,k)            &
                + b_win(:,:,k)*(1.0 - dtrans_win(:,:,k))
end do

! add upward flux in spectral window
up = up + up_win

! MK Compute flux_sw in terms of solar_up, and use flux_sw in tdt calculation
do k = 1,n+1
  flux_lw(:,:,k) = up(:,:,k)-down(:,:,k)   ! LW only, upward +ve
  flux_sw(:,:,k) = solar_down(:,:,k) - solar_up(:,:,k)  ! Net downward SW
! flux_rad(:,:,k) = flux_lw(:,:,k) + flux_sw(:,:,k)   ! not used
end do

if ( two_stream_SW .eq. 1 ) then
  do k = 1,n
    tdt_rad(:,:,k) = ( flux_lw(:,:,k+1) - flux_lw(:,:,k)                  &
                     - flux_sw(:,:,k+1) + flux_sw(:,:,k)                  &
                     )                                                    &
                   * grav / ( cp_air*( p_half(:,:,k+1)-p_half(:,:,k) ) )
  end do
else
  do k = 1,n
    tdt_rad(:,:,k) = ( flux_lw(:,:,k+1) - flux_lw(:,:,k)                  &
                     - solar_down(:,:,k+1) + solar_down(:,:,k) )          &
                   * grav / ( cp_air*( p_half(:,:,k+1)-p_half(:,:,k) ) )
  end do
endif

do k = 1,n
! tdt_sw is not used:
! tdt_sw(:,:,k) = ( - flux_sw(:,:,k+1) + flux_sw(:,:,k) )                 &
!                  * grav / ( cp_air*( p_half(:,:,k+1)-p_half(:,:,k) ) )
  tdt(:,:,k) = tdt(:,:,k) + tdt_rad(:,:,k)
end do

!------- outgoing lw flux toa (olr) -------
!     if ( id_olr > 0 ) then
!         used = send_data ( id_olr, olr, Time_diag)
!     endif
!------- upward lw flux surface -------
!     if ( id_lwup_sfc > 0 ) then
!         used = send_data ( id_lwup_sfc, b_surf, Time_diag)
!     endif
!------- temperature tendency due to radiation ------------
!     if ( id_tdt_rad > 0 ) then
!        used = send_data ( id_tdt_rad, tdt_rad, Time_diag)
!     endif
!     if ( id_tdt_sw > 0 ) then
!        used = send_data ( id_tdt_sw, tdt_sw, Time_diag)
!     endif
!------- total radiative flux (at half levels) -----------
!     if ( id_flux_rad > 0 ) then
!        used = send_data ( id_flux_rad, flux_rad, Time_diag)
!     endif
!------- longwave radiative flux (at half levels) --------
!     if ( id_flux_lw > 0 ) then
!        used = send_data ( id_flux_lw, net, Time_diag)
!     endif
!     if ( id_flux_sw > 0 ) then
!        used = send_data ( id_flux_sw, flux_sw, Time_diag)
!     endif
!     if ( id_entrop_rad > 0 ) then
!        do k=1,n
!           entrop_rad(:,:,k) =tdt_rad(:,:,k)/t(:,:,k)*p_half(:,:,n+1)/1.e5
!        end do
!        used = send_data ( id_entrop_rad, entrop_rad, Time_diag)
!     endif

! -------------------------------------------------------------------------
if ( two_stream_SW .eq. 1 ) then
  deallocate (solar)
  if ( ozone_in_SW .eq. 1 ) then
    deallocate (ozone_mag_up, ozone_dF0_up)
    deallocate (abs_uv_LH_up, abs_vis_LH_up)
    deallocate (abs_uv_LH_FS_up, abs_vis_LH_FS_up, r_bar)
  endif
endif
deallocate (tdt_rad, up, up_win, solar_up)
!deallocate (tdt_sw, flux_rad)  ! not used
deallocate (b_surf)
! -------------------------------------------------------------------------

return
end subroutine radiation_up

! ==================================================================================

subroutine radiation_end

!deallocate (b, tdt_rad, tdt_sw, entrop_rad)
!!deallocate (up, down, net, solar_down, flux_rad, flux_sw)
!deallocate (up, net, flux_rad, flux_sw)
!deallocate (b_surf, olr, swin, albedo)
!!deallocate (dtrans)
!deallocate (tau, solar_tau)
!deallocate (ss, solar, tau_0, solar_tau_0, p2)

end subroutine radiation_end

! ==================================================================================

end module radiation_mod

#include "ECCO_OPTIONS.h"

      subroutine cost_averagesgeneric(
     &     localbarfile,
     &     localbar, localfld, xx_localbar_mean_dummy,
     &     first, last, startofloc, endofloc, inloc,
     &     sum1loc, locrec, nnz, myThid )

c     ==================================================================
c     SUBROUTINE cost_averagesgeneric
c     ==================================================================
c
c     o Compute time averages of cost variables
c
c     ==================================================================
c     SUBROUTINE cost_averagesgeneric
c     ==================================================================

      implicit none

c     == global variables ==

#include "EEPARAMS.h"
#include "SIZE.h"
#include "PARAMS.h"

#ifdef ALLOW_ECCO
# include "ECCO_SIZE.h"
# include "ECCO.h"
#endif

c     == routine arguments ==

      integer myThid
      integer nnz
      integer locrec
      integer sum1loc

      _RL localbar(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nnz,nSx,nSy)
      _RL localfld(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nnz,nSx,nSy)
      _RL xx_localbar_mean_dummy

      logical first
      logical last
      logical startofloc
      logical endofloc
      logical inloc

      character*(MAX_LEN_FNAM) localbarfile

c     == local variables ==

      integer bi,bj
      integer i,j,k
      integer itlo,ithi
      integer jtlo,jthi
      integer jmin,jmax
      integer imin,imax

      integer il

      character*(128) fname
#ifdef ALLOW_ECCO_DEBUG
      character*(max_len_mbuf) msgbuf
#endif

c     == external functions ==

      integer  ilnblnk
      external ilnblnk

c     == end of interface ==

#ifdef ALLOW_ECCO_DEBUG
       write(msgbuf,'(a)') '>> entering'
        call print_message( msgbuf, standardmessageunit,
     &                    SQUEEZE_RIGHT , myThid)

       il=ilnblnk( localbarfile )
       write(msgbuf,'(a,a)')
     & 'cost_averagesgeneric, file : ',localbarfile(1:il)
       call print_message( msgbuf, standardmessageunit,
     &                    SQUEEZE_RIGHT , myThid)

       write(msgbuf,'(a,5L5)')
     & 'cost_averagesgeneric, logicals : ',
     &  first, last, startofloc, endofloc, inloc
       call print_message( msgbuf, standardmessageunit,
     &                    SQUEEZE_RIGHT , myThid)

       write(msgbuf,'(a,3i5)')
     & 'cost_averagesgeneric, integers : ',
     &  sum1loc, locrec, nnz
       call print_message( msgbuf, standardmessageunit,
     &                    SQUEEZE_RIGHT , myThid)

       write(msgbuf,'(a)') '<< leaving'
        call print_message( msgbuf, standardmessageunit,
     &                    SQUEEZE_RIGHT , myThid)
#endif

      jtlo = myByLo(myThid)
      jthi = myByHi(myThid)
      itlo = myBxLo(myThid)
      ithi = myBxHi(myThid)
      jmin = 1
      jmax = sNy
      imin = 1
      imax = sNx

      if (startofloc .and. endofloc) then
c--     Save snapshot at every time step
        do bj = jtlo,jthi
          do bi = itlo,ithi
            do k = 1,nnz
              do j = jmin,jmax
                do i = imin,imax
                  localbar(i,j,k,bi,bj) = localfld(i,j,k,bi,bj)
                enddo
              enddo
            enddo
          enddo
        enddo
c--     Save ...bar on file.
        il=ilnblnk( localbarfile )
        write(fname,'(2a,i10.10)')
     &       localbarfile(1:il), '.', eccoiter
#ifdef ALLOW_AUTODIFF
        if ( nnz .EQ. 1 ) then
           call active_write_xy( fname, localbar, locrec, eccoiter,
     &          myThid, xx_localbar_mean_dummy )
        else
           call active_write_xyz( fname, localbar, locrec, eccoiter,
     &          myThid, xx_localbar_mean_dummy )
        endif
#else
        if ( nnz .EQ. 1 ) then
           CALL WRITE_REC_XY_RL( fname, localbar, locrec, 1, myThid )
        else
           CALL WRITE_REC_XYZ_RL( fname, localbar, locrec, 1, myThid )
        endif
#endif

      elseif (first .or. startofloc) then
c--     Assign the first value to the array holding the average.
        do bj = jtlo,jthi
          do bi = itlo,ithi
            do k = 1,nnz
              do j = jmin,jmax
                do i =  imin,imax
                  localbar(i,j,k,bi,bj) = localfld(i,j,k,bi,bj)
                enddo
              enddo
            enddo
          enddo
        enddo
      else if (last .or. endofloc) then
c--     Add the last value and devide by the number of accumulated records.
        do bj = jtlo,jthi
          do bi = itlo,ithi
            do k = 1,nnz
              do j = jmin,jmax
                do i = imin,imax
                  localbar(i,j,k,bi,bj) =
     &                  (localbar(i,j,k,bi,bj)
     &                  +localfld(i,j,k,bi,bj))/
     &                  float(sum1loc)
                enddo
              enddo
            enddo
          enddo
        enddo
c--     Save ...bar on file.
        il=ilnblnk( localbarfile )
        write(fname,'(2a,i10.10)')
     &       localbarfile(1:il), '.', eccoiter
#ifdef ALLOW_AUTODIFF
        if ( nnz .EQ. 1 ) then
           call active_write_xy( fname, localbar, locrec, eccoiter,
     &          myThid, xx_localbar_mean_dummy )
        else
           call active_write_xyz( fname, localbar, locrec, eccoiter,
     &          myThid, xx_localbar_mean_dummy )
        endif
#else
        if ( nnz .EQ. 1 ) then
           CALL WRITE_REC_XY_RL( fname, localbar, locrec, 1, myThid )
        else
           CALL WRITE_REC_XYZ_RL( fname, localbar, locrec, 1, myThid )
        endif
#endif
      else if (       (       inloc        ) .and.
     &          .not. (first .or. startofloc) .and.
     &          .not. (last  .or. endofloc  )       ) then
c--     Accumulate the array holding the average.
        do bj = jtlo,jthi
          do bi = itlo,ithi
            do j = jmin,jmax
              do k = 1,nnz
                do i = imin,imax
                  localbar(i,j,k,bi,bj) =
     &                  localbar(i,j,k,bi,bj) + localfld(i,j,k,bi,bj)
                enddo
              enddo
            enddo
          enddo
        enddo
      else
        stop   'in cost_averagesgeneric'
      endif

      return
      end

#include "SHELFICE_OPTIONS.h"

CBOP
C !ROUTINE: SHELFICE_U_DRAG_COEFF

C !INTERFACE: ==========================================================
      SUBROUTINE SHELFICE_U_DRAG_COEFF(
     I        bi, bj, k, inp_KE,
     I        uFld, vFld, kappaRU,
     U        KE,
     O        cDrag,
     I        myIter, myThid )

C !DESCRIPTION:
C Calculates the drag coefficient due to friction and the no-slip condition
C at the bottom of the shelf-ice (in analogy to bottom drag)
C such as the ice-shelf stress: taux_{ice} = -Cd * U_{top} * rUnit2mass ;

C !USES: ===============================================================
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "SHELFICE.h"

C !INPUT PARAMETERS: ===================================================
C  bi,bj          :: tile indices
C  k              :: vertical level to process
C  inp_KE         :: =T : KE is provided as input ; =F : to compute here
C  uFld           :: velocity, zonal component
C  vFld           :: velocity, meridional component
C  kappaRU        :: vertical viscosity
C  KE             :: Kinetic energy (input when inp_KE = T)
C  myIter         :: current iteration number
C  myThid         :: my Thread Id number
      INTEGER bi, bj, k
      LOGICAL inp_KE
      _RL uFld   (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL vFld   (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL KE     (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL kappaRU(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr+1)
      INTEGER myIter, myThid

C !OUTPUT PARAMETERS: ==================================================
C  KE             :: Kinetic energy (output when inp_KE = F)
C  cDrag          :: bottom drag coefficient
      _RL cDrag  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)

#ifdef ALLOW_SHELFICE
C !LOCAL VARIABLES : ====================================================
C  i,j            :: loop indices
C  Kp1            :: =k+1 for k<Nr, =Nr for k>=Nr
      INTEGER i, j
      INTEGER kUpC, kTop
      _RL viscFac, dragFac, uSq
      _RL rDrCkp1
CEOP

C-  No-slip BCs impose a drag at top
      IF ( usingZCoords ) THEN
       kTop    = 1
       kUpC    = k
c      dragFac = mass2rUnit*rhoConst
       dragFac = 1. _d 0
      ELSE
       kTop    = Nr
       kUpC    = k+1
       dragFac = mass2rUnit*rhoConst
      ENDIF
      rDrCkp1 = recip_drC(kUpC)
CML      IF (k.EQ.kTop) rDrCkp1=recip_drF(k)
      viscFac = 0. _d 0
      IF (no_slip_shelfice) viscFac = 2. _d 0

C--   Initialise drag-coeff
      DO j=1-OLy,sNy+OLy
       DO i=1-OLx,sNx+OLx
         cDrag(i,j) = 0. _d 0
       ENDDO
      ENDDO

C--   Friction at the bottom of ice-shelf (no-slip BC)
      IF ( no_slip_shelfice .AND. bottomVisc_pCell ) THEN
C-    friction accounts for true distance (including hFac) to the surface
       DO j=1-OLy,sNy+OLy-1
        DO i=1-OLx+1,sNx+OLx-1
         IF ( k.EQ.MAX( kTopC(i-1,j,bi,bj),kTopC(i,j,bi,bj) ) ) THEN
           cDrag(i,j) = cDrag(i,j)
     &                + kappaRU(i,j,kUpC)*rDrCkp1*viscFac
     &                        * _recip_hFacW(i,j,k,bi,bj)
         ENDIF
        ENDDO
       ENDDO
      ELSEIF ( no_slip_shelfice ) THEN
C-    ignores partial-cell reduction of the distance to the surface
       DO j=1-OLy,sNy+OLy-1
        DO i=1-OLx+1,sNx+OLx-1
         IF ( k.EQ.MAX( kTopC(i-1,j,bi,bj),kTopC(i,j,bi,bj) ) ) THEN
           cDrag(i,j) = cDrag(i,j)
     &                + kappaRU(i,j,kUpC)*rDrCkp1*viscFac
         ENDIF
        ENDDO
       ENDDO
      ENDIF

C--   Add Linear drag contribution:
      IF ( SHELFICEDragLinear.NE.zeroRL ) THEN
       DO j=1-OLy,sNy+OLy
        DO i=1-OLx+1,sNx+OLx
         IF ( k.EQ.MAX( kTopC(i-1,j,bi,bj),kTopC(i,j,bi,bj) ) ) THEN
          cDrag(i,j) = cDrag(i,j) + SHELFICEDragLinear*dragFac
         ENDIF
        ENDDO
       ENDDO
      ENDIF

C--   Add quadratic drag
      IF ( SHELFICEselectDragQuadr.EQ.0 ) THEN
       IF ( .NOT.inp_KE ) THEN
         DO j=1-OLy,sNy+OLy-1
          DO i=1-OLx,sNx+OLx-1
            KE(i,j) = 0.25*(
     &          ( uFld( i , j )*uFld( i , j )*_hFacW(i,j,k,bi,bj)
     &           +uFld(i+1, j )*uFld(i+1, j )*_hFacW(i+1,j,k,bi,bj) )
     &        + ( vFld( i , j )*vFld( i , j )*_hFacS(i,j,k,bi,bj)
     &           +vFld( i ,j+1)*vFld( i ,j+1)*_hFacS(i,j+1,k,bi,bj) )
     &                     )*_recip_hFacC(i,j,k,bi,bj)
          ENDDO
         ENDDO
       ENDIF
C-    average grid-cell-center KE to get velocity norm @ U.pt
       DO j=1-OLy,sNy+OLy-1
        DO i=1-OLx+1,sNx+OLx-1
          uSq = 0. _d 0
          IF ( k.EQ.MAX( kTopC(i-1,j,bi,bj),kTopC(i,j,bi,bj) ) ) THEN
           uSq = KE(i,j)+KE(i-1,j)
          ENDIF
          IF ( uSq.GT.zeroRL ) THEN
           cDrag(i,j) = cDrag(i,j)
     &                + shiDragQuadFld(i,j,bi,bj)*SQRT(uSq)*dragFac
          ENDIF
        ENDDO
       ENDDO
      ELSEIF ( SHELFICEselectDragQuadr.EQ.1 ) THEN
C-    calculate locally velocity norm @ U.pt (local U & 4 V averaged)
       DO j=1-OLy,sNy+OLy-1
        DO i=1-OLx+1,sNx+OLx-1
          uSq = 0. _d 0
          IF ( k.EQ.MAX( kTopC(i-1,j,bi,bj),kTopC(i,j,bi,bj) ) ) THEN
           uSq = uFld(i,j)*uFld(i,j)
     &       + ( (vFld(i-1, j )*vFld(i-1, j )*hFacS(i-1, j ,k,bi,bj)
     &           +vFld( i , j )*vFld( i , j )*hFacS( i , j ,k,bi,bj))
     &         + (vFld(i-1,j+1)*vFld(i-1,j+1)*hFacS(i-1,j+1,k,bi,bj)
     &           +vFld( i ,j+1)*vFld( i ,j+1)*hFacS( i ,j+1,k,bi,bj))
     &         )*recip_hFacW(i,j,k,bi,bj)*0.25 _d 0
          ENDIF
          IF ( uSq.GT.zeroRL ) THEN
           cDrag(i,j) = cDrag(i,j)
     &                + shiDragQuadFld(i,j,bi,bj)*SQRT(uSq)*dragFac
          ENDIF
        ENDDO
       ENDDO
      ELSEIF ( SHELFICEselectDragQuadr.EQ.2 ) THEN
C-    same as above but using wet-point method to average 4 V
       DO j=1-OLy,sNy+OLy-1
        DO i=1-OLx+1,sNx+OLx-1
          uSq = 0. _d 0
          IF ( k.EQ.MAX( kTopC(i-1,j,bi,bj),kTopC(i,j,bi,bj) ) ) THEN
           uSq = ( hFacS(i-1, j ,k,bi,bj) + hFacS( i , j ,k,bi,bj) )
     &         + ( hFacS(i-1,j+1,k,bi,bj) + hFacS( i ,j+1,k,bi,bj) )
           IF ( uSq.GT.zeroRL ) THEN
            uSq = uFld(i,j)*uFld(i,j)
     &        +( (vFld(i-1, j )*vFld(i-1, j )*hFacS(i-1, j ,k,bi,bj)
     &           +vFld( i , j )*vFld( i , j )*hFacS( i , j ,k,bi,bj))
     &         + (vFld(i-1,j+1)*vFld(i-1,j+1)*hFacS(i-1,j+1,k,bi,bj)
     &           +vFld( i ,j+1)*vFld( i ,j+1)*hFacS( i ,j+1,k,bi,bj))
     &         )/uSq
           ELSE
            uSq = uFld(i,j)*uFld(i,j)
           ENDIF
          ENDIF
          IF ( uSq.GT.zeroRL ) THEN
           cDrag(i,j) = cDrag(i,j)
     &                + shiDragQuadFld(i,j,bi,bj)*SQRT(uSq)*dragFac
          ENDIF
        ENDDO
       ENDDO
      ENDIF

#ifdef ALLOW_DIAGNOSTICS
      IF ( useDiagnostics .AND.
     &     ( no_slip_shelfice .OR. SHELFICEDragLinear.NE.zeroRL
     &                        .OR. SHELFICEselectDragQuadr.GE.0 )
     &   ) THEN
       IF ( selectImplicitDrag.EQ.0 ) THEN
C-     Explicit case: diagnose directly the Ice-Shelf stress
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           shelficeDragU(i,j,bi,bj) = shelficeDragU(i,j,bi,bj)
     &                              - cDrag(i,j)*uFld(i,j)*rUnit2mass
          ENDDO
         ENDDO
       ELSE
C-     Implicit case: save drag-coeff for diagnostics of the Ice-Shelf stress
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           shelficeDragU(i,j,bi,bj) = shelficeDragU(i,j,bi,bj)
     &                              + cDrag(i,j)*rUnit2mass
          ENDDO
         ENDDO
       ENDIF
      ENDIF
#endif /* ALLOW_DIAGNOSTICS */
#endif /* ALLOW_SHELFICE */

      RETURN
      END

#include "FLT_OPTIONS.h"

CBOP 0
C !ROUTINE: FLT_TRAJ

C !INTERFACE:
      SUBROUTINE FLT_TRAJ (
     I                      myTime, myIter, myThid )

C     !DESCRIPTION:
C     *==========================================================*
C     | SUBROUTINE FLT_TRAJ
C     | o This routine samples the model state at float position
C     |   every flt_int_traj time steps and writes output.
C     *==========================================================*

C     !USES:
      IMPLICIT NONE
C     == global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "DYNVARS.h"
#include "FLT_SIZE.h"
#include "FLT.h"
#include "FLT_BUFF.h"
#ifdef ALLOW_EXCH2
#include "W2_EXCH2_SIZE.h"
#include "W2_EXCH2_TOPOLOGY.h"
#endif

C     !INPUT PARAMETERS:
C     myTime :: current time in simulation
C     myIter :: current iteration number
C     myThid :: my Thread Id number
      _RL myTime
      INTEGER myIter, myThid

C     !FUNCTIONS:
      _RL FLT_MAP_K2R
      EXTERNAL FLT_MAP_K2R

C     !LOCAL VARIABLES:
      INTEGER bi, bj, nFlds
      INTEGER ip, kp, ii
      _RL ix, jy, i0x, j0y, xx, yy, zz
      _RL uu, vv, tt, ss, pp

      INTEGER imax
      PARAMETER (imax=13)
      _RL tmp(imax)
      _RL npart_read, npart_times
      _RS dummyRS(1)
      INTEGER fp, ioUnit, irecord
      CHARACTER*(MAX_LEN_FNAM) fn
      CHARACTER*(MAX_LEN_MBUF) msgBuf
#ifdef ALLOW_EXCH2
      INTEGER nT
#endif
CEOP

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C--   set number of fields to write
      nFlds = 0
      IF ( flt_selectTrajOutp.GE.1 ) nFlds = nFlds + 8
      IF ( flt_selectTrajOutp.GE.2 ) nFlds = nFlds + 5

C--   check buffer size
      IF ( nFlds.GT.fltBufDim ) THEN
         _BEGIN_MASTER(myThid)
         WRITE(msgBuf,'(3(A,I4))') ' FLT_TRAJ: fltBufDim=', fltBufDim,
     &                             ' too small (<', nFlds, ' )'
         CALL PRINT_ERROR( msgBuf, myThid )
         WRITE(msgBuf,'(2A)')     ' FLT_TRAJ: => increase fltBufDim',
     &                            ' in "FLT_SIZE.h" & recompile'
         CALL PRINT_ERROR( msgBuf, myThid )
         _END_MASTER(myThid)
         CALL ALL_PROC_DIE( myThid )
         STOP 'ABNORMAL END: S/R FLT_TRAJ'
      ENDIF

      IF ( myIter.EQ.nIter0 .OR. flt_selectTrajOutp.LE.0 ) RETURN

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C--   Calculate position + other fields at float position and fill up IO-buffer

      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)

#ifdef ALLOW_EXCH2
         nT = W2_myTileList(bi,bj)
         i0x = DFLOAT( exch2_txGlobalo(nT) - 1 )
         j0y = DFLOAT( exch2_tyGlobalo(nT) - 1 )
#else
         i0x = DFLOAT( myXGlobalLo-1 + (bi-1)*sNx )
         j0y = DFLOAT( myYGlobalLo-1 + (bj-1)*sNy )
#endif
         DO ip=1,npart_tile(bi,bj)

            ix = ipart(ip,bi,bj)
            jy = jpart(ip,bi,bj)
            CALL FLT_MAP_IJLOCAL2XY( xx, yy,
     I                               ix, jy, bi,bj, myThid )
            zz = FLT_MAP_K2R( kpart(ip,bi,bj),bi,bj,myThid )
            kp = NINT(kpart(ip,bi,bj))
            tmp(1) = npart(ip,bi,bj)
            tmp(2) = myTime
            tmp(3) = xx
            tmp(4) = yy
            tmp(5) = zz
            tmp(6) = ix + i0x
            tmp(7) = jy + j0y
            tmp(8) = kpart(ip,bi,bj)

            IF ( ( flt_selectTrajOutp.GE.2 )   .AND.
     &           ( myTime.GE.tstart(ip,bi,bj)) .AND.
     &           ( tend(ip,bi,bj).EQ.-1. .OR. myTime.LE.tend(ip,bi,bj))
     &         ) THEN
              IF ( kp.LT.1 .OR. kp.GT.Nr ) THEN
                WRITE(msgBuf,'(2A,I8)') '** WARNING ** FLT_TRAJ: ',
     &            ' illegal value for kp=',kp
                CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                              SQUEEZE_RIGHT, myThid )
                WRITE(msgBuf,'(A,1P5E20.13)')
     &            ' FLT_TRAJ: ', (flt_io_buff(ii,ip,bi,bj),ii=1,5)
                CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                              SQUEEZE_RIGHT, myThid )
c               CALL PRINT_ERROR( msgBuf, myThid )
c               STOP 'ABNORMAL END: S/R FLT_TRAJ'
C-- jmc: not sure if this is right but added to avoid Pb in FLT_BILINEAR:
                kp = MIN( MAX(kp,1), Nr)
              ENDIF
              CALL FLT_BILINEAR  (ix,jy,uu,uVel,  kp,1,bi,bj,myThid)
              CALL FLT_BILINEAR  (ix,jy,vv,vVel,  kp,2,bi,bj,myThid)
              CALL FLT_BILINEAR2D(ix,jy,pp,etaN,     0,bi,bj,myThid)
              CALL FLT_BILINEAR  (ix,jy,tt,theta, kp,0,bi,bj,myThid)
              CALL FLT_BILINEAR  (ix,jy,ss,salt,  kp,0,bi,bj,myThid)
              tmp( 9) = pp
              tmp(10) = uu
              tmp(11) = vv
              tmp(12) = tt
              tmp(13) = ss
            ELSEIF ( flt_selectTrajOutp.GE.2 ) THEN
              tmp( 9) = flt_nan
              tmp(10) = flt_nan
              tmp(11) = flt_nan
              tmp(12) = flt_nan
              tmp(13) = flt_nan
            ENDIF

            DO ii=1,nFlds
              flt_io_buff(ii,ip,bi,bj) = tmp(ii)
            ENDDO

         ENDDO

       ENDDO
      ENDDO

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C--   Write shared buffer to file

      _BARRIER
      _BEGIN_MASTER(myThid)

      fn = 'float_trajectories'
      fp = writeBinaryPrec

      DO bj=1,nSy
       DO bi=1,nSx

C (1) read actual number floats from file (if exists)
         ioUnit = -2
         CALL MDS_READVEC_LOC(  fn, fp, ioUnit, 'RL', nFlds,
     O                          tmp, dummyRS,
     I                          bi, bj, 1, myThid )
         IF ( ioUnit.GT. 0 ) THEN
            npart_read  = tmp(1)
            npart_times = tmp(5)
            ii = NINT(tmp(7))
C-       for backward compatibility with old trajectory files:
            IF ( ii.EQ.0 ) ii = 13
            IF ( ii.NE.nFlds ) THEN
              WRITE(msgBuf,'(A,I4,A)')
     &            'FLT_TRAJ: nFlds=', nFlds,' different from'
              CALL PRINT_ERROR( msgBuf, myThid )
              WRITE(msgBuf,'(3A,I4,A)')
     &            'previous file (',fn(1:18),') value =',ii
              CALL PRINT_ERROR( msgBuf, myThid )
              CALL ALL_PROC_DIE( 0 )
              STOP 'ABNORMAL END: S/R FLT_TRAJ'
            ENDIF
C-       close the read-unit (safer to use a different unit for writing)
            CLOSE( ioUnit )
         ELSE
            npart_read  = 0.
            npart_times = 0.
            tmp(2)      = myTime
         ENDIF

C (2) write new actual number floats and time axis into file
C-    the standard routine mds_writevec_loc can be used here

C     total number of records in this file
         tmp(1) = DBLE(npart_tile(bi,bj))+npart_read
C     first time of writing floats (do not change when written)
c        tmp(2) = tmp(2)
C     current time
         tmp(3) = myTime
C     timestep
         tmp(4) = flt_int_traj
C     total number of timesteps
         tmp(5) = npart_times + 1.
C     total number of floats
         tmp(6) = max_npart
C     total number of fields
         tmp(7) = nFlds
         DO ii=8,nFlds
           tmp(ii) = 0.
         ENDDO
         ioUnit = -1
         CALL MDS_WRITEVEC_LOC( fn, fp, ioUnit, 'RL', nFlds,
     &                          tmp, dummyRS,
     &                          bi, bj, -1, myIter, myThid )

         DO ip=1,npart_tile(bi,bj)
C (3) write float positions into file
            irecord = npart_read+ip+1
            IF ( ip.NE.npart_tile(bi,bj) ) irecord = -irecord
            CALL MDS_WRITEVEC_LOC( fn, fp, ioUnit, 'RL', nFlds,
     I                             flt_io_buff(1,ip,bi,bj), dummyRS,
     I                             bi, bj, irecord, myIter, myThid )
         ENDDO
         CLOSE( ioUnit )

       ENDDO
      ENDDO

      _END_MASTER(myThid)
      _BARRIER

      RETURN
      END

#include "CPP_EEOPTIONS.h"

CBOP
C     !ROUTINE: IFNBLNK

C     !INTERFACE:
      subroutine oad_s_IFNBLNK( string, index )
      IMPLICIT NONE

C     !DESCRIPTION:
C     *==========================================================*
C     | FUNCTION IFNBLNK                                         |
C     | o Find first non-blank in character string.              |
C     *==========================================================*
C
C     !INPUT PARAMETERS:
C     string :: String to find first non-blank in.
      CHARACTER*(*) string
      integer index

C     !LOCAL VARIABLES:
C     L, LS :: Temps for string locations
      INTEGER L, LS
CEOP
C
      LS     = LEN(string)
      index = 0
      L=1
      DO while ((L.le.LS).and.(string(L:L) .eq. ' '))
        L=L+1
      end do
      index = L
      END

#include "BLING_OPTIONS.h"
#ifdef ALLOW_EXF
# include "EXF_OPTIONS.h"
#endif

CBOP
      subroutine BLING_INI_FORCING( myThid )

C     ==========================================================
C     | subroutine bling_ini_forcing
C     | o Initialize forcing fields
C     ==========================================================

      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#ifdef ALLOW_EXF
# include "EXF_INTERP_SIZE.h"
#endif
#include "BLING_VARS.h"
#include "BLING_LOAD.h"

C !INPUT PARAMETERS: ===================================================
C  myThid               :: thread number
      INTEGER myThid
CEOP

#ifdef ALLOW_BLING

c !LOCAL VARIABLES: ===================================================
       INTEGER bi,bj,i,j
#ifdef USE_BLING_V1
       CHARACTER*(MAX_LEN_MBUF) msgBuf
#endif

C First call requires that we initialize everything to zero for safety
      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
         BLING_ldRec(bi,bj) = 0
       ENDDO
      ENDDO
      CALL LEF_ZERO( dicwind0,myThid )
      CALL LEF_ZERO( dicwind1,myThid )
      CALL LEF_ZERO( atmosp0,myThid )
      CALL LEF_ZERO( atmosp1,myThid )
      CALL LEF_ZERO( silica0,myThid )
      CALL LEF_ZERO( silica1,myThid )
      CALL LEF_ZERO( ice0,myThid )
      CALL LEF_ZERO( ice1,myThid )
      CALL LEF_ZERO( feinput0,myThid )
      CALL LEF_ZERO( feinput1,myThid )

#ifdef USE_BLING_V1
#ifdef USE_SIBLING
        WRITE(msgBuf,'(2A)')
     &       ' BLING_INI_FORCING: You can not have USE_SIBLING ',
     &       ' with USE_BLING_V1'
        CALL PRINT_ERROR( msgBuf, myThid )
        STOP 'ABNORMAL END: S/R BLING_INI_FORCING'
#endif
#ifdef USE_BLING_DVM
        WRITE(msgBuf,'(2A)')
     &       ' BLING_INI_FORCING: You can not have USE_BLING_DVM ',
     &       ' with USE_BLING_V1'
        CALL PRINT_ERROR( msgBuf, myThid )
        STOP 'ABNORMAL END: S/R BLING_INI_FORCING'
#endif
#ifdef ADVECT_PHYTO
        WRITE(msgBuf,'(2A)')
     &       ' BLING_INI_FORCING: You can not use ADVECT_PHYTO ',
     &       ' with USE_BLING_V1'
        CALL PRINT_ERROR( msgBuf, myThid )
        STOP 'ABNORMAL END: S/R BLING_INI_FORCING'
#endif
#endif /* USE_BLING_V1 */

c set reasonable values to those that need at least something
       DO bj = myByLo(myThid), myByHi(myThid)
        DO bi = myBxLo(myThid), myBxHi(myThid)
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
             apco2(i,j,bi,bj) = bling_pCO2*maskC(i,j,1,bi,bj)
             wind(i,j,bi,bj)     = 5. _d 0*maskC(i,j,1,bi,bj)
             atmosP(i,j,bi,bj)   = 1. _d 0*maskC(i,j,1,bi,bj)
             fIce(i,j,bi,bj)     = 0. _d 0
             fluxCO2(i,j,bi,bj)  = 0. _d 0
             InputFe(i,j,bi,bj)  = 1. _d -11*maskC(i,j,1,bi,bj)
             silica(i,j,bi,bj)   = 7.6838 _d -3*maskC(i,j,1,bi,bj)
          ENDDO
         ENDDO
        ENDDO
       ENDDO

#ifdef ALLOW_EXF
      IF ( useEXF ) THEN
       IF ( apco2file .NE. ' ' ) THEN
      CALL EXF_INIT_FLD(
     I     'apco2', apco2file, apco2mask,
     I     apco2period, exf_inscal_apco2, apco2const,
     O     apco2, apco20, apco21,
# ifdef USE_EXF_INTERPOLATION
     I     apco2_lon0, apco2_lon_inc,
     I     apco2_lat0, apco2_lat_inc,
     I     apco2_nlon, apco2_nlat, xC, yC, apco2_interpMethod,
# endif
     I     myThid )
       ENDIF
      ENDIF
#endif /* ALLOW_EXF */

#endif /* ALLOW_BLING */
      RETURN
      END

#include "KPP_OPTIONS.h"
#ifdef ALLOW_AUTODIFF
# include "AUTODIFF_OPTIONS.h"
#endif
#ifdef ALLOW_SALT_PLUME
# include "SALT_PLUME_OPTIONS.h"
#endif

C-- File kpp_calc.F:
C--  Contents
C--  o KPP_CALC         - Main KPP interface routine.
C--  o KPP_CALC_DUMMY   - Dummy routine for TAF

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C !ROUTINE: KPP_CALC

C !INTERFACE: ==========================================================
      SUBROUTINE KPP_CALC(
     I     bi, bj, myTime, myIter, myThid )

C !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE KPP_CALC                                      |
C     | o Compute all KPP fields defined in KPP.h                |
C     *==========================================================*
C     | This subroutine serves as an interface between MITGCMUV  |
C     | code and NCOM 1-D routines in kpp_routines.F             |
C     *==========================================================*

c=======================================================================
c
c     written  by  : jan morzel, august  11, 1994
c     modified by  : jan morzel, january 25, 1995 : "dVsq" and 1d code
c                    detlef stammer, august, 1997 : for MIT GCM Classic
c                    d. menemenlis,    july, 1998 : for MIT GCM UV
c
c     compute vertical mixing coefficients based on the k-profile
c     and oceanic planetary boundary layer scheme by large & mcwilliams.
c
c     summary:
c     - compute interior mixing everywhere:
c       interior mixing gets computed at all interfaces due to constant
c       internal wave background activity ("fkpm" and "fkph"), which
c       is enhanced in places of static instability (local richardson
c       number < 0).
c       Additionally, mixing can be enhanced by adding contribution due
c       to shear instability which is a function of the local richardson
c       number
c     - double diffusivity:
c       interior mixing can be enhanced by double diffusion due to salt
c       fingering and diffusive convection (ifdef "kmixdd").
c     - kpp scheme in the boundary layer:
c
c       a.boundary layer depth:
c         at every gridpoint the depth of the oceanic boundary layer
c         ("hbl") gets computed by evaluating bulk richardson numbers.
c       b.boundary layer mixing:
c         within the boundary layer, above hbl, vertical mixing is
c         determined by turbulent surface fluxes, and interior mixing at
c         the lower boundary, i.e. at hbl.
c
c     this subroutine provides the interface between the MITGCM and
c     the routine "kppmix", where boundary layer depth, vertical
c     viscosity, vertical diffusivity, and counter gradient term (ghat)
c     are computed slabwise.
c     note: subroutine "kppmix" uses m-k-s units.
c
c     time level:
c     input tracer and velocity profiles are evaluated at time level
c     tau, surface fluxes come from tau or tau-1.
c
c     grid option:
c     in this "1-grid" implementation, diffusivity and viscosity
c     profiles are computed on the "t-grid" (by using velocity shear
c     profiles averaged from the "u,v-grid" onto the "t-grid"; note, that
c     the averaging includes zero values on coastal and seafloor grid
c     points).  viscosity on the "u,v-grid" is computed by averaging the
c     "t-grid" viscosity values onto the "u,v-grid".
c
c     vertical grid:
c     mixing coefficients get evaluated at the bottom of the lowest
c     layer, i.e., at depth zw(Nr).  these values are only useful when
c     the model ocean domain does not include the entire ocean down to
c     the seafloor ("upperocean" setup) and allows flux through the
c     bottom of the domain.  for full-depth runs, these mixing
c     coefficients are being zeroed out before leaving this subroutine.
c
c-------------------------------------------------------------------------

c global parameters updated by kpp_calc
c     KPPviscAz   - KPP eddy viscosity coefficient                 (m^2/s)
c     KPPdiffKzT  - KPP diffusion coefficient for temperature      (m^2/s)
c     KPPdiffKzS  - KPP diffusion coefficient for salt and tracers (m^2/s)
c     KPPghat     - Nonlocal transport coefficient                 (s/m^2)
c     KPPhbl      - Boundary layer depth on "t-grid"                   (m)
c     KPPfrac     - Fraction of short-wave flux heating the mixing layer
c     KPPplumefrac- Fraction of saltplume (flux) penetrating mixing layer

c--   KPP_CALC computes vertical viscosity and diffusivity for region
c     (-2:sNx+3,-2:sNy+3) as required by CALC_DIFFUSIVITY and requires
c     values of uVel, vVel, surfaceForcingU, surfaceForcingV in the
c     region (-2:sNx+4,-2:sNy+4).
c     Hence overlap region needs to be set OLx=4, OLy=4.
c \ev

C !USES: ===============================================================
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "DYNVARS.h"
#include "KPP.h"
#include "KPP_PARAMS.h"
#include "FFIELDS.h"
#include "GRID.h"
#include "GAD.h"
#ifdef ALLOW_SALT_PLUME
# include "SALT_PLUME.h"
#endif /* ALLOW_SALT_PLUME */
#ifdef ALLOW_SHELFICE
# include "SHELFICE.h"
#endif /* ALLOW_SHELFICE */
#ifdef ALLOW_AUTODIFF_TAMC
# include "tamc.h"
#endif /* ALLOW_AUTODIFF_TAMC */

C !INPUT PARAMETERS: ===================================================
c Routine arguments
c     bi, bj :: Current tile indices
c     myTime :: Current time in simulation
c     myIter :: Current iteration number in simulation
c     myThid :: My Thread Id. number
      INTEGER bi, bj
      _RL     myTime
      INTEGER myIter
      INTEGER myThid

#ifdef ALLOW_KPP
C !FUNCTIONS:
      LOGICAL  DIFFERENT_MULTIPLE
      EXTERNAL DIFFERENT_MULTIPLE

C !LOCAL VARIABLES: ====================================================
c Local constants
c     minusone, p0, p5, p25, p125, p0625
c     iMin, iMax, jMin, jMax  - array computation indices
      _RL        minusone
      PARAMETER( minusone=-1.0)
      _RL        p0    , p5    , p25     , p125      , p0625
      PARAMETER( p0=0.0, p5=0.5, p25=0.25, p125=0.125, p0625=0.0625 )
      INTEGER   iMin      ,iMax          ,jMin      ,jMax
      PARAMETER(iMin=2-OLx,iMax=sNx+OLx-1,jMin=2-OLy,jMax=sNy+OLy-1)

c Local arrays and variables
c     sdens  (nx,ny        - density of surface layer                (kg/m^3)
c     ustar  (nx,ny)       - surface friction velocity                  (m/s)
c     bo     (nx,ny)       - surface turbulent buoyancy forcing     (m^2/s^3)
c     bosol  (nx,ny)       - surface radiative buoyancy forcing     (m^2/s^3)
c     shsq   (nx,ny,Nr)    - local velocity shear squared
c                            at interfaces for ri_iwmix             (m^2/s^2)
c     dVsq   (nx,ny,Nr)    - velocity shear re surface squared
c                            at grid levels for bldepth             (m^2/s^2)
c     dbloc  (nx,ny,Nr)    - local delta buoyancy at interfaces
c                            for ri_iwmix and bldepth                 (m/s^2)
c     Ritop  (nx,ny,Nr)    - numerator of bulk richardson number
c                            at grid levels for bldepth
c     vddiff (nx,ny,Nrp2,1)- vertical viscosity on "t-grid"           (m^2/s)
c     vddiff (nx,ny,Nrp2,2)- vert. diff. on next row for salt&tracers (m^2/s)
c     vddiff (nx,ny,Nrp2,3)- vert. diff. on next row for temperature  (m^2/s)
c     ghat   (nx,ny,Nr)    - nonlocal transport coefficient           (s/m^2)
c     hbl    (nx,ny)       - mixing layer depth                           (m)
c     kbl    (nx,ny)       - k-cell index of mixing layer depth
c     kmtj   (nx,ny)       - maximum number of wet levels in each column
c     work?  (nx,ny)       - horizontal working arrays
c     temp?  (nx,ny,Nr)    - 3d working arrays
c     boplume(nx,ny,Nrp1)  - surface haline buoyancy forcing        (m^2/s^3)
      _RL sdens ( 1-OLx:sNx+OLx, 1-OLy:sNy+OLy                )
      _RL ustar ( 1-OLx:sNx+OLx, 1-OLy:sNy+OLy                )
      _RL bo    ( 1-OLx:sNx+OLx, 1-OLy:sNy+OLy                )
      _RL bosol ( 1-OLx:sNx+OLx, 1-OLy:sNy+OLy                )
      _RL shsq  ( 1-OLx:sNx+OLx, 1-OLy:sNy+OLy, Nr            )
      _RL dVsq  ( 1-OLx:sNx+OLx, 1-OLy:sNy+OLy, Nr            )
      _RL dbloc ( 1-OLx:sNx+OLx, 1-OLy:sNy+OLy, Nr            )
      _RL Ritop ( 1-OLx:sNx+OLx, 1-OLy:sNy+OLy, Nr            )
      _RL vddiff( 1-OLx:sNx+OLx, 1-OLy:sNy+OLy, 0:Nrp1, mdiff )
      _RL ghat  ( 1-OLx:sNx+OLx, 1-OLy:sNy+OLy, Nr            )
      _RL hbl   ( 1-OLx:sNx+OLx, 1-OLy:sNy+OLy                )
cph(
      _RL TTALPHA( 1-OLx:sNx+OLx, 1-OLy:sNy+OLy, Nrp1 )
      _RL SSBETA ( 1-OLx:sNx+OLx, 1-OLy:sNy+OLy, Nrp1 )
cph)
#if ( defined ALLOW_SALT_PLUME || defined SHORTWAVE_HEATING )
      _RL worka ( 1-OLx:sNx+OLx, 1-OLy:sNy+OLy                )
#endif
#ifdef ALLOW_SALT_PLUME
      _RL temp1   ( 1-OLx:sNx+OLx, 1-OLy:sNy+OLy, Nr          )
      _RL temp2   ( 1-OLx:sNx+OLx, 1-OLy:sNy+OLy, Nr          )
      _RL boplume ( 1-OLx:sNx+OLx, 1-OLy:sNy+OLy, Nrp1        )
#ifdef SALT_PLUME_SPLIT_BASIN
      _RL lon ( 1-OLx:sNx+OLx, 1-OLy:sNy+OLy                  )
      _RL lat ( 1-OLx:sNx+OLx, 1-OLy:sNy+OLy                  )
#endif /* SALT_PLUME_SPLIT_BASIN */
#endif /* ALLOW_SALT_PLUME */
#ifdef SHORTWAVE_HEATING
      INTEGER kbl(1-OLx:sNx+OLx, 1-OLy:sNy+OLy                )
C     interpolation factor 1 >= (KPPhbl+rF(kbl))/drF(kbl) >= 0
      _RL rFac
#endif
      INTEGER i, j, kSurf, k, kp1, km1, im1, ip1, jm1, jp1
C     ikey :: tape key (depends on tiles)
      INTEGER ikey
CEOP

#ifdef ALLOW_AUTODIFF_TAMC
      ikey = bi + (bj-1)*nSx + (ikey_dynamics-1)*nSx*nSy
#else /* ALLOW_AUTODIFF_TAMC */
      ikey = 0
#endif /* ALLOW_AUTODIFF_TAMC */

c     Check to see if new vertical mixing coefficient should be computed now?
      IF ( DIFFERENT_MULTIPLE(kpp_freq,myTime,deltaTClock)
     1     .OR. myTime .EQ. startTime ) THEN

c-----------------------------------------------------------------------
c     prepare input arrays for subroutine "kppmix" to compute
c     viscosity and diffusivity and ghat.
c     All input arrays need to be in m-k-s units.
c
c     note: for the computation of the bulk richardson number in the
c     "bldepth" subroutine, gradients of velocity and buoyancy are
c     required at every depth. in the case of very fine vertical grids
c     (thickness of top layer < 2m), the surface reference depth must
c     be set to zref=epsilon/2*zgrid(k), and the reference value
c     of velocity and buoyancy must be computed as vertical average
c     between the surface and 2*zref.  in the case of coarse vertical
c     grids zref is zgrid(1)/2., and the surface reference value is
c     simply the surface value at zgrid(1).
c-----------------------------------------------------------------------

c------------------------------------------------------------------------
c     density related quantities
c     --------------------------
c
c      sdens   - density of surface layer                        (kg/m^3)
c      dbloc   - local buoyancy gradient at Nr interfaces
c                g/rho{k+1,k+1} * [ drho{k,k+1}-drho{k+1,k+1} ]   (m/s^2)
c      dbsfc (stored in Ritop to conserve stack memory)
c              - buoyancy difference with respect to the surface
c                g * [ drho{1,k}/rho{1,k} - drho{k,k}/rho{k,k} ]  (m/s^2)
c      ttalpha - thermal expansion coefficient without 1/rho factor
c                d(rho{k,k})/d(T(k))                           (kg/m^3/C)
c      ssbeta  - salt expansion coefficient without 1/rho factor
c                d(rho{k,k})/d(S(k))                    ((kg/m^3)/(g/kg))
c------------------------------------------------------------------------

      CALL STATEKPP(
     O     sdens, dbloc, Ritop,
     O     TTALPHA, SSBETA,
     I     ikey, bi, bj, myThid )

      DO k = 1, Nr
       DO j = 1-OLy, sNy+OLy
        DO i = 1-OLx, sNx+OLx
         ghat(i,j,k) = dbloc(i,j,k)
        ENDDO
       ENDDO
      ENDDO

#ifdef KPP_SMOOTH_DBLOC
c     horizontally smooth dbloc with a 121 filter
c     smooth dbloc stored in ghat to save space
c     dbloc(k) is buoyancy gradientnote between k and k+1
c     levels therefore k+1 mask must be used

      DO k = 1, Nr-1
       CALL SMOOTH_HORIZ (
     I      k+1, bi, bj,
     U      ghat (1-OLx,1-OLy,k),
     I      myThid )
      ENDDO

#endif /* KPP_SMOOTH_DBLOC */

#ifdef KPP_SMOOTH_DENS
c     horizontally smooth density related quantities with 121 filters
      CALL SMOOTH_HORIZ (
     I     1, bi, bj,
     U     sdens,
     I     myThid )
      DO k = 1, Nr
         CALL SMOOTH_HORIZ (
     I        k+1, bi, bj,
     U        dbloc (1-OLx,1-OLy,k),
     I        myThid )
         CALL SMOOTH_HORIZ (
     I        k, bi, bj,
     U        Ritop (1-OLx,1-OLy,k),
     I        myThid )
         CALL SMOOTH_HORIZ (
     I        k, bi, bj,
     U        TTALPHA(1-OLx,1-OLy,k),
     I        myThid )
         CALL SMOOTH_HORIZ (
     I        k, bi, bj,
     U        SSBETA(1-OLx,1-OLy,k),
     I        myThid )
      ENDDO
#endif /* KPP_SMOOTH_DENS */

c     surface index
      kSurf = 1
      DO k = 1, Nr
       km1 = max(1,k-1)
       kp1 = min(Nr,k+1)
       DO j = 1-OLy, sNy+OLy
        DO i = 1-OLx, sNx+OLx

c     zero out dbloc over land points (so that the convective
c     part of the interior mixing can be diagnosed).
c     ML: Note that dbloc and ghat (=smoothed dbloc) are defined at
c     the bottom of the cell rather than the (MITgcm-standard) top
c     of the cell; therefore the proper masking is maskC(k)*maskC(k+1)
         dbloc(i,j,k) = dbloc(i,j,k) * maskC(i,j,k,bi,bj)
     &        * maskC(i,j,kp1,bi,bj)
         ghat(i,j,k)  = ghat(i,j,k)  * maskC(i,j,k,bi,bj)
     &        * maskC(i,j,kp1,bi,bj)
#ifdef ALLOW_SHELFICE
         IF ( useShelfIce ) kSurf = MAX(1,kTopC(i,j,bi,bj))
#endif /* ALLOW_SHELFICE */
         Ritop(i,j,k) = Ritop(i,j,k) * maskC(i,j,k,bi,bj)
     &        * maskC(i,j,kSurf,bi,bj)
         IF(k.EQ.nzmax(i,j,bi,bj)) THEN
          dbloc(i,j,k) = p0
          ghat(i,j,k)  = p0
          Ritop(i,j,k) = p0
         ENDIF

c     numerator of bulk richardson number on grid levels
c     note: land and ocean bottom values need to be set to zero
c     so that the subroutine "bldepth" works correctly
         Ritop(i,j,k) = (zgrid(1)-zgrid(k)) * Ritop(i,j,k)

        ENDDO
       ENDDO
      ENDDO

cph(
cph  this avoids a single or double recomp./call of statekpp
#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE sdens, Ritop       = comlev1_kpp, key = ikey
CADJ STORE TTALPHA, SSBETA    = comlev1_kpp, key = ikey
#endif /* ALLOW_AUTODIFF_TAMC */
cph)

CML#ifdef ALLOW_SHELFICE
CMLC     For the pbl parameterisation to work underneath the ice shelves
CMLC     it needs to know the surface (ice-ocean) fluxes. However, masking
CMLC     and indexing problems make this part of the code not work
CMLC     underneath the ice shelves and the following lines are only here
CMLC     to remind me that this still needs to be sorted out.
CML      shelfIceFac = 0. _d 0
CML      IF ( useShelfIce ) selfIceFac = 1. _d 0
CML      DO j = jMin, jMax
CML       DO i = iMin, iMax
CML        surfForcT = surfaceForcingT(i,j,bi,bj)
CML     &       + shelficeForcingT(i,j,bi,bj) * shelfIceFac
CML        surfForcS = surfaceForcingS(i,j,bi,bj)
CML     &       + shelficeForcingS(i,j,bi,bj) * shelfIceFac
CML       ENDDO
CML      ENDDO
CML#endif /* ALLOW_SHELFICE */

c------------------------------------------------------------------------
c     friction velocity, turbulent and radiative surface buoyancy forcing
c     -------------------------------------------------------------------
c     taux / rho = surfaceForcingU                               (N/m^2)
c     tauy / rho = surfaceForcingV                               (N/m^2)
c     ustar = sqrt( sqrt( taux^2 + tauy^2 ) / rho )                (m/s)
c     bo    = - g * ( alpha*surfaceForcingT +
c                     beta *surfaceForcingS ) / rho            (m^2/s^3)
c     bosol = - g * alpha * Qsw * drF(1) / rho                 (m^2/s^3)
c     boplume = g * (beta * saltPlumeFlux/rhoConst ) /rho      (m^2/s^3)
c             = g * (beta * SPforcingS   /rhoConst ) /rho
c              +g * (alpha* SPforcingT   / ??
c------------------------------------------------------------------------
c     velocity shear
c     --------------
c     Get velocity shear squared, averaged from "u,v-grid"
c     onto "t-grid" (in (m/s)**2):
c     dVsq(k)=(Uref-U(k))**2+(Vref-V(k))**2      at grid levels
c     shsq(k)=(U(k)-U(k+1))**2+(V(k)-V(k+1))**2  at interfaces
c
c     note: Vref can depend on the surface fluxes that is why we compute
c     dVsq in the subroutine that does the surface related stuff
c     (admittedly this is a bit messy)
c------------------------------------------------------------------------

#ifdef ALLOW_SALT_PLUME
      DO j=jMin,jMax
       DO i=iMin,iMax
#ifndef SALT_PLUME_VOLUME
        temp1(i,j,1) = saltPlumeFlux(i,j,bi,bj)
        temp2(i,j,1) = 0. _d 0
        DO k=2,Nr
         temp1(i,j,k) = 0. _d 0
         temp2(i,j,k) = 0. _d 0
        ENDDO
#else /* def SALT_PLUME_VOLUME */
        DO k=1,Nr
         temp1(i,j,k) = SPforcingS(i,j,k,bi,bj)
         temp2(i,j,k) = SPforcingT(i,j,k,bi,bj)
        ENDDO
#endif /* SALT_PLUME_VOLUME */
       ENDDO
      ENDDO
#endif /* ALLOW_SALT_PLUME */

      CALL KPP_FORCING_SURF(
     I     sdens, surfaceForcingU, surfaceForcingV,
     I     surfaceForcingT, surfaceForcingS, adjustColdSST_diag,
     I     Qsw,
#ifdef KPP_ESTIMATE_UREF
     I     dbloc,
#endif /* KPP_ESTIMATE_UREF */
#ifdef ALLOW_SALT_PLUME
     I     temp1, temp2,
#endif /* ALLOW_SALT_PLUME */
     I     ttalpha, ssbeta,
     O     ustar, bo, bosol,
#ifdef ALLOW_SALT_PLUME
     O     boplume,
#endif /* ALLOW_SALT_PLUME */
     O     dVsq,
     I     ikey, iMin, iMax, jMin, jMax, bi, bj, myTime, myThid )

#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE ustar, bo, bosol, dVsq = comlev1_kpp, key = ikey
# ifdef ALLOW_SALT_PLUME
CADJ STORE boplume = comlev1_kpp, key = ikey
# endif
#endif

c initialize arrays to zero
      DO k = 1, Nr
       DO j = 1-OLy, sNy+OLy
        DO i = 1-OLx, sNx+OLx
         shsq(i,j,k) = p0
        ENDDO
       ENDDO
      ENDDO

c     shsq computation
      DO k = 1, Nrm1
       kp1 = k + 1
       DO j = jMin, jMax
        jm1 = j - 1
        jp1 = j + 1
        DO i = iMin, iMax
         im1 = i - 1
         ip1 = i + 1
         shsq(i,j,k) = p5 * (
     &        (uVel(i,  j,  k,bi,bj)-uVel(i,  j,  kp1,bi,bj)) *
     &        (uVel(i,  j,  k,bi,bj)-uVel(i,  j,  kp1,bi,bj)) +
     &        (uVel(ip1,j,  k,bi,bj)-uVel(ip1,j,  kp1,bi,bj)) *
     &        (uVel(ip1,j,  k,bi,bj)-uVel(ip1,j,  kp1,bi,bj)) +
     &        (vVel(i,  j,  k,bi,bj)-vVel(i,  j,  kp1,bi,bj)) *
     &        (vVel(i,  j,  k,bi,bj)-vVel(i,  j,  kp1,bi,bj)) +
     &        (vVel(i,  jp1,k,bi,bj)-vVel(i,  jp1,kp1,bi,bj)) *
     &        (vVel(i,  jp1,k,bi,bj)-vVel(i,  jp1,kp1,bi,bj)) )
#ifdef KPP_SMOOTH_SHSQ
         shsq(i,j,k) = p5 * shsq(i,j,k) + p125 * (
     &        (uVel(i,  jm1,k,bi,bj)-uVel(i,  jm1,kp1,bi,bj)) *
     &        (uVel(i,  jm1,k,bi,bj)-uVel(i,  jm1,kp1,bi,bj)) +
     &        (uVel(ip1,jm1,k,bi,bj)-uVel(ip1,jm1,kp1,bi,bj)) *
     &        (uVel(ip1,jm1,k,bi,bj)-uVel(ip1,jm1,kp1,bi,bj)) +
     &        (uVel(i,  jp1,k,bi,bj)-uVel(i,  jp1,kp1,bi,bj)) *
     &        (uVel(i,  jp1,k,bi,bj)-uVel(i,  jp1,kp1,bi,bj)) +
     &        (uVel(ip1,jp1,k,bi,bj)-uVel(ip1,jp1,kp1,bi,bj)) *
     &        (uVel(ip1,jp1,k,bi,bj)-uVel(ip1,jp1,kp1,bi,bj)) +
     &        (vVel(im1,j,  k,bi,bj)-vVel(im1,j,  kp1,bi,bj)) *
     &        (vVel(im1,j,  k,bi,bj)-vVel(im1,j,  kp1,bi,bj)) +
     &        (vVel(im1,jp1,k,bi,bj)-vVel(im1,jp1,kp1,bi,bj)) *
     &        (vVel(im1,jp1,k,bi,bj)-vVel(im1,jp1,kp1,bi,bj)) +
     &        (vVel(ip1,j,  k,bi,bj)-vVel(ip1,j,  kp1,bi,bj)) *
     &        (vVel(ip1,j,  k,bi,bj)-vVel(ip1,j,  kp1,bi,bj)) +
     &        (vVel(ip1,jp1,k,bi,bj)-vVel(ip1,jp1,kp1,bi,bj)) *
     &        (vVel(ip1,jp1,k,bi,bj)-vVel(ip1,jp1,kp1,bi,bj)) )
#endif
        ENDDO
       ENDDO
      ENDDO

#ifdef ALLOW_DIAGNOSTICS
      IF ( useDiagnostics ) THEN
       CALL DIAGNOSTICS_FILL(shsq,  'KPPshsq ',0,Nr,2,bi,bj,myThid)
      ENDIF
#endif /* ALLOW_DIAGNOSTICS */
cph(
#ifdef ALLOW_AUTODIFF_TAMC
#ifdef KPP_AUTODIFF_EXCESSIVE_STORE
CADJ STORE shsq = comlev1_kpp, key = ikey
#endif
#endif /* ALLOW_AUTODIFF_TAMC */
cph)

c-----------------------------------------------------------------------
c     solve for viscosity, diffusivity, ghat, and hbl on "t-grid"
c-----------------------------------------------------------------------

#if ( !defined EXCLUDE_PCELL_MIX_CODE && defined  ALLOW_AUTODIFF_TAMC )
CADJ STORE KPPdiffKzS(:,:,:,bi,bj) = comlev1_kpp, key = ikey
CADJ STORE KPPdiffKzT(:,:,:,bi,bj) = comlev1_kpp, key = ikey
#endif
c     precompute background vertical diffusivities, which are needed for
c     matching diffusivities at bottom of KPP PBL
      CALL CALC_3D_DIFFUSIVITY(
     I        bi,bj,1-OLx,sNx+OLx,1-OLy,sNy+OLy,
     I        GAD_SALINITY, .FALSE., .FALSE.,
     O        KPPdiffKzS(1-OLx,1-OLy,1,bi,bj),
     I        myThid)
      CALL CALC_3D_DIFFUSIVITY(
     I        bi,bj,1-OLx,sNx+OLx,1-OLy,sNy+OLy,
     I        GAD_TEMPERATURE, .FALSE., .FALSE.,
     O        KPPdiffKzT(1-OLx,1-OLy,1,bi,bj),
     I        myThid)
#ifndef EXCLUDE_KPP_DOUBLEDIFF
      IF ( KPPuseDoubleDiff ) THEN
C     Add the contribution of double diffusive effects (salt fingering
C     and diffusive convection) here. It would be more logical to add
C     them right after Ri_iwmix within kppmix, but ttalpha, ssbeta, theta
C     and salt are not passed to kppmix and are thus not available there.
       CALL KPP_DOUBLEDIFF(
     I      TTALPHA, SSBETA,
     U      KPPdiffKzT(1-OLx,1-OLy,1,bi,bj),
     U      KPPdiffKzS(1-OLx,1-OLy,1,bi,bj),
     I      ikey,1-OLx,sNx+OLx,1-OLy,sNy+OLy,bi,bj,myThid)
      ENDIF
#endif /* ndef EXCLUDE_KPP_DOUBLEDIFF */
#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE KPPdiffKzS(:,:,:,bi,bj) = comlev1_kpp, key = ikey
CADJ STORE KPPdiffKzT(:,:,:,bi,bj) = comlev1_kpp, key = ikey
#endif

      CALL KPPMIX (
     I       nzmax(1-OLx,1-OLy,bi,bj), shsq, dVsq, ustar,
     I       maskC(1-OLx,1-OLy,1,bi,bj),
     I       bo, bosol,
#ifdef ALLOW_SALT_PLUME
     I       boplume, SaltPlumeDepth(1-OLx,1-OLy,bi,bj),
#ifdef SALT_PLUME_SPLIT_BASIN
     I       XC(1-OLx,1-OLy,bi,bj), YC(1-OLx,1-OLy,bi,bj),
#endif /* SALT_PLUME_SPLIT_BASIN */
#endif /* ALLOW_SALT_PLUME */
     I       dbloc, Ritop, fCori(1-OLx,1-OLy,bi,bj),
#ifdef SHORTWAVE_HEATING
     I       SWFRac3D  (1-OLx,1-OLy,1,bi,bj),
#endif
     I       KPPdiffKzS(1-OLx,1-OLy,1,bi,bj),
     I       KPPdiffKzT(1-OLx,1-OLy,1,bi,bj),
     I       ikey,
     O       vddiff,
     U       ghat,
     O       hbl,
#ifdef SHORTWAVE_HEATING
     O       kbl,
#endif
     I       bi, bj, myTime, myIter, myThid )

c-----------------------------------------------------------------------
c     zero out land values and transfer to global variables
c-----------------------------------------------------------------------

      DO k = 1, Nr
       km1 = max(1,k-1)
       DO j = jMin, jMax
        DO i = iMin, iMax
         KPPviscAz(i,j,k,bi,bj) = vddiff(i,j,k-1,1) * maskC(i,j,k,bi,bj)
     &        * maskC(i,j,km1,bi,bj)
         KPPdiffKzS(i,j,k,bi,bj)= vddiff(i,j,k-1,2) * maskC(i,j,k,bi,bj)
     &        * maskC(i,j,km1,bi,bj)
         KPPdiffKzT(i,j,k,bi,bj)= vddiff(i,j,k-1,3) * maskC(i,j,k,bi,bj)
     &        * maskC(i,j,km1,bi,bj)
         KPPghat(i,j,k,bi,bj)   = ghat(i,j,k)       * maskC(i,j,k,bi,bj)
     &        * maskC(i,j,km1,bi,bj)
        ENDDO
       ENDDO
      ENDDO
      kSurf = 1
      DO j = jMin, jMax
       DO i = iMin, iMax
#ifdef ALLOW_SHELFICE
        IF ( useShelfIce ) kSurf = MAX(1,kTopC(i,j,bi,bj))
#endif /* ALLOW_SHELFICE */
        KPPhbl(i,j,bi,bj) = hbl(i,j) * maskC(i,j,kSurf,bi,bj)
       ENDDO
      ENDDO

#ifdef KPP_SMOOTH_VISC
c     horizontal smoothing of vertical viscosity
      DO k = 1, Nr
         CALL SMOOTH_HORIZ (
     I        k, bi, bj,
     U        KPPviscAz(1-OLx,1-OLy,k,bi,bj),
     I        myThid )
      ENDDO
C jmc: No EXCH inside bi,bj loop !!!
c     _EXCH_XYZ_RL(KPPviscAz  , myThid )
#endif /* KPP_SMOOTH_VISC */

#ifdef KPP_SMOOTH_DIFF
c     horizontal smoothing of vertical diffusivity
      DO k = 1, Nr
         CALL SMOOTH_HORIZ (
     I        k, bi, bj,
     U        KPPdiffKzS(1-OLx,1-OLy,k,bi,bj),
     I        myThid )
         CALL SMOOTH_HORIZ (
     I        k, bi, bj,
     U        KPPdiffKzT(1-OLx,1-OLy,k,bi,bj),
     I        myThid )
      ENDDO
#endif /* KPP_SMOOTH_DIFF */

cph(
cph  crucial: this avoids full recomp./call of kppmix
#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE KPPhbl(:,:,bi,bj) = comlev1_kpp, key = ikey
# ifdef SHORTWAVE_HEATING
CADJ STORE kbl = comlev1_kpp, key = ikey
# endif
#endif /* ALLOW_AUTODIFF_TAMC */
cph)

#ifdef SHORTWAVE_HEATING
      IF ( selectPenetratingSW .GE. 1 ) THEN
#ifdef ALLOW_AUTODIFF_TAMC
C     Avoid uselessly recomputing this block because of re-using worka
CADJ INCOMPLETE worka
#endif
       IF ( KPPuseSWfrac3D ) THEN
C     Determine the fraction of solar shortwave flux penetrating to the
C     bottom of the mixed layer by interpolation.
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          k = kbl(i,j)
          rFac = MAX( (KPPhbl(i,j,bi,bj)+rF(k))*recip_drF(k), zeroRL )
          worka(i,j) = SWFrac3D(i,j,k,bi,bj)
     &         + rFac*(SWFrac3D(i,j,k+1,bi,bj) - SWFrac3D(i,j,k,bi,bj))
         ENDDO
        ENDDO
       ELSE
C     Compute fraction of solar short-wave flux penetrating to
C     the bottom of the mixing layer.
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          worka(i,j) = KPPhbl(i,j,bi,bj)
         ENDDO
        ENDDO
        CALL SWFRAC(
     I     (sNx+2*OLx)*(sNy+2*OLy), minusone,
     U     worka,
     I     myTime, myIter, myThid )
       ENDIF
       DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
         KPPfrac(i,j,bi,bj) = 1. _d 0 - worka(i,j)
        ENDDO
       ENDDO
      ENDIF
#endif /* SHORTWAVE_HEATING */

#ifdef ALLOW_SALT_PLUME
C     Compute fraction of saltplume (flux) penetrating to
C     the bottom of the mixing layer.
#ifdef ALLOW_AUTODIFF_TAMC
C     Avoid uselessly recomputing the previous block because of worka
CADJ INCOMPLETE worka
#endif
      IF ( useSALT_PLUME ) THEN
#ifndef SALT_PLUME_VOLUME
       DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
         worka(i,j) = KPPhbl(i,j,bi,bj)
#ifdef SALT_PLUME_SPLIT_BASIN
         lon(i,j) = XC(i,j,bi,bj)
         lat(i,j) = YC(i,j,bi,bj)
#endif /* SALT_PLUME_SPLIT_BASIN */
        ENDDO
       ENDDO
       CALL SALT_PLUME_FRAC(
     I      (sNx+2*OLx)*(sNy+2*OLy), minusone,
     I      SaltPlumeDepth(1-OLx,1-OLy,bi,bj),
#ifdef SALT_PLUME_SPLIT_BASIN
     I      lon,lat,
#endif /* SALT_PLUME_SPLIT_BASIN */
     U      worka,
     I      myTime, myIter, myThid )
       DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
         KPPplumefrac(i,j,bi,bj) = 1. _d 0 - worka(i,j)
        ENDDO
       ENDDO
#else /* SALT_PLUME_VOLUME */
       DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
         KPPplumefrac(i,j,bi,bj) = 0. _d 0
        ENDDO
       ENDDO
#endif /* SALT_PLUME_VOLUME */
      ENDIF
#endif /* ALLOW_SALT_PLUME */

      ENDIF

#endif /* ALLOW_KPP */

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C !ROUTINE: KPP_CALC_DUMMY

C !INTERFACE: ==========================================================
      SUBROUTINE KPP_CALC_DUMMY(
     I     bi, bj, myTime, myIter, myThid )

C !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE KPP_CALC_DUMMY                                |
C     | o Compute all KPP fields defined in KPP.h                |
C     | o Dummy routine for TAF                                  |
C     *==========================================================*

C !USES: ===============================================================
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "KPP.h"
#include "KPP_PARAMS.h"
#include "GRID.h"
#include "GAD.h"
#ifdef ALLOW_AUTODIFF_TAMC
# include "tamc.h"
#endif /* ALLOW_AUTODIFF_TAMC */

C !INPUT PARAMETERS: ===================================================
c     bi, bj :: Current tile indices
c     myTime :: Current time in simulation
c     myIter :: Current iteration number in simulation
c     myThid :: My Thread Id. number
      INTEGER bi, bj
      _RL     myTime
      INTEGER myIter
      INTEGER myThid

#ifdef ALLOW_KPP
C !LOCAL VARIABLES: ====================================================
      INTEGER i, j, k
#if ( !defined EXCLUDE_PCELL_MIX_CODE && defined  ALLOW_AUTODIFF_TAMC )
      INTEGER ikey
#endif
CEOP

      DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
            KPPhbl (i,j,bi,bj) = 1.0
            KPPfrac(i,j,bi,bj) = 0.0
#ifdef ALLOW_SALT_PLUME
            KPPplumefrac(i,j,bi,bj) = 0.0
#endif /* ALLOW_SALT_PLUME */
            DO k = 1,Nr
               KPPghat   (i,j,k,bi,bj) = 0.0
               KPPviscAz (i,j,k,bi,bj) = viscArNr(1)
            ENDDO
         ENDDO
      ENDDO

#if ( !defined EXCLUDE_PCELL_MIX_CODE && defined  ALLOW_AUTODIFF_TAMC )
      ikey = bi + (bj-1)*nSx + (ikey_dynamics-1)*nSx*nSy
CADJ STORE KPPdiffKzS(:,:,:,bi,bj) = comlev1_kpp, key = ikey
CADJ STORE KPPdiffKzT(:,:,:,bi,bj) = comlev1_kpp, key = ikey
#endif
      CALL CALC_3D_DIFFUSIVITY(
     I     bi,bj,1-OLx,sNx+OLx,1-OLy,sNy+OLy,
     I     GAD_SALINITY, .FALSE., .FALSE.,
     O     KPPdiffKzS(1-OLx,1-OLy,1,bi,bj),
     I     myThid)
      CALL CALC_3D_DIFFUSIVITY(
     I     bi,bj,1-OLx,sNx+OLx,1-OLy,sNy+OLy,
     I     GAD_TEMPERATURE, .FALSE., .FALSE.,
     O     KPPdiffKzT(1-OLx,1-OLy,1,bi,bj),
     I     myThid)

#endif
      RETURN
      END

#include "PROFILES_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C !ROUTINE: PROFILES_MAKE_NCFILE

C !INTERFACE:
      SUBROUTINE PROFILES_MAKE_NCFILE( myThid )

C     !DESCRIPTION:
C     Combine tiled files into one global netcdf file of
C     model-equivalent profiles

C     !USES:
      IMPLICIT NONE
C     == Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "EESUPPORT.h"
#include "PARAMS.h"
#include "PROFILES_SIZE.h"
#include "profiles.h"
#include "netcdf.inc"

C     !INPUT/OUTPUT PARAMETERS:
C     myThid  :: my Thread Id number
      INTEGER myThid
CEOP

C     !FUNCTIONS:
      INTEGER  ILNBLNK
      EXTERNAL ILNBLNK

C     !LOCAL VARIABLES:
      INTEGER kLev, kProf, k
      INTEGER num_file, num_var, prof_num
      INTEGER bi, bj
      INTEGER err, dimId, irec, fid1, fid2
      INTEGER dimId1, dimId2, vecid(2)
      INTEGER varId0, varId1(NVARMAX*2), varId2(NVARMAX*2)
      INTEGER length, Zlength, optimcycle
      INTEGER IL, JL
      INTEGER vec_start(2), vec_count(2)
      _RL tmpgs
      _RL prof_mask1D(NLEVELMAX)
      _RL prof_traj1D(NLEVELMAX)
      _RL prof_buff(NVARMAX,NLEVELMAX,NOBSGLOB)
      _RL prof_mask_buff(NVARMAX,NLEVELMAX,NOBSGLOB)
      _RL prof_modval_glo(NVARMAX,NLEVELMAX,NOBSGLOB)
      _RL prof_mask_glo(NVARMAX,NLEVELMAX,NOBSGLOB)
      CHARACTER*(MAX_LEN_FNAM) prof_namesequi(NFILESPROFMAX,NVARMAX)
      CHARACTER*(MAX_LEN_FNAM) profFile
      CHARACTER*(MAX_LEN_FNAM) fnameequinc
      CHARACTER*(MAX_LEN_FNAM) fnamedata
      LOGICAL exst

C Set new netcdf variables names
      DO num_file = 1, NFILESPROFMAX
        DO num_var = 1, NVARMAX
          IL = ILNBLNK( prof_names(num_file,num_var) )
          WRITE(prof_namesequi(num_file,num_var),'(2A)')
     &     prof_names(num_file,num_var)(1:IL),'model'
        ENDDO
      ENDDO

C Initialize buffers
      DO num_var = 1, NVARMAX
        DO prof_num = 1, NOBSGLOB
          DO kLev = 1, NLEVELMAX
            prof_buff(num_var,kLev,prof_num) = 0.
            prof_mask_buff(num_var,kLev,prof_num) = 0.
          ENDDO
        ENDDO
      ENDDO

C Loop over files
      DO num_file = 1, NFILESPROFMAX

        _BEGIN_MASTER( myThid )
C File maintenance
        DO bj = 1, nSy
          DO bi = 1, nSx
            IF ( (ProfNo(num_file,bi,bj).GT.0).AND.
     &           (profilesDoNcOutput) ) THEN
C Need to close file so that data is not lost when run finishes
              err = NF_SYNC( fidforward(num_file,bi,bj) )
              CALL PROFILES_NF_ERROR(
     &             'MAKE_NCFILE: NF_SYNC fidforward',
     &             err,bi,bj,myThid )
            ENDIF

C Loop over variables
            DO num_var = 1, NVARMAX
              IF (vec_quantities(num_file,num_var,bi,bj)) THEN
C Loop over profiles
                DO prof_num = 1, NOBSGLOB
                  IF (prof_num.LE.ProfNo(num_file,bi,bj)) THEN
C Initialize
                    DO kLev = 1, NLEVELMAX
                      prof_traj1D(kLev) = 0.
                      prof_mask1D(kLev) = 0.
                      prof_buff(num_var,kLev,prof_num) = 0.
                      prof_mask_buff(num_var,kLev,prof_num) = 0.
                    ENDDO

C Read tiled files
                    CALL ACTIVE_READ_PROFILE( num_file,
     &                   ProfDepthNo(num_file,bi,bj),prof_traj1D,
     &                   num_var,prof_num,.false.,optimcycle,
     &                   bi,bj,myThid,
     &                   profiles_dummy(num_file,num_var,bi,bj) )

C Save model equi and masks in buffer
C Combine all threads
                    irec = prof_ind_glob(num_file,prof_num,bi,bj)

                    DO kProf = 1, ProfDepthNo(num_file,bi,bj)
                      prof_buff(num_var,kProf,irec) =
     &                 prof_buff(num_var,kProf,irec)
     &                 + prof_traj1D(kProf)

                      prof_mask_buff(num_var,kProf,irec) =
     &                 prof_mask_buff(num_var,kProf,irec)
     &                 + prof_mask1D_cur(kProf,bi,bj)

                    ENDDO

                  ENDIF !IF (prof_num.LE.ProfNo(num_file,bi,bj))
                ENDDO !DO prof_num
              ENDIF !IF (vecquantities
            ENDDO !DO num_var

          ENDDO !DO bi
        ENDDO !DO bj
        _END_MASTER( myThid )

C Combine all processes
        DO num_var = 1, NVARMAX
          DO prof_num = 1, NOBSGLOB
            DO kLev = 1, NLEVELMAX
              tmpgs = prof_buff(num_var,kLev,prof_num)
              _GLOBAL_SUM_RL(tmpgs, myThid)

              prof_modval_glo(num_var,kLev,prof_num) = tmpgs
              tmpgs = prof_mask_buff(num_var,kLev,prof_num)
              _GLOBAL_SUM_RL(tmpgs, myThid)

              prof_mask_glo(num_var,kLev,prof_num) = tmpgs

            ENDDO !DO kLev
          ENDDO !DO prof_num
        ENDDO !DO num_var

        _BEGIN_MASTER( myThid )
        IF (myProcId.EQ.0) THEN
C Get dimensions of input file
          profFile=' '
          IL = ILNBLNK( profilesfiles(num_file) )
          IF (IL.NE.0) THEN
            WRITE(profFile,'(A)') profilesfiles(num_file)(1:IL)
          ENDIF

          IL = ILNBLNK( profFile )
          IF (IL.NE.0) THEN
            WRITE(fnamedata,'(2A)') profFile(1:IL),'.nc'
            err = NF_OPEN( fnamedata, NF_NOWRITE, fid1 )
            CALL PROFILES_NF_ERROR(
     &           'MAKE_NCFILE: NF_OPEN('//fnamedata(1:IL+3)//')',
     &           err,bi,bj,myThid )
            err = NF_INQ_DIMID( fid1,'iPROF', dimId )
            CALL PROFILES_NF_ERROR(
     &           'MAKE_NCFILE: NF_INQ_DIMID iPROF',
     &           err,bi,bj,myThid )
            err = NF_INQ_DIMLEN( fid1, dimId, length )
            CALL PROFILES_NF_ERROR(
     &           'MAKE_NCFILE: NF_INQ_DIMLEN length',
     &           err,bi,bj,myThid )
            err = NF_INQ_DIMID( fid1,'iDEPTH', dimId )
            CALL PROFILES_NF_ERROR(
     &           'MAKE_NCFILE: NF_INQ_DIMID iDEPTH',
     &           err,bi,bj,myThid )
            IF (err.NE.NF_NOERR) THEN
              err = NF_INQ_DIMID( fid1,'Z', dimId )
              CALL PROFILES_NF_ERROR(
     &             'MAKE_NCFILE: NF_INQ_DIMID Z',
     &             err,bi,bj,myThid )
            ENDIF
            err = NF_INQ_DIMLEN( fid1, dimId, Zlength )
            CALL PROFILES_NF_ERROR(
     &           'MAKE_NCFILE: NF_INQ_DIMLEN Zlength',
     &           err,bi,bj,myThid )

C Create new netcdf global file for model-equivalent
            JL = ILNBLNK( profilesDir )
            WRITE(fnameequinc,'(3A)')
     &       profilesDir(1:JL),profFile(1:IL),'.equi.nc'

            JL = ILNBLNK( fnameequinc )
            INQUIRE( FILE = fnameequinc(1:JL), EXIST = exst )
            IF (.NOT.exst) THEN
              err = NF_CREATE(fnameequinc(1:JL),NF_CLOBBER,fid2)
              CALL PROFILES_NF_ERROR(
     &             'MAKE_NCFILE: NF_CREATE('//fnameequinc(1:JL)//')',
     &             err,bi,bj,myThid )
              err = NF_DEF_DIM(fid2,'iDEPTH',Zlength,dimId1)
              CALL PROFILES_NF_ERROR(
     &             'MAKE_NCFILE: NF_DEF_DIM iDepth',
     &             err,bi,bj,myThid )
              err = NF_DEF_DIM(fid2,'iPROF',length,dimId2)
              CALL PROFILES_NF_ERROR(
     &             'MAKE_NCFILE: NF_DEF_DIM iPROF',
     &             err,bi,bj,myThid )

              vecid(1)=dimId1
              vecid(2)=dimId2

C Define variables and attributes
              DO num_var = 1, NVARMAX
                err = NF_INQ_VARID( fid1,
     &                prof_names(num_file,num_var), varId0 )
                CALL PROFILES_NF_ERROR( 'MAKE_NCFILE: NF_INQ_VARID('
     &               //prof_names(num_file,num_var)//')',
     &               err,bi,bj,myThid )

                IF (err.EQ.NF_NOERR) THEN
                  err = NF_DEF_VAR( fid2,
     &                  prof_namesequi(num_file,num_var),
     &                  NF_DOUBLE, 2, vecid, varId1(2+(num_var-1)*2) )
                  CALL PROFILES_NF_ERROR(
     &                 'MAKE_NCFILE: NF_DEF_VAR prof_namesequi',
     &                 err,bi,bj,myThid )
                  err = NF_PUT_ATT_DOUBLE( fid2,
     &                  varId1(2+(num_var-1)*2),
     &                  '_FillValue', NF_DOUBLE, 1, 0. _d 0 )
                  CALL PROFILES_NF_ERROR(
     &                 'MAKE_NCFILE: NF_PUT_ATT_DOUBLE varId(2',
     &                 err,bi,bj,myThid )

                  err = NF_DEF_VAR( fid2,
     &                  prof_namesmask(num_file,num_var),
     &                  NF_DOUBLE, 2, vecid, varId1(3+(num_var-1)*2) )
                  CALL PROFILES_NF_ERROR(
     &                 'MAKE_NCFILE: NF_DEF_VAR prof_namesmask',
     &                 err,bi,bj,myThid )
                  err = NF_PUT_ATT_DOUBLE( fid2,
     &                  varId1(3+(num_var-1)*2),
     &                  '_FillValue', NF_DOUBLE, 1, 0. _d 0 )
                  CALL PROFILES_NF_ERROR(
     &                 'MAKE_NCFILE: NF_PUT_ATT_DOUBLE varId(3',
     &                 err,bi,bj,myThid )

                ENDIF
              ENDDO !DO num_var

              err = NF_ENDDEF( fid2 )
              CALL PROFILES_NF_ERROR( 'MAKE_NCFILE: NF_ENDDEF fid2',
     &             err,bi,bj,myThid )

            ELSE !IF (.NOT.exst)
              JL = ILNBLNK( fnameequinc )
              err = NF_OPEN( fnameequinc(1:JL), NF_WRITE, fid2 )
              CALL PROFILES_NF_ERROR(
     &             'MAKE_NCFILE: NF_OPEN('//fnameequinc(1:JL)//')',
     &             err,bi,bj,myThid )

            ENDIF !IF (.NOT.exst)

C Write profiles
            DO num_var = 1, NVARMAX
              IF (vec_quantities(num_file,num_var,1,1)) THEN
                DO prof_num = 1, NOBSGLOB
                  IF (prof_num.LE.length) THEN
                    DO k = 1, Zlength
                      prof_traj1D(k) =
     &                 prof_modval_glo(num_var,k,prof_num)

                      prof_mask1D(k) =
     &                 prof_mask_glo(num_var,k,prof_num)

                    ENDDO

                    vec_start(1) = 1
                    vec_start(2) = prof_num
                    vec_count(1) = Zlength
                    vec_count(2) = 1

                    err = NF_INQ_VARID( fid2,
     &                    prof_namesequi(num_file,num_var),
     &                    varId2(2+(num_var-1)*2) )
                    CALL PROFILES_NF_ERROR(
     &                   'MAKE_NCFILE: NF_INQ_VARID prof_namesequi',
     &                   err,bi,bj,myThid )
                    err = NF_PUT_VARA_DOUBLE( fid2,
     &                    varId2(2+(num_var-1)*2),
     &                    vec_start, vec_count, prof_traj1D )
                    CALL PROFILES_NF_ERROR(
     &                  'MAKE_NCFILE: NF_PUT_VARA_DOUBLE prof_traj1D',
     &                  err,bi,bj,myThid )

                    err = NF_INQ_VARID( fid2,
     &                    prof_namesmask(num_file,num_var),
     &                    varId2(3+(num_var-1)*2) )
                    CALL PROFILES_NF_ERROR(
     &                   'MAKE_NCFILE: NF_INQ_VARID prof_namesmask',
     &                   err,bi,bj,myThid )
                    err = NF_PUT_VARA_DOUBLE( fid2,
     &                    varId2(3+(num_var-1)*2),
     &                    vec_start, vec_count, prof_mask1D )
                    CALL PROFILES_NF_ERROR(
     &                  'MAKE_NCFILE: NF_PUT_VARA_DOUBLE prof_mask1D',
     &                  err,bi,bj,myThid )

                  ENDIF !IF (prof_num.LE.length)
                ENDDO !DO prof_num
              ENDIF !IF vec_quantities(num_file,num_var,1,1)
            ENDDO !DO num_var

            err = NF_CLOSE( fid2 )
            CALL PROFILES_NF_ERROR( 'MAKE_NCFILE: NF_CLOSE fid2',
     &           err,bi,bj,myThid )

          ENDIF !IF (IL.NE.0)
        ENDIF !IF (myProcId.EQ.0)
        _END_MASTER( myThid )

      ENDDO !DO num_file

      RETURN
      END

#include "OBCS_OPTIONS.h"
#ifdef ALLOW_SEAICE
#include "SEAICE_OPTIONS.h"
#endif

CBOP
C     !ROUTINE: OBCS_APPLY_UVICE
C     !INTERFACE:
      SUBROUTINE OBCS_APPLY_UVICE(
     U                             uFld, vFld,
     I                             myThid )

C     !DESCRIPTION:
C     *==========================================================*
C     | S/R OBCS_APPLY_UVICE
C     |   Apply OB values to corresponding field array
C     *==========================================================*

C     !USES:
      IMPLICIT NONE
C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
c#include "GRID.h"
#include "OBCS_PARAMS.h"
#include "OBCS_GRID.h"
#include "OBCS_SEAICE.h"
#ifdef ALLOW_SEAICE
# include "SEAICE_SIZE.h"
# include "SEAICE_GRID.h"
# include "SEAICE.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine Arguments ==
C    uFld     :: horizontal velocity field, 1rst component (zonal)
C    vFld     :: horizontal velocity field, 2nd  component (meridional)
C    myThid   :: my Thread Id number
      _RL uFld(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL vFld(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      INTEGER myThid

#if ( defined ALLOW_SEAICE && defined SEAICE_CGRID && !defined OBCS_UVICE_OLD )

C     !LOCAL VARIABLES:
C    bi, bj   :: indices of current tile
C    i, j     :: Loop counters
      INTEGER bi, bj
      INTEGER i, j
      INTEGER Iobc, Jobc
      _RL uvIceApplyFac
CEOP

      uvIceApplyFac = OBCS_uvApplyFac
c     IF ( OBCS_monitorFreq.EQ.1. ) uvIceApplyFac =  -1.
c     IF ( OBCS_monitorFreq.EQ.deltaTMom*0.5 ) uvIceApplyFac = 0.
c     IF ( OBCS_monitorFreq.EQ.deltaTMom ) uvIceApplyFac = 1.
c     WRITE(standardMessageUnit,*)
c          'OBCS_APPLY_UVICE: uvIceApplyFac=', uvIceApplyFac

      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)

        IF ( useSeaiceNeumann ) THEN
C--   Neumann BC for seaice: before applying OB-value to ice-velocity, copy
C     interior ice-velocity field (next to OB) to OB-array: OB[N,S,E,W][u,v]ice

# ifdef ALLOW_OBCS_NORTH
         IF ( tileHasOBN(bi,bj) ) THEN
C     Northern boundary
          DO i=1-OLx,sNx+OLx
           Jobc = OB_Jn(i,bi,bj)
           IF ( Jobc.NE.OB_indexNone ) THEN
            OBNuice(i,bi,bj) = uFld(i,Jobc-1,bi,bj)
            OBNvice(i,bi,bj) = vFld(i,Jobc-1,bi,bj)
           ENDIF
          ENDDO
         ENDIF
# endif /* ALLOW_OBCS_NORTH */

# ifdef ALLOW_OBCS_SOUTH
         IF ( tileHasOBS(bi,bj) ) THEN
C     Southern boundary
          DO i=1-OLx,sNx+OLx
           Jobc = OB_Js(i,bi,bj)
           IF ( Jobc.NE.OB_indexNone ) THEN
            OBSuice(i,bi,bj) = uFld(i,Jobc+1,bi,bj)
            OBSvice(i,bi,bj) = vFld(i,Jobc+2,bi,bj)
           ENDIF
          ENDDO
         ENDIF
# endif /* ALLOW_OBCS_SOUTH */

# ifdef ALLOW_OBCS_EAST
         IF ( tileHasOBE(bi,bj) ) THEN
C     Eastern boundary
          DO j=1-OLy,sNy+OLy
           Iobc = OB_Ie(j,bi,bj)
           IF ( Iobc.NE.OB_indexNone ) THEN
            OBEuice(j,bi,bj) = uFld(Iobc-1,j,bi,bj)
            OBEvice(j,bi,bj) = vFld(Iobc-1,j,bi,bj)
           ENDIF
          ENDDO
         ENDIF
# endif /* ALLOW_OBCS_EAST */

# ifdef ALLOW_OBCS_WEST
         IF ( tileHasOBW(bi,bj) ) THEN
C     Western boundary
          DO j=1-OLy,sNy+OLy
           Iobc = OB_Iw(j,bi,bj)
           IF ( Iobc.NE.OB_indexNone ) THEN
            OBWuice(j,bi,bj) = uFld(Iobc+2,j,bi,bj)
            OBWvice(j,bi,bj) = vFld(Iobc+1,j,bi,bj)
           ENDIF
          ENDDO
         ENDIF
# endif /* ALLOW_OBCS_WEST */

C-      end if useSeaiceNeumann block
        ENDIF

C--   Set model variables to OB values on N/S/E/W Boundaries:
C     2 steps: 1) set tangential component ; 2) set normal component.
C     This ensures that the normal component is set correctly even
C     when it conficts with tangential setting from an other OB.

C--   Set Tangential component first:

C     Set model variables to OB values on North/South Boundaries
# ifdef ALLOW_OBCS_NORTH
        IF ( tileHasOBN(bi,bj) ) THEN
C     Northern boundary
         DO i=1-OLx,sNx+OLx
          Jobc = OB_Jn(i,bi,bj)
          IF ( Jobc.NE.OB_indexNone ) THEN
           uFld(i,Jobc,bi,bj) = OBNuice(i,bi,bj)
     &                        *seaiceMaskU(i,Jobc,bi,bj)
          ENDIF
         ENDDO
        ENDIF
# endif /* ALLOW_OBCS_NORTH */

# ifdef ALLOW_OBCS_SOUTH
        IF ( tileHasOBS(bi,bj) ) THEN
C     Southern boundary
         DO i=1-OLx,sNx+OLx
          Jobc = OB_Js(i,bi,bj)
          IF ( Jobc.NE.OB_indexNone ) THEN
           uFld(i,Jobc,bi,bj) = OBSuice(i,bi,bj)
     &                        *seaiceMaskU(i,Jobc,bi,bj)
          ENDIF
         ENDDO
        ENDIF
# endif /* ALLOW_OBCS_SOUTH */

C     Set model variables to OB values on East/West Boundaries
# ifdef ALLOW_OBCS_EAST
        IF ( tileHasOBE(bi,bj) ) THEN
C     Eastern boundary
         DO j=1-OLy,sNy+OLy
          Iobc = OB_Ie(j,bi,bj)
          IF ( Iobc.NE.OB_indexNone ) THEN
           vFld(Iobc,j,bi,bj) = OBEvice(j,bi,bj)
     &                        *seaiceMaskV(Iobc,j,bi,bj)
          ENDIF
         ENDDO
        ENDIF
# endif /* ALLOW_OBCS_EAST */

# ifdef ALLOW_OBCS_WEST
        IF ( tileHasOBW(bi,bj) ) THEN
C     Western boundary
         DO j=1-OLy,sNy+OLy
          Iobc = OB_Iw(j,bi,bj)
          IF ( Iobc.NE.OB_indexNone ) THEN
           vFld(Iobc,j,bi,bj) = OBWvice(j,bi,bj)
     &                        *seaiceMaskV(Iobc,j,bi,bj)
          ENDIF
         ENDDO
        ENDIF
# endif /* ALLOW_OBCS_WEST */

C--   Then set Normal component:

C     Set model variables to OB values on North/South Boundaries
# ifdef ALLOW_OBCS_NORTH
        IF ( tileHasOBN(bi,bj) ) THEN
C     Northern boundary
         DO i=1-OLx,sNx+OLx
          Jobc = OB_Jn(i,bi,bj)
          IF ( Jobc.NE.OB_indexNone ) THEN
           vFld(i,Jobc,bi,bj)   = OBNvice(i,bi,bj)
     &                          *seaiceMaskV(i,Jobc,bi,bj)
           IF ( uvIceApplyFac.GE.0. )
     &     vFld(i,Jobc+1,bi,bj) = OBNvice(i,bi,bj)
     &                          *seaiceMaskV(i,Jobc,bi,bj)
     &                          *uvIceApplyFac
          ENDIF
         ENDDO
        ENDIF
# endif /* ALLOW_OBCS_NORTH */

# ifdef ALLOW_OBCS_SOUTH
        IF ( tileHasOBS(bi,bj) ) THEN
C     Southern boundary
         DO i=1-OLx,sNx+OLx
          Jobc = OB_Js(i,bi,bj)
          IF ( Jobc.NE.OB_indexNone ) THEN
           vFld(i,Jobc+1,bi,bj) = OBSvice(i,bi,bj)
     &                          *seaiceMaskV(i,Jobc+1,bi,bj)
           IF ( uvIceApplyFac.GE.0. )
     &     vFld(i,Jobc,bi,bj)   = OBSvice(i,bi,bj)
     &                          *seaiceMaskV(i,Jobc+1,bi,bj)
     &                          *uvIceApplyFac
          ENDIF
         ENDDO
        ENDIF
# endif /* ALLOW_OBCS_SOUTH */

C     Set model variables to OB values on East/West Boundaries
# ifdef ALLOW_OBCS_EAST
        IF ( tileHasOBE(bi,bj) ) THEN
C     Eastern boundary
         DO j=1-OLy,sNy+OLy
          Iobc = OB_Ie(j,bi,bj)
          IF ( Iobc.NE.OB_indexNone ) THEN
           uFld(Iobc,j,bi,bj)   = OBEuice(j,bi,bj)
     &                          *seaiceMaskU(Iobc,j,bi,bj)
           IF ( uvIceApplyFac.GE.0. )
     &     uFld(Iobc+1,j,bi,bj) = OBEuice(j,bi,bj)
     &                          *seaiceMaskU(Iobc,j,bi,bj)
     &                          *uvIceApplyFac
          ENDIF
         ENDDO
        ENDIF
# endif /* ALLOW_OBCS_EAST */

# ifdef ALLOW_OBCS_WEST
        IF ( tileHasOBW(bi,bj) ) THEN
C     Western boundary
         DO j=1-OLy,sNy+OLy
          Iobc = OB_Iw(j,bi,bj)
          IF ( Iobc.NE.OB_indexNone ) THEN
           uFld(Iobc+1,j,bi,bj) = OBWuice(j,bi,bj)
     &                          *seaiceMaskU(Iobc+1,j,bi,bj)
           IF ( uvIceApplyFac.GE.0. )
     &     uFld(Iobc,j,bi,bj)   = OBWuice(j,bi,bj)
     &                          *seaiceMaskU(Iobc+1,j,bi,bj)
     &                          *uvIceApplyFac
          ENDIF
         ENDDO
        ENDIF
# endif /* ALLOW_OBCS_WEST */

       ENDDO
      ENDDO

      CALL EXCH_UV_XY_RL( uFld, vFld,.TRUE.,myThid)

#endif /* ALLOW_SEAICE and SEAICE_CGRID and not OBCS_UVICE_OLD */

      RETURN
      END

#include "ATM_CPL_OPTIONS.h"

CBOP
C     !ROUTINE: CPL_WRITE_PICKUP
C     !INTERFACE:
      SUBROUTINE CPL_WRITE_PICKUP(
     I                             suff, myTime, myIter, myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE CPL_WRITE_PICKUP
C     | o Store coupling state for restart.
C     | - Atmospheric version -
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "CPL_PARAMS.h"
#include "ATMCPL.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     suff    :: suffix for pickup file (eg. ckptA or 0000000010)
C     myTime  :: Current time in simulation
C     myIter  :: Current iteration number in simulation
C     myThid  :: My Thread Id number
      CHARACTER*(*) suff
      _RL     myTime
      INTEGER myIter
      INTEGER myThid
CEOP

#ifdef COMPONENT_MODULE
C     === Functions ====
      INTEGER  ILNBLNK
      EXTERNAL ILNBLNK

C !LOCAL VARIABLES: ====================================================
C     j           :: loop index / field number
C     nj          :: record number
C     fp          :: pickup-file precision
C     glf         :: local flag for "globalFiles"
C     fn          :: character buffer for creating filename
C     nWrFlds     :: number of fields being written
C     listDim     :: dimension of "wrFldList" local array
C     wrFldList   :: list of written fields
C     msgBuf      :: Informational/error message buffer
      INTEGER j, nj, fp, lChar
      LOGICAL glf
      _RL     timList(1)
      CHARACTER*(MAX_LEN_FNAM) fn
      INTEGER listDim, nWrFlds
      PARAMETER( listDim = 18 )
      CHARACTER*(8) wrFldList(listDim)
      CHARACTER*(MAX_LEN_MBUF) msgBuf
CEOP

      lChar = ILNBLNK(suff)
      IF ( lChar.EQ.0 ) THEN
        WRITE(fn,'(2A)') 'pickup_cpl'
      ELSE
        WRITE(fn,'(2A)') 'pickup_cpl.',suff(1:lChar)
      ENDIF
      fp = precFloat64
      j  = 0

C-    Firstly, write 3-D fields as consecutive records
C-    Then switch to 2-D fields:
c       nj = -j*Nr
C     record number < 0 : a hack not to write meta files now:
c       nj = nj-1
        j = j + 1
        CALL WRITE_REC_3D_RL( fn, fp, 1,
     &                        HeatFlux  , -j, myIter, myThid )
        IF (j.LE.listDim) wrFldList(j) = 'qHeatFlx'

        j = j + 1
        CALL WRITE_REC_3D_RL( fn, fp, 1,
     &                        qShortWave, -j, myIter, myThid )
        IF (j.LE.listDim) wrFldList(j) = 'qShortW '

        j = j + 1
        CALL WRITE_REC_3D_RL( fn, fp, 1,
     &                        tauX      , -j, myIter, myThid )
        IF (j.LE.listDim) wrFldList(j) = 'surfTauX'

        j = j + 1
        CALL WRITE_REC_3D_RL( fn, fp, 1,
     &                        tauY      , -j, myIter, myThid )
        IF (j.LE.listDim) wrFldList(j) = 'surfTauY'

        j = j + 1
        CALL WRITE_REC_3D_RL( fn, fp, 1,
     &                        EvMPrFlux , -j, myIter, myThid )
        IF (j.LE.listDim) wrFldList(j) = 'Evp-Prec'

#ifdef ALLOW_LAND
      IF ( atm_cplExch_RunOff ) THEN
        j = j + 1
        CALL WRITE_REC_3D_RL( fn, fp, 1,
     &                        RunOffFlux, -j, myIter, myThid )
        IF (j.LE.listDim) wrFldList(j) = 'RunOffFx'
        j = j + 1
        CALL WRITE_REC_3D_RL( fn, fp, 1,
     &                        RunOffEnFx, -j, myIter, myThid )
        IF (j.LE.listDim) wrFldList(j) = 'RnOfEnFx'
      ENDIF
#endif /* ALLOW_LAND */
#ifdef ALLOW_THSICE
      IF ( atm_cplExch1W_sIce ) THEN
        j = j + 1
        CALL WRITE_REC_3D_RL( fn, fp, 1,
     &                        iceSaltFlx, -j, myIter, myThid )
        IF (j.LE.listDim) wrFldList(j) = 'saltFlux'
      ENDIF
      IF ( atm_cplExch_SaltPl ) THEN
        j = j + 1
        CALL WRITE_REC_3D_RL( fn, fp, 1,
     &                        saltPlmFlx_cpl, -j, myIter, myThid )
        IF (j.LE.listDim) wrFldList(j) = 'sltPlmFx'
      ENDIF
#endif /* ALLOW_THSICE */
#ifdef ALLOW_AIM
      IF ( atm_cplExch_DIC ) THEN
        j = j + 1
        CALL WRITE_REC_3D_RL( fn, fp, 1,
     &                        airCO2    , -j, myIter, myThid )
        IF (j.LE.listDim) wrFldList(j) = 'atm-CO2 '
        j = j + 1
        CALL WRITE_REC_3D_RL( fn, fp, 1,
     &                        sWSpeed   , -j, myIter, myThid )
        IF (j.LE.listDim) wrFldList(j) = 'wndSpeed'
      ENDIF
#endif /* ALLOW_AIM */
C-    with only 2-D fields:
        nj = -j

C--------------------------
        nWrFlds = j
        IF ( nWrFlds.GT.listDim ) THEN
          WRITE(msgBuf,'(2A,I5,A)') 'CPL_WRITE_PICKUP: ',
     &     'trying to write ',nWrFlds,' fields'
          CALL PRINT_ERROR( msgBuf, myThid )
          WRITE(msgBuf,'(2A,I5,A)') 'CPL_WRITE_PICKUP: ',
     &     'field-list dimension (listDim=',listDim,') too small'
          CALL PRINT_ERROR( msgBuf, myThid )
          CALL ALL_PROC_DIE( myThid )
          STOP 'ABNORMAL END: S/R CPL_WRITE_PICKUP (list-size Pb)'
        ENDIF
#ifdef ALLOW_MDSIO
C     uses this specific S/R to write (with more informations) only meta files
        j  = 1
        nj = ABS(nj)
        IF ( nWrFlds*Nr .EQ. nj ) THEN
          j  = Nr
          nj = nWrFlds
        ENDIF
        glf  = globalFiles
        timList(1) = myTime
        CALL MDS_WR_METAFILES( fn, fp, glf, .FALSE.,
     &                         0, 0, j, ' ',
     &                         nWrFlds, wrFldList,
     &                         1, timList, oneRL,
     &                         nj, myIter, myThid )
#endif /* ALLOW_MDSIO */
C--------------------------

#endif /* COMPONENT_MODULE */

      RETURN
      END

#include "GGL90_OPTIONS.h"
#ifdef ALLOW_GENERIC_ADVDIFF
# include "GAD_OPTIONS.h"
#endif
#ifdef ALLOW_AUTODIFF
# include "AUTODIFF_OPTIONS.h"
#endif

CBOP
C !ROUTINE: GGL90_CALC

C !INTERFACE: ======================================================
      SUBROUTINE GGL90_CALC(
     I                 bi, bj, sigmaR, myTime, myIter, myThid )

C !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE GGL90_CALC                                    |
C     | o Compute all GGL90 fields defined in GGL90.h            |
C     *==========================================================*
C     | Equation numbers refer to                                |
C     |  Gaspar et al. (1990), JGR 95 (C9), pp 16,179            |
C     | Some parts of the implementation follow Blanke and       |
C     |  Delecuse (1993), JPO, and OPA code, in particular the   |
C     |  computation of the                                      |
C     |  mixing length = max(min(lk,depth),lkmin)                |
C     | Note: Only call this S/R if Nr > 1 (no use if Nr=1)      |
C     *==========================================================*

C global parameters updated by ggl90_calc
C     GGL90TKE     :: sub-grid turbulent kinetic energy          (m^2/s^2)
C     GGL90viscAz  :: GGL90 eddy viscosity coefficient             (m^2/s)
C     GGL90diffKzT :: GGL90 diffusion coefficient for temperature  (m^2/s)
C \ev

C !USES: ============================================================
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "DYNVARS.h"
#include "FFIELDS.h"
#include "GRID.h"
#include "GGL90.h"
#ifdef ALLOW_SHELFICE
# include "SHELFICE.h"
#endif
#ifdef ALLOW_AUTODIFF_TAMC
# include "tamc.h"
#endif

C !INPUT PARAMETERS: ===================================================
C Routine arguments
C     bi, bj :: Current tile indices
C     sigmaR :: Vertical gradient of iso-neutral density
C     myTime :: Current time in simulation
C     myIter :: Current time-step number
C     myThid :: My Thread Id number
      INTEGER bi, bj
      _RL     sigmaR(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL     myTime
      INTEGER myIter
      INTEGER myThid

#ifdef ALLOW_GGL90

#ifdef ALLOW_DIAGNOSTICS
      LOGICAL  DIAGNOSTICS_IS_ON
      EXTERNAL DIAGNOSTICS_IS_ON
#endif /* ALLOW_DIAGNOSTICS */

C !LOCAL VARIABLES: ====================================================
C     iMin,iMax,jMin,jMax :: index boundaries of computation domain
C     i, j, k          :: array computation indices
C     kSrf             :: vertical index of surface level
C     kTop             :: index of top interface (just below surf. level)
C     kBot             :: index of bottom interface (just above bottom lev.)
C     hFac/hFacI       :: fractional thickness of W-cell
C     explDissFac      :: explicit Dissipation Factor (in [0-1])
C     implDissFac      :: implicit Dissipation Factor (in [0-1])
C
C     In general, all 3D variables are defined at W-points (i.e.,
C     between k and k-1), all 2D variables are also defined at W-points
C     or at the very surface level (like uStarSquare)
C
C     uStarSquare      :: square of friction velocity
C     verticalShear    :: (squared) vertical shear of horizontal velocity
C     Nsquare          :: squared buoyancy freqency
C     RiNumber         :: local Richardson number
C     KappaM           :: (local) viscosity parameter (eq.10)
C     KappaH           :: (local) diffusivity parameter for temperature (eq.11)
C     KappaE           :: (local) diffusivity parameter for TKE (eq.15)
C     TKEdissipation   :: dissipation of TKE
C     GGL90mixingLength:: mixing length of scheme following Banke+Delecuse
C         rMixingLength:: inverse of mixing length
C     TKEPrandtlNumber :: here, an empirical function of the Richardson number
      INTEGER iMin ,iMax ,jMin ,jMax
      INTEGER i, j, k
      INTEGER kp1, km1
      INTEGER kSrf, kTop, kBot
      INTEGER errCode
      _RL deltaTloc
      _RL explDissFac, implDissFac
      _RL uStarSquare  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL verticalShear(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL KappaM       (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL KappaH
c     _RL Nsquare
      _RL Nsquare(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
c     _RL SQRTTKE
      _RL SQRTTKE(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL RiNumber
#ifdef ALLOW_GGL90_IDEMIX
      _RL IDEMIX_RiNumber
#endif
      _RL TKEdissipation
      _RL tempU, tempUp, tempV, tempVp, prTemp, tmpVisc
      _RL TKEPrandtlNumber (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL GGL90mixingLength(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL rMixingLength    (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL KappaE           (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL GGL90visctmp     (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
#ifdef ALLOW_GGL90_IDEMIX
      _RL hFacI            (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
C     IDEMIX_gTKE :: dissipation of internal wave energy is a source
C                    of TKE and mixing (output of S/R GGL90_IDEMIX)
      _RL IDEMIX_gTKE      (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
#endif /* ALLOW_GGL90_IDEMIX */
#ifdef ALLOW_GGL90_LANGMUIR
C   uStar, vStar :: frictional velocity component
      _RL uStar, vStar, depthFac
      _RL recip_Lasq, recip_LD
      _RL LCmixingLength(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL stokesterm(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL dstokesUdR(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL dstokesVdR(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
#endif /* ALLOW_GGL90_LANGMUIR */
      _RL recip_hFacI      (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL hFac
      _RS mskLoc
#ifdef ALLOW_GGL90_SMOOTH
      _RS maskI            (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
#endif
C-    tri-diagonal matrix
      _RL a3d(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL b3d(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL c3d(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
C     This mixed layer model is not invariant under coordinate
C     transformation to pressure coordinates, so we need these
C     factors to scale the vertical (pressure) coordinates
      _RL coordFac, recip_coordFac
#ifdef ALLOW_GGL90_HORIZDIFF
C     xA, yA   :: area of lateral faces
C     dfx, dfy :: diffusive flux across lateral faces
C     gTKE     :: right hand side of diffusion equation
      _RL xA  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL yA  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL dfx (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL dfy (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL gTKE(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
#endif /* ALLOW_GGL90_HORIZDIFF */
#ifdef ALLOW_GGL90_SMOOTH
      _RL p4, p8, p16
#endif
#ifdef ALLOW_SHELFICE
      INTEGER ki
      _RL KE     (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL uFld   (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL vFld   (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL cDragU (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL cDragV (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL stressU(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL stressV(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL kappaRX(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr+1)
#endif
#ifdef ALLOW_DIAGNOSTICS
# ifndef ALLOW_AUTODIFF
      LOGICAL doDiagTKEmin
      _RL recip_deltaT
# endif
      _RL surf_flx_tke(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
#endif /* ALLOW_DIAGNOSTICS */
#ifdef ALLOW_AUTODIFF_TAMC
C     tkey :: tape key (depends on tiles)
C     kkey :: tape key (depends on levels and tiles)
      INTEGER tkey, kkey
#endif
CEOP

      PARAMETER( iMin = 2-OLx, iMax = sNx+OLx-1 )
      PARAMETER( jMin = 2-OLy, jMax = sNy+OLy-1 )
#ifdef ALLOW_GGL90_SMOOTH
      p4  = 0.25   _d 0
      p8  = 0.125  _d 0
      p16 = 0.0625 _d 0
#endif

      IF ( usingPCoords ) THEN
       kSrf = Nr
       kTop = Nr
      ELSE
       kSrf =  1
       kTop =  2
      ENDIF
      deltaTloc = dTtracerLev(kSrf)

      coordFac = 1. _d 0
      IF ( usingPCoords) coordFac = gravity * rhoConst
      recip_coordFac = 1./coordFac

#ifdef ALLOW_AUTODIFF_TAMC
      tkey = bi + (bj-1)*nSx + (ikey_dynamics-1)*nSx*nSy
#endif /* ALLOW_AUTODIFF_TAMC */

C     explicit/implicit timestepping weights for dissipation
      explDissFac = 0. _d 0
      implDissFac = 1. _d 0 - explDissFac

#ifdef ALLOW_DIAGNOSTICS
# ifndef ALLOW_AUTODIFF
      doDiagTKEmin = .FALSE.
# endif
      IF ( useDiagnostics ) THEN
# ifndef ALLOW_AUTODIFF
       doDiagTKEmin = DIAGNOSTICS_IS_ON('GGL90Emn',myThid)
C- note: needs to explicitly increment the counter since DIAGNOSTICS_FILL
C        does it only if k=1 (never the case here)
       IF ( doDiagTKEmin )
     &      CALL DIAGNOSTICS_COUNT('GGL90Emn',bi,bj,myThid)
# endif
       DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
         surf_flx_tke(i,j) = 0.
        ENDDO
       ENDDO
      ENDIF
#endif

C     For nonlinear free surface and especially with r*-coordinates, the
C     hFacs change every timestep, so we need to update them here in the
C     case of using IDEMIX.
       DO k=1,Nr
        km1 = MAX(k-1,1)
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          hFac =
     &         MIN( halfRS, _hFacC(i,j,km1,bi,bj) )
     &       + MIN( halfRS, _hFacC(i,j,k  ,bi,bj) )
          recip_hFacI(i,j,k)=0. _d 0
          IF ( hFac .NE. 0. _d 0 )
     &         recip_hFacI(i,j,k)=1. _d 0/hFac
#ifdef ALLOW_GGL90_IDEMIX
          hFacI(i,j,k) = hFac
#endif /* ALLOW_GGL90_IDEMIX */
         ENDDO
        ENDDO
       ENDDO

#ifdef ALLOW_GGL90_IDEMIX
C     step forward IDEMIX_E(energy) and compute tendency for TKE,
C     IDEMIX_gTKE = tau_d * IDEMIX_E**2, following Olbers and Eden (2013)
      IF ( useIDEMIX) CALL GGL90_IDEMIX(
     I     bi, bj, hFacI, recip_hFacI, sigmaR,
     O     IDEMIX_gTKE,
     I     myTime, myIter, myThid )
#endif /* ALLOW_GGL90_IDEMIX */

C     Initialize local fields
      DO k=1,Nr
       DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
         rMixingLength(i,j,k)     = 0. _d 0
         GGL90visctmp(i,j,k)      = 0. _d 0
         KappaE(i,j,k)            = 0. _d 0
         TKEPrandtlNumber(i,j,k)  = 1. _d 0
         GGL90mixingLength(i,j,k) = GGL90mixingLengthMin
#ifndef SOLVE_DIAGONAL_LOWMEMORY
         a3d(i,j,k) = 0. _d 0
         b3d(i,j,k) = 1. _d 0
         c3d(i,j,k) = 0. _d 0
#endif
         Nsquare(i,j,k) = 0. _d 0
         SQRTTKE(i,j,k) = 0. _d 0
        ENDDO
       ENDDO
      ENDDO
#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE GGL90TKE(:,:,:,bi,bj)=comlev1_bibj, key=tkey, kind=isbyte
#endif
      DO j=1-OLy,sNy+OLy
       DO i=1-OLx,sNx+OLx
        KappaM(i,j)        = 0. _d 0
        uStarSquare(i,j)   = 0. _d 0
        verticalShear(i,j) = 0. _d 0
c       rMixingLength(i,j,1)  = 0. _d 0
#ifdef ALLOW_AUTODIFF
        IF ( usingZCoords .AND. maskC(i,j,1,bi,bj).EQ.oneRS
     &       .AND. GGL90TKE(i,j,1,bi,bj) .GT. zeroRL ) THEN
#endif
         SQRTTKE(i,j,1) = SQRT( GGL90TKE(i,j,1,bi,bj) )
#ifdef ALLOW_AUTODIFF
        ELSE
         SQRTTKE(i,j,1) = 0. _d 0
        ENDIF
#endif
#ifdef ALLOW_GGL90_HORIZDIFF
        xA(i,j)  = 0. _d 0
        yA(i,j)  = 0. _d 0
        dfx(i,j) = 0. _d 0
        dfy(i,j) = 0. _d 0
        gTKE(i,j) = 0. _d 0
#endif /* ALLOW_GGL90_HORIZDIFF */
       ENDDO
      ENDDO

#ifdef ALLOW_GGL90_LANGMUIR
      IF (useLANGMUIR) THEN
       recip_Lasq = 1. _d 0 / LC_num
       recip_Lasq = recip_Lasq * recip_Lasq
       recip_LD   = 4. _d 0 * PI / LC_lambda
       DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
         stokesterm(i,j) = 0. _d 0
         dstokesUdR(i,j) = 0. _d 0
         dstokesVdR(i,j) = 0. _d 0
        ENDDO
       ENDDO
      ENDIF
#endif

      DO k = 2, Nr
       DO j=jMin,jMax
        DO i=iMin,iMax
         mskLoc = maskC(i,j,k,bi,bj)*maskC(i,j,k-1,bi,bj)
#ifdef ALLOW_AUTODIFF
         IF ( mskLoc.EQ.oneRS
     &        .AND. GGL90TKE(i,j,k,bi,bj) .GT. zeroRL ) THEN
#endif
          SQRTTKE(i,j,k)=SQRT( GGL90TKE(i,j,k,bi,bj) )
#ifdef ALLOW_AUTODIFF
         ELSE
          SQRTTKE(i,j,k)=0. _d 0
         ENDIF
#endif

C     buoyancy frequency
         Nsquare(i,j,k) = gravity*gravitySign*recip_rhoConst
     &                  * sigmaR(i,j,k) * coordFac
C     vertical shear term (dU/dz)^2+(dV/dz)^2 is computed later
C     to save some memory
C     Initialise mixing length (eq. 2.35)
         GGL90mixingLength(i,j,k) = SQRTTWO *
     &        SQRTTKE(i,j,k)/SQRT( MAX(Nsquare(i,j,k),GGL90eps) )
     &        * mskLoc
        ENDDO
       ENDDO
      ENDDO

      CALL GGL90_MIXINGLENGTH(
     U     GGL90mixingLength,
#ifdef ALLOW_GGL90_LANGMUIR
     O     LCmixingLength,
#endif
     O     rMixingLength,
     I     iMin ,iMax ,jMin ,jMax,
     I     bi, bj, myTime, myIter, myThid )
#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE GGL90mixingLength = comlev1_bibj, key=tkey, kind=isbyte
CADJ STORE rMixingLength     = comlev1_bibj, key=tkey, kind=isbyte
# ifdef ALLOW_GGL90_LANGMUIR
CADJ STORE LCmixingLength    = comlev1_bibj, key=tkey, kind=isbyte
# endif
#endif

C     start "proper" k-loop
      DO k=2,Nr
       km1 = k-1
#ifdef ALLOW_AUTODIFF_TAMC
       kkey = k + (tkey-1)*Nr
#endif
#ifdef ALLOW_GGL90_HORIZDIFF
       IF ( GGL90diffTKEh .GT. 0. _d 0 ) THEN
C     horizontal diffusion of TKE (requires an exchange in
C      do_fields_blocking_exchanges)
C     common factors
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          xA(i,j) = _dyG(i,j,bi,bj)*drC(k)*
     &                 (MIN(.5 _d 0,_hFacW(i,j,km1,bi,bj) ) +
     &                  MIN(.5 _d 0,_hFacW(i,j,k  ,bi,bj) ) )
          yA(i,j) = _dxG(i,j,bi,bj)*drC(k)*
     &                 (MIN(.5 _d 0,_hFacS(i,j,km1,bi,bj) ) +
     &                  MIN(.5 _d 0,_hFacS(i,j,k  ,bi,bj) ) )
         ENDDO
        ENDDO
C     Compute diffusive fluxes
C     ... across x-faces
        DO j=1-OLy,sNy+OLy
         dfx(1-OLx,j)=0. _d 0
         DO i=1-OLx+1,sNx+OLx
          dfx(i,j) = -GGL90diffTKEh*xA(i,j)
     &      *_recip_dxC(i,j,bi,bj)
     &      *(GGL90TKE(i,j,k,bi,bj)-GGL90TKE(i-1,j,k,bi,bj))
#ifdef ISOTROPIC_COS_SCALING
     &      *CosFacU(j,bi,bj)
#endif /* ISOTROPIC_COS_SCALING */
         ENDDO
        ENDDO
C     ... across y-faces
        DO i=1-OLx,sNx+OLx
         dfy(i,1-OLy)=0. _d 0
        ENDDO
        DO j=1-OLy+1,sNy+OLy
         DO i=1-OLx,sNx+OLx
          dfy(i,j) = -GGL90diffTKEh*yA(i,j)
     &      *_recip_dyC(i,j,bi,bj)
     &      *(GGL90TKE(i,j,k,bi,bj)-GGL90TKE(i,j-1,k,bi,bj))
#ifdef ISOTROPIC_COS_SCALING
     &      *CosFacV(j,bi,bj)
#endif /* ISOTROPIC_COS_SCALING */
         ENDDO
        ENDDO
C     Compute divergence of fluxes
        DO j=1-OLy,sNy+OLy-1
         DO i=1-OLx,sNx+OLx-1
          gTKE(i,j) = -recip_drC(k)*recip_rA(i,j,bi,bj)
     &         *recip_hFacI(i,j,k)
     &         *((dfx(i+1,j)-dfx(i,j))
     &         + (dfy(i,j+1)-dfy(i,j)) )
         ENDDO
        ENDDO
C     end if GGL90diffTKEh .eq. 0.
       ENDIF
#endif /* ALLOW_GGL90_HORIZDIFF */

C     viscosity and diffusivity
#ifdef ALLOW_GGL90_LANGMUIR
       IF (useLANGMUIR) THEN
        DO j=jMin,jMax
         DO i=iMin,iMax
          KappaM(i,j) = GGL90ck*LCmixingLength(i,j,k)*SQRTTKE(i,j,k)
         ENDDO
        ENDDO
       ELSE
#endif
        DO j=jMin,jMax
         DO i=iMin,iMax
          KappaM(i,j) = GGL90ck*GGL90mixingLength(i,j,k)*SQRTTKE(i,j,k)
#ifdef ALLOW_GGL90_LANGMUIR
         ENDDO
        ENDDO
       ENDIF
       DO j=jMin,jMax
        DO i=iMin,iMax
#endif
         GGL90visctmp(i,j,k) = MAX( KappaM(i,j),diffKrNrS(k)
     &                            * recip_coordFac*recip_coordFac )
     &        * maskC(i,j,k,bi,bj)*maskC(i,j,k-1,bi,bj)
C        note: storing GGL90visctmp like this, and using it later to compute
C              GGL9rdiffKr etc. is robust in case of smoothing (e.g. see OPA)
         KappaM(i,j) = MAX( KappaM(i,j),viscArNr(k)
     &                    * recip_coordFac*recip_coordFac )
     &                    * maskC(i,j,k,bi,bj)*maskC(i,j,k-1,bi,bj)
        ENDDO
       ENDDO

C     compute vertical shear (dU/dz)^2+(dV/dz)^2
       IF ( calcMeanVertShear ) THEN
C     by averaging (@ grid-cell center) the 4 vertical shear compon @ U,V pos.
        DO j=jMin,jMax
         DO i=iMin,iMax
          tempU  = ( uVel( i ,j,km1,bi,bj) - uVel( i ,j,k,bi,bj) )
          tempUp = ( uVel(i+1,j,km1,bi,bj) - uVel(i+1,j,k,bi,bj) )
          tempV  = ( vVel(i, j ,km1,bi,bj) - vVel(i, j ,k,bi,bj) )
          tempVp = ( vVel(i,j+1,km1,bi,bj) - vVel(i,j+1,k,bi,bj) )
          verticalShear(i,j) = (
     &                 ( tempU*tempU + tempUp*tempUp )
     &               + ( tempV*tempV + tempVp*tempVp )
     &                         )*halfRL*recip_drC(k)*recip_drC(k)
     &                          *coordFac*coordFac
         ENDDO
        ENDDO
       ELSE
C     from the averaged flow at grid-cell center (2 compon x 2 pos.)
        DO j=jMin,jMax
         DO i=iMin,iMax
          tempU = ( ( uVel(i,j,km1,bi,bj) + uVel(i+1,j,km1,bi,bj) )
     &             -( uVel(i,j,k  ,bi,bj) + uVel(i+1,j,k  ,bi,bj) )
     &            )*halfRL*recip_drC(k)
     &             *coordFac
          tempV = ( ( vVel(i,j,km1,bi,bj) + vVel(i,j+1,km1,bi,bj) )
     &             -( vVel(i,j,k  ,bi,bj) + vVel(i,j+1,k  ,bi,bj) )
     &            )*halfRL*recip_drC(k)
     &             *coordFac
          verticalShear(i,j) = tempU*tempU + tempV*tempV
         ENDDO
        ENDDO
       ENDIF
#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE kappaM        = comlev1_bibj_k, key = kkey, kind=isbyte
CADJ STORE verticalShear = comlev1_bibj_k, key = kkey, kind=isbyte
#endif /* ALLOW_AUTODIFF_TAMC */

#ifdef ALLOW_GGL90_LANGMUIR
       IF (useLANGMUIR) THEN
C       compute (dStokesU/dz) and (dStokesV/dz)
        depthFac = recip_Lasq*EXP( recip_LD*rF(k) )
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          uStar = SIGN( SQRT(ABS(surfaceForcingU(i,j,bi,bj))),
     &                  surfaceForcingU(i,j,bi,bj) )
          dstokesUdR(i,j) = recip_LD * uStar * depthFac
          vStar = SIGN( SQRT(ABS(surfaceForcingV(i,j,bi,bj))),
     &                  surfaceForcingV(i,j,bi,bj) )
          dstokesVdR(i,j) = recip_LD * vStar * depthFac
         ENDDO
        ENDDO

        IF ( calcMeanVertShear ) THEN
C     by averaging (@ grid-cell center) the 4 vertical shear compon @
C     U,V pos.
         DO j=jMin,jMax
          DO i=iMin,iMax
           tempU  = ( uVel( i ,j,km1,bi,bj) - uVel( i ,j,k,bi,bj) )
           tempUp = ( uVel(i+1,j,km1,bi,bj) - uVel(i+1,j,k,bi,bj) )
           tempV  = ( vVel(i, j ,km1,bi,bj) - vVel(i, j ,k,bi,bj) )
           tempVp = ( vVel(i,j+1,km1,bi,bj) - vVel(i,j+1,k,bi,bj) )
           stokesterm(i,j) = (
     &              ( tempU *dstokesUdR(i,j)
     &               +tempUp*dstokesUdR(i+1,j) )
     &             +( tempV *dstokesVdR(i,j)
     &               +tempVp*dstokesVdR(i,j+1) )
     &                       )*halfRL*recip_drC(k)*coordFac*coordFac
          ENDDO
         ENDDO
        ELSE
C     from the averaged flow at grid-cell center (2 compon x 2 pos.)
         DO j=jMin,jMax
          DO i=iMin,iMax
           tempU = ( ( uVel(i,j,km1,bi,bj) + uVel(i+1,j,km1,bi,bj) )
     &              -( uVel(i,j,k  ,bi,bj) + uVel(i+1,j,k  ,bi,bj) )
     &             )*halfRL*recip_drC(k)
     &              *coordFac
           tempV = ( ( vVel(i,j,km1,bi,bj) + vVel(i,j+1,km1,bi,bj) )
     &              -( vVel(i,j,k  ,bi,bj) + vVel(i,j+1,k  ,bi,bj) )
     &             )*halfRL*recip_drC(k)
     &              *coordFac
           stokesterm(i,j) = halfRL*coordFac*(
     &                       tempU*(dstokesUdR(i,j)+dstokesUdR(i+1,j))
     &                     + tempV*(dstokesVdR(i,j)+dstokesVdR(i,j+1))
     &                       )
          ENDDO
         ENDDO
        ENDIF
       ENDIF
# ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE stokesterm = comlev1_bibj, key=tkey, kind=isbyte
# endif
#endif /* ALLOW_GGL90_LANGMUIR */

C     compute Prandtl number (always greater than 1)
#ifdef ALLOW_GGL90_IDEMIX
       IF ( useIDEMIX ) THEN
        DO j=jMin,jMax
         DO i=iMin,iMax
          RiNumber = MAX(Nsquare(i,j,k),0. _d 0)
     &         /(verticalShear(i,j)+GGL90eps)
          IDEMIX_RiNumber = MAX( KappaM(i,j)*Nsquare(i,j,k), 0. _d 0)/
     &         ( GGL90eps + IDEMIX_gTKE(i,j,k) )
          prTemp          = 6.6 _d 0 * MIN( RiNumber, IDEMIX_RiNumber )
          TKEPrandtlNumber(i,j,k) = MIN(10. _d 0,prTemp)
          TKEPrandtlNumber(i,j,k) = MAX( oneRL,TKEPrandtlNumber(i,j,k) )
         ENDDO
        ENDDO
       ELSE
#endif /* ALLOW_GGL90_IDEMIX */
        DO j=jMin,jMax
         DO i=iMin,iMax
          RiNumber = MAX(Nsquare(i,j,k),0. _d 0)
     &         /(verticalShear(i,j)+GGL90eps)
          prTemp = 1. _d 0
          IF ( RiNumber .GE. 0.2 _d 0 ) prTemp = 5. _d 0 * RiNumber
          TKEPrandtlNumber(i,j,k) = MIN(10. _d 0,prTemp)
         ENDDO
        ENDDO
#ifdef ALLOW_GGL90_IDEMIX
       ENDIF
#endif /* ALLOW_GGL90_IDEMIX */
#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE TKEPrandtlNumber(:,:,k)=comlev1_bibj_k,key=kkey,kind=isbyte
#endif /* ALLOW_AUTODIFF_TAMC */

       DO j=jMin,jMax
        DO i=iMin,iMax
C        diffusivity
         KappaH = KappaM(i,j)/TKEPrandtlNumber(i,j,k)
         KappaE(i,j,k) = GGL90alpha * KappaM(i,j)
     &        * maskC(i,j,k,bi,bj)*maskC(i,j,k-1,bi,bj)

C     dissipation term
         TKEdissipation = explDissFac*GGL90ceps
     &        *SQRTTKE(i,j,k)*rMixingLength(i,j,k)
     &        *GGL90TKE(i,j,k,bi,bj)
C     partial update with sum of explicit contributions
         GGL90TKE(i,j,k,bi,bj) = GGL90TKE(i,j,k,bi,bj)
     &        + deltaTloc*(
     &        + KappaM(i,j)*verticalShear(i,j)
     &        - KappaH*Nsquare(i,j,k)
     &        - TKEdissipation
     &        )
        ENDDO
       ENDDO

#ifdef ALLOW_GGL90_IDEMIX
       IF ( useIDEMIX ) THEN
C     add IDEMIX contribution to the turbulent kinetic energy
        DO j=jMin,jMax
         DO i=iMin,iMax
          GGL90TKE(i,j,k,bi,bj) = GGL90TKE(i,j,k,bi,bj)
     &         + deltaTloc*IDEMIX_gTKE(i,j,k)
         ENDDO
        ENDDO
       ENDIF
#endif /* ALLOW_GGL90_IDEMIX */

#ifdef ALLOW_GGL90_LANGMUIR
       IF ( useLANGMUIR ) THEN
C     add Langmuir contribution to the turbulent kinetic energy
        DO j=jMin,jMax
         DO i=iMin,iMax
          GGL90TKE(i,j,k,bi,bj) = GGL90TKE(i,j,k,bi,bj)
     &         + deltaTloc*(KappaM(i,j)*stokesterm(i,j))
         ENDDO
        ENDDO
       ENDIF
#endif /* ALLOW_GGL90_LANGMUIR */

#ifdef ALLOW_GGL90_HORIZDIFF
       IF ( GGL90diffTKEh .GT. 0. _d 0 ) THEN
C--    Add horiz. diffusion tendency
        DO j=jMin,jMax
         DO i=iMin,iMax
          GGL90TKE(i,j,k,bi,bj) = GGL90TKE(i,j,k,bi,bj)
     &                          + gTKE(i,j)*deltaTloc
         ENDDO
        ENDDO
       ENDIF
#endif /* ALLOW_GGL90_HORIZDIFF */

C--   end of k loop
      ENDDO
      IF ( usingPCoords ) THEN
C     impose TKE(1) = 0.
       DO j=jMin,jMax
        DO i=iMin,iMax
         GGL90TKE(i,j,1,bi,bj) = 0. _d 0
        ENDDO
       ENDDO
      ENDIF

C     ==============================================
C     Implicit time step to update TKE for k=1,Nr;
C     TKE(Nr+1)=0 by default;
C     for pressure coordinates, this translates into
C     TKE(1)  = 0, TKE(Nr+1) is the surface value
C     ==============================================
C     set up matrix
C--   Lower diagonal
      DO j=jMin,jMax
       DO i=iMin,iMax
         a3d(i,j,1) = 0. _d 0
       ENDDO
      ENDDO
      DO k=2,Nr
#ifdef GGL90_MISSING_HFAC_BUG
       IF ( .NOT.useIDEMIX ) THEN
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          recip_hFacI(i,j,k) = oneRS
         ENDDO
        ENDDO
       ENDIF
#endif
       km1=MAX(2,k-1)
       DO j=jMin,jMax
        DO i=iMin,iMax
         IF ( usingPCoords) km1=MIN(Nr,MAX(kSurfC(i,j,bi,bj)+1,k-1))
C-    We keep recip_hFacC in the diffusive flux calculation,
C-    but no hFacC in TKE volume control
C-    No need for maskC(k-1) with recip_hFacC(k-1)
         a3d(i,j,k) = -deltaTloc
     &        *recip_drF(k-1)*recip_hFacC(i,j,k-1,bi,bj)
     &        *.5 _d 0*(KappaE(i,j, k )+KappaE(i,j,km1))
     &        *recip_drC(k)*maskC(i,j,k,bi,bj)*recip_hFacI(i,j,k)
     &        *coordFac*coordFac
        ENDDO
       ENDDO
      ENDDO
C--   Upper diagonal
      DO j=jMin,jMax
       DO i=iMin,iMax
         c3d(i,j,1)  = 0. _d 0
       ENDDO
      ENDDO
      DO k=2,Nr
       kp1=MIN(k+1,Nr)
       DO j=jMin,jMax
        DO i=iMin,iMax
         IF ( usingZCoords ) kp1=MAX(1,MIN(klowC(i,j,bi,bj),k+1))
C-    We keep recip_hFacC in the diffusive flux calculation,
C-    but no hFacC in TKE volume control
C-    No need for maskC(k) with recip_hFacC(k)
         c3d(i,j,k) = -deltaTloc
     &        *recip_drF( k ) * recip_hFacC(i,j,k,bi,bj)
     &        *.5 _d 0*(KappaE(i,j,k)+KappaE(i,j,kp1))
     &        *recip_drC(k)*maskC(i,j,k-1,bi,bj)*recip_hFacI(i,j,k)
     &        *coordFac*coordFac
        ENDDO
       ENDDO
      ENDDO

      IF (.NOT.GGL90_dirichlet) THEN
C      Neumann bottom boundary condition for TKE: no flux from bottom
       IF ( usingPCoords ) THEN
        DO j=jMin,jMax
         DO i=iMin,iMax
          kBot = MIN(kSurfC(i,j,bi,bj)+1,Nr)
          a3d(i,j,kBot) = 0. _d 0
         ENDDO
        ENDDO
       ELSE
        DO j=jMin,jMax
         DO i=iMin,iMax
          kBot = MAX(kLowC(i,j,bi,bj),1)
          c3d(i,j,kBot) = 0. _d 0
         ENDDO
        ENDDO
       ENDIF
      ENDIF

C--   Center diagonal
      DO k=1,Nr
       km1 = MAX(k-1,1)
       DO j=jMin,jMax
        DO i=iMin,iMax
         b3d(i,j,k) = 1. _d 0 - c3d(i,j,k) - a3d(i,j,k)
     &        + implDissFac*deltaTloc*GGL90ceps*SQRTTKE(i,j,k)
     &        * rMixingLength(i,j,k)
     &        * maskC(i,j,k,bi,bj)*maskC(i,j,km1,bi,bj)
        ENDDO
       ENDDO
      ENDDO
      IF ( usingPCoords ) THEN
C     impose TKE(1) = 0.
       DO j=jMin,jMax
        DO i=iMin,iMax
         b3d(i,j,1) = 1. _d 0
        ENDDO
       ENDDO
      ENDIF
C     end set up matrix

C     Apply boundary condition
      IF ( calcMeanVertShear ) THEN
C     by averaging (@ grid-cell center) the 4 components @ U,V pos.
       DO j=jMin,jMax
        DO i=iMin,iMax
         tempU  = surfaceForcingU( i ,j,bi,bj)
         tempUp = surfaceForcingU(i+1,j,bi,bj)
         tempV  = surfaceForcingV(i, j ,bi,bj)
         tempVp = surfaceForcingV(i,j+1,bi,bj)
         uStarSquare(i,j) =
     &        ( tempU*tempU + tempUp*tempUp
     &        + tempV*tempV + tempVp*tempVp
     &        )*halfRL
C Note: adding parenthesis in 4 terms sum (-> 2 group of 2) as below:
c        uStarSquare(i,j) =
c    &        ( ( tempU*tempU + tempUp*tempUp )
c    &        + ( tempV*tempV + tempVp*tempVp )
c    &        )*halfRL
C       seems to break restart !
        ENDDO
       ENDDO
      ELSE
       DO j=jMin,jMax
        DO i=iMin,iMax
C     estimate friction velocity uStar from surface forcing
         uStarSquare(i,j) =
     &     ( .5 _d 0*( surfaceForcingU(i,  j,  bi,bj)
     &               + surfaceForcingU(i+1,j,  bi,bj) ) )**2
     &   + ( .5 _d 0*( surfaceForcingV(i,  j,  bi,bj)
     &               + surfaceForcingV(i,  j+1,bi,bj) ) )**2
        ENDDO
       ENDDO
      ENDIF
#ifdef ALLOW_SHELFICE
C     uStarSquare should not have any effect undernath iceshelves, but
C     masking uStarSquare underneath ice shelf is not necessary because
C     surfaceForcingU/V=0 in this case (see shelfice_forcing_surf.F)
C     Instead, uStarSquare is computed from the sub-glacial drag.
      IF ( useSHELFICE .AND.
     &     ( no_slip_shelfice .OR. SHELFICEDragLinear.NE.zeroRL
     &                        .OR. SHELFICEselectDragQuadr.GE.0 )
     &   ) THEN
C     First, we need to compute an early estimate of the drag
C     coefficients based ond the ocean velocity of the previous time
C     step only; because kappaRU and kappaRV are not yet available,
C     kappyRX is just set to horizontally constant viscosity
C     coefficients.
       DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
         stressU(i,j) = 0. _d 0
         stressV(i,j) = 0. _d 0
        ENDDO
       ENDDO
       DO k=1,Nr+1
        ki = MIN(k,Nr)
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          kappaRX(i,j,k) = viscArNr(ki)
         ENDDO
        ENDDO
       ENDDO
       DO k=1,Nr
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          KE  (i,j) = 0. _d 0
          uFld(i,j) = uVel(i,j,k,bi,bj)
          vFld(i,j) = vVel(i,j,k,bi,bj)
         ENDDO
        ENDDO
        CALL SHELFICE_U_DRAG_COEFF( bi, bj, k, .FALSE.,
     I       uFld, vFld, kappaRX, KE,
     O       cDragU,
     I       myIter, myThid )
        CALL SHELFICE_V_DRAG_COEFF( bi, bj, k, .FALSE.,
     I       uFld, vFld, kappaRX, KE,
     O       cDragV,
     I       myIter, myThid )
C-     compute explicit stress
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          stressU(i,j) = stressU(i,j) - cDragU(i,j)*uFld(i,j)*rUnit2mass
          stressV(i,j) = stressV(i,j) - cDragV(i,j)*vFld(i,j)*rUnit2mass
         ENDDO
        ENDDO
       ENDDO
C
       DO j=jMin,jMax
        DO i=jMin,jMax
         IF ( kTopC(i,j,bi,bj) .GT. 0 ) THEN
          uStarSquare(i,j) =
     &         ( stressU(i,j)*stressU(i,j)+stressU(i+1,j)*stressU(i+1,j)
     &         + stressV(i,j)*stressV(i,j)+stressV(i,j+1)*stressV(i,j+1)
     &         )*halfRL
         ENDIF
        ENDDO
       ENDDO
      ENDIF
#endif
#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE uStarSquare      = comlev1_bibj, key = tkey, kind = isbyte
#endif
      DO j=jMin,jMax
       DO i=iMin,iMax
#ifdef ALLOW_AUTODIFF
         IF ( uStarSquare(i,j) .GT. zeroRL )
     &        uStarSquare(i,j) = SQRT(uStarSquare(i,j))*recip_coordFac
#else
         uStarSquare(i,j) = SQRT(uStarSquare(i,j))*recip_coordFac
#endif
       ENDDO
      ENDDO
#ifdef ALLOW_AUTODIFF_TAMC
C     avoid recomputing the above multiple times in AD routine
CADJ STORE TKEPrandtlNumber = comlev1_bibj, key = tkey, kind = isbyte
CADJ STORE GGL90visctmp     = comlev1_bibj, key = tkey, kind = isbyte
CADJ STORE kappaE           = comlev1_bibj, key = tkey, kind = isbyte
CADJ STORE a3d, b3d, c3d    = comlev1_bibj, key = tkey, kind = isbyte
#endif

C     Dirichlet surface boundary condition for TKE
      IF ( usingPCoords ) THEN
       DO j=jMin,jMax
        DO i=iMin,iMax
CML#ifdef ALLOW_SHELFICE
CML         IF ( useShelfIce ) THEN
CML          kSrf = MAX(kTopC(i,j,bi,bj),1)
CML          kTop = kSrf
CML         ENDIF
CML#endif
         GGL90TKE(i,j,kSrf,bi,bj) = GGL90TKE(i,j,kSrf,bi,bj)
     &        - c3d(i,j,kSrf) * maskC(i,j,kSrf,bi,bj)
     &        *MAX(GGL90TKEsurfMin,GGL90m2*uStarSquare(i,j))
         c3d(i,j,kSrf) = 0. _d 0
        ENDDO
       ENDDO
      ELSE
       DO j=jMin,jMax
        DO i=iMin,iMax
#ifdef ALLOW_SHELFICE
         IF ( useShelfIce ) THEN
          kSrf = MAX(1,kTopC(i,j,bi,bj))
          kTop = MIN(kSrf+1,Nr)
         ENDIF
#endif
         GGL90TKE(i,j,kSrf,bi,bj) = maskC(i,j,kSrf,bi,bj)
     &        *MAX(GGL90TKEsurfMin,GGL90m2*uStarSquare(i,j))
         GGL90TKE(i,j,kTop,bi,bj) = GGL90TKE(i,j,kTop,bi,bj)
     &        - a3d(i,j,kTop)*GGL90TKE(i,j,kSrf,bi,bj)
         a3d(i,j,kTop) = 0. _d 0
        ENDDO
       ENDDO
      ENDIF

      IF (GGL90_dirichlet) THEN
C      Dirichlet bottom boundary condition for TKE = GGL90TKEbottom
       IF ( usingPCoords ) THEN
        DO j=jMin,jMax
         DO i=iMin,iMax
          kBot = MIN(kSurfC(i,j,bi,bj)+1,Nr)
          GGL90TKE(i,j,kBot,bi,bj) = GGL90TKE(i,j,kBot,bi,bj)
     &                             - GGL90TKEbottom*a3d(i,j,kBot)
          a3d(i,j,kBot) = 0. _d 0
         ENDDO
        ENDDO
       ELSE
        DO j=jMin,jMax
         DO i=iMin,iMax
          kBot = MAX(kLowC(i,j,bi,bj),1)
          GGL90TKE(i,j,kBot,bi,bj) = GGL90TKE(i,j,kBot,bi,bj)
     &                             - GGL90TKEbottom*c3d(i,j,kBot)
          c3d(i,j,kBot) = 0. _d 0
         ENDDO
        ENDDO
       ENDIF
      ENDIF

#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE GGL90TKE(:,:,:,bi,bj)=comlev1_bibj, key=tkey, kind=isbyte
#endif
C     solve tri-diagonal system
      errCode = -1
      CALL SOLVE_TRIDIAGONAL( iMin,iMax, jMin,jMax,
     I                        a3d, b3d, c3d,
     U                        GGL90TKE(1-OLx,1-OLy,1,bi,bj),
     O                        errCode,
     I                        bi, bj, myThid )

#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE GGL90TKE(:,:,:,bi,bj)=comlev1_bibj, key=tkey, kind=isbyte
#endif
      DO k=2,Nr
#if ( defined ALLOW_DIAGNOSTICS && !defined ALLOW_AUTODIFF )
C     This diagnostics code causes extra recomputations so we skip it.
       IF ( doDiagTKEmin ) THEN
        DO j=1,sNy
         DO i=1,sNx
          surf_flx_tke(i,j) = GGL90TKE(i,j,k,bi,bj)
     &         * maskC(i,j,k,bi,bj)*maskC(i,j,k-1,bi,bj)
         ENDDO
        ENDDO
       ENDIF
#endif
       DO j=jMin,jMax
        DO i=iMin,iMax
C     impose minimum TKE to avoid numerical undershoots below zero;
C     level k=1 is either prescribed surface boundary condition (z-coords) or
C     bottom boundary conditions, which by definition is zero
         GGL90TKE(i,j,k,bi,bj) = maskC(i,j,k,bi,bj)*maskC(i,j,k-1,bi,bj)
     &                  *MAX( GGL90TKE(i,j,k,bi,bj), GGL90TKEmin )
        ENDDO
       ENDDO
#if ( defined ALLOW_DIAGNOSTICS && !defined ALLOW_AUTODIFF )
       IF ( doDiagTKEmin ) THEN
        recip_deltaT = 1. _d 0 / deltaTloc
        DO j=1,sNy
         DO i=1,sNx
          surf_flx_tke(i,j) = (GGL90TKE(i,j,k,bi,bj)-surf_flx_tke(i,j))
     &         *recip_deltaT
         ENDDO
        ENDDO
        CALL DIAGNOSTICS_FILL( surf_flx_tke ,'GGL90Emn',
     &                         k, 1, 2, bi, bj, myThid )
       ENDIF
#endif
      ENDDO

C     end of time step
C     ===============================

      DO k=2,Nr
#ifdef ALLOW_GGL90_SMOOTH
       DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
         maskI(i,j) = maskC(i,j,k,bi,bj)*maskC(i,j,k-1,bi,bj)
     &        *mskCor(i,j,bi,bj)
         GGL90visctmp(i,j,k) = GGL90visctmp(i,j,k)*mskCor(i,j,bi,bj)
        ENDDO
       ENDDO
#endif
       DO j=1,sNy
        DO i=1,sNx
#ifdef ALLOW_GGL90_SMOOTH
         tmpVisc = (
     &     p4 *    GGL90visctmp(i  ,j  ,k)
     &    +p8 *( ( GGL90visctmp(i-1,j  ,k) + GGL90visctmp(i+1,j  ,k) )
     &         + ( GGL90visctmp(i  ,j-1,k) + GGL90visctmp(i  ,j+1,k) ) )
     &    +p16*( ( GGL90visctmp(i+1,j+1,k) + GGL90visctmp(i-1,j-1,k) )
     &         + ( GGL90visctmp(i+1,j-1,k) + GGL90visctmp(i-1,j+1,k) ) )
     &             )/(
     &     p4
     &    +p8 *(( maskI(i-1,j  ) + maskI(i+1,j  ) )
     &         +( maskI(i  ,j-1) + maskI(i  ,j+1) ) )
     &    +p16*(( maskI(i+1,j+1) + maskI(i-1,j-1) )
     &         +( maskI(i+1,j-1) + maskI(i-1,j+1) ) )
     &               )*maskI(i,j)
#else
         tmpVisc = GGL90visctmp(i,j,k)
#endif
         tmpVisc = MIN(tmpVisc/TKEPrandtlNumber(i,j,k),GGL90diffMax)
     &        * coordFac*coordFac
         GGL90diffKr(i,j,k,bi,bj)= MAX( tmpVisc , diffKrNrS(k) )
        ENDDO
       ENDDO

       DO j=1,sNy
        DO i=1,sNx+1
#ifdef ALLOW_GGL90_SMOOTH
         tmpVisc = (
     &     p4 *(   GGL90visctmp(i-1,j  ,k) + GGL90visctmp(i,j  ,k) )
     &    +p8 *( ( GGL90visctmp(i-1,j-1,k) + GGL90visctmp(i,j-1,k) )
     &         + ( GGL90visctmp(i-1,j+1,k) + GGL90visctmp(i,j+1,k) ) )
     &             )/(
     &     p4 * 2. _d 0
     &    +p8 *(( maskI(i-1,j-1) + maskI(i,j-1) )
     &         +( maskI(i-1,j+1) + maskI(i,j+1) ) )
     &               )*maskI(i-1,j) * maskI(i,j)
#else
         tmpVisc = _maskW(i,j,k-1,bi,bj) * _maskW(i,j,k,bi,bj) * halfRL
     &          *( GGL90visctmp(i-1,j,k)
     &           + GGL90visctmp(i,  j,k) )
#endif
         tmpVisc = MIN( tmpVisc , GGL90viscMax )
     &        * coordFac*coordFac
         GGL90viscArU(i,j,k,bi,bj) = MAX( tmpVisc, viscArNr(k) )
        ENDDO
       ENDDO

       DO j=1,sNy+1
        DO i=1,sNx
#ifdef ALLOW_GGL90_SMOOTH
         tmpVisc = (
     &     p4 *(   GGL90visctmp(i  ,j-1,k) + GGL90visctmp(i  ,j,k) )
     &    +p8 *( ( GGL90visctmp(i-1,j-1,k) + GGL90visctmp(i-1,j,k) )
     &         + ( GGL90visctmp(i+1,j-1,k) + GGL90visctmp(i+1,j,k) ) )
     &             )/(
     &     p4 * 2. _d 0
     &    +p8 *(( maskI(i-1,j-1) + maskI(i-1,j) )
     &         +( maskI(i+1,j-1) + maskI(i+1,j) ) )
     &               )*maskI(i,j-1) * maskI(i,j)
#else
         tmpVisc = _maskS(i,j,k-1,bi,bj) * _maskS(i,j,k,bi,bj) * halfRL
     &          *( GGL90visctmp(i,j-1,k)
     &           + GGL90visctmp(i,j,  k) )
#endif
         tmpVisc = MIN( tmpVisc , GGL90viscMax )
     &        * coordFac*coordFac
         GGL90viscArV(i,j,k,bi,bj) = MAX( tmpVisc, viscArNr(k) )
        ENDDO
       ENDDO
      ENDDO

#ifdef ALLOW_DIAGNOSTICS
      IF ( useDiagnostics ) THEN
        CALL DIAGNOSTICS_FILL( GGL90TKE   ,'GGL90TKE',
     &                         0,Nr, 1, bi, bj, myThid )
        CALL DIAGNOSTICS_FILL( GGL90viscArU,'GGL90ArU',
     &                         0,Nr, 1, bi, bj, myThid )
        CALL DIAGNOSTICS_FILL( GGL90viscArV,'GGL90ArV',
     &                         0,Nr, 1, bi, bj, myThid )
        CALL DIAGNOSTICS_FILL( GGL90diffKr,'GGL90Kr ',
     &                         0,Nr, 1, bi, bj, myThid )
        CALL DIAGNOSTICS_FILL( TKEPrandtlNumber ,'GGL90Prl',
     &                         0,Nr, 2, bi, bj, myThid )
#ifdef ALLOW_GGL90_LANGMUIR
        IF (useLANGMUIR) THEN
         CALL DIAGNOSTICS_FILL( LCmixingLength,'GGL90Lmx',
     &                          0,Nr, 2, bi, bj, myThid )
        ELSE
#else
        IF (.TRUE.) THEN
#endif /* ALLOW_GGL90_LANGMUIR */
         CALL DIAGNOSTICS_FILL( GGL90mixingLength,'GGL90Lmx',
     &                          0,Nr, 2, bi, bj, myThid )
        ENDIF

C     avoid extra 3D diagnostics field and abuse unused field
        IF ( DIAGNOSTICS_IS_ON('GGL90KN2',myThid) ) THEN
         DO k=1,Nr
          DO j=1,sNy
           DO i=1,sNx
            TKEPrandtlNumber(i,j,k) =
     &           GGL90diffKr(i,j,k,bi,bj) * Nsquare(i,j,k)
           ENDDO
          ENDDO
         ENDDO
         CALL DIAGNOSTICS_FILL( TKEPrandtlNumber ,'GGL90KN2',
     &                          0, Nr, 2, bi, bj, myThid )
        ENDIF

        IF ( DIAGNOSTICS_IS_ON('GGL90flx',myThid) ) THEN
C     diagnose surface flux of TKE
         IF ( usingPCoords ) THEN
          DO j=jMin,jMax
           DO i=iMin,iMax
CML#ifdef ALLOW_SHELFICE
CML           IF ( useShelfIce ) THEN
CML            kSrf = MAX(kTopC(i,j,bi,bj),1)
CML            kTop = kSrf
CML           ENDIF
CML#endif
            surf_flx_tke(i,j) =
     &           (MAX(GGL90TKEsurfMin,GGL90m2*uStarSquare(i,j))
     &           - GGL90TKE(i,j,kSrf,bi,bj) )
     &           *recip_drF(kSrf)*recip_hFacC(i,j,kSrf,bi,bj)
     &           *KappaE(i,j,kSrf)
     &           *coordFac
           ENDDO
          ENDDO
         ELSE
          DO j=jMin,jMax
           DO i=iMin,iMax
#ifdef ALLOW_SHELFICE
            IF ( useShelfIce ) THEN
             kSrf = MAX(1,kTopC(i,j,bi,bj))
             kTop = MIN(kSrf+1,Nr)
            ENDIF
#endif
            surf_flx_tke(i,j) =(GGL90TKE(i,j,kSrf,bi,bj)-
     &                          GGL90TKE(i,j,kTop,bi,bj))
     &         *recip_drF(kSrf)*recip_hFacC(i,j,kSrf,bi,bj)
     &         *KappaE(i,j,kTop)
           ENDDO
          ENDDO
         ENDIF
         CALL DIAGNOSTICS_FILL( surf_flx_tke,'GGL90flx',
     &                          0, 1, 2, bi, bj, myThid )
        ENDIF

        IF ( DIAGNOSTICS_IS_ON('GGL90tau',myThid) ) THEN
         k=kSrf
         DO j=jMin,jMax
          DO i=iMin,iMax
#ifdef ALLOW_SHELFICE
           IF ( useShelfIce ) k = MAX(1,kTopC(i,j,bi,bj))
#endif
C     diagnose work done by the wind
           surf_flx_tke(i,j) =
     &      halfRL*( surfaceForcingU(i,  j,bi,bj)*uVel(i  ,j,k,bi,bj)
     &              +surfaceForcingU(i+1,j,bi,bj)*uVel(i+1,j,k,bi,bj))
     &    + halfRL*( surfaceForcingV(i,j,  bi,bj)*vVel(i,j  ,k,bi,bj)
     &              +surfaceForcingV(i,j+1,bi,bj)*vVel(i,j+1,k,bi,bj))
           surf_flx_tke(i,j) = surf_flx_tke(i,j) *recip_coordFac
          ENDDO
         ENDDO
         CALL DIAGNOSTICS_FILL( surf_flx_tke,'GGL90tau',
     &                          0, 1, 2, bi, bj, myThid )
        ENDIF
C     endif useDiagnostics
      ENDIF
#endif /* ALLOW_DIAGNOSTICS */

#endif /* ALLOW_GGL90 */

      RETURN
      END

!=======================================================================
      subroutine coupsend_i4vec( component, dataname, length, vecFld )
      implicit none
! Predefined constants/arrays
#include "CPLR_SIG.h"
! MPI variables
#include "mpif.h"
! Arguments
      character*(*) component
      character*(*) dataname
      integer length
      integer vecFld(length)
! Functions
      integer mitcplr_match_comp
      integer generate_tag
      external mitcplr_match_comp
      external generate_tag
! Local
      integer count,dtype,dest,tag,comm,ierr
      integer compind, numprocs
      integer i, n
      integer ibuf(MAX_IBUF)
!     ------------------------------------------------------------------

      if ( 1+length .gt. MAX_IBUF )
     &    STOP 'coupsend_i4vec: length exceeds MAX_IBUF'

! Establish who I am communicating with
      compind = mitcplr_match_comp( component )
      if (compind.le.0) STOP 'coupsend_i4vec: Bad component id'
      comm = MPI_COMM_compcplr( compind )
      numprocs = num_component_procs(compind)
      if (numprocs.lt.1) then
        write(LogUnit,*) 'coupsend_i4vec: compind = ',compind
        STOP 'coupsend_i4vec: numprocs < 1'
      endif
      if (VERB)
     &  write(LogUnit,*) 'coupsend_i4vec: ',component_Name(compind)
      if (VERB)
     &  write(LogUnit,*) 'coupsend_i4vec: dataname=',dataname

! Copy vector to buffer
      ibuf(1) = length
      do i=1,length
        ibuf(i+1) = vecFld(i)
      enddo

! Foreach component process
      do n=1,numprocs

! Send message
       count = 1+length
       dtype = MPI_INTEGER
       tag = generate_tag( 125, n, dataname )
       dest = rank_component_procs(n,compind)

       if (VERB) then
        write(LogUnit,*)
     &    'coupsend_i4vec: calling MPI_Send dest=',dest,
     &    ' proc=',n,'/',numprocs
        call flush(LogUnit)
       endif
       call MPI_Send( ibuf, count, dtype, dest, tag, comm, ierr )
       if (VERB) then
        write(LogUnit,*) 'coupsend_i4vec: returned ierr=',ierr
        call flush(LogUnit)
       endif

       if (ierr.ne.0) then
        write(LogUnit,*) 'coupsend_i4vec: rank(W,G)=',
     &            my_rank_in_world,my_rank_in_global,
     &            ' ierr=',ierr
        STOP 'coupsend_i4vec: MPI_Send failed'
       endif

      enddo ! n

!     ------------------------------------------------------------------
      return
      end
!=======================================================================

#include "COST_OPTIONS.h"
c#ifdef ALLOW_CTRL
c# include "CTRL_OPTIONS.h"
c#endif

CBOP
C     !ROUTINE: COST_TEMP
C     !INTERFACE:
      SUBROUTINE COST_TEMP( myThid )
C     *==========================================================*
C     | SUBROUTINE COST_TEMP
C     | o the subroutine computes the sum of the squared errors
C     |   relatively to the Levitus climatology
C     *==========================================================*
C
C     \ev
C     !USES:
       IMPLICIT NONE
C     == Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "cost.h"
#ifdef ALLOW_OPENAD
# include "FFIELDS.h"
#else
# include "cost_local.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     myThid - Thread number for this instance of the routine.
      INTEGER myThid

#ifdef ALLOW_COST_TEMP
C     !LOCAL VARIABLES:
      INTEGER i, j, k
      INTEGER bi, bj
      INTEGER Nk
      _RL locfc,tmp
      _RL thetalev(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
CEOP

      Nk = 2
C Read annual mean Levitus temperature

      CALL READ_FLD_XYZ_RL('lev_t_an.bin',' ',thetalev,0,myThid)

C  Total number of wet temperature point
      tmp  = 0. _d 0
      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
         DO k=1, Nk
          DO j=1,sNy
           DO i=1,sNx
             tmp = tmp + maskC(i,j,k,bi,bj)
           ENDDO
          ENDDO
         ENDDO
       ENDDO
      ENDDO
      _GLOBAL_SUM_RL( tmp , myThid )
      IF ( tmp.GT.0. ) tmp = 1. _d 0 / tmp

      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)

         locfc = 0. _d 0
         DO k=1,Nk
           DO j=1,sNy
            DO i=1,sNx
              locfc = locfc + tmp*maskC(i,j,k,bi,bj)*
     &         wtheta(k,bi,bj)*
     &         ( cMeanTheta(i,j,k,bi,bj) - thetalev(i,j,k,bi,bj) )**2
            ENDDO
           ENDDO
         ENDDO

         objf_temp_tut(bi,bj) = locfc
c        print*,'objf_temp_tut =',locfc,startTime,endTime,tmp

       ENDDO
      ENDDO

#endif /* ALLOW_COST_TEMP */
      RETURN
      END

#include "CPP_OPTIONS.h"

CBOP
C     !ROUTINE: UPDATE_R_STAR
C     !INTERFACE:
      SUBROUTINE UPDATE_R_STAR( useLatest, myTime, myIter, myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE UPDATE_R_STAR
C     | o Update the thickness fractions (hFacC,W,S)
C     |   according to the surface r-position = Non-Linear FrSurf
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     == Global variables
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "SURFACE.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     useLatest :: if true use rStarFacC, else use rStarFacNm1C
C     myTime    :: Current time in simulation
C     myIter    :: Current iteration number in simulation
C     myThid    :: Thread number for this instance of the routine.
      LOGICAL useLatest
      _RL myTime
      INTEGER myIter
      INTEGER myThid

C     !LOCAL VARIABLES:
#ifdef NONLIN_FRSURF
C     Local variables
C     i,j,k,bi,bj :: loop counter
      INTEGER i,j,k,bi,bj
CEOP

      DO bj=myByLo(myThid), myByHi(myThid)
       DO bi=myBxLo(myThid), myBxHi(myThid)

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

       IF (useLatest) THEN

        DO k=1,Nr
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
# ifndef DISABLE_RSTAR_CODE
C-- Update the fractional thickness hFacC , hFacW & hFacS (& "recip_hFac") :
            hFacC(i,j,k,bi,bj) = h0FacC(i,j,k,bi,bj)
     &                          *rStarFacC(i,j,bi,bj)
            hFacW(i,j,k,bi,bj) = h0FacW(i,j,k,bi,bj)
     &                          *rStarFacW(i,j,bi,bj)
            hFacS(i,j,k,bi,bj) = h0FacS(i,j,k,bi,bj)
     &                          *rStarFacS(i,j,bi,bj)
#endif
C
#ifdef USE_MASK_AND_NO_IF
            recip_hFacC(i,j,k,bi,bj) = maskC(i,j,k,bi,bj)
     &        / ( _hFacC(i,j,k,bi,bj) + (1.-maskC(i,j,k,bi,bj)) )
            recip_hFacW(i,j,k,bi,bj) = maskW(i,j,k,bi,bj)
     &        / ( _hFacW(i,j,k,bi,bj) + (1.-maskW(i,j,k,bi,bj)) )
            recip_hFacS(i,j,k,bi,bj) = maskS(i,j,k,bi,bj)
     &        / ( _hFacS(i,j,k,bi,bj) + (1.-maskS(i,j,k,bi,bj)) )
#else
           IF (maskC(i,j,k,bi,bj).NE.0.)
     &      recip_hFacC(i,j,k,bi,bj) = 1. _d 0 / _hFacC(i,j,k,bi,bj)
           IF (maskW(i,j,k,bi,bj).NE.0.)
     &      recip_hFacW(i,j,k,bi,bj) = 1. _d 0 / _hFacW(i,j,k,bi,bj)
           IF (maskS(i,j,k,bi,bj).NE.0.)
     &      recip_hFacS(i,j,k,bi,bj) = 1. _d 0 / _hFacS(i,j,k,bi,bj)
#endif
          ENDDO
         ENDDO
        ENDDO

       ELSE

        DO k=1,Nr
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
# ifndef DISABLE_RSTAR_CODE
C-- Update the fractional thickness hFacC , hFacW & hFacS (&
C"recip_hFac") :
            hFacC(i,j,k,bi,bj) = h0FacC(i,j,k,bi,bj)
     &                          *rStarFacNm1C(i,j,bi,bj)
            hFacW(i,j,k,bi,bj) = h0FacW(i,j,k,bi,bj)
     &                          *rStarFacNm1W(i,j,bi,bj)
            hFacS(i,j,k,bi,bj) = h0FacS(i,j,k,bi,bj)
     &                          *rStarFacNm1S(i,j,bi,bj)
#endif
C
#ifdef USE_MASK_AND_NO_IF
            recip_hFacC(i,j,k,bi,bj) = maskC(i,j,k,bi,bj) /
     &        ( _hFacC(i,j,k,bi,bj) + (oneRS - maskC(i,j,k,bi,bj)) )
            recip_hFacW(i,j,k,bi,bj) = maskW(i,j,k,bi,bj) /
     &        ( _hFacW(i,j,k,bi,bj) + (oneRS - maskW(i,j,k,bi,bj)) )
            recip_hFacS(i,j,k,bi,bj) = maskS(i,j,k,bi,bj) /
     &        ( _hFacS(i,j,k,bi,bj) + (oneRS - maskS(i,j,k,bi,bj)) )
#else
            IF ( maskC(i,j,k,bi,bj).NE.zeroRS )
     &        recip_hFacC(i,j,k,bi,bj) = oneRS / _hFacC(i,j,k,bi,bj)
            IF ( maskW(i,j,k,bi,bj).NE.zeroRS )
     &        recip_hFacW(i,j,k,bi,bj) = oneRS / _hFacW(i,j,k,bi,bj)
            IF ( maskS(i,j,k,bi,bj).NE.zeroRS )
     &        recip_hFacS(i,j,k,bi,bj) = oneRS / _hFacS(i,j,k,bi,bj)
#endif
          ENDDO
         ENDDO
        ENDDO

       ENDIF

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C- end bi,bj loop
       ENDDO
      ENDDO

c     _EXCH_XYZ_RS( hFacC, myThid )
c     _EXCH_XYZ_RS( recip_hFacC, myThid )
c     CALL EXCH_UV_XYZ_RS(hFacW,hFacS,.FALSE.,myThid)
c     CALL EXCH_UV_XYZ_RS(recip_hFacW,recip_hFacS,.FALSE.,myThid)

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
#endif /* NONLIN_FRSURF */

      RETURN
      END

#include "STREAMICE_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

CBOP
      SUBROUTINE STREAMICE_TAUB ( myThid )

C     /============================================================\
C     | SUBROUTINE                                                 |
C     | o                                                          |
C     |============================================================|
C     |                                                            |
C     \============================================================/
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "GRID.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "STREAMICE.h"
#include "STREAMICE_CG.h"

C     !INPUT/OUTPUT ARGUMENTS
      INTEGER myThid
c       _RL taudx (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
c       _RL taudx (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)

#ifdef ALLOW_STREAMICE
#ifdef STREAMICE_HYBRID_STRESS

C     LOCAL VARIABLES
      INTEGER i, j, bi, bj, k, l
      _RL umid, vmid

      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        DO j=1,sNy
         DO i=1,sNx
cph(
#ifdef ALLOW_STREAMICE_FP_ADJ
          taubx_new_si (i,j,bi,bj) = 0.
          tauby_new_si (i,j,bi,bj) = 0.
#else
          streamice_taubx (i,j,bi,bj) = 0.
          streamice_tauby (i,j,bi,bj) = 0.
#endif
cph)
          IF (STREAMICE_hmask(i,j,bi,bj).eq.1) THEN

c            streamice_taubx (i,j,bi,bj) =
c      &      tau_beta_eff_streamice(i,j,bi,bj) * U_streamice(i,j,bi,bj)
c            streamice_tauby (i,j,bi,bj) =
c      &      tau_beta_eff_streamice(i,j,bi,bj) * V_streamice(i,j,bi,bj)

           umid = 0.0
           vmid = 0.0

           DO k=0,1
            DO l=0,1
             umid = umid + 0.25 *
     &        dxG(i,j+l,bi,bj)*dyG(i+k,j,bi,bj) *
     &        recip_rA(i,j,bi,bj) *
#ifdef ALLOW_STREAMICE_FP_ADJ
     &        U_new_si(i+k,j+l,bi,bj)
#else
     &        U_streamice(i+k,j+l,bi,bj)
#endif
             vmid = vmid + 0.25 *
     &        dxG(i,j+l,bi,bj)*dyG(i+k,j,bi,bj) *
     &        recip_rA(i,j,bi,bj) *
#ifdef ALLOW_STREAMICE_FP_ADJ
     &        V_new_si(i+k,j+l,bi,bj)
#else
     &        V_streamice(i+k,j+l,bi,bj)
#endif
            ENDDO
           ENDDO

#ifdef ALLOW_STREAMICE_FP_ADJ
           taubx_new_si (i,j,bi,bj) =
     &      tau_beta_eff_streamice(i,j,bi,bj) * umid
           tauby_new_si (i,j,bi,bj) =
     &      tau_beta_eff_streamice(i,j,bi,bj) * vmid
#else
           streamice_taubx (i,j,bi,bj) =
     &      tau_beta_eff_streamice(i,j,bi,bj) * umid
           streamice_tauby (i,j,bi,bj) =
     &      tau_beta_eff_streamice(i,j,bi,bj) * vmid
#endif
          ENDIF
         ENDDO
        ENDDO
       ENDDO
      ENDDO

#endif
#endif
      RETURN
      END

#include "FIZHI_OPTIONS.h"
       subroutine update_chemistry_exports (myTime, myIter, myThid)
c----------------------------------------------------------------------
c  Subroutine update_chemistry_exports - 'Wrapper' routine to update
c        the fields related to the earth chemistry that are needed
c        by fizhi.
c        Also: Set up "bi, bj loop" and some timers and clocks here.
c
c Call:  interp_chemistry
c-----------------------------------------------------------------------
       implicit none
#include "SIZE.h"
#include "fizhi_SIZE.h"
#include "fizhi_land_SIZE.h"
#include "GRID.h"
#include "DYNVARS.h"
#include "fizhi_chemistry_coms.h"
#include "fizhi_coms.h"
#include "gridalt_mapping.h"
#include "EEPARAMS.h"
#include "chronos.h"

      integer myIter, myThid
      _RL myTime

c pe on physics grid refers to bottom edge
      _RL pephy(1-Olx:sNx+Olx,1-Oly:sNy+Oly,Nrphys+1,nSx,nSy)
      _RL pphy(sNx,sNy,Nrphys,nSx,nSy)
      _RL oz1(nlatsoz,nlevsoz), strq1(nlatsq,nlevsq)
      _RL waterin(sNx,sNy,Nrphys), xlat(sNx,sNy)

      integer i, j, L, LL, bi, bj
      integer im1, im2, jm1, jm2
      integer nhms1,nymd1,nhms2,nymd2,imns,ipls
      _RL facm, facp
      logical alarm
      external alarm

      im1 = 1
      im2 = sNx
      jm1 = 1
      jm2 = sNy

      if( alarm('radsw').or.alarm('radlw') ) then

       do bj = myByLo(myThid), myByHi(myThid)
       do bi = myBxLo(myThid), myBxHi(myThid)

c  Construct the physics grid pressures - count pephy levels top down
c                                         (even though dpphy counted bottom up)
        do j = 1,sNy
        do i = 1,sNx
         pephy(i,j,Nrphys+1,bi,bj)=(Ro_surf(i,j,bi,bj)+etaH(i,j,bi,bj))
         do L = 2,Nrphys+1
         LL = Nrphys+2-L
         pephy(i,j,LL,bi,bj)=pephy(i,j,LL+1,bi,bj)-dpphys(i,j,L-1,bi,bj)
         enddo
        enddo
        enddo
        do j = 1,sNy
        do i = 1,sNx
         do L = 1,Nrphys
          pphy(i,j,L,bi,bj)=(pephy(i,j,L+1,bi,bj)+pephy(i,j,L,bi,bj))
     .                                              /200.
         enddo
        enddo
        enddo

        do j = 1,sNy
        do i = 1,sNx
         xlat(i,j) = yC(i,j,bi,bj)
         do L = 1,Nrphys
          waterin(i,j,L) = sphy(i,j,L,bi,bj)
         enddo
        enddo
        enddo

        call time_bound(nymd,nhms,nymd1,nhms1,nymd2,nhms2,imns,ipls)
        call interp_time(nymd,nhms,nymd1,nhms1,nymd2,nhms2,facm,facp)

        do L = 1,nlevsoz
        do j = 1,nlatsoz
         oz1(j,L) = ozone(j,L,imns)*facm + ozone(j,L,ipls)*facp
        enddo
        enddo

        do L = 1,nlevsq
        do j = 1,nlatsq
         strq1(j,L) = stratq(j,L,imns)*facm + stratq(j,L,ipls)*facp
        enddo
        enddo

        call interp_chemistry(strq1,nlevsq,nlatsq,levsq,latsq,
     .   oz1,nlevsoz,nlatsoz,levsoz,latsoz,
     .   waterin,pphy(1,1,1,bi,bj),xlat,
     .   im2,jm2,Nrphys,nSx,nSy,bi,bj,o3,qstr)

       enddo
       enddo

      endif

      return
      end

      subroutine interp_chemistry (stratq,nwatlevs,nwatlats,watlevs,
     . watlats,ozone,nozlevs,nozlats,ozlevs,ozlats,
     . qz,plz,xlat,im,jm,lm,nSx,nSy,bi,bj,ozrad,qzrad)

      implicit none

c Input Variables
c ---------------
      integer nwatlevs,nwatlats,nozlevs,nozlats,nSx,nSy,bi,bj
      _RL stratq(nwatlats,nwatlevs),ozone(nozlats,nozlevs)
      _RL watlevs(nwatlevs),watlats(nwatlats)
      _RL ozlevs(nozlevs),ozlats(nozlats)
      integer im,jm,lm
      _RL qz(im,jm,lm),plz(im,jm,lm)
      _RL xlat(im,jm)
      _RL ozrad(im,jm,lm,nSx,nSy)
      _RL qzrad(im,jm,lm,nSx,nSy)

C **********************************************************************
C ****           Get Ozone and Stratospheric Moisture Data          ****
C **********************************************************************

      call interp_qz (stratq,nwatlevs,nwatlats,watlevs,watlats,im*jm,
     .                         bi,bj, xlat,lm,plz,qz,qzrad(1,1,1,bi,bj))
      call interp_oz (ozone ,nozlevs,nozlats,ozlevs,ozlats,im*jm,
     .                         bi,bj, xlat,lm,plz,ozrad(1,1,1,bi,bj))

      return
      end

      subroutine interp_qz(stratq,nwatlevs,nwatlats,watlevs,watlats,
     .                         irun,bi,bj,xlat,nlevs,pres,qz_in,qz_out )
C***********************************************************************
C  Purpose
C     To Interpolate Chemistry Moisture from Chemistry Grid to Physics Grid
C
C  INPUT Argument Description
C     stratq .... Climatological SAGE Stratospheric Moisture
C     irun ...... Number of Columns to be filled
C     xlat ...... Latitude in Degrees
C     nlevs ..... Vertical   Dimension
C     pres ...... PRES (IM,JM,nlevs) Three-dimensional array of pressures
C     qz_in ..... Model Moisture (kg/kg mass mixing radtio)
C     qz_out .... Combination of Chemistry Moisture and Model Moisture
C                 (kg/kg mass mixing ratio)
C
C***********************************************************************

      implicit none
      integer nwatlevs,nwatlats
      integer bi,bj
      _RL stratq ( nwatlats,nwatlevs )
      _RL watlats (nwatlats)
      _RL watlevs (nwatlevs)

      integer irun,nlevs
      _RL xlat  (irun)
      _RL pres  (irun,nlevs)
      _RL qz_in (irun,nlevs)
      _RL qz_out(irun,nlevs)

c Local Variables
c ---------------
      integer     pqu,pql,dpq
      parameter ( pqu = 100.    )
      parameter ( pql = 300.    )
      parameter ( dpq = pql-pqu )

      integer i,k,L1,L2,LM,LP
      _RL h2o_time_lat (irun,nwatlevs)
      _RL       qz_clim(irun,nlevs)

      _RL  qpr1(irun), qpr2(irun), slope(irun)
      _RL   pr1(irun),  pr2(irun)

      integer  jlat,jlatm,jlatp

C **********************************************************************
C ****         Interpolate Moisture data to model latitudes          ***
C **********************************************************************

      DO 32 k = 1, nwatlevs
        DO 34   i = 1,irun

        DO 36 jlat = 1, nwatlats
           IF( watlats(jlat).gt.xlat(i) ) THEN
              IF( jlat.EQ.1 ) THEN
                  jlatm    = 1
                  jlatp    = 1
                  slope(i) = 0
                    ELSE
                  jlatm    = jlat -1
                  jlatp    = jlat
                  slope(i) = ( xlat(i)        -watlats(jlat-1) )
     .                     / ( watlats(jlat)-watlats(jlat-1) )
              ENDIF
              GOTO 37
           ENDIF
   36   CONTINUE
        jlatm    = nwatlats
        jlatp    = nwatlats
        slope(i) =  1
   37   CONTINUE
        QPR1(i) = stratq(jlatm,k)
        QPR2(i) = stratq(jlatp,k)
   34   CONTINUE

        do  i = 1,irun
        h2o_time_lat(i,k) = qpr1(i) + slope(i)*(qpr2(i)-qpr1(i))
        enddo

   32 CONTINUE

C **********************************************************************
C ****     Interpolate Latitude Moisture data to model pressures     ***
C **********************************************************************

      DO 40 L2 = 1,nlevs

        DO 44 i= 1, irun
        DO 46 L1 = 1,nwatlevs
           IF( watlevs(L1).GT.pres(i,L2) ) THEN
             IF( L1.EQ.1 ) THEN
                 LM = 1
                 LP = 2
               ELSE
                 LM = L1-1
                 LP = L1
             ENDIF
             GOTO 47
           ENDIF
   46   CONTINUE
        LM = nwatlevs-1
        LP = nwatlevs
   47   CONTINUE
         PR1(i) =     watlevs (LM)
         PR2(i) =     watlevs (LP)
        QPR1(i) = h2o_time_lat(i,LM)
        QPR2(i) = h2o_time_lat(i,LP)
   44   CONTINUE

      do i= 1, irun
           slope(i) =(QPR1(i)-QPR2(i)) / (PR1(i)-PR2(i))
      qz_clim(i,L2) = QPR2(i) + (pres(i,L2)-PR2(i))*SLOPE(i)
      enddo

   40 CONTINUE

c
c ... Above 100 mb, using climatological  water data set ...................
c ... Below 300 mb, using model predicted water data set ...................
c ... In between, using linear interpolation ...............................
c
      do k= 1, nlevs
      do i= 1, irun
           if( pres(i,k).ge.pqu  .and. pres(i,k).le. pql) then
             qz_out(i,k) = qz_clim(i,k)+(qz_in(i,k)-
     1                     qz_clim(i,k))*(pres(i,k)-pqu)/dpq
      else if( pres(i,k) .gt. pql ) then
             qz_out(i,k) = qz_in  (i,k)
      else
             qz_out(i,k) = qz_clim(i,k)
           endif
      enddo
      enddo

      return
      end

      subroutine interp_oz (ozone,nozlevs,nozlats,ozlevs,ozlats,
     .                            irun,bi,bj,xlat,nlevs,plevs,ozrad)
C***********************************************************************
C  Purpose
C     To Interpolate Chemistry Ozone from Chemistry Grid to Physics Grid
C
C  INPUT Argument Description
C     ozone ..... Climatological Ozone
C     chemistry .. Chemistry State Data Structure
C     irun ....... Number of Columns to be filled
C     xlat ....... Latitude in Degrees
C     nlevs ...... Vertical   Dimension
C     pres ....... Three-dimensional array of pressures
C     ozrad ...... Ozone on Physics Grid (kg/kg mass mixing radtio)
C
C***********************************************************************
      implicit none
      integer nozlevs,nozlats,irun,nlevs
      integer bi,bj
      _RL ozone(nozlats,nozlevs)
      _RL xlat(irun)
      _RL plevs(irun,nlevs)
      _RL ozrad(irun,nlevs)
      _RL ozlevs(nozlevs),ozlats(nozlats)

c Local Variables
c ---------------
      _RL zero,one,o3min,voltomas
      PARAMETER ( ZERO     = 0.0 )
      PARAMETER ( ONE      = 1.0 )
      PARAMETER ( O3MIN    = 1.0E-10  )
      PARAMETER ( VOLTOMAS = 1.655E-6 )

      integer  i,k,L1,L2,LM,LP
      integer  jlat,jlatm,jlatp
      _RL  O3INT1(IRUN,nozlevs)
      _RL    QPR1(IRUN), QPR2(IRUN), SLOPE(IRUN)
      _RL     PR1(IRUN),  PR2(IRUN)

C **********************************************************************
C ****           INTERPOLATE ozone data to model latitudes           ***
C **********************************************************************

      DO 32 K=1,nozlevs
      DO 34 I=1,IRUN

      DO 36 jlat = 1,nozlats
      IF( ozlats(jlat).gt.xlat(i) ) THEN
      IF( jlat.EQ.1 ) THEN
      jlatm    = 1
      jlatp    = 1
      slope(i) = zero
        ELSE
      jlatm    = jlat-1
      jlatp    = jlat
      slope(i) = ( XLAT(I)        -ozlats(jlat-1) )
     .         / ( ozlats(jlat)-ozlats(jlat-1) )
      ENDIF
      GOTO 37
      ENDIF
   36 CONTINUE
      jlatm    = nozlats
      jlatp    = nozlats
      slope(i) = one
   37 CONTINUE
      QPR1(I) = ozone(jlatm,k)
      QPR2(I) = ozone(jlatp,k)
   34 CONTINUE

      DO 38 I=1,IRUN
      o3int1(i,k) = qpr1(i) + slope(i)*( qpr2(i)-qpr1(i) )
   38 CONTINUE

   32 CONTINUE

C **********************************************************************
C ****     INTERPOLATE latitude ozone data to model pressures        ***
C **********************************************************************

      DO 40 L2 = 1,NLEVS

      DO 44 I  = 1,IRUN
      DO 46 L1 = 1,nozlevs
      IF( ozlevs(L1).GT.PLEVS(I,L2) ) THEN
      IF( L1.EQ.1 ) THEN
          LM = 1
          LP = 2
        ELSE
          LM = L1-1
          LP = L1
      ENDIF
      GOTO 47
      ENDIF
   46 CONTINUE
            LM = nozlevs-1
            LP = nozlevs
   47 CONTINUE
       PR1(I) = ozlevs (LM)
       PR2(I) = ozlevs (LP)
      QPR1(I) =   O3INT1(I,LM)
      QPR2(I) =   O3INT1(I,LP)
   44 CONTINUE

      DO 48 I=1,IRUN
         SLOPE(I) = ( QPR1(I)-QPR2(I) )
     .            / (  PR1(I)- PR2(I) )
      ozrad(I,L2) =   QPR2(I) + ( PLEVS(I,L2)-PR2(I) )*SLOPE(I)

      if( ozrad(i,l2).lt.o3min ) then
          ozrad(i,l2) =  o3min
      endif

   48 CONTINUE
   40 CONTINUE

C **********************************************************************
C ****     CONVERT FROM VOLUME MIXING RATIO TO MASS MIXING RATIO     ***
C **********************************************************************

      DO 60 L2=1,NLEVS
      DO 60 I=1,IRUN
c     DO 60 I=1,IRUN*NLEVS
c     ozrad (I,1) = ozrad(I,1) * VOLTOMAS
      ozrad (I,L2) = ozrad(I,L2) * VOLTOMAS
  60  CONTINUE

      RETURN
      END

#include "DIC_OPTIONS.h"
#ifdef ALLOW_CTRL
# include "CTRL_OPTIONS.h"
#endif

cphc$taf COMMON DIC_XX        adname = addic_xx
cphc$taf COMMON DIC_COST_CTRL adname = ADDIC_COST_CTRL

C !INTERFACE: ==========================================================
      SUBROUTINE DIC_SET_CONTROL( myThid )

C !DESCRIPTION:

C !USES: ===============================================================
      IMPLICIT NONE

C     == GLobal variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#ifdef DIC_BIOTIC
# include "DIC_VARS.h"
# include "DIC_CTRL.h"
#endif
#ifdef ALLOW_CTRL
#include "CTRL_SIZE.h"
#include "CTRL.h"
#include "CTRL_DUMMY.h"
#endif
C     == Routine arguments ==
      INTEGER myThid

#ifdef ALLOW_CTRL
cph#ifdef DIC_BIOTIC
C     == Local arguments ==
#ifdef ALLOW_DIC_CONTROL
      INTEGER bi, bj
      INTEGER i, j
#endif

c     == end of interface ==
CEOP

#ifdef ALLOW_DIC_CONTROL

      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
         DO j = 1, sNy
          DO i = 1, sNx
c           feload(i,j,bi,bj) = feload(i,j,bi,bj)*(1. _d 0 +xx_dic(1))
            rain_ratio(i,j,bi,bj) =
     &                      rain_ratio(i,j,bi,bj)*(1. _d 0 +xx_dic(2))
          ENDDO
         ENDDO
       ENDDO
      ENDDO

      _EXCH_XY_RL( alpha, myThid )
      _EXCH_XY_RL( rain_ratio, myThid )
c     _EXCH_XY_RL( feload, myThid )

      KScav       = KScav       * ( 1. _d 0 + xx_dic(3)*1. _d 6 )
      ligand_stab = ligand_stab * ( 1. _d 0 + xx_dic(4)*1. _d 6 )
      ligand_tot  = ligand_tot  * ( 1. _d 0 + xx_dic(5)*1. _d 6 )

      print *,'COST KScav = ', KScav
      print *,'COST ligand_stab = ', ligand_stab
      print *,'COST ligand_tot = ', ligand_tot

#endif /* ALLOW_DIC_CONTROL */

cph#endif /* DIC_BIOTIC */
#endif /* ALLOW_CTRL */

      RETURN
      END

#include "AUTODIFF_OPTIONS.h"

CBOP
C     !ROUTINE: ADDAMP_ADJ
C     !INTERFACE:
      SUBROUTINE ADDAMP_ADJ(
     I       NrIn, minRef, maxRef, timeDamp,
     I       fieldRef,
     U       adfieldDamp,
     I       myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | author: Gael Forget
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     myThid :: my Thread Id number
      INTEGER NrIn, myThid
      _RL minRef,maxRef,timeDamp
      _RL fieldRef(1-OLx:sNx+OLx,1-OLy:sNy+OLy,NrIn,nSx,nSy)
      _RL adfieldDamp(1-OLx:sNx+OLx,1-OLy:sNy+OLy,NrIn,nSx,nSy)

C     !LOCAL VARIABLES:
      INTEGER bi,bj,i,j,k
      _RL facDamp
CEOP

      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        DO k=1,NrIn
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           IF ( (fieldRef(i,j,k,bi,bj).GE.maxRef).OR.
     &          (fieldRef(i,j,k,bi,bj).LE.minRef) ) THEN
              facDamp=(1. _d 0-deltaTClock/timeDamp)
           ELSE
              facDamp=1. _d 0
           ENDIF
           adfieldDamp(i,j,k,bi,bj)=facDamp*
     &        adfieldDamp(i,j,k,bi,bj)
          ENDDO
         ENDDO
        ENDDO
       ENDDO
      ENDDO

      RETURN
      END

#include "AIM_OPTIONS.h"

CBOP
C     !ROUTINE: SUFLUX_PREP
C     !INTERFACE:
      SUBROUTINE SUFLUX_PREP(
     I                   PSA,TA,QA,RH,ThA,Vsurf2,WVS,CLAT,FOROG,
     I                   FMASK,TLAND,TSEA,TSICE,SSR,
     O                   SPEED0,DRAG,DENVV,dTskin,T1,T0,Q0,
     I                   kGrd,bi,bj,myThid)

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R SUFLUX_PREP
C     | o prepare surface flux calculation
C     *==========================================================*
C     | o contain 1rst part of original S/R SUFLUX (Speedy code)
C     *==========================================================*
C--
C--   SUBROUTINE SUFLUX (PSA,UA,VA,TA,QA,RH,PHI,
C--  &                   PHI0,FMASK,TLAND,TSEA,SWAV,SSR,SLRD,
C--  &                   USTR,VSTR,SHF,EVAP,SLRU,
C--  &                   TSFC,TSKIN,U0,V0,T0,Q0)
C--
C--   Purpose: Compute surface fluxes of momentum, energy and moisture,
C--            and define surface skin temperature from energy balance
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     Resolution parameters

C-- size for MITgcm & Physics package :
#include "AIM_SIZE.h"

#include "EEPARAMS.h"

C     Physical constants + functions of sigma and latitude
#include "com_physcon.h"

C     Surface flux constants
#include "com_sflcon.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine Arguments ==
C--   Input:   
C    PSA    :: norm. surface pressure [p/p0]   (2-dim)
C    TA     :: temperature                     (3-dim)
C    QA     :: specific humidity [g/kg]        (3-dim)
C    RH     :: relative humidity [0-1]         (3-dim)
C    ThA    :: Pot.temperature    [K]          (3-dim)
C    Vsurf2 :: square of surface wind speed (2-dim,input)
C               ==> UA,VA are no longer used
C    WVS    :: weights for near surf interp    (2-dim)
C    CLAT   :: cos(lat)                        (2-dim)
C    FOROG  :: orographic factor (surf. drag)  (2-dim)
C    FMASK  :: fraction land - sea - sea-ice (2.5-dim)
C    TLAND  :: land-surface temperature        (2-dim)
C    TSEA   ::  sea-surface temperature        (2-dim)
C    TSICE  ::  sea-ice surface temperature    (2-dim)
C    SSR    :: sfc sw radiation (net flux)     (2-dim)
C--   Output:  
C    SPEED0 :: effective surface wind speed    (2-dim)
C    DRAG   :: surface Drag term (= Cd*Rho*|V|)(2-dim)
C                         ==> USTR,VSTR are no longer used
C    DENVV  :: surface flux (sens,lat.) coeff. (=Rho*|V|) [kg/m2/s]
C    dTskin :: temp. correction for daily-cycle heating [K]
C    T1     :: near-surface air temperature (from Pot.Temp)
C    T0     :: near-surface air temperature    (2-dim)
C    Q0     :: near-surface sp. humidity [g/kg](2-dim)
C--   Input:
C    kGrd   :: Ground level index              (2-dim)
C    bi,bj  :: tile index
C    myThid :: Thread number for this instance of the routine
C--
      _RL  PSA(NGP), TA(NGP,NLEV), QA(NGP,NLEV), RH(NGP,NLEV)
      _RL  ThA(NGP,NLEV)
      _RL  Vsurf2(NGP), WVS(NGP), CLAT(NGP), FOROG(NGP)
      _RL  FMASK(NGP,3), TLAND(NGP), TSEA(NGP), TSICE(NGP)
      _RL  SSR(NGP)

      _RL  SPEED0(NGP), DRAG(NGP,0:3), T1(NGP), DENVV(NGP)
      _RL  dTskin(NGP), T0(NGP), Q0(NGP)

      INTEGER kGrd(NGP)
      INTEGER bi,bj,myThid
CEOP

#ifdef ALLOW_AIM

C-- Local variables:
       _RL  QSAT0(NGP,2)

      INTEGER J, Ktmp, NL1
      _RL tmpRH(NGP)
      _RL factWind2, kappa

C- jmc: declare all local variables:
      _RL GTEMP0, GHUM0, RCP, PRD, VG2
c     _RL RDTH, FSLAND, FSSEA, FSSICE
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C--   1. Extrapolation of wind, temp, hum. and density to the surface

C     1.1 Wind components

c     DO J=1,NGP
c       U0(J) = 0.0
c       V0(J) = 0.0
c       Ktmp = kGrd(J)
c      IF ( Ktmp.GT.0 ) THEN
c       U0(J) = FWIND0*UA(J,Ktmp)
c       V0(J) = FWIND0*VA(J,Ktmp)
c      ENDIF
c     ENDDO

C     1.2 Temperature

      GTEMP0 = 1.-FTEMP0
      RCP = 1. _d 0 /CP
      kappa = RD/CP
C
      DO J=1,NGP
        Ktmp = kGrd(J)
        NL1 = Ktmp-1
       IF ( Ktmp.GT.1 ) THEN
c_FM    T0(J) = TA(J,NLEV)+WVI(NLEV,2)*(TA(J,NLEV)-TA(J,NL1))
c_FM    T1(J) = TA(J,NLEV)+RCP*(PHI(J,NLEV)-PHI0(J))
        T0(J) = TA(J,Ktmp) +    WVS(J)*(TA(J,Ktmp)-TA(J,NL1))
Cjmc: used previously but not valid with partial cell !
c       T1(J) = TA(J,Ktmp)*(SIGH(Ktmp)/SIG(Ktmp))**kappa
        T1(J) = ThA(J,Ktmp)*(PSA(J)**kappa)
        tmpRH(J)=RH(J,Ktmp)
       ELSE
        T0(J) = 273.16 _d 0
        T1(J) = 273.16 _d 0
        tmpRH(J)= 0.
       ENDIF
      ENDDO

      DO J=1,NGP
c       T0(J) = FTEMP0*T0(J)+GTEMP0*T1(J)
        T0(J) = FTEMP0*MIN(T0(J),T1(J))+GTEMP0*T1(J)
      ENDDO

C     1.3 Spec. humidity

      GHUM0 = 1.-FHUM0

      CALL SHTORH (-1,NGP,T0, PSA, 1. _d 0, Q0, tmpRH, QSAT0, myThid)

      DO J=1,NGP
       IF ( kGrd(J) .GT. 0 ) THEN
        Q0(J)=FHUM0*Q0(J)+GHUM0*QA(J,kGrd(J))
       ENDIF
      ENDDO

C     1.4 Density * wind speed (including gustiness factor)

      PRD = P0/RD
      VG2 = VGUST*VGUST
      factWind2 = FWIND0*FWIND0

      DO J=1,NGP
c_FM    DENVV(J)=(PRD*PSA(J)/T0(J))*
c_FM &           SQRT(U0(J)*U0(J)+V0(J)*V0(J)+VG2)
        SPEED0(J)=SQRT(factWind2*Vsurf2(J)+VG2)
        DENVV(J)=(PRD*PSA(J)/T0(J))*SPEED0(J)
      ENDDO

C     1.5 Define effective skin temperature to compensate for
C         non-linearity of heat/moisture fluxes during the daily cycle
C         Tskin = Tland + dTskin

      DO J=1,NGP
        dTskin(J)=CTDAY*CLAT(J)*SSR(J)*PSA(J)
      ENDDO


C--   2. Computation of fluxes over land and sea

C     2.1 Wind stress

C     Orographic correction

      DO J=1,NGP
c       CDENVV(J,1)=CDL*DENVV(J)*FOROG(J)
c       CDENVV(J,2)=CDS*DENVV(J)
        DRAG(J,1) = CDL*DENVV(J)*FOROG(J)
        DRAG(J,2) = CDS*DENVV(J)
        DRAG(J,3) = CDS*DENVV(J)
      ENDDO

C - Notes:
C   Because of a different mapping between the Drag and the Wind (A/C-grid)
C   the surface stress is computed later, in "External Forcing",
C   Here compute only surface drag term (= C_drag*Rho*|V| ) 

c     DO J=1,NGP
c       USTR(J,1) = -CDENVV(J,1)*UA(J,NLEV)
c       VSTR(J,1) = -CDENVV(J,1)*VA(J,NLEV)
c       USTR(J,2) = -CDENVV(J,2)*UA(J,NLEV)
c       VSTR(J,2) = -CDENVV(J,2)*VA(J,NLEV)
c     ENDDO

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
#endif /* ALLOW_AIM */

      RETURN
      END

      SUBROUTINE SFLSET (PHI0, FOROG, bi,bj,myThid)
C--
C--   SUBROUTINE SFLSET (PHI0)
C--
C--   Purpose: compute orographic factor for land surface drag
C--   Input:   PHI0   = surface geopotential            (2-dim)
C     Output:  FOROG  = orographic factor (surf. drag)  (2-dim)
C--            (originally in common blocks: SFLFIX)

      IMPLICIT NONE

C     Resolution parameters

C-- size for MITgcm & Physics package :
#include "AIM_SIZE.h"

#include "EEPARAMS.h"

C     Physical constants + functions of sigma and latitude
#include "com_physcon.h"

C     Surface flux constants
#include "com_sflcon.h"

C-- Routine arguments:
      INTEGER bi,bj,myThid
      _RL  PHI0(NGP)
      _RL  FOROG(NGP)

#ifdef ALLOW_AIM

C-- Local variables:
      INTEGER J
      _RL  RHDRAG

      RHDRAG = 1./(GG*HDRAG)

      DO J=1,NGP
        FOROG(J) = 1. _d 0
     &   + FHDRAG*(1. _d 0 - EXP(-MAX(PHI0(J),0. _d 0)*RHDRAG) )
      ENDDO

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
#endif /* ALLOW_AIM */

      RETURN
      END

#include "STREAMICE_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

CBOP
      SUBROUTINE STREAMICE_CG_SOLVE_MATFREE (
     U                               cg_Uin,     ! x-velocities
     U                               cg_Vin,     ! y-velocities
     I                               cg_Bu,      ! force in x dir
     I                               cg_Bv,      ! force in y dir
     I                               tolerance,
     O                               iters,
     I                               myThid )
C     /============================================================\
C     | SUBROUTINE                                                 |
C     | o                                                          |
C     |============================================================|
C     |                                                            |
C     \============================================================/
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "STREAMICE.h"
#include "STREAMICE_CG.h"

C     !INPUT/OUTPUT ARGUMENTS
C     cg_Uin, cg_Vin - input and output velocities
C     cg_Bu, cg_Bv - driving stress
      INTEGER myThid
      INTEGER iters
      _RL tolerance
      _RL cg_Uin (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL cg_Vin (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL cg_Bu (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL cg_Bv (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)

C     LOCAL VARIABLES
      INTEGER i, j, bi, bj, cg_halo, conv_flag
      INTEGER iter, is, js, ie, je
c     INTEGER colx, coly
      _RL dot_p1, dot_p2, alpha_k, beta_k, resid, resid_0
      _RL dot_p1_tile (nSx,nSy)
      _RL dot_p2_tile (nSx,nSy)
      CHARACTER*(MAX_LEN_MBUF) msgBuf

      iters = streamice_max_cg_iter

#ifdef ALLOW_STREAMICE

      conv_flag = 0

      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
        DO j=1,sNy
         DO i=1,sNx
          Zu_SI (i,j,bi,bj) = 0. _d 0
          Zv_SI (i,j,bi,bj) = 0. _d 0
          Ru_SI (i,j,bi,bj) = 0. _d 0
          Rv_SI (i,j,bi,bj) = 0. _d 0
          Au_SI (i,j,bi,bj) = 0. _d 0
          Av_SI (i,j,bi,bj) = 0. _d 0
          Du_SI (i,j,bi,bj) = 0. _d 0
          Dv_SI (i,j,bi,bj) = 0. _d 0
         ENDDO
        ENDDO
       ENDDO
      ENDDO

C     FIND INITIAL RESIDUAL, and initialize r

c #ifdef STREAMICE_CONSTRUCT_MATRIX

c         DO bj = myByLo(myThid), myByHi(myThid)
c          DO bi = myBxLo(myThid), myBxHi(myThid)
c           DO j=js,je
c            DO i=is,ie
c             DO colx=-1,1
c              DO coly=-1,1
c               Au_SI(i,j,bi,bj) = Au_SI(i,j,bi,bj) +
c      &         streamice_cg_A1(i,j,bi,bj,colx,coly)*
c      &         cg_Uin(i+colx,j+coly,bi,bj)+
c      &         streamice_cg_A2(i,j,bi,bj,colx,coly)*
c      &         cg_Vin(i+colx,j+coly,bi,bj)
c               Av_SI(i,j,bi,bj) = Av_SI(i,j,bi,bj) +
c      &         streamice_cg_A3(i,j,bi,bj,colx,coly)*
c      &         cg_Uin(i+colx,j+coly,bi,bj)+
c      &         streamice_cg_A4(i,j,bi,bj,colx,coly)*
c      &         cg_Vin(i+colx,j+coly,bi,bj)
c              ENDDO
c             ENDDO
c            ENDDO
c           ENDDO
c          ENDDO
c         ENDDO

c #else

      CALL STREAMICE_CG_ACTION( myThid,
     O    Au_SI,
     O    Av_SI,
     I    cg_Uin,
     I    cg_Vin,
     I    0, sNx+1, 0, sNy+1 )

c #endif

      _EXCH_XY_RL( Au_SI, myThid )
      _EXCH_XY_RL( Av_SI, myThid )

      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          Ru_SI(i,j,bi,bj)=cg_Bu(i,j,bi,bj)-
     &     Au_SI(i,j,bi,bj)
          Rv_SI(i,j,bi,bj)=cg_Bv(i,j,bi,bj)-
     &     Av_SI(i,j,bi,bj)
         ENDDO
        ENDDO
        dot_p1_tile(bi,bj) = 0. _d 0
        dot_p2_tile(bi,bj) = 0. _d 0
       ENDDO
      ENDDO

      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
        DO j=1,sNy
         DO i=1,sNx
          IF (STREAMICE_umask(i,j,bi,bj).eq.1.0)
     &      dot_p1_tile(bi,bj)=dot_p1_tile(bi,bj)+Ru_SI(i,j,bi,bj)**2
          IF (STREAMICE_vmask(i,j,bi,bj).eq.1.0)
     &      dot_p1_tile(bi,bj)=dot_p1_tile(bi,bj)+Rv_SI(i,j,bi,bj)**2
         ENDDO
        ENDDO
       ENDDO
      ENDDO

      CALL GLOBAL_SUM_TILE_RL( dot_p1_tile, dot_p1, myThid )
      resid_0 = sqrt(dot_p1)

C    CCCCCCCCCCCCCCCCCCCC

      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          IF (STREAMICE_umask(i,j,bi,bj).eq.1.0)
     &      Zu_SI(i,j,bi,bj)=Ru_SI(i,j,bi,bj) / DIAGu_SI(i,j,bi,bj)
          IF (STREAMICE_vmask(i,j,bi,bj).eq.1.0)
     &      Zv_SI(i,j,bi,bj)=Rv_SI(i,j,bi,bj) / DIAGv_SI(i,j,bi,bj)
         ENDDO
        ENDDO
       ENDDO
      ENDDO

      cg_halo = min(OLx-1,OLy-1)
      conv_flag = 0

      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          Du_SI(i,j,bi,bj)=Zu_SI(i,j,bi,bj)
          Dv_SI(i,j,bi,bj)=Zv_SI(i,j,bi,bj)
         ENDDO
        ENDDO
       ENDDO
      ENDDO

      resid = resid_0
      iters = 0

c  !!!!!!!!!!!!!!!!!!
c  !!              !!
c  !! MAIN CG LOOP !!
c  !!              !!
c  !!!!!!!!!!!!!!!!!!

c  ! initially, b-grid data is valid up to 3 halo nodes out -- right? (check for MITgcm!!)

       WRITE(msgBuf,'(A)') 'BEGINNING MAIN CG LOOP'
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                     SQUEEZE_RIGHT , 1)

c       IF(STREAMICE_construct_matrix) CALL STREAMICE_CG_MAKE_A(myThid)

      do iter = 1, streamice_max_cg_iter
       if (resid .gt. tolerance*resid_0) then

c      to avoid using "exit"
       iters = iters + 1

       is = 1 - cg_halo
       ie = sNx + cg_halo
       js = 1 - cg_halo
       je = sNy + cg_halo

       DO bj = myByLo(myThid), myByHi(myThid)
        DO bi = myBxLo(myThid), myBxHi(myThid)
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           Au_SI(i,j,bi,bj) = 0. _d 0
           Av_SI(i,j,bi,bj) = 0. _d 0
          ENDDO
         ENDDO
        ENDDO
       ENDDO

c        IF (STREAMICE_construct_matrix) THEN

c #ifdef STREAMICE_CONSTRUCT_MATRIX
c
c         DO bj = myByLo(myThid), myByHi(myThid)
c          DO bi = myBxLo(myThid), myBxHi(myThid)
c           DO j=js,je
c            DO i=is,ie
c             DO colx=-1,1
c              DO coly=-1,1
c               Au_SI(i,j,bi,bj) = Au_SI(i,j,bi,bj) +
c      &         streamice_cg_A1(i,j,bi,bj,colx,coly)*
c      &         Du_SI(i+colx,j+coly,bi,bj)+
c      &         streamice_cg_A2(i,j,bi,bj,colx,coly)*
c      &         Dv_SI(i+colx,j+coly,bi,bj)
c               Av_SI(i,j,bi,bj) = Av_SI(i,j,bi,bj) +
c      &         streamice_cg_A3(i,j,bi,bj,colx,coly)*
c      &         Du_SI(i+colx,j+coly,bi,bj)+
c      &         streamice_cg_A4(i,j,bi,bj,colx,coly)*
c      &         Dv_SI(i+colx,j+coly,bi,bj)
c              ENDDO
c             ENDDO
c            ENDDO
c           ENDDO
c          ENDDO
c         ENDDO
c
c !        else
c #else

        CALL STREAMICE_CG_ACTION( myThid,
     O     Au_SI,
     O     Av_SI,
     I     Du_SI,
     I     Dv_SI,
     I     is,ie,js,je)

c        ENDIF

c #endif

       DO bj = myByLo(myThid), myByHi(myThid)
        DO bi = myBxLo(myThid), myBxHi(myThid)
         dot_p1_tile(bi,bj) = 0. _d 0
         dot_p2_tile(bi,bj) = 0. _d 0
        ENDDO
       ENDDO

       DO bj = myByLo(myThid), myByHi(myThid)
        DO bi = myBxLo(myThid), myBxHi(myThid)
         DO j=1,sNy
          DO i=1,sNx
           IF (STREAMICE_umask(i,j,bi,bj).eq.1.0) THEN
           dot_p1_tile(bi,bj)=dot_p1_tile(bi,bj)+Zu_SI(i,j,bi,bj)*
     &        Ru_SI(i,j,bi,bj)
            dot_p2_tile(bi,bj)=dot_p2_tile(bi,bj)+Du_SI(i,j,bi,bj)*
     &        Au_SI(i,j,bi,bj)
           ENDIF
           IF (STREAMICE_vmask(i,j,bi,bj).eq.1.0) THEN
            dot_p1_tile(bi,bj)=dot_p1_tile(bi,bj)+Zv_SI(i,j,bi,bj)*
     &        Rv_SI(i,j,bi,bj)
            dot_p2_tile(bi,bj)=dot_p2_tile(bi,bj)+Dv_SI(i,j,bi,bj)*
     &        Av_SI(i,j,bi,bj)
           ENDIF
          ENDDO
         ENDDO
        ENDDO
       ENDDO

       CALL GLOBAL_SUM_TILE_RL( dot_p1_tile, dot_p1, myThid )
       CALL GLOBAL_SUM_TILE_RL( dot_p2_tile, dot_p2, myThid )
       alpha_k = dot_p1/dot_p2

       DO bj = myByLo(myThid), myByHi(myThid)
        DO bi = myBxLo(myThid), myBxHi(myThid)
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx

           IF (STREAMICE_umask(i,j,bi,bj).eq.1.0) THEN
            cg_Uin(i,j,bi,bj)=cg_Uin(i,j,bi,bj)+
     &       alpha_k*Du_SI(i,j,bi,bj)
            Ru_old_SI(i,j,bi,bj) = Ru_SI(i,j,bi,bj)
            Zu_old_SI(i,j,bi,bj) = Zu_SI(i,j,bi,bj)
            Ru_SI(i,j,bi,bj) = Ru_SI(i,j,bi,bj)-
     &       alpha_k*Au_SI(i,j,bi,bj)
            Zu_SI(i,j,bi,bj) = Ru_SI(i,j,bi,bj) /
     &       DIAGu_SI(i,j,bi,bj)
           ENDIF

           IF (STREAMICE_vmask(i,j,bi,bj).eq.1.0) THEN
            cg_Vin(i,j,bi,bj)=cg_Vin(i,j,bi,bj)+
     &       alpha_k*Dv_SI(i,j,bi,bj)
            Rv_old_SI(i,j,bi,bj) = Rv_SI(i,j,bi,bj)
            Zv_old_SI(i,j,bi,bj) = Zv_SI(i,j,bi,bj)
            Rv_SI(i,j,bi,bj) = Rv_SI(i,j,bi,bj)-
     &       alpha_k*Av_SI(i,j,bi,bj)
            Zv_SI(i,j,bi,bj) = Rv_SI(i,j,bi,bj) /
     &       DIAGv_SI(i,j,bi,bj)

           ENDIF
          ENDDO
         ENDDO
        ENDDO
       ENDDO

       DO bj = myByLo(myThid), myByHi(myThid)
        DO bi = myBxLo(myThid), myBxHi(myThid)
         dot_p1_tile(bi,bj) = 0. _d 0
         dot_p2_tile(bi,bj) = 0. _d 0
        ENDDO
       ENDDO

       DO bj = myByLo(myThid), myByHi(myThid)
        DO bi = myBxLo(myThid), myBxHi(myThid)
         DO j=1,sNy
          DO i=1,sNx

           IF (STREAMICE_umask(i,j,bi,bj).eq.1.0) THEN
            dot_p1_tile(bi,bj)=dot_p1_tile(bi,bj)+Zu_SI(i,j,bi,bj)*
     &        Ru_SI(i,j,bi,bj)
            dot_p2_tile(bi,bj)=dot_p2_tile(bi,bj)+Zu_old_SI(i,j,bi,bj)*
     &        Ru_old_SI(i,j,bi,bj)
           ENDIF

           IF (STREAMICE_vmask(i,j,bi,bj).eq.1.0) THEN
            dot_p1_tile(bi,bj)=dot_p1_tile(bi,bj)+Zv_SI(i,j,bi,bj)*
     &        Rv_SI(i,j,bi,bj)
            dot_p2_tile(bi,bj)=dot_p2_tile(bi,bj)+Zv_old_SI(i,j,bi,bj)*
     &        Rv_old_SI(i,j,bi,bj)
           ENDIF

          ENDDO
         ENDDO
        ENDDO
       ENDDO

       CALL GLOBAL_SUM_TILE_RL( dot_p1_tile, dot_p1, myThid )
       CALL GLOBAL_SUM_TILE_RL( dot_p2_tile, dot_p2, myThid )

       beta_k = dot_p1/dot_p2

       DO bj = myByLo(myThid), myByHi(myThid)
        DO bi = myBxLo(myThid), myBxHi(myThid)
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           IF (STREAMICE_umask(i,j,bi,bj).eq.1.0)
     &      Du_SI(i,j,bi,bj)=beta_k*Du_SI(i,j,bi,bj)+
     &      Zu_SI(i,j,bi,bj)
           IF (STREAMICE_vmask(i,j,bi,bj).eq.1.0)
     &      Dv_SI(i,j,bi,bj)=beta_k*Dv_SI(i,j,bi,bj)+
     &      Zv_SI(i,j,bi,bj)
          ENDDO
         ENDDO
        ENDDO
       ENDDO

       DO bj = myByLo(myThid), myByHi(myThid)
        DO bi = myBxLo(myThid), myBxHi(myThid)
         dot_p1_tile(bi,bj) = 0. _d 0
        ENDDO
       ENDDO

       DO bj = myByLo(myThid), myByHi(myThid)
        DO bi = myBxLo(myThid), myBxHi(myThid)
         DO j=1,sNy
          DO i=1,sNx
           IF (STREAMICE_umask(i,j,bi,bj).eq.1.0)
     &      dot_p1_tile(bi,bj)=dot_p1_tile(bi,bj)+Ru_SI(i,j,bi,bj)**2
           IF (STREAMICE_vmask(i,j,bi,bj).eq.1.0)
     &      dot_p1_tile(bi,bj)=dot_p1_tile(bi,bj)+Rv_SI(i,j,bi,bj)**2
          ENDDO
         ENDDO
        ENDDO
       ENDDO

       CALL GLOBAL_SUM_TILE_RL( dot_p1_tile, dot_p1, myThid )
       resid = sqrt(dot_p1)

c        IF (iter .eq. 1) then
c         print *, alpha_k, beta_k, resid
c        ENDIF

       cg_halo = cg_halo - 1

       if (cg_halo .eq. 0) then
        cg_halo = min(OLx-1,OLy-1)
        _EXCH_XY_RL( Du_SI, myThid )
        _EXCH_XY_RL( Dv_SI, myThid )
        _EXCH_XY_RL( Ru_SI, myThid )
        _EXCH_XY_RL( Rv_SI, myThid )
        _EXCH_XY_RL( cg_Uin, myThid )
        _EXCH_XY_RL( cg_Vin, myThid )
       endif

       endif
      enddo ! end of CG loop

c     to avoid using "exit"
c     if iters has reached max_iters there is no convergence

      IF (iters .lt. streamice_max_cg_iter) THEN
       conv_flag = 1
      ENDIF

c       DO bj = myByLo(myThid), myByHi(myThid)
c        DO bi = myBxLo(myThid), myBxHi(myThid)
c         DO j=1-OLy,sNy+OLy
c          DO i=1-OLy,sNx+OLy
c           IF (STREAMICE_umask(i,j,bi,bj).eq.3.0)
c      &     cg_Uin(i,j,bi,bj)=u_bdry_values_SI(i,j,bi,bj)
c           IF (STREAMICE_vmask(i,j,bi,bj).eq.3.0)
c      &     cg_Vin(i,j,bi,bj)=v_bdry_values_SI(i,j,bi,bj)
c          ENDDO
c         ENDDO
c        ENDDO
c       ENDDO
c
c       _EXCH_XY_RL( cg_Uin, myThid )
c       _EXCH_XY_RL( cg_Vin, myThid )

#endif
      RETURN
      END

#include "SEAICE_OPTIONS.h"

CBOP
C     !ROUTINE: SEAICE_CALC_RESIDUAL
C     !INTERFACE:
      SUBROUTINE SEAICE_CALC_RESIDUAL(
     I     uIceLoc, vIceLoc,
     O     uIceRes, vIceRes,
     I     newtonIter, krylovIter, myTime, myIter, myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE SEAICE_CALC_RESIDUAL
C     | o For Jacobian-free Newton-Krylov solver compute
C     |   the residual of the momentum equations
C     *==========================================================*
C     | written by Martin Losch, Oct 2012
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "SEAICE_SIZE.h"
#if ( defined SEAICE_ALLOW_BOTTOMDRAG || defined SEAICE_ALLOW_SIDEDRAG )
# include "SEAICE_PARAMS.h"
#endif
#include "SEAICE_GRID.h"
#include "SEAICE.h"

C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
C     myTime :: Simulation time
C     myIter :: Simulation timestep number
C     myThid :: my Thread Id. number
C     newtonIter :: current iterate of Newton iteration
C     krylovIter :: current iterate of Krylov iteration
      _RL     myTime
      INTEGER myIter
      INTEGER myThid
      INTEGER newtonIter
      INTEGER krylovIter
C     u/vIceLoc :: local copies of the current ice velocity
      _RL uIceLoc(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL vIceLoc(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
C     u/vIceRes :: residual of sea-ice momentum equations
      _RL uIceRes(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL vIceRes(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)

#if ( defined SEAICE_CGRID && defined SEAICE_ALLOW_JFNK )
C     u/vIceLHS :: left hand side of momentum equations
      _RL uIceLHS(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL vIceLHS(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
C     u/vIceRHS :: righ hand side of momentum equations
      _RL uIceRHS(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL vIceRHS(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)

C     i,j,bi,bj :: loop indices
      INTEGER i,j,bi,bj
CEOP

C     Initialise
      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        DO J=1-OLy,sNy+OLy
         DO I=1-OLx,sNx+OLx
          uIceLHS(I,J,bi,bj) = 0. _d 0
          vIceLHS(I,J,bi,bj) = 0. _d 0
          uIceRHS(I,J,bi,bj) = 0. _d 0
          vIceRHS(I,J,bi,bj) = 0. _d 0
         ENDDO
        ENDDO
       ENDDO
      ENDDO
C     u/vIceLoc have changed so that new drag coefficients and
C     viscosities are required
      CALL SEAICE_OCEANDRAG_COEFFS(
     I     uIceLoc, vIceLoc, HEFFM,
     O     DWATN,
     I     krylovIter, myTime, myIter, myThid )
#ifdef SEAICE_ALLOW_BOTTOMDRAG
      CALL SEAICE_BOTTOMDRAG_COEFFS(
     I     uIceLoc, vIceLoc, HEFFM,
#ifdef SEAICE_ITD
     I     HEFFITD, AREAITD, AREA,
#else
     I     HEFF, AREA,
#endif
     O     CbotC,
     I     krylovIter, myTime, myIter, myThid )
#endif /* SEAICE_ALLOW_BOTTOMDRAG */
#ifdef SEAICE_ALLOW_SIDEDRAG
        IF ( SEAICEsideDrag .NE. 0. _d 0 ) CALL SEAICE_SIDEDRAG_STRESS(
     I       uIceLoc, vIceLoc, coastRoughU, coastRoughV, AREA,
     O       sideDragU, sideDragV,
     I       krylovIter, myTime, myIter, myThid )
#endif /* SEAICE_ALLOW_SIDEDRAG */
      CALL SEAICE_CALC_STRAINRATES(
     I     uIceLoc, vIceLoc,
     O     e11, e22, e12,
     I     krylovIter, myTime, myIter, myThid )
      CALL SEAICE_CALC_VISCOSITIES(
     I     e11, e22, e12, SEAICE_zMin, SEAICE_zMax, HEFFM, press0,
     I     tensileStrFac,
     O     eta, etaZ, zeta, zetaZ, press, deltaC,
     I     krylovIter, myTime, myIter, myThid )

C     The scheme is backward Euler in time, i.e. the rhs-vector contains
C     only terms that are independent of u/vIce, except for the time
C     derivative part mass*(u/vIce-u/vIceNm1)/deltaT

C     compute new right hand side (depends to DWATN=Cdrag)
C     sea-surface tilt and wind stress: FORCEX0, FORCEY0
C     + mass*(u/vIceNm1)/deltaT
C     + Cdrag*(uVel*cosWat - vVel*sinWat)/(vVel*cosWat + uVel*sinWat)
      CALL SEAICE_CALC_RHS(
     O      uIceRHS, vIceRHS,
     I      newtonIter, krylovIter, myTime, myIter, myThid )

C     Left-hand side contributions:
C     + mass*(u/vIce)/deltaT
C     + Cdrag*(uIce*cosWat - vIce*sinWat)/(vIce*cosWat + uIce*sinWat)
C     + CdragBot*uIce/vIce
C     - mass*f*vIce/+mass*f*uIce
C     - dsigma/dx / -dsigma/dy, eta and zeta are only computed once per
C     Newton iterate
       CALL SEAICE_CALC_LHS(
     I      uIceLoc, vIceLoc,
     O      uIceLHS, vIceLHS,
     I      newtonIter, myTime, myIter, myThid )

C     Right-hand side contributions only need to be computed once per
C     time step, therefore we will put them into a separate routine
C     and call them elsewhere to save floating point operations

C     Calculate the residual
       DO bj=myByLo(myThid),myByHi(myThid)
        DO bi=myBxLo(myThid),myBxHi(myThid)
         DO J=1,sNy
          DO I=1,sNx
           uIceRes(I,J,bi,bj) = uIceLHS(I,J,bi,bj) - uIceRHS(I,J,bi,bj)
           vIceRes(I,J,bi,bj) = vIceLHS(I,J,bi,bj) - vIceRHS(I,J,bi,bj)
          ENDDO
         ENDDO
        ENDDO
       ENDDO

#endif /* SEAICE_CGRID and SEAICE_ALLOW_JFNK */

      RETURN
      END

#include "SMOOTH_OPTIONS.h"

C !INTERFACE: ==========================================================
      SUBROUTINE SMOOTH_RHS( fld_in, gt_in, myThid )

C     *==========================================================*
C     | SUBROUTINE smooth_rhs
C     | o As part of smooth_diff3D, this routine computes the
C     |   right hand side of the tendency equation (see below).
C     |   It is made of bits from model/src and pkg/generic_advdiff
C     |   pieced togheter.
C     *==========================================================*

C !DESCRIPTION:
C Calculates the tendency of a tracer due to advection and diffusion.
C It calculates the fluxes in each direction indepentently and then
C sets the tendency to the divergence of these fluxes. The advective
C fluxes are only calculated here when using the linear advection schemes
C otherwise only the diffusive and parameterized fluxes are calculated.
C
C Contributions to the flux are calculated and added:
C \begin{equation*}
C {\bf F} = {\bf F}_{adv} + {\bf F}_{diff} +{\bf F}_{GM} + {\bf F}_{KPP}
C \end{equation*}
C
C The tendency is the divergence of the fluxes:
C \begin{equation*}
C G_\theta = G_\theta + \nabla \cdot {\bf F}
C \end{equation*}
C
C The tendency is assumed to contain data on entry.

C !USES: ===============================================================
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "SMOOTH.h"

C !INPUT PARAMETERS: ===================================================
      _RL fld_in(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      _RL gt_in (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      INTEGER myThid

C local variables:
      INTEGER bi,bj,iMin,iMax,jMin,jMax
      _RS xA    (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RS yA    (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RS maskUp(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL dTdz  (nSx,nSy)
      _RL dTdx  (nSx,nSy)
      _RL dTdy  (nSx,nSy)
      INTEGER i,j,k
      _RL fZon  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      _RL fMer  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      _RL fVerT (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      _RL df    (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)

      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)

c 1rst k loop: initialization
        DO k=1,Nr
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           fZon(i,j,k,bi,bj)  = 0. _d 0
           fMer(i,j,k,bi,bj)  = 0. _d 0
           fVerT(i,j,k,bi,bj) = 0. _d 0
           gt_in(i,j,k,bi,bj) = 0. _d 0
          ENDDO
         ENDDO
        ENDDO

        iMin = 1-OLx+1
        iMax = sNx+OLx-1
        jMin = 1-OLy+1
        jMax = sNy+OLy-1

c 2nd k loop: flux computation
        DO k=1,Nr

         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           df(i,j,bi,bj) = 0. _d 0
           xA(i,j,bi,bj) = _dyG(i,j,bi,bj)
     &      *drF(k)*smooth_hFacW(i,j,k,bi,bj)
           yA(i,j,bi,bj) = _dxG(i,j,bi,bj)
     &      *drF(k)*smooth_hFacS(i,j,k,bi,bj)
           IF (k .EQ. 1) THEN
             maskUp(i,j,bi,bj) = 0.
           ELSE
            maskUp(i,j,bi,bj) =
     &        maskC(i,j,k-1,bi,bj)*maskC(i,j,k,bi,bj)
           ENDIF
          ENDDO
         ENDDO

c      ///gmredi_xtr///

         DO j=jMin,jMax
          DO i=iMin,iMax
           df(i,j,bi,bj) = df(i,j,bi,bj)
     &       -xA(i,j,bi,bj)
     &       *smooth3D_Kux(i,j,k,bi,bj)
     &       *recip_dxC(i,j,bi,bj)
     &       *(fld_in(i,j,k,bi,bj)-fld_in(i-1,j,k,bi,bj))
          ENDDO
         ENDDO

         DO j=jMin,jMax
          DO i=iMin,iMax
           dTdz(bi,bj) =  0.5*(
     &      +0.5*recip_drC(k)*
     &       ( maskC(i-1,j,k,bi,bj)*
     &       (fld_in(i-1,j, MAX(k-1,1) ,bi,bj)-fld_in(i-1,j,k,bi,bj))
     &       +maskC( i ,j,k,bi,bj)*
     &       (fld_in( i ,j, MAX(k-1,1) ,bi,bj)-fld_in( i ,j,k,bi,bj))
     &       )
     &      +0.5*recip_drC(MIN(k+1,Nr))*
     &       ( maskC(i-1,j,MIN(k+1,Nr),bi,bj)*
     &       (fld_in(i-1,j,k,bi,bj)-fld_in(i-1,j,MIN(k+1,Nr),bi,bj))
     &       +maskC( i ,j,MIN(k+1,Nr),bi,bj)*
     &       (fld_in( i ,j,k,bi,bj)-fld_in( i ,j,MIN(k+1,Nr),bi,bj))
     &       )                )
           df(i,j,bi,bj) = df(i,j,bi,bj)
     &      - xA(i,j,bi,bj)*smooth3D_Kuz(i,j,k,bi,bj)*dTdz(bi,bj)
          ENDDO
         ENDDO

         DO j=jMin,jMax
          DO i=iMin,iMax
           dTdy(bi,bj) = 0.5*(
     &      +0.5*(maskS(i,j,k,bi,bj)
     &         *recip_dyC(i,j,bi,bj)*
     &         (fld_in(i,j,k,bi,bj)-fld_in(i,j-1,k,bi,bj))
     &        +maskS(i,j+1,k,bi,bj)
     &        *recip_dyC(i,j+1,bi,bj)*
     &        (fld_in(i,j+1,k,bi,bj)-fld_in(i,j,k,bi,bj)))
     &      +0.5*(maskS(i-1,j,k,bi,bj)
     &        *recip_dyC(i,j,bi,bj)*
     &        (fld_in(i-1,j,k,bi,bj)-fld_in(i-1,j-1,k,bi,bj))
     &        +maskS(i-1,j+1,k,bi,bj)
     &        *recip_dyC(i,j+1,bi,bj)*
     &        (fld_in(i-1,j+1,k,bi,bj)-fld_in(i-1,j,k,bi,bj)))
     &       )
           df(i,j,bi,bj) = df(i,j,bi,bj)
     &      - xA(i,j,bi,bj)*smooth3D_Kuy(i,j,k,bi,bj)*dTdy(bi,bj)
          ENDDO
         ENDDO

c      /// end for x ///

         DO j=jMin,jMax
          DO i=iMin,iMax
           fZon(i,j,k,bi,bj) = fZon(i,j,k,bi,bj) + df(i,j,bi,bj)
          ENDDO
         ENDDO

         DO j=jMin,jMax
          DO i=iMin,iMax
           df(i,j,bi,bj) = 0.
          ENDDO
         ENDDO

c      ///gmredi_ytr///

         DO j=jMin,jMax
          DO i=iMin,iMax
           df(i,j,bi,bj) = df(i,j,bi,bj)
     &      -yA(i,j,bi,bj)
     &       *smooth3D_Kvy(i,j,k,bi,bj)
     &       *recip_dyC(i,j,bi,bj)
     &       *(fld_in(i,j,k,bi,bj)-fld_in(i,j-1,k,bi,bj))
          ENDDO
         ENDDO

         DO j=jMin,jMax
          DO i=iMin,iMax
           dTdz(bi,bj) =  0.5*(
     &      +0.5*recip_drC(k)*
     &       ( maskC(i,j-1,k,bi,bj)*
     &          (fld_in(i,j-1,MAX(k-1,1),bi,bj)-fld_in(i,j-1,k,bi,bj))
     &         +maskC(i, j ,k,bi,bj)*
     &          (fld_in(i, j ,MAX(k-1,1),bi,bj)-fld_in(i, j ,k,bi,bj))
     &       )
     &      +0.5*recip_drC(MIN(k+1,Nr))*
     &       ( maskC(i,j-1,MIN(k+1,Nr),bi,bj)*
     &         (fld_in(i,j-1,k,bi,bj)-fld_in(i,j-1,MIN(k+1,Nr),bi,bj))
     &         +maskC(i, j ,MIN(k+1,Nr),bi,bj)*
     &         (fld_in(i, j ,k,bi,bj)-fld_in(i, j ,MIN(k+1,Nr),bi,bj))
     &       )      )
           df(i,j,bi,bj) = df(i,j,bi,bj)
     &      - yA(i,j,bi,bj)*smooth3D_Kvz(i,j,k,bi,bj)*dTdz(bi,bj)
          ENDDO
         ENDDO

         DO j=jMin,jMax
          DO i=iMin,iMax
           dTdx(bi,bj) = 0.5*(
     &      +0.5*(maskW(i+1,j,k,bi,bj)
     &            *recip_dxC(i+1,j,bi,bj)*
     &            (fld_in(i+1,j,k,bi,bj)-fld_in(i,j,k,bi,bj))
     &            +maskW(i,j,k,bi,bj)
     &            *recip_dxC(i,j,bi,bj)*
     &            (fld_in(i,j,k,bi,bj)-fld_in(i-1,j,k,bi,bj)))
     &      +0.5*(maskW(i+1,j-1,k,bi,bj)
     &            *recip_dxC(i+1,j,bi,bj)*
     &            (fld_in(i+1,j-1,k,bi,bj)-fld_in(i,j-1,k,bi,bj))
     &            +maskW(i,j-1,k,bi,bj)
     &            *recip_dxC(i,j,bi,bj)*
     &            (fld_in(i,j-1,k,bi,bj)-fld_in(i-1,j-1,k,bi,bj)))
     &       )
           df(i,j,bi,bj) = df(i,j,bi,bj)
     &      - yA(i,j,bi,bj)*smooth3D_Kvx(i,j,k,bi,bj)*dTdx(bi,bj)
          ENDDO
         ENDDO

c      /// end for y ///

         DO j=jMin,jMax
          DO i=iMin,iMax
           fMer(i,j,k,bi,bj) = fMer(i,j,k,bi,bj) + df(i,j,bi,bj)
          ENDDO
         ENDDO

         DO j=jMin,jMax
          DO i=iMin,iMax
           df(i,j,bi,bj) = 0.
          ENDDO
         ENDDO

c       /// GAD_DIFF_R ///

         IF ( k.GT.1 .AND. .NOT.smooth3DdoImpldiff ) THEN
          DO j=jMin,jMax
           DO i=iMin,iMax
            df(i,j,bi,bj) =
     &        -_rA(i,j,bi,bj)
     &        *smooth3D_kappaR(i,j,k,bi,bj)*recip_drC(k)
     &        *(fld_in(i,j,k,bi,bj)
     &        -fld_in(i,j,k-1,bi,bj))*rkSign
           ENDDO
          ENDDO
         ENDIF

c      ///gmredi rtrans///

         IF (k.GT.1) THEN
          DO j=jMin,jMax
           DO i=iMin,iMax
            dTdx(bi,bj) = 0.5*(
     &       +0.5*(maskW(i+1,j,k,bi,bj)
     &             *recip_dxC(i+1,j,bi,bj)*
     &             (fld_in(i+1,j,k,bi,bj)-fld_in(i,j,k,bi,bj))
     &            +maskW(i,j,k,bi,bj)
     &             *recip_dxC(i,j,bi,bj)*
     &             (fld_in(i,j,k,bi,bj)-fld_in(i-1,j,k,bi,bj)))
     &       +0.5*(maskW(i+1,j,k-1,bi,bj)
     &             *recip_dxC(i+1,j,bi,bj)*
     &             (fld_in(i+1,j,k-1,bi,bj)-fld_in(i,j,k-1,bi,bj))
     &            +maskW(i,j,k-1,bi,bj)
     &             *recip_dxC(i,j,bi,bj)*
     &             (fld_in(i,j,k-1,bi,bj)-fld_in(i-1,j,k-1,bi,bj)))
     &                        )

            dTdy(bi,bj) = 0.5*(
     &       +0.5*(maskS(i,j,k,bi,bj)
     &             *recip_dyC(i,j,bi,bj)*
     &             (fld_in(i,j,k,bi,bj)-fld_in(i,j-1,k,bi,bj))
     &            +maskS(i,j+1,k,bi,bj)
     &             *recip_dyC(i,j+1,bi,bj)*
     &             (fld_in(i,j+1,k,bi,bj)-fld_in(i,j,k,bi,bj)))
     &       +0.5*(maskS(i,j,k-1,bi,bj)
     &             *recip_dyC(i,j,bi,bj)*
     &             (fld_in(i,j,k-1,bi,bj)-fld_in(i,j-1,k-1,bi,bj))
     &            +maskS(i,j+1,k-1,bi,bj)
     &             *recip_dyC(i,j+1,bi,bj)*
     &             (fld_in(i,j+1,k-1,bi,bj)-fld_in(i,j,k-1,bi,bj)))
     &                        )

            df(i,j,bi,bj) = df(i,j,bi,bj)
     &           - rA(i,j,bi,bj)
     &           *( smooth3D_Kwx(i,j,k,bi,bj)*dTdx(bi,bj)
     &             +smooth3D_Kwy(i,j,k,bi,bj)*dTdy(bi,bj) )

           ENDDO
          ENDDO
         ENDIF

c     /// end for r ///

         IF (k.GT.1) THEN
          DO j=jMin,jMax
           DO i=iMin,iMax
            fVerT(i,j,k-1,bi,bj) = fVerT(i,j,k-1,bi,bj)
     &       + df(i,j,bi,bj)*maskUp(i,j,bi,bj)
           ENDDO
          ENDDO
         ENDIF

         DO j=jMin,jMax
          DO i=iMin,iMax
           df(i,j,bi,bj) = 0.
          ENDDO
         ENDDO

        ENDDO !k
       ENDDO !bi
      ENDDO !bj

c these exchanges are crucial:
      CALL EXCH_UV_XYZ_RL(fZon,fMer,.TRUE.,myThid)
      CALL EXCH_XYZ_RL ( fVerT, myThid )

      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
c 3rd k loop: Divergence of fluxes
        DO k=1,Nr
         IF (k.GT.1) THEN
          DO j=jMin,jMax
           DO i=iMin,iMax
            gt_in(i,j,k,bi,bj) = gt_in(i,j,k,bi,bj)
     &       -smooth_recip_hFacC(i,j,k,bi,bj)*recip_drF(k)
     &       *recip_rA(i,j,bi,bj)
     &       *( (fZon(i+1,j,k,bi,bj)-fZon(i,j,k,bi,bj))
     &         +(fMer(i,j+1,k,bi,bj)-fMer(i,j,k,bi,bj))
     &         +(fVerT(i,j,k,bi,bj)-fVerT(i,j,k-1,bi,bj))*rkSign
     &        )
           ENDDO
          ENDDO
         ELSE
          DO j=jMin,jMax
           DO i=iMin,iMax
            gt_in(i,j,k,bi,bj) = gt_in(i,j,k,bi,bj)
     &       -smooth_recip_hFacC(i,j,k,bi,bj)*recip_drF(k)
     &       *recip_rA(i,j,bi,bj)
     &       *( (fZon(i+1,j,k,bi,bj)-fZon(i,j,k,bi,bj))
     &         +(fMer(i,j+1,k,bi,bj)-fMer(i,j,k,bi,bj))
     &         +(fVerT(i,j,k,bi,bj))*rkSign
     &        )
           ENDDO
          ENDDO
         ENDIF
        ENDDO

       ENDDO
      ENDDO

      CALL EXCH_XYZ_RL( gt_in, myThid )

      RETURN
      END

#include "STIC_OPTIONS.h"
#ifdef ALLOW_SHELFICE
# include "SHELFICE_OPTIONS.h"
#endif

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C !ROUTINE: STIC_INIT_FIXED

C !INTERFACE:
      SUBROUTINE STIC_INIT_FIXED( myThid )

C     !DESCRIPTION:
C     Initialize STIC variables that are kept fixed during the run.

C     !USES:
      IMPLICIT NONE
C     == Global variables ===
#include "EEPARAMS.h"
#include "SIZE.h"
#include "PARAMS.h"
#include "GRID.h"
#include "STIC.h"
#ifdef ALLOW_SHELFICE
# include "SHELFICE.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     myThid ::  my Thread Id number
      INTEGER myThid
CEOP

C     !LOCAL VARIABLES:
C     i,j,bi,bj - Loop counters
      INTEGER i, j, k, bi, bj
      INTEGER CURI, CURJ, FRONT_K
C local variabls used to determine shelf-ice and ice-front masks
C     iceFrontCellThickness   :: the ratio of the horizontal length
C                         of the ice front in each model grid cell
C                         divided by the grid cell area.  The "thickness"
C                         of the colum perpendicular to the front
C     iceFrontWidth    :: the width of the ice front.
      _RL ice_bottom_Z_C
      _RL wet_top_Z_N, wet_bottom_Z_N
      _RL iceFrontWetContact_Z_max
      _RL iceFrontVertContactFrac, iceFrontCellThickness
      _RL iceFrontWidth, iceFrontFaceArea
      _RS fK_icefront (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)

      INTEGER SI
      _RL epsilon_H

#ifdef ALLOW_DIAGNOSTICS
      INTEGER       diagNum
      CHARACTER*8   diagName
      CHARACTER*16  diagCode
      CHARACTER*16  diagUnits
      CHARACTER*(80) diagTitle
#endif /* ALLOW_DIAGNOSTICS */

C ow - 06/29/2018
C     pkg/shelfice maskSHI above is not consistent with the spirit of gencost.
C     Use mask2dSHI and mask3dSHI below instead.
C     mask2dSHI and mask3dSHI are the 2d and 3d mask for shelfice. They are
C     zero if there is no shelfice and one if otherwise. For any i,j,
C     if there is at least one non-zero mask3dSHI in the vertical, then
C     mask2dSHI at i,j is one.
      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
        DO k=1,Nr
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           mask3dSHIICF(i,j,k,bi,bj) = 0. _d 0
           mask3dSHI(i,j,k,bi,bj) = 0. _d 0
           mask3dICF(i,j,k,bi,bj) = 0. _d 0
           IF (k.EQ.1) THEN
            mask2dSHIICF(i,j,bi,bj) = 0. _d 0
            mask2dSHI(i,j,bi,bj) = 0. _d 0
            mask2dICF(i,j,bi,bj) = 0. _d 0
           ENDIF
          ENDDO
         ENDDO
        ENDDO

        DO j = 1-OLy,sNy+OLy
         DO i = 1-OLx,sNx+OLx
          sticfLength(i,j,bi,bj) = 0. _d 0
          DO SI = 1,4
           CURI_ARR(i,j,bi,bj,SI) = -9999
           CURJ_ARR(i,j,bi,bj,SI) = -9999
           sticfWidth_arr(i,j,bi,bj,SI) = 0. _d 0
          ENDDO
         ENDDO
        ENDDO

       ENDDO
      ENDDO

C--  STEEP_ICECAVITY parameters (BEGIN)
      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
        DO j = 1-OLy, sNy+OLy
         DO i = 1-OLx, sNx+OLx
          kIcf(i,j,bi,bj) = 0
          DO k = 1 , Nr
           IF ( R_stic(i,j,bi,bj) .GT. ABS(rF(k))) kIcf(i,j,bi,bj) = k
          ENDDO
          fK_icefront(i,j,bi,bj) = FLOAT(kIcf(i,j,bi,bj))
         ENDDO
        ENDDO
       ENDDO
      ENDDO
C--  STEEP_ICECAVITY parameters (END)

C--   Create masks for shelf-ice and ice-front by modifyig code from
C     shelfice_thermodynamics.F minimum fraction of a cell adjacent to an
C     ice front that must be wet for exchange to happen
      epsilon_H = 1. _d -03

      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)

C--   First ice front then ice shelf.  Loop through each i,j point
C--   process ice fronts in k, then process ice shelf.
        DO j = 1-OLy+1,sNy+OLy-1
         DO i = 1-OLx+1,sNx+OLx-1

C--   The k index where the ice front ends (0 if no ice front)
          FRONT_K = kIcf(i,j,bi,bj)

C--   If there is an ice front at this (i,j) continue
          IF (FRONT_K .GT. 0) THEN

C--   Loop through all depths where the ice front is fround
           DO k = 1, FRONT_K
C--   Loop around the four laterally neighboring cells of the ice front.
C--   If any neighboring points has wet volume in contact with the ice
C--   front at (i,j) then calculate ice-ocean exchanges.
C--   The four laterally neighboring point are at (CURI,CURJ)
            DO SI = 1,4
             IF     (SI .EQ. 1) THEN
C--   Looking to right
              CURI = i+1
              CURJ = j
              iceFrontWidth = dyG(i+1,j,bi,bj)
             ELSEIF (SI .EQ. 2) THEN
C--   Looking to LEFT
              CURI = i-1
              CURJ = j
              iceFrontWidth = dyG(i,j,bi,bj)
             ELSEIF (SI .EQ. 3) THEN
C--   Looking to NORTH
              CURI = i
              CURJ = j+1
              iceFrontWidth = dxG(i,j+1,bi,bj)
             ELSEIF (SI .EQ. 4) THEN
C--   Looking to south
              CURI = i
              CURJ = j-1
              iceFrontWidth = dxG(i,j,bi,bj)
             ENDIF

             CURI_ARR(i,j,bi,bj,SI) = CURI
             CURJ_ARR(i,j,bi,bj,SI) = CURJ
             sticfWidth_arr(i,j,bi,bj,SI) = iceFrontWidth

C--   cell depth describes the average distance perpendicular to the ice
C--   front fact

             iceFrontCellThickness = 0. _d 0
             IF(iceFrontWidth.NE.0. _d 0)
     &         iceFrontCellThickness = RA(CURI,CURJ,bi,bj)/iceFrontWidth
             iceFrontFaceArea  = drF(k)*iceFrontWidth

C--   First, make sure the adjacent point has at least some water in it.
             IF (_hFacC(CURI,CURJ,k,bi,bj) .GT. zeroRL) THEN

C--   we need to determine how much of the ice front is in contact with
C--   water in the neighboring grid cell at this depth level.

C--   1. Determine the top depth with water in the current cell
C--   2. Determine the top depth with water in the neighbor cell
C--   3. Determine the depth where water  gap between (1) and (2).
C--   4. If there is a gap then ice front is in contact with water in
C--      the neighboring cell

C--   ice_bottom_Z_C: the depth (m) of the bottom of the ice in the
C--               current cell.  Bounded between rF(k) and rF(k+1).
C--               * If the ice extends past the bottom of the cell then
C--                 ice_bottom_Z_C = rF(k+1)
C--               [rF(k) >= ice_bottom_Z_C >= rF(k+1)]  (rF is negative)
              ice_bottom_Z_C = MAX(rF(k+1),
     &             MIN(Ro_surf(i,j, bi,bj), rF(k)))

C--   wet_top_Z_N: the depth (m) of the bottom of the ice in the
C--              neighboring grid.  If the neighboring cell has ice in
C--              (in the form of a shelf or front) then wet_top_Z_N is
C--              the depth of this neighboring ice.
C--
C--              * If neighbor cell has no ice, then Ro_surf = 0 and
C--                wet_top_Z_N = rF(k)
C--              [rF(k) >= wet_top_Z_N >= rF(k+1)]     (rF is negative)

              wet_top_Z_N = MAX(rF(k+1),
     &             MIN(Ro_surf(CURI,CURJ, bi,bj), rF(k)))

C--   wet_bottom_Z_N: the depth (m) of the bottom of the wet part of the
C--              neighboring cell.  If the seafloor reaches into
C--              the grid cell then the bottom of the wet part of the
C--              grid cell is at the seafloor.
C--
C--              * If the seafloor is deeper than this grid cell then
C--                wet_bottom_Z = rF(k+1)
C--              * If the seafloor is shallower than this grid cell then
C--                wet_bottom_Z = rF(k)
C--              * If the seafloor reaches partly into this grid cell
C--                then wet_bottom_Z = R_low

C--              [rF(k) >= wet_bottom_Z >= rF(k+1)]     (rF is negative)

              wet_bottom_Z_N = MIN(rF(k),
     &             MAX(R_low(CURI,CURJ, bi,bj), rF(k+1)))

C--   iceFrontWetContact_Z_max:  The deepest point where the
C--              the ice front at (i,j) is in contact with water
C--              in the neighboring cell.  The shallower of
C--              wet_bottom_Z_N (seafloor depth of neighboring point) and
C--              ice_bottom_Z_C (bottom of ice front in this center cell).

C--              * wet_bottom_Z_N if the seafloor of the neighboring
C--                cell is shallower than the ice draft at (i,j).
C--              * ice_bottom_Z_C if the ice draft at (i,j) is shallower
C--                than the seafloor of the neighboring cell.

              IF (ice_bottom_Z_C .GT. wet_bottom_Z_N) THEN
               iceFrontWetContact_Z_max = ice_bottom_Z_C
              ELSE
               iceFrontWetContact_Z_max = wet_bottom_Z_N
              ENDIF

C--   The shallowest depth where the ice front at (i,j) is in contact
C--   with water in the neighboring cell.  If the neighboring cell has
C--   no ice draft then wet_top_Z_N = rF(k), the top of the cell.
C--   Otherwise, the shallowest depth where the ice front at (i,j) can
C--   be in in contact with water (not ice) in (CURI, CURJ)
C--   is wet_top_Z_N.

C--   the fraction of the grid cell height that has ice draft in contact
C--   with water in the neighboring cell.
              iceFrontVertContactFrac =
     &             (wet_top_Z_N - iceFrontWetContact_Z_max)/ drF(k)
C--   Only proceed if iceFrontVertContactFrac is > 0, the
C--   ice draft at (i,j)
C--   is in contact with some water in the neighboring grid cell.
              IF (iceFrontVertContactFrac .GT. epsilon_H) THEN
               mask3dSHIICF(CURI,CURJ,k,bi,bj) = 1. _d 0
               mask2dSHIICF(CURI,CURJ,  bi,bj) = 1. _d 0
               mask3dICF   (CURI,CURJ,k,bi,bj) = 1. _d 0
               mask2dICF   (CURI,CURJ,  bi,bj) = 1. _d 0
              ENDIF /* iceFrontVertContactFrac */
             ENDIF /* hFacC(CURI,CURJ,k,bi,bj) */
            ENDDO /* SI loop for adjacent cells */
           ENDDO /* k loop */
          ENDIF /* FRONT_K */

C--   ice shelf
          k = kTopC(i,j,bi,bj)

C--   If there is an ice front at this (i,j) continue
C--   I am assuming k is only .GT. when there is at least some
C--   nonzero wet point below the shelf in the grid cell.
          IF (k .GT. 0) THEN
           mask3dSHIICF(i,j,k,bi,bj) = 1. _d 0
           mask2dSHIICF(i,j,  bi,bj) = 1. _d 0
           mask3dSHI   (i,j,k,bi,bj) = 1. _d 0
           mask2dSHI   (i,j,  bi,bj) = 1. _d 0
          ENDIF /* SHELF k > 0 */
         ENDDO /* i */
        ENDDO /* j */
       ENDDO /* bi */
      ENDDO /* bj */

C     fill in the halos
      _EXCH_XY_RS(  mask2dSHIICF, myThid )
      _EXCH_XY_RS(  mask2dICF   , myThid )
      _EXCH_XY_RS(  mask2dSHI   , myThid )
      _EXCH_XYZ_RS( mask3dSHIICF, myThid )
      _EXCH_XYZ_RS( mask3dICF   , myThid )
      _EXCH_XYZ_RS( mask3dSHI   , myThid )

C     output the masks
      CALL WRITE_FLD_XY_RS ( 'mask2dSHIICF',' ',mask2dSHIICF,-1,myThid)
      CALL WRITE_FLD_XYZ_RS( 'mask3dSHIICF',' ',mask3dSHIICF, 0,myThid)
      CALL WRITE_FLD_XY_RS ( 'mask2dSHI',' ',mask2dSHI,-1,myThid)
      CALL WRITE_FLD_XYZ_RS( 'mask3dSHI',' ',mask3dSHI, 0,myThid)
      CALL WRITE_FLD_XY_RS ( 'mask2dICF',' ',mask2dICF,-1,myThid)
      CALL WRITE_FLD_XYZ_RS( 'mask3dICF',' ',mask3dICF, 0,myThid)
      CALL WRITE_FLD_XY_RS ( 'R_stic',' ',R_stic,-1,myThid)
      CALL WRITE_FLD_XY_RS ( 'kIcf',' ',fK_icefront,-1,myThid)

#ifdef ALLOW_DIAGNOSTICS
      IF ( useDiagnostics ) THEN

# ifdef ALLOW_SHITRANSCOEFF_3D
       diagName  = 'SHIgam3T'
       diagTitle = '3D-Ice shelf exchange coefficient for theta'
       diagUnits = 'm/s             '
       diagCode  = 'SMR     MR      '
       CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I      diagName, diagCode, diagUnits, diagTitle, 0, myThid )

       diagName  = 'SHIgam3S'
       diagTitle = '3D-Ice shelf exchange coefficient for salt'
       diagUnits = 'm/s             '
       diagCode  = 'SMR     MR      '
       CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I      diagName, diagCode, diagUnits, diagTitle, 0, myThid )
# endif

       diagName  = 'SHIICFfw'
       diagTitle = 'total ice shelf and front FW flux (+ upward)'
       diagUnits = 'kg/m^2/s        '
       diagCode  = 'SM      L1      '
       CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I      diagName, diagCode, diagUnits, diagTitle, 0, myThid )

       diagName  = 'SHIICFht'
       diagTitle = 'total ice shelf and ice front heat flux (+ upward)'
       diagUnits = 'W/m^2           '
       diagCode  = 'SM      L1      '
       CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I      diagName, diagCode, diagUnits, diagTitle, 0, myThid )

       diagName  = 'STCfwFlx'
       diagTitle ='Ice front freshwater flux (+ve increases ocean salt)'
       diagUnits = 'kg/m^2/s        '
       diagCode  = 'SM      MR      '
       CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I      diagName, diagCode, diagUnits, diagTitle, 0, myThid )

       diagName  = 'STChtFlx'
       diagTitle = 'Ice front heat flux  (+ve cools ocean)'
       diagUnits = 'W/m^2           '
       diagCode  = 'SM      MR      '
       CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I      diagName, diagCode, diagUnits, diagTitle, 0, myThid )

       diagName  = 'STCForcT'
       diagTitle = 'Ice front forcing for theta, >0 increases theta'
       diagUnits = 'W/m^2           '
       diagCode  = 'SM      MR      '
       CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I      diagName, diagCode, diagUnits, diagTitle, 0, myThid )

       diagName  = 'STCForcS'
       diagTitle = 'Ice front forcing for salt, >0 increases salt'
       diagUnits = 'g/m^2/s         '
       diagCode  = 'SM      MR      '
       CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I      diagName, diagCode, diagUnits, diagTitle, 0, myThid )

C     these diagnostics are never filled
c      diagName  = 'SHIICFFT'
c      diagTitle = 'total SHI and ICF forcing for T, >0 increases theta'
c      diagUnits = 'W/m^2           '
c      diagCode  = 'SM      L1      '
c      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
c    I      diagName, diagCode, diagUnits, diagTitle, 0, myThid )

c      diagName  = 'SHIICFFS'
c      diagTitle = 'total SHI and ICF forcing for S, >0 increases salt'
c      diagUnits = 'g/m^2/s         '
c      diagCode  = 'SM      L1      '
c      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
c    I      diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      ENDIF
#endif

      RETURN
      END

#include "CAL_OPTIONS.h"

      subroutine cal_GetMonthsRec(
     O                             fac, first, changed,
     O                             month0, month1, year0, year1,
     I                             mytime, myiter, mythid
     &                           )

c     ==================================================================
c     SUBROUTINE cal_GetMonthsRec
c     ==================================================================
c
c     o Given the current model time or iteration number this routine
c       returns the corrresponding months that will have to be used in
c       order to interpolate monthly mean fields. The routine derives 
c       from *exf_GetMonthsRec* of the external forcing package.
c
c     started: Christian Eckert eckert@mit.edu 21-Apr-2000
c              - ported from the external forcing package and slightly
c                modified (10 --> nmonthyear-2, 12 --> nmonthyear).
c
c     changed: Patrick Heimbach heimbach@mit.edu 15-Jun-2000
c              - fixed bug for month1 = nmonthyear
c
c     ==================================================================
c     SUBROUTINE cal_GetMonthsRec
c     ==================================================================

      implicit none

c     == global variables ==

#include "cal.h"

c     == routine arguments ==

      _RL     fac
      logical first
      logical changed
      integer month0
      integer month1
      integer year0
      integer year1
      _RL     mytime
      integer myiter
      integer mythid

c     == local variables ==

      integer currentdate(4)
      integer midtime(4)
      integer middate(4)
      integer tempDate(4)
      integer middate0_1, middate0_2
      integer middate0(4)
      integer middate1_1, middate1_2
      integer middate1(4)
      integer prevdate(4)
      integer shifttime(4)
      integer startofmonth_1, startofmonth_2
      integer endofmonth_1,  endofmonth_2
      integer startofmonth(4)
      integer endofmonth(4)
      integer difftime(4)
      integer presentmonth
      integer presentyear
      integer previous
      integer next
      integer prevcount
      integer modelsteptime(4)

      _RL     currentsecs
      _RL     prevsecs
      _RL     midsecs_np
      _RL     diffsecs
      _RL     midsecs

c     == end of interface ==

ce    --> Include a check whether the right calendar is used.

      shifttime(1) =  1
      shifttime(2) =  0
      shifttime(3) =  0
      shifttime(4) = -1

      call cal_TimeInterval( -modelstep, 'secs', modelsteptime,
     &                        mythid )

c     Determine the current date and the current month.
      call cal_GetDate( myiter, mytime, currentdate, mythid )

      presentyear     = currentdate(1)/10000
      presentmonth    = mod(currentdate(1)/100,100)
      startofmonth_1  = (currentdate(1)/100)*100 + 1
      startofmonth_2  = 0
      call cal_FullDate( startofmonth_1, startofmonth_2,
     &                   startofmonth, mythid )

      endofmonth_1    = (currentdate(1)/100)*100 +
     &                  ndaymonth(presentmonth,currentdate(3))
      endofmonth_2    = 235959
      call cal_FullDate( endofmonth_1, endofmonth_2,
     &                   endofmonth, mythid )

c     Determine middle of current month.
      currentsecs = float(
     &              (mod(currentdate(1),100)-1)*secondsperday +
     &              currentdate(2)/10000*secondsperhour +
     &              mod(currentdate(2)/100,100)*secondsperminute +
     &              mod(currentdate(2),100)
     &              )
      midsecs     = float(ndaymonth(presentmonth,currentdate(3))*
     &                    secondsperday/2)

      call cal_TimeInterval( midsecs, 'secs', midtime, mythid )
      call cal_AddTime( startofmonth, midtime, middate, mythid )
      call cal_AddTime( currentdate, modelsteptime, prevdate, mythid )

      prevsecs = float(
     &           (mod(prevdate(1),100)-1)*secondsperday +
     &           prevdate(2)/10000*secondsperhour +
     &           mod(prevdate(2)/100,100)*secondsperminute +
     &           mod(prevdate(2),100)
     &           )

c--   Set switches for reading new records.
      first = ((mytime - modelstart) .lt. 0.5*modelstep)

      if ( first ) then
        changed = .false.
      endif

      if ( currentsecs .lt. midsecs ) then

        month0 = mod(presentmonth+nmonthyear-2,nmonthyear)+1
        year0 = presentyear
        if (month0 .EQ. 12) year0 = year0 - 1
        prevcount = month0

        shifttime(1) = -shifttime(1)
        call cal_AddTime( startofmonth, shifttime, middate0, mythid )
        middate0_1  = (middate0(1)/100)*100 + 1
        middate0_2  = 0
        call cal_FullDate( middate0_1, middate0_2, tempDate,
     &                     mythid )

        previous   = mod(tempDate(1)/100,100)

        midsecs_np = float(ndaymonth(previous,tempDate(3))*
     &                     secondsperday/2)

        call cal_TimeInterval( midsecs_np, 'secs', midtime, mythid )
        call cal_AddTime( tempDate, midtime, middate0, mythid )

        month1 = presentmonth
        year1 = presentyear

        middate1(1) = middate(1)
        middate1(2) = middate(2)
        middate1(3) = middate(3)
        middate1(4) = middate(4)

      else

        month0 = presentmonth
        year0 = presentyear

        if ( prevsecs .lt. midsecs ) then
          prevcount = mod(presentmonth+nmonthyear-2,nmonthyear)+1
        else
          prevcount = presentmonth
        endif

        middate0(1) = middate(1)
        middate0(2) = middate(2)
        middate0(3) = middate(3)
        middate0(4) = middate(4)

        month1 = mod(presentmonth, nmonthyear) + 1
        year1 = presentyear
        if ( month1 .EQ. 1 ) year1 = year1 + 1

        call cal_AddTime( endofmonth, shifttime, middate1, mythid )
        middate1_1  = (middate1(1)/100)*100 + 1
        middate1_2  = 0

        call cal_FullDate( middate1_1, middate1_2, tempDate,
     &                     mythid )
        next       = mod(tempDate(1)/100,100)
        midsecs_np = float(ndaymonth(next,tempDate(3))*
     &                     secondsperday/2)
        call cal_TimeInterval( midsecs_np, 'secs', midtime, mythid )
        call cal_AddTime( tempDate, midtime, middate1, mythid )

      endif

      call cal_SubDates( middate1, middate0, difftime, mythid )
      call cal_ToSeconds( difftime, diffsecs, mythid )

c     Set counters, switches, and the linear interpolation factor.
c     only check month, not year, as it will always change
      if ( (.not. first) .and. (prevcount .ne. month0) ) then
        changed = .true.
      else
        changed = .false.
      endif

      if ( currentsecs .lt. midsecs ) then
        fac = (midsecs - currentsecs)/diffsecs
      else
        fac = (2.*midsecs + midsecs_np - currentsecs)/
     &        diffsecs
      endif

      return
      end

#include "STREAMICE_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

CBOP
      SUBROUTINE STREAMICE_GET_FP_ERR_OAD ( err_max, myThid )
C     /============================================================\
C     | SUBROUTINE                                                 |
C     | o                                                          |
C     |============================================================|
C     |                                                            |
C     \============================================================/
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "STREAMICE.h"
#include "STREAMICE_CG.h"

C     !INPUT/OUTPUT ARGUMENTS
      _RL err_max
      INTEGER myThid

#ifdef ALLOW_STREAMICE
#ifdef ALLOW_STREAMICE_FP_ADJ
      INTEGER conv_flag, i, j, bi, bj

      INTEGER ikey_nl
      _RL err_tempu, err_tempv
      _RL max_vel, tempu, tempv, err_lastchange, cgtol
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      _RL err_sum, conj_norm
      _RL err_sum_tile (nSx,nSy)

       err_max = 0. _d 0
       err_sum = 0. _d 0
       conj_norm = 0. _d 0

       DO bj = myByLo(myThid), myByHi(myThid)
        DO bi = myBxLo(myThid), myBxHi(myThid)
         err_sum_tile(bi,bj) = 0. _d 0
        ENDDO
       ENDDO

       DO bj = myByLo(myThid), myByHi(myThid)
        DO bi = myBxLo(myThid), myBxHi(myThid)
         DO j=1,sNy
          DO i=1,sNx
           err_tempu = 0. _d 0
           err_tempv = 0. _d 0
           IF (STREAMICE_umask(i,j,bi,bj).eq.1) THEN
            err_tempu =
     &       ABS (U_streamice(i,j,bi,bj)-u_new_SI(i,j,bi,bj))
           ENDIF
           IF (STREAMICE_vmask(i,j,bi,bj).eq.1) THEN
            err_tempv = MAX( err_tempu,
     &       ABS (V_streamice(i,j,bi,bj)-v_new_SI(i,j,bi,bj)))
           ENDIF
           IF (err_tempv .ge. err_max) err_max = err_tempv
          ENDDO
         ENDDO
        ENDDO
       ENDDO

       CALL GLOBAL_MAX_R8 (err_max, myThid)

#endif
#endif
      RETURN
      END

#include "FIZHI_OPTIONS.h"
       subroutine update_ocean_exports (myTime, myIter, myThid)
c----------------------------------------------------------------------
c  Subroutine update_ocean_exports - 'Wrapper' routine to update
c        the fields related to the ocean surface that are needed
c        by fizhi (sst and sea ice extent).
c
c Call:  getsst  (Return the current sst field-read dataset if needed)
c        getsice (Return the current sea ice field-read data if needed)
c-----------------------------------------------------------------------
       implicit none
#include "SIZE.h"
#include "GRID.h"
#include "fizhi_ocean_coms.h"
#include "EEPARAMS.h"
#include "chronos.h"
#ifdef ALLOW_EXCH2
#include "W2_EXCH2_SIZE.h"
#include "W2_EXCH2_TOPOLOGY.h"
#endif /* ALLOW_EXCH2 */

       integer myIter, myThid
       _RL myTime

       INTEGER xySize
#if defined(ALLOW_EXCH2)
       PARAMETER ( xySize = W2_ioBufferSize )
#else
       PARAMETER ( xySize = Nx*Ny )
#endif
       integer i, j, bi, bj, bislot, bjslot
       integer im1, im2, jm1, jm2, idim1, idim2, jdim1, jdim2
       integer xsize, ysize
       _RL        sstmin
       parameter ( sstmin = 273.16 )

       _RL sst1 (xySize), sst2 (xySize)
       _RL sice1(xySize), sice2(xySize)
c      _RL sst1(xsize,ysize),sst2(xsize,ysize)
c      _RL sice1(xsize,ysize),sice2(xsize,ysize)
       integer nymd1sst(nSx,nSy),nymd2sst(nSx,nSy)
       integer nymd1sice(nSx,nSy),nymd2sice(nSx,nSy)
       integer nhms1sst(nSx,nSy),nhms2sst(nSx,nSy)
       integer nhms1sice(nSx,nSy),nhms2sice(nSx,nSy)
       integer sstdates(370,nSx,nSy),sicedates(370,nSx,nSy)
       integer ssttimes(370,nSx,nSy),sicetimes(370,nSx,nSy)
       logical first(nSx,nSy)
       integer nSxnSy
       parameter(nSxnSy = nSx*nSy)
       data first/nSxnSy*.true./

       save nymd1sst,nymd2sst,nymd1sice,nymd2sice
       save nhms1sst,nhms2sst,nhms1sice,nhms2sice
       save sst1, sst2, sice1, sice2
       save sstdates, sicedates
       save ssttimes, sicetimes

#if defined(ALLOW_EXCH2)
       xsize = exch2_global_Nx
       ysize = exch2_global_Ny
#else
       xsize = Nx
       ysize = Ny
#endif
       idim1 = 1-OLx
       idim2 = sNx+OLx
       jdim1 = 1-OLy
       jdim2 = sNy+OLy
       im1 = 1
       im2 = sNx
       jm1 = 1
       jm2 = sNy

C***********************************************************************

       DO BJ = myByLo(myThid),myByHi(myThid)
       DO BI = myBxLo(myThid),myBxHi(myThid)
#if defined(ALLOW_EXCH2)
       bislot = exch2_txglobalo(W2_myTileList(bi,bj))-1
       bjslot = exch2_tyglobalo(W2_myTileList(bi,bj))-1
#else
       bislot = myXGlobalLo-1+(bi-1)*sNx
       bjslot = myYGlobalLo-1+(bj-1)*sNy
#endif

       call getsst(ksst,sstclim,idim1,idim2,jdim1,jdim2,im1,im2,
     .  jm1,jm2,nSx,nSy,xsize,ysize,bi,bj,bislot,bjslot,nymd,nhms,
     .  sst1,sst2,first(bi,bj),nymd1sst(bi,bj),nymd2sst(bi,bj),
     .  nhms1sst(bi,bj),nhms2sst(bi,bj),sstdates(1,bi,bj),
     .  ssttimes(1,bi,bj),sst,myThid)
       call getsice(kice,siceclim,idim1,idim2,jdim1,jdim2,im1,im2,
     .  jm1,jm2,nSx,nSy,xsize,ysize,bi,bj,bislot,bjslot,nymd,nhms,
     .  sice1,sice2,first(bi,bj),nymd1sice(bi,bj),nymd2sice(bi,bj),
     .  nhms1sice(bi,bj),nhms2sice(bi,bj),sicedates(1,bi,bj),
     .  sicetimes(1,bi,bj),sice,myThid)

c Check for Minimum Open-Water SST
c --------------------------------
       do j=jm1,jm2
       do i=im1,im2
       if(sice(i,j,bi,bj).eq.0.0 .and. sst(i,j,bi,bj).lt.sstmin)
     .                                          sst(i,j,bi,bj) = sstmin
       enddo
       enddo

       ENDDO
       ENDDO
       _EXCH_XY_RL(sst,myThid)
       _EXCH_XY_RL(sice,myThid)

       return
       end

       subroutine getsice(iunit,clim,idim1,idim2,jdim1,jdim2,im1,im2,
     .   jm1,jm2,nSumx,nSumy,xsize,ysize,bi,bj,bislot,bjslot,nymd,nhms,
     .   sicebc1,sicebc2,first,nymdbc1,nymdbc2,nhmsbc1,nhmsbc2,
     .   nymdbc,nhmsbc,sice,mythid)
C***********************************************************************
C
C!ROUTINE: GETSICE
C!DESCRIPTION:  GETSICE returns the sea ice depth.
C!              This routine is adaptable for any frequency
C!              data upto a daily frequency.
C!              note: for diurnal data ndmax should be increased.
C
C!INPUT PARAMETERS:
C!      iunit     Unit number assigned to the sice data file
C!      idim1     Start dimension in x-direction
C!      idim2     End dimension in x-direction
C!      jdim1     Start dimension in y-direction
C!      jdim2     End dimension in y-direction
C!      im1       Begin of x-direction span for filling sice
C!      im2       End of x-direction span for filling sice
C!      jm1       Begin of y-direction span for filling sice
C!      jm2       End of y-direction span for filling sice
C!      nSumx     Number of processors in x-direction (local processor)
C!      nSumy     Number of processors in y-direction (local processor)
C!      xsize      Number of processors in x-direction (global)
C!      ysize      Number of processors in y-direction (global)
C!      bi        Processor number in x-direction (local to processor)
C!      bj        Processor number in y-direction (local to processor)
C!      bislot  Processor number in x-direction (global)
C!      bjslot  Processor number in y-direction (global)
C!      nymd    YYMMDD of the current model timestep
C!      nhms    HHMMSS of the model time
C
C!OUTPUT PARAMETERS:
C!      sice(idim1:idim2,jdim1:jdim2,nSumx,nSumy) Sea ice depth in meters
C
C!ROUTINES CALLED:
C
C!      bcdata       Reads the data for a given unit number
C!      bcheader     Reads the header info for a given unit number
C!      interp_time  Returns weights for linear interpolation
C
C--------------------------------------------------------------------------

      implicit none
#include "SIZE.h"

      integer iunit,idim1,idim2,jdim1,jdim2,im1,im2,jm1,jm2,nSumx,nSumy
      integer xsize,ysize,bi,bj,bislot,bjslot,nymd,nhms,mythid
      logical clim

      _RL sicebc1(xsize,ysize)
      _RL sicebc2(xsize,ysize)
      _RL sice(idim1:idim2,jdim1:jdim2,nSumx,nSumy)
      integer nhmsbc1,nhmsbc2,nymdbc1,nymdbc2
      logical first

C Maximum number of dates in one year for the data
      integer ndmax
      parameter (ndmax = 370)
      integer nymdbc(ndmax),nhmsbc(ndmax)

      character*8  cname
      character*80 cdscrip
      character*22 sicedata
      _RL fac1, fac2, lat0, lon0, timebc1, timebc2, timemod, undef
      logical found, error
      integer i,j,n,nn,iyear,iyearbc,nd,ndby3,imbc,jmbc
      integer ndatebc,nrec
      integer nymdmod


C--------- Variable Initialization ---------------------------------

      data error /.false./

c  save header info
      save imbc,jmbc,lat0,lon0,ndatebc,undef

c  this only works for between 1950-2050
      if (nymd .lt. 500101) then
        nymdmod = 20000000 + nymd
      else if (nymd .le. 991231) then
        nymdmod = 19000000 + nymd
      else
        nymdmod = nymd
      endif

      iyear   = nymdmod/10000
      if(clim) then
       if(xsize.eq.192)sicedata='sice19232.weekly.clim'
       if(xsize.eq.612)sicedata='sice612102.weekly.clim'
      else
       if(xsize.eq.192)
     .           WRITE(sicedata,'(A,I4)')'sice19232.weekly.y',iyear
       if(xsize.eq.612)
     .           WRITE(sicedata,'(A,I4)')'sice612102.weekly.y',iyear
      endif

c  initialize so that first time through they have values for the check
c  these values make the iyear .ne. iyearbc true anyways for
c  for the first time so first isnt checked below.

      if (first) then
        nymdbc(2) = 0
        nymdbc1   = 0
        nymdbc2   = 0
        nhmsbc1   = 0
        nhmsbc2   = 0
        first = .false.
      endif

C---------- Read in Header file ----------------------------------

      iyearbc = nymdbc(2)/10000

      if( iyear.ne.iyearbc ) then

       close(iunit)
       open (iunit,file=sicedata,form='unformatted',access='direct',
     .                                         recl=xsize*ysize*4)
       nrec = 1
       call bcheader (iunit, ndmax, nrec,
     .          cname, cdscrip, imbc, jmbc, lat0, lon0,
     .          ndatebc, nymdbc, nhmsbc, undef, error)

C--------- Check data for Compatibility ------------------------------

C Check for correct data in boundary condition file
       if (.not.error .and. cname.ne.'SICE') then
        write(6,*)'Wrong data in SICE boundary condition file => ',cname
        error = .true.
       endif

C Check Horizontal Resolution
       if(.not.error.and.imbc*jmbc.ne.xsize*ysize)then
        write(6,*) ' B.C. Resolution DOES NOT match Model Resolution!'
        write(6,*) ' B.C. Resolution:  ',imbc*jmbc
        write(6,*) 'Model Resolution:  ',xsize*ysize
        error = .true.
       endif

C Check Year
       iyearbc = nymdbc(2)/10000
       if (.not.error .and. iyear.ne.iyearbc .and. iyearbc.ne.0) then
        write(6,*)'     B.C. Year DOES NOT match REQUESTED Year!'
        write(6,*)'     B.C. Year:  ', iyearbc
        write(6,*)'Requested Year:  ', iyear
        error = .true.
       endif

       if (.not.error)   then
C if climatology, fill dates for data with current model year
        if (iyearbc.eq.0) then
         write(6,*)
         write(6,*) 'Climatological Dataset is being used.'
         write(6,*) 'Current model year to be used to fill Header Dates'
         do n = 2, ndatebc-1
          nymdbc(n) = nymdbc(n) +(nymdmod/10000)*10000
         enddo
C  For the first date subtract 1 year from the current model NYMD
         n = 1
         nymdbc(n) = nymdbc(n) +(nymdmod/10000-1)*10000
C  For the last date add 1 year to the current model NYMD
         n = ndatebc
         nymdbc(n) = nymdbc(n) +(nymdmod/10000+1)*10000
        endif

C  Write out header info
        _BEGIN_MASTER( myThid )
        write(6,*) ' Updated boundary condition data'
        write(6,*) ' ---------------------------------'
        write(6,*) ' Variable: ',cname
        write(6,*) ' Description: ',cdscrip
        write(6,*) ' Resolution: x= ',imbc,' y= ',jmbc,
     .                                       ' Undefined value = ',undef
        write(6,*) ' Starting latitude = ',lat0,' longitude =',lon0
        write(6,*) ' Data valid at these times: '
        ndby3 = ndatebc/3
        do n = 1, ndby3*3,3
         write(6,1000) (nn,nymdbc(nn),nhmsbc(nn),nn=n,n+2)
 1000    format(3(2x,i3,':',i8,2x,i8))
        enddo
        write(6,1000) (nn,nymdbc(nn),nhmsbc(nn),nn=ndby3*3+1,ndatebc)
        _END_MASTER( myThid )
       endif

      endif

C---------- Read sice data if necessary -------------------------------

      found = .false.
      nd = 2

c  If model time is not within the times of saved sice data
c  from previous call to getsice then read new data

      timemod = dfloat(nymdmod) + dfloat(nhms)   /1000000
      timebc1 = dfloat(nymdbc1) + dfloat(nhmsbc1)/1000000
      timebc2 = dfloat(nymdbc2) + dfloat(nhmsbc2)/1000000

      if (timemod .lt. timebc1 .or. timemod .ge. timebc2) then

       do while (.not.found .and. nd .le. ndatebc)
        timebc2 = dfloat(nymdbc(nd)) + dfloat(nhmsbc(nd))/1000000
        if (timebc2 .gt. timemod) then
         nymdbc1 = nymdbc(nd-1)
         nymdbc2 = nymdbc(nd)
         nhmsbc1 = nhmsbc(nd-1)
         nhmsbc2 = nhmsbc(nd)
         call bcdata (iunit,imbc,jmbc,nd,nd+1,sicebc1,sicebc2)
         found = .true.
        else
         nd = nd + 1
        endif
       enddo

c  Otherwise the data from the last time in getsice surrounds the
c  current model time.

      else
       found = .true.
      endif

      if (.not.found) then
       print *, 'STOP: Could not find SICE dates for model time.'
       call my_finalize
       call my_exit (101)
      endif

C---------- Interpolate sice data ------------------------------------

      call interp_time(nymdmod,nhms,nymdbc1,nhmsbc1,nymdbc2,nhmsbc2,
     .                                                       fac1,fac2)

      do j = jm1,jm2
      do i = im1,im2
       sice(i,j,bi,bj) = sicebc1(i+bislot,j+bjslot)*fac1
     .                 + sicebc2(i+bislot,j+bjslot)*fac2
c average to 0 or 1
c -----------------
       if (sice(i,j,bi,bj) .ge. 0.5) then
        sice(i,j,bi,bj) = 1.
       else
        sice(i,j,bi,bj) = 0.
       endif
      enddo
      enddo

C---------- Fill sice with depth of ice ------------------------------------
      do j = jm1,jm2
      do i = im1,im2
       if (sice(i,j,bi,bj) .eq. 1.) then
        sice(i,j,bi,bj) = 3.
       endif
      enddo
      enddo
C---------------------------------------------------------------------------

      return
      end
      subroutine getsst(iunit,clim,idim1,idim2,jdim1,jdim2,im1,im2,
     .   jm1,jm2,nSumx,nSumy,xsize,ysize,bi,bj,bislot,bjslot,nymd,nhms,
     .   sstbc1,sstbc2,first,nymdbc1,nymdbc2,nhmsbc1,nhmsbc2,
     .   nymdbc,nhmsbc,sst,mythid)
C***********************************************************************
C
C!ROUTINE: GETSST
C!DESCRIPTION:  GETSST gets the SST data.
C!              This routine is adaptable for any frequency
C!              data upto a daily frequency.
C!              note: for diurnal data ndmax should be increased.
C
C!INPUT PARAMETERS:
C!      iunit     Unit number assigned to the sice data file
C!      idim1     Start dimension in x-direction
C!      idim2     End dimension in x-direction
C!      jdim1     Start dimension in y-direction
C!      jdim2     End dimension in y-direction
C!      im1       Begin of x-direction span for filling sst
C!      im2       End of x-direction span for filling sst
C!      jm1       Begin of y-direction span for filling sst
C!      jm2       End of y-direction span for filling sst
C!      nSumx     Number of processors in x-direction (local processor)
C!      nSumy     Number of processors in y-direction (local processor)
C!      xsize     x-dimension of global array
C!      ysize     y-dimension of global array
C!      bi        Processor number in x-direction (local to processor)
C!      bj        Processor number in y-direction (local to processor)
C!      bislot    Slot number into global array in x-direction (global)
C!      bjslot    Slot number into global array in y-direction (global)
C!      nymd      YYMMDD of the current model timestep
C!      nhms      HHMMSS of the model time
C
C!OUTPUT PARAMETERS:
C!     sst(idim1:idim2,jdim1:jdim2,nSumx,nSumy) Sea surface temperature (K)
C
C!ROUTINES CALLED:
C
C!     bcdata     Reads the data for a given unit number
C!     bcheader   Reads the header info for a given unit number
C!     interp_time  Returns weights for linear interpolation
C
C--------------------------------------------------------------------------

      implicit none
#include "SIZE.h"

      integer iunit,idim1,idim2,jdim1,jdim2,im1,im2,jm1,jm2,nSumx,nSumy
      integer xsize,ysize,bi,bj,bislot,bjslot,nymd,nhms,mythid
      logical clim

      _RL sstbc1(xsize,ysize)
      _RL sstbc2(xsize,ysize)
      _RL sst(idim1:idim2,jdim1:jdim2,nSumx,nSumy)
      integer nhmsbc1,nhmsbc2,nymdbc1,nymdbc2
      logical first

C Maximum number of dates in one year for the data
      integer ndmax
      parameter (ndmax = 370)
      integer nymdbc(ndmax),nhmsbc(ndmax)

      character*8  cname
      character*80 cdscrip
      character*21 sstdata
      _RL fac1, fac2, lat0, lon0, timebc1, timebc2, timemod, undef
      logical found, error
      integer i,j,n,nn,iyear,iyearbc,nd,ndby3,imbc,jmbc
      integer ndatebc,nrec
      integer nymdmod


C--------- Variable Initialization ---------------------------------

      data error /.false./

c  save header info
      save imbc,jmbc,lat0,lon0,ndatebc,undef

c  this only works for between 1950-2050
      if (nymd .lt. 500101) then
        nymdmod = 20000000 + nymd
      else if (nymd .le. 991231) then
        nymdmod = 19000000 + nymd
      else
        nymdmod = nymd
      endif

      iyear   = nymdmod/10000
      if(clim) then
       if(xsize.eq.192)sstdata='sst19232.weekly.clim'
       if(xsize.eq.612)sstdata='sst612102.weekly.clim'
      else
       if(xsize.eq.192)
     .           WRITE(sstdata,'(A,I4)')'sst19232.weekly.y',iyear
       if(xsize.eq.612)
     .           WRITE(sstdata,'(A,I4)')'sst612102.weekly.y',iyear
      endif

c  initialize so that first time through they have values for the check
c  these vaules make the iyear .ne. iyearbc true anyways for
c  for the first time so first isnt checked below.
      if (first) then
        nymdbc(2) = 0
        nymdbc1   = 0
        nymdbc2   = 0
        nhmsbc1   = 0
        nhmsbc2   = 0
        first = .false.
      endif

C---------- Read in Header file ----------------------------------

      iyearbc = nymdbc(2)/10000

      if( iyear.ne.iyearbc ) then

       close(iunit)
       open (iunit,file=sstdata,form='unformatted',access='direct',
     .                                        recl=xsize*ysize*4)
       nrec = 1
       call bcheader (iunit, ndmax, nrec,
     .          cname, cdscrip, imbc, jmbc, lat0, lon0,
     .          ndatebc, nymdbc, nhmsbc, undef, error)

C--------- Check data for Compatibility

C Check for correct data in boundary condition file
       if (.not.error .and. cname.ne.'SST') then
        write(6,*)'Wrong data in SST boundary condition file => ',cname
        error = .true.
       endif

C Check Horizontal Resolution
       if(.not.error.and.imbc*jmbc.ne.xsize*ysize)then
        write(6,*) ' B.C. Resolution DOES NOT match Model Resolution!'
        write(6,*) ' B.C. Resolution:  ',imbc*jmbc
        write(6,*) 'Model Resolution:  ',xsize*ysize
        error = .true.
       endif

C Check Year
       iyearbc = nymdbc(2)/10000
       if (.not.error .and. iyear.ne.iyearbc .and. iyearbc.ne.0) then
        write(6,*)'     B.C. Year DOES NOT match REQUESTED Year!'
        write(6,*)'     B.C. Year:  ', iyearbc
        write(6,*)'Requested Year:  ', iyear
        error = .true.
       endif

       if (.not.error)   then
C if climatology, fill dates for data with current model year
        if (iyearbc.eq.0) then
         write(6,*)
         write(6,*)'Climatological Dataset is being used.'
         write(6,*)'Current model year is used to fill Header Dates'
         do n = 2, ndatebc-1
          nymdbc(n) = nymdbc(n) +(nymdmod/10000)*10000
         enddo
C  For the first date subtract 1 year from the current model NYMD
         n = 1
         nymdbc(n) = nymdbc(n) +(nymdmod/10000-1)*10000
C  For the last date add 1 year to the current model NYMD
         n = ndatebc
         nymdbc(n) = nymdbc(n) +(nymdmod/10000+1)*10000
        endif

C  Write out header info
        _BEGIN_MASTER( myThid )
        write(6,*) ' Updated boundary condition data'
        write(6,*) ' ---------------------------------'
        write(6,*) ' Variable: ',cname
        write(6,*) ' Description: ',cdscrip
        write(6,*) ' Resolution: x= ',imbc,' y= ',jmbc,
     .                                       ' Undefined value = ',undef
        write(6,*) ' Starting latitude = ',lat0,' longitude =',lon0
        write(6,*) ' Data valid at these times: '
        ndby3 = ndatebc/3
        do n = 1, ndby3*3,3
         write(6,1000) (nn,nymdbc(nn),nhmsbc(nn),nn=n,n+2)
 1000    format(3(2x,i3,':',i8,2x,i8))
        enddo
        write(6,1000) (nn,nymdbc(nn),nhmsbc(nn),nn=ndby3*3+1,ndatebc)
        _END_MASTER( myThid )
       endif

       if( error ) call my_exit (101)

      endif

C---------- Read SST data if necessary -------------------------------

      found = .false.
      nd = 2

c  If model time is not within the times of saved sst data
c  from previous call to getsst then read new data

      timemod = dfloat(nymdmod) + dfloat(nhms)   /1000000
      timebc1 = dfloat(nymdbc1) + dfloat(nhmsbc1)/1000000
      timebc2 = dfloat(nymdbc2) + dfloat(nhmsbc2)/1000000

      if (timemod .lt. timebc1 .or. timemod .ge. timebc2) then

       do while (.not.found .and. nd .le. ndatebc)
        timebc2 = dfloat(nymdbc(nd)) + dfloat(nhmsbc(nd))/1000000
        if (timebc2 .gt. timemod) then
         nymdbc1 = nymdbc(nd-1)
         nymdbc2 = nymdbc(nd)
         nhmsbc1 = nhmsbc(nd-1)
         nhmsbc2 = nhmsbc(nd)
         call bcdata (iunit,imbc,jmbc,nd,nd+1,sstbc1,sstbc2)
         found = .true.
        else
         nd = nd + 1
        endif
       enddo

c  Otherwise the data from the last time in getsst surrounds the
c  current model time.

      else
       found = .true.
      endif

      if (.not.found) then
       print *, 'STOP: Could not find SST dates for model time.'
       call my_finalize
       call my_exit (101)
      endif

C---------- Interpolate SST data ------------------------------------

      call interp_time(nymdmod,nhms,nymdbc1,nhmsbc1,nymdbc2,nhmsbc2,
     .                                                        fac1,fac2)

      do j = jm1,jm2
      do i = im1,im2
       sst(i,j,bi,bj) = sstbc1(i+bislot,j+bjslot)*fac1
     .                + sstbc2(i+bislot,j+bjslot)*fac2
      enddo
      enddo


      return
      end

      subroutine bcdata (iunit,im,jm,nrec1,nrec2,field1,field2)
C************************************************************************
C
C!ROUTINE:      BCDATA
C!DESCRIPTION:  BCDATA reads the data from the file assigned to the
C!              passed unit number and returns data from the two times
C!              surrounding the current model time.  The two record
C!              postitions are not assumed to be next to each other.
C
C!INPUT PARAMETERS:
C!      im      number of x points
C!      im      number of x points
C!      nrec1   record number of the time before the model time
C!      nrec2   record number of the time after the model time
C
C!OUTPUT PARAMETERS:
C!      field1(im,jm)  data field before the model time
C!      field2(im,jm)  data field after the model time
C
C--------------------------------------------------------------------------
      implicit none

      integer iunit,im,jm,nrec1,nrec2

      _RL  field1(im,jm)
      _RL  field2(im,jm)

      integer i,j
      real*4 f1(im,jm), f2(im,jm)

C--------- Read file -----------------------------------------------
      read(iunit,rec=nrec1) f1
      read(iunit,rec=nrec2) f2

#ifdef _BYTESWAPIO
      call MDS_BYTESWAPR4( im*jm, f1)
      call MDS_BYTESWAPR4( im*jm, f2)
#endif
      do j=1,jm
      do i=1,im
       field1(i,j) = f1(i,j)
       field2(i,j) = f2(i,j)
      enddo
      enddo

      return
      end
      subroutine bcheader (iunit, ndmax, nrec,
     .           cname, cdscrip, im, jm, lat0, lon0, ndatebc,
     .           nymdbc, nhmsbc, undef, error)
C************************************************************************
C
C!ROUTINE:     BCHEADER
C!DESCRIPTION: BCHEADER reads the header from a file and returns the info.
C
C!INPUT PARAMETERS:
C!      iunit    unit number assigned to the data file
C!      ndmax    maximum number of date/times of the data
C!      nrec     record number of the header info (or assume 1 ?)
C
C!OUTPUT PARAMETERS:
C!      cname         name of the data in the file header
C!      cdscrip       description of the data in the file header
C!      im            number of x points
C!      jm            number of y points
C!      lat0          starting latitude for the data grid
C!      lon0          starting longitude for the data grid
C!      ndatebc       number of date/times of the data in the file
C!      nymdbc(ndmax) array of dates for the data including century
C!      nhmsbc(ndmax) array of times for the data
C!      undef         value for undefined values in the data
C!      error         logical TRUE if dataset problem
C
C--------------------------------------------------------------------------
      implicit none

      integer iunit, ndmax, nrec

      character*8  cname
      character*80 cdscrip
      character*112 dummy112
      integer im,jm,ndatebc,nymdbc(ndmax),nhmsbc(ndmax)
      _RL lat0,lon0,undef
      logical error

      integer i
      integer*4 im_32,jm_32
      integer*4 ndatebc_32,nhmsbc_32(ndmax),nymdbc_32(ndmax)
      real*4 lat0_32,lon0_32,undef_32

C--------- Read file -----------------------------------------------

      read(iunit,rec=nrec,err=500) cname, cdscrip,
     .     im_32, jm_32, lat0_32, lon0_32,
     .     ndatebc_32, undef_32

#ifdef _BYTESWAPIO
      call MDS_BYTESWAPI4( 1, im_32)
      call MDS_BYTESWAPI4( 1, jm_32)
      call MDS_BYTESWAPR4( 1, lat0_32)
      call MDS_BYTESWAPR4( 1, lon0_32)
      call MDS_BYTESWAPI4( 1, ndatebc_32)
      call MDS_BYTESWAPR4( 1, undef_32)
#endif

      read(iunit,rec=nrec,err=500) dummy112,
     .     (nymdbc_32(i), nhmsbc_32(i), i=1,ndatebc_32)

      im = im_32
      jm = jm_32
      lat0 = lat0_32
      lon0 = lon0_32
      undef = undef_32

      ndatebc = ndatebc_32
      do i=1,ndatebc
#ifdef _BYTESWAPIO
      call MDS_BYTESWAPI4( 1, nymdbc_32(i))
      call MDS_BYTESWAPI4( 1, nhmsbc_32(i))
#endif
      nymdbc(i) = nymdbc_32(i)
      nhmsbc(i) = nhmsbc_32(i)
      enddo

      return
  500 continue
      print *, 'Error reading boundary condition from unit ',iunit
      error = .true.
      return
      end

#include "GAD_OPTIONS.h"

CBOP
C !ROUTINE: GAD_DST2U1_ADV_R

C !INTERFACE: ==========================================================
      SUBROUTINE GAD_DST2U1_ADV_R(
     I           bi,bj,k, advectionScheme,
     I           deltaTloc, rTrans, wFld,
     I           tracer,
     O           wT,
     I           myThid )

C !DESCRIPTION:
C  Calculates the area integrated vertical flux due to advection
C  of a tracer using second-order Direct Space and Time (DST-2)
C  interpolation (=Lax-Wendroff) or simple 1rst order upwind scheme.

C !USES: ===============================================================
      IMPLICIT NONE
#include "SIZE.h"
#include "GRID.h"
#include "GAD.h"

C !INPUT PARAMETERS: ===================================================
C  bi,bj             :: tile indices
C  k                 :: vertical level
C  advectionScheme   :: advection scheme to use: either 2nd Order DST
C                                                or 1rst Order Upwind
C  deltaTloc         :: local time-step (s)
C  rTrans            :: vertical volume transport
C  wFld              :: vertical flow
C  tracer            :: tracer field
C  myThid            :: thread number
      INTEGER bi,bj,k
      INTEGER advectionScheme
      _RL deltaTloc
      _RL rTrans(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL wFld  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL tracer(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      INTEGER myThid

C !OUTPUT PARAMETERS: ==================================================
C  wT                :: vertical advective flux
      _RL wT    (1-OLx:sNx+OLx,1-OLy:sNy+OLy)

C !LOCAL VARIABLES: ====================================================
C  i,j               :: loop indices
C  km1               :: =max( k-1 , 1 )
C  rLimit            :: centered (vs upwind) fraction
C  wLoc              :: velocity, vertical component
C  wCFL              :: Courant-Friedrich-Levy number
      INTEGER i,j,km1
      _RL wLoc, wCFL, rLimit, wAbs
CEOP

      rLimit = 0. _d 0
      IF ( advectionScheme.EQ.ENUM_DST2 ) rLimit = 1. _d 0

      km1=MAX(1,k-1)

      IF ( k.LE.1 .OR. k.GT.Nr) THEN
       DO j=1-Oly,sNy+Oly
        DO i=1-Olx,sNx+Olx
         wT(i,j) = 0.
        ENDDO
       ENDDO
      ELSE
       DO j=1-Oly,sNy+Oly
        DO i=1-Olx,sNx+Olx

         wLoc = wFld(i,j)
c        wLoc = rTrans(i,j)*recip_rA(i,j,bi,bj)
         wCFL = ABS(wLoc*deltaTloc*recip_drC(k))

c        wT(i,j) = maskC(i,j,km1,bi,bj)*(
c    &     rTrans(i,j)*(tracer(i,j,km1)+tracer(i,j,k))*0.5 _d 0
c    &   + ( 1. _d 0 - rLimit*(1. _d 0 - wCFL) )*ABS(rTrans(i,j))
c    &                *(tracer(i,j,km1)-tracer(i,j,k))*0.5 _d 0*rkSign
c    &                                  )
C-- above formulation produces large truncation error when:
C    1rst.O upWind and   w*rkSign > 0 & |tracer(k-1)| << |tracer(k)|
C                   or   w*rkSign < 0 & |tracer(k-1)| >> |tracer(k)|
C-- change to a more robust expression:
         wAbs = ABS(rTrans(i,j))*rkSign
     &       *( 1. _d 0 - rLimit*(1. _d 0 - wCFL) )
         wT(i,j) = maskC(i,j,km1,bi,bj)*(
     &             ( rTrans(i,j)+wAbs )* 0.5 _d 0 * tracer(i,j,km1)
     &           + ( rTrans(i,j)-wAbs )* 0.5 _d 0 * tracer(i,j,k)
     &                                  )
        ENDDO
       ENDDO
      ENDIF

      RETURN
      END

#include "GMREDI_OPTIONS.h"

CBOP
C     !ROUTINE: GMREDI_RESIDUAL_FLOW
C     !INTERFACE:
      SUBROUTINE GMREDI_RESIDUAL_FLOW(
     U                  uFld, vFld, wFld,
     I                  bi, bj, myIter, myThid )
C     !DESCRIPTION:
C     Add GM-bolus velocity to Eulerian velocity to get Residual Mean velocity.

C     !USES:
      IMPLICIT NONE

C     == GLobal variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "GMREDI.h"
#ifdef ALLOW_EDDYPSI
# include "DYNVARS.h"
# include "FFIELDS.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     uFld   :: zonal      velocity (updated)
C     vFld   :: meridional velocity (updated)
C     wFld   :: vertical volume transport (updated)
C     bi,bj  :: tile indices
C     myIter :: my Iteration number
C     myThid :: my Thread Id number
      INTEGER bi, bj, myIter, myThid
      _RL uFld  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL vFld  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL wFld  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)

#ifdef ALLOW_GMREDI
#ifdef GM_BOLUS_ADVEC

C     !LOCAL VARIABLES:
C     == Local variables ==
C     i, j, k :: loop indices
      INTEGER i, j, k
      INTEGER kp1
      _RL maskp1, flipSign4LHCoord
      _RL delPsi
#ifdef ALLOW_EDDYPSI
      _RL ustar, vstar
#endif
CEOP

C     Since bolus transport is computed as curl of stream-function, needs to
C     flip sign when using Left-Handed Coordinate system such as P-coordinate
      flipSign4LHCoord = -gravitySign

      IF ( GM_AdvForm .AND. .NOT.GM_AdvSeparate
     &     .AND. .NOT.GM_InMomAsStress ) THEN

       DO k=1,Nr
        kp1 = MIN(k+1,Nr)
        maskp1 = 1.
        IF (k.GE.Nr) maskp1 = 0.

        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
           delPsi = GM_PsiX(i,j,kp1,bi,bj)*deepFacF(kp1)*maskp1
     &            - GM_PsiX(i,j, k, bi,bj)*deepFacF(k)
           uFld(i,j,k) = uFld(i,j,k)
     &                 + delPsi*recip_drF(k)*_recip_hFacW(i,j,k,bi,bj)
     &                         *recip_deepFacC(k)*flipSign4LHCoord
         ENDDO
        ENDDO
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
           delPsi = GM_PsiY(i,j,kp1,bi,bj)*deepFacF(kp1)*maskp1
     &            - GM_PsiY(i,j, k, bi,bj)*deepFacF(k)
           vFld(i,j,k) = vFld(i,j,k)
     &                 + delPsi*recip_drF(k)*_recip_hFacS(i,j,k,bi,bj)
     &                         *recip_deepFacC(k)*flipSign4LHCoord
         ENDDO
        ENDDO
C       deep-model: simplify FacF / Fac2F (from dx,y / rA) to: 1/FacF
        DO j=1-OLy,sNy+OLy-1
         DO i=1-OLx,sNx+OLx-1
           delPsi = ( dyG(i+1,j,bi,bj)*GM_PsiX(i+1,j,k,bi,bj)
     &               -dyG( i ,j,bi,bj)*GM_PsiX( i ,j,k,bi,bj)
     &               +dxG(i,j+1,bi,bj)*GM_PsiY(i,j+1,k,bi,bj)
     &               -dxG(i, j ,bi,bj)*GM_PsiY(i, j ,k,bi,bj)
     &              )
           wFld(i,j,k) = wFld(i,j,k)
     &                 + delPsi*recip_rA(i,j,bi,bj)
     &                         *recip_deepFacF(k)*flipSign4LHCoord
         ENDDO
        ENDDO

       ENDDO

#ifdef ALLOW_EDDYPSI
      ELSEIF( GM_AdvForm .AND. .NOT.GM_AdvSeparate
     &        .AND. GM_InMomAsStress ) THEN

C     Calculate the mean velocity from the residual and bolus
       DO k=1,Nr
        kp1 = MIN(k+1,Nr)
        maskp1 = 1.
        IF (k.GE.Nr) maskp1 = 0.

        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          delPsi = GM_PsiX(i,j,kp1,bi,bj)*deepFacF(kp1)*maskp1
     &           - GM_PsiX(i,j, k, bi,bj)*deepFacF(k)
          ustar = delPsi*recip_drF(k)*_recip_hFacW(i,j,k,bi,bj)
     &                  *recip_deepFacC(k)*flipSign4LHCoord
          uEulerMean(i,j,k,bi,bj) = uVel(i,j,k,bi,bj) - ustar
         ENDDO
        ENDDO
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          delPsi = GM_PsiY(i,j,kp1,bi,bj)*deepFacF(kp1)*maskp1
     &           - GM_PsiY(i,j, k, bi,bj)*deepFacF(k)
          vstar  = delPsi*recip_drF(k)*_recip_hFacS(i,j,k,bi,bj)
     &                   *recip_deepFacC(k)*flipSign4LHCoord
          vEulerMean(i,j,k,bi,bj) = vVel(i,j,k,bi,bj) - vstar
         ENDDO
        ENDDO

       ENDDO

#ifdef ALLOW_DIAGNOSTICS
       IF ( useDiagnostics ) THEN
        CALL DIAGNOSTICS_FILL(uEulerMean,'U_EulerM',0,Nr,1,bi,bj,myThid)
        CALL DIAGNOSTICS_FILL(vEulerMean,'V_EulerM',0,Nr,1,bi,bj,myThid)
       ENDIF
#endif /* ALLOW_DIAGNOSTICS */
#endif /* ALLOW_EDDYPSI */

      ENDIF
#endif /* GM_BOLUS_ADVEC */
#endif /* ALLOW_GMREDI */

      RETURN
      END

#include "EXF_OPTIONS.h"
#ifdef ALLOW_AUTODIFF
# include "AUTODIFF_OPTIONS.h"
#endif

CBOI
C
C !TITLE: EXTERNAL FORCING
C !AUTHORS: mitgcm developers ( mitgcm-support@mitgcm.org )
C !AFFILIATION: Massachussetts Institute of Technology
C !DATE:
C !INTRODUCTION: External forcing package
C \bv
C * The external forcing package, in conjunction with the
C   calendar package (cal), enables the handling of realistic forcing
C   fields of differing temporal forcing patterns.
C * It comprises climatological restoring and relaxation
C * Bulk formulae are implemented to convert atmospheric fields
C   to surface fluxes.
C * An interpolation routine provides on-the-fly interpolation of
C   forcing fields an arbitrary grid onto the model grid.
C * A list of EXF variables and units is in EXF_FIELDS.h
C
C     !CALLING SEQUENCE:
C ...
C  EXF_GETFORCING (TOP LEVEL ROUTINE)
C  |
C  |-- EXF_GETCLIM (get climatological fields used e.g. for relax.)
C  |   |--- exf_set_climtemp (relax. to 3-D temperature field)
C  |   |--- exf_set_climsalt (relax. to 3-D salinity field)
C  |   |--- exf_set_climsst  (relax. to 2-D SST field)
C  |   |--- exf_set_climsss  (relax. to 2-D SSS field)
C  |   o
C  |
C  |-- EXF_GETFFIELDS <- this one does almost everything
C  |   |   1. reads in fields, either flux or atmos. state,
C  |   |      depending on CPP options (for each variable two fields
C  |   |      consecutive in time are read in and interpolated onto
C  |   |      current time step).
C  |   |   2. If forcing is atmos. state and control is atmos. state,
C  |   |      then the control variable anomalies are read here
C  |   |          * ctrl_getatemp
C  |   |          * ctrl_getaqh
C  |   |          * ctrl_getuwind
C  |   |          * ctrl_getvwind
C  |   |      If forcing and control are fluxes, then
C  |   |      controls are added later.
C  |   o
C  |
C  |-- EXF_CHECK_RANGE
C  |   |   Check whether read fields are within assumed range
C  |   |   (may capture mismatches in units)
C  |   o
C  |
C  |-- EXF_RADIATION
C  |   |   Compute net or downwelling radiative fluxes via
C  |   |   Stefan-Boltzmann law in case only one is known.
C  |-- EXF_WIND
C  |   |   Compute air-sea wind-stress from winds (or the other way)
C  |-- EXF_BULKFORMULAE
C  |   |   Compute air-sea buoyancy fluxes from atmospheric
C  |   |   state following Large and Pond, JPO, 1981/82
C  |   o
C  |
C  |-- < add time-mean river runoff here, if available >
C  |
C  |-- < update tile edges here >
C  |
C  |-- EXF_GETSURFACEFLUXES
C  |   |   If forcing and control are fluxes, then
C  |   |   control vector anomalies are added here.
C  |   |--- ctrl_get_gen
C  |   o
C  |
C  |-- < treatment of hflux w.r.t. swflux >
C  |
C  |-- EXF_DIAGNOSTICS_FILL
C  |   |   Do EXF-related diagnostics output here.
C  |-- EXF_MONITOR
C  |   |   Monitor EXF-forcing fields
C  |   o
C  |
C  |-- EXF_MAPFIELDS
C  |   |   Forcing fields from exf package are mapped onto
C  |   |   mitgcm forcing arrays.
C  |   |   Mapping enables a runtime rescaling of fields
C  |   o
C
C \ev
CEOI

CBOP
C     !ROUTINE: EXF_GETFORCING
C     !INTERFACE:
      SUBROUTINE EXF_GETFORCING( myTime, myIter, myThid )

C     !DESCRIPTION: \bv
C     *=================================================================
C     | SUBROUTINE EXF_GETFORCING
C     *=================================================================
C     o Get the forcing fields for the current time step. The switches
C       for the inclusion of the individual forcing components have to
C       be set in EXF_OPTIONS.h (or ECCO_CPPOPTIONS.h).
C       A note on surface fluxes:
C       The MITgcm-UV vertical coordinate z is positive upward.
C       This implies that a positive flux is out of the ocean
C       model. However, the wind stress forcing is not treated
C       this way. A positive zonal wind stress accelerates the
C       model ocean towards the east.
C       started: eckert@mit.edu, heimbach@mit.edu, ralf@ocean.mit.edu
C       mods for pkg/seaice: menemenlis@jpl.nasa.gov 20-Dec-2002
C     *=================================================================
C     | SUBROUTINE EXF_GETFORCING
C     *=================================================================
C     \ev

C     !USES:
      IMPLICIT NONE

C     == global variables ==
#include "EEPARAMS.h"
#include "SIZE.h"
#include "PARAMS.h"
#include "GRID.h"

#include "EXF_PARAM.h"
#include "EXF_FIELDS.h"
#include "EXF_CONSTANTS.h"
#ifdef ALLOW_AUTODIFF_TAMC
# include "tamc.h"
#endif
#ifdef ALLOW_TAPENADE
# include "EXF_INTERP_SIZE.h"
# include "EXF_INTERP_PARAM.h"
#endif /* ALLOW_TAPENADE */
#if ( defined ALLOW_DOWNWARD_RADIATION ) || \
      ( defined ALLOW_ATM_TEMP && defined ALLOW_BULKFORMULAE )
# include "FFIELDS.h"
# include "DYNVARS.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     == routine arguments ==
      _RL     myTime
      INTEGER myIter
      INTEGER myThid

C     !LOCAL VARIABLES:
C     == local variables ==
      INTEGER bi,bj
      INTEGER i,j,ks
#if ( defined ALLOW_DOWNWARD_RADIATION ) || \
      ( defined ALLOW_ATM_TEMP && defined ALLOW_BULKFORMULAE )
      INTEGER kl
      _RL deltaSST
C     exf_Tsf :: local copy of global field gcmSST or extrapolated
C                surface temperature (in deg Celsius)
      _RL exf_Tsf        (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
#endif
C     == end of interface ==
CEOP

      ks = 1
      IF ( usingPCoords ) ks = Nr
#if ( defined ALLOW_DOWNWARD_RADIATION ) || \
      ( defined ALLOW_ATM_TEMP && defined ALLOW_BULKFORMULAE )
C     Compute the surface temperature either as copy of the global
C     variable gcmSST or by extrapolation to the actual surface
C     (W-point).
      kl = 2
      IF ( usingPCoords ) kl = Nr-1
      DO bj = myByLo(myThid),myByHi(myThid)
       DO bi = myBxLo(myThid),myBxHi(myThid)
        IF ( Nr.GE.2 .AND. sstExtrapol.GT.0. _d 0 ) THEN
         DO j = 1-OLy,sNy+OLy
          DO i = 1-OLx,sNx+OLx
           deltaSST = sstExtrapol
     &          *( theta(i,j,ks,bi,bj)-theta(i,j,kl,bi,bj) )
     &          *  maskC(i,j,kl,bi,bj)
           exf_Tsf(i,j,bi,bj) = gcmSST(i,j,bi,bj) + cen2kel
     &          + MAX( deltaSST, 0. _d 0 )
          ENDDO
         ENDDO
        ELSE
         DO j = 1-OLy,sNy+OLy
          DO i = 1-OLx,sNx+OLx
           exf_Tsf(i,j,bi,bj) = gcmSST(i,j,bi,bj) + cen2kel
          ENDDO
         ENDDO
        ENDIF
       ENDDO
      ENDDO
#endif

C     Get values of climatological fields.
      CALL EXF_GETCLIM( myTime, myIter, myThid )

C     Get the surface forcing fields.
      CALL EXF_GETFFIELDS( myTime, myIter, myThid )
      IF ( .NOT.useAtmWind ) THEN
       IF ( stressIsOnCgrid .AND. ustressfile.NE.' '
     &                      .AND. vstressfile.NE.' ' )
     &  CALL EXCH_UV_XY_RL( ustress, vstress, .TRUE., myThid )
      ENDIF

#ifdef ALLOW_AUTODIFF_TAMC
C     Store fields after reading them so that we do not need to save
C     their 0/1 levels to comlev1. Not all fields are required here (in
C     most cases only u/vwind or u/vstress, aqh, atemp, precip,
C     snowprecip, runoff), but we have directives for all potential
C     candidates here.
CADJ STORE ustress      = comlev1, key=ikey_dynamics, kind=isbyte
CADJ STORE vstress      = comlev1, key=ikey_dynamics, kind=isbyte
CADJ STORE uwind        = comlev1, key=ikey_dynamics, kind=isbyte
CADJ STORE vwind        = comlev1, key=ikey_dynamics, kind=isbyte
CADJ STORE wspeed       = comlev1, key=ikey_dynamics, kind=isbyte
# ifdef ALLOW_ATM_TEMP
CADJ STORE aqh        = comlev1, key=ikey_dynamics, kind=isbyte
CADJ STORE atemp      = comlev1, key=ikey_dynamics, kind=isbyte
CADJ STORE precip     = comlev1, key=ikey_dynamics, kind=isbyte
CADJ STORE lwflux     = comlev1, key=ikey_dynamics, kind=isbyte
CADJ STORE swflux     = comlev1, key=ikey_dynamics, kind=isbyte
CADJ STORE snowprecip = comlev1, key=ikey_dynamics, kind=isbyte
#  ifdef ALLOW_READ_TURBFLUXES
CADJ STORE hs         = comlev1, key=ikey_dynamics, kind=isbyte
CADJ STORE hl         = comlev1, key=ikey_dynamics, kind=isbyte
#  endif /* ALLOW_READ_TURBFLUXES */
#  ifdef EXF_READ_EVAP
CADJ STORE evap       = comlev1, key=ikey_dynamics, kind=isbyte
#  endif /* EXF_READ_EVAP */
#  ifdef ALLOW_DOWNWARD_RADIATION
CADJ STORE swdown     = comlev1, key=ikey_dynamics, kind=isbyte
CADJ STORE lwdown     = comlev1, key=ikey_dynamics, kind=isbyte
#  endif
# else /* ALLOW_ATM_TEMP undef */
#  ifdef SHORTWAVE_HEATING
CADJ STORE swflux     = comlev1, key=ikey_dynamics, kind=isbyte
#  endif
# endif /* ALLOW_ATM_TEMP */
# ifdef ATMOSPHERIC_LOADING
CADJ STORE apressure  = comlev1, key=ikey_dynamics, kind=isbyte
# endif
# ifdef ALLOW_RUNOFF
CADJ STORE runoff     = comlev1, key=ikey_dynamics, kind=isbyte
# endif
# ifdef ALLOW_SALTFLX
CADJ STORE saltflx    = comlev1, key=ikey_dynamics, kind=isbyte
# endif
# ifdef EXF_SEAICE_FRACTION
CADJ STORE areamask   = comlev1, key=ikey_dynamics, kind=isbyte
# endif
#endif /* ALLOW_AUTODIFF_TAMC */

#ifdef ALLOW_AUTODIFF
# ifdef ALLOW_AUTODIFF_MONITOR
        CALL EXF_ADJOINT_SNAPSHOTS( 2, myTime, myIter, myThid )
# endif
#endif /* ALLOW_AUTODIFF */

#ifdef ALLOW_DOWNWARD_RADIATION
C     Set radiative fluxes
      CALL EXF_RADIATION( exf_Tsf, myTime, myIter, myThid )
#endif

C     Set wind fields
      CALL EXF_WIND( myTime, myIter, myThid )

#ifdef ALLOW_ATM_TEMP
# ifdef ALLOW_BULKFORMULAE
#  ifdef ALLOW_AUTODIFF_TAMC
C     Here we probably only need to store uwind, vwind, wstress but we
C     keep the other fields for the paranoid AD-modeller
CADJ STORE uwind        = comlev1, key=ikey_dynamics, kind=isbyte
CADJ STORE vwind        = comlev1, key=ikey_dynamics, kind=isbyte
CADJ STORE wspeed       = comlev1, key=ikey_dynamics, kind=isbyte
CADJ STORE ustress      = comlev1, key=ikey_dynamics, kind=isbyte
CADJ STORE vstress      = comlev1, key=ikey_dynamics, kind=isbyte
CADJ STORE wstress      = comlev1, key=ikey_dynamics, kind=isbyte
#  endif
C     Compute turbulent fluxes (and surface stress) from bulk formulae
      CALL EXF_BULKFORMULAE( exf_Tsf, myTime, myIter, myThid )
#  ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE evap         = comlev1, key=ikey_dynamics, kind=isbyte
#  endif
# endif /* ALLOW_BULKFORMULAE */
#endif /* ALLOW_ATM_TEMP */

      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)

#ifdef ALLOW_ATM_TEMP
C     compute hflux & sflux from multiple components
        DO j = 1,sNy
         DO i = 1,sNx
C     Net surface heat flux.
          hflux(i,j,bi,bj) =
     &         - hs(i,j,bi,bj)
     &         - hl(i,j,bi,bj)
     &         + lwflux(i,j,bi,bj)
#ifndef SHORTWAVE_HEATING
     &         + swflux(i,j,bi,bj)
#endif
C             fresh-water flux from Precipitation and Evaporation.
          sflux(i,j,bi,bj) = evap(i,j,bi,bj) - precip(i,j,bi,bj)
         ENDDO
        ENDDO
#endif /* ALLOW_ATM_TEMP */

C     Apply runoff, masks and exchanges
        DO j = 1,sNy
         DO i = 1,sNx
#ifdef ALLOW_RUNOFF
          sflux(i,j,bi,bj) = sflux(i,j,bi,bj) - runoff(i,j,bi,bj)
#endif
          hflux(i,j,bi,bj) = hflux(i,j,bi,bj)*maskC(i,j,ks,bi,bj)
          sflux(i,j,bi,bj) = sflux(i,j,bi,bj)*maskC(i,j,ks,bi,bj)
         ENDDO
        ENDDO

       ENDDO
      ENDDO

C     Update the tile edges: needed for some EXF fields involved in horizontal
C     averaging, e.g., wind-stress; fields used by main model or other pkgs
C     are exchanged in EXF_MAPFIELDS.
c     _EXCH_XY_RL(hflux,   myThid)
c     _EXCH_XY_RL(sflux,   myThid)
      IF ( stressIsOnCgrid ) THEN
       CALL EXCH_UV_XY_RL( ustress, vstress, .TRUE., myThid )
      ELSE
       CALL EXCH_UV_AGRID_3D_RL(ustress, vstress, .TRUE., 1, myThid)
      ENDIF
#ifdef SHORTWAVE_HEATING
c     _EXCH_XY_RL(swflux, myThid)
#endif
#ifdef ATMOSPHERIC_LOADING
c     _EXCH_XY_RL(apressure, myThid)
#endif
#ifdef EXF_SEAICE_FRACTION
c     _EXCH_XY_RL(areamask, myThid)
#endif

C     Get values of the surface flux anomalies.
      CALL EXF_GETSURFACEFLUXES( myTime, myIter, myThid )

      IF ( useExfCheckRange .AND.
     &     ( myIter.EQ.nIter0 .OR. exf_debugLev.GE.debLevC ) ) THEN
       CALL EXF_CHECK_RANGE( myTime, myIter, myThid )
      ENDIF

#ifdef ALLOW_AUTODIFF
# ifdef ALLOW_AUTODIFF_MONITOR
      CALL EXF_ADJOINT_SNAPSHOTS( 1, myTime, myIter, myThid )
# endif
#endif /* ALLOW_AUTODIFF */

#ifdef ALLOW_ATM_TEMP
# ifdef SHORTWAVE_HEATING
C     Treatment of qnet
C     The location of the summation of Qnet in exf_mapfields is unfortunate:
C     For backward compatibility issues we want it to happen after
C     applying control variables, but before exf_diagnostics_fill.
C     Therefore, we DO it exactly here:
      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
        DO j = 1-OLy,sNy+OLy
         DO i = 1-OLx,sNx+OLx
          hflux(i,j,bi,bj) = hflux(i,j,bi,bj) + swflux(i,j,bi,bj)
         ENDDO
        ENDDO
       ENDDO
      ENDDO
# endif /* SHORTWAVE_HEATING */
#endif /* ALLOW_ATM_TEMP */

C     Diagnostics output
      CALL EXF_DIAGNOSTICS_FILL( myTime, myIter, myThid )

C     Monitor output
      CALL EXF_MONITOR( myTime, myIter, myThid )

C     Map the forcing fields onto the corresponding model fields.
      CALL EXF_MAPFIELDS( myTime, myIter, myThid )

#ifdef ALLOW_AUTODIFF
# ifdef ALLOW_AUTODIFF_MONITOR
      IF ( .NOT. useSEAICE )
     &     CALL EXF_ADJOINT_SNAPSHOTS( 3, myTime, myIter, myThid )
# endif
#endif /* ALLOW_AUTODIFF */

      RETURN
      END

module gcm_params_mod

!use fms_mod, only: write_version_number

implicit none
private

!  ---- public interfaces ----

real,    public :: gcm_unset_RS = 0.
real,    public :: gcm_unset_RL = 0.
integer, public :: gcm_unset_I  = 0
integer, public, parameter :: gcm_LEN_MBUF = 512
integer, public, parameter :: gcm_LEN_FNAM = 512
integer, public, parameter :: gcm_LEN_PREC = 200
character*1, public :: gcm_SQZ_R = ' '
character*1, public :: gcm_SQZ_L = ' '
character*1, public :: gcm_SQZ_B = ' '
integer, public :: gcm_precFloat32 = 0
integer, public :: gcm_precFloat64 = 0
integer, public :: gcm_debLev0  = 0
integer, public :: gcm_debLevA  = 0
integer, public :: gcm_debLevB  = 0
integer, public :: gcm_debLevC  = 0
integer, public :: gcm_debLevD  = 0
integer, public :: gcm_debLevE  = 0
integer, public :: gcm_stdMsgUnit = 0
integer, public :: gcm_errMsgUnit = 0
integer, public :: gcm_debugLevel = 0
logical, public :: gcm_debugMode = .FALSE.

public gcm_params_init

contains

! <SUBROUTINE NAME="gcm_params_init">

!   <OVERVIEW>
!     Initialization routine. The purpose of this routine
!     is initialize the GCM PARAMS module from EEPARAMS.h & PARAMS.h
!     commom bloc values which are passed as argument to this routine.
!   </OVERVIEW>
!   <DESCRIPTION>
!   </DESCRIPTION>
!   <TEMPLATE>
!     call gcm_params_init( ... )
!   </TEMPLATE>

subroutine gcm_params_init(                                          &
               inp_unset_RS, inp_unset_RL, inp_unset_I,              &
!              inp_LEN_MBUF, inp_LEN_FNAM, inp_LEN_PREC,             &
               inp_SQZ_R, inp_SQZ_L, inp_SQZ_B,                      &
               inp_precFloat32, inp_precFloat64,                     &
               inp_debLev0, inp_debLevA, inp_debLevB,                &
               inp_debLevC, inp_debLevD, inp_debLevE,                &
               inp_stdMsgUnit, inp_errMsgUnit,                       &
               inp_debugLevel, inp_debugMode,                        &
               myThid )

#ifdef LET_RS_BE_REAL4
  real*4,  intent(in) :: inp_unset_RS
#else
  real*8,  intent(in) :: inp_unset_RS
#endif
  real,    intent(in) :: inp_unset_RL
  integer, intent(in) :: inp_unset_I
! integer, intent(in) :: inp_LEN_MBUF
! integer, intent(in) :: inp_LEN_FNAM
! integer, intent(in) :: inp_LEN_PREC
  character*1, intent(in) :: inp_SQZ_R
  character*1, intent(in) :: inp_SQZ_L
  character*1, intent(in) :: inp_SQZ_B
  integer, intent(in) :: inp_precFloat32
  integer, intent(in) :: inp_precFloat64
  integer, intent(in) :: inp_debLev0
  integer, intent(in) :: inp_debLevA
  integer, intent(in) :: inp_debLevB
  integer, intent(in) :: inp_debLevC
  integer, intent(in) :: inp_debLevD
  integer, intent(in) :: inp_debLevE
  integer, intent(in) :: inp_stdMsgUnit
  integer, intent(in) :: inp_errMsgUnit
  integer, intent(in) :: inp_debugLevel
  logical, intent(in) :: inp_debugMode

  integer, intent(in) :: myThid

   gcm_unset_RS    = inp_unset_RS
   gcm_unset_RL    = inp_unset_RL
   gcm_unset_I     = inp_unset_I
!  gcm_LEN_MBUF    = inp_LEN_MBUF
!  gcm_LEN_FNAM    = inp_LEN_FNAM
!  gcm_LEN_PREC    = inp_LEN_PREC
   gcm_SQZ_R       = inp_SQZ_R
   gcm_SQZ_L       = inp_SQZ_L
   gcm_SQZ_B       = inp_SQZ_B
   gcm_precFloat32 = inp_precFloat32
   gcm_precFloat64 = inp_precFloat64
   gcm_debLev0     = inp_debLev0
   gcm_debLevA     = inp_debLevA
   gcm_debLevB     = inp_debLevB
   gcm_debLevB     = inp_debLevC
   gcm_debLevD     = inp_debLevD
   gcm_debLevE     = inp_debLevE
   gcm_stdMsgUnit  = inp_stdMsgUnit
   gcm_errMsgUnit  = inp_errMsgUnit
   gcm_debugLevel  = inp_debugLevel
   gcm_debugMode   = inp_debugMode

end subroutine gcm_params_init
! </SUBROUTINE>

!-----------------------------------------------------------------------

end module gcm_params_mod

#include "CPP_EEOPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 0
C !ROUTINE: MDS_BUFFERtoRS

C !INTERFACE:
      SUBROUTINE MDS_BUFFERtoRS( vecBuf, arr, narr, copyTo, myThid )

C !DESCRIPTION:
C Copy from Buffer to RS array "arr", if copyTo=T ; otherwise do the reverse

C !USES:
      IMPLICIT NONE
c#include "EEPARAMS.h"

C !INPUT/OUTPUT PARAMETERS:
C vecBuf ( RL )    :: buffer vector array (Input/Output if copyTo=T/F)
C arr    ( RS )    :: model  vector array (Output/Input if copyTo=T/F)
C narr   (integer) :: dimension of buffer & model vector array
C copyTo (logical) :: if =T, copy buffer -> model ; if =F: copy buffer <- model
C myThid (integer) :: my Thread Id number
      INTEGER narr
      _RL vecBuf(narr)
      _RS arr(narr)
      LOGICAL copyTo
      INTEGER myThid
CEOP

C !LOCAL VARIABLES:
      INTEGER L

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      IF (copyTo) THEN
        DO L=1,narr
         arr(L) = vecBuf(L)
        ENDDO
      ELSE
        DO L=1,narr
          vecBuf(L) = arr(L)
        ENDDO
      ENDIF

      RETURN
      END

#include "MONITOR_OPTIONS.h"
#ifdef ALLOW_AUTODIFF
# include "AUTODIFF_OPTIONS.h"
#endif
#ifdef ALLOW_CTRL
# include "CTRL_OPTIONS.h"
#endif
#include "AD_CONFIG.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: MONITOR

C     !INTERFACE:
      SUBROUTINE G_MONITOR(
     I                      myTime, myIter, myThid )

C     !DESCRIPTION:
C     Monitor key dynamical variables: calculate over the full domain
C      some simple statistics (e.g., min,max,average) and write them.

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "DYNVARS.h"
#include "FFIELDS.h"
#include "MONITOR.h"
#ifdef ALLOW_MNC
# include "MNC_PARAMS.h"
#endif
#ifdef ALLOW_AUTODIFF_MONITOR
# include "g_common.h"
#endif

C     !INPUT PARAMETERS:
      _RL myTime
      INTEGER myIter
      INTEGER myThid
CEOP

#if (defined (ALLOW_TANGENTLINEAR_RUN) || defined (ALLOW_ADMTLM))
#ifdef ALLOW_AUTODIFF_MONITOR

C     === Functions ====
      LOGICAL  DIFFERENT_MULTIPLE
      EXTERNAL DIFFERENT_MULTIPLE
      LOGICAL  MASTER_CPU_IO
      EXTERNAL MASTER_CPU_IO

C     !LOCAL VARIABLES:
      CHARACTER*(MAX_LEN_MBUF) msgBuf
c     _RL dT
      _RL dummyRL(6)
      INTEGER k

      IF ( DIFFERENT_MULTIPLE(adjMonitorFreq,myTime,deltaTClock) ) THEN

        IF ( MASTER_CPU_IO(myThid) ) THEN
C--   only the master thread is allowed to switch On/Off mon_write_stdout
C     & mon_write_mnc (since it is the only thread that uses those flags):

          IF (monitor_stdio) THEN
            mon_write_stdout = .TRUE.
          ELSE
            mon_write_stdout = .FALSE.
          ENDIF
          mon_write_mnc = .FALSE.
#ifdef ALLOW_MNC
          IF (useMNC .AND. monitor_mnc) THEN
            DO k = 1,MAX_LEN_MBUF
              mon_fname(k:k) = ' '
            ENDDO
            mon_fname(1:9) = 'g_monitor'
            CALL MNC_CW_APPEND_VNAME(
     &           'T', '-_-_--__-__t', 0,0, myThid)
            CALL MNC_CW_SET_UDIM(mon_fname, -1, myThid)
            CALL MNC_CW_RL_W_S(
     &          'D',mon_fname,1,1,'T', myTime, myThid)
            CALL MNC_CW_SET_UDIM(mon_fname, 0, myThid)
            mon_write_mnc = .TRUE.
          ENDIF
#endif /* ALLOW_MNC */

C       Dynamics field monitor start
          IF ( mon_write_stdout ) THEN
            WRITE(msgBuf,'(2A)') '// ==========================',
     &             '============================='
            CALL PRINT_MESSAGE( msgBuf, mon_ioUnit, SQUEEZE_RIGHT , 1)
            WRITE(msgBuf,'(A)')
     &             '// Begin TL_MONITOR dynamic field statistics'
            CALL PRINT_MESSAGE( msgBuf, mon_ioUnit, SQUEEZE_RIGHT , 1)
            WRITE(msgBuf,'(2A)') '// ==========================',
     &             '============================='
            CALL PRINT_MESSAGE( msgBuf, mon_ioUnit, SQUEEZE_RIGHT , 1)
          ENDIF

C--   endif master cpu io
        ENDIF

C       Print the time to make grepping the stdout easier
        CALL MON_SET_PREF('g__time',myThid)
        CALL MON_OUT_I( '_tsnumber', myIter,mon_string_none,myThid)
        CALL MON_OUT_RL('_secondsf', myTime,mon_string_none,myThid)

C       Print the basic statistics of model state variables
        CALL MON_SET_PREF('g__dynstat',myThid)

        CALL MON_WRITESTATS_RL(  1, g_etaN, '_g_eta',
     &           maskInC, maskInC, rA , drF, dummyRL, myThid )
        CALL MON_WRITESTATS_RL( Nr, g_uVel, '_g_uvel',
     &           hFacW, maskInW, rAw, drF, dummyRL, myThid )
        CALL MON_WRITESTATS_RL( Nr, g_vVel, '_g_vvel',
     &           hFacS, maskInS, rAs, drF, dummyRL, myThid )
        CALL MON_WRITESTATS_RL( Nr, g_wVel, '_g_wvel',
     &           maskC, maskInC, rA , drC, dummyRL, myThid )
        CALL MON_WRITESTATS_RL( Nr, g_theta,'_g_theta',
     &           hFacC, maskInC, rA , drF, dummyRL, myThid )
        CALL MON_WRITESTATS_RL( Nr, g_salt, '_g_salt',
     &           hFacC, maskInC, rA , drF, dummyRL, myThid )
        IF ( nSx.EQ.1 .AND. nSy.EQ.1 ) THEN
C-      print stats only if nSx=nSy=1 since otherwise stats are wrong
         k = 1
         IF ( usingPCoords ) k = Nr
         CALL MON_WRITESTATS_RL( 1,g_theta(1-OLx,1-OLy,k,1,1),'_g_sst',
     &            maskInC, maskInC, rA , drF, dummyRL, myThid )
         CALL MON_WRITESTATS_RL( 1, g_salt(1-OLx,1-OLy,k,1,1),'_g_sss',
     &            maskInC, maskInC, rA , drF, dummyRL, myThid )
        ENDIF

C       Print the basic statistics of external forcing
        IF ( monitorSelect.GE.4 ) THEN
         CALL MON_SET_PREF('g__forcing',myThid)
         CALL MON_WRITESTATS_RS( 1, g_Qnet, '_g_qnet',
     &            maskInC, maskInC, rA , drF, dummyRL, myThid )
#ifdef SHORTWAVE_HEATING
         CALL MON_WRITESTATS_RS( 1, g_Qsw , '_g_qsw',
     &            maskInC, maskInC, rA , drF, dummyRL, myThid )
#endif
         CALL MON_WRITESTATS_RS( 1, g_EmPmR,'_g_empmr',
     &            maskInC, maskInC, rA , drF, dummyRL, myThid )
         CALL MON_WRITESTATS_RS( 1, g_fu ,  '_g_fu',
     &            maskInW, maskInW, rAw, drF, dummyRL, myThid )
         CALL MON_WRITESTATS_RS( 1, g_fv ,  '_g_fv',
     &            maskInS, maskInS, rAs, drF, dummyRL, myThid )
        ENDIF

C       Print the numerical stablility parameters for current state
c       CALL MON_SET_PREF('g__g_vcfl',myThid)
c       dT = MAX(dTtracerLev(1),deltaTMom)
c       CALL MON_ADVCFL( '_g_uvel', g_uVel,recip_dxC,dT,myThid )
c       CALL MON_ADVCFL( '_g_vvel', g_vVel,recip_dyC,dT,myThid )
c       CALL MON_ADVCFLW( '_g_wvel',g_wVel,recip_drC,dT,myThid )
c       CALL MON_ADVCFLW2('_g_W_hf',g_wVel,recip_hFacC,
c    &                                     recip_drF,dT,myThid )

C       Dynamics field monitor finish
        IF ( MASTER_CPU_IO(myThid) ) THEN
C--   only the master thread is allowed to switch On/Off mon_write_stdout
C     & mon_write_mnc (since it is the only thread that uses those flags):

          IF ( mon_write_stdout ) THEN
            WRITE(msgBuf,'(2A)') '// ==========================',
     &             '============================='
            CALL PRINT_MESSAGE( msgBuf, mon_ioUnit, SQUEEZE_RIGHT , 1)
            WRITE(msgBuf,'(A)')
     &             '// End TL_MONITOR dynamic field statistics'
            CALL PRINT_MESSAGE( msgBuf, mon_ioUnit, SQUEEZE_RIGHT , 1)
            WRITE(msgBuf,'(2A)') '// ==========================',
     &             '============================='
            CALL PRINT_MESSAGE( msgBuf, mon_ioUnit, SQUEEZE_RIGHT , 1)
          ENDIF

          mon_write_stdout = .FALSE.
          mon_write_mnc    = .FALSE.

C--   endif master cpu io
        ENDIF

C     endif different multiple
      ENDIF

#endif /* ALLOW_AUTODIFF_MONITOR */
#endif /* ALLOW_TANGENTLINEAR_RUN */

      RETURN
      END

#include "FRAZIL_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 0
C !ROUTINE: FRAZIL_INIT_FIXED

C !INTERFACE:
      SUBROUTINE FRAZIL_INIT_FIXED( myThid )

C     !DESCRIPTION:
C     Initialize FRAZIL variables that are kept fixed during the run

C     !USES:
      IMPLICIT NONE
#include "EEPARAMS.h"
#include "SIZE.h"
#include "PARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     myThid :: my Thread Id number
      INTEGER myThid
CEOP

#ifdef ALLOW_DIAGNOSTICS
      IF ( useDiagnostics ) THEN
        CALL FRAZIL_DIAGNOSTICS_INIT( myThid )
      ENDIF
#endif

      RETURN
      END

#include "GRIDALT_OPTIONS.h"

       SUBROUTINE MAKE_PHYS_GRID(drF,hfacC,im1,im2,jm1,jm2,Nr,
     & nSx,nSy,i1,i2,j1,j2,bi,bj,Nrphys,Lbot,dpphys,numlevphys,nlperdyn)
C***********************************************************************
C SUBROUTINE MAKE_PHYS_GRID
C
C Purpose: Define the grid that the will be used to run the high-end
C          atmospheric physics.
C
C Algorithm: Fit additional levels of some (~) known thickness in
C          between existing levels of the grid used for the dynamics
C
C Need:    Information about the dynamics grid vertical spacing
C
C Input:   drF         - delta r (p*) edge-to-edge
C          hfacC       - fraction of grid box above topography
C          im1, im2    - beginning and ending i - dimensions
C          jm1, jm2    - beginning and ending j - dimensions
C          Nr          - number of levels in dynamics grid
C          nSx,nSy     - number of processes in x and y direction
C          i1, i2      - beginning and ending i - index to fill
C          j1, j2      - beginning and ending j - index to fill
C          bi, bj      - x-dir and y-dir index of process
C          Nrphys      - number of levels in physics grid
C
C Output:  dpphys      - delta r (p*) edge-to-edge of physics grid
C          numlevphys  - number of levels used in the physics
C          nlperdyn    - physics level number atop each dynamics layer
C
C NOTES: 1) Pressure levs are built up from bottom, using p0, ps and dp:
C              p(i,j,k)=p(i,j,k-1) + dp(k)*ps(i,j)/p0(i,j)
C        2) Output dp(s) are aligned to fit EXACTLY between existing
C           levels of the dynamics vertical grid
C        3) IMPORTANT! This routine assumes the levels are numbered
C           from the bottom up, ie, level 1 is the surface.
C           IT WILL NOT WORK OTHERWISE!!!
C        4) This routine does NOT work for surface pressures less
C           (ie, above in the atmosphere) than about 350 mb
C***********************************************************************

       IMPLICIT NONE

       integer im1,im2,jm1,jm2,Nr,nSx,nSy,Nrphys
       integer i1,i2,j1,j2,bi,bj
       integer numlevphys
       _RS hfacC(im1:im2,jm1:jm2,Nr,nSx,nSy)
       _RL dpphys(im1:im2,jm1:jm2,Nrphys,nSx,nSy)
       _RS drF(Nr)
       integer Lbot(im1:im2,jm1:jm2,nSx,nSy)
       integer nlperdyn(im1:im2,jm1:jm2,Nr,nSx,nSy)

       integer i,j,L,Lbotij,Lnew
C Require 12 (or 15) levels near the surface (300 mb worth) for fizhi.
C   the dp(s) are in the dptry arrays:
       integer ntry,ntry10,ntry40
       parameter (ntry10 = 12)
       parameter (ntry40 = 12)
       _RL dptry(15),dptry10(ntry10),dptry40(ntry40)
       _RL bot_thick,bot_thick40
       _RL dptry_accum(15)
       data dptry10/300.000,600.000,1000.000,1400.000,1700.000,2500.000,
     &            2500.000,2500.000,2500.000,5000.000,5000.000,5000.000/
       data dptry40/300.000,600.000, 800.000, 800.000,1250.000,
     &            1250.000,2500.000,2500.000,2500.000,2500.000,2500.000,
     &            2500.000/
       data bot_thick40/20000.000/
       _RL deltap, dpstar_accum
       integer nlbotmax, nstart, nlevs, nlphys, ndone
       _RL thindp

       if( (Nr.eq.10) .or. (Nr.eq.20) ) then
        ntry = ntry10
        bot_thick = bot_thick40
        do L = 1,ntry
         dptry(L) = dptry10(L)
        enddo
       elseif((Nr.eq.40).or.(Nr.eq.46).or.(Nr.eq.70)) then
        ntry = ntry40
        bot_thick = bot_thick40
        do L = 1,ntry
         dptry(L) = dptry40(L)
        enddo
       else
        print *,' Dont know how to make fizhi grid '
        stop
       endif

       thindp=100.
       if(Nr.eq.70)thindp=0.02

       do L = 1,Nr
        do j = j1,j2
        do i = i1,i2+1
         nlperdyn(i,j,L,bi,bj) = 0
        enddo
        enddo
       enddo

C Figure out how many physics levels there will be
C   (need 12 between sfc and 300 mb above it - see how many
C    there are in the dynamics if the surface pressure is at
C    the sum of drF, ie, the maximum dynamics grid layers possible)
       nlevs = 0
       dpstar_accum = 0.
       do L = 1,Nr
        dpstar_accum = dpstar_accum + drF(L)
        if(dpstar_accum.le.bot_thick) nlevs = nlevs+1
       enddo
       numlevphys = Nr - nlevs + ntry + 1

       dptry_accum(1) = dptry(1)
       do Lnew = 2,ntry
        dptry_accum(Lnew) = dptry_accum(Lnew-1) + dptry(Lnew)
       enddo

C      do for each grid point:
       do j = j1,j2
       do i = i1,i2
        Lbotij = Lbot(i,j,bi,bj)

C Find the maximum number of physics levels to fit in the bottom level

        nlbotmax = 0
        do Lnew = 1,ntry
         if ( (nlbotmax.eq.0) .and.
     & (dptry_accum(Lnew).gt.(hfacC(i,j,Lbotij,bi,bj)*drF(Lbotij))))then
          nlbotmax = Lnew
         endif
        enddo
        if(nlbotmax.eq.0)then
         nlbotmax = ntry
        endif

C See how many of the physics levs can fit in the bottom level

        nlphys = 0
        deltap = 0.
        do Lnew = 1,nlbotmax
C Test to see if the next physics level fits, if yes, add it
         if((hfacC(i,j,Lbotij,bi,bj)*drF(Lbotij)).ge.
     &                                           deltap+dptry(Lnew))then
          nlphys = nlphys + 1
          dpphys(i,j,nlphys,bi,bj) = dptry(Lnew)
          deltap = deltap + dptry(Lnew)
         else
C If the level does not fit, decide whether to make a new thinner
C  one or make the one below a bit thicker
          if((dptry(Lnew-1)+(hfacC(i,j,Lbotij,bi,bj)*
     &             drF(Lbotij)-deltap)) .gt. (dptry(Lnew-1)*1.5) ) then
C Add a new thin layer
           nlphys = nlphys + 1
           dpphys(i,j,nlphys,bi,bj) =
     &                      (hfacC(i,j,Lbotij,bi,bj)*drF(Lbotij))-deltap
          else
C Make the one below thicker
           dpphys(i,j,nlphys,bi,bj) = dpphys(i,j,nlphys,bi,bj) +
     &                      (hfacC(i,j,Lbotij,bi,bj)*drF(Lbotij)-deltap)
          endif
          deltap = deltap+(hfacC(i,j,Lbotij,bi,bj)*drF(Lbotij)-deltap)
         endif
        enddo

        nlperdyn(i,j,Lbotij,bi,bj) = nlphys

C Now proceed upwards - see how many physics levels fit in each
C   subsequent dynamics level - go through all 12 required levels

        do L = Lbotij+1,Nr
         ndone = 0
         if(nlphys.lt.ntry)then
          deltap = 0.
          nstart = nlphys + 1
          do Lnew = nstart,ntry
           if((hfacC(i,j,L,bi,bj)*drF(L)).ge.deltap+dptry(Lnew))then
            nlphys = nlphys + 1
            dpphys(i,j,nlphys,bi,bj) = dptry(Lnew)
            deltap = deltap + dptry(Lnew)
            ndone = 0
           elseif (ndone.eq.0) then
C If the level does not fit, decide whether to make a new thinner
C  one or make the one below a bit thicker
            ndone = 1
            if( (dptry(Lnew-1)+(hfacC(i,j,L,bi,bj)*drF(L)-deltap))
     &                    .gt. (dptry(Lnew-1)*1.5) ) then
C Add a new thin layer
             nlphys = nlphys + 1
             dpphys(i,j,nlphys,bi,bj) =
     &                             (hfacC(i,j,L,bi,bj)*drF(L))-deltap
             deltap = hfacC(i,j,L,bi,bj)*drF(L)
            else
C Make the one below thicker
             dpphys(i,j,nlphys,bi,bj) = dpphys(i,j,nlphys,bi,bj) +
     &                      (hfacC(i,j,L,bi,bj)*drF(L)-deltap)
             deltap = hfacC(i,j,L,bi,bj)*drF(L)
            endif
           endif
          enddo
C Need one more peice of logic - if we finished Lnew loop and
C  now we are done adding new physics layers, we need to be sure
C  that we are at the edge of a dynamics layer. if not, we need
C  to add one more layer.
          if(nlphys.ge.ntry)then
           if(abs(deltap-hfacC(i,j,L-1,bi,bj)*drF(L-1)).gt.0.001)then
            nlphys = nlphys + 1
            dpphys(i,j,nlphys,bi,bj) = hfacC(i,j,L-1,bi,bj)*drF(L-1)
     &                                                          - deltap
           endif
          endif

         elseif(nlphys.eq.ntry)then
C Mostly done with new layers - make sure we end at dynamics edge,
C      if not, make one more thinner (thinner than dyn grid) layer
          if(abs(deltap-hfacC(i,j,L-1,bi,bj)*drF(L-1)).gt.0.001)then
           nlphys = nlphys + 1
           dpphys(i,j,nlphys,bi,bj) = hfacC(i,j,L-1,bi,bj)*drF(L-1)
     &                                                          - deltap
           nlphys = nlphys + 1
           dpphys(i,j,nlphys,bi,bj) = hfacC(i,j,L,bi,bj)*drF(L)
          else
           nlphys = nlphys + 1
           dpphys(i,j,nlphys,bi,bj) = hfacC(i,j,L,bi,bj)*drF(L)
          endif
         else
C we are done adding new physics layers, just copy the rest
C    of the dynamics grid onto the physics grid
          nlphys = nlphys + 1
          dpphys(i,j,nlphys,bi,bj) = hfacC(i,j,L,bi,bj)*drF(L)
         endif
         nlperdyn(i,j,L,bi,bj) = nlphys
        enddo

C  All done adding layers - if we need more to make numlevphys, put
C     them as thin (1 mb) layers near the top
       if(nlphys.lt.numlevphys)then
        nlevs = numlevphys-nlphys
        dpphys(i,j,nlphys,bi,bj)=dpphys(i,j,nlphys,bi,bj)-thindp*nlevs
        do Lnew = nlphys+1,numlevphys
         dpphys(i,j,Lnew,bi,bj) = thindp
        enddo
        nlperdyn(i,j,Nr,bi,bj) = numlevphys
       endif
C END OF LOOP OVER GRID POINTS

       enddo
       enddo

       return
       end

#include "MOM_COMMON_OPTIONS.h"

      SUBROUTINE MOM_HDISSIP(
     I        bi, bj, k,
     I        tension, strain, hFacZ,
     I        viscAh_s, viscAh_t, viscA4_s, viscA4_t,
     I        harmonic, biharmonic, useVariableViscosity,
     O        uDissip, vDissip,
     I        myThid )

      IMPLICIT NONE

C     Calculate horizontal dissipation terms in terms of tension and strain
C       Du = d/dx At Tension + d/dy As Strain
C       Dv = d/dx As Strain  - d/dy At Tension

C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"

C     == Routine arguments ==
      INTEGER bi,bj,k
      _RL tension(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL strain (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RS hFacZ  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL viscAh_s(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL viscAh_t(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL viscA4_s(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL viscA4_t(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      LOGICAL harmonic, biharmonic, useVariableViscosity
      _RL uDissip(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL vDissip(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER myThid

C     == Local variables ==
      INTEGER i, j

C     - Laplacian and bi-harmonic terms
      IF (harmonic) THEN
       DO j=2-OLy,sNy+OLy-1
        DO i=2-OLx,sNx+OLx-1

         uDissip(i,j) =
     &    recip_dyG(i,j,bi,bj)*recip_dyG(i,j,bi,bj)
     &    *recip_dxC(i,j,bi,bj)
     &    *(
     &       dyF( i , j ,bi,bj)*dyF( i , j ,bi,bj)
     &         *viscAh_t( i , j )*tension( i , j )
     &      -dyF(i-1, j ,bi,bj)*dyF(i-1, j ,bi,bj)
     &         *viscAh_t(i-1, j )*tension(i-1, j )
     &     )
     &    +recip_dxC(i,j,bi,bj)*recip_dxC(i,j,bi,bj)
     &    *recip_dyG(i,j,bi,bj)
     &    *(
     &       dxV( i ,j+1,bi,bj)*dxV( i ,j+1,bi,bj)
     &         *viscAh_s(i,j+1)*strain( i ,j+1)
     &      -dxV( i , j ,bi,bj)*dxV( i , j ,bi,bj)
     &         *viscAh_s(i, j )*strain( i , j )
     &     )

         vDissip(i,j) =
     &    recip_dyC(i,j,bi,bj)*recip_dyC(i,j,bi,bj)
     &    *recip_dxG(i,j,bi,bj)
     &    *(
     &       dyU(i+1, j ,bi,bj)*dyU(i+1, j ,bi,bj)
     &         *viscAh_s(i+1,j)*strain(i+1,j)
     &      -dyU( i , j ,bi,bj)*dyU( i , j ,bi,bj)
     &         *viscAh_s( i ,j)*strain( i ,j)
     &     )
     &    -recip_dxG(i,j,bi,bj)*recip_dxG(i,j,bi,bj)
     &    *recip_dyC(i,j,bi,bj)
     &    *(
     &       dxF( i , j ,bi,bj)*dxF( i , j ,bi,bj)
     &         *viscAh_t(i, j )*tension(i, j )
     &      -dxF( i ,j-1,bi,bj)*dxF( i ,j-1,bi,bj)
     &         *viscAh_t(i,j-1)*tension(i,j-1)
     &     )

        ENDDO
       ENDDO
      ENDIF
      IF (biharmonic) THEN
       STOP 'MOM_HDISSIP: BIHARMONIC NOT ALLOWED WITH STRAIN-TENSION'
      ENDIF

      RETURN
      END

#include "MATRIX_OPTIONS.h"

C !ROUTINE MATRIX_WRITE_TENDENCY.F
C This routine writes both the explicit and implicit matrices
C to file.

      SUBROUTINE MATRIX_WRITE_TENDENCY( myTime, myIter, myThid )

      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "PTRACERS_SIZE.h"
#include "PTRACERS_PARAMS.h"
#include "MATRIX.h"

      _RL myTime
      INTEGER myIter
      INTEGER myThid

#ifdef ALLOW_MATRIX

      LOGICAL  DIFFERENT_MULTIPLE
      EXTERNAL DIFFERENT_MULTIPLE

      INTEGER bi,bj,i,j,k,iTracer,iRec
      CHARACTER*(MAX_LEN_FNAM) suff
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      _RL recipImpMatrixCounter, recipExpDeltaTtracer

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      IF ( DIFFERENT_MULTIPLE(expMatrixWriteTime,myTime,deltaTClock)
     &   ) THEN
        bj=myByLo(myThid)
        bi=myBxLo(myThid)
        recipExpDeltaTtracer = expMatrixCounter(bi,bj)*dTtracerLev(1)
        recipExpDeltaTtracer = 1. _d 0 / recipExpDeltaTtracer
        iRec = expMatrixWriteCount
        DO iTracer=1,PTRACERS_numInUse
          DO bj=myByLo(myThid),myByHi(myThid)
           DO bi=myBxLo (myThid),myBxHi(myThid)
             DO k=1,Nr
              DO j=1-OLy, sNy+OLy
               DO i=1-OLx, sNx+OLx
                 MATRIX(i,j,k,bi,bj,iTracer,1) =
     &                   MATRIX(i,j,k,bi,bj,iTracer,1)
     &                   *recipExpDeltaTtracer
               ENDDO
              ENDDO
             ENDDO
           ENDDO
          ENDDO
          _BEGIN_MASTER(myThid)
          bj=myByLo(myThid)
          bi=myBxLo(myThid)
          WRITE(msgBuf,'(A,I4,2I6)') 'Writing explicit matrix :',
     &       iTracer, expMatrixWriteCount, expMatrixCounter(bi,bj)
          CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                        SQUEEZE_RIGHT, myThid )
          _END_MASTER(myThid)
          WRITE(suff,'(A9,I2.2)') 'MATRIXEXP',iTracer
          CALL WRITE_REC_XYZ_RL(suff,
     &         MATRIX(1-OLx,1-OLy,1,1,1,iTracer,1),iRec,myIter,myThid)
        ENDDO
        _BARRIER
        _BEGIN_MASTER(myThid)
         expMatrixWriteCount = expMatrixWriteCount + 1
        _END_MASTER(myThid)

C       Reset explicit matrix
        DO bj=myByLo(myThid),myByHi(myThid)
         DO bi=myBxLo (myThid),myBxHi(myThid)
           expMatrixCounter(bi,bj) = 0
         ENDDO
        ENDDO
        DO iTracer=1,PTRACERS_numInUse
          DO bj=myByLo(myThid),myByHi(myThid)
           DO bi=myBxLo (myThid),myBxHi(myThid)
             DO k=1,Nr
              DO j=1-OLy, sNy+OLy
               DO i=1-OLx, sNx+OLx
                 MATRIX(i,j,k,bi,bj,iTracer,1) = 0. _d 0
               ENDDO
              ENDDO
             ENDDO
           ENDDO
          ENDDO
        ENDDO
      ENDIF

      IF ( DIFFERENT_MULTIPLE(impMatrixWriteTime,myTime,deltaTClock)
     &   ) THEN
        bj=myByLo(myThid)
        bi=myBxLo(myThid)
        recipImpMatrixCounter = impMatrixCounter(bi,bj)
        recipImpMatrixCounter = 1. _d 0 / recipImpMatrixCounter
        iRec = impMatrixWriteCount
        DO iTracer=1,PTRACERS_numInUse
          DO bj=myByLo(myThid), myByHi (myThid)
           DO bi=myBxLo (myThid), myBxHi (myThid)
             DO k=1,Nr
              DO j=1-OLy, sNy+OLy
               DO i=1-OLx, sNx+OLx
                 MATRIX(i,j,k,bi,bj,iTracer,2) =
     &                   MATRIX(i,j,k,bi,bj,iTracer,2)
     &                   *recipImpMatrixCounter
               ENDDO
              ENDDO
             ENDDO
           ENDDO
          ENDDO
          _BEGIN_MASTER(myThid)
          bj=myByLo(myThid)
          bi=myBxLo(myThid)
          WRITE(msgBuf,'(A,I4,2I6)') 'Writing implicit matrix :',
     &       iTracer, impMatrixWriteCount, impMatrixCounter(bi,bj)
          CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                        SQUEEZE_RIGHT, myThid )
          _END_MASTER(myThid)
          WRITE(suff,'(A9,I2.2)') 'MATRIXIMP',iTracer
          CALL WRITE_REC_XYZ_RL(suff,
     &         MATRIX(1-OLx,1-OLy,1,1,1,iTracer,2),iRec,myIter,myThid)
        ENDDO
        _BARRIER
        _BEGIN_MASTER(myThid)
         impMatrixWriteCount = impMatrixWriteCount + 1
        _END_MASTER(myThid)

C       Reset implicit matrix
        DO bj=myByLo(myThid),myByHi(myThid)
         DO bi=myBxLo (myThid),myBxHi(myThid)
           impMatrixCounter(bi,bj) = 0
         ENDDO
        ENDDO
        DO iTracer=1,PTRACERS_numInUse
          DO bj=myByLo(myThid), myByHi (myThid)
           DO bi=myBxLo (myThid), myBxHi (myThid)
             DO k=1,Nr
              DO j=1-OLy, sNy+OLy
               DO i=1-OLx, sNx+OLx
                 MATRIX(i,j,k,bi,bj,iTracer,2) = 0. _d 0
               ENDDO
              ENDDO
             ENDDO
           ENDDO
          ENDDO
        ENDDO
      ENDIF

#endif /* ALLOW_MATRIX */
      RETURN
      END

#include "FIZHI_OPTIONS.h"
      SUBROUTINE QCHECK ( idim1,idim2,jdim1,jdim2,ldim,Nsx,Nsy,im1,im2,
     .     jm1,jm2,bi,bj,dp,qz)
C***********************************************************************
C  Purpose
C     Check Specific Humidity Field for Negative values
C
C  Argument Description
C     IDIM1 .... Start Zonal Dimension
C     IDIM2 .... End Zonal Dimension
C     JDIM1 .... Start Meridional Dimension
C     JDIM2 .... End Meridional Dimension
C     IM1 ...... Start Zonal Span
C     IM2 ...... End Zonal Span
C     JM1 ...... Start Meridional Span
C     JM2 ...... End Meridional Span
C     LDIM ..... Vertical   Dimension
C     DP ....... Delta Pressure
C     QZ ........Specific Humidity (g/g)
C***********************************************************************
      implicit none

      integer idim1,idim2,jdim1,jdim2,Ldim,im1,im2,jm1,jm2
      integer Nsx,Nsy,bi,bj
      _RL qz(idim1:idim2,jdim1:jdim2,ldim,Nsx,Nsy)
      _RL dp(idim1:idim2,jdim1:jdim2,ldim,Nsx,Nsy)

      integer i,j,L,LM1
      _RL ddsig

c Fill Negative Specific Humidities
c ---------------------------------
      DO L=2,Ldim
      LM1 = L-1
      do j=jm1,jm2
      do i=im1,im2
       ddsig = dp(i,j,LM1,bi,bj)/dp(i,j,L,bi,bj)
       if( qz(i,j,LM1,bi,bj).lt.0.0  _d 0) then
        qz(i,j,L,bi,bj  ) = qz(i,j,L,bi,bj) + qz(i,j,LM1,bi,bj)*ddsig
        qz(i,j,LM1,bi,bj) = 0.0 _d 0
       endif
      enddo
      enddo
      enddo

      do j=jm1,jm2
      do i=im1,im2
       if(qz(i,j,Ldim,bi,bj).lt.0.0  _d 0)qz(i,j,Ldim,bi,bj) = 0.0 _d 0
      enddo
      enddo

      return
      end

      subroutine tracer_fill ( pq,im,jm,lm,dlam,dphi,dp)
C***********************************************************************
C  PURPOSE
C     Fill negative tracer values using local borrowing
C
C  INPUT
C     pq ..... Mass-weighted (PI) Tracer
C     im ..... Zonal      Dimension
C     jm ..... Meridional Dimension
C     lm ..... Vertical   Dimension
C     dlam ... Zonal      Grid Increment
C     dphi ... Meridional Grid Increment
C     dp ..... Vertical   Grid Increment
C
C  Note:
C     If no immediate surrounding value is large enough to fill negative
C     value,
C     the sum of immediate surrounding positive values is tried.
C     If sum is not large enough, tracer is simply set to zero.
C
C***********************************************************************

      implicit none

c Input Variables
c ---------------
      integer im,jm,lm
      _RL    pq(im,jm,lm),dlam(im),dphi(jm),dp(im,jm,lm)

c Local Variables
c ---------------
      integer  i,j,l,im1,ip1,imax,m
      _RL     lam(im), phi(jm)
      _RL     array(6)
      _RL     pi,a,getcon,undef
      _RL     qmax,qval,sum,fact

      _RL        dxu(im,jm)
      _RL        dxv(im,jm)
      _RL        dxp(im,jm)
      _RL        dyv(im,jm)
      _RL        dyp(im,jm)

      _RL d2p(im,jm)

C *********************************************************
C ****                 Initialization                  ****
C *********************************************************

      pi = 4.0*atan(1.0)
      a  = getcon('EARTH RADIUS')

c Compute Longitudes
c ------------------
      lam(1) = -pi
      do i=2,im
      lam(i) = lam(i-1) + dlam(i-1)
      enddo

c Compute Latitudes
c -----------------
      phi(1) = -pi/2.
      do j=2,jm-1
      phi(j) = phi(j-1) + dphi(j-1)
      enddo
      phi(jm) =  pi/2.

c Compute DXU and DYV
c -------------------
      do j=2,jm-1
      do i=1,im
      dxu(i,j) = a*cos(phi(j))*dlam(i)
      enddo
      enddo

      do j=2,jm-2
      do i=1,im
      dyv(i,j) = a*dphi(j)
      enddo
      enddo
      do i=1,im
      dyv(i,1)    = a*(dphi(1)   +0.5*dphi(2)   )
      dyv(i,jm-1) = a*(dphi(jm-1)+0.5*dphi(jm-2))
      enddo

c Compute DXP and DXV
c -------------------
      do j=2,jm-1
      im1 =  im
      do i=1,im
      dxp(i,j) = ( dxu(i,j)+dxu(im1,j) )*0.5
      im1 = i
      enddo
      enddo

      do j=2,jm-2
      do i=1,im
      dxv(i,j) = ( dxp(i,j)+dxp(i,j+1) )*0.5
      enddo
      enddo

c Compute DYP
c -----------
      do j=3,jm-2
      do i=1,im
      dyp(i,j) = ( dyv(i,j)+dyv(i,j-1) )*0.5
      enddo
      enddo
      do i=1,im
      dyp(i,2)    = dyv(i,1)
      dyp(i,jm-1) = dyv(i,jm-1)
      enddo

c Compute Area Factor D2P
c -----------------------
      do j=3,jm-2
      do i=1,im
      d2p(i,j) = 0.5*( dxv(i,j)+dxv(i,j-1) )*dyp(i,j)
      enddo
      enddo
      do i=1,im
      d2p(i,2)    = dxv(i,2)   *dyp(i,2)
      d2p(i,jm-1) = dxv(i,jm-2)*dyp(i,jm-1)
      enddo

      undef = getcon('UNDEF')

C *********************************************************
C ****             Fill Negative Values                ****
C *********************************************************

      do l=1,lm
      do j=2,jm-1

      im1 = im-1
      i   = im
      do ip1=1,im

      if( pq(i,j,L).lt.0.0 ) then

      qval     = pq(i  ,j,L)*d2p(i  ,j)*dp(i,j,L)
      array(1) = pq(ip1,j,L)*d2p(ip1,j)*dp(i,j,L)
      array(2) = pq(im1,j,L)*d2p(im1,j)*dp(i,j,L)

      if( j.eq.jm-1 ) then
      array(3) = -undef
      else
      array(3) = pq(i,j+1,L)*d2p(i,j+1)*dp(i,j,L)
      endif
      if( j.eq.2    ) then
      array(4) = -undef
      else
      array(4) = pq(i,j-1,L)*d2p(i,j-1)*dp(i,j,L)
      endif
      if( L.eq.1    ) then
      array(5) = -undef
      else
      array(5) = pq(i,j,L-1)*d2p(i,j)*dp(i,j,L)
      endif
      if( L.eq.lm   ) then
      array(6) = -undef
      else
      array(6) = pq(i,j,L+1)*d2p(i,j)*dp(i,j,L)
      endif

      call maxval1 (array,6,-qval,qmax,imax)

      if( imax.eq.0 ) then
          sum = 0.0
          do m=1,6
          if( array(m).gt.0.0 ) sum = sum + array(m)
          enddo
             if( sum.gt.-qval ) then
               fact = 1.0 + qval/sum
               if( array(1).gt.0 ) pq(ip1,j,L) = pq(ip1,j,L) * fact
               if( array(2).gt.0 ) pq(im1,j,L) = pq(im1,j,L) * fact
               if( array(3).gt.0 ) pq(i,j+1,L) = pq(i,j+1,L) * fact
               if( array(4).gt.0 ) pq(i,j-1,L) = pq(i,j-1,L) * fact
               if( array(5).gt.0 ) pq(i,j,L-1) = pq(i,j,L-1) * fact
               if( array(6).gt.0 ) pq(i,j,L+1) = pq(i,j,L+1) * fact
                                   pq(i,j,L)   = 0.0
             else
               pq(i,j,L) = 0.0
             endif
      else
          if( imax.eq.1 ) pq(ip1,j,L) = pq(ip1,j,L) +
     .                                 pq(i,j,L)*d2p(i,j)/d2p(ip1,j)
          if( imax.eq.2 ) pq(im1,j,L) = pq(im1,j,L) +
     .                                 pq(i,j,L)*d2p(i,j)/d2p(im1,j)
          if( imax.eq.3 ) pq(i,j+1,L) = pq(i,j+1,L) +
     .                                 pq(i,j,L)*d2p(i,j)/d2p(i,j+1)
          if( imax.eq.4 ) pq(i,j-1,L) = pq(i,j-1,L) +
     .                                 pq(i,j,L)*d2p(i,j)/d2p(i,j-1)
          if( imax.eq.5 ) pq(i,j,L-1) = pq(i,j,L-1) +
     .                                 pq(i,j,L)*dp(i,j,L) /dp(i,j,L-1)
          if( imax.eq.6 ) pq(i,j,L+1) = pq(i,j,L+1) +
     .                                 pq(i,j,L)*dp(i,j,L) /dp(i,j,L+1)
                          pq(i,j,L)   = 0.0
      endif

      endif  ! End pq<0 Test

      im1 = i
      i   = ip1
      enddo
      enddo
      enddo

      return
      end

      subroutine maxval1 (q,im,qval,qmax,imax)
C***********************************************************************
C  PURPOSE
C     Find the location and value of the array element which is greater
C     than a prescribed value.
C
C  INPUT
C     q ...... Array Elements
C     im ..... Dimension of Array q
C     qval ... Prescribed Value
C
C  OUTPUT
C     qmax ... Largest Array element which is greater than qval
C     imax ... Location of Largest Array Element
C
C  Note:
C     If no array element is larger than qval, then imax = 0
C
C***********************************************************************
      implicit none
      integer  im, i, imax
      _RL   q(im), qmax, qval
      qmax = qval
      imax = 0
      do i=1,im
      if( q(i).gt.qmax ) then
      qmax = q(i)
      imax =   i
      endif
      enddo
      return
      end

#include "OBSFIT_OPTIONS.h"

CBOP
C     !ROUTINE: OBSFIT_INIT_EQUIFILES

C     !INTERFACE:
      SUBROUTINE OBSFIT_INIT_EQUIFILES(
     I                                  num_file,
     I                                  fid1,
     I                                  file2,
     O                                  fid2,
     I                                  length,
     I                                  bi,
     I                                  bj,
     I                                  myThid )

C     !DESCRIPTION:
C     ==================================================================
C     | Initialization of model counterparts files
C     | for ObsFit observations
C     ==================================================================

C !USES:
      IMPLICIT NONE
C     == Global variables ===
#include "EEPARAMS.h"
#include "SIZE.h"
#include "GRID.h"
#include "DYNVARS.h"
#ifdef ALLOW_OBSFIT
# include "OBSFIT_SIZE.h"
# include "OBSFIT.h"
# include "netcdf.inc"
#endif

C     !INPUT PARAMETERS:
C     myThid: my thread ID number
      INTEGER num_file, length, fid1, fid2
      CHARACTER*(*) file2
      INTEGER bi, bj, myThid
CEOP

#ifdef ALLOW_OBSFIT
C     !LOCAL VARIABLES:
      INTEGER dimid, varID(3), varID0
      INTEGER irec, err
      _RL tmp_vec(2)
      CHARACTER*(MAX_LEN_MBUF) msgBuf

      IF (obsfitDoNcOutput) THEN

C Create a netcdf file
        err = NF_CREATE( file2, NF_CLOBBER, fid2 )
        CALL OBSFIT_NF_ERROR( 'INIT_EQUIFILE: NF_CREATE fid2',
     &       err,bi,bj,myThid )
        err = NF_DEF_DIM( fid2, 'iSAMPLE', length, dimid )
        CALL OBSFIT_NF_ERROR( 'INIT_EQUIFILE: NF_DEF_DIM sample',
     &       err,bi,bj,myThid )
        err = NF_DEF_VAR( fid2, 'sample_ind_glob',
     &        NF_INT, 1, dimid, varID(1) )
        CALL OBSFIT_NF_ERROR( 'INIT_EQUIFILE: NF_DEF_VAR sample',
     &       err,bi,bj,myThid )
        err = NF_PUT_ATT_INT( fid2, varID(1), '_FillValue',
     &        NF_INT, 1, 0 )
        CALL OBSFIT_NF_ERROR( 'INIT_EQUIFILE: NF_PUT_ATT_INT sample',
     &       err,bi,bj,myThid )

        err = NF_INQ_VARID( fid1, obsfit_nameval, varID0 )
        IF (err.EQ.NF_NOERR) THEN

          err = NF_DEF_VAR( fid2, obsfit_nameequi,
     &          NF_DOUBLE, 1, dimid, varID(2) )
          CALL OBSFIT_NF_ERROR( 'INIT_EQUIFILE: NF_DEF_VAR val',
     &         err,bi,bj,myThid )
          err = NF_PUT_ATT_DOUBLE( fid2,varID(2),
     &          '_FillValue', NF_DOUBLE, 1, 0. _d 0 )
          CALL OBSFIT_NF_ERROR( 'INIT_EQUIFILE: NF_PUT_ATT_INT val',
     &         err,bi,bj,myThid )

          err = NF_DEF_VAR( fid2, obsfit_namemask,
     &          NF_DOUBLE, 1, dimid, varID(3) )
          CALL OBSFIT_NF_ERROR( 'INIT_EQUIFILE: NF_DEF_VAR mask',
     &         err,bi,bj,myThid )
          err = NF_PUT_ATT_DOUBLE( fid2, varID(3),
     &          '_FillValue', NF_DOUBLE, 1, 0. _d 0 )
          CALL OBSFIT_NF_ERROR( 'INIT_EQUIFILE: NF_PUT_ATT_INT mask',
     &         err,bi,bj,myThid )

        ELSE
            WRITE( msgBuf,'(2A)' )
     &          'S/R OBSFIT_INIT_EQUIFILES: no variable obs_val'
            CALL PRINT_MESSAGE( msgBuf,
     &           standardMessageUnit, SQUEEZE_RIGHT, myThid )
            WRITE( msgBuf,'(2A)' )
     &           'INIT_EQUIFILES: NF_INQ_VARID obs_val'
            CALL OBSFIT_NF_ERROR( msgBuf, err, bi, bj, myThid )

        ENDIF

        err = NF_ENDDEF( fid2 )
        CALL OBSFIT_NF_ERROR( 'INIT_EQUIFILES: NF_ENDDEF fid2',
     &       err,bi,bj,myThid )
        err = NF_CLOSE( fid2 )
        CALL OBSFIT_NF_ERROR( 'INIT_EQUIFILES: NF_CLOSE fid2',
     &       err,bi,bj,myThid )

        err = NF_OPEN( file2,NF_WRITE,fid2 )
        CALL OBSFIT_NF_ERROR( 'INIT_EQUIFILES: NF_OPEN'//file2//')',
     &       err,bi,bj,myThid )

      ELSE !IF (obsfitDoNcOutput)

C Create a binary file
        OPEN( fid2, FILE=file2, FORM='unformatted', STATUS='unknown',
     &   ACCESS='direct', RECL=2*WORDLENGTH*2 )

        DO irec = 1, 2
          tmp_vec(irec) = zeroRL
        ENDDO
#ifdef _BYTESWAPIO
        CALL MDS_BYTESWAPR8(2,tmp_vec)
#endif

        DO irec = length, 1, -1
          WRITE( fid2, rec=(irec*2-1) ) tmp_vec
          WRITE( fid2, rec=(irec*2) ) tmp_vec
        ENDDO

      ENDIF !IF (obsfitDoNcOutput)

#endif

      END

#include "EXF_OPTIONS.h"
#ifdef ALLOW_CTRL
# include "CTRL_OPTIONS.h"
#endif
#ifdef ALLOW_ECCO
# include "ECCO_OPTIONS.h"
#endif

      SUBROUTINE EXF_GETCLIM(
     I                        myTime, myIter, myThid )

c     ==================================================================
c     SUBROUTINE exf_getclim
c     ==================================================================
c
c     o Get the climatogy fields for the current time step. The switches
c       for the inclusion of the individual forcing components have to
c       be set in EXF_OPTIONS.h .
c
c       A note on surface fluxes:
c
c       The MITgcm-UV vertical coordinate z is positive upward.
c       This implies that a positive flux is out of the ocean
c       model. However, the wind stress forcing is not treated
c       this way. A positive zonal wind stress accelerates the
c       model ocean towards the east.
c
c     started: Ralf.Giering@FastOpt.de 25-Mai-2000
c
c     ==================================================================
c     SUBROUTINE exf_getclim
c     ==================================================================

      IMPLICIT NONE

c     == global variables ==
#include "EEPARAMS.h"
#include "SIZE.h"
#include "GRID.h"
#include "PARAMS.h"
#ifdef ALLOW_BULK_OFFLINE
# include "DYNVARS.h"
#endif
#include "EXF_PARAM.h"
#include "EXF_CONSTANTS.h"
#include "EXF_INTERP_SIZE.h"
#include "EXF_INTERP_PARAM.h"
#include "EXF_FIELDS.h"

c     == routine arguments ==

c     myThid - thread number for this instance of the routine.

      _RL     myTime
      INTEGER myIter
      INTEGER myThid

c     == local variables ==

      INTEGER ks
#if (defined ALLOW_CLIMSST_RELAXATION || defined ALLOW_BULK_OFFLINE )
      INTEGER i, j, bi, bj
#endif

c     == end of interface ==

      ks = 1
      IF ( usingPCoords ) ks = Nr

#ifdef ALLOW_CLIMSST_RELAXATION
c     Get values of climatological sst fields.
      CALL EXF_SET_FLD(
     I     'climsst', climsstfile, climsstmask,
     I     climsstStartTime, climsstperiod, climsstRepCycle,
     I     exf_inscal_climsst,
     I     climsst_exfremo_intercept, climsst_exfremo_slope,
     U     climsst, climsst0, climsst1,
#ifdef USE_EXF_INTERPOLATION
     I     climsst_lon0, climsst_lon_inc, climsst_lat0, climsst_lat_inc,
     I     climsst_nlon, climsst_nlat, xC, yC, climsst_interpMethod,
#endif
     I     myTime, myIter, myThid )

      DO bj = myByLo(myThid),myByHi(myThid)
       DO bi = myBxLo(myThid),myBxHi(myThid)
        DO j = 1,sNy
         DO i = 1,sNx
            IF (climsst(i,j,bi,bj) .LT. climtempfreeze) THEN
               climsst(i,j,bi,bj) = climtempfreeze
            ENDIF
         ENDDO
        ENDDO
       ENDDO
      ENDDO
c--   Update the tile edges.
      _EXCH_XY_RL(climsst, myThid)
#endif /* ALLOW_CLIMSST_RELAXATION */

#ifdef ALLOW_CLIMSSS_RELAXATION
c     Get values of climatological sss fields.
      CALL EXF_SET_FLD(
     I     'climsss', climsssfile, climsssmask,
     I     climsssStartTime, climsssperiod, climsssRepCycle,
     I     exf_inscal_climsss,
     I     climsss_exfremo_intercept, climsss_exfremo_slope,
     U     climsss, climsss0, climsss1,
#ifdef USE_EXF_INTERPOLATION
     I     climsss_lon0, climsss_lon_inc, climsss_lat0, climsss_lat_inc,
     I     climsss_nlon, climsss_nlat, xC, yC, climsss_interpMethod,
#endif
     I     myTime, myIter, myThid )
c--   Update the tile edges.
      _EXCH_XY_RL(climsss, myThid)
#endif

#ifdef ALLOW_CLIMSTRESS_RELAXATION
c     Get values of climatological ustr fields.
      CALL EXF_SET_UV (
     I     'climustr', climustrfile, climustrmask,
     I     climustrStartTime, climustrperiod, climustrRepCycle,
     I     exf_inscal_climustr,
     I     climustr_exfremo_intercept, climustr_exfremo_slope,
     U     climustr, climustr0, climustr1,
     I     'climvstr', climvstrfile, climvstrmask,
     I     climvstrStartTime, climvstrperiod, climvstrRepCycle,
     I     exf_inscal_climvstr,
     I     climvstr_exfremo_intercept, climvstr_exfremo_slope,
     U     climvstr, climvstr0, climvstr1,
#ifdef USE_EXF_INTERPOLATION
     I     climustr_lon0, climustr_lon_inc,
     I     climustr_lat0, climustr_lat_inc,
     I     climustr_nlon, climustr_nlat, climustr_interpMethod,
     I     climvstr_lon0, climvstr_lon_inc,
     I     climvstr_lat0, climvstr_lat_inc,
     I     climvstr_nlon, climvstr_nlat, climvstr_interpMethod,
     I     uvInterp_climstr,
#endif
     I     myTime, myIter, myThid )

      CALL EXCH_UV_XY_RL( climustr, climvstr, .TRUE., myThid )
#endif /* CLIMSTRESS_RELAXATION */

#ifdef ALLOW_BULK_OFFLINE
      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
# ifdef ALLOW_CLIMSST_RELAXATION
           IF ( climsstfile .NE. ' ' .AND.
     &          climsstperiod .NE. 0. )
     &          theta(i,j,ks,bi,bj) = climsst(i,j,bi,bj)
# endif
# ifdef ALLOW_CLIMSSS_RELAXATION
           IF ( climsssfile .NE. ' ' .AND.
     &          climsssperiod .NE. 0. )
     &          salt(i,j,ks,bi,bj) = climsss(i,j,bi,bj)
# endif
# ifdef ALLOW_CLIMSTRESS_RELAXATION
           IF ( climustrfile .NE. ' ' .AND.
     &          climustrperiod .NE. 0. )
     &          uVel(i,j,ks,bi,bj) = climustr(i,j,bi,bj)
           IF ( climvstrfile .NE. ' ' .AND.
     &          climvstrperiod .NE. 0. )
     &          vVel(i,j,ks,bi,bj) = climvstr(i,j,bi,bj)
# endif
           IF ( myIter .EQ. nIter0 ) THEN
              IF ( maskC(i,j,ks,bi,bj) .NE. 0. .AND.
     &             theta(i,j,ks,bi,bj) .EQ. 0. ) THEN
                print *, 'ph-warn-exf-clim ', i, j, theta(i,j,ks,bi,bj)
cph                STOP 'in exf_getclim'
              ENDIF
           ENDIF
          ENDDO
         ENDDO
       ENDDO
      ENDDO
#endif /* ALLOW_BULK_OFFLINE */

      RETURN
      END

#include "STREAMICE_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

CBOP
      SUBROUTINE STREAMICE_INIT_VARIA( myThid )
C     /============================================================\
C     | SUBROUTINE STREAMICE_INIT_VARIA                             |
C     | o Routine to initialize STREAMICE variables.                |
C     |============================================================|
C     | Initialize STREAMICE parameters and variables.              |
C     \============================================================/
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "GRID.h"
#include "SET_GRID.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "STREAMICE.h"
#include "STREAMICE_CG.h"
#include "STREAMICE_ADV.h"

C     === Routine arguments ===
C     myThid -  Number of this instance of STREAMICE_INIT_VARIA
      INTEGER myThid
CEndOfInterface

#ifdef ALLOW_STREAMICE
C     === Local variables ===
C     I,J,bi,bj - Loop counters
      INTEGER i, j, k, bi, bj, Gi, Gj
      INTEGER col_y, col_x
      _RL slope_pos, c1, x, y, lenx, leny
      CHARACTER*(MAX_LEN_MBUF) msgBuf
#ifdef STREAMICE_3D_GLEN_CONST
      INTEGER r
#endif
#ifdef ALLOW_CTRL
      _RS     dummyRS
#endif

CEOP

C     ZERO OUT FLOATING POINT ARRAYS

      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          H_streamIce(i,j,bi,bj) = 0. _d 0
          U_streamice(i,j,bi,bj) = 0. _d 0
          V_streamice(i,j,bi,bj) = 0. _d 0
          visc_streamice(i,j,bi,bj) = 0. _d 0
          tau_beta_eff_streamice(i,j,bi,bj) = 0. _d 0
          float_frac_streamice(i,j,bi,bj) = 0. _d 0
          base_el_streamice(i,j,bi,bj) = 0. _d 0
          surf_el_streamice(i,j,bi,bj) = 0. _d 0
          area_shelf_streamice(i,j,bi,bj) = 0. _d 0
          mass_ice_streamice(i,j,bi,bj) = 0. _d 0
          BDOT_streamice(i,j,bi,bj) = 0. _d 0
          u_streamice_ext(i,j,bi,bj) = 0. _d 0
          v_streamice_ext(i,j,bi,bj) = 0. _d 0
#ifdef ALLOW_STREAMICE_TIMEDEP_FORCING
          BDOT_streamice1(i,j,bi,bj) = 0. _d 0
          streamice_bdot_maxmelt1(i,j,bi,bj) = 0. _d 0
          streamice_bglen1(i,j,bi,bj) = 0. _d 0
          streamice_beta1(i,j,bi,bj) = 0. _d 0
#endif
          streamice_bdot_depth_maxmelt_v(i,j,bi,bj) = 0. _d 0
          streamice_bdot_maxmelt_v(i,j,bi,bj) = 0. _d 0
          ADOT_streamice(i,j,bi,bj) = streamice_adot_uniform
          C_basal_friction(i,j,bi,bj) = C_basal_fric_const
#ifndef STREAMICE_3D_GLEN_CONST
          B_glen(i,j,bi,bj) = B_glen_isothermal
#else
          do k=1,Nr
           B_glen(i,j,k,bi,bj) = B_glen_isothermal
          enddo
#endif
          H_streamice_prev(i,j,bi,bj) = 0. _d 0
#ifdef STREAMICE_STRESS_BOUNDARY_CONTROL
          STREAMICE_u_normal_pert(i,j,bi,bj) = 0. _d 0
          STREAMICE_v_normal_pert(i,j,bi,bj) = 0. _d 0
          STREAMICE_u_shear_pert(i,j,bi,bj) = 0. _d 0
          STREAMICE_v_shear_pert(i,j,bi,bj) = 0. _d 0
          STREAMICE_u_normal_stress(i,j,bi,bj) = 0. _d 0
          STREAMICE_v_normal_stress(i,j,bi,bj) = 0. _d 0
          STREAMICE_u_shear_stress(i,j,bi,bj) = 0. _d 0
          STREAMICE_v_shear_stress(i,j,bi,bj) = 0. _d 0
#ifdef ALLOW_STREAMICE_TIMEDEP_FORCING
          STREAMICE_u_normal_stress1(i,j,bi,bj) = 0. _d 0
          STREAMICE_v_normal_stress1(i,j,bi,bj) = 0. _d 0
          STREAMICE_u_shear_stress1(i,j,bi,bj) = 0. _d 0
          STREAMICE_v_shear_stress1(i,j,bi,bj) = 0. _d 0
#endif
#endif
#ifdef ALLOW_STREAMICE_2DTRACER
#ifdef STREAMICE_TRACER_AB
         GAD_trac_2d (i,j,bi,bj) = 0. _d 0
c         GAD_trac_2dNm1 (i,j,bi,bj) = 0. _d 0
#endif
#endif
#ifdef ALLOW_AUTODIFF
          ru_old_si(i,j,bi,bj) = 0. _d 0
          rv_old_si(i,j,bi,bj) = 0. _d 0
          zu_old_si(i,j,bi,bj) = 0. _d 0
          zv_old_si(i,j,bi,bj) = 0. _d 0
c          h_after_uflux_SI(i,j,bi,bj) = 0. _d 0
#endif
#ifdef USE_ALT_RLOW
          R_low_si(i,j,bi,bj) = 0. _d 0
#endif

#ifdef STREAMICE_HYBRID_STRESS
          do k=1,Nr
           visc_streamice_full(i,j,k,bi,bj) =
     &     eps_glen_min**((1-n_glen)/n_glen)
          enddo
          streamice_taubx (i,j,bi,bj) = 0. _d 0
          streamice_tauby (i,j,bi,bj) = 0. _d 0
#endif
         ENDDO
        ENDDO

#ifdef ALLOW_COST_TEST
        cost_func1_streamice (bi,bj) = 0.0
        cost_vel_streamice (bi,bj) = 0.0
        cost_surf_streamice (bi,bj) = 0.0
        cost_smooth_fric_streamice (bi,bj) = 0.0
        cost_smooth_glen_streamice (bi,bj) = 0.0
        cost_prior_streamice (bi,bj) = 0.0
        cost_smooth_bdotmelt_streamice(bi,bj) = 0.0
#endif

       ENDDO
      ENDDO

      DO j = 1-OLy, sNy+OLy
       DO i = 1-OLx, sNx+OLx
        DO bj = myByLo(myThid), myByHi(myThid)
         DO bi = myBxLo(myThid), myBxHi(myThid)
cc          DO k=1,4
           DO col_x=-1,1
            DO col_y=-1,1
             streamice_cg_A1(i,j,bi,bj,col_x,col_y)=0.0
             streamice_cg_A2(i,j,bi,bj,col_x,col_y)=0.0
             streamice_cg_A3(i,j,bi,bj,col_x,col_y)=0.0
             streamice_cg_A4(i,j,bi,bj,col_x,col_y)=0.0
            ENDDO
           ENDDO
cc          ENDDO
         ENDDO
        ENDDO
       ENDDO
      ENDDO

C     INIT. INTEGER ARRAYS

      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          STREAMICE_hmask(i,j,bi,bj) = -1.0
          STREAMICE_umask(i,j,bi,bj) = 0.0
          STREAMICE_vmask(i,j,bi,bj) = 0.0
          STREAMICE_ufacemask(i,j,bi,bj) = 0.0
          STREAMICE_vfacemask(i,j,bi,bj) = 0.0
          STREAMICE_float_cond(i,j,bi,bj) = 0.0
         ENDDO
        ENDDO
       ENDDO
      ENDDO

#ifdef USE_ALT_RLOW
c init alternate array for topog
      IF ( STREAMICEtopogFile .NE. ' ' ) THEN
        _BARRIER
C The 0 is the "iteration" argument. The ' ' is an empty suffix
       CALL READ_FLD_XY_RL( STREAMICEtopogFile, '',
     &      R_low_si, 0, myThid )

      ELSE
        WRITE(msgBuf,'(A)') 'STREAMICE TOPOG - FILENAME MISSING'
        CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT , 1)
      ENDIF
#endif

c initialize thickness

#ifndef STREAMICE_GEOM_FILE_SETUP

      IF ( STREAMICEthickInit.EQ.'PARAM' ) THEN

      WRITE(msgBuf,'(A)') 'initializing analytic thickness'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT , 1)

       slope_pos = shelf_edge_pos - shelf_flat_width
       c1 = 0.0
       IF (shelf_slope_scale .GT. 0.0) THEN
        c1 = 1.0 / shelf_slope_scale
       ENDIF

       DO bj = myByLo(myThid), myByHi(myThid)
        DO bi = myBxLo(myThid), myBxHi(myThid)
         DO j=1,sNy
          DO i=1,sNx
           Gi = (myXGlobalLo-1)+(bi-1)*sNx+i
           Gj = (myYGlobalLo-1)+(bj-1)*sNy+j

           IF ((Gi.lt.Nx).and.(Gj.lt.Ny)) THEN

C             IF (flow_dir .EQ. 2.0) THEN
            IF (.TRUE.) THEN
             IF (xC(i-1,j,bi,bj).GE.shelf_edge_pos) THEN
              area_shelf_streamice(i,j,bi,bj) = 0. _d 0
              STREAMICE_hmask(i,j,bi,bj) = 0. _d 0
             ELSE

              IF (xC(i,j,bi,bj).GT.slope_pos) THEN
               H_streamice (i,j,bi,bj) = shelf_min_draft
              ELSE
               H_streamice (i,j,bi,bj) = (shelf_min_draft +
     &          (shelf_max_draft - shelf_min_draft) *
     &          min (oneRL, (c1*(slope_pos-xC(i,j,bi,bj)))**2))
              ENDIF

              IF (xC(i,j,bi,bj).GT.shelf_edge_pos) THEN
               area_shelf_streamice(i,j,bi,bj) = rA(i,j,bi,bj) *
     &          (shelf_edge_pos-xG(i,j,bi,bj)) /
     &          (xG(i+1,j,bi,bj)-xG(i,j,bi,bj))
               IF (area_shelf_streamice(i,j,bi,bj).gt. 0. _d 0) THEN
                STREAMICE_hmask(i,j,bi,bj) = 2.0
               ELSE
                STREAMICE_hmask(i,j,bi,bj) = 0.0
                H_streamice(i,j,bi,bj) = 0.0
               ENDIF
              ELSE
               area_shelf_streamice(i,j,bi,bj) = rA(i,j,bi,bj)
               STREAMICE_hmask(i,j,bi,bj) = 1.0
              ENDIF

             ENDIF
            ENDIF
           ENDIF
          ENDDO
         ENDDO
        ENDDO
       ENDDO

      ELSE IF ( STREAMICEthickInit.EQ.'FILE' ) THEN

       IF ( STREAMICEthickFile .NE. ' ' ) THEN
        _BARRIER
C The 0 is the "iteration" argument. The ' ' is an empty suffix
        CALL READ_FLD_XY_RL( STREAMICEthickFile, ' ', H_streamice,
     &      0, myThid )
        DO bj = myByLo(myThid), myByHi(myThid)
         DO bi = myBxLo(myThid), myBxHi(myThid)
          DO j=1,sNy
           DO i=1,sNx
            Gi = (myXGlobalLo-1)+(bi-1)*sNx+i
            Gj = (myYGlobalLo-1)+(bj-1)*sNy+j
            IF ((Gi.lt.Nx.OR.STREAMICE_EW_periodic).and.
     &          (Gj.lt.Ny.OR.STREAMICE_NS_periodic)) THEN
             IF (H_streamice(i,j,bi,bj).GT.0. _d 0) THEN
              area_shelf_streamice(i,j,bi,bj) = rA(i,j,bi,bj)
              STREAMICE_hmask(i,j,bi,bj) = 1.0
             ELSE
              area_shelf_streamice(i,j,bi,bj) = 0. _d 0
              STREAMICE_hmask(i,j,bi,bj) = 0. _d 0
             ENDIF
             Do k=1,Nr
             STREAMICE_ctrl_mask(i,j,k,bi,bj) = 1. _d 0
             enddo
            ENDIF
           ENDDO
          ENDDO
         ENDDO
        ENDDO
       ELSE
        WRITE(msgBuf,'(A)') 'INIT THICKNESS - FILENAME MISSING'
        CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT , 1)
       ENDIF

      ELSE

       WRITE(msgBuf,'(A)') 'INIT THICKNESS - NOT IMPLENTED'
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT , 1)
      ENDIF

#else
c STREAMICE_GEOM_FILE_SETUP - init thickness and hmask MUST come from file

      IF ( STREAMICEthickFile .NE. ' ' ) THEN
        _BARRIER
C The 0 is the "iteration" argument. The ' ' is an empty suffix
      CALL READ_FLD_XY_RL( STREAMICEthickFile, ' ', H_streamice,
     &      0, myThid )
      ELSE
       WRITE(msgBuf,'(A)') 'INIT THICKNESS - FILENAME MISSING'
       CALL PRINT_ERROR( msgBuf, myThid)
      ENDIF

      IF ( STREAMICEhMaskFile .NE. ' ' ) THEN
        _BARRIER
C The 0 is the "iteration" argument. The ' ' is an empty suffix
      CALL READ_FLD_XY_RS( STREAMICEhMaskFile, ' ', STREAMICE_hmask,
     &      0, myThid )
      ELSE
       WRITE(msgBuf,'(A)') 'INIT HMASK - FILENAME MISSING'
       CALL PRINT_ERROR( msgBuf, myThid)
      ENDIF

      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          IF ( H_streamice(i,j,bi,bj) .GT. zeroRL .AND.
     &         STREAMICE_hmask(i,j,bi,bj) .EQ. oneRS ) THEN
           area_shelf_streamice(i,j,bi,bj) = rA(i,j,bi,bj)
          ENDIF
         ENDDO
        ENDDO
       ENDDO
      ENDDO

#endif
c STREAMICE_GEOM_FILE_SETUP

      IF ( .NOT. ( startTime .EQ. baseTime .AND.  nIter0 .EQ. 0
     &     .AND. pickupSuff .EQ. ' ') ) THEN

                          CALL STREAMICE_READ_PICKUP ( myThid )

      ENDIF

c finish initialize thickness

c initialize glen constant

      IF ( STREAMICEGlenConstConfig.EQ.'FILE' ) THEN

       IF ( STREAMICEGlenConstFile .NE. ' ' ) THEN
        _BARRIER

#ifdef STREAMICE_3D_GLEN_CONST

        CALL READ_FLD_XYZ_RL( STREAMICEGlenConstFile, ' ',
     &      B_glen, 0, myThid )

#else

        CALL READ_FLD_XY_RL( STREAMICEGlenConstFile, ' ',
     &      B_glen, 0, myThid )
        CALL READ_FLD_XY_RL( STREAMICEGlenConstFile, ' ',
     &      B_glen_init, 0, myThid )

#endif
       ELSE
        WRITE(msgBuf,'(A)') 'INIT GLEN - FILENAME MISSING'
        CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT , 1)
       ENDIF

      ELSE IF (STREAMICEGlenConstConfig.EQ.'UNIFORM' ) THEN

        DO bj = myByLo(myThid), myByHi(myThid)
         DO bi = myBxLo(myThid), myBxHi(myThid)
          DO j=1,sNy
           DO i=1,sNx
#ifdef STREAMICE_3D_GLEN_CONST
            DO r=1,Nr
             B_glen(i,j,r,bi,bj) = B_glen_isothermal
            ENDDO
#else
             B_glen(i,j,bi,bj) = B_glen_isothermal
#endif
           ENDDO
          ENDDO
         ENDDO
        ENDDO

      ELSE

       WRITE(msgBuf,'(A)') 'INIT GLEN CONSTANT - NOT IMPLENTED'
       CALL PRINT_ERROR( msgBuf, myThid)
       STOP 'ABNORMAL END: S/R STREAMICE_INIT_VAR'
      ENDIF

c finish initialize glen constant

c initialize melt rates

      IF ( STREAMICEBdotConfig.EQ.'FILE' ) THEN

       IF ( STREAMICEBdotFile .NE. ' ' ) THEN
        _BARRIER

        CALL READ_FLD_XY_RL( STREAMICEBdotFile, ' ',
     &      BDOT_streamice, 0, myThid )

       ELSE
        WRITE(msgBuf,'(A)') 'INIT BDOT - FILENAME MISSING'
        CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT , 1)
       ENDIF

      ELSEIF ( STREAMICEBdotConfig.EQ.'PARAM' ) THEN

       IF ( STREAMICEBdotDepthFile .NE. ' ' ) THEN
        _BARRIER

        CALL READ_FLD_XY_RL( STREAMICEBdotDepthFile, ' ',
     &      streamice_bdot_depth_maxmelt_v, 0, myThid )

       ENDIF

       IF ( STREAMICEBdotMaxMeltFile .NE. ' ' ) THEN
        _BARRIER

        CALL READ_FLD_XY_RL( STREAMICEBdotMaxMeltFile, ' ',
     &     streamice_bdot_maxmelt_v , 0, myThid )

       ENDIF

      ENDIF

c finish initialize melt rates

c initialize SMB rates

      IF ( STREAMICEAdotConfig.EQ.'FILE' ) THEN

       IF ( STREAMICEAdotFile .NE. ' ' ) THEN
        _BARRIER

        CALL READ_FLD_XY_RL( STREAMICEAdotFile, ' ',
     &      ADOT_streamice, 0, myThid )

       ELSE
        WRITE(msgBuf,'(A)') 'INIT ADOT - FILENAME MISSING'
        CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT , 1)
       ENDIF

      ENDIF

c finish initialize SMB rates

      IF ( STREAMICE_vel_ext.OR.STREAMICE_vel_ext_cgrid ) THEN

       IF ( STREAMICE_uvel_ext_file .NE. ' ' ) THEN
        _BARRIER

        CALL READ_FLD_XY_RL( STREAMICE_uvel_ext_file, ' ',
     &      u_streamice_ext, 0, myThid )

        DO bj = myByLo(myThid), myByHi(myThid)
         DO bi = myBxLo(myThid), myBxHi(myThid)
          DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
            U_streamice(i,j,bi,bj) = U_streamice_ext(i,j,bi,bj)
           ENDDO
          ENDDO
         ENDDO
        ENDDO

       ELSE
        WRITE(msgBuf,'(A)') 'INIT UVEL - FILENAME MISSING'
        CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT , 1)
       ENDIF

       IF ( STREAMICE_vvel_ext_file .NE. ' ' ) THEN
        _BARRIER

        CALL READ_FLD_XY_RL( STREAMICE_vvel_ext_file, ' ',
     &      v_streamice_ext, 0, myThid )

        DO bj = myByLo(myThid), myByHi(myThid)
         DO bi = myBxLo(myThid), myBxHi(myThid)
          DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
            V_streamice(i,j,bi,bj) = V_streamice_ext(i,j,bi,bj)
           ENDDO
          ENDDO
         ENDDO
        ENDDO

       ELSE
        WRITE(msgBuf,'(A)') 'INIT VVEL - FILENAME MISSING'
        CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT , 1)
       ENDIF

      ENDIF

c initialize basal traction

      IF ( STREAMICEbasalTracConfig.EQ.'FILE' ) THEN

       IF ( STREAMICEbasalTracFile .NE. ' ' ) THEN
        _BARRIER

        CALL READ_FLD_XY_RL( STREAMICEbasalTracFile, ' ',
     &      C_basal_friction, 0, myThid )
        CALL READ_FLD_XY_RL( STREAMICEbasalTracFile, ' ',
     &      C_basal_fric_init, 0, myThid )

       ELSE
        WRITE(msgBuf,'(A)') 'INIT C_BASAL - FILENAME MISSING'
        CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT , 1)
       ENDIF

      ELSE IF (STREAMICEbasalTracConfig.EQ.'UNIFORM' ) THEN

        DO bj = myByLo(myThid), myByHi(myThid)
         DO bi = myBxLo(myThid), myBxHi(myThid)
          DO j=1,sNy
           DO i=1,sNx
            C_basal_friction(i,j,bi,bj) = C_basal_fric_const
           ENDDO
          ENDDO
         ENDDO
        ENDDO

      ELSE IF (STREAMICEbasalTracConfig.EQ.'2DPERIODIC' ) THEN

       lenx = sNx*nSx*nPx*delX(1)
       leny = sNy*nSy*nPy*delY(1)
       DO bj = myByLo(myThid), myByHi(myThid)
        DO bi = myBxLo(myThid), myBxHi(myThid)
         DO j=1,sNy
          DO i=1,sNx
           x = xC(i,j,bi,bj)
           y = yC(i,j,bi,bj)
           C_basal_friction(i,j,bi,bj) =
     &      sqrt(C_basal_fric_const**2*
     &        (1+sin(2*streamice_kx_b_init*PI*x/lenx)*
     &           sin(2*streamice_ky_b_init*PI*y/leny)))
          ENDDO
         ENDDO
        ENDDO
       ENDDO

      ELSE IF (STREAMICEbasalTracConfig.EQ.'1DPERIODIC' ) THEN

       lenx = sNx*nSx*nPx*delX(1)
       DO bj = myByLo(myThid), myByHi(myThid)
        DO bi = myBxLo(myThid), myBxHi(myThid)
         DO j=1,sNy
          DO i=1,sNx
           x = xC(i,j,bi,bj)
           y = yC(i,j,bi,bj)
           C_basal_friction(i,j,bi,bj) =
     &      sqrt(C_basal_fric_const**2*(1+
     &        sin(2*streamice_kx_b_init*PI*x/lenx)))
          ENDDO
         ENDDO
        ENDDO
       ENDDO

      ELSE

       WRITE(msgBuf,'(A)') 'INIT TRAC - NOT IMPLENTED'
       CALL PRINT_ERROR( msgBuf, myThid)
       STOP 'ABNORMAL END: S/R STREAMICE_INIT_VAR'
      ENDIF

c finish initialize basal trac

#ifdef ALLOW_STREAMICE_2DTRACER

      IF ( STREAMICETRAC2DINITFILE .NE. ' ' ) THEN
         _BARRIER

        CALL READ_FLD_XY_RL( STREAMICETRAC2dInitFile, ' ',
     &      trac2d, 0, myThid )

       ELSE
        WRITE(msgBuf,'(A)') 'TRAC2dInit - NO FILE SPECIFIED'
        CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT , 1)
        DO bj = myByLo(myThid), myByHi(myThid)
         DO bi = myBxLo(myThid), myBxHi(myThid)
          DO j=1,sNy
           DO i=1,sNx
            trac2d(i,j,bi,bj) = 0.0
           ENDDO
          ENDDO
         ENDDO
        ENDDO

       ENDIF

      _EXCH_XY_RL (trac2d, myThid)

#endif /*STREAMICE_ALLOW_2DTRACER*/

#ifdef STREAMICE_STRESS_BOUNDARY_CONTROL
      IF ( STREAMICEuNormalStressFile .NE. ' ') THEN
        _BARRIER
       CALL READ_FLD_XY_RL ( STREAMICEuNormalStressFile, ' ',
     &  streamice_u_normal_stress, 0, myThid )
      ELSE
       WRITE(msgBuf,'(A)') 'IMPOSED NORMAL U STRESS NOT SET'
       CALL PRINT_ERROR( msgBuf, myThid)
      ENDIF

      IF ( STREAMICEvNormalStressFile .NE. ' ') THEN
        _BARRIER
       CALL READ_FLD_XY_RL ( STREAMICEvNormalStressFile, ' ',
     &  streamice_v_normal_stress, 0, myThid )
      ELSE
       WRITE(msgBuf,'(A)') 'IMPOSED NORMAL V STRESS NOT SET'
       CALL PRINT_ERROR( msgBuf, myThid)
      ENDIF

      IF ( STREAMICEuShearStressFile .NE. ' ') THEN
        _BARRIER
       CALL READ_FLD_XY_RL ( STREAMICEuShearStressFile, ' ',
     &  streamice_u_shear_stress, 0, myThid )
      ELSE
       WRITE(msgBuf,'(A)') 'IMPOSED SHEAR U STRESS NOT SET'
       CALL PRINT_ERROR( msgBuf, myThid)
      ENDIF

      IF ( STREAMICEvShearStressFile .NE. ' ') THEN
        _BARRIER
       CALL READ_FLD_XY_RL ( STREAMICEvShearStressFile, ' ',
     &  streamice_v_shear_stress, 0, myThid )
      ELSE
       WRITE(msgBuf,'(A)') 'IMPOSED SHEAR V STRESS NOT SET'
       CALL PRINT_ERROR( msgBuf, myThid)
      ENDIF

      CALL EXCH_XY_RL
     & (streamice_v_shear_stress, myThid)
      CALL EXCH_XY_RL
     & (streamice_u_shear_stress, myThid)
      CALL EXCH_XY_RL
     & (streamice_v_normal_stress, myThid)
      CALL EXCH_XY_RL
     & (streamice_u_normal_stress, myThid)

#endif /*STREAMICE_STRESS_BOUNDARY_CONTROL*/

      CALL STREAMICE_UPD_FFRAC_UNCOUPLED ( myThid )

      _EXCH_XY_RL(H_streamice, myThid )
      _EXCH_XY_RS(STREAMICE_hmask, myThid )
      _EXCH_XY_RL(area_shelf_streamice, myThid )
      _EXCH_XY_RL(C_basal_friction, myThid )
      _EXCH_XY_RL(u_streamice_ext, myThid )
      _EXCH_XY_RL(v_streamice_ext, myThid )
#ifndef STREAMICE_3D_GLEN_CONST
      _EXCH_XY_RL(B_glen, myThid )
#else
      CALL EXCH_3D_RL(B_glen, Nr,myThid )
#endif

#ifdef USE_ALT_RLOW
      _EXCH_XY_RL(R_low_si, myThid )
#endif

c#ifdef STREAMICE_HYBRID_STRESS

c      CALL STREAMICE_VISC_BETA (myThid)

c DNG THIS CALL IS TO INITIALISE VISCOSITY
c     TO AVOID POSSIBLE ADJOINT INSTABILITIES
c     IT IS WRITTEN OVER IN FIRST TIMESTEP

#if (defined (ALLOW_AUTODIFF))
#ifndef ALLOW_STREAMICE_FP_ADJ

       CALL STREAMICE_UPD_FFRAC_UNCOUPLED ( myThid )
       CALL STREAMICE_VELMASK_UPD (myThid)

       CALL STREAMICE_VEL_SOLVE ( myThid,
     &                           streamice_max_nl_iter,
     &                           streamice_max_cg_iter,
     &                           0 )

#endif
#endif

      CALL WRITE_FLD_XY_RL ( "C_basal_fric", "",
     & C_basal_friction, 0, myThid )
      CALL WRITE_FLD_XY_RL ( "B_glen_sqrt", "",
     & B_glen, 0, myThid )
      CALL WRITE_FLD_XY_RL ( "H_streamice", "init",
     & H_streamIce, 0, myThid )
#ifdef ALLOW_STREAMICE_2DTRACER
      CALL WRITE_FLD_XY_RL ( "2DTracer", "init",
     & trac2d, 0, myThid )
#endif
      CALL WRITE_FLD_XY_RL ( "area_shelf_streamice", "init",
     & area_shelf_streamice, 0, myThid )
      CALL WRITE_FLD_XY_RS ( "STREAMICE_hmask", "init",
     & STREAMICE_hmask, 0, myThid )
#ifdef ALLOW_CTRL
      CALL ACTIVE_WRITE_GEN_RS( 'maskCtrlst', STREAMICE_ctrl_mask,
     &  'XY', Nr, 1, .FALSE., 0, myThid, dummyRS )
#endif
c      call active_write_xyz( 'maskCtrlS', STREAMICE_ctrl_mask, 1, 0,
c     & myThid, dummy)
c       CALL STREAMICE_VELMASK_UPD (myThid)
c       CALL STREAMICE_UPD_FFRAC_UNCOUPLED ( myThid )
c       CALL STREAMICE_VEL_SOLVE( myThid )

      CALL WRITE_FLD_XY_RL ( "U_init", "",
     &   C_basal_friction, 0, myThid )
      CALL WRITE_FLD_XY_RL ( "V_init", "",
     &   V_streamice, 0, myThid )
#ifdef USE_ALT_RLOW
      CALL WRITE_FLD_XY_RL ( "R_low_si", "init",
     & R_low_si, 0, myThid )
#endif

c       CALL WRITE_FULLARRAY_RL ("H",H_streamice,1,0,0,1,0,myThid)
c       CALL WRITE_FULLARRAY_RS ("hmask",STREAMICE_hmask,1,0,0,1,0,myThid)
c       CALL WRITE_FULLARRAY_RL ("umask",STREAMICE_umask,1,0,0,1,0,myThid)

#endif /* ALLOW_STREAMICE */

      RETURN
      END

#include "MOM_COMMON_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: MOM_INIT_FIXED

C     !INTERFACE:
      SUBROUTINE MOM_INIT_FIXED( myThid )

C     !DESCRIPTION:
C     Initialize fixed quantities
C      for momentum (common to fluxform & vecinv) packages

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "SURFACE.h"
#include "MOM_VISC.h"

C     !INPUT PARAMETERS:
C     myThid               :: my thread Id number
      INTEGER myThid
CEOP

C     !LOCAL VARIABLES:
C     i,j,k,bi,bj  :: loop counter
      INTEGER i,j,k,bi,bj
      _RL recip_dt
      _RL twoThird
#ifdef ALLOW_BOTTOMDRAG_ROUGHNESS
C     msgBuf :: Informational/error message buffer
      INTEGER kLow
      _RL hLoc
      _RL recip_zRoughBot
      CHARACTER*(MAX_LEN_MBUF) msgBuf
#endif

      twoThird = 2. _d 0 / 3. _d 0
      recip_dt = 1. _d 0
      IF ( deltaTMom.NE.0. ) recip_dt = 1. _d 0/deltaTMom

      _BEGIN_MASTER(myThid)
      DO k=1,Nr
        deepFacAdv(k) = 1. _d 0
      ENDDO
#ifndef MOM_USE_OLD_DEEP_VERT_ADV
      IF ( useNHMTerms ) THEN
       DO k=1,Nr
        deepFacAdv(k) = deepFacC(k)
       ENDDO
      ENDIF
#endif
      _END_MASTER(myThid)

      DO bj=myByLo(myThid), myByHi(myThid)
       DO bi=myBxLo(myThid), myBxHi(myThid)

#ifdef ALLOW_3D_VISCAH
         DO k=1,Nr
          DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
            viscAhDfld(i,j,k,bi,bj) = 0. _d 0
            viscAhZfld(i,j,k,bi,bj) = 0. _d 0
           ENDDO
          ENDDO
         ENDDO
#endif
#ifdef ALLOW_3D_VISCA4
         DO k=1,Nr
          DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
            viscA4Dfld(i,j,k,bi,bj) = 0. _d 0
            viscA4Zfld(i,j,k,bi,bj) = 0. _d 0
           ENDDO
          ENDDO
         ENDDO
#endif
#ifdef ALLOW_NONHYDROSTATIC
C--   Set the horizontal viscosities to default value.
         DO k=1,Nr
          DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
            viscAh_W(i,j,k,bi,bj) = viscAhW
            viscA4_W(i,j,k,bi,bj) = viscA4W
           ENDDO
          ENDDO
         ENDDO
#endif /* ALLOW_NONHYDROSTATIC */

C--   Calculate length-scale factor (used in S/R MOM_CALC_VISC)
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
            L2_D(i,j,bi,bj) = rA(i,j,bi,bj)
          ENDDO
         ENDDO
         IF ( .NOT.useAreaViscLength ) THEN
          DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
            IF ( recip_dxF(i,j,bi,bj).NE.0. .OR.
     &           recip_dyF(i,j,bi,bj).NE.0. ) THEN
              L2_D(i,j,bi,bj) = 2. _d 0
     &           /((recip_dxF(i,j,bi,bj)**2+recip_dyF(i,j,bi,bj)**2))
            ENDIF
           ENDDO
          ENDDO
         ENDIF
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
            L3_D(i,j,bi,bj) = L2_D(i,j,bi,bj)**1.5
            L4rdt_D(i,j,bi,bj) = 0.03125 _d 0*recip_dt
     &                       *L2_D(i,j,bi,bj)**2
          ENDDO
         ENDDO

         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
            L2_Z(i,j,bi,bj) = rAz(i,j,bi,bj)
          ENDDO
         ENDDO
         IF ( .NOT.useAreaViscLength ) THEN
          DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
            IF ( recip_dxV(i,j,bi,bj).NE.0. .OR.
     &           recip_dyU(i,j,bi,bj).NE.0. ) THEN
              L2_Z(i,j,bi,bj) = 2. _d 0
     &           /((recip_dxV(i,j,bi,bj)**2+recip_dyU(i,j,bi,bj)**2))
            ENDIF
           ENDDO
          ENDDO
         ENDIF
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
            L3_Z(i,j,bi,bj) = L2_Z(i,j,bi,bj)**1.5
            L4rdt_Z(i,j,bi,bj) = 0.03125 _d 0*recip_dt
     &                       *L2_Z(i,j,bi,bj)**2
          ENDDO
         ENDDO

#ifdef ALLOW_SMAG_3D
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           smag3D_hLsC(i,j,bi,bj) = rA (i,j,bi,bj)**twoThird
           smag3D_hLsW(i,j,bi,bj) = rAw(i,j,bi,bj)**twoThird
           smag3D_hLsS(i,j,bi,bj) = rAs(i,j,bi,bj)**twoThird
           smag3D_hLsZ(i,j,bi,bj) = rAz(i,j,bi,bj)**twoThird
          ENDDO
         ENDDO
#endif /* ALLOW_SMAG_3D */

C-     end bi,bj loops
       ENDDO
      ENDDO

#ifdef ALLOW_3D_VISCAH
      IF ( viscAhDfile .NE. ' ' ) THEN
         CALL READ_FLD_XYZ_RL(viscAhDfile,' ',viscAhDfld,0,myThid)
         CALL EXCH_3D_RL( viscAhDfld, Nr, myThid )
      ENDIF
      IF ( viscAhZfile .NE. ' ' ) THEN
         CALL READ_FLD_XYZ_RL(viscAhZfile,' ',viscAhZfld,0,myThid)
         CALL EXCH_Z_3D_RL( viscAhZfld, Nr, myThid )
      ENDIF
#endif /* ALLOW_3D_VISCAH */
#ifdef ALLOW_3D_VISCA4
      IF ( viscA4Dfile .NE. ' ' ) THEN
         CALL READ_FLD_XYZ_RL(viscA4Dfile,' ',viscA4Dfld,0,myThid)
         CALL EXCH_3D_RL( viscA4Dfld, Nr, myThid )
      ENDIF
      IF ( viscA4Zfile .NE. ' ' ) THEN
         CALL READ_FLD_XYZ_RL(viscA4Zfile,' ',viscA4Zfld,0,myThid)
         CALL EXCH_Z_3D_RL( viscA4Zfld, Nr, myThid )
      ENDIF
#endif /* ALLOW_3D_VISCA4 */

#ifdef ALLOW_BOTTOMDRAG_ROUGHNESS
C--   Compute bottom drag coefficents as a function of grid cell thickness
C     and roughness length, assuming von Karman constant = 0.4
      DO bj=myByLo(myThid), myByHi(myThid)
       DO bi=myBxLo(myThid), myBxHi(myThid)
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          bottomDragCoeffW(i,j,bi,bj) = bottomDragQuadratic
          bottomDragCoeffS(i,j,bi,bj) = bottomDragQuadratic
         ENDDO
        ENDDO
        IF ( zRoughBot .GT. 0. _d 0 .AND. usingZCoords ) THEN
         recip_zRoughBot = 1. _d 0 / zRoughBot
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx+1,sNx+OLx
           kLow = MIN( kLowC(i-1,j,bi,bj), kLowC(i,j,bi,bj)  )
           IF ( kLow .GE. 1 ) THEN
            hLoc = ( oneRL +
     &           0.5*drF(kLow)*hFacW(i,j,kLow,bi,bj)*recip_zRoughBot )
            hLoc = 0.4 _d 0/LOG(hLoc)
            bottomDragCoeffW(i,j,bi,bj) = hLoc*hLoc
           ELSE
            bottomDragCoeffW(i,j,bi,bj) = 0. _d 0
           ENDIF
          ENDDO
         ENDDO
         DO j=1-OLy+1,sNy+OLy
          DO i=1-OLx,sNx+OLx
           kLow = MIN( kLowC(i,j-1,bi,bj), kLowC(i,j,bi,bj)  )
           IF ( kLow .GE. 1 ) THEN
            hLoc = ( oneRL +
     &           0.5*drF(kLow)*hFacS(i,j,kLow,bi,bj)*recip_zRoughBot )
            hLoc = 0.4 _d 0/LOG(hLoc)
            bottomDragCoeffS(i,j,bi,bj) = hLoc*hLoc
           ELSE
            bottomDragCoeffS(i,j,bi,bj) = 0. _d 0
           ENDIF
          ENDDO
         ENDDO
        ELSEIF ( zRoughBot .GT. 0. _d 0 ) THEN
C-    Roughness dependent drag not yet coded for P-Coordinates
         WRITE(msgBuf,'(2A)') 'MOM_INIT_FIXED: zRoughBot > 0.',
     &                ' not yet implemented for P-Coordinate'
         CALL PRINT_ERROR( msgBuf, myThid )
         STOP 'ABNORMAL END: S/R MOM_INIT_FIXED'
        ENDIF
       ENDDO
      ENDDO
#endif /* ALLOW_BOTTOMDRAG_ROUGHNESS */

#ifdef ALLOW_DIAGNOSTICS
      IF ( useDiagnostics ) THEN
        CALL MOM_DIAGNOSTICS_INIT( myThid )
      ENDIF
#endif /* ALLOW_DIAGNOSTICS */

      RETURN
      END

#     include "GAD_OPTIONS.h"

      SUBROUTINE GAD_PPM_ADV_X(meth,bi,bj,kk,
     I           calc_CFL,delT,uvel,ufac,fbar,
     O           flux,myThid )
C     |================================================================|
C     | PPM_ADV_X: evaluate grid-cell advective flux in X.             |
C     | Lagrangian-type Piecewise Parabolic Method (PPM).              |
C     |================================================================|

          implicit none

C     =============================================== global variables
#         include "SIZE.h"
#         include "GRID.h"
#         include "GAD.h"

C     ================================================================
C       meth     :: advection method.
C       bi,bj    :: tile indexing.
C       kk       :: r-index.
C       calc_CFL :: TRUE to calc. CFL from vel.
C       delT     :: time-step.
C       uvel     :: vel.-comp in x-direction.
C       ufac     :: vel.-flux in x-direction.
C       fbar     :: grid-cell values.
C       flux     :: adv.-flux in x-direction.
C       myThid   :: thread number.
C     ================================================================
          integer meth
          integer bi,bj,kk
          logical calc_CFL
          _RL delT
          _RL uvel(1-OLx:sNx+OLx,
     &             1-OLy:sNy+OLy)
          _RL ufac(1-OLx:sNx+OLx,
     &             1-OLy:sNy+OLy)
          _RL fbar(1-OLx:sNx+OLx,
     &             1-OLy:sNy+OLy)
          _RL flux(1-OLx:sNx+OLx,
     &             1-OLy:sNy+OLy)
          integer myThid

C     ================================================================
C       ix,iy,ir :: grid indexing.
C       floc     :: row of grid-cell values.
C       mloc     :: row of grid-cell mask values.
C       fhat     :: row of poly. coeff.
C                    - FHAT(:,I) = PQM coeff.
C       edge     :: row of edge-wise values/slopes.
C                    - EDGE(1,:) = VALUE.
C                    - EDGE(2,:) = DF/DY.
C       ohat     :: row of oscl. coeff.
C                    - OHAT(1,:) = D^1F/DS^1.
C                    - OHAT(2,:) = D^2F/DS^2.
C     ================================================================
          integer ix,iy
          _RL mloc(1-OLx:sNx+OLx)
          _RL floc(1-OLx:sNx+OLx)
          _RL fhat(1:3,
     &             1-OLx:sNx+OLx)
          _RL edge(1-OLx:sNx+OLx)
          _RL ohat(1:2,
     &             1-OLx:sNx+OLx)
          _RL vsum

          do iy = 1-OLy+0, sNy+OLy-0
C     ==================== zero stencil "ghost" cells along boundaries
              flux( +1-OLx+0,iy) = 0. _d 0
              flux( +1-OLx+1,iy) = 0. _d 0
              flux( +1-OLx+2,iy) = 0. _d 0
              flux( +1-OLx+3,iy) = 0. _d 0
              flux(sNx+OLx-0,iy) = 0. _d 0
              flux(sNx+OLx-1,iy) = 0. _d 0
              flux(sNx+OLx-2,iy) = 0. _d 0
          end do

C     ================================================================
C       (1): copy a single row of data onto contiguous storage, treat
C            as a set of one-dimensional problems.
C       (2): calc. "oscillation-indicators" for each grid-cell if ad-
C            vection scheme is WENO-class.
C       (3): calc. edge-centred values/slopes by high-order interpol-
C            ation.
C       (4): calc. cell-centred polynomial profiles with appropriate
C            slope-limiting.
C       (5): calc. fluxes using a local, semi-lagrangian integration.
C     ================================================================

          do iy = 1-OLy+0, sNy+OLy-0

          vsum = 0.0 _d 0
          do ix = 1-OLx+0, sNx+OLx-0
C     ================================== quick break on zero transport
              vsum = vsum
     &             + abs(ufac(ix,iy))
          end do

          if (vsum .gt. 0. _d 0) then

          do ix = 1-OLx+0, sNx+OLx-0
C     ================================== make local unit-stride copies
              floc(ix) = fbar (ix,iy)
              mloc(ix) =
     &          maskC(ix,iy,kk,bi,bj)
          end do

C     ==================== reconstruct derivatives for WENO indicators
          if (meth.eq.ENUM_PPM_WENO_LIMIT) then
          CALL GAD_OSC_HAT_X(bi,bj,kk,iy,
     &                   mloc,floc,
     &                   ohat,myThid)
          end if

C     ==================== reconstruct 3rd--order accurate edge values
          CALL GAD_PPM_P3E_X(bi,bj,kk,iy,
     &                   mloc,floc,
     &                   edge,myThid)

C     ==================== reconstruct coeff. for grid-cell poynomials
          CALL GAD_PPM_HAT_X(bi,bj,kk,iy,
     &                   meth,
     &                   mloc,floc,
     &                   edge,ohat,
     &                   fhat,myThid)

C     ==================== evaluate integral fluxes on grid-cell edges
          CALL GAD_PPM_FLX_X(bi,bj,kk,iy,
     &                   calc_CFL,
     &                   delT,uvel,
     &                   ufac,fhat,
     &                   flux,myThid)

          else

          do ix = 1-OLx+3, sNx+OLx-2
C     ================================== "null" flux on zero transport
              flux(ix,iy) = 0.0 _d 0
          end do

          end if

          end do

          return

c     end subroutine GAD_PPM_ADV_X
      end

#include "LAND_OPTIONS.h"

CBOP
C     !ROUTINE: LAND_DIAGNOSTICS_INIT
C     !INTERFACE:
      SUBROUTINE LAND_DIAGNOSTICS_INIT( myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE LAND_DIAGNOSTICS_INIT
C     | o Routine to initialize list of all available diagnostics
C     |   for LAND package
C     *==========================================================*
C     \ev
C     !USES:
      IMPLICIT NONE

C     === Global variables ===
#include "EEPARAMS.h"
c #include "SIZE.h"
c #include "PARAMS.h"
c #include "LAND_PARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
C     myThid ::  my thread Id number
      INTEGER myThid
CEOP

#ifdef ALLOW_DIAGNOSTICS
C     !LOCAL VARIABLES:
C     === Local variables ===
C     diagNum   :: diagnostics number in the (long) list of available diag.
C     diagName  :: local short name (8c) of a diagnostics
C     diagCode  :: local parser field with characteristics of the diagnostics
C              cf head of S/R DIAGNOSTICS_INIT_EARLY or DIAGNOSTICS_MAIN_INIT
C     diagUnits :: local string (16c): physical units of a diagnostic field
C     diagTitle :: local string (80c): description of field in diagnostic
      INTEGER       diagNum
      CHARACTER*8   diagName
      CHARACTER*16  diagCode
      CHARACTER*16  diagUnits
      CHARACTER*(80) diagTitle

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

c     IF ( useDiagnostics ) THEN

C--    Land state variables:
        diagName  = 'GrdSurfT'
        diagTitle = 'Surface Temperature over land'
        diagUnits = 'degC            '
        diagCode  = 'SM      Lg      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

        diagName  = 'GrdTemp '
        diagTitle = 'Ground Temperature at each level'
        diagUnits = 'degC            '
        diagCode  = 'SM      MG      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

        diagName  = 'GrdEnth '
        diagTitle = 'Ground Enthalpy at each level'
        diagUnits = 'J/m3            '
        diagCode  = 'SM      MG      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

        diagName  = 'GrdWater'
        diagTitle =
     &       'Ground Water (vs Field Capacity) Fraction at each level'
        diagUnits = '0-1             '
        diagCode  = 'SM P    MG      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

c       cdiag(160) = 'SNOW    '
c       tdiag(160) = 'Snow Depth (mm water equivalent)'
c       udiag(160) = 'mm water equiv  '
c       gdiag(160) = 'SM      L1      '
c---
        diagName  = 'LdSnowH '
        diagTitle = 'Snow Thickness over land'
        diagUnits = 'm               '
        diagCode  = 'SM P    Lg      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

        diagName  = 'LdSnwAge'
        diagTitle = 'Snow Age over land'
        diagUnits = 's               '
        diagCode  = 'SM P    Lg      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

C--    Fluxes:

        diagName  = 'RUNOFF  '
        diagTitle = 'Run-Off per surface unit'
        diagUnits = 'kg/m2/s         '
        diagCode  = 'SM      L1      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

        diagName  = 'EnRunOff'
        diagTitle = 'Energy flux associated with run-Off'
        diagUnits = 'W/m^2           '
        diagCode  = 'SM      L1      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

        diagName  = 'landHFlx'
        diagTitle = 'net surface downward Heat flux over land'
        diagUnits = 'W/m^2           '
        diagCode  = 'SM      Lg      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

        diagName  = 'landPmE '
        diagTitle = 'Precipitation minus Evaporation over land'
        diagUnits = 'kg/m^2/s        '
        diagCode  = 'SM      Lg      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

        diagName  = 'ldEnFxPr'
        diagTitle =
     &    'Energy flux (over land) associated with Precip (snow,rain)'
        diagUnits = 'W/m^2           '
        diagCode  = 'SM      Lg      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

c     ENDIF

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#endif /* ALLOW_DIAGNOSTICS */

      RETURN
      END

#include "SALT_PLUME_OPTIONS.h"

CBOP 0
C     !ROUTINE: SALT_PLUME_INIT_VARIA
C     !INTERFACE:
      SUBROUTINE SALT_PLUME_INIT_VARIA( myThid )

C     !DESCRIPTION:
C     Initialize SALT_PLUME variables

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "SALT_PLUME.h"

C     !INPUT/OUTPUT PARAMETERS:
C     myThid ::  my Thread Id number
      INTEGER myThid
CEOP

#ifdef ALLOW_SALT_PLUME

C     !LOCAL VARIABLES:
      INTEGER i,j, bi,bj,Nrp1
#ifdef SALT_PLUME_VOLUME
      INTEGER k
#endif

      Nrp1=Nr+1
      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)

C     Initialize arrays in common blocks :
C     2-dim.
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          SaltPlumeDepth (i,j,bi,bj) = 0. _d 0
          saltPlumeFlux  (i,j,bi,bj) = 0. _d 0
#ifdef SALT_PLUME_VOLUME
          SPbrineVolFlux (i,j,bi,bj) = 0. _d 0
          SPforcS1       (i,j,bi,bj) = 0. _d 0
          DO k=1,Nr
           dSPvolSurf2kLev (i,j,k,bi,bj) = 0. _d 0
           dSPvolkLev2Above(i,j,k,bi,bj) = 0. _d 0
           SPforcingS      (i,j,k,bi,bj) = 0. _d 0
           SPforcingT      (i,j,k,bi,bj) = 0. _d 0
           SPplumek        (i,j,k,bi,bj) = 1. _d 0
          ENDDO
          dSPvolkLev2Above (i,j,Nrp1,bi,bj) = 0. _d 0
          SPplumek         (i,j,Nrp1,bi,bj) = 1. _d 0
#endif
         ENDDO
        ENDDO

C- end bi,bj loops
       ENDDO
      ENDDO

#endif /* ALLOW_SALT_PLUME */

      RETURN
      END

#include "FLT_OPTIONS.h"

      SUBROUTINE FLT_READPARMS( myThid  )

C     ==================================================================
C     SUBROUTINE FLT_READPARMS
C     ==================================================================
C     o read float-pkg parameters from file "data.flt"
C     ==================================================================

C     !USES:
      IMPLICIT NONE

#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "FLT_SIZE.h"
#include "FLT.h"

C     == routine arguments ==
C     myThid - thread number for this instance of the routine.
      INTEGER myThid

C     == local variables ==
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      INTEGER iUnit

      NAMELIST /FLT_NML/ flt_int_traj, flt_int_prof,
     &                   flt_selectTrajOutp, flt_selectProfOutp,
     &                   flt_noise, flt_deltaT, FLT_Iter0,
     &                   flt_file, mapIniPos2Index

C     == end of interface ==

      IF ( .NOT.useFLT ) THEN
C-    pkg FLT is not used
        _BEGIN_MASTER(myThid)
C-    Track pkg activation status:
C     print a (weak) warning if data.flt is found
         CALL PACKAGES_UNUSED_MSG( 'useFLT', ' ', ' ' )
        _END_MASTER(myThid)
        RETURN
      ENDIF

      _BEGIN_MASTER(myThid)

C     Set default values.
      flt_deltaT   = deltaTClock
      FLT_Iter0 = 0
      flt_int_traj =  3600.
      flt_int_prof = 43200.
      flt_noise    = 0.0
      flt_file     = 'float_pos'
      mapIniPos2Index = .TRUE.
      flt_selectTrajOutp = 2
      flt_selectProfOutp = 2

      WRITE(msgBuf,'(A)') ' FLT_READPARMS: opening data.flt'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      CALL OPEN_COPY_DATA_FILE(
     I                          'data.flt', 'FLT_READPARMS',
     O                          iUnit,
     I                          myThid )

C     Read parameters from open data file
      READ(UNIT=iUnit,NML=FLT_NML)
      WRITE(msgBuf,'(A)') ' FLT_READPARMS: finished reading data.flt'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
C     Close the open data file
#ifdef SINGLE_DISK_IO
      CLOSE(iUnit)
#else
      CLOSE(iUnit,STATUS='DELETE')
#endif /* SINGLE_DISK_IO */

C     Do some checks
c     IF ( useFLT .AND. useOBCS ) THEN
c       WRITE(msgBuf,'(A,A)')
c    &   'S/R FLT_READPARMS: floats currently not implemented',
c    &   ' with open boundaries'
c       CALL PRINT_ERROR( msgBuf , myThid)
c       STOP 'ABNORMAL END: S/R FLT_READPARMS'
c     ENDIF

      _END_MASTER(myThid)
      _BARRIER

      RETURN
      END

#include "CPP_OPTIONS.h"

CBOP
C     !ROUTINE: DO_STAGGER_FIELDS_EXCHANGES
C     !INTERFACE:
      SUBROUTINE DO_STAGGER_FIELDS_EXCHANGES(myTime, myIter, myThid)
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE DO_STAGGER_FIELDS_EXCHANGES
C     | o Exchange edge info of Active tracers fields (U,V)
C     |   (needed when using stagger time Step + multiDimAdvec)
C     *==========================================================*
C     \ev
C     !USES:
      IMPLICIT NONE
C     == Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "DYNVARS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     myTime  :: Current time in simulation
C     myIter  :: Current iteration number in simulation
C     myThid  :: Thread number for this instance of the routine.
      _RL myTime
      INTEGER myIter
      INTEGER myThid
CEOP

      IF ( .NOT.useOffLine ) THEN
C-    Apply Exchanges on dynamics state variable, except in Off-Line mode

C- note: use less common EXCH S/R here (instead of usual ones) to
C        force TAF to also generate AD version for these rare ones
      IF ( staggerTimeStep ) THEN
        IF ( .NOT.applyExchUV_early )
     &   CALL EXCH_UV_3D_RL( uVel, vVel, .TRUE., Nr, myThid )
c    &   CALL EXCH_UV_XYZ_RL( uVel,vVel, .TRUE., myThid )
        IF ( .NOT.implicitIntGravWave )
     &   CALL EXCH_3D_RL( wVel, Nr, myThid )
c    &  _EXCH_XYZ_RL( wVel, myThid )
      ENDIF
c #ifdef ALLOW_NONHYDROSTATIC
      IF ( implicitIntGravWave ) THEN
c       _EXCH_XYZ_RL( theta, myThid )
c       _EXCH_XYZ_RL( salt , myThid )
        CALL EXCH_SM_3D_RL( theta, .FALSE., Nr, myThid )
        CALL EXCH_SM_3D_RL( salt , .FALSE., Nr, myThid )
      ENDIF
c #endif

C-    if not useOffLine: end
      ENDIF

      RETURN
      END

#include "FIZHI_OPTIONS.h"
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: FIZHI_WRITE_VEGTILES
C     !INTERFACE:
      SUBROUTINE FIZHI_WRITE_VEGTILES(fn,pickupflg,myTime,myIter,myThid)

C     !DESCRIPTION:

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "fizhi_SIZE.h"
#include "fizhi_land_SIZE.h"
#include "fizhi_coms.h"
#include "fizhi_land_coms.h"
#include "fizhi_earth_coms.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#ifdef ALLOW_MNC
#include "MNC_PARAMS.h"
#endif
#ifdef ALLOW_EXCH2
#include "W2_EXCH2_SIZE.h"
#include "W2_EXCH2_TOPOLOGY.h"
#endif /* ALLOW_EXCH2 */

      EXTERNAL ILNBLNK
      INTEGER ILNBLNK
      INTEGER MDS_RECLEN

C     !INPUT/OUTPUT PARAMETERS:
      CHARACTER*(*) fn
      INTEGER pickupflg
      _RL myTime
      INTEGER myIter
      INTEGER myThid

CEOP
C     !LOCAL VARIABLES:
      CHARACTER*1 prec
      CHARACTER*80 bnam
      character*(MAX_LEN_FNAM) dataFName
      integer ilst
      integer i,k,n
      integer ig,jg,tn,iunit
      integer length_of_rec
      integer bi,bj,irec,fileprec
      Real*8 r8seg(nchp)

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      DO i = 1,80
        bnam(i:i) = ' '
      ENDDO
      ilst = ILNBLNK(fn)
      if (pickupflg.eq.0) then
        prec = 'D'
        fileprec = 64
        WRITE(bnam,'(a,a)') 'pickup_vegtiles.', fn(1:ilst)
      else
        prec = 'D'
        fileprec = 64
        WRITE(bnam,'(a,a)') 'state_vegtiles.', fn(1:ilst)
      endif

#ifdef ALLOW_MNC
      IF (useMNC.AND. pickup_write_mnc) THEN

C       Write fizhi veg-space variables using the MNC package
        CALL MNC_CW_SET_UDIM(bnam, 1, myThid)
        CALL MNC_CW_RL_W_S('D',bnam,0,0,'T', myTime, myThid)
        CALL MNC_CW_I_W_S('I',bnam,0,0,'iter',myIter,myThid)

C       fizhi_coms.h
        CALL MNC_CW_RL_W(prec,bnam,0,0,'ctmt', ctmt, myThid)
        CALL MNC_CW_RL_W(prec,bnam,0,0,'xxmt', xxmt, myThid)
        CALL MNC_CW_RL_W(prec,bnam,0,0,'yymt', yymt, myThid)
        CALL MNC_CW_RL_W(prec,bnam,0,0,'zetamt', zetamt, myThid)
        CALL MNC_CW_RL_W(prec,bnam,0,0,'xlmt', xlmt, myThid)
        CALL MNC_CW_RL_W(prec,bnam,0,0,'khmt', khmt, myThid)
        CALL MNC_CW_RL_W(prec,bnam,0,0,'tke', tke, myThid)

C       fizhi_land_coms.h
        CALL MNC_CW_RL_W(prec,bnam,0,0,'tcanopy', tcanopy, myThid)
        CALL MNC_CW_RL_W(prec,bnam,0,0,'tdeep', tdeep, myThid)
        CALL MNC_CW_RL_W(prec,bnam,0,0,'ecanopy', ecanopy, myThid)
        CALL MNC_CW_RL_W(prec,bnam,0,0,'swetshal', swetshal, myThid)
        CALL MNC_CW_RL_W(prec,bnam,0,0,'swetroot', swetroot, myThid)
        CALL MNC_CW_RL_W(prec,bnam,0,0,'swetdeep', swetdeep, myThid)
        CALL MNC_CW_RL_W(prec,bnam,0,0,'snodep', snodep, myThid)
        CALL MNC_CW_RL_W(prec,bnam,0,0,'capac', capac, myThid)
        CALL MNC_CW_RL_W(prec,bnam,0,0,'chlt', chlt, myThid)
        CALL MNC_CW_RL_W(prec,bnam,0,0,'chlon', chlon, myThid)
        CALL MNC_CW_I_W('I',bnam,0,0,'igrd', igrd, myThid)

C       fizhi_earth_coms.h
        CALL MNC_CW_I_W('I',bnam,0,0,'ityp', ityp, myThid)
        CALL MNC_CW_RL_W(prec,bnam,0,0,'chfr', chfr, myThid)

      ENDIF
#endif /*  Not ALLOW_MNC sequence */


      call MDSFINDUNIT( iunit, mythid )
      length_of_rec=MDS_RECLEN( fileprec, nchp, mythid )

      DO bj = myByLo(myThid), myByHi(myThid)
      DO bi = myBxLo(myThid), myBxHi(myThid)

#ifdef ALLOW_EXCH2
       tn = W2_myTileList(bi,bj)
       iG = tn
       jG = 1
#else
       iG = bi+(myXGlobalLo-1)/sNx
       jG = bj+(myYGlobalLo-1)/sNy
       tn = (jG - 1)*(nPx*nSx) + iG
#endif /* ALLOW_EXCH2 */

       write(dataFname,'(a,2a,i3.3,a,i3.3,a)')
     &  'pickup_vegtiles.',fn(1:ilst),'.',iG,'.',jG,'.data'
       open( iUnit, file=dataFName, status='unknown',
     &       access='direct', recl=length_of_rec )

C First write single-level turbulence fields
       do n = 1,nchp
        r8seg(n) = ctmt(n,bi,bj)
       enddo
#ifdef _BYTESWAPIO
       call MDS_BYTESWAPR8( nchp, r8seg )
#endif
       write(iunit,rec=1) r8seg

       do n = 1,nchp
        r8seg(n) = xxmt(n,bi,bj)
       enddo
#ifdef _BYTESWAPIO
       call MDS_BYTESWAPR8( nchp, r8seg )
#endif
       write(iunit,rec=2) r8seg

       do n = 1,nchp
        r8seg(n) = yymt(n,bi,bj)
       enddo
#ifdef _BYTESWAPIO
       call MDS_BYTESWAPR8( nchp, r8seg )
#endif
       write(iunit,rec=3) r8seg

       do n = 1,nchp
        r8seg(n) = zetamt(n,bi,bj)
       enddo
#ifdef _BYTESWAPIO
       call MDS_BYTESWAPR8( nchp, r8seg )
#endif
       write(iunit,rec=4) r8seg

C And now write Multi-level turbulence fields
       do k = 1,Nrphys
        do n = 1,nchp
         r8seg(n) = xlmt(n,k,bi,bj)
        enddo
#ifdef _BYTESWAPIO
        call MDS_BYTESWAPR8( nchp, r8seg )
#endif
        irec = 4 + 0*Nrphys + k
        write(iunit,rec=irec) r8seg
       enddo

       do k = 1,Nrphys
        do n = 1,nchp
         r8seg(n) = khmt(n,k,bi,bj)
        enddo
#ifdef _BYTESWAPIO
        call MDS_BYTESWAPR8( nchp, r8seg )
#endif
        irec = 4 + 1*Nrphys + k
        write(iunit,rec=irec) r8seg
       enddo

       do k = 1,Nrphys
        do n = 1,nchp
         r8seg(n) = tke(n,k,bi,bj)
        enddo
#ifdef _BYTESWAPIO
        call MDS_BYTESWAPR8( nchp, r8seg )
#endif
        irec = 4 + 2*Nrphys + k
        write(iunit,rec=irec) r8seg
       enddo

C And finally, write land surface fields
       do n = 1,nchp
        r8seg(n) = tcanopy(n,bi,bj)
       enddo
#ifdef _BYTESWAPIO
       call MDS_BYTESWAPR8( nchp, r8seg )
#endif
       irec = 4 + 3*Nrphys + 1
       write(iunit,rec=irec) r8seg

       do n = 1,nchp
        r8seg(n) = tdeep(n,bi,bj)
       enddo
#ifdef _BYTESWAPIO
       call MDS_BYTESWAPR8( nchp, r8seg )
#endif
       irec = 4 + 3*Nrphys + 2
       write(iunit,rec=irec) r8seg

       do n = 1,nchp
        r8seg(n) = ecanopy(n,bi,bj)
       enddo
#ifdef _BYTESWAPIO
       call MDS_BYTESWAPR8( nchp, r8seg )
#endif
       irec = 4 + 3*Nrphys + 3
       write(iunit,rec=irec) r8seg

       do n = 1,nchp
        r8seg(n) = swetshal(n,bi,bj)
       enddo
#ifdef _BYTESWAPIO
       call MDS_BYTESWAPR8( nchp, r8seg )
#endif
       irec = 4 + 3*Nrphys + 4
       write(iunit,rec=irec) r8seg

       do n = 1,nchp
        r8seg(n) = swetroot(n,bi,bj)
       enddo
#ifdef _BYTESWAPIO
       call MDS_BYTESWAPR8( nchp, r8seg )
#endif
       irec = 4 + 3*Nrphys + 5
       write(iunit,rec=irec) r8seg

       do n = 1,nchp
        r8seg(n) = swetdeep(n,bi,bj)
       enddo
#ifdef _BYTESWAPIO
       call MDS_BYTESWAPR8( nchp, r8seg )
#endif
       irec = 4 + 3*Nrphys + 6
       write(iunit,rec=irec) r8seg

       do n = 1,nchp
        r8seg(n) = snodep(n,bi,bj)
       enddo
#ifdef _BYTESWAPIO
       call MDS_BYTESWAPR8( nchp, r8seg )
#endif
       irec = 4 + 3*Nrphys + 7
       write(iunit,rec=irec) r8seg

       do n = 1,nchp
        r8seg(n) = capac(n,bi,bj)
       enddo
#ifdef _BYTESWAPIO
       call MDS_BYTESWAPR8( nchp, r8seg )
#endif
       irec = 4 + 3*Nrphys + 8
       write(iunit,rec=irec) r8seg

       close(iunit)

C End of bi bj loop
      enddo
      enddo

      RETURN
      END


C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: FIZHI_READ_VEGTILES
C     !INTERFACE:
      SUBROUTINE FIZHI_READ_VEGTILES(Iter,prec,myThid)

C     !DESCRIPTION:

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "fizhi_SIZE.h"
#include "fizhi_land_SIZE.h"
#include "fizhi_coms.h"
#include "fizhi_land_coms.h"
#include "fizhi_earth_coms.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#ifdef ALLOW_MNC
#include "MNC_PARAMS.h"
#endif
#ifdef ALLOW_EXCH2
#include "W2_EXCH2_SIZE.h"
#include "W2_EXCH2_TOPOLOGY.h"
#endif /* ALLOW_EXCH2 */

      EXTERNAL ILNBLNK
      INTEGER ILNBLNK
      INTEGER MDS_RECLEN

C     !INPUT/OUTPUT PARAMETERS:
      CHARACTER*1 prec
      INTEGER Iter
      INTEGER myThid

CEOP
C     !LOCAL VARIABLES:
      CHARACTER*80 fn
      CHARACTER*80 bnam
      integer ilst
      character*(MAX_LEN_FNAM) dataFName
      integer i,k,n
      integer ig,jg,tn,iunit
      integer length_of_rec
      integer bi,bj,irec,fileprec
      Real*8 r8seg(nchp)

      DO i = 1,80
        bnam(i:i) = ' '
      ENDDO
      WRITE(fn,'(a,I10.10)') 'pickup_vegtiles.',Iter
      ilst = ILNBLNK(fn)
      WRITE(bnam,'(a,I10.10)') 'pickup_vegtiles.',Iter
      fileprec = 64

#ifdef ALLOW_MNC
      IF (useMNC.AND. pickup_write_mnc) THEN

C       Write fizhi veg-space variables using the MNC package
        CALL MNC_FILE_CLOSE_ALL_MATCHING(bnam, myThid)
        CALL MNC_CW_SET_UDIM(bnam, 1, myThid)

C       fizhi_coms.h
        CALL MNC_CW_RL_R(prec,bnam,0,0,'ctmt', ctmt, myThid)
        CALL MNC_CW_RL_R(prec,bnam,0,0,'xxmt', xxmt, myThid)
        CALL MNC_CW_RL_R(prec,bnam,0,0,'yymt', yymt, myThid)
        CALL MNC_CW_RL_R(prec,bnam,0,0,'zetamt', zetamt, myThid)
        CALL MNC_CW_RL_R(prec,bnam,0,0,'xlmt', xlmt, myThid)
        CALL MNC_CW_RL_R(prec,bnam,0,0,'khmt', khmt, myThid)
        CALL MNC_CW_RL_R(prec,bnam,0,0,'tke', tke, myThid)

C       fizhi_land_coms.h
        CALL MNC_CW_RL_R(prec,bnam,0,0,'tcanopy', tcanopy, myThid)
        CALL MNC_CW_RL_R(prec,bnam,0,0,'tdeep', tdeep, myThid)
        CALL MNC_CW_RL_R(prec,bnam,0,0,'ecanopy', ecanopy, myThid)
        CALL MNC_CW_RL_R(prec,bnam,0,0,'swetshal', swetshal, myThid)
        CALL MNC_CW_RL_R(prec,bnam,0,0,'swetroot', swetroot, myThid)
        CALL MNC_CW_RL_R(prec,bnam,0,0,'swetdeep', swetdeep, myThid)
        CALL MNC_CW_RL_R(prec,bnam,0,0,'snodep', snodep, myThid)
        CALL MNC_CW_RL_R(prec,bnam,0,0,'capac', capac, myThid)

      ENDIF
#endif /*  Not ALLOW_MNC sequence */

      call MDSFINDUNIT( iunit, mythid )
      length_of_rec=MDS_RECLEN( fileprec, nchp, mythid )

      DO bj = myByLo(myThid), myByHi(myThid)
      DO bi = myBxLo(myThid), myBxHi(myThid)

#ifdef ALLOW_EXCH2
       tn = W2_myTileList(bi,bj)
       iG = tn
       jG = 1
#else
       iG = bi+(myXGlobalLo-1)/sNx
       jG = bj+(myYGlobalLo-1)/sNy
       tn = (jG - 1)*(nPx*nSx) + iG
#endif /* ALLOW_EXCH2 */

       write(dataFname,'(2a,i3.3,a,i3.3,a)')
     &              fn(1:ilst),'.',iG,'.',jG,'.data'
       print *,' Opening ',dataFName(1:ilst+13)
       open( iUnit, file=dataFName, status='old',
     &       access='direct', recl=length_of_rec )

       irec = 0
C First read single-level turbulence fields
       read(iunit,rec=1) r8seg
#ifdef _BYTESWAPIO
       call MDS_BYTESWAPR8( nchp, r8seg )
#endif
       do n = 1,nchp
        ctmt(n,bi,bj) = r8seg(n)
       enddo

       read(iunit,rec=2) r8seg
#ifdef _BYTESWAPIO
       call MDS_BYTESWAPR8( nchp, r8seg )
#endif
       do n = 1,nchp
        xxmt(n,bi,bj) = r8seg(n)
       enddo

       read(iunit,rec=3) r8seg
#ifdef _BYTESWAPIO
       call MDS_BYTESWAPR8( nchp, r8seg )
#endif
       do n = 1,nchp
        yymt(n,bi,bj) = r8seg(n)
       enddo

       read(iunit,rec=4) r8seg
#ifdef _BYTESWAPIO
       call MDS_BYTESWAPR8( nchp, r8seg )
#endif
       do n = 1,nchp
        zetamt(n,bi,bj) = r8seg(n)
       enddo

C And now read Multi-level turbulence fields
       do k = 1,Nrphys
        irec = 4 + 0*Nrphys + k
        read(iunit,rec=irec) r8seg
#ifdef _BYTESWAPIO
        call MDS_BYTESWAPR8( nchp, r8seg )
#endif
        do n = 1,nchp
         xlmt(n,k,bi,bj) = r8seg(n)
        enddo
       enddo

       do k = 1,Nrphys
        irec = 4 + 1*Nrphys + k
        read(iunit,rec=irec) r8seg
#ifdef _BYTESWAPIO
        call MDS_BYTESWAPR8( nchp, r8seg )
#endif
        do n = 1,nchp
         khmt(n,k,bi,bj) = r8seg(n)
        enddo
       enddo

       do k = 1,Nrphys
        irec = 4 + 2*Nrphys + k
        read(iunit,rec=irec) r8seg
#ifdef _BYTESWAPIO
        call MDS_BYTESWAPR8( nchp, r8seg )
#endif
        do n = 1,nchp
         tke(n,k,bi,bj) = r8seg(n)
        enddo
       enddo

C And finally, read land surface fields
       irec = 4 + 3*Nrphys + 1
       read(iunit,rec=irec) r8seg
#ifdef _BYTESWAPIO
       call MDS_BYTESWAPR8( nchp, r8seg )
#endif
       do n = 1,nchp
        tcanopy(n,bi,bj) = r8seg(n)
       enddo

       irec = 4 + 3*Nrphys + 2
       read(iunit,rec=irec) r8seg
#ifdef _BYTESWAPIO
       call MDS_BYTESWAPR8( nchp, r8seg )
#endif
       do n = 1,nchp
        tdeep(n,bi,bj) = r8seg(n)
       enddo

       irec = 4 + 3*Nrphys + 3
       read(iunit,rec=irec) r8seg
#ifdef _BYTESWAPIO
       call MDS_BYTESWAPR8( nchp, r8seg )
#endif
       do n = 1,nchp
        ecanopy(n,bi,bj) = r8seg(n)
       enddo

       irec = 4 + 3*Nrphys + 4
       read(iunit,rec=irec) r8seg
#ifdef _BYTESWAPIO
       call MDS_BYTESWAPR8( nchp, r8seg )
#endif
       do n = 1,nchp
        swetshal(n,bi,bj) = r8seg(n)
       enddo

       irec = 4 + 3*Nrphys + 5
       read(iunit,rec=irec) r8seg
#ifdef _BYTESWAPIO
       call MDS_BYTESWAPR8( nchp, r8seg )
#endif
       do n = 1,nchp
        swetroot(n,bi,bj) = r8seg(n)
       enddo

       irec = 4 + 3*Nrphys + 6
       read(iunit,rec=irec) r8seg
#ifdef _BYTESWAPIO
       call MDS_BYTESWAPR8( nchp, r8seg )
#endif
       do n = 1,nchp
        swetdeep(n,bi,bj) = r8seg(n)
       enddo

       irec = 4 + 3*Nrphys + 7
       read(iunit,rec=irec) r8seg
#ifdef _BYTESWAPIO
       call MDS_BYTESWAPR8( nchp, r8seg )
#endif
       do n = 1,nchp
        snodep(n,bi,bj) = r8seg(n)
       enddo

       irec = 4 + 3*Nrphys + 8
       read(iunit,rec=irec) r8seg
#ifdef _BYTESWAPIO
       call MDS_BYTESWAPR8( nchp, r8seg )
#endif
       do n = 1,nchp
        capac(n,bi,bj) = r8seg(n)
       enddo

       close(iunit)

C End of bi bj loop
      enddo
      enddo


      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#include "BLING_OPTIONS.h"
#ifdef ALLOW_EXF
# include "EXF_OPTIONS.h"
#endif
#ifdef ALLOW_AUTODIFF
# include "AUTODIFF_OPTIONS.h"
#endif

CBOP
      SUBROUTINE BLING_MAIN( PTR_DIC, PTR_ALK, PTR_O2,
#ifndef USE_BLING_V1
     U           PTR_NO3, PTR_PO4, PTR_FE,
     U           PTR_DON, PTR_DOP,
#ifdef USE_SIBLING
     U           PTR_SI,
#endif
#ifdef ADVECT_PHYTO
     U           PTR_PHY,
#endif
#else
     U           PTR_PO4, PTR_DOP, PTR_FE,
#endif
     I           bi, bj, imin, imax, jmin, jmax,
     I           myTime, myIter, myThid)

C     ==================================================================
C     | subroutine bling_main
C     | o Updates all the tracers for the effects of air-sea exchange,
C     |   biological production, and remineralization.
C     | - The basic model includes 8 tracers
C     | - There is an optional tracer for phytoplankton biomass
C     | - River runoff is included here
C     ==================================================================

      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "PTRACERS_SIZE.h"
#include "PTRACERS_PARAMS.h"
#ifdef ALLOW_EXF
# include "EXF_INTERP_SIZE.h"
# include "EXF_FIELDS.h"
#endif
#include "BLING_VARS.h"
#ifdef ALLOW_AUTODIFF_TAMC
# include "tamc.h"
#endif

C     === Routine arguments ===
C     bi,bj         :: tile indices
C     iMin,iMax     :: computation domain: 1rst index range
C     jMin,jMax     :: computation domain: 2nd  index range
C     myTime        :: current time
C     myIter        :: current timestep
C     myThid        :: thread Id. number
      INTEGER bi, bj, imin, imax, jmin, jmax
      _RL     myTime
      INTEGER myIter
      INTEGER myThid
C     === Input ===
C     PTR_DIC       :: dissolved inorganic carbon
C     PTR_ALK       :: alkalinity
C     PTR_O2        :: oxygen concentration
C     PTR_FE        :: iron concentration
C     PTR_PO4       :: phosphate concentration
C     PTR_NO3       :: nitrate concentration
C     PTR_DOP       :: dissolved organic phosphorus concentration
C     PTR_DON       :: dissolved organic nitrogen concentration
C     PTR_PHY       :: total phytoplankton biomass
      _RL  PTR_DIC(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL  PTR_ALK(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL  PTR_O2 (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL  PTR_FE (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL  PTR_PO4(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL  PTR_DOP(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
#ifndef USE_BLING_V1
      _RL  PTR_NO3(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL  PTR_DON(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
#ifdef USE_SIBLING
      _RL  PTR_SI (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
#endif
#ifdef ADVECT_PHYTO
      _RL  PTR_PHY(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
#endif
#endif

C     === Local variables ===
C     i,j,k                :: loop indices
C     G_xxx                :: tendency term for tracer xxx
C     surf_DIC             :: tendency of DIC due to air-sea exchange
C     surf_Fe              :: tendency of Fe due to dust deposition
C     surf_O2              :: tendency of O2 due to air-sea exchange
C     FluxO2               :: air-sea O2 flux
C     runoff_PO4           :: tendency due to river runoff

       INTEGER i,j,k
      _RL  G_DIC(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL  G_ALK(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL  G_O2 (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL  G_FE (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL  G_PO4(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL  G_DOP(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL  surf_DIC(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL  surf_Fe(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL  surf_O2(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL  FluxO2(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL  runoff_PO4(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
#ifndef USE_BLING_V1
      _RL  G_NO3(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL  G_DON(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
#ifdef USE_SIBLING
      _RL  G_SI (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
#endif
#endif
#ifdef ALLOW_AUTODIFF_TAMC
C     tkey :: tape key (tile dependent)
      INTEGER tkey
#endif
CEOP

c-----------------------------------------------------------
c  Initialize local variables

#ifdef ALLOW_AUTODIFF_TAMC
      tkey = bi + (bj - 1)*nSx + (ikey_dynamics - 1)*nSx*nSy
#endif
      DO j=jmin,jmax
       DO i=imin,imax
        surf_DIC(i,j)        = 0. _d 0
        surf_O2(i,j)         = 0. _d 0
        surf_Fe(i,j)         = 0. _d 0
        fluxO2(i,j)          = 0. _d 0
        runoff_PO4(i,j)      = 0. _d 0
       ENDDO
      ENDDO
      DO j=jmin,jmax
       DO i=imin,imax
        DO k=1,Nr
         G_DIC(i,j,k)        = 0. _d 0
         G_ALK(i,j,k)        = 0. _d 0
         G_O2(i,j,k)         = 0. _d 0
         G_FE(i,j,k)         = 0. _d 0
         G_PO4(i,j,k)        = 0. _d 0
         G_DOP(i,j,k)        = 0. _d 0
#ifndef USE_BLING_V1
         G_NO3(i,j,k)        = 0. _d 0
         G_DON(i,j,k)        = 0. _d 0
#ifdef USE_SIBLING
         G_SI(i,j,k)         = 0. _d 0
#endif
#endif
        ENDDO
       ENDDO
      ENDDO

c-----------------------------------------------------------
c  carbon and oxygen air-sea interaction
       CALL BLING_AIRSEAFLUX(
     I                       PTR_DIC, PTR_ALK, PTR_O2, PTR_PO4,
#ifdef USE_SIBLING
     I                       PTR_SI,
#endif
     U                       surf_DIC, surf_O2, fluxO2,
     I                       bi, bj, imin, imax, jmin, jmax,
     I                       myTime, myIter, myThid)

#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE ph(:,:,:,bi,bj), ak0(:,:,bi,bj), fugf(:,:,bi,bj)
CADJ &     = comlev1_bibj, key = tkey, kind = isbyte
#endif

c-----------------------------------------------------------
c  determine calcite saturation for remineralization
       CALL BLING_CARBONATE_SYS(
     I                         PTR_DIC, PTR_ALK, PTR_PO4,
#ifdef USE_SIBLING
     I                         PTR_SI,
#endif
     I                         bi, bj, imin, imax, jmin, jmax,
     I                         myTime, myIter, myThid)

#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE omegaC(:,:,:,bi,bj) = comlev1_bibj, key=tkey, kind=isbyte
#endif

C-----------------------------------------------------------
C  biological activity
C  call either "BLING" or "BLING + nitrogen"
#ifndef USE_BLING_V1
       CALL BLING_BIO_NITROGEN(
     I                 PTR_O2, PTR_FE, PTR_PO4, PTR_DOP,
     I                 PTR_NO3, PTR_DON,
#ifdef USE_SIBLING
     I                 PTR_SI,
#endif
#ifdef ADVECT_PHYTO
     I                 PTR_PHY,
#endif
     U                 G_DIC, G_ALK, G_O2, G_FE,
     U                 G_PO4, G_DOP, G_NO3, G_DON,
#ifdef USE_SIBLING
     U                 G_SI,
#endif
     I                 bi, bj, imin, imax, jmin, jmax,
     I                 myTime, myIter, myThid)
#else
       CALL BLING_BIO(
     I                 PTR_O2, PTR_FE, PTR_PO4, PTR_DOP,
     U                 G_DIC, G_ALK, G_O2, G_FE,
     U                 G_PO4, G_DOP,
     I                 bi, bj, imin, imax, jmin, jmax,
     I                 myTime, myIter, myThid)
#endif

C-----------------------------------------------------------
C  Calculate river runoff source
C  Tracers are already diluted by freswater input, P-E+R
C  This accounts for tracer concentration in river runoff
C  no input south of 60S (it is ice melt)

#if (defined ALLOW_EXF && defined ALLOW_RUNOFF)
       DO j=jmin,jmax
        IF (YC(i,j,bi,bj).gt.-60.0) THEN
         DO i=imin,imax
          runoff_PO4(i,j) = river_conc_po4*runoff(i,j,bi,bj)
     &                       *recip_drF(1)*recip_hFacC(i,j,1,bi,bj)
         ENDDO
        ENDIF
       ENDDO
#endif

C-----------------------------------------------------------
C   adding surface tendencies due to air-sea exchange
C   adding surface tendencies due to river runoff
C   (assuming no dilution / runoff input for O2, Fe)
C   adding aeolian iron source

         DO j=jmin,jmax
          DO i=imin,imax

               G_DIC(i,j,1) = G_DIC(i,j,1) + surf_DIC(i,j)
     &                    + runoff_PO4(i,j)*CtoN*NtoP
               G_ALK(i,j,1) = G_ALK(i,j,1)
     &                    - runoff_PO4(i,j)*NtoP
               G_O2(i,j,1)  = G_O2(i,j,1) + surf_O2(i,j)
               surf_Fe(i,j) = alpfe*InputFe(i,j,bi,bj)
               G_FE(i,j,1)  = G_FE(i,j,1) + surf_Fe(i,j)
     &                    * recip_drF(1) * recip_hFacC(i,j,1,bi,bj)
               G_PO4(i,j,1) = G_PO4(i,j,1) + runoff_PO4(i,j)
               G_DOP(i,j,1) = G_DOP(i,j,1)
     &                    + runoff_PO4(i,j)*river_dom_to_nut
#ifndef USE_BLING_V1
               G_NO3(i,j,1) = G_NO3(i,j,1) + runoff_PO4(i,j)*NtoP
               G_DON(i,j,1) = G_DON(i,j,1)
     &                    + runoff_PO4(i,j)*NtoP*river_dom_to_nut

#endif
          ENDDO
         ENDDO

C-----------------------------------------------------------
C update
       DO k=1,Nr
         DO j=jmin,jmax
          DO i=imin,imax
           PTR_DIC(i,j,k)=PTR_DIC(i,j,k)+G_DIC(i,j,k)*PTRACERS_dTLev(k)
           PTR_ALK(i,j,k)=PTR_ALK(i,j,k)+G_ALK(i,j,k)*PTRACERS_dTLev(k)
           PTR_O2 (i,j,k)=PTR_O2 (i,j,k)+G_O2 (i,j,k)*PTRACERS_dTLev(k)
           PTR_FE (i,j,k)=PTR_FE (i,j,k)+G_FE (i,j,k)*PTRACERS_dTLev(k)
           PTR_PO4(i,j,k)=PTR_PO4(i,j,k)+G_PO4(i,j,k)*PTRACERS_dTLev(k)
           PTR_DOP(i,j,k)=PTR_DOP(i,j,k)+G_DOP(i,j,k)*PTRACERS_dTLev(k)
#ifndef USE_BLING_V1
           PTR_NO3(i,j,k)=PTR_NO3(i,j,k)+G_NO3(i,j,k)*PTRACERS_dTLev(k)
           PTR_DON(i,j,k)=PTR_DON(i,j,k)+G_DON(i,j,k)*PTRACERS_dTLev(k)
#ifdef USE_SIBLING
           PTR_SI (i,j,k)=PTR_SI (i,j,k)+G_SI (i,j,k)*PTRACERS_dTLev(k)
#endif
#endif
          ENDDO
         ENDDO
       ENDDO

C-----------------------------------------------------------
#ifdef ALLOW_DIAGNOSTICS
      IF ( useDiagnostics ) THEN
        CALL DIAGNOSTICS_FILL(pH      ,'BLGPH3D ',0,Nr,1,bi,bj,myThid)
        CALL DIAGNOSTICS_FILL(OmegaAr ,'BLGOMAR ',0,Nr,1,bi,bj,myThid)
        CALL DIAGNOSTICS_FILL(pCO2    ,'BLGPCO2 ',0,1 ,1,bi,bj,myThid)
        CALL DIAGNOSTICS_FILL(fluxCO2 ,'BLGCFLX ',0,1 ,1,bi,bj,myThid)
        CALL DIAGNOSTICS_FILL(fluxO2  ,'BLGOFLX ',0,1 ,2,bi,bj,myThid)
        CALL DIAGNOSTICS_FILL(surf_Fe ,'BLGSURFE',0,1, 2,bi,bj,myThid)
        CALL DIAGNOSTICS_FILL(apco2,'BLGapco2',0,1, 1,bi,bj,myThid)
      ENDIF
#endif /* ALLOW_DIAGNOSTICS */

       RETURN
       END

#include "CPP_OPTIONS.h"

      SUBROUTINE GATHER_XZ( global, local, myThid )
C     Gather elements of a x-z array from all mpi processes to process 0.
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "EESUPPORT.h"
C     mythid - thread number for this instance of the routine.
C     global,local - working arrays used to transfer 2-D fields
      INTEGER mythid 
      Real*8  global(Nx)
      _RL     local(1-OLx:sNx+OLx,nSx,nSy)

      INTEGER iG, i, bi, bj
#ifdef ALLOW_USE_MPI

      _RL     temp(1-OLx:sNx+OLx,nSx,nSy)

      INTEGER istatus(MPI_STATUS_SIZE), ierr
      INTEGER lbuff, idest, itag, npe, ready_to_receive
#endif /* ALLOW_USE_MPI */

C--   Make everyone wait except for master thread.
      _BARRIER
      _BEGIN_MASTER( myThid )

#ifndef ALLOW_USE_MPI

      DO bj=1,nSy
         DO bi=1,nSx
               DO i=1,sNx
                  iG = myXGlobalLo-1+(bi-1)*sNx+i
                  global(iG) = local(i,bi,bj)
               ENDDO
         ENDDO
      ENDDO

#else /* ALLOW_USE_MPI */

      lbuff = (sNx+2*OLx)*nSx*nSy
      idest = 0
      itag  = 0
      ready_to_receive = 0

      IF( mpiMyId .EQ. 0 ) THEN

C--   Process 0 fills-in its local data
         npe = 0
         DO bj=1,nSy
            DO bi=1,nSx
                  DO i=1,sNx
                     iG = mpi_myXGlobalLo(npe+1)-1+(bi-1)*sNx+i
                     global(iG) = local(i,bi,bj)
                  ENDDO
            ENDDO
         ENDDO

C--   Process 0 polls and receives data from each process in turn
         DO npe = 1, numberOfProcs-1
#ifndef DISABLE_MPI_READY_TO_RECEIVE
            CALL MPI_SEND (ready_to_receive, 1, MPI_INTEGER,
     &           npe, itag, MPI_COMM_MODEL, ierr)
#endif
            CALL MPI_RECV (temp, lbuff, MPI_DOUBLE_PRECISION,
     &           npe, itag, MPI_COMM_MODEL, istatus, ierr)

C--   Process 0 gathers the local arrays into a global array.
            DO bj=1,nSy
               DO bi=1,nSx
                     DO i=1,sNx
                        iG = mpi_myXGlobalLo(npe+1)-1+(bi-1)*sNx+i
                        global(iG) = temp(i,bi,bj)
                     ENDDO
                  ENDDO
            ENDDO
         ENDDO

      ELSE

C--   All proceses except 0 wait to be polled then send local array
#ifndef DISABLE_MPI_READY_TO_RECEIVE
         CALL MPI_RECV (ready_to_receive, 1, MPI_INTEGER,
     &        idest, itag, MPI_COMM_MODEL, istatus, ierr)
#endif
         CALL MPI_SEND (local, lbuff, MPI_DOUBLE_PRECISION,
     &        idest, itag, MPI_COMM_MODEL, ierr)

      ENDIF

#endif /* ALLOW_USE_MPI */

      _END_MASTER( myThid )
      _BARRIER

      RETURN
      END

#include "CPP_OPTIONS.h"

CBOP
C     !ROUTINE: UPDATE_ETAWS
C     !INTERFACE:
      SUBROUTINE UPDATE_ETAWS( myTime, myIter, myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE UPDATE_ETAWS
C     | o For hybrid sigma-coordinate, derive SSH value
C     |   (etaHw & etaHs) and SSH tendency (dEtaWdt & dEtaSdt)
C     |   at grid-cell Western and Southern edges.
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     == Global variables
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "DYNVARS.h"
#include "GRID.h"
#include "SURFACE.h"

C     !INPUT/OUTPUT PARAMETERS:
C     myTime  :: Current time in simulation
C     myIter  :: Current iteration number
C     myThid  :: my Thread Id number
      _RL myTime
      INTEGER myIter
      INTEGER myThid

#ifdef NONLIN_FRSURF
# ifndef DISABLE_SIGMA_CODE
C     !LOCAL VARIABLES:
C     i,j,bi,bj  :: Loop counters
      INTEGER i,j,bi,bj
CEOP

      IF ( nonlinFreeSurf.GT.0 .AND. selectSigmaCoord.NE.0 ) THEN

       DO bj=myByLo(myThid),myByHi(myThid)
        DO bi=myBxLo(myThid),myBxHi(myThid)
C-     1rst bi,bj loop :

C-- copy etaHX -> dEtaXdt
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
            dEtaWdt(i,j,bi,bj) = etaHw(i,j,bi,bj)
            dEtaSdt(i,j,bi,bj) = etaHs(i,j,bi,bj)
          ENDDO
         ENDDO

         DO j=1,sNy+1
          DO i=1,sNx+1
            etaHw(i,j,bi,bj)   = ( etaH (i-1,j,bi,bj)
     &                           + etaH ( i ,j,bi,bj) )*0.5 _d 0
            etaHs(i,j,bi,bj)   = ( etaH (i,j-1,bi,bj)
     &                           + etaH (i, j ,bi,bj) )*0.5 _d 0
c           etaHw(i,j,bi,bj)   = 0.5 _d 0
c    &                         *(   etaH (i-1,j,bi,bj)*rA(i-1,j,bi,bj)
c    &                            + etaH ( i ,j,bi,bj)*rA( i ,j,bi,bj)
c    &                          )*recip_rAw(i,j,bi,bj)
c           etaHs(i,j,bi,bj)   = 0.5 _d 0
c    &                         *(   etaH (i,j-1,bi,bj)*rA(i,j-1,bi,bj)
c    &                            + etaH (i, j ,bi,bj)*rA(i, j ,bi,bj)
c    &                          )*recip_rAs(i,j,bi,bj)
          ENDDO
         ENDDO

C- end 1rst bi,bj loop.
        ENDDO
       ENDDO

       CALL EXCH_UV_XY_RL( etaHw, etaHs, .FALSE., myThid )

       DO bj=myByLo(myThid),myByHi(myThid)
        DO bi=myBxLo(myThid),myBxHi(myThid)
C-     2nd bi,bj loop :

         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
            dEtaWdt(i,j,bi,bj) = ( etaHw(i,j,bi,bj)
     &                           - dEtaWdt(i,j,bi,bj) )/deltaTFreeSurf
            dEtaSdt(i,j,bi,bj) = ( etaHs(i,j,bi,bj)
     &                           - dEtaSdt(i,j,bi,bj) )/deltaTFreeSurf
          ENDDO
         ENDDO

C- end 2nd bi,bj loop.
        ENDDO
       ENDDO

      ENDIF
# endif /* DISABLE_SIGMA_CODE */
#endif /* NONLIN_FRSURF */

      RETURN
      END

#include "THSICE_OPTIONS.h"

CBOP
C     !ROUTINE: THSICE_READ_PICKUP
C     !INTERFACE:
      SUBROUTINE THSICE_READ_PICKUP( myIter, myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R THSICE_READ_PICKUP
C     | o Read thsice pickup file
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "THSICE_PARAMS.h"
#include "THSICE_VARS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
      INTEGER myIter
      INTEGER myThid
CEOP

#ifdef ALLOW_THSICE

C     == Local variables ==
      INTEGER prec
      CHARACTER*(10) suff
      CHARACTER*(MAX_LEN_FNAM) fn

      IF ( .NOT. thSIce_pickup_write_mnc ) THEN

        prec = precFloat64
        IF ( pickupSuff.EQ.' ' ) THEN
          IF ( rwSuffixType.EQ.0 ) THEN
            WRITE(fn,'(A,I10.10)') 'pickup_ic.', myIter
          ELSE
            CALL RW_GET_SUFFIX( suff, startTime, myIter, myThid )
            WRITE(fn,'(A,A)') 'pickup_ic.', suff
          ENDIF
        ELSE
          WRITE(fn,'(A,A10)')    'pickup_ic.', pickupSuff
        ENDIF
        CALL READ_REC_3D_RL( fn, prec, 1, iceMask,  1, myIter,myThid )
        CALL READ_REC_3D_RL( fn, prec, 1, iceHeight,2, myIter,myThid )
        CALL READ_REC_3D_RL( fn, prec, 1,snowHeight,3, myIter,myThid )
        CALL READ_REC_3D_RL( fn, prec, 1, Tsrf,     4, myIter,myThid )
        CALL READ_REC_3D_RL( fn, prec, 1, Tice1,    5, myIter,myThid )
        CALL READ_REC_3D_RL( fn, prec, 1, Tice2,    6, myIter,myThid )
        CALL READ_REC_3D_RL( fn, prec, 1, Qice1,    7, myIter,myThid )
        CALL READ_REC_3D_RL( fn, prec, 1, Qice2,    8, myIter,myThid )
        CALL READ_REC_3D_RL( fn, prec, 1, snowAge,  9, myIter,myThid )

        IF ( stepFwd_oceMxL .AND. startIceModel.EQ.0 )  THEN
          CALL READ_REC_3D_RL( fn,prec,1, tOceMxL, 10, myIter,myThid )
          CALL READ_REC_3D_RL( fn,prec,1, sOceMxL, 11, myIter,myThid )
        ENDIF

      ENDIF

#ifdef ALLOW_MNC
      IF ( thSIce_pickup_write_mnc ) THEN
        WRITE(fn,'(A)') 'pickup_ic'
        CALL MNC_FILE_CLOSE_ALL_MATCHING(fn, myThid)
        CALL MNC_CW_SET_UDIM(fn, 1, myThid)
        CALL MNC_CW_SET_CITER(fn, 3, 3, myIter, 0, myThid)
        CALL MNC_CW_RL_R('D',fn,0,0,'iceMask',   iceMask,   myThid)
        CALL MNC_CW_RL_R('D',fn,0,0,'iceHeight', iceHeight, myThid)
        CALL MNC_CW_RL_R('D',fn,0,0,'snowHeight',snowHeight,myThid)
        CALL MNC_CW_RL_R('D',fn,0,0,'Tsrf',      Tsrf,      myThid)
        CALL MNC_CW_RL_R('D',fn,0,0,'Tice1',     Tice1,     myThid)
        CALL MNC_CW_RL_R('D',fn,0,0,'Tice2',     Tice1,     myThid)
        CALL MNC_CW_RL_R('D',fn,0,0,'Qice1',     Qice1,     myThid)
        CALL MNC_CW_RL_R('D',fn,0,0,'Qice2',     Qice2,     myThid)
        CALL MNC_CW_RL_R('D',fn,0,0,'snowAge',   snowAge,   myThid)
        IF ( stepFwd_oceMxL ) THEN
          CALL MNC_CW_RL_R('D',fn,0,0,'tOceMxL',tOceMxL,myThid)
          CALL MNC_CW_RL_R('D',fn,0,0,'sOceMxL',sOceMxL,myThid)
        ENDIF
      ENDIF
#endif  /* ALLOW_MNC */

#endif  /* ALLOW_THSICE */
      RETURN
      END

#include "GAD_OPTIONS.h"
#ifdef ALLOW_PTRACERS
# include "PTRACERS_OPTIONS.h"
#endif
#ifdef ALLOW_AUTODIFF
# include "AUTODIFF_OPTIONS.h"
#endif

CBOP
C !ROUTINE: GAD_SOM_ADV_Y

C !INTERFACE: ==========================================================
      SUBROUTINE GAD_SOM_ADV_Y(
     I           bi,bj,k, limiter,
     I           overlapOnly, interiorOnly,
     I           N_edge, S_edge, E_edge, W_edge,
     I           deltaTloc, vTrans, maskIn,
     U           sm_v, sm_o, sm_x, sm_y, sm_z,
     U           sm_xx, sm_yy, sm_zz, sm_xy, sm_xz, sm_yz,
     O           vT,
     I           myThid )

C !DESCRIPTION:
C  Calculates the area integrated meridional flux due to advection
C  of a tracer using
C--
C        Second-Order Moments Advection of tracer in Y-direction
C        ref: M.J.Prather, 1986, JGR, 91, D6, pp 6671-6681.
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C      The 3-D grid has dimension  (Nx,Ny,Nz) with corresponding
C      velocity field (U,V,W).  Parallel subroutine calculate
C      advection in the X- and Z- directions.
C      The moment [Si] are as defined in the text, Sm refers to
C      the total mass in each grid box
C      the moments [Fi] are similarly defined and used as temporary
C      storage for portions of the grid boxes in transit.
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C !USES: ===============================================================
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "GAD.h"
#ifdef ALLOW_AUTODIFF_TAMC
# include "tamc.h"
#endif

C !INPUT PARAMETERS: ===================================================
C  bi,bj         :: tile indices
C  k             :: vertical level
C  limiter       :: 0: no limiter ; 1: Prather, 1986 limiter
C  overlapOnly   :: only update the edges of myTile, but not the interior
C  interiorOnly  :: only update the interior of myTile, but not the edges
C [N,S,E,W]_edge :: true if N,S,E,W edge of myTile is an Edge of the cube
C  vTrans        :: zonal volume transport
C  maskIn        :: 2-D array Interior mask
C  myThid        :: my Thread Id. number
      INTEGER bi,bj,k
      INTEGER limiter
      LOGICAL overlapOnly, interiorOnly
      LOGICAL N_edge, S_edge, E_edge, W_edge
      _RL deltaTloc
      _RL vTrans(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RS maskIn(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER myThid

C !OUTPUT PARAMETERS: ==================================================
C  sm_v         :: volume of grid cell
C  sm_o         :: tracer content of grid cell (zero order moment)
C  sm_x,y,z     :: 1rst order moment of tracer distribution, in x,y,z direction
C  sm_xx,yy,zz  ::  2nd order moment of tracer distribution, in x,y,z direction
C  sm_xy,xz,yz  ::  2nd order moment of tracer distr., in cross direction xy,xz,yz
C  vT           :: meridional advective flux
      _RL sm_v  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL sm_o  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL sm_x  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL sm_y  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL sm_z  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL sm_xx (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL sm_yy (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL sm_zz (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL sm_xy (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL sm_xz (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL sm_yz (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL vT    (1-OLx:sNx+OLx,1-OLy:sNy+OLy)

#if ( defined GAD_ALLOW_TS_SOM_ADV || defined PTRACERS_ALLOW_DYN_STATE )
C !LOCAL VARIABLES: ====================================================
C  i,j           :: loop indices
C  vLoc          :: volume transported (per time step)
C [iMin,iMax]Upd :: loop range to update tracer field
C [jMin,jMax]Upd :: loop range to update tracer field
C  nbStrips      :: number of strips (if region to update is splitted)
      _RL three
      PARAMETER( three = 3. _d 0 )
      INTEGER i,j
      INTEGER ns, nbStrips
      INTEGER iMinUpd(2), iMaxUpd(2), jMinUpd(2), jMaxUpd(2)
      _RL  recip_dT
      _RL  slpmax, s1max, s1new, s2new
      _RL  vLoc, alf1, alf1q, alpmn
      _RL  alfp, alpq, alp1, locTp
      _RL  alfn, alnq, aln1, locTn
      _RL  alp  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL  aln  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL  fp_v (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL  fn_v (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL  fp_o (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL  fn_o (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL  fp_x (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL  fn_x (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL  fp_y (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL  fn_y (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL  fp_z (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL  fn_z (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL  fp_xx(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL  fn_xx(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL  fp_yy(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL  fn_yy(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL  fp_zz(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL  fn_zz(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL  fp_xy(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL  fn_xy(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL  fp_xz(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL  fn_xz(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL  fp_yz(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL  fn_yz(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
CEOP

#ifdef ALLOW_AUTODIFF_TAMC
CADJ INIT somtape_y = COMMON, 2
#endif
      recip_dT = 0.
      IF ( deltaTloc.GT.zeroRL ) recip_dT = 1.0 _d 0 / deltaTloc

C-    Set loop ranges for updating tracer field (splitted in 2 strips)
      nbStrips   = 1
      iMinUpd(1) = 1-OLx
      iMaxUpd(1) = sNx+OLx
      jMinUpd(1) = 1-OLy+1
      jMaxUpd(1) = sNy+OLy-1
      IF ( overlapOnly ) THEN
C     update in overlap-Only
        IF ( S_edge ) jMinUpd(1) = 1
        IF ( N_edge ) jMaxUpd(1) = sNy
        IF ( W_edge ) THEN
          iMinUpd(1) = 1-OLx
          iMaxUpd(1) = 0
        ENDIF
        IF ( E_edge ) THEN
          IF ( W_edge ) nbStrips = 2
          iMinUpd(nbStrips) = sNx+1
          iMaxUpd(nbStrips) = sNx+OLx
        ENDIF
      ELSE
C     do not only update the overlap
        IF ( interiorOnly .AND. W_edge ) iMinUpd(1) = 1
        IF ( interiorOnly .AND. E_edge ) iMaxUpd(1) = sNx
      ENDIF

C--   start 1rst loop on strip number "ns"
      DO ns=1,nbStrips

      IF ( limiter.EQ.1 ) THEN
#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE sm_o,sm_y,sm_yy,sm_xy,sm_yz
CADJ &     = somtape_y, key = ns, kind = isbyte
#endif
       DO j=jMinUpd(1)-1,jMaxUpd(1)+1
        DO i=iMinUpd(ns),iMaxUpd(ns)
C     If flux-limiting transport is to be applied, place limits on
C     appropriate moments before transport.
         slpmax = 0.
         IF ( sm_o(i,j).GT.0. ) slpmax = sm_o(i,j)
         s1max = slpmax*1.5 _d 0
         s1new = MIN(  s1max, MAX(-s1max,sm_y(i,j)) )
         s2new = MIN( (slpmax+slpmax-ABS(s1new)/three),
     &                MAX(ABS(s1new)-slpmax,sm_yy(i,j))  )
         sm_xy(i,j) = MIN( slpmax, MAX(-slpmax,sm_xy(i,j)) )
         sm_yz(i,j) = MIN( slpmax, MAX(-slpmax,sm_yz(i,j)) )
         sm_y (i,j) = s1new
         sm_yy(i,j) = s2new
        ENDDO
       ENDDO
      ENDIF

#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE sm_o,sm_v,sm_x,sm_xx,sm_xy,sm_xz,sm_y,sm_yy,sm_yz,sm_z,sm_zz
CADJ &     = somtape_y, key = ns, kind = isbyte
#endif
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C---  part.1 : calculate flux for all moments
      DO j=jMinUpd(1),jMaxUpd(1)+1
       DO i=iMinUpd(ns),iMaxUpd(ns)
        vLoc = vTrans(i,j)*deltaTloc
C--    Flux from (j-1) to (j) when V>0 (i.e., take right side of box j-1)
        fp_v (i,j) = MAX( zeroRL,  vLoc )
        alp  (i,j) = fp_v(i,j)/sm_v(i,j-1)
        alpq       = alp(i,j)*alp(i,j)
        alp1       = 1. _d 0 - alp(i,j)
C-     Create temporary moments/masses for partial boxes in transit
C       use same indexing as velocity, "p" for positive V
        fp_o (i,j) = alp(i,j)*( sm_o(i,j-1) + alp1*sm_y(i,j-1)
     &                        + alp1*(alp1-alp(i,j))*sm_yy(i,j-1)
     &                        )
        fp_y (i,j) = alpq    *( sm_y(i,j-1) + three*alp1*sm_yy(i,j-1) )
        fp_yy(i,j) = alp(i,j)*alpq*sm_yy(i,j-1)
        fp_x (i,j) = alp(i,j)*( sm_x(i,j-1) + alp1*sm_xy(i,j-1) )
        fp_z (i,j) = alp(i,j)*( sm_z(i,j-1) + alp1*sm_yz(i,j-1) )

        fp_xy(i,j) = alpq    *sm_xy(i,j-1)
        fp_yz(i,j) = alpq    *sm_yz(i,j-1)
        fp_xx(i,j) = alp(i,j)*sm_xx(i,j-1)
        fp_zz(i,j) = alp(i,j)*sm_zz(i,j-1)
        fp_xz(i,j) = alp(i,j)*sm_xz(i,j-1)
C--    Flux from (j) to (j-1) when V<0 (i.e., take left side of box j)
        fn_v (i,j) = MAX( zeroRL, -vLoc )
        aln  (i,j) = fn_v(i,j)/sm_v(i, j )
        alnq       = aln(i,j)*aln(i,j)
        aln1       = 1. _d 0 - aln(i,j)
C-     Create temporary moments/masses for partial boxes in transit
C       use same indexing as velocity, "n" for negative V
        fn_o (i,j) = aln(i,j)*( sm_o(i, j ) - aln1*sm_y(i, j )
     &                        + aln1*(aln1-aln(i,j))*sm_yy(i, j )
     &                        )
        fn_y (i,j) = alnq    *( sm_y(i, j ) - three*aln1*sm_yy(i, j ) )
        fn_yy(i,j) = aln(i,j)*alnq*sm_yy(i, j )
        fn_x (i,j) = aln(i,j)*( sm_x(i, j ) - aln1*sm_xy(i, j ) )
        fn_z (i,j) = aln(i,j)*( sm_z(i, j ) - aln1*sm_yz(i, j ) )
        fn_xy(i,j) = alnq    *sm_xy(i, j )
        fn_yz(i,j) = alnq    *sm_yz(i, j )
        fn_xx(i,j) = aln(i,j)*sm_xx(i, j )
        fn_zz(i,j) = aln(i,j)*sm_zz(i, j )
        fn_xz(i,j) = aln(i,j)*sm_xz(i, j )
C--    Save zero-order flux:
        vT(i,j) = ( fp_o(i,j) - fn_o(i,j) )*recip_dT
       ENDDO
      ENDDO

C--   end 1rst loop on strip number "ns"
c     ENDDO

#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE sm_o,sm_v,sm_x,sm_y,sm_z,sm_xy,sm_yy,sm_yz
CADJ &     = somtape_y, key = ns, kind = isbyte
#endif
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C--   start 2nd loop on strip number "ns"
c     DO ns=1,nbStrips

C---  part.2 : re-adjust moments remaining in the box
C      take off from grid box (j): negative V(j) and positive V(j+1)
      DO j=jMinUpd(1),jMaxUpd(1)
       DO i=iMinUpd(ns),iMaxUpd(ns)
#ifdef ALLOW_OBCS
        IF ( maskIn(i,j).NE.zeroRS ) THEN
#endif /* ALLOW_OBCS */
        alf1  = 1. _d 0 - aln(i,j) - alp(i,j+1)
        alf1q = alf1*alf1
        alpmn = alp(i,j+1) - aln(i,j)
        sm_v (i,j) = sm_v (i,j) - fn_v (i,j) - fp_v (i,j+1)
        sm_o (i,j) = sm_o (i,j) - fn_o (i,j) - fp_o (i,j+1)
        sm_y (i,j) = alf1q*( sm_y(i,j) - three*alpmn*sm_yy(i,j) )
        sm_yy(i,j) = alf1*alf1q*sm_yy(i,j)
        sm_xy(i,j) = alf1q*sm_xy(i,j)
        sm_yz(i,j) = alf1q*sm_yz(i,j)
        sm_x (i,j) = sm_x (i,j) - fn_x (i,j) - fp_x (i,j+1)
        sm_xx(i,j) = sm_xx(i,j) - fn_xx(i,j) - fp_xx(i,j+1)
        sm_z (i,j) = sm_z (i,j) - fn_z (i,j) - fp_z (i,j+1)
        sm_zz(i,j) = sm_zz(i,j) - fn_zz(i,j) - fp_zz(i,j+1)
        sm_xz(i,j) = sm_xz(i,j) - fn_xz(i,j) - fp_xz(i,j+1)
#ifdef ALLOW_OBCS
        ENDIF
#endif /* ALLOW_OBCS */
       ENDDO
      ENDDO

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C---  part.3 : Put the temporary moments into appropriate neighboring boxes
C      add into grid box (j): positive V(j) and negative V(j+1)
      DO j=jMinUpd(1),jMaxUpd(1)
       DO i=iMinUpd(ns),iMaxUpd(ns)
#ifdef ALLOW_OBCS
        IF ( maskIn(i,j).NE.zeroRS ) THEN
#endif /* ALLOW_OBCS */
        sm_v (i,j) = sm_v (i,j) + fp_v (i,j) + fn_v (i,j+1)
        alfp = fp_v(i, j )/sm_v(i,j)
        alfn = fn_v(i,j+1)/sm_v(i,j)
        alf1 = 1. _d 0 - alfp - alfn
        alp1 = 1. _d 0 - alfp
        aln1 = 1. _d 0 - alfn
        alpmn = alfp - alfn
        locTp = alfp*sm_o(i,j) - alp1*fp_o(i,j)
        locTn = alfn*sm_o(i,j) - aln1*fn_o(i,j+1)
        sm_yy(i,j) = alf1*alf1*sm_yy(i,j) + alfp*alfp*fp_yy(i,j)
     &                                    + alfn*alfn*fn_yy(i,j+1)
     &   - 5. _d 0*(-alpmn*alf1*sm_y(i,j) + alfp*alp1*fp_y(i,j)
     &                                    - alfn*aln1*fn_y(i,j+1)
     &             + twoRL*alfp*alfn*sm_o(i,j) + (alp1-alfp)*locTp
     &                                         + (aln1-alfn)*locTn
     &             )
        sm_xy(i,j) = alf1*sm_xy(i,j) + alfp*fp_xy(i,j)
     &                               + alfn*fn_xy(i,j+1)
     &     + three*( alpmn*sm_x(i,j) - alp1*fp_x(i,j)
     &                               + aln1*fn_x(i,j+1)
     &             )
        sm_yz(i,j) = alf1*sm_yz(i,j) + alfp*fp_yz(i,j)
     &                               + alfn*fn_yz(i,j+1)
     &     + three*( alpmn*sm_z(i,j) - alp1*fp_z(i,j)
     &                               + aln1*fn_z(i,j+1)
     &             )
        sm_y (i,j) = alf1*sm_y(i,j) + alfp*fp_y(i,j) + alfn*fn_y(i,j+1)
     &             + three*( locTp - locTn )
        sm_o (i,j) = sm_o (i,j) + fp_o (i,j) + fn_o (i,j+1)
        sm_x (i,j) = sm_x (i,j) + fp_x (i,j) + fn_x (i,j+1)
        sm_xx(i,j) = sm_xx(i,j) + fp_xx(i,j) + fn_xx(i,j+1)
        sm_z (i,j) = sm_z (i,j) + fp_z (i,j) + fn_z (i,j+1)
        sm_zz(i,j) = sm_zz(i,j) + fp_zz(i,j) + fn_zz(i,j+1)
        sm_xz(i,j) = sm_xz(i,j) + fp_xz(i,j) + fn_xz(i,j+1)
#ifdef ALLOW_OBCS
        ENDIF
#endif /* ALLOW_OBCS */
       ENDDO
      ENDDO

C--   end 2nd loop on strip number "ns"
      ENDDO
#endif /* GAD_ALLOW_TS_SOM_ADV or PTRACERS_ALLOW_DYN_STATE */

      RETURN
      END

#include "PTRACERS_OPTIONS.h"
#include "GAD_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: PTRACERS_CHECK

C     !INTERFACE:
      SUBROUTINE PTRACERS_CHECK( myThid )

C     !DESCRIPTION:
C     Print summary of PTRACERS setting and Check dependances
C     with main model and other packages

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "PTRACERS_SIZE.h"
#include "PTRACERS_PARAMS.h"
#include "GAD.h"

C     !INPUT PARAMETERS:
      INTEGER myThid
CEOP

#ifdef ALLOW_PTRACERS
C     !LOCAL VARIABLES:
C     iTracer    :: tracer index
C     iUnit      :: unit number for I/O
C     msgBuf     :: Informational/error message buffer
      INTEGER iTracer
      INTEGER iUnit, errCount
      CHARACTER*(MAX_LEN_MBUF) msgBuf

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      _BEGIN_MASTER(myThid)
      errCount = 0

      WRITE(msgBuf,'(A)') 'PTRACERS_CHECK: #define ALLOW_PTRACERS'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )

C--   Print a summary of pTracer parameter values:
      iUnit = standardMessageUnit
      WRITE(msgBuf,'(A)') '// ==================================='
      CALL PRINT_MESSAGE( msgBuf, iUnit, SQUEEZE_RIGHT , myThid )
      WRITE(msgBuf,'(A)') '// PTRACERS parameters '
      CALL PRINT_MESSAGE( msgBuf, iUnit, SQUEEZE_RIGHT , myThid )
      WRITE(msgBuf,'(A)') '// ==================================='
      CALL PRINT_MESSAGE( msgBuf, iUnit, SQUEEZE_RIGHT , myThid )
      CALL WRITE_0D_I( PTRACERS_numInUse, INDEX_NONE,
     &   'PTRACERS_numInUse =',
     &   ' /* number of tracers */')
      CALL WRITE_0D_I( PTRACERS_Iter0, INDEX_NONE,
     &   'PTRACERS_Iter0 =',
     &   ' /* timestep number when tracers are initialized */')
      CALL WRITE_0D_L( PTRACERS_startAllTrc, INDEX_NONE,
     &   'PTRACERS_startAllTrc =','/* all tracers start @ startTime */')
      CALL WRITE_0D_L( PTRACERS_doAB_onGpTr, INDEX_NONE,
     &   'PTRACERS_doAB_onGpTr =',
     &   '/* apply AB on Tendencies (rather than on Tracers) */')
      CALL WRITE_0D_L( PTRACERS_addSrelax2EmP, INDEX_NONE,
     &   'PTRACERS_addSrelax2EmP =','/* add Salt relaxation to EmP */')
      CALL WRITE_1D_RL( PTRACERS_dTLev, Nr, INDEX_K,
     &   'PTRACERS_dTLev =',
     &'   /* Ptracer timestep ( s ) */')
      CALL WRITE_0D_RL(PTRACERS_monitorFreq, INDEX_NONE,
     &   'PTRACERS_monitorFreq =',
     &   ' /* Frequency^-1 for monitor output (s) */')
      CALL WRITE_0D_RL(PTRACERS_dumpFreq, INDEX_NONE,
     &   'PTRACERS_dumpFreq =',
     &   ' /* Frequency^-1 for snapshot output (s) */')
      CALL WRITE_0D_L( PTRACERS_useRecords, INDEX_NONE,
     &   'PTRACERS_useRecords =', ' /* all tracers in 1 file */')

      CALL WRITE_0D_L( PTRACERS_snapshot_mnc, INDEX_NONE,
     &     'PTRACERS_snapshot_mnc =',
     &     ' /* use MNC for snapshot output */')
      CALL WRITE_0D_L( PTRACERS_pickup_write_mnc, INDEX_NONE,
     &     'PTRACERS_pickup_write_mnc =',
     &     ' /* use MNC for writing pickups */')
      CALL WRITE_0D_L( PTRACERS_pickup_read_mnc, INDEX_NONE,
     &     'PTRACERS_pickup_read_mnc =',
     &     ' /* use MNC for reading pickups */')

      DO iTracer=1,PTRACERS_numInUse
        WRITE(msgBuf,'(A)') ' -----------------------------------'
        CALL PRINT_MESSAGE( msgBuf, iUnit, SQUEEZE_RIGHT, myThid )
        WRITE(msgBuf,'(A,I4)') ' tracer number : ',iTracer
        CALL PRINT_MESSAGE( msgBuf, iUnit, SQUEEZE_RIGHT, myThid )
        CALL WRITE_0D_C( PTRACERS_names(iTracer), -1, INDEX_NONE,
     &     'PTRACERS_names =', ' /* Tracer short name */')
        CALL WRITE_0D_C( PTRACERS_long_names(iTracer), -1, INDEX_NONE,
     &     'PTRACERS_long_names =', ' /* Tracer long name */')
        CALL WRITE_0D_C( PTRACERS_ioLabel(iTracer), 0, INDEX_NONE,
     &     'PTRACERS_ioLabel =', ' /* tracer IO Label */')
        IF ( .NOT.PTRACERS_startAllTrc )
     &  CALL WRITE_0D_RL( PTRACERS_startStepFwd(iTracer), INDEX_NONE,
     &     'PTRACERS_startStepFwd =', ' /* tracer starting time */')
        CALL WRITE_0D_I( PTRACERS_advScheme(iTracer), INDEX_NONE,
     &     'PTRACERS_advScheme =', ' /* Advection Scheme */')
        CALL WRITE_0D_L( PTRACERS_SOM_Advection(iTracer), INDEX_NONE,
     &     'PTRACERS_SOM_Advection =',
     &     ' /* tracer uses SOM advection scheme */')
        CALL WRITE_0D_L( PTRACERS_ImplVertAdv(iTracer), INDEX_NONE,
     &     'PTRACERS_ImplVertAdv =',
     &     ' /* implicit vert. advection flag */')
        CALL WRITE_0D_L( PTRACERS_MultiDimAdv(iTracer), INDEX_NONE,
     &     'PTRACERS_MultiDimAdv =',
     &     ' /* tracer uses Multi-Dim advection */')
        CALL WRITE_0D_L( PTRACERS_AdamsBashGtr(iTracer), INDEX_NONE,
     &     'PTRACERS_AdamsBashGtr =',
     &     ' /* apply AB on tracer tendency */')
        CALL WRITE_0D_L( PTRACERS_AdamsBash_Tr(iTracer), INDEX_NONE,
     &     'PTRACERS_AdamsBash_Tr =',
     &     ' /* apply AB on passive tracer */')
        CALL WRITE_0D_RL( PTRACERS_diffKh(iTracer), INDEX_NONE,
     &     'PTRACERS_diffKh =', ' /* Laplacian Diffusivity */')
        CALL WRITE_0D_RL( PTRACERS_diffK4(iTracer), INDEX_NONE,
     &     'PTRACERS_diffK4 =', ' /* Biharmonic Diffusivity */')
        CALL WRITE_1D_RL( PTRACERS_diffKrNr(1,iTracer), Nr, INDEX_K,
     &     'PTRACERS_diffKrNr =', ' /* Vertical Diffusivity */')
        CALL WRITE_0D_L( PTRACERS_useGMRedi(iTracer), INDEX_NONE,
     &     'PTRACERS_useGMRedi =', ' /* apply GM-Redi */')
        CALL WRITE_0D_L( PTRACERS_useDWNSLP(iTracer), INDEX_NONE,
     &     'PTRACERS_useDWNSLP =', ' /* apply DOWN-SLOPE Flow */')
        CALL WRITE_0D_L( PTRACERS_useKPP(iTracer), INDEX_NONE,
     &     'PTRACERS_useKPP =', ' /* apply KPP scheme */')
#ifdef GAD_SMOLARKIEWICZ_HACK
        CALL WRITE_0D_L( PTRACERS_stayPositive(iTracer), INDEX_NONE,
     &     'PTRACERS_stayPositive =',
     &     ' /* use Smolarkiewicz Hack for this tracer */')
#endif
        CALL WRITE_1D_RL( PTRACERS_ref(1,iTracer), Nr, INDEX_K,
     &     'PTRACERS_ref =', ' /* Reference vertical profile */')
        CALL WRITE_0D_RL( PTRACERS_EvPrRn(iTracer), INDEX_NONE,
     &     'PTRACERS_EvPrRn =', '/* tracer conc. in Evap. & Rain */')

      ENDDO
      WRITE(msgBuf,'(A)') ' -----------------------------------'
      CALL PRINT_MESSAGE( msgBuf, iUnit, SQUEEZE_RIGHT, myThid )

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      IF ( PTRACERS_Iter0.GE.nEndIter ) THEN
        WRITE(msgBuf,'(2A)') '** WARNING ** PTRACERS_CHECK:',
     &       ' PTRACERS_Iter0 beyond run-end (=nEndIter)'
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
        WRITE(msgBuf,'(2A)') '** WARNING ** PTRACERS_CHECK:',
     &       ' ==> do not load initial conditions nor pickup file'
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
      ELSEIF ( PTRACERS_Iter0.GT.nIter0 ) THEN
        WRITE(msgBuf,'(2A)') 'PTRACERS_CHECK:',
     &       ' wrong setting of PTRACERS_Iter0 :'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(2A)') 'PTRACERS_CHECK:',
     &       ' nIter0 < PTRACERS_Iter0 < nEndIter not supported'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF

#ifndef INCLUDE_IMPLVERTADV_CODE
      DO iTracer=1,PTRACERS_numInUse
       IF ( PTRACERS_ImplVertAdv(iTracer) ) THEN
        WRITE(msgBuf,'(A)')
     &   'PTRACERS_CHECK: #undef INCLUDE_IMPLVERTADV_CODE'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(2A,I4,A)') 'PTRACERS_CHECK:',
     &   ' but pTracers_ImplVertAdv(',iTracer,' ) is TRUE'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
       ENDIF
      ENDDO
      IF ( PTRACERS_dTLev(1).NE.PTRACERS_dTLev(Nr)
     &     .AND. implicitDiffusion ) THEN
        WRITE(msgBuf,'(A)')
     &   'PTRACERS_CHECK: #undef INCLUDE_IMPLVERTADV_CODE'
        CALL PRINT_ERROR( msgBuf , myThid)
        WRITE(msgBuf,'(2A)') 'PTRACERS_CHECK: ',
     &   'but implicitDiffusion=T with non-uniform PTRACERS_dTLev'
        CALL PRINT_ERROR( msgBuf , myThid)
        errCount = errCount + 1
      ENDIF
#endif
      DO iTracer=1,PTRACERS_numInUse
       IF ( PTRACERS_useGMRedi(iTracer) .AND. .NOT.useGMRedi ) THEN
        WRITE(msgBuf,'(2A,I4,A)') 'PTRACERS_CHECK:',
     &    ' pTracers_useGMRedi(',iTracer,' ) is TRUE'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(A,L5,A)')
     &    'PTRACERS_CHECK: But not useGMRedi (=',useGMRedi,')'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
       ENDIF
       IF ( PTRACERS_useDWNSLP(iTracer) .AND. .NOT.useDOWN_SLOPE ) THEN
        WRITE(msgBuf,'(2A,I4,A)') 'PTRACERS_CHECK:',
     &    ' pTracers_useDWNSLP(',iTracer,' ) is TRUE'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(2A,L5,A)') 'PTRACERS_CHECK:',
     &    ' But not useDOWN_SLOPE (=', useDOWN_SLOPE, ')'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
       ENDIF
       IF ( PTRACERS_useKPP(iTracer) .AND. .NOT.useKPP ) THEN
        WRITE(msgBuf,'(2A,I4,A)') 'PTRACERS_CHECK:',
     &    ' pTracers_useKPP(',iTracer,' ) is TRUE'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(A,L5,A)')
     &    'PTRACERS_CHECK: But not useKPP (=',useKPP,')'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
       ENDIF
#ifndef GAD_SMOLARKIEWICZ_HACK
       IF ( PTRACERS_stayPositive(iTracer) ) THEN
        WRITE(msgBuf,'(2A)') 'PTRACERS_CHECK:',
     &    ' Smolarkiewicz Hack code is not compiled'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(2A,I4,A)') 'PTRACERS_CHECK:',
     &    ' but needed to keep pTracer(', iTracer, ' ) positive.'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(2A)') 'PTRACERS_CHECK: Re-compile with: ',
     &    ' #define GAD_SMOLARKIEWICZ_HACK in GAD_OPTIONS.h'
        CALL PRINT_ERROR( msgBuf , myThid)
        errCount = errCount + 1
       ENDIF
#endif /* ndef GAD_SMOLARKIEWICZ_HACK */
#ifndef PTRACERS_ALLOW_DYN_STATE
       IF ( PTRACERS_SOM_Advection(iTracer) ) THEN
        WRITE(msgBuf,'(2A,I4,A)') 'PTRACERS_CHECK:',
     &    ' PTRACERS_SOM_Advection(', iTracer, ') = T, but'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(3A)') 'PTRACERS_CHECK:',
     &    ' PTRACERS_ALLOW_DYN_STATE is not defined',
     &    ' in PTRACERS_OPTIONS.h.'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
       ENDIF
#endif
      ENDDO

      IF ( errCount.GE.1 ) THEN
        WRITE(msgBuf,'(A,I5,A)')
     &       'PTRACERS_CHECK: detected', errCount,' fatal error(s)'
        CALL PRINT_ERROR( msgBuf, myThid )
        CALL ALL_PROC_DIE( 0 )
        STOP 'ABNORMAL END: S/R PTRACERS_CHECK'
      ENDIF

      _END_MASTER(myThid)
C     Everyone else must wait for the parameters to be loaded
      _BARRIER

#endif /* ALLOW_PTRACERS */

      RETURN
      END

#include "STREAMICE_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

CBOP

      SUBROUTINE STREAMICE_TRIDIAG_SOLVE(
     U                               cg_Uin,     ! x-velocities
     U                               cg_Vin,     ! x-velocities
     U                               cg_Bu,      ! force in x dir
     I                               A_uu,       ! section of matrix that multiplies u and projects on u
     I                               umask,
     I                               myThid )
C     /============================================================\
C     | SUBROUTINE                                                 |
C     | o                                                          |
C     |============================================================|
C     |                                                            |
C     \============================================================/
      IMPLICIT NONE

#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "STREAMICE.h"
#include "STREAMICE_CG.h"

      _RL cg_Uin (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL cg_Vin (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL cg_Bu (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL A_uu (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy,-1:1,-1:1)
      _RS umask (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      INTEGER myThid

      INTEGER iMin,iMax,i,j,k
      _RL aMat(1:Nx)
      _RL bMat(1:Nx)
      _RL cMat(1:Nx)
      _RL yMat(1:Nx)
      _RL bet(1:Nx)
      _RL tmpvar
      INTEGER errCode


!      CALL WRITE_FLD_XY_RL ("taud_tri","",cg_Bu,0,mythid)
!      CALL WRITE_FLD_XY_RL ("A_m1m1","",A_uu(:,:,:,:,-1,-1),0,mythid)
!      CALL WRITE_FLD_XY_RL ("A_m1_0","",A_uu(:,:,:,:,-1,0),0,mythid)
!      CALL WRITE_FLD_XY_RL ("A_m1p1","",A_uu(:,:,:,:,-1,1),0,mythid)
!      CALL WRITE_FLD_XY_RL ("A_0_m1","",A_uu(:,:,:,:,0,-1),0,mythid)
!      CALL WRITE_FLD_XY_RL ("A_0_0","",A_uu(:,:,:,:,0,0),0,mythid)
!      CALL WRITE_FLD_XY_RL ("A_0_p1","",A_uu(:,:,:,:,0,1),0,mythid)
!      CALL WRITE_FLD_XY_RL ("A_p1m1","",A_uu(:,:,:,:,1,-1),0,mythid)
!      CALL WRITE_FLD_XY_RL ("A_p1_0","",A_uu(:,:,:,:,1,0),0,mythid)
!      CALL WRITE_FLD_XY_RL ("A_p1p1","",A_uu(:,:,:,:,1,1),0,mythid)



      IF (nPx.gt.1 .or. nSx.gt.1) THEN
       STOP 'must be serial for tridiag solve'
      ENDIF

      errCode = 0

      imax = 0
      iMin = 2
      do i=imin,Nx
       if (umask(i,1,1,1).eq.1.0) THEN

        aMat(i)=0.0
        bmat(i)=0.0
        cmat(i)=0.0
        ymat(i)=0.0
        do j=-1,1
        do k=1,3
        aMat(i) = amat(i)+A_uu(i,k,1,1,-1,j)
        bMat(i) = bmat(i)+A_uu(i,k,1,1,0,j)
        cMat(i) = cmat(i)+A_uu(i,k,1,1,1,j)
        enddo
        yMat(i) = ymat(i)+cg_Bu(i,j+2,1,1)
        enddo
       else
        iMax = i-1
        exit
       endif
      enddo

      IF(imax.eq.0) THEN
       imax=Nx
      ENDIF


      IF ( bMat(imin).NE.0. _d 0 ) THEN
       bet(imin) = 1. _d 0 / bMat(imin)
      ELSE
       bet(imin) = 0. _d 0
       errCode = 1
      ENDIF

      DO i=imin+1,imax
       tmpvar = bmat(i) - amat(i)*cmat(i-1)*bet(i-1)
       IF ( tmpvar .NE. 0. _d 0 ) THEN
        bet(i) = 1. _d 0 / tmpvar
       ELSE
        bet(i) = 0. _d 0
        errCode = 1
       ENDIF
      ENDDO


      ymat(imin) = ymat(imin)*bet(imin)

      DO i=imin+1,imax
       ymat(i) = ( ymat(i)
     &            - amat(i)*ymat(i-1)
     &            )*bet(i)
      ENDDO


      DO i=imax-1,imin,-1
          ymat(i) = ymat(i)
     &     - cmat(i)*bet(i)*ymat(i+1)
      ENDDO

      DO j=1,sNy
       DO i=imin,imax
        cg_Uin (i,j,1,1) = ymat(i)
       ENDDO
      ENDDO

      DO j=1,sNy
       DO i=1,sNx
        cg_Vin (i,j,1,1) = 0. _d 0
       ENDDO
      ENDDO

      print *, "ERRORCODE", errcode

      RETURN
      END

#include "THSICE_OPTIONS.h"
#ifdef ALLOW_BULK_FORCE
#include "BULK_FORCE_OPTIONS.h"
#endif

CBOP
C     !ROUTINE: THSICE_GET_BULKF
C     !INTERFACE:
      SUBROUTINE THSICE_GET_BULKF(
     I                  bi, bj,
     I                  iMin,iMax, jMin,jMax,
     I                  icFlag, hSnow, Tsf,
     O                  flxExcSw, dFlxdT, evap, dEvdT,
     I                  myTime, myIter, myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R  THSICE_GET_BULKF
C     *==========================================================*
C     | Interface S/R : get Surface Fluxes from pkg BULK_FORCE
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     == Global data ==
#include "SIZE.h"
#ifdef ALLOW_BULK_FORCE
#include "EEPARAMS.h"
#include "BULKF_PARAMS.h"
#include "BULKF.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
C     bi,bj       :: tile indices
C     iMin,iMax   :: computation domain: 1rst index range
C     jMin,jMax   :: computation domain: 2nd  index range
C     icFlag     :: sea-ice fractional mask [0-1]
C     icFlag     :: True= get fluxes at this location ; False= do nothing
C     hSnow       :: snow height [m]
C     Tsf         :: surface (ice or snow) temperature (oC)
C     flxExcSw    :: net (downward) surface heat flux, except short-wave [W/m2]
C     dFlxdT      :: deriv of flx with respect to Tsf    [W/m/K]
C     evap        :: surface evaporation (>0 if evaporate) [kg/m2/s]
C     dEvdT       :: deriv of evap. with respect to Tsf  [kg/m2/s/K]
C     myThid      :: Thread no. that called this routine.
      INTEGER bi, bj
      INTEGER iMin, iMax
      INTEGER jMin, jMax
      _RL     icFlag  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL     hSnow   (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL     Tsf     (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL     flxExcSw(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL     dFlxdT  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL     evap    (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL     dEvdT   (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL     myTime
      INTEGER myIter
      INTEGER myThid
CEOP

#ifdef ALLOW_THSICE
#ifdef ALLOW_BULK_FORCE

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C     === Local variables ===
C     iceornot    :: 0=open water, 1=ice cover, 2=ice+snow
      INTEGER iceornot
      INTEGER i, j
      _RL  flwup         ! upward LW at surface (W m-2)
      _RL  flwNet_dwn    ! net (downward) LW at surface (W m-2)
      _RL  fsh           ! surface downward sensible heat (W m-2)
      _RL  flh           ! surface downward latent heat (W m-2)
      _RL  ust, vst, ssq
#ifdef ALLOW_FORMULA_AIM
      _RL     Tsurf(1), SHF(1), EVPloc(1), SLRU(1)
      _RL     dEvp(1), sFlx(0:2)
#endif

      DO j=jMin,jMax
       DO i=iMin,iMax
        IF ( icFlag(i,j).GT.0. _d 0 ) THEN
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

         IF ( hSnow(i,j).GT.3. _d -1 ) THEN
          iceornot=2
         ELSE
          iceornot=1
         ENDIF

#ifdef ALLOW_FORMULA_AIM
         IF ( useFluxFormula_AIM ) THEN

          Tsurf(1) = Tsf(i,j)
          CALL BULKF_FORMULA_AIM(
     I               Tsurf, flwdwn(i,j,bi,bj),
     I               ThAir(i,j,bi,bj), Tair(i,j,bi,bj),
     I               Qair(i,j,bi,bj), wspeed(i,j,bi,bj),
     O               SHF, EVPloc, SLRU,
     O               dEvp, sFlx,
     I               iceornot, myThid )

          flxExcSw(i,j) = sFlx(1)
          dFlxdT(i,j)   = sFlx(2)
C-      convert from [g/m2/s] to [kg/m2/s]
          evap(i,j)  = EVPloc(1) * 1. _d -3
          dEvdT(i,j) = dEvp(1)   * 1. _d -3

         ELSE
#else  /* ALLOW_FORMULA_AIM */
         IF ( .TRUE. ) THEN
#endif /* ALLOW_FORMULA_AIM */

          ust = 0.
          vst = 0.
          ssq = 0.

          IF ( blk_nIter.EQ.0 ) THEN
           CALL BULKF_FORMULA_LANL(
     I          uwind(i,j,bi,bj), vwind(i,j,bi,bj), wspeed(i,j,bi,bj),
     I          Tair(i,j,bi,bj), Qair(i,j,bi,bj),
     I          cloud(i,j,bi,bj), Tsf(i,j),
     O          flwup, flh, fsh, dFlxdT(i,j), ust, vst,
     O          evap(i,j), ssq, dEvdT(i,j),
     I          iceornot, myThid )
          ELSE
           CALL BULKF_FORMULA_LAY(
     I          uwind(i,j,bi,bj), vwind(i,j,bi,bj), wspeed(i,j,bi,bj),
     I          Tair(i,j,bi,bj), Qair(i,j,bi,bj), Tsf(i,j),
     O          flwup, flh, fsh, dFlxdT(i,j), ust, vst,
     O          evap(i,j), ssq, dEvdT(i,j),
     I          iceornot, i,j,bi,bj,myThid )
          ENDIF

          flwNet_dwn = flwdwn(i,j,bi,bj) - flwup
          flxExcSw(i,j) = flwNet_dwn + fsh + flh

         ENDIF

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
        ENDIF
       ENDDO
      ENDDO

#endif /* ALLOW_BULK_FORCE */
#endif /* ALLOW_THSICE */

      RETURN
      END

#include "CPP_EEOPTIONS.h"
#include "W2_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 0
C !ROUTINE: W2_SET_GEN_FACETS( myThid )

C !INTERFACE:
      SUBROUTINE W2_SET_GEN_FACETS( myThid )

C     !DESCRIPTION:
C     Set-up multi-facets (=sub-domain) topology : general case
C     process topology information from "data.exch2" (facet_dims,facet_link)

C     !USES:
      IMPLICIT NONE

C      Tile topology settings data structures
#include "SIZE.h"
#include "EEPARAMS.h"
#include "W2_EXCH2_SIZE.h"
#include "W2_EXCH2_PARAMS.h"
#include "W2_EXCH2_TOPOLOGY.h"

C     !INPUT PARAMETERS:
C     myThid  :: my Thread Id number
C               (Note: not relevant since threading has not yet started)
      INTEGER myThid

C     !LOCAL VARIABLES:
C     === Local variables ===
C     msgBuf     :: Informational/error message buffer
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      CHARACTER*1 edge(4)
      INTEGER i,j,jj,fNx,fNy
      INTEGER errCnt
CEOP
      DATA edge / 'N' , 'S' , 'E' , 'W' /

      WRITE(msgBuf,'(2A,I3,A)') 'W2_SET_GEN_FACETS:',
     &              ' preDefTopol=', preDefTopol, ' selected'
      CALL PRINT_MESSAGE( msgBuf, W2_oUnit,SQUEEZE_RIGHT,myThid )

C     count Nb of Facets (from facet_dims) ; set nFacets
C     Assume: consecutive pair (x-dim,y-dim) of non-zero dimension
      errCnt = 0
      nFacets = 0
C     find last pair of non-zero dims
      DO j=1,W2_maxNbFacets
        fNx = facet_dims(2*j-1)
        fNy = facet_dims( 2*j )
C       IF ( nFacets.EQ.0 .AND. fNx*fNy.EQ.0 ) THEN
        IF ( fNx.NE.0 .AND. fNy.NE.0 ) THEN
          nFacets = j
        ELSEIF ( fNx.NE.0 .OR. fNy.NE.0 ) THEN
          errCnt = errCnt + 1
          WRITE(msgBuf,'(A,I3,A,2I6)')
     &      'dimsFacets: Expect pair of >0 dims : facet',j,
     &      ' :',fNx,fNy
          CALL PRINT_ERROR( msgBuf, myThid )
        ENDIF
      ENDDO
      IF ( nFacets.EQ.0 ) THEN
        errCnt = errCnt + 1
        WRITE(msgBuf,'(A)')
     &    'dimsFacets: All dimensions are zero!'
        CALL PRINT_ERROR( msgBuf, myThid )
      ENDIF
      IF ( errCnt.GT.0 ) THEN
        WRITE(msgBuf,'(A,I3,A)') 'W2_SET_GEN_FACETS: found', errCnt,
     &                           ' errors in dimsFacets list'
        CALL PRINT_ERROR( msgBuf, myThid )
        STOP 'ABNORMAL END: W2_SET_GEN_FACETS (dimsFacets list)'
      ENDIF

C-    print out Nb of facets:
      WRITE(msgBuf,'(A,I3,A)')
     &  'W2_SET_GEN_FACETS: Number of facets =', nFacets,
     &  ' (inferred from "dimsFacets")'
      CALL PRINT_MESSAGE( msgBuf, W2_oUnit, SQUEEZE_RIGHT, myThid )

C-    Check remaining part of the list:
      errCnt = 0
      DO jj=2*nFacets+1,2*W2_maxNbFacets
        IF ( facet_dims(jj).NE.0 ) THEN
          errCnt = errCnt + 1
          WRITE(msgBuf,'(A,I3,A,I5,A)') ' dimsFacets(j=',jj,') =',
     &           facet_dims(jj), ' : beyond end of list (=1rst zero)'
          CALL PRINT_ERROR( msgBuf, myThid )
        ENDIF
      ENDDO
C-    check sign
      DO jj=1,2*nFacets
       IF ( facet_dims(jj).LT.0 ) THEN
         errCnt = errCnt + 1
         i=1+MOD(jj-1,2)
         j = (jj+1)/2
         WRITE(msgBuf,'(A,I2,A,I3,A,I6,A)') 'dimension', i,
     &     ' of facet', j, ' =', facet_dims(jj), ' : invalid (< 0)'
         CALL PRINT_ERROR( msgBuf, myThid )
       ENDIF
      ENDDO
      IF ( errCnt.GT.0 ) THEN
        WRITE(msgBuf,'(A,I3,A)') 'W2_SET_GEN_FACETS: found', errCnt,
     &                           ' invalid dims'
        CALL PRINT_ERROR( msgBuf, myThid )
        STOP 'ABNORMAL END: W2_SET_GEN_FACETS (dimsFacets list)'
      ENDIF

C     check "facet_link" list:
      errCnt = 0
      DO j=nFacets+1,W2_maxNbFacets
       DO i=1,4
        IF ( facet_link(i,j).NE.0 ) THEN
          errCnt = errCnt + 1
          WRITE(msgBuf,'(3A,I3,A,F6.2,A)')
     &       'Link for ',edge(i), '.Edge of facet #',j,
     &       ' (facetEdgeLink=',facet_link(i,j),')'
          CALL PRINT_ERROR( msgBuf, myThid )
          WRITE(msgBuf,'(A,I3,A)')
     &      ' is beyond range (> nFacets=',nFacets,')'
          CALL PRINT_ERROR( msgBuf, myThid )
        ENDIF
       ENDDO
      ENDDO
      IF ( errCnt.GT.0 ) THEN
        WRITE(msgBuf,'(A,I3,A)') 'W2_SET_GEN_FACETS: found', errCnt,
     &                           ' errors in facetEdgeLink list'
        CALL PRINT_ERROR( msgBuf, myThid )
        STOP 'ABNORMAL END: W2_SET_GEN_FACETS (facetEdgeLink list)'
      ENDIF

      RETURN
      END

#include "CAL_OPTIONS.h"

      SUBROUTINE CAL_SUBDATES(
     I                         finaldate,
     I                         initialdate,
     O                         diffdate,
     I                         myThid )

C     ==================================================================
C     SUBROUTINE cal_SubDates
C     ==================================================================
C
C     o Subtract two dates. In case calendar dates are given finaldate
C       must be after initialdate.
C
C     started: Christian Eckert eckert@mit.edu  30-Jun-1999
C     changed: Christian Eckert eckert@mit.edu  29-Dec-1999
C              - restructured the original version in order to have a
C                better interface to the MITgcmUV.
C              Christian Eckert eckert@mit.edu  03-Feb-2000
C              - Introduced new routine and function names, cal_<NAME>,
C                for verion 0.1.3.
C
C     ==================================================================
C     SUBROUTINE cal_SubDates
C     ==================================================================

      IMPLICIT NONE

C     == global variables ==
#include "EEPARAMS.h"
#include "cal.h"

C     == routine arguments ==
      INTEGER finaldate(4)
      INTEGER initialdate(4)
      INTEGER diffdate(4)
      INTEGER myThid

C     == local variables ==
      INTEGER workdate(4)
      INTEGER ierr
      CHARACTER*(MAX_LEN_MBUF) msgBuf

C     == end of interface ==

      IF ( cal_setStatus .LT. 1 ) THEN
        WRITE( msgBuf,'(2A,4I9)') 'CAL_SUBDATES: ', 'finaldate=',
     &    finaldate(1),finaldate(2),finaldate(3),finaldate(4)
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE( msgBuf,'(2A,4I9)') 'CAL_SUBDATES: ', 'initialdate=',
     &    initialdate(1),initialdate(2),initialdate(3),initialdate(4)
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE( msgBuf,'(2A,I2,A)') 'CAL_SUBDATES: ',
     &    'called too early (cal_setStatus=',cal_setStatus,' )'
        CALL PRINT_ERROR( msgBuf, myThid )
        STOP 'ABNORMAL END: S/R CAL_SUBDATES'
      ENDIF

      if ((initialdate(4) .gt. 0) .eqv.
     &    (  finaldate(4) .gt. 0)) then

        if (initialdate(4) .eq. -1) then
C         The time interval is subtracted.
          workdate(1) = -initialdate(1)
          workdate(2) = -initialdate(2)
          workdate(3) =  0
          workdate(4) = -1
          call cal_AddTime( finaldate, workdate, diffdate, myThid )
        else
C         The time interval between initial and final date is calculated.
          call cal_TimePassed(
     &          initialdate, finaldate, diffdate, myThid )
        endif
      else

        ierr = 801
        call cal_PrintError( ierr, myThid )
        stop ' stopped in cal_SubDates.'

      endif

      RETURN
      END

#include "GMREDI_OPTIONS.h"

CBOP
C     !ROUTINE: GMREDI_DIAGNOSTICS_FILL
C     !INTERFACE:
      SUBROUTINE GMREDI_DIAGNOSTICS_FILL(
     I                  bi, bj, myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE GMREDI_DIAGNOSTICS_FILL
C     | o fill GM-Redi diagnostics
C     *==========================================================*
C     | Note: formerly was part of S/R GMREDI_CALC_TENSOR
C     |       and was isolated in this S/R for TAF reasons
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "GMREDI.h"

C     !INPUT/OUTPUT PARAMETERS:
C     bi, bj :: tile indices
C     myThid :: my Thread Id number
      INTEGER bi,bj
      INTEGER myThid

#ifdef ALLOW_GMREDI
#ifdef ALLOW_DIAGNOSTICS
C     !FUNCTIONS:
      LOGICAL     DIAGNOSTICS_IS_ON
      EXTERNAL    DIAGNOSTICS_IS_ON
#endif /* ALLOW_DIAGNOSTICS */
CEOP

C     !LOCAL VARIABLES:
#ifdef ALLOW_EDDYPSI
      INTEGER i,j,k
      _RL tmpfld3dloc (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
#endif

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#ifdef ALLOW_DIAGNOSTICS
      IF ( useDiagnostics ) THEN

#ifdef GM_VISBECK_VARIABLE_K
       IF ( GM_Visbeck_alpha.NE.0. ) THEN
         CALL DIAGNOSTICS_FILL(VisbeckK,'GM_VisbK',0,1,1,bi,bj,myThid)
       ENDIF
#endif
#ifdef GM_GEOM_VARIABLE_K
       IF ( GEOM_alpha.NE.0. ) THEN
         CALL DIAGNOSTICS_FILL(GEOM_K3d,'GM_GEOMK',0,Nr,1,bi,bj,myThid)
         CALL DIAGNOSTICS_FILL(GEOM_EKE,'GEOMeE  ',0,1,1,bi,bj,myThid)
       ENDIF
#endif
         CALL DIAGNOSTICS_FILL(Kux,'GM_Kux  ',0,Nr,1,bi,bj,myThid)
         CALL DIAGNOSTICS_FILL(Kvy,'GM_Kvy  ',0,Nr,1,bi,bj,myThid)
#ifdef GM_EXTRA_DIAGONAL
       IF ( GM_ExtraDiag ) THEN
         CALL DIAGNOSTICS_FILL(Kuz,'GM_Kuz  ',0,Nr,1,bi,bj,myThid)
         CALL DIAGNOSTICS_FILL(Kvz,'GM_Kvz  ',0,Nr,1,bi,bj,myThid)
       ENDIF
#endif
         CALL DIAGNOSTICS_FILL(Kwx,'GM_Kwx  ',0,Nr,1,bi,bj,myThid)
         CALL DIAGNOSTICS_FILL(Kwy,'GM_Kwy  ',0,Nr,1,bi,bj,myThid)
         CALL DIAGNOSTICS_FILL(Kwz,'GM_Kwz  ',0,Nr,1,bi,bj,myThid)
#ifdef GM_BOLUS_ADVEC
       IF ( GM_AdvForm ) THEN
         CALL DIAGNOSTICS_FILL(GM_PsiX,'GM_PsiX ',0,Nr,1,bi,bj,myThid)
         CALL DIAGNOSTICS_FILL(GM_PsiY,'GM_PsiY ',0,Nr,1,bi,bj,myThid)
       ENDIF
#endif

#ifdef ALLOW_EDDYPSI
       IF ( DIAGNOSTICS_IS_ON('GMEdTauX',myThid) ) THEN
        DO k = 1, Nr
         DO j = 1, sNy
          DO i = 1, sNx
           tmpfld3dloc(i,j,k,bi,bj) =
     &      0.5*rhoConst*fCori(i,j,bi,bj)*
     &      Kwy(i,j,k,bi,bj)
          ENDDO
         ENDDO
        ENDDO
        CALL DIAGNOSTICS_FILL(tmpfld3dloc,'GMEdTauX',
     &   0,Nr,1,bi,bj,myThid)
       ENDIF
c
       IF ( DIAGNOSTICS_IS_ON('GMEdTauY',myThid) ) THEN
        DO k = 1, Nr
         DO j = 1, sNy
          DO i = 1, sNx
           tmpfld3dloc(i,j,k,bi,bj) =
     &      -0.5*rhoConst*fCori(i,j,bi,bj)*
     &      Kwx(i,j,k,bi,bj)
          ENDDO
         ENDDO
        ENDDO
        CALL DIAGNOSTICS_FILL(tmpfld3dloc,'GMEdTauY',
     &   0,Nr,1,bi,bj,myThid)
       ENDIF
#endif /* ALLOW_EDDYPSI */
#ifdef GM_BATES_K3D
       IF (GM_useBatesK3d) THEN
         CALL DIAGNOSTICS_FILL(GM_BatesK3d,'GM_BaK  ',0,Nr,0,1,1,myThid)
       ENDIF
#endif

      ENDIF
#endif /* ALLOW_DIAGNOSTICS */

#endif /* ALLOW_GMREDI */

      RETURN
      END

#include "DIAG_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 0
C     !ROUTINE: DIAGNOSTICS_OUT

C     !INTERFACE:
      SUBROUTINE DIAGNOSTICS_OUT(
     I                       listId, myTime, myIter, myThid )

C     !DESCRIPTION:
C     Write output for diagnostics fields.

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "DIAGNOSTICS_SIZE.h"
#include "DIAGNOSTICS.h"

      INTEGER NrMax
      PARAMETER( NrMax = numLevels )

C     !INPUT PARAMETERS:
C     listId  :: Diagnostics list number being written
C     myIter  :: current iteration number
C     myTime  :: current time of simulation (s)
C     myThid  :: my Thread Id number
      _RL     myTime
      INTEGER listId, myIter, myThid
CEOP

C     !FUNCTIONS:
      INTEGER ILNBLNK
      EXTERNAL ILNBLNK

C     !LOCAL VARIABLES:
C     i,j,k :: loop indices
C     bi,bj :: tile indices
C     lm    :: loop index (averageCycle)
C     md    :: field number in the list "listId".
C     ndId  :: diagnostics  Id number (in available diagnostics list)
C     ip    :: diagnostics  pointer to storage array
C     im    :: counter-mate pointer to storage array
C     mate  :: counter mate Id number (in available diagnostics list)
C     mDbl  :: processing mate Id number (in case processing requires 2 diags)
C     mVec  :: vector mate Id number
C     ppFld :: post-processed diag or not (=0): =1 stored in qtmp1 ; =2 in qtmp2
C   isComputed :: previous post-processed diag (still available in qtmp)
C     nLevOutp :: number of levels to write in output file
C
C--   COMMON /LOCAL_DIAGNOSTICS_OUT/ local common block (for multi-threaded)
C     qtmp1 :: temporary array; used to store a copy of diag. output field.
C     qtmp2 :: temporary array; used to store a copy of a 2nd diag. field.
C-  Note: local common block no longer needed.
c     COMMON /LOCAL_DIAGNOSTICS_OUT/ qtmp1
      _RL qtmp1(1-OLx:sNx+OLx,1-OLy:sNy+OLy,NrMax,nSx,nSy)
      _RL qtmp2(1-OLx:sNx+OLx,1-OLy:sNy+OLy,NrMax,nSx,nSy)

      INTEGER i, j, k, lm
      INTEGER bi, bj
      INTEGER md, ndId, nn, ip, im
      INTEGER mate, mDbl, mVec
      INTEGER ppFld, isComputed
      CHARACTER*10 gcode
      _RL undefRL
      INTEGER nLevOutp, kLev

      INTEGER iLen,jLen
      INTEGER ioUnit
      CHARACTER*(MAX_LEN_FNAM) fn
      CHARACTER*(10) suff
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      INTEGER prec, nRec, nTimRec
      _RL     timeRec(2)
      _RL     tmpLoc
#ifdef ALLOW_MDSIO
      LOGICAL glf
#endif
#ifdef ALLOW_MNC
      CHARACTER*(MAX_LEN_FNAM) diag_mnc_bn
#endif /*  ALLOW_MNC  */

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C---  set file properties
      ioUnit= standardMessageUnit
      undefRL = misValFlt(listId)

      IF ( rwSuffixType.EQ.0 ) THEN
        WRITE(suff,'(I10.10)') myIter
      ELSE
        CALL RW_GET_SUFFIX( suff, myTime, myIter, myThid )
      ENDIF
      iLen = ILNBLNK(fnames(listId))
      WRITE(fn,'(3A)') fnames(listId)(1:iLen), '.', suff
      IF ( diag_mdsio.AND.(diagMdsDir.NE.' ') ) THEN
        jLen = ILNBLNK(diagMdsDir)
        WRITE(fn,'(5A)') diagMdsDir(1:jLen), '/',
     &                 fnames(listId)(1:iLen), '.', suff
      ENDIF

C-    for now, if integrate vertically, output field has just 1 level:
      nLevOutp = nlevels(listId)
      IF ( fflags(listId)(2:2).EQ.'I' ) nLevOutp = 1

C--   Set time information:
      IF ( freq(listId).LT.0. ) THEN
C-    Snap-shot: store a unique time (which is consistent with State-Var timing)
        nTimRec = 1
        timeRec(1) = myTime
      ELSE
C-    Time-average: store the 2 edges of the time-averaging interval.
C      this time is consitent with intermediate Var (i.e., non-state, e.g, flux,
C      tendencies) timing. For State-Var, this is shifted by + halt time-step.
        nTimRec = 2

C-    end of time-averaging interval:
        timeRec(2) = myTime

C-    begining of time-averaging interval:
c       timeRec(1) = myTime - freq(listId)
C     a) find the time of the previous multiple of output freq:
        timeRec(1) = myTime-deltaTClock*0.5 _d 0
        timeRec(1) = (timeRec(1)-phase(listId))/freq(listId)
        tmpLoc     = DINT( timeRec(1) )
        IF ( timeRec(1).LT.zeroRL ) THEN
          IF ( timeRec(1).NE.tmpLoc ) tmpLoc = tmpLoc - 1. _d 0
        ENDIF
        timeRec(1) = phase(listId) + freq(listId)*tmpLoc
c       WRITE(0,'(3I5,A,2F17.4)') myProcId, myThid, listId,
c    &                     ' f ', tmpLoc, timeRec(1)/deltaTClock
        timeRec(1) = MAX( timeRec(1), startTime )

C     b) round off to nearest multiple of time-step:
        timeRec(1) = (timeRec(1)-baseTime)/deltaTClock
        tmpLoc = DNINT( timeRec(1) )
C     if just half way, NINT will return the next time-step: correct this
        IF ( (timeRec(1)+halfRL).EQ.tmpLoc ) tmpLoc = tmpLoc - 1. _d 0
        timeRec(1) = baseTime + deltaTClock*tmpLoc
c       WRITE(0,'(3I5,A,2F17.4)') myProcId, myThid, listId,
c    &                     '   ', tmpLoc, timeRec(1)/deltaTClock
      ENDIF
C--   Convert time to iteration number (debug)
c     DO i=1,nTimRec
c       timeRec(i) = timeRec(i)/deltaTClock
c     ENDDO

C--   Place the loop on lm (= averagePeriod) outside the loop on md (= field):
      DO lm=1,averageCycle(listId)

#ifdef ALLOW_MNC
       IF (useMNC .AND. diag_mnc) THEN
         CALL DIAGNOSTICS_MNC_SET(
     I                    nLevOutp, listId, lm,
     O                    diag_mnc_bn,
     I                    undefRL, myTime, myIter, myThid )
       ENDIF
#endif /*  ALLOW_MNC  */

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

       isComputed = 0
       DO md = 1,nfields(listId)
        ndId = ABS(jdiag(md,listId))
        gcode = gdiag(ndId)(1:10)
        mate = 0
        mVec = 0
        mDbl = 0
        ppFld = 0
        IF ( gcode(5:5).EQ.'C' ) THEN
C-      Check for Mate of a Counter Diagnostic
           mate = hdiag(ndId)
        ELSEIF ( gcode(5:5).EQ.'P' ) THEN
           ppFld = 1
           IF ( gdiag(hdiag(ndId))(5:5).EQ.'P' ) ppFld = 2
C-      Also load the mate (if stored) for Post-Processing
           nn = ndId
           DO WHILE ( gdiag(nn)(5:5).EQ.'P' )
             nn = hdiag(nn)
           ENDDO
           IF ( mdiag(md,listId).NE.0 ) mDbl = hdiag(nn)
c          write(0,*) ppFld,' ndId=', ndId, nn, mDbl, isComputed
        ELSEIF ( gcode(1:1).EQ.'U' .OR. gcode(1:1).EQ.'V' ) THEN
C-      Check for Mate of a Vector Diagnostic
           mVec = hdiag(ndId)
        ENDIF
        IF ( idiag(md,listId).NE.0 .AND. gcode(5:5).NE.'D' ) THEN
C--     Start processing 1 Fld :

          ip = ABS(idiag(md,listId)) + kdiag(ndId)*(lm-1)
          im = mdiag(md,listId)
          IF (mate.GT.0) im = im + kdiag(mate)*(lm-1)
          IF (mDbl.GT.0) im = im + kdiag(mDbl)*(lm-1)
          IF (mVec.GT.0) im = im + kdiag(mVec)*(lm-1)

          IF ( ppFld.EQ.2 .AND. isComputed.EQ.hdiag(ndId) ) THEN
C-        Post-Processed diag from an other Post-Processed diag -and-
C         both of them have just been calculated and are still stored in qtmp:
C         => skip computation and just write qtmp2
            IF ( diag_dBugLevel.GE.debLevB .AND. myThid.EQ.1 ) THEN
              WRITE(ioUnit,'(A,I6,3A,I6)')
     &          '  get Post-Proc. Diag # ', ndId, '  ', cdiag(ndId),
     &          ' from previous computation of Diag # ', isComputed
            ENDIF
            isComputed = 0
          ELSEIF ( ndiag(ip,1,1).EQ.0 ) THEN
C-        Empty diagnostics case :
            isComputed = 0

            _BEGIN_MASTER( myThid )
            WRITE(msgBuf,'(A,I10)')
     &        '- WARNING - from DIAGNOSTICS_OUT at iter=', myIter
            CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                          SQUEEZE_RIGHT, myThid )
            WRITE(msgBuf,'(A,I6,3A,I4,2A)')
     &        '- WARNING -   diag.#',ndId, ' : ',flds(md,listId),
     &        ' (#',md,' ) in outp.Stream: ',fnames(listId)
            CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                          SQUEEZE_RIGHT, myThid )
            IF ( averageCycle(listId).GT.1 ) THEN
             WRITE(msgBuf,'(A,2(I3,A))')
     &         '- WARNING -   has not been filled (ndiag(lm=',lm,')=',
     &                                             ndiag(ip,1,1), ' )'
            ELSE
             WRITE(msgBuf,'(A,2(I3,A))')
     &         '- WARNING -   has not been filled (ndiag=',
     &                                             ndiag(ip,1,1), ' )'
            ENDIF
            CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                          SQUEEZE_RIGHT, myThid )
            WRITE(msgBuf,'(A)')
     &        'WARNING DIAGNOSTICS_OUT  => write ZEROS instead'
            CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                          SQUEEZE_RIGHT, myThid )
            _END_MASTER( myThid )
            DO bj = myByLo(myThid), myByHi(myThid)
              DO bi = myBxLo(myThid), myBxHi(myThid)
                DO k = 1,nLevOutp
                  DO j = 1-OLy,sNy+OLy
                    DO i = 1-OLx,sNx+OLx
                      qtmp1(i,j,k,bi,bj) = 0. _d 0
                    ENDDO
                  ENDDO
                ENDDO
              ENDDO
            ENDDO

          ELSE
C-        diagnostics is not empty :
            isComputed = 0

            IF ( diag_dBugLevel.GE.debLevB .AND. myThid.EQ.1 ) THEN
              IF ( ppFld.GE.1 ) THEN
               WRITE(ioUnit,'(A,I6,3A,I3,3A)')
     &           ' Post-Processing Diag #', ndId, ' "', cdiag(ndId),
     &           '" (list#', listId, ') Parms "', gdiag(ndId), '"'
               IF ( mDbl.EQ.0 ) THEN
                WRITE(ioUnit,'(2(3A,I6,A,I8))') '   from diag: ',
     &            cdiag(nn), ' (#', nn, ') Cnt=', ndiag(ip,1,1)
               ELSE
                WRITE(ioUnit,'(2(3A,I6,A,I8))') '   from diag: ',
     &            cdiag(nn), ' (#', nn, ') Cnt=', ndiag(ip,1,1),
     &            ' and diag: ',
     &            cdiag(mDbl), ' (#', mDbl, ') Cnt=', ndiag(im,1,1)
               ENDIF
              ELSE
               WRITE(ioUnit,'(A,I6,3A,I3,3A,I8)')
     &           ' Computing Diagnostic #', ndId, ' "', cdiag(ndId),
     &           '" (list#', listId, ') Parms "', gdiag(ndId),
     &           '", Count=', ndiag(ip,1,1)
              ENDIF
              IF ( mate.GT.0 ) THEN
               WRITE(ioUnit,'(3A,I6,3A)')
     &           '         use Counter Mate for "', cdiag(ndId),
     &           '" :  Diagnostic #', mate, ' "', cdiag(mate), '"'
              ELSEIF ( mVec.GT.0 ) THEN
               IF ( im.GT.0 .AND. ndiag(MAX(1,im),1,1).GT.0 ) THEN
                WRITE(ioUnit,'(3A,I6,3A)')
     &            '             Vector  Mate for "', cdiag(ndId),
     &            '" :  Diagnostic # ', mVec, ' "', cdiag(mVec),
     &            '" exists'
               ELSE
                WRITE(ioUnit,'(3A,I6,3A)')
     &            '             Vector  Mate for "', cdiag(ndId),
     &            '" :  Diagnostic # ', mVec, ' "', cdiag(mVec),
     &            '" not enabled'
               ENDIF
              ENDIF
            ENDIF

            IF ( fflags(listId)(2:2).EQ.' ' ) THEN
C-       get only selected levels:
              DO bj = myByLo(myThid), myByHi(myThid)
               DO bi = myBxLo(myThid), myBxHi(myThid)
                DO k = 1,nlevels(listId)
                  kLev = NINT(levs(k,listId))
                  CALL DIAGNOSTICS_GET_DIAG(
     I                         kLev, undefRL,
     O                         qtmp1(1-OLx,1-OLy,k,bi,bj),
     I                         ndId, mate, ip, im, bi, bj, myThid )
                ENDDO
               ENDDO
              ENDDO
              IF ( mDbl.GT.0 ) THEN
               DO bj = myByLo(myThid), myByHi(myThid)
                DO bi = myBxLo(myThid), myBxHi(myThid)
                 DO k = 1,nlevels(listId)
                  kLev = NINT(levs(k,listId))
                  CALL DIAGNOSTICS_GET_DIAG(
     I                         kLev, undefRL,
     O                         qtmp2(1-OLx,1-OLy,k,bi,bj),
     I                         mDbl, 0, im, 0, bi, bj, myThid )
                 ENDDO
                ENDDO
               ENDDO
              ENDIF
            ELSE
C-       get all the levels (for vertical post-processing)
              DO bj = myByLo(myThid), myByHi(myThid)
               DO bi = myBxLo(myThid), myBxHi(myThid)
                  CALL DIAGNOSTICS_GET_DIAG(
     I                         0, undefRL,
     O                         qtmp1(1-OLx,1-OLy,1,bi,bj),
     I                         ndId, mate, ip, im, bi, bj, myThid )
               ENDDO
              ENDDO
              IF ( mDbl.GT.0 ) THEN
               DO bj = myByLo(myThid), myByHi(myThid)
                DO bi = myBxLo(myThid), myBxHi(myThid)
                  CALL DIAGNOSTICS_GET_DIAG(
     I                         0, undefRL,
     O                         qtmp2(1-OLx,1-OLy,1,bi,bj),
     I                         mDbl, 0, im, 0, bi, bj, myThid )
                ENDDO
               ENDDO
              ENDIF
            ENDIF

C-----------------------------------------------------------------------
C--     Apply specific post-processing (e.g., interpolate) before output
C-----------------------------------------------------------------------
            IF ( fflags(listId)(2:2).EQ.'P' ) THEN
C-          Do vertical interpolation:
             IF ( fluidIsAir ) THEN
C jmc: for now, this can only work in an atmospheric set-up (fluidIsAir);
              CALL DIAGNOSTICS_INTERP_VERT(
     I                         listId, md, ndId, ip, im, lm,
     U                         qtmp1, qtmp2,
     I                         undefRL, myTime, myIter, myThid )
             ELSE
               WRITE(msgBuf,'(2A)') 'DIAGNOSTICS_OUT: ',
     &           'INTERP_VERT not allowed in this config'
               CALL PRINT_ERROR( msgBuf , myThid )
               STOP 'ABNORMAL END: S/R DIAGNOSTICS_OUT'
             ENDIF
            ENDIF
            IF ( fflags(listId)(2:2).EQ.'I' ) THEN
C-          Integrate vertically: for now, output field has just 1 level:
              CALL DIAGNOSTICS_SUM_LEVELS(
     I                         listId, md, ndId, ip, im, lm,
     U                         qtmp1,
     I                         undefRL, myTime, myIter, myThid )
            ENDIF
            IF ( ppFld.GE.1 ) THEN
C-          Do Post-Processing:
             IF ( flds(md,listId).EQ.'PhiVEL  '
     &       .OR. flds(md,listId).EQ.'PsiVEL  '
     &          ) THEN
              CALL DIAGNOSTICS_CALC_PHIVEL(
     I                         listId, md, ndId, ip, im, lm,
     I                         NrMax,
     U                         qtmp1, qtmp2,
     I                         myTime, myIter, myThid )
              isComputed = ndId
             ELSE
               WRITE(msgBuf,'(2A)') 'DIAGNOSTICS_OUT: ',
     &           'unknown Processing method for diag="',cdiag(ndId),'"'
               CALL PRINT_ERROR( msgBuf , myThid )
               STOP 'ABNORMAL END: S/R DIAGNOSTICS_OUT'
             ENDIF
            ENDIF

C--     End of empty diag / not-empty diag block
          ENDIF

C--     Ready to write field "md", element "lm" in averageCycle(listId)

C-        write to binary file, using MDSIO pkg:
          IF ( diag_mdsio ) THEN
c          nRec = lm + (md-1)*averageCycle(listId)
           nRec = md + (lm-1)*nfields(listId)
C         default precision for output files
           prec = writeBinaryPrec
C         fFlag(1)=R(or D): force it to be 32-bit(or 64) precision
           IF ( fflags(listId)(1:1).EQ.'R' ) prec = precFloat32
           IF ( fflags(listId)(1:1).EQ.'D' ) prec = precFloat64
C         a hack not to write meta files now: pass -nRec < 0 to MDS_WRITE S/R
           IF ( ppFld.LE.1 ) THEN
            CALL WRITE_REC_LEV_RL(
     I                            fn, prec,
     I                            NrMax, 1, nLevOutp,
     I                            qtmp1, -nRec, myIter, myThid )
           ELSE
            CALL WRITE_REC_LEV_RL(
     I                            fn, prec,
     I                            NrMax, 1, nLevOutp,
     I                            qtmp2, -nRec, myIter, myThid )
           ENDIF
          ENDIF

#ifdef ALLOW_MNC
          IF (useMNC .AND. diag_mnc) THEN
           IF ( ppFld.LE.1 ) THEN
            CALL DIAGNOSTICS_MNC_OUT(
     I                       NrMax, nLevOutp, listId, ndId, mate,
     I                       diag_mnc_bn, qtmp1,
     I                       undefRL, myTime, myIter, myThid )
           ELSE
            CALL DIAGNOSTICS_MNC_OUT(
     I                       NrMax, nLevOutp, listId, ndId, mate,
     I                       diag_mnc_bn, qtmp2,
     I                       undefRL, myTime, myIter, myThid )
           ENDIF
          ENDIF
#endif /*  ALLOW_MNC  */

C--     end of Processing Fld # md
        ENDIF
       ENDDO

C--   end loop on lm counter (= averagePeriod)
      ENDDO

#ifdef ALLOW_MDSIO
      IF (diag_mdsio) THEN
C-    Note: temporary: since it is a pain to add more arguments to
C     all MDSIO S/R, uses instead this specific S/R to write only
C     meta files but with more informations in it.
            glf = globalFiles
            nRec = averageCycle(listId)*nfields(listId)
            CALL MDS_WR_METAFILES(fn, prec, glf, .FALSE.,
     &              0, 0, nLevOutp, ' ',
     &              nfields(listId), flds(1,listId),
     &              nTimRec, timeRec, undefRL,
     &              nRec, myIter, myThid)
      ENDIF
#endif /*  ALLOW_MDSIO  */

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#include "DIC_OPTIONS.h"

      SUBROUTINE DIC_READ_CO2_PICKUP(
     I                                myIter, myThid )

      IMPLICIT NONE
C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "DIC_VARS.h"
#include "DIC_ATMOS.h"

C     == Routine arguments ==
C     myThid  :: my Thread Id number
      INTEGER myIter
      INTEGER myThid

#ifdef ALLOW_DIC

C     !FUNCTIONS
      INTEGER  MDS_RECLEN
      EXTERNAL MDS_RECLEN

C     !LOCAL VARIABLES:
C     == Local variables ==
      INTEGER fp, ioUnit
      CHARACTER*(10) suff
      CHARACTER*(MAX_LEN_FNAM) fn, filNam
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      LOGICAL useCurrentDir, fileExist
      REAL*8 tmpFld(2)
      INTEGER length_of_rec
CEOP

      IF ( dic_int1.EQ.3 ) THEN

        IF (pickupSuff.EQ.' ') THEN
          IF ( rwSuffixType.EQ.0 ) THEN
            WRITE(fn,'(A,I10.10)') 'pickup_dic_co2atm.', myIter
          ELSE
            CALL RW_GET_SUFFIX( suff, startTime, myIter, myThid )
            WRITE(fn,'(A,A)') 'pickup_dic_co2atm.', suff
          ENDIF
        ELSE
          WRITE(fn,'(A,A10)') 'pickup_dic_co2atm.', pickupSuff
        ENDIF
        fp = precFloat64

C--   First check if pickup file exist
#ifdef ALLOW_MDSIO
        useCurrentDir = .FALSE.
        CALL MDS_CHECK4FILE(
     I                       fn, '.data', 'DIC_READ_CO2_PICKUP',
     O                       filNam, fileExist,
     I                       useCurrentDir, myThid )
#else
        STOP 'ABNORMAL END: S/R DIC_READ_CO2_PICKUP: Needs MDSIO pkg'
#endif
        IF ( .NOT.fileExist ) THEN
          WRITE(msgBuf,'(4A)') 'DIC_READ_CO2_PICKUP: ',
     &      'with dic_int1=3, needs CO2-atmos pickup to restart'
          CALL PRINT_ERROR( msgBuf, myThid )
          STOP 'ABNORMAL END: S/R DIC_READ_CO2_PICKUP'
        ENDIF
        _BEGIN_MASTER(myThid)
        CALL MDSFINDUNIT( ioUnit, myThid )
        length_of_rec = MDS_RECLEN( fp, 2, myThid )
        OPEN( ioUnit, file=filNam, status='old',
     &        access='direct', recl=length_of_rec )
        READ(ioUnit,rec=1) tmpFld
#ifdef _BYTESWAPIO
        CALL MDS_BYTESWAPR8( 2, tmpFld )
#endif
        total_atmos_carbon = tmpFld(1)
        atpco2 = tmpFld(2)

       _END_MASTER(myThid)
c      _BARRIER
      ENDIF

#endif /*  ALLOW_DIC  */

      RETURN
      END

#include "STREAMICE_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 0
C !ROUTINE: STREAMICE_INIT_FIXED

C !INTERFACE:
      SUBROUTINE STREAMICE_INIT_PHI( myThid )

C     !DESCRIPTION:
C     Initialize STREAMICE nodal basis gradients for FEM solver

C     !USES:
      IMPLICIT NONE
#include "EEPARAMS.h"
#include "SIZE.h"
#include "PARAMS.h"
#include "STREAMICE.h"
#include "STREAMICE_CG.h"
#include "GRID.h"

C     myThid ::  my Thread Id number
      INTEGER myThid
CEOP

C     !LOCAL VARIABLES:
C     === Local variables ===
      INTEGER bi, bj, i, j, xnode, ynode, xq, yq, m, n, kx, ky
      REAL gradx(2), grady(2)  ! gradients at quadrature points

C     here the terms used to calculate matrix terms in the
C     velocity solve are initialized
C
C     this is a quasi-finite element method; the gradient
C     of the basis functions are approximated based on knowledge
C     of the grid
C
C     Dphi (i,j,bi,bj,m,n,p):
C       gradient (in p-direction) of nodal basis function in
C       cell (i,j) on thread (bi,bj) which is centered on node m,
C       at quadrature point n
C
C    %  3 - 4
C    %  |   |
C    %  1 - 2
C
C     NOTE 2x2 quadrature is hardcoded - might make it specifiable through CPP
C
C     this will not be updated in overlap cells - so we extend it as far as we can

      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
        DO j=1-OLy,sNy+OLy-1
         DO i=1-OLx,sNx+OLx-1

          DO xq = 1,2
           gradx(xq) = Xquad(3-xq) * recip_dxG (i,j,bi,bj) +
     &                 Xquad(xq) * recip_dxG (i+1,j,bi,bj)
           grady(xq) = Xquad(3-xq) * recip_dyG (i,j,bi,bj) +
     &                 Xquad(xq) * recip_dyG (i,j+1,bi,bj)
          ENDDO

          DO n = 1,4

           xq = 2 - mod(n,2)
           yq = floor ((n+1)/2.0)

           DO m = 1,4

            xnode = 2 - mod(m,2)
            ynode = floor ((m+1)/2.0)

            kx = 1 ; ky = 1
            if (xq.eq.xnode) kx = 2
            if (yq.eq.ynode) ky = 2

            Dphi (i,j,bi,bj,m,n,1) =
     &       (2*xnode-3) * Xquad(ky) * gradx(yq)
            Dphi (i,j,bi,bj,m,n,2) =
     &       (2*ynode-3) * Xquad(kx) * grady(xq)

           ENDDO

           grid_jacq_streamice (i,j,bi,bj,n) =
     &      (Xquad(3-xq)*dyG(i,j,bi,bj) + Xquad(xq)*dyG(i+1,j,bi,bj)) *
     &      (Xquad(3-yq)*dxG(i,j,bi,bj) + Xquad(yq)*dxG(i,j+1,bi,bj))

          ENDDO
         ENDDO
        ENDDO
       ENDDO
      ENDDO

      RETURN
      END

#include "FIZHI_OPTIONS.h"
      subroutine fizhi_tendency_apply_u(
     U                        gU_arr,
     I                        iMin,iMax,jMin,jMax, kLev, bi, bj,
     I                        myTime, myIter, myThid )
C=======================================================================
C Routine: fizhi_tendency_apply_u
C     Interpolate tendencies from physics grid to dynamics grid and
C     add fizhi tendency terms to U tendency.
C
C INPUT:
C     iMin - Working range of tile for applying forcing.
C     iMax
C     jMin
C     jMax
C     kLev
C
C Notes: Routine works for one level at a time
C        Assumes that U and V tendencies are already on C-Grid
C=======================================================================
      implicit none

#include "SIZE.h"
#include "GRID.h"
#include "EEPARAMS.h"
#include "DYNVARS.h"
#include "fizhi_SIZE.h"
#include "fizhi_land_SIZE.h"
#include "fizhi_coms.h"

      _RL     gU_arr(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER iMin, iMax, jMin, jMax
      INTEGER kLev, bi, bj
      _RL     myTime
      INTEGER myIter
      INTEGER myThid

      integer i, j

      do j=jMin,jMax
       do i=iMin,iMax
        gU_arr(i,j) = gU_arr(i,j) +
     .      maskW(i,j,kLev,bi,bj) * guphy(i,j,kLev,bi,bj)
       enddo
      enddo

      return
      end
      subroutine fizhi_tendency_apply_v(
     U                        gV_arr,
     I                        iMin,iMax,jMin,jMax, kLev, bi, bj,
     I                        myTime, myIter, myThid )
C=======================================================================
C Routine: fizhi_tendency_apply_v
C     Interpolate tendencies from physics grid to dynamics grid and
C     add fizhi tendency terms to V tendency.
C
C INPUT:
C     iMin - Working range of tile for applying forcing.
C     iMax
C     jMin
C     jMax
C     kLev
C
C Notes: Routine works for one level at a time
C        Assumes that U and V tendencies are already on C-Grid
C=======================================================================
      implicit none

#include "SIZE.h"
#include "GRID.h"
#include "EEPARAMS.h"
#include "DYNVARS.h"
#include "fizhi_SIZE.h"
#include "fizhi_land_SIZE.h"
#include "fizhi_coms.h"

      _RL     gV_arr(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER iMin, iMax, jMin, jMax
      INTEGER kLev, bi, bj
      _RL     myTime
      INTEGER myIter
      INTEGER myThid

      integer i, j

      do j=jMin,jMax
       do i=iMin,iMax
        gV_arr(i,j) = gV_arr(i,j) +
     .      maskS(i,j,kLev,bi,bj) * gvphy(i,j,kLev,bi,bj)
       enddo
      enddo

      return
      end
      subroutine fizhi_tendency_apply_t(
     U                        gT_arr,
     I                        iMin,iMax,jMin,jMax, kLev, bi, bj,
     I                        myTime, myIter, myThid )
C=======================================================================
C Routine: fizhi_tendency_apply_t
C     Interpolate tendencies from physics grid to dynamics grid and
C     add fizhi tendency terms to T (theta) tendency.
C
C INPUT:
C     iMin - Working range of tile for applying forcing.
C     iMax
C     jMin
C     jMax
C     kLev
C
C Notes: Routine works for one level at a time
C=======================================================================
      implicit none

#include "SIZE.h"
#include "GRID.h"
#include "EEPARAMS.h"
#include "DYNVARS.h"
#include "fizhi_SIZE.h"
#include "fizhi_land_SIZE.h"
#include "fizhi_coms.h"

      _RL     gT_arr(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER iMin, iMax, jMin, jMax
      INTEGER kLev, bi, bj
      _RL     myTime
      INTEGER myIter
      INTEGER myThid

      integer i, j

      do j=jMin,jMax
       do i=iMin,iMax
        gT_arr(i,j) = maskC(i,j,kLev,bi,bj)
     .       *( gT_arr(i,j) + gthphy(i,j,kLev,bi,bj) )
       enddo
      enddo

      return
      end
      subroutine fizhi_tendency_apply_s(
     U                        gS_arr,
     I                        iMin,iMax,jMin,jMax, kLev, bi, bj,
     I                        myTime, myIter, myThid )
C=======================================================================
C Routine: fizhi_tendency_apply_s
C     Interpolate tendencies from physics grid to dynamics grid and
C     add fizhi tendency terms to S tendency.
C
C INPUT:
C     iMin - Working range of tile for applying forcing.
C     iMax
C     jMin
C     jMax
C     kLev
C
C Notes: Routine works for one level at a time
C=======================================================================
      implicit none

#include "SIZE.h"
#include "GRID.h"
#include "EEPARAMS.h"
#include "DYNVARS.h"
#include "fizhi_SIZE.h"
#include "fizhi_land_SIZE.h"
#include "fizhi_coms.h"

      _RL     gS_arr(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER iMin, iMax, jMin, jMax
      INTEGER kLev, bi, bj
      _RL     myTime
      INTEGER myIter
      INTEGER myThid

      integer i, j

      do j=jMin,jMax
       do i=iMin,iMax
        gS_arr(i,j) = maskC(i,j,kLev,bi,bj)
     .       *( gS_arr(i,j) + gsphy(i,j,kLev,bi,bj) )
       enddo
      enddo

      return
      end

#include "STIC_OPTIONS.h"

CBOP
C     !ROUTINE: STIC_INIT_DEPTHS
C     !INTERFACE:
      SUBROUTINE STIC_INIT_DEPTHS(
     I                    myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE STIC_INIT_DEPTHS
C     | o Modify ocean upper boundary position according to
C     |   ice-shelf topography
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "STIC.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     myThid    :: my Thread Id number
      INTEGER myThid

C     !LOCAL VARIABLES:
C     == Local variables ==
C     bi, bj    :: tile indices
C     i, j      :: Loop counters
      INTEGER bi, bj
      INTEGER i, j
CEOP

C--   Initialize R_stic
      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          R_stic     (i,j,bi,bj) = 0. _d 0
          sticfLength(i,j,bi,bj) = 0. _d 0
         ENDDO
        ENDDO
       ENDDO
      ENDDO

C---- ICEFRONT BEGIN
      IF ( STIClengthFile .NE. ' ' ) THEN
       CALL READ_FLD_XY_RS( STIClengthFile, ' ',
     &      sticfLength, 0, myThid )
       _EXCH_XY_RS( sticfLength, myThid )
      ENDIF

      IF ( STICdepthFile .NE. ' ' ) THEN
       CALL READ_FLD_XY_RS( STICdepthFile, ' ',
     &      R_stic, 0, myThid )
       _EXCH_XY_RS( R_stic, myThid )
      ENDIF

C     Make sure that R_stic is positive
      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
        DO j = 1-OLy, sNy+OLy
         DO i = 1-OLx, sNx+OLx
          R_stic(i,j,bi,bj) = ABS(R_stic(i,j,bi,bj))
         ENDDO
        ENDDO
       ENDDO
      ENDDO

      RETURN
      END

#include "PACKAGES_CONFIG.h"
#include "CPP_EEOPTIONS.h"
#include "W2_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 0
C !ROUTINE: W2_SET_MYOWN_FACETS

C !INTERFACE:
      SUBROUTINE W2_SET_MYOWN_FACETS( myThid )

C     !DESCRIPTION:
C     Set-up multi-facets (=sub-domain) topology :
C     User specific version to be modified accordingly

C     !USES:
      IMPLICIT NONE

C      Tile topology settings data structures
#include "SIZE.h"
#include "EEPARAMS.h"
#ifdef ALLOW_EXCH2
#include "W2_EXCH2_SIZE.h"
#include "W2_EXCH2_PARAMS.h"
#include "W2_EXCH2_TOPOLOGY.h"
#endif /* ALLOW_EXCH2 */

C     !INPUT PARAMETERS:
C     myThid  :: my Thread Id number
C               (Note: not relevant since threading has not yet started)
      INTEGER myThid

#ifdef ALLOW_EXCH2
C     !FUNCTIONS:

C     !LOCAL VARIABLES:
C     === Local variables ===
C     msgBuf     :: Informational/error message buffer
c     CHARACTER*(MAX_LEN_MBUF) msgBuf
CEOP

      STOP 'ABNORMAL END: S/R W2_SET_MYOWN_FACETS empty'

#endif /* ALLOW_EXCH2 */

      RETURN
      END

#include "ATM_PHYS_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 0
C !ROUTINE: ATM_PHYS_INIT_FIXED

C !INTERFACE:
      SUBROUTINE ATM_PHYS_INIT_FIXED( myThid )

C     !DESCRIPTION:
C     Initialize ATM_PHYS variables that are kept fixed during the run.

C     !USES:
      use gcm_params_mod,          only: gcm_params_init
      use constants_mod,           only: constants_init
      use radiation_mod,           only: radiation_init
      use lscale_cond_mod,         only: lscale_cond_init
      use dargan_bettsmiller_mod,  only: dargan_bettsmiller_init
      use vert_turb_driver_mod,    only: vert_turb_driver_init
      use vert_diff_mod,           only: gcm_vert_diff_init
      use mixed_layer_mod,         only: mixed_layer_init

      IMPLICIT NONE
#include "EEPARAMS.h"
#include "SIZE.h"
#include "PARAMS.h"
#include "ATM_PHYS_PARAMS.h"
#include "ATM_PHYS_VARS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     myThid ::  my Thread Id number
      INTEGER myThid
CEOP

C     !LOCAL VARIABLES:
C     === Local variables ===
C     msgBuf     :: Informational/error message buffer
C     iUnit      :: Work variable for IO unit number
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      INTEGER iUnit
      INTEGER axes(4)
      INTEGER i,j,k,bi,bj
      _RL cst_albedo, cst_mxlDepth

      namelist / atmosphere_nml /
     &   turb, ldry_convection, lwet_convection, do_virtual,
     &   two_stream, mixed_layer_bc,
     &   roughness_heat, roughness_moist, roughness_mom

      cst_albedo   = 0.
      cst_mxlDepth = 1.

      _BARRIER
      _BEGIN_MASTER(myThid)
      module_is_initialized =.false.
      turb = .false.
      ldry_convection = .false.
      lwet_convection = .false.
      do_virtual = .false.      ! whether virtual temp used in gcm_vert_diff
      two_stream = .true.
      mixed_layer_bc = .false.
      roughness_heat = 0.05
      roughness_moist = 0.05
      roughness_mom = 0.05
      WRITE(msgBuf,'(A)') 'ATM_PHYS_INIT_FIXED: opening data.atm_gray'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT , 1)
      CALL OPEN_COPY_DATA_FILE(
     I                     'data.atm_gray', 'ATM_PHYS_INIT_FIXED',
     O                     iUnit,
     I                     myThid )

C      Read parameters from open data file
      READ(UNIT=iUnit,NML=atmosphere_nml)
      WRITE(msgBuf,'(A)')
     &     'ATM_PHYS_INIT_FIXED: finished reading data.atm_gray'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT , 1)
C     Close the open data file
#ifdef SINGLE_DISK_IO
      CLOSE(iUnit)
#else
      CLOSE(iUnit,STATUS='DELETE')
#endif /* SINGLE_DISK_IO */

      CALL GCM_PARAMS_INIT(
     I         UNSET_RS, UNSET_RL, UNSET_I,
!    I         MAX_LEN_MBUF, MAX_LEN_FNAM, MAX_LEN_PREC,
     I         SQUEEZE_RIGHT, SQUEEZE_LEFT, SQUEEZE_BOTH,
     I         precFloat32, precFloat64,
     I         debLevZero, debLevA, debLevB,
     I         debLevC, debLevD, debLevE,
     I         standardMessageUnit, errorMessageUnit,
     I         debugLevel, debugMode,
     I         myThid )

      CALL CONSTANTS_INIT
      _END_MASTER(myThid)
      _BARRIER

      CALL MIXED_LAYER_INIT ( 1, sNx, 1, sNy, Nr, axes,
c    I                        lat2d, ocean_qflux,
     &                        startTime, cst_mxlDepth, myThid )
      CALL GCM_VERT_DIFF_INIT ( sNx, sNy, Nr,
     I                         .true., myThid, do_virtual )

      CALL LSCALE_COND_INIT( myThid )

      IF (lwet_convection) THEN
        CALL DARGAN_BETTSMILLER_INIT( myThid )
      ENDIF

      IF( two_stream) THEN
        CALL RADIATION_INIT( 1, sNx, 1, sNy, Nr, nSx,nSy, axes,
     &                       startTime, cst_albedo, myThid )
      ENDIF

      IF (turb) THEN
        CALL VERT_TURB_DRIVER_INIT( sNx,sNy,Nr,axes,
     &                              startTime, myThid )
      ENDIF

      module_is_initialized = .true.

      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
            atmPhys_Qflx(i,j,bi,bj) = 0. _d 0
            atmPhys_MxLD(i,j,bi,bj) = cst_mxlDepth
            atmPhys_Albedo(i,j,bi,bj) = cst_albedo
          ENDDO
         ENDDO
         DO k=1,Nr
          DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
            atmPhys_Ozone(i,j,k,bi,bj) = 0. _d 0
           ENDDO
          ENDDO
         ENDDO
       ENDDO
      ENDDO
      IF ( atmPhys_qFlxFile .NE. ' ' ) THEN
        CALL READ_FLD_XY_RL( atmPhys_qFlxFile,' ',
     &                       atmPhys_Qflx, 0, myThid )
        CALL EXCH_XY_RL( atmPhys_Qflx, myThid )
      ENDIF
      IF ( atmPhys_mxldFile .NE. ' ' ) THEN
        CALL READ_FLD_XY_RL( atmPhys_mxldFile,' ',
     &                       atmPhys_MxLD, 0, myThid )
        CALL EXCH_XY_RL( atmPhys_MxLD, myThid )
      ENDIF
      IF ( atmPhys_albedoFile .NE. ' ' ) THEN
        CALL READ_FLD_XY_RL( atmPhys_albedoFile,' ',
     &                       atmPhys_Albedo, 0, myThid )
        CALL EXCH_XY_RL( atmPhys_Albedo, myThid )
      ENDIF
      IF ( atmPhys_ozoneFile .NE. ' ' ) THEN
        CALL READ_FLD_XYZ_RL( atmPhys_ozoneFile,' ',
     &                        atmPhys_Ozone, 0, myThid )
        CALL EXCH_XYZ_RL( atmPhys_Ozone, myThid )
      ENDIF

#ifdef ALLOW_MNC
c     IF (useMNC) THEN
c       CALL ATM_PHYS_MNC_INIT( myThid )
c     ENDIF
#endif /* ALLOW_MNC */

#ifdef ALLOW_DIAGNOSTICS
      IF ( useDiagnostics ) THEN
        CALL ATM_PHYS_DIAGNOSTICS_INIT( myThid )
      ENDIF
#endif

      RETURN
      END

#include "EXF_OPTIONS.h"

CBOP
C     !ROUTINE: EXF_GetFFieldRec
C     !INTERFACE:
      SUBROUTINE EXF_GetFFieldRec(
     I               fldStartTime, fldPeriod, fldRepeatCycle,
     I               fldName, usefldyearlyfields,
     O               fac, first, changed,
     O               count0, count1, year0, year1,
     I               myTime, myIter, myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE EXF_GetFFieldRec
C     | o Get flags, counters, and the linear interpolation
C     |   factor for a given field.
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "EXF_PARAM.h"
#ifdef ALLOW_CAL
# include "cal.h"
#endif

C     !INPUT PARAMETERS:
C     fldStartTime       :: time in seconds of first fld record from the
C                           beginning of the model integration or, if
C                           usefldyearlyfields, from the beginning of year
C     fldPeriod          :: period between forcing field records
C     fldRepeatCycle     :: time duration of a repeating cycle
C     fldName            :: field short name (to print mesg)
C     usefldyearlyfields :: when set, use yearly forcing files
C     myTime             :: current time in simulation
C     myIter             :: current iteration number in simulation
C     myThid             :: my thread identification number
      _RL     fldStartTime, fldPeriod, fldRepeatCycle
      CHARACTER*(*) fldName
      LOGICAL usefldyearlyfields
      _RL     myTime
      INTEGER myIter, myThid

C     !OUTPUT PARAMETERS:
C     fac     :: weight of record count0 for linear interpolation purposes
C     first   :: model initialization flag: read two forcing records
C     changed :: flag indicating that a new forcing record must be read
C     count0  :: record number for forcing field preceding myTime
C     count1  :: record number for forcing field following myTime
C     year0   :: year of forcing file for record preceding myTime
C     year1   :: year of forcing file for record following myTime
      _RL     fac
      LOGICAL first, changed
      INTEGER count0, count1, year0, year1

C     !FUNCTIONS:
#ifdef ALLOW_CAL
      INTEGER  cal_IsLeap
      EXTERNAL cal_IsLeap
#endif

C     !LOCAL VARIABLES:
C     mydate        :: model date of current time step
C     yearStartDate :: start of year date for flux record just before mydate
C     difftime      :: time difference between yearStartDate and mydate
C     fldsectot     :: time in seconds from fldStartTime to mydate
C     fldsecs       :: time from start of current forcing period to mydate
C     fldsecs0      :: time from start of repeat period to mydate
C     fldsecs1      :: time from end of current forcing period to mydate
C     secondsInYear :: seconds in the flux year just before mydate
C     myDateSeconds :: seconds from beginning of year to mydate
#ifdef ALLOW_CAL
      INTEGER mydate(4)
      INTEGER yearStartDate(4)
      INTEGER difftime(4)
      _RL fldsectot, fldsecs, fldsecs0, fldsecs1
      _RL secondsInYear, myDateSeconds
#endif
       INTEGER intimeP, intime0, intime1
       _RL locTime, aWght, bWght
      CHARACTER*(MAX_LEN_MBUF) msgBuf
CEOP

#ifdef ALLOW_CAL
      IF ( useCAL ) THEN

C     Set some default values.
       first = ((myTime - modelstart) .lt. 0.5*modelstep)
       changed = .FALSE.

       if ( fldPeriod .eq. 0. _d 0 ) then
C     Read field only once in the beginning. Hack: count1=count0 causes
C     the model to read the first record twice, but since this this is
C     done only the first time around it is not too much of an overhead.
        first   = ((myTime - modelstart) .lt. 0.5*modelstep)
        changed = .FALSE.
        fac     = 1. _d 0
        count0  = 1
        count1  = count0
C     Give these variables some unproblematic values although they are
C     never used in this context.
        year0   = 0
        year1   = year0
       else
C       fldPeriod .ne. 0
        if (.not.usefldyearlyfields) then

C     Determine offset in seconds from beginning of input data
C     to current date.
         fldsectot = myTime - fldStartTime

C     Determine the flux records just before and after mycurrentdate.
         if ( fldRepeatCycle .eq. 0. _d 0 ) then

          if ( fldsectot .lt. 0. _d 0 ) then
           WRITE(msgBuf,'(4A,1P1E17.10,A)') 'EXF_GetFFieldRec ',
     &       'for field "', fldName, '": myTime=', myTime, ' earlier'
           CALL PRINT_ERROR( msgBuf, myThid )
           WRITE(msgBuf,'(2A,1P1E18.10,A)') 'EXF_GetFFieldRec: ',
     &       'than 1rst reccord (field-startdate=', fldStartTime, ')'
           CALL PRINT_ERROR( msgBuf, myThid )
           STOP 'ABNORMAL END: S/R EXF_GetFFieldRec'
          endif
          count0       = INT((fldsectot+0.5)/fldPeriod) + 1
          count1       = count0 + 1
          fldsecs      = MOD(fldsectot,fldPeriod)

         else
C        if ( fldRepeatCycle .gt. 0. )

C     If using repeating data then make fldsectot cycle around.
          if (fldsectot.lt.0. _d 0)
     &        fldsectot = fldsectot + fldRepeatCycle
          fldsecs0     = MOD(fldsectot,fldRepeatCycle)
          count0       = INT((fldsecs0+0.5)/fldPeriod) + 1
          fldsecs1     = MOD(fldsectot+fldPeriod,fldRepeatCycle)
          count1       = INT((fldsecs1+0.5)/fldPeriod) + 1
          fldsecs      = MOD(fldsecs0,fldPeriod)

         endif

C     Weight belonging to count0 for linear interpolation purposes.
         fac = 1. - fldsecs/fldPeriod

        else
C       if (usefldyearlyfields)

C     Determine seconds from beginning of year to model current time.
         CALL cal_GetDate( myIter, myTime, mydate, myThid )
         year0            = INT(mydate(1)/10000.)
         yearStartDate(1) = year0 * 10000 + 101
         yearStartDate(2) = 0
         yearStartDate(3) = mydate(3)
         yearStartDate(4) = mydate(4)
         CALL cal_TimePassed(yearStartDate,mydate,difftime,myThid)
         CALL cal_ToSeconds (difftime,myDateSeconds,myThid)

C     Determine the flux year just before mycurrentdate.
         if ( myDateSeconds .lt. fldStartTime ) year0 = year0 - 1

C     Determine seconds in the flux year just before mycurrentdate.
         secondsInYear = ndaysnoleap * secondsperday
         if ( cal_IsLeap(year0,myThid) .eq. 2)
     &       secondsInYear = ndaysleap * secondsperday

C     Determine the record just before mycurrentdate.
         if ( myDateSeconds .lt. fldStartTime )
     &       myDateSeconds = myDateSeconds + secondsInYear
         fldsectot = myDateSeconds - fldStartTime
         count0    = INT((fldsectot+0.5)/fldPeriod) + 1

C     Determine the flux year and record just after mycurrentdate.
         year1  = year0
         count1 = count0 + 1
         if ( (fldStartTime+count0*fldPeriod) .ge. secondsInYear ) then
          year1  = year0 + 1
          count1 = 1
         endif

C     Weight belonging to count0 for linear interpolation purposes.
         fldsecs = MOD(fldsectot,fldPeriod)
         fac     = 1. - fldsecs/fldPeriod
         if ( year0 .ne. year1 )
     &       fac = 1. - fldsecs/(secondsInYear-(count0-1)*fldPeriod)

       endif
C      if (usefldyearlyfields)

C     Set switch for reading new record.
       if ( fldsecs - modelstep .lt. 0. _d 0 ) changed = .TRUE.

       endif
C      if (fldPeriod .eq. 0.)

      ELSE
#else /* ALLOW_CAL */
      IF ( .TRUE. ) THEN
#endif /* ALLOW_CAL */

       year0 = 0
       year1 = 0

       IF ( fldPeriod .EQ. 0. _d 0 ) THEN
        fac     = 1. _d 0
        first   = ( myIter.EQ.nIter0 )
        changed = .FALSE.
C     Read field only once in the beginning. Hack: count1=count0 causes
C     the model to read the first record twice, but since this this is
C     done only the first time around it is not too much of an overhead.
        count0  = 1
        count1  = 1

       ELSE
        locTime = myTime - fldStartTime + fldPeriod*halfRL
        CALL GET_PERIODIC_INTERVAL(
     O                  intimeP, intime0, intime1, bWght, aWght,
     I                  fldRepeatCycle, fldPeriod,
     I                  deltaTClock, locTime, myThid )

C      Fld @ t = bWght*Fld(intime0) + aWght*Fld(intime1)
        fac     =  bWght
        first   = ( myIter .EQ.nIter0 )
        changed = ( intime0.NE.intimeP )
        count0  = intime0
        count1  = intime1

        IF ( intime0 .LE. 0 ) THEN
           WRITE(msgBuf,'(3A,I10,A,1P1E17.10)')
     &       'EXF_GetFFieldRec: for field "', fldName,
     &       '" @ Iter=', myIter, ' , myTime=', myTime
           CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                         SQUEEZE_RIGHT, myThid )
           WRITE(msgBuf,'(2(A,1P1E18.10))')
     &       'EXF_GetFFieldRec:  fldRepeatCycle=', fldRepeatCycle,
     &                            ' , fldPeriod=', fldPeriod
           CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                         SQUEEZE_RIGHT, myThid )
           WRITE(msgBuf,'(3(A,I8))') 'EXF_GetFFieldRec:  intimeP=',
     &       intimeP, ', intime0=', intime0, ', intime1=', intime1
           CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                         SQUEEZE_RIGHT, myThid )
           WRITE(msgBuf,'(2(A,1P1E14.7),A,1P1E16.9)')
     &      'EXF_GetFFieldRec:  bWght,aWght=', bWght, ',', aWght,
     &      ' @ locTime=', locTime
           CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                         SQUEEZE_RIGHT, myThid )
           WRITE(msgBuf,'(2A)') 'EXF_GetFFieldRec: ',
     &        'Reccord number "intime0" not valid ; possible cause:'
           CALL PRINT_ERROR( msgBuf, myThid )
           WRITE(msgBuf,'(2A,1P2E18.10)') 'EXF_GetFFieldRec: ',
     &        ' myTime earlier than field-StartTime=', fldStartTime
           CALL PRINT_ERROR( msgBuf, myThid )
           STOP 'ABNORMAL END: S/R EXF_GetFFieldRec'
        ENDIF

C-     end if fldPeriod=0
       ENDIF

C--   end if/else useCAL
      ENDIF

      RETURN
      END

#include "GMREDI_OPTIONS.h"

C     !ROUTINE: EIGENVAL
C     !INTERFACE:
      SUBROUTINE GMREDI_CALC_EIGS(
     I     iMin, iMax, jMin, jMax,
     I     bi, bj, N2, myThid, kLow,
     I     mask, hfac, recip_hfac,
     I     rlow, nmodes, writediag,
     O     Rmid, vec)

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE GMREDI_CALC_URMS
C     | o Calculate the vertical structure of the rms eddy
C     |   velocity based on baroclinic modal decomposition
C     *==========================================================*
C     \ev

      IMPLICIT NONE

C     == Global variables ==
#include "SIZE.h"
#include "GRID.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GMREDI.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     bi, bj    :: tile indices
      LOGICAL writediag
      INTEGER iMin,iMax,jMin,jMax
      INTEGER bi, bj
      INTEGER myThid
      INTEGER nmodes
      INTEGER kLow(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL mask(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL hfac(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL recip_hfac(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL rlow(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL N2(  1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL Rmid(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL vec(nmodes,1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)

#ifdef GM_BATES_K3D
C     !LOCAL VARIABLES:
C     == Local variables ==
      INTEGER i,j,k,kk,m
# ifdef HAVE_LAPACK
C     info     :: error code from LAPACK
C     idx      :: index used for sorting the eigenvalues
C     a3d      :: lower diagonal of eigenvalue problem
C     b3d      :: diagonal of eigenvalue problem
C     c3d      :: upper diagonal of eigenvalue problem
C     val      :: Eigenvalue (wavenumber) of the first baroclinic mode
C     eigR     :: Real component of all the eigenvalues in a water column
C     eigI     :: Imaginary component of all the eigenvalues in a water column
C     vecs     :: All the eigenvectors of a water column
C     dummy    :: Redundant variable for calling lapack
C     work     :: Work array for lapack
C     array    :: Array containing the matrix with a,b,c
C     eigval   :: Vector containing the eigenvalues
      INTEGER info
      INTEGER idx
      _RL a3d(   1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL b3d(   1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL c3d(   1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL val(   1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL eigR(Nr),eigI(Nr),vecs(Nr,Nr),dummy(1,Nr),work(Nr*Nr)
      _RL array(Nr,Nr)
      _RL eigval(0:nmodes)
# else
C     drNr     :: distance from bottom of cell to cell centre at Nr
C     BuoyFreq :: buoyancy frequency, SQRT(N2)
C     intN     :: Vertical integral of BuoyFreq to each grid cell centre
C     intN0    :: Vertical integral of BuoyFreq to z=0
C     c1       :: intN0/pi
C     nEigs    :: number of eigenvalues/vectors to calculate
      _RL drNr
      _RL BuoyFreq(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr+1)
      _RL intN(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL intN0(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL c1(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER nEigs(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
# endif
C     small    :: a small number (used to avoid floating point exceptions)
C     vecint   :: vertical integral of eigenvector and/or square of eigenvector
C     fCori2   :: square of the Coriolis parameter
      _RL small
      _RL vecint(nmodes,1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL fCori2(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      CHARACTER*(MAX_LEN_MBUF) msgBuf

      small = TINY(zeroRL)

C     Square of the Coriolis parameter
      DO i=1-OLx,sNx+OLx
       DO j=1-OLy,sNy+OLy
        fCori2(i,j) = fCori(i,j,bi,bj)*fCori(i,j,bi,bj)
       ENDDO
      ENDDO

      DO k=1,Nr
       DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
         DO m=1,nmodes
          vec(m,i,j,k) = zeroRL
         ENDDO
        ENDDO
       ENDDO
      ENDDO

# ifdef HAVE_LAPACK
C     Calculate the tridiagonal operator matrix for
C     f^2 d/dz 1/N^2 d/dz
C     a3d is the lower off-diagonal, b3d is the diagonal
C     and c3d is the upper off-diagonal
      DO k=1,Nr
       DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
         IF (kLow(i,j) .GT. 0) THEN
           IF (k.EQ.1) THEN
             a3d(i,j,k) = zeroRL
             c3d(i,j,k) = fCori2(i,j)*recip_hFac(i,j,k)
     &                    *recip_drC(k+1)*recip_drF(k)/N2(i,j,k+1)
             b3d(i,j,k) = -c3d(i,j,k)

           ELSEIF (k.LT.kLow(i,j)) THEN
             a3d(i,j,k) = fCori2(i,j)*recip_hFac(i,j,k)
     &                    *recip_drF(k)*recip_drC(k)/N2(i,j,k)
             c3d(i,j,k) = fCori2(i,j)*recip_hFac(i,j,k)
     &                    *recip_drF(k)*recip_drC(k+1)/N2(i,j,k+1)
             b3d(i,j,k) = -a3d(i,j,k)-c3d(i,j,k)

           ELSEIF (k.EQ.kLow(i,j)) THEN
             a3d(i,j,k) = fCori2(i,j)*recip_hFac(i,j,k)
     &                    *recip_drF(k)*recip_drC(k)/N2(i,j,k)
             c3d(i,j,k) = zeroRL
             b3d(i,j,k) = -a3d(i,j,k)

           ELSE
             a3d(i,j,k) = zeroRL
             b3d(i,j,k) = zeroRL
             c3d(i,j,k) = zeroRL
           ENDIF

         ELSE
           a3d(i,j,k) = zeroRL
           b3d(i,j,k) = zeroRL
           c3d(i,j,k) = zeroRL
         ENDIF
        ENDDO
       ENDDO
      ENDDO

      DO j=1-OLy,sNy+OLy
       DO i=1-OLx,sNx+OLx
        IF (kLow(i,j).GT.0) THEN
          DO kk=1,Nr
           DO k=1,Nr
            array(k,kk) = zeroRL
           ENDDO
          ENDDO

          k=1
          array(k,k)   = b3d(i,j,k)
          array(k,k+1) = c3d(i,j,k)
          DO k=2,Nr-1
           array(k,k-1) = a3d(i,j,k)
           array(k,k)   = b3d(i,j,k)
           array(k,k+1) = c3d(i,j,k)
          ENDDO
          k=Nr
          array(k,k-1) = a3d(i,j,k)
          array(k,k)   = b3d(i,j,k)

          CALL DGEEV('N','V',Nr,array,Nr,eigR,eigI,dummy,1,
     &         vecs,Nr,work,Nr*Nr,info)
          IF( info.LT.0 ) THEN
            WRITE(msgBuf,'(A,x,2(A1,I2),A1,x,A,I4)')
     &           'GMREDI_CALC_EIGS problem with arguments for DGEEV at',
     &           '(',i,',',j,')', 'error code =',info
            CALL PRINT_ERROR( msgBuf , myThid )

          ELSEIF(info.GT.0 ) THEN
            WRITE(msgBuf,'(A,x,2(A1,I2),A1,x,A,I4)')
     &           'GMREDI_CALC_EIGS problems with eigensolver DGEEV at',
     &           '(',i,',',j,')', 'error code =',info
            CALL PRINT_ERROR( msgBuf , myThid )

          ENDIF

C         Find the second largest eigenvalue (the Rossby radius)
C         and the first M baroclinic modes (eigenvectors)
          DO m=0,nmodes
           eigval(m) = -HUGE(zeroRL)
          ENDDO

          DO k=1,kLow(i,j)
           eigval(0) = MAX(eigval(0),eigR(k))
          ENDDO
          DO m=1,MIN(nmodes,klow(i,j)-1)
           DO k=1,kLow(i,j)
            IF (eigR(k).LT.eigval(m-1)) THEN
              eigval(m) = MAX(eigval(m),eigR(k))
              IF (eigval(m).EQ.eigR(k)) idx=k
            ENDIF
           ENDDO
           IF(vecs(1,idx).LT.zeroRL) THEN
             DO k=1,Nr
              vec(m,i,j,k) = -vecs(k,idx)
             ENDDO
           ELSE
             DO k=1,Nr
              vec(m,i,j,k) = vecs(k,idx)
             ENDDO
           ENDIF
          ENDDO
          val(i,j) = eigval(1)
        ELSE
          val(i,j)=zeroRL
          DO k=1,Nr
           DO m=1,nmodes
            vec(m,i,j,k)=zeroRL
           ENDDO
          ENDDO

        ENDIF
       ENDDO
      ENDDO

       DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
         IF (kLow(i,j).GT.2 .AND. val(i,j).NE.zeroRL) THEN
           Rmid(i,j) = 1.0/(SQRT(ABS(val(i,j)))+small)
         ELSE
           Rmid(i,j) = zeroRL
         ENDIF
        ENDDO
       ENDDO

# else
      DO k=1,Nr
       DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
         BuoyFreq(i,j,k) = mask(i,j,k)*SQRT(N2(i,j,k))
        ENDDO
       ENDDO
      ENDDO
      k=Nr+1
      DO j=1-OLy,sNy+OLy
       DO i=1-OLx,sNx+OLx
        BuoyFreq(i,j,k) = zeroRL
       ENDDO
      ENDDO

C     integrate N using something like Simpson s rule (but not quite)
C     drC*( (N(k+1)+N(k+2))/2 + (N(k)+N(k+1))/2 )/2
C     when k=Nr, say that N(k+2)=0 and N(k+1)=0
      k=Nr
C     drNr is like drC(Nr+1)/2
      drNr = rC(Nr)-rF(Nr+1)
      DO j=1-OLy,sNy+OLy
       DO i=1-OLx,sNx+OLx
        intN(i,j,k) = op5*BuoyFreq(i,j,k)*drNr
       ENDDO
      ENDDO
      DO k=Nr-1,1,-1
       DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
         intN(i,j,k) = intN(i,j,k+1)
     &        + drC(k)*( op25*BuoyFreq(i,j,k+2) + op5*BuoyFreq(i,j,k)
     &                 + op25*BuoyFreq(i,j,k+1) )
        ENDDO
       ENDDO
      ENDDO

C     intN integrates to z=rC(1).  We want to integrate to z=0.
C     Assume that N(0)=0 and N(1)=0.
C     drC(1) is like half a grid cell.
      DO j=1-OLy,sNy+OLy
       DO i=1-OLx,sNx+OLx
        intN0(i,j) = intN(i,j,1)
     &       + drC(1)*op5*BuoyFreq(i,j,2)
       ENDDO
      ENDDO

      DO j=1-OLy,sNy+OLy
       DO i=1-OLx,sNx+OLx
        c1(i,j) = intN0(i,j)/pi
        Rmid(i,j) = c1(i,j)/ABS(fCori(i,j,bi,bj))
       ENDDO
      ENDDO

      DO j=1-OLy,sNy+OLy
       DO i=1-OLx,sNx+OLx
        nEigs(i,j) = MIN(klow(i,j),nmodes)
       ENDDO
      ENDDO
      DO k=1,Nr
       DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
         IF (mask(i,j,k).NE.0.0) THEN
           DO m=1,nEigs(i,j)
            vec(m,i,j,k) = -COS(intN(i,j,k)/(m*c1(i,j)))
           ENDDO
         ENDIF
        ENDDO
       ENDDO
      ENDDO

C     The WKB approximation for the baroclinic mode does not always
C     integrate to zero so we adjust it.
      DO j=1-OLy,sNy+OLy
       DO i=1-OLx,sNx+OLx
        DO m=1,nEigs(i,j)
         vecint(m,i,j) = zeroRL
        ENDDO
       ENDDO
      ENDDO
      DO k=1,Nr
       DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
         DO m=1,nEigs(i,j)
         vecint(m,i,j) = vecint(m,i,j) + hfac(i,j,k)*vec(m,i,j,k)*drF(k)
         ENDDO
        ENDDO
       ENDDO
      ENDDO
      DO j=1-OLy,sNy+OLy
       DO i=1-OLx,sNx+OLx
        DO m=1,nEigs(i,j)
         vecint(m,i,j) = vecint(m,i,j)/(-rlow(i,j)+small)
        ENDDO
       ENDDO
      ENDDO
      DO k=1,Nr
       DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
         DO m=1,nEigs(i,j)
          vec(m,i,j,k) = vec(m,i,j,k) - vecint(m,i,j)
         ENDDO
        ENDDO
       ENDDO
      ENDDO
# endif

C     Normalise the eigenvectors
      DO j=1-OLy,sNy+OLy
       DO i=1-OLx,sNx+OLx
        DO m=1,nmodes
         vecint(m,i,j) = zeroRL
        ENDDO
       ENDDO
      ENDDO

      DO k=1,Nr
       DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
         DO m=1,nmodes
          vecint(m,i,j) = vecint(m,i,j) +
     &         mask(i,j,k)*drF(k)*hfac(i,j,k)
     &         *vec(m,i,j,k)*vec(m,i,j,k)
         ENDDO
        ENDDO
       ENDDO
      ENDDO

      DO j=1-OLy,sNy+OLy
       DO i=1-OLx,sNx+OLx
        DO m=1,nmodes
         vecint(m,i,j) = SQRT(vecint(m,i,j))
        ENDDO
       ENDDO
      ENDDO

      DO k=1,Nr
       DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
         DO m=1,nmodes
          vec(m,i,j,k) = vec(m,i,j,k)/(vecint(m,i,j)+small)
         ENDDO
        ENDDO
       ENDDO
      ENDDO

# ifdef ALLOW_DIAGNOSTICS
C     Diagnostics
      IF ( useDiagnostics.AND.writediag ) THEN
#  ifdef HAVE_LAPACK
        CALL DIAGNOSTICS_FILL(a3d, 'GM_A3D  ',0,Nr,0,1,1,myThid)
        CALL DIAGNOSTICS_FILL(b3d, 'GM_B3D  ',0,Nr,0,1,1,myThid)
        CALL DIAGNOSTICS_FILL(c3d, 'GM_C3D  ',0,Nr,0,1,1,myThid)
#  endif
      ENDIF
# endif

#endif /* GM_BATES_K3D */

      RETURN
      END

#include "MOM_COMMON_OPTIONS.h"

CBOP
C !ROUTINE: MOM_U_METRIC_NH

C !INTERFACE: ==========================================================
      SUBROUTINE MOM_U_METRIC_NH(
     I               bi,bj,k,
     I               uFld, wFld,
     O               uMetricTerms,
     I               myThid )

C !DESCRIPTION:
C Calculates the zonal metric term due to non-hydrostaticity on the sphere:
C \begin{equation}
C -\frac{u}{a} \overline{w}^{ik}
C \end{equation}

C !USES: ===============================================================
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"

C !INPUT PARAMETERS: ===================================================
C  bi,bj                :: tile indices
C  k                    :: vertical level
C  uFld                 :: zonal flow
C  wFld                 :: vertical flow
C  myThid               :: thread number
      INTEGER bi,bj,k
      _RL uFld(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL wFld(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      INTEGER myThid

C !OUTPUT PARAMETERS: ==================================================
C  uMetricTerms         :: metric term
      _RL uMetricTerms(1-OLx:sNx+OLx,1-OLy:sNy+OLy)

C !LOCAL VARIABLES: ====================================================
C  i,j                  :: loop indices
      INTEGER i,j,kp1
      _RL wVelBottomOverride
CEOP

      kp1=min(k+1,Nr)
      wVelBottomOverride=1.
      IF (k.EQ.Nr) wVelBottomOverride=0.

      DO j=1-Olx,sNy+Oly
       DO i=1-Olx+1,sNx+Olx
         uMetricTerms(i,j) = uFld(i,j)*recip_rSphere*recip_deepFacC(k)
     &    *0.25*( (wFld(i-1,j,kp1,bi,bj)+wFld(i,j,kp1,bi,bj))
     &            *rVel2wUnit(kp1)*wVelBottomOverride
     &          + (wFld(i-1,j, k ,bi,bj)+wFld(i,j, k ,bi,bj))
     &            *rVel2wUnit( k )
     &          )*gravitySign
       ENDDO
      ENDDO

      RETURN
      END

#include "MONITOR_OPTIONS.h"

C--  File mon_calc_advcfl.F: Routines to compute Tracer Advective CFL
C--   Contents
C--   o MON_CALC_ADVCFL_TILE
C--   o MON_CALC_ADVCFL_GLOB

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: MON_CALC_ADVCFL_TILE

C     !INTERFACE:
      SUBROUTINE MON_CALC_ADVCFL_TILE(
     I               myNr, bi, bj,
     I               uFld, vFld, wFld, dT_lev,
     O               maxCFL,
     I               myIter, myThid )

C     Calculate Maximum advective CFL in 3 direction (x,y,z)
C     for current tile bi,bj

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
c#include "SURFACE.h"
c#include "MONITOR.h"

C     !INPUT/OUTPUT PARAMETERS:
C     myNr    :: number of levels
C     bi, bj  :: tile indices
C     uFld    :: zonal velocity
C     vFld    :: merid velocity
C     wFld    :: vert. velocity
C     dT_lev  :: tracer time-step
C     maxCFL  :: maximum advective CFL in 3 directions
C     myIter  :: my Iteration number
C     myThid  :: my Thread Id number
      INTEGER myNr, bi, bj
      _RL uFld  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,myNr)
      _RL vFld  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,myNr)
      _RL wFld  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,myNr)
      _RL dT_lev(myNr)
      _RL maxCFL(3)
      INTEGER myIter, myThid
CEOP

C     !LOCAL VARIABLES:
      INTEGER i,j,k
      _RL uTrans(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL vTrans(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL rTrans(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL rTransKp1, tmpVal, recVol_dT

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      maxCFL(1) = 0.
      maxCFL(2) = 0.
      maxCFL(3) = 0.

      DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
          rTrans(i,j) = 0.
        ENDDO
      ENDDO

      DO k=myNr,1,-1

C--   compute horiz. transport and time-step divided by volume
C     (without level thickness "drF" since it cancels)
        DO j=1,sNy+1
         DO i=1,sNx+1
           uTrans(i,j) = uFld(i,j,k)*dyG(i,j,bi,bj)*deepFacC(k)
     &                         *hFacW(i,j,k,bi,bj)
           vTrans(i,j) = vFld(i,j,k)*dxG(i,j,bi,bj)*deepFacC(k)
     &                         *hFacS(i,j,k,bi,bj)
         ENDDO
        ENDDO
        DO j=1,sNy
         DO i=1,sNx
           recVol_dT = dT_lev(k)
     &             *recip_rA(i,j,bi,bj)*recip_deepFac2C(k)
     &                   *recip_hFacC(i,j,k,bi,bj)
           tmpVal = (
     &          + MAX( uTrans(i+1,j), zeroRL )
     &          - MIN( uTrans( i ,j), zeroRL )
     &              )*recVol_dT
           maxCFL(1) = MAX( maxCFL(1), tmpVal )
           tmpVal = (
     &          + MAX( vTrans(i,j+1), zeroRL )
     &          - MIN( vTrans(i, j ), zeroRL )
     &              )*recVol_dT
           maxCFL(2) = MAX( maxCFL(2), tmpVal )
         ENDDO
        ENDDO

C--   compute vert. transport and time-step divided by volume
C     (without grid-cell area "rA" since it cancels)
        DO j=1,sNy
         DO i=1,sNx
           rTransKp1 = rTrans(i,j)
           rTrans(i,j) = wFld(i,j,k)
     &                 *deepFac2F(k)*rhoFacF(k)
           recVol_dT = dT_lev(k)
     &             *recip_deepFac2C(k)*recip_rhoFacC(k)
     &             *recip_drF(k)*recip_hFacC(i,j,k,bi,bj)
           tmpVal = (
     &          + MAX( rTrans(i,j), zeroRL )
     &          - MIN( rTransKp1, zeroRL )
     &              )*recVol_dT
           maxCFL(3) = MAX( maxCFL(3), tmpVal )
         ENDDO
        ENDDO

      ENDDO

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: MON_CALC_ADVCFL_GLOB

C     !INTERFACE:
      SUBROUTINE MON_CALC_ADVCFL_GLOB(
     I               maxCFL, myIter, myThid )

C     !DESCRIPTION:
C     Calculate Maximum advective CFL in 3 direction (x,y,z)
C     in global domain (from tile-max value)

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "MONITOR.h"

C     !INPUT PARAMETERS:
C     maxCFL  :: maximum advective CFL (per tile) in 3 directions
C     myIter  :: Current iteration number in simulation
C     myThid  :: my Thread Id number
      _RL maxCFL(3,nSx,nSy)
      INTEGER myIter
      INTEGER myThid
CEOP

C     !LOCAL VARIABLES:
      INTEGER bi, bj
      _RL uCFL, vCFL, wCFL

      uCFL = 0.
      vCFL = 0.
      wCFL = 0.
      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
         uCFL = MAX( uCFL, maxCFL(1,bi,bj) )
         vCFL = MAX( vCFL, maxCFL(2,bi,bj) )
         wCFL = MAX( wCFL, maxCFL(3,bi,bj) )
       ENDDO
      ENDDO
      _GLOBAL_MAX_RL( uCFL, myThid )
      _GLOBAL_MAX_RL( vCFL, myThid )
      _GLOBAL_MAX_RL( wCFL, myThid )

C-    store values in common bloc
      _BEGIN_MASTER(myThid)
       mon_trAdvCFL(1) = uCFL
       mon_trAdvCFL(2) = vCFL
       mon_trAdvCFL(3) = wCFL
      _END_MASTER(myThid)

      RETURN
      END

#include "ZONAL_FILT_OPTIONS.h"

CBOP
C     !ROUTINE: ZONAL_FILT_INIT
C     !INTERFACE:
      SUBROUTINE ZONAL_FILT_INIT( myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R ZONAL_FILT_INIT
C     | o Initialise FFT filter for latitude circle.
C     *==========================================================*
C     | The details of particular FFT libraries may differ.
C     | Changing to a different library may entail modifying the
C     | code here. However, the broad process is usually the
C     | same.
C     | Note - Fourier modes for sNx and sNx+1 are damped in the
C     |        same way. This is because we have not implemented
C     |        a scheme that sets the damping factor for the
C     |        highest wave number for odd sNx. Instead the
C     |        highest wave number for odd sNx. Instead only
C     |        wave numbers 1:INT(sNx/2) are partially damped.
C     |        Wave number sNx/2 (if it exists) is removed
C     |        altogether.
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "ZONAL_FILT.h"
#include "FFTPACK.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     myThid :: my Thread Id number
      INTEGER myThid
CEOP

#ifdef ALLOW_ZONAL_FILT
C     !LOCAL VARIABLES:
C     == Local variables ==
C     alpha  :: Used to evaluate frequency and latitude dependent
C               amplitude damping factor.
C     wvNum  :: Wave number
C     lat    :: Temporary holding latitude
C     nWv    :: No. of waves that fit on grid.
C     msgBuf :: Informational/error message buffer
c     _RL alpha, wvNum
c     INTEGER nWv
      INTEGER i, j, bi, bj
      CHARACTER*(MAX_LEN_MBUF) msgBuf

C     !FUNCTIONS:
      _RL ampfact
      _RS lat
      ampfact(lat,i) = MIN( oneRL,
     &   ( COS( ABS(lat)*deg2rad )
     &      /COS( zonal_filt_lat*deg2rad ) )**zonal_filt_cospow
     &      /(SIN( PI*FLOAT(i)/FLOAT(Nx) ) )**zonal_filt_sinpow
     &   )

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      IF ( sNx.NE.Nx ) THEN
         WRITE(msgBuf,'(A,I3,A)')
     &    'S/R ZONAL_FILT_INIT: Multi-tiles ( nSx*nPx=', nSx*nPx, ' )'
         CALL PRINT_ERROR( msgBuf, myThid )
         WRITE(msgBuf,'(A)')
     &    ' in Zonal (X) dir. not implemented in Zonal-Filter code'
         CALL PRINT_ERROR( msgBuf, myThid )
         STOP 'ABNORMAL END: S/R ZONAL_FILT_INIT'
      ENDIF

      _BEGIN_MASTER(myThid)
C     o Initialise specific library FFT package
      DO bj=1,nSy
c      CALL R8FFTI( Nx, FFTPACKWS(1,bj) )
       CALL R8FFTI1( Nx, FFTPACKWS2(1,bj), FFTPACKWS3(1,bj) )
      ENDDO

C     o Set amplitude scale factor as function of latitude and mode number
      DO bj=1,nSy
       DO bi=1,nSx
        DO j=1-oLy,sNy+Oly
         ampFactor(1,j,bi,bj) = oneRL
         ampFactorV(1,j,bi,bj) = oneRL
         DO i=1,Nx/2-1
          ampFactor(2*i,j,bi,bj) = ampfact( yC(1,j,bi,bj) , I )
c         IF (ampFactor(2*i,j,bi,bj).LE..9) ampFactor(2*i,j,bi,bj)=0.
          ampFactor(2*I+1,j,bi,bj) = ampFactor(2*i,j,bi,bj)
          ampFactorV(2*i,j,bi,bj) = ampfact( yG(1,j,bi,bj) , I )
c         IF (ampFactorV(2*i,j,bi,bj).LE..9) ampFactorV(2*i,j,bi,bj)=0.
          ampFactorV(2*I+1,j,bi,bj) = ampFactorV(2*i,j,bi,bj)
         ENDDO

         i=Nx/2
         IF ( zonal_filt_mode2dx.EQ.0 ) THEN
           ampFactor(Nx,j,bi,bj) = ampfact( yC(1,j,bi,bj) , i )
           ampFactorV(Nx,j,bi,bj) = ampfact( yG(1,j,bi,bj) , i )
         ELSE
           ampFactor(Nx,j,bi,bj) = 0.
           ampFactorV(Nx,j,bi,bj) = 0.
         ENDIF

        ENDDO
       ENDDO
      ENDDO
      _END_MASTER(myThid)
      CALL BAR2(myThid)

      CALL WRITE_REC_XY_RL( 'ampFactor', ampFactor, 1, 0, myThid )

#endif /* ALLOW_ZONAL_FILT */

      RETURN
      END

#include "CTRL_OPTIONS.h"
#ifdef ALLOW_OBCS
# include "OBCS_OPTIONS.h"
#endif

      subroutine ctrl_getobcsw(
     I                          myTime, myIter, myThid )

c     ==================================================================
c     SUBROUTINE ctrl_getobcsw
c     ==================================================================
c
c     o Get western obc of the control vector and add it
c       to dyn. fields
c
c     started: heimbach@mit.edu, 29-Aug-2001
c     modified: gebbie@mit.edu, 18-Mar-2003
c
c     ==================================================================
c     SUBROUTINE ctrl_getobcsw
c     ==================================================================

      implicit none

c     == global variables ==
#ifdef ALLOW_OBCSW_CONTROL
#include "EEPARAMS.h"
#include "SIZE.h"
#include "PARAMS.h"
#include "GRID.h"
#include "OBCS_PARAMS.h"
#include "OBCS_GRID.h"
#include "OBCS_FIELDS.h"
#include "CTRL_SIZE.h"
#include "CTRL.h"
#include "CTRL_DUMMY.h"
#include "CTRL_OBCS.h"
#include "OPTIMCYCLE.h"
#endif /* ALLOW_OBCSW_CONTROL */

c     == routine arguments ==
      _RL     myTime
      integer myIter
      integer myThid

#if ( defined ALLOW_OBCS_WEST && defined ALLOW_OBCSW_CONTROL )
c     == external functions ==
      integer  ilnblnk
      external ilnblnk

c     == local variables ==
      integer bi,bj
      integer i,j,k
      integer itlo,ithi
      integer jtlo,jthi
      integer jmin,jmax
      integer ilobcsw
      integer iobcs
      integer ip1
      _RL     obcswfac
      logical obcswfirst
      logical obcswchanged
      integer obcswcount0
      integer obcswcount1
cgg      _RL maskyz   (1-OLy:sNy+OLy,Nr,nSx,nSy)
      _RL tmpfldyz (1-OLy:sNy+OLy,Nr,nSx,nSy)
      logical doglobalread
      logical ladinit
      character*(MAX_LEN_FNAM) fnameobcsw
#ifdef ALLOW_OBCS_CONTROL_MODES
      integer nk,nz
      _RL     tmpz (Nr,nSx,nSy)
      _RL     stmp
#endif
      integer ilDir

c     == end of interface ==

      jtlo = myByLo(myThid)
      jthi = myByHi(myThid)
      itlo = myBxLo(myThid)
      ithi = myBxHi(myThid)
      jmin = 1-OLy
      jmax = sNy+OLy
      ip1  = 1

c--   Now, read the control vector.
      doglobalread = .false.
      ladinit      = .false.

c     Find ctrlDir (w/o trailing blanks) length
      ilDir = ilnblnk(ctrlDir)

      if (optimcycle .ge. 0) then
       ilobcsw=ilnblnk( xx_obcsw_file )
       write(fnameobcsw,'(2a,i10.10)')
     &      ctrlDir(1:ilDir)//xx_obcsw_file(1:ilobcsw), '.', optimcycle
      endif

c--   Get the counters, flags, and the interpolation factor.
      call ctrl_get_gen_rec(
     I                   xx_obcswstartdate, xx_obcswperiod,
     O                   obcswfac, obcswfirst, obcswchanged,
     O                   obcswcount0,obcswcount1,
     I                   myTime, myIter, myThid )

      do iobcs = 1,nobcs

       if ( obcswfirst ) then
#ifdef ALLOW_AUTODIFF
        call active_read_yz( fnameobcsw, tmpfldyz,
     &                       (obcswcount0-1)*nobcs+iobcs,
     &                       doglobalread, ladinit, optimcycle,
     &                       myThid, xx_obcsw_dummy )
#else
        CALL READ_REC_YZ_RL( fnameobcsw, ctrlprec, Nr, tmpfldyz,
     &                       (obcswcount0-1)*nobcs+iobcs, 1, myThid )
#endif

        do bj = jtlo,jthi
         do bi = itlo,ithi
#ifdef ALLOW_OBCS_CONTROL_MODES
          if (iobcs .gt. 2) then
           do j = jmin,jmax
            i = OB_Iw(j,bi,bj)
            IF ( i.EQ.OB_indexNone ) i = 1
cih    Determine number of open vertical layers.
            nz = 0
            do k = 1,Nr
              if (iobcs .eq. 3) then
                nz = nz + maskW(i+ip1,j,k,bi,bj)
              else
                nz = nz + maskS(i,j,k,bi,bj)
              endif
            end do
cih    Compute absolute velocities from the barotropic-baroclinic modes.
            do k = 1,Nr
             if (k.le.nz) then
              stmp = 0.
              do nk = 1,nz
               stmp = stmp +
     &         modesv(k,nk,nz)*tmpfldyz(j,nk,bi,bj)
              end do
               tmpz(k,bi,bj) = stmp
             else
              tmpz(k,bi,bj) = 0.
             end if
            enddo
            do k = 1,Nr
              if (iobcs .eq. 3) then
                tmpfldyz(j,k,bi,bj) = tmpz(k,bi,bj)
     &            *recip_hFacW(i+ip1,j,k,bi,bj)
              else
                tmpfldyz(j,k,bi,bj) = tmpz(k,bi,bj)
     &            *recip_hFacS(i,j,k,bi,bj)
              endif
            end do
           enddo
          endif
#endif
          do k = 1,Nr
           do j = jmin,jmax
            xx_obcsw1(j,k,bi,bj,iobcs)  = tmpfldyz (j,k,bi,bj)
cgg   &                                        *   maskyz (j,k,bi,bj)
           enddo
          enddo
         enddo
        enddo
       endif

       if ( (obcswfirst) .or. (obcswchanged)) then

        do bj = jtlo,jthi
         do bi = itlo,ithi
          do k = 1,Nr
           do j = jmin,jmax
            xx_obcsw0(j,k,bi,bj,iobcs) = xx_obcsw1(j,k,bi,bj,iobcs)
            tmpfldyz (j,k,bi,bj)       = 0. _d 0
           enddo
          enddo
         enddo
        enddo

#ifdef ALLOW_AUTODIFF
        call active_read_yz( fnameobcsw, tmpfldyz,
     &                       (obcswcount1-1)*nobcs+iobcs,
     &                       doglobalread, ladinit, optimcycle,
     &                       myThid, xx_obcsw_dummy )
#else
        CALL READ_REC_YZ_RL( fnameobcsw, ctrlprec, Nr, tmpfldyz,
     &                       (obcswcount1-1)*nobcs+iobcs, 1, myThid )
#endif

        do bj = jtlo,jthi
         do bi = itlo,ithi
#ifdef ALLOW_OBCS_CONTROL_MODES
          if (iobcs .gt. 2) then
           do j = jmin,jmax
            i = OB_Iw(j,bi,bj)
            IF ( i.EQ.OB_indexNone ) i = 1
cih    Determine number of open vertical layers.
            nz = 0
            do k = 1,Nr
              if (iobcs .eq. 3) then
                nz = nz + maskW(i+ip1,j,k,bi,bj)
              else
                nz = nz + maskS(i,j,k,bi,bj)
              endif
            end do
cih    Compute absolute velocities from the barotropic-baroclinic modes.
            do k = 1,Nr
             if (k.le.nz) then
              stmp = 0.
              do nk = 1,nz
               stmp = stmp +
     &         modesv(k,nk,nz)*tmpfldyz(j,nk,bi,bj)
              end do
               tmpz(k,bi,bj) = stmp
             else
               tmpz(k,bi,bj) = 0.
             end if
            enddo
            do k = 1,Nr
              if (iobcs .eq. 3) then
                tmpfldyz(j,k,bi,bj) = tmpz(k,bi,bj)
     &            *recip_hFacW(i+ip1,j,k,bi,bj)
              else
                tmpfldyz(j,k,bi,bj) = tmpz(k,bi,bj)
     &            *recip_hFacS(i,j,k,bi,bj)
              endif
            end do
           enddo
          endif
#endif
          do k = 1,Nr
           do j = jmin,jmax
            xx_obcsw1 (j,k,bi,bj,iobcs) = tmpfldyz (j,k,bi,bj)
cgg   &                                        *   maskyz (j,k,bi,bj)
           enddo
          enddo
         enddo
        enddo
       endif

c--   Add control to model variable.
       do bj = jtlo, jthi
        do bi = itlo, ithi
c--   Calculate mask for tracer cells (0 => land, 1 => water).
         do k = 1,Nr
          do j = 1,sNy
           i = OB_Iw(j,bi,bj)
           IF ( i.EQ.OB_indexNone ) i = 1
           if (iobcs .EQ. 1) then
            OBWt(j,k,bi,bj) = OBWt (j,k,bi,bj)
     &           + obcswfac            *xx_obcsw0(j,k,bi,bj,iobcs)
     &           + (1. _d 0 - obcswfac)*xx_obcsw1(j,k,bi,bj,iobcs)
            OBWt(j,k,bi,bj) = OBWt(j,k,bi,bj)
     &           *maskW(i+ip1,j,k,bi,bj)
           else if (iobcs .EQ. 2) then
            OBWs(j,k,bi,bj) = OBWs (j,k,bi,bj)
     &           + obcswfac            *xx_obcsw0(j,k,bi,bj,iobcs)
     &           + (1. _d 0 - obcswfac)*xx_obcsw1(j,k,bi,bj,iobcs)
            OBWs(j,k,bi,bj) = OBWs(j,k,bi,bj)
     &           *maskW(i+ip1,j,k,bi,bj)
           else if (iobcs .EQ. 3) then
            OBWu(j,k,bi,bj) = OBWu (j,k,bi,bj)
     &           + obcswfac            *xx_obcsw0(j,k,bi,bj,iobcs)
     &           + (1. _d 0 - obcswfac)*xx_obcsw1(j,k,bi,bj,iobcs)
            OBWu(j,k,bi,bj) = OBWu(j,k,bi,bj)
     &           *maskW(i+ip1,j,k,bi,bj)
           else if (iobcs .EQ. 4) then
            OBWv(j,k,bi,bj) = OBWv (j,k,bi,bj)
     &           + obcswfac            *xx_obcsw0(j,k,bi,bj,iobcs)
     &           + (1. _d 0 - obcswfac)*xx_obcsw1(j,k,bi,bj,iobcs)
            OBWv(j,k,bi,bj) = OBWv(j,k,bi,bj)
     &           *maskS(i,j,k,bi,bj)
           endif
          enddo
         enddo
        enddo
       enddo

C--   End over iobcs loop
      enddo

#endif /* defined ALLOW_OBCS_WEST && defined ALLOW_OBCSW_CONTROL */

      return
      end

#include "EXF_OPTIONS.h"

      SUBROUTINE EXF_READPARMS( myThid )

C     ==================================================================
C     SUBROUTINE exf_readparms
C     ==================================================================
C
C     o This routine initialises the package that calculates external
C       forcing fields for a given timestep of the MITgcmUV. Parameters
C       for this package are set in "data.externalforcing". Some additional
C       precompiler switches have to be specified in "EXF_OPTIONS.h".
C
C     started: Christian Eckert eckert@mit.edu  30-Jun-1999
C
C     changed: Christian Eckert eckert@mit.edu  11-Jan-2000
C              - Restructured the code in order to create a package
C                for the MITgcmUV.
C              Christian Eckert eckert@mit.edu  12-Feb-2000
C              - Changed Routine names (package prefix: exf_)
C     changed: Patrick Heimbach, heimbach@mit.edu  04-May-2000
C              - changed the handling of precip and sflux with respect
C                to CPP options ALLOW_BULKFORMULAE and ALLOW_ATM_TEMP
C     changed: Ralf.Giering@FastOpt.de 25-Mai-20000
C              - moved relaxation and climatology to extra routines
C              Patrick Heimbach, heimbach@mit.edu  04-May-2000
C              - added obcs parameters
C     changed: Virginie Thierry, vthierry@ucsd.edu 04-June-2001
C              - added new obcs parameters (for each boundaries)
C     included runoff D. Stammer, Nov. 25, 2001
C     included pressure forcing. heimbach@mit.edu 05-Nov-2002
C     added "repeatPeriod" for cycling of forcing datasets 19-Dec-2002
C     mods for pkg/seaice: menemenlis@jpl.nasa.gov 20-Dec-2002
C
C     ==================================================================
C     SUBROUTINE exf_readparms
C     ==================================================================

      IMPLICIT NONE

C     == global variables ==

#include "EEPARAMS.h"
#include "SIZE.h"
#include "PARAMS.h"
c#include "cal.h"
#include "EXF_PARAM.h"
#include "EXF_CONSTANTS.h"
#include "EXF_INTERP_SIZE.h"
#include "EXF_INTERP_PARAM.h"

C     == routine arguments ==
      INTEGER myThid

C     == local variables ==
#ifdef USE_EXF_INTERPOLATION
      INTEGER j
#endif /* USE_EXF_INTERPOLATION */
      INTEGER iUnit
      LOGICAL exf_verbose
      CHARACTER*(2) exf_yftype
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      _RL     exf_inscal_sst, exf_inscal_sss
C     == end of interface ==

C     Surface flux data.
      NAMELIST /EXF_NML_01/
     &      windstressmax,       repeatPeriod,    exf_albedo,
     &   ocean_emissivity,     ice_emissivity, snow_emissivity,
     &          exf_iceCd,          exf_iceCe,     exf_iceCh,
     &   exf_scal_BulkCdn,     climtempfreeze, useExfCheckRange,
     &      exf_iprec    ,   exf_iprec_obcs  , exf_yftype,
     &     exf_verbose  ,   exf_debugLev    , exf_monFreq,
     &     exf_adjMonFreq, exf_adjMonSelect,
     & useExfYearlyFields,  twoDigitYear,
     & readStressOnAgrid, rotateStressOnAgrid, readStressOnCgrid,
     & useAtmWind,          useRelativeWind  , noNegativeEvap,
     & useStabilityFct_overIce, diags_opOceWeighted,
     & select_ZenAlbedo, useExfZenIncoming,
     & hu, ht, umin, atmrho, atmcp, cen2kel, gravity_mks,
     & cdrag_1, cdrag_2, cdrag_3, cdrag_8, cdragMax, umax,
     & cstanton_1, cstanton_2, cdalton,
     & flamb, flami, zolmin, zref,
     & cvapor_fac, cvapor_exp, cvapor_fac_ice, cvapor_exp_ice,
     & humid_fac, gamma_blk, saltsat, sstExtrapol, psim_fac

      NAMELIST /EXF_NML_02/
     &          hfluxfile,     hfluxstartdate1,     hfluxstartdate2,
     &          hfluxRepCycle,     hfluxperiod,     hfluxStartTime,
     &          atempfile,     atempstartdate1,     atempstartdate2,
     &          atempRepCycle,     atempperiod,     atempStartTime,
     &            aqhfile,       aqhstartdate1,       aqhstartdate2,
     &            aqhRepCycle,       aqhperiod,       aqhStartTime,
     &            hs_file,       hs_startdate1,       hs_startdate2,
     &            hs_RepCycle,       hs_period,       hs_StartTime,
     &            hl_file,       hl_startdate1,       hl_startdate2,
     &            hl_RepCycle,       hl_period,       hl_StartTime,
     &          sfluxfile,     sfluxstartdate1,     sfluxstartdate2,
     &          sfluxRepCycle,     sfluxperiod,     sfluxStartTime,
     &           evapfile,      evapstartdate1,      evapstartdate2,
     &           evapRepCycle,      evapperiod,      evapStartTime,
     &         precipfile,    precipstartdate1,    precipstartdate2,
     &         precipRepCycle,    precipperiod,    precipStartTime,
     &     snowprecipfile, snowprecipstartdate1, snowprecipstartdate2,
     &     snowprecipRepCycle, snowprecipperiod, snowprecipStartTime,
     &         runofffile,    runoffstartdate1,    runoffstartdate2,
     &         runoffRepCycle,    runoffperiod,    runoffStartTime,
     &      runoftempfile,
     &        saltflxfile,   saltflxstartdate1,   saltflxstartdate2,
     &        saltflxRepCycle,   saltflxperiod,   saltflxStartTime,
     &        ustressfile,   ustressstartdate1,   ustressstartdate2,
     &        ustressRepCycle,   ustressperiod,   ustressStartTime,
     &        vstressfile,   vstressstartdate1,   vstressstartdate2,
     &        vstressRepCycle,   vstressperiod,   vstressStartTime,
     &          uwindfile,     uwindstartdate1,     uwindstartdate2,
     &          uwindRepCycle,     uwindperiod,     uwindStartTime,
     &          vwindfile,     vwindstartdate1,     vwindstartdate2,
     &          vwindRepCycle,     vwindperiod,     vwindStartTime,
     &         wspeedfile,    wspeedstartdate1,    wspeedstartdate2,
     &         wspeedRepCycle,    wspeedperiod,    wspeedStartTime,
     &         swfluxfile,    swfluxstartdate1,    swfluxstartdate2,
     &         swfluxRepCycle,    swfluxperiod,    swfluxStartTime,
     &         lwfluxfile,    lwfluxstartdate1,    lwfluxstartdate2,
     &         lwfluxRepCycle,    lwfluxperiod,    lwfluxStartTime,
     &         swdownfile,    swdownstartdate1,    swdownstartdate2,
     &         swdownRepCycle,    swdownperiod,    swdownStartTime,
     &         lwdownfile,    lwdownstartdate1,    lwdownstartdate2,
     &         lwdownRepCycle,    lwdownperiod,    lwdownStartTime,
     &      apressurefile, apressurestartdate1, apressurestartdate2,
     &      apressureRepCycle, apressureperiod, apressureStartTime,
     &        tidePotFile,   tidePotStartdate1,   tidePotStartdate2,
     &        tidePotRepCycle,   tidePotPeriod,   tidePotStartTime,
     &       areamaskfile,  areamaskstartdate1,  areamaskstartdate2,
     &       areamaskRepCycle,  areamaskperiod,  areamaskStartTime,
     &        climsstfile,   climsststartdate1,   climsststartdate2,
     &        climsstRepCycle,   climsstperiod,   climsstStartTime,
     &        climsssfile,   climsssstartdate1,   climsssstartdate2,
     &        climsssRepCycle,   climsssperiod,   climsssStartTime,
     &       climustrfile,  climustrstartdate1,  climustrstartdate2,
     &       climustrRepCycle,  climustrperiod,  climustrStartTime,
     &       climvstrfile,  climvstrstartdate1,  climvstrstartdate2,
     &       climvstrRepCycle,  climvstrperiod,  climvstrStartTime,
     &     areamaskTauRelax,  climsstTauRelax,    climsssTauRelax,
     &                       climustrTauRelax,   climvstrTauRelax

      NAMELIST /EXF_NML_03/
     &   exf_inscal_hflux,  exf_inscal_sflux,    exf_inscal_evap,
     & exf_inscal_ustress,  exf_inscal_vstress,
     &   exf_inscal_uwind,  exf_inscal_vwind,    exf_inscal_wspeed,
     &   exf_inscal_atemp,  exf_offset_atemp,
     &   exf_inscal_aqh,    exf_inscal_hs,       exf_inscal_hl,
     &     exf_inscal_sst,  exf_inscal_sss,
     &  exf_inscal_swflux,  exf_inscal_lwflux,   exf_inscal_precip,
     &  exf_inscal_runoff,  exf_inscal_apressure, exf_inscal_snowprecip,
     &  exf_inscal_runoftemp, exf_inscal_saltflx,
     &  exf_inscal_swdown,  exf_inscal_lwdown,
     & exf_inscal_climsst, exf_inscal_climsss,
     & exf_inscal_climustr, exf_inscal_climvstr,
     &  exf_outscal_hflux,  exf_outscal_ustress, exf_outscal_vstress,
     & exf_outscal_swflux,  exf_outscal_sst,     exf_outscal_sss,
     &  exf_outscal_sflux,  exf_outscal_apressure,
     & exf_inscal_tidePot,  exf_outscal_tidePot,
     & exf_inscal_areamask, exf_outscal_areamask,
     &  hfluxconst, atempconst, aqhconst, hs_const, hl_const,
     &  sfluxconst, evapconst, precipconst, snowprecipconst,
     &  runoffconst, runoftempconst, saltflxconst, ustressconst,
     &  vstressconst, uwindconst, vwindconst, wspeedconst, swfluxconst,
     &  lwfluxconst, swdownconst, lwdownconst, apressureconst,
     &  tidePotConst, areamaskconst, climsstconst, climsssconst,
     &  climustrconst, climvstrconst,
     &     hflux_exfremo_intercept, hflux_exfremo_slope,
     &     atemp_exfremo_intercept, atemp_exfremo_slope,
     &     aqh_exfremo_intercept, aqh_exfremo_slope,
     &     hs_exfremo_intercept,  hs_exfremo_slope,
     &     hl_exfremo_intercept,  hl_exfremo_slope,
     &     sflux_exfremo_intercept, sflux_exfremo_slope,
     &     evap_exfremo_intercept, evap_exfremo_slope,
     &     precip_exfremo_intercept, precip_exfremo_slope,
     &     snowprecip_exfremo_intercept, snowprecip_exfremo_slope,
     &     runoff_exfremo_intercept, runoff_exfremo_slope,
     &     runoftemp_exfremo_intercept, runoftemp_exfremo_slope,
     &     saltflx_exfremo_intercept, saltflx_exfremo_slope,
     &     ustress_exfremo_intercept, ustress_exfremo_slope,
     &     vstress_exfremo_intercept, vstress_exfremo_slope,
     &     uwind_exfremo_intercept, uwind_exfremo_slope,
     &     vwind_exfremo_intercept, vwind_exfremo_slope,
     &     wspeed_exfremo_intercept, wspeed_exfremo_slope,
     &     swflux_exfremo_intercept, swflux_exfremo_slope,
     &     lwflux_exfremo_intercept, lwflux_exfremo_slope,
     &     swdown_exfremo_intercept, swdown_exfremo_slope,
     &     lwdown_exfremo_intercept, lwdown_exfremo_slope,
     &     apressure_exfremo_intercept, apressure_exfremo_slope,
     &     tidePot_exfremo_intercept, tidePot_exfremo_slope,
     &     areamask_exfremo_intercept, areamask_exfremo_slope,
     &     climsst_exfremo_intercept, climsst_exfremo_slope,
     &     climsss_exfremo_intercept, climsss_exfremo_slope,
     &     climustr_exfremo_intercept, climustr_exfremo_slope,
     &     climvstr_exfremo_intercept, climvstr_exfremo_slope

#ifdef USE_EXF_INTERPOLATION
      NAMELIST /EXF_NML_04/
     & ustress_lon0, ustress_lon_inc, ustress_lat0, ustress_lat_inc,
     & ustress_nlon, ustress_nlat, ustress_interpMethod,
     & vstress_lon0, vstress_lon_inc, vstress_lat0, vstress_lat_inc,
     & vstress_nlon, vstress_nlat, vstress_interpMethod,
     & hflux_lon0, hflux_lon_inc, hflux_lat0, hflux_lat_inc,
     & hflux_nlon, hflux_nlat, hflux_interpMethod,
     & sflux_lon0, sflux_lon_inc, sflux_lat0, sflux_lat_inc,
     & sflux_nlon, sflux_nlat, sflux_interpMethod,
     & swflux_lon0, swflux_lon_inc, swflux_lat0, swflux_lat_inc,
     & swflux_nlon, swflux_nlat, swflux_interpMethod,
     & lwflux_lon0, lwflux_lon_inc, lwflux_lat0, lwflux_lat_inc,
     & lwflux_nlon, lwflux_nlat, lwflux_interpMethod,
     & atemp_lon0, atemp_lon_inc, atemp_lat0, atemp_lat_inc,
     & atemp_nlon, atemp_nlat, atemp_interpMethod,
     & aqh_lon0, aqh_lon_inc, aqh_lat0, aqh_lat_inc,
     & aqh_nlon, aqh_nlat, aqh_interpMethod,
     & hs_lon0, hs_lon_inc, hs_lat0, hs_lat_inc,
     & hs_nlon, hs_nlat, hs_interpMethod,
     & hl_lon0, hl_lon_inc, hl_lat0, hl_lat_inc,
     & hl_nlon, hl_nlat, hl_interpMethod,
     & evap_lon0, evap_lon_inc, evap_lat0, evap_lat_inc,
     & evap_nlon, evap_nlat, evap_interpMethod,
     & precip_lon0, precip_lon_inc, precip_lat0, precip_lat_inc,
     & precip_nlon, precip_nlat, precip_interpMethod,
     & runoff_lon0, runoff_lon_inc, runoff_lat0, runoff_lat_inc,
     & runoff_nlon, runoff_nlat, runoff_interpMethod,
     & saltflx_lon0, saltflx_lon_inc,
     & saltflx_lat0, saltflx_lat_inc,
     & saltflx_nlon, saltflx_nlat, saltflx_interpMethod,
     & snowprecip_lon0, snowprecip_lon_inc,
     & snowprecip_lat0, snowprecip_lat_inc,
     & snowprecip_nlon, snowprecip_nlat, snowprecip_interpMethod,
     & uwind_lon0, uwind_lon_inc, uwind_lat0, uwind_lat_inc,
     & uwind_nlon, uwind_nlat, uwind_interpMethod,
     & vwind_lon0, vwind_lon_inc, vwind_lat0, vwind_lat_inc,
     & vwind_nlon, vwind_nlat, vwind_interpMethod,
     & wspeed_lon0, wspeed_lon_inc, wspeed_lat0, wspeed_lat_inc,
     & wspeed_nlon, wspeed_nlat, wspeed_interpMethod,
     & swdown_lon0, swdown_lon_inc, swdown_lat0, swdown_lat_inc,
     & swdown_nlon, swdown_nlat, swdown_interpMethod,
     & lwdown_lon0, lwdown_lon_inc, lwdown_lat0, lwdown_lat_inc,
     & lwdown_nlon, lwdown_nlat, lwdown_interpMethod,
     & apressure_lon0, apressure_lon_inc,
     & apressure_lat0, apressure_lat_inc,
     & apressure_nlon, apressure_nlat, apressure_interpMethod,
     & tidePot_lon0, tidePot_lon_inc, tidePot_lat0, tidePot_lat_inc,
     & tidePot_nlon, tidePot_nlat, tidePot_interpMethod,
     & areamask_lon0, areamask_lon_inc, areamask_lat0, areamask_lat_inc,
     & areamask_nlon, areamask_nlat, areamask_interpMethod,
     & climsst_lon0, climsst_lon_inc, climsst_lat0, climsst_lat_inc,
     & climsst_nlon, climsst_nlat, climsst_interpMethod,
     & climsss_lon0, climsss_lon_inc,climsss_lat0, climsss_lat_inc,
     & climsss_nlon, climsss_nlat, climsss_interpMethod,
     & climustr_lon0, climustr_lon_inc, climustr_lat0, climustr_lat_inc,
     & climustr_nlon, climustr_nlat, climustr_interpMethod,
     & climvstr_lon0, climvstr_lon_inc, climvstr_lat0, climvstr_lat_inc,
     & climvstr_nlon, climvstr_nlat, climvstr_interpMethod,
     & exf_output_interp
#endif /* USE_EXF_INTERPOLATION */

#ifdef ALLOW_OBCS
      NAMELIST /EXF_NML_OBCS/
     &    useOBCSYearlyFields,
     &    obcsNstartdate1,   obcsNstartdate2,   obcsNstartTime,
     &        obcsNperiod,   obcsNrepCycle,
     &    obcsSstartdate1,   obcsSstartdate2,   obcsSstartTime,
     &        obcsSperiod,   obcsSrepCycle,
     &    obcsEstartdate1,   obcsEstartdate2,   obcsEstartTime,
     &        obcsEperiod,   obcsErepCycle,
     &    obcsWstartdate1,   obcsWstartdate2,   obcsWstartTime,
     &        obcsWperiod,   obcsWrepCycle,
     &    siobNstartdate1,   siobNstartdate2,   siobNstartTime,
     &        siobNperiod,   siobNrepCycle,
     &    siobSstartdate1,   siobSstartdate2,   siobSstartTime,
     &        siobSperiod,   siobSrepCycle,
     &    siobEstartdate1,   siobEstartdate2,   siobEstartTime,
     &        siobEperiod,   siobErepCycle,
     &    siobWstartdate1,   siobWstartdate2,   siobWstartTime,
     &        siobWperiod,   siobWrepCycle
#endif /* ALLOW_OBCS */

      IF ( .NOT.useEXF ) THEN
C-    pkg EXF is not used
        _BEGIN_MASTER(myThid)
C-    Track pkg activation status:
C     print a (weak) warning if data.exf is found
         CALL PACKAGES_UNUSED_MSG( 'useEXF', ' ', ' ' )
        _END_MASTER(myThid)
        RETURN
      ENDIF

      _BEGIN_MASTER(myThid)

C     Set default values.

#ifdef USE_EXF_INTERPOLATION
C     define interpolation default input-grid
      CALL EXF_INIT_INTERP( myThid )
#endif /* USE_EXF_INTERPOLATION */
c     exf_verbose        = debugMode
      exf_verbose        = .FALSE.
      exf_debugLev       = debugLevel
      exf_monFreq        = monitorFreq
      exf_adjMonFreq     = adjMonitorFreq
      exf_adjMonSelect   = 1
      useExfCheckRange   = .TRUE.
      select_ZenAlbedo   = 0
      useExfZenIncoming  = .FALSE.
      readStressOnAgrid  = .FALSE.
      rotateStressOnAgrid= .FALSE.
      readStressOnCgrid  = .FALSE.
#ifdef ALLOW_ATM_WIND
      useAtmWind         = .TRUE.
#else
      useAtmWind         = .FALSE.
#endif
      useRelativeWind    = .FALSE.
      noNegativeEvap     = .FALSE.
      useStabilityFct_overIce = .FALSE.
      diags_opOceWeighted= .TRUE.

C-  default value should be set to main model parameter:
c     cen2kel     =  celsius2K
c     gravity_mks = gravity
c     atmcp       =  atm_Cp
c     humid_fac   =  atm_Rq     <- default is zero !!!

      cen2kel        =      273.150  _d 0
      gravity_mks    =        9.81   _d 0
      atmrho         =        1.200  _d 0
      atmcp          =     1005.000  _d 0
      flamb          =  2500000.000  _d 0
      flami          =   334000.000  _d 0
      cvapor_fac     =   640380.000  _d 0
      cvapor_exp     =     5107.400  _d 0
      cvapor_fac_ice = 11637800.000  _d 0
      cvapor_exp_ice =     5897.800  _d 0
      humid_fac      =        0.606  _d 0
      gamma_blk      =        0.010  _d 0
      saltsat        =        0.980  _d 0
      sstExtrapol    =        0.0    _d 0
      cdrag_1        =        0.0027000 _d 0
      cdrag_2        =        0.0001420 _d 0
      cdrag_3        =        0.0000764 _d 0
#ifdef  ALLOW_DRAG_LARGEYEAGER09
      cdrag_8        =       -3.1480700 _d -13
      cdragMax       =        2.34      _d -03
      umax           =       33.        _d 0
#else
      cdrag_8        = UNSET_RL
      cdragMax       = UNSET_RL
      umax           = UNSET_RL
#endif
      cstanton_1     =        0.0327 _d 0
      cstanton_2     =        0.0180 _d 0
      cdalton        =        0.0346 _d 0
      zolmin         =     -100.000  _d 0
      psim_fac       =        5.000  _d 0
      zref           =       10.000  _d 0
      hu             =       10.000  _d 0
      ht             =        2.000  _d 0
      umin           =        0.5    _d 0
      exf_iceCd        = 1.63 _d -3
      exf_iceCe        = 1.63 _d -3
      exf_iceCh        = 1.63 _d -3
      exf_albedo       = 0.1 _d 0
C--   this default is chosen to be backward compatible with
C--   an earlier setting of 5.5 = ocean_emissivity*stefanBoltzmann
      ocean_emissivity = 5.50 _d -8 / 5.670 _d -8
      ice_emissivity   = 0.95 _d 0
      snow_emissivity  = 0.95 _d 0

C     Calendar data.
      hfluxstartdate1    = 0
      hfluxstartdate2    = 0
      hfluxperiod        = 0.0 _d 0
      hfluxconst         = 0.0 _d 0
      hflux_exfremo_intercept = 0.0 _d 0
      hflux_exfremo_slope = 0.0 _d 0

      atempstartdate1    = 0
      atempstartdate2    = 0
      atempperiod        = 0.0 _d 0
      atempconst         = celsius2K
      atemp_exfremo_intercept = 0.0 _d 0
      atemp_exfremo_slope = 0.0 _d 0

      aqhstartdate1      = 0
      aqhstartdate2      = 0
      aqhperiod          = 0.0 _d 0
      aqhconst           = 0.0 _d 0
      aqh_exfremo_intercept = 0.0 _d 0
      aqh_exfremo_slope  = 0.0 _d 0

      hs_startdate1      = 0
      hs_startdate2      = 0
      hs_period          = 0.0 _d 0
      hs_const           = 0.0 _d 0
      hs_exfremo_intercept = 0.0 _d 0
      hs_exfremo_slope   = 0.0 _d 0

      hl_startdate1      = 0
      hl_startdate2      = 0
      hl_period          = 0.0 _d 0
      hl_const           = 0.0 _d 0
      hl_exfremo_intercept = 0.0 _d 0
      hl_exfremo_slope   = 0.0 _d 0

      sfluxstartdate1    = 0
      sfluxstartdate2    = 0
      sfluxperiod        = 0.0 _d 0
      sfluxconst         = 0.0 _d 0
      sflux_exfremo_intercept = 0.0 _d 0
      sflux_exfremo_slope = 0.0 _d 0

      evapstartdate1   = 0
      evapstartdate2   = 0
      evapperiod       = 0.0 _d 0
      evapconst        = 0.0 _d 0
      evap_exfremo_intercept = 0.0 _d 0
      evap_exfremo_slope = 0.0 _d 0

      precipstartdate1   = 0
      precipstartdate2   = 0
      precipperiod       = 0.0 _d 0
      precipconst        = 0.0 _d 0
      precip_exfremo_intercept = 0.0 _d 0
      precip_exfremo_slope = 0.0 _d 0

      snowprecipstartdate1   = 0
      snowprecipstartdate2   = 0
      snowprecipperiod       = 0.0 _d 0
      snowprecipconst        = 0.0 _d 0
      snowprecip_exfremo_intercept = 0.0 _d 0
      snowprecip_exfremo_slope = 0.0 _d 0

      runoffstartdate1   = 0
      runoffstartdate2   = 0
      runoffperiod       = 0.0 _d 0
      runoffconst        = 0.0 _d 0
      runoff_exfremo_intercept = 0.0 _d 0
      runoff_exfremo_slope = 0.0 _d 0

      runoftempconst              = 0.0 _d 0
      runoftemp_exfremo_intercept = 0.0 _d 0
      runoftemp_exfremo_slope     = 0.0 _d 0

      saltflxstartdate1  = 0
      saltflxstartdate2  = 0
      saltflxperiod      = 0.0 _d 0
      saltflxconst       = 0.0 _d 0
      saltflx_exfremo_intercept = 0.0 _d 0
      saltflx_exfremo_slope = 0.0 _d 0

      ustressstartdate1  = 0
      ustressstartdate2  = 0
      ustressperiod      = 0.0 _d 0
      ustressconst       = 0.0 _d 0
      ustress_exfremo_intercept = 0.0 _d 0
      ustress_exfremo_slope = 0.0 _d 0

      vstressstartdate1  = 0
      vstressstartdate2  = 0
      vstressperiod      = 0.0 _d 0
      vstressconst       = 0.0 _d 0
      vstress_exfremo_intercept = 0.0 _d 0
      vstress_exfremo_slope = 0.0 _d 0

      uwindstartdate1    = 0
      uwindstartdate2    = 0
      uwindperiod        = 0.0 _d 0
      uwindconst         = 0.0 _d 0
      uwind_exfremo_intercept = 0.0 _d 0
      uwind_exfremo_slope = 0.0 _d 0

      vwindstartdate1    = 0
      vwindstartdate2    = 0
      vwindperiod        = 0.0 _d 0
      vwindconst         = 0.0 _d 0
      vwind_exfremo_intercept = 0.0 _d 0
      vwind_exfremo_slope = 0.0 _d 0

      wspeedstartdate1    = 0
      wspeedstartdate2    = 0
      wspeedperiod        = 0.0 _d 0
      wspeedconst         = 0.0 _d 0
      wspeed_exfremo_intercept = 0.0 _d 0
      wspeed_exfremo_slope = 0.0 _d 0

      swfluxstartdate1   = 0
      swfluxstartdate2   = 0
      swfluxperiod       = 0.0 _d 0
      swfluxconst        = 0.0 _d 0
      swflux_exfremo_intercept = 0.0 _d 0
      swflux_exfremo_slope = 0.0 _d 0

      lwfluxstartdate1   = 0
      lwfluxstartdate2   = 0
      lwfluxperiod       = 0.0 _d 0
      lwfluxconst        = 0.0 _d 0
      lwflux_exfremo_intercept = 0.0 _d 0
      lwflux_exfremo_slope = 0.0 _d 0

      swdownstartdate1   = 0
      swdownstartdate2   = 0
      swdownperiod       = 0.0 _d 0
      swdownconst        = 0.0 _d 0
      swdown_exfremo_intercept = 0.0 _d 0
      swdown_exfremo_slope = 0.0 _d 0

      lwdownstartdate1   = 0
      lwdownstartdate2   = 0
      lwdownperiod       = 0.0 _d 0
      lwdownconst        = 0.0 _d 0
      lwdown_exfremo_intercept = 0.0 _d 0
      lwdown_exfremo_slope = 0.0 _d 0

      apressurestartdate1    = 0
      apressurestartdate2    = 0
      apressureperiod        = 0.0 _d 0
      apressureconst         = surf_pRef
      apressure_exfremo_intercept = 0.0 _d 0
      apressure_exfremo_slope = 0.0 _d 0

      tidePotStartdate1  = 0
      tidePotStartdate2  = 0
      tidePotPeriod      = 0.0 _d 0
      tidePotConst       = 0.0 _d 0
      tidePot_exfremo_intercept = 0. _d 0
      tidePot_exfremo_slope = 0. _d 0

      areamaskstartdate1 = 0
      areamaskstartdate2 = 0
      areamaskperiod     = 0.0 _d 0
      areamaskTauRelax   = 0.0 _d 0
      areamaskconst      = 0.0 _d 0
      areamask_exfremo_intercept = 0. _d 0
      areamask_exfremo_slope = 0. _d 0

      climsststartdate1  = 0
      climsststartdate2  = 0
      climsstperiod      = 0
      climsstTauRelax    = 0.0 _d 0
      climsstconst       = 0.0 _d 0
      climsst_exfremo_intercept = 0.0 _d 0
      climsst_exfremo_slope = 0.0 _d 0

      climsssstartdate1  = 0
      climsssstartdate2  = 0
      climsssperiod      = 0
      climsssTauRelax    = 0.0 _d 0
      climsssconst       = 0.0 _d 0
      climsss_exfremo_intercept = 0.0 _d 0
      climsss_exfremo_slope = 0.0 _d 0

      climustrstartdate1  = 0
      climustrstartdate2  = 0
      climustrperiod      = 0
      climustrTauRelax    = 0.0 _d 0
      climustrconst       = 0.0 _d 0
      climustr_exfremo_intercept = 0.0 _d 0
      climustr_exfremo_slope = 0.0 _d 0

      climvstrstartdate1  = 0
      climvstrstartdate2  = 0
      climvstrperiod      = 0
      climvstrTauRelax    = 0.0 _d 0
      climvstrconst       = 0.0 _d 0
      climvstr_exfremo_intercept = 0.0 _d 0
      climvstr_exfremo_slope = 0.0 _d 0

      useOBCSYearlyFields = .FALSE.
      obcsNstartdate1    = 0
      obcsNstartdate2    = 0
      obcsNperiod        = 0.0 _d 0
      obcsSstartdate1    = 0
      obcsSstartdate2    = 0
      obcsSperiod        = 0.0 _d 0
      obcsEstartdate1    = 0
      obcsEstartdate2    = 0
      obcsEperiod        = 0.0 _d 0
      obcsWstartdate1    = 0
      obcsWstartdate2    = 0
      obcsWperiod        = 0.0 _d 0

      siobNstartdate1    = UNSET_I
      siobNstartdate2    = UNSET_I
      siobNperiod        = UNSET_RL
      siobSstartdate1    = UNSET_I
      siobSstartdate2    = UNSET_I
      siobSperiod        = UNSET_RL
      siobEstartdate1    = UNSET_I
      siobEstartdate2    = UNSET_I
      siobEperiod        = UNSET_RL
      siobWstartdate1    = UNSET_I
      siobWstartdate2    = UNSET_I
      siobWperiod        = UNSET_RL

      repeatPeriod       = 0.0 _d 0
      windstressmax      = 2.0 _d 0

      exf_scal_BulkCdn   = 1.0  _d 0

C     Initialise freezing temperature of sea water
      climtempfreeze     = -1.9 _d 0

C     Data files.
      hfluxfile          = ' '
      atempfile          = ' '
      aqhfile            = ' '
      hs_file            = ' '
      hl_file            = ' '
      evapfile           = ' '
      precipfile         = ' '
      snowprecipfile     = ' '
      sfluxfile          = ' '
      runofffile         = ' '
      runoftempfile      = ' '
      saltflxfile        = ' '
      ustressfile        = ' '
      vstressfile        = ' '
      uwindfile          = ' '
      vwindfile          = ' '
      wspeedfile         = ' '
      swfluxfile         = ' '
      lwfluxfile         = ' '
      swdownfile         = ' '
      lwdownfile         = ' '
      apressurefile      = ' '
      tidePotFile        = ' '
      areamaskfile       = ' '
      climsstfile        = ' '
      climsssfile        = ' '
      climustrfile       = ' '
      climvstrfile       = ' '

C     Start Time.
      hfluxStartTime     = UNSET_RL
      atempStartTime     = UNSET_RL
      aqhStartTime       = UNSET_RL
      hs_StartTime       = UNSET_RL
      hl_StartTime       = UNSET_RL
      evapStartTime      = UNSET_RL
      precipStartTime    = UNSET_RL
      snowprecipStartTime= UNSET_RL
      sfluxStartTime     = UNSET_RL
      runoffStartTime    = UNSET_RL
      saltflxStartTime   = UNSET_RL
      ustressStartTime   = UNSET_RL
      vstressStartTime   = UNSET_RL
      uwindStartTime     = UNSET_RL
      vwindStartTime     = UNSET_RL
      wspeedStartTime    = UNSET_RL
      swfluxStartTime    = UNSET_RL
      lwfluxStartTime    = UNSET_RL
      swdownStartTime    = UNSET_RL
      lwdownStartTime    = UNSET_RL
      apressureStartTime = UNSET_RL
      tidePotStartTime   = UNSET_RL
      areamaskStartTime  = UNSET_RL
      climsstStartTime   = UNSET_RL
      climsssStartTime   = UNSET_RL
      climustrStartTime  = UNSET_RL
      climvstrStartTime  = UNSET_RL
      obcsNstartTime     = UNSET_RL
      obcsSstartTime     = UNSET_RL
      obcsEstartTime     = UNSET_RL
      obcsWstartTime     = UNSET_RL
      siobNstartTime     = UNSET_RL
      siobSstartTime     = UNSET_RL
      siobEstartTime     = UNSET_RL
      siobWstartTime     = UNSET_RL

C     Initialise file type and field precision
      exf_iprec            = 32
      exf_iprec_obcs       = UNSET_I
      exf_yftype           = 'RL'
      useExfYearlyFields   = .FALSE.
      twoDigitYear         = .FALSE.

C     Input scaling factors.
      exf_inscal_hflux     =  1. _d 0
      exf_inscal_sflux     =  1. _d 0
      exf_inscal_ustress   =  1. _d 0
      exf_inscal_vstress   =  1. _d 0
      exf_inscal_uwind     =  1. _d 0
      exf_inscal_vwind     =  1. _d 0
      exf_inscal_wspeed    =  1. _d 0
      exf_inscal_swflux    =  1. _d 0
      exf_inscal_lwflux    =  1. _d 0
      exf_inscal_precip    =  1. _d 0
      exf_inscal_snowprecip=  1. _d 0
c     exf_inscal_sst       =  1. _d 0
c     exf_inscal_sss       =  1. _d 0
      exf_inscal_atemp     =  1. _d 0
      exf_offset_atemp     =  0. _d 0
      exf_inscal_aqh       =  1. _d 0
      exf_inscal_hs        =  1. _d 0
      exf_inscal_hl        =  1. _d 0
      exf_inscal_evap      =  1. _d 0
      exf_inscal_apressure =  1. _d 0
      exf_inscal_runoff    =  1. _d 0
      exf_inscal_runoftemp =  1. _d 0
      exf_inscal_saltflx   =  1. _d 0
      exf_inscal_swdown    =  1. _d 0
      exf_inscal_lwdown    =  1. _d 0
      exf_inscal_climsst   =  1. _d 0
      exf_inscal_climsss   =  1. _d 0
      exf_inscal_climustr  =  1. _d 0
      exf_inscal_climvstr  =  1. _d 0
      exf_inscal_tidePot   =  1. _d 0
      exf_inscal_areamask  =  1. _d 0

C     Output scaling factors.
      exf_outscal_hflux    =  1. _d 0
      exf_outscal_sflux    =  1. _d 0
      exf_outscal_ustress  =  1. _d 0
      exf_outscal_vstress  =  1. _d 0
      exf_outscal_swflux   =  1. _d 0
      exf_outscal_sst      =  1. _d 0
      exf_outscal_sss      =  1. _d 0
      exf_outscal_apressure=  1. _d 0
      exf_outscal_tidePot  =  1. _d 0
      exf_outscal_areamask =  1. _d 0

#ifdef USE_EXF_INTERPOLATION
      ustress_lon0   = inp_lon0
      uwind_lon0     = inp_lon0
      vstress_lon0   = inp_lon0
      hflux_lon0     = inp_lon0
      sflux_lon0     = inp_lon0
      swflux_lon0    = inp_lon0
      runoff_lon0    = inp_lon0
      saltflx_lon0   = inp_lon0
      atemp_lon0     = inp_lon0
      aqh_lon0       = inp_lon0
      hs_lon0        = inp_lon0
      hl_lon0        = inp_lon0
      evap_lon0      = inp_lon0
      precip_lon0    = inp_lon0
      snowprecip_lon0= inp_lon0
      vwind_lon0     = inp_lon0
      wspeed_lon0    = inp_lon0
      lwflux_lon0    = inp_lon0
      swdown_lon0    = inp_lon0
      lwdown_lon0    = inp_lon0
      apressure_lon0 = inp_lon0
      tidePot_lon0   = inp_lon0
      areamask_lon0  = inp_lon0
      vstress_lat0   = inp_lat0
      vwind_lat0     = inp_lat0
      wspeed_lat0    = inp_lat0
      ustress_lat0   = inp_lat0
      hflux_lat0     = inp_lat0
      sflux_lat0     = inp_lat0
      runoff_lat0    = inp_lat0
      saltflx_lat0   = inp_lat0
      swflux_lat0    = inp_lat0
      atemp_lat0     = inp_lat0
      aqh_lat0       = inp_lat0
      hs_lat0        = inp_lat0
      hl_lat0        = inp_lat0
      evap_lat0      = inp_lat0
      precip_lat0    = inp_lat0
      snowprecip_lat0= inp_lat0
      uwind_lat0     = inp_lat0
      lwflux_lat0    = inp_lat0
      swdown_lat0    = inp_lat0
      lwdown_lat0    = inp_lat0
      apressure_lat0 = inp_lat0
      tidePot_lat0   = inp_lat0
      areamask_lat0  = inp_lat0
      ustress_nlon   = inp_gNx
      ustress_nlat   = inp_gNy
      vstress_nlon   = inp_gNx
      vstress_nlat   = inp_gNy
      hflux_nlon     = inp_gNx
      hflux_nlat     = inp_gNy
      sflux_nlon     = inp_gNx
      sflux_nlat     = inp_gNy
      swflux_nlon    = inp_gNx
      swflux_nlat    = inp_gNy
      runoff_nlon    = inp_gNx
      runoff_nlat    = inp_gNy
      saltflx_nlon   = inp_gNx
      saltflx_nlat   = inp_gNy
      atemp_nlon     = inp_gNx
      atemp_nlat     = inp_gNy
      aqh_nlon       = inp_gNx
      aqh_nlat       = inp_gNy
      hs_nlon        = inp_gNx
      hs_nlat        = inp_gNy
      hl_nlon        = inp_gNx
      hl_nlat        = inp_gNy
      evap_nlon      = inp_gNx
      evap_nlat      = inp_gNy
      precip_nlon    = inp_gNx
      precip_nlat    = inp_gNy
      snowprecip_nlon= inp_gNx
      snowprecip_nlat= inp_gNy
      uwind_nlon     = inp_gNx
      uwind_nlat     = inp_gNy
      vwind_nlon     = inp_gNx
      vwind_nlat     = inp_gNy
      wspeed_nlon    = inp_gNx
      wspeed_nlat    = inp_gNy
      lwflux_nlon    = inp_gNx
      lwflux_nlat    = inp_gNy
      swdown_nlon    = inp_gNx
      swdown_nlat    = inp_gNy
      lwdown_nlon    = inp_gNx
      lwdown_nlat    = inp_gNy
      apressure_nlon = inp_gNx
      apressure_nlat = inp_gNy
      tidePot_nlon   = inp_gNx
      tidePot_nlat   = inp_gNy
      areamask_nlon  = inp_gNx
      areamask_nlat  = inp_gNy
      ustress_lon_inc   = inp_dLon
      vstress_lon_inc   = inp_dLon
      hflux_lon_inc     = inp_dLon
      sflux_lon_inc     = inp_dLon
      swflux_lon_inc    = inp_dLon
      runoff_lon_inc    = inp_dLon
      saltflx_lon_inc   = inp_dLon
      atemp_lon_inc     = inp_dLon
      aqh_lon_inc       = inp_dLon
      hs_lon_inc        = inp_dLon
      hl_lon_inc        = inp_dLon
      evap_lon_inc      = inp_dLon
      precip_lon_inc    = inp_dLon
      snowprecip_lon_inc= inp_dLon
      uwind_lon_inc     = inp_dLon
      vwind_lon_inc     = inp_dLon
      wspeed_lon_inc    = inp_dLon
      lwflux_lon_inc    = inp_dLon
      swdown_lon_inc    = inp_dLon
      lwdown_lon_inc    = inp_dLon
      apressure_lon_inc = inp_dLon
      tidePot_lon_inc   = inp_dLon
      areamask_lon_inc  = inp_dLon

      climsst_lon0    = inp_lon0
      climsss_lon0    = inp_lon0
      climustr_lon0   = inp_lon0
      climvstr_lon0   = inp_lon0
      climsst_lat0    = inp_lat0
      climsss_lat0    = inp_lat0
      climustr_lat0   = inp_lat0
      climvstr_lat0   = inp_lat0
      climsst_nlon    = inp_gNx
      climsst_nlat    = inp_gNy
      climsss_nlon    = inp_gNx
      climsss_nlat    = inp_gNy
      climustr_nlon   = inp_gNx
      climustr_nlat   = inp_gNy
      climvstr_nlon   = inp_gNx
      climvstr_nlat   = inp_gNy
      climsst_lon_inc = inp_dLon
      climsss_lon_inc = inp_dLon
      climustr_lon_inc= inp_dLon
      climvstr_lon_inc= inp_dLon

      DO j=1,MAX_LAT_INC
        ustress_lat_inc(j)   = inp_dLat(j)
        vstress_lat_inc(j)   = inp_dLat(j)
        hflux_lat_inc(j)     = inp_dLat(j)
        sflux_lat_inc(j)     = inp_dLat(j)
        swflux_lat_inc(j)    = inp_dLat(j)
        runoff_lat_inc(j)    = inp_dLat(j)
        saltflx_lat_inc(j)   = inp_dLat(j)
        atemp_lat_inc(j)     = inp_dLat(j)
        aqh_lat_inc(j)       = inp_dLat(j)
        hs_lat_inc(j)        = inp_dLat(j)
        hl_lat_inc(j)        = inp_dLat(j)
        evap_lat_inc(j)      = inp_dLat(j)
        precip_lat_inc(j)    = inp_dLat(j)
        snowprecip_lat_inc(j)= inp_dLat(j)
        uwind_lat_inc(j)     = inp_dLat(j)
        vwind_lat_inc(j)     = inp_dLat(j)
        wspeed_lat_inc(j)    = inp_dLat(j)
        lwflux_lat_inc(j)    = inp_dLat(j)
        swdown_lat_inc(j)    = inp_dLat(j)
        lwdown_lat_inc(j)    = inp_dLat(j)
        apressure_lat_inc(j) = inp_dLat(j)
        tidePot_lat_inc(j)   = inp_dLat(j)
        areamask_lat_inc(j)  = inp_dLat(j)
        climsst_lat_inc(j)   = inp_dLat(j)
        climsss_lat_inc(j)   = inp_dLat(j)
        climustr_lat_inc(j)  = inp_dLat(j)
        climvstr_lat_inc(j)  = inp_dLat(j)
      ENDDO

      ustress_interpMethod   = 12
      vstress_interpMethod   = 22
      hflux_interpMethod     =  1
      sflux_interpMethod     =  1
      swflux_interpMethod    =  1
      runoff_interpMethod    =  1
      saltflx_interpMethod   =  1
      atemp_interpMethod     =  1
      aqh_interpMethod       =  1
      hs_interpMethod        =  1
      hl_interpMethod        =  1
      evap_interpMethod      =  1
      precip_interpMethod    =  1
      snowprecip_interpMethod=  1
      uwind_interpMethod     = 12
      vwind_interpMethod     = 22
      wspeed_interpMethod    =  1
      lwflux_interpMethod    =  1
      swdown_interpMethod    =  1
      lwdown_interpMethod    =  1
      apressure_interpMethod =  1
      tidePot_interpMethod   =  1
      areamask_interpMethod  =  1
      climsst_interpMethod   =  2
      climsss_interpMethod   =  2
      climustr_interpMethod  = 12
      climvstr_interpMethod  = 22

      exf_output_interp = .FALSE.
#endif /* USE_EXF_INTERPOLATION */

C--   Next, read pkg/exf parameter file.
      WRITE(msgBuf,'(A)') 'EXF_READPARMS: opening data.exf'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )

      CALL OPEN_COPY_DATA_FILE(
     I                          'data.exf', 'EXF_READPARMS',
     O                          iUnit,
     I                          myThid )

      WRITE(msgBuf,'(A)')
     &     'EXF_READPARMS: reading EXF_NML_01'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      READ(  iUnit, nml = EXF_NML_01 )
C-    Set default fldRepeatCycle to repeatPeriod
      hfluxRepCycle      = repeatPeriod
      atempRepCycle      = repeatPeriod
      aqhRepCycle        = repeatPeriod
      hs_RepCycle        = repeatPeriod
      hl_RepCycle        = repeatPeriod
      evapRepCycle       = repeatPeriod
      precipRepCycle     = repeatPeriod
      snowprecipRepCycle = repeatPeriod
      sfluxRepCycle      = repeatPeriod
      runoffRepCycle     = repeatPeriod
      saltflxRepCycle    = repeatPeriod
      ustressRepCycle    = repeatPeriod
      vstressRepCycle    = repeatPeriod
      uwindRepCycle      = repeatPeriod
      vwindRepCycle      = repeatPeriod
      wspeedRepCycle     = repeatPeriod
      swfluxRepCycle     = repeatPeriod
      lwfluxRepCycle     = repeatPeriod
      swdownRepCycle     = repeatPeriod
      lwdownRepCycle     = repeatPeriod
      apressureRepCycle  = repeatPeriod
      tidePotRepCycle    = repeatPeriod
      areamaskRepCycle   = repeatPeriod
      climsstRepCycle    = repeatPeriod
      climsssRepCycle    = repeatPeriod
      climustrRepCycle   = repeatPeriod
      climvstrRepCycle   = repeatPeriod
C-
      obcsNrepCycle      = repeatPeriod
      obcsSrepCycle      = repeatPeriod
      obcsErepCycle      = repeatPeriod
      obcsWrepCycle      = repeatPeriod
      siobNrepCycle      = UNSET_RL
      siobSrepCycle      = UNSET_RL
      siobErepCycle      = UNSET_RL
      siobWrepCycle      = UNSET_RL

      WRITE(msgBuf,'(A)')
     &     'EXF_READPARMS: reading EXF_NML_02'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      READ(  iUnit, nml = EXF_NML_02 )
      WRITE(msgBuf,'(A)')
     &     'EXF_READPARMS: reading EXF_NML_03'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      READ(  iUnit, nml = EXF_NML_03 )
#ifdef USE_EXF_INTERPOLATION
      WRITE(msgBuf,'(A)')
     &     'EXF_READPARMS: reading EXF_NML_04'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      READ(  iUnit, nml = EXF_NML_04 )
#endif /* USE_EXF_INTERPOLATION */

#ifdef ALLOW_OBCS
      IF ( useOBCS ) THEN
       WRITE(msgBuf,'(A)')
     &      'EXF_READPARMS: reading EXF_NML_OBCS'
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                     SQUEEZE_RIGHT, myThid )
       READ(  iUnit, nml = EXF_NML_OBCS )
      ENDIF
       IF(siobNstartdate1.EQ.UNSET_I ) siobNstartdate1=obcsNstartdate1
       IF(siobNstartdate2.EQ.UNSET_I ) siobNstartdate2=obcsNstartdate2
       IF(siobNperiod    .EQ.UNSET_RL) siobNperiod    =obcsNperiod
       IF(siobNrepCycle  .EQ.UNSET_RL) siobNrepCycle  =obcsNrepCycle
       IF(siobSstartdate1.EQ.UNSET_I ) siobSstartdate1=obcsSstartdate1
       IF(siobSstartdate2.EQ.UNSET_I ) siobSstartdate2=obcsSstartdate2
       IF(siobSperiod    .EQ.UNSET_RL) siobSperiod    =obcsSperiod
       IF(siobSrepCycle  .EQ.UNSET_RL) siobSrepCycle  =obcsSrepCycle
       IF(siobEstartdate1.EQ.UNSET_I ) siobEstartdate1=obcsEstartdate1
       IF(siobEstartdate2.EQ.UNSET_I ) siobEstartdate2=obcsEstartdate2
       IF(siobEperiod    .EQ.UNSET_RL) siobEperiod    =obcsEperiod
       IF(siobErepCycle  .EQ.UNSET_RL) siobErepCycle  =obcsErepCycle
       IF(siobWstartdate1.EQ.UNSET_I ) siobWstartdate1=obcsWstartdate1
       IF(siobWstartdate2.EQ.UNSET_I ) siobWstartdate2=obcsWstartdate2
       IF(siobWperiod    .EQ.UNSET_RL) siobWperiod    =obcsWperiod
       IF(siobWrepCycle  .EQ.UNSET_RL) siobWrepCycle  =obcsWrepCycle

       IF(exf_iprec_obcs .EQ. UNSET_I) exf_iprec_obcs =exf_iprec
#endif /* ALLOW_OBCS */

      WRITE(msgBuf,'(A)')
     &     'EXF_READPARMS: finished reading data.exf'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )

#ifdef SINGLE_DISK_IO
      CLOSE(iUnit)
#else
      CLOSE(iUnit,STATUS='DELETE')
#endif /* SINGLE_DISK_IO */

C--   Retired parameters
      IF ( exf_yftype.NE.'RL' ) THEN
       STOP 'S/R EXF_READPARAMS: value of exf_yftype not allowed'
      ENDIF

C--   Derive other parameters:
      IF ( exf_verbose ) exf_debugLev = MAX( exf_debugLev, debLevD )
      IF ( .NOT.(useThSIce.OR.useSEAICE) ) diags_opOceWeighted=.FALSE.
      hq = ht
      stressIsOnCgrid = readStressOnCgrid
#if ( defined (ALLOW_BULKFORMULAE) )
      IF ( useAtmWind ) stressIsOnCgrid = .FALSE.
#endif
#ifdef USE_EXF_INTERPOLATION
      IF ( (ustress_interpMethod.GE.1 .AND. ustressfile.NE.' ') .OR.
     &     (vstress_interpMethod.GE.1 .AND. vstressfile.NE.' ') )
     &   stressIsOnCgrid = .FALSE.
#endif /* USE_EXF_INTERPOLATION */

      useExfZenAlbedo = select_ZenAlbedo.GE.1
     &            .AND. select_ZenAlbedo.LE.3

C--   Overwrite tauThetaClimRelax but stop if already set.
C- Note: need this, even if EXF option ALLOW_CLIMSST_RELAXATION is undef;
C        this prevents to apply relaxation towards potentially wrong SST since,
C        with EXF, we skip the update of loaded SST in EXTERNAL_FIELDS_LOAD.
C- Note2: let s see whether we can put this back under ifdef
C        ALLOW_CLIMSST_RELAXATION, but always call EXTERNAL_FIELDS_LOAD.
C        If ALLOW_CLIMSST_RELAXATION is undef, clim.relaxation could still
C        be done outside of exf.
#ifdef ALLOW_CLIMSST_RELAXATION
      IF ( tauThetaClimRelax.NE.0. _d 0 ) THEN
        WRITE(msgBuf,'(2A)') 'EXF_READPARMS: ',
     &   'with EXF, cannot use "tauThetaClimRelax" in "data"'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(2A)') 'since SST relax. is handled by EXF',
     &   ' (data.exf, "climsstTauRelax")'
        CALL PRINT_ERROR( msgBuf, myThid )
        STOP 'ABNORMAL END: S/R EXF_READPARMS'
      ENDIF
      tauThetaClimRelax = climsstTauRelax
#endif

#ifdef ALLOW_CLIMSSS_RELAXATION
C--   Overwrite tauSaltClimRelax but stop if already set.
      IF ( tauSaltClimRelax.NE.0. _d 0 ) THEN
        WRITE(msgBuf,'(2A)') 'EXF_READPARMS: ',
     &   'with EXF, cannot use "tauSaltClimRelax" in "data"'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(2A)') 'since SSS relax. is handled by EXF',
     &   ' (data.exf, "climsssTauRelax")'
        CALL PRINT_ERROR( msgBuf, myThid )
        STOP 'ABNORMAL END: S/R EXF_READPARMS'
      ENDIF
      tauSaltClimRelax = climsssTauRelax
#endif

C     Complete the start date specifications for the forcing
C     fields to get a complete calendar date array.
C     => moved to EXF_INIT_FIXED

      _END_MASTER( myThid )
      _BARRIER

      RETURN
      END

#include "OPENAD_OPTIONS.h"

      subroutine template()
C     !FUNCTIONS
      use OAD_tape
      use OAD_rev
      use OAD_cp


! original arguments get inserted before version
!         ! and declared here together with all local variables
!         ! generated by xaifBooster

!use mode_variables

!$TEMPLATE_PRAGMA_DECLARATIONS
      type(modeType) :: our_orig_mode

      integer iaddr
      external iaddr

!LOCAL VARIABLES:
      CHARACTER*(2) adpref
      CHARACTER*(80) fname
      INTEGER il
      INTEGER myNr
      LOGICAL useCurrentDir
      Real*8  active_var_p(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      INTEGER  ILNBLNK
      EXTERNAL ILNBLNK

#ifdef ALLOW_OPENAD_ACTIVE_READ_XYZ

      myNr = Nr
      useCurrentDir = .FALSE.

      if (our_rev_mode%plain) then
         our_orig_mode = our_rev_mode
! original function
         active_var_p = active_var%v
! set up for plain execution
         our_rev_mode%arg_store=.FALSE.
         our_rev_mode%arg_restore=.FALSE.
         our_rev_mode%plain=.TRUE.
         our_rev_mode%tape=.FALSE.
         our_rev_mode%adjoint=.FALSE.
         call ACTIVE_READ_3D_RL(
     &        active_var_file, active_var_p, doglobalread,
     &        useCurrentDir, lAdInit, iRec, myNr,
     &        FORWARD_SIMULATION, myOptimIter, myThid )
! reset the mode
         our_rev_mode=our_orig_mode
! copy back
         active_var%v = active_var_p
      end if

      if (our_rev_mode%tape) then
! taping
         our_orig_mode=our_rev_mode
         our_rev_mode%arg_store=.FALSE.
         our_rev_mode%arg_restore=.FALSE.
         our_rev_mode%plain=.TRUE.
         our_rev_mode%tape=.FALSE.
         our_rev_mode%adjoint=.FALSE.
         if (oad_st_sz.lt.oad_st_ptr) call oad_st_grow()
         oad_st(oad_st_ptr) = active_var_file 
         oad_st_ptr = oad_st_ptr+1 
         if (oad_it_sz.lt.oad_it_ptr) call oad_it_grow()
         oad_it(oad_it_ptr) = iRec
         oad_it_ptr = oad_it_ptr+1 
         call ACTIVE_READ_3D_RL(
     &        active_var_file, active_var, doglobalread,
     &        useCurrentDir, lAdInit, iRec, myNr,
     &        FORWARD_SIMULATION, myOptimIter, myThid )
         our_rev_mode=our_orig_mode
      end if

      if (our_rev_mode%adjoint) then
! adjoint
         oad_st_ptr = oad_st_ptr-1
         active_var_file = oad_st(oad_st_ptr) 
         oad_it_ptr = oad_it_ptr-1
         iRec = oad_it(oad_it_ptr) 
         adpref = 'ad'
         il   = ILNBLNK( active_var_file )
         WRITE(fname(1:80),'(A)') ' '
         WRITE(fname(1:2+il),'(2A)') adpref, active_var_file(1:il)
!         WRITE(fname(1:2+il),'(2A)') adpref, active_var_file
         active_var_p = active_var%d
! set up for plain execution
         our_orig_mode=our_rev_mode
         our_rev_mode%arg_store=.FALSE.
         our_rev_mode%arg_restore=.FALSE.
         our_rev_mode%plain=.TRUE.
         our_rev_mode%tape=.FALSE.
         our_rev_mode%adjoint=.FALSE.
         call ACTIVE_READ_3D_RL(
     &        fname, active_var_p, doglobalread,
     &        useCurrentDir, lAdInit, iRec, myNr,
     &        REVERSE_SIMULATION, myOptimIter, myThid )
! reset the mode
         our_rev_mode=our_orig_mode
! copy back
         active_var%d = active_var_p
      end if

#endif /* ALLOW_OPENAD_ACTIVE_READ_XYZ */

      end

#include "AIM_OPTIONS.h"

CStartOfInterface
      SUBROUTINE AIM_FIELDS_LOAD(
     I                            myTime, myIter, myThid )
C     *==========================================================*
C     | SUBROUTINE AIM_FIELDS_LOAD
C     | o Control reading of AIM fields from external source.
C     *==========================================================*
C     | Loads surface boundary condition datasets for AIM.
C     | The routine is called every timetep and periodically
C     | loads a set of external fields.
C     | Monthly climatology files are read either for
C     | a) a direct use (useMMsurfFc):
C     |   Albedo, Soil moisture, Surface Temperature
C     | b) time interpolation (useFMsurfBC):
C     |   Sea & Land surf. Temp, snow, sea-ice, soil-water (2-lev)
C     | + (1rst.iter) ground albedo, vegetation, land-sea fraction
C     | Most of the work is done by the master thread while
C     | the other threads spin (but all inside MDSIO S/R).
C     *==========================================================*
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "AIM_PARAMS.h"
c #include "AIM_GRID.h"
#include "AIM_FFIELDS.h"

C     === Routine arguments ===
C     myTime :: Simulation time
C     myIter :: Simulation timestep number
C     myThid :: Thread no. that called this routine.
      _RL     myTime
      INTEGER myIter
      INTEGER myThid
CEndOfInterface

C     === Functions ===

#ifdef ALLOW_AIM
C     === Local variables ===
C     bi,bj, i,j  :: Loop counters
C     tYear       :: Fraction within year of myTime
C     mnthIndex   :: Current time in whole months
C     prevMnthIndex
C     fNam        :: Strings used in constructing file names
C     mnthNam
C     pfact       :: used to convert Pot.Temp. to in-situ Temp.
C     loadNewData :: true when need to load new data from file
      INTEGER bi,bj, i, j
      INTEGER mnthIndex
      INTEGER prevMnthIndex
      COMMON / LOCAL_AIM_FIELDS_LOAD / prevMnthIndex
c     _RL pfact
      LOGICAL loadNewData
C--   for use with useMMsurfFc:
      CHARACTER*(MAX_LEN_FNAM) fNam
      CHARACTER*3 mnthNam(12)
      DATA mnthNam /
     & 'jan', 'feb', 'mar', 'apr', 'may', 'jun',
     & 'jul', 'aug', 'sep', 'oct', 'nov', 'dec' /
      SAVE mnthNam
C--   for use with useFMsurfBC:
      INTEGER nm0, nm1, nm2, nm3
      _RL t0prd, tNcyc, tmprd

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C--   find which month to use for surface BC
C     aim_surfForc_TimePeriod :: Length of forcing time period (e.g. 1 month)
C     aim_surfForc_NppCycle   :: Number of time period per Cycle (e.g. 12)
      t0prd = myTime / aim_surfForc_TimePeriod
      tNcyc = aim_surfForc_NppCycle

      IF (aim_useMMsurfFc) THEN
C-     select the current month :
        tmprd = MOD(t0prd,tNcyc)
        mnthIndex = 1 + INT(tmprd)
      ELSEIF (aim_useFMsurfBC) THEN
        tmprd = t0prd - 0.5 _d 0 + tNcyc
        tmprd = MOD(tmprd,tNcyc)
C-     select indices of previous month (nm0) and next month (nm1):
        nm0 = 1 + INT(tmprd)
        nm1 = 1 + MOD(nm0,aim_surfForc_NppCycle)
        mnthIndex = nm0
      ELSE
        RETURN
      ENDIF

C--   decide if it is time to load new data
      IF ( myIter.EQ.nIter0 ) THEN
        loadNewData = .TRUE.
      ELSE
        IF ( mnthIndex .NE. prevMnthIndex ) THEN
C-      switch to a new time record
          loadNewData = .TRUE.
        ELSE
          loadNewData = .FALSE.
        ENDIF
      ENDIF

C  note: reading/writing 2-D/3-D field with MDS-IO S/R is thread safe;
C        => no need for BARRIER call before/after loading fileds

      IF (aim_useMMsurfFc) THEN
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C-- Use Monthly Mean surface forcing fields:

       IF ( loadNewData ) THEN
C-    New month so load in data

C-    Only one thread updates parameter in common block
C-    Wait for everyone to set loadNewData before Master updates prevMnthIndex
         _BARRIER
         _BEGIN_MASTER( myThid )
         prevMnthIndex = mnthIndex
         _END_MASTER( myThid   )

C        o Albedo ( convert % to fraction )
         WRITE(fNam,'(A,A,A)' ) 'salb.',
     &         mnthNam(mnthIndex), aim_MMsufx(1:aim_MMsufxLength)
         CALL READ_REC_XY_RS( fNam, aim_albedo, 1, myIter, myThid )

C        o Surface temperature ( in kelvin )
         IF (aim_surfPotTemp) THEN
          WRITE(fNam,'(A,A,A)' )'stheta.',
     &         mnthNam(mnthIndex), aim_MMsufx(1:aim_MMsufxLength)
         ELSE
          WRITE(fNam,'(A,A,A)' )'sTemp.',
     &         mnthNam(mnthIndex), aim_MMsufx(1:aim_MMsufxLength)
         ENDIF
         CALL READ_REC_XY_RS( fNam, aim_sst0, 1, myIter, myThid )

C        o Soil moisture
         WRITE(fNam,'(A,A,A)' ) 'smoist.',
     &         mnthNam(mnthIndex), aim_MMsufx(1:aim_MMsufxLength)
         CALL READ_REC_XY_RS( fNam, aim_sw10, 1, myIter, myThid )

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C--  Converts fields for direct use in Atmos. Physics routine.
C     better here rather than in "aim_do_atmos" since:
C     a) change together conversion factor and input file name.
C     b) conversion applied only 1 time / month ;
C     c) easy to check here (variable in common).

         DO bj = myByLo(myThid), myByHi(myThid)
          DO bi = myBxLo(myThid), myBxHi(myThid)

C-  Converts surface albedo : input data is in % 0-100
C     and Franco s package needs a fraction between 0-1
           DO j=1,sNy
            DO i=1,sNx
             aim_albedo(I,J,bi,bj) = aim_albedo(I,J,bi,bj)/100.
            ENDDO
           ENDDO

C-  Converts soil moisture (case input is in cm in bucket of depth 20cm.)
c          DO j=1,sNy
c           DO i=1,sNx
c            aim_sw10(I,J,bi,bj) = aim_sw10(I,J,bi,bj)
c    &                                   /20.
c           ENDDO
c          ENDDO

C--   Correct for truncation (because of hFacMin) of surface reference
C      pressure Ro_surf that affects Surf.Temp. :
           DO j=1,sNy
            DO i=1,sNx
c            pfact = (Ro_surf(i,j,bi,bj)/atm_Po)**atm_kappa
             aim_sst0(i,j,bi,bj) = aim_sst0(i,j,bi,bj)
     &                           * truncSurfP(i,j,bi,bj)
            ENDDO
           ENDDO

C-- end bi,bj loops
          ENDDO
         ENDDO

         IF (myIter.EQ.nIter0) THEN
          CALL WRITE_FLD_XY_RS( 'aim_Tsurf',' ', aim_sst0, 0, myThid )
         ENDIF

C-     endif New month - load in data
       ENDIF

      ELSEIF (aim_useFMsurfBC) THEN
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C-- Use Franco Molteni surface BC:
C    take part of S/R INFORC + part of S/R FORDATE (albedo)
C    of the F.Molteni SPEEDY code (ver23)

       IF ( myIter.EQ.nIter0 ) THEN
        DO bj = myByLo(myThid), myByHi(myThid)
         DO bi = myBxLo(myThid), myBxHi(myThid)
          DO j=1-Oly,sNy+Oly
           DO i=1-Olx,sNx+Olx
c           aim_landFr(i,j,bi,bj)= 0.
            aim_albedo(i,j,bi,bj)= 0.
            aim_veget(i,j,bi,bj) = 0.
            aim_sst0(i,j,bi,bj) =300.
            aim_lst0(i,j,bi,bj) =300.
            aim_oic0(i,j,bi,bj) = 0.
            aim_snw0(i,j,bi,bj) = 0.
            aim_sw10(i,j,bi,bj) = 0.
            aim_sw20(i,j,bi,bj) = 0.
            aim_qfx0(i,j,bi,bj) = 0.
            aim_sst1(i,j,bi,bj) =300.
            aim_lst1(i,j,bi,bj) =300.
            aim_oic1(i,j,bi,bj) = 0.
            aim_snw1(i,j,bi,bj) = 0.
            aim_sw11(i,j,bi,bj) = 0.
            aim_sw21(i,j,bi,bj) = 0.
            aim_qfx1(i,j,bi,bj) = 0.
           ENDDO
          ENDDO
         ENDDO
        ENDDO
       ENDIF

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

       IF ( loadNewData ) THEN
C-     Load new data:

C-    Only one thread updates parameter in common block
C-    Wait for everyone to set loadNewData before Master updates prevMnthIndex
        _BARRIER
        _BEGIN_MASTER( myThid )
        prevMnthIndex = mnthIndex
        _END_MASTER( myThid )

        IF ( myIter.EQ.nIter0 ) THEN
C-      Load Fixed Forcing only at the 1rst iter:

c        IF ( aim_LandFile .NE. ' '  ) THEN
c         CALL READ_REC_XY_RS(aim_LandFile,aim_landFr,1,myIter,myThid)
c        ENDIF
         IF ( aim_albFile .NE. ' '  ) THEN
          CALL READ_REC_XY_RS(aim_albFile,aim_albedo, 1,myIter,myThid)
         ENDIF
c           alb0(i,j) = 0.01*r4inp(i,j)
         IF ( aim_vegFile .NE. ' '  ) THEN
          CALL READ_REC_XY_RS(aim_vegFile,aim_veget,1,myIter,myThid)
         ENDIF

C-      endif 1rst iter.
        ENDIF

        IF ( aim_sstFile .NE. ' '  ) THEN
          CALL READ_REC_XY_RS(aim_sstFile,aim_sst0,nm0,myIter,myThid)
          CALL READ_REC_XY_RS(aim_sstFile,aim_sst1,nm1,myIter,myThid)
        ENDIF
        IF ( aim_lstFile .NE. ' '  ) THEN
          CALL READ_REC_XY_RS(aim_lstFile,aim_lst0,nm0,myIter,myThid)
          CALL READ_REC_XY_RS(aim_lstFile,aim_lst1,nm1,myIter,myThid)
        ENDIF
        IF ( aim_oiceFile .NE. ' '  ) THEN
          CALL READ_REC_XY_RS(aim_oiceFile,aim_oic0,nm0,myIter,myThid)
          CALL READ_REC_XY_RS(aim_oiceFile,aim_oic1,nm1,myIter,myThid)
        ENDIF
        IF ( aim_snowFile .NE. ' '  ) THEN
          CALL READ_REC_XY_RS(aim_snowFile,aim_snw0,nm0,myIter,myThid)
          CALL READ_REC_XY_RS(aim_snowFile,aim_snw1,nm1,myIter,myThid)
        ENDIF
        IF ( aim_swcFile .NE. ' '  ) THEN
          CALL READ_REC_XY_RS(aim_swcFile,aim_sw10,nm0,myIter,myThid)
          CALL READ_REC_XY_RS(aim_swcFile,aim_sw11,nm1,myIter,myThid)
          nm2 = nm0 + aim_surfForc_NppCycle
          nm3 = nm1 + aim_surfForc_NppCycle
          CALL READ_REC_XY_RS(aim_swcFile,aim_sw20,nm2,myIter,myThid)
          CALL READ_REC_XY_RS(aim_swcFile,aim_sw21,nm3,myIter,myThid)
        ENDIF
        IF ( aim_qfxFile .NE. ' '  ) THEN
          CALL READ_REC_XY_RS(aim_qfxFile,aim_qfx0,nm0,myIter,myThid)
          CALL READ_REC_XY_RS(aim_qfxFile,aim_qfx1,nm1,myIter,myThid)
        ENDIF

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

        DO bj = myByLo(myThid), myByHi(myThid)
         DO bi = myBxLo(myThid), myBxHi(myThid)

          IF ( myIter.EQ.nIter0 ) THEN
C-  Converts surface albedo : from % (input data) to a fraction [0-1}
c          alb0(i,j) = 0.01*r4inp(i,j)
           DO j=1,sNy
            DO i=1,sNx
             aim_albedo(i,j,bi,bj) = aim_albedo(I,J,bi,bj)/100. _d 0
            ENDDO
           ENDDO

C-  Converts vegetation fraction: from % (input data) to a fraction [0-1]
c          veg(i,j)=max(0.,0.01*veg(i,j))
           DO j=1,sNy
            DO i=1,sNx
             aim_veget(i,j,bi,bj) =
     &                 MAX(0. _d 0, aim_veget(i,j,bi,bj)/100. _d 0)
            ENDDO
           ENDDO
C-      endif 1rst iter.
          ENDIF

C--   Correct for truncation (because of hFacMin) of surface reference
C      pressure Ro_surf that affects Surf.Temp. :
          DO j=1,sNy
           DO i=1,sNx
c            pfact = (Ro_surf(i,j,bi,bj)/atm_Po)**atm_kappa
             aim_lst0(i,j,bi,bj) = aim_lst0(i,j,bi,bj)
     &                           * truncSurfP(i,j,bi,bj)
             aim_lst1(i,j,bi,bj) = aim_lst1(i,j,bi,bj)
     &                           * truncSurfP(i,j,bi,bj)
           ENDDO
          ENDDO

C-     end bi,bj loops
         ENDDO
        ENDDO

C--    endif load new data.
       ENDIF

      ENDIF

#endif /* ALLOW_AIM */

      RETURN
      END

#include "MOM_COMMON_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: MOM_UV_SMAG_3D

C     !INTERFACE:
      SUBROUTINE MOM_UV_SMAG_3D(
     I        str11, str22, str12, str13, str23,
     I        viscAh3d_00, viscAh3d_12,
     I        viscAh3d_13, viscAh3d_23,
c    I        hFacZ,
     O        uDissip, vDissip,
     I        iMin,iMax,jMin,jMax, k, bi, bj, myThid )

C     !DESCRIPTION:

C     !USES:
      IMPLICIT NONE

C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "GRID.h"
#include "PARAMS.h"

C     !INPUT PARAMETERS:
C     iMin,iMax     :: 1rst index loop ranges
C     jMin,jMax     :: 2nd  index loop ranges
      _RL str11(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL str22(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL str12(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL str13(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr+1)
      _RL str23(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr+1)
c     _RS hFacZ(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL viscAh3d_00(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL viscAh3d_12(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL viscAh3d_13(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr+1)
      _RL viscAh3d_23(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr+1)
      INTEGER iMin,iMax, jMin,jMax
      INTEGER k, bi, bj
      INTEGER myThid

C     !OUTPUT PARAMETERS:
      _RL uDissip(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL vDissip(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
CEOP

#ifdef ALLOW_SMAG_3D
C     !LOCAL VARIABLES:
      INTEGER i,j
      INTEGER km1, kp1
      _RL maskM1, maskP1

      km1 = MAX( 1,k-1)
      kp1 = MIN(Nr,k+1)
      maskM1 = 1.
      maskP1 = 1.
      IF ( k.LE.1 )  maskM1 = 0.
      IF ( k.GE.Nr ) maskP1 = 0.

C     - Laplacian and bi-harmonic terms
c     IF (harmonic) THEN

C- note: free-slip @ bottom is commented out

C-    use simple (momentum conserving) scaling
C      (but not conserving angular momentum)

       DO j= jMin,jMax
        DO i= iMin,iMax
         uDissip(i,j) = recip_rAw(i,j,bi,bj)*(
     &     ( viscAh3d_00( i , j , k )*str11( i , j , k )
     &         *dyF( i , j ,bi,bj)
     &      -viscAh3d_00(i-1, j , k )*str11(i-1, j , k )
     &         *dyF(i-1, j ,bi,bj)
     &     )
     &    +( viscAh3d_12( i ,j+1, k )*str12( i ,j+1, k )
     &         *dxV( i ,j+1,bi,bj)
     &      -viscAh3d_12( i , j , k )*str12( i , j , k )
     &         *dxV( i , j ,bi,bj)
     &     )                                 )
     &                + recip_drF( k )
     &    *( viscAh3d_13( i , j ,k+1)*str13( i , j ,k+1)
c    &         *maskW(i,j,kp1,bi,bj)*maskP1
     &      -viscAh3d_13( i , j , k )*str13( i , j , k )
c    &         *maskW(i,j,km1,bi,bj)*maskM1
     &     )*rkSign*recip_hFacW(i,j,k,bi,bj)
        ENDDO
       ENDDO

       DO j= jMin,jMax
        DO i= iMin,iMax
         vDissip(i,j) = recip_rAs(i,j,bi,bj)*(
     &     ( viscAh3d_12(i+1, j , k )*str12(i+1, j ,k)
     &         *dyU(i+1, j ,bi,bj)
     &      -viscAh3d_12( i , j , k )*str12( i , j ,k)
     &         *dyU( i , j ,bi,bj)
     &     )
     &    +( viscAh3d_00( i , j , k )*str22( i , j ,k)
     &         *dxF( i , j ,bi,bj)
     &      -viscAh3d_00( i ,j-1, k )*str22( i ,j-1,k)
     &         *dxF( i ,j-1,bi,bj)
     &     )                                )
     &                + recip_drF( k )
     &    *( viscAh3d_23( i , j ,k+1)*str23( i , j ,k+1)
c    &         *maskS(i,j,kp1,bi,bj)*maskP1
     &      -viscAh3d_23( i , j , k )*str23( i , j , k )
c    &         *maskS(i,j,km1,bi,bj)*maskM1
     &     )*rkSign*recip_hFacS(i,j,k,bi,bj)

        ENDDO
       ENDDO

c     ENDIF

c     IF (biharmonic) THEN
c      STOP 'MOM_UV_SMAG_3D: BIHARMONIC NOT ALLOWED WITH SMAG_3D'
c     ENDIF

#endif /* ALLOW_SMAG_3D */
      RETURN
      END

#include "SHAP_FILT_OPTIONS.h"
#undef CALC_CS_CORNER_EXTENDED

      SUBROUTINE SHAP_FILT_RELVORT3(
     I        bi,bj,k,
     I        uFld, vFld, hFacZ,
     O        vort3,
     I        myThid)
      IMPLICIT NONE
C     *==========================================================*
C     | S/R SHAP_FILT_RELVORT3
C     *==========================================================*
C     | copied from S/R MOM_CALC_RELVORT3, except:
C     |  a) do not apply any masking
C     |  b) use more uniform rAz at CS-grid corners
C     *==========================================================*

C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#ifdef ALLOW_EXCH2
#include "W2_EXCH2_SIZE.h"
#include "W2_EXCH2_TOPOLOGY.h"
#endif /* ALLOW_EXCH2 */
C     == Routine arguments ==
C     myThid - Instance number for this innvocation of CALC_MOM_RHS
      INTEGER bi,bj,k
      _RL uFld(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL vFld(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RS hFacZ(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL vort3(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER myThid

C     == Local variables ==
      INTEGER i,j
      LOGICAL northWestCorner, northEastCorner,
     &        southWestCorner, southEastCorner
      INTEGER myFace
#ifdef ALLOW_EXCH2
      INTEGER myTile
#endif /* ALLOW_EXCH2 */
      _RL AZcorner

#ifdef ALLOW_AUTODIFF
      DO J=1-OLy,sNy+OLy
       DO I=1-OLx,sNx+OLx
        vort3(I,J) = 0. _d 0
       ENDDO
      ENDDO
#endif

      DO J=2-OLy,sNy+OLy
       DO I=2-OLx,sNx+OLx

C       Horizontal curl of flow field - ignoring lopping factors
        vort3(I,J)=
     &      recip_rAz(I,J,bi,bj)*(
     &      ( vFld(I,J)*dyC(I,J,bi,bj)
     &       -vFld(I-1,J)*dyC(I-1,J,bi,bj) )
     &     -( uFld(I,J)*dxC(I,J,bi,bj)
     &       -uFld(I,J-1)*dxC(I,J-1,bi,bj) )
     &                           )

C       Horizontal curl of flow field - including lopping factors
c       IF (hFacZ(i,j).NE.0.) THEN
c        vort3(I,J)=
c    &      recip_rAz(I,J,bi,bj)*(
c    &      vFld(I,J)*dyc(I,J,bi,bj)*_hFacW(i,j,k,bi,bj)
c    &     -vFld(I-1,J)*dyc(I-1,J,bi,bj)*_hFacW(i-1,j,k,bi,bj)
c    &     -uFld(I,J)*dxc(I,J,bi,bj)*_hFacS(i,j,k,bi,bj)
c    &     +uFld(I,J-1)*dxc(I,J-1,bi,bj)*_hFacS(i,j-1,k,bi,bj)
c    &                           )
c    &                            /hFacZ(i,j)
c       ELSE
c        vort3(I,J)=0.
c       ENDIF

       ENDDO
      ENDDO

C     RETURN

C     Special stuff for Cubed Sphere
      IF (useCubedSphereExchange) THEN
       AZcorner = 0.75 _d 0
#ifdef ALLOW_EXCH2
       myTile = W2_myTileList(bi,bj)
       myFace = exch2_myFace(myTile)
         southWestCorner = exch2_isWedge(myTile).EQ.1
     &               .AND. exch2_isSedge(myTile).EQ.1
         southEastCorner = exch2_isEedge(myTile).EQ.1
     &               .AND. exch2_isSedge(myTile).EQ.1
         northEastCorner = exch2_isEedge(myTile).EQ.1
     &               .AND. exch2_isNedge(myTile).EQ.1
         northWestCorner = exch2_isWedge(myTile).EQ.1
     &               .AND. exch2_isNedge(myTile).EQ.1
#else
       myFace = bi
       southWestCorner = .TRUE.
       southEastCorner = .TRUE.
       northWestCorner = .TRUE.
       northEastCorner = .TRUE.
#endif /* ALLOW_EXCH2 */

       IF ( southWestCorner ) THEN
C               U(0,1)     D(0,1)      U(1,1)     TILE
C                |                      |
C   V(-1,1) --- Z(0,1) --- V(0,1) ---  Z(1,1) --- V(1,1) ---
C                |                      |
C               U(0,0)     D(0,0)      U(1,0)     D(1,0)
C                |                      |
C                      --- V(0,0) ---  Z(1,0) --- V(1,0) ---
C                                       |
C                                      U(1,-1)
         I=1
         J=1
C-    to get the same truncation, independent from the face Nb,
C     do (1+2)+3, and always in the same order (exch3 convention order):
         vort3(I,J)=
     &     +recip_rA(I,J,bi,bj)/AZcorner*(
     &      ( vFld(I,J)*dyC(I,J,bi,bj)
     &       -uFld(I,J)*dxC(I,J,bi,bj) )
     &      + uFld(I,J-1)*dxC(I,J-1,bi,bj)
     &     )
C-    the quick way, but do not get the same truncation on the 3 faces:
c        vort3(I,J)=
c    &     +recip_rA(I,J,bi,bj)/AZcorner*(
c    &      vFld(I,J)*dyC(I,J,bi,bj)
c    &     -uFld(I,J)*dxC(I,J,bi,bj)
c    &     +uFld(I,J-1)*dxC(I,J-1,bi,bj)
c    &     )
c        IF (hFacZ(i,j).EQ.0. _d 0) vort3(i,j) = 0. _d 0
#ifdef CALC_CS_CORNER_EXTENDED
         vort3(I-1,J)=
     &      recip_rAz(I-1,J,bi,bj)*(
     &      vFld(I-1,J)*dyC(I-1,J,bi,bj)
     &     -vFld(I-2,J)*dyC(I-2,J,bi,bj)
     &     -uFld(I-1,J)*dxC(I-1,J,bi,bj)
     &     +vFld(I+0,J-1)*dyC(I+0,J-1,bi,bj)
     &                             )
c    &     *maskS(i-1,j,k,bi,bj)*maskS(i-2,j,k,bi,bj)
c    &     *maskW(i-1,j,k,bi,bj)*maskS(i,j-1,k,bi,bj)
         vort3(I,J-1)=vort3(I-1,J)
#endif
       ENDIF

       IF ( southEastCorner ) THEN
C   TILE       U(N+1,1)     D(N+1,1)      U(N+2,1)
C               |                          |
C   V(N,1) --- Z(N+1,1) --- V(N+1,1) ---  Z(N+2,1) --- V(N+3,1) ---
C               |                          |
C   D(N,0)     U(N+1,0)     D(N+1,0)      U(N+2,0)
C               |                          |
C   V(N,0) --- Z(N+1,0) --- V(N+1,0) ---
C               |                          |
C              U(N+1,-1)
         I=sNx+1
         J=1
C-    to get the same truncation, independent from the face Nb,
C      (exch3 convention order):
         IF ( myFace.EQ.2 ) THEN
          vort3(I,J)=
     &     +recip_rA(I-1,J,bi,bj)/AZcorner*(
     &      (-uFld(I,J)*dxC(I,J,bi,bj)
     &       -vFld(I-1,J)*dyC(I-1,J,bi,bj) )
     &      + uFld(I,J-1)*dxC(I,J-1,bi,bj)
     &     )
         ELSEIF ( myFace.EQ.4 ) THEN
          vort3(I,J)=
     &     +recip_rA(I-1,J,bi,bj)/AZcorner*(
     &      (-vFld(I-1,J)*dyC(I-1,J,bi,bj)
     &       +uFld(I,J-1)*dxC(I,J-1,bi,bj) )
     &      - uFld(I,J)*dxC(I,J,bi,bj)
     &     )
         ELSE
          vort3(I,J)=
     &     +recip_rA(I-1,J,bi,bj)/AZcorner*(
     &      (+uFld(I,J-1)*dxC(I,J-1,bi,bj)
     &       -uFld(I,J)*dxC(I,J,bi,bj)     )
     &      - vFld(I-1,J)*dyC(I-1,J,bi,bj)
     &     )
         ENDIF
C-    the quick way, but do not get the same truncation on the 3 faces:
c        vort3(I,J)=
c    &     +recip_rA(I-1,J,bi,bj)/AZcorner*(
c    &     -vFld(I-1,J)*dyC(I-1,J,bi,bj)
c    &     -uFld(I,J)*dxC(I,J,bi,bj)
c    &     +uFld(I,J-1)*dxC(I,J-1,bi,bj)
c    &     )
c        IF (hFacZ(i,j).EQ.0. _d 0) vort3(i,j) = 0. _d 0
#ifdef CALC_CS_CORNER_EXTENDED
         vort3(I+1,J)=
     &      recip_rAz(I+1,J,bi,bj)*(
     &      vFld(I+1,J)*dyC(I+1,J,bi,bj)
     &     -vFld(I-0,J)*dyC(I-0,J,bi,bj)
     &     -uFld(I+1,J)*dxC(I+1,J,bi,bj)
     &     -vFld(I-1,J-1)*dyC(I-1,J-1,bi,bj)
     &                           )
c    &     *maskS(i+1,j,k,bi,bj)*maskS(i-0,j,k,bi,bj)
c    &     *maskW(i+1,j,k,bi,bj)*maskS(i-1,j-1,k,bi,bj)
         vort3(I,J-1)=vort3(I+1,J)
#endif
       ENDIF

       IF ( northWestCorner ) THEN
C                                            U(1,N+2)
C                                             |
C                          --- V(0,N+1) ---  Z(1,N+2) --- V(1,N+2) ---
C                  |                          |
C                 U(0,N+1)     D(0,N+1)      U(1,N+1)     D(1,N+1)
C                  |                          |
C   V(-1,N+1) --- Z(0,N+1) --- V(0,N+1) ---  Z(1,N+1) --- V(1,N+1) ---
C                  |                          |
C                 U(0,N)       D(0,N)        U(1,N)       TILE
         I=1
         J=sNy+1
C-    to get the same truncation, independent from the face Nb,
C      (exch3 convention order):
         IF ( myFace.EQ.1 ) THEN
          vort3(I,J)=
     &     +recip_rA(I,J-1,bi,bj)/AZcorner*(
     &      (+uFld(I,J-1)*dxC(I,J-1,bi,bj)
     &       +vFld(I,J)*dyC(I,J,bi,bj)     )
     &       -uFld(I,J)*dxC(I,J,bi,bj)
     &     )
         ELSEIF ( myFace.EQ.3 ) THEN
          vort3(I,J)=
     &     +recip_rA(I,J-1,bi,bj)/AZcorner*(
     &      (-uFld(I,J)*dxC(I,J,bi,bj)
     &       +uFld(I,J-1)*dxC(I,J-1,bi,bj) )
     &      + vFld(I,J)*dyC(I,J,bi,bj)
     &     )
         ELSE
          vort3(I,J)=
     &     +recip_rA(I,J-1,bi,bj)/AZcorner*(
     &      (+vFld(I,J)*dyC(I,J,bi,bj)
     &       -uFld(I,J)*dxC(I,J,bi,bj)     )
     &      + uFld(I,J-1)*dxC(I,J-1,bi,bj)
     &     )
         ENDIF
C-    the quick way, but do not get the same truncation on the 3 faces:
c        vort3(I,J)=
c    &     +recip_rA(I,J-1,bi,bj)/AZcorner*(
c    &      vFld(I,J)*dyC(I,J,bi,bj)
c    &     -uFld(I,J)*dxC(I,J,bi,bj)
c    &     +uFld(I,J-1)*dxC(I,J-1,bi,bj)
c    &     )
c        IF (hFacZ(i,j).EQ.0. _d 0) vort3(i,j) = 0. _d 0
#ifdef CALC_CS_CORNER_EXTENDED
         vort3(I-1,J)=
     &      recip_rAz(I-1,J,bi,bj)*(
     &      vFld(I-1,J)*dyC(I-1,J,bi,bj)
     &     -vFld(I-2,J)*dyC(I-2,J,bi,bj)
     &     +vFld(I-0,J+1)*dyC(I-0,J+1,bi,bj)
     &     +uFld(I-1,J-1)*dxC(I-1,J-1,bi,bj)
     &                           )
c    &     *maskS(i-1,j,k,bi,bj)*maskS(i-2,j,k,bi,bj)
c    &     *maskS(i,j+1,k,bi,bj)*maskW(i-1,j-1,k,bi,bj)
         vort3(I,J+1)=vort3(I-1,J)
#endif
       ENDIF

       IF ( northEastCorner ) THEN
C                U(N+1,N+2)
C                 |                              |
C   V(N,N+2) --- Z(N+1,N+2) --- V(N+1,N+2) ---
C                 |                              |
C   D(N,N+1)     U(N+1,N+1)     D(N+1,N+1)      U(N+2,N+1)
C                 |                              |
C   V(N,N+1) --- Z(N+1,N+1) --- V(N+1,N+1) ---  Z(N+2,N+1) --- V(N+3,N+1) ---
C                 |                              |
C   TILE         U(N+1,N)       D(N+1,N)        U(N+2,N)
         I=sNx+1
         J=sNy+1
C-    to get the same truncation, independent from the face Nb:
C      (exch3 convention order):
         IF ( MOD(myFace,2).EQ.1 ) THEN
          vort3(I,J)=
     &     +recip_rA(I-1,J-1,bi,bj)/AZcorner*(
     &      (-uFld(I,J)*dxC(I,J,bi,bj)
     &       -vFld(I-1,J)*dyC(I-1,J,bi,bj) )
     &      + uFld(I,J-1)*dxC(I,J-1,bi,bj)
     &     )
         ELSE
          vort3(I,J)=
     &     +recip_rA(I-1,J-1,bi,bj)/AZcorner*(
     &      (+uFld(I,J-1)*dxC(I,J-1,bi,bj)
     &       -uFld(I,J)*dxC(I,J,bi,bj)     )
     &      - vFld(I-1,J)*dyC(I-1,J,bi,bj)
     &     )
         ENDIF
C-    the quick way, but do not get the same truncation on the 3 faces:
c        vort3(I,J)=
c    &     +recip_rA(I-1,J-1,bi,bj)/AZcorner*(
c    &     -vFld(I-1,J)*dyC(I-1,J,bi,bj)
c    &     -uFld(I,J)*dxC(I,J,bi,bj)
c    &     +uFld(I,J-1)*dxC(I,J-1,bi,bj)
c    &     )
c        IF (hFacZ(i,j).EQ.0. _d 0) vort3(i,j) = 0. _d 0
#ifdef CALC_CS_CORNER_EXTENDED
         vort3(I+1,J)=
     &      recip_rAz(I+1,J,bi,bj)*(
     &      vFld(I+1,J)*dyC(I+1,J,bi,bj)
     &     -vFld(I-0,J)*dyC(I-0,J,bi,bj)
     &     -vFld(I-1,J+1)*dyC(I-1,J+1,bi,bj)
     &     +uFld(I+1,J-1)*dxC(I+1,J-1,bi,bj)
     &                           )
c    &     *maskS(i+1,j,k,bi,bj)*maskS(i-0,j,k,bi,bj)
c    &     *maskS(i-1,j+1,k,bi,bj)*maskW(i+1,j-1,k,bi,bj)
         vort3(I,J+1)=vort3(I+1,J)
#endif
       ENDIF
      ENDIF

      RETURN
      END

# include "OBCS_OPTIONS.h"

C--  File obcs_exf_load.F: Routines to read of OBC fields with EXF
C--   Contents
C--   o OBCS_EXF_LOAD
C--   o OBCS_EXF_READ_XZ
C--   o OBCS_EXF_READ_YZ

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

CBOP
C     !ROUTINE: OBCS_EXF_LOAD
C     !INTERFACE:
      SUBROUTINE OBCS_EXF_LOAD (
     I                           myTime, myIter, myThid )

C     !DESCRIPTION:
C     *==============================================================*
C     | SUBROUTINE OBCS_EXF_LOAD
C     *==============================================================*
C     | read open boundary conditions from file
C     | N.B.: * uses exf and cal routines for file/record handling
C     |       * uses ctrl routines for control variable handling
C     *==============================================================*

C     !USES:
      IMPLICIT NONE
C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "OBCS_PARAMS.h"
c#include "OBCS_GRID.h"
#include "OBCS_FIELDS.h"
#include "OBCS_SEAICE.h"
#ifdef ALLOW_EXF
# include "EXF_PARAM.h"
#endif
#ifdef ALLOW_PTRACERS
# include "PTRACERS_SIZE.h"
# include "OBCS_PTRACERS.h"
#endif /* ALLOW_PTRACERS */

C     !INPUT/OUTPUT PARAMETERS:
      _RL     myTime
      INTEGER myIter
      INTEGER myThid

#if ( defined ALLOW_EXF ) && ( defined ALLOW_OBCS_PRESCRIBE )
C     !LOCAL VARIABLES:
CEOP

# ifdef ALLOW_OBCS_NORTH
      CALL OBCS_EXF_READ_XZ (
     I     'N', useOBCSYearlyFields,
     I     obcsNstartTime, obcsNperiod, obcsNrepCycle,
     U     OBNu,   OBNu0,   OBNu1,   OBNufile,
     U     OBNv,   OBNv0,   OBNv1,   OBNvfile,
     U     OBNt,   OBNt0,   OBNt1,   OBNtfile,
     U     OBNs,   OBNs0,   OBNs1,   OBNsfile,
#  ifdef NONLIN_FRSURF
     U     OBNeta, OBNeta0, OBNeta1, OBNetafile,
#  endif
#  ifdef ALLOW_SEAICE
     I     siobNstartTime, siobNperiod, siobNrepCycle,
     U     OBNa,   OBNa0,   OBNa1,   OBNafile,
     U     OBNh,   OBNh0,   OBNh1,   OBNhfile,
     U     OBNsl,  OBNsl0,  OBNsl1,  OBNslfile,
     U     OBNsn,  OBNsn0,  OBNsn1,  OBNsnfile,
     U     OBNuice,OBNuice0,OBNuice1,OBNuicefile,
     U     OBNvice,OBNvice0,OBNvice1,OBNvicefile,
#  endif
#  ifdef ALLOW_PTRACERS
     U     OBNptr ,OBNptr0, OBNptr1, OBNptrFile,
#  endif
     I     myTime, myIter, myThid )
# endif /* ALLOW_OBCS_NORTH */

# ifdef ALLOW_OBCS_SOUTH
      CALL OBCS_EXF_READ_XZ (
     I     'S', useOBCSYearlyFields,
     I     obcsSstartTime, obcsSperiod, obcsSrepCycle,
     U     OBSu,   OBSu0,   OBSu1,   OBSufile,
     U     OBSv,   OBSv0,   OBSv1,   OBSvfile,
     U     OBSt,   OBSt0,   OBSt1,   OBStfile,
     U     OBSs,   OBSs0,   OBSs1,   OBSsfile,
#  ifdef NONLIN_FRSURF
     U     OBSeta, OBSeta0, OBSeta1, OBSetafile,
#  endif
#  ifdef ALLOW_SEAICE
     I     siobSstartTime, siobSperiod, siobSrepCycle,
     U     OBSa,   OBSa0,   OBSa1,   OBSafile,
     U     OBSh,   OBSh0,   OBSh1,   OBShfile,
     U     OBSsl,  OBSsl0,  OBSsl1,  OBSslfile,
     U     OBSsn,  OBSsn0,  OBSsn1,  OBSsnfile,
     U     OBSuice,OBSuice0,OBSuice1,OBSuicefile,
     U     OBSvice,OBSvice0,OBSvice1,OBSvicefile,
#  endif
#  ifdef ALLOW_PTRACERS
     U     OBSptr ,OBSptr0, OBSptr1, OBSptrFile,
#  endif
     I     myTime, myIter, myThid )
# endif /* ALLOW_OBCS_SOUTH */

# ifdef ALLOW_OBCS_EAST
      CALL OBCS_EXF_READ_YZ (
     I     'E', useOBCSYearlyFields,
     I     obcsEstartTime, obcsEperiod, obcsErepCycle,
     U     OBEu,   OBEu0,   OBEu1,   OBEufile,
     U     OBEv,   OBEv0,   OBEv1,   OBEvfile,
     U     OBEt,   OBEt0,   OBEt1,   OBEtfile,
     U     OBEs,   OBEs0,   OBEs1,   OBEsfile,
#  ifdef NONLIN_FRSURF
     U     OBEeta, OBEeta0, OBEeta1, OBEetafile,
#  endif
#  ifdef ALLOW_SEAICE
     I     siobEstartTime, siobEperiod, siobErepCycle,
     U     OBEa,   OBEa0,   OBEa1,   OBEafile,
     U     OBEh,   OBEh0,   OBEh1,   OBEhfile,
     U     OBEsl,  OBEsl0,  OBEsl1,  OBEslfile,
     U     OBEsn,  OBEsn0,  OBEsn1,  OBEsnfile,
     U     OBEuice,OBEuice0,OBEuice1,OBEuicefile,
     U     OBEvice,OBEvice0,OBEvice1,OBEvicefile,
#  endif
#  ifdef ALLOW_PTRACERS
     U     OBEptr ,OBEptr0, OBEptr1, OBEptrFile,
#  endif
     I     myTime, myIter, myThid )
# endif /* ALLOW_OBCS_EAST */

# ifdef ALLOW_OBCS_WEST
      CALL OBCS_EXF_READ_YZ (
     I     'W', useOBCSYearlyFields,
     I     obcsWstartTime, obcsWperiod, obcsWrepCycle,
     U     OBWu,   OBWu0,   OBWu1,   OBWufile,
     U     OBWv,   OBWv0,   OBWv1,   OBWvfile,
     U     OBWt,   OBWt0,   OBWt1,   OBWtfile,
     U     OBWs,   OBWs0,   OBWs1,   OBWsfile,
#  ifdef NONLIN_FRSURF
     U     OBWeta, OBWeta0, OBWeta1, OBWetafile,
#  endif
#  ifdef ALLOW_SEAICE
     I     siobWstartTime, siobWperiod, siobWrepCycle,
     U     OBWa,   OBWa0,   OBWa1,   OBWafile,
     U     OBWh,   OBWh0,   OBWh1,   OBWhfile,
     U     OBWsl,  OBWsl0,  OBWsl1,  OBWslfile,
     U     OBWsn,  OBWsn0,  OBWsn1,  OBWsnfile,
     U     OBWuice,OBWuice0,OBWuice1,OBWuicefile,
     U     OBWvice,OBWvice0,OBWvice1,OBWvicefile,
#  endif
#  ifdef ALLOW_PTRACERS
     U     OBWptr ,OBWptr0, OBWptr1, OBWptrFile,
#  endif
     I     myTime, myIter, myThid )
# endif /* ALLOW_OBCS_WEST */

#endif /* ALLOW_EXF and ALLOW_OBCS_PRESCRIBE */

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

CBOP
C     !ROUTINE: OBCS_EXF_READ_XZ
C     !INTERFACE:
      SUBROUTINE OBCS_EXF_READ_XZ (
     I     obName, useYearlyFields,
     I     obcsStartTime, obcsPeriod, obcsRepeatCycle,
     U     OBu,   OBu0,   OBu1,   OBufile,
     U     OBv,   OBv0,   OBv1,   OBvfile,
     U     OBt,   OBt0,   OBt1,   OBtfile,
     U     OBs,   OBs0,   OBs1,   OBsfile,
#ifdef NONLIN_FRSURF
     U     OBeta, OBeta0, OBeta1, OBetafile,
#endif
#ifdef ALLOW_SEAICE
     I     siobStartTime, siobPeriod, siobRepeatCycle,
     U     OBa,   OBa0,   OBa1,   OBafile,
     U     OBh,   OBh0,   OBh1,   OBhfile,
     U     OBsl,  OBsl0,  OBsl1,  OBslfile,
     U     OBsn,  OBsn0,  OBsn1,  OBsnfile,
     U     OBuice,OBuice0,OBuice1,OBuicefile,
     U     OBvice,OBvice0,OBvice1,OBvicefile,
#endif
#ifdef ALLOW_PTRACERS
     U     OBptr ,OBptr0, OBptr1, OBptrFile,
#endif
     I     myTime, myIter, myThid )

C     !DESCRIPTION:
C     *==============================================================*
C     | SUBROUTINE OBCS_EXF_READ_XZ
C     *==============================================================*
C     | read open boundary conditions from file
C     | N.B.: * uses exf and cal routines for file/record handling
C     |       * uses ctrl routines for control variable handling
C     *==============================================================*

C     !USES:
      IMPLICIT NONE
C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#ifdef ALLOW_EXF
# include "EXF_PARAM.h"
#endif
#ifdef ALLOW_PTRACERS
# include "PTRACERS_SIZE.h"
# include "PTRACERS_PARAMS.h"
#endif /* ALLOW_PTRACERS */

C     !INPUT/OUTPUT PARAMETERS:
      CHARACTER*(*) obName
      LOGICAL useYearlyFields
      _RL     obcsStartTime, obcsPeriod, obcsRepeatCycle
      _RL OBu     (1-OLx:sNx+OLx,Nr,nSx,nSy)
      _RL OBv     (1-OLx:sNx+OLx,Nr,nSx,nSy)
      _RL OBt     (1-OLx:sNx+OLx,Nr,nSx,nSy)
      _RL OBs     (1-OLx:sNx+OLx,Nr,nSx,nSy)
      _RL OBu0    (1-OLx:sNx+OLx,Nr,nSx,nSy)
      _RL OBv0    (1-OLx:sNx+OLx,Nr,nSx,nSy)
      _RL OBt0    (1-OLx:sNx+OLx,Nr,nSx,nSy)
      _RL OBs0    (1-OLx:sNx+OLx,Nr,nSx,nSy)
      _RL OBu1    (1-OLx:sNx+OLx,Nr,nSx,nSy)
      _RL OBv1    (1-OLx:sNx+OLx,Nr,nSx,nSy)
      _RL OBt1    (1-OLx:sNx+OLx,Nr,nSx,nSy)
      _RL OBs1    (1-OLx:sNx+OLx,Nr,nSx,nSy)
      CHARACTER*(MAX_LEN_FNAM) OBuFile,OBvFile,OBtFile,OBsFile
#ifdef NONLIN_FRSURF
      _RL OBeta   (1-OLx:sNx+OLx,nSx,nSy)
      _RL OBeta0  (1-OLx:sNx+OLx,nSx,nSy)
      _RL OBeta1  (1-OLx:sNx+OLx,nSx,nSy)
      CHARACTER*(MAX_LEN_FNAM) OBetaFile
#endif
#ifdef ALLOW_SEAICE
      _RL     siobStartTime, siobPeriod, siobRepeatCycle
      _RL OBa     (1-OLx:sNx+OLx,nSx,nSy)
      _RL OBh     (1-OLx:sNx+OLx,nSx,nSy)
      _RL OBa0    (1-OLx:sNx+OLx,nSx,nSy)
      _RL OBh0    (1-OLx:sNx+OLx,nSx,nSy)
      _RL OBa1    (1-OLx:sNx+OLx,nSx,nSy)
      _RL OBh1    (1-OLx:sNx+OLx,nSx,nSy)
      _RL OBsl    (1-OLx:sNx+OLx,nSx,nSy)
      _RL OBsn    (1-OLx:sNx+OLx,nSx,nSy)
      _RL OBsl0   (1-OLx:sNx+OLx,nSx,nSy)
      _RL OBsn0   (1-OLx:sNx+OLx,nSx,nSy)
      _RL OBsl1   (1-OLx:sNx+OLx,nSx,nSy)
      _RL OBsn1   (1-OLx:sNx+OLx,nSx,nSy)
      _RL OBuice  (1-OLx:sNx+OLx,nSx,nSy)
      _RL OBvice  (1-OLx:sNx+OLx,nSx,nSy)
      _RL OBuice0 (1-OLx:sNx+OLx,nSx,nSy)
      _RL OBvice0 (1-OLx:sNx+OLx,nSx,nSy)
      _RL OBuice1 (1-OLx:sNx+OLx,nSx,nSy)
      _RL OBvice1 (1-OLx:sNx+OLx,nSx,nSy)
      CHARACTER*(MAX_LEN_FNAM)
     &     OBaFile,OBhFile,OBslFile,OBsnFile,OBuiceFile,OBviceFile
#endif /* ALLOW_SEAICE */
#ifdef ALLOW_PTRACERS
      _RL OBptr (1-OLx:sNx+OLx,Nr,nSx,nSy,PTRACERS_num)
      _RL OBptr0(1-OLx:sNx+OLx,Nr,nSx,nSy,PTRACERS_num)
      _RL OBptr1(1-OLx:sNx+OLx,Nr,nSx,nSy,PTRACERS_num)
      CHARACTER*(MAX_LEN_FNAM) OBptrFile(PTRACERS_num)
#endif /* ALLOW_PTRACERS */
      _RL     myTime
      INTEGER myIter
      INTEGER myThid

#if ( defined ALLOW_EXF ) && ( defined ALLOW_OBCS_PRESCRIBE )
C     !LOCAL VARIABLES:
C     msgBuf     :: Informational/error message buffer
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      CHARACTER*(6) fldName
      LOGICAL first, changed
      INTEGER count0, count1
      INTEGER year0, year1
      _RL     fac
# ifdef ALLOW_PTRACERS
      INTEGER iTracer
# endif /* ALLOW_PTRACERS */
CEOP

      IF ( useCAL .AND. obcsPeriod .EQ. -12. _d 0 ) THEN
# ifdef ALLOW_CAL
C-    obcsPeriod=-12 means input file contains 12 monthly means
C     records, corresponding to Jan. (rec=1) through Dec. (rec=12)
        CALL cal_GetMonthsRec(
     O              fac, first, changed,
     O              count0, count1, year0, year1,
     I              myTime, myIter, myThid )
# endif /* ALLOW_CAL */
      ELSEIF ( useCal .AND. obcsPeriod .EQ. -1. _d 0 ) THEN
C-    obcsPeriod=-1 means fields are monthly means.
C     With useYearlyFields=.TRUE., each yearly input file contains
C     12 monthly mean records.  Otherwise, a single input file contains
C     monthly mean records starting at the month obcsStartTime falls in.
# ifdef ALLOW_CAL
        CALL EXF_GetMonthsRec(
     I              obcsStartTime, useYearlyFields,
     O              fac, first, changed,
     O              count0, count1, year0, year1,
     I              myTime, myIter, myThid )
# endif /* ALLOW_CAL */
      ELSEIF ( obcsPeriod .LT. 0. _d 0 ) THEN
        WRITE(msgBuf,'(A,1PE16.8,3A)')
     &     'OBCS_EXF_READ_XZ: Invalid obcsPeriod=', obcsPeriod,
     &     ' for ', obName, ' OBCS files'
        CALL PRINT_ERROR( msgBuf, myThid )
        STOP 'ABNORMAL END: S/R OBCS_EXF_READ_XZ'
      ELSE
C-    get record numbers and interpolation factor
        fldName = 'obcs'//obName
        CALL EXF_GetFFieldRec(
     I              obcsStartTime, obcsPeriod, obcsRepeatCycle,
     I              fldName, useYearlyFields,
     O              fac, first, changed,
     O              count0, count1, year0, year1,
     I              myTime, myIter, myThid )
      ENDIF
      IF ( exf_debugLev.GE.debLevD ) THEN
         _BEGIN_MASTER( myThid )
         WRITE(msgBuf,'(4A)') ' OBCS_EXF_READ_XZ: ',
     &     'processing ', obName, '-OBCS files'
         CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                       SQUEEZE_RIGHT, myThid )
         WRITE(msgBuf,'(2A,I10,2I7)') ' OBCS_EXF_READ_XZ: ',
     &     ' myIter, count0, count1:', myIter, count0, count1
         CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                       SQUEEZE_RIGHT, myThid )
         WRITE(msgBuf,'(2A,2(L2,2X),E16.9)') ' OBCS_EXF_READ_XZ: ',
     &     ' first, changed, fac:  ', first, changed, fac
         CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                       SQUEEZE_RIGHT, myThid )
         _END_MASTER( myThid )
      ENDIF

      CALL EXF_SET_OBCS_XZ( OBu, OBu0, OBu1, OBufile, 'u', Nr,
     I                      fac, first, changed, useYearlyFields,
     I                      obcsPeriod, count0, count1, year0, year1,
     I                      myTime, myIter, myThid )
      CALL EXF_SET_OBCS_XZ( OBv, OBv0, OBv1, OBvfile, 'v', Nr,
     I                      fac, first, changed, useYearlyFields,
     I                      obcsPeriod, count0, count1, year0, year1,
     I                      myTime, myIter, myThid )
      CALL EXF_SET_OBCS_XZ( OBt, OBt0, OBt1, OBtfile, 's', Nr,
     I                      fac, first, changed, useYearlyFields,
     I                      obcsPeriod, count0, count1, year0, year1,
     I                      myTime, myIter, myThid )
      CALL EXF_SET_OBCS_XZ( OBs, OBs0, OBs1, OBsfile, 's', Nr,
     I                      fac, first, changed, useYearlyFields,
     I                      obcsPeriod, count0, count1, year0, year1,
     I                      myTime, myIter, myThid )
# ifdef NONLIN_FRSURF
       CALL EXF_SET_OBCS_XZ( OBeta, OBeta0, OBeta1, OBetaFile, 's', 1,
     I                       fac, first, changed, useYearlyFields,
     I                       obcsPeriod, count0, count1, year0, year1,
     I                       myTime, myIter, myThid )
# endif /* NONLIN_FRSURF */
# ifdef ALLOW_PTRACERS
      IF ( usePTRACERS ) THEN
       DO iTracer = 1, PTRACERS_numInUse
        CALL EXF_SET_OBCS_XZ( OBptr (1-OLx,1,1,1,iTracer),
     I                        OBptr0(1-OLx,1,1,1,iTracer),
     I                        OBptr1(1-OLx,1,1,1,iTracer),
     I                        OBptrFile(iTracer), 's', Nr,
     I                        fac, first, changed, useYearlyFields,
     I                        obcsPeriod, count0, count1, year0, year1,
     I                        myTime, myIter, myThid )
       ENDDO
      ENDIF
# endif /* ALLOW_PTRACERS */

# ifdef ALLOW_SEAICE
      IF (useSEAICE) THEN
       IF ( useCAL .AND. siobPeriod .EQ. -12. _d 0 ) THEN
#  ifdef ALLOW_CAL
C-    obcsPeriod=-12 means input file contains 12 monthly means
C     records, corresponding to Jan. (rec=1) through Dec. (rec=12)
        CALL cal_GetMonthsRec(
     O              fac, first, changed,
     O              count0, count1, year0, year1,
     I              myTime, myIter, myThid )
#  endif /* ALLOW_CAL */
       ELSEIF ( useCal .AND. siobPeriod .EQ. -1. _d 0 ) THEN
C-    siobPeriod=-1 means fields are monthly means.
C     With useYearlyFields=.TRUE., each yearly input file contains
C     12 monthly mean records.  Otherwise, a single input file contains
C     monthly mean records starting at the month siobStartTime falls in.
# ifdef ALLOW_CAL
        CALL EXF_GetMonthsRec(
     I              siobStartTime, useYearlyFields,
     O              fac, first, changed,
     O              count0, count1, year0, year1,
     I              myTime, myIter, myThid )
# endif /* ALLOW_CAL */
       ELSEIF ( siobPeriod .LT. 0. _d 0 ) THEN
        WRITE(msgBuf,'(A,1PE16.8,3A)')
     &     'OBCS_EXF_READ_XZ: Invalid siobPeriod=', siobPeriod,
     &     ' for ', obName, ' OBCS files'
        CALL PRINT_ERROR( msgBuf, myThid )
        STOP 'ABNORMAL END: S/R OBCS_EXF_READ_XZ'
       ELSE
C-    get record numbers and interpolation factor
        fldName = 'SIob'//obName
        CALL EXF_GetFFieldRec(
     I              siobStartTime, siobPeriod, siobRepeatCycle,
     I              fldName, useYearlyFields,
     O              fac, first, changed,
     O              count0, count1, year0, year1,
     I              myTime, myIter, myThid )
       ENDIF
       IF ( exf_debugLev.GE.debLevD ) THEN
         _BEGIN_MASTER( myThid )
         WRITE(msgBuf,'(4A)') ' OBCS_EXF_READ_XZ: ',
     &     'processing SEAICE ', obName, '-OBCS files'
         CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                       SQUEEZE_RIGHT, myThid )
         WRITE(msgBuf,'(2A,I10,2I7)') ' OBCS_EXF_READ_XZ: ',
     &     ' myIter, count0, count1:', myIter, count0, count1
         CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                       SQUEEZE_RIGHT, myThid )
         WRITE(msgBuf,'(2A,2(L2,2X),E16.9)') ' OBCS_EXF_READ_XZ: ',
     &     ' first, changed, fac:  ', first, changed, fac
         CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                       SQUEEZE_RIGHT, myThid )
         _END_MASTER( myThid )
       ENDIF

       CALL EXF_SET_OBCS_XZ( OBa, OBa0, OBa1, OBafile, 's', 1,
     I                       fac, first, changed, useYearlyFields,
     I                       siobPeriod, count0, count1, year0, year1,
     I                       myTime, myIter, myThid )
       CALL EXF_SET_OBCS_XZ( OBh, OBh0, OBh1, OBhfile, 's', 1,
     I                       fac, first, changed, useYearlyFields,
     I                       siobPeriod, count0, count1, year0, year1,
     I                       myTime, myIter, myThid )
       CALL EXF_SET_OBCS_XZ( OBsl, OBsl0, OBsl1, OBslfile, 's', 1,
     I                       fac, first, changed, useYearlyFields,
     I                       siobPeriod, count0, count1, year0, year1,
     I                       myTime, myIter, myThid )
       CALL EXF_SET_OBCS_XZ( OBsn, OBsn0, OBsn1, OBsnfile, 's', 1,
     I                       fac, first, changed, useYearlyFields,
     I                       siobPeriod, count0, count1, year0, year1,
     I                       myTime, myIter, myThid )
       CALL EXF_SET_OBCS_XZ( OBuice,OBuice0,OBuice1,OBuicefile,'u', 1,
     I                       fac, first, changed, useYearlyFields,
     I                       siobPeriod, count0, count1, year0, year1,
     I                       myTime, myIter, myThid )
       CALL EXF_SET_OBCS_XZ( OBvice,OBvice0,OBvice1,OBvicefile,'v', 1,
     I                       fac, first, changed, useYearlyFields,
     I                       siobPeriod, count0, count1, year0, year1,
     I                       myTime, myIter, myThid )
      ENDIF
# endif /* ALLOW_SEAICE */

#endif /* ALLOW_EXF and ALLOW_OBCS_PRESCRIBE */
      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

CBOP
C     !ROUTINE: OBCS_EXF_READ_YZ
C     !INTERFACE:
      SUBROUTINE OBCS_EXF_READ_YZ (
     I     obName, useYearlyFields,
     I     obcsStartTime, obcsPeriod, obcsRepeatCycle,
     U     OBu,   OBu0,   OBu1,   OBufile,
     U     OBv,   OBv0,   OBv1,   OBvfile,
     U     OBt,   OBt0,   OBt1,   OBtfile,
     U     OBs,   OBs0,   OBs1,   OBsfile,
#ifdef NONLIN_FRSURF
     U     OBeta, OBeta0, OBeta1, OBetafile,
#endif
#ifdef ALLOW_SEAICE
     I     siobStartTime, siobPeriod, siobRepeatCycle,
     U     OBa,   OBa0,   OBa1,   OBafile,
     U     OBh,   OBh0,   OBh1,   OBhfile,
     U     OBsl,  OBsl0,  OBsl1,  OBslfile,
     U     OBsn,  OBsn0,  OBsn1,  OBsnfile,
     U     OBuice,OBuice0,OBuice1,OBuicefile,
     U     OBvice,OBvice0,OBvice1,OBvicefile,
#endif
#ifdef ALLOW_PTRACERS
     U     OBptr ,OBptr0, OBptr1, OBptrFile,
#endif
     I     myTime, myIter, myThid )

C     !DESCRIPTION:
C     *==============================================================*
C     | SUBROUTINE OBCS_EXF_READ_YZ
C     *==============================================================*
C     | read open boundary conditions from file
C     | N.B.: * uses exf and cal routines for file/record handling
C     |       * uses ctrl routines for control variable handling
C     *==============================================================*

C     !USES:
      IMPLICIT NONE
C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#ifdef ALLOW_EXF
# include "EXF_PARAM.h"
#endif
#ifdef ALLOW_PTRACERS
# include "PTRACERS_SIZE.h"
# include "PTRACERS_PARAMS.h"
#endif /* ALLOW_PTRACERS */

C     !INPUT/OUTPUT PARAMETERS:
      CHARACTER*(*) obName
      LOGICAL useYearlyFields
      _RL     obcsStartTime, obcsPeriod, obcsRepeatCycle
      _RL OBu     (1-OLy:sNy+OLy,Nr,nSx,nSy)
      _RL OBv     (1-OLy:sNy+OLy,Nr,nSx,nSy)
      _RL OBt     (1-OLy:sNy+OLy,Nr,nSx,nSy)
      _RL OBs     (1-OLy:sNy+OLy,Nr,nSx,nSy)
      _RL OBu0    (1-OLy:sNy+OLy,Nr,nSx,nSy)
      _RL OBv0    (1-OLy:sNy+OLy,Nr,nSx,nSy)
      _RL OBt0    (1-OLy:sNy+OLy,Nr,nSx,nSy)
      _RL OBs0    (1-OLy:sNy+OLy,Nr,nSx,nSy)
      _RL OBu1    (1-OLy:sNy+OLy,Nr,nSx,nSy)
      _RL OBv1    (1-OLy:sNy+OLy,Nr,nSx,nSy)
      _RL OBt1    (1-OLy:sNy+OLy,Nr,nSx,nSy)
      _RL OBs1    (1-OLy:sNy+OLy,Nr,nSx,nSy)
      CHARACTER*(MAX_LEN_FNAM) OBuFile,OBvFile,OBtFile,OBsFile
#ifdef NONLIN_FRSURF
      _RL OBeta   (1-OLy:sNy+OLy,nSx,nSy)
      _RL OBeta0  (1-OLy:sNy+OLy,nSx,nSy)
      _RL OBeta1  (1-OLy:sNy+OLy,nSx,nSy)
      CHARACTER*(MAX_LEN_FNAM) OBetaFile
#endif
#ifdef ALLOW_SEAICE
      _RL     siobStartTime, siobPeriod, siobRepeatCycle
      _RL OBa     (1-OLy:sNy+OLy,nSx,nSy)
      _RL OBh     (1-OLy:sNy+OLy,nSx,nSy)
      _RL OBa0    (1-OLy:sNy+OLy,nSx,nSy)
      _RL OBh0    (1-OLy:sNy+OLy,nSx,nSy)
      _RL OBa1    (1-OLy:sNy+OLy,nSx,nSy)
      _RL OBh1    (1-OLy:sNy+OLy,nSx,nSy)
      _RL OBsl    (1-OLy:sNy+OLy,nSx,nSy)
      _RL OBsn    (1-OLy:sNy+OLy,nSx,nSy)
      _RL OBsl0   (1-OLy:sNy+OLy,nSx,nSy)
      _RL OBsn0   (1-OLy:sNy+OLy,nSx,nSy)
      _RL OBsl1   (1-OLy:sNy+OLy,nSx,nSy)
      _RL OBsn1   (1-OLy:sNy+OLy,nSx,nSy)
      _RL OBuice  (1-OLy:sNy+OLy,nSx,nSy)
      _RL OBvice  (1-OLy:sNy+OLy,nSx,nSy)
      _RL OBuice0 (1-OLy:sNy+OLy,nSx,nSy)
      _RL OBvice0 (1-OLy:sNy+OLy,nSx,nSy)
      _RL OBuice1 (1-OLy:sNy+OLy,nSx,nSy)
      _RL OBvice1 (1-OLy:sNy+OLy,nSx,nSy)
      CHARACTER*(MAX_LEN_FNAM)
     &     OBaFile,OBhFile,OBslFile,OBsnFile,OBuiceFile,OBviceFile
#endif /* ALLOW_SEAICE */
#ifdef ALLOW_PTRACERS
      _RL OBptr (1-OLy:sNy+OLy,Nr,nSx,nSy,PTRACERS_num)
      _RL OBptr0(1-OLy:sNy+OLy,Nr,nSx,nSy,PTRACERS_num)
      _RL OBptr1(1-OLy:sNy+OLy,Nr,nSx,nSy,PTRACERS_num)
      CHARACTER*(MAX_LEN_FNAM) OBptrFile(PTRACERS_num)
#endif /* ALLOW_PTRACERS */
      _RL     myTime
      INTEGER myIter
      INTEGER myThid

#if ( defined ALLOW_EXF ) && ( defined ALLOW_OBCS_PRESCRIBE )
C     !LOCAL VARIABLES:
C     msgBuf     :: Informational/error message buffer
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      CHARACTER*(6) fldName
      LOGICAL first, changed
      INTEGER count0, count1
      INTEGER year0, year1
      _RL     fac
# ifdef ALLOW_PTRACERS
      INTEGER iTracer
# endif /* ALLOW_PTRACERS */
CEOP

      IF ( useCAL .AND. obcsPeriod .EQ. -12. _d 0 ) THEN
# ifdef ALLOW_CAL
C-    obcsPeriod=-12 means input file contains 12 monthly means
C     records, corresponding to Jan. (rec=1) through Dec. (rec=12)
        CALL cal_GetMonthsRec(
     O              fac, first, changed,
     O              count0, count1, year0, year1,
     I              myTime, myIter, myThid )
# endif /* ALLOW_CAL */
      ELSEIF ( useCal .AND. obcsPeriod .EQ. -1. _d 0 ) THEN
C-    obcsPeriod=-1 means fields are monthly means.
C     With useYearlyFields=.TRUE., each yearly input file contains
C     12 monthly mean records.  Otherwise, a single input file contains
C     monthly mean records starting at the month obcsStartTime falls in.
# ifdef ALLOW_CAL
        CALL EXF_GetMonthsRec(
     I              obcsStartTime, useYearlyFields,
     O              fac, first, changed,
     O              count0, count1, year0, year1,
     I              myTime, myIter, myThid )
# endif /* ALLOW_CAL */
      ELSEIF ( obcsPeriod .LT. 0. _d 0 ) THEN
        WRITE(msgBuf,'(A,1PE16.8,3A)')
     &     'OBCS_EXF_READ_YZ: Invalid obcsPeriod=', obcsPeriod,
     &     ' for ', obName, ' OBCS files'
        CALL PRINT_ERROR( msgBuf, myThid )
        STOP 'ABNORMAL END: S/R OBCS_EXF_READ_YZ'
      ELSE
C-    get record numbers and interpolation factor
        fldName = 'obcs'//obName
        CALL EXF_GetFFieldRec(
     I              obcsStartTime, obcsPeriod, obcsRepeatCycle,
     I              fldName, useYearlyFields,
     O              fac, first, changed,
     O              count0, count1, year0, year1,
     I              myTime, myIter, myThid )
      ENDIF
      IF ( exf_debugLev.GE.debLevD ) THEN
         _BEGIN_MASTER( myThid )
         WRITE(msgBuf,'(4A)') ' OBCS_EXF_READ_XZ: ',
     &     'processing ', obName, '-OBCS files'
         CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                       SQUEEZE_RIGHT, myThid )
         WRITE(msgBuf,'(2A,I10,2I7)') ' OBCS_EXF_READ_YZ: ',
     &     ' myIter, count0, count1:', myIter, count0, count1
         CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                       SQUEEZE_RIGHT, myThid )
         WRITE(msgBuf,'(2A,2(L2,2X),E16.9)') ' OBCS_EXF_READ_YZ: ',
     &     ' first, changed, fac:  ', first, changed, fac
         CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                       SQUEEZE_RIGHT, myThid )
         _END_MASTER( myThid )
      ENDIF

      CALL EXF_SET_OBCS_YZ( OBu, OBu0, OBu1, OBufile, 'u', Nr,
     I                      fac, first, changed, useYearlyFields,
     I                      obcsPeriod, count0, count1, year0, year1,
     I                      myTime, myIter, myThid )
      CALL EXF_SET_OBCS_YZ( OBv, OBv0, OBv1, OBvfile, 'v', Nr,
     I                      fac, first, changed, useYearlyFields,
     I                      obcsPeriod, count0, count1, year0, year1,
     I                      myTime, myIter, myThid )
      CALL EXF_SET_OBCS_YZ( OBt, OBt0, OBt1, OBtfile, 's', Nr,
     I                      fac, first, changed, useYearlyFields,
     I                      obcsPeriod, count0, count1, year0, year1,
     I                      myTime, myIter, myThid )
      CALL EXF_SET_OBCS_YZ( OBs, OBs0, OBs1, OBsfile, 's', Nr,
     I                      fac, first, changed, useYearlyFields,
     I                      obcsPeriod, count0, count1, year0, year1,
     I                      myTime, myIter, myThid )
# ifdef NONLIN_FRSURF
       CALL EXF_SET_OBCS_YZ( OBeta, OBeta0, OBeta1, OBetaFile, 's', 1,
     I                       fac, first, changed, useYearlyFields,
     I                       obcsPeriod, count0, count1, year0, year1,
     I                       myTime, myIter, myThid )
# endif /* NONLIN_FRSURF */
# ifdef ALLOW_PTRACERS
      IF ( usePTRACERS ) THEN
       DO iTracer = 1, PTRACERS_numInUse
        CALL EXF_SET_OBCS_YZ( OBptr (1-OLx,1,1,1,iTracer),
     I                        OBptr0(1-OLx,1,1,1,iTracer),
     I                        OBptr1(1-OLx,1,1,1,iTracer),
     I                        OBptrFile(iTracer), 's', Nr,
     I                        fac, first, changed, useYearlyFields,
     I                        obcsPeriod, count0, count1, year0, year1,
     I                        myTime, myIter, myThid )
       ENDDO
      ENDIF
# endif /* ALLOW_PTRACERS */

# ifdef ALLOW_SEAICE
      IF (useSEAICE) THEN
       IF ( useCAL .AND. siobPeriod .EQ. -12. _d 0 ) THEN
#  ifdef ALLOW_CAL
C-    obcsPeriod=-12 means input file contains 12 monthly means
C     records, corresponding to Jan. (rec=1) through Dec. (rec=12)
        CALL cal_GetMonthsRec(
     O              fac, first, changed,
     O              count0, count1, year0, year1,
     I              myTime, myIter, myThid )
#  endif /* ALLOW_CAL */
       ELSEIF ( useCal .AND. siobPeriod .EQ. -1. _d 0 ) THEN
C-    siobPeriod=-1 means fields are monthly means.
C     With useYearlyFields=.TRUE., each yearly input file contains
C     12 monthly mean records.  Otherwise, a single input file contains
C     monthly mean records starting at the month siobStartTime falls in.
# ifdef ALLOW_CAL
        CALL EXF_GetMonthsRec(
     I              siobStartTime, useYearlyFields,
     O              fac, first, changed,
     O              count0, count1, year0, year1,
     I              myTime, myIter, myThid )
# endif /* ALLOW_CAL */
       ELSEIF ( siobPeriod .LT. 0. _d 0 ) THEN
        WRITE(msgBuf,'(A,1PE16.8,3A)')
     &     'OBCS_EXF_READ_YZ: Invalid siobPeriod=', siobPeriod,
     &     ' for ', obName, ' OBCS files'
        CALL PRINT_ERROR( msgBuf, myThid )
        STOP 'ABNORMAL END: S/R OBCS_EXF_READ_YZ'
       ELSE
C-    get record numbers and interpolation factor
        fldName = 'SIob'//obName
        CALL EXF_GetFFieldRec(
     I              siobStartTime, siobPeriod, siobRepeatCycle,
     I              fldName, useYearlyFields,
     O              fac, first, changed,
     O              count0, count1, year0, year1,
     I              myTime, myIter, myThid )
       ENDIF
       IF ( exf_debugLev.GE.debLevD ) THEN
         _BEGIN_MASTER( myThid )
         WRITE(msgBuf,'(4A)') ' OBCS_EXF_READ_XZ: ',
     &     'processing SEAICE ', obName, '-OBCS files'
         CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                       SQUEEZE_RIGHT, myThid )
         WRITE(msgBuf,'(2A,I10,2I7)') ' OBCS_EXF_READ_YZ: ',
     &     ' myIter, count0, count1:', myIter, count0, count1
         CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                       SQUEEZE_RIGHT, myThid )
         WRITE(msgBuf,'(2A,2(L2,2X),E16.9)') ' OBCS_EXF_READ_YZ: ',
     &     ' first, changed, fac:  ', first, changed, fac
         CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                       SQUEEZE_RIGHT, myThid )
         _END_MASTER( myThid )
       ENDIF

       CALL EXF_SET_OBCS_YZ( OBa, OBa0, OBa1, OBafile, 's', 1,
     I                       fac, first, changed, useYearlyFields,
     I                       siobPeriod, count0, count1, year0, year1,
     I                       myTime, myIter, myThid )
       CALL EXF_SET_OBCS_YZ( OBh, OBh0, OBh1, OBhfile, 's', 1,
     I                       fac, first, changed, useYearlyFields,
     I                       siobPeriod, count0, count1, year0, year1,
     I                       myTime, myIter, myThid )
       CALL EXF_SET_OBCS_YZ( OBsl, OBsl0, OBsl1, OBslfile, 's', 1,
     I                       fac, first, changed, useYearlyFields,
     I                       siobPeriod, count0, count1, year0, year1,
     I                       myTime, myIter, myThid )
       CALL EXF_SET_OBCS_YZ( OBsn, OBsn0, OBsn1, OBsnfile, 's', 1,
     I                       fac, first, changed, useYearlyFields,
     I                       siobPeriod, count0, count1, year0, year1,
     I                       myTime, myIter, myThid )
       CALL EXF_SET_OBCS_YZ( OBuice,OBuice0,OBuice1,OBuicefile,'u', 1,
     I                       fac, first, changed, useYearlyFields,
     I                       siobPeriod, count0, count1, year0, year1,
     I                       myTime, myIter, myThid )
       CALL EXF_SET_OBCS_YZ( OBvice,OBvice0,OBvice1,OBvicefile,'v', 1,
     I                       fac, first, changed, useYearlyFields,
     I                       siobPeriod, count0, count1, year0, year1,
     I                       myTime, myIter, myThid )
      ENDIF
# endif /* ALLOW_SEAICE */

#endif /* ALLOW_EXF and ALLOW_OBCS_PRESCRIBE */
      RETURN
      END

#include "STREAMICE_OPTIONS.h"

      SUBROUTINE template()
      use OAD_cp
      use OAD_tape
      use OAD_rev

!$TEMPLATE_PRAGMA_DECLARATIONS

      integer :: cp_loop_variable_1,cp_loop_variable_2,
     +     cp_loop_variable_3,cp_loop_variable_4

      type(modeType) :: our_orig_mode

      integer iaddr
      external iaddr


      Real*8 H_p (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      Real*8 surf_p (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      Real*8 R_p (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      Real*8 H_d (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      Real*8 surf_d (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      Real*8 R_d (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      
C
C     **** Statements ****
C


      if (our_rev_mode%plain) then
#ifdef STREAMICE_ALLOW_DEPTH_CONTROL
#ifdef STREAMICE_SMOOTH_FLOATATION

       H_p = H_streamice%v
       surf_p = surf_el_streamice%v
       R_p = R_low_si%v      

       CALL STREAMICE_INVERT_SURF_FORTHICK(
     O            H_p,
     I            surf_p,
     I            R_p,
     I            delta,
     I            myThid)

       H_streamice%v = H_p
#endif
#endif
      end if
      if (our_rev_mode%tape) then
#ifdef STREAMICE_SMOOTH_FLOATATION
#ifdef STREAMICE_ALLOW_DEPTH_CONTROL
c set up for plain execution
       our_orig_mode=our_rev_mode
       our_rev_mode%arg_store=.FALSE.
       our_rev_mode%arg_restore=.FALSE.
       our_rev_mode%plain=.TRUE.
       our_rev_mode%tape=.FALSE.
       our_rev_mode%adjoint=.FALSE.

       H_p = H_streamice%v
       surf_p = surf_el_streamice%v
       R_p = R_low_si%v

       call oad_tape_push(surf_p)
       call oad_tape_push(R_p)
       call oad_tape_push(delta)
       call oad_tape_push(myThid)

       CALL STREAMICE_INVERT_SURF_FORTHICK(
     O            H_p,
     I            surf_p,
     I            R_p,
     I            delta,
     I            myThid)

       call oad_tape_push(H_p)
       H_streamice%v = H_p
       our_rev_mode=our_orig_mode
#endif
#endif     
      end if
      if (our_rev_mode%adjoint) then
c set up for plain execution
#ifdef STREAMICE_ALLOW_DEPTH_CONTROL
#ifdef STREAMICE_SMOOTH_FLOATATION
         our_orig_mode=our_rev_mode
         our_rev_mode%arg_store=.FALSE.
         our_rev_mode%arg_restore=.FALSE.
         our_rev_mode%plain=.TRUE.
         our_rev_mode%tape=.FALSE.
         our_rev_mode%adjoint=.FALSE.

        call oad_tape_pop(H_p)
        call oad_tape_pop(myThid)
        call oad_tape_pop(delta)
        call oad_tape_pop(R_p)
        call oad_tape_pop(surf_p)

        H_d = H_streamice%d
        surf_d = surf_el_streamice%d
        R_d = R_low_si%d      

        CALL ADSTRMICE_H_INV (
     &            H_p,
     &            H_d,
     &            Surf_p,
     &            R_p,
     &            R_d,
     &            delta,
     &            mythid)

        R_low_si%d = R_d

       our_rev_mode=our_orig_mode
#endif      
#endif
      end if
      end subroutine template

#include "FRAZIL_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 0
C !ROUTINE: FRAZIL_INIT_VARIA

C !INTERFACE:
      SUBROUTINE FRAZIL_INIT_VARIA( myThid )

C     !DESCRIPTION:
C     Initialize FRAZIL variables

C     !USES:
      IMPLICIT NONE
#include "EEPARAMS.h"
#include "SIZE.h"
#ifdef ALLOW_FRAZIL
# include "FRAZIL.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     myThid :: my Thread Id number
      INTEGER myThid
CEOP

#ifdef ALLOW_FRAZIL

C     !LOCAL VARIABLES:
      INTEGER i,j,k,bi,bj

C     Initialize arrays in common blocks :
      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
        DO k=1,Nr
         DO j=1-Oly,sNy+OLy
          DO i=1-Olx,sNx+Olx
           FrazilForcingT(i,j,k,bi,bj) = 0. _d 0
          ENDDO
         ENDDO
        ENDDO
       ENDDO
      ENDDO

#endif /* ALLOW_FRAZIL */

      RETURN
      END

#include "LAYERS_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      SUBROUTINE LAYERS_INIT_VARIA( myThid )

C ===================================================================
C     Initialize LAYERS variables.
C ===================================================================

      IMPLICIT NONE
#include "EEPARAMS.h"
#include "SIZE.h"
#include "PARAMS.h"
#include "LAYERS_SIZE.h"
#include "LAYERS.h"

C  INPUT/OUTPUT PARAMETERS:
C     myThid ::  my Thread Id number
      INTEGER myThid

#ifdef ALLOW_LAYERS

C     === Local variables ===
      INTEGER bi, bj
#ifdef LAYERS_THERMODYNAMICS
      INTEGER i,j,kg
      INTEGER iTracer
#endif

      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)

C     Loop through 3D layers variables:
#ifdef LAYERS_THERMODYNAMICS
        DO kg=1,Nlayers
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           layers_Hc (i,j,kg,bi,bj) = 0. _d 0
           layers_PIc(i,j,kg,bi,bj) = 0. _d 0
          ENDDO
         ENDDO
        ENDDO
        DO kg=1,Nlayers-1
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           layers_Hc        (i,j,kg,bi,bj) = 0. _d 0
           layers_TtendSurf (i,j,kg,bi,bj) = 0. _d 0
           layers_TtendDiffh(i,j,kg,bi,bj) = 0. _d 0
           layers_TtendDiffr(i,j,kg,bi,bj) = 0. _d 0
           layers_TtendAdvh (i,j,kg,bi,bj) = 0. _d 0
           layers_TtendAdvr (i,j,kg,bi,bj) = 0. _d 0
           layers_StendSurf (i,j,kg,bi,bj) = 0. _d 0
           layers_StendDiffh(i,j,kg,bi,bj) = 0. _d 0
           layers_StendDiffr(i,j,kg,bi,bj) = 0. _d 0
           layers_StendAdvh(i,j,kg,bi,bj) = 0. _d 0
           layers_StendAdvr(i,j,kg,bi,bj) = 0. _d 0
          ENDDO
         ENDDO
        ENDDO
#ifdef LAYERS_PRHO_REF
        DO kg=1,Nr
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           layers_alpha(i,j,kg,bi,bj) = 0. _d 0
           layers_beta(i,j,kg,bi,bj) = 0. _d 0
          ENDDO
         ENDDO
        ENDDO
#endif /* LAYERS_PRHO_REF */

        DO iTracer = 1,2
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           layers_surfflux(i,j,1,iTracer,bi,bj) = 0. _d 0
          ENDDO
         ENDDO
         DO kg=1,Nr
          DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
            layers_tottend (i,j,kg,iTracer,bi,bj) = 0. _d 0
            layers_dfx     (i,j,kg,iTracer,bi,bj) = 0. _d 0
            layers_dfy     (i,j,kg,iTracer,bi,bj) = 0. _d 0
            layers_dfr     (i,j,kg,iTracer,bi,bj) = 0. _d 0
            layers_afx     (i,j,kg,iTracer,bi,bj) = 0. _d 0
            layers_afy     (i,j,kg,iTracer,bi,bj) = 0. _d 0
            layers_afr     (i,j,kg,iTracer,bi,bj) = 0. _d 0
#ifdef SHORTWAVE_HEATING
            layers_sw      (i,j,kg,1      ,bi,bj) = 0. _d 0
#endif /* SHORTWAVE_HEATING */
           ENDDO
          ENDDO
         ENDDO
        ENDDO
#endif /* LAYERS_THERMODYNAMICS */

C- end bi,bj loops
       ENDDO
      ENDDO

#endif /* ALLOW_LAYERS */

      RETURN
      END

#include "AUTODIFF_OPTIONS.h"
#include "AD_CONFIG.h"

CBOP
C !ROUTINE: COPY_ADVAR_OUTP
C !INTERFACE:
      SUBROUTINE COPY_ADVAR_OUTP(
     I                            inpFldRS, inpFldRL,
     O                            outFld,
     I                            nNz, vType, myThid )

C !DESCRIPTION:
C     Copy input AD-variable (RS or RL) into output array and then, according
C      to variable type, apply ADEXCH to output array.
C     vType (1rst digit):
C           = 1,3 : process RS input field ; = 2,4 : process RL input field
C           = 1,2 : without sign. ;          = 3,4 : with sign.
C     vType (2nd digit) = 10 : A-grid location (i.e., grid-cell center)
C                       = 20 : B-grid location (i.e., grid-cell corner)

C     !USES:
      IMPLICIT NONE

C Global variables / common blocks
#include "EEPARAMS.h"
#include "SIZE.h"

C     !INPUT/OUTPUT PARAMETERS:
C Routine arguments
C inpFldRS ( RS )  :: input AD-variable field
C inpFldRL ( RL )  :: input AD-variable field
C outFld   ( RL )  :: copy of input field
C nNz     (integer):: third dimension of 3-D input/output field
C vType   (integer):: type of AD-variable (select which ADEXCH to use)
C myThid  (integer):: my Thread Id number
      INTEGER nNz
      _RS    inpFldRS(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nNz,nSx,nSy)
      _RL    inpFldRL(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nNz,nSx,nSy)
      _RL    outFld(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nNz,nSx,nSy)
      INTEGER vType
      INTEGER myThid

#ifdef ALLOW_AUTODIFF_MONITOR
#if (defined (ALLOW_ADJOINT_RUN) || defined (ALLOW_ADMTLM))
C !LOCAL VARIABLES:
C   i,j,k   :: loop indices
C   bi,bj   :: tile indices
C   gridloc :: advar horizontal-grid location
      INTEGER i,j,k,bi,bj
      INTEGER gridloc
      LOGICAL wSign
CEOP

      gridloc = vType/10
      IF ( MOD(vType,10).LT.1 .OR. MOD(vType,10).GT.4
     &      .OR. gridloc.LT.1 .OR. gridloc.GT.2 ) THEN
        STOP 'ABNORMAL END: COPY_ADVAR_OUTP invalid vType'
      ENDIF
      wSign = MOD(vType,10).GE.3

      IF ( MOD(vType,2).EQ.1 ) THEN
       DO bj = myByLo(myThid), myByHi(myThid)
        DO bi = myBxLo(myThid), myBxHi(myThid)
         DO k=1,nNz
          DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
             outFld(i,j,k,bi,bj) = inpFldRS(i,j,k,bi,bj)
           ENDDO
          ENDDO
         ENDDO
        ENDDO
       ENDDO
      ELSE
       DO bj = myByLo(myThid), myByHi(myThid)
        DO bi = myBxLo(myThid), myBxHi(myThid)
         DO k=1,nNz
          DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
             outFld(i,j,k,bi,bj) = inpFldRL(i,j,k,bi,bj)
           ENDDO
          ENDDO
         ENDDO
        ENDDO
       ENDDO
      ENDIF

#ifdef ALLOW_OPENAD
C--   need to all the correct OpenAD EXCH S/R ; left empty for now
#else /* ALLOW_OPENAD */

      IF ( gridloc.EQ.1 ) THEN
       IF ( wSign ) THEN
#ifdef AUTODIFF_TAMC_COMPATIBILITY
c       CALL ADEXCH_SM_3D_RL( wSign, nNz, myThid, outFld )
#else
c       CALL ADEXCH_SM_3D_RL( outFld, wSign, nNz, myThid )
#endif
        STOP 'ABNORMAL END: COPY_ADVAR_OUTP missing wSign,loc=1'
       ELSE
#ifdef AUTODIFF_TAMC_COMPATIBILITY
        CALL ADEXCH_3D_RL( nNz, myThid, outFld )
#else
        CALL ADEXCH_3D_RL( outFld, nNz, myThid )
#endif
       ENDIF
      ELSEIF ( gridloc.EQ.2 ) THEN
       IF ( wSign ) THEN
        STOP 'ABNORMAL END: COPY_ADVAR_OUTP wSign,loc=2 not coded'
       ELSE
#ifdef AUTODIFF_TAMC_COMPATIBILITY
c       CALL ADEXCH_Z_3D_RL( nNz, myThid, outFld )
#else
c       CALL ADEXCH_Z_3D_RL( outFld, nNz, myThid )
#endif
        STOP 'ABNORMAL END: COPY_ADVAR_OUTP missing noSign,loc=2'
       ENDIF
      ENDIF
#endif /* ALLOW_OPENAD */

#endif /* ALLOW_ADJOINT_RUN or ALLOW_ADMTLM */
#endif /* ALLOW_AUTODIFF_MONITOR */
      RETURN
      END

#include "ctrparam.h"
#ifdef OCEAN_3D
#  include "ATM2D_OPTIONS.h"
#endif
C
#ifndef OCEAN_3D
      SUBROUTINE ATM2D_INIT_FIXED(nCouplePer, myThid)
#else
      SUBROUTINE ATM2D_INIT_FIXED(myThid)
#endif
C     |==========================================================|
C     | Initialization steps prior to any pickup info loaded.    |
C     \==========================================================/
      IMPLICIT NONE

#include "ATMSIZE.h"
#include "DRIVER.h"
#ifdef OCEAN_3D
#  include "SIZE.h"
#  include "EEPARAMS.h"
#  include "PARAMS.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     nCouplePer - total number of coupled periods for this run
C     myThid - thread number for this instance of the routine.
#ifndef OCEAN_3D
      INTEGER nCouplePer    !not a subroutine parm for OCEAN_3D
#endif
      INTEGER myThid

      NAMELIST /COUPLE_PARM/
     &        dtcouple, dtatm, dtocn, startYear, endYear, taveDump

C     === Local variables ===
#ifdef OCEAN_3D
      INTEGER nCouplePer    !not a subroutine parm for OCEAN_3D
# ifdef ATM2D_MPI_ON
      INTEGER msgUnit
# endif
#endif

      CALL CHECK_SETTINGS

C     set default values for these parms in couple.nml
      dtatm = 1
      dtocn = 8
      dtcouple = 8
      startYear = 1
      endYear = 100
      taveDump=100

C     Next lines done in stand-alone ML model, so don't use any
C     MITGCM helper routines; hopefully no unit conflict...
      OPEN(514,file='couple.nml',status='old')
      READ(514,COUPLE_PARM)
      CLOSE(514)

#ifdef OCEAN_3D
      CALL ATM2D_READPARMS(myThid)
#endif

      ncall_atm=dtcouple/dtatm
      ncall_ocean=dtcouple/dtocn
      nCouplePer = (endYear-startYear+1)*24*365/dtcouple

      PRINT *,'Model run years:',startYear,' to ', endYear
      PRINT *,'dcouple=',dtcouple
      PRINT *,'dtatm=',dtatm
      PRINT *,'dtocn=',dtocn
      PRINT *,'Total number of coupled periods:',nCouplePer

#ifdef OCEAN_3D
      nTimeSteps = nCouplePer    !overwrite whatever MITGCM gets from data
#endif

#ifdef CPL_OCEANCO2
      ocupt=0.0
      temuptann=0.0
#endif

#ifdef OCEAN_3D
#  ifdef ATM2D_MPI_ON

      CALL INITIALISE

C     Perform registration with other components
      CALL ACCEPT_COMPONENT_REGISTRATIONS

C     Coordinate the transfer configuration information
C     between components
      msgUnit = standardMessageUnit
      CALL EXCH_COMPONENT_CONFIGS(
     I                             msgUnit )
#  endif

      CALL INIT_ATM2D(dtatm, dtocn, dtcouple, myThid)
#endif

      RETURN
      END

#include "STREAMICE_OPTIONS.h"
#ifdef ALLOW_AUTODIFF
# include "AUTODIFF_OPTIONS.h"
#endif

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

CBOP
      SUBROUTINE STREAMICE_ADVECT_2DTRACER (
     &  myThid,
     &  myIter,
     &  time_step,
     &  uTrans,
     &  vTrans,
     &  bcMaskx,
     &  bcMasky)

C     *============================================================*
C     | SUBROUTINE                                                 |
C     | o                                                          |
C     *============================================================*
C     |                                                            |
C     *============================================================*
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "GRID.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "STREAMICE.h"
#include "STREAMICE_ADV.h"
#ifdef ALLOW_AUTODIFF_TAMC
# include "tamc.h"
#endif

      INTEGER myThid, myIter
      _RL time_step
      _RL uTrans(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL vTrans(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RS bcMaskx(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RS bcMasky(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
c      _RL trac(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)

#ifdef ALLOW_STREAMICE
#ifdef ALLOW_STREAMICE_2DTRACER

      INTEGER i, j, bi, bj, Gi, Gj
      _RL thick_bd
      _RL sec_per_year, time_step_loc, MR, SMB, TMB
      _RL BCVALX(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL BCVALY(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL xtracflux(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL ytracflux(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
#ifdef STREAMICE_TRACER_AB
      _RL GAD_trac_2dNm1(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
#endif
      CHARACTER*(MAX_LEN_MBUF) msgBuf

      sec_per_year = 365.*86400.

      time_step_loc = time_step / sec_per_year

      PRINT *, "time_step_loc ", time_step_loc

      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        DO j=1-3,sNy+3
         DO i=1-3,sNx+3

c          H_streamice_prev(i,j,bi,bj) =
c     &     H_streamice(i,j,bi,bj)

          ytracflux (i,j,bi,bj) = 0. _d 0
          xtracflux (i,j,bi,bj) = 0. _d 0
#ifdef STREAMICE_TRACER_AB
          GAD_trac_2dNm1(i,j,bi,bj)=GAD_trac_2d(i,j,bi,bj)
          GAD_trac_2d (i,j,bi,bj) = 0. _d 0
#endif

          IF (STREAMICE_ufacemask(i,j,bi,bj).eq.3.0) THEN
           BCVALX(i,j,bi,bj) = trac2d_ubdry_values_SI(i,j,bi,bj)
          ELSEIF (STREAMICE_ufacemask(i,j,bi,bj).eq.4.0) THEN
           BCVALX(i,j,bi,bj) = trac2d_ubdry_values_SI(i,j,bi,bj)
          ENDIF

          IF (STREAMICE_vfacemask(i,j,bi,bj).eq.3.0) THEN
           BCVALy(i,j,bi,bj) = trac2d_vbdry_values_SI(i,j,bi,bj)
          ELSEIF (STREAMICE_vfacemask(i,j,bi,bj).eq.4.0) THEN
           BCVALy(i,j,bi,bj) = trac2d_vbdry_values_SI(i,j,bi,bj)
          ENDIF

         ENDDO
        ENDDO
       ENDDO
      ENDDO

      _EXCH_XY_RL(BCVALX,myThid)
      _EXCH_XY_RL(BCVALY,myThid)

#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE trac2d  = comlev1, key=ikey_dynamics
#endif

      CALL STREAMICE_ADV_FLUX_FL_X ( myThid ,
     I   uTrans ,
     I   trac2d ,
     I   BCMASKX,
     I   BCVALX,
     O   xtracflux,
     I   time_step_loc)

      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        DO j=1-3,sNy+3
         DO i=1,sNx
          Gi = (myXGlobalLo-1)+(bi-1)*sNx+i
          Gj = (myYGlobalLo-1)+(bj-1)*sNy+j
          IF (((Gj .ge. 1) .and. (Gj .le. Ny))
     &       .or.STREAMICE_NS_PERIODIC) THEN

          IF (STREAMICE_hmask(i,j,bi,bj).eq.1.0 .or.
     &        STREAMICE_hmask(i,j,bi,bj).eq.2.0) THEN

#ifdef STREAMICE_TRACER_AB
           GAD_trac_2d(i,j,bi,bj) = GAD_trac_2d(i,j,bi,bj) -
#else
           trac2d(i,j,bi,bj) = trac2d(i,j,bi,bj) -
#endif
     &      ((xtracflux(i+1,j,bi,bj)*dyG(i+1,j,bi,bj) -
     &       xtracflux(i,j,bi,bj)*dyG(i,j,bi,bj)) *
     &        recip_rA (i,j,bi,bj) -
     &     trac2d(i,j,bi,bj) *
     &      (utrans(i+1,j,bi,bj)*dyG(i+1,j,bi,bj)-
     &       utrans(i,j,bi,bj)*dyG(i,j,bi,bj)) *
     &       recip_rA(i,j,bi,bj))
#ifndef STREAMICE_TRACER_AB
     &      * time_step_loc
#endif
          ENDIF
          ENDIF
         ENDDO
        ENDDO
       ENDDO
      ENDDO
      _EXCH_XY_RL(utrans,myThid)

#ifdef ALLOW_AUTODIFF_TAMC
# ifndef STREAMICE_TRACER_AB
CADJ STORE trac2d  = comlev1, key=ikey_dynamics
# endif
#endif

      CALL STREAMICE_ADV_FLUX_FL_Y ( myThid ,
     I   vTrans ,
     I   trac2d ,
     I   BCMASKy,
     I   BCVALy,
     O   ytracflux,
     I   time_step_loc)

      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        DO j=1,sNy
         DO i=1,sNx
          Gi = (myXGlobalLo-1)+(bi-1)*sNx+i
          Gj = (myYGlobalLo-1)+(bj-1)*sNy+j

          IF (STREAMICE_hmask(i,j,bi,bj).eq.1.0 .or.
     &        STREAMICE_hmask(i,j,bi,bj).eq.2.0) THEN
c           IF (Gi.eq.34.and.Gj.eq.94) THEN
c            print *, "GOT HERE YFLUX", ytracflux(i,j,bi,bj),
c     &        ytracflux(i,j+1,bi,bj),trac2d(i,j,bi,bj),
c     &        vtrans(i,j,bi,bj), vtrans(i,j+1,bi,bj),
c     &        bcmasky(i,j,bi,bj)
c           ENDIF

#ifdef STREAMICE_TRACER_AB
           GAD_trac_2d(i,j,bi,bj) = GAD_trac_2d(i,j,bi,bj) -
#else
           trac2d(i,j,bi,bj) = trac2d(i,j,bi,bj) -
#endif
     &      ((ytracflux(i,j+1,bi,bj)*dxG(i,j+1,bi,bj) -
     &       ytracflux(i,j,bi,bj)*dxG(i,j,bi,bj)) *
     &        recip_rA (i,j,bi,bj) -
     &      (vtrans(i,j+1,bi,bj)*dxG(i,j+1,bi,bj) -
     &       vtrans(i,j,bi,bj)*dxG(i,j,bi,bj)) *
     &     trac2d(i,j,bi,bj) *
     &       recip_rA(i,j,bi,bj))
#ifndef STREAMICE_TRACER_AB
     &       * time_step_loc
#endif
          ENDIF
         ENDDO
        ENDDO
       ENDDO
      ENDDO

#ifdef STREAMICE_TRACER_AB

      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        DO j=1,sNy
         DO i=1,sNx

          trac2d(i,j,bi,bj) = trac2d(i,j,bi,bj) + time_step_loc *
     &      GAD_trac_2d(i,j,bi,bj)

          IF (myIter.eq.0) THEN
           trac2d(i,j,bi,bj) = trac2d(i,j,bi,bj) + time_step_loc *
     &      (.5+.01) *
     &      (GAD_trac_2d(i,j,bi,bj) - GAD_trac_2dNm1(i,j,bi,bj))
          ENDIF

         ENDDO
        ENDDO
       ENDDO
      ENDDO

#endif

      _EXCH_XY_RL(trac2d, myThid)

      WRITE(msgBuf,'(A)') 'END STREAMICE_ADVECT_THICKNESS'
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                     SQUEEZE_RIGHT , 1)

#endif
#endif
      RETURN
      END

#include "CD_CODE_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: CD_CODE_WRITE_PICKUP

C     !INTERFACE:
      SUBROUTINE CD_CODE_WRITE_PICKUP(
     I                         permPickup, suff,
     I                         myTime, myIter, myThid )

C     !DESCRIPTION:
C     Read the pickup.

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "CD_CODE_VARS.h"
#ifdef ALLOW_MNC
#include "MNC_PARAMS.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     permPickup :: Is or is not a permanent pickup
C     suff    :: suffix for pickup file (eg. ckptA or 0000000010)
C     myTime  :: Current time in simulation
C     myIter  :: Current iteration number in simulation
C     myThid  :: My Thread Id number
      LOGICAL permPickup
      CHARACTER*(*) suff
      _RL     myTime
      INTEGER myIter
      INTEGER myThid
CEOP

#ifdef ALLOW_CD_CODE

C     !LOCAL VARIABLES:
      CHARACTER*(MAX_LEN_FNAM) fn
      INTEGER prec

#ifdef ALLOW_MNC
      IF (useMNC .AND. pickup_write_mnc) THEN

        IF ( permPickup ) THEN
          WRITE(fn,'(A)') 'pickup_cd'
        ELSE
          WRITE(fn,'(A,A)') 'pickup_cd.',suff
        ENDIF

C       Read variables from the pickup file
        CALL MNC_CW_SET_UDIM(fn, 1, myThid)
        IF ( permPickup ) THEN
          CALL MNC_CW_SET_CITER(fn, 3, 3, myIter, -1, myThid)
        ELSE
          CALL MNC_CW_SET_CITER(fn, 2, -1, -1, -1, myThid)
        ENDIF
        CALL MNC_CW_SET_UDIM(fn, 1, myThid)
        CALL MNC_CW_RL_W('D',fn,0,0,'uVelD',uVelD, myThid)
        CALL MNC_CW_RL_W('D',fn,0,0,'vVelD',vVelD, myThid)
        CALL MNC_CW_RL_W('D',fn,0,0,'Unm1',Unm1, myThid)
        CALL MNC_CW_RL_W('D',fn,0,0,'Vnm1',Vnm1, myThid)
        CALL MNC_CW_RL_W('D',fn,0,0,'etaNm1', etaNm1, myThid)
        CALL MNC_FILE_CLOSE_ALL_MATCHING(fn, myThid)
      ENDIF
#endif /*  ALLOW_MNC  */

      IF (pickup_write_mdsio) THEN

        prec = precFloat64
        WRITE(fn,'(A,A)') 'pickup_cd.',suff

        CALL WRITE_REC_3D_RL( fn, prec, Nr, uVelD, 1, myIter, myThid )
        CALL WRITE_REC_3D_RL( fn, prec, Nr, vVelD, 2, myIter, myThid )
        CALL WRITE_REC_3D_RL( fn, prec, Nr, uNM1,  3, myIter, myThid )
        CALL WRITE_REC_3D_RL( fn, prec, Nr, vNM1,  4, myIter, myThid )
        CALL WRITE_REC_3D_RL( fn, prec, 1,etaNm1,4*Nr+1,myIter,myThid)
      ENDIF

#endif /*  ALLOW_CD_CODE  */

      RETURN
      END

#include "SEAICE_OPTIONS.h"

CBOP
C     !ROUTINE: SEAICE_DIAGNOSTICS_STATE
C     !INTERFACE:
      SUBROUTINE SEAICE_DIAGNOSTICS_STATE(
     I                      myTime, myIter, myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R  SEAICE_DIAGNOSTICS_STATE
C     | o fill-in diagnostics array for SEAICE state variables
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "SEAICE_SIZE.h"
#include "SEAICE_PARAMS.h"
#include "SEAICE.h"
#include "SEAICE_TRACER.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine Arguments ==
C     myTime  :: time counter for this thread
C     myIter  :: iteration counter for this thread
C     myThid  :: thread number for this instance of the routine.
      _RL  myTime
      INTEGER myIter
      INTEGER myThid
CEOP

#ifdef ALLOW_DIAGNOSTICS
C     == Local variables ==
C     bi,bj   :: tile indices
      INTEGER i,j,bi,bj
      _RL tIce (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      INTEGER k
      _RL recip_multDim
      _RL tmp
#ifdef ALLOW_SITRACER
      INTEGER iTracer
      CHARACTER*8   diagName
#endif

      LOGICAL  DIAGNOSTICS_IS_ON
      EXTERNAL DIAGNOSTICS_IS_ON

      IF ( useDiagnostics ) THEN
       CALL DIAGNOSTICS_FILL( AREA, 'SIarea  ', 0, 1, 0, 1,1, myThid )
       CALL DIAGNOSTICS_FILL( HEFF, 'SIheff  ', 0, 1, 0, 1,1, myThid )
       CALL DIAGNOSTICS_FILL( UICE, 'SIuice  ', 0, 1, 0, 1,1, myThid )
       CALL DIAGNOSTICS_FILL( VICE, 'SIvice  ', 0, 1, 0, 1,1, myThid )

       IF ( DIAGNOSTICS_IS_ON('SItices ',myThid) ) THEN
        DO bj = myByLo(myThid), myByHi(myThid)
         DO bi = myBxLo(myThid), myBxHi(myThid)
C     use tIce as a temporary field, as it is done in seaice_growth
          DO j=1,sNy
           DO i=1,sNx
            tIce(i,j,bi,bj) = 0. _d 0
           ENDDO
          ENDDO
C     division by zero is not possible
          recip_multDim = 1. _d 0/SEAICE_multDim
          DO k=1,SEAICE_multDim
           DO j=1,sNy
            DO i=1,sNx
             tmp = 1. _d 0
#ifdef SEAICE_ITD
             IF (AREA(i,j,bi,bj) .GT. ZERO)
     &            tmp=AREAITD(i,j,K,bi,bj)/AREA(i,j,bi,bj)
#endif /* SEAICE_ITD */
             tIce(i,j,bi,bj) = tIce(i,j,bi,bj)
     &            + TICES(i,j,K,bi,bj)*tmp*recip_multDim
            ENDDO
           ENDDO
          ENDDO
         ENDDO
        ENDDO
        CALL DIAGNOSTICS_FRACT_FILL(
     I                   tIce, AREA, 1. _d 0, 1, 'SItices ',
     I                   0, 1, 0, 1, 1, myThid )
       ENDIF

       CALL DIAGNOSTICS_FILL(HSNOW  ,'SIhsnow ',0,1 ,0,1,1,myThid)

#ifdef SEAICE_ITD
       CALL DIAGNOSTICS_FILL(HEFFITD ,'SIheffN ',0,nITD ,0,1,1,myThid)
       CALL DIAGNOSTICS_FILL(AREAITD ,'SIareaN ',0,nITD ,0,1,1,myThid)
       CALL DIAGNOSTICS_FILL(HSNOWITD,'SIhsnowN',0,nITD ,0,1,1,myThid)
#endif

#ifdef ALLOW_SITRACER
       DO iTracer = 1, SItrNumInUse
        WRITE(diagName,'(A4,I2.2,A2)') 'SItr',iTracer,'  '
        IF (SItrMate(iTracer).EQ.'HEFF') THEN
         CALL DIAGNOSTICS_FRACT_FILL(
     I        SItracer(1-OLx,1-OLy,1,1,iTracer), HEFF,
     I        ONE, 1, diagName, 0, 1, 0, 1, 1, myThid )
        ELSE
         CALL DIAGNOSTICS_FRACT_FILL(
     I        SItracer(1-OLx,1-OLy,1,1,iTracer), AREA,
     I        ONE, 1, diagName, 0, 1, 0, 1, 1, myThid )
        ENDIF
       ENDDO
#endif
#ifdef SEAICE_VARIABLE_SALINITY
       CALL DIAGNOSTICS_FILL(HSALT  ,'SIhsalt ',0,1 ,0,1,1,myThid)
#endif
C
       IF ( DIAGNOSTICS_IS_ON('SIuheff ',myThid) ) THEN
        DO bj = myByLo(myThid), myByHi(myThid)
         DO bi = myBxLo(myThid), myBxHi(myThid)
          DO j = 1,sNy
           DO i = 1,sNx+1
            tIce(i,j,bi,bj) =
#ifdef SEAICE_CGRID
     &           UICE(i,j,bi,bj)
#else
C     average B-grid velocities to C-grid points
     &           0.5 _d 0*(UICE(i,j,bi,bj)+UICE(i,j+1,bi,bj))
#endif /* SEAICE_CGRID */
     &           *0.5 _d 0*(HEFF(i,j,bi,bj)+HEFF(i-1,j,bi,bj))
           ENDDO
          ENDDO
         ENDDO
        ENDDO
        CALL DIAGNOSTICS_FILL(tIce,'SIuheff ',0,1,0,1,1,myThid)
       ENDIF
       IF ( DIAGNOSTICS_IS_ON('SIvheff ',myThid) ) THEN
        DO bj = myByLo(myThid), myByHi(myThid)
         DO bi = myBxLo(myThid), myBxHi(myThid)
          DO j = 1,sNy+1
           DO i = 1,sNx
            tIce(i,j,bi,bj) =
#ifdef SEAICE_CGRID
     &           VICE(i,j,bi,bj)
#else
C     average B-grid velocities to C-grid points
     &           0.5 _d 0*(VICE(i,j,bi,bj)+VICE(i+1,j,bi,bj))
#endif /* SEAICE_CGRID */
     &           *0.5 _d 0*(HEFF(i,j,bi,bj)+HEFF(i,j-1,bi,bj))
           ENDDO
          ENDDO
         ENDDO
        ENDDO
        CALL DIAGNOSTICS_FILL(tIce,'SIvheff ',0,1,0,1,1,myThid)
       ENDIF
C
C     endif useDiagnostics
      ENDIF

#endif /* ALLOW_DIAGNOSTICS */

      RETURN
      END

#include "STREAMICE_OPTIONS.h"

      subroutine template()
      use OAD_cp
      use OAD_tape
      use OAD_rev

!$TEMPLATE_PRAGMA_DECLARATIONS

      integer myi
! Temporaries to hold the stack pointers
      integer temp_double_tape_pointer, temp_integer_tape_pointer, temp_logical_tape_pointer, temp_character_tape_pointer, temp_string_tape_pointer
      type(modeType) :: our_orig_mode

      integer iaddr
      external iaddr
!<------------------Begin user declarations ---------------------->!
! Insert declarations of dummy variables for calling adjoint computation
! without side effects, and storing adjoint variable iterates

      real*8 adj_fp_err_change

#ifdef ALLOW_STREAMICE_FP_ADJ

#ifdef STREAMICE_ALLOW_FRIC_CONTROL
      Real*8 C_basal_dummy_d (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
#endif
#ifdef STREAMICE_ALLOW_BGLEN_CONTROL
      Real*8 B_glen_dummy_d (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
#endif
#ifdef STREAMICE_ALLOW_DEPTH_CONTROL
      Real*8 R_low_si_dummy_d (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
#endif
      Real*8 H_streamice_dummy_d (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      Real*8 taudx_dummy_d (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      Real*8 taudy_dummy_d (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      Real*8 u_dummy_d (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      Real*8 v_dummy_d (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      Real*8 u_new_dummy_d (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      Real*8 v_new_dummy_d (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
#ifdef STREAMICE_HYBRID_STRESS
      Real*8 taubx_dummy_d (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      Real*8 tauby_dummy_d (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      Real*8 visc_full_dummy_d (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      Real*8 taubx_new_dummy (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      Real*8 tauby_new_dummy (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      Real*8 visc_new_dummy (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
#endif

!<------------------End user declarations ------------------------>!
      if (our_rev_mode%plain) then
      our_orig_mode=our_rev_mode
      IF(ISINLOOP .eq. 0) THEN
        CONVERGED = .FALSE.
        ADJ_CONVERGED = .FALSE.
        !ERR_LAST_CHANGE = 10.
      end if
      IF(ISINLOOP .ne. 0) THEN
        IF(.NOT. CONVERGED) THEN
          NL_ITER = (NL_ITER + 1)
          CALL OpenAD_streamice_vel_phi(MYTHID,MAXNLITER,MAXCGITER,CGTOL
     +,CG_ITERS,err_max)

          WRITE(MSGBUF,'(A,I5,A,I4,A)') 'streamice linear solve number',
     +NL_ITER,' ',CG_ITERS,' iterations '

          CALL print_message(MSGBUF,STANDARDMESSAGEUNIT,'R',1)

!!!!!!!!!!!! conv check

          if (STREAMICE_chkresidconvergence) then

           WRITE(msgBuf,'(A,E15.7)') 'err/err_init',
     &                       err_max/err_init
           CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT , 1)

           IF (err_max .LE. streamice_nonlin_tol * err_init) THEN
            CONVERGED = .true.
           ENDIF

           IF (err_max<err_last_change*1.e-2 .and.
     &      STREAMICE_lower_cg_tol) THEN
            cgtol = cgtol * 5.e-2
            err_last_change = err_max
            WRITE(msgBuf,'(A,E15.7)') 'new cg tol: ',
     &                       cgtol
            CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT , 1)
           ENDIF

          endif

          if (STREAMICE_chkfixedptconvergence) then

           CALL openad_STREAMICE_GET_FP_ERR_OAD ( err_max_fp, myThid )

           WRITE(msgBuf,'(A,1PE22.14)') 'STREAMICE_FP_ERROR =',
     &                       err_max_fp
           CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT , 1)

           IF (err_max_fp .LE. streamice_nonlin_tol_fp) THEN
            CONVERGED = .true.
           ENDIF

          endif

          DO bj = myByLo(myThid), myByHi(myThid)
           DO bi = myBxLo(myThid), myBxHi(myThid)
            DO j=1-OLy,sNy+OLy
             DO i=1-OLx,sNx+OLx
              U_streamice (i,j,bi,bj)=u_new_SI (i,j,bi,bj)
              V_streamice (i,j,bi,bj)=v_new_SI (i,j,bi,bj)
#ifdef STREAMICE_HYBRID_STRESS
              streamice_taubx(i,j,bi,bj)=taubx_new_si(i,j,bi,bj)
              streamice_tauby(i,j,bi,bj)=tauby_new_si(i,j,bi,bj)
              DO m=Nr,1,-1
               visc_streamice_full(i,j,m,bi,bj)=
     &          visc_full_new_si(i,j,m,bi,bj)
              ENDDO
#endif
             ENDDO
            ENDDO
           ENDDO
          ENDDO

!!!!!!!!!!!! end conv check

        end if
      end if

      our_rev_mode=our_orig_mode
      end if

!!!!!!!!!!!! TAPE MODE !!!!!!!!!!!!!!

      if (our_rev_mode%tape) then
      our_orig_mode=our_rev_mode
      if(isinloop.eq.0) then
        CONVERGED = .false.
        nl_iter = 0
      end if

      if(isinloop.eq.1) then

        CALL TIMER_START('STREAMICE TAPE FIXED POINT LOOP',myThid)

        IF (.not. (CONVERGED).AND. nl_iter.lt.MAXNLITER) THEN
          NL_ITER = (NL_ITER+1)
          !Run in plain mode while not converged
          our_rev_mode%plain=.true.
          our_rev_mode%tape=.false.
          our_rev_mode%adjoint=.false.
          CALL OpenAD_streamice_vel_phi(MYTHID,MAXNLITER,MAXCGITER,CGTOL
     +,CG_ITERS,err_max)

!---- write out number of cg iters

          WRITE(MSGBUF,'(A,I5,A,I4,A)') 'streamice linear solve number',
     +NL_ITER,' ',CG_ITERS,' iterations '
!          OAD_CTMP0 = 1
          CALL print_message(MSGBUF,STANDARDMESSAGEUNIT,'R',1)

!---- conv check

          if (STREAMICE_chkresidconvergence) then

           WRITE(msgBuf,'(A,E15.7)') 'err/err_init',
     &                       err_max/err_init
           CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT , 1)

           IF (err_max .LE. streamice_nonlin_tol * err_init) THEN
            CONVERGED = .true.
           ENDIF

           IF (err_max<err_last_change*1.e-2 .and.
     &      STREAMICE_lower_cg_tol) THEN
            cgtol = cgtol * 5.e-2
            err_last_change = err_max
            WRITE(msgBuf,'(A,E15.7)') 'new cg tol: ',
     &                       cgtol
            CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT , 1)
           ENDIF

          endif

          if (STREAMICE_chkfixedptconvergence) then

           CALL openad_STREAMICE_GET_FP_ERR_OAD ( err_max_fp, myThid )

           WRITE(msgBuf,'(A,1PE22.14)') 'STREAMICE_FP_ERROR =',
     &                       err_max_fp
           CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT , 1)

           IF (err_max_fp .LE. streamice_nonlin_tol_fp) THEN
            CONVERGED = .true.
           ENDIF

          endif

          DO bj = myByLo(myThid), myByHi(myThid)
            DO bi = myBxLo(myThid), myBxHi(myThid)
              DO j=1-OLy,sNy+OLy
                DO i=1-OLx,sNx+OLx
                  U_streamice (i,j,bi,bj)%v=u_new_SI (i,j,bi,bj)%v
                  V_streamice (i,j,bi,bj)%v=v_new_SI (i,j,bi,bj)%v
#ifdef STREAMICE_HYBRID_STRESS
                  streamice_taubx(i,j,bi,bj)%v=
     &             taubx_new_si(i,j,bi,bj)%v
                  streamice_tauby(i,j,bi,bj)%v=
     &             tauby_new_si(i,j,bi,bj)%v
                  DO m=Nr,1,-1
                   visc_streamice_full(i,j,m,bi,bj)%v=
     &              visc_full_new_si(i,j,m,bi,bj)%v
                  ENDDO
#endif
                ENDDO
              ENDDO
            ENDDO
          ENDDO

!--------conv check done

          if (converged .OR. nl_iter.eq.MAXNLITER) then
            !Run once in tape mode if this is the last time
            our_rev_mode%plain=.false.
            our_rev_mode%tape=.true.
            our_rev_mode%adjoint=.false.
            CALL OpenAD_streamice_vel_phi(MYTHID,MAXNLITER,MAXCGITER,CG
     +TOL,CG_ITERS,err_max)
          end if
        end if
        CALL TIMER_STOP('STREAMICE TAPE FIXED POINT LOOP',myThid)
      end if
      if(isinloop.eq.2 ) then

        CALL OpenAD_streamice_vel_phi(MYTHID,MAXNLITER,MAXCGITER,CGTOL
     +,CG_ITERS,err_max)

        DO bj = myByLo(myThid), myByHi(myThid)
          DO bi = myBxLo(myThid), myBxHi(myThid)
            DO j=1-OLy,sNy+OLy
              DO i=1-OLx,sNx+OLx
                U_streamice (i,j,bi,bj)%v=u_new_SI (i,j,bi,bj)%v
                V_streamice (i,j,bi,bj)%v=v_new_SI (i,j,bi,bj)%v
#ifdef STREAMICE_HYBRID_STRESS
                  streamice_taubx(i,j,bi,bj)%v=
     &             taubx_new_si(i,j,bi,bj)%v
                  streamice_tauby(i,j,bi,bj)%v=
     &             tauby_new_si(i,j,bi,bj)%v
                  DO m=Nr,1,-1
                   visc_streamice_full(i,j,m,bi,bj)%v=
     &              visc_full_new_si(i,j,m,bi,bj)%v
                  ENDDO
#endif
              ENDDO
            ENDDO
          ENDDO
        ENDDO
      end if
      our_rev_mode=our_orig_mode
      end if

!!!!!!!!!!!! ADJOINT MODE !!!!!!!!!!!!!!

      if (our_rev_mode%adjoint) then
      our_orig_mode=our_rev_mode

      if(isinloop.eq.2) then

        ADJ_CONVERGED = .false.
        adj_iter = 0

        DO bj = myByLo(myThid), myByHi(myThid)
          DO bi = myBxLo(myThid), myBxHi(myThid)
            DO j=1-OLy,sNy+OLy
              DO i=1-OLx,sNx+OLx
                v_new_SI (i,j,bi,bj)%d= V_streamice(i,j,bi,bj)%d
                V_streamice  (i,j,bi,bj)%d = 0.0
                u_new_SI (i,j,bi,bj)%d= U_streamice(i,j,bi,bj)%d
                U_streamice  (i,j,bi,bj)%d = 0.0
#ifdef STREAMICE_HYBRID_STRESS
                taubx_new_si(i,j,bi,bj)%d=
     &           streamice_taubx(i,j,bi,bj)%d
                streamice_taubx(i,j,bi,bj)%d = 0.0
                tauby_new_si(i,j,bi,bj)%d=
     &           streamice_tauby(i,j,bi,bj)%d
                streamice_tauby(i,j,bi,bj)%d = 0.0
                DO m=Nr,1,-1
                 visc_full_new_si(i,j,m,bi,bj)%d=
     &            visc_streamice_full(i,j,m,bi,bj)%d
                 visc_streamice_full(i,j,m,bi,bj)%d = 0.0
                ENDDO
#endif
              ENDDO
            ENDDO
          ENDDO
        ENDDO

        CALL OpenAD_streamice_vel_phi(MYTHID,MAXNLITER,MAXCGITER,CGTOL
     +,CG_ITERS,err_max)

        DO BJ = MYBYLO(MYTHID), MYBYHI(MYTHID), 1
          DO BI = MYBXLO(MYTHID), MYBXHI(MYTHID), 1
            DO J = 1-OLy,sNy+OLy
              DO I = 1-OLx,sNx+OLx

                U_streamice_dvals(I,J,BI,BJ) =
     +U_STREAMICE(INT(I),INT(J),INT(BI),INT(BJ))%d
                V_streamice_dvals(I,J,BI,BJ) =
     +V_STREAMICE(INT(I),INT(J),INT(BI),INT(BJ))%d
#ifdef STREAMICE_HYBRID_STRESS
                taubx_dvals(I,J,BI,BJ) =
     +streamice_taubx(INT(I),INT(J),INT(BI),INT(BJ))%d
                tauby_dvals(I,J,BI,BJ) =
     +streamice_tauby(INT(I),INT(J),INT(BI),INT(BJ))%d
                DO m=Nr,1,-1
                visc_full_dvals(I,J,m,BI,BJ) =
     +VISC_STREAMICE_FULL(INT(I),INT(J),m,INT(BI),INT(BJ))%d
                ENDDO
#endif

                U_new_si(I,J,BI,BJ)%d =
     +U_STREAMICE(INT(I),INT(J),INT(BI),INT(BJ))%d
                V_new_si(I,J,BI,BJ)%d =
     +V_STREAMICE(INT(I),INT(J),INT(BI),INT(BJ))%d
#ifdef STREAMICE_HYBRID_STRESS
                taubx_new_si(I,J,BI,BJ)%d =
     +streamice_taubx(INT(I),INT(J),INT(BI),INT(BJ))%d
                tauby_new_si(I,J,BI,BJ)%d =
     +streamice_tauby(INT(I),INT(J),INT(BI),INT(BJ))%d
                DO m=Nr,1,-1
                visc_full_new_si(I,J,m,BI,BJ)%d =
     +VISC_STREAMICE_FULL(INT(I),INT(J),m,INT(BI),INT(BJ))%d
                ENDDO
#endif

              END DO
            END DO
          END DO
        END DO

      end if

      if(isinloop.eq.1) then
        if((.NOT.ADJ_CONVERGED).AND.(adj_iter.lt.MAXNLITER)) then

          adj_iter = adj_iter + 1
          if (adj_iter.eq.1) then
           CALL TIMER_START('STREAMICE ADJ FIXED POINT LOOP0',myThid)
          else
           CALL TIMER_START('STREAMICE ADJ FIXED POINT LOOP',myThid)
          endif

          DO BJ = MYBYLO(MYTHID), MYBYHI(MYTHID), 1
            DO BI = MYBXLO(MYTHID), MYBXHI(MYTHID), 1
              DO J = 1-OLy,sNy+OLy
                DO I = 1-OLx,sNx+OLx

                  U_DUMMY_D(INT(I),INT(J),INT(BI),INT(BJ)) =
     +U_streamice(INT(I),INT(J),INT(BI),INT(BJ))%d
                  V_DUMMY_D(INT(I),INT(J),INT(BI),INT(BJ)) =
     +V_streamice(INT(I),INT(J),INT(BI),INT(BJ))%d
#ifdef STREAMICE_HYBRID_STRESS
                  TAUBX_DUMMY_D(INT(I),INT(J),INT(BI),INT(BJ)) =
     +streamice_taubx(INT(I),INT(J),INT(BI),INT(BJ))%d
                  TAUBY_DUMMY_D(INT(I),INT(J),INT(BI),INT(BJ)) =
     +streamice_tauby(INT(I),INT(J),INT(BI),INT(BJ))%d
                  DO m=Nr,1,-1
                   VISC_FULL_DUMMY_D(INT(I),INT(J),m,INT(BI),INT(BJ))=
     +VISC_STREAMICE_FULL(INT(I),INT(J),m,INT(BI),INT(BJ))%d
                  ENDDO
#endif

                  U_NEW_DUMMY_D(INT(I),INT(J),INT(BI),INT(BJ)) =
     +U_NEW_SI(INT(I),INT(J),INT(BI),INT(BJ))%d
                  V_NEW_DUMMY_D(INT(I),INT(J),INT(BI),INT(BJ)) =
     +V_NEW_SI(INT(I),INT(J),INT(BI),INT(BJ))%d
#ifdef STREAMICE_HYBRID_STRESS
                  TAUBX_new_DUMMY(INT(I),INT(J),INT(BI),INT(BJ)) =
     +TAUBX_new_si(INT(I),INT(J),INT(BI),INT(BJ))%d
                  TAUBY_new_DUMMY(INT(I),INT(J),INT(BI),INT(BJ)) =
     +TAUBY_new_si(INT(I),INT(J),INT(BI),INT(BJ))%d
                  DO m=Nr,1,-1
                   VISC_new_DUMMY(INT(I),INT(J),m,INT(BI),INT(BJ))=
     +visc_full_new_si(INT(I),INT(J),m,INT(BI),INT(BJ))%d
                  ENDDO
#endif

                  U_STREAMICE(INT(I),INT(J),INT(BI),INT(BJ))%d =
     +U_streamice_dvals(I,J,BI,BJ)
                  V_STREAMICE(INT(I),INT(J),INT(BI),INT(BJ))%d =
     +V_STREAMICE_dvals(I,J,BI,BJ)
#ifdef STREAMICE_HYBRID_STRESS
                  streamice_taubx(INT(I),INT(J),INT(BI),INT(BJ))%d =
     +taubx_dvals(I,J,BI,BJ)
                  streamice_tauby(INT(I),INT(J),INT(BI),INT(BJ))%d =
     +tauby_dvals(I,J,BI,BJ)
                  DO m=Nr,1,-1
              VISC_STREAMICE_FULL(INT(I),INT(J),m,INT(BI),INT(BJ))%d
     +=visc_full_dvals(I,J,m,BI,BJ)
                  ENDDO
#endif

#ifdef STREAMICE_ALLOW_FRIC_CONTROL
                  C_basal_dummy_d(INT(I),INT(J),INT(BI),INT(BJ)) =
     +C_basal_friction(INT(I),INT(J),INT(BI),INT(BJ))%d
#endif
#ifdef STREAMICE_ALLOW_BGLEN_CONTROL
                  b_glen_dummy_d(INT(I),INT(J),INT(BI),INT(BJ)) =
     +B_glen(INT(I),INT(J),INT(BI),INT(BJ))%d
#endif
#ifdef STREAMICE_ALLOW_DEPTH_CONTROL
                  R_low_si_dummy_d(INT(I),INT(J),INT(BI),INT(BJ)) =
     +R_low_si(INT(I),INT(J),INT(BI),INT(BJ))%d
#endif
                  H_streamice_dummy_d(INT(I),INT(J),INT(BI),INT(BJ)) =
     +H_streamice(INT(I),INT(J),INT(BI),INT(BJ))%d
                  taudx_dummy_d(INT(I),INT(J),INT(BI),INT(BJ)) =
     +taudx_si(INT(I),INT(J),INT(BI),INT(BJ))%d
                  taudy_dummy_d(INT(I),INT(J),INT(BI),INT(BJ)) =
     +taudy_si(INT(I),INT(J),INT(BI),INT(BJ))%d

                END DO
              END DO
            END DO
          END DO

          !Store the stack pointers
          temp_double_tape_pointer = oad_dt_ptr
          temp_integer_tape_pointer = oad_it_ptr
          temp_logical_tape_pointer = oad_lt_ptr
          temp_string_tape_pointer = oad_st_ptr

#ifdef ALLOW_PETSC
          IF (STREAMICE_OAD_petsc_reuse) then
           if (adj_iter.eq.1) then
            STREAMICE_need2createmat=.true.
            STREAMICE_need2destroymat=.false.
            PETSC_PRECOND_TMP = PETSC_PRECOND_TYPE
            PETSC_PRECOND_TYPE = PETSC_PRECOND_OAD
           else
            STREAMICE_need2createmat=.false.
            STREAMICE_need2destroymat=.false.
           endif
          ENDIF
#endif

          CALL OpenAD_streamice_vel_phi(MYTHID,MAXNLITER,MAXCGITER,CGTOL
     +,CG_ITERS,err_max)

#ifdef ALLOW_PETSC
          IF (STREAMICE_OAD_petsc_reuse) then
           if (adj_iter.eq.MAXNLITER) then
            STREAMICE_need2createmat=.true.
            STREAMICE_need2destroymat=.true.
            CALL streamice_petscmatdestroy()
            PETSC_PRECOND_TYPE = PETSC_PRECOND_TMP
           endif
          ENDIF
#endif

          DO BJ = MYBYLO(MYTHID), MYBYHI(MYTHID), 1
            DO BI = MYBXLO(MYTHID), MYBXHI(MYTHID), 1
              DO J = 1-OLy,sNy+OLy
                DO I = 1-OLx,sNx+OLx

                  U_NEW_SI(INT(I),INT(J),INT(BI),INT(BJ))%d =
     +U_NEW_DUMMY_D(INT(I),INT(J),INT(BI),INT(BJ))
                  V_NEW_SI(INT(I),INT(J),INT(BI),INT(BJ))%d =
     +V_NEW_DUMMY_D(INT(I),INT(J),INT(BI),INT(BJ))
#ifdef STREAMICE_HYBRID_STRESS
                  TAUBX_new_si(INT(I),INT(J),INT(BI),INT(BJ))%d =
     +TAUBX_new_DUMMY(INT(I),INT(J),INT(BI),INT(BJ))
                  TAUBY_new_si(INT(I),INT(J),INT(BI),INT(BJ))%d =
     +TAUBY_new_DUMMY(INT(I),INT(J),INT(BI),INT(BJ))
                  DO m=Nr,1,-1
                   visc_full_new_si(INT(I),INT(J),m,INT(BI),INT(BJ))%d=
     +VISC_new_DUMMY(INT(I),INT(J),m,INT(BI),INT(BJ))
                  ENDDO
#endif

                END DO
              END DO
            END DO
          END DO

!---- write out number of cg iters

          WRITE(MSGBUF,'(A,I5)') 'streamice adjoint solve number'
     +,ADJ_ITER
!          OAD_CTMP0 = 1
          CALL print_message(MSGBUF,STANDARDMESSAGEUNIT,'R',1)

!---- end write out number of cg iters

!---- conv check

          if (STREAMICE_chkfixedptconvergence) then

           CALL openad_STREAMICE_GET_FP_ERR_OAD ( err_max_fp, myThid )

           WRITE(msgBuf,'(A,1PE22.14)') 'STREAMICE_FP_ADJ_ERROR =',
     &                       err_max_fp
           CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT , 1)

           IF(adj_iter.eq.1) then
            err_init = err_max_fp
           ELSE
            IF (err_max_fp .LE.
     &             streamice_nonlin_tol_adjoint_rl*err_init) THEN
             ADJ_CONVERGED = .true.
            ELSEIF (err_max_fp .LE.
     &             streamice_nonlin_tol_adjoint) THEN
             ADJ_CONVERGED = .true.
            ELSEIF (err_max_fp > err_last_change) THEN
             ADJ_CONVERGED = .true.
             WRITE(msgBuf,'(A)') 'STOP: ADJOINT FP ERROR INCREASING'
             CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT , 1)
            ENDIF
#ifdef ALLOW_PETSC
            IF (STREAMICE_OAD_petsc_reuse.AND.ADJ_CONVERGED) THEN
              STREAMICE_need2createmat=.true.
              STREAMICE_need2destroymat=.true.
              CALL streamice_petscmatdestroy()
              PETSC_PRECOND_TYPE = PETSC_PRECOND_TMP
            ENDIF
#endif

           ENDIF

           err_last_change = err_max_fp

          endif

!--------conv check done

          DO BJ = MYBYLO(MYTHID), MYBYHI(MYTHID), 1
            DO BI = MYBXLO(MYTHID), MYBXHI(MYTHID), 1
              DO J = 1-OLy,sNy+OLy
                DO I = 1-OLx,sNx+OLx

                  U_NEW_SI(INT(I),INT(J),INT(BI),INT(BJ))%d = U_STREAMICE(
     +I,J,BI,BJ)%d
                  V_NEW_SI(INT(I),INT(J),INT(BI),INT(BJ))%d = V_STREAMICE(
     +I,J,BI,BJ)%d
#ifdef STREAMICE_HYBRID_STRESS
                  TAUBX_NEW_SI(INT(I),INT(J),INT(BI),INT(BJ))%d = STREAMIC
     +E_TAUBX(I,J,BI,BJ)%d
                  TAUBY_NEW_SI(INT(I),INT(J),INT(BI),INT(BJ))%d = STREAMIC
     +E_TAUBY(I,J,BI,BJ)%d
                  DO m=Nr,1,-1
                  VISC_FULL_NEW_SI(INT(I),INT(J),m,INT(BI),INT(BJ))%d =
     +VISC_STREAMICE_FULL(I,J,m,BI,BJ)%d
                  ENDDO
#endif

                  U_streamice(INT(I),INT(J),INT(BI),INT(BJ))%d =
     +U_dummy_d(INT(I),INT(J),INT(BI),INT(BJ))
                  V_streamice(INT(I),INT(J),INT(BI),INT(BJ))%d =
     +V_dummy_d(INT(I),INT(J),INT(BI),INT(BJ))
#ifdef STREAMICE_HYBRID_STRESS
                  streamice_taubx(INT(I),INT(J),INT(BI),INT(BJ))%d =
     +taubx_dummy_d(INT(I),INT(J),INT(BI),INT(BJ))
                  streamice_tauby(INT(I),INT(J),INT(BI),INT(BJ))%d =
     +tauby_dummy_d(INT(I),INT(J),INT(BI),INT(BJ))
                  DO m=Nr,1,-1
                  visc_streamice_full(I,J,m,BI,BJ)%d =
     +visc_full_dummy_d(I,J,m,BI,BJ)
                  ENDDO
#endif

#ifdef STREAMICE_ALLOW_FRIC_CONTROL
                  C_basal_friction(INT(I),INT(J),INT(BI),INT(BJ))%d =
     +C_basal_dummy_d(INT(I),INT(J),INT(BI),INT(BJ))
#endif
#ifdef STREAMICE_ALLOW_BGLEN_CONTROL
                  b_glen(INT(I),INT(J),INT(BI),INT(BJ))%d =
     +B_glen_dummy_d(INT(I),INT(J),INT(BI),INT(BJ))
#endif
#ifdef STREAMICE_ALLOW_DEPTH_CONTROL
                  R_low_si(INT(I),INT(J),INT(BI),INT(BJ))%d =
     +R_low_si_dummy_d(INT(I),INT(J),INT(BI),INT(BJ))
#endif
                  H_streamice(INT(I),INT(J),INT(BI),INT(BJ))%d =
     +H_streamice_dummy_d(INT(I),INT(J),INT(BI),INT(BJ))
                  taudx_si(INT(I),INT(J),INT(BI),INT(BJ))%d =
     +taudx_dummy_d(INT(I),INT(J),INT(BI),INT(BJ))
                  taudy_si(INT(I),INT(J),INT(BI),INT(BJ))%d =
     +taudy_dummy_d(INT(I),INT(J),INT(BI),INT(BJ))

                END DO
              END DO
            END DO
          END DO

          oad_dt_ptr = temp_double_tape_pointer
          oad_it_ptr = temp_integer_tape_pointer
          oad_lt_ptr = temp_logical_tape_pointer
          oad_st_ptr = temp_string_tape_pointer

          if (adj_iter.eq.1) then
           CALL TIMER_STOP('STREAMICE ADJ FIXED POINT LOOP0',myThid)
          else
           CALL TIMER_STOP('STREAMICE ADJ FIXED POINT LOOP',myThid)
          endif
        end if
      end if

      if(isinloop.eq.0) then

          CALL OpenAD_streamice_vel_phi(MYTHID,MAXNLITER,MAXCGITER,CGTOL
     +,CG_ITERS,err_max)

          DO BJ = MYBYLO(MYTHID), MYBYHI(MYTHID), 1
            DO BI = MYBXLO(MYTHID), MYBXHI(MYTHID), 1
              DO J = 1-OLy,sNy+OLy
                DO I = 1-OLx,sNx+OLx

                  U_streamice(INT(I),INT(J),INT(BI),INT(BJ))%d = 0. _d 0
                  V_streamice(INT(I),INT(J),INT(BI),INT(BJ))%d = 0. _d 0
#ifdef STREAMICE_HYBRID_STRESS
              streamice_taubx(INT(I),INT(J),INT(BI),INT(BJ))%d = 0. _d 0
              streamice_tauby(INT(I),INT(J),INT(BI),INT(BJ))%d = 0. _d 0
                  DO m=Nr,1,-1
        visc_streamice_full(INT(I),INT(J),m,INT(BI),INT(BJ))%d = 0. _d 0
                  ENDDO
#endif

                END DO
              END DO
            END DO
          END DO

      end if

      our_rev_mode=our_orig_mode
      end if

#endif

      end subroutine template

#include "AIM_OPTIONS.h"
#ifdef ALLOW_LAND
#include "LAND_OPTIONS.h"
#endif

CBOP
C     !ROUTINE: AIM_LAND_IMPL
C     !INTERFACE:
      SUBROUTINE AIM_LAND_IMPL(
     I               FMASK, dTskin,
     I               Shf0, dShf, Evp0, dEvp, Slr0, dSlr,
     U               sFlx,
     U               Tsurf, SHF, EVAP, SLRU,
     O               dTsurf,
     I               bi, bj, myTime, myIter, myThid)

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R AIM_LAND_IMPL
C     | o AIM Interface to the implicit part of the land model
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     == Global variables ===
C-- size for MITgcm & Physics package :
#include "AIM_SIZE.h" 

#include "EEPARAMS.h"
#include "PARAMS.h"

#include "AIM_FFIELDS.h"
#include "com_physcon.h"
c #include "com_physvar.h"

#ifdef ALLOW_LAND
#include "LAND_SIZE.h" 
#include "LAND_PARAMS.h"
#include "LAND_VARS.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     FMASK    :: land fraction [0-1]
C     dTskin   :: temp. correction for daily-cycle heating [K]
C     Shf0     :: sensible heat flux over freezing surf.
C     dShf     :: sensible heat flux derivative relative to surf. temp
C     Evp0     :: evaporation computed over freezing surface (Ts=0.oC)
C     dEvp     :: evaporation derivative relative to surf. temp
C     Slr0     :: upward long wave radiation over freezing surf.
C     dSlr     :: upward long wave derivative relative to surf. temp
C     sFlx     :: net surface flux (+=down) function of surf. temp Ts:
C                 0: Flux(Ts=0.oC) ; 1: Flux(Ts^n) ; 2: d.Flux/d.Ts(Ts^n)
C     Tsurf    :: surface temperature        (2-dim)
C     SHF      :: sensible heat flux              (2-dim)
C     EVAP     :: evaporation [g/(m^2 s)]         (2-dim)
C     SLRU     :: sfc lw radiation (upward flux)  (2-dim)
C     dTsurf   :: surf. temp change after 1 implicit time step [oC]
C     bi,bj    :: Tile index
C     myTime   :: Current time of simulation ( s )
C     myIter   :: Current iteration number in simulation
C     myThid   :: Number of this instance of the routine
      _RL  FMASK(NGP), dTskin(NGP)
      _RL  Shf0(NGP), dShf(NGP), Evp0(NGP), dEvp(NGP)
      _RL  Slr0(NGP), dSlr(NGP), sFlx(NGP,0:2)
      _RL  Tsurf(NGP), SHF(NGP), EVAP(NGP), SLRU(NGP)
      _RL  dTsurf(NGP)
      INTEGER bi, bj, myIter, myThid
      _RL myTime
CEOP

#ifdef ALLOW_AIM
#ifdef ALLOW_LAND
C     == Local variables ==
C     i,j, I2      :: loop counters
      INTEGER i,j, I2

      IF ( useLand .AND. land_impl_grT ) THEN

C-     Initialisation :
       DO j=1,sNy
        DO i=1,sNx
         I2 = i+(j-1)*sNx

C-    initialize temp. changes and fresh water flux :
         dTsurf(I2) = 0.
         land_Pr_m_Ev(i,j,bi,bj) = 0. _d 0
         land_EnWFlux(i,j,bi,bj) = 0. _d 0

        ENDDO
       ENDDO

       IF ( land_calc_snow ) THEN
C-     Evap of snow: substract Latent Heat of freezing from heatFlux
        DO j=1,sNy
         DO i=1,sNx
          I2 = i+(j-1)*sNx
          IF ( land_skinT(i,j,bi,bj).LT. 0. _d 0 .OR.
     &         land_hSnow(i,j,bi,bj).GT. 0. _d 0 ) THEN
           sFlx(I2,0) = sFlx(I2,0) - ALHF*Evp0(I2)
           sFlx(I2,1) = sFlx(I2,1) - ALHF*EVAP(I2)
           sFlx(I2,2) = sFlx(I2,2) - ALHF*dEvp(I2)
           land_EnWFlux(i,j,bi,bj) = -ALHF
          ENDIF
         ENDDO
        ENDDO
       ENDIF

       CALL LAND_IMPL_TEMP(
     I               aim_landFr, 
     I               dTskin, sFlx,
     O               dTsurf,
     I               bi, bj, myTime, myIter, myThid)

C--    Surface B.C. for atmospheric physics:
C-     Update Evap, Upward SW according to surf. temp. changes
       DO J=1,NGP
        IF ( dTsurf(J) .GT. 999. ) THEN
         SHF (J)  = Shf0(J)
         EVAP(J)  = Evp0(J)
         SLRU(J)  = Slr0(J)
        ELSE
         SHF (J)  = SHF (J) + dTsurf(J)*dShf(J)
         EVAP(J)  = EVAP(J) + dTsurf(J)*dEvp(J)
         SLRU(J)  = SLRU(J) + dTsurf(J)*dSlr(J)
        ENDIF
       ENDDO

C--    Update surface fluxes for Land model: 
       DO j=1,sNy
        DO i=1,sNx
         I2 = i+(j-1)*sNx
C-     net surface downward heat flux :
         IF ( dTsurf(I2) .GT. 999. ) THEN
          land_HeatFlx(i,j,bi,bj) = sFlx(I2,0)
         ELSE
          land_HeatFlx(i,j,bi,bj) = sFlx(I2,1)+dTsurf(I2)*sFlx(I2,2)
         ENDIF
C-     energy flux associated with Evap of Snow
         land_EnWFlux(i,j,bi,bj) = -land_EnWFlux(i,j,bi,bj)*EVAP(I2)
        ENDDO
       ENDDO

C-     Update Surf.Temp.:
       DO J=1,NGP
        IF ( dTsurf(J) .GT. 999. ) THEN
         dTsurf(J)= tFreeze - Tsurf(J)
         Tsurf(J) = tFreeze
        ELSE
         Tsurf(J) = Tsurf(J)+ dTsurf(J)
        ENDIF
       ENDDO

C- end (if useLand & land_impl_grT)
      ENDIF

#endif /* ALLOW_LAND */
#endif /* ALLOW_AIM */

      RETURN
      END

#include "CPP_OPTIONS.h"

CBOP
C     !ROUTINE: INI_SALT
C     !INTERFACE:
      SUBROUTINE INI_SALT ( myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE INI_SALT                                       
C     | o Set model initial salinity field.                       
C     *==========================================================*
C     | There are several options for setting the initial         
C     | temperature file                                          
C     |  1. Inline code                                           
C     |  2. Vertical profile ( uniform S in X and Y )             
C     |  3. Three-dimensional data from a file. For example from  
C     |     Levitus or from a checkpoint file from a previous     
C     |     integration.                                          
C     | In addition to setting the salinity field we also         
C     | set the initial salinity tendency term here.              
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "DYNVARS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     myThid -  Number of this instance of INI_SALT 
      INTEGER myThid

C     !LOCAL VARIABLES:
C     == Local variables ==
C     bi,bj  - Loop counters
C     I,J,K
      INTEGER bi, bj
      INTEGER  I,  J, K, localWarnings
      CHARACTER*(MAX_LEN_MBUF) msgBuf
CEOP

       _RL pedyn(Nr+1), pdyn(Nr), pkappa(Nr)
       integer Lbotij
       _RL getcon, kappa, dum, pinmb
       _RL temperature(1-Olx:sNx+Olx,1-Oly:sNy+Oly,Nr,nSx,nSy)
       _RL rhum(1-Olx:sNx+Olx,1-Oly:sNy+Oly,Nr,nSx,nSy)
       _RL qstar(1-Olx:sNx+Olx,1-Oly:sNy+Oly,Nr,nSx,nSy)

C Need to convert from input RH to q -- Need pressure, temperature
C Build pressures - we know there is no topography and eta = 0
       pedyn(1) = 100000.
       do K = 2,Nr+1
        pedyn(K) = pedyn(K-1) - drF(K-1)
       enddo
       do K = 1,Nr
        pdyn(K)=(pedyn(K+1)+pedyn(K))/2.
       enddo
       kappa = getcon('KAPPA')
       do K = 1,Nr
        pkappa(K)=(pdyn(K)/100000.)**kappa
       enddo
C Now convert from theta to Temperature
      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
        DO K=1,Nr
         DO J=1,sNy
          DO I=1,sNx
           temperature(I,J,K,bi,bj) = theta(I,J,K,bi,bj) * pkappa(K)
          ENDDO
         ENDDO
        ENDDO
       ENDDO
      ENDDO

C--   Initialise salinity field to the vertical reference profile
      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
        DO K=1,Nr
         DO J=1-Oly,sNy+Oly
          DO I=1-Olx,sNx+Olx
           salt(I,J,K,bi,bj) = sRef(K)
          ENDDO
         ENDDO
        ENDDO
       ENDDO
      ENDDO

      IF ( hydrogSaltFile .NE. ' ' ) THEN
       _BEGIN_MASTER( myThid )
       CALL READ_FLD_XYZ_RL( hydrogSaltFile, ' ', rhum, 0, myThid )
       _END_MASTER(myThid)

C Now convert from rh to q
      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
        DO K=1,Nr-1
         DO J=1,sNy
          DO I=1,sNx
           pinmb = pdyn(K)/100.
           call qsat(temperature(i,j,k,bi,bj),pinmb,qstar(i,j,k,bi,bj),
     .               dum,.false.)
           salt(I,J,K,bi,bj) = rhum(i,j,k,bi,bj) * qstar(i,j,k,bi,bj)
          ENDDO
         ENDDO
        ENDDO
       ENDDO
      ENDDO

       _EXCH_XYZ_RL(salt  , myThid )

      ENDIF

C     Apply mask and test consistancy
      localWarnings=0
      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
        DO K=1,Nr
         DO J=1,sNy
          DO I=1,sNx
           IF (hFacC(I,J,K,bi,bj).EQ.0) salt(I,J,K,bi,bj) = 0.
           IF (hFacC(I,J,K,bi,bj).NE.0.AND.salt(I,J,K,bi,bj).EQ.0.
     &      .AND. sRef(k).NE.0.) THEN
             localWarnings=localWarnings+1
            ENDIF
          ENDDO
         ENDDO
        ENDDO
       ENDDO
      ENDDO
      IF (localWarnings.NE.0) THEN
       WRITE(msgBuf,'(A,A)')
     &  'S/R INI_SALT: salt = 0 identically. If this is intentional',
     &  'you will need to edit ini_salt.F to avoid this safety check'
       CALL PRINT_ERROR( msgBuf , myThid)
       STOP 'ABNORMAL END: S/R INI_SALT'
      ENDIF

      CALL PLOT_FIELD_XYZRL( salt, 'Initial Salinity' , Nr, 1, myThid )

      RETURN
      END

#include "GAD_OPTIONS.h"

CBOP
C !ROUTINE: GAD_C4_ADV_Y

C !INTERFACE: ==========================================================
      SUBROUTINE GAD_C4_ADV_Y(
     I           bi,bj,k,
     I           vTrans, maskLocS,
     I           tracer,
     O           vT,
     I           myThid )

C !DESCRIPTION:
C Calculates the area integrated meridional flux due to advection of a tracer
C using centered fourth-order interpolation:
C \begin{equation*}
C F^y_{adv} = V \overline{ \theta - \frac{1}{6} \delta_{jj} \theta }^j
C \end{equation*}
C Near boundaries, the scheme reduces to a second if the flow is away
C from the boundary and to third order if the flow is towards
C the boundary.

C !USES: ===============================================================
      IMPLICIT NONE
#include "SIZE.h"
#include "GRID.h"
#include "GAD.h"

C !INPUT PARAMETERS: ===================================================
C  bi,bj        :: tile indices
C  k            :: vertical level
C  vTrans       :: meridional volume transport
C  maskLocS     :: mask (either 0 or 1) at grid-cell southern edge
C  tracer       :: tracer field
C  myThid       :: my thread Id number
      INTEGER bi,bj,k
      _RL vTrans  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RS maskLocS(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL tracer  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER myThid

C !OUTPUT PARAMETERS: ==================================================
C  uT           :: zonal advective flux
      _RL vT      (1-OLx:sNx+OLx,1-OLy:sNy+OLy)

C !LOCAL VARIABLES: ====================================================
C  i,j                  :: loop indices
C  Rjm,Rj,Rjp           :: differences at j-1,j,j+1
C  Rjjm,Rjjp            :: second differences at j-1,j
      INTEGER i,j
      _RL Rjm,Rj,Rjp,Rjjm,Rjjp
CEOP

      DO i=1-Olx,sNx+Olx
       vT(i,1-Oly)=0.
       vT(i,2-Oly)=0.
       vT(i,sNy+Oly)=0.
      ENDDO
      DO j=1-Oly+2,sNy+Oly-1
       DO i=1-Olx,sNx+Olx
        Rjp = (tracer(i,j+1)-tracer(i, j ))*maskLocS(i,j+1)
        Rj  = (tracer(i, j )-tracer(i,j-1))*maskLocS(i, j )
        Rjm = (tracer(i,j-1)-tracer(i,j-2))*maskLocS(i,j-1)
        Rjjp=(Rjp-Rj)
        Rjjm=(Rj-Rjm)
        vT(i,j) =
     &   vTrans(i,j)*(
     &     Tracer(i,j)+Tracer(i,j-1)-oneSixth*( Rjjp+Rjjm )
     &               )*0.5 _d 0
     &  +ABS( vTrans(i,j) )*0.5 _d 0*oneSixth*( Rjjp-Rjjm )
     &    *( 1. _d 0 - maskS(i,j-1,k,bi,bj)*maskS(i,j+1,k,bi,bj) )
c    &    *( 1. _d 0 - maskLocS(i,j-1)*maskLocS(i,j+1) )
       ENDDO
      ENDDO

      RETURN
      END

#include "EXF_OPTIONS.h"

      SUBROUTINE EXF_FILTER_RL(
     U                          arr,
     I                          ckind, myThid )

C     ==================================================================
C     SUBROUTINE EXF_FILTER_RL
C     ==================================================================
C
C     o apply mask to input field
C
C     ==================================================================
C     SUBROUTINE EXF_FILTER_RL
C     ==================================================================

      IMPLICIT NONE

C     == global variables ==
#include "EEPARAMS.h"
#include "SIZE.h"
#include "PARAMS.h"
#include "GRID.h"
c#include "EXF_CONSTANTS.h"

C     == routine arguments ==
      _RL arr(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      CHARACTER*1 ckind
      INTEGER myThid

C     == local variables ==
      INTEGER bi,bj
      INTEGER i,j, ks

C     == end of interface ==

C     filter forcing field array
      IF ( ckind.NE.' ' ) THEN

        ks = 1
        IF ( usingPCoords ) ks = Nr

        DO bj = myByLo(myThid), myByHi(myThid)
         DO bi = myBxLo(myThid), myBxHi(myThid)

C         Set undefined values to zero.
Crg not necessary and
Crg would require additional intermediate results in adjoint
crg          DO j = 1,sNy
crg            DO i = 1,sNx
crg              IF (arr(i,j,bi,bj) .LE. exf_undef) THEN
crg                arr(i,j,bi,bj) = 0. _d 0
crg              ENDIF
crg            ENDDO
crg          ENDDO

C         Set land points to zero
          IF     ( ckind .EQ. 'c' ) THEN
            DO j = 1,sNy
             DO i = 1,sNx
               IF ( maskC(i,j,ks,bi,bj) .EQ. 0. ) THEN
                 arr(i,j,bi,bj) = 0. _d 0
               ENDIF
             ENDDO
            ENDDO
          ELSEIF ( ckind .EQ. 'w' ) THEN
            DO j = 1,sNy
             DO i = 1,sNx
               IF ( maskW(i,j,ks,bi,bj) .EQ. 0. ) THEN
                 arr(i,j,bi,bj) = 0. _d 0
               ENDIF
             ENDDO
            ENDDO
          ELSEIF ( ckind .EQ. 's' ) THEN
            DO j = 1,sNy
             DO i = 1,sNx
               IF ( maskS(i,j,ks,bi,bj) .EQ. 0. ) THEN
                 arr(i,j,bi,bj) = 0. _d 0
               ENDIF
             ENDDO
            ENDDO
          ENDIF

         ENDDO
        ENDDO
      ENDIF

      RETURN
      END

#include "STREAMICE_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

CBOP
      SUBROUTINE STREAMICE_CG_WRAPPER(
     U                               cg_Uin,
     U                               cg_Vin,
     I                               cg_tauU,
     I                               cg_tauV,
     I                               tolerance,
     O                               iters,
     I                               maxIter,
     I                               myThid )

C     /============================================================\
C     | SUBROUTINE                                                 |
C     | o                                                          |
C     |============================================================|
C     |                                                            |
C     \============================================================/
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "STREAMICE.h"
#include "STREAMICE_CG.h"

C     !INPUT/OUTPUT ARGUMENTS
C     cg_Uin, cg_Vin - input and output velocities
C     cg_Bu, cg_Bv - driving stress

      INTEGER myThid
      INTEGER iters
      INTEGER maxIter
      _RL tolerance

      _RL cg_Uin (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL cg_Vin (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL cg_tauU (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL cg_tauV (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)

#ifdef ALLOW_STREAMICE

      INTEGER i, j, bi, bj

      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
        DO j=1,sNy
         DO i=1,sNx

          DIAGu_SI (i,j,bi,bj) = 0. _d 0
          DIAGv_SI (i,j,bi,bj) = 0. _d 0
          ubd_SI (i,j,bi,bj) = 0. _d 0
          vbd_SI (i,j,bi,bj) = 0. _d 0
         ENDDO
        ENDDO
       ENDDO
      ENDDO

C     DIRICHLET BOUNDARY VALUES ADDED TO RHS

      CALL STREAMICE_CG_BOUND_VALS( myThid,
     O    ubd_SI,
     O    vbd_SI)

      _EXCH_XY_RL(ubd_SI, myThid)
      _EXCH_XY_RL(vbd_SI, myThid)

c      CALL WRITE_FLD_XY_RL ( "ubd_SI", "",
c     &   ubd_SI, 0, myThid )

c      CALL WRITE_FLD_XY_RL ( "vbd_SI", "",
c     &   STREAMICE_vmask, 0, myThid )

      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          RHSu_SI (i,j,bi,bj) = cg_tauU (i,j,bi,bj)
     &     - ubd_SI(i,j,bi,bj)
          RHSv_SI (i,j,bi,bj) = cg_tauV (i,j,bi,bj)
     &     - vbd_SI(i,j,bi,bj)
         ENDDO
        ENDDO
       ENDDO
      ENDDO

      _EXCH_XY_RL( RHSu_SI, myThid )
      _EXCH_XY_RL( RHSv_SI, myThid )

C     GET DIAGONAL OF MATRIX

      CALL STREAMICE_CG_ADIAG( myThid,
     O    DIAGu_SI,
     O    DIAGv_SI)

      _EXCH_XY_RL( DIAGu_SI, myThid )
      _EXCH_XY_RL( DIAGv_SI, myThid )

C     ccccc

      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
        DO j=1-OLy,sNy+OLy
         DO i=1-OLy,sNx+OLy
          IF (STREAMICE_umask(i,j,bi,bj).ne.1.0)
     &     cg_Uin(i,j,bi,bj)=0.0
          IF (STREAMICE_vmask(i,j,bi,bj).ne.1.0)
     &     cg_Vin(i,j,bi,bj)=0.0

c           print *, "rhs", i,j,RHSu_SI(i,j,bi,bj)

         ENDDO
        ENDDO
       ENDDO
      ENDDO

#ifdef STREAMICE_CONSTRUCT_MATRIX

      CALL STREAMICE_CG_MAKE_A(myThid)

c      call write_fld_xy_rl ("streamicb_cg_A1_m1_m1","",
c     & streamice_cg_A1(:,:,1,1,-1,-1),0,myThid)
c      call write_fld_xy_rl ("streamicb_cg_A1_m1_0","",
c     & streamice_cg_A1(:,:,1,1,-1,0),0,myThid)
c      call write_fld_xy_rl ("streamicb_cg_A1_m1_p1","",
c     & streamice_cg_A1(:,:,1,1,-1,1),0,myThid)
c      call write_fld_xy_rl ("streamicb_cg_A1_0_m1","",
c     & streamice_cg_A1(:,:,1,1,0,-1),0,myThid)
c      call write_fld_xy_rl ("streamicb_cg_A1_0_0","",
c     & streamice_cg_A1(:,:,1,1,0,0),0,myThid)
c      call write_fld_xy_rl ("streamicb_cg_A1_0_p1","",
c     & streamice_cg_A1(:,:,1,1,0,1),0,myThid)
c      call write_fld_xy_rl ("streamicb_cg_A1_p1_m1","",
c     & streamice_cg_A1(:,:,1,1,1,-1),0,myThid)
c      call write_fld_xy_rl ("streamicb_cg_A1_p1_0","",
c     & streamice_cg_A1(:,:,1,1,1,0),0,myThid)
c      call write_fld_xy_rl ("streamicb_cg_A1_p1_p1","",
c     & streamice_cg_A1(:,:,1,1,1,1),0,myThid)
c
c      call write_fld_xy_rl ("streamicb_cg_A2_m1_m1","",
c     & streamice_cg_A2(:,:,1,1,-1,-1),0,myThid)
c      call write_fld_xy_rl ("streamicb_cg_A2_m1_0","",
c     & streamice_cg_A2(:,:,1,1,-1,0),0,myThid)
c      call write_fld_xy_rl ("streamicb_cg_A2_m1_p1","",
c     & streamice_cg_A2(:,:,1,1,-1,1),0,myThid)
c      call write_fld_xy_rl ("streamicb_cg_A2_0_m1","",
c     & streamice_cg_A2(:,:,1,1,0,-1),0,myThid)
c      call write_fld_xy_rl ("streamicb_cg_A2_0_0","",
c     & streamice_cg_A2(:,:,1,1,0,0),0,myThid)
c      call write_fld_xy_rl ("streamicb_cg_A2_0_p1","",
c     & streamice_cg_A2(:,:,1,1,0,1),0,myThid)
c      call write_fld_xy_rl ("streamicb_cg_A2_p1_m1","",
c     & streamice_cg_A2(:,:,1,1,1,-1),0,myThid)
c      call write_fld_xy_rl ("streamicb_cg_A2_p1_0","",
c     & streamice_cg_A2(:,:,1,1,1,0),0,myThid)
c      call write_fld_xy_rl ("streamicb_cg_A2_p1_p1","",
c     & streamice_cg_A2(:,:,1,1,1,1),0,myThid)
c
c      call write_fld_xy_rl ("streamicb_cg_A3_m1_m1","",
c     & streamice_cg_A3(:,:,1,1,-1,-1),0,myThid)
c      call write_fld_xy_rl ("streamicb_cg_A3_m1_0","",
c     & streamice_cg_A3(:,:,1,1,-1,0),0,myThid)
c      call write_fld_xy_rl ("streamicb_cg_A3_m1_p1","",
c     & streamice_cg_A3(:,:,1,1,-1,1),0,myThid)
c      call write_fld_xy_rl ("streamicb_cg_A3_0_m1","",
c     & streamice_cg_A3(:,:,1,1,0,-1),0,myThid)
c      call write_fld_xy_rl ("streamicb_cg_A3_0_0","",
c     & streamice_cg_A3(:,:,1,1,0,0),0,myThid)
c      call write_fld_xy_rl ("streamicb_cg_A3_0_p1","",
c     & streamice_cg_A3(:,:,1,1,0,1),0,myThid)
c      call write_fld_xy_rl ("streamicb_cg_A3_p1_m1","",
c     & streamice_cg_A3(:,:,1,1,1,-1),0,myThid)
c      call write_fld_xy_rl ("streamicb_cg_A3_p1_0","",
c     & streamice_cg_A3(:,:,1,1,1,0),0,myThid)
c      call write_fld_xy_rl ("streamicb_cg_A3_p1_p1","",
c     & streamice_cg_A3(:,:,1,1,1,1),0,myThid)
c
c      call write_fld_xy_rl ("streamicb_cg_A4_m1_m1","",
c     & streamice_cg_A4(:,:,1,1,-1,-1),0,myThid)
c      call write_fld_xy_rl ("streamicb_cg_A4_m1_0","",
c     & streamice_cg_A4(:,:,1,1,-1,0),0,myThid)
c      call write_fld_xy_rl ("streamicb_cg_A4_m1_p1","",
c     & streamice_cg_A4(:,:,1,1,-1,1),0,myThid)
c      call write_fld_xy_rl ("streamicb_cg_A4_0_m1","",
c     & streamice_cg_A4(:,:,1,1,0,-1),0,myThid)
c      call write_fld_xy_rl ("streamicb_cg_A4_0_0","",
c     & streamice_cg_A4(:,:,1,1,0,0),0,myThid)
c      call write_fld_xy_rl ("streamicb_cg_A4_0_p1","",
c     & streamice_cg_A4(:,:,1,1,0,1),0,myThid)
c      call write_fld_xy_rl ("streamicb_cg_A4_p1_m1","",
c     & streamice_cg_A4(:,:,1,1,1,-1),0,myThid)
c      call write_fld_xy_rl ("streamicb_cg_A4_p1_0","",
c     & streamice_cg_A4(:,:,1,1,1,0),0,myThid)
c      call write_fld_xy_rl ("streamicb_cg_A4_p1_p1","",
c     & streamice_cg_A4(:,:,1,1,1,1),0,myThid)
c

c       print *, "MATRIX 1"
c       do i=1,sNx
c        print *, i,
c      & streamice_cg_A1(i,1,1,1,-1,0),
c      & streamice_cg_A1(i,1,1,1,0,0),
c      & streamice_cg_A1(i,1,1,1,1,0),
c      & streamice_cg_A1(i,2,1,1,-1,0),
c      & streamice_cg_A1(i,2,1,1,0,0),
c      & streamice_cg_A1(i,2,1,1,1,0),
c      & streamice_cg_A1(i,3,1,1,-1,0),
c      & streamice_cg_A1(i,3,1,1,0,0),
c      & streamice_cg_A1(i,3,1,1,1,0),
c      & visc_streamice(i,1,1,1),visc_streamice(i,2,1,1),
c      & visc_streamice(i,3,1,1)
c       enddo

      CALL STREAMICE_CG_SOLVE(
     &  cg_Uin,
     &  cg_Vin,
     &  RHSu_SI,
     &  RHSv_SI,
     &  streamice_cg_A1,
     &  streamice_cg_A2,
     &  streamice_cg_A3,
     &  streamice_cg_A4,
     &  tolerance,
     &  iters,
     &  maxIter,
     &  myThid )

      _EXCH_XY_RL( RHSu_SI, myThid )
      _EXCH_XY_RL( RHSv_SI, myThid )

c       DO bj = myByLo(myThid), myByHi(myThid)
c        DO bi = myBxLo(myThid), myBxHi(myThid)
c         DO j=1-OLy,sNy+OLy
c          DO i=1-OLx,sNx+OLx
c           cg_Uin(i,j,bi,bj) = cg_Uin(i,j,bi,bj) +
c      &     0.0 * cg_Uin(i,j,bi,bj)**2
c           cg_Vin(i,j,bi,bj) = cg_Vin(i,j,bi,bj) +
c      &     0.0 * cg_Vin(i,j,bi,bj)**2
c          ENDDO
c         ENDDO
c        ENDDO
c       ENDDO

#else

      CALL STREAMICE_CG_SOLVE_MATFREE(
     &  cg_Uin,
     &  cg_Vin,
     &  RHSu_SI,
     &  RHSv_SI,
     &  tolerance,
     &  iters,
     &  myThid )

#endif

C    ACTUAL CG CALL

      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
        DO j=1-OLy,sNy+OLy
         DO i=1-OLy,sNx+OLy
          IF (STREAMICE_umask(i,j,bi,bj).eq.3.0)
     &     cg_Uin(i,j,bi,bj)=u_bdry_values_SI(i,j,bi,bj)
          IF (STREAMICE_vmask(i,j,bi,bj).eq.3.0)
     &     cg_Vin(i,j,bi,bj)=v_bdry_values_SI(i,j,bi,bj)

c           print *, "rhs", i,j,RHSu_SI(i,j,bi,bj)

         ENDDO
        ENDDO
       ENDDO
      ENDDO

      _EXCH_XY_RL( cg_Uin, myThid )
      _EXCH_XY_RL( cg_Vin, myThid )

#endif
      RETURN
      END

#include "BULK_FORCE_OPTIONS.h"

CBOP
C     !ROUTINE: BULKF_INIT_VARIA
C     !INTERFACE:
      SUBROUTINE BULKF_INIT_VARIA( myThid )

C     *==========================================================*
C     | SUBROUTINE BULKF_INIT_VARIA
C     | o Initialize bulk formula arrays
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "BULKF_PARAMS.h"
#include "BULKF.h"
#ifdef CONSERV_BULKF
#include "BULKF_CONSERV.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     myThid ::  Number of this instance of BULKF_INIT_VARIA
      INTEGER myThid
CEOP

#ifdef ALLOW_BULK_FORCE
C     == Local variables ==
C     bi,bj  :: tile indices
C     i,j    :: Loop counters
      INTEGER bi, bj
      INTEGER i, j

C     set up bulk formula arrays to zero
      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
         DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
             Tair  (i,j,bi,bj) = 0. _d 0
             Qair  (i,j,bi,bj) = 0. _d 0
             Solar (i,j,bi,bj) = 0. _d 0
             flwdwn(i,j,bi,bj) = 0. _d 0
             cloud (i,j,bi,bj) = 0. _d 0
             wspeed(i,j,bi,bj) = 0. _d 0
             uwind (i,j,bi,bj) = 0. _d 0
             vwind (i,j,bi,bj) = 0. _d 0
             runoff(i,j,bi,bj) = 0. _d 0
#ifdef ALLOW_FORMULA_AIM
             thAir (i,j,bi,bj) = 0. _d 0
#endif
             qnetch(i,j,bi,bj) = 0. _d 0
             empch (i,j,bi,bj) = 0. _d 0
           ENDDO
         ENDDO
#ifdef CONSERV_BULKF
         DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
              CONS_Qnet (i,j,bi,bj) = 0. _d 0
              CONS_EmPmR(i,j,bi,bj) = 0. _d 0
           ENDDO
         ENDDO
#endif
       ENDDO
      ENDDO

#ifdef CONSERV_BULKF
      constim = 0. _d 0
#endif

#endif /* ALLOW_BULK_FORCE */

      RETURN
      END

#include "STIC_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C !ROUTINE: STIC_READPARMS

C !INTERFACE:
      SUBROUTINE STIC_READPARMS( myThid )

C     !DESCRIPTION:
C     Initialize STIC variables and constants.

C     !USES:
      IMPLICIT NONE
C     == Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "STIC.h"
#ifdef ALLOW_SHELFICE
# include "SHELFICE.h"
#endif

C     !INPUT PARAMETERS:
      INTEGER myThid
CEOP

C     !LOCAL VARIABLES:
C     msgBuf     :: Informational/error message buffer
C     iUnit      :: Work variable for IO unit number
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      INTEGER iUnit

      NAMELIST /STIC_PARM01/
     &     STIClengthFile, STICdepthFile

      IF ( .NOT.useSTIC ) THEN
C-    pkg STIC is not used
        _BEGIN_MASTER(myThid)
C-    Track pkg activation status:
C     print a (weak) warning if data.stic is found
         CALL PACKAGES_UNUSED_MSG( 'useSTIC', ' ', ' ' )
        _END_MASTER(myThid)
        RETURN
      ENDIF

      _BEGIN_MASTER(myThid)

C--   Default values for STIC
C-    file names for initial conditions:
C     the default topography should be the same as for pkg/shelfice, but
C     we allow different files and issue a warning. For the following
C     line to work, S/R SHELFICE_READPARMS needs to be called first.
      STICdepthFile  = SHELFICEtopoFile
      STIClengthFile = ' '

      WRITE(msgBuf,'(A)') 'STIC_READPARMS: opening data.stic'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      CALL OPEN_COPY_DATA_FILE(
     I                     'data.stic', 'STIC_READPARMS',
     O                     iUnit,
     I                     myThid )

C     Read parameters from open data file
      READ(UNIT=iUnit,NML=STIC_PARM01)
      WRITE(msgBuf,'(A)')
     &    'STIC_READPARMS: finished reading data.stic'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
C     Close the open data file
#ifdef SINGLE_DISK_IO
      CLOSE(iUnit)
#else
      CLOSE(iUnit,STATUS='DELETE')
#endif /* SINGLE_DISK_IO */

      _END_MASTER(myThid)

C--   Everyone else must wait for the parameters to be loaded
      _BARRIER

      RETURN
      END

#include "ZONAL_FILT_OPTIONS.h"

CBOP 0
C     !ROUTINE: ZONAL_FILT_APPLY_TS

C     !INTERFACE:
      SUBROUTINE ZONAL_FILT_APPLY_TS(
     U                 tFld, sFld,
     I                 myThid )

C     !DESCRIPTION:
C     *==========================================================*
C     | S/R ZONAL_FILT_APPLY_TS
C     | o Apply FFT filter to a latitude circle.
C     *==========================================================*

C     !USES:
      IMPLICIT NONE
C     == Global data ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"

C     !INPUT/OUTPUT PARAMETERS:
C     myThid  :: my Thread Id number
      _RL tFld(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      _RL sFld(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      INTEGER myThid
CEOP

#ifdef ALLOW_ZONAL_FILT

C     !LOCAL VARIABLES:
      INTEGER bi,bj

      DO bj=myByLo(myThid),myByHi(myThid)
      DO bi=myBxLo(myThid),myBxHi(myThid)

        IF ( tempStepping ) CALL ZONAL_FILTER(
     U                       tFld( 1-OLx,1-OLy,1,bi,bj),
     I                       hFacC(1-OLx,1-OLy,1,bi,bj),
     I                       1, sNy, Nr, bi, bj, 1, myThid )
        IF ( saltStepping ) CALL ZONAL_FILTER(
     U                       sFld( 1-OLx,1-OLy,1,bi,bj),
     I                       hFacC(1-OLx,1-OLy,1,bi,bj),
     I                       1, sNy, Nr, bi, bj, 1, myThid )


      ENDDO
      ENDDO

#endif /* ALLOW_ZONAL_FILT */

      RETURN
      END

#include "OBCS_OPTIONS.h"
#ifdef ALLOW_SEAICE
# include "SEAICE_OPTIONS.h"
#endif

CBOP
C     !ROUTINE: OBCS_APPLY_SEAICE
C     !INTERFACE:

      SUBROUTINE OBCS_APPLY_SEAICE( myThid )

C     !DESCRIPTION:
C     *==========================================================*
C     | S/R OBCS_APPLY_SEAICE
C     *==========================================================*

C     !USES:
      IMPLICIT NONE
C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
c#include "OBCS_PARAMS.h"
#include "OBCS_GRID.h"
#include "OBCS_SEAICE.h"
#ifdef ALLOW_SEAICE
# include "SEAICE_SIZE.h"
# include "SEAICE_PARAMS.h"
# include "SEAICE.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine Arguments ==
C    myThid   :: my Thread Id number
      INTEGER myThid
CEOP

#if ( defined ALLOW_OBCS && defined ALLOW_SEAICE )

C     !LOCAL VARIABLES:
C     == Local variables ==
      INTEGER bi, bj
      INTEGER i, j
      INTEGER Iobc, Jobc
#ifdef OBCS_SEAICE_SMOOTH_EDGE
      INTEGER k
      _RL edge_val
#endif

      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)

#ifdef ALLOW_OBCS_NORTH
        IF ( tileHasOBN(bi,bj) ) THEN
C     Set model variables to OB values on Northern Boundary
         DO i=1-OLx,sNx+OLx
          Jobc = OB_Jn(i,bi,bj)
          IF ( Jobc.NE.OB_indexNone ) THEN
           IF ( useSeaiceNeumann ) THEN
C     Neumann boundary conditions
            HEFF (i,Jobc,bi,bj) = HEFF (i,Jobc-1,bi,bj)
            AREA (i,Jobc,bi,bj) = AREA (i,Jobc-1,bi,bj)
            HSNOW(i,Jobc,bi,bj) = HSNOW(i,Jobc-1,bi,bj)
#  ifdef SEAICE_VARIABLE_SALINITY
            HSALT(i,Jobc,bi,bj) = HSALT(i,Jobc-1,bi,bj)
#  endif
           ELSE
            HEFF (i,Jobc,bi,bj) = OBNh (i,bi,bj)
            AREA (i,Jobc,bi,bj) = OBNa (i,bi,bj)
            HSNOW(i,Jobc,bi,bj) = OBNsn(i,bi,bj)
#  ifdef SEAICE_VARIABLE_SALINITY
            HSALT(i,Jobc,bi,bj) = OBNsl(i,bi,bj)
#  endif
           ENDIF
          ENDIF
         ENDDO
        ENDIF
#endif /* ALLOW_OBCS_NORTH */

#ifdef ALLOW_OBCS_SOUTH
        IF ( tileHasOBS(bi,bj) ) THEN
C     Set model variables to OB values on Southern Boundary
         DO i=1-OLx,sNx+OLx
          Jobc = OB_Js(i,bi,bj)
          IF ( Jobc.NE.OB_indexNone ) THEN
           IF ( useSeaiceNeumann ) THEN
C     Neumann boundary conditions
            HEFF (i,Jobc,bi,bj) = HEFF (i,Jobc+1,bi,bj)
            AREA (i,Jobc,bi,bj) = AREA (i,Jobc+1,bi,bj)
            HSNOW(i,Jobc,bi,bj) = HSNOW(i,Jobc+1,bi,bj)
#  ifdef SEAICE_VARIABLE_SALINITY
            HSALT(i,Jobc,bi,bj) = HSALT(i,Jobc+1,bi,bj)
#  endif
           ELSE
            HEFF (i,Jobc,bi,bj) = OBSh (i,bi,bj)
            AREA (i,Jobc,bi,bj) = OBSa (i,bi,bj)
            HSNOW(i,Jobc,bi,bj) = OBSsn(i,bi,bj)
#  ifdef SEAICE_VARIABLE_SALINITY
            HSALT(i,Jobc,bi,bj) = OBSsl(i,bi,bj)
#  endif
           ENDIF
          ENDIF
         ENDDO
        ENDIF
#endif /* ALLOW_OBCS_SOUTH */

#ifdef ALLOW_OBCS_EAST
        IF ( tileHasOBE(bi,bj) ) THEN
C     Set model variables to OB values on Eastern Boundary
         DO j=1-OLy,sNy+OLy
          Iobc = OB_Ie(j,bi,bj)
          IF ( Iobc.NE.OB_indexNone ) THEN
           IF ( useSeaiceNeumann ) THEN
C     Neumann boundary conditions
            HEFF (Iobc,j,bi,bj) = HEFF (Iobc-1,j,bi,bj)
            AREA (Iobc,j,bi,bj) = AREA (Iobc-1,j,bi,bj)
            HSNOW(Iobc,j,bi,bj) = HSNOW(Iobc-1,j,bi,bj)
#  ifdef SEAICE_VARIABLE_SALINITY
            HSALT(Iobc,j,bi,bj) = HSALT(Iobc-1,j,bi,bj)
#  endif
           ELSE
            HEFF (Iobc,j,bi,bj) = OBEh (j,bi,bj)
            AREA (Iobc,j,bi,bj) = OBEa (j,bi,bj)
            HSNOW(Iobc,j,bi,bj) = OBEsn(j,bi,bj)
#  ifdef SEAICE_VARIABLE_SALINITY
            HSALT(Iobc,j,bi,bj) = OBEsl(j,bi,bj)
#  endif
           ENDIF
          ENDIF
         ENDDO
        ENDIF
#endif /* ALLOW_OBCS_EAST */

#ifdef ALLOW_OBCS_WEST
        IF ( tileHasOBW(bi,bj) ) THEN
C     Set model variables to OB values on Western Boundary
         DO j=1-OLy,sNy+OLy
          Iobc = OB_Iw(j,bi,bj)
          IF ( Iobc.NE.OB_indexNone ) THEN
           IF ( useSeaiceNeumann ) THEN
C     Neumann boundary conditions
            HEFF (Iobc,j,bi,bj) = HEFF (Iobc+1,j,bi,bj)
            AREA (Iobc,j,bi,bj) = AREA (Iobc+1,j,bi,bj)
            HSNOW(Iobc,j,bi,bj) = HSNOW(Iobc+1,j,bi,bj)
#  ifdef SEAICE_VARIABLE_SALINITY
            HSALT(Iobc,j,bi,bj) = HSALT(Iobc+1,j,bi,bj)
#  endif
           ELSE
            HEFF (Iobc,j,bi,bj) = OBWh (j,bi,bj)
            AREA (Iobc,j,bi,bj) = OBWa (j,bi,bj)
            HSNOW(Iobc,j,bi,bj) = OBWsn(j,bi,bj)
#  ifdef SEAICE_VARIABLE_SALINITY
            HSALT(Iobc,j,bi,bj) = OBWsl(j,bi,bj)
#  endif
           ENDIF
          ENDIF
         ENDDO
        ENDIF
#endif /* ALLOW_OBCS_WEST */

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#ifdef OBCS_SEAICE_SMOOTH_EDGE
        k = 1

#ifdef ALLOW_OBCS_NORTH
        IF ( tileHasOBN(bi,bj) ) THEN
C     Northern Boundary
         DO i=1-OLx,sNx+OLx
          Jobc = OB_Jn(i,bi,bj)
          IF ( Jobc.NE.OB_indexNone ) THEN
           IF ( _maskS(i,Jobc-1,k,bi,bj) .NE. 0. ) THEN
            IF ( SEAICEadvHeff .AND. OBNhfile .NE. ' ' ) THEN
             edge_val = 0.5 _d 0 *
     &           (HEFF(i,Jobc-1,bi,bj)+HEFF(i,Jobc-2,bi,bj))
             HEFF(i,Jobc-1,bi,bj) = edge_val
             HEFF(i,Jobc-2,bi,bj) = edge_val
            ENDIF
            IF ( SEAICEadvArea .AND. OBNafile .NE. ' ' ) THEN
             edge_val = 0.5 _d 0 *
     &           (AREA(i,Jobc-1,bi,bj)+AREA(i,Jobc-2,bi,bj))
             AREA(i,Jobc-1,bi,bj) = edge_val
             AREA(i,Jobc-2,bi,bj) = edge_val
            ENDIF
            IF ( SEAICEadvSNOW .AND. OBNsnfile .NE. ' ' ) THEN
             edge_val = 0.5 _d 0 *
     &           (HSNOW(i,Jobc-1,bi,bj)+HSNOW(i,Jobc-2,bi,bj))
             HSNOW(i,Jobc-1,bi,bj) = edge_val
             HSNOW(i,Jobc-2,bi,bj) = edge_val
            ENDIF
#  ifdef SEAICE_VARIABLE_SALINITY
            IF ( SEAICEadvSALT .AND. OBNslfile .NE. ' ' ) THEN
             edge_val = 0.5 _d 0 *
     &           (HSALT(i,Jobc-1,bi,bj)+HSALT(i,Jobc-2,bi,bj))
             HSALT(i,Jobc-1,bi,bj) = edge_val
             HSALT(i,Jobc-2,bi,bj) = edge_val
            ENDIF
#  endif
           ENDIF
          ENDIF
         ENDDO
        ENDIF
#endif /* ALLOW_OBCS_NORTH */

#ifdef ALLOW_OBCS_SOUTH
        IF ( tileHasOBS(bi,bj) ) THEN
C     Southern Boundary
         DO i=1-OLx,sNx+OLx
          Jobc = OB_Js(i,bi,bj)
          IF ( Jobc.NE.OB_indexNone ) THEN
           IF ( _maskS(i,Jobc+2,k,bi,bj) .NE. 0. ) THEN
            IF ( SEAICEadvHeff .AND. OBNhfile .NE. ' ' ) THEN
             edge_val = 0.5 _d 0 *
     &           (HEFF(i,Jobc+1,bi,bj)+HEFF(i,Jobc+2,bi,bj))
             HEFF(i,Jobc+1,bi,bj) = edge_val
             HEFF(i,Jobc+2,bi,bj) = edge_val
            ENDIF
            IF ( SEAICEadvArea .AND. OBNafile .NE. ' ' ) THEN
             edge_val = 0.5 _d 0 *
     &           (AREA(i,Jobc+1,bi,bj)+AREA(i,Jobc+2,bi,bj))
             AREA(i,Jobc+1,bi,bj) = edge_val
             AREA(i,Jobc+2,bi,bj) = edge_val
            ENDIF
            IF ( SEAICEadvSNOW .AND. OBNsnfile .NE. ' ' ) THEN
             edge_val = 0.5 _d 0 *
     &           (HSNOW(i,Jobc+1,bi,bj)+HSNOW(i,Jobc+2,bi,bj))
             HSNOW(i,Jobc+1,bi,bj) = edge_val
             HSNOW(i,Jobc+2,bi,bj) = edge_val
            ENDIF
#  ifdef SEAICE_VARIABLE_SALINITY
            IF ( SEAICEadvSALT .AND. OBNslfile .NE. ' ' ) THEN
             edge_val = 0.5 _d 0 *
     &           (HSALT(i,Jobc+1,bi,bj)+HSALT(i,Jobc+2,bi,bj))
             HSALT(i,Jobc+1,bi,bj) = edge_val
             HSALT(i,Jobc+2,bi,bj) = edge_val
            ENDIF
#  endif
           ENDIF
          ENDIF
         ENDDO
        ENDIF
#endif /* ALLOW_OBCS_SOUTH */

#ifdef ALLOW_OBCS_EAST
        IF ( tileHasOBE(bi,bj) ) THEN
C     Eastern Boundary
         DO j=1-OLy,sNy+OLy
          Iobc = OB_Ie(j,bi,bj)
          IF ( Iobc.NE.OB_indexNone ) THEN
           IF ( _maskW(Iobc-1,j,k,bi,bj) .NE. 0. ) THEN
            IF ( SEAICEadvHeff .AND. OBNhfile .NE. ' ' ) THEN
             edge_val = 0.5 _d 0 *
     &           (HEFF(Iobc-1,j,bi,bj)+HEFF(Iobc-2,j,bi,bj))
             HEFF(Iobc-1,j,bi,bj) = edge_val
             HEFF(Iobc-2,j,bi,bj) = edge_val
            ENDIF
            IF ( SEAICEadvArea .AND. OBNafile .NE. ' ' ) THEN
             edge_val = 0.5 _d 0 *
     &           (AREA(Iobc-1,j,bi,bj)+AREA(Iobc-2,j,bi,bj))
             AREA(Iobc-1,j,bi,bj) = edge_val
             AREA(Iobc-2,j,bi,bj) = edge_val
            ENDIF
            IF ( SEAICEadvSNOW .AND. OBNsnfile .NE. ' ' ) THEN
             edge_val = 0.5 _d 0 *
     &           (HSNOW(Iobc-1,j,bi,bj)+HSNOW(Iobc-2,j,bi,bj))
             HSNOW(Iobc-1,j,bi,bj) = edge_val
             HSNOW(Iobc-2,j,bi,bj) = edge_val
            ENDIF
#  ifdef SEAICE_VARIABLE_SALINITY
            IF ( SEAICEadvSALT .AND. OBNslfile .NE. ' ' ) THEN
             edge_val = 0.5 _d 0 *
     &           (HSALT(Iobc-1,j,bi,bj)+HSALT(Iobc-2,j,bi,bj))
             HSALT(Iobc-1,j,bi,bj) = edge_val
             HSALT(Iobc-2,j,bi,bj) = edge_val
            ENDIF
#  endif
           ENDIF
          ENDIF
         ENDDO
        ENDIF
#endif /* ALLOW_OBCS_EAST */

#ifdef ALLOW_OBCS_WEST
        IF ( tileHasOBW(bi,bj) ) THEN
C     Western Boundary
         DO j=1-OLy,sNy+OLy
          Iobc = OB_Iw(j,bi,bj)
          IF ( Iobc.NE.OB_indexNone ) THEN
           IF ( _maskW(Iobc+2,j,k,bi,bj) .NE. 0. ) THEN
            IF ( SEAICEadvHeff .AND. OBNhfile .NE. ' ' ) THEN
             edge_val = 0.5 _d 0 *
     &           (HEFF(Iobc+1,j,bi,bj)+HEFF(Iobc+2,j,bi,bj))
             HEFF(Iobc+1,j,bi,bj) = edge_val
             HEFF(Iobc+2,j,bi,bj) = edge_val
            ENDIF
            IF ( SEAICEadvArea .AND. OBNafile .NE. ' ' ) THEN
             edge_val = 0.5 _d 0 *
     &           (AREA(Iobc+1,j,bi,bj)+AREA(Iobc+2,j,bi,bj))
             AREA(Iobc+1,j,bi,bj) = edge_val
             AREA(Iobc+2,j,bi,bj) = edge_val
            ENDIF
            IF ( SEAICEadvSNOW .AND. OBNsnfile .NE. ' ' ) THEN
             edge_val = 0.5 _d 0 *
     &           (HSNOW(Iobc+1,j,bi,bj)+HSNOW(Iobc+2,j,bi,bj))
             HSNOW(Iobc+1,j,bi,bj) = edge_val
             HSNOW(Iobc+2,j,bi,bj) = edge_val
            ENDIF
#  ifdef SEAICE_VARIABLE_SALINITY
            IF ( SEAICEadvSALT .AND. OBNslfile .NE. ' ' ) THEN
             edge_val = 0.5 _d 0 *
     &           (HSALT(Iobc+1,j,bi,bj)+HSALT(Iobc+2,j,bi,bj))
             HSALT(Iobc+1,j,bi,bj) = edge_val
             HSALT(Iobc+2,j,bi,bj) = edge_val
            ENDIF
#  endif
           ENDIF
          ENDIF
         ENDDO
        ENDIF
#endif /* ALLOW_OBCS_WEST */

#endif /* OBCS_SEAICE_SMOOTH_EDGE */

       ENDDO
      ENDDO

#ifdef ALLOW_OBCS_SEAICE_SPONGE
      IF ( useSeaiceSponge ) THEN
       CALL OBCS_SEAICE_SPONGE_A( myThid )
       CALL OBCS_SEAICE_SPONGE_H( myThid )
      ENDIF
#endif /* ALLOW_OBCS_SEAICE_SPONGE */

#endif /* defined ALLOW_OBCS and defined ALLOW_SEAICE */

      RETURN
      END

#include "LAND_OPTIONS.h"

CBOP
C     !ROUTINE: LAND_INIT_FIXED
C     !INTERFACE:
      SUBROUTINE LAND_INIT_FIXED( myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R LAND_INIT_FIXED
C     | o Initialize Land package
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     == Global variables ===

C-- size for MITgcm & Land package :
#include "LAND_SIZE.h"

#include "EEPARAMS.h"
#include "PARAMS.h"
#include "LAND_PARAMS.h"
#include "LAND_VARS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     myThid :: my Thread Id number
      INTEGER myThid
CEOP

#ifdef ALLOW_LAND

C     !LOCAL VARIABLES:
C     msgBuf      :: Informational/error message buffer
c     CHARACTER*(MAX_LEN_MBUF) msgBuf

      IF ( useMNC ) THEN
        CALL LAND_MNC_INIT(sNx,sNy, OLx,OLy, nSx,nSy, nPx,nPy,
     &       land_nLev, myThid)
      ENDIF

      IF ( useDiagnostics ) CALL LAND_DIAGNOSTICS_INIT( myThid )

#endif /* ALLOW_LAND */

      RETURN
      END

#include "GMREDI_OPTIONS.h"
#ifdef ALLOW_CTRL
# include "CTRL_OPTIONS.h"
#endif

CBOP
C     !ROUTINE: GMREDI_INIT_VARIA
C     !INTERFACE:
      SUBROUTINE GMREDI_INIT_VARIA( myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE GMREDI_INIT_VARIA
C     | o Routine to initialize GM/Redi variables
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "GMREDI.h"

C     !INPUT/OUTPUT PARAMETERS:
C     myThid ::  my Thread Id number
      INTEGER myThid
CEOP

#ifdef ALLOW_GMREDI
C     !LOCAL VARIABLES:
      INTEGER i,j,k,bi,bj

C--   Initialise again 3-D control variables (AD-compiler need to see this)
#if (defined ALLOW_KAPREDI_CONTROL && defined GM_READ_K3D_REDI )
C--   Initialize 3-D Isopycnal diffusivity in common block
      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
        DO k=1,Nr
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           GM_inpK3dRedi(i,j,k,bi,bj) = GM_isopycK
     &                  *GM_isoFac1d(k)*GM_isoFac2d(i,j,bi,bj)
          ENDDO
         ENDDO
        ENDDO
       ENDDO
      ENDDO
#endif /* ALLOW_KAPREDI_CONTROL and GM_READ_K3D_REDI */
#if (defined ALLOW_KAPGM_CONTROL && defined GM_READ_K3D_GM )
C--   Initialize 3-D Thickness diffusivity in common block
      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
        DO k=1,Nr
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           GM_inpK3dGM(i,j,k,bi,bj) = GM_background_K
     &                  *GM_bolFac1d(k)*GM_bolFac2d(i,j,bi,bj)
          ENDDO
         ENDDO
        ENDDO
       ENDDO
      ENDDO
#endif /* ALLOW_KAPGM_CONTROL and GM_READ_K3D_GM */

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
#ifdef ALLOW_AUTODIFF
C- Note: To simplify dependency & avoid recomputations, when compiling
C        pkg/autodiff, we always call GMREDI_INIT_VARIA to initialise control
C        variables (as done above) without condition on useGMRedi.
C        Therefore, in this case, the "If useGMRedi" is added back here:
      IF ( useGMRedi ) THEN
#endif
#ifdef GM_GEOM_VARIABLE_K
C     use AB2 time stepping
       _BEGIN_MASTER( myThid )
        GEOM_startAB = MIN( nIter0, 1 )
       _END_MASTER( myThid )
#endif

#if (defined ALLOW_KAPREDI_CONTROL && defined GM_READ_K3D_REDI )
C--   Read (again) 3-D Isopycnal diffusivity from file
      IF ( GM_K3dRediFile .NE. ' ' ) THEN
       CALL READ_FLD_XYZ_RL( GM_K3dRediFile, ' ',
     &                       GM_inpK3dRedi, 0, myThid )
       CALL EXCH_XYZ_RL( GM_inpK3dRedi, myThid )
      ENDIF
#endif /* ALLOW_KAPREDI_CONTROL and GM_READ_K3D_REDI */
#if (defined ALLOW_KAPGM_CONTROL && defined GM_READ_K3D_GM )
C--   Read (again) 3-D Thickness diffusivity from file
      IF ( GM_K3dGMFile .NE. ' ' ) THEN
       CALL READ_FLD_XYZ_RL( GM_K3dGMFile, ' ',
     &                       GM_inpK3dGM, 0, myThid )
       CALL EXCH_XYZ_RL( GM_inpK3dGM, myThid )
      ENDIF
#endif /* ALLOW_KAPGM_CONTROL and GM_READ_K3D_GM */

      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)

C     Initialize 3-D arrays in common blocks :
        DO k=1,Nr
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           Kwx(i,j,k,bi,bj) = 0. _d 0
           Kwy(i,j,k,bi,bj) = 0. _d 0
           Kwz(i,j,k,bi,bj) = 0. _d 0
           Kux(i,j,k,bi,bj) = 0. _d 0
           Kvy(i,j,k,bi,bj) = 0. _d 0
#ifdef GM_EXTRA_DIAGONAL
           Kuz(i,j,k,bi,bj) = 0. _d 0
           Kvz(i,j,k,bi,bj) = 0. _d 0
#endif
#ifdef GM_BOLUS_ADVEC
           GM_PsiX(i,j,k,bi,bj) = 0. _d 0
           GM_PsiY(i,j,k,bi,bj) = 0. _d 0
#endif
#ifdef ALLOW_GM_LEITH_QG
           GM_LeithQG_K(i,j,k,bi,bj) = 0. _d 0
#endif
#ifdef GM_BATES_K3D
           GM_BatesK3d(i,j,k,bi,bj) = 0. _d 0
#endif
#ifdef GM_GEOM_VARIABLE_K
           GEOM_K3d(i,j,k,bi,bj) = 0. _d 0
#endif
          ENDDO
         ENDDO
        ENDDO
C     Initialize 2-D arrays in common blocks :
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
#ifdef GM_VISBECK_VARIABLE_K
           VisbeckK(i,j,bi,bj) = 0. _d 0
#endif
#ifdef GM_GEOM_VARIABLE_K
           GEOM_EKE(i,j,bi,bj) = GEOM_ini_EKE * maskInC(i,j,bi,bj)
           GEOM_gEKE_Nm1(i,j,bi,bj) = 0. _d 0
#endif
         ENDDO
        ENDDO

C- end bi,bj loops
       ENDDO
      ENDDO

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C--   write GM scaling factors to file:
      IF ( GM_iso1dFile .NE. ' ' ) THEN
        CALL WRITE_GLVEC_RS( 'GM_isoFac1d', ' ', GM_isoFac1d,
     I                        Nr, -1, myThid )
      ENDIF
      IF ( GM_bol1dFile .NE. ' ' ) THEN
        CALL WRITE_GLVEC_RS( 'GM_bolFac1d', ' ', GM_bolFac1d,
     I                        Nr, -1, myThid )
      ENDIF
      IF ( GM_iso2dFile .NE. ' ' ) THEN
        CALL WRITE_FLD_XY_RS( 'GM_isoFac2d',' ',GM_isoFac2d,-1,myThid )
      ENDIF
      IF ( GM_bol2dFile .NE. ' ' ) THEN
        CALL WRITE_FLD_XY_RS( 'GM_bolFac2d',' ',GM_bolFac2d,-1,myThid )
      ENDIF

#if ( defined GM_BATES_K3D || defined GM_GEOM_VARIABLE_K )
      IF ( .NOT.( startTime.EQ.baseTime .AND. nIter0.EQ.0
     &            .AND. pickupSuff.EQ.' ' )
     &     .AND.( GM_useBatesK3d .OR. GM_useGEOM ) ) THEN
        CALL GMREDI_READ_PICKUP( nIter0, myThid )
      ENDIF
#endif

#ifdef GM_BATES_K3D
C     This is put here, but really should be in gmredi_init_fixed.F. The
C     problem is that fCori, fCoriCos, etc are not initialized when
C     gmredi_init_fixed.F is called. To be fixed.
C     Computing beta = df/dy
      IF ( selectCoriMap.EQ.1 ) THEN
       DO bj = myByLo(myThid), myByHi(myThid)
        DO bi = myBxLo(myThid), myBxHi(myThid)
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           gradf(i,j,bi,bj) =  beta
          ENDDO
         ENDDO
        ENDDO
       ENDDO
      ELSEIF ( selectCoriMap.EQ.2 ) THEN
       DO bj = myByLo(myThid), myByHi(myThid)
        DO bi = myBxLo(myThid), myBxHi(myThid)
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           gradf(i,j,bi,bj) = recip_rSphere*fCoriCos(i,j,bi,bj)
          ENDDO
         ENDDO
        ENDDO
       ENDDO
      ELSE
       DO bj = myByLo(myThid), myByHi(myThid)
        DO bi = myBxLo(myThid), myBxHi(myThid)
         DO j=1-OLy+1,sNy+OLy-1
          DO i=1-OLx+1,sNx+OLx-1
           gradf(i,j,bi,bj)  =  .5 _d 0*angleSinC(i,j,bi,bj)*(
     &    (fCori(i+1,j,bi,bj)-fCori(i  ,j,bi,bj))*recip_dxC(i+1,j,bi,bj)
     &   +(fCori(i  ,j,bi,bj)-fCori(i-1,j,bi,bj))*recip_dxC(i,j,bi,bj) )
     &                       +  .5 _d 0*angleCosC(i,j,bi,bj)*(
     &    (fCori(i,j+1,bi,bj)-fCori(i,j  ,bi,bj))*recip_dyC(i,j+1,bi,bj)
     &   +(fCori(i,j  ,bi,bj)-fCori(i,j-1,bi,bj))*recip_dyC(i,j,bi,bj) )
           gradf(i,j,bi,bj)=max(1. _d -18, gradf(i,j,bi,bj) )
          ENDDO
         ENDDO
        ENDDO
       ENDDO
      ENDIF
      CALL EXCH_XY_RL( gradf, myThid)
#endif /* GM_BATES_K3D */

#ifdef ALLOW_AUTODIFF
      ENDIF
#endif
#endif /* ALLOW_GMREDI */

      RETURN
      END

#include "SALT_PLUME_OPTIONS.h"

CBOP
C     !ROUTINE: SALT_PLUME_FORCING_SURF
C     !INTERFACE:
      SUBROUTINE SALT_PLUME_FORCING_SURF(
     I                            bi, bj, iMin, iMax, jMin, jMax,
     I                            myTime,myIter,myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R SALT_PLUME_FORCING_SURF
C     | o saltPlume is the amount of salt rejected by ice while freezing;
C     |   it is here subtracted from surfaceForcingS and will be redistributed
C     |   to multiple vertical levels later on as per Duffy et al. (GRL 1999)
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "FFIELDS.h"
#include "DYNVARS.h"
#include "SALT_PLUME.h"

C     !INPUT PARAMETERS:
C     bi,bj                :: tile indices
C     myTime               :: model time
C     myIter               :: time-step number
C     myThid               :: thread number
      INTEGER bi, bj, iMin, iMax, jMin, jMax
      _RL myTime
      INTEGER myIter
      INTEGER myThid
CEOP

#ifdef ALLOW_SALT_PLUME
C     !LOCAL VARIABLES:
C     i,j                  :: loop indices
C     ks                   :: surface level index
      INTEGER i, j, ks
      IF ( usingPCoords ) THEN
         ks = Nr
      ELSE
         ks = 1
      ENDIF

      DO j = jMin, jMax
       DO i = iMin, iMax
#ifdef SALT_PLUME_VOLUME
        SPforcS1(i,j,bi,bj)=SPbrineVolFlux(i,j,bi,bj)
     &   *SPbrineSconst*rhoConst
        SPforcT1(i,j,bi,bj)=SPbrineVolFlux(i,j,bi,bj)
     &   *theta(i,j,1,bi,bj)*rhoConst
     &   *HeatCapacity_Cp

Cunits: surfaceForcingT [Kelvin.m/s], surfaceForcingS [g/kg.m/s]
C SPforcS1 has same unit as saltPlumeFlux [g/m2/s]=[g/kg kg/m2/s]
C SPforcT1: [W/m2]
        surfaceForcingS(i,j,bi,bj) = surfaceForcingS(i,j,bi,bj)
     &      - SPforcS1(i,j,bi,bj) * mass2rUnit
        surfaceForcingT(i,j,bi,bj) = surfaceForcingT(i,j,bi,bj)
     &      - SPforcT1(i,j,bi,bj) * mass2rUnit / HeatCapacity_Cp
#else /* SALT_PLUME_VOLUME */
        surfaceForcingS(i,j,bi,bj) = surfaceForcingS(i,j,bi,bj)
     &       - saltPlumeFlux(i,j,bi,bj) * mass2rUnit
#endif /* SALT_PLUME_VOLUME */
       ENDDO
      ENDDO
#endif /* ALLOW_SALT_PLUME */

      RETURN
      END

#include "STREAMICE_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      SUBROUTINE STREAMICE_ADV_FLUX_FL_X ( myThid ,
     I   UADV ,
     I   TRAC ,
     I   BC_FACEMASK,
     I   BC_XVALUES,
     O   XFLUX,
     I   time_step )

      IMPLICIT NONE

C     O   hflux_x ! flux per unit width across face
C     O   h
C     I   time_step

C     === Global variables ===
#include "SIZE.h"
#include "GRID.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "STREAMICE.h"
!#include "GAD_FLUX_LIMITER.h"

      INTEGER myThid
      _RL UADV         (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL TRAC         (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RS BC_FACEMASK  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL BC_XVALUES   (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL XFLUX        (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL time_step

#ifdef ALLOW_STREAMICE

C     LOCAL VARIABLES

      INTEGER i, j, bi, bj, Gi, Gj, k
      _RL uface, phi, cfl, Cr, rdenom, d0, d1, psi
      _RL stencil (-1:1)
      LOGICAL H0_valid(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
                        ! there are valid cells to calculate a
                        ! slope-limited 2nd order flux
      _RL SLOPE_LIMITER
!       _RL total_vol_out
      external SLOPE_LIMITER

!       total_vol_out = 0.0

      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        DO j=1-oly,sNy+oly
         DO i=1-olx,sNx+olx
          H0_valid(i,j,bi,bj)=.false.
         ENDDO
        ENDDO
       ENDDO
      ENDDO

      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        DO j=1-3,sNy+3
         Gj = (myYGlobalLo-1)+(bj-1)*sNy+j
         IF (((Gj .ge. 1) .and. (Gj .le. Ny))
     &       .or.STREAMICE_NS_PERIODIC) THEN
          DO i=1,sNx+1
C        THESE ARRAY BOUNDS INSURE THAT AFTER THIS STEP,
C        VALUES WILL BE RELIABLE 1 GRID CELLS OUT IN THE
C        X DIRECTION AND 3 CELLS OUT IN THE Y DIR
           IF ((STREAMICE_hmask(i,j,bi,bj).eq.1.0) .or.
     &         ((STREAMICE_hmask(i-1,j,bi,bj).eq.1.0) .and.
     &          (STREAMICE_hmask(i,j,bi,bj).ne.1.0))) THEN

            Gi = (myXGlobalLo-1)+(bi-1)*sNx+i

            uface = UADV(i,j,bi,bj)
            cfl = ABS(uface) * time_step * recip_dxC(i,j,bi,bj)

            IF (BC_FACEMASK(i,j,bi,bj).eq.3.0 .and.
     &          uface.gt.0 .and.
     &          STREAMICE_hmask(i,j,bi,bj).eq.1.0) THEN
             XFLUX (i,j,bi,bj) = BC_XVALUES(i,j,bi,bj) * uface
            ELSEIF
     &          (BC_FACEMASK(i,j,bi,bj).eq.3.0 .and.
     &          uface.le.0 .and.
     &          STREAMICE_hmask(i-1,j,bi,bj).eq.1.0) THEN
             XFLUX (i,j,bi,bj) = BC_XVALUES(i,j,bi,bj) * uface
            ELSE

             IF (uface .gt. 0. _d 0) THEN
              DO k=-1,1
               stencil (k) = TRAC(i+k-1,j,bi,bj)
              ENDDO
              IF ((STREAMICE_hmask(i,j,bi,bj).eq.1.0) .and.
     &            (STREAMICE_hmask(i-2,j,bi,bj).eq.1.0))
     &             H0_valid(i,j,bi,bj)=.true.

              IF (((Gi.eq.1).and.(STREAMICE_hmask(i-1,j,bi,bj).eq.3.0))
     &             .and.(.not.STREAMICE_EW_PERIODIC))
     &         THEN  ! we are at western bdry and there is a thick. bdry cond

               XFLUX (i,j,bi,bj) = TRAC(i-1,j,bi,bj) * uface

              ELSEIF (H0_valid(i,j,bi,bj)) THEN

               rdenom = (stencil(1)-stencil(0))
               IF (rdenom .ne. 0.) THEN
                Cr = (stencil(0)-stencil(-1))/rdenom
               ELSE
                Cr = 1.E20 *  (stencil(0)-stencil(-1))
               ENDIF

               IF (STREAMICE_ADV_SCHEME.ne.'DST3') THEN
!                phi = SLOPE_LIMITER(stencil(0)-stencil(-1),
!     &                              stencil(1)-stencil(0))
                 phi = SLOPE_LIMITER (Cr)
               ELSE
                d0 = (2.-cfl)*(1.-cfl)/6.0
                d1 = (1.-cfl**2)/6.0
                psi = d0+d1*Cr
                phi = MAX(0. _d 0,MIN(MIN(1. _d 0,psi),
     &                Cr*(1. _d 0 -CFL)/(CFL+1. _d -20) ))
               ENDIF

               IF (STREAMICE_ADV_SCHEME.ne.'DST3') THEN
                XFLUX (i,j,bi,bj) = uface *
     &           (stencil(0) + phi * .5 * (1.0-cfl) *
     &           (stencil(1)-stencil(0)))
               ELSE
                XFLUX (i,j,bi,bj) = uface *
     &           (stencil(0) + phi *
     &           (stencil(1)-stencil(0)))
               ENDIF

              ELSE ! one of the two cells needed for a HO scheme is missing, use FO scheme

               XFLUX (i,j,bi,bj) = uface * stencil(0)

              ENDIF

             ELSEIF (uface .lt. 0. _d 0) THEN ! uface <= 0

              DO k=-1,1
               stencil (k) = TRAC(i-k,j,bi,bj)
              ENDDO
              IF ((STREAMICE_hmask(i-1,j,bi,bj).eq.1.0) .and.
     &            (STREAMICE_hmask(i+1,j,bi,bj).eq.1.0))
     &             H0_valid(i,j,bi,bj)=.true.

              IF (((Gi.eq.Nx).and.(STREAMICE_hmask(i+1,j,bi,bj).eq.3.0))
     &            .and.(.not.STREAMICE_EW_PERIODIC))
     &         THEN  ! we are at western bdry and there is a thick. bdry cond

               XFLUX (i,j,bi,bj) = TRAC(i+1,j,bi,bj) * uface

              ELSEIF (H0_valid(i,j,bi,bj)) THEN

               rdenom = (stencil(1)-stencil(0))
               IF (rdenom .ne. 0.) THEN
                Cr = (stencil(0)-stencil(-1))/rdenom
               ELSE
                Cr = 1.E20 *  (stencil(0)-stencil(-1))
               ENDIF

               IF (STREAMICE_ADV_SCHEME.ne.'DST3') THEN
!                phi = SLOPE_LIMITER(stencil(0)-stencil(-1),
!     &                        stencil(1)-stencil(0))
                 phi = SLOPE_LIMITER (Cr)

               ELSE
                d0 = (2.-cfl)*(1.-cfl)/6.0
                d1 = (1.-cfl**2)/6.0
                psi = d0+d1*Cr
                phi = MAX(0. _d 0,MIN(MIN(1. _d 0,psi),
     &                Cr*(1. _d 0 -CFL)/(CFL+1. _d -20) ))
               ENDIF

               IF (STREAMICE_ADV_SCHEME.ne.'DST3') THEN
                XFLUX (i,j,bi,bj) = uface *
     &           (stencil(0) + phi * .5 * (1.0-cfl) *
     &           (stencil(1)-stencil(0)))
               ELSE
                XFLUX (i,j,bi,bj) = uface *
     &           (stencil(0) + phi *
     &           (stencil(1)-stencil(0)))
               ENDIF

              ELSE ! one of the two cells needed for a HO scheme is missing, use FO scheme

               Xflux (i,j,bi,bj) = uface * stencil(0)

              ENDIF

             ELSE

              Xflux (i,j,bi,bj) = 0. _d 0

             ENDIF

            ENDIF

           ENDIF
          ENDDO
         ENDIF
        ENDDO
       ENDDO
      ENDDO

!C     X-FLUXES AT CELL BOUNDARIES CALCULATED; NOW TAKE FLUX DIVERGENCE TO INCREMENT THICKNESS
!
!      DO bj=myByLo(myThid),myByHi(myThid)
!       DO bi=myBxLo(myThid),myBxHi(myThid)
!        DO j=1-3,sNy+3
!         Gj = (myYGlobalLo-1)+(bj-1)*sNy+j
!         IF ((Gj .ge. 1) .and. (Gj .le. Ny)) THEN
!          DO i=1-2,sNx+2
!           IF (STREAMICE_hmask(i,j,bi,bj).eq.1.0) THEN
!            h(i,j,bi,bj) = h(i,j,bi,bj) - time_step *
!     &       (hflux_x(i+1,j,bi,bj)*dyG(i+1,j,bi,bj) -
!     &        hflux_x(i,j,bi,bj)*dyG(i,j,bi,bj)) *
!     &       recip_rA (i,j,bi,bj)
!           ENDIF
!          ENDDO
!         ENDIF
!        ENDDO
!       ENDDO
!      ENDDO

#endif
      RETURN
      END SUBROUTINE STREAMICE_ADV_FLUX_FL_X

#include "SBO_OPTIONS.h"
#ifdef ALLOW_SEAICE
# include "SEAICE_OPTIONS.h"
#endif

CBOP
C !ROUTINE: SBO_CALC

C !INTERFACE: ==========================================================
      SUBROUTINE SBO_CALC( myTime, myIter, myThid )

C !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE SBO_CALC                                      |
C     | o Do SBO diagnostic output.                              |
C     *==========================================================*
C     | NOTE: The following subtleties are ignored for time      |
C     | being but may need revisiting at some point in time.     |
C     | 1) The model is volume-preserving and Boussinesq so      |
C     |    quantities like oceanic mass need to be interpreted   |
C     |    with some care.  We remove spurious mass variations   |
C     |    using the Greatbatch correction. Real freshwater      |
C     |    fluxes retained in mass load.                         |
C     | 2) The sea surface height variable etaN might lag other  |
C     |    prognostic variables by half a time step.  This lag   |
C     |    is ignored in SBO computations.                       |
C     | 3) OAM due to currents assumes constant density          |
C     |    (=rhoConst), rms differences using variable density   |
C     |    is less than 1%, assuming rhoConst is a good measure  |
C     |    of the actual mean density                            |
C     | 4) Seaice motion added to OAMC.  Seaice mass is in OAMP  |
C     |    and COM.   Net freshwater flux is between atmosphere  |
C     |    and liquid ocean plus seaice.  I.e. changes in seaice |
C     |    mass due to melt/freeze with liquid ocean do not      |
C     |    change net freshwater flux.                           |
C     *==========================================================*

C=======================================================================
C
C     Based on ftp://euler.jpl.nasa.gov/sbo/software/calc_sbo2.f
C     Written  by Richard Gross (Richard.Gross@jpl.nasa.gov)
C     Reference
C           Gross, R. S., F. O. Bryan, Y. Chao, J. O. Dickey, S. L. Marcus,
C           R. M. Ponte, and R. Tokmakian, The IERS Special Bureau for the
C           Oceans, in IERS Technical Note on the IERS Global Geophysical
C           Fluids Center, edited by B. Chao, in press, Observatoire de Paris,
C           Paris, France, 2002.
C
C     June 10, 2001: Modified for online computations in MIT GCM UV
C              by Dimitris Menemenlis (Menemenlis@jpl.nasa.gov)
C     Jan 7, 2014: Modified for real freshwater flux and coordinates other
C              than spherical polar by Katy Quinn (kquinn@aer.com)
C
C     Purpose
C           calc_sbo calculates the core products of the IERS Special Bureau
C           for the Oceans including oceanic mass, center-of-mass, and angular
C           momentum.
C
C=======================================================================
C \ev

C !USES: ===============================================================
      IMPLICIT NONE
C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "DYNVARS.h"
#include "FFIELDS.h"
#include "SBO.h"
#ifdef ALLOW_SEAICE
# include "SEAICE_SIZE.h"
# include "SEAICE.h"
#endif

C !INPUT PARAMETERS: ===================================================
C     == Routine arguments ==
C     myTime  :: Current time of simulation ( s )
C     myIter  :: Iteration number
C     myThid  :: Number of this instance of SBO_CALC
      _RL     myTime
      INTEGER myIter, myThid

#ifdef ALLOW_SBO

C !LOCAL VARIABLES: ====================================================
C     bi, bj    :: array indices
C     i         :: index over longitude grid points
C     j         :: index over latitude  grid points
C     k         :: index over layers
C     lat       :: latitude  of grid point (radians)
C     lon       :: longitude of grid point (radians)
C     darea     :: element of surface area (m**2)
C     dvolume   :: element of volume (m**3)
C     ae        :: mean radius of Earth (m) (PREM value)
C     sbo_omega :: mean angular velocity of Earth (rad/s)
C     UE,VN     :: geographic (east,north) ocean velocities at cell centers (m/s)
C     UEice,VNice  :: geographic (east,north) seaice velocities at cell centers (m/s)
C     Mload     :: total mass load (kg/m**2)
C     GCload    :: mass load for Greatbatch correction (kg/m**2)
C     FWLoad    :: real freshwater flux mass load (kg/m**2)
      integer bi, bj, i, j, k
      _RL lat, lon, darea, dvolume
      _RL ae, sbo_omega
      PARAMETER ( ae        = 6.3710 _d 6    )
      PARAMETER ( sbo_omega = 7.292115 _d -5 )
      _RL UE(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      _RL VN(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      _RL UEice(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL VNice(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL Mload(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL GCload, FWload
C Tiled global sums
      _RL tile_FWload(nSx,nSy)
      _RL tile_sboarea(nSx,nSy)
      _RL tile_GCload(nSx,nSy)
      _RL tile_mass(nSx,nSy)
      _RL tile_xcom(nSx,nSy)
      _RL tile_ycom(nSx,nSy)
      _RL tile_zcom(nSx,nSy)
      _RL tile_xoamc(nSx,nSy)
      _RL tile_yoamc(nSx,nSy)
      _RL tile_zoamc(nSx,nSy)
      _RL tile_xoamp(nSx,nSy)
      _RL tile_yoamp(nSx,nSy)
      _RL tile_zoamp(nSx,nSy)
      _RL tile_xoamc_si(nSx,nSy)
      _RL tile_yoamc_si(nSx,nSy)
      _RL tile_zoamc_si(nSx,nSy)
      _RL tile_mass_si(nSx,nSy)
      _RL tile_mass_fw(nSx,nSy)
      _RL tile_xcom_fw(nSx,nSy)
      _RL tile_ycom_fw(nSx,nSy)
      _RL tile_zcom_fw(nSx,nSy)
      _RL tile_xoamp_fw(nSx,nSy)
      _RL tile_yoamp_fw(nSx,nSy)
      _RL tile_zoamp_fw(nSx,nSy)
      _RL tile_mass_gc (nSx,nSy)
C Pre-computed cos(lat), sin(lat), cos(lon), sin(lon)
      _RL COSlat(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL SINlat(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL COSlon(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL SINlon(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
CEOP

C Initialize variables to be computed---------------------------------
C-    note: only done once (by master thread) for var in common block
      _BEGIN_MASTER(myThid)

      xoamc = 0.0
      yoamc = 0.0
      zoamc = 0.0
      xoamp = 0.0
      yoamp = 0.0
      zoamp = 0.0
      mass  = 0.0
      xcom  = 0.0
      ycom  = 0.0
      zcom  = 0.0
      sboarea = 0.0

      xoamc_si = 0.0
      yoamc_si = 0.0
      zoamc_si = 0.0
      mass_si  = 0.0

      xoamp_fw = 0.0
      yoamp_fw = 0.0
      zoamp_fw = 0.0
      mass_fw  = 0.0
      xcom_fw  = 0.0
      ycom_fw  = 0.0
      zcom_fw  = 0.0

      mass_gc  = 0.0

      _END_MASTER(myThid)

C Get geographic (East,North) velocities------------------------------

      CALL ROTATE_UV2EN_RL(
     U          uVel, vVel,
     U          UE, VN,
     I          .TRUE., .TRUE., .FALSE., Nr, mythid )

#ifdef ALLOW_SEAICE
      IF ( useSEAICE ) THEN
        CALL ROTATE_UV2EN_RL(
     U          UICE, VICE,
     U          UEice, VNice,
     I          .TRUE., .TRUE., .FALSE., 1, mythid )
      ELSE
#else /* ALLOW_SEAICE */
      IF ( .TRUE. ) THEN
#endif /* ALLOW_SEAICE */
        DO bj = myByLo(myThid), myByHi(myThid)
         DO bi = myBxLo(myThid), myBxHi(myThid)
          DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
             UEice(i,j,bi,bj) = 0.
             VNice(i,j,bi,bj) = 0.
           ENDDO
          ENDDO
         ENDDO
        ENDDO
      ENDIF

C Calculate mass load-------------------------------------------------
C     Calculate mass load (Mload), Greatbatch correction for
C     spurious mass but spatial mean freshwater flux retained.
C     Mload *needs* to be total mass (for center of mass), so add
C     back missing time invariant term: -R_low*rhoConst

c Calculate freshwater load
C Calculate Greatbatch correction load over global ocean volume
c Note: no halo regions in i,j loops, do not want to double book sums
      FWload = 0.0
      GCload = 0.0
      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
        tile_FWload(bi,bj) = 0.0
        tile_GCload(bi,bj) = 0.0
        tile_sboarea(bi,bj) = 0.0
        DO j = 1, sNy
         DO i = 1, sNx
            darea = rA(i,j,bi,bj)*maskC(i,j,1,bi,bj)
            tile_sboarea(bi,bj) = tile_sboarea(bi,bj) + darea
            tile_FWload(bi,bj) =  tile_FWload(bi,bj) +
     &           rhoConst*etaN(i,j,bi,bj)*darea +
     &           sIceLoad(i,j,bi,bj)*darea
            DO k = 1, Nr
               dvolume = rA(i,j,bi,bj)*drF(k)*hFacC(i,j,k,bi,bj)
               tile_GCload(bi,bj) = tile_GCload(bi,bj) +
     &              rhoInSitu(i,j,k,bi,bj) * dvolume
            ENDDO
         ENDDO
        ENDDO
       ENDDO
      ENDDO
      CALL GLOBAL_SUM_TILE_RL( tile_FWload  , FWload  , myThid )
      CALL GLOBAL_SUM_TILE_RL( tile_sboarea , sboarea , myThid )
      CALL GLOBAL_SUM_TILE_RL( tile_GCload  , GCload  , myThid )
      FWload = FWload/sboarea
      GCload = -1.0 * GCload/sboarea

c Total mass load with freshwater flux
      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
        DO j = 1-OLy, sNy+OLy
         DO i = 1-OLx, sNx+OLx
            Mload(i,j,bi,bj) =  rhoConst*etaN(i,j,bi,bj) +
     &           sIceLoad(i,j,bi,bj) +
     &           GCload - R_low(i,j,bi,bj)*rhoConst
            DO k = 1, Nr
               Mload(i,j,bi,bj) = Mload(i,j,bi,bj) +
     &           rhoInSitu(i,j,k,bi,bj)*drF(k)*hFacC(i,j,k,bi,bj)
            ENDDO
         ENDDO
        ENDDO
       ENDDO
      ENDDO

c Pre-compute cos(lat), sin(lat), cos(lon), sin(lon)
      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
        DO j = 1-OLy, sNy+OLy
         DO i = 1-OLx, sNx+OLx
            lat = yC(i,j,bi,bj) * deg2rad
            lon = xC(i,j,bi,bj) * deg2rad
            COSlat(i,j,bi,bj) = COS(lat)
            SINlat(i,j,bi,bj) = SIN(lat)
            COSlon(i,j,bi,bj) = COS(lon)
            SINlon(i,j,bi,bj) = SIN(lon)
         ENDDO
        ENDDO
       ENDDO
      ENDDO

C Main loops----------------------------------------------------------
C     loop over all grid points, accumulating mass, com, oam
C     Note: no halo regions in i,j loops, do not want to double book sums

      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)

C Initialize tile sums---------------------------------
        tile_xoamc(bi,bj) = 0.0
        tile_yoamc(bi,bj) = 0.0
        tile_zoamc(bi,bj) = 0.0
        tile_xoamp(bi,bj) = 0.0
        tile_yoamp(bi,bj) = 0.0
        tile_zoamp(bi,bj) = 0.0
        tile_mass(bi,bj) = 0.0
        tile_xcom(bi,bj) = 0.0
        tile_ycom(bi,bj) = 0.0
        tile_zcom(bi,bj) = 0.0

        tile_xoamc_si(bi,bj) = 0.0
        tile_yoamc_si(bi,bj) = 0.0
        tile_zoamc_si(bi,bj) = 0.0
        tile_mass_si(bi,bj) = 0.0

        tile_xoamp_fw(bi,bj) = 0.0
        tile_yoamp_fw(bi,bj) = 0.0
        tile_zoamp_fw(bi,bj) = 0.0
        tile_mass_fw(bi,bj) = 0.0
        tile_xcom_fw(bi,bj) = 0.0
        tile_ycom_fw(bi,bj) = 0.0
        tile_zcom_fw(bi,bj) = 0.0

        tile_mass_gc(bi,bj) = 0.0

        DO j = 1, sNy
         DO i = 1, sNx

           IF ( maskC(i,j,1,bi,bj) .NE. 0. ) THEN

C     horizontal area
              darea = rA(i,j,bi,bj)*maskC(i,j,1,bi,bj)

C     accumulate mass of oceans, Greatbatch correction, seaice
              tile_mass(bi,bj) = tile_mass(bi,bj) +
     &          Mload(i,j,bi,bj)*darea
              tile_mass_gc(bi,bj) = tile_mass_gc(bi,bj) +
     &          GCload*darea
              tile_mass_si(bi,bj) = tile_mass_si(bi,bj) +
     &          sIceLoad(i,j,bi,bj)*darea

C     accumulate center-of-mass of oceans (need to divide by total mass at end)
              tile_xcom(bi,bj) = tile_xcom(bi,bj) +
     &          Mload(i,j,bi,bj)*COSlat(i,j,bi,bj)*COSlon(i,j,bi,bj)
     &          * ae * darea
              tile_ycom(bi,bj) = tile_ycom(bi,bj) +
     &          Mload(i,j,bi,bj)*COSlat(i,j,bi,bj)*SINlon(i,j,bi,bj)
     &          * ae * darea
              tile_zcom(bi,bj) = tile_zcom(bi,bj) +
     &          Mload(i,j,bi,bj)*SINlat(i,j,bi,bj)
     &          * ae * darea

C     accumulate oceanic angular momentum due to currents (need depth integral too)
C     Note: depth integral goes from k=1,Nr.  hFacC takes care of R_low and etaN (as per JMC)
              DO k = 1, Nr
                 dvolume = rA(i,j,bi,bj)*drF(k)
     &             * maskC(i,j,k,bi,bj)*hFacC(i,j,k,bi,bj)
                 tile_xoamc(bi,bj) = tile_xoamc(bi,bj) +
     &             ( VN(i,j,k,bi,bj)*SINlon(i,j,bi,bj) -
     &             UE(i,j,k,bi,bj)*
     &             SINlat(i,j,bi,bj)*COSlon(i,j,bi,bj) )
     &             * rhoConst * ae * dvolume
                 tile_yoamc(bi,bj) = tile_yoamc(bi,bj) +
     &             (-VN(i,j,k,bi,bj)*COSlon(i,j,bi,bj) -
     &             UE(i,j,k,bi,bj)*
     &             SINlat(i,j,bi,bj)*SINlon(i,j,bi,bj) )
     &             * rhoConst * ae * dvolume
                 tile_zoamc(bi,bj) = tile_zoamc(bi,bj) +
     &             UE(i,j,k,bi,bj)*COSlat(i,j,bi,bj)
     &             * rhoConst * ae * dvolume
              ENDDO

C     accumulate sea angular momentum due to motion (one layer, so no depth integral needed)
              tile_xoamc_si(bi,bj) = tile_xoamc_si(bi,bj) +
     &          ( VNice(i,j,bi,bj)*SINlon(i,j,bi,bj) -
     &          UEice(i,j,bi,bj)*
     &          SINlat(i,j,bi,bj)*COSlon(i,j,bi,bj) )
     &          * sIceLoad(i,j,bi,bj) * ae * darea
              tile_yoamc_si(bi,bj) = tile_yoamc_si(bi,bj) +
     &          (-VNice(i,j,bi,bj)*COSlon(i,j,bi,bj) -
     &          UEice(i,j,bi,bj)*
     &          SINlat(i,j,bi,bj)*SINlon(i,j,bi,bj) )
     &          * sIceLoad(i,j,bi,bj) * ae * darea
              tile_zoamc_si(bi,bj) = tile_zoamc_si(bi,bj) +
     &          UEice(i,j,bi,bj)*COSlat(i,j,bi,bj)
     &          * sIceLoad(i,j,bi,bj) * ae * darea

C     accumulate oceanic angular momentum due to pressure
              tile_xoamp(bi,bj) = tile_xoamp(bi,bj) -
     &          SINlat(i,j,bi,bj)*COSlat(i,j,bi,bj)*COSlon(i,j,bi,bj)
     &          * sbo_omega * Mload(i,j,bi,bj) * ae*ae * darea
              tile_yoamp(bi,bj) = tile_yoamp(bi,bj) -
     &          SINlat(i,j,bi,bj)*COSlat(i,j,bi,bj)*SINlon(i,j,bi,bj)
     &          * sbo_omega * Mload(i,j,bi,bj) * ae*ae * darea
              tile_zoamp(bi,bj) = tile_zoamp(bi,bj) +
     &          COSlat(i,j,bi,bj) * COSlat(i,j,bi,bj)
     &          * sbo_omega * Mload(i,j,bi,bj) * ae*ae * darea

C     accumulate mass of real freshwater flux
              tile_mass_fw(bi,bj) = tile_mass_fw(bi,bj) +
     &          FWload * darea

C     accumulate center-of-mass of real freshwater flux (need to divide by total FW mass at end)
              tile_xcom_fw(bi,bj) = tile_xcom_fw(bi,bj) +
     &          FWload * COSlat(i,j,bi,bj) * COSlon(i,j,bi,bj)
     &          * ae * darea
              tile_ycom_fw(bi,bj) = tile_ycom_fw(bi,bj) +
     &          FWload * COSlat(i,j,bi,bj) * SINlon(i,j,bi,bj)
     &          * ae * darea
              tile_zcom_fw(bi,bj) = tile_zcom_fw(bi,bj) +
     &          FWload * SINlat(i,j,bi,bj)
     &          * ae * darea

C     accumulate oceanic angular momentum due to real freshwater flux
              tile_xoamp_fw(bi,bj) = tile_xoamp_fw(bi,bj) -
     &          SINlat(i,j,bi,bj)*COSlat(i,j,bi,bj)*COSlon(i,j,bi,bj)
     &          * sbo_omega * FWload * ae*ae * darea
              tile_yoamp_fw(bi,bj) = tile_yoamp_fw(bi,bj) -
     &          SINlat(i,j,bi,bj)*COSlat(i,j,bi,bj)*SINlon(i,j,bi,bj)
     &          * sbo_omega * FWload * ae*ae * darea
              tile_zoamp_fw(bi,bj) = tile_zoamp_fw(bi,bj) +
     &          COSlat(i,j,bi,bj) * COSlat(i,j,bi,bj)
     &          * sbo_omega * FWload * ae*ae * darea

C     end if over ocean
           ENDIF
C     end loop over i,j
         ENDDO
        ENDDO

C     end loop over bi,bj
       ENDDO
      ENDDO

C     sum all global values across model tiles
      CALL GLOBAL_SUM_TILE_RL( tile_mass  , mass  , myThid )
      CALL GLOBAL_SUM_TILE_RL( tile_xcom  , xcom  , myThid )
      CALL GLOBAL_SUM_TILE_RL( tile_ycom  , ycom  , myThid )
      CALL GLOBAL_SUM_TILE_RL( tile_zcom  , zcom  , myThid )
      CALL GLOBAL_SUM_TILE_RL( tile_xoamc , xoamc , myThid )
      CALL GLOBAL_SUM_TILE_RL( tile_yoamc , yoamc , myThid )
      CALL GLOBAL_SUM_TILE_RL( tile_zoamc , zoamc , myThid )
      CALL GLOBAL_SUM_TILE_RL( tile_xoamp , xoamp , myThid )
      CALL GLOBAL_SUM_TILE_RL( tile_yoamp , yoamp , myThid )
      CALL GLOBAL_SUM_TILE_RL( tile_zoamp , zoamp , myThid )

      CALL GLOBAL_SUM_TILE_RL( tile_xoamc_si , xoamc_si , myThid )
      CALL GLOBAL_SUM_TILE_RL( tile_yoamc_si , yoamc_si , myThid )
      CALL GLOBAL_SUM_TILE_RL( tile_zoamc_si , zoamc_si , myThid )
      CALL GLOBAL_SUM_TILE_RL( tile_mass_si , mass_si , myThid )

      CALL GLOBAL_SUM_TILE_RL( tile_mass_fw  , mass_fw  , myThid )
      CALL GLOBAL_SUM_TILE_RL( tile_xcom_fw  , xcom_fw  , myThid )
      CALL GLOBAL_SUM_TILE_RL( tile_ycom_fw  , ycom_fw  , myThid )
      CALL GLOBAL_SUM_TILE_RL( tile_zcom_fw  , zcom_fw  , myThid )
      CALL GLOBAL_SUM_TILE_RL( tile_xoamp_fw , xoamp_fw , myThid )
      CALL GLOBAL_SUM_TILE_RL( tile_yoamp_fw , yoamp_fw , myThid )
      CALL GLOBAL_SUM_TILE_RL( tile_zoamp_fw , zoamp_fw , myThid )
      CALL GLOBAL_SUM_TILE_RL( tile_mass_gc  , mass_gc  , myThid )

C     finish calculating center-of-mass of oceans
C-    note: only master thread updates/modifies var in common block
      _BEGIN_MASTER(myThid)

      IF ( mass.NE.zeroRL ) THEN
        xcom = xcom / mass
        ycom = ycom / mass
        zcom = zcom / mass
      ENDIF

      IF ( mass_fw.NE.zeroRL ) THEN
        xcom_fw = xcom_fw / mass_fw
        ycom_fw = ycom_fw / mass_fw
        zcom_fw = zcom_fw / mass_fw
      ENDIF

C     Add seaice OAMC to total OAMC
      xoamc = xoamc + xoamc_si
      yoamc = yoamc + yoamc_si
      zoamc = zoamc + zoamc_si

      _END_MASTER(myThid)

#endif /* ALLOW_SBO */

      RETURN
      END

#include "PACKAGES_CONFIG.h"
#include "CPP_OPTIONS.h"

C--  File diags_rho.F: density & density advection diagnostics
C--   Contents
C--   o DIAGS_RHO_L
C--   o DIAGS_RHO_G

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: DIAGS_RHO_L
C     !INTERFACE:
      SUBROUTINE DIAGS_RHO_L(
     I                        diagRho, k, bi, bj,
     I                        rho3d, rhoKm1, wFld,
     I                        myTime, myIter, myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R DIAGS_RHO_L
C     | o Density vertical advective term diagnostics
C     *==========================================================*
C     | works with local arrays, and called inside k,bi,bj loops
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine Arguments ==
C     diagRho  :: select which diags to fill
C     k        :: level index
C     bi, bj   :: tile indices
C     rho3d    :: in-situ density anomaly
C     rhoKm1   :: density of water @ level above (k-1), evaluated at pressure level k
C     wFld     :: vertical velocity
C     myTime   :: Current time
C     myIter   :: Iteration number
C     myThid   :: my Thread Id number
      INTEGER diagRho
      INTEGER k, bi, bj
      _RL rho3d (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL rhoKm1(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL wFld  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      _RL myTime
      INTEGER myIter, myThid
CEOP

#ifdef ALLOW_DIAGNOSTICS

C     !LOCAL VARIABLES:
C     == Local variables ==
C     i,j      :: Loop counters
C     tmpFld   :: temporary working array
      INTEGER i,j
      _RL tmpFld(1-OLx:sNx+OLx,1-OLy:sNy+OLy)

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      IF ( k.GE.2 .AND. MOD(diagRho,8).GE.4 ) THEN
C--   Diagnose Vertical velocity times vertical difference
C     of potential density reference at level below (i.e. level k)
        DO j=1,sNy
         DO i=1,sNx
           tmpFld(i,j) = wFld(i,j,k,bi,bj)
     &                 *( rho3d(i,j,k) - rhoKm1(i,j) )*rkSign
         ENDDO
        ENDDO
        CALL DIAGNOSTICS_FILL(tmpFld,'WdRHO_P ',k,1,2,bi,bj,myThid)
        IF ( k.EQ.2 ) CALL DIAGNOSTICS_COUNT('WdRHO_P ',bi,bj,myThid)
      ENDIF

      IF ( k.GE.2 .AND. diagRho.GE.8 ) THEN
C--   Diagnose Vertical velocity times vertical difference
C     of density at fixed Temp & Salt (from level above, i.e. level k-1)
        DO j=1,sNy
         DO i=1,sNx
           tmpFld(i,j) = wFld(i,j,k,bi,bj)
     &                 *( rhoKm1(i,j) - rho3d(i,j,k-1) )*rkSign
         ENDDO
        ENDDO
        CALL DIAGNOSTICS_FILL(tmpFld,'WdRHOdP ',k,1,2,bi,bj,myThid)
        IF ( k.EQ.2 ) CALL DIAGNOSTICS_COUNT('WdRHOdP ',bi,bj,myThid)
      ENDIF

#endif /* ALLOW_DIAGNOSTICS */

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: DIAGS_RHO_G
C     !INTERFACE:
      SUBROUTINE DIAGS_RHO_G(
     I                        rho3d, uFld, vFld, wFld,
     I                        myTime, myIter, myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R DIAGS_RHO_G
C     | o Density & Density advective Flux diagnostics
C     *==========================================================*
C     | works with global arrays; k,bi,bj loops are done here
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine Arguments ==
C     rho3d    :: in-situ density anomaly
C     uFld     :: zonal velocity
C     vFld     :: meridional velocity
C     wFld     :: vertical velocity
C     myTime   :: Current time
C     myIter   :: Iteration number
C     myThid   :: my Thread Id number
      _RL rho3d(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      _RL uFld (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      _RL vFld (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      _RL wFld (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      _RL myTime
      INTEGER myIter, myThid
CEOP

#ifdef ALLOW_DIAGNOSTICS
C     !FUNCTIONS:
      LOGICAL  DIAGNOSTICS_IS_ON
      EXTERNAL DIAGNOSTICS_IS_ON

C     !LOCAL VARIABLES:
C     == Local variables ==
C     i,j      :: Loop counters
C     k, bi,bj :: level & tile indices
C     tmpFld   :: temporary working array
      INTEGER i,j
      INTEGER k, bi,bj
      _RL tmpFld(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL tmpFac

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      CALL DIAGNOSTICS_FILL( rho3d, 'RHOAnoma',
     &                               0, Nr, 0, 1, 1, myThid )
      tmpFac = 1. _d 0
      CALL DIAGNOSTICS_SCALE_FILL( rho3d, tmpFac, 2,
     &                   'RHOANOSQ', 0, Nr, 0, 1, 1, myThid )

      IF ( DIAGNOSTICS_IS_ON('URHOMASS',myThid) ) THEN
       DO bj=myByLo(myThid),myByHi(myThid)
        DO bi=myBxLo(myThid),myBxHi(myThid)
         DO k=1,Nr
          DO j=1,sNy
           DO i=1,sNx+1
             tmpFld(i,j) = uFld(i,j,k,bi,bj)*_hFacW(i,j,k,bi,bj)
     &                   *(rho3d(i-1,j,k,bi,bj)+rho3d(i,j,k,bi,bj))
     &                   *0.5 _d 0
           ENDDO
          ENDDO
          CALL DIAGNOSTICS_FILL(tmpFld,'URHOMASS',k,1,2,bi,bj,myThid)
         ENDDO
        ENDDO
       ENDDO
      ENDIF

      IF ( DIAGNOSTICS_IS_ON('VRHOMASS',myThid) ) THEN
       DO bj=myByLo(myThid),myByHi(myThid)
        DO bi=myBxLo(myThid),myBxHi(myThid)
         DO k=1,Nr
          DO j=1,sNy+1
           DO i=1,sNx
             tmpFld(i,j) = vFld(i,j,k,bi,bj)*_hFacS(i,j,k,bi,bj)
     &                   *(rho3d(i,j-1,k,bi,bj)+rho3d(i,j,k,bi,bj))
     &                   *0.5 _d 0
           ENDDO
          ENDDO
          CALL DIAGNOSTICS_FILL(tmpFld,'VRHOMASS',k,1,2,bi,bj,myThid)
         ENDDO
        ENDDO
       ENDDO
      ENDIF

      IF ( DIAGNOSTICS_IS_ON('WRHOMASS',myThid) ) THEN
       DO bj=myByLo(myThid),myByHi(myThid)
        DO bi=myBxLo(myThid),myBxHi(myThid)
         DO k=1,Nr
          IF ( k.EQ.1 ) THEN
           DO j=1,sNy
            DO i=1,sNx
             tmpFld(i,j) = wFld(i,j,k,bi,bj)*rho3d(i,j,k,bi,bj)
            ENDDO
           ENDDO
          ELSE
           DO j=1,sNy
            DO i=1,sNx
             tmpFld(i,j) = wFld(i,j,k,bi,bj)
     &                   *(rho3d(i,j,k-1,bi,bj)+rho3d(i,j,k,bi,bj))
     &                   *0.5 _d 0
            ENDDO
           ENDDO
          ENDIF
          CALL DIAGNOSTICS_FILL(tmpFld,'WRHOMASS',k,1,2,bi,bj,myThid)
         ENDDO
        ENDDO
       ENDDO
      ENDIF

#endif /* ALLOW_DIAGNOSTICS */

      RETURN
      END

#include "STREAMICE_OPTIONS.h"
#ifdef ALLOW_AUTODIFF
# include "AUTODIFF_OPTIONS.h"
#endif

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

CBOP
      SUBROUTINE STREAMICE_GET_VEL_RESID_ERR_OAD ( err_max, myThid )
C     /============================================================\
C     | SUBROUTINE                                                 |
C     | o                                                          |
C     |============================================================|
C     |                                                            |
C     \============================================================/
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "STREAMICE.h"
#include "STREAMICE_CG.h"

C     !INPUT/OUTPUT ARGUMENTS
      _RL err_max
      INTEGER myThid

#ifdef ALLOW_STREAMICE
#ifdef ALLOW_STREAMICE_FP_ADJ

      INTEGER conv_flag, i, j, bi, bj, myIter
      Real*8 u_dummy (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      Real*8 v_dummy (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL err_sum
      _RL err_sum_tile (nSx,nSy)

      INTEGER ikey_nl
      _RL err_tempu, err_tempv
      _RL max_vel, tempu, tempv, err_lastchange, cgtol
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      LOGICAL isTape

       err_max = 0. _d 0
       err_sum = 0. _d 0

       DO bj = myByLo(myThid), myByHi(myThid)
        DO bi = myBxLo(myThid), myBxHi(myThid)
         err_sum_tile(bi,bj) = 0. _d 0
        ENDDO
       ENDDO

        DO bj = myByLo(myThid), myByHi(myThid)
         DO bi = myBxLo(myThid), myBxHi(myThid)
          DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
            Au_SI (i,j,bi,bj) = 0. _d 0
            Av_SI (i,j,bi,bj) = 0. _d 0
            u_dummy (i,j,bi,bj) = u_streamice(i,j,bi,bj)
            v_dummy (i,j,bi,bj) = v_streamice(i,j,bi,bj)
            ubd_SI (i,j,bi,bj) = 0. _d 0
            vbd_SI (i,j,bi,bj) = 0. _d 0
           ENDDO
          ENDDO
         ENDDO
        ENDDO

        CALL STREAMICE_CG_BOUND_VALS( myThid,
     O    ubd_SI,
     O    vbd_SI)

        CALL STREAMICE_CG_ACTION( myThid,
     O    Au_SI,
     O    Av_SI,
     I    U_dummy,
     I    V_dummy,
     I    0, sNx+1, 0, sNy+1 )

        DO bj = myByLo(myThid), myByHi(myThid)
         DO bi = myBxLo(myThid), myBxHi(myThid)
          DO j=1,sNy
           DO i=1,sNx
            err_tempu = 0. _d 0
            err_tempv = 0. _d 0
            IF (STREAMICE_umask(i,j,bi,bj).eq.1) THEN
             err_tempu =
     &        ABS (Au_SI(i,j,bi,bj)+0*ubd_SI(i,j,bi,bj) -
     &            taudx_SI(i,j,bi,bj))
            ENDIF
            IF (STREAMICE_vmask(i,j,bi,bj).eq.1) THEN
             err_tempv = MAX( err_tempu,
     &        ABS (Av_SI(i,j,bi,bj)+0*vbd_SI(i,j,bi,bj) -
     &            taudy_SI(i,j,bi,bj)))
            ENDIF
            IF (err_tempv .ge. err_max) THEN
             err_max = err_tempv
            ENDIF
           ENDDO
          ENDDO
         ENDDO
        ENDDO

        CALL GLOBAL_MAX_R8 (err_max, myThid)

#endif
#endif
      RETURN
      END

#include "GRDCHK_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C !ROUTINE: GRDCHK_SUMMARY

C !INTERFACE:
      SUBROUTINE GRDCHK_SUMMARY( myThid )

C     !DESCRIPTION:
C     o Summarize the settings for doing gradient checks.
C
C     started: Christian Eckert eckert@mit.edu 06-Mar-2000
C     continued: heimbach@mit.edu: 13-Jun-2001

C     !USES:
      IMPLICIT NONE
C     == Global variables ===
#include "EEPARAMS.h"
#include "SIZE.h"
#include "GRDCHK.h"

C     !INPUT/OUTPUT PARAMETERS:
C     myThid     :: my Thread Id number
      INTEGER myThid

#ifdef ALLOW_GRDCHK
C     !FUNCTIONS:
      INTEGER  ILNBLNK
      EXTERNAL ILNBLNK

C     !LOCAL VARIABLES:
      INTEGER iL
      CHARACTER*(MAX_LEN_MBUF) msgBuf
CEOP

      _BEGIN_MASTER( myThid )

      iL = ILNBLNK( grdchkvarname )

      WRITE(msgBuf,'(A)') ' '
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)')
     &  '// ======================================================='
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT , myThid )
      WRITE(msgBuf,'(A)')
     &  '// Gradient check configuration  >>> START <<<'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)')
     &  '// ======================================================='
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)') ' '
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )

      WRITE(msgBuf,'(A,I8)')
     &  '  grdchkvarindex :               ', grdchkvarindex
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(3A)')
     &  '  matching CTRL xx_file:       "', grdchkvarname(1:iL), '"'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A,1PE10.3)')
     &  '  eps =                        ', grdchk_eps
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A,I8)')
     &  '  First location:                ', nbeg
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A,I8)')
     &  '  Last location:                 ', nend
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A,I8)')
     &  '  Increment:                     ', nstep
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A,I8)')
     &  '  grdchkWhichProc:               ', grdchkwhichproc
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(2(A,I7))') '  iLocTile =', iLocTile,
     &                       ' ,   jLocTile =', jLocTile
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )

      WRITE(msgBuf,'(A)') ' '
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT , myThid )
      WRITE(msgBuf,'(A)')
     &  '// ======================================================='
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)')
     &  '// Gradient check configuration  >>> END <<<'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)')
     &  '// ======================================================='
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT , myThid )
      WRITE(msgBuf,'(A)') ' '
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )

      _END_MASTER( myThid )

#endif /* ALLOW_GRDCHK */

      RETURN
      END

#include "ATM2D_OPTIONS.h"
#ifdef ATM2D_MPI_ON

CStartOfInterface
      SUBROUTINE CPL_RECV_OCN_FIELDS
C     /==========================================================\
C     | SUBROUTINE CPL_RECV_OCN_FIELDS                           |
C     | o Routine for receiving surface fields from ocean        |
C     |   component.                                             |
C     |==========================================================|
C     | This version talks to the MITgcm general circulation     |
C     | model.                                                   |
C     \==========================================================/
      IMPLICIT NONE

C     == Global variables ==
#include "OCNSIZE.h"
#include "OCNVARS.h"
#include "OCNIDS.h"

C     == Routine arguments ==

C     == Local variables ==

CEndOfInterface

C     Receive Ocean mixed-layer depths from ocean component
      CALL COUPRECV_R8TILES( ocnCompName, ocnMxlDName,
     I                       Nx_ocn, Ny_ocn,
     O                       OcMxlD_ocn )

C     Receive sea surface temperature from ocean component
      CALL COUPRECV_R8TILES( ocnCompName, ocnSSTName,
     I                       Nx_ocn, Ny_ocn,
     O                       SST_ocn )

C     Receive sea surface salinity from ocean component
      CALL COUPRECV_R8TILES( ocnCompName, ocnSSSName,
     I                       Nx_ocn, Ny_ocn,
     O                       SSS_ocn )

C     Receive sea surface velocity square from ocean component
      CALL COUPRECV_R8TILES( ocnCompName, ocnSSVsqName,
     I                       Nx_ocn, Ny_ocn,
     O                       vSq_ocn )

      IF ( ocnCpl_exchange_DIC ) THEN
C       Receive ocn->atm flux of CO2 from ocean component
        CALL COUPRECV_R8TILES( ocnCompName, ocnFCO2Name,
     I                       Nx_ocn, Ny_ocn,
     O                       fluxCO2_ocn )
      ENDIF

      RETURN
      END

#endif

#include "DIC_OPTIONS.h"

CBOP
C !ROUTINE: DIC_READPARMS
C !INTERFACE: ==========================================================
      SUBROUTINE DIC_READPARMS( myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R DIC_READPARMS
C     | o Initialise and read dic package parameters
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "DIC_VARS.h"
#include "PTRACERS_SIZE.h"
#include "PTRACERS_PARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
C     myThid    :: My Thread Id. number
      INTEGER myThid
CEOP

#ifdef ALLOW_DIC

C     === Local variables ===
C     msgBuf    :: Informational/error message buffer
C     iUnit     :: Work variable for IO unit number
C     errCount  :: error counter
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      INTEGER iUnit
      INTEGER errCount
#ifndef CARBONCHEM_SOLVESAPHE
      INTEGER selectBTconst, selectFTconst, selectHFconst
      INTEGER selectK1K2const, selectPHsolver
#endif

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C-- Abiotic dic parameters:
C permil   :: set carbon mol/m3 <---> mol/kg conversion factor
C             default permil = 1024.5 kg/m3
C Pa2Atm   :: Conversion factor for atmospheric pressure anomaly pLoad (when
C             coupled to atmospheric model) into Atm.
C             Default assumes pLoad in Pascal: 1 Atm = 1.01325e5 Pa = 1013.25 mb
C  selectBTconst :: estimates borate concentration from salinity:
C     =1 :: use default formulation of Uppström (1974)(same as S/R CARBON_COEFFS)
C     =2 :: use new formulation from Lee et al (2010)
C  selectFTconst :: estimates fluoride concentration from salinity:
C     =1 :: use default formulation of Riley (1965) (same as S/R CARBON_COEFFS)
C     =2 :: use new formulation from Culkin (1965)
C  selectHFconst :: sets the first dissociation constant for hydrogen fluoride:
C     =1 :: use default  Dickson and Riley (1979) (same as S/R CARBON_COEFFS)
C     =2 :: use new formulation of Perez and Fraga (1987)
C  selectK1K2const :: sets the 1rst & 2nd dissociation constants of carbonic acid:
C     =1 :: use default formulation of Millero (1995) with data
C            from Mehrbach et al. (1973) (same as S/R CARBON_COEFFS)
C     =2 :: use formulation of Roy et al. (1993)
C     =3 :: use "combination" formulation of Millero (1995)
C     =4 :: use formulation of Luecker et al. (2000)
C     =5 :: use formulation of Millero (2010, Mar. Fresh Wat. Res.)
C     =6 :: use formulation of Waters, Millero, Woosley (2014, Mar. Chem.)
C  selectPHsolver :: sets the pH solver to use:
C     =0 :: use Follows et al., (2006) solver;
C     =1 :: use the GENERAL solver from Munhoven (2013);
C     =2 :: use SEC solver  from Munhoven (2013);
C     =3 :: use FAST solver from Munhoven (2013);
C  useCalciteSaturation :: dissolve calcium carbonate below the calcite
C                          saturation horizon following method by Karsten Friis
C  calcOmegaCalciteFreq :: Frequency that 3d calcite saturation state, omegaC,
C                          is calculated.
C  nIterCO3             :: Number of iterations of the Follows 3D pH solver to
C                          calculate deep carbonate ion concenetration (no
C                          effect when using the Munhoven/SolveSapHe solvers).
C  selectCalciteDissolution :: flag to control calcite dissolution rate method:
C          =0 : Constant dissolution rate
C          =1 : Follows sinking flux (default);
C          =2 : Keir (1980) Geochem. Cosmochem. Acta. ;
C          =3 : Naviaux et al. 2019, Marine Chemistry
C  calciteDissolRate :: Rate constant (%) for calcite dissolution from
C          e.g. Keir (1980) Geochem. Cosmochem. Acta. or Naviaux et al. (2019)
C  calciteDissolExp  :: Rate exponent for calcite dissolution from
C          e.g. Keir (1980) Geochem. Cosmochem. Acta. or Naviaux et al. (2019)
C  WsinkPIC             :: sinking speed (m/s) of particulate inorganic carbon
C                          for calcite dissolution through the watercolumn
C  selectCalciteBottomRemin :: to either remineralize in bottom or top layer
C                          if flux reaches bottom layer: =0 : bottom, =1 : top
C   zca         :: scale depth for CaCO3 remineralization power law (m)
C----

      NAMELIST /ABIOTIC_PARMS/
     &  permil, Pa2Atm,
     &  selectBTconst, selectFTconst,
     &  selectHFconst, selectK1K2const,
     &  selectPHsolver,
     &  useCalciteSaturation, calcOmegaCalciteFreq,
     &  nIterCO3, selectCalciteDissolution,
     &  WsinkPIC, selectCalciteBottomRemin,
     &  calciteDissolRate, calciteDissolExp,
     &  zca

#ifdef DIC_BIOTIC
C-- Biotic dic parameters:
C   DOPfraction :: fraction of new production going to DOP
C   KDOPRemin   :: DOP remineralization rate (1/s) = 1/(6 month)
C   KRemin      :: remin power law coeff
C   zcrit       :: Minimum Depth (m) over which biological activity
C                  is computed --> determines nlev as the indice of the
C                  first layer deeper than -zcrit
C   O2crit      :: critical oxygen level (mol/m3)
C   R_OP, R_CP  :: stochiometric ratios
C   R_NP, R_FeP
CC Parameters for light/nutrient limited bioac
C   parfrac     :: fraction of Qsw that is PAR
C   k0          :: light attentuation coefficient (1/m)
C   lit0        :: half saturation light constant (W/m2)
C   KPO4        :: half saturation phosphate constant (mol/m3)
C   KFE         :: half saturation fe constant (mol/m3)
CC Iron chemisty values
C   alpfe       :: solubility of aeolian fe
C   fesedflux_pcm :: ratio of sediment iron to sinking organic matter
C   FeIntSec    :: y-axis crossing for Fe_flux = fesedflux_pcm*pflux + FeIntSec
C   freefemax   :: max solubility of free iron (mol/m3)
CC Control variables
C   KScav       :: iron scavenging rate QQ
C   ligand_stab :: ligand-free iron stability constant (m3/mol)
C   ligand_tot  :: total free ligand  (mol/m3)
C   alpha       :: timescale for biological activity
C                  read in alphaUniform and filled in 2d array alpha
C   rain_ratio  :: inorganic/organic carbon rain ratio
C                  read in rainRatioUniform and filled in 2d array rain_ratio

      NAMELIST /BIOTIC_PARMS/
     & DOPfraction, KDOPRemin, KRemin, zcrit,
     & O2crit, R_OP, R_CP, R_NP, R_FeP,
     & parfrac, k0, lit0, KPO4, KFE, kchl,
     & alpfe, fesedflux_pcm, FeIntSec, freefemax,
     & KScav, ligand_stab, ligand_tot,
     & alphaUniform, rainRatioUniform
#endif

      NAMELIST /DIC_FORCING/
     &          DIC_windFile, DIC_atmospFile, DIC_silicaFile,
     &          DIC_deepSilicaFile, DIC_iceFile, DIC_parFile,
     &          DIC_chlaFile, DIC_ironFile,
     &          DIC_forcingPeriod, DIC_forcingCycle,
     &          dic_int1, dic_int2, dic_int3, dic_int4, dic_pCO2

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      _BEGIN_MASTER(myThid)
       errCount = 0

       permil      = 1. _d 0 / 1024.5 _d 0
       Pa2Atm      = 1.01325 _d 5
       selectBTconst   = UNSET_I
       selectFTconst   = UNSET_I
       selectHFconst   = UNSET_I
       selectK1K2const = UNSET_I
       selectPHsolver  = UNSET_I
       useCalciteSaturation = .FALSE.
C-- Parameters used in Calcite Saturation calculation (useCalciteSaturation=T):
C set calcite saturation calculation to every timestep - could be expensive
       calcOmegaCalciteFreq = deltaTClock
C number of iterations for the Follows 3d pH solver
       nIterCO3             = 10
C flag to either remineralize in bottom or top layer if flux
C reaches bottom layer 0=bottom, 1=top
       selectCalciteBottomRemin = 1
C selectCalciteDissolution :: flag to control calcite dissolution rate method:
       selectCalciteDissolution = 1
C Calcite dissolution rate constant (%/day, defaults set later if not read in)
       calciteDissolRate(1) = UNSET_RL
       calciteDissolRate(2) = UNSET_RL
C Calcite dissolution rate exponent (defaults set later if not read in)
       calciteDissolExp(1)  = UNSET_RL
       calciteDissolExp(2)  = UNSET_RL
C set nominal particulate sinking rate (m/s)
       WsinkPIC             = 100. _d 0/86400. _d 0
C-- setting default values for Calcite Saturation params ends here.
       zca                  = 3500. _d 0

#ifdef DIC_BIOTIC
       DOPfraction = 0.67 _d 0
       KDOPRemin   = 1. _d 0/(6. _d 0*30. _d 0*86400. _d 0)
       KRemin      = 0.9 _d 0
       zcrit       = 500. _d 0
       O2crit      = 4. _d -3
       R_OP        =-170. _d 0
       R_CP        = 117. _d 0
       R_NP        = 16. _d 0
       R_FeP       = 0.000468 _d 0
       parfrac     = 0.4 _d 0
       k0          = 0.02 _d 0
       kchl        = 0.02 _d 0
       lit0        = 30. _d 0
       KPO4        = 5. _d -4
       KFE         = 1.2 _d -7
       alpfe       = 0.01 _d 0
       fesedflux_pcm = 6.8 _d -4 * 106. _d 0
       FeIntSec    = 0.5 _d -6 / 86400. _d 0
       freefemax   = 3. _d -7
       KScav       = 0.19 _d 0/(360. _d 0*86400. _d 0)
       ligand_stab = 1. _d 8
       ligand_tot  = 1. _d -6
       alphaUniform     = 2. _d -3/(360. _d 0 * 86400. _d 0)
       rainRatioUniform = 7. _d -2
#endif
       DIC_windFile   = ' '
       DIC_atmospFile = ' '
       DIC_silicaFile = ' '
       DIC_deepSilicaFile = ' '
       DIC_iceFile    = ' '
       DIC_parFile    = ' '
       DIC_chlaFile   = ' '
       DIC_ironFile   = ' '
       dic_int1    = 0
       dic_int2    = 0
       dic_int3    = 0
       dic_int4    = 0
       dic_pCO2    = 278. _d -6
C default periodic forcing to same as for physics
       DIC_forcingPeriod = externForcingPeriod
       DIC_forcingCycle  = externForcingCycle

      WRITE(msgBuf,'(A)') ' DIC_READPARMS: opening data.dic'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     I                    SQUEEZE_RIGHT, myThid )

      CALL OPEN_COPY_DATA_FILE( 'data.dic', 'DIC_READPARMS',
     O                          iUnit, myThid )

C--   Read parameters from open data file:

C-    Abiotic parameters
      READ(UNIT=iUnit,NML=ABIOTIC_PARMS)

#ifdef DIC_BIOTIC
C-    Biotic parameters
      READ(UNIT=iUnit,NML=BIOTIC_PARMS)
#endif

C-    forcing filenames and parameters
      READ(UNIT=iUnit,NML=DIC_FORCING)

      WRITE(msgBuf,'(A)')
     &   ' DIC_READPARMS: finished reading data.dic'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     I                    SQUEEZE_RIGHT, myThid )

C--   Close the open data file
#ifdef SINGLE_DISK_IO
      CLOSE(iUnit)
#else
      CLOSE(iUnit,STATUS='DELETE')
#endif /* SINGLE_DISK_IO */

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C-    derive other parameters:

C-    set parameter default values
      IF ( selectBTconst  .EQ.UNSET_I ) selectBTconst   = 1
      IF ( selectFTconst  .EQ.UNSET_I ) selectFTconst   = 1
      IF ( selectHFconst  .EQ.UNSET_I ) selectHFconst   = 1
      IF ( selectK1K2const.EQ.UNSET_I ) selectK1K2const = 1
      IF ( selectPHsolver .EQ.UNSET_I ) selectPHsolver  = 0

      IF ( selectCalciteDissolution .EQ. 3 ) THEN
C     Calcite dissolution rate constant for the Naviaux et al. 2019 scheme
C      Default values are slightly different from the paper, but consistent with
C      the Darwin model. Values include a ~1e5 cm2/mol conversion factor for
C      specific surface area (SSA) of CaCO3 (e.g. benthic forams or synthetic
C      calcite), for example, Subhas et al. 2018 (Marine Chemistry).
        IF ( calciteDissolRate(1).EQ.UNSET_RL )
     &       calciteDissolRate(1) = 5.22 _d -9
        IF ( calciteDissolRate(2).EQ.UNSET_RL )
     &       calciteDissolRate(2) = 1.65 _d -5
C     Calcite dissolution rate exponent for the Naviaux et al. 2019 scheme
        IF ( calciteDissolExp(1).EQ.UNSET_RL )
     &       calciteDissolExp(1) = 0.11 _d 0
        IF ( calciteDissolExp(2).EQ.UNSET_RL )
     &       calciteDissolExp(2) = 4.76 _d 0
      ELSE
C     use second set of Coeff only if select case =3
       calciteDissolRate(2) = 0.0 _d 0
       calciteDissolExp(2)  = 0.0 _d 0
C     set default for other cases:
       IF ( selectCalciteDissolution .EQ. 0 ) THEN
C     Calcite dissolution rate constant
        IF ( calciteDissolRate(1).EQ.UNSET_RL )
     &       calciteDissolRate(1) = 1 _d 0/(360 _d 0*86400.0 _d 0)
C     Calcite dissolution rate exponent not used for constant dissolution
        calciteDissolExp(1) = 0.0 _d 0
       ELSE
C     Calcite dissolution rate constant (%/day) for Keir dissolution
        IF ( calciteDissolRate(1).EQ.UNSET_RL )
     &       calciteDissolRate(1) = 7.177 _d 0
C     Calcite dissolution rate exponent for Keir dissolution (4.2 for aragonite)
        IF ( calciteDissolExp(1).EQ.UNSET_RL )
     &       calciteDissolExp(1) = 4.54 _d 0
       ENDIF
      ENDIF

#ifdef DIC_BIOTIC
       QSW_underice = .FALSE.
#ifdef USE_QSW_UNDERICE
       QSW_underice = .TRUE.
#elif (defined (USE_QSW))
C if using Qsw and seaice, then ice fraction is already
C taken into account
       IF ( useSEAICE ) QSW_underice = .TRUE.
       IF ( useThSIce ) QSW_underice = .TRUE.
#endif
#endif /* DIC_BIOTIC */

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C--   Print out parameter values :

      iUnit = standardMessageUnit
      WRITE(msgBuf,'(A)') ' '
      CALL PRINT_MESSAGE(msgBuf,iUnit,SQUEEZE_RIGHT,myThid)
      WRITE(msgBuf,'(A)') '// ==================================='
      CALL PRINT_MESSAGE(msgBuf,iUnit,SQUEEZE_RIGHT,myThid)
      WRITE(msgBuf,'(A)') '// DIC package parameters :'
      CALL PRINT_MESSAGE(msgBuf,iUnit,SQUEEZE_RIGHT,myThid)
      WRITE(msgBuf,'(A)') '// ==================================='
      CALL PRINT_MESSAGE(msgBuf,iUnit,SQUEEZE_RIGHT,myThid)

#ifdef CARBONCHEM_SOLVESAPHE
C Record the solver to calculate pH and evaluate surface ocean pCO2
      IF ( selectPHsolver.GT.0 ) THEN
         WRITE(msgBuf,'(A)')
     &  'Using Munhoven (2013) Solvesaphe for pH/pCO2'
         CALL PRINT_MESSAGE(msgBuf,iUnit,SQUEEZE_RIGHT,myThid)
      ELSEIF ( selectPHsolver.EQ.0 ) THEN
         WRITE(msgBuf,'(A)')
     &  'Using Follows et al. (2006) for pH/pCO2'
         CALL PRINT_MESSAGE(msgBuf,iUnit,SQUEEZE_RIGHT,myThid)
      ENDIF
#endif /* CARBONCHEM_SOLVESAPHE */

C Record which carbonate coefficients are used and which pH/pCO2 solver
#ifdef CARBONCHEM_SOLVESAPHE
      WRITE(msgBuf,'(A)')
     &  'Using Munhoven (2013) Solvesaphe carbon coefficients'
      CALL PRINT_MESSAGE(msgBuf,iUnit,SQUEEZE_RIGHT,myThid)
C Munhoven (2013)'s "Solvesaphe" coefficients have several options:
      IF ( selectK1K2const.EQ.1 ) THEN
         WRITE(msgBuf,'(A)')
     &  'Using Millero (1995)/Mehrbach K1 and K2 coefficients'
         CALL PRINT_MESSAGE(msgBuf,iUnit,SQUEEZE_RIGHT,myThid)
      ELSEIF ( selectK1K2const.EQ.2 ) THEN
         WRITE(msgBuf,'(A)')
     &  'Using Roy et al. (1993) K1 and K2 coefficients'
         CALL PRINT_MESSAGE(msgBuf,iUnit,SQUEEZE_RIGHT,myThid)
      ELSEIF ( selectK1K2const.EQ.3 ) THEN
         WRITE(msgBuf,'(A)')
     &  'Using Millero (1995) "consensus" K1 and K2 coefficients'
         CALL PRINT_MESSAGE(msgBuf,iUnit,SQUEEZE_RIGHT,myThid)
      ELSEIF ( selectK1K2const.EQ.4 ) THEN
         WRITE(msgBuf,'(A)')
     &  'Using Luecker et al. (2000) K1 and K2 coefficients'
         CALL PRINT_MESSAGE(msgBuf,iUnit,SQUEEZE_RIGHT,myThid)
      ELSEIF ( selectK1K2const.EQ.5 ) THEN
         WRITE(msgBuf,'(A)')
     &  'Using Millero et al. (2010) K1 and K2 coefficients'
         CALL PRINT_MESSAGE(msgBuf,iUnit,SQUEEZE_RIGHT,myThid)
      ELSEIF ( selectK1K2const.EQ.6 ) THEN
         WRITE(msgBuf,'(A)')
     &  'Using Waters et al. (2014) K1 and K2 coefficients'
         CALL PRINT_MESSAGE(msgBuf,iUnit,SQUEEZE_RIGHT,myThid)
      ENDIF

      IF ( selectHFconst.EQ.1 ) THEN
         WRITE(msgBuf,'(A)')
     &  'Using Dickson and Riley (1979) KF coefficient'
         CALL PRINT_MESSAGE(msgBuf,iUnit,SQUEEZE_RIGHT,myThid)
      ELSEIF ( selectHFconst.EQ.2 ) THEN
         WRITE(msgBuf,'(A)')
     &  'Using Perez and Fraga (1987) KF coefficient'
         CALL PRINT_MESSAGE(msgBuf,iUnit,SQUEEZE_RIGHT,myThid)
      ENDIF

      IF ( selectBTconst.EQ.1 ) THEN
         WRITE(msgBuf,'(A)')
     & 'Using Uppstrom (1974) BT estimation from salinity'
         CALL PRINT_MESSAGE(msgBuf,iUnit,SQUEEZE_RIGHT,myThid)
      ELSEIF ( selectBTconst.EQ.2 ) THEN
         WRITE(msgBuf,'(A)')
     &  'Using Lee et al (2010) BT estimation from salinity'
         CALL PRINT_MESSAGE(msgBuf,iUnit,SQUEEZE_RIGHT,myThid)
      ENDIF

      IF ( selectFTconst.EQ.1 ) THEN
         WRITE(msgBuf,'(A)')
     &  'Using Riley (1965) FT estimation from salinity'
         CALL PRINT_MESSAGE(msgBuf,iUnit,SQUEEZE_RIGHT,myThid)
      ELSEIF ( selectBTconst.EQ.2 ) THEN
         WRITE(msgBuf,'(A)')
     &  'Using Culkin (1965) FT estimation from salinity'
         CALL PRINT_MESSAGE(msgBuf,iUnit,SQUEEZE_RIGHT,myThid)
      ENDIF
#else /* CARBONCHEM_SOLVESAPHE */
C OCMIP2 Coefficients from S/R CARBON_COEFFS in CARBON_CHEM.F
      WRITE(msgBuf,'(A)')
     &  'Using Millero (1995)/Mehrbach K1 and K2 coefficients'
      CALL PRINT_MESSAGE(msgBuf,iUnit,SQUEEZE_RIGHT,myThid)
      WRITE(msgBuf,'(A)')
     &  'Using Dickson and Riley (1979) KF coefficient'
      CALL PRINT_MESSAGE(msgBuf,iUnit,SQUEEZE_RIGHT,myThid)
      WRITE(msgBuf,'(A)')
     &  'Using Uppstrom (1974) BT estimation from salinity'
      CALL PRINT_MESSAGE(msgBuf,iUnit,SQUEEZE_RIGHT,myThid)
      WRITE(msgBuf,'(A)')
     &  'Using Riley (1965) FT estimation from salinity'
      CALL PRINT_MESSAGE(msgBuf,iUnit,SQUEEZE_RIGHT,myThid)
#endif /* CARBONCHEM_SOLVESAPHE */

C- namelist ABIOTIC_PARMS
       CALL WRITE_0D_RL( permil, INDEX_NONE,'permil =',
     &  ' /* Ref. density to convert mol/m3 to mol/kg */')
       CALL WRITE_0D_RL( Pa2Atm, INDEX_NONE,'Pa2Atm =',
     &  ' /* Atmosph. pressure conversion coeff (to Atm) */')
       CALL WRITE_0D_RL( zca, INDEX_NONE,'zca =',
     &  ' /* Scale depth for CaCO3 remineralization (m) */')
       CALL WRITE_0D_L( useCalciteSaturation, INDEX_NONE,
     &  'useCalciteSaturation  =',
     &  '  /* Flag for omegaC calculation on/off */')
      IF ( useCalciteSaturation ) THEN
       CALL WRITE_0D_RL( calcOmegaCalciteFreq, INDEX_NONE,
     &  'calcOmegaCalciteFreq =',
     &  ' /* Frequency of calcite saturation calculation (s) */')
       IF ( selectCalciteDissolution .LT. 3 ) THEN
        IF ( selectCalciteDissolution .EQ. 0 )
     &  WRITE(msgBuf,'(A)') 'Using Constant dissolution rate method'
        IF ( selectCalciteDissolution .EQ. 1 )
     &  WRITE(msgBuf,'(A)') 'Using Follows default dissolution method'
        IF ( selectCalciteDissolution .EQ. 2 )
     &  WRITE(msgBuf,'(A)') 'Using Keir (1980) dissolution method'
        IF ( selectCalciteDissolution .GE. 0 ) THEN
         CALL PRINT_MESSAGE(msgBuf,iUnit,SQUEEZE_RIGHT,myThid)
         CALL WRITE_0D_RL( calciteDissolRate(1), INDEX_NONE,
     &   'calciteDissolRate =',
     &   ' /* Rate constant for calcite dissolution (%/day) */')
        ENDIF
        IF ( selectCalciteDissolution .GE. 1  ) THEN
         CALL WRITE_0D_RL( calciteDissolExp(1), INDEX_NONE,
     &   'calciteDissolExp = ',
     &   ' /* Rate exponent for calcite dissolution */')
        ENDIF
       ELSEIF ( selectCalciteDissolution .EQ. 3 ) THEN
        WRITE(msgBuf,'(A)')
     &               'Using Naviaux et al. (2019) dissolution rates'
        CALL PRINT_MESSAGE(msgBuf,iUnit,SQUEEZE_RIGHT,myThid)
        CALL WRITE_0D_RL( calciteDissolRate(1), INDEX_NONE,
     &   'calciteDissolRate(1) =',
     &   ' /* Rate constant for dissolution (%/day), omega > 0.8272 */')
        CALL WRITE_0D_RL( calciteDissolRate(2), INDEX_NONE,
     &   'calciteDissolRate(2) =',
     &   ' /* Rate constant for dissolution (%/day), omega < 0.8272 */')
        CALL WRITE_0D_RL( calciteDissolExp(1), INDEX_NONE,
     &   'calciteDissolExp(1) = ',
     &   ' /* Rate exponent for dissolution, omega > 0.8272 */')
        CALL WRITE_0D_RL( calciteDissolExp(2), INDEX_NONE,
     &   'calciteDissolExp(2) = ',
     &   ' /* Rate exponent for dissolution, omega < 0.8272 */')
       ENDIF
       CALL WRITE_0D_RL( WsinkPIC, INDEX_NONE, 'WsinkPIC =',
     &  ' /* Sinking speed of particulate inorganic carbon (m/s) */')
       CALL WRITE_0D_I( selectCalciteBottomRemin, INDEX_NONE,
     &  'selectCalciteBottomRemin =',
     &  ' /* Remineralize CO3 bottom flux: =0: here, =1: top layer */')
      ENDIF

#ifdef DIC_BIOTIC
C- namelist BIOTIC_PARMS
       CALL WRITE_0D_RL( DOPfraction, INDEX_NONE,'DOPfraction =',
     &  ' /* Fraction of new production going to DOP */')
       CALL WRITE_0D_RL( KDOPRemin, INDEX_NONE,'KDOPRemin =',
     &  ' /* DOP remineralization rate (1/s) */')
       CALL WRITE_0D_RL( KRemin, INDEX_NONE,'KRemin =',
     &  ' /* Remin power law coeff. */')
       CALL WRITE_0D_RL( zcrit, INDEX_NONE,'zcrit =',
     &  ' /* Minimum depth for biological activity (m) */')
       CALL WRITE_0D_RL( O2crit, INDEX_NONE,'O2crit =',
     &  ' /* Critical oxygen level (mol/m3) */')
       CALL WRITE_0D_RL( R_OP, INDEX_NONE,'R_OP =',
     &  ' /* Stochiometric ratio R_OP */')
       CALL WRITE_0D_RL( R_CP, INDEX_NONE,'R_CP =',
     &  ' /* Stochiometric ratio R_CP */')
       CALL WRITE_0D_RL( R_NP, INDEX_NONE,'R_NP =',
     &  ' /* Stochiometric ratio R_NP */')
       CALL WRITE_0D_RL( R_FeP, INDEX_NONE,'R_FeP =',
     &  ' /* Stochiometric ratio R_FeP */')
       CALL WRITE_0D_RL( parfrac, INDEX_NONE,'parfrac =',
     &  ' /* Fraction of Qsw that is PAR */')
       CALL WRITE_0D_RL( k0, INDEX_NONE,'k0 =',
     &  ' /* Light attentuation coefficient, water (1/m) */')
       CALL WRITE_0D_RL( kchl, INDEX_NONE,'kchl =',
     &  ' /* Light attentuation coefficient, chlorophyll (m2/mg) */')
       CALL WRITE_0D_RL( lit0, INDEX_NONE,'lit0 =',
     &  ' /* Half saturation light constant (W/m2) */')
       CALL WRITE_0D_RL( KPO4, INDEX_NONE,'KPO4 =',
     &  ' /* Half saturation phosphate constant (mol/m3) */')
       CALL WRITE_0D_RL( KFE, INDEX_NONE,'KFE =',
     &  ' /* Half saturation fe constant (mol/m3) */')
       CALL WRITE_0D_RL( alpfe, INDEX_NONE,'alpfe =',
     &  ' /* Solubility of aeolian fe */')
       CALL WRITE_0D_RL( fesedflux_pcm, INDEX_NONE,'fesedflux_pcm =',
     &  ' /* Sediment Fe flux = fesedflux_pcm*pflux+FeIntSec */')
       CALL WRITE_0D_RL( FeIntSec, INDEX_NONE,'FeIntSec =',
     &  ' /* Sediment Fe flux = fesedflux_pcm * pflux + FeIntSec */')
       CALL WRITE_0D_RL( freefemax, INDEX_NONE,'freefemax =',
     &  ' /* Max solubility of free iron (mol/m3) */')
       CALL WRITE_0D_RL( KScav, INDEX_NONE,'KScav =',
     &  ' /* Iron scavenging rate */')
       CALL WRITE_0D_RL( ligand_stab, INDEX_NONE,'ligand_stab =',
     &  ' /* Ligand-free iron stability constant (m3/mol) */')
       CALL WRITE_0D_RL( ligand_tot, INDEX_NONE,'ligand_tot =',
     &  ' /* Total free ligand  (mol/m3) */')
       CALL WRITE_0D_RL( alphaUniform, INDEX_NONE,'alphaUniform =',
     &  ' /* Timescale for biological activity */')
       CALL WRITE_0D_RL(rainRatioUniform,INDEX_NONE,'rainRatioUniform=',
     &  ' /* Inorganic/organic carbon rain ratio */')
       CALL WRITE_0D_L( QSW_underice, INDEX_NONE, 'QSW_underice  =',
     &  '  /* Flag for Qsw under Sea-Ice (i.e. SI fract included) */')
#endif /* DIC_BIOTIC */

C- namelist DIC_FORCING
       CALL WRITE_0D_C( DIC_windFile, -1, INDEX_NONE, 'DIC_windFile =',
     & '  /* File name of wind speeds */')
       CALL WRITE_0D_C( DIC_atmospFile, -1,INDEX_NONE,'DIC_atmospFile=',
     & '  /* File name of atmospheric pressure*/')
       CALL WRITE_0D_C( DIC_silicaFile, -1,INDEX_NONE,
     & 'DIC_silicaFile=','  /* File name of surface silica */')
      IF ( useCalciteSaturation ) THEN
       CALL WRITE_0D_C( DIC_deepSilicaFile, -1,INDEX_NONE,
     & 'DIC_deepSilicaFile=','  /* File name of 3d silica field */')
      ENDIF
       CALL WRITE_0D_C( DIC_iceFile, -1, INDEX_NONE, 'DIC_iceFile =',
     & '  /* File name of seaice fraction */')
       CALL WRITE_0D_C( DIC_parFile, -1,INDEX_NONE,'DIC_parFile=',
     & '  /* File name of photosynthetically available radiation */')
       CALL WRITE_0D_C( DIC_chlaFile, -1,INDEX_NONE,'DIC_chlaFile=',
     & '  /* File name of chlorophyll climatology */')
       CALL WRITE_0D_C( DIC_ironFile, -1, INDEX_NONE, 'DIC_ironFile =',
     & '  /* File name of aeolian iron flux */')
       CALL WRITE_0D_RL( DIC_forcingPeriod,
     &   INDEX_NONE,'DIC_forcingPeriod =',
     &  ' /* Periodic forcing parameter specific for DIC (s) */')
       CALL WRITE_0D_RL( DIC_forcingCycle,
     &   INDEX_NONE,'DIC_forcingCycle =',
     &  ' /* Periodic forcing parameter specific for DIC (s) */')
       CALL WRITE_0D_I( dic_int1, INDEX_NONE, 'dic_int1 =',
     &  '  /*  */')
       CALL WRITE_0D_I( dic_int2, INDEX_NONE, 'dic_int2 =',
     &  '  /*  */')
       CALL WRITE_0D_I( dic_int3, INDEX_NONE, 'dic_int3 =',
     &  '  /*  */')
       CALL WRITE_0D_I( dic_int4, INDEX_NONE, 'dic_int4 =',
     &  '  /*  */')
       CALL WRITE_0D_RL( dic_pCO2, INDEX_NONE,'dic_pCO2 =',
     &  ' /* Atmospheric pCO2 to be read in data.dic */')

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      IF ( dic_int1.EQ.0 .AND. dic_pCO2.NE.278. _d -6 ) THEN
        WRITE(msgBuf,'(A)')
     &    'DIC_READPARMS: cannot change default dic_pCO2 if dic_int1=0'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF
#ifdef ALLOW_OLD_VIRTUALFLUX
      IF ( PTRACERS_EvPrRn(1).NE.UNSET_RL .OR.
     &     PTRACERS_EvPrRn(2).NE.UNSET_RL ) THEN
        WRITE(msgBuf,'(2A)') 'DIC_READPARMS: ',
     &    'when ALLOW_OLD_VIRTUALFLUX is defined (in DIC_OPTIONS.h)'
        CALL PRINT_ERROR( msgBuf, myThid )
        IF ( PTRACERS_EvPrRn(1).NE.UNSET_RL ) THEN
         WRITE(msgBuf,'(2A)') 'DIC_READPARMS: ',
     &   ' cannot set PTRACERS_EvPrRn(1) (in data.ptracers)'
         CALL PRINT_ERROR( msgBuf, myThid )
        ENDIF
        IF ( PTRACERS_EvPrRn(2).NE.UNSET_RL ) THEN
         WRITE(msgBuf,'(2A)') 'DIC_READPARMS: ',
     &   ' cannot set PTRACERS_EvPrRn(2) (in data.ptracers)'
         CALL PRINT_ERROR( msgBuf, myThid )
        ENDIF
        errCount = errCount + 1
      ENDIF
#endif /* ALLOW_OLD_VIRTUALFLUX */

#ifdef CARBONCHEM_SOLVESAPHE
      IF ( selectHFconst.LT.1 .OR. selectHFconst.GT.2 .OR.
     &     selectBTconst.LT.1 .OR. selectBTconst.GT.2 .OR.
     &     selectFTconst.LT.1 .OR. selectFTconst.GT.2 ) THEN
        WRITE(msgBuf,'(2A)') 'DIC_READPARMS: ',
     &        'Invalid value for selectHF, selectBT or selectFT'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF
      IF ( selectK1K2const.LT.1 .OR. selectK1K2const.GT.6 ) THEN
        WRITE(msgBuf,'(2A)') 'DIC_READPARMS: ',
     &        'Invalid value for selectK1K2const (< 1 or > 6)'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF
      IF ( selectPHsolver.LT.0 .OR. selectPHsolver.GT.3 ) THEN
        WRITE(msgBuf,'(2A)') 'DIC_READPARMS: ',
     &        'Invalid value for selectPHsolver (< 0 or > 3)'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF
#else /* CARBONCHEM_SOLVESAPHE */
      IF ( selectBTconst.NE.1 .OR. selectFTconst.NE.1 .OR.
     &     selectHFconst.NE.1 .OR. selectK1K2const.NE.1 ) THEN
        WRITE(msgBuf,'(2A)') 'DIC_READPARMS: ',
     &    'to use: selectHF, selectBT, selectFT or selectK1K2const'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(2A)') 'DIC_READPARMS: ',
     &    'needs: "#define CARBONCHEM_SOLVESAPHE" in "DIC_OPTIONS.h"'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF
      IF ( selectPHsolver.NE.0 ) THEN
        WRITE(msgBuf,'(2A)') 'DIC_READPARMS: ',
     &    'to use: selectPHsolver > 0'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(2A)') 'DIC_READPARMS: ',
     &    'needs: "#define CARBONCHEM_SOLVESAPHE" in "DIC_OPTIONS.h"'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF
#endif /* CARBONCHEM_SOLVESAPHE */

#ifdef DIC_CALCITE_SAT
C Issue an error and stop for invalid selectCalciteDissolution
      IF ( ( selectCalciteDissolution .LT. 0 .OR.
     &       selectCalciteDissolution .GT. 3 )
     &              .AND. useCalciteSaturation ) THEN
        WRITE(msgBuf,'(2A,I4,A)') 'DIC_READPARMS: ',
     &    'selectCalciteDissolution =', selectCalciteDissolution,
     &    ' : invalid value'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF
C Issue a soft message if a deepSilicaFile is supplied
C    but will not be used because useCalciteSaturation is FALSE
      IF ( DIC_deepSilicaFile .NE. ' ' .AND.
     &                        .NOT. useCalciteSaturation ) THEN
        WRITE(msgBuf,'(2A)') 'DIC_READPARMS: ',
     &    'to use: DIC_deepSilicaFile (3d silicate input)'
         CALL PRINT_MESSAGE(msgBuf,iUnit,SQUEEZE_RIGHT,myThid)
        WRITE(msgBuf,'(2A)') 'DIC_READPARMS: ',
     &    'needs: "useCalciteSaturation=.TRUE." in "data.dic"'
         CALL PRINT_MESSAGE(msgBuf,iUnit,SQUEEZE_RIGHT,myThid)
      ENDIF
#else
C Issue an error and stop if useCalciteSaturation is TRUE but
C    DIC_CALCITE_SATURATION code is not compiled
      IF ( useCalciteSaturation ) THEN
        WRITE(msgBuf,'(2A)') 'DIC_READPARMS: ',
     &    'to enable: useCalciteSaturation'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(2A)') 'DIC_READPARMS: ',
     &    'needs: "#define DIC_CALCITE_SAT" in "DIC_OPTIONS.h"'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF

C Issue an error and stop if deepSilicaFile is supplied but
C    DIC_CALCITE_SATURATION code is not compiled
      IF ( DIC_deepSilicaFile .NE. ' '  ) THEN
        WRITE(msgBuf,'(2A)') 'DIC_READPARMS: ',
     &    'to use: DIC_deepSilicaFile (3d silicate input)'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(2A)') 'DIC_READPARMS: ',
     &    'needs: "#define DIC_CALCITE_SAT" in "DIC_OPTIONS.h"'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF
#endif /* DIC_CALCITE_SAT */

      IF ( errCount.GE.1 ) THEN
        WRITE(msgBuf,'(A,I3,A)')
     &       'DIC_READPARMS: detected', errCount,' fatal error(s)'
        CALL PRINT_ERROR( msgBuf, myThid )
        CALL ALL_PROC_DIE( 0 )
        STOP 'ABNORMAL END: S/R DIC_READPARMS'
      ENDIF
      _END_MASTER(myThid)

C--   Everyone else must wait for the parameters to be loaded
      _BARRIER

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#endif /* ALLOW_DIC */

      RETURN
      END

#include "ctrparam.h"
#include "ATM2D_OPTIONS.h"
C
      SUBROUTINE CALC_FILELOAD( curTime, iloop, aloop,
     &                        wght0, wght1,
     &                        intime0, intime1,
     &                        ifTime, myThid)

C     *==========================================================*
C     | Determines weights to be used for external files.        |
C     *==========================================================*

      IMPLICIT NONE

#include "ATMSIZE.h"
#include "SIZE.h"
#include "EEPARAMS.h"
#include "ATM2D_VARS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
C     curTime - Simulation time (s) starting from year 0
C     iloop - loop counter for main loop (coupled periods)
C     aloop - loop counter for atm time steps (within a coupled per.)
C     wght0, wght1 - weights of the two months to average
C     intime0 - first of the two month to average
C     intime1 - latter of the two months to average
C     iftime - return true if time to do a file re-load
C     myThid - Thread no. that called this routine.
      _RL  curTime
      INTEGER iloop
      INTEGER aloop
      _RL  wght0
      _RL  wght1
      INTEGER intime0
      INTEGER intime1
      LOGICAL ifTime
      INTEGER myThid


C     !LOCAL VARIABLES

      _RL  dmonth(0:13)
      DATA dmonth /-1339200.D0, 1339200.D0, 3888000.D0, 6436800.D0,
     &          9072000.D0, 11707200.D0, 14342400.D0, 16977600.D0,
     &         19656000.D0, 22291200.D0, 24926400.D0, 27561600.D0,
     &         30196800.D0, 32875200.D0/
C               /-15.5D0*86400.D0, 15.5D0*86400.D0, 45.0D0*86400.D0,
C     &           74.5D0*86400.D0, 105.0D0*86400.D0, 135.5D0*86400.D0,
C     &          166.0D0*86400.D0, 196.5D0*86400.D0, 227.5D0*86400.D0,
C     &          258.0D0*86400.D0, 288.5D0*86400.D0, 319.0D0*86400.D0,
C     &          349.5D0*86400.D0, 380.5D0*86400.D0/
      _RL secYr
      DATA secYr /31536000.D0/   !ignore externForcingCycle from data
      _RL  ifcyc     ! time in current year, in seconds
      INTEGER mn     ! loop counter

      iftime=.FALSE.
      ifcyc=mod(curTime,secYr)

      DO mn=1,13

        IF ((ifcyc.GT.dmonth(mn-1)).AND.(ifcyc.LE.dmonth(mn)))
     &      intime1=mn

      ENDDO

C     hence if curTime falls exactly mid-month, it is dmonth(intime1)
C     although this should never happen if passed curTime is a mid-step time

      intime0=intime1-1
      wght1=(ifcyc - dmonth(intime0)) /
     &     (dmonth(intime1) - dmonth(intime0))
      wght0= 1. _d 0-wght1

      IF (ifcyc.LE.dmonth(intime0) + dtatmo) ifTime=.TRUE.
      IF ((iloop.EQ.1).AND.(aloop.EQ.1)) ifTime= .TRUE.

      IF (intime0.EQ.0) intime0=12
      IF (intime1.EQ.13) intime1=1

      RETURN
      END

#include "CAL_OPTIONS.h"

      subroutine cal_PrintDate(
     I                          caldate,
     I                          mythid
     &                        )

c     ==================================================================
c     SUBROUTINE cal_PrintDate
c     ==================================================================
c
c     o Print a calendar date.
c
c     Purpose: Print a date as used by the calendar tool in some nice
c              format by using the MITgcmuvs print routine
c
c     started: Christian Eckert eckert@mit.edu  30-Jun-1999
c
c     changed: Christian Eckert eckert@mit.edu  19-Jan-2000
c
c              - inserted print statements
c
c              Christian Eckert eckert@mit.edu  03-Feb-2000
c
c              - Introduced new routine and function names, cal_<NAME>,
c                for verion 0.1.3.
c
c     ==================================================================
c     SUBROUTINE cal_PrintDate
c     ==================================================================

      implicit none

c     == global variables ==

#include "EEPARAMS.h"

c     == routine arguments ==

c     caldate - date in the format used by the calendar tool.
c     mythid  - thread number for this instance of the routine.

      integer caldate(4)
      integer mythid

c     == local variables ==

      integer ierr, ioUnit
      character*(max_len_mbuf) msgbuf

c     == end of interface ==

      ioUnit=standardMessageUnit

      if ( caldate(4) .gt. 0 ) then
c       Print the calendar date.
        write(msgBuf,'(i10,i8,i3,i4)') caldate(1), caldate(2),
     &                                 caldate(3), caldate(4)
        CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )

      else if ( caldate(4) .eq. -1 ) then
c       Print the time interval.
        write(msgBuf,'(i10,i8,i3,i4)') caldate(1), caldate(2),
     &                                 caldate(3), caldate(4)
        CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )

      else

        ierr = 2001
        call cal_PrintError( ierr, mythid )
        stop ' stopped in cal_PrintDate.'

      endif

      return
      end

#include "RUNCLOCK_OPTIONS.h"

      SUBROUTINE RUNCLOCK_CHECK( myThid )
C     /==========================================================\
C     | SUBROUTINE RUNCLOCK_CHECK                                  |
C     | o Check dependances with other packages                  |
C     |==========================================================|
C     \==========================================================/
      IMPLICIT NONE

C     === Global variables ===
#include "EEPARAMS.h"
#include "RUNCLOCK.h"

C     === Routine arguments ===
C     myThid -  Number of this instances
      INTEGER myThid

C     === Local variables ===
C     msgBuf      - Informational/error meesage buffer
      CHARACTER*(MAX_LEN_MBUF) msgBuf


#ifdef ALLOW_RUNCLOCK

       WRITE(msgBuf,'(A)') 'RUNCLOCK_CHECK: #define RUNCLOCK'
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT , 1)


C--  Check parameters:

      _BEGIN_MASTER(myThid)


      _END_MASTER(myThid)

#endif /* ALLOW_RUNCLOCK */
      RETURN
      END

#include "LONGSTEP_OPTIONS.h"

CBOP
C     !ROUTINE: LONGSTEP_DIAGNOSTICS_INIT
C     !INTERFACE:
      SUBROUTINE LONGSTEP_DIAGNOSTICS_INIT( myThid )
C     !DESCRIPTION:
C     Routine to initialize longstep diagnostics

C     !USES:
      IMPLICIT NONE
C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "LONGSTEP_PARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
C     myThid -  Number of this instance of LONGSTEP_DIAGNOSTICS_INIT
      INTEGER myThid
CEOP

#ifdef ALLOW_DIAGNOSTICS
C     !LOCAL VARIABLES:
C     === Local variables ===
C     msgBuf      - Informational/error message buffer
c     CHARACTER*(MAX_LEN_MBUF) msgBuf

      INTEGER       diagNum
      INTEGER       diagMate
      CHARACTER*8   diagName
      CHARACTER*16  diagCode
      CHARACTER*16  diagUnits
      CHARACTER*(80) diagTitle

C--   Add diagnostics to the (long) list

      diagName  = 'LSwVel  '
      diagTitle = 'Vertical Component of Velocity (m/s)'
      diagUnits = 'm/s             '
      diagCode  = 'WM      LR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'LSuVel  '
      diagTitle = 'Zonal Component of Velocity (m/s)'
      diagUnits = 'm/s             '
      diagCode  = 'UUR     MR      '
      diagMate  = diagNum + 2
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I   diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

      diagName  = 'LSvVel  '
      diagTitle = 'Meridional Component of Velocity (m/s)'
      diagUnits = 'm/s             '
      diagCode  = 'VVR     MR      '
      diagMate  = diagNum
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I   diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

      diagName  = 'LStheta '
      diagTitle = 'Potential Temperature'
      diagUnits = 'degC            '
      diagCode  = 'SMR     MR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'LSsalt  '
      diagTitle = 'Salinity'
      diagUnits = 'g/kg            '
      diagCode  = 'SMR     MR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      IF ( ivdc_kappa .NE. 0. _d 0 ) THEN
        diagName  = 'LScnvAdj'
        diagTitle = 'Convective Adjustment Index [0-1] '
        diagUnits = 'fraction        '
        diagCode  = 'SM      LR      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )
      ENDIF

#ifdef SHORTWAVE_HEATING
      diagName  = 'LSqsw   '
      diagTitle = 'net Short-Wave radiation (+=up)'
      diagUnits = 'W/m^2           '
      diagCode  = 'SM      U1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )
#endif

      diagName  = 'LSfwFlux'
      diagTitle = 'net surface Fresh-Water flux into the ocean'
      diagUnits = 'kg/m^2/s        '
      diagCode  = 'SM      U1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

#ifdef ALLOW_GMREDI
      IF ( useGMRedi ) THEN
       diagName  = 'LSkwx   '
       diagTitle = 'K_31 element (W.point, X.dir) of GM-Redi tensor'
       diagUnits = 'm^2/s           '
       diagCode  = 'UM      LR      '
       diagMate  = diagNum + 2
       CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I    diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

       diagName  = 'LSkwy   '
       diagTitle = 'K_32 element (W.point, Y.dir) of GM-Redi tensor'
       diagUnits = 'm^2/s           '
       diagCode  = 'VM      LR      '
       diagMate  = diagNum
       CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I    diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

       diagName  = 'LSkwz   '
       diagTitle = 'K_33 element (W.point, Z.dir) of GM-Redi tensor'
       diagUnits = 'm^2/s           '
       diagCode  = 'WM P    LR      '
       CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

       diagName  = 'LSkux   '
       diagTitle = 'K_11 element (U.point, X.dir) of GM-Redi tensor'
       diagUnits = 'm^2/s           '
       diagCode  = 'UU P    MR      '
       CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

       diagName  = 'LSkvy   '
       diagTitle = 'K_22 element (V.point, Y.dir) of GM-Redi tensor'
       diagUnits = 'm^2/s           '
       diagCode  = 'VV P    MR      '
       CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

       diagName  = 'LSkuz   '
       diagTitle = 'K_13 element (U.point, Z.dir) of GM-Redi tensor'
       diagUnits = 'm^2/s           '
       diagCode  = 'UU      MR      '
       CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

       diagName  = 'LSkvz   '
       diagTitle = 'K_23 element (V.point, Z.dir) of GM-Redi tensor'
       diagUnits = 'm^2/s           '
       diagCode  = 'VV      MR      '
       CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

       diagName  = 'LS_PsiX '
       diagTitle = 'GM Bolus transport Psi in longstep : U component'
       diagUnits = 'm^2/s           '
       diagCode  = 'UU      LR      '
       CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

       diagName  = 'LS_PsiY '
       diagTitle = 'GM Bolus transport Psi in longstep : V component'
       diagUnits = 'm^2/s           '
       diagCode  = 'VV      LR      '
       CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      ENDIF
#endif

#ifdef ALLOW_KPP
      IF ( useKPP ) THEN
       diagName  = 'LSKPPdfS'
       diagTitle = 'Vertical diffusion coefficient for salt & tracers'
       diagUnits = 'm^2/s           '
       diagCode  = 'SM P    LR      '
       CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

       diagName  = 'LSKPPght'
       diagTitle = 'Nonlocal transport coefficient'
       diagUnits = 's/m^2           '
       diagCode  = 'SM P    LR      '
       CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )
      ENDIF
#endif /* ALLOW_KPP */

#endif /* ALLOW_DIAGNOSTICS */

      RETURN
      END

!=======================================================================
      subroutine mitcplr_init2b( myTypeStr )

      implicit none
! Predefined constants/arrays
#include "CPLR_SIG.h"
! MPI variables
#include "mpif.h"

! Arguments
      character*(*) myTypeStr
! Local
      integer myid, numprocs, ierr
      integer MPI_COMM_temp
      integer n,j,lenbuf,compind
      integer ibuf(MAX_IBUF)
!     ------------------------------------------------------------------

! Foreach component type
      do compind = 1,num_components

       MPI_COMM_temp=MPI_COMM_compcplr(compind)

! Find-out my position (rank) in the "global" communicator
       call MPI_COMM_RANK( MPI_COMM_temp, myid, ierr )
       if (ierr.ne.0) write(LogUnit,*) 'MITCPLR_init2b: ',
     &     ' Rank = ',myid,' MPI_COMM_RANK ierr=',ierr
! How big is the "global" comminicator?
       call MPI_COMM_SIZE( MPI_COMM_temp, numprocs, ierr )
       if (ierr.ne.0) write(LogUnit,*) 'MITCPLR_init2b: ',
     &     ' Size = ',numprocs,' MPI_COMM_RANK ierr=',ierr
       if (DEBUG) write(LogUnit,*) 'MITCPLR_init2b: ',
     &     ' Rank/Size = ',myid,' /',numprocs

!     - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

! Assume nothing again
       num_coupler_procs=0
       num_component_procs(compind)=0
       num_compcplr_procs(compind)=0

! Receive a message from each of the other processes in "myglobal"
       do n=0,numprocs-1
        ibuf( 1)=myid
        ibuf( 2)=MITCPLR_COUPLER
        ibuf( 3)=0
        ibuf( 4)=0
        ibuf( 5)=0
        ibuf( 6)=0
        ibuf( 7)=0
        ibuf( 8)=0
        ibuf( 9)=0
        ibuf(10)=0
        ibuf(11)=0
        ibuf(12)=0
        lenbuf=12
        call MPI_Bcast(
     &               ibuf, lenbuf, MPI_INTEGER,
     &               n,
     &               MPI_COMM_temp, ierr )
        if (ierr.ne.0) write(LogUnit,*) 'MITCPLR_init2b: ',
     &    ' MPI_Bcast from ',ibuf(1),ibuf(2),' ierr=',ierr

        if ( ibuf(2).eq.MITCPLR_COUPLER ) then
! If the broadcaster is the "coupler"
         num_coupler_procs=num_coupler_procs + 1
         rank_coupler_procs(num_coupler_procs) = ibuf(1)
         num_compcplr_procs(compind)=num_compcplr_procs(compind) + 1
         j=num_compcplr_procs(compind)
         rank_compcplr_procs(j,compind)=ibuf(1)
        else
! If the broadcaster is a "component"
         num_component_procs(compind)=num_component_procs(compind) + 1
         j=num_component_procs(compind)
         rank_component_procs(j,compind)=ibuf(1)
         num_compcplr_procs(compind)=num_compcplr_procs(compind) + 1
         j=num_compcplr_procs(compind)
         rank_compcplr_procs(j,compind)=ibuf(1)
        endif

       enddo

       if (num_coupler_procs .ne. 1) then
        STOP 'MITCPLR_init2b: I can only handle one coupling process'
       endif

      enddo

!     - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

      do compind = 1,num_components
       write(LogUnit,*) 'MITCPLR_init2b: ',
     &      MPI_COMM_compcplr(compind),
     &     ' comp. ranks = ',(rank_component_procs(j,compind),
     &                        j=1,num_component_procs(compind) )
       write(LogUnit,*) 'MITCPLR_init2b: ',
     &      MPI_COMM_compcplr(compind),
     &     ' c+c ranks = ',(rank_compcplr_procs(j,compind),
     &                        j=1,num_compcplr_procs(compind) )
      enddo

!     ------------------------------------------------------------------
      call flush(LogUnit)
      return
      end
!=======================================================================

#include "PTRACERS_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: PTRACERS_CHECK_PICKUP
C     !INTERFACE:
      SUBROUTINE PTRACERS_CHECK_PICKUP(
     I                 missFldList,
     I                 nMissing, nbFields,
     I                 myIter, myThid )

C     !DESCRIPTION:
C     Check that fields that are needed to restart have been read.
C     In case some fields are missing, stop if pickupStrictlyMatch=T
C     or try, if possible, to restart without the missing field.

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "PTRACERS_SIZE.h"
#include "PTRACERS_PARAMS.h"
#include "PTRACERS_START.h"

C     !INPUT/OUTPUT PARAMETERS:
C     missFldList :: List of missing fields   (attempted to read but not found)
C     nMissing    :: Number of missing fields (attempted to read but not found)
C     nbFields    :: number of fields in pickup file (read from meta file)
C     myIter      :: Iteration number
C     myThid      :: my Thread Id. number
      CHARACTER*(8) missFldList(*)
      INTEGER nMissing
      INTEGER nbFields
      INTEGER myIter
      INTEGER myThid
CEOP

C     !FUNCTIONS
      INTEGER  ILNBLNK
      EXTERNAL ILNBLNK

C     !LOCAL VARIABLES:
      INTEGER i, iTracer
      INTEGER j
      INTEGER ioUnit
      INTEGER warnCnts
      LOGICAL stopFlag
      CHARACTER*(8) fldName
      CHARACTER*(2) ioLabel
      CHARACTER*(MAX_LEN_MBUF) msgBuf

      ioUnit = errorMessageUnit

      _BEGIN_MASTER( myThid )

       IF ( nMissing.GE.1 ) THEN
        stopFlag = .FALSE.
        warnCnts = nMissing
        DO j=1,nMissing
         fldName = missFldList(j)

C     find the corresponding pTracer:
         IF ( fldName(1:3).EQ.'pTr' ) THEN
           ioLabel = fldName(4:5)
         ELSEIF ( fldName(1:4).EQ.'gPtr' ) THEN
           ioLabel = fldName(5:6)
         ELSE
           ioLabel = '  '
         ENDIF
         iTracer = 0
         DO i=1,PTRACERS_numInUse
           IF ( iTracer.EQ.0 .AND.
     &          ioLabel.EQ.PTRACERS_ioLabel(i) ) iTracer = i
         ENDDO

C-    passive tracer field is always needed:
         IF ( iTracer.GT.0 .AND.
     &        fldName(1:3).EQ.'pTr' .AND. fldName(6:8).EQ.'   ' ) THEN
           stopFlag = .TRUE.
           WRITE(msgBuf,'(2A,I4,3A)') 'PTRACERS_CHECK_PICKUP: ',
     &       'cannot restart without tracer ',iTracer,
     &       ' field "',fldName,'"'
           CALL PRINT_ERROR( msgBuf, myThid )

C-    fields with alternative in place to restart without:
C-    (but get a non-perfect restart)
         ELSEIF ( iTracer.GT.0 .AND. (
     &      ( fldName(1:4).EQ.'gPtr' .AND. fldName(7:8).EQ.'m1' ) .OR.
     &      ( fldName(1:3).EQ.'pTr' .AND. fldName(6:8).EQ.'Nm1' )
     &                               ) ) THEN
           PTRACERS_startAB(iTracer) = 0
           IF ( fldName(1:4).EQ.'gPtr' ) WRITE(msgBuf,'(2A,I4)')
     &        '** WARNING ** PTRACERS_CHECK_PICKUP: ',
     &        'tracer Tendency is missing for pTr# :',iTracer
           IF ( fldName(1:3).EQ.'pTr' )  WRITE(msgBuf,'(2A,I4)')
     &        '** WARNING ** PTRACERS_CHECK_PICKUP: ',
     &        'tracer @ iter-1 is missing for pTr# :',iTracer
           CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
           IF ( .NOT.pickupStrictlyMatch .AND. .NOT.stopFlag ) THEN
             WRITE(msgBuf,'(3A,I4)') '** WARNING ** ',
     &        '1rst time-step will use simple Euler time-stepping',
     &        ' for pTr# ',iTracer
             CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
           ENDIF

         ELSE
C-    unrecognized field:
           iTracer = 0
         ENDIF

C-    unrecognized field or tracer:
         IF ( iTracer.EQ.0 ) THEN
           stopFlag = .TRUE.
           WRITE(msgBuf,'(4A)') 'PTRACERS_CHECK_PICKUP: ',
     &       'missing field "',missFldList(j),'" not recognized'
           CALL PRINT_ERROR( msgBuf, myThid )
         ENDIF
        ENDDO

        IF ( stopFlag ) THEN
         STOP 'ABNORMAL END: S/R PTRACERS_CHECK_PICKUP'
        ELSEIF ( pickupStrictlyMatch ) THEN
         WRITE(msgBuf,'(4A)') 'PTRACERS_CHECK_PICKUP: ',
     &      'try "pickupStrictlyMatch=.FALSE.,"',
     &      ' in file: "data" (NameList PARM03)'
         CALL PRINT_ERROR( msgBuf, myThid )
         STOP 'ABNORMAL END: S/R PTRACERS_CHECK_PICKUP'
        ELSEIF ( warnCnts .GT. 0 ) THEN
         WRITE(msgBuf,'(4A)') '** WARNING ** PTRACERS_CHECK_PICKUP: ',
     &     'Will get only an approximated Restart'
         CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
        ENDIF

       ENDIF

      _END_MASTER( myThid )

      RETURN
      END

#include "EXF_OPTIONS.h"
#ifdef ALLOW_CTRL
# include "CTRL_OPTIONS.h"
#endif
#ifdef ALLOW_ECCO
# include "ECCO_OPTIONS.h"
#endif
#ifdef ALLOW_AUTODIFF
# include "AUTODIFF_OPTIONS.h"
#endif

      SUBROUTINE EXF_GETFFIELDS( myTime, myIter, myThid )

C     ==================================================================
C     SUBROUTINE exf_getffields
C     ==================================================================
C
C     o Read-in atmospheric state and/or surface fluxes from files.
C
C       heimbach@mit.edu, 23-May-2003 totally re-structured
C       5-Aug-2003: added USE_EXF_INTERPOLATION for arbitrary input grid
C
C     ==================================================================
C     SUBROUTINE exf_getffields
C     ==================================================================

      IMPLICIT NONE

C     == global variables ==

#include "EEPARAMS.h"
#include "SIZE.h"
#include "PARAMS.h"
#include "DYNVARS.h"
#include "GRID.h"

#include "EXF_PARAM.h"
#include "EXF_CONSTANTS.h"
#include "EXF_INTERP_SIZE.h"
#include "EXF_INTERP_PARAM.h"
#include "EXF_FIELDS.h"

#ifdef ALLOW_CTRL
# include "CTRL_SIZE.h"
# include "CTRL.h"
# include "CTRL_DUMMY.h"
# ifdef ALLOW_GENTIM2D_CONTROL
#  include "CTRL_GENARR.h"
# endif
#endif
#ifdef ALLOW_AUTODIFF_TAMC
# include "tamc.h"
#endif

C     == routine arguments ==
      _RL     myTime
      INTEGER myIter
      INTEGER myThid

C     == local variables ==
      INTEGER i, j, bi, bj
#ifdef ALLOW_ROTATE_UV_CONTROLS
      _RL     tmpUE(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL     tmpVN(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL     tmpUX(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL     tmpVY(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
#endif
#if (defined (ALLOW_CTRL) && \
     defined (ALLOW_GENTIM2D_CONTROL))
      INTEGER iarr
#endif

C     == end of interface ==

C--   read forcing fields from files and temporal interpolation

C-    Zonal and meridional wind stress.
      IF ( .NOT.useAtmWind ) THEN
       CALL EXF_SET_UV(
     I     'ustress', ustressfile, ustressmask,
     I     ustressStartTime, ustressperiod, ustressRepCycle,
     I     exf_inscal_ustress,
     I     ustress_exfremo_intercept, ustress_exfremo_slope,
     U     ustress, ustress0, ustress1,
     I     'vstress', vstressfile, vstressmask,
     I     vstressStartTime, vstressperiod, vstressRepCycle,
     I     exf_inscal_vstress,
     I     vstress_exfremo_intercept, vstress_exfremo_slope,
     U     vstress, vstress0, vstress1,
#ifdef USE_EXF_INTERPOLATION
     I     ustress_lon0, ustress_lon_inc, ustress_lat0, ustress_lat_inc,
     I     ustress_nlon, ustress_nlat, ustress_interpMethod,
     I     vstress_lon0, vstress_lon_inc, vstress_lat0, vstress_lat_inc,
     I     vstress_nlon, vstress_nlat, vstress_interpMethod,
     I     uvInterp_stress,
#endif /* USE_EXF_INTERPOLATION */
     I     myTime, myIter, myThid )
      ELSE
       DO bj = myByLo(myThid),myByHi(myThid)
        DO bi = myBxLo(myThid),myBxHi(myThid)
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           ustress(i,j,bi,bj) = 0. _d 0
           vstress(i,j,bi,bj) = 0. _d 0
          ENDDO
         ENDDO
        ENDDO
       ENDDO
      ENDIF

C-    Wind speed
      CALL EXF_SET_FLD(
     I     'wspeed', wspeedfile, wspeedmask,
     I     wspeedStartTime, wspeedperiod, wspeedRepCycle,
     I     exf_inscal_wspeed,
     I     wspeed_exfremo_intercept, wspeed_exfremo_slope,
     U     wspeed, wspeed0, wspeed1,
#ifdef USE_EXF_INTERPOLATION
     I     wspeed_lon0, wspeed_lon_inc,
     I     wspeed_lat0, wspeed_lat_inc,
     I     wspeed_nlon, wspeed_nlat, xC, yC, wspeed_interpMethod,
#endif
     I     myTime, myIter, myThid )

C-    Zonal and meridional wind.
      IF ( useAtmWind ) THEN
       CALL EXF_SET_UV(
     I     'uwind', uwindfile, uwindmask,
     I     uwindStartTime, uwindperiod, uwindRepCycle,
     I     exf_inscal_uwind,
     I     uwind_exfremo_intercept, uwind_exfremo_slope,
     U     uwind, uwind0, uwind1,
     I     'vwind', vwindfile, vwindmask,
     I     vwindStartTime, vwindperiod, vwindRepCycle,
     I     exf_inscal_vwind,
     I     vwind_exfremo_intercept, vwind_exfremo_slope,
     U     vwind, vwind0, vwind1,
#ifdef USE_EXF_INTERPOLATION
     I     uwind_lon0, uwind_lon_inc, uwind_lat0, uwind_lat_inc,
     I     uwind_nlon, uwind_nlat, uwind_interpMethod,
     I     vwind_lon0, vwind_lon_inc, vwind_lat0, vwind_lat_inc,
     I     vwind_nlon, vwind_nlat, vwind_interpMethod, uvInterp_wind,
#endif /* USE_EXF_INTERPOLATION */
     I     myTime, myIter, myThid )

      ELSE
       DO bj = myByLo(myThid),myByHi(myThid)
        DO bi = myBxLo(myThid),myBxHi(myThid)
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           uwind(i,j,bi,bj) = 0. _d 0
           vwind(i,j,bi,bj) = 0. _d 0
          ENDDO
         ENDDO
        ENDDO
       ENDDO
      ENDIF

C-    Atmospheric heat flux.
      CALL EXF_SET_FLD(
     I     'hflux', hfluxfile, hfluxmask,
     I     hfluxStartTime, hfluxperiod, hfluxRepCycle,
     I     exf_inscal_hflux,
     I     hflux_exfremo_intercept, hflux_exfremo_slope,
     U     hflux, hflux0, hflux1,
#ifdef USE_EXF_INTERPOLATION
     I     hflux_lon0, hflux_lon_inc, hflux_lat0, hflux_lat_inc,
     I     hflux_nlon, hflux_nlat, xC, yC, hflux_interpMethod,
#endif
     I     myTime, myIter, myThid )

C-    Freshwater flux.
      CALL EXF_SET_FLD(
     I     'sflux', sfluxfile, sfluxmask,
     I     sfluxStartTime, sfluxperiod, sfluxRepCycle,
     I     exf_inscal_sflux,
     I     sflux_exfremo_intercept, sflux_exfremo_slope,
     U     sflux, sflux0, sflux1,
#ifdef USE_EXF_INTERPOLATION
     I     sflux_lon0, sflux_lon_inc, sflux_lat0, sflux_lat_inc,
     I     sflux_nlon, sflux_nlat, xC, yC, sflux_interpMethod,
#endif
     I     myTime, myIter, myThid )

#ifdef ALLOW_ATM_TEMP

C-    Atmospheric temperature.
      CALL EXF_SET_FLD(
     I     'atemp', atempfile, atempmask,
     I     atempStartTime, atempperiod, atempRepCycle,
     I     exf_inscal_atemp,
     I     atemp_exfremo_intercept, atemp_exfremo_slope,
     U     atemp, atemp0, atemp1,
#ifdef USE_EXF_INTERPOLATION
     I     atemp_lon0, atemp_lon_inc, atemp_lat0, atemp_lat_inc,
     I     atemp_nlon, atemp_nlat, xC, yC, atemp_interpMethod,
#endif
     I     myTime, myIter, myThid )
      DO bj = myByLo(myThid),myByHi(myThid)
       DO bi = myBxLo(myThid),myBxHi(myThid)
        DO j = 1,sNy
         DO i = 1,sNx
          atemp(i,j,bi,bj) = atemp(i,j,bi,bj) + exf_offset_atemp
         ENDDO
        ENDDO
       ENDDO
      ENDDO

C-    Atmospheric humidity.
      CALL EXF_SET_FLD(
     I     'aqh', aqhfile, aqhmask,
     I     aqhStartTime, aqhperiod, aqhRepCycle,
     I     exf_inscal_aqh,
     I     aqh_exfremo_intercept, aqh_exfremo_slope,
     U     aqh, aqh0, aqh1,
#ifdef USE_EXF_INTERPOLATION
     I     aqh_lon0, aqh_lon_inc, aqh_lat0, aqh_lat_inc,
     I     aqh_nlon, aqh_nlat, xC, yC, aqh_interpMethod,
#endif
     I     myTime, myIter, myThid )

# ifdef ALLOW_READ_TURBFLUXES

C-    Sensible Heat flux
      CALL EXF_SET_FLD(
     I     'hs', hs_file, hs_mask,
     I     hs_StartTime, hs_period, hs_RepCycle,
     I     exf_inscal_hs,
     I     hs_exfremo_intercept, hs_exfremo_slope,
     U     hs, hs0, hs1,
#  ifdef USE_EXF_INTERPOLATION
     I     hs_lon0, hs_lon_inc, hs_lat0, hs_lat_inc,
     I     hs_nlon, hs_nlat, xC, yC, hs_interpMethod,
#  endif
     I     myTime, myIter, myThid )

C-    Latent Heat flux
      CALL EXF_SET_FLD(
     I     'hl', hl_file, hl_mask,
     I     hl_StartTime, hl_period, hl_RepCycle,
     I     exf_inscal_hl,
     I     hl_exfremo_intercept, hl_exfremo_slope,
     U     hl, hl0, hl1,
#  ifdef USE_EXF_INTERPOLATION
     I     hl_lon0, hl_lon_inc, hl_lat0, hl_lat_inc,
     I     hl_nlon, hl_nlat, xC, yC, hl_interpMethod,
#  endif
     I     myTime, myIter, myThid )

# endif /* ALLOW_READ_TURBFLUXES */

C-    Net long wave radiative flux.
      CALL EXF_SET_FLD(
     I     'lwflux', lwfluxfile, lwfluxmask,
     I     lwfluxStartTime, lwfluxperiod, lwfluxRepCycle,
     I     exf_inscal_lwflux,
     I     lwflux_exfremo_intercept, lwflux_exfremo_slope,
     U     lwflux, lwflux0, lwflux1,
#ifdef USE_EXF_INTERPOLATION
     I     lwflux_lon0, lwflux_lon_inc, lwflux_lat0, lwflux_lat_inc,
     I     lwflux_nlon, lwflux_nlat, xC, yC, lwflux_interpMethod,
#endif
     I     myTime, myIter, myThid )

#ifdef EXF_READ_EVAP
C-    Evaporation
      CALL EXF_SET_FLD(
     I     'evap', evapfile, evapmask,
     I     evapStartTime, evapperiod, evapRepCycle,
     I     exf_inscal_evap,
     I     evap_exfremo_intercept, evap_exfremo_slope,
     U     evap, evap0, evap1,
#ifdef USE_EXF_INTERPOLATION
     I     evap_lon0, evap_lon_inc, evap_lat0, evap_lat_inc,
     I     evap_nlon, evap_nlat, xC, yC, evap_interpMethod,
#endif
     I     myTime, myIter, myThid )
#endif /* EXF_READ_EVAP */

C-    Precipitation.
      CALL EXF_SET_FLD(
     I     'precip', precipfile, precipmask,
     I     precipStartTime, precipperiod, precipRepCycle,
     I     exf_inscal_precip,
     I     precip_exfremo_intercept, precip_exfremo_slope,
     U     precip, precip0, precip1,
#ifdef USE_EXF_INTERPOLATION
     I     precip_lon0, precip_lon_inc, precip_lat0, precip_lat_inc,
     I     precip_nlon, precip_nlat, xC, yC, precip_interpMethod,
#endif
     I     myTime, myIter, myThid )

C-    Snow.
      CALL EXF_SET_FLD(
     I     'snowprecip', snowprecipfile, snowprecipmask,
     I     snowprecipStartTime, snowprecipperiod, snowprecipRepCycle,
     I     exf_inscal_snowprecip,
     I     snowprecip_exfremo_intercept, snowprecip_exfremo_slope,
     U     snowprecip, snowprecip0, snowprecip1,
#ifdef USE_EXF_INTERPOLATION
     I     snowprecip_lon0, snowprecip_lon_inc,
     I     snowprecip_lat0, snowprecip_lat_inc,
     I     snowprecip_nlon, snowprecip_nlat, xC, yC,
     I     snowprecip_interpMethod,
#endif
     I     myTime, myIter, myThid )
C     Take care of case where total precip is not defined
#ifdef ALLOW_AUTODIFF_TAMC
# ifdef ALLOW_ATM_TEMP
CADJ STORE precip      = comlev1, key=ikey_dynamics, kind=isbyte
CADJ STORE snowprecip  = comlev1, key=ikey_dynamics, kind=isbyte
# endif
#endif
      IF ( snowPrecipFile .NE. ' ' ) THEN
       DO bj = myByLo(myThid),myByHi(myThid)
        DO bi = myBxLo(myThid),myBxHi(myThid)
         DO j = 1,sNy
          DO i = 1,sNx
           precip(i,j,bi,bj) =
     &          MAX( precip(i,j,bi,bj), snowPrecip(i,j,bi,bj) )
          ENDDO
         ENDDO
        ENDDO
       ENDDO
      ENDIF

#endif /* ALLOW_ATM_TEMP */

#if defined(ALLOW_ATM_TEMP) || defined(SHORTWAVE_HEATING)
C-    Net short wave radiative flux.
      CALL EXF_SET_FLD(
     I     'swflux', swfluxfile, swfluxmask,
     I     swfluxStartTime, swfluxperiod, swfluxRepCycle,
     I     exf_inscal_swflux,
     I     swflux_exfremo_intercept, swflux_exfremo_slope,
     U     swflux, swflux0, swflux1,
#ifdef USE_EXF_INTERPOLATION
     I     swflux_lon0, swflux_lon_inc, swflux_lat0, swflux_lat_inc,
     I     swflux_nlon, swflux_nlat, xC, yC, swflux_interpMethod,
#endif
     I     myTime, myIter, myThid )
#endif

#ifdef ALLOW_DOWNWARD_RADIATION

C-    Downward shortwave radiation.
      CALL EXF_SET_FLD(
     I     'swdown', swdownfile, swdownmask,
     I     swdownStartTime, swdownperiod, swdownRepCycle,
     I     exf_inscal_swdown,
     I     swdown_exfremo_intercept, swdown_exfremo_slope,
     U     swdown, swdown0, swdown1,
#ifdef USE_EXF_INTERPOLATION
     I     swdown_lon0, swdown_lon_inc, swdown_lat0, swdown_lat_inc,
     I     swdown_nlon, swdown_nlat, xC, yC, swdown_interpMethod,
#endif
     I     myTime, myIter, myThid )

C-    Downward longwave radiation.
      CALL EXF_SET_FLD(
     I     'lwdown', lwdownfile, lwdownmask,
     I     lwdownStartTime, lwdownperiod, lwdownRepCycle,
     I     exf_inscal_lwdown,
     I     lwdown_exfremo_intercept, lwdown_exfremo_slope,
     U     lwdown, lwdown0, lwdown1,
#ifdef USE_EXF_INTERPOLATION
     I     lwdown_lon0, lwdown_lon_inc, lwdown_lat0, lwdown_lat_inc,
     I     lwdown_nlon, lwdown_nlat, xC, yC, lwdown_interpMethod,
#endif
     I     myTime, myIter, myThid )

#endif /* ALLOW_DOWNWARD_RADIATION */

#ifdef ATMOSPHERIC_LOADING
C-    Atmos. pressure forcing
      CALL EXF_SET_FLD(
     I     'apressure', apressurefile, apressuremask,
     I     apressureStartTime, apressureperiod, apressureRepCycle,
     I     exf_inscal_apressure,
     I     apressure_exfremo_intercept, apressure_exfremo_slope,
     U     apressure, apressure0, apressure1,
#ifdef USE_EXF_INTERPOLATION
     I     apressure_lon0, apressure_lon_inc,
     I     apressure_lat0, apressure_lat_inc,
     I     apressure_nlon,apressure_nlat,xC,yC, apressure_interpMethod,
#endif
     I     myTime, myIter, myThid )
#endif

#ifdef EXF_ALLOW_TIDES
C-    Tidal geopotential
      CALL EXF_SET_FLD(
     I     'tidePot', tidePotFile, tidePotMask,
     I     tidePotStartTime, tidePotPeriod, tidePotRepCycle,
     I     exf_inscal_tidePot,
     I     tidePot_exfremo_intercept, tidePot_exfremo_slope,
     U     tidePot, tidePot0, tidePot1,
#ifdef USE_EXF_INTERPOLATION
     I     tidePot_lon0, tidePot_lon_inc,
     I     tidePot_lat0, tidePot_lat_inc,
     I     tidePot_nlon, tidePot_nlat, xC, yC, tidePot_interpMethod,
#endif
     I     myTime, myIter, myThid )
#endif /* EXF_ALLOW_TIDES */

#ifdef EXF_SEAICE_FRACTION
C-    fractional ice-covered area mask
      CALL EXF_SET_FLD(
     I     'areamask', areamaskfile, areamaskmask,
     I     areamaskStartTime, areamaskperiod, areamaskRepCycle,
     I     exf_inscal_areamask,
     I     areamask_exfremo_intercept, areamask_exfremo_slope,
     U     areamask, areamask0, areamask1,
#ifdef USE_EXF_INTERPOLATION
     I     areamask_lon0, areamask_lon_inc,
     I     areamask_lat0, areamask_lat_inc,
     I     areamask_nlon, areamask_nlat, xC, yC, areamask_interpMethod,
#endif
     I     myTime, myIter, myThid )
#endif

#ifdef ALLOW_RUNOFF
C-    Runoff
      CALL EXF_SET_FLD(
     I     'runoff', runofffile, runoffmask,
     I     runoffStartTime, runoffperiod, runoffRepCycle,
     I     exf_inscal_runoff,
     I     runoff_exfremo_intercept, runoff_exfremo_slope,
     U     runoff, runoff0, runoff1,
#ifdef USE_EXF_INTERPOLATION
     I     runoff_lon0, runoff_lon_inc, runoff_lat0, runoff_lat_inc,
     I     runoff_nlon, runoff_nlat, xC, yC, runoff_interpMethod,
#endif
     I     myTime, myIter, myThid )
#endif /* ALLOW_RUNOFF */

#ifdef ALLOW_RUNOFTEMP
C-    Runoff temperature
      CALL EXF_SET_FLD(
     I     'runoftemp', runoftempfile, runoffmask,
     I     runoffStartTime, runoffperiod, runoffRepCycle,
     I     exf_inscal_runoftemp,
     I     runoftemp_exfremo_intercept, runoftemp_exfremo_slope,
     U     runoftemp, runoftemp0, runoftemp1,
#ifdef USE_EXF_INTERPOLATION
     I     runoff_lon0, runoff_lon_inc, runoff_lat0, runoff_lat_inc,
     I     runoff_nlon, runoff_nlat, xC, yC, runoff_interpMethod,
#endif
     I     myTime, myIter, myThid )
#endif /* ALLOW_RUNOFTEMP */

#ifdef ALLOW_SALTFLX
C-    Salt flux
      CALL EXF_SET_FLD(
     I     'saltflx', saltflxfile, saltflxmask,
     I     saltflxStartTime, saltflxperiod, saltflxRepCycle,
     I     exf_inscal_saltflx,
     I     saltflx_exfremo_intercept, saltflx_exfremo_slope,
     U     saltflx, saltflx0, saltflx1,
#ifdef USE_EXF_INTERPOLATION
     I     saltflx_lon0, saltflx_lon_inc,
     I     saltflx_lat0, saltflx_lat_inc,
     I     saltflx_nlon, saltflx_nlat, xC, yC, saltflx_interpMethod,
#endif
     I     myTime, myIter, myThid )
#endif

#ifdef ALLOW_ROTATE_UV_CONTROLS
      IF ( useCTRL ) THEN
        DO bj = myByLo(myThid),myByHi(myThid)
         DO bi = myBxLo(myThid),myBxHi(myThid)
          DO j = 1-OLy,sNy+OLy
           DO i = 1-OLx,sNx+OLx
             tmpUE(i,j,bi,bj) = 0. _d 0
             tmpVN(i,j,bi,bj) = 0. _d 0
             tmpUX(i,j,bi,bj) = 0. _d 0
             tmpVY(i,j,bi,bj) = 0. _d 0
           ENDDO
          ENDDO
         ENDDO
        ENDDO
      ENDIF
#endif

#if (defined (ALLOW_CTRL) && defined (ALLOW_GENTIM2D_CONTROL))
      IF ( useCTRL ) THEN
       DO bj = myByLo(myThid),myByHi(myThid)
       DO bi = myBxLo(myThid),myBxHi(myThid)
        DO j = 1,sNy
         DO i = 1,sNx
          DO iarr = 1, maxCtrlTim2D
#ifdef ALLOW_ATM_TEMP
           IF (xx_gentim2d_file(iarr)(1:8).EQ.'xx_atemp')
     &       atemp(i,j,bi,bj)=atemp(i,j,bi,bj)+
     &                         xx_gentim2d(i,j,bi,bj,iarr)
           IF (xx_gentim2d_file(iarr)(1:6).EQ.'xx_aqh')
     &       aqh(i,j,bi,bj)=aqh(i,j,bi,bj)+
     &                         xx_gentim2d(i,j,bi,bj,iarr)
           IF (xx_gentim2d_file(iarr)(1:9).EQ.'xx_precip')
     &       precip(i,j,bi,bj)=precip(i,j,bi,bj)+
     &                         xx_gentim2d(i,j,bi,bj,iarr)
           IF (xx_gentim2d_file(iarr)(1:13).EQ.'xx_snowprecip')
     &       snowprecip(i,j,bi,bj)=snowprecip(i,j,bi,bj)+
     &                         xx_gentim2d(i,j,bi,bj,iarr)
           IF (xx_gentim2d_file(iarr)(1:9).EQ.'xx_lwflux')
     &       lwflux(i,j,bi,bj)=lwflux(i,j,bi,bj)+
     &                         xx_gentim2d(i,j,bi,bj,iarr)
#endif
#if defined(ALLOW_ATM_TEMP) || defined(SHORTWAVE_HEATING)
           IF (xx_gentim2d_file(iarr)(1:9).EQ.'xx_swflux')
     &       swflux(i,j,bi,bj)=swflux(i,j,bi,bj)+
     &                         xx_gentim2d(i,j,bi,bj,iarr)
#endif
#ifdef ALLOW_DOWNWARD_RADIATION
           IF (xx_gentim2d_file(iarr)(1:9).EQ.'xx_swdown')
     &       swdown(i,j,bi,bj)=swdown(i,j,bi,bj)+
     &                         xx_gentim2d(i,j,bi,bj,iarr)
           IF (xx_gentim2d_file(iarr)(1:9).EQ.'xx_lwdown')
     &       lwdown(i,j,bi,bj)=lwdown(i,j,bi,bj)+
     &                         xx_gentim2d(i,j,bi,bj,iarr)
#endif
#ifdef ALLOW_RUNOFF
           IF (xx_gentim2d_file(iarr)(1:9).EQ.'xx_runoff')
     &       runoff(i,j,bi,bj)=runoff(i,j,bi,bj)+
     &                         xx_gentim2d(i,j,bi,bj,iarr)
#endif
#ifdef EXF_READ_EVAP
           IF (xx_gentim2d_file(iarr)(1:7).EQ.'xx_evap')
     &       evap(i,j,bi,bj)=evap(i,j,bi,bj)+
     &                         xx_gentim2d(i,j,bi,bj,iarr)
#endif
#ifdef ATMOSPHERIC_LOADING
           IF (xx_gentim2d_file(iarr)(1:12).EQ.'xx_apressure')
     &       apressure(i,j,bi,bj)=apressure(i,j,bi,bj)+
     &                         xx_gentim2d(i,j,bi,bj,iarr)
#endif
#ifdef EXF_SEAICE_FRACTION
           IF (xx_gentim2d_file(iarr)(1:11).EQ.'xx_areamask')
     &       areamask(i,j,bi,bj)=areamask(i,j,bi,bj)+
     &                         xx_gentim2d(i,j,bi,bj,iarr)
#endif
#ifndef ALLOW_ROTATE_UV_CONTROLS
           IF (xx_gentim2d_file(iarr)(1:8).EQ.'xx_uwind')
     &       uwind(i,j,bi,bj)=uwind(i,j,bi,bj)+
     &                         xx_gentim2d(i,j,bi,bj,iarr)
           IF (xx_gentim2d_file(iarr)(1:8).EQ.'xx_vwind')
     &       vwind(i,j,bi,bj)=vwind(i,j,bi,bj)+
     &                         xx_gentim2d(i,j,bi,bj,iarr)
#else
           IF (xx_gentim2d_file(iarr)(1:8).EQ.'xx_uwind')
     &       tmpUE(i,j,bi,bj)=tmpUE(i,j,bi,bj)+
     &                         xx_gentim2d(i,j,bi,bj,iarr)
           IF (xx_gentim2d_file(iarr)(1:8).EQ.'xx_vwind')
     &       tmpVN(i,j,bi,bj)=tmpVN(i,j,bi,bj)+
     &                         xx_gentim2d(i,j,bi,bj,iarr)
#endif
          ENDDO
         ENDDO
        ENDDO
       ENDDO
       ENDDO
#ifdef ALLOW_ROTATE_UV_CONTROLS
       CALL ROTATE_UV2EN_RL(tmpUX,tmpVY,tmpUE,tmpVN,
     &      .FALSE.,.FALSE.,.TRUE.,1,myThid)

       DO bj = myByLo(myThid),myByHi(myThid)
         DO bi = myBxLo(myThid),myBxHi(myThid)
          DO j = 1,sNy
           DO i = 1,sNx
             uwind(i,j,bi,bj)=uwind(i,j,bi,bj)+tmpUX(i,j,bi,bj)
             vwind(i,j,bi,bj)=vwind(i,j,bi,bj)+tmpVY(i,j,bi,bj)
           ENDDO
          ENDDO
         ENDDO
       ENDDO
#endif /* ALLOW_ROTATE_UV_CONTROLS */

      ENDIF !if (useCTRL) then
#endif

      RETURN
      END

#include "CPP_EEOPTIONS.h"

CBOP
C     !ROUTINE: DIFFERENT_MULTIPLE

C     !INTERFACE:
      LOGICAL FUNCTION DIFFERENT_MULTIPLE( freq, val1, step )
      IMPLICIT NONE

C     !DESCRIPTION:
C     *==========================================================*
C     | LOGICAL FUNCTION DIFFERENT\_MULTIPLE                       
C     | o Checks if a multiple of freq exist
C     |   around val1 +/- step/2
C     *==========================================================*
C     | This routine is used for diagnostic and other periodic    
C     | operations. It is very sensitive to arithmetic precision. 
C     | For IEEE conforming arithmetic it works well but for      
C     | cases where short cut arithmetic  is used it may not work 
C     | as expected. To overcome this issue compile this routine  
C     | separately with no optimisation.                          
C     *==========================================================*

C     !INPUT PARAMETERS:
C     == Routine arguments ==
C     freq       :: Frequency by which time is divided.
C     val1       :: time that is checked 
C     step       :: length of time interval (around val1) that is checked 
      _RL  freq, val1, step

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C     !LOCAL VARIABLES:
C     == Local variables ==
C     v1, v2, v3, v4 :: Temp. for holding time
C     d1, d2, d3     :: Temp. for hold difference
      _RL  v1, v2, v3, v4, d1, d2, d3
CEOP

C     o Do easy cases first.
      DIFFERENT_MULTIPLE = .FALSE.

      IF ( freq .NE. 0. ) THEN
        IF ( ABS(step) .GT. freq ) THEN
         DIFFERENT_MULTIPLE = .TRUE.
        ELSE

C         o This case is more complex because of round-off error
          v1 = val1
          v2 = val1 - step
          v3 = val1 + step

C         Test v1 to see if its a "closest multiple"
          v4 = NINT(v1/freq)*freq
          d1 = v1-v4
          d2 = v2-v4
          d3 = v3-v4
          IF ( ABS(d1) .LT. ABS(d2) .AND. ABS(d1) .LE. ABS(d3) )
     &        DIFFERENT_MULTIPLE = .TRUE.

        ENDIF
      ENDIF

      RETURN
      END

#include "CTRL_OPTIONS.h"

cph #ifdef TARGET_CRAY_VECTOR
cph #  define NML_OPTIM ECCO_OPTIM
cph #  define NML_ECCO  ECCO_PARMS
cph #else
cph #  define NML_OPTIM NML=ECCO_OPTIM
cph #  define NML_ECCO  NML=ECCO_PARMS
cph #endif

c     ==================================================================
c
c     optim.F: Routines for doing an off-line optimization after the
c              ECCO forward and adjoint model have been run.
c
c     numbmod       - Returns number of variables.
c     simul         - Mid-level routine that calls the model and its
c                     adjoint
c     model         - Forward model.
c     admodel       - Modified forward model and adjoint model.
c     initmod       - Initialisation routine.
c     postmod       - Final routine that prints results.
c
c
c     Documentation:
c
c     The collection of these routines originated mainly from Ralf
c     Giering. Patrick Heimbach improved and corrected some parts of
c     the original code. Christian Eckert contributed the interface
c     to the ECCO release of the MITgcmUV in order to get the off-
c     line version going. The on-line optimisation uses a simple
c     example, whereas the off-line version deals with the ECCO
c     release output. The off-line version can, of course, only
c     do one optimization step at a time.
c
c     started:  Christian Eckert  eckert@mit.edu  15-Feb-2000
c
c               - On-line and off-line capability and some cosmetic
c                 changes.
c
c     changed:  Patrick Heimbach heimbach@mit.edu 19-Jun-2000
c               - finished, revised and debugged
c
c     ==================================================================

      subroutine optim_numbmod(
     O                    nn
     &                  )

c     ==================================================================
c     SUBROUTINE optim_numbmod
c     ==================================================================
c
c     o Set the number of control variables.
c
c     started: Christian Eckert eckert@mit.edu 15-Feb-2000
c
c     changed: Christian Eckert eckert@mit.edu 09-Mar-2000
c
c              - Added ECCO layout.
c
c     changed:  Patrick Heimbach heimbach@mit.edu 19-Jun-2000
c               - finished, revised and debugged
c
c     ==================================================================
c     SUBROUTINE optim_numbmod
c     ==================================================================

      IMPLICIT NONE

c     == global variables ==

#include "EEPARAMS.h"
#include "SIZE.h"

#include "CTRL_SIZE.h"
#include "CTRL.h"
#include "optim.h"
#include "minimization.h"
#include "CTRL_OBCS.h"
#ifndef ECCO_CTRL_DEPRECATED
# include "ctrl_local_params.h"
#endif

c     == routine arguments ==

      integer nn

c     == local variables ==

      integer ivar
      integer il
      integer errio

      _RL            ff

#if defined (DYNAMIC)
      _RL            vv(nn)
#elif defined (USE_POINTER) || (MAX_INDEPEND == 0)
      _RL            vv
      pointer (pvv,vv(1))
#else
      integer nmax
      parameter( nmax = MAX_INDEPEND )
      _RL   vv(nmax)
#endif

      character*(max_len_prec) record

      logical lheaderonly

c     == external ==

      integer  ilnblnk

c     == end of interface ==

      namelist /CTRL_NML/
     &  xx_theta_file, xx_salt_file,
     &  xx_hflux_file, xx_hflux_remo_intercept, xx_hflux_remo_slope,
     &  xx_hfluxstartdate1, xx_hfluxstartdate2, xx_hfluxperiod,
     &  xx_sflux_file, xx_sflux_remo_intercept, xx_sflux_remo_slope,
     &  xx_sfluxstartdate1, xx_sfluxstartdate2, xx_sfluxperiod,
     &  xx_tauu_file, xx_tauu_remo_intercept, xx_tauu_remo_slope,
     &  xx_tauustartdate1,  xx_tauustartdate2,  xx_tauuperiod,
     &  xx_tauv_file, xx_tauv_remo_intercept, xx_tauv_remo_slope,
     &  xx_tauvstartdate1,  xx_tauvstartdate2,  xx_tauvperiod,
     &  xx_atemp_file, xx_atemp_remo_intercept, xx_atemp_remo_slope,
     &  xx_atempstartdate1, xx_atempstartdate2, xx_atempperiod,
     &  xx_aqh_file, xx_aqh_remo_intercept, xx_aqh_remo_slope,
     &  xx_aqhstartdate1, xx_aqhstartdate2, xx_aqhperiod,
     &  xx_precip_file, xx_precip_remo_intercept, xx_precip_remo_slope,
     &  xx_precipstartdate1, xx_precipstartdate2, xx_precipperiod,
     &  xx_swflux_file, xx_swflux_remo_intercept, xx_swflux_remo_slope,
     &  xx_swfluxstartdate1, xx_swfluxstartdate2, xx_swfluxperiod,
     &  xx_swdown_file, xx_swdown_remo_intercept, xx_swdown_remo_slope,
     &  xx_swdownstartdate1, xx_swdownstartdate2, xx_swdownperiod,
     &  xx_lwflux_file, xx_lwflux_remo_intercept, xx_lwflux_remo_slope,
     &  xx_lwfluxstartdate1, xx_lwfluxstartdate2, xx_lwfluxperiod,
     &  xx_lwdown_file, xx_lwdown_remo_intercept, xx_lwdown_remo_slope,
     &  xx_lwdownstartdate1, xx_lwdownstartdate2, xx_lwdownperiod,
     &  xx_evap_file, xx_evap_remo_intercept, xx_evap_remo_slope,
     &  xx_evapstartdate1, xx_evapstartdate2, xx_evapperiod,
     &  xx_snowprecip_file, xx_snowprecip_remo_intercept,
     &  xx_snowprecip_remo_slope,  xx_snowprecipperiod,
     &  xx_snowprecipstartdate1, xx_snowprecipstartdate2,
     &  xx_apressure_file, xx_apressure_remo_intercept,
     &  xx_apressure_remo_slope, xx_apressureperiod,
     &  xx_apressurestartdate1, xx_apressurestartdate2,
     &  xx_runoff_file, xx_runoff_remo_intercept, xx_runoff_remo_slope,
     &  xx_runoffstartdate1, xx_runoffstartdate2, xx_runoffperiod,
     &  xx_uwind_file, xx_uwind_remo_intercept, xx_uwind_remo_slope,
     &  xx_uwindstartdate1, xx_uwindstartdate2, xx_uwindperiod,
     &  xx_vwind_file, xx_vwind_remo_intercept, xx_vwind_remo_slope,
     &  xx_vwindstartdate1, xx_vwindstartdate2, xx_vwindperiod,
     &  xx_obcsn_file, xx_obcss_file, xx_obcsw_file, xx_obcse_file,
     &  xx_obcsnstartdate1,  xx_obcsnstartdate2,  xx_obcsnperiod,
     &  xx_obcssstartdate1,  xx_obcssstartdate2,  xx_obcssperiod,
     &  xx_obcswstartdate1,  xx_obcswstartdate2,  xx_obcswperiod,
     &  xx_obcsestartdate1,  xx_obcsestartdate2,  xx_obcseperiod,
     &  xx_diffkr_file, xx_kapgm_file, xx_tr1_file,
     &  xx_sst_file, xx_sss_file,
     &  xx_sststartdate1, xx_sststartdate2, xx_sstperiod,
     &  xx_sssstartdate1, xx_sssstartdate2, xx_sssperiod,
     &  xx_depth_file, xx_efluxy_file, xx_efluxp_file,
     &  xx_bottomdrag_file, xx_edtaux_file, xx_edtauy_file,
     &  xx_uvel_file, xx_vvel_file, xx_etan_file,
     &  xx_shifwflx_file,
     &  xx_shifwflx_remo_intercept, xx_shifwflx_remo_slope,
     &  xx_shifwflxstartdate1, xx_shifwflxstartdate2, xx_shifwflxperiod,
     &  doInitXX, doPackDiag, doZscaleUnpack, doZscalePack,
     &  doMainUnpack, doMainPack, doAdmtlmBypassAD, delZexp,
     &  xx_hfluxm_file, doSinglePrecTapelev

      namelist /CTRL_PACKNAMES/
     &  yadmark, yctrlid, yctrlposunpack, yctrlpospack,
     &  ctrlname, costname, scalname, maskname, metaname

      namelist /OPTIM/
     &                      optimcycle,
     &                      numiter, nfunc, fmin, iprint,
     &                      epsf, epsx, epsg,
     &                      nupdate, eps

c--   Initialise myx/ygloballo to one. In the MITgcm they are set in
c     ini_procs.F according to the current mpi-process, but here we
c     can just set them to 1 because we do not anticipate to ever run
c     this program in a multprocessor environment.
      myygloballo = 1
      myxgloballo = 1

c--   Preset the optimization parameters.
      optimcycle =  0
      nvars      =  0
      numiter    =  1
      nfunc      =  1
      fmin       =  0.0
      iprint     =  10
      epsx       =  1.e-6
      epsg       =  1.e-6
      eps        = -1.e-6
      nupdate    =  1
      ff         = 0.
cdfer      expId      = 'MIT_CE_000'
      yctrlid    = 'MIT_CE_000'

      modeldataunit = 14
      scrunit1      = 11

c--   Read control parameters from file.
      open(unit=scrunit1,status='scratch')

      open(unit = modeldataunit,file = 'data.ctrl',
     &     status = 'old', iostat = errio)
      if ( errio .lt. 0 ) then
         stop ' stopped in optim_numbmod'
      endif

      do while ( .true. )
         read(modeldataunit, fmt='(a)', end=21) record
         il = max(ilnblnk(record),1)
         if ( record(1:1) .ne. commentcharacter )
     &        write(unit=scrunit1, fmt='(a)') record(:il)
      enddo
   21 continue
      close( modeldataunit )

      rewind( scrunit1 )
      read(unit = scrunit1, nml = ctrl_nml)
      read(unit = scrunit1, nml = ctrl_packnames)
      close( scrunit1 )
      print*, ' OPTIM_NUMBMOD: Control options have been read.'

cph(
cdfer      expId = yctrlid
cph)

c--   Read optimization parameters from file.
      open(unit=scrunit1,status='scratch')

      open(unit = modeldataunit,file = 'data.optim',
     &     status = 'old', iostat = errio)
      if ( errio .lt. 0 ) then
         stop ' stopped in optim_numbmod'
      endif

      do while ( .true. )
         read(modeldataunit, fmt='(a)', end=22) record
         il = max(ilnblnk(record),1)
         if ( record(1:1) .ne. commentcharacter )
     &        write(unit=scrunit1, fmt='(a)') record(:il)
      enddo
   22 continue
      close( modeldataunit )

      rewind( scrunit1 )
      read(unit = scrunit1, nml = optim)
      close( scrunit1 )
      print*, ' OPTIM_NUMBMOD: Minimization options have been read.'

      if (eps .gt. 0.0) then
        epsf = eps
        epsx = eps
        epsg = eps
      endif

c     Initialise some global variables before calling optim_readdata, so
c     that they contain sensible values.
      do ivar=1,maxcvars
       ncvarindex(ivar) = -1
       ncvarrecs(ivar)  = -1
       ncvarxmax(ivar)  = -1
       ncvarymax(ivar)  = -1
       ncvarnrmax(ivar) = -1
       ncvargrd(ivar)   = 'X'
       ncvartype(ivar)  = 'UNSET'
      enddo

      lheaderonly = .true.
      call optim_readdata ( nn, ctrlname, lheaderonly, ff, vv)

c--   Do some final printout.
      print*
      print*, ' OPTIM_NUMBMOD: Iteration number = ', optimcycle
      print*, ' number of control variables     = ', nn
      print*, ' Data will be read from the following files:'
      print*

ce    --> data.err file in case dimensional i/o is used.
ce    --> scaling  file in case dimensional i/o is used.

      return
      end

#include "STREAMICE_OPTIONS.h"

CBOP
C !ROUTINE: STREAMICE_WRITE_PICKUP

C !INTERFACE: ==========================================================
      SUBROUTINE STREAMICE_WRITE_PICKUP( permPickup,
     &                    suff, myTime, myIter, myThid )

C !DESCRIPTION:
C     Writes current state of pkg/streamice to a pickup file

C !USES: ===============================================================
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "STREAMICE.h"

C !INPUT PARAMETERS: ===================================================
C     permPickup      :: write a permanent pickup
C     suff            :: suffix for pickup file (eg. ckptA or 0000000010)
C     myTime          :: model time
C     myIter          :: time-step number
C     myThid          :: thread number
      LOGICAL permPickup
      CHARACTER*(*) suff
      _RL myTime
      INTEGER myIter
      INTEGER myThid

C !OUTPUT PARAMETERS: ==================================================
C  none

#ifdef ALLOW_STREAMICE
C     === Functions ====
      INTEGER  ILNBLNK
      EXTERNAL ILNBLNK

C !LOCAL VARIABLES: ====================================================
C     j           :: loop index / field number
C     nj          :: record number
C     fp          :: pickup-file precision
C     glf         :: local flag for "globalFiles"
C     fn          :: character buffer for creating filename
C     nWrFlds     :: number of fields being written
C     listDim     :: dimension of "wrFldList" local array
C     wrFldList   :: list of written fields
C     msgBuf      :: Informational/error message buffer
      INTEGER j, nj, fp, lChar
      LOGICAL glf
      _RL     timList(1)
      CHARACTER*(MAX_LEN_FNAM) fn
      INTEGER listDim, nWrFlds
      PARAMETER( listDim = 12 )
      CHARACTER*(8) wrFldList(listDim)
      CHARACTER*(MAX_LEN_MBUF) msgBuf
CEOP

        lChar = ILNBLNK(suff)
        IF ( lChar.EQ.0 ) THEN
          WRITE(fn,'(2A)') 'pickup_streamice'
        ELSE
          WRITE(fn,'(2A)') 'pickup_streamice.',suff(1:lChar)
        ENDIF
        fp = precFloat64
        j  = 0

C       Firstly, write 3-D fields as consecutive records,

#ifdef STREAMICE_HYBRID_STRESS
C     record number < 0 : a hack not to write meta files now:
        j = j + 1
#ifdef ALLOW_OPENAD
        CALL WRITE_REC_3D_RL( fn, fp, Nr, visc_streamice_full%v,
     &                        -j, myIter, myThid )
#else
        CALL WRITE_REC_3D_RL( fn, fp, Nr, visc_streamice_full,
     &                        -j, myIter, myThid )
#endif
        IF (j.LE.listDim) wrFldList(j) = 'visc3d  '
#endif /* STREAMICE_HYBRID_STRESS */

C-    switch to 2-D fields:
        nj = -j*Nr

        j = j + 1
        nj = nj-1
#ifdef ALLOW_OPENAD
        CALL WRITE_REC_3D_RL( fn, fp, 1, area_shelf_streamice%v,
     &                        nj, myIter, myThid )
#else
        CALL WRITE_REC_3D_RL( fn, fp, 1, area_shelf_streamice,
     &                        nj, myIter, myThid )
#endif
        IF (j.LE.listDim) wrFldList(j) = 'SI_area '

        j = j + 1
        nj = nj-1
        CALL WRITE_REC_3D_RS( fn, fp, 1, STREAMICE_hmask,
     &                        nj, myIter, myThid )
        IF (j.LE.listDim) wrFldList(j) = 'SI_hmask'

        j = j + 1
        nj = nj-1
#ifdef ALLOW_OPENAD
        CALL WRITE_REC_3D_RL( fn, fp, 1, U_streamice%v,
     &                        nj, myIter, myThid )
#else
        CALL WRITE_REC_3D_RL( fn, fp, 1, U_streamice,
     &                        nj, myIter, myThid )
#endif
        IF (j.LE.listDim) wrFldList(j) = 'SI_uvel '

        j = j + 1
        nj = nj-1
#ifdef ALLOW_OPENAD
        CALL WRITE_REC_3D_RL( fn, fp, 1, V_streamice%v,
     &                        nj, myIter, myThid )
#else
        CALL WRITE_REC_3D_RL( fn, fp, 1, V_streamice,
     &                        nj, myIter, myThid )
#endif
        IF (j.LE.listDim) wrFldList(j) = 'SI_vvel '

        j = j + 1
        nj = nj-1
#ifdef ALLOW_OPENAD
        CALL WRITE_REC_3D_RL( fn, fp, 1, H_streamice%v,
     &                        nj, myIter, myThid )
#else
        CALL WRITE_REC_3D_RL( fn, fp, 1, H_streamice,
     &                        nj, myIter, myThid )
#endif
        IF (j.LE.listDim) wrFldList(j) = 'SI_thick'

        j = j + 1
        nj = nj-1
#ifdef ALLOW_OPENAD
        CALL WRITE_REC_3D_RL( fn, fp, 1, tau_beta_eff_streamice%v,
     &                        nj, myIter, myThid )
#else
        CALL WRITE_REC_3D_RL( fn, fp, 1, tau_beta_eff_streamice,
     &                        nj, myIter, myThid )
#endif
        IF (j.LE.listDim) wrFldList(j) = 'SI_betaF'

        j = j + 1
        nj = nj-1
#ifdef ALLOW_OPENAD
        CALL WRITE_REC_3D_RL( fn, fp, 1, visc_streamice%v,
     &                        nj, myIter, myThid )
#else
        CALL WRITE_REC_3D_RL( fn, fp, 1, visc_streamice,
     &                        nj, myIter, myThid )
#endif
        IF (j.LE.listDim) wrFldList(j) = 'SI_visc '

#ifdef STREAMICE_HYBRID_STRESS
        j = j + 1
        nj = nj-1
#ifdef ALLOW_OPENAD
        CALL WRITE_REC_3D_RL( fn, fp, 1, streamice_taubx%v,
     &                        nj, myIter, myThid )
#else
        CALL WRITE_REC_3D_RL( fn, fp, 1, streamice_taubx,
     &                        nj, myIter, myThid )
#endif
        IF (j.LE.listDim) wrFldList(j) = 'SI_taubx'

        j = j + 1
        nj = nj-1
#ifdef ALLOW_OPENAD
        CALL WRITE_REC_3D_RL( fn, fp, 1, streamice_tauby%v,
     &                        nj, myIter, myThid )
#else
        CALL WRITE_REC_3D_RL( fn, fp, 1, streamice_tauby,
     &                        nj, myIter, myThid )
#endif
        IF (j.LE.listDim) wrFldList(j) = 'SI_tauby'
#endif

c       j = j + 1
c       nj = nj-1
c       CALL WRITE_REC_3D_RL( fn, fp, 1, myPa_Surf2,
c    &                        nj, myIter, myThid )
c       IF (j.LE.listDim) wrFldList(j) = 'myPaSur2'

C--------------------------
        nWrFlds = j
        IF ( nWrFlds.GT.listDim ) THEN
          WRITE(msgBuf,'(2A,I5,A)') 'STREAMICE_WRITE_PICKUP: ',
     &     'trying to write ',nWrFlds,' fields'
          CALL PRINT_ERROR( msgBuf, myThid )
          WRITE(msgBuf,'(2A,I5,A)') 'STREAMICE_WRITE_PICKUP: ',
     &     'field-list dimension (listDim=',listDim,') too small'
          CALL PRINT_ERROR( msgBuf, myThid )
          CALL ALL_PROC_DIE( myThid )
          STOP 'ABNORMAL END: S/R STREAMICE_WRITE_PICKUP (list-size Pb)'
        ENDIF
#ifdef ALLOW_MDSIO
C     uses this specific S/R to write (with more informations) only meta files
        j  = 1
        nj = ABS(nj)
        IF ( nWrFlds*Nr .EQ. nj ) THEN
          j  = Nr
          nj = nWrFlds
        ENDIF
        glf  = globalFiles
        timList(1) = myTime
        CALL MDS_WR_METAFILES( fn, fp, glf, .FALSE.,
     &                         0, 0, j, ' ',
     &                         nWrFlds, wrFldList,
     &                         1, timList, oneRL,
     &                         nj, myIter, myThid )
#endif /* ALLOW_MDSIO */
C--------------------------

#endif /* ALLOW_STREAMICE */

      RETURN
      END

#include "CPP_OPTIONS.h"

CBOP
C     !ROUTINE: INI_NH_VARS
C     !INTERFACE:
      SUBROUTINE INI_NH_VARS ( myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE INI_NH_VARS
C     | o Initialise to zero all NH_VARS.h arrays
C     *==========================================================*
C     | Sets all the NH State variables & tendencies to zero.
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "NH_VARS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     myThid  ::  My Thread Id number
      INTEGER myThid
CEOP

#if (defined ALLOW_NONHYDROSTATIC || defined ALLOW_QHYD_STAGGER_TS )
C     !LOCAL VARIABLES:
C     == Local variables ==
C     bi,bj   :: tile indices
C     i,j,k   :: loop counters
      INTEGER bi, bj
      INTEGER i, j, k
#endif /* ALLOW_NONHYDROSTATIC or ALLOW_QHYD_STAGGER_TS */

#ifdef ALLOW_NONHYDROSTATIC
c     IF ( nonHydrostatic ) THEN
C- Note: comment out this IF so that we are sure that all variables in
C        common blocs (even if never used later) are always initialised
        DO bj = myByLo(myThid), myByHi(myThid)
         DO bi = myBxLo(myThid), myBxHi(myThid)
          DO j=1-OLy,sNy+OLy
            DO i=1-OLx,sNx+OLx
              dPhiNH(i,j,bi,bj)    = 0. _d 0
            ENDDO
          ENDDO
          DO k=1,Nr
           DO j=1-OLy,sNy+OLy
            DO i=1-OLx,sNx+OLx
              phi_nh(i,j,k,bi,bj)  = 0. _d 0
              gW   (i,j,k,bi,bj)   = 0. _d 0
#ifdef ALLOW_ADAMSBASHFORTH_3
              gWnm (i,j,k,bi,bj,1) = 0. _d 0
              gWnm (i,j,k,bi,bj,2) = 0. _d 0
#else /* ALLOW_ADAMSBASHFORTH_3 */
              gWnm1(i,j,k,bi,bj)   = 0. _d 0
#endif /* ALLOW_ADAMSBASHFORTH_3 */
            ENDDO
           ENDDO
          ENDDO
         ENDDO
        ENDDO
c     ENDIF
#endif /* ALLOW_NONHYDROSTATIC */

#ifdef ALLOW_QHYD_STAGGER_TS
c     IF ( staggerTimeStep ) THEN
        DO bj = myByLo(myThid), myByHi(myThid)
         DO bi = myBxLo(myThid), myBxHi(myThid)
          DO k=1,Nr
           DO j=1-OLy,sNy+OLy
            DO i=1-OLx,sNx+OLx
#ifdef ALLOW_ADAMSBASHFORTH_3
              QHydGwNm(i,j,k,bi,bj,1) = 0. _d 0
              QHydGwNm(i,j,k,bi,bj,2) = 0. _d 0
#else /* ALLOW_ADAMSBASHFORTH_3 */
              QHydGwNm(i,j,k,bi,bj)   = 0. _d 0
#endif /* ALLOW_ADAMSBASHFORTH_3 */
            ENDDO
           ENDDO
          ENDDO
         ENDDO
        ENDDO
c     ENDIF
#endif /* ALLOW_QHYD_STAGGER_TS */

      RETURN
      END

#include "GCHEM_OPTIONS.h"
#ifdef ALLOW_DIC
# include "DIC_OPTIONS.h"
#endif
#ifdef ALLOW_BLING
# include "BLING_OPTIONS.h"
#endif
#ifdef ALLOW_DARWIN
# include "DARWIN_OPTIONS.h"
#endif

CBOP
C !ROUTINE: GCHEM_FORCING_SEP
C !INTERFACE: ==========================================================
      SUBROUTINE GCHEM_FORCING_SEP( myTime, myIter, myThid )

C !DESCRIPTION:
C     calls subroutine that will update passive tracers values
C     with a separate timestep. Since GCHEM_FORCING_SEP is now
C     called before DO_FIELDS_BLOCKING_EXCHANGES, the passive
C     tracer values in the halo regions are not up to date and
C     must not be used.

C !USES: ===============================================================
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "DYNVARS.h"
#include "PTRACERS_SIZE.h"
#include "PTRACERS_PARAMS.h"
#include "PTRACERS_FIELDS.h"
#include "GCHEM.h"
#ifdef ALLOW_DIC
# include "DIC_VARS.h"
#endif /* ALLOW_DIC */
#ifdef ALLOW_BLING
# include "BLING_VARS.h"
#endif /* ALLOW_BLING */
#ifdef ALLOW_DARWIN
# include "DARWIN_FLUX.h"
# include "DARWIN_SIZE.h"
#endif

C !INPUT PARAMETERS: ===================================================
C  myThid               :: thread number
      _RL myTime
      INTEGER myIter, myThid
CEOP

#ifdef ALLOW_GCHEM
#ifdef GCHEM_SEPARATE_FORCING

C!LOCAL VARIABLES: ====================================================
C  i,j                  :: loop indices
C  bi,bj                :: tile indices
C  k                    :: vertical level
      INTEGER bi,bj,iMin,iMax,jMin,jMax
c     INTEGER i,j
      PARAMETER( iMin = 1 , iMax = sNx )
      PARAMETER( jMin = 1 , jMax = sNy )
#if (defined ALLOW_OBCS) || (defined ALLOW_DIAGNOSTICS)
      INTEGER iTr
#endif
#ifdef ALLOW_DIAGNOSTICS
      CHARACTER*8 diagName
#endif /* ALLOW_DIAGNOSTICS */

#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_ENTER('GCHEM_FORCING_SEP',myThid)
#endif

#ifdef ALLOW_DIAGNOSTICS
      IF ( useDiagnostics ) THEN
C--   fill-in tracer diagnostics before any GChem udate
       DO iTr = 1,gchem_sepFTr_num
        diagName = '        '
        WRITE(diagName,'(A5,A2)') 'GC_Tr', PTRACERS_ioLabel(iTr)
        CALL DIAGNOSTICS_FILL( pTracer(1-OLx,1-OLy,1,1,1,iTr), diagName,
     &                         0, Nr, 0, 1, 1, myThid )
       ENDDO
      ENDIF
#endif /* ALLOW_DIAGNOSTICS */

ccccccccccccccccccccccccc
c global calculations   c
ccccccccccccccccccccccccc
#ifdef ALLOW_OLD_VIRTUALFLUX
#ifdef ALLOW_DIC
# ifdef ALLOW_AUTODIFF
      IF ( .NOT.useDIC ) STOP 'ABNORMAL END: S/R GCHEM_FORCING_SEP (1)'
# else /* ALLOW_AUTODIFF */
      IF ( useDIC ) THEN
# endif /* ALLOW_AUTODIFF */
c find global surface averages
       gsm_s = 0. _d 0
       gsm_dic = 0. _d 0
       gsm_alk = 0. _d 0
       CALL GCHEM_SURFMEAN(salt,gsm_s,myThid)
       CALL GCHEM_SURFMEAN(
     &             pTracer(1-OLx,1-OLy,1,1,1,1), gsm_dic, myThid )
       CALL GCHEM_SURFMEAN(
     &             pTracer(1-OLx,1-OLy,1,1,1,2), gsm_alk, myThid )
# ifndef ALLOW_AUTODIFF
      ENDIF
# endif /* ALLOW_AUTODIFF */
#endif /* ALLOW_DIC */
#ifdef ALLOW_DARWIN
c     IF ( useDARWIN ) THEN
c find global surface averages
       gsm_s = 0. _d 0
       gsm_dic = 0. _d 0
       gsm_alk = 0. _d 0
       CALL GCHEM_SURFMEAN(salt,gsm_s,myThid)
       CALL GCHEM_SURFMEAN(
     &             pTracer(1-OLx,1-OLy,1,1,1,iDIC), gsm_dic, myThid )
       CALL GCHEM_SURFMEAN(
     &             pTracer(1-OLx,1-OLy,1,1,1,iALK), gsm_alk, myThid )
c     ENDIF
#endif
ccccccccccccccccccccccccccccccccccccccccccc
#endif /* ALLOW_OLD_VIRTUALFLUX */

#ifdef ALLOW_DARWIN
      IF ( useDARWIN ) THEN
        CALL DARWIN_CONS( myIter, myTime, myThid )
      ENDIF
#endif

ccccccccccccccccccccccccc
c chemical forcing      c
ccccccccccccccccccccccccc
C$taf loop = parallel
      DO bj=myByLo(myThid),myByHi(myThid)
C$taf loop = parallel
       DO bi=myBxLo(myThid),myBxHi(myThid)

ccccccccccccccccccccccccccc DIC cccccccccccccccccccccccccccccccc
#ifdef ALLOW_DIC
# ifdef ALLOW_AUTODIFF
        IF (.NOT.useDIC) STOP 'ABNORMAL END: S/R GCHEM_FORCING_SEP (2)'
# else /* ALLOW_AUTODIFF */
        IF ( useDIC ) THEN
# endif /* ALLOW_AUTODIFF */
#ifdef ALLOW_DEBUG
          IF (debugMode) CALL DEBUG_CALL('DIC_BIOTIC_FORCING',myThid)
#endif
#ifdef ALLOW_FE
          CALL DIC_BIOTIC_FORCING( pTracer(1-OLx,1-OLy,1,bi,bj,1),
     &                          pTracer(1-OLx,1-OLy,1,bi,bj,2),
     &                          pTracer(1-OLx,1-OLy,1,bi,bj,3),
     &                          pTracer(1-OLx,1-OLy,1,bi,bj,4),
     &                          pTracer(1-OLx,1-OLy,1,bi,bj,5),
     &                          pTracer(1-OLx,1-OLy,1,bi,bj,6),
     &                          bi, bj, iMin, iMax, jMin, jMax,
     &                          myTime, myIter, myThid )
#else
#ifdef ALLOW_O2
          CALL DIC_BIOTIC_FORCING( pTracer(1-OLx,1-OLy,1,bi,bj,1),
     &                          pTracer(1-OLx,1-OLy,1,bi,bj,2),
     &                          pTracer(1-OLx,1-OLy,1,bi,bj,3),
     &                          pTracer(1-OLx,1-OLy,1,bi,bj,4),
     &                          pTracer(1-OLx,1-OLy,1,bi,bj,5),
     &                          bi, bj, iMin, iMax, jMin, jMax,
     &                          myTime, myIter, myThid )
#else
          CALL DIC_BIOTIC_FORCING( pTracer(1-OLx,1-OLy,1,bi,bj,1),
     &                          pTracer(1-OLx,1-OLy,1,bi,bj,2),
     &                          pTracer(1-OLx,1-OLy,1,bi,bj,3),
     &                          pTracer(1-OLx,1-OLy,1,bi,bj,4),
     &                          bi, bj, iMin, iMax, jMin, jMax,
     &                          myTime, myIter, myThid )
#endif
#endif
# ifndef ALLOW_AUTODIFF
        ENDIF
# endif /* ALLOW_AUTODIFF */
#endif /* ALLOW_DIC */
cccccccccccccccccccccccccc END DIC cccccccccccccccccccccccccccccccccc

ccccccccccccccccccccccccccc BLING cccccccccccccccccccccccccccccccc
#ifdef ALLOW_BLING
        IF ( useBLING ) THEN
# ifndef USE_BLING_V1
#  ifdef USE_SIBLING
          CALL BLING_MAIN( pTracer(1-OLx,1-OLy,1,bi,bj,1),
     &                          pTracer(1-OLx,1-OLy,1,bi,bj,2),
     &                          pTracer(1-OLx,1-OLy,1,bi,bj,3),
     &                          pTracer(1-OLx,1-OLy,1,bi,bj,4),
     &                          pTracer(1-OLx,1-OLy,1,bi,bj,5),
     &                          pTracer(1-OLx,1-OLy,1,bi,bj,6),
     &                          pTracer(1-OLx,1-OLy,1,bi,bj,7),
     &                          pTracer(1-OLx,1-OLy,1,bi,bj,8),
     &                          pTracer(1-OLx,1-OLy,1,bi,bj,9),
#   ifdef ADVECT_PHYTO
     &                          pTracer(1-OLx,1-OLy,1,bi,bj,10),
#   endif
     &                          bi, bj, iMin, iMax, jMin, jMax,
     &                          myTime, myIter, myThid )
#  else /* USE_SIBLING */
          CALL BLING_MAIN( pTracer(1-OLx,1-OLy,1,bi,bj,1),
     &                          pTracer(1-OLx,1-OLy,1,bi,bj,2),
     &                          pTracer(1-OLx,1-OLy,1,bi,bj,3),
     &                          pTracer(1-OLx,1-OLy,1,bi,bj,4),
     &                          pTracer(1-OLx,1-OLy,1,bi,bj,5),
     &                          pTracer(1-OLx,1-OLy,1,bi,bj,6),
     &                          pTracer(1-OLx,1-OLy,1,bi,bj,7),
     &                          pTracer(1-OLx,1-OLy,1,bi,bj,8),
#   ifdef ADVECT_PHYTO
     &                          pTracer(1-OLx,1-OLy,1,bi,bj,9),
#   endif
     &                          bi, bj, iMin, iMax, jMin, jMax,
     &                          myTime, myIter, myThid )
#  endif /* USE_SIBLING */
# else /* USE_BLING_v1 */
          CALL BLING_MAIN( pTracer(1-OLx,1-OLy,1,bi,bj,1),
     &                          pTracer(1-OLx,1-OLy,1,bi,bj,2),
     &                          pTracer(1-OLx,1-OLy,1,bi,bj,3),
     &                          pTracer(1-OLx,1-OLy,1,bi,bj,4),
     &                          pTracer(1-OLx,1-OLy,1,bi,bj,5),
     &                          pTracer(1-OLx,1-OLy,1,bi,bj,6),
#  ifdef ADVECT_PHYTO
     &                          pTracer(1-OLx,1-OLy,1,bi,bj,7),
#  endif
     &                          bi, bj, iMin, iMax, jMin, jMax,
     &                          myTime, myIter, myThid )
# endif /* USE_BLING_v1 */
        ENDIF
#endif /* ALLOW_BLING */
cccccccccccccccccccccccccc END BLING cccccccccccccccccccccccccccccccccc

#ifdef ALLOW_DARWIN
        IF ( useDARWIN ) THEN
#ifdef NUT_SUPPLY
c articficial supply of nutrients
#ifdef ALLOW_DEBUG
          IF (debugMode) CALL DEBUG_CALL('DARWIN_NUT_SUPPLY',myThid)
#endif
          CALL DARWIN_NUT_SUPPLY( pTracer(1-OLx,1-OLy,1,bi,bj,1),
     &                          bi, bj, iMin, iMax, jMin, jMax,
     &                          myIter, myTime, myThid )
          CALL DARWIN_NUT_SUPPLY( pTracer(1-OLx,1-OLy,1,bi,bj,2),
     &                          bi, bj, iMin, iMax, jMin, jMax,
     &                          myIter, myTime, myThid )
          CALL DARWIN_NUT_SUPPLY( pTracer(1-OLx,1-OLy,1,bi,bj,3),
     &                          bi, bj, iMin, iMax, jMin, jMax,
     &                          myIter, myTime, myThid )
          CALL DARWIN_NUT_SUPPLY( pTracer(1-OLx,1-OLy,1,bi,bj,4),
     &                          bi, bj, iMin, iMax, jMin, jMax,
     &                          myIter, myTime, myThid )
#endif
ccccccccccccccc
C darwin_forcing operates on bi,bj part only, but needs to get full
C array because of last (iPtr) index
#ifdef ALLOW_DEBUG
          IF (debugMode) CALL DEBUG_CALL('DARWIN_FORCING',myThid)
#endif
          CALL DARWIN_FORCING(  pTracer(1-OLx,1-OLy,1,1,1,1),
     &                          bi, bj, iMin, iMax, jMin, jMax,
     &                          myIter, myTime, myThid )
        ENDIF
#endif /* ALLOW_DARWIN */

#ifdef ALLOW_OBCS
C--   Apply (again) open boundary conditions for each passive tracer
C Note: could skip this 2nd call to OBCS_APPLY if all DIC/DARWIN
C       updates of ptracers were only done in the interior (i.e. with
C       tendency multiplied by maskInC)
        IF ( useOBCS .AND. .NOT.useDIC ) THEN
#ifdef ALLOW_DEBUG
          IF (debugMode) CALL DEBUG_CALL('OBCS_APPLY_PTRACER',myThid)
#endif
          DO iTr = 1,gchem_sepFTr_num
            CALL OBCS_APPLY_PTRACER(
     I                bi, bj, 0, iTr,
     U                pTracer(1-OLx,1-OLy,1,bi,bj,iTr),
     I                myThid )
          ENDDO
        ENDIF
#endif /* ALLOW_OBCS */

       ENDDO
      ENDDO

#ifdef ALLOW_DARWIN
      IF ( useDARWIN ) THEN
         CALL DARWIN_CONS( myIter, myTime, myThid )
#ifdef ALLOW_CARBON
         CALL DIC_ATMOS( 1, myTime, myIter, myThid )
#endif
      ENDIF
#endif /* ALLOW_DARWIN */

#ifdef ALLOW_DIC
# ifdef ALLOW_AUTODIFF
      IF ( .NOT.useDIC ) STOP 'ABNORMAL END: S/R GCHEM_FORCING_SEP (3)'
# else /* ALLOW_AUTODIFF */
      IF ( useDIC ) THEN
# endif /* ALLOW_AUTODIFF */
#ifdef ALLOW_DEBUG
       IF (debugMode) CALL DEBUG_CALL('DIC_ATMOS',myThid)
#endif
       CALL DIC_ATMOS( myTime, myIter, myThid )
# ifdef COMPONENT_MODULE
       CALL DIC_STORE_FLUXCO2( myTime, myIter, myThid )
# endif
# ifdef ALLOW_COST
       CALL DIC_COST( myTime, myIter, myThid )
# endif
# ifndef ALLOW_AUTODIFF
      ENDIF
# endif /* ALLOW_AUTODIFF */
#endif /* ALLOW_DIC */

#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_LEAVE('GCHEM_FORCING_SEP',myThid)
#endif

#endif /* GCHEM_SEPARATE_FORCING */
#endif /* ALLOW_GCHEM */

      RETURN
      END

#include "ATM2D_OPTIONS.h"

CBOP 0
C !ROUTINE: CPL_RECV_OCN_OCNCONFIG

C !INTERFACE:
      SUBROUTINE CPL_RECV_OCN_OCNCONFIG

C !DESCRIPTION:
C     *==========================================================*
C     | SUBROUTINE CPL_RECV_OCN_OCNCONFIG
C     | o Routine for receiving ocean config into coupling level.
C     *==========================================================*
C     | This version talks to the MITgcm general circulation
C     | model. For now just get the models depth map.
C     *==========================================================*

#ifdef ATM2D_MPI_ON
C !USES:
      IMPLICIT NONE
C     == Global variables ==
#include "OCNSIZE.h"
#include "OCNVARS.h"
#include "OCNIDS.h"
c#include "CPL_PARAMS.h"

C !INPUT/OUTPUT PARAMETERS:

C !LOCAL VARIABLES:
      INTEGER tmpFld(1)
CEOP

C     Get config from ocean component
C     o receive number of coupler time-steps the ocean will do
      CALL COUPRECV_I4VEC( ocnCompName,
     I                     'nCouplingSteps', 1,
     O                     tmpFld )
c     nSteps_ocn = tmpFld(1)

C     o receive Ocean Mixed-Layer Depth
      CALL COUPRECV_R8TILES( ocnCompName,
     I                       ocnMxlDName, Nx_ocn, Ny_ocn,
     O                       OcMxlD_ocn )

#endif /* ATM2D_MPI_ON */

      RETURN
      END

#include "RBCS_OPTIONS.h"

C     !ROUTINE: RBCS_FIELDS_LOAD
C     !INTERFACE:
      SUBROUTINE RBCS_FIELDS_LOAD( myTime, myIter, myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE RBCS_FIELDS_LOAD
C     | o Control reading of fields from external source.
C     *==========================================================*
C     | RBCS External source field loading routine.
C     | This routine is called every time we want to
C     | load a a set of external fields. The routine decides
C     | which fields to load and then reads them in.
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#ifdef ALLOW_PTRACERS
#include "PTRACERS_SIZE.h"
#include "PTRACERS_PARAMS.h"
#endif
#include "RBCS_SIZE.h"
#include "RBCS_PARAMS.h"
#include "RBCS_FIELDS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
C     myTime :: Simulation time
C     myIter :: Simulation timestep number
C     myThid :: Thread no. that called this routine.
      _RL     myTime
      INTEGER myIter
      INTEGER myThid

C     !FUNCTIONS:
      INTEGER  IFNBLNK, ILNBLNK
      EXTERNAL IFNBLNK, ILNBLNK

C     !LOCAL VARIABLES:
C     === Local arrays ===
C     [01]      :: End points for interpolation
C     Above use static heap storage to allow exchange.
C     aWght, bWght :: Interpolation weights

      INTEGER bi, bj, i, j, k
      INTEGER intimeP, intime0, intime1
      _RL aWght, bWght, locTime
      INTEGER Ifprd
#ifdef ALLOW_PTRACERS
      INTEGER iTracer
#endif
      INTEGER IL, initer0, initer1
      CHARACTER*(MAX_LEN_FNAM) fullName
CEOP

#ifdef ALLOW_RBCS
      CALL TIMER_START('RBCS_FIELDS_LOAD      [I/O]', myThid)

C--   First call requires that we initialize everything to zero for safety
C      <= already done in RBCS_INIT_VARIA

C--   Now calculate whether it is time to update the forcing arrays
      bi = myBxLo(myThid)
      bj = myByLo(myThid)
      IF (rbcsForcingPeriod.GT.0. _d 0) THEN
       locTime = myTime - rbcsForcingOffset
       CALL GET_PERIODIC_INTERVAL(
     O                   intimeP, intime0, intime1, bWght, aWght,
     I                   rbcsForcingCycle, rbcsForcingPeriod,
     I                   deltaTclock, locTime, myThid )
#ifdef ALLOW_DEBUG
       IF ( debugLevel.GE.debLevB ) THEN
        _BEGIN_MASTER(myThid)
        WRITE(standardMessageUnit,'(A,I10,A,4I5,A,2F14.10)')
     &   ' RBCS_FIELDS_LOAD,', myIter,
     &   ' : iP,iLd,i0,i1=', intimeP,rbcsLdRec(bi,bj), intime0,intime1,
     &   ' ; Wght=', bWght, aWght
        _END_MASTER(myThid)
       ENDIF
#endif /* ALLOW_DEBUG */
      ELSE
       intimeP = 1
       intime1 = 1
       intime0 = 1
       aWght = .5 _d 0
       bWght = .5 _d 0
      ENDIF

#ifdef ALLOW_AUTODIFF_TAMC
C-    assuming that we call S/R RBCS_FIELDS_LOAD at each time-step and
C     with increasing time, this will catch when we need to load new records;
C     But with Adjoint run, this is not always the case => might end-up using
C     the wrong time-records
      IF ( intime0.NE.intimeP .OR. myIter.EQ.nIter0 ) THEN
#else /* ALLOW_AUTODIFF_TAMC */
C-    Make no assumption on sequence of calls to RBCS_FIELDS_LOAD ;
C     This is the correct formulation (works in Adjoint run).
C     Unfortunatly, produces many recomputations <== not used until it is fixed
      IF ( intime1.NE.rbcsLdRec(bi,bj) ) THEN
#endif /* ALLOW_AUTODIFF_TAMC */

C--   If the above condition is met then we need to read in
C     data for the period ahead and the period behind myTime.
       IF ( debugLevel.GE.debLevZero ) THEN
        _BEGIN_MASTER(myThid)
        WRITE(standardMessageUnit,'(A,I10,A,2(2I5,A))')
     &    ' RBCS_FIELDS_LOAD, it=', myIter,
     &    ' : Reading new data, i0,i1=', intime0, intime1,
     &    ' (prev=', intimeP, rbcsLdRec(bi,bj), ' )'
        _END_MASTER(myThid)
       ENDIF

C     for rbcsSingleTimeFiles=.TRUE.
       Ifprd = NINT(rbcsForcingPeriod/deltaTrbcs)
       initer0 = rbcsIter0 + intime0*Ifprd
       initer1 = rbcsIter0 + intime1*Ifprd

#ifndef DISABLE_RBCS_MOM
       IF ( useRBCuVel .AND. relaxUFile.NE.' '  ) THEN
        IF ( rbcsSingleTimeFiles ) THEN
         IL=ILNBLNK( relaxUFile )
         WRITE(fullName,'(2A,I10.10)') relaxUFile(1:IL),'.',initer0
         CALL READ_REC_XYZ_RS(fullName, rbcu0, 1, myIter, myThid)
         WRITE(fullName,'(2A,I10.10)') relaxUFile(1:IL),'.',initer1
         CALL READ_REC_XYZ_RS(fullName, rbcu1, 1, myIter, myThid)
        ELSE
         CALL READ_REC_XYZ_RS(relaxUFile,rbcu0,intime0,myIter,myThid)
         CALL READ_REC_XYZ_RS(relaxUFile,rbcu1,intime1,myIter,myThid)
        ENDIF
       ENDIF
       IF ( useRBCvVel .AND. relaxVFile.NE.' '  ) THEN
        IF ( rbcsSingleTimeFiles ) THEN
         IL=ILNBLNK( relaxVFile )
         WRITE(fullName,'(2A,I10.10)') relaxVFile(1:IL),'.',initer0
         CALL READ_REC_XYZ_RS(fullName, rbcv0, 1, myIter, myThid)
         WRITE(fullName,'(2A,I10.10)') relaxVFile(1:IL),'.',initer1
         CALL READ_REC_XYZ_RS(fullName, rbcv1, 1, myIter, myThid)
        ELSE
         CALL READ_REC_XYZ_RS(relaxVFile,rbcv0,intime0,myIter,myThid)
         CALL READ_REC_XYZ_RS(relaxVFile,rbcv1,intime1,myIter,myThid)
        ENDIF
       ENDIF
       IF ( (useRBCuVel .AND. relaxUFile.NE.' ') .OR.
     &      (useRBCvVel .AND. relaxVFile.NE.' ') ) THEN
        CALL EXCH_UV_XYZ_RS( rbcu0, rbcv0, .TRUE., myThid )
        CALL EXCH_UV_XYZ_RS( rbcu1, rbcv1, .TRUE., myThid )
       ENDIF
#endif /* DISABLE_RBCS_MOM */
       IF ( useRBCtemp .AND. relaxTFile .NE. ' '  ) THEN
        IF ( rbcsSingleTimeFiles ) THEN
         IL=ILNBLNK( relaxTFile )
         WRITE(fullName,'(2a,i10.10)') relaxTFile(1:IL),'.',initer0
         CALL READ_REC_XYZ_RS(fullName, rbct0, 1, myIter, myThid)
         WRITE(fullName,'(2a,i10.10)') relaxTFile(1:IL),'.',initer1
         CALL READ_REC_XYZ_RS(fullName, rbct1, 1, myIter, myThid)
        ELSE
         CALL READ_REC_XYZ_RS(relaxTFile,rbct0,intime0,myIter,myThid)
         CALL READ_REC_XYZ_RS(relaxTFile,rbct1,intime1,myIter,myThid)
        ENDIF
        CALL EXCH_XYZ_RS( rbct0 , myThid )
        CALL EXCH_XYZ_RS( rbct1 , myThid )
       ENDIF
       IF ( useRBCsalt .AND. relaxSFile .NE. ' '  ) THEN
        IF ( rbcsSingleTimeFiles ) THEN
         IL=ILNBLNK( relaxSFile )
         WRITE(fullName,'(2a,i10.10)') relaxSFile(1:IL),'.',initer0
         CALL READ_REC_XYZ_RS(fullName, rbcs0, 1, myIter, myThid)
         WRITE(fullName,'(2a,i10.10)') relaxSFile(1:IL),'.',initer1
         CALL READ_REC_XYZ_RS(fullName, rbcs1, 1, myIter, myThid)
        ELSE
         CALL READ_REC_XYZ_RS(relaxSFile,rbcs0,intime0,myIter,myThid)
         CALL READ_REC_XYZ_RS(relaxSFile,rbcs1,intime1,myIter,myThid)
        ENDIF
        CALL EXCH_XYZ_RS( rbcs0 , myThid )
        CALL EXCH_XYZ_RS( rbcs1 , myThid )
       ENDIF

#ifdef ALLOW_PTRACERS
       IF ( usePTRACERS ) THEN
        DO iTracer = 1, PTRACERS_numInUse
         IF ( useRBCptrnum(iTracer) .AND.
     &        relaxPtracerFile(iTracer).NE. ' ' ) THEN
          IF ( rbcsSingleTimeFiles ) THEN
           IL=ILNBLNK( relaxPtracerFile(iTracer) )
           WRITE(fullName,'(2a,i10.10)') relaxPtracerFile(iTracer)(1:IL)
     &                                   ,'.',initer0
           CALL READ_REC_XYZ_RS( fullName,
     &                           rbcptr0(1-Olx,1-Oly,1,1,1,iTracer),
     &                           1, myIter, myThid )
           WRITE(fullName,'(2a,i10.10)') relaxPtracerFile(iTracer)(1:IL)
     &                                   ,'.',initer1
           CALL READ_REC_XYZ_RS( fullName,
     &                           rbcptr1(1-Olx,1-Oly,1,1,1,iTracer),
     &                           1, myIter, myThid )
          ELSE
           CALL READ_REC_XYZ_RS( relaxPtracerFile(iTracer),
     &                           rbcptr0(1-Olx,1-Oly,1,1,1,iTracer),
     &                           intime0, myIter, myThid )
           CALL READ_REC_XYZ_RS( relaxPtracerFile(iTracer),
     &                           rbcptr1(1-Olx,1-Oly,1,1,1,iTracer),
     &                           intime1, myIter, myThid )
          ENDIF
          CALL EXCH_XYZ_RS( rbcptr0(1-Olx,1-Oly,1,1,1,iTracer),myThid )
          CALL EXCH_XYZ_RS( rbcptr1(1-Olx,1-Oly,1,1,1,iTracer),myThid )
         ENDIF
        ENDDO
       ENDIF
#endif /* ALLOW_PTRACERS */

C-    save newly loaded time-record
       DO bj = myByLo(myThid), myByHi(myThid)
         DO bi = myBxLo(myThid), myBxHi(myThid)
           rbcsLdRec(bi,bj) = intime1
         ENDDO
       ENDDO

C--   end if-block for loading new time-records
      ENDIF

C--   Interpolate
      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
#ifndef DISABLE_RBCS_MOM
        IF ( useRBCuVel .OR. useRBCvVel ) THEN
         DO k=1,Nr
          DO j=1-Oly,sNy+Oly
           DO i=1-Olx,sNx+Olx
            RBCuVel(i,j,k,bi,bj) = bWght*rbcu0(i,j,k,bi,bj)
     &                            +aWght*rbcu1(i,j,k,bi,bj)
            RBCvVel(i,j,k,bi,bj) = bWght*rbcv0(i,j,k,bi,bj)
     &                            +aWght*rbcv1(i,j,k,bi,bj)
           ENDDO
          ENDDO
         ENDDO
        ENDIF
#endif /* DISABLE_RBCS_MOM */
         DO k=1,Nr
          DO j=1-Oly,sNy+Oly
           DO i=1-Olx,sNx+Olx
            RBCtemp(i,j,k,bi,bj) = bWght*rbct0(i,j,k,bi,bj)
     &                            +aWght*rbct1(i,j,k,bi,bj)
            RBCsalt(i,j,k,bi,bj) = bWght*rbcs0(i,j,k,bi,bj)
     &                            +aWght*rbcs1(i,j,k,bi,bj)
           ENDDO
          ENDDO
         ENDDO
       ENDDO
      ENDDO

#ifdef ALLOW_PTRACERS
      IF ( usePTRACERS ) THEN
       DO iTracer = 1, PTRACERS_numInUse
        IF (useRBCptrnum(iTracer)) THEN
         DO bj = myByLo(myThid), myByHi(myThid)
          DO bi = myBxLo(myThid), myBxHi(myThid)
           DO k=1,Nr
            DO j=1-Oly,sNy+Oly
             DO i=1-Olx,sNx+Olx
               RBC_ptracers(i,j,k,bi,bj,iTracer) =
     &                      bWght*rbcptr0(i,j,k,bi,bj,iTracer)
     &                     +aWght*rbcptr1(i,j,k,bi,bj,iTracer)
             ENDDO
            ENDDO
           ENDDO
          ENDDO
         ENDDO
        ENDIF
       ENDDO
      ENDIF
#endif /* ALLOW_PTRACERS */

      CALL TIMER_STOP ('RBCS_FIELDS_LOAD      [I/O]', myThid)

#endif /* ALLOW_RBCS */

      RETURN
      END

#include "KPP_OPTIONS.h"

      SUBROUTINE KPP_CALC_VISC(
     I        bi,bj,iMin,iMax,jMin,jMax,K,
     U        KappaRU,KappaRV,
     I        myThid)

C     *==========================================================*
C     | SUBROUTINE KPP_CALC_VISC                                 |
C     | o Add contrubution to net viscosity from KPP mixing      |
C     *==========================================================*
      IMPLICIT NONE

C     == GLobal variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "DYNVARS.h"
#include "GRID.h"
#include "KPP.h"

C     == Routine arguments ==
C     bi, bj, iMin, iMax, jMin, jMax - Range of points for which calculation
C     myThid - Instance number for this innvocation of CALC_COMMON_FACTORS
C
      INTEGER bi,bj,iMin,iMax,jMin,jMax,K
      _RL KappaRU(1-Olx:sNx+Olx,1-Oly:sNy+Oly,Nr)
      _RL KappaRV(1-Olx:sNx+Olx,1-Oly:sNy+Oly,Nr)
      INTEGER myThid

C     == Local variables ==
C     I, J, K - Loop counters
      INTEGER i,j

      DO j=jMin,jMax
       DO i=iMin,iMax
        KappaRU(i,j,k) = max ( KappaRU(i,j,k),
     &         KappaRU(i,j,k) - viscArNr(1) + _maskW(i,j,k,bi,bj) *
     &         0.5*(KPPviscAz(i,j,k,bi,bj)+KPPviscAz(i-1,j,k,bi,bj)) )
       ENDDO
      ENDDO

      DO j=jMin,jMax
       DO i=iMin,iMax
        KappaRV(i,j,k) = max ( KappaRV(i,j,k),
     &         KappaRV(i,j,k) - viscArNr(1) + _maskS(i,j,k,bi,bj) *
     &         0.5*(KPPviscAz(i,j,k,bi,bj)+KPPviscAz(i,j-1,k,bi,bj)) )
       ENDDO
      ENDDO

      RETURN
      END

#include "CPP_EEOPTIONS.h"
#undef DBUG_EXCH_VEC

C--   Contents
C--   o EXCH_SEND_PUT_VEC_X_RL
C--   o EXCH_SEND_PUT_VEC_Y_RL

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 0
C !ROUTINE: EXCH_SEND_PUT_VEC_X_RL

C !INTERFACE:
      SUBROUTINE EXCH_SEND_PUT_VEC_X_RL(
     I                        arrayE, arrayW,
     O                        bufRecE, bufRecW,
     I                        myd1, myThid )
C     !DESCRIPTION:
C     *==========================================================*
C     | SUBROUTINE EXCH_SEND_PUT_VEC_X_RL
C     | o "Send" or "put" X edges for RL array.
C     *==========================================================*
C     | Routine that invokes actual message passing send or
C     |   direct "put" of data to update buffer in X direction
C     | Note: Since only master-thread send/put, assumes input
C     |       & output arrays are shared (i.e. incommon block)
C     *==========================================================*

C     !USES:
      IMPLICIT NONE

C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "EESUPPORT.h"
#include "EXCH.h"

C     !INPUT/OUTPUT PARAMETERS:
C     arrayE        :: Input buffer array to send to Eastern Neighbour
C     arrayW        :: Input buffer array to send to Western Neighbour
C     bufRecE       :: buffer array to collect Eastern Neighbour values
C     bufRecW       :: buffer array to collect Western Neighbour values
C     myd1          :: size
C     myThid        :: my Thread Id. number
      INTEGER myd1
      _RL  arrayE(myd1,nSx,nSy),  arrayW(myd1,nSx,nSy)
      _RL bufRecE(myd1,nSx,nSy), bufRecW(myd1,nSx,nSy)
      INTEGER myThid
CEOP

C     !LOCAL VARIABLES:
C     I             :: Loop counters
C     bi, bj        :: tile indices
C     biW, bjW      :: West tile indices
C     biE, bjE      :: East tile indices
C     theProc       :: Variables used in message building
C     theTag        :: Variables used in message building
C     theType       :: Variables used in message building
C     theSize       :: Variables used in message building
C     westCommMode  :: variables holding type of communication
C     eastCommMode  ::  a particular tile face uses.
      INTEGER I
      INTEGER bi, bj, biW, bjW, biE, bjE
      INTEGER westCommMode
      INTEGER eastCommMode
#ifdef ALLOW_USE_MPI
      INTEGER theProc, theTag, theType, theSize, mpiRc
#endif
#ifdef DBUG_EXCH_VEC
      INTEGER ioUnit
#endif

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C--   Write data to exchange buffer
C     Various actions are possible depending on the communication mode
C     as follows:
C       Mode      Action
C     --------   ---------------------------
C     COMM_NONE  Do nothing
C
C     COMM_MSG   Message passing communication ( e.g. MPI )
C                Fill west send buffer from this tile.
C                Send data with tag identifying tile and direction.
C                Fill east send buffer from this tile.
C                Send data with tag identifying tile and direction.
C
C     COMM_PUT   "Put" communication ( UMP_, shmemput, etc... )
C                Fill east receive buffer of west-neighbor tile
C                Fill west receive buffer of east-neighbor tile
C                Sync. memory
C                Write data-ready Ack for east edge of west-neighbor tile
C                Write data-ready Ack for west edge of east-neighbor tile
C                Sync. memory

C     Prevent anyone to access shared buffer while an other thread modifies it
      _BARRIER

      _BEGIN_MASTER(myThid)

#ifdef DBUG_EXCH_VEC
      ioUnit = errorMessageUnit
      WRITE(ioUnit,'(A,2L5)')
     &    'SEND_PUT_X: exchNeedsMemsync,exchUsesBarrier=',
     &     exchNeedsMemsync,exchUsesBarrier
#endif

      DO bj=1,nSy
       DO bi=1,nSx

        westCommMode  = _tileCommModeW(bi,bj)
        eastCommMode  = _tileCommModeE(bi,bj)
        biE =  _tileBiE(bi,bj)
        bjE =  _tileBjE(bi,bj)
        biW =  _tileBiW(bi,bj)
        bjW =  _tileBjW(bi,bj)

C       o Send or Put west edge
        IF ( westCommMode .EQ. COMM_MSG  ) THEN
C        Send the data
#ifdef ALLOW_USE_MPI
         IF ( usingMPI ) THEN
          theProc = tilePidW(bi,bj)
          theTag  = _tileTagSendW(bi,bj)
          theSize = myd1
          theType = _MPI_TYPE_RL
          exchNReqsX(1,bi,bj) = exchNReqsX(1,bi,bj)+1
#ifdef DBUG_EXCH_VEC
          write(ioUnit,'(A,7I5,I8)') 'qq1xW: ',myProcId,bi,bj,
     &          theProc,theTag, exchNReqsX(1,bi,bj),
     &          exchReqIdX(exchNReqsX(1,bi,bj),1,bi,bj), theSize
#endif
          CALL MPI_Isend( arrayW(1,bi,bj), theSize, theType,
     &                    theProc, theTag, MPI_COMM_MODEL,
     &                    exchReqIdX(exchNReqsX(1,bi,bj),1,bi,bj),
     &                    mpiRc )
         ENDIF
#endif /* ALLOW_USE_MPI */
         eastRecvAck(1,biW,bjW) = 1
        ELSEIF ( westCommMode .EQ. COMM_PUT  ) THEN
c         write(0,*) 'SEND_PUT_VEC_X: copy E:',biW,bjW,' <- W:',bi,bj
          DO I=1,myd1
            bufRecE(I,biW,bjW) = arrayW(I,bi,bj)
          ENDDO
        ELSEIF ( westCommMode .NE. COMM_NONE ) THEN
         STOP ' S/R EXCH: Invalid commW mode.'
        ENDIF

C       o Send or Put east edge
        IF ( eastCommMode .EQ. COMM_MSG  ) THEN
C        Send the data
#ifdef ALLOW_USE_MPI
         IF ( usingMPI ) THEN
          theProc = tilePidE(bi,bj)
          theTag  = _tileTagSendE(bi,bj)
          theSize = myd1
          theType = _MPI_TYPE_RL
          exchNReqsX(1,bi,bj) = exchNReqsX(1,bi,bj)+1
#ifdef DBUG_EXCH_VEC
c         if (theProc .eq. 2 .or. theProc .eq. 4) then
c         if (arrayE(1,bi,bj) .ne. 0.) then
          write(ioUnit,'(A,7I5,I8)') 'qq1xE: ',myProcId,bi,bj,
     &       theProc,theTag, exchNReqsX(1,bi,bj),
     &       exchReqIdX(exchNReqsX(1,bi,bj),1,bi,bj), theSize
c         endif
c         endif
#endif
          CALL MPI_Isend( arrayE(1,bi,bj), theSize, theType,
     &                    theProc, theTag, MPI_COMM_MODEL,
     &                    exchReqIdX(exchNReqsX(1,bi,bj),1,bi,bj),
     &                    mpiRc)
         ENDIF
#endif /* ALLOW_USE_MPI */
         westRecvAck(1,biE,bjE) = 1
        ELSEIF ( eastCommMode .EQ. COMM_PUT  ) THEN
c         write(0,*) 'SEND_PUT_VEC_X: copy W:',biE,bjE,' <- E:',bi,bj
          DO I=1,myd1
            bufRecW(I,biE,bjE) = arrayE(I,bi,bj)
          ENDDO
        ELSEIF ( eastCommMode .NE. COMM_NONE ) THEN
         STOP ' S/R EXCH: Invalid commE mode.'
        ENDIF

       ENDDO
      ENDDO

      _END_MASTER(myThid)

C--   Signal completetion ( making sure system-wide memory state is
C--                         consistent ).

C     ** NOTE ** We are relying on being able to produce strong-ordered
C     memory semantics here. In other words we assume that there is a
C     mechanism which can ensure that by the time the Ack is seen the
C     overlap region data that will be exchanged is up to date.
      IF ( exchNeedsMemSync  ) CALL MEMSYNC

      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        biE = _tileBiE(bi,bj)
        bjE = _tileBjE(bi,bj)
        biW = _tileBiW(bi,bj)
        bjW = _tileBjW(bi,bj)
        westCommMode = _tileCommModeW(bi,bj)
        eastCommMode = _tileCommModeE(bi,bj)
        IF ( westCommMode .EQ. COMM_PUT ) eastRecvAck(1,biW,bjW) = 1
        IF ( eastCommMode .EQ. COMM_PUT ) westRecvAck(1,biE,bjE) = 1
        IF ( westCommMode .EQ. COMM_GET ) eastRecvAck(1,biW,bjW) = 1
        IF ( eastCommMode .EQ. COMM_GET ) westRecvAck(1,biE,bjE) = 1
       ENDDO
      ENDDO

C--   Make sure "ack" setting is seen system-wide.
C     Here strong-ordering is not an issue but we want to make
C     sure that processes that might spin on the above Ack settings
C     will see the setting.
C     ** NOTE ** On some machines we wont spin on the Ack setting
C     ( particularly the T90 ), instead we will use s system barrier.
C     On the T90 the system barrier is very fast and switches out the
C     thread while it waits. On most machines the system barrier
C     is much too slow and if we own the machine and have one thread
C     per process preemption is not a problem.
      IF ( exchNeedsMemSync  ) CALL MEMSYNC

C     Wait until all threads finish filling buffer <-- jmc: really needed ?
      _BARRIER

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 0
C !ROUTINE: EXCH_SEND_PUT_VEC_Y_RL

C !INTERFACE:
      SUBROUTINE EXCH_SEND_PUT_VEC_Y_RL(
     I                        arrayN, arrayS,
     O                        bufRecN, bufRecS,
     I                        myd1, myThid )
C     !DESCRIPTION:
C     *==========================================================*
C     | SUBROUTINE EXCH_SEND_PUT_VEC_Y_RL
C     | o "Send" or "put" Y edges for RL array.
C     *==========================================================*
C     | Routine that invokes actual message passing send or
C     |   direct "put" of data to update buffer in X direction
C     | Note: Since only master-thread send/put, assumes input
C     |       & output arrays are shared (i.e. incommon block)
C     *==========================================================*

C     !USES:
      IMPLICIT NONE

C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "EESUPPORT.h"
#include "EXCH.h"

C     !INPUT/OUTPUT PARAMETERS:
C     arrayN        :: buffer array to collect Northern Neighbour values
C     arrayS        :: buffer array to collect Southern Neighbour values
C     myd1          :: size
C     myThid        :: my Thread Id. number
C     arrayN        :: Input buffer array to send to Northern Neighbour
C     arrayS        :: Input buffer array to send to Southern Neighbour
C     bufRecN       :: buffer array to collect Northern Neighbour values
C     bufRecS       :: buffer array to collect Southern Neighbour values
C     myd1          :: size
C     myThid        :: my Thread Id. number
      INTEGER myd1
      _RL  arrayN(myd1,nSx,nSy),  arrayS(myd1,nSx,nSy)
      _RL bufRecN(myd1,nSx,nSy), bufRecS(myd1,nSx,nSy)
      INTEGER myThid
CEOP

C     !LOCAL VARIABLES:
C     I             :: Loop index
C     bi, bj        :: tile indices
C     biS, bjS      :: South tile indices
C     biN, bjN      :: North tile indices
C     theProc       :: Variables used in message building
C     theTag        :: Variables used in message building
C     theType       :: Variables used in message building
C     theSize       :: Variables used in message building
C     southCommMode :: variables holding type of communication
C     northCommMode ::  a particular tile face uses.
      INTEGER I
      INTEGER bi, bj, biS, bjS, biN, bjN
      INTEGER southCommMode
      INTEGER northCommMode
#ifdef ALLOW_USE_MPI
      INTEGER theProc, theTag, theType, theSize, mpiRc
#endif
#ifdef DBUG_EXCH_VEC
      INTEGER ioUnit
#endif

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C--   Write data to exchange buffer
C     Various actions are possible depending on the communication mode
C     as follows:
C       Mode      Action
C     --------   ---------------------------
C     COMM_NONE  Do nothing
C
C     COMM_MSG   Message passing communication ( e.g. MPI )
C                Fill west send buffer from this tile.
C                Send data with tag identifying tile and direction.
C                Fill east send buffer from this tile.
C                Send data with tag identifying tile and direction.
C
C     COMM_PUT   "Put" communication ( UMP_, shmemput, etc... )
C                Fill east receive buffer of south-neighbor tile
C                Fill west receive buffer of north-neighbor tile
C                Sync. memory
C                Write data-ready Ack for east edge of south-neighbor tile
C                Write data-ready Ack for west edge of north-neighbor tile
C                Sync. memory

C     Prevent anyone to access shared buffer while an other thread modifies it
      _BARRIER

      _BEGIN_MASTER(myThid)

#ifdef DBUG_EXCH_VEC
      ioUnit = errorMessageUnit
#endif

      DO bj=1,nSy
       DO bi=1,nSx

        southCommMode  = _tileCommModeS(bi,bj)
        northCommMode  = _tileCommModeN(bi,bj)
        biN =  _tileBiN(bi,bj)
        bjN =  _tileBjN(bi,bj)
        biS =  _tileBiS(bi,bj)
        bjS =  _tileBjS(bi,bj)

C       o Send or Put south edge
        IF ( southCommMode .EQ. COMM_MSG  ) THEN
C        Send the data
#ifdef ALLOW_USE_MPI
         IF ( usingMPI ) THEN
          theProc = tilePidS(bi,bj)
          theTag  = _tileTagSendS(bi,bj)
          theSize = myd1
          theType = _MPI_TYPE_RL
          exchNReqsY(1,bi,bj) = exchNReqsY(1,bi,bj)+1
          CALL MPI_Isend( arrayS(1,bi,bj), theSize, theType,
     &                    theProc, theTag, MPI_COMM_MODEL,
     &                    exchReqIdY(exchNReqsY(1,bi,bj),1,bi,bj),
     &                    mpiRc )
         ENDIF
#endif /* ALLOW_USE_MPI */
         northRecvAck(1,biS,bjS) = 1
        ELSEIF ( southCommMode .EQ. COMM_PUT  ) THEN
c         write(0,*) 'SEND_PUT_VEC_Y: copy N:',biS,bjS,' <- S:',bi,bj
          DO I=1,myd1
            bufRecN(I,biS,bjS) = arrayS(I,bi,bj)
          ENDDO
        ELSEIF ( southCommMode .NE. COMM_NONE ) THEN
         STOP ' S/R EXCH: Invalid commS mode.'
        ENDIF

C       o Send or Put north edge
        IF ( northCommMode .EQ. COMM_MSG  ) THEN
C        Send the data
#ifdef ALLOW_USE_MPI
         IF ( usingMPI ) THEN
          theProc = tilePidN(bi,bj)
          theTag  = _tileTagSendN(bi,bj)
          theSize = myd1
          theType = _MPI_TYPE_RL
          exchNReqsY(1,bi,bj) = exchNReqsY(1,bi,bj)+1
          CALL MPI_Isend( arrayN(1,bi,bj), theSize, theType,
     &                    theProc, theTag, MPI_COMM_MODEL,
     &                    exchReqIdY(exchNReqsY(1,bi,bj),1,bi,bj),
     &                    mpiRc )
         ENDIF
#endif /* ALLOW_USE_MPI */
         southRecvAck(1,biN,bjN) = 1
        ELSEIF ( northCommMode .EQ. COMM_PUT  ) THEN
c         write(0,*) 'SEND_PUT_VEC_Y: copy S:',biN,bjN,' <- N:',bi,bj
          DO I=1,myd1
            bufRecS(I,biN,bjN) = arrayN(I,bi,bj)
          ENDDO
        ELSEIF ( northCommMode .NE. COMM_NONE ) THEN
         STOP ' S/R EXCH: Invalid commN mode.'
        ENDIF

       ENDDO
      ENDDO

      _END_MASTER(myThid)

C--   Signal completetion ( making sure system-wide memory state is
C--                         consistent ).

C     ** NOTE ** We are relying on being able to produce strong-ordered
C     memory semantics here. In other words we assume that there is a
C     mechanism which can ensure that by the time the Ack is seen the
C     overlap region data that will be exchanged is up to date.
      IF ( exchNeedsMemSync  ) CALL MEMSYNC

      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        biN = _tileBiN(bi,bj)
        bjN = _tileBjN(bi,bj)
        biS = _tileBiS(bi,bj)
        bjS = _tileBjS(bi,bj)
        southCommMode = _tileCommModeS(bi,bj)
        northCommMode = _tileCommModeN(bi,bj)
        IF ( southCommMode .EQ. COMM_PUT ) northRecvAck(1,biS,bjS) = 1
        IF ( northCommMode .EQ. COMM_PUT ) southRecvAck(1,biN,bjN) = 1
        IF ( southCommMode .EQ. COMM_GET ) northRecvAck(1,biS,bjS) = 1
        IF ( northCommMode .EQ. COMM_GET ) southRecvAck(1,biN,bjN) = 1
       ENDDO
      ENDDO

C--   Make sure "ack" setting is seen system-wide.
C     Here strong-ordering is not an issue but we want to make
C     sure that processes that might spin on the above Ack settings
C     will see the setting.
C     ** NOTE ** On some machines we wont spin on the Ack setting
C     ( particularly the T90 ), instead we will use s system barrier.
C     On the T90 the system barrier is very fast and switches out the
C     thread while it waits. On most machines the system barrier
C     is much too slow and if we own the machine and have one thread
C     per process preemption is not a problem.
      IF ( exchNeedsMemSync  ) CALL MEMSYNC

C     Wait until all threads finish filling buffer <-- jmc: really needed ?
      _BARRIER

      RETURN
      END

#include "DIAG_OPTIONS.h"

CBOP
C     !ROUTINE: DIAGSTATS_INI_IO
C     !INTERFACE:
      SUBROUTINE DIAGSTATS_INI_IO( myThid )

C     !DESCRIPTION: \bv
C     *==================================================================
C     | S/R DIAGSTATS_INI_IO
C     | o set I/O unit for ASCII output file
C     *==================================================================
C     \ev

C     !USES:
      IMPLICIT NONE

C     == Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "DIAGNOSTICS_SIZE.h"
#include "DIAGNOSTICS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     myThid   :: my Thread Id number
      INTEGER myThid

C     !FUNCTIONS:
      INTEGER  ILNBLNK
      EXTERNAL ILNBLNK

C     !LOCAL VARIABLES:
      INTEGER m, n, j, iL, nUnit
      CHARACTER*(10) suff
      CHARACTER*(MAX_LEN_FNAM) dataFName
      CHARACTER*(MAX_LEN_MBUF) msgBuf, tmpBuf
CEOP

      _BEGIN_MASTER( myThid)

      IF ( diagSt_Ascii .AND. myProcId.EQ.0 ) THEN

        DO n=1,diagSt_nbLists

C-      get a free unit number as the I/O channel for this routine
          CALL MDSFINDUNIT( nUnit, myThid )
          diagSt_ioUnit(n) = nUnit

C-      set file name
          IF ( rwSuffixType.EQ.0 ) THEN
            WRITE(suff,'(I10.10)') nIter0
          ELSE
            CALL RW_GET_SUFFIX( suff, startTime, nIter0, myThid )
          ENDIF
          iL = ILNBLNK(diagSt_Fname(n))
          WRITE(dataFName,'(4A)')
     &          diagSt_Fname(n)(1:iL), '.', suff, '.txt'

C-      open file with corresponding file unit
          OPEN( nUnit, FILE=dataFName, STATUS='unknown' )

          WRITE(msgBuf,'(4A,I6)') 'DIAGSTATS_INI_IO: ',
     &         'open file: ',dataFName(1:iL+15), ' , unit=', nUnit
          CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                        SQUEEZE_RIGHT, myThid )

C-      write a kind of header:
          WRITE(nUnit,'(2A)')      '# header of file: ',
     &                               diagSt_Fname(n)(1:iL)
          WRITE(nUnit,'(A,F17.6)') '# frequency (s): ', diagSt_freq(n)
          WRITE(nUnit,'(A,F17.6)') '# phase (s)    : ', diagSt_phase(n)
          WRITE(msgBuf,'(A)')      '# Regions      : '
          iL = 17
          DO j=0,nRegions
            IF (diagSt_region(j,n).GE.1 .AND.iL+3.LE.MAX_LEN_MBUF) THEN
              tmpBuf(1:iL) = msgBuf(1:iL)
              WRITE(msgBuf,'(A,I3)') tmpBuf(1:iL),j
              iL = iL+3
            ENDIF
          ENDDO
          WRITE(nUnit,'(A)') msgBuf(1:iL)
          DO j=1,diagSt_nbFlds(n),10
            WRITE(nUnit,'(A,20A)')      '# Fields       :',
     &        (' ', diagSt_Flds(m,n), m=j,MIN(diagSt_nbFlds(n),j+9) )
          ENDDO
          DO j=1,diagSt_nbFlds(n),50
            WRITE(nUnit,'(A,50I4)')   '# Nb of levels : ',
     &         ( kdiag(jSdiag(m,n)), m=j,MIN(diagSt_nbFlds(n),j+49) )
          ENDDO
          WRITE(nUnit,'(2A)') '# end of header ----------------------',
     &                        '--------------------------------------'
          WRITE(nUnit,'(A)') ' '

        ENDDO

      ENDIF

      _END_MASTER( myThid )

      RETURN
      END

#include "PACKAGES_CONFIG.h"
#include "CPP_OPTIONS.h"

CBOP
C     !ROUTINE: UPDATE_ETAH
C     !INTERFACE:
      SUBROUTINE UPDATE_ETAH( myTime, myIter, myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE UPDATE_ETAH
C     | o Update etaH after mom-correction-step/integr_continuity
C     |  (required with NLFS to derive surface layer thickness)
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     == Global variables
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "DYNVARS.h"
#include "GRID.h"
#include "SURFACE.h"

C     !INPUT/OUTPUT PARAMETERS:
C     myTime  :: Current time in simulation
C     myIter  :: Current iteration number
C     myThid  :: my Thread Id number
      _RL myTime
      INTEGER myIter
      INTEGER myThid

C     !LOCAL VARIABLES:
C     i,j,bi,bj  :: Loop counters
      INTEGER i,j,bi,bj
CEOP

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)

C--   before updating etaH, save current etaH field in etaHnm1
        DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
            etaHnm1(i,j,bi,bj) = etaH(i,j,bi,bj)
          ENDDO
        ENDDO

C--   Update etaH at the end of the time step :
C     Incorporate the Explicit part of -Divergence(Barotropic_Flow)

        IF (implicDiv2Dflow.EQ. 1. _d 0) THEN
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
            etaH(i,j,bi,bj) = etaN(i,j,bi,bj)
          ENDDO
         ENDDO

        ELSE
         DO j=1,sNy
          DO i=1,sNx
            etaH(i,j,bi,bj) = etaN(i,j,bi,bj)
     &       + (1. - implicDiv2Dflow)*dEtaHdt(i,j,bi,bj)
     &                               *deltaTFreeSurf
          ENDDO
         ENDDO
        ENDIF

#ifdef ALLOW_OBCS
C--    Apply OBC to etaH (NonLin-FreeSurf): needed since viscous terms
C       depend on hFacZ which is not only function of boundary hFac values.
        IF ( useOBCS.AND.nonlinFreeSurf.GT.0 )
     &     CALL OBCS_APPLY_ETA( bi, bj, etaH, myThid )
#endif /* ALLOW_OBCS */

C- end bi,bj loop.
       ENDDO
      ENDDO

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      IF ( implicDiv2Dflow .NE. 1. _d 0 .OR.
     &    ( useOBCS.AND.nonlinFreeSurf.GT.0 ) )
     &    CALL EXCH_XY_RL( etaH, myThid )

      RETURN
      END

#include "MOM_COMMON_OPTIONS.h"

CBOP
C !ROUTINE: MOM_CALC_STRAIN

C !INTERFACE: ==========================================================
      SUBROUTINE MOM_CALC_STRAIN(
     I        bi,bj,k,
     I        uFld, vFld, hFacZ,
     O        strain,
     I        myThid )

C !DESCRIPTION:
C Calculates the strain of the horizontal flow field (at vorticity points):
C \begin{equation*}
C D_S = \frac{\Delta y_u}{\Delta x_v} \delta_i \frac{v}{\Delta y_c}
C     + \frac{\Delta x_v}{\Delta y_u} \delta_j \frac{u}{\Delta x_c}
C \end{equation*}
C assuming free-slip boundaries.

C !USES: ===============================================================
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"

C !INPUT PARAMETERS: ===================================================
C  bi,bj                :: tile indices
C  k                    :: vertical level
C  uFld                 :: zonal flow
C  vFld                 :: meridional flow
C  hFacZ                :: open-water thickness at vorticity points
C  myThid               :: thread number
      INTEGER bi,bj,k
      _RL uFld(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL vFld(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RS hFacZ(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER myThid

C !OUTPUT PARAMETERS: ==================================================
C  strain               :: strain of horizontal flow
      _RL strain(1-OLx:sNx+OLx,1-OLy:sNy+OLy)

C !LOCAL VARIABLES: ====================================================
C  i,j                  :: loop indices
      INTEGER i,j
CEOP

      DO j=2-OLy,sNy+OLy
       DO i=2-OLx,sNx+OLx

C       Strain of horizontal flow field (ignoring lopping factors)
        strain(i,j)=
     &    ( dyC( i , j ,bi,bj)*vFld( i , j )
     &     -dyC(i-1, j ,bi,bj)*vFld(i-1, j )
     &     +dxC( i , j ,bi,bj)*uFld( i , j )
     &     -dxC( i ,j-1,bi,bj)*uFld( i ,j-1)
     &    )*recip_rAz(i,j,bi,bj)*recip_deepFacC(k)
c       strain(i,j)=
c    &    dyU(i,j,bi,bj)*recip_dxV(i,j,bi,bj)*(
c    &              vFld( i , j )*recip_dyC( i , j ,bi,bj)
c    &             -vFld(i-1, j )*recip_dyC(i-1, j ,bi,bj) )
c    &   +dxV(i,j,bi,bj)*recip_dyU(i,j,bi,bj)*(
c    &             +uFld( i , j )*recip_dxC( i , j ,bi,bj)
c    &             -uFld( i ,j-1)*recip_dxC( i ,j-1,bi,bj) )

C       Set strain to zero on boundaries (free-slip)
C       mask is now applied afterwards, outside this S/R.
c       IF (hFacZ(i,j).EQ.0.) THEN
c        strain(i,j)=0.
c       ENDIF

       ENDDO
      ENDDO

C     Special stuff for Cubed Sphere
      IF (useCubedSphereExchange) THEN
c      STOP 'S/R MOM_CALC_STRAIN: We should not use strain on the cube!'
      ENDIF

      RETURN
      END

#include "MOM_FLUXFORM_OPTIONS.h"

CBOP
C !ROUTINE: MOM_U_METRIC_CYLINDER

C !INTERFACE: ==========================================================
      SUBROUTINE MOM_U_METRIC_CYLINDER(
     I        bi,bj,k,
     I        uFld, vFld,
     O        uMetricTerms,
     I        myThid )

C !DESCRIPTION:
C Calculates the zonal metric term due to cylinder curvature:
C \begin{equation}
C +\frac{u v}{r}
C \end{equation}

C !USES: ===============================================================
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"

C !INPUT PARAMETERS: ===================================================
C  bi,bj                :: tile indices
C  k                    :: vertical level
C  uFld                 :: zonal flow
C  vFld                 :: meridional flow
C  myThid               :: thread number
      INTEGER bi,bj,k
      _RL uFld(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL vFld(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER myThid

C !OUTPUT PARAMETERS: ==================================================
C  uMetricTerms         :: metric term
      _RL uMetricTerms(1-OLx:sNx+OLx,1-OLy:sNy+OLy)

C !LOCAL VARIABLES: ====================================================
C  i,j                  :: loop indices
      INTEGER i,j
      _RL radius
CEOP

      DO j=1-OLy,sNy+OLy-1
       DO i=1-OLx+1,sNx+OLx
          radius = (yG(i,j,bi,bj)+yG(i,j+1,bi,bj))*0.5 _d 0
C-   to get the same results as before:
c         radius = yC(i,j,bi,bj)
          IF ( radius.GT.0. ) THEN
             uMetricTerms(i,j) =
     &            uFld(i,j)
     &            *0.25*(vFld(i,j) + vFld(i-1,j) +
     &                   vFld(i,j+1)+vFld(i-1,j+1))/radius
          ELSE
             uMetricTerms(i,j) = 0.
          ENDIF

       ENDDO
      ENDDO

      RETURN
      END

#include "MDSIO_OPTIONS.h"

      SUBROUTINE MDS_SEG4toRS( j,bi,bj,k,nNz, seg, copyTo, arr )

C IN:
C     j,bi,bj,k  integer :: indices to array "arr"
C     nNz        integer :: K dimension of array "arr"
C     seg        Real*4  :: 1-D vector of length sNx
C OUT:
C     arr         _RS    :: model tiled array
C
C Created: 03/20/99 adcroft@mit.edu

      IMPLICIT NONE
C Global variables / common blocks
#include "SIZE.h"

C Arguments
      INTEGER j,bi,bj,k,nNz
      _RS arr(1-oLx:sNx+oLx,1-oLy:sNy+oLy,nNz,nSx,nSy)
      LOGICAL copyTo
      Real*4 seg(sNx)
C Local
      INTEGER ii
C     ------------------------------------------------------------------
      IF (copyTo) THEN
       DO ii=1,sNx
        arr(ii,j,k,bi,bj)=seg(ii)
       ENDDO
      ELSE
       DO ii=1,sNx
        seg(ii)=arr(ii,j,k,bi,bj)
       ENDDO
      ENDIF
C     ------------------------------------------------------------------
      RETURN
      END

#include "CPP_OPTIONS.h"

!      _RL FUNCTION SLOPE_LIMITER (num, denom)

       _RL FUNCTION SLOPE_LIMITER (Cr)

!       _RL num, denom
!       _RL SLOPE_LIMITER
!       _RL r
       _RL Cr

! used for flux limiting in advective subroutines
! Van Leer limiter (source: Wikipedia!)

!       if (denom .eq. 0.0) then
!        SLOPE_LIMITER = 0.0
!       elseif (num*denom .le. 0.0) then
!        SLOPE_LIMITER = 0.0
!       else
!        r = num/denom
!        SLOPE_LIMITER = (r+abs(r))/(1+abs(r))
!       endif

       SLOPE_LIMITER = max(0.D0,max(min(1.D0,2.D0*Cr),
     &                 min(2.D0,Cr)))


       RETURN
       END

#include "CAL_OPTIONS.h"

      integer function cal_IntYears(
     I                               mythid
     &                             )

c     ==================================================================
c     FUNCTION cal_IntYears
c     ==================================================================
c
c     o Return the number of calendar years that are affected by the 
c       current model integration.
c
c              
c     started: Christian Eckert eckert@mit.edu  30-Jun-1999
c
c     changed: Christian Eckert eckert@mit.edu  29-Dec-1999
c
c              - restructured the original version in order to have a
c                better interface to the MITgcmUV.
c
c              Christian Eckert eckert@mit.edu  03-Feb-2000
c
c              - Introduced new routine and function names, cal_<NAME>,
c                for verion 0.1.3.
c
c     ==================================================================
c     FUNCTION cal_IntYears
c     ==================================================================

      implicit none

c     == global variables ==

#include "cal.h"

c     == routine arguments ==

      integer mythid

c     == end of interface ==

      cal_IntYears = ( modelenddate(1)  /10000 -
     &             modelstartdate(1)/10000   ) + 1

      if ( ( modelenddate(2) .eq. 0) .and.
     &     ( mod(modelenddate(1),100) .eq. 1 ) .and.
     &       mod(modelenddate(1)/100,100) .eq. 1 ) then
        cal_IntYears = cal_IntYears -1
      endif

      return
      end

#include "RW_OPTIONS.h"

CBOP
C     !ROUTINE: WRITE_LOCAL_RS
C     !INTERFACE:
      SUBROUTINE WRITE_LOCAL_RS(
     I                 pref, suff, nNr, field,
     I                 bi, bj, iRec, myIter, myThArg )

C     !DESCRIPTION:
C     Write "RS" type local-tile array "field" corresponding to tile bi,bj
C     to binary file (prefix,suffix) at record position "iRec".

C     !USES:
      IMPLICIT NONE
C     Global variables / common blocks
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     pref    :: file name prefix
C     suff    :: file name suffix
C     nNr     :: Number of levels to write
C     field   :: field array to write
C     bi,bj   :: tile indices
C     iRec    :: record number in output file
C     myIter  :: Iteration number
C     myThArg :: thread argument (= my Thread Id or = 0 to simply
C                     write 1 tile without thread synchronisation)
      CHARACTER*(*) pref,suff
      INTEGER nNr
      _RS field(1-Olx:sNx+Olx,1-Oly:sNy+Oly,nNr)
      INTEGER bi,bj
      INTEGER iRec
      INTEGER myIter
      INTEGER myThArg

C     !FUNCTIONS
      INTEGER  IFNBLNK, ILNBLNK
      EXTERNAL IFNBLNK, ILNBLNK

C     Common block
      COMMON /RD_WR_FLD/ globalFile
      LOGICAL globalFile

C     !LOCAL VARIABLES:
      LOGICAL useCurrentDir
      _RL dummyRL(1)
      CHARACTER*(2) fType
      CHARACTER*(MAX_LEN_FNAM) fullName
      INTEGER s1Lo,s1Hi,s2Lo,s2Hi
      INTEGER myThid

C--   Build file name
C     Name has form 'prefix.suffix'
C     e.g. U.0000000100
      s1Lo = IFNBLNK(pref)
      s1Hi = ILNBLNK(pref)
      IF ( suff .EQ. ' ' ) THEN
       WRITE( fullName, '(A)' ) pref(s1Lo:s1Hi)
      ELSEIF ( suff .EQ. 'I10' ) THEN
       WRITE( fullName, '(A,A,I10.10)' ) pref(s1Lo:s1Hi),'.',myIter
      ELSE
       s2Lo = IFNBLNK(suff)
       s2Hi = ILNBLNK(suff)
       WRITE( fullName, '(A,A)' ) pref(s1Lo:s1Hi),suff(s2Lo:s2Hi)
      ENDIF
C
      useCurrentDir = .TRUE.
      fType='RS'
#ifdef ALLOW_MDSIO
      IF (nSx.EQ.1.AND.nSy.EQ.1) THEN
C The hack below replaces MDS_WRITELOCAL with MDS_WRITE_FIELD for
C single-threaded execution because the former does not support the
C singleCpuIo option. This is a placeholder until MDS_WRITELOCAL
C functionality is superseded by pkg/diagnostics.
         myThid = MAX(myThArg,1)
         CALL MDS_WRITE_FIELD(
     I                        fullName, writeBinaryPrec,
     I                        globalFile, useCurrentDir,
     I                        fType, nNr, 1, nNr, dummyRL, field,
     I                        iRec, myIter, myThid )
      ELSE
         CALL MDS_WRITELOCAL(
     I                        fullName, writeBinaryPrec, globalFile,
     I                        fType, nNr, dummyRL, field,
     I                        bi, bj, iRec, myIter, myThArg )
      ENDIF
#endif

      RETURN
      END

#include "CPP_OPTIONS.h"

c     ==================================================================
c
c     shpere.F: Routines that handle the projection onto sherical
c               harmonics.
c
c     Routines:
c
c     o adfsc4dat  - Adjoint routine of fsc4dat.
c     o shc2grid   - Evaluate a spherical harmonics model on a
c                    regular grid.
c     o shc4grid   - Evaluate a spherical harmonics model on a
c                    regular grid.
c
c     o shcrotate  - s/r used for the sph analysis ...
c     o shc2zone   - s/r used for the sph analysis ...
c     o shc4zone   - s/r used for the sph analysis ...
c     o fsc2dat    - s/r used for the sph analysis ...
c     o frsbase    - s/r used for the sph analysis ...
c     o helmholtz  - s/r used for the sph analysis ...
c     o recur_z    - s/r used for the sph analysis ...
c
c     o shcError   - Print error message and stop program (see below).
c
c     IMSL Routines:
c
c     o fftrb      - Compute the real periodic sequence from its Fourier
c                    coefficients.
c                    --> replace by NAGLIB routine. C06...
c
c     Platform-specific:
c
c     M abort      - FORTRAN intrinsic on SUN and, presumably, on CRAY to
c                    exit the program if an error condition is met.
c
c     -->  Replaced ABORT by shcError ( Christian Eckert  MIT  22-Mar-2000 )
c
c     Note:
c     =====
c
c     Where code is written in lower case letters, changes were
c     introduced. The changes are mainly related to F90 syntax.
c     Additionally, I replaced the call to the intrinsic *AMOD*
c     by its generic name *MOD*. ( Ch.E. 25-May-1999 )
c
c
c     Documentation:
c
c
c     ==================================================================

      SUBROUTINE FSC4DAT(N,FSC)

      IMPLICIT NONE

      INTEGER N
      REAL FSC(N)
      REAL SCALE
      integer i

#ifdef USE_SPH_PROJECTION
      CALL FFTRF(N,FSC,FSC)
#else
      do i=1,n
        fsc(i) = 0.0
      enddo
#endif

      SCALE        = 2.0/FLOAT(N)
      FSC(1)       = FSC(1)/FLOAT(N)

CE      FSC(2:N-1:2) = FSC(2:N-1:2)*SCALE
CE      FSC(3:N  :2) =-FSC(3:N:  2)*SCALE ! change sign of SINE coeffs.

      do i = 2,n-1,2
        fsc( i ) =  fsc( i )*scale
      enddo
      do i = 3,n,2
        fsc( i ) = -fsc( i )*scale ! change sign of sine coeffs.
      enddo

      IF (MOD(N,2).EQ.0) THEN
         FSC(N) = FSC(N)/FLOAT(N)
      ENDIF

      RETURN
      END

c     ==================================================================

      subroutine adfsc4dat(n,adfsc)

      implicit none

      integer n
      real adfsc(n)

      integer i

#ifdef USE_SPH_PROJECTION
      call fftrb(n,adfsc,adfsc)
#else
      do i=1,n
        adfsc(i) = 0.0
      enddo
#endif

      do i=1,n
        adfsc(i) = adfsc(i)/float(n)
      enddo

      end

c     ==================================================================

      SUBROUTINE SHC2GRID( LMAX, SHC, NLON, NLAT, GRID, P )
C
C --- Evaluate a spherical harmonics model on a regular grid.
C
C      SHC  ! spherical harmonic coefficients in the order of
C           !
C           !         C00         :               SHC(1)
C           !     S11 C10 C11     :        SHC(2) SHC(3) SHC(4)
C           ! S22 S21 C20 C21 C22 : SHC(5) SHC(6) SHC(7) SHC(8) SHC(9)
C           !
C           ! i.e.,  C(L,M) = SHC(L*L+L+1+M)
C           !        S(L,M) = SHC(L*L+L+1-M)
C     NLAT  ! number of latitude (zonal) lines.
C     NLON  ! number of longitude (meridional) lines.
C           !
C     GRID  ! grid values in the order of
C           ! ((west to east),south to north)
C           ! ((LON=1,NLON),LAT=1,NLAT)
C           ! grid values are defined on the "centers"
C           ! of geographically regular equi-angular blocks.
C
C --- Coded by Dr. Myung-Chan Kim, Center for Space Research, 1997
C              University of Texas at Austin, Austin, Texas, 78712
C
      IMPLICIT NONE

      INTEGER LMAX                       ! INPUT  max. degree
      REAL    SHC((1+LMAX)*(1+LMAX))     ! INPUT  spherical harmonics
      INTEGER NLAT                       ! INPUT  number of latitude  lines.
      INTEGER NLON                       ! INPUT  number of longitude lines.
      REAL    GRID(NLON,NLAT)            ! OUTPUT grid values
      REAL    P((LMAX+1)*(LMAX+2)/2)     ! work space

      INTEGER NLONLMT
      PARAMETER (NLONLMT=10000)
      REAL HS (NLONLMT)
      REAL HN (NLONLMT)

      REAL    DLAT, ANGLE, XLAT1, XLAT2
      INTEGER LATS, LATN

ce    integer js, jn

      integer i

ce      IF(NLON.GT.NLONLMT) CALL ABORT('NLON.GT.NLONLMT')
ce      IF(NLON.LT.LMAX*2 ) CALL ABORT('NLON.LT.LMAX*2 ')
      IF(NLON.GT.NLONLMT) CALL shcError('NLON.GT.NLONLMT',1)
      IF(NLON.LT.LMAX*2 ) CALL shcError('NLON.LT.LMAX*2 ',1)

      DLAT  = 180.0/FLOAT(NLAT)
      ANGLE = 180.0/FLOAT(NLON)

      CALL SHCROTATE(LMAX,SHC,ANGLE)
      DO LATS = 1,(NLAT+1)/2
         LATN = NLAT-(LATS-1)
         XLAT2 =-90.0 + FLOAT(LATS)*DLAT
         XLAT1 = XLAT2-DLAT
         do i=1,nlon
           hs(i) = 0.0
           hn(i) = 0.0
         enddo
         CALL SHC2ZONE( LMAX, SHC, XLAT1, XLAT2, HS, HN, P )
         CALL FSC2DAT( NLON, HS )
         CALL FSC2DAT( NLON, HN )
         do i=1,nlon
           grid(i,lats) = hs(i)
           grid(i,latn) = hn(i)
         enddo
      ENDDO
      CALL SHCROTATE(LMAX,SHC,-ANGLE)
      RETURN
      END

c     ==================================================================

      SUBROUTINE SHC4GRID( LMAX, SHC, NLON, NLAT, GRID, P )

      IMPLICIT NONE

      INTEGER LMAX                       ! INPUT  max. degree
      REAL    SHC((1+LMAX)*(1+LMAX))     ! OUTPUT spherical harmonics
      INTEGER NLAT                       ! INPUT  number of latitude  lines.
      INTEGER NLON                       ! INPUT  number of longitude lines.
      REAL    GRID(NLON,NLAT)            ! INPUT  grid values
      REAL    P((LMAX+1)*(LMAX+2)/2)     ! work space

      INTEGER NLONLMT
      PARAMETER (NLONLMT=10000)
      REAL HS (NLONLMT)
      REAL HN (NLONLMT)

      REAL    DLAT, ANGLE, XLAT1, XLAT2
      INTEGER LATS, LATN

ce    integer js, jn

      integer i

      IF(NLON.GT.NLONLMT) THEN
         PRINT *, 'NLON = ', NLON
         PRINT *, 'NLONLMT = ', NLONLMT
ce         CALL ABORT('NLON.GT.NLONLMT')
         CALL shcError('NLON.GT.NLONLMT',1)
      END IF

      IF(NLON.LT.LMAX*2 ) THEN
         PRINT *, 'NLON = ', NLON
         PRINT *, 'LMAX = ', LMAX
ce         CALL ABORT('NLON.LT.LMAX*2')
         CALL shcError('NLON.LT.LMAX*2',1)
      END IF

      DLAT  = 180.0/FLOAT(NLAT)
      ANGLE = 180.0/FLOAT(NLON)
      DO LATS = 1,(NLAT+1)/2
         LATN = NLAT-(LATS-1)
         do i = 1,nlon
           hs(i) = grid(i,lats)
           hn(i) = grid(i,latn)
         enddo
         CALL FSC4DAT(NLON,HS)
         CALL FSC4DAT(NLON,HN)
         XLAT2 =-90.0 + FLOAT(LATS)*DLAT
         XLAT1 = XLAT2-DLAT
         CALL SHC4ZONE(LMAX,SHC,XLAT1,XLAT2,HS,HN,P)
      ENDDO
      CALL SHCROTATE(LMAX,SHC,-ANGLE)

      RETURN
      END

c     ==================================================================

      SUBROUTINE SHCROTATE(LMAX,SHC,ANGLE)

      IMPLICIT NONE

      INTEGER  LMAX                   ! max. degree of spherical harmonics.
      REAL     SHC((1+LMAX)*(1+LMAX)) ! spherical harmonic coeffs.
      REAL     ANGLE                  ! in degree.

      INTEGER LMAXLMT
      PARAMETER (LMAXLMT=10000)

      REAL    H(LMAXLMT*2+1)
      INTEGER K, L, M
      REAL    SINA, COSA, C, S

      if (mod(angle,360.0) .ne. 0.0) then

         CALL FRSBASE(ANGLE,H,1,1+LMAX+LMAX)

         DO M = 0,LMAX
            IF(M.EQ.0) THEN
               SINA = 0.0
               COSA = 1.0
            ELSE
               COSA = H(M+M)
               SINA = H(M+M+1)
            ENDIF
            DO L = M,LMAX
               K = L*L+L+1
               C = SHC(K+M)
               S = SHC(K-M)
               SHC(K+M) = COSA*C + SINA*S
               SHC(K-M) =-SINA*C + COSA*S
            ENDDO
         ENDDO

      ENDIF

      RETURN
      END

c     ==================================================================

      SUBROUTINE SHC2ZONE(LMAX,SHC,XLAT1,XLAT2,HS,HN,P)

      IMPLICIT NONE

      INTEGER LMAX                   ! INPUT  max. degree of spher. harmonics.
      REAL    SHC((1+LMAX)*(1+LMAX)) ! INPUT  spherical harmonic coeffs.
      REAL    XLAT1                  ! INPUT  latitude.
      REAL    XLAT2                  ! INPUT  latitude.
      REAL    HS(1+LMAX+LMAX)        ! OUTPUT
      REAL    HN(1+LMAX+LMAX)        ! OUTPUT
      REAL    P((LMAX+1)*(LMAX+2)/2) ! INPUT

      INTEGER LMAXLMT
      PARAMETER (LMAXLMT=5000)

      REAL    FACT(0:LMAXLMT) !
      INTEGER LMAX1, J, K, L, M
      REAL    DEG2RAD, SLAT
      REAL    A, B, E, F, Q, DA, DB, XLAT

ce      IF (LMAX.GT.LMAXLMT) CALL ABORT('LMAX.GT.LMAXLMT')
cph      IF (LMAX.GT.LMAXLMT) CALL shcError('LMAX.GT.LMAXLMT',1)

      DEG2RAD = ACOS(-1.0)/180.0
      XLAT = 0.5*(XLAT1+XLAT2)
      do k = 1,lmax
        fact(k) = 1.0
      enddo
      SLAT = SIN(XLAT*DEG2RAD)

      CALL HELMHOLTZ(LMAX,SLAT,P)
      LMAX1 = LMAX+1
      K    = 0
      DO M = 0,LMAX
         A    = 0.0
         B    = 0.0
         E    = 0.0
         F    = 0.0
         DO L = M,LMAX-1,2
            K    = K+1
            J    = L*L+L+1
            Q    = FACT(L)*P(K)
            DA   = Q*SHC(J+M)
            DB   = Q*SHC(J-M)
            A    = A+DA
            B    = B+DB
            E    = E+DA
            F    = F+DB
            K    = K+1
            J    = J+L+L+2
            Q    = FACT(L+1)*P(K)
            DA   = Q*SHC(J+M)
            DB   = Q*SHC(J-M)
            A    = A+DA
            B    = B+DB
            E    = E-DA
            F    = F-DB
         ENDDO
         IF(MOD(LMAX-L,2).EQ.0) THEN
            K    = K+1
            J    = LMAX*LMAX+LMAX+1
            Q    = FACT(LMAX)*P(K)
            DA   = Q*SHC(J+M)
            DB   = Q*SHC(J-M)
            A    = A+DA
            B    = B+DB
            E    = E+DA
            F    = F+DB
         ENDIF
         IF(M.EQ.0) THEN
            HS(1) = A
            HN(1) = E
         ELSE
            HS(M+M  ) = A
            HS(M+M+1) = B
            HN(M+M  ) = E
            HN(M+M+1) = F
         ENDIF
      ENDDO

      RETURN
      END

c     ==================================================================

      SUBROUTINE SHC4ZONE(LMAX,SHC,XLAT1,XLAT2,HS,HN,P)

      IMPLICIT NONE

      INTEGER LMAX
      REAL    SHC((1+LMAX)*(1+LMAX))    ! spherical harmonic coeffs.
      REAL    XLAT1                     ! latitude.
      REAL    XLAT2                     ! latitude.
      REAL    P((LMAX+1)*(LMAX+2)/2)
C
C   - output -
C
      REAL HS(1+LMAX+LMAX)
      REAL HN(1+LMAX+LMAX)
C
C   - work space -
C
      INTEGER LMAXLMT
      PARAMETER (LMAXLMT=5000)

      REAL    XLAT, SIN0, SIN1, SIN2, SCALE
      REAL    DEG2RAD, CE, CO, SE, SO
      INTEGER I, J, K, L, M
      INTEGER JP, I1, I2

ce      IF(LMAX.GT.LMAXLMT) CALL ABORT('LMAX.GT.LMAXLMT')
cph      IF(LMAX.GT.LMAXLMT) CALL shcError('LMAX.GT.LMAXLMT',1)

      IF(XLAT1 .LT. -90.0+1.E-10) THEN
        do i = 1,(1+lmax)*(1+lmax)
          shc(i) = 0.0
        enddo
      ENDIF

      XLAT  = 0.5*(XLAT1+XLAT2)
      DEG2RAD  = ACOS(-1.0)/180.0
         SIN0  = SIN(XLAT *DEG2RAD)
         SIN1  = SIN(AMAX1(-90.0,XLAT1)*DEG2RAD)
         SIN2  = SIN(AMIN1(  0.0,XLAT2)*DEG2RAD)
         SCALE = (SIN2 - SIN1)*0.25
      do i = 1,lmax+lmax+1
        hs(i) = hs(i)*scale
        hn(i) = hn(i)*scale
      enddo

      CALL HELMHOLTZ(LMAX,SIN0,P)
      I    = 0
cadj loop = parallel
      DO M = 0,LMAX
         IF (M .EQ. 0) THEN
            J  = 1
            JP = 1
         ELSE
            J  = 2*M
            JP = J+1
         ENDIF
         CE = HS(J)+HN(J)
         CO = HS(J)-HN(J)
         SE = HS(J)+HN(JP)
         SO = HS(J)-HN(JP)
         I1 = I+1
         I2 = I+2
cadj loop = parallel
         DO L = M,LMAX-1,2
            K = L*L+L+1
            SHC(K+M) = SHC(K+M) + P(I1) * CE
            SHC(K-M) = SHC(K-M) + P(I1) * SE
            K = K+L+L+2
            SHC(K+M) = SHC(K+M) + P(I2) * CO
            SHC(K-M) = SHC(K-M) + P(I2) * SO
         ENDDO
         I = I + 2
         IF(MOD(LMAX-M,2).NE.1) THEN
            I = I+1
            K = LMAX*LMAX+LMAX+1
            SHC(K+M) = SHC(K+M) + P(I) * CE
            SHC(K-M) = SHC(K-M) + P(I) * SE
         ENDIF
      ENDDO
      RETURN
      END

c     ==================================================================

      subroutine fsc2dat(n,fsc)
c
c --- this routine are coded to clarify the imsl's fftrf/fftrb.
c
      implicit none

      integer n
      real fsc(n)

      integer i

      do i = 2,n-1,2
        fsc(i  ) =  fsc(i  )*0.5
        fsc(i+1) = -fsc(i+1)*0.5   ! change sign of sine coeffs.
      enddo

#ifdef USE_SPH_PROJECTION
      call fftrb(n,fsc,fsc)
#else
      do i = 1,n
        fsc( i ) = 0.0
      enddo
#endif

      return
      end

c     ==================================================================

      SUBROUTINE FRSBASE(A,H,I,J)
C
C --- Given A (in degree), return H(I:J) = 1,COS(A),SIN(A).....
C
      IMPLICIT NONE

      REAL A
      REAL H(1)
      INTEGER I, J

      REAL DEG2RAD, T, ARG
      INTEGER N, L

      DEG2RAD = ACOS(-1.0)/180.0

      N      = J-I+1
      IF(N.LE.0) RETURN
      H(I)   = 1.0
      IF(N.EQ.1) RETURN
      ARG    = A * DEG2RAD
      H(I+1) = COS(ARG)
      IF(N.EQ.2) RETURN
      H(I+2) = SIN(ARG)
      IF(N.EQ.3) RETURN
      T      = H(I+1)+H(I+1)
      H(I+3) = T*H(I+1) - 1.0
      IF(N.EQ.4) RETURN
      H(I+4) = T*H(I+2)
      IF(N.EQ.5) RETURN
      DO L = I+5,J
      H(L)   = T*H(L-2)-H(L-4)
      END DO

      RETURN
      END

c     ==================================================================

      SUBROUTINE HELMHOLTZ(LMAX,S,P)
C
C --- compute the fully normalized associated legendre polynomials.
C
      IMPLICIT NONE

      INTEGER LMAX        ! INPUT  max. degree.
      REAL    S           ! INPUT  sin(latitude).
      REAL    P(1)        ! OUTPUT assoc. legendre polynomials.

      INTEGER LMAXLMT
      PARAMETER(LMAXLMT=10800)

      REAL A(0:LMAXLMT)
      REAL ISECT(0:LMAXLMT)
      REAL X(LMAXLMT)
      REAL Y(LMAXLMT+LMAXLMT)
      REAL Z(LMAXLMT)

      INTEGER LMAXOLD
      DATA    LMAXOLD/-1/
      SAVE    LMAXOLD, ISECT, X, Y, Z

      REAL    C, CM, AK
      INTEGER K, L, N, M

      IF(LMAX.NE.LMAXOLD) THEN
         ISECT(0) = 1
         DO L = 1,LMAX
            X(L) = SNGL(1.0D0/DSQRT(DBLE(FLOAT(4*L*L-1))))
            Y(L) = SNGL(DSQRT(DBLE(FLOAT(L))))
            Y(L+LMAX) = SNGL(DSQRT(DBLE(FLOAT(L+LMAX))))
            ISECT(L) = L*LMAX-L*(L-3)/2+1
         ENDDO
         CALL RECUR_Z(Z,LMAX)
         LMAXOLD = LMAX
      ENDIF

      C  = SNGL(DSQRT(1.0D0-DBLE(S)*DBLE(S)))
      CM = 1.0
         P(1) = 1.0
         DO M = 1,LMAX
            K = ISECT(M)
            CM   =    C * CM
            P(K) = Z(M) * CM
         ENDDO
         N    = 1
         DO M = 0,LMAX-N
            K = ISECT(M)+N
            L = N+M
            AK   = X(L)*Y(L+M)*Y(N)
            P(K) = S*P(K-1)/AK
            A(M) = AK
         ENDDO
         DO N = 2,LMAX
            DO M = 0,LMAX-N
               K = ISECT(M)+N
               L = N+M
               AK   = X(L)*Y(L+M)*Y(N)
               P(K) =(S*P(K-1)-P(K-2)*A(M))/AK
               A(M) = AK
            ENDDO
         ENDDO
      RETURN
      END

c     ==================================================================

      SUBROUTINE RECUR_Z(Z,LMAX)
C
C --- Coefficients for fully normalized sectorial Legendre polynomials.
C
      IMPLICIT NONE

      INTEGER LMAX
      REAL    Z(LMAX)

      DOUBLE PRECISION ZZ
      INTEGER L

      ZZ   = 2.0D0
      DO L = 1,LMAX
         ZZ   = ZZ * DBLE(FLOAT(L+L+1))/DBLE(FLOAT(L+L))
         Z(L) = SNGL(DSQRT(ZZ))
      ENDDO

      RETURN
      END

c     ==================================================================

      subroutine shcError( errstring, ierr )
c
c --- Print an error message and exit. Written in order to replace
c     the machine specific routine ABORT.
c     ( Christian Eckert  MIT  22-Mar-2000 )
c
      implicit none

      integer       ierr
      character*(*) errstring

      if ( ierr .ne. 0 ) then
        print*
        print*,' sphere: ',errstring
        print*
        stop   ' ... program stopped.'
      endif

      return
      end

c     ==================================================================

#include "THSICE_OPTIONS.h"
c#ifdef ALLOW_AUTODIFF
c# include "AUTODIFF_OPTIONS.h"
c#endif
#ifdef ALLOW_COST
# include "COST_OPTIONS.h"
#endif

      SUBROUTINE THSICE_COST_TEST( myTime, myIter, myThid )

c     ==================================================================
c     SUBROUTINE thsice_cost_test
c     ==================================================================
c
c     o Compute sea-ice cost function.  The following options can be
c       selected with data.thsice (THSICE_PARM02) variable thsice_cost_ice_flag
c
c     thsice_cost_ice_flag = 1
c     - compute mean sea-ice volume
c       costIceStart < myTime < costIceEnd
c
c     thsice_cost_ice_flag = 2
c     - compute mean sea-ice area
c       costIceStart < myTime < costIceEnd
c
c     thsice_cost_ice_flag = 3
c     - heat content of top level plus latent heat of sea-ice
c       costIceStart < myTime < costIceEnd
c
c     thsice_cost_ice_flag = 4
c     - heat content of top level
c       costIceStart < myTime < costIceEnd
c
c     thsice_cost_ice_flag = 5
c     - heat content of top level plus sea-ice plus latent heat of snow
c       costIceStart < myTime < costIceEnd
c
c     thsice_cost_ice_flag = 6
c     - quadratic cost function measuring difference between pkg/thsice
c       AREA variable and simulated sea-ice measurements at every time
c       step.
c
c     ==================================================================
c     SUBROUTINE thsice_cost_test
c     ==================================================================

      IMPLICIT NONE

c     == global variables ==
#ifdef ALLOW_THSICE_COST_TEST
#include "EEPARAMS.h"
#include "SIZE.h"
#include "GRID.h"
#include "PARAMS.h"
#include "THSICE_SIZE.h"
#include "THSICE_COST.h"
#include "THSICE_VARS.h"
c#include "DYNVARS.h"
#include "cost.h"
#endif /* ALLOW_THSICE_COST_TEST */

c     == routine arguments ==
      _RL     myTime
      INTEGER myIter
      INTEGER myThid

#ifdef ALLOW_THSICE_COST_TEST
c     == external functions ==
c     INTEGER  ILNBLNK
c     EXTERNAL ILNBLNK

c     == local variables ==
c     msgBuf     :: Informational/error message buffer
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      INTEGER bi, bj, i, j
      _RL tempVar

c     == end of interface ==

      IF ( myTime .GT. (endTime - lastinterval) ) THEN
         tempVar = 1. _d 0/
     &             ( ( 1. _d 0 + MIN(endTime-startTime,lastinterval) )
     &             / deltaTClock )

         IF ( thsice_cost_ice_flag .EQ. 1 ) THEN
c     sea-ice volume
            DO bj=myByLo(myThid),myByHi(myThid)
               DO bi=myBxLo(myThid),myBxHi(myThid)
                  DO j = 1,sNy
                     DO i =  1,sNx
                        objf_thsice(bi,bj) = objf_thsice(bi,bj) +
     &                       tempVar*rA(i,j,bi,bj)*iceHeight(i,j,bi,bj)
                     ENDDO
                  ENDDO
               ENDDO
            ENDDO

         ELSEIF ( thsice_cost_ice_flag .EQ. 2 ) THEN
c     sea-ice area
            DO bj=myByLo(myThid),myByHi(myThid)
               DO bi=myBxLo(myThid),myBxHi(myThid)
                  DO j = 1,sNy
                     DO i =  1,sNx
                        objf_thsice(bi,bj) = objf_thsice(bi,bj) +
     &                       tempVar*rA(i,j,bi,bj)*iceMask(i,j,bi,bj)
                     ENDDO
                  ENDDO
               ENDDO
            ENDDO

         ELSE
            WRITE(msgBuf,'(A)')
     &           'THSICE_COST_TEST: invalid thsice_cost_ice_flag'
            CALL PRINT_ERROR( msgBuf, myThid )
            STOP 'ABNORMAL END: S/R THSICE_COST_TEST'
         ENDIF
      ENDIF

#endif /* ALLOW_THSICE_COST_TEST */

      RETURN
      END

CBOI
C
C !TITLE: MITGCM KERNEL CODE SYNOPSIS
C !AUTHORS: mitgcm developers ( support@mitgcm.org )
C !AFFILIATION: Massachussetts Institute of Technology
C !DATE:
C !INTRODUCTION: Kernel dynamical routines
C This document summarises MITgcm code under the model/ subdirectory.
C The code under model/ ( src/ and inc/ ) contains most of
C the driver routines for the baseline forms of the kernel equations in the
C MITgcm algorithm. Numerical code for much of the baseline forms of
C these equations is also under the model/ directory. Other numerical code
C used for the kernel equations is contained in packages in the pkg/
C directory tree.
C Code for auxiliary equations and alternate discretizations of the kernel
C equations and algorithm can also be found in the pkg/ directory tree.
C
C \subsection{Getting Help and Reporting Errors and Problems}
C If you have questions please subscribe and e-mail support@mitgcm.org.
C We also welcome reports of errors and inconsistencies in the code or
C in the accompanying documentation. Please feel free to send these
C to support@mitgcm.org. For further information and to review
C problems reported to support@mitgcm.org please visit http://mitgcm.org.
C
C \subsection{MITgcm Kernel Code Calling Sequence}
C \bv
C
C Invocation from WRAPPER level...
C
C  |
C  |-THE_MODEL_MAIN :: Primary driver for the MITgcm algorithm
C    |              :: Called from WRAPPER level numerical
C    |              :: code invocation routine. On entry
C    |              :: to THE_MODEL_MAIN separate thread and
C    |              :: separate processes will have been established.
C    |              :: Each thread and process will have a unique ID
C    |              :: but as yet it will not be associated with a
C    |              :: specific region in decomposed discrete space.
C    |
C    |-INITIALISE_FIXED :: Set fixed model arrays such as topography,
C    | |                :: grid, solver matrices etc..
C    | |
C    | |-INI_PARMS :: Routine to set kernel model parameters.
C    | |           :: Kernel parameters are read from file "data"
C    | |           :: in directory in which code executes.
C    | |
C    | |-PACKAGES_BOOT       :: Start up the optional package environment.
C    | |                     :: Runtime selection of active packages.
C    | |-CPL_IMPORT_CPLPARMS :: Import coupling parameters from/to
C    | |                     :: the coupler layer
C    | |-PACKAGES_READPARMS  :: Read each package input parameter file
C    | | |- ${PKG}_READPARMS
C    | |
C    | |-SET_PARMS :: Finalise model parameter setting (if fct of pkg usage)
C    | |
C    | |-INI_MODEL_IO   :: Initialise Input/Output setting
C    | |  |-MNC_INIT    :: Initialise MITgcm NetCDF interface (MNC)(see pkg/mnc)
C    | |  |-MNC_CW_INIT :: Initialise MNC grid and variable types  (see pkg/mnc)
C    | |  |-MON_INIT    :: Initialises monitor package ( see pkg/monitor )
C    | |
C    | |-INI_GRID       :: Control grid array (vert. and horiz.) initialisation.
C    | | |              :: Grid arrays are held and described in GRID.h.
C    | | |-LOAD_GRID_SPACING    :: Load grid spacing (vector) from files
C    | | |-INI_VERTICAL_GRID    :: Set up vertical grid and coordinate
C    | | |-INI_CARTESIAN_GRID   :: Cartesian horiz. grid initialisation
C    | | |                      :: (calculate grid from kernel parameters).
C    | | |-INI_SPHERICAL_POLAR_GRID :: Spherical polar horiz. grid setting
C    | | |                          :: (calculate grid from kernel parameters).
C    | | |-INI_CURVILINEAR_GRID :: General orthogonal, structured horiz. grid
C    | | |                      :: initialisation; input from raw grid files
C    | | |                      :: (LONC.bin, LATC.bin, DXF.bin, ... ) or per
C    | | |                      :: face file: horizGridFile(.faceXXX.bin)
C    | | |-INI_CYLINDER_GRID    :: Cylindrical horiz. grid setting
C    | |
C    | |-LOAD_REF_FILES   :: Read-in reference vertical profiles (T,S,Rho)
C    | |-INI_EOS          :: Initialise Equation Of State (EOS) coefficients
C    | |-SET_REF_STATE    :: Set reference pressure/geopotential, reference
C    | |                  :: stratification (for implicit IGW), vertical
C    | |                  :: velocity scaling factor and anelastic ref. density
C    | |-SET_GRID_FACTORS :: Set grid factors (fct of k) for deep-atmosphere
C    | |
C    | |-INI_DEPTHS    :: Read (from "bathyFile") or set bathymetry/orography.
C    | |-INI_MASKS_ETC :: Derive horizontal and vertical cell fractions and
C    | |               :: land masking for solid-fluid boundaries.
C    | |
C    | |-PACKAGES_INIT_FIXED  :: do all packages fixed-initialisation setting
C    | | |- ${PKG}_INIT_FIXED
C    | |
C    | |-INI_GLOBAL_DOMAIN :: Initialise domain related (global) quantities.
C    | |-INI_LINEAR_PHISURF :: Set ref. surface Bo_surf
C    | |
C    | |-INI_CORI          :: Set coriolis term. zero, f-plane, beta-plane,
C    | |                   :: sphere options are coded.
C    | |-INI_CG2D          :: 2D conjugate grad solver initialisation.
C    | |-INI_CG3D          :: 3D conjugate grad solver initialisation.
C    | |
C    | |-CONFIG_SUMMARY    :: Provide synopsis of kernel setup. Includes
C    | |                   :: annotated table of kernel parameter settings.
C    | |
C    | |-PACKAGES_CHECK    :: call each package configuration checking S/R
C    | | |- ${PKG}_CHECK
C    | |
C    | |-CONFIG_CHECK      :: Check config and parameter consistency.
C    | |
C    | |-WRITE_GRID        :: write grid fields to output files
C    | |-CPL_EXCH_CONFIGS  :: exchange config with coupler-interface
C    |
C    |-CTRL_UNPACK         :: Control vector support package. see pkg/ctrl
C    |-COST_DEPENDENT_INIT :: ( see pkg/cost )
C    |
C    |-ADTHE_MAIN_LOOP :: Derivative evaluating form of main time stepping loop
C    !                 :: Automatically generated by TAF.
C    |
C    |-THE_MAIN_LOOP   :: Main timestepping loop routine.
C    | |
C    | |-INITIALISE_VARIA :: Set the initial conditions for time evolving fields
C    | | |
C #ifdef ALLOW_AUTODIFF
C    | | |-INI_DEPTHS         \
C    | | |-CTRL_DEPTH_INI      \
C    | | |-UPDATE_MASKS_ETC     } ALLOW_DEPTH_CONTROL case
C    | | |-UPDATE_CG2D         /
C #endif
C    | | |-INI_NLFS_VARS :: Initialise all Non-Lin Free-Surf arrays (SURFACE.h)
C    | | |-INI_DYNVARS   :: Initialise to zero all DYNVARS.h arrays
C    | | |-INI_NH_VARS   :: Initialise to zero all NH_VARS.h arrays
C    | | |-INI_FFIELDS   :: Initialise forcing fields in FFIELDS.h to zero
C    | | |
C    | | |-INI_FIELDS    :: Control initialising model fields to non-zero
C    | | | |-INI_VEL     :: Initialize 3D flow field.
C    | | | |-INI_THETA   :: Set model initial temperature field.
C    | | | |-INI_SALT    :: Set model initial salinity field.
C    | | | |-INI_PSURF   :: Set model initial free-surface height/pressure.
C    | | | |-READ_PICKUP :: Read in main model pickup files to restart a run.
C    | | |
C    | | |-INI_MIXING   :: Initialise diapycnal diffusivity.
C    | | |
C    | | |-TAUEDDY_INIT_VARIA :: Initialise eddy (bolus) streamfunction
C    | | |
C    | | |-INI_FORCING  :: Set model initial forcing fields, either
C    | | |   |          :: set in-line or from file as shown here:
C    | | |   |-READ_FLD_XY_RS(zonalWindFile)
C    | | |   |-READ_FLD_XY_RS(meridWindFile)
C    | | |   |-READ_FLD_XY_RS(surfQnetFile)
C    | | |   |-READ_FLD_XY_RS(EmPmRfile)
C    | | |   |-READ_FLD_XY_RS(thetaClimFile)
C    | | |   |-READ_FLD_XY_RS(saltClimFile)
C    | | |   |-READ_FLD_XY_RS(surfQswFile)
C    | | |
C    | | |-AUTODIFF_INIT_VARIA :: (see pkg/autodiff )
C    | | |
C    | | |-PACKAGES_INIT_VARIABLES :: Does initialisation of time evolving
C    | | | | ${PKG}_INIT_VARIA     :: package data.
C    | | |
C    | | |-COST_INIT_VARIA     :: ( see pkg/cost )
C    | | |-CONVECTIVE_ADJUSTMENT_INI :: Apply conv. adjustment to initial state
C    | | |
C    | | |-CALC_R_STAR    :: Calculate the new level thickness factor (r* coord)
C    | | |-UPDATE_R_STAR  :: Update the level thickness fraction (r* coord).
C    | | |-UPDATE_SIGMA   :: Update the level thickness fraction (sigma-coord).
C    | | |-CALC_SURF_DR   :: Calculate the new surface level thickness.
C    | | |-UPDATE_SURF_DR :: Update the surface-level thickness fraction.
C    | | |
C    | | |-UPDATE_CG2D    :: Update 2D conjugate grad. for Free-Surf.
C    | | |
C    | | |-INTEGR_CONTINUITY :: Integrate the continuity Equation
C    | | | |-INTEGRATE_FOR_W :: Integrate for vertical velocity
C    | | | |-OBCS_APPLY_W    :: Open boundary package (see pkg/obcs).
C    | | | |-DUMMY_FOR_ETAN  :: For printing adEtaN (see pkg/autodiff).
C    | | | |-UPDATE_ETAH     :: Update Surface height/pressure
C    | | |
C    | | |-CALC_R_STAR    :: Calculate the new level thickness factor (r* coord)
C    | | |-CALC_SURF_DR   :: Calculate the new surface level thickness.
C    | | |
C    | | |-STATE_SUMMARY    :: Summarise model prognostic variables.
C    | | |
C    | | |-MONITOR          :: Monitor state (see pkg/monitor)
C    | | |
C    | | |-DO_THE_MODEL_IO  :: Controlling routine for IO
C    | | | |-WRITE_STATE    ::  Write model state variables.
C    | | | |-FIZHI_WRITE_STATE :: Write Fizhi pkg output (see pkg/fizhi)
C    | | | |-LAND_OUTPUT       :: Write Land pkg output (see pkg/land)
C    | | | |-OBCS_OUTPUT       :: Write OBCS pkg output (see pkg/obcs)
C    | | | |-GMREDI_OUTPUT     :: Write GM-Redi pkg output (see pkg/gmredi)
C    | | | |-KPP_OUTPUT        :: Write KPP  pkg output (see pkg/kpp)
C    | | | |-PP81_OUTPUT       :: Write PP81 pkg output (see pkg/pp81)
C    | | | |-KL10_OUTPUT       :: Write KL10 pkg output (see pkg/kl10)
C    | | | |-MY82_OUTPUT       :: Write MY82 pkg output (see pkg/my82)
C    | | | |-OPPS_OUTPUT       :: Write OPPS pkg output (see pkg/opps)
C    | | | |-GGL90_OUTPUT      :: Write GGL90 pkg output (see pkg/ggl90)
C    | | | |-SBO_CALC          :: Compute SBO diagnostics (see pkg/sbo)
C    | | | |-SBO_OUTPUT        :: Write SBO  pkg output   (see pkg/sbo)
C    | | | |-SEAICE_OUTPUT     :: Write SeaIce pkg output (see pkg/seaice)
C    | | | |-SHELFICE_OUTPUT   :: Write ShelfIce pkg output (see pkg/shelfice)
C    | | | |-THSICE_OUTPUT     :: Write ThSIce pkg output (see pkg/thsice)
C    | | | |-PTRACERS_OUTPUT   :: Write pTracers pkg output (see pkg/ptracers)
C    | | | |-MATRIX_OUTPUT     :: Write Matrix pkg output (see pkg/matrix)
C    | | | |-GCHEM_OUTPUT      :: Write Geochemistry pkg output (see pkg/gchem)
C    | | | |-LAYERS_CALC       :: Calculate layers diagnostics (see pkg/layers)
C    | | | |-DIAGNOSTICS_WRITE :: Write pkg/diagnostics output
C    | | |
C====|>| ****************************
C====|>| BEGIN MAIN TIMESTEPPING LOOP
C====|>| ****************************
C    | |-COST_AVERAGESFIELDS :: time-averaged Cost function terms (see pkg/cost)
C    | |-PROFILES_INLOOP     :: ( see pkg/profiles )
C    | /
C    | |-MAIN_DO_LOOP    :: Open-AD case: Main timestepping loop routine
C    | \                    otherwise: just call FORWARD_STEP
C    | |
C/\  | |-FORWARD_STEP        :: Step forward a time-step ( AT LAST !!! )
C/\  | | |
C/\  | | |-AUTODIFF_INADMODE_UNSET :: Set/reset some adjoint flags
C/\  | | |-RESET_NLFS_VARS   :: Reset some Non-Lin Free-Surf vars (Adjoint)
C/\  | | |-UPDATE_R_STAR     :: Reset r-star factor variables     (Adjoint)
C/\  | | |-UPDATE_SURF_DR    :: Reset NLFS surface thickness vars (Adjoint)
C/\  | | |
C/\  | | |-PTRACERS_SWITCH_ONOFF    :: Set/reset pTracers time-stepping switch
C/\  | | |-DIAGNOSTICS_SWITCH_ONOFF :: Activate/de-activate diagnostics
C/\  | | |-DO_STATEVARS_DIAGS ( 0 ) :: fill-up state variable diagnostics
C/\  | | |
C/\  | | |-NEST_CHILD_SETMEMO :: Nesting interface
C/\  | | |-NEST_PARENT_IO_1   :: Nesting interface
C/\  | | |
C/\  | | |-LOAD_FIELDS_DRIVER :: Control loading of input fields from files
C/\  | | |
C/\  | | |-BULKF_FORCING      :: Calculate surface forcing (see pkg/bulk_force)
C/\  | | |-CHEAPAML           :: Cheap AML driver ( see pkg/cheapaml )
C/\  | | |-CTRL_MAP_FORCING   :: Control vector support package. (see pkg/ctrl)
C/\  | | |-DUMMY_IN_STEPPING  :: Autodiff package ( pkg/autodiff ).
C/\  | | |
C/\  | | |-CPL_EXPORT_MY_DATA :: Send coupling fields to coupler
C/\  | | |-CPL_IMPORT_EXTERNAL_DATA :: Receive coupling fields from coupler
C/\  | | |
C/\  | | |-OASIS_PUT     :: Oasis coupler interface
C/\  | | |-OASIS_GET     :: Oasis coupler interface
C/\  | | |
C/\  | | |-EBM_DRIVER    :: Calculate EBM type atmospheric forcing (see pkg/ebm)
C/\  | | |
C/\  | | |-DO_ATMOSPHERIC_PHYS :: Atmospheric physics computation
C/\  | | | |
C/\  | | | |-UPDATE_OCEAN_EXPORTS     :: ( see pkg/fizhi )
C/\  | | | |-UPDATE_EARTH_EXPORTS     :: ( see pkg/fizhi )
C/\  | | | |-UPDATE_CHEMISTRY_EXPORTS :: ( see pkg/fizhi )
C/\  | | | |-FIZHI_WRAPPER            :: ( see pkg/fizhi )
C/\  | | | |-STEP_FIZHI_FG            :: ( see pkg/fizhi )
C/\  | | | |-FIZHI_UPDATE_TIME        :: ( see pkg/fizhi )
C/\  | | | |
C/\  | | | |-ATM_PHYS_DRIVER          :: ( see pkg/atm_phys )
C/\  | | | |
C/\  | | | |-AIM_DO_PHYSICS           :: ( see pkg/aim_v23 )
C/\  | | |
C/\  | | |-DO_OCEANIC_PHYS     :: Oceanic (& seaice) physics computation
C/\  | | | |
C/\  | | | |-OBCS_CALC         :: Open boundary. package (see pkg/obcs).
C/\  | | | |
C/\  | | | |-FRAZIL_CALC_RHS   :: Compute FRAZIL tendencies ( see pkg/frazil )
C/\  | | | |-THSICE_MAIN       :: Thermodynamic sea-ice driver (see pkg/thsice)
C/\  | | | |-SEAICE_MODEL      :: Sea-ice model driver (see pkg/seaice )
C/\  | | | |-SEAICE_COST_SENSI   :: Sea-ice cost-function (see pkg/seaice )
C/\  | | | |-SHELFICE_THERMODYNAMICS :: Compute ShelfIce thermo (pkg/shelfice)
C/\  | | | |-ICEFRONT_THERMODYNAMICS :: Compute IceFront thermo (pkg/icefront)
C/\  | | | |
C/\  | | | |-SALT_PLUME_DO_EXCH   :: (see pkg/salt_plume )
C/\  | | | |-FREEZE_SURFACE       :: Prevent SST to fall below TFreeze
C/\  | | | |-OCN_APPLY_IMPORT     :: Apply imported fields from coupler
C/\  | | | |-EXTERNAL_FORCING_SURF:: Compute appropriately dimensioned
C/\  | | | |                      :: surface forcing terms.
C/\  | | | |-FIND_RHO_2D @ p(k)   :: Calculate [rho(T,S,p)-Rho_0] of a slice
C/\  | | | |-FIND_RHO_2D @ p(k-1) :: Calculate [rho(T,S,p)-Rho_0] of a slice
C/\  | | | |-GRAD_SIGMA           :: Calculate isoneutral gradients
C/\  | | | |-CALC_IVDC       :: Set Implicit Vertical Diffusivity for Convection
C/\  | | | |-CALC_OCE_MXLAYER        :: Diagnose Oceanic Mixed Layer depth
C/\  | | | |
C/\  | | | |-SALT_PLUME_CALC_DEPTH   :: (see pkg/salt_plume )
C/\  | | | |-SALT_PLUME_VOLFRAC      :: (see pkg/salt_plume )
C/\  | | | |-SALT_PLUME_APPLY (Temp) :: (see pkg/salt_plume )
C/\  | | | |-SALT_PLUME_APPLY (Salt) :: (see pkg/salt_plume )
C/\  | | | |-SALT_PLUME_FORCING_SURF :: (see pkg/salt_plume )
C/\  | | | |-KPP_CALC           :: Compute KPP  vertical mixing ( see pkg/kpp )
C/\  | | | |-PP81_CALC          :: Compute PP81 vertical mixing ( see pkg/pp81 )
C/\  | | | |-KL10_CALC          :: Compute KL10 vertical mixing ( see pkg/kl10 )
C/\  | | | |-MY82_CALC          :: Compute MY82 vertical mixing ( see pkg/kl10 )
C/\  | | | |-GGL90_CALC         :: Compute GGL90 vertical mixing (see pkg/ggl10)
C/\  | | | |-GMREDI_CALC_TENSOR :: Compute GM-Redi tensor ( see pkg/gmredi )
C/\  | | | |-DWNSLP_CALC_FLOW   :: Compute Down-Slope flow  (see pkg/down_slope)
C/\  | | | |-BBL_CALC_RHS       :: Compute BBL tendencies ( see pkg/bbl )
C/\  | | | |-MYPACKAGE_CALC_RHS :: Compute mypackage tendencies (pkg/mypackage)
C/\  | | | |
C/\  | | | |-GMREDI_DO_EXCH     :: ( see pkg/gmredi )
C/\  | | | |-KPP_DO_EXCH        :: ( see pkg/kpp )
C/\  | | | |-DIAGS_RHO_G        :: Compute some density related diagnostics
C/\  | | | |-DIAGS_OCEANIC_SURF_FLUX :: Diagnose oceanic surface fluxes
C/\  | | | |-SALT_PLUME_DIAGNOSTICS_FILL :: (see pkg/salt_plume )
C/\  | | | |-ECCO_PHYS          :: ( see pkg/ecco )
C/\  | | |
C/\  | | |-STREAMICE_TIMESTEP   :: ( see pkg/streamice )
C/\  | | |
C/\  | | |-GCHEM_CALC_TENDENCY  :: geochemistry driver routine (see pkg/gchem)
C/\  | | |
C/\  | | |-LONGSTEP_AVERAGE        :: Averaging state vars ( see pkg/longstep )
C/\  | | |-LONGSTEP_THERMODYNAMICS :: Step forward tracers ( see pkg/longstep )
C/\  | | |
C/\  | | |-THERMODYNAMICS       :: theta, salt + tracer equations driver.
C/\  | | | |                         (synchronous time-stepping case)
C/\  | | | |-CALC_WSURF_TR          :: Compute T & S Linear-Free-Surf correction
C/\  | | | |-PTRACERS_CALC_WSURF_TR :: Compute Tracers Linear-Free-Surf correct.
C/\  | | | |
C/\  | | | |-GMREDI_RESIDUAL_FLOW :: Get the flow field used to advect tracers
C/\  | | | |
C/\  | | | |-TEMP_INTEGRATE       :: Step forward Prognostic Eq for Temperature.
C/\  | | | | |
C/\  | | | | |-ADAMS_BASHFORTH3   :: Extrapolate tracer forward in time (AB-3)
C/\  | | | | |-ADAMS_BASHFORTH2   :: Extrapolate tracer forward in time (AB-2)
C/\  | | | | |-CALC_3D_DIFFUSIVITY :: set vertical diffusivity
C/\  | | | | |
C/\  | | | | |-GAD_SOM_ADVECT     :: Second Order Moment (SOM) advection
C/\  | | | | |-GAD_ADVECTION      :: Generalised advection driver (multi-dim
C/\  | | | | |                         advection case) (see pkg/gad).
C/\  | | | | |-CALC_ADV_FLOW      :: set 3-D flow field to advect tracer
C/\  | | | | |-APPLY_FORCING_T    :: Problem specific forcing for temperature.
C/\  | | | | |-GAD_CALC_RHS       :: Calculate Advection-Diffusion tendency terms
C/\  | | | | |
C/\  | | | | |-ADAMS_BASHFORTH3   :: Extrapolate tendency forward in time (AB-3)
C/\  | | | | |-ADAMS_BASHFORTH2   :: Extrapolate tendency forward in time (AB-2)
C/\  | | | | |-FREESURF_RESCALE_G :: Re-scale Gt for free-surface height.
C/\  | | | | |-DWNSLP_APPLY       :: Add pkg/down_slope tendency
C/\  | | | | |
C/\  | | | | |-TIMESTEP_TRACER    :: Step tracer field forward in time
C/\  | | | | |
C/\  | | | | |-GAD_IMPLICIT_R     :: Solve vertical implicit Advect-Diffus. eqn.
C/\  | | | | |-IMPLDIFF           :: Solve vertical implicit diffusion equation.
C/\  | | | | |-CYCLE_AB_TRACER    :: Cycle time-stepping arrays for tracer field
C/\  | | | | |-CYCLE_TRACER       :: Cycle time-stepping arrays for tracer field
C/\  | | | |
C/\  | | | |-SALT_INTEGRATE       :: Step forward Prognostic Eq for Salinity.
C/\  | | | | |                       same sequence of calls as in TEMP_INTEGRATE
C/\  | | | |
C/\  | | | |-PTRACERS_INTEGRATE   :: Integrate other tracer(s) (see pkg/ptracers).
C/\  | | | | |                       same sequence of calls as in TEMP_INTEGRATE
C/\  | | | | |-OBCS_APPLY_PTRACER :: Open boundary package for pTracers
C/\  | | | |
C/\  | | | |-OBCS_APPLY_TS        :: Open boundary package (see pkg/obcs ).
C/\  | | |
C/\  | | |-LONGSTEP_AVERAGE        :: Averaging state vars ( see pkg/longstep )
C/\  | | |-LONGSTEP_THERMODYNAMICS :: Step forward tracers ( see pkg/longstep )
C/\  | | |
C/\  | | |-DO_STAGGER_FIELDS_EXCHANGES :: Update overlap regions of arrays
C/\  | | |                                 Theta & Salt (implicit IGW case)
C/\  | | |
C/\  | | |-DYNAMICS       :: Momentum equations driver.
C/\  | | | |
C/\  | | | |-CALC_GRAD_PHI_SURF :: Calculate the gradient of the surface
C/\  | | | |                       Potential anomaly.
C/\  | | | |-CALC_VISCOSITY   :: Calculate net vertical viscosity
C/\  | | | |-MOM_CALC_3D_STRAIN :: Calculates the strain tensor of 3D flow field
C/\  | | | |-OBCS_COPY_UV_N   :: for Stevens bndary Conditions (see pkg/obcs)
C/\  | | | |
C/\  | | | |-CALC_PHI_HYD     :: Integrate the hydrostatic relation.
C/\  | | | |-MOM_FLUXFORM     :: Flux Form momentum eqn. (pkg/mom_fluxform)
C/\  | | | |-MOM_VECINV       :: Vector Invariant momentum eqn (pkg/mom_vecinv)
C/\  | | | |-MOM_CALC_SMAG_3D :: Calculate Smagorinsky 3D (harmonic) viscosities
C/\  | | | |-MOM_UV_SMAG_3D   :: Calculate U,V mom. tendency due to Smag 3D Visc
C/\  | | | |-TIMESTEP         :: Step horizontal momentum fields forward in time
C/\  | | | |
C/\  | | | |-MOM_U_IMPLICIT_R :: Solve implicitly vertical Adv-Diffus equation.
C/\  | | | |-IMPLDIFF         :: Solve vertical implicit diffusion equation.
C/\  | | | |-OBCS_SAVE_UV_N   :: for Stevens bndary Conditions (see pkg/obcs)
C/\  | | | |-OBCS_APPLY_UV    :: Apply Open bndary Conditions to provisional U,V
C/\  | | | |-IMPLDIFF         :: (CD-Scheme) Solve vertical impl. diffus. eqn
C/\  | | | |
C/\  | | | |-CALC_GW          :: Vert. momentum tendency terms (Non-Hydrostatic)
C/\  | | | | |-MOM_W_SMAG_3D  :: Calculate W mom. tendency due to Smag 3D Visc
C/\  | | | |-TIMESTEP_WVEL    :: Step vert mom forward in time (Non-Hydrostatic)
C/\  | | |
C/\  | | |-MNC_UPDATE_TIME    :: Update MNC time record (see pkg/mnc)
C/\  | | |
C/\  | | |-UPDATE_R_STAR  :: Update the level thickness fraction (r* coord).
C/\  | | |-UPDATE_SIGMA   :: Update the level thickness fraction (sigma-coord).
C/\  | | |-UPDATE_R_STAR  :: Update the level thickness fraction.
C/\  | | |-UPDATE_SURF_DR :: Update the surface-level thickness fraction.
C/\  | | |-UPDATE_CG2D    :: Update 2D conjugate grad. for Free-Surf.
C/\  | | |
C/\  | | |-SHAP_FILT_APPLY_UV  :: Apply Shapiro Filter to provisional velocity
C/\  | | |-ZONAL_FILT_APPLY_UV :: Apply  Zonal  Filter to provisional velocity
C/\  | | |
C/\  | | |-SOLVE_FOR_PRESSURE  :: Find surface pressure.
C/\  | | | |-CALC_DIV_GHAT     :: Form the RHS of the surface pressure eqn.
C/\  | | | |-CG2D              :: Two-dim pre-con. conjugate-gradient.
C/\  | | | |-PRE_CG3D          :: Finish to set the RHS of the 3-D pressure eqn.
C/\  | | | |-CG3D              :: Three-dim pre-con. conjugate-gradient solver.
C/\  | | | |-POST_CG3D         :: finalise solution of NH and Free-Surf pressure
C/\  | | |
C/\  | | |-MOMENTUM_CORRECTION_STEP :: Finalise momentum stepping
C/\  | | | |-CALC_GRAD_PHI_SURF  :: Return DDx and DDy of surface pressure
C/\  | | | |-CORRECTION_STEP     :: Pressure correction to momentum
C/\  | | | |-OBCS_APPLY_UV       :: Open boundary package (see pkg/obcs).
C/\  | | | |-SHAP_FILT_APPLY_UV  :: Apply Shapiro Filter to latest velocity
C/\  | | | |-ZONAL_FILT_APPLY_UV :: Apply  Zonal  Filter to latest velocity
C/\  | | |
C/\  | | |-INTEGR_CONTINUITY   :: Integrate continuity equation (see above)
C/\  | | |
C/\  | | |-CALC_R_STAR    :: Calculate the new level thickness factor (r* coord)
C/\  | | |-CALC_SURF_DR   :: Calculate the new surface level thickness.
C/\  | | |
C/\  | | |-DO_STAGGER_FIELDS_EXCHANGES :: Update overlap regions of arrays
C/\  | | |                             uVel,vVel & wVel (stagger-time-step case)
C/\  | | |
C/\  | | |-DO_STATEVARS_DIAGS ( 1 ) :: fill-up state variable diagnostics
C/\  | | |
C/\  | | |-THERMODYNAMICS       :: theta, salt + tracer Eq. driver (see above).
C/\  | | |                         (staggered time-stepping case)
C/\  | | |
C/\  | | |-TRACERS_CORRECTION_STEP :: Finalise tracer stepping:
C/\  | | | |                       ::  apply filter, conv.adjustment
C/\  | | | |-TRACERS_IIGW_CORRECTION :: apply Implicit IGW adjustment to T & S
C/\  | | | |-SHAP_FILT_APPLY_TS        :: Apply Shapiro Filter to latest T & S
C/\  | | | |-ZONAL_FILT_APPLY_TS       :: Apply  Zonal  Filter to latest T & S
C/\  | | | |-PTRACERS_ZONAL_FILT_APPLY :: Apply  Zonal Filter to pTracers
C/\  | | | |-SALT_FILL                 :: Fill up negative Salt
C/\  | | | |-OPPS_INTERFACE            :: ( see pkg/opps )
C/\  | | | |-CONVECTIVE_ADJUSTMENT     :: Apply convective adjustment
C/\  | | | |-MATRIX_STORE_TENDENCY_IMP :: ( see pkg/matrix )
C/\  | | |
C/\  | | |-LONGSTEP_AVERAGE        :: Averaging state vars ( see pkg/longstep )
C/\  | | |-LONGSTEP_THERMODYNAMICS :: Step forward tracers ( see pkg/longstep )
C/\  | | |
C/\  | | |-GCHEM_FORCING_SEP :: Tracer forcing for gchem pkg (if tracer
C/\  | | |                   :: dependent tendencies calculated separately)
C/\  | | |
C/\  | | |-DO_FIELDS_BLOCKING_EXCHANGES :: Sync up overlap regions.
C/\  | | |
C/\  | | |-DO_STATEVARS_DIAGS ( 2 ) :: fill-up state variable diagnostics
C/\  | | |
C/\  | | |-GRIDALT_UPDATE    :: ( see pkg/gridalt )
C/\  | | |-STEP_FIZHI_CORR   :: ( see pkg/fizhi )
C/\  | | |
C/\  | | |-FLT_MAIN          :: Step forward Floats (see pkg/flt)
C/\  | | |
C/\  | | |-NEST_PARENT_IO_2  :: Nesting interface
C/\  | | |-NEST_CHILD_TRANSP :: Nesting interface
C/\  | | |
C/\  | | |-MONITOR          :: Monitor package (pkg/monitor).
C/\  | | |
C/\  | | |-COST_TILE        :: ( see pkg/cost )
C/\  | | |
C/\  | | |-DO_THE_MODEL_IO  :: Controlling routine for IO (see above)
C/\  | | |
C/\  | | |-PTRACERS_RESET   :: Re-initialize PTRACERS ( see pkg/ptracers )
C/\  | | |
C/\  | | |-DO_WRITE_PICKUP  :: Controlling routine for writing files to restart
C/\  | | | |-PACKAGES_WRITE_PICKUP :: Write pickup files for each package
C/\  | | | | |                     ::  which needs it to restart
C/\  | | | | |-GAD_WRITE_PICKUP       :: Write Generic AdvDiff pickups for SOM
C/\  | | | | |                        :: advection scheme (pkg/generic_advdiff)
C/\  | | | | |-CD_CODE_WRITE_PICKUP   :: Write CD-code pickups (see pkg/cd_code)
C/\  | | | | |-OBCS_WRITE_PICKUP      :: Write OBCS pickups    (see pkg/obcs)
C/\  | | | | |-GGL90_WRITE_PICKUP     :: Write GGL90 pickups   (see pkg/ggl90)
C/\  | | | | |-GMREDI_WRITE_PICKUP    :: Write GMREDI pickups  (see pkg/gmredi)
C/\  | | | | |-BBL_WRITE_PICKUP       :: Write BBL pickups     (see pkg/bbl)
C/\  | | | | |-CHEAPAML_WRITE_PICKUP  :: Write CheapAML pickups (pkg/cheapaml)
C/\  | | | | |-FLT_WRITE_PICKUP       :: Write Floats pickups  (see pkg/flt)
C/\  | | | | |-PTRACERS_WRITE_PICKUP  :: Write pTracers pickups (pkg/ptracers)
C/\  | | | | |-GCHEM_WRITE_PICKUP     :: Write Geo-Chem pickups (see pkg/gchem)
C/\  | | | | |-SEAICE_WRITE_PICKUP    :: Write SeaIce pickups  (see pkg/seaice)
C/\  | | | | |-STREAMICE_WRITE_PICKUP :: Write StreamIce pickups (pkg/streamice)
C/\  | | | | |-SHELFICE_WRITE_PICKUP  :: Write ShelfIce pickups (pkg/shelfice)
C/\  | | | | |-THSICE_WRITE_PICKUP    :: Write ThSIce pickups  (see pkg/thsice)
C/\  | | | | |-LAND_WRITE_PICKUP      :: Write Land   pickups  (see pkg/land)
C/\  | | | | |-ATM_PHYS_WRITE_PICKUP  :: Write Atm-Phys pickups (pkg/atm_phys)
C/\  | | | | |-FIZHI_WRITE_PICKUP     :: Write Fizhi pickups   (see pkg/fizhi)
C/\  | | | | |-FIZHI_WRITE_VEGTILES   :: Write Fizhi VegTiles  (see pkg/fizhi)
C/\  | | | | |-FIZHI_WRITE_DATETIME   :: Write Fizhi DateTime  (see pkg/fizhi)
C/\  | | | | |-CPL_WRITE_PICKUP       :: Write Coupling-Interface pickups
C/\  | | | | |-ECCO_WRITE_PICKUP      :: Write ECCO pickups    (see pkg/ecco)
C/\  | | | | |-MYPACKAGE_WRITE_PICKUP :: Write pkg/mypackage pickups
C/\  | | | |
C/\  | | | |-WRITE_PICKUP          :: Write main model pickup files.
C/\  | | |
C/\  | | |-AUTODIFF_INADMODE_SET   :: Set/reset some adjoint flags
C    | |
C<===|=| **************************
C<===|=| END MAIN TIMESTEPPING LOOP
C<===|=| **************************
C    | |
C    | |-COST_AVERAGESFIELDS :: Time-averaged Cost function terms (see pkg/cost)
C    | |-PROFILES_INLOOP     :: ( see pkg/profiles )
C    | |-COST_FINAL          :: Cost function package (see pkg/cost)
C    |
C    |-CTRL_PACK       :: Control vector support package (see pkg/ctrl)
C    |
C    |-GRDCHK_MAIN     :: Gradient check package (see pkg/grdchk)
C    |
C    |-TIMER_PRINTALL  :: Computational timing summary
C    |
C    |-COMM_STATS      :: Summarise inter-proc and inter-thread communication
C    |                 :: events.
C \ev
C
CEOI

#include "PACKAGES_CONFIG.h"
#include "CPP_OPTIONS.h"
#include "AD_CONFIG.h"
#ifdef ALLOW_AUTODIFF
# include "AUTODIFF_OPTIONS.h"
#endif
#ifdef ALLOW_CTRL
# include "CTRL_OPTIONS.h"
#endif

CBOP
C     !ROUTINE: THE_MODEL_MAIN

C     !INTERFACE:
      SUBROUTINE THE_MODEL_MAIN(myThid)

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE THE_MODEL_MAIN
C     | o Master controlling routine for model using the MITgcm
C     |   UV parallel wrapper.
C     *==========================================================*
C     | THE_MODEL_MAIN is invoked by the MITgcm UV parallel
C     | wrapper with a single integer argument "myThid". This
C     | variable identifies the thread number of an instance of
C     | THE_MODEL_MAIN. Each instance of THE_MODEL_MAIN works
C     | on a particular region of the models domain and
C     | synchronises with other instances as necessary. The
C     | routine has to "understand" the MITgcm parallel
C     | environment and the numerical algorithm. Editing this
C     | routine is best done with some knowledge of both aspects.
C     | Notes
C     | =====
C     | C*P* comments indicating place holders for which code is
C     |      presently being developed.
C     *==========================================================*
C     \ev

C     !CALLING SEQUENCE:
C     THE_MODEL_MAIN()
C       |
C       |
C       |--INITIALISE_FIXED
C       |   o Set model configuration (fixed arrays)
C       |     Topography, hydrography, timestep, grid, etc..
C       |
C       |--CTRL_UNPACK      o Derivative mode. Unpack control vector.
C       |
C       |--ADTHE_MAIN_LOOP  o Main timestepping loop for combined
C       |                     prognostic and reverse mode integration.
C       |
C       |--THE_MAIN_LOOP    o Main timestepping loop for pure prognostic
C       |                     integration.
C       |
C       |--CTRL_PACK        o Derivative mode. Unpack control vector.
C       |
C       |--GRDCHK_MAIN      o Gradient check control routine.
C       |
C       |--TIMER_PRINTALL   o Print out timing statistics.
C       |
C       |--COMM_STATS       o Print out communication statistics.

C     !USES:
      IMPLICIT NONE

C     == Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "DYNVARS.h"

#ifdef ALLOW_AUTODIFF_TAMC
# include "tamc.h"
#endif
#ifdef ALLOW_CTRL
# include "CTRL_SIZE.h"
# include "CTRL.h"
# include "OPTIMCYCLE.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     myThid :: Thread number for this instance of the routine.
      INTEGER myThid

C     !LOCAL VARIABLES:
C     == Local variables ==
C     Note: Under the multi-threaded model myIter and myTime are local
C           variables passed around as routine arguments.
C           Although this is fiddly it saves the need to impose
C           additional synchronisation points when they are updated.
C     myTime :: Time counter for this thread
C     myIter :: Iteration counter for this thread
      INTEGER myIter
      _RL     myTime
      LOGICAL costFinalExist
      LOGICAL lastdiva
CEOP

C--   set default:
      costFinalExist = .TRUE.
      lastdiva = .TRUE.

#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_ENTER('THE_MODEL_MAIN',myThid)
#endif

#if ( defined USE_PAPI || defined USE_PCL_FLOPS_SFP || defined USE_PCL_FLOPS || defined USE_PCL )
      CALL TIMER_CONTROL('','INIT','THE_MODEL_MAIN',myThid)
#endif
C--   This timer encompasses the whole code
      CALL TIMER_START('ALL                    [THE_MODEL_MAIN]',myThid)

#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_CALL('INITIALISE_FIXED',myThid)
#endif
C--   Set model configuration (fixed arrays)
      CALL TIMER_START('INITIALISE_FIXED       [THE_MODEL_MAIN]',myThid)
      CALL INITIALISE_FIXED( myThid )
      CALL TIMER_STOP ('INITIALISE_FIXED       [THE_MODEL_MAIN]',myThid)

      myTime = startTime
      myIter = nIter0

#ifdef ALLOW_ADMTLM

      STOP 'should never get here; ADMTLM_DSVD calls ADMTLM_DRIVER'

#elif ( defined ALLOW_AUTODIFF )

# ifdef ALLOW_CTRL
      IF ( useCTRL ) THEN
#  ifndef EXCLUDE_CTRL_PACK
        INQUIRE( FILE='costfinal', EXIST=costFinalExist )
        IF ( .NOT.costFinalExist ) THEN
          IF ( (optimcycle.NE.0 .OR. .NOT.doinitxx)
     &         .AND. doMainUnpack ) THEN
            CALL TIMER_START('CTRL_UNPACK   [THE_MODEL_MAIN]',myThid)
            CALL CTRL_UNPACK( .TRUE. , myThid )
            CALL TIMER_STOP ('CTRL_UNPACK   [THE_MODEL_MAIN]',myThid)
          ENDIF
        ENDIF
#  elif ( defined ALLOW_DIVIDED_ADJOINT )
        INQUIRE( FILE='costfinal', EXIST=costFinalExist )
#  endif /* EXCLUDE_CTRL_PACK & ALLOW_DIVIDED_ADJOINT */
      ENDIF
# endif /* ALLOW_CTRL */

# ifdef ALLOW_COST
      CALL COST_DEPENDENT_INIT ( myThid )
# endif

# if ( defined ALLOW_TANGENTLINEAR_RUN )

#  ifndef ALLOW_TAPENADE
#   ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_CALL('G_THE_MAIN_LOOP',myThid)
#   endif
      CALL TIMER_START('G_THE_MAIN_LOOP           [TANGENT RUN]',myThid)
      CALL G_THE_MAIN_LOOP ( myTime, myIter, myThid )
      CALL TIMER_STOP ('G_THE_MAIN_LOOP           [TANGENT RUN]',myThid)
#  endif /* ndef ALLOW_TAPENADE */

# elif ( defined ALLOW_ADJOINT_RUN )

#  ifdef ALLOW_TAPENADE
      CALL THE_MAIN_LOOP_B( myTime, myIter, myThid )
#  else /* ALLOW_TAPENADE */

#   ifdef ALLOW_DIVIDED_ADJOINT
C-- The following assumes the TAF option '-pure'
      IF ( .NOT.costFinalExist ) THEN
#    ifdef ALLOW_DEBUG
        IF (debugMode) CALL DEBUG_CALL('MDTHE_MAIN_LOOP',myThid)
#    endif
        CALL TIMER_START('MDTHE_MAIN_LOOP            [MD RUN]', myThid)
        CALL MDTHE_MAIN_LOOP ( myTime, myIter, myThid )
        CALL TIMER_STOP ('MDTHE_MAIN_LOOP            [MD RUN]', myThid)
        CALL COST_FINAL_STORE ( lastdiva, myThid )
      ELSE
C-- for DIVA, avoid forward-related output in adjoint part
        CALL TURNOFF_MODEL_IO( 1, myThid )
#    ifdef ALLOW_DEBUG
        IF (debugMode) CALL DEBUG_CALL('ADTHE_MAIN_LOOP',myThid)
#    endif
        CALL TIMER_START('ADTHE_MAIN_LOOP       [ADJOINT RUN]', myThid)
        CALL ADTHE_MAIN_LOOP (  myThid )
        CALL TIMER_STOP ('ADTHE_MAIN_LOOP       [ADJOINT RUN]', myThid)
        CALL COST_FINAL_RESTORE ( lastdiva, myThid )
      ENDIF

#   else /* ALLOW_DIVIDED_ADJOINT undef */
#    ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_CALL('ADTHE_MAIN_LOOP',myThid)
#    endif
      CALL TIMER_START('ADTHE_MAIN_LOOP          [ADJOINT RUN]', myThid)
      CALL ADTHE_MAIN_LOOP ( myThid )
      CALL TIMER_STOP ('ADTHE_MAIN_LOOP          [ADJOINT RUN]', myThid)
#   endif /* ALLOW_DIVIDED_ADJOINT */

#  endif /* ALLOW_TAPENADE */

# else /* forward run only within AD setting */

#  ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_CALL('THE_MAIN_LOOP',myThid)
#  endif
C--   Call time stepping loop of full model
      CALL TIMER_START('THE_MAIN_LOOP          [THE_MODEL_MAIN]',myThid)
      CALL THE_MAIN_LOOP( myTime, myIter, myThid )
      CALL TIMER_STOP ('THE_MAIN_LOOP          [THE_MODEL_MAIN]',myThid)

# endif /* forward run only within AD setting */

# ifdef ALLOW_CTRL
#  ifndef EXCLUDE_CTRL_PACK
      IF ( useCTRL .AND. lastdiva .AND. doMainPack ) THEN
        CALL TIMER_START('CTRL_PACK           [THE_MODEL_MAIN]',myThid)
        CALL CTRL_PACK( .FALSE. , myThid )
        CALL TIMER_STOP ('CTRL_PACK           [THE_MODEL_MAIN]',myThid)
        IF ( ( optimcycle.EQ.0 .OR. (.NOT. doMainUnpack) )
     &       .AND. myIter.EQ.nIter0 ) THEN
          CALL TIMER_START('CTRL_PACK     [THE_MODEL_MAIN]',myThid)
          CALL CTRL_PACK( .TRUE. , myThid )
          CALL TIMER_STOP ('CTRL_PACK     [THE_MODEL_MAIN]',myThid)
        ENDIF
      ENDIF
#  endif /* EXCLUDE_CTRL_PACK */
# endif /* ALLOW_CTRL */

# ifdef ALLOW_GRDCHK
      IF ( useGrdchk .AND. lastdiva ) THEN
        CALL TIMER_START('GRDCHK_MAIN         [THE_MODEL_MAIN]',myThid)
        CALL GRDCHK_MAIN( myThid )
        CALL TIMER_STOP ('GRDCHK_MAIN         [THE_MODEL_MAIN]',myThid)
      ENDIF
# endif

#else /* ALL AD-related undef */

# ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_CALL('THE_MAIN_LOOP',myThid)
# endif
C--   Call time stepping loop of full model
      CALL TIMER_START('THE_MAIN_LOOP          [THE_MODEL_MAIN]',myThid)
      CALL THE_MAIN_LOOP( myTime, myIter, myThid )
      CALL TIMER_STOP ('THE_MAIN_LOOP          [THE_MODEL_MAIN]',myThid)

#endif /* ALLOW_TANGENTLINEAR_RUN ALLOW_ADJOINT_RUN ALLOW_ADMTLM */

#ifdef ALLOW_STREAMICE
      IF ( useStreamIce ) THEN
        CALL STREAMICE_FINALIZE_PETSC
      ENDIF
#endif

#ifdef ALLOW_MNC
      IF ( useMNC ) THEN
C       Close all open NetCDF files
        _BEGIN_MASTER( myThid )
        CALL MNC_FILE_CLOSE_ALL( myThid )
        _END_MASTER( myThid )
      ENDIF
#endif

#ifdef ALLOW_PROFILES
      IF ( usePROFILES ) THEN
C       Close all open NetCDF files
        CALL PROFILES_NC_CLOSE( myThid )
      ENDIF
#endif /* ALLOW_PROFILES */

#ifdef ALLOW_OBSFIT
      IF ( useOBSFIT ) THEN
C       Close all open NetCDF files
        CALL OBSFIT_NC_CLOSE( myThid )
      ENDIF
#endif /* ALLOW_OBSFIT */

C--   This timer encompasses the whole code
      CALL TIMER_STOP ('ALL                    [THE_MODEL_MAIN]',myThid)

C--   Write timer statistics
      IF ( myThid .EQ. 1 ) THEN
        CALL TIMER_PRINTALL( myThid )
        CALL COMM_STATS
      ENDIF

C--   Check threads synchronization :
      CALL BAR_CHECK( 9, myThid )

#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_LEAVE('THE_MODEL_MAIN',myThid)
#endif

      RETURN
      END

#include "PP81_OPTIONS.h"

CBOP
C !ROUTINE: PP81_CALC

C !INTERFACE: =======================================================
      subroutine PP81_CALC(
     I                bi, bj, sigmaR, myTime, myIter, myThid )

C !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE PP81_CALC                                     |
C     | o Compute all PP81 fields defined in PP81.h              |
C     *==========================================================*
C     | This subroutine is based on SPEM code                    |
C     *==========================================================*

C global parameters updated by pp_calc
C     PPviscAz  :: PP eddy viscosity coefficient              (m^2/s)
C     PPdiffKzT :: PP diffusion coefficient for temperature   (m^2/s)
C
C \ev

C !USES: ============================================================
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#ifdef ALLOW_3D_DIFFKR
# include "DYNVARS.h"
#endif
#include "PP81.h"
c#ifdef ALLOW_AUTODIFF_TAMC
c#include "tamc.h"
c#endif /* ALLOW_AUTODIFF_TAMC */

C !INPUT PARAMETERS: ===================================================
C Routine arguments
C     bi, bj :: Current tile indices
C     sigmaR :: Vertical gradient of iso-neutral density
C     myTime :: Current time in simulation
C     myIter :: Current time-step number
C     myThid :: My Thread Id number
      INTEGER bi, bj
      _RL     sigmaR(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL     myTime
      INTEGER myIter
      INTEGER myThid

#ifdef ALLOW_PP81
C !LOCAL VARIABLES: ====================================================
c Local constants
C     imin, imax, jmin, jmax  - array computation indices
C     RiNumber                - Richardson Number
      INTEGER I, J, K
      INTEGER   iMin ,iMax ,jMin ,jMax
      _RL     denom, PPviscTmp
      _RL     RiNumber(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
CEOP
      iMin = 2-OLx
      iMax = sNx+OLx-1
      jMin = 2-OLy
      jMax = sNy+OLy-1

      DO K = 2, Nr
       CALL PP81_RI_NUMBER(
     I      bi, bj, K, iMin, iMax, jMin, jMax,
     O      RiNumber,
     I      myTime, myThid )
       DO J=jMin,jMax
        DO I=iMin,iMax
         IF ( RiNumber(I,J) .LT. RiLimit ) THEN
          denom = 1.0 + PPalpha*RiLimit
          PPviscTmp = PPviscMax
         ELSE
          denom = 1.0 + PPalpha*RiNumber(I,J)
          PPviscTmp = PPnu0/(denom**PPnRi)
         ENDIF
C     assign a minium ( = background ) value
         PPviscAr(I,J,K,bi,bj) = MAX(PPviscTmp,viscArNr(k))
         PPdiffKr(I,J,K,bi,bj) = MAX(PPviscAr(I,J,K,bi,bj)/denom,
#ifdef ALLOW_3D_DIFFKR
     &                               diffKr(i,j,k,bi,bj) )
#else
     &                               diffKrNrS(k) )
#endif
CML         if ( k.eq.2 .and. i.ge.1 .and. i.le.sNx .and. j.eq.1)
CML     &        print '(A,3I3,5E14.5)', 'ml-pp81', I,J,K, RiLimit,
CML     &        RiNumber(I,J),denom,
CML     &        PPviscAr(I,J,K,bi,bj), PPdiffKr(I,J,K,bi,bj)
        ENDDO
       ENDDO
#ifdef ALLOW_PP81_LOWERBOUND
CRT   This is where the lower limit for subsurface layers
CRT   (BRIOS special) is set.
       IF ( (usingZCoords .AND. K .EQ. 2) .OR.
     &      (usingPCoords .AND. K .EQ. Nr) ) THEN
        DO J=jMin,jMax
         DO I=iMin,iMax
          PPviscAr(I,J,K,bi,bj) = MAX(PPviscMin,PPviscAr(I,J,K,bi,bj))
          PPdiffKr(I,J,K,bi,bj) = MAX(PPdiffMin,PPdiffKr(I,J,K,bi,bj))
         ENDDO
        ENDDO
       ENDIF
#endif /* ALLOW_PP81_LOWERBOUND */
C     Mask land points
       DO J=jMin,jMax
        DO I=iMin,iMax
         PPviscAr(I,J,K,bi,bj) = PPviscAr(I,J,K,bi,bj)
     &        * maskC(I,J,K,bi,bj)
         PPdiffKr(I,J,K,bi,bj) = PPdiffKr(I,J,K,bi,bj)
     &        * maskC(I,J,K,bi,bj)
        ENDDO
       ENDDO
C     end K-loop
      ENDDO

#ifdef ALLOW_DIAGNOSTICS
      IF ( useDiagnostics ) THEN
       CALL DIAGNOSTICS_FILL(PPviscAr,'PPviscAr',0,Nr,1,bi,bj,myThid)
       CALL DIAGNOSTICS_FILL(PPdiffKr,'PPdiffKr',0,Nr,1,bi,bj,myThid)
      ENDIF
#endif /* ALLOW_DIAGNOSTICS */

#endif /* ALLOW_PP81 */

      RETURN
      END

#include "CAL_OPTIONS.h"

      SUBROUTINE CAL_TIME2DUMP(
     I                          phase, freq, step,
     U                          time2write,
     I                          myTime, myIter, myThid )

c     ==================================================================
C--   Convert approximate months (30-31 days) and years (360-372 days)
C     to exact calendar months and years.
c     ==================================================================

      IMPLICIT NONE

c     == global variables ==

#include "cal.h"

c     == routine arguments ==
      _RL     phase, freq, step
      LOGICAL time2write
      _RL     myTime
      INTEGER myIter
      INTEGER myThid

c     == local variables ==
      INTEGER thisDate(4), prevDate(4)
      _RL posFreq
      _RL shTime, prTime

      IF ( calendarDumps .AND. freq .NE. 0. ) THEN
C-     Same as in FCT DIFF_PHASE_MULTIPLE:
c      IF ( myTime+step .GE. phase+baseTime ) THEN
C-     should compare to phase+baseTime (above), but would need PARAMS.h ;
C      choose to disable this condition for negative time:
       IF ( myTime+step.GE.phase .OR. myTime.LT.0. ) THEN
        posFreq = ABS(freq)
C-    First determine calendar dates for this and previous time step.
        shTime = myTime - phase
        prTime = shTime - step
        CALL CAL_GETDATE( myIter, shTime, thisDate, myThid )
        CALL CAL_GETDATE( myIter, prTime, prevDate, myThid )
C-    Monthly Freq:
        IF ( posFreq.GE.2592000. .AND. posFreq.LE.2678400. ) THEN
           time2write = .FALSE.
           IF ( (thisdate(1)-prevdate(1)).GT.50 )   time2write=.TRUE.
        ENDIF
C-    Yearly  Freq:
        IF ( posFreq.GE.31104000. .AND. posFreq.LE.31968000. ) THEN
           time2write = .FALSE.
           IF ( (thisdate(1)-prevdate(1)).GT.5000 ) time2write=.TRUE.
        ENDIF
       ENDIF
      ENDIF

      RETURN
      END

#include "GAD_OPTIONS.h"

C--   File gad_advscheme.F: Keeping track of Advection schemes requirement
C--    Contents:
C--    o GAD_ADVSCHEME_INIT
C--    o GAD_ADVSCHEME_SET
C--    o GAD_ADVSCHEME_GET (Function)

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: GAD_ADVSCHEME_INIT

C     !INTERFACE:
      SUBROUTINE GAD_ADVSCHEME_INIT( myThid )

C     !DESCRIPTION:
C     *==========================================================*
C     | S/R GAD\_ADVSCHEME\_INIT
C     | o Initialise shared local variables
C     *==========================================================*

C     !USES:
      IMPLICIT NONE
C--   Global variables
#include "SIZE.h"
#include "GAD.h"

C--   Local variables shared by S/R within this file (gad_advscheme.F)
C     GAD_advScheme_OlMin :: overlap minimum size for this advection scheme
      INTEGER GAD_advScheme_OlMin(GAD_Scheme_MaxNum)
      COMMON /GAD_ADVSCHEME_LOCAL/ GAD_advScheme_OlMin

C     !INPUT PARAMETERS:
C     myThid    :: my Thread Id number
      INTEGER myThid

C     !LOCAL VARIABLES:
      INTEGER n
CEOP

      _BEGIN_MASTER(myThid)
       DO n=1,GAD_Scheme_MaxNum
         GAD_advScheme_OlMin(n) = -1
       ENDDO
      _END_MASTER(myThid)

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: GAD_ADVSCHEME_SET

C     !INTERFACE:
      SUBROUTINE GAD_ADVSCHEME_SET(
     I                         advScheme, OlMinSize,
     U                         errCode,
     I                         myThid )

C     !DESCRIPTION:
C     *==========================================================*
C     | S/R GAD\_ADVSCHEME\_SET
C     | o Store minimum length of OverLap (related to stencil)
C     |   that this advection needs.
C     *==========================================================*

C     !USES:
      IMPLICIT NONE
C--   Global variables
#include "SIZE.h"
#include "EEPARAMS.h"
#include "GAD.h"

C--   Local variables shared by S/R within this file (gad_advscheme.F)
C     GAD_advScheme_OlMin :: overlap minimum size for this advection scheme
      INTEGER GAD_advScheme_OlMin(GAD_Scheme_MaxNum)
      COMMON /GAD_ADVSCHEME_LOCAL/ GAD_advScheme_OlMin

C     !INPUT/OUTPUT PARAMETERS:
C     advScheme :: advection scheme number
C     OlMinSize :: overlap minimum size for this advection scheme
C     errCode   :: tracks occurence of errors ( > 0)
C     myThid    :: my Thread Id number
      INTEGER advScheme
      INTEGER OlMinSize
      INTEGER errCode
      INTEGER myThid

C     !LOCAL VARIABLES:
C     msgBuf  :: Informational/error message buffer
      CHARACTER*(MAX_LEN_MBUF) msgBuf
CEOP

      IF ( advScheme.GE.1 .AND. advScheme.LE.GAD_Scheme_MaxNum ) THEN
       _BEGIN_MASTER(myThid)
        GAD_advScheme_OlMin(advScheme) = OlMinSize
       _END_MASTER(myThid)
      ELSE
        WRITE(msgBuf,'(2A,I6,A)') 'GAD_ADVSCHEME_SET: ',
     &    'Advection-Scheme Number:', advScheme, ' not valid'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(2A,I4,A)') 'GAD_ADVSCHEME_SET: ',
     &    'should be > 0 and < GAD_Scheme_MaxNum =', GAD_Scheme_MaxNum
        CALL PRINT_ERROR( msgBuf, myThid )
        errCode = MAX( errCode, 1 )
      ENDIF

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: GAD_ADVSCHEME_GET

C     !INTERFACE:
      INTEGER FUNCTION GAD_ADVSCHEME_GET( advScheme )

C     !DESCRIPTION:
C     *==========================================================*
C     | INTEGER FUNCTION GAD\_ADVSCHEME\_GET
C     | o Return minimum length of OverLap (related to stencil)
C     |   that this advection needs.
C     *==========================================================*

C     !USES:
      IMPLICIT NONE
C--   Global variables
#include "SIZE.h"
#include "GAD.h"

C--   Local variables shared by S/R within this file (gad_advscheme.F)
C     GAD_advScheme_OlMin :: overlap minimum size for this advection scheme
      INTEGER GAD_advScheme_OlMin(GAD_Scheme_MaxNum)
      COMMON /GAD_ADVSCHEME_LOCAL/ GAD_advScheme_OlMin

C     !INPUT PARAMETERS:
C     advScheme  :: advection scheme number
      INTEGER advScheme

C     !LOCAL VARIABLES:
CEOP

      IF ( advScheme.GE.1 .AND. advScheme.LE.GAD_Scheme_MaxNum ) THEN
        GAD_ADVSCHEME_GET = GAD_advScheme_OlMin(advScheme)
      ELSE
        GAD_ADVSCHEME_GET = -2
      ENDIF

      RETURN
      END

#include "ctrparam.h"
#include "ATM2D_OPTIONS.h"

C     !INTERFACE:
      SUBROUTINE CALC_1DTO2D( myThid )
C     *==========================================================*
C     | - Takes 1D atmos data, regrid to 2D ocean grid. This     |
C     |   involves totalling runoff into bands and redistributing|
C     |   and using derivates dF/dT and dH/dT to compute         |
C     |   local variations in evap and heat flux.                |
C     *==========================================================*
        IMPLICIT NONE

#include "ATMSIZE.h"
#include "SIZE.h"
#include "GRID.h"
#include "EEPARAMS.h"

C     === Global SeaIce Variables ===
#include "THSICE_VARS.h"

C     === Atmos/Ocean/Seaice Interface Variables ===
#include "ATM2D_VARS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
C     myThid - Thread no. that called this routine.
      INTEGER myThid

C     LOCAL VARIABLES:
      INTEGER i,j           ! loop counters across ocean grid
      INTEGER ib,ibj1,ibj2  ! runoff band variables
      _RL run_b(sNy)        ! total runoff in a band
      _RL fv_toC            ! meridional wind stress for ocean C-grid pt

      CALL INIT_2DFLD(myThid)

C     Accumulate runoff into bands (runoff bands are on the ocean grid)
      DO ib=1,numBands
        ibj1=1
        IF (ib.GT.1) ibj1= rband(ib-1)+1
        ibj2=sNy
        IF (ib.LT.numBands) ibj2= rband(ib)
        run_b(ib)=0. _d 0
        DO j=ibj1,ibj2
          run_b(ib)=run_b(ib) +
     &              atm_runoff(atm_oc_ind(j))*atm_oc_frac1(j) +
     &              atm_runoff(atm_oc_ind(j)+1)*atm_oc_frac2(j)
        ENDDO
      ENDDO

      DO j=1,sNy

C       do a linear interpolation from atmos data to get tauv
        fv_toC = atm_tauv(tauv_jpt(j)) * tauv_jwght(j) + 
     &        atm_tauv(tauv_jpt(j)+1) * (1. _d 0 - tauv_jwght(j))
    
        DO i=1,sNx

          IF (maskC(i,j,1,1,1).EQ.1.) THEN

            runoff_2D(i,j) = run_b(runIndex(j)) *
     &                       runoffVal(i,j)/rA(i,j,1,1)

            CALL CALC_WGHT2D(i,j,atm_oc_ind(j),atm_oc_wgt(j))

            IF (atm_oc_wgt(j).LT.1. _d 0)
     &          CALL CALC_WGHT2D(i, j, atm_oc_ind(j)+1,
     &                           1. _d 0-atm_oc_wgt(j))

            fv_2D(i,j) = fv_toC

C  Tabulate following diagnostic fluxes from atmos model only
            qnet_atm(i,j)= qnet_atm(i,j) +
     &          qneti_2D(i,j)*dtatmo*iceMask(i,j,1,1) +
     &          qneto_2D(i,j)*dtatmo*(1. _d 0-iceMask(i,j,1,1))
            evap_atm(i,j)= evap_atm(i,j) +
     &          evapi_2D(i,j)*dtatmo*iceMask(i,j,1,1) +
     &          evapo_2D(i,j)*dtatmo*(1. _d 0-iceMask(i,j,1,1))
            precip_atm(i,j)= precip_atm(i,j) +
     &           precipi_2D(i,j)*dtatmo*iceMask(i,j,1,1) +
     &           precipo_2D(i,j)*dtatmo*(1. _d 0-iceMask(i,j,1,1))
            runoff_atm(i,j)= runoff_atm(i,j) +
     &           runoff_2D(i,j)*dtatmo
         ENDIF

        ENDDO
      ENDDO

      RETURN
      END


C--------------------------------------------------------------------------

#include "ctrparam.h"
#include "ATM2D_OPTIONS.h"

C     !INTERFACE:
      SUBROUTINE CALC_WGHT2D( i, j, ind, wgt)
C     *==========================================================*
C     | Use atmos grid cell 1D value and weight to convert to 2D.|
C     | Variations from zonal mean computed used derivative dH/dT|
C     | and dF/dT  for heat flux and evap terms.                 |
C     |                                                          |
C     | Fluxes/values over seaice computed only if seaice present|
C     *==========================================================*
        IMPLICIT NONE

#include "ATMSIZE.h"
#include "SIZE.h"
#include "EEPARAMS.h"

C     === Global SeaIce Variables ===
#include "THSICE_VARS.h"

C     === Atmos/Ocean/Seaice Interface Variables ===
#include "ATM2D_VARS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
C     i,j   - coordinates of point on ocean grid
C     ind   - index into the atmos grid array
C     wght  - weight of this atmos cell for total
      INTEGER    i, j
      INTEGER    ind
      _RL        wgt

      precipo_2D(i,j)= precipo_2D(i,j) + atm_precip(ind)*wgt
      solarnet_ocn_2D(i,j)=solarnet_ocn_2D(i,j) + atm_solar_ocn(ind)*wgt
      slp_2D(i,j)= slp_2D(i,j) + atm_slp(ind)*wgt
      pCO2_2D(i,j)= pCO2_2D(i,j) + atm_pco2(ind)*wgt
      wspeed_2D(i,j)= wspeed_2D(i,j) + atm_windspeed(ind)*wgt
      fu_2D(i,j)= fu_2D(i,j) + atm_tauu(ind)*wgt

      qneto_2D(i,j)= qneto_2D(i,j) + atm_qnet_ocn(ind)*wgt
      evapo_2D(i,j)= evapo_2D(i,j) + atm_evap_ocn(ind)*wgt
      IF (evapo_2D(i,j).GT.0. _d 0) THEN  !convert negative evap. to precip
        precipo_2D(i,j)= precipo_2D(i,j) - evapo_2D(i,j)
        evapo_2D(i,j)=0. _d 0
      ENDIF

      IF (iceMask(i,j,1,1) .GT. 0. _d 0) THEN
        qneti_2D(i,j)= qneti_2D(i,j) + atm_qnet_ice(ind)*wgt
        precipi_2D(i,j)= precipi_2D(i,j) + atm_precip(ind)*wgt
        evapi_2D(i,j)= evapi_2D(i,j) + atm_evap_ice(ind)*wgt
        IF (evapi_2D(i,j).GT.0. _d 0) THEN  !convert negative evap. to precip
          precipi_2D(i,j)= precipi_2D(i,j) - evapi_2D(i,j)
          evapi_2D(i,j)=0. _d 0
        ENDIF
        dFdT_ice_2D(i,j)= dFdT_ice_2D(i,j) + atm_dFdT_ice(ind)*wgt
        Tair_2D(i,j)= Tair_2D(i,j) + atm_Tair(ind)*wgt
        solarinc_2D(i,j)= solarinc_2D(i,j) + atm_solarinc(ind)*wgt
      ENDIF

      IF (useAltDeriv) THEN
        qneto_2D(i,j)= qneto_2D(i,j) + atm_dFdt_ocnq(ind)*
     &             (sstFromOcn(i,j)-ctocn(ind))*wgt
        evapo_2D(i,j)= evapo_2D(i,j) + atm_dLdt_ocnq(ind)*
     &             (sstFromOcn(i,j)-ctocn(ind))*wgt
        IF (iceMask(i,j,1,1) .GT. 0. _d 0) THEN
          qneti_2D(i,j)=qneti_2D(i,j)+atm_dFdt_iceq(ind)*
     &             (Tsrf(i,j,1,1)-ctice(ind))*wgt
          evapi_2D(i,j)=evapi_2D(i,j)+atm_dLdt_iceq(ind)*
     &             (Tsrf(i,j,1,1)-ctice(ind))*wgt
        ENDIF
      ELSE
        qneto_2D(i,j)= qneto_2D(i,j) + atm_dFdt_ocn(ind)*
     &             (sstFromOcn(i,j)-ctocn(ind))*wgt
        evapo_2D(i,j)= evapo_2D(i,j) + atm_dLdt_ocn(ind)*
     &             (sstFromOcn(i,j)-ctocn(ind))*wgt
        IF (iceMask(i,j,1,1) .GT. 0. _d 0) THEN
          qneti_2D(i,j)= qneti_2D(i,j) + atm_dFdt_ice(ind)*
     &             (Tsrf(i,j,1,1)-ctice(ind))*wgt
          evapi_2D(i,j)= evapi_2D(i,j)+atm_dLdt_ice(ind)*
     &             (Tsrf(i,j,1,1)-ctice(ind))*wgt
        ENDIF
      ENDIF


      RETURN
      END

C--------------------------------------------------------------------------

#include "ctrparam.h"
#include "ATM2D_OPTIONS.h"

C     !INTERFACE:
      SUBROUTINE INIT_2DFLD( myThid)
C     *==========================================================*
C     | Zero out the 2D fields; called prior to doing any of the |
C     | 1D->2D calculation.                                      |
C     *==========================================================*
        IMPLICIT NONE

#include "ATMSIZE.h"
#include "SIZE.h"
#include "EEPARAMS.h"
#include "ATM2D_VARS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
C     myThid - Thread no. that called this routine.
      INTEGER myThid

C     LOCAL VARIABLES:
      INTEGER i,j

      DO i=1,sNx
        DO j=1,sNy

          precipo_2D(i,j)= 0. _d 0
          precipi_2D(i,j)= 0. _d 0
          solarnet_ocn_2D(i,j)= 0. _d 0
          slp_2D(i,j)= 0. _d 0
          pCO2_2D(i,j)= 0. _d 0
          wspeed_2D(i,j)= 0. _d 0
          fu_2D(i,j)= 0. _d 0
          fv_2D(i,j)= 0. _d 0
          qneto_2D(i,j)= 0. _d 0
          evapo_2D(i,j)= 0. _d 0
          qneti_2D(i,j)= 0. _d 0
          evapi_2D(i,j)= 0. _d 0
          dFdT_ice_2D(i,j)= 0. _d 0
          Tair_2D(i,j)= 0. _d 0
          solarinc_2D(i,j)= 0. _d 0
          runoff_2D(i,j)= 0. _d 0

        ENDDO
      ENDDO

      RETURN
      END

!=======================================================================
      subroutine compsend_i4vec( dataname, length, vecFld )
      implicit none
! Predefined constants/arrays
#include "CPLR_SIG.h"
! MPI variables
#include "mpif.h"
! Arguments
      character*(*) dataname
      integer length
      integer vecFld(length)
! Functions
      integer generate_tag
      external generate_tag
! Local
      integer count,datatype,dest,tag,comm,ierr
      integer i
      integer ibuf(MAX_IBUF)
!     ------------------------------------------------------------------

      if ( 1+length .gt. MAX_IBUF )
     &    STOP 'compsend_i4vec: length exceeds MAX_IBUF'

! Copy vector to buffer
      ibuf(1) = length
      do i=1,length
        ibuf(i+1) = vecFld(i)
      enddo

! Send message
      count = 1+length
      datatype = MPI_INTEGER
      dest = my_coupler_rank
      tag = generate_tag( 115, my_rank_in_global, dataname )
      comm = MPI_COMM_myglobal

      if (VERB) then
        write(LogUnit,*)
     &   'compsend_i4vec: calling MPI_Send dest=',dest
        write(LogUnit,*) 'compsend_i4vec: dataname=',dataname
        call flush(LogUnit)
      endif
      call MPI_Send( ibuf, count, datatype, dest, tag, comm, ierr )
      if (VERB) then
        write(LogUnit,*) 'compsend_i4vec: returned ierr=',ierr
        call flush(LogUnit)
      endif

      if (ierr.ne.0) then
        write(LogUnit,*) 'compsend_i4vec: rank(W,G,L)=',
     &            my_rank_in_world,my_rank_in_global,my_rank_in_local,
     &            ' ierr=',ierr
        STOP 'compsend_i4vec: MPI_Send failed'
      endif

!     ------------------------------------------------------------------
      return
      end
!=======================================================================

#include "MONITOR_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: MON_PRINTSTATS_RS

C     !INTERFACE:
      SUBROUTINE MON_PRINTSTATS_RS(
     I     myNr, arr, arrName,
     I     myThid )

C     !DESCRIPTION:
C     Prints to STDOUT the bare statistics of global array "\_RS arr"
C     with label "arrName".

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "MONITOR.h"

C     !INPUT PARAMETERS:
      INTEGER myNr
      _RS arr(1-OLx:sNx+OLx,1-OLy:sNy+OLy,myNr,nSx,nSy)
      CHARACTER*(*) arrName
      INTEGER myThid
CEOP

C     !LOCAL VARIABLES:
      _RL theMin
      _RL theMax
      _RL theMean
      _RL theSD

      CALL MON_STATS_RS(
     I     myNr, arr,
     O     theMin,theMax,theMean,theSD,
     I     myThid )

      CALL MON_OUT_RL( arrName, theMax,  mon_foot_max  ,myThid)
      CALL MON_OUT_RL( arrName, theMin,  mon_foot_min  ,myThid)
      CALL MON_OUT_RL( arrName, theMean, mon_foot_mean ,myThid)
      CALL MON_OUT_RL( arrName, theSD,   mon_foot_sd   ,myThid)

      RETURN
      END

#include "CPP_OPTIONS.h"

CBOP
C !ROUTINE: CONVECTIVELY_MIXTRACER
C !INTERFACE:
      SUBROUTINE CONVECTIVELY_MIXTRACER(
     I                              bi, bj, k, weightA, weightB,
     U                              Tracer,
     I                              myThid )
C !DESCRIPTION:
C Mixes a tracer over two layers according to the weights pre-calculated
C as a function of stability.
C
C Mixing is represented by:
C                       T(k-1) = T(k-1) + A * ( T(k) - T(k-1) )
C                       T(k)   = T(k)   + B * ( T(k-1) - T(k) )

C !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"

C !INPUT/OUTPUT PARAMETERS:
C     bi,bj,k :: indices
C     weightA :: weight for level k-1
C     weightB :: weight for level  k
C     myThid  :: my Thread Id number
      INTEGER bi,bj,k
      _RL weightA(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL weightB(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL Tracer (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      INTEGER myThid

#if (defined INCLUDE_CONVECT_CALL || defined INCLUDE_CONVECT_INI_CALL)

C !LOCAL VARIABLES:
C     i,j      :: Loop counter
C     delTrac  :: Difference between tracer in each layer
      INTEGER i,j
      _RL delTrac
CEOP

      DO j=1-OLy,sNy+OLy
       DO i=1-OLx,sNx+OLx

        delTrac=Tracer(i,j,k,bi,bj)-Tracer(i,j,k-1,bi,bj)
        Tracer(i,j,k-1,bi,bj)=Tracer(i,j,k-1,bi,bj)
     &                       +weightA(i,j)*delTrac
        Tracer(i,j,k,bi,bj)=Tracer(i,j,k,bi,bj)
     &                       -weightB(i,j)*delTrac

       ENDDO
      ENDDO

#endif /* INCLUDE_CONVECT_CALL or INCLUDE_CONVECT_INI_CALL */

      RETURN
      END

#include "OFFLINE_OPTIONS.h"

C !INTERFACE: ==========================================================
      SUBROUTINE OFFLINE_RESET_PARMS( myThid )

C !DESCRIPTION:
C reset some of the main-code parameters for offline calculation

C !USES: ===============================================================
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "OFFLINE.h"

C !INPUT PARAMETERS: ===================================================
C  myThid         :: my Thread Id. number
      INTEGER myThid
CEOP

C     !FUNCTIONS:
c     INTEGER  ILNBLNK
c     EXTERNAL ILNBLNK

C     !LOCAL VARIABLES:
C     msgBuf      :: Informational/error message buffer
      CHARACTER*(MAX_LEN_MBUF) msgBuf

      _BEGIN_MASTER(myThid)

C-    For off-line calculation, switch off Momentum and Active-tracers (=T,S):
      WRITE(msgBuf,'(A,A)') ' OFFLINE_RESET_PARMS: ',
     &    '=> turn off Temp,Salt & Mom_Stepping flags'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      tempStepping = .FALSE.
      saltStepping = .FALSE.
      momStepping  = .FALSE.

C-    Switch off dynstat monitor (but keep one @ the end)
c     IF ( monitorFreq.GT.0. ) THEN
c       monitorFreq = endTime
c         WRITE(msgBuf,'(A,A,1PE18.10)') ' OFFLINE_RESET_PARMS: ',
c    &    '=> reset monitorFreq to:', monitorFreq
c         CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
c    &                        SQUEEZE_RIGHT, myThid )
c     ENDIF

      IF ( Wvelfile .EQ. ' '  ) THEN
C--   Make sure we compute vertical velocity since it is not read from a file
        IF ( .NOT.exactConserv ) THEN
          WRITE(msgBuf,'(A,A)') '** WARNING ** OFFLINE_RESET_PARMS: ',
     &    '=> turn on exactConserv to compute wVel'
          CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                        SQUEEZE_RIGHT, myThid )
          CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                        SQUEEZE_RIGHT, myThid )
          exactConserv = .TRUE.
        ENDIF
      ELSE
C--   Vertical velocity is read from a file: make sure it is not re-computed
        IF ( exactConserv ) THEN
          WRITE(msgBuf,'(A,A)') '** WARNING ** OFFLINE_RESET_PARMS: ',
     &    '=> turn off exactConserv to skip wVel calc'
          CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                        SQUEEZE_RIGHT, myThid )
          CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                        SQUEEZE_RIGHT, myThid )
          exactConserv = .FALSE.
        ENDIF
      ENDIF

      _END_MASTER(myThid)

      RETURN
      END

#include "CPP_OPTIONS.h"

      subroutine exch_allgather_2d_rl(
     I       arr
     O     , full
     I     , myThid
     &     )

c     ==================================================================
c     SUBROUTINE exch_allgather_2d_rl
c     ==================================================================
c
c     o exchange local domains of a distributed 2d field
c       so that every processor has the whole field
c
c     started: Ralf Giering Ralf.Giering@FastOpt.de 12-Jun-2001
c
c     ==================================================================
c     SUBROUTINE exch_allgather_2d_rl
c     ==================================================================
      implicit none

c     == global variables ==

#include "EEPARAMS.h"
#include "SIZE.h"
#include "EESUPPORT.h"
#include "EXCH.h"

c     == routine arguments ==

      _RL arr ( 1-OLx:sNx+OLx, 1-OLy:sNy+OLy, nSx, nSy )
      _RL full( 1-OLx:sNx+OLx, 1-OLy:sNy+OLy, nSx, nSy, nPx, nPy )
      integer myThid

c     == local variables ==
#ifdef ALLOW_USE_MPI
      integer mpirc
      integer mpicrd(2)
      integer ipx, ipy

      _RL recvbuf( 1-OLx:sNx+OLx, 1-OLy:sNy+OLy, nSx, nSy, nPx*nPy )

      integer    sendsize
      parameter( sendsize = sNx*sNy*nSx*nSy )
      integer    recvsize
      parameter( recvsize = sNx*sNy*nSx*nSy )

      integer iproc
      integer bi, bj
      integer i, j
#endif

C--   Can not start until everyone is ready
      _BARRIER

c--   Only the master thread is doing communication
      _BEGIN_MASTER( myThid )

#ifdef ALLOW_USE_MPI
      IF ( usingMPI ) THEN

      call MPI_Allgather(  arr    , sendsize, MPI_DOUBLE_PRECISION
     &                   , recvbuf, recvsize, MPI_DOUBLE_PRECISION
     &                   , MPI_COMM_MODEL, mpiRC
     &                   )

c--   arrange array according to cartesian coordinates of processors
      do iproc = 1, numberOfProcs

c--     get coordinates of processor (iporc-1)
        call MPI_Cart_coords(
     I          MPI_COMM_MODEL, iproc-1, 2, mpicrd
     O        , mpirc
     &        )

        ipx = 1 + mpicrd(1)
        ipy = 1 + mpicrd(2)

        do bj = 1, nSy
          do bi = 1, nSx
            do j = 1, sNy
              do i = 1, sNx
                full(i,j,bi,bj,ipx,ipy) = recvbuf(i,j,bi,bj,iproc)
              enddo
            enddo
          enddo
        enddo

      enddo

      ENDIF
#endif /* ALLOW_USE_MPI */

c--   end of master thread only computations
      _END_MASTER( myThid )

      _BARRIER

      RETURN
      END

#include "CPP_OPTIONS.h"
#include "LAYERS_OPTIONS.h"

CBOP
C     !ROUTINE: LAYERS_WSURF_TR
C     !INTERFACE:
      SUBROUTINE LAYERS_WSURF_TR(thetaFld, saltFld, wVelFld,
     I                         myTime, myIter, myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE LAYERS_WSURF_TR
C     |     (copied from CALC_WSURF_TR)
C     | o Compute a correction for the source/sink of tracer
C     |   due to the linear free surface.
C     | o Add this correction to the layers surface flux
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     == Global variables
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "SURFACE.h"
#include "LAYERS_SIZE.h"
#include "LAYERS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     myTime   :: Current time in simulation
C     myIter   :: Current iteration number in simulation
C     myThid   :: Thread number for this instance of the routine.
C     thetaFld :: Potential Temperature field
C     saltFld  :: Salinity field
C     wvelFld  :: vertical velocity field
      _RL myTime
      INTEGER myIter
      INTEGER myThid
      _RL thetaFld(1-Olx:sNx+Olx,1-Oly:sNy+Oly,Nr,nSx,nSy)
      _RL saltFld (1-Olx:sNx+Olx,1-Oly:sNy+Oly,Nr,nSx,nSy)
      _RL wVelFld (1-Olx:sNx+Olx,1-Oly:sNy+Oly,Nr,nSx,nSy)

#ifdef LAYERS_THERMODYNAMICS

C     !LOCAL VARIABLES:
C     Local variables
C     i,j,k,bi,bj  :: loop counter
C     tCor, sCor   :: corrections for theta and salt
      INTEGER i,j,bi,bj,ks
      _RL tcor, scor
CEOP

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      DO bj=myByLo(myThid), myByHi(myThid)
       DO bi=myBxLo(myThid), myBxHi(myThid)
         DO j=1,sNy
          DO i=1,sNx
             ks = ksurfC(i,j,bi,bj)
             IF (ks.LE.Nr) THEN
c --           Temperature
               tcor = -wVelFld(i,j,ks,bi,bj) * thetaFld(i,j,ks,bi,bj)
               scor = -wVelFld(i,j,ks,bi,bj) * saltFld(i,j,ks,bi,bj)
               IF (linFSConserveTr) THEN
                 tcor = tcor + TsurfCor
                 scor = scor + SsurfCor
               ENDIF
c --           Temperature needs to be in the units of TFLUX)
               layers_surfflux(i,j,1,1,bi,bj) =
     &           layers_surfflux(i,j,1,1,bi,bj) +
     &           tcor * HeatCapacity_Cp * rUnit2mass
c --           Salinity needs to be in the units of SFLUX)
               layers_surfflux(i,j,1,2,bi,bj) =
     &           layers_surfflux(i,j,1,2,bi,bj) +
     &           scor * rUnit2mass
             ENDIF
          ENDDO
         ENDDO
C-     end bi,bj loop.
       ENDDO
      ENDDO

#endif /* LAYERS_THERMODYNAMICS */

      RETURN
      END

#include "MY82_OPTIONS.h"

      SUBROUTINE MY82_CALC_VISC(
     I        bi,bj,iMin,iMax,jMin,jMax,K,
     U        KappaRU,KappaRV,
     I        myThid)

CBOP
C     *==========================================================*
C     | SUBROUTINE MY82_CALC_VISC
C     | o Add contrubution to net viscosity from MY82 mixing
C     *==========================================================*
      IMPLICIT NONE

C     == GLobal variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "MY82.h"

C     == Routine arguments ==
C     bi, bj, iMin, iMax, jMin, jMax - Range of points for which calculation
C     myThid - Instance number for this innvocation of CALC_COMMON_FACTORS
C
      INTEGER bi,bj,iMin,iMax,jMin,jMax,K
      _RL KappaRU(1-Olx:sNx+Olx,1-Oly:sNy+Oly,Nr)
      _RL KappaRV(1-Olx:sNx+Olx,1-Oly:sNy+Oly,Nr)
      INTEGER myThid

#ifdef ALLOW_MY82

C     == Local variables ==
C     I, J, K - Loop counters
      INTEGER i,j
CEOP
      DO j=jMin,jMax
       DO i=iMin,iMax
        KappaRU(i,j,k) = max ( KappaRU(i,j,k),
     &         KappaRU(i,j,k) - viscArNr(k) + _maskW(i,j,k,bi,bj) *
     &    0.5 _d 0*(MYviscAr(i,j,k,bi,bj)+MYviscAr(i-1,j,k,bi,bj)) )
       ENDDO
      ENDDO

      DO j=jMin,jMax
       DO i=iMin,iMax
        KappaRV(i,j,k) = max ( KappaRV(i,j,k),
     &         KappaRV(i,j,k) - viscArNr(k) + _maskS(i,j,k,bi,bj) *
     &    0.5 _d 0*(MYviscAr(i,j,k,bi,bj)+MYviscAr(i,j-1,k,bi,bj)) )
       ENDDO
      ENDDO

#endif /* ALLOW_MY82 */

      RETURN
      END

#include "ECCO_OPTIONS.h"

      subroutine cost_gencost_sshv4(
     I                        myThid )

c     ==================================================================
c     SUBROUTINE cost_gencost_sshv4
c     ==================================================================
c
c     o Evaluate cost function contributions of sea surface height.
c
c        started: Gael Forget, Oct-2009
c
c        working assumption for the time mean dynamic topography (MDT)
c        constraint: the various SLA data sets (tp, ers, gfo) have been
c        consistenty cross-referenced, as done in the RADS data sets. We
c        do not need to know the reference dynamic topography (or
c        SSH/Geoid). Simply it is assumed that the biases between
c        instruments have been taken care of. This is only a matter for
c        the MDT constraint, not for SLA constraints (see below).
c
cgf 1) there are a few hardcoded numbers that will eventually be put in common
cgf     blocks/namelists
cgf 2) there are a several refinements that should be considered, such as
cgf     modulating weights with respect to numbers of samples
c
c     ==================================================================
c     SUBROUTINE cost_gencost_sshv4
c     ==================================================================

      implicit none

c     == global variables ==

#include "EEPARAMS.h"
#include "SIZE.h"
#include "PARAMS.h"
#include "GRID.h"
#ifdef ALLOW_CAL
# include "cal.h"
#endif
#ifdef ALLOW_ECCO
# include "ECCO_SIZE.h"
# include "ECCO.h"
#endif
#ifdef ALLOW_SMOOTH
# include "SMOOTH.h"
#endif

c     == routine arguments ==
      integer myThid

#ifdef ALLOW_GENCOST_CONTRIBUTION

c     == functions ==
      LOGICAL  MASTER_CPU_THREAD
      EXTERNAL MASTER_CPU_THREAD
      INTEGER  ILNBLNK
      EXTERNAL ILNBLNK

c     == local variables ==

      integer bi,bj
      integer i,j,k
      integer itlo,ithi
      integer jtlo,jthi
      integer jmin,jmax
      integer imin,imax
      integer irec,jrec,krec
      integer ilps
      integer nrec_year, nrec_total, nrec_mdt_ref
c introduce use_mon to switch from using daily to monthly data if true
      logical use_mon

      logical doglobalread
      logical ladinit

c mapping to gencost
      integer igen_mdt, igen_lsc, igen_gmsl
      integer igen_tp, igen_ers, igen_gfo
      integer igen_etagcm

      _RL spval, factor
      _RL offset
      _RL offset_sum
      _RL slaoffset
      _RL slaoffset_sum
      _RL slaoffset_weight

c local arrays
      _RL num0array ( 1-OLx:sNx+OLx, 1-OLy:sNy+OLy, nSx, nSy )
      _RL num0total
      integer tempinteger

      _RL diagnosfld ( 1-OLx:sNx+OLx, 1-OLy:sNy+OLy, nSx, nSy )

      _RL mdtob(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL tpob(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL ersob(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL gfoob(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL mdtma(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL tpma(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL ersma(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL gfoma(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL etagcm(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)

      character*(MAX_LEN_FNAM) mdtfi, tpfi, ersfi, gfofi
      integer tpsta(4), erssta(4), gfosta(4)
      integer mdtsta(4), mdtend(4)
      _RL tpper, ersper, gfoper

c for PART 1: re-reference MDT (mdt) to the inferred SLA reference field
      _RL psmean    ( 1-OLx:sNx+OLx, 1-OLy:sNy+OLy, nSx, nSy )
      _RL mean_slaobs_mdt(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL mean_slaobs_NUM(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)

c for PART 2: compute time mean differences over the model period
      _RL mean_slaobs_model(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL mean_psMssh_all(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL mean_psMssh_all_NUM(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL mean_psMssh_all_MSK(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)

      _RL mean_psMslaobs(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL mean_psMslaobs_MSK(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)

      _RL mean_psMtpobs(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL mean_psMtpobs_NUM(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)

      _RL mean_psMersobs(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL mean_psMersobs_NUM(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)

      _RL mean_psMgfoobs(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL mean_psMgfoobs_NUM(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)

c for PART 4/5: compute smooth/raw anomalies
      _RL anom_psMslaobs(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL anom_psMslaobs_NUM (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL anom_psMslaobs_MSK (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL anom_psMslaobs_SUB (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL anom_slaobs (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL anom_slaobs_SUB  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)

      _RL anom_psMtpobs(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL anom_tpobs(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)

      _RL anom_psMersobs(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL anom_ersobs(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)

      _RL anom_psMgfoobs(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL anom_gfoobs(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)

      integer mdt_y0,mdt_y1,year
      integer num0

      _RL junk,junkweight

      integer nrecsave

      integer k2, k2_mdt, k2_lsc
      logical dosumsq

      character*(MAX_LEN_FNAM) fname
      character*(MAX_LEN_FNAM) fname4test
      character*(MAX_LEN_MBUF) msgbuf

      LOGICAL doReference
      LOGICAL useEtaMean

c     == end of interface ==

C-    Initialise (again) gencost_weight
      DO k = 1, NGENCOST
       DO bj = myByLo(myThid), myByHi(myThid)
        DO bi = myBxLo(myThid), myBxHi(myThid)
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           gencost_weight(i,j,bi,bj,k) = 0. _d 0
          ENDDO
         ENDDO
        ENDDO
       ENDDO
      ENDDO

      jtlo = myByLo(myThid)
      jthi = myByHi(myThid)
      itlo = myBxLo(myThid)
      ithi = myBxHi(myThid)
      jmin = 1
      jmax = sNy
      imin = 1
      imax = sNx

c-- detect the relevant gencost indices
      igen_mdt=0
      igen_tp =0
      igen_ers=0
      igen_gfo=0
      igen_lsc=0
      igen_gmsl=0
      igen_etagcm=0
      do k=1,NGENCOST
        if (gencost_name(k).EQ.'sshv4-mdt') igen_mdt=k
        if (gencost_name(k).EQ.'sshv4-tp') igen_tp=k
        if (gencost_name(k).EQ.'sshv4-ers') igen_ers=k
        if (gencost_name(k).EQ.'sshv4-gfo') igen_gfo=k
        if (gencost_name(k).EQ.'sshv4-lsc') igen_lsc=k
        if (gencost_name(k).EQ.'sshv4-gmsl') igen_gmsl=k
      enddo

      k2_mdt=0
      k2_lsc=0
      if (igen_mdt.GT.0) then
       do k2 = 1, NGENPPROC
        if (gencost_posproc(k2,igen_mdt).EQ.'smooth') k2_mdt=k2
       enddo
      endif
      if (igen_lsc.GT.0) then
       do k2 = 1, NGENPPROC
        if (gencost_posproc(k2,igen_lsc).EQ.'smooth') k2_lsc=k2
       enddo
      endif
      write(msgbuf,'(a,2(1x,i5))')
     &  'sshv4: k2_[mdt,lsc]: ', k2_mdt, k2_lsc
      call print_message( msgbuf, standardmessageunit,
     &                    SQUEEZE_RIGHT , myThid)

      dosumsq = .TRUE.
      if (igen_mdt.GT.0) then
       call ecco_zero( gencost_weight(1-OLx,1-OLy,1,1,igen_mdt),
     &                 1, zeroRL, myThid )
       if ( gencost_errfile(igen_mdt) .NE. ' ' )
     &   call ecco_readwei( gencost_errfile(igen_mdt),
     &     gencost_weight(1-OLx,1-OLy,1,1,igen_mdt),
     &     1, 1, 1, dosumsq, myThid )
      endif
      if (igen_lsc.GT.0) then
       call ecco_zero( gencost_weight(1-OLx,1-OLy,1,1,igen_lsc),
     &                 1, zeroRL, myThid )
       if ( gencost_errfile(igen_lsc) .NE. ' ' )
     &   call ecco_readwei( gencost_errfile(igen_lsc),
     &     gencost_weight(1-OLx,1-OLy,1,1,igen_lsc),
     &     1, 1, 1, dosumsq, myThid )
      endif
      if (igen_tp.GT.0) then
       call ecco_zero( gencost_weight(1-OLx,1-OLy,1,1,igen_tp),
     &                 1, zeroRL, myThid )
       if ( gencost_errfile(igen_tp) .NE. ' ' )
     &   call ecco_readwei( gencost_errfile(igen_tp),
     &     gencost_weight(1-OLx,1-OLy,1,1,igen_tp),
     &     1, 1, 1, dosumsq, myThid )
      endif
      if (igen_ers.GT.0) then
       call ecco_zero( gencost_weight(1-OLx,1-OLy,1,1,igen_ers),
     &                 1, zeroRL, myThid )
       if ( gencost_errfile(igen_ers) .NE. ' ' )
     &   call ecco_readwei( gencost_errfile(igen_ers),
     &     gencost_weight(1-OLx,1-OLy,1,1,igen_ers),
     &     1, 1, 1, dosumsq, myThid )
      endif
      if (igen_gfo.GT.0) then
       call ecco_zero( gencost_weight(1-OLx,1-OLy,1,1,igen_gfo),
     &                 1, zeroRL, myThid )
       if ( gencost_errfile(igen_gfo) .NE. ' ' )
     &   call ecco_readwei( gencost_errfile(igen_gfo),
     &     gencost_weight(1-OLx,1-OLy,1,1,igen_gfo),
     &     1, 1, 1, dosumsq, myThid )
      endif

c switch for excluding global mean
      useEtaMean=.TRUE.

      write(msgbuf,'(a,l)')
     & ' sshv4: use global mean of eta useEtaMean=',useEtaMean
      call print_message( msgbuf, standardmessageunit,
     &                    SQUEEZE_RIGHT , myThid)

C Check to determine use_mon and nrec_year. Check all igen_[tp,ers,gfo]
C in case some of the data files are not defined.
      use_mon = .FALSE.
      IF ( igen_tp.GT.0 ) use_mon = use_mon .OR.
     &     gencost_avgperiod(igen_tp) .EQ.'month' .OR.
     &     gencost_avgperiod(igen_tp) .EQ.'MONTH'
      IF ( igen_ers.GT.0 ) use_mon = use_mon .OR.
     &     gencost_avgperiod(igen_ers) .EQ.'month' .OR.
     &     gencost_avgperiod(igen_ers) .EQ.'MONTH'
      IF ( igen_gfo.GT.0 ) use_mon = use_mon .OR.
     &      gencost_avgperiod(igen_gfo).EQ.'month' .OR.
     &      gencost_avgperiod(igen_gfo).EQ.'MONTH'

c minimum number of observations to consider re-referenced MDT
      nrec_year=366
      nrec_total=ndaysrec
      IF (use_mon) THEN
        num0=3
        nrec_mdt_ref=12
        nrec_year=12
        nrec_total=nmonsrec
      else
        num0=100
        nrec_mdt_ref=365
      endif

      write(msgbuf,'(a,L5,2(1x,i10),2(1x,i5))')
     & ' sshv4: use_mon, nrec_year, nrec_total, num0, nrec_mdt_ref: ',
     &          use_mon, nrec_year, nrec_total, num0, nrec_mdt_ref
      call print_message( msgbuf, standardmessageunit,
     &                    SQUEEZE_RIGHT , myThid)
c determine whether or not to re-reference
c-- not only model period has to fall within the mdt period
c-- but that there has to be at least 365 days (or 12 months) of model
c-- run so for short model run, this will always get set to FALSE
C Note also the hard-coded years 1992,2011 here that should be
c removed at some point in the future if the reference MDT start
c date no longer falls between 1992 and 2011
      doReference=.FALSE.
      IF ((modelstartdate(1).GT.1992*10000).AND.
     &    (modelstartdate(1).LT.2011*10000).AND.
     &    (nrec_total.GE.nrec_mdt_ref))  doReference=.TRUE.

      write(msgbuf,'(a,l)') ' sshv4:re-reference MDT=',doReference
      call print_message( msgbuf, standardmessageunit,
     &                    SQUEEZE_RIGHT , myThid)

c-- initialize local arrays
      do bj = jtlo,jthi
        do bi = itlo,ithi
          do j = jmin,jmax
            do i = imin,imax
              mdtma(i,j,bi,bj) = 0. _d 0
              mdtob(i,j,bi,bj) = 0. _d 0
              tpma(i,j,bi,bj) = 0. _d 0
              tpob(i,j,bi,bj) = 0. _d 0
              ersma(i,j,bi,bj) = 0. _d 0
              ersob(i,j,bi,bj) = 0. _d 0
              gfoma(i,j,bi,bj) = 0. _d 0
              gfoob(i,j,bi,bj) = 0. _d 0
            enddo
          enddo
        enddo
      enddo

c mdtfi, mdtsta, mdtend
      if (igen_mdt.GT.0) then
       ilps=ilnblnk( gencost_datafile(igen_mdt) )
       mdtfi=gencost_datafile(igen_mdt)(1:ilps)
       call cal_CopyDate(gencost_startdate(1,igen_mdt),mdtsta,myThid)
       call cal_CopyDate(gencost_enddate(1,igen_mdt), mdtend, myThid)
       if (gencost_barfile(igen_mdt)(1:5).EQ.'m_eta')
     &    igen_etagcm=igen_mdt
      endif
c tpfi, tpsta, tpper
      if (igen_tp.GT.0) then
       ilps=ilnblnk( gencost_datafile(igen_tp) )
       tpfi=gencost_datafile(igen_tp)(1:ilps)
       call cal_CopyDate(gencost_startdate(1,igen_tp),tpsta,myThid)
       tpper=gencost_period(igen_tp)
       if (gencost_barfile(igen_tp)(1:5).EQ.'m_eta')
     &    igen_etagcm=igen_tp
      endif
c ersfi, erssta, ersper
      if (igen_ers.GT.0) then
       ilps=ilnblnk( gencost_datafile(igen_ers) )
       ersfi=gencost_datafile(igen_ers)(1:ilps)
       call cal_CopyDate(gencost_startdate(1,igen_ers),erssta,myThid)
       ersper=gencost_period(igen_ers)
       if (gencost_barfile(igen_ers)(1:5).EQ.'m_eta')
     &    igen_etagcm=igen_ers
      endif
c gfofi, gfosta, gfoper
      if (igen_gfo.GT.0) then
       ilps=ilnblnk( gencost_datafile(igen_gfo) )
       gfofi=gencost_datafile(igen_gfo)(1:ilps)
       call cal_CopyDate(gencost_startdate(1,igen_gfo),gfosta,myThid)
       gfoper=gencost_period(igen_gfo)
       if (gencost_barfile(igen_gfo)(1:5).EQ.'m_eta')
     &    igen_etagcm=igen_gfo
      endif

c mdt_y0, mdt_y1
C in the case the model run is within the valid mdt years,
C we use the max/min check below to get the bound instead of
C basing on mdt years alone.
c       mdt_y0=mdtsta(1)/10000
c       mdt_y1=mdtend(1)/10000
       mdt_y0=max(mdtsta(1)/10000,modelstartdate(1)/10000)
       mdt_y1=min(mdtend(1)/10000,modelenddate(1)/10000)

       write(msgbuf,'(a,i8,a,i8)')
     &  'mdt[start,end]date(1): ', mdtsta(1), ',', mdtend(1)
        call print_message( msgbuf, standardmessageunit,
     &                      SQUEEZE_RIGHT , myThid)
        write(msgbuf,'(a,i4,a,i4)')
     &  '  TP MDT yrrange:          ', mdt_y0, ',', mdt_y1
        call print_message( msgbuf, standardmessageunit,
     &                      SQUEEZE_RIGHT , myThid)

c--   First, read tiled data.
      doglobalread = .false.
      ladinit      = .false.

      ilps=ilnblnk( gencost_barfile(igen_etagcm) )
      write(fname,'(2a,i10.10)')
     &     gencost_barfile(igen_etagcm)(1:ilps),'.',eccoiter

cgf =======================================================
cgf PART 1:
cgf        x Get the MDT (mdt) ... compute the sample mean
cgf        (mean_slaobs_mdt) of the SLA data (i.e. RADS for tp, ers, and gfo
cgf        together) over the time interval of the MDT ... subtract
cgf        mean_slaobs_mdt from mdt.
cgf        x At this point, mdt is the inferred SLA reference field.
cgf        x From there on, mdt+sla will be directly comparable to
cgf        the model SSH (etagcm).
cgf =======================================================

c--   Read mean field and mask

      write(msgbuf,'(a,l)') ' sshv4:using_mdt=',using_mdt
      call print_message( msgbuf, standardmessageunit,
     &                    SQUEEZE_RIGHT , myThid)
      if (using_mdt)
     &  CALL READ_REC_3D_RL( mdtfi, cost_iprec, 1,
     &                       mdtob, 1, 1, myThid )

      factor =  0.01 _d 0
      spval  = -9990. _d 0

      do bj = jtlo,jthi
        do bi = itlo,ithi
          do j = jmin,jmax
            do i = imin,imax
              if ( (maskInC(i,j,bi,bj) .EQ. 0.).OR.
#ifndef ALLOW_SHALLOW_ALTIMETRY
     &             (R_low(i,j,bi,bj).GT.-200.).OR.
#endif
     &             (mdtob(i,j,bi,bj) .LT. spval ).OR.
     &             (mdtob(i,j,bi,bj) .EQ. 0. _d 0) ) then
                mdtma(i,j,bi,bj) = 0. _d 0
                mdtob(i,j,bi,bj) = 0. _d 0
              else
                mdtma(i,j,bi,bj) = 1. _d 0
                mdtob(i,j,bi,bj) = mdtob(i,j,bi,bj)*factor
              endif
            enddo
          enddo
        enddo
      enddo

c--   Compute mean_slaobs_mdt: sample mean SLA over the time period of mdt.

       do bj = jtlo,jthi
        do bi = itlo,ithi
         do j = jmin,jmax
          do i = imin,imax
              mean_slaobs_mdt(i,j,bi,bj)  = 0. _d 0
              mean_slaobs_NUM(i,j,bi,bj)  = 0. _d 0
          enddo
         enddo
        enddo
       enddo

      do year=mdt_y0,mdt_y1
       do irec=1,nrec_year

       do bj = jtlo,jthi
        do bi = itlo,ithi
         do j = jmin,jmax
          do i = imin,imax
              tpma(i,j,bi,bj) = 0. _d 0
              tpob(i,j,bi,bj) = 0. _d 0
              ersma(i,j,bi,bj) = 0. _d 0
              ersob(i,j,bi,bj) = 0. _d 0
              gfoma(i,j,bi,bj) = 0. _d 0
              gfoob(i,j,bi,bj) = 0. _d 0
          enddo
         enddo
        enddo
       enddo

#ifdef ECCO_VERBOSE
       write(msgbuf,'(a,3(1x,l))') ' sshv4:using_[tpj,ers,gfo]: ',
     &   using_tpj, using_ers, using_gfo
       call print_message( msgbuf, standardmessageunit,
     &                     SQUEEZE_RIGHT , myThid)
#endif
       if (using_tpj)
     & call cost_sla_read_yd( tpfi, tpsta, use_mon,
     &                tpob, tpma,
     &                year, irec, myThid )
       if (using_ers)
     & call cost_sla_read_yd( ersfi, erssta, use_mon,
     &                ersob, ersma,
     &                year, irec, myThid )
       if (using_gfo)
     & call cost_sla_read_yd( gfofi, gfosta, use_mon,
     &                gfoob, gfoma,
     &                year, irec, myThid )

       if (igen_tp .GT. 0) then
        do bj = jtlo,jthi
         do bi = itlo,ithi
          do j = jmin,jmax
           do i = imin,imax
      if ( tpma(i,j,bi,bj)*mdtma(i,j,bi,bj)*
     &    gencost_weight(i,j,bi,bj,igen_tp) .NE. 0. ) then
          mean_slaobs_mdt(i,j,bi,bj)= mean_slaobs_mdt(i,j,bi,bj)+
     &  tpob(i,j,bi,bj)
          mean_slaobs_NUM(i,j,bi,bj)= mean_slaobs_NUM(i,j,bi,bj)+1. _d 0
      endif
           enddo
          enddo
         enddo
        enddo
       endif
       if (igen_ers .GT. 0) then
        do bj = jtlo,jthi
         do bi = itlo,ithi
          do j = jmin,jmax
           do i = imin,imax
      if ( ersma(i,j,bi,bj)*mdtma(i,j,bi,bj)*
     &    gencost_weight(i,j,bi,bj,igen_ers) .NE. 0. ) then
          mean_slaobs_mdt(i,j,bi,bj)= mean_slaobs_mdt(i,j,bi,bj)+
     &  ersob(i,j,bi,bj)
          mean_slaobs_NUM(i,j,bi,bj)= mean_slaobs_NUM(i,j,bi,bj)+1. _d 0
      endif
           enddo
          enddo
         enddo
        enddo
       endif
       if (igen_gfo .GT. 0) then
        do bj = jtlo,jthi
         do bi = itlo,ithi
          do j = jmin,jmax
           do i = imin,imax
      if ( gfoma(i,j,bi,bj)*mdtma(i,j,bi,bj)*
     &    gencost_weight(i,j,bi,bj,igen_gfo) .NE. 0. ) then
          mean_slaobs_mdt(i,j,bi,bj)= mean_slaobs_mdt(i,j,bi,bj)+
     &  gfoob(i,j,bi,bj)
          mean_slaobs_NUM(i,j,bi,bj)= mean_slaobs_NUM(i,j,bi,bj)+1. _d 0
      endif
           enddo
          enddo
         enddo
        enddo
       endif

       enddo !do irec=1,nrec_year
      enddo !do year=mdt_y0,mdt_y1

      do bj = jtlo,jthi
        do bi = itlo,ithi
          do j = jmin,jmax
            do i = imin,imax
               if ( ( mean_slaobs_NUM(i,j,bi,bj) .NE. 0. ).AND.
     &              ( maskc(i,j,1,bi,bj) .NE. 0. ).AND.
     &              ( mdtma(i,j,bi,bj) .NE. 0. ) ) then
                  mean_slaobs_mdt(i,j,bi,bj) =
     &                 mean_slaobs_mdt(i,j,bi,bj) /
     &                 mean_slaobs_NUM(i,j,bi,bj)
               else
                  mean_slaobs_mdt(i,j,bi,bj) = 0. _d 0
               endif
            enddo
          enddo
        enddo
      enddo

c--   smooth mean_slaobs_mdt:

      if (igen_mdt.GT.0) then
       if (gencost_outputlevel(igen_mdt).GT.0) then
        write(fname4test,'(1a)') 'sla2mdt_raw'
        CALL WRITE_REC_3D_RL( fname4test, precFloat32, 1,
     &                        mean_slaobs_mdt, 1, 1, myThid )
       endif

#ifdef ALLOW_SMOOTH
       if ( useSMOOTH.AND.(k2_mdt.GT.0) ) then
        call smooth_hetero2d(mean_slaobs_mdt,maskInC,
     &     gencost_posproc_c(k2_mdt,igen_mdt),
     &     gencost_posproc_i(k2_mdt,igen_mdt),myThid)

        if (gencost_outputlevel(igen_mdt).GT.0) then
         write(fname4test,'(1a)') 'sla2mdt_smooth'
         CALL WRITE_REC_3D_RL( fname4test, precFloat32, 1,
     &                         mean_slaobs_mdt, 1, 1, myThid )
        endif
       endif
#endif
c     endif igen_mdt .gt. 0
      endif

c--   re-reference mdt:
      do bj = jtlo,jthi
        do bi = itlo,ithi
          do j = jmin,jmax
            do i = imin,imax
               if ( ( mdtma(i,j,bi,bj) .NE. 0. ).AND.
     &              ( maskc(i,j,1,bi,bj) .NE. 0. ).AND.
     &              ( doReference ) ) then
                  mdtob(i,j,bi,bj) = mdtob(i,j,bi,bj)
     &                 -mean_slaobs_mdt(i,j,bi,bj)
               endif
            enddo
          enddo
        enddo
      enddo

cgf =======================================================
cgf PART 2: compute sample means of etagcm-slaobs over the
cgf         period that is covered by the model (i.e. etagcm).
cgf       x for all SLA data sets together: mean_psMssh_all, mean_psMssh_all_MSK,
cgf         and offset will be used in PART 3 (MDT cost term).
cgf       x for each SLA data individually. mean_psMtpobs, mean_psMtpobs_MS, etc.
cgf         will be used in PART 4&5 (SLA cost terms).
cgf =======================================================

      do bj = jtlo,jthi
        do bi = itlo,ithi
          do j = jmin,jmax
            do i = imin,imax

              psmean(i,j,bi,bj)    = 0. _d 0
              mean_psMslaobs(i,j,bi,bj)  = 0. _d 0
              mean_psMtpobs(i,j,bi,bj)  = 0. _d 0
              mean_psMersobs(i,j,bi,bj) = 0. _d 0
              mean_psMgfoobs(i,j,bi,bj) = 0. _d 0
              mean_psMssh_all(i,j,bi,bj) = 0. _d 0
              mean_slaobs_model(i,j,bi,bj)  = 0. _d 0

              mean_psMtpobs_NUM(i,j,bi,bj)  = 0. _d 0
              mean_psMersobs_NUM(i,j,bi,bj) = 0. _d 0
              mean_psMgfoobs_NUM(i,j,bi,bj) = 0. _d 0
              mean_psMssh_all_NUM(i,j,bi,bj) = 0. _d 0
              mean_psMslaobs_MSK(i,j,bi,bj)  = 0. _d 0

            enddo
          enddo
        enddo
      enddo
      offset     = 0. _d 0
      offset_sum = 0. _d 0

#ifdef ECCO_VERBOSE
      write(msgbuf,'(a,3(1x,i6))')
     & 'sshv4: before entering irec loop, n[mon,day]srec,nrec_total: ',
     & nmonsrec,ndaysrec,nrec_total
      call print_message( msgbuf, standardmessageunit,
     &                    SQUEEZE_RIGHT , myThid)
#endif

      do irec = 1, nrec_total

#ifdef ALLOW_AUTODIFF
        call active_read_xy( fname, etagcm, irec, doglobalread,
     &                       ladinit, eccoiter, myThid,
     &                       gencost_dummy(igen_etagcm) )
#else
        CALL READ_REC_XY_RL( fname, etagcm, iRec, 1, myThid )
#endif

        if (.NOT.useEtaMean)
     &  CALL REMOVE_MEAN_RL( 1, etagcm, maskInC, maskInC, rA, drF,
     &                       'etagcm', zeroRL, 1, myThid )

       do bj = jtlo,jthi
        do bi = itlo,ithi
         do j = jmin,jmax
          do i = imin,imax
              tpma(i,j,bi,bj) = 0. _d 0
              tpob(i,j,bi,bj) = 0. _d 0
              ersma(i,j,bi,bj) = 0. _d 0
              ersob(i,j,bi,bj) = 0. _d 0
              gfoma(i,j,bi,bj) = 0. _d 0
              gfoob(i,j,bi,bj) = 0. _d 0
          enddo
         enddo
        enddo
       enddo

        if (using_tpj)
     &  call cost_sla_read( tpfi, tpsta, tpper, use_mon,
     &                zeroRL, zeroRL,
     &                tpob, tpma,
     &                irec, myThid )
        if (using_ers)
     &  call cost_sla_read( ersfi, erssta, ersper, use_mon,
     &                zeroRL, zeroRL,
     &                ersob, ersma,
     &                irec, myThid )
        if (using_gfo)
     &  call cost_sla_read( gfofi, gfosta, gfoper, use_mon,
     &                zeroRL, zeroRL,
     &                gfoob, gfoma,
     &                irec, myThid )

        do bj = jtlo,jthi
          do bi = itlo,ithi
            do j = jmin,jmax
              do i = imin,imax
                psmean(i,j,bi,bj) = psmean(i,j,bi,bj) +
     &                etagcm(i,j,bi,bj) / float(nrec_total)
                if ( igen_tp .GT. 0 ) then
                  if ( tpma(i,j,bi,bj)*
     &             gencost_weight(i,j,bi,bj,igen_tp) .NE. 0. ) then
                   mean_slaobs_model(i,j,bi,bj)=
     &              mean_slaobs_model(i,j,bi,bj)+tpob(i,j,bi,bj)
                   mean_psMtpobs(i,j,bi,bj) =
     &                 mean_psMtpobs(i,j,bi,bj) +
     &                 etagcm(i,j,bi,bj)-tpob(i,j,bi,bj)
                   mean_psMtpobs_NUM(i,j,bi,bj) =
     &                 mean_psMtpobs_NUM(i,j,bi,bj) + 1. _d 0
                  endif
                endif
                if ( igen_ers .GT. 0 ) then
                  if ( ersma(i,j,bi,bj)*
     &             gencost_weight(i,j,bi,bj,igen_ers) .NE. 0. ) then
                   mean_slaobs_model(i,j,bi,bj)=
     &              mean_slaobs_model(i,j,bi,bj)+ersob(i,j,bi,bj)
                   mean_psMersobs(i,j,bi,bj) =
     &                 mean_psMersobs(i,j,bi,bj) +
     &                 etagcm(i,j,bi,bj)-ersob(i,j,bi,bj)
                   mean_psMersobs_NUM(i,j,bi,bj) =
     &                 mean_psMersobs_NUM(i,j,bi,bj) + 1. _d 0
                  endif
                endif
                if ( igen_gfo .GT. 0 ) then
                  if ( gfoma(i,j,bi,bj)*
     &             gencost_weight(i,j,bi,bj,igen_gfo) .NE. 0. ) then
                   mean_slaobs_model(i,j,bi,bj)=
     &              mean_slaobs_model(i,j,bi,bj)+gfoob(i,j,bi,bj)
                   mean_psMgfoobs(i,j,bi,bj) =
     &                 mean_psMgfoobs(i,j,bi,bj) +
     &                 etagcm(i,j,bi,bj)-gfoob(i,j,bi,bj)
                   mean_psMgfoobs_NUM(i,j,bi,bj) =
     &                 mean_psMgfoobs_NUM(i,j,bi,bj) + 1. _d 0
                  endif
                endif
              enddo
            enddo
          enddo
        enddo

c--   END loop over irec records for the first time.
      enddo

      call ecco_zero(num0array,1,oneRL,myThid)

        do bj = jtlo,jthi
          do bi = itlo,ithi
            do j = jmin,jmax
              do i = imin,imax
               if ( ( mean_psMtpobs_NUM(i,j,bi,bj) .NE. 0. )
     &              ) then
                  mean_psMssh_all(i,j,bi,bj) =
     &                 mean_psMssh_all(i,j,bi,bj) +
     &                 mean_psMtpobs(i,j,bi,bj)
                  mean_psMssh_all_NUM(i,j,bi,bj) =
     &                 mean_psMssh_all_NUM(i,j,bi,bj) +
     &                 mean_psMtpobs_NUM(i,j,bi,bj)
                  mean_psMtpobs(i,j,bi,bj) =
     &                 mean_psMtpobs(i,j,bi,bj) /
     &                 mean_psMtpobs_NUM(i,j,bi,bj)
               endif
               if ( ( mean_psMersobs_NUM(i,j,bi,bj) .NE. 0. )
     &              ) then
                  mean_psMssh_all(i,j,bi,bj) =
     &                 mean_psMssh_all(i,j,bi,bj) +
     &                 mean_psMersobs(i,j,bi,bj)
                  mean_psMssh_all_NUM(i,j,bi,bj) =
     &                 mean_psMssh_all_NUM(i,j,bi,bj) +
     &                 mean_psMersobs_NUM(i,j,bi,bj)
                  mean_psMersobs(i,j,bi,bj) =
     &                 mean_psMersobs(i,j,bi,bj) /
     &                 mean_psMersobs_NUM(i,j,bi,bj)
               endif
               if ( ( mean_psMgfoobs_NUM(i,j,bi,bj) .NE. 0. )
     &              ) then
                  mean_psMssh_all(i,j,bi,bj) =
     &                 mean_psMssh_all(i,j,bi,bj) +
     &                 mean_psMgfoobs(i,j,bi,bj)
                  mean_psMssh_all_NUM(i,j,bi,bj) =
     &                 mean_psMssh_all_NUM(i,j,bi,bj) +
     &                 mean_psMgfoobs_NUM(i,j,bi,bj)
                  mean_psMgfoobs(i,j,bi,bj) =
     &                 mean_psMgfoobs(i,j,bi,bj) /
     &                 mean_psMgfoobs_NUM(i,j,bi,bj)
               endif

               if ( ( mean_psMssh_all_NUM(i,j,bi,bj) .GT. 0 ).AND.
     &              ( maskc(i,j,1,bi,bj) .NE. 0. )
     &              ) then
                  mean_psMslaobs(i,j,bi,bj) =
     &                 mean_psMssh_all(i,j,bi,bj) /
     &                 mean_psMssh_all_NUM(i,j,bi,bj)
                  mean_psMslaobs_MSK(i,j,bi,bj) = 1. _d 0
               else
                  mean_psMslaobs(i,j,bi,bj) = 0. _d 0
                  mean_psMslaobs_MSK(i,j,bi,bj) = 0. _d 0
               endif

               if ( ( mean_psMssh_all_NUM(i,j,bi,bj) .GT. num0 ).AND.
     &              ( maskc(i,j,1,bi,bj) .NE. 0. ) .AND.
     &              ( mdtma(i,j,bi,bj) .NE. 0. ).AND.
     &              ( doReference ) ) then
                  mean_slaobs_model(i,j,bi,bj) =
     &                 mean_slaobs_model(i,j,bi,bj) /
     &                 mean_psMssh_all_NUM(i,j,bi,bj)
                  mean_psMssh_all(i,j,bi,bj) =
     &                 mean_psMssh_all(i,j,bi,bj) /
     &                 mean_psMssh_all_NUM(i,j,bi,bj)-mdtob(i,j,bi,bj)
                  mean_psMssh_all_MSK(i,j,bi,bj) = 1. _d 0
                  offset=offset+RA(i,j,bi,bj)*mean_psMssh_all(i,j,bi,bj)
                  offset_sum=offset_sum+RA(i,j,bi,bj)
               elseif ( ( mdtma(i,j,bi,bj) .NE. 0. ) .AND.
     &              ( maskc(i,j,1,bi,bj) .NE. 0. ).AND.
     &              ( .NOT.doReference ) ) then
                  mean_slaobs_model(i,j,bi,bj) = 0.d0
                  mean_psMssh_all(i,j,bi,bj) = 0. _d 0
                  mean_psMssh_all_MSK(i,j,bi,bj) = 1. _d 0
                  offset=offset+RA(i,j,bi,bj)
     &                  *( psmean(i,j,bi,bj) -mdtob(i,j,bi,bj) )
                  offset_sum=offset_sum+RA(i,j,bi,bj)
                  num0array(i,j,bi,bj)=0. _d 0
               else
                  mean_slaobs_model(i,j,bi,bj) = 0.d0
                  mean_psMssh_all(i,j,bi,bj) = 0. _d 0
                  mean_psMssh_all_MSK(i,j,bi,bj) = 0. _d 0
                  num0array(i,j,bi,bj)=0. _d 0
               endif
              enddo
            enddo
          enddo
        enddo

c--   Do a global summation.
      _GLOBAL_SUM_RL( offset     , myThid )
      _GLOBAL_SUM_RL( offset_sum , myThid )

C --  add warning that written mean_slaobs_model is all zero
c     due to having less data points that hardcoded num0
        num0total=0. _d 0
        do bj = jtlo,jthi
          do bi = itlo,ithi
            do j = jmin,jmax
              do i = imin,imax
                num0total=num0total+num0array(i,j,bi,bj)
              enddo
            enddo
          enddo
        enddo
      if(num0total.LT.1. _d 0) then
        write(msgbuf,'(A,i5,A)')
     &  '** WARNING ** S/R COST_GENCOST_SSHV4: There are <',num0,' pts'
      call print_message( msgbuf, errormessageunit,
     &                    SQUEEZE_RIGHT , myThid)
        write(msgbuf,'(A)')
     &  '                  at all grid points for combined tp+ers+gfo.'
      call print_message( msgbuf, errormessageunit,
     &                    SQUEEZE_RIGHT , myThid)
        write(msgbuf,'(A)')
     &  'So, all model slaob minus model sla2model_raw are set to 0.'
      call print_message( msgbuf, errormessageunit,
     &                    SQUEEZE_RIGHT , myThid)
      endif

      if (igen_gmsl.GT.0) then
       if (offset_sum .EQ. 0.0) then
        if (gencost_outputlevel(igen_gmsl).GT.0) then
        _BEGIN_MASTER( myThid )
        write(msgbuf,'(a)') ' sshv4: offset_sum = zero!'
        call print_message( msgbuf, standardmessageunit,
     &                          SQUEEZE_RIGHT , myThid)
        _END_MASTER( myThid )
        endif
c       stop   '  ... stopped in cost_ssh.'
       else
        if (gencost_outputlevel(igen_gmsl).GT.0) then
        _BEGIN_MASTER( myThid )
        write(msgbuf,'(a,2d22.15)') ' sshv4:offset,sum=',
     &      offset,offset_sum
        call print_message( msgbuf, standardmessageunit,
     &                          SQUEEZE_RIGHT , myThid)
        _END_MASTER( myThid )
        endif
       endif
c     endif igen_gmsl .gt. 0
      endif

c--   Compute (average) offset
      if ( offset_sum.NE.0. _d 0 ) then
        offset = offset / offset_sum
      else
        offset = 0. _d 0
      endif

c--   subtract offset from mean_psMssh_all and psmean
      do bj = jtlo,jthi
        do bi = itlo,ithi
          do j = jmin,jmax
            do i = imin,imax

               if ( (mean_psMssh_all_NUM(i,j,bi,bj) .GT. num0) .AND.
     &              ( mdtma(i,j,bi,bj) .NE. 0. ) .AND.
     &              ( maskc(i,j,1,bi,bj) .NE. 0. ) .AND.
     &              ( doReference ) ) then
c use the re-referencing approach
                   mean_psMssh_all(i,j,bi,bj) =
     &                 mean_psMssh_all(i,j,bi,bj) - offset
                   mean_psMssh_all_MSK(i,j,bi,bj) = 1. _d 0

               elseif ( ( mdtma(i,j,bi,bj) .NE. 0. ) .AND.
     &              ( maskc(i,j,1,bi,bj) .NE. 0. ) .AND.
     &              ( .NOT.doReference ) ) then
c use the simpler approach
                   mean_psMssh_all(i,j,bi,bj) =
     &             psmean(i,j,bi,bj) -mdtob(i,j,bi,bj) - offset
                   mean_psMssh_all_MSK(i,j,bi,bj) = 1. _d 0

               else
                   mean_psMssh_all(i,j,bi,bj) = 0. _d 0
                   mean_psMssh_all_MSK(i,j,bi,bj) = 0. _d 0
               endif

               if ( maskc(i,j,1,bi,bj) .NE. 0. )
     &            psmean(i,j,bi,bj)=psmean(i,j,bi,bj)-offset

            enddo
          enddo
        enddo
      enddo

c--    smooth mean_psMssh_all
      if (igen_mdt.GT.0) then
       if (gencost_outputlevel(igen_mdt).GT.0) then
        write(fname4test,'(1a)') 'mdtdiff_raw'
        CALL WRITE_REC_3D_RL( fname4test, precFloat32, 1,
     &                        mean_psMssh_all, 1, 1, myThid )
        write(fname4test,'(1a)') 'sla2model_raw'
        CALL WRITE_REC_3D_RL( fname4test, precFloat32, 1,
     &                        mean_slaobs_model, 1, 1, myThid )
       endif

#ifdef ALLOW_SMOOTH
       if ( useSMOOTH.AND.(k2_mdt.GT.0) ) then
        call smooth_hetero2d(mean_psMssh_all,maskInC,
     &     gencost_posproc_c(k2_mdt,igen_mdt),
     &     gencost_posproc_i(k2_mdt,igen_mdt),myThid)
        call smooth_hetero2d(mean_slaobs_model,maskInC,
     &     gencost_posproc_c(k2_mdt,igen_mdt),
     &     gencost_posproc_i(k2_mdt,igen_mdt),myThid)

        if (gencost_outputlevel(igen_mdt).GT.0) then
         write(fname4test,'(1a)') 'mdtdiff_smooth'
         CALL WRITE_REC_3D_RL( fname4test, precFloat32, 1,
     &                         mean_psMssh_all, 1, 1, myThid )
         write(fname4test,'(1a)') 'sla2model_smooth'
         CALL WRITE_REC_3D_RL( fname4test, precFloat32, 1,
     &                         mean_slaobs_model, 1, 1, myThid )
        endif
       endif
#endif

cgf at this point:
cgf     1) mean_psMssh_all is the sample mean <etagcm-slaobs-mdt-offset>,
cgf             to which a smoothing filter has been applied.
cgf     2) mean_psMtpobs is the (unsmoothed) sample mean <etagcm-tpobs>.
cgf             And similarly for ers and gfo, each treated separately.

cgf =======================================================
cgf PART 3: compute MDT cost term
cgf =======================================================

       do bj = jtlo,jthi
        do bi = itlo,ithi
         do j = jmin,jmax
          do i = imin,imax
       if (mean_psMssh_all_MSK(i,j,bi,bj).NE.0. _d 0) then
         junk = mean_psMssh_all(i,j,bi,bj)
         junkweight = gencost_weight(i,j,bi,bj,igen_mdt)
     &              * mdtma(i,j,bi,bj)
       else
         junk = 0. _d 0
         junkweight = 0. _d 0
       endif
       objf_gencost(bi,bj,igen_mdt) = objf_gencost(bi,bj,igen_mdt)
     &      + junk*junk*junkweight
       if ( junkweight .NE. 0. ) num_gencost(bi,bj,igen_mdt) =
     &      num_gencost(bi,bj,igen_mdt) + 1. _d 0
       diagnosfld(i,j,bi,bj) = junk*junk*junkweight
          enddo
         enddo
        enddo
       enddo

       if (gencost_outputlevel(igen_mdt).GT.0) then
        write(fname4test,'(1a)') 'misfits_mdt'
        CALL WRITE_REC_3D_RL( fname4test, precFloat32, 1,
     &                        diagnosfld, 1, 1, myThid )
       endif
c     endif igen_mdt .gt. 0
      endif

cgf =======================================================
cgf PART 4: compute smooth SLA cost term
cgf =======================================================

      if (use_mon) then
        nrecsave=1
      else
        nrecsave=35
      endif

C add a warning if nrec_total is less than the hardcoded nrecsave
      tempinteger=nrec_total-nrecsave+1
#ifdef ECCO_VERBOSE
      write(msgbuf,'(A,i5,1x,i5,1x,i5)')
     & 'sshv4: nrec[save,_total],tempinteger',
     &     nrecsave,nrec_total,tempinteger
#endif
      if(tempinteger.LT.1) then
        write(msgbuf,'(A,i5)')
     &  '** WARNING ** S/R COST_GENCOST_SSHV4: There are < ',nrecsave
        call print_message( msgbuf, errormessageunit,
     &                      SQUEEZE_RIGHT , myThid)
        if (use_mon) then
         write(msgbuf,'(A)')
     &   '        months required to calculate running mean tp+ers+gfo.'
         call print_message( msgbuf, errormessageunit,
     &                       SQUEEZE_RIGHT , myThid)
        else
         write(msgbuf,'(A)')
     &   '        days required to calculate running mean tp+ers+gfo.'
         call print_message( msgbuf, errormessageunit,
     &                       SQUEEZE_RIGHT , myThid)
        endif
        write(msgbuf,'(A)')
     &  'PART 4 in cost_gencost_sshv4 is skipped entirely, and there'
      call print_message( msgbuf, errormessageunit,
     &                    SQUEEZE_RIGHT , myThid)
        write(msgbuf,'(A)')
     &  'will be NO report of [tp,ers,gfo,lsc,gmsl] in costfunction.'
      call print_message( msgbuf, errormessageunit,
     &                    SQUEEZE_RIGHT , myThid)
      endif

      do irec = 1, nrec_total-nrecsave+1

       do bj = jtlo,jthi
        do bi = itlo,ithi
         do j = jmin,jmax
          do i = imin,imax
              anom_psMslaobs(i,j,bi,bj)  = 0. _d 0
              anom_psMslaobs_MSK(i,j,bi,bj)  = 0. _d 0
              anom_psMslaobs_SUB(i,j,bi,bj)  = 0. _d 0
              anom_slaobs(i,j,bi,bj)  = 0. _d 0
              anom_slaobs_SUB(i,j,bi,bj)  = 0. _d 0
              anom_psMslaobs_NUM(i,j,bi,bj)  = 0. _d 0
          enddo
         enddo
        enddo
       enddo

c PART 4.1: compute running sample average over nrecsave
c ------------------------------------------------------

      do jrec=1,nrecsave

        krec=irec+jrec-1

#ifdef ALLOW_AUTODIFF
        call active_read_xy( fname, etagcm, krec, doglobalread,
     &                       ladinit, eccoiter, myThid,
     &                       gencost_dummy(igen_etagcm) )
#else
        CALL READ_REC_XY_RL( fname, etagcm, kRec, 1, myThid )
#endif

        if (.NOT.useEtaMean)
     &  CALL REMOVE_MEAN_RL( 1, etagcm, maskInC, maskInC, rA, drF,
     &                       'etagcm', zeroRL, 1, myThid )

       do bj = jtlo,jthi
        do bi = itlo,ithi
         do j = jmin,jmax
          do i = imin,imax
              tpma(i,j,bi,bj) = 0. _d 0
              tpob(i,j,bi,bj) = 0. _d 0
              ersma(i,j,bi,bj) = 0. _d 0
              ersob(i,j,bi,bj) = 0. _d 0
              gfoma(i,j,bi,bj) = 0. _d 0
              gfoob(i,j,bi,bj) = 0. _d 0
          enddo
         enddo
        enddo
       enddo

        if (using_tpj)
     &  call cost_sla_read( tpfi, tpsta, tpper, use_mon,
     &                zeroRL, zeroRL,
     &                tpob, tpma,
     &                krec, myThid )
        if (using_ers)
     &  call cost_sla_read( ersfi, erssta, ersper, use_mon,
     &                zeroRL, zeroRL,
     &                ersob, ersma,
     &                krec, myThid )
        if (using_gfo)
     &  call cost_sla_read( gfofi, gfosta, gfoper, use_mon,
     &                zeroRL, zeroRL,
     &                gfoob, gfoma,
     &                krec, myThid )

       do bj = jtlo,jthi
        do bi = itlo,ithi
         do j = jmin,jmax
          do i = imin,imax
      if ( tpma(i,j,bi,bj)*mean_psMslaobs_MSK(i,j,bi,bj)
     &  .NE.0. ) then
           anom_psMslaobs(i,j,bi,bj)= anom_psMslaobs(i,j,bi,bj)+
     &        etagcm(i,j,bi,bj)-tpob(i,j,bi,bj)
     &        -mean_psMslaobs(i,j,bi,bj)
           anom_slaobs(i,j,bi,bj)= anom_slaobs(i,j,bi,bj)+
     &        tpob(i,j,bi,bj)
           anom_psMslaobs_NUM(i,j,bi,bj)=
     &        anom_psMslaobs_NUM(i,j,bi,bj)+1. _d 0
           if ( (2*jrec.EQ.nrecsave).OR.(2*jrec-1.EQ.nrecsave) )
     &        anom_psMslaobs_MSK(i,j,bi,bj)  = 1. _d 0
      endif
      if ( ersma(i,j,bi,bj)*mean_psMslaobs_MSK(i,j,bi,bj)
     &  .NE.0. ) then
           anom_psMslaobs(i,j,bi,bj)= anom_psMslaobs(i,j,bi,bj)+
     &        etagcm(i,j,bi,bj)-ersob(i,j,bi,bj)
     &        -mean_psMslaobs(i,j,bi,bj)
           anom_slaobs(i,j,bi,bj)= anom_slaobs(i,j,bi,bj)+
     &        ersob(i,j,bi,bj)
           anom_psMslaobs_NUM(i,j,bi,bj)=
     &        anom_psMslaobs_NUM(i,j,bi,bj)+1. _d 0
           if ( (2*jrec.EQ.nrecsave).OR.(2*jrec-1.EQ.nrecsave) )
     &        anom_psMslaobs_MSK(i,j,bi,bj)  = 1. _d 0
      endif
      if ( gfoma(i,j,bi,bj)*mean_psMslaobs_MSK(i,j,bi,bj)
     &  .NE.0. ) then
           anom_psMslaobs(i,j,bi,bj)= anom_psMslaobs(i,j,bi,bj)+
     &        etagcm(i,j,bi,bj)-gfoob(i,j,bi,bj)
     &        -mean_psMslaobs(i,j,bi,bj)
           anom_slaobs(i,j,bi,bj)= anom_slaobs(i,j,bi,bj)+
     &        gfoob(i,j,bi,bj)
           anom_psMslaobs_NUM(i,j,bi,bj)=
     &        anom_psMslaobs_NUM(i,j,bi,bj)+1. _d 0
           if ( (2*jrec.EQ.nrecsave).OR.(2*jrec-1.EQ.nrecsave) )
     &        anom_psMslaobs_MSK(i,j,bi,bj)  = 1. _d 0
      endif
          enddo
         enddo
        enddo
       enddo

      enddo !do jrec=1,nrecsave

        do bj = jtlo,jthi
          do bi = itlo,ithi
            do j = jmin,jmax
              do i = imin,imax
               if ( ( anom_psMslaobs_NUM(i,j,bi,bj) .NE. 0. ).AND.
     &              ( maskc(i,j,1,bi,bj) .NE. 0. )
     &            ) then
                  anom_psMslaobs(i,j,bi,bj) =
     &                 anom_psMslaobs(i,j,bi,bj) /
     &                 anom_psMslaobs_NUM(i,j,bi,bj)
                  anom_slaobs(i,j,bi,bj) =
     &                 anom_slaobs(i,j,bi,bj) /
     &                 anom_psMslaobs_NUM(i,j,bi,bj)
               else
                  anom_psMslaobs(i,j,bi,bj) = 0. _d 0
                  anom_slaobs(i,j,bi,bj) = 0. _d 0
               endif
              enddo
            enddo
          enddo
        enddo

c PART 4.11: separate time variable offset
c ----------------------------------------

      slaoffset     = 0. _d 0
      slaoffset_sum = 0. _d 0
      slaoffset_weight = 0. _d 0

      if (igen_lsc.GT.0) then
        do bj = jtlo,jthi
          do bi = itlo,ithi
            do j = jmin,jmax
              do i = imin,imax
               if ( ( anom_psMslaobs_NUM(i,j,bi,bj) .NE. 0. ).AND.
     &              ( maskc(i,j,1,bi,bj) .NE. 0. )
     &            ) then
                  slaoffset=slaoffset+RA(i,j,bi,bj)*
     &                      anom_psMslaobs(i,j,bi,bj)
                  slaoffset_sum=slaoffset_sum+RA(i,j,bi,bj)
C Of interest is the total weight for an average of N
C indep sample (not the area weighted average of weight)
C Since slaoffset is itself area weighted, however, the
C total weight is only approx the simple weight sum:
                  slaoffset_weight=slaoffset_weight+
     &                      gencost_weight(i,j,bi,bj,igen_lsc)
               endif
              enddo
            enddo
          enddo
        enddo

      _GLOBAL_SUM_RL( slaoffset     , myThid )
      _GLOBAL_SUM_RL( slaoffset_weight , myThid )
      _GLOBAL_SUM_RL( slaoffset_sum , myThid )

       if (igen_gmsl.GT.0) then
        if (slaoffset_sum .EQ. 0.0) then
         if (gencost_outputlevel(igen_gmsl).GT.0) then
         _BEGIN_MASTER( myThid )
         write(msgbuf,'(a)') ' sshv4: slaoffset_sum = zero!'
         call print_message( msgbuf, standardmessageunit,
     &                           SQUEEZE_RIGHT , myThid)
         _END_MASTER( myThid )
         endif
c        stop   '  ... stopped in cost_ssh.'
        else
         if (gencost_outputlevel(igen_gmsl).GT.0) then
         _BEGIN_MASTER( myThid )
         write(msgbuf,'(a,3d22.15)') ' sshv4:slaoffset,sum,weight=',
     &          slaoffset,slaoffset_sum,slaoffset_weight
         call print_message( msgbuf, standardmessageunit,
     &                           SQUEEZE_RIGHT , myThid)
         _END_MASTER( myThid )
         endif
        endif
c      endif igen_gmsl .gt. 0
       endif

c--   Compute (average) slaoffset
       if (slaoffset_sum.NE.0. _d 0) then
        slaoffset = slaoffset / slaoffset_sum
       else
        slaoffset = 0. _d 0
       endif

c--   Subtract slaoffset from anom_psMslaobs
        do bj = jtlo,jthi
          do bi = itlo,ithi
            do j = jmin,jmax
              do i = imin,imax
               if ( ( anom_psMslaobs_NUM(i,j,bi,bj) .NE. 0. ).AND.
     &              ( maskc(i,j,1,bi,bj) .NE. 0. )
     &            ) then
                  anom_psMslaobs(i,j,bi,bj) =
     &                 anom_psMslaobs(i,j,bi,bj) - slaoffset
                  anom_slaobs(i,j,bi,bj) =
     &                 anom_slaobs(i,j,bi,bj) - slaoffset
               else
                  anom_psMslaobs(i,j,bi,bj) = 0. _d 0
                  anom_slaobs(i,j,bi,bj) = 0. _d 0
               endif
              enddo
            enddo
          enddo
        enddo

c PART 4.2: smooth anom_psMslaobs in space
c ----------------------------------------

      if (gencost_outputlevel(igen_lsc).GT.0) then
        write(fname4test,'(1a)') 'sladiff_raw'
        CALL WRITE_REC_3D_RL( fname4test, precFloat32, 1,
     &                        anom_psMslaobs, irec, 1, myThid )
        write(fname4test,'(1a)') 'slaobs_raw'
        CALL WRITE_REC_3D_RL( fname4test, precFloat32, 1,
     &                        anom_slaobs, irec, 1, myThid )
      endif

#ifdef ALLOW_SMOOTH
      if ( useSMOOTH.AND.(k2_lsc.GT.0) ) then
        call smooth_hetero2d(anom_psMslaobs,maskInC,
     &     gencost_posproc_c(k2_lsc,igen_lsc),
     &     gencost_posproc_i(k2_lsc,igen_lsc),myThid)
        call smooth_hetero2d(anom_slaobs,maskInC,
     &     gencost_posproc_c(k2_lsc,igen_lsc),
     &     gencost_posproc_i(k2_lsc,igen_lsc),myThid)

        if (gencost_outputlevel(igen_lsc).GT.0) then
         write(fname4test,'(1a)') 'sladiff_smooth'
         CALL WRITE_REC_3D_RL( fname4test, precFloat32, 1,
     &                         anom_psMslaobs, irec, 1, myThid )
         write(fname4test,'(1a)') 'slaobs_smooth'
         CALL WRITE_REC_3D_RL( fname4test, precFloat32, 1,
     &                         anom_slaobs, irec, 1, myThid )
        endif
      endif
#endif

c PART 4.3: compute cost function term
c ------------------------------------

       do bj = jtlo,jthi
        do bi = itlo,ithi
         do j = jmin,jmax
          do i = imin,imax
          if ( (gencost_weight(i,j,bi,bj,igen_lsc).GT.0.).AND.
     &         (anom_psMslaobs_MSK(i,j,bi,bj).GT.0.) ) then
            junk = anom_psMslaobs(i,j,bi,bj)
            anom_slaobs_SUB(i,j,bi,bj) = anom_slaobs(i,j,bi,bj)
            anom_psMslaobs_SUB(i,j,bi,bj) = anom_psMslaobs(i,j,bi,bj)
          else
            junk = 0. _d 0
            anom_slaobs_SUB(i,j,bi,bj)= 0. _d 0
            anom_psMslaobs_SUB(i,j,bi,bj)= 0. _d 0
          endif
          objf_gencost(bi,bj,igen_lsc) = objf_gencost(bi,bj,igen_lsc)
     &        + junk*junk*gencost_weight(i,j,bi,bj,igen_lsc)
          if ( (gencost_weight(i,j,bi,bj,igen_lsc).GT.0.).AND.
     &         (anom_psMslaobs_MSK(i,j,bi,bj).GT.0.) )
     &         num_gencost(bi,bj,igen_lsc) =
     &         num_gencost(bi,bj,igen_lsc) + 1. _d 0
           enddo
         enddo
        enddo
       enddo

       if (gencost_outputlevel(igen_lsc).GT.0) then
        write(fname4test,'(1a)') 'sladiff_subsample'
        CALL WRITE_REC_3D_RL( fname4test, precFloat32, 1,
     &                        anom_psMslaobs_SUB, irec, 1, myThid )
        write(fname4test,'(1a)') 'slaobs_subsample'
        CALL WRITE_REC_3D_RL( fname4test, precFloat32, 1,
     &                        anom_slaobs_SUB, irec, 1, myThid )
       endif

c     endif igen_lsc .gt. 0
      endif

c PART 4.4: compute cost function term for global mean sea level
c --------------------------------------------------------------

      IF ( MASTER_CPU_THREAD(myThid) .AND. ( igen_gmsl.GT.0 )
     &     .AND. ( slaoffset_sum.GT.0.25 _d 0 * globalArea ) ) THEN
          junk=slaoffset
          junkweight=1. _d 0
          objf_gencost(1,1,igen_gmsl) = objf_gencost(1,1,igen_gmsl)
     &        + junk*junk*junkweight
          num_gencost(1,1,igen_gmsl) = num_gencost(1,1,igen_gmsl)
     &        + 1. _d 0
c      print*,'igen_gmsl',igen_gmsl,
      ENDIF

cgf =======================================================
cgf PART 5: compute raw SLA cost term
cgf =======================================================

c time associated with this ndaysrec mean
        krec = irec + (nrecsave/2)

#ifdef ALLOW_AUTODIFF
        call active_read_xy( fname, etagcm, krec, doglobalread,
     &                       ladinit, eccoiter, myThid,
     &                       gencost_dummy(igen_etagcm) )
#else
        CALL READ_REC_XY_RL( fname, etagcm, kRec, 1, myThid )
#endif

        if (.NOT.useEtaMean)
     &  CALL REMOVE_MEAN_RL( 1, etagcm, maskInC, maskInC, rA, drF,
     &                       'etagcm', zeroRL, 1, myThid )

       do bj = jtlo,jthi
        do bi = itlo,ithi
         do j = jmin,jmax
          do i = imin,imax
              tpma(i,j,bi,bj) = 0. _d 0
              tpob(i,j,bi,bj) = 0. _d 0
              ersma(i,j,bi,bj) = 0. _d 0
              ersob(i,j,bi,bj) = 0. _d 0
              gfoma(i,j,bi,bj) = 0. _d 0
              gfoob(i,j,bi,bj) = 0. _d 0
          enddo
         enddo
        enddo
       enddo

        if (using_tpj)
     &  call cost_sla_read( tpfi, tpsta, tpper, use_mon,
     &                zeroRL, zeroRL,
     &                tpob, tpma,
     &                krec, myThid )
        if (using_ers)
     &  call cost_sla_read( ersfi, erssta, ersper, use_mon,
     &                zeroRL, zeroRL,
     &                ersob, ersma,
     &                krec, myThid )
        if (using_gfo)
     &  call cost_sla_read( gfofi, gfosta, gfoper, use_mon,
     &                zeroRL, zeroRL,
     &                gfoob, gfoma,
     &                krec, myThid )

       do bj = jtlo,jthi
        do bi = itlo,ithi
         do j = jmin,jmax
          do i = imin,imax
              anom_psMtpobs(i,j,bi,bj)  = 0. _d 0
              anom_psMersobs(i,j,bi,bj) = 0. _d 0
              anom_psMgfoobs(i,j,bi,bj) = 0. _d 0
              anom_tpobs(i,j,bi,bj)  = 0. _d 0
              anom_ersobs(i,j,bi,bj) = 0. _d 0
              anom_gfoobs(i,j,bi,bj) = 0. _d 0
          enddo
         enddo
        enddo
       enddo

       do bj = jtlo,jthi
        do bi = itlo,ithi
         do j = jmin,jmax
          do i = imin,imax
      if ( tpma(i,j,bi,bj)*mean_psMslaobs_MSK(i,j,bi,bj).NE.0. )
     & then
         anom_psMtpobs(i,j,bi,bj)=
     &       etagcm(i,j,bi,bj) - tpob(i,j,bi,bj)
     &       - mean_psMslaobs(i,j,bi,bj) - slaoffset
     &       - anom_psMslaobs(i,j,bi,bj)
         anom_tpobs(i,j,bi,bj)=tpob(i,j,bi,bj) - slaoffset
     &       - anom_slaobs(i,j,bi,bj)
      endif
      if ( ersma(i,j,bi,bj)*mean_psMslaobs_MSK(i,j,bi,bj).NE.0. )
     & then
         anom_psMersobs(i,j,bi,bj)=
     &       etagcm(i,j,bi,bj) - ersob(i,j,bi,bj)
     &       - mean_psMslaobs(i,j,bi,bj) - slaoffset
     &       - anom_psMslaobs(i,j,bi,bj)
         anom_ersobs(i,j,bi,bj)=ersob(i,j,bi,bj) - slaoffset
     &       - anom_slaobs(i,j,bi,bj)
      endif
      if ( gfoma(i,j,bi,bj)*mean_psMslaobs_MSK(i,j,bi,bj).NE.0. )
     & then
         anom_psMgfoobs(i,j,bi,bj)=
     &       etagcm(i,j,bi,bj) - gfoob(i,j,bi,bj)
     &       - mean_psMslaobs(i,j,bi,bj) - slaoffset
     &       - anom_psMslaobs(i,j,bi,bj)
         anom_gfoobs(i,j,bi,bj)=gfoob(i,j,bi,bj) - slaoffset
     &       - anom_slaobs(i,j,bi,bj)
      endif
          enddo
         enddo
        enddo
       enddo

      if ( igen_tp .GT. 0 ) then
       if (gencost_outputlevel(igen_tp).GT.0) then
        write(fname4test,'(1a)') 'sladiff_tp_raw'
        CALL WRITE_REC_3D_RL( fname4test, precFloat32, 1,
     &                        anom_psMtpobs, irec, 1, myThid )
        write(fname4test,'(1a)') 'slaobs_tp_raw'
        CALL WRITE_REC_3D_RL( fname4test, precFloat32, 1,
     &                        anom_tpobs, irec, 1, myThid )
       endif
      endif

      if ( igen_ers .GT. 0 ) then
       if (gencost_outputlevel(igen_ers).GT.0) then
        write(fname4test,'(1a)') 'sladiff_ers_raw'
        CALL WRITE_REC_3D_RL( fname4test, precFloat32, 1,
     &                        anom_psMersobs, irec, 1, myThid )
        write(fname4test,'(1a)') 'slaobs_ers_raw'
        CALL WRITE_REC_3D_RL( fname4test, precFloat32, 1,
     &                        anom_ersobs, irec, 1, myThid )
       endif
      endif

      if ( igen_gfo .GT. 0 ) then
       if (gencost_outputlevel(igen_gfo).GT.0) then
        write(fname4test,'(1a)') 'sladiff_gfo_raw'
        CALL WRITE_REC_3D_RL( fname4test, precFloat32, 1,
     &                        anom_psMgfoobs, irec, 1, myThid )
        write(fname4test,'(1a)') 'slaobs_gfo_raw'
        CALL WRITE_REC_3D_RL( fname4test, precFloat32, 1,
     &                        anom_gfoobs, irec, 1, myThid )
       endif
      endif
      if ( igen_tp .GT. 0 ) then
       do bj = jtlo,jthi
        do bi = itlo,ithi
         do j = jmin,jmax
          do i = imin,imax
c--             The array psobs contains SSH anomalies.
                junkweight = mean_psMslaobs_MSK(i,j,bi,bj)
     &                      *gencost_weight(i,j,bi,bj,igen_tp)
     &                      *tpma(i,j,bi,bj)
                junk = anom_psMtpobs(i,j,bi,bj)
                objf_gencost(bi,bj,igen_tp) =
     &              objf_gencost(bi,bj,igen_tp)+junk*junk*junkweight
                if ( junkweight .NE. 0. )
     &              num_gencost(bi,bj,igen_tp) =
     &              num_gencost(bi,bj,igen_tp) + 1. _d 0
          enddo
         enddo
        enddo
       enddo
      endif
      if ( igen_ers .GT. 0 ) then
       do bj = jtlo,jthi
        do bi = itlo,ithi
         do j = jmin,jmax
          do i = imin,imax
c--             The array ersobs contains SSH anomalies.
                junkweight = mean_psMslaobs_MSK(i,j,bi,bj)
     &                      *gencost_weight(i,j,bi,bj,igen_ers)
     &                      *ersma(i,j,bi,bj)
                junk = anom_psMersobs(i,j,bi,bj)
                objf_gencost(bi,bj,igen_ers) =
     &               objf_gencost(bi,bj,igen_ers)+junk*junk*junkweight
                if ( junkweight .NE. 0. )
     &              num_gencost(bi,bj,igen_ers) =
     &              num_gencost(bi,bj,igen_ers) + 1. _d 0
          enddo
         enddo
        enddo
       enddo
      endif
      if ( igen_gfo .GT. 0 ) then
       do bj = jtlo,jthi
        do bi = itlo,ithi
         do j = jmin,jmax
          do i = imin,imax
c--             The array gfoobs contains SSH anomalies.
                junkweight = mean_psMslaobs_MSK(i,j,bi,bj)
     &                      *gencost_weight(i,j,bi,bj,igen_gfo)
     &                      *gfoma(i,j,bi,bj)
                junk = anom_psMgfoobs(i,j,bi,bj)
                objf_gencost(bi,bj,igen_gfo) =
     &              objf_gencost(bi,bj,igen_gfo)+junk*junk*junkweight
                if ( junkweight .NE. 0. )
     &              num_gencost(bi,bj,igen_gfo) =
     &              num_gencost(bi,bj,igen_gfo) + 1. _d 0
          enddo
         enddo
        enddo
       enddo
      endif

      enddo !do irec = 1, nrec_total-nrecsave+1

#endif /* ifdef ALLOW_GENCOST_CONTRIBUTION */

      RETURN
      END

#include "CAL_OPTIONS.h"

      SUBROUTINE CAL_CHECKDATE(
     I                          date,
     O                          valid,
     O                          calerr,
     I                          myThid )

C     ==================================================================
C     SUBROUTINE cal_CheckDate
C     ==================================================================
C
C     o Check whether the array date conforms with the required format.
C
C     started: Christian Eckert eckert@mit.edu  30-Jun-1999
C     changed: Christian Eckert eckert@mit.edu  29-Dec-1999
C              - restructured the original version in order to have a
C                better interface to the MITgcmUV.
C              Christian Eckert eckert@mit.edu  03-Feb-2000
C              - Introduced new routine and function names, cal_<NAME>,
C                for verion 0.1.3.
C              21-Sep-2003: fixed check_sign logic to work with
C              negative intervals (menemenlis@jpl.nasa.gov)
C
C     ==================================================================
C     SUBROUTINE cal_CheckDate
C     ==================================================================

      IMPLICIT NONE

C     == global variables ==
#include "EEPARAMS.h"
#include "cal.h"

C     == routine arguments ==
      INTEGER date(4)
      LOGICAL valid
      INTEGER calerr
      INTEGER myThid

C     == local variables ==
C     msgBuf     :: Informational/error message buffer
      INTEGER yy, mm, dd
      INTEGER nsecs
      INTEGER lp,wd
      INTEGER hh, mn, ss
      INTEGER hhmmss
      LOGICAL wrong_sign
      CHARACTER*(MAX_LEN_MBUF) msgBuf
C     == end of interface ==

      valid  = .true.
      calerr = 0
c     wrong_sign = date(1)*date(2).lt.0
C     product above might go over integer*4 limit; better to check each one:
      wrong_sign = ( (date(1).LT.0) .AND. date(2).GT.0 )
     &        .OR. ( (date(1).GT.0) .AND. date(2).LT.0 )

      IF ( wrong_sign ) THEN
C         cal_CheckDate: Signs of first two components unequal
          calerr = 1803
C         invalid sign is fatal (since we need to check for valid month)
          valid = .FALSE.
      ELSEIF ( cal_setStatus .LT. 1 ) THEN
          WRITE( msgBuf,'(2A,4I9)')  'CAL_CHECKDATE:',
     &      ' date=',date(1),date(2),date(3),date(4)
          CALL PRINT_ERROR( msgBuf, myThid )
          WRITE( msgBuf,'(2A,I2,A)') 'CAL_CHECKDATE:',
     &      ' called too early (cal_setStatus=',cal_setStatus,' )'
          CALL PRINT_ERROR( msgBuf, myThid )
c         valid = .FALSE.

      ELSEIF ( date(4).LE.0 ) THEN
C--   date without weekday (date(4)= -1) and no LeapYear index (date(3)= 0)

        IF ( date(4).NE.-1 ) THEN
C         cal_CheckDate: Last component of array not valid
          calerr = 1801
        ELSEIF ( date(3).NE.0 ) THEN
C         cal_CheckDate: Third component of interval array not 0
          calerr = 1802
        ENDIF

      ELSE
C--   normal date with weekday (date(4)> 0) and LeapYear index (date(3)> 0)

        CALL CAL_CONVDATE( date, yy, mm, dd, nsecs, lp, wd, myThid )
        IF ( mm.EQ.0 .OR. ABS(mm).GT.nMonthYear ) THEN
          WRITE( msgBuf,'(2A,I10)') 'CAL_CHECKDATE:',
     &      ' Invalid month in date(1)=', date(1)
          CALL PRINT_ERROR( msgBuf, myThid )
C       invalid month is fatal (used as index in nDayMonth array)
          valid = .FALSE.
        ELSEIF ( wd.LT.1 .OR. wd.GT.7 ) THEN
C         cal_CheckDate: Weekday indentifier not correct
          calerr = 1805
C       invalid weekday is not safe (index in dayOfWeek, but just to print)
        ELSEIF ( lp.NE.1 .AND. lp.NE.2 ) then
C         cal_CheckDate: Leap year identifier not correct
          calerr = 1806
C       invalid leap-year index is fatal (used as index in nDayMonth array)
          valid = .FALSE.
        ELSEIF ( dd.EQ.0 .OR. ABS(dd).GT.nMaxDayMonth ) THEN
C-note: can refine above using Nb of days of the corresponding month:
c       ELSEIF ( dd.EQ.0 .OR. ABS(dd).GT.nDayMonth(mm,lp) ) THEN
          WRITE( msgBuf,'(2A,I10)') 'CAL_CHECKDATE:',
     &      ' Invalid day in date(1)=', date(1)
          CALL PRINT_ERROR( msgBuf, myThid )
        ELSEIF ( date(1).LT.refDate(1) ) THEN
C         cal_CheckDate: Calendar date before predef. reference date
          calerr = 1807
        ENDIF

      ENDIF

      IF ( valid .AND. cal_setStatus.GE.1 ) THEN
C--   check 2nd component (hhmmss=date(2)) and print warning
        hhmmss  = ABS(date(2))
        hh = hhmmss/10000
        mn = MOD(hhmmss/100,100)
        ss = MOD(hhmmss,100)
        IF ( ss.GE.secondsPerMinute ) THEN
          WRITE( msgBuf,'(2A,I10)') '** WARNING ** CAL_CHECKDATE:',
     &      ' Invalid Seconds in date(2)=', date(2)
          CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                        SQUEEZE_RIGHT, myThid )
        ENDIF
        IF ( mn.GE.minutesPerHour ) THEN
          WRITE( msgBuf,'(2A,I10)') '** WARNING ** CAL_CHECKDATE:',
     &      ' Invalid Minutes in date(2)=', date(2)
          CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                        SQUEEZE_RIGHT, myThid )
        ENDIF
        IF ( hh.GE.hoursPerDay ) THEN
          WRITE( msgBuf,'(2A,I10)') '** WARNING ** CAL_CHECKDATE:',
     &      ' Invalid  Hours  in date(2)=', date(2)
          CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                        SQUEEZE_RIGHT, myThid )
        ENDIF
      ENDIF

      RETURN
      END

#include "DIC_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: DIC_READ_PICKUP

C     !INTERFACE:
      SUBROUTINE DIC_READ_PICKUP( myIter, myThid )

C     !DESCRIPTION:
C     Reads current state of DIC from a pickup file

C     !USES:
      IMPLICIT NONE
C     == Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "DIC_VARS.h"

C     !INPUT PARAMETERS:
C     myIter      :: time-step number in simulation
C     myThid      :: my Thread Id number
      INTEGER myIter
      INTEGER myThid

#ifdef ALLOW_DIC
#ifdef DIC_BIOTIC
C     !FUNCTIONS:
      INTEGER  ILNBLNK
      EXTERNAL ILNBLNK

C     !LOCAL VARIABLES:
C     fn          :: character buffer for creating filename
C     fp          :: precision of pickup files
C     filePrec    :: pickup-file precision (read from meta file)
C     nbFields    :: number of fields in pickup file (read from meta file)
C     missFldList :: List of missing fields   (attempted to read but not found)
C     missFldDim  :: Dimension of missing fields list array: missFldList
C     nMissing    :: Number of missing fields (attempted to read but not found)
C     j           :: loop index
C     nj          :: record number
C     ioUnit      :: temp for writing msg unit
C     msgBuf      :: Informational/error message buffer
      INTEGER fp
      INTEGER filePrec, nbFields
      INTEGER missFldDim, nMissing
      INTEGER j, nj, ioUnit
      PARAMETER( missFldDim = 12 )
      CHARACTER*(10) suff
      CHARACTER*(MAX_LEN_FNAM) fn
      CHARACTER*(8) missFldList(missFldDim)
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      CHARACTER*(MAX_LEN_FNAM) tmpNam
C- note: to avoid beeing caught by tools/OAD_support/stop2print.sed,
C        change "stopFlag" to "StopFlag"
      LOGICAL useCurrentDir, fileExist, StopFlag
      INTEGER iL
CEOP

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

       IF ( pickupSuff.EQ.' ' ) THEN
        IF ( rwSuffixType.EQ.0 ) THEN
          WRITE(fn,'(A,I10.10)') 'pickup_dic.', myIter
        ELSE
          CALL RW_GET_SUFFIX( suff, startTime, myIter, myThid )
          WRITE(fn,'(A,A)') 'pickup_dic.', suff
        ENDIF
       ELSE
        WRITE(fn,'(A,A10)') 'pickup_dic.', pickupSuff
       ENDIF
       fp = precFloat64

       CALL READ_MFLDS_SET(
     I                      fn,
     O                      nbFields, filePrec,
     I                      Nr, myIter, myThid )
       _BEGIN_MASTER( myThid )
c      IF ( filePrec.NE.0 .AND. filePrec.NE.fp ) THEN
       IF ( nbFields.GE.0 .AND. filePrec.NE.fp ) THEN
         WRITE(msgBuf,'(2A,I4)') 'DIC_READ_PICKUP: ',
     &    'pickup-file binary precision do not match !'
         CALL PRINT_ERROR( msgBuf, myThid )
         WRITE(msgBuf,'(A,2(A,I4))') 'DIC_READ_PICKUP: ',
     &    'file prec.=', filePrec, ' but expecting prec.=', fp
         CALL PRINT_ERROR( msgBuf, myThid )
         CALL ALL_PROC_DIE( 0 )
         STOP 'ABNORMAL END: S/R DIC_READ_PICKUP (data-prec Pb)'
       ENDIF
       _END_MASTER( myThid )

       ioUnit = errorMessageUnit
       StopFlag = .FALSE.
       IF ( nbFields.LE.0 ) THEN
C-      No meta-file or old meta-file without List of Fields
        IF ( pickupStrictlyMatch ) THEN
         WRITE(msgBuf,'(4A)') 'DIC_READ_PICKUP: ',
     &      'no field-list found in meta-file',
     &      ' => cannot check for strick-matching'
         CALL PRINT_ERROR( msgBuf, myThid )
         WRITE(msgBuf,'(4A)') 'DIC_READ_PICKUP: ',
     &      'try with " pickupStrictlyMatch=.FALSE.,"',
     &      ' in file: "data", NameList: "PARM03"'
         CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
         StopFlag = .TRUE.
        ELSE
         WRITE(msgBuf,'(4A)') 'WARNING >> DIC_READ_PICKUP: ',
     &      ' no field-list found'
         CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
         IF ( nbFields.EQ.-1 ) THEN
C-      No meta-file: then check if binary pickup file (i.e., ".data") exist
#ifdef ALLOW_MDSIO
          useCurrentDir = .FALSE.
          CALL MDS_CHECK4FILE(
     I                     fn, '.data', 'DIC_READ_PICKUP',
     O                     tmpNam, fileExist,
     I                     useCurrentDir, myThid )
#else
          STOP 'ABNORMAL END: S/R DIC_READ_PICKUP: Needs MDSIO pkg'
#endif
          IF ( fileExist ) THEN
           WRITE(msgBuf,'(4A)') 'WARNING >> ',
     &      ' try to read pickup as currently written'
           CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
          ELSE
           iL = ILNBLNK(fn)
           WRITE(msgBuf,'(4A)') 'DIC_READ_PICKUP: ',
     &      'missing both "meta" & "data" files for "', fn(1:iL), '"'
           CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
           nbFields = -2
          ENDIF
         ELSE
C-      Old meta-file without List of Fields
c         WRITE(msgBuf,'(4A)') 'WARNING >> ',
c    &      ' try to read pickup as it used to be written'
c         CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
c         WRITE(msgBuf,'(4A)') 'WARNING >> ',
c    &      ' until checkpoint59l (2007 Dec 17)'
c         CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
          WRITE(msgBuf,'(4A)') 'DIC_READ_PICKUP: ',
     &      'no field-list found in meta-file'
          CALL PRINT_ERROR( msgBuf, myThid )
          StopFlag = .TRUE.
         ENDIF
        ENDIF
       ENDIF
       IF ( StopFlag ) THEN
         CALL ALL_PROC_DIE( myThid )
         STOP 'ABNORMAL END: S/R DIC_READ_PICKUP'
       ENDIF

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

       IF ( nbFields.EQ.0 ) THEN
C---   Old meta-file without List of Fields: use the old way to read pickup

       ELSEIF ( nbFields.NE.-2 ) THEN
C---   New way to read DIC pickup:
        nj = 0
C---    read DIC 3-D fields for restart
#ifdef DIC_CALCITE_SAT
        IF ( useCalciteSaturation ) THEN
         CALL READ_MFLDS_3D_RL( 'DIC_pH3d', pH3D,
     &                                nj, fp, Nr, myIter, myThid )
         _BEGIN_MASTER( myThid )
         pH_isLoaded(2) = .TRUE.
         _END_MASTER( myThid )
        ENDIF
#endif

C-    switch to 2-D fields:
        nj = nj*Nr
C---    read DIC 2-D fields for restart
        CALL READ_MFLDS_3D_RL( 'DIC_pH2d', pH,
     &                                 nj, fp, 1 , myIter, myThid )
        _BEGIN_MASTER( myThid )
        pH_isLoaded(1) = .TRUE.
        _END_MASTER( myThid )

C--    end: new way to read pickup file
       ENDIF

C--    Check for missing fields:
       nMissing = missFldDim
       CALL READ_MFLDS_CHECK(
     O                     missFldList,
     U                     nMissing,
     I                     myIter, myThid )
       IF ( nMissing.GT.missFldDim ) THEN
         WRITE(msgBuf,'(2A,I4)') 'DIC_READ_PICKUP: ',
     &     'missing fields list has been truncated to', missFldDim
         CALL PRINT_ERROR( msgBuf, myThid )
         CALL ALL_PROC_DIE( myThid )
         STOP 'ABNORMAL END: S/R DIC_READ_PICKUP (list-size Pb)'
       ENDIF
       IF ( nMissing.GE.1 ) THEN
        DO j=1,nMissing
         IF ( missFldList(nj) .EQ. 'DIC_pH2d' ) THEN
           _BEGIN_MASTER( myThid )
           pH_isLoaded(1) = .FALSE.
           _END_MASTER( myThid )
         ELSEIF ( missFldList(nj) .EQ. 'DIC_pH3d' ) THEN
           _BEGIN_MASTER( myThid )
           pH_isLoaded(2) = .FALSE.
           _END_MASTER( myThid )
         ELSE
          StopFlag = .TRUE.
          WRITE(msgBuf,'(4A)') 'DIC_READ_PICKUP: ',
     &       'cannot restart without field "',missFldList(nj),'"'
          CALL PRINT_ERROR( msgBuf, myThid )
         ENDIF
        ENDDO
        IF ( pickupStrictlyMatch .AND. .NOT.StopFlag ) THEN
          StopFlag = .TRUE.
          WRITE(msgBuf,'(4A)') 'DIC_READ_PICKUP: ',
     &      'try with " pickupStrictlyMatch=.FALSE.,"',
     &      ' in file: "data", NameList: "PARM03"'
          CALL PRINT_ERROR( msgBuf, myThid )
        ENDIF
       ENDIF
       IF ( StopFlag ) THEN
         CALL ALL_PROC_DIE( myThid )
         STOP 'ABNORMAL END: S/R DIC_READ_PICKUP'
       ENDIF

       _BEGIN_MASTER( myThid )
       IF ( .NOT.pH_isLoaded(1) ) THEN
         WRITE(msgBuf,'(2A)') 'WARNING >> DIC_READ_PICKUP: ',
     &      'will restart from approximated 2-D pH'
         CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
       ENDIF
       IF ( useCalciteSaturation .AND. .NOT.pH_isLoaded(2) ) THEN
         WRITE(msgBuf,'(2A)') 'WARNING >> DIC_READ_PICKUP: ',
     &      'will restart from approximated 3-D pH'
c        CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
       ENDIF
       _END_MASTER( myThid )

C--    Update overlap regions:
       CALL EXCH_XY_RL( pH, myThid )
#ifdef DIC_CALCITE_SAT
       IF ( useCalciteSaturation ) THEN
c        CALL EXCH_3D_RL( pH3D, Nr, myThid )
       ENDIF
#endif

#endif /* DIC_BIOTIC */
#endif /* ALLOW_DIC  */

      RETURN
      END

#include "ECCO_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: cost_genread
C     !INTERFACE:
      subroutine cost_genread(
     I                           active_var_file,
     O                           active_var,
     O                           active_tmp,
     I                           iRec,
     I                           nz,
     I                           nnzbar,
     I                           nrecloc,
     I                           preproc,
     I                           preproc_c,
     I                           preproc_i,
     I                           preproc_r,
     I                           dummy,
     I                           myThid )

C     !DESCRIPTION: \bv
C     reads and pre-processes bar file records
C     \ev

C     !USES:
      IMPLICIT NONE

C     == Global variables ==
#include "EEPARAMS.h"
#include "SIZE.h"
#ifdef ALLOW_ECCO
# include "ECCO_SIZE.h"
# include "ECCO.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     myThid:          thread number for this instance
      CHARACTER*(*) active_var_file
      _RL     active_var(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nz,nSx,nSy)
      _RL     active_tmp(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nz,nSx,nSy)
      INTEGER iRec
      INTEGER nz, nnzbar, nrecloc
      CHARACTER*(MAX_LEN_FNAM) preproc(NGENPPROC)
      CHARACTER*(MAX_LEN_FNAM) preproc_c(NGENPPROC)
      INTEGER preproc_i(NGENPPROC)
      _RL     preproc_r(NGENPPROC)
      _RL     dummy
      INTEGER myThid

#ifdef ALLOW_ECCO
C     !LOCAL VARIABLES:
C     == Local variables ==
      INTEGER nyearsINT
      _RL     recip_nyearsRL
      INTEGER iyear, imon
      INTEGER i,j,k,bi,bj
CEOP

      IF ( preproc(1) .EQ. 'clim') THEN

c--   Loop over month
       nyearsINT=int((nrecloc-irec)/preproc_i(1))+1
       recip_nyearsRL = nyearsINT
       recip_nyearsRL = 1. _d 0/recip_nyearsRL

       CALL ECCO_ZERO( active_var, nz, zeroRL, myThid )
       CALL ECCO_ZERO( active_tmp, nz, zeroRL, myThid )
       DO iyear=1,nyearsINT
        imon=irec+(iyear-1)*preproc_i(1)
        CALL ECCO_READBAR( active_var_file, active_var,
     &       imon, nz, nnzbar, dummy, myThid )
        DO bj = myByLo(myThid),myByHi(myThid)
         DO bi = myBxLo(myThid),myBxHi(myThid)
          DO k = 1,nnzbar
           DO j = 1-OLy,sNy+OLy
            DO i = 1-OLx,sNx+OLx
             active_tmp(i,j,k,bi,bj) = active_tmp(i,j,k,bi,bj)
     &            + active_var(i,j,k,bi,bj)
            ENDDO
           ENDDO
          ENDDO
         ENDDO
        ENDDO
       ENDDO

       DO bj = myByLo(myThid),myByHi(myThid)
        DO bi = myBxLo(myThid),myBxHi(myThid)
         DO k = 1,nnzbar
          DO j = 1-OLy,sNy+OLy
           DO i = 1-OLx,sNx+OLx
            active_var(i,j,k,bi,bj) = active_tmp(i,j,k,bi,bj)
     &           * recip_nyearsRL
           ENDDO
          ENDDO
         ENDDO
        ENDDO
       ENDDO
      ELSE
       CALL ECCO_READBAR( active_var_file, active_var,
     &      irec, nz, nnzbar, dummy, myThid )
      ENDIF

#endif /* ALLOW_ECCO */

      RETURN
      END

C     ECCO_CPPOPTIONS used to affect maxcvars and defined ALLOW_OBCS?_CONTROL
C#include "ECCO_CPPOPTIONS.h"
C     now:
C     CTRL_OPTIONS affects maxcvars and may define ALLOW_OBCS?_CONTROL
#include "CTRL_OPTIONS.h"

      subroutine optim_writedata(
     I                       nn,
     I                       dfile,
     I                       printlists,
     I                       ff,
     I                       vv
     &                     )

c     ==================================================================
c     SUBROUTINE optim_writedata
c     ==================================================================
c
c     o Writes the latest update of the control vector to file(s). These
c       files can then be used by the MITgcmUV state estimation setup
c       for the next forward/adjoint simluation.
c
c     started: Christian Eckert eckert@mit.edu 12-Apr-2000
c
c     changed:  Patrick Heimbach heimbach@mit.edu 19-Jun-2000
c               - finished, revised and debugged
c
c     ==================================================================
c     SUBROUTINE optim_writedata
c     ==================================================================

      IMPLICIT NONE

c     == global variables ==

#include "EEPARAMS.h"
#include "SIZE.h"
#include "CTRL_SIZE.h"
#ifdef ALLOW_OBCS_CONTROL
# include "CTRL_OBCS.h"
#endif
#include "CTRL.h"
#include "optim.h"

c     == routine arguments ==

      integer nn
      _RL     ff
      _RL     vv(nn)

      character*(9) dfile
      logical printlists

c     == local variables ==

      integer i,j,k
      integer ii
CML      integer bi,bj
      integer biG,bjG
      integer nopt
      integer icvcomp
      integer icvoffset
      integer icvrec
      integer ivar
      integer funit
      integer cbuffindex

      real*4 cbuff( sNx*nSx*nPx*sNy*nSy*nPy )

      character*(128) fname
      character*(18)  prefix
      parameter ( prefix =  " OPTIM_WRITEDATA: " )
cgg(
      _RL     gg
      integer igg
      integer iobcs
cgg)

c     == end of interface ==

c--   I/O unit to use.
      funit = 20

c--   Next optimization cycle.
      nopt = optimcycle + 1

      if ( dfile .eq. ctrlname ) then
       print*
       print*,' OPTIM_WRITEDATA: Writing new control vector to file(s)'
       print*,'                  for optimization cycle: ',nopt
       print*
      else
       print*
       print*,' OPTIM_WRITEDATA: subroutine called by a false *dfile*'
       print*,'                  argument. *dfile* = ',dfile
       print*
       stop   '  ...  stopped in OPTIM_WRITEDATA.'
      endif

      bjG = 1 + (myYGlobalLo - 1)/sNy
      biG = 1 + (myXGlobalLo - 1)/sNx

c--         Generate file name and open the file.
      write(fname(1:128),'(4a,i4.4)')
     &     dfile,'_',yctrlid(1:10),'.opt', nopt
      open( funit, file   = fname,
     &     status = 'new',
     &     form   = 'unformatted',
     &     access = 'sequential'   )

      print *, prefix, 'nvartype   ', nvartype
      print *, prefix, 'nvarlength ', nvarlength
      print *, prefix, 'yctrlid    ', yctrlid
      print *, prefix, 'nopt       ', nopt
      print *, prefix, 'ff         ', ff
      print *, prefix, 'iG         ', biG
      print *, prefix, 'jG         ', bjG
      print *, prefix, 'nSx        ', nSx
      print *, prefix, 'nSy        ', nSy

      if ( printlists ) then
       print *, prefix, 'nWetcGlobal ', (nWetcGlobal(k), k=1,Nr)
       print *, prefix, 'nWetsGlobal ', (nWetsGlobal(k), k=1,Nr)
       print *, prefix, 'nWetwGlobal ', (nWetwGlobal(k), k=1,Nr)
c      print *, prefix, 'nWetvGlobal ', (nWetvGlobal(k), k=1,Nr)
       print *, prefix, 'ncvarindex ',  (ncvarindex(i), i=1,maxcvars)
       print *, prefix, 'ncvarrecs ',   (ncvarrecs(i),  i=1,maxcvars)
       print *, prefix, 'ncvarxmax ',   (ncvarxmax(i),  i=1,maxcvars)
       print *, prefix, 'ncvarymax ',   (ncvarymax(i),  i=1,maxcvars)
       print *, prefix, 'ncvarnrmax ',  (ncvarnrmax(i), i=1,maxcvars)
       print *, prefix, 'ncvargrd ',    (ncvargrd(i),   i=1,maxcvars)
      endif

c--   Write the header.
      write( funit ) nvartype
      write( funit ) nvarlength
      write( funit ) yctrlid
      write( funit ) optimcycle
      write( funit ) ff
      write( funit ) big
      write( funit ) bjg
      write( funit ) nSx
      write( funit ) nSy
      write( funit ) (nWetcGlobal(k), k=1,Nr)
      write( funit ) (nWetsGlobal(k), k=1,Nr)
      write( funit ) (nWetwGlobal(k), k=1,Nr)
c#ifdef ALLOW_CTRL_WETV
c     write( funit ) (nWetvGlobal(k), k=1,Nr)
c#endif
#ifdef ALLOW_SHELFICE
      write(funit) (nWetiGlobal(k),   k=1,Nr)
c     write(funit) nWetiGlobal(1)
#endif

c     Add OBCS Mask information into the header section for optimization.
#ifdef ALLOW_OBCSN_CONTROL
      write(funit) ((nWetobcsnGlo(k,iobcs), k=1,Nr),iobcs= 1,nobcs)
#endif
#ifdef ALLOW_OBCSS_CONTROL
      write(funit) ((nWetobcssGlo(k,iobcs), k=1,Nr),iobcs= 1,nobcs)
#endif
#ifdef ALLOW_OBCSW_CONTROL
      write(funit) ((nWetobcswGlo(k,iobcs), k=1,Nr),iobcs= 1,nobcs)
#endif
#ifdef ALLOW_OBCSE_CONTROL
      write(funit) ((nWetobcseGlo(k,iobcs), k=1,Nr),iobcs= 1,nobcs)
#endif

      write( funit ) (ncvarindex(ivar), ivar=1,nvartype)
      write( funit ) (ncvarrecs(ivar),  ivar=1,nvartype)
      write( funit ) (ncvarxmax(ivar),  ivar=1,nvartype)
      write( funit ) (ncvarymax(ivar),  ivar=1,nvartype)
      write( funit ) (ncvarnrmax(ivar), ivar=1,nvartype)
      write( funit ) (ncvargrd(ivar),   ivar=1,nvartype)
      write( funit ) (ncvartype(ivar),  ivar=1,nvartype)

c--         Write the data.
      icvoffset = 0
c     do ivar = 1,maxcvars
      do ivar = 1,nvartype
       if ( ncvarindex(ivar) .ne. -1 ) then
        do icvrec = 1,ncvarrecs(ivar)
cph         do bj = 1,nsy
cph          do bi = 1,nsx
         write( funit ) ncvarindex(ivar)
CML         write( funit ) bi
CML         write( funit ) bj
         write( funit ) nSx
         write( funit ) nSy
         do k = 1,ncvarnrmax(ivar)
          cbuffindex = 0
          if (ncvargrd(ivar) .eq. 'c') then
           cbuffindex = nWetcGlobal(k)
          else if (ncvargrd(ivar) .eq. 's') then
           cbuffindex = nWetsGlobal(k)
          else if (ncvargrd(ivar) .eq. 'w') then
           cbuffindex = nWetwGlobal(k)
c         else if (ncvargrd(ivar) .eq. 'v') then
c          cbuffindex = nWetvGlobal(k)
#ifdef ALLOW_SHELFICE
          else if (ncvargrd(ivar) .eq. 'i') then
           cbuffindex = nWetiGlobal(k)
#endif
#ifdef ALLOW_OBCS_CONTROL
c     O.B. points have the grid mask "m".
          else if (ncvargrd(ivar) .eq. 'm') then
c     From "icvrec", calculate what iobcs must be.
           gg   = (icvrec-1)/nobcs
           igg  = int(gg)
           iobcs= icvrec - igg*nobcs
# ifdef ALLOW_OBCSN_CONTROL
           if (ncvarindex(ivar).eq.1) cbuffindex=nWetobcsnGlo(k,iobcs)
# endif
# ifdef ALLOW_OBCSS_CONTROL
           if (ncvarindex(ivar).eq.2) cbuffindex=nWetobcssGlo(k,iobcs)
# endif
# ifdef ALLOW_OBCSE_CONTROL
           if (ncvarindex(ivar).eq.3) cbuffindex=nWetobcseGlo(k,iobcs)
# endif
# ifdef ALLOW_OBCSW_CONTROL
           if (ncvarindex(ivar).eq.4) cbuffindex=nWetobcswGlo(k,iobcs)
# endif
#endif /* ALLOW_OBCS_CONTROL */
          endif
          if (cbuffindex .gt. 0) then
           do icvcomp = 1,cbuffindex
            cbuff(icvcomp) = vv(icvoffset + icvcomp)
c     If you want to optimize with respect to just O.B. T and S
c     uncomment the next two lines.
c           if (iobcs .eq. 3) cbuff(icvcomp)=0.
c           if (iobcs .eq. 4) cbuff(icvcomp)=0.
           enddo
           write( funit ) cbuffindex
           write( funit ) k
           write( funit ) (cbuff(ii), ii=1,cbuffindex)
           icvoffset = icvoffset + cbuffindex
          endif
         enddo
cph                  enddo
cph               enddo
        enddo
       endif
      enddo

      close( funit )

      print *, prefix, 'end of optim_writedata, icvoffset ', icvoffset
      print *, ' '

      return
      end

#     include "GAD_OPTIONS.h"

      SUBROUTINE GAD_PPM_P3E_X(bi,bj,kk,iy,
     &           mask,fbar,edge,myThid)
C     |================================================================|
C     | PPM_P3E_X: approximate edge values with degree-3 polynomials.  |
C     | Fixed grid-spacing variant in X.                               |
C     |================================================================|

          implicit none

C     =============================================== global variables
#         include "SIZE.h"
#         include "GRID.h"
#         include "GAD.h"

C     ====================================================== arguments
          integer bi,bj,kk,iy
          _RL mask(1-OLx:sNx+OLx)
          _RL fbar(1-OLx:sNx+OLx)
          _RL edge(1-OLx:sNx+OLx)
          integer myThid

C     ====================================================== variables
          integer ix
          _RL mloc(-2:+1)
          _RL floc(-2:+1)
          _RL ftmp

          do  ix = 1-OLx+2, sNx+OLx-1

C     ================ mask local stencil: expand from centre outwards
              mloc(-1) = mask(ix-1)
              mloc(+0) = mask(ix+0)

              floc(-1) = fbar(ix+0)
     &          + mloc(-1)*(fbar(ix-1)-fbar(ix+0))
              floc(+0) = fbar(ix-1)
     &          + mloc(+0)*(fbar(ix+0)-fbar(ix-1))

              mloc(-2) = mask(ix-2) * mloc(-1)

              ftmp = 2. _d 0 * floc(-1) - floc(+0)
              floc(-2) = ftmp
     &          + mloc(-2)*(fbar(ix-2)-ftmp)

              mloc(+1) = mask(ix+1) * mloc(+0)

              ftmp = 2. _d 0 * floc(+0) - floc(-1)
              floc(+1) = ftmp
     &          + mloc(+1)*(fbar(ix+1)-ftmp)

C     ================ centred, 3rd-order interpolation for edge value
              edge(ix) =
     &      -(1. _d 0 / 12. _d 0)*(floc(-2)+floc(+1))
     &      +(7. _d 0 / 12. _d 0)*(floc(-1)+floc(+0))

          end do

          return

c     end subroutine GAD_PPM_P3E_X
      end

#include "CPP_OPTIONS.h"

CBOP
C     !ROUTINE: TRACERS_CORRECTION_IIGW
C     !INTERFACE:
      SUBROUTINE TRACERS_IIGW_CORRECTION(
     I                   bi, bj, myTime, myIter, myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R TRACERS_IIGW_CORRECTION
C     | o apply correction term to Tracers due to Implicit
C     |   treatment of Internal Gravity Waves:
C-    |    -DeltaT.(w^{n+1}-w^{n})*d.Tr_{ref}/dz
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "DYNVARS.h"
#ifdef ALLOW_NONHYDROSTATIC
#include "NH_VARS.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine Arguments ==
C     bi,bj   :: tile indices
C     myTime  :: current time in simulation
C     myIter  :: current iteration number in simulation
C     myThid  :: my Thread Id number
      INTEGER bi,bj
      _RL     myTime
      INTEGER myIter
      INTEGER myThid

#ifdef ALLOW_NONHYDROSTATIC
C     !LOCAL VARIABLES:
C     == Local variables ==
C     i,j,k           :: Loop counters
      INTEGER i,j,k
      INTEGER kp1
      _RL     dTr_k, dTrp1
      _RL     dW_k(1-Olx:sNx+Olx,1-Oly:sNy+Oly)
      _RL     dWp1(1-Olx:sNx+Olx,1-Oly:sNy+Oly)
CEOP

C-    Initialise dW = w^{n+1} - w^{n} to zero:
      DO j=1-Oly,sNy+Oly
        DO i=1-Olx,sNx+Olx
          dWp1(i,j) = 0. _d 0
        ENDDO
      ENDDO

C--   Start vertical loop
      DO k=1,Nr

C-    Compute dW @ interface k & k+1
       kp1 = MIN(k+1,Nr)
       DO j=1-Oly,sNy+Oly
        DO i=1-Olx,sNx+Olx
          dW_k(i,j) = dWp1(i,j)
          dWp1(i,j) = ( wVel(i,j,kp1,bi,bj)
     &                  - gW(i,j,kp1,bi,bj) )*maskC(i,j,k,bi,bj)
        ENDDO
       ENDDO

C-     Add Impl.IGW correction to Pot.Temperature:
       dTr_k = 0. _d 0
       IF ( k.GT.1 ) dTr_k = (tRef(k) - tRef(k-1))*rkSign
       dTrp1 = (tRef(kp1) - tRef(k))*rkSign
       IF ( tempAdvection .AND.
     &     (dTr_k.NE.0. _d 0 .OR. dTrp1.NE.0. _d 0) ) THEN
         DO j=1-Oly,sNy+Oly
          DO i=1-Olx,sNx+Olx
          theta(i,j,k,bi,bj) = theta(i,j,k,bi,bj)
     &       -dTtracerLev(k)*0.5 _d 0
     &                      *( dTr_k*dW_k(i,j) + dTrp1*dWp1(i,j) )
     &                      *recip_drF(k)*_recip_hFacC(i,j,k,bi,bj)
          ENDDO
         ENDDO
       ENDIF

C-     Add Impl.IGW correction to Salinity/Water vapor:
       dTr_k = 0. _d 0
       IF ( k.GT.1 ) dTr_k = (sRef(k) - sRef(k-1))*rkSign
       dTrp1 = (sRef(kp1) - sRef(k))*rkSign
       IF ( saltAdvection .AND.
     &     (dTr_k.NE.0. _d 0 .OR. dTrp1.NE.0. _d 0) ) THEN
         DO j=1-Oly,sNy+Oly
          DO i=1-Olx,sNx+Olx
            salt(i,j,k,bi,bj) = salt(i,j,k,bi,bj)
     &       -dTtracerLev(k)*0.5 _d 0
     &                      *( dTr_k*dW_k(i,j) + dTrp1*dWp1(i,j) )
     &                      *recip_drF(k)*_recip_hFacC(i,j,k,bi,bj)
          ENDDO
         ENDDO
       ENDIF

C-    End of k loop
      ENDDO

#endif /* ALLOW_NONHYDROSTATIC */

      RETURN
      END

#include "ADMTLM_OPTIONS.h"

      subroutine admtlm_metric( myThid )
C     /==========================================================\
C     | subroutine admtlm_metric                                 |
C     | o This routine assigns final T,S to cost function        |
C     \==========================================================/
       implicit none

C     == Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "DYNVARS.h"
#ifdef ALLOW_ADMTLM
# include "cost.h"
# include "g_cost.h"
# include "OPTIMCYCLE.h"
#endif

C     ======== Routine arguments ======================
C     myThid - Thread number for this instance of the routine.
      integer myThid

#ifdef ALLOW_ADMTLM
C     ========= Local variables =========================
      integer i, j, k
      integer bi, bj
      _RL myMetric
      _RL stdDevSST
      _RL stdDevSSS
      _RL stdDevtheta
      _RL stdDevsalt
      _RL stdDevuvel
      _RL stdDevvvel
      _RL stdDevetan

      myMetric  = 0. _d 0
      stdDevSST = 0.52 _d 0
      stdDevSSS = 0.134 _d 0
      stdDevtheta = 1.
      stdDevsalt  = 1.
      stdDevuvel  = 1.
      stdDevvvel  = 1.
      stdDevetan  = 1.

      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        DO j=1,sNy
         DO i=1,sNx
          DO k=1,Nr
           myMetric = myMetric
     &      + g_objf_state_final(i,j,bi,bj,k+0*Nr)**2/stdDevtheta**2
     &      + g_objf_state_final(i,j,bi,bj,k+1*Nr)**2/stdDevsalt**2
     &      + g_objf_state_final(i,j,bi,bj,k+2*Nr)**2/stdDevuvel**2
     &      + g_objf_state_final(i,j,bi,bj,k+3*Nr)**2/stdDevvvel**2
          END DO
           myMetric = myMetric
     &      + g_objf_state_final(i,j,bi,bj,1+4*Nr)**2/stdDevetan**2
         END DO
        END DO
       END DO
      END DO

      _GLOBAL_SUM_RL( myMetric , myThid )
      myMetric = myMetric/(nx*ny*(4*Nr+1))

cph(
      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        DO j=1,sNy
         DO i=1,sNx
c            print '(a,2I4,2(x,F15.9))', 'ph-metric T ', i, j,
c     &           g_objf_state_final(i,j,bi,bj,1),
c     &           g_objf_state_final(i,j,bi,bj,1)**2 / stdDevSST**2
c            print '(a,2I4,2(x,F15.9))', 'ph-metric S ', i, j,
c     &           g_objf_state_final(i,j,bi,bj,2),
c     &           g_objf_state_final(i,j,bi,bj,2)**2 / stdDevSSS**2
          END DO
        END DO
       END DO
      END DO

      print *, 'ph-admtlm myMetric = ', optimcycle, myMetric

cph)

#endif

      end

#include "THSICE_OPTIONS.h"

C     !ROUTINE: THSICE_IMPL_TEMP
C     !INTERFACE:
      SUBROUTINE THSICE_IMPL_TEMP(
     I                netSW, sFlx,
     O                dTsurf,
     I                bi, bj, myTime, myIter, myThid)
C     *==========================================================*
C     | S/R  THSICE_IMPL_TEMP
C     | o Calculate sea-ice and surface temp. implicitly
C     *==========================================================*
C     | o return surface fluxes for atmosphere boundary layer
C     |  physics (and therefore called within atmospheric physics)
C     *==========================================================*

C     !USES:
      IMPLICIT NONE
C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "FFIELDS.h"
#include "THSICE_SIZE.h"
#include "THSICE_PARAMS.h"
#include "THSICE_VARS.h"
      INTEGER siLo, siHi, sjLo, sjHi
      PARAMETER ( siLo = 1-OLx , siHi = sNx+OLx )
      PARAMETER ( sjLo = 1-OLy , sjHi = sNy+OLy )

C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
C     netSW   :: net Short Wave surf. flux (+=down) [W/m2]
C     sFlx    :: surf. heat flux (+=down) except SW, function of surf. temp Ts:
C                0: Flx(Ts=0) ; 1: Flx(Ts=Ts^n) ; 2: d.Flx/dTs(Ts=Ts^n)
C     dTsurf  :: surf. temp adjusment: Ts^n+1 - Ts^n
C     bi,bj   :: Tile index
C     myIter  :: iteration counter for this thread
C     myTime  :: time counter for this thread
C     myThid  :: thread number for this instance of the routine.
      _RL netSW  (sNx,sNy)
      _RL sFlx   (sNx,sNy,0:2)
      _RL dTsurf (sNx,sNy)
      INTEGER bi,bj
      _RL  myTime
      INTEGER myIter
      INTEGER myThid

#ifdef ALLOW_THSICE
C     !LOCAL VARIABLES:
C     === Local variables ===
C     tFrzOce  :: sea-water freezing temperature [oC] (function of S)
C     dTsrf    :: surf. temp adjusment: Ts^n+1 - Ts^n
      INTEGER i,j
      INTEGER iMin, iMax
      INTEGER jMin, jMax
      _RL tFrzOce(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
c     _RL dTsrf  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      LOGICAL dBugFlag

C-    define grid-point location where to print debugging values
#include "THSICE_DEBUG.h"

 1010 FORMAT(A,1P4E14.6)

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      iMin = 1
      iMax = sNx
      jMin = 1
      jMax = sNy
      dBugFlag = debugLevel.GE.debLevC

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C    part.1 : ice-covered fraction ;
C     Solve for surface and ice temperature (implicitly) ; compute surf. fluxes
C-------
      DO j = jMin, jMax
       DO i = iMin, iMax
        icFlxSW(i,j,bi,bj) = netSW(i,j)
        IF (iceMask(i,j,bi,bj).GT.0. _d 0) THEN
          tFrzOce(i,j) = -mu_Tf*sOceMxL(i,j,bi,bj)
#ifdef ALLOW_DBUG_THSICE
          IF ( dBug(i,j,bi,bj) ) THEN
           WRITE(6,'(A,2I4,2I2)') 'ThSI_IMPL_T: i,j=',i,j,bi,bj
           WRITE(6,1010) 'ThSI_IMPL_T:-0- iceMask,hIc,hSn,Tsf=',
     &                   iceMask(i,j,bi,bj), iceHeight(i,j,bi,bj),
     &                   snowHeight(i,j,bi,bj), Tsrf(i,j,bi,bj)
           WRITE(6,1010) 'ThSI_IMPL_T:-0- Tice(1,2),Qice(1,2)=',
     &           Tice1(i,j,bi,bj), Tice2(i,j,bi,bj),
     &           Qice1(i,j,bi,bj), Qice2(i,j,bi,bj)
          ENDIF
#endif
        ENDIF
       ENDDO
      ENDDO

      CALL THSICE_SOLVE4TEMP(
     I          bi, bj,
     I          iMin,iMax, jMin,jMax, dBugFlag, .FALSE.,.FALSE.,
     I          iceMask(siLo,sjLo,bi,bj), iceHeight(siLo,sjLo,bi,bj),
     I          snowHeight(siLo,sjLo,bi,bj), tFrzOce, sFlx,
     U          icFlxSW(siLo,sjLo,bi,bj), Tsrf(siLo,sjLo,bi,bj),
     U          Qice1(siLo,sjLo,bi,bj), Qice2(siLo,sjLo,bi,bj),
     O          Tice1(siLo,sjLo,bi,bj), Tice2(siLo,sjLo,bi,bj), dTsurf,
     O          sHeating(siLo,sjLo,bi,bj), flxCndBt(siLo,sjLo,bi,bj),
     O          icFlxAtm(siLo,sjLo,bi,bj), icFrwAtm(siLo,sjLo,bi,bj),
     I          myTime, myIter, myThid )

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
#endif /* ALLOW_THSICE */

      RETURN
      END

#include "DIC_OPTIONS.h"
#include "PTRACERS_OPTIONS.h"

CBOP
C !ROUTINE: DIC_SURFFORCING_INIT

C !INTERFACE: ==========================================================
      SUBROUTINE DIC_SURFFORCING_INIT(
     I          myThid )

C !DESCRIPTION:
C  Calculate first guess of pH

C !USES: ===============================================================
      IMPLICIT NONE
#include "SIZE.h"
#include "DYNVARS.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "FFIELDS.h"
#include "DIC_VARS.h"
#include "PTRACERS_SIZE.h"
#include "PTRACERS_PARAMS.h"
#include "PTRACERS_FIELDS.h"

C !INPUT PARAMETERS: ===================================================
C  myThid               :: thread number
      INTEGER  myThid

#ifdef ALLOW_DIC

C !LOCAL VARIABLES: ====================================================
      INTEGER i,j, kLev, it
      INTEGER iMin,iMax,jMin,jMax, bi, bj
       _RL co3dummy
C local variables for carbon chem
      _RL surfalk(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL surfphos(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL surfsi(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL surftemp(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL surfsalt(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL surfdic(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER iprt,jprt
      LOGICAL debugPrt
#ifdef ALLOW_DEBUG
C     msgBuf     :: Informational/error message buffer
      CHARACTER*(MAX_LEN_MBUF) msgBuf
#endif
CEOP

C =================================================================

      kLev = 1
      jMin=1
      jMax=sNy
      iMin=1
      iMax=sNx

C Solubility relation coefficients
      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          ak0(i,j,bi,bj)=0. _d 0
          ak1(i,j,bi,bj)=0. _d 0
          ak2(i,j,bi,bj)=0. _d 0
          akw(i,j,bi,bj)=0. _d 0
          akb(i,j,bi,bj)=0. _d 0
          akf(i,j,bi,bj)=0. _d 0
          ak1p(i,j,bi,bj)=0. _d 0
          ak2p(i,j,bi,bj)=0. _d 0
          ak3p(i,j,bi,bj)=0. _d 0
          aksi(i,j,bi,bj)=0. _d 0
          fugf(i,j,bi,bj)=0. _d 0
          ff(i,j,bi,bj)=0. _d 0
          ft(i,j,bi,bj)=0. _d 0
          st(i,j,bi,bj)=0. _d 0
          bt(i,j,bi,bj)=0. _d 0
         ENDDO
        ENDDO
       ENDDO
      ENDDO

      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)

C determine inorganic carbon chem coefficients
        DO j=jMin,jMax
         DO i=iMin,iMax
#ifdef DIC_BIOTIC
#ifdef DIC_BOUNDS
            surfalk(i,j)  = MAX( 0.4 _d 0,
     &                      MIN( 10. _d 0, PTRACER(i,j,kLev,bi,bj,2) ) )
     &                    * maskC(i,j,kLev,bi,bj)
            surfphos(i,j) = MAX( 1.0 _d -11,
     &                      MIN( 1. _d -1, PTRACER(i,j,kLev,bi,bj,3) ) )
     &                    * maskC(i,j,kLev,bi,bj)
#else
            surfalk(i,j)  = PTRACER(i,j,kLev,bi,bj,2)
     &                    * maskC(i,j,kLev,bi,bj)
            surfphos(i,j) = PTRACER(i,j,kLev,bi,bj,3)
     &                    * maskC(i,j,kLev,bi,bj)
#endif
#else /* DIC_BIOTIC */
            surfalk(i,j)  = 2.366595 _d 0 *salt(i,j,kLev,bi,bj)/35. _d 0
     &                    * maskC(i,j,kLev,bi,bj)
            surfphos(i,j) = 5.1225 _d -4 * maskC(i,j,kLev,bi,bj)
#endif /* DIC_BIOTIC */
C for non-interactive Si
            surfsi(i,j)   = silicaSurf(i,j,bi,bj)*maskC(i,j,kLev,bi,bj)
#ifdef DIC_BOUNDS
            surftemp(i,j) = MAX( -4. _d 0,
     &                      MIN( 50. _d 0, theta(i,j,kLev,bi,bj) ) )
            surfsalt(i,j) = MAX( 4. _d 0,
     &                      MIN( 50. _d 0, salt(i,j,kLev,bi,bj) ) )
            surfdic(i,j)  = MAX( 0.4 _d 0,
     &                      MIN( 10. _d 0, PTRACER(i,j,kLev,bi,bj,1) ) )
#else
            surftemp(i,j) = theta(i,j,kLev,bi,bj)
            surfsalt(i,j) = salt(i,j,kLev,bi,bj)
            surfdic(i,j)  = PTRACER(i,j,kLev,bi,bj,1)
     &                    * maskC(i,j,kLev,bi,bj)
#endif
         ENDDO
        ENDDO

#ifdef CARBONCHEM_SOLVESAPHE
#ifdef ALLOW_DEBUG
        IF (debugMode) CALL DEBUG_CALL('DIC_COEFFS_SURF',myThid)
#endif
        CALL DIC_COEFFS_SURF(
     I                       surftemp,surfsalt,
     I                       bi,bj,iMin,iMax,jMin,jMax,myThid)
#else /* CARBONCHEM_SOLVESAPHE */
#ifdef ALLOW_DEBUG
        IF (debugMode) CALL DEBUG_CALL('CARBON_COEFFS',myThid)
#endif
        CALL CARBON_COEFFS(
     I                       surftemp,surfsalt,
     I                       bi,bj,iMin,iMax,jMin,jMax,myThid)

#endif /* CARBONCHEM_SOLVESAPHE */

C====================================================================

        IF ( .NOT.pH_isLoaded(1) ) THEN
C set guess of 2-d surface pH for first step here
#ifdef ALLOW_DEBUG
          IF (debugMode) THEN
            WRITE(msgBuf,'(A)') 'Initial pCO2 approximation method'
            CALL DEBUG_MSG(msgBuf(1:33),myThid)
          ENDIF
#endif

          debugPrt = debugMode
C first approximation
C$TAF LOOP = parallel
          DO j=jMin,jMax
C$TAF LOOP = parallel
           DO i=iMin,iMax
            IF ( maskC(i,j,kLev,bi,bj) .NE. 0. _d 0) THEN
C$TAF init dic_surf = static, 10
#ifdef CARBONCHEM_SOLVESAPHE
             IF ( selectPHsolver.GT.0 ) THEN
C Use Munhoven (2013) Solvesaphe routine to initialize pH
#ifdef ALLOW_DEBUG
              IF (debugPrt) CALL DEBUG_CALL('AHINI_FOR_AT',myThid)
#endif
C call AHINI_FOR_AT to get better initial guess of pH
              CALL AHINI_FOR_AT(
     I           surfalk(i,j)*permil,
     I           surfdic(i,j)*permil,
     I           bt(i,j,bi,bj),
     U           pH(i,j,bi,bj),
     I           i,j,kLev,bi,bj,nIter0,myThid )

C$TAF STORE pH(i,j,bi,bj)                              = dic_surf
C$TAF STORE surfalk(i,j), surfphos(i,j), surfsi(i,j)   = dic_surf

#ifdef ALLOW_DEBUG
              IF (debugPrt)
     &          CALL DEBUG_CALL('CALC_PCO2_SOLVESAPHE',myThid)
#endif
              CALL CALC_PCO2_SOLVESAPHE(
     I         surftemp(i,j),surfsalt(i,j),
     I         surfdic(i,j), surfphos(i,j),
     I         surfsi(i,j),surfalk(i,j),
     U         pH(i,j,bi,bj),pCO2(i,j,bi,bj),co3dummy,
     I         i,j,kLev,bi,bj, debugPrt, nIter0, myThid )
              debugPrt = .FALSE.
             ELSE
C Use the original Follows et al. (2006) solver
#endif /* CARBONCHEM_SOLVESAPHE */
#ifdef ALLOW_DEBUG
              IF (debugPrt) THEN
                CALL DEBUG_CALL('CALC_PCO2_APPROX',myThid)
                debugPrt = .FALSE.
              ENDIF
#endif
              DO it=1,10
cC$TAF STORE pH(i,j,bi,bj)                              = dic_surf
cC$TAF STORE surfalk(i,j), surfphos(i,j), surfsi(i,j)   = dic_surf
               CALL CALC_PCO2_APPROX(
     I          surftemp(i,j),surfsalt(i,j),
     I          surfdic(i,j), surfphos(i,j),
     I          surfsi(i,j),surfalk(i,j),
     I          ak1(i,j,bi,bj),ak2(i,j,bi,bj),
     I          ak1p(i,j,bi,bj),ak2p(i,j,bi,bj),ak3p(i,j,bi,bj),
     I          aks(i,j,bi,bj),akb(i,j,bi,bj),akw(i,j,bi,bj),
     I          aksi(i,j,bi,bj),akf(i,j,bi,bj),
     I          ak0(i,j,bi,bj), fugf(i,j,bi,bj),
     I          ff(i,j,bi,bj),
     I          bt(i,j,bi,bj),st(i,j,bi,bj),ft(i,j,bi,bj),
     U          pH(i,j,bi,bj),pCO2(i,j,bi,bj),co3dummy,
     I          i,j,kLev,bi,bj, it ,  myThid )
              ENDDO
#ifdef CARBONCHEM_SOLVESAPHE
             ENDIF
#endif /* CARBONCHEM_SOLVESAPHE */
            ENDIF
           ENDDO
          ENDDO

#ifdef ALLOW_DEBUG
         IF (debugMode) THEN
          iprt = MIN(20,sNx)
          jprt = MIN(20,sNy)
          WRITE(msgBuf,'(4(A,F9.6),2(A,F11.8),A,F9.6)')
     &        ' first guess pH=', pH(iprt,jprt,bi,bj),
     &        ', Temp=',theta(iprt,jprt,1,bi,bj),
     &        ', Salt=',salt(iprt,jprt,1,bi,bj),
     &        ', DIC=', surfdic(iprt,jprt),
     &        ', PO4=', surfphos(iprt,jprt),
     &        ', SiT=', surfsi(iprt,jprt),
     &        ', ALK=', surfalk(iprt,jprt)
          CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                        SQUEEZE_RIGHT, myThid )
c         WRITE(standardMessageUnit,*) 'QQ first guess pH ',
c    &        pH(iprt,jprt,bi,bj),' Temp ',theta(iprt,jprt,1,bi,bj),
c    &        ' Salt ',salt(iprt,jprt,1,bi,bj),
c    &        ' DIC ' ,surfdic(iprt,jprt),
c    &        ' PO4 ' ,surfphos(iprt,jprt),
c    &        ' SiT ' ,surfsi(iprt,jprt),
c    &        ' ALK ' ,surfalk(iprt,jprt)
c         CALL DEBUG_MSG(msgBuf,myThid)
         ENDIF
#endif

C end if-block (.NOT.pH_isLoaded)
        ENDIF
C     end bi,bj loops
       ENDDO
      ENDDO

#endif /* ALLOW_DIC */
      RETURN
      END

#include "SHAP_FILT_OPTIONS.h"

      SUBROUTINE SHAP_FILT_U(uVel,bi,bj,K,myCurrentTime,myThid)
C     /==========================================================\
C     | S/R SHAP_FILT_U                                          |
C     | Applies Shapiro filter to U field over one XY slice      |
C     | of one tile at a time.                                   |
C     \==========================================================/
      IMPLICIT NONE

C     == Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "SHAP_FILT.h"

C     == Routine arguments
      _RL uVel(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      INTEGER myThid
      _RL     myCurrentTime
      INTEGER bi, bj, K

#ifdef ALLOW_SHAP_FILT

C     == Local variables ==
      _RL tmpFldX(1-OLx:sNx+OLx,1-OLy:sNy+OLy,2)
      _RL tmpFldY(1-OLx:sNx+OLx,1-OLy:sNy+OLy,2)
      _RS maskZ(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER I,J,N,N1,N2

      DO J=1-OLy,sNy+OLy
       DO I=1-OLx,sNx+OLx
        tmpFldX(i,j,1) = uVel(i,j,k,bi,bj)
     &                   *_maskW(i,j,k,bi,bj)
       ENDDO
      ENDDO

C     Extract small-scale noise from tmpFldX (delta_ii^n)
      DO N=1,nShapUV
       N1=1+mod(N+1,2)
       N2=1+mod( N ,2)
       DO J=1-OLy,sNy+OLy
        DO I=1-OLx+1,sNx+OLx-1
         tmpFldX(i,j,N2) = -0.25*(
     &          tmpFldX(i-1,j,N1) + tmpFldX(i+1,j,N1)
     &             - 2.*tmpFldX(i,j,N1) 
     &            )*_maskW(i,j,k,bi,bj)
        ENDDO
       ENDDO
      ENDDO

C     Create temporary Zeta mask (accounting for thin walls)
      DO J=1-OLy,sNy+OLy
       DO I=1-OLx+1,sNx+OLx
        maskZ(i,j) = _maskS(i-1,j,k,bi,bj)
     &              *_maskS( i ,j,k,bi,bj)
       ENDDO
      ENDDO

#ifdef SEQUENTIAL_2D_SHAP
      DO J=1-OLy,sNy+OLy
       DO I=1-OLx,sNx+OLx
        tmpFldX(i,j,N2) = uVel(i,j,k,bi,bj) - tmpFldX(i,j,N2)
        tmpFldY(i,j,1) = tmpFldX(i,j,N2)
       ENDDO
      ENDDO
#else
      DO J=1-OLy,sNy+OLy
       DO I=1-OLx,sNx+OLx
        tmpFldY(i,j,1) = uVel(i,j,k,bi,bj)
     &                   *_maskW(i,j,k,bi,bj)
       ENDDO
      ENDDO
#endif /* SEQUENTIAL_2D_SHAP */

C     Extract small-scale noise from tmpFldY (delta_jj^n)
      DO N=1,nShapUV
       N1=1+mod(N+1,2)
       N2=1+mod( N ,2)
       DO J=1-OLy+1,sNy+OLy-1
        DO I=1-OLx+1,sNx+OLx
         tmpFldY(i,j,N2) = -0.25*(
     &    (tmpFldY(i,j+1,N1)-tmpFldY(i, j ,N1))*maskZ(i,j+1)
     &   -(tmpFldY(i, j ,N1)-tmpFldY(i,j-1,N1))*maskZ(i, j )
#ifdef NO_SLIP_SHAP
     &   -2.*(2.-maskZ(i,j)-maskZ(i,j+1))*tmpFldY(i,j,N1)
#endif
     &         )*_maskW(i,j,k,bi,bj)
        ENDDO
       ENDDO
      ENDDO

C     Subtract small-scale noise from field
#ifdef SEQUENTIAL_2D_SHAP
      DO J=1-OLy,sNy+OLy
       DO I=1-OLx,sNx+OLx
        uVel(i,j,k,bi,bj) = tmpFldX(i,j,N2) - tmpFldY(i,j,N2)
       ENDDO
      ENDDO
#else
      DO J=1-OLy,sNy+OLy
       DO I=1-OLx,sNx+OLx
        uVel(i,j,k,bi,bj) = uVel(i,j,k,bi,bj)
     &    -0.5*( tmpFldX(i,j,N2)+tmpFldY(i,j,N2) )
       ENDDO
      ENDDO
#endif /* SEQUENTIAL_2D_SHAP */

#endif /* ALLOW_SHAP_FILT */

      RETURN
      END

#include "OBCS_OPTIONS.h"

      SUBROUTINE ORLANSKI_SOUTH( bi, bj, futureTime,
     I                      uVel, vVel, wVel, theta, salt,
     I                      myThid )
C     *==========================================================*
C     | SUBROUTINE ORLANSKI_SOUTH                                |
C     | o Calculate future boundary data at open boundaries      |
C     |   at time = futureTime by applying Orlanski radiation    |
C     |   conditions.                                            |
C     *==========================================================*
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "OBCS_PARAMS.h"
#include "OBCS_GRID.h"
#include "OBCS_FIELDS.h"
#include "ORLANSKI.h"

C SPK 6/2/00: Added radiative OBCs for salinity.
C SPK 6/6/00: Changed calculation of OB*w. When K=1, the
C             upstream value is used. For example on the eastern OB:
C                IF (K.EQ.1) THEN
C                   OBEw(J,K,bi,bj)=wVel(I_obc-1,J,K,bi,bj)
C                ENDIF
C
C SPK 7/7/00: 1) Removed OB*w fix (see above).
C             2) Added variable CMAX. Maximum diagnosed phase speed is now
C                clamped to CMAX. For stability of AB-II scheme (CFL) the
C                (non-dimensional) phase speed must be <0.5
C             3) (Sonya Legg) Changed application of uVel and vVel.
C                uVel on the western OB is actually applied at I_obc+1
C                while vVel on the southern OB is applied at J_obc+1.
C             4) (Sonya Legg) Added templates for forced OBs.
C
C SPK 7/17/00: Non-uniform resolution is now taken into account in diagnosing
C              phase speeds and time-stepping OB values. CL is still the
C              non-dimensional phase speed; CVEL is the dimensional phase
C              speed: CVEL = CL*(dx or dy)/dt, where dx and dy is the
C              appropriate grid spacings. Note that CMAX (with which CL
C              is compared) remains non-dimensional.
C
C SPK 7/18/00: Added code to allow filtering of phase speed following
C              Blumberg and Kantha. There is now a separate array
C              CVEL_**, where **=Variable(U,V,T,S,W)Boundary(E,W,N,S) for
C              the dimensional phase speed. These arrays are initialized to
C              zero in ini_obcs.F. CVEL_** is filtered according to
C              CVEL_** = fracCVEL*CVEL(new) + (1-fracCVEL)*CVEL_**(old).
C              fracCVEL=1.0 turns off filtering.
C
C SPK 7/26/00: Changed code to average phase speed. A new variable
C              'cvelTimeScale' was created. This variable must now be
C              specified. Then, fracCVEL=deltaT/cvelTimeScale.
C              Since the goal is to smooth out the 'singularities' in the
C              diagnosed phase speed, cvelTimeScale could be picked as the
C              duration of the singular period in the unfiltered case. Thus,
C              for a plane wave cvelTimeScale might be the time take for the
C              wave to travel a distance DX, where DX is the width of the region
C              near which d(phi)/dx is small.

C     == Routine arguments ==
      INTEGER bi, bj
      _RL futureTime
      _RL uVel (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      _RL vVel (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      _RL wVel (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      _RL theta(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      _RL salt (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      INTEGER myThid

#ifdef ALLOW_ORLANSKI
#ifdef ALLOW_OBCS_SOUTH
C     == Local variables ==
      INTEGER  I, K, J_obc
      _RL CL, ab1, ab2, fracCVEL, f1, f2
      _RL denom
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      ab1   =  1.5 _d 0 + abEps /* Adams-Bashforth coefficients */
      ab2   = -0.5 _d 0 - abEps
      /* CMAX is maximum allowable phase speed-CFL for AB-II */
      /* cvelTimeScale is averaging period for phase speed in sec. */

      fracCVEL = deltaT/cvelTimeScale /* fraction of new phase speed used*/
      f1 = fracCVEL /* dont change this. Set cvelTimeScale */
      f2 = 1.0-fracCVEL   /* dont change this. set cvelTimeScale */

C     Southern OB (Orlanski Radiation Condition)
       DO K=1,Nr
         DO I=1-OLx,sNx+OLx
            J_obc=OB_Js(I,bi,bj)
            IF ( J_obc.NE.OB_indexNone ) THEN
C-             uVel
                denom =
     &          (ab1*US_STORE_2(I,K,bi,bj) + ab2*US_STORE_3(I,K,bi,bj))
               IF ( denom .NE. 0 _d 0 ) THEN
                 CL = (uVel(I,J_obc+1,K,bi,bj)-US_STORE_1(I,K,bi,bj))
     &              / denom
                 CL = MIN( MAX( CL, zeroRL ), CMAX )
               ELSE
                 CL = 0. _d 0
               ENDIF
               CVEL_US(I,K,bi,bj) = f1*(CL*dyU(I,J_obc+2,bi,bj)/deltaT)+
     &                f2*CVEL_US(I,K,bi,bj)
C              update OBC to next timestep
               OBSu(I,K,bi,bj)=uVel(I,J_obc,K,bi,bj)+
     &          CVEL_US(I,K,bi,bj)*deltaT*recip_dyU(I,J_obc+1,bi,bj)*
     &          (ab1*(uVel(I,J_obc+1,K,bi,bj)-uVel(I,J_obc,K,bi,bj)) +
     &         ab2*(US_STORE_1(I,K,bi,bj)-US_STORE_4(I,K,bi,bj)))

C-             vVel (to be applied at J_obc+1)
                denom =
     &          (ab1*VS_STORE_2(I,K,bi,bj) + ab2*VS_STORE_3(I,K,bi,bj))
               IF ( denom .NE. 0 _d 0 ) THEN
                 CL = (vVel(I,J_obc+2,K,bi,bj)-VS_STORE_1(I,K,bi,bj))
     &              / denom
                 CL = MIN( MAX( CL, zeroRL ), CMAX )
               ELSE
                 CL = 0. _d 0
               ENDIF
               CVEL_VS(I,K,bi,bj) = f1*(CL*dyF(I,J_obc+2,bi,bj)/deltaT)+
     &                f2*CVEL_VS(I,K,bi,bj)
C              update OBC to next timestep
               OBSv(I,K,bi,bj)=vVel(I,J_obc+1,K,bi,bj)+
     &          CVEL_VS(I,K,bi,bj)*deltaT*recip_dyF(I,J_obc+1,bi,bj)*
     &          (ab1*(vVel(I,J_obc+2,K,bi,bj)-vVel(I,J_obc+1,K,bi,bj))+
     &          ab2*(VS_STORE_1(I,K,bi,bj)-VS_STORE_4(I,K,bi,bj)))

C-             Temperature
                denom =
     &          (ab1*TS_STORE_2(I,K,bi,bj) + ab2*TS_STORE_3(I,K,bi,bj))
               IF ( denom .NE. 0 _d 0 ) THEN
                 CL = (theta(I,J_obc+1,K,bi,bj)-TS_STORE_1(I,K,bi,bj))
     &              / denom
                 CL = MIN( MAX( CL, zeroRL ), CMAX )
               ELSE
                 CL = 0. _d 0
               ENDIF
               CVEL_TS(I,K,bi,bj) = f1*(CL*dyC(I,J_obc+2,bi,bj)/deltaT)+
     &                f2*CVEL_TS(I,K,bi,bj)
C              update OBC to next timestep
               OBSt(I,K,bi,bj)=theta(I,J_obc,K,bi,bj)+
     &          CVEL_TS(I,K,bi,bj)*deltaT*recip_dyC(I,J_obc+1,bi,bj)*
     &          (ab1*(theta(I,J_obc+1,K,bi,bj)-theta(I,J_obc,K,bi,bj))+
     &          ab2*(TS_STORE_1(I,K,bi,bj)-TS_STORE_4(I,K,bi,bj)))

C-             Salinity
                denom =
     &          (ab1*SS_STORE_2(I,K,bi,bj) + ab2*SS_STORE_3(I,K,bi,bj))
               IF ( denom .NE. 0 _d 0 ) THEN
                 CL = (salt(I,J_obc+1,K,bi,bj)-SS_STORE_1(I,K,bi,bj))
     &              / denom
                 CL = MIN( MAX( CL, zeroRL ), CMAX )
               ELSE
                 CL = 0. _d 0
               ENDIF
               CVEL_SS(I,K,bi,bj) = f1*(CL*dyC(I,J_obc+2,bi,bj)/deltaT)+
     &                f2*CVEL_SS(I,K,bi,bj)
C              update OBC to next timestep
               OBSs(I,K,bi,bj)=salt(I,J_obc,K,bi,bj)+
     &          CVEL_SS(I,K,bi,bj)*deltaT*recip_dyC(I,J_obc+1,bi,bj)*
     &          (ab1*(salt(I,J_obc+1,K,bi,bj)-salt(I,J_obc,K,bi,bj)) +
     &         ab2*(SS_STORE_1(I,K,bi,bj)-SS_STORE_4(I,K,bi,bj)))

#ifdef ALLOW_NONHYDROSTATIC
             IF ( nonHydrostatic ) THEN
C-             wVel
                denom =
     &          (ab1*WS_STORE_2(I,K,bi,bj)+ab2*WS_STORE_3(I,K,bi,bj))
               IF ( denom .NE. 0 _d 0 ) THEN
                 CL = (wVel(I,J_obc+1,K,bi,bj)-WS_STORE_1(I,K,bi,bj))
     &              / denom
                 CL = MIN( MAX( CL, zeroRL ), CMAX )
               ELSE
                 CL = 0. _d 0
               ENDIF
               CVEL_WS(I,K,bi,bj)=f1*(CL*dyC(I,J_obc+2,bi,bj)/deltaT)
     &                   + f2*CVEL_WS(I,K,bi,bj)
C              update OBC to next timestep
               OBSw(I,K,bi,bj)=wVel(I,J_obc,K,bi,bj)+
     &           CVEL_WS(I,K,bi,bj)*deltaT*recip_dyC(I,J_obc+1,bi,bj)*
     &           (ab1*(wVel(I,J_obc+1,K,bi,bj)-wVel(I,J_obc,K,bi,bj))+
     &           ab2*(WS_STORE_1(I,K,bi,bj)-WS_STORE_4(I,K,bi,bj)))
             ENDIF
#endif /* ALLOW_NONHYDROSTATIC */

C              update/save storage arrays
C              uVel
C              copy t-1 to t-2 array
               US_STORE_3(I,K,bi,bj)=US_STORE_2(I,K,bi,bj)
C              copy (current time) t to t-1 arrays
               US_STORE_2(I,K,bi,bj)=uVel(I,J_obc+2,K,bi,bj) -
     &         uVel(I,J_obc+1,K,bi,bj)
               US_STORE_1(I,K,bi,bj)=uVel(I,J_obc+1,K,bi,bj)
               US_STORE_4(I,K,bi,bj)=uVel(I,J_obc,K,bi,bj)
C              vVel
C              copy t-1 to t-2 array
               VS_STORE_3(I,K,bi,bj)=VS_STORE_2(I,K,bi,bj)
C              copy (current time) t to t-1 arrays
               VS_STORE_2(I,K,bi,bj)=vVel(I,J_obc+3,K,bi,bj) -
     &         vVel(I,J_obc+2,K,bi,bj)
               VS_STORE_1(I,K,bi,bj)=vVel(I,J_obc+2,K,bi,bj)
               VS_STORE_4(I,K,bi,bj)=vVel(I,J_obc+1,K,bi,bj)
C              Temperature
C              copy t-1 to t-2 array
               TS_STORE_3(I,K,bi,bj)=TS_STORE_2(I,K,bi,bj)
C              copy (current time) t to t-1 arrays
               TS_STORE_2(I,K,bi,bj)=theta(I,J_obc+2,K,bi,bj) -
     &         theta(I,J_obc+1,K,bi,bj)
               TS_STORE_1(I,K,bi,bj)=theta(I,J_obc+1,K,bi,bj)
               TS_STORE_4(I,K,bi,bj)=theta(I,J_obc,K,bi,bj)
C              Salinity
C              copy t-1 to t-2 array
               SS_STORE_3(I,K,bi,bj)=SS_STORE_2(I,K,bi,bj)
C              copy (current time) t to t-1 arrays
               SS_STORE_2(I,K,bi,bj)=salt(I,J_obc+2,K,bi,bj) -
     &         salt(I,J_obc+1,K,bi,bj)
               SS_STORE_1(I,K,bi,bj)=salt(I,J_obc+1,K,bi,bj)
               SS_STORE_4(I,K,bi,bj)=salt(I,J_obc,K,bi,bj)
#ifdef ALLOW_NONHYDROSTATIC
             IF ( nonHydrostatic ) THEN
C              wVel
C              copy t-1 to t-2 array
               WS_STORE_3(I,K,bi,bj)=WS_STORE_2(I,K,bi,bj)
C              copy (current time) t to t-1 arrays
               WS_STORE_2(I,K,bi,bj)=wVel(I,J_obc+2,K,bi,bj) -
     &         wVel(I,J_obc+1,K,bi,bj)
               WS_STORE_1(I,K,bi,bj)=wVel(I,J_obc+1,K,bi,bj)
               WS_STORE_4(I,K,bi,bj)=wVel(I,J_obc,K,bi,bj)
             ENDIF
#endif /* ALLOW_NONHYDROSTATIC */
            ENDIF
         ENDDO
      ENDDO

#endif /* ALLOW_OBCS_SOUTH */
#endif /* ALLOW_ORLANSKI */
      RETURN
      END

#include "OPENAD_OPTIONS.h"
c#ifdef ALLOW_AUTODIFF
c# include "AUTODIFF_OPTIONS.h"
c#endif
#ifdef ALLOW_OBCS
# include "OBCS_OPTIONS.h"
#endif
#ifdef ALLOW_SEAICE
# include "SEAICE_OPTIONS.h"
#endif
#ifdef ALLOW_GENERIC_ADVDIFF
# include "GAD_OPTIONS.h"
#endif
#ifdef ALLOW_DIC
# include "DIC_OPTIONS.h"
#endif
#ifdef ALLOW_GMREDI
# include "GMREDI_OPTIONS.h"
#endif
#ifdef ALLOW_STREAMICE
# include "STREAMICE_OPTIONS.h"
#endif
#ifdef ALLOW_GGL90
# include "GGL90_OPTIONS.h"
#endif
#ifdef ALLOW_EXF
# include "EXF_OPTIONS.h"
#endif
#ifdef ALLOW_COST
# include "COST_OPTIONS.h"
#endif
#ifdef ALLOW_CTRL
# include "CTRL_OPTIONS.h"
#endif
c#ifdef ALLOW_ECCO
c# include "ECCO_OPTIONS.h"
c#endif

CBOP
C     !ROUTINE: INNER_DO_LOOP
C     !INTERFACE:
      SUBROUTINE INNER_DO_LOOP( iloop, myTime, myIter, myThid )

C     !DESCRIPTION: \bv
C     *================================================================*
C     | SUBROUTINE INNER_DO_LOOP
C     | o Inner time-stepping "do-loop" for OPENAD_DIVA
C     *================================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"

#ifdef ALLOW_OPENAD_DIVA
C-- Header files that are included in the_main_loop.F for TAF (e.g., DYNVARS.h)
C    might be needed here (where the iloop is done) for OpenAD

# ifdef ALLOW_CTRL
#  include "CTRL_SIZE.h"
#  include "CTRL.h"
#  include "CTRL_DUMMY.h"
#  include "CTRL_GENARR.h"
#  include "CTRL_OBCS.h"
# endif
# ifdef ALLOW_COST
#  include "cost.h"
# endif

# ifdef ALLOW_PTRACERS
#  include "PTRACERS_SIZE.h"
#  include "PTRACERS_FIELDS.h"
#  include "PTRACERS_START.h"
# endif
# ifdef ALLOW_GCHEM
#  include "GCHEM_FIELDS.h"
# endif
# ifdef ALLOW_CFC
#  include "CFC.h"
# endif
# ifdef ALLOW_DIC
#  include "DIC_VARS.h"
#  include "DIC_LOAD.h"
#  include "DIC_ATMOS.h"
#  include "DIC_CTRL.h"
#  include "DIC_COST.h"
# endif
# ifdef ALLOW_OBCS
#  include "OBCS_PARAMS.h"
#  include "OBCS_FIELDS.h"
#  include "OBCS_SEAICE.h"
#  ifdef ALLOW_PTRACERS
#   include "OBCS_PTRACERS.h"
#  endif
# endif
# ifdef ALLOW_SHELFICE
#  include "SHELFICE.h"
#  include "SHELFICE_COST.h"
# endif
# ifdef ALLOW_STREAMICE
#  include "STREAMICE.h"
#  include "STREAMICE_ADV.h"
#  include "STREAMICE_BDRY.h"
#  include "STREAMICE_CG.h"
# endif

#endif /* ALLOW_OPENAD_DIVA */

C     !INPUT/OUTPUT PARAMETERS:
C     myTime :: time counter for this thread
C     myIter :: iteration counter for this thread
C     myThid :: thread number for this instance of the routine.
      INTEGER iloop
      _RL     myTime
      INTEGER myIter
      INTEGER myThid

#ifdef ALLOW_OPENAD_DIVA
C     !FUNCTIONS:

C     !LOCAL VARIABLES:
      INTEGER iloop1
      INTEGER prod
CEOP

#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_ENTER('INNER_DO_LOOP',myThid)
#endif

C--   Start Inner time-stepping Loop:
      DO iloop1 = 1, nTimeSteps
        prod = (iloop-1)*nTimeSteps_l2+iloop1

#ifdef ALLOW_DEBUG
        IF (debugMode) CALL DEBUG_CALL('FORWARD_STEP',myThid)
#endif
        CALL TIMER_START('FORWARD_STEP        [INNER_DO_LOOP]',myThid)
        CALL FORWARD_STEP( prod, myTime, myIter, myThid )
        CALL TIMER_STOP ('FORWARD_STEP        [INNER_DO_LOOP]',myThid)

      ENDDO
C--   end of Inner time-stepping Loop

#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_LEAVE('INNER_DO_LOOP',myThid)
#endif

#endif /* ALLOW_OPENAD_DIVA */
      RETURN
      END

#include "STREAMICE_OPTIONS.h"
#ifdef ALLOW_AUTODIFF
# include "AUTODIFF_OPTIONS.h"
#endif

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

CBOP
      SUBROUTINE STREAMICE_VEL_SOLVE_FP ( myThid, maxNLIter,
     &                                maxCGiter, myIter )
C     /============================================================\
C     | SUBROUTINE                                                 |
C     | o                                                          |
C     |============================================================|
C     |                                                            |
C     \============================================================/
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "STREAMICE.h"
#include "STREAMICE_CG.h"

C     !INPUT/OUTPUT ARGUMENTS
      INTEGER myThid
      INTEGER maxNLIter
      INTEGER maxCGIter
      INTEGER myIter

#ifdef ALLOW_STREAMICE

C     LOCAL VARIABLES

#ifdef ALLOW_STREAMICE_FP_ADJ
      INTEGER i, j, k, l, bi, bj, loopiter
      INTEGER NL_iter
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      _RL err_last_change, cgtol, err_init
      LOGICAL CONVERGED

#ifdef ALLOW_OPENAD
      INTEGER ADJ_ITER
      LOGICAL ADJ_CONVERGED
#endif

      isinloop0 =0
      isinloop1 =1
      isinloop2 =2

      IF (STREAMICE_ppm_driving_stress) THEN
       CALL STREAMICE_DRIVING_STRESS_PPM (myThid)
      ELSE
       CALL STREAMICE_DRIVING_STRESS (myThid)
      ENDIF

#ifdef STREAMICE_STRESS_BOUNDARY_CONTROL
      _EXCH_XY_RL( taudx_SI , myThid )
      _EXCH_XY_RL( taudy_SI , myThid )
      CALL STREAMICE_FORCED_BUTTRESS (myThid)
#endif

      CALL TIMER_START ('STREAMICE_VEL_SOLVE',myThid)

      cgtol = streamice_cg_tol
      nl_iter = 0
      CONVERGED = .false.
      err_last_change = 1 _d 1

      _EXCH_XY_RL( taudx_SI , myThid )
      _EXCH_XY_RL( taudy_SI , myThid )

       DO bj = myByLo(myThid), myByHi(myThid)
        DO bi = myBxLo(myThid), myBxHi(myThid)
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           U_streamice (i,j,bi,bj)=U_streamice (i,j,bi,bj)
     & + 0*u_new_SI (i,j,bi,bj)
           V_streamice (i,j,bi,bj)=V_streamice (i,j,bi,bj)
     & + 0*v_new_SI (i,j,bi,bj)
          ENDDO
         ENDDO
        ENDDO
       ENDDO

#ifdef STREAMICE_HYBRID_STRESS
       CALL STREAMICE_VISC_BETA_HYBRID ( myThid )
#else
       CALL STREAMICE_VISC_BETA ( myThid )
#endif

       if (STREAMICE_chkresidconvergence .or.
     &    (streamice_maxnliter_cpl.eq.0 .and. myIter.eq.0)) then

        CALL STREAMICE_GET_VEL_RESID_ERR_OAD ( err_init, myThid )
        err_last_change = err_init

        WRITE(msgBuf,'(A,E15.7)') 'initial nonlinear resid (error): ',
     &                       err_init
        CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT , 1)

       endif

#ifdef ALLOW_OPENAD
      CALL STREAMICE_VEL_PHISTAGE (
     I                   myThid,
     I                   maxNLIter,
     I                   maxCGiter,
     O                   cgtol,
     O                   nL_iter,
     O                   adj_iter,
     O                   CONVERGED,
     O                   ADJ_CONVERGED,
     O                   err_last_change,
     O                   err_init,
     I                   isinloop0)
#endif

#if (defined(ALLOW_STREAMICE_FP_ADJ) && defined(ALLOW_TAPENADE))
#ifdef STREAMICE_HYBRID_STRESS
!$AD FP-LOOP "u_streamice,v_streamice,streamice_taubx,streamice_tauby,visc_streamice_full" adj_reduction=1.e-6
#else
!$AD FP-LOOP "u_streamice,v_streamice" adj_reduction=2.e-8
#endif
      DO WHILE (.not.CONVERGED)
#else
      DO loopiter=1,maxNLIter
#endif

C     To avoid using "exit", loop goes through all iterations
C       but after convergence loop does nothing

c        IF (.not.CONVERGED) THEN

#ifndef ALLOW_OPENAD
      CALL STREAMICE_VEL_PHISTAGE (
     I                   myThid,
     I                   maxNLIter,
     I                   maxCGiter,
     O                   cgtol,
     O                   nL_iter,
     O                   CONVERGED,
     O                   err_last_change,
     O                   err_init,
     I                   isinloop1)
#else
      CALL STREAMICE_VEL_PHISTAGE (
     I                   myThid,
     I                   maxNLIter,
     I                   maxCGiter,
     O                   cgtol,
     O                   nL_iter,
     O                   adj_iter,
     O                   CONVERGED,
     O                   ADJ_CONVERGED,
     O                   err_last_change,
     O                   err_init,
     I                   isinloop1)
#endif

c      DO bj = myByLo(myThid), myByHi(myThid)
c       DO bi = myBxLo(myThid), myBxHi(myThid)
c        DO j=1-OLy,sNy+OLy
c         DO i=1-OLx,sNx+OLx
c          U_streamice (i,j,bi,bj)=u_new_SI (i,j,bi,bj)
c          V_streamice (i,j,bi,bj)=v_new_SI (i,j,bi,bj)
c         ENDDO
c        ENDDO
c       ENDDO
c      ENDDO

      ENDDO

#ifdef ALLOW_OPENAD
      CALL STREAMICE_VEL_PHISTAGE (
     I                   myThid,
     I                   maxNLIter,
     I                   maxCGiter,
     O                   cgtol,
     O                   nL_iter,
     O                   adj_iter,
     O                   CONVERGED,
     O                   ADJ_CONVERGED,
     O                   err_last_change,
     O                   err_init,
     I                   isinloop2)
#endif

C END NL ITER. LOOP
C-------------------------------------------------------------------

      if (nl_iter .lt. streamice_max_nl_iter) then
       WRITE(msgBuf,'(A,I5,A)') 'VELOCITY SOLVE CONVERGED, ',
     &         nl_iter, ' iterations'
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                     SQUEEZE_RIGHT , 1)
       PRINT *, 'VELOCITY SOLVE CONVERGED, ', nl_iter, 'iterations'
      else
       WRITE(msgBuf,'(A,I5,A)') 'VELOCITY SOLVE NOT CONVERGED IN ',
     &         nl_iter, ' iterations'
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                     SQUEEZE_RIGHT , 1)
       PRINT *, 'VELOCITY SOLVE NOT CONVERGED IN ', nl_iter,
     &        'iterations'
      endif

      _EXCH_XY_RL(U_streamice, myThid)
      _EXCH_XY_RL(V_streamice, myThid)

      CALL TIMER_STOP ('STREAMICE_VEL_SOLVE',myThid)

#endif
#endif
      RETURN
      END

#include "STREAMICE_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

CBOP
      SUBROUTINE STREAMICE_APPLY_FLUX_CTRL ( myThid )

C     /============================================================\
C     | SUBROUTINE                                                 |   
C     | o                                                          |
C     |============================================================|
C     |                                                            |
C     \============================================================/
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "GRID.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "STREAMICE.h"
!#ifdef ALLOW_STREAMICE_FLUX_CONTROL
!#include "STREAMICE_CTRL_FLUX.h"
!#endif

      INTEGER myThid

#ifdef ALLOW_STREAMICE
#ifdef ALLOW_STREAMICE_FLUX_CONTROL
#ifdef STREAMICE_FALSE
      INTEGER bi, bj, i, j, k
      _RS maskval
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      _RL streamice_flux_scale_current (n_fluxes_max)


!!!!!!!  IN PLACE OF THIS, THERE WOULD BE CALL TO SOMETHING
!!!!!!   LIKE CTRL_GENTIME_2D IN ORDER TO PROPERLY INTERPOLATE
!!!!!!   THE SCALINGS TO THE CURRENT TIME STEP

      DO i=1,n_fluxes
       streamice_flux_scale_current (i) =
     &  streamice_ctrl_flux_scale (i,1)
      ENDDO

!!!!!!!!
!!!!!!!
!!!!!!!!

      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
        DO j=1,sNy
         DO i=1,sNx
          IF (streamice_umask(i,j,bi,bj).eq.3.0 .OR.
     &        streamice_vmask(i,j,bi,bj).eq.3.0) THEN

           maskval = INT(streamice_ctrl_flux_mask(i,j,bi,bj))

           DO k=1,n_fluxes_max
            IF (maskval.eq.streamice_ctrl_flux_id(k)) THEN
             IF (streamice_umask(i,j,bi,bj).eq.3.0
              u_bdry_values_SI (i,j,bi,bj) = 
     &         u_bdry_values_SI_base(i,j,bi,bj) *
     &         streamice_flux_scale_current (k)
             ENDIF
             IF (streamice_vmask(i,j,bi,bj).eq.3.0
              v_bdry_values_SI (i,j,bi,bj) = 
     &         v_bdry_values_SI_base(i,j,bi,bj) *
     &         streamice_flux_scale_current (k)
             ENDIF
             EXIT
            ENDIF
           ENDDO 
          ENDIF
         ENDDO
        ENDDO
       ENDDO
      ENDDO
#endif
#endif
#endif
      RETURN
      END

#include "ATM_CPL_OPTIONS.h"

CBOP 0
C !ROUTINE: CPL_EXCH_CONFIGS

C !INTERFACE:
      SUBROUTINE CPL_EXCH_CONFIGS( myThid )

C !DESCRIPTION:
C     *==========================================================*
C     | SUBROUTINE CPL_EXCH_CONFIGS
C     | o Controlling routine for initial config exchange between
C     |   component models and atmosphere component.
C     | - Atmospheric version -
C     *==========================================================*
C     | Controls the import of configuration information
C     | (grid/topography,etc...) from other components and the
C     | export of configuration information from this component.
C     | The routine does some basic checking on consistency
C     | components and summarizes the information that has been
C     | imported.
C     | The routine will need to be customised for different
C     | styles of coupled run. The coupler requires consistency
C     | between sending and receiving operations posted by
C     | various components. Therefore changes in one component
C     | model CPL_EXCH_CONFIG may require changes in other
C     | component models CPL_EXCH_CONFIG routines as well
C     | as in the coupler EXCH_COMPONENT_CONFIG routine.
C     *==========================================================*

C !USES:
      IMPLICIT NONE
C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
c#include "PARAMS.h"
c#include "CPL_PARAMS.h"

C !INPUT/OUTPUT PARAMETERS:
C     myThid :: Thread number for this instance of the routine
      INTEGER myThid

C !LOCAL VARIABLES:
C     errMsg   :: error message to print to clog file
      LOGICAL errFlag
      CHARACTER*70 errMsg
c     CHARACTER*(MAX_LEN_MBUF) msgBuf
C--   local variable in common block
      _RL landMask_loc(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      COMMON / CPL_EXCH_CONFIGS_LOC / landMask_loc
CEOP

      errFlag = .FALSE.
      errMsg  = ' '

C-    Get configuration information (=land/sea mask) from other pkg
      CALL ATM_GET_ATMCONFIG(
     O                        landMask_loc,
     I                        myThid )

C-    Post my configuration information to the coupler "layer".
      CALL ATM_EXPORT_ATMCONFIG(
     U                        errFlag,
     I                        landMask_loc, myThid )

C-    Import other component model(s) configuration(s) from the coupler "layer"
C     o Get ocean model configuration
      CALL ATM_IMPORT_OCNCONFIG( myThid )

C-    Summarise coupling config set-up and check for inconsistency
      _BARRIER
      CALL ATM_CHECK_CPLCONFIG(
     U                        errFlag, errMsg,
     I                        landMask_loc, myThid )

C--   All procs in World check for error and stop if any
      _BEGIN_MASTER( myThid )
      CALL MITCPLR_ALL_CHECK( errFlag, errMsg )
      _END_MASTER( myThid )

      _BARRIER

      RETURN
      END

#include "ECCO_OPTIONS.h"

      subroutine cost_gencost_glbmean(
     I                     myThid
     &                   )

c     ==================================================================
c     SUBROUTINE cost_gencost_glbmean
c     ==================================================================
c
c     o Evaluate cost function contribution of global mean time series
c        of OBP and SSH
c
c     started: Ou Wang Nov-2015
c
c     ==================================================================
c     SUBROUTINE cost_gencost_glbmean
c     ==================================================================

      implicit none

c     == global variables ==

#include "EEPARAMS.h"
#include "SIZE.h"
#include "PARAMS.h"
#include "GRID.h"
#include "DYNVARS.h"

#ifdef ALLOW_ECCO
# include "ECCO_SIZE.h"
# include "ECCO.h"
#endif

c     == routine arguments ==

      integer myThid

#ifdef ALLOW_ECCO
# ifdef ALLOW_GENCOST_CONTRIBUTION
#  ifdef ALLOW_GENCOST_1D

c     == local variables ==

      integer bi,bj
      integer i,j
      integer itlo,ithi
      integer jtlo,jthi
      integer irec
      integer il

      logical doglobalread
      logical ladinit

      _RL locbar(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL locw

      _RL locbarmean ( 1-OLx:sNx+OLx, 1-OLy:sNy+OLy, nSx, nSy )
      _RL locbaranom ( 1-OLx:sNx+OLx, 1-OLy:sNy+OLy, nSx, nSy )
      _RL loccount ( 1-OLx:sNx+OLx, 1-OLy:sNy+OLy, nSx, nSy )
      _RL junk, junkweight

      character*(MAX_LEN_FNAM) fname

      _RL fac
      _RL locbarglbmean
      _RL locbarglbmean_sum

      integer k, kgen
      integer locnrec
      integer ilo, ihi
      integer locunit
      _RL dataglbmean ( N1DDATA )
      _RL meandataglbmean, meandataglbmeannu
      _RL locmask ( N1DDATA )

      character*(max_len_mbuf) msgbuf

c     == external functions ==

      integer  ilnblnk, ifnblnk
      external ilnblnk, ifnblnk

      LOGICAL  MASTER_CPU_THREAD
      EXTERNAL MASTER_CPU_THREAD

c     == end of interface ==

      jtlo = myByLo(myThid)
      jthi = myByHi(myThid)
      itlo = myBxLo(myThid)
      ithi = myBxHi(myThid)

      do k=1,NGENCOST
        kgen=0
        if (((gencost_name(k).EQ.'gmbp') .OR.
     &       (gencost_name(k).EQ.'gmsl'))
     &     .AND.( gencost_is1d(k) )
     &     .AND.(using_gencost(k)) ) kgen=k

        if (kgen.GT.0) then
          locw   = gencost_wei1d(kgen)

          if(locw .NE. 0. _d 0) then

c-- initialise local variables
            fac = 1. _d 0
c convert phibot from m2/s2 to cm
            if(gencost_name(k).EQ.'gmbp') fac = 1. _d 2 * recip_gravity
            do bj = jtlo,jthi
              do bi = itlo,ithi
                do j = 1,sNy
                  do i = 1,sNx
                    locbarmean(i,j,bi,bj) = 0. _d 0
                    locbaranom(i,j,bi,bj) = 0. _d 0
                    loccount(i,j,bi,bj) = 0. _d 0
                    locbar(i,j,bi,bj) = 0. _d 0
                  enddo
                enddo
              enddo
            enddo

            doglobalread = .false.
            ladinit      = .false.

c-- map global variable to local variables

            locnrec = gencost_nrec(kgen)

            meandataglbmean = 0. _d 0
            meandataglbmeannu = 0. _d 0
            do irec = 1, N1DDATA
             dataglbmean(irec) = 0. _d 0
             locmask(irec) = 0. _d 0
            enddo

            do irec = 1, locnrec
              dataglbmean(irec) =  gencost_1DDATA(irec,kgen)
              if ( gencost_1DDATA(irec,kgen).gt.gencost_spmin(kgen)
     &          .and. gencost_1DDATA(irec,kgen).lt.gencost_spmax(kgen)
     &          .and. gencost_1DDATA(irec,kgen).ne.gencost_spzero(kgen)
     &           ) then
                locmask(irec) = 1. _d 0
                meandataglbmean = meandataglbmean + dataglbmean(irec)
                meandataglbmeannu = meandataglbmeannu + 1. _d 0
              endif
            enddo
            if(meandataglbmeannu.NE.0. _d 0)
     &        meandataglbmean = meandataglbmean / meandataglbmeannu

C now remove the time-mean from the data
            do irec = 1, locnrec
               if(locmask(irec).EQ.1. _d 0) then
                 dataglbmean(irec) = dataglbmean(irec)
     &            - meandataglbmean
               endif
            enddo
c--

#ifdef ALLOW_CTRL
            il=ilnblnk( gencost_barfile(kgen) )
            write(fname,'(2a,i10.10)')
     &        gencost_barfile(kgen)(1:il),'.',eccoiter
#endif

c--   ============
c--   Mean values.
c--   ============

            do irec = 1, locnrec

              if(locmask(irec) .NE. 0. _d 0) then
c--     Compute the mean over all bpdat records.
#ifdef ALLOW_AUTODIFF
                call active_read_xy( fname, locbar, irec, doglobalread,
     &                               ladinit, eccoiter, myThid,
     &                               gencost_dummy(kgen) )
#else
                call read_rec_xy_rl( fname, locbar, irec, 1, myThid )
#endif

                do bj = jtlo,jthi
                  do bi = itlo,ithi
                    do j = 1,sNy
                      do i = 1,sNx
                        if ( maskc(i,j,1,bi,bj).NE. 0. _d 0 ) then
                          locbarmean(i,j,bi,bj) =
     &                       locbarmean(i,j,bi,bj) +
     &                       fac*locbar(i,j,bi,bj)
                          loccount(i,j,bi,bj) = loccount(i,j,bi,bj) +
     &                       1. _d 0
                        endif
                      enddo
                    enddo
                  enddo
                enddo
              endif

            enddo

            do bj = jtlo,jthi
              do bi = itlo,ithi
                do j = 1,sNy
                  do i = 1,sNx
                    if (loccount(i,j,bi,bj).GT. 0. _d 0) then
                      locbarmean(i,j,bi,bj) =
     &                  locbarmean(i,j,bi,bj)/loccount(i,j,bi,bj)
                    endif
                  enddo
                enddo
              enddo
            enddo

c--   ==========
c--   Anomalies.
c--   ==========

c--   Loop over records for the second time.
            do irec = 1, locnrec

              if(locmask(irec) .NE. 0. _d 0) then
#ifdef ALLOW_AUTODIFF
                call active_read_xy( fname, locbar, irec, doglobalread,
     &                               ladinit, eccoiter, myThid,
     &                               gencost_dummy(kgen) )
#else
                call read_rec_xy_rl( fname, locbar, irec, 1, myThid )
#endif

c--    Compute field of anomalies
                do bj = jtlo,jthi
                  do bi = itlo,ithi
                    do j = 1,sNy
                      do i = 1,sNx
                        if ( maskc(i,j,1,bi,bj).NE. 0. _d 0) then
                          locbaranom(i,j,bi,bj) =
     &                      fac*locbar(i,j,bi,bj) -
     &                        locbarmean(i,j,bi,bj)
                        else
                          locbaranom(i,j,bi,bj) = 0. _d 0
                        endif
                      enddo
                    enddo
                  enddo
                enddo

c--    Remove global mean value
                locbarglbmean     = 0. _d 0
                locbarglbmean_sum = 0. _d 0

                do bj = jtlo,jthi
                  do bi = itlo,ithi
                    do j = 1,sNy
                      do i = 1,sNx
                        if ( maskc(i,j,1,bi,bj).NE. 0. _d 0) then
                          locbarglbmean  = locbarglbmean +
     &                     RA(i,j,bi,bj)*locbaranom(i,j,bi,bj)
                          locbarglbmean_sum = locbarglbmean_sum +
     &                      RA(i,j,bi,bj)
                        endif
                      enddo
                    enddo
                  enddo
                enddo

                _GLOBAL_SUM_RL( locbarglbmean     , myThid )
                _GLOBAL_SUM_RL( locbarglbmean_sum , myThid )

                IF (  MASTER_CPU_THREAD(myThid) .AND.
     &               ( locmask(irec) .NE. 0. _d 0 ) .AND.
     &               ( locbarglbmean_sum .NE. 0. _d 0 ) ) THEN
                    junk=locbarglbmean/locbarglbmean_sum -
     &                dataglbmean(irec)
                    junkweight=locw
                    objf_gencost(1,1,kgen) = objf_gencost(1,1,kgen)
     &                  + junk*junk*junkweight
                    num_gencost(1,1,kgen) = num_gencost(1,1,kgen)
     &                  + 1. _d 0

                    WRITE(msgBuf,'(A,i6,2e16.5)')
     &               gencost_name(kgen)(1:10),irec,
     &               locbarglbmean/locbarglbmean_sum, dataglbmean(irec)
                    CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                                SQUEEZE_RIGHT , 1)

                ENDIF

              endif ! if(locmask .ne. 0. _d 0)
            enddo

          endif !if(locw .NE. 0. _d 0) then
        endif !if (kgen.GT.0) then

      enddo !do k=1,NGENCOST

#  endif /* ifdef ALLOW_GENCOST_1D */
# endif /* ifdef ALLOW_GENCOST_CONTRIBUTION */
#endif /* ifdef ALLOW_ECCO */

      end

#include "PROFILES_OPTIONS.h"
#include "AD_CONFIG.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C     BOP
C     !ROUTINE: PROFILES_INIT_FIXED

C     !INTERFACE:
      SUBROUTINE PROFILES_INIT_FIXED( myThid )

C     !DESCRIPTION:
C     Initialization for netcdf profiles data

C     !USES:
      IMPLICIT NONE
C     == Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "DYNVARS.h"
#ifdef ALLOW_CAL
#include "cal.h"
#endif
#ifdef ALLOW_PROFILES
# include "PROFILES_SIZE.h"
# include "profiles.h"
# include "netcdf.inc"
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     myThid: my thread ID number
      INTEGER myThid
C     EOP

#ifdef ALLOW_PROFILES
C     !FUNCTIONS:
      INTEGER  ILNBLNK
      EXTERNAL ILNBLNK
      INTEGER  MDS_RECLEN
      EXTERNAL MDS_RECLEN

C     !LOCAL VARIABLES:
C     i,j,bi,bj    :: loop indices
C     kLev         :: vertical level index
C     prof_num, num_file, num_var
C                  :: loop indices for profiles, files, and variables
C     iG,jG        :: global indices
C     ic, chunkProf:: chunk-related indices
C     chunk        :: chunk size
C     ProfNo_tile  :: counter
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      INTEGER iUnit
      INTEGER kLev, prof_num
      INTEGER chunk, chunkProf, ic, recLen
      INTEGER i,j,bi,bj,iG,jG,num_file,num_var,ProfNo_tile
      INTEGER stopProfiles
      INTEGER fid, dimId, varId1, varId1a, varId1b
      INTEGER varId2,varId3
      _RL tmpyymmdd(1000),tmphhmmss(1000),diffsecs
      _RL yymmddMin,yymmddMax
      _RL hhmmssMin,hhmmssMax

      INTEGER tmpdate(4),tmpdiff(4),profIsInRunTime
      _RL tmp_lon, tmp_lon2(1000), tmp_lat2(1000)
      _RL lon_cur, lat_cur
      _RL lon_1, lon_2, lat_1, lat_2
      _RL lon_tmp1, lon_tmp2
      _RL lat_fac, lon_fac
      INTEGER prof_i, prof_j
      INTEGER vec_start(2), vec_count(2), profno_div1000
      CHARACTER*(MAX_LEN_FNAM) profilesfile, fnamedatanc
      CHARACTER*(MAX_LEN_FNAM) fnameequinc
# ifdef ALLOW_ADJOINT_RUN
      CHARACTER*(MAX_LEN_FNAM) adfnameequinc
# endif
# ifdef ALLOW_TANGENTLINEAR_RUN
      CHARACTER*(MAX_LEN_FNAM) tlfnameequinc
# endif
      INTEGER IL, JL, KL, err, nerr
      LOGICAL exst

      INTEGER varId_intp1, varId_intp2, varId_intp11, varId_intp22
      INTEGER varId_intp3, varId_intp4, varId_intp5, iq, iINTERP
      _RL tmp_i(1000,NUM_INTERP_POINTS)
      _RL tmp_j(1000,NUM_INTERP_POINTS)
      _RL tmp_weights(1000,NUM_INTERP_POINTS),tmp_sum_weights
      _RL tmp_xC11(1000),tmp_yC11(1000)
      _RL tmp_xCNINJ(1000),tmp_yCNINJ(1000)
      INTEGER stopGenericGrid
      Real*8 xy_buffer_r8(0:sNx+1,0:sNy+1)
      INTEGER vec_start2(2), vec_count2(2)
      INTEGER hh, ProfNo_hh
# ifdef ALLOW_PROFILES_SAMPLESPLIT_COST
      INTEGER m, kC, kCMax
      INTEGER varId4
      _RL tmp_avgbin(1000)
# endif /* ALLOW_PROFILES_SAMPLESPLIT_COST */

      iUnit = standardMessageUnit
      WRITE(msgBuf,'(A)') ' '
      CALL PRINT_MESSAGE( msgBuf, iUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)')
     &     '// ======================================================='
      CALL PRINT_MESSAGE( msgBuf, iUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)')
     &     '// insitu profiles model sampling >>> START <<<'
      CALL PRINT_MESSAGE( msgBuf, iUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)')
     &     '// ======================================================='
      CALL PRINT_MESSAGE( msgBuf, iUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)') ' '
      CALL PRINT_MESSAGE( msgBuf, iUnit, SQUEEZE_RIGHT, myThid )

      stopProfiles = 0
      stopGenericGrid = 0

      IF ( (.NOT.profilesDoGenGrid) .AND.
     &     (.NOT.usingSphericalPolarGrid .OR. rotateGrid) ) THEN
       WRITE(msgBuf,'(2A)') 'PROFILES_INIT_FIXED: ',
     &      'profilesDoGenGrid=.true. is required'
       CALL PRINT_ERROR( msgBuf , myThid )
       WRITE(msgBuf,'(2A)') 'PROFILES_INIT_FIXED: ',
     &      'unless usingSphericalGrid=.TRUE. and rotateGrid=.FALSE.'
       CALL PRINT_ERROR( msgBuf , myThid )
       CALL ALL_PROC_DIE( myThid )
       STOP 'ABNORMAL END: S/R PROFILES_INIT_FIXED'
      ENDIF

      WRITE(msgBuf,'(A)') ' '
      CALL PRINT_MESSAGE( msgBuf, iUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)') 'general packages parameters :'

      JL = ILNBLNK( profilesDir )
      IF (JL.NE.0) THEN
       WRITE(msgBuf,'(2A)') '  profilesDir ', profilesDir(1:JL)
      ELSE
       WRITE(msgBuf,'(2A)') '  profilesDir ','./'
      ENDIF

      CALL PRINT_MESSAGE( msgBuf, iUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A,L5)') '  profilesDoGenGrid  ', profilesDoGenGrid
      CALL PRINT_MESSAGE( msgBuf, iUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A,L5)') '  profilesDoNcOutput ', profilesDoNcOutput
      CALL PRINT_MESSAGE( msgBuf, iUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)') ' '
      CALL PRINT_MESSAGE( msgBuf, iUnit, SQUEEZE_RIGHT, myThid )

      _BEGIN_MASTER( myThid )

      DO bj = 1, nSy
       DO bi = 1, nSx
        profiles_curfile_buff(bi,bj) = 0
        yymmddMin=modelstartdate(1)
        yymmddMax=modelenddate(1)
        hhmmssMin=modelstartdate(2)
        hhmmssMax=modelenddate(2)

        DO kLev = 1, NLEVELMAX
         DO ic = 1, 1000
          DO num_var = 1, NVARMAX
           profiles_data_buff  (kLev,ic,num_var,bi,bj) = 0. _d 0
           profiles_weight_buff(kLev,ic,num_var,bi,bj) = 0. _d 0
          ENDDO
         ENDDO
        ENDDO

        DO num_file = 1, NFILESPROFMAX
         ProfNo_hh=0
         profilesfile=' '
         IL = ILNBLNK( profilesfiles(num_file) )
         IF (IL.NE.0) THEN
          WRITE(profilesfile,'(A)') profilesfiles(num_file)(1:IL)
          WRITE(msgBuf,'(A)') ' '
          CALL PRINT_MESSAGE( msgBuf, iUnit, SQUEEZE_RIGHT, myThid )
          WRITE(msgBuf,'(A,I3,2A)') 'profiles file #', num_file,
     &         ' is ', profilesfile(1:IL)
          CALL PRINT_MESSAGE( msgBuf, iUnit, SQUEEZE_RIGHT, myThid )
         ENDIF

         IL = ILNBLNK( profilesfile )
         IF (IL.NE.0) THEN
C===========================================================
C     Open data files and read information
C===========================================================
          WRITE(fnamedatanc,'(2A)') profilesfile(1:IL),'.nc'
          err = NF_OPEN( fnamedatanc, NF_NOWRITE,
     &         fiddata(num_file,bi,bj) )
          CALL PROFILES_NF_ERROR(
     &         'INIT_FIXED: NF_OPEN fiddata',err,bi,bj,myThid )

C     1) Read the number of profiles and available dimensions:
          fid = fiddata(num_file,bi,bj)

          err = NF_INQ_DIMID( fid, 'iPROF', dimId )
          CALL PROFILES_NF_ERROR(
     &         'INIT_FIXED: NF_INQ_DIMID iPROF',err,bi,bj,myThid )
          err = NF_INQ_DIMLEN( fid,
     &         dimId, ProfNo(num_file,bi,bj) )
          CALL PROFILES_NF_ERROR(
     &         'INIT_FIXED: NF_INQ_DIMLEN ProfNo',
     &         err,bi,bj,myThid )

          err = NF_INQ_DIMID( fid, 'iDEPTH', dimId )
          CALL PROFILES_NF_ERROR(
     &         'INIT_FIXED: NF_INQ_DIMID iDEPTH',
     &         err,bi,bj,myThid )
          IF (err.NE.NF_NOERR) THEN
           err = NF_INQ_DIMID( fid, 'Z', dimId )
           CALL PROFILES_NF_ERROR(
     &          'INIT_FIXED: NF_INQ_DIMID Z',err,bi,bj,myThid )

          ENDIF

          err = NF_INQ_DIMLEN( fid, dimId,
     &         ProfDepthNo(num_file,bi,bj) )
          CALL PROFILES_NF_ERROR(
     &         'INIT_FIXED: NF_INQ_DIMLEN ProfDepthNo',
     &         err,bi,bj,myThid )

          err = NF_INQ_DIMID( fid, 'iINTERP', dimId )
          IF (err.EQ.NF_NOERR) THEN
           err = NF_INQ_DIMLEN( fid, dimId, iINTERP )
           CALL PROFILES_NF_ERROR(
     &          'INIT_FIXED: NF_INQ_DIMLEN iINTERP',
     &          err,bi,bj,myThid )

          ELSE

           IF (debugLevel .GE. debLevA) THEN
            CALL PROFILES_NF_ERROR(
     &           'INIT_FIXED: NF_INQ_DIMID iINTERP',
     &           err,bi,bj,myThid )
            WRITE(msgBuf,'(3A,I3)')
     &           'S/R PROFILES_INIT_FIXED: ',
     &           'no iINTERP dim in data file using iINTERP ',
     &           '= NUM_INTERP_POINTS =', NUM_INTERP_POINTS
            CALL PRINT_MESSAGE( msgBuf, iUnit, SQUEEZE_RIGHT, myThid )

           ENDIF

           iINTERP = NUM_INTERP_POINTS

          ENDIF

          WRITE(msgBuf,'(2(A,I4))')
     &         '  current tile is bi,bj                      =',
     &         bi,',',bj
          CALL PRINT_MESSAGE( msgBuf, iUnit, SQUEEZE_RIGHT, myThid )
          WRITE(msgBuf,'(A,I9)')
     &         '  # of depth levels in file                  =',
     &         ProfDepthNo(num_file,bi,bj)
          CALL PRINT_MESSAGE( msgBuf, iUnit, SQUEEZE_RIGHT, myThid )
          WRITE(msgBuf,'(A,I9)')
     &         '  # of profiles in file                      =',
     &         ProfNo(num_file,bi,bj)
          CALL PRINT_MESSAGE( msgBuf, iUnit, SQUEEZE_RIGHT, myThid )

C     2) Read dates and positions:
          err = NF_INQ_VARID( fid,'prof_depth', varId1a )
          CALL PROFILES_NF_ERROR(
     &         'INIT_FIXED: NF_INQ_VARID prof_depth',
     &         err,bi,bj,myThid )
          IF (err.NE.NF_NOERR) THEN
C     LEGACY: Try old variable name: depth
           err = NF_INQ_VARID( fid,'depth', varId1a )
           CALL PROFILES_NF_ERROR(
     &          'INIT_FIXED: NF_INQ_VARID depth',
     &          err,bi,bj,myThid )

          ENDIF

          IF (err.NE.NF_NOERR) THEN
C     If neither is found, then stop
           IL = ILNBLNK( profilesfile )
           WRITE(msgBuf,'(4A)')
     &          'PROFILES_INIT_FIXED: file ', profilesfile(1:IL),
     &          '.nc is not in the pkg/profiles format',
     &          ' (no prof_depth etc.)'
           CALL PRINT_ERROR( msgBuf, myThid )

           stopProfiles = 1
          ENDIF

          DO kLev = 1, ProfDepthNo(num_file,bi,bj)
           err = NF_GET_VAR1_DOUBLE( fid, varId1a, kLev,
     &          prof_depth(num_file,kLev,bi,bj) )
           CALL PROFILES_NF_ERROR(
     &          'INIT_FIXED: NF_VAR1_DOUBLE prof_depth',
     &          err,bi,bj,myThid )
          ENDDO

C     Get time, lon, lat varIds
          err = NF_INQ_VARID( fid,'prof_YYYYMMDD', varId1a )
          nerr = err
          CALL PROFILES_NF_ERROR(
     &         'INIT_FIXED: NF_INQ_VARID prof_YYYYMMDD',
     &         err,bi,bj,myThid )
          err = NF_INQ_VARID( fid,'prof_HHMMSS', varId1b )
          nerr = nerr + err
          CALL PROFILES_NF_ERROR(
     &         'INIT_FIXED: NF_INQ_VARID prof_HHMMSS',
     &         err,bi,bj,myThid )
          err = NF_INQ_VARID( fid,'prof_lon', varId2 )
          nerr = nerr + err
          CALL PROFILES_NF_ERROR(
     &         'INIT_FIXED: NF_INQ_VARID prof_lon',
     &         err,bi,bj,myThid )
          err = NF_INQ_VARID( fid,'prof_lat', varId3 )
          nerr = nerr + err
          CALL PROFILES_NF_ERROR(
     &         'INIT_FIXED: NF_INQ_VARID prof_lat',
     &         err,bi,bj,myThid )
# ifdef ALLOW_PROFILES_SAMPLESPLIT_COST
          err = NF_INQ_VARID( fid,'prof_bin_id_a', varId4 )
          nerr = nerr + err
          CALL PROFILES_NF_ERROR(
     &         'INIT_FIXED: NF_INQ_VARID prof_bin_id_a',
     &         err,bi,bj,myThid )
# endif /* ALLOW_PROFILES_SAMPLESPLIT_COST */

          IF (nerr.NE.NF_NOERR) THEN
           IL = ILNBLNK( profilesfile )
           WRITE(msgBuf,'(4A)')
     &          'PROFILES_INIT_FIXED: file ', profilesfile(1:IL),
     &          '.nc not in pkg/profiles format',
     &          ' (no prof_YYYYMMDD etc.)'
           CALL PRINT_ERROR( msgBuf, myThid )

           stopProfiles = 1
          ENDIF

          IF (profilesDoGenGrid) THEN
C     3) Read interpolation information (grid points, coeffs, etc.)
           err = NF_INQ_VARID( fid,'prof_interp_XC11', varId_intp1 )
           nerr = err
           CALL PROFILES_NF_ERROR(
     &          'INIT_FIXED: NF_INQ_VARID prof_interp_XC11',
     &          err,bi,bj,myThid )
           err = NF_INQ_VARID( fid,'prof_interp_YC11', varId_intp2 )
           nerr = nerr + err
           CALL PROFILES_NF_ERROR(
     &          'INIT_FIXED: NF_INQ_VARID prof_interp_YC11',
     &          err,bi,bj,myThid )
           err = NF_INQ_VARID( fid,'prof_interp_XCNINJ', varId_intp11 )
           nerr = nerr + err
           CALL PROFILES_NF_ERROR(
     &          'INIT_FIXED: NF_INQ_VARID prof_interp_XCNINJ',
     &          err,bi,bj,myThid )
           err = NF_INQ_VARID( fid,'prof_interp_YCNINJ', varId_intp22 )
           nerr = nerr + err
           CALL PROFILES_NF_ERROR(
     &          'INIT_FIXED: NF_INQ_VARID prof_interp_YCNINJ',
     &          err,bi,bj,myThid )
           err = NF_INQ_VARID( fid,'prof_interp_weights', varId_intp3 )
           nerr = nerr + err
           CALL PROFILES_NF_ERROR(
     &          'INIT_FIXED: NF_INQ_VARID prof_interp_weights',
     &          err,bi,bj,myThid )
           err = NF_INQ_VARID( fid,'prof_interp_i', varId_intp4 )
           nerr = nerr + err
           CALL PROFILES_NF_ERROR(
     &          'INIT_FIXED: NF_INQ_VARID prof_interp_i',
     &          err,bi,bj,myThid )
           err = NF_INQ_VARID( fid,'prof_interp_j', varId_intp5 )
           nerr = nerr + err
           CALL PROFILES_NF_ERROR(
     &          'INIT_FIXED: NF_INQ_VARID prof_interp_j',
     &          err,bi,bj,myThid )

           IF (nerr.NE.NF_NOERR) THEN
            IL = ILNBLNK( profilesfile )
            WRITE(msgBuf,'(4A)')
     &           'PROFILES_INIT_FIXED: file ', profilesfile(1:IL),
     &           '.nc missing interpolation information',
     &           ' (profilesDoGenGrid)'
            CALL PRINT_ERROR( msgBuf, myThid )

            stopGenericGrid = 2
           ENDIF
          ENDIF !IF (profilesDoGenGrid)

C     4) Default values
          DO prof_num = 1, NOBSGLOB
           prof_time     (num_file,prof_num,bi,bj) = -999. _d 0
           prof_lon      (num_file,prof_num,bi,bj) = -999. _d 0
           prof_lat      (num_file,prof_num,bi,bj) = -999. _d 0
           prof_ind_glob (num_file,prof_num,bi,bj) = 0
# ifdef ALLOW_PROFILES_SAMPLESPLIT_COST
           prof_ind_avgbin(num_file,prof_num,bi,bj) = -999
# endif /* ALLOW_PROFILES_SAMPLESPLIT_COST */

           DO iq = 1, NUM_INTERP_POINTS
            prof_interp_i(num_file,prof_num,iq,bi,bj) = 1
            prof_interp_j(num_file,prof_num,iq,bi,bj) = 1
            prof_interp_weights(num_file,prof_num,iq,bi,bj) = 0. _d 0
           ENDDO

           prof_interp_xC11  (num_file,prof_num,bi,bj) = -999. _d 0
           prof_interp_yC11  (num_file,prof_num,bi,bj) = -999. _d 0
           prof_interp_xCNINJ(num_file,prof_num,bi,bj) = -999. _d 0
           prof_interp_yCNINJ(num_file,prof_num,bi,bj) = -999. _d 0
          ENDDO !DO prof_num

C     5) Main loop: look for profiles in this bi,bj tile
          ProfNo_tile = 0
          profNo_div1000 = MAX(0,INT(ProfNo(num_file,bi,bj)/1000))

          DO chunkProf = 1, profno_div1000+1
C     5.1) Read a chunk
           chunk = 1000*(chunkProf-1)

           IF (MIN(ProfNo(num_file,bi,bj), 1000*chunkProf).GE.
     &          1+chunk) THEN
            vec_start(1) = 1
            vec_start(2) = 1+chunk
            vec_count(1) = 1
            vec_count(2) = MIN(1000, ProfNo(num_file,bi,bj)-chunk)

            IF ( (vec_count(2).LE.0) .OR.
     &           (vec_count(2).GT.1000) .OR.
     &           (vec_start(2).LE.0) .OR.
     &           (vec_count(2)+vec_start(2)-1.GT.
     &           ProfNo(num_file,bi,bj)) ) THEN
             IL  = ILNBLNK( profilesfile )
             WRITE(msgBuf,'(3A)')
     &            'PROFILES_INIT_FIXED: file ',profilesfile(1:IL),
     &            '.nc was not read properly (case 1).'
             CALL PRINT_ERROR( msgBuf, myThid )

             stopProfiles = 1
            ENDIF

            err = NF_GET_VARA_DOUBLE( fid, varId1a,
     &           vec_start(2),vec_count(2), tmpyymmdd )
            nerr = err
            CALL PROFILES_NF_ERROR(
     &           'INIT_FIXED: NF_GET_VARA_DOUBLE tmpyymmdd',
     &           err,bi,bj,myThid )
            err = NF_GET_VARA_DOUBLE( fid, varId1b,
     &           vec_start(2), vec_count(2), tmphhmmss )
            nerr = nerr + err
            CALL PROFILES_NF_ERROR(
     &           'INIT_FIXED: NF_GET_VARA_DOUBLE tmphhmmss',
     &           err,bi,bj,myThid )
            err = NF_GET_VARA_DOUBLE( fid, varId2,
     &           vec_start(2),vec_count(2), tmp_lon2 )
            nerr = nerr + err
            CALL PROFILES_NF_ERROR(
     &           'INIT_FIXED: NF_GET_VARA_DOUBLE tmp_lon2',
     &           err,bi,bj,myThid )
            err = NF_GET_VARA_DOUBLE( fid, varId3,
     &           vec_start(2),vec_count(2), tmp_lat2 )
            nerr = nerr + err
            CALL PROFILES_NF_ERROR(
     &           'INIT_FIXED: NF_GET_VARA_DOUBLE tmp_lat2',
     &           err,bi,bj,myThid )
# ifdef ALLOW_PROFILES_SAMPLESPLIT_COST
            err = NF_GET_VARA_DOUBLE( fid, varId4,
     &           vec_start(2),vec_count(2), tmp_avgbin )
            nerr = nerr + err
            CALL PROFILES_NF_ERROR(
     &           'INIT_FIXED: NF_GET_VARA_DOUBLE tmp_avgbin',
     &           err,bi,bj,myThid )
# endif /* ALLOW_PROFILES_SAMPLESPLIT_COST */

            IF (nerr.NE.NF_NOERR) THEN
             WRITE(msgBuf,'(3A)')
     &            'PROFILES_INIT_FIXED: file ', profilesfile(1:IL),
     &            '.nc get_vara_double (case 2).'
             CALL PRINT_ERROR( msgBuf, myThid )

             stopProfiles = 1
            ENDIF

C     If profilesDoGenGrid, then read interpolation coeffs and indices
            IF (profilesDoGenGrid) THEN
             err = NF_GET_VARA_DOUBLE( fid, varId_intp1,
     &            vec_start(2),vec_count(2), tmp_xC11 )
             CALL PROFILES_NF_ERROR(
     &            'INIT_FIXED: NF_GET_VARA_DOUBLE tmp_xC11',
     &            err,bi,bj,myThid )
             err = NF_GET_VARA_DOUBLE( fid, varId_intp2,
     &            vec_start(2),vec_count(2), tmp_yC11 )
             CALL PROFILES_NF_ERROR(
     &            'INIT_FIXED: NF_GET_VARA_DOUBLE tmp_yC11',
     &            err,bi,bj,myThid )
             err = NF_GET_VARA_DOUBLE( fid, varId_intp11,
     &            vec_start(2),vec_count(2), tmp_xCNINJ )
             CALL PROFILES_NF_ERROR(
     &            'INIT_FIXED: NF_GET_VARA_DOUBLE tmp_xCNINJ',
     &            err,bi,bj,myThid )
             err = NF_GET_VARA_DOUBLE( fid, varId_intp22,
     &            vec_start(2),vec_count(2), tmp_yCNINJ )
             CALL PROFILES_NF_ERROR(
     &            'INIT_FIXED: NF_GET_VARA_DOUBLE tmp_yCNINJ',
     &            err,bi,bj,myThid )

             DO iq = 1, iINTERP
              vec_start2(1) = iq
              vec_start2(2) = 1+chunk
              vec_count2(1) = 1
              vec_count2(2) = MIN(1000,ProfNo(num_file,bi,bj)-chunk)

              err = NF_GET_VARA_DOUBLE( fid, varId_intp3,
     &             vec_start2,vec_count2, tmp_weights(1,iq) )
              CALL PROFILES_NF_ERROR(
     &             'INIT_FIXED: NF_GET_VARA_DOUBLE tmp_weights',
     &             err,bi,bj,myThid )
              err = NF_GET_VARA_DOUBLE( fid, varId_intp4,
     &             vec_start2,vec_count2, tmp_i(1,iq) )
              CALL PROFILES_NF_ERROR(
     &             'INIT_FIXED: NF_GET_VARA_DOUBLE tmp_i',
     &             err,bi,bj,myThid )
              err = NF_GET_VARA_DOUBLE(fid, varId_intp5,
     &             vec_start2,vec_count2, tmp_j(1,iq) )
              CALL PROFILES_NF_ERROR(
     &             'INIT_FIXED: NF_GET_VARA_DOUBLE tmp_j',
     &             err,bi,bj,myThid )
             ENDDO
            ENDIF !IF (profilesDoGenGrid)

C     5.2) Loop through this chunk
            DO ic = 1, MIN(1000,ProfNo(num_file,bi,bj)-chunk)
             IF (stopProfiles.EQ.0) THEN

              profIsInRunTime = 1

              IF (( (tmpyymmdd(ic).GT.yymmddMin).OR.
     &             ((tmpyymmdd(ic).EQ.yymmddMin) .AND.
     &              (tmphhmmss(ic).GT.hhmmssMin)) ) .AND.
     &            ( (tmpyymmdd(ic).LT.yymmddMax).OR.
     &             ((tmpyymmdd(ic).EQ.yymmddMax) .AND.
     &              (tmphhmmss(ic).LT.hhmmssMax)) )) THEN
               hh = INT(tmphhmmss(ic))/10000
               IF (hh.LT.hoursPerDay) THEN
                profIsInRunTime = 1

                CALL CAL_FULLDATE( INT(tmpyymmdd(ic)),
     &               INT(tmphhmmss(ic)),tmpdate,myThid )
                CALL CAL_TIMEPASSED( modelstartdate,tmpdate,
     &               tmpdiff,myThid )
                CALL CAL_TOSECONDS(
     &               tmpdiff,diffsecs,myThid )

                diffsecs = diffsecs+nIter0*deltaTClock

               ELSE
C     If tmp hhmmss is out of range then disregard profile
                profIsInRunTime = 0
                diffsecs  = -deltaTClock
                ProfNo_hh = ProfNo_hh+1
               ENDIF

              ELSE

               profIsInRunTime = 0
               diffsecs = -deltaTClock

              ENDIF !IF (( (tmpyymmdd(ic)

C     5.2a) Determine profiles in current tile domain (lat-lon grid case)
              IF ( (.NOT.profilesDoGenGrid) .AND.
     &             (profIsInRunTime.EQ.1) ) THEN
               IF (xC(sNx+1,1,bi,bj).LT.xC(1,1,bi,bj)) THEN
                tmp_lon = xC(sNx+1,1,bi,bj)+360. _d 0
               ELSE
                tmp_lon = xC(sNx+1,1,bi,bj)
               ENDIF

               IF ( (xC(1,1,bi,bj).LE.tmp_lon2(ic)) .AND.
     &              (tmp_lon.GT.tmp_lon2(ic)) .AND.
     &              (yC(1,1,bi,bj).LE.tmp_lat2(ic)) .AND.
     &              (yC(1,sNy+1,bi,bj).GT.tmp_lat2(ic)) ) THEN
                lon_cur = tmp_lon2(ic)
                lat_cur = tmp_lat2(ic)
               ELSEIF ( (xC(sNx+1,1,bi,bj).LT.xC(1,1,bi,bj))
     &               .AND. (xC(1,1,bi,bj).LE. tmp_lon2(ic)+360. _d 0)
     &               .AND. (tmp_lon.GT.tmp_lon2(ic)+360. _d 0)
     &               .AND. (yC(1,1,bi,bj).LE.tmp_lat2(ic))
     &               .AND. (yC(1,sNy+1,bi,bj).GT.tmp_lat2(ic)) ) THEN
                lon_cur = tmp_lon2(ic)+360. _d 0
                lat_cur = tmp_lat2(ic)
               ELSE
                profIsInRunTime = 0
               ENDIF

C     Determine value of i,j to the south-ouest of data point
               prof_i = -10
               prof_j = -10
               lon_1  = -10
               lon_2  = -10
               lat_1  = -10
               lat_2  = -10

               IF (profIsInRunTime.EQ.1) THEN
                DO j = 1, sNy+1
                 DO i = 1, sNx+1
C     Value of j, south of the data point:
                  IF ( (yC(i,j,bi,bj).LE.lat_cur) .AND.
     &                 (yC(i,j+1,bi,bj).GT.lat_cur) ) THEN
                   prof_j = j
                   lat_1  = yC(i,j,bi,bj)
                   lat_2  = yC(i,j+1,bi,bj)
                  ENDIF

C     Value of i, west of the data point:
                  IF (xC(i+1,j,bi,bj).LT.xC(1,j,bi,bj)) THEN
                   lon_tmp2 = xC(i+1,j,bi,bj)+360
                  ELSE
                   lon_tmp2 = xC(i+1,j,bi,bj)
                  ENDIF
                  IF (xC(i,j,bi,bj).LT.xC(1,j,bi,bj)) THEN
                   lon_tmp1 = xC(i,j,bi,bj)+360
                  ELSE
                   lon_tmp1 = xC(i,j,bi,bj)
                  ENDIF

                  IF ( lon_tmp1.LE.lon_cur .AND.
     &                 lon_tmp2.GT.lon_cur ) THEN
                   prof_i = i
                   lon_1  = lon_tmp1
                   lon_2  = lon_tmp2
                  ENDIF

                 ENDDO !DO i
                ENDDO !DO j
               ENDIF !IF (profIsRunTime.EQ.1)

               IF ((prof_i.EQ.-10).OR.(prof_j.EQ.-10)) THEN
                profIsInRunTime = 0
               ENDIF

               IF (profIsInRunTime.EQ.1) THEN
C     If yes then store prof_time and longitude and latitude:
                ProfNo_tile = ProfNo_tile+1
                prof_time(num_file,ProfNo_tile,bi,bj)     =  diffsecs
                prof_lon(num_file,ProfNo_tile,bi,bj)      = lon_cur
                prof_lat(num_file,ProfNo_tile,bi,bj)      = lat_cur
                prof_ind_glob(num_file,ProfNo_tile,bi,bj) = ic+chunk
# ifdef ALLOW_PROFILES_SAMPLESPLIT_COST
                prof_ind_avgbin(num_file,ProfNo_tile,bi,bj)
     &               = tmp_avgbin(ic)
# endif /* ALLOW_PROFILES_SAMPLESPLIT_COST */
C     Then store interpolation coeffs and indices
                lon_fac = (lon_cur-lon_1)/(lon_2-lon_1)
                lat_fac = (lat_cur-lat_1)/(lat_2-lat_1)

                prof_interp_weights(num_file,ProfNo_tile,1,bi,bj)
     &               = (1-lon_fac)*(1-lat_fac)
                prof_interp_i(num_file,ProfNo_tile,1,bi,bj) = prof_i
                prof_interp_j(num_file,ProfNo_tile,1,bi,bj) = prof_j

                prof_interp_weights(num_file,ProfNo_tile,2,bi,bj)
     &               = lon_fac*(1-lat_fac)
                prof_interp_i(num_file,ProfNo_tile,2,bi,bj) = prof_i+1
                prof_interp_j(num_file,ProfNo_tile,2,bi,bj) = prof_j

                prof_interp_weights(num_file,ProfNo_tile,3,bi,bj)
     &               = (1-lon_fac)*lat_fac
                prof_interp_i(num_file,ProfNo_tile,3,bi,bj) = prof_i
                prof_interp_j(num_file,ProfNo_tile,3,bi,bj) = prof_j+1

                prof_interp_weights(num_file,ProfNo_tile,4,bi,bj)
     &               = lon_fac*lat_fac
                prof_interp_i(num_file,ProfNo_tile,4,bi,bj) = prof_i+1
                prof_interp_j(num_file,ProfNo_tile,4,bi,bj) = prof_j+1
               ENDIF !IF (profIsRunTime.EQ.1)

C     5.2a) Determine profiles in current tile domain (gen grid case)
              ELSEIF (profIsInRunTime.EQ.1) THEN

               IF (stopGenericGrid.EQ.0) THEN
                IF (ABS(tmp_xC11(ic)-xC(1,1,bi,bj)).LT.0.0001 _d 0
     &         .AND.ABS(tmp_yC11(ic)-yC(1,1,bi,bj)).LT.0.0001 _d 0
     &         .AND.ABS(tmp_xCNINJ(ic)-xC(sNx,sNy,bi,bj)).LT.0.0001 _d 0
     &         .AND.ABS(tmp_yCNINJ(ic)-yC(sNx,sNy,bi,bj)).LT.0.0001 _d 0
     &         .AND.profIsInRunTime.EQ.1 ) THEN
C     If yes then store prof_time and interpolation coeffs and indices:
                 ProfNo_tile = ProfNo_tile+1
                 prof_time(num_file,ProfNo_tile,bi,bj) = diffsecs
# ifdef ALLOW_PROFILES_SAMPLESPLIT_COST
                 prof_ind_avgbin(num_file,ProfNo_tile,bi,bj)
     &                = tmp_avgbin(ic)
# endif /* ALLOW_PROFILES_SAMPLESPLIT_COST */
                 prof_interp_xC11(num_file,ProfNo_tile,bi,bj)
     &                = tmp_xC11(ic)
                 prof_interp_yC11(num_file,ProfNo_tile,bi,bj)
     &                = tmp_yC11(ic)
                 prof_interp_xCNINJ(num_file,ProfNo_tile,bi,bj)
     &                = tmp_xCNINJ(ic)
                 prof_interp_yCNINJ(num_file,ProfNo_tile,bi,bj)
     &                = tmp_yCNINJ(ic)
                 tmp_sum_weights = 0. _d 0

                 DO iq = 1, iINTERP

                  prof_interp_weights(num_file,ProfNo_tile,iq,bi,bj)
     &                 = tmp_weights(ic,iq)
                  prof_interp_i(num_file,ProfNo_tile,iq,bi,bj)
     &                 = INT(tmp_i(ic,iq))
                  prof_interp_j(num_file,ProfNo_tile,iq,bi,bj)
     &                 = INT(tmp_j(ic,iq))
                  tmp_sum_weights = tmp_sum_weights + tmp_weights(ic,iq)
C     More test of the inputs: is the offline-computed
C     Interpolation information consistent (self and with grid)
                  IF ( tmp_i(ic,iq).LT.0     .OR. tmp_j(ic,iq).LT.0 .OR.
     &                 tmp_i(ic,iq).GT.sNx+1 .OR. tmp_j(ic,iq).GT.sNy+1
     &                 ) THEN
                   WRITE(msgBuf,'(4A)')
     &                  'PROFILES_INIT_FIXED: file ',
     &                  profilesfile(1:IL),
     &                  '.nc has inconsistent interp ',
     &                  '(profilesDoGenGrid; out of tile)'
                   CALL PRINT_ERROR( msgBuf, myThid )

                   stopGenericGrid = 1
                  ENDIF

# ifdef ALLOW_PROFILES_EXCLUDE_CORNERS
                  IF (tmp_weights(ic,iq).NE.0. _d 0) THEN
C     We should not reach the corners just outside of the current tile.
c             IF ( (tmp_i(ic,iq).EQ.0.AND.tmp_j(ic,iq).EQ.0)
c    &        .OR. (tmp_i(ic,iq).EQ.sNx+1.AND.tmp_j(ic,iq).EQ.sNy+1)
c    &        .OR. (tmp_i(ic,iq).EQ.0.AND.tmp_j(ic,iq).EQ.sNy+1)
c    &        .OR. (tmp_i(ic,iq).EQ.sNx+1.AND.tmp_j(ic,iq).EQ.0) ) THEN
C     This should be the same, fewer evaluations, and easier to read?
                   IF((tmp_i(ic,iq).EQ.0.OR.tmp_i(ic,iq).EQ.sNx+1) .AND.
     &                (tmp_j(ic,iq).EQ.0.OR.tmp_j(ic,iq).EQ.sNy+1)
     &                ) THEN
                    WRITE(msgBuf,'(5A)')
     &                   'PROFILES_INIT_FIXED: file ',
     &                   profilesfile(1:IL),
     &                   '.nc has inconsistent interp',
     &                   '(profilesDoGenGrid; overlapping',
     &                   'corner)'
                    CALL PRINT_ERROR( msgBuf, myThid )

                    stopGenericGrid = 1
                   ENDIF
                  ENDIF
# endif /* ALLOW_PROFILES_EXCLUDE_CORNERS */

                  IF ( (tmp_weights(ic,iq).LT.0. _d 0) .OR.
     &                 (tmp_weights(ic,iq).GT.1. _d 0) ) THEN
                   WRITE(msgBuf,'(5A)')
     &                  'PROFILES_INIT_FIXED: file ',
     &                  profilesfile(1:IL),
     &                  '.nc has inconsistent interp',
     &                  'weights (profilesDoGenGrid; ',
     &                  'sum oustide 0-1)'
                   CALL PRINT_ERROR( msgBuf, myThid)

                   stopGenericGrid = 1
                  ENDIF

                 ENDDO !DO iq

                 IF (ABS(tmp_sum_weights -1. _d 0).GT. 0.0001 _d 0) THEN
                  WRITE(msgBuf,'(4A)')
     &                 'PROFILES_INIT_FIXED: file ', profilesfile(1:IL),
     &                 '.nc has inconsistent interp weights',
     &                 ' (profilesDoGenGrid; dont add to 1)'
                  CALL PRINT_ERROR( msgBuf, myThid)

                  stopGenericGrid = 1
                 ENDIF

                 prof_ind_glob(num_file,ProfNo_tile,bi,bj) = ic + chunk

                ENDIF !IF ( ( ABS(tmp_xC11(ic)...
               ENDIF !IF (stopGenericGrid.EQ.0)
              ENDIF!IF (.NOT.profilesDoGenGrid ... ELSEIF ...

C     Check that maximum size was not reached:
              IF (ProfNo_tile.GE.NOBSGLOB) THEN
               WRITE(msgBuf,'(3A)')
     &              'PROFILES_INIT_FIXED: file ', profilesfile(1:IL),
     &              '.nc not read properly (increase NOBSGLOB).'
               CALL PRINT_ERROR( msgBuf, myThid)

               stopProfiles = 1

              ENDIF

             ENDIF !IF (stopProfiles.EQ.0)
            ENDDO !DO ic

           ENDIF !IF (MIN(ProfNo(num_file,bi,bj)
          ENDDO !DO chunkProf

          ProfNo(num_file,bi,bj) = ProfNo_tile

          WRITE(msgBuf,'(A,I9)')
     &         '  # of profiles with erroneous HHMMSS values =',
     &         ProfNo_hh
          CALL PRINT_MESSAGE( msgBuf, iUnit, SQUEEZE_RIGHT, myThid )

          WRITE(msgBuf,'(A,I9)')
     &         '  # of profiles within tile and time period  =',
     &         ProfNo(num_file,bi,bj)
          CALL PRINT_MESSAGE( msgBuf, iUnit, SQUEEZE_RIGHT, myThid )

C     6) Available variables in the data set
          DO num_var = 1, NVARMAX
           prof_num_var_cur(num_file,num_var,bi,bj) = 0
          ENDDO
          prof_num_var_tot(num_file,bi,bj) = 0

          DO num_var = 1, NVARMAX
           JL = ILNBLNK( prof_names(num_file,num_var) )
           err = NF_INQ_VARID( fid,
     &          prof_names(num_file,num_var)(1:JL), varId1 )

           IF (err.EQ.NF_NOERR) THEN
            vec_quantities(num_file,num_var,bi,bj) = .TRUE.

            prof_num_var_tot(num_file,bi,bj) =
     &           prof_num_var_tot(num_file,bi,bj) + 1
            prof_num_var_cur(num_file,num_var,bi,bj) =
     &           prof_num_var_tot(num_file,bi,bj)
           ELSE
            CALL PROFILES_NF_ERROR(
     &           'INIT_FIXED: NF_INQ_VARID prof_names = '//
     &           prof_names(num_file,num_var)(1:JL),err,bi,bj,myThid )
            IF (debugLevel .GE. debLevA) THEN
             WRITE(msgBuf,'(3A)') 'S/R PROFILES_INIT_FIXED: no ',
     &            prof_names(num_file,num_var)(1:JL),
     &            ', setting corresponding vec_quantities = F'
             CALL PRINT_MESSAGE( msgBuf, iUnit, SQUEEZE_RIGHT, myThid )
            ENDIF
            vec_quantities(num_file,num_var,bi,bj) = .FALSE.
           ENDIF

           IF (vec_quantities(num_file,num_var,bi,bj)) THEN
            KL = ILNBLNK( prof_names(num_file,num_var) )
            JL = ILNBLNK( prof_namesmod(num_file,num_var) )

            IF (prof_namesmod(num_file,num_var).EQ.'pTracer') THEN
             WRITE(msgBuf,'(A,I3,5A,I3)') '  variable #',
     &            num_var,' is ' ,
     &            prof_names(num_file,num_var)(1:KL),' and ',
     &            prof_namesmod(num_file,num_var)(1:JL),' #',
     &            prof_itracer(num_file,num_var)
            ELSE
             WRITE(msgBuf,'(A,I3,4A)') '  variable #',
     &            num_var,' is            ' ,
     &            prof_names(num_file,num_var)(1:KL),' and ',
     &            prof_namesmod(num_file,num_var)(1:JL)
            ENDIF
            CALL PRINT_MESSAGE( msgBuf, iUnit, SQUEEZE_RIGHT, myThid )
           ENDIF !IF (vec_quantities
          ENDDO !DO num_var

C===========================================================
C     Create files for model counterparts to observations
C===========================================================

          IF (ProfNo(num_file,bi,bj).GT.0) THEN
           iG=bi+(myXGlobalLo-1)/sNx ! Kludge until unstructered tiles
           jG=bj+(myYGlobalLo-1)/sNy ! Kludge until unstructered tiles
           JL = ILNBLNK( profilesDir )

           IF (profilesDoNcOutput) THEN
            WRITE(fnameequinc,'(3A,2(I3.3,A))')
     &           profilesDir(1:JL),profilesfile(1:IL),
     &           '.',iG,'.',jG,'.equi.nc'
# ifdef ALLOW_ADJOINT_RUN
            WRITE(adfnameequinc,'(4A,2(I3.3,A))')
     &           profilesDir(1:JL),'ad',profilesfile(1:IL),
     &           '.',iG,'.',jG,'.equi.nc'
# endif /* ALLOW_ADJOINT_RUN */
# ifdef ALLOW_TANGENTLINEAR_RUN
            WRITE(tlfnameequinc,'(4A,2(I3.3,A))')
     &           profilesDir(1:JL),'tl',profilesfile(1:IL),
     &           '.',iG,'.',jG,'.equi.nc'
# endif /* ALLOW_TANGENTLINEAR_RUN */

            JL = ILNBLNK( fnameequinc )
            INQUIRE( FILE = fnameequinc(1:JL), EXIST = exst )
            IF (.NOT.exst) THEN
             CALL PROFILES_INIT_NCFILE( num_file,
     &            fiddata(num_file,bi,bj), fnameequinc(1:JL),
     &            fidforward(num_file,bi,bj),
     &            ProfNo(num_file,bi,bj),
     &            ProfDepthNo(num_file,bi,bj),
     &            bi, bj, myThid )
            ELSE
C     Obtain existing NetCDF file id
             err = NF_OPEN( fnameequinc(1:JL), NF_WRITE,
     &            fidforward(num_file,bi,bj) )
             CALL PROFILES_NF_ERROR( 'INIT_FIXED: NF_OPEN fidforward',
     &            err,bi,bj,myThid )
            ENDIF

# ifdef ALLOW_ADJOINT_RUN
            JL = ILNBLNK( adfnameequinc )
            INQUIRE( FILE = adfnameequinc(1:JL), EXIST = exst )
            IF (.NOT.exst) THEN
             CALL PROFILES_INIT_NCFILE( num_file,
     &            fiddata(num_file,bi,bj), adfnameequinc(1:JL),
     &            fidadjoint(num_file,bi,bj),
     &            ProfNo(num_file,bi,bj),
     &            ProfDepthNo(num_file,bi,bj),
     &            bi, bj, myThid )
            ELSE
C     Obtain existing NetCDF file id
             err = NF_OPEN( adfnameequinc(1:JL), NF_WRITE,
     &            fidadjoint(num_file,bi,bj) )
             CALL PROFILES_NF_ERROR( 'INIT_FIXED: NF_OPEN fidadjoint',
     &            err,bi,bj,myThid )
            ENDIF

# endif /* ALLOW_ADJOINT_RUN */
# ifdef ALLOW_TANGENTLINEAR_RUN
            JL = ILNBLNK( tlfnameequinc )
            INQUIRE( FILE = tlfnameequinc(1:JL), EXIST = exst )
            IF (.NOT.exst) THEN
             CALL PROFILES_INIT_NCFILE( num_file,
     &            fiddata(num_file,bi,bj), tlfnameequinc(1:JL),
     &            fidtangent(num_file,bi,bj),
     &            ProfNo(num_file,bi,bj),
     &            ProfDepthNo(num_file,bi,bj),
     &            bi, bj, myThid )
            ELSE
C     Obtain existing NetCDF file id
             err = NF_OPEN( tlfnameequinc(1:JL), NF_WRITE,
     &            fidtangent(num_file,bi,bj) )
             CALL PROFILES_NF_ERROR( 'INIT_FIXED: NF_OPEN fidtangent',
     &            err,bi,bj,myThid )
            ENDIF

# endif /* ALLOW_TANGENTLINEAR_RUN */
           ELSE !IF (profilesDoNcOutput
            WRITE(fnameequinc,'(3A,2(I3.3,A))')
     &           profilesDir(1:JL),profilesfile(1:IL),
     &           '.',iG,'.',jG,'.equi.data'

# ifdef ALLOW_ADJOINT_RUN
            WRITE(adfnameequinc,'(4A,2(I3.3,A))')
     &           profilesDir(1:JL),'ad',profilesfile(1:IL),
     &           '.',iG,'.',jG,'.equi.data'

# endif /* ALLOW_ADJOINT_RUN */
# ifdef ALLOW_TANGENTLINEAR_RUN
            WRITE(tlfnameequinc,'(4A,2(I3.3,A))')
     &           profilesDir(1:JL),'tl',profilesfile(1:IL),
     &           '.',iG,'.',jG,'.equi.data'

# endif /* ALLOW_TANGENTLINEAR_RUN */

            JL = ILNBLNK( fnameequinc )
            INQUIRE( FILE = fnameequinc(1:JL), EXIST = exst )
# ifdef PROFILES_USE_MDSFINDUNITS
            CALL MDSFINDUNIT( fidforward(num_file,bi,bj), myThid )
# else
            CALL PROFILES_FINDUNIT( fidforward(num_file,bi,bj), myThid )
# endif
            IF (.NOT.exst) THEN
             CALL PROFILES_INIT_NCFILE( num_file,
     &            fiddata(num_file,bi,bj), fnameequinc(1:JL),
     &            fidforward(num_file,bi,bj),
     &            ProfNo(num_file,bi,bj),
     &            ProfDepthNo(num_file,bi,bj),
     &            bi, bj, myThid )
            ELSE
             OPEN( fidforward(num_file,bi,bj),
     &            FILE = fnameequinc(1:JL), FORM = 'unformatted',
     &            STATUS = 'unknown', ACCESS = 'direct',
     &            RECL = (ProfDepthNo(num_file,bi,bj)+1)*WORDLENGTH*2 )
            ENDIF

# ifdef ALLOW_ADJOINT_RUN
            JL = ILNBLNK( adfnameequinc )
            INQUIRE( FILE = adfnameequinc(1:JL), EXIST = exst )
#  ifdef PROFILES_USE_MDSFINDUNITS
            CALL MDSFINDUNIT( fidadjoint(num_file,bi,bj), myThid )
#  else
            CALL PROFILES_FINDUNIT( fidadjoint(num_file,bi,bj), myThid )
#  endif
            IF (.NOT.exst) THEN
             CALL PROFILES_INIT_NCFILE( num_file,
     &            fiddata(num_file,bi,bj), adfnameequinc(1:JL),
     &            fidadjoint(num_file,bi,bj),
     &            ProfNo(num_file,bi,bj),
     &            ProfDepthNo(num_file,bi,bj),
     &            bi, bj, myThid )
            ELSE
             OPEN( fidadjoint(num_file,bi,bj),
     &            FILE = adfnameequinc(1:JL), FORM = 'unformatted',
     &            STATUS = 'unknown', ACCESS = 'direct',
     &            RECL = (ProfDepthNo(num_file,bi,bj)+1)*WORDLENGTH*2 )
            ENDIF

# endif /* ALLOW_ADJOINT_RUN */
# ifdef ALLOW_TANGENTLINEAR_RUN
            JL = ILNBLNK( tlfnameequinc )
            INQUIRE( FILE = tlfnameequinc(1:JL), EXIST = exst )
#  ifdef PROFILES_USE_MDSFINDUNITS
            CALL MDSFINDUNIT( fidtangent(num_file,bi,bj), myThid )
#  else
            CALL PROFILES_FINDUNIT( fidtangent(num_file,bi,bj), myThid )
#  endif
            IF (.NOT.exst) THEN
             CALL PROFILES_INIT_NCFILE( num_file,
     &            fiddata(num_file,bi,bj), tlfnameequinc(1:JL),
     &            fidtangent(num_file,bi,bj),
     &            ProfNo(num_file,bi,bj),
     &            ProfDepthNo(num_file,bi,bj),
     &            bi, bj, myThid )
            ELSE
             OPEN( fidtangent(num_file,bi,bj),
     &            FILE = tlfnameequinc(1:JL), FORM = 'unformatted',
     &            STATUS = 'unknown', ACCESS = 'direct',
     &            RECL = (ProfDepthNo(num_file,bi,bj)+1)*WORDLENGTH*2 )
            ENDIF

# endif /* ALLOW_TANGENTLINEAR_RUN */

           ENDIF !IF (profilesDoNcOutput

          ENDIF !IF (ProfNo(num_file,bi,bj).GT.0)

C     ===========================================================
         ELSE !IF (IL.NE.0)

          ProfNo(num_file,bi,bj) = 0

          DO num_var = 1, NVARMAX
           prof_num_var_cur(num_file,num_var,bi,bj) = 0
           vec_quantities(num_file,num_var,bi,bj) = .FALSE.
          ENDDO

          prof_num_var_tot(num_file,bi,bj) = 0

          DO prof_num = 1, NOBSGLOB
           prof_time      (num_file,prof_num,bi,bj) = -999. _d 0
           prof_lon       (num_file,prof_num,bi,bj) = -999. _d 0
           prof_lat       (num_file,prof_num,bi,bj) = -999. _d 0
           prof_ind_glob  (num_file,prof_num,bi,bj) = 0
# ifdef ALLOW_PROFILES_SAMPLESPLIT_COST
           prof_ind_avgbin(num_file,prof_num,bi,bj) = -999
# endif /* ALLOW_PROFILES_SAMPLESPLIT_COST */

           DO iq = 1, NUM_INTERP_POINTS
            prof_interp_i(num_file,prof_num,iq,bi,bj) = 1
            prof_interp_j(num_file,prof_num,iq,bi,bj) = 1
            prof_interp_weights(num_file,prof_num,iq,bi,bj) = 0. _d 0
           ENDDO

           prof_interp_xC11  (num_file,prof_num,bi,bj) = -999. _d 0
           prof_interp_yC11  (num_file,prof_num,bi,bj) = -999. _d 0
           prof_interp_xCNINJ(num_file,prof_num,bi,bj) = -999. _d 0
           prof_interp_yCNINJ(num_file,prof_num,bi,bj) = -999. _d 0
          ENDDO !DO prof_num

         ENDIF !IF (IL.NE.0)

        ENDDO !DO num_file

# ifdef ALLOW_PROFILES_SAMPLESPLIT_COST
C     Find unique depth levels from all profile datasets
C     initialize prof_depth_comb
        IF (bi.EQ.1.AND.bj.EQ.1) THEN
         NLEVELCOMB = 0
         NLEVELCOMBRL = NLEVELCOMB
        ENDIF

        DO kCMax = 1, NLEVELCOMBMAX
         prof_depth_comb(kCMax,bi,bj) = -999. _d 0
        ENDDO

        m = 1
        DO num_file = 1, NFILESPROFMAX
         DO kLev = 1, ProfDepthNo(num_file,bi,bj)
          IF (m.EQ.1) THEN
           prof_depth_comb(m,bi,bj) = prof_depth(num_file,kLev,bi,bj)
           m = m + 1
C     Sort
          ELSE !IF (m.EQ.1)
           DO kCMax = 1, NLEVELCOMBMAX-1
            IF (prof_depth_comb(kCMax,bi,bj) .NE. -999. _d 0) THEN
             IF ( prof_depth(num_file,kLev,bi,bj).LT.
     &            prof_depth_comb(kCMax,bi,bj).AND. kCMax.EQ.1 ) THEN

              prof_depth_comb(NLEVELCOMBMAX,bi,bj) =
     &             prof_depth_comb(kCMax,bi,bj)

              prof_depth_comb(kCMax,bi,bj) =
     &             prof_depth(num_file,kLev,bi,bj)

              DO kC = NLEVELCOMBMAX-1, kCMax+2, -1
               prof_depth_comb(kC,bi,bj) = prof_depth_comb(kC-1,bi,bj)
              ENDDO !DO kC

              prof_depth_comb(kCMax+1,bi,bj) =
     &             prof_depth_comb(NLEVELCOMBMAX,bi,bj)

             ELSEIF ( prof_depth(num_file,kLev,bi,bj).GT.
     &             prof_depth_comb(kCMax,bi,bj) .AND.
     &             prof_depth(num_file,kLev,bi,bj).LT.
     &             prof_depth_comb(kCMax+1,bi,bj) ) THEN

              prof_depth_comb(NLEVELCOMBMAX,bi,bj) =
     &             prof_depth_comb(kCMax+1,bi,bj)

              prof_depth_comb(kCMax+1,bi,bj) =
     &            prof_depth(num_file, kLev,bi,bj)

              DO kC = NLEVELCOMBMAX-1, kCMax+3, -1
               prof_depth_comb(kC,bi,bj) = prof_depth_comb(kC-1,bi,bj)
              ENDDO !DO kC

              prof_depth_comb(kCMax+2,bi,bj)=
     &             prof_depth_comb(NLEVELCOMBMAX,bi,bj)

             ELSEIF ( prof_depth(num_file,kLev,bi,bj).GT.
     &             prof_depth_comb(kCMax,bi,bj) .AND.
     &             prof_depth_comb(kCMax+1,bi,bj).EQ. -999. _d 0 ) THEN

              prof_depth_comb(kCMax+1,bi,bj) =
     &             prof_depth(num_file, kLev,bi,bj)

             ENDIF !IF (prof_depth(num_file,kLev,bi,bj).LT.
            ENDIF !IF (prof_depth_comb(kCMax,bi,bj).NE.-999.
           ENDDO !DO kCMax

          ENDIF !IF (m.EQ.1)

          IF (m.GE.NLEVELCOMBMAX-2) THEN
           WRITE(msgBuf,'(A)') 'increase NLEVELCOMBMAX'
           CALL PRINT_ERROR( msgBuf, myThid )
          ENDIF

         ENDDO ! DO kLev
        ENDDO ! DO num_file

        prof_depth_comb(NLEVELCOMBMAX,bi,bj) = -999. _d 0

C     Diagnostics output
        DO kCMax = 1, NLEVELCOMBMAX
         IF ( prof_depth_comb(kCMax,bi,bj) .GE. 0. _d 0
     &        .AND. NLEVELCOMB.LT.kCMax ) THEN
          NLEVELCOMB = kCMax

          IF (kCMax.GE.NLEVELCOMBMAX-2) THEN
           WRITE(msgBuf,'(A,2I6)')
     &          'increase NLEVELCOMBMAX: kCMax, NLEVELCOMBMA  ',
     &          kCMax, NLEVELCOMBMAX
           CALL PRINT_ERROR( msgBuf, myThid )
          ENDIF
         ENDIF !IF ( prof_depth_comb(m,bi,bj) .GE. 0. _d 0
        ENDDO !DO kCMax

        WRITE(msgBuf,'(A,I6,D20.5)') 'NLEVELCOMB = ', NLEVELCOMB
        CALL PRINT_MESSAGE( msgBuf, iUnit, SQUEEZE_RIGHT, myThid )
# endif /* ALLOW_PROFILES_SAMPLESPLIT_COST */

C===========================================================
C     Error analysis:
C===========================================================

C     1) Provide interpolation information
        IF (stopGenericGrid.EQ.2) THEN
         iG=bi+(myXGlobalLo-1)/sNx ! Kludge until unstructered tiles
         jG=bj+(myYGlobalLo-1)/sNy ! Kludge until unstructered tiles
C     XC grid
         CALL MDSFINDUNIT( fid, myThid )
         WRITE(fnameequinc,'(A,2(I3.3,A),2(I4.4,A))')
     &        'profilesXCincl1PointOverlap.',iG,'.',jG,'.',
     &        sNx,'.',sNy,'.data'

         recLen = MDS_RECLEN( 64,(sNx+2)*(sNy+2),myThid )

         WRITE(iUnit,'(2A,/,A)')
     &        'PROFILES_INIT_FIXED: creating grid from profiles; ',
     &        'file:', fnameequinc
         JL  = ILNBLNK( fnameequinc )
         OPEN( fid, FILE = fnameequinc(1:JL), FORM = 'unformatted',
     &        STATUS = 'unknown', ACCESS = 'direct', RECL = recLen )

         DO j = 0, sNy+1
          DO i = 0, sNx+1
           xy_buffer_r8(i,j) = xC(i,j,bi,bj)
          ENDDO
         ENDDO

# ifdef _BYTESWAPIO
         CALL MDS_BYTESWAPR8( (sNx+2)*(sNy+2),xy_buffer_r8 )
# endif
         WRITE(fid,rec=1) xy_buffer_r8
         CLOSE(fid)
C     YC grid
         CALL MDSFINDUNIT( fid, myThid )
         WRITE(fnameequinc,'(A,2(I3.3,A),2(I4.4,A))')
     &        'profilesYCincl1PointOverlap.',iG,'.',jG,'.',
     &        sNx,'.',sNy,'.data'

         recLen = MDS_RECLEN( 64,(sNx+2)*(sNy+2),myThid )

         WRITE(iUnit,'(2A,/,A)')
     &        'PROFILES_INIT_FIXED: creating grid from profiles; ',
     &        'file:', fnameequinc
         JL  = ILNBLNK( fnameequinc )
         OPEN( fid, FILE = fnameequinc(1:JL), FORM = 'unformatted',
     &        STATUS = 'unknown', ACCESS = 'direct', RECL = recLen )

         DO j = 0, sNy+1
          DO i = 0, sNx+1
           xy_buffer_r8(i,j) = yC(i,j,bi,bj)
          ENDDO
         ENDDO

# ifdef _BYTESWAPIO
         CALL MDS_BYTESWAPR8( (sNx+2)*(sNy+2),xy_buffer_r8 )
# endif
         WRITE(fid,rec=1) xy_buffer_r8
         CLOSE(fid)

         WRITE(msgBuf,'(2A)')
     &        'PROFILES_INIT_FIXED : when using profilesDoGenGrid ',
     &        'you have to provide interpolation coeffs etc. '
         CALL PRINT_ERROR( msgBuf, myThid )

         WRITE(msgBuf,'(2A)')
     &        'and some of your nc files dont have them. ',
     &        'You could use profiles_prep_mygrid.m and/or'
         CALL PRINT_ERROR( msgBuf, myThid )

         WRITE(msgBuf,'(A)')
     &        'use the grid info in profiles*incl1PointOverlap*data'
         CALL PRINT_ERROR( msgBuf, myThid )

         stopProfiles = 1
        ENDIF !IF (stopGenericGrid.EQ.2)

       ENDDO !DO bi
      ENDDO !DO bj

      _END_MASTER( myThid )
      _BARRIER

# ifdef ALLOW_PROFILES_SAMPLESPLIT_COST
      NLEVELCOMBRL = NLEVELCOMB
      _GLOBAL_MAX_RL( NLEVELCOMBRL, myThid )
      NLEVELCOMB = NLEVELCOMBRL
# endif

C     2) Stop after other kind of errors
      CALL GLOBAL_SUM_INT( stopProfiles, myThid )
      IF ( stopProfiles.GE.1) THEN
       CALL ALL_PROC_DIE( myThid )
       STOP 'ABNORMAL END: S/R PROFILES_INIT_FIXED'
      ENDIF

      CALL GLOBAL_SUM_INT( stopGenericGrid, myThid )
      IF ( stopGenericGrid.GE.1) THEN
       CALL ALL_PROC_DIE( myThid )
       STOP 'ABNORMAL END: S/R PROFILES_INIT_FIXED'
      ENDIF

      WRITE(msgBuf,'(A)') ' '
      CALL PRINT_MESSAGE( msgBuf, iUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)')
     &     '// ======================================================='
      CALL PRINT_MESSAGE( msgBuf, iUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)')
     &     '// insitu profiles model sampling >>> END <<<'
      CALL PRINT_MESSAGE( msgBuf, iUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)')
     &     '// ======================================================='
      CALL PRINT_MESSAGE( msgBuf, iUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)') ' '
      CALL PRINT_MESSAGE( msgBuf, iUnit, SQUEEZE_RIGHT, myThid )
#endif /* ALLOW_PROFILES */

      RETURN
      END

#include "SMOOTH_OPTIONS.h"

      SUBROUTINE SMOOTH_IMPLDIFF( bi, bj, iMin, iMax, jMin, jMax,
     I                     deltaTX, KappaRX, recip_hFac,
     U                     gXNm1,
     I                     myThid )

C     *==========================================================*
C     | SUBROUTINE smooth_impldiff
C     | o Copy of model/src/impldiff
C     |    (simplified and with specified time step)
C     *==========================================================*

C     !USES:
      IMPLICIT NONE
C     == Global data ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"

C     !INPUT/OUTPUT PARAMETERS:
      INTEGER bi, bj, iMin, iMax, jMin, jMax
      _RL deltaTX
      _RL KappaRX(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RS recip_hFac(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      _RL gXnm1(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      INTEGER myThid

C     !LOCAL VARIABLES:
      INTEGER i,j,k
      _RL gYnm1(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      _RL a(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL b(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL c(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL bet(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL gam(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
CEOP

C--   Initialise
      DO k=1,Nr
       DO j=jMin,jMax
        DO i=iMin,iMax
         gYNm1(i,j,k,bi,bj) = 0. _d 0
        ENDDO
       ENDDO
      ENDDO

C--   Old aLower
      DO j=jMin,jMax
       DO i=iMin,iMax
         a(i,j,1) = 0. _d 0
       ENDDO
      ENDDO
      DO k=2,Nr
       DO j=jMin,jMax
        DO i=iMin,iMax
          a(i,j,k) = -deltaTX*recip_hFac(i,j,k,bi,bj)*recip_drF(k)
     &               *recip_deepFac2C(k)*recip_rhoFacC(k)
     &               *KappaRX(i,j, k )*recip_drC( k )
     &               *deepFac2F(k)*rhoFacF(k)
          IF (recip_hFac(i,j,k-1,bi,bj).EQ.0.) a(i,j,k)=0.
        ENDDO
       ENDDO
      ENDDO

C--   Old aUpper
      DO k=1,Nr-1
       DO j=jMin,jMax
        DO i=iMin,iMax
          c(i,j,k) = -deltaTX*recip_hFac(i,j,k,bi,bj)*recip_drF(k)
     &               *recip_deepFac2C(k)*recip_rhoFacC(k)
     &               *KappaRX(i,j,k+1)*recip_drC(k+1)
     &               *deepFac2F(k+1)*rhoFacF(k+1)
          IF (recip_hFac(i,j,k+1,bi,bj).EQ.0.) c(i,j,k)=0.
        ENDDO
       ENDDO
      ENDDO
      DO j=jMin,jMax
       DO i=iMin,iMax
         c(i,j,Nr) = 0. _d 0
       ENDDO
      ENDDO

C--   Old aCenter
      DO k=1,Nr
       DO j=jMin,jMax
        DO i=iMin,iMax
          b(i,j,k) = 1. _d 0 - c(i,j,k) - a(i,j,k)
        ENDDO
       ENDDO
      ENDDO

C--   Old and new gam, bet are the same
      DO k=1,Nr
       DO j=jMin,jMax
        DO i=iMin,iMax
          bet(i,j,k) = 1. _d 0
          gam(i,j,k) = 0. _d 0
        ENDDO
       ENDDO
      ENDDO

C--   Only need do anything if Nr>1
      IF (Nr.GT.1) THEN

       k = 1
C--    Beginning of forward sweep (top level)
       DO j=jMin,jMax
        DO i=iMin,iMax
         IF (b(i,j,1).NE.0.) bet(i,j,1) = 1. _d 0 / b(i,j,1)
        ENDDO
       ENDDO

      ENDIF

C--   Middle of forward sweep
      IF (Nr.GE.2) THEN

CADJ loop = sequential
       DO k=2,Nr

        DO j=jMin,jMax
         DO i=iMin,iMax
          gam(i,j,k) = c(i,j,k-1)*bet(i,j,k-1)
          IF ( ( b(i,j,k) - a(i,j,k)*gam(i,j,k) ) .NE. 0.)
     &        bet(i,j,k) = 1. _d 0 / ( b(i,j,k) - a(i,j,k)*gam(i,j,k) )
         ENDDO
        ENDDO

       ENDDO

      ENDIF

      DO j=jMin,jMax
       DO i=iMin,iMax
        gYNm1(i,j,1,bi,bj) = gXNm1(i,j,1,bi,bj)*bet(i,j,1)
       ENDDO
      ENDDO
      DO k=2,Nr
       DO j=jMin,jMax
        DO i=iMin,iMax
         gYnm1(i,j,k,bi,bj) = bet(i,j,k)*
     &        (gXnm1(i,j,k,bi,bj) - a(i,j,k)*gYnm1(i,j,k-1,bi,bj))
        ENDDO
       ENDDO
      ENDDO

C--    Backward sweep
CADJ loop = sequential
       DO k=Nr-1,1,-1
        DO j=jMin,jMax
         DO i=iMin,iMax
          gYnm1(i,j,k,bi,bj)=gYnm1(i,j,k,bi,bj)
     &              -gam(i,j,k+1)*gYnm1(i,j,k+1,bi,bj)
         ENDDO
        ENDDO
       ENDDO

       DO k=1,Nr
        DO j=jMin,jMax
         DO i=iMin,iMax
          gXnm1(i,j,k,bi,bj)=gYnm1(i,j,k,bi,bj)
         ENDDO
        ENDDO
       ENDDO

      RETURN
      END

#include "ATM_CPL_OPTIONS.h"

CBOP
C     !ROUTINE: ATM_STORE_LAND
C     !INTERFACE:
      SUBROUTINE ATM_STORE_LAND(
     I                     bi, bj,
     I                     myTime, myIter, myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE ATM_STORE_LAND
C     | o Routine for saving Land fluxes from LAND pkg
C     |   for export to coupling layer.
C     *==========================================================*
C     | This version interfaces to the LAND package.
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     == Global variables ==
#ifdef ALLOW_LAND
# include "LAND_SIZE.h"
#else
# include "SIZE.h"
#endif

#include "EEPARAMS.h"
#include "PARAMS.h"
#include "CPL_PARAMS.h"
#ifdef ALLOW_LAND
c #include "LAND_PARAMS.h"
# include "LAND_VARS.h"
#endif
C     == Global variables for coupling interface ==
#include "ATMCPL.h"

C     !INPUT/OUTPUT PARAMETERS:
C     bi, bj    :: Tile indices
C     myTime    :: Current model time
C     myIter    :: Current timestep number
C     myThid    :: my Thread Id number
      INTEGER bi, bj
      _RL     myTime
      INTEGER myIter
      INTEGER myThid
CEOP

#ifdef ALLOW_LAND
C     !LOCAL VARIABLES:
C     i, j      :: Loop counters
      INTEGER i, j
      _RL cplTimeFraction

C     o Accumulate RunOff from land bucket that will be exported to the
C       coupling layer. RunOff is per surface unit, in kg/m2/s
       cplTimeFraction = 1. _d 0 / DFLOAT(cplSendFrq_iter)
       RunOffTime(bi,bj) = RunOffTime(bi,bj) + cplTimeFraction
       DO j=1,sNy
        DO i=1,sNx
          RunOffFlux(i,j,bi,bj) = RunOffFlux(i,j,bi,bj)
     &                 + land_runOff(i,j,bi,bj)*cplTimeFraction
        ENDDO
       ENDDO

C     o Accumulate RunOff Energy from land bucket that will be exported
C       to the coupling layer. RunOff Energy is per surface unit, in W/m2.
       cplTimeFraction = 1. _d 0 / DFLOAT(cplSendFrq_iter)
       ROEnFxTime(bi,bj) = ROEnFxTime(bi,bj) + cplTimeFraction
       DO j=1,sNy
        DO i=1,sNx
          RunOffEnFx(i,j,bi,bj) = RunOffEnFx(i,j,bi,bj)
     &                 + land_enRnOf(i,j,bi,bj)*cplTimeFraction
        ENDDO
       ENDDO

#endif /* ALLOW_LAND */

      RETURN
      END

#include "CPP_EEOPTIONS.h"

CBOP
C     !ROUTINE: ALL_PROC_DIE

C     !INTERFACE:
      SUBROUTINE ALL_PROC_DIE( myThArg )

C     !DESCRIPTION:
C     *==========================================================*
C     | SUBROUTINE ALL_PROC_DIE
C     | o when all process call this routine, die cleanly:
C     |   set Error-Flag and call MPI finalise
C     *==========================================================*
C     | used before a STOP:
C     | - Only implemented for MPI multi-proc.
C     | - if some Proc do not call this S/R, MPI will hang.
C     *==========================================================*

C     !USES:
      IMPLICIT NONE

C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "EESUPPORT.h"

C     !INPUT/OUTPUT PARAMETERS:
C     myThArg      :: thread argument (= my Thread Id number
C                  :: or = 0 if called within single-thread section)
      INTEGER myThArg
CEOP

C     !FUNCTIONS
      INTEGER  ILNBLNK
      EXTERNAL ILNBLNK

C     == Local variables ==
C     msgBuf       :: I/O Buffer
C     myThid       :: my Thread Id number
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      INTEGER myThid
#ifdef ALLOW_USE_MPI
C     mpiRC        :: Error code reporting variable used with MPI.
      INTEGER mpiRC
#endif /* ALLOW_USE_MPI */

      myThid = MAX(myThArg,1)
C--   Print message
      WRITE(msgBuf,'(A)') 'S/R ALL_PROC_DIE: ending the run'
      CALL PRINT_ERROR( msgBuf, myThid )

      _BEGIN_MASTER(myThid)

C--   Finishes
      eeEndError = .TRUE.
      fatalError = .TRUE.

C-    Flush IO-unit before MPI termination
      CALL MDS_FLUSH( errorMessageUnit, myThid )
c#ifdef ALLOW_USE_MPI
      CALL MDS_FLUSH( standardMessageUnit, myThid )
c#endif /* ALLOW_USE_MPI */

#ifdef ALLOW_USE_MPI
C- Note: since MPI_INIT is always called, better to also always terminate MPI
C        (even if usingMPI=F) --> comment out test on usingMPI
c     IF ( usingMPI ) THEN
C     better to avoid this call if multi-components set-up ; otherwise will
C     hang here since procs of other comp. are not calling MPI_finalize now.
       IF ( .NOT.( useCoupler .OR.
     &             useNEST_PARENT .OR. useNEST_CHILD .OR.
     &             useNest2W_parent .OR. useNest2W_child )
     &    ) THEN
#ifdef ALLOW_OASIS
         IF ( useOASIS ) CALL OASIS_ABORT
#endif /* ALLOW_OASIS */
         CALL MPI_FINALIZE  ( mpiRC )
         IF ( mpiRC .NE. MPI_SUCCESS ) THEN
          WRITE(msgBuf,'(A,I5)')
     &     'S/R FIN_PROCS: MPI_FINALIZE return code', mpiRC
          CALL PRINT_ERROR( msgBuf, myThid )
         ENDIF
       ENDIF
c     ENDIF
#endif /* ALLOW_USE_MPI */

C-    Some systems do not always flush the IO buffer to disk.
C     To fix this, can either close these files (implies not to write
C     anything after) or flush the io-unit (done above).
c       CLOSE( errorMessageUnit )
#ifdef ALLOW_USE_MPI
C- Note: comment out if usingMPI ... since we always open standardMessageUnit
C        when ALLOW_USE_MPI is defined, better to flush/close also if usingMPI=F
cc    IF ( usingMPI ) THEN
c       CLOSE( standardMessageUnit )
cc    ENDIF
#endif /* ALLOW_USE_MPI */

      _END_MASTER(myThid)

      IF ( myThArg.GE.1 ) THEN
        _BARRIER
      ENDIF

      RETURN
      END

#include "BBL_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 0
C !ROUTINE: BBL_DIAGNOSTICS_STATE

C !INTERFACE:
      SUBROUTINE BBL_DIAGNOSTICS_STATE(
     I                     myTime, myIter, myThid )

C     !DESCRIPTION:
C     Fill-in diagnostics array for BBL state variables

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "BBL.h"

C     !INPUT PARAMETERS:
C     myTime   :: Current time of simulation ( s )
C     myIter   :: Current iteration number in simulation
C     myThid   :: my Thread Id number
      _RL     myTime
      INTEGER myIter, myThid
CEOP

#ifdef ALLOW_BBL
C     !LOCAL VARIABLES:

#ifdef ALLOW_DIAGNOSTICS
      IF ( useDiagnostics ) THEN

         CALL DIAGNOSTICS_FILL( bbl_theta    , 'BBLtheta',
     &                          0, 1, 0, 1, 1, myThid )
         CALL DIAGNOSTICS_FILL( bbl_salt     , 'BBLsalt ',
     &                          0, 1, 0, 1, 1, myThid )
         CALL DIAGNOSTICS_FILL( bbl_eta      , 'BBLeta  ',
     &                          0, 1, 0, 1, 1, myThid )
         CALL DIAGNOSTICS_FILL( bbl_TendTheta, 'BBLtendT',
     &                          0, 1, 0, 1, 1, myThid )
         CALL DIAGNOSTICS_FILL( bbl_TendSalt , 'BBLtendS',
     &                          0, 1, 0, 1, 1, myThid )

      ENDIF
#endif /* ALLOW_DIAGNOSTICS */

#endif /* ALLOW_BBL */

      RETURN
      END

#include "CPP_OPTIONS.h"

CBOP
C     !ROUTINE: STATE_SUMMARY
C     !INTERFACE:
      SUBROUTINE STATE_SUMMARY( myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE STATE_SUMMARY                                  
C     | o Summarize model prognostic variables.                   
C     *==========================================================*
C     | This routine can be called at any time during an          
C     | integration to provide a summary of the model state.      
C     | Note                                                      
C     |  1. Under multi-process parallelism the state summary     
C     |     is only given for the per-process data.               
C     |  2. Under multi-threading the summary is produced by      
C     |     the master thread. This threads reads data managed by 
C     |     other threads.                                        
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "DYNVARS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     myThid -  Number of this instance of STATE_SUMMARY
      INTEGER myThid

C     !LOCAL VARIABLES:
C     == Local variables ==
      CHARACTER*(MAX_LEN_MBUF) msgBuf
CEOP

      _BEGIN_MASTER(myThid)
      WRITE(msgBuf,'(A)')
     &'// ======================================================='
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit, 
     &                    SQUEEZE_RIGHT , myThid )
      WRITE(msgBuf,'(A)') '// Model current state'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit, 
     &                    SQUEEZE_RIGHT , myThid )
      WRITE(msgBuf,'(A)')
     &'// ======================================================='
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT , myThid )
      WRITE(msgBuf,'(A)') ' '
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT , myThid )
      _END_MASTER(myThid)

      RETURN
      END

#include "OBCS_OPTIONS.h"

C--  File obcs_mon_stats.F: compute statistic of a field at OB section
C--   Contents
C--   o OBCS_MON_STATS_EW_RL
C--   o OBCS_MON_STATS_NS_RL

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: OBCS_MON_STATS_EW_RL

C     !INTERFACE:
      SUBROUTINE OBCS_MON_STATS_EW_RL(
     I     tHasOBE, tHasOBW, iEb, iWb, iNone,
     I     kSize, mSize, gPos,
     I     arr, arrhFac, arrDy, arrDr, mskInC,
     O     arrStats,
     I     myThid )

C     !DESCRIPTION:
C     *==========================================================*
C     | SUBROUTINE OBCS_MON_STATS_EW_RL
C     | o Caclulate field statistics at Eastern & Western OB
C     *==========================================================*

C     !USES:
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"

C     !INPUT PARAMETERS:
C     tHasOBE  :: list of OBE active tiles
C     tHasOBW  :: list of OBW active tiles
C     iEb      :: index of Eastern OB
C     iWb      :: index of Western OB
C     iNone    :: null index value
C     kSize    :: field-array 3rd dimension
C     mSize    :: hFac-array  3rd dimension
C     gPos     :: field position on C-grid ( 0=center , 1=U , 2=V , 3=Corner)
C     arr      :: field-array
C     arrhFac  :: hFac factor
C     arrDy    :: grid-cell length along OB
C     arrDr    :: grid-level thickness
C     mskInC   :: 2-d mask defining the interior region (cell centered)
C     myThid   :: my Thread Id number
      LOGICAL tHasOBE(nSx,nSy)
      LOGICAL tHasOBW(nSx,nSy)
      INTEGER iEb(1-OLy:sNy+OLy,nSx,nSy)
      INTEGER iWb(1-OLy:sNy+OLy,nSx,nSy)
      INTEGER iNone
      INTEGER kSize
      INTEGER mSize
      INTEGER gPos
      _RL arr    (1-OLx:sNx+OLx,1-OLy:sNy+OLy,kSize,nSx,nSy)
      _RS arrhFac(1-OLx:sNx+OLx,1-OLy:sNy+OLy,mSize,nSx,nSy)
      _RS arrDy  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RS arrDr  (kSize)
      _RS mskInC (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      INTEGER myThid

C     !OUTPUT PARAMETERS:
C     arrStats :: field statistics at Eatern & Western OB
      _RL arrStats(0:4,2)
CEOP

#ifdef ALLOW_OBCS
#ifdef ALLOW_MONITOR

C     !FUNCTIONS:

C     !LOCAL VARIABLES:
C     bi, bj   :: tile indices
C     j, k     :: loop indices
C     ii, iB   :: local index of open boundary
      INTEGER k
#if (defined ALLOW_OBCS_EAST ) || (defined ALLOW_OBCS_WEST )
      INTEGER bi, bj
      INTEGER j, km
      INTEGER ii, iB
      LOGICAL noPnts
      _RL tmpA, tmpV, tmpMask
      _RL theMin, theMax, theArea, theMean, theVar
      _RL tileArea(nSx,nSy)
      _RL tileMean(nSx,nSy)
      _RL tileVar (nSx,nSy)
#endif

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      DO k=0,4
        arrStats(k,1) = 0. _d 0
      ENDDO
#ifdef ALLOW_OBCS_EAST
      theMin = 0.
      theMax = 0.
      theMean= 0.
      theVar = 0.
      theArea= 0.
      noPnts = .TRUE.
c     IF ( usingEast_OB ) THEN
        DO bj=myByLo(myThid),myByHi(myThid)
         DO bi=myBxLo(myThid),myBxHi(myThid)
          tileArea(bi,bj) = 0.
          tileMean(bi,bj) = 0.
          tileVar (bi,bj) = 0.
          IF ( tHasOBE(bi,bj) ) THEN
           DO k=1,kSize
            km = MIN(k,mSize)
            DO j=1,sNy
             tmpMask = 0.
             ii = iEb(j,bi,bj)
C-    If 1 OB location is on 2 tiles (@ edge of 2 tiles), select the one which
C     communicates with tile interior (sNx+1) rather than with halo region (i=1)
             IF ( ii.NE.iNone .AND. ii.GT.1 ) THEN
              iB = ii
              tmpMask = arrhFac(iB,j,km,bi,bj)
     &                *( mskInC(ii-1,j,bi,bj)-mskInC(ii,j,bi,bj) )
             ENDIF
             IF ( tmpMask.GT.0. _d 0 ) THEN
              tmpV = arr(ii,j,k,bi,bj)
              tmpA = arrDy(iB,j,bi,bj)*arrDr(k)*tmpMask
              IF ( noPnts ) THEN
                theMin = tmpV
                theMax = tmpV
                noPnts = .FALSE.
              ENDIF
              theMin = MIN( theMin, tmpV )
              theMax = MAX( theMax, tmpV )
              tileArea(bi,bj) = tileArea(bi,bj) + tmpA
              tileMean(bi,bj) = tileMean(bi,bj) + tmpA*tmpV
              tileVar (bi,bj) = tileVar (bi,bj) + tmpA*tmpV*tmpV
             ENDIF
            ENDDO
           ENDDO
          ENDIF
         ENDDO
        ENDDO
        CALL GLOBAL_SUM_TILE_RL( tileArea, theArea, myThid )
c     ENDIF
      IF ( theArea.GT.0. ) THEN
        CALL GLOBAL_SUM_TILE_RL( tileMean, theMean, myThid )
        CALL GLOBAL_SUM_TILE_RL( tileVar , theVar , myThid )
        arrStats(0,1) = theArea
        arrStats(1,1) = theMean
        arrStats(2,1) = theVar

        theMean = theMean/theArea
        IF ( noPnts ) theMin = theMean
        theMin = -theMin
        _GLOBAL_MAX_RL(theMin,myThid)
        theMin = -theMin
        IF ( noPnts ) theMax = theMean
        _GLOBAL_MAX_RL(theMax,myThid)
        arrStats(3,1) = theMin
        arrStats(4,1) = theMax

      ENDIF
#endif /* ALLOW_OBCS_EAST */

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      DO k=0,4
        arrStats(k,2) = 0. _d 0
      ENDDO
#ifdef ALLOW_OBCS_WEST
      theMin = 0.
      theMax = 0.
      theMean= 0.
      theVar = 0.
      theArea= 0.
      noPnts = .TRUE.
c     IF ( usingWest_OB ) THEN
        DO bj=myByLo(myThid),myByHi(myThid)
         DO bi=myBxLo(myThid),myBxHi(myThid)
          tileArea(bi,bj) = 0.
          tileMean(bi,bj) = 0.
          tileVar (bi,bj) = 0.
          IF ( tHasOBW(bi,bj) ) THEN
           DO k=1,kSize
            km = MIN(k,mSize)
            DO j=1,sNy
             tmpMask = 0.
             ii = iWb(j,bi,bj)
C-    If 1 OB location is on 2 tiles (@ edge of 2 tiles), select the one which
C     communicates with tile interior (i=0) rather than with halo region (i=sNx)
             IF ( ii.NE.iNone .AND. ii.LT.sNx ) THEN
              iB = ii+1
              tmpMask = arrhFac(iB,j,km,bi,bj)
     &                *( mskInC(ii+1,j,bi,bj)-mskInC(ii,j,bi,bj) )
             ENDIF
             IF ( tmpMask.GT.0. _d 0 ) THEN
              IF ( gPos.EQ.1 .OR. gPos.EQ.3 ) ii = iB
              tmpV = arr(ii,j,k,bi,bj)
              tmpA = arrDy(iB,j,bi,bj)*arrDr(k)*tmpMask
              IF ( noPnts ) THEN
                theMin = tmpV
                theMax = tmpV
                noPnts = .FALSE.
              ENDIF
              theMin = MIN( theMin, tmpV )
              theMax = MAX( theMax, tmpV )
              tileArea(bi,bj) = tileArea(bi,bj) + tmpA
              tileMean(bi,bj) = tileMean(bi,bj) + tmpA*tmpV
              tileVar (bi,bj) = tileVar (bi,bj) + tmpA*tmpV*tmpV
             ENDIF
            ENDDO
           ENDDO
          ENDIF
         ENDDO
        ENDDO
        CALL GLOBAL_SUM_TILE_RL( tileArea, theArea, myThid )
c     ENDIF
      IF ( theArea.GT.0. ) THEN
        CALL GLOBAL_SUM_TILE_RL( tileMean, theMean, myThid )
        CALL GLOBAL_SUM_TILE_RL( tileVar , theVar , myThid )
        arrStats(0,2) = theArea
        arrStats(1,2) = theMean
        arrStats(2,2) = theVar

        theMean = theMean/theArea
        IF ( noPnts ) theMin = theMean
        theMin = -theMin
        _GLOBAL_MAX_RL(theMin,myThid)
        theMin = -theMin
        IF ( noPnts ) theMax = theMean
        _GLOBAL_MAX_RL(theMax,myThid)
        arrStats(3,2) = theMin
        arrStats(4,2) = theMax

      ENDIF
#endif /* ALLOW_OBCS_WEST */

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#endif /* ALLOW_MONITOR */
#endif /* ALLOW_OBCS */

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: OBCS_MON_STATS_NS_RL

C     !INTERFACE:
      SUBROUTINE OBCS_MON_STATS_NS_RL(
     I     tHasOBN, tHasOBS, jNb, jSb, jNone,
     I     kSize, mSize, gPos,
     I     arr, arrhFac, arrDx, arrDr, mskInC,
     O     arrStats,
     I     myThid )

C     !DESCRIPTION:
C     *==========================================================*
C     | SUBROUTINE OBCS_MON_STATS_NS_RL
C     | o Caclulate field statistics at Northern & Southern OB
C     *==========================================================*

C     !USES:
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"

C     !INPUT PARAMETERS:
C     tHasOBN  :: list of OBN active tiles
C     tHasOBS  :: list of OBS active tiles
C     jNb      :: index of Northern OB
C     jSb      :: index of Southern OB
C     jNone    :: null index value
C     kSize    :: field-array 3rd dimension
C     mSize    :: hFac-array  3rd dimension
C     gPos     :: field position on C-grid ( 0=center , 1=U , 2=V , 3=Corner)
C     arr      :: field-array
C     arrhFac  :: hFac factor
C     arrDx    :: grid-cell length along OB
C     arrDr    :: grid-level thickness
C     mskInC   :: 2-d mask defining the interior region (cell centered)
C     myThid   :: my Thread Id number
      LOGICAL tHasOBN(nSx,nSy)
      LOGICAL tHasOBS(nSx,nSy)
      INTEGER jNb(1-OLx:sNx+OLx,nSx,nSy)
      INTEGER jSb(1-OLx:sNx+OLx,nSx,nSy)
      INTEGER jNone
      INTEGER kSize
      INTEGER mSize
      INTEGER gPos
      _RL arr    (1-OLx:sNx+OLx,1-OLy:sNy+OLy,kSize,nSx,nSy)
      _RS arrhFac(1-OLx:sNx+OLx,1-OLy:sNy+OLy,mSize,nSx,nSy)
      _RS arrDx  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RS arrDr  (kSize)
      _RS mskInC (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      INTEGER myThid

C     !OUTPUT PARAMETERS:
C     arrStats :: field statistics at Northern & Southern OB
      _RL arrStats(0:4,2)
CEOP

#ifdef ALLOW_OBCS
#ifdef ALLOW_MONITOR

C     !FUNCTIONS:

C     !LOCAL VARIABLES:
C     bi, bj   :: tile indices
C     i, k     :: loop indices
C     jj, jB   :: local index of open boundary
      INTEGER k
#if (defined ALLOW_OBCS_NORTH) || (defined ALLOW_OBCS_SOUTH)
      INTEGER bi, bj
      INTEGER i, km
      INTEGER jj, jB
      LOGICAL noPnts
      _RL tmpA, tmpV, tmpMask
      _RL theMin, theMax, theArea, theMean, theVar
      _RL tileArea(nSx,nSy)
      _RL tileMean(nSx,nSy)
      _RL tileVar (nSx,nSy)
#endif

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      DO k=0,4
        arrStats(k,1) = 0. _d 0
      ENDDO
#ifdef ALLOW_OBCS_NORTH
      theMin = 0.
      theMax = 0.
      theMean= 0.
      theVar = 0.
      theArea= 0.
      noPnts = .TRUE.
c     IF ( usingNorth_OB ) THEN
        DO bj=myByLo(myThid),myByHi(myThid)
         DO bi=myBxLo(myThid),myBxHi(myThid)
          tileArea(bi,bj) = 0.
          tileMean(bi,bj) = 0.
          tileVar (bi,bj) = 0.
          IF ( tHasOBN(bi,bj) ) THEN
           DO k=1,kSize
            km = MIN(k,mSize)
            DO i=1,sNx
             tmpMask = 0.
             jj = jNb(i,bi,bj)
C-    If 1 OB location is on 2 tiles (@ edge of 2 tiles), select the one which
C     communicates with tile interior (sNy+1) rather than with halo region (j=1)
             IF ( jj.NE.jNone .AND. jj.GT.1 ) THEN
              jB = jj
              tmpMask = arrhFac(i,jB,km,bi,bj)
     &                *( mskInC(i,jj-1,bi,bj)-mskInC(i,jj,bi,bj) )
             ENDIF
             IF ( tmpMask.GT.0. _d 0 ) THEN
              tmpV = arr(i,jj,k,bi,bj)
              tmpA = arrDx(i,jB,bi,bj)*arrDr(k)*tmpMask
              IF ( noPnts ) THEN
                theMin = tmpV
                theMax = tmpV
                noPnts = .FALSE.
              ENDIF
              theMin = MIN( theMin, tmpV )
              theMax = MAX( theMax, tmpV )
              tileArea(bi,bj) = tileArea(bi,bj) + tmpA
              tileMean(bi,bj) = tileMean(bi,bj) + tmpA*tmpV
              tileVar (bi,bj) = tileVar (bi,bj) + tmpA*tmpV*tmpV
             ENDIF
            ENDDO
           ENDDO
          ENDIF
         ENDDO
        ENDDO
        CALL GLOBAL_SUM_TILE_RL( tileArea, theArea, myThid )
c     ENDIF
      IF ( theArea.GT.0. ) THEN
        CALL GLOBAL_SUM_TILE_RL( tileMean, theMean, myThid )
        CALL GLOBAL_SUM_TILE_RL( tileVar , theVar , myThid )
        arrStats(0,1) = theArea
        arrStats(1,1) = theMean
        arrStats(2,1) = theVar

        theMean = theMean/theArea
        IF ( noPnts ) theMin = theMean
        theMin = -theMin
        _GLOBAL_MAX_RL(theMin,myThid)
        theMin = -theMin
        IF ( noPnts ) theMax = theMean
        _GLOBAL_MAX_RL(theMax,myThid)
        arrStats(3,1) = theMin
        arrStats(4,1) = theMax

      ENDIF
#endif /* ALLOW_OBCS_NORTH */

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      DO k=0,4
        arrStats(k,2) = 0. _d 0
      ENDDO
#ifdef ALLOW_OBCS_SOUTH
      theMin = 0.
      theMax = 0.
      theMean= 0.
      theVar = 0.
      theArea= 0.
      noPnts = .TRUE.
c     IF ( usingSouth_OB ) THEN
        DO bj=myByLo(myThid),myByHi(myThid)
         DO bi=myBxLo(myThid),myBxHi(myThid)
          tileArea(bi,bj) = 0.
          tileMean(bi,bj) = 0.
          tileVar (bi,bj) = 0.
          IF ( tHasOBS(bi,bj) ) THEN
           DO k=1,kSize
            km = MIN(k,mSize)
            DO i=1,sNx
             tmpMask = 0.
             jj = jSb(i,bi,bj)
C-    If 1 OB location is on 2 tiles (@ edge of 2 tiles), select the one which
C     communicates with tile interior (j=0) rather than with halo region (j=sNy)
             IF ( jj.NE.jNone .AND. jj.LT.sNy ) THEN
              jB = jj+1
              tmpMask = arrhFac(i,jB,km,bi,bj)
     &                *( mskInC(i,jj+1,bi,bj)-mskInC(i,jj,bi,bj) )
             ENDIF
             IF ( tmpMask.GT.0. _d 0 ) THEN
              IF ( gPos.EQ.2 .OR. gPos.EQ.3 ) jj = jB
              tmpV = arr(i,jj,k,bi,bj)
              tmpA = arrDx(i,jB,bi,bj)*arrDr(k)*tmpMask
              IF ( noPnts ) THEN
                theMin = tmpV
                theMax = tmpV
                noPnts = .FALSE.
              ENDIF
              theMin = MIN( theMin, tmpV )
              theMax = MAX( theMax, tmpV )
              tileArea(bi,bj) = tileArea(bi,bj) + tmpA
              tileMean(bi,bj) = tileMean(bi,bj) + tmpA*tmpV
              tileVar (bi,bj) = tileVar (bi,bj) + tmpA*tmpV*tmpV
             ENDIF
            ENDDO
           ENDDO
          ENDIF
         ENDDO
        ENDDO
        CALL GLOBAL_SUM_TILE_RL( tileArea, theArea, myThid )
c     ENDIF
      IF ( theArea.GT.0. ) THEN
        CALL GLOBAL_SUM_TILE_RL( tileMean, theMean, myThid )
        CALL GLOBAL_SUM_TILE_RL( tileVar , theVar , myThid )
        arrStats(0,2) = theArea
        arrStats(1,2) = theMean
        arrStats(2,2) = theVar

        theMean = theMean/theArea
        IF ( noPnts ) theMin = theMean
        theMin = -theMin
        _GLOBAL_MAX_RL(theMin,myThid)
        theMin = -theMin
        IF ( noPnts ) theMax = theMean
        _GLOBAL_MAX_RL(theMax,myThid)
        arrStats(3,2) = theMin
        arrStats(4,2) = theMax

      ENDIF
#endif /* ALLOW_OBCS_SOUTH */

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#endif /* ALLOW_MONITOR */
#endif /* ALLOW_OBCS */

      RETURN
      END

#include "FIZHI_OPTIONS.h"
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: FIZHI_INIT_VEGSURFTILES
C     !INTERFACE:
      subroutine fizhi_init_vegsurftiles(globalArr,xsize,ysize,
     &                                   nymd,nhms,prec,myThid)

C     !DESCRIPTION:
C      Read in grid space values of the land state
C      and then convert to vegetation tile space

C     !USES:
C      Calls routine grd2msc to do grid to tile space for each bi bj
      implicit none
#include "SIZE.h"
#include "fizhi_SIZE.h"
#include "fizhi_land_SIZE.h"
#include "fizhi_coms.h"
#include "fizhi_land_coms.h"
#include "fizhi_earth_coms.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#ifdef ALLOW_EXCH2
#include "W2_EXCH2_SIZE.h"
#include "W2_EXCH2_TOPOLOGY.h"
#endif /* ALLOW_EXCH2 */

C     !INPUT/OUTPUT PARAMETERS:
      integer xsize, ysize
      Real*8 globalArr(xsize,ysize,8)
      CHARACTER*1 prec
      INTEGER nhms,nymd
      INTEGER myThid

      EXTERNAL ILNBLNK
      INTEGER ILNBLNK
      INTEGER MDS_RECLEN
CEOP
C     !LOCAL VARIABLES:
      CHARACTER(MAX_LEN_FNAM) fn
      integer ihour
      integer i,j,n
      integer bislot,bjslot,iunit
      integer recl
      integer bi,bj,fileprec
      _RL tempgrid(sNx,sNy)
      _RL temptile(nchp)
      _RL fracland(sNx,sNy,Nsx,Nsy)

      ihour = nhms/10000
      if(xsize.eq.192) then
      WRITE(fn,'(a,I8,a,I2.2,a)')
     .            'vegtiles_cs32.d',nymd,'z',ihour,'.bin'
      elseif(xsize.eq.612) then
      WRITE(fn,'(a,I8,a,I2.2,a)')
     .            'vegtiles_cs102.d',nymd,'z',ihour,'.bin'
      else
      print *,' xsize is ',xsize
      stop 'do not seem to have correct vegtiles data '
      endif
      fileprec = 64

      call MDSFINDUNIT( iunit, mythid )
      recl=MDS_RECLEN( fileprec, Nx*Ny*8, mythid )

C Only do I/O if I am the master thread
      _BEGIN_MASTER( myThid )

      open(iUnit,file=fn,status='old',access='direct',recl=recl)
      read(iunit,rec=1) globalarr
      close( iunit )
      _END_MASTER( myThid )


#ifdef _BYTESWAPIO
       call MDS_BYTESWAPR8( Nx*Ny*8, globalarr )
#endif

      DO bj = myByLo(myThid), myByHi(myThid)
      DO bi = myBxLo(myThid), myBxHi(myThid)

#if defined(ALLOW_EXCH2)
       bislot = exch2_txglobalo(W2_myTileList(bi,bj))-1
       bjslot = exch2_tyglobalo(W2_myTileList(bi,bj))-1
#else
       bislot = myXGlobalLo-1+(bi-1)*sNx
       bjslot = myYGlobalLo-1+(bj-1)*sNy
#endif /* ALLOW_EXCH2 */

      call get_landfrac(sNx,sNy,Nsx,Nsy,bi,bj,maxtyp,
     .        surftype,tilefrac,fracland(1,1,bi,bj))

       do j = 1,sNy
       do i = 1,sNx
        tempgrid(i,j) = globalarr(i+bislot,j+bjslot,1)
       enddo
       enddo
       call grd2msc(tempgrid,sNx,sNy,igrd(1,bi,bj),
     .                 temptile,nchp,nchptot(bi,bj))
       do n = 1,nchp
        tcanopy(n,bi,bj) = temptile(n)
       enddo

       do j = 1,sNy
       do i = 1,sNx
        tempgrid(i,j) = globalarr(i+bislot,j+bjslot,2)
        if (tempgrid(i,j).gt.1.e14 .and. fracland(i,j,bi,bj).gt.0.0001)
     .    tempgrid(i,j) = globalarr(i+bislot,j+bjslot,1) - 0.5
       enddo
       enddo
       call grd2msc(tempgrid,sNx,sNy,igrd(1,bi,bj),
     .                    temptile,nchp,nchptot(bi,bj))
       do n = 1,nchp
        tdeep(n,bi,bj) = temptile(n)
       enddo

       do j = 1,sNy
       do i = 1,sNx
        tempgrid(i,j) = globalarr(i+bislot,j+bjslot,3)
        if (tempgrid(i,j).gt.1.e14 .and. fracland(i,j,bi,bj).gt.0.0001)
     .    tempgrid(i,j) = 0.01
       enddo
       enddo
       call grd2msc(tempgrid,sNx,sNy,igrd(1,bi,bj),
     .                    temptile,nchp,nchptot(bi,bj))
       do n = 1,nchp
        ecanopy(n,bi,bj) = temptile(n)
       enddo

       do j = 1,sNy
       do i = 1,sNx
        tempgrid(i,j) = globalarr(i+bislot,j+bjslot,4)
        if (tempgrid(i,j).gt.1.e14 .and. fracland(i,j,bi,bj).gt.0.0001)
     .    tempgrid(i,j) = 0.7
       enddo
       enddo
       call grd2msc(tempgrid,sNx,sNy,igrd(1,bi,bj),
     .                    temptile,nchp,nchptot(bi,bj))
       do n = 1,nchp
        swetshal(n,bi,bj) = temptile(n)
       enddo

       do j = 1,sNy
       do i = 1,sNx
        tempgrid(i,j) = globalarr(i+bislot,j+bjslot,5)
        if (tempgrid(i,j).gt.1.e14 .and. fracland(i,j,bi,bj).gt.0.0001)
     .    tempgrid(i,j) = 0.5
       enddo
       enddo
       call grd2msc(tempgrid,sNx,sNy,igrd(1,bi,bj),
     .                    temptile,nchp,nchptot(bi,bj))
       do n = 1,nchp
        swetroot(n,bi,bj) = temptile(n)
       enddo

       do j = 1,sNy
       do i = 1,sNx
        tempgrid(i,j) = globalarr(i+bislot,j+bjslot,6)
        if (tempgrid(i,j).gt.1.e14 .and. fracland(i,j,bi,bj).gt.0.0001)
     .    tempgrid(i,j) = 0.3
       enddo
       enddo
       call grd2msc(tempgrid,sNx,sNy,igrd(1,bi,bj),
     .                    temptile,nchp,nchptot(bi,bj))
       do n = 1,nchp
        swetdeep(n,bi,bj) = temptile(n)
       enddo

       do j = 1,sNy
       do i = 1,sNx
        tempgrid(i,j) = globalarr(i+bislot,j+bjslot,7)
        if (tempgrid(i,j).gt.1.e14 .and. fracland(i,j,bi,bj).gt.0.0001)
     .    tempgrid(i,j) = 0.
       enddo
       enddo
       call grd2msc(tempgrid,sNx,sNy,igrd(1,bi,bj),
     .                    temptile,nchp,nchptot(bi,bj))
       do n = 1,nchp
        snodep(n,bi,bj) = temptile(n)
       enddo

       do j = 1,sNy
       do i = 1,sNx
        tempgrid(i,j) = globalarr(i+bislot,j+bjslot,8)
        if (tempgrid(i,j).gt.1.e14 .and. fracland(i,j,bi,bj).gt.0.0001)
     .    tempgrid(i,j) = 0.
       enddo
       enddo
       call grd2msc(tempgrid,sNx,sNy,igrd(1,bi,bj),
     .                    temptile,nchp,nchptot(bi,bj))
       do n = 1,nchp
        capac(n,bi,bj) = temptile(n)
       enddo

       close(iunit)

C End of bi bj loop
      enddo
      enddo

      RETURN
      END

#include "SEAICE_OPTIONS.h"
#ifdef ALLOW_EXF
# include "EXF_OPTIONS.h"
#endif
#ifdef ALLOW_SALT_PLUME
# include "SALT_PLUME_OPTIONS.h"
#endif
#ifdef ALLOW_AUTODIFF
# include "AUTODIFF_OPTIONS.h"
#endif

#undef SEAICE_GROWTH_ADX_STORE_MORE

CBOP
C     !ROUTINE: SEAICE_GROWTH_ADX
C     !INTERFACE:
      SUBROUTINE SEAICE_GROWTH_ADX( myTime, myIter, myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE seaice_growth_adx
C     | o Adjointable seaice thermodynamic code based on
C     |   Ian Fentys code with modifications for nonlinear free
C     |   surface budget closure by A.Bigdeli.
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "DYNVARS.h"
#include "GRID.h"
#include "FFIELDS.h"
#include "SEAICE_SIZE.h"
#include "SEAICE_PARAMS.h"
#include "SEAICE.h"
#include "SEAICE_GRID.h"
#include "SEAICE_TRACER.h"
#ifdef ALLOW_EXF
# include "EXF_PARAM.h"
# include "EXF_FIELDS.h"
#endif
#ifdef ALLOW_SALT_PLUME
# include "SALT_PLUME.h"
#endif
#ifdef ALLOW_AUTODIFF_TAMC
# include "tamc.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
C     myTime :: Simulation time
C     myIter :: Simulation timestep number
C     myThid :: Thread no. that called this routine.
      _RL myTime
      INTEGER myIter, myThid
CEOP

#ifdef SEAICE_USE_GROWTH_ADX
#if (defined ALLOW_EXF) && (defined ALLOW_ATM_TEMP)
C     !FUNCTIONS:
#ifdef ALLOW_DIAGNOSTICS
      LOGICAL  DIAGNOSTICS_IS_ON
      EXTERNAL DIAGNOSTICS_IS_ON
#endif

C     !LOCAL VARIABLES:
C     === Local variables ===
C
C unit/sign convention:

C HEFF is effective Hice thickness (m3/m2)
C HSNOW is Heffective snow thickness (m3/m2)
C HSALT is Heffective salt content (g/m2)
C AREA is the seaice cover fraction (0<=AREA<=1)

C     i,j,bi,bj :: Loop counters
      INTEGER i, j, bi, bj
C     number of surface interface layer, and second interface layer
      INTEGER kSurface, kSrfS
C     IT :: ice thickness category index (MULTICATEGORIES and ITD code)
      INTEGER IT
C     msgBuf      :: Informational/error message buffer
c     CHARACTER*(MAX_LEN_MBUF) msgBuf
C     constants
      _RL tempFrz, ICE2SNOW, SNOW2ICE, surf_theta
      _RL QI, QS
      _RL lhSublim

C     Regularization values squared
      _RL area_reg_sq, hice_reg_sq

C     pathological cases thresholds
      _RL heffTooHeavy

C     Helper variables: reciprocal of some constants
      _RL recip_multDim
      _RL recip_deltaTtherm
      _RL recip_rhoIce
      _RL recip_QI
      _RL recip_QS
      _RL recip_HO
      _RL recip_HO_south
      _RL rhoFresh2rhoSnow
      _RL rhoSnow2rhoFresh
      _RL rhoIce2rhoFresh

C     facilitate multi-category snow implementation
      _RL pFac, pFacSnow

C     temporary variables available for the various computations
      _RL tmpscal0, tmpscal1, tmpscal2, tmpscal3

#ifdef ALLOW_AUTODIFF_TAMC
C     tkey :: tape key (depends on tiles)
      INTEGER tkey
#endif

C==   local arrays ==
C--   TmixLoc        :: ocean surface/mixed-layer temperature (in K)
      _RL TmixLoc       (1:sNx,1:sNy)

C     actual ice thickness (with upper and lower limit)
      _RL hiceActual          (1:sNx,1:sNy)
C     actual snow thickness
      _RL hsnowActual         (1:sNx,1:sNy)
C     actual ice thickness (with lower limit only) Reciprocal
      _RL recip_hiceActual    (1:sNx,1:sNy)

C     AREA_PRE :: hold sea-ice fraction field before any seaice-thermo update
      _RL AREApreTH           (1:sNx,1:sNy)
      _RL HEFFpreTH           (1:sNx,1:sNy)
      _RL HSNWpreTH           (1:sNx,1:sNy)

C     wind speed
      _RL UG                  (1:sNx,1:sNy)

C     temporary variables available for the various computations
      _RL ticeInMult          (1:sNx,1:sNy,nITD)
      _RL ticeOutMult         (1:sNx,1:sNy,nITD)
      _RL hiceActualMult      (1:sNx,1:sNy,nITD)
      _RL hsnowActualMult     (1:sNx,1:sNy,nITD)

      _RL F_io_net_mult     (1:sNx,1:sNy,nITD)
      _RL F_ia_net_mult     (1:sNx,1:sNy,nITD)
      _RL F_ia_mult     (1:sNx,1:sNy,nITD)
      _RL QSWI_mult     (1:sNx,1:sNy,nITD)

C Variables related to FWsublim are dummies required for call
C to seaice_solve4temp subroutine and are not used afterwards
C in this routine (by choice).
      _RL FWsublim_mult     (1:sNx,1:sNy,nITD)
      _RL FWsublim          (1:sNx,1:sNy)

#ifdef ALLOW_SALT_PLUME
c     d(HEFF)/dt from heat fluxes in the open water fraction of the grid cell
      _RL IceGrowthRateInLeads          (1:sNx,1:sNy)

c     The fraction of salt released in leads by new ice production there
c     which is to be sent to the salt plume package
      _RL leadPlumeFraction             (1:sNx,1:sNy)
#endif

      _RL QSWO_BELOW_FIRST_LAYER (1:sNx,1:sNy)
      _RL QSWO_IN_FIRST_LAYER (1:sNx,1:sNy)
      _RL QSWO (1:sNx,1:sNy)
      _RL QSWI (1:sNx,1:sNy)

C     Sea ice growth rates (m/s)
      _RL ActualNewTotalVolumeChange     (1:sNx,1:sNy)
      _RL ActualNewTotalSnowMelt     (1:sNx,1:sNy)

      _RL NetExistingIceGrowthRate      (1:sNx,1:sNy)
      _RL IceGrowthRateUnderExistingIce (1:sNx,1:sNy)
      _RL IceGrowthRateFromSurface      (1:sNx,1:sNy)
      _RL IceGrowthRateOpenWater        (1:sNx,1:sNy)
      _RL IceGrowthRateMixedLayer       (1:sNx,1:sNy)

      _RL EnergyInNewTotalIceVolume     (1:sNx,1:sNy)
      _RL NetEnergyFluxOutOfOcean       (1:sNx,1:sNy)

#ifdef ALLOW_DIAGNOSTICS
C Local arrays for diagnostics
      _RL SItflux     (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL SIeprflx    (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL SIatmFW     (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
#endif
CAB these two terms are placeholders for extra bits from advection,
C   used in budget
      _RL SIheffNeg   (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL SIhsnwNeg   (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
CAB
      _RL d_HEFFbyFLOODING              (1:sNx,1:sNy)

C     The energy taken out of the ocean which is not converted
C     to sea ice (Joules)
      _RL ResidualEnergyOutOfOcean      (1:sNx,1:sNy)

C     Snow accumulation rate over ice (m/s)
      _RL SnowAccRateOverIce            (1:sNx,1:sNy)

C     Total snow accumulation over ice (m)
      _RL SnowAccOverIce                (1:sNx,1:sNy)

C     The precipitation rate over the ice which goes immediately into the ocean
      _RL PrecipRateOverIceSurfaceToSea (1:sNx,1:sNy)

C     The potential snow melt rate if all snow surface heat flux convergences
C     goes to melting snow (m/s)
      _RL PotSnowMeltRateFromSurf       (1:sNx,1:sNy)

C     The potential thickness of snow which could be melted by snow surface
C     heat flux convergence (m)
      _RL PotSnowMeltFromSurf           (1:sNx,1:sNy)

C     The actual snow melt rate due to snow surface  heat flux convergence
      _RL SnowMeltRateFromSurface       (1:sNx,1:sNy)

C     The actual surface heat flux convergence used to melt snow (W/m^2)
      _RL SurfHeatFluxConvergToSnowMelt (1:sNx,1:sNy)

C     The actual thickness of snow to be melted by snow surface
C     heat flux convergence (m)
      _RL SnowMeltFromSurface           (1:sNx,1:sNy)

C     The freshwater contribution to the ocean from melting snow (m)
      _RL FreshwaterContribFromSnowMelt (1:sNx,1:sNy)

C     The freshwater contribution to (from) the ocean from melting (growing) ice (m)
      _RL FreshwaterContribFromIce      (1:sNx,1:sNy)

C     S_a : d(AREA)/dt
      _RL S_a                           (1:sNx,1:sNy)

C     S_h : d(HEFF)/dt
      _RL S_h                           (1:sNx,1:sNy)

C     S_hsnow : d(HSNOW)/dt
      _RL S_hsnow                       (1:sNx,1:sNy)

C     F_ia  - sea ice/snow surface heat flux with atmosphere (W/m^2)
C       F_ia > 0, heat loss to atmosphere
C       F_ia < 0, atmospheric heat flux convergence (ice/snow surface melt)
      _RL F_ia                          (1:sNx,1:sNy)

C     F_ia_net - the net heat flux divergence at the sea ice/snow surface
C                including sea ice conductive fluxes and atmospheric fluxes (W/m^2)
C       F_ia_net = 0, sea ice/snow surface energy balance condition met
C                     upward conductive fluxes balance surface heat loss
C       F_ia_net < 0, net heat flux convergence at ice/snow surface
C                     zero conductive fluxes and net atmospheric convergence
      _RL F_ia_net                      (1:sNx,1:sNy)

C     F_ia_net - the net heat flux divergence at the sea ice/snow surface
C                before snow is melted with any convergence (W/m^2)
C        F_ia_net < 0, some snow, if present, will melt
      _RL F_ia_net_before_snow          (1:sNx,1:sNy)

C     F_io_net - the net upward conductive heat flux through the ice+snow system
C                realized at the sea ice/snow surface
C        F_io_net > 0, heat conducting upward from ice base --> basal thickening
C        F_io_net = 0, no upward heat conduction
C                      ice/snow surface temperature > SEAICE_freeze)
      _RL F_io_net                      (1:sNx,1:sNy)

C     F_ao  - heat flux from atmosphere to ocean (W/m^2)
C        F_ao > 0
      _RL F_ao                          (1:sNx,1:sNy)

C     F_mi - heat flux from ocean to the ice (W/m^2)
      _RL F_mi                          (1:sNx,1:sNy)

C     S_a_from_IGROW : d(AREA)/dt [from ice growth rate from open water fluxes]
      _RL S_a_IGROW                     (1:sNx,1:sNy)

C     S_a_from_IGROW : d(AREA)/dt [from ice growth rate from ocean-ice fluxes]
      _RL S_a_IGRML                     (1:sNx,1:sNy)

C     S_a_from_IGROW : d(AREA)/dt [from ice growth rate from ice-atm fluxes]
      _RL S_a_IGRNE                     (1:sNx,1:sNy)

C     Factor by which we increase the upper ocean friction velocity (u*) when
C     ice is absent in a grid cell  (dimensionless)
      _RL MLTF

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C ===================================================================
C =================PART 0: constants and initializations=============
C ===================================================================

      IF ( usingPCoords ) THEN
       kSurface = Nr
       kSrfS    = Nr
      ELSE
       kSurface = 1
       kSrfS    = 2
      ENDIF

C     Cutoff for iceload
      heffTooHeavy=drF(kSurface) / 5. _d 0
      IF ( usingPCoords )
     &     heffTooHeavy = heffTooHeavy * recip_rhoConst * recip_gravity

C     RATIO OF SEA ICE DENSITY to SNOW DENSITY
      ICE2SNOW     = SEAICE_rhoIce/SEAICE_rhoSnow
      SNOW2ICE     = ONE / ICE2SNOW

C  Heat Flux * QI = [W] [m^3/kg] [kg/J] = [m^3/s] or [m/s] per unit area
      QI           = ONE/(SEAICE_rhoIce*SEAICE_lhFusion)
C  Heat Flux * QS = [W] [m^3/kg] [kg/J] = [m^3/s] or [m/s] per unit area
      QS           = ONE/(SEAICE_rhoSnow*SEAICE_lhFusion)

C     ICE LATENT HEAT CONSTANT
      lhSublim = SEAICE_lhEvap + SEAICE_lhFusion

C     avoid unnecessary divisions in loops
      recip_multDim     = SEAICE_multDim
      recip_multDim     = ONE / recip_multDim
C     above/below: double/single precision calculation of recip_multDim
c     recip_multDim     = 1./float(SEAICE_multDim)
      recip_deltaTtherm = ONE / SEAICE_deltaTtherm
      recip_rhoIce      = ONE / SEAICE_rhoIce
      recip_QI          = ONE / QI
      recip_QS          = ONE / QS
      recip_HO          = ONE / HO
      recip_HO_south    = ONE / HO_south
      rhoFresh2rhoSnow  = rhoConstFresh / SEAICE_rhoSnow
      rhoSnow2rhoFresh  = ONE / rhoFresh2rhoSnow
      rhoIce2rhoFresh   = SEAICE_rhoIce / rhoConstFresh

C     regularization constants
      area_reg_sq = SEAICE_area_reg * SEAICE_area_reg
      hice_reg_sq = SEAICE_hice_reg * SEAICE_hice_reg

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)

#ifdef ALLOW_AUTODIFF_TAMC
        tkey = bi + (bj-1)*nSx + (ikey_dynamics-1)*nSx*nSy
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CADJ STORE area (:,:,bi,bj) = comlev1_bibj, key = tkey, byte = isbyte
CADJ STORE heff (:,:,bi,bj) = comlev1_bibj, key = tkey, byte = isbyte
CADJ STORE hsnow(:,:,bi,bj) = comlev1_bibj, key = tkey, byte = isbyte
CADJ STORE qnet (:,:,bi,bj) = comlev1_bibj, key = tkey, byte = isbyte
CADJ STORE qsw  (:,:,bi,bj) = comlev1_bibj, key = tkey, byte = isbyte
CADJ STORE tices(:,:,:,bi,bj)=comlev1_bibj, key = tkey, byte = isbyte
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
#endif

C array initializations
C =====================

        DO J=1,sNy
         DO I=1,sNx

C NEW VARIABLE NAMES
          NetExistingIceGrowthRate(I,J) = 0.0 _d 0
          IceGrowthRateOpenWater(I,J)   = 0.0 _d 0
          IceGrowthRateFromSurface(I,J) = 0.0 _d 0
          IceGrowthRateMixedLayer(I,J)  = 0.0 _d 0

          EnergyInNewTotalIceVolume(I,J) = 0.0 _d 0
          NetEnergyFluxOutOfOcean(I,J)   = 0.0 _d 0
          ResidualEnergyOutOfOcean(I,J)  = 0.0 _d 0

          PrecipRateOverIceSurfaceToSea(I,J) = 0.0 _d 0

          DO IT=1,SEAICE_multDim
            ticeInMult(I,J,IT)            = 0.0 _d 0
            ticeOutMult(I,J,IT)           = 0.0 _d 0

            F_io_net_mult(I,J,IT)  = 0.0 _d 0
            F_ia_net_mult(I,J,IT)  = 0.0 _d 0
            F_ia_mult(I,J,IT)      = 0.0 _d 0

            QSWI_mult(I,J,IT)      = 0.0 _d 0
            FWsublim_mult(I,J,IT)  = 0.0 _d 0
          ENDDO

          F_io_net(I,J) = 0.0 _d 0
          F_ia_net(I,J) = 0.0 _d 0
          F_ia(I,J)     = 0.0 _d 0

          QSWI(I,J) = 0.0 _d 0
          FWsublim(I,J) = 0.0 _d 0

          QSWO_BELOW_FIRST_LAYER (I,J) = 0.0 _d 0
          QSWO_IN_FIRST_LAYER (I,J) = 0.0 _d 0
          QSWO(I,J) = 0.0 _d 0

          ActualNewTotalVolumeChange(I,J) = 0.0 _d 0
          ActualNewTotalSnowMelt(I,J)     = 0.0 _d 0

          SnowAccOverIce(I,J) = 0.0 _d 0
          SnowAccRateOverIce(I,J) = 0.0 _d 0

          PotSnowMeltRateFromSurf(I,J)    = 0.0 _d 0
          PotSnowMeltFromSurf(I,J)        = 0.0 _d 0
          SnowMeltRateFromSurface(I,J)    = 0.0 _d 0
          SurfHeatFluxConvergToSnowMelt(I,J) = 0.0 _d 0
          SnowMeltFromSurface(I,J)       = 0.0 _d 0

          FreshwaterContribFromSnowMelt(I,J) = 0.0 _d 0
          FreshwaterContribFromIce(I,J) = 0.0 _d 0

          S_a(I,J)       = 0.0 _d 0
          S_a_IGROW(I,J) = 0.0 _d 0
          S_a_IGRML(I,J) = 0.0 _d 0
          S_a_IGRNE(I,J) = 0.0 _d 0

          S_h(I,J)       = 0.0 _d 0
          S_hsnow(I,J)   = 0.0 _d 0

          d_HEFFbyFLOODING(I,J) = 0.0 _d 0
#ifdef ALLOW_SALT_PLUME
          IceGrowthRateInLeads            (I,J) = 0. _d 0
          leadPlumeFraction               (I,J) = 0. _d 0
          saltPlumeFlux             (I,J,bi,bj) = 0. _d 0
#endif
#ifdef ALLOW_DIAGNOSTICS
          SIeprflx(I,J,bi,bj) = 0. _d 0
#endif
         ENDDO
        ENDDO

C =====================================================================
C  PART 1: Store ice and snow state on onset + regularize actual
C               snow and ice thickness
C =====================================================================
CAB
        DO J=1,sNy
         DO I=1,sNx
         SIheffNeg(I,J,bi,bj)=d_HEFFbyNEG(I,J,bi,bj)*SINegFac
         SIhsnwNeg(I,J,bi,bj)=d_HSNWbyNEG(I,J,bi,bj)*SINegFac
         ENDDO
        ENDDO

        DO J=1,sNy
         DO I=1,sNx

          tmpscal0 = HEFF(I,J,bi,bj)
          HEFF(I,J,bi,bj) = MAX(ZERO, tmpscal0)
          tmpscal1 = AREA(I,J,bi,bj)
          AREA(I,J,bi,bj) = MAX(ZERO, tmpscal1)

          IF (HEFF(I,J,bi,bj) .LE. ZERO) then
             AREA(I,J, bi,bj)  = ZERO
             HSNOW(I,J, bi,bj) = ZERO
          ELSEIF (AREA(I,J,bi,bj) .LE. ZERO) then
             HEFF(I,J,bi,bj)  = ZERO
             HSNOW(I,J,bi,bj) = ZERO
          ENDIF

          HEFFpreTH(I,J) = HEFF(I,J,bi,bj)
          HSNWpreTH(I,J) = HSNOW(I,J,bi,bj)
          AREApreTH(I,J) = AREA(I,J,bi,bj)

         ENDDO
        ENDDO

#ifdef ALLOW_DIAGNOSTICS
        IF ( useDiagnostics ) THEN
         CALL DIAGNOSTICS_FILL(AREA, 'SIareaPT',0,1,1,bi,bj,myThid)
         CALL DIAGNOSTICS_FILL(HEFF, 'SIheffPT',0,1,1,bi,bj,myThid)
         CALL DIAGNOSTICS_FILL(HSNOW,'SIhsnoPT',0,1,1,bi,bj,myThid)
        ENDIF
#endif /* ALLOW_DIAGNOSTICS */

#if (defined ALLOW_AUTODIFF_TAMC && defined SEAICE_GROWTH_ADX_STORE_MORE)
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CADJ STORE AREApreTH = comlev1_bibj, key = tkey, byte = isbyte
CADJ STORE HEFFpreTH = comlev1_bibj, key = tkey, byte = isbyte
CADJ STORE HSNWpreTH = comlev1_bibj, key = tkey, byte = isbyte
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
#endif /* ALLOW_AUTODIFF_TAMC */

C     COMPUTE ACTUAL ICE/SNOW THICKNESS; USE MIN/MAX VALUES
C     TO REGULARIZE SEAICE_SOLVE4TEMP/d_AREA COMPUTATIONS

        DO J=1,sNy
         DO I=1,sNx
          IF (HEFFpreTH(I,J) .GT. ZERO) THEN
c          regularize AREA with SEAICE_area_reg
           tmpscal1 = SQRT(AREApreTH(I,J)* AREApreTH(I,J) + area_reg_sq)

c          hiceActual calculated with the regularized AREA
           tmpscal2 = HEFFpreTH(I,J) / tmpscal1

c          regularize hiceActual with SEAICE_hice_reg (add lower bound)
c           hiceActual(I,J) = SQRT(tmpscal2 * tmpscal2 + hice_reg_sq)
           hiceActual(I,J) = MAX(0.05 _d 0, tmpscal2)

c          hsnowActual calculated with the regularized AREA (no lower bound)
c          hsnowActual(I,J) = HSNWpreTH(I,J) / tmpscal1
c          actually I do not think we need to regularize this.
           hsnowActual(I,J) = HSNWpreTH(I,J) / AREApreTH(I,J)

c          regularize the inverse of hiceActual by hice_reg
           recip_hiceActual(I,J)  = AREApreTH(I,J) /
     &         sqrt(HEFFpreTH(I,J)*HEFFpreTH(I,J) + hice_reg_sq)

c         Do not regularize when HEFFpreTH = 0
          ELSE
           hiceActual (I,J)       = ZERO
           hsnowActual(I,J)       = ZERO
           recip_hiceActual(I,J)  = ZERO
          ENDIF

         ENDDO
        ENDDO

C =============================================================================
C Part 2: Precipitation as snow or rain over ice
C =============================================================================

        DO J=1,sNy
         DO I=1,sNx
c        if we have ice and the temperature of the ice is below the freezing point
c        then the precip falls and accumulates as snow
          IF (( AREApreTH(I,J)     .GT. ZERO) .AND.
     &        ( TICES(I,J,1,bi,bj) .LT. celsius2k) ) THEN

c use either prescribed snowfall or PRECIP rate
           IF ( snowPrecipFile .NE. ' ' ) THEN
c    rate of snow accumulation in m/s over ice
c                      y [m/s] \approx 1.0 [kg/m^3] / 0.9 [m^3/kg] * x [m/s]
             SnowAccRateOverIce(I,J) = rhoFresh2rhoSnow *
     &               snowPrecip(i,j,bi,bj)

           ELSE
             SnowAccRateOverIce(I,J) = rhoFresh2rhoSnow *
     &           PRECIP(i,j,bi,bj)

           ENDIF

           PrecipRateOverIceSurfaceToSea(I,J) = ZERO

          ELSE
c            The snow/ice surface is not frozen (wet) so the precipitation
c            remains wet and runs into the ocean
             SnowAccRateOverIce(I,J) = ZERO
             PrecipRateOverIceSurfaceToSea(I,J) = PRECIP(i,j,bi,bj)
          ENDIF

c  actual change in snow thickness due to precipitation in units of
c  mean snow thickness
          SnowAccOverIce(I,J) =
     &     SnowAccRateOverIce(I,J) * SEAICE_deltaTtherm * AREApreTH(I,J)

c I,J
         ENDDO
        ENDDO

C =============================================================================
C FIND WIND SPEED
C =============================================================================

        DO j=1,sNy
         DO i=1,sNx
C ocean surface/mixed layer temperature
          TmixLoc(i,j) = theta(i,j,kSurface,bi,bj) + celsius2K
C wind speed from exf
          UG(I,J) = MAX(SEAICE_EPS, wspeed(I,J,bi,bj))
         ENDDO
        ENDDO
#if (defined ALLOW_AUTODIFF_TAMC && defined SEAICE_GROWTH_ADX_STORE_MORE)
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CADJ STORE UG                 = comlev1_bibj,key=tkey,byte=isbyte
CADJ STORE SnowAccRateOverIce = comlev1_bibj,key=tkey,byte=isbyte
CADJ STORE PrecipRateOverIceSurfaceToSea
CADJ &                        = comlev1_bibj,key=tkey,byte=isbyte
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
#endif /* ALLOW_AUTODIFF_TAMC */

C =============================================================================
c           Retrieve the air-sea heat and shortwave radiative fluxes
C =============================================================================

        CALL SEAICE_BUDGET_OCEAN(
     I       UG,
     I       TmixLoc,
     O       F_ao, QSWO,
     I       bi, bj, myTime, myIter, myThid )

#if (!defined SEAICE_EXTERNAL_FLUXES && defined ALLOW_AUTODIFF_TAMC)
C     In this case it might be better save the output of
C     seaice_budget_ocean rather than recompute the bulkformulae.
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CADJ STORE f_ao = comlev1_bibj, key = tkey, byte = isbyte
CADJ STORE qswo = comlev1_bibj, key = tkey, byte = isbyte
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
#endif
C =============================================================================
C      Calc air-sea fluxes in the uppermost grid cell
C =============================================================================

C--   Not all of the sw radiation is absorbed in the uppermost ocean
C     grid cell layer. Only that fraction which converges in the
C     uppermost ocean grid cell is used to melt ice.
C     SWFrac3D - the fraction of incoming sw radiation absorbed in the
C     uppermost ocean grid cell (calculated in initialise_fixed.F)

C The contribution of shortwave heating is
C not included without #define SHORTWAVE_HEATING
#ifdef SHORTWAVE_HEATING
        IF ( selectPenetratingSW .GE. 1 ) THEN
         DO J=1,sNy
          DO I=1,sNx
           tmpscal0 = SWFrac3D(I,J,kSrfS,bi,bj)
           QSWO_BELOW_FIRST_LAYER(I,J)= QSWO(I,J)*tmpscal0
           QSWO_IN_FIRST_LAYER(I,J)   = QSWO(I,J)*(ONE - tmpscal0)
          ENDDO
         ENDDO
C     This is not  necessary, as both variables  are already initialised
C     to zero in the beginning of the routine.
c        ELSE
c#endif
c         DO J=1,sNy
c          DO I=1,sNx
c           QSWO_BELOW_FIRST_LAYER(I,J)= ZERO
c           QSWO_IN_FIRST_LAYER(I,J)   = ZERO
c          ENDDO
c         ENDDO
c#ifdef SHORTWAVE_HEATING
        ENDIF
#endif
        DO J=1,sNy
         DO I=1,sNx
          IceGrowthRateOpenWater(I,J) = QI *
     &         (F_ao(I,J) - QSWO(I,J) + QSWO_IN_FIRST_LAYER(I,J))
         ENDDO
        ENDDO

#ifdef ALLOW_AUTODIFF_TAMC
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CADJ STORE salt(:,:,kSurface,bi,bj)
CADJ &                 = comlev1_bibj, key = tkey, byte = isbyte
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
#endif /* ALLOW_AUTODIFF_TAMC */

C =============================================================================
c  calculate heat fluxes within ice (conduction), F_io, and across the
c  ice/atmosphere interface, F_ia
C =============================================================================

C--   Start loop over multi-categories
        DO IT=1,SEAICE_multDim

         DO J=1,sNy
          DO I=1,sNx
c record prior ice surface temperatures
           ticeInMult(I,J,IT)  = TICES(I,J,IT,bi,bj)
           ticeOutMult(I,J,IT) = TICES(I,J,IT,bi,bj)
           TICES(I,J,IT,bi,bj) = ZERO
          ENDDO
         ENDDO

c set relative thickness of ice categories
         pFac = (2.0 _d 0*IT - 1.0 _d 0)*recip_multDim
         pFacSnow = 1. _d 0

c find actual snow and ice thickness within categories categories
         IF ( SEAICE_useMultDimSnow ) pFacSnow=pFac

         DO J=1,sNy
          DO I=1,sNx
            hiceActualMult(I,J,IT)   = hiceActual(I,J) *pFac
            hsnowActualMult(I,J,IT)  = hsnowActual(I,J)*pFacSnow
          ENDDO
         ENDDO
C     multDim-loop
        ENDDO

#if (defined ALLOW_AUTODIFF_TAMC && defined SEAICE_GROWTH_ADX_STORE_MORE)
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CADJ STORE hiceActualMult = comlev1_bibj, key = tkey, byte = isbyte
CADJ STORE hsnowActualMult= comlev1_bibj, key = tkey, byte = isbyte
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
#endif /* ALLOW_AUTODIFF_TAMC */

c =======================================================================
c  find calculate heat fluxes within ice (conduction) and across the
c  ice/atmosphere interface for each thickness category
c =======================================================================

        DO IT=1,SEAICE_multDim
         CALL SEAICE_SOLVE4TEMP(
     I        UG, hiceActualMult(1,1,IT), hsnowActualMult(1,1,IT),
#ifdef SEAICE_CAP_SUBLIM
         This error is put here intentionally, because SEAICE_CAP_SUBLIM
         cannot be defined together with SEAICE_USE_GROWTH_ADX
     I        latentHeatFluxMaxMult(1,1,IT),
#endif
     I        ticeInMult(1,1,IT),
     O        ticeOutMult(1,1,IT),
     O        F_io_net_mult(1,1,IT),
     O        F_ia_net_mult(1,1,IT),
     O        F_ia_mult(1,1,IT),
     O        QSWI_mult(1,1,IT),
     O        FWsublim_mult(1,1,IT),
     I        bi, bj, myTime, myIter, myThid )
        ENDDO

c =======================================================================
c  record the ice surface temperature in each category
c  and find the average of fluxes across each category

        DO IT=1,SEAICE_multDim
         DO J=1,sNy
          DO I=1,sNx

C     update TICES
            TICES(I,J,IT,bi,bj) = ticeOutMult(I,J,IT)

            F_io_net(I,J) = F_io_net(I,J) +
     &        F_io_net_mult(I,J,IT)*recip_multDim

            F_ia_net(I,J) = F_ia_net(I,J) +
     &        F_ia_net_mult(I,J,IT)*recip_multDim

            F_ia(I,J)  = F_ia(I,J)     +
     &        F_ia_mult(I,J,IT)*recip_multDim

            QSWI(I,J)  = QSWI(I,J) + QSWI_mult(I,J,IT)*recip_multDim

            FWsublim(I,J) = FWsublim(I,J) +
     &         FWsublim_mult(I,J,IT)*recip_multDim

          ENDDO
         ENDDO
        ENDDO
#ifdef ALLOW_AUTODIFF_TAMC
C     This store is needed to avoid recomputing seaice_solve4temp in AD-mode,
C     because F_ia_net is modified in the block below.
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CADJ STORE F_ia_net  = comlev1_bibj, key = tkey, byte = isbyte
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
#endif /* ALLOW_AUTODIFF_TAMC */

        DO J=1,sNy
         DO I=1,sNx
c          If there is heat flux convergence at the snow surface,
c          use that energy to melt snow before melting ice.  It is
c          possible that some snow will remain after melting,
c          which will drive F_ia_net to zero, or that all of the
c          snow will be melted, leaving a nonzero F_ia_net to melt
c          some ice.
          F_ia_net_before_snow(I,J) = F_ia_net(I,J)

c         Only continue if there is snow and ice in the cell
          IF (AREApreTH(I,J) .LE. ZERO) THEN
            IceGrowthRateUnderExistingIce(I,J) = 0. _d 0
            IceGrowthRateFromSurface(I,J)      = 0. _d 0
            NetExistingIceGrowthRate(I,J)      = 0. _d 0
          ELSE
c           The growth rate (m/s) beneath existing ice is given by the upward
c           ocean-ice conductive flux, F_io_net, and QI.
            IceGrowthRateUnderExistingIce(I,J) = F_io_net(I,J)*QI

c           The rate at which snow is melted (m/s) because of surface
c           heat flux convergence.  Note, during snow melt, F_ia_net must
c           be negative (implying convergence) to make PSMRFW is positive
            PotSnowMeltRateFromSurf(I,J) = - F_ia_net(I,J)*QS

c           This is the depth of snow (m) that would be melted in one dt
            PotSnowMeltFromSurf(I,J)  =
     &        PotSnowMeltRateFromSurf(I,J) * SEAICE_deltaTtherm

c           If we can melt MORE than is actually there, then the melt
c           rate is reduced so that only that which is there
c           is melted during the time step.  In this case, not all of the
c           heat flux convergence at the surface is used to melt snow.
c           Any remaining energy will melt ice.

c           SurfHeatFluxConvergToSnowMelt is the part of the total heat
c           flux convergence which melts snow.

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CCHECK: HSNOW ACTUAL SHOULD NOT BE REGULARIZED FOR THIS
            IF (PotSnowMeltFromSurf(I,J) .GE. hsnowActual(I,J)) THEN

c           Snow melt and melt rate [m] (actual snow thickness)
              SnowMeltFromSurface(I,J)     = hsnowActual(I,J)

              SnowMeltRateFromSurface(I,J) =
     &           SnowMeltFromSurface(I,J) * recip_deltaTtherm

              SurfHeatFluxConvergToSnowMelt(I,J) =
     &          - hsnowActual(I,J)*recip_QS*recip_deltaTtherm
           ELSE
c             In this case there will be snow remaining after melting.
c             All of the surface heat convergence will be redirected to
c             this effort.
              SnowMeltFromSurface(I,J) = PotSnowMeltFromSurf(I,J)

              SnowMeltRateFromSurface(I,J) =PotSnowMeltRateFromSurf(I,J)

              SurfHeatFluxConvergToSnowMelt(I,J) = F_ia_net(I,J)

           ENDIF

c          Reduce the heat flux convergence available to melt surface
c          ice by the amount used to melt snow
           F_ia_net(I,J) = F_ia_net(I,J) -
     &         SurfHeatFluxConvergToSnowMelt(I,J)

           IceGrowthRateFromSurface(I,J) = F_ia_net(I,J) * QI

c          The total growth rate (m/s) of the existing ice - the rate of
c          new ice accretion at the base less the rate due to surface melt
           NetExistingIceGrowthRate(I,J) =
     &            IceGrowthRateUnderExistingIce(I,J) +
     &            IceGrowthRateFromSurface(I,J)
          ENDIF

         ENDDO
        ENDDO
#ifdef ALLOW_AUTODIFF_TAMC
C     Store F_io/ia_net and QSWI to avoid calling seaice_solve4temp in AD-mode
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CADJ STORE F_io_net      = comlev1_bibj, key = tkey, byte = isbyte
CADJ STORE F_ia_net      = comlev1_bibj, key = tkey, byte = isbyte
CADJ STORE QSWI          = comlev1_bibj, key = tkey, byte = isbyte
CADJ STORE theta(:,:,kSurface,bi,bj)
CADJ &                   = comlev1_bibj, key = tkey, byte = isbyte
CADJ STORE salt(:,:,kSurface,bi,bj)
CADJ &                   = comlev1_bibj, key = tkey, byte = isbyte
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
#endif /* ALLOW_AUTODIFF_TAMC */
c     inflection point
        tmpscal0 = 0.4 _d 0
c     steepness/inflection point
        tmpscal1 = 7.0 _d 0/tmpscal0
c     avoid recomputing constant coefficients
        tmpscal2 = STANTON_NUMBER*USTAR_BASE*rhoConst*HeatCapacity_Cp
C     Calculate the heat fluxes from the ocean to the sea ice
        DO J=1,sNy
         DO I=1,sNx
c
c     Bound the ocean temperature to be at or above the freezing point.
          tempFrz = SEAICE_tempFrz0 +
     &              SEAICE_dTempFrz_dS * salt(I,J,kSurface,bi,bj)

          surf_theta = max(theta(I,J,kSurface,bi,bj), tempFrz)

C     MCPHEE_TAPER_FAC = 12.5 (CONSTANT PARAMETER)
          MLTF = ONE + (MCPHEE_TAPER_FAC - ONE)
     &         / ( ONE + EXP( (AREApreTH(I,J) - tmpscal0)*tmpscal1 ) )

C          IF (AREApreTH(I,J) .GT. ZERO) THEN
CC     If ice is present, MixedLayerTurbulenceFactor = 1.0, else 12.50
C           MLTF = ONE
C          ELSE
C           MLTF = MCPHEE_TAPER_FAC
C          ENDIF

          F_mi(I,J) = - tmpscal2 * (surf_theta - tempFrz) * MLTF

          IceGrowthRateMixedLayer (I,J) = F_mi(I,J) * QI

         ENDDO
        ENDDO
#ifdef ALLOW_AUTODIFF_TAMC
C     The first two store directives are also needed to avoid calling
C     seaice_solve4temp in AD-mode.
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CADJ STORE NetExistingIceGrowthRate      = comlev1_bibj,
CADJ &     key = tkey, byte = isbyte
CADJ STORE IceGrowthRateMixedLayer       = comlev1_bibj,
CADJ &     key = tkey, byte = isbyte
# ifdef SEAICE_GROWTH_ADX_STORE_MORE
CADJ STORE SnowMeltRateFromSurface       = comlev1_bibj,
CADJ &     key = tkey, byte = isbyte
CADJ STORE IceGrowthRateUnderExistingIce = comlev1_bibj,
CADJ &     key = tkey, byte = isbyte
CADJ STORE IceGrowthRateFromSurface      = comlev1_bibj,
CADJ &     key = tkey, byte = isbyte
# endif
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
#endif /* ALLOW_AUTODIFF_TAMC */

C       CALCULATE THICKNESS DERIVATIVES of ice (dhdt) and snow (dhsdt)
        DO J=1,sNy
         DO I=1,sNx

          S_h(I,J) =
     &       NetExistingIceGrowthRate(I,J) *  AREApreTH(I,J)
     &     + IceGrowthRateOpenWater(I,J)   * (ONE - AREApreTH(I,J))
     &     + IceGrowthRateMixedLayer(I,J)

c         Both the accumulation and melt rates are in terms
c         of actual snow thickness.  As with ice, multiplying
c         with area converts to mean snow thickness.
          S_hsnow(I,J) =  AREApreTH(I,J) *
     &      ( SnowAccRateOverIce(I,J) - SnowMeltRateFromSurface(I,J))

         ENDDO
        ENDDO
#ifdef ALLOW_AUTODIFF_TAMC
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C     storing S_h would save one line of recomputation so do not do it
cnostore CADJ STORE S_h = comlev1_bibj, key = tkey, byte = isbyte
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
#endif /* ALLOW_AUTODIFF_TAMC */

#ifdef ALLOW_SALT_PLUME
# ifdef SALT_PLUME_IN_LEADS
C     avoid repetitive division by a constant
        tmpscal0 = 5. _d 0 / (ONE - SPinflectionPoint)
C     Now that we know the thickness tendency terms, we can calculate
C     the saltPlumeFlux
        DO J=1,sNy
         DO I=1,sNx

c     It is assumed that ice production in leads can generate
c     salt plumes. The fraction of the salt sent to the plume package
c     from ice produced in leads (defined as the open water
c     fraction) is a nonlinear function of ice concentration, AREA.
c
c     Specifically, function is a logistic curve (sigmoid) with a range and
c     domain {0,1}. The function, f(AREA), has a single free parameter,
c     SEAICE_plumeInflectionPoint, the inflection point of the curve.
c     By construction, the function has the following properties:
c     f(1) \approx 1.0
c     f(SEAICE_plumeInflectionPoint) = 0.5
c     f(0) \approx 0.0 (when SEAICE_plumeInflectionPoint \geq 0.5)
c     f(0) > 0.0 (when SEAICE_plumeInflectionPoint < 0.5)
c
c     As AREA --> 1, the open water fraction occurs in narrow leads,
c     new ice production become spatially non-uniform, and the assumptions
c     motivating KPP no longer hold. To treat overturning in a more
c     physically realistic way, the salt produced in the leads should
c     be sent to depth via the plume package. To assure only narrow leads
c     generate plumes, choose a SEAICE_plumeInflectionPoint of > 0.8.

c     Ensure that there is already ice present or that the total ice
c     ice tendency term is positive.  We do not want to release
c     salt if sea ice is not established in the cell.

          IF (AREApreTH(I,J) .GT. ZERO .OR. S_h(I,J) .GT. ZERO ) THEN

           leadPlumeFraction(I,J) = ONE
     &          / ( ONE + EXP( ( SPinflectionPoint - AREApreTH(I,J) )
     &                         * tmpscal0 )
     &            )

c     Only consider positive ice growth rate in leads for salt production
           IceGrowthRateInLeads(I,J) = max( ZERO,
     &          (ONE - AREApreTH(I,J)) * IceGrowthRateOpenWater(I,J))

           saltPlumeFlux(I,J,bi,bj) = leadPlumeFraction(I,J) *
     &          HEFFM(I,J,bi,bj)*IceGrowthRateInLeads(I,J)*
     &          ICE2WATR*rhoConstFresh*
     &          (salt(I,J,kSurface,bi,bj) - SEAICE_salt0)
          ELSE

           saltPlumeFlux(I,J,bi,bj) = ZERO

          ENDIF

         ENDDO
        ENDDO
#endif /* SALT_PLUME_IN_LEADS */
#endif /* ALLOW_SALT_PLUME */

c       Caculate dA/dt (S_a)
        DO J=1,sNy
         DO I=1,sNx

          S_a(I,J) =  0. _d 0

c     Caculate the ice area growth rate from the open water fluxes.
c     First, determine whether the open water growth rate is positive or
c     negative.  If positive, make sure that ice is present or that the
c     net ice thickness growth rate is positive before extending ice cover

c     this is the geometric term: Area/(2*Heff),
c     with Area/Heff regularized as Area/(Heff^2 + epsilon^2)
c     Area/(Heff^2 + ep^2) = recip_hiceActual
c     epsilon = SEAICE_hice_reg

          tmpscal0 = 0.5 _d 0 * recip_hiceActual(I,J)

C    -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
C         /* IceGrowthRateOpenWater */

          S_a_IGROW(I,J) = ZERO

c         Expand ice cover if the open water growth rate is positive
          IF ( IceGrowthRateOpenWater(I,J) .GT. ZERO) THEN
           IF ( AREApreTH(I,J) .GT. ZERO   .OR.
     &          S_h(I,J)       .GT. ZERO )  THEN
c     Determine which hemisphere for hemisphere-dependent
c     "lead closing variable", HO
            IF ( YC(I,J,bi,bj) .LT. ZERO ) THEN
             S_a_IGROW(I,J) = (ONE - AREApreTH(I,J)) *
     &            IceGrowthRateOpenWater(I,J)*recip_HO_south
            ELSE
             S_a_IGROW(I,J) = (ONE - AREApreTH(I,J)) *
     &            IceGrowthRateOpenWater(I,J)*recip_HO
            ENDIF
           ENDIF

C    -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
c         Contract ice cover if the open water growth rate is negative
          ELSE
           S_a_IGROW(I,J) = tmpscal0 *
     &          IceGrowthRateOpenWater(I,J) * (ONE - AREApreTH(I,J))
          ENDIF

          S_a(I,J) = S_a(I,J) + S_a_IGROW(I,J)

C    -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
c         /* IceGrowthRateMixedLayer */
C         Contract ice if the IceGrowthRateMixedLayer is negative
          S_a_IGRML(I,J) = ZERO

          IF ( IceGrowthRateMixedLayer(I,J) .LE. ZERO)  THEN
           S_a_IGRML(I,J) = tmpscal0 * IceGrowthRateMixedLayer(I,J)
          ENDIF

          S_a(I,J) = S_a(I,J) + S_a_IGRML(I,J)

c
C    -=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=-=
C         Contract ice if the NetExistingIceGrowthRate is negative
C         /* NetExistingIceGrowthRate */
          S_a_IGRNE(I,J) = ZERO
          IF ( NetExistingIceGrowthRate(I,J) .LE. ZERO .AND.
     &         HEFFpreTH(I,J)                .GT. ZERO ) THEN

           S_a_IGRNE(I,J) =
     &       tmpscal0 * NetExistingIceGrowthRate(I,J) * AREApreTH(I,J)

          ENDIF

          S_a(I,J) = S_a(I,J) + S_a_IGRNE(I,J)

         ENDDO
        ENDDO

C     Update the area, heff, and hsnow
        DO J=1,sNy
         DO I=1,sNx
          HEFF(I,J,bi,bj)  = HEFFpreTH(I,J) +
     &         SEAICE_deltaTtherm * S_h(I,J) * HEFFM(I,J,bi,bj)

          AREA(I,J,bi,bj)  = AREApreTH(I,J) +
     &         SEAICE_deltaTtherm * S_a(I,J) * HEFFM(I,J,bi,bj)

          HSNOW(I,J,bi,bj) = HSNWpreTH(I,J) +
     &         SEAICE_deltaTtherm * S_hsnow(I,J) * HEFFM(I,J,bi,bj)
         ENDDO
        ENDDO

#ifdef ALLOW_AUTODIFF_TAMC
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CADJ STORE AREA (:,:,bi,bj) = comlev1_bibj,key=tkey,byte=isbyte
CADJ STORE HEFF (:,:,bi,bj) = comlev1_bibj,key=tkey,byte=isbyte
CADJ STORE HSNOW(:,:,bi,bj) = comlev1_bibj,key=tkey,byte=isbyte
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
#endif /* ALLOW_AUTODIFF_TAMC */
        DO J=1,sNy
         DO I=1,sNx
c     Bound area, heff, and hsnow
          tmpscal0 = AREA(I,J,bi,bj)
          AREA(I,J,bi,bj)  = MIN(ONE,  tmpscal0)
          tmpscal1 = AREA(I,J,bi,bj)
          AREA(I,J,bi,bj)  = MAX(ZERO, tmpscal1)
          tmpscal2 = HEFF(I,J,bi,bj)
          HEFF(I,J,bi,bj)  = MAX(ZERO, tmpscal2)
          tmpscal3 = HSNOW(I,J,bi,bj)
          HSNOW(I,J,bi,bj) = MAX(ZERO, tmpscal3)

c     Sanity checks
          IF ( HEFF(I,J,bi,bj) .LE. ZERO .OR.
     &         AREA(I,J,bi,bj) .LE. ZERO ) THEN

           AREA(I,J,bi,bj)       = 0. _d 0
           HEFF(I,J,bi,bj)       = 0. _d 0
           HSNOW(I,J,bi,bj)      = 0. _d 0

          ENDIF

         ENDDO
        ENDDO

#ifdef SHORTWAVE_HEATING
        IF ( selectPenetratingSW .GE. 1 ) THEN
         DO J=1,sNy
          DO I=1,sNx

c         THE EFFECTIVE SHORTWAVE HEATING RATE
           QSW(I,J,bi,bj)  =
     &          QSWI(I,J)  * (      AREApreTH(I,J)) +
     &          QSWO(I,J)  * (ONE - AREApreTH(I,J))
          ENDDO
         ENDDO
        ELSE
#endif
         DO J=1,sNy
          DO I=1,sNx
           QSW(I,J,bi,bj) = 0. _d 0
          ENDDO
         ENDDO
#ifdef SHORTWAVE_HEATING
        ENDIF
#endif

        DO J=1,sNy
         DO I=1,sNx

c     The actual ice volume change over the time step
          ActualNewTotalVolumeChange(I,J) =
     &         HEFF(I,J,bi,bj) - HEFFpreTH(I,J)

c     The net average snow thickness melt that is actually realized. e.g.
c     hsnow_orig  = 0.25 m (e.g. 1 m of ice over a cell 1/4 covered in snow)
c     hsnow_new   = 0.20 m
c     snow accum  = 0.05 m
c     melt = 0.25 + 0.05 - 0.2 = 0.1 m

c     since this is in mean snow thickness it might have been  0.4 of actual
c     snow thickness over the 1/4 of the cell which is ice covered.
          ActualNewTotalSnowMelt(I,J) =
     &         HSNWpreTH(I,J) +
     &         SnowAccOverIce(I,J) -
     &         HSNOW(I,J,bi,bj)

c     The energy required to melt or form the new ice volume
          EnergyInNewTotalIceVolume(I,J) =
     &         ActualNewTotalVolumeChange(I,J)*recip_QI
c
c     This is the net energy flux out of the ice+ocean system
c     Remember -----
c     F_ia_net : Under ice/snow surface freezing conditions,
c                vertical conductive heat flux convergence (F_c < 0) balances
c                heat flux divergence to atmosphere (F_ia > 0)
c                Otherwise, F_ia_net = F_ia (pos)
c
c     F_io_net : Under ice/snow surface freezing conditions, F_c < 0.
c                Under ice surface melting conditions, F_c = 0 (no energy flux
c                from the ice to ocean)
c
c     So if we are freezing, F_io_net = the conductive flux and there
c     is energy balance at ice surface, F_ia_net =0.  If we are melting,
c     there is a convergence of energy into the ice from above
          NetEnergyFluxOutOfOcean(I,J) = SEAICE_deltaTtherm *
     &               ( AREApreTH(I,J) *
     &                 (F_ia_net(I,J) + F_io_net(I,J) + QSWI(I,J))
     &         +     ( ONE - AREApreTH(I,J)) *  F_ao(I,J))

c     THE QUANTITY OF HEAT WHICH IS THE RESIDUAL TO THE QUANTITY OF
c     ML temperature.  If the net energy flux is exactly balanced by the
c     latent energy of fusion in the new ice created then we will not
c     change the ML temperature at all.

          ResidualEnergyOutOfOcean(I,J) =
     &             NetEnergyFluxOutOfOcean(I,J) -
     &             EnergyInNewTotalIceVolume(I,J)

C     NOW FORMULATE QNET
C     THIS QNET DETERMINES THE TEMPERATURE CHANGE
C     QNET IS A DEPTH AVERAGED HEAT FLUX FOR THE OCEAN COLUMN

          QNET(I,J,bi,bj) =
     &             ResidualEnergyOutOfOcean(I,J) * recip_deltaTtherm

c     Like snow melt, if there is melting, this quantity is positive.
c     The change of freshwater content is per unit area over the entire
c     cell, not just over the ice covered bits.  This term is only used
c     to calculate freshwater fluxes for the purpose of changing the
c     salinity of the liquid cell.  In the case of non-zero ice salinity,
c     the amount of freshwater is reduced by the ratio of ice salinity
c     to water cell salinity.
          IF  (salt(I,J,kSurface,bi,bj) .GE. SEAICE_salt0 .AND.
     &         salt(I,J,kSurface,bi,bj) .GT. 0. _d 0) THEN

           FreshwaterContribFromIce(I,J) =
     &            - ActualNewTotalVolumeChange(I,J) *
     &              rhoIce2rhoFresh
C     &             * (ONE - SEAICE_salt0/salt(I,J,kSurface,bi,bj))

          ELSE
C     If the liquid cell has a lower salinity than the specified
c     salinity of sea ice then assume the sea ice is completely fresh
           FreshwaterContribFromIce(I,J) =
     &             -ActualNewTotalVolumeChange(I,J) *
     &              rhoIce2rhoFresh
          ENDIF
CAB
          tmpscal3 = max( 0. _d 0,
     &                    min(SEAICE_salt0,salt(I,J,kSurface,bi,bj)) )
CAB   Salt in ice + ridgid - ice from snow flood
          tmpscal2 = (ActualNewTotalVolumeChange(I,J)+
     &                   SIheffNeg(I,J,bi,bj)+
     &                  0.0 )
     &                   * tmpscal3
     &                   * HEFFM(I,J,bi,bj)
     &                   * recip_deltaTtherm * SEAICE_rhoIce

CAB   test for getting the lines
          saltflux(I,J,bi,bj) = tmpscal2
CAB

c     The freshwater contribution from snow comes only in the form of melt
c     unlike ice, which takes freshwater upon growth and yields freshwater
c     upon melt.  This is why the the actual new average snow melt was
c     determined. In m/m^2 over the entire cell.
          FreshwaterContribFromSnowMelt(I,J) =
     &         ActualNewTotalSnowMelt(I,J)*rhoSnow2rhoFresh

c    This seems to be in m/s, original time level 2 for area
c    Only the precip and evap need to be area weighted.  The runoff
c    and freshwater contribs from ice and snow melt are already mean
c    weighted
          EmPmR(I,J,bi,bj)  = HEFFM(I,J,bi,bj)*(
     &         ( EVAP(I,J,bi,bj) - PRECIP(I,J,bi,bj) )
     &         * ( ONE - AREApreTH(I,J) )
     &         - PrecipRateOverIceSurfaceToSea(I,J)*AREApreTH(I,J)
#ifdef ALLOW_RUNOFF
     &         - RUNOFF(I,J,bi,bj)
#endif
     &         - (FreshwaterContribFromIce(I,J) +
     &            FreshwaterContribFromSnowMelt(I,J))
     &           *recip_deltaTtherm ) * rhoConstFresh
     &         +( SIheffNeg(I,J,bi,bj)*SEAICE_rhoIce
     &          + SIhsnwNeg(I,J,bi,bj)*SEAICE_rhoSnow)
     &          *recip_deltaTtherm * HEFFM(I,J,bi,bj)

         ENDDO
        ENDDO

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C Treat flooding after calculations of QNET and before Sea Ice loading
        IF(SEAICEuseFlooding) THEN
#ifdef ALLOW_AUTODIFF_TAMC
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CADJ STORE HEFF (:,:,bi,bj) = comlev1_bibj,key=tkey,byte=isbyte
CADJ STORE HSNOW(:,:,bi,bj) = comlev1_bibj,key=tkey,byte=isbyte
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
#endif /* ALLOW_AUTODIFF_TAMC */
C     convert snow to ice if submerged.
         DO J=1,sNy
          DO I=1,sNx
           tmpscal0           = ( HSNOW(I,J,bi,bj)*SEAICE_rhoSnow
     &              +HEFF(I,J,bi,bj)*SEAICE_rhoIce )*recip_rhoConst
           d_HEFFbyFLOODING(I,J) = MAX(0. _d 0,tmpscal0-HEFF(I,J,bi,bj))
           HEFF(I,J,bi,bj)    = HEFF(I,J,bi,bj) + d_HEFFbyFLOODING(I,J)
           HSNOW(I,J,bi,bj)   = HSNOW(I,J,bi,bj)
     &                           - d_HEFFbyFLOODING(I,J)*ICE2SNOW

          ENDDO
         ENDDO
c     SEAICEuseFlooding
        ENDIF
#ifdef ALLOW_DIAGNOSTICS
        IF (useDiagnostics) THEN
         tmpscal1=1. _d 0 * recip_deltaTtherm
         CALL DIAGNOSTICS_SCALE_FILL(d_HEFFbyFLOODING,
     &      tmpscal1,1,'SIdHbFLO',0,1,3,bi,bj,myThid)
        ENDIF
#endif /* ALLOW_DIAGNOSTICS */

C     Sea Ice Load on the sea surface.
C     =================================
        IF ( useRealFreshWaterFlux ) THEN
         DO J=1,sNy
          DO I=1,sNx
#ifdef SEAICE_CAP_ICELOAD
           tmpscal1 = HEFF(I,J,bi,bj)*SEAICE_rhoIce
     &              + HSNOW(I,J,bi,bj)*SEAICE_rhoSnow
           tmpscal2 = MIN(tmpscal1,heffTooHeavy*rhoConst)
#else
           tmpscal2 = HEFF(I,J,bi,bj)*SEAICE_rhoIce
     &              + HSNOW(I,J,bi,bj)*SEAICE_rhoSnow
#endif
           sIceLoad(i,j,bi,bj) = tmpscal2
          ENDDO
         ENDDO
        ENDIF

C Everything down here is diagnostic, and should reflect what we
C calculated above and passed out to the ocean instead of computed
C again.  Otherwise we can end up with mismatch when we modify above
C and not replicate down here.
#ifdef ALLOW_DIAGNOSTICS
        IF (useDiagnostics) THEN
         DO J=1,sNy
          DO I=1,sNx
           SItflux(I,J,bi,bj) = 0.0 +
c     &        (AREApreTH(I,J)
c     &        *(F_ia_net(I,J)
c     &        + F_io_net(I,J) + QSWI(I,J))
c     &        +( ONE - AREApreTH(I,J)) *  F_ao(I,J))
     &          NetEnergyFluxOutOfOcean(I,J)*recip_deltaTtherm
     &          *HEFFM(I,J,bi,bj)
     &          +(SIheffNeg(I,J,bi,bj)*recip_QI
     &          +( SIhsnwNeg(I,J,bi,bj) - ActualNewTotalSnowMelt(I,J)
     &           + SnowAccOverIce(I,J) )*recip_QS)
     &          * recip_deltaTtherm * HEFFM(I,J,bi,bj)

           SIatmFW(I,J,bi,bj) = HEFFM(I,J,bi,bj)*(
     &          EVAP(I,J,bi,bj)*( ONE - AREApreTH(I,J) )
     &          - PRECIP(I,J,bi,bj)
#ifdef ALLOW_RUNOFF
     &          - RUNOFF(I,J,bi,bj)
#endif /* ALLOW_RUNOFF */
     &          )*rhoConstFresh
          ENDDO
         ENDDO

         IF (useRealFreshWaterFlux.AND.(nonlinFreeSurf.NE.0)) THEN
          DO J=1,sNy
           DO I=1,sNx
C Heat flux term associated with EmPmR:
            SIeprflx(I,J,bi,bj) =  -EmPmR(I,J,bi,bj)
     &           * HeatCapacity_Cp *theta(I,J,kSurface,bi,bj)
           ENDDO
          ENDDO
c        ELSE
CAB I  HAVE NOT FIGURED  OUT the QNET for the ELSE case, should not matter 01/14/2021 L2275
         ENDIF
        ENDIF
#endif /* ALLOW_DIAGNOSTICS */

#ifdef SEAICE_DEBUG
        DO j=1,sNy
         DO i=1,sNx

          IF ( (i .EQ. SEAICE_debugPointI)   .and.
     &         (j .EQ. SEAICE_debugPointJ) ) THEN

           print *,'ifice: myTime,myIter:',myTime,myIter

           print  '(A,2i4,2(1x,1P3E15.4))',
     &          'ifice i j --------------  ',i,j

           print  '(A,2i4,2(1x,1P3E15.4))',
     &          'ifice i j F(mi ao), rHIA  ',
     &          i,j, F_mi(i,j), F_ao(i,j),
     &          recip_hiceActual(i,j)

           print  '(A,2i4,2(1x,1P3E15.4))',
     &          'ifice i j Fi(a,ant2/1 ont)',
     &          i,j, F_ia(i,j),
     &          F_ia_net_before_snow(i,j),
     &          F_ia_net(i,j),
     &          F_io_net(i,j)

           print  '(A,2i4,2(1x,1P3E15.4))',
     &          'ifice i j AREA2/1 HEFF2/1 ',i,j,
     &          AREApreTH(I,J),
     &          AREA(i,j,bi,bj),
     &          HEFFpreTH(I,J),
     &          HEFF(i,j,bi,bj)

           print  '(A,2i4,2(1x,1P3E15.4))',
     &          'ifice i j HSNOW2/1 TMX    ',i,j,
     &          HSNWpreTH(I,J),
     &          HSNOW(I,J,bi,bj),
     &          theta(I,J,kSurface,bi,bj)

           print  '(A,2i4,2(1x,1P3E15.4))',
     &          'ifice i j TI ATP LWD      ',i,j,
     &          TICES(i,j,1, bi,bj) - celsius2k,
     &          ATEMP(i,j,bi,bj) - celsius2k,
     &          LWDOWN(i,j,bi,bj)

           print  '(A,2i4,2(1x,1P3E15.4))',
     &          'ifice i j S_a(tot,OW,ML,NE',i,j,
     &          S_a(i,j),
     &          S_a_IGROW(I,J),
     &          S_a_IGRML(I,J),
     &          S_a_IGRNE(I,J)

           print  '(A,2i4,2(1x,1P3E15.4))',
     &          'ifice i j S_a S_h S_hsnow ',i,j,
     &          S_a(i,j),
     &          S_h(i,j),
     &          S_hsnow(i,j)

           print  '(A,2i4,2(1x,1P3E15.4))',
     &          'ifice i j IGR(ML OW ICE)  ',i,j,
     &          IceGrowthRateMixedLayer(i,j),
     &          IceGrowthRateOpenWater(i,j),
     &          NetExistingIceGrowthRate(i,j)

           print  '(A,2i4,2(1x,1P3E15.4))',
     &          'ifice i j IVC(A ENIN)     ',i,j,
     &          ActualNewTotalVolumeChange(i,j),
     &          EnergyInNewTotalIceVolume(i,j)
c     &          ExpectedIceVolumeChange(i,j),

           print  '(A,2i4,2(1x,1P3E15.4))',
     &          'ifice i j EF(NOS RE) QNET ',i,j,
     &          NetEnergyFluxOutOfOcean(i,j),
     &          ResidualEnergyOutOfOcean(i,j),
     &          QNET(I,J,bi,bj)

           print  '(A,2i4,3(1x,1P3E15.4))',
     &          'ifice i j QSW QSWO QSWI   ',i,j,
     &          QSW(i,j,bi,bj),
     &          QSWO(i,j),
     &          QSWI(i,j)

c                  print  '(A,2i4,3(1x,1P3E15.4))',
c     &                 'ifice i j SW(BML IML SW)  ',i,j,
c     &                 QSW_absorb_below_first_layer(i,j),
c     &                 QSW_absorb_in_first_layer(i,j),
c     &                 SEAICE_SWFrac

c                  print  '(A,2i4,3(1x,1P3E15.4))',
c     &                 'ifice i j ptc(to, qsw, oa)',i,j,
c     &                 PredTempChange(i,j),
c     &                 PredTempChangeFromQSW (i,j),
c     &                 PredTempChangeFromOA_MQNET(i,j)

c                  print  '(A,2i4,3(1x,1P3E15.4))',
c     &                 'ifice i j ptc(fion,ian,ia)',i,j,
c     &                 PredTempChangeFromF_IO_NET(i,j),
c     &                 PredTempChangeFromF_IA_NET(i,j),
c     &                 PredTempChangeFromFIA(i,j)

c                  print  '(A,2i4,3(1x,1P3E15.4))',
c     &                 'ifice i j ptc(niv)        ',i,j,
c     &                 PredTempChangeFromNewIceVol(i,j)

           print  '(A,2i4,3(1x,1P3E15.4))',
     &          'ifice i j EmPmR EVP PRE RU',i,j,
     &          EmPmR(I,J,bi,bj),
     &          EVAP(I,J,bi,bj),
     &          PRECIP(I,J,bi,bj),
     &          RUNOFF(I,J,bi,bj)

           print  '(A,2i4,3(1x,1P3E15.4))',
     &          'ifice i j PRROIS,SAOI(R .)',i,j,
     &          PrecipRateOverIceSurfaceToSea(I,J),
     &          SnowAccRateOverIce(I,J),
     &          SnowAccOverIce(I,J)

           print  '(A,2i4,4(1x,1P3E15.4))',
     &          'ifice i j SM(PM PMR . .R) ',i,j,
     &          PotSnowMeltFromSurf(I,J),
     &          PotSnowMeltRateFromSurf(I,J),
     &          SnowMeltFromSurface(I,J),
     &          SnowMeltRateFromSurface(I,J)

           print  '(A,2i4,4(1x,1P3E15.4))',
     &          'ifice i j TotSnwMlt       ',i,j,
     &          ActualNewTotalSnowMelt(I,J)
c     &                 ExpectedSnowVolumeChange(I,J)

           print  '(A,2i4,4(1x,1P3E15.4))',
     &          'ifice i j fw(CFICE, CFSM) ',i,j,
     &          FreshwaterContribFromIce(I,J),
     &          FreshwaterContribFromSnowMelt(I,J)

           print  '(A,2i4,2(1x,1P3E15.4))',
     &          'ifice i j --------------  ',i,j

          ENDIF

         ENDDO
        ENDDO
#endif /* SEAICE_DEBUG */

C close bi,bj loops
       ENDDO
      ENDDO

#ifdef ALLOW_DIAGNOSTICS
      IF ( useDiagnostics ) THEN
C these diags need to be done outside of the bi,bj loop so that
C we may do potential global mean adjustement to them consistently.

       CALL DIAGNOSTICS_FILL(SItflux, 'SItflux ',0,1,0,1,1,myThid)
       CALL DIAGNOSTICS_FILL(SIeprflx,'SIeprflx',0,1,0,1,1,myThid)

C SIatmFW follows the same convention as empmr -- SIatmFW diag does not
       tmpscal1= - 1. _d 0
       CALL DIAGNOSTICS_SCALE_FILL(SIatmFW,
     &      tmpscal1,1,'SIatmFW ',0,1,0,1,1,myThid)
      ENDIF
#endif /* ALLOW_DIAGNOSTICS */

#else  /* ALLOW_EXF and ALLOW_ATM_TEMP */
      STOP 'SEAICE_GROWTH_ADX not compiled with EXF and ALLOW_ATM_TEMP'
#endif /* ALLOW_EXF and ALLOW_ATM_TEMP */
#endif /* SEAICE_USE_GROWTH_ADX */

      RETURN
      END

#include "SEAICE_OPTIONS.h"
#ifdef ALLOW_OBCS
# include "OBCS_OPTIONS.h"
#endif

CStartOfInterface
      SUBROUTINE SEAICE_INIT_VARIA( myThid )
C     *==========================================================*
C     | SUBROUTINE SEAICE_INIT_VARIA                             |
C     | o Initialization of sea ice model.                       |
C     *==========================================================*
C     *==========================================================*
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "DYNVARS.h"
#include "FFIELDS.h"
#include "SEAICE_SIZE.h"
#include "SEAICE_PARAMS.h"
#include "SEAICE_GRID.h"
#include "SEAICE.h"
#include "SEAICE_TRACER.h"
#ifdef OBCS_UVICE_OLD
# include "OBCS_GRID.h"
#endif

C     === Routine arguments ===
C     myThid :: Thread no. that called this routine.
      INTEGER myThid
CEndOfInterface

C     === Local variables ===
C     i,j,k,bi,bj :: Loop counters

      INTEGER i, j, bi, bj
      INTEGER kSrf
      INTEGER k
#ifdef ALLOW_SITRACER
      INTEGER iTr, jTh
#endif
#ifdef OBCS_UVICE_OLD
      INTEGER I_obc, J_obc
#endif /* ALLOW_OBCS */
#ifdef SEAICE_CGRID
      _RS mask_uice
      _RL recip_tensilDepth
#endif

      IF ( usingPCoords ) THEN
       kSrf = Nr
      ELSE
       kSrf = 1
      ENDIF

C--   Initialise all variables in common blocks:
      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          HEFF(i,j,bi,bj)=0. _d 0
          AREA(i,j,bi,bj)=0. _d 0
          HSNOW(i,j,bi,bj)   = 0. _d 0
#ifdef SEAICE_ITD
          DO k=1,nITD
           AREAITD(i,j,k,bi,bj) =0. _d 0
           HEFFITD(i,j,k,bi,bj) =0. _d 0
           HSNOWITD(i,j,k,bi,bj)=0. _d 0
          ENDDO
#endif
          UICE(i,j,bi,bj)=0. _d 0
          VICE(i,j,bi,bj)=0. _d 0
C
          uIceNm1(i,j,bi,bj) = 0. _d 0
          vIceNm1(i,j,bi,bj) = 0. _d 0
          DWATN  (i,j,bi,bj) = 0. _d 0
#ifdef SEAICE_CGRID
          stressDivergenceX(i,j,bi,bj) = 0. _d 0
          stressDivergenceY(i,j,bi,bj) = 0. _d 0
# ifdef SEAICE_ALLOW_EVP
          seaice_sigma1 (i,j,bi,bj) = 0. _d 0
          seaice_sigma2 (i,j,bi,bj) = 0. _d 0
          seaice_sigma12(i,j,bi,bj) = 0. _d 0
# endif /* SEAICE_ALLOW_EVP */
#endif
#if ( defined SEAICE_CGRID || defined SEAICE_BGRID_DYNAMICS )
          e11    (i,j,bi,bj) = 0. _d 0
          e22    (i,j,bi,bj) = 0. _d 0
          e12    (i,j,bi,bj) = 0. _d 0
          deltaC (i,j,bi,bj) = 0. _d 0
          PRESS  (i,j,bi,bj) = 0. _d 0
          ETA    (i,j,bi,bj) = 0. _d 0
          etaZ   (i,j,bi,bj) = 0. _d 0
          ZETA   (i,j,bi,bj) = 0. _d 0
          FORCEX (i,j,bi,bj) = 0. _d 0
          FORCEY (i,j,bi,bj) = 0. _d 0
          tensileStrFac(i,j,bi,bj) = 0. _d 0
          PRESS0(i,j,bi,bj)  = 0. _d 0
          FORCEX0(i,j,bi,bj) = 0. _d 0
          FORCEY0(i,j,bi,bj) = 0. _d 0
          SEAICE_zMax(i,j,bi,bj) = 0. _d 0
          SEAICE_zMin(i,j,bi,bj) = 0. _d 0
#endif
#ifdef SEAICE_CGRID
          seaiceMassC(i,j,bi,bj)=0. _d 0
          seaiceMassU(i,j,bi,bj)=0. _d 0
          seaiceMassV(i,j,bi,bj)=0. _d 0
# ifdef SEAICE_ALLOW_FREEDRIFT
          uice_fd(i,j,bi,bj) = 0. _d 0
          vice_fd(i,j,bi,bj) = 0. _d 0
# endif
# ifdef SEAICE_ALLOW_BOTTOMDRAG
          CbotC(i,j,bi,bj)   = 0. _d 0
# endif /* SEAICE_ALLOW_BOTTOMDRAG */
# ifdef SEAICE_ALLOW_SIDEDRAG
          sideDragU(i,j,bi,bj) = 0. _d 0
          sideDragV(i,j,bi,bj) = 0. _d 0
# endif /* SEAICE_ALLOW_SIDEDRAG */
#endif /* SEAICE_CGRID */
#ifdef SEAICE_BGRID_DYNAMICS
          uIceB(i,j,bi,bj)   = 0. _d 0
          vIceB(i,j,bi,bj)   = 0. _d 0
          AMASS(i,j,bi,bj)   = 0. _d 0
          DAIRN(i,j,bi,bj)   = 0. _d 0
          WINDX(i,j,bi,bj)   = 0. _d 0
          WINDY(i,j,bi,bj)   = 0. _d 0
          GWATX(i,j,bi,bj)   = 0. _d 0
          GWATY(i,j,bi,bj)   = 0. _d 0
#endif /* SEAICE_BGRID_DYNAMICS */
#ifdef SEAICE_VARIABLE_SALINITY
          HSALT(i,j,bi,bj)  = 0. _d 0
#endif
#ifdef ALLOW_SITRACER
          DO iTr = 1, SItrMaxNum
           SItracer(i,j,bi,bj,iTr) = 0. _d 0
           SItrBucket(i,j,bi,bj,iTr) = 0. _d 0
c "ice concentration" tracer that should remain .EQ.1.
           if (SItrName(iTr).EQ.'one') SItracer(i,j,bi,bj,iTr)=1. _d 0
          ENDDO
          DO jTh = 1, 5
           SItrHEFF (i,j,bi,bj,jTh) = 0. _d 0
          ENDDO
          DO jTh = 1, 3
           SItrAREA (i,j,bi,bj,jTh) = 0. _d 0
          ENDDO
#endif
          DO k=1,nITD
            TICES(i,j,k,bi,bj)=0. _d 0
          ENDDO
          saltWtrIce(i,j,bi,bj) = 0. _d 0
          frWtrIce(i,j,bi,bj)   = 0. _d 0
         ENDDO
        ENDDO
       ENDDO
      ENDDO

#ifdef ALLOW_AUTODIFF
C- Note: To simplify dependency & avoid recomputations, when compiling
C        pkg/autodiff, we always call SEAICE_INIT_VARIA to initialise control
C        variables (as done above) without condition on useSEAICE.
C        Therefore, in this case, the "If useSEAICE" is added back here:
      IF ( useSEAICE ) THEN
#endif

C--   Initialize (variable) grid info. As long as we allow masking of
C--   velocities outside of ice covered areas (in seaice_dynsolver)
C--   we need to re-initialize seaiceMaskU/V here for TAF
      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
#ifdef SEAICE_CGRID
        DO j=1-OLy+1,sNy+OLy
         DO i=1-OLx+1,sNx+OLx
          seaiceMaskU(i,j,bi,bj)=   0.0 _d 0
          seaiceMaskV(i,j,bi,bj)=   0.0 _d 0
          mask_uice=HEFFM(i,j,bi,bj)+HEFFM(i-1,j  ,bi,bj)
          IF(mask_uice.GT.1.5 _d 0) seaiceMaskU(i,j,bi,bj)=1.0 _d 0
          mask_uice=HEFFM(i,j,bi,bj)+HEFFM(i  ,j-1,bi,bj)
          IF(mask_uice.GT.1.5 _d 0) seaiceMaskV(i,j,bi,bj)=1.0 _d 0
         ENDDO
        ENDDO
# ifdef OBCS_UVICE_OLD
        IF (useOBCS) THEN
C--   If OBCS is turned on, close southern and western boundaries
         DO i=1-OLx,sNx+OLx
C Southern boundary
          J_obc = OB_Js(i,bi,bj)
          IF ( J_obc.NE.OB_indexNone ) THEN
           seaiceMaskU(i,J_obc,bi,bj)=   0.0 _d 0
           seaiceMaskV(i,J_obc,bi,bj)=   0.0 _d 0
          ENDIF
         ENDDO
         DO j=1-OLy,sNy+OLy
C Western boundary
          I_obc = OB_Iw(j,bi,bj)
          IF ( I_obc.NE.OB_indexNone ) THEN
           seaiceMaskU(I_obc,j,bi,bj)=   0.0 _d 0
           seaiceMaskV(I_obc,j,bi,bj)=   0.0 _d 0
          ENDIF
         ENDDO
        ENDIF
# endif /* OBCS_UVICE_OLD */
#endif /* SEAICE_CGRID */

        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          DO k=1,nITD
           TICES(i,j,k,bi,bj)=273.0 _d 0
          ENDDO
#ifdef SEAICE_CGRID
          seaiceMassC(i,j,bi,bj)=1000.0 _d 0
          seaiceMassU(i,j,bi,bj)=1000.0 _d 0
          seaiceMassV(i,j,bi,bj)=1000.0 _d 0
#endif
#ifdef SEAICE_BGRID_DYNAMICS
          AMASS      (i,j,bi,bj)=1000.0 _d 0
#endif
         ENDDO
        ENDDO

       ENDDO
      ENDDO

C--   Update overlap regions
#ifdef SEAICE_CGRID
      CALL EXCH_UV_XY_RL(seaiceMaskU,seaiceMaskV,.FALSE.,myThid)
#endif
#ifdef SEAICE_BGRID_DYNAMICS
      _EXCH_XY_RS(UVM, myThid)
#endif

C--   Now lets look at all these beasts
      IF ( plotLevel.GE.debLevC ) THEN
         CALL PLOT_FIELD_XYRL( HEFFM   , 'Current HEFFM   ' ,
     &        nIter0, myThid )
#ifdef SEAICE_CGRID
         CALL PLOT_FIELD_XYRL( seaiceMaskU, 'Current seaiceMaskU',
     &        nIter0, myThid )
         CALL PLOT_FIELD_XYRL( seaiceMaskV, 'Current seaiceMaskV',
     &        nIter0, myThid )
#endif
#ifdef SEAICE_BGRID_DYNAMICS
         CALL PLOT_FIELD_XYRS( UVM     , 'Current UVM     ' ,
     &        nIter0, myThid )
#endif
      ENDIF

C--   Set model variables to initial/restart conditions
      IF ( .NOT. ( startTime .EQ. baseTime .AND.  nIter0 .EQ. 0
     &     .AND. pickupSuff .EQ. ' ') ) THEN

         CALL SEAICE_READ_PICKUP ( myThid )

      ELSE

       DO bj=myByLo(myThid),myByHi(myThid)
        DO bi=myBxLo(myThid),myBxHi(myThid)
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           HEFF(i,j,bi,bj)=SEAICE_initialHEFF*HEFFM(i,j,bi,bj)
           UICE(i,j,bi,bj)=ZERO
           VICE(i,j,bi,bj)=ZERO
          ENDDO
         ENDDO
        ENDDO
       ENDDO

C--   Read initial sea-ice velocity from file (if available)
       IF ( uIceFile .NE. ' ' )
     &  CALL READ_FLD_XY_RL( uIceFile, ' ', uIce, 0, myThid )
       IF ( vIceFile .NE. ' ' )
     &  CALL READ_FLD_XY_RL( vIceFile, ' ', vIce, 0, myThid )
       IF ( uIceFile .NE. ' ' .OR. vIceFile .NE. ' ' ) THEN
#ifdef SEAICE_CGRID
        DO bj=myByLo(myThid),myByHi(myThid)
         DO bi=myBxLo(myThid),myBxHi(myThid)
          DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
            uIce(i,j,bi,bj) = uIce(i,j,bi,bj)*seaiceMaskU(i,j,bi,bj)
            vIce(i,j,bi,bj) = vIce(i,j,bi,bj)*seaiceMaskV(i,j,bi,bj)
           ENDDO
          ENDDO
         ENDDO
        ENDDO
#endif /* SEAICE_CGRID */
        CALL EXCH_UV_XY_RL( uIce, vIce, .TRUE., myThid )
       ENDIF

C--   Read initial sea-ice thickness from file if available.
       IF ( HeffFile .NE. ' ' ) THEN
        CALL READ_FLD_XY_RL( HeffFile, ' ', HEFF, 0, myThid )
        _EXCH_XY_RL(HEFF,myThid)
        DO bj=myByLo(myThid),myByHi(myThid)
         DO bi=myBxLo(myThid),myBxHi(myThid)
          DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
            HEFF(i,j,bi,bj) = MAX(HEFF(i,j,bi,bj),ZERO)
           ENDDO
          ENDDO
         ENDDO
        ENDDO
       ENDIF

       DO bj=myByLo(myThid),myByHi(myThid)
        DO bi=myBxLo(myThid),myBxHi(myThid)
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           IF(HEFF(i,j,bi,bj).GT.ZERO) AREA(i,j,bi,bj)=ONE
          ENDDO
         ENDDO
        ENDDO
       ENDDO

C--   Read initial sea-ice area from file if available.
       IF ( AreaFile .NE. ' ' ) THEN
        CALL READ_FLD_XY_RL( AreaFile, ' ', AREA, 0, myThid )
        _EXCH_XY_RL(AREA,myThid)
        DO bj=myByLo(myThid),myByHi(myThid)
         DO bi=myBxLo(myThid),myBxHi(myThid)
          DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
            AREA(i,j,bi,bj) = MAX(AREA(i,j,bi,bj),ZERO)
            AREA(i,j,bi,bj) = MIN(AREA(i,j,bi,bj),ONE)
            IF ( AREA(i,j,bi,bj) .LE. ZERO ) HEFF(i,j,bi,bj) = ZERO
            IF ( HEFF(i,j,bi,bj) .LE. ZERO ) AREA(i,j,bi,bj) = ZERO
           ENDDO
          ENDDO
         ENDDO
        ENDDO
       ENDIF

       DO bj=myByLo(myThid),myByHi(myThid)
        DO bi=myBxLo(myThid),myBxHi(myThid)
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           HSNOW(i,j,bi,bj) = 0.2 _d 0 * AREA(i,j,bi,bj)
          ENDDO
         ENDDO
        ENDDO
       ENDDO

C--   Read initial snow thickness from file if available.
       IF ( HsnowFile .NE. ' ' ) THEN
        CALL READ_FLD_XY_RL( HsnowFile, ' ', HSNOW, 0, myThid )
        _EXCH_XY_RL(HSNOW,myThid)
        DO bj=myByLo(myThid),myByHi(myThid)
         DO bi=myBxLo(myThid),myBxHi(myThid)
          DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
            HSNOW(i,j,bi,bj) = MAX(HSNOW(i,j,bi,bj),ZERO)
           ENDDO
          ENDDO
         ENDDO
        ENDDO
       ENDIF

#ifdef SEAICE_ITD
       DO bj=myByLo(myThid),myByHi(myThid)
        DO bi=myBxLo(myThid),myBxHi(myThid)
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           AREAITD(i,j,1,bi,bj)   = AREA(i,j,bi,bj)
           HEFFITD(i,j,1,bi,bj)   = HEFF(i,j,bi,bj)
           HSNOWITD(i,j,1,bi,bj)  = HSNOW(i,j,bi,bj)
           opnWtrFrac(i,j,bi,bj)  = 1. _d 0 - AREA(i,j,bi,bj)
           fw2ObyRidge(i,j,bi,bj) = 0. _d 0
          ENDDO
         ENDDO
         CALL SEAICE_ITD_REDIST(bi, bj, baseTime, nIter0, myThid)
        ENDDO
       ENDDO
#endif

#ifdef SEAICE_VARIABLE_SALINITY
       DO bj=myByLo(myThid),myByHi(myThid)
        DO bi=myBxLo(myThid),myBxHi(myThid)
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           HSALT(i,j,bi,bj)=HEFF(i,j,bi,bj)*salt(i,j,kSrf,bi,bj)*
     &            SEAICE_rhoIce*SEAICE_saltFrac
cif     &            ICE2WATR*rhoConstFresh*SEAICE_saltFrac

          ENDDO
         ENDDO
        ENDDO
       ENDDO

C--   Read initial sea ice salinity from file if available.
       IF ( HsaltFile .NE. ' ' ) THEN
        CALL READ_FLD_XY_RL( HsaltFile, ' ', HSALT, 0, myThid )
        _EXCH_XY_RL(HSALT,myThid)
       ENDIF
#endif /* SEAICE_VARIABLE_SALINITY */

#ifdef ALLOW_SITRACER
C--   Read initial sea ice age from file if available.
       DO iTr = 1, SItrMaxNum
        IF ( SItrFile(iTr) .NE. ' ' ) THEN
        CALL READ_FLD_XY_RL( siTrFile(iTr), ' ',
     &   SItracer(1-OLx,1-OLy,1,1,iTr), 0, myThid )
        _EXCH_XY_RL(SItracer(1-OLx,1-OLy,1,1,iTr),myThid)
        ENDIF
       ENDDO
#endif /* ALLOW_SITRACER */

      ENDIF

#ifdef ALLOW_OBCS
C--   In case we use scheme with a large stencil that extends into overlap:
C     no longer needed with the right masking in advection & diffusion S/R.
c     IF ( useOBCS ) THEN
c       DO bj=myByLo(myThid),myByHi(myThid)
c        DO bi=myBxLo(myThid),myBxHi(myThid)
c          CALL OBCS_COPY_TRACER( HEFF(1-OLx,1-OLy,bi,bj),
c    I                            1, bi, bj, myThid )
c          CALL OBCS_COPY_TRACER( AREA(1-OLx,1-OLy,bi,bj),
c    I                            1, bi, bj, myThid )
c          CALL OBCS_COPY_TRACER( HSNOW(1-OLx,1-OLy,bi,bj),
c    I                            1, bi, bj, myThid )
#ifdef SEAICE_VARIABLE_SALINITY
c          CALL OBCS_COPY_TRACER( HSALT(1-OLx,1-OLy,bi,bj),
c    I                            1, bi, bj, myThid )
#endif
c        ENDDO
c       ENDDO
c     ENDIF
#endif /* ALLOW_OBCS */

C---  Complete initialization
      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
#if ( defined SEAICE_CGRID || defined SEAICE_BGRID_DYNAMICS )
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          ZETA(i,j,bi,bj)        = HEFF(i,j,bi,bj)*(1.0 _d 11)
          ETA(i,j,bi,bj)         = ZETA(i,j,bi,bj)/SEAICE_eccen**2
          PRESS0(i,j,bi,bj)      = SEAICE_strength*HEFF(i,j,bi,bj)
     &         *EXP(-SEAICE_cStar*(ONE-AREA(i,j,bi,bj)))
          SEAICE_zMax(i,j,bi,bj) = SEAICE_zetaMaxFac*PRESS0(i,j,bi,bj)
          SEAICE_zMin(i,j,bi,bj) = SEAICE_zetaMin
          PRESS0(i,j,bi,bj)      = PRESS0(i,j,bi,bj)*HEFFM(i,j,bi,bj)
         ENDDO
        ENDDO
#endif
        IF ( useRealFreshWaterFlux .AND. .NOT.useThSIce ) THEN
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           sIceLoad(i,j,bi,bj) = HEFF(i,j,bi,bj)*SEAICE_rhoIce
     &                         + HSNOW(i,j,bi,bj)*SEAICE_rhoSnow

          ENDDO
         ENDDO
        ENDIF
       ENDDO
      ENDDO
#ifdef SEAICE_CGRID
C     compute tensile strength factor k: tensileStrength = k*PRESS
C     can be done in initialisation phase as long as it depends only
C     on depth
      IF ( SEAICE_tensilFac .NE. 0. _d 0 ) THEN
       recip_tensilDepth = 0. _d 0
       IF ( SEAICE_tensilDepth .GT. 0. _d 0 )
     &      recip_tensilDepth = 1. _d 0 / SEAICE_tensilDepth
       DO bj=myByLo(myThid),myByHi(myThid)
        DO bi=myBxLo(myThid),myBxHi(myThid)
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           tensileStrFac(i,j,bi,bj) = SEAICE_tensilFac*HEFFM(i,j,bi,bj)
     &          *exp(-ABS(R_low(i,j,bi,bj))*recip_tensilDepth)
          ENDDO
         ENDDO
        ENDDO
       ENDDO
      ENDIF
# if ( defined SEAICE_ALLOW_JFNK || defined SEAICE_ALLOW_KRYLOV )
C     Computing this metric cannot be done in S/R SEAICE_INIT_FIXED
C     where it belongs, because globalArea is only defined later after
C     S/R PACKAGES_INIT_FIXED, so we move this computation here.
      CALL SEAICE_MAP_RS2VEC( nVec, rAw, rAs,
     &     scalarProductMetric, .TRUE., myThid )
      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        DO i=1,nVec
         scalarProductMetric(i,1,bi,bj) =
     &        scalarProductMetric(i,1,bi,bj)/globalArea
        ENDDO
       ENDDO
      ENDDO
# endif /* SEAICE_ALLOW_JFNK or KRYLOV */

#endif /* SEAICE_CGRID */

#ifdef ALLOW_AUTODIFF
C-    end if useSEAICE block
      ENDIF
#endif

      RETURN
      END

#include "PACKAGES_CONFIG.h"
#include "CPP_OPTIONS.h"

CBOP
C     !ROUTINE: SWFRAC
C     !INTERFACE:
      SUBROUTINE SWFRAC(
     I                  imax, fact,
     U                  swdk,
     I                  myTime, myIter, myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE SWFRAC
C     | o Compute solar short-wave flux penetration.
C     *==========================================================*
C     | Compute fraction of solar short-wave flux penetrating to
C     | specified depth, swdk, due to exponential decay in
C     | Jerlov water type jwtype.
C     | Reference : Two band solar absorption model of Paulson
C     |             and Simpson (1977, JPO, 7, 952-956)
C     | Notes
C     | =====
C     | Parameter jwtype is hardcoded to 2 for time being.
C     | Below 200m the solar penetration gets set to zero,
C     | otherwise the limit for the exponent (+/- 5678) needs to
C     | be taken care of.
C     | Written by   : Jan Morzel
C     | Date         : July 12, 1995
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
C     input arguments
C     imax    :: number of vertical grid points
C     fact    :: scale  factor to apply to depth array
C     myTime  :: Current time in simulation
C     myIter  :: Current iteration number in simulation
C     myThid  :: My Thread Id. number
      INTEGER imax
      _RL     fact
      _RL     myTime
      INTEGER myIter
      INTEGER myThid
C     input/output arguments
C     swdk    :: on input: vertical depth for desired sw fraction
C               (fact*swdk) is negative distance (m) from surface
C     swdk    :: on output: short wave (radiation) fractional decay
      _RL     swdk(imax)

C     !LOCAL VARIABLES:
C     === Local variables ===
C     max number of different water types
      INTEGER   nwtype  , jwtype
      PARAMETER(nwtype=5)
      _RL facz
      _RL rfac(nwtype),a1(nwtype),a2(nwtype)
      INTEGER i
#ifdef ALLOW_CAL
c     _RL     fac
c     LOGICAL first, changed
c     INTEGER count0, count1, year0, year1
c     INTEGER jerl(12)
c     DATA jerl / 2 , 2 , 2 , 3 , 3 , 3 , 4 , 4 , 4 , 4 , 3 , 2 /
#endif /* ALLOW_CAL */
CEOP

C     Jerlov water type :
C                  I          IA         IB         II         III
C     jwtype :     1          2          3          4          5
      DATA rfac / 0.58 _d 0, 0.62 _d 0, 0.67 _d 0, 0.77 _d 0, 0.78 _d 0/
      DATA a1   / 0.35 _d 0, 0.6  _d 0, 1.0  _d 0, 1.5  _d 0, 1.4  _d 0/
      DATA a2   / 23.0 _d 0, 20.0 _d 0, 17.0 _d 0, 14.0 _d 0, 7.9  _d 0/

#ifdef ALLOW_CAL
ceh3 this should have an IF ( useCALENDAR ) THEN
CML(
C     myIter = 0 makes cal_getMonthsRec always return  count0=12
C     so that jerl(count0) = 2.
C     The following lines are meant to be an example of how to
C     include time dependent water types. However, it would probably
C     make more sense to first think about a regionally varying
C     water type before implementing a time dependence.
CML      CALL  cal_GetMonthsRec(
CML     O     fac, first, changed, count0, count1, year0, year1,
CML     I     myTime, myIter, myThid )
CML      jwtype=jerl(count0)
CML)
      jwtype=2
#else /* ALLOW_CAL undef */
      jwtype=2
#endif /* ALLOW_CAL */

      DO i = 1,imax
        facz = fact*swdk(i)
        IF ( facz .LT. -200. _d 0 ) THEN
          swdk(i) = 0. _d 0
        ELSE
          swdk(i) =       rfac(jwtype)  * exp( facz/a1(jwtype) )
     &       + (1. _d 0 - rfac(jwtype)) * exp( facz/a2(jwtype) )
        ENDIF
      ENDDO

      RETURN
      END

#include "MNC_OPTIONS.h"
      
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

CBOP 0
C     !ROUTINE: MNC_CW_CITER_SETG
      
C     !INTERFACE:
      SUBROUTINE MNC_CW_CITER_SETG( 
     I     igroup,
     I     iflag, ival_curr, ival_next,
     I     myThid ) 

C     !DESCRIPTION:
C     Set CITER information for group "igroup"

C     !USES:
      implicit none
#include "MNC_COMMON.h"

C     !INPUT PARAMETERS:
      integer igroup, iflag, ival_curr, ival_next, myThid
CEOP

C     !LOCAL VARIABLES:
      integer i

      mnc_cw_cit(1,igroup) = iflag
      IF ( ival_curr .GT. 0 ) THEN

        IF ( mnc_cw_cit(2,igroup) .NE. ival_curr ) THEN

C         The current iteration number has changed so we need to reset
C         the unlimited dimension for all the files in this citer group
          DO i = 1,MNC_MAX_ID
            IF ( mnc_cw_fgci(i) .eq. igroup ) THEN
              mnc_cw_fgud(i) = 0
            ENDIF
          ENDDO

          mnc_cw_cit(2,igroup) = ival_curr

        ENDIF
        
      ENDIF
      IF ( ival_next .GT. 0 ) THEN
        mnc_cw_cit(3,igroup) = ival_next
      ENDIF

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

CBOP 0
C     !ROUTINE: MNC_CW_CITER_GETG
      
C     !INTERFACE:
      SUBROUTINE MNC_CW_CITER_GETG( 
     I     igroup,
     O     iflag, ival_curr, ival_next,
     I     myThid ) 

C     !DESCRIPTION:
C     Get the current CITER information for group "igroup"

C     !USES:
      implicit none
#include "MNC_COMMON.h"

C     !INPUT PARAMETERS:
      integer igroup, iflag, ival_curr, ival_next, myThid
CEOP

      iflag     = mnc_cw_cit(1,igroup) 
      ival_curr = mnc_cw_cit(2,igroup)
      ival_next = mnc_cw_cit(3,igroup)

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

CBOP 0
C     !ROUTINE: MNC_CW_SET_CITER
      
C     !INTERFACE:
      SUBROUTINE MNC_CW_SET_CITER( 
     I     fgname, 
     I     igroup, 
     I     iflag, ival_curr, ival_next,
     I     myThid ) 

C     !DESCRIPTION:
C     Set the flag and/or current iteration value

C     !USES:
      implicit none
#include "MNC_COMMON.h"
#include "EEPARAMS.h"

C     !INPUT PARAMETERS:
      integer igroup, iflag, ival_curr, ival_next, myThid
      character*(*) fgname
CEOP

C     !LOCAL VARIABLES:
      integer fgf,fgl, indfg
      character*(MAX_LEN_MBUF) msgbuf

C     Functions
      integer IFNBLNK, ILNBLNK

C     Check that this name is not already defined
      fgf = IFNBLNK(fgname)
      fgl = ILNBLNK(fgname)
      CALL MNC_GET_IND(MNC_MAX_ID, fgname, mnc_cw_fgnm, indfg, myThid)
      IF (indfg .LT. 1) THEN
C       Error if this file group name is not set
        write(msgbuf,'(3a)') 
     &       'MNC_CW_SET_CITER ERROR: the file group name ''', 
     &       fgname(fgf:fgl), ''' does not exist'
        CALL print_error(msgbuf, mythid)
        STOP 'ABNORMAL END: S/R MNC_CW_SET_CITER'
      ENDIF

      IF (igroup .LT. 1) THEN
        igroup = mnc_cw_fgci(indfg)
      ELSE
        mnc_cw_fgci(indfg) = igroup
      ENDIF
      IF ((igroup .LT. 1) .OR. (igroup .GT. MNC_MAX_INFO)) THEN
        write(msgbuf,'(4a)') 
     &       'MNC_CW_SET_CITER ERROR: invalid igroup index for ', 
     &       'file group name ''', fgname(fgf:fgl), ''''
        CALL print_error(msgbuf, mythid)
        STOP 'ABNORMAL END: S/R MNC_CW_SET_CITER'
      ENDIF

      CALL MNC_CW_CITER_SETG( igroup, 
     &     iflag, ival_curr, ival_next, myThid )

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

CBOP 0
C     !ROUTINE: MNC_CW_GET_CITER
      
C     !INTERFACE:
      SUBROUTINE MNC_CW_GET_CITER( 
     I     fgname, 
     O     igroup, 
     O     iflag, ival_curr, ival_next,
     I     myThid ) 

C     !DESCRIPTION:
C     Set the flag and/or current iteration value

C     !USES:
      implicit none
#include "MNC_COMMON.h"
#include "EEPARAMS.h"

C     !INPUT PARAMETERS:
      integer igroup, iflag, ival_curr, ival_next, myThid
      character*(*) fgname
CEOP

C     !LOCAL VARIABLES:
      integer fgf,fgl, indfg
      character*(MAX_LEN_MBUF) msgbuf

C     Functions
      integer IFNBLNK, ILNBLNK

C     Check that this name is not already defined
      fgf = IFNBLNK(fgname)
      fgl = ILNBLNK(fgname)
      CALL MNC_GET_IND(MNC_MAX_ID, fgname, mnc_cw_fgnm, indfg, myThid)
      IF (indfg .LT. 1) THEN
C       Error if this file group name is not set
        write(msgbuf,'(3a)') 
     &       'MNC_CW_SET_CITER ERROR: the file group name ''', 
     &       fgname(fgf:fgl), ''' does not exist'
        CALL print_error(msgbuf, mythid)
        STOP 'ABNORMAL END: S/R MNC_CW_SET_CITER'
      ENDIF

      igroup = mnc_cw_fgci(indfg)
      IF ((igroup .LT. 1) .OR. (igroup .GT. MNC_MAX_INFO)) THEN
        igroup    = -1
        iflag     = -1
        ival_curr = -1
        ival_next = -1
      ELSE
        CALL MNC_CW_CITER_GETG( igroup, 
     &       iflag, ival_curr, ival_next, myThid )
      ENDIF


      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#include "SALT_PLUME_OPTIONS.h"

CBOP 0
C     !ROUTINE: SALT_PLUME_INIT_FIXED
C     !INTERFACE:
      SUBROUTINE SALT_PLUME_INIT_FIXED( myThid )

C     !DESCRIPTION:
C     Initialize SALT_PLUME variables that are kept fixed during the run.

C     !USES:
      IMPLICIT NONE
#include "EEPARAMS.h"
#include "SIZE.h"
#include "PARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     myThid ::  my Thread Id number
      INTEGER myThid
CEOP

#ifdef ALLOW_SALT_PLUME

#ifdef ALLOW_MNC
      IF (useMNC) THEN
        CALL SALT_PLUME_MNC_INIT( myThid )
      ENDIF
#endif /* ALLOW_MNC */

#ifdef ALLOW_DIAGNOSTICS
      IF ( useDiagnostics ) THEN
        CALL SALT_PLUME_DIAGNOSTICS_INIT( myThid )
      ENDIF
#endif /* ALLOW_DIAGNOSTICS */

#endif /* ALLOW_SALT_PLUME */

      RETURN
      END

#include "PACKAGES_CONFIG.h"
#include "CPP_OPTIONS.h"
#ifdef ALLOW_CD_CODE
#include "CD_CODE_OPTIONS.h"
#endif

CBOP
C     !ROUTINE: TIMESTEP
C     !INTERFACE:
      SUBROUTINE TIMESTEP( bi, bj, iMin, iMax, jMin, jMax, k,
     I                     dPhiHydX,dPhiHydY, phiSurfX, phiSurfY,
     I                     guDissip, gvDissip,
     I                     myTime, myIter, myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R TIMESTEP
C     | o Step model fields forward in time
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "SURFACE.h"
#include "RESTART.h"
#include "DYNVARS.h"
#ifdef ALLOW_NONHYDROSTATIC
#include "NH_VARS.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine Arguments ==
C     dPhiHydX,Y :: Gradient (X & Y directions) of Hydrostatic Potential
C     phiSurfX :: gradient of Surface potential (Pressure/rho, ocean)
C     phiSurfY ::          or geopotential (atmos) in X and Y direction
C     guDissip :: dissipation tendency (all explicit terms), u component
C     gvDissip :: dissipation tendency (all explicit terms), v component

      INTEGER bi,bj,iMin,iMax,jMin,jMax
      INTEGER k
      _RL     dPhiHydX(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL     dPhiHydY(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL     phiSurfX(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL     phiSurfY(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL     guDissip(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL     gvDissip(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL     myTime
      INTEGER myIter, myThid

C     !LOCAL VARIABLES:
C     == Local variables ==
C     guExt    :: forcing tendency, u component
C     gvExt    :: forcing tendency, v component
C     gu_AB    :: tendency increment from Adams-Bashforth, u component
C     gv_AB    :: tendency increment from Adams-Bashforth, v component
      INTEGER i,j
      _RL phFac, psFac
      _RL     guExt(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL     gvExt(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL     gUtmp(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL     gVtmp(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL     gu_AB(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL     gv_AB(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL     gUdPx(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL     gVdPy(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
#ifdef ALLOW_NONHYDROSTATIC
      _RL     nhFac
#endif
#ifdef ALLOW_CD_CODE
      _RL     guCor(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL     gvCor(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
#endif
CEOP

C-- explicit part of the surface potential gradient is added in this S/R
      psFac = pfFacMom*(1. _d 0 - implicSurfPress)
     &       *recip_deepFacC(k)*recip_rhoFacC(k)

C--  factors for gradient (X & Y directions) of Hydrostatic Potential
      phFac = pfFacMom

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C-    Initialize local arrays (not really necessary for all but safer)
      DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
          guExt(i,j) = 0. _d 0
          gvExt(i,j) = 0. _d 0
          gUtmp(i,j) = 0. _d 0
          gVtmp(i,j) = 0. _d 0
          gUdPx(i,j) = 0. _d 0
          gVdPy(i,j) = 0. _d 0
#ifdef ALLOW_CD_CODE
          guCor(i,j) = 0. _d 0
          gvCor(i,j) = 0. _d 0
#endif
        ENDDO
      ENDDO

      IF ( momForcing ) THEN
C--   Collect forcing term in local array guExt,gvExt:
        CALL APPLY_FORCING_U(
     U                        guExt,
     I                        iMin,iMax,jMin,jMax, k, bi,bj,
     I                        myTime, myIter, myThid )
        CALL APPLY_FORCING_V(
     U                        gvExt,
     I                        iMin,iMax,jMin,jMax, k, bi,bj,
     I                        myTime, myIter, myThid )
      ENDIF

      IF ( .NOT.staggerTimeStep .AND. .NOT.implicitIntGravWave ) THEN
C--   Synchronous time step: add grad Phi_Hyp to gU,gV before doing Adams-Bashforth
        DO j=jMin,jMax
         DO i=iMin,iMax
           gU(i,j,k,bi,bj) = gU(i,j,k,bi,bj) - phFac*dPhiHydX(i,j)
           gV(i,j,k,bi,bj) = gV(i,j,k,bi,bj) - phFac*dPhiHydY(i,j)
         ENDDO
        ENDDO
c     ELSE
C--   Stagger time step: grad Phi_Hyp will be added later
      ENDIF

C--   Dissipation term inside the Adams-Bashforth:
      IF ( momViscosity .AND. momDissip_In_AB) THEN
        DO j=jMin,jMax
         DO i=iMin,iMax
           gU(i,j,k,bi,bj) = gU(i,j,k,bi,bj) + guDissip(i,j)
           gV(i,j,k,bi,bj) = gV(i,j,k,bi,bj) + gvDissip(i,j)
         ENDDO
        ENDDO
      ENDIF

C--   Forcing term inside the Adams-Bashforth:
      IF ( momForcing .AND. momForcingOutAB.NE.1 ) THEN
        DO j=jMin,jMax
         DO i=iMin,iMax
           gU(i,j,k,bi,bj) = gU(i,j,k,bi,bj) + guExt(i,j)
           gV(i,j,k,bi,bj) = gV(i,j,k,bi,bj) + gvExt(i,j)
         ENDDO
        ENDDO
      ENDIF

#ifdef CD_CODE_NO_AB_MOMENTUM
      IF ( useCDscheme ) THEN
C-    CD-scheme, before doing AB, store gU,Vtmp = gU,V^n (+dissip. +forcing)
        DO j=jMin,jMax
         DO i=iMin,iMax
           gUtmp(i,j) = gU(i,j,k,bi,bj)
           gVtmp(i,j) = gV(i,j,k,bi,bj)
         ENDDO
        ENDDO
      ENDIF
#endif /* CD_CODE_NO_AB_MOMENTUM */

C-    Compute effective gU,gV_[n+1/2] terms (including Adams-Bashforth weights)
C     and save gU,gV_[n] into guNm1,gvNm1 for the next time step.
#ifdef ALLOW_ADAMSBASHFORTH_3
      CALL ADAMS_BASHFORTH3(
     I                        bi, bj, k, Nr,
     U                        gU(1-OLx,1-OLy,1,bi,bj), guNm,
     O                        gu_AB,
     I                        mom_StartAB, myIter, myThid )
      CALL ADAMS_BASHFORTH3(
     I                        bi, bj, k, Nr,
     U                        gV(1-OLx,1-OLy,1,bi,bj), gvNm,
     O                        gv_AB,
     I                        mom_StartAB, myIter, myThid )
#else /* ALLOW_ADAMSBASHFORTH_3 */
      CALL ADAMS_BASHFORTH2(
     I                        bi, bj, k, Nr,
     U                        gU(1-OLx,1-OLy,1,bi,bj),
     U                        guNm1(1-OLx,1-OLy,1,bi,bj),
     O                        gu_AB,
     I                        mom_StartAB, myIter, myThid )
      CALL ADAMS_BASHFORTH2(
     I                        bi, bj, k, Nr,
     U                        gV(1-OLx,1-OLy,1,bi,bj),
     U                        gvNm1(1-OLx,1-OLy,1,bi,bj),
     O                        gv_AB,
     I                        mom_StartAB, myIter, myThid )
#endif /* ALLOW_ADAMSBASHFORTH_3 */
#ifdef ALLOW_DIAGNOSTICS
      IF ( useDiagnostics ) THEN
        CALL DIAGNOSTICS_FILL(gu_AB,'AB_gU   ',k,1,2,bi,bj,myThid)
        CALL DIAGNOSTICS_FILL(gv_AB,'AB_gV   ',k,1,2,bi,bj,myThid)
      ENDIF
#endif /* ALLOW_DIAGNOSTICS */

C-     Make a local copy in gU,Vtmp of gU,V^n+1/2 (+dissip. +forcing)
#ifdef CD_CODE_NO_AB_MOMENTUM
      IF ( .NOT.useCDscheme ) THEN
#endif
        DO j=jMin,jMax
         DO i=iMin,iMax
           gUtmp(i,j) = gU(i,j,k,bi,bj)
           gVtmp(i,j) = gV(i,j,k,bi,bj)
         ENDDO
        ENDDO
#ifdef CD_CODE_NO_AB_MOMENTUM
      ENDIF
#endif

C--   Forcing term outside the Adams-Bashforth:
      IF ( momForcing .AND. momForcingOutAB.EQ.1 ) THEN
        DO j=jMin,jMax
         DO i=iMin,iMax
           gUtmp(i,j) = gUtmp(i,j) + guExt(i,j)
           gVtmp(i,j) = gVtmp(i,j) + gvExt(i,j)
         ENDDO
        ENDDO
      ENDIF

C--   Dissipation term outside the Adams-Bashforth:
      IF ( momViscosity .AND. .NOT.momDissip_In_AB ) THEN
        DO j=jMin,jMax
         DO i=iMin,iMax
           gUtmp(i,j) = gUtmp(i,j) + guDissip(i,j)
           gVtmp(i,j) = gVtmp(i,j) + gvDissip(i,j)
         ENDDO
        ENDDO
      ENDIF

#ifdef ALLOW_CD_CODE
      IF ( useCDscheme ) THEN
C-     Step forward D-grid velocity using C-grid gU,Vtmp = gU,V +dissip +forcing
C      and return coriolis terms on C-grid (guCor,gvCor)
        CALL CD_CODE_SCHEME(
     I                  bi,bj,k, dPhiHydX,dPhiHydY, gUtmp,gVtmp,
     O                  guCor,gvCor,
     I                  myTime, myIter, myThid)

#ifdef CD_CODE_NO_AB_MOMENTUM
        IF ( momForcing .AND. momForcingOutAB.EQ.1 ) THEN
         DO j=jMin,jMax
          DO i=iMin,iMax
           gUtmp(i,j) = ( gU(i,j,k,bi,bj) + guExt(i,j) ) + guCor(i,j)
           gVtmp(i,j) = ( gV(i,j,k,bi,bj) + gvExt(i,j) ) + gvCor(i,j)
          ENDDO
         ENDDO
        ELSE
         DO j=jMin,jMax
          DO i=iMin,iMax
           gUtmp(i,j) = gU(i,j,k,bi,bj) + guCor(i,j)
           gVtmp(i,j) = gV(i,j,k,bi,bj) + gvCor(i,j)
          ENDDO
         ENDDO
        ENDIF
        IF ( momViscosity .AND. .NOT.momDissip_In_AB ) THEN
         DO j=jMin,jMax
          DO i=iMin,iMax
           gUtmp(i,j) = gUtmp(i,j) + guDissip(i,j)
           gVtmp(i,j) = gVtmp(i,j) + gvDissip(i,j)
          ENDDO
         ENDDO
        ENDIF
#else /* CD_CODE_NO_AB_MOMENTUM */
        DO j=jMin,jMax
         DO i=iMin,iMax
           gUtmp(i,j) = gUtmp(i,j) + guCor(i,j)
           gVtmp(i,j) = gVtmp(i,j) + gvCor(i,j)
         ENDDO
        ENDDO
#endif /* CD_CODE_NO_AB_MOMENTUM */
      ENDIF
#endif /* ALLOW_CD_CODE */

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#ifdef NONLIN_FRSURF
      IF ( .NOT. vectorInvariantMomentum
     &     .AND. nonlinFreeSurf.GT.1 ) THEN
       IF ( select_rStar.GT.0 ) THEN
# ifndef DISABLE_RSTAR_CODE
        DO j=jMin,jMax
         DO i=iMin,iMax
           gUtmp(i,j) = gUtmp(i,j)/rStarExpW(i,j,bi,bj)
           gVtmp(i,j) = gVtmp(i,j)/rStarExpS(i,j,bi,bj)
         ENDDO
        ENDDO
# endif /* DISABLE_RSTAR_CODE */
       ELSEIF ( selectSigmaCoord.NE.0 ) THEN
# ifndef DISABLE_SIGMA_CODE
        DO j=jMin,jMax
         DO i=iMin,iMax
           gUtmp(i,j) = gUtmp(i,j)
     &        /( 1. _d 0 + dEtaWdt(i,j,bi,bj)*deltaTFreeSurf
     &                    *dBHybSigF(k)*recip_drF(k)
     &                    *recip_hFacW(i,j,k,bi,bj)
     &         )
           gVtmp(i,j) = gVtmp(i,j)
     &        /( 1. _d 0 + dEtaSdt(i,j,bi,bj)*deltaTFreeSurf
     &                    *dBHybSigF(k)*recip_drF(k)
     &                    *recip_hFacS(i,j,k,bi,bj)
     &         )
         ENDDO
        ENDDO
# endif /* DISABLE_SIGMA_CODE */
       ELSE
        DO j=jMin,jMax
         DO i=iMin,iMax
          IF ( k.EQ.kSurfW(i,j,bi,bj) ) THEN
           gUtmp(i,j) = gUtmp(i,j)
     &         *_hFacW(i,j,k,bi,bj)/hFac_surfW(i,j,bi,bj)
          ENDIF
          IF ( k.EQ.kSurfS(i,j,bi,bj) ) THEN
           gVtmp(i,j) = gVtmp(i,j)
     &         *_hFacS(i,j,k,bi,bj)/hFac_surfS(i,j,bi,bj)
          ENDIF
         ENDDO
        ENDDO
       ENDIF
      ENDIF
#endif /* NONLIN_FRSURF */

C-- Explicit (remaining) part of the Hyd pressure gradient:
      IF ( staggerTimeStep .OR. implicitIntGravWave ) THEN
        DO j=jMin,jMax
         DO i=iMin,iMax
           gUdPx(i,j) = -phFac*dPhiHydX(i,j) - psFac*phiSurfX(i,j)
           gVdPy(i,j) = -phFac*dPhiHydY(i,j) - psFac*phiSurfY(i,j)
         ENDDO
        ENDDO
      ELSEIF ( implicSurfPress.NE.oneRL ) THEN
        DO j=jMin,jMax
         DO i=iMin,iMax
           gUdPx(i,j) = -psFac*phiSurfX(i,j)
           gVdPy(i,j) = -psFac*phiSurfY(i,j)
         ENDDO
        ENDDO
      ENDIF

#ifdef ALLOW_NONHYDROSTATIC
C-- explicit part of the NH pressure gradient is added here
      IF ( use3Dsolver .AND. implicitNHPress.NE.1. _d 0 ) THEN
        nhFac = pfFacMom*(1. _d 0 - implicitNHPress)
     &         *recip_deepFacC(k)*recip_rhoFacC(k)
       IF ( exactConserv ) THEN
        DO j=jMin,jMax
         DO i=iMin,iMax
          gUdPx(i,j) = gUdPx(i,j)
     &               - nhFac*_recip_dxC(i,j,bi,bj)
     &               *( (phi_nh(i,j,k,bi,bj)-phi_nh(i-1,j,k,bi,bj))
     &                 -( dPhiNH(i,j,bi,bj) - dPhiNH(i-1,j,bi,bj) )
     &                )
          gVdPy(i,j) = gVdPy(i,j)
     &               - nhFac*_recip_dyC(i,j,bi,bj)
     &               *( (phi_nh(i,j,k,bi,bj)-phi_nh(i,j-1,k,bi,bj))
     &                 -( dPhiNH(i,j,bi,bj) - dPhiNH(i,j-1,bi,bj) )
     &                )
         ENDDO
        ENDDO
       ELSE
        DO j=jMin,jMax
         DO i=iMin,iMax
          gUdPx(i,j) = gUdPx(i,j)
     &               - nhFac*_recip_dxC(i,j,bi,bj)
     &               *( phi_nh(i,j,k,bi,bj) - phi_nh(i-1,j,k,bi,bj) )
          gVdPy(i,j) = gVdPy(i,j)
     &               - nhFac*_recip_dyC(i,j,bi,bj)
     &               *( phi_nh(i,j,k,bi,bj) - phi_nh(i,j-1,k,bi,bj) )
         ENDDO
        ENDDO
       ENDIF
      ENDIF
#endif /* ALLOW_NONHYDROSTATIC */

C     Step forward zonal velocity (store in Gu)
      DO j=jMin,jMax
        DO i=iMin,iMax
          gU(i,j,k,bi,bj) = uVel(i,j,k,bi,bj)
     &     + deltaTMom*( gUtmp(i,j) + gUdPx(i,j) )
     &                *_maskW(i,j,k,bi,bj)
        ENDDO
      ENDDO

C     Step forward meridional velocity (store in Gv)
      DO j=jMin,jMax
        DO i=iMin,iMax
          gV(i,j,k,bi,bj) = vVel(i,j,k,bi,bj)
     &     + deltaTMom*( gVtmp(i,j) + gVdPy(i,j) )
     &                *_maskS(i,j,k,bi,bj)
        ENDDO
      ENDDO

#ifdef ALLOW_DIAGNOSTICS
      IF ( useDiagnostics ) THEN
        IF ( staggerTimeStep .OR. implicitIntGravWave ) THEN
         DO j=jMin,jMax
          DO i=iMin,iMax
            gUdPx(i,j) = gUdPx(i,j)*_maskW(i,j,k,bi,bj)
            gVdPy(i,j) = gVdPy(i,j)*_maskS(i,j,k,bi,bj)
          ENDDO
         ENDDO
        ELSE
         DO j=jMin,jMax
          DO i=iMin,iMax
            gUdPx(i,j) = ( gUdPx(i,j) - phFac*dPhiHydX(i,j) )
     &                 *_maskW(i,j,k,bi,bj)
            gVdPy(i,j) = ( gVdPy(i,j) - phFac*dPhiHydY(i,j) )
     &                 *_maskS(i,j,k,bi,bj)
          ENDDO
         ENDDO
        ENDIF
        CALL DIAGNOSTICS_FILL( gUdPx,'Um_dPhiX',k,1,2,bi,bj,myThid )
        CALL DIAGNOSTICS_FILL( gVdPy,'Vm_dPhiY',k,1,2,bi,bj,myThid )
      ENDIF
      IF ( momViscosity .AND. useDiagnostics ) THEN
        CALL DIAGNOSTICS_FILL( guDissip,'Um_Diss ',k,1,2,bi,bj,myThid )
        CALL DIAGNOSTICS_FILL( gvDissip,'Vm_Diss ',k,1,2,bi,bj,myThid )
      ENDIF
      IF ( momForcing .AND. useDiagnostics ) THEN
        CALL DIAGNOSTICS_FILL( guExt,'Um_Ext  ',k,1,2,bi,bj,myThid )
        CALL DIAGNOSTICS_FILL( gvExt,'Vm_Ext  ',k,1,2,bi,bj,myThid )
      ENDIF
#ifdef ALLOW_CD_CODE
      IF ( useCDscheme .AND. useDiagnostics ) THEN
        CALL DIAGNOSTICS_FILL( guCor,'Um_Cori ',k,1,2,bi,bj,myThid )
        CALL DIAGNOSTICS_FILL( gvCor,'Vm_Cori ',k,1,2,bi,bj,myThid )
      ENDIF
#endif /* ALLOW_CD_CODE */
#endif /* ALLOW_DIAGNOSTICS */

      RETURN
      END

#include "OPPS_OPTIONS.h"
#undef OPPS_ORGCODE

C--  File opps_calc.F:
C--   Contents
C--   o OPPS_CALC
C--   o STATE1
C--   o NLOPPS

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C !ROUTINE: OPPS_CALC

C !INTERFACE: ======================================================
      SUBROUTINE OPPS_CALC(
     U     tracerEnv,
     O     OPPSconvectCount,
     I     wVel,
     I     kMax, nTracer, nTracerInuse,
     I     I, J, bi, bj, myTime, myIter, myThid )

C !DESCRIPTION: \bv
C     *=====================================================================*
C     | SUBROUTINE OPPS_CALC                                                |
C     | o Compute all OPPS fields defined in OPPS.h                         |
C     *=====================================================================*
C     | This subroutine is based on the routine 3dconvection.F              |
C     | by E. Skyllingstad (?)                                              |
C     | plenty of modifications to make it work:                            |
C     | - removed many unused parameters and variables                      |
C     | - turned everything (back) into 1D code                             |
C     | - pass variables, that are originally in common blocks:             |
C     |   maxDepth                                                          |
C     | - pass vertical velocity, set in OPPS_INTERFACE                     |
C     | - do not use convadj for now (whatever that is)                     |
C     | - changed two .LT. 0 to .LE. 0 statements (because of possible      |
C     |   division)                                                         |
C     | - replaced statement function state1 by call to a real function     |
C     | - removed range check, actually moved it up to OPPS_INTERFACE       |
C     | - avoid division by zero: if (Wd.EQ.0) dt = ...1/Wd                 |
C     | - cleaned-up debugging                                              |
C     | - replaced local dz and GridThickness by global drF                 |
C     | - replaced 1/dz by 1*recip_drF                                      |
C     | - replaced 9.81 with gravity (=9.81)                                |
C     | - added a lot of comments that relate code to equation in paper     |
C     |   (Paluszkiewicz+Romea, 1997, Dynamics of Atmospheres and Oceans,   |
C     |   26, pp. 95-130)                                                   |
C     | - included passive tracer support. This is the main change and may  |
C     |   not improve the readability of the code because of the joint      |
C     |   treatment of active (theta, salt) and passive tracers. The array  |
C     |   tracerEnv(Nr,2+PTRACERS_num) contains                             |
C     |   theta    = tracerEnv(:,1),                                        |
C     |   salt     = tracerEnv(:,2), and                                    |
C     |   ptracers = tracerEnv(:,3:PTRACERS_num+2).                         |
C     |   All related array names have been changed accordingly, so that    |
C     |   instead of Sd(Nr) and Td(Nr) (plume salinity and temperature), we |
C     |   have Pd(Nr,nTracer) (tracer in plume), with Sd(:) = Pd(:,2),      |
C     |   Td(:) = Pd(:,1), etc.                                             |
C     | o TODO:                                                             |
C     |   clean up the logic of the vertical loops and get rid off the      |
C     |   GOTO statements                                                   |
C     *=====================================================================*
C \ev

      IMPLICIT NONE

C !USES: ==============================================================
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "OPPS.h"
#include "GRID.h"

C !INPUT/OUTPUT PARAMETERS: ============================================
C Routine arguments
C     OPPSconvectCount :: counter for freqency of convection events
C     bi, bj :: array indices on which to apply calculations
C     myTime :: Current time in simulation
      INTEGER KMax, nTracer, nTracerInUse
      _RL tracerEnv(Nr,nTracer)
      _RL OPPSconvectCount(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL wVel(Nr)
      INTEGER I, J, bi, bj
      _RL     myTime
      INTEGER myThid, myIter

#ifdef ALLOW_OPPS
C !FUNCTIONS: ==========================================================
c     EXTERNAL DIFFERENT_MULTIPLE
c     LOGICAL  DIFFERENT_MULTIPLE
      _RL STATE1

C !LOCAL VARIABLES: ====================================================
C Local constants
C     msgBuf      :: Informational/error message buffer
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      INTEGER K, K2, K2m1, K2p1, ktr
      INTEGER ntime,nn,kmx,ic
      INTEGER maxDepth

      _RL wsqr,oldflux,newflux,entrainrate
      _RL pmix
      _RL D1, D2
      _RL dz1,dz2
      _RL radius,StartingFlux
      _RL dtts,dt
C     Arrays
      _RL Paa(Nr,nTracer)
      _RL wda(Nr), mda(Nr), pda(Nr,nTracer)
C
C     Pd, Wd           :: tracers, vertical velocity in plume
C     Md               :: plume mass flux (?)
C     Ad               :: fractional area covered by plume
C     Dd               :: density in plume
C     De               :: density of environment
C     PlumeEntrainment ::
      _RL Ad(Nr),Wd(Nr),Dd(Nr),Md(Nr)
      _RL De(Nr)
      _RL PlumeEntrainment(Nr)
      _RL Pd(Nr,nTracer)
CEOP

C--   Check to see if should convect now
C      IF ( DIFFERENT_MULTIPLE(cAdjFreq,myTime,deltaTClock) ) THEN
      IF ( .true. ) THEN
C     local initialization

C     Copy some arrays
      dtts = dTtracerLev(1)

C     start k-loop

      DO k=1,KMax-1

C initialize the plume T,S,density, and w velocity

       DO ktr=1,nTracerInUse
        Pd(k,ktr) = tracerEnv(k,ktr)
       ENDDO
       Dd(k)=STATE1(Pd(k,2),Pd(k,1),i,j,k,bi,bj,myThid)
       De(k)=Dd(k)
CML       print *, 'ml-opps:', i,j,k,tracerEnv(k,2),tracerEnv(k,1),
CML     &      Dd(k),Pd(k,1),Pd(k,2)
CML compute vertical velocity at cell centers from GCM velocity
       Wd(k)= - .5*(wVel(K)+wVel(K+1))
CML(
CML    avoid division by zero
CML       IF (Wd(K) .EQ. 0.D0) Wd(K) = 2.23e-16
CML)

C guess at initial top grid cell vertical velocity

CML          Wd(k) = 0.03

C these estimates of initial plume velocity based on plume size and
C top grid cell water mass

c          Wd(k) = 0.5*drF(k)/(dtts*FRACTIONAL_AREA)
c          Wd(k) = 0.5*drF(k)/dtts

       wsqr=Wd(k)*Wd(k)
       PlumeEntrainment(k) = 0.0

#ifdef ALLOW_OPPS_DEBUG
       IF ( OPPSdebugLevel.GE.debLevB ) THEN
        WRITE(msgBuf,'(A,I3)')
     &       'S/R OPPS_CALC: doing old lowerparcel', k
        CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &       SQUEEZE_RIGHT , 1)
       ENDIF
#endif /* ALLOW_OPPS_DEBUG */
       radius=PlumeRadius
       StartingFlux=radius*radius*Wd(k)*Dd(k)
       oldflux=StartingFlux

       dz2=DrF(k)
       DO k2=k,KMax-1
        D1=STATE1( Pd(k2,2), Pd(k2,1),i,j,k2+1,bi,bj,myThid)
        D2=STATE1( tracerEnv(k2+1,2), tracerEnv(k2+1,1),
     &                                i,j,k2+1,bi,bj,myThid)
        De(k2+1)=D2

C To start downward, parcel has to initially be heavier than environment
C but after it has started moving, we continue plume until plume tke or
C flux goes negative

CML     &       _hFacC(i,j,k-1,bi,bj)
CML     &       *_hFacC(i,j,k,bi,bj) .GT. 0.
CML     &  .AND.
        IF (D2-D1 .LT. STABILITY_THRESHOLD.or.k2.ne.k) THEN
         dz1=dz2
         dz2=DrF(k2+1)

C     find mass flux according to eq.(3) from paper by vertical integration

         newflux=oldflux+e2*radius*Wd(k2)*Dd(k2)*
     &        .5*(dz1+dz2)
CML         print *, 'ml-opps:', i,j,k,oldflux,newflux,e2,radius,
CML     &        Wd(k2),Dd(k2),Pd(k2,1),Pd(k2,2),dz1,dz2

         PlumeEntrainment(k2+1) = newflux/StartingFlux

         IF(newflux.LE.0.0) then
#ifdef ALLOW_OPPS_DEBUG
          IF ( OPPSdebugLevel.GE.debLevA ) THEN
           WRITE(msgBuf,'(A,I3)')
     &          'S/R OPPS_CALC: Plume entrained to zero at level ', k2
           CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &          SQUEEZE_RIGHT , 1)
          ENDIF
#endif /* ALLOW_OPPS_DEBUG */
          maxdepth = k2
          if(maxdepth.eq.k) goto 1000
          goto 1
         endif

C entrainment rate is basically a scaled mass flux dM/M

         entrainrate = (newflux - oldflux)/newflux
         oldflux = newflux

C mix var(s) are the average environmental values over the two grid levels

         DO ktr=1,nTracerInUse
          pmix=(dz1*tracerEnv(k2,ktr)+dz2*tracerEnv(k2+1,ktr))
     &         /(dz1+dz2)
          Pd(k2+1,ktr)=Pd(k2,ktr)
     &         - entrainrate*(pmix - Pd(k2,ktr))
         ENDDO

C compute the density at this level for the buoyancy term in the
C vertical k.e. equation

         Dd(k2+1)=STATE1(Pd(k2+1,2),Pd(k2+1,1),i,j,k2+1,bi,bj,myThid)

C next, solve for the vertical velocity k.e. using combined eq. (4)
C and eq (5) from the paper

#ifdef ALLOW_OPPS_DEBUG
         IF ( OPPSdebugLevel.GE.debLevA ) THEN
          WRITE(msgBuf,'(A,3E12.4,I3)')
     &    'S/R OPPS_CALC: Dd,De,entr,k ',Dd(k2),De(k2),entrainrate,k2
          CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &         SQUEEZE_RIGHT , 1)
         ENDIF
#endif /* ALLOW_OPPS_DEBUG */
CML   insert Eq. (4) into Eq. (5) to get something like this for wp^2
         wsqr = wsqr - wsqr*abs(entrainrate)+ gravity*
     &        (dz1*(Dd(k2)-De(k2))/De(k2)
     &        +dz2*(Dd(k2+1)-De(k2+1))/De(k2+1))

C if negative k.e. then plume has reached max depth, get out of loop

         IF(wsqr.LE.0.0)then
          maxdepth = k2
#ifdef ALLOW_OPPS_DEBUG
          IF ( OPPSdebugLevel.GE.debLevA ) THEN
           WRITE(msgBuf,'(A,I3)')
     &     'S/R OPPS_CALC: Plume velocity went to zero at level ', k2
           CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &          SQUEEZE_RIGHT , 1)
           WRITE(msgBuf,'(A,4A14)')
     &          'S/R OPPS_CALC: ', 'wsqr', 'entrainrate',
     &          '(Dd-De)/De up', '(Dd-De)/De do'
           CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &          SQUEEZE_RIGHT , 1)
           WRITE(msgBuf,'(A,4E14.6)')
     &          'S/R OPPS_CALC: ', wsqr, entrainrate,
     &          (Dd(k2)-De(k2))/De(k2), (Dd(k2+1)-De(k2+1))/De(k2+1)
           CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &          SQUEEZE_RIGHT , 1)
          ENDIF
#endif /* ALLOW_OPPS_DEBUG */
          if(maxdepth.eq.k) goto 1000
          goto 1
         endif
         Wd(k2+1)=sqrt(wsqr)

C     compute a new radius based on the new mass flux at this grid level
C     from Eq. (4)

         radius=sqrt(newflux/(Wd(k2)*Dd(k2)))
        ELSE
         maxdepth=k2
         if(maxdepth.eq.k) goto 1000
         GOTO 1
        ENDIF
       ENDDO

C plume has reached the bottom

       MaxDepth=kMax

 1     CONTINUE

       Ad(k)=FRACTIONAL_AREA
       IC=0

C start iteration on fractional area, not used in OGCM implementation

       DO IC=1,Max_ABE_Iterations

C next compute the mass flux beteen each grid box using the entrainment

        Md(k)=Wd(k)*Ad(k)

        DO k2=k+1,maxDepth
         Md(k2)=Md(k)*PlumeEntrainment(k2)
#ifdef ALLOW_OPPS_DEBUG
         IF ( OPPSdebugLevel.GE.debLevA ) THEN
          WRITE(msgBuf,'(A,2E12.4,I3)')
     &         'S/R OPPS_CALC: Md, Wd, and  k are ',Md(k2),Wd(k2),k2
          CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &         SQUEEZE_RIGHT , 1)
         ENDIF
#endif /* ALLOW_OPPS_DEBUG */
        ENDDO

C Now move on to calculate new temperature using flux from
C Td, Sd, Wd, ta, sa, and we. Values for these variables are at
C center of grid cell, use weighted average to get boundary values

C use a timestep limited by the GCM model timestep and the maximum plume
C velocity (CFL criteria)

C calculate the weighted wd, td, and sd
        dt = dtts
        do k2=k,maxDepth-1
         IF ( Wd(K2) .NE. 0. _d 0 ) dt = min(dt,drF(k2)/Wd(k2))

C time integration will be integer number of steps to get one
C gcm time step

         ntime = nint(0.5*int(dtts/dt))
         if(ntime.eq.0) then
          ntime = 1
         endif

C make sure area weighted vertical velocities match; in other words
C make sure mass in equals mass out at the intersection of each grid
C cell. Eq. (20)

         mda(k2) = (md(k2)*drF(k2)+md(k2+1)*drF(k2+1))/
     *        (drF(k2)+drF(k2+1))

         wda(k2) = (wd(k2)*drF(k2)+wd(k2+1)*drF(k2+1))/
     *        (drF(k2)+drF(k2+1))

         DO ktr = 1, nTracerInUse
          Pda(k2,ktr) = Pd(k2,ktr)
          Paa(k2,ktr) = tracerEnv(k2+1,ktr)
         ENDDO

        enddo
        dt = min(dt,dtts)
#ifdef ALLOW_OPPS_DEBUG
        IF ( OPPSdebugLevel.GE.debLevA ) THEN
         WRITE(msgBuf,'(A,F14.4)')
     &        'S/R OPPS_CALC: time step = ', dt
         CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &        SQUEEZE_RIGHT , 1)
        ENDIF
#endif /* ALLOW_OPPS_DEBUG */
        DO ktr=1,nTracerInUse
         Pda(maxdepth,ktr) = Pd(maxdepth,ktr)
        ENDDO

        kmx = maxdepth-1
        do nn=1,ntime

C     top point

         DO ktr = 1,nTracerInUse
          tracerEnv(k,ktr) =  tracerEnv(k,ktr)-
     &        (mda(k)*(Pda(k,ktr)-Paa(k,ktr)))*dt*recip_drF(k)
         ENDDO

C now do inner points if there are any

CML         if(Maxdepth-k.gt.1) then
CML    This if statement is superfluous
CML         IF ( k .LT. Maxdepth-1 ) THEN
CML         DO k2=k+1,Maxdepth-1
CML         mda(maxDepth) = 0.
         DO k2=k+1,kmx
          k2m1 = max(k,k2-1)
          k2p1 = max(k2+1,maxDepth)

           DO ktr = 1,nTracerInUse
            tracerEnv(k2,ktr) = tracerEnv(k2,ktr) +
     &           (mda(k2m1)*(Pda(k2m1,ktr)-Paa(k2m1,ktr))
     &           -mda(k2)  *(Pda(k2,ktr)  -Paa(k2,ktr))  )
     &           *dt*recip_drF(k2)
           ENDDO
          ENDDO
CML    This if statement is superfluous
CML         ENDIF

C     bottom point

         DO ktr=1,nTracerInUse
          tracerEnv(kmx+1,ktr) =  tracerEnv(kmx+1,ktr)+
     &        mda(kmx)*(Pda(kmx,ktr)-Paa(kmx,ktr))*dt*recip_drF(kmx+1)
         ENDDO

C     set the environmental temp and salinity to equal new fields

         DO ktr=1,nTracerInUse
          DO k2=1,kmx
           paa(k2,ktr) = tracerEnv(k2+1,ktr)
          ENDDO
         ENDDO

C end loop on number of time integration steps

        enddo
       ENDDO

C     count convection event in this grid cell

       OPPSconvectCount(I,J,K) = OPPSconvectCount(I,J,K) + 1. _d 0

C     jump here if k = maxdepth or if level not unstable, go to next
C     profile point

 1000  continue

C     end  of k-loop

      ENDDO

C--   End IF (DIFFERENT_MULTIPLE)
      ENDIF

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      _RL FUNCTION STATE1( sLoc, tLoc, i, j, kRef, bi, bj, myThid )

C     !DESCRIPTION: \bv
C     *===============================================================*
C     | o SUBROUTINE STATE1
C     |   Calculates rho(S,T,p)
C     |   It is absolutely necessary to compute
C     |   the full rho and not sigma=rho-rhoConst, because
C     |   density is used as a scale factor for fluxes and velocities
C     *===============================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "DYNVARS.h"
#ifdef ALLOW_NONHYDROSTATIC
# include "NH_VARS.h"
#endif /* ALLOW_NONHYDROSTATIC */

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
      INTEGER i, j, kRef, bi, bj, myThid
      _RL tLoc, sLoc

C     !LOCAL VARIABLES:
C     == Local variables ==
      _RL rhoLoc
      _RL pLoc

CMLC     estimate pressure from depth at cell centers
CML      mtoSI = gravity*rhoConst
CML      pLoc = ABS(rC(kRef))*mtoSI

      IF ( usingZCoords ) THEN
C     in Z coordinates the pressure is rho0 * (hydrostatic) Potential
#ifdef ALLOW_NONHYDROSTATIC
       IF ( selectP_inEOS_Zc.EQ.3 ) THEN
        pLoc = rhoConst*( totPhiHyd(i,j,kRef,bi,bj)
     &                  + phi_nh(i,j,kRef,bi,bj)
     &                  + phiRef(2*kRef)
     &                  )*maskC(i,j,kRef,bi,bj)
       ELSEIF ( selectP_inEOS_Zc.EQ.2 ) THEN
#else /* ALLOW_NONHYDROSTATIC */
       IF     ( selectP_inEOS_Zc.EQ.2 ) THEN
#endif /* ALLOW_NONHYDROSTATIC */
C----------
C     NOTE: For now, totPhiHyd only contains the Potential anomaly
C           since PhiRef has not (yet) been added in S/R DIAGS_PHI_HYD
C----------
        pLoc = rhoConst*( totPhiHyd(i,j,kRef,bi,bj)
     &                  + phiRef(2*kRef)
     &                  )*maskC(i,j,kRef,bi,bj)
c      ELSEIF ( selectP_inEOS_Zc.EQ.1 ) THEN
C note: for the case selectP_inEOS_Zc=0, also use pRef4EOS (set to
C       rhoConst*phiRef(2*k) ) to reproduce same previous machine truncation
       ELSEIF ( selectP_inEOS_Zc.LE.1 ) THEN
        pLoc = pRef4EOS(kRef)*maskC(i,j,kRef,bi,bj)
       ELSE
        pLoc = rhoConst*phiRef(2*kRef)*maskC(i,j,kRef,bi,bj)
       ENDIF
      ELSEIF ( usingPCoords ) THEN
C     in P coordinates the pressure is just the coordinate of the tracer point
       pLoc = rC(kRef)* maskC(i,j,kRef,bi,bj)
      ENDIF

      CALL FIND_RHO_SCALAR( tLoc, sLoc, pLoc, rhoLoc, myThid )
      STATE1 = rhoLoc

#endif /* ALLOW_OPPS */
      RETURN
      END

#ifdef OPPS_ORGCODE
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C Listed below is the subroutine for use in parallel 3-d circulation code.
C It has been used in the parallel semtner-chervin code and is now being used
C In the POP code.  The subroutine is called nlopps (long story to explain why).

C I've attached the version of lopps that we've been using in the simulations.
C There is one common block that is different from the standard model commons
C (countc) and it is not needed if the array convadj is not used.  The routine
C does need "kmp" which is why the boundc common is included. For massively
C parallel codes (like POP) we think this will work well when converted from a
C "slab" (i=is,ie) to a column, which just means removing the "do i=is,ie" loop.
C There are differences between this
C code and the 1-d code and the earlier scheme implemented in 3-d models. These
C differences are described below.

      subroutine nlopps(j,is,ie,ta,sa,gcmdz)

      parameter (imt = 361 , jmt = 301 , km = 30 )

C     Nlopps:   E. Skyllingstad and T. Paluszkiewicz

C     Version: December 11, 1996

C     Nlopps:  This version of lopps is significantly different from
C     the original code developed by R. Romea and T. Paluskiewicz.  The
C     code uses a flux constraint to control the change in T and S at
C     each grid level.  First, a plume profile of T,S, and W are
C     determined using the standard plume model, but with a detraining
C     mass instead of entraining.  Thus, the T and S plume
C     characteristics still change, but the plume contracts in size
C     rather than expanding ala classical entraining plumes.  This
C     is heuristically more in line with large eddy simulation results.
C     At each grid level, the convergence of plume velocity determines
C     the flux of T and S, which is conserved by using an upstream
C     advection.  The vertical velocity is balanced so that the area
C     weighted upward velocity equals the area weighted downdraft
C     velocity, ensuring mass conservation. The present implementation
C     adjusts the plume for a time period equal to the time for 1/2 of
C     the mass of the fastest moving level to move downward.  As a
C     consequence, the model does not completely adjust the profile at
C     each model time step, but provides a smooth adjustment over time.

c      include "params.h"
c      include "plume_fast_inc.h"
c      include "plume_fast.h"
c #include "loppsd.h"

      real ta(imt,km),sa(imt,km),gcmdz(km),dz(km)
      real pdensity,wsqr,oldflux,newflux,entrainrate,adtemp
      REAL Del,D,dza1,dza2,kd,kd1,Smix,Thmix,PlumeS,PlumeT,PlumeD

      INTEGER i,j,k
Clfh
      integer is,ie,k2
Clfh
      REAL D1,D2,state1,Density
      REAL dz1,dz2
      REAL radius,StartingFlux
      real ttemp(km),stemp(km),taa(km),saa(km)
      real wda(km),tda(km),sda(km),mda(km)
      real dtts,dt,sumo,sumn
      integer ntime,nn,kmx,ic

      LOGICAL debug,done
      INTEGER MAX_ABE_ITERATIONS
      PARAMETER(MAX_ABE_ITERATIONS=1)
      REAL PlumeRadius
      REAL STABILITY_THRESHOLD
      REAL FRACTIONAL_AREA
      REAL MAX_FRACTIONAL_AREA
      REAL VERTICAL_VELOCITY
      REAL ENTRAINMENT_RATE
      REAL e2
      PARAMETER ( PlumeRadius          =  100.D0   )
      PARAMETER ( STABILITY_THRESHOLD  =  -1.E-4   )
      PARAMETER ( FRACTIONAL_AREA      =  .1E0    )
      PARAMETER ( MAX_FRACTIONAL_AREA  =  .8E0     )
      PARAMETER ( VERTICAL_VELOCITY    =  .02E0   )
      PARAMETER ( ENTRAINMENT_RATE     =  -.05E0     )
      PARAMETER ( e2    =   2.E0*ENTRAINMENT_RATE  )
      ! Arrays.
      REAL Ad(km),Sd(km),Td(km),Wd(km),Dd(km),Md(km)
      REAL Se(km),Te(km),We(km),De(km)
      REAL PlumeEntrainment(km)
      REAL GridThickness(km)

C input kmp through a common block

      common / boundc / wsx(imt,jmt),wsy(imt,jmt),hfs(imt,jmt),
     1                  ple(imt,jmt),kmp(imt,jmt),kmq(imt,jmt)
cwmseas
     &                 ,wsx1(imt,jmt),wsy1(imt,jmt)
     1                 ,wsx2(imt,jmt),wsy2(imt,jmt)

C input the variables through a common

      logical problem
      common /countc/ convadj(imt,jmt,km),ics,depth(km),problem

C-----may want to setup an option to get this only on first call
C     otherwise it is repetive
C     griddz is initialize by call to setupgrid

        dtts = 2400

        do k=1,km
          dz(k) = 0.01*gcmdz(k)
        enddo

        do k=1,km
           GridThickness(k) = dz(k)
        enddo

C modified to loop over slab

      DO i=is,ie

        numgridpoints=kmp(i,j)

C  go to next column if only 1 grid point or on land

        if(numgridpoints.le.1) goto 1100

C loop over depth

      debug = .false.

C first save copy of initial profile

      DO k=1,NumGridPoints
         stemp(k)=sa(i,k)
         ttemp(k)=ta(i,k)

C do a check of t and s range, if out of bounds set flag

         if(problem) then
            write(0,*)"Code in trouble before this nlopps call"
            return
         endif

         if(sa(i,k).gt.40..or.ta(i,k).lt.-4.0) then
            problem = .true.
            write(0,*)"t out of range at j ",j
            debug = .true.
            return
         endif
      ENDDO

      if(debug) then
        write(*,*)"T and S Profile at  ",i,j
        write(*,*)(ta(i,k),sa(i,k),k=1,NumGridPoints)
      endif

      DO k=1,NumGridPoints-1

C initialize the plume T,S,density, and w velocity

          Sd(k)=stemp(k)
          Td(k)=ttemp(k)
          Dd(k)=state1(stemp(k),ttemp(k),k)
          De(k)=Dd(k)
c          Wd(k)=VERTICAL_VELOCITY

C guess at initial top grid cell vertical velocity

          Wd(k) = 0.03

C these estimates of initial plume velocity based on plume size and
C top grid cell water mass

c          Wd(k) = 0.5*dz(k)/(dtts*FRACTIONAL_AREA)
c          Wd(k) = 0.5*dz(k)/dtts

          wsqr=Wd(k)*Wd(k)
          PlumeEntrainment(k) = 0.0

          if(debug) write(0,*) 'Doing old lowerparcel'
          radius=PlumeRadius
          StartingFlux=radius*radius*Wd(k)*Dd(k)
          oldflux=StartingFlux

          dz2=GridThickness(k)
          DO k2=k,NumGridPoints-1
            D1=state1(Sd(k2),Td(k2),k2+1)
            D2=state1(stemp(k2+1),ttemp(k2+1),k2+1)
            De(k2+1)=D2

C To start downward, parcel has to initially be heavier than environment
C but after it has started moving, we continue plume until plume tke or
C flux goes negative

            IF (D2-D1 .LT. STABILITY_THRESHOLD.or.k2.ne.k) THEN
                 dz1=dz2
                 dz2=GridThickness(k2+1)

C define mass flux according to eq. 4 from paper

                 newflux=oldflux+e2*radius*Wd(k2)*Dd(k2)*0.50*
     .              (dz1+dz2)

                 PlumeEntrainment(k2+1) = newflux/StartingFlux

                 IF(newflux.LT.0.0) then
                     if(debug) then
                      write(0,*)"Plume entrained to zero at ",k2
                     endif
                     maxdepth = k2
                     if(maxdepth.eq.k) goto 1000
                     goto 1
                 endif

C entrainment rate is basically a scaled mass flux dM/M

                 entrainrate = (newflux - oldflux)/newflux
                 oldflux = newflux

C mix var(s) are the average environmental values over the two grid levels

                 smix=(dz1*stemp(k2)+dz2*stemp(k2+1))/(dz1+dz2)
                 thmix=(dz1*ttemp(k2)+dz2*ttemp(k2+1))/(dz1+dz2)

C first compute the new salinity and temperature for this level
C using equations 3.6 and 3.7 from the paper

                  sd(k2+1)=sd(k2) - entrainrate*(smix - sd(k2))
                  td(k2+1)=td(k2) - entrainrate*(thmix - td(k2))

C compute the density at this level for the buoyancy term in the
C vertical k.e. equation

                 Dd(k2+1)=state1(Sd(k2+1),Td(k2+1),k2+1)

C next, solve for the vertical velocity k.e. using combined eq. 4
C and eq 5 from the paper

                 if(debug) then
                  write(0,*)"Dd,De,entr,k ",Dd(k2),De(k2),entrainrate,k2
                 endif

                 wsqr = wsqr - wsqr*abs(entrainrate)+ 9.81*
     .             (dz1*(Dd(k2)-De(k2))/De(k2)
     .             +dz2*(Dd(k2+1)-De(k2+1))/De(k2+1))

C if negative k.e. then plume has reached max depth, get out of loop

                 IF(wsqr.LT.0.0)then
                     maxdepth = k2
                     if(debug) then
                      write(0,*)"Plume velocity went to zero at ",k2
                     endif
                     if(maxdepth.eq.k) goto 1000
                     goto 1
                 endif
                 Wd(k2+1)=sqrt(wsqr)

C compute a new radius based on the new mass flux at this grid level

                 radius=sqrt(newflux/(Wd(k2)*Dd(k2)))
              ELSE
                 maxdepth=k2
                 if(maxdepth.eq.k) goto 1000
                 GOTO 1
              ENDIF
          ENDDO

C plume has reached the bottom

          MaxDepth=NumGridPoints

1         continue

          Ad(k)=FRACTIONAL_AREA
          IC=0

C start iteration on fractional area, not used in OGCM implementation

          DO IC=1,Max_ABE_Iterations

C next compute the mass flux beteen each grid box using the entrainment

 92          continue
             Md(k)=Wd(k)*Ad(k)

             DO k2=k+1,MaxDepth
               Md(k2)=Md(k)*PlumeEntrainment(k2)
               if(debug) then
                 write(0,*)"Md, Wd, and  k are ",Md(k2),Wd(k2),k2
               endif
             ENDDO

C Now move on to calculate new temperature using flux from
C Td, Sd, Wd, ta, sa, and we. Values for these variables are at
C center of grid cell, use weighted average to get boundary values

C use a timestep limited by the GCM model timestep and the maximum plume
C velocity (CFL criteria)

C calculate the weighted wd, td, and sd

             dt = dtts
             do k2=k,maxdepth-1
                dt = min(dt,dz(k2)/wd(k2))

C time integration will be integer number of steps to get one
C gcm time step

                ntime = nint(0.5*int(dtts/dt))
                if(ntime.eq.0) then
                   ntime = 1
                endif

C make sure area weighted vertical velocities match; in other words
C make sure mass in equals mass out at the intersection of each grid
C cell.

                mda(k2) = (md(k2)*dz(k2)+md(k2+1)*dz(k2+1))/
     *                    (dz(k2)+dz(k2+1))

                wda(k2) = (wd(k2)*dz(k2)+wd(k2+1)*dz(k2+1))/
     *                    (dz(k2)+dz(k2+1))

                tda(k2) = td(k2)
                sda(k2) = sd(k2)

                taa(k2) = ttemp(k2+1)
                saa(k2) = stemp(k2+1)

             enddo
             dt = min(dt,dtts)
             if(debug) then
               write(0,*)"Time step is ", dt
             endif
             tda(maxdepth) = td(maxdepth)
             sda(maxdepth) = sd(maxdepth)

C do top and bottom points first

             kmx = maxdepth-1
             do nn=1,ntime

               ttemp(k) =  ttemp(k)-
     *                  (mda(k)*(tda(k)-taa(k)))*dt*recip_drF(k)

               stemp(k) =  stemp(k)-
     *                  (mda(k)*(sda(k)-saa(k)))*dt*recip_drF(k)

C now do inner points if there are any

               if(Maxdepth-k.gt.1) then
                 do k2=k+1,Maxdepth-1

                   ttemp(k2) = ttemp(k2) +
     *              (mda(k2-1)*(tda(k2-1)-taa(k2-1))-
     *              mda(k2)*(tda(k2)-taa(k2)))
     *              *dt*recip_drF(k2)

                  stemp(k2) = stemp(k2) +
     *              (mda(k2-1)*(sda(k2-1)-saa(k2-1))-
     *              mda(k2)*(sda(k2)-saa(k2)))
     *              *dt*recip_drF(k2)

                 enddo
               endif
               ttemp(kmx+1) =  ttemp(kmx+1)+
     *                  (mda(kmx)*(tda(kmx)-taa(kmx)))*
     *                  dt*recip_drF(kmx+1)

               stemp(kmx+1) =  stemp(kmx+1)+
     *                  (mda(kmx)*(sda(kmx)-saa(kmx)))*
     *                  dt*recip_drF(kmx+1)

C set the environmental temp and salinity to equal new fields

                do k2=1,maxdepth-1
                  taa(k2) = ttemp(k2+1)
                  saa(k2) = stemp(k2+1)
                enddo

C end loop on number of time integration steps

             enddo
          ENDDO
999       continue

C assume that it converged, so update the ta and sa with new fields

c          if(i.gt.180.and.j.gt.200.and.i.lt.240) then
c            write(*,*)"Converged ",i,j,k,maxdepth,ttemp(k+1),ta(i,k+1)
c          endif
          do k2=k,maxdepth
            convadj(i,j,k2) = convadj(i,j,k2) + (ttemp(k2)-
     *          ta(i,k2))
            sa(i,k2) = stemp(k2)
            ta(i,k2) = ttemp(k2)
c          if(i.gt.180.and.j.gt.200.and.i.lt.240) then
c            write(*,*)"convadj ",convadj(i,j,k2)
c          endif

C see if nlopps messed up

            if(sa(i,k).gt.40..or.ta(i,k).lt.-4.0) then
               problem = .true.
               write(0,*)"t out of range at j after adjust",j
               debug = .true.
            endif

          enddo

C jump here if k = maxdepth or if level not unstable, go to next
C profile point

1000      continue

C end loop on k, move on to next possible plume

      ENDDO
1100  continue

C i loop

      ENDDO
      END

#endif /* OPPS_ORGCODE */

!=======================================================================
      subroutine couprecv_r4tiles( component, dataname, Nx, Ny, arr )
      implicit none
! Arguments
      character*(*) component
      character*(*) dataname
      integer Nx,Ny
      real*4 arr(Nx,Ny)
! Predefined constants/arrays
#include "CPLR_SIG.h"
! MPI variables
#include "mpif.h"
      integer count,dtype,rank,tag,comm,ierr
      integer stat(MPI_STATUS_SIZE)
! Functions
      integer mitcplr_match_comp
      integer generate_tag
! Local
      integer compind,numprocs
      integer i,j,ij,n,bibj
      integer Ni,Io,Nj,Jo
      character*(MAXLEN_COMP_NAME) recvdname
!     ------------------------------------------------------------------

! Establish who I am communicating with
      compind=mitcplr_match_comp( component )
      if (compind.le.0) stop 'couprecv_r4tiles: Bad component id'
      comm=MPI_COMM_compcplr( compind )
      numprocs=num_component_procs(compind)
      if (numprocs.lt.1) then
       write(LogUnit,*) 'couprecv_r4tiles: compind = ',compind
       stop 'couprecv_r4tiles: numprocs < 1'
      endif
      if (VERB)
     &  write(LogUnit,*) 'couprecv_r4tiles: ',component_Name(compind)
      if (VERB)
     &  write(LogUnit,*) 'couprecv_r4tiles: dataname=',dataname

! Foreach component process
      do n=1,numprocs

! Foreach tile within process
       do bibj=1,component_num_tiles(n,compind)

! Receive message
       count=HEADER_SIZE+MAX_R4_BUFLEN
       dtype=MPI_REAL
       tag=generate_tag(103,bibj,dataname)
       rank=rank_component_procs(n,compind)

       if (VERB) then
        write(LogUnit,*)
     &    'couprecv_r4tiles: calling MPI_Recv rank=',rank,
     &    ' proc=',n,'/',numprocs,' tile=',bibj
        call flush(LogUnit)
       endif
       call MPI_Recv(r4buf, count, dtype, rank, tag, comm, stat, ierr)
       if (VERB) then
        write(LogUnit,*) 'couprecv_r4tiles: returned ierr=',ierr
        call flush(LogUnit)
       endif

       if (ierr.ne.0) then
        write(LogUnit,*) 'couprecv_r4tiles: rank(W,G)=',
     &            my_rank_in_world,my_rank_in_global,
     &            ' ierr=',ierr
        stop 'couprecv_r4tiles: MPI_Recv failed'
       endif

! Extract header
       Io=int(0.5+r4buf(1))
       Ni=int(0.5+r4buf(2))
       Jo=int(0.5+r4buf(3))
       Nj=int(0.5+r4buf(4))

       if (Io+Ni-1.gt.Nx .or. Io.lt.1) then
        write(LogUnit,*) 'couprecv_r4tiles: Io,Ni=',Io,Ni
        stop 'couprecv_r4tiles: Incompatible header/target array'
       endif
       if (Jo+Nj-1.gt.Ny .or. Jo.lt.1) then
        write(LogUnit,*) 'couprecv_r4tiles: Jo,Nj=',Jo,Nj
        stop 'couprecv_r4tiles: Incompatible header/target array'
       endif
       if (Io.ne.component_tile_i0(bibj,n,compind))
     &    stop 'couprecv_r4tiles: Io != component_tile_i0'
       if (Jo.ne.component_tile_j0(bibj,n,compind))
     &    stop 'couprecv_r4tiles: Jo != component_tile_j0'
       if (Ni.ne.component_tile_nx(bibj,n,compind))
     &    stop 'couprecv_r4tiles: Ni != component_tile_nx'
       if (Nj.ne.component_tile_ny(bibj,n,compind))
     &    stop 'couprecv_r4tiles: Nj != component_tile_ny'

       call mitcplr_real2char( r4buf(9), recvdname )
       if (recvdname .ne. dataname) then
        write(LogUnit,*) 'couprecv_r4tiles: recvdname = ',recvdname
        write(LogUnit,*) 'couprecv_r4tiles:  dataname = ',dataname
        stop 'couprecv_r4tiles: recvdname != dataname'
       endif

! Extract data
       do j=1,Nj
        do i=1,Ni
         ij=HEADER_SIZE+i+Ni*(j-1)
         arr(Io+i-1,Jo+j-1)=r4buf(ij)
        enddo
       enddo

       enddo ! bibj

      enddo ! n

!     ------------------------------------------------------------------
      return
      end
!=======================================================================

#include "MOM_FLUXFORM_OPTIONS.h"

CBOP
C !ROUTINE: MOM_V_CORIOLIS

C !INTERFACE: ==========================================================
      SUBROUTINE MOM_V_CORIOLIS(
     I        bi, bj, k, uFld,
     U        vCoriolisTerm,
     I        myThid )

C !DESCRIPTION:
C Calculates the horizontal Coriolis term in the meridional equation:
C \begin{equation*}
C -\overline{f}^j \overline{u}^{ij}
C \end{equation*}

C !USES: ===============================================================
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "SURFACE.h"

C !INPUT PARAMETERS: ===================================================
C  bi, bj               :: tile indices
C  k                    :: vertical level
C  uFld                 :: zonal flow
C  myThid               :: thread number
      INTEGER bi, bj, k
      _RL uFld(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER myThid

C !OUTPUT PARAMETERS: ==================================================
C  vCoriolisTerm        :: Coriolis term
      _RL vCoriolisTerm(1-OLx:sNx+OLx,1-OLy:sNy+OLy)

C !LOCAL VARIABLES: ====================================================
C  i,j                  :: loop indices
      INTEGER i, j
CEOP

      IF ( selectCoriScheme.LE.1 ) THEN
C-    Original discretization
       DO j=1-OLy+1,sNy+OLy
        DO i=1-OLx,sNx+OLx-1
         vCoriolisTerm(i,j) = -halfRL
     &   *( _fCori(i, j ,bi,bj) + _fCori(i,j-1,bi,bj) )
     &   *0.25 _d 0*( uFld(i, j ) + uFld(i+1, j )
     &              + uFld(i,j-1) + uFld(i+1,j-1)
     &              )
        ENDDO
       ENDDO
      ELSEIF ( selectCoriScheme.LE.3 ) THEN
C-    Energy conserving discretization
       DO j=1-OLy+1,sNy+OLy
        DO i=1-OLx,sNx+OLx-1
         vCoriolisTerm(i,j) = -halfRL
     &        *( _fCori(i, j ,bi,bj)
     &          *halfRL*( uFld( i , j ) + uFld(i+1, j ) )
     &         + _fCori(i,j-1,bi,bj)
     &          *halfRL*( uFld( i ,j-1) + uFld(i+1,j-1) ) )
        ENDDO
       ENDDO
      ELSE
C-    Using averaged transport:
       DO j=1-OLy+1,sNy+OLy
        DO i=1-OLx,sNx+OLx-1
         vCoriolisTerm(i,j) = -halfRL
     &   *( _fCori(i, j ,bi,bj) + _fCori(i,j-1,bi,bj) )
     &   *( uFld( i , j )*dyG( i , j ,bi,bj)*hFacW( i , j ,k,bi,bj)
     &    + uFld(i+1, j )*dyG(i+1, j ,bi,bj)*hFacW(i+1, j ,k,bi,bj)
     &    + uFld( i ,j-1)*dyG( i ,j-1,bi,bj)*hFacW( i ,j-1,k,bi,bj)
     &    + uFld(i+1,j-1)*dyG(i+1,j-1,bi,bj)*hFacW(i+1,j-1,k,bi,bj)
     &    )*0.25 _d 0*recip_dyC(i,j,bi,bj)*recip_hFacS(i,j,k,bi,bj)
        ENDDO
       ENDDO
      ENDIF

      IF ( selectCoriScheme.EQ.1 .OR. selectCoriScheme.EQ.3 ) THEN
C-    Scale term so that only "wet" points are used
C     Due to: Jamart and Ozer, 1986, JGR 91 (C9), 10,621-10,631
C         "Numerical Boundary Layers and Spurious Residual Flows"
       DO j=1-OLy+1,sNy+OLy
        DO i=1-OLx,sNx+OLx-1
         vCoriolisTerm(i,j) = vCoriolisTerm(i,j)
     &   *4. _d 0/MAX( oneRS,
     &                 maskW( i , j ,k,bi,bj)+maskW(i+1, j ,k,bi,bj)
     &                +maskW( i ,j-1,k,bi,bj)+maskW(i+1,j-1,k,bi,bj) )
        ENDDO
       ENDDO
      ENDIF

      RETURN
      END

#include "SHELFICE_OPTIONS.h"

CBOP
C     !ROUTINE: SHELFICE_INIT_DEPTHS
C     !INTERFACE:
      SUBROUTINE SHELFICE_INIT_DEPTHS(
     U                    rLowC, rSurfC,
     I                    myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE SHELFICE_INIT_DEPTHS
C     | o Modify ocean upper boundary position according to
C     |   ice-shelf topography
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#ifdef ALLOW_SHELFICE
# include "SHELFICE.h"
#endif /* ALLOW_SHELFICE */

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     rLowC     :: base of fluid column in r_unit at grid-cell center
C     rSurfC    :: surface reference position (r_unit) at grid-cell center
C     myThid    :: my Thread Id number
      _RS rLowC  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RS rSurfC (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      INTEGER myThid

#ifdef ALLOW_SHELFICE
C     !LOCAL VARIABLES:
C     == Local variables ==
C     bi, bj    :: tile indices
C     i, j      :: Loop counters
      INTEGER bi, bj
      INTEGER i, j
CEOP

C--   Initialize R_shelfIce
      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          R_shelfIce(i,j,bi,bj) = 0. _d 0
         ENDDO
        ENDDO
       ENDDO
      ENDDO

      IF ( SHELFICEtopoFile .NE. ' ' ) THEN
       _BARRIER
C-    Read the shelfIce draught using the mid-level I/O pacakage read_write_rec
C     The 0 is the "iteration" argument. The 1 is the record number.
       CALL READ_REC_XY_RS( SHELFICEtopoFile, R_shelfIce,
     &                      1, 0, myThid )
C-    Read the shelfIce draught using the mid-level I/O pacakage read_write_fld
C     The 0 is the "iteration" argument. The ' ' is an empty suffix
C      CALL READ_FLD_XY_RS( SHELFICEtopoFile, ' ', R_shelfIce,
C    &                      0, myThid )
C-     end setup R_shelfIce in the interior
      ENDIF

#ifdef ALLOW_SHELFICE_REMESHING
      IF ( SHELFICEremeshFrequency.GT.zeroRL .AND.
     &     ( nIter0.NE.0 .OR. startTime.NE.baseTime
     &                   .OR. pickupSuff.NE.' ') ) THEN
        CALL SHELFICE_READ_PICKUP( 0, nIter0, myThid )
      ENDIF
#endif /* ALLOW_SHELFICE_REMESHING */

C- fill in the overlap (+ BARRIER):
      _EXCH_XY_RS( R_shelfIce, myThid )

C--   Modify ocean upper boundary position according to ice-shelf topography
      IF ( usingZCoords ) THEN
        DO bj=myByLo(myThid), myByHi(myThid)
         DO bi=myBxLo(myThid), myBxHi(myThid)
          DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
            rSurfC(i,j,bi,bj) =
     &        MIN( rSurfC(i,j,bi,bj), R_shelfIce(i,j,bi,bj) )
           ENDDO
          ENDDO
         ENDDO
        ENDDO
      ELSE
        STOP 'SHELFICE_INIT_DEPTHS: Missing code for P-coords'
      ENDIF

#endif /* ALLOW_SHELFICE */

      RETURN
      END

#include "MOM_COMMON_OPTIONS.h"

CBOP
C !ROUTINE: MOM_VISC_QGL_LIMIT

C !INTERFACE: ==========================================================
      SUBROUTINE MOM_VISC_QGL_LIMIT(
     I                           bi, bj, k,
     O                           stretching,
     I                           Nsquare,
     I                           uFld, vFld, vort3,
     I                           myTime, myIter, myThid )

C     !DESCRIPTION:
C     *==========================================================*
C     | SUBROUTINE MOM_VISC_QGL_LIMIT
C     | Limit the contribution of the vortex stretching term.
C     | When the flow is unstratified, the algorithm tries to
C     | divide by zero. This subroutine ensures that the result
C     | remains finite.
C     *==========================================================*

C !USES: ===============================================================
      IMPLICIT NONE

C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
c#include "DYNVARS.h"
c#include "MOM_VISC.h"

C !INPUT PARAMETERS: ===================================================
C  bi,bj                :: tile indices
C  k                    :: vertical level
C  Nsquare              :: buoyancy frequency
C  uFld                 :: U velocity (east flow on spherical grid)
C  vFld                 :: V velocity (north flow on spherical grid)
C  vort3                :: Relative vorticity
C  myTime               :: current time of simulation ( s )
C  myIter               :: current iteration number of simulation
C  myThid               :: my Thread Id number
      INTEGER bi,bj,k
      _RL Nsquare(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL uFld(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL vFld(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL vort3(1-OLx:sNx+OLx,1-OLy:sNy+OLy)

      _RL     myTime
      INTEGER myIter
      INTEGER myThid

C !OUTPUT PARAMETERS: ==================================================
C  stretching           :: vortex stretching term (to be limited)
      _RL stretching(1-OLx:sNx+OLx,1-OLy:sNy+OLy)

#ifdef ALLOW_LEITH_QG

C !LOCAL VARIABLES: ====================================================
      INTEGER i,j
      _RL U_scale_sq(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL Ro_g_sq(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
C      _RL Bu_g(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL Fr_g_sq(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL stretching_hold(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL QGL_lim_epsil
      _RL vort3C

CEOP

C Initialise local variables
      DO j=1-OLy,sNy+OLy
       DO i=1-OLx,sNx+OLx
C       square of the velocity scale
        U_scale_sq(i,j)         = 0. _d 0
C       square of the gridscale Rossby number
        Ro_g_sq(i,j)           = 0. _d 0
C       Gridscale Burger number
C        Bu_g(i,j)            = 0. _d 0
C       Square of the gridscale Froude number
        Fr_g_sq(i,j)            = 0. _d 0
        stretching_hold(i,j) = 0. _d 0
       ENDDO
      ENDDO

      QGL_lim_epsil = 1. _d -24

C Put a cap on the stretching term.

       DO j=2-OLy,sNy+OLy-1
        DO I=2-OLx,sNx+OLx-1
          U_scale_sq(i,j) = 0.5* (
     &             ( uFld(i,j)*uFld(i,j)
     &              + uFld(i+1,j)*uFld(i+1,j) )
     &           + ( vFld(i,j)*vFld(i,j)
     &              + vFld(i,j+1)*vFld(i,j+1) )
     &                             )

C        Grid scale Rossby number, squared: U^2 / (fL)^2
          Ro_g_sq(i,j) = U_scale_sq(i,j) * recip_rA(i,j,bi,bj) /
     &                  MAX(QGL_lim_epsil, fCori(i,j,bi,bj)**2)
C        Grid scale Burger number: N^2 H^2 / (f^2 L^2)
C         Bu_g(i,j) = Nsquare(i,j) * drf(k)**2 * recip_rA(i,j,bi,bj) /
C     &                 (fCori(i,j,bi,bj)**2 * PI)
C        Grid scale Froude number, squared: U^2 pi^2 /(N^2 H)^2
C          Include a small number to prevent division by zero
          Fr_g_sq(i,j) = U_scale_sq(i,j) * PI * PI /
     &                 (MAX((Nsquare(i,j) * drF(k))**2,
     &                      QGL_lim_epsil))

C     Make the scheme gracefully transition to something else
C     as stratification goes to zero
C
C        Implement eqn. (55) from Bachman et al. (2017) JGR-Oceans
C         stretching_hold(i,j) = MIN( ABS(stretching(i,j)),
C     &    ABS(vort3(i,j) / MAX(Bu_g(i,j),Ro_g_sq(i,j)) ) )

C        Implement eqn. (56) from Bachman et al. (2017) JGR-Oceans
C          This limiter goes to 2D Leith as stratification -> 0
          vort3C = halfRL*halfRL*(vort3(i,j) + vort3(i+1,j)
     &                            + vort3(i,j+1) + vort3(i+1,j+1))

          stretching_hold(i,j) = min( ABS(stretching(i,j)),
     &                  ABS(vort3C * Fr_g_sq(i,j) /
     &                       (Ro_g_sq(i,j) + Fr_g_sq(i,j)**2
     &                         + QGL_lim_epsil) )
     &                               )

          stretching(i,j) = SIGN(stretching_hold(i,j), stretching(i,j))

        ENDDO
       ENDDO

#endif /* ALLOW_LEITH_QG */

      RETURN
      END

#include "ICEFRONT_OPTIONS.h"

CBOP
      SUBROUTINE ICEFRONT_INIT_VARIA( myThid )
C     *============================================================*
C     | SUBROUTINE ICEFRONT_INIT_VARIA                             |
C     | o Routine to initialize ICEFRONT variables.                |
C     *============================================================*
C     | Initialize ICEFRONT parameters and variables.              |
C     *============================================================*
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "ICEFRONT.h"

C     === Routine arguments ===
C     myThid -  Number of this instance of ICEFRONT_INIT_VARIA
      INTEGER myThid
CEndOfInterface

#ifdef ALLOW_ICEFRONT
C     === Local variables ===
C     I,J,K,bi,bj - Loop counters
      INTEGER I, J, K, bi, bj
CEOP

      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
        DO K = 1, Nr
         DO J = 1, sNy
          DO I = 1, sNx
           icefront_TendT (i,j,k,bi,bj) = 0. _d 0
           icefront_TendS (i,j,k,bi,bj) = 0. _d 0
          ENDDO
         ENDDO
        ENDDO
       ENDDO
      ENDDO

#endif /* ALLOW_ICEFRONT */

      RETURN
      END

#include "PACKAGES_CONFIG.h"
#include "CPP_OPTIONS.h"

CBOP
C     !ROUTINE: INI_CG2D
C     !INTERFACE:
      SUBROUTINE INI_CG2D( myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE INI_CG2D
C     | o Initialise 2d conjugate gradient solver operators.
C     *==========================================================*
C     | These arrays are purely a function of the basin geom.
C     | We set then here once and them use then repeatedly.
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "SURFACE.h"
#include "CG2D.h"

C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
C     myThid - Thread no. that called this routine.
      INTEGER myThid

C     !LOCAL VARIABLES:
C     === Local variables ===
C     bi,bj  :: tile indices
C     i,j,k  :: Loop counters
C     faceArea :: Temporary used to hold cell face areas.
C     myNorm   :: Work variable used in calculating normalisation factor
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      INTEGER bi, bj
      INTEGER i, j, k, ks
      _RL     faceArea
      _RL     cg2dTolerance
      _RS     myNorm
      _RS     aC, aCw, aCs
CEOP

C--   Initialize arrays in common blocs (CG2D.h) ; not really necessary
C     but safer when EXCH do not fill all the overlap regions.
      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          aW2d(i,j,bi,bj) = 0. _d 0
          aS2d(i,j,bi,bj) = 0. _d 0
          aC2d(i,j,bi,bj) = 0. _d 0
          pW(i,j,bi,bj) = 0. _d 0
          pS(i,j,bi,bj) = 0. _d 0
          pC(i,j,bi,bj) = 0. _d 0
         ENDDO
        ENDDO
       ENDDO
      ENDDO

C--   Init. scalars
      _BEGIN_MASTER(myThid)
      cg2dNorm = 0. _d 0
      cg2dNormaliseRHS = .FALSE.
      cg2dTolerance_sq = 0. _d 0
      _END_MASTER(myThid)

C--   Initialise laplace operator
C     aW2d: integral in Z Ax/dX
C     aS2d: integral in Z Ay/dY
      myNorm = 0. _d 0
      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        DO j=1,sNy
         DO i=1,sNx
          aW2d(i,j,bi,bj) = 0. _d 0
          aS2d(i,j,bi,bj) = 0. _d 0
         ENDDO
        ENDDO
        DO k=1,Nr
         DO j=1,sNy
          DO i=1,sNx
C  deep-model: *deepFacC (faceArea), /deepFacC (recip_dx,y): => no net effect
           faceArea = _dyG(i,j,bi,bj)*drF(k)
     &               *_hFacW(i,j,k,bi,bj)
           aW2d(i,j,bi,bj) = aW2d(i,j,bi,bj)
     &              + implicSurfPress*implicDiv2DFlow
     &               *faceArea*recip_dxC(i,j,bi,bj)
           faceArea = _dxG(i,j,bi,bj)*drF(k)
     &               *_hFacS(i,j,k,bi,bj)
           aS2d(i,j,bi,bj) = aS2d(i,j,bi,bj)
     &              + implicSurfPress*implicDiv2DFlow
     &               *faceArea*recip_dyC(i,j,bi,bj)
          ENDDO
         ENDDO
        ENDDO
        DO j=1,sNy
         DO i=1,sNx
#ifdef ALLOW_OBCS
           aW2d(i,j,bi,bj) = aW2d(i,j,bi,bj)
     &                   *maskInC(i,j,bi,bj)*maskInC(i-1,j,bi,bj)
           aS2d(i,j,bi,bj) = aS2d(i,j,bi,bj)
     &                   *maskInC(i,j,bi,bj)*maskInC(i,j-1,bi,bj)
#endif /* ALLOW_OBCS */
           myNorm = MAX(ABS(aW2d(i,j,bi,bj)),myNorm)
           myNorm = MAX(ABS(aS2d(i,j,bi,bj)),myNorm)
         ENDDO
        ENDDO
       ENDDO
      ENDDO
      _GLOBAL_MAX_RS( myNorm, myThid )
      IF ( myNorm .NE. zeroRS ) THEN
       myNorm = 1. _d 0/myNorm
      ELSE
       myNorm = 1. _d 0
      ENDIF
      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        DO j=1,sNy
         DO i=1,sNx
          aW2d(i,j,bi,bj) = aW2d(i,j,bi,bj)*myNorm
          aS2d(i,j,bi,bj) = aS2d(i,j,bi,bj)*myNorm
         ENDDO
        ENDDO
       ENDDO
      ENDDO

C--   Update overlap regions
CcnhDebugStarts
C     CALL PLOT_FIELD_XYRS( aW2d, 'AW2D INI_CG2D.1' , 1, myThid )
C     CALL PLOT_FIELD_XYRS( aS2d, 'AS2D INI_CG2D.1' , 1, myThid )
CcnhDebugEnds
      CALL EXCH_UV_XY_RS( aW2d, aS2d, .FALSE., myThid )
CcnhDebugStarts
C     CALL PLOT_FIELD_XYRS( aW2d, 'AW2D INI_CG2D.2' , 1, myThid )
C     CALL PLOT_FIELD_XYRS( aS2d, 'AS2D INI_CG2D.2' , 1, myThid )
CcnhDebugEnds

      _BEGIN_MASTER(myThid)
C-- set global parameter in common block:
      cg2dNorm = myNorm
C-- Define the solver tolerance in the appropriate Unit :
      cg2dNormaliseRHS = cg2dTargetResWunit.LE.zeroRL
      IF ( cg2dNormaliseRHS ) THEN
C-  when using a normalisation of RHS, tolerance has no unit => no conversion
        cg2dTolerance = cg2dTargetResidual
      ELSEIF ( implicDiv2DFlow.GT.zeroRL ) THEN
C-  convert Target-Residual (in W unit) to cg2d-solver residual unit [m^2/s^2]
        cg2dTolerance = cg2dNorm * cg2dTargetResWunit
     &                           * implicDiv2DFlow / deltaTMom
     &                           * globalArea / SQRT( n2dWetPts )
      ELSE
C-  special case implicDiv2DFlow=0 :
C   not much to solve anyway, cg2dTolerance does not matter as long as it is > 0
        cg2dTolerance = cg2dNorm * cg2dTargetResWunit
     &                           * globalArea / deltaTMom
      ENDIF
      cg2dTolerance_sq = cg2dTolerance*cg2dTolerance
      _END_MASTER(myThid)

CcnhDebugStarts
      _BEGIN_MASTER( myThid )
       WRITE(msgBuf,'(2A,1PE23.16)') 'INI_CG2D: ',
     &      'CG2D normalisation factor = ', cg2dNorm
       CALL PRINT_MESSAGE( msgBuf,standardMessageUnit,SQUEEZE_RIGHT,1)
       IF (.NOT.cg2dNormaliseRHS) THEN
        WRITE(msgBuf,'(2A,1PE22.15,A,1PE16.10,A)') 'INI_CG2D: ',
     &      'cg2dTolerance =', cg2dTolerance,
     &      ' (Area=', globalArea/SQRT(n2dWetPts), ')'
        CALL PRINT_MESSAGE(msgBuf,standardMessageUnit,SQUEEZE_RIGHT,1)
       ENDIF
       WRITE(msgBuf,*) ' '
       CALL PRINT_MESSAGE( msgBuf,standardMessageUnit,SQUEEZE_RIGHT,1)
      _END_MASTER( myThid )
CcnhDebugEnds

C--   Initialise preconditioner
C     Note. 20th May 1998
C           I made a weird discovery! In the model paper we argue
C           for the form of the preconditioner used here ( see
C           A Finite-volume, Incompressible Navier-Stokes Model
C           ...., Marshall et. al ). The algebra gives a simple
C           0.5 factor for the averaging of ac and aCw to get a
C           symmettric pre-conditioner. By using a factor of 0.51
C           i.e. scaling the off-diagonal terms in the
C           preconditioner down slightly I managed to get the
C           number of iterations for convergence in a test case to
C           drop form 192 -> 134! Need to investigate this further!
C           For now I have introduced a parameter cg2dpcOffDFac which
C           defaults to 0.51 but can be set at runtime.
      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
C-    calculate and store solver main diagonal :
        DO j=0,sNy
         DO i=0,sNx
           ks = kSurfC(i,j,bi,bj)
           aC2d(i,j,bi,bj) = -(
     &       aW2d(i,j,bi,bj) + aW2d(i+1,j, bi,bj)
     &      +aS2d(i,j,bi,bj) + aS2d( i,j+1,bi,bj)
     &      +freeSurfFac*myNorm*recip_Bo(i,j,bi,bj)*deepFac2F(ks)
     &                  *rA(i,j,bi,bj)/deltaTMom/deltaTFreeSurf
     &                        )
         ENDDO
        ENDDO
        DO j=1,sNy
         DO i=1,sNx
           aC  = aC2d( i, j, bi,bj)
           aCs = aC2d( i,j-1,bi,bj)
           aCw = aC2d(i-1,j, bi,bj)
           IF ( aC .EQ. zeroRS ) THEN
            pC(i,j,bi,bj) = 1. _d 0
           ELSE
            pC(i,j,bi,bj) =  1. _d 0 / aC
           ENDIF
           IF ( aC + aCw .EQ. zeroRS ) THEN
            pW(i,j,bi,bj) = 0.
           ELSE
            pW(i,j,bi,bj) =
     &         -aW2d(i,j,bi,bj)/((cg2dpcOffDFac *(aCw+aC))**2 )
           ENDIF
           IF ( aC + aCs .EQ. zeroRS ) THEN
            pS(i,j,bi,bj) = 0.
           ELSE
            pS(i,j,bi,bj) =
     &         -aS2d(i,j,bi,bj)/((cg2dpcOffDFac *(aCs+aC))**2 )
           ENDIF
C          pC(i,j,bi,bj) = 1.
C          pW(i,j,bi,bj) = 0.
C          pS(i,j,bi,bj) = 0.
         ENDDO
        ENDDO
       ENDDO
      ENDDO
C--   Update overlap regions
      CALL EXCH_XY_RS( pC, myThid )
      CALL EXCH_UV_XY_RS( pW, pS, .FALSE., myThid )
CcnhDebugStarts
C     CALL PLOT_FIELD_XYRS( pC, 'pC   INI_CG2D.2' , 1, myThid )
C     CALL PLOT_FIELD_XYRS( pW, 'pW   INI_CG2D.2' , 1, myThid )
C     CALL PLOT_FIELD_XYRS( pS, 'pS   INI_CG2D.2' , 1, myThid )
CcnhDebugEnds

      RETURN
      END

#include "GGL90_OPTIONS.h"

CBOP
C     !ROUTINE: GGL90_READ_PICKUP
C     !INTERFACE:
      SUBROUTINE GGL90_READ_PICKUP( myIter, myThid )

C     !DESCRIPTION: \bv
C     *================================================================*
C     | SUBROUTINE GGL90_READ_PICKUP
C     | o read ggl90 pickups
C     *================================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GGL90.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     myThid -  Number of this instance of GGL90_READ_CHECKPOINT
      INTEGER myIter
      INTEGER myThid

#ifdef ALLOW_GGL90

C     !LOCAL VARIABLES:
C     == Local variables ==
      CHARACTER*(MAX_LEN_FNAM) fn
      CHARACTER*(10) suff
      INTEGER prec
CEOP

C--   Suffix for pickup files
      IF (pickupSuff.EQ.' ') THEN
        IF ( rwSuffixType.EQ.0 ) THEN
          WRITE(suff,'(I10.10)') myIter
        ELSE
          CALL RW_GET_SUFFIX( suff, startTime, myIter, myThid )
        ENDIF
      ELSE
        WRITE(suff,'(A10)') pickupSuff
      ENDIF

      _BARRIER

      prec = precFloat64

      WRITE(fn,'(A,A10)') 'pickup_ggl90.',suff
      CALL READ_REC_3D_RL( fn, prec, Nr, GGL90TKE, 1, myIter, myThid )

      _EXCH_XYZ_RL( GGL90TKE, myThid )

#ifdef ALLOW_GGL90_IDEMIX
      IF (useIDEMIX) THEN
       CALL READ_REC_3D_RL( fn, prec, Nr, IDEMIX_E, 2, myIter, myThid )
       _EXCH_XYZ_RL( IDEMIX_E, myThid )
      ENDIF
#endif

#endif /*  ALLOW_GGL90  */

      RETURN
      END

#include "CPP_EEOPTIONS.h"

      SUBROUTINE GET_WRITE_GLOBAL_FLD ( flag )
      IMPLICIT NONE
C GET_WRITE_GLOBAL_FLD( flag ) gets the internal logical state
C that indicates whether to write a "global" or "tiled" files.
C READ_WRITE_FLD package should return 
C   flag = .TRUE.  indicates "global" files
C   flag = .FALSE. indicates "tiled" files
C
C Arguments (ouput)
      LOGICAL flag
C Common
      COMMON /RD_WR_FLD/ globalFile
      LOGICAL globalFile
C
      flag=globalFile
C
      RETURN
      END

#include "PACKAGES_CONFIG.h"
#include "CPP_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: DO_WRITE_PICKUP
C     !INTERFACE:
      SUBROUTINE DO_WRITE_PICKUP(
     I                    modelEnd,
     I                    myTime, myIter, myThid )

C     !DESCRIPTION:
C     This is the controlling routine that decides when to write restart
C      (or "pickup" or "checkpoint" ) files. Then it calls 2 subroutines
C     to write the main-model pickup and each package pickup files.
C
C     Both ``rolling-pickup'' files and permanent pickup files
C     are written from here. A rolling pickup works through a circular
C     list of suffices. Generally the circular list has two entries so
C     that a rolling pickup will overwrite the last rolling
C     pickup but one. This is useful for running long jobs without
C     filling too much disk space.  In a permanent pickup, data is
C     written suffixed by the current timestep number. Permanent
C     pickups can be used to provide snap-shots from which the
C     model can be restarted.

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "RESTART.h"
      LOGICAL  DIFFERENT_MULTIPLE
      EXTERNAL DIFFERENT_MULTIPLE

C     !INPUT PARAMETERS:
C     modelEnd  :: true if call at end of model run.
C     myTime    :: Current time of simulation ( s )
C     myIter    :: Iteration number
C     myThid    :: Thread number for this instance of the routine.
      LOGICAL modelEnd
      INTEGER myThid
      INTEGER myIter
      _RL     myTime
CEOP

C     !LOCAL VARIABLES:
C     permPickup :: Flag indicating whether a permanent pickup will
C                       be written.
C     tempPickup :: Flag indicating if it is time to write a non-permanent
C                       pickup (that will be permanent if permPickup=T)
C     suffix     :: pickup-name suffix
C     msgBuf     :: message buffer
      LOGICAL permPickup, tempPickup
      CHARACTER*(10) suffix
      CHARACTER*(MAX_LEN_MBUF) msgBuf

      permPickup = .FALSE.
      tempPickup = .FALSE.
      permPickup =
     &     DIFFERENT_MULTIPLE(pChkPtFreq,myTime,deltaTClock)
      tempPickup =
     &     DIFFERENT_MULTIPLE( chkPtFreq,myTime,deltaTClock)

#ifdef ALLOW_CAL
      IF ( useCAL ) THEN
         CALL CAL_TIME2DUMP( zeroRL, pChkPtFreq, deltaTClock,
     U                       permPickup,
     I                       myTime, myIter, myThid )
         CALL CAL_TIME2DUMP( zeroRL, chkPtFreq,  deltaTClock,
     U                       tempPickup,
     I                       myTime, myIter, myThid )
      ENDIF
#endif

      IF ( (modelEnd.AND.writePickupAtEnd)
     &     .OR. permPickup .OR. tempPickup ) THEN
C--   This is time to write pickup files

C-    Create suffix to pass on to main & package pickup routines
        IF ( permPickup .AND. rwSuffixType.EQ.0 ) THEN
          WRITE(suffix,'(I10.10)') myIter
        ELSEIF ( permPickup ) THEN
          CALL RW_GET_SUFFIX( suffix, myTime, myIter, myThid )
        ELSE
          WRITE(suffix,'(A)') checkPtSuff(nCheckLev)
        ENDIF

C-    Write a pickup for each package which need it to restart
        CALL PACKAGES_WRITE_PICKUP(
     I                permPickup, suffix, myTime, myIter, myThid )

C-    Write main model pickup
        IF ( .NOT.useOffLine .OR. nonlinFreeSurf.GT.0 ) THEN
           CALL WRITE_PICKUP(
     I                permPickup, suffix, myTime, myIter, myThid )
        ENDIF

        _BEGIN_MASTER(myThid)
C-    Write information to stdout so there is a record that
C     writing the pickup was completed
        WRITE(msgBuf,'(A11,I10,1X,A10)')
     &     "%CHECKPOINT ", myIter, suffix
        CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )

C-    Update pickup level for the next time we write pickup
        IF ( .NOT. permPickup ) THEN
          nCheckLev = MOD(nCheckLev, maxNoChkptLev)+1
        ENDIF
        _END_MASTER(myThid)

      ELSEIF ( modelEnd ) THEN
        WRITE(msgBuf,'(A)')
     &     "Did not write pickup because writePickupAtEnd = FALSE"
        CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )

C--   time to write pickup files: end
      ENDIF

      RETURN
      END

module lscale_cond_mod

!-----------------------------------------------------------------------
!use            fms_mod, only:  file_exist, error_mesg, open_file,  &
!                               check_nml_error, mpp_pe, FATAL,  &
!                               close_file
use simple_sat_vapor_pres_mod, only:  escomp, descomp

use      constants_mod, only:  HLv,HLs,Cp_air,Grav,rdgas,rvgas
use     gcm_params_mod, only: gcm_LEN_MBUF, gcm_SQZ_R, gcm_stdMsgUnit

implicit none
private
!-----------------------------------------------------------------------
!  ---- public interfaces ----

   public  lscale_cond, lscale_cond_init

!-----------------------------------------------------------------------
!   ---- version number ----

 character(len=128) :: version = '$Id: lscale_cond_mod.F90,v 1.2 2017/08/11 20:48:51 jmc Exp $'
 character(len=128) :: tag = '$Name:  $'

!-----------------------------------------------------------------------
!   ---- local/private data ----

    real, parameter :: d622 = rdgas/rvgas
    real, parameter :: d378 = 1.-d622

    logical :: do_init=.true.

!-----------------------------------------------------------------------
!   --- namelist ----

real    :: hc=1.00
logical :: do_evap=.false.

namelist /lscale_cond_nml/  hc, do_evap

!-----------------------------------------------------------------------
!           description of namelist variables
!
!  hc        =  relative humidity at which large scale condensation
!               occurs, where 0 <= hc <= 1 (default: hc=1.)
!
!  do_evap   =  flag for the re-evaporation of moisture in
!               sub-saturated layers below, if do_evap=.true. then
!               re-evaporation is performed (default: do_evap=.false.)
!
!-----------------------------------------------------------------------

contains

!#######################################################################

!   subroutine lscale_cond (tin, qin, pfull, phalf, coldT, &
!                           rain, snow, tdel, qdel, mask, conv)
subroutine lscale_cond (tin, qin, pfull, phalf, coldT, &
                        rain, snow, tdel, qdel, qsat,  &
                        myThid, mask, conv )

!-----------------------------------------------------------------------
!
!                      large scale condensation
!
!-----------------------------------------------------------------------
!
!   input:  tin      temperature at full model levels
!           qin      specific humidity of water vapor at full
!                      model levels
!           pfull    pressure at full model levels
!           phalf    pressure at half (interface) model levels
!           coldT    should precipitation be snow at this point?
!   optional:
!           mask     optional mask (0 or 1.)
!           conv     logical flag; if true then no large-scale
!                       adjustment is performed at that grid-point or
!                       model level
!
!  output:  rain     liquid precipitation (kg/m2)
!           snow     frozen precipitation (kg/m2)
!           tdel     temperature tendency at full model levels
!           qdel     specific humidity tendency (of water vapor) at
!                      full model levels
!           qsat     saturated specific humidity
!
!-----------------------------------------------------------------------
!--------------------- interface arguments -----------------------------

   real   , intent(in) , dimension(:,:,:) :: tin, qin, pfull, phalf
   logical   , intent(in) , dimension(:,:):: coldT
   real   , intent(out), dimension(:,:)   :: rain,snow
   real   , intent(out), dimension(:,:,:) :: tdel, qdel, qsat
   integer, intent(in)                    :: myThid
   real   , intent(in) , dimension(:,:,:), optional :: mask
   logical, intent(in) , dimension(:,:,:), optional :: conv
!-----------------------------------------------------------------------
!---------------------- local data -------------------------------------

logical,dimension(size(tin,1),size(tin,2),size(tin,3)) :: do_adjust
   real,dimension(size(tin,1),size(tin,2),size(tin,3)) ::  &
                             esat, desat, dqsat, pmes, pmass
   real,dimension(size(tin,1),size(tin,2))             :: hlcp, precip
integer  k, kx
!-----------------------------------------------------------------------
!     computation of precipitation by condensation processes
!-----------------------------------------------------------------------

!      if (do_init) call error_mesg ('lscale_cond',  &
!                         'lscale_cond_init has not been called.', FATAL)

      kx=size(tin,3)

!----- compute proper latent heat --------------------------------------
      WHERE (coldT)
           hlcp = HLs/Cp_air
      ELSEWHERE
           hlcp = HLv/Cp_air
      END WHERE

!----- saturation vapor pressure (esat) & specific humidity (qsat) -----

      call  escomp (tin,esat)
      call descomp (tin,desat)

      esat(:,:,:)=esat(:,:,:)*hc

   where (pfull(:,:,:) > d378*esat(:,:,:))
      pmes(:,:,:)=1.0/(pfull(:,:,:)-d378*esat(:,:,:))
      qsat(:,:,:)=d622*esat(:,:,:)*pmes(:,:,:)
      qsat(:,:,:)=max(0.0,qsat(:,:,:))
     dqsat(:,:,:)=d622*pfull(:,:,:)*desat(:,:,:)*pmes(:,:,:)*pmes(:,:,:)
   elsewhere
      pmes(:,:,:)=0.0
      qsat(:,:,:)=0.0
     dqsat(:,:,:)=0.0
   endwhere

!--------- do adjustment where greater than saturated value ------------

   if (present(conv)) then
!!!!  do_adjust(:,:,:)=(.not.conv(:,:,:) .and. qin(:,:,:) > qsat(:,:,:))
      do_adjust(:,:,:)=(.not.conv(:,:,:) .and.   &
                         (qin(:,:,:) - qsat(:,:,:))*qsat(:,:,:) > 0.0)
   else
!!!!  do_adjust(:,:,:)=(qin(:,:,:) > qsat(:,:,:))
      do_adjust(:,:,:)=( (qin(:,:,:) - qsat(:,:,:))*qsat(:,:,:) > 0.0)
   endif

   if (present(mask)) then
      do_adjust(:,:,:)=do_adjust(:,:,:) .and. (mask(:,:,:) > 0.5)
   end if

!----------- compute adjustments to temp and spec humidity -------------
   do k = 1,kx
   where (do_adjust(:,:,k))
      qdel(:,:,k)=(qsat(:,:,k)-qin(:,:,k))/(1.0+hlcp(:,:)*dqsat(:,:,k))
      tdel(:,:,k)=-hlcp(:,:)*qdel(:,:,k)
   elsewhere
      qdel(:,:,k)=0.0
      tdel(:,:,k)=0.0
   endwhere
   end do

!------------ pressure mass of each layer ------------------------------

   do k=1,kx
      pmass(:,:,k)=(phalf(:,:,k+1)-phalf(:,:,k))/Grav
   enddo

!------------ re-evaporation of precipitation in dry layer below -------

   if (do_evap) then
      if (present(mask)) then
!        call precip_evap (pmass,tin,qin,qsat,dqsat,hlcp,tdel,qdel,mask)
         call precip_evap (pmass,tin,qin,qsat,dqsat,hlcp,tdel,qdel,      &
                           myThid, mask )
      else
         call precip_evap (pmass,tin,qin,qsat,dqsat,hlcp,tdel,qdel,      &
                           myThid )
      endif
   endif

!------------ integrate precip -----------------------------------------

      precip(:,:)=0.0
   do k=1,kx
      precip(:,:)=precip(:,:)-pmass(:,:,k)*qdel(:,:,k)
   enddo
      precip(:,:)=max(precip(:,:),0.0)

   !assign precip to snow or rain
   WHERE (coldT)
      snow = precip
      rain = 0.
   ELSEWHERE
      rain = precip
      snow = 0.
   END WHERE

!-----------------------------------------------------------------------

   end subroutine lscale_cond

!#######################################################################

! subroutine precip_evap (pmass, tin, qin, qsat, dqsat, hlcp, &
!                         tdel, qdel, mask)
subroutine precip_evap (pmass, tin, qin, qsat, dqsat, hlcp, &
                        tdel, qdel, myThid, mask )

!-----------------------------------------------------------------------
!        performs re-evaporation of falling precipitation
!-----------------------------------------------------------------------
   real, intent(in),    dimension(:,:,:) :: pmass, tin, qin, qsat, dqsat
   real, intent(in),    dimension(:,:)   :: hlcp
   real, intent(inout), dimension(:,:,:) :: tdel, qdel
   integer, intent(in)                   :: myThid
   real, intent(in), dimension(:,:,:), optional :: mask
!-----------------------------------------------------------------------
   real, dimension(size(tin,1),size(tin,2)) :: exq, def

   integer  k
!-----------------------------------------------------------------------
    exq(:,:)=0.0

    do k=1,size(tin,3)

        where (qdel(:,:,k) < 0.0)  exq(:,:) = exq(:,:) -  &
                                               qdel(:,:,k)*pmass(:,:,k)

        if (present(mask)) exq(:,:) = exq(:,:)*mask(:,:,k)

!  ---- evaporate precip where needed ------

        where ( (qdel(:,:,k) >= 0.0) .and. (exq(:,:) > 0.0) )
            exq(:,:) = exq(:,:) / pmass(:,:,k)
            def(:,:) = (qsat(:,:,k)-qin(:,:,k))/(1.+hlcp(:,:)*dqsat(:,:,k))
            def(:,:) = min(max(def(:,:),0.0),exq(:,:))
            qdel(:,:,k) = qdel(:,:,k) + def(:,:)
            tdel(:,:,k) = tdel(:,:,k) - def(:,:)*hlcp(:,:)
            exq(:,:) = (exq(:,:)-def(:,:))*pmass(:,:,k)
        endwhere

    enddo

!-----------------------------------------------------------------------

   end subroutine precip_evap

!#######################################################################

   subroutine lscale_cond_init (myThid)

!-----------------------------------------------------------------------
!
!        initialization for large scale condensation
!
!-----------------------------------------------------------------------

  integer, intent(in) :: myThid

!-----------------------------------------------------------------------

! integer  unit,io,ierr
  integer         :: iUnit
  CHARACTER*(gcm_LEN_MBUF) :: msgBuf

!----------- read namelist ---------------------------------------------

!    _BARRIER
!    _BEGIN_MASTER(myThid)
     CALL BARRIER(myThid)
     IF ( myThid.EQ.1 ) THEN

     WRITE(msgBuf,'(A)') 'LSCALE_COND_INIT: opening data.atm_gray'
     CALL PRINT_MESSAGE( msgBuf, gcm_stdMsgUnit, gcm_SQZ_R, myThid )
     CALL OPEN_COPY_DATA_FILE(                                      &
                           'data.atm_gray', 'LSCALE_COND_INIT',     &
                           iUnit,                                   &
                           myThid )
!    Read parameters from open data file
     READ(UNIT=iUnit,NML=lscale_cond_nml)
     WRITE(msgBuf,'(A)')                                            &
          'LSCALE_COND_INIT: finished reading data.atm_gray'
     CALL PRINT_MESSAGE( msgBuf, gcm_stdMsgUnit, gcm_SQZ_R, myThid )
!    Close the open data file
#ifdef SINGLE_DISK_IO
     CLOSE(iUnit)
#else
     CLOSE(iUnit,STATUS='DELETE')
#endif /* SINGLE_DISK_IO */

!      if (file_exist('input.nml')) then
!         unit = open_file (file='input.nml', action='read')
!         ierr=1; do while (ierr /= 0)
!            read  (unit, nml=lscale_cond_nml, iostat=io, end=10)
!            ierr = check_nml_error (io,'lscale_cond_nml')
!         enddo
!  10     call close_file (unit)
!      endif

!---------- output namelist --------------------------------------------

!      unit = open_file (file='logfile.out', action='append')
!      if ( mpp_pe() == 0 ) then
!           write (unit,'(/,80("="),/(a))') trim(version), trim(tag)
!           write (unit,nml=lscale_cond_nml)
!      endif
!      call close_file (unit)

      do_init=.false.

     ENDIF
     CALL BARRIER(myThid)

   end subroutine lscale_cond_init

!#######################################################################

end module lscale_cond_mod

#include "EXF_OPTIONS.h"

CBOP 0
C     !ROUTINE: EXF_WEIGHT_SFX_DIAGS
C     !INTERFACE:
      SUBROUTINE EXF_WEIGHT_SFX_DIAGS(
     I                                 siceFrac, diagGroup,
     I                                 myTime, myIter, myThid )

C     !DESCRIPTION:
C     Apply open-ocean fraction weight to surface fluxes
C     before filling-in corresponding diagnostics

C     !USES:
      IMPLICIT NONE

C     == Global variables ===
#include "EEPARAMS.h"
#include "SIZE.h"
#include "PARAMS.h"
#include "EXF_PARAM.h"
#include "EXF_FIELDS.h"

C     !INPUT PARAMETERS:
C     siceFrac  :: seaice fraction [0-1]
C     diagGroup :: select which group of surface fluxes to process
C               :: =1 : wind-stress ; =2 : other surf. fluxes
C     myTime    :: current time in simulation [s]
C     myIter    :: current iteration number in simulation
C     myThid    :: my Thread Id number
      _RL     siceFrac(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      INTEGER diagGroup
      _RL     myTime
      INTEGER myIter
      INTEGER myThid

#ifdef ALLOW_DIAGNOSTICS
C     !FUNCTIONS:
      LOGICAL  DIAGNOSTICS_IS_ON
      EXTERNAL DIAGNOSTICS_IS_ON

C     !LOCAL VARIABLES:
C     tmpFld    :: open-ocean weighted surface flux
C     bi,bj     :: tile indices
C     i,j       :: grid point indices
      _RL     tmpFld(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      INTEGER bi, bj
      INTEGER i, j
CEOP

      IF ( useDiagnostics .AND. diags_opOceWeighted ) THEN

C--   First group of surface-flux: Momentum fluxes
        IF ( diagGroup.EQ.-1 ) THEN
          CALL DIAGNOSTICS_FILL( ustress,'EXFtaux ', 0,1,0,1,1,myThid )
          CALL DIAGNOSTICS_FILL( vstress,'EXFtauy ', 0,1,0,1,1,myThid )
        ELSEIF ( diagGroup.EQ.1 ) THEN

         IF ( DIAGNOSTICS_IS_ON('EXFtaux ',myThid) ) THEN
          DO bj=myByLo(myThid),myByHi(myThid)
           DO bi=myBxLo(myThid),myBxHi(myThid)
            IF ( stressIsOnCgrid ) THEN
             DO j = 1,sNy
              DO i = 1,sNx+1
               tmpFld(i,j,bi,bj) = ustress(i,j,bi,bj)
     &            *( oneRL - halfRL*
     &               ( siceFrac(i-1,j,bi,bj) + siceFrac(i,j,bi,bj) ) )
              ENDDO
             ENDDO
            ELSE
             DO j = 1-OLy,sNy+OLy
              DO i = 1-OLx,sNx+OLx
               tmpFld(i,j,bi,bj) = ustress(i,j,bi,bj)
     &                           *( oneRL - siceFrac(i,j,bi,bj) )
              ENDDO
             ENDDO
            ENDIF
           ENDDO
          ENDDO
          CALL DIAGNOSTICS_FILL( tmpFld, 'EXFtaux ', 0,1,0,1,1,myThid )
         ENDIF

         IF ( DIAGNOSTICS_IS_ON('EXFtauy ',myThid) ) THEN
          DO bj=myByLo(myThid),myByHi(myThid)
           DO bi=myBxLo(myThid),myBxHi(myThid)
            IF ( stressIsOnCgrid ) THEN
             DO j = 1,sNy+1
              DO i = 1,sNx
               tmpFld(i,j,bi,bj) = vstress(i,j,bi,bj)
     &            *( oneRL - halfRL*
     &               ( siceFrac(i,j-1,bi,bj) + siceFrac(i,j,bi,bj) ) )
              ENDDO
             ENDDO
            ELSE
             DO j = 1-OLy,sNy+OLy
              DO i = 1-OLx,sNx+OLx
               tmpFld(i,j,bi,bj) = vstress(i,j,bi,bj)
     &                           *( oneRL - siceFrac(i,j,bi,bj) )
              ENDDO
             ENDDO
            ENDIF
           ENDDO
          ENDDO
          CALL DIAGNOSTICS_FILL( tmpFld, 'EXFtauy ', 0,1,0,1,1,myThid )
         ENDIF

C--   end first group
        ENDIF

C--   Second group of surface-flux: Buoyancy fluxes
        IF ( diagGroup.EQ.-2 ) THEN
          CALL DIAGNOSTICS_FILL( hflux,  'EXFqnet ', 0,1,0,1,1,myThid )
          CALL DIAGNOSTICS_FILL( sflux,  'EXFempmr', 0,1,0,1,1,myThid )
#if defined(ALLOW_ATM_TEMP) || defined(SHORTWAVE_HEATING)
          CALL DIAGNOSTICS_FILL( swflux, 'EXFswnet', 0,1,0,1,1,myThid )
#endif /* ALLOW_ATM_TEMP or SHORTWAVE_HEATING */
        ELSEIF ( diagGroup.EQ.2 ) THEN

         IF ( DIAGNOSTICS_IS_ON('EXFqnet ',myThid) ) THEN
          DO bj=myByLo(myThid),myByHi(myThid)
           DO bi=myBxLo(myThid),myBxHi(myThid)
             DO j = 1-OLy,sNy+OLy
              DO i = 1-OLx,sNx+OLx
               tmpFld(i,j,bi,bj) = hflux(i,j,bi,bj)
     &                           *( oneRL - siceFrac(i,j,bi,bj) )
              ENDDO
             ENDDO
           ENDDO
          ENDDO
          CALL DIAGNOSTICS_FILL( tmpFld, 'EXFqnet ', 0,1,0,1,1,myThid )
         ENDIF

         IF ( DIAGNOSTICS_IS_ON('EXFempmr',myThid) ) THEN
          DO bj=myByLo(myThid),myByHi(myThid)
           DO bi=myBxLo(myThid),myBxHi(myThid)
             DO j = 1-OLy,sNy+OLy
              DO i = 1-OLx,sNx+OLx
               tmpFld(i,j,bi,bj) = sflux(i,j,bi,bj)
     &                           *( oneRL - siceFrac(i,j,bi,bj) )
              ENDDO
             ENDDO
           ENDDO
          ENDDO
          CALL DIAGNOSTICS_FILL( tmpFld, 'EXFempmr', 0,1,0,1,1,myThid )
         ENDIF

#if defined(ALLOW_ATM_TEMP) || defined(SHORTWAVE_HEATING)
         IF ( DIAGNOSTICS_IS_ON('EXFswnet',myThid) ) THEN
          DO bj=myByLo(myThid),myByHi(myThid)
           DO bi=myBxLo(myThid),myBxHi(myThid)
             DO j = 1-OLy,sNy+OLy
              DO i = 1-OLx,sNx+OLx
               tmpFld(i,j,bi,bj) = swflux(i,j,bi,bj)
     &                           *( oneRL - siceFrac(i,j,bi,bj) )
              ENDDO
             ENDDO
           ENDDO
          ENDDO
          CALL DIAGNOSTICS_FILL( tmpFld, 'EXFswnet', 0,1,0,1,1,myThid )
         ENDIF
#endif /* ALLOW_ATM_TEMP or SHORTWAVE_HEATING */

C--   end second group
        ENDIF

#ifdef ALLOW_ATM_TEMP
C--   Third group: Individual components of surface buoyancy fluxes ;
C     processed the same way and at same time as buoyancy fluxes (second group)
        IF ( diagGroup.EQ.-2 ) THEN
#ifdef ALLOW_ATM_TEMP
          CALL DIAGNOSTICS_FILL( hs    , 'EXFhs   ', 0,1,0,1,1,myThid )
          CALL DIAGNOSTICS_FILL( hl    , 'EXFhl   ', 0,1,0,1,1,myThid )
          CALL DIAGNOSTICS_FILL( lwflux, 'EXFlwnet', 0,1,0,1,1,myThid )
          CALL DIAGNOSTICS_FILL( evap,   'EXFevap ', 0,1,0,1,1,myThid )
#endif /* ALLOW_ATM_TEMP */
        ELSEIF ( diagGroup.EQ.2 ) THEN

         IF ( DIAGNOSTICS_IS_ON('EXFhs   ',myThid) ) THEN
          DO bj=myByLo(myThid),myByHi(myThid)
           DO bi=myBxLo(myThid),myBxHi(myThid)
             DO j = 1-OLy,sNy+OLy
              DO i = 1-OLx,sNx+OLx
               tmpFld(i,j,bi,bj) = hs(i,j,bi,bj)
     &                           *( oneRL - siceFrac(i,j,bi,bj) )
              ENDDO
             ENDDO
           ENDDO
          ENDDO
          CALL DIAGNOSTICS_FILL( tmpFld, 'EXFhs   ', 0,1,0,1,1,myThid )
         ENDIF

         IF ( DIAGNOSTICS_IS_ON('EXFhl   ',myThid) ) THEN
          DO bj=myByLo(myThid),myByHi(myThid)
           DO bi=myBxLo(myThid),myBxHi(myThid)
             DO j = 1-OLy,sNy+OLy
              DO i = 1-OLx,sNx+OLx
               tmpFld(i,j,bi,bj) = hl(i,j,bi,bj)
     &                           *( oneRL - siceFrac(i,j,bi,bj) )
              ENDDO
             ENDDO
           ENDDO
          ENDDO
          CALL DIAGNOSTICS_FILL( tmpFld, 'EXFhl   ', 0,1,0,1,1,myThid )
         ENDIF

         IF ( DIAGNOSTICS_IS_ON('EXFlwnet',myThid) ) THEN
          DO bj=myByLo(myThid),myByHi(myThid)
           DO bi=myBxLo(myThid),myBxHi(myThid)
             DO j = 1-OLy,sNy+OLy
              DO i = 1-OLx,sNx+OLx
               tmpFld(i,j,bi,bj) = lwflux(i,j,bi,bj)
     &                           *( oneRL - siceFrac(i,j,bi,bj) )
              ENDDO
             ENDDO
           ENDDO
          ENDDO
          CALL DIAGNOSTICS_FILL( tmpFld, 'EXFlwnet', 0,1,0,1,1,myThid )
         ENDIF

         IF ( DIAGNOSTICS_IS_ON('EXFevap ',myThid) ) THEN
          DO bj=myByLo(myThid),myByHi(myThid)
           DO bi=myBxLo(myThid),myBxHi(myThid)
             DO j = 1-OLy,sNy+OLy
              DO i = 1-OLx,sNx+OLx
               tmpFld(i,j,bi,bj) = evap(i,j,bi,bj)
     &                           *( oneRL - siceFrac(i,j,bi,bj) )
              ENDDO
             ENDDO
           ENDDO
          ENDDO
          CALL DIAGNOSTICS_FILL( tmpFld, 'EXFevap ', 0,1,0,1,1,myThid )
         ENDIF

C--   end third group
        ENDIF
#endif /* ALLOW_ATM_TEMP */

      ENDIF
#endif /* ALLOW_DIAGNOSTICS */

      RETURN
      END

!=======================================================================
      subroutine comprecv_i4vec( dataname, length, vecFld )
      implicit none
! Predefined constants/arrays
#include "CPLR_SIG.h"
! MPI variables
#include "mpif.h"
! Arguments
      character*(*) dataname
      integer length
      integer vecFld(length)
! Functions
      integer generate_tag
      external generate_tag
! Local
      integer count,dtype,rank,tag,comm,ierr
      integer stat(MPI_STATUS_SIZE)
      integer i, j
      integer ibuf(MAX_IBUF)
!     ------------------------------------------------------------------

      if ( 1+length .gt. MAX_IBUF )
     &    STOP 'comprecv_i4vec: length exceeds MAX_IBUF'

! Receive message
      count = MAX_IBUF
      dtype = MPI_INTEGER
      rank = my_coupler_rank
      tag = generate_tag( 125, my_rank_in_global, dataname )
      comm = MPI_COMM_myglobal

      if (VERB) then
        write(LogUnit,*)
     &   'comprecv_i4vec: calling MPI_Recv rank=',rank
        write(LogUnit,*) 'comprecv_i4vec: dataname=',dataname
        call flush(LogUnit)
      endif
      call MPI_Recv( ibuf, count, dtype, rank, tag, comm, stat, ierr )
      if (VERB) then
        write(LogUnit,*) 'comprecv_i4vec: returned ierr=',ierr
        call flush(LogUnit)
      endif

      if (ierr.ne.0) then
        write(LogUnit,*) 'comprecv_i4vec: rank(W,G,L)=',
     &            my_rank_in_world,my_rank_in_global,my_rank_in_local,
     &            ' ierr=',ierr
        STOP 'comprecv_i4vec: MPI_Recv failed'
      endif

! Check header
      j = ibuf(1)
      if ( j.ne.length ) then
        write(LogUnit,*) 'comprecv_i4vec: length,header=', length, j
        STOP 'comprecv_i4vec: Incompatible header'
      endif

! Extract data
      do i=1,length
        vecFld(i) = ibuf(i+1)
      enddo

!     ------------------------------------------------------------------
      return
      end
!=======================================================================

#include "CPP_OPTIONS.h"

CBOP
C     !ROUTINE: GRAD_SIGMA
C     !INTERFACE:
      SUBROUTINE GRAD_SIGMA(
     I             bi, bj, iMin, iMax, jMin, jMax, k,
     I             rhoK, sigKm1, sigKp1,
     O             sigmaX, sigmaY, sigmaR,
     I             myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE GRAD_SIGMA
C     | o Calculate isoneutral gradients
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"

C     !INPUT/OUTPUT PARAMETERS:
C     bi, bj     :: tile indices
C     iMin,iMax  :: not used
C     jMin,jMax  :: not used
C     k          :: current level index
C     rhoK       :: density at level k
C     sigKm1     :: upper level density computed at current pressure
C     sigKp1     :: lower level density computed at current pressure
C     sigmaX,Y,R :: iso-neutral gradient of density in 3 directions X,Y,R
C     myThid     :: my Thread Id. number
      INTEGER bi,bj,iMin,iMax,jMin,jMax,k
      _RL rhoK(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL sigKm1(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL sigKp1(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL sigmaX(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL sigmaY(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL sigmaR(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      INTEGER myThid

C     !LOCAL VARIABLES:
C     rhoLoc     :: local copy of rhoK
      INTEGER i,j
      _RL rhoLoc(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
CEOP

C-    safer to work on a local copy of rhoK (before a partial update)
      DO j=1-OLy,sNy+OLy
       DO i=1-OLx,sNx+OLx
        rhoLoc(i,j) = rhoK(i,j)
       ENDDO
      ENDDO

C-    Internal exchange for calculations in X
      IF ( useCubedSphereExchange ) THEN
        CALL FILL_CS_CORNER_TR_RL( 1, .FALSE.,
     &                             rhoLoc, bi,bj, myThid )
      ENDIF
      DO j=1-OLy,sNy+OLy
       DO i=1-OLx+1,sNx+OLx
        sigmaX(i,j,k)=_maskW(i,j,k,bi,bj)
     &        *_recip_dxC(i,j,bi,bj)*recip_deepFacC(k)
     &        *(rhoLoc(i,j)-rhoLoc(i-1,j))
       ENDDO
      ENDDO

C-    Internal exchange for calculations in Y
      IF ( useCubedSphereExchange ) THEN
        CALL FILL_CS_CORNER_TR_RL( 2, .FALSE.,
     &                             rhoLoc, bi,bj, myThid )
      ENDIF
      DO j=1-OLy+1,sNy+OLy
       DO i=1-OLx,sNx+OLx
        sigmaY(i,j,k)=_maskS(i,j,k,bi,bj)
     &        *_recip_dyC(i,j,bi,bj)*recip_deepFacC(k)
     &        *(rhoLoc(i,j)-rhoLoc(i,j-1))
       ENDDO
      ENDDO

      IF (k.EQ.1) THEN
       DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
         sigmaR(i,j,k)= 0. _d 0
        ENDDO
       ENDDO
      ELSE
       DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
         sigmaR(i,j,k)= maskC(i,j,k,bi,bj)*maskC(i,j,k-1,bi,bj)
     &                *recip_drC(k)*rkSign
     &                *(sigKp1(i,j)-sigKm1(i,j))
        ENDDO
       ENDDO
      ENDIF

      RETURN
      END

#include "PACKAGES_CONFIG.h"
#include "CPP_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: DO_THE_MODEL_IO

C     !INTERFACE:
      SUBROUTINE DO_THE_MODEL_IO(
     I                            modelEnd,
     I                            myTime, myIter, myThid )

C     !DESCRIPTION:
C     This is the controlling routine for IO in the model main
C     time--stepping loop.  Many systems do not have thread safe IO so it
C     is easier to lump everything together and do dumping of fields and
C     updating of forcing terms in a single place.  The approach to IO
C     used here is that writes are only performed by thread 1 and that a
C     process only writes out its data (it does not know about anyone
C     elses data!)  Reading on the other hand is assumed to be from a
C     file containing all the data for all the processes. Only the
C     portion of data of interest to this process is actually loaded. To
C     work well this assumes the existence of some reliable tool to join
C     datasets together at the end of a run -- see joinds.

C     !CALLING SEQUENCE:
C     DO_THE_MODEL_IO
C       |
C       |-- WRITE_STATE
C       |
C       |-- FIZHI_WRITE_STATE
C       |
C       |-- LAND_OUTPUT
C       |
C       |-- OBCS_OUTPUT
C       |
C       |-- GMREDI_OUTPUT
C       |
C       |-- KPP_OUTPUT
C       |
C       |-- PP81_OUTPUT
C       |
C       |-- KL10_OUTPUT
C       |
C       |-- MY82_OUTPUT
C       |
C       |-- OPPS_OUTPUT
C       |
C       |-- GGL90_OUTPUT
C       |
C       |-- SBO_CALC
C       |-- SBO_OUTPUT
C       |
C       |-- STERGLOH_OUTPUT
C       |
C       |-- SEAICE_OUTPUT
C       |
C       |-- SHELFICE_OUTPUT
C       |
C       |-- THSICE_OUTPUT
C       |
C       |-- PTRACERS_OUTPUT
C       |
C       |-- MATRIX_OUTPUT
C       |
C       |-- GCHEM_OUTPUT
C       |
C       |-- LAYERS_CALC
C       |
C       |-- DIAGNOSTICS_WRITE

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "DYNVARS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     modelEnd :: true if call at end of model run.
C     myTime   :: Current time of simulation ( s )
C     myIter   :: Iteration number
C     myThid   :: Thread number for this instance of the routine.
      LOGICAL modelEnd
      _RL     myTime
      INTEGER myThid
      INTEGER myIter

C     !FUNCTIONS:
      LOGICAL  DIFFERENT_MULTIPLE
      EXTERNAL DIFFERENT_MULTIPLE
CEOP

C     Generaly only thread 1 does IO here. It can not start until
C     all threads fields are ready.
      IF ( plotLevel.GE.debLevD ) THEN
        IF ( DIFFERENT_MULTIPLE(dumpFreq,myTime,deltaTClock)
     &     ) THEN

          _BARRIER

C         Write "text-plots" of certain fields
          CALL PLOT_FIELD_XYZRL( uVel , 'Current uVel  ',
     &         Nr, myIter, myThid )
          CALL PLOT_FIELD_XYZRL( vVel , 'Current vVel  ',
     &         Nr, myIter, myThid )
          CALL PLOT_FIELD_XYZRL( theta, 'Current theta ',
     &         Nr, myIter, myThid )
          CALL PLOT_FIELD_XYRL( etaN  , 'Current etaN  ',
     &         myIter, myThid )

        ENDIF
      ENDIF

C     Write model state to binary file
      IF ( .NOT.useOffLine ) THEN
        CALL WRITE_STATE( myTime, myIter, myThid )
      ENDIF

#ifdef ALLOW_FIZHI
      IF ( useFIZHI )
     &     CALL FIZHI_WRITE_STATE( myTime, myIter, myThid )
#endif

#ifdef ALLOW_LAND
C     Do LAND output
      IF ( useLAND )
     &     CALL LAND_OUTPUT( myTime, myIter, myThid )
#endif

#ifdef ALLOW_OBCS
      IF (useOBCS )
     &     CALL OBCS_OUTPUT( myTime, myIter, myThid )
#endif

#ifdef ALLOW_GMREDI
C     Do GMRedi output.
      IF (useGMRedi .AND. myIter.NE.nIter0 .AND. .NOT.useOffLine )
     &     CALL GMREDI_OUTPUT( myTime, myIter, myThid )
#endif

#ifdef ALLOW_KPP
C     Do KPP diagnostics.
      IF ( useKPP )
     &     CALL KPP_OUTPUT( myTime, myIter, myThid )
#endif

#ifdef ALLOW_PP81
C     Do PP81 diagnostics.
      IF ( usePP81 )
     &     CALL PP81_OUTPUT( myTime, myIter, myThid )
#endif

#ifdef ALLOW_KL10
C     Do KL10 diagnostics.
      IF ( useKL10 )
     &     CALL KL10_OUTPUT( myTime, myIter, myThid )
#endif

#ifdef ALLOW_MY82
C     Do MY82 diagnostics.
      IF ( useMY82 )
     &     CALL MY82_OUTPUT( myTime, myIter, myThid )
#endif

c#ifdef ALLOW_OPPS
C--   Do OPPS diagnostics.
c     IF ( useOPPS )
c    & CALL OPPS_OUTPUT( myTime, myIter, myThid )
c#endif

#ifdef ALLOW_GGL90
C--   Do GGL90 diagnostics.
      IF ( useGGL90 )
     & CALL GGL90_OUTPUT( myTime, myIter, myThid )
#endif

#ifdef ALLOW_SBO
C     Do SBO diagnostics.
      IF ( useSBO ) THEN
        CALL SBO_CALC( myTime, myIter, myThid )
        CALL SBO_OUTPUT( myTime, myIter, myThid )
      ENDIF
#endif

#ifdef ALLOW_ECCO
      IF ( useECCO ) THEN
        CALL STERGLOH_OUTPUT( myTime, myIter, myThid )
      ENDIF
#endif

#ifdef  ALLOW_SEAICE
      IF ( useSEAICE ) THEN
        CALL SEAICE_OUTPUT( myTime, myIter, myThid )
      ENDIF
#endif  /* ALLOW_SEAICE */

#ifdef  ALLOW_SHELFICE
      IF ( useShelfIce ) THEN
        CALL SHELFICE_OUTPUT( myTime, myIter, myThid )
      ENDIF
#endif  /* ALLOW_SHELFICE */

#ifdef ALLOW_THSICE
C     Do seaice output.
      IF (useThSIce)
     &     CALL THSICE_OUTPUT( myTime, myIter, myThid )
#endif

#ifdef ALLOW_PTRACERS
C--   Do ptracer output.
      IF ( usePTRACERS )
     & CALL PTRACERS_OUTPUT( myTime, myIter, myThid )
#endif

#ifdef ALLOW_MATRIX
C--   Do matrix output
      IF (useMATRIX)
     & CALL MATRIX_OUTPUT( myTime, myIter, myThid )
#endif

#ifdef ALLOW_GCHEM
C--   Do GCHEM diagnostics.
      IF (useGCHEM)
     & CALL GCHEM_OUTPUT( myTime, myIter, myThid )
#endif

#ifdef ALLOW_OFFLINE
C--   Do Off-Line variables output
c     IF (useOffLine)
c    & CALL OFFLINE_STATE( myTime, myIter, myThid )
#endif

#ifdef ALLOW_LAYERS
      IF ( useLayers ) THEN
        CALL LAYERS_CALC( myTime, myIter, myThid )
      ENDIF
#endif /* ALLOW_LAYERS */

#ifdef ALLOW_DIAGNOSTICS
      IF ( useDiagnostics )
     &     CALL DIAGNOSTICS_WRITE( modelEnd, myTime, myIter, myThid )
#endif

      RETURN
      END

#include "GAD_OPTIONS.h"

CBOP
C     !ROUTINE: GAD_FLUXLIMIT_IMPL_R
C     !INTERFACE:
      SUBROUTINE GAD_FLUXLIMIT_IMPL_R(
     I           bi,bj,k, iMin,iMax,jMin,jMax,
     I           deltaTarg, rTrans, recip_hFac, tFld,
     O           a3d, b3d, c3d,
     I           myThid )

C     !DESCRIPTION:
C     Compute matrix element to solve vertical advection implicitly
C      using flux--limiter advection scheme.
C     Method:
C      contribution of vertical transport at interface k is added
C      to matrix lines k and k-1.

C     !USES:
      IMPLICIT NONE

C     == Global variables ===
#include "SIZE.h"
#include "GRID.h"
#include "EEPARAMS.h"
#include "PARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine Arguments ==
C     bi, bj       :: tile indices
C     k            :: vertical level
C     iMin, iMax   :: computation domain
C     jMin, jMax   :: computation domain
C     deltaTarg    :: time step
C     rTrans       :: vertical volume transport
C     recip_hFac   :: inverse of cell open-depth factor
C     tFld         :: tracer field
C     a3d          :: lower diagonal of the tridiagonal matrix
C     b3d          :: main  diagonal of the tridiagonal matrix
C     c3d          :: upper diagonal of the tridiagonal matrix
C     myThid       :: thread number
      INTEGER bi,bj,k
      INTEGER iMin,iMax,jMin,jMax
      _RL     deltaTarg(Nr)
      _RL     rTrans(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RS recip_hFac(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL     tFld  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL     a3d   (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL     b3d   (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL     c3d   (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      INTEGER myThid

C     == Local Variables ==
C     i, j         :: loop indices
C     kp1          :: =min( k+1 , Nr )
C     km1          :: =max( k-1 , 1 )
C     km2          :: =max( k-2 , 1 )
C     Cr           :: slope ratio
C     Rjm, Rj, Rjp :: differences at k-1,k,k+1
C     w_CFL        :: Courant-Friedrich-Levy number
C     upwindFac    :: upwind factor
C     rCenter      :: centered contribution
C     rUpwind      :: upwind   contribution
      INTEGER i, j, kp1, km1, km2
      _RL Cr, Rjm, Rj, Rjp, w_CFL
      _RL upwindFac(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL rCenter, rUpwind
      _RL deltaTcfl
      _RL CrMax
      PARAMETER( CrMax = 1.D+6 )

C Statement function provides Limiter(Cr)
#include "GAD_FLUX_LIMITER.h"
CEOP

      km2 = MAX(1,k-2)
      km1 = MAX(1,k-1)
      kp1 = MIN(Nr,k+1)

C--   process interior interface only:
      IF ( k.GT.1 .AND. k.LE.Nr ) THEN

C--   Compute the upwind fraction:
       deltaTcfl = deltaTarg(k)
       DO j=jMin,jMax
        DO i=iMin,iMax
         w_CFL = deltaTcfl*rTrans(i,j)*recip_rA(i,j,bi,bj)*recip_drC(k)
     &                    *recip_deepFac2F(k)*recip_rhoFacF(k)
         Rjp = (tFld(i,j,kp1)-tFld(i,j,k)  )*maskC(i,j,kp1,bi,bj)
         Rj  = (tFld(i,j,k)  -tFld(i,j,km1))
         Rjm = (tFld(i,j,km1)-tFld(i,j,km2))*maskC(i,j,km2,bi,bj)

         IF ( rTrans(i,j).LT.zeroRL ) THEN
           Cr = Rjm
         ELSE
           Cr = Rjp
         ENDIF
         IF ( ABS(Rj)*CrMax .LE. ABS(Cr) ) THEN
           Cr = SIGN( CrMax, Cr )*SIGN( oneRL, Rj )
         ELSE
           Cr = Cr/Rj
         ENDIF

C        calculate upwind fraction using Limiter Function:
         upwindFac(i,j) = 1. _d 0
     &                  - Limiter(Cr) * ( 1. _d 0 + ABS(w_CFL) )
         upwindFac(i,j) = MAX( -1. _d 0, upwindFac(i,j) )
        ENDDO
       ENDDO

C--    Add centered & upwind contributions
       DO j=jMin,jMax
         DO i=iMin,iMax
           rCenter = 0.5 _d 0 *rTrans(i,j)*recip_rA(i,j,bi,bj)*rkSign
           rUpwind = ABS(rCenter)*upwindFac(i,j)
           a3d(i,j,k)   = a3d(i,j,k)
     &                  - (rCenter+rUpwind)*deltaTarg(k)
     &                   *recip_hFac(i,j,k)*recip_drF(k)
     &                   *recip_deepFac2C(k)*recip_rhoFacC(k)
           b3d(i,j,k)   = b3d(i,j,k)
     &                  - (rCenter-rUpwind)*deltaTarg(k)
     &                   *recip_hFac(i,j,k)*recip_drF(k)
     &                   *recip_deepFac2C(k)*recip_rhoFacC(k)
           b3d(i,j,k-1) = b3d(i,j,k-1)
     &                  + (rCenter+rUpwind)*deltaTarg(k-1)
     &                   *recip_hFac(i,j,k-1)*recip_drF(k-1)
     &                   *recip_deepFac2C(k-1)*recip_rhoFacC(k-1)
           c3d(i,j,k-1) = c3d(i,j,k-1)
     &                  + (rCenter-rUpwind)*deltaTarg(k-1)
     &                   *recip_hFac(i,j,k-1)*recip_drF(k-1)
     &                   *recip_deepFac2C(k-1)*recip_rhoFacC(k-1)
         ENDDO
       ENDDO

C--   process interior interface only: end
      ENDIF

      RETURN
      END

#include "ctrparam.h"
#include "ATM2D_OPTIONS.h"

C     !INTERFACE:
      SUBROUTINE RELAX_ADD( wght0, wght1,
     &               intime0, intime1, iftime, myIter, myThid)
C     *==========================================================*
C     | Adds restoring terms to surface forcing. Note that:      |
C     |    - restoring is phased out as restor (or act.) SST <2C |
C     |    - if nsTypeRelax NE 0, salt rest. phased out nr poles |
C     |    - if ntTypeRelax NE 0, temp rest. phased out nr poles |
C     *==========================================================*
        IMPLICIT NONE

#include "ATMSIZE.h"
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "THSICE_VARS.h"
#include "ATM2D_VARS.h"

c include ocean and seaice vars

C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
C     wght0, wght1   - weight of first and second month, respectively
C     intime0,intime1- month id # for first and second months
C     iftime - true -> prompts a reloading of data from disk
C     myIter - Ocean iteration number
C     myThid - Thread no. that called this routine.
      _RL  wght0
      _RL  wght1
      INTEGER intime0
      INTEGER intime1
      LOGICAL iftime
      INTEGER myIter
      INTEGER myThid

C     LOCAL VARIABLES:
C     Save below so that continual file reloads aren't necessary
      COMMON /OCEANRELAX/
     &                 sst0, sst1, sss0, sss1

      _RS  sst0(1-Olx:sNx+Olx,1-Oly:sNy+Oly,1,1)
      _RS  sst1(1-Olx:sNx+Olx,1-Oly:sNy+Oly,1,1)
      _RS  sss0(1-Olx:sNx+Olx,1-Oly:sNy+Oly,1,1)
      _RS  sss1(1-Olx:sNx+Olx,1-Oly:sNy+Oly,1,1)
      _RL lambdaTheta,lambdaSalt
      _RS nearIce    ! constant used to phase out rest near frz point
      _RL qrelflux, frelflux
      _RL sstRelax(1:sNx,1:sNy) ! relaxation sst as computed from file
      _RL sssRelax(1:sNx,1:sNy) ! relaxation sss as computed from file
      INTEGER i,j

      IF (ifTime) THEN

C      If the above condition is met then we need to read in
C      data for the period ahead and the period behind current time.

        WRITE(*,*) 'S/R RELAX_ADD: Reading new data'
        IF ( thetaRelaxFile .NE. ' '  ) THEN
          CALL READ_REC_XY_RS( thetaRelaxFile,sst0,intime0,
     &                      myIter,myThid )
          CALL READ_REC_XY_RS( thetaRelaxFile,sst1,intime1,
     &                      myIter,myThid )
        ENDIF
        IF ( saltRelaxFile .NE. ' '  ) THEN
          CALL READ_REC_XY_RS( saltRelaxFile,sss0,intime0,
     &                      myIter,myThid )
          CALL READ_REC_XY_RS( saltRelaxFile,sss1,intime1,
     &                      myIter,myThid )
        ENDIF

      ENDIF

      IF ((thetaRelaxFile.NE.' ').OR.(saltRelaxFile.NE.' ')) THEN

C--   Interpolate and add to anomaly
      DO j=1,sNy

        IF (ntTypeRelax .EQ. 0) THEN
          lambdaTheta =  r_tauThetaRelax
        ELSE
          lambdaTheta = r_tauThetaRelax *
     &                 max(cos(1.5 _d 0*yC(1,j,1,1)*deg2rad),0. _d 0)
        ENDIF
        IF (nsTypeRelax .EQ. 0) THEN
          lambdaSalt = r_tauSaltRelax
        ELSE
          lambdaSalt = r_tauSaltRelax *
     &                max(cos(1.5 _d 0*yC(1,j,1,1)*deg2rad),0. _d 0)
        ENDIF

        DO i=1,sNx

          IF (maskC(i,j,1,1,1) .EQ. 1.) THEN

          IF (thetaRelaxFile.NE.' ') THEN
            sstRelax(i,j)= (wght0*sst0(i,j,1,1) + wght1*sst1(i,j,1,1))
          ELSE  !no T restoring; use actual SST to determine if nr freezing
            sstRelax(i,j)= sstFromOcn(i,j)
          ENDIF

          IF (saltRelaxFile.NE.' ') THEN
            sssRelax(i,j)= (wght0*sss0(i,j,1,1) + wght1*sss1(i,j,1,1))
          ELSE  ! no S restoring; this ensures frelflux=0
            sssRelax(i,j)= sssFromOcn(i,j)
          ENDIF


C         Next lines: linearly phase out SST restoring between 2C and -1C
C         ONLY if seaice is present
          IF ((sstRelax(i,j).GT.2. _d 0).OR.
     &        (iceMask(i,j,1,1) .EQ. 0. _d 0)) THEN
              nearIce=1.0
          ELSEIF (sstRelax(i,j) .LE. -1. _d 0) THEN
              nearIce=0.0
          ELSE
              nearIce=(sstRelax(i,j)+1.0)/3.0
          endif

          qrelflux= lambdaTheta*(sstFromOcn(i,j)-sstRelax(i,j))
     &            * (HeatCapacity_Cp*rhoNil*drF(1))*nearIce
C-    should use rhoConst instead of rhoNil:
c    &            * (HeatCapacity_Cp*rhoConst*drF(1))*nearIce

C         no longer restore on top of ice, but effectively full gridpoint UNDER ice
C         (unless gridpoint is fully ice covered)
          IF (iceMask(i,j,1,1) .LT. 0.999 _d 0) THEN
               qneto_2D(i,j)= qneto_2D(i,j) + qrelflux
     &                / (1. _d 0 - iceMask(i,j,1,1))
          ENDIF
C          qneto_2D(i,j)= qneto_2D(i,j) + qrelflux
C          qneti_2D(i,j)= qneti_2D(i,j) + qrelflux

          frelflux= -lambdaSalt*(sssFromOcn(i,j)-sssRelax(i,j))/
     &                  (convertFW2Salt *recip_drF(1))*nearIce

C         or use actual salt instead of convertFW2salt above?

          IF (frelflux .GT. 0. _d 0) THEN
            evapo_2D(i,j)= evapo_2D(i,j) - frelflux
C           note most of the time, evapi=0 when iceMask>0 anyway
C           (i.e., only when relaxing SST >2 but ocn still ice-covered)
            IF (iceMask(i,j,1,1).GT.0. _d 0)
     &            evapi_2D(i,j)= evapi_2D(i,j) - frelflux
          ELSE
            precipo_2D(i,j)= precipo_2D(i,j) + frelflux
            IF (iceMask(i,j,1,1).GT.0. _d 0)
     &            precipi_2D(i,j)= precipi_2D(i,j) + frelflux
          ENDIF

C          IF (iceMask(i,j,1,1) .GT. 0. _d 0) THEN
C          PRINT *,'Frelflux',frelflux,precipi_2D(i,j),atm_precip(j+1)
C          ENDIF

C         Diagnostics
          sum_qrel(i,j)= sum_qrel(i,j) + qrelflux*dtatmo
          sum_frel(i,j)= sum_frel(i,j) + frelflux*dtatmo

          ENDIF
        ENDDO
      ENDDO
      ENDIF

C      PRINT *,'***bottom of relaxadd',wght0,wght1,intime0,intime1
C      PRINT *,'evapo_2d: ',evapo_2D(JBUGI,JBUGJ)
C      PRINT *,'precipo_2d: ',precipo_2D(JBUGI,JBUGJ)
C      PRINT *,'qneto_2d: ',qneto_2D(JBUGI,JBUGJ)
C      PRINT *,'SStfrom Ocn: ',sstfromocn(JBUGI,JBUGJ)
C      PRINT *,'SSSfrom Ocn: ',sssfromocn(JBUGI,JBUGJ)

      RETURN
      END

#include "THSICE_OPTIONS.h"

CBOP
C     !ROUTINE: THSICE_DO_EXCH
C     !INTERFACE:
      SUBROUTINE THSICE_DO_EXCH( myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE THSICE_DO_EXCH
C     | o Apply Exchanges to THSICE variables when necessary
C     *==========================================================*
C     \ev
C     !USES:
      IMPLICIT NONE

C     === Global variables ===
#include "EEPARAMS.h"
#include "SIZE.h"
#include "PARAMS.h"
#include "THSICE_PARAMS.h"
#include "THSICE_VARS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     myThid ::  my thread Id number
      INTEGER myThid
CEOP

#ifdef ALLOW_THSICE
C     !LOCAL VARIABLES:

      CALL EXCH_XY_RL( iceMask, myThid )
      IF ( useSEAICE .OR. thSIceAdvScheme.GT.0 ) THEN
C--   Exchange fields that are advected by seaice dynamics
        CALL EXCH_XY_RL( iceHeight, myThid )
        CALL EXCH_XY_RL( snowHeight, myThid )
        CALL EXCH_XY_RL( Qice1, myThid )
        CALL EXCH_XY_RL( Qice2, myThid )
      ENDIF

#endif /* ALLOW_THSICE */

      RETURN
      END

#include "SEAICE_OPTIONS.h"
#ifdef ALLOW_AUTODIFF
# include "AUTODIFF_OPTIONS.h"
#endif

CBOP
C     !ROUTINE: SEAICE_READPARMS
C     !INTERFACE:
      SUBROUTINE SEAICE_READPARMS( myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R SEAICE_READPARMS
C     | o Routine to read in file data.seaice
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#ifdef ALLOW_GENERIC_ADVDIFF
# include "GAD.h"
#endif /* ALLOW_GENERIC_ADVDIFF */
#include "SEAICE_SIZE.h"
#include "SEAICE_PARAMS.h"
#include "SEAICE_TRACER.h"
#ifdef ALLOW_COST
# include "SEAICE_COST.h"
#endif
#ifdef ALLOW_MNC
# include "MNC_PARAMS.h"
#endif
#ifdef ALLOW_EXF
# include "EXF_CONSTANTS.h"
#endif /* ALLOW_EXF */
#ifdef ALLOW_AUTODIFF
# include "AUTODIFF_PARAMS.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
C     myThid     :: my Thread Id. number
      INTEGER myThid
CEOP

C     !LOCAL VARIABLES:
C     === Local variables ===
C     msgBuf     :: Informational/error message buffer
C     iUnit      :: Work variable for IO unit number
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      LOGICAL chkFlag
      INTEGER iUnit
      INTEGER l
#ifdef ALLOW_SITRACER
      INTEGER iTracer
#endif
#ifdef ALLOW_COST
      INTEGER locDate(4)
#endif /* ALLOW_COST */
      INTEGER nRetired, nError
      _RL tmp

C-    Old parameters (to be retired one day):
      _RL SEAICE_availHeatTaper
      _RL SEAICE_gamma_t, SEAICE_gamma_t_frz, SEAICE_availHeatFracFrz

C-    Retired parameters:
C     MAX_TICE          :: maximum ice temperature   (deg C)
C     LAD               :: time stepping used for sea-ice advection:
C                          1 = LEAPFROG,  2 = BACKWARD EULER.
C     SEAICE_freeze     :: FREEZING TEMP. OF SEA WATER
C     SEAICEuseMetricTerms :: replaced by SEAICEselectMetricTerms
      _RL SEAICE_sensHeat, SEAICE_latentWater, SEAICE_latentIce
      _RL SEAICE_salinity, SIsalFRAC, SIsal0
      _RL SEAICE_lhSublim, SEAICE_freeze, MAX_HEFF
      _RL areaMin, areaMax, A22, hiceMin, MAX_TICE
      LOGICAL SEAICEadvAge
      LOGICAL SEAICEuseMetricTerms
      INTEGER SEAICEadvSchAge, LAD, SEAICEturbFluxFormula
      INTEGER NPSEUDOTIMESTEPS, SOLV_MAX_ITERS
      INTEGER SEAICEnewtonIterMax, SEAICEkrylovIterMax
      _RL JFNKgamma_nonlin
      _RL SEAICEdiffKhAge
      CHARACTER*(MAX_LEN_MBUF) IceAgeFile, IceAgeTrFile(4)
      _RL SEAICE_abEps
      LOGICAL SEAICEuseAB2
#ifdef ALLOW_COST
C     former ALLOW_SEAICE_COST_SMR_AREA related flags
      _RL  mult_smrarea
      _RL  mult_smrsst
      _RL  mult_smrsss
      CHARACTER*(MAX_LEN_FNAM) smrarea_errfile
      CHARACTER*(MAX_LEN_FNAM) smrareadatfile
      CHARACTER*(MAX_LEN_FNAM) smrareabarfile
      CHARACTER*(MAX_LEN_FNAM) smrsstbarfile
      CHARACTER*(MAX_LEN_FNAM) smrsssbarfile
      INTEGER smrareastartdate1
      INTEGER smrareastartdate2
      _RL wsmrarea0
      _RL wmean_smrarea
      _RL smrareaperiod
      _RL SEAICE_clamp_salt
      _RL SEAICE_clamp_theta
#endif /* ALLOW_COST */
      _RL SEAICE_taveFreq
      LOGICAL SEAICE_tave_mnc

C--   SEAICE parameters
      NAMELIST /SEAICE_PARM01/
     & SEAICEuseDYNAMICS, SEAICEuseFREEDRIFT, SEAICEuseStrImpCpl,
     & SEAICEuseMCS, SEAICEuseMCE, SEAICEuseTD, SEAICEusePL,
     & SEAICEuseTEM, SEAICEuseTilt,
     & SEAICEuseMetricTerms, SEAICEselectMetricTerms,
     & useHB87stressCoupling, SEAICEupdateOceanStress,
     & usePW79thermodynamics, useMaykutSatVapPoly, SEAICEuseFlooding,
     & SEAICErestoreUnderIce, SEAICE_growMeltByConv,
     & SEAICE_salinityTracer, SEAICE_ageTracer,
     & SEAICEadvHeff, SEAICEadvArea, SEAICEadvSnow,
     & SEAICEadvSalt, SEAICEadvAge, SEAICEaddSnowMass,
     & SEAICEmomAdvection, SEAICEselectKEscheme, SEAICEselectVortScheme,
     & SEAICEhighOrderVorticity, SEAICEupwindVorticity,
     & SEAICEuseAbsVorticity, SEAICEuseJamartMomAdv,
     & SEAICE_clipVelocities, SEAICE_maskRHS,
     & SEAICE_no_slip, SEAICE_2ndOrderBC,
     & SEAICEetaZmethod, LAD, IMAX_TICE, postSolvTempIter,
     & SEAICEuseFluxForm, SEAICEadvScheme, SEAICEadvSchArea,
     & SEAICEadvSchHeff, SEAICEadvSchSnow,
     & SEAICEadvSchSalt, SEAICEadvSchAge,
     & SEAICEdiffKhHeff, SEAICEdiffKhSnow, SEAICEdiffKhArea,
     & SEAICEdiffKhSalt, SEAICEdiffKhAge, DIFF1,
     & SEAICE_deltaTtherm, SEAICE_deltaTdyn,
     & SEAICE_LSRrelaxU, SEAICE_LSRrelaxV,
     & SOLV_MAX_ITERS, SOLV_NCHECK, NPSEUDOTIMESTEPS,
     & LSR_ERROR, LSR_mixIniGuess, SEAICEuseMultiTileSolver,
     & SEAICE_deltaTevp, SEAICE_elasticParm, SEAICE_evpTauRelax,
     & SEAICE_evpDampC, SEAICEnEVPstarSteps,
     & SEAICE_evpAlpha, SEAICE_evpBeta,
     & SEAICEaEVPcoeff, SEAICEaEVPcStar, SEAICEaEVPalphaMin,
     & SEAICE_evpAreaReg,
     & SEAICE_zetaMin, SEAICE_zetaMaxFac, SEAICEusePicardAsPrecon,
     & SEAICEuseLSRflex, SEAICEuseKrylov, SEAICEuseJFNK,
     & SEAICEnonLinIterMax, SEAICElinearIterMax, SEAICEnonLinTol,
     & SEAICEnewtonIterMax, SEAICEkrylovIterMax, JFNKgamma_nonlin,
     & SEAICEpreconNL_Iter, SEAICEpreconLinIter,
     & SEAICE_JFNK_lsIter, SEAICE_JFNK_lsLmax, SEAICE_JFNK_lsGamma,
     & SEAICE_JFNK_tolIter, JFNKres_t,JFNKres_tFac,
     & JFNKgamma_lin_min,JFNKgamma_lin_max,
     & SEAICE_JFNKepsilon, SEAICE_OLx, SEAICE_OLy,
     & SEAICE_JFNKphi, SEAICE_JFNKalpha, SEAICEuseIMEX, SEAICEuseBDF2,
     & SEAICEuseLinRemapITD,
     & useHibler79IceStrength, SEAICEpartFunc, SEAICEredistFunc,
     & SEAICEridgingIterMax, SEAICEsimpleRidging, SEAICEsnowFracRidge,
     & SEAICEgStar, SEAICEhStar, SEAICEaStar, SEAICEshearParm,
     & SEAICEmuRidging, SEAICEmaxRaft, SEAICE_cf,
     & SEAICEuseAB2, SEAICE_abEps,
     & SEAICEpresH0, SEAICEpresPow0, SEAICEpresPow1,
     & SEAICE_initialHEFF, SEAICEturbFluxFormula,
     & SEAICE_areaGainFormula, SEAICE_areaLossFormula,
     & SEAICE_doOpenWaterGrowth, SEAICE_doOpenWaterMelt,
     & SEAICE_rhoAir, SEAICE_rhoIce, SEAICE_rhoSnow, ICE2WATR,
     & SEAICE_cpAir, SEAICEscaleSurfStress,
     & SEAICE_drag, SEAICE_waterDrag, SEAICEdWatMin, SEAICE_dryIceAlb,
     & SEAICE_wetIceAlb, SEAICE_drySnowAlb, SEAICE_wetSnowAlb, HO,
     & SEAICE_drag_south, SEAICE_waterDrag_south,
     & SEAICE_dryIceAlb_south, SEAICE_wetIceAlb_south,
     & SEAICE_drySnowAlb_south, SEAICE_wetSnowAlb_south, HO_south,
     & SEAICEsideDrag, uCoastLineFile, vCoastLineFile,
     & SEAICE_cBasalStar, SEAICEbasalDragU0, SEAICEbasalDragK1,
     & SEAICEbasalDragK2, SEAICE_wetAlbTemp, SEAICE_waterAlbedo,
     & SEAICE_strength, SEAICE_cStar, SEAICE_eccen,
     & SEAICE_eccfr, SEAICEtdMU, SEAICEmcMu,
     & SEAICEpressReplFac, SEAICE_tensilFac, SEAICE_tensilDepth,
     & SEAICE_lhFusion, SEAICE_lhEvap, SEAICE_dalton,
     & SEAICE_sensHeat, SEAICE_latentWater, SEAICE_latentIce,
     & SEAICE_salinity, SIsalFRAC, SIsal0,
     & areaMin, areaMax, A22, hiceMin,
     & SEAICE_iceConduct, SEAICE_snowConduct,
     & SEAICE_emissivity, SEAICE_ice_emiss, SEAICE_snow_emiss,
     & SEAICE_snowThick, SEAICE_shortwave, SEAICE_freeze, OCEAN_drag,
     & SEAICE_tempFrz0, SEAICE_dTempFrz_dS, SEAICE_salt0,
     & SEAICE_saltFrac, SEAICEstressFactor, SEAICE_availHeatTaper,
     & SEAICE_mcPheePiston, SEAICE_frazilFrac, SEAICE_mcPheeTaper,
     & SEAICE_mcPheeStepFunc, SEAICE_gamma_t, SEAICE_gamma_t_frz,
     & SEAICE_availHeatFrac, SEAICE_availHeatFracFrz, SEAICE_PDF,
     & AreaFile, HeffFile, uIceFile, vIceFile, HsnowFile, HsaltFile,
     & SEAICEheatConsFix, SEAICE_multDim, SEAICE_useMultDimSnow,
     & SEAICE_deltaMin, SEAICE_area_reg, SEAICE_hice_reg,
     & SEAICE_area_floor, SEAICE_area_max, SEAICE_tauAreaObsRelax,
     & SEAICE_airTurnAngle, SEAICE_waterTurnAngle,
     & MAX_HEFF, MIN_ATEMP, MIN_LWDOWN, MAX_TICE, MIN_TICE,
     & SEAICE_EPS, SEAICE_EPS_SQ,
     & SEAICEwriteState, SEAICEuseEVPpickup,
     & SEAICEuseEVPstar, SEAICEuseEVPrev,
     & SEAICE_monFreq, SEAICE_dumpFreq, SEAICE_taveFreq,
     & SEAICE_tave_mnc, SEAICE_dump_mnc, SEAICE_mon_mnc,
#ifdef SEAICE_ITD
     & Hlimit_c1, Hlimit_c2, Hlimit_c3, Hlimit,
#endif
     & SEAICE_debugPointI, SEAICE_debugPointJ,
     & SINegFac

#ifdef ALLOW_COST
      NAMELIST /SEAICE_PARM02/
     &          mult_ice_export, mult_ice, cost_ice_flag,
     &          costIceStart1, costIceStart2,
     &          costIceEnd1, costIceEnd2,
     &          SEAICE_cutoff_area, SEAICE_cutoff_heff,
     &          SEAICE_clamp_salt, SEAICE_clamp_theta,
     &          mult_smrsst, smrsstbarfile,
     &          mult_smrsss, smrsssbarfile,
     &          mult_smrarea, smrareabarfile, smrareadatfile,
     &          wsmrarea0, wmean_smrarea, smrarea_errfile,
     &          smrareastartdate1, smrareastartdate2, smrareaperiod
#endif

#ifdef ALLOW_SITRACER
      NAMELIST /SEAICE_PARM03/
     &  SItrFile, SItrName, SItrNameLong, SItrUnit, SItrMate,
     &  SItrFromOcean0, SItrFromOceanFrac, SItrFromFlood0,
     &  SItrFromFloodFrac, SItrExpand0,
     &  IceAgeTrFile, SItrNumInUse
#endif

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      IF ( .NOT.useSEAICE ) THEN
C-    pkg SEAICE is not used
        _BEGIN_MASTER(myThid)
C-    Track pkg activation status:
C     print a (weak) warning if data.seaice is found
         CALL PACKAGES_UNUSED_MSG( 'useSEAICE', ' ', ' ' )
        _END_MASTER(myThid)
        RETURN
      ENDIF

      _BEGIN_MASTER(myThid)

C--   set default sea ice parameters
#if ( defined SEAICE_CGRID || defined SEAICE_BGRID_DYNAMICS )
      SEAICEuseDYNAMICS  = .TRUE.
#else
      SEAICEuseDYNAMICS  = .FALSE.
#endif
      SEAICEadjMODE      = 0
      SEAICEuseFREEDRIFT = .FALSE.
      SEAICEuseStrImpCpl = .FALSE.
      SEAICEuseTilt      = .TRUE.
      SEAICEheatConsFix  = .FALSE.
      SEAICEuseTEM       = .FALSE.
      SEAICEuseMCS       = .FALSE.
      SEAICEuseMCE       = .FALSE.
      SEAICEuseTD        = .FALSE.
      SEAICEusePL        = .FALSE.
      SEAICEuseMetricTerms = .TRUE.
      SEAICEselectMetricTerms = UNSET_I
      SEAICEuseEVPpickup = .TRUE.
      SEAICEuseEVPstar   = .TRUE.
      SEAICEuseEVPrev    = .TRUE.
      SEAICErestoreUnderIce = .FALSE.
      SEAICE_growMeltByConv = .FALSE.
      SEAICE_salinityTracer = .FALSE.
      SEAICE_ageTracer      = .FALSE.
      useHB87stressCoupling = .FALSE.
      SEAICEupdateOceanStress = .TRUE.
      SEAICEscaleSurfStress = .TRUE.
      SEAICEaddSnowMass     = .TRUE.
      usePW79thermodynamics = .TRUE.
C     start of ridging parameters
      useHibler79IceStrength= .TRUE.
      SEAICEsimpleRidging   = .TRUE.
C     The range of this proportionality constant is 2 to 17
      SEAICE_cf             = 17. _d 0
C     By default use partition function of Thorndyke et al. (1975) ...
      SEAICEpartFunc        = 0
C     and redistribution function of Hibler (1980)
      SEAICEredistFunc      = 0
      SEAICEridgingIterMax  = 10
C     This parameter is not well constraint (Lipscomb et al. 2007)
      SEAICEshearParm       = 0.5 _d 0
C     Thorndyke et al. (1975)
      SEAICEgStar           = 0.15 _d 0
C     suggested by Hibler (1980), Flato and Hibler (1995)
C     SEAICEhStar           = 100. _d 0
C     but this value of 25 seems to give thinner ridges in better agreement
C     with observations (according to Lipscomb et al 2007)
      SEAICEhStar           =  25. _d 0
C     according to Lipscomb et al. (2007) these values for aStar and mu
C     are approximately equivalent to gStar=0.15 (aStar = gStar/3) for
C     SEAICEpartFunc = 1 ...
      SEAICEaStar           = 0.05 _d 0
C     ... and hStar=25 for SEAICEredistFunc = 1
C     Libscomb et al. (2007): mu =  3,  4,  5,   6
C     correspond to        hStar = 25, 50, 75, 100
      SEAICEmuRidging       = 3. _d 0
      SEAICEmaxRaft         = 1. _d 0
      SEAICEsnowFracRidge   = 0.5 _d 0
      SEAICEuseLinRemapITD  = .TRUE.
C     end ridging parampeters
      useMaykutSatVapPoly = .FALSE.
      SEAICEuseFluxForm  = .TRUE.
      SEAICEadvHeff      = .TRUE.
      SEAICEadvArea      = .TRUE.
      SEAICEadvSnow      = .TRUE.
#ifdef SEAICE_VARIABLE_SALINITY
      SEAICEadvSalt      = .TRUE.
#else
      SEAICEadvSalt      = .FALSE.
#endif
      SEAICEmomAdvection       = .FALSE.
      SEAICEselectKEscheme     = 1
      SEAICEselectVortScheme   = 2
      SEAICEhighOrderVorticity = .FALSE.
      SEAICEupwindVorticity    = .FALSE.
      SEAICEuseAbsVorticity    = .FALSE.
      SEAICEuseJamartMomAdv    = .FALSE.
      SEAICEuseFlooding  = .TRUE.
      SEAICE_no_slip     = .FALSE.
      SEAICE_2ndOrderBC  = .FALSE.
      SEAICE_clipVelocities = .FALSE.
      SEAICE_maskRHS     = .FALSE.
      SEAICEetaZmethod   = 3
      SEAICEadvScheme    = 77
      SEAICEadvSchArea   = UNSET_I
      SEAICEadvSchHeff   = UNSET_I
      SEAICEadvSchSnow   = UNSET_I
      SEAICEadvSchSalt   = UNSET_I
      SEAICEdiffKhArea   = UNSET_RL
      SEAICEdiffKhHeff   = UNSET_RL
      SEAICEdiffKhSnow   = UNSET_RL
      SEAICEdiffKhSalt   = UNSET_RL
      DIFF1      = UNSET_RL
C--   old DIFF1 default:
c     DIFF1      = .004 _d 0
      SEAICE_deltaTtherm = dTtracerLev(1)
      SEAICE_deltaTdyn   = dTtracerLev(1)
      SEAICE_deltaTevp   = UNSET_RL
      SEAICEuseBDF2      = .FALSE.
      SEAICEuseKrylov    = .FALSE.
      SEAICEuseLSRflex   = .FALSE.
C     JFNK stuff
      SEAICEuseJFNK       = .FALSE.
      SEAICEuseIMEX       = .FALSE.
      SEAICE_JFNK_lsIter  = UNSET_I
      SEAICE_JFNK_lsLmax  = 4
      SEAICE_JFNK_lsGamma = 0.5 _d 0
      SEAICE_JFNK_tolIter = 100
C     This should be the default for both JFNK and for LSR but in order
C     to not jeopardize any existing results, and because it does not yet
C     work for llc/cubed-sphere topologies, we require that the user knows
C     what he/she is doing when turning this on.
      SEAICE_OLx          = OLx-2
      SEAICE_OLy          = OLy-2
      JFNKgamma_nonlin    = 1. _d -05
      JFNKgamma_lin_min   = 0.10 _d 0
      JFNKgamma_lin_max   = 0.99 _d 0
      JFNKres_t           = UNSET_RL
      JFNKres_tFac        = UNSET_RL
      SEAICE_JFNKepsilon  = 1. _d -06
C     factor for inexact Newton forcing, .gt. 0 and .le. 1
      SEAICE_JFNKphi      = 1. _d 0
C     exponent for inexact Newton forcing .gt. 1 and .le. 2
      SEAICE_JFNKalpha    = 1. _d 0
C     Hunke, JCP, 2001 use 615 kg/m^2 for this, but does not recommend using it
      SEAICE_evpDampC    = -1. _d 0
      SEAICE_zetaMin     = 0. _d 0
      SEAICE_zetaMaxFac  = 2.5 _d 8
      SEAICEpresH0       = 1. _d 0
      SEAICEpresPow0     = 1
      SEAICEpresPow1     = 1
      SEAICE_evpTauRelax = -1. _d 0
      SEAICE_elasticParm = 0.33333333333333333333333333 _d 0
      SEAICE_evpAlpha    = UNSET_RL
      SEAICE_evpBeta     = UNSET_RL
      SEAICEnEVPstarSteps = UNSET_I
      SEAICEaEVPcoeff    = UNSET_RL
      SEAICEaEVPcStar    = UNSET_RL
      SEAICEaEVPalphaMin = UNSET_RL
      SEAICE_evpAreaReg  = -1.
      SEAICE_initialHEFF = ZERO
#ifdef SEAICE_ITD
C     Coefficients used to calculate sea ice thickness category limits
C     after Lipscomb et al. (2001, JGR), Equ. 22
C     choose between
C      - original parameters of Lipscomb et al. (2001):
C        c1=3.0/N, c2=15*c1, c3=3.0
C      - and a higher resolution of thin end of ITD:
C        c1=1.5/N, c2=42*c1, c3=3.3
      DO l = 0, nITD
       Hlimit(l) = UNSET_RL
      ENDDO
      Hlimit_c1          = 3.0
      Hlimit_c2          = 15.
      Hlimit_c3          = 3.0
#endif
      SEAICE_rhoIce      = 0.91   _d +03
      SEAICE_rhoSnow     = 330.   _d 0
      ICE2WATR           = UNSET_RL
      SEAICE_drag        = 0.001  _d 0
      OCEAN_drag         = 0.001  _d 0
      SEAICE_waterDrag   = 0.0055 _d 0
      SEAICEsideDrag     = 0.0    _d 0
      SEAICEdWatMin      = 0.25   _d 0
      SEAICE_dryIceAlb   = 0.75   _d 0
      SEAICE_wetIceAlb   = 0.66   _d 0
      SEAICE_drySnowAlb  = 0.84   _d 0
      SEAICE_wetSnowAlb  = 0.7    _d 0
      HO                 = 0.5    _d 0
      SEAICE_drag_south       = UNSET_RL
      SEAICE_waterDrag_south  = UNSET_RL
      SEAICE_dryIceAlb_south  = UNSET_RL
      SEAICE_wetIceAlb_south  = UNSET_RL
      SEAICE_drySnowAlb_south = UNSET_RL
      SEAICE_wetSnowAlb_south = UNSET_RL
      HO_south                = UNSET_RL
C     basal drag parameters following Lemieux et al. (2015)
      SEAICE_cBasalStar = UNSET_RL
      SEAICEbasalDragU0 =  5. _d -05
      SEAICEbasalDragK1 =  8. _d 0
      SEAICEbasalDragK2 =  0. _d 0
C     Lemieux et al. (2015) recommend: SEAICEbasalDragK2 = 15. _d 0
C
      SEAICE_wetAlbTemp  = -1. _d -3
#ifdef SEAICE_EXTERNAL_FLUXES
      SEAICE_waterAlbedo = UNSET_RL
#else /* if undef SEAICE_EXTERNAL_FLUXES */
      SEAICE_waterAlbedo = 0.1    _d +00
#endif /* SEAICE_EXTERNAL_FLUXES */
      SEAICE_strength    = 2.75   _d +04
      SEAICE_cStar       = 20.    _d 0
      SEAICEpressReplFac = 1.     _d 0
      SEAICE_eccen       = 2.     _d 0
      SEAICE_eccfr       = UNSET_RL
      SEAICE_tensilFac   = 0.     _d 0
      SEAICE_tensilDepth = 0.     _d 0
      SEAICEtdMU         = 1.     _d 0
      SEAICEmcMu         = 1.     _d 0
C     coefficients for flux computations/bulk formulae
      SEAICE_dalton      = 1.75   _d -03
#ifdef ALLOW_EXF
      IF ( useEXF ) THEN
C     Use parameters that have already been set in data.exf
C     to be consistent
       SEAICE_rhoAir     = atmrho
       SEAICE_cpAir      = atmcp
       SEAICE_lhEvap     = flamb
       SEAICE_lhFusion   = flami
       SEAICE_boltzmann  = stefanBoltzmann
       SEAICE_emissivity = ocean_emissivity
       SEAICE_ice_emiss  = ice_emissivity
       SEAICE_snow_emiss = snow_emissivity
      ELSE
#else
      IF ( .TRUE. ) THEN
#endif /* ALLOW_EXF */
       SEAICE_rhoAir     = 1.3    _d 0
       SEAICE_cpAir      = 1004.  _d 0
       SEAICE_lhEvap     = 2.50   _d 6
       SEAICE_lhFusion   = 3.34   _d 5
       SEAICE_boltzmann  = 5.670  _d -08
C     old default value of 0.97001763668430343479
       SEAICE_emissivity = 5.5    _d -08/5.670 _d -08
       SEAICE_ice_emiss  = SEAICE_emissivity
       SEAICE_snow_emiss = SEAICE_emissivity
      ENDIF
      SEAICE_iceConduct  = 2.1656 _d +00
      SEAICE_snowConduct = 3.1    _d -01
      SEAICE_snowThick   = 0.15   _d 0
      SEAICE_shortwave   = 0.30   _d 0
      SEAICE_salt0       = 0.0    _d 0
      SEAICE_saltFrac    = 0.0    _d 0
#ifdef SEAICE_ITD
C in case defined(SEAICE_ITD) MULTDIM = nITD (see SEAICE_SIZE.h)
c      SEAICE_multDim     = MULTDIM
C the switch MULTICATEGORY (and with it parameter MULTDIM) has been retired
C  and SEAICE_multDim is now a runtime parameter;
C  in case SEAICE_multDim is given in data.seaice it needs to be overwritten
C  after PARM01 was read (see below)
      SEAICE_multDim     = nITD
      SEAICE_PDF(1)     = 1. _d 0
      DO l=2,nITD
       SEAICE_PDF(l)     = 0. _d 0
      ENDDO
#else
      SEAICE_multDim     = 1
      DO l=1,nITD
       SEAICE_PDF(l)     = UNSET_RL
      ENDDO
#endif
      SEAICE_useMultDimSnow = .TRUE.
C     default to be set later (ocean-seaice turbulent flux coeff):
      SEAICE_mcPheeStepFunc = .FALSE.
      SEAICE_mcPheeTaper    = UNSET_RL
      SEAICE_availHeatTaper = UNSET_RL
      SEAICE_mcPheePiston   = UNSET_RL
      SEAICE_frazilFrac     = UNSET_RL
      SEAICE_gamma_t        = UNSET_RL
      SEAICE_gamma_t_frz    = UNSET_RL
      SEAICE_availHeatFrac  = UNSET_RL
      SEAICE_availHeatFracFrz = UNSET_RL
      SEAICE_doOpenWaterGrowth=.TRUE.
      SEAICE_doOpenWaterMelt=.FALSE.
      SEAICE_areaLossFormula=1
      SEAICE_areaGainFormula=1
      SEAICE_tempFrz0    = 0.0901 _d 0
      SEAICE_dTempFrz_dS = -0.0575 _d 0
C     old default for constant freezing point
c     SEAICE_tempFrz0    = -1.96 _d 0
c     SEAICE_dTempFrz_dS = 0. _d 0
      SEAICEstressFactor = 1.     _d 0
      SEAICE_tauAreaObsRelax = -999. _d 0
      AreaFile   = ' '
      HsnowFile  = ' '
      HsaltFile  = ' '
      HeffFile   = ' '
      uIceFile   = ' '
      vIceFile   = ' '
      uCoastLineFile = ' '
      vCoastLineFile = ' '
      IMAX_TICE  = 10
      postSolvTempIter = 2
C     LSR parameters
      SEAICEuseLSR = .TRUE.
      SEAICEusePicardAsPrecon = .FALSE.
      SEAICE_LSRrelaxU = 0.95 _d 0
      SEAICE_LSRrelaxV = 0.95 _d 0
      SOLV_NCHECK= 2
      SEAICEnonLinIterMax = UNSET_I
      SEAICElinearIterMax = UNSET_I
      SEAICEpreconNL_Iter =  0
      SEAICEpreconLinIter = 10
#ifdef SEAICE_ALLOW_FREEDRIFT
      LSR_mixIniGuess =  0
#else
      LSR_mixIniGuess = -1
#endif
      LSR_ERROR  = 0.00001    _d 0
      SEAICEuseMultiTileSolver = .FALSE.

      SEAICE_area_floor = siEPS
      SEAICE_area_reg   = siEPS
      SEAICE_hice_reg   = 0.05 _d 0
      SEAICE_area_max   = 1.00 _d 0

      SEAICE_airTurnAngle   = 0.0 _d 0
      SEAICE_waterTurnAngle = 0.0 _d 0
      MIN_ATEMP         = -50.    _d 0
      MIN_LWDOWN        = 60.     _d 0
      MIN_TICE          = -50.    _d 0
      SEAICE_deltaMin   = UNSET_RL
      SEAICE_EPS        = 1.      _d -10
      SEAICE_EPS_SQ     = -99999.

      SEAICEwriteState  = .FALSE.
      SEAICE_monFreq    = monitorFreq
      SEAICE_dumpFreq   = dumpFreq
#ifdef ALLOW_MNC
      SEAICE_dump_mnc = snapshot_mnc
      SEAICE_mon_mnc  = monitor_mnc
#else
      SEAICE_dump_mnc = .FALSE.
      SEAICE_mon_mnc  = .FALSE.
#endif
      SEAICE_debugPointI = UNSET_I
      SEAICE_debugPointJ = UNSET_I
      SINegFac = 1. _d 0
C-    Retired parameters:
c     LAD        = 2
      LAD        = UNSET_I
      NPSEUDOTIMESTEPS   = UNSET_I
      SOLV_MAX_ITERS     = UNSET_I
      SEAICEnewtonIterMax= UNSET_I
      SEAICEkrylovIterMax= UNSET_I
      JFNKgamma_nonlin   = UNSET_RL
c     SEAICE_sensHeat    = 1.75 _d -03 * 1004 * 1.3
c     SEAICE_sensHeat    = 2.284  _d +00
      SEAICE_sensHeat    = UNSET_RL
c     SEAICE_latentWater = 1.75 _d -03 * 2.500 _d 06 * 1.3
c     SEAICE_latentWater = 5.6875 _d +03
      SEAICE_latentWater = UNSET_RL
c     SEAICE_latentIce   = 1.75 _d -03 * 2.834 _d 06 * 1.3
c     SEAICE_latentIce   = 6.4474 _d +03
      SEAICE_latentIce   = UNSET_RL
      SEAICE_salinity    = UNSET_RL
      SIsalFRAC          = UNSET_RL
      SIsal0             = UNSET_RL
      IceAgeFile         = ' '
c     MAX_TICE           = 30.     _d 0
      MAX_TICE           = UNSET_RL
      areaMin            = UNSET_RL
      hiceMin            = UNSET_RL
      A22                = UNSET_RL
      areaMax            = UNSET_RL
      SEAICE_lhSublim    = UNSET_RL
      SEAICEadvAge       = .TRUE.
      SEAICEadvSchAge    = UNSET_I
      SEAICEdiffKhAge    = UNSET_RL
      IceAgeTrFile(1)    = ' '
      IceAgeTrFile(2)    = ' '
      IceAgeTrFile(3)    = ' '
      IceAgeTrFile(4)    = ' '
      SEAICEturbFluxFormula =UNSET_I
      SEAICE_freeze      = UNSET_RL
      MAX_HEFF           = UNSET_RL
      SEAICEuseAB2       = .FALSE.
      SEAICE_abEps       = UNSET_RL
      SEAICE_taveFreq    = UNSET_RL
      SEAICE_tave_mnc    = .FALSE.
C-    end retired parameters

#ifdef ALLOW_COST
      locDate(1) = 0
      locDate(2) = 0
# ifdef ALLOW_CAL
      CALL CAL_GETDATE( -1, startTime, locDate, myThid )
# endif /* ALLOW_CAL */
      mult_ice_export   =  0. _d 0
      mult_ice          =  0. _d 0
      costIceStart1     = locDate(1)
      costIceStart2     = locDate(2)
      costIceEnd1       =  0
      costIceEnd2       =  0
      cost_ice_flag     =  1
      SEAICE_cutoff_area = 0.0001 _d 0
      SEAICE_cutoff_heff = 0. _d 0
C     retired cost related parameters
      SEAICE_clamp_salt  = UNSET_RL
      SEAICE_clamp_theta = UNSET_RL
      mult_smrsst       =  UNSET_RL
      mult_smrsss       =  UNSET_RL
      mult_smrarea      =  UNSET_RL
      wsmrarea0         =  UNSET_RL
      wmean_smrarea     =  UNSET_RL
      smrsstbarfile     =  ' '
      smrsssbarfile     =  ' '
      smrareabarfile    =  ' '
      smrareadatfile    =  ' '
      smrarea_errfile   =  ' '
      smrareastartdate1 = UNSET_I
      smrareastartdate2 = UNSET_I
#endif /* ALLOW_COST */

#ifdef ALLOW_SITRACER
      SItrNumInUse=SItrMaxNum
      DO iTracer = 1, SItrMaxNum
       SItrFile(iTracer) = ' '
       SItrName(iTracer) = ' '
       SItrNameLong(iTracer) = ' '
       SItrUnit(iTracer) = ' '
       SItrMate(iTracer) = 'HEFF'
       SItrFromOcean0(iTracer)    = ZERO
       SItrFromOceanFrac(iTracer) = ZERO
       SItrFromFlood0(iTracer)    = ZERO
       SItrFromFloodFrac(iTracer) = ZERO
       SItrExpand0(iTracer)       = ZERO
      ENDDO
#endif /* ALLOW_SITRACER */
      nRetired = 0
      nError   = 0

C     Open and read the data.seaice file
      WRITE(msgBuf,'(A)')
     &' '
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT , myThid)
      WRITE(msgBuf,'(A)') ' SEAICE_READPARMS: opening data.seaice'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT , myThid)

      CALL OPEN_COPY_DATA_FILE(
     I                          'data.seaice', 'SEAICE_READPARMS',
     O                          iUnit,
     I                          myThid )

C--   Read settings from model parameter file "data.seaice".
      READ(UNIT=iUnit,NML=SEAICE_PARM01)

#ifdef ALLOW_COST
      READ(UNIT=iUnit,NML=SEAICE_PARM02)
#endif /* ALLOW_COST */

#ifdef ALLOW_SITRACER
      READ(UNIT=iUnit,NML=SEAICE_PARM03)
#endif /* ALLOW_SITRACER */

#ifdef SINGLE_DISK_IO
      CLOSE(iUnit)
#else
      CLOSE(iUnit,STATUS='DELETE')
#endif /* SINGLE_DISK_IO */

#ifdef SEAICE_ITD
C SEAICE_multDim has become a runtime parameter but if SEAICE_ITD is defined
C  it needs to equal nITD because of shared code (mostly in seaice_growth.F).
C nITD is set in SEAICE_SIZE.h
      SEAICE_multDim     = nITD
#endif

      WRITE(msgBuf,'(A)')
     &     ' SEAICE_READPARMS: finished reading data.seaice'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT , myThid)

C--   Set default values (if not specified in data.seaice namelist)

C--   Default for regularizing Delta to remain backward compatible
      IF ( SEAICE_deltaMin .EQ. UNSET_RL ) SEAICE_deltaMin = SEAICE_EPS
C--   Default is to have a normal flow rule if SEAICE_eccfr is not set
      IF (SEAICE_eccfr .EQ. UNSET_RL ) SEAICE_eccfr = SEAICE_eccen

C--   If no PDF was prescribed use the default uniform pdf
      tmp = SEAICE_multDim
      DO l = 1, SEAICE_multDim
       IF (SEAICE_PDF(l).EQ.UNSET_RL) SEAICE_PDF(l) = ONE/tmp
      ENDDO
      DO l = SEAICE_multDim+1, nITD
       IF (SEAICE_PDF(l).EQ.UNSET_RL) SEAICE_PDF(l) = 0. _d 0
      ENDDO

      IF (ICE2WATR.EQ.UNSET_RL) ICE2WATR = SEAICE_rhoIce*recip_rhoConst
      IF (SEAICE_drag_south       .EQ. UNSET_RL)
     &    SEAICE_drag_south       = SEAICE_drag
      IF (SEAICE_waterDrag_south  .EQ. UNSET_RL)
     &    SEAICE_waterDrag_south  = SEAICE_waterDrag
      IF (SEAICE_dryIceAlb_south  .EQ. UNSET_RL)
     &    SEAICE_dryIceAlb_south  = SEAICE_dryIceAlb
      IF (SEAICE_wetIceAlb_south  .EQ. UNSET_RL)
     &    SEAICE_wetIceAlb_south  = SEAICE_wetIceAlb
      IF (SEAICE_drySnowAlb_south .EQ. UNSET_RL)
     &    SEAICE_drySnowAlb_south = SEAICE_drySnowAlb
      IF (SEAICE_wetSnowAlb_south .EQ. UNSET_RL)
     &    SEAICE_wetSnowAlb_south = SEAICE_wetSnowAlb
      IF (HO_south                .EQ. UNSET_RL)
     &    HO_south                = HO
C     Basal drag parameter
      IF (SEAICE_cBasalStar .EQ. UNSET_RL)
     &     SEAICE_cBasalStar = SEAICE_cStar

C     Check that requested time step size is supported.  The combination
C     below is the only one that is supported at this time.  Does not
C     mean that something fancier will not work, just that it has not
C     yet been tried nor thought through.
      IF ( SEAICE_deltaTtherm .NE. dTtracerLev(1)     .OR.
     &     SEAICE_deltaTdyn   .LT. SEAICE_deltaTtherm .OR.
     &     (SEAICE_deltaTdyn/SEAICE_deltaTtherm) .NE.
     &     INT(SEAICE_deltaTdyn/SEAICE_deltaTtherm) ) THEN
         WRITE(msgBuf,'(A)')
     &        'Unsupported combination of SEAICE_deltaTtherm,'
         CALL PRINT_ERROR( msgBuf , myThid)
         WRITE(msgBuf,'(A)')
     &        ' SEAICE_deltaTdyn, and dTtracerLev(1)'
         CALL PRINT_ERROR( msgBuf , myThid)
         nError = nError + 1
      ENDIF
      SEAICEuseEVP = .FALSE.
#ifdef SEAICE_ALLOW_EVP
C     There are three ways to turn on EVP
C     1. original EVP (Hunke, 2001)
      IF ( SEAICE_deltaTevp .NE. UNSET_RL ) SEAICEuseEVP = .TRUE.
C     2. modified EVP (Lemieux et al., 2012) or revised EVP (Bouillon
C     et al., 2014) by setting alpha and beta
      IF ( SEAICE_evpAlpha  .NE. UNSET_RL
     &  .OR. SEAICE_evpBeta .NE. UNSET_RL ) SEAICEuseEVP = .TRUE.
C     3. adaptive EVP
      IF ( SEAICEaEVPcoeff  .NE. UNSET_RL ) SEAICEuseEVP = .TRUE.
C     if EVP is turned on, a couple of parameters need to be computed
      IF ( SEAICEuseEVP ) THEN
       IF (    (SEAICE_deltaTdyn/SEAICE_deltaTevp) .NE.
     &      INT(SEAICE_deltaTdyn/SEAICE_deltaTevp) .AND.
     &      .NOT. (SEAICEuseEVPstar.OR.SEAICEuseEVPrev) ) THEN
        WRITE(msgBuf,'(A)')
     &       'SEAICE_deltaTevp must be a factor of SEAICE_deltaTdyn.'
        CALL PRINT_ERROR( msgBuf , myThid)
        nError = nError + 1
       ENDIF
       IF ( SEAICE_elasticParm .LE. 0. _d 0 ) THEN
        WRITE(msgBuf,'(A)')
     &       'SEAICE_elasticParm must greater than 0.'
        CALL PRINT_ERROR( msgBuf , myThid)
        nError = nError + 1
       ENDIF
       IF ( SEAICE_evpTauRelax .LE. 0. _d 0 )
     &      SEAICE_evpTauRelax = SEAICE_deltaTdyn*SEAICE_elasticParm
C     determine number of internal steps
       IF ( SEAICEnEVPstarSteps.EQ.UNSET_I ) THEN
        IF ( SEAICE_deltaTevp.EQ.UNSET_RL ) THEN
         WRITE(msgBuf,'(A,A)') 'S/R SEAICE_readparms: Either ',
     &        'SEAICEnEVPstarSteps or SEAICE_deltaTevp need to be set.'
         CALL PRINT_ERROR( msgBuf , myThid)
         nError = nError + 1
        ELSE
         SEAICEnEVPstarSteps = INT(SEAICE_deltaTdyn/SEAICE_deltaTevp)
        ENDIF
       ENDIF
C     default: evpAlpha = evpBeta
       IF ( SEAICE_evpAlpha .NE. UNSET_RL .AND.
     &  SEAICE_evpBeta .EQ. UNSET_RL ) SEAICE_evpBeta = SEAICE_evpAlpha
       IF ( SEAICE_evpBeta .NE. UNSET_RL .AND.
     & SEAICE_evpAlpha .EQ. UNSET_RL ) SEAICE_evpAlpha = SEAICE_evpBeta
C     derive other parameters
       IF ( SEAICE_evpBeta .EQ. UNSET_RL ) THEN
        SEAICE_evpBeta   = SEAICE_deltaTdyn/SEAICE_deltaTevp
       ELSE
        SEAICE_deltaTevp = SEAICE_deltaTdyn/SEAICE_evpBeta
       ENDIF
       IF ( SEAICE_evpAlpha .EQ. UNSET_RL ) THEN
        SEAICE_evpAlpha = 2. _d 0 * SEAICE_evpTauRelax/SEAICE_deltaTevp
       ELSE
        SEAICE_evpTauRelax = 0.5 _d 0 *SEAICE_evpAlpha*SEAICE_deltaTevp
       ENDIF
C     this turns on adaptive EVP
       IF ( SEAICEaEVPcoeff .NE. UNSET_RL ) THEN
        IF ( SEAICEaEVPcStar  .EQ.UNSET_RL) SEAICEaEVPcStar   =4. _d 0
        IF (SEAICEaEVPalphaMin.EQ.UNSET_RL) SEAICEaEVPalphaMin=5. _d 0
C     requires EVP* to work well, so make sure we set it here (commented out
C     for now, but these values are the default values now)
CML        SEAICEuseEVPstar   = .TRUE.
CML        SEAICEuseEVPrev    = .TRUE.
C     For adaptive EVP we do not need constant parameters alpha and
C     beta, because they are computed dynamically. Reset them to
C     undefined here, so that we know if something funny is going on.
        SEAICE_evpAlpha     = UNSET_RL
        SEAICE_evpBeta      = UNSET_RL
       ENDIF
C     Check if all parameters are set.
      ENDIF
#endif /* SEAICE_ALLOW_EVP */

#ifdef SEAICE_ALLOW_FREEDRIFT
      IF ( SEAICEuseFREEDRIFT ) SEAICEuseEVP = .FALSE.
      IF ( SEAICEuseFREEDRIFT ) THEN
        WRITE(msgBuf,'(A,A)')
     &       'WARNING FROM S/R SEAICE_READPARMS:',
     &       ' switch seaice from LSR or EVP to "free drift"'
      CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                    SQUEEZE_RIGHT , myThid)
      ENDIF
#endif /* SEAICE_ALLOW_FREEDRIFT */

#ifndef SEAICE_ITD
      IF ( .NOT.useHibler79IceStrength ) THEN
       useHibler79IceStrength = .TRUE.
       WRITE(msgBuf,'(A,A)')
     &      'WARNING FROM S/R SEAICE_READPARMS:',
     &      ' resetting useHibler79IceStrength = .TRUE., because'
      CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                    SQUEEZE_RIGHT , myThid)
       WRITE(msgBuf,'(A,A)')
     &      'WARNING FROM S/R SEAICE_READPARMS:',
     &      ' SEAICE_ITD is not defined.'
      CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                    SQUEEZE_RIGHT , myThid)
      ENDIF
#endif /* SEAICE_ITD */

C     reset default SEAICEuseLSR according to parameters from namelist
      SEAICEuseLSR = .NOT.SEAICEuseFREEDRIFT .AND. .NOT.SEAICEuseEVP
     &     .AND. .NOT.SEAICEuseJFNK .AND. .NOT. SEAICEuseKrylov
C     allow SEAICEuseLSR = .TRUE. if used as a preconditioner for non-linear
C     JFNK problem (and Krylov solver is not used)
      IF ( SEAICEuseJFNK .AND. SEAICEusePicardAsPrecon .AND.
     &     .NOT. SEAICEuseKrylov ) SEAICEuseLSR = .TRUE.
      IF ( SEAICEuseJFNK .AND. .NOT. SEAICEusePicardAsPrecon )
     &     SEAICEuseKrylov = .FALSE.

C     Set different defaults for different solvers
      IF ( SEAICEnonLinIterMax .EQ. UNSET_I ) THEN
C     two nonlinear iterations correspond to the original modified
C     Euler time stepping scheme of Zhang+Hibler (1997)
       IF ( SEAICEuseLSR ) SEAICEnonLinIterMax = 2
       IF ( SEAICEuseJFNK.OR.SEAICEuseKrylov ) SEAICEnonLinIterMax = 10
      ENDIF
C     Make sure that we have least two pseudo time steps for Picard-LSR
      IF ( SEAICEuseLSR .AND. .NOT. SEAICEusePicardAsPrecon )
     &     SEAICEnonLinIterMax = MAX(SEAICEnonLinIterMax,2)

C     If we do not use the LSR solver, using LSRflex makes no sense
      IF ( .NOT. SEAICEuseLSR ) SEAICEuseLSRflex = .FALSE.

C-    different defaults for different linear solvers
      IF ( SEAICElinearIterMax .EQ. UNSET_I ) THEN
C     maximum number of LSOR steps in default Picard solver
C     (=previous default for retired SOLV_MAX_ITERS)
#ifdef ALLOW_AUTODIFF
       SEAICElinearIterMax = SOLV_MAX_FIXED
#else
       SEAICElinearIterMax = 1500
#endif
C     the maximum number of Krylov dimensions of 50 is hard coded in
C     S/R SEAICE_FGMRES, so that more than 50 linear iterations will
C     restart GMRES
       IF ( SEAICEuseJFNK.OR.SEAICEuseKrylov ) SEAICElinearIterMax = 10
      ENDIF

C     Turn line search with JFNK solver off by default by making this
C     number much larger than the maximum allowed Newton iterations
      IF ( SEAICE_JFNK_lsIter .EQ. UNSET_I )
     &     SEAICE_JFNK_lsIter  = 2*SEAICEnewtonIterMax

C     2nd order boundary conditions only possible for no_slip,
C     and EVP, JFNK, and Krylov solvers
      IF ( .NOT. SEAICE_no_slip ) SEAICE_2ndOrderBC = .FALSE.
      IF ( SEAICEuseLSR ) SEAICE_2ndOrderBC = .FALSE.

C     2nd order boundary conditions require one more row of overlap for
C     the additive Schwartz method
      IF ( SEAICE_2ndOrderBC ) THEN
       SEAICE_OLx = OLx-3
       SEAICE_OLy = OLy-3
      ENDIF

      IF ( SEAICEselectMetricTerms .EQ. UNSET_I ) THEN
       IF ( SEAICEuseMetricTerms ) THEN
        SEAICEselectMetricTerms = 2
       ELSE
C-    just for backward compatibility:
        SEAICEselectMetricTerms = 0
       ENDIF
      ELSEIF ( .NOT.SEAICEuseMetricTerms .AND.
     &         SEAICEselectMetricTerms .GT. 0  ) THEN
C-    inconsistent setting:
       WRITE(msgBuf,'(2A)') 'S/R SEAICE_READPARMS: ',
     &      'Cannot set both: SEAICEuseMetricTerms= False'
       CALL PRINT_ERROR( msgBuf , myThid)
       WRITE(msgBuf,'(2A,I2)') 'S/R SEAICE_READPARMS: ',
     &      ' AND SEAICEselectMetricTerms =', SEAICEselectMetricTerms
       CALL PRINT_ERROR( msgBuf , myThid)
       nError = nError + 1
      ENDIF
      IF ( SEAICEselectMetricTerms .LT. 0 .OR.
     &     SEAICEselectMetricTerms .GT. 2 ) THEN
       WRITE(msgBuf,'(2A,I2)') 'S/R SEAICE_READPARMS: ',
     &      'SEAICEselectMetricTerms = ', SEAICEselectMetricTerms
       CALL PRINT_ERROR( msgBuf , myThid)
       WRITE(msgBuf,'(2A)') 'S/R SEAICE_READPARMS: ',
     &      'SEAICEselectMetricTerms needs to be >=0 and <= 2'
       CALL PRINT_ERROR( msgBuf , myThid)
       nError = nError + 1
      ENDIF
C-    to skip some compution of metric terms (all zero on Cartesian-Grid)
      IF ( usingCartesianGrid ) SEAICEselectMetricTerms = 0

C     -    The old ways of specifying mcPheeTaper, mcPheePiston & frazilFrac:
C     a) prevent multiple specification of the same coeff;
C     b) if specified, then try to recover old way of setting & default.
      IF ( SEAICE_mcPheeTaper .EQ. UNSET_RL ) THEN
       IF ( SEAICE_availHeatTaper.EQ.UNSET_RL ) THEN
         SEAICE_mcPheeTaper = 0.0 _d 0
       ELSE
         SEAICE_mcPheeTaper = SEAICE_availHeatTaper
       ENDIF
      ELSEIF ( SEAICE_availHeatTaper.NE.UNSET_RL ) THEN
         WRITE(msgBuf,'(2A)') 'S/R SEAICE_READPARMS: Cannot specify ',
     &    'both SEAICE_mcPheeTaper & SEAICE_availHeatTaper'
         CALL PRINT_ERROR( msgBuf , myThid)
         nError = nError + 1
      ENDIF

C-    set SEAICE_frazilFrac if not yet done
      IF ( SEAICE_gamma_t_frz .NE. UNSET_RL ) THEN
       IF ( SEAICE_frazilFrac .EQ. UNSET_RL ) THEN
         SEAICE_frazilFrac = SEAICE_deltaTtherm/SEAICE_gamma_t_frz
       ELSE
         WRITE(msgBuf,'(2A)') 'S/R SEAICE_READPARMS: Cannot specify ',
     &    'both SEAICE_frazilFrac & SEAICE_gamma_t_frz'
         CALL PRINT_ERROR( msgBuf , myThid)
         nError = nError + 1
       ENDIF
      ENDIF
      IF ( SEAICE_availHeatFracFrz.NE.UNSET_RL ) THEN
       IF ( SEAICE_frazilFrac .EQ. UNSET_RL ) THEN
         SEAICE_frazilFrac = SEAICE_availHeatFracFrz
       ELSE
        IF ( SEAICE_gamma_t_frz .EQ. UNSET_RL ) THEN
         WRITE(msgBuf,'(2A)') 'S/R SEAICE_READPARMS: Cannot specify ',
     &    'both SEAICE_frazilFrac  & SEAICE_availHeatFracFrz'
        ELSE
         WRITE(msgBuf,'(2A)') 'S/R SEAICE_READPARMS: Cannot specify ',
     &    'both SEAICE_gamma_t_frz & SEAICE_availHeatFracFrz'
        ENDIF
        CALL PRINT_ERROR( msgBuf , myThid)
        nError = nError + 1
       ENDIF
      ENDIF
C     the default for SEAICE_gamma_t_frz use to be SEAICE_gamma_t:
      IF ( SEAICE_gamma_t .NE. UNSET_RL .AND.
     &     SEAICE_frazilFrac .EQ. UNSET_RL ) THEN
         SEAICE_frazilFrac = SEAICE_deltaTtherm/SEAICE_gamma_t
      ENDIF
C     the default for SEAICE_availHeatFracFrz use to be SEAICE_availHeatFrac:
      IF ( SEAICE_availHeatFrac.NE.UNSET_RL .AND.
     &     SEAICE_frazilFrac .EQ. UNSET_RL ) THEN
         SEAICE_frazilFrac = SEAICE_availHeatFrac
      ENDIF
      IF ( SEAICE_frazilFrac .EQ. UNSET_RL ) THEN
         SEAICE_frazilFrac = 1. _d 0
      ENDIF

C-    start by setting SEAICE_availHeatFrac (used in seaice_init_fixed.F
C     to set SEAICE_mcPheePiston once drF is known)
      IF ( SEAICE_gamma_t .NE. UNSET_RL ) THEN
       IF ( SEAICE_availHeatFrac.EQ.UNSET_RL ) THEN
         SEAICE_availHeatFrac = SEAICE_deltaTtherm/SEAICE_gamma_t
       ELSE
         WRITE(msgBuf,'(2A)') 'S/R SEAICE_READPARMS: Cannot specify ',
     &    'both SEAICE_gamma_t & SEAICE_availHeatFrac'
         CALL PRINT_ERROR( msgBuf , myThid)
         nError = nError + 1
       ENDIF
      ENDIF
      IF ( SEAICE_mcPheePiston .NE. UNSET_RL .AND.
     &     SEAICE_availHeatFrac.NE. UNSET_RL ) THEN
        IF ( SEAICE_gamma_t .EQ. UNSET_RL ) THEN
         WRITE(msgBuf,'(2A)') 'S/R SEAICE_READPARMS: Cannot specify ',
     &    'both SEAICE_mcPheePiston & SEAICE_availHeatFrac'
        ELSE
         WRITE(msgBuf,'(2A)') 'S/R SEAICE_READPARMS: Cannot specify ',
     &    'both SEAICE_mcPheePiston & SEAICE_gamma_t'
        ENDIF
        CALL PRINT_ERROR( msgBuf , myThid)
        nError = nError + 1
      ENDIF

      IF ( useThSice ) THEN
C     If the thsice package with the Winton thermodynamics is used
C     is does not make sense to have the following parameters defined,
C     so we reset them here
       usePW79thermodynamics = .FALSE.
       SEAICEadvHeff         = .FALSE.
       SEAICEadvArea         = .FALSE.
       SEAICEadvSnow         = .FALSE.
       SEAICEadvSalt         = .FALSE.
      ENDIF
C     Set advection schemes to some sensible values if not done in data.seaice
      IF ( SEAICEadvSchArea .EQ. UNSET_I )
     &     SEAICEadvSchArea = SEAICEadvSchHeff
      IF ( SEAICEadvSchArea .EQ. UNSET_I )
     &     SEAICEadvSchArea = SEAICEadvScheme
      IF ( SEAICEadvScheme .NE. SEAICEadvSchArea )
     &     SEAICEadvScheme  = SEAICEadvSchArea
      IF ( SEAICEadvSchHeff .EQ. UNSET_I )
     &     SEAICEadvSchHeff = SEAICEadvSchArea
      IF ( SEAICEadvSchSnow .EQ. UNSET_I )
     &     SEAICEadvSchSnow = SEAICEadvSchHeff
      IF ( SEAICEadvSchSalt .EQ. UNSET_I )
     &     SEAICEadvSchSalt = SEAICEadvSchHeff
C     Set diffusivity to some sensible values if not done in data.seaice
      IF ( SEAICEdiffKhArea .EQ. UNSET_RL )
     &     SEAICEdiffKhArea = SEAICEdiffKhHeff
      IF ( SEAICEdiffKhArea .EQ. UNSET_RL )
     &     SEAICEdiffKhArea = 0. _d 0
      IF ( SEAICEdiffKhHeff .EQ. UNSET_RL )
     &     SEAICEdiffKhHeff = SEAICEdiffKhArea
      IF ( SEAICEdiffKhSnow .EQ. UNSET_RL )
     &     SEAICEdiffKhSnow = SEAICEdiffKhHeff
      IF ( SEAICEdiffKhSalt .EQ. UNSET_RL )
     &     SEAICEdiffKhSalt = SEAICEdiffKhHeff
      IF ( SEAICE_EPS_SQ .EQ. -99999. )
     &     SEAICE_EPS_SQ = SEAICE_EPS * SEAICE_EPS

#ifdef ALLOW_GENERIC_ADVDIFF
      SEAICEmultiDimAdvection = .TRUE.
      IF ( SEAICEadvScheme.EQ.ENUM_CENTERED_2ND
     & .OR.SEAICEadvScheme.EQ.ENUM_UPWIND_3RD
     & .OR.SEAICEadvScheme.EQ.ENUM_CENTERED_4TH ) THEN
       SEAICEmultiDimAdvection = .FALSE.
      ENDIF
#else
      SEAICEmultiDimAdvection = .FALSE.
#endif /* ALLOW_GENERIC_ADVDIFF */

C-    Retired parameters
      IF ( SEAICEnewtonIterMax .NE. UNSET_I ) THEN
       nRetired = nRetired + 1
       WRITE(msgBuf,'(A,A)')
     &  'S/R SEAICE_READPARMS: "SEAICEnewtonIterMax" ',
     &  'is no longer allowed in file "data.seaice"'
       CALL PRINT_ERROR( msgBuf, myThid )
       WRITE(msgBuf,'(A)')
     &  'S/R SEAICE_READPARMS: use "SEAICEnonLinIterMax" instead'
       CALL PRINT_ERROR( msgBuf, myThid )
      ENDIF
      IF ( SEAICEkrylovIterMax .NE. UNSET_I ) THEN
       nRetired = nRetired + 1
       WRITE(msgBuf,'(A,A)')
     &  'S/R SEAICE_READPARMS: "SEAICEkrylovIterMax" ',
     &  'is no longer allowed in file "data.seaice"'
       CALL PRINT_ERROR( msgBuf, myThid )
       WRITE(msgBuf,'(A)')
     &  'S/R SEAICE_READPARMS: use "SEAICElinearIterMax" instead'
       CALL PRINT_ERROR( msgBuf, myThid )
      ENDIF
      IF ( NPSEUDOTIMESTEPS    .NE. UNSET_I ) THEN
       nRetired = nRetired + 1
       WRITE(msgBuf,'(A,A)')
     &  'S/R SEAICE_READPARMS: "NPSEUDOTIMESTEPS" ',
     &  'is no longer allowed in file "data.seaice"'
       CALL PRINT_ERROR( msgBuf, myThid )
       WRITE(msgBuf,'(A)')
     &  'S/R SEAICE_READPARMS: use "SEAICEnonLinIterMax" instead'
       CALL PRINT_ERROR( msgBuf, myThid )
      ENDIF
      IF ( SOLV_MAX_ITERS .NE. UNSET_I ) THEN
       nRetired = nRetired + 1
       WRITE(msgBuf,'(A,A)')
     &  'S/R SEAICE_READPARMS: "SOLV_MAX_ITERS" ',
     &  'is no longer allowed in file "data.seaice"'
       CALL PRINT_ERROR( msgBuf, myThid )
       WRITE(msgBuf,'(A)')
     &  'S/R SEAICE_READPARMS: use "SEAICElinearIterMax" instead'
       CALL PRINT_ERROR( msgBuf, myThid )
      ENDIF
      IF ( JFNKgamma_nonlin   .NE. UNSET_RL ) THEN
       nRetired = nRetired + 1
       WRITE(msgBuf,'(A,A)')
     &  'S/R SEAICE_READPARMS: "JFNKgamma_nonlin" ',
     &  'is no longer allowed in file "data.seaice"'
       CALL PRINT_ERROR( msgBuf, myThid )
       WRITE(msgBuf,'(A)')
     &  'S/R SEAICE_READPARMS: use "SEAICEnonLinTol" instead'
       CALL PRINT_ERROR( msgBuf, myThid )
      ENDIF
      IF ( SEAICE_sensHeat    .NE. UNSET_RL ) THEN
       nRetired = nRetired + 1
       WRITE(msgBuf,'(A,A)')
     &  'S/R SEAICE_READPARMS: "SEAICE_sensHeat" ',
     &  'is no longer allowed in file "data.seaice"'
       CALL PRINT_ERROR( msgBuf, myThid )
       WRITE(msgBuf,'(A,A)')
     &  'S/R SEAICE_READPARMS: set "SEAICE_cpAir", ',
     &  '"SEAICE_dalton", and "SEAICE_rhoAir" instead'
       CALL PRINT_ERROR( msgBuf, myThid )
      ENDIF
      IF ( SEAICE_latentWater .NE. UNSET_RL ) THEN
       nRetired = nRetired + 1
       WRITE(msgBuf,'(A,A)')
     &  'S/R SEAICE_READPARMS: "SEAICE_latentWater" ',
     &  'is no longer allowed in file "data.seaice"'
       CALL PRINT_ERROR( msgBuf, myThid )
       WRITE(msgBuf,'(A,A)')
     &  'S/R SEAICE_READPARMS: set "SEAICE_lhEvap", ',
     &  '"SEAICE_dalton", and "SEAICE_rhoAir" instead'
       CALL PRINT_ERROR( msgBuf, myThid )
      ENDIF
      IF ( SEAICE_latentIce   .NE. UNSET_RL ) THEN
       nRetired = nRetired + 1
       WRITE(msgBuf,'(A,A)')
     &  'S/R SEAICE_READPARMS: "SEAICE_latentIce" ',
     &  'is no longer allowed in file "data.seaice"'
       CALL PRINT_ERROR( msgBuf, myThid )
       WRITE(msgBuf,'(A,A)')
     &  'S/R SEAICE_READPARMS: set "SEAICE_lhFusion", ',
     &  '"SEAICE_dalton", and "SEAICE_rhoAir" instead'
       CALL PRINT_ERROR( msgBuf, myThid )
      ENDIF
      IF ( SEAICE_freeze .NE. UNSET_RL ) THEN
       WRITE(msgBuf,'(A,A)')'S/R SEAICE_READPARMS: ',
     &  '"SEAICE_freeze" no longer allowed in file "data.seaice"'
       CALL PRINT_ERROR( msgBuf, myThid )
       WRITE(msgBuf,'(A,A)')'S/R SEAICE_READPARMS: ',
     &  'set instead "SEAICE_tempFrz0" and "SEAICE_dTempFrz_dS"'
       CALL PRINT_ERROR( msgBuf, myThid )
      ENDIF
      IF ( SEAICE_salinity   .NE. UNSET_RL ) THEN
       nRetired = nRetired + 1
       WRITE(msgBuf,'(A,A)') 'S/R SEAICE_READPARMS: ',
     &  '"SEAICE_salinity" is no longer allowed in file "data.seaice"'
       CALL PRINT_ERROR( msgBuf, myThid )
       WRITE(msgBuf,'(A,A)') 'S/R SEAICE_READPARMS: ',
     &  'set "SEAICE_saltFrac" instead'
       CALL PRINT_ERROR( msgBuf, myThid )
      ENDIF
      IF ( SIsalFrac .NE. UNSET_RL ) THEN
       nRetired = nRetired + 1
       WRITE(msgBuf,'(A,A)') 'S/R SEAICE_READPARMS: ',
     &  '"SIsalFrac" is no longer allowed in file "data.seaice"'
       CALL PRINT_ERROR( msgBuf, myThid )
       WRITE(msgBuf,'(A,A)') 'S/R SEAICE_READPARMS: ',
     &  'set "SEAICE_saltFrac" instead'
       CALL PRINT_ERROR( msgBuf, myThid )
      ENDIF
      IF ( SIsal0 .NE. UNSET_RL ) THEN
       nRetired = nRetired + 1
       WRITE(msgBuf,'(A,A)') 'S/R SEAICE_READPARMS: ',
     &  '"SIsal0" is no longer allowed in file "data.seaice"'
       CALL PRINT_ERROR( msgBuf, myThid )
       WRITE(msgBuf,'(A,A)') 'S/R SEAICE_READPARMS: ',
     &  'set "SEAICE_salt0" instead'
       CALL PRINT_ERROR( msgBuf, myThid )
      ENDIF
      IF ( IceAgeFile .NE. ' ' ) THEN
       nRetired = nRetired + 1
       WRITE(msgBuf,'(A,A)')
     &  'S/R SEAICE_READPARMS: "IceAgeFile" ',
     &  'is no longer allowed in file "data.seaice"'
       CALL PRINT_ERROR( msgBuf, myThid )
       WRITE(msgBuf,'(A,A)')
     &  'S/R SEAICE_READPARMS: replaced by ',
     &  '"IceAgeTrFile(SEAICE_num)" array '
       CALL PRINT_ERROR( msgBuf, myThid )
      ENDIF
      IF ( areaMax .NE. UNSET_RL ) THEN
       nRetired = nRetired + 1
       WRITE(msgBuf,'(A,A)')
     &  'S/R SEAICE_READPARMS: "areaMax" ',
     &  'is no longer allowed in file "data.seaice"'
       CALL PRINT_ERROR( msgBuf, myThid )
       WRITE(msgBuf,'(A,A)')
     &  'S/R SEAICE_READPARMS: replaced by ',
     &  '"SEAICE_area_max"'
       CALL PRINT_ERROR( msgBuf, myThid )
      ENDIF
      IF ( areaMin .NE. UNSET_RL ) THEN
       nRetired = nRetired + 1
       WRITE(msgBuf,'(A,A)')
     &  'S/R SEAICE_READPARMS: "areaMin" ',
     &  'is no longer allowed in file "data.seaice"'
       CALL PRINT_ERROR( msgBuf, myThid )
       WRITE(msgBuf,'(A,A)')
     &  'S/R SEAICE_READPARMS: replaced by ',
     &  '"SEAICE_area_reg" for regularization and ',
     &  '"SEAICE_area_floor" setting a lower bound'
       CALL PRINT_ERROR( msgBuf, myThid )
      ENDIF
      IF (SEAICE_lhSublim .NE. UNSET_RL ) THEN
       nRetired = nRetired + 1
       WRITE(msgBuf,'(A,A)')
     &  'S/R SEAICE_READPARMS: "SEAICE_lhSublim" ',
     &  'is no longer allowed in file "data.seaice"'
       CALL PRINT_ERROR( msgBuf, myThid )
       WRITE(msgBuf,'(A,A)')
     &  'S/R SEAICE_READPARMS: specify ',
     &  '"SEAICE_lhFusion" and "SEAICE_lhEvap" instead'
       CALL PRINT_ERROR( msgBuf, myThid )
      ENDIF
      IF ( A22 .NE. UNSET_RL ) THEN
       nRetired = nRetired + 1
       WRITE(msgBuf,'(A,A)')
     &  'S/R SEAICE_READPARMS: "A22" ',
     &  'is no longer allowed in file "data.seaice"'
       CALL PRINT_ERROR( msgBuf, myThid )
       WRITE(msgBuf,'(A,A)')
     &  'S/R SEAICE_READPARMS: replaced by ',
     &  '"SEAICE_area_reg" for regularization'
       CALL PRINT_ERROR( msgBuf, myThid )
      ENDIF
      IF ( LAD .NE. UNSET_I ) THEN
       nRetired = nRetired + 1
       WRITE(msgBuf,'(A,A)') 'S/R SEAICE_READPARMS: "LAD" ',
     &  'is no longer allowed in file "data.seaice"'
       CALL PRINT_ERROR( msgBuf, myThid )
       WRITE(msgBuf,'(A,A)') 'always use modified Euler step ',
     &  '(LAD==2) since Leap frog code (LAD==1) is gone.'
       CALL PRINT_ERROR( msgBuf, myThid )
      ENDIF
      IF ( MAX_TICE .NE. UNSET_RL ) THEN
       nRetired = nRetired + 1
       WRITE(msgBuf,'(A,A)')
     &  'S/R SEAICE_READPARMS: "MAX_TICE" ',
     &  'is no longer allowed in file "data.seaice"'
       CALL PRINT_ERROR( msgBuf, myThid )
      ENDIF
      IF ( hiceMin .NE. UNSET_RL ) THEN
       nRetired = nRetired + 1
       WRITE(msgBuf,'(A,A)')
     &  'S/R SEAICE_READPARMS: "hiceMin" ',
     &  'is no longer allowed in file "data.seaice"'
       CALL PRINT_ERROR( msgBuf, myThid )
       WRITE(msgBuf,'(A,A)')
     &  'S/R SEAICE_READPARMS: replaced by ',
     &  '"SEAICE_hice_reg" for regularization'
       CALL PRINT_ERROR( msgBuf, myThid )
      ENDIF
      IF ( .NOT. SEAICEadvAge ) THEN
       nRetired = nRetired + 1
       WRITE(msgBuf,'(A,A)')
     &  'S/R SEAICE_READPARMS: "SEAICEadvAge" ',
     &  'is no longer allowed in file "data.seaice"'
       CALL PRINT_ERROR( msgBuf, myThid )
       WRITE(msgBuf,'(A,A)')
     &  'S/R SEAICE_READPARMS: since ALLOW_SITRACER ',
     &  'replaced and extended SEAICE_AGE'
       CALL PRINT_ERROR( msgBuf, myThid )
      ENDIF
      IF ( SEAICEadvSchAge .NE. UNSET_I ) THEN
       nRetired = nRetired + 1
       WRITE(msgBuf,'(A,A)')
     &  'S/R SEAICE_READPARMS: "SEAICEadvSchAge" ',
     &  'is no longer allowed in file "data.seaice"'
       CALL PRINT_ERROR( msgBuf, myThid )
       WRITE(msgBuf,'(A,A)')
     &  'S/R SEAICE_READPARMS: since ALLOW_SITRACER ',
     &  'replaced and extended SEAICE_AGE'
       CALL PRINT_ERROR( msgBuf, myThid )
      ENDIF
      IF ( SEAICEdiffKhAge .NE. UNSET_RL ) THEN
       nRetired = nRetired + 1
       WRITE(msgBuf,'(A,A)')
     &  'S/R SEAICE_READPARMS: "SEAICEdiffKhAge" ',
     &  'is no longer allowed in file "data.seaice"'
       CALL PRINT_ERROR( msgBuf, myThid )
       WRITE(msgBuf,'(A,A)')
     &  'S/R SEAICE_READPARMS: since ALLOW_SITRACER ',
     &  'replaced and extended SEAICE_AGE'
       CALL PRINT_ERROR( msgBuf, myThid )
      ENDIF
      IF ( ( IceAgeTrFile(1) .NE. ' ' ).OR.
     &     ( IceAgeTrFile(2) .NE. ' ' ).OR.
     &     ( IceAgeTrFile(3) .NE. ' ' ).OR.
     &     ( IceAgeTrFile(4) .NE. ' ' ) ) THEN
       nRetired = nRetired + 1
       WRITE(msgBuf,'(A,A)')
     &  'S/R SEAICE_READPARMS: "IceAgeTrFile" ',
     &  'is no longer allowed in file "data.seaice"'
       CALL PRINT_ERROR( msgBuf, myThid )
       WRITE(msgBuf,'(A,A)')
     &  'S/R SEAICE_READPARMS: since ALLOW_SITRACER ',
     &  'replaced and extended SEAICE_AGE'
       CALL PRINT_ERROR( msgBuf, myThid )
      ENDIF
      IF ( SEAICEturbFluxFormula .NE. UNSET_I ) THEN
       WRITE(msgBuf,'(A,A)')'S/R SEAICE_READPARMS: ',
     &  '"SEAICEturbFluxFormula" no longer allowed in "data.seaice"'
       CALL PRINT_ERROR( msgBuf, myThid )
       WRITE(msgBuf,'(A,A)')'S/R SEAICE_READPARMS: ',
     &  ' Set instead "SEAICE_mcPheePiston" and "SEAICE_frazilFrac"'
       CALL PRINT_ERROR( msgBuf, myThid )
      ENDIF
      IF ( MAX_HEFF .NE. UNSET_RL ) THEN
       nRetired = nRetired + 1
       WRITE(msgBuf,'(A,A)')
     &  'S/R SEAICE_READPARMS: "MAX_HEFF" ',
     &  'is no longer allowed in file "data.seaice"'
       CALL PRINT_ERROR( msgBuf, myThid )
      ENDIF
      IF ( SEAICEuseAB2 ) THEN
       nRetired = nRetired + 1
       WRITE(msgBuf,'(A,A)')
     &  'S/R SEAICE_READPARMS: "SEAICEuseAB2" ',
     &  'is no longer allowed in file "data.seaice"'
       CALL PRINT_ERROR( msgBuf, myThid )
      ENDIF
      IF ( SEAICE_abEps .NE. UNSET_RL ) THEN
       nRetired = nRetired + 1
       WRITE(msgBuf,'(A,A)')
     &  'S/R SEAICE_READPARMS: "SEAICE_abEps" ',
     &  'is no longer allowed in file "data.seaice"'
       CALL PRINT_ERROR( msgBuf, myThid )
      ENDIF
#ifdef ALLOW_COST
      IF ( smrsstbarfile .NE.  ' ' .OR. smrsssbarfile .NE. ' '
     &     .OR. smrareabarfile .NE. ' ' .OR. smrareadatfile .NE. ' '
     &     .OR. smrarea_errfile .NE. ' '
     &     .OR. mult_smrsst .NE. UNSET_RL .OR. mult_smrsss.NE.UNSET_RL
     &     .OR. mult_smrarea .NE. UNSET_RL .OR. wsmrarea0 .NE.UNSET_RL
     &     .OR. wmean_smrarea .NE. UNSET_RL
     &     .OR. smrareastartdate1 .NE. UNSET_I
     &     .OR. smrareastartdate2 .NE. UNSET_I
     &     ) THEN
       nRetired = nRetired + 1
       WRITE(msgBuf,'(A,A)')
     &  'S/R SEAICE_READPARMS: "SMR"-related parameters ',
     &  'are no longer allowed in file "data.seaice"'
       CALL PRINT_ERROR( msgBuf, myThid )
      ENDIF
      IF ( SEAICE_clamp_salt .NE. UNSET_RL ) THEN
       nRetired = nRetired + 1
       WRITE(msgBuf,'(A,A)')
     &  'S/R SEAICE_READPARMS: "SEAICE_clamp_salt" ',
     &  'is no longer allowed in file "data.seaice"'
       CALL PRINT_ERROR( msgBuf, myThid )
      ENDIF
      IF ( SEAICE_clamp_theta .NE. UNSET_RL ) THEN
       nRetired = nRetired + 1
       WRITE(msgBuf,'(A,A)')
     &  'S/R SEAICE_READPARMS: "SEAICE_clamp_theta" ',
     &  'is no longer allowed in file "data.seaice"'
       CALL PRINT_ERROR( msgBuf, myThid )
      ENDIF
#endif /* ALLOW_COST */
      IF ( SEAICE_taveFreq .NE. UNSET_RL ) THEN
        WRITE(msgBuf,'(2A)') 'SEAICE_READPARMS: "SEAICE_taveFreq"',
     &    ' is no longer allowed in file "data.seaice"'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(2A)') 'SEAICE_READPARMS: ',
     &    ' since "pkg/timeave" has been removed.'
        CALL PRINT_ERROR( msgBuf, myThid )
        nRetired = nRetired + 1
      ENDIF
      IF ( SEAICE_tave_mnc ) THEN
        WRITE(msgBuf,'(2A)') 'SEAICE_READPARMS: "SEAICE_tave_mnc"',
     &    ' is no longer allowed in file "data.seaice"'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(2A)') 'SEAICE_READPARMS: ',
     &    ' since "pkg/timeave" has been removed.'
        CALL PRINT_ERROR( msgBuf, myThid )
        nRetired = nRetired + 1
      ENDIF

      IF ( nRetired .GT. 0 ) THEN
       WRITE(msgBuf,'(2A)') 'S/R SEAICE_READPARMS: ',
     &  'Error reading parameter file "data.seaice"'
       CALL PRINT_ERROR( msgBuf, myThid )
       WRITE(msgBuf,'(A,I3,A)') 'S/R SEAICE_READPARMS: ', nRetired,
     &      ' out of date parameters were found in the namelist'
       CALL PRINT_ERROR( msgBuf, myThid )
      ENDIF

      IF ( nError .GT. 0 ) THEN
       WRITE(msgBuf,'(2A)') 'S/R SEAICE_READPARMS: ',
     &  'Error reading parameter file "data.seaice"'
       CALL PRINT_ERROR( msgBuf, myThid )
       WRITE(msgBuf,'(A,I3,A)') 'S/R SEAICE_READPARMS: ', nError,
     &  ' parameters values are inconsistent or incomplete'
       CALL PRINT_ERROR( msgBuf, myThid )
      ENDIF

      IF ( nRetired .GT. 0 .OR. nError .GT. 0 ) THEN
       CALL ALL_PROC_DIE( 0 )
       STOP 'ABNORMAL END: S/R SEAICE_READPARMS'
      ENDIF

C--   Now set-up any remaining parameters that result from other params

C-    convert SEAICE_doOpenWaterGrowth/Melt logical switch to numerical
C     facOpenGrow/facOpenMelt
      facOpenGrow = 0. _d 0
      facOpenMelt = 0. _d 0
      IF (SEAICE_doOpenWaterGrowth) facOpenGrow = 1. _d 0
      IF (SEAICE_doOpenWaterMelt)   facOpenMelt = 1. _d 0

C-    Set Output type flags :
      SEAICE_dump_mdsio = .TRUE.
      SEAICE_mon_stdio  = .TRUE.
#ifdef ALLOW_MNC
      IF (useMNC) THEN
        IF ( .NOT.outputTypesInclusive
     &       .AND. SEAICE_dump_mnc ) SEAICE_dump_mdsio = .FALSE.
        IF ( .NOT.outputTypesInclusive
     &       .AND. SEAICE_mon_mnc  ) SEAICE_mon_stdio  = .FALSE.
      ENDIF
#endif

C-    store value of logical flag which might be changed in AD mode
#ifdef ALLOW_AUTODIFF
      SEAICEuseFREEDRIFTinFwdMode = SEAICEuseFREEDRIFT
      SEAICEuseDYNAMICSinFwdMode  = SEAICEuseDYNAMICS
#endif /* ALLOW_AUTODIFF */

C     Check the consitency of a few parameters
      IF ( SEAICE_emissivity .LT. 1. _d -04 ) THEN
       WRITE(msgBuf,'(2A)')
     &      'SEAICE_emissivity is no longer emissivity*(boltzmann ',
     &      'constant) but really an emissivity.'
       CALL PRINT_ERROR( msgBuf , myThid)
       WRITE(msgBuf,'(2A)')
     &      'Typical values are near 1 ',
     &      '(default is 5.5/5.67=0.9700176...).'
       CALL PRINT_ERROR( msgBuf , myThid)
       WRITE(msgBuf,'(A,E13.6,A)')
     &      'Please change SEAICE_emissivity in data.seaice to ',
     &      SEAICE_emissivity, '/5.67e-8.'
       CALL PRINT_ERROR( msgBuf , myThid)
       STOP 'ABNORMAL END: S/R SEAICE_READPARMS'
      ENDIF

C--   Since the default of SEAICE_waterDrag has changed, issue a warning
C     in case of large values
      chkFlag = .FALSE.
      IF ( SEAICE_waterDrag .GT. 1. _d 0 ) THEN
       WRITE(msgBuf,'(A,A,F5.2)') '** WARNING ** SEAICE_READPARMS: ',
     &      'SEAICE_waterDrag = ', SEAICE_waterDrag
       CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                     SQUEEZE_RIGHT, myThid )
       chkFlag = .TRUE.
      ENDIF
      IF ( SEAICE_waterDrag_South .GT. 1. _d 0 ) THEN
       WRITE(msgBuf,'(A,A,F5.2)') '** WARNING ** SEAICE_READPARMS: ',
     &      'SEAICE_waterDrag_South = ', SEAICE_waterDrag_South
       CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                     SQUEEZE_RIGHT, myThid )
       chkFlag = .TRUE.
      ENDIF
      IF ( chkFlag ) THEN
       WRITE(msgBuf,'(3A)') '** WARNING ** SEAICE_READPARMS: ',
     &      'That is 3 orders of magnitude larger',
     &      ' than the default of 5.5e-3.'
       CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                     SQUEEZE_RIGHT, myThid )
       WRITE(msgBuf,'(2A)') '** WARNING ** SEAICE_READPARMS: ',
     &      'Are you maybe using an old (pre Jun2018) data.seaice?'
       CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                     SQUEEZE_RIGHT, myThid )
      ENDIF

#ifdef SEAICE_ALLOW_SIDEDRAG
      IF ( SEAICEsideDrag .NE. 0.0 _d 0 .AND. SEAICE_no_slip ) THEN
       WRITE(msgBuf,'(3A)') '** WARNING ** SEAICE_READPARMS: ',
     &      'SEAICEsideDrag .NE. 0.,',
     &      ' resetting SEAICE_no_slip = .FALSE.'
       CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                     SQUEEZE_RIGHT, myThid )
       SEAICE_no_slip = .FALSE.
      ENDIF
#endif

      IF ( DIFF1 .EQ. UNSET_RL ) THEN
        DIFF1 = 0. _d 0
        chkFlag = .FALSE.
        IF ( SEAICEadvScheme.EQ.2 ) THEN
C--   Since DIFF1 default value has been changed (2011/05/29), issue a warning
C     in case using centered avection scheme without any diffusion:
         IF ( SEAICEadvHeff .AND. SEAICEdiffKhHeff .EQ. 0. _d 0 ) THEN
          WRITE(msgBuf,'(2A)') '** WARNING ** SEAICE_READPARMS: ',
     &    'will use AdvScheme = 2 for HEFF  without any diffusion'
          CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                        SQUEEZE_RIGHT, myThid )
          chkFlag = .TRUE.
         ENDIF
         IF ( SEAICEadvArea .AND. SEAICEdiffKhArea .EQ. 0. _d 0 ) THEN
          WRITE(msgBuf,'(2A)') '** WARNING ** SEAICE_READPARMS: ',
     &    'will use AdvScheme = 2 for AREA  without any diffusion'
          CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                        SQUEEZE_RIGHT, myThid )
          chkFlag = .TRUE.
         ENDIF
         IF ( SEAICEadvSnow .AND. SEAICEdiffKhSnow .EQ. 0. _d 0 ) THEN
          WRITE(msgBuf,'(2A)') '** WARNING ** SEAICE_READPARMS: ',
     &    'will use AdvScheme = 2 for HSNOW without any diffusion'
          CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                        SQUEEZE_RIGHT, myThid )
          chkFlag = .TRUE.
         ENDIF
         IF ( SEAICEadvSalt .AND. SEAICEdiffKhSalt .EQ. 0. _d 0 ) THEN
          WRITE(msgBuf,'(2A)') '** WARNING ** SEAICE_READPARMS: ',
     &    'will use AdvScheme = 2 for HSALT without any diffusion'
          CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                        SQUEEZE_RIGHT, myThid )
          chkFlag = .TRUE.
         ENDIF
         IF ( chkFlag ) THEN
          WRITE(msgBuf,'(2A)') '** WARNING ** SEAICE_READPARMS: ',
     &      'since DIFF1 is set to 0 (= new DIFF1 default value)'
          CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                        SQUEEZE_RIGHT, myThid )
         ENDIF
        ENDIF
      ENDIF

      _END_MASTER(myThid)

C--   Everyone else must wait for the parameters to be loaded
      _BARRIER

      RETURN
      END

#include "OCN_CPL_OPTIONS.h"

CBOP
C     !ROUTINE: OCN_CPL_READ_PICKUP
C     !INTERFACE:
      SUBROUTINE OCN_CPL_READ_PICKUP( myIter, myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE OCN_CPL_READ_PICKUP
C     | o Reads fields from a pickup file for a restart
C     *==========================================================*
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "CPL_PARAMS.h"
#include "OCNCPL.h"
#ifdef ALLOW_PTRACERS
# include "PTRACERS_SIZE.h"
# include "PTRACERS_PARAMS.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     myIter :: Iteration number
C     myThid :: my Thread Id number
      INTEGER myIter
      INTEGER myThid
CEOP

#ifdef COMPONENT_MODULE

C     !LOCAL VARIABLES:
      INTEGER prec, rec_ind
      CHARACTER*(10) suff
      CHARACTER*(MAX_LEN_FNAM) fn

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

       IF ( pickupSuff.EQ.' ' ) THEN
         IF ( rwSuffixType.EQ.0 ) THEN
           WRITE(fn,'(A,I10.10)') 'pickup_cpl.', myIter
         ELSE
           CALL RW_GET_SUFFIX( suff, startTime, myIter, myThid )
           WRITE(fn,'(A,A)') 'pickup_cpl.', suff
         ENDIF
       ELSE
         WRITE(fn,'(A,A10)') 'pickup_cpl.', pickupSuff
       ENDIF
       prec = precFloat64
       rec_ind=0

c      IF ( .NOT. cpl_earlyExpImpCall ) THEN
c        CALL READ_REC_3D_RL( fn,prec,1,atmSLPr   , 1,myIter,myThid )
c        CALL READ_REC_3D_RL( fn,prec,1,HeatFlux  , 2,myIter,myThid )
c        CALL READ_REC_3D_RL( fn,prec,1,qShortWave, 3,myIter,myThid )
c        CALL READ_REC_3D_RL( fn,prec,1,tauX      , 4,myIter,myThid )
c        CALL READ_REC_3D_RL( fn,prec,1,tauY      , 5,myIter,myThid )
c        CALL READ_REC_3D_RL( fn,prec,1,FWFlux    , 6,myIter,myThid )
c        CALL READ_REC_3D_RL( fn,prec,1,iceSaltFlx, 7,myIter,myThid )
c        CALL READ_REC_3D_RL( fn,prec,1,seaIceMass, 8,myIter,myThid )
c        rec_ind=8
c      ENDIF

#ifdef ALLOW_DIC
       IF ( ocn_cplExch_DIC ) THEN
         IF (nIter0.GT.PTRACERS_Iter0) THEN
          rec_ind = rec_ind+1
          CALL READ_REC_3D_RL( fn, prec, 1,
     &                         fluxCO2cpl, rec_ind, myIter, myThid )
         ENDIF
       ENDIF
#endif /* ALLOW_DIC */

C--   Fill in the halo region:
c      IF ( .NOT. cpl_earlyExpImpCall ) THEN
c        _EXCH_XY_RL( atmSLPr   , myThid )
c        _EXCH_XY_RL( HeatFlux  , myThid )
c        _EXCH_XY_RL( qShortWave, myThid )
c        CALL EXCH_UV_XY_RL( tauX, tauY, .TRUE., myThid )
c        _EXCH_XY_RL( FWFlux    , myThid )
c        _EXCH_XY_RL( iceSaltFlx, myThid )
c        _EXCH_XY_RL( seaIceMass, myThid )
c      ENDIF
#ifdef ALLOW_DIC
       IF ( ocn_cplExch_DIC ) THEN
         _EXCH_XY_RL( fluxCO2cpl, myThid )
       ENDIF
#endif /* ALLOW_DIC */

#endif /* COMPONENT_MODULE */

      RETURN
      END

#include "STREAMICE_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

CBOP
      SUBROUTINE STREAMICE_DRIVING_STRESS( myThid )
c      O taudx,
c      O taudy )

C     /============================================================\
C     | SUBROUTINE                                                 |
C     | o                                                          |
C     |============================================================|
C     |                                                            |
C     \============================================================/
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "STREAMICE.h"
#include "STREAMICE_CG.h"

C     !INPUT/OUTPUT ARGUMENTS
      INTEGER myThid
c       _RL taudx (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
c       _RL taudx (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)

#ifdef ALLOW_STREAMICE
C     LOCAL VARIABLES
      INTEGER i, j, bi, bj, Gi, Gj
      LOGICAL at_west_bdry, at_east_bdry,
     &        at_north_bdry, at_south_bdry
      _RL grd_below_sl
      _RL sx, sy, diffx, diffy
c     _RL geom_fac
      _RL i_rhow
      _RL avg_density
     & (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
#ifdef STREAMICE_FIRN_CORRECTION
      _RL firn_depth, h
#endif

      IF (myXGlobalLo.eq.1) at_west_bdry = .true.
      IF (myYGlobalLo.eq.1) at_south_bdry = .true.
      IF (myXGlobalLo-1+sNx*nSx.eq.Nx)
     & at_east_bdry = .false.
      IF (myYGlobalLo-1+sNy*nSy.eq.Ny)
     & at_north_bdry = .false.
#ifdef STREAMICE_FIRN_CORRECTION
      firn_depth = streamice_density *
     &    streamice_firn_correction
     & / (streamice_density-streamice_density_firn)
#endif
      i_rhow = 1./streamice_density_ocean_avg

      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
        DO j=1-OLy+1,sNy+OLy-1
         DO i=1-OLx+1,sNx+OLx-1
          taudx_SI(i,j,bi,bj) = 0. _d 0
          taudy_SI(i,j,bi,bj) = 0. _d 0
#ifdef STREAMICE_FIRN_CORRECTION
          if (STREAMICE_apply_firn_correction) then
           if (streamice_hmask(i,j,bi,bj).eq.1) then
            h = h_streamice(i,j,bi,bj)
            if (h.lt.firn_depth) then
             avg_density(i,j,bi,bj) = streamice_density_firn
            else
             avg_density(i,j,bi,bj) = streamice_density *
     &        (h - streamice_firn_correction) / h
            endif
           endif
          else
#endif
           avg_density(i,j,bi,bj) = streamice_density
#ifdef STREAMICE_FIRN_CORRECTION
          endif
#endif
         ENDDO
        ENDDO
       ENDDO
      ENDDO

      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)

        DO i=1,sNx
         DO j=1,sNy

          diffx = 0. _d 0
          diffy = 0. _d 0
          sx = 0. _d 0
          sy = 0. _d 0

          Gi = (myXGlobalLo-1)+(bi-1)*sNx+i
          Gj = (myYGlobalLo-1)+(bj-1)*sNy+j

          IF (streamice_umask(i,j,bi,bj).eq.1.0) THEN

           IF (streamice_hmask(i-1,j,bi,bj).eq.1.0.AND.
     &      streamice_hmask(i,j,bi,bj).eq.1.0) THEN

c             geom_fac = sqrt(rA(i-1,j,bi,bj)*recip_rA(i,j,bi,bj)*
c      &        dxF(i,j,bi,bj)*recip_dxF(i-1,j,bi,bj))

            taudx_si(i,j,bi,bj) = taudx_si(i,j,bi,bj) -
     &       0.25 * dyG(i,j,bi,bj) *
     &       gravity *
     &       (H_streamice(i,j,bi,bj)*avg_density(i,j,bi,bj)+
     &        H_streamice(i-1,j,bi,bj)*avg_density(i-1,j,bi,bj)) *
     &       (surf_el_streamice(i,j,bi,bj)-
     &              surf_el_streamice(i-1,j,bi,bj))

CCC
            taudx_si(i,j,bi,bj) = taudx_si(i,j,bi,bj) -
     &       streamice_density * gravity *
     &       streamice_bg_surf_slope_x * .25 * rA(i,j,bi,bj) *
     &       (H_streamice(i-1,j,bi,bj) + H_streamice(i,j,bi,bj))
CCC

           ELSE IF (streamice_hmask(i-1,j,bi,bj).eq.1.0) THEN

            IF (float_frac_streamice(i-1,j,bi,bj) .eq. 1.0) THEN

#ifdef USE_ALT_RLOW
             IF (R_low_si(i-1,j,bi,bj) .lt. 0. _d 0) then
#else
             IF (R_low(i-1,j,bi,bj) .lt. 0. _d 0) then
#endif
              grd_below_sl = 1. _d 0
             else
              grd_below_sl = 0. _d 0
             endif

             taudx_si(i,j,bi,bj) = taudx_si(i,j,bi,bj) +
     &        0.25 * dyG(i,j,bi,bj) *
     &        gravity *
     &        (avg_density(i-1,j,bi,bj) * H_streamice(i-1,j,bi,bj)**2-
#ifdef USE_ALT_RLOW
     &         streamice_density_ocean_avg * grd_below_sl *
     &         R_low_si(i-1,j,bi,bj)**2)
#else
     &         streamice_density_ocean_avg * grd_below_sl *
     &         R_low(i-1,j,bi,bj)**2)
#endif

            ELSE

#ifdef STREAMICE_FIRN_CORRECTION

             if (STREAMICE_apply_firn_correction) then
             if (H_streamice(i-1,j,bi,bj).lt.firn_depth) then
              taudx_si(i,j,bi,bj) = taudx_si(i,j,bi,bj) +
     &         0.25 * dyG(i,j,bi,bj) *
     &         streamice_density_firn * gravity *
     &         (1-streamice_density_firn*i_rhow) *
     &         H_streamice(i-1,j,bi,bj)**2
             else
              taudx_si(i,j,bi,bj) = taudx_si(i,j,bi,bj) +
     &         0.25 * dyG(i,j,bi,bj) * gravity * (
     &         streamice_density_firn * firn_depth**2 +
     &         (h_streamice(i-1,j,bi,bj)-firn_depth) *
     &          (streamice_density_firn*firn_depth+streamice_density*
     &          (h_streamice(i-1,j,bi,bj)-streamice_firn_correction)) -
     &         streamice_density**2*i_rhow*
     &          (h_streamice(i-1,j,bi,bj)-streamice_firn_correction)**2
     &         )
             endif
             else

#endif
             taudx_si(i,j,bi,bj) = taudx_si(i,j,bi,bj) +
     &        0.25 * dyG(i,j,bi,bj) *
     &        streamice_density * gravity *
     &        (1-streamice_density*i_rhow) *
     &         H_streamice(i-1,j,bi,bj)**2

#ifdef STREAMICE_FIRN_CORRECTION
             endif
#endif

            ENDIF

           ELSE IF (streamice_hmask(i,j,bi,bj).eq.1.0) THEN

            IF (float_frac_streamice(i,j,bi,bj) .eq. 1.0) THEN

#ifdef USE_ALT_RLOW
             IF (R_low_si(i,j,bi,bj) .lt. 0. _d 0) then
#else
             IF (R_low(i,j,bi,bj) .lt. 0. _d 0) then
#endif
              grd_below_sl = 1. _d 0
             else
              grd_below_sl = 0. _d 0
             endif

             taudx_si(i,j,bi,bj) = taudx_si(i,j,bi,bj) -
     &        0.25 * dyG(i,j,bi,bj) *
     &        gravity *
     &        (avg_density(i,j,bi,bj) * H_streamice(i,j,bi,bj)**2 -
#ifdef USE_ALT_RLOW
     &         streamice_density_ocean_avg * grd_below_sl *
     &         R_low_si(i,j,bi,bj)**2)
#else
     &         streamice_density_ocean_avg * grd_below_sl *
     &         R_low(i,j,bi,bj)**2)
#endif

            ELSE

#ifdef STREAMICE_FIRN_CORRECTION

             if (STREAMICE_apply_firn_correction) then
             if (H_streamice(i,j,bi,bj).lt.firn_depth) then
              taudx_si(i,j,bi,bj) = taudx_si(i,j,bi,bj) -
     &         0.25 * dyG(i,j,bi,bj) *
     &         streamice_density_firn * gravity *
     &         (1-streamice_density_firn*i_rhow) *
     &         H_streamice(i,j,bi,bj)**2
             else
              taudx_si(i,j,bi,bj) = taudx_si(i,j,bi,bj) -
     &         0.25 * dyG(i,j,bi,bj) * gravity * (
     &         streamice_density_firn *  firn_depth**2 +
     &         (h_streamice(i,j,bi,bj)-firn_depth) *
     &          (streamice_density_firn*firn_depth+streamice_density*
     &          (h_streamice(i,j,bi,bj)-streamice_firn_correction)) -
     &         streamice_density**2*i_rhow*
     &          (h_streamice(i,j,bi,bj)-streamice_firn_correction)**2
     &         )
             endif
             else

#endif
             taudx_si(i,j,bi,bj) = taudx_si(i,j,bi,bj) -
     &        0.25 * dyG(i,j,bi,bj) *
     &        streamice_density * gravity *
     &        (1-streamice_density*i_rhow) *
     &         H_streamice(i,j,bi,bj)**2
#ifdef STREAMICE_FIRN_CORRECTION
             endif
#endif

            END IF
           END IF

c cells below

           IF (streamice_hmask(i-1,j-1,bi,bj).eq.1.0.AND.
     &      streamice_hmask(i,j-1,bi,bj).eq.1.0) THEN

c             geom_fac = sqrt(rA(i-1,j-1,bi,bj)*recip_rA(i,j-1,bi,bj)*
c      &             dxF(i,j-1,bi,bj)*recip_dxF(i-1,j-1,bi,bj))

            taudx_si(i,j,bi,bj) = taudx_si(i,j,bi,bj) -
     &       0.25 * dyg(i,j-1,bi,bj) *
     &       gravity *
     &       (H_streamice(i,j-1,bi,bj)*avg_density(i,j-1,bi,bj)+
     &        H_streamice(i-1,j-1,bi,bj)*avg_density(i-1,j-1,bi,bj)) *
     &       (surf_el_streamice(i,j-1,bi,bj)-
     &              surf_el_streamice(i-1,j-1,bi,bj))

            taudx_si(i,j,bi,bj) = taudx_si(i,j,bi,bj) -
     &       streamice_density * gravity *
     &       streamice_bg_surf_slope_x * .25 * rA(i,j-1,bi,bj) *
     &       (H_streamice(i-1,j-1,bi,bj) + H_streamice(i,j-1,bi,bj))

           ELSE IF (streamice_hmask(i-1,j-1,bi,bj).eq.1.0) THEN

            IF (float_frac_streamice(i-1,j-1,bi,bj) .eq. 1.0) THEN

#ifdef USE_ALT_RLOW
             IF (R_low_si(i-1,j-1,bi,bj) .lt. 0. _d 0) then
#else
             IF (R_low(i-1,j-1,bi,bj) .lt. 0. _d 0) then
#endif
              grd_below_sl = 1. _d 0
             else
              grd_below_sl = 0. _d 0
             endif

             taudx_si(i,j,bi,bj) = taudx_si(i,j,bi,bj) +
     &        0.25 * dyg(i,j-1,bi,bj) *
     &        gravity *
     &        (avg_density(i-1,j-1,bi,bj)*H_streamice(i-1,j-1,bi,bj)**2-
#ifdef USE_ALT_RLOW
     &         streamice_density_ocean_avg*grd_below_sl *
     &         R_low_si(i-1,j-1,bi,bj)**2)
#else
     &         streamice_density_ocean_avg * grd_below_sl *
     &         R_low(i-1,j-1,bi,bj)**2)
#endif

            ELSE

#ifdef STREAMICE_FIRN_CORRECTION

             if (STREAMICE_apply_firn_correction) then
             if (H_streamice(i-1,j-1,bi,bj).lt.firn_depth) then
              taudx_si(i,j,bi,bj) = taudx_si(i,j,bi,bj) +
     &         0.25 * dyG(i,j-1,bi,bj) *
     &         streamice_density_firn * gravity *
     &         (1-streamice_density_firn*i_rhow) *
     &         H_streamice(i-1,j-1,bi,bj)**2
             else
              taudx_si(i,j,bi,bj) = taudx_si(i,j,bi,bj) +
     &         0.25 * dyG(i,j-1,bi,bj) * gravity * (
     &         streamice_density_firn * firn_depth**2 +
     &         (h_streamice(i-1,j-1,bi,bj)-firn_depth) *
     &          (streamice_density_firn*firn_depth+streamice_density*
     &          (h_streamice(i-1,j-1,bi,bj)-streamice_firn_correction))-
     &         streamice_density**2*i_rhow*
     &         (h_streamice(i-1,j-1,bi,bj)-streamice_firn_correction)**2
     &         )
             endif
             else

#endif
             taudx_si(i,j,bi,bj) = taudx_si(i,j,bi,bj) +
     &        0.25 * dyG(i,j-1,bi,bj) *
     &        streamice_density * gravity *
     &        (1-streamice_density*i_rhow) *
     &         H_streamice(i-1,j-1,bi,bj)**2
#ifdef STREAMICE_FIRN_CORRECTION
             endif
#endif

            ENDIF

           ELSE IF (streamice_hmask(i,j-1,bi,bj).eq.1.0) THEN

            IF (float_frac_streamice(i,j-1,bi,bj) .eq. 1.0) THEN

#ifdef USE_ALT_RLOW
             IF (R_low_si(i,j-1,bi,bj) .lt. 0. _d 0) then
#else
             IF (R_low(i,j-1,bi,bj) .lt. 0. _d 0) then
#endif
              grd_below_sl = 1. _d 0
             else
              grd_below_sl = 0. _d 0
             endif

             taudx_si(i,j,bi,bj) = taudx_si(i,j,bi,bj) -
     &        0.25 * dyg(i,j-1,bi,bj) *
     &        gravity *
     &        (avg_density(i,j-1,bi,bj) * H_streamice(i,j-1,bi,bj)**2 -
#ifdef USE_ALT_RLOW
     &         streamice_density_ocean_avg * grd_below_sl *
     &         R_low_si(i,j-1,bi,bj)**2)
#else
     &         streamice_density_ocean_avg * grd_below_sl *
     &         R_low(i,j-1,bi,bj)**2)
#endif

            ELSE

#ifdef STREAMICE_FIRN_CORRECTION
             if (STREAMICE_apply_firn_correction) then
             if (H_streamice(i,j-1,bi,bj).lt.firn_depth) then
              taudx_si(i,j,bi,bj) = taudx_si(i,j,bi,bj) -
     &         0.25 * dyG(i,j-1,bi,bj) *
     &         streamice_density_firn * gravity *
     &         (1-streamice_density_firn*i_rhow) *
     &         H_streamice(i,j-1,bi,bj)**2
             else
              taudx_si(i,j,bi,bj) = taudx_si(i,j,bi,bj) -
     &         0.25 * dyG(i,j-1,bi,bj) * gravity * (
     &         streamice_density_firn * firn_depth**2 +
     &         (h_streamice(i,j-1,bi,bj)-firn_depth) *
     &          (streamice_density_firn*firn_depth+streamice_density*
     &          (h_streamice(i,j-1,bi,bj)-streamice_firn_correction))-
     &         streamice_density**2*i_rhow*
     &         (h_streamice(i,j-1,bi,bj)-streamice_firn_correction)**2
     &         )
             endif
             else

#endif
             taudx_si(i,j,bi,bj) = taudx_si(i,j,bi,bj) -
     &        0.25 * dyG(i,j-1,bi,bj) *
     &        streamice_density * gravity *
     &        (1-streamice_density*i_rhow) *
     &         H_streamice(i,j-1,bi,bj)**2
#ifdef STREAMICE_FIRN_CORRECTION
             endif
#endif

            END IF
           END IF
          END IF       ! if umask==1

c!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

          IF (streamice_vmask(i,j,bi,bj).eq.1.0) THEN

           IF (streamice_hmask(i,j-1,bi,bj).eq.1.0.AND.
     &      streamice_hmask(i,j,bi,bj).eq.1.0) THEN

c             geom_fac = sqrt(rA(i,j-1,bi,bj)*recip_rA(i,j,bi,bj)*
c      &        dxF(i,j,bi,bj)*recip_dyF(i,j-1,bi,bj))

            taudy_si(i,j,bi,bj) = taudy_si(i,j,bi,bj) -
     &       0.25 * dxG(i,j,bi,bj) *
     &       gravity *
     &       (H_streamice(i,j,bi,bj)*avg_density(i,j,bi,bj)+
     &        H_streamice(i,j-1,bi,bj)*avg_density(i,j-1,bi,bj))*
     &       (surf_el_streamice(i,j,bi,bj)-
     &              surf_el_streamice(i,j-1,bi,bj))

            taudy_si(i,j,bi,bj) = taudy_si(i,j,bi,bj) -
     &       streamice_density * gravity *
     &       streamice_bg_surf_slope_y * .25 * rA(i,j,bi,bj) *
     &       (H_streamice(i,j-1,bi,bj) + H_streamice(i,j,bi,bj))

           ELSE IF (streamice_hmask(i,j-1,bi,bj).eq.1.0) THEN

            IF (float_frac_streamice(i,j-1,bi,bj) .eq. 1.0) THEN

#ifdef USE_ALT_RLOW
             IF (R_low_si(i,j-1,bi,bj) .lt. 0. _d 0) then
#else
             IF (R_low(i,j-1,bi,bj) .lt. 0. _d 0) then
#endif
              grd_below_sl = 1. _d 0
             else
              grd_below_sl = 0. _d 0
             endif

             taudy_si(i,j,bi,bj) = taudy_si(i,j,bi,bj) +
     &        0.25 * dxG(i,j,bi,bj) *
     &        gravity *
     &        (avg_density(i,j-1,bi,bj) * H_streamice(i,j-1,bi,bj)**2 -
#ifdef USE_ALT_RLOW
     &         streamice_density_ocean_avg * grd_below_sl *
     &         R_low_si(i,j-1,bi,bj)**2)
#else
     &         streamice_density_ocean_avg * grd_below_sl *
     &         R_low(i,j-1,bi,bj)**2)
#endif

            ELSE

#ifdef STREAMICE_FIRN_CORRECTION
             if (STREAMICE_apply_firn_correction) then
             if (H_streamice(i,j-1,bi,bj).lt.firn_depth) then
              taudy_si(i,j,bi,bj) = taudy_si(i,j,bi,bj) +
     &         0.25 * dxG(i,j,bi,bj) *
     &         streamice_density_firn * gravity *
     &         (1-streamice_density_firn*i_rhow) *
     &         H_streamice(i,j-1,bi,bj)**2
             else
              taudy_si(i,j,bi,bj) = taudy_si(i,j,bi,bj) +
     &         0.25 * dxG(i,j,bi,bj) * gravity * (
     &         streamice_density_firn * firn_depth**2 +
     &         (h_streamice(i,j-1,bi,bj)-firn_depth) *
     &          (streamice_density_firn*firn_depth+streamice_density*
     &          (h_streamice(i,j-1,bi,bj)-streamice_firn_correction))-
     &         streamice_density**2*i_rhow*
     &         (h_streamice(i,j-1,bi,bj)-streamice_firn_correction)**2
     &         )
             endif
             else

#endif
             taudy_si(i,j,bi,bj) = taudy_si(i,j,bi,bj) +
     &        0.25 * dxG(i,j,bi,bj) *
     &        streamice_density * gravity *
     &        (1-streamice_density*i_rhow) *
     &         H_streamice(i,j-1,bi,bj)**2
#ifdef STREAMICE_FIRN_CORRECTION
             endif
#endif

            ENDIF

           ELSE IF (streamice_hmask(i,j,bi,bj).eq.1.0) THEN

            IF (float_frac_streamice(i,j,bi,bj) .eq. 1.0) THEN

#ifdef USE_ALT_RLOW
             IF (R_low_si(i,j,bi,bj) .lt. 0. _d 0) then
#else
             IF (R_low(i,j,bi,bj) .lt. 0. _d 0) then
#endif
              grd_below_sl = 1. _d 0
             else
              grd_below_sl = 0. _d 0
             endif

             taudy_si(i,j,bi,bj) = taudy_si(i,j,bi,bj) -
     &        0.25 * dxG(i,j,bi,bj) *
     &        gravity *
     &        (avg_density(i,j,bi,bj) * H_streamice(i,j,bi,bj)**2 -
#ifdef USE_ALT_RLOW
     &         streamice_density_ocean_avg * grd_below_sl *
     &         R_low_si(i,j,bi,bj)**2)
#else
     &         streamice_density_ocean_avg * grd_below_sl *
     &         R_low(i,j,bi,bj)**2)
#endif

            ELSE

#ifdef STREAMICE_FIRN_CORRECTION
             if (STREAMICE_apply_firn_correction) then
             if (H_streamice(i,j,bi,bj).lt.firn_depth) then
              taudy_si(i,j,bi,bj) = taudy_si(i,j,bi,bj) -
     &         0.25 * dxG(i,j,bi,bj) *
     &         streamice_density_firn * gravity *
     &         (1-streamice_density_firn*i_rhow) *
     &         H_streamice(i,j,bi,bj)**2
             else
              taudy_si(i,j,bi,bj) = taudy_si(i,j,bi,bj) -
     &         0.25 * dxG(i,j,bi,bj) * gravity * (
     &         streamice_density_firn * firn_depth**2 +
     &         (h_streamice(i,j,bi,bj)-firn_depth) *
     &          (streamice_density_firn*firn_depth+streamice_density*
     &          (h_streamice(i,j,bi,bj)-streamice_firn_correction))-
     &         streamice_density**2*i_rhow*
     &         (h_streamice(i,j,bi,bj)-streamice_firn_correction)**2
     &         )
             endif
             else

#endif
             taudy_si(i,j,bi,bj) = taudy_si(i,j,bi,bj) -
     &        0.25 * dxG(i,j,bi,bj) *
     &        streamice_density * gravity *
     &        (1-streamice_density*i_rhow) *
     &         H_streamice(i,j,bi,bj)**2
#ifdef STREAMICE_FIRN_CORRECTION
             endif
#endif

            END IF
           END IF

c cells to left

           IF (streamice_hmask(i-1,j-1,bi,bj).eq.1.0.AND.
     &      streamice_hmask(i-1,j,bi,bj).eq.1.0) THEN

c             geom_fac = sqrt(rA(i-1,j-1,bi,bj)*recip_rA(i-1,j,bi,bj)*
c      &        dxF(i-1,j,bi,bj)*recip_dxF(i-1,j-1,bi,bj))

            taudy_si(i,j,bi,bj) = taudy_si(i,j,bi,bj) -
     &       0.25 * dxG(i-1,j,bi,bj) *
     &       gravity *
     &       (H_streamice(i-1,j,bi,bj)*avg_density(i-1,j,bi,bj)+
     &        H_streamice(i-1,j-1,bi,bj)*avg_density(i-1,j-1,bi,bj))*
     &       (surf_el_streamice(i-1,j,bi,bj)-
     &              surf_el_streamice(i-1,j-1,bi,bj))

            taudy_si(i,j,bi,bj) = taudy_si(i,j,bi,bj) -
     &       streamice_density * gravity *
     &       streamice_bg_surf_slope_y * .25 * rA(i-1,j,bi,bj) *
     &       (H_streamice(i-1,j-1,bi,bj) + H_streamice(i-1,j,bi,bj))

           ELSE IF (streamice_hmask(i-1,j-1,bi,bj).eq.1.0) THEN

            IF (float_frac_streamice(i-1,j-1,bi,bj) .eq. 1.0) THEN

#ifdef USE_ALT_RLOW
             IF (R_low_si(i-1,j-1,bi,bj) .lt. 0. _d 0) then
#else
             IF (R_low(i-1,j-1,bi,bj) .lt. 0. _d 0) then
#endif
              grd_below_sl = 1. _d 0
             else
              grd_below_sl = 0. _d 0
             endif

             taudy_si(i,j,bi,bj) = taudy_si(i,j,bi,bj) +
     &        0.25 * dxG(i-1,j,bi,bj) *
     &        gravity *
     &        (avg_density(i-1,j-1,bi,bj)*H_streamice(i-1,j-1,bi,bj)**2-
#ifdef USE_ALT_RLOW
     &         streamice_density_ocean_avg*grd_below_sl *
     &         R_low_si(i-1,j-1,bi,bj)**2)
#else
     &         streamice_density_ocean_avg * grd_below_sl *
     &         R_low(i-1,j-1,bi,bj)**2)
#endif

            ELSE

#ifdef STREAMICE_FIRN_CORRECTION
             if (STREAMICE_apply_firn_correction) then
             if (H_streamice(i-1,j-1,bi,bj).lt.firn_depth) then
              taudy_si(i,j,bi,bj) = taudy_si(i,j,bi,bj) +
     &         0.25 * dxG(i-1,j,bi,bj) *
     &         streamice_density_firn * gravity *
     &         (1-streamice_density_firn*i_rhow) *
     &         H_streamice(i-1,j-1,bi,bj)**2
             else
              taudy_si(i,j,bi,bj) = taudy_si(i,j,bi,bj) +
     &         0.25 * dxG(i-1,j,bi,bj) * gravity * (
     &         streamice_density_firn * firn_depth**2 +
     &         (h_streamice(i-1,j-1,bi,bj)-firn_depth) *
     &          (streamice_density_firn*firn_depth+streamice_density*
     &          (h_streamice(i-1,j-1,bi,bj)-streamice_firn_correction))-
     &         streamice_density**2*i_rhow*
     &        (h_streamice(i-1,j-1,bi,bj)-streamice_firn_correction)**2
     &         )
             endif
             else
#endif
             taudy_si(i,j,bi,bj) = taudy_si(i,j,bi,bj) +
     &        0.25 * dxG(i-1,j,bi,bj) *
     &        streamice_density * gravity *
     &        (1-streamice_density*i_rhow) *
     &         H_streamice(i-1,j-1,bi,bj)**2
#ifdef STREAMICE_FIRN_CORRECTION
             endif
#endif

            ENDIF

           ELSE IF (streamice_hmask(i-1,j,bi,bj).eq.1.0) THEN

            IF (float_frac_streamice(i-1,j,bi,bj) .eq. 1.0) THEN

#ifdef USE_ALT_RLOW
             IF (R_low_si(i-1,j,bi,bj) .lt. 0. _d 0) then
#else
             IF (R_low(i-1,j,bi,bj) .lt. 0. _d 0) then
#endif
              grd_below_sl = 1. _d 0
             else
              grd_below_sl = 0. _d 0
             endif

             taudy_si(i,j,bi,bj) = taudy_si(i,j,bi,bj) -
     &        0.25 * dxG(i-1,j,bi,bj) *
     &        gravity *
     &        (avg_density(i-1,j,bi,bj) * H_streamice(i-1,j,bi,bj)**2 -
#ifdef USE_ALT_RLOW
     &         streamice_density_ocean_avg * grd_below_sl *
     &         R_low_si(i-1,j,bi,bj)**2)
#else
     &         streamice_density_ocean_avg * grd_below_sl *
     &         R_low(i-1,j,bi,bj)**2)
#endif

            ELSE

#ifdef STREAMICE_FIRN_CORRECTION
             if (STREAMICE_apply_firn_correction) then
             if (H_streamice(i-1,j,bi,bj).lt.firn_depth) then
              taudy_si(i,j,bi,bj) = taudy_si(i,j,bi,bj) -
     &         0.25 * dxG(i-1,j,bi,bj) *
     &         streamice_density_firn * gravity *
     &         (1-streamice_density_firn*i_rhow) *
     &         H_streamice(i-1,j,bi,bj)**2
             else
              taudy_si(i,j,bi,bj) = taudy_si(i,j,bi,bj) -
     &         0.25 * dxG(i-1,j,bi,bj) * gravity * (
     &         streamice_density_firn * firn_depth**2 +
     &         (h_streamice(i-1,j,bi,bj)-firn_depth) *
     &          (streamice_density_firn*firn_depth+streamice_density*
     &          (h_streamice(i-1,j,bi,bj)-streamice_firn_correction))-
     &         streamice_density**2*i_rhow*
     &        (h_streamice(i-1,j,bi,bj)-streamice_firn_correction)**2
     &         )
             endif
             else
#endif
             taudy_si(i,j,bi,bj) = taudy_si(i,j,bi,bj) -
     &        0.25 * dxG(i-1,j,bi,bj) *
     &        streamice_density * gravity *
     &        (1-streamice_density*i_rhow) *
     &         H_streamice(i-1,j,bi,bj)**2
#ifdef STREAMICE_FIRN_CORRECTION
             endif
#endif

            END IF
           END IF
          END IF      ! if vmask ==1

         ENDDO
        ENDDO
       ENDDO
      ENDDO

c      taudx_SI (1,1,1,1) = taudx_SI (1,1,1,1) +
c     & streamice_v_normal_pert (1,1,1,1)
c       call write_fld_xy_rl("TAUDX_SI","",taudx_si,0,myThid)
c       call write_fld_xy_rl("TAUDY_SI","",taudy_si,0,myThid)

#endif
      RETURN
      END

#include "GAD_OPTIONS.h"

CBOP
C !ROUTINE: GAD_DST3_ADV_Y

C !INTERFACE: ==========================================================
      SUBROUTINE GAD_DST3_ADV_Y(
     I           bi,bj,k, calcCFL, deltaTloc,
     I           vTrans, vFld,
     I           maskLocS, tracer,
     O           vT,
     I           myThid )
C !DESCRIPTION:
C  Calculates the area integrated Meridional flux due to advection of a
C  tracer using 3rd-order Direct Space and Time (DST-3) Advection Scheme

C !USES: ===============================================================
      IMPLICIT NONE

C     == GLobal variables ==
#include "SIZE.h"
#ifdef OLD_DST3_FORMULATION
#include "EEPARAMS.h"
#include "PARAMS.h"
#endif
#include "GRID.h"
#include "GAD.h"

C     == Routine arguments ==
C !INPUT PARAMETERS: ===================================================
C  bi,bj             :: tile indices
C  k                 :: vertical level
C  calcCFL           :: =T: calculate CFL number ; =F: take vFld as CFL
C  deltaTloc         :: local time-step (s)
C  vTrans            :: meridional volume transport
C  vFld              :: meridional flow / CFL number
C  tracer            :: tracer field
C  myThid            :: thread number
      INTEGER bi,bj,k
      LOGICAL calcCFL
      _RL deltaTloc
      _RL vTrans(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL vFld  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RS maskLocS(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL tracer(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER myThid

C !OUTPUT PARAMETERS: ==================================================
C  vT                :: meridional advective flux
      _RL vT    (1-OLx:sNx+OLx,1-OLy:sNy+OLy)

C     == Local variables ==
C !LOCAL VARIABLES: ====================================================
C  i,j               :: loop indices
C  vCFL              :: Courant-Friedrich-Levy number
      INTEGER i,j
      _RL Rjm,Rj,Rjp,vCFL,d0,d1
#ifdef OLD_DST3_FORMULATION
      _RL psiP,psiM,thetaP,thetaM
      _RL smallNo
c     _RL Rjjm,Rjjp

c     IF (inAdMode .AND. useApproxAdvectionInAdMode) THEN
c      smallNo = 1.0D-20
c     ELSE
       smallNo = 1.0D-20
c     ENDIF
#endif

      DO i=1-OLx,sNx+OLx
       vT(i,1-OLy)=0.
       vT(i,2-OLy)=0.
       vT(i,sNy+OLy)=0.
      ENDDO
      DO j=1-OLy+2,sNy+OLy-1
       DO i=1-OLx,sNx+OLx
        Rjp=(tracer(i,j+1)-tracer(i, j ))*maskLocS(i,j+1)
        Rj =(tracer(i, j )-tracer(i,j-1))*maskLocS(i, j )
        Rjm=(tracer(i,j-1)-tracer(i,j-2))*maskLocS(i,j-1)

        vCFL = vFld(i,j)
        IF ( calcCFL ) vCFL = ABS( vFld(i,j)*deltaTloc
     &                  *recip_dyC(i,j,bi,bj)*recip_deepFacC(k) )
        d0=(2.-vCFL)*(1.-vCFL)*oneSixth
        d1=(1.-vCFL*vCFL)*oneSixth
#ifdef OLD_DST3_FORMULATION
        IF ( ABS(Rj).LT.smallNo .OR.
     &       ABS(Rjm).LT.smallNo ) THEN
         thetaP=0.
         psiP=0.
        ELSE
         thetaP=(Rjm+smallNo)/(smallNo+Rj)
         psiP=d0+d1*thetaP
        ENDIF
        IF ( ABS(Rj).LT.smallNo .OR.
     &       ABS(Rjp).LT.smallNo ) THEN
         thetaM=0.
         psiM=0.
        ELSE
         thetaM=(Rjp+smallNo)/(smallNo+Rj)
         psiM=d0+d1*thetaM
        ENDIF
        vT(i,j)=
     &   0.5*(vTrans(i,j)+ABS(vTrans(i,j)))
     &      *( Tracer(i,j-1) + psiP*Rj )
     &  +0.5*(vTrans(i,j)-ABS(vTrans(i,j)))
     &      *( Tracer(i, j ) - psiM*Rj )
#else /* OLD_DST3_FORMULATION */
        vT(i,j)=
     &   0.5*(vTrans(i,j)+ABS(vTrans(i,j)))
     &      *( Tracer(i,j-1) + (d0*Rj+d1*Rjm) )
     &  +0.5*(vTrans(i,j)-ABS(vTrans(i,j)))
     &      *( Tracer(i, j ) - (d0*Rj+d1*Rjp) )
#endif /* OLD_DST3_FORMULATION */

       ENDDO
      ENDDO

      RETURN
      END

#include "REGRID_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 0
C     !ROUTINE: REGRID_READPARMS

C     !INTERFACE:
      SUBROUTINE REGRID_READPARMS( myThid )

C     !DESCRIPTION:
C     Initialize REGRID variables and constants.

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "REGRID_SIZE.h"
#include "REGRID.h"

C     !INPUT PARAMETERS:
      INTEGER myThid
CEOP

#ifdef ALLOW_REGRID

      CHARACTER*(MAX_LEN_MBUF) msgBuf
      CHARACTER*(MAX_LEN_FNAM) blank
      INTEGER iUnit, i

      NAMELIST /REGRID_PARM01/
     &     regrid_MNC, regrid_MDSIO,
     &     regrid_ngrids, regrid_fbname_in,
     &     regrid_nout

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      IF ( .NOT.useREGRID ) THEN
C-    pkg REGRID is not used
        _BEGIN_MASTER(myThid)
C-    Track pkg activation status:
C     print a (weak) warning if data.regrid is found
         CALL PACKAGES_UNUSED_MSG( 'useREGRID', ' ', ' ' )
        _END_MASTER(myThid)
        RETURN
      ENDIF

      _BEGIN_MASTER(myThid)

      DO i = 1,MAX_LEN_FNAM
        blank(i:i) = ' '
      ENDDO

C     Default values for REGRID
      REGRID_MNC      = useMNC
      REGRID_MDSIO    = .FALSE.
      regrid_ngrids   = 0
      DO i = 1,REGRID_NGRID_MAX
        REGRID_fbname_in(i)(1:MAX_LEN_FNAM) = blank(1:MAX_LEN_FNAM)
        REGRID_fbname_out(i)(1:MAX_LEN_FNAM) = blank(1:MAX_LEN_FNAM)
        regrid_nout(i) = 0
      ENDDO

      WRITE(msgBuf,'(A)') 'REGRID_READPARMS: opening data.regrid'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT , 1)
      CALL OPEN_COPY_DATA_FILE(
     I                     'data.regrid', 'REGRID_READPARMS',
     O                     iUnit,
     I                     myThid )

C     Read parameters from open data file
      READ(UNIT=iUnit,NML=REGRID_PARM01)
      WRITE(msgBuf,'(A)')
     &     'REGRID_READPARMS: finished reading data.regrid'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &     SQUEEZE_RIGHT , 1)
C     Close the open data file
#ifdef SINGLE_DISK_IO
      CLOSE(iUnit)
#else
      CLOSE(iUnit,STATUS='DELETE')
#endif /* SINGLE_DISK_IO */

C     Make sure that we locally honor the global MNC on/off flag
      REGRID_MNC = REGRID_MNC .AND. useMNC
#ifndef ALLOW_MNC
C     Fix to avoid running without getting any output:
      REGRID_MNC = .FALSE.
#endif
      REGRID_MDSIO = (.NOT. REGRID_MNC) .OR. outputTypesInclusive

      _END_MASTER(myThid)

C--   Everyone else must wait for the parameters to be loaded
      _BARRIER

#endif /* ALLOW_REGRID */

      RETURN
      END

#include "GAD_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: GAD_READ_PICKUP

C     !INTERFACE:
      SUBROUTINE GAD_READ_PICKUP( myIter, myThid )

C     !DESCRIPTION:
C     Reads current state of 2nd.Order moments from a pickup file

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GAD.h"
#include "GAD_SOM_VARS.h"
#ifdef ALLOW_MNC
#include "MNC_PARAMS.h"
#endif

C     !INPUT PARAMETERS:
C     myIter  :: time-step number
C     myThid  :: thread number
      INTEGER myIter
      INTEGER myThid

#ifdef GAD_ALLOW_TS_SOM_ADV

C     !LOCAL VARIABLES:
C     n       :: 2nd.O. moment loop index
C     iRec    :: record number
C     fn      :: character buffer for creating filename
C     prec    :: precision of pickup files
      INTEGER n, prec, iRec
      CHARACTER*(10) suff
      CHARACTER*(MAX_LEN_FNAM) fn, filNam
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      INTEGER ioUnit
      LOGICAL useCurrentDir, fileExist
CEOP

C-    Need to synchronize here before doing master-thread IO
C note: not presently needed (synchronized through MDS_CHECK4FILE call)
c     _BARRIER
      ioUnit = errorMessageUnit

#ifdef ALLOW_MNC
      IF ( useMNC .AND. pickup_read_mnc ) THEN
c      IF ( tempSOM_Advection ) THEN
C       Read variables from the pickup file
c       WRITE(fn,'(a)') 'pickup_som'
c       CALL MNC_FILE_CLOSE_ALL_MATCHING(fn, myThid)
c       CALL MNC_CW_SET_UDIM(fn, 1, myThid)
c       CALL MNC_CW_SET_CITER(fn, 3, 3, myIter, -1, myThid)
c       prefix = 'somT_'
c       DO n = 1,nSOM
c         CALL MNC_CW_RL_R('D',fn,0,0, som_name,
c    &         som_T(1-OLx,1-OLy,1,1,1,n),myThid)
c       ENDDO
c      ENDIF
      ENDIF
#endif /*  ALLOW_MNC  */

c     IF ( pickup_read_mdsio .AND. tempSOM_Advection ) THEN
      IF ( tempSOM_Advection ) THEN
C--   Pot. Temp. 2nd.Order moments

        IF (pickupSuff .EQ. ' ') THEN
          IF ( rwSuffixType.EQ.0 ) THEN
            WRITE(fn,'(A,I10.10)') 'pickup_somT.', myIter
          ELSE
            CALL RW_GET_SUFFIX( suff, startTime, myIter, myThid )
            WRITE(fn,'(A,A)') 'pickup_somT.', suff
          ENDIF
        ELSE
          WRITE(fn,'(A,A10)') 'pickup_somT.', pickupSuff
        ENDIF

C-      First check if pickup file exist
#ifdef ALLOW_MDSIO
        useCurrentDir = .FALSE.
        CALL MDS_CHECK4FILE(
     I                       fn, '.data', 'GAD_READ_PICKUP',
     O                       filNam, fileExist,
     I                       useCurrentDir, myThid )
#else
        STOP 'ABNORMAL END: S/R GAD_READ_PICKUP: Needs MDSIO pkg'
#endif

        IF ( fileExist ) THEN
C-      Read 2nd Order moments as consecutive records
          prec = precFloat64
          DO n=1,nSOM
            iRec = n
            CALL READ_REC_3D_RL( fn, prec, Nr,
     O                som_T(1-OLx,1-OLy,1,1,1,n),
     I                iRec, myIter, myThid )
          ENDDO
        ELSE
          IF ( pickupStrictlyMatch ) THEN
            WRITE(msgBuf,'(4A)') 'GAD_READ_PICKUP: ',
     &        'try with " pickupStrictlyMatch=.FALSE.,"',
     &        ' in file: "data", NameList: "PARM03"'
            CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
            STOP 'ABNORMAL END: S/R GAD_READ_PICKUP'
          ELSE
            WRITE(msgBuf,'(2A)') 'WARNING >> GAD_READ_PICKUP: ',
     &        'approximated restart: reset SOM_T to zero'
            CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
          ENDIF
        ENDIF

      ENDIF

c     IF ( pickup_read_mdsio .AND. saltSOM_Advection ) THEN
      IF ( saltSOM_Advection ) THEN
C--   Salinity 2nd.Order moments

        IF (pickupSuff .EQ. ' ') THEN
          IF ( rwSuffixType.EQ.0 ) THEN
            WRITE(fn,'(A,I10.10)') 'pickup_somS.', myIter
          ELSE
            CALL RW_GET_SUFFIX( suff, startTime, myIter, myThid )
            WRITE(fn,'(A,A)') 'pickup_somS.', suff
          ENDIF
        ELSE
          WRITE(fn,'(A,A10)') 'pickup_somS.', pickupSuff
        ENDIF

C-      First check if pickup file exist
#ifdef ALLOW_MDSIO
        useCurrentDir = .FALSE.
        CALL MDS_CHECK4FILE(
     I                       fn, '.data', 'GAD_READ_PICKUP',
     O                       filNam, fileExist,
     I                       useCurrentDir, myThid )
#else
        STOP 'ABNORMAL END: S/R GAD_READ_PICKUP: Needs MDSIO pkg'
#endif

        IF ( fileExist ) THEN
C-      Read 2nd Order moments as consecutive records
          prec = precFloat64
          DO n=1,nSOM
            iRec = n
            CALL READ_REC_3D_RL( fn, prec, Nr,
     O                som_S(1-OLx,1-OLy,1,1,1,n),
     I                iRec, myIter, myThid )
          ENDDO
        ELSE
          IF ( pickupStrictlyMatch ) THEN
            WRITE(msgBuf,'(4A)') 'GAD_READ_PICKUP: ',
     &        'try with " pickupStrictlyMatch=.FALSE.,"',
     &        ' in file: "data", NameList: "PARM03"'
            CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
            STOP 'ABNORMAL END: S/R GAD_READ_PICKUP'
          ELSE
            WRITE(msgBuf,'(2A)') 'WARNING >> GAD_READ_PICKUP: ',
     &        'approximated restart: reset SOM_S to zero'
            CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
          ENDIF
        ENDIF

      ENDIF

#endif /* GAD_ALLOW_TS_SOM_ADV */

      RETURN
      END

#include "CPP_EEOPTIONS.h"

CBOP
C     !ROUTINE: MDS_FLUSH

C     !INTERFACE:
      SUBROUTINE MDS_FLUSH( ioUnit, myThid )

C     !DESCRIPTION:
C     call the intrinsic subroutine FLUSH (if available) on the ioUnit argument

C     !USES:
      IMPLICIT NONE
#include "EEPARAMS.h"

C     !INPUT PARAMETERS:
C     ioUnit (integer) :: unit number
C     myThid (integer) :: my Thread Id number
      INTEGER ioUnit
      INTEGER myThid

C     !LOCAL VARIABLES:
CEOP

#ifdef HAVE_FLUSH
      CALL FLUSH( ioUnit )
#endif

      RETURN
      END

#include "COST_OPTIONS.h"
#ifdef ALLOW_CTRL
# include "CTRL_OPTIONS.h"
#endif

CBOP
C     !ROUTINE: COST_WEIGHTS
C     !INTERFACE:
      SUBROUTINE COST_WEIGHTS( myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE COST_WEIGHTS
C     | o Set weights used in the cost function
C     *==========================================================*
C
C     \ev
C     !USES:
      IMPLICIT NONE
C     == Global variables ===
#include "EEPARAMS.h"
#include "SIZE.h"
#include "PARAMS.h"
#include "GRID.h"
#ifdef ALLOW_OPENAD
# include "FFIELDS.h"
#else
# include "cost_local.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
      INTEGER  myThid

C     !FUNCTIONS:
      INTEGER  MDS_RECLEN
      EXTERNAL MDS_RECLEN

C     !LOCAL VARIABLES:
      INTEGER bi,bj
      INTEGER i,j,k
      INTEGER iUnit, length_of_rec

      _RL dummy
      _RL wti(Nr)
      REAL*8 tmpwti(Nr)
      CHARACTER*(MAX_LEN_MBUF) msgBuf
CEOP

C--   Initialize variance (weight) fields.
      DO k = 1,Nr
       wti(k) = 0. _d 0
      ENDDO
      DO bj = myByLo(myThid),myByHi(myThid)
       DO bi = myBxLo(myThid),myBxHi(myThid)
        DO j = 1-OLy,sNy+OLy
         DO i = 1-OLx,sNx+OLx
          whfluxm(i,j,bi,bj)= 0. _d 0
         ENDDO
        ENDDO
        DO k = 1,Nr
         wtheta(k,bi,bj) = 0. _d 0
        ENDDO
       ENDDO
      ENDDO

C--   Read error information and set up weight matrices.

#ifdef ALLOW_COST_TEMP
C  Temperature weights for cost function
       _BEGIN_MASTER(myThid)
       CALL MDSFINDUNIT( iUnit, myThid )
       length_of_rec = MDS_RECLEN( precFloat64, Nr, myThid )
       OPEN( iUnit, FILE='Err_levitus_15layer.bin', STATUS='OLD',
     &       FORM='UNFORMATTED',ACCESS='DIRECT',RECL=length_of_rec )
       READ(iUnit,rec=1) tmpwti
       CLOSE(iUnit)
#ifdef _BYTESWAPIO
       CALL MDS_BYTESWAPR8( Nr, tmpwti )
#endif
       _END_MASTER(myThid)
       _BARRIER

       DO k=1,Nr
         wti(k) = tmpwti(k)
       ENDDO
       WRITE(msgBuf,'(3A)') 'S/R COST_WEIGHTS:',
     &  ' Temperature weights loaded from: ','Err_levitus_15layer.bin'
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                     SQUEEZE_RIGHT , myThid )

c     print*,'Weights for temperature: wti', (wti(k),k=1,nr)

      DO bj = myByLo(myThid),myByHi(myThid)
        DO bi = myBxLo(myThid),myBxHi(myThid)
          DO k = 1, Nr
               wtheta(k,bi,bj) = 1. _d 0/wti(k)/wti(k)
          ENDDO
        ENDDO
      ENDDO
#endif /* ALLOW_COST_TEMP */

C--   Then the hflux weights :

#ifdef ALLOW_COST_HFLUXM
      CALL READ_REC_3D_RL( 'Err_hflux.bin', precFloat64, 1,
     &                      whfluxm, 1, 0, myThid )
      _EXCH_XY_RL(whfluxm   , myThid )
      DO bj = myByLo(myThid),myByHi(myThid)
        DO bi = myBxLo(myThid),myBxHi(myThid)
          DO j = 1-OLy,sNy+OLy
            DO i = 1-OLx,sNx+OLx
c            print*,'Uncertainties for Heat Flux',i,j,whfluxm(i,j,bi,bj)
             IF (whfluxm(i,j,bi,bj) .NE. 0. _d 0) THEN
                 whfluxm(i,j,bi,bj) = 1. _d 0 /whfluxm(i,j,bi,bj)
     &                                        /whfluxm(i,j,bi,bj)
             ELSE
                 whfluxm(i,j,bi,bj) = 1. _d 0
             ENDIF
            ENDDO
          ENDDO
        ENDDO
      ENDDO
#ifdef ALLOW_NONDIMENSIONAL_CONTROL_IO
      CALL ACTIVE_WRITE_XY('whfluxm',whfluxm,1,0,myThid,dummy)
#endif
#endif /* ALLOW_COST_HFLUXM */
      RETURN
      END

#include "GCHEM_OPTIONS.h"
#ifdef ALLOW_BLING
# include "BLING_OPTIONS.h"
#endif
#ifdef ALLOW_DARWIN
# include "DARWIN_OPTIONS.h"
#endif

C !INTERFACE: ==========================================================
      SUBROUTINE GCHEM_INIT_VARI(myThid )

C !DESCRIPTION:
C calls subroutines that initialize any time dependent variables
C for any tracer experiment

C !USES: ===============================================================
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#ifdef ALLOW_AUTODIFF
# include "GRID.h"
# include "DYNVARS.h"
#endif /* ALLOW_AUTODIFF */
#include "GCHEM.h"
#include "GCHEM_SIZE.h"
#include "GCHEM_FIELDS.h"

C !INPUT PARAMETERS: ===================================================
C  myThid               :: thread number
      INTEGER myThid
CEOP

C !LOCAL VARIABLES: ====================================================
C  i,j,k,bi,bj          :: loop indices
C  jTr                  :: ptracer number
#ifdef GCHEM_ADD2TR_TENDENCY
      INTEGER i,j,k
      INTEGER bi,bj
      INTEGER jTr
#endif /* GCHEM_ADD2TR_TENDENCY */

C--   Initialise GCHEM variables:

#ifdef GCHEM_ADD2TR_TENDENCY
      DO jTr = 1, GCHEM_tendTr_num
       DO bj=myByLo(myThid),myByHi(myThid)
        DO bi=myBxLo(myThid),myBxHi(myThid)
         DO k = 1, Nr
          DO j = 1-OLy, sNy+OLy
           DO i = 1-OLx, sNx+OLx
            gchemTendency(i,j,k,bi,bj,jTr) = 0. _d 0
           ENDDO
          ENDDO
         ENDDO
        ENDDO
       ENDDO
      ENDDO
#endif /* GCHEM_ADD2TR_TENDENCY */

C--   Initialise other Geo-Chemistry pkg variables:

#ifdef ALLOW_DIC
# ifdef ALLOW_AUTODIFF
      IF ( .NOT.useDIC ) STOP 'ABNORMAL END: S/R GCHEM_INIT_VARI'
# else /* ALLOW_AUTODIFF */
      IF ( useDIC ) THEN
# endif /* ALLOW_AUTODIFF */
         CALL DIC_INIT_VARIA(myThid)
# ifndef ALLOW_AUTODIFF
      ENDIF
# endif
#endif /* ALLOW_DIC */

#ifdef ALLOW_BLING
# ifndef ALLOW_AUTODIFF_TAMC
      IF ( useBLING ) THEN
# endif
         CALL BLING_INIT_VARIA(myThid)
         CALL BLING_INI_FORCING(myThid)
         CALL BLING_CARBONATE_INIT(myThid)
# ifndef ALLOW_AUTODIFF_TAMC
      ENDIF
# endif
#endif /* ALLOW_BLING */

#ifdef ALLOW_SPOIL
      IF ( useSPOIL ) THEN
         CALL SPOIL_INIT_VARIA( myThid )
      ENDIF
#endif /* ALLOW_SPOIL */

#ifdef ALLOW_DARWIN
      IF ( useDARWIN ) THEN
         CALL DARWIN_INIT_VARI(myThid )
#ifdef ALLOW_CARBON
         CALL DIC_SURFFORCING_INIT(myThid)
         CALL DIC_DIAGS_INIT(myThid)
#endif
      ENDIF
#endif /* ALLOW_DARWIN */

      RETURN
      END

!=======================================================================
      subroutine compsend_r4tiles( dataname,Ni,Oi,Nj,Oj,Nk,Ti,Tj, arr )
      implicit none
! Arguments
      character*(*) dataname
      integer Ni,Oi,Nj,Oj,Nk,Ti,Tj
      real*4 arr(1-Oi:Ni+Oi,1-Oj:Nj+Oj,Nk,Ti,Tj)
! Predefined constants/arrays
#include "CPLR_SIG.h"
! MPI variables
#include "mpif.h"
      integer count,datatype,dest,tag,comm,ierr
! Functions
      integer generate_tag
! Local
      integer i,j,ij,bi,bj,k,bibj
!     ------------------------------------------------------------------

      if (HEADER_SIZE+Ni*Nj.gt.MAX_R4_BUFLEN)
     &    stop 'compsend_r4tiles: Nx*Ny too big'

! Foreach tile which is non-blank
      do bibj=1,my_num_tiles

       bi=my_tile_bi(bibj)
       bj=my_tile_bj(bibj)

       if (Ni.ne.my_tile_nx(bibj))
     &     stop 'compsend_r4tiles: ni != my_tile_nx'
       if (Nj.ne.my_tile_ny(bibj))
     &     stop 'compsend_r4tiles: nj != my_tile_ny'

! Set up buffer
       r4buf(1)=float( my_tile_i0(bibj) )
       r4buf(2)=float( my_tile_nx(bibj) )
       r4buf(3)=float( my_tile_j0(bibj) )
       r4buf(4)=float( my_tile_ny(bibj) )
       call mitcplr_char2real( dataname, r4buf(9) )

! Copy interior of tile to buffer
       k=1
       do j=1,Nj
        do i=1,Ni
         ij=HEADER_SIZE+i+Ni*(j-1)
         r4buf(ij)=arr(i,j,k,bi,bj)
        enddo
       enddo

! Send message
       count=HEADER_SIZE+Ni*Nj
       datatype=MPI_REAL
       dest=my_coupler_rank
       tag=generate_tag(103,bibj,dataname)
       comm=MPI_COMM_myglobal

       if (VERB) then
        write(LogUnit,*)
     &   'compsend_r4tiles: calling MPI_Send dest=',dest,' tile=',bibj
        write(LogUnit,*) 'compsend_r4tiles: dataname=',dataname
        call flush(LogUnit)
       endif
       call MPI_Send( r4buf, count, datatype, dest, tag, comm, ierr )
       if (VERB) then
        write(LogUnit,*) 'compsend_r4tiles: returned ierr=',ierr
        call flush(LogUnit)
       endif

       if (ierr.ne.0) then
        write(LogUnit,*) 'compsend_r4tiles: rank(W,G,L)=',
     &            my_rank_in_world,my_rank_in_global,my_rank_in_local,
     &            ' ierr=',ierr
        stop 'compsend_r4tiles: MPI_Send failed'
       endif

      enddo ! bibj

!     ------------------------------------------------------------------
      return
      end
!=======================================================================

#include "PROFILES_OPTIONS.h"

C     ==================================================================
C     active_file_profiles_g.F: Routines that handle the I/O of
C                               active variables for the tangently linear
C                               calculations, related to netcdf
C                               profiles data files
C
C     Routines
C     o  g_active_read_profile  - Read an active 1 record from file
C                                 fwd-mode only: including a mask
C     o  g_active_write_profile - Write nn active 1D record to file.
C                                 fwd-mode only: including a mask
C
C     changed: gforget@ocean.mit.edu 23-Mar-2006
C     ==================================================================

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C !ROUTINE: G_ACTIVE_READ_PROFILE

C !INTERFACE:
      SUBROUTINE G_ACTIVE_READ_PROFILE(
     I                           active_num_file,
     I                           nactive_var,
     O                           active_var,
     O                           g_active_var,
     I                           active_varnum,
     I                           irec,
     I                           lAdInit,
     I                           myOptimIter,
     I                           bi,
     I                           bj,
     I                           myThid,
     O                           dummy
     &                         )

C     !DESCRIPTION:
C     Read active 1D records from file for tangent linear simulation

C     !USES:
      IMPLICIT NONE
C     == Global variables ===
#include "EEPARAMS.h"
#include "SIZE.h"
#ifdef ALLOW_PROFILES
# include "PROFILES_SIZE.h"
# include "profiles.h"
#endif

C     !INPUT PARAMETERS:
C     active_var_file: filename
C     nactive_var:     integer size of active_var
C     active_var:      array
C     irec:            record number
C     myOptimIter:     number of optimization iteration (default: 0)
C     myThid:          my thread ID number
C     lAdInit:         initialisation of corresponding adjoint
C                      variable and write to active file
      INTEGER active_num_file
      INTEGER nactive_var
      INTEGER active_varnum
      INTEGER irec
      INTEGER myOptimIter
      INTEGER bi, bj, myThid
      LOGICAL lAdInit
C     !OUTPUT PARAMETERS:
      _RL     active_var(nactive_var)
      _RL     g_active_var(nactive_var)
      _RL     dummy
CEOP

#ifdef ALLOW_PROFILES

      CALL ACTIVE_READ_PROFILE_RL( fidforward(active_num_file,bi,bj),
     &     active_num_file,
     &     nactive_var,  active_var, active_varnum, lAdInit,
     &     irec, prof_ind_glob(active_num_file,irec,bi,bj),
     &     FORWARD_SIMULATION, myOptimIter, bi, bj, myThid )

      CALL ACTIVE_READ_PROFILE_RL( fidtangent(active_num_file,bi,bj),
     &     active_num_file,
     &     nactive_var, g_active_var,active_varnum, lAdInit,
     &     irec, prof_ind_glob(active_num_file,irec,bi,bj),
     &     TANGENT_SIMULATION, myOptimIter, bi, bj, myThid )

#endif

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C !ROUTINE: G_ACTIVE_WRITE_PROFILE

C !INTERFACE:
      SUBROUTINE G_ACTIVE_WRITE_PROFILE(
     I                           active_num_file,
     I                           nactive_var,
     I                           active_var,
     I                           g_active_var,
     I                           active_varnum,
     I                           irec,
     I                           myOptimIter,
     I                           bi,
     I                           bj,
     I                           myThid,
     I                           dummy,
     I                           g_dummy
     &                                )

C     !DESCRIPTION:
C     Write active 1D records to file for tangent linear simulation

C     !USES:
      IMPLICIT NONE
C     == Global variables ===
#include "EEPARAMS.h"
#include "SIZE.h"
#ifdef ALLOW_PROFILES
# include "PROFILES_SIZE.h"
# include "profiles.h"
#endif

C     !INPUT PARAMETERS:
C     active_var_file: filename
C     nactive_var:     integer size of active_var
C     active_var:      array
C     irec:            record number
C     myOptimIter:     number of optimization iteration (default: 0)
C     myThid:          my thread ID number
      INTEGER nactive_var,active_num_file
      _RL     active_var(nactive_var)
      _RL     g_active_var(nactive_var)
      INTEGER irec,active_varnum
      INTEGER myOptimIter
      INTEGER bi,bj,myThid
      _RL     dummy
      _RL     g_dummy
C     !OUTPUT PARAMETERS:
CEOP

#ifdef ALLOW_PROFILES

      CALL ACTIVE_WRITE_PROFILE_RL( fidforward(active_num_file,bi,bj),
     &     active_num_file,
     &     nactive_var, active_var, active_varnum,
     &     irec, prof_ind_glob(active_num_file,irec,bi,bj),
     &     FORWARD_SIMULATION, myOptimIter, bi, bj, myThid )

      CALL ACTIVE_WRITE_PROFILE_RL( fidtangent(active_num_file,bi,bj),
     &     active_num_file,
     &     nactive_var, g_active_var, active_varnum,
     &     irec, prof_ind_glob(active_num_file,irec,bi,bj),
     &     TANGENT_SIMULATION, myOptimIter, bi, bj, myThid )

#endif

      RETURN
      END

#include "LONGSTEP_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: LONGSTEP_CHECK_ITERS

C     !INTERFACE:
      SUBROUTINE LONGSTEP_CHECK_ITERS( myThid )

C     !DESCRIPTION:
C     Check that starttime and endtime are multiples of long time step.
C     Fix endtime if not, abort if starttime is not.

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "LONGSTEP_PARAMS.h"
#include "PARAMS.h"

C     !INPUT PARAMETERS:
      INTEGER myThid
CEOP

#ifdef ALLOW_LONGSTEP

C     !LOCAL VARIABLES:
C     extraIter  :: extra iterations added to finish on a longstep
C     msgBuf     :: message buffer
      INTEGER extraIter
      CHARACTER*(MAX_LEN_MBUF) msgBuf

      IF (MOD(nIter0, LS_nIter) .NE. 0) THEN
C       Restarting from a pickup in the middle of a longstep will lead
C       to invalid vel,... averages, so we abort
        WRITE(msgBuf,'(2A,2I10)')
     &       ' LONGSTEP_CHECK_ITERS: nIter0 is not a multiple of',
     &       ' LS_niter', nIter0, LS_niter
        CALL PRINT_ERROR( msgBuf, myThid )
        STOP 'ABNORMAL END: S/R LONGSTEP_CHECK_ITERS'
      ENDIF

      IF (MOD(nEndIter, LS_nIter) .NE. 0) THEN
C       Add as many time steps as necessary to bring endtime to the end
C       of a long time step, so that the pickup will be valid.
        WRITE(msgBuf,'(3A)') '**WARNING** ',
     &       ' LONGSTEP_CHECK_ITERS: nEndIter is not a multiple of',
     &       ' LS_niter:'
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                      SQUEEZE_RIGHT , myThid)
        WRITE(msgBuf,'(2A,2I10)') '**WARNING** ',
     &       ' LONGSTEP_CHECK_ITERS:     ', nEndIter, LS_niter
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                      SQUEEZE_RIGHT , myThid)
        extraIter = LS_nIter - MOD(nEndIter, LS_nIter)
        nEndIter = nEndIter + extraIter
        nTimeSteps = nEndIter - nIter0
        endTime = baseTime + deltaTClock*DFLOAT(nEndIter)
        WRITE(msgBuf,'(2A)') '**WARNING** ',
     &       ' LONGSTEP_CHECK_ITERS: adjusting to'
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                      SQUEEZE_RIGHT , myThid)
        WRITE(msgBuf,'(2A,I10)') '**WARNING** ',
     &       ' LONGSTEP_CHECK_ITERS:     nEndIter   =', nEndIter
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                      SQUEEZE_RIGHT , myThid)
        WRITE(msgBuf,'(2A,I10)') '**WARNING** ',
     &       ' LONGSTEP_CHECK_ITERS:     nTimeSteps =', nTimeSteps
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                      SQUEEZE_RIGHT , myThid)
        WRITE(msgBuf,'(2A,1PE23.15)') '**WARNING** ',
     &       ' LONGSTEP_CHECK_ITERS:     endTime    =', endTime
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                      SQUEEZE_RIGHT , myThid)
C       log to standard output too
        WRITE(msgBuf,'(2A)') 'S/R LONGSTEP_CHECK_ITERS: ',
     &    ' adjusting endTime:'
        CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                      SQUEEZE_RIGHT , 1)
        CALL WRITE_0D_RL( endTime, INDEX_NONE,'endTime =',
     &'   /* Integration ending time ( s ). */')
        CALL WRITE_0D_I( nTimeSteps, INDEX_NONE,'nTimeSteps =',
     &'   /* Number of timesteps */')
      ENDIF

#endif /* ALLOW_LONGSTEP */

      RETURN
      END

      subroutine outstore( n, fc, gnorm0, m, jmin, jmax )
c
c         arguments
c
      integer n, m, jmin, jmax
      double precision    fc, gnorm0
c----
c
      common /xxstore/ itape, ntape, isize
      integer itape, ntape, isize

      open(  itape
     $     , file   = 'OPWARMI'
     $     , access = 'sequential'
     $     , form   = 'formatted'  )
      rewind (itape)

      write( itape, * ) n, fc, gnorm0, isize, m, jmin, jmax

      close(itape)

      return
      end

#include "MNC_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 0
C     !ROUTINE: MNC_FILE_CREATE

C     !INTERFACE:
      SUBROUTINE MNC_FILE_CREATE( 
     I     fname, 
     I     myThid )

C     !DESCRIPTION:
C     Create a NetCDF file.
      
C     !USES:
      implicit none

C     !INPUT PARAMETERS:
      integer myThid
      character*(*) fname
CEOP

C     !LOCAL VARIABLES:
      integer indf

      CALL MNC_FILE_OPEN(fname, 0, indf, myThid)

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 0
C     !ROUTINE: MNC_FILE_OPEN

C     !INTERFACE:
      SUBROUTINE MNC_FILE_OPEN( 
     I     fname, 
     I     itype, 
     O     indf, 
     I     myThid )

C     !DESCRIPTION:
C     Open or create a NetCDF file.
      
C     !USES:
      implicit none
#include "MNC_COMMON.h"
#include "EEPARAMS.h"
#include "netcdf.inc"

C     !INPUT PARAMETERS:
      integer myThid,indf
      character*(*) fname
      integer itype
C     itype => [ 0=new | 1=append | 2=read-only ]
CEOP

C     !LOCAL VARIABLES:
      integer n, err, fid, nf
      character*(MAX_LEN_MBUF) msgbuf

C     Functions
      integer ILNBLNK

C     Is the file already open?
      nf = ILNBLNK(fname)
      CALL MNC_GET_IND(MNC_MAX_FID, fname,mnc_f_names,indf,myThid)
      IF (indf .GT. 0) THEN
        write(msgbuf,'(3a)') 'MNC_FILE_OPEN ERROR: ''', fname(1:nf), 
     &       ''' is already open -- cannot open twice'
        CALL print_error(msgbuf, mythid)
        stop 'ABNORMAL END: package MNC'
      ENDIF

      write(msgbuf,'(3a)') 'opening ''', fname(1:nf), ''''
      IF (itype .EQ. 0) THEN

C       Create new file
        err = NF_CREATE(fname, NF_CLOBBER, fid)
        CALL MNC_HANDLE_ERR(err, msgbuf, myThid)

      ELSEIF (itype .EQ. 1) THEN

C       Append to existing file
        CALL MNC_FILE_READALL(fname, myThid)

      ELSE
C       Error
        write(msgbuf,'(a,i5,a)') 'MNC_FILE_OPEN ERROR: ''', itype, 
     &       ''' is not defined--should be: [0|1]'
        CALL print_error( msgbuf, mythid )
        stop 'ABNORMAL END: S/R MNC_FILE_ADD_ATTR_STR'
      ENDIF

      CALL MNC_GET_NEXT_EMPTY_IND(MNC_MAX_FID, mnc_f_names,
     &     'mnc_f_names', indf, myThid)
      n = ILNBLNK(fname)
      mnc_f_names(indf)(1:n) = fname(1:n)
      mnc_f_info(indf,1) = 1
      mnc_f_info(indf,2) = fid
      mnc_f_info(indf,3) = 0
      mnc_fv_ids(indf,1) = 0
      mnc_f_alld(indf,1) = 0

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 0
C     !ROUTINE: MNC_FILE_ADD_ATTR_STR

C     !INTERFACE:
      SUBROUTINE MNC_FILE_ADD_ATTR_STR( 
     I     fname, 
     I     atname, 
     I     sval, 
     I     myThid )

C     !DESCRIPTION:
C     Add a character string attribute to a NetCDF file.

C     !USES:
      implicit none

C     !INPUT PARAMETERS:
      integer myThid
      character*(*) fname, atname, sval
CEOP
      real*4 sZero
      sZero = 0.

      CALL MNC_FILE_ADD_ATTR_ANY(fname,atname, 1, 
     &     sval, 0, 0.0D0, sZero, 0, myThid )
      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 0
C     !ROUTINE: MNC_FILE_ADD_ATTR_DBL

C     !INTERFACE:
      SUBROUTINE MNC_FILE_ADD_ATTR_DBL( 
     I     fname, 
     I     atname, 
     I     len, 
     I     dval, 
     I     myThid )

C     !DESCRIPTION:
C     Add a double-precision real attribute to a NetCDF file.

C     !USES:
      implicit none

C     !INPUT PARAMETERS:
      integer myThid, len
      character*(*) fname, atname
      REAL*8 dval
CEOP
      real*4 sZero
      sZero = 0.

      CALL MNC_FILE_ADD_ATTR_ANY(fname,atname, 2, 
     &     ' ', len, dval, sZero, 0, myThid )
      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 0
C     !ROUTINE: MNC_FILE_ADD_ATTR_REAL

C     !INTERFACE:
      SUBROUTINE MNC_FILE_ADD_ATTR_REAL( 
     I     fname, 
     I     atname, 
     I     len, 
     I     rval, 
     I     myThid )

C     !DESCRIPTION:
C     Add a single-precision real attribute to a NetCDF file.

C     !USES:
      implicit none

C     !INPUT PARAMETERS:
      integer myThid, len
      character*(*) fname, atname
      REAL*4 rval
CEOP

      CALL MNC_FILE_ADD_ATTR_ANY(fname,atname, 3, 
     &     ' ', len, 0.0D0, rval, 0, myThid )
      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 0
C     !ROUTINE: MNC_FILE_ADD_ATTR_INT

C     !INTERFACE:
      SUBROUTINE MNC_FILE_ADD_ATTR_INT( 
     I     fname, 
     I     atname, 
     I     len, 
     I     ival, 
     I     myThid )

C     !DESCRIPTION:
C     Add an integer attribute to a NetCDF file.

C     !USES:
      implicit none

C     !INPUT PARAMETERS:
      integer myThid, len, ival
      character*(*) fname, atname
CEOP
      real*4 sZero
      sZero = 0.

      CALL MNC_FILE_ADD_ATTR_ANY(fname,atname, 4, 
     &     ' ', len, 0.0D0, sZero, ival, myThid )
      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 1
C     !ROUTINE: MNC_FILE_ADD_ATTR_ANY

C     !INTERFACE:
      SUBROUTINE MNC_FILE_ADD_ATTR_ANY( 
     I     fname, 
     I     atname, 
     I     atype, sv, len,dv,rv,iv, 
     I     myThid )

C     !DESCRIPTION:
C     Add all attributes to a NetCDF file.

C     !USES:
      implicit none
#include "MNC_COMMON.h"
#include "EEPARAMS.h"
#include "netcdf.inc"

C     !INPUT PARAMETERS:
      integer myThid, atype, len, iv
      character*(*) fname, atname, sv
      REAL*8 dv
      REAL*4 rv
CEOP

C     !LOCAL VARIABLES:
      integer n, nf, err, fid, ind, n1, lens
      character*(MNC_MAX_CHAR) s1
      character*(MAX_LEN_MBUF) msgbuf

C     Functions
      integer ILNBLNK

C     Verify that the file is open
      CALL MNC_GET_IND(MNC_MAX_FID, fname, mnc_f_names, ind, myThid)
      IF (ind .LT. 0) THEN
        nf = ILNBLNK( fname )
        write(msgbuf,'(3a)') 'MNC ERROR: file ''',
     &       fname(1:nf), ''' must be opened first'
        CALL print_error( msgbuf, mythid )
        stop 'ABNORMAL END: S/R MNC_FILE_ADD_ATTR_INT'
      ENDIF
      fid = mnc_f_info(ind,2)

C     Enter define mode
      CALL MNC_FILE_REDEF(fname, myThid)

      s1(1:MNC_MAX_CHAR) = mnc_blank_name(1:MNC_MAX_CHAR)
      n1 = ILNBLNK(atname)
      s1(1:n1) = atname(1:n1)

      IF (atype .EQ. 1) THEN
        lens = ILNBLNK(sv)
        err = NF_PUT_ATT_TEXT(fid, NF_GLOBAL, s1, lens, sv)
        CALL MNC_HANDLE_ERR(err,
     &       'adding TEXT attribute in S/R MNC_FILE_ADD_ATTR_ANY', 
     &       myThid)
      ELSEIF (atype .EQ. 2) THEN
        err = NF_PUT_ATT_DOUBLE(fid, NF_GLOBAL, s1, NF_DOUBLE, len, dv)
        CALL MNC_HANDLE_ERR(err,
     &       'adding DOUBLE attribute in S/R MNC_FILE_ADD_ATTR_ANY',
     &       myThid)
      ELSEIF (atype .EQ. 3) THEN
        err = NF_PUT_ATT_REAL(fid, NF_GLOBAL, s1, NF_FLOAT, len, rv)
        CALL MNC_HANDLE_ERR(err,
     &       'adding REAL attribute in S/R MNC_FILE_ADD_ATTR_ANY',
     &       myThid)
      ELSEIF (atype .EQ. 4) THEN
        err = NF_PUT_ATT_INT(fid, NF_GLOBAL, s1, NF_INT, len, iv)
        CALL MNC_HANDLE_ERR(err,
     &       'adding INT attribute in S/R MNC_FILE_ADD_ATTR_ANY',
     &       myThid)
      ELSE
        write(msgbuf,'(a,i10,a)') 'MNC ERROR: atype = ''', atype, 
     &       ''' is invalid--must be: [1-4]'
        n = ILNBLNK(msgbuf)
        CALL print_error(msgbuf(1:n), mythid)
        stop 'ABNORMAL END: S/R MNC_VAR_ADD_ATTR_ANY'
      ENDIF

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 1
C     !ROUTINE: MNC_FILE_CLOSE

C     !INTERFACE:
      SUBROUTINE MNC_FILE_CLOSE( 
     I     fname, 
     I     myThid )

C     !DESCRIPTION:
C     Close a NetCDF file.
      
C     !USES:
      implicit none
#include "MNC_COMMON.h"
#include "EEPARAMS.h"
#include "netcdf.inc"

C     !INPUT PARAMETERS:
      integer myThid
      character*(*) fname
CEOP

C     !LOCAL VARIABLES:
      integer i,j,k,n, err, fid, indf, nf
      character*(MAX_LEN_MBUF) msgbuf

C     Functions
      integer ILNBLNK

      nf = ILNBLNK(fname)

C     Check that the file is open
      CALL MNC_GET_IND(MNC_MAX_FID, fname, mnc_f_names, indf, myThid)
      IF (indf .LT. 1) THEN
        write(msgbuf,'(3a)') 'MNC Warning: file ''', fname(1:nf), 
     &       ''' is already closed'
        CALL print_error( msgbuf, mythid )
        RETURN
      ENDIF
      fid = mnc_f_info(indf,2)
      err = NF_CLOSE(fid)
      write(msgbuf,'(3a)') ' cannot close file ''', fname(1:nf), ''''
      CALL MNC_HANDLE_ERR(err, msgbuf, myThid)

C     Clear all the info associated with this file
C     variables
      n = mnc_fv_ids(indf,1)
      IF (n .GE. 1) THEN
        DO i = 1,n
          j = 2 + 3*(i - 1)
          k = mnc_fv_ids(indf,j)
          mnc_v_names(k)(1:MNC_MAX_CHAR)=mnc_blank_name(1:MNC_MAX_CHAR)
        ENDDO
        DO i = 1,MNC_MAX_INFO
          mnc_fv_ids(indf,i) = 0
        ENDDO
      ENDIF
C     dims
      n = mnc_f_alld(indf,1)
      mnc_f_alld(indf,1) = 0
      DO i = 1,n
        j = mnc_f_alld(indf,i+1)
        mnc_d_ids(j)  = 0
        mnc_d_size(j) = 0
        mnc_d_names(j)(1:MNC_MAX_CHAR) = mnc_blank_name(1:MNC_MAX_CHAR)
        mnc_f_alld(indf,i+1) = 0
      ENDDO
C     grids
      n = mnc_f_info(indf,3)
      IF (n .GT. 0) THEN
        DO i = 1,n
          j = 4 + 3*(i - 1)
          k = mnc_f_info(indf,j)
          mnc_g_names(k)(1:MNC_MAX_CHAR)=mnc_blank_name(1:MNC_MAX_CHAR)
        ENDDO
        DO i = 1,MNC_MAX_INFO
          mnc_fd_ind(indf,i) = 0
          mnc_f_info(indf,i) = 0
        ENDDO
      ENDIF
C     file name
      DO i = 1,MNC_MAX_PATH
        mnc_f_names(indf)(i:i) = ' '
      ENDDO

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 0
C     !ROUTINE: MNC_FILE_CLOSE_ALL_MATCHING

C     !INTERFACE:
      SUBROUTINE MNC_FILE_CLOSE_ALL_MATCHING( 
     I     fname, 
     I     myThid ) 

C     !DESCRIPTION:
C     Close all files matching a character string.
      
C     !USES:
      implicit none
#include "MNC_COMMON.h"
#include "EEPARAMS.h"
#include "netcdf.inc"

C     !INPUT PARAMETERS:
      integer myThid
      character*(*) fname
CEOP

C     !LOCAL VARIABLES:
      integer i,n

C     Functions
      integer ILNBLNK

      n = ILNBLNK(fname)
      DO i = 1,MNC_MAX_FID

C       Check that the file is open
        IF (fname(1:n) .EQ. mnc_f_names(i)(1:n)) THEN
          CALL MNC_FILE_CLOSE(mnc_f_names(i), myThid)
        ENDIF

      ENDDO

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 0
C     !ROUTINE: MNC_FILE_CLOSE_ALL

C     !INTERFACE:
      SUBROUTINE MNC_FILE_CLOSE_ALL( 
     I     myThid ) 

C     !DESCRIPTION:
C     Close all NetCDF files.
      
C     !USES:
      implicit none
#include "MNC_COMMON.h"
#include "EEPARAMS.h"
#include "netcdf.inc"

C     !INPUT PARAMETERS:
      integer myThid
CEOP

C     !LOCAL VARIABLES:
      integer i
      character*(MNC_MAX_PATH) bpath

      DO i = 1,MNC_MAX_PATH
        bpath(i:i) = ' '
      ENDDO

      DO i = 1,MNC_MAX_FID

C       Check that the file is open
        IF (mnc_f_names(i)(1:MNC_MAX_PATH) 
     &       .NE. bpath(1:MNC_MAX_PATH)) THEN
          CALL MNC_FILE_CLOSE(mnc_f_names(i), myThid)
        ENDIF

      ENDDO

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 0
C     !ROUTINE: MNC_FILE_REDEF

C     !INTERFACE:
      SUBROUTINE MNC_FILE_REDEF( 
     I     fname, 
     I     myThid )

C     !DESCRIPTION:
C     Set the NetCDF file to DEFINE mode.
      
C     !USES:
      implicit none
#include "MNC_COMMON.h"
#include "EEPARAMS.h"
#include "netcdf.inc"

C     !INPUT PARAMETERS:
      integer myThid
      character*(*) fname
CEOP

C     !LOCAL VARIABLES:
      integer ind, fid, def, err, n
      character*(MAX_LEN_MBUF) msgbuf

C     Functions
      integer ILNBLNK

C     Verify that the file is open
      CALL MNC_GET_IND(MNC_MAX_FID, fname, mnc_f_names, ind, myThid)
      IF (ind .LT. 0) THEN
        n = ILNBLNK(fname)
        write(msgbuf,'(3a)') 'MNC ERROR: file ''',
     &       fname(1:n), ''' must be opened first'
        CALL print_error( msgbuf, mythid )
        stop 'ABNORMAL END: S/R MNC_FILE_REDEF'
      ENDIF
      def = mnc_f_info(ind,1)
      fid = mnc_f_info(ind,2)

      IF (def .NE. 1) THEN
C       Enter define mode
        err = NF_REDEF(fid)
        CALL MNC_HANDLE_ERR(err, 
     &       'entering define mode in S/R MNC_FILE_REDEF', myThid)
        mnc_f_info(ind,1) = 1
      ENDIF

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 0
C     !ROUTINE: MNC_FILE_ENDDEF

C     !INTERFACE:
      SUBROUTINE MNC_FILE_ENDDEF( 
     I     fname, 
     I     myThid )

C     !DESCRIPTION:
C     End DEFINE mode for a NetCDF file.
      
C     !USES:
      implicit none
#include "MNC_COMMON.h"
#include "EEPARAMS.h"
#include "netcdf.inc"

C     !INPUT PARAMETERS:
      integer myThid
      character*(*) fname
CEOP

C     !LOCAL VARIABLES:
      integer ind, fid, def, err, n
      character*(MAX_LEN_MBUF) msgbuf

C     Functions
      integer ILNBLNK

C     Verify that the file is open
      CALL MNC_GET_IND(MNC_MAX_FID, fname, mnc_f_names, ind, myThid)
      IF (ind .LT. 0) THEN
        n = ILNBLNK(fname)
        write(msgbuf,'(3a)') 'MNC ERROR: file ''',
     &       fname(1:n), ''' must be opened first'
        CALL print_error( msgbuf, mythid )
        stop 'ABNORMAL END: S/R MNC_FILE_REDEF'
      ENDIF
      def = mnc_f_info(ind,1)
      fid = mnc_f_info(ind,2)

      IF (def .NE. 2) THEN
C       Enter define mode
        err = NF_ENDDEF(fid)
        CALL MNC_HANDLE_ERR(err, 
     &       'ending define mode in S/R MNC_FILE_ENDDEF', myThid)
        mnc_f_info(ind,1) = 2
      ENDIF

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 1
C     !ROUTINE: MNC_FILE_READALL

C     !INTERFACE:
      SUBROUTINE MNC_FILE_READALL( 
     I     fname, 
     I     myThid ) 

C     !DESCRIPTION:
C     Try to open and read a NetCDF file.
      
C     !USES:
      implicit none
#include "EEPARAMS.h"
#include "netcdf.inc"

C     !INPUT PARAMETERS:
      integer myThid
      character*(*) fname
CEOP

C     Functions
      integer IFNBLNK, ILNBLNK

C     Local Variables
      integer ierr, nff,nlf, indf
      character*(MAX_LEN_MBUF) msgbuf

      nff = IFNBLNK(fname)
      nlf = ILNBLNK(fname)
      CALL MNC_FILE_TRY_READ(fname, ierr, indf, myThid)
      write(msgbuf,'(3a)') 'MNC ERROR: cannot open file ''', 
     &     fname(nff:nlf), ''' for read/write access'
      CALL MNC_HANDLE_ERR(ierr, msgbuf, myThid)

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 1
C     !ROUTINE: MNC_FILE_TRY_READ

C     !INTERFACE:
      SUBROUTINE MNC_FILE_TRY_READ( 
     I     fname, 
     O     ierr, 
     O     indf, 
     I     myThid ) 

C     !DESCRIPTION:
C     Try to open and read a NetCDF file.
      
C     !USES:
      implicit none
#include "MNC_COMMON.h"
#include "EEPARAMS.h"
#include "netcdf.inc"

C     !INPUT PARAMETERS:
      integer myThid, ierr, indf
      character*(*) fname

C     !LOCAL VARIABLES:
      integer i,j,k, fid, err, ndim,nvar,ngat,unlimid
      integer dlen, id, xtype, nat, nff,nlf, iv
      integer ndv, did, ns,ne, n1,n2, indg, indv
      character*(MAX_LEN_MBUF) msgbuf
      character*(NF_MAX_NAME) name
      integer idlist(NF_MAX_VAR_DIMS)
      character*(MNC_MAX_CHAR) dnames(20)
CEOP
C     Functions
      integer IFNBLNK, ILNBLNK

C     Open and save the filename and fID
      nff = IFNBLNK(fname)
      nlf = ILNBLNK(fname)
      err = NF_OPEN(fname, NF_WRITE, fid)
      ierr = NF_NOERR
      IF (err .NE. NF_NOERR) THEN
        ierr = err
        RETURN
      ENDIF
      CALL MNC_GET_NEXT_EMPTY_IND(MNC_MAX_FID, mnc_f_names,
     &     'mnc_f_names', indf, myThid)
      mnc_f_names(indf)(1:(nlf-nff+1)) = fname(nff:nlf)
      mnc_f_info(indf,2) = fid

C     Get the overall number of entities
      err = NF_INQ(fid, ndim, nvar, ngat, unlimid)
      write(msgbuf,'(4a)') 'MNC ERROR: cannot read number of dims',
     &     ' in file ''', fname(nff:nlf), ''''
      CALL MNC_HANDLE_ERR(err, msgbuf, myThid)

C     Read each dimension and save the information
      DO id = 1,ndim
        err = NF_INQ_DIM(fid, id, name, dlen)
        write(msgbuf,'(2a,i5,3a)') 'MNC ERROR: cannot read dimension',
     &       ' info for dim ''', id, ''' in file ''', 
     &       fname(nff:nlf), ''''
        CALL MNC_HANDLE_ERR(err, msgbuf, myThid)
        IF (id .EQ. unlimid) THEN
          dlen = -1
        ENDIF
        ns = IFNBLNK(name)
        ne = ILNBLNK(name)

        CALL MNC_DIM_INIT_ALL(fname,name(ns:ne),dlen,'N', myThid)
        DO i = 1,mnc_f_alld(indf,1)
          j = mnc_f_alld(indf,i+1)
          n1 = IFNBLNK(mnc_d_names(j))
          n2 = ILNBLNK(mnc_d_names(j))
          IF (((ne-ns) .EQ. (n2-n1)) 
     &         .AND. (mnc_d_names(j)(ns:ne) .EQ. name(ns:ne))) THEN
            mnc_d_ids(j) = id
            goto 10
          ENDIF
        ENDDO
 10     CONTINUE
      ENDDO

C     Read and save each variable
      DO id = 1,nvar
        err = NF_INQ_VAR(fid, id, name, xtype, ndv, idlist, nat)
        write(msgbuf,'(2a,i5,3a)') 'MNC ERROR: cannot read variable',
     &       ' info for variable ''', id, ''' in file ''', 
     &       fname(nff:nlf), ''''
        CALL MNC_HANDLE_ERR(err, msgbuf, myThid)
        n1 = IFNBLNK(name)
        n2 = ILNBLNK(name)

C       Create a grid for this variable
        DO i = 1,ndv
          did = idlist(i)
          dnames(i)(1:MNC_MAX_CHAR) = mnc_d_names(did)(1:MNC_MAX_CHAR)
        ENDDO

        CALL MNC_GRID_INIT_ALL(fname, name, ndv, dnames, indg, myThid)

C       Update the tables
        CALL MNC_GET_NEXT_EMPTY_IND(MNC_MAX_ID,mnc_v_names,
     &       'mnc_v_names', indv,myThid)
        mnc_v_names(indv)(1:(n2-n1+1)) = name(n1:n2)
        iv = 2 + 3*mnc_fv_ids(indf,1)
        mnc_fv_ids(indf,iv)   = indv
        mnc_fv_ids(indf,iv+1) = id
        DO i = 1,mnc_f_info(indf,3)
          j = 4 + 3*(i-1)
          k = mnc_f_info(indf,j)
          IF (k .EQ. indg) THEN
            mnc_fv_ids(indf,iv+2) = j
            GOTO 20
          ENDIF
        ENDDO
 20     CONTINUE
        mnc_fv_ids(indf,1) = mnc_fv_ids(indf,1) + 1
        
      ENDDO

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#include "LAND_OPTIONS.h"

CBOP
C     !ROUTINE: LAND_READ_PICKUP
C     !INTERFACE:
      SUBROUTINE LAND_READ_PICKUP( myIter, myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R LAND_READ_PICKUP
C     | o Reads current state of land model from a pickup file
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     == Global variables ===
#include "LAND_SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "LAND_PARAMS.h"
#include "LAND_VARS.h"

C     == Routine Arguments ==
C     myIter  :: time-step number
C     myThid  :: Number of this instance
      INTEGER myIter
      INTEGER myThid

#ifdef ALLOW_LAND

C     !LOCAL VARIABLES:
C     fn      :: character buffer for creating filename
C     prec    :: precision of pickup files
C     k       :: loop index
      INTEGER prec, k
      CHARACTER*(10) suff
      CHARACTER*(MAX_LEN_FNAM) fn
CEOP

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      IF ( .NOT.land_pickup_read_mnc ) THEN

        IF ( rwSuffixType.EQ.0 ) THEN
          WRITE(fn,'(A,I10.10)') 'pickup_land.',myIter
        ELSE
          CALL RW_GET_SUFFIX( suff, startTime, myIter, myThid )
          WRITE(fn,'(A,A10)') 'pickup_land.',suff
        ENDIF
        prec = precFloat64

        IF ( land_oldPickup ) THEN
C-    Read fields as consecutive records
          CALL READ_REC_3D_RL( fn, prec, land_nLev,
     &                         land_groundT, 1, myIter, myThid )
          CALL READ_REC_3D_RL( fn, prec, land_nLev,
     &                         land_groundW, 2, myIter, myThid )

      ELSE

C-    Read fields as consecutive records
          CALL READ_REC_3D_RL( fn, prec, land_nLev,
     &                         land_enthalp, 1, myIter, myThid )
          CALL READ_REC_3D_RL( fn, prec, land_nLev,
     &                         land_groundW, 2, myIter, myThid )
          k=2*land_nLev
          CALL READ_REC_3D_RL( fn, prec, 1,
     &                         land_skinT,  k+1, myIter, myThid )
          CALL READ_REC_3D_RL( fn, prec, 1,
     &                         land_hSnow,  k+2, myIter, myThid )
          CALL READ_REC_3D_RL( fn, prec, 1,
     &                         land_snowAge,k+3, myIter, myThid )

        ENDIF

      ENDIF

#ifdef ALLOW_MNC
      IF ( land_pickup_read_mnc ) THEN

        DO k = 1,MAX_LEN_FNAM
          fn(k:k) = ' '
        ENDDO
        WRITE(fn,'(A)') 'pickup_land'
        CALL MNC_FILE_CLOSE_ALL_MATCHING(fn, myThid)
        CALL MNC_CW_SET_UDIM(fn, 1, myThid)
        CALL MNC_CW_SET_CITER(fn, 3, 3, myIter, -1, myThid)

        CALL MNC_CW_RL_R('D',fn,0,0,
     &       'land_enthalp', land_enthalp, myThid)
        CALL MNC_CW_RL_R('D',fn,0,0,
     &       'land_groundW', land_groundW, myThid)

        CALL MNC_CW_RL_R('D',fn,0,0,
     &       'land_skinT', land_skinT, myThid)
        CALL MNC_CW_RL_R('D',fn,0,0,
     &       'land_hSnow', land_hSnow, myThid)
        CALL MNC_CW_RL_R('D',fn,0,0,
     &       'land_snAge', land_snowAge, myThid)

      ENDIF
#endif

C- jmc: exchange is not really necessary for land model
C-      and presently exchange S/R cannot work for 3d array where 3rd dim <> Nr

#endif /* ALLOW_LAND */

      RETURN
      END

#include "PROFILES_OPTIONS.h"

C     ==================================================================
C     active_file_control_profiles.F: Routines that handle the I/O of
C                                     active variables for the adjoint
C                                     calculations, related to netcdf
C                                     profiles data files
C
C     Routines
C     o  active_read_profile_rl  - Read an active 1 record from file
C                                  fwd-mode only: including a mask
C     o  active_write_profile_rl - Write nn active 1D record to file.
C                                  fwd-mode only: including a mask
C
C     started: Gael Forget 15-March-2006
C     ==================================================================

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C !ROUTINE: ACTIVE_READ_PROFILE_RL

C !INTERFACE:
      SUBROUTINE ACTIVE_READ_PROFILE_RL(
     I                                fid,
     I                                active_num_file,
     I                                nactive_var,
     O                                active_var,
     I                                active_varnum,
     I                                lAdInit,
     I                                irec,
     I                                irecglob,
     I                                theSimulationMode,
     I                                myOptimIter,
     I                                bi,
     I                                bj,
     I                                myThid
     &                              )

C     !DESCRIPTION:
C     Read an active 1D record from file. In forward-mode
C     (theSimulationMode = FORWARD_SIMULATION) also read a mask from
C     file.

C     !USES:
      IMPLICIT NONE
C     == Global variables ===
#include "EEPARAMS.h"
#include "SIZE.h"
#include "PARAMS.h"
#ifdef ALLOW_PROFILES
# include "netcdf.inc"
# include "PROFILES_SIZE.h"
# include "profiles.h"
#endif

C     !INPUT PARAMETERS:
C     myThid :: my thread ID number
      INTEGER fid
      INTEGER active_num_file, nactive_var, active_varnum
      LOGICAL lAdInit
      INTEGER irec, irecglob
      INTEGER theSimulationMode
      INTEGER myOptimIter
      INTEGER bi, bj, myThid
C     !OUTPUT PARAMETERS:
      _RL     active_var(nactive_var)
CEOP

#ifdef ALLOW_PROFILES
C     !LOCAL VARIABLES:
      INTEGER err, varId, maskId, vec_start(2), vec_count(2)
      INTEGER i, ivar, jrec
      _RL     active_data_t(nactive_var)
      REAL*8  vec_tmp(nactive_var+1)

      IF (profilesDoNcOutput) THEN
        vec_start(1)=1
        vec_start(2)=irec
        vec_count(1)=nactive_var
        vec_count(2)=1

C ESCO: Put a single NF_INQ_VARID for prof_names
        err = NF_INQ_VARID( fid,
     &        prof_names(active_num_file,active_varnum), varId )
        CALL PROFILES_NF_ERROR(
     &       'ACTIVE_READ: NF_INQ_VARID prof_names',
     &       err,bi,bj,myThid )

      ELSE
        jrec = 2 * ( (irec-1)*prof_num_var_tot(active_num_file,bi,bj)
     &       + prof_num_var_cur(active_num_file,active_varnum,bi,bj)
     &       -1 )

      ENDIF

C     >>>>>>>>>>>>>>>>>>>             <<<<<<<<<<<<<<<<<<<
C     >>>>>>>>>>>>>>>>>>> FORWARD RUN <<<<<<<<<<<<<<<<<<<
C     >>>>>>>>>>>>>>>>>>>             <<<<<<<<<<<<<<<<<<<

      IF (theSimulationMode .EQ. FORWARD_SIMULATION) THEN

        _BEGIN_MASTER( myThid )

        IF (profilesDoNcOutput) THEN
          err = NF_GET_VARA_DOUBLE( fid, varId, vec_start, vec_count,
     &          active_var )
          CALL PROFILES_NF_ERROR(
     &         'ACTIVE_READ: NF_GET_VARA_DOUBLE active_var',
     &         err,bi,bj,myThid )

          err = NF_INQ_VARID( fid,
     &          prof_namesmask(active_num_file,active_varnum),
     &          maskId )
          CALL PROFILES_NF_ERROR(
     &         'ACTIVE_READ: NF_INQ_VARID prof_namesmask',
     &         err,bi,bj,myThid )
          err = NF_GET_VARA_DOUBLE( fid, maskId, vec_start, vec_count,
     &          prof_mask1D_cur(1,bi,bj) )
          CALL PROFILES_NF_ERROR(
     &         'ACTIVE_READ: NF_GET_VARA_DOUBLE prof_mask1D_cur',
     &         err,bi,bj,myThid )

        ELSE

          READ(fid,rec=jrec+1) vec_tmp
# ifdef _BYTESWAPIO
          CALL MDS_BYTESWAPR8(nactive_var+1,vec_tmp)
# endif
          DO ivar=1,nactive_var
            active_var(ivar)=vec_tmp(ivar)
          ENDDO

          READ(fid,rec=jrec+2) vec_tmp
# ifdef _BYTESWAPIO
          CALL MDS_BYTESWAPR8(nactive_var+1,vec_tmp)
# endif
          DO ivar=1,nactive_var
            prof_mask1D_cur(ivar,bi,bj)=vec_tmp(ivar)
          ENDDO

        ENDIF

        _END_MASTER( myThid )

      ENDIF

C     >>>>>>>>>>>>>>>>>>>             <<<<<<<<<<<<<<<<<<<
C     >>>>>>>>>>>>>>>>>>> ADJOINT RUN <<<<<<<<<<<<<<<<<<<
C     >>>>>>>>>>>>>>>>>>>             <<<<<<<<<<<<<<<<<<<

      IF (theSimulationMode .EQ. REVERSE_SIMULATION) THEN

        _BEGIN_MASTER( myThid )

        IF (profilesDoNcOutput) THEN
          err = NF_GET_VARA_DOUBLE( fid, varId, vec_start, vec_count,
     &          active_data_t )
          CALL PROFILES_NF_ERROR(
     &         'ACTIVE_READ: NF_GET_VARA_DOUBLE AD active_data_t',
     &         err,bi,bj,myThid )

C     Add active_var from appropriate location to data.
          DO i = 1,nactive_var
            active_data_t(i) = active_data_t(i) + active_var(i)
          ENDDO
C     Store the result on disk.

          err = NF_PUT_VARA_DOUBLE(fid, varId, vec_start, vec_count,
     &          active_data_t )
          CALL PROFILES_NF_ERROR(
     &         'ACTIVE_READ: NF_PUT_VARA_DOUBLE AD active_data_t',
     &         err,bi,bj,myThid )

C     Set active_var to zero.
          DO i = 1,nactive_var
            active_var(i) = 0. _d 0
          ENDDO

        ELSE

          READ(fid,rec=jrec+1) vec_tmp
# ifdef _BYTESWAPIO
          CALL MDS_BYTESWAPR8(nactive_var+1,vec_tmp)
# endif
          DO ivar=1,nactive_var
            active_data_t(ivar)=vec_tmp(ivar)
          ENDDO

C     Add active_var from appropriate location to data.
          DO i = 1,nactive_var
            active_data_t(i) = active_data_t(i) + active_var(i)
          ENDDO

C     Store the result on disk.
          DO ivar=1,nactive_var
            vec_tmp(ivar)=active_data_t(ivar)
          ENDDO
#ifdef _BYTESWAPIO
          CALL MDS_BYTESWAPR8(nactive_var+1,vec_tmp)
#endif
          WRITE(fid,rec=jrec+1) vec_tmp

C     Set active_var to zero.
          DO i = 1,nactive_var
            active_var(i) = 0. _d 0
          ENDDO

        ENDIF

        _END_MASTER( myThid )

      ENDIF

C     >>>>>>>>>>>>>>>>>>>             <<<<<<<<<<<<<<<<<<<
C     >>>>>>>>>>>>>>>>>>> TANGENT RUN <<<<<<<<<<<<<<<<<<<
C     >>>>>>>>>>>>>>>>>>>             <<<<<<<<<<<<<<<<<<<

      IF (theSimulationMode .EQ. TANGENT_SIMULATION) THEN

        _BEGIN_MASTER( myThid )

        IF (profilesDoNcOutput) THEN
          err = NF_GET_VARA_DOUBLE( fid, varId, vec_start, vec_count,
     &          active_var )
          CALL PROFILES_NF_ERROR(
     &         'ACTIVE_READ: NF_GET_VARA_DOUBLE TL active_var',
     &         err,bi,bj,myThid )

        ELSE

          READ(fid,rec=jrec+1) vec_tmp
# ifdef _BYTESWAPIO
          CALL MDS_BYTESWAPR8(nactive_var+1,vec_tmp)
# endif
          DO ivar=1,nactive_var
            active_var(ivar)=vec_tmp(ivar)
          ENDDO

        ENDIF

        _END_MASTER( myThid )

      ENDIF

#endif /* ALLOW_PROFILES */

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C !ROUTINE: ACTIVE_WRITE_PROFILE_RL

C !INTERFACE:
      SUBROUTINE ACTIVE_WRITE_PROFILE_RL(
     I                                 fid,
     I                                 active_num_file,
     I                                 nactive_var,
     I                                 active_var,
     I                                 active_varnum,
     I                                 irec,
     I                                 irecglob,
     I                                 theSimulationMode,
     I                                 myOptimIter,
     I                                 bi,
     I                                 bj,
     I                                 myThid
     &                               )

C     !DESCRIPTION:
C     Write an active 1D record to file. In forward-mode
C     (theSimulationMode = FORWARD_SIMULATION) also write a mask to file.

C     !USES:
      IMPLICIT NONE
C     == Global variables ===
#include "EEPARAMS.h"
#include "SIZE.h"
#include "PARAMS.h"
#ifdef ALLOW_PROFILES
# include "netcdf.inc"
# include "PROFILES_SIZE.h"
# include "profiles.h"
#endif

C     !INPUT PARAMETERS:
C     myThid :: my thread ID number
      INTEGER fid
      INTEGER active_num_file, nactive_var, active_varnum
      INTEGER irec, irecglob
      INTEGER theSimulationMode
      INTEGER myOptimIter
      INTEGER bi,bj,myThid
      _RL     active_var(nactive_var)
C     !OUTPUT PARAMETERS:
CEOP

#ifdef ALLOW_PROFILES
C     !LOCAL VARIABLES:
      INTEGER err, varId, maskId, vec_start(2), vec_count(2)
      INTEGER i, ivar, jrec
      _RL     active_data_t(nactive_var)
      real*8  vec_tmp(nactive_var+1)

      IF (profilesDoNcOutput) THEN
        vec_start(1)=1
        vec_start(2)=irec
        vec_count(1)=nactive_var
        vec_count(2)=1

C ESCO: Put a single NF_INQ_VARID for prof_names
        err = NF_INQ_VARID( fid,
     &        prof_names(active_num_file,active_varnum), varId )
        CALL PROFILES_NF_ERROR(
     &       'ACTIVE_WRITE: NF_INQ_VARID prof_names',
     &       err,bi,bj,myThid )

      ELSE
        jrec = 2 * ( (irec-1)*prof_num_var_tot(active_num_file,bi,bj)
     &       + prof_num_var_cur(active_num_file,active_varnum,bi,bj)
     &       -1 )

      ENDIF

C     >>>>>>>>>>>>>>>>>>>             <<<<<<<<<<<<<<<<<<<
C     >>>>>>>>>>>>>>>>>>> FORWARD RUN <<<<<<<<<<<<<<<<<<<
C     >>>>>>>>>>>>>>>>>>>             <<<<<<<<<<<<<<<<<<<

      IF (theSimulationMode .EQ. FORWARD_SIMULATION) THEN

        _BEGIN_MASTER( myThid )

        IF (profilesDoNcOutput) THEN
          err = NF_PUT_VARA_DOUBLE( fid, varId, vec_start, vec_count,
     &          active_var )
          CALL PROFILES_NF_ERROR(
     &         'ACTIVE_WRITE: NF_PUT_VARA_DOUBLE active_var',
     &         err,bi,bj,myThid )

          err = NF_INQ_VARID( fid,
     &          prof_namesmask(active_num_file,active_varnum),
     &          maskId )
          CALL PROFILES_NF_ERROR(
     &         'ACTIVE_WRITE: NF_INQ_VARID prof_namesmask',
     &         err,bi,bj,myThid )
          err = NF_PUT_VARA_DOUBLE(fid, maskId, vec_start, vec_count,
     &          prof_mask1D_cur(1,bi,bj) )
          CALL PROFILES_NF_ERROR(
     &         'ACTIVE_WRITE: NF_PUT_VARA_DOUBLE prof_mask1D_cur',
     &         err,bi,bj,myThid )

          err = NF_INQ_VARID( fid, 'prof_ind_glob', maskId )
          CALL PROFILES_NF_ERROR(
     &         'ACTIVE_WRITE: NF_INQ_VARID prof_ind_glob',
     &         err,bi,bj,myThid )
          err = NF_PUT_VAR1_INT( fid, maskId, vec_start(2), irecglob )
          CALL PROFILES_NF_ERROR(
     &         'ACTIVE_WRITE: NF_PUT_VAR1_INT irecglob',
     &         err,bi,bj,myThid )

        ELSE

          DO ivar=1,nactive_var
            vec_tmp(ivar)=active_var(ivar)
          ENDDO
          vec_tmp(nactive_var+1)=irecglob
# ifdef _BYTESWAPIO
          CALL MDS_BYTESWAPR8(nactive_var+1,vec_tmp)
# endif
          WRITE(fid,rec=jrec+1) vec_tmp
          DO ivar=1,nactive_var
            vec_tmp(ivar)=prof_mask1D_cur(ivar,bi,bj)
          ENDDO
          vec_tmp(nactive_var+1)=irecglob
# ifdef _BYTESWAPIO
          CALL MDS_BYTESWAPR8(nactive_var+1,vec_tmp)
# endif
          WRITE(fid,rec=jrec+2) vec_tmp

        ENDIF

        _END_MASTER( myThid )

      ENDIF

C     >>>>>>>>>>>>>>>>>>>             <<<<<<<<<<<<<<<<<<<
C     >>>>>>>>>>>>>>>>>>> ADJOINT RUN <<<<<<<<<<<<<<<<<<<
C     >>>>>>>>>>>>>>>>>>>             <<<<<<<<<<<<<<<<<<<

      IF (theSimulationMode .EQ. REVERSE_SIMULATION) THEN

        _BEGIN_MASTER( myThid )

        IF (profilesDoNcOutput) THEN
          err = NF_GET_VARA_DOUBLE( fid, varId, vec_start, vec_count,
     &          active_data_t )
          CALL PROFILES_NF_ERROR(
     &         'ACTIVE_WRITE: NF_GET_VARA_DOUBLE AD active_data_t',
     &         err,bi,bj,myThid )

C     Add active_var to data.
          DO i = 1,nactive_var
            active_var(i) = active_var(i) + active_data_t(i)
            active_data_t(i) = 0. _d 0
          ENDDO

          err = NF_PUT_VARA_DOUBLE( fid, varId, vec_start, vec_count,
     &          active_data_t )
          CALL PROFILES_NF_ERROR(
     &         'ACTIVE_WRITE: NF_PUT_VARA_DOUBLE AD active_data_t',
     &         err,bi,bj,myThid )

        ELSE

          READ(fid,rec=jrec+1) vec_tmp
# ifdef _BYTESWAPIO
          CALL MDS_BYTESWAPR8(nactive_var+1,vec_tmp)
# endif
          DO ivar=1,nactive_var
            active_data_t(ivar)=vec_tmp(ivar)
          ENDDO

C         Add active_var from appropriate location to data.
          DO i = 1,nactive_var
            active_var(i) = active_var(i) + active_data_t(i)
            active_data_t(i) = 0. _d 0
          ENDDO

C         Store the result on disk.
          DO ivar=1,nactive_var
            vec_tmp(ivar)=active_data_t(ivar)
          ENDDO
# ifdef _BYTESWAPIO
          CALL MDS_BYTESWAPR8(nactive_var+1,vec_tmp)
# endif
          WRITE(fid,rec=jrec+1) vec_tmp

        ENDIF

        _END_MASTER( myThid )

      ENDIF

C     >>>>>>>>>>>>>>>>>>>             <<<<<<<<<<<<<<<<<<<
C     >>>>>>>>>>>>>>>>>>> TANGENT RUN <<<<<<<<<<<<<<<<<<<
C     >>>>>>>>>>>>>>>>>>>             <<<<<<<<<<<<<<<<<<<

      IF (theSimulationMode .EQ. TANGENT_SIMULATION) THEN

        _BEGIN_MASTER( myThid )

        IF (profilesDoNcOutput) THEN
          err = NF_PUT_VARA_DOUBLE( fid, varId, vec_start, vec_count,
     &          active_var )
          CALL PROFILES_NF_ERROR(
     &         'ACTIVE_WRITE: NF_PUT_VARA_DOUBLE TL active_var',
     &         err,bi,bj,myThid )

        ELSE

          DO ivar=1,nactive_var
            vec_tmp(ivar)=active_var(ivar)
          ENDDO
          vec_tmp(nactive_var+1)=irecglob
# ifdef _BYTESWAPIO
          CALL MDS_BYTESWAPR8(nactive_var+1,vec_tmp)
# endif
          WRITE(fid,rec=jrec+1) vec_tmp

        ENDIF

        _END_MASTER( myThid )

      ENDIF

#endif /* ALLOW_PROFILES */

      RETURN
      END

#include "KL10_OPTIONS.h"

CBOP
C     !ROUTINE: KL10_DIAGNOSTICS_INIT
C     !INTERFACE:
      SUBROUTINE KL10_DIAGNOSTICS_INIT( myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE KL10_DIAGNOSTICS_INIT
C     | o Routine to initialize list of all available diagnostics
C     |   for KL10 package
C     *==========================================================*
C     \ev
C     !USES:
      IMPLICIT NONE

C     === Global variables ===

C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
C     myThid ::  my Thread Id number
      INTEGER myThid
CEOP

#ifdef ALLOW_DIAGNOSTICS
C     !LOCAL VARIABLES :
C     === Local variables ===
C     diagNum   :: diagnostics number in the (long) list of available diag.
C     diagName  :: local short name (8c) of a diagnostics
C     diagCode  :: local parser field with characteristics of the diagnostics
C              cf head of S/R DIAGNOSTICS_INIT_EARLY or DIAGNOSTICS_MAIN_INIT
C     diagUnits :: local string (16c): physical units of a diagnostic field
C     diagTitle :: local string (80c): description of field in diagnostic
      INTEGER       diagNum
      CHARACTER*8   diagName
      CHARACTER*16  diagCode
      CHARACTER*16  diagUnits
      CHARACTER*(80) diagTitle

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

        diagName  = 'KLviscAr'
        diagTitle = 'KL10 vertical eddy viscosity coefficient'
        diagUnits = 'm^2/s           '
        diagCode  = 'SM P    LR      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

        diagName  = 'KLdiffKr'
        diagTitle = 'KL10 Vertical diffusion coefficient for tracers'
        diagUnits = 'm^2/s           '
        diagCode  = 'SM P    LR      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

        diagName  = 'KLeps   '
        diagTitle = 'KL10 Turbulent dissipation rate'
        diagUnits = 'm^2/s^3           '
        diagCode  = 'SM P    LR      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

#endif /* ALLOW_DIAGNOSTICS */

      RETURN
      END

#include "GCHEM_OPTIONS.h"

CBOP
C !ROUTINE: GCHEM_FIELDS_LOAD

C !INTERFACE: ==========================================================
      SUBROUTINE GCHEM_FIELDS_LOAD (
     I           myTime, myIter, myThid )

C !DESCRIPTION:
C  calls routines which read in fields needed for any tracer experiment
C !USES: ===============================================================
      IMPLICIT NONE
#include "EEPARAMS.h"
#include "GCHEM.h"

C !INPUT PARAMETERS: ===================================================
C  myTime               :: current time
C  myIter               :: current iteration
C  myThid               :: thread number
      _RL myTime
      INTEGER myIter
      INTEGER myThid

C !LOCAL VARIABLES: ====================================================
CEOP

#ifdef ALLOW_GCHEM

cccccccccccccccccccccccccc
c load external data     c
cccccccccccccccccccccccccc
#ifdef ALLOW_DIC
      IF ( useDIC ) THEN
       CALL DIC_FIELDS_LOAD( myTime, myIter, myThid )
      ENDIF
#endif

#ifdef ALLOW_BLING
      IF ( useBLING ) THEN
       CALL BLING_FIELDS_LOAD( myTime, myIter, myThid )
      ENDIF
#endif

#ifdef ALLOW_CFC
      IF ( useCFC ) THEN
       CALL CFC_FIELDS_LOAD( myTime, myIter, myThid )
      ENDIF
#endif

#ifdef ALLOW_DARWIN
      IF ( useDARWIN ) THEN
       CALl DARWIN_FIELDS_LOAD(myIter,myTime,myThid)
      ENDIF
#endif

#endif /* ALLOW_GCHEM */

      RETURN
      END

#include "ATM_CPL_OPTIONS.h"

CBOP 0
C !ROUTINE: CPL_REGISTER

C !INTERFACE:
      SUBROUTINE CPL_REGISTER

C !DESCRIPTION:
C     *==========================================================*
C     | SUBROUTINE CPL_REGISTER
C     | o Routine controlling registration with MIT coupler.
C     | - Atmospheric version -
C     *==========================================================*
C     | This version talks to the MIT Coupler. It uses the MIT
C     | Coupler "checkpoint1" library calls.
C     *==========================================================*

C !USES:
      IMPLICIT NONE
C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#ifdef ALLOW_EXCH2
# include "W2_EXCH2_SIZE.h"
# include "W2_EXCH2_TOPOLOGY.h"
# include "W2_EXCH2_PARAMS.h"
#endif /* ALLOW_EXCH2 */

C !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     myThid    :: Thread number for this instance of the routine
c     INTEGER myThid
CEOP

#ifdef COMPONENT_MODULE
C !LOCAL VARIABLES:
C     == Local variables ==
C     bi, bj    :: Tile indices
C     j         :: Loop counter
C     iG0, jG0  :: Base coordinates of a tile on the global grid.
C     iReg      :: Array for passing attributes to the coupler
C     x,ySize   :: expected size of the coupler 2-D maps
      INTEGER iG0, jG0
      INTEGER bi, bj
      INTEGER j, nTiles
      INTEGER iReg(6,nSx*nSy)
c     INTEGER xSize, ySize
#ifdef ALLOW_EXCH2
      INTEGER tN
      LOGICAL useExch2LayOut
#endif /* ALLOW_EXCH2 */

C--   Set dimensions of coupler 2-D maps:
c     xSize = Nx
c     ySize = Ny

#ifdef ALLOW_EXCH2
C-- Note: current coupler mapping relies only on i0,j0,nx,ny ; this prevent to
C     map tiles to Exch-2 global map when faces do not fit in global-IO-array
C     (see, e.g., gather/scatter_2d routines in eesupp/src, case where
C      iGjLoc <> 0 or jGjLoc <> 1 ).
      useExch2LayOut = .FALSE.
      IF ( W2_useE2ioLayOut ) THEN
        useExch2LayOut = .TRUE.
        DO tN=1,exch2_nTiles
          IF   ( exch2_mydNx(tN) .GT. exch2_global_Nx ) THEN
           useExch2LayOut = .FALSE.
C-         face x-size larger than glob-size : fold it
c              iGjLoc = 0
c              jGjLoc = exch2_mydNx(tN) / xSize
          ELSEIF ( exch2_tNy(tN) .GT. exch2_global_Ny ) THEN
           useExch2LayOut = .FALSE.
C-         tile y-size larger than glob-size : make a long line
c              iGjLoc = exch2_mydNx(tN)
c              jGjLoc = 0
          ELSE
C-          default (face fit into global-IO-array)
c             iGjLoc = 0
c             jGjLoc = 1
          ENDIF
        ENDDO
      ENDIF
c     IF ( useExch2LayOut ) THEN
c       xSize = exch2_global_Nx
c       ySize = exch2_global_Ny
c     ENDIF
C-- Note: should check that xSize,ySize match with coupler Nx_atm,Ny_atm
#endif /* ALLOW_EXCH2 */

C--   Register with the MIT coupler
      j = 0
      DO bj=1,nSy
       DO bi=1,nSx
        j = j+1
        jG0 = myYGlobalLo+(bj-1)*sNy
        iG0 = myXGlobalLo+(bi-1)*sNx
#ifdef ALLOW_EXCH2
        IF ( useExch2LayOut ) THEN
          tN = W2_myTileList(bi,bj)
          iG0 = exch2_txGlobalo(tN)
          jG0 = exch2_tyGlobalo(tN)
        ENDIF
#endif /* ALLOW_EXCH2 */
        iReg(1,j) = bi
        iReg(2,j) = bj
        iReg(3,j) = sNx
        iReg(4,j) = sNy
        iReg(5,j) = iG0
        iReg(6,j) = jG0
       ENDDO
      ENDDO
      nTiles = nSx*nSy
      CALL MITCOMPONENT_TILE_REGISTER( nTiles, iReg )
#endif /* COMPONENT_MODULE */

      RETURN
      END

#include "DIAG_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 0
C     !ROUTINE: DIAGNOSTICS_READPARMS

C     !INTERFACE:
      SUBROUTINE DIAGNOSTICS_READPARMS( myThid )

C     !DESCRIPTION:
C     Read Diagnostics Namelists to specify output sequence.

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "DIAGNOSTICS_SIZE.h"
#include "DIAGNOSTICS_P2SHARE.h"
#include "DIAGNOSTICS.h"
#include "DIAGNOSTICS_CALC.h"
#include "DIAGSTATS_REGIONS.h"

C     !INPUT PARAMETERS:
      INTEGER myThid
CEOP

C     !FUNCTIONS:
      INTEGER  ILNBLNK
      EXTERNAL ILNBLNK
      CHARACTER*(8) DIAGS_RENAMED
      EXTERNAL DIAGS_RENAMED
#ifdef ALLOW_FIZHI
      _RL      getcon
      EXTERNAL getcon
#endif

C     !LOCAL VARIABLES:
C     ldimLoc :: Max Number of Lists  (in data.diagnostics)
C     kdimLoc :: Max Number of Levels (in data.diagnostics)
C     fdimLoc :: Max Number of Fields (in data.diagnostics)
C     frequency :: Frequency (in s) of Output (ouput every "frequency" second)
C     timePhase :: phase (in s) within the "frequency" period to write output
C     averagingFreq  :: frequency (in s) for periodic averaging interval
C     averagingPhase :: phase     (in s) for periodic averaging interval
C     repeatCycle    :: number of averaging intervals in 1 cycle
C     missing_value  :: missing value for real-type fields in output file
C     missing_value_int :: missing value for integers in output (not used)
C     levels    :: List Output Levels
C     fields    :: List Output Fields
C     fileName  :: List Output Filename
C--   for regional-statistics
C     set_regMask(n) :: region-mask set-index that define the region "n"
C     val_regMask(n) :: corresponding mask value of region "n" in the region-mask
C--   per level statistics output:
C     stat_freq   :: Frequency (in s) of statistics output
C     stat_phase  :: phase (in s) to write statistics output
C     stat_region :: List of statistics output Regions
C     stat_fields :: List of statistics output Fields
C     stat_fName  :: List of statistics output Filename
      INTEGER     ldimLoc, kdimLoc, fdimLoc, rdimLoc
      PARAMETER ( ldimLoc = 2*numLists )
      PARAMETER ( kdimLoc = 2*numLevels )
      PARAMETER ( fdimLoc = 2*numperList )
      PARAMETER ( rdimLoc = nRegions+21 )
      _RL         frequency(ldimLoc), timePhase(ldimLoc)
      _RL         averagingFreq(ldimLoc), averagingPhase(ldimLoc)
      INTEGER     repeatCycle(ldimLoc)
      _RL         missing_value(ldimLoc)
      INTEGER     missing_value_int(ldimLoc)
      _RL         levels(kdimLoc,ldimLoc)
      _RL         stat_freq(ldimLoc), stat_phase(ldimLoc)
      CHARACTER*8 fields(fdimLoc,ldimLoc)
      CHARACTER*8 stat_fields(fdimLoc,ldimLoc)
      CHARACTER*80 fileName(ldimLoc), blkFilName
      CHARACTER*80 stat_fName(ldimLoc)
      CHARACTER*8 fileFlags(ldimLoc)
      CHARACTER*8 blk8c, diagName
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      CHARACTER*(MAX_LEN_FNAM) namBuf
      CHARACTER*12 suffix
      INTEGER stat_region(rdimLoc,ldimLoc)
      INTEGER set_regMask(rdimLoc)
      _RS     val_regMask(rdimLoc)
      INTEGER ku, stdUnit
      INTEGER j,k,l,n,m,nf
      INTEGER iLen, regionCount

C--   full level output:
      NAMELIST / DIAGNOSTICS_LIST /
     &     frequency, timePhase,
     &     averagingFreq, averagingPhase, repeatCycle,
     &     missing_value, missing_value_int,
     &     levels, fields, fileName, fileFlags,
     &     dumpAtLast, diag_dBugLevel, diag_mnc, useMissingValue,
     &     diagCG_maxIters, diagCG_resTarget,
     &     diagCG_pcOffDFac, diagCG_prtResFrq, xPsi0, yPsi0,
     &     diag_pickup_read,     diag_pickup_write,
     &     diag_pickup_read_mnc, diag_pickup_write_mnc,
     &     diagMdsDir, diagMdsDirCreate

C--   per level statistics output:
      NAMELIST / DIAG_STATIS_PARMS /
     &     stat_freq, stat_phase, stat_region, stat_fields,
     &     stat_fName, diagSt_mnc,
     &     set_regMask, val_regMask,
     &     diagSt_regMaskFile, nSetRegMskFile

      IF ( .NOT.useDiagnostics ) THEN
C-    pkg DIAGNOSTICS is not used
        _BEGIN_MASTER(myThid)
         useDiag4AdjOutp = .FALSE.
C-    Track diagnostics pkg activation status:
         diag_pkgStatus = -1
C     print a (weak) warning if data.diagnostics is found
         CALL PACKAGES_UNUSED_MSG( 'useDiagnostics', ' ', ' ' )
        _END_MASTER(myThid)
        _BARRIER
        RETURN
      ENDIF

C-    Initialize and Read Diagnostics Namelist
      _BEGIN_MASTER(myThid)

      blk8c  = '        '
      DO k=1,LEN(blkFilName)
        blkFilName(k:k) = ' '
      ENDDO

      DO l = 1,ldimLoc
        frequency(l)  = 0.
        timePhase(l)  = UNSET_RL
        averagingFreq(l) = 0.
        averagingPhase(l)= 0.
        repeatCycle(l)   = 0
        fileName(l)   = blkFilName
C-    Cannot use model standard Unset value since this was used previously
C     as defaut missing value that one might want to recover;
C     Use instead the unlikely missing value of One for the Undef-missing-Val
c       missing_value(l)     = UNSET_RL
        missing_value(l)     = oneRL
        missing_value_int(l) = UNSET_I
        fileFlags(l)  = blk8c
        DO k = 1,kdimLoc
          levels(k,l) = UNSET_RL
        ENDDO
        DO m = 1,fdimLoc
          fields(m,l) = blkName
        ENDDO
      ENDDO
      diagLoc_ioUnit = 0
      diag_dBugLevel = debugLevel
      dumpAtLast   = .FALSE.
      diag_mnc     = useMNC
      useMissingValue = .FALSE.
      diag_pickup_read      = .FALSE.
      diag_pickup_write     = .FALSE.
      diag_pickup_read_mnc  = .FALSE.
      diag_pickup_write_mnc = .FALSE.
      diagMdsDir = ' '
      diagMdsDirCreate = .TRUE.

      prtFirstCall     = .TRUE.
      diagCG_maxIters  = cg2dMaxIters
      diagCG_resTarget = cg2dTargetResidual
      diagCG_prtResFrq = printResidualFreq
      diagCG_pcOffDFac = 1.
      IF ( cg2dpcOffDFac.GT.zeroRL )
     &  diagCG_pcOffDFac = 0.25 _d 0 /( cg2dpcOffDFac*cg2dpcOffDFac )
      xPsi0 = UNSET_RS
      yPsi0 = UNSET_RS

      diagSt_regMaskFile = ' '
      nSetRegMskFile = 0
      DO k = 1,rdimLoc
        set_regMask(k) = 0
        val_regMask(k) = 0.
      ENDDO
      DO l = 1,ldimLoc
        stat_freq(l)  = 0.
        stat_phase(l) = UNSET_RL
        stat_fName(l) = blkFilName
        DO k = 1,rdimLoc
          stat_region(k,l) = UNSET_I
        ENDDO
        DO m = 1,fdimLoc
          stat_fields(m,l) = blkName
        ENDDO
      ENDDO
C     useDiag4AdjOutp will be to set to T if ADJ diags are found in namelist
      useDiag4AdjOutp = .FALSE.
C-    Track diagnostics pkg activation status:
      diag_pkgStatus = 1

      WRITE(msgBuf,'(2A)')
     &     ' DIAGNOSTICS_READPARMS: opening data.diagnostics'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,SQUEEZE_RIGHT,1)

      CALL OPEN_COPY_DATA_FILE('data.diagnostics',
     &     'DIAGNOSTICS_READPARMS', ku, myThid )

      WRITE(msgBuf,'(2A)') 'S/R DIAGNOSTICS_READPARMS,',
     &     ' read namelist "diagnostics_list": start'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT , 1)
      READ  (ku,NML=diagnostics_list)
      WRITE(msgBuf,'(2A)') 'S/R DIAGNOSTICS_READPARMS,',
     &     ' read namelist "diagnostics_list": OK'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT , 1)

C-    set default for statistics output according to the main flag
      diag_mnc = diag_mnc .AND. useMNC
      diagSt_mnc = diag_mnc

      WRITE(msgBuf,'(2A)') 'S/R DIAGNOSTICS_READPARMS,',
     &     ' read namelist "DIAG_STATIS_PARMS": start'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT , 1)
      READ  (ku,NML=DIAG_STATIS_PARMS)
      WRITE(msgBuf,'(2A)') 'S/R DIAGNOSTICS_READPARMS,',
     &     ' read namelist "DIAG_STATIS_PARMS": OK'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT , 1)

#ifdef SINGLE_DISK_IO
      CLOSE(ku)
#else
      CLOSE(ku,STATUS='DELETE')
#endif /* SINGLE_DISK_IO */

C     Initialise DIAG_SELECT common block (except pointers)
      nlists = 0
      DO n = 1,numLists
        freq(n) = 0.
        phase(n) = 0.
        averageFreq(n)  = 0.
        averagePhase(n) = 0.
        averageCycle(n) = 1
        nlevels(n) = 0
        nfields(n) = 0
        fnames(n) = blkFilName
c       misValFlt(n) = UNSET_RL
c       misValInt(n) = UNSET_I
        misValFlt(n) = -999. _d 0
#ifdef ALLOW_FIZHI
        IF ( useFIZHI ) misValFlt(n) = getcon('UNDEF')
#endif
        DO k = 1,numLevels
          levs(k,n) = 0
        ENDDO
        DO m = 1,numperList
          flds(m,n) = blkName
        ENDDO
        fflags(n)   = blk8c
      ENDDO

C     useMNC is confusing (can be T at this point & turned off later, whereas
C     for all other pkgs, model stops if use${PKG}= T with #undef ALLOW_${PKG})
#ifndef ALLOW_MNC
C     Fix to avoid running without getting any output:
      diag_mnc   = .FALSE.
      diagSt_mnc = .FALSE.
#endif

C     Fill Diagnostics Common Block with Namelist Info
      diagSt_mnc = diagSt_mnc .AND. useMNC
      diag_mdsio = (.NOT. diag_mnc) .OR. outputTypesInclusive
      diag_pickup_read_mnc  = diag_pickup_read_mnc .AND. diag_mnc
      diag_pickup_write_mnc = diag_pickup_write_mnc .AND. diag_mnc
      diag_pickup_read_mdsio  =
     &     diag_pickup_read .AND. (.NOT. diag_pickup_read_mnc)
      diag_pickup_write_mdsio = diag_pickup_write .AND.
     &     ((.NOT. diag_pickup_write_mnc) .OR. outputTypesInclusive)
      diagSt_ascii = (.NOT. diagSt_mnc) .OR. outputTypesInclusive

C     remove trailing "/":
      iLen = ILNBLNK( diagMdsDir )
      IF ( iLen.GE.2 ) THEN
       IF ( diagMdsDir(iLen:iLen).EQ.'/' ) THEN
         namBuf = diagMdsDir
         WRITE(diagMdsDir,'(A)') namBuf(1:iLen-1)
       ENDIF
      ENDIF

      DO l = 1,ldimLoc
       iLen = ILNBLNK(fileName(l))
C-     Only lists with non-empty file name (iLen>0) are considered
       IF ( iLen.GE.1 .AND. nlists.LT.numLists ) THEN
         n = nlists + 1
         freq(n)    = frequency(l)
         IF ( timePhase(l).NE. UNSET_RL ) THEN
           phase(n) = timePhase(l)
         ELSEIF ( frequency(l) .LT. 0. ) THEN
           phase(n) = -0.5 _d 0 * frequency(l)
         ENDIF
         IF ( averagingFreq(l).GT.0. .AND. repeatCycle(l).GT.1 ) THEN
           averageFreq(n)  = averagingFreq(l)
           averagePhase(n) = averagingPhase(l)
           averageCycle(n) = repeatCycle(l)
         ELSEIF (averagingFreq(l).NE.0. .OR. repeatCycle(l).NE.0) THEN
           WRITE(msgBuf,'(2A,F18.6,I4)') 'DIAGNOSTICS_READPARMS: ',
     &       'unvalid Average-Freq & Cycle:',
     &       averagingFreq(l), repeatCycle(l)
           CALL PRINT_ERROR( msgBuf , myThid )
           WRITE(msgBuf,'(2A,I4,2A)') 'DIAGNOSTICS_READPARMS: ',
     &         ' for list l=', l, ', fileName: ', fileName(l)
           CALL PRINT_ERROR( msgBuf , myThid )
           STOP 'ABNORMAL END: S/R DIAGNOSTICS_READPARMS'
         ELSEIF ( frequency(l) .EQ. 0. ) THEN
           averageFreq(n)  = nTimeSteps*deltaTClock
           averagePhase(n) = phase(n)
         ELSEIF ( frequency(l) .GT. 0. ) THEN
           averageFreq(n)  = frequency(l)
           averagePhase(n) = phase(n)
         ENDIF
c        IF ( missing_value(l) .NE. UNSET_RL )
c    &        misValFlt(n) = missing_value(l)
c        IF ( missing_value_int(l) .NE. UNSET_I )
c    &        misValInt(n) = missing_value_int(l)
         IF ( missing_value(l) .NE. oneRL )
     &        misValFlt(n) = missing_value(l)
         fnames(n)  = fileName (l)
         fflags(n)  = fileFlags(l)
         nlevels(n) = 0
         IF ( levels(1,l).NE.UNSET_RL ) THEN
           DO k=1,kdimLoc
             IF ( levels(k,l).NE.UNSET_RL .AND.
     &            nlevels(n).LT.numLevels ) THEN
               nlevels(n) = nlevels(n) + 1
               levs(nlevels(n),n) = levels(k,l)
             ELSEIF ( levels(k,l).NE.UNSET_RL ) THEN
              WRITE(msgBuf,'(2A,I4)') 'DIAGNOSTICS_READPARMS: ',
     &         'Exceed Max.Num. of Levels numLevels=', numLevels
              CALL PRINT_ERROR( msgBuf , myThid )
              WRITE(msgBuf,'(2A,I4,A,F8.0)') 'DIAGNOSTICS_READPARMS: ',
     &         'when trying to add level(k=', k, ' )=', levels(k,l)
              CALL PRINT_ERROR( msgBuf , myThid )
              WRITE(msgBuf,'(2A,I4,2A)') 'DIAGNOSTICS_READPARMS: ',
     &         ' for list l=', l, ', fileName: ', fileName(l)
              CALL PRINT_ERROR( msgBuf , myThid )
              STOP 'ABNORMAL END: S/R DIAGNOSTICS_READPARMS'
             ENDIF
           ENDDO
         ELSE
C-       will set levels later, once the Nb of levels of each diag is known
           nlevels(n) = -1
         ENDIF
         nfields(n) = 0
         DO m=1,fdimLoc
           diagName = DIAGS_RENAMED( fields(m,l), myThid )
           IF ( diagName.NE.blkName .AND.
     &          nfields(n).LT.numperList ) THEN
             nfields(n) = nfields(n) + 1
             flds(nfields(n),n) = diagName
           ELSEIF ( diagName.NE.blkName ) THEN
             WRITE(msgBuf,'(2A,I4)') 'DIAGNOSTICS_READPARMS: ',
     &        'Exceed Max.Num. of Fields/list numperList=', numperList
             CALL PRINT_ERROR( msgBuf , myThid )
             WRITE(msgBuf,'(2A,I4,3A,I4,2A)') 'DIAGNOSTICS_READPARMS: ',
     &        'when trying to add field (m=', m, ' ): ', diagName
             CALL PRINT_ERROR( msgBuf , myThid )
             WRITE(msgBuf,'(2A,I4,2A)') 'DIAGNOSTICS_READPARMS: ',
     &        ' in list l=', l, ', fileName: ', fileName(l)
             CALL PRINT_ERROR( msgBuf , myThid )
             STOP 'ABNORMAL END: S/R DIAGNOSTICS_READPARMS'
           ENDIF
         ENDDO
         nlists = nlists + 1
c        write(6,*) 'list summary:',n,nfields(n),nlevels(n)
       ELSEIF ( iLen.GE.1 ) THEN
         WRITE(msgBuf,'(2A,I4)') 'DIAGNOSTICS_READPARMS: ',
     &            'Exceed Max.Num. of list numLists=', numLists
         CALL PRINT_ERROR( msgBuf , myThid )
         WRITE(msgBuf,'(2A,I4)') 'DIAGNOSTICS_READPARMS: ',
     &    'when trying to add list l=', l
         CALL PRINT_ERROR( msgBuf , myThid )
         WRITE(msgBuf,'(2A,F18.6,2A)') 'DIAGNOSTICS_READPARMS: ',
     &    ' Frq=', frequency(l), ', fileName: ', fileName(l)
         CALL PRINT_ERROR( msgBuf , myThid )
         STOP 'ABNORMAL END: S/R DIAGNOSTICS_READPARMS'
       ENDIF
      ENDDO

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C-    Initialise DIAG_STATS_REGMASK common block (except the mask)
      nSetRegMask = 0
      DO j = 0,nRegions
        diagSt_kRegMsk(j) = 0
        diagSt_vRegMsk(j) = 0.
      ENDDO
C     Global statistics (region # 0)
      diagSt_kRegMsk(0) = 1

C-    Initialise DIAG_STATIS common block (except pointers)
      diagSt_nbLists = 0
      DO n = 1,numLists
        diagSt_freq(n) = 0.
        diagSt_phase(n) = 0.
        diagSt_nbFlds(n) = 0
        diagSt_ioUnit(n) = 0
        diagSt_Fname(n) = blkFilName
        DO j = 0,nRegions
          diagSt_region(j,n) = 0
        ENDDO
        DO m = 1,numperList
          diagSt_Flds(m,n) = blkName
        ENDDO
      ENDDO

C     Fill Diagnostics Common Block with Namelist Info
      diagSt_ascii = (.NOT. diagSt_mnc) .OR. outputTypesInclusive

C-    Region mask correspondence table:
C     note: this table should be build when regions are defined ;
C     for now, simpler just to read it from namelist in data.diagnostics
      j = 0
      DO k = 1,rdimLoc
       IF ( set_regMask(k).NE.0 .OR. val_regMask(k).NE.0. ) THEN
         j = j+1
         IF ( j.LE.nRegions ) THEN
           diagSt_kRegMsk(j) = set_regMask(k)
           diagSt_vRegMsk(j) = val_regMask(k)
         ENDIF
       ENDIF
      ENDDO
      IF ( j.GT.nRegions ) THEN
         WRITE(msgBuf,'(2A,I4,A)') 'DIAGNOSTICS_READPARMS: ',
     &   'set_regMask & val_regMask lists assume at least',j,' regions'
         CALL PRINT_ERROR( msgBuf , myThid )
         WRITE(msgBuf,'(2A)') 'DIAGNOSTICS_READPARMS: ',
     &   'Need to increase "nRegions" in DIAGNOSTICS_SIZE.h'
         CALL PRINT_ERROR( msgBuf , myThid )
         STOP 'ABNORMAL END: S/R DIAGNOSTICS_READPARMS'
      ENDIF

      DO l = 1,ldimLoc
       iLen = ILNBLNK(stat_fName(l))
C-     Only lists with non-empty file name (iLen>0) are considered
       IF ( iLen.GE.1 .AND. diagSt_nbLists.LT.numLists)THEN
         n = diagSt_nbLists + 1
         diagSt_freq(n) = stat_freq(l)
         IF ( stat_phase(l).NE. UNSET_RL ) THEN
           diagSt_phase(n) = stat_phase(l)
         ELSEIF ( stat_freq(l) .LT. 0. ) THEN
           diagSt_phase(n) = -0.5 _d 0 * stat_freq(l)
         ENDIF
         diagSt_Fname(n)  = stat_fName(l)
         regionCount = 0
         DO k=1,rdimLoc
           j = stat_region(k,l)
           IF ( j.NE.UNSET_I .AND. j.GE.0 .AND. j.LE.nRegions ) THEN
            IF ( diagSt_region(j,n).EQ.0 ) THEN
             diagSt_region(j,n) = 1
             regionCount = regionCount + 1
            ELSE
             WRITE(msgBuf,'(2A,I4,2A)')
     &        'DIAGNOSTICS_READPARMS:',
     &        ' in list l=', l, ', stat_fName: ', stat_fName(l)
             CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                           SQUEEZE_RIGHT , myThid )
             WRITE(msgBuf,'(A,I4,A)')
     &        'DIAGNOSTICS_READPARMS: region=',j,
     &        ' can only be selected once => ignore 2nd selection'
             CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                           SQUEEZE_RIGHT , myThid )
            ENDIF
           ELSEIF ( j.NE.UNSET_I ) THEN
             WRITE(msgBuf,'(A,I4,A,I4,2A)')
     &       'DIAGNOSTICS_READPARMS: region=',j,
     &         ' in list l=', l, ', stat_fName: ', stat_fName(l)
             CALL PRINT_ERROR( msgBuf , myThid )
             WRITE(msgBuf,'(2A,I4,A,I4,2A)')
     &       'DIAGNOSTICS_READPARMS: ==> exceed Max.Nb of regions',
     &       '(=',nRegions,' )'
             CALL PRINT_ERROR( msgBuf , myThid )
             STOP 'ABNORMAL END: S/R DIAGNOSTICS_READPARMS'
           ENDIF
         ENDDO
         IF ( regionCount.EQ.0 ) THEN
C-       no region selected => default is Global statistics (region Id: 0)
           diagSt_region(0,n) = 1
         ENDIF
         diagSt_nbFlds(n) = 0
         DO m=1,fdimLoc
           diagName = DIAGS_RENAMED( stat_fields(m,l), myThid )
           IF ( diagName.NE.blkName .AND.
     &          diagSt_nbFlds(n).LT.numperList ) THEN
             diagSt_nbFlds(n) = diagSt_nbFlds(n) + 1
             diagSt_Flds(diagSt_nbFlds(n),n) = diagName
           ELSEIF ( diagName.NE.blkName ) THEN
             WRITE(msgBuf,'(2A,I4)') 'DIAGNOSTICS_READPARMS: ',
     &        'Exceed Max.Num. of Fields/list numperList=', numperList
             CALL PRINT_ERROR( msgBuf , myThid )
             WRITE(msgBuf,'(2A,I4,3A,I4,2A)') 'DIAGNOSTICS_READPARMS: ',
     &        'when trying to add stat_field (m=', m, ' ): ', diagName
             CALL PRINT_ERROR( msgBuf , myThid )
             WRITE(msgBuf,'(2A,I4,2A)') 'DIAGNOSTICS_READPARMS: ',
     &        ' in list l=', l, ', stat_fName: ', stat_fName(l)
             CALL PRINT_ERROR( msgBuf , myThid )
             STOP 'ABNORMAL END: S/R DIAGNOSTICS_READPARMS'
           ENDIF
         ENDDO
         diagSt_nbLists = diagSt_nbLists + 1
c        write(6,*) 'stat-list summary:',n,diagSt_nbFlds(n),regionCount
       ELSEIF ( iLen.GE.1 ) THEN
         WRITE(msgBuf,'(2A,I4)') 'DIAGNOSTICS_READPARMS: ',
     &            'Exceed Max.Num. of list numLists=', numLists
         CALL PRINT_ERROR( msgBuf , myThid )
         WRITE(msgBuf,'(2A,I4)') 'DIAGNOSTICS_READPARMS: ',
     &    'when trying to add stat_list l=', l
         CALL PRINT_ERROR( msgBuf , myThid )
         WRITE(msgBuf,'(2A,F18.6,2A)') 'DIAGNOSTICS_READPARMS: ',
     &    ' Frq=', stat_freq(l), ', stat_fName: ', stat_fName(l)
         CALL PRINT_ERROR( msgBuf , myThid )
         STOP 'ABNORMAL END: S/R DIAGNOSTICS_READPARMS'
       ENDIF
      ENDDO

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C     Echo History List Data Structure
      stdUnit = standardMessageUnit
      WRITE(msgBuf,'(A)')
     & '-----------------------------------------------------'
      CALL PRINT_MESSAGE( msgBuf, stdUnit,SQUEEZE_RIGHT, myThid)
      WRITE(msgBuf,'(A)')
     &     ' DIAGNOSTICS_READPARMS: global parameter summary:'
      CALL PRINT_MESSAGE( msgBuf, stdUnit,SQUEEZE_RIGHT, myThid)
      CALL WRITE_0D_I( diag_dBugLevel, INDEX_NONE,
     & ' diag_dBugLevel =', ' /* level of printed debug messages */')
      CALL WRITE_0D_L( dumpAtLast, INDEX_NONE,
     & ' dumpAtLast =',' /* always write time-ave diags at the end */')
      CALL WRITE_0D_L( diag_mnc,   INDEX_NONE,
     & ' diag_mnc =', '   /* write NetCDF output files */')
      IF ( diag_mdsio.AND.(diagMdsDir.NE.' ') ) THEN
       CALL WRITE_0D_C( diagMdsDir, -1, INDEX_NONE,
     & ' diagMdsDir =', ' /* directory for mds diagnostics output */')
       CALL WRITE_0D_L( diagMdsDirCreate, INDEX_NONE,
     & ' diagMdsDirCreate =', ' /* call mkdir to create diagMdsDir */')
      ENDIF
      CALL WRITE_0D_L( useMissingValue, INDEX_NONE,
     & ' useMissingValue =', ' /* put MissingValue where mask = 0 */')
      CALL WRITE_0D_I( diagCG_maxIters, INDEX_NONE,
     & ' diagCG_maxIters =', ' /* max number of iters in diag_cg2d */')
      CALL WRITE_0D_RL( diagCG_resTarget, INDEX_NONE,
     & ' diagCG_resTarget =', ' /* residual target for diag_cg2d */')
      CALL WRITE_0D_RL( diagCG_pcOffDFac, INDEX_NONE,
     & ' diagCG_pcOffDFac =',
     & ' /* preconditioner off-diagonal factor */')
      WRITE(msgBuf,'(A)')
     & '-----------------------------------------------------'
      CALL PRINT_MESSAGE( msgBuf, stdUnit,SQUEEZE_RIGHT, myThid)
      WRITE(msgBuf,'(A)')
     &     ' DIAGNOSTICS_READPARMS: active diagnostics summary:'
      CALL PRINT_MESSAGE( msgBuf, stdUnit,SQUEEZE_RIGHT, myThid)
      WRITE(msgBuf,'(A)')
     & '-----------------------------------------------------'
      CALL PRINT_MESSAGE( msgBuf, stdUnit,SQUEEZE_RIGHT, myThid)
      DO n = 1,nlists
        WRITE(msgBuf,'(2A)') 'Creating Output Stream: ', fnames(n)
        CALL PRINT_MESSAGE( msgBuf, stdUnit,SQUEEZE_RIGHT, myThid)
        WRITE(msgBuf,'(2(A,F18.6))') 'Output Frequency:', freq(n),
     &                               ' ; Phase: ', phase(n)
        CALL PRINT_MESSAGE( msgBuf, stdUnit,SQUEEZE_RIGHT, myThid)
        WRITE(msgBuf,'(2(A,F18.6),A,I4)')
     &    ' Averaging Freq.:', averageFreq(n),
     &    ' , Phase: ', averagePhase(n), ' , Cycle:', averageCycle(n)
        CALL PRINT_MESSAGE( msgBuf, stdUnit,SQUEEZE_RIGHT, myThid)
        IF ( fflags(n).EQ.blk8c ) THEN
c         WRITE(msgBuf,'(A,1PE20.12,A,I12,3A)')
c    &       ' missing value:',  misValFlt(n),
c    &       ' ; for integers:', misValInt(n)
          WRITE(msgBuf,'(A,1PE20.12,3A)')
     &       ' missing value:', misValFlt(n)
        ELSE
c         WRITE(msgBuf,'(A,1PE20.12,A,I12,3A)')
c    &       ' missing value:',  misValFlt(n),
c    &       ' ; for integers:', misValInt(n),
c    &       ' ; F-Flags="', fflags(n),'"'
          WRITE(msgBuf,'(A,1PE20.12,3A)')
     &       ' missing value:', misValFlt(n),
     &       ' ; F-Flags="', fflags(n),'"'
        ENDIF
        CALL PRINT_MESSAGE( msgBuf, stdUnit,SQUEEZE_RIGHT, myThid)
        IF ( nlevels(n).EQ.-1 .AND. fflags(n)(2:2).EQ.'I' ) THEN
          WRITE(msgBuf,'(A)') ' Cumulate all Levels (to be set later)'
          CALL PRINT_MESSAGE( msgBuf, stdUnit,SQUEEZE_RIGHT, myThid)
        ELSEIF ( nlevels(n).EQ.-1 ) THEN
          WRITE(msgBuf,'(A,A)') ' Levels:    ','will be set later'
          CALL PRINT_MESSAGE( msgBuf, stdUnit,SQUEEZE_RIGHT, myThid)
        ELSEIF ( fflags(n)(2:2).EQ.'P' ) THEN
         DO l=1,nlevels(n),10
          m = MIN(nlevels(n),l+9)
          WRITE(msgBuf,'(A,1P10E10.3)')' interp:  ', (levs(k,n),k=l,m)
          CALL PRINT_MESSAGE( msgBuf, stdUnit,SQUEEZE_RIGHT, myThid)
         ENDDO
        ELSE
         suffix = ' Levels:    '
         IF ( fflags(n)(2:2).EQ.'I' ) suffix = ' Sum Levels:'
         DO l=1,nlevels(n),20
          m = MIN(nlevels(n),l+19)
          WRITE(msgBuf,'(A,20F5.0)') suffix, (levs(k,n),k=l,m)
          CALL PRINT_MESSAGE( msgBuf, stdUnit,SQUEEZE_RIGHT, myThid)
         ENDDO
        ENDIF
        DO nf = 1,nfields(n),10
          m = MIN(nfields(n),nf+9)
          WRITE(msgBuf,'(21A)') ' Fields:   ',(' ',flds(l,n),l=nf,m)
          CALL PRINT_MESSAGE( msgBuf, stdUnit,SQUEEZE_RIGHT, myThid)
        ENDDO
      ENDDO
      WRITE(msgBuf,'(A)')
     & '-----------------------------------------------------'
      CALL PRINT_MESSAGE( msgBuf, stdUnit,SQUEEZE_RIGHT, myThid)
      WRITE(msgBuf,'(A)')
     &     ' DIAGNOSTICS_READPARMS: statistics diags. summary:'
      CALL PRINT_MESSAGE( msgBuf, stdUnit,SQUEEZE_RIGHT, myThid)
      DO n = 1,diagSt_nbLists
        WRITE(msgBuf,'(2A)') 'Creating Stats. Output Stream: ',
     &                       diagSt_Fname(n)
        CALL PRINT_MESSAGE( msgBuf, stdUnit,SQUEEZE_RIGHT, myThid)
        WRITE(msgBuf,'(2(A,F18.6))') 'Output Frequency:',
     &               diagSt_freq(n), ' ; Phase: ', diagSt_phase(n)
        CALL PRINT_MESSAGE( msgBuf, stdUnit,SQUEEZE_RIGHT, myThid)
        WRITE(msgBuf,'(A)') ' Regions: '
        l = 10
        DO j=0,nRegions
         IF ( diagSt_region(j,n).GE.1 ) THEN
          l = l+3
          IF (l.LE.MAX_LEN_MBUF) WRITE(msgBuf(l-2:l),'(I3)') j
         ENDIF
        ENDDO
        CALL PRINT_MESSAGE( msgBuf, stdUnit,SQUEEZE_RIGHT, myThid)
        DO nf = 1,diagSt_nbFlds(n),10
          m = MIN(diagSt_nbFlds(n),nf+9)
          WRITE(msgBuf,'(21A)') ' Fields:   ',
     &                 (' ',diagSt_Flds(l,n),l=nf,m)
          CALL PRINT_MESSAGE( msgBuf, stdUnit,SQUEEZE_RIGHT, myThid)
        ENDDO
      ENDDO
      WRITE(msgBuf,'(A)')
     & '-----------------------------------------------------'
      CALL PRINT_MESSAGE( msgBuf, stdUnit,SQUEEZE_RIGHT, myThid)
      WRITE(msgBuf,'(A)')
      CALL PRINT_MESSAGE( msgBuf, stdUnit,SQUEEZE_RIGHT, myThid)

      _END_MASTER(myThid)

C--   Everyone else must wait for the parameters to be loaded
      _BARRIER

      RETURN
      END

#include "STIC_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C !ROUTINE: STIC_CHECK

C !INTERFACE:
      SUBROUTINE STIC_CHECK( myThid )

C     !DESCRIPTION:
C     Check dependances with other packages

C     !USES:
      IMPLICIT NONE
C     == Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "STIC.h"
#ifdef ALLOW_SHELFICE
# include "SHELFICE.h"
#endif

C     !INPUT PARAMETERS:
C     myThid   :: my Thread Id number
      INTEGER myThid
CEOP

C     !FUNCTIONS:
      INTEGER  ILNBLNK
      EXTERNAL ILNBLNK

C     !LOCAL VARIABLES:
C     msgBuf   :: Informational/error message buffer
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      INTEGER errCount, iL, jL

      _BEGIN_MASTER(myThid)
      errCount = 0

       WRITE(msgBuf,'(A)') 'STIC_CHECK: #define STEEP_ICECAVITY'
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                     SQUEEZE_RIGHT, myThid )

C--  Print out some kee parameters :
       CALL WRITE_0D_C( STIClengthFile,-1,INDEX_NONE,'STIClengthFile =',
     &  ' /* file name of ice front lengths */')
       CALL WRITE_0D_C( STICdepthFile,-1,INDEX_NONE,'STICdepthFile =',
     &  ' /* file name of ice front depths */')

C--  Check parameters:

       IF ( .NOT. useSHELFICE ) THEN
#ifndef ALLOW_SHELFICE
        WRITE(msgBuf,'(A)')
     &      'pkg/steep_icecavity requires pkg/shelfice,'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(A)')
     &      'please add shelfice to packages.conf'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
#endif
        WRITE(msgBuf,'(A)')
     &       'pkg/steep_icecavity requires useShelfIce = T, '//
     &       'set useShelfIce = .TRUE., in data.pkg'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
       ELSE
#ifdef ALLOW_SHELFICE
        IF ( STICdepthFile .NE. SHELFICEtopoFile ) THEN
         iL = ILNBLNK(STICdepthFile)
         jL = ILNBLNK(SHELFICEtopoFile)
         WRITE(msgBuf,'(6A)') '** WARNING ** STIC_CHECK: ',
     &        'STICdepthFile = ''', STICdepthFile(1:iL),
     &        ''' .NE. SHELFICEtopoFile = ''',
     &        SHELFICEtopoFile(1:jL), ''''
         CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                       SQUEEZE_RIGHT, myThid )
        ENDIF
        IF ( SHELFICEboundaryLayer ) THEN
         WRITE(msgBuf,'(A,A)')
     &     'pkg/steep_icecavity requires SHELFICEboundaryLayer = F, ',
     &     'remove SHELFICEboundaryLayer = .TRUE., in data.shelfice'
         CALL PRINT_ERROR( msgBuf, myThid )
         errCount = errCount + 1
        ENDIF
#endif
       ENDIF

#ifndef ALLOW_ADDFLUID
       WRITE(msgBuf,'(A,A)')
     &      'pkg/steep_icecavity requires'
     &      'CPP flag ALLOW_ADDFLUID to be defined'
       CALL PRINT_ERROR( msgBuf, myThid )
       errCount = errCount + 1
#endif

      IF ( errCount.GE.1 ) THEN
        WRITE(msgBuf,'(A,I3,A)')
     &       'STIC_CHECK: detected', errCount,' fatal error(s)'
        CALL PRINT_ERROR( msgBuf, myThid )
        CALL ALL_PROC_DIE( 0 )
        STOP 'ABNORMAL END: S/R STIC_CHECK'
      ENDIF

      _END_MASTER(myThid)

      RETURN
      END

#include "CPP_EEOPTIONS.h"
#include "W2_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 0
C !ROUTINE: W2_SET_SINGLE_FACET

C !INTERFACE:
      SUBROUTINE W2_SET_SINGLE_FACET( myThid )

C     !DESCRIPTION:
C     Set-up simple single facet (domain in 1 piece) topology

C     !USES:
      IMPLICIT NONE

C      Tile topology settings data structures
#include "SIZE.h"
#include "EEPARAMS.h"
#include "W2_EXCH2_SIZE.h"
#include "W2_EXCH2_PARAMS.h"
#include "W2_EXCH2_TOPOLOGY.h"

C     !INPUT PARAMETERS:
C     myThid  :: my Thread Id number
C               (Note: not relevant since threading has not yet started)
      INTEGER myThid

C     !LOCAL VARIABLES:
C     === Local variables ===
C     msgBuf     :: Informational/error message buffer
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      INTEGER j
CEOP

      WRITE(msgBuf,'(2A,I3,A)') 'W2_SET_SINGLE_FACET:',
     &              ' preDefTopol=', preDefTopol, ' selected'
      CALL PRINT_MESSAGE( msgBuf, W2_oUnit,SQUEEZE_RIGHT,myThid )

C--   Number of facets:
      nFacets = 1

C--   Set Facet Edge connections (topology graph) ignoring any previous
C     setting from data.exch2 (Edges order: N,S,E,W <==> 1,2,3,4 )
C     face 1 N(=1) edge connects to face 1 S(=2) edge:
      facet_link(1,1) = 1.2
C     face 1 S(=2) edge connects to face 1 N(=1) edge:
      facet_link(2,1) = 1.1
C     face 1 E(=3) edge connects to face 1 W(=4) edge:
      facet_link(3,1) = 1.4
C     face 1 W(=4) edge connects to face 1 E(=3) edge:
      facet_link(4,1) = 1.3

C--   Facet dimension: take the 1rst 2 numbers from facet_dims (if correct)
      IF ( facet_dims(1).EQ.0 .AND. facet_dims(2).EQ.0 ) THEN
C-    Default: take global dimension from SIZE.h (will fail with blank tiles)
        facet_dims(1) = Nx
        facet_dims(2) = Ny
      ENDIF
      IF ( facet_dims(1).LE.0 .OR. facet_dims(2).LE.0 ) THEN
         WRITE(msgBuf,'(2A,2I5)') 'W2_SET_SINGLE_FACET:',
     &     ' unvalid 1rst 2 dimensions:', facet_dims(1), facet_dims(2)
         CALL PRINT_MESSAGE( msgBuf, W2_oUnit,SQUEEZE_RIGHT,myThid )
         CALL PRINT_ERROR( msgBuf, myThid )
         CALL ALL_PROC_DIE( 0 )
         STOP 'ABNORMAL END: S/R W2_SET_SINGLE_FACET: unvalid dims'
      ENDIF
      DO j=3,W2_maxNbFacets*2
       IF ( facet_dims(j).NE.0 ) THEN
         WRITE(msgBuf,'(2A,I5)') 'W2_SET_SINGLE_FACET:',
     &     ' no more than 2 dims (X,Y) expected for single facet'
         CALL PRINT_MESSAGE( msgBuf, W2_oUnit,SQUEEZE_RIGHT,myThid )
         CALL PRINT_ERROR( msgBuf, myThid )
         CALL ALL_PROC_DIE( 0 )
         STOP 'ABNORMAL END: S/R W2_SET_SINGLE_FACET: unexpected dims'
       ENDIF
      ENDDO

      RETURN
      END

#include "RW_OPTIONS.h"

      SUBROUTINE READ_FLD_XYZ_RS( pref,suff,field,myIter,myThid)
C READ_FLD_XYZ_RS is a "front-end" interface to the low-level I/O
C routines. It assumes single record files.
      IMPLICIT NONE
C Global
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
C Arguments
      CHARACTER*(*) pref,suff
      _RS field(1-Olx:sNx+Olx,1-Oly:sNy+Oly,Nr,nSx,nSy)
      INTEGER myIter
      INTEGER myThid
C Functions
      INTEGER ILNBLNK,IFNBLNK
C Local
      LOGICAL useCurrentDir
      _RL dummyRL(1)
      CHARACTER*(2) fType
      INTEGER nNz
      INTEGER iRec
      INTEGER s1Lo,s1Hi,s2Lo,s2Hi
      CHARACTER*(MAX_LEN_FNAM) fullName
C
C--   Build file name
C     Name has form 'prefix.suffix'
C     e.g. U.0000000100
      s1Lo = IFNBLNK(pref)
      s1Hi = ILNBLNK(pref)
      IF ( suff .EQ. ' ' ) THEN
       WRITE( fullName, '(A)' ) pref(s1Lo:s1Hi)
      ELSE
       s2Lo = IFNBLNK(suff)
       s2Hi = ILNBLNK(suff)
       WRITE( fullName, '(A,A)' ) pref(s1Lo:s1Hi),suff(s2Lo:s2Hi)
      ENDIF

      useCurrentDir = .FALSE.
      fType='RS'
      nNz=Nr
      iRec=1
#ifdef ALLOW_MDSIO
      CALL MDS_READ_FIELD(
     I                     fullName, readBinaryPrec, useCurrentDir,
     I                     fType, nNz, 1, nNz,
     O                     dummyRL, field,
     I                     iRec, myThid )
#endif
      RETURN
      END

#include "CPP_EEOPTIONS.h"

CBOP
C     !ROUTINE: LEF_ZERO
C     !INTERFACE:
      SUBROUTINE LEF_ZERO( arr ,myThid )
C     !DESCRIPTION: \bv
C     This routine simply sets the argument array to zero
C     \ev
C     !USES:
      IMPLICIT NONE
C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
C     !INPUT/OUTPUT PARAMETERS:
C     === Arguments ===
      _RS  arr (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      INTEGER myThid
C     !LOCAL VARIABLES:
C     === Local variables ===
      INTEGER i,j,bi,bj
CEOP

      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
        DO j=1-Oly,sNy+Oly
         DO i=1-Olx,sNx+Olx
          arr(i,j,bi,bj)=0.
         ENDDO
        ENDDO
       ENDDO
      ENDDO

      RETURN
      END

#include "MNC_OPTIONS.h"

C--  File mnc_readparms.F
C--   Contents
C--   o MNC_READPARMS
C--   o MNC_SET_OUTDIR

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 0
C     !ROUTINE: MNC_READPARMS

C     !INTERFACE:
      SUBROUTINE MNC_READPARMS( myThid )

C     !DESCRIPTION:
C     Read the MNC run-time parameters file.  IF the file does not
C     exist, MNC will assume that it is not needed (that is, some other
C     IO routines such as MDSIO will be used) and will not issue any
C     errors.

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "MNC_COMMON.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "MNC_PARAMS.h"

C     !INPUT PARAMETERS:
      INTEGER myThid
CEOP

C     !FUNCTIONS:
      INTEGER ILNBLNK

C     !LOCAL VARIABLES:
      INTEGER i, nl, ku
      CHARACTER*(MAX_LEN_MBUF) data_file
      CHARACTER*(MAX_LEN_MBUF) msgBuf
C--   retired parameters:
      LOGICAL timeave_mnc

      NAMELIST /MNC_01/
     &     mnc_use_indir, mnc_use_outdir, mnc_outdir_date,
     &     mnc_outdir_num, mnc_use_name_ni0, mnc_echo_gvtypes,
     &     pickup_write_mnc, pickup_read_mnc,
     &     timeave_mnc, snapshot_mnc, monitor_mnc, autodiff_mnc,
     &     writegrid_mnc, readgrid_mnc,
     &     mnc_outdir_str, mnc_indir_str, mnc_max_fsize,
     &     mnc_filefreq,
     &     mnc_read_bathy, mnc_read_salt, mnc_read_theta

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      IF ( .NOT.useMNC ) THEN
C-    pkg MNC is not used
        _BEGIN_MASTER(myThid)
C-    Track pkg activation status:
C     print a (weak) warning if data.mnc is found
         CALL PACKAGES_UNUSED_MSG( 'useMNC', ' ', ' ' )
        _END_MASTER(myThid)
        RETURN
      ENDIF

C-----
C     Need some work to make MNC multi-threaded safe.
C     For now, switch it off (otherwise, it is hanging up somewhere)
      IF ( nThreads.GT.1 ) THEN
        _BARRIER
        _BEGIN_MASTER( myThid )
        WRITE(msgBuf,'(2A)') '** WARNING ** MNC_READPARMS: ',
     &                       'useMNC unsafe with multi-threads'
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                      SQUEEZE_RIGHT , myThid )
        WRITE(msgBuf,'(2A)') '** WARNING ** MNC_READPARMS: ',
     &                       'for now, switch useMNC to FALSE'
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                      SQUEEZE_RIGHT , myThid )
        useMNC = .FALSE.
        _END_MASTER( myThid )
        _BARRIER
        RETURN
      ENDIF
C-----

C     Set default values for MNC run-time parameters
      DO i = 1,MAX_LEN_FNAM
        mnc_outdir_str(i:i) = ' '
        mnc_indir_str(i:i)  = ' '
      ENDDO
      mnc_echo_gvtypes      =  .FALSE.
      mnc_use_outdir        =  .FALSE.
        mnc_outdir_str(1:4) =  'mnc_'
        mnc_outdir_date     =  .FALSE.
        mnc_outdir_num      =  .TRUE.
      mnc_use_name_ni0      =  .FALSE.
      pickup_write_mnc      =  .FALSE.
      pickup_read_mnc       =  .FALSE.
      mnc_use_indir         =  .FALSE.
        mnc_indir_str(1:4)  =  '    '
      monitor_mnc           =  .TRUE.
      timeave_mnc           =  .TRUE.
      snapshot_mnc          =  .TRUE.
      autodiff_mnc          =  .TRUE.
      writegrid_mnc         =  .TRUE.
C     2GB is 2147483648 bytes or approx: 2.1475e+09
      mnc_max_fsize         =  2.1 _d 9
      readgrid_mnc          =  .FALSE.

C     New parms for initial files
      mnc_read_bathy        =  .FALSE.
      mnc_read_salt         =  .FALSE.
      mnc_read_theta        =  .FALSE.

C     Temporary hack for Baylor
      mnc_filefreq          =  -1

C     Set the file name
      DO i=1,MAX_LEN_MBUF
        data_file(i:i) = ' '
      ENDDO
      WRITE(data_file,'(a)') 'data.mnc'
      nl = ILNBLNK(data_file)

      WRITE(msgbuf,'(3a)') ' MNC_READPARMS: opening file ''',
     &       data_file(1:nl), ''''
      CALL PRINT_MESSAGE(msgBuf,standardMessageUnit,
     &     SQUEEZE_RIGHT,myThid)

      CALL OPEN_COPY_DATA_FILE(data_file(1:nl),'MNC_READPARMS',
     &     ku, myThid )
      READ(ku,NML=MNC_01)
#ifdef SINGLE_DISK_IO
      CLOSE(ku)
#else
      CLOSE(ku,STATUS='DELETE')
#endif /* SINGLE_DISK_IO */

      WRITE(msgBuf,'(a)') ' MNC_READPARMS: finished reading data.mnc'
      CALL PRINT_MESSAGE(msgBuf,standardMessageUnit,
     &     SQUEEZE_RIGHT,myThid)

C--   Check for retired parameters:
      IF ( .NOT.timeave_mnc ) THEN
        WRITE(msgBuf,'(2A)') 'MNC_READPARMS: "timeave_mnc"',
     &    ' is no longer allowed in file "data.mnc"'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(2A)') 'MNC_READPARMS: ',
     &    ' since "pkg/timeave" has been removed.'
        CALL PRINT_ERROR( msgBuf, myThid )
c       errCount = errCount + 1
        STOP 'ABNORMAL END: S/R MNC_READPARMS'
      ENDIF

C     Pickups must always be read in an EXCLUSIVE fashion
      IF (pickup_read_mnc)  pickup_read_mdsio = .FALSE.

C     IO handling is done in one of two senses:
C     (1) outputTypesInclusive=.TRUE. is an "inclusive-or" meaning that
C         one or more write methods can occur simultaneously or
C     (2) outputTypesInclusive=.FALSE. is an "exclusive-or" meaning that
C         only one write method can occur in a given run
C
C     Since all the *_mdsio flags default to .TRUE. and
C     outputTypesInclusive defaults to .FALSE., the logic here is
C     simple:
      IF ( (.NOT. outputTypesInclusive)
     &     .AND. pickup_write_mnc ) pickup_write_mdsio = .FALSE.
      IF ( (.NOT. outputTypesInclusive)
     &     .AND. snapshot_mnc ) snapshot_mdsio = .FALSE.
      IF ( (.NOT. outputTypesInclusive)
     &     .AND. monitor_mnc ) monitor_stdio = .FALSE.

C     Reads are always an exclusive relationship
      IF (pickup_read_mnc) pickup_read_mdsio = .FALSE.

C     Create and/or set the MNC output directory
      IF (mnc_use_outdir) THEN
        IF ( mnc_outdir_num .OR. mnc_outdir_date ) THEN
          CALL MNC_SET_OUTDIR(myThid)
        ELSE
          DO i = 1,MNC_MAX_CHAR
            mnc_out_path(i:i) = ' '
          ENDDO
          write(mnc_out_path,'(2A)')
     &         mnc_outdir_str(1:ILNBLNK(mnc_outdir_str)), '/'
        ENDIF
      ENDIF

C--   print out some kee parameters :

C--   Check the parameters :
      IF ( pickup_write_mnc .OR. pickup_read_mnc ) THEN
        WRITE(msgBuf,'(2A)') '** WARNING ** MNC_READPARMS: ',
     &   'incomplete MNC pickup files implementation'
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
      ENDIF
      IF ( pickup_write_mnc ) THEN
        WRITE(msgBuf,'(2A)') '** WARNING ** MNC_READPARMS: ',
     &   '=> pickup_write_mnc=T not recommanded'
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
      ENDIF
      IF ( pickup_read_mnc ) THEN
        WRITE(msgBuf,'(2A)') '** WARNING ** MNC_READPARMS: ',
     &   '=> pickup_read_mnc=T not working for some set-up'
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
      ENDIF

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 1
C     !ROUTINE: MNC_SET_OUTDIR

C     !INTERFACE:
      SUBROUTINE MNC_SET_OUTDIR( myThid )

C     !DESCRIPTION:
C     Create the output (sub--)directory for the MNC output files.

C     !USES:
      IMPLICIT NONE
#include "MNC_COMMON.h"
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "MNC_PARAMS.h"

C     !INPUT PARAMETERS:
      integer myThid
CEOP

C     !LOCAL VARIABLES:
      integer i,j,k, ntot, npathd, idate
      CHARACTER*(MNC_MAX_PATH) pathd
      CHARACTER*(100) cenc
      integer ienc(MNC_MAX_PATH)
      integer ncenc

C     Functions
      integer ILNBLNK

      cenc(1:26)  = 'abcdefghijklmnopqrstuvwxyz'
      cenc(27:52) = 'ABCDEFGHIJKLMNOPQRSTUVWXYZ'
      cenc(53:70) = '0123456789_.,+-=/~'
      ncenc = 70
      npathd = 100
      IF (mnc_outdir_date) THEN
        idate = 1
      ELSE
        idate = 0
      ENDIF
      DO i = 1,MNC_MAX_PATH
        pathd(i:i) = ' '
      ENDDO
      k = ILNBLNK(mnc_outdir_str)
      IF (k .GT. MNC_MAX_PATH)  k = MNC_MAX_PATH
      pathd(1:k) = mnc_outdir_str(1:k)
      ntot = 0
      DO i = 1,k
        DO j = 1,ncenc
          IF (pathd(i:i) .EQ. cenc(j:j)) THEN
            ntot = ntot + 1
            ienc(ntot) = j
            GOTO 20
          ENDIF
        ENDDO
 20     CONTINUE
      ENDDO

      CALL mnccdir(ntot, ienc, idate)

      DO i = 1,MNC_MAX_PATH
        mnc_out_path(i:i) = ' '
      ENDDO
      IF (ntot .GT. 0) THEN
        IF (ntot .GT. (MNC_MAX_PATH-40)) THEN
          ntot = MNC_MAX_PATH - 40
        ENDIF
        DO i = 1,ntot
          j = ienc(i)
          mnc_out_path(i:i) = cenc(j:j)
        ENDDO
        mnc_out_path((ntot+1):(ntot+1)) = '/'
      ENDIF

      RETURN
      END

#include "PACKAGES_CONFIG.h"
#include "CPP_EEOPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: FILL_CS_CORNER_UV_RS

C     !INTERFACE:
      SUBROUTINE FILL_CS_CORNER_UV_RS(
     I     withSigns,
     U     uFld, vFld,
     I     bi,bj, myThid)
      IMPLICIT NONE

C     !DESCRIPTION:
C     *==========================================================*
C     | SUBROUTINE FILL_CS_CORNER_UV_RS
C     | o Fill the corner-halo region of CS-grid,
C     |   for a 2 components, C-grid vector field
C     *==========================================================*
C     | o the corner halo region is filled with valid values
C     |   in order to extend in X and Y direction calculations
C     |   of fluxes, on a wide stencil.
C     *==========================================================*

C     !USES:
C     == Global variables ==

#include "SIZE.h"
#include "EEPARAMS.h"
#ifdef ALLOW_EXCH2
#include "W2_EXCH2_SIZE.h"
#include "W2_EXCH2_TOPOLOGY.h"
#endif /* ALLOW_EXCH2 */

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C
C     withSigns :: uFld,vFld are vector components
C     uFld      :: u-component, at C-grid West  point location
C     vFld      :: v-component, at C-grid SOuth point location
C     bi,bj     :: tile indices
C     myThid    :: thread number
      LOGICAL withSigns
      _RS     uFld(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RS     vFld(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER bi,bj
      INTEGER myThid

C     !LOCAL VARIABLES:
C     == Local variables ==
C      i,j           :: loop indices
C      myTile        :: tile number
      INTEGER i,j
      LOGICAL southWestCorner
      LOGICAL southEastCorner
      LOGICAL northWestCorner
      LOGICAL northEastCorner
      _RL negOne
#ifdef ALLOW_EXCH2
      INTEGER myTile
#endif
CEOP

      IF (useCubedSphereExchange) THEN

       negOne = 1. _d 0
       IF (withSigns) negOne = -1. _d 0

#ifdef ALLOW_EXCH2
       myTile = W2_myTileList(bi,bj)
       southWestCorner = exch2_isWedge(myTile).EQ.1
     &             .AND. exch2_isSedge(myTile).EQ.1
       southEastCorner = exch2_isEedge(myTile).EQ.1
     &             .AND. exch2_isSedge(myTile).EQ.1
       northEastCorner = exch2_isEedge(myTile).EQ.1
     &             .AND. exch2_isNedge(myTile).EQ.1
       northWestCorner = exch2_isWedge(myTile).EQ.1
     &             .AND. exch2_isNedge(myTile).EQ.1
#else
       southWestCorner = .TRUE.
       southEastCorner = .TRUE.
       northWestCorner = .TRUE.
       northEastCorner = .TRUE.
#endif

C--    To extend calculations in X direction, fill uFld array
C        with valid value in the corner.
C  e.g., NW corner: copy V(    0,sNy  ) into U(   -1,sNy+1)
C                   copy V(    0,sNy-1) into U(   -2,sNy+1)
C                   copy V(   -1,sNy  ) into U(   -1,sNy+2)
C                   copy V(   -1,sNy-1) into U(   -2,sNy+2)
C          |             |
C      U(-1,sNy+1)   U(1,sNy+1)   U(2,sNy+1)
C          | ^           |             |
C     -----|--\--------corner----------|
C          |   \         |             |
C          |    \        |
C          |     \       |
C     -----|---V(0,sNy)--|---------------
C          |             |
C
C--    to extend calculations in Y direction, fill vFld array
C        with valid value in the corner.
C  e.g., NW corner: copy U(    2,sNy+1) into V(   0,sNy+2)
C                   copy U(    3,sNy+1) into V(   0,sNy+3)
C                   copy U(    2,sNy+2) into V(  -1,sNy+2)
C                   copy U(    3,sNy+2) into V(  -1,sNy+3)
C          |              |              |
C     -----|--V(0,sNy+2)--|--------------|
C          |    ^====================\
C      U(-1,sNy+1)     U(1,sNy+1)     U(2,sNy+1)
C          |              |              |
C     -----|--V(0,sNy+1)--o--------------|
C          |              |\             |
C          |              | \=corner
C          |              |
C     -----|--V(0,sNy)----|--
C          |              |
C

        IF ( southWestCorner ) THEN
C-        prepare for direction X:
          DO j=1,OLy
           DO i=1,OLx
            uFld( 1-i , 1-j ) = negOne*vFld( 1-j , 1+i )
           ENDDO
          ENDDO
C-        prepare for direction Y:
          DO j=1,OLy
           DO i=1,OLx
            vFld( 1-i , 1-j ) = negOne*uFld( 1+j , 1-i )
           ENDDO
          ENDDO
        ENDIF

        IF ( southEastCorner ) THEN
C-        prepare for direction X:
          DO j=1,OLy
           DO i=2,OLx
            uFld(sNx+i, 1-j ) = vFld(sNx+j, i  )
           ENDDO
          ENDDO
C-        prepare for direction Y:
          DO j=1,OLy
           DO i=1,OLx
            vFld(sNx+i, 1-j ) = uFld(sNx+1-j, 1-i  )
           ENDDO
          ENDDO
        ENDIF

        IF ( northWestCorner ) THEN
C-        prepare for direction X:
          DO j=1,OLy
           DO i=1,OLx
            uFld( 1-i ,sNy+j) = vFld( 1-j , sNy+1-i )
           ENDDO
          ENDDO
C-        prepare for direction Y:
          DO j=2,OLy
           DO i=1,OLx
            vFld( 1-i ,sNy+j) = uFld(  j  , sNy+i )
           ENDDO
          ENDDO
        ENDIF

        IF ( northEastCorner ) THEN
C-        prepare for direction X:
          DO j=1,OLy
           DO i=2,OLx
            uFld(sNx+i,sNy+j) = negOne*vFld(sNx+j, sNy+2-i )
           ENDDO
          ENDDO
C-        prepare for direction Y:
          DO j=2,OLy
           DO i=1,OLx
            vFld(sNx+i,sNy+j) = negOne*uFld(sNx+2-j, sNy+i )
           ENDDO
          ENDDO
        ENDIF

C--   End useCubedSphereExchange
      ENDIF

      RETURN
      END

#include "DWNSLP_OPTIONS.h"

CBOP
C     !ROUTINE: DWNSLP_CALC_RHO
C     !INTERFACE:
      SUBROUTINE DWNSLP_CALC_RHO(
     I                tFld, sFld,
     O                rhoLoc,
     I                k, bi, bj, myTime, myIter, myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE DWNSLP_CALC_RHO
C     | o Calculates [rho(S,T,z)-rhoConst] of a 2-D slice
C     |   filling land-points with bottom density
C     *==========================================================*
C     | Note: could move this S/R to model/src (if needed) since
C     |  it does not contain anything specific to Down-Slope pkg
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"

C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
C     tFld      :: Pot.Temperature (3-D array)
C     sFld      :: Salinity (3-D array)
C     rhoLoc    :: In-situ density [kg/m3] (2-D array) computed at z=rC ;
C     k         :: current vertical index
C     bi,bj     :: Tile indices
C     myTime    :: Current time in simulation
C     myIter    :: Current time-step number
C     myThid    :: my Thread Id number
      _RL     tFld     (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      _RL     sFld     (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      _RL     rhoLoc   (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER k, bi, bj
      _RL     myTime
      INTEGER myIter, myThid
CEOP

C     !LOCAL VARIABLES:
C     === Local variables ===
C     msgBuf     :: Informational/error message buffer
c     CHARACTER*(MAX_LEN_MBUF) msgBuf
      _RL     tLoc     (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL     sLoc     (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER i,j,kl

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C--   make a local copy of Temp & salt, copying bottom values further down
      DO j=1-OLy,sNy+OLy
       DO i=1-OLx,sNx+OLx
c        kl = k
c        IF ( kLowC(i,j,bi,bj).GE.1 ) THEN
c          IF ( k.GT.kLowC (i,j,bi,bj) ) k = kLowC (i,j,bi,bj)
c          IF ( k.LT.kSurfC(i,j,bi,bj) ) k = kSurfC(i,j,bi,bj)
c        ENDIF
C-    same as above, using min,max:
         kl = MIN( MAX(k,kSurfC(i,j,bi,bj)), MAX(kLowC(i,j,bi,bj),1) )
         tLoc(i,j) = tFld(i,j,kl,bi,bj)
         sLoc(i,j) = sFld(i,j,kl,bi,bj)
       ENDDO
      ENDDO

      CALL FIND_RHO_2D(
     I      1-OLx, sNx+OLx, 1-OLy, sNy+OLy, k,
     I      tLoc, sLoc,
     O      rhoLoc,
     I      k, bi, bj, myThid )

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      RETURN
      END

#include "OBCS_OPTIONS.h"
#ifdef ALLOW_CTRL
# include "CTRL_OPTIONS.h"
#endif

CBOP
C !ROUTINE: OBCS_COST_DRIVER

C !INTERFACE: ==========================================================
      SUBROUTINE OBCS_COST_DRIVER(
     I                             myTime, myIter, myThid )

C !DESCRIPTION:
C     - Calculate cost function contributions (Tikhonov regularisation)
C       for obcs
C     - modified from pkg/ecco/cost_obcs.F

C !USES: ===============================================================
      IMPLICIT NONE
C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#ifdef ALLOW_CTRL
# include "CTRL_SIZE.h"
# include "CTRL.h"
# include "CTRL_OBCS.h"
#endif

C !INPUT PARAMETERS: ===================================================
      _RL     myTime
      INTEGER myIter
      INTEGER myThid

#if defined ALLOW_CTRL && defined ALLOW_COST
C !LOCAL VARIABLES: ====================================================
      INTEGER ivar
      INTEGER iobcsN, iobcsS, iobcsE, iobcsW
# ifdef ALLOW_OBCS_CONTROL
      INTEGER startrec, endrec
# endif
CEOP

      IF ( useObcsCostContribution ) THEN

C     Find ctrl-indices
       iobcsN = 0
       iobcsS = 0
       iobcsE = 0
       iobcsW = 0
       DO ivar = 1, maxcvars
        IF ( ncvargrd(ivar) .EQ. 'm' ) THEN
         IF ( ncvarindex(ivar) .EQ. 1 ) iobcsN = ivar
         IF ( ncvarindex(ivar) .EQ. 2 ) iobcsS = ivar
         IF ( ncvarindex(ivar) .EQ. 3 ) iobcsE = ivar
         IF ( ncvarindex(ivar) .EQ. 4 ) iobcsW = ivar
        ENDIF
       ENDDO

#ifdef ALLOW_OBCSN_CONTROL
       IF ( iobcsN.GT.0 ) THEN
cgg   North boundary contribution to cost function.
        startrec = ncvarrecstart(iobcsN)
        endrec   = ncvarrecsend(iobcsN)
        CALL OBCS_COST_OB_N( startrec, endrec,
     I                       myTime, myIter, myThid )
       ENDIF
#endif
#ifdef ALLOW_OBCSS_CONTROL
       IF ( iobcsS.GT.0 ) THEN
cgg   South boundary contribution to cost function.
        startrec = ncvarrecstart(iobcsS)
        endrec   = ncvarrecsend(iobcsS)
        CALL OBCS_COST_OB_S( startrec, endrec,
     I                       myTime, myIter, myThid )
       ENDIF
#endif
#ifdef ALLOW_OBCSE_CONTROL
       IF ( iobcsE.GT.0 ) THEN
cgg   East boundary contribution to cost function.
        startrec = ncvarrecstart(iobcsE)
        endrec   = ncvarrecsend(iobcsE)
        CALL OBCS_COST_OB_E( startrec, endrec,
     I                       myTime, myIter, myThid )
       ENDIF
#endif
#ifdef ALLOW_OBCSW_CONTROL
       IF ( iobcsW.GT.0 ) THEN
cgg   West boundary contribution to cost function.
        startrec = ncvarrecstart(iobcsW)
        endrec   = ncvarrecsend(iobcsW)
        CALL OBCS_COST_OB_W( startrec, endrec,
     I                       myTime, myIter, myThid )
       ENDIF
#endif

#ifdef OBCS_VOLFLUX_COST_CONTRIBUTION
       STOP 'CPP-flag OBCS_VOLFLUX_COST_CONTRIBUTION defined: '//
     &      'S/R OBCS_COST_VOL needs to be fixed!'
c       IF ( ( iobcsN+iobcsS+iobcsE+iobcsW ) .GT.0 ) THEN
c        CALL OBCS_COST_VOL( startrec, endrec,
c     I                      myTime, myIter, myThid )
c       ENDIF
#endif

C     useObcsCostContribution
      ENDIF

#endif /* ALLOW_CTRL and ALLOW_COST */

      RETURN
      END

#include "SEAICE_OPTIONS.h"
#ifdef ALLOW_EXF
# include "EXF_OPTIONS.h"
#endif
#ifdef ALLOW_AUTODIFF
# include "AUTODIFF_OPTIONS.h"
#endif

CBOP
C     !ROUTINE: SEAICE_CHECK
C     !INTERFACE:
      SUBROUTINE SEAICE_CHECK( myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R SEAICE_CHECK
C     | o Validate basic package setup and inter-package
C     |   dependencies.
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#ifdef ALLOW_EXF
# include "EXF_PARAM.h"
#endif
#include "GRID.h"
#include "SEAICE_SIZE.h"
#include "SEAICE_PARAMS.h"
#include "SEAICE.h"
#include "SEAICE_TRACER.h"
#ifdef ALLOW_GENERIC_ADVDIFF
# include "GAD.h"
#endif /* ALLOW_GENERIC_ADVDIFF */
C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
C     myThid     :: my Thread Id. number
      INTEGER myThid
CEOP

C     !LOCAL VARIABLES:
C     === Local variables ===
C     ioUnit     :: temp for writing msg unit
C     msgBuf     :: Informational/error message buffer
C     errCount   :: error counter
      INTEGER ioUnit
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      LOGICAL checkAdvSchArea, checkAdvSchHeff, checkAdvSchSnow
      LOGICAL checkAdvSchSalt
#ifdef ALLOW_SITRACER
      INTEGER iTracer
#endif
      _RL SEAICE_mcphee_max
      INTEGER  kSrf
      INTEGER  i
      INTEGER  errCount
      INTEGER  ILNBLNK
      EXTERNAL ILNBLNK
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      IF ( usingPCoords ) THEN
       kSrf        = Nr
      ELSE
       kSrf        = 1
      ENDIF
      ioUnit = errorMessageUnit

      _BEGIN_MASTER(myThid)

C--   ALLOW_SEAICE
      WRITE(msgBuf,'(A)') 'SEAICE_CHECK: #define ALLOW_SEAICE'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &     SQUEEZE_RIGHT, myThid )

      errCount = 0

C--   SEAICE needs forcing_In_AB FALSE
      IF (tracForcingOutAB.NE.1) THEN
         WRITE(msgBuf,'(2A)') 'SEAICE_CHECK:',
     &         ' Need T,S forcing out of AB (tracForcingOutAB=1)'
         CALL PRINT_ERROR( msgBuf, myThid )
         errCount = errCount + 1
      ENDIF

C-------------------------------------------------
C--   Check seaice thermodynamics setting:
      IF ( usePW79thermodynamics ) THEN

C--   check ice cover fraction formula
       IF ((SEAICE_areaGainFormula.LT.1).OR.
     &     (SEAICE_areaGainFormula.GT.2)) THEN
         WRITE(msgBuf,'(2A)') 'SEAICE_CHECK:',
     &         ' SEAICE_areaGainFormula must be between 1 and 2'
         CALL PRINT_ERROR( msgBuf, myThid )
         errCount = errCount + 1
       ENDIF
       IF ((SEAICE_areaLossFormula.LT.1).OR.
     &     (SEAICE_areaLossFormula.GT.3)) THEN
         WRITE(msgBuf,'(2A)') 'SEAICE_CHECK:',
     &         ' SEAICE_areaLossFormula must be between 1 and 2'
         CALL PRINT_ERROR( msgBuf, myThid )
         errCount = errCount + 1
       ENDIF

       IF ( (.NOT.SEAICE_doOpenWaterGrowth)
     &   .AND.( (SEAICE_areaGainFormula.NE.2).OR.
     &          (SEAICE_areaLossFormula.NE.3) ) ) THEN
        WRITE(msgBuf,'(2A)') 'SEAICE_CHECK: ',
     &       'when SEAICE_doOpenWaterGrowth is false, you need to set'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(A)')
     &   'SEAICE_areaGainFormula.EQ.2 and SEAICE_areaLossFormula.EQ.3'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
       ENDIF

C--   check concistency of turbulent flux term etc. specification

       SEAICE_mcphee_max=drF(kSrf)/SEAICE_deltaTtherm
       IF ( usingPCoords ) SEAICE_mcphee_max
     &      = SEAICE_mcphee_max * recip_rhoConst * recip_gravity
       IF ( SEAICE_mcPheePiston .LT. 0. _d 0 .OR.
     &      SEAICE_mcPheePiston .GT. SEAICE_mcphee_max ) THEN
        WRITE(msgBuf,'(2A)') 'SEAICE_CHECK:',
     &   ' SEAICE_mcPheePiston is out of bounds.'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(2A)') 'SEAICE_CHECK:',
     &   ' They must lie within 0. and drF(1)/SEAICE_deltaTtherm'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
       ENDIF

       IF ( ( SEAICE_frazilFrac .LT. 0. _d 0 ) .OR.
     &      ( SEAICE_frazilFrac .GT. 1. _d 0 ) ) THEN
        WRITE(msgBuf,'(2A)') 'SEAICE_CHECK:',
     &   ' SEAICE_frazilFrac is out of bounds.'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(2A)') 'SEAICE_CHECK:',
     &   ' They must lie within 0. and 1. '
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
       ENDIF

       IF ( ( SEAICE_mcPheeTaper .LT. 0. _d 0 ) .OR.
     &      ( SEAICE_mcPheeTaper .GT. 1. _d 0 ) ) THEN
        WRITE(msgBuf,'(2A)')
     &      'SEAICE_mcPheeTaper cannot be specified  ',
     &      'outside of the [0. 1.] range'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
       ENDIF

       IF ( SEAICE_doOpenWaterMelt .AND.
     &      (.NOT.SEAICE_doOpenWaterGrowth) ) THEN
        WRITE(msgBuf,'(2A)') 'SEAICE_CHECK: ',
     &       'to use SEAICE_doOpenWaterMelt, you need to '
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(A)')
     &   'also set SEAICE_doOpenWaterGrowth to .TRUE.'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
       ENDIF

C     check albedos
       IF ( SEAICE_dryIceAlb .GT. SEAICE_drySnowAlb ) THEN
        WRITE(msgBuf,'(2A)') '** WARNING ** SEAICE_CHECK: ',
     &       'SEAICE_dryIceAlb > SEAICE_drySnowAlb makes little sense'
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
        WRITE(msgBuf,'(2A)') '** WARNING ** SEAICE_CHECK: and leads ',
     &       'to albedo = SEAICE_drySnowAlb for all snow thicknesses'
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
       ENDIF
       IF ( SEAICE_wetIceAlb .GT. SEAICE_wetSnowAlb ) THEN
        WRITE(msgBuf,'(2A)') '** WARNING ** SEAICE_CHECK: ',
     &       'SEAICE_wetIceAlb > SEAICE_wetSnowAlb makes little sense'
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
        WRITE(msgBuf,'(2A)') '** WARNING ** SEAICE_CHECK: and leads ',
     &       'to albedo = SEAICE_wetSnowAlb for all snow thicknesses'
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
       ENDIF
       IF ( SEAICE_dryIceAlb_south .GT. SEAICE_drySnowAlb_south ) THEN
        WRITE(msgBuf,'(3A)') '** WARNING ** SEAICE_CHECK: ',
     &       'SEAICE_dryIceAlb_south > SEAICE_drySnowAlb_south ',
     &       'makes little sense'
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
        WRITE(msgBuf,'(2A)') '** WARNING ** SEAICE_CHECK: and leads ',
     &  'to albedo = SEAICE_drySnowAlb_south for all snow thicknesses'
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
       ENDIF
       IF ( SEAICE_wetIceAlb_south .GT. SEAICE_wetSnowAlb_south ) THEN
        WRITE(msgBuf,'(3A)') '** WARNING ** SEAICE_CHECK: ',
     &       'SEAICE_wetIceAlb_south > SEAICE_wetSnowAlb_south ',
     &       'makes little sense'
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
        WRITE(msgBuf,'(2A)') '** WARNING ** SEAICE_CHECK: and leads ',
     &  'to albedo = SEAICE_wetSnowAlb_south for all snow thicknesses'
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
       ENDIF

C--   end if usePW79thermodynamics
      ENDIF
C--   Checking seaice thermodynamics setting: end
C-------------------------------------------------

C--   check specifications of new features for testing

#ifdef ALLOW_BALANCE_FLUXES
      IF ( usePW79thermodynamics .AND. selectBalanceEmPmR.EQ.2 ) THEN
        WRITE(msgBuf,'(2A)') 'SEAICE_CHECK: ',
     &       'selectBalanceEmPmR=2 not yet implemented in pkg/seaice'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF
#endif

#ifdef SEAICE_DISABLE_HEATCONSFIX
      IF ( SEAICEheatConsFix ) THEN
        WRITE(msgBuf,'(2A)') 'SEAICE_CHECK: ',
     &       'to use SEAICEheatConsFix, you need to '
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(A)')
     &   'undef SEAICE_DISABLE_HEATCONSFIX and recompile'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF
#endif

#ifndef ALLOW_SITRACER
      IF ( SEAICE_salinityTracer ) THEN
        WRITE(msgBuf,'(2A)') 'SEAICE_CHECK: ',
     &       'to use SEAICE_salinityTracer, you need to '
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(A)')
     &   'define ALLOW_SITRACER and recompile'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF

      IF ( SEAICE_ageTracer ) THEN
        WRITE(msgBuf,'(2A)') 'SEAICE_CHECK: ',
     &       'to use SEAICE_ageTracer, you need to '
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(A)')
     &   'define ALLOW_SITRACER and recompile'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF
#endif

C--   check SItracer specifications
#ifdef ALLOW_SITRACER

c to be added : if SEAICE_salinityTracer we need one tracer doing that
c to be added : if SEAICE_ageTracer we suggest that one tracer does that

      DO iTracer = 1, SItrNumInUse

      IF ( ( SItrFromOceanFrac(iTracer) .LT. 0. _d 0 ) .OR.
     &     ( SItrFromOceanFrac(iTracer) .GT. 1. _d 0 ) ) THEN
         WRITE(msgBuf,'(2A)')
     &      'SItrFromOceanFrac cannot be specified  ',
     &      'outside of the [0. 1.] range'
         CALL PRINT_ERROR( msgBuf, myThid )
         errCount = errCount + 1
      ENDIF

      IF ( ( SItrFromFloodFrac(iTracer) .LT. 0. _d 0 ) .OR.
     &     ( SItrFromFloodFrac(iTracer) .GT. 1. _d 0 ) ) THEN
         WRITE(msgBuf,'(2A)')
     &      'SItrFromFloodFrac cannot be specified  ',
     &      'outside of the [0. 1.] range'
         CALL PRINT_ERROR( msgBuf, myThid )
         errCount = errCount + 1
      ENDIF

c      IF ( (SItrName(iTracer).EQ.'salinity') .AND.
c     &     (SItrMate(iTracer).NE.'HEFF') ) THEN
c         WRITE(msgBuf,'(2A)')
c     &      'SItrName = "salinity" requires  ',
c     &      'SItrMate = "HEFF" '
c         CALL PRINT_ERROR( msgBuf, myThid )
c         errCount = errCount + 1
c      ENDIF

      IF ( (SItrName(iTracer).NE.'salinity').AND.
     &     ( (SItrFromOceanFrac(iTracer).NE.ZERO).OR.
     &       (SItrFromFloodFrac(iTracer).NE.ZERO) ) ) THEN
         WRITE(msgBuf,'(2A)')
     &      'SItrFromOceanFrac / SItrFromFloodFrac is only  ',
     &      'available for SItrName = "salinity" (for now)'
         CALL PRINT_ERROR( msgBuf, myThid )
         errCount = errCount + 1
      ENDIF

      ENDDO
#endif

C--   Check advection schemes
#ifdef ALLOW_GENERIC_ADVDIFF
      checkAdvSchArea = SEAICEadvArea .AND. (
     &     SEAICEadvSchArea.NE.ENUM_UPWIND_1RST .AND.
     &     SEAICEadvSchArea.NE.ENUM_CENTERED_2ND .AND.
     &     SEAICEadvSchArea.NE.ENUM_DST2 .AND.
     &     SEAICEadvSchArea.NE.ENUM_FLUX_LIMIT .AND.
     &     SEAICEadvSchArea.NE.ENUM_DST3 .AND.
     &     SEAICEadvSchArea.NE.ENUM_DST3_FLUX_LIMIT .AND.
     &     SEAICEadvSchArea.NE.ENUM_PPM_NULL_LIMIT  .AND.
     &     SEAICEadvSchArea.NE.ENUM_PPM_MONO_LIMIT  .AND.
     &     SEAICEadvSchArea.NE.ENUM_PPM_WENO_LIMIT  .AND.
     &     SEAICEadvSchArea.NE.ENUM_PQM_NULL_LIMIT  .AND.
     &     SEAICEadvSchArea.NE.ENUM_PQM_MONO_LIMIT  .AND.
     &     SEAICEadvSchArea.NE.ENUM_PQM_WENO_LIMIT  .AND.
     &     SEAICEadvSchArea.NE.ENUM_OS7MP )
      checkAdvSchHEFF = SEAICEadvHeff .AND. (
     &     SEAICEadvSchHeff.NE.ENUM_UPWIND_1RST .AND.
     &     SEAICEadvSchHeff.NE.ENUM_CENTERED_2ND .AND.
     &     SEAICEadvSchHeff.NE.ENUM_DST2 .AND.
     &     SEAICEadvSchHeff.NE.ENUM_FLUX_LIMIT .AND.
     &     SEAICEadvSchHeff.NE.ENUM_DST3 .AND.
     &     SEAICEadvSchHeff.NE.ENUM_DST3_FLUX_LIMIT .AND.
     &     SEAICEadvSchHeff.NE.ENUM_PPM_NULL_LIMIT  .AND.
     &     SEAICEadvSchHeff.NE.ENUM_PPM_MONO_LIMIT  .AND.
     &     SEAICEadvSchHeff.NE.ENUM_PPM_WENO_LIMIT  .AND.
     &     SEAICEadvSchHeff.NE.ENUM_PQM_NULL_LIMIT  .AND.
     &     SEAICEadvSchHeff.NE.ENUM_PQM_MONO_LIMIT  .AND.
     &     SEAICEadvSchHeff.NE.ENUM_PQM_WENO_LIMIT  .AND.
     &     SEAICEadvSchHeff.NE.ENUM_OS7MP )
      checkAdvSchSnow = SEAICEadvSnow .AND. (
     &     SEAICEadvSchSnow.NE.ENUM_UPWIND_1RST .AND.
     &     SEAICEadvSchSnow.NE.ENUM_CENTERED_2ND .AND.
     &     SEAICEadvSchSnow.NE.ENUM_DST2 .AND.
     &     SEAICEadvSchSnow.NE.ENUM_FLUX_LIMIT .AND.
     &     SEAICEadvSchSnow.NE.ENUM_DST3 .AND.
     &     SEAICEadvSchSnow.NE.ENUM_DST3_FLUX_LIMIT .AND.
     &     SEAICEadvSchSnow.NE.ENUM_PPM_NULL_LIMIT  .AND.
     &     SEAICEadvSchSnow.NE.ENUM_PPM_MONO_LIMIT  .AND.
     &     SEAICEadvSchSnow.NE.ENUM_PPM_WENO_LIMIT  .AND.
     &     SEAICEadvSchSnow.NE.ENUM_PQM_NULL_LIMIT  .AND.
     &     SEAICEadvSchSnow.NE.ENUM_PQM_MONO_LIMIT  .AND.
     &     SEAICEadvSchSnow.NE.ENUM_PQM_WENO_LIMIT  .AND.
     &     SEAICEadvSchSnow.NE.ENUM_OS7MP )
      checkAdvSchSalt = SEAICEadvSalt .AND. (
     &     SEAICEadvSchSalt.NE.ENUM_UPWIND_1RST .AND.
     &     SEAICEadvSchSalt.NE.ENUM_CENTERED_2ND .AND.
     &     SEAICEadvSchSalt.NE.ENUM_DST2 .AND.
     &     SEAICEadvSchSalt.NE.ENUM_FLUX_LIMIT .AND.
     &     SEAICEadvSchSalt.NE.ENUM_DST3 .AND.
     &     SEAICEadvSchSalt.NE.ENUM_DST3_FLUX_LIMIT .AND.
     &     SEAICEadvSchSalt.NE.ENUM_PPM_NULL_LIMIT  .AND.
     &     SEAICEadvSchSalt.NE.ENUM_PPM_MONO_LIMIT  .AND.
     &     SEAICEadvSchSalt.NE.ENUM_PPM_WENO_LIMIT  .AND.
     &     SEAICEadvSchSalt.NE.ENUM_PQM_NULL_LIMIT  .AND.
     &     SEAICEadvSchSalt.NE.ENUM_PQM_MONO_LIMIT  .AND.
     &     SEAICEadvSchSalt.NE.ENUM_PQM_WENO_LIMIT  .AND.
     &     SEAICEadvSchSalt.NE.ENUM_OS7MP )
      IF ( checkAdvSchArea .OR. checkAdvSchHeff .OR.
     &     checkAdvSchSnow .OR. checkAdvSchSalt ) THEN
       WRITE(msgBuf,'(2A)') 'SEAICE_CHECK: allowed advection schemes',
     &          ' for heff, area, snow, and salt are: '
       CALL PRINT_ERROR( msgBuf, myThid )
       WRITE(msgBuf,'(A,13I3)') 'SEAICE_CHECK:',
     &      ENUM_UPWIND_1RST, ENUM_CENTERED_2ND, ENUM_DST2,
     &      ENUM_FLUX_LIMIT, ENUM_DST3, ENUM_DST3_FLUX_LIMIT,
     &      ENUM_PPM_NULL_LIMIT,ENUM_PPM_MONO_LIMIT,ENUM_PPM_WENO_LIMIT,
     &      ENUM_PQM_NULL_LIMIT,ENUM_PQM_MONO_LIMIT,ENUM_PQM_WENO_LIMIT,
     &      ENUM_OS7MP
       CALL PRINT_ERROR( msgBuf, myThid )
       WRITE(msgBuf,'(2A)') 'SEAICE_CHECK:',
     &      ' the following Adv.Schemes are not allowed:'
       CALL PRINT_ERROR( msgBuf, myThid )
       IF ( checkAdvSchArea ) THEN
        WRITE(msgBuf,'(2A,I3)') 'SEAICE_CHECK:',
     &       ' SEAICEadvSchArea = ',  SEAICEadvSchArea
        CALL PRINT_ERROR( msgBuf, myThid )
       ENDIF
       IF ( checkAdvSchHeff ) THEN
        WRITE(msgBuf,'(2A,I3)') 'SEAICE_CHECK:',
     &       ' SEAICEadvSchHeff = ',  SEAICEadvSchHeff
        CALL PRINT_ERROR( msgBuf, myThid )
       ENDIF
       IF ( checkAdvSchSnow ) THEN
        WRITE(msgBuf,'(2A,I3)') 'SEAICE_CHECK:',
     &       ' SEAICEadvSchSnow = ',  SEAICEadvSchSnow
        CALL PRINT_ERROR( msgBuf, myThid )
       ENDIF
       IF ( checkAdvSchSalt ) THEN
        WRITE(msgBuf,'(2A,I3)') 'SEAICE_CHECK:',
     &       ' SEAICEadvSchSalt = ',  SEAICEadvSchSalt
        CALL PRINT_ERROR( msgBuf, myThid )
       ENDIF
       errCount = errCount + 1
      ENDIF
      IF ( SEAICEadvScheme.EQ.ENUM_CENTERED_2ND ) THEN
C-- for now, the code does not allow to use the default advection scheme
C    (Centered 2nd order) for 1 ice-field and an other advection scheme
C    for an other ice-field. In this case, stop here.
        checkAdvSchArea = SEAICEadvArea .AND.
     &     SEAICEadvSchArea.NE.ENUM_CENTERED_2ND
        checkAdvSchHEFF = SEAICEadvHeff .AND.
     &     SEAICEadvSchHeff.NE.ENUM_CENTERED_2ND
        checkAdvSchSnow = SEAICEadvSnow .AND.
     &     SEAICEadvSchSnow.NE.ENUM_CENTERED_2ND
        checkAdvSchSalt = SEAICEadvSalt .AND.
     &     SEAICEadvSchSalt.NE.ENUM_CENTERED_2ND
#else /* not ALLOW_GENERIC_ADVDIFF */
      IF ( SEAICEadvScheme.EQ.2 ) THEN
C-- for now, the code does not allow to use the default advection scheme
C    (Centered 2nd order) for 1 ice-field and an other advection scheme
C    for an other ice-field. In this case, stop here.
        checkAdvSchArea = SEAICEadvArea .AND.
     &     SEAICEadvSchArea.NE.2
        checkAdvSchHEFF = SEAICEadvHeff .AND.
     &     SEAICEadvSchHeff.NE.2
        checkAdvSchSnow = SEAICEadvSnow .AND.
     &     SEAICEadvSchSnow.NE.2
        checkAdvSchSalt = SEAICEadvSalt .AND.
     &     SEAICEadvSchSalt.NE.2
#endif /* ALLOW_GENERIC_ADVDIFF */
       IF ( checkAdvSchArea .OR. checkAdvSchHeff .OR.
     &      checkAdvSchSnow .OR. checkAdvSchSalt ) THEN
        WRITE(msgBuf,'(A,I3,A)') 'SEAICE_CHECK: SEAICEadvScheme=',
     &   SEAICEadvScheme, ' not compatible with those Adv.Scheme:'
        CALL PRINT_ERROR( msgBuf, myThid )
        IF ( checkAdvSchArea ) THEN
         WRITE(msgBuf,'(2A,I3)') 'SEAICE_CHECK:',
     &        ' SEAICEadvSchArea = ',  SEAICEadvSchArea
         CALL PRINT_ERROR( msgBuf, myThid )
        ENDIF
        IF ( checkAdvSchHeff ) THEN
         WRITE(msgBuf,'(2A,I3)') 'SEAICE_CHECK:',
     &        ' SEAICEadvSchHeff = ',  SEAICEadvSchHeff
         CALL PRINT_ERROR( msgBuf, myThid )
        ENDIF
        IF ( checkAdvSchSnow ) THEN
         WRITE(msgBuf,'(2A,I3)') 'SEAICE_CHECK:',
     &        ' SEAICEadvSchSnow = ',  SEAICEadvSchSnow
         CALL PRINT_ERROR( msgBuf, myThid )
        ENDIF
        IF ( checkAdvSchSalt ) THEN
         WRITE(msgBuf,'(2A,I3)') 'SEAICE_CHECK:',
     &        ' SEAICEadvSchSalt = ',  SEAICEadvSchSalt
         CALL PRINT_ERROR( msgBuf, myThid )
        ENDIF
        errCount = errCount + 1
       ENDIF
      ELSEIF ( DIFF1 .NE. 0. _d 0 ) THEN
C-- for now, the code does not allow to use DIFF1 without the default
C   advection scheme (Centered 2nd order). In this case, stop here.
        WRITE(msgBuf,'(2A,1PE16.8)') 'SEAICE_CHECK: ',
     &        'harmonic+biharmonic DIFF1=',  DIFF1
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(2A,I3)') 'SEAICE_CHECK: ',
     &        'not available with SEAICEadvScheme=', SEAICEadvScheme
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF

C     Avoid using both type of diffusion scheme (DIFF1 & SEAICEdiffKh)
      IF ( DIFF1 .NE. 0. _d 0 .AND. (
     &     ( SEAICEdiffKhHeff .NE. 0. _d 0 ) .OR.
     &     ( SEAICEdiffKhArea .NE. 0. _d 0 ) .OR.
     &     ( SEAICEdiffKhSnow .NE. 0. _d 0 ) .OR.
     &     ( SEAICEdiffKhSalt .NE. 0. _d 0 )
     &                              ) ) THEN
       WRITE(msgBuf,'(2A)') 'SEAICE_CHECK:',
     &  ' DIFF1 > 0 and one of the SEAICEdiffKh[] > 0'
       CALL PRINT_ERROR( msgBuf, myThid )
       WRITE(msgBuf,'(2A)') 'SEAICE_CHECK:',
     &  ' => Cannot use both type of diffusion'
       CALL PRINT_ERROR( msgBuf, myThid )
       errCount = errCount + 1
      ENDIF

      IF ( postSolvTempIter.GT.2 .OR. postSolvTempIter .LT. 0 ) THEN
       WRITE(msgBuf,'(2A)') 'SEAICE_CHECK:',
     &  ' => allowed values for postSolveTempIter: 0, 1, 2'
       CALL PRINT_ERROR( msgBuf, myThid )
       errCount = errCount + 1
      ENDIF

      IF ( SEAICEpresH0    .LE. 0. _d 0 .OR.
     &     SEAICEpresPow0  .LT. 0 .OR. SEAICEpresPow1  .LT. 0 ) THEN
        WRITE(msgBuf,'(2A)') 'SEAICE_CHECK: ',
     &      'SEAICEpresH0 (real), SEAICEpresPow0 (integer)'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(2A)') 'SEAICE_CHECK: OR SEAICEpresPow1 ',
     &      '(integer) has been specified as negative (data.seaice)'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF

C--
#ifdef ALLOW_AUTODIFF_TAMC
      IF ( SEAICEuseLSR ) THEN
      IF ( SEAICEnonLinIterMax .GT. MPSEUDOTIMESTEPS ) THEN
       WRITE(msgBuf,'(2A)') 'SEAICE_CHECK:',
     &  ' need to increase MPSEUDOTIMESTEPS in SEAICE_PARAMS.h'
       CALL PRINT_ERROR( msgBuf, myThid )
       WRITE(msgBuf,'(2A,2I4)') 'SEAICE_CHECK:',
     &  ' MPSEUDOTIMESTEPS, SEAICEnonLinIterMax = ',
     &  MPSEUDOTIMESTEPS, SEAICEnonLinIterMax
       CALL PRINT_ERROR( msgBuf, myThid )
       errCount = errCount + 1
      ENDIF
      IF ( SEAICElinearIterMax .GT. SOLV_MAX_FIXED ) THEN
       WRITE(msgBuf,'(2A,I10,A,I10)') 'SEAICE_CHECK:',
     &      'SEAICElinearIterMax = ', SEAICElinearIterMax,
     &      ' > SOLV_MAX_FIXED = ', SOLV_MAX_FIXED
       CALL PRINT_ERROR( msgBuf, myThid )
       WRITE(msgBuf,'(2A,I10,A,I10)') 'SEAICE_CHECK:',
     &'either increase SOLV_MAX_FIXED or decrease SEAICElinearIterMax'
       CALL PRINT_ERROR( msgBuf, myThid )
       STOP 'ABNORMAL END: S/R SEAICE_LSR'
      ENDIF
      IF ( IMAX_TICE .GT. NMAX_TICE ) THEN
       WRITE(msgBuf,'(2A)') 'SEAICE_CHECK:',
     &  ' need to increase NMAX_TICE in SEAICE_PARAMS.h'
       CALL PRINT_ERROR( msgBuf, myThid )
       WRITE(msgBuf,'(2A,2I4)') 'SEAICE_CHECK:',
     &  ' NMAX_TICE, MAX_TICE = ', NMAX_TICE, IMAX_TICE
       CALL PRINT_ERROR( msgBuf, myThid )
       errCount = errCount + 1
      ENDIF
C     endif SEAICEuseLSR
      ENDIF
      IF ( SEAICE_maskRHS ) THEN
       WRITE(msgBuf,'(A)') 'SEAICE_CHECK: SEAICE_maskRHS not allowed'
       CALL PRINT_ERROR( msgBuf, myThid )
       errCount = errCount + 1
      ENDIF
#endif

C--   SEAICE_CGRID, SEAICE_BGRID_DYNAMICS and SEAICEuseDYNAMICS
#if ( defined SEAICE_CGRID && defined SEAICE_BGRID_DYNAMICS )
      WRITE(msgBuf,'(A,A)')
     &     'SEAICE_CHECK: SEAICE_CGRID and SEAICE_BGRID_DYNAMICS ',
     &     'cannot be defined at the same time.'
      CALL PRINT_ERROR( msgBuf, myThid )
      errCount = errCount + 1
#endif
#if !( defined SEAICE_CGRID || defined SEAICE_BGRID_DYNAMICS )
      IF (SEAICEuseDYNAMICS) THEN
         WRITE(msgBuf,'(A,A)')
     &      'SEAICE_CHECK: either SEAICE_CGRID ',
     &      'or SEAICE_BGRID_DYNAMICS needed for SEAICEuseDYNAMICS = T'
         CALL PRINT_ERROR( msgBuf, myThid )
         errCount = errCount + 1
      ENDIF
#endif

#ifndef SEAICE_ALLOW_MOM_ADVECTION
      IF ( SEAICEmomAdvection ) THEN
       WRITE(msgBuf,'(A)')
     &   'SEAICE_ALLOW_MOM_ADVECTION needed for SEAICEmomAdvection'
       CALL PRINT_ERROR( msgBuf, myThid )
       errCount = errCount + 1
      ENDIF
#endif

C--   SEAICE_EXTERNAL_FORCING is obsolete: issue warning but continue.
#ifdef SEAICE_EXTERNAL_FORCING
        WRITE(msgBuf,'(2A)') '** WARNING ** SEAICE_CHECK: ',
     &        'SEAICE_EXTERNAL_FORCING option is obsolete:'
        CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
        WRITE(msgBuf,'(2A)') '** WARNING ** SEAICE_CHECK: ',
     &        'seaice now always uses exf to read input files.'
        CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
#endif

C--   SEAICE_GROWTH_LEGACY is obsolete: issue warning but continue.
#ifdef SEAICE_GROWTH_LEGACY
      WRITE(msgBuf,'(2A)') '** WARNING ** SEAICE_CHECK: ',
     &     'CPP flag SEAICE_GROWTH_LEGACY has been retired.'
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
#endif /* SEAICE_GROWTH_LEGACY */

C--   SEAICE_CAP_HEFF is obsolete: issue warning but continue.
#ifdef SEAICE_CAP_HEFF
      WRITE(msgBuf,'(2A)') '** WARNING ** SEAICE_CHECK: ',
     &     'CPP flag SEAICE_CAP_HEFF has been retired.'
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
#endif /* SEAICE_CAP_HEFF */

C--   SEAICE_MULTICATEGORY is obsolete: issue warning but continue.
#ifdef SEAICE_MULTICATEGORY
      WRITE(msgBuf,'(2A)') '** WARNING ** SEAICE_CHECK: ',
     &     'CPP flag SEAICE_MULTICATEGORY has been retired.'
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(2A)') '** WARNING ** SEAICE_CHECK: ',
     &     'Specify SEAICE_multDim=7 in data.seaice to recover'
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(2A)') '** WARNING ** SEAICE_CHECK: ',
     &     'previous default SEAICE_MULTICATEGORY setting.'
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
#endif /* SEAICE_MULTICATEGORY */

C--   SEAICE_ALLOW_TD_IF is obsolete: issue error and stop.
#ifdef SEAICE_ALLOW_TD_IF
         WRITE(msgBuf,'(A)')
     &     'SEAICE_ALLOW_TD_IF option is obsolete:'
         CALL PRINT_ERROR( msgBuf, myThid )
         WRITE(msgBuf,'(A)')
     &     'the seaice*_IF codes are now merged into the main branch.'
         CALL PRINT_ERROR( msgBuf, myThid )
         errCount = errCount + 1
#endif /* SEAICE_ALLOW_TD_IF */

C--   SEAICE_DO_OPEN_WATER_GROWTH is obsolete: issue error and stop.
#if defined(SEAICE_DO_OPEN_WATER_GROWTH) || \
      defined(SEAICE_DO_OPEN_WATER_MELT)
         WRITE(msgBuf,'(2A)') 'SEAICE_CHECK: ',
     &     'SEAICE_DO_OPEN_WATER_GROWTH / MELT options are obsolete'
         CALL PRINT_ERROR( msgBuf, myThid )
         WRITE(msgBuf,'(2A)') 'they are replaced with run time',
     &     ' parameter SEAICE_doOpenWaterGrowth / Melt'
         CALL PRINT_ERROR( msgBuf, myThid )
         errCount = errCount + 1
#endif /* SEAICE_DO_OPEN_WATER_GROWTH */

C--   SEAICE_OCN_MELT_ACT_ON_AREA is obsolete: issue error and stop.
#ifdef SEAICE_OCN_MELT_ACT_ON_AREA
         WRITE(msgBuf,'(A)')
     &     'SEAICE_OCN_MELT_ACT_ON_AREA option is obsolete:'
         CALL PRINT_ERROR( msgBuf, myThid )
         WRITE(msgBuf,'(A)')
     &     'it is now done with SEAICE_areaLossFormula.EQ.1 and 2'
         CALL PRINT_ERROR( msgBuf, myThid )
         errCount = errCount + 1
#endif /* SEAICE_OCN_MELT_ACT_ON_AREA */

C--   FENTY_AREA_EXPANSION_CONTRACTION is obsolete: issue error and stop.
#ifdef FENTY_AREA_EXPANSION_CONTRACTION
         WRITE(msgBuf,'(A)')
     &     'FENTY_AREA_EXPANSION_CONTRACTION option is obsolete:'
         CALL PRINT_ERROR( msgBuf, myThid )
         WRITE(msgBuf,'(A)')
     &     'it is now done with SEAICE_areaLoss(Melt)Formula.EQ.1'
         CALL PRINT_ERROR( msgBuf, myThid )
         errCount = errCount + 1
#endif /* SEAICE_DO_OPEN_WATER_MELT */

C--   SEAICE_AGE is obsolete: issue error and stop.
#ifdef SEAICE_AGE
         WRITE(msgBuf,'(2A)') 'SEAICE_CHECK: ',
     &     'SEAICE_AGE option is obsolete: '
         CALL PRINT_ERROR( msgBuf, myThid )
         WRITE(msgBuf,'(2A)') 'it now is done',
     &     ' with SEAICE_SITRACER and siTrName=age'
         CALL PRINT_ERROR( msgBuf, myThid )
         errCount = errCount + 1
#endif /* SEAICE_AGE */

C--   SEAICE_SALINITY is obsolete: issue error and stop.
#ifdef SEAICE_SALINITY
         WRITE(msgBuf,'(A)')
     &     'SEAICE_SALINITY option is obsolete'
         CALL PRINT_ERROR( msgBuf, myThid )
         WRITE(msgBuf,'(A)')
     &     'use SEAICE_VARIABLE_SALINITY instead.'
         CALL PRINT_ERROR( msgBuf, myThid )
         errCount = errCount + 1
#endif /* SEAICE_SALINITY */

C--   SEAICE_OLD_AND_BAD_DISCRETIZATION is obsolete: issue error and stop.
#ifdef SEAICE_OLD_AND_BAD_DISCRETIZATION
         WRITE(msgBuf,'(A)')
     &     'SEAICE_OLD_AND_BAD_DISCRETIZATION option is obsolete'
         CALL PRINT_ERROR( msgBuf, myThid )
         WRITE(msgBuf,'(A)')
     &     'and has no effect.'
         CALL PRINT_ERROR( msgBuf, myThid )
         errCount = errCount + 1
#endif /* SEAICE_OLD_AND_BAD_DISCRETIZATION */

C--   pkg/seaice requires pkg/exf with following CPP options/
C jmc: strickly true for Thermodynamics parts since Dynamics can be used
C      without EXF (assuming a simple scaling of wind-stress over ice)
      IF ( usePW79thermodynamics ) THEN
#ifndef ALLOW_EXF
         WRITE(msgBuf,'(A)')
     &        'need to define ALLOW_EXF'
         CALL PRINT_ERROR( msgBuf, myThid )
         errCount = errCount + 1
#else /* ALLOW_EXF */
         IF ( .NOT.useEXF ) THEN
           WRITE(msgBuf,'(A)')
     &        'S/R SEAICE_CHECK: need to set useEXF in data.pkg'
           CALL PRINT_ERROR( msgBuf, myThid )
           errCount = errCount + 1
         ENDIF
#ifndef ALLOW_ATM_TEMP
         WRITE(msgBuf,'(2A)') 'S/R SEAICE_CHECK: ',
     &        'need to define pkg/exf ALLOW_ATM_TEMP'
         CALL PRINT_ERROR( msgBuf, myThid )
         errCount = errCount + 1
#endif
#ifndef ALLOW_DOWNWARD_RADIATION
         WRITE(msgBuf,'(2A)') 'S/R SEAICE_CHECK: ',
     &        'need to define pkg/exf ALLOW_DOWNWARD_RADIATION'
         CALL PRINT_ERROR( msgBuf, myThid )
         errCount = errCount + 1
#endif
#ifdef SEAICE_EXTERNAL_FLUXES
# if !defined(EXF_READ_EVAP) && !defined(ALLOW_BULKFORMULAE)
         WRITE(msgBuf,'(2A)') 'S/R SEAICE_CHECK: ',
     &     'need to set EXF_READ_EVAP or ALLOW_BULKFORMULAE in pkg/exf'
         CALL PRINT_ERROR( msgBuf, myThid )
         errCount = errCount + 1
# endif /* !defined(EXF_READ_EVAP) && !defined(ALLOW_BULKFORMULAE) */
         IF ( SEAICE_waterAlbedo .NE. UNSET_RL ) THEN
          WRITE(msgBuf,'(A)')
     &      'SEAICE_waterAlbedo is not used with SEAICE_EXTERNAL_FLUXES'
          CALL PRINT_ERROR( msgBuf, myThid )
          WRITE(msgBuf,'(A)')
     &      'Set exf_albedo in data.exf EXF_NML_01 instead'
          CALL PRINT_ERROR( msgBuf, myThid )
          errCount = errCount + 1
         ENDIF
         IF ( lwfluxfile .NE. ' ' .AND. lwdownfile .EQ. ' ' ) THEN
          i = ILNBLNK(lwfluxfile)
          WRITE(msgBuf,'(A,A)')
     &         'lwFlux is read from lwfluxfile = ',lwfluxfile(1:i)
          CALL PRINT_ERROR( msgBuf, myThid )
          WRITE(msgBuf,'(2A)')
     &         'implying that lwdown = 0. For pkg/seaice to work ',
     &         'properly lwdown should be read from lwdownfile!'
          CALL PRINT_ERROR( msgBuf, myThid )
          errCount = errCount + 1
         ENDIF
         IF ( swfluxfile .NE. ' ' .AND. swdownfile .EQ. ' ' ) THEN
          i = ILNBLNK(swfluxfile)
          WRITE(msgBuf,'(A,A)')
     &         'swFlux is read from swfluxfile = ',swfluxfile(1:i)
          CALL PRINT_ERROR( msgBuf, myThid )
          WRITE(msgBuf,'(2A)')
     &         'implying that swdown = 0. For pkg/seaice to work ',
     &         'properly swdown should be read from swdownfile!'
          CALL PRINT_ERROR( msgBuf, myThid )
          errCount = errCount + 1
         ENDIF
#else /* if undef SEAICE_EXTERNAL_FLUXES */
         WRITE(msgBuf,'(3A)') 'S/R SEAICE_CHECK: ',
     &     'SEAICE_EXTERNAL_FLUXES is undefined, so we assume you ',
     &     'know what you are doing.'
         CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &        SQUEEZE_RIGHT, myThid )
         CALL PRINT_ERROR( msgBuf, myThid )
         WRITE(msgBuf,'(2A)') 'S/R SEAICE_CHECK: ',
     &     'Use S/R SEAICE_BUDGET_OCEAN to compute fluxes over ocean.'
         CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &        SQUEEZE_RIGHT, myThid )
         CALL PRINT_ERROR( msgBuf, myThid )
#endif /* SEAICE_EXTERNAL_FLUXES */
#ifndef SEAICE_CGRID
         IF ( .NOT.useAtmWind ) THEN
           WRITE(msgBuf,'(2A)') 'S/R SEAICE_CHECK: ',
     &        'needs pkg/exf useAtmWind to be true'
           CALL PRINT_ERROR( msgBuf, myThid )
           errCount = errCount + 1
         ENDIF
#endif
#ifndef EXF_SEAICE_FRACTION
         IF ( SEAICE_tauAreaObsRelax.GT.zeroRL ) THEN
           WRITE(msgBuf,'(2A)') 'S/R SEAICE_CHECK: ',
     &        'ice-area relaxation needs #define EXF_SEAICE_FRACTION'
           CALL PRINT_ERROR( msgBuf, myThid )
           errCount = errCount + 1
         ENDIF
#endif
#endif /* ALLOW_EXF */
C     end if usePW79thermodynamics
      ENDIF

      IF ( ( SEAICEuseDynamics .OR. SEAICEuseFREEDRIFT ) .AND.
     &     momStepping .AND. .NOT.SEAICEupdateOceanStress ) THEN
        WRITE(msgBuf,'(2A)') '** WARNING ** SEAICE_CHECK: ',
     &      'SEAICEupdateOceanStress= FALSE will'
        CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
        WRITE(msgBuf,'(2A)') '** WARNING ** SEAICE_CHECK: ',
     &      'give inconsistent Ocean surface stress'
        CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      ENDIF

#ifdef SEAICE_CGRID
      IF ( SEAICEuseDynamics ) THEN
C--   Check Overlap size:
       IF ( SEAICEuseJFNK ) THEN
        IF ( OLx.LT.3 .OR. OLy.LT.3 ) THEN
         WRITE(msgBuf,'(A,A)')
     &        'SEAICE_CHECK: cannot use JFNK-solver with',
     &        ' overlap (OLx,OLy) smaller than 3'
         CALL PRINT_ERROR( msgBuf, myThid )
         errCount = errCount + 1
        ENDIF
       ELSE
        IF ( OLx.LT.2 .OR. OLy.LT.2 ) THEN
         WRITE(msgBuf,'(A,A)')
     &        'SEAICE_CHECK: cannot use dynamics solver with',
     &        ' overlap (OLx,OLy) smaller than 2'
         CALL PRINT_ERROR( msgBuf, myThid )
         errCount = errCount + 1
        ENDIF
       ENDIF
       IF ( SEAICE_OLx .GT. OLx-2 .OR. SEAICE_OLy .GT. OLy-2 .OR.
     &      SEAICE_OLx .LT. 0     .OR. SEAICE_OLy .LT. 0 ) THEN
        WRITE(msgBuf,'(A,I2,A,I2)') 'S/R SEAICE_CHECK: SEAICE_OLx/y = ',
     &       SEAICE_OLx, '/', SEAICE_OLy
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(2A,I2,A,I2)')
     &       'S/R SEAICE_CHECK: SEAICE_OLx/y cannot be smaller than 0 ',
     &       'or larger than OLx/y-2 = ', OLx-2, '/', OLy-2
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
       ENDIF
       IF ( SEAICE_2ndOrderBC ) THEN
        IF ( OLx.LT.3 .OR. OLy.LT.3 ) THEN
         WRITE(msgBuf,'(A,A)')
     &   'SEAICE_CHECK: SEAICE_2ndOrderBC = .TRUE. requires',
     &   ' an overlap (OLx,OLy) of at least 3'
         CALL PRINT_ERROR( msgBuf, myThid )
         errCount = errCount + 1
        ENDIF
        IF ( SEAICE_OLx .GT. OLx-3 .OR. SEAICE_OLy .GT. OLy-3 ) THEN
         WRITE(msgBuf,'(A,I2,A,I2)')
     &        'S/R SEAICE_CHECK: SEAICE_OLx/y = ',
     &        SEAICE_OLx, '/', SEAICE_OLy
         CALL PRINT_ERROR( msgBuf, myThid )
         WRITE(msgBuf,'(2A,I2,A,I2)')
     &        'S/R SEAICE_CHECK: with SEAICE_2ndOrderBC, SEAICE_OLx/y',
     &        ' cannot be larger than OLx/y-3 = ', OLx-3, '/', OLy-3
         CALL PRINT_ERROR( msgBuf, myThid )
         errCount = errCount + 1
        ENDIF
       ENDIF

# ifdef SEAICE_ALLOW_EVP
       IF ( SEAICEuseEVP ) THEN
#  ifdef ALLOW_AUTODIFF_TAMC
        IF ( SEAICEnEVPstarSteps.GT.nEVPstepMax ) THEN
         WRITE(msgBuf,'(2A)')
     &        'SEAICE_CHECK: need to set nEVPstepMax to >= ',
     &        'SEAICEnEVPstarSteps'
         CALL PRINT_ERROR( msgBuf, myThid )
         WRITE(msgBuf,'(A,I4)')
     &   'SEAICE_CHECK: SEAICEnEVPstarSteps = ', SEAICEnEVPstarSteps
         CALL PRINT_ERROR( msgBuf, myThid )
         errCount = errCount + 1
        ENDIF
#  endif
        IF ( .NOT.(SEAICEuseEVPstar.OR.SEAICEuseEVPrev)
     &       .AND. SEAICEnEVPstarSteps.NE.
     &       INT(SEAICE_deltaTdyn/SEAICE_deltaTevp) ) THEN
         WRITE(msgBuf,'(2A)') 'SEAICE_CHECK: SEAICEnEVPstarSteps is ',
     &        'set in namelist, but SEAICEuseEVPstar = .FALSE.'
         CALL PRINT_ERROR( msgBuf, myThid )
         errCount = errCount + 1
        ENDIF
       ENDIF
# else /* SEAICE_ALLOW_EVP */
       IF ( SEAICEuseEVP ) THEN
        WRITE(msgBuf,'(A)')
     &       'SEAICE_CHECK: SEAICEuseEVP = .TRUE., so EVP is turned on'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(A)')
     &       'SEAICE_CHECK: by setting appropriate runtime parameters,'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(2A)') 'SEAICE_CHECK: but cpp-flag ',
     &       'SEAICE_ALLOW_EVP is not defined in SEAICE_OPTIONS.h'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
       ENDIF
# endif /* SEAICE_ALLOW_EVP */

# ifdef SEAICE_ALLOW_EVP
       IF ( SEAICEuseEVP .AND. (SEAICE_eccfr.NE.SEAICE_eccen) ) THEN
        WRITE(msgBuf,'(2A)') 'SEAICE_CHECK: SEAICEuseEVP = .TRUE., ',
     &       'so EVP is turned on by setting appropriate'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(A,F5.2,A,F5.2,A)')
     &       'SEAICE_CHECK: runtime parameters, but SEAICE_eccfr(=',
     &       SEAICE_eccfr , ')/=SEAICE_eccen(=', SEAICE_eccen, ')'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(2A)')'SEAICE_CHECK: implies a non-normal flow ',
     &       'rule for the elliptical yield curve,'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(A)')
     &       'SEAICE_CHECK: which is not implemented for EVP.'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
       ENDIF
       IF ( SEAICEuseEVP .AND.
     &      ( SEAICEuseTD .OR. SEAICEusePL .OR.
     &        SEAICEuseMCE .OR.  SEAICEuseMCS ) ) THEN
        WRITE(msgBuf,'(2A)') 'SEAICE_CHECK: SEAICEuseMCS, ',
     &      'SEAICEuseTD, SEAICEusePL, or SEAICEuseMCE = .TRUE.,'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(2A)') 'SEAICE_CHECK: and SEAICEuseEVP = ',
     &       '.TRUE., but these non-standard rheologies'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(A)')
     &       'SEAICE_CHECK: are not implemented for EVP'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
       ENDIF
# endif /* SEAICE_ALLOW_EVP */

#ifndef SEAICE_ALLOW_LSR_FLEX
      IF ( SEAICEuseLSRflex ) THEN
       WRITE(msgBuf,'(A)')
     &   'SEAICE_ALLOW_LSR_FLEX needed for SEAICEuseLSRflex'
       CALL PRINT_ERROR( msgBuf, myThid )
       errCount = errCount + 1
      ENDIF
#endif
C     SEAICEuseDynamics
      ENDIF
#endif /* SEAICE_CGRID */

#ifndef SEAICE_GLOBAL_3DIAG_SOLVER
      IF ( SEAICEuseMultiTileSolver ) THEN
        WRITE(msgBuf,'(A)')
     &   'SEAICE_CHECK: SEAICEuseMultiTileSolver = .TRUE.'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(2A)') ' but CPP-flag ',
     &   'SEAICE_GLOBAL_3DIAG_SOLVER is #undef in SEAICE_OPTIONS.h'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF
#endif /* SEAICE_GLOBAL_3DIAG_SOLVER */

#ifndef SEAICE_ALLOW_CLIPVELS
      IF ( SEAICE_clipVelocities ) THEN
        WRITE(msgBuf,'(A)')
     &      'SEAICE_CHECK: SEAICE_clipVelocities = .TRUE.'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(2A)') 'SEAICE_CHECK: but cpp-flag ',
     &       'SEAICE_ALLOW_CLIPVELS is not defined in SEAICE_OPTIONS.h'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF
#endif /* SEAICE_ALLOW_CLIPVELS */

#ifndef SEAICE_ALLOW_CLIPZETA
      IF ( SEAICE_evpDampC .GT. 0. _d 0 .OR.
     &     SEAICE_zetaMin  .GT. 0. _d 0 ) THEN
        WRITE(msgBuf,'(2A)')
     &      'SEAICE_CHECK: SEAICE_evpDampC and/or SEAICE_zetaMin ',
     &      'are set in data.seaice'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(2A)') 'SEAICE_CHECK: but cpp-flag ',
     &       'SEAICE_ALLOW_CLIPZETA is not defined in SEAICE_OPTIONS.h'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF
#endif /* SEAICE_ALLOW_CLIPZETA */

#ifndef SEAICE_ALLOW_TEM
      IF ( SEAICEuseTEM ) THEN
       WRITE(msgBuf,'(2A)') 'SEAICE_CHECK: SEAICEuseTEM requires ',
     &      'that SEAICE_ALLOW_TEM is defined.'
       CALL PRINT_ERROR( msgBuf, myThid )
       errCount = errCount + 1
      ENDIF
#endif
#ifndef SEAICE_ALLOW_MCE
      IF ( SEAICEuseMCE ) THEN
       WRITE(msgBuf,'(2A)') 'SEAICE_CHECK: SEAICEuseMCE requires ',
     &      'that SEAICE_ALLOW_MCE is defined.'
       CALL PRINT_ERROR( msgBuf, myThid )
       errCount = errCount + 1
      ENDIF
#endif
#ifndef SEAICE_ALLOW_MCS
      IF ( SEAICEuseMCS ) THEN
       WRITE(msgBuf,'(2A)') 'SEAICE_CHECK: SEAICEuseMCS requires ',
     &      'that SEAICE_ALLOW_MCS is defined.'
       CALL PRINT_ERROR( msgBuf, myThid )
       errCount = errCount + 1
      ENDIF
#endif
#ifndef SEAICE_ALLOW_TEARDROP
      IF (SEAICEuseTD ) THEN
       WRITE(msgBuf,'(2A)') 'SEAICE_CHECK: SEAICEuseTD requires ',
     &      'that SEAICE_ALLOW_TEARDROP is defined.'
       CALL PRINT_ERROR( msgBuf, myThid )
       errCount = errCount + 1
      ENDIF
      IF ( SEAICEusePL ) THEN
       WRITE(msgBuf,'(2A)') 'SEAICE_CHECK: SEAICEusePL requires ',
     &      'that SEAICE_ALLOW_TEARDROP is defined.'
       CALL PRINT_ERROR( msgBuf, myThid )
       errCount = errCount + 1
      ENDIF
#endif

      i = 0
      IF ( SEAICEuseTEM ) i = i + 1
      IF ( SEAICEuseMCS ) i = i + 1
      IF ( SEAICEuseMCE ) i = i + 1
      IF ( SEAICEuseTD  ) i = i + 1
      IF ( SEAICEusePL  ) i = i + 1
      IF ( i .GT. 1 ) THEN
       WRITE(msgBuf,'(2A)') 'SEAICE_CHECK: More than one rheology ',
     &      'flag = .TRUE.,'
       CALL PRINT_ERROR( msgBuf, myThid )
       WRITE(msgBuf,'(A)')
     &      'SEAICE_CHECK: but only one can be .TRUE. at a time.'
       CALL PRINT_ERROR( msgBuf, myThid )
       errCount = errCount + 1
      ENDIF

#ifdef SEAICE_BGRID_DYNAMICS
      IF ( i .GE. 1 ) THEN
       WRITE(msgBuf,'(2A)') 'SEAICE_CHECK: non-default rheologies ',
     &      'require that SEAICE_CGRID is defined.'
       CALL PRINT_ERROR( msgBuf, myThid )
       errCount = errCount + 1
      ENDIF

# ifdef SEAICE_TEST_ICE_STRESS_1
       WRITE(msgBuf,'(A)')
     &  'SEAICE_CHECK: Only relevant for B-grid:'
       CALL PRINT_ERROR( msgBuf, myThid )
       WRITE(msgBuf,'(A)')
     &  'SEAICE_CHECK: SEAICE_TEST_ICE_STRESS_1 is replaced by'
       CALL PRINT_ERROR( msgBuf, myThid )
       WRITE(msgBuf,'(A)')
     &  'SEAICE_CHECK: SEAICE_BICE_STRESS (defined by default)'
       CALL PRINT_ERROR( msgBuf, myThid )
       errCount = errCount + 1
# endif /* SEAICE_TEST_ICE_STRESS_1 */
      IF ( SEAICEuseDYNAMICS.AND.useCubedSphereExchange ) THEN
       WRITE(msgBuf,'(2A)') 'SEAICE_CHECK: ',
     &       'B-grid dynamics not working on Cubed-Sphere grid'
       CALL PRINT_ERROR( msgBuf, myThid )
       errCount = errCount + 1
      ENDIF
      IF ( SEAICEuseDYNAMICS.AND.useOBCS ) THEN
       WRITE(msgBuf,'(2A)') 'SEAICE_CHECK: ',
     &       'Open-Boundaries not implemented in B-grid dynamics'
       CALL PRINT_ERROR( msgBuf, myThid )
C      errCount = errCount + 1
      ENDIF
#endif /* SEAICE_BGRID_DYNAMICS */

C--   SEAICE_ALLOW_FREEDRIFT and SEAICEuseFREEDRIFT
#ifndef SEAICE_ALLOW_FREEDRIFT
      IF (SEAICEuseFREEDRIFT) THEN
        WRITE(msgBuf,'(A)')
     &   'need to #define SEAICE_ALLOW_FREEDRIFT for SEAICEuseFREEDRIFT'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF
      IF ( LSR_mixIniGuess.GE.0 ) THEN
        WRITE(msgBuf,'(A)')
     &   'need to #define SEAICE_ALLOW_FREEDRIFT to use LSR_mixIniGuess'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF
#endif

#ifndef SEAICE_VARIABLE_SALINITY
      IF ( SEAICEadvSalt ) THEN
        WRITE(msgBuf,'(A)')
     &      'SEAICE_CHECK: SEAICEadvSalt = .TRUE. but cpp-flag'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(2A)') 'SEAICE_CHECK: ',
     &   'SEAICE_VARIABLE_SALINITY is undef in SEAICE_OPTIONS.h'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF
#endif /* SEAICE_VARIABLE_SALINITY */

#ifdef SEAICE_ALLOW_JFNK
      IF ( SEAICEuseJFNK ) THEN
       IF ( JFNKres_t.NE.UNSET_RL .AND. JFNKres_tFac.NE.UNSET_RL) THEN
        WRITE(msgBuf,'(3A)') 'S/R SEAICE_CHECK: JFNKres_t and ',
     &       'JFNKres_tFac are both set, so that JFNKres_t will be'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(3A)') 'S/R SEAICE_CHECK: ',
     &       'overwritten by JFNKres_tFac*JFNKresidual ',
     &       'in each initial Newton iteration.'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(2A)')
     &       'S/R SEAICE_CHECK: For safety we stop here. ',
     &       'Please unset one of the two parameters.'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
       ELSEIF (JFNKres_t.EQ.UNSET_RL.AND.JFNKres_tFac.EQ.UNSET_RL) THEN
        WRITE(msgBuf,'(2A)') 'S/R SEAICE_CHECK: need to specify ',
     &       'JFNKres_t or JFNKres_tFac for SEAICEuseJFNK=.TRUE.'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
       ENDIF
      ENDIF
      IF ( SEAICEuseJFNK .AND. SEAICEuseEVP ) THEN
       WRITE(msgBuf,'(2A)')
     &      'S/R SEAICE_CHECK: cannot have both SEAICEuseJFNK=.TRUE.',
     &      'and SEAICEuseEVP=.TRUE. (i.e. SEAICE_deltaTevp > 0)'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF
#else
      IF ( SEAICEuseJFNK ) THEN
        WRITE(msgBuf,'(A)')
     &      'SEAICE_CHECK: SEAICEuseJFNK = .TRUE. but cpp-flag'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(2A)') 'SEAICE_CHECK: ',
     &   'SEAICE_ALLOW_JFNK is undef in SEAICE_OPTIONS.h'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF
#endif /* SEAICE_ALLOW_JFNK */
#ifndef SEAICE_ALLOW_KRYLOV
      IF ( SEAICEuseKrylov ) THEN
        WRITE(msgBuf,'(A)')
     &      'SEAICE_CHECK: SEAICEuseKRYLOV = .TRUE. but cpp-flag'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(2A)') 'SEAICE_CHECK: ',
     &   'SEAICE_ALLOW_KRYLOV is undef in SEAICE_OPTIONS.h'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF
#endif /* SEAICE_ALLOW_KRYLOV */

      IF ( SEAICEuseDynamics .AND. .NOT.SEAICEuseJFNK ) THEN
       IF ( SEAICEuseBDF2 ) THEN
        WRITE(msgBuf,'(2A)') 'SEAICE_CHECK: SEAICEuseBDF2 = .TRUE. ',
     &       'only allowed with SEAICEuseJFNK = .TRUE.'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
       ENDIF
       IF ( SEAICEuseIMEX ) THEN
        WRITE(msgBuf,'(2A)') 'SEAICE_CHECK: SEAICEuseIMEX = .TRUE. ',
     &       'only allowed with SEAICEuseJFNK = .TRUE.'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
       ENDIF
      ENDIF
      IF ( SEAICEuseIMEX ) THEN
       WRITE(msgBuf,'(3A)') '** WARNING ** SEAICE_CHECK: ',
     &      'SEAICEuseIMEX = .TRUE. ',
     &      'currently has no effect, because the code is missing'
       CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      ENDIF

      IF ( .NOT.(SEAICEetaZmethod.EQ.0.OR.SEAICEetaZmethod.EQ.3) ) THEN
       WRITE(msgBuf,'(A,I2)')
     &      'SEAICE_CHECK: SEAICEetaZmethod = ', SEAICEetaZmethod
       CALL PRINT_ERROR( msgBuf, myThid )
       WRITE(msgBuf,'(2A)') 'SEAICE_CHECK: ',
     &      'is no longer allowed; allowed values are 0 and 3'
       CALL PRINT_ERROR( msgBuf, myThid )
       errCount = errCount + 1
      ENDIF

      IF ( SEAICEpressReplFac .LT. 0. _d 0 .OR.
     &     SEAICEpressReplFac .GT. 1. _d 0 ) THEN
       WRITE(msgBuf,'(A,F5.2)')
     &      'SEAICE_CHECK: SEAICEpressReplFac = ', SEAICEpressReplFac
       CALL PRINT_ERROR( msgBuf, myThid )
       WRITE(msgBuf,'(A)') 'SEAICE_CHECK: cannot be < 0 or > 1'
       CALL PRINT_ERROR( msgBuf, myThid )
       errCount = errCount + 1
      ENDIF

C--   Some sanity checks for SEAICEdWatMin
      IF ( SEAICEdWatMin .LT. 0. _d 0 ) THEN
       WRITE(msgBuf,'(A,A,F5.2,A)') 'SEAICE_CHECK: ',
     &      'SEAICEdWatMin (= ', SEAICEdWatMin, ') may not be < 0.'
       CALL PRINT_ERROR( msgBuf , myThid)
       errCount = errCount + 1
      ENDIF
      IF ( SEAICE_waterDrag .EQ. 0. _d 0
     &     .AND. SEAICEdWatMin .GT. 0. _d 0) THEN
       WRITE(msgBuf,'(A,A,F5.2)') '** WARNING ** SEAICE_CHECK: ',
     &      'SEAICE_waterDrag  = ', SEAICE_waterDrag
       CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                     SQUEEZE_RIGHT, myThid )
       WRITE(msgBuf,'(A,A,F5.2)') '** WARNING ** SEAICE_CHECK: ',
     &      'but SEAICEdWatMin = ', SEAICEdWatMin
       CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                     SQUEEZE_RIGHT, myThid )
       WRITE(msgBuf,'(A,A)') '** WARNING ** SEAICE_CHECK: ',
     &      'so that the ice-ocean drag will be non-zero'
       CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                     SQUEEZE_RIGHT, myThid )
      ENDIF
#ifdef SEAICE_ALLOW_FREEDRIFT
      IF ( SEAICE_waterDrag_South .EQ. 0. _d 0
     &     .OR.  SEAICE_waterDrag .EQ. 0. _d 0 ) THEN
       WRITE(msgBuf,'(A,A,A)') 'SEAICE_CHECK: ',
     &      'When SEAICE_ALLOW_FREEDRIFT is defined, ',
     &      'SEAICE_waterDrag or SEAICE_waterDragSouth may not be zero.'
       CALL PRINT_ERROR( msgBuf , myThid)
       errCount = errCount + 1
      ENDIF
#endif /* SEAICE_ALLOW_FREEDRIFT */

#ifndef SEAICE_ALLOW_BOTTOMDRAG
      IF ( SEAICEbasalDragK2 .GT. 0. _d 0 ) THEN
       WRITE(msgBuf,'(A,E12.5)')
     &      'SEAICE_CHECK: SEAICEbasalDragK2 = ', SEAICEbasalDragK2
       CALL PRINT_ERROR( msgBuf, myThid )
       WRITE(msgBuf,'(2A)') 'SEAICE_CHECK: is greater than 0, ',
     &      'but SEAICE_ALLOW_BOTTOMDRAG is not defined'
       CALL PRINT_ERROR( msgBuf, myThid )
       errCount = errCount + 1
      ENDIF
#endif /* SEAICE_ALLOW_BOTTOMDRAG */

#ifndef SEAICE_ALLOW_SIDEDRAG
      IF ( SEAICEsideDrag .NE. 0. _d 0 ) THEN
       WRITE(msgBuf,'(A,E12.5,A)')
     &      'SEAICE_CHECK: SEAICEsideDrag = ', SEAICEsideDrag,
     &      ' is set, but SEAICE_ALLOW_SIDEDRAG is not defined'
       CALL PRINT_ERROR( msgBuf, myThid )
       errCount = errCount + 1
      ENDIF
      IF ( uCoastLineFile .NE. ' ' ) THEN
       i = ILNBLNK(uCoastLineFile)
       WRITE(msgBuf,'(3A)')
     &      'SEAICE_CHECK: uCoastLineFile = ', uCoastLineFile(1:i),
     &      ' is set, but SEAICE_ALLOW_SIDEDRAG is not defined'
       CALL PRINT_ERROR( msgBuf, myThid )
       errCount = errCount + 1
      ENDIF
      IF( vCoastLineFile .NE. ' ' ) THEN
       i = ILNBLNK(vCoastLineFile)
       WRITE(msgBuf,'(3A)')
     &      'SEAICE_CHECK: vCoastLineFile = ', vCoastLineFile(1:i),
     &      ' is set, but SEAICE_ALLOW_SIDEDRAG is not defined'
       CALL PRINT_ERROR( msgBuf, myThid )
       errCount = errCount + 1
      ENDIF
#endif

#ifdef SEAICE_ITD
C     The ice thickness distribution (ITD) module can only be used with
C     the zero-layer thermodynamics of S/R SEAICE_GROWTH and the
C     advection in S/R SEAICE_ADVDIFF
C     If useThSice=.TRUE., do not reset it here, but issue a warning
      IF ( useThSice ) THEN
       WRITE(msgBuf,'(2A)') '** WARNING ** SEAICE_CHECK: ',
     &      'SEAICE_ITD is defined, but useThSice = .TRUE.'
       CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &      SQUEEZE_RIGHT, myThid )
       WRITE(msgBuf,'(2A)') '** WARNING ** SEAICE_CHECK: ',
     &      'avoids the ice thickness distribution code.'
       CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &      SQUEEZE_RIGHT, myThid )
       WRITE(msgBuf,'(2A)') '** WARNING ** SEAICE_CHECK: ',
     &      'If you want the ITD code, set useThSice=.FALSE.'
       CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &      SQUEEZE_RIGHT, myThid )
      ENDIF
C
      IF ( .NOT.SEAICEmultiDimAdvection ) THEN
       WRITE(msgBuf,'(A,L1)')
     &      'SEAICE_CHECK: SEAICEmultiDimAdvection = ',
     &      SEAICEmultiDimAdvection
       CALL PRINT_ERROR( msgBuf, myThid )
       WRITE(msgBuf,'(2A)') 'SEAICE_CHECK: is not allowed when ',
     &      'SEAICE_ITD is defined'
       CALL PRINT_ERROR( msgBuf, myThid )
       WRITE(msgBuf,'(2A)') 'SEAICE_CHECK: use a multiDimAdvection ',
     &      'scheme instead'
       CALL PRINT_ERROR( msgBuf, myThid )
       errCount = errCount + 1
      ENDIF
#endif

#ifdef ALLOW_SEAICE_COST_SMR_AREA
      WRITE(msgBuf,'(2A)')
     & 'SEAICE_CHECK: cpp-flag ALLOW_SEAICE_COST_SMR_AREA ',
     & 'is not allowed anymore.'
      CALL PRINT_ERROR( msgBuf, myThid )
      WRITE(msgBuf,'(A)')
     & 'SEAICE_CHECK: Use pkg/ecco''s generic cost function instead.'
      CALL PRINT_ERROR( msgBuf, myThid )
      errCount = errCount + 1
#endif

      IF ( errCount .GE. 1 ) THEN
       WRITE(msgBuf,'(A,I3,2A)') 'SEAICE_CHECK: ', errCount,
     &      ' parameter/CPP-flag combinations are',
     &      ' inconsistent or incomplete'
       CALL PRINT_ERROR( msgBuf, myThid )
       WRITE(msgBuf,'(A,I3,A)')
     &       'SEAICE_CHECK: detected', errCount,' fatal error(s)'
       CALL PRINT_ERROR( msgBuf, myThid )
       CALL ALL_PROC_DIE( 0 )
       STOP 'ABNORMAL END: S/R SEAICE_CHECK'
      ENDIF

      _END_MASTER(myThid)

      RETURN
      END

#include "STREAMICE_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 0
C !ROUTINE: STREAMICE_INIT_FIXED

C !INTERFACE:
      SUBROUTINE STREAMICE_INIT_DIAGNOSTICS( myThid )

C     !DESCRIPTION:
C     Initialize STREAMICE variables that are kept fixed during the run.

C     !USES:
      IMPLICIT NONE
#include "EEPARAMS.h"
#include "SIZE.h"
#include "PARAMS.h"
#include "STREAMICE.h"
#include "STREAMICE_CG.h"
#include "STREAMICE_BDRY.h"
#include "GRID.h"

C     myThid ::  my Thread Id number
      INTEGER myThid

#ifdef ALLOW_STREAMICE
#ifdef ALLOW_DIAGNOSTICS

      CHARACTER*(MAX_LEN_MBUF) msgBuf
      INTEGER       diagNum
c     INTEGER       diagMate
      CHARACTER*8   diagName
      CHARACTER*16  diagCode
      CHARACTER*16  diagUnits
      CHARACTER*(80) diagTitle

      diagName  = 'SI_Uvel '
      diagTitle = 'Ice stream x-velocity'
      diagUnits = 'm/a        '
      diagCode  = 'UZ      L1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I      diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'SI_Vvel '
      diagTitle = 'Ice stream y-velocity'
      diagUnits = 'm/a        '
      diagCode  = 'VZ      L1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I      diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'SI_Thick'
      diagTitle = 'Ice stream thickness'
      diagUnits = 'm          '
      diagCode  = 'SM      L1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I      diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'SI_area '
      diagTitle = 'Ice stream cell area coverage'
      diagUnits = 'm^2        '
      diagCode  = 'SM      L1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I      diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'SI_float'
      diagTitle = 'Ice stream grounding ind'
      diagUnits = 'none       '
      diagCode  = 'SM      L1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I      diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'SI_hmask'
      diagTitle = 'Ice stream thickness mask'
      diagUnits = 'none       '
      diagCode  = 'SM      L1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I      diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'SI_usurf'
      diagTitle = 'Ice stream surface x-vel'
      diagUnits = 'none       '
      diagCode  = 'SM      L1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I      diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'SI_vsurf'
      diagTitle = 'Ice stream surface y-vel'
      diagUnits = 'none       '
      diagCode  = 'SM      L1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I      diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'SI_ubase'
      diagTitle = 'Ice stream basal x-vel'
      diagUnits = 'none       '
      diagCode  = 'SM      L1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I      diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'SI_vbase'
      diagTitle = 'Ice stream basal y-vel'
      diagUnits = 'none       '
      diagCode  = 'SM      L1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I      diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'SI_taubx'
      diagTitle = 'Ice stream basal x-stress'
      diagUnits = 'none       '
      diagCode  = 'SM      L1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I      diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'SI_tauby'
      diagTitle = 'Ice stream basal y-stress'
      diagUnits = 'none       '
      diagCode  = 'SM      L1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I      diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'SI_selev'
      diagTitle = 'Ice stream surface elev'
      diagUnits = 'none       '
      diagCode  = 'SM      L1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I      diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'SI2Dtrac'
      diagTitle = 'Ice stream 2d tracer'
      diagUnits = 'none       '
      diagCode  = 'SM      L1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I      diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'BDOT_SI '
      diagTitle = 'Ice stream 2d tracer'
      diagUnits = 'none       '
      diagCode  = 'SM      L1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I      diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      WRITE(msgBuf,'(A)') 'ADDED DIAGS TO LIST'
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                     SQUEEZE_RIGHT , 1)

#endif /* ALLOW_DIAGNOSTICS */
#endif /* ALLOW_STREAMICE */
      RETURN
      END

#include "PACKAGES_CONFIG.h"
#include "CPP_EEOPTIONS.h"

CBOP
C     !ROUTINE: EEBOOT_MINIMAL

C     !INTERFACE:
      SUBROUTINE EEBOOT_MINIMAL( myComm )

C     !DESCRIPTION:
C     *==========================================================*
C     | SUBROUTINE EEBOOT\_MINIMAL
C     | o Set an initial environment that is predictable i.e.
C     | behaves in a similar way on all machines and stable.
C     *==========================================================*
C     | Under MPI this routine calls MPI\_INIT to setup the
C     | mpi environment ( on some systems the code is running as
C     | a single process prior to MPI\_INIT, on others the mpirun
C     | script has already created multiple processes). Until
C     | MPI\_Init is called it is unclear what state the
C     | application is in. Once this routine has been run it is
C     | "safe" to do things like I/O to report erros and to get
C     | run parameters.
C     | Note: This routine can also be compiled with CPP
C     | directives set so that no multi-processing is initialise.
C     | This is OK and will work fine.
C     *==========================================================*

C     !USES:
      IMPLICIT NONE
C     == Global data ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "EESUPPORT.h"

C     !ROUTINE ARGUMENTS
C     == Routine arguments ==
C     myComm     :: Communicator that is passed down from
C                   upper level driver (if there is one).
      INTEGER myComm

C     !FUNCTIONS:
c     INTEGER  IFNBLNK
c     EXTERNAL IFNBLNK
      INTEGER  ILNBLNK
      EXTERNAL ILNBLNK

C     !LOCAL VARIABLES:
C     == Local variables ==
C     myThid     :: Temp. dummy thread number.
C     fNam       :: Used to build file name for standard and error output.
C     msgBuf     :: Used to build messages for printing.
      INTEGER myThid
#ifdef USE_PDAF
      CHARACTER*18 fNam
#else
      CHARACTER*13 fNam
#endif /* USE_PDAF */
      CHARACTER*(MAX_LEN_MBUF) msgBuf
#ifdef ALLOW_USE_MPI
C     mpiRC      :: Error code reporting variable used with MPI.
      INTEGER mpiRC
      INTEGER mpiIsInitialized
      LOGICAL doReport
#if defined(ALLOW_OASIS) || defined(COMPONENT_MODULE)
      INTEGER mpiMyWId
#elif defined(ALLOW_NEST2W_COMMON)
      INTEGER mpiMyWId
#endif
#if defined(ALLOW_NEST_PARENT) || defined(ALLOW_NEST_CHILD)
      INTEGER mpiMyWId, color
#endif
#ifdef USE_PDAF
      INTEGER mpi_task_id
      CHARACTER*(14) fmtStr
#else
      CHARACTER*(6) fmtStr
#endif /* USE_PDAF */
      INTEGER iTmp
#endif /* ALLOW_USE_MPI */
CEOP

C--   Default values set to single processor case
      numberOfProcs = 1
      myProcId      = 0
      pidIO         = myProcId
      myProcessStr  = '------'
C     Set a dummy value for myThid because we are not multi-threading yet.
      myThid        = 1

C     Annoyingly there is no universal way to have the usingMPI
C     parameter work as one might expect. This is because, on some
C     systems I/O does not work until MPI_Init has been called.
C     The solution for now is that the parameter below may need to
C     be changed manually!
#ifdef ALLOW_USE_MPI
      usingMPI = .TRUE.
#else
      usingMPI = .FALSE.
#endif

      IF ( .NOT.usingMPI ) THEN

        WRITE(myProcessStr,'(I4.4)') myProcId
        WRITE(fNam,'(A,A)') 'STDERR.', myProcessStr(1:4)
        OPEN(errorMessageUnit,FILE=fNam,STATUS='unknown')
c       WRITE(fNam,'(A,A)') 'STDOUT.', myProcessStr(1:4)
c       OPEN(standardMessageUnit,FILE=fNam,STATUS='unknown')

#ifdef ALLOW_USE_MPI
      ELSE
C--   MPI style multiple-process initialisation
C--   =========================================

       CALL MPI_Initialized( mpiIsInitialized, mpiRC )

       IF ( mpiIsInitialized .EQ. 0 ) THEN
C--     Initialise MPI multi-process parallel environment.
C       On some systems program forks at this point. Others have already
C       forked within mpirun - now thats an open standard!
        CALL MPI_INIT( mpiRC )
        IF ( mpiRC .NE. MPI_SUCCESS ) THEN
         eeBootError = .TRUE.
         WRITE(msgBuf,'(A,I5)')
     &        'EEBOOT_MINIMAL: MPI_INIT return code', mpiRC
         CALL PRINT_ERROR( msgBuf, myThid )
         GOTO 999
        ENDIF

C--     MPI has now been initialized ; now we need to either
C       ask for a communicator or pretend that we have:
C       Pretend that we have asked for a communicator
        MPI_COMM_MODEL = MPI_COMM_WORLD

       ELSE
C--     MPI was already initialized and communicator has been passed
C       down from upper level driver
        MPI_COMM_MODEL = myComm

       ENDIF

       doReport = .FALSE.
#ifdef USE_PDAF
C     initialize PDAF
C     for more output increase second parameter from 1 to 2
       CALL INIT_PARALLEL_PDAF(0, 1, MPI_COMM_MODEL, MPI_COMM_MODEL,
     &      mpi_task_id)
#endif /* USE_PDAF */

#ifdef ALLOW_OASIS
C      add a 1rst preliminary call EESET_PARAMS to set useOASIS
C      (needed to decide either to call OASIS_INIT or not)
       CALL MPI_COMM_RANK( MPI_COMM_WORLD, mpiMyWId, mpiRC )
       CALL EESET_PARMS ( mpiMyWId, doReport )
       IF ( useOASIS ) CALL OASIS_INIT(MPI_COMM_MODEL)
#endif /* ALLOW_OASIS */

#ifdef COMPONENT_MODULE
C--    Set the running directory
       CALL MPI_COMM_RANK( MPI_COMM_WORLD, mpiMyWId, mpiRC )
       CALL SETDIR( mpiMyWId )

C- jmc: test:
C      add a 1rst preliminary call EESET_PARAMS to set useCoupler
C      (needed to decide either to call CPL_INIT or not)
       CALL EESET_PARMS ( mpiMyWId, doReport )
C- jmc: test end ; otherwise, uncomment next line:
c      useCoupler = .TRUE.

C--    Ask coupler interface for a communicator
       IF ( useCoupler) CALL CPL_INIT
#endif /* COMPONENT_MODULE */

C--    Case with Nest(ing)
#if defined(ALLOW_NEST_PARENT) || defined(ALLOW_NEST_CHILD)
C--    Set the running directory
       CALL MPI_COMM_RANK( MPI_COMM_WORLD, mpiMyWId, mpiRC )
       CALL SETDIR( mpiMyWId )

C--    Setup Nesting Execution Environment
       CALL NEST_EEINIT( mpiMyWId, color )
#endif /* ALLOW_NEST_PARENT | ALLOW_NEST_CHILD */

#ifdef ALLOW_NEST2W_COMMON
C--    Case with 2-Ways Nest(ing)
C-     Set the running directory
       CALL MPI_COMM_RANK( MPI_COMM_WORLD, mpiMyWId, mpiRC )
       CALL SETDIR( mpiMyWId )

C-     Setup Nesting Execution Environment
       CALL NEST2W_EEINIT( mpiMyWId )
       IF ( eeBootError ) GOTO 999
#endif /* ALLOW_NEST2W_COMMON */

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C--    Get my process number
       CALL MPI_COMM_RANK( MPI_COMM_MODEL, mpiMyId, mpiRC )
       IF ( mpiRC .NE. MPI_SUCCESS ) THEN
        eeBootError = .TRUE.
        WRITE(msgBuf,'(A,I5)')
     &        'EEBOOT_MINIMAL: MPI_COMM_RANK return code', mpiRC
        CALL PRINT_ERROR( msgBuf, myThid )
        GOTO 999
       ENDIF
       myProcId = mpiMyId
       iTmp = MAX(4,1 + INT(LOG10(DFLOAT(nPx*nPy))))
#ifdef USE_PDAF
       WRITE(fmtStr,'(4(A,I1),A)')
     &      '(I',iTmp,'.',iTmp,',A1,I',iTmp,'.',iTmp,')'
       WRITE(myProcessStr,fmtStr) mpi_task_id,'.',myProcId
#else
       WRITE(fmtStr,'(2(A,I1),A)') '(I',iTmp,'.',iTmp,')'
       WRITE(myProcessStr,fmtStr) myProcId
#endif /* USE_PDAF */
       iTmp = ILNBLNK( myProcessStr )
       mpiPidIo = myProcId
       pidIO    = mpiPidIo
       IF ( mpiPidIo .EQ. myProcId ) THEN
#ifdef SINGLE_DISK_IO
        IF( myProcId .EQ. 0 ) THEN
#endif
         WRITE(fNam,'(A,A)') 'STDERR.', myProcessStr(1:iTmp)
         OPEN(errorMessageUnit,FILE=fNam,STATUS='unknown')
         WRITE(fNam,'(A,A)') 'STDOUT.', myProcessStr(1:iTmp)
         OPEN(standardMessageUnit,FILE=fNam,STATUS='unknown')
#ifdef SINGLE_DISK_IO
        ELSE
         OPEN(errorMessageUnit,FILE='/dev/null',STATUS='unknown')
         standardMessageUnit=errorMessageUnit
        ENDIF
        IF( myProcId .EQ. 0 ) THEN
          WRITE(msgBuf,'(2A)') '** WARNING ** EEBOOT_MINIMAL: ',
     &     'defined SINGLE_DISK_IO will result in losing'
          CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                        SQUEEZE_RIGHT, myThid )
          WRITE(msgBuf,'(2A)') '** WARNING ** EEBOOT_MINIMAL: ',
     &     'any message (error/warning) from any proc <> 0'
          CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                        SQUEEZE_RIGHT, myThid )
        ENDIF
#endif
       ENDIF

#if defined(ALLOW_NEST_PARENT) || defined(ALLOW_NEST_CHILD)
       WRITE(standardMessageUnit,'(2(A,I6))')
     &           ' mpiMyWId =', mpiMyWId, ' , color =',color
#endif /* ALLOW_NEST_PARENT | ALLOW_NEST_CHILD */

C--    Synchronise all processes
C      Strictly this is superfluous, but by using it we can guarantee to
C      find out about processes that did not start up.
       CALL MPI_BARRIER( MPI_COMM_MODEL, mpiRC )
       IF ( mpiRC .NE. MPI_SUCCESS ) THEN
        eeBootError = .TRUE.
        WRITE(msgBuf,'(A,I6)')
     &        'EEBOOT_MINIMAL: MPI_BARRIER return code', mpiRC
        CALL PRINT_ERROR( msgBuf, myThid )
        GOTO 999
       ENDIF

C--    Get number of MPI processes
       CALL MPI_COMM_SIZE ( MPI_COMM_MODEL, mpiNProcs, mpiRC )
       IF ( mpiRC .NE. MPI_SUCCESS ) THEN
        eeBootError = .TRUE.
        WRITE(msgBuf,'(A,I6)')
     &        'EEBOOT_MINIMAL: MPI_COMM_SIZE return code', mpiRC
        CALL PRINT_ERROR( msgBuf, myThid )
        GOTO 999
       ENDIF
       numberOfProcs = mpiNProcs

#endif /* ALLOW_USE_MPI */
      ENDIF

C--    Under MPI only allow same number of processes as proc grid size.
C      Strictly we are allowed more procs but knowing there
C      is an exact match makes things easier.
       IF ( numberOfProcs .NE. nPx*nPy ) THEN
        eeBootError = .TRUE.
        WRITE(msgBuf,'(2(A,I6))')
     &  'EEBOOT_MINIMAL: No. of procs=', numberOfProcs,
     &  ' not equal to nPx*nPy=', nPx*nPy
        CALL PRINT_ERROR( msgBuf, myThid )
        GOTO 999
       ENDIF

#ifdef USE_LIBHPM
       CALL F_HPMINIT(myProcId, "mitgcmuv")
#endif

 999  CONTINUE
      RETURN
      END

#include "COST_OPTIONS.h"
#ifdef ALLOW_STREAMICE
# include "STREAMICE_OPTIONS.h"
#endif

      subroutine cost_test( myThid )
C     *==========================================================*
C     | subroutine cost_test                                     |
C     | o this routine computes the cost function for the tiles  |
C     |   of this processor                                      |
C     *==========================================================*
C     | Notes                                                    |
C     *==========================================================*
      IMPLICIT NONE

C     == Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "DYNVARS.h"
#include "GRID.h"
#include "cost.h"
#ifdef ALLOW_STREAMICE
# include "STREAMICE.h"
#endif

C     == Routine arguments ==
C     myThid - Thread number for this instance of the routine.
      integer bi, bj
      integer myThid

#ifdef ALLOW_COST_TEST
C     == Local variables
      integer i, j
c      _RL i_numcells
      INTEGER  ILNBLNK
      EXTERNAL ILNBLNK
c      CHARACTER*(MAX_LEN_FNAM) STREAMICExvelOptimFile
c      CHARACTER*(MAX_LEN_FNAM) STREAMICEyvelOptimFile
c      _RL U_obs (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
c      _RL V_obs (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)

c      i_numcells = 1.0/(Nx*Ny)

c      STREAMICExvelOptimFile=
c     & STREAMICEvelOptimFile(1:
c     & ILNBLNK(STREAMICEvelOptimFile))//"u.bin"
c      STREAMICEyvelOptimFile=
c     & STREAMICEvelOptimFile(1:
c     & ILNBLNK(STREAMICEvelOptimFile))//"v.bin"

c      _BARRIER

c      CALL READ_FLD_XY_RS( STREAMICExvelOptimFile, ' ',
c     &      U_obs, 0, myThid )
c      CALL READ_FLD_XY_RS( STREAMICEyvelOptimFile, ' ',
c     &      V_obs, 0, myThid )

C--   Calculate mask for tracer cells  (0 => land, 1 => water)
c       k=1

C--   Calculate cost function on tile of this instance
      do bj = myByLo(myThid),myByHi(myThid)
        do bi = myBxLo(myThid),myBxHi(myThid)
          do j=1,sNy
            do i=1,sNx

            if (streamice_hmask(i,j,bi,bj).eq.1.0) then
             objf_test (bi,bj) = objf_test (bi,bj) +
     &       u_streamice(i,j,bi,bj)**2+v_streamice(i,j,bi,bj)**2+
     &       h_streamice(i,j,bi,bj)**2
            endif

            enddo
          enddo
        enddo
      enddo

#endif /* ALLOW_COST_TEST */

      RETURN
      END

#include "SHELFICE_OPTIONS.h"

CBOP
      SUBROUTINE SHELFICE_INIT_VARIA( myThid )
C     *============================================================*
C     | SUBROUTINE SHELFICE_INIT_VARIA
C     | o Routine to initialize SHELFICE variables.
C     *============================================================*
C     | Initialize SHELFICE parameters and variables.
C     *============================================================*
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "SHELFICE.h"
#ifdef ALLOW_COST
# include "SHELFICE_COST.h"
#endif /* ALLOW_COST */

C     === Routine arguments ===
C     myThid -  Number of this instance of SHELFICE_INIT_VARIA
      INTEGER myThid
CEndOfInterface

#ifdef ALLOW_SHELFICE
C     === Local variables ===
C     i,j,bi,bj - Loop counters
      INTEGER i, j, bi, bj
CEOP

      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
        DO j = 1-OLy, sNy+OLy
         DO i = 1-OLx, sNx+OLx
           shelficeForcingT      (i,j,bi,bj) = 0. _d 0
           shelficeForcingS      (i,j,bi,bj) = 0. _d 0
           shelficeHeatFlux      (i,j,bi,bj) = 0. _d 0
           shelficeFreshWaterFlux(i,j,bi,bj) = 0. _d 0
           shiTransCoeffT        (i,j,bi,bj) = 0. _d 0
           shiTransCoeffS        (i,j,bi,bj) = 0. _d 0
           shelficeMass          (i,j,bi,bj) = 0. _d 0
           shiCDragFld           (i,j,bi,bj) = 0. _d 0
           shiDragQuadFld        (i,j,bi,bj) = 0. _d 0
         ENDDO
        ENDDO
       ENDDO
      ENDDO
#ifdef ALLOW_AUTODIFF
C- Note: To simplify dependency & avoid recomputations, when compiling
C        pkg/autodiff, we always call SHELFICE_INIT_VARIA to initialise control
C        variables (as done above) without condition on useShelfIce.
C        Therefore, in this case, the "If useShelfIce" is added back here:
      IF ( useShelfIce ) THEN
#endif

      IF ( .NOT. SHELFICEuseGammaFrict ) THEN
       IF ( SHELFICETransCoeffTFile .NE. ' ' ) THEN
        CALL READ_FLD_XY_RL( SHELFICETransCoeffTFile, ' ',
     &                       shiTransCoeffT, 0, myThid )
        _EXCH_XY_RL( shiTransCoeffT, myThid )
        DO bj = myByLo(myThid), myByHi(myThid)
         DO bi = myBxLo(myThid), myBxHi(myThid)
          DO j = 1-OLy, sNy+OLy
           DO i = 1-OLx, sNx+OLx
            shiTransCoeffS(i,j,bi,bj) = SHELFICEsaltToHeatRatio *
     &                                  shiTransCoeffT(i,j,bi,bj)
           ENDDO
          ENDDO
         ENDDO
        ENDDO
       ELSE
C     set coefficients to constant values
        DO bj = myByLo(myThid), myByHi(myThid)
         DO bi = myBxLo(myThid), myBxHi(myThid)
          DO j = 1-OLy, sNy+OLy
           DO i = 1-OLx, sNx+OLx
            shiTransCoeffT(i,j,bi,bj) = SHELFICEheatTransCoeff
            shiTransCoeffS(i,j,bi,bj) = SHELFICEsaltTransCoeff
           ENDDO
          ENDDO
         ENDDO
        ENDDO
       ENDIF
      ENDIF
C     Update the spatially varying version of the drag coefficient
C     shiCDragFld used in shelfice_thermodynamics
C     shiCDragQuadFld used in shelfice_u/v_drag_coeff
      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
        DO j = 1-OLy, sNy+OLy
         DO i = 1-OLx, sNx+OLx
          shiCDragFld(i,j,bi,bj) = shiCDrag
          shiDragQuadFld(i,j,bi,bj) = SHELFICEDragQuadratic
         ENDDO
        ENDDO
       ENDDO
      ENDDO

      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
        DO j = 1-OLy, sNy+OLy
         DO i = 1-OLx, sNx+OLx
           shelficeMass(i,j,bi,bj) = shelficeMassInit(i,j,bi,bj)
         ENDDO
        ENDDO
       ENDDO
      ENDDO

      IF ( SHELFICEMassStepping .AND.
     &     ( nIter0.NE.0 .OR. startTime.NE.baseTime
     &                   .OR. pickupSuff.NE.' ') ) THEN
        CALL SHELFICE_READ_PICKUP( 1, nIter0, myThid )
      ENDIF

#ifdef ALLOW_SHELFICE_REMESHING
      IF ( SHI_update_kTopC ) THEN
C     set/update "kTopC" to agree with changing ice-shelf mass
        DO bj = myByLo(myThid), myByHi(myThid)
         DO bi = myBxLo(myThid), myBxHi(myThid)
          DO j = 1-OLy, sNy+OLy
           DO i = 1-OLx, sNx+OLx
             IF ( kSurfC(i,j,bi,bj).LE.Nr .AND.
     &            shelficeMass(i,j,bi,bj).GT.zeroRL ) THEN
               kTopC(i,j,bi,bj) = kSurfC(i,j,bi,bj)
             ELSE
               kTopC(i,j,bi,bj) = 0
             ENDIF
           ENDDO
          ENDDO
         ENDDO
        ENDDO
      ENDIF
#endif /* ALLOW_SHELFICE_REMESHING */

#ifdef ALLOW_COST
      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
         DO j = 1-OLy, sNy+OLy
          DO i = 1-OLx, sNx+OLx
           cMeanSHIforT (i,j,bi,bj) = 0. _d 0
           cMeanSHIforS (i,j,bi,bj) = 0. _d 0
          ENDDO
         ENDDO
       ENDDO
      ENDDO
c--
      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
         objf_shelfice(bi,bj) = 0. _d 0
         objf_shifwflx(bi,bj) = 0. _d 0
         num_shifwflx(bi,bj)  = 0. _d 0
       ENDDO
      ENDDO
#endif /* ALLOW_COST */

#ifdef ALLOW_AUTODIFF
C-    end if useShelfIce block
      ENDIF
#endif

#endif /* ALLOW_SHELFICE */

      RETURN
      END

#include "SEAICE_OPTIONS.h"
#ifdef ALLOW_OBCS
# include "OBCS_OPTIONS.h"
#else
# define OBCS_UVICE_OLD
#endif

CBOP
C     !ROUTINE: SEAICE_CALC_STRAINRATES
C     !INTERFACE:
      SUBROUTINE SEAICE_CALC_STRAINRATES(
     I     uFld, vFld,
     O     e11Loc, e22Loc, e12Loc,
     I     iStep, myTime, myIter, myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE  SEAICE_CALC_STRAINRATES
C     | o compute strain rates from ice velocities
C     *==========================================================*
C     | written by Martin Losch, Apr 2007
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "SEAICE_SIZE.h"
#include "SEAICE_PARAMS.h"
#include "SEAICE_GRID.h"
#include "SEAICE.h"

C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
C     uFld   :: ice velocity, u-component
C     vFld   :: ice velocity, v-component
C     e11Loc :: strain rate tensor, component 1,1
C     e22Loc :: strain rate tensor, component 2,2
C     e12Loc :: strain rate tensor, component 1,2
C     iStep  :: Sub-time-step number
C     myTime :: Simulation time
C     myIter :: Simulation timestep number
C     myThid :: My Thread Id. number
      _RL uFld   (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL vFld   (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL e11Loc (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL e22Loc (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL e12Loc (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      INTEGER iStep
      _RL     myTime
      INTEGER myIter
      INTEGER myThid
CEOP

#ifdef SEAICE_CGRID
C     !LOCAL VARIABLES:
C     === Local variables ===
C     i,j,bi,bj :: Loop counters
      INTEGER i, j, bi, bj
C     hFacU, hFacV :: determine the no-slip boundary condition
      _RS hFacU, hFacV, noSlipFac
      _RL third
      PARAMETER ( third = 0.333333333333333333333333333 _d 0 )
C     auxillary variables that help writing code that
C     vectorizes even after TAFization
      _RL dudx (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL dvdy (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL dudy (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL dvdx (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL uave (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL vave (1-OLx:sNx+OLx,1-OLy:sNy+OLy)

      noSlipFac = 0. _d 0
      IF ( SEAICE_no_slip ) noSlipFac = 1. _d 0
C     in order repoduce results before fixing a bug in r1.20 comment out
C     the following line
CML      IF ( SEAICE_no_slip ) noSlipFac = 2. _d 0
C
      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
C     abbreviations on C-points, need to do them in separate loops
C     for vectorization
        DO j=1-OLy,sNy+OLy-1
         DO i=1-OLx,sNx+OLx-1
          dudx(i,j) = _recip_dxF(i,j,bi,bj) *
     &         (uFld(i+1,j,bi,bj)-uFld(i,j,bi,bj))
          uave(i,j) = 0.5 _d 0 * (uFld(i,j,bi,bj)+uFld(i+1,j,bi,bj))
         ENDDO
        ENDDO
        DO j=1-OLy,sNy+OLy-1
         DO i=1-OLx,sNx+OLx-1
          dvdy(i,j) = _recip_dyF(i,j,bi,bj) *
     &         (vFld(i,j+1,bi,bj)-vFld(i,j,bi,bj))
          vave(i,j) = 0.5 _d 0 * (vFld(i,j,bi,bj)+vFld(i,j+1,bi,bj))
         ENDDO
        ENDDO
C     evaluate strain rates at C-points
        DO j=1-OLy,sNy+OLy-1
         DO i=1-OLx,sNx+OLx-1
          e11Loc(i,j,bi,bj) = dudx(i,j) + vave(i,j) * k2AtC(i,j,bi,bj)
          e22Loc(i,j,bi,bj) = dvdy(i,j) + uave(i,j) * k1AtC(i,j,bi,bj)
         ENDDO
        ENDDO
#ifndef OBCS_UVICE_OLD
C--     for OBCS: assume no gradient beyong OB
        DO j=1-OLy,sNy+OLy-1
         DO i=1-OLx,sNx+OLx-1
          e11Loc(i,j,bi,bj) = e11Loc(i,j,bi,bj)*maskInC(i,j,bi,bj)
          e22Loc(i,j,bi,bj) = e22Loc(i,j,bi,bj)*maskInC(i,j,bi,bj)
         ENDDO
        ENDDO
#endif /* OBCS_UVICE_OLD */

C     abbreviations at Z-points, need to do them in separate loops
C     for vectorization
        DO j=1-OLy+1,sNy+OLy
         DO i=1-OLx+1,sNx+OLx
          dudy(i,j) = ( uFld(i,j,bi,bj) - uFld(i  ,j-1,bi,bj) )
     &         * _recip_dyU(i,j,bi,bj)
          uave(i,j) = 0.5 _d 0 * (uFld(i,j,bi,bj)+uFld(i  ,j-1,bi,bj))
         ENDDO
        ENDDO
        DO j=1-OLy+1,sNy+OLy
         DO i=1-OLx+1,sNx+OLx
          dvdx(i,j) = ( vFld(i,j,bi,bj) - vFld(i-1,j  ,bi,bj) )
     &         * _recip_dxV(i,j,bi,bj)
          vave(i,j) = 0.5 _d 0 * (vFld(i,j,bi,bj)+vFld(i-1,j  ,bi,bj))
         ENDDO
        ENDDO
C     evaluate strain rates at Z-points
        DO j=1-OLy+1,sNy+OLy
         DO i=1-OLx+1,sNx+OLx
          hFacU = SIMaskU(i,j,bi,bj) - SIMaskU(i,j-1,bi,bj)
          hFacV = SIMaskV(i,j,bi,bj) - SIMaskV(i-1,j,bi,bj)
          e12Loc(i,j,bi,bj) = 0.5 _d 0 * (
     &         dudy(i,j) + dvdx(i,j)
     &         - k1AtZ(i,j,bi,bj) * vave(i,j)
     &         - k2AtZ(i,j,bi,bj) * uave(i,j)
     &         )
     &         *HEFFM(i  ,j  ,bi,bj)*HEFFM(i-1,j  ,bi,bj)
     &         *HEFFM(i  ,j-1,bi,bj)*HEFFM(i-1,j-1,bi,bj)
     &         + noSlipFac * (
     &           2.0 _d 0 * uave(i,j) * _recip_dyU(i,j,bi,bj) * hFacU
     &         + 2.0 _d 0 * vave(i,j) * _recip_dxV(i,j,bi,bj) * hFacV
     &         )
C     no slip at the boundary implies u(j)+u(j-1)=0 and v(i)+v(i-1)=0
C     accross the boundary; this is already accomplished by masking so
C     that the following lines are not necessary
c$$$     &         - hFacV * k1AtZ(i,j,bi,bj) * vave(i,j)
c$$$     &         - hFacU * k2AtZ(i,j,bi,bj) * uave(i,j)
         ENDDO
        ENDDO
        IF ( SEAICE_no_slip .AND. SEAICE_2ndOrderBC ) THEN
         DO j=1-OLy+2,sNy+OLy-1
          DO i=1-OLx+2,sNx+OLx-1
           hFacU = (SIMaskU(i,j,bi,bj) - SIMaskU(i,j-1,bi,bj))*third
           hFacV = (SIMaskV(i,j,bi,bj) - SIMaskV(i-1,j,bi,bj))*third
           hFacU = hFacU*( SIMaskU(i,j-2,bi,bj)*SIMaskU(i,j-1,bi,bj)
     &                   + SIMaskU(i,j+1,bi,bj)*SIMaskU(i,j,  bi,bj) )
           hFacV = hFacV*( SIMaskV(i-2,j,bi,bj)*SIMaskV(i-1,j,bi,bj)
     &                   + SIMaskV(i+1,j,bi,bj)*SIMaskV(i  ,j,bi,bj) )
C     right hand sided dv/dx = (9*v(i,j)-v(i+1,j))/(4*dxv(i,j)-dxv(i+1,j))
C     according to a Taylor expansion to 2nd order. We assume that dxv
C     varies very slowly, so that the denominator simplifies to 3*dxv(i,j),
C     then dv/dx = (6*v(i,j)+3*v(i,j)-v(i+1,j))/(3*dxv(i,j))
C                = 2*v(i,j)/dxv(i,j) + (3*v(i,j)-v(i+1,j))/(3*dxv(i,j))
C     the left hand sided dv/dx is analogously
C                = - 2*v(i-1,j)/dxv(i,j) - (3*v(i-1,j)-v(i-2,j))/(3*dxv(i,j))
C     the first term is the first order part, which is already added.
C     For e12 we only need 0.5 of this gradient and vave = is either
C     0.5*v(i,j) or 0.5*v(i-1,j) near the boundary so that we need an
C     extra factor of 2. This explains the six. du/dy is analogous.
C     The masking is ugly, but hopefully effective.
           e12Loc(i,j,bi,bj) = e12Loc(i,j,bi,bj) + 0.5 _d 0 * (
     &            _recip_dyU(i,j,bi,bj) * ( 6.0 _d 0 * uave(i,j)
     &          - uFld(i,j-2,bi,bj)*SIMaskU(i,j-1,bi,bj)
     &          - uFld(i,j+1,bi,bj)*SIMaskU(i,j  ,bi,bj) ) * hFacU
     &          + _recip_dxV(i,j,bi,bj) * ( 6.0 _d 0 * vave(i,j)
     &          - vFld(i-2,j,bi,bj)*SIMaskV(i-1,j,bi,bj)
     &          - vFld(i+1,j,bi,bj)*SIMaskV(i  ,j,bi,bj) ) * hFacV
     &          )
          ENDDO
         ENDDO
        ENDIF
       ENDDO
      ENDDO

#ifdef ALLOW_AUTODIFF
#ifdef SEAICE_DYN_STABLE_ADJOINT
cgf zero out adjoint fields to stabilize pkg/seaice dyna. adjoint
      CALL ZERO_ADJ( 1, e11Loc, myThid)
      CALL ZERO_ADJ( 1, e12Loc, myThid)
      CALL ZERO_ADJ( 1, e22Loc, myThid)
#endif
#endif /* ALLOW_AUTODIFF */

#endif /* SEAICE_CGRID */
      RETURN
      END

#include "MYPACKAGE_OPTIONS.h"
C--  File mypackage_tendency_apply.F: Routines to apply MYPACKAGE tendencies
C--   Contents
C--   o MYPACKAGE_TENDENCY_APPLY_U
C--   o MYPACKAGE_TENDENCY_APPLY_V
C--   o MYPACKAGE_TENDENCY_APPLY_T
C--   o MYPACKAGE_TENDENCY_APPLY_S

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C !ROUTINE: MYPACKAGE_TENDENCY_APPLY_U

C !INTERFACE:
      SUBROUTINE MYPACKAGE_TENDENCY_APPLY_U(
     U                     gU_arr,
     I                     iMin,iMax,jMin,jMax, k, bi, bj,
     I                     myTime, myIter, myThid )

C     !DESCRIPTION:
C     Add mypackage tendency terms to U tendency.  Routine works for one
C     level at a time. Assumes that U and V tendencies are on C-Grid or
C     on A-grid.

C     !USES:
      IMPLICIT NONE
C     == Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "GRID.h"
c#include "DYNVARS.h"
#include "MYPACKAGE.h"

C     !INPUT/OUTPUT PARAMETERS:
C     gU_arr    :: the tendency array
C     iMin,iMax :: Working range of x-index for applying forcing.
C     jMin,jMax :: Working range of y-index for applying forcing.
C     k         :: Current vertical level index
C     bi,bj     :: Current tile indices
C     myTime    :: Current time in simulation
C     myIter    :: Current iteration number
C     myThid    :: my Thread Id number
      _RL     gU_arr(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER iMin, iMax, jMin, jMax
      INTEGER k, bi, bj
      _RL     myTime
      INTEGER myIter
      INTEGER myThid
CEOP

#ifdef MYPACKAGE_TENDENCY
C     !LOCAL VARIABLES:
      INTEGER i, j

      IF ( myPa_applyTendU .AND. myPa_Tend_Cgrid ) THEN
        DO j=jMin,jMax
         DO i=iMin,iMax
          gU_arr(i,j) = gU_arr(i,j)
     &     + maskW(i,j,k,bi,bj) * myPa_TendVelU(i,j,k,bi,bj)
         ENDDO
        ENDDO
      ELSEIF ( myPa_applyTendU ) THEN
C--   Assume Agrid position:
        DO j=jMin,jMax
         DO i=iMin,iMax
          gU_arr(i,j) = gU_arr(i,j)
     &     + maskW(i,j,k,bi,bj)*( myPa_TendVelU(i-1,j,k,bi,bj)
     &                           +myPa_TendVelU( i ,j,k,bi,bj)
     &                          )*0.5 _d 0
         ENDDO
        ENDDO
      ENDIF

#endif /* MYPACKAGE_TENDENCY */

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C !ROUTINE: MYPACKAGE_TENDENCY_APPLY_V

C !INTERFACE:
      SUBROUTINE MYPACKAGE_TENDENCY_APPLY_V(
     U                     gV_arr,
     I                     iMin,iMax,jMin,jMax, k, bi, bj,
     I                     myTime, myIter, myThid )

C     !DESCRIPTION:
C     Add mypackage tendency terms to V tendency.  Routine works for one
C     level at a time. Assumes that U and V tendencies are on C-Grid or
C     on A-grid.

C     !USES:
      IMPLICIT NONE
C     == Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "GRID.h"
c#include "DYNVARS.h"
#include "MYPACKAGE.h"

C     !INPUT/OUTPUT PARAMETERS:
C     gV_arr    :: the tendency array
C     iMin,iMax :: Working range of x-index for applying forcing.
C     jMin,jMax :: Working range of y-index for applying forcing.
C     k         :: Current vertical level index
C     bi,bj     :: Current tile indices
C     myTime    :: Current time in simulation
C     myIter    :: Current iteration number
C     myThid    :: my Thread Id number
      _RL     gV_arr(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER iMin, iMax, jMin, jMax
      INTEGER k, bi, bj
      _RL     myTime
      INTEGER myIter
      INTEGER myThid
CEOP

#ifdef MYPACKAGE_TENDENCY
C     !LOCAL VARIABLES:
      INTEGER i, j

      IF ( myPa_applyTendV .AND. myPa_Tend_Cgrid ) THEN
        DO j=jMin,jMax
         DO i=iMin,iMax
          gV_arr(i,j) = gV_arr(i,j)
     &     + maskS(i,j,k,bi,bj) * myPa_TendVelV(i,j,k,bi,bj)
         ENDDO
        ENDDO
      ELSEIF ( myPa_applyTendV ) THEN
C--   Assume Agrid position:
        DO j=jMin,jMax
         DO i=iMin,iMax
          gV_arr(i,j) = gV_arr(i,j)
     &     + maskS(i,j,k,bi,bj)*( myPa_TendVelV(i,j-1,k,bi,bj)
     &                           +myPa_TendVelV(i, j ,k,bi,bj)
     &                          )*0.5 _d 0
         ENDDO
        ENDDO
      ENDIF

#endif /* MYPACKAGE_TENDENCY */

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C !ROUTINE: MYPACKAGE_TENDENCY_APPLY_T

C !INTERFACE:
      SUBROUTINE MYPACKAGE_TENDENCY_APPLY_T(
     U                     gT_arr,
     I                     iMin,iMax,jMin,jMax, k, bi, bj,
     I                     myTime, myIter, myThid )

C     !DESCRIPTION:
C     Add mypackage tendency terms to T (theta) tendency.  Routine works
C     for one level at a time

C     !USES:
      IMPLICIT NONE
C     == Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "GRID.h"
c#include "DYNVARS.h"
#include "MYPACKAGE.h"

C     !INPUT/OUTPUT PARAMETERS:
C     gT_arr    :: the tendency array
C     iMin,iMax :: Working range of x-index for applying forcing.
C     jMin,jMax :: Working range of y-index for applying forcing.
C     k         :: Current vertical level index
C     bi,bj     :: Current tile indices
C     myTime    :: Current time in simulation
C     myIter    :: Current iteration number
C     myThid    :: my Thread Id number
      _RL     gT_arr(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER iMin, iMax, jMin, jMax
      INTEGER k, bi, bj
      _RL     myTime
      INTEGER myIter
      INTEGER myThid
CEOP

#ifdef MYPACKAGE_TENDENCY
C     !LOCAL VARIABLES:
      INTEGER i, j

      IF ( myPa_applyTendT ) THEN
        DO j=jMin,jMax
         DO i=iMin,iMax
          gT_arr(i,j) = gT_arr(i,j)
     &     + maskC(i,j,k,bi,bj) * myPa_TendScal1(i,j,k,bi,bj)
         ENDDO
        ENDDO
      ENDIF

#endif /* MYPACKAGE_TENDENCY */

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C !ROUTINE: MYPACKAGE_TENDENCY_APPLY_S

C !INTERFACE:
      SUBROUTINE MYPACKAGE_TENDENCY_APPLY_S(
     U                     gS_arr,
     I                     iMin,iMax,jMin,jMax, k, bi, bj,
     I                     myTime, myIter, myThid )

C     !DESCRIPTION:
C     Add mypackage tendency terms to S tendency.  Routine works for one
C     level at a time

C     !USES:
      IMPLICIT NONE
C     == Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "GRID.h"
c#include "DYNVARS.h"
#include "MYPACKAGE.h"

C     !INPUT/OUTPUT PARAMETERS:
C     gS_arr    :: the tendency array
C     iMin,iMax :: Working range of x-index for applying forcing.
C     jMin,jMax :: Working range of y-index for applying forcing.
C     k         :: Current vertical level index
C     bi,bj     :: Current tile indices
C     myTime    :: Current time in simulation
C     myIter    :: Current iteration number
C     myThid    :: my Thread Id number
      _RL     gS_arr(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER iMin, iMax, jMin, jMax
      INTEGER k, bi, bj
      _RL     myTime
      INTEGER myIter
      INTEGER myThid
CEOP

#ifdef MYPACKAGE_TENDENCY
C     !LOCAL VARIABLES:
      INTEGER i, j

      IF ( myPa_applyTendS ) THEN
        DO j=jMin,jMax
         DO i=iMin,iMax
          gS_arr(i,j) = gS_arr(i,j)
     &     + maskC(i,j,k,bi,bj) * myPa_TendScal2(i,j,k,bi,bj)
         ENDDO
        ENDDO
      ENDIF

#endif /* MYPACKAGE_TENDENCY */

      RETURN
      END

#include "ECCO_OPTIONS.h"
#ifdef ALLOW_SEAICE
# include "SEAICE_OPTIONS.h"
#endif
#ifdef ALLOW_EXF
# include "EXF_OPTIONS.h"
#endif
#ifdef ALLOW_CTRL
# include "CTRL_OPTIONS.h"
#endif
#ifdef ALLOW_GMREDI
# include "GMREDI_OPTIONS.h"
#endif

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C !ROUTINE: COST_GENCOST_CUSTOMIZE

C !INTERFACE:
      SUBROUTINE COST_GENCOST_CUSTOMIZE( myThid )

C     !DESCRIPTION:
C     Customize various costs

C     !USES:
      IMPLICIT NONE
C     == Global variables ===
#include "EEPARAMS.h"
#include "SIZE.h"
#include "GRID.h"
#include "PARAMS.h"
#include "DYNVARS.h"
#include "FFIELDS.h"
#ifdef ALLOW_ECCO
# include "ECCO_SIZE.h"
# include "ECCO.h"
#endif
#ifdef ALLOW_SEAICE
#  include "SEAICE_SIZE.h"
#  include "SEAICE.h"
#endif
#ifdef ALLOW_EXF
# include "EXF_FIELDS.h"
#endif
#ifdef ALLOW_CTRL
# include "CTRL_FIELDS.h"
#endif
#ifdef ALLOW_GMREDI
# include "GMREDI.h"
#endif
#ifdef ALLOW_PTRACERS
# include "PTRACERS_SIZE.h"
# include "PTRACERS_FIELDS.h"
#endif

C !INPUT PARAMETERS: ===================================================
C myThid    :: my Thread Id number
      INTEGER myThid

C !OUTPUT PARAMETERS: ==================================================

#ifdef ALLOW_GENCOST_CONTRIBUTION
C !LOCAL VARIABLES: ====================================================
      INTEGER bi,bj
      INTEGER i,j,k
#ifdef ALLOW_GENCOST3D
      INTEGER k2,kk
      INTEGER itr
#endif
      INTEGER kLev
#ifdef ALLOW_EXF
      _RL uBarC, vBarC
      _RL zontau  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL mertau  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL zonwind (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL merwind (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
#endif
      INTEGER jMin,jMax
      INTEGER iMin,iMax
CEOP

      jMin = 1
      jMax = sNy
      iMin = 1
      iMax = sNx

#ifdef ALLOW_EXF
c rotated to EW/NS tracer point
        do bj = myByLo(myThid),myByHi(myThid)
          do bi = myBxLo(myThid),myBxHi(myThid)
            do j = jMin,jMax
              do i = iMin,iMax
                uBarC = 0.5 _d 0
     &           *(ustress(i,j,bi,bj)+ustress(i+1,j,bi,bj))
                vBarC = 0.5 _d 0
     &           *(vstress(i,j,bi,bj)+vstress(i,j+1,bi,bj))
                zontau(i,j,bi,bj) = angleCosC(i,j,bi,bj)*uBarC
     &                           -angleSinC(i,j,bi,bj)*vBarC
                mertau(i,j,bi,bj) = angleSinC(i,j,bi,bj)*uBarC
     &                           +angleCosC(i,j,bi,bj)*vBarC
              enddo
            enddo
          enddo
        enddo

c the following should be identical to the above
c     CALL ROTATE_UV2EN_RL(ustress,vstress,zontau,mertau,
c    &     .TRUE.,.TRUE.,.TRUE.,1,myThid)

      CALL ROTATE_UV2EN_RL(uwind,vwind,zonwind,merwind,
     &     .TRUE.,.FALSE.,.TRUE.,1,myThid)
#endif

      do k=1,NGENCOST
      itr=gencost_itracer(k)
      kLev = MAX( 1, MIN( Nr, gencost_kLev_select(k) ) )
      do bj = myByLo(myThid),myByHi(myThid)
       do bi = myBxLo(myThid),myBxHi(myThid)
        do j = jMin,jMax
         do i =  iMin,iMax

         if (gencost_barfile(k)(1:5).EQ.'m_eta' .and.
     &       gencost_barfile(k)(1:9).NE.'m_eta_dyn') then
           gencost_modfld(i,j,bi,bj,k) =
     &      m_eta(i,j,bi,bj)*maskC(i,j,1,bi,bj)
         elseif (gencost_barfile(k)(1:9).EQ.'m_boxmean') then
           gencost_modfld(i,j,bi,bj,k) =
     &      gencost_storefld(i,j,bi,bj,k)
         elseif (gencost_barfile(k)(1:9).EQ.'m_horflux') then
           gencost_modfld(i,j,bi,bj,k) =
     &      gencost_storefld(i,j,bi,bj,k)
         elseif (gencost_barfile(k)(1:5).EQ.'m_sst') then
           gencost_modfld(i,j,bi,bj,k) =
     &      THETA(i,j,1,bi,bj)*maskC(i,j,1,bi,bj)
         elseif (gencost_barfile(k)(1:5).EQ.'m_sss') then
           gencost_modfld(i,j,bi,bj,k) =
     &      SALT(i,j,1,bi,bj)*maskC(i,j,1,bi,bj)
         elseif (gencost_barfile(k)(1:11).EQ.'m_drifterUE') then
           gencost_modfld(i,j,bi,bj,k) =
     &      m_UE(i,j,kLev,bi,bj)*maskC(i,j,kLev,bi,bj)
         elseif (gencost_barfile(k)(1:11).EQ.'m_drifterVN') then
           gencost_modfld(i,j,bi,bj,k) =
     &      m_VN(i,j,kLev,bi,bj)*maskC(i,j,kLev,bi,bj)
         elseif (gencost_barfile(k)(1:4).EQ.'m_bp' .and.
     &           gencost_barfile(k)(1:12).NE.'m_bp_nopabar') then
           gencost_modfld(i,j,bi,bj,k) =
     &      m_bp(i,j,bi,bj)*maskC(i,j,1,bi,bj)
#ifdef ATMOSPHERIC_LOADING
#ifdef ALLOW_IB_CORR
         elseif (gencost_barfile(k)(1:9).EQ.'m_eta_dyn') then
           gencost_modfld(i,j,bi,bj,k) =
     &      m_eta_dyn(i,j,bi,bj)*maskC(i,j,1,bi,bj)
         elseif (gencost_barfile(k)(1:12).EQ.'m_bp_nopabar') then
           gencost_modfld(i,j,bi,bj,k) =
     &      m_bp_nopabar(i,j,bi,bj)*maskC(i,j,1,bi,bj)
#endif
#endif
#ifdef ALLOW_GEOTHERMAL_FLUX
         elseif (gencost_barfile(k)(1:16).EQ.'m_geothermalflux') then
           gencost_modfld(i,j,bi,bj,k) =
     &      geothermalFlux(i,j,bi,bj)*maskC(i,j,1,bi,bj)
#endif
#ifdef ALLOW_EXF
         elseif (gencost_barfile(k)(1:9).EQ.'m_ustress') then
           gencost_modfld(i,j,bi,bj,k) =
     &      zontau(i,j,bi,bj)*maskC(i,j,1,bi,bj)
         elseif (gencost_barfile(k)(1:9).EQ.'m_vstress') then
           gencost_modfld(i,j,bi,bj,k) =
     &      mertau(i,j,bi,bj)*maskC(i,j,1,bi,bj)
         elseif (gencost_barfile(k)(1:7).EQ.'m_uwind') then
           gencost_modfld(i,j,bi,bj,k) =
     &      zonwind(i,j,bi,bj)*maskC(i,j,1,bi,bj)
         elseif (gencost_barfile(k)(1:7).EQ.'m_vwind') then
           gencost_modfld(i,j,bi,bj,k) =
     &      merwind(i,j,bi,bj)*maskC(i,j,1,bi,bj)
#ifdef ALLOW_ATM_TEMP
         elseif (gencost_barfile(k)(1:7).EQ.'m_atemp') then
           gencost_modfld(i,j,bi,bj,k) =
     &      atemp(i,j,bi,bj)*maskC(i,j,1,bi,bj)
         elseif (gencost_barfile(k)(1:5).EQ.'m_aqh') then
           gencost_modfld(i,j,bi,bj,k) =
     &      aqh(i,j,bi,bj)*maskC(i,j,1,bi,bj)
         elseif (gencost_barfile(k)(1:8).EQ.'m_precip') then
           gencost_modfld(i,j,bi,bj,k) =
     &      precip(i,j,bi,bj)*maskC(i,j,1,bi,bj)
#endif
#ifdef ALLOW_DOWNWARD_RADIATION
         elseif (gencost_barfile(k)(1:8).EQ.'m_swdown') then
           gencost_modfld(i,j,bi,bj,k) =
     &      swdown(i,j,bi,bj)*maskC(i,j,1,bi,bj)
         elseif (gencost_barfile(k)(1:8).EQ.'m_lwdown') then
           gencost_modfld(i,j,bi,bj,k) =
     &      lwdown(i,j,bi,bj)*maskC(i,j,1,bi,bj)
#endif
         elseif (gencost_barfile(k)(1:8).EQ.'m_wspeed') then
           gencost_modfld(i,j,bi,bj,k) =
     &      wspeed(i,j,bi,bj)*maskC(i,j,1,bi,bj)
#endif /* ALLOW_EXF */
#ifdef ALLOW_CTRL
#ifdef ALLOW_BOTTOMDRAG_CONTROL
         elseif (gencost_barfile(k)(1:12).EQ.'m_bottomdrag') then
           gencost_modfld(i,j,bi,bj,k) =
     &      bottomDragFld(i,j,bi,bj)*maskC(i,j,1,bi,bj)
#endif
#endif
#ifdef ALLOW_SEAICE
         elseif ( (gencost_name(k).EQ.'siv4-conc').OR.
     &            (gencost_barfile(k)(1:8).EQ.'m_siarea') ) then
           gencost_modfld(i,j,bi,bj,k) =
     &      area(i,j,bi,bj)*maskC(i,j,1,bi,bj)
         elseif (gencost_name(k).EQ.'siv4-deconc') then
           gencost_modfld(i,j,bi,bj,k) =
     &      theta(i,j,1,bi,bj)*maskC(i,j,1,bi,bj)
         elseif ( (gencost_name(k).EQ.'siv4-exconc').OR.
     &            (gencost_barfile(k)(1:8).EQ.'m_siheff') ) then
           gencost_modfld(i,j,bi,bj,k) =
     &      heff(i,j,bi,bj)*maskC(i,j,1,bi,bj)
         elseif (gencost_barfile(k)(1:9).EQ.'m_sihsnow') then
           gencost_modfld(i,j,bi,bj,k) =
     &      hsnow(i,j,bi,bj)*maskC(i,j,1,bi,bj)
         elseif (gencost_barfile(k)(1:11).EQ.'m_freeboard') then
           gencost_modfld(i,j,bi,bj,k) =
     &      gencost_storefld(i,j,bi,bj,k)*maskC(i,j,1,bi,bj)
#endif
#ifdef ALLOW_GENCOST3D
         elseif (gencost_barfile(k)(1:7).EQ.'m_theta') then
           kk=gencost_pointer3d(k)
           do k2=1,Nr
            gencost_mod3d(i,j,k2,bi,bj,kk) =
     &       theta(i,j,k2,bi,bj)*maskC(i,j,k2,bi,bj)
           enddo
         elseif (gencost_barfile(k)(1:6).EQ.'m_salt') then
           kk=gencost_pointer3d(k)
           do k2=1,Nr
            gencost_mod3d(i,j,k2,bi,bj,kk) =
     &       salt(i,j,k2,bi,bj)*maskC(i,j,k2,bi,bj)
           enddo
#ifdef ALLOW_PTRACERS
         elseif (gencost_barfile(k)(1:9).EQ.'m_ptracer') then
           kk=gencost_pointer3d(k)
           do k2=1,Nr
            gencost_mod3d(i,j,k2,bi,bj,kk) =
     &       pTracer(i,j,k2,bi,bj,itr)*maskC(i,j,k2,bi,bj)
           enddo
#endif
         elseif (gencost_barfile(k)(1:4).EQ.'m_UE') then
           kk=gencost_pointer3d(k)
           do k2=1,Nr
            gencost_mod3d(i,j,k2,bi,bj,kk) =
     &       m_UE(i,j,k2,bi,bj)*maskC(i,j,k2,bi,bj)
           enddo
         elseif (gencost_barfile(k)(1:4).EQ.'m_VN') then
           kk=gencost_pointer3d(k)
           do k2=1,Nr
            gencost_mod3d(i,j,k2,bi,bj,kk) =
     &       m_VN(i,j,k2,bi,bj)*maskC(i,j,k2,bi,bj)
           enddo
         elseif (gencost_barfile(k)(1:7).EQ.'m_trVol') then
           kk=gencost_pointer3d(k)
           do k2=1,Nr
             gencost_mod3d(i,j,k2,bi,bj,kk) = trVol(i,j,k2,bi,bj)
           enddo
         elseif (gencost_barfile(k)(1:8).EQ.'m_trHeat') then
           kk=gencost_pointer3d(k)
           do k2=1,Nr
             gencost_mod3d(i,j,k2,bi,bj,kk) = trHeat(i,j,k2,bi,bj)
           enddo
         elseif (gencost_barfile(k)(1:8).EQ.'m_trSalt') then
           kk=gencost_pointer3d(k)
           do k2=1,Nr
             gencost_mod3d(i,j,k2,bi,bj,kk) = trSalt(i,j,k2,bi,bj)
           enddo
#if (defined (ALLOW_3D_DIFFKR) || defined (ALLOW_DIFFKR_CONTROL))
         elseif (gencost_barfile(k)(1:8).EQ.'m_diffkr') then
           kk=gencost_pointer3d(k)
           do k2=1,Nr
            gencost_mod3d(i,j,k2,bi,bj,kk) =
     &       diffkr(i,j,k2,bi,bj)*maskC(i,j,k2,bi,bj)
           enddo
#endif
#ifdef ALLOW_CTRL
#if ( defined ALLOW_KAPGM_CONTROL && defined GM_READ_K3D_GM )
         elseif (gencost_barfile(k)(1:7).EQ.'m_kapgm') then
           kk=gencost_pointer3d(k)
           do k2=1,Nr
            gencost_mod3d(i,j,k2,bi,bj,kk) =
     &       GM_inpK3dGM(i,j,k2,bi,bj)*maskC(i,j,k2,bi,bj)
           enddo
#endif
#if ( defined ALLOW_KAPREDI_CONTROL && defined GM_READ_K3D_REDI )
         elseif (gencost_barfile(k)(1:9).EQ.'m_kapredi') then
           kk=gencost_pointer3d(k)
           do k2=1,Nr
            gencost_mod3d(i,j,k2,bi,bj,kk) =
     &       GM_inpK3dRedi(i,j,k2,bi,bj)*maskC(i,j,k2,bi,bj)
           enddo
#endif
#endif
#endif /* ALLOW_GENCOST3D */
         endif

         enddo
        enddo
       enddo
      enddo
      enddo

#endif /* ALLOW_GENCOST_CONTRIBUTION */

      RETURN
      END

#include "THSICE_OPTIONS.h"
#ifdef ALLOW_AUTODIFF
# include "AUTODIFF_OPTIONS.h"
#endif

CBOP
C     !ROUTINE: THSICE_EXTEND
C     !INTERFACE:
      SUBROUTINE THSICE_EXTEND(
     I                  bi, bj,
     I                  iMin,iMax, jMin,jMax, dBugFlag,
     I                  fzMlOc, tFrz, tOce,
     U                  icFrac, hIce, hSnow,
     U                  tSrf, tIc1, tIc2, qIc1, qIc2,
     O                  flx2oc, frw2oc, fsalt,
     I                  myTime, myIter, myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R  THSICE_EXTEND
C     | o Extend sea-ice area incresing ice fraction
C     *==========================================================*
C     | o incorporate surplus of energy to
C     |   make new ice or make ice grow laterally
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     == Global variables ==
#include "EEPARAMS.h"
#include "SIZE.h"
#include "THSICE_SIZE.h"
#include "THSICE_PARAMS.h"
#ifdef ALLOW_AUTODIFF_TAMC
# include "tamc.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine Arguments ==
C     bi,bj       :: tile indices
C     iMin,iMax   :: computation domain: 1rst index range
C     jMin,jMax   :: computation domain: 2nd  index range
C     dBugFlag    :: allow to print debugging stuff (e.g. on 1 grid point).
C---  Input:
C         iceMask :: sea-ice fractional mask [0-1]
C  fzMlOc (esurp) :: ocean mixed-layer freezing/melting potential [W/m2]
C  tFrz    (Tf)   :: sea-water freezing temperature [oC] (function of S)
C  tOce           :: surface level oceanic temperature [oC]
C---  Modified (input&output):
C  icFrac(iceFrac):: fraction of grid area covered in ice
C  hIce (iceThick):: ice height [m]
C  hSnow          :: snow height [m]
C  tSrf           :: surface (ice or snow) temperature [oC]
C  tIc1           :: temperature of ice layer 1 [oC]
C  tIc2           :: temperature of ice layer 2 [oC]
C  qIc1   (qicen) :: ice enthalpy (J/kg), 1rst level
C  qIc2   (qicen) :: ice enthalpy (J/kg), 2nd level
C---  Output
C  flx2oc   (=)   :: (additional) heat flux to ocean    [W/m2]        (+=dwn)
C  frw2oc   (=)   :: (additional) fresh water flux to ocean [kg/m2/s] (+=dwn)
C  fsalt    (=)   :: (additional) salt flux to ocean        [g/m2/s]  (+=dwn)
C---  Input:
C     myTime      :: current Time of simulation [s]
C     myIter      :: current Iteration number in simulation
C     myThid      :: my Thread Id number
      INTEGER bi,bj
      INTEGER iMin, iMax
      INTEGER jMin, jMax
      LOGICAL dBugFlag
c     _RL iceMask(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL fzMlOc (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL tFrz   (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL tOce   (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL icFrac (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL hIce   (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL hSnow  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL tSrf   (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL tIc1   (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL tIc2   (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL qIc1   (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL qIc2   (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL flx2oc (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL frw2oc (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL fsalt  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL  myTime
      INTEGER myIter
      INTEGER myThid
CEOP

#ifdef ALLOW_THSICE
C     !LOCAL VARIABLES:
C---  local copy of input/output argument list variables (see description above)
      _RL esurp
      _RL Tf
      _RL iceFrac
      _RL iceThick
      _RL qicen(nlyr)

C     == Local variables ==
C     iceVol    :: previous ice volume
C     newIce    :: new ice volume to produce
C     hNewIce   :: thickness of new ice to form
C     iceFormed :: ice-volume formed (new ice volume = iceVol+iceFormed )
C     qicAv     :: mean enthalpy of ice (layer 1 & 2) [J/m^3]
      _RL deltaTice ! time-step for ice model
      _RL iceVol
      _RL newIce
      _RL hNewIce
      _RL iceFormed
      _RL qicAv
      INTEGER  i,j     ! loop indices

#ifdef ALLOW_AUTODIFF_TAMC
C     tkey :: tape key (depends on tiles)
      INTEGER tkey
#endif
C-    define grid-point location where to print debugging values
#include "THSICE_DEBUG.h"

#ifdef ALLOW_DBUG_THSICE
 1020 FORMAT(A,1P4E11.3)
#endif

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      deltaTice = thSIce_deltaT

#ifdef ALLOW_AUTODIFF
      DO j = 1-OLy, sNy+OLy
       DO i = 1-OLx, sNx+OLx
         flx2oc(i,j) = 0. _d 0
         frw2oc(i,j) = 0. _d 0
         fsalt (i,j) = 0. _d 0
       ENDDO
      ENDDO
#endif /* ALLOW_AUTODIFF */

#ifdef ALLOW_AUTODIFF_TAMC
      tkey = bi + (bj-1)*nSx + (ikey_dynamics-1)*nSx*nSy
CADJ STORE hIce   = comlev1_bibj, key = tkey, kind = isbyte
CADJ STORE hSnow  = comlev1_bibj, key = tkey, kind = isbyte
CADJ STORE icFrac = comlev1_bibj, key = tkey, kind = isbyte
CADJ STORE qIc1   = comlev1_bibj, key = tkey, kind = isbyte
CADJ STORE qIc2   = comlev1_bibj, key = tkey, kind = isbyte
#endif
      DO j = jMin, jMax
       DO i = iMin, iMax

        IF (fzMlOc(i,j).GT.0. _d 0) THEN
         esurp     = fzMlOc(i,j)
         Tf        = tFrz(i,j)
         iceFrac   = icFrac(i,j)
         iceThick  = hIce(i,j)
         qicen(1)  = qIc1(i,j)
         qicen(2)  = qIc2(i,j)
C---
C--   start ice
         iceFormed = 0. _d 0
         iceVol    = iceFrac*iceThick

C-    enthalpy of new ice to form :
         IF ( iceFrac.LE.0. _d 0 ) THEN
          qicen(1) = -cpWater*Tmlt1
     &              + cpIce *(Tmlt1-Tf) + Lfresh*(1. _d 0-Tmlt1/Tf)
          qicen(2) = -cpIce *Tf + Lfresh
         ENDIF
         qicAv     = rhoi*(qicen(1)+qicen(2))*0.5 _d 0
         newIce    = esurp*deltaTice/qicAv

         IF ( icFrac(i,j).EQ.0. _d 0 ) THEN
C-  to keep identical results (as it used to be):
c-old_v: IF ( newIce.GE.hThinIce*iceMaskMin ) THEN
C-  here we allow to form ice earlier (as soon as min-ice-vol is reached)
c-new_v:
          IF ( newIce.GT.hIceMin*iceMaskMin ) THEN
C-    if there is no ice in grid-cell and enough ice to form:
C-    make ice over iceMaskMin fraction, up to hThinIce,
C     and if more ice to form, then increase fraction
           iceThick  = MIN(hThinIce,newIce/iceMaskMin)
           iceThick  = MAX(iceThick,newIce/iceMaskMax)
           iceFrac   = newIce/iceThick
           iceFormed = newIce
          ENDIF
         ELSEIF ( iceVol.LT.hiMax*iceMaskMax ) THEN
C-    if there is already some ice
C     create ice with same thickness or hNewIceMax (the smallest of the 2)
           hNewIce = MIN(hIce(i,j),hNewIceMax)
           iceFrac = MIN(icFrac(i,j)+newIce/hNewIce,iceMaskMax)
C-    update thickness: area weighted average
c-new_v:
           iceThick = MIN(hiMax,(iceVol+newIce)/iceFrac)
C-  to keep identical results: comment the line above and uncomment line below:
c-old_v     iceFrac = MIN(icFrac(i,j)+newIce/iceThick,iceMaskMax)
           iceFormed = iceThick*iceFrac - iceVol
C-    spread snow out over ice
           hSnow(i,j) = hSnow(i,j)*icFrac(i,j)/iceFrac
         ENDIF
C-    oceanic fluxes:
         flx2oc(i,j) = qicAv*iceFormed/deltaTice
         frw2oc(i,j) = -rhoi*iceFormed/deltaTice
         fsalt (i,j) = -(rhoi*saltIce)*iceFormed/deltaTice

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
#ifdef ALLOW_DBUG_THSICE
         IF ( dBug(i,j,bi,bj) ) THEN
          WRITE(6,1020) 'ThSI_EXT: iceH, newIce, newIceFrac=',
     &                       iceThick, newIce, iceFrac-icFrac(i,j)
          WRITE(6,1020) 'ThSI_EXT: iceFrac,flx2oc,fsalt,frw2oc=',
     &                  iceFrac,flx2oc(i,j),fsalt(i,j),frw2oc(i,j)
         ENDIF
#endif
#ifdef CHECK_ENERGY_CONSERV
         CALL THSICE_CHECK_CONSERV( dBugFlag, i, j, bi, bj, 1,
     I            icFrac(i,j), iceFrac, iceThick, hSnow(i,j), qicen,
     I            flx2oc(i,j), frw2oc(i,j), fsalt(i,j),
     I            myTime, myIter, myThid )
#endif /* CHECK_ENERGY_CONSERV */
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C-- Update Sea-Ice state output:
         IF ( iceFrac.GT.0. _d 0 .AND. icFrac(i,j).EQ.0. _d 0) THEN
c         hSnow(i,j) = 0. _d 0
          tSrf(i,j)  = tFrz(i,j)
          tIc1(i,j)  = tFrz(i,j)
          tIc2(i,j)  = tFrz(i,j)
          qIc1(i,j)  = qicen(1)
          qIc2(i,j)  = qicen(2)
         ENDIF
         icFrac(i,j) = iceFrac
         hIce  (i,j) = iceThick
        ENDIF
       ENDDO
      ENDDO

#endif /* ALLOW_THSICE */

      RETURN
      END

#include "MOM_FLUXFORM_OPTIONS.h"

CBOP
C !ROUTINE: MOM_U_METRIC_SPHERE

C !INTERFACE: ==========================================================
      SUBROUTINE MOM_U_METRIC_SPHERE(
     I        bi, bj, k,
     I        uFld, vFld,
     O        uMetricTerms,
     I        myThid )

C !DESCRIPTION:
C Calculates the zonal metric term due to sphericity:
C \begin{equation}
C \frac{u}{a} \overline{v}^{ij} \tan{\phi}
C \end{equation}

C !USES: ===============================================================
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"

C !INPUT PARAMETERS: ===================================================
C  bi, bj               :: tile indices
C  k                    :: vertical level
C  uFld                 :: zonal velocity
C  vFld                 :: meridional velocity
C  myThid               :: my Thread Id number
      INTEGER bi, bj, k
      _RL uFld(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL vFld(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER myThid

C !OUTPUT PARAMETERS: ==================================================
C  uMetricTerms         :: metric term
      _RL uMetricTerms(1-OLx:sNx+OLx,1-OLy:sNy+OLy)

C !LOCAL VARIABLES: ====================================================
C  i, j                 :: loop indices
      INTEGER i, j
CEOP

      IF ( selectMetricTerms.EQ.1 ) THEN
C-    Using analytical expression for tan(Phi) (stored in: tanPhiAtU)
        DO j=1-OLx,sNy+OLy-1
         DO i=1-OLx+1,sNx+OLx
           uMetricTerms(i,j) =
     &      uFld(i,j)*recip_rSphere*recip_deepFacC(k)*0.25 _d 0
     &          *( vFld(i,j  ) + vFld(i-1,j  )
     &           + vFld(i,j+1) + vFld(i-1,j+1)
     &           )*_tanPhiAtU(i,j,bi,bj)
         ENDDO
        ENDDO
      ELSE
C-    Using grid-spacing gradient: estimates tan(Phi)/rSphere as -del^j(dxC)/rAz
        DO j=2-OLx,sNy+OLy-1
         DO i=2-OLx,sNx+OLx
           uMetricTerms(i,j) = -halfRL*
     &     ( ( uFld(i,j-1) + uFld(i,j) )*halfRL
     &      *( dxC(i,j,bi,bj)-dxC(i,j-1,bi,bj) )*recip_rAz(i, j, bi,bj)
     &      *( vFld(i-1, j )*dxG(i-1, j, bi,bj)*hFacS(i-1, j, k,bi,bj)
     &       + vFld( i,  j )*dxG( i,  j, bi,bj)*hFacS( i,  j, k,bi,bj)
     &       )*halfRL
     &     + ( uFld(i,j) + uFld(i,j+1) )*halfRL
     &      *( dxC(i,j+1,bi,bj)-dxC(i,j,bi,bj) )*recip_rAz(i,j+1,bi,bj)
     &      *( vFld(i-1,j+1)*dxG(i-1,j+1,bi,bj)*hFacS(i-1,j+1,k,bi,bj)
     &       + vFld( i, j+1)*dxG( i, j+1,bi,bj)*hFacS( i, j+1,k,bi,bj)
     &       )*halfRL
     &     )*recip_hFacW(i,j,k,bi,bj)
     &      *recip_dxC(i,j,bi,bj)*recip_deepFacC(k)
         ENDDO
        ENDDO
      ENDIF

      RETURN
      END

#include "SHELFICE_OPTIONS.h"

CBOP
C     !ROUTINE: SHELFICE_REMESH_STATE
C     !INTERFACE:
      SUBROUTINE SHELFICE_REMESH_STATE(
     I                    k1SurfC, k1SurfW, k1SurfS, mrgFacC,
     U                    mrgFacW, mrgFacS,
     I                    myTime, myIter, myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE SHELFICE_REMESH_STATE
C     | o Update state variables near the surface
C     |   where remeshing occurs
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "DYNVARS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     k1SurfC   :: surface level index (at cell center) before remeshing
C     k1SurfW   :: surface level index (at cell W.Edge) before remeshing
C     k1SurfS   :: surface level index (at cell S.Edge) before remeshing
C     mrgFacC   :: merging weight for tracers (cell center)
C     mrgFacW   :: merging weight for U component velocity
C     mrgFacS   :: merging weight for V component velocity
C     myTime    :: Current time in simulation
C     myIter    :: Current iteration number
C     myThid    :: my Thread Id number
      INTEGER k1SurfC(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      INTEGER k1SurfW(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      INTEGER k1SurfS(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL mrgFacC(1-OLx:sNx+OLx,1-OLy:sNy+OLy,2,nSx,nSy)
      _RL mrgFacW(1-OLx:sNx+OLx,1-OLy:sNy+OLy,2,nSx,nSy)
      _RL mrgFacS(1-OLx:sNx+OLx,1-OLy:sNy+OLy,2,nSx,nSy)
      _RL myTime
      INTEGER myIter
      INTEGER myThid
CEOP

#ifdef ALLOW_SHELFICE_REMESHING
C     !LOCAL VARIABLES:
C     bi,bj   :: tile indices
C     i,j,k   :: Loop counters
C     k1, k2  :: previous and new surface level
C     ioUnit  :: temp for writing msg unit
C     msgBuf  :: Informational/error message buffer
      INTEGER bi, bj
      INTEGER i, j
      INTEGER k1, k2
      _RL r_newDz

C--  Update model state: 1) tracers
      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
        DO j = 1-OLy,sNy+OLy
         DO i = 1-OLx,sNx+OLx
          k1 = k1SurfC(i,j,bi,bj)
          k2 = kSurfC(i,j,bi,bj)
          IF ( k2.LT.k1 .AND. k1.LE.Nr ) THEN
C-    Splitting top cell (=k1):
C     just copy tracer value from former top (=k1) into new top cell (=k2)
            theta(i,j,k2,bi,bj) = theta(i,j,k1,bi,bj)
            salt(i,j,k2,bi,bj)  = salt(i,j,k1,bi,bj)
#ifdef ALLOW_ADAMSBASHFORTH_3
            gtNm(i,j,k2,bi,bj,1) = gtNm(i,j,k1,bi,bj,1)
            gtNm(i,j,k2,bi,bj,2) = gtNm(i,j,k1,bi,bj,2)
            gsNm(i,j,k2,bi,bj,1) = gsNm(i,j,k1,bi,bj,1)
            gsNm(i,j,k2,bi,bj,2) = gsNm(i,j,k1,bi,bj,2)
#else
            gtNm1(i,j,k2,bi,bj) = gtNm1(i,j,k1,bi,bj)
            gsNm1(i,j,k2,bi,bj) = gsNm1(i,j,k1,bi,bj)
#endif
          ENDIF
          IF ( k2.GT.k1 .AND. k2.LE.Nr ) THEN
C-    Merging top cell (=k1) into the one just below (=k2):
C     average tracer into new top cell (=k2) using weight factor "mrgFacC"
            theta(i,j,k2,bi,bj) =
     &            theta(i,j,k1,bi,bj)*mrgFacC(i,j,1,bi,bj)
     &          + theta(i,j,k2,bi,bj)*mrgFacC(i,j,2,bi,bj)
            theta(i,j,k1,bi,bj) = 0.0
            salt (i,j,k2,bi,bj) =
     &            salt(i,j,k1,bi,bj)*mrgFacC(i,j,1,bi,bj)
     &          + salt(i,j,k2,bi,bj)*mrgFacC(i,j,2,bi,bj)
            salt(i,j,k1,bi,bj) = 0.0
#ifdef ALLOW_ADAMSBASHFORTH_3
            gtNm(i,j,k2,bi,bj,1) =
     &            gtNm(i,j,k1,bi,bj,1)*mrgFacC(i,j,1,bi,bj)
     &          + gtNm(i,j,k2,bi,bj,1)*mrgFacC(i,j,2,bi,bj)
            gtNm(i,j,k2,bi,bj,2) =
     &            gtNm(i,j,k1,bi,bj,2)*mrgFacC(i,j,1,bi,bj)
     &          + gtNm(i,j,k2,bi,bj,2)*mrgFacC(i,j,2,bi,bj)
            gtNm(i,j,k1,bi,bj,1)= 0.0
            gtNm(i,j,k1,bi,bj,2)= 0.0
C-
            gsNm(i,j,k2,bi,bj,1) =
     &            gsNm(i,j,k1,bi,bj,1)*mrgFacC(i,j,1,bi,bj)
     &          + gsNm(i,j,k2,bi,bj,1)*mrgFacC(i,j,2,bi,bj)
            gsNm(i,j,k2,bi,bj,2) =
     &            gsNm(i,j,k1,bi,bj,2)*mrgFacC(i,j,1,bi,bj)
     &          + gsNm(i,j,k2,bi,bj,2)*mrgFacC(i,j,2,bi,bj)
            gsNm(i,j,k1,bi,bj,1)= 0.0
            gsNm(i,j,k1,bi,bj,2)= 0.0
#else
            gtNm1(i,j,k2,bi,bj) =
     &            gtNm1(i,j,k1,bi,bj)*mrgFacC(i,j,1,bi,bj)
     &          + gtNm1(i,j,k2,bi,bj)*mrgFacC(i,j,2,bi,bj)
            gtNm1(i,j,k1,bi,bj) = 0.0
            gsNm1(i,j,k2,bi,bj) =
     &            gsNm1(i,j,k1,bi,bj)*mrgFacC(i,j,1,bi,bj)
     &          + gsNm1(i,j,k2,bi,bj)*mrgFacC(i,j,2,bi,bj)
            gsNm1(i,j,k1,bi,bj) = 0.0
#endif
          ENDIF
         ENDDO
        ENDDO
       ENDDO
      ENDDO

      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)

C--  Update merging weights for both components of horizontal velocity
        DO j = 1-OLy,sNy+OLy
         DO i = 1-OLx,sNx+OLx
          IF ( kSurfW(i,j,bi,bj).NE.k1SurfW(i,j,bi,bj) ) THEN
            k1 = k1SurfW(i,j,bi,bj)
            k2 =  kSurfW(i,j,bi,bj)
            IF ( k2.GT.k1 .AND. k2.LE.Nr ) THEN
C-      merging former (=k1) into new (=k2) surface grid cell
c             r_newDz = recip_drF(k2)/hFacW(i,j,k2,bi,bj)
              r_newDz = recip_drF(k2)*recip_hFacW(i,j,k2,bi,bj)
              mrgFacW(i,j,1,bi,bj) = mrgFacW(i,j,1,bi,bj)
     &                              *drF(k1)*r_newDz
              mrgFacW(i,j,2,bi,bj) = mrgFacW(i,j,2,bi,bj)
     &                              *drF(k2)*r_newDz
            ENDIF
          ENDIF
         ENDDO
        ENDDO
        DO j = 1-OLy,sNy+OLy
         DO i = 1-OLx,sNx+OLx
          IF ( kSurfS(i,j,bi,bj).NE.k1SurfS(i,j,bi,bj) ) THEN
            k1 = k1SurfS(i,j,bi,bj)
            k2 =  kSurfS(i,j,bi,bj)
            IF ( k2.GT.k1 .AND. k2.LE.Nr ) THEN
C-      merging former (=k1) into new (=k2) surface grid cell
c             r_newDz = recip_drF(k2)/hFacS(i,j,k2,bi,bj)
              r_newDz = recip_drF(k2)*recip_hFacS(i,j,k2,bi,bj)
              mrgFacS(i,j,1,bi,bj) = mrgFacS(i,j,1,bi,bj)
     &                              *drF(k1)*r_newDz
              mrgFacS(i,j,2,bi,bj) = mrgFacS(i,j,2,bi,bj)
     &                              *drF(k2)*r_newDz
            ENDIF
          ENDIF
         ENDDO
        ENDDO

C--  Update model state: 2) horizontal velocity components U & V
        DO j = 1-OLy,sNy+OLy
         DO i = 1-OLx,sNx+OLx
          IF ( k1SurfW(i,j,bi,bj).NE.kSurfW(i,j,bi,bj) ) THEN
           k1 = k1SurfW(i,j,bi,bj)
           k2 =  kSurfW(i,j,bi,bj)
           IF ( k2.LT.k1 .AND. k1.LE.Nr ) THEN
C-      spliting case: just copy former surface value (=k1) into new one (=k2)
            uVel(i,j,k2,bi,bj) = uVel(i,j,k1,bi,bj)
#ifdef ALLOW_ADAMSBASHFORTH_3
            guNm(i,j,k2,bi,bj,1) = guNm(i,j,k1,bi,bj,1)
            guNm(i,j,k2,bi,bj,2) = guNm(i,j,k1,bi,bj,2)
#else
            guNm1(i,j,k2,bi,bj) = guNm1(i,j,k1,bi,bj)
#endif
           ENDIF
           IF ( k2.GT.k1 .AND. k2.LE.Nr ) THEN
C-      merging former (=k1) into new (=k2) surface grid cell
            uVel(i,j,k2,bi,bj) =
     &            uVel(i,j,k1,bi,bj)*mrgFacW(i,j,1,bi,bj)
     &          + uVel(i,j,k2,bi,bj)*mrgFacW(i,j,2,bi,bj)
            uVel(i,j,k1,bi,bj) = 0.0
#ifdef ALLOW_ADAMSBASHFORTH_3
            guNm(i,j,k2,bi,bj,1) =
     &            guNm(i,j,k1,bi,bj,1)*mrgFacW(i,j,1,bi,bj)
     &          + guNm(i,j,k2,bi,bj,1)*mrgFacW(i,j,2,bi,bj)
            guNm(i,j,k2,bi,bj,2) =
     &            guNm(i,j,k1,bi,bj,2)*mrgFacW(i,j,1,bi,bj)
     &          + guNm(i,j,k2,bi,bj,2)*mrgFacW(i,j,2,bi,bj)
            guNm(i,j,k1,bi,bj,1)= 0.0
            guNm(i,j,k1,bi,bj,2)= 0.0
#else
            guNm1(i,j,k2,bi,bj) =
     &            guNm1(i,j,k1,bi,bj)*mrgFacW(i,j,1,bi,bj)
     &          + guNm1(i,j,k2,bi,bj)*mrgFacW(i,j,2,bi,bj)
            guNm1(i,j,k1,bi,bj) = 0.0
#endif
           ENDIF
          ENDIF
         ENDDO
        ENDDO
        DO j = 1-OLy,sNy+OLy
         DO i = 1-OLx,sNx+OLx
          IF ( k1SurfS(i,j,bi,bj).NE.kSurfS(i,j,bi,bj) ) THEN
           k1 = k1SurfS(i,j,bi,bj)
           k2 =  kSurfS(i,j,bi,bj)
           IF ( k2.LT.k1 .AND. k1.LE.Nr ) THEN
C-      spliting case: just copy former surface value (=k1) into new one (=k2)
            vVel(i,j,k2,bi,bj) = vVel(i,j,k1,bi,bj)
#ifdef ALLOW_ADAMSBASHFORTH_3
            gvNm(i,j,k2,bi,bj,1) = gvNm(i,j,k1,bi,bj,1)
            gvNm(i,j,k2,bi,bj,2) = gvNm(i,j,k1,bi,bj,2)
#else
            gvNm1(i,j,k2,bi,bj) = gvNm1(i,j,k1,bi,bj)
#endif
           ENDIF
           IF ( k2.GT.k1 .AND. k2.LE.Nr ) THEN
C-      merging former (=k1) into new (=k2) surface grid cell
            vVel(i,j,k2,bi,bj) =
     &            vVel(i,j,k1,bi,bj)*mrgFacS(i,j,1,bi,bj)
     &          + vVel(i,j,k2,bi,bj)*mrgFacS(i,j,2,bi,bj)
            vVel(i,j,k1,bi,bj) = 0.0
#ifdef ALLOW_ADAMSBASHFORTH_3
            gvNm(i,j,k2,bi,bj,1) =
     &            gvNm(i,j,k1,bi,bj,1)*mrgFacS(i,j,1,bi,bj)
     &          + gvNm(i,j,k2,bi,bj,1)*mrgFacS(i,j,2,bi,bj)
            gvNm(i,j,k2,bi,bj,2) =
     &            gvNm(i,j,k1,bi,bj,2)*mrgFacS(i,j,1,bi,bj)
     &          + gvNm(i,j,k2,bi,bj,2)*mrgFacS(i,j,2,bi,bj)
            gvNm(i,j,k1,bi,bj,1)= 0.0
            gvNm(i,j,k1,bi,bj,2)= 0.0
#else
            gvNm1(i,j,k2,bi,bj) =
     &            gvNm1(i,j,k1,bi,bj)*mrgFacS(i,j,1,bi,bj)
     &          + gvNm1(i,j,k2,bi,bj)*mrgFacS(i,j,2,bi,bj)
            gvNm1(i,j,k1,bi,bj) = 0.0
#endif
           ENDIF
          ENDIF
         ENDDO
        ENDDO

       ENDDO
      ENDDO

#endif /* ALLOW_SHELFICE_REMESHING */
      RETURN
      END

#include "GCHEM_OPTIONS.h"

C !INTERFACE: ==========================================================
      SUBROUTINE GCHEM_DIAGNOSTICS_INIT( myThid )

C !DESCRIPTION:
C define diagnostics for gchem package
C experiment

C !USES: ===============================================================
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "PTRACERS_SIZE.h"
#include "PTRACERS_PARAMS.h"
#include "GCHEM.h"
c#include "GAD.h"

C !INPUT PARAMETERS: ===================================================
C  myThid               :: thread number
      INTEGER myThid
CEOP

#ifdef ALLOW_DIAGNOSTICS
#ifdef GCHEM_SEPARATE_FORCING

C     Functions ::
      INTEGER     ILNBLNK
      EXTERNAL    ILNBLNK
c     CHARACTER*4 GAD_DIAG_SUFX
c     EXTERNAL    GAD_DIAG_SUFX

C     !LOCAL VARIABLES:
      INTEGER       diagNum
      CHARACTER*8   diagName
      CHARACTER*16  diagCode
      CHARACTER*16  diagUnits
      CHARACTER*(80) diagTitle

      INTEGER      iTrc, ilnb
      CHARACTER*7  trcUnits
      CHARACTER*30 locName

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C--   Define diagnostics Names :
      DO iTrc=1,MIN( gchem_sepFTr_num, PTRACERS_num )
C-     Set default name & tracer Units:
       WRITE(locName,'(A,I4.4,A)') 'Tracer ',iTrc
       trcUnits  = '(kg/kg)'
C-     use units & (short) name from data.ptracers :
       ilnb = ILNBLNK(PTRACERS_units(iTrc))
       IF ( ilnb.GE.1 ) THEN
         ilnb = LEN(trcUnits)
         trcUnits = PTRACERS_units(iTrc)(1:ilnb)
       ENDIF
       ilnb = ILNBLNK(PTRACERS_names(iTrc))
       IF ( ilnb.GE.1 ) THEN
         ilnb = MIN(LEN(locName),ilnb)
         WRITE(locName,'(A)') PTRACERS_names(iTrc)(1:ilnb)
       ENDIF
       ilnb = MAX(ILNBLNK(locName),1)

       WRITE(diagName,'(A5,A2,A1)') 'GC_Tr',PTRACERS_ioLabel(iTrc),' '
       WRITE(diagTitle,'(2A)') locName(1:ilnb),
     &                         ' concentration before GCHEM'
       diagUnits = trcUnits//'         '
       diagCode  = 'SMR     MR      '
       CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I           diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      ENDDO

C--   Other diagnostics should be initialized in each package called by gchem

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#endif /* GCHEM_SEPARATE_FORCING */
#endif /* ALLOW_DIAGNOSTICS */

      RETURN
      END

#include "STREAMICE_OPTIONS.h"
#ifdef ALLOW_AUTODIFF
# include "AUTODIFF_OPTIONS.h"
#endif

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

CBOP
      SUBROUTINE STREAMICE_VEL_PHI (
     I           myThid,
     I           maxNLIter,
     I           maxCGiter,
     I           cgtol,
     O           cg_iters,
     O           max_err)
C     /============================================================\
C     | SUBROUTINE                                                 |
C     | o                                                          |
C     |============================================================|
C     |                                                            |
C     \============================================================/
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "STREAMICE.h"
#include "STREAMICE_CG.h"
c#ifdef ALLOW_PETSC
c#include "finclude/petsc.h"
c#endif

C     !INPUT/OUTPUT ARGUMENTS
      INTEGER myThid
      INTEGER maxNLIter
      INTEGER maxCGIter
      _RL cgtol
      INTEGER cg_iters
      _RL max_err

#ifdef ALLOW_STREAMICE_FP_ADJ

C     LOCAL VARIABLES

      INTEGER i,j,bi,bj
      CHARACTER*(MAX_LEN_MBUF) msgBuf

      _EXCH_XY_RL( U_streamice , myThid )
      _EXCH_XY_RL( V_streamice , myThid )

#ifdef STREAMICE_HYBRID_STRESS
       CALL STREAMICE_VISC_BETA_HYBRID ( myThid )
#else
       CALL STREAMICE_VISC_BETA ( myThid )
#endif

      _EXCH_XY_RL( tau_beta_eff_streamice , myThid )
      _EXCH_XY_RL( visc_streamice , myThid )

       CALL STREAMICE_GET_VEL_RESID_ERR_OAD (max_err,myThid)

       DO bj = myByLo(myThid), myByHi(myThid)
        DO bi = myBxLo(myThid), myBxHi(myThid)
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           u_new_SI(i,j,bi,bj) = U_streamice(i,j,bi,bj)
           v_new_SI(i,j,bi,bj) = V_streamice(i,j,bi,bj)
          ENDDO
         ENDDO
        ENDDO
       ENDDO

       CALL STREAMICE_CG_WRAPPER(
     &       U_new_si,
     &       V_new_si,
     &       taudx_SI,
     &       taudy_SI,
     &       cgtol,
     &       cg_iters,
     &       maxCGIter,
     &       myThid )

#ifdef STREAMICE_HYBRID_STRESS
        CALL STREAMICE_TAUB (myThid)
#endif

#endif /* ALLOW_STREAMICE_FP_ADJ */
      RETURN
      END

#include "CTRL_OPTIONS.h"
C- note: although we just need CPP_EEOPTIONS.h here, prefer to
C        include the same option-file above as in the AD version.

C--  File ctrl_bound.F:
C--   Contents
C--   o CTRL_BOUND_3D
C--   o CTRL_BOUND_2D

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: CTRL_BOUND_3D
C     !INTERFACE:
      SUBROUTINE CTRL_BOUND_3D(
     U                fieldCur,
     I                mask3D, boundsVec, myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | started: Gael Forget gforget@mit.edu 20-Aug-2007
C     |
C     | o in forward mode: impose bounds on ctrl vector values
C     | o in adjoint mode: do nothing ... or emulate local minimum
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
      _RL fieldCur(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      _RS mask3D  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      _RL boundsVec(5)
      INTEGER myThid

C     !LOCAL VARIABLES:
      INTEGER bi,bj,i,j,k
CEOP

      IF (boundsVec(1).LT.boundsVec(4)) THEN

       DO bj=myByLo(myThid), myByHi(myThid)
        DO bi=myBxLo(myThid), myBxHi(myThid)

         DO k = 1,Nr
          DO j = 1,sNy
           DO i = 1,sNx
             IF (mask3D(i,j,k,bi,bj).NE.0.) THEN
              IF (fieldCur(i,j,k,bi,bj).GT.boundsVec(4)) THEN
               fieldCur(i,j,k,bi,bj)=boundsVec(4)
              ENDIF
              IF (fieldCur(i,j,k,bi,bj).LT.boundsVec(1)) THEN
               fieldCur(i,j,k,bi,bj)=boundsVec(1)
              ENDIF
             ENDIF
           ENDDO
          ENDDO
         ENDDO

        ENDDO
       ENDDO

      ENDIF

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C
C     !ROUTINE: CTRL_BOUND_2D
C     !INTERFACE:
      SUBROUTINE CTRL_BOUND_2D(
     U                fieldCur,
     I                mask2D, boundsVec, myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | started: Gael Forget gforget@mit.edu 20-Aug-2007
C     |
C     | o in forward mode: impose bounds on ctrl vector values
C     | o in adjoint mode: do nothing ... or emulate local minimum
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
      _RL fieldCur(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RS mask2D  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL boundsVec(5)
      INTEGER myThid

C     !LOCAL VARIABLES:
      INTEGER bi,bj,i,j
CEOP

      IF (boundsVec(1).LT.boundsVec(4)) THEN

       DO bj=myByLo(myThid), myByHi(myThid)
        DO bi=myBxLo(myThid), myBxHi(myThid)

          DO j = 1-OLy,sNy+OLy
           DO i = 1-OLx,sNx+OLx
             IF (mask2D(i,j,bi,bj).NE.0.) THEN
              IF (fieldCur(i,j,bi,bj).GT.boundsVec(4)) THEN
               fieldCur(i,j,bi,bj)=boundsVec(4)
              ENDIF
              IF (fieldCur(i,j,bi,bj).LT.boundsVec(1)) THEN
               fieldCur(i,j,bi,bj)=boundsVec(1)
              ENDIF
             ENDIF
           ENDDO
          ENDDO

        ENDDO
       ENDDO

      ENDIF

      RETURN
      END

#include "EXF_OPTIONS.h"

CBOP 0
C     !ROUTINE: EXF_DIAGNOSTICS_FILL
C     !INTERFACE:
      SUBROUTINE EXF_DIAGNOSTICS_FILL(
     I                                 myTime, myIter, myThid )

C     !DESCRIPTION:
C     Fill-in External Forcing (EXF) pkg diagnostics
C     directly from pkg global variables (in common)

C     !USES:
      IMPLICIT NONE

C     == Global variables ===
#include "EEPARAMS.h"
#include "SIZE.h"
#include "PARAMS.h"
#include "EXF_PARAM.h"
#include "EXF_FIELDS.h"

C     !INPUT PARAMETERS:
C     myTime    :: current time in simulation [s]
C     myIter    :: current iteration number in simulation
C     myThid    :: my Thread Id number
      _RL     myTime
      INTEGER myIter
      INTEGER myThid

#ifdef ALLOW_DIAGNOSTICS
C     !FUNCTIONS:
c     LOGICAL  DIAGNOSTICS_IS_ON
c     EXTERNAL DIAGNOSTICS_IS_ON

C     !LOCAL VARIABLES:
CEOP

      IF ( useDiagnostics ) THEN

       IF ( .NOT.diags_opOceWeighted ) THEN
        CALL DIAGNOSTICS_FILL( ustress,   'EXFtaux ',0,1,0,1,1,myThid )
        CALL DIAGNOSTICS_FILL( vstress,   'EXFtauy ',0,1,0,1,1,myThid )
        CALL DIAGNOSTICS_FILL( sflux,     'EXFempmr',0,1,0,1,1,myThid )
        CALL DIAGNOSTICS_FILL( hflux,     'EXFqnet ',0,1,0,1,1,myThid )
#if defined(ALLOW_ATM_TEMP) || defined(SHORTWAVE_HEATING)
        CALL DIAGNOSTICS_FILL( swflux,    'EXFswnet',0,1,0,1,1,myThid )
#endif
       ENDIF
        CALL DIAGNOSTICS_FILL( uwind,     'EXFuwind',0,1,0,1,1,myThid )
        CALL DIAGNOSTICS_FILL( vwind,     'EXFvwind',0,1,0,1,1,myThid )
        CALL DIAGNOSTICS_FILL( wspeed,    'EXFwspee',0,1,0,1,1,myThid )
#ifdef ALLOW_ATM_TEMP
        CALL DIAGNOSTICS_FILL( atemp,     'EXFatemp',0,1,0,1,1,myThid )
        CALL DIAGNOSTICS_FILL( aqh,       'EXFaqh  ',0,1,0,1,1,myThid )
       IF ( .NOT.diags_opOceWeighted ) THEN
        CALL DIAGNOSTICS_FILL( hs,        'EXFhs   ',0,1,0,1,1,myThid )
        CALL DIAGNOSTICS_FILL( hl,        'EXFhl   ',0,1,0,1,1,myThid )
        CALL DIAGNOSTICS_FILL( lwflux,    'EXFlwnet',0,1,0,1,1,myThid )
        CALL DIAGNOSTICS_FILL( evap,      'EXFevap ',0,1,0,1,1,myThid )
       ENDIF
        CALL DIAGNOSTICS_FILL( precip,    'EXFpreci',0,1,0,1,1,myThid )
        CALL DIAGNOSTICS_FILL( snowprecip,'EXFsnow ',0,1,0,1,1,myThid )
#endif
#ifdef ALLOW_DOWNWARD_RADIATION
        CALL DIAGNOSTICS_FILL( lwdown,    'EXFlwdn ',0,1,0,1,1,myThid )
        CALL DIAGNOSTICS_FILL( swdown,    'EXFswdn ',0,1,0,1,1,myThid )
#endif
#ifdef ATMOSPHERIC_LOADING
        CALL DIAGNOSTICS_FILL( apressure, 'EXFpress',0,1,0,1,1,myThid )
#endif
#ifdef ALLOW_RUNOFF
        CALL DIAGNOSTICS_FILL( runoff,    'EXFroff ',0,1,0,1,1,myThid )
#endif
#ifdef ALLOW_RUNOFTEMP
        CALL DIAGNOSTICS_FILL( runoftemp, 'EXFroft ',0,1,0,1,1,myThid )
#endif
#ifdef ALLOW_SALTFLX
        CALL DIAGNOSTICS_FILL( saltflx,   'EXFsalfx',0,1,0,1,1,myThid )
#endif

      ENDIF
#endif /* ALLOW_DIAGNOSTICS */

      RETURN
      END

#include "OBSFIT_OPTIONS.h"
#include "AD_CONFIG.h"

C--  File obsfit_nc_utils.F:
C--   Contents
C--   o OBSFIT_NF_ERROR
C--   o OBSFIT_NC_CLOSE

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C !ROUTINE: OBSFIT_NF_ERROR

C !INTERFACE:
      SUBROUTINE OBSFIT_NF_ERROR( message, STATUS, bi, bj, myThid )

C     !DESCRIPTION:
C     Print NetCDF error message

C     !USES:
      IMPLICIT NONE
C     == Global variables ===
#ifdef ALLOW_OBSFIT
# include "SIZE.h"
# include "EEPARAMS.h"
# include "PARAMS.h"
# include "netcdf.inc"
#endif

C     !INPUT PARAMETERS:
C     message   :: optional message
C     STATUS    :: NetCDF error status
C     bi,bj     :: Tile indices
C     myThid    :: my thread ID number
      CHARACTER*(*) message
      INTEGER STATUS, bi, bj, myThid

C     !OUTPUT PARAMETERS:
CEOP

C     !FUNCTIONS:
      INTEGER ILNBLNK
      EXTERNAL ILNBLNK

C     !LOCAL VARIABLES:
#ifdef ALLOW_OBSFIT
      INTEGER IL
      CHARACTER*(MAX_LEN_MBUF) msgBuf

      IF ( debugLevel .GE. debLevA .AND. STATUS .NE. NF_NOERR ) THEN
        IL = ILNBLNK(message)
        IF ( IL .GT. 0 ) THEN
          IF ( (bi.GT.0).AND.(bj.GT.0) ) THEN
            WRITE( msgBuf,'(A,A,2I3,1X,A)' )
     &       'NF_MESSAGE: OBSFIT_', message(1:IL),
     &       bi, bj, NF_STRERROR(STATUS)
          ELSE
             WRITE( msgBuf,'(A,A,1X,A)' )
     &       'NF_MESSAGE: OBSFIT_', message(1:IL),
     &       NF_STRERROR(STATUS)
          ENDIF
        ELSE
          IF ( (bi.GT.0).AND.(bj.GT.0) ) THEN
            WRITE( msgBuf,'(A,2I3,1X,A)' ) 'NF_MESSAGE: OBSFIT ',
     &       bi, bj, NF_STRERROR(STATUS)
          ELSE
            WRITE( msgBuf,'(A,1X,A)' ) 'NF_MESSAGE: OBSFIT ',
     &       NF_STRERROR(STATUS)
          ENDIF
        ENDIF
        CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &       SQUEEZE_RIGHT,myThid )
      ENDIF
#endif /* ALLOW_OBSFIT */

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C !ROUTINE: OBSFIT_NC_CLOSE

C !INTERFACE:
      SUBROUTINE OBSFIT_NC_CLOSE( myThid )

C     !DESCRIPTION:
C     Close NetCDF files

C     !USES:
      IMPLICIT NONE
C     == Global variables ===
#ifdef ALLOW_OBSFIT
# include "SIZE.h"
# include "EEPARAMS.h"
# include "OBSFIT_SIZE.h"
# include "OBSFIT.h"
# include "netcdf.inc"
#endif

C     !INPUT PARAMETERS:
C     myThid :: my thread ID number
      INTEGER myThid

C     !OUTPUT PARAMETERS:
CEOP

C     !FUNCTIONS:
      INTEGER ILNBLNK
      EXTERNAL ILNBLNK

C     !LOCAL VARIABLES:
#ifdef ALLOW_OBSFIT
C     bi,bj :: tile indices
      INTEGER bi, bj
      INTEGER IL, num_file
      INTEGER STATUS
      CHARACTER*(MAX_LEN_MBUF) msgBuf

      _BEGIN_MASTER( myThid )

      DO num_file = 1, NFILESMAX_OBS
        IL = ILNBLNK( obsfitFiles(num_file) )

        IF ( IL.NE.0 ) THEN
          WRITE( msgBuf,'(A,A,5(1X,I8))' )
     &         'S/R OBSFIT_NC_CLOSE:',
     &         ' Closing '//obsfitFiles(num_file)(1:IL), num_file,
     &         fiddata_obs(num_file)
           CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &          SQUEEZE_RIGHT,myThid )
C Data file
          IF ( fiddata_obs(num_file) .GT. 0 ) THEN
            STATUS = NF_CLOSE( fiddata_obs(num_file) )
            WRITE( msgBuf,'(A,I3,I8)' )
     &           'NC_CLOSE: NF_CLOSE data unit',
     &           num_file, fiddata_obs(num_file)
            CALL OBSFIT_NF_ERROR( msgBuf, STATUS,
     &           0, 0, myThid )
          ENDIF

C Global equi file
          IF ( fidglobal(num_file) .GT. 0 ) THEN
            STATUS = NF_CLOSE( fidglobal(num_file) )
            WRITE( msgBuf,'(A,I3,I8)' )
     &           'NC_CLOSE: NF_CLOSE global equi unit',
     &           num_file, fidglobal(num_file)
            CALL OBSFIT_NF_ERROR( msgBuf, STATUS,
     &           0, 0, myThid )
          ENDIF

          IF (obsfitDoNcOutput) THEN
c            DO bj = myByLo(myThid), myByHi(myThid)
c               DO bi = myBxLo(myThid), myBxHi(myThid)
C Since this is only done by the master thread, we loop over the
C entire range of tiles
            DO bj = 1, nSy
              DO bi = 1, nSx
                WRITE( msgBuf,'(A,A,5(1X,I8))' )
     &           'S/R OBSFIT_NC_CLOSE:',
     &           ' Closing '//obsfitFiles(num_file)(1:IL), num_file,
     &           fidfwd_obs(num_file,bi,bj),
     &           fidadj_obs(num_file,bi,bj),
     &           fidtan_obs(num_file,bi,bj)
                CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &               SQUEEZE_RIGHT,myThid )

C Forward equivalent (.equi) file
                IF ( fidfwd_obs(num_file,bi,bj) .GT. 0 ) THEN
                 STATUS = NF_CLOSE( fidfwd_obs(num_file,bi,bj) )
                 WRITE( msgBuf,'(A,I3,I8)' )
     &                'NC_CLOSE: NF_CLOSE fwd unit',
     &                num_file, fidfwd_obs(num_file,bi,bj)
                 CALL OBSFIT_NF_ERROR( msgBuf, STATUS,
     &                bi, bj, myThid )
                ENDIF
#ifdef ALLOW_ADJOINT_RUN
C Adjoint equivalent (.equi) file
                IF ( fidadj_obs(num_file,bi,bj) .GT. 0 ) THEN
                 STATUS = NF_CLOSE( fidadj_obs(num_file,bi,bj) )
                 WRITE( msgBuf,'(A,I3,I8)' )
     &                'NC_CLOSE: NF_CLOSE adj unit',
     &                num_file, fidadj_obs(num_file,bi,bj)
                 CALL OBSFIT_NF_ERROR( msgBuf, STATUS,
     &                bi, bj, myThid )
                ENDIF
#endif
#ifdef ALLOW_TANGENTLINEAR_RUN
C Tangent linear equivalent (.equi) file
                IF ( fidtan_obs(num_file,bi,bj) .GT. 0 ) THEN
                 STATUS = NF_CLOSE( fidtan_obs(num_file,bi,bj) )
                 WRITE( msgBuf,'(A,I3,I8)' )
     &                'NC_CLOSE: NF_CLOSE tlm unit',
     &                num_file, fidtan_obs(num_file,bi,bj)
                 CALL OBSFIT_NF_ERROR( msgBuf, STATUS,
     &                bi, bj, myThid )
                ENDIF
#endif

              ENDDO
            ENDDO
          ENDIF
        ENDIF
      ENDDO

      _END_MASTER( myThid )
#endif /* ALLOW_OBSFIT */

      RETURN
      END

#include "CAL_OPTIONS.h"

      subroutine cal_DaysPerMonth( 
     I                             myiter,
     I                             mytime,
     O                             ndays,
     I                             mythid
     &                           )

c     ==================================================================
c     SUBROUTINE cal_DaysPerMonth
c     ==================================================================
c
c     o Given the iteration number and/or the current time of integration
c       return the number of days left in the current calendar month
c       including the day belonging to iter/currenttime.
c              
c     started: Christian Eckert eckert@mit.edu  30-Jun-1999
c
c     changed: Christian Eckert eckert@mit.edu  29-Dec-1999
c
c              - restructured the original version in order to have a
c                better interface to the MITgcmUV.
c
c              Christian Eckert eckert@mit.edu  03-Feb-2000
c
c              - Introduced new routine and function names, cal_<NAME>,
c                for verion 0.1.3.
c
c     ==================================================================
c     SUBROUTINE cal_DaysPerMonth
c     ==================================================================

      implicit none

c     == global variables ==

#include "cal.h"

c     == routine arguments ==

      integer myiter
      _RL     mytime
      integer ndays
      integer mythid

c     == local variables ==

      integer mydate(4)
      integer myday
      integer mymonth
      integer myyear
      integer finalyear
      integer finalmonth
      integer present
      integer final
      integer ierr

c     == end of interface ==

      call cal_GetDate( myiter, mytime, mydate, mythid )

      myday      = mod(mydate(1),100)
      mymonth    = mod(mydate(1)/100,100)
      myyear     = mydate(1)/10000
      present    = mydate(1)/100
      finalyear  = modelenddate(1)/10000
      finalmonth = mod(modelenddate(1)/100,100)
      final      = modelenddate(1)/100

      if (myyear .lt. finalyear) then
        ndays = ndaymonth(mymonth,mydate(3)) - myday + 1
      else if (myyear .eq. finalyear) then
        if (mymonth .eq. finalmonth) then
          ndays = mod(modelenddate(1),100) - myday + 1
        else
          ndays = ndaymonth(mymonth,mydate(3)) - myday + 1
        endif
      else

        ierr = 1201
        call cal_PrintError( ierr, mythid )
        stop ' stopped in cal_DaysPerMonth.'

      endif

      return
      end

CBOI
C !TITLE: pkg/mom\_advdiff
C !AUTHORS: adcroft@mit.edu
C !INTRODUCTION: Flux-form Momentum Equations Package
C
C Package "mom\_fluxform" provides methods for calculating explicit terms
C in the momentum equation cast in flux-form:
C \begin{eqnarray*}
C G^u & = & -\frac{1}{\rho} \partial_x \phi_h
C           -\nabla \cdot {\bf v} u
C           -fv
C           +\frac{1}{\rho} \nabla \cdot {\bf \tau}^x
C           + \mbox{metrics}
C \\
C G^v & = & -\frac{1}{\rho} \partial_y \phi_h
C           -\nabla \cdot {\bf v} v
C           +fu
C           +\frac{1}{\rho} \nabla \cdot {\bf \tau}^y
C           + \mbox{metrics}
C \end{eqnarray*}
C where ${\bf v}=(u,v,w)$ and $\tau$, the stress tensor, includes surface
C stresses as well as internal viscous stresses.
CEOI

#include "MOM_FLUXFORM_OPTIONS.h"
#ifdef ALLOW_AUTODIFF
# include "AUTODIFF_OPTIONS.h"
#endif
#ifdef ALLOW_MOM_COMMON
# include "MOM_COMMON_OPTIONS.h"
#endif
#ifdef ALLOW_GGL90
# include "GGL90_OPTIONS.h"
#endif
C- to switch back to (very) old accounting of geometry/Area factor
#undef OLD_UV_GEOM

CBOP
C !ROUTINE: MOM_FLUXFORM

C !INTERFACE: ==========================================================
      SUBROUTINE MOM_FLUXFORM(
     I        bi,bj,k,iMin,iMax,jMin,jMax,
     I        kappaRU, kappaRV,
     U        fVerUkm, fVerVkm,
     O        fVerUkp, fVerVkp,
     O        guDiss, gvDiss,
     I        myTime, myIter, myThid )

C !DESCRIPTION:
C Calculates all the horizontal accelerations except for the implicit surface
C pressure gradient and implicit vertical viscosity.

C !USES: ===============================================================
C     == Global variables ==
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "DYNVARS.h"
#include "FFIELDS.h"
#include "SURFACE.h"
#ifdef ALLOW_MOM_COMMON
# include "MOM_VISC.h"
#endif
#if ( defined ALLOW_GGL90 && defined ALLOW_GGL90_LANGMUIR )
# include "GGL90.h"
#endif
#ifdef ALLOW_AUTODIFF
# ifdef ALLOW_AUTODIFF_TAMC
#  include "tamc.h"
# endif
# include "MOM_FLUXFORM.h"
#endif

C !INPUT PARAMETERS: ===================================================
C  bi,bj                :: current tile indices
C  k                    :: current vertical level
C  iMin,iMax,jMin,jMax  :: loop ranges
C  kappaRU              :: vertical viscosity
C  kappaRV              :: vertical viscosity
C  fVerUkm              :: vertical advective flux of U, interface above (k-1/2)
C  fVerVkm              :: vertical advective flux of V, interface above (k-1/2)
C  fVerUkp              :: vertical advective flux of U, interface below (k+1/2)
C  fVerVkp              :: vertical advective flux of V, interface below (k+1/2)
C  guDiss               :: dissipation tendency (all explicit terms), u component
C  gvDiss               :: dissipation tendency (all explicit terms), v component
C  myTime               :: current time
C  myIter               :: current time-step number
C  myThid               :: my Thread Id number
      INTEGER bi,bj,k
      INTEGER iMin,iMax,jMin,jMax
      _RL kappaRU(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr+1)
      _RL kappaRV(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr+1)
      _RL fVerUkm(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL fVerVkm(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL fVerUkp(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL fVerVkp(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL guDiss(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL gvDiss(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL     myTime
      INTEGER myIter
      INTEGER myThid

C !OUTPUT PARAMETERS: ==================================================
C None - updates gU() and gV() in common blocks

C !LOCAL VARIABLES: ====================================================
C  i,j                  :: loop indices
C  gAdd                 :: individual momentum tendency term to add
C  del2                 :: horizontal second derivative (Laplacian)
C  uCf,vCf              :: Coriolis acceleration
C  vMT                  :: vertical/Non-Hyd. metric terms
C  fZon                 :: zonal fluxes
C  fMer                 :: meridional fluxes
C  fVrUp,fVrDw          :: vertical viscous fluxes at interface k & k+1
      INTEGER i,j
#ifdef ALLOW_AUTODIFF_TAMC
C     kkey :: tape key (depends on level and tile indices)
      INTEGER kkey
#endif
      _RL gAdd(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL del2(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL  uCf(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL  vCf(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL  vMT(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL fZon(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL fMer(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL fVrUp(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL fVrDw(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
C     afFacMom     :: Tracer parameters for turning terms on and off.
C     vfFacMom
C     pfFacMom        afFacMom - Advective terms
C     cfFacMom        vfFacMom - Eddy viscosity terms
C     mtFacMom        pfFacMom - Pressure terms
C                     cfFacMom - Coriolis terms
C                     foFacMom - Forcing
C                     mtFacMom - Metric term
C     uDudxFac, AhDudxFac, etc ... individual term parameters for switching terms off
      _RS    hFacZ(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RS   h0FacZ(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RS  r_hFacZ(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RS       xA(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RS       yA(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL   uTrans(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL   vTrans(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL     uFld(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL     vFld(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL  rTransU(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL  rTransV(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
#if ( defined ALLOW_GGL90 && defined ALLOW_GGL90_LANGMUIR )
      _RL     uRes(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL     vRes(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
#endif
      _RL       KE(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL    cDrag(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL viscAh_D(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL viscAh_Z(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL viscA4_D(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL viscA4_Z(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL    vort3(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL     hDiv(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL   strain(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL  tension(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL stretching(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
#ifdef ALLOW_LEITH_QG
      _RL  Nsquare(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
#endif
      _RL  uDudxFac
      _RL  AhDudxFac
      _RL  vDudyFac
      _RL  AhDudyFac
      _RL  wDudrFac
      _RL  ArDudrFac
      _RL  fuFac
      _RL  mtFacU
      _RL  mtNHFacU
      _RL  uDvdxFac
      _RL  AhDvdxFac
      _RL  vDvdyFac
      _RL  AhDvdyFac
      _RL  wDvdrFac
      _RL  ArDvdrFac
      _RL  fvFac
      _RL  mtFacV
      _RL  mtNHFacV
      _RL  sideMaskFac
      _RL  rAdvDeepFac
      LOGICAL bottomDragTerms, diagFlag
CEOP
#ifdef MOM_BOUNDARY_CONSERVE
      COMMON / MOM_FLUXFORM_LOCAL / uBnd, vBnd
      _RL  uBnd(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      _RL  vBnd(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
#endif /* MOM_BOUNDARY_CONSERVE */

#ifdef ALLOW_AUTODIFF_TAMC
      kkey = bi + (bj-1)*nSx + (ikey_dynamics-1)*nSx*nSy
      kkey = k  + (kkey-1)*Nr
#endif /* ALLOW_AUTODIFF_TAMC */

C     Initialise intermediate terms
      DO j=1-OLy,sNy+OLy
       DO i=1-OLx,sNx+OLx
        gAdd(i,j) = 0.
        del2(i,j) = 0.
        uCf(i,j)  = 0.
        vCf(i,j)  = 0.
        vMT(i,j)  = 0.
        fZon(i,j) = 0.
        fMer(i,j) = 0.
        fVrUp(i,j)= 0.
        fVrDw(i,j)= 0.
        rTransU(i,j)= 0.
        rTransV(i,j)= 0.
c       KE(i,j)     = 0.
        hDiv(i,j)   = 0.
        vort3(i,j)  = 0.
        strain(i,j) = 0.
        tension(i,j)= 0.
        stretching(i,j) = 0.
#ifdef ALLOW_LEITH_QG
        Nsquare(i,j) = 0.
#endif
        guDiss(i,j) = 0.
        gvDiss(i,j) = 0.
#if ( defined ALLOW_GGL90 && defined ALLOW_GGL90_LANGMUIR )
c       uRes(i,j)   = 0.
c       vRes(i,j)   = 0.
#endif
       ENDDO
      ENDDO

C--   Term by term tracer parmeters
C     o U momentum equation
      uDudxFac     = afFacMom*1.
      AhDudxFac    = vfFacMom*1.
      vDudyFac     = afFacMom*1.
      AhDudyFac    = vfFacMom*1.
      wDudrFac     = afFacMom*1.
      ArDudrFac    = vfFacMom*1.
      mtFacU       = mtFacMom*1.
      mtNHFacU     = 1.
      fuFac        = cfFacMom*1.
C     o V momentum equation
      uDvdxFac     = afFacMom*1.
      AhDvdxFac    = vfFacMom*1.
      vDvdyFac     = afFacMom*1.
      AhDvdyFac    = vfFacMom*1.
      wDvdrFac     = afFacMom*1.
      ArDvdrFac    = vfFacMom*1.
      mtFacV       = mtFacMom*1.
      mtNHFacV     = 1.
      fvFac        = cfFacMom*1.

      IF (implicitViscosity) THEN
        ArDudrFac  = 0.
        ArDvdrFac  = 0.
      ENDIF

C note: using standard stencil (no mask) results in under-estimating
C       vorticity at a no-slip boundary by a factor of 2 = sideDragFactor
      IF ( no_slip_sides ) THEN
        sideMaskFac = sideDragFactor
      ELSE
        sideMaskFac = 0. _d 0
      ENDIF

      IF ( selectImplicitDrag.EQ.0 .AND.
     &      (  no_slip_bottom
     &    .OR. selectBotDragQuadr.GE.0
     &    .OR. bottomDragLinear.NE.0. ) ) THEN
       bottomDragTerms=.TRUE.
      ELSE
       bottomDragTerms=.FALSE.
      ENDIF

C--   Calculate open water fraction at vorticity points
      CALL MOM_CALC_HFACZ( bi,bj,k,hFacZ,r_hFacZ,myThid )
#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE hFacZ(:,:)  = comlev1_bibj_k, key = kkey, byte = isbyte
#endif

C---- Calculate common quantities used in both U and V equations
C     Calculate tracer cell face open areas
      DO j=1-OLy,sNy+OLy
       DO i=1-OLx,sNx+OLx
        xA(i,j) = _dyG(i,j,bi,bj)*deepFacC(k)
     &          *drF(k)*_hFacW(i,j,k,bi,bj)
        yA(i,j) = _dxG(i,j,bi,bj)*deepFacC(k)
     &          *drF(k)*_hFacS(i,j,k,bi,bj)
        h0FacZ(i,j) = hFacZ(i,j)
       ENDDO
      ENDDO
#ifdef NONLIN_FRSURF
      IF ( momViscosity .AND. no_slip_sides
     &                  .AND. nonlinFreeSurf.GT.0 ) THEN
        DO j=2-OLy,sNy+OLy
         DO i=2-OLx,sNx+OLx
          h0FacZ(i,j) = MIN(
     &       MIN( h0FacW(i,j,k,bi,bj), h0FacW(i,j-1,k,bi,bj) ),
     &       MIN( h0FacS(i,j,k,bi,bj), h0FacS(i-1,j,k,bi,bj) ) )
         ENDDO
        ENDDO
      ENDIF
# ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE h0FacZ(:,:) = comlev1_bibj_k, key = kkey, byte = isbyte
# endif
#endif /* NONLIN_FRSURF */

C     Make local copies of horizontal flow field
      DO j=1-OLy,sNy+OLy
       DO i=1-OLx,sNx+OLx
        uFld(i,j) = uVel(i,j,k,bi,bj)
        vFld(i,j) = vVel(i,j,k,bi,bj)
       ENDDO
      ENDDO

C     Calculate velocity field "volume transports" through tracer cell faces.
C     anelastic: transports are scaled by rhoFacC (~ mass transport)
      DO j=1-OLy,sNy+OLy
       DO i=1-OLx,sNx+OLx
        uTrans(i,j) = uFld(i,j)*xA(i,j)*rhoFacC(k)
        vTrans(i,j) = vFld(i,j)*yA(i,j)*rhoFacC(k)
       ENDDO
      ENDDO

      CALL MOM_CALC_KE( bi,bj,k,2,uFld,vFld,KE,myThid )
      IF ( useVariableVisc ) THEN
        CALL MOM_CALC_HDIV( bi,bj,k,2,uFld,vFld,hDiv,myThid )
        CALL MOM_CALC_RELVORT3( bi,bj,k,uFld,vFld,hFacZ,vort3,myThid )
        CALL MOM_CALC_TENSION( bi,bj,k,uFld,vFld,tension,myThid )
        CALL MOM_CALC_STRAIN( bi,bj,k,uFld,vFld,hFacZ,strain,myThid )
#ifdef ALLOW_LEITH_QG
        IF ( viscC2LeithQG.NE.zeroRL ) THEN
          CALL MOM_VISC_QGL_STRETCH(bi,bj,k,
     O                            stretching, Nsquare,
     I                            myTime, myIter, myThid)
          CALL MOM_VISC_QGL_LIMIT(bi,bj,k,
     O                          stretching,
     I                          Nsquare, uFld,vFld,vort3,
     I                          myTime, myIter, myThid )
        ENDIF
#endif /* ALLOW_LEITH_QG */
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
           IF ( hFacZ(i,j).EQ.0. ) THEN
             vort3(i,j)  = sideMaskFac*vort3(i,j)
             strain(i,j) = sideMaskFac*strain(i,j)
           ENDIF
         ENDDO
        ENDDO
#ifdef ALLOW_DIAGNOSTICS
        IF ( useDiagnostics ) THEN
          CALL DIAGNOSTICS_FILL(hDiv,   'momHDiv ',k,1,2,bi,bj,myThid)
          CALL DIAGNOSTICS_FILL(vort3,  'momVort3',k,1,2,bi,bj,myThid)
          CALL DIAGNOSTICS_FILL(tension,'Tension ',k,1,2,bi,bj,myThid)
          CALL DIAGNOSTICS_FILL(strain, 'Strain  ',k,1,2,bi,bj,myThid)
C     stretching will be zero, unless using QG Leith
          IF ( viscC2LeithQG.NE.zeroRL ) THEN
            CALL DIAGNOSTICS_FILL(stretching,
     I                            'Stretch ',k,1,2,bi,bj,myThid)
          ENDIF
        ENDIF
#endif
      ENDIF
#ifdef ALLOW_AUTODIFF_TAMC
C     KE is used a lot, so we save here in order to avoid multiple
C     recomputations of this variable.
CADJ STORE KE(:,:)      = comlev1_bibj_k, key = kkey, byte = isbyte
C     Variables tension and strain are relatively cheap to recompute, so
C     we do not save them here (but saving them would clearly avoid
C     the recomputations).
cCADJ STORE tension(:,:) = comlev1_bibj_k, key = kkey, byte = isbyte
cCADJ STORE strain(:,:)  = comlev1_bibj_k, key = kkey, byte = isbyte
C     hDiv and vort3 are relatively expensive to recompute, so we save
C     them here.
CADJ STORE hDiv(:,:)    = comlev1_bibj_k, key = kkey, byte = isbyte
CADJ STORE vort3(:,:)   = comlev1_bibj_k, key = kkey, byte = isbyte
#endif

C---  First call (k=1): compute vertical adv. flux fVerUkm & fVerVkm
      IF (momAdvection.AND.k.EQ.1) THEN

#ifdef MOM_BOUNDARY_CONSERVE
        CALL MOM_UV_BOUNDARY( bi, bj, k,
     I                        uVel, vVel,
     O                        uBnd(1-OLx,1-OLy,k,bi,bj),
     O                        vBnd(1-OLx,1-OLy,k,bi,bj),
     I                        myTime, myIter, myThid )
#endif /* MOM_BOUNDARY_CONSERVE */

C-    Calculate vertical transports above U & V points (West & South face):

#ifdef ALLOW_AUTODIFF_TAMC
# ifdef NONLIN_FRSURF
#  ifndef DISABLE_RSTAR_CODE
CADJ STORE dwtransc(:,:,bi,bj) = comlev1_bibj_k, key=kkey, byte=isbyte
CADJ STORE dwtransu(:,:,bi,bj) = comlev1_bibj_k, key=kkey, byte=isbyte
CADJ STORE dwtransv(:,:,bi,bj) = comlev1_bibj_k, key=kkey, byte=isbyte
#  endif
# endif /* NONLIN_FRSURF */
#endif /* ALLOW_AUTODIFF_TAMC */
        CALL MOM_CALC_RTRANS( k, bi, bj,
     O                        rTransU, rTransV,
     I                        myTime, myIter, myThid )

C-    Free surface correction term (flux at k=1)
        CALL MOM_U_ADV_WU( bi, bj, k, deepFacAdv,
     I                     uVel, wVel, rTransU,
     O                     fVerUkm, myThid )

        CALL MOM_V_ADV_WV( bi, bj, k, deepFacAdv,
     I                     vVel, wVel, rTransV,
     O                     fVerVkm, myThid )

C---  endif momAdvection & k=1
      ENDIF

C---  Calculate vertical transports (at k+1) below U & V points :
      IF (momAdvection) THEN
        CALL MOM_CALC_RTRANS( k+1, bi, bj,
     O                        rTransU, rTransV,
     I                        myTime, myIter, myThid )
      ENDIF
#ifdef ALLOW_AUTODIFF_TAMC
C     This saves us from calling the relatively expensive
C     mom_calc_rtrans in AD mode.
CADJ STORE rTransU(:,:) = comlev1_bibj_k, key = kkey, byte = isbyte
CADJ STORE rTransV(:,:) = comlev1_bibj_k, key = kkey, byte = isbyte
#endif

#ifdef MOM_BOUNDARY_CONSERVE
      IF ( momAdvection .AND. k.LT.Nr ) THEN
        CALL MOM_UV_BOUNDARY( bi, bj, k+1,
     I                        uVel, vVel,
     O                        uBnd(1-OLx,1-OLy,k+1,bi,bj),
     O                        vBnd(1-OLx,1-OLy,k+1,bi,bj),
     I                        myTime, myIter, myThid )
      ENDIF
#endif /* MOM_BOUNDARY_CONSERVE */

      IF (momViscosity) THEN
       DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
         viscAh_D(i,j) = viscAhD
         viscAh_Z(i,j) = viscAhZ
         viscA4_D(i,j) = viscA4D
         viscA4_Z(i,j) = viscA4Z
        ENDDO
       ENDDO
       IF ( useVariableVisc ) THEN
        CALL MOM_CALC_VISC( bi, bj, k,
     O           viscAh_Z, viscAh_D, viscA4_Z, viscA4_D,
     I           hDiv, vort3, tension, strain, stretching, KE, hFacZ,
     I           myThid )
       ENDIF
#ifdef ALLOW_AUTODIFF_TAMC
# ifndef AUTODIFF_ALLOW_VISCFACADJ
C     These store directive must not be here, if you want to recompute
C     these viscosity coefficients with a modified viscFacAdj = viscFacInAd
C     because the store directives intentionally prevent the recomputation.
CADJ STORE viscAh_Z(:,:) = comlev1_bibj_k, key = kkey, byte = isbyte
CADJ STORE viscAh_D(:,:) = comlev1_bibj_k, key = kkey, byte = isbyte
CADJ STORE viscA4_Z(:,:) = comlev1_bibj_k, key = kkey, byte = isbyte
CADJ STORE viscA4_D(:,:) = comlev1_bibj_k, key = kkey, byte = isbyte
# endif /* AUTODIFF_ALLOW_VISCFACADJ */
#endif /* ALLOW_AUTODIFF_TAMC */
      ENDIF

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C---- Zonal momentum equation starts here

      IF (momAdvection) THEN
C---  Calculate mean fluxes (advection)   between cells for zonal flow.

C--   For Deep-Model (deepAtmosphere=T), no need for NHMTerm w*u/r since
C     vertical advective flux (in MOM_U_ADV_WU) is changed to W*(u*deepFacC)
C     with rAdvDeepFac factor in flux divergence

#ifdef MOM_BOUNDARY_CONSERVE
        CALL MOM_U_ADV_UU( bi,bj,k,uTrans,uBnd(1-OLx,1-OLy,k,bi,bj),
     O                     fZon,myThid )
        CALL MOM_U_ADV_VU( bi,bj,k,vTrans,uBnd(1-OLx,1-OLy,k,bi,bj),
     O                     fMer,myThid )
        CALL MOM_U_ADV_WU( bi, bj, k+1, deepFacAdv,
     I                     uBnd, wVel, rTransU,
     O                     fVerUkp, myThid )
#else /* MOM_BOUNDARY_CONSERVE */
C--   Zonal flux (fZon is at east face of "u" cell)
C     Mean flow component of zonal flux -> fZon
        CALL MOM_U_ADV_UU( bi,bj,k,uTrans,uFld,fZon,myThid )

C--   Meridional flux (fMer is at south face of "u" cell)
C     Mean flow component of meridional flux -> fMer
        CALL MOM_U_ADV_VU( bi,bj,k,vTrans,uFld,fMer,myThid )

C--   Vertical flux (fVer is at upper face of "u" cell)
C     Mean flow component of vertical flux (at k+1) -> fVer
        CALL MOM_U_ADV_WU( bi, bj, k+1, deepFacAdv,
     I                     uVel, wVel, rTransU,
     O                     fVerUkp, myThid )
#endif /* MOM_BOUNDARY_CONSERVE */

C--   Tendency is minus divergence of the fluxes + coriolis + pressure term
        rAdvDeepFac = wDudrFac*rkSign
#ifndef MOM_USE_OLD_DEEP_VERT_ADV
        IF ( useNHMTerms ) rAdvDeepFac = rAdvDeepFac*recip_deepFacC(k)
#endif
        IF ( selectMetricTerms.EQ.3 ) THEN
C-      In this case fMer contains the advective flux vTrans*(u*dxC)
         DO j=jMin,jMax
          DO i=iMin,iMax
           gU(i,j,k,bi,bj) =
     &      -_recip_hFacW(i,j,k,bi,bj)*recip_drF(k)
     &      *recip_rAw(i,j,bi,bj)*recip_deepFac2C(k)*recip_rhoFacC(k)
     &      *( ( fZon( i, j ) - fZon(i-1,j ) )*uDudxFac
     &        +( fMer( i,j+1) - fMer( i, j ) )*vDudyFac
     &                                        *recip_dxC(i,j,bi,bj)
     &        +( fVerUkp(i,j) - fVerUkm(i,j) )*rAdvDeepFac
     &       )
          ENDDO
         ENDDO
        ELSE
         DO j=jMin,jMax
          DO i=iMin,iMax
           gU(i,j,k,bi,bj) =
#ifdef OLD_UV_GEOM
     &      -_recip_hFacW(i,j,k,bi,bj)*recip_drF(k)/
     &      ( 0.5 _d 0*(rA(i,j,bi,bj)+rA(i-1,j,bi,bj)) )
#else
     &      -_recip_hFacW(i,j,k,bi,bj)*recip_drF(k)
     &      *recip_rAw(i,j,bi,bj)*recip_deepFac2C(k)*recip_rhoFacC(k)
#endif
     &      *( ( fZon( i, j ) - fZon(i-1,j ) )*uDudxFac
     &        +( fMer( i,j+1) - fMer( i, j ) )*vDudyFac
     &        +( fVerUkp(i,j) - fVerUkm(i,j) )*rAdvDeepFac
     &       )
          ENDDO
         ENDDO
        ENDIF

#ifdef ALLOW_DIAGNOSTICS
        IF ( useDiagnostics ) THEN
          CALL DIAGNOSTICS_FILL( fZon,  'ADVx_Um ',k,1,2,bi,bj,myThid)
          CALL DIAGNOSTICS_FILL( fMer,  'ADVy_Um ',k,1,2,bi,bj,myThid)
          CALL DIAGNOSTICS_FILL(fVerUkm,'ADVrE_Um',k,1,2,bi,bj,myThid)
        ENDIF
#endif

#ifdef NONLIN_FRSURF
C-- account for 3.D divergence of the flow in rStar coordinate:
# ifndef DISABLE_RSTAR_CODE
        IF ( select_rStar.GT.0 ) THEN
         DO j=jMin,jMax
          DO i=iMin,iMax
           gU(i,j,k,bi,bj) = gU(i,j,k,bi,bj)
     &     - (rStarExpW(i,j,bi,bj) - 1. _d 0)/deltaTFreeSurf
     &       *uVel(i,j,k,bi,bj)
          ENDDO
         ENDDO
        ENDIF
        IF ( select_rStar.LT.0 ) THEN
         DO j=jMin,jMax
          DO i=iMin,iMax
           gU(i,j,k,bi,bj) = gU(i,j,k,bi,bj)
     &     - rStarDhWDt(i,j,bi,bj)*uVel(i,j,k,bi,bj)
          ENDDO
         ENDDO
        ENDIF
# endif /* DISABLE_RSTAR_CODE */
#endif /* NONLIN_FRSURF */

#ifdef ALLOW_ADDFLUID
        IF ( selectAddFluid.GE.1 ) THEN
         DO j=jMin,jMax
          DO i=iMin,iMax
           gU(i,j,k,bi,bj) = gU(i,j,k,bi,bj)
     &     + uVel(i,j,k,bi,bj)*mass2rUnit*0.5 _d 0
     &      *( addMass(i-1,j,k,bi,bj) + addMass(i,j,k,bi,bj) )
     &      *_recip_hFacW(i,j,k,bi,bj)*recip_drF(k)*recip_rhoFacC(k)
     &      * recip_rAw(i,j,bi,bj)*recip_deepFac2C(k)
          ENDDO
         ENDDO
        ENDIF
#endif /* ALLOW_ADDFLUID */

      ELSE
C-    if momAdvection / else
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
           gU(i,j,k,bi,bj) = 0. _d 0
         ENDDO
        ENDDO

C-    endif momAdvection.
      ENDIF

      IF (momViscosity) THEN
C---  Calculate eddy fluxes (dissipation) between cells for zonal flow.

C     Bi-harmonic term del^2 U -> del2
        IF ( useBiharmonicVisc )
     &  CALL MOM_U_DEL2U( bi, bj, k, uFld, hFacZ, h0FacZ,
     O                    del2, myThid )
#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE del2(:,:) = comlev1_bibj_k, key = kkey, byte = isbyte
#endif

C     Laplacian and bi-harmonic terms, Zonal  Fluxes -> fZon
        CALL MOM_U_XVISCFLUX( bi,bj,k,uFld,del2,fZon,
     I                        viscAh_D,viscA4_D,myThid )

C     Laplacian and bi-harmonic termis, Merid Fluxes -> fMer
        CALL MOM_U_YVISCFLUX( bi,bj,k,uFld,del2,hFacZ,fMer,
     I                        viscAh_Z,viscA4_Z,myThid )

C     Eddy component of vertical flux (interior component only) -> fVrUp & fVrDw
       IF (.NOT.implicitViscosity) THEN
        CALL MOM_U_RVISCFLUX( bi,bj, k, uVel,kappaRU,fVrUp,myThid )
        CALL MOM_U_RVISCFLUX( bi,bj,k+1,uVel,kappaRU,fVrDw,myThid )
       ENDIF

C--   Tendency is minus divergence of the fluxes
C     anelastic: hor.visc.fluxes are not scaled by rhoFac (by vert.visc.flx is)
        DO j=jMin,jMax
         DO i=iMin,iMax
          guDiss(i,j) =
#ifdef OLD_UV_GEOM
     &     -_recip_hFacW(i,j,k,bi,bj)*recip_drF(k)/
     &      ( 0.5 _d 0*(rA(i,j,bi,bj)+rA(i-1,j,bi,bj)) )
#else
     &     -_recip_hFacW(i,j,k,bi,bj)*recip_drF(k)
     &     *recip_rAw(i,j,bi,bj)*recip_deepFac2C(k)
#endif
     &     *( ( fZon(i,j  ) - fZon(i-1,j) )*AhDudxFac
     &       +( fMer(i,j+1) - fMer(i,  j) )*AhDudyFac
     &       +( fVrDw(i,j)  - fVrUp(i,j)  )*rkSign*ArDudrFac
     &                                     *recip_rhoFacC(k)
     &     )
         ENDDO
        ENDDO

#ifdef ALLOW_DIAGNOSTICS
        IF ( useDiagnostics ) THEN
          CALL DIAGNOSTICS_FILL(fZon, 'VISCx_Um',k,1,2,bi,bj,myThid)
          CALL DIAGNOSTICS_FILL(fMer, 'VISCy_Um',k,1,2,bi,bj,myThid)
          IF (.NOT.implicitViscosity)
     &    CALL DIAGNOSTICS_FILL(fVrUp,'VISrE_Um',k,1,2,bi,bj,myThid)
        ENDIF
#endif

C-- No-slip and drag BCs appear as body forces in cell abutting topography
        IF (no_slip_sides) THEN
C-     No-slip BCs impose a drag at walls...
         CALL MOM_U_SIDEDRAG( bi, bj, k,
     I        uFld, del2, h0FacZ,
     I        viscAh_Z, viscA4_Z,
     I        useHarmonicVisc, useBiharmonicVisc, useVariableVisc,
     O        gAdd,
     I        myThid )
         DO j=jMin,jMax
          DO i=iMin,iMax
           guDiss(i,j) = guDiss(i,j) + gAdd(i,j)
          ENDDO
         ENDDO
        ENDIF
C-    No-slip BCs impose a drag at bottom
        IF ( bottomDragTerms ) THEN
#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE KE(:,:) = comlev1_bibj_k, key = kkey, byte = isbyte
#endif
         CALL MOM_U_BOTDRAG_COEFF( bi, bj, k, .TRUE.,
     I                   uFld, vFld, kappaRU, KE,
     O                   cDrag,
     I                   myIter, myThid )
#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE cDrag(:,:) = comlev1_bibj_k, key = kkey, byte = isbyte
#endif
         DO j=jMin,jMax
          DO i=iMin,iMax
            guDiss(i,j) = guDiss(i,j)
     &                  - cDrag(i,j)*uFld(i,j)
     &                  *_recip_hFacW(i,j,k,bi,bj)*recip_drF(k)
          ENDDO
         ENDDO
         IF ( useDiagnostics ) THEN
          DO j=jMin,jMax
           DO i=iMin,iMax
            botDragU(i,j,bi,bj) = botDragU(i,j,bi,bj)
     &                          - cDrag(i,j)*uFld(i,j)*rUnit2mass
           ENDDO
          ENDDO
         ENDIF
        ENDIF

#ifdef ALLOW_SHELFICE
        IF ( useShelfIce .AND. selectImplicitDrag.EQ.0 ) THEN
#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE KE(:,:) = comlev1_bibj_k, key = kkey, byte = isbyte
#endif
         CALL SHELFICE_U_DRAG_COEFF( bi, bj, k, .TRUE.,
     I                   uFld, vFld, kappaRU, KE,
     O                   cDrag,
     I                   myIter, myThid )
#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE cDrag(:,:) = comlev1_bibj_k, key = kkey, byte = isbyte
#endif
         DO j=jMin,jMax
          DO i=iMin,iMax
            guDiss(i,j) = guDiss(i,j)
     &                  - cDrag(i,j)*uFld(i,j)
     &                  *_recip_hFacW(i,j,k,bi,bj)*recip_drF(k)
          ENDDO
         ENDDO
        ENDIF
#endif /* ALLOW_SHELFICE */

C-    endif momViscosity
      ENDIF

C--   Forcing term (moved to timestep.F)
c     IF (momForcing)
c    &  CALL EXTERNAL_FORCING_U(
c    I     iMin,iMax,jMin,jMax,bi,bj,k,
c    I     myTime,myThid)

C--   Metric terms for curvilinear grid systems
      diagFlag = .FALSE.
#ifdef MOM_USE_OLD_DEEP_VERT_ADV
      IF ( useNHMTerms ) THEN
#else
      IF ( useNHMTerms .AND. .NOT.deepAtmosphere ) THEN
#endif
C      o Non-Hydrostatic/vertical (spherical) metric terms
       CALL MOM_U_METRIC_NH( bi,bj,k,uFld,wVel,vMT,myThid )
       diagFlag = .TRUE.
       DO j=jMin,jMax
        DO i=iMin,iMax
         gU(i,j,k,bi,bj) = gU(i,j,k,bi,bj)+mtNHFacU*vMT(i,j)
        ENDDO
       ENDDO
#ifdef ALLOW_DIAGNOSTICS
       IF ( useDiagnostics .AND.
     &     ( selectMetricTerms.EQ.0 .OR. selectMetricTerms.EQ.3 ) ) THEN
        CALL DIAGNOSTICS_FILL( vMT, 'Um_Metr ', k,1,2, bi,bj, myThid )
       ENDIF
#endif /* ALLOW_DIAGNOSTICS */
      ENDIF
      IF ( selectMetricTerms.GE.1 .AND. selectMetricTerms.NE.3 ) THEN
       IF ( usingSphericalPolarGrid ) THEN
C      o Spherical polar grid metric terms
        CALL MOM_U_METRIC_SPHERE( bi,bj,k,uFld,vFld,gAdd,myThid )
        DO j=jMin,jMax
         DO i=iMin,iMax
          gU(i,j,k,bi,bj) = gU(i,j,k,bi,bj)+mtFacU*gAdd(i,j)
         ENDDO
        ENDDO
       ENDIF
       IF ( usingCylindricalGrid ) THEN
C      o Cylindrical grid metric terms
        CALL MOM_U_METRIC_CYLINDER( bi,bj,k,uFld,vFld,gAdd,myThid )
        DO j=jMin,jMax
         DO i=iMin,iMax
          gU(i,j,k,bi,bj) = gU(i,j,k,bi,bj)+mtFacU*gAdd(i,j)
         ENDDO
        ENDDO
       ENDIF
#ifdef ALLOW_DIAGNOSTICS
       IF ( useDiagnostics ) THEN
        IF ( diagFlag ) THEN
         DO j=jMin,jMax
          DO i=iMin,iMax
           gAdd(i,j) = gAdd(i,j) + vMT(i,j)
          ENDDO
         ENDDO
        ENDIF
        CALL DIAGNOSTICS_FILL( gAdd, 'Um_Metr ', k,1,2, bi,bj, myThid )
       ENDIF
#endif /* ALLOW_DIAGNOSTICS */
      ENDIF

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C---- Meridional momentum equation starts here

      IF (momAdvection) THEN

C--   For Deep-Model (deepAtmosphere=T), no need for NHMTerm w*v/r since
C     vertical advective flux (in MOM_V_ADV_WV) is changed to W*(v*deepFacC)
C     with rAdvDeepFac factor in flux divergence

#ifdef MOM_BOUNDARY_CONSERVE
        CALL MOM_V_ADV_UV( bi,bj,k,uTrans,vBnd(1-OLx,1-OLy,k,bi,bj),
     O                     fZon,myThid )
        CALL MOM_V_ADV_VV( bi,bj,k,vTrans,vBnd(1-OLx,1-OLy,k,bi,bj),
     O                     fMer,myThid )
        CALL MOM_V_ADV_WV( bi, bj, k+1, deepFacAdv,
     I                     vBnd, wVel, rTransV,
     O                     fVerVkp, myThid )
#else /* MOM_BOUNDARY_CONSERVE */
C---  Calculate mean fluxes (advection)   between cells for meridional flow.
C     Mean flow component of zonal flux -> fZon
        CALL MOM_V_ADV_UV( bi,bj,k,uTrans,vFld,fZon,myThid )

C--   Meridional flux (fMer is at north face of "v" cell)
C     Mean flow component of meridional flux -> fMer
        CALL MOM_V_ADV_VV( bi,bj,k,vTrans,vFld,fMer,myThid )

C--   Vertical flux (fVer is at upper face of "v" cell)
C     Mean flow component of vertical flux (at k+1) -> fVerV
        CALL MOM_V_ADV_WV( bi, bj, k+1, deepFacAdv,
     I                     vVel, wVel, rTransV,
     O                     fVerVkp, myThid )
#endif /* MOM_BOUNDARY_CONSERVE */

C--   Tendency is minus divergence of the fluxes + coriolis + pressure term
        rAdvDeepFac = wDvdrFac*rkSign
#ifndef MOM_USE_OLD_DEEP_VERT_ADV
        IF ( useNHMTerms ) rAdvDeepFac = rAdvDeepFac*recip_deepFacC(k)
#endif
        DO j=jMin,jMax
         DO i=iMin,iMax
          gV(i,j,k,bi,bj) =
#ifdef OLD_UV_GEOM
     &     -_recip_hFacS(i,j,k,bi,bj)*recip_drF(k)/
     &      ( 0.5 _d 0*(_rA(i,j,bi,bj)+_rA(i,j-1,bi,bj)) )
#else
     &     -_recip_hFacS(i,j,k,bi,bj)*recip_drF(k)
     &     *recip_rAs(i,j,bi,bj)*recip_deepFac2C(k)*recip_rhoFacC(k)
#endif
     &     *( ( fZon(i+1,j)  - fZon(i,j  )  )*uDvdxFac
     &       +( fMer(i,  j)  - fMer(i,j-1)  )*vDvdyFac
     &       +( fVerVkp(i,j) - fVerVkm(i,j) )*rAdvDeepFac
     &     )
         ENDDO
        ENDDO

#ifdef ALLOW_DIAGNOSTICS
        IF ( useDiagnostics ) THEN
          CALL DIAGNOSTICS_FILL( fZon,  'ADVx_Vm ',k,1,2,bi,bj,myThid)
          CALL DIAGNOSTICS_FILL( fMer,  'ADVy_Vm ',k,1,2,bi,bj,myThid)
          CALL DIAGNOSTICS_FILL(fVerVkm,'ADVrE_Vm',k,1,2,bi,bj,myThid)
        ENDIF
#endif

#ifdef NONLIN_FRSURF
C-- account for 3.D divergence of the flow in rStar coordinate:
# ifndef DISABLE_RSTAR_CODE
        IF ( select_rStar.GT.0 ) THEN
         DO j=jMin,jMax
          DO i=iMin,iMax
           gV(i,j,k,bi,bj) = gV(i,j,k,bi,bj)
     &     - (rStarExpS(i,j,bi,bj) - 1. _d 0)/deltaTFreeSurf
     &       *vVel(i,j,k,bi,bj)
          ENDDO
         ENDDO
        ENDIF
        IF ( select_rStar.LT.0 ) THEN
         DO j=jMin,jMax
          DO i=iMin,iMax
           gV(i,j,k,bi,bj) = gV(i,j,k,bi,bj)
     &     - rStarDhSDt(i,j,bi,bj)*vVel(i,j,k,bi,bj)
          ENDDO
         ENDDO
        ENDIF
# endif /* DISABLE_RSTAR_CODE */
#endif /* NONLIN_FRSURF */

#ifdef ALLOW_ADDFLUID
        IF ( selectAddFluid.GE.1 ) THEN
         DO j=jMin,jMax
          DO i=iMin,iMax
           gV(i,j,k,bi,bj) = gV(i,j,k,bi,bj)
     &     + vVel(i,j,k,bi,bj)*mass2rUnit*0.5 _d 0
     &      *( addMass(i,j-1,k,bi,bj) + addMass(i,j,k,bi,bj) )
     &      *_recip_hFacS(i,j,k,bi,bj)*recip_drF(k)*recip_rhoFacC(k)
     &      * recip_rAs(i,j,bi,bj)*recip_deepFac2C(k)
          ENDDO
         ENDDO
        ENDIF
#endif /* ALLOW_ADDFLUID */

      ELSE
C-    if momAdvection / else
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
           gV(i,j,k,bi,bj) = 0. _d 0
         ENDDO
        ENDDO

C-    endif momAdvection.
      ENDIF

      IF (momViscosity) THEN
C---  Calculate eddy fluxes (dissipation) between cells for meridional flow.
C     Bi-harmonic term del^2 V -> del2
        IF ( useBiharmonicVisc )
     &  CALL MOM_V_DEL2V( bi, bj, k, vFld, hFacZ, h0FacZ,
     O                    del2, myThid )
#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE del2(:,:) = comlev1_bibj_k, key = kkey, byte = isbyte
#endif

C     Laplacian and bi-harmonic terms, Zonal  Fluxes -> fZon
        CALL MOM_V_XVISCFLUX( bi,bj,k,vFld,del2,hFacZ,fZon,
     I                        viscAh_Z,viscA4_Z,myThid )

C     Laplacian and bi-harmonic termis, Merid Fluxes -> fMer
        CALL MOM_V_YVISCFLUX( bi,bj,k,vFld,del2,fMer,
     I                        viscAh_D,viscA4_D,myThid )

C     Eddy component of vertical flux (interior component only) -> fVrUp & fVrDw
       IF (.NOT.implicitViscosity) THEN
        CALL MOM_V_RVISCFLUX( bi,bj, k, vVel,KappaRV,fVrUp,myThid )
        CALL MOM_V_RVISCFLUX( bi,bj,k+1,vVel,KappaRV,fVrDw,myThid )
       ENDIF

C--   Tendency is minus divergence of the fluxes + coriolis + pressure term
C     anelastic: hor.visc.fluxes are not scaled by rhoFac (by vert.visc.flx is)
        DO j=jMin,jMax
         DO i=iMin,iMax
          gvDiss(i,j) =
#ifdef OLD_UV_GEOM
     &     -_recip_hFacS(i,j,k,bi,bj)*recip_drF(k)/
     &      ( 0.5 _d 0*(_rA(i,j,bi,bj)+_rA(i,j-1,bi,bj)) )
#else
     &     -_recip_hFacS(i,j,k,bi,bj)*recip_drF(k)
     &      *recip_rAs(i,j,bi,bj)*recip_deepFac2C(k)
#endif
     &     *( ( fZon(i+1,j)  - fZon(i,j  ) )*AhDvdxFac
     &       +( fMer(i,  j)  - fMer(i,j-1) )*AhDvdyFac
     &       +( fVrDw(i,j)   - fVrUp(i,j) )*rkSign*ArDvdrFac
     &                                     *recip_rhoFacC(k)
     &     )
         ENDDO
        ENDDO

#ifdef ALLOW_DIAGNOSTICS
        IF ( useDiagnostics ) THEN
          CALL DIAGNOSTICS_FILL(fZon, 'VISCx_Vm',k,1,2,bi,bj,myThid)
          CALL DIAGNOSTICS_FILL(fMer, 'VISCy_Vm',k,1,2,bi,bj,myThid)
          IF (.NOT.implicitViscosity)
     &    CALL DIAGNOSTICS_FILL(fVrUp,'VISrE_Vm',k,1,2,bi,bj,myThid)
        ENDIF
#endif

C-- No-slip and drag BCs appear as body forces in cell abutting topography
        IF (no_slip_sides) THEN
C-     No-slip BCs impose a drag at walls...
         CALL MOM_V_SIDEDRAG( bi, bj, k,
     I        vFld, del2, h0FacZ,
     I        viscAh_Z, viscA4_Z,
     I        useHarmonicVisc, useBiharmonicVisc, useVariableVisc,
     O        gAdd,
     I        myThid )
         DO j=jMin,jMax
          DO i=iMin,iMax
           gvDiss(i,j) = gvDiss(i,j) + gAdd(i,j)
          ENDDO
         ENDDO
        ENDIF
C-    No-slip BCs impose a drag at bottom
        IF ( bottomDragTerms ) THEN
#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE KE(:,:) = comlev1_bibj_k, key = kkey, byte = isbyte
#endif
         CALL MOM_V_BOTDRAG_COEFF( bi, bj, k, .TRUE.,
     I                   uFld, vFld, kappaRV, KE,
     O                   cDrag,
     I                   myIter, myThid )
#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE cDrag(:,:) = comlev1_bibj_k, key = kkey, byte = isbyte
#endif
         DO j=jMin,jMax
          DO i=iMin,iMax
            gvDiss(i,j) = gvDiss(i,j)
     &                  - cDrag(i,j)*vFld(i,j)
     &                  *_recip_hFacS(i,j,k,bi,bj)*recip_drF(k)
          ENDDO
         ENDDO
         IF ( useDiagnostics ) THEN
          DO j=jMin,jMax
           DO i=iMin,iMax
            botDragV(i,j,bi,bj) = botDragV(i,j,bi,bj)
     &                          - cDrag(i,j)*vFld(i,j)*rUnit2mass
           ENDDO
          ENDDO
         ENDIF
        ENDIF

#ifdef ALLOW_SHELFICE
        IF ( useShelfIce .AND. selectImplicitDrag.EQ.0 ) THEN
#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE KE(:,:) = comlev1_bibj_k, key = kkey, byte = isbyte
#endif
         CALL SHELFICE_V_DRAG_COEFF( bi, bj, k, .TRUE.,
     I                   uFld, vFld, kappaRV, KE,
     O                   cDrag,
     I                   myIter, myThid )
#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE cDrag(:,:) = comlev1_bibj_k, key = kkey, byte = isbyte
#endif
         DO j=jMin,jMax
          DO i=iMin,iMax
            gvDiss(i,j) = gvDiss(i,j)
     &                  - cDrag(i,j)*vFld(i,j)
     &                  *_recip_hFacS(i,j,k,bi,bj)*recip_drF(k)
          ENDDO
         ENDDO
        ENDIF
#endif /* ALLOW_SHELFICE */

C-    endif momViscosity
      ENDIF

C--   Forcing term (moved to timestep.F)
c     IF (momForcing)
c    & CALL EXTERNAL_FORCING_V(
c    I     iMin,iMax,jMin,jMax,bi,bj,k,
c    I     myTime,myThid)

C--   Metric terms for curvilinear grid systems
      diagFlag = .FALSE.
#ifdef MOM_USE_OLD_DEEP_VERT_ADV
      IF ( useNHMTerms ) THEN
#else
      IF ( useNHMTerms .AND. .NOT.deepAtmosphere ) THEN
#endif
C      o Non-Hydrostatic/vertical (spherical) metric terms
       CALL MOM_V_METRIC_NH( bi,bj,k,vFld,wVel,vMT,myThid )
       diagFlag = .TRUE.
       DO j=jMin,jMax
        DO i=iMin,iMax
         gV(i,j,k,bi,bj) = gV(i,j,k,bi,bj)+mtNHFacV*vMT(i,j)
        ENDDO
       ENDDO
#ifdef ALLOW_DIAGNOSTICS
       IF ( useDiagnostics .AND. selectMetricTerms.EQ.0 ) THEN
        CALL DIAGNOSTICS_FILL( vMT, 'Vm_Metr ', k,1,2, bi,bj, myThid )
       ENDIF
#endif /* ALLOW_DIAGNOSTICS */
      ENDIF
      IF ( selectMetricTerms.GE.1 ) THEN
       IF ( usingSphericalPolarGrid ) THEN
C      o Spherical polar grid metric terms
        CALL MOM_V_METRIC_SPHERE( bi,bj,k,uFld,gAdd,myThid )
        DO j=jMin,jMax
         DO i=iMin,iMax
          gV(i,j,k,bi,bj) = gV(i,j,k,bi,bj)+mtFacV*gAdd(i,j)
         ENDDO
        ENDDO
       ENDIF
       IF ( usingCylindricalGrid ) THEN
C      o Cylindrical grid metric terms
        CALL MOM_V_METRIC_CYLINDER( bi,bj,k,uFld,vFld,gAdd,myThid )
        DO j=jMin,jMax
         DO i=iMin,iMax
          gV(i,j,k,bi,bj) = gV(i,j,k,bi,bj)+mtFacV*gAdd(i,j)
         ENDDO
        ENDDO
       ENDIF
#ifdef ALLOW_DIAGNOSTICS
       IF ( useDiagnostics ) THEN
        IF ( diagFlag ) THEN
         DO j=jMin,jMax
          DO i=iMin,iMax
           gAdd(i,j) = gAdd(i,j) + vMT(i,j)
          ENDDO
         ENDDO
        ENDIF
        CALL DIAGNOSTICS_FILL( gAdd, 'Vm_Metr ', k,1,2, bi,bj, myThid )
       ENDIF
#endif /* ALLOW_DIAGNOSTICS */
      ENDIF

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C--   Coriolis term (call to CD_CODE_SCHEME has been moved to timestep.F)
      IF ( .NOT.useCDscheme ) THEN
#if ( defined ALLOW_GGL90 && defined ALLOW_GGL90_LANGMUIR )
       IF ( useLANGMUIR ) THEN
        CALL GGL90_ADD_STOKESDRIFT(
     O                 uRes, vRes,
     I                 uFld, vFld, k, bi, bj, myThid )
        CALL MOM_U_CORIOLIS( bi,bj,k,vRes,uCf,myThid )
        CALL MOM_V_CORIOLIS( bi,bj,k,uRes,vCf,myThid )
       ELSE
#endif
        CALL MOM_U_CORIOLIS( bi,bj,k,vFld,uCf,myThid )
        CALL MOM_V_CORIOLIS( bi,bj,k,uFld,vCf,myThid )
#if ( defined ALLOW_GGL90 && defined ALLOW_GGL90_LANGMUIR )
       ENDIF
#endif
        DO j=jMin,jMax
         DO i=iMin,iMax
          gU(i,j,k,bi,bj) = gU(i,j,k,bi,bj) + fuFac*uCf(i,j)
          gV(i,j,k,bi,bj) = gV(i,j,k,bi,bj) + fvFac*vCf(i,j)
         ENDDO
        ENDDO
#ifdef ALLOW_DIAGNOSTICS
        IF ( useDiagnostics ) THEN
          CALL DIAGNOSTICS_FILL( uCf,'Um_Cori ',k,1,2,bi,bj,myThid )
          CALL DIAGNOSTICS_FILL( vCf,'Vm_Cori ',k,1,2,bi,bj,myThid )
        ENDIF
#endif
      ENDIF

C--   3.D Coriolis term (horizontal momentum, Eastward component: -fprime*w)
      IF ( select3dCoriScheme.GE.1 ) THEN
        CALL MOM_U_CORIOLIS_NH( bi,bj,k,wVel,uCf,myThid )
        DO j=jMin,jMax
         DO i=iMin,iMax
          gU(i,j,k,bi,bj) = gU(i,j,k,bi,bj) + fuFac*uCf(i,j)
         ENDDO
        ENDDO
       IF ( usingCurvilinearGrid .OR. rotateGrid ) THEN
C-     presently, non zero angleSinC array only supported with Curvilinear-Grid
        CALL MOM_V_CORIOLIS_NH( bi,bj,k,wVel,vCf,myThid )
        DO j=jMin,jMax
         DO i=iMin,iMax
          gV(i,j,k,bi,bj) = gV(i,j,k,bi,bj) + fvFac*vCf(i,j)
         ENDDO
        ENDDO
       ENDIF
      ENDIF

C--   Set du/dt & dv/dt on boundaries to zero
      DO j=jMin,jMax
       DO i=iMin,iMax
        gU(i,j,k,bi,bj) = gU(i,j,k,bi,bj)*_maskW(i,j,k,bi,bj)
        guDiss(i,j)     = guDiss(i,j)    *_maskW(i,j,k,bi,bj)
        gV(i,j,k,bi,bj) = gV(i,j,k,bi,bj)*_maskS(i,j,k,bi,bj)
        gvDiss(i,j)     = gvDiss(i,j)    *_maskS(i,j,k,bi,bj)
       ENDDO
      ENDDO

#ifdef ALLOW_DIAGNOSTICS
      IF ( useDiagnostics ) THEN
        CALL DIAGNOSTICS_FILL(KE,    'momKE   ',k,1,2,bi,bj,myThid)
        CALL DIAGNOSTICS_FILL(gU(1-OLx,1-OLy,k,bi,bj),
     &                               'Um_Advec',k,1,2,bi,bj,myThid)
        CALL DIAGNOSTICS_FILL(gV(1-OLx,1-OLy,k,bi,bj),
     &                               'Vm_Advec',k,1,2,bi,bj,myThid)
      ENDIF
#endif /* ALLOW_DIAGNOSTICS */

      RETURN
      END

#include "SALT_PLUME_OPTIONS.h"

CBOP 0
C     !ROUTINE: SALT_PLUME_MNC_INIT
C     !INTERFACE:
      SUBROUTINE SALT_PLUME_MNC_INIT( myThid )

C     !DESCRIPTION:
C     Initialize MNC lookup tables for Mypackage.

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "SALT_PLUME.h"

C     !INPUT PARAMETERS:
      INTEGER myThid
CEOP

#ifdef ALLOW_SALT_PLUME
#ifdef ALLOW_MNC

      IF (useMNC) THEN

       CALL MNC_CW_ADD_VNAME('saltPlumeFlux', 'Cen_xy_Hn__-__t', 3,4,
     &                       myThid)
       CALL MNC_CW_ADD_VATTR_TEXT('saltPlumeFlux','units','g/m^2/s',
     &                            myThid)
       CALL MNC_CW_ADD_VATTR_TEXT('saltPlumeFlux','description',
     &     'Net downward salt flux rejected during freezing', myThid)

      ENDIF

#endif /* ALLOW_MNC */
#endif /* ALLOW_SALT_PLUME */

      RETURN
      END

#include "CTRL_OPTIONS.h"

      subroutine optim_readparms(
     I                            myThid )

c     ==================================================================
c     SUBROUTINE optim_readparms
c     ==================================================================
c
c     o Initialise the optimization part of the ECCO release.
c
c     started: Christian Eckert eckert@mit.edu 03-Mar-2000
c
c     changed:
c
c     ==================================================================
c     SUBROUTINE optim_readparms
c     ==================================================================

      IMPLICIT NONE

c     == global variables ==
#include "EEPARAMS.h"
#include "SIZE.h"
#include "PARAMS.h"
#include "OPTIMCYCLE.h"

c     == routine arguments ==
      INTEGER myThid

c     == local variables ==
      INTEGER iUnit
c     this is a dummy parameter that is never used; it is introduced here
c     so that we can have compatible namelists between mitgmcuv_ad and
c     optim.x compiled from optim_m1qn3
      _RL dfminFrac
      CHARACTER*(MAX_LEN_MBUF) msgBuf

C     These variables were formerly defined in optim.h, but they are
C     only used in the offline optimization, but never within the
C     MITgcm.  packages. We define them here locally to allow to keep
C     the namelist intact.
      INTEGER nvars
      INTEGER numiter
      INTEGER nfunc
      INTEGER iprint
      INTEGER nupdate
      _RL epsf
      _RL epsx
      _RL fmin
      _RL epsg
      _RL eps
      LOGICAL nondimcontrol

c     == end of interface ==

c--   Optimization parameters.
      NAMELIST /optim/
     &                 optimcycle, nvars,
     &                 nondimcontrol,
     &                 numiter, nfunc, fmin, dfminFrac, iprint,
     &                 epsf, epsx, epsg,
     &                 nupdate, eps

      IF ( .NOT.useCTRL ) THEN
C-    pkg CTRL is not used
        _BEGIN_MASTER(myThid)
C-    Track pkg activation status:
C     print a (weak) warning if data.optim is found
         CALL PACKAGES_UNUSED_MSG( 'useCTRL',
     I                             'OPTIM_READPARMS', 'optim' )
        _END_MASTER(myThid)
        RETURN
      ENDIF

      _BEGIN_MASTER( myThid )

c--     Set default values.
        optimcycle    =   0
        nvars         =  10
        nondimcontrol =  .false.
        numiter       =   0
        nfunc         =   1
        fmin          =   0.0 _d 0
        dfminFrac     =   0.0 _d 0
        iprint        =  10
        epsx          =   1.e-6
        epsg          =   1.e-6
        eps           =  -1.e-6
        nupdate       =   0

        WRITE(msgBuf,'(A)') 'OPTIM_READPARMS: opening data.optim'
        CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT , 1)

        CALL OPEN_COPY_DATA_FILE(
     I                          'data.optim', 'OPTIM_READPARMS',
     O                          iUnit,
     I                          myThid )

        READ(unit = iUnit, nml = optim)

        WRITE(msgBuf,'(A)')
     &       'OPTIM_READPARMS: finished reading data.optim'
        CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                  SQUEEZE_RIGHT , 1)

#ifdef SINGLE_DISK_IO
        CLOSE(iUnit)
#else
        CLOSE(iUnit,STATUS='DELETE')
#endif /* SINGLE_DISK_IO */

      _END_MASTER( myThid )

      _BARRIER

      RETURN
      END

#include "MONITOR_OPTIONS.h"
#ifdef ALLOW_AUTODIFF
# include "AUTODIFF_OPTIONS.h"
#endif
#ifdef ALLOW_CTRL
# include "CTRL_OPTIONS.h"
#endif
#include "AD_CONFIG.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: MONITOR

C     !INTERFACE:
      SUBROUTINE ADMONITOR(
     I                      myTime, myIter, myThid )

C     !DESCRIPTION:
C     Monitor key dynamical variables: calculate over the full domain
C      some simple statistics (e.g., min,max,average) and write them.

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "MONITOR.h"
#ifdef ALLOW_MNC
# include "MNC_PARAMS.h"
#endif
#ifdef ALLOW_AUTODIFF_MONITOR
# include "AUTODIFF_PARAMS.h"
# include "adcommon.h"
#endif

C     !INPUT PARAMETERS:
      _RL myTime
      INTEGER myIter
      INTEGER myThid
CEOP

#if (defined (ALLOW_ADJOINT_RUN) || defined (ALLOW_ADMTLM))
#ifdef ALLOW_AUTODIFF_MONITOR

C     === Functions ====
      LOGICAL  DIFFERENT_MULTIPLE
      EXTERNAL DIFFERENT_MULTIPLE
      LOGICAL  MASTER_CPU_IO
      EXTERNAL MASTER_CPU_IO

C     !LOCAL VARIABLES:
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      _RL dummyRL(6)
      INTEGER k
      _RL var2Du(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL var2Dv(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL var3Du(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      _RL var3Dv(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      _RS dumRS(1)
      _RL dumRL(1)

      IF ( DIFFERENT_MULTIPLE(adjMonitorFreq,myTime,deltaTClock) ) THEN

        IF ( MASTER_CPU_IO(myThid) ) THEN
C--   only the master thread is allowed to switch On/Off mon_write_stdout
C     & mon_write_mnc (since it is the only thread that uses those flags):

          IF (monitor_stdio) THEN
            mon_write_stdout = .TRUE.
          ELSE
            mon_write_stdout = .FALSE.
          ENDIF
          mon_write_mnc = .FALSE.
#ifdef ALLOW_MNC
          IF (useMNC .AND. monitor_mnc) THEN
            DO k = 1,MAX_LEN_MBUF
              mon_fname(k:k) = ' '
            ENDDO
            mon_fname(1:9) = 'admonitor'
            CALL MNC_CW_APPEND_VNAME(
     &           'T', '-_-_--__-__t', 0,0, myThid)
            CALL MNC_CW_SET_UDIM(mon_fname, -1, myThid)
            CALL MNC_CW_RL_W_S(
     &          'D',mon_fname,1,1,'T', myTime, myThid)
            CALL MNC_CW_SET_UDIM(mon_fname, 0, myThid)
            mon_write_mnc = .TRUE.
          ENDIF
#endif /* ALLOW_MNC */

C       Dynamics field monitor start
          IF ( mon_write_stdout ) THEN
            WRITE(msgBuf,'(2A)') '// ==========================',
     &             '============================='
            CALL PRINT_MESSAGE( msgBuf, mon_ioUnit, SQUEEZE_RIGHT , 1)
            WRITE(msgBuf,'(A)')
     &             '// Begin AD_MONITOR dynamic field statistics'
            CALL PRINT_MESSAGE( msgBuf, mon_ioUnit, SQUEEZE_RIGHT , 1)
            WRITE(msgBuf,'(2A)') '// ==========================',
     &             '============================='
            CALL PRINT_MESSAGE( msgBuf, mon_ioUnit, SQUEEZE_RIGHT , 1)
          ENDIF

C--   endif master cpu io
        ENDIF

C       Print the time to make grepping the stdout easier
        CALL MON_SET_PREF('ad_time',myThid)
        CALL MON_OUT_I( '_tsnumber', myIter,mon_string_none,myThid)
        CALL MON_OUT_RL('_secondsf', myTime,mon_string_none,myThid)

C       Print the basic statistics of model state variables
        CALL MON_SET_PREF('ad_dynstat',myThid)
        IF ( mon_AdVarExch.EQ.1 ) THEN
#ifndef AUTODIFF_TAMC_COMPATIBILITY
          CALL ADEXCH_3D_RL(  adEtaN, 1 , myThid )
          CALL ADEXCH_UV_3D_RL( aduVel, advVel, .TRUE., Nr, myThid )
          CALL ADEXCH_3D_RL( adwVel,  Nr, myThid )
          CALL ADEXCH_3D_RL( adTheta, Nr, myThid )
          CALL ADEXCH_3D_RL( adSalt,  Nr, myThid )
#endif
        ENDIF
        IF ( mon_AdVarExch.NE.2 ) THEN
          CALL MON_WRITESTATS_RL(  1, adEtaN, '_adeta',
     &             maskInC, maskInC, rA , drF, dummyRL, myThid )
          CALL MON_WRITESTATS_RL( Nr, aduVel, '_aduvel',
     &             hFacW, maskInW, rAw, drF, dummyRL, myThid )
          CALL MON_WRITESTATS_RL( Nr, advVel, '_advvel',
     &             hFacS, maskInS, rAs, drF, dummyRL, myThid )
          CALL MON_WRITESTATS_RL( Nr, adwVel, '_adwvel',
     &             maskC, maskInC, rA , drC, dummyRL, myThid )
          CALL MON_WRITESTATS_RL( Nr, adTheta,'_adtheta',
     &             hFacC, maskInC, rA , drF, dummyRL, myThid )
          CALL MON_WRITESTATS_RL( Nr, adSalt, '_adsalt',
     &             hFacC, maskInC, rA , drF, dummyRL, myThid )
          IF ( monitorSelect.GE.3 .AND.
     &         nSx.EQ.1 .AND. nSy.EQ.1 ) THEN
C-      print stats only if nSx=nSy=1 since otherwise stats are wrong
           k = 1
           IF ( usingPCoords ) k = Nr
           CALL MON_WRITESTATS_RL( 1, adTheta(1-OLx,1-OLy,k,1,1),
     &          '_adsst', maskInC, maskInC, rA, drF, dummyRL, myThid )
           CALL MON_WRITESTATS_RL( 1, adSalt(1-OLx,1-OLy,k,1,1),
     &          '_adsss', maskInC, maskInC, rA, drF, dummyRL, myThid )
          ENDIF
        ELSE
C       case dumpAdVarExch = 2
          CALL COPY_ADVAR_OUTP( dumRS, adEtaN, var2Du, 1 , 12, myThid )
          CALL MON_WRITESTATS_RL(  1, var2Du, '_adeta',
     &             maskInC, maskInC, rA , drF, dummyRL, myThid )

          CALL COPY_AD_UV_OUTP( dumRS, dumRS, aduVel, advVel,
     &                                 var3Du, var3Dv, Nr, 34, myThid )
          CALL MON_WRITESTATS_RL( Nr, var3Du, '_aduvel',
     &             hFacW, maskInW, rAw, drF, dummyRL, myThid )
          CALL MON_WRITESTATS_RL( Nr, var3Dv, '_advvel',
     &             hFacS, maskInS, rAs, drF, dummyRL, myThid )

          CALL COPY_ADVAR_OUTP( dumRS, adwVel, var3Du, Nr, 12, myThid )
          CALL MON_WRITESTATS_RL( Nr, var3Du, '_adwvel',
     &             maskC, maskInC, rA , drC, dummyRL, myThid )
          CALL COPY_ADVAR_OUTP( dumRS, adTheta,var3Du, Nr, 12, myThid )
          CALL COPY_ADVAR_OUTP( dumRS, adSalt, var3Dv, Nr, 12, myThid )
          CALL MON_WRITESTATS_RL( Nr, var3Du, '_adtheta',
     &             hFacC, maskInC, rA , drF, dummyRL, myThid )
          CALL MON_WRITESTATS_RL( Nr, var3Dv, '_adsalt',
     &             hFacC, maskInC, rA , drF, dummyRL, myThid )
          IF ( monitorSelect.GE.3 .AND.
     &         nSx.EQ.1 .AND. nSy.EQ.1 ) THEN
C-      print stats only if nSx=nSy=1 since otherwise stats are wrong
           k = 1
           IF ( usingPCoords ) k = Nr
           CALL MON_WRITESTATS_RL( 1, var3Du(1-OLx,1-OLy,k,1,1),
     &          '_adsst', maskInC, maskInC, rA, drF, dummyRL, myThid )
           CALL MON_WRITESTATS_RL( 1, var3Dv(1-OLx,1-OLy,k,1,1),
     &          '_adsss', maskInC, maskInC, rA, drF, dummyRL, myThid )
          ENDIF
        ENDIF

C       Print the basic statistics of external forcing
        IF ( monitorSelect.GE.4 ) THEN
          CALL MON_SET_PREF('ad_forcing',myThid)
          IF ( mon_AdVarExch.NE.2 ) THEN
           CALL MON_WRITESTATS_RS( 1, adQnet, '_adqnet',
     &              maskInC, maskInC, rA , drF, dummyRL, myThid )
#ifdef SHORTWAVE_HEATING
           CALL MON_WRITESTATS_RS( 1, adQsw , '_adqsw',
     &              maskInC, maskInC, rA , drF, dummyRL, myThid )
#endif
           CALL MON_WRITESTATS_RS( 1, adEmPmR,'_adempmr',
     &              maskInC, maskInC, rA , drF, dummyRL, myThid )
           CALL MON_WRITESTATS_RS( 1, adfu ,  '_adfu',
     &              maskInW, maskInW, rAw, drF, dummyRL, myThid )
           CALL MON_WRITESTATS_RS( 1, adfv ,  '_adfv',
     &              maskInS, maskInS, rAs, drF, dummyRL, myThid )
          ELSE
C       case dumpAdVarExch = 2
           CALL COPY_ADVAR_OUTP( adQnet, dumRL, var2Du, 1, 11, myThid )
           CALL MON_WRITESTATS_RL( 1, var2Du, '_adqnet',
     &              maskInC, maskInC, rA , drF, dummyRL, myThid )
#ifdef SHORTWAVE_HEATING
           CALL COPY_ADVAR_OUTP( adQsw,  dumRL, var2Du, 1, 11, myThid )
           CALL MON_WRITESTATS_RL( 1, var2Du, '_adqsw',
     &              maskInC, maskInC, rA , drF, dummyRL, myThid )
#endif
           CALL COPY_ADVAR_OUTP( adEmPmR,dumRL, var2Du, 1, 11, myThid )
           CALL MON_WRITESTATS_RL( 1, var2Du, '_adempmr',
     &              maskInC, maskInC, rA , drF, dummyRL, myThid )
           CALL COPY_AD_UV_OUTP( adFu, adFv, dumRL, dumRL,
     &                                  var2Du, var2Dv, 1, 33, myThid )
           CALL MON_WRITESTATS_RL( 1, var2Du, '_adfu',
     &              maskInW, maskInW, rAw, drF, dummyRL, myThid )
           CALL MON_WRITESTATS_RL( 1, var2Dv, '_adfv',
     &              maskInS, maskInS, rAs, drF, dummyRL, myThid )
          ENDIF
        ENDIF

C       Dynamics field monitor finish
        IF ( MASTER_CPU_IO(myThid) ) THEN
C--   only the master thread is allowed to switch On/Off mon_write_stdout
C     & mon_write_mnc (since it is the only thread that uses those flags):

          IF ( mon_write_stdout ) THEN
            WRITE(msgBuf,'(2A)') '// ==========================',
     &             '============================='
            CALL PRINT_MESSAGE( msgBuf, mon_ioUnit, SQUEEZE_RIGHT , 1)
            WRITE(msgBuf,'(A)')
     &             '// End AD_MONITOR dynamic field statistics'
            CALL PRINT_MESSAGE( msgBuf, mon_ioUnit, SQUEEZE_RIGHT , 1)
            WRITE(msgBuf,'(2A)') '// ==========================',
     &             '============================='
            CALL PRINT_MESSAGE( msgBuf, mon_ioUnit, SQUEEZE_RIGHT , 1)
          ENDIF

          mon_write_stdout = .FALSE.
          mon_write_mnc    = .FALSE.

C--   endif master cpu io
        ENDIF

C     endif different multiple
      ENDIF

#ifdef ALLOW_EXF
cph This case is handled separately in exf_adjoint_snapshots_ad.F
#endif

#ifdef ALLOW_SEAICE
      CALL ADSEAICE_MONITOR ( myTime, myIter, myThid )
#endif

#ifdef ALLOW_PTRACERS
      CALL ADPTRACERS_MONITOR ( myTime, myIter, myThid )
#endif

#endif /* ALLOW_AUTODIFF_MONITOR */
#endif /* ALLOW_ADJOINT_RUN */

      RETURN
      END

#include "FIZHI_OPTIONS.h"
       subroutine step_fizhi_fg (myTime, myIter, myThid, dt)
c-----------------------------------------------------------------------
c  Subroutine step_fizhi_fg - 'Wrapper' routine to advance
c        the physics state and make a 'first guess' at the new
c        value. At this point, increment with the physics 
c        tendency only. 
c        Also: Set up "bi, bj loop" and some timers and clocks here.
c Call: step_physics
c-----------------------------------------------------------------------
       implicit none
#include "SIZE.h"
#include "fizhi_SIZE.h"
#include "fizhi_land_SIZE.h"
#include "fizhi_coms.h"
#include "gridalt_mapping.h"
#include "EEPARAMS.h"
#include "DYNVARS.h"
#include "GRID.h"

       integer myIter, myThid 
       _RL myTime

       integer bi, bj
       integer im1, im2, jm1, jm2, idim1, idim2, jdim1, jdim2
       _RL dt

       _RL tempij(sNx,sNy)
       integer i,j,L

       idim1 = 1-OLx
       idim2 = sNx+OLx
       jdim1 = 1-OLy
       jdim2 = sNy+OLy
       im1 = 1
       im2 = sNx
       jm1 = 1
       jm2 = sNy

       do bj = myByLo(myThid), myByHi(myThid)
       do bi = myBxLo(myThid), myBxHi(myThid)

c  Step forward the physics state using physics tendencies
        call step_physics(uphy,vphy,thphy,sphy,dt,idim1,idim2,
     .      jdim1,jdim2,
     .      Nrphys,Nsx,Nsy,1,sNx,1,sNy,bi,bj,duphy,dvphy,dthphy,dsphy)

      if(2.eq.1 )then
      print *,' In step fizhi fg, new fizhi fields ',bi,' dt= ',dt
      do L = 1,Nrphys
       do j = jm1,jm2
       do i = im1,im2
        tempij(i,j) = uphy(i,j,L,bi,bj)
       enddo
       enddo
c      print *,' uphy at level ',l,' ',tempij
      enddo
      do L = 1,Nrphys
       do j = jm1,jm2
       do i = im1,im2
        tempij(i,j) = vphy(i,j,L,bi,bj)
       enddo
       enddo
c      print *,' vphy at level ',l,' ',tempij
      enddo
      do L = 1,Nrphys
       do j = jm1,jm2
       do i = im1,im2
        tempij(i,j) = thphy(i,j,L,bi,bj)
       enddo
       enddo
       print *,' thphy at level ',l,' ',tempij
      enddo
      do L = 1,Nrphys
       do j = jm1,jm2
       do i = im1,im2
        tempij(i,j) = sphy(i,j,L,bi,bj)
       enddo
       enddo
       print *,' sphy at level ',l,' ',tempij
      enddo
      endif

        call qcheck (idim1,idim2,jdim1,jdim2,Nrphys,Nsx,Nsy,im1,im2,
     .       jm1,jm2,bi,bj,dpphys,sphy)

      if(2.eq.1 )then
      print *,' In step fizhi fg after qcheck ',bi
      do L = 1,Nrphys
       do j = jm1,jm2
       do i = im1,im2
        tempij(i,j) = sphy(i,j,L,bi,bj)
       enddo
       enddo
       print *,' sphy after qcheck at level ',l,' ',tempij
      enddo
      endif

       enddo
       enddo

       return
       end

#include "EXF_OPTIONS.h"
#ifdef ALLOW_EXCH2
# include "W2_OPTIONS.h"
#endif /* ALLOW_EXCH2 */

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 0
C     !ROUTINE: EXF_INIT_INTERP

C     !INTERFACE:
      SUBROUTINE EXF_INIT_INTERP( myThid )

C     !DESCRIPTION:
C     Define input grid setting to be used for EXF interpolated fields
C     as default input grid.
C     Note: default input grid matches (in case of simple Lat-Lonp grid)
C     model grid cell-center position, leading to trivial interpolation.

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#ifdef USE_EXF_INTERPOLATION
# ifdef ALLOW_EXCH2
# include "W2_EXCH2_SIZE.h"
# include "W2_EXCH2_TOPOLOGY.h"
# endif /* ALLOW_EXCH2 */
# include "SET_GRID.h"
#endif /* USE_EXF_INTERPOLATION */
#include "EXF_INTERP_SIZE.h"
#include "EXF_INTERP_PARAM.h"

C     !INPUT PARAMETERS:
      INTEGER myThid
CEOP

#ifdef USE_EXF_INTERPOLATION
C     !LOCAL VARIABLES:
      INTEGER j
c     CHARACTER*(MAX_LEN_MBUF) msgBuf

      _BEGIN_MASTER(myThid)

# ifdef ALLOW_EXCH2
      inp_gNx = exch2_mydNx(1)
      inp_gNy = exch2_mydNy(1)
# else /* ALLOW_EXCH2 */
      inp_gNx = Nx
      inp_gNy = Ny
# endif /* ALLOW_EXCH2 */

      inp_lon0 = xgOrigin + delX(1)*halfRL
      inp_lat0 = ygOrigin + delY(1)*halfRL

      inp_dLon = delX(1)
      DO j=1,MAX_LAT_INC
        IF (j.LT.inp_gNy) THEN
          inp_dLat(j) = (delY(j) + delY(j+1))*halfRL
        ELSE
          inp_dLat(j) = 0.
        ENDIF
      ENDDO

      _END_MASTER(myThid)
#endif /* USE_EXF_INTERPOLATION */

      RETURN
      END

#include "CTRL_OPTIONS.h"

CBOP
C     !ROUTINE: CTRL_MAP_GENTIM2D
C     !INTERFACE:
      SUBROUTINE CTRL_MAP_GENTIM2D(
     I                        myTime, myIter, myThid )
C     !DESCRIPTION: \bv
C     *=============================================================*
C     | S/R  CTRL_MAP_GENTIM2D
C     *=============================================================*

C     !USES:
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "FFIELDS.h"
#include "DYNVARS.h"
#include "GRID.h"
#include "CTRL_SIZE.h"
#include "CTRL.h"
#include "CTRL_GENARR.h"
#include "CTRL_DUMMY.h"
#include "OPTIMCYCLE.h"

C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
C     myIter :: iteration counter for this thread
C     myTime :: time counter for this thread
C     myThid :: thread number for this instance of the routine.
      _RL  myTime
      INTEGER myIter
      INTEGER myThid

C     !LOCAL VARIABLES:
C     == Local variables ==
      integer bi,bj
      integer i,j,k
      integer itlo,ithi
      integer jtlo,jthi
      integer jmin,jmax
      integer imin,imax
      integer il
      integer iarr

      logical equal
      logical doglobalread
      logical ladinit
      character*(MAX_LEN_FNAM) fnamebase

      _RL fac
      _RL xx_gentim2d_loc(1-olx:snx+olx,1-oly:sny+oly,nsx,nsy)
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      _RL LOCsumTile(nSx,nSy), LOCsumGlob

c     == external ==
      integer  ilnblnk
      external ilnblnk
CEOP

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#ifdef ALLOW_GENTIM2D_CONTROL
C--   An example of connecting specific fields
C--   to generic time-varying 2D control arrays
cph--->>>
cph--->>> COMPILE FAILURE IS DELIBERATE
cph--->>> BE SURE WHAT YOU ARE DOING AND CUSTOMIZE <<<---
cph--->>>
C--   generic - user-defined control vars
      DO iarr = 1, maxCtrlTim2D

       DO bj = myByLo(myThid), myByHi(myThid)
        DO bi = myBxLo(myThid), myBxHi(myThid)
         DO J = 1-Oly,sNy+Oly
          DO I = 1-Olx,sNx+Olx
           xx_gentim2d_loc(I,J,bi,bj) = 0. _d 0
          ENDDO
         ENDDO
        ENDDO
       ENDDO
C
       fnamebase = xx_gentim2d_file(iarr)
       CALL CTRL_GET_GEN (
     I      xx_gentim2d_file(iarr),
     I      xx_gentim2d_startdate(1,iarr),
     I      xx_gentim2d_period(iarr),
     I      maskC,
     O      xx_gentim2d_loc,
     I      xx_gentim2d0(1-Olx,1-Oly,1,1,iarr),
     I      xx_gentim2d1(1-Olx,1-Oly,1,1,iarr),
     I      xx_gentim2d_dummy(iarr),
     I      zeroRL, zeroRL,
     I      wgentim2d(1-Olx,1-Oly,1,1,iarr),
     I      mytime, myiter, mythid )
C
      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
            do j = 1,sNy
              do i =  1,sNx
              if (xx_gentim2d_cumsum(iarr)) then
                xx_gentim2d(i,j,bi,bj,iarr)=xx_gentim2d(i,j,bi,bj,iarr)
     &            +xx_gentim2d_loc(i,j,bi,bj)
              else
                xx_gentim2d(i,j,bi,bj,iarr)=xx_gentim2d_loc(i,j,bi,bj)
              endif
              enddo
            enddo
        enddo
      enddo
C
      if (xx_gentim2d_glosum(iarr)) then

      LOCsumGlob=0. _d 0
      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
          LOCsumTile(bi,bj)=0. _d 0
            do j = 1,sNy
              do i =  1,sNx
                LOCsumTile(bi,bj)=LOCsumTile(bi,bj)+
     &            maskC(i,j,1,bi,bj)*rA(i,j,bi,bj)
     &            *xx_gentim2d(i,j,bi,bj,iarr)
              enddo
            enddo
        enddo
      enddo

      CALL GLOBAL_SUM_TILE_RL( LOCsumTile, LOCsumGlob, myThid )

       DO bj = myByLo(myThid), myByHi(myThid)
        DO bi = myBxLo(myThid), myBxHi(myThid)
         DO J = 1-Oly,sNy+Oly
          DO I = 1-Olx,sNx+Olx
             xx_gentim2d(I,J,bi,bj,iarr) =
     &            LOCsumGlob/globalArea*maskC(i,j,1,bi,bj)
          ENDDO
         ENDDO
        ENDDO
       ENDDO

         WRITE(msgBuf,'(A,I6,A,I6,A,1PE21.14)') ' xx_gentim2d ',
     &    iarr,' : iter=', myiter, ' ; global sum = ', LOCsumGlob
         CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                       SQUEEZE_RIGHT, myThid )

       endif

       DO bj = myByLo(myThid), myByHi(myThid)
        DO bi = myBxLo(myThid), myBxHi(myThid)
         DO J = 1-Oly,sNy+Oly
          DO I = 1-Olx,sNx+Olx
           if (iarr.EQ.1) then
             theta(I,J,1,bi,bj) = theta(I,J,1,bi,bj)
     &                          + xx_gentim2d(I,J,bi,bj,iarr)
           endif
          ENDDO
         ENDDO
        ENDDO
       ENDDO

      ENDDO

#endif /* ALLOW_GENTIM2D_CONTROL */

      RETURN
      END

#include "LAND_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 0
C     !ROUTINE: LAND_MNC_INIT

C     !INTERFACE:
      SUBROUTINE LAND_MNC_INIT( 
     I     sNx,sNy, OLx,OLy, nSx,nSy, nPx,nPy, Nland_lev, 
     I     myThid )

C     !DESCRIPTION:
C     Create the pre-defined grid types and variable types.

C     The grid type is a character string that encodes the presence and
C     types associated with the four possible dimensions.  The character
C     string follows the format
C     \begin{center}
C       \texttt{H0\_H1\_H2\_\_V\_\_T}
C     \end{center}
C     where the terms \textit{H0}, \textit{H1}, \textit{H2}, \textit{V},
C     \textit{T} can be almost any combination of the following:
C     \begin{center}
C       \begin{tabular}[h]{|ccc|c|c|}\hline
C         \multicolumn{3}{|c|}{Horizontal} & Vertical & Time \\
C         \textit{H0}: location & \textit{H1}: dimensions & \textit{H2}: halo 
C               & \textit{V}: location & \textit{T}: level  \\\hline
C         \texttt{-} & xy & Hn & \texttt{-} & \texttt{-} \\
C         U  &  x  &  Hy  &  i  &  t  \\
C         V  &  y  &      &  c  &     \\
C         Cen  &   &      &     &     \\
C         Cor  &   &      &     &     \\\hline
C       \end{tabular}
C     \end{center}

C     !USES:
      implicit none
#ifdef ALLOW_MNC
#include "MNC_COMMON.h"
#endif  /*  ALLOW_MNC  */
#include "EEPARAMS.h"

C     !INPUT PARAMETERS:
      integer myThid
      integer sNx,sNy, OLx,OLy, nSx,nSy, nPx,nPy
      integer Nland_lev
CEOP

#ifdef ALLOW_MNC

C     !LOCAL VARIABLES:
      integer CW_MAX_LOC
      parameter ( CW_MAX_LOC = 5 )
      integer i, ihorz,ihsub,ivert,itime,ihalo, is,ih, n,ntot
      integer ndim, ncomb, nvch
      character*(MNC_MAX_CHAR) name
      character*(MNC_MAX_CHAR) dn(CW_MAX_LOC)
      character*(5) horz_dat(CW_MAX_LOC), hsub_dat(CW_MAX_LOC),
     &     vert_dat(CW_MAX_LOC), time_dat(CW_MAX_LOC), 
     &     halo_dat(CW_MAX_LOC)
      integer dim(CW_MAX_LOC), ib(CW_MAX_LOC), ie(CW_MAX_LOC)

C     Functions
      integer ILNBLNK
      external ILNBLNK

C     ......12345....12345....12345....12345....12345...
      data horz_dat /
     &     '-    ', 'U    ', 'V    ', 'Cen  ', 'Cor  '  /
      data hsub_dat /
     &     'xy   ', 'x    ', 'y    ', '-    ', '     '  /
      data halo_dat /
     &     'Hn   ', 'Hy   ', '--   ', '     ', '     '  /
      data vert_dat /
     &     'Zland', '     ', '     ', '     ', '     '  /
      data time_dat /
     &     '-    ', 't    ', '     ', '     ', '     '  /


      ncomb = 0
      DO ihorz = 1,5
        DO is = 1,3
          DO ih = 1,2
            
C           Loop just ONCE if the Horiz component is "-"
            ihsub = is
            ihalo = ih
            IF (ihorz .EQ. 1) THEN
              IF ((is .EQ. 1) .AND. (ih .EQ. 1)) THEN
                ihsub = 4
                ihalo = 3
              ELSE
                GOTO 10
              ENDIF
            ENDIF
            
            DO ivert = 1,1
              DO itime = 1,2
                
C               horiz and hsub
                name(1:MNC_MAX_CHAR) = mnc_blank_name(1:MNC_MAX_CHAR)
                n = ILNBLNK(horz_dat(ihorz))
                name(1:n) = horz_dat(ihorz)(1:n)
                ntot = n + 1              
                name(ntot:ntot) = '_'
                n = ILNBLNK(hsub_dat(ihsub))
                name((ntot+1):(ntot+n)) = hsub_dat(ihsub)(1:n)
                ntot = ntot + n

C               halo, vert, and time
                write(name((ntot+1):(ntot+5)), '(a1,2a2)')
     &               '_', halo_dat(ihalo)(1:2), '__'
                nvch = ILNBLNK(vert_dat(ivert))
                n = ntot+6+nvch-1
                name((ntot+6):(n)) = vert_dat(ivert)(1:nvch)
                write(name((n+1):(n+3)), '(a2,a1)') 
     &               '__', time_dat(itime)(1:1)

                ndim = 0
                DO i = 1,CW_MAX_LOC
                  dn(i)(1:MNC_MAX_CHAR)=mnc_blank_name(1:MNC_MAX_CHAR)
                  dim(i) = 0
                  ib(i) = 0
                  ie(i) = 0
                ENDDO

C               Horizontal dimensions
                IF (halo_dat(ihalo)(1:5) .EQ. 'Hn   ') THEN

                  IF (hsub_dat(ihsub)(1:1) .EQ. 'x') THEN
                    ndim = ndim + 1
                    IF ( (horz_dat(ihorz)(1:3) .EQ. 'Cen')
     &                   .OR. (horz_dat(ihorz)(1:1) .EQ. 'V') ) THEN
                      dn(ndim)(1:1) = 'X'
                      dim(ndim) = sNx + 2*OLx
                      ib(ndim)  = OLx + 1
                      ie(ndim)  = OLx + sNx
                    ENDIF
                    IF ( (horz_dat(ihorz)(1:3) .EQ. 'Cor')
     &                   .OR. (horz_dat(ihorz)(1:1) .EQ. 'U') ) THEN
                      dn(ndim)(1:3) = 'Xp1'
                      dim(ndim) = sNx + 2*OLx
                      ib(ndim)  = OLx + 1
                      ie(ndim)  = OLx + sNx + 1
                    ENDIF
                  ENDIF
                  IF ((hsub_dat(ihsub)(1:1) .EQ. 'y')
     &                 .OR. (hsub_dat(ihsub)(2:2) .EQ. 'y')) THEN
                    ndim = ndim + 1
                    IF ( (horz_dat(ihorz)(1:3) .EQ. 'Cen')
     &                   .OR. (horz_dat(ihorz)(1:1) .EQ. 'U') ) THEN
                      dn(ndim)(1:1) = 'Y'
                      dim(ndim) = sNy + 2*OLy
                      ib(ndim)  = OLy + 1
                      ie(ndim)  = OLy + sNy
                    ENDIF
                    IF ( (horz_dat(ihorz)(1:3) .EQ. 'Cor')
     &                   .OR. (horz_dat(ihorz)(1:1) .EQ. 'V') ) THEN
                      dn(ndim)(1:3) = 'Yp1'
                      dim(ndim) = sNy + 2*OLy
                      ib(ndim)  = OLy + 1
                      ie(ndim)  = OLy + sNy + 1
                    ENDIF
                  ENDIF

                ELSEIF (halo_dat(ihalo)(1:5) .EQ. 'Hy   ') THEN

                  IF (hsub_dat(ihsub)(1:1) .EQ. 'x') THEN
                    ndim = ndim + 1
                    dn(ndim)(1:3) = 'Xwh'
                    dim(ndim) = sNx + 2*OLx
                    ib(ndim)  = 1
                    ie(ndim)  = sNx + 2*OLx
                  ENDIF
                  IF ((hsub_dat(ihsub)(1:1) .EQ. 'y')
     &                 .OR. (hsub_dat(ihsub)(2:2) .EQ. 'y')) THEN
                    ndim = ndim + 1
                    dn(ndim)(1:3) = 'Ywh'
                    dim(ndim) = sNy + 2*OLy
                    ib(ndim)  = 1
                    ie(ndim)  = sNy + 2*OLy
                  ENDIF

                ENDIF

C               Vertical dimension
                IF (vert_dat(ivert)(1:5) .EQ. 'Zland') THEN
                  ndim = ndim + 1
                  dn(ndim)(1:5) = 'Zland'
                  dim(ndim) = Nland_lev
                  ib(ndim)  = 1
                  ie(ndim)  = Nland_lev
                ENDIF

C               Time dimension
                IF ( (time_dat(itime)(1:1) .EQ. 't')
     &               .and. (ndim .ne. 0) ) THEN
                  ndim = ndim + 1
                  dn(ndim)(1:1) = 'T'
                  dim(ndim) = -1
                  ib(ndim)  = 1
                  ie(ndim)  = 1
                ENDIF

                IF (ndim .GT. 0) THEN

                  CALL MNC_CW_ADD_GNAME(name, ndim, 
     &                 dim, dn, ib, ie, myThid)

                ENDIF

              ENDDO
            ENDDO

 10         CONTINUE
          ENDDO
        ENDDO
      ENDDO

C     Now add the variable definitions
      CALL MNC_CW_ADD_VNAME(
     &     'land_groundT','Cen_xy_Hn__Zland__t',4,5,myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('land_groundT','units','---',myThid)

      CALL MNC_CW_ADD_VNAME(
     &     'land_enthalp','Cen_xy_Hn__Zland__t',4,5,myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('land_enthalp','units','---',myThid)

      CALL MNC_CW_ADD_VNAME(
     &     'land_groundW','Cen_xy_Hn__Zland__t',4,5,myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('land_groundW','units','---',myThid)

      CALL MNC_CW_ADD_VNAME('land_skinT','Cen_xy_Hn__-__t',3,4,myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('land_skinT','units','---',myThid)
      CALL MNC_CW_ADD_VNAME('land_hSnow','Cen_xy_Hn__-__t',3,4,myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('land_hSnow','units','---',myThid)
      CALL MNC_CW_ADD_VNAME('land_snAge','Cen_xy_Hn__-__t',3,4,myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('land_snAge','units','---',myThid)
      CALL MNC_CW_ADD_VNAME('land_RunOff','Cen_xy_Hn__-__t',3,4,myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('land_RunOff','units','---',myThid)
      CALL MNC_CW_ADD_VNAME('land_enRnOf','Cen_xy_Hn__-__t',3,4,myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('land_enRnOf','units','---',myThid)

      CALL MNC_CW_ADD_VNAME('land_HeatFx','Cen_xy_Hn__-__t',3,4,myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('land_HeatFx','units','---',myThid)
      CALL MNC_CW_ADD_VNAME('land_frWaFx','Cen_xy_Hn__-__t',3,4,myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('land_frWaFx','units','---',myThid)
      CALL MNC_CW_ADD_VNAME('land_EnWaFx','Cen_xy_Hn__-__t',3,4,myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('land_EnWaFx','units','---',myThid)

#endif  /*  ALLOW_MNC  */
      
      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#include "BULK_FORCE_OPTIONS.h"

CBOP
C     !ROUTINE: BULKF_FORMULA_LANL
C     !INTERFACE:
      SUBROUTINE BULKF_FORMULA_LANL(
     I                           uw, vw, us, Ta, Qa, nc, tsf_in,
     O                           flwupa, flha, fsha, df0dT,
     O                           ust, vst, evp, ssq, dEvdT,
     I                           iceornot, myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE BULKF_FORMULA_LANL
c     | o Calculate bulk formula fluxes over open ocean or seaice
C     *==========================================================*
C     \ev
C swd -- bulkf formula used in bulkf and ice pkgs
C        taken from exf package
C
C     wind stress = (ust,vst) = rhoA * Cd * Ws * (del.u,del.v)
C     Sensib Heat flux = fsha = rhoA * Ch * Ws * del.T * CpAir
C     Latent Heat flux = flha = rhoA * Ce * Ws * del.Q * Lvap
C                      = -Evap * Lvap
C   with Ws = wind speed = sqrt(del.u^2 +del.v^2) ;
C        del.T = Tair - Tsurf ; del.Q = Qair - Qsurf
C        Cd,Ch,Ce = transfer coefficient for momentum, sensible
C                    & latent heat flux [no units]
C     *==========================================================*

C     !USES:
       IMPLICIT NONE
C     === Global variables ===
#include "EEPARAMS.h"
#include "SIZE.h"
#include "PARAMS.h"
#include "BULKF_PARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     input:
      _RL uw                 ! zonal wind speed (at grid center) [m/s]
      _RL vw                 ! meridional wind speed (at grid center) [m/s]
      _RL us                 ! wind speed        [m/s]   at height hu
      _RL Ta                 ! air temperature   [K]     at height ht
      _RL Qa                 ! specific humidity [kg/kg] at heigth ht
      _RL nc                 ! fraction cloud cover
      _RL tsf_in             ! sea-ice or sea surface temperature [oC]
      INTEGER iceornot       ! 0=open water, 1=sea-ice, 2=sea-ice with snow
      INTEGER myThid         ! my Thread Id number
C     output:
      _RL flwupa             ! upward long wave radiation (>0 upward) [W/m2]
      _RL flha               ! latent heat flux         (>0 downward) [W/m2]
      _RL fsha               ! sensible heat flux       (>0 downward) [W/m2]
      _RL df0dT              ! derivative of heat flux with respect to Tsf [W/m2/K]
      _RL ust                ! zonal wind stress (at grid center)     [N/m2]
      _RL vst                ! meridional wind stress (at grid center)[N/m2]
      _RL evp                ! evaporation rate (over open water) [kg/m2/s]
      _RL ssq                ! surface specific humidity          [kg/kg]
      _RL dEvdT              ! derivative of evap. with respect to Tsf [kg/m2/s/K]
CEOP

#ifdef ALLOW_BULK_FORCE

C     == Local variables ==
      _RL dflhdT             ! derivative of latent heat with respect to T
      _RL dfshdT             ! derivative of sensible heat with respect to T
      _RL dflwupdT           ! derivative of long wave with respect to T

      _RL tsf                ! surface temperature [K]
      _RL ht                 ! height for air temperature [m]
c     _RL hq                 ! height for humidity [m]
      _RL hu                 ! height for wind speed [m]
c     _RL zref               ! reference height [m]
      _RL usm                ! wind speed limited [m/s]
c     _RL umin               ! minimum wind speed used for drag-coeff [m/s]
      _RL lath               ! latent heat of vaporization or sublimation
      _RL t0                 ! virtual temperature [K]
      _RL deltap             ! potential temperature diff [K]
      _RL delq               ! specific humidity difference [kg/kg]
      _RL ustar              ! friction velocity [m/s]
      _RL tstar              ! temperature scale [K]
      _RL qstar              ! humidity scale  [kg/kg]
      _RL rd                 ! = sqrt(Cd)          [-]
      _RL re                 ! = Ce / sqrt(Cd)     [-]
      _RL rh                 ! = Ch / sqrt(Cd)     [-]
      _RL rdn, ren, rhn      ! initial (neutral) values of rd, re, rh
      _RL stable             ! = 1 if stable ; = 0 if unstable
      _RL huol               ! stability parameter [-]
      _RL x                  ! stability function  [-]
      _RL xsq                ! = x^2               [-]
      _RL psimh              ! momentum stability function
      _RL psixh              ! latent & sensib. stability function
      _RL czol               ! = zref*Karman_cst*gravity
      _RL aln                ! = log(ht/zref)
c     _RL cdalton            ! coeff to evaluate Dalton Number
c     _RL mixratio
c     _RL ea
c     _RL psim_fac
      _RL tau                ! surface stress  coef = ?
      _RL csha               ! sensib.heat flx coef = rhoA * Ws * Ch * CpAir
      _RL clha               ! latent heat flx coef = rhoA * Ws * Ce * Lvap
      _RL zice
      _RL ssq0, ssq1, ssq2   ! constant used in surface specific humidity
      _RL p0                 ! reference sea-level atmospheric pressure [mb]
      _RL bulkf_Cdn          ! drag coefficient
      INTEGER niter_bulk, iter

C     == external Functions
c     _RL       exf_BulkCdn
c     external  exf_BulkCdn
c     _RL       exf_BulkqSat
c     external  exf_BulkqSat
c     _RL       exf_BulkRhn
c     external  exf_BulkRhn

      DATA   ssq0,           ssq1,           ssq2
     &     / 3.797915 _d 0 , 7.93252 _d -6 , 2.166847 _d -3 /
      DATA   p0 / 1013. _d 0 /

C--- Compute turbulent surface fluxes
              ht =  2. _d 0
c             hq =  2. _d 0
              hu = 10. _d 0
c             zref = 10. _d 0
              zice = 0.0005 _d 0
              aln = log(ht/zref)
              niter_bulk = 5
c             cdalton = 0.0346000 _d 0
              czol = zref*xkar*gravity
c             psim_fac=5. _d 0
c             umin=1. _d 0

              lath=Lvap
              if (iceornot.gt.0) lath=Lvap+Lfresh
              Tsf=Tsf_in+Tf0kel
C-   Wind speed
              if (us.eq.0. _d 0) then
                us = sqrt(uw*uw + vw*vw)
              endif
              usm = max(us,umin)
c
              t0     = Ta*(1. _d 0 + humid_fac*Qa)
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
cQQ           ssq    = 0.622*6.11*exp(22.47*(1.d0-Tf0kel/tsf))/p0
c             ssq = 3.797915 _d 0*exp(
c    &                lath*(7.93252 _d -6 - 2.166847 _d -3/Tsf)
c    &                               )/p0
              ssq = ssq0*exp( lath*(ssq1-ssq2/Tsf) ) / p0

              deltap = ta  - tsf + gamma_blk*ht
              delq   = Qa - ssq

C--  initialize estimate exchange coefficients
              rdn=xkar/(log(zref/zice))
              rhn=rdn
              ren=rdn
C--  calculate turbulent scales
              ustar=rdn*usm
              tstar=rhn*deltap
              qstar=ren*delq

C--  iteration with psi-functions to find transfer coefficients
              do iter=1,niter_bulk
                 huol   = czol/ustar**2 *(tstar/t0 +
     &                    qstar/(1. _d 0/humid_fac+Qa))
                 huol   = sign( min(abs(huol),10. _d 0), huol)
                 stable = 5. _d -1 + sign(5. _d -1 , huol)
                 xsq = max(sqrt(abs(1. _d 0 - 16. _d 0*huol)),1. _d 0)
                 x      = sqrt(xsq)
                 psimh = -5. _d 0*huol*stable + (1. _d 0-stable)*
     &                    (2. _d 0*log(5. _d -1*(1. _d 0+x)) +
     &                     2. _d 0*log(5. _d -1*(1. _d 0+xsq)) -
     &                     2. _d 0*atan(x) + pi*.5 _d 0)
                 psixh  = -5. _d 0*huol*stable + (1. _d 0-stable)*
     &                     (2. _d 0*log(5. _d -1*(1. _d 0+xsq)))

C--  Update the transfer coefficients
                 rd = rdn/(1. _d 0 + rdn*(aln-psimh)/xkar)
                 rh = rhn/(1. _d 0 + rhn*(aln-psixh)/xkar)
                 re = rh
C--  Update ustar, tstar, qstar using updated, shifted coefficients.
                 ustar = rd*usm
                 qstar = re*delq
                 tstar = rh*deltap
              enddo

              tau   = rhoa*ustar**2
              tau   = tau*us/usm
              csha  = rhoa*cpair*us*rh*rd
              clha  = rhoa*lath*us*re*rd

              fsha  = csha*deltap
              flha  = clha*delq
              evp   = -flha/lath

C--  Upward long wave radiation
cQQ           mixratio=Qa/(1-Qa)
cQQ           ea=p0*mixratio/(0.62197+mixratio)
cQQ           flwupa=-0.985*stefan*tsf**4
cQQ  &                  *(0.39-0.05*sqrt(ea))
cQQ  &                  *(1-0.6*nc**2)
              if (iceornot.eq.0) then
               flwupa=ocean_emissivity*stefan*tsf**4
               dflwupdT=4. _d 0*ocean_emissivity*stefan*tsf**3
              elseif (iceornot.eq.2) then
                flwupa=snow_emissivity*stefan*tsf**4
                dflwupdT=4. _d 0*snow_emissivity*stefan*tsf**3
              else
                flwupa=ice_emissivity*stefan*tsf**4
                dflwupdT=4. _d 0*ice_emissivity*stefan*tsf**3
              endif
cQQ           dflhdT = -clha*Tf0kel*ssq*22.47/(tsf**2)
c             dflhdT = -clha*Lath*ssq/(Rvap*tsf**2)
c             dflhdT = -clha*ssq*Lath*2.166847 _d -3/(Tsf**2)
              dEvdT  =  clha*ssq*ssq2/(Tsf*Tsf)
              dflhdT = -lath*dEvdT
              dfshdT = -csha
cQQ           dflwupdT= 4.*0.985*stefan*tsf**3
cQQ  &                  *(0.39-0.05*sqrt(ea))
cQQ  &                  *(1-0.6*nc**2)
c total derivative with respect to surface temperature
              df0dT=-dflwupdT+dfshdT+dflhdT

C--  Wind stress at center points
C-   in-lining of function: exf_BulkCdn(umps) = cdrag_1/umps + cdrag_2 + cdrag_3*umps
              bulkf_Cdn = cdrag_1/usm + cdrag_2 + cdrag_3*usm
              ust = rhoa*bulkf_Cdn*us*uw
              vst = rhoa*bulkf_Cdn*us*vw
#endif /*ALLOW_BULK_FORCE*/

      RETURN
      END

#include "ECCO_OPTIONS.h"
#include "AD_CONFIG.h"
#ifdef ALLOW_CTRL
# include "CTRL_OPTIONS.h"
#endif

      SUBROUTINE ECCO_COST_INIT_FIXED( myThid )

c     ==================================================================
c     SUBROUTINE ecco_cost_init_fixed
c     ==================================================================
c
c     o Set contributions to the cost function and the cost function
c       itself to zero. The cost function and the individual contribu-
c       tions are defined in the header file "ecco_cost.h".
c
c     started: Christian Eckert eckert@mit.edu 30-Jun-1999
c
c     changed: Christian Eckert eckert@mit.edu 25-Feb-2000
c
c              - Restructured the code in order to create a package
c                for the MITgcmUV.
c
c     changed: Ralf Giering 18-Jan-2001
c
c              - move namelist reading to cost_readparms.F
c
c     ==================================================================
c     SUBROUTINE ecco_cost_init_fixed
c     ==================================================================

      IMPLICIT NONE

c     == global variables ==
#include "EEPARAMS.h"
#include "SIZE.h"
#include "GRID.h"
#include "PARAMS.h"

#ifdef ALLOW_CAL
# include "cal.h"
#endif
#include "ECCO_SIZE.h"
#include "ECCO.h"
#ifdef ALLOW_CTRL
# include "OPTIMCYCLE.h"
#endif

c     == routine arguments ==
      integer myThid

c     == external functions ==
      integer  ifnblnk
      external ifnblnk
      integer  ilnblnk
      external ilnblnk
#ifdef ALLOW_CAL
      integer  cal_IntYears
      external cal_IntYears
      integer  cal_IntMonths
      external cal_IntMonths
      integer  cal_IntDays
      external cal_IntDays
#endif

c     == local variables ==
      integer k
      logical exst
      _RL     missingObsFlag
      PARAMETER ( missingObsFlag = 1. _d 23 )
#ifdef ALLOW_GENCOST_1D
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      integer ilo, ihi, irec, gwunit
#endif
#ifdef ALLOW_GENCOST_CONTRIBUTION
      integer k2
#endif
#ifndef ECCO_VARIABLE_AREAVOLGLOB
      INTEGER i, j, bi, bj
#endif
c     == end of interface ==

      _BEGIN_MASTER(myThid)
#ifdef ALLOW_CTRL
      eccoiter=optimcycle
#else
      eccoiter=0
#endif
      _END_MASTER(myThid)

#ifndef ECCO_VARIABLE_AREAVOLGLOB
      DO bj=myByLo(myThid),myByHi(myThid)
        DO bi=myBxLo(myThid),myBxHi(myThid)
          DO k = 1,Nr
            DO j = 1-OLy,sNy+OLy
              DO i = 1-OLx,sNx+OLx
                eccoVol_0(i,j,k,bi,bj)=
     &          hFacC(i,j,k,bi,bj)*drF(k)*rA(i,j,bi,bj)
              ENDDO
            ENDDO
          ENDDO
        ENDDO
      ENDDO
#endif

#ifdef ALLOW_CAL

c--   The number of monthly and daily averages generated by the
c--   current model integration.
      nyearsrec = cal_IntYears( myThid )
      nmonsrec = cal_IntMonths( myThid )
      ndaysrec = cal_IntDays( myThid )

#ifdef ALLOW_GENCOST_CONTRIBUTION
      do k = 1, NGENCOST

c--    skip averaging when several cost terms use the
c      same barfile or when barfile is undefined
       gencost_barskip(k)=.FALSE.
       if ( gencost_barfile(k).EQ.' ' )
     &      gencost_barskip(k)=.TRUE.
       do k2 = 1,k-1
         if ( gencost_barfile(k2).EQ.gencost_barfile(k) )
     &      gencost_barskip(k)=.TRUE.
       enddo

c--    set time averaging parameters
       if ( (using_gencost(k)).AND.( (gencost_flag(k).GE.1).OR.
     &         (gencost_avgperiod(k).NE.'     ') ) ) then
         if ( gencost_avgperiod(k) .EQ. 'day' .OR.
     &        gencost_avgperiod(k) .EQ. 'DAY' ) then
            gencost_nrec(k)   = ndaysrec
            gencost_period(k) = 86400.
         else if ( gencost_avgperiod(k) .EQ. 'month' .OR.
     &        gencost_avgperiod(k) .EQ. 'MONTH' ) then
            gencost_nrec(k)   =nmonsrec
            gencost_period(k) = 0.
         else if ( gencost_avgperiod(k) .EQ. 'step' .OR.
     &        gencost_avgperiod(k) .EQ. 'STEP' ) then
            gencost_nrec(k)   =nTimeSteps+1
            gencost_period(k) = dTtracerLev(1)
         else if ( gencost_avgperiod(k) .EQ. 'const' .OR.
     &        gencost_avgperiod(k) .EQ. 'CONST' ) then
            gencost_nrec(k)   =1
            gencost_period(k) = dTtracerLev(1)
         else if ( gencost_avgperiod(k) .EQ. 'year' .OR.
     &        gencost_avgperiod(k) .EQ. 'YEAR' ) then
           STOP
     &      'ecco_cost_init_fixed: yearly data not yet implemented'
         else
           STOP
     &      'ecco_cost_init_fixed: gencost_avgperiod wrongly specified'
         endif
       endif

c--    set observation start/enddate
       if (gencost_startdate1(k).GT.0) then
         call cal_FullDate(
     &     gencost_startdate1(k), gencost_startdate2(k),
     &     gencost_startdate(1,k), myThid )
       else
         call cal_CopyDate(modelStartDate,
     &     gencost_startdate(1,k),myThid)
         gencost_startdate1(k)=startdate_1
         gencost_startdate2(k)=startdate_2
       endif

       if (gencost_enddate1(k).GT.0) then
         call cal_FullDate(
     &     gencost_enddate1(k), gencost_enddate2(k),
     &     gencost_enddate(1,k), myThid )
       else
         call cal_CopyDate(modelEndDate,
     &     gencost_enddate(1,k),myThid)
       endif

#ifdef ALLOW_GENCOST_1D
      if ( (gencost_name(k).EQ.'gmbp') .OR.
     &     (gencost_name(k).EQ.'gmsl')) then
       if(gencost_nrec(k).GT.N1DDATA)then
        WRITE(msgBuf,'(2A,2i8)') 'ecco_cost_init_fixed: ',
     &   'Increase N1DDATA', N1DDATA, gencost_nrec(k)
        CALL PRINT_ERROR( msgBuf, myThid)
       endif

      do irec = 1, N1DDATA
       gencost_1DDATA(irec,k) = 0. _d 0
      enddo

      if(gencost_wei1d(k).NE.0. _d 0)then
        gencost_wei1d(k) = 1. _d 0 / gencost_wei1d(k)
     &      /gencost_wei1d(k)
      endif

      if ( gencost_datafile(k) .NE. ' ' ) then
      ilo = ifnblnk(gencost_datafile(k))
      ihi = ilnblnk(gencost_datafile(k))

      CALL OPEN_COPY_DATA_FILE(
     I                          gencost_datafile(k)(ilo:ihi),
     I                          'ECCO_COST_INIT_FIXED: ',
     O                          gwunit,
     I                          myThid )
      do irec = 1, gencost_nrec(k)
         read(gwunit,*) gencost_1DDATA(irec,k)
      enddo
      close(gwunit)
      endif

      endif
#endif /* ALLOW_GENCOST_1D */

      enddo !do k = 1, NGENCOST
#endif /* ALLOW_GENCOST_CONTRIBUTION */

#endif /* ALLOW_CAL */

C-    ECCO_CHECK is now called from packages_check.F
c     call ecco_check( myThid )

c--   Get the weights that are to be used for the individual cost
c--   function contributions.
c     Now done from s/r obcs_init_fixed, because this function only
c     contains obcs-related weights.
c     call ecco_cost_weights( myThid )

c--   Initialise adjoint of monthly mean files calculated
c--   in cost_averagesfields (and their ad...).
cph(
cph   The following init. shoud not be applied if in the middle
cph   of a divided adjoint run
cph)
#ifndef ALLOW_TANGENTLINEAR_RUN
cph!!! and I think it needs to be seen by TAF
cph!!! for repeated TLM runs
cph!!!
      inquire( file='costfinal', exist=exst )
      if ( .NOT. exst) then
         call ecco_cost_init_barfiles( myThid )
      endif
#endif

c--   Summarize the cost function setup. <-- now called at the end of ECCO_CHECK
c     call ecco_summary( myThid )

      _BARRIER

      RETURN
      END

#include "CPP_EEOPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C !ROUTINE: PROFILES_FINDUNIT

C !INTERFACE:
      SUBROUTINE PROFILES_FINDUNIT( ioUnit, myThid )

C     !DESCRIPTION:
C     PROFILES_FINDUNIT returns a valid, unused unit number for f77 I/O
C     The routine stops the program is an error occurs in the process
C     of searching the I/O channels.
C     Created: 03/20/99 adcroft@mit.edu

C     !USES:
      IMPLICIT NONE
C     == Global variables ===
#include "EEPARAMS.h"

C     !INPUT PARAMETERS:
C     ioUnit: unit number
C     myThid: my thread ID number
      INTEGER ioUnit
      INTEGER myThid
C     !OUTPUT PARAMETERS:
C     ioUnit: unit number
CEOP

C     !LOCAL VARIABLES:
      INTEGER ii
      LOGICAL op
      INTEGER ios
      CHARACTER*(MAX_LEN_MBUF) msgBuf

C Sweep through a valid range of unit numbers
      ioUnit=-1
      DO ii = 2000, 9999
        IF ( ioUnit.EQ.-1 ) THEN
C Skip reserved unit numbers
          IF ( ii.NE.errorMessageUnit .AND.
     &         ii.NE.standardMessageUnit .AND.
     &         ii.NE.scrUnit1 .AND. ii.NE.scrUnit2 .AND.
     &         ii.NE.eeDataUnit .AND. ii.NE.modelDataUnit ) THEN
            INQUIRE( UNIT = ii, IOSTAT = ios, OPENED = op )
            IF (ios.NE.0) THEN
              WRITE(msgBuf,'(A,I4)')
     &         ' PROFILES_FINDUNIT: inquiring unit number =', ii
              CALL PRINT_MESSAGE( msgBuf,
     &             standardMessageUnit, SQUEEZE_RIGHT, myThid )
              WRITE(msgBuf,'(A)')
     &         ' PROFILES_FINDUNIT: inquire statement failed!'
              CALL PRINT_ERROR( msgBuf, myThid )
              CALL ALL_PROC_DIE( myThid )
              STOP 'ABNORMAL END: S/R PROFILES_FINDUNIT'
            ENDIF

            IF ( .NOT.op ) THEN
              ioUnit=ii
            ENDIF

          ENDIF
        ENDIF
      ENDDO !DO ii

C Was there an available unit number
      IF ( ioUnit.EQ.-1 ) THEN
        WRITE(msgBuf,'(A)')
     &   ' PROFILES_FINDUNIT: no available unit number!'
        CALL PRINT_ERROR( msgBuf, myThid )
        CALL ALL_PROC_DIE( myThid )
        STOP 'ABNORMAL END: S/R PROFILES_FINDUNIT'
      ENDIF

      RETURN
      END

#include "CAL_OPTIONS.h"

      SUBROUTINE CAL_CONVDATE(
     I                         date,
     O                         yy, mm, dd, ss,
     O                         lp, wd,
     I                         myThid )

C     ==================================================================
C     SUBROUTINE cal_ConvDate
C     ==================================================================
C
C     o Decompose the first part of a date array.
C
C     started: Christian Eckert eckert@mit.edu  30-Jun-1999
C     changed: Christian Eckert eckert@mit.edu  29-Dec-1999
C              - restructured the original version in order to have a
C                better interface to the MITgcmUV.
C              Christian Eckert eckert@mit.edu  03-Feb-2000
C              - Introduced new routine and function names, cal_<NAME>,
C                for verion 0.1.3.
C              21-Sep-2003: fixed check_sign logic to work with
C              negative intervals (menemenlis@jpl.nasa.gov)
C
C     ==================================================================
C     SUBROUTINE cal_ConvDate
C     ==================================================================

      IMPLICIT NONE

C     == global variables ==
#include "EEPARAMS.h"
#include "cal.h"

C     == routine arguments ==
      INTEGER date(4)
      INTEGER yy, mm, dd
      INTEGER ss, lp, wd
      INTEGER myThid

C     == local variables ==
      INTEGER fac
      INTEGER date_1
      INTEGER date_2
      INTEGER ierr
      LOGICAL wrong_sign
      CHARACTER*(MAX_LEN_MBUF) msgBuf
C     == end of interface ==

      IF ( cal_setStatus .LT. 1 ) THEN
        WRITE( msgBuf,'(2A,4I9)') 'CAL_CONVDATE: ',
     &       'date=',date(1),date(2),date(3),date(4)
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE( msgBuf,'(2A,I2,A)') 'CAL_CONVDATE: ',
     &    'called too early (cal_setStatus=',cal_setStatus,' )'
        CALL PRINT_ERROR( msgBuf, myThid )
        STOP 'ABNORMAL END: S/R CAL_CONVDATE'
      ENDIF

C     Check the sign of the date.
      fac = 1
      wrong_sign = ( (date(1).lt.0) .and. date(2).gt.0 )
     &        .OR. ( (date(1).gt.0) .and. date(2).lt.0 )

      if ( wrong_sign ) then
        ierr = 901
        call cal_PrintError( ierr, myThid )
        stop ' stopped in cal_ConvDate.'
      else
        if ( date(1).lt.0 .OR. date(2).lt.0 ) then
          date_1 = -date(1)
          date_2 = -date(2)
          fac    = -1
        else
          date_1 = date(1)
          date_2 = date(2)
          fac    = 1
        endif
      endif

C     Decompose the entries.
      if (date(4) .ne. -1) then
        yy = date_1/10000
        mm = mod(date_1/100,100)
        dd = mod(date_1,100)
      else
        yy = 0
        mm = 0
        dd = date_1
      endif
      ss = mod(date_2,100) +
     &     mod(date_2/100,100)*secondsPerMinute +
     &     date_2/10000*secondsPerHour

C     Include the sign.
      yy = fac*yy
      mm = fac*mm
      dd = fac*dd
      ss = fac*ss

      lp = date(3)
      wd = date(4)

      RETURN
      END

#include "STREAMICE_OPTIONS.h"
#ifdef ALLOW_AUTODIFF
# include "AUTODIFF_OPTIONS.h"
#endif
#ifdef ALLOW_COST
# include "COST_OPTIONS.h"
#endif

      subroutine streamice_cost_accum ( myIter, myThid )
C     *==========================================================*
C     | subroutine cost_test                                     |
C     | o this routine accumulates the STREAMICE cost func-      |
C     |   tion at each time step, called from cost_tile          |
C     *==========================================================*
C     |                                                          |
C     | Notes                                                    |
C     | =====                                                    |
C     *==========================================================*
      IMPLICIT NONE

C     == Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "DYNVARS.h"
#include "GRID.h"
#ifdef ALLOW_STREAMICE
# include "STREAMICE.h"
#endif

#ifdef ALLOW_COST
# include "cost.h"
#endif
#ifdef ALLOW_AUTODIFF_TAMC
# include "tamc.h"
#endif

C     == Routine arguments ==
C     myThid - Thread number for this instance of the routine.
      integer myIter, myThid

#ifdef ALLOW_COST
C     == Local variables
      _RL thetaRef, HAF

      integer i, j, k, bi, bj
      integer ig, jg
      integer itlo,ithi
      integer jtlo,jthi
      integer il
      integer itime
      INTEGER  ILNBLNK
      EXTERNAL ILNBLNK

      jtlo = myByLo(myThid)
      jthi = myByHi(myThid)
      itlo = myBxLo(myThid)
      ithi = myBxHi(myThid)

C--   Calculate mask for tracer cells  (0 => land, 1 => water)
c       k=1

c#ifdef ALLOW_AUTODIFF_TAMC
cCADJ STORE surf_el_streamice = comlev1, key = ikey_dynamics,
cCADJ &     kind = isbyte
cCADJ STORE H_streamice_prev  = comlev1, key = ikey_dynamics,
cCADJ &     kind = isbyte
cCADJ STORE H_streamice       = comlev1, key = ikey_dynamics,
cCADJ &     kind = isbyte
c#endif

C--   Calculate cost function on tile of this instance
      do bj = jtlo,jthi
        do bi = itlo,ithi
          do j=1,sNy
            do i=1,sNx

             if (streamice_cost_mask(i,j,bi,bj).eq.1.0) THEN
              cost_func1_streamice (bi,bj) =
     &        cost_func1_streamice (bi,bj) + 0.0
             endif

            end do
          end do
        end do
      end do

#ifdef ALLOW_STREAMICE_TC_COST
      IF ( STREAMICE_do_timedep_cost ) THEN
       CALL STREAMICE_COST_REG_ACCUM (myIter, myThid)
       DO itime = 1,streamiceMaxCostLevel
        IF (myIter==streamice_surf_cost_timesteps(itime)) THEN
         CALL STREAMICE_COST_SURF_ACCUM (myIter, myThid)
        ENDIF
        IF (myIter==streamice_vel_cost_timesteps(itime)) THEN
         CALL STREAMICE_COST_VEL_ACCUM (myIter, myThid)
        ENDIF
       ENDDO
      ENDIF
#endif

#endif

      RETURN
      END

#include "SMOOTH_OPTIONS.h"

      SUBROUTINE SMOOTH_CORREL2D(
     &           fld_in, mask_in, smoothOpNb, myThid )

C     *==========================================================*
C     | SUBROUTINE smooth_correl2D
C     | o Routine that applies spatial correlation
C     |   operator to a 2D control field
C     *==========================================================*

      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "GRID.h"
#include "PARAMS.h"
#include "SMOOTH.h"

      _RL fld_in(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RS mask_in(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      INTEGER smoothOpNb
      INTEGER myThid

      INTEGER nbt_in
      CHARACTER*(MAX_LEN_FNAM) fnamegeneric
      INTEGER i,j,bi,bj
      INTEGER IL

c     == functions ==
      INTEGER  ILNBLNK
      EXTERNAL ILNBLNK

      IL = ILNBLNK( smoothDir )

c read smoothing [i.e diffusion] operator:
      WRITE(fnamegeneric,'(2A,I3.3)')
     &      smoothDir(1:IL),
     &    'smooth2Doperator',smoothOpNb
      CALL READ_REC_3D_RL( fnamegeneric, smoothprec,
     &                     1, smooth2D_Kux,1,1,myThid )
      CALL READ_REC_3D_RL( fnamegeneric, smoothprec,
     &                     1, smooth2D_Kvy,2,1,myThid )
      CALL EXCH_XY_RL( smooth2D_Kux, myThid )
      CALL EXCH_XY_RL( smooth2D_Kvy, myThid )

c read normalization field [i.e. 1/sqrt(var(filter))]:
      WRITE(fnamegeneric,'(2A,I3.3)')
     &      smoothDir(1:IL),
     &     'smooth2Dnorm',smoothOpNb
      CALL READ_REC_3D_RL( fnamegeneric, smoothprec,
     &                     1, smooth2Dnorm, 1, 1, myThid )
      CALL EXCH_XY_RL( smooth2Dnorm, myThid )

c division by ~sqrt(area):
      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        DO j = 1,sNy
         DO i = 1,sNx
           fld_in(i,j,bi,bj)=fld_in(i,j,bi,bj)
     & *SQRT(recip_rA(i,j,bi,bj))
         ENDDO
        ENDDO
       ENDDO
      ENDDO
      CALL EXCH_XY_RL ( fld_in , myThid )

c do the smoothing:
      nbt_in = smooth2Dnbt(smoothOpNb)/2
      CALL SMOOTH_DIFF2D( fld_in, mask_in, nbt_in, myThid )

c division by ~sqrt(var(filter)):
      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
         DO j = 1,sNy
          DO i = 1,sNx
            fld_in(i,j,bi,bj) = fld_in(i,j,bi,bj)
     &                        *smooth2Dnorm(i,j,bi,bj)
          ENDDO
         ENDDO
        ENDDO
       ENDDO
      CALL EXCH_XY_RL( fld_in , myThid )

      RETURN
      END

#include "RW_OPTIONS.h"

C--  File read_mflds.F: Routines to handle reading Multi-Fields File (+ meta file)
C--   Contents
C--   o READ_MFLDS_INIT
C--   o READ_MFLDS_SET
C--   o READ_MFLDS_3D_RL
C--   o READ_MFLDS_LEV_RL
C--   o READ_MFLDS_LEV_RS
C--   o READ_MFLDS_CHECK
C--   o READ_MFLDS_RENAME

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: READ_MFLDS_INIT
C     !INTERFACE:
      SUBROUTINE READ_MFLDS_INIT(
     I                            myThid )

C     !DESCRIPTION:
C     Initialise Multi-Fields read variables in common block

C     !USES:
      IMPLICIT NONE
c#include "SIZE.h"
#include "EEPARAMS.h"
#include "RW_MFLDS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     myThid   :: my Thread Id. number
      INTEGER myThid
CEOP

C     !LOCAL VARIABLES:
C     i        :: loop counter
      INTEGER i
C-    for debug print:
c     CHARACTER*(MAX_LEN_MBUF) msgBuf
C-----

C-    Initialise variables in common block:
      thirdDim = 0
      nFl3D    = 0
      nFlds    = 0
      nMissFld = 0
      mFldsFile = ' '
      DO i=1,sizFldList
        fldList(i) = ' '
        fldMiss(i) = ' '
      ENDDO

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: READ_MFLDS_SET
C     !INTERFACE:
      SUBROUTINE READ_MFLDS_SET(
     I                      fName,
     O                      nbFields, filePrec,
     I                      fileDim3, myIter, myThid )

C     !DESCRIPTION:
C     This is the controlling routine for preparing Multi-Fields read
C     by reading the corresponding meta file.
C     the meta-file content is stored in common block (header: RW_MFLDS.h)
C     to be reachable by all threads

C Note: 1) Output arguments should not be shared variables (= not in common block)
C       2) Only master-thread returns a valid filePrec (others just return 0)

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "RW_MFLDS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     fName    :: current MFLDS file name (prefix) to read
C     nbFields :: Number of fields in current MFLDS file
C     filePrec :: data-precision in current MFLDS file
C     fileDim3 :: 3rd dimension of fields in current MFLDS file
C     myIter   :: Iteration number
C     myThid   :: my Thread Id. number
      CHARACTER*(MAX_LEN_FNAM) fName
      INTEGER nbFields
      INTEGER filePrec
      INTEGER fileDim3
      INTEGER myIter
      INTEGER myThid
CEOP

C !FUNCTIONS
      INTEGER  ILNBLNK
      EXTERNAL ILNBLNK

C     !LOCAL VARIABLES:
C-    do change dir. (using mdsioLocalDir):
      LOGICAL  useCurrentDir
C-    output of MDS_READ_META :
      INTEGER  nSizD, nSizT
      PARAMETER( nSizD = 5 , nSizT = 20 )
      CHARACTER*(MAX_LEN_PREC/2) simulName
      CHARACTER*(MAX_LEN_MBUF/2) titleLine
      INTEGER nDims, nTimRec
      INTEGER dimList(3,nSizD)
      _RL     timList(nSizT)
      _RL     misVal
      INTEGER nRecords, fileIter
C-    for debug print:
      INTEGER i, j, ioUnit
      CHARACTER*(MAX_LEN_MBUF) msgBuf
C-----

C-    Initialise output arguments:
      nbFields = 0
      filePrec = 0

#ifdef RW_SAFE_MFLDS
      i = ILNBLNK(mFldsFile)
      IF ( i.NE.0 ) THEN
        i = MIN(i, MAX_LEN_MBUF-48-34 )
        WRITE(msgBuf,'(4A)') 'READ_MFLDS_SET: ',
     &    'MFLDS file-name already set to: ',mFldsFile(1:i)
        CALL PRINT_ERROR( msgBuf, myThid )
        CALL ALL_PROC_DIE( myThid )
        STOP 'ABNORMAL END: S/R READ_MFLDS_SET (fileName)'
      ENDIF
      _BARRIER
#endif /* RW_SAFE_MFLDS */
      _BEGIN_MASTER( myThid )

C-    Initialise variables in common block:
      thirdDim = fileDim3
      nFl3D    = 0
      nFlds    = 0
      nMissFld = 0
      mFldsFile = fName
      DO i=1,sizFldList
        fldList(i) = ' '
        fldMiss(i) = ' '
      ENDDO

#ifdef ALLOW_MDSIO
       useCurrentDir = .FALSE.
       nDims = nSizD
       nFlds = sizFldList
       nTimRec = nSizT
       CALL MDS_READ_META(
     I               fName,
     O               simulName,
     O               titleLine,
     O               filePrec,
     U               nDims,   nFlds,   nTimRec,
     O               dimList, fldList, timList,
     O               misVal, nRecords, fileIter,
     I               useCurrentDir, myThid )
#endif /* ALLOW_MDSIO */

C-    evaluate Nb of 3.D fields (used if mix 3-D & 2-D fields in file):
      nFl3D = 0
      IF ( nFlds.GE.1 ) THEN
        IF ( nDims.EQ.2 .AND. thirdDim.GT.1
     &                   .AND. nFlds.LT.nRecords ) THEN
          IF ( MOD( nRecords-nFlds , thirdDim-1 ) .EQ. 0 )
     &       nFl3D = (nRecords-nFlds)/(thirdDim-1)
        ENDIF
        IF ( nFlds.NE.nRecords .AND. nFl3D.EQ.0 ) THEN
C-    here we have a problem
          WRITE(msgBuf,'(A,I5,A,I4,A)')
     &     'READ_MFLDS_SET: Pb with Nb of records=', nRecords,
     &     ' (3rd-Dim=', thirdDim,')'
          CALL PRINT_ERROR( msgBuf, myThid )
          WRITE(msgBuf,'(A,I5,A,I4,A)')
     &     ' does not match Nb of flds=', nFlds
          CALL PRINT_ERROR( msgBuf, myThid )
          CALL ALL_PROC_DIE( 0 )
          STOP 'ABNORMAL END: S/R READ_MFLDS_SET (Nb-records Pb)'
        ENDIF
c       IF ( nFl3D.EQ.0 ) nFl3D = nFlds
      ENDIF

C-    write to Standard Output
      IF ( debugLevel.GE.debLevA ) THEN
        ioUnit = standardMessageUnit
        i = ILNBLNK(simulName)
        IF ( i.GE.1 ) THEN
         WRITE(msgBuf,'(3A)') ' simulName=>', simulName(1:i), '<'
         CALL PRINT_MESSAGE(msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
        ENDIF
        i = ILNBLNK(titleLine)
        IF ( i.GE.1 ) THEN
         WRITE(msgBuf,'(3A)') ' titleLine=>', titleLine(1:i), '<'
         CALL PRINT_MESSAGE(msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
        ENDIF
        WRITE(msgBuf,'(2(A,I4),A,I10)')
     &    ' nRecords =', nRecords, ' ; filePrec =', filePrec,
     &    ' ; fileIter =', fileIter
        CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
        WRITE(msgBuf,'(A,I4,A)') '    nDims =', nDims, ' , dims:'
        CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
        DO j=1,nDims
         WRITE(msgBuf,'(I4,A,3I4)') j,':',(dimList(i,j),i=1,3)
         CALL PRINT_MESSAGE(msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
        ENDDO
        WRITE(msgBuf,'(3(A,I4))')
     &    '    nFlds =', nFlds, ' , nFl3D =', nFl3D, ' , fields:'
        CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
        DO j=1,nFlds,20
         WRITE(msgBuf,'(20(A2,A8,A))')
     &     (' >', fldList(i), '<', i=j,MIN(j+19,nFlds) )
         CALL PRINT_MESSAGE(msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
        ENDDO
        WRITE(msgBuf,'(A,1PE22.14,A,I4,A)') 'missingVal=', misVal,
     &                           ' ; nTimRec =',nTimRec,' , timeList:'
        CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
        IF ( nTimRec.GE.1 ) THEN
         WRITE(msgBuf,'(1P20E20.12)') (timList(i),i=1,nTimRec)
         CALL PRINT_MESSAGE(msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
        ENDIF
      ENDIF

      _END_MASTER( myThid )
      _BARRIER

C-    set output arguments:
      nbFields = nFlds

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: READ_MFLDS_3D_RL
C     !INTERFACE:
      SUBROUTINE READ_MFLDS_3D_RL(
     I                fldName,
     O                field,
     U                nj,
     I                fPrec, nNz, myIter, myThid )

C     !DESCRIPTION:
C     Read, from a Multi-Fields binary file, field "fldName" into array "field"
C     record Nb "nj" is search through the field-list (from meta-file) which
C     has been set before (calling READ_MFLDS_SET).
C     In case nFlds is <=0 , by-pass the search and directly read record number "nj"

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "RW_MFLDS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     fldName :: Name of the field to read
C     field   :: Output array to read in
C     nj (in) :: number of the record (in file) just before the one to read
C     nj (out):: number of the record (from current file) which was read in
C     fPrec   :: File precision (number of bits per word, = 32 or 64)
C     nNz     :: Number of levels to read in
C     myIter  :: Iteration number
C     myThid  :: My Thread Id number
      CHARACTER*(8) fldName
      _RL     field(*)
      INTEGER nj
      INTEGER fPrec
      INTEGER nNz
      INTEGER myIter
      INTEGER myThid
CEOP

C     !FUNCTIONS
      INTEGER  ILNBLNK
      EXTERNAL ILNBLNK

C     !LOCAL VARIABLES:
      INTEGER j, iL, ioUnit
      LOGICAL prtMsg
      LOGICAL useCurrentDir
      _RS     dummyRS(1)
      CHARACTER*(2) fType
      CHARACTER*(MAX_LEN_FNAM) fName
      CHARACTER*(MAX_LEN_MBUF) msgBuf
C-----

      iL = ILNBLNK(mFldsFile)
#ifdef RW_SAFE_MFLDS
      IF ( iL.EQ.0 ) THEN
        WRITE(msgBuf,'(2A,I4)') 'READ_MFLDS_3D_RL: ',
     &    'empty MFLDS file-name'
        CALL PRINT_ERROR( msgBuf, myThid )
        CALL ALL_PROC_DIE( myThid )
        STOP 'ABNORMAL END: S/R READ_MFLDS_3D_RL (fileName)'
      ENDIF
#endif /* RW_SAFE_MFLDS */

      ioUnit = standardMessageUnit
      prtMsg = debugLevel.GE.debLevA .AND. myThid.EQ.1
      IF ( nFlds.GE.1 ) THEN
C--   Search for "fldName" in list of field-names:
        nj = 0
        DO j=1,nFlds
          IF ( fldName.EQ.fldList(j) .AND. nj.EQ.0 ) nj = j
        ENDDO
        IF ( nj.EQ.0 ) THEN
C-      record unsuccessful search:
          _BEGIN_MASTER( myThid )
          nMissFld = nMissFld + 1
          j = MIN(nMissFld,sizFldList)
          fldMiss(j) = fldName
          _END_MASTER( myThid )
          IF ( prtMsg ) THEN
            iL = ILNBLNK(mFldsFile)
            iL = MIN(iL,MAX_LEN_MBUF-54-20)
            WRITE(msgBuf,'(5A)') 'READ_MFLDS_3D_RL: ',
     &       'field: "',fldName,'" missing in file: ',mFldsFile(1:iL)
            CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
          ENDIF
        ELSE
C-      convert from field Number to record number (if mix of 3D & 2D flds)
          j = nj
          IF ( nj.GT.nFl3D ) nj = nj + nFl3D*(thirdDim-1)
          IF ( prtMsg ) THEN
            WRITE(msgBuf,'(3A,2(A,I4))') 'READ_MFLDS_3D_RL: ',
     &       'read field: "',fldName,'", #',j,' in fldList, rec=',nj
            CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
          ENDIF
        ENDIF
      ELSEIF ( nj.GE.0 ) THEN
C-      increment record number
        nj = nj + 1
        IF ( prtMsg ) THEN
            WRITE(msgBuf,'(3A,2(A,I4))') 'READ_MFLDS_3D_RL: ',
     &       'no fldList, try to read field "',fldName, '", rec=',nj
            CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
        ENDIF
      ENDIF

      IF ( nj.GE.1 ) THEN
C--   read in array "field"
        fName = mFldsFile
        useCurrentDir = .FALSE.
        fType = 'RL'
#ifdef ALLOW_MDSIO
        CALL MDS_READ_FIELD(
     I                       fName, fPrec, useCurrentDir,
     I                       fType, nNz, 1, nNz,
     O                       field, dummyRS,
     I                       nj, myThid )

#endif
      ENDIF

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: READ_MFLDS_LEV_RL
C     !INTERFACE:
      SUBROUTINE READ_MFLDS_LEV_RL(
     I                fldName,
     O                field,
     U                nj,
     I                fPrec, kSiz, kLo, kHi, myIter, myThid )

C     !DESCRIPTION:
C     Read, from a Multi-Fields binary file, field "fldName", a set of
C     consecutive levels (from kLo to kHi) into 3D RL array "field" (size: kSiz)
C     record Nb "nj" is search through the field-list (from meta-file) which
C     has been set before (calling READ_MFLDS_SET).
C     In case nFlds is <=0, by-pass the search and directly read record number "nj"

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "RW_MFLDS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     fldName :: Name of the field to read
C     field   :: Output array (RL type) to read in
C     nj (in) :: number of the record (in file) just before the one to read
C     nj (out):: number of the record (from current file) which was read in
C     fPrec   :: File precision (number of bits per word, = 32 or 64)
C     kSiz    :: size of third dimension of array "field" to read-in
C     kLo     :: 1rst vertical level (of array "field") to read-in
C     kHi     :: last vertical level (of array "field") to read-in
C     myIter  :: Iteration number
C     myThid  :: My Thread Id number
      CHARACTER*(8) fldName
      _RL     field(*)
      INTEGER nj
      INTEGER fPrec
      INTEGER kSiz, kLo, kHi
      INTEGER myIter
      INTEGER myThid
CEOP

C     !FUNCTIONS
      INTEGER  ILNBLNK
      EXTERNAL ILNBLNK

C     !LOCAL VARIABLES:
      INTEGER j, iL, ioUnit
      LOGICAL prtMsg
      LOGICAL useCurrentDir
      _RS     dummyRS(1)
      CHARACTER*(2) fType
      CHARACTER*(MAX_LEN_FNAM) fName
      CHARACTER*(MAX_LEN_MBUF) msgBuf
C-----

      iL = ILNBLNK(mFldsFile)
#ifdef RW_SAFE_MFLDS
      IF ( iL.EQ.0 ) THEN
        WRITE(msgBuf,'(2A,I4)') 'READ_MFLDS_LEV_RL: ',
     &    'empty MFLDS file-name'
        CALL PRINT_ERROR( msgBuf, myThid )
        CALL ALL_PROC_DIE( myThid )
        STOP 'ABNORMAL END: S/R READ_MFLDS_LEV_RL (fileName)'
      ENDIF
#endif /* RW_SAFE_MFLDS */

      ioUnit = standardMessageUnit
      prtMsg = debugLevel.GE.debLevA .AND. myThid.EQ.1
      IF ( nFlds.GE.1 ) THEN
C--   Search for "fldName" in list of field-names:
        nj = 0
        DO j=1,nFlds
          IF ( fldName.EQ.fldList(j) .AND. nj.EQ.0 ) nj = j
        ENDDO
        IF ( nj.EQ.0 ) THEN
C-      record unsuccessful search:
          _BEGIN_MASTER( myThid )
          nMissFld = nMissFld + 1
          j = MIN(nMissFld,sizFldList)
          fldMiss(j) = fldName
          _END_MASTER( myThid )
          IF ( prtMsg ) THEN
            iL = ILNBLNK(mFldsFile)
            iL = MIN(iL,MAX_LEN_MBUF-54-20)
            WRITE(msgBuf,'(5A)') 'READ_MFLDS_LEV_RL: ',
     &       'field: "',fldName,'" missing in file: ',mFldsFile(1:iL)
            CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
          ENDIF
        ELSE
C-      convert from field Number to record number (if mix of 3D & 2D flds)
          j = nj
          IF ( nj.GT.nFl3D ) nj = nj + nFl3D*(thirdDim-1)
          IF ( prtMsg ) THEN
            WRITE(msgBuf,'(3A,2(A,I4))') 'READ_MFLDS_LEV_RL: ',
     &       'read field: "',fldName,'", #',j,' in fldList, rec=',nj
            CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
          ENDIF
        ENDIF
      ELSEIF ( nj.GE.0 ) THEN
C-      increment record number
        nj = nj + 1
        IF ( prtMsg ) THEN
            WRITE(msgBuf,'(3A,2(A,I4))') 'READ_MFLDS_LEV_RL: ',
     &       'no fldList, try to read field "',fldName, '", rec=',nj
            CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
        ENDIF
      ENDIF

      IF ( nj.GE.1 ) THEN
C--   read in array "field"
        fName = mFldsFile
        useCurrentDir = .FALSE.
        fType = 'RL'
#ifdef ALLOW_MDSIO
        CALL MDS_READ_FIELD(
     I                       fName, fPrec, useCurrentDir,
     I                       fType, kSiz, kLo, kHi,
     O                       field, dummyRS,
     I                       nj, myThid )

#endif
      ENDIF

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: READ_MFLDS_LEV_RS
C     !INTERFACE:
      SUBROUTINE READ_MFLDS_LEV_RS(
     I                fldName,
     O                field,
     U                nj,
     I                fPrec, kSiz, kLo, kHi, myIter, myThid )

C     !DESCRIPTION:
C     Read, from a Multi-Fields binary file, field "fldName", a set of
C     consecutive levels (from kLo to kHi) into 3D RS array "field" (size: kSiz)
C     record Nb "nj" is search through the field-list (from meta-file) which
C     has been set before (calling READ_MFLDS_SET).
C     In case nFlds is <=0, by-pass the search and directly read record number "nj"

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "RW_MFLDS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     fldName :: Name of the field to read
C     field   :: Output array (RS type) to read in
C     nj (in) :: number of the record (in file) just before the one to read
C     nj (out):: number of the record (from current file) which was read in
C     fPrec   :: File precision (number of bits per word, = 32 or 64)
C     kSiz    :: size of third dimension of array "field" to read-in
C     kLo     :: 1rst vertical level (of array "field") to read-in
C     kHi     :: last vertical level (of array "field") to read-in
C     myIter  :: Iteration number
C     myThid  :: My Thread Id number
      CHARACTER*(8) fldName
      _RS     field(*)
      INTEGER nj
      INTEGER fPrec
      INTEGER kSiz, kLo, kHi
      INTEGER myIter
      INTEGER myThid
CEOP

C     !FUNCTIONS
      INTEGER  ILNBLNK
      EXTERNAL ILNBLNK

C     !LOCAL VARIABLES:
      INTEGER j, iL, ioUnit
      LOGICAL prtMsg
      LOGICAL useCurrentDir
      _RL     dummyRL(1)
      CHARACTER*(2) fType
      CHARACTER*(MAX_LEN_FNAM) fName
      CHARACTER*(MAX_LEN_MBUF) msgBuf
C-----

      iL = ILNBLNK(mFldsFile)
#ifdef RW_SAFE_MFLDS
      IF ( iL.EQ.0 ) THEN
        WRITE(msgBuf,'(2A,I4)') 'READ_MFLDS_LEV_RS: ',
     &    'empty MFLDS file-name'
        CALL PRINT_ERROR( msgBuf, myThid )
        CALL ALL_PROC_DIE( myThid )
        STOP 'ABNORMAL END: S/R READ_MFLDS_LEV_RS (fileName)'
      ENDIF
#endif /* RW_SAFE_MFLDS */

      ioUnit = standardMessageUnit
      prtMsg = debugLevel.GE.debLevA .AND. myThid.EQ.1
      IF ( nFlds.GE.1 ) THEN
C--   Search for "fldName" in list of field-names:
        nj = 0
        DO j=1,nFlds
          IF ( fldName.EQ.fldList(j) .AND. nj.EQ.0 ) nj = j
        ENDDO
        IF ( nj.EQ.0 ) THEN
C-      record unsuccessful search:
          _BEGIN_MASTER( myThid )
          nMissFld = nMissFld + 1
          j = MIN(nMissFld,sizFldList)
          fldMiss(j) = fldName
          _END_MASTER( myThid )
          IF ( prtMsg ) THEN
            iL = ILNBLNK(mFldsFile)
            iL = MIN(iL,MAX_LEN_MBUF-54-20)
            WRITE(msgBuf,'(5A)') 'READ_MFLDS_LEV_RS: ',
     &       'field: "',fldName,'" missing in file: ',mFldsFile(1:iL)
            CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
          ENDIF
        ELSE
C-      convert from field Number to record number (if mix of 3D & 2D flds)
          j = nj
          IF ( nj.GT.nFl3D ) nj = nj + nFl3D*(thirdDim-1)
          IF ( prtMsg ) THEN
            WRITE(msgBuf,'(3A,2(A,I4))') 'READ_MFLDS_LEV_RS: ',
     &       'read field: "',fldName,'", #',j,' in fldList, rec=',nj
            CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
          ENDIF
        ENDIF
      ELSEIF ( nj.GE.0 ) THEN
C-      increment record number
        nj = nj + 1
        IF ( prtMsg ) THEN
            WRITE(msgBuf,'(3A,2(A,I4))') 'READ_MFLDS_LEV_RS: ',
     &       'no fldList, try to read field "',fldName, '", rec=',nj
            CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
        ENDIF
      ENDIF

      IF ( nj.GE.1 ) THEN
C--   read in array "field"
        fName = mFldsFile
        useCurrentDir = .FALSE.
        fType = 'RS'
#ifdef ALLOW_MDSIO
        CALL MDS_READ_FIELD(
     I                       fName, fPrec, useCurrentDir,
     I                       fType, kSiz, kLo, kHi,
     O                       dummyRL, field,
     I                       nj, myThid )

#endif
      ENDIF

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: READ_MFLDS_CHECK
C     !INTERFACE:
      SUBROUTINE READ_MFLDS_CHECK(
     O                errList,
     U                nbErr,
     I                myIter, myThid )

C     !DESCRIPTION:
C     After reading a Multi-Fields binary file, check (and report)
C     for missing fields (attempted to read but not found).
C
C     Note: If missing fields, print error msg but take no action (no stop)
C           but return number of missing fields (+ list, if nbErr_inputArg > 0)
C           Depending on the calling context, may choose to stop or to continue

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "RW_MFLDS.h"

C     !INPUT PARAMETERS:
C     nbErr   :: max size of array errList
C     myIter  :: Iteration number
C     myThid  :: My Thread Id number
C     !OUTPUT PARAMETERS:
C     errList :: List of missing fields   (attempted to read but not found)
C     nbErr   :: Number of missing fields (attempted to read but not found)
      CHARACTER*(8) errList(*)
      INTEGER nbErr
      INTEGER myIter
      INTEGER myThid
CEOP

C     !FUNCTIONS
      INTEGER  ILNBLNK
      EXTERNAL ILNBLNK

C     !LOCAL VARIABLES:
      INTEGER i, j, nj, iL, ioUnit
      LOGICAL prtMsg
      CHARACTER*(MAX_LEN_MBUF) msgBuf
C-----

      iL = ILNBLNK(mFldsFile)
#ifdef RW_SAFE_MFLDS
      IF ( iL.EQ.0 ) THEN
        WRITE(msgBuf,'(2A,I4)') 'READ_MFLDS_CHECK: ',
     &    'empty MFLDS file-name'
        CALL PRINT_ERROR( msgBuf, myThid )
        CALL ALL_PROC_DIE( myThid )
        STOP 'ABNORMAL END: S/R READ_MFLDS_CHECK (fileName)'
      ENDIF
#endif /* RW_SAFE_MFLDS */

C--   Initialise output arguments
      DO j=1,nbErr
       errList(j) = ' '
      ENDDO

C--   every one waits for master thread to finish the update of
C       missing fields number & list.
      _BARRIER

      IF ( nMissFld.GE.1 ) THEN
C--   Attempted to read some fields that were not in the current MFLDS file
C     => report by printing Error Msg:
         ioUnit = errorMessageUnit
         _BEGIN_MASTER( myThid )
         WRITE(msgBuf,'(3A)') 'READ_MFLDS_CHECK: ',
     &     'reading from file: ', mFldsFile(1:iL)
         CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
         WRITE(msgBuf,'(2A,I4,A)') 'READ_MFLDS_CHECK: ',
     &     'which contains ', nFlds, ' fields :'
         CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
         DO j=1,nFlds,20
          WRITE(msgBuf,'(20(A2,A8,A))')
     &     (' >', fldList(i), '<', i=j,MIN(j+19,nFlds) )
          CALL PRINT_MESSAGE(msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
         ENDDO
         WRITE(msgBuf,'(A,I4,A)') 'READ_MFLDS_CHECK: ',
     &                  nMissFld, ' field(s) is/are missing :'
         CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
         nj = MIN( nMissFld, sizFldList )
         DO j=1,nj,20
          WRITE(msgBuf,'(20(A2,A8,A))')
     &     (' >', fldMiss(i), '<', i=j,MIN(j+19,nj) )
          CALL PRINT_MESSAGE(msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
         ENDDO
         _END_MASTER( myThid )

C-       Size problem:
         IF ( nMissFld.GT.sizFldList ) THEN
           WRITE(msgBuf,'(2A,I4)') 'READ_MFLDS_CHECK: ',
     &      'missing fields list has been truncated to', sizFldList
           CALL PRINT_ERROR( msgBuf, myThid )
           CALL ALL_PROC_DIE( myThid )
           STOP 'ABNORMAL END: S/R READ_MFLDS_CHECK (list-size Pb)'
         ENDIF

C-       Fill the error output list (up to the Max size: nbErr)
         nj = MIN( nMissFld, nbErr )
         DO j=1,nj
          errList(j) = fldMiss(j)
         ENDDO
      ELSE
C--   Normal end : print msg before resetting "mFldsFile"
        ioUnit = standardMessageUnit
        prtMsg = debugLevel.GE.debLevA .AND. myThid.EQ.1
        IF ( prtMsg ) THEN
         WRITE(msgBuf,'(3A)') 'READ_MFLDS_CHECK: ',
     &     '- normal end ; reset MFLDS file-name: ', mFldsFile(1:iL)
         CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
        ENDIF

      ENDIF

C-    Return the number of missing fields
      nbErr = nMissFld

#ifdef RW_SAFE_MFLDS
      _BARRIER
      _BEGIN_MASTER( myThid )
C--   Reset MFLDS file name:
       mFldsFile = ' '
      _END_MASTER( myThid )
      _BARRIER
#endif /* RW_SAFE_MFLDS */

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: READ_MFLDS_RENAME
C     !INTERFACE:
      SUBROUTINE READ_MFLDS_RENAME(
     I                              fldName, newName,
     O                              errCode,
     I                              myThid )

C     !DESCRIPTION:
C     Rename one field in fldList

C     !USES:
      IMPLICIT NONE
c#include "SIZE.h"
#include "EEPARAMS.h"
#include "RW_MFLDS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     fldName  :: field name to rename
C     newName  :: new name to replace fldName
C     errCode  :: returned error code:
C                 0 = succesful ; 1 = fldName not found ; > 1 : error
C     myThid   :: my Thread Id. number
      CHARACTER*(8) fldName
      CHARACTER*(8) newName
      INTEGER errCode
      INTEGER myThid
CEOP

C     !LOCAL VARIABLES:
C     i , j    :: loop counter
      INTEGER i , j
C-    for debug print:
c     CHARACTER*(MAX_LEN_MBUF) msgBuf

      errCode = 1

C-    search for fldName in fldList:
      j = 0
      DO i=1,nFlds
        IF ( fldList(i) .EQ. fldName ) THEN
          IF ( j.EQ.0 ) THEN
            errCode = 0
            j = i
          ELSE
C--    fldName appears more than once in fldList (errCode=3):
            errCode = 3
          ENDIF
        ENDIF
      ENDDO

      IF ( errCode.EQ.0 ) THEN
C--   Do not replace if newName is already in the list (errCode=2):
        DO i=1,nFlds
          IF ( fldList(i).EQ.newName ) errCode = 2
        ENDDO
      ENDIF

      IF ( errCode.EQ.0 ) THEN
        _BARRIER
        _BEGIN_MASTER( myThid )
        fldList(j) = newName
        _END_MASTER( myThid )
        _BARRIER
      ENDIF

      RETURN
      END

#include "PP81_OPTIONS.h"

CBOP
C     !ROUTINE: PP81_OUTPUT
C     !INTERFACE:
      SUBROUTINE PP81_OUTPUT( myTime, myIter, myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE PP81_OUTPUT
C     | o Do PP81 diagnostic output.
C     *==========================================================
C     | The following CPP flag (MULTIPLE_RECORD_PP81_STATE_FILES) is
C     | #define/#undefed here since it is specific to this routine
C     | and very user-preference specific.
C     |
C     | If #undefed (default) the state files are written as in all versions
C     | prior to checkpoint32, where a file is created per variable, per time
C     | and per tile. This *has* to be the default because most users use this
C     | mode and all utilities and scripts (diagnostic) assume this form.
C     | It is also robust, as explained below.
C     |
C     | If #defined, subsequent snap-shots are written as records in the
C     | same file (no iteration number in filenames).
C     | Advantages: - fewer files
C     |       - for small problems, is easy to copy the output around
C     | Disadvantages:
C     |       - breaks a lot of diagnostic scripts
C     |       - for large or long problems this creates huge files
C     |       - is an unexpected, unsolicited change in behaviour which came
C     |         as a surprise (in c32) and inconvenience to several users
C     |       - can not accomodate changing the frequency of output
C     |         after a pickup (this is trivial in previous method
C     |         but needs new code and parameters in this new method)
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "PP81.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     myTime :: my time in simulation ( s )
C     myIter :: my Iteration number
C     myThid :: my Thread Id number
      _RL     myTime
      INTEGER myIter
      INTEGER myThid

#ifdef ALLOW_PP81

C     !FUNCTIONS:
      LOGICAL  DIFFERENT_MULTIPLE
      EXTERNAL DIFFERENT_MULTIPLE

C     !LOCAL VARIABLES:
C     == Local variables ==
      CHARACTER*(10) suff
CEOP

C----------------------------------------------------------------
C     Dump snapshot of PP variables.
C----------------------------------------------------------------

      IF ( myIter.NE.nIter0 .AND.
     &     DIFFERENT_MULTIPLE( PPdumpFreq, myTime, deltaTClock )
     &   ) THEN

       IF (PPwriteState) THEN
C       Write each snap-shot as a new file
        IF ( rwSuffixType.EQ.0 ) THEN
          WRITE(suff,'(I10.10)') myIter
        ELSE
          CALL RW_GET_SUFFIX( suff, myTime, myIter, myThid )
        ENDIF
        CALL WRITE_FLD_XYZ_RL('PPviscAr.',suff,PPviscAr,
     &       myIter,myThid)
        CALL WRITE_FLD_XYZ_RL('PPdiffKr.',suff,PPdiffKr,
     &       myIter,myThid)
       ENDIF

      ENDIF

#endif /* ALLOW_PP81 */

      RETURN
      END

#include "CPP_EEOPTIONS.h"

CBOP
C     !ROUTINE: NML_CHANGE_SYNTAX

C     !INTERFACE:
      SUBROUTINE NML_CHANGE_SYNTAX(
     U                              record,
     I                              data_file, myThid )
C     !DESCRIPTION:
C     *=================================================================*
C     | SUBROUTINE NML\_CHANGE\_SYNTAX
C     | o Apply changes to namelist to fit compiler requirement
C     *=================================================================*
C     | Change trailing \& to trailing / when needed
C     | Change array specification from F95 standard
C     |        to commonly accepted F77 form (extented F77)
C     *=================================================================*

C     !USES:
      IMPLICIT NONE

C     == Global variables ==
#include "EEPARAMS.h"

C     !FUNCTIONS:
      INTEGER  ILNBLNK
      EXTERNAL ILNBLNK
#ifdef NML_EXTENDED_F77
      INTEGER  IFNBLNK
      EXTERNAL IFNBLNK
#endif /* NML_EXTENDED_F77 */

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     record    :: current line record (from parameter file) to process
C     data_file :: current parameter file which contains the current record
C     myThid    :: my Thread Id number
      CHARACTER*(MAX_LEN_PREC) record
      CHARACTER*(*) data_file
      INTEGER myThid

C     !LOCAL VARIABLES:
C     == Local variables ==
      INTEGER il
      CHARACTER*(2) nmlEnd
#ifdef NML_TERMINATOR
      PARAMETER( nmlEnd = ' /' )
#else
      PARAMETER( nmlEnd = ' &' )
#endif

#ifdef NML_EXTENDED_F77
C     i0      :: position of active "=" (end of variable name definition)
C     i1      :: position of 1rst left parenthesis
C     i2      :: position of 1rst colon
C     i3      :: position of 1rst comma after the 1rst colon
C     i4      :: position of right parenthesis after the 1rst left one
C     nWd     :: number of words following "=" found in this reccord
C     msgBuf  :: Informational/error message buffer
      INTEGER i0, i1, i2, i3, i4
      INTEGER nWd, is, ie, iUnit
      INTEGER i, n, ii
c     INTEGER iLf
      LOGICAL sngQ, dblQ, comma
      LOGICAL hasNum1, hasNum2
      LOGICAL debugPrt
      CHARACTER*(MAX_LEN_MBUF) msgBuf
#endif /* NML_EXTENDED_F77 */
CEOP

      il = MAX(ILNBLNK(record),1)
      IF ( il .EQ. 2 ) THEN
       IF ( record(1:2) .EQ. ' &' ) THEN
        record(1:2) = nmlEnd
       ENDIF
      ENDIF

#ifdef NML_EXTENDED_F77
      debugPrt = .FALSE.
c     iLf = MAX(ILNBLNK(data_file),1)
      iUnit = errorMessageUnit
      i0 = 0
      i1 = 0
      i2 = 0
      i3 = 0
      i4 = 0
C--   search for end of variable spec ('=' char) and count words that follow
      nWd = 0
      sngQ  = .TRUE.
      dblQ  = .TRUE.
      comma = .FALSE.
      DO i=1,il
        IF ( record(i:i).EQ."'" .AND. dblQ ) THEN
          sngQ = .NOT.sngQ
          IF ( i0.GE.1 .AND. sngQ ) nWd = nWd + 1
        ENDIF
        IF ( record(i:i).EQ.'"' .AND. sngQ ) THEN
          dblQ = .NOT.dblQ
          IF ( i0.GE.1 .AND. dblQ ) nWd = nWd + 1
        ENDIF
        IF ( record(i:i).EQ.'='  .AND. i0.EQ.0
     &                .AND. sngQ .AND. dblQ ) i0 = i
      ENDDO
C--   find position of 1rst set of parenthesis, comma and colon
      DO i=1,i0
        IF ( record(i:i).EQ.'(' .AND. i1.EQ.0 ) i1 = -i
        IF ( record(i:i).EQ.':' .AND. i1.LT.0 ) THEN
          IF ( i2.EQ.0 ) i2 = i
          IF ( comma ) THEN
            WRITE(msgBuf,'(2A)') 'NML_CHANGE_SYNTAX: warning: ',
     &                           'no possible safe conversion of rec:'
            CALL PRINT_MESSAGE( msgBuf, iUnit, SQUEEZE_RIGHT, myThid )
            WRITE(iUnit,'(A)') record(1:il)
            WRITE(msgBuf,'(4A)') 'NML_CHANGE_SYNTAX: ',
     &                           'from file="', data_file, '".'
c    &                           'from file="', data_file(1:iLf), '".'
            CALL PRINT_MESSAGE( msgBuf, iUnit, SQUEEZE_RIGHT, myThid )
            i1 = 1
          ENDIF
        ENDIF
        IF ( record(i:i).EQ.',' .AND. i1.LT.0 ) THEN
          comma = .TRUE.
          IF ( i3.EQ.0 .AND. i2.GE.1 ) i3 = i
        ENDIF
        IF ( record(i:i).EQ.')' .AND. i1.LT.0 ) THEN
          i1 = -i1
          i4 = i
        ENDIF
      ENDDO
      IF ( debugPrt .AND. i0.GE.1 ) THEN
c       WRITE(iUnit,'(5A)') ' ', data_file(1:iLf),
c    &               ' , rec >', record(1:i0), '<'
        WRITE(iUnit,'(5A)') ' ',data_file,' , rec >',record(1:i0),'<'
        WRITE(iUnit,'(A,2I4,L5,A,4I4)')
     &  '  i0,nWd,comma =',i0,nWd,comma,' ; i1,i2,i3,i4 =',i1,i2,i3,i4
      ENDIF
      IF ( i4.EQ.0 .AND. i1.NE.0 ) THEN
        i2 = 0
        IF ( i1.NE.1 ) THEN
          WRITE(msgBuf,'(2A)') 'NML_CHANGE_SYNTAX: ',
     &                         'error in parsing record:'
          CALL PRINT_MESSAGE( msgBuf, iUnit, SQUEEZE_RIGHT, myThid )
          WRITE(iUnit,'(A)') record(1:il)
          WRITE(msgBuf,'(4A)') 'NML_CHANGE_SYNTAX: ',
     &                          'from file="', data_file, '".'
c    &                          'from file="', data_file(1:iLf), '".'
          CALL PRINT_MESSAGE( msgBuf, iUnit, SQUEEZE_RIGHT, myThid )
        ENDIF
      ENDIF
C--   Only try conversion if colon found within 1rst pair of parenthesis
      IF ( i2.NE.0 ) THEN
C     check for index value between i1 and i2
       IF ( i2.GT.i1+1 ) THEN
         is = IFNBLNK(record(i1+1:i2-1))
         ie = ILNBLNK(record(i1+1:i2-1))
         i = i1+is
         IF ( record(i:i).EQ.'-' .OR.  record(i:i).EQ.'+' ) is = is+1
         hasNum1 = ( is.GE.1 .AND. is.LE.ie )
         IF ( hasNum1 ) THEN
          DO i=i1+is,i1+ie
           n = ICHAR(record(i:i))
           IF ( n.LT.ICHAR('0') .OR. n.GT.ICHAR('9') ) hasNum1 = .FALSE.
          ENDDO
         ENDIF
       ELSE
         hasNum1 = .FALSE.
       ENDIF
C     check for index value after i2 (and before i3 or i4)
       ii = i4
       IF ( i3.NE.0 ) ii = i3
       IF ( ii.GT.i2+1 ) THEN
         is = IFNBLNK(record(i2+1:ii-1))
         ie = ILNBLNK(record(i2+1:ii-1))
         i = i2+is
         IF ( record(i:i).EQ.'-' .OR.  record(i:i).EQ.'+' ) is = is+1
         hasNum2 = ( is.GE.1 .AND. is.LE.ie )
         IF ( hasNum2 ) THEN
          DO i=i2+is,i2+ie
           n = ICHAR(record(i:i))
           IF ( n.LT.ICHAR('0') .OR. n.GT.ICHAR('9') ) hasNum2 = .FALSE.
          ENDDO
         ENDIF
       ELSE
         hasNum2 = .FALSE.
       ENDIF
       IF ( i3.NE.0 ) THEN
C--   Colon applies to 1rst index of multidim array (found comma after colon)
C     Note: safe case which cannot be confused with sub-string colon
         IF ( hasNum1 .AND. hasNum2 ) THEN
           IF ( debugPrt ) WRITE(iUnit,'(3A)')
     &                           'remove: "',record(i2:i3-1),'"'
           DO i=i2,i3-1
             record(i:i) = ' '
           ENDDO
         ELSE
           WRITE(msgBuf,'(2A)') 'NML_CHANGE_SYNTAX: ',
     &                  'invalid indices for array conversion in:'
           CALL PRINT_MESSAGE( msgBuf, iUnit, SQUEEZE_RIGHT, myThid )
           WRITE(iUnit,'(A)') record(1:il)
           WRITE(msgBuf,'(4A)') 'NML_CHANGE_SYNTAX: ',
     &                          'from file="', data_file, '".'
c    &                          'from file="', data_file(1:iLf), '".'
           CALL PRINT_MESSAGE( msgBuf, iUnit, SQUEEZE_RIGHT, myThid )
         ENDIF
       ENDIF
       IF ( i3.EQ.0 .AND. nWd.NE.1 ) THEN
C--   Colon applies to index of vector (single-dim array):
C     discard the case where colon defines sub-string of character-string variable
C     by assuming that in this case 1 and only 1 word follows the equal sign
         IF ( hasNum1 .AND. hasNum2 ) THEN
           IF ( debugPrt ) WRITE(iUnit,'(3A)')
     &                           'remove: "',record(i2:i4-1),'"'
           DO i=i2,i4-1
             record(i:i) = ' '
           ENDDO
         ELSE
           WRITE(msgBuf,'(2A)') 'NML_CHANGE_SYNTAX: ',
     &                  'invalid indices for vector conversion in:'
           CALL PRINT_MESSAGE( msgBuf, iUnit, SQUEEZE_RIGHT, myThid )
           WRITE(iUnit,'(A)') record(1:il)
           WRITE(msgBuf,'(4A)') 'NML_CHANGE_SYNTAX: ',
     &                          'from file="', data_file, '".'
c    &                          'from file="', data_file(1:iLf), '".'
           CALL PRINT_MESSAGE( msgBuf, iUnit, SQUEEZE_RIGHT, myThid )
         ENDIF
       ENDIF
C-----
      ENDIF
#endif /* NML_EXTENDED_F77 */

      RETURN
      END

#include "FIZHI_OPTIONS.h"
CBOP
C     !ROUTINE: FIZHI_WRITE_PICKUP
C     !INTERFACE:
      SUBROUTINE FIZHI_WRITE_PICKUP( suff, myTime, myIter, myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R FIZHI_WRITE_PICKUP
C     | o Writes current state of fizhi package to a pickup file
C     *==========================================================*
C     \ev

C     !USES:
CEOP
      IMPLICIT NONE

C     == Global variables ===
#include "SIZE.h"
#include "fizhi_SIZE.h"
#include "fizhi_land_SIZE.h"
#include "fizhi_coms.h"
#include "fizhi_land_coms.h"
#include "EEPARAMS.h"
#include "PARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine Arguments ==
C     suff    :: suffix for pickup file (eg. ckptA or 0000000010)
C     myTime  :: current time
C     myIter  :: time-step number
C     myThid  :: Number of this instance
      CHARACTER*(*) suff
      _RL myTime
      INTEGER myIter
      INTEGER myThid

C     !LOCAL VARIABLES:
C     fn      :: character buffer for creating filename
C     prec    :: precision of pickup files
C     lgf     :: flag to write "global" files
      INTEGER prec, iChara, lChar
      CHARACTER*(MAX_LEN_FNAM) fn
      LOGICAL lgf
      _RL temp(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nrphys,Nsx,Nsy)
      integer i,j,k,bi,bj

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
      do bj = 1,myByLo(myThid), myByHi(myThid)
      do bi = 1,myBxLo(myThid), myBxHi(myThid)
      do k = 1,Nrphys
      do j = 1-OLy,sNy+OLy
      do i = 1-OLx,sNx+OLx
       temp(i,j,k,bi,bj) = 0.
      enddo
      enddo
      enddo
      enddo
      enddo

      lChar = 0
      DO iChara = 1,len(suff)
       IF ( suff(iChara:iChara) .NE. ' ') lChar=iChara
      ENDDO
      WRITE(fn,'(A,A)') 'pickup_fizhi.',suff(1:lChar)
      prec = precFloat64
      lgf = globalFiles

C--   Write fields as consecutive records
      CALL WRITE_REC_3D_RL(fn,prec,Nrphys,uphy,      1,myIter,myThid)
      CALL WRITE_REC_3D_RL(fn,prec,Nrphys,vphy,      2,myIter,myThid)
      CALL WRITE_REC_3D_RL(fn,prec,Nrphys,thphy,     3,myIter,myThid)
      CALL WRITE_REC_3D_RL(fn,prec,Nrphys,sphy,      4,myIter,myThid)

      CALL WRITE_REC_3D_RL(fn,prec,Nrphys,cldtot_lw, 5,myIter,myThid)
      CALL WRITE_REC_3D_RL(fn,prec,Nrphys,cldras_lw, 6,myIter,myThid)
      CALL WRITE_REC_3D_RL(fn,prec,Nrphys,cldlsp_lw, 7,myIter,myThid)
      CALL WRITE_REC_3D_RL(fn,prec,Nrphys,lwlz,      8,myIter,myThid)
      CALL WRITE_REC_3D_RL(fn,prec,Nrphys,cldtot_sw, 9,myIter,myThid)
      CALL WRITE_REC_3D_RL(fn,prec,Nrphys,cldras_sw,10,myIter,myThid)
      CALL WRITE_REC_3D_RL(fn,prec,Nrphys,cldlsp_sw,11,myIter,myThid)
      CALL WRITE_REC_3D_RL(fn,prec,Nrphys,swlz,     12,myIter,myThid)
      CALL WRITE_REC_3D_RL(fn,prec,Nrphys,qliqavelw,13,myIter,myThid)
      CALL WRITE_REC_3D_RL(fn,prec,Nrphys,qliqavesw,14,myIter,myThid)
      CALL WRITE_REC_3D_RL(fn,prec,Nrphys,fccavelw, 15,myIter,myThid)
      CALL WRITE_REC_3D_RL(fn,prec,Nrphys,fccavesw, 16,myIter,myThid)

      do bj = myByLo(myThid), myByHi(myThid)
      do bi = myBxLo(myThid), myBxHi(myThid)
      do j = 1,sNy
      do i = 1,sNx
       temp(i,j,1,bi,bj) = raincon(i,j,bi,bj)
       temp(i,j,2,bi,bj) = rainlsp(i,j,bi,bj)
       temp(i,j,3,bi,bj) = snowfall(i,j,bi,bj)
      enddo
      enddo

      temp(1,1,4,bi,bj) = float(iras(bi,bj))
      temp(2,1,4,bi,bj) = float(nlwcld(bi,bj))
      temp(3,1,4,bi,bj) = float(nlwlz(bi,bj))
      temp(4,1,4,bi,bj) = float(nswcld(bi,bj))
      temp(5,1,4,bi,bj) = float(nswlz(bi,bj))
      temp(6,1,4,bi,bj) = float(imstturbsw(bi,bj))
      temp(7,1,4,bi,bj) = float(imstturblw(bi,bj))

      enddo
      enddo

      CALL WRITE_REC_3D_RL(fn,prec,Nrphys,temp,17,myIter,myThid)

      RETURN
      END

#include "DIAG_OPTIONS.h"
#ifdef ALLOW_AUTODIFF
# include "AUTODIFF_OPTIONS.h"
#endif

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: DIAGNOSTICS_SWITCH_ONOFF

C     !INTERFACE:
      SUBROUTINE DIAGNOSTICS_SWITCH_ONOFF(
     I                       seqFlag, myTime, myIter, myThid )

C     !DESCRIPTION:
C-----
C     Called at the beginning of the time-step,
C     to switch on/off diagnostics for snap-shot output
C-----
C      during iterations that are multiple of |freq|,
C      switch ON diagnostics (ndiag>=0) that will become active
C      and then can be written at the end of the time-step ;
C      otherwise, put diagnostics in non-active mode (ndiag=-1)
C-----

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "DIAGNOSTICS_SIZE.h"
#include "DIAGNOSTICS.h"

C     !INPUT PARAMETERS:
C     seqFlag  :: flag that indicates where this S/R is called from:
C              :: = 1 : called from the top of FORWARD_STEP, forward sweep
C              :: =-1 : called from AUTODIFF_INADMODE_SET_AD, backward sweep
C     myTime   :: current Time of simulation ( s )
C     myIter   :: current Iteration number
C     myThid   :: my Thread Id number
      INTEGER seqFlag
      _RL     myTime
      INTEGER myIter
      INTEGER myThid

C     !FUNCTIONS
      LOGICAL  DIFF_PHASE_MULTIPLE
      EXTERNAL DIFF_PHASE_MULTIPLE

C     !LOCAL VARIABLES:
C      newIter :: future iteration number
C      j,m,n   :: loop index
      CHARACTER*(MAX_LEN_MBUF) msgBuf
c     INTEGER newIter
      INTEGER m, n, nd
      INTEGER bi, bj, ip, iSp
      LOGICAL time4SnapShot
      _RL     phiSec, freqSec
      INTEGER nInterval
      _RL     xInterval
      LOGICAL firstCall
      LOGICAL dBugFlag
      INTEGER dBugUnit
#ifdef ALLOW_FIZHI
      LOGICAL  ALARM2NEXT
      EXTERNAL ALARM2NEXT
      CHARACTER*9 tagname
#endif
CEOP

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      dBugFlag = diag_dBugLevel.GE.debLevE .AND. myThid.EQ.1
      dBugUnit = errorMessageUnit

C--   Track diagnostics pkg activation status:
      firstCall = myIter.EQ.nIter0
      IF ( seqFlag.EQ.-1 ) THEN
#ifdef ALLOW_DIVIDED_ADJOINT
        CALL DIAGS_TRACK_DIVA( firstCall, myIter, myThid )
#else
        firstCall = (myIter+1).EQ.nEndIter
#endif
      ENDIF
      IF ( firstCall .AND. ( seqFlag.EQ.1 .OR. seqFlag.EQ.-1 ) ) THEN
c       IF ( seqFlag.EQ.1 .AND. diag_pkgStatus.NE.10 ) STOP
        _BARRIER
        _BEGIN_MASTER(myThid)
        diag_pkgStatus = ready2fillDiags
        _END_MASTER(myThid)
        _BARRIER
c     ELSEIF
c       IF ( diag_pkgStatus.NE.ready2fillDiags ) STOP
      ENDIF

c     newIter = 1 + myIter
      DO n = 1,nlists

       IF ( freq(n).LT.0. ) THEN
C--    Select diagnostics list that uses instantaneous output

        freqSec = freq(n)
        phiSec = phase(n)
        time4SnapShot = DIFF_PHASE_MULTIPLE( phiSec, freqSec,
     &                                       myTime, deltaTClock )
#ifdef ALLOW_FIZHI
        IF ( useFIZHI ) THEN
         WRITE(tagname,'(A,I2.2)')'diagtag',n
         time4SnapShot = ALARM2NEXT(tagname,deltaT)
        ENDIF
#endif
#ifdef ALLOW_CAL
        IF ( useCAL ) THEN
          CALL CAL_TIME2DUMP( phiSec, freqSec, deltaTClock,
     U                        time4SnapShot,
     I                        myTime, myIter, myThid )
        ENDIF
#endif /* ALLOW_CAL */

        DO bj=myByLo(myThid), myByHi(myThid)
         DO bi=myBxLo(myThid), myBxHi(myThid)
          IF ( time4SnapShot ) THEN
C--       switch ON diagnostics of output-stream # n
            DO m=1,nActive(n)
c             nd = ABS(jdiag(m,n))
c             IF (ndiag(nd).NE.0) WRITE(0,*) myIter,nd,ndiag(nd),' ->',0
              ip = idiag(m,n)
              IF (ip.GT.0) ndiag(ip,bi,bj) = 0
            ENDDO
          ELSE
C--       switch OFF diagnostics of output-stream # n
            DO m=1,nActive(n)
c             nd = ABS(jdiag(m,n))
c             IF (ndiag(nd).NE.-1) WRITE(0,*) myIter,nd,ndiag(nd),' ->',-1
              ip = idiag(m,n)
              IF (ip.GT.0) ndiag(ip,bi,bj) = -1
            ENDDO
          ENDIF
         ENDDO
        ENDDO

C--    list with instantaneous output: end
       ENDIF

       IF ( averageCycle(n).GT.1 ) THEN
C--    Select diagnostics list that uses periodic averaging
        xInterval = myTime + deltaTClock*0.5 _d 0 - averagePhase(n)
        xInterval = xInterval / averageFreq(n)
        IF ( xInterval.GE.0. ) THEN
          nInterval = INT(xInterval)
        ELSE
          nInterval = 1 + INT( -xInterval/FLOAT(averageCycle(n)) )
          nInterval = nInterval*averageCycle(n) + INT(xInterval) - 1
        ENDIF
        nInterval = MOD(nInterval,averageCycle(n))

C-     check future value of pdiag:
        IF (dBugFlag.AND.pdiag(n,1,1).NE.nInterval)
     &    WRITE(dBugUnit,'(A,I8,3(A,I4),F17.6)')
     &     'DIAG_SWITCH_ONOFF: at it=', myIter, ', list:', n,
     &     ' switch', pdiag(n,1,1),' ->', nInterval, xInterval
        IF ( nInterval.LT.0 .OR. nInterval.GE.averageCycle(n) ) THEN
          WRITE(msgBuf,'(2A,I3,A,I4)') 'DIAGNOSTICS_SWITCH_ONOFF:',
     &       ' error setting pdiag(n=',n,') to:', nInterval
          CALL PRINT_ERROR( msgBuf , myThid )
          WRITE(msgBuf,'(2A,I4,A,F17.6)') 'DIAGNOSTICS_SWITCH_ONOFF:',
     &       ' cycle=', averageCycle(n), ', xInt=', xInterval
          CALL PRINT_ERROR( msgBuf , myThid )
          STOP 'ABNORMAL END: S/R DIAGNOSTICS_SWITCH_ONOFF'
        ENDIF

        DO bj=myByLo(myThid), myByHi(myThid)
         DO bi=myBxLo(myThid), myBxHi(myThid)
           pdiag(n,bi,bj) = nInterval
         ENDDO
        ENDDO
C--    list with periodic averaging: end
       ENDIF

      ENDDO

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      DO n = 1,diagSt_nbLists

       IF ( diagSt_freq(n).LT.0. ) THEN
C--    Select diagnostics list that uses instantaneous output

        dBugFlag = diag_dBugLevel.GE.debLevE

        freqSec = diagSt_freq(n)
        phiSec = diagSt_phase(n)
        time4SnapShot = DIFF_PHASE_MULTIPLE( phiSec, freqSec,
     &                                       myTime, deltaTClock )

#ifdef ALLOW_FIZHI
        IF ( useFIZHI ) THEN
         WRITE(tagname,'(A,I2.2)')'diagStg',n
         time4SnapShot = ALARM2NEXT(tagname,deltaT)
        ENDIF
#endif
#ifdef ALLOW_CAL
        IF ( useCAL ) THEN
          CALL CAL_TIME2DUMP( phiSec, freqSec, deltaTClock,
     U                        time4SnapShot,
     I                        myTime, myIter, myThid )
        ENDIF
#endif /* ALLOW_CAL */

        DO bj=myByLo(myThid), myByHi(myThid)
         DO bi=myBxLo(myThid), myBxHi(myThid)
          dBugFlag = dBugFlag.AND.(bi.EQ.1.AND.bj.EQ.1.AND.myThid.EQ.1)
          IF ( time4SnapShot ) THEN
C--     switch ON diagnostics of output-stream # n
            DO m=1,diagSt_nbActv(n)
             iSp = iSdiag(m,n)
             IF (iSp.GT.0) THEN
               nd = jSdiag(m,n)
               IF (dBugFlag.AND.qSdiag(0,0,iSp,bi,bj).NE. 0.)
     &          WRITE(dBugUnit,'(A,I8,A,I6,3A,1PE10.3,A,I3)')
     &           'DIAG_SWITCH_ONOFF: at it=', myIter, ' diag:', nd,
     &           ' ',cdiag(nd),' :',qSdiag(0,0,iSp,bi,bj),' ->', 0
               qSdiag(0,0,iSp,bi,bj) = 0.
             ENDIF
            ENDDO
          ELSE
C--     switch OFF diagnostics of output-stream # n
            DO m=1,diagSt_nbActv(n)
             iSp = iSdiag(m,n)
             IF (iSp.GT.0) THEN
               nd = jSdiag(m,n)
               IF (dBugFlag.AND.qSdiag(0,0,iSp,bi,bj).NE.-1.)
     &          WRITE(dBugUnit,'(A,I8,A,I6,3A,1PE10.3,A,I3)')
     &           'DIAG_SWITCH_ONOFF: at it=', myIter, ' diag:', nd,
     &           ' ',cdiag(nd),' :',qSdiag(0,0,iSp,bi,bj),' ->', -1
               qSdiag(0,0,iSp,bi,bj) = -1.
             ENDIF
            ENDDO
          ENDIF
         ENDDO
        ENDDO

       ENDIF
      ENDDO

      RETURN
      END

#include "FIZHI_OPTIONS.h"
      SUBROUTINE TILE (
     I                 NCH, DTSTEP, ITYP, TRAINL,TRAINC, TSNOW,  UM,
     I                 ETURB,  DEDQA,  DEDTC,  HSTURB, DHSDQA, DHSDTC,
     I                 TM,     QM,     CD,     SUNANG, PARDIR,  PARDIF,
     I                 SWNET,  HLWDWN, PSUR,    ZLAI,   GREEN,  Z2,
     I                 SQSCAT, RSOIL1, RSOIL2,   RDC,    U2FAC,
     I                 QSATTC, DQSDTC, ALWRAD, BLWRAD,
     U                 TC, TD, QA, SWET1, SWET2, SWET3, CAPAC, SNOW,
     O                 EVAP, SHFLUX, RUNOFF, BOMB,
     O                 EINT,   ESOI,   EVEG,   ESNO, SMELT, HLATN,
     O                 HLWUP,GDRAIN,RUNSRF,FWSOIL,
     O                 STRDG1, STRDG2, STRDG3, STRDG4,
     O                 STRDG5, STRDG6, STRDG7, STRDG8, STRDG9
     &                )

C   SCCS VERSION @(#)lsm.f      1.2 11/3/92

C****
C****       This subroutine computes the outgoing fluxes of sensible and
C**** latent heat from the land surface and updates the surface prognostic
C**** variables.
C****
      IMPLICIT NONE
C
C****
#include "sibber.h"
C****
      INTEGER NCH
      INTEGER ITYP(NCH)
      _RL  DTSTEP,  TRAINL(NCH), TRAINC(NCH), TSNOW(NCH), UM(NCH),
     &       ETURB(NCH),  DEDQA(NCH), HSTURB(NCH), DHSDTC(NCH),
     &         TM (NCH),     CD(NCH), SUNANG(NCH), DHSDQA(NCH),
     &         QM (NCH), PARDIR(NCH), PARDIF(NCH),  SWNET(NCH),
     &      HLWDWN(NCH),   PSUR(NCH),   ZLAI(NCH),  GREEN(NCH),
     &          Z2(NCH), SQSCAT(NCH),  DEDTC(NCH)
      _RL  RSOIL1(NCH), RSOIL2(NCH),    RDC(NCH),  U2FAC(NCH),
     &     QSATTC(NCH), DQSDTC(NCH),  ALWRAD(NCH), BLWRAD(NCH),
     &          TC(NCH),     TD(NCH),     QA(NCH),   BOMB(NCH),
     &       SWET1(NCH),  SWET2(NCH),  SWET3(NCH),  CAPAC(NCH),
     &        SNOW(NCH),   EVAP(NCH), SHFLUX(NCH), RUNOFF(NCH)
      _RL   EINT(NCH),    ESOI(NCH),   EVEG(NCH),   ESNO(NCH),
     &     STRDG1(NCH),  STRDG2(NCH), STRDG3(NCH), STRDG4(NCH),
     &     STRDG5(NCH),  STRDG6(NCH), STRDG7(NCH), STRDG8(NCH),
     &     STRDG9(NCH),
     &      SMELT(NCH),   HLATN(NCH),  HLWUP(NCH), GDRAIN(NCH),
     &     RUNSRF(NCH),  FWSOIL(NCH)
C****
      INTEGER ChNo
      _RL     SWET(nch,NLAY),   VGPSAT(NTYPS),   VGCSAT (NTYPS),
     &       VGZDEP(NLAY,NTYPS),   VGSLOP(NTYPS),            DELTC,
     &                    DELEA,    VGPH1(NTYPS),     VGPH2(NTYPS),
     &            VGRPLN(NTYPS),    CSOIL0(NTYPS),          WSOI12,
     &             VGBEE(NTYPS),    DELZ12(NTYPS),
     &            DELZ23(NTYPS)
C****

      _RL PHLAY(nch,NLAY), AKLAY(nch,NLAY), SWET12(nch),
     &      CSOIL(nch),
     &       RCUN(nch),     VPDSTR(nch),   ESATTX(nch),
     &       VPDSTX(nch),   VGBEEX(nch)
      _RL EMAXRT(nch), VGWMAX(NLAY,NTYPS), FTEMP(nch),
     &        PHR(nch),      SOILCO(nch),    RC(nch),
     &        EAX(nch),          TX(nch),   RCX(nch),
     &     DRCDTC(nch),      SATCAP(nch),   PAR(nch),
     &       PDIR(nch),       DUMMY(nch)
      _RL FTEMPX(nch),  DRCDEA(nch), VGPSAX(nch), VGCSAX(nch),
     &                VGZDEX(NLAY,nch), VGSLOX(nch), VGPH1X(nch),
     &     VGPH2X(nch),  VGRPLX(nch)
      _RL  DEDEA(nch),  DHSDEA(nch),     EM(nch), ESATTC(nch),
     &     DESDTC(nch),      EA(nch),     RA(nch),   ALHX(nch),
     &     WETEQ1(nch), WETEQ2(nch),
     &        RX1(nch),     RX2(nch), SNWFRC(nch), POTFRC(nch),
     &     ESNFRC(nch),  EIRFRC(nch),   FCAN(nch),  EPFRC,
     &     DEFCIT, EADJST, RTBS
      _RL cmpbug

C****
      DATA VGWMAX   /8.4,    621.6,      840.0,
     2               8.4,    621.6,      840.0,
     3               8.4,    621.6,      840.0,
     4               8.4,    197.4,      420.0,
     5               8.704,  204.5,      435.2,
     6               8.4,     71.4,      420.0,
     7               4.000,   4.000,    130.56,
     8               4.000,   4.000,    130.56,
     9               8.704,   73.984,    130.56,
     1               4.000,   4.000,    130.56
     &              /
      DATA VGBEE /    4.,    4.,    4.,    4.,  1.69,    4.,
     &                4.,  1.69,  1.69, 1.69/
C      DATA VGBEE /    7.,    7.,    7.,    7.,  1.69,    7.,
C     &                7.,  1.69,  1.69, 1.69/
c      DATA VGBEE /    4.,    4.,    4.,    4.,  0.95,    4.,
c     &                4.,  0.95,  0.95, 0.95/
C      DATA VGBEE /7, 7, 7, 7, 2, 7, 7, 4, 2, 4/
      DATA VGPSAT/    -0.281,     -0.281,       -0.281,       -0.281,
     5                -0.073,     -0.281,       -0.281,       -0.073,
     9                -0.073 ,    -0.073/
C      DATA VGPSAT/    -0.086,     -0.086,       -0.086,       -0.086,
C     5                -0.073,     -0.086,       -0.086,       -0.073,
C     9                -0.073 ,    -0.073/
c      DATA VGPSAT/    -0.281,     -0.281,       -0.281,       -0.281,
c     5                -0.014,     -0.281,       -0.281,       -0.014,
c     9                -0.014 ,    -0.014/
c      DATA VGCSAT /  0.00002,  0.00002,    0.00002,    0.00002,
c     5               0.0000583,  0.00002,    0.00002,    0.0000583,
c     9               0.0000583,  0.0000583
c     &              /
      DATA VGCSAT /  0.0000012,  0.0000012,    0.0000012,    0.0000012,
     5               0.0000583,  0.0000012,    0.0000012,    0.0000583,
     9               0.0000583,  0.0000583
     &              /
C**** - - - - - - - -
C**** THE FOLLOWING 3 VARIABLES MUST MAINTAIN CONSISTENT VALUES.  ZDEP12(N) =
C****  (VGZDEP(1,N)+VGZDEP(2,N))/2. ; SIMILARLY FOR ZDEP23(N).
C****
      DATA VGZDEP /.02, 1.48, 2.00,
     2             .02, 1.48, 2.00,
     3             .02, 1.48, 2.00,
     4             .02,  .47, 1.00,
     5             .02,  .47, 1.00,
     6             .02,  .17, 1.00,
     7             .0092,  .0092,  .30,
     8             .0092,  .0092,  .30,
     9             .02,  .17,  .30,
     1             .0092,  .0092,  .30
     &            /
      DATA DELZ12 / 0.75, 0.75, 0.75, 0.245, 0.245, 0.095, 0.0092,
     8        0.0092, 0.095, 0.0092 /
      DATA DELZ23 / 1.74, 1.74, 1.74, 0.735, 0.735, 0.585, 0.155,
     8        0.155, 0.235, 0.155 /
C**** - - - - - - - -
      DATA VGSLOP /    .1736,     .1736,     .1736,     .1736,
     5                 1.000,     .1736,     .1736,     1.000,
     &                 1.000 , 1.000 /
c      DATA VGSLOP /    .1736,     .1736,     .1736,     .1736,
c     5                 .0872,     .1736,     .1736,     .0872,
c     &                 .0872 , .0872 /
c      DATA VGSLOP / 1., 1., 1.,  1., 1., 1.,  1., 1., 1.,1./
      DATA VGPH1 /     -100.,     -190.,     -200.,     -120.,
     5                 -200.,     -200.,     -200.,      -10.,
     9                  -10.,      -10. /
      DATA VGPH2 /     -500.,     -250.,     -250.,     -230.,
     5                 -400.,     -400.,     -250.,     -100.,
     9                 -100.,     -100. /
      DATA VGRPLN /0.245E+09, 0.245E+09, 0.245E+09, 0.250E+09,
     5             0.250E+09, 0.250E+09, 0.245E+09,   0.1E+09,
     9               0.1E+09, 0.100E+09 /
C****
      DATA DELTC /0.01/, DELEA /0.001/

c Note: SNWMID & CSOIL0 parameters modified from (Koster/Suarez)
c       to obtain improved albedo, radswg, and annual/diurnal cycle (L.Takacs 2/17/00)
c ------------------------------------------------------------------------------------
      DATA CSOIL0 /175000.,175000.,175000.,175000.,175000.,
     .             175000.,175000.,120000.,175000., 70000./
#include "snwmid.h"

C****
C**** ---------------------------------------------------------------------
C****
CFPP$ EXPAND (TMPFAC, RCANOP, SOIL, WUPDAT, SMFAC)
C****
C**** Expand data as specified by ITYP into arrays of size NCH.
C****
      DO 50 ChNo = 1, NCH
      BOMB(CHNO) = 0.
      VGBEEX(ChNo) = VGBEE(ITYP(ChNo))
      VGPSAX(ChNo) = VGPSAT(ITYP(ChNo))
      VGCSAX(ChNo) = VGCSAT(ITYP(ChNo))
      VGZDEX(SFCLY ,ChNo) = VGZDEP(SFCLY ,ITYP(ChNo))
      VGZDEX(ROOTLY,ChNo) = VGZDEP(ROOTLY,ITYP(ChNo))
      VGZDEX(RECHLY,ChNo) = VGZDEP(RECHLY,ITYP(ChNo))
      VGSLOX(ChNo) = VGSLOP(ITYP(ChNo))
      VGPH1X(ChNo) = VGPH1(ITYP(ChNo))
      VGPH2X(ChNo) = VGPH2(ITYP(ChNo))
      VGRPLX(ChNo) = VGRPLN(ITYP(ChNo))
  50  CONTINUE

C****
C**** Pre-process input arrays as necessary:

      DO 100 ChNo = 1, NCH

      DEDQA(CHNO)  = MAX(  DEDQA(CHNO), 500. _d 0/ALHE )
      DEDTC(CHNO)  = MAX(  DEDTC(CHNO),   0. _d 0)
      DHSDQA(CHNO) = MAX( DHSDQA(CHNO),   0. _d 0)
      DHSDTC(CHNO) = MAX( DHSDTC(CHNO), -10. _d 0)

      EM(CHNO)     = QM(CHNO) * PSUR(CHNO) / EPSILON
      EA(CHNO)     = QA(CHNO) * PSUR(CHNO) / EPSILON
      ESATTC(CHNO) = QSATTC(CHNO) * PSUR(CHNO) / EPSILON
      DESDTC(CHNO) = DQSDTC(CHNO) * PSUR(CHNO) / EPSILON
C      DEDEA(CHNO)  = DEDQA(CHNO) * EPSILON / ( PSUR(CHNO) * ALHX(CHNO) )
      DEDEA(CHNO)  = DEDQA(CHNO) * EPSILON / PSUR(CHNO)
      DHSDEA(CHNO) = DHSDQA(CHNO) * EPSILON / PSUR(CHNO)
C      DEDTC(CHNO)  = DEDTC(CHNO) / ALHX(CHNO)
C      ETURB(CHNO)  = ETURB(CHNO) / ALHX(CHNO)
      PAR(CHNO)    = (PARDIR(CHNO) + PARDIF(CHNO) + 1.E-20)
      PDIR(CHNO)   = PARDIR(CHNO) / PAR(CHNO)
      RA(CHNO)     = ONE / ( CD(CHNO) * UM(CHNO) )
      SATCAP(ChNo) = 0.1 * ZLAI(ChNo)
      CSOIL(CHNO)  = CSOIL0(ITYP(ChNo))
      SWET(ChNo,SFCLY ) = max( min(SWET1(ChNo),1. _d 0), 0. _d 0)
      SWET(ChNo,ROOTLY) = max( min(SWET2(ChNo),1. _d 0), 0. _d 0)
      SWET(ChNo,RECHLY) = max( min(SWET3(ChNo),1. _d 0), 0. _d 0)
      CAPAC(CHNO)       = max( min(CAPAC(ChNo),SATCAP(CHNO)), 0. _d 0)
C****

      SNWFRC(CHNO) = SNOW(CHNO) / ( SNOW(CHNO) + SNWMID(ITYP(CHNO)) )
      FCAN(CHNO) = MIN( 1. _d 0, MAX(0. _d 0,CAPAC(ChNo)/SATCAP(ChNo)) )
      POTFRC(CHNO)=1.-(1.-SNWFRC(CHNO))*(1.-FCAN(CHNO))


      WSOI12=SWET(ChNo,SFCLY ) * VGWMAX(SFCLY ,ITYP(ChNo)) +
     &       SWET(ChNo,ROOTLY) * VGWMAX(ROOTLY,ITYP(ChNo))
      SWET12(ChNo) = WSOI12 /
     &          (VGWMAX(SFCLY,ITYP(ChNo)) + VGWMAX(ROOTLY,ITYP(ChNo)))

      EMAXRT(CHNO) = ( SNOW(CHNO) + CAPAC(CHNO) + WSOI12 ) / DTSTEP

C****
      RUNOFF(CHNO) = 0.
      RUNSRF(CHNO) = 0.
C**** (SMELT is zeroed in FLUXES)
C      SMELT(CHNO)  = 0.
      FWSOIL(CHNO) = 0.
 100  CONTINUE

C****
C**** - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C****       STEP 1: COMPUTE EFFECTIVE RESISTANCE RC FOR ENERGY BALANCE.
C****          (RCUNST  computes the unstressed resistance,
C****           VPDFAC  computes the vapor pressure deficit stress term,
C****           TMPFAC  computes the temperature stress term,
C****           SOIL    computes soil moisture potentials and conds.,
C****           SMFAC   computes rc given a leaf water potential stress,
C****           RSURFP  computes rc given a parallel resist. from the
C****                   surface,
C****           RCANOP  computes rc corrected for snow and interception.)
C****

      CALL RCUNST (
     I             NCH, ITYP, SUNANG, SQSCAT, PDIR,
     I             PAR, ZLAI, GREEN,
     O             RCUN
     &            )

      CALL VPDFAC (
     I             NCH,  ITYP,  ESATTC, EA,
     O             VPDSTR
     &            )

      CALL TMPFAC (
     I             NCH,  ITYP, TC,
     O             FTEMP
     &            )

      CALL SOIL (
     I           NCH, ITYP, SWET12, VGBEEX, VGPSAX, VGCSAX, DELZ12,
     O           PHR, SOILCO, DUMMY
     &          )

      cmpbug=0.

      CALL SMFAC (
     I            NCH,    ITYP,   ESATTC, EA,   PHR, SOILCO, RCUN,
     I            VPDSTR, FTEMP,  TC,     PSUR, Z2,  RSOIL1, RSOIL2,
     I            VGPH1X, VGPH2X, VGRPLX,
     O            RC
     &           )

      CALL RSURFP (
     I             NCH, UM, U2FAC, Z2, RDC, SWET(1,SFCLY),
     I             ESATTC, EA,
     U             RC,
     O             RX1, RX2
     &            )

      CALL RCANOP (
     I             NCH, CAPAC, SNOW, SATCAP, RA, ETURB, SNWFRC,
     I             POTFRC,
     U             RC
     &            )

C****
C**** -    -    -    -    -    -    -    -    -    -    -    -    -    -
C****
C**** Compute DRC/DT and DRC/DEA using temperature, v.p. perturbations:
C****

      DO 120 ChNo = 1, NCH
      TX(ChNo) = TC(ChNo) + DELTC
      ESATTX(ChNo) = ESATTC(ChNo) + DESDTC(CHNO) * DELTC
      EAX(ChNo) = EA(ChNo) + DELEA
  120 CONTINUE
C****
C**** temperature:
      CALL VPDFAC (NCH, ITYP, ESATTX, EA, VPDSTX)
      CALL TMPFAC (NCH, ITYP, TX, FTEMPX)
      CALL SMFAC (
     I            NCH,    ITYP,   ESATTX, EA,   PHR, SOILCO, RCUN,
     I            VPDSTX, FTEMPX, TX,     PSUR, Z2,  RSOIL1, RSOIL2,
     I            VGPH1X, VGPH2X, VGRPLX,
     O            RCX
     &           )
      CALL RSURFP (NCH, UM, U2FAC, Z2, RDC, SWET(1,SFCLY),
     I             ESATTX, EA,
     &             RCX,
     O             DUMMY,DUMMY
     &            )
      CALL RCANOP (NCH, CAPAC, SNOW, SATCAP, RA, ETURB, SNWFRC,
     &               POTFRC, RCX)
C****
      DO 125 ChNo = 1, NCH
      DRCDTC(ChNo) = (RCX(ChNo) - RC(ChNo)) / DELTC
  125 CONTINUE
C****
C**** vapor pressure:
      CALL VPDFAC (NCH, ITYP, ESATTC, EAX, VPDSTX)
      CALL SMFAC (
     I            NCH,    ITYP,  ESATTC, EAX,  PHR, SOILCO, RCUN,
     I            VPDSTX, FTEMP, TC,     PSUR, Z2,  RSOIL1, RSOIL2,
     I            VGPH1X, VGPH2X, VGRPLX,
     O            RCX
     &           )
      CALL RSURFP (NCH, UM, U2FAC, Z2, RDC, SWET(1,SFCLY),
     I             ESATTC, EAX,
     &             RCX,
     O             DUMMY,DUMMY
     &            )
      CALL RCANOP (NCH, CAPAC, SNOW, SATCAP, RA, ETURB, SNWFRC,
     &               POTFRC, RCX)
C****
      DO 150 ChNo = 1, NCH
      DRCDEA(ChNo) = (RCX(ChNo) - RC(ChNo)) / DELEA
  150 CONTINUE
C****

C****
C**** - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C****       STEP 2: Solve the energy balance at the surface.
C****
C****
C**** Determine effective latent heat of vaporization based on
C**** assumed fractional coverage of snow.  This requires the
C**** determination of the fractions of moisture taken from the various
C**** reservoirs:
C****         ESNFRC=fraction of total evap. coming from snow
C****         EIRFRC=fraction of total evap. coming from interception res.

      DO 200 CHNO=1,NCH
      RTBS=RX1(CHNO)*RX2(CHNO)/(RX1(CHNO)+RX2(CHNO))
      EPFRC=POTFRC(CHNO) * ( RA(CHNO) + RTBS ) /
     &                    ( RA(CHNO) + POTFRC(CHNO)*RTBS )
      ESNFRC(CHNO)=EPFRC*SNWFRC(CHNO)/
     &                      (SNWFRC(CHNO)+FCAN(CHNO)+1.E-20)
      EIRFRC(CHNO)=EPFRC*FCAN(CHNO)/(SNWFRC(CHNO)+FCAN(CHNO)+1.E-20)
      ALHX(CHNO) = (1.-ESNFRC(CHNO))*ALHE + ESNFRC(CHNO)*ALHS
  200 CONTINUE

      CALL FLUXES (
     I                NCH,   ITYP, DTSTEP, ESATTC, DESDTC,   ALHX,
     I              ETURB,  DEDEA,  DEDTC, HSTURB, DHSDEA, DHSDTC,
     I                 RC, DRCDEA, DRCDTC,
     I              SWNET, HLWDWN, ALWRAD, BLWRAD, ESNFRC,
     I                 TM,     EM,  CSOIL,   PSUR, EMAXRT, VGWMAX,
     U                 TC,     TD,     EA,   SWET,   SNOW,
     O             RUNOFF,   EVAP, SHFLUX,  SMELT,  HLWUP, BOMB,STRDG1,
     O             STRDG2, STRDG3, STRDG4, STRDG5, STRDG6, STRDG7,
     O             STRDG8, STRDG9
     &            )
c****
C****
C**** - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C****       STEP 3: Update the water quantities in the soil and in the
C****          interception reservoir.
C****          (WUPDAT  reduces moisture contents using calculated
C****           evap.,
C****           GWATER  computes darcian flux of water between soil
C****           layers.)
C****

      CALL WUPDAT (
     I               NCH,   ITYP, DTSTEP,
     I               EVAP, SATCAP, VGWMAX, TC, RA, RC,
     I               RX1, RX2,ESNFRC,EIRFRC,
     U               CAPAC, SNOW, SWET, RUNOFF,
     O               EINT, ESOI, EVEG, ESNO, RUNSRF,FWSOIL
     &              )

C****
C**** Correct any energy balance inconsistency.
C****
      DO 300 CHNO=1,NCH
      IF(EVAP(CHNO) .GT. 0.) THEN
        EADJST=(ESNO(CHNO)/DTSTEP) - ESNFRC(CHNO)*EVAP(CHNO)
        SHFLUX(CHNO)=SHFLUX(CHNO)-EADJST*(ALHS-ALHE)
        ENDIF
  300 CONTINUE



      CALL SOIL (
     I             NCH,          ITYP,        SWET (1, SFCLY), VGBEEX,
     I             VGPSAX,       VGCSAX,      DELZ12,
     O             PHLAY(1,SFCLY), AKLAY(1,SFCLY),  DUMMY
     &            )
      CALL SOIL (
     I             NCH,          ITYP,        SWET(1,ROOTLY), VGBEEX,
     I             VGPSAX,       VGCSAX,      DELZ12,
     O             PHLAY(1,ROOTLY), AKLAY(1,ROOTLY),   WETEQ1
     &            )
      CALL SOIL (
     I             NCH,          ITYP,        SWET(1,RECHLY), VGBEEX,
     I             VGPSAX,       VGCSAX,      DELZ23,
     O             PHLAY(1,RECHLY), AKLAY(1,RECHLY),   WETEQ2
     &            )

      CALL GWATER (
     I             NCH, ITYP, VGWMAX, PHLAY, AKLAY, TC, DTSTEP,
     I             VGZDEX, VGSLOX, WETEQ1, WETEQ2,
     I             VGPSAX, VGCSAX,
     U             SWET, RUNOFF, GDRAIN
     &            )

C**** - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C****
C****       STEP 4: Allow precipitation to fill interception reservoir
C****          and top soil layer
C****

      CALL SOIL (
     I             NCH,          ITYP,        SWET(1,ROOTLY), VGBEEX,
     I             VGPSAX,       VGCSAX,      DELZ12,
     O             PHLAY(1,ROOTLY), AKLAY(1,ROOTLY),   WETEQ1
     &            )

      CALL INTERC (
     I             NCH, ITYP, DTSTEP, TRAINL, TRAINC, TSNOW, SATCAP,
     I             VGWMAX, CSOIL, WETEQ1,
     U             TC, CAPAC, SNOW, SWET, RUNOFF, RUNSRF,
     &             SMELT, FWSOIL
     &            )


C****
C****
C**** Process data for return to GCM:

      DO 2000 ChNo = 1, NCH
      QA(CHNO) = EA(CHNO) * EPSILON / PSUR(CHNO)
C      DEDTC(CHNO) = DEDTC(CHNO) * ALHX(CHNO)
C      ETURB(CHNO) = ETURB(CHNO) * ALHX(CHNO)
      HLATN (CHNO) = EVAP (CHNO) * ALHX(CHNO)
      SWET1(ChNo) = SWET(ChNo,SFCLY)
      SWET2(ChNo) = SWET(ChNo,ROOTLY)
      SWET3(ChNo) = SWET(ChNo,RECHLY)

      IF(SWET1(ChNo).LT.1.E-10) SWET1(CHNO) = 0.0
      IF(SWET2(ChNo).LT.1.E-10) SWET2(CHNO) = 0.0
      IF(SWET3(ChNo).LT.1.E-10) SWET3(CHNO) = 0.0
      IF(CAPAC(ChNo).LT.1.E-10) CAPAC(CHNO) = 0.0
      IF(SNOW (ChNo).LT.1.E-10) SNOW (CHNO) = 0.0
      IF(RUNOFF(ChNo).LT.1.E-10) RUNOFF(CHNO) = 0.0

      EINT(CHNO) = EINT(CHNO) * ALHE / DTSTEP
      ESOI(CHNO) = ESOI(CHNO) * ALHE / DTSTEP
      EVEG(CHNO) = EVEG(CHNO) * ALHE / DTSTEP
      ESNO(CHNO) = ESNO(CHNO) * ALHS / DTSTEP

      DEFCIT = EVAP(CHNO) * ( RC(CHNO) + RA(CHNO) )
CCOOMMSTRDG1(CHNO) = DEFCIT / RA(CHNO)
CCOOMMSTRDG2(CHNO) = DEFCIT / ( RA(CHNO) + RCUN(CHNO) )
CCOOMMSTRDG3(CHNO) = DEFCIT / ( RA(CHNO) + RCUN(CHNO)/VPDSTR(CHNO) )
CCOOMMSTRDG4(CHNO) = DEFCIT / ( RA(CHNO) +
CCOOMM                   RCUN(CHNO)/(VPDSTR(CHNO)*FTEMP(CHNO)) )

 2000 CONTINUE
C****

      RETURN
      END
C****
C**** [ END CHIP ]
C****
C**** -----------------------------------------------------------------
C**** /////////////////////////////////////////////////////////////////
C**** -----------------------------------------------------------------
C****
C**** [ BEGIN INTERC ]
C****
      SUBROUTINE INTERC (
     I                   NCH, ITYP, DTSTEP, TRAINL, TRAINC,
     I                   TSNOW, SATCAP, WMAX, CSOIL, WETEQ1,
     U                   TC, CAPAC, SNOW,  SWET1,  RUNOFF, RUNSRF,
     U                   SMELT, FWSOIL
     &                  )
C****
C**** This routine uses the precipitation forcing to determine
C**** changes in interception, snowcover, and soil moisture storage.
C****
C**** Note:  In this formulation, rain that falls on frozen ground
C**** runs-off, rather than freezes.
C****
      IMPLICIT NONE
C****
#include "sibber.h"
C****
      INTEGER NCH
      INTEGER ITYP(NCH), ChNo
      _RL  TRAINL(NCH), TRAINC(NCH), TSNOW(NCH),  SATCAP(NCH),
     &      WMAX(NLAY,NTYPS), TC(NCH),   CSOIL(NCH),   CAPAC(NCH),
     &      SNOW(NCH), SWET1(NCH),  RUNOFF(NCH),  SMELT(NCH),
     &     RUNSRF(NCH), FWSOIL(NCH), WETEQ1(NCH), WETINT
      _RL DTSTEP, SNOWM, WATADD, CAVAIL, THRUC, WRUNC, WRUNL,
     &     TIMFRL, TIMFRC, FWETL, FWETC, THRU1, THRU2, THRUL, XTCORR,
     &     WETFRC
C****
C      DATA FWET0  /0.30/
      DATA FWETL /1.00/, FWETC /0.20/, TIMFRL/1.00/, TIMFRC/0.125/
C****
C**** ------------------------------------------------------------------
C**** Loop over chips:
      DO 100 ChNo = 1, NCH
C****
C**** Add to snow cover.  Melt snow if necessary.
      SNOW(ChNo) = SNOW(ChNo) + TSNOW(ChNo)*DTSTEP
      SNOWM = 0.
      IF( SNOW(CHNO).GT.0. .AND. TC(CHNO).GT.TF ) THEN
        SNOWM = MIN( SNOW(ChNo),
     &       MAX( 0. _d 0, (TC(ChNo)-TF)*CSOIL(ChNo)/ALHM )  )
        IF( SNOWM .EQ. SNOW(CHNO) ) THEN
            TC(ChNo) = TC(ChNo) - SNOWM * ALHM / CSOIL(ChNo)
            SNOW(CHNO)=0.
          ELSE
            TC(CHNO)=TF
            SNOW(ChNo) = SNOW(ChNo) - SNOWM
          ENDIF
        SMELT(CHNO)=SMELT(CHNO)+SNOWM/DTSTEP
        ENDIF
C****
C**** =======================================================
C****
C**** Load interception reservoir.  STEP 1: Large scale condensation.
C****
C**** Determine XTCORR, the fraction of a storm that falls on a previously
C**** wet surface due to the time correlation of precipitation position.
C**** (Time scale TIMFRL for large scale storms set to one for FWETL=1
C**** to reflect the effective loss of "position memory" when storm
C**** covers entire grid square.)

        XTCORR= (1.-TIMFRL) * MIN( 1. _d 0,(CAPAC(CHNO)/SATCAP(CHNO))/
     $       FWETL )

C****
C**** Fill interception reservoir with precipitation.
C**** THRU1 is first calculated as the amount falling through the
C****    canopy under the assumption that all rain falls randomly.
C****    only a fraction 1-XTCORR falls randomly, though, so the result
C****    is multiplied by 1-XTCORR.
C****
      WATADD = TRAINL(ChNo)*DTSTEP + SMELT(CHNO)*DTSTEP
      CAVAIL = ( SATCAP(CHNO) - CAPAC(CHNO) ) * FWETL
      WETINT = CAPAC(CHNO)/SATCAP(CHNO)
      IF( WATADD*(1.-WETINT) .LT. CAVAIL ) THEN
          THRU1 = WATADD*WETINT
        ELSE
          THRU1 = (WATADD - CAVAIL)
        ENDIF
      THRU1=THRU1*(1.-XTCORR)

C**** THRU2 is the amount that falls immediately through the canopy due
C**** to 'position memory'.

      THRU2=XTCORR*WATADD

      THRUL=THRU1+THRU2
      CAPAC(CHNO)=CAPAC(CHNO)+WATADD-THRU1-THRU2
C****
C**** ---------------------------------------------------
C****
C**** STEP 2: Moist convective precipitation.
C****
C**** Determine XTCORR, the fraction of a storm that falls on a previously
C**** wet surface due to the time correlation of precipitation position.

      XTCORR= (1.-TIMFRC) * MIN( 1. _d 0,(CAPAC(CHNO)/SATCAP(CHNO))/
     $     FWETC )

C****
C**** Fill interception reservoir with precipitation.
C**** THRU1 is first calculated as the amount falling through the
C****    canopy under the assumption that all rain falls randomly.
C****    only a fraction 1-XTCORR falls randomly, though, so the result
C****    is multiplied by 1-XTCORR.
C****
      WATADD = TRAINC(ChNo)*DTSTEP
      CAVAIL = ( SATCAP(CHNO) - CAPAC(CHNO) ) * FWETC
      WETINT = CAPAC(CHNO)/SATCAP(CHNO)
      IF( WATADD*(1.-WETINT) .LT. CAVAIL ) THEN
          THRU1 = WATADD*WETINT
        ELSE
          THRU1 = (WATADD - CAVAIL)
        ENDIF
      THRU1=THRU1*(1.-XTCORR)

C**** THRU2 is the amount that falls immediately through the canopy due
C**** to 'position memory'.

      THRU2=XTCORR*WATADD

      THRUC=THRU1+THRU2
      CAPAC(CHNO)=CAPAC(CHNO)+WATADD-THRU1-THRU2
C****
C***** =================================================================
C****
C**** Add precipitation moisture to soil, generate runoff.  if
C**** temperature is below freezing, all precipitation runs off.
C****
C**** STEP 1: Large scale condensation:
C****
      IF(SWET1(CHNO).GT.WETEQ1(CHNO) .AND. WETEQ1(CHNO).NE.1.) THEN
          WETFRC=(SWET1(CHNO)-WETEQ1(CHNO))/(1.-WETEQ1(CHNO))
        ELSE
          WETFRC=0.
        ENDIF

      CAVAIL = ( 1.-WETFRC)*FWETL*WMAX(1,ITYP(ChNo))*(1-WETEQ1(CHNO))
      IF ( THRUL * (1-WETFRC) .LT. CAVAIL ) THEN
          WRUNL = THRUL * WETFRC
          SWET1(ChNo) = SWET1(ChNo)
     *    + THRUL * ( 1. - WETFRC) / WMAX(1,ITYP(ChNo))
        ELSE
          WRUNL = THRUL - CAVAIL
          SWET1(CHNO) = SWET1(CHNO) + CAVAIL / WMAX(1,ITYP(ChNo))
        ENDIF
C****

C**** STEP 2: Moist convective precipitation:
C****
      IF(SWET1(CHNO).GT.WETEQ1(CHNO) .AND. WETEQ1(CHNO).NE.1.) THEN
          WETFRC=(SWET1(CHNO)-WETEQ1(CHNO))/(1.-WETEQ1(CHNO))
        ELSE
          WETFRC=0.
        ENDIF

      CAVAIL = (1.-WETFRC)*FWETC*WMAX(1,ITYP(ChNo))*(1-WETEQ1(CHNO))
      IF ( THRUC * (1-WETFRC) .LT. CAVAIL ) THEN
          WRUNC = THRUC * WETFRC
          SWET1(ChNo) = SWET1(ChNo)
     *    + THRUC * ( 1. - WETFRC) / WMAX(1,ITYP(ChNo))
        ELSE
          WRUNC = THRUC - CAVAIL
          SWET1(CHNO) = SWET1(CHNO) + CAVAIL / WMAX(1,ITYP(ChNo))
        ENDIF
C****
      RUNOFF(ChNo) = RUNOFF(ChNo) + (WRUNC+WRUNL)/DTSTEP
      RUNSRF(ChNo) = RUNSRF(ChNo) + (WRUNC+WRUNL)/DTSTEP
      FWSOIL(CHNO) = FWSOIL(CHNO) + (THRUC+THRUL-WRUNC-WRUNL)/DTSTEP
C****
 100  CONTINUE
C****
      RETURN
      END
C****
C**** [ END INTERC ]
C****
C**** -----------------------------------------------------------------
C**** /////////////////////////////////////////////////////////////////
C**** -----------------------------------------------------------------
C****
C**** [ BEGIN RCUNST ]
C****
      SUBROUTINE RCUNST (
     I                   NCH, ITYP, SUNANG, SQSCAT, PDIR,
     I                   PAR, ZLAI, GREEN,
     O                   RCUN
     &                  )
C****
C****     This subroutine calculates the unstressed canopy resistance.
C**** (p. 1353, Sellers 1985.)  Extinction coefficients are computed first.
C****
      IMPLICIT NONE
C****
#include "sibber.h"
C****
      INTEGER NCH
      INTEGER ITYP(NCH), ChNo

      _RL  SUNANG(NCH),   PDIR(NCH),   PAR(NCH),   ZLAI(NCH),
     &      SQSCAT(NCH),  GREEN(NCH),  RCUN(NCH)

      _RL   VGCHIL(NTYPS), VGZMEW(NTYPS),
     &       VGRST1(NTYPS), VGRST2(NTYPS), VGRST3(NTYPS)

      _RL            RHO4,         EXTK1,         EXTK2,
     &               RCINV,         GAMMA,          EKAT,    DUM1,
     &                DUM2,          DUM3,            AA,      BB,
     &                  ZK,            CC


      DATA VGCHIL /        0.1,        0.25,        0.01,        -0.3,
     5                    0.01,        0.20,         0.0,         0.0,
     9                     0.0,        0.0 /

      DATA VGZMEW/      0.9809,      0.9638,      0.9980,      1.0773,
     5                  0.9980,      0.9676,       1.000,       1.000,
     9                   1.000,      1.0000 /

      DATA VGRST1 /     2335.9,      9802.2,      2869.7,      2582.0,
     5                 93989.4,      9802.2,         0.0,         0.0,
     9                     0.0 ,        0.0/

      DATA VGRST2 /        0.0,        10.6,         3.7,         1.1,
     5                    0.01,        10.6,         0.0,         0.0,
     9                     0.0 ,        0.0/

      DATA VGRST3 /      153.5,       180.0,       233.0,       110.0,
     5                   855.0,       180.0,         1.0,         1.0,
     9                     1.0,         1.0 /




      DO 100 ChNo = 1, NCH

C**** First compute optical parameters.
C**** (Note: CHIL is constrained to be >= 0.01, as in SiB calcs.)

      AA = 0.5 - (0.633 + 0.330*VGCHIL(ITYP(ChNo)))*VGCHIL(ITYP(ChNo))
      BB = 0.877 * ( ONE - 2.*AA )
      CC =  ( AA + BB*SUNANG(ChNo) ) / SUNANG(ChNo)

      EXTK1 =  CC * SQSCAT(ChNo)
      EXTK2 = (ONE / VGZMEW(ITYP(ChNo))) * SQSCAT(ChNo)

      DUM1 =      PDIR(ChNo)  *   CC
      DUM2 = (ONE-PDIR(ChNo)) * ( BB*(ONE/3.+PIE/4.) + AA*1.5 )

C**** Bound extinction coefficient by 50./ZLAI:

      ZK =     PDIR(ChNo) *MIN( EXTK1, 50. _d 0/ZLAI(ChNo) ) +
     &    (ONE-PDIR(ChNo))*MIN( EXTK2, 50. _d 0/ZLAI(ChNo) )

C**** Now compute unstressed canopy resistance:

      GAMMA = VGRST1(ITYP(ChNo)) / VGRST3(ITYP(ChNo)) +
     &        VGRST2(ITYP(ChNo))

      EKAT = EXP( ZK*ZLAI(ChNo) )
      RHO4 = GAMMA / (PAR(ChNo) * (DUM1 + DUM2))

      DUM1 = (VGRST2(ITYP(ChNo)) - GAMMA) / (GAMMA + 1.E-20)
      DUM2 = (RHO4 * EKAT + ONE) / (RHO4 + ONE)
      DUM3 = ZK * VGRST3(ITYP(ChNo))
      RCINV = ( DUM1*LOG(DUM2) + ZK*ZLAI(ChNo) ) / DUM3

      RCUN(ChNo) = ONE / (RCINV * GREEN(ChNo) + 1.E-10)

 100  CONTINUE


      RETURN
      END
C****
C**** [ END RCUNST ]
C****
C**** -----------------------------------------------------------------
C**** /////////////////////////////////////////////////////////////////
C**** -----------------------------------------------------------------
C****
C**** [ BEGIN SOIL ]
C****
      SUBROUTINE SOIL (
     I         NCH, ITYP,  WET, VGBEEX, VGPSAX, VGCSAX, DELZ,
     O         PHR, SOILCO, WETEQ
     &                )
C****
C**** This subroutine returns soil moisture potential and conductivity.

      IMPLICIT NONE
C****
#include "sibber.h"
C****
      INTEGER NCH
      INTEGER ITYP(NCH), ChNo

      _RL    WET(NCH),    PHR(NCH), SOILCO(NCH), VGPSAX(NCH),
     &     VGCSAX(NCH), VGBEEX(NCH),  DELZ(NTYPS),  WETEQ(NCH),
     &     WEXPB,  WET0,  PHEQ

      DO 100 ChNo = 1, NCH

      WET0  = MAX(WET(CHNO),0.01 _d 0)
      WEXPB = WET0**VGBEEX(ChNo)

      PHR(ChNo)    = VGPSAX(ChNo) / WEXPB
      SOILCO(ChNo) = VGCSAX(ChNo) * WEXPB * WEXPB * WET0 * WET0 * WET0

      PHEQ = PHR(CHNO) - DELZ(ITYP(CHNO))
      WETEQ(CHNO) = ( PHEQ/VGPSAX(CHNO) ) ** ( -1/VGBEEX(CHNO) )

 100  CONTINUE

      RETURN
      END
C****
C**** [ END SOIL ]
C****
C**** -----------------------------------------------------------------
C**** /////////////////////////////////////////////////////////////////
C**** -----------------------------------------------------------------
C****
C**** [ BEGIN FLUXES ]
C****
      SUBROUTINE FLUXES (
     I            NCH,   ITYP, DTSTEP, ESATTC, DESDTC,   ALHX,
     I          ETURB,  DEDEA,  DEDTC, HSTURB, DHSDEA, DHSDTC,
     I             RC, DRCDEA, DRCDTC,
     I          SWNET, HLWDWN, ALWRAD, BLWRAD, ESNFRC,
     I             TM,     EM,  CSOIL,   PSUR, EMAXRT,   WMAX,
     U             TC,     TD,     EA,  SWET1,   SNOW,
     O         RUNOFF,   EVAP, SHFLUX,  SMELT,  HLWUP, BOMB, STRDG1,
     O         STRDG2, STRDG3, STRDG4, STRDG5, STRDG6, STRDG7,
     O         STRDG8, STRDG9
     &                  )
C****
C**** This subroutine computes the fluxes of latent and sensible heat
C**** from the surface through an energy balance calculation.
C****
      IMPLICIT NONE
C****
#include "sibber.h"
C****
      INTEGER NCH
      INTEGER ITYP(NCH), ChNo

      _RL       DTSTEP, ESATTC(NCH), DESDTC(NCH),   ALHX(NCH),
     &       ETURB(NCH),  DEDEA(NCH),  DEDTC(NCH),
     &      HSTURB(NCH), DHSDEA(NCH), DHSDTC(NCH),
     &          RC(NCH), DRCDEA(NCH), DRCDTC(NCH),
     &       SWNET(NCH), HLWDWN(NCH), ALWRAD(NCH), BLWRAD(NCH),
     &          TM(NCH),     EM(NCH),  CSOIL(NCH),   PSUR(NCH),
     &      EMAXRT(NCH),         WMAX(NLAY,NTYPS),
     &          TC(NCH),     TD(NCH),     EA(NCH), ESNFRC(NCH),
     &               SWET1(NCH,NLAY),   SNOW(NCH),
     &      RUNOFF(NCH),   EVAP(NCH), SHFLUX(NCH),  SMELT(NCH),
     &       HLWUP(NCH),   BOMB(NCH)
      _RL STRDG1(NCH),STRDG2(NCH),STRDG3(NCH),STRDG4(NCH)
      _RL STRDG5(NCH),STRDG6(NCH),STRDG7(NCH),STRDG8(NCH)
      _RL STRDG9(NCH)

      _RL     HLWTC,  CDEEPS,      Q0,  RHOAIR,   CONST,  DHLWTC,
     &        EPLANT,     A11,     A12,     A21,     A22,      F0,
     &           DEA,     DTC,  SNLEFT,     Q0X,  Q0SNOW,
     &         EANEW,  ESATNW,  EHARMN, DETERM, DENOM

      LOGICAL CHOKE
      _RL deepfac(ntyps)
      DATA deepfac /1.,1.,1.,1.,1.,1.,1.,1.,1.,1./
C****
C**** -------------------------------------------------------------------

      DO 200 ChNo = 1, NCH
C****
      HLWTC = ALWRAD(CHNO) + BLWRAD(CHNO) * TC(CHNO)
      CDEEPS = PIE * CSOIL(ChNo) * 2. / 86400.
      RHOAIR = PSUR(ChNo) * 100. / (RGAS * TC(ChNo))
      CONST = RHOAIR * EPSILON / PSUR(ChNo)
      DHLWTC = BLWRAD(CHNO)
C****
C**** Compute matrix elements A11, A22, AND Q0 (energy balance equation).
C****

      A11 = CSOIL(ChNo)/DTSTEP +
     &        DHLWTC +
     &        DHSDTC(ChNo) +
     &        ALHX(CHNO)*DEDTC(ChNo) +
     &        CDEEPS
      A12 = DHSDEA(ChNo) + ALHX(CHNO) * DEDEA(ChNo)
      Q0 =  SWNET(ChNo) +
     &        HLWDWN(ChNo) -
     &        HLWTC -
     &        HSTURB(ChNo) -
     &        ALHX(CHNO) * ETURB(ChNo) -
     &        CDEEPS * (TC(ChNo) - TD(ChNo))

          STRDG3(ChNo)=Q0/A11
          STRDG4(ChNo)=(SWNET(ChNo)+HLWDWN(ChNo)-HLWTC)/A11
          STRDG5(ChNo)=HSTURB(ChNo)/A11
          STRDG6(ChNo)=ALHX(CHNO)*ETURB(ChNo)/A11
          STRDG7(ChNo)=CDEEPS*(TC(ChNo) - TD(ChNo))/A11
          STRDG9(ChNo)=A11

C****
C**** Compute matrix elements A21, A22, and F0 (canopy water budget
C**** equation) and solve for fluxes.  Three cases are considered:
C****
C**** 1. Standard case: RC>0.
C**** 2. RC = 0.  Can only occur if CIR is full or ETURB is negative.
C****
      CHOKE = .TRUE.

      IF( RC(CHNO) .GT. 0.) THEN
          EPLANT = CONST * (ESATTC(ChNo) - EA(ChNo)) / RC(ChNo)
          IF(EPLANT*ETURB(ChNo).GE.0.) THEN
              EHARMN = 2.*EPLANT*ETURB(CHNO) / (EPLANT + ETURB(ChNo))
            ELSE
              EHARMN=0.
            ENDIF
C****
C****            Some limitations to A21 and A22 are applied:
C****            we assume that the increase in plant evaporation
C****            due to an increase in either TC or EA balances
C****            or outweighs any decrease due to RC changes.
C****

          A21 =  -DEDTC(ChNo)*RC(ChNo) +
     &      max(0. _d 0, CONST*DESDTC(ChNo) - EHARMN*DRCDTC(ChNo) )
          A22 = -( RC(ChNo)*DEDEA(ChNo) +
     &               max( 0. _d 0, CONST + EHARMN*DRCDEA(ChNo) )   )

          F0 = RC(ChNo) * (ETURB(ChNo) - EPLANT)
          DETERM = MIN( A12*A21/(A11*A22) - 1., -0.1 _d 0)
          DEA = ( Q0*A21 - A11*F0 ) / ( DETERM * A11*A22 )
          DTC = ( Q0 - A12*DEA ) / A11

          STRDG1(ChNo)=DTC
          STRDG2(ChNo)=DEA
          STRDG8(ChNo)=-A12*DEA/A11

          EVAP(ChNo) = ETURB(ChNo) + DEDEA(ChNo)*DEA + DEDTC(ChNo)*DTC
          SHFLUX(ChNo) = HSTURB(ChNo) + DHSDEA(ChNo)*DEA +
     &                                            DHSDTC(ChNo)*DTC
          DENOM = DETERM * A11*A22
        ELSE
          CHOKE = .FALSE.
          A21 = -DESDTC(ChNo)
          A22 = 1.
          F0 = ESATTC(ChNo) - EA(ChNo)
          DEA = ( Q0*A21 - A11*F0 ) / ( A12*A21 - A11*A22 )
          DTC = ( Q0 - A12*DEA ) / A11

          STRDG1(ChNo)=DTC
          STRDG2(ChNo)=DEA
          STRDG8(ChNo)=-A12*DEA/A11

          EVAP(ChNo) = ETURB(ChNo) + DEDEA(ChNo)*DEA + DEDTC(ChNo)*DTC
          SHFLUX(ChNo) = HSTURB(ChNo) + DHSDEA(ChNo)*DEA +
     &                                            DHSDTC(ChNo)*DTC
          DENOM = A12 * A21 - A11*A22
        ENDIF


C**** - - - - - - - - - - - - - - - - - - - -
C**** Account for snowmelt, if necessary.
C**** - - - - - - - - - - - - - - - - - - - -
      SMELT(CHNO)=0.
      SNLEFT=SNOW(CHNO)-EVAP(CHNO)*DTSTEP*ESNFRC(CHNO)
      IF(TC(CHNO)+DTC .GT. TF .AND. SNLEFT.GT.0.) THEN

C****      First re-calculate energy balance under assumption that all
C****      snow is melted.

        Q0X=Q0-ALHM*SNLEFT/DTSTEP
        SMELT(CHNO)=SNLEFT/DTSTEP

            DEA = ( Q0X*A21 - A11*F0 ) / DENOM
            DTC = ( Q0X - A12*DEA ) / A11

C****      If TC+DTC is now less than TF, too much snow has melted.  Now
C****      solve for balance assuming only some of the snow has melted.
C****      Set TC to TF.

        IF(TC(CHNO)+DTC .LT. TF) THEN
          DTC=TF-TC(CHNO)
          DEA=(F0-A21*DTC)/A22
          Q0SNOW=A11*DTC+A12*DEA
          SMELT(CHNO)=(Q0-Q0SNOW)/ALHM
          ENDIF

          STRDG1(ChNo)=DTC
          STRDG2(ChNo)=DEA
          STRDG8(ChNo)=-A12*DEA/A11

        EVAP(ChNo) = ETURB(ChNo) + DEDEA(ChNo)*DEA +
     &                   DEDTC(ChNo)*DTC
        SHFLUX(ChNo) = HSTURB(ChNo) + DHSDEA(ChNo)*DEA +
     &                                            DHSDTC(ChNo)*DTC

        ENDIF

C**** - - - - - - - - - - - - - - - - - - - - - - -
C**** Adjustments

C**** 1. Adjust deltas and fluxes if all available water evaporates
C****    during time step:
C****
      IF( EVAP(CHNO) .GT. EMAXRT(CHNO) ) THEN
        CHOKE = .FALSE.
        DEA = EM(CHNO) - EA(CHNO)
        DTC =
     &   (Q0 + ALHX(CHNO)*(ETURB(ChNo)-EMAXRT(CHNO)) - DHSDEA(CHNO)*DEA)
     &          /  ( A11 - ALHX(CHNO)*DEDTC(ChNo) )

          STRDG1(ChNo)=DTC
          STRDG2(ChNo)=DEA
          STRDG8(ChNo)=0.

        EVAP(CHNO) = EMAXRT(CHNO)
        SHFLUX(ChNo) = HSTURB(ChNo) + DHSDEA(ChNo)*DEA +
     &                                            DHSDTC(ChNo)*DTC
        SMELT(CHNO)=0.
        ENDIF
C****
C**** Adjust DEA and DTC if solutions were pathological:
C****
      ESATNW = ESATTC(CHNO)+DESDTC(CHNO)*DTC
      EANEW = EA(CHNO) + DEA



C**** 2. Pathological cases.

C**** Case 1: EVAP is positive in presence of negative gradient.
C**** Case 2: EVAP and ETURB have opposite sign, implying that
C**** "virtual effects" derivatives are meaningless and thus that we
C**** do not know the proper tendency terms.
C**** In both cases, assume zero evaporation for the time step.

C      IF( ( EVAP(CHNO) .LT. 0. .AND. EM(CHNO).LT.ESATNW )
C     &    .OR. ( EVAP(CHNO)*ETURB(CHNO) .LT. 0. ) )  THEN
      IF( EVAP(CHNO) .LT. 0. .AND. EM(CHNO).LT.ESATNW )  THEN
        CHOKE = .FALSE.
        DEA = EM(CHNO) - EA(CHNO)
        DTC = ( Q0 + ALHX(CHNO)*ETURB(ChNo) - DHSDEA(CHNO)*DEA ) /
     &            ( A11 - ALHX(CHNO)*DEDTC(ChNo) )

          STRDG1(ChNo)=DTC
          STRDG2(ChNo)=DEA
          STRDG8(ChNo)=0.

        EVAP(CHNO) = 0.
        SHFLUX(ChNo) = HSTURB(ChNo) + DHSDEA(ChNo)*DEA +
     &                                            DHSDTC(ChNo)*DTC

        IF(TC(CHNO)+DTC .GT. TF .AND. SNOW(CHNO).GT.0.) THEN
          Q0X=Q0-ALHM*SNOW(CHNO)/DTSTEP
          SMELT(CHNO)=SNOW(CHNO)/DTSTEP
          DTC = ( Q0X + ALHX(CHNO)*ETURB(ChNo) - DHSDEA(CHNO)*DEA ) /
     &              ( A11 - ALHX(CHNO)*DEDTC(ChNo) )
          IF(TC(CHNO)+DTC .LT. TF) THEN
            DTC=TF-TC(CHNO)
            Q0SNOW=A11*DTC+A12*DEA
            SMELT(CHNO)=(Q0-Q0SNOW)/ALHM
            ENDIF
          SHFLUX(ChNo) = HSTURB(ChNo) + DHSDEA(ChNo)*DEA +
     &                                            DHSDTC(ChNo)*DTC
          ENDIF
        ENDIF



C**** 3. Exceesive dea change: apply "choke".

      IF( CHOKE .AND. ABS(DEA) .GT. 0.5*EA(CHNO) ) THEN
        DEA = SIGN(.5*EA(CHNO),DEA)
        DTC = ( Q0 - A12*DEA ) / A11

          STRDG1(ChNo)=DTC
          STRDG2(ChNo)=DEA
          STRDG8(ChNo)=-A12*DEA/A11

        EVAP(ChNo) = ETURB(ChNo) + DEDEA(ChNo)*DEA + DEDTC(ChNo)*DTC
        SHFLUX(ChNo) = HSTURB(ChNo) + DHSDEA(ChNo)*DEA +
     &                                            DHSDTC(ChNo)*DTC
        IF(TC(CHNO)+DTC .GT. TF .AND. SNOW(CHNO).GT.0.) THEN
          SNLEFT=SNOW(CHNO)-EVAP(CHNO)*DTSTEP*ESNFRC(CHNO)
          Q0X=Q0-ALHM*SNLEFT/DTSTEP
          SMELT(CHNO)=SNLEFT/DTSTEP
          DTC = ( Q0X - A12*DEA ) / A11
          IF(TC(CHNO)+DTC .LT. TF) THEN
            DTC=TF-TC(CHNO)
            Q0SNOW=A11*DTC+A12*DEA
            SMELT(CHNO)=(Q0-Q0SNOW)/ALHM
            ENDIF
          EVAP(ChNo) = ETURB(ChNo) + DEDEA(ChNo)*DEA + DEDTC(ChNo)*DTC
          SHFLUX(ChNo) = HSTURB(ChNo) + DHSDEA(ChNo)*DEA +
     &                                            DHSDTC(ChNo)*DTC
          ENDIF
        ENDIF

C**** - - - - - - - - - - - - - - - - - - - - - - - - - - - -

      TC(ChNo) = TC(ChNo) + DTC
      EA(ChNo) = EA(ChNo) + DEA
      TD(ChNo) = TD(ChNo) +
c  CHANGED THIS: deep layer 2 times deeper
     &     DTSTEP * CDEEPS * (TC(ChNo) - TD(ChNo)) /
     .       (CSOIL(ChNo)*67.73*deepfac(ityp(ChNo)))
      HLWUP(CHNO) = HLWTC + DHLWTC*DTC

      SNOW(CHNO)=SNOW(CHNO)-SMELT(CHNO)*DTSTEP

C**** Make sure EA remains positive

      EA(CHNO) = MAX(EA(CHNO), 0.0 _d 0)

  200 CONTINUE



      RETURN
      END
C****
C**** [ END FLUXES ]
C****
C**** -----------------------------------------------------------------
C**** /////////////////////////////////////////////////////////////////
C**** -----------------------------------------------------------------
C****
C**** [ BEGIN VPDFAC ]
C****
      SUBROUTINE VPDFAC (
     I                   NCH, ITYP, ESATTC, EA,
     O                   VPDSTR
     &                  )
C****
C**** This subroutine computes the vapor pressure deficit stress.
C****
      IMPLICIT NONE
C****
#include "sibber.h"
C****
      INTEGER NCH
      INTEGER ITYP(NCH), ChNo
      _RL    ESATTC(NCH), EA(NCH),  VPDSTR(NCH)
c     _RL  VGDFAC(NTYPS)
C****
c     DATA VGDFAC /   .0273,    .0357,    .0310,    .0238,
c    5                .0275,    .0275,       0.,       0.,
c    9                   0.,      0. /
C****
C**** -----------------------------------------------------------------

      DO 100 ChNo = 1, NCH
C****
c      VPDSTR(ChNo) = 1. - (ESATTC(ChNo)-EA(ChNo)) * VGDFAC(ITYP(ChNo))
c      VPDSTR (ChNo) = MIN( 1. _d 0, MAX( VPDSTR(ChNo), 1. _d -10 ) )
      VPDSTR(CHNO) = 1.
C****
 100  CONTINUE
C****
      RETURN
      END
C****
C**** [ END VPDFAC ]
C****
C**** -----------------------------------------------------------------
C**** /////////////////////////////////////////////////////////////////
C**** -----------------------------------------------------------------
C****
C**** [ BEGIN TMPFAC ]
C****
      SUBROUTINE TMPFAC (
     I                   NCH,  ITYP, TC,
     O                   FTEMP
     &                  )
C****
C**** Compute temperature stress factor.
C****
      IMPLICIT NONE
C****
#include "sibber.h"
C****
      INTEGER NCH
      INTEGER ITYP(NCH), ChNo, TypPtr
      _RL TC(NCH), FTEMP(NCH)
      _RL    VGTLL(MemFac*NTYPS),    VGTU(MemFac*NTYPS),
     &       VGTCF1(MemFac*NTYPS),  VGTCF2(MemFac*NTYPS),
     &       VGTCF3(MemFac*NTYPS)
C****
      DATA VGTLL /MemFac*273., MemFac*273., MemFac*268., MemFac*283.,
     5            MemFac*283., MemFac*273., MemFac*  0., MemFac*  0.,
     9            MemFac*  0., MemFac*  0. /
      DATA VGTU /MemFac*318., MemFac*318., MemFac*313., MemFac*328.,
     5           MemFac*323., MemFac*323., MemFac*  0., MemFac*  0.,
     9           MemFac*  0. , MemFac*  0./
      DATA VGTCF1 / MemFac*-1.43549E-06,  MemFac*-6.83584E-07,
     3              MemFac* 1.67699E-07,  MemFac*-1.43465E-06,
     5              MemFac*-2.76097E-06,  MemFac*-1.58094E-07,
     7                       MemFac* 0.,           MemFac* 0.,
     9                       MemFac* 0. , MemFac*  0./
      DATA VGTCF2 / MemFac* 7.95859E-04,  MemFac* 3.72064E-04,
     3              MemFac*-7.65944E-05,  MemFac* 8.24060E-04,
     5              MemFac* 1.57617E-03,  MemFac* 8.44847E-05,
     7                       MemFac* 0.,           MemFac* 0.,
     9                       MemFac* 0. , MemFac*  0./
      DATA VGTCF3 / MemFac*-1.11575E-01,  MemFac*-5.21533E-02,
     3              MemFac* 6.14960E-03,  MemFac*-1.19602E-01,
     5              MemFac*-2.26109E-01,  MemFac*-1.27272E-02,
     7                       MemFac* 0.,           MemFac* 0.,
     9                       MemFac* 0. , MemFac*  0./
C****
C**** ----------------------------------------------------------------

      DO 100 ChNo = 1, NCH
C****
      TypPtr = MOD(ChNo,MemFac) + (ITYP(ChNo)-1)*MemFac + 1
      FTEMP(ChNo) = (TC(ChNo) - VGTLL(TypPtr)) *
     &              (TC(ChNo) - VGTU(TypPtr)) *
     &                    ( VGTCF1(TypPtr)*TC(ChNo)*TC(ChNo) +
     &                      VGTCF2(TypPtr)*TC(ChNo) +
     &                      VGTCF3(TypPtr) )
      IF ( TC(ChNo) .LE. VGTLL(TypPtr) .OR. TC(ChNo) .GE. VGTU(TypPtr) )
     &      FTEMP (ChNo) = 1.E-10
      FTEMP(CHNO) = MIN( 1. _d 0, MAX( FTEMP(ChNo), 1. _d -10 ) )
C****
 100  CONTINUE
C****
      RETURN
      END
C****
C**** [ END TMPFAC ]
C****
C**** -----------------------------------------------------------------
C**** /////////////////////////////////////////////////////////////////
C**** -----------------------------------------------------------------
C****
C**** [ BEGIN SMFAC ]
C****
      SUBROUTINE SMFAC (
     I                  NCH,    ITYP,   ESATTC, EA, PHR,  SOILCO,
     I                  RCUN,   VPDSTR, FTEMP,  TC, PSUR, Z2,
     I                  RSOIL1, RSOIL2, VGPH1X, VGPH2X, VGRPLX,
     O                  RC
     &                 )
C****
C**** This subroutine estimates RC after computing the
C**** leaf water potential stress.
C****
      IMPLICIT NONE
C****
#include "sibber.h"
C****
      INTEGER NCH
      INTEGER ITYP(NCH), ChNo
      _RL  ESATTC(NCH),      EA(NCH),     PHR(NCH),  SOILCO(NCH),
     &        RCUN(NCH),  VPDSTR(NCH),   FTEMP(NCH),      TC(NCH),
     &        PSUR(NCH),      Z2(NCH),  RSOIL1(NCH),  RSOIL2(NCH),
     &      VGPH1X(NCH),  VGPH2X(NCH),  VGRPLX(NCH),      RC(NCH)
      _RL   RCUNTD,  RHOAIR,   CONST,     DEF,     D12,     DR2,
     &        RSOIL,      R0,    EEST,  RSTFAC
C****
C**** -----------------------------------------------------------------

      DO 100 ChNo = 1, NCH
C****
      RCUNTD = RCUN(ChNo) / ( VPDSTR(ChNo)*FTEMP(ChNo) )
      RHOAIR = PSUR(ChNo) * 100. / ( RGAS*TC(ChNo) )

C****
      CONST = RHOAIR * EPSILON / PSUR(ChNo)
      DEF = ( ESATTC(ChNo) - EA(ChNo) ) * CONST
      D12 = VGPH1X(ChNo) - VGPH2X(ChNo)
      DR2 = PHR(ChNo) - Z2(ChNo) - VGPH2X(ChNo)
      RSOIL = RSOIL1(ChNo) + RSOIL2(ChNo)/SOILCO(ChNo)
      R0 = ( VGRPLX(ChNo) + RSOIL ) / RHOW
      EEST = DEF*DR2 / ( RCUNTD*D12 + DEF*R0 )
      RSTFAC = ( DR2 - R0*EEST ) / D12
      RSTFAC = MIN( 1. _d 0, MAX( 0.001 _d 0, RSTFAC ) )
      RC(ChNo) = RCUNTD / RSTFAC
C****
 100  CONTINUE
C****
      RETURN
      END
C****
C**** [ END SMFAC ]
C****
C**** -----------------------------------------------------------------
C**** /////////////////////////////////////////////////////////////////
C**** -----------------------------------------------------------------
C****
C**** [ BEGIN RSURFP ]
C****
      SUBROUTINE RSURFP (
     I                   NCH, UM, U2FAC, Z2, RDC, WET, ESATTC, EA,
     U                   RC,
     O                   RX1, RX2
     &                  )
C****
      IMPLICIT NONE
      INTEGER NCH
      INTEGER ChNo
      _RL     UM(NCH),   U2FAC(NCH),     Z2(NCH),    RDC(NCH),
     &        WET(NCH),  ESATTC(NCH),     EA(NCH),
     &         RC(NCH),     RX1(NCH),    RX2(NCH)
      _RL  U2, RSURF, HESAT
C****
C**** -----------------------------------------------------------------

      DO 100 ChNo = 1, NCH
C****
      U2 = UM(ChNo) * U2FAC(ChNo)
c      RSURF = RDC(ChNo) / U2 + 30. / (1.E-20 + WET(ChNo))
      RSURF = RDC(ChNo) / U2 + 26. + 6. / (1.E-20 + WET(ChNo))**2

C**** Account for subsaturated humidity at soil surface:
C****
      HESAT = ESATTC(CHNO) * MIN( 1. _d 0, WET(CHNO)*2. _d 0)
      IF( EA(CHNO) .LT. HESAT ) THEN
          RSURF=RSURF*( 1. + (ESATTC(CHNO)-HESAT)/(HESAT-EA(CHNO)) )
        ELSE
          RSURF=1.E10
        ENDIF


      RX1(CHNO)=RC(CHNO)
      RX2(CHNO)=RSURF

      RC(ChNo) = RC(CHNO) * RSURF / ( RC(ChNo) + RSURF )
C****
 100  CONTINUE
C****
      RETURN
      END
C****
C**** [ END RSURFP ]
C****
C**** -----------------------------------------------------------------
C**** /////////////////////////////////////////////////////////////////
C**** -----------------------------------------------------------------
C****
C**** [ BEGIN RCANOP ]
C****
      SUBROUTINE RCANOP (
     I                   NCH, CAPAC, SNOW, SATCAP, RA, ETURB, SNWFRC,
     I                   POTFRC,
     U                   RC
     &                  )
C****
C**** The effective latent heat resistance RC depends on the quantity
C**** of interception reservoir water and the snow cover.  POTFRC
C**** is the fraction of the tile from which potential evaporation
C**** occurs.
C****
      IMPLICIT NONE
      INTEGER NCH
      INTEGER ChNo
      _RL CAPAC(NCH), SNOW(NCH), SATCAP(NCH), RA(NCH), ETURB(NCH),
     &          RC(NCH), SNWFRC(NCH), POTFRC(NCH)
      _RL ETCRIT,RAMPFC

C**** (Note: ETCRIT arbitrarily set to ~-5 W/m2, or -2.e-6 mm/sec.)
      DATA ETCRIT/ -2.E-6 /
C****
C**** -----------------------------------------------------------------

      DO 100 ChNo = 1, NCH

C**** - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C**** Case 1: Vegetation present (SATCAP GT .001).  Potential evap. from
c**** both interception reservoir and snow.

      IF(SATCAP(CHNO).GT..001) THEN
        RC(ChNo)=RC(ChNo)*(1.-POTFRC(CHNO))/
     &                ( 1.+POTFRC(CHNO)*RC(ChNo)/RA(ChNo) )
        ENDIF

C**** - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C**** Case 2: Vegetation absent (SATCAP LE .001).  Potential evap. from
c**** snow only.

      IF(SATCAP(CHNO) .LE. .001) THEN
        RC(ChNo)=RC(ChNo)*(1.-SNWFRC(CHNO))/
     &                  ( 1.+SNWFRC(CHNO)*RC(ChNo)/RA(ChNo) )
        ENDIF

C**** - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C**** Assume RC=0 for condensation (dew).
C**** RAMPFC is used to ensure continuity in RC.

      RAMPFC=ETURB(CHNO)/ETCRIT
      IF ( RAMPFC .GE. 0. ) RC(CHNO) = RC(CHNO)*(1.-RAMPFC)
      IF ( RAMPFC .GT. 1. ) RC(ChNo) = 0.
C****
 100  CONTINUE
C****
      RETURN
      END
C****
C**** [ END RCANOP ]
C****
C**** -----------------------------------------------------------------
C**** /////////////////////////////////////////////////////////////////
C**** -----------------------------------------------------------------
C****
C***** [ BEGIN WUPDAT ]
C****
      SUBROUTINE WUPDAT (
     I                     NCH,   ITYP, DTSTEP,
     I                     EVAP, SATCAP, VGWMAX, TC, RA, RC,
     I                     RX1, RX2,ESNFRC,EIRFRC,
     U                     CAPAC, SNOW, SWET, RUNOFF,
     O                     EINT, ESOI, EVEG, ESNO, RUNSRF, FWSOIL
     &                    )
C****
C**** This subroutine allows evapotranspiration to adjust the water
C**** contents of the interception reservoir and the soil layers.
C****
      IMPLICIT NONE
C****
#include "sibber.h"
C****
      INTEGER NCH
      INTEGER ITYP(NCH), ChNo
      _RL    EVAP(NCH),  SATCAP(NCH),  VGWMAX(NLAY,NTYPS),
     &          TC(NCH),      RA(NCH),             RC(NCH),
     &       CAPAC(NCH),    SNOW(NCH),    SWET(nch,NLAY),
     &      RUNOFF(NCH),     RX1(NCH),
     &         RX2(NCH),  RUNSRF(NCH),  FWSOIL(NCH),
     &      ESNFRC(NCH),  EIRFRC(NCH)
      _RL EINT(NCH), ESOI(NCH), EVEG(NCH), ESNO(NCH)
      _RL  DTSTEP, EGRO, FWS, THRU, DEWRUN,
     &     WTOTAL,WLAY1,WLAY2,ELAY1,ELAY2,EGROI
C****
C**** -----------------------------------------------------------------

      DO 100 ChNo = 1, NCH
C****
C**** Partition evap between interception, snow, and ground reservoirs.
C****
      WLAY1 = SWET(ChNo,SFCLY) * VGWMAX(SFCLY,ITYP(ChNo))
      WLAY2 = SWET(ChNo,ROOTLY) * VGWMAX(ROOTLY,ITYP(ChNo))
      WTOTAL = WLAY1 + WLAY2
C****
      ESNO(CHNO)=ESNFRC(CHNO)*EVAP(CHNO)*DTSTEP
      EINT(CHNO)=EIRFRC(CHNO)*EVAP(CHNO)*DTSTEP
      EGRO = EVAP(CHNO)*DTSTEP - ESNO(CHNO) - EINT(CHNO)

C**** Ensure that individual capacities are not exceeded.

      IF(ESNO(CHNO) .GT. SNOW(CHNO)) THEN
        EINT(CHNO)=EINT(CHNO)+(ESNO(CHNO)-SNOW(CHNO))
        ESNO(CHNO)=SNOW(CHNO)
        ENDIF
      EGROI=EGRO+EINT(CHNO)
      IF(EGROI .GT. CAPAC(CHNO)+WTOTAL) THEN
        ESNO(CHNO)=ESNO(CHNO)+EGROI-(CAPAC(CHNO)+WTOTAL)
        EGROI=CAPAC(CHNO)+WTOTAL
        ENDIF

      EINT(CHNO)=EGROI-EGRO
      IF(EINT(CHNO) .GT. CAPAC(CHNO)) THEN
        EGRO=EGRO+EINT(CHNO)-CAPAC(CHNO)
        EINT(CHNO)=CAPAC(CHNO)
        ENDIF
      IF(EGRO .GT. WTOTAL) THEN
        EINT(CHNO)=EINT(CHNO)+EGRO-WTOTAL
        EGRO=WTOTAL
        ENDIF
C****
C**** Separate egro into surface-evaporation/transpiration components:
C****
      IF( RX1(CHNO)+RX2(CHNO) .NE. 0. ) THEN
          ESOI(CHNO)=EGRO*RX1(CHNO)/(RX1(CHNO)+RX2(CHNO))
          EVEG(CHNO)=EGRO - ESOI(CHNO)
        ELSE
          ESOI(CHNO)=EGRO/2.
          EVEG(CHNO)=EGRO/2.
        ENDIF
C****
C**** Translate ESOI and EVEG into evaporation fluxes from layers 1 and 2:
C****
      IF( WTOTAL .GT. 0. ) THEN
          FWS = EVEG(CHNO) / WTOTAL
        ELSE
          FWS = 1.
        ENDIF
      ELAY1 = WLAY1*FWS + ESOI(CHNO)
      ELAY2 = WLAY2*FWS
C****
C**** Ensure that enough soil water is available in each layer:
C****
      IF( ELAY1 .GT. WLAY1 ) THEN
        ELAY2 = ELAY2 + (ELAY1 - WLAY1)
        ELAY1 = WLAY1
        ENDIF
      IF( ELAY2 .GT. WLAY2 ) THEN
        ELAY1 = ELAY1 + (ELAY2 - WLAY2)
        ELAY2 = WLAY2
        ENDIF

C**** Special case for condensation:
      IF(EVAP(CHNO) .LT. 0.) THEN
          EINT(CHNO)=(1.-ESNFRC(CHNO))*EVAP(CHNO)*DTSTEP
          ELAY1=0.
          ELAY2=0.
          ESOI(CHNO)=0.
          EVEG(CHNO)=0.
          ESNO(CHNO)=ESNFRC(CHNO)*EVAP(CHNO)*DTSTEP
        ENDIF

C****
C**** Remove moisture from reservoirs:
C****
      SNOW(ChNo) = SNOW(ChNo) - ESNO(CHNO)
      CAPAC(ChNo) = CAPAC(ChNo) - EINT(CHNO)
      SWET(ChNo,SFCLY) = (WLAY1 - ELAY1) / VGWMAX(SFCLY,ITYP(ChNo))
      SWET(ChNo,ROOTLY) = (WLAY2 - ELAY2) / VGWMAX(ROOTLY,ITYP(CHNO))
C****
C**** Ensure against numerical precision problems:
      SWET(ChNo,SFCLY)  = MIN( 1. _d 0, MAX( 0. _d 0, SWET(ChNo,SFCLY) )
     $     )
      SWET(ChNo,ROOTLY) = MIN( 1. _d 0, MAX( 0. _d 0, SWET(ChNo,ROOTLY)
     $     ) )
C****
C****
C**** -------------------------------------------------
C**** DEWFALL:
C****
C**** If dewfall adds to cir, insure that it does not fill
C**** beyond capacity.  If resulting throughfall adds to top soil layer,
C**** insure that it also does not fill beyond capacity.
C****
      IF( CAPAC(ChNo) .GT. SATCAP(ChNo) ) THEN
        THRU = CAPAC(ChNo) - SATCAP(ChNo)
        CAPAC(ChNo) = SATCAP(ChNo)
        SWET(ChNo,SFCLY) = SWET(ChNo,SFCLY) +
     &                         THRU / VGWMAX(SFCLY,ITYP(ChNo))
        DEWRUN=0.
        IF ( SWET(ChNo,SFCLY) .GT. 1. ) THEN
          DEWRUN = ( SWET(ChNo,SFCLY) - 1. ) * VGWMAX(SFCLY,ITYP(ChNo))
          SWET(ChNo,SFCLY) = 1.
          RUNOFF(ChNo) = RUNOFF(ChNo) + DEWRUN/DTSTEP
          RUNSRF(ChNo) = RUNSRF(ChNo) + DEWRUN/DTSTEP
          ENDIF
        FWSOIL(CHNO) = FWSOIL(CHNO) + (THRU-DEWRUN)/DTSTEP
        ENDIF
C****
 100  CONTINUE
C****
      RETURN
      END
C****
C**** [ END WUPDAT ]
C****
C**** -----------------------------------------------------------------
C**** /////////////////////////////////////////////////////////////////
C**** -----------------------------------------------------------------
C****
C**** [ BEGIN GWATER ]
C****
      SUBROUTINE GWATER (
     I                     NCH,    ITYP,   WSMAX,  PHLAY, AKLAY, TC,
     I                     DTSTEP, VGZDEX, VGSLOX, WETEQ1, WETEQ2,
     I                     PHSAT,   AKSAT,
     U                     SWET,   RUNOFF,  GDRAIN
     &                    )
C****
C**** This subroutine computes diffusion between soil layers.
C****
      IMPLICIT NONE
C****
#include "sibber.h"
C****
      INTEGER NCH
      INTEGER ITYP(NCH), ChNo
      _RL  VGSLOX(NCH), RUNOFF(NCH), GDRAIN(NCH)
      _RL  ZDEP12,   AKAVE,  GWFLUX,  ZDEP23,  HALFMX,  DHDZ,
     &    FAREA, TFM2, FRAMP

      _RL   WSMAX(NLAY,NTYPS),   PHLAY(nch,NLAY),
     &       AKLAY(nch,NLAY),             TC(NCH),
     &                  DTSTEP,    SWET(nch,NLAY),
     &      VGZDEX(NLAY,nch),  WETEQ1(NCH),  WETEQ2(NCH),
     &      PHSAT(NCH), AKSAT(NCH)

C****
C**** ----------------------------------------------------------------

      DO 100 ChNo = 1, NCH
C****
C**** Diffusion between layer 1 and 2:
      ZDEP12 = VGZDEX(SFCLY,ChNo) + VGZDEX(ROOTLY,ChNo)
      IF( SWET(CHNO,SFCLY) .GT. WETEQ1(CHNO) ) THEN
          FAREA=(SWET(CHNO,SFCLY) - WETEQ1(CHNO)) / (1. - WETEQ1(CHNO))
          DHDZ = 1. + 2.*(PHSAT(CHNO)-PHLAY(CHNO,ROOTLY))/ZDEP12
          AKAVE = AKSAT(CHNO)
        ELSE
          FAREA = 1.
          DHDZ = 1. + 2.*(PHLAY(ChNo,SFCLY)-PHLAY(ChNo,ROOTLY))/ZDEP12
          AKAVE = AKLAY(ChNo,ROOTLY)
        ENDIF
C****
      GWFLUX = 1000. * DTSTEP * AKAVE * DHDZ * FAREA
C****
C**** Test for limits on water holding capacity.
C****
      HALFMX=0.5*ABS( SWET(CHNO,SFCLY)-WETEQ1(CHNO) )
     &                               * WSMAX(SFCLY,ITYP(CHNO))
      IF (GWFLUX .GE. 0.) THEN
          GWFLUX = MIN( GWFLUX,
     &               SWET(ChNo,SFCLY) * WSMAX(SFCLY,ITYP(ChNo)) )
          GWFLUX = MIN( GWFLUX,    WSMAX(ROOTLY,ITYP(ChNo)) -
     &              SWET(ChNo,ROOTLY) * WSMAX(ROOTLY,ITYP(ChNo)) )
          GWFLUX = MIN( GWFLUX, HALFMX )
        ELSE
          GWFLUX = -MIN( ABS(GWFLUX),
     &                SWET(ChNo,ROOTLY) * WSMAX(ROOTLY,ITYP(ChNo)) )
          GWFLUX = -MIN( ABS(GWFLUX),   WSMAX(SFCLY,ITYP(ChNo)) -
     &                SWET(ChNo,SFCLY) * WSMAX(SFCLY,ITYP(ChNo)) )
          GWFLUX = -MIN( ABS(GWFLUX),  HALFMX )
        ENDIF
C****
C**** Prevent diffusion when ground is frozen (INCLUDE RAMPING):
      TFM2=TF-2.
      FRAMP=(TC(CHNO)-TFM2)/2.
      FRAMP=MIN(1. _d 0, MAX(0. _d 0,FRAMP) )
      GWFLUX=GWFLUX*FRAMP
C****
C**** Update water contents
      SWET(ChNo,SFCLY) = SWET(ChNo,SFCLY) -
     &                        GWFLUX / WSMAX(SFCLY,ITYP(ChNo))
      SWET(ChNo,ROOTLY) = SWET(ChNo,ROOTLY) +
     &                        GWFLUX / WSMAX(ROOTLY,ITYP(ChNo))
C****
C**** - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C**** Diffusion between root and recharge layers:
      ZDEP23 = VGZDEX(ROOTLY,ChNo) + VGZDEX(RECHLY,ChNo)
      DHDZ=1. + 2. * (PHLAY(ChNo,ROOTLY) - PHLAY(ChNo,RECHLY)) / ZDEP23
      IF(DHDZ.GE.0.) THEN
          AKAVE = AKLAY(ChNo,ROOTLY)
        ELSE
          AKAVE = AKLAY(ChNo,RECHLY)
        ENDIF
      GWFLUX = 1000. * DTSTEP * AKAVE * DHDZ
C****
C**** Test for limits on water holding capacity:
      HALFMX=0.5*ABS( SWET(CHNO,ROOTLY)-WETEQ2(CHNO) )
     &                               * WSMAX(ROOTLY,ITYP(CHNO))
      IF (GWFLUX .GE. 0.) THEN
          GWFLUX = MIN( GWFLUX,
     &                    SWET(ChNo,ROOTLY) * WSMAX(ROOTLY,ITYP(ChNo)) )
          GWFLUX = MIN( GWFLUX,    WSMAX(RECHLY,ITYP(ChNo)) -
     &                    SWET(ChNo,RECHLY) * WSMAX(RECHLY,ITYP(ChNo)) )
          GWFLUX = MIN( GWFLUX, HALFMX )
        ELSE
          GWFLUX = -MIN( ABS(GWFLUX),
     &                    SWET(ChNo,RECHLY) * WSMAX(RECHLY,ITYP(ChNo)) )
          GWFLUX = -MIN( ABS(GWFLUX), WSMAX(ROOTLY,ITYP(ChNo)) -
     &                    SWET(ChNo,ROOTLY) * WSMAX(ROOTLY,ITYP(ChNo)) )
          GWFLUX = -MIN( ABS(GWFLUX), HALFMX )
        ENDIF
C****
C**** Prevent diffusion when ground is frozen (INCLUDE RAMPING):
      FRAMP=(TC(CHNO)-TFM2)/2.
      FRAMP=MIN(1. _d 0, MAX(0. _d 0,FRAMP) )
      GWFLUX=GWFLUX*FRAMP
C****
C**** Update water contents
      SWET(ChNo,ROOTLY) = SWET(ChNo,ROOTLY) -
     &                            GWFLUX / WSMAX(ROOTLY,ITYP(ChNo))
      SWET(ChNo,RECHLY) = SWET(ChNo,RECHLY) +
     &                            GWFLUX / WSMAX(RECHLY,ITYP(ChNo))
      GDRAIN(CHNO)=GWFLUX/DTSTEP
C****
C**** - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
C**** Flux of moisture out of lower soil layer to water table
C**** (approximation to SiB)
C****
      GWFLUX = VGSLOX(ChNo) * AKLAY(ChNo,RECHLY) * 1000. * DTSTEP

C**** Prevent diffusion when ground is frozen (INCLUDE RAMPING):
      FRAMP=(TC(CHNO)-TFM2)/2.
      FRAMP=MIN(1. _d 0, MAX(0. _d 0,FRAMP) )
      GWFLUX=GWFLUX*FRAMP

      GWFLUX = MIN( GWFLUX,
     &                 SWET(ChNo,RECHLY) * WSMAX(RECHLY,ITYP(ChNo)) )
      SWET(ChNo,RECHLY) = SWET(ChNo,RECHLY) -
     &                                GWFLUX / WSMAX(RECHLY,ITYP(ChNo))
C****
      RUNOFF (ChNo) = RUNOFF (ChNo) + GWFLUX/DTSTEP
C****
 100  CONTINUE
C****
      RETURN
      END
C****
C**** [ END GWATER ]

#include "GMREDI_OPTIONS.h"
#ifdef ALLOW_AUTODIFF
# include "AUTODIFF_OPTIONS.h"
#endif

CBOP
C     !ROUTINE: GMREDI_SLOPE_LIMIT
C     !INTERFACE:
      SUBROUTINE GMREDI_SLOPE_LIMIT(
     O             SlopeX, SlopeY,
     O             SlopeSqr, taperFct,
     U             hTransLay, baseSlope, recipLambda,
     U             dSigmaDr,
     I             dSigmaDx, dSigmaDy,
     I             Lrho, hMixLay, rDepth, depthZ, kLow,
     I             kPos, k, bi, bj, myTime, myIter, myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE GMREDI_SLOPE_LIMIT
C     | o Calculate slopes for use in GM/Redi tensor
C     *==========================================================*
C     | On entry:
C     |            dSigmaDr     contains the downward d/dz Sigma
C     |            dSigmaDx/Dy  contains X/Y gradients of sigma
C     |            Lrho
C     |            hMixLay      mixed layer depth (> 0)
C     |            rDepth       depth (> 0) in r-Unit from the surface
C     |            depthZ       contains the depth (< 0 !) [m]
C    U             hTransLay    transition layer depth (> 0)
C    U             baseSlope, recipLambda,
C     | On exit:
C     |            dSigmaDr     contains the effective downward dSig/dz
C     |            SlopeX/Y     contains X/Y slopes
C     |            SlopeSqr     contains Sx^2+Sy^2
C     |            taperFct     contains tapering funct. value ;
C     |                         = 1 when using no tapering
C    U             hTransLay    transition layer depth (> 0)
C    U             baseSlope, recipLambda
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     == Global variables ==
#include "SIZE.h"
#include "GRID.h"
#include "EEPARAMS.h"
#include "GMREDI.h"
#include "PARAMS.h"
#ifdef ALLOW_AUTODIFF_TAMC
#include "tamc.h"
#endif /* ALLOW_AUTODIFF_TAMC */

C     !INPUT PARAMETERS:
C     dSigmaDx :: zonal      gradient of density
C     dSigmaDy :: meridional gradient of density
C     Lrho     ::
C     hMixLay  :: mixed layer thickness (> 0) [m]
C     rDepth   :: depth (> 0) in r-Unit from the surface
C     depthZ   :: model discretized depth (< 0) [m]
C     kLow     :: bottom level index 2-D array
C     kPos     :: grid-cell location: 1,2,3 : at U,V,W location
C     k        :: level index
C     bi, bj   :: tile indices
C     myTime   :: time in simulation
C     myIter   :: iteration number in simulation
C     myThid   :: My Thread Id. number
C     !OUTPUT PARAMETERS:
C     SlopeX      :: isopycnal slope in X direction
C     SlopeY      :: isopycnal slope in Y direction
C     SlopeSqr    :: square of isopycnal slope
C     taperFct    :: tapering function
C     hTransLay   :: depth of the base of the transition layer (> 0) [m]
C     baseSlope   :: slope at the the base of the transition layer
C     recipLambda :: Slope vertical gradient at Trans. Layer Base (=recip.Lambda)
C     dSigmaDr    :: downward gradient of neutral density
      _RL SlopeX     (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL SlopeY     (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL SlopeSqr   (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL taperFct   (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL hTransLay  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL baseSlope  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL recipLambda(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL dSigmaDr   (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL dSigmaDx   (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL dSigmaDy   (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL Lrho       (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL hMixLay    (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL rDepth
      _RS depthZ(*)
      INTEGER kLow   (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER kPos, k, bi, bj
      _RL     myTime
      INTEGER myIter
      INTEGER myThid

#ifdef ALLOW_GMREDI
C     !LOCAL VARIABLES:
      _RL fpi
      PARAMETER( fpi = PI )
      INTEGER i, j
      _RL f1, Smod, f2, Rnondim
      _RL maxSlopeSqr
      _RL convSlopeUnit, loc_rMaxSlope
      _RL dSigmMod   (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL dRdSigmaLtd(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL tmpFld     (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
#ifndef GM_EXCLUDE_FM07_TAP
      _RL dTransLay, rLambMin, DoverLamb
      _RL taperFctLoc, taperFctHat
      _RL minTransLay
      _RL SlopeMod(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL locVar  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
#endif
#ifdef GMREDI_WITH_STABLE_ADJOINT
      _RL slopeSqTmp, slopeTmp, slopeMax
c# ifdef ALLOW_AUTODIFF_TAMC
c      INTEGER ikey
c# endif
#endif
C-   need to put this one in GM namelist :
      _RL GM_bigSlope
      GM_bigSlope = 1. _d +02
CEOP

      IF (kPos.EQ.3 ) THEN
       GM_bigSlope   = GM_bigSlope*wUnit2rVel(k)
       maxSlopeSqr   = GM_maxSlope*GM_maxSlope
     &                *wUnit2rVel(k)*wUnit2rVel(k)
       convSlopeUnit = rVel2wUnit(k)
      ELSE
       GM_bigSlope   = GM_bigSlope*z2rUnit(k)
       maxSlopeSqr   = GM_maxSlope*GM_maxSlope
     &                *z2rUnit(k)*z2rUnit(k)
       convSlopeUnit = rUnit2z(k)
      ENDIF
      loc_rMaxSlope  = GM_rMaxSlope*convSlopeUnit

#ifdef ALLOW_AUTODIFF_TAMC
C     TAF thinks for some reason that rDepth is an active variable.
C     While this does not make the adjoint code wrong, the resulting
C     code inhibits vectorization in some cases so we tell TAF here
C     that rDepth is actually a passive grid variable that needs no adjoint
CADJ PASSIVE rDepth
C     Without this store directive, TAF generates an extra field anyway
C     so we do it here explicitly with a local tape and live without the
C     corresponding warning.
CADJ INIT loctape_gm = COMMON, 1
C     Note that this directive is not necessary in any verification
C     experiment, so we leave it commented out for now.
cCADJ STORE dSigmaDr = loctape_gm
C
C     Alternatively one can use a global tape, to be defined in
C     the_main_loop.F. This option is still here but commented out with
C     "c" (also in the_main_loop.F), in case we decide to go for larger
C     memory overhead and fewer recomputations
c      ikey = bi + (bj-1)*nSx + (ikey_dynamics-1)*nSx*nSy
c      ikey = kPos + (k - 1  + (ikey - 1)*Nr)*3
cCADJ STORE dSigmaDr = comlev1_gmredi_slope, key=ikey, byte=isbyte
#endif /* ALLOW_AUTODIFF_TAMC */

      DO j=1-OLy+1,sNy+OLy-1
       DO i=1-OLx+1,sNx+OLx-1
        dSigmMod(i,j)    = 0. _d 0
        tmpFld(i,j)      = 0. _d 0
       ENDDO
      ENDDO

      IF (GM_taper_scheme.EQ.'orig' .OR.
     &    GM_taper_scheme.EQ.'clipping') THEN

#ifdef GM_EXCLUDE_CLIPPING

        STOP 'Need to compile without "#define GM_EXCLUDE_CLIPPING"'

#else  /* GM_EXCLUDE_CLIPPING */

C-      Original implementation in mitgcmuv
C       (this turns out to be the same as Cox slope clipping)

C-      Cox 1987 "Slope clipping"
        DO j=1-OLy+1,sNy+OLy-1
         DO i=1-OLx+1,sNx+OLx-1
          tmpFld(i,j) = dSigmaDx(i,j)*dSigmaDx(i,j)
     &                + dSigmaDy(i,j)*dSigmaDy(i,j)
          IF ( tmpFld(i,j) .EQ. zeroRL ) THEN
           dSigmMod(i,j) = 0. _d 0
          ELSE
           dSigmMod(i,j) = SQRT( tmpFld(i,j) )
          ENDIF
         ENDDO
        ENDDO

        DO j=1-OLy+1,sNy+OLy-1
         DO i=1-OLx+1,sNx+OLx-1
          IF ( dSigmMod(i,j) .NE. zeroRL ) THEN
           tmpFld(i,j) = dSigmMod(i,j)*loc_rMaxSlope
           IF ( dSigmaDr(i,j) .LE. tmpFld(i,j) )
     &          dSigmaDr(i,j) = tmpFld(i,j)
          ENDIF
         ENDDO
        ENDDO

        DO j=1-OLy+1,sNy+OLy-1
         DO i=1-OLx+1,sNx+OLx-1
          IF ( dSigmMod(i,j) .EQ. zeroRL ) THEN
           SlopeX(i,j) = 0. _d 0
           SlopeY(i,j) = 0. _d 0
          ELSE
           dRdSigmaLtd(i,j) = 1. _d 0/( dSigmaDr(i,j) )
           SlopeX(i,j) = dSigmaDx(i,j)*dRdSigmaLtd(i,j)
           SlopeY(i,j) = dSigmaDy(i,j)*dRdSigmaLtd(i,j)
          ENDIF
         ENDDO
        ENDDO

        DO j=1-OLy+1,sNy+OLy-1
         DO i=1-OLx+1,sNx+OLx-1
          SlopeSqr(i,j) = SlopeX(i,j)*SlopeX(i,j)
     &                  + SlopeY(i,j)*SlopeY(i,j)
          taperFct(i,j) = 1. _d 0
         ENDDO
        ENDDO

#endif /* GM_EXCLUDE_CLIPPING */

      ELSEIF (GM_taper_scheme.EQ.'fm07' ) THEN
C--   Ferrari & Mc.Williams, 2007:

#ifdef GM_EXCLUDE_FM07_TAP

        STOP 'Need to compile without "#define GM_EXCLUDE_FM07_TAP"'

#else  /* GM_EXCLUDE_FM07_TAP */

C-    a) Calculate separately slope magnitude (SlopeMod)
C        and slope horiz. direction (Slope_X,Y : normalized)
        DO j=1-OLy+1,sNy+OLy-1
         DO i=1-OLx+1,sNx+OLx-1
          IF ( k.GT.kLow(i,j) ) THEN
C-        Bottom or below:
            SlopeX  (i,j) = 0. _d 0
            SlopeY  (i,j) = 0. _d 0
            SlopeMod(i,j) = 0. _d 0
            taperFct(i,j) = 0. _d 0
          ELSE
C-        Above bottom:
           IF ( dSigmaDr(i,j).LE. GM_Small_Number )
     &          dSigmaDr(i,j) = GM_Small_Number
           tmpFld(i,j) = dSigmaDx(i,j)*dSigmaDx(i,j)
     &                 + dSigmaDy(i,j)*dSigmaDy(i,j)
           IF ( tmpFld(i,j).GT.zeroRL ) THEN
            locVar(i,j) = SQRT( tmpFld(i,j) )
            SlopeX  (i,j) = dSigmaDx(i,j)/locVar(i,j)
            SlopeY  (i,j) = dSigmaDy(i,j)/locVar(i,j)
            SlopeMod(i,j) = locVar(i,j)/dSigmaDr(i,j)
            taperFct(i,j) = 1. _d 0
           ELSE
            SlopeX  (i,j) = 0. _d 0
            SlopeY  (i,j) = 0. _d 0
            SlopeMod(i,j) = 0. _d 0
            taperFct(i,j) = 0. _d 0
           ENDIF
          ENDIF
         ENDDO
        ENDDO

C-    b) Set Transition Layer Depth:
        IF ( k.EQ.1 ) THEN
          minTransLay = GM_facTrL2dz*( depthZ(k) - depthZ(k+1) )
        ELSE
          minTransLay = GM_facTrL2dz*( depthZ(k-1) - depthZ(k) )
        ENDIF
        DO j=1-OLy+1,sNy+OLy-1
         DO i=1-OLx+1,sNx+OLx-1
          IF ( hTransLay(i,j).LE.0. _d 0 ) THEN
C-     previously below the transition layer
            tmpFld(i,j) = Lrho(i,j)*SlopeMod(i,j)
C-     ensure that transition layer is at least as thick than current level and
C      not thicker than the larger of the 2 : maxTransLay and facTrL2ML*hMixLay
            dTransLay =
     &        MIN( MAX( tmpFld(i,j), minTransLay ),
     &             MAX( GM_facTrL2ML*hMixLay(i,j), GM_maxTransLay ) )
            IF ( k.GE.kLow(i,j) ) THEN
C-     bottom & below & 1rst level above the bottom :
              recipLambda(i,j) = 0. _d 0
              baseSlope(i,j)   = SlopeMod(i,j)
C-- note: do not catch the 1rst level/interface (k=kLow) above the bottom
C         since no baseSlope has yet been stored (= 0); but might fit
C         well into transition layer criteria (if locally not stratified)
            ELSEIF ( dTransLay+hMixLay(i,j)+depthZ(k) .GE. zeroRL ) THEN
C-     Found the transition Layer : set depth of base of Transition layer
              hTransLay(i,j) = -depthZ(k+1)
C      and compute inverse length scale "1/Lambda" from slope vert. grad
              IF ( baseSlope(i,j).GT.zeroRL ) THEN
                recipLambda(i,j) = recipLambda(i,j)
     &                           / MIN( baseSlope(i,j), GM_maxSlope )
              ELSE
                recipLambda(i,j) = 0. _d 0
              ENDIF
C      slope^2 & Kwz should remain > 0 : prevent too large negative D/lambda
              IF ( hMixLay(i,j)+depthZ(k+1).LT.zeroRL ) THEN
                rLambMin = 1. _d 0 /( hMixLay(i,j)+depthZ(k+1) )
                recipLambda(i,j) = MAX( recipLambda(i,j), rLambMin )
              ENDIF
            ELSE
C-     Still below Trans. layer: store slope & slope vert. grad.
              recipLambda(i,j) = ( MIN( SlopeMod(i,j), GM_maxSlope )
     &                           - MIN( baseSlope(i,j), GM_maxSlope )
     &                           ) / ( depthZ(k) - depthZ(k+1) )
              baseSlope(i,j)   = SlopeMod(i,j)
            ENDIF
          ENDIF
         ENDDO
        ENDDO

C-    c) Set Slope component according to vertical position
C      (in Mixed-Layer / in Transition Layer / below Transition Layer)
        DO j=1-OLy+1,sNy+OLy-1
         DO i=1-OLx+1,sNx+OLx-1
          IF ( hTransLay(i,j).GT.0. _d 0 ) THEN
C-        already above base of transition layer:

            DoverLamb = (hTransLay(i,j)-hMixLay(i,j))*recipLambda(i,j)
            IF ( -depthZ(k).LE.hMixLay(i,j) ) THEN
C-        compute tapering function -G(z) in the mixed Layer:
              taperFctLoc =
     &          ( -depthZ(k)/(hTransLay(i,j)+hMixLay(i,j))
     &            *( 2. _d 0 + DoverLamb )
     &          )
C-        compute tapering function -G^(z) in the mixed Layer
              taperFctHat =
     &          ( -depthZ(k)/(hTransLay(i,j)+hMixLay(i,j))
     &            *  2. _d 0
     &            *( 1. _d 0 + DoverLamb )
     &          )
            ELSE
C-        compute tapering function -G(z) in the transition Layer:
              taperFctLoc =
     &          ( -depthZ(k)/(hTransLay(i,j)+hMixLay(i,j))
     &            *( 2. _d 0 + DoverLamb )
     &          )
     &        - ( (depthZ(k)+hMixLay(i,j))*(depthZ(k)+hMixLay(i,j))
     &            /( hTransLay(i,j)*hTransLay(i,j)
     &               - hMixLay(i,j)*hMixLay(i,j)  )
     &            *( 1. _d 0 + hTransLay(i,j)*recipLambda(i,j) )
     &          )
C-        compute tapering function -G^(z) in the transition Layer:
              taperFctHat =
     &          ( -depthZ(k)/(hTransLay(i,j)+hMixLay(i,j))
     &            *  2. _d 0
     &            *( 1. _d 0 + DoverLamb )
     &          )
     &        - ( (depthZ(k)+hMixLay(i,j))*(depthZ(k)+hMixLay(i,j))
     &            /( hTransLay(i,j)*hTransLay(i,j)
     &               - hMixLay(i,j)*hMixLay(i,j)  )
     &            *( 1. _d 0 + hTransLay(i,j)*recipLambda(i,j)*2. _d 0 )
     &          )
            ENDIF
C-        modify the slope (above bottom of transition layer):
c           Smod = baseSlope(i,j)
C-        safer to limit the slope (even if it might never exceed GM_maxSlope)
            Smod = MIN( baseSlope(i,j), GM_maxSlope )
            SlopeX(i,j) = SlopeX(i,j)*Smod*taperFctLoc
            SlopeY(i,j) = SlopeY(i,j)*Smod*taperFctLoc
c           SlopeSqr(i,j) = Smod*Smod*taperFctHat
c           SlopeSqr(i,j) = baseSlope(i,j)*Smod*taperFctHat
            SlopeSqr(i,j) = MIN( baseSlope(i,j), GM_bigSlope )
     &                     *Smod*taperFctHat

          ELSE
C--       Still below base of transition layer:
c           Smod = SlopeMod(i,j)
C-        safer to limit the slope:
            Smod = MIN( SlopeMod(i,j), GM_maxSlope )
            SlopeX(i,j) = SlopeX(i,j)*Smod
            SlopeY(i,j) = SlopeY(i,j)*Smod
c           SlopeSqr(i,j) = Smod*Smod
c           SlopeSqr(i,j) = SlopeMod(i,j)*Smod
            SlopeSqr(i,j) = MIN( SlopeMod(i,j), GM_bigSlope )
     &                     *Smod

C--       end if baseSlope > 0 / else => above/below base of Trans. Layer
          ENDIF

         ENDDO
        ENDDO

#endif  /* GM_EXCLUDE_FM07_TAP */

      ELSEIF (GM_taper_scheme.EQ.'ac02') THEN

#ifdef GM_EXCLUDE_AC02_TAP

        STOP 'Need to compile without "#define GM_EXCLUDE_AC02_TAP"'

#else  /* GM_EXCLUDE_AC02_TAP */

C-      New Scheme (A. & C. 2002): relax part of the small slope approximation
C         compute the true slope (no approximation)
C         but still neglect Kxy & Kyx (assumed to be zero)

        DO j=1-OLy+1,sNy+OLy-1
         DO i=1-OLx+1,sNx+OLx-1
          dRdSigmaLtd(i,j) = ( dSigmaDx(i,j)*dSigmaDx(i,j)
     &                       + dSigmaDy(i,j)*dSigmaDy(i,j)
     &                       )*convSlopeUnit*convSlopeUnit
     &                       + dSigmaDr(i,j)*dSigmaDr(i,j)
          taperFct(i,j) = 1. _d 0

          IF ( dRdSigmaLtd(i,j).NE.zeroRL ) THEN
             dRdSigmaLtd(i,j) = 1. _d 0 / ( dRdSigmaLtd(i,j) )
             SlopeSqr(i,j) = ( dSigmaDx(i,j)*dSigmaDx(i,j)
     &                       + dSigmaDy(i,j)*dSigmaDy(i,j)
     &                       )*dRdSigmaLtd(i,j)
             SlopeX(i,j) = dSigmaDx(i,j)
     &                    *dRdSigmaLtd(i,j)*dSigmaDr(i,j)
             SlopeY(i,j) = dSigmaDy(i,j)
     &                    *dRdSigmaLtd(i,j)*dSigmaDr(i,j)
          ELSE
             SlopeSqr(i,j) = 0. _d 0
             SlopeX(i,j) = 0. _d 0
             SlopeY(i,j) = 0. _d 0
          ENDIF
#ifndef ALLOW_AUTODIFF_TAMC
cph-- this part does not adjoint well
          IF ( SlopeSqr(i,j) .GT. maxSlopeSqr .AND.
     &         SlopeSqr(i,j) .LT. GM_slopeSqCutoff ) THEN
           taperFct(i,j) = maxSlopeSqr/SlopeSqr(i,j)
          ELSEIF ( SlopeSqr(i,j) .GE. GM_slopeSqCutoff ) THEN
           taperFct(i,j) = 0. _d 0
          ENDIF
#endif
         ENDDO
        ENDDO

#endif /* GM_EXCLUDE_AC02_TAP */

      ELSE

#ifdef GM_EXCLUDE_TAPERING

        STOP 'Need to compile without "#define GM_EXCLUDE_TAPERING"'

#else  /* GM_EXCLUDE_TAPERING */

C----------------------------------------------------------------------

C- Compute the slope, no clipping, but avoid reverse slope in negatively
C                                  stratified (dSigmaDr < 0) region :

#ifdef ALLOW_AUTODIFF_TAMC
C     Without this store directive, TAF generates an extra field anyway
C     so we do it here explicitly with a local tape and live without the
C     corresponding warning.
CADJ STORE dSigmaDr = loctape_gm
#endif

        DO j=1-OLy+1,sNy+OLy-1
         DO i=1-OLx+1,sNx+OLx-1
          IF ( dSigmaDr(i,j) .NE. zeroRL ) THEN
           IF ( dSigmaDr(i,j) .LE. GM_Small_Number )
     &         dSigmaDr(i,j) = GM_Small_Number
          ENDIF
         ENDDO
        ENDDO

        DO j=1-OLy+1,sNy+OLy-1
         DO i=1-OLx+1,sNx+OLx-1
          IF ( dSigmaDr(i,j) .EQ. zeroRL ) THEN
           IF ( dSigmaDx(i,j) .NE. zeroRL ) THEN
            SlopeX(i,j) = SIGN( GM_bigSlope, dSigmaDx(i,j) )
           ELSE
            SlopeX(i,j) = 0. _d 0
           ENDIF
           IF ( dSigmaDy(i,j) .NE. zeroRL ) THEN
            SlopeY(i,j) = SIGN( GM_bigSlope, dSigmaDy(i,j) )
           ELSE
            SlopeY(i,j) = 0. _d 0
           ENDIF
          ELSE
           dRdSigmaLtd(i,j) = 1. _d 0 / dSigmaDr(i,j)
           SlopeX(i,j) = dSigmaDx(i,j)*dRdSigmaLtd(i,j)
           SlopeY(i,j) = dSigmaDy(i,j)*dRdSigmaLtd(i,j)
c          SlopeX(i,j) = dSigmaDx(i,j)/dSigmaDr(i,j)
c          SlopeY(i,j) = dSigmaDy(i,j)/dSigmaDr(i,j)
          ENDIF
         ENDDO
        ENDDO

#ifdef ALLOW_AUTODIFF_TAMC
cCADJ STORE slopeX(:,:) = comlev1_gmredi_slope, key=ikey, byte=isbyte
cCADJ STORE slopeY(:,:) = comlev1_gmredi_slope, key=ikey, byte=isbyte
CADJ STORE SlopeX = loctape_gm
CADJ STORE SlopeY = loctape_gm
#endif

        DO j=1-OLy+1,sNy+OLy-1
         DO i=1-OLx+1,sNx+OLx-1
          SlopeSqr(i,j) = SlopeX(i,j)*SlopeX(i,j)
     &                   +SlopeY(i,j)*SlopeY(i,j)
          taperFct(i,j) = 1. _d 0
#ifdef ALLOW_AUTODIFF_TAMC
         ENDDO
        ENDDO
cCADJ STORE SlopeSqr = comlev1_gmredi_slope, key=ikey, byte=isbyte
CADJ STORE SlopeSqr = loctape_gm
        DO j=1-OLy+1,sNy+OLy-1
         DO i=1-OLx+1,sNx+OLx-1
#endif
          IF ( SlopeSqr(i,j) .GE. GM_slopeSqCutoff ) THEN
            slopeSqr(i,j) = GM_slopeSqCutoff
            taperFct(i,j) = 0. _d 0
          ENDIF
         ENDDO
        ENDDO

C- Compute the tapering function for the GM+Redi tensor :

       IF (GM_taper_scheme.EQ.'linear') THEN

C-      Simplest adiabatic tapering = Smax/Slope (linear)
        DO j=1-OLy+1,sNy+OLy-1
         DO i=1-OLx+1,sNx+OLx-1

          IF ( SlopeSqr(i,j) .EQ. zeroRL ) THEN
           taperFct(i,j) = 1. _d 0
          ELSEIF ( SlopeSqr(i,j) .GT. maxSlopeSqr .AND.
     &             SlopeSqr(i,j) .LT. GM_slopeSqCutoff )  THEN
           taperFct(i,j) = SQRT(maxSlopeSqr / SlopeSqr(i,j))
           slopeSqr(i,j) = MIN( slopeSqr(i,j),GM_bigSlope*GM_bigSlope )
          ENDIF

         ENDDO
        ENDDO

       ELSEIF (GM_taper_scheme.EQ.'gkw91') THEN

C-      Gerdes, Koberle and Willebrand, Clim. Dyn. 1991
        DO j=1-OLy+1,sNy+OLy-1
         DO i=1-OLx+1,sNx+OLx-1

          IF ( SlopeSqr(i,j) .EQ. zeroRL ) THEN
           taperFct(i,j) = 1. _d 0
          ELSEIF ( SlopeSqr(i,j) .GT. maxSlopeSqr .AND.
     &             SlopeSqr(i,j) .LT. GM_slopeSqCutoff ) THEN
           taperFct(i,j) = maxSlopeSqr/SlopeSqr(i,j)
          ENDIF

         ENDDO
        ENDDO

       ELSEIF (GM_taper_scheme.EQ.'dm95') THEN

C-      Danabasoglu and McWilliams, J. Clim. 1995
        DO j=1-OLy+1,sNy+OLy-1
         DO i=1-OLx+1,sNx+OLx-1

          IF ( SlopeSqr(i,j) .EQ. zeroRL ) THEN
           taperFct(i,j) = 1. _d 0
          ELSEIF ( SlopeSqr(i,j) .LT. GM_slopeSqCutoff ) THEN
           Smod = SQRT(SlopeSqr(i,j))*convSlopeUnit
           taperFct(i,j) = op5*( oneRL + TANH( (GM_Scrit-Smod)/GM_Sd ) )
          ENDIF
         ENDDO
        ENDDO

       ELSEIF (GM_taper_scheme.EQ.'ldd97') THEN

C-      Large, Danabasoglu and Doney, JPO 1997
        DO j=1-OLy+1,sNy+OLy-1
         DO i=1-OLx+1,sNx+OLx-1

          IF ( SlopeSqr(i,j) .EQ. zeroRL ) THEN
           taperFct(i,j) = 1. _d 0
          ELSEIF ( SlopeSqr(i,j) .LT. GM_slopeSqCutoff ) THEN
           Smod = SQRT(SlopeSqr(i,j))
           f1 = op5*( oneRL
     &              + TANH( (GM_Scrit-Smod*convSlopeUnit)/GM_Sd ) )
           Rnondim = rDepth/(Lrho(i,j)*Smod)
           IF ( Rnondim.GE.1. _d 0 ) THEN
             f2 = 1. _d 0
           ELSE
             f2 = op5*( 1. _d 0 + SIN( fpi*(Rnondim-op5) ) )
           ENDIF
           taperFct(i,j) = f1*f2
          ENDIF

         ENDDO
        ENDDO

       ELSEIF (GM_taper_scheme.EQ.'stableGmAdjTap') THEN

#ifdef GMREDI_WITH_STABLE_ADJOINT

C special choice for adjoint/optimization of parameters
C (~ strong clipping, reducing non linearity of kw=f(K))

C this variable could be relaced by the runtime parameter GM_maxSlope
        slopeMax= 2. _d -3

# ifdef ALLOW_AUTODIFF_TAMC
cCADJ STORE SlopeX(:,:) = comlev1_gmredi_slope, key=ikey, byte=isbyte
cCADJ STORE SlopeY(:,:) = comlev1_gmredi_slope, key=ikey, byte=isbyte
CADJ STORE SlopeX = loctape_gm
CADJ STORE SlopeY = loctape_gm
#endif
        DO j=1-OLy+1,sNy+OLy-1
         DO i=1-OLx+1,sNx+OLx-1
          slopeSqTmp = SlopeX(i,j)*SlopeX(i,j)
     &               + SlopeY(i,j)*SlopeY(i,j)

          IF ( slopeSqTmp .GT. slopeMax**2 ) then
           slopeTmp = SQRT(slopeSqTmp)
           SlopeX(i,j) = SlopeX(i,j)*slopeMax/slopeTmp
           SlopeY(i,j) = SlopeY(i,j)*slopeMax/slopeTmp
          ENDIF
         ENDDO
        ENDDO

C move the assignment of SlopeSqr to its own do-loop block from the do-loop
C block above to reduce TAF recomputations. The assignment of taperFct is
C also moved to keep the original order of operations.
        DO j=1-OLy+1,sNy+OLy-1
         DO i=1-OLx+1,sNx+OLx-1
          SlopeSqr(i,j) = SlopeX(i,j)*SlopeX(i,j)
     &                  + SlopeY(i,j)*SlopeY(i,j)
          taperFct(i,j) = 1. _d 0
         ENDDO
        ENDDO

#else  /* GMREDI_WITH_STABLE_ADJOINT */

        STOP 'Need to compile wth "#define GMREDI_WITH_STABLE_ADJOINT"'

#endif /* GMREDI_WITH_STABLE_ADJOINT */

       ELSEIF (GM_taper_scheme.NE.' ') THEN
        STOP 'GMREDI_SLOPE_LIMIT: Bad GM_taper_scheme'
       ENDIF

#endif /* GM_EXCLUDE_TAPERING */

      ENDIF

#endif /* ALLOW_GMREDI */

      RETURN
      END

#include "THSICE_OPTIONS.h"
#ifdef ALLOW_AUTODIFF
# include "AUTODIFF_OPTIONS.h"
#endif

CBOP
C     !ROUTINE: THSICE_CHECK
C     !INTERFACE:

      SUBROUTINE THSICE_CHECK( myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R THSICE_CHECK
C     | o Check parameters and other package dependences
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     == Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "THSICE_SIZE.h"
#include "THSICE_PARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     myThid   :: my Thread Id number
      INTEGER myThid

C     !LOCAL VARIABLES:
C     msgBuf   :: Informational/error message buffer
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      INTEGER errCount
CEOP

      _BEGIN_MASTER(myThid)
      errCount = 0

       WRITE(msgBuf,'(A)') 'THSICE_CHECK: #define THSICE'
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                     SQUEEZE_RIGHT, myThid )

C--   Check parameter consistency:
      IF ( .NOT.( thSIce_skipThermo .OR. useBulkForce .OR. useEXF
     &       .OR. useAIM .OR. useCheapAML .OR. useATM2d ) ) THEN
C-    need some form of ATM-surface pkg to provide Air-Ice surf fluxes
        WRITE(msgBuf,'(2A)')
     &   'THSICE_CHECK: needs some PKG (EXF,Bulk-Force,AIM,CheapAML)'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(2A)')
     &   'THSICE_CHECK: to provide Air-Ice surface fluxes for THSICE'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF
      IF ( thSIceAdvScheme.EQ.0 .AND. thSIce_diffK.NE.0. ) THEN
        WRITE(msgBuf,'(2A)')
     &   'THSICE_CHECK: to use thSIce_diffK, needs to select',
     &   ' one advection scheme (thSIceAdvScheme<>0)'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF
#ifndef ALLOW_GENERIC_ADVDIFF
      IF ( thSIceAdvScheme.NE.0 ) THEN
        WRITE(msgBuf,'(2A)') 'THSICE_CHECK: Need to compile ',
     &     '"generic_advdiff" pkg in order to use thSIceAdvScheme'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF
#endif /* ndef ALLOW_GENERIC_ADVDIFF */

      IF ( thSIceBalanceAtmFW.NE.0 ) THEN
#ifndef ALLOW_BALANCE_FLUXES
        WRITE(msgBuf,'(2A)') 'THSICE_CHECK: needs to have ',
     &     'ALLOW_BALANCE_FLUXES defined to use thSIceBalanceAtmFW'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
#endif
       IF ( selectBalanceEmPmR.GE.1 ) THEN
        WRITE(msgBuf,'(2A)') 'THSICE_CHECK: cannot use',
     &       ' both selectBalanceEmPmR and thSIceBalanceAtmFW'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
       ENDIF
      ENDIF

#ifdef ALLOW_AUTODIFF_TAMC
      IF ( nitMaxTsf .GT. MaxTsf ) THEN
        WRITE(msgBuf,'(2A)')
     &   'THSICE_CHECK: Need to set MaxTsf >= nitMaxTsf for TAF'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF
#endif /* ALLOW_AUTODIFF_TAMC */
#ifdef ALLOW_AUTODIFF
# ifdef ALLOW_DBUG_THSICE
        WRITE(msgBuf,'(2A)')
     &   'THSICE_CHECK: cannot compile AD-code with ALLOW_DBUG_THSICE'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
# endif
#endif /* ALLOW_AUTODIFF */

      IF ( useAIM .AND. .NOT.( stepFwd_oceMxL .OR. useCoupler )
     &            .AND.  tauRelax_MxL.NE. -1. _d 0 ) THEN
C-    with pkg/aim, usual way to use pkg/thsice is to step-forward Mixed-Layer
C     (stepFwd_oceMxL=T); otherwise, need to be sure SST are set, e.g. by AIM
C     when setting tauRelax_MxL=-1 ; add a warning if this is not the case
        WRITE(msgBuf,'(2A)') '** WARNING ** THSICE_CHECK: ',
     &   'SST are not stepped forward (stepFwd_oceMx=F)'
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
        WRITE(msgBuf,'(2A)') '** WARNING ** THSICE_CHECK: ',
     &   'nor set (from files) by pkg/aim (tauRelax_MxL<>-1)'
c    &   'nor copied from pkg/aim SST (tauRelax_MxL<>-1.)'
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
      ENDIF

      IF ( errCount.GE.1 ) THEN
        WRITE(msgBuf,'(A,I3,A)')
     &       'THSICE_CHECK: detected', errCount,' fatal error(s)'
        CALL PRINT_ERROR( msgBuf, myThid )
        CALL ALL_PROC_DIE( 0 )
        STOP 'ABNORMAL END: S/R THSICE_CHECK'
      ENDIF

      _END_MASTER(myThid)

      RETURN
      END

#include "OBCS_OPTIONS.h"

C--  File obcs_external_fields_load.F: Routines to read of OBC fields from files
C--   Contents
C--   o OBCS_FIELDS_LOAD
C--   o OBCS_TIME_INTERP_XZ
C--   o OBCS_TIME_INTERP_YZ

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: OBCS_FIELDS_LOAD
C     !INTERFACE:
      SUBROUTINE OBCS_FIELDS_LOAD( myTime, myIter, myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE OBCS_FIELDS_LOAD
C     | o Control reading of fields from external source.
C     *==========================================================*
C     | External source field loading routine for open boundaries.
C     | This routine is called every time we want to
C     | load a a set of external open boundary fields.
C     | Only if there are fields available (file names are not empty)
C     | the open boundary fields are overwritten.
C     | The routine decides which fields to load and then reads them in.
C     | This routine needs to be customised for particular
C     | experiments.
C     | Notes
C     | =====
C     | Two-dimensional and three-dimensional I/O are handled in
C     | the following way under MITgcmUV. A master thread
C     | performs I/O using system calls. This threads reads data
C     | into a temporary buffer. At present the buffer is loaded
C     | with the entire model domain. This is probably OK for now
C     | Each thread then copies data from the buffer to the
C     | region of the proper array it is responsible for.
C     | =====
C     | This routine is the complete analogue to external_fields_load,
C     | except for exchanges of forcing fields. These are done in
C     | obcs_precribe_exchanges, which is called from dynamics.
C     | - Forcing period and cycle are the same as for other fields
C     |   in external forcing.
C     | - constant boundary values are also read here and not
C     |   directly in obcs_init_variables (which calls obcs_calc
C     |   which in turn calls this routine)
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "OBCS_PARAMS.h"
#include "OBCS_FIELDS.h"
#ifdef ALLOW_PTRACERS
#include "PTRACERS_SIZE.h"
#include "OBCS_PTRACERS.h"
#include "PTRACERS_PARAMS.h"
#endif /* ALLOW_PTRACERS */

C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
C     myTime :: Simulation time
C     myIter :: Simulation timestep number
C     myThid :: my Thread Id. number
      _RL     myTime
      INTEGER myIter
      INTEGER myThid

C     if external forcing (exf) package is enabled (useEXF=T), all loading of
C     external fields is done by exf
#ifndef EXCLUDE_FFIELDS_LOAD
#if ( defined ALLOW_OBCS && defined ALLOW_OBCS_PRESCRIBE )

C     !LOCAL VARIABLES:
C     === Local arrays ===
C     aWght, bWght :: Interpolation weights
C     msgBuf       :: Informational/error message buffer
      INTEGER fp
      INTEGER iRecP, iRec0, iRec1
      _RL aWght, bWght
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      INTEGER bi, bj
#ifdef NONLIN_FRSURF
# if (defined ALLOW_OBCS_EAST ) || (defined ALLOW_OBCS_WEST )
      INTEGER j
# endif
# if (defined ALLOW_OBCS_NORTH) || (defined ALLOW_OBCS_SOUTH)
      INTEGER i
# endif
#endif /* NONLIN_FRSURF */
#ifdef ALLOW_PTRACERS
      INTEGER iTr
#endif
CEOP

      fp = readBinaryPrec

      IF ( periodicExternalForcing ) THEN

C--   Now calculate whether it is time to update the forcing arrays
      CALL GET_PERIODIC_INTERVAL(
     O                  iRecP, iRec0, iRec1, bWght, aWght,
     I                  externForcingCycle, externForcingPeriod,
     I                  deltaTClock, myTime, myThid )

      bi = myBxLo(myThid)
      bj = myByLo(myThid)
#ifdef ALLOW_DEBUG
# ifndef ALLOW_AUTODIFF
      IF ( debugLevel.GE.debLevB ) THEN
        _BEGIN_MASTER(myThid)
        WRITE(standardMessageUnit,'(A,I10,A,4I5,A,2F14.10)')
     &   ' OBCS_FIELDS_LOAD,', myIter,
     &   ' : iP,iLd,i0,i1=', iRecP,OBCS_ldRec(bi,bj), iRec0,iRec1,
     &   ' ; Wght=', bWght, aWght
        _END_MASTER(myThid)
      ENDIF
# endif
#endif /* ALLOW_DEBUG */

#ifdef ALLOW_AUTODIFF
C-    assuming that we call S/R OBCS_FIELDS_LOAD at each time-step and
C     with increasing time, this will catch when we need to load new records;
C     But with Adjoint run, this is not always the case => might end-up using
C     the wrong time-records
      IF ( iRec0.NE.iRecP .OR. myIter.EQ.nIter0 ) THEN
#else /* ALLOW_AUTODIFF */
C-    Make no assumption on sequence of calls to OBCS_FIELDS_LOAD ;
C     This is the correct formulation (works in Adjoint run).
C     Unfortunatly, produces many recomputations <== not used until it is fixed
      IF ( iRec1.NE.OBCS_ldRec(bi,bj) ) THEN
#endif /* ALLOW_AUTODIFF */

# ifndef ALLOW_AUTODIFF
C--   If the above condition is met then we need to read in
C     data for the period ahead and the period behind myTime.
       IF ( debugLevel.GE.debLevZero ) THEN
        _BEGIN_MASTER(myThid)
        WRITE(standardMessageUnit,'(A,I10,A,2(2I5,A))')
     &   ' OBCS_FIELDS_LOAD, it=', myIter,
     &   ' : Reading new data, i0,i1=', iRec0, iRec1,
     &    ' (prev=', iRecP, OBCS_ldRec(bi,bj), ' )'
        _END_MASTER(myThid)
       ENDIF
# endif /* ALLOW_AUTODIFF */

#ifndef ALLOW_MDSIO
       STOP 'ABNORMAL END: OBCS_FIELDS_LOAD: NEEDS MSDIO PKG'
#endif /* ALLOW_MDSIO */

       _BARRIER

#ifdef ALLOW_OBCS_EAST
C     Eastern boundary
      IF ( OBEuFile .NE. ' '  ) THEN
       CALL READ_REC_YZ_RL( OBEuFile, fp,Nr,OBEu0,iRec0,myIter,myThid )
       CALL READ_REC_YZ_RL( OBEuFile, fp,Nr,OBEu1,iRec1,myIter,myThid )
      ENDIF
      IF ( OBEvFile .NE. ' '  ) THEN
       CALL READ_REC_YZ_RL( OBEvFile, fp,Nr,OBEv0,iRec0,myIter,myThid )
       CALL READ_REC_YZ_RL( OBEvFile, fp,Nr,OBEv1,iRec1,myIter,myThid )
      ENDIF
      IF ( OBEtFile .NE. ' '  ) THEN
       CALL READ_REC_YZ_RL( OBEtFile, fp,Nr,OBEt0,iRec0,myIter,myThid )
       CALL READ_REC_YZ_RL( OBEtFile, fp,Nr,OBEt1,iRec1,myIter,myThid )
      ENDIF
      IF ( OBEsFile .NE. ' '  ) THEN
       CALL READ_REC_YZ_RL( OBEsFile, fp,Nr,OBEs0,iRec0,myIter,myThid )
       CALL READ_REC_YZ_RL( OBEsFile, fp,Nr,OBEs1,iRec1,myIter,myThid )
      ENDIF
# ifdef ALLOW_NONHYDROSTATIC
      IF ( OBEwFile .NE. ' '  ) THEN
       CALL READ_REC_YZ_RL( OBEwFile, fp,Nr,OBEw0,iRec0,myIter,myThid )
       CALL READ_REC_YZ_RL( OBEwFile, fp,Nr,OBEw1,iRec1,myIter,myThid )
      ENDIF
# endif /* ALLOW_NONHYDROSTATIC */
# ifdef NONLIN_FRSURF
      IF ( OBEetaFile .NE. ' '  ) THEN
       CALL READ_REC_YZ_RL(OBEetaFile,fp,1,OBEeta0,iRec0,myIter,myThid)
       CALL READ_REC_YZ_RL(OBEetaFile,fp,1,OBEeta1,iRec1,myIter,myThid)
      ENDIF
# endif /* NONLIN_FRSURF */
#endif /* ALLOW_OBCS_EAST */
#ifdef ALLOW_OBCS_WEST
C     Western boundary
      IF ( OBWuFile .NE. ' '  ) THEN
       CALL READ_REC_YZ_RL( OBWuFile, fp,Nr,OBWu0,iRec0,myIter,myThid )
       CALL READ_REC_YZ_RL( OBWuFile, fp,Nr,OBWu1,iRec1,myIter,myThid )
      ENDIF
      IF ( OBWvFile .NE. ' '  ) THEN
       CALL READ_REC_YZ_RL( OBWvFile, fp,Nr,OBWv0,iRec0,myIter,myThid )
       CALL READ_REC_YZ_RL( OBWvFile, fp,Nr,OBWv1,iRec1,myIter,myThid )
      ENDIF
      IF ( OBWtFile .NE. ' '  ) THEN
       CALL READ_REC_YZ_RL( OBWtFile, fp,Nr,OBWt0,iRec0,myIter,myThid )
       CALL READ_REC_YZ_RL( OBWtFile, fp,Nr,OBWt1,iRec1,myIter,myThid )
      ENDIF
      IF ( OBWsFile .NE. ' '  ) THEN
       CALL READ_REC_YZ_RL( OBWsFile, fp,Nr,OBWs0,iRec0,myIter,myThid )
       CALL READ_REC_YZ_RL( OBWsFile, fp,Nr,OBWs1,iRec1,myIter,myThid )
      ENDIF
# ifdef ALLOW_NONHYDROSTATIC
      IF ( OBWwFile .NE. ' '  ) THEN
       CALL READ_REC_YZ_RL( OBWwFile, fp,Nr,OBWw0,iRec0,myIter,myThid )
       CALL READ_REC_YZ_RL( OBWwFile, fp,Nr,OBWw1,iRec1,myIter,myThid )
      ENDIF
# endif /* ALLOW_NONHYDROSTATIC */
# ifdef NONLIN_FRSURF
      IF ( OBWetaFile .NE. ' '  ) THEN
       CALL READ_REC_YZ_RL(OBWetaFile,fp,1,OBWeta0,iRec0,myIter,myThid)
       CALL READ_REC_YZ_RL(OBWetaFile,fp,1,OBWeta1,iRec1,myIter,myThid)
      ENDIF
# endif /* NONLIN_FRSURF */
#endif /* ALLOW_OBCS_WEST */
#ifdef ALLOW_OBCS_NORTH
C     Northern boundary
      IF ( OBNuFile .NE. ' '  ) THEN
       CALL READ_REC_XZ_RL( OBNuFile, fp,Nr,OBNu0,iRec0,myIter,myThid )
       CALL READ_REC_XZ_RL( OBNuFile, fp,Nr,OBNu1,iRec1,myIter,myThid )
      ENDIF
      IF ( OBNvFile .NE. ' '  ) THEN
       CALL READ_REC_XZ_RL( OBNvFile, fp,Nr,OBNv0,iRec0,myIter,myThid )
       CALL READ_REC_XZ_RL( OBNvFile, fp,Nr,OBNv1,iRec1,myIter,myThid )
      ENDIF
      IF ( OBNtFile .NE. ' '  ) THEN
       CALL READ_REC_XZ_RL( OBNtFile, fp,Nr,OBNt0,iRec0,myIter,myThid )
       CALL READ_REC_XZ_RL( OBNtFile, fp,Nr,OBNt1,iRec1,myIter,myThid )
      ENDIF
      IF ( OBNsFile .NE. ' '  ) THEN
       CALL READ_REC_XZ_RL( OBNsFile, fp,Nr,OBNs0,iRec0,myIter,myThid )
       CALL READ_REC_XZ_RL( OBNsFile, fp,Nr,OBNs1,iRec1,myIter,myThid )
      ENDIF
# ifdef ALLOW_NONHYDROSTATIC
      IF ( OBNwFile .NE. ' '  ) THEN
       CALL READ_REC_XZ_RL( OBNwFile, fp,Nr,OBNw0,iRec0,myIter,myThid )
       CALL READ_REC_XZ_RL( OBNwFile, fp,Nr,OBNw1,iRec1,myIter,myThid )
      ENDIF
# endif /* ALLOW_NONHYDROSTATIC */
# ifdef NONLIN_FRSURF
      IF ( OBNetaFile .NE. ' '  ) THEN
       CALL READ_REC_XZ_RL(OBNetaFile,fp,1,OBNeta0,iRec0,myIter,myThid)
       CALL READ_REC_XZ_RL(OBNetaFile,fp,1,OBNeta1,iRec1,myIter,myThid)
      ENDIF
# endif /* NONLIN_FRSURF */
#endif /* ALLOW_OBCS_NORTH */
#ifdef ALLOW_OBCS_SOUTH
C     Southern boundary
      IF ( OBSuFile .NE. ' '  ) THEN
       CALL READ_REC_XZ_RL( OBSuFile, fp,Nr,OBSu0,iRec0,myIter,myThid )
       CALL READ_REC_XZ_RL( OBSuFile, fp,Nr,OBSu1,iRec1,myIter,myThid )
      ENDIF
      IF ( OBSvFile .NE. ' '  ) THEN
       CALL READ_REC_XZ_RL( OBSvFile, fp,Nr,OBSv0,iRec0,myIter,myThid )
       CALL READ_REC_XZ_RL( OBSvFile, fp,Nr,OBSv1,iRec1,myIter,myThid )
      ENDIF
      IF ( OBStFile .NE. ' '  ) THEN
       CALL READ_REC_XZ_RL( OBStFile, fp,Nr,OBSt0,iRec0,myIter,myThid )
       CALL READ_REC_XZ_RL( OBStFile, fp,Nr,OBSt1,iRec1,myIter,myThid )
      ENDIF
      IF ( OBSsFile .NE. ' '  ) THEN
       CALL READ_REC_XZ_RL( OBSsFile, fp,Nr,OBSs0,iRec0,myIter,myThid )
       CALL READ_REC_XZ_RL( OBSsFile, fp,Nr,OBSs1,iRec1,myIter,myThid )
      ENDIF
# ifdef ALLOW_NONHYDROSTATIC
      IF ( OBSwFile .NE. ' '  ) THEN
       CALL READ_REC_XZ_RL( OBSwFile, fp,Nr,OBSw0,iRec0,myIter,myThid )
       CALL READ_REC_XZ_RL( OBSwFile, fp,Nr,OBSw1,iRec1,myIter,myThid )
      ENDIF
# endif /* ALLOW_NONHYDROSTATIC */
# ifdef NONLIN_FRSURF
      IF ( OBSetaFile .NE. ' '  ) THEN
       CALL READ_REC_XZ_RL(OBSetaFile,fp,1,OBSeta0,iRec0,myIter,myThid)
       CALL READ_REC_XZ_RL(OBSetaFile,fp,1,OBSeta1,iRec1,myIter,myThid)
      ENDIF
# endif /* NONLIN_FRSURF */
#endif /* ALLOW_OBCS_SOUTH */

#ifdef ALLOW_PTRACERS
      IF (usePTRACERS) THEN
C     read boundary values for passive tracers
       DO iTr = 1, PTRACERS_numInUse
# ifdef ALLOW_OBCS_EAST
C     Eastern boundary
        IF ( OBEptrFile(iTr) .NE. ' '  ) THEN
         CALL READ_REC_YZ_RL( OBEptrFile(iTr), fp, Nr,
     &                OBEptr0(1-OLy,1,1,1,iTr), iRec0, myIter, myThid )
         CALL READ_REC_YZ_RL( OBEptrFile(iTr), fp, Nr,
     &                OBEptr1(1-OLy,1,1,1,iTr), iRec1, myIter, myThid )
        ENDIF
# endif /* ALLOW_OBCS_EAST */
# ifdef ALLOW_OBCS_WEST
C     Western boundary
        IF ( OBWptrFile(iTr) .NE. ' '  ) THEN
         CALL READ_REC_YZ_RL( OBWptrFile(iTr), fp, Nr,
     &                OBWptr0(1-OLy,1,1,1,iTr), iRec0, myIter, myThid )
         CALL READ_REC_YZ_RL( OBWptrFile(iTr), fp, Nr,
     &                OBWptr1(1-OLy,1,1,1,iTr), iRec1, myIter, myThid )
        ENDIF
# endif /* ALLOW_OBCS_WEST */
# ifdef ALLOW_OBCS_NORTH
C     Northern boundary
        IF ( OBNptrFile(iTr) .NE. ' '  ) THEN
         CALL READ_REC_XZ_RL( OBNptrFile(iTr), fp, Nr,
     &                OBNptr0(1-OLy,1,1,1,iTr), iRec0, myIter, myThid )
         CALL READ_REC_XZ_RL( OBNptrFile(iTr), fp, Nr,
     &                OBNptr1(1-OLy,1,1,1,iTr), iRec1, myIter, myThid )
        ENDIF
# endif /* ALLOW_OBCS_NORTH */
# ifdef ALLOW_OBCS_SOUTH
C     Southern boundary
        IF ( OBSptrFile(iTr) .NE. ' '  ) THEN
         CALL READ_REC_XZ_RL( OBSptrFile(iTr), fp, Nr,
     &                OBSptr0(1-OLy,1,1,1,iTr), iRec0, myIter, myThid )
         CALL READ_REC_XZ_RL( OBSptrFile(iTr), fp, Nr,
     &                OBSptr1(1-OLy,1,1,1,iTr), iRec1, myIter, myThid )
        ENDIF
# endif /* ALLOW_OBCS_SOUTH */
C     end do iTr
       ENDDO
C     end if (usePTRACERS)
      ENDIF
#endif /* ALLOW_PTRACERS */

C     At this point in external_fields_load the input fields are exchanged.
C     However, we do not have exchange routines for vertical
C     slices and they are not planned, either, so the approriate fields
C     are exchanged after the open boundary conditions have been
C     applied. (in DYNAMICS and DO_FIELDS_BLOCKING_EXCHANGES)
       _BARRIER

# ifndef ALLOW_AUTODIFF
C-    save newly loaded time-record
        DO bj = myByLo(myThid), myByHi(myThid)
         DO bi = myBxLo(myThid), myBxHi(myThid)
           OBCS_ldRec(bi,bj) = iRec1
         ENDDO
        ENDDO
# endif /* ALLOW_AUTODIFF */

C     end if time to read new data
      ENDIF

C     if not periodicForcing
      ELSE
       aWght = 0. _d 0
       bWght = 1. _d 0
C     read boundary values once and for all
       IF ( myIter .EQ. nIter0 ) THEN
#ifndef ALLOW_MDSIO
         STOP 'ABNORMAL END: OBCS_FIELDS_LOAD: NEEDS MSDIO PKG'
#endif /* ALLOW_MDSIO */
        _BARRIER
C      Read constant boundary conditions only for myIter = nIter0
        WRITE(msgBuf,'(1X,A,I10,1P1E20.12)')
     &       'OBCS_FIELDS_LOAD: Reading initial data:',
     &       myIter, myTime
        CALL PRINT_MESSAGE(msgBuf,standardMessageUnit,
     &       SQUEEZE_RIGHT,myThid)
        iRec0 = 1

#ifdef ALLOW_OBCS_EAST
C     Eastern boundary
        IF ( OBEuFile .NE. ' '  ) THEN
         CALL READ_REC_YZ_RL( OBEuFile,fp,Nr,OBEu0,iRec0,myIter,myThid )
        ENDIF
        IF ( OBEvFile .NE. ' '  ) THEN
         CALL READ_REC_YZ_RL( OBEvFile,fp,Nr,OBEv0,iRec0,myIter,myThid )
        ENDIF
        IF ( OBEtFile .NE. ' '  ) THEN
         CALL READ_REC_YZ_RL( OBEtFile,fp,Nr,OBEt0,iRec0,myIter,myThid )
        ENDIF
        IF ( OBEsFile .NE. ' '  ) THEN
         CALL READ_REC_YZ_RL( OBEsFile,fp,Nr,OBEs0,iRec0,myIter,myThid )
        ENDIF
# ifdef ALLOW_NONHYDROSTATIC
        IF ( OBEwFile .NE. ' '  ) THEN
         CALL READ_REC_YZ_RL( OBEwFile,fp,Nr,OBEw0,iRec0,myIter,myThid )
        ENDIF
# endif /* ALLOW_NONHYDROSTATIC */
# ifdef NONLIN_FRSURF
        IF ( OBEetaFile .NE. ' '  ) THEN
         CALL READ_REC_YZ_RL( OBEetaFile, fp, 1, OBEeta0, iRec0,
     &                        myIter, myThid )
        ENDIF
# endif /* NONLIN_FRSURF */
#endif /* ALLOW_OBCS_EAST */
#ifdef ALLOW_OBCS_WEST
C     Western boundary
        IF ( OBWuFile .NE. ' '  ) THEN
         CALL READ_REC_YZ_RL( OBWuFile,fp,Nr,OBWu0,iRec0,myIter,myThid )
        ENDIF
        IF ( OBWvFile .NE. ' '  ) THEN
         CALL READ_REC_YZ_RL( OBWvFile,fp,Nr,OBWv0,iRec0,myIter,myThid )
        ENDIF
        IF ( OBWtFile .NE. ' '  ) THEN
         CALL READ_REC_YZ_RL( OBWtFile,fp,Nr,OBWt0,iRec0,myIter,myThid )
        ENDIF
        IF ( OBWsFile .NE. ' '  ) THEN
         CALL READ_REC_YZ_RL( OBWsFile,fp,Nr,OBWs0,iRec0,myIter,myThid )
        ENDIF
# ifdef ALLOW_NONHYDROSTATIC
        IF ( OBWwFile .NE. ' '  ) THEN
         CALL READ_REC_YZ_RL( OBWwFile,fp,Nr,OBWw0,iRec0,myIter,myThid )
        ENDIF
# endif /* ALLOW_NONHYDROSTATIC */
# ifdef NONLIN_FRSURF
        IF ( OBWetaFile .NE. ' '  ) THEN
         CALL READ_REC_YZ_RL( OBWetaFile, fp, 1, OBWeta0, iRec0,
     &                        myIter, myThid )
        ENDIF
# endif /* NONLIN_FRSURF */
#endif /* ALLOW_OBCS_WEST */
#ifdef ALLOW_OBCS_NORTH
C     Northern boundary
        IF ( OBNuFile .NE. ' '  ) THEN
         CALL READ_REC_XZ_RL( OBNuFile,fp,Nr,OBNu0,iRec0,myIter,myThid )
        ENDIF
        IF ( OBNvFile .NE. ' '  ) THEN
         CALL READ_REC_XZ_RL( OBNvFile,fp,Nr,OBNv0,iRec0,myIter,myThid )
        ENDIF
        IF ( OBNtFile .NE. ' '  ) THEN
         CALL READ_REC_XZ_RL( OBNtFile,fp,Nr,OBNt0,iRec0,myIter,myThid )
        ENDIF
        IF ( OBNsFile .NE. ' '  ) THEN
         CALL READ_REC_XZ_RL( OBNsFile,fp,Nr,OBNs0,iRec0,myIter,myThid )
        ENDIF
# ifdef ALLOW_NONHYDROSTATIC
        IF ( OBNwFile .NE. ' '  ) THEN
         CALL READ_REC_XZ_RL( OBNwFile,fp,Nr,OBNw0,iRec0,myIter,myThid )
        ENDIF
# endif /* ALLOW_NONHYDROSTATIC */
# ifdef NONLIN_FRSURF
        IF ( OBNetaFile .NE. ' '  ) THEN
         CALL READ_REC_XZ_RL( OBNetaFile, fp, 1, OBNeta0, iRec0,
     &                        myIter, myThid )
        ENDIF
# endif /* NONLIN_FRSURF */
#endif /* ALLOW_OBCS_NORTH */
#ifdef ALLOW_OBCS_SOUTH
C     Southern boundary
        IF ( OBSuFile .NE. ' '  ) THEN
         CALL READ_REC_XZ_RL( OBSuFile,fp,Nr,OBSu0,iRec0,myIter,myThid )
        ENDIF
        IF ( OBSvFile .NE. ' '  ) THEN
         CALL READ_REC_XZ_RL( OBSvFile,fp,Nr,OBSv0,iRec0,myIter,myThid )
        ENDIF
        IF ( OBStFile .NE. ' '  ) THEN
         CALL READ_REC_XZ_RL( OBStFile,fp,Nr,OBSt0,iRec0,myIter,myThid )
        ENDIF
        IF ( OBSsFile .NE. ' '  ) THEN
         CALL READ_REC_XZ_RL( OBSsFile,fp,Nr,OBSs0,iRec0,myIter,myThid )
        ENDIF
# ifdef ALLOW_NONHYDROSTATIC
        IF ( OBSwFile .NE. ' '  ) THEN
         CALL READ_REC_XZ_RL( OBSwFile,fp,Nr,OBSw0,iRec0,myIter,myThid )
        ENDIF
# endif /* ALLOW_NONHYDROSTATIC */
# ifdef NONLIN_FRSURF
        IF ( OBSetaFile .NE. ' '  ) THEN
         CALL READ_REC_XZ_RL( OBSetaFile, fp, 1, OBSeta0, iRec0,
     &                        myIter, myThid )
        ENDIF
# endif /* NONLIN_FRSURF */
#endif /* ALLOW_OBCS_SOUTH */

#ifdef ALLOW_PTRACERS
        IF (usePTRACERS) THEN
C     read passive tracer boundary values
         DO iTr = 1, PTRACERS_numInUse
# ifdef ALLOW_OBCS_EAST
C     Eastern boundary
          IF ( OBEptrFile(iTr) .NE. ' '  ) THEN
           CALL READ_REC_YZ_RL( OBEptrFile(iTr), fp, Nr,
     &               OBEptr0(1-OLy,1,1,1,iTr), iRec0,myIter, myThid )
          ENDIF
# endif /* ALLOW_OBCS_EAST */
# ifdef ALLOW_OBCS_WEST
C     Western boundary
          IF ( OBWptrFile(iTr) .NE. ' '  ) THEN
           CALL READ_REC_YZ_RL( OBWptrFile(iTr), fp, Nr,
     &               OBWptr0(1-OLy,1,1,1,iTr), iRec0, myIter, myThid )
          ENDIF
# endif /* ALLOW_OBCS_WEST */
# ifdef ALLOW_OBCS_NORTH
C     Northern boundary
          IF ( OBNptrFile(iTr) .NE. ' '  ) THEN
           CALL READ_REC_XZ_RL( OBNptrFile(iTr), fp, Nr,
     &               OBNptr0(1-OLy,1,1,1,iTr), iRec0, myIter, myThid )
          ENDIF
# endif /* ALLOW_OBCS_NORTH */
# ifdef ALLOW_OBCS_SOUTH
C     Southern boundary
          IF ( OBSptrFile(iTr) .NE. ' '  ) THEN
           CALL READ_REC_XZ_RL( OBSptrFile(iTr), fp, Nr,
     &               OBSptr0(1-OLy,1,1,1,iTr), iRec0, myIter, myThid )
          ENDIF
# endif /* ALLOW_OBCS_SOUTH */
C     end do iTr
         ENDDO
C     end if (usePTRACERS)
        ENDIF
#endif /* ALLOW_PTRACERS */
        _BARRIER
C     endif myIter .EQ. nIter0
       ENDIF
C     endif for periodicForcing
      ENDIF

C--   Now interpolate OBSu, OBSv, OBSt, OBSs, OBSptr, etc.
C--   For periodicForcing, aWght = 0. and bWght = 1. so that the
C--   interpolation boilds down to copying the time-independent
C--   forcing field OBSu0 to OBSu
#ifdef ALLOW_OBCS_EAST
       IF ( OBEuFile .NE. ' '  ) CALL OBCS_TIME_INTERP_YZ(
     &      OBEu, OBEu0, OBEu1, aWght, bWght, myThid )
       IF ( OBEvFile .NE. ' '  ) CALL OBCS_TIME_INTERP_YZ(
     &      OBEv, OBEv0, OBEv1, aWght, bWght, myThid )
       IF ( OBEtFile .NE. ' '  ) CALL OBCS_TIME_INTERP_YZ(
     &      OBEt, OBEt0, OBEt1, aWght, bWght, myThid )
       IF ( OBEsFile .NE. ' '  ) CALL OBCS_TIME_INTERP_YZ(
     &      OBEs, OBEs0, OBEs1, aWght, bWght, myThid )
# ifdef ALLOW_NONHYDROSTATIC
       IF ( OBEwFile .NE. ' '  ) CALL OBCS_TIME_INTERP_YZ(
     &      OBEw, OBEw0, OBEw1, aWght, bWght, myThid )
# endif /* ALLOW_NONHYDROSTATIC */
# ifdef NONLIN_FRSURF
       IF ( OBEetaFile .NE. ' ' ) THEN
        DO bj = myByLo(myThid), myByHi(myThid)
         DO bi = myBxLo(myThid), myBxHi(myThid)
          DO j=1-OLy,sNy+OLy
           OBEeta(j,bi,bj) = bWght*OBEeta0(j,bi,bj)
     &                      +aWght*OBEeta1(j,bi,bj)
          ENDDO
         ENDDO
        ENDDO
       ENDIF
# endif /* NONLIN_FRSURF */
#endif /* ALLOW_OBCS_EAST */
#ifdef ALLOW_OBCS_WEST
       IF ( OBWuFile .NE. ' '  ) CALL OBCS_TIME_INTERP_YZ(
     &      OBWu, OBWu0, OBWu1, aWght, bWght, myThid )
       IF ( OBWvFile .NE. ' '  ) CALL OBCS_TIME_INTERP_YZ(
     &      OBWv, OBWv0, OBWv1, aWght, bWght, myThid )
       IF ( OBWtFile .NE. ' '  ) CALL OBCS_TIME_INTERP_YZ(
     &      OBWt, OBWt0, OBWt1, aWght, bWght, myThid )
       IF ( OBWsFile .NE. ' '  ) CALL OBCS_TIME_INTERP_YZ(
     &      OBWs, OBWs0, OBWs1, aWght, bWght, myThid )
# ifdef ALLOW_NONHYDROSTATIC
       IF ( OBWwFile .NE. ' '  ) CALL OBCS_TIME_INTERP_YZ(
     &      OBWw, OBWw0, OBWw1, aWght, bWght, myThid )
# endif /* ALLOW_NONHYDROSTATIC */
# ifdef NONLIN_FRSURF
       IF ( OBWetaFile .NE. ' ' ) THEN
        DO bj = myByLo(myThid), myByHi(myThid)
         DO bi = myBxLo(myThid), myBxHi(myThid)
          DO j=1-OLy,sNy+OLy
           OBWeta(j,bi,bj) = bWght*OBWeta0(j,bi,bj)
     &                      +aWght*OBWeta1(j,bi,bj)
          ENDDO
         ENDDO
        ENDDO
       ENDIF
# endif /* NONLIN_FRSURF */
#endif /* ALLOW_OBCS_WEST */
#ifdef ALLOW_OBCS_NORTH
       IF ( OBNuFile .NE. ' '  ) CALL OBCS_TIME_INTERP_XZ(
     &      OBNu, OBNu0, OBNu1, aWght, bWght, myThid )
       IF ( OBNvFile .NE. ' '  ) CALL OBCS_TIME_INTERP_XZ(
     &      OBNv, OBNv0, OBNv1, aWght, bWght, myThid )
       IF ( OBNtFile .NE. ' '  ) CALL OBCS_TIME_INTERP_XZ(
     &      OBNt, OBNt0, OBNt1, aWght, bWght, myThid )
       IF ( OBNsFile .NE. ' '  ) CALL OBCS_TIME_INTERP_XZ(
     &      OBNs, OBNs0, OBNs1, aWght, bWght, myThid )
# ifdef ALLOW_NONHYDROSTATIC
       IF ( OBNwFile .NE. ' '  ) CALL OBCS_TIME_INTERP_XZ(
     &      OBNw, OBNw0, OBNw1, aWght, bWght, myThid )
# endif /* ALLOW_NONHYDROSTATIC */
# ifdef NONLIN_FRSURF
       IF ( OBNetaFile .NE. ' ' ) THEN
        DO bj = myByLo(myThid), myByHi(myThid)
         DO bi = myBxLo(myThid), myBxHi(myThid)
          DO i=1-OLx,sNx+OLx
           OBNeta(i,bi,bj) = bWght*OBNeta0(i,bi,bj)
     &                      +aWght*OBNeta1(i,bi,bj)
          ENDDO
         ENDDO
        ENDDO
       ENDIF
# endif /* NONLIN_FRSURF */
#endif /* ALLOW_OBCS_NORTH */
#ifdef ALLOW_OBCS_SOUTH
       IF ( OBSuFile .NE. ' '  ) CALL OBCS_TIME_INTERP_XZ(
     &      OBSu, OBSu0, OBSu1, aWght, bWght, myThid )
       IF ( OBSvFile .NE. ' '  ) CALL OBCS_TIME_INTERP_XZ(
     &      OBSv, OBSv0, OBSv1, aWght, bWght, myThid )
       IF ( OBStFile .NE. ' '  ) CALL OBCS_TIME_INTERP_XZ(
     &      OBSt, OBSt0, OBSt1, aWght, bWght, myThid )
       IF ( OBSsFile .NE. ' '  ) CALL OBCS_TIME_INTERP_XZ(
     &      OBSs, OBSs0, OBSs1, aWght, bWght, myThid )
# ifdef ALLOW_NONHYDROSTATIC
       IF ( OBSwFile .NE. ' '  ) CALL OBCS_TIME_INTERP_XZ(
     &      OBSw, OBSw0, OBSw1, aWght, bWght, myThid )
# endif /* ALLOW_NONHYDROSTATIC */
# ifdef NONLIN_FRSURF
       IF ( OBSetaFile .NE. ' ' ) THEN
        DO bj = myByLo(myThid), myByHi(myThid)
         DO bi = myBxLo(myThid), myBxHi(myThid)
          DO i=1-OLx,sNx+OLx
           OBSeta(i,bi,bj) = bWght*OBSeta0(i,bi,bj)
     &                      +aWght*OBSeta1(i,bi,bj)
          ENDDO
         ENDDO
        ENDDO
       ENDIF
# endif /* NONLIN_FRSURF */
#endif /* ALLOW_OBCS_SOUTH */

#ifdef ALLOW_PTRACERS
      IF (usePTRACERS) THEN
C     "interpolate" passive tracer boundary values
       DO iTr = 1, PTRACERS_numInUse
# ifdef ALLOW_OBCS_EAST
        IF ( OBEptrFile(iTr) .NE. ' '  )
     &       CALL OBCS_TIME_INTERP_YZ(
     O       OBEptr (1-OLy,1,1,1,iTr),
     I       OBEptr0(1-OLy,1,1,1,iTr),
     I       OBEptr1(1-OLy,1,1,1,iTr), aWght, bWght, myThid )
# endif /* ALLOW_OBCS_EAST */
# ifdef ALLOW_OBCS_WEST
        IF ( OBWptrFile(iTr) .NE. ' '  )
     &       CALL OBCS_TIME_INTERP_YZ(
     O       OBWptr (1-OLy,1,1,1,iTr),
     I       OBWptr0(1-OLy,1,1,1,iTr),
     I       OBWptr1(1-OLy,1,1,1,iTr), aWght, bWght, myThid )
# endif /* ALLOW_OBCS_WEST */
# ifdef ALLOW_OBCS_NORTH
        IF ( OBNptrFile(iTr) .NE. ' '  )
     &       CALL OBCS_TIME_INTERP_XZ(
     O       OBNptr (1-OLx,1,1,1,iTr),
     I       OBNptr0(1-OLx,1,1,1,iTr),
     I       OBNptr1(1-OLx,1,1,1,iTr), aWght, bWght, myThid )
# endif /* ALLOW_OBCS_NORTH */
# ifdef ALLOW_OBCS_SOUTH
        IF ( OBSptrFile(iTr) .NE. ' '  )
     &       CALL OBCS_TIME_INTERP_XZ(
     O       OBSptr (1-OLx,1,1,1,iTr),
     I       OBSptr0(1-OLx,1,1,1,iTr),
     I       OBSptr1(1-OLx,1,1,1,iTr), aWght, bWght, myThid )
# endif /* ALLOW_OBCS_SOUTH */
C     end do iTr
       ENDDO
C     end if (usePTRACERS)
      ENDIF
#endif /* ALLOW_PTRACERS */

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: OBCS_TIME_INTERP_XZ
C     !INTERFACE:
      SUBROUTINE OBCS_TIME_INTERP_XZ(
     O     fld,
     I     fld0, fld1, aWght, bWght, myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE OBCS_TIME_INTERP_XZ
C     | o Interpolate between to records
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
C     aWght, bWght :: Interpolation weights
C     myThid       :: my Thread Id. number
      _RL fld (1-OLx:sNx+OLx,Nr,nSx,nSy)
      _RL fld0(1-OLx:sNx+OLx,Nr,nSx,nSy)
      _RL fld1(1-OLx:sNx+OLx,Nr,nSx,nSy)
      _RL aWght,bWght
      INTEGER myThid

C     !LOCAL VARIABLES:
C     === Local arrays ===
C     bi,bj,i,j :: loop counters
      INTEGER bi,bj,i,k
CEOP
       DO bj = myByLo(myThid), myByHi(myThid)
        DO bi = myBxLo(myThid), myBxHi(myThid)
         DO k = 1, Nr
          DO i=1-OLx,sNx+OLx
           fld(i,k,bi,bj)   = bWght*fld0(i,k,bi,bj)
     &                       +aWght*fld1(i,k,bi,bj)
          ENDDO
         ENDDO
        ENDDO
       ENDDO

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: OBCS_TIME_INTERP_YZ
C     !INTERFACE:
      SUBROUTINE OBCS_TIME_INTERP_YZ(
     O     fld,
     I     fld0, fld1, aWght, bWght, myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE OBCS_TIME_INTERP_YZ
C     | o Interpolate between to records
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
C     aWght, bWght :: Interpolation weights
C     myThid       :: my Thread Id. number
      _RL fld (1-OLy:sNy+OLy,Nr,nSx,nSy)
      _RL fld0(1-OLy:sNy+OLy,Nr,nSx,nSy)
      _RL fld1(1-OLy:sNy+OLy,Nr,nSx,nSy)
      _RL aWght,bWght
      INTEGER myThid

C     !LOCAL VARIABLES:
C     === Local arrays ===
C     bi,bj,i,j :: loop counters
      INTEGER bi,bj,j,k
CEOP
       DO bj = myByLo(myThid), myByHi(myThid)
        DO bi = myBxLo(myThid), myBxHi(myThid)
         DO k = 1, Nr
          DO j=1-OLy,sNy+OLy
           fld(j,k,bi,bj)   = bWght*fld0(j,k,bi,bj)
     &                       +aWght*fld1(j,k,bi,bj)
          ENDDO
         ENDDO
        ENDDO
       ENDDO

#endif /* ALLOW_OBCS AND ALLOW_OBCS_PRESCRIBE */
#endif /* ndef EXCLUDE_FFIELDS_LOAD */

       RETURN
       END

#include "AUTODIFF_OPTIONS.h"
#ifdef ALLOW_CTRL
# include "CTRL_OPTIONS.h"
#endif
#ifdef ALLOW_OBCS
# include "OBCS_OPTIONS.h"
#endif
#ifdef ALLOW_SEAICE
# include "SEAICE_OPTIONS.h"
#endif
#ifdef ALLOW_EXF
# include "EXF_OPTIONS.h"
#endif

      SUBROUTINE AUTODIFF_STORE( myThid )

C     ==================================================================
C     SUBROUTINE autodiff_store
C     ==================================================================
C
C     packing for checkpoint storage
C
C     started: Matt Mazloff mmazloff@mit.edu 03-May-2007
C
C     ==================================================================
C     SUBROUTINE autodiff_store
C     ==================================================================

      IMPLICIT NONE

C     == global variables ==

#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
C**************************************
C These includes are needed for
C AD-checkpointing.
C They provide the fields to be stored.

#include "GRID.h"
#include "DYNVARS.h"
#include "FFIELDS.h"
#include "SURFACE.h"

#ifdef ALLOW_OBCS
# include "OBCS_PARAMS.h"
# include "OBCS_FIELDS.h"
# include "OBCS_SEAICE.h"
#endif
#ifdef ALLOW_EXF
# include "EXF_FIELDS.h"
# ifdef ALLOW_BULKFORMULAE
#  include "EXF_CONSTANTS.h"
# endif
#endif /* ALLOW_EXF */
#ifdef ALLOW_SEAICE
# include "SEAICE_SIZE.h"
# include "SEAICE.h"
#endif
#ifdef ALLOW_CTRL
# include "CTRL_SIZE.h"
# include "CTRL.h"
# include "CTRL_OBCS.h"
#endif
C     it is important that this file is included after SEAICE_SIZE.h
#include "AUTODIFF_STORE.h"

C     == routine arguments ==
C     myThid   :: my Thread Id number
      INTEGER myThid

#ifdef ALLOW_AUTODIFF_TAMC
C     == local variables ==
#if ( defined AUTODIFF_USE_STORE_RESTORE || \
     ( defined ALLOW_OBCS && defined AUTODIFF_USE_STORE_RESTORE_OBCS ))
      INTEGER bi, bj
      INTEGER I, J, K
#endif

C--   == end of interface ==

#ifdef ALLOW_DEBUG
      IF ( debugMode ) CALL DEBUG_ENTER('AUTODIFF_STORE',myThid)
#endif

#ifdef AUTODIFF_USE_STORE_RESTORE
C--   Over all tiles
      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
C-      2D arrays
        DO J=1-OLy,sNy+OLy
         DO I=1-OLx,sNx+OLx
          StoreDynVars2D(I,J,bi,bj,1) = etaN(I,J,bi,bj)
          StoreDynVars2D(I,J,bi,bj,2) = taux0(I,J,bi,bj)
          StoreDynVars2D(I,J,bi,bj,3) = taux1(I,J,bi,bj)
          StoreDynVars2D(I,J,bi,bj,4) = tauy0(I,J,bi,bj)
          StoreDynVars2D(I,J,bi,bj,5) = tauy1(I,J,bi,bj)
          StoreDynVars2D(I,J,bi,bj,6) = qnet0(I,J,bi,bj)
          StoreDynVars2D(I,J,bi,bj,7) = qnet1(I,J,bi,bj)
          StoreDynVars2D(I,J,bi,bj,8)  = empmr0(I,J,bi,bj)
          StoreDynVars2D(I,J,bi,bj,9) = empmr1(I,J,bi,bj)
          StoreDynVars2D(I,J,bi,bj,10) = sst0(I,J,bi,bj)
          StoreDynVars2D(I,J,bi,bj,11) = sst1(I,J,bi,bj)
          StoreDynVars2D(I,J,bi,bj,12) = sss0(I,J,bi,bj)
          StoreDynVars2D(I,J,bi,bj,13) = sss1(I,J,bi,bj)
          StoreDynVars2D(I,J,bi,bj,14) = saltflux0(I,J,bi,bj)
          StoreDynVars2D(I,J,bi,bj,15) = saltflux1(I,J,bi,bj)
#ifdef SHORTWAVE_HEATING
          StoreDynVars2D(I,J,bi,bj,16) = qsw0(I,J,bi,bj)
          StoreDynVars2D(I,J,bi,bj,17) = qsw1(I,J,bi,bj)
#else
          StoreDynVars2D(I,J,bi,bj,16) = 0.
          StoreDynVars2D(I,J,bi,bj,17) = 0.
#endif
#ifdef ATMOSPHERIC_LOADING
          StoreDynVars2D(I,J,bi,bj,18) = pload0(I,J,bi,bj)
          StoreDynVars2D(I,J,bi,bj,19) = pload1(I,J,bi,bj)
#else
          StoreDynVars2D(I,J,bi,bj,18) = 0.
          StoreDynVars2D(I,J,bi,bj,19) = 0.
#endif
          StoreDynVars2D(I,J,bi,bj,20) = etaH(I,J,bi,bj)
          StoreDynVars2D(I,J,bi,bj,21) = dEtaHdt(I,J,bi,bj)
          StoreDynVars2D(I,J,bi,bj,22) = PmEpR(I,J,bi,bj)
         ENDDO
        ENDDO
       ENDDO
      ENDDO

C--   Over all tiles
      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
C-      3D arrays
        DO K=1,Nr
         DO J=1-OLy,sNy+OLy
          DO I=1-OLx,sNx+OLx
#ifdef ALLOW_ADAMSBASHFORTH_3
           StoreDynVars3D(I,J,K,bi,bj,1)  = gtNm(I,J,K,bi,bj,1)
           StoreDynVars3D(I,J,K,bi,bj,2)  = gsNm(I,J,K,bi,bj,1)
           StoreDynVars3D(I,J,K,bi,bj,3)  = guNm(I,J,K,bi,bj,1)
           StoreDynVars3D(I,J,K,bi,bj,4)  = gvNm(I,J,K,bi,bj,1)
#else
           StoreDynVars3D(I,J,K,bi,bj,1)  = gtNm1(I,J,K,bi,bj)
           StoreDynVars3D(I,J,K,bi,bj,2)  = gsNm1(I,J,K,bi,bj)
           StoreDynVars3D(I,J,K,bi,bj,3)  = guNm1(I,J,K,bi,bj)
           StoreDynVars3D(I,J,K,bi,bj,4)  = gvNm1(I,J,K,bi,bj)
#endif
           StoreDynVars3D(I,J,K,bi,bj,5)  = theta(I,J,K,bi,bj)
           StoreDynVars3D(I,J,K,bi,bj,6)  = salt(I,J,K,bi,bj)
           StoreDynVars3D(I,J,K,bi,bj,7)  = uVel(I,J,K,bi,bj)
           StoreDynVars3D(I,J,K,bi,bj,8)  = vVel(I,J,K,bi,bj)
           StoreDynVars3D(I,J,K,bi,bj,9)  = wVel(I,J,K,bi,bj)
           StoreDynVars3D(I,J,K,bi,bj,10) = totPhiHyd(I,J,K,bi,bj)
#ifdef ALLOW_ADAMSBASHFORTH_3
           StoreDynVars3D(I,J,K,bi,bj,11) = gtNm(I,J,K,bi,bj,2)
           StoreDynVars3D(I,J,K,bi,bj,12) = gsNm(I,J,K,bi,bj,2)
           StoreDynVars3D(I,J,K,bi,bj,13) = guNm(I,J,K,bi,bj,2)
           StoreDynVars3D(I,J,K,bi,bj,14) = gvNm(I,J,K,bi,bj,2)
#endif
          ENDDO
         ENDDO
        ENDDO
       ENDDO
      ENDDO

#ifdef ALLOW_EXF
C--   Over all tiles
      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
C-      2D arrays
        DO J=1-OLy,sNy+OLy
         DO I=1-OLx,sNx+OLx
          StoreEXF1(I,J,bi,bj,1)  = hflux0(I,J,bi,bj)
          StoreEXF1(I,J,bi,bj,2)  = hflux1(I,J,bi,bj)
          StoreEXF1(I,J,bi,bj,3)  = sflux0(I,J,bi,bj)
          StoreEXF1(I,J,bi,bj,4)  = sflux1(I,J,bi,bj)
          StoreEXF1(I,J,bi,bj,5)  = ustress0(I,J,bi,bj)
          StoreEXF1(I,J,bi,bj,6)  = ustress1(I,J,bi,bj)
          StoreEXF1(I,J,bi,bj,7)  = vstress0(I,J,bi,bj)
          StoreEXF1(I,J,bi,bj,8)  = vstress1(I,J,bi,bj)
          StoreEXF1(I,J,bi,bj,9)  = wspeed0(I,J,bi,bj)
          StoreEXF1(I,J,bi,bj,10) = wspeed1(I,J,bi,bj)
# ifdef SHORTWAVE_HEATING
          StoreEXF1(I,J,bi,bj,11) = swflux0(I,J,bi,bj)
          StoreEXF1(I,J,bi,bj,12) = swflux1(I,J,bi,bj)
# else
          StoreEXF1(I,J,bi,bj,11) = 0.0
          StoreEXF1(I,J,bi,bj,12) = 0.0
# endif
# ifdef ALLOW_RUNOFF
          StoreEXF1(I,J,bi,bj,13) = runoff0(I,J,bi,bj)
          StoreEXF1(I,J,bi,bj,14) = runoff1(I,J,bi,bj)
# else
          StoreEXF1(I,J,bi,bj,13) = 0.0
          StoreEXF1(I,J,bi,bj,14) = 0.0
# endif
# ifdef ATMOSPHERIC_LOADING
          StoreEXF1(I,J,bi,bj,15) = apressure0(I,J,bi,bj)
          StoreEXF1(I,J,bi,bj,16) = apressure1(I,J,bi,bj)
          StoreEXF1(I,J,bi,bj,17) = siceload(I,J,bi,bj)
# else
          StoreEXF1(I,J,bi,bj,15) = 0.0
          StoreEXF1(I,J,bi,bj,16) = 0.0
          StoreEXF1(I,J,bi,bj,17) = 0.0
# endif
# ifdef ALLOW_CLIMSSS_RELAXATION
          StoreEXF1(I,J,bi,bj,18) = climsss0(I,J,bi,bj)
          StoreEXF1(I,J,bi,bj,19) = climsss1(I,J,bi,bj)
# else
          StoreEXF1(I,J,bi,bj,18) = 0.0
          StoreEXF1(I,J,bi,bj,19) = 0.0
# endif
# ifdef ALLOW_CLIMSST_RELAXATION
          StoreEXF1(I,J,bi,bj,20) = climsst0(I,J,bi,bj)
          StoreEXF1(I,J,bi,bj,21) = climsst1(I,J,bi,bj)
# else
          StoreEXF1(I,J,bi,bj,20) = 0.0
          StoreEXF1(I,J,bi,bj,21) = 0.0
# endif
# ifdef ALLOW_SALTFLX
          StoreEXF1(I,J,bi,bj,22) = saltflx0(I,J,bi,bj)
          StoreEXF1(I,J,bi,bj,23) = saltflx1(I,J,bi,bj)
# else
          StoreEXF1(I,J,bi,bj,22) = 0.0
          StoreEXF1(I,J,bi,bj,23) = 0.0
# endif
         ENDDO
        ENDDO
       ENDDO
      ENDDO

C--   Over all tiles
      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
C-      2D arrays
        DO J=1-OLy,sNy+OLy
         DO I=1-OLx,sNx+OLx
# ifdef ALLOW_ATM_TEMP
          StoreEXF2(I,J,bi,bj,1) = aqh0(I,J,bi,bj)
          StoreEXF2(I,J,bi,bj,2) = aqh1(I,J,bi,bj)
          StoreEXF2(I,J,bi,bj,3) = atemp0(I,J,bi,bj)
          StoreEXF2(I,J,bi,bj,4) = atemp1(I,J,bi,bj)
          StoreEXF2(I,J,bi,bj,5) = precip0(I,J,bi,bj)
          StoreEXF2(I,J,bi,bj,6) = precip1(I,J,bi,bj)
          StoreEXF2(I,J,bi,bj,7) = lwflux0(I,J,bi,bj)
          StoreEXF2(I,J,bi,bj,8) = lwflux1(I,J,bi,bj)
          StoreEXF2(I,J,bi,bj,9)  = snowprecip0(I,J,bi,bj)
          StoreEXF2(I,J,bi,bj,10) = snowprecip1(I,J,bi,bj)
#  ifdef ALLOW_READ_TURBFLUXES
          StoreEXF2(I,J,bi,bj,11) = hs0(I,J,bi,bj)
          StoreEXF2(I,J,bi,bj,12) = hs1(I,J,bi,bj)
          StoreEXF2(I,J,bi,bj,13) = hl0(I,J,bi,bj)
          StoreEXF2(I,J,bi,bj,14) = hl1(I,J,bi,bj)
#  else
          StoreEXF2(I,J,bi,bj,11) = 0.0
          StoreEXF2(I,J,bi,bj,12) = 0.0
          StoreEXF2(I,J,bi,bj,13) = 0.0
          StoreEXF2(I,J,bi,bj,14) = 0.0
#  endif
#  ifdef EXF_READ_EVAP
          StoreEXF2(I,J,bi,bj,15) = evap0(I,J,bi,bj)
          StoreEXF2(I,J,bi,bj,16) = evap1(I,J,bi,bj)
#  else
          StoreEXF2(I,J,bi,bj,15) = evap(I,J,bi,bj)
          StoreEXF2(I,J,bi,bj,16) = 0.0
#  endif /* EXF_READ_EVAP */
#  ifdef ALLOW_DOWNWARD_RADIATION
          StoreEXF2(I,J,bi,bj,17) = swdown0(I,J,bi,bj)
          StoreEXF2(I,J,bi,bj,18) = swdown1(I,J,bi,bj)
          StoreEXF2(I,J,bi,bj,19) = lwdown0(I,J,bi,bj)
          StoreEXF2(I,J,bi,bj,20) = lwdown1(I,J,bi,bj)
#  else
          StoreEXF2(I,J,bi,bj,17) = 0.0
          StoreEXF2(I,J,bi,bj,18) = 0.0
          StoreEXF2(I,J,bi,bj,19) = 0.0
          StoreEXF2(I,J,bi,bj,20) = 0.0
#  endif
# endif /* ALLOW_ATM_TEMP */
          StoreEXF2(I,J,bi,bj,21) = uwind0(I,J,bi,bj)
          StoreEXF2(I,J,bi,bj,22) = uwind1(I,J,bi,bj)
          StoreEXF2(I,J,bi,bj,23) = vwind0(I,J,bi,bj)
          StoreEXF2(I,J,bi,bj,24) = vwind1(I,J,bi,bj)
         ENDDO
        ENDDO
       ENDDO
      ENDDO
#endif /* ALLOW_EXF */

#ifdef ALLOW_SEAICE
C--   Over all tiles
      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
C-      2D arrays
        DO J=1-OLy,sNy+OLy
         DO I=1-OLx,sNx+OLx
          StoreSEAICE(I,J,bi,bj, 1) = AREA(I,J,bi,bj)
          StoreSEAICE(I,J,bi,bj, 2) = HEFF(I,J,bi,bj)
          StoreSEAICE(I,J,bi,bj, 3) = HSNOW(I,J,bi,bj)
          StoreSEAICE(I,J,bi,bj, 4) = RUNOFF(I,J,bi,bj)
          StoreSEAICE(I,J,bi,bj, 5) = UICE(I,J,bi,bj)
          StoreSEAICE(I,J,bi,bj, 6) = VICE(I,J,bi,bj)
          StoreSEAICE(I,J,bi,bj, 7) = ZETA(I,J,bi,bj)
          StoreSEAICE(I,J,bi,bj, 8) = ETA(I,J,bi,bj)
# ifdef SEAICE_CGRID
          StoreSEAICE(I,J,bi,bj, 9) = dwatn(I,J,bi,bj)
#  ifdef SEAICE_ALLOW_BOTTOMDRAG
          StoreSEAICE(I,J,bi,bj,10) = cbotc(I,J,bi,bj)
#  else
          StoreSEAICE(I,J,bi,bj,10) = 0.0
#  endif /* SEAICE_ALLOW_BOTTOMDRAG */
          StoreSEAICE(I,J,bi,bj,11) = stressDivergenceX(I,J,bi,bj)
          StoreSEAICE(I,J,bi,bj,12) = stressDivergenceY(I,J,bi,bj)
# else
          StoreSEAICE(I,J,bi,bj, 9) = 0.0
          StoreSEAICE(I,J,bi,bj,10) = 0.0
          StoreSEAICE(I,J,bi,bj,11) = 0.0
          StoreSEAICE(I,J,bi,bj,12) = 0.0
# endif /* SEAICE_CGRID */
# ifdef SEAICE_ALLOW_EVP
          StoreSEAICE(I,J,bi,bj,13) = seaice_sigma1(I,J,bi,bj)
          StoreSEAICE(I,J,bi,bj,14) = seaice_sigma2(I,J,bi,bj)
          StoreSEAICE(I,J,bi,bj,15) = seaice_sigma12(I,J,bi,bj)
# else
          StoreSEAICE(I,J,bi,bj,13) = 0.0
          StoreSEAICE(I,J,bi,bj,14) = 0.0
          StoreSEAICE(I,J,bi,bj,15) = 0.0
# endif /* SEAICE_ALLOW_EVP */
# ifdef SEAICE_VARIABLE_SALINITY
          StoreSEAICE(I,J,bi,bj,16) = HSALT(I,J,bi,bj)
# else
          StoreSEAICE(I,J,bi,bj,16) = 0.0
# endif
         ENDDO
        ENDDO
C--   this 3D array comes last because it has a variable size nITD
        DO K=1,nITD
         DO J=1-OLy,sNy+OLy
          DO I=1-OLx,sNx+OLx
           StoreSEAICE(I,J,bi,bj,16+K) = TICES(I,J,K,bi,bj)
          ENDDO
         ENDDO
        ENDDO
C
       ENDDO
      ENDDO
#endif /* ALLOW_SEAICE */

#endif /* AUTODIFF_USE_STORE_RESTORE */

#if ( defined ALLOW_OBCS && defined AUTODIFF_USE_STORE_RESTORE_OBCS )
# ifdef ALLOW_OBCS_NORTH
C--   Over all tiles
      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
C-      2D arrays
        DO K=1,Nr
         DO I=1-OLx,sNx+OLx
          StoreOBCSN(I,K,bi,bj,1)  = OBNu(I,K,bi,bj)
          StoreOBCSN(I,K,bi,bj,2)  = OBNv(I,K,bi,bj)
          StoreOBCSN(I,K,bi,bj,3)  = OBNt(I,K,bi,bj)
          StoreOBCSN(I,K,bi,bj,4)  = OBNs(I,K,bi,bj)
#  ifdef ALLOW_OBCS_PRESCRIBE
          StoreOBCSN(I,K,bi,bj,5)  = OBNu0(I,K,bi,bj)
          StoreOBCSN(I,K,bi,bj,6)  = OBNv0(I,K,bi,bj)
          StoreOBCSN(I,K,bi,bj,7)  = OBNt0(I,K,bi,bj)
          StoreOBCSN(I,K,bi,bj,8)  = OBNs0(I,K,bi,bj)
          StoreOBCSN(I,K,bi,bj,9)  = OBNu1(I,K,bi,bj)
          StoreOBCSN(I,K,bi,bj,10) = OBNv1(I,K,bi,bj)
          StoreOBCSN(I,K,bi,bj,11) = OBNt1(I,K,bi,bj)
          StoreOBCSN(I,K,bi,bj,12) = OBNs1(I,K,bi,bj)
#  endif
#  ifdef ALLOW_OBCSN_CONTROL
          StoreOBCSN(I,K,bi,bj,13) = xx_obcsn0(I,K,bi,bj,1)
          StoreOBCSN(I,K,bi,bj,14) = xx_obcsn0(I,K,bi,bj,2)
          StoreOBCSN(I,K,bi,bj,15) = xx_obcsn0(I,K,bi,bj,3)
          StoreOBCSN(I,K,bi,bj,16) = xx_obcsn0(I,K,bi,bj,4)
          StoreOBCSN(I,K,bi,bj,17) = xx_obcsn1(I,K,bi,bj,1)
          StoreOBCSN(I,K,bi,bj,18) = xx_obcsn1(I,K,bi,bj,2)
          StoreOBCSN(I,K,bi,bj,19) = xx_obcsn1(I,K,bi,bj,3)
          StoreOBCSN(I,K,bi,bj,20) = xx_obcsn1(I,K,bi,bj,4)
#  else
          StoreOBCSN(I,K,bi,bj,13) = 0.0
          StoreOBCSN(I,K,bi,bj,14) = 0.0
          StoreOBCSN(I,K,bi,bj,15) = 0.0
          StoreOBCSN(I,K,bi,bj,16) = 0.0
          StoreOBCSN(I,K,bi,bj,17) = 0.0
          StoreOBCSN(I,K,bi,bj,18) = 0.0
          StoreOBCSN(I,K,bi,bj,19) = 0.0
          StoreOBCSN(I,K,bi,bj,20) = 0.0
#  endif
         ENDDO
        ENDDO
       ENDDO
      ENDDO
# endif /* ALLOW_OBCS_NORTH */

# ifdef ALLOW_OBCS_SOUTH
C--   Over all tiles
      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
C-      2D arrays
        DO K=1,Nr
         DO I=1-OLx,sNx+OLx
          StoreOBCSS(I,K,bi,bj,1)  = OBSu(I,K,bi,bj)
          StoreOBCSS(I,K,bi,bj,2)  = OBSv(I,K,bi,bj)
          StoreOBCSS(I,K,bi,bj,3)  = OBSt(I,K,bi,bj)
          StoreOBCSS(I,K,bi,bj,4)  = OBSs(I,K,bi,bj)
#  ifdef ALLOW_OBCS_PRESCRIBE
          StoreOBCSS(I,K,bi,bj,5)  = OBSu0(I,K,bi,bj)
          StoreOBCSS(I,K,bi,bj,6)  = OBSv0(I,K,bi,bj)
          StoreOBCSS(I,K,bi,bj,7)  = OBSt0(I,K,bi,bj)
          StoreOBCSS(I,K,bi,bj,8)  = OBSs0(I,K,bi,bj)
          StoreOBCSS(I,K,bi,bj,9)  = OBSu1(I,K,bi,bj)
          StoreOBCSS(I,K,bi,bj,10) = OBSv1(I,K,bi,bj)
          StoreOBCSS(I,K,bi,bj,11) = OBSt1(I,K,bi,bj)
          StoreOBCSS(I,K,bi,bj,12) = OBSs1(I,K,bi,bj)
#  endif
#  ifdef ALLOW_OBCSS_CONTROL
          StoreOBCSS(I,K,bi,bj,13) = xx_obcss0(I,K,bi,bj,1)
          StoreOBCSS(I,K,bi,bj,14) = xx_obcss0(I,K,bi,bj,2)
          StoreOBCSS(I,K,bi,bj,15) = xx_obcss0(I,K,bi,bj,3)
          StoreOBCSS(I,K,bi,bj,16) = xx_obcss0(I,K,bi,bj,4)
          StoreOBCSS(I,K,bi,bj,17) = xx_obcss1(I,K,bi,bj,1)
          StoreOBCSS(I,K,bi,bj,18) = xx_obcss1(I,K,bi,bj,2)
          StoreOBCSS(I,K,bi,bj,19) = xx_obcss1(I,K,bi,bj,3)
          StoreOBCSS(I,K,bi,bj,20) = xx_obcss1(I,K,bi,bj,4)
#  else
          StoreOBCSS(I,K,bi,bj,13) = 0.0
          StoreOBCSS(I,K,bi,bj,14) = 0.0
          StoreOBCSS(I,K,bi,bj,15) = 0.0
          StoreOBCSS(I,K,bi,bj,16) = 0.0
          StoreOBCSS(I,K,bi,bj,17) = 0.0
          StoreOBCSS(I,K,bi,bj,18) = 0.0
          StoreOBCSS(I,K,bi,bj,19) = 0.0
          StoreOBCSS(I,K,bi,bj,20) = 0.0
#  endif
         ENDDO
        ENDDO
       ENDDO
      ENDDO
# endif /* ALLOW_OBCS_SOUTH */

# ifdef ALLOW_OBCS_EAST
C--   Over all tiles
      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
C-      2D arrays
        DO K=1,Nr
         DO J=1-OLy,sNy+OLy
          StoreOBCSE(J,K,bi,bj,1)  = OBEu(J,K,bi,bj)
          StoreOBCSE(J,K,bi,bj,2)  = OBEv(J,K,bi,bj)
          StoreOBCSE(J,K,bi,bj,3)  = OBEt(J,K,bi,bj)
          StoreOBCSE(J,K,bi,bj,4)  = OBEs(J,K,bi,bj)
#  ifdef ALLOW_OBCS_PRESCRIBE
          StoreOBCSE(J,K,bi,bj,5)  = OBEu0(J,K,bi,bj)
          StoreOBCSE(J,K,bi,bj,6)  = OBEv0(J,K,bi,bj)
          StoreOBCSE(J,K,bi,bj,7)  = OBEt0(J,K,bi,bj)
          StoreOBCSE(J,K,bi,bj,8)  = OBEs0(J,K,bi,bj)
          StoreOBCSE(J,K,bi,bj,9)  = OBEu1(J,K,bi,bj)
          StoreOBCSE(J,K,bi,bj,10) = OBEv1(J,K,bi,bj)
          StoreOBCSE(J,K,bi,bj,11) = OBEt1(J,K,bi,bj)
          StoreOBCSE(J,K,bi,bj,12) = OBEs1(J,K,bi,bj)
#  endif
#  ifdef ALLOW_OBCSE_CONTROL
          StoreOBCSE(J,K,bi,bj,13) = xx_obcse0(J,K,bi,bj,1)
          StoreOBCSE(J,K,bi,bj,14) = xx_obcse0(J,K,bi,bj,2)
          StoreOBCSE(J,K,bi,bj,15) = xx_obcse0(J,K,bi,bj,3)
          StoreOBCSE(J,K,bi,bj,16) = xx_obcse0(J,K,bi,bj,4)
          StoreOBCSE(J,K,bi,bj,17) = xx_obcse1(J,K,bi,bj,1)
          StoreOBCSE(J,K,bi,bj,18) = xx_obcse1(J,K,bi,bj,2)
          StoreOBCSE(J,K,bi,bj,19) = xx_obcse1(J,K,bi,bj,3)
          StoreOBCSE(J,K,bi,bj,20) = xx_obcse1(J,K,bi,bj,4)
#  else
          StoreOBCSE(J,K,bi,bj,13) = 0.0
          StoreOBCSE(J,K,bi,bj,14) = 0.0
          StoreOBCSE(J,K,bi,bj,15) = 0.0
          StoreOBCSE(J,K,bi,bj,16) = 0.0
          StoreOBCSE(J,K,bi,bj,17) = 0.0
          StoreOBCSE(J,K,bi,bj,18) = 0.0
          StoreOBCSE(J,K,bi,bj,19) = 0.0
          StoreOBCSE(J,K,bi,bj,20) = 0.0
#  endif
         ENDDO
        ENDDO
       ENDDO
      ENDDO
# endif /* ALLOW_OBCS_EAST */

# ifdef ALLOW_OBCS_WEST
C--   Over all tiles
      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
C-      2D arrays
        DO K=1,Nr
         DO J=1-OLy,sNy+OLy
          StoreOBCSW(J,K,bi,bj,1)  = OBWu(J,K,bi,bj)
          StoreOBCSW(J,K,bi,bj,2)  = OBWv(J,K,bi,bj)
          StoreOBCSW(J,K,bi,bj,3)  = OBWt(J,K,bi,bj)
          StoreOBCSW(J,K,bi,bj,4)  = OBWs(J,K,bi,bj)
#  ifdef ALLOW_OBCS_PRESCRIBE
          StoreOBCSW(J,K,bi,bj,5)  = OBWu0(J,K,bi,bj)
          StoreOBCSW(J,K,bi,bj,6)  = OBWv0(J,K,bi,bj)
          StoreOBCSW(J,K,bi,bj,7)  = OBWt0(J,K,bi,bj)
          StoreOBCSW(J,K,bi,bj,8)  = OBWs0(J,K,bi,bj)
          StoreOBCSW(J,K,bi,bj,9)  = OBWu1(J,K,bi,bj)
          StoreOBCSW(J,K,bi,bj,10) = OBWv1(J,K,bi,bj)
          StoreOBCSW(J,K,bi,bj,11) = OBWt1(J,K,bi,bj)
          StoreOBCSW(J,K,bi,bj,12) = OBWs1(J,K,bi,bj)
#  endif
#  ifdef ALLOW_OBCSW_CONTROL
          StoreOBCSW(J,K,bi,bj,13) = xx_obcsw0(J,K,bi,bj,1)
          StoreOBCSW(J,K,bi,bj,14) = xx_obcsw0(J,K,bi,bj,2)
          StoreOBCSW(J,K,bi,bj,15) = xx_obcsw0(J,K,bi,bj,3)
          StoreOBCSW(J,K,bi,bj,16) = xx_obcsw0(J,K,bi,bj,4)
          StoreOBCSW(J,K,bi,bj,17) = xx_obcsw1(J,K,bi,bj,1)
          StoreOBCSW(J,K,bi,bj,18) = xx_obcsw1(J,K,bi,bj,2)
          StoreOBCSW(J,K,bi,bj,19) = xx_obcsw1(J,K,bi,bj,3)
          StoreOBCSW(J,K,bi,bj,20) = xx_obcsw1(J,K,bi,bj,4)
#  else
          StoreOBCSW(J,K,bi,bj,13) = 0.0
          StoreOBCSW(J,K,bi,bj,14) = 0.0
          StoreOBCSW(J,K,bi,bj,15) = 0.0
          StoreOBCSW(J,K,bi,bj,16) = 0.0
          StoreOBCSW(J,K,bi,bj,17) = 0.0
          StoreOBCSW(J,K,bi,bj,18) = 0.0
          StoreOBCSW(J,K,bi,bj,19) = 0.0
          StoreOBCSW(J,K,bi,bj,20) = 0.0
#  endif
         ENDDO
        ENDDO
       ENDDO
      ENDDO
# endif /* ALLOW_OBCS_WEST */
#endif /* ALLOW_OBCS & AUTODIFF_USE_STORE_RESTORE_OBCS */

#ifdef ALLOW_DEBUG
      IF ( debugMode ) CALL DEBUG_LEAVE('AUTODIFF_STORE',myThid)
#endif

#endif /* ALLOW_AUTODIFF_TAMC */
C**************************************

      RETURN
      END

#include "MYPACKAGE_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C !ROUTINE: MYPACKAGE_DIAGNOSTICS_STATE

C !INTERFACE:
      SUBROUTINE MYPACKAGE_DIAGNOSTICS_STATE(
     I                     myTime, myIter, myThid )

C     !DESCRIPTION:
C     Fill-in diagnostics array for MYPACKAGE state variables

C     !USES:
      IMPLICIT NONE
C     == Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
C  put following include within #ifdef in case this file is copied to local
C  code dir but pkg/mypackage is not compiled (missing file MYPACKAGE.h).
#ifdef ALLOW_MYPACKAGE
#include "MYPACKAGE.h"
#endif

C     !INPUT PARAMETERS:
C     myTime   :: Current time of simulation ( s )
C     myIter   :: Current iteration number in simulation
C     myThid   :: my Thread Id number
      _RL     myTime
      INTEGER myIter, myThid
CEOP

#ifdef ALLOW_MYPACKAGE
C     !LOCAL VARIABLES:

#ifdef ALLOW_DIAGNOSTICS
      IF ( useDiagnostics ) THEN

#ifdef MYPACKAGE_3D_STATE
         CALL DIAGNOSTICS_FILL( mypa_StatScal1,'MYPaSta1',
     &                          0,Nr, 0, 1, 1, myThid )
         CALL DIAGNOSTICS_FILL( mypa_StatScal2,'MYPaSta2',
     &                          0,Nr, 0, 1, 1, myThid )
         CALL DIAGNOSTICS_FILL( mypa_StatVelU, 'MYPaStaU',
     &                          0,Nr, 0, 1, 1, myThid )
         CALL DIAGNOSTICS_FILL( mypa_StatVelV, 'MYPaStaV',
     &                          0,Nr, 0, 1, 1, myThid )
#endif /* MYPACKAGE_3D_STATE */

#ifdef MYPACKAGE_2D_STATE
         CALL DIAGNOSTICS_FILL( mypa_Surf1 ,   'MYPaSur1',
     &                          0, 1, 0, 1, 1, myThid )
         CALL DIAGNOSTICS_FILL( mypa_Surf2 ,   'MYPaSur2',
     &                          0, 1, 0, 1, 1, myThid )
#endif /* MYPACKAGE_2D_STATE */

      ENDIF
#endif /* ALLOW_DIAGNOSTICS */

#endif /* ALLOW_MYPACKAGE */

      RETURN
      END

#     include "GAD_OPTIONS.h"

      SUBROUTINE GAD_PQM_FLX_X(bi,bj,kk,iy,
     &           calc_CFL,delT,uvel,
     &           ufac,fhat,flux,myThid)
C     |================================================================|
C     | PQM_FLX_X: evaluate PQM flux on grid-cell edges.               |
C     |================================================================|

          implicit none

C     =============================================== global variables
#         include "SIZE.h"
#         include "GRID.h"
#         include "GAD.h"

C     ================================================================
C       bi,bj     :: tile indexing.
C       kk        :: r-index.
C       iy        :: y-index.
C       calc_CFL  :: TRUE to calc. CFL from vel.
C       delT      :: time-step.
C       uvel      :: vel.-comp in x-direction.
C       ufac      :: vel.-flux in x-direction.
C       fhat      :: row of poly. coeff.
C       flux      :: adv.-flux in x-direction.
C       myThid    :: thread number.
C     ================================================================
          integer bi,bj,kk,iy
          logical calc_CFL
          _RL delT
          _RL uvel(1-OLx:sNx+OLx,
     &             1-OLy:sNy+OLy)
          _RL ufac(1-OLx:sNx+OLx,
     &             1-OLy:sNy+OLy)
          _RL fhat(1:5,
     &             1-OLx:sNx+OLx)
          _RL flux(1-OLx:sNx+OLx,
     &             1-OLy:sNy+OLy)
          integer myThid

C     ================================================================
C       ix        :: x-indexing.
C       uCFL      :: CFL number.
C       intF      :: upwind tracer edge-value.
C       ss11,ss22 :: int. endpoints.
C       ivec      :: int. basis vec.
C     ================================================================
          integer ix
          _RL uCFL,intF
          _RL ss11,ss22
          _RL ivec(1:5)

C     ================================================================
C       (1): calc. "departure-points" for each grid-cell edge by int-
C            egrating edge position backward in time over one single
C            time-step. This is a "single-cell" implementation: requ-
C            ires CFL <= 1.0.
C       (2): calc. flux as the integral of the upwind grid-cell poly-
C            nomial over the deformation interval found in (1).
C     ================================================================

          do  ix = 1-OLx+4, sNx+OLx-3

              if (uvel(ix,iy) .eq. 0. _d 0) then

                  flux(ix,iy)    = 0. _d 0

              else

              if (uvel(ix,iy) .gt. 0. _d 0) then

C     ==================== integrate PQM profile over upwind cell IX-1
              if ( calc_CFL ) then
              uCFL = uvel(ix,iy) * delT
     &             * recip_dxF(ix-1,iy,bi,bj)
     &             * recip_deepFacC(kk)
              else
              uCFL = uvel(ix,iy)
              end if

              ss11 = +1. _d 0 - 2. _d 0 * uCFL
              ss22 = +1. _d 0

C     ==================== integrate profile over region swept by face
              ivec(1) = ss22 - ss11
              ivec(2) =(ss22 ** 2
     &                - ss11 ** 2)*(1. _d 0 / 2. _d 0)
              ivec(3) =(ss22 ** 3
     &                - ss11 ** 3)*(1. _d 0 / 3. _d 0)
              ivec(4) =(ss22 ** 4
     &                - ss11 ** 4)*(1. _d 0 / 4. _d 0)
              ivec(5) =(ss22 ** 5
     &                - ss11 ** 5)*(1. _d 0 / 5. _d 0)

              intF = ivec(1) * fhat(1,ix-1)
     &             + ivec(2) * fhat(2,ix-1)
     &             + ivec(3) * fhat(3,ix-1)
     &             + ivec(4) * fhat(4,ix-1)
     &             + ivec(5) * fhat(5,ix-1)

CML              intF = intF / (ss22 - ss11)

              else

C     ==================== integrate PQM profile over upwind cell IX+0
              if ( calc_CFL ) then
              uCFL = uvel(ix,iy) * delT
     &             * recip_dxF(ix-0,iy,bi,bj)
     &             * recip_deepFacC(kk)
              else
              uCFL = uvel(ix,iy)
              end if

              ss11 = -1. _d 0 - 2. _d 0 * uCFL
              ss22 = -1. _d 0

C     ==================== integrate profile over region swept by face
              ivec(1) = ss22 - ss11
              ivec(2) =(ss22 ** 2
     &                - ss11 ** 2)*(1. _d 0 / 2. _d 0)
              ivec(3) =(ss22 ** 3
     &                - ss11 ** 3)*(1. _d 0 / 3. _d 0)
              ivec(4) =(ss22 ** 4
     &                - ss11 ** 4)*(1. _d 0 / 4. _d 0)
              ivec(5) =(ss22 ** 5
     &                - ss11 ** 5)*(1. _d 0 / 5. _d 0)

              intF = ivec(1) * fhat(1,ix-0)
     &             + ivec(2) * fhat(2,ix-0)
     &             + ivec(3) * fhat(3,ix-0)
     &             + ivec(4) * fhat(4,ix-0)
     &             + ivec(5) * fhat(5,ix-0)

CML              intF = intF / (ss22 - ss11)

              end if

c             intF = 0.5 _d 0 * intF / uCFL
C-    to avoid potential underflow:
              intF = 0.5 _d 0 * intF / sign(max(abs(uCFL),1.d-20),uCFL)

C     ==================== calc. flux = upwind tracer * face-transport
              flux(ix,iy) = + ufac(ix,iy) * intF

              end if

          end do

          return

c     end subroutine GAD_PQM_FLX_X
      end

c ----------------------------------------------------------------
c --- ctrl_cost_gen2d
c --- ctrl_cost_gen3d
c ----------------------------------------------------------------

#include "CTRL_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: ctrl_cost_gen2d
C     !INTERFACE:
      subroutine ctrl_cost_gen2d(
     I                       startrec,
     I                       endrec,
     I                       xx_gen_file,
     I                       xx_gen_dummy,
     I                       xx_gen_period,
     I                       xx_gen_weight,
     I                       dodimensionalcost,
     O                       num_gen_anom,
     O                       objf_gen_anom,
     I                       xx_gen_mask2D,
     I                       myThid )

C     !DESCRIPTION: \bv
C     Generic routine for all 2D control penalty terms
C     \ev

      implicit none

c     == global variables ==

#include "EEPARAMS.h"
#include "SIZE.h"
#include "PARAMS.h"
#include "GRID.h"

#ifdef ALLOW_CTRL
# include "CTRL_SIZE.h"
# include "CTRL.h"
# include "OPTIMCYCLE.h"
#endif

c     == routine arguments ==

      integer startrec
      integer endrec
      character*(MAX_LEN_FNAM) xx_gen_file
      _RL xx_gen_dummy
      _RL xx_gen_period
      _RL xx_gen_weight(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      logical dodimensionalcost
      _RL num_gen_anom(nSx,nSy)
      _RL objf_gen_anom(nSx,nSy)
      _RS xx_gen_mask2D(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      integer myThid

#ifdef ALLOW_CTRL

c     == local variables ==

      integer bi,bj
      integer i, j
      integer itlo,ithi
      integer jtlo,jthi
      integer jmin,jmax
      integer imin,imax
      integer nrec
      integer irec
      integer ilfld,ilDir

      _RL fctile
      _RL tmpx
      _RL lengthscale

      _RL tmpfld2d(1-OLx:sNx+OLx,1-OLy:sNy+OLy,   nSx,nSy)

      logical doglobalread
      logical ladinit

      character*(MAX_LEN_FNAM) fnamefld

c     == external functions ==

      integer  ilnblnk
      external ilnblnk

CEOP

      jtlo = myByLo(myThid)
      jthi = myByHi(myThid)
      itlo = myBxLo(myThid)
      ithi = myBxHi(myThid)
      jmin = 1
      jmax = sNy
      imin = 1
      imax = sNx

      lengthscale = 1. _d 0

c--   Read state record from global file.
      doglobalread = .false.
      ladinit      = .false.

c--   Number of records to be used.
      nrec = endrec-startrec+1

c--   Find ctrlDir length
      ilDir=ilnblnk( ctrlDir )

      do bj = jtlo,jthi
       do bi = itlo,ithi
        do j = 1-OLy,sNy+OLy
         do i = 1-OLx,sNx+OLx
          tmpfld2d(i,j,bi,bj) = 0. _d 0
         enddo
        enddo
       enddo
      enddo

      if (optimcycle .ge. 0) then
        ilfld=ilnblnk( xx_gen_file )
        write(fnamefld,'(2a,i10.10)')
     &       ctrlDir(1:ilDir)//xx_gen_file(1:ilfld),'.',optimcycle
      endif

c--   >>> Loop 1 to compute mean forcing:
      do bj = jtlo,jthi
        do bi = itlo,ithi
          num_gen_anom(bi,bj)  = 0. _d 0
          objf_gen_anom(bi,bj) = 0. _d 0
        enddo
      enddo

c--   >>> Loop over records.
      do irec = startrec,endrec

#ifdef ALLOW_AUTODIFF
        call active_read_xy(
     &        fnamefld, tmpfld2d, irec, doglobalread,
     &        ladinit, optimcycle, myThid, xx_gen_dummy )
#else
        CALL READ_REC_XY_RL( fnamefld, tmpfld2d, iRec, 1, myThid )
#endif

c--     Loop over this thread tiles.
        do bj = jtlo,jthi
          do bi = itlo,ithi

c--         Determine the weights to be used.
            fctile = 0. _d 0
            do j = jmin,jmax
              do i = imin,imax
                if (xx_gen_mask2D(i,j,bi,bj) .ne. 0. _d 0) then

                tmpx = tmpfld2d(i,j,bi,bj)
                IF ( dodimensionalcost ) THEN
                  fctile = fctile + xx_gen_weight(i,j,bi,bj)*tmpx*tmpx
                ELSE
                  fctile = fctile + tmpx*tmpx
                ENDIF
                if ( xx_gen_weight(i,j,bi,bj) .ne. 0. _d 0 )
     &            num_gen_anom(bi,bj) = num_gen_anom(bi,bj)
     &            + 1. _d 0
                endif

              enddo
            enddo

            objf_gen_anom(bi,bj) = objf_gen_anom(bi,bj) + fctile

          enddo
        enddo

c--   End of loop over records.
      enddo

#endif /* ALLOW_CTRL */

      return
      end

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: ctrl_cost_gen3d
C     !INTERFACE:
      subroutine ctrl_cost_gen3d(
     I                       xx_gen_file,
     I                       xx_gen_dummy,
     I                       xx_gen_weight,
     I                       dodimensionalcost,
     O                       num_gen,
     O                       objf_gen,
     I                       xx_gen_mask,
     I                       myThid )

C     !DESCRIPTION: \bv
C     Generic routine for all 3D control penalty terms
C     \ev

      implicit none

c     == global variables ==

#include "EEPARAMS.h"
#include "SIZE.h"
#include "PARAMS.h"
#include "GRID.h"

#ifdef ALLOW_CTRL
# include "CTRL_SIZE.h"
# include "CTRL.h"
# include "OPTIMCYCLE.h"
#endif

c     == routine arguments ==

      character*(MAX_LEN_FNAM) xx_gen_file
      _RL xx_gen_dummy
      _RL xx_gen_weight(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      logical dodimensionalcost
      _RL num_gen(nSx,nSy)
      _RL objf_gen(nSx,nSy)
      _RS xx_gen_mask(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      INTEGER myThid

#ifdef ALLOW_CTRL

c     == local variables ==

      integer bi,bj
      integer i,j,k
      integer itlo,ithi
      integer jtlo,jthi
      integer jmin,jmax
      integer imin,imax
      integer irec
      integer ilfld,ilDir

      _RL tmpx

      logical doglobalread
      logical ladinit
      _RL     tmpfld3d(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)

      character*(MAX_LEN_FNAM) fnamefld

c     == external functions ==

      integer  ilnblnk
      external ilnblnk

CEOP

      jtlo = myByLo(myThid)
      jthi = myByHi(myThid)
      itlo = myBxLo(myThid)
      ithi = myBxHi(myThid)
      jmin = 1
      jmax = sNy
      imin = 1
      imax = sNx

c--   Read state record from global file.
      doglobalread = .false.
      ladinit      = .false.

c--   Find ctrlDir length
      ilDir=ilnblnk( ctrlDir )

      do bj = jtlo,jthi
       do bi = itlo,ithi
        do k = 1,Nr
         do j = 1-OLy,sNy+OLy
          do i = 1-OLx,sNx+OLx
           tmpfld3d(i,j,k,bi,bj) = 0. _d 0
          enddo
         enddo
        enddo
       enddo
      enddo

      if (optimcycle .ge. 0) then
        ilfld = ilnblnk( xx_gen_file )
        write(fnamefld,'(2a,i10.10)')
     &       ctrlDir(1:ilDir)//xx_gen_file(1:ilfld),'.',optimcycle
      endif

c--   >>> Loop 1 to compute mean forcing:
      do bj = jtlo,jthi
        do bi = itlo,ithi
          num_gen(bi,bj)  = 0. _d 0
          objf_gen(bi,bj) = 0. _d 0
        enddo
      enddo

      irec = 1

#ifdef ALLOW_AUTODIFF
      call active_read_xyz(
     &      fnamefld, tmpfld3d, irec, doglobalread,
     &      ladinit, optimcycle, myThid, xx_gen_dummy )
#else
      CALL READ_REC_XYZ_RL( fnamefld, tmpfld3d, iRec, 1, myThid )
#endif

c--   Loop over this thread tiles.
      do bj = jtlo,jthi
        do bi = itlo,ithi

          num_gen(bi,bj)  = 0. _d 0
          objf_gen(bi,bj) = 0. _d 0

          do k = 1,Nr
            do j = jmin,jmax
              do i = imin,imax
                if (xx_gen_mask(i,j,k,bi,bj) .ne. 0. _d 0) then
                  tmpx = tmpfld3d(i,j,k,bi,bj)
                IF ( dodimensionalcost ) THEN
                  objf_gen(bi,bj) = objf_gen(bi,bj)
     &                 + xx_gen_weight(i,j,k,bi,bj)
     &                 *tmpx*tmpx
                ELSE
                  objf_gen(bi,bj) = objf_gen(bi,bj) + tmpx*tmpx
                ENDIF
                if ( xx_gen_weight(i,j,k,bi,bj) .ne. 0. _d 0 )
     &            num_gen(bi,bj) = num_gen(bi,bj) + 1. _d 0
                endif
              enddo
            enddo
          enddo

        enddo
      enddo

#endif /* ALLOW_CTRL */

      return
      end

#include "RW_OPTIONS.h"

      SUBROUTINE WRITE_FLD_XYZ_RL( pref,suff,field,myIter,myThid )
C WRITE_FLD_XYZ_RL is a "front-end" interface to the low-level I/O
C routines. It assumes single record files.
      IMPLICIT NONE
C Global
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
C Arguments
      CHARACTER*(*) pref,suff
      _RL field(1-Olx:sNx+Olx,1-Oly:sNy+Oly,Nr,nSx,nSy)
      INTEGER myIter
      INTEGER myThid
C Functions
      INTEGER ILNBLNK,IFNBLNK
C Common
      COMMON /RD_WR_FLD/ globalFile
      LOGICAL globalFile
C Local
      LOGICAL useCurrentDir
      _RS dummyRS(1)
      CHARACTER*(2) fType
      INTEGER nNz
      INTEGER iRec
      INTEGER s1Lo,s1Hi,s2Lo,s2Hi
      CHARACTER*(MAX_LEN_FNAM) fullName
C
C--   Build file name
C     Name has form 'prefix.suffix'
C     e.g. U.0000000100
      s1Lo = IFNBLNK(pref)
      s1Hi = ILNBLNK(pref)
      IF ( suff .EQ. ' ' ) THEN
       WRITE( fullName, '(A)' ) pref(s1Lo:s1Hi)
      ELSEIF ( suff .EQ. 'I10' ) THEN
       WRITE( fullName, '(A,A,I10.10)' ) pref(s1Lo:s1Hi),'.',myIter
      ELSE
       s2Lo = IFNBLNK(suff)
       s2Hi = ILNBLNK(suff)
       WRITE( fullName, '(A,A)' ) pref(s1Lo:s1Hi),suff(s2Lo:s2Hi)
      ENDIF
C
      useCurrentDir = .FALSE.
      fType='RL'
      nNz=Nr
      iRec=1
#ifdef ALLOW_MDSIO
      CALL MDS_WRITE_FIELD(
     I                      fullName, writeBinaryPrec,
     I                      globalFile, useCurrentDir,
     I                      fType, nNz, 1, nNz, field, dummyRS,
     I                      iRec, myIter, myThid )
#endif
      RETURN
      END

#include "CTRL_OPTIONS.h"
#ifdef ALLOW_EXF
# include "EXF_OPTIONS.h"
#endif

C--   File ctrl_get_mask.F:
C--    Contents:
C--    o CTRL_GET_MASK3D
C--    o CTRL_GET_MASK2D

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

CBOP
C     !ROUTINE: CTRL_GET_MASK3D
C     !INTERFACE:
      SUBROUTINE CTRL_GET_MASK3D(
     I      xx_filename,
     U      mask3D,
     I      myThid )

C     !DESCRIPTION: \bv
C     *=================================================================
C     | SUBROUTINE CTRL_GET_MASK3D
C     | o A simple routine to return the correct 3D mask for each ctrl
C     |   variable
C     | o Only important for a few cases: e.g.
C     |   - uvel/vvel need maskW/S rather than maskC
C     |   - in shelfice domain, need special 2D masks
C     *=================================================================
C     \ev

C     !USES:
      IMPLICIT NONE

C     == global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"

C     !INPUT/OUTPUT PARAMETERS:
      CHARACTER*(MAX_LEN_FNAM) xx_filename
      _RS mask3D(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      INTEGER myThid

C     !LOCAL VARIABLES:
CEOP

C --- Initial velocity
#if (defined (ALLOW_UVEL0_CONTROL) && defined (ALLOW_VVEL0_CONTROL))
      IF (xx_filename(1:7).EQ.'xx_uvel') THEN
        CALL CTRL_CPRSRS(maskW,Nr,mask3D,Nr,myThid)
      ELSEIF (xx_filename(1:7).EQ.'xx_vvel') THEN
        CALL CTRL_CPRSRS(maskS,Nr,mask3D,Nr,myThid)
      ELSE
#else
      IF (.TRUE.) THEN
#endif
C --- Set to maskC by default
        CALL CTRL_CPRSRS(maskC, Nr, mask3D, Nr, myThid)
      ENDIF

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C     !ROUTINE: CTRL_GET_MASK2D
C     !INTERFACE:
      SUBROUTINE CTRL_GET_MASK2D(
     I      xx_filename,
     U      mask2D,
     I      myThid )

C     !DESCRIPTION: \bv
C     *=================================================================
C     | SUBROUTINE CTRL_GET_MASK2D
C     | o A simple routine to return the correct 2D mask for each ctrl
C     |   variable.
C     | o 2D mask is in XY plane
C     | o Only important for a few cases: e.g.
C     |   - uvel/vvel need maskW/S rather than maskC
C     |   - in shelfice domain, need special 2D masks
C     *=================================================================
C     \ev

C     !USES:
      IMPLICIT NONE

C     == global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#ifdef ALLOW_SHELFICE
# include "SHELFICE.h"
#endif
#ifdef ALLOW_EXF
# include "EXF_PARAM.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
      CHARACTER*(MAX_LEN_FNAM) xx_filename
      _RS mask2D(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      INTEGER myThid

C     !LOCAL VARIABLES:
      LOGICAL iAmDone
CEOP

      iAmDone = .FALSE.

C --- Shelfice
#ifdef ALLOW_SHELFICE
      IF ((xx_filename(1:11).EQ.'xx_shicoeff').OR.
     &    (xx_filename(1:11).EQ.'xx_shicdrag').OR.
     &    (xx_filename(1:11).EQ.'xx_shifwflx')) THEN
        CALL CTRL_CPRSRS(maskSHI, Nr, mask2D, 1, myThid)
        iAmDone = .TRUE.
      ENDIF
#endif

C --- Wind stress. Wind speed always uses maskC
#ifndef ALLOW_ROTATE_UV_CONTROLS
# ifdef ALLOW_EXF
      IF (stressIsOnCgrid) THEN
# endif
        IF (xx_filename(1:7).EQ.'xx_tauu') THEN
          CALL CTRL_CPRSRS(maskW, Nr, mask2D, 1, myThid)
          iAmDone = .TRUE.
        ELSEIF (xx_filename(1:7).EQ.'xx_tauv') THEN
          CALL CTRL_CPRSRS(maskS, Nr, mask2D, 1, myThid)
          iAmDone = .TRUE.
        ENDIF
# ifdef ALLOW_EXF
      ENDIF
# endif
#endif

C --- Set to maskC by default, if not set
      IF (.NOT.iAmDone) CALL CTRL_CPRSRS(maskC, Nr, mask2D, 1, myThid)

      RETURN
      END

#include "CPP_EEOPTIONS.h"
CBOP

C     !ROUTINE: MEMSYNC

C     !INTERFACE:
      SUBROUTINE MEMSYNC
      IMPLICIT NONE

C     !DESCRIPTION:
C     *==========================================================*
C     | SUBROUTINE MEMSYNC                                        
C     | o Place holder for memory sync routine                    
C     *==========================================================*
C     | This routine is called wherever the code requires         
C     | that writes performed by one thread or process must       
C     | be guaranteed visible to other processes and or threads.  
C     |  On SPARC this routine would implement a                  
C     |  asm("membar \#LoadStore|\#StoreStore");                    
C     |  On ALPHA                                                 
C     |  asm("mb");                                               
C     |  Note: I have yet to show this is necessary although      
C     |        the Memory Channel writes must need something like 
C     |        this.                                              
C     *==========================================================*
CEOP

      END

#include "SMOOTH_OPTIONS.h"

      SUBROUTINE SMOOTH_INIT_FIXED( myThid )

C     *==========================================================*
C     | SUBROUTINE smooth_init_fixed
C     | o Routine that initializes smoothing/correlation operators
C     *==========================================================*

      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "SMOOTH.h"

      INTEGER myThid

      INTEGER smoothOpNb
      INTEGER i, j, k, bi, bj

      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        DO k=1,Nr
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           smooth_recip_hFacC(i,j,k,bi,bj) = _recip_hFacC(i,j,k,bi,bj)
           smooth_hFacW(i,j,k,bi,bj) = _hFacW(i,j,k,bi,bj)
           smooth_hFacS(i,j,k,bi,bj) = _hFacS(i,j,k,bi,bj)
          ENDDO
         ENDDO
        ENDDO
       ENDDO
      ENDDO

      DO smoothOpNb=1,smoothOpNbMax
       IF (smooth2Dtype(smoothOpNb).NE.0) THEN
        CALL smooth_init2D( smoothOpNb, myThid )
       ENDIF
      ENDDO

      DO smoothOpNb=1,smoothOpNbMax
       IF (smooth2Dtype(smoothOpNb).NE.0) THEN
        CALL smooth_filtervar2D( smoothOpNb, myThid )
       ENDIF
      ENDDO

      DO smoothOpNb=1,smoothOpNbMax
       IF ( (smooth3DtypeZ(smoothOpNb).NE.0).OR.
     &      (smooth3DtypeH(smoothOpNb).NE.0) ) THEN
        CALL smooth_init3D( smoothOpNb, myThid )
       ENDIF
      ENDDO

      DO smoothOpNb=1,smoothOpNbMax
       IF ( (smooth3DtypeZ(smoothOpNb).NE.0).OR.
     &      (smooth3DtypeH(smoothOpNb).NE.0) ) THEN
        CALL smooth_filtervar3D( smoothOpNb, myThid )
       ENDIF
      ENDDO

      RETURN
      END

#include "STREAMICE_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

CBOP
      SUBROUTINE STREAMICE_FORCED_BUTTRESS( myThid )
c      O taudx,
c      O taudy )

C     *============================================================*
C     | SUBROUTINE                                                 |
C     | o                                                          |
C     *============================================================*
C     |                                                            |
C     *============================================================*
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "STREAMICE.h"
#include "STREAMICE_CG.h"

C     !INPUT/OUTPUT ARGUMENTS
      INTEGER myThid
c       _RL taudx (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
c       _RL taudy (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)

#ifdef ALLOW_STREAMICE
#ifdef STREAMICE_STRESS_BOUNDARY_CONTROL

C     LOCAL VARIABLES
      INTEGER i, j, bi, bj, k
      _RL unconf_stress, i_rhow
      _RL avg_density
     & (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
#ifdef STREAMICE_FIRN_CORRECTION
      _RL firn_depth, h
#endif

      i_rhow = 1./streamice_density_ocean_avg
#ifdef STREAMICE_FIRN_CORRECTION
      firn_depth = streamice_density *
     &    streamice_firn_correction
     & / (streamice_density-streamice_density_firn)
#endif /* STREAMICE_FIRN_CORRECTION */

      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
        DO j=1-OLy+1,sNy+OLy-1
         DO i=1-OLx+1,sNx+OLx-1
#ifdef STREAMICE_FIRN_CORRECTION
          if (STREAMICE_apply_firn_correction) then
           if (streamice_hmask(i,j,bi,bj).eq.1) then
            h = h_streamice(i,j,bi,bj)
            if (h.lt.firn_depth) then
             avg_density(i,j,bi,bj) = streamice_density_firn
            else
             avg_density(i,j,bi,bj) = streamice_density *
     &        (h - streamice_firn_correction) / h
            endif
           endif
          else
#endif /* STREAMICE_FIRN_CORRECTION */
           avg_density(i,j,bi,bj) = streamice_density
#ifdef STREAMICE_FIRN_CORRECTION
          endif
#endif /* STREAMICE_FIRN_CORRECTION */
         ENDDO
        ENDDO
       ENDDO
      ENDDO

      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
        DO j=1-OLy+1,sNy+OLy-1
         DO i=1-OLy+1,sNx+OLy-1
c         taudx_SI(i,j,bi,bj) = 0. _d 0
c         taudy_SI(i,j,bi,bj) = 0. _d 0
          IF (streamice_hmask(i,j,bi,bj).eq.1.0) THEN

            ! baseline unconfined stress

            IF (float_frac_streamice(i,j,bi,bj) .eq. 1.0) THEN

              unconf_stress = gravity *
     &         (avg_density(i,j,bi,bj) * H_streamice(i,j,bi,bj)**2 -
#ifdef USE_ALT_RLOW
     &          streamice_density_ocean_avg * R_low_si(i,j,bi,bj)**2)
#else
     &          streamice_density_ocean_avg * R_low(i,j,bi,bj)**2)
#endif

            ELSE

#ifdef STREAMICE_FIRN_CORRECTION
             if (STREAMICE_apply_firn_correction) then

              if (H_streamice(i,j,bi,bj).lt.firn_depth) then
               unconf_stress =
     &          streamice_density_firn * gravity *
     &          (1-streamice_density_firn*i_rhow) *
     &          H_streamice(i,j,bi,bj)**2
              else
               unconf_stress = gravity * (
     &          streamice_density_firn * firn_depth**2 +
     &          (h_streamice(i,j,bi,bj)-firn_depth) *
     &           (streamice_density_firn*firn_depth+streamice_density*
     &           (h_streamice(i,j,bi,bj)-streamice_firn_correction)) -
     &          streamice_density**2*i_rhow*
     &           (h_streamice(i,j,bi,bj)-streamice_firn_correction)**2
     &          )
              endif

             else
#endif /* STREAMICE_FIRN_CORRECTION */

              unconf_stress = streamice_density * gravity *
     &         (1-streamice_density/streamice_density_ocean_avg) *
     &          H_streamice(i,j,bi,bj)**2

#ifdef STREAMICE_FIRN_CORRECTION
             endif
#endif /* STREAMICE_FIRN_CORRECTION */

            ENDIF

            ! right face

            if (streamice_ufacemask(i+1,j,bi,bj).eq.2.0) then

             do k=0,1
              if (streamice_umask(i+1,j+k,bi,bj).eq.1.0) then

c               if ((j+k).eq.10) then
c                print *, "GOT HERE 1", unconf_stress,
c     &               taudx_SI(i+1,j+k,bi,bj)
c               endif

               taudx_SI(i+1,j+k,bi,bj) = taudx_SI(i+1,j+k,bi,bj) +
     &          (streamice_u_normal_pert(i+1,j,bi,bj)  +
     &           streamice_u_normal_stress(i+1,j,bi,bj)) *
     &          .5 * unconf_stress * dyG(i+1,j,bi,bj)

               taudy_SI(i+1,j+k,bi,bj) = taudy_SI(i+1,j+k,bi,bj) +
     &         (streamice_v_shear_pert(i+1,j,bi,bj) +
     &          streamice_v_shear_stress(i+1,j,bi,bj)) *
     &          .5 * unconf_stress * dyG(i+1,j,bi,bj)

c               if ((j+k).eq.10) then
c                print *, "GOT HERE 1", taudx_SI(i+1,j+k,bi,bj)
c               endif

              endif
             enddo
            endif

            ! left face

            if (streamice_ufacemask(i,j,bi,bj).eq.2.0) then

             do k=0,1
              if (streamice_umask(i,j+k,bi,bj).eq.1.0) then

               taudx_SI(i,j+k,bi,bj) = taudx_SI(i,j+k,bi,bj) -
     &         (streamice_u_normal_pert(i,j,bi,bj) +
     &          streamice_u_normal_stress(i,j,bi,bj)) *
     &          .5 * unconf_stress * dyG(i,j,bi,bj)

               taudy_SI(i,j+k,bi,bj) = taudy_SI(i,j+k,bi,bj) -
     &         (streamice_v_shear_pert(i,j,bi,bj) +
     &          streamice_v_shear_stress(i,j,bi,bj)) *
     &          .5 * unconf_stress * dyG(i,j,bi,bj)

              endif
             enddo
            endif

            if (streamice_vfacemask(i,j+1,bi,bj).eq.2.0) then

             do k=0,1
              if (streamice_umask(i+k,j+1,bi,bj).eq.1.0) then

               taudy_SI(i+k,j+1,bi,bj) = taudy_SI(i+k,j+1,bi,bj) +
     &         (streamice_v_normal_pert(i,j+1,bi,bj) +
     &          streamice_v_normal_stress(i,j+1,bi,bj)) *
     &           .5 * dxG(i,j+1,bi,bj) * unconf_stress

               taudx_SI(i+k,j+1,bi,bj) = taudx_SI(i+k,j+1,bi,bj) +
     &         (streamice_u_shear_pert(i,j+1,bi,bj) +
     &          streamice_u_shear_stress(i,j+1,bi,bj)) *
     &          .5 * unconf_stress * dxG(i,j+1,bi,bj)

              endif
             enddo
            endif

            if (streamice_vfacemask(i,j,bi,bj).eq.2.0) then

             do k=0,1
              if (streamice_umask(i+k,j,bi,bj).eq.1.0) then

               taudy_SI(i+k,j,bi,bj) = taudy_SI(i+k,j,bi,bj) -
     &         (streamice_v_normal_pert(i,j,bi,bj) +
     &          streamice_v_normal_stress(i,j,bi,bj)) *
     &          .5 * dxG(i,j,bi,bj) * unconf_stress

               taudx_SI(i+k,j,bi,bj) = taudx_SI(i+k,j,bi,bj) -
     &         (streamice_u_shear_pert(i,j,bi,bj) +
     &          streamice_u_shear_stress(i,j,bi,bj)) *
     &          .5 * unconf_stress * dxG(i,j,bi,bj)

              endif
             enddo
            endif

          ENDIF
         ENDDO
        ENDDO
       ENDDO
      ENDDO

#endif /* STREAMICE_STRESS_BOUNDARY_CONTROL */
#endif /* ALLOW_STREAMICE */
      RETURN
      END

#include "MYPACKAGE_OPTIONS.h"

CBOP
C !ROUTINE: MYPACKAGE_CALC_RHS

C !INTERFACE: ==========================================================
      SUBROUTINE MYPACKAGE_CALC_RHS(
     I                     myTime, myIter, myThid )

C !DESCRIPTION:
C Calculate custom tendency terms outside k-loop in DO_OCEANIC_PHYS

C !USES: ===============================================================
      IMPLICIT NONE
C     == Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
c#include "PARAMS.h"
C  put following include within #ifdef in case this file is copied to local
C  code dir but pkg/mypackage is not compiled (missing file MYPACKAGE.h).
c#ifdef ALLOW_MYPACKAGE
c# include "MYPACKAGE.h"
c#endif

C !INPUT PARAMETERS: ===================================================
C myTime    :: Current time in simulation
C myIter    :: Current time-step number
C myThid    :: my Thread Id number
      _RL     myTime
      INTEGER myIter, myThid

C !OUTPUT PARAMETERS: ==================================================

#ifdef ALLOW_MYPACKAGE
C !LOCAL VARIABLES: ====================================================
C bi,bj     :: Tile indices
      INTEGER bi, bj
CEOP

C--   Loops on tile indices bi,bj
      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)

C--   Calculate custom tendency terms ...

C--   end bi,bj loops.
       ENDDO
      ENDDO

#endif /* ALLOW_MYPACKAGE */

      RETURN
      END

#include "MDSIO_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: MDS_CHECK4FILE

C     !INTERFACE:
      SUBROUTINE MDS_CHECK4FILE(
     I                           filePfx, fileSfx, prtID,
     O                           fileName, fileExist,
     I                           useCurrentDir,
     I                           myThid )

C     !DESCRIPTION:
C     Check if file exist :
C     1rst check prefix alone, then prefix+suffix ; then prefix.tileNb+suffix

C     !USES:
      IMPLICIT NONE
C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C useCurrentDir :: always search for file in the current directory
C                  (even if "mdsioLocalDir" is set)
C     filePfx   :: file name prefix
C     fileSfx   :: file name suffix
C     prtID     :: print Identificator (in case file is not found)
C     fileName  :: file which has been found
C     fileExist :: True when file has been found
C     myThid    :: my Thread Id number
      LOGICAL useCurrentDir
      CHARACTER*(*) filePfx, fileSfx, prtID
      CHARACTER*(*) fileName
      LOGICAL fileExist
      INTEGER myThid

C     !FUNCTIONS:
      INTEGER  IFNBLNK, ILNBLNK
      EXTERNAL IFNBLNK, ILNBLNK

C     !LOCAL VARIABLES:
C     == Local variables in common block ==
      LOGICAL shareExist
      COMMON / LOCAL_MDS_CHECK4FILE / shareExist
C     == Local variables ==
      CHARACTER*(MAX_LEN_MBUF) msgBuf, msgPfx
      INTEGER iG, jG
      INTEGER lp, ip, is, iL, i, ioUnit
CEOP

      ioUnit = errorMessageUnit
      fileName = ' '

C--   First check if fileName is long enough
      lp = ILNBLNK( mdsioLocalDir )
      IF ( useCurrentDir ) lp = 0
      ip = ILNBLNK(filePfx)
      is = ILNBLNK(fileSfx)
      IF ( ip.EQ.0 ) is = 0
       i  = LEN(fileName)
      IF ( i .LT. lp+ip+is+8 ) THEN
        WRITE(msgBuf,'(A,I6,A,I6)')
     &    'MDS_CHECK4FILE: file name length=', i,
     &    ' too small <', lp+ip+is+8
        CALL PRINT_ERROR( msgBuf, myThid )
        STOP 'ABNORMAL END: S/R MDS_CHECK4FILE'
      ENDIF

      _BARRIER
      _BEGIN_MASTER( myThid )

C--   Check if file with various suffix exist
      fileExist = .FALSE.
      IF ( .NOT.fileExist .AND. ip.GE.1 ) THEN
C-    look for file = {filePfx}
        WRITE(fileName,'(A)') filePfx(1:ip)
        INQUIRE( FILE=fileName, EXIST=fileExist )
      ENDIF
      IF ( .NOT.fileExist .AND. is.GE.1 ) THEN
C-    look for file = {filePfx}{fileSfx}
        WRITE(fileName,'(2A)') filePfx(1:ip), fileSfx(1:is)
        INQUIRE( FILE=fileName, EXIST=fileExist )
      ENDIF
      IF ( .NOT.fileExist .AND. is.GE.1 ) THEN
C-    look for file = {filePfx}'.{iG}.{jG}'{fileSfx}
        iG = 1+(myXGlobalLo-1)/sNx
        jG = 1+(myYGlobalLo-1)/sNy
        IF ( lp.EQ.0 ) THEN
          WRITE(fileName,'(2A,I3.3,A,I3.3,A)')
     &                  filePfx(1:ip), '.', iG, '.', jG, fileSfx(1:is)
        ELSE
          WRITE(fileName,'(3A,I3.3,A,I3.3,A)') mdsioLocalDir(1:lp),
     &                  filePfx(1:ip), '.', iG, '.', jG, fileSfx(1:is)
        ENDIF
        INQUIRE( FILE=fileName, EXIST=fileExist )
      ENDIF
      IF ( .NOT.fileExist .AND. is.GE.1 ) THEN
C-    look for file = {filePfx}'.001.001'{fileSfx}
        IF ( lp.EQ.0 ) THEN
          WRITE(fileName,'(3A)')
     &                  filePfx(1:ip), '.001.001', fileSfx(1:is)
        ELSE
          WRITE(fileName,'(4A)') mdsioLocalDir(1:lp),
     &                  filePfx(1:ip), '.001.001', fileSfx(1:is)
        ENDIF
        INQUIRE( FILE=fileName, EXIST=fileExist )
      ENDIF

      IF ( .NOT.fileExist ) THEN
        ip = MAX(ILNBLNK(filePfx),1)
        is = MAX(is,1)
        i  = MAX(ILNBLNK(fileName),1)
        iL = ILNBLNK(prtID)
        IF ( iL.GE.1 ) THEN
          WRITE(msgPfx,'(2A)') 'WARNING >> ',prtID(1:iL)
        ELSE
          WRITE(msgPfx,'(2A)') 'WARNING >> MDS_CHECK4FILE'
        ENDIF
        iL = ILNBLNK(msgPfx)
        WRITE(msgBuf,'(7A)') msgPfx(1:iL), ': file: ',
     &       filePfx(1:ip), ' , ', fileSfx(1:is), ' , ', fileName(1:i)
        CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
        WRITE(msgBuf,'(2A)') msgPfx(1:iL), ': Files DO not exist'
        CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
        fileName = ' '
      ENDIF

      shareExist = fileExist

      _END_MASTER( myThid )
      _BARRIER

      fileExist = shareExist

      RETURN
      END

#include "CPP_EEOPTIONS.h"

CBOP
C     !ROUTINE: STOP_IF_ERROR

C     !INTERFACE:
      SUBROUTINE STOP_IF_ERROR( errFlag, errMsg, myThid )

C     !DESCRIPTION:
C     *==========================================================*
C     | SUBROUTINE STOP_IF_ERROR
C     | o stop every Processes if flag is true
C     *==========================================================*
C     | Presently, gathering of error signal involves a
C     | global_sum which could degrade performance if called too
C     | many times. A potentially faster method (not implemented):
C     | only the proc(s) in error send a non-blocking error signal
C     | to everybody; however, this requires to check for error
C     | signal reception before doing any communication.
C     *==========================================================*

C     !USES:
      IMPLICIT NONE

C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     errFlag :: stop if this logical flag is true
C     errMsg  :: error message to print in case it stops
C     myThid  :: my Thread Id number
      LOGICAL errFlag
      CHARACTER*(*) errMsg
      INTEGER myThid
CEOP

C     !FUNCTIONS
      INTEGER  ILNBLNK
      EXTERNAL ILNBLNK

C     == Local variables ==
C     msgBuf       :: I/O Buffer
C     errCount     :: error counter
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      INTEGER errCount

C--   Collect error from all Threads and Procs
      errCount = 0
      IF ( errFlag ) THEN
        errCount = 1
      ENDIF
      CALL GLOBAL_SUM_INT( errCount, myThid )

      IF ( errCount.GE.1 ) THEN
C--   Print message
        IF ( errFlag ) CALL PRINT_ERROR( errMsg, myThid )
        WRITE(msgBuf,'(A,I5,A)')
     &   'occurs', errCount, ' time(s) among all Threads and Procs'
        CALL PRINT_ERROR( msgBuf, myThid )
C--   Finishes
        CALL ALL_PROC_DIE( myThid )
        STOP 'ABNORMAL END: S/R STOP_IF_ERROR'
      ENDIF

      RETURN
      END

#undef USE_OBSOLETE_MDS_RW_FIELD
#include "MDSIO_OPTIONS.h"

C--  File mdsio_rw_field.F: old version of MDSIO READ/WRITE FIELD S/R with
C    fewer arguments (kept for backward compatibility): call new MDSIO S/R
C    with fixed additional arguments
C--   Contents
C--   o MDSREADFIELD
C--   o MDSREADFIELD_LOC
C--   o MDSWRITEFIELD
C--   o MDSWRITEFIELD_LOC

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      SUBROUTINE MDSREADFIELD(
     I   fName,
     I   filePrec,
     I   arrType,
     I   nNz,
     O   arr,
     I   irecord,
     I   myThid )
C
C Arguments:
C
C fName     (string)  :: base name for file to written
C filePrec  (integer) :: number of bits per word in file (32 or 64)
C arrType   (char(2)) :: declaration of "arr": either "RS" or "RL"
C nNz       (integer) :: size of third dimension: normally either 1 or Nr
C arr       ( RS/RL ) :: array to write, arr(:,:,nNz,:,:)
C irecord   (integer) :: record number to read
C myThid    (integer) :: thread identifier
C
C Routine now calls MDS_READ_FIELD, just a way to add 2 extra arguments
C to the argument list. The 1rst new argument is to make the difference between
C the vertical dimension (3rd dimension) of the output array and the number
C of levels to read in. This routine assumes they are the same.
C The 2nd new argument (useCurrentDir=.FALSE.) allows to read files from
C the "mdsioLocalDir" directory (if it is set).

      IMPLICIT NONE
C Global variables / COMMON blocks
#include "SIZE.h"
c #include "EEPARAMS.h"

C Routine arguments
      CHARACTER*(*) fName
      INTEGER filePrec
      CHARACTER*(2) arrType
      INTEGER nNz
      _RL     arr(*)
      INTEGER irecord
      INTEGER myThid

#ifdef USE_OBSOLETE_MDS_RW_FIELD
C Local variables
      _RL dummyRL(1)
      _RS dummyRS(1)

      IF ( arrType.EQ.'RL' ) THEN
        CALL MDS_READ_FIELD(
     I                fName, filePrec, .FALSE., arrType, nNz, 1, nNz,
     O                arr, dummyRS,
     I                irecord, myThid )
      ELSE
        CALL MDS_READ_FIELD(
     I                fName, filePrec, .FALSE., arrType, nNz, 1, nNz,
     O                dummyRL, arr,
     I                irecord, myThid )
      ENDIF

#else /* USE_OBSOLETE_MDS_RW_FIELD */
      STOP 'ABNORMAL END: S/R MDSREADFIELD is retired'
#endif /* USE_OBSOLETE_MDS_RW_FIELD */

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      SUBROUTINE MDSREADFIELD_LOC(
     I   fName,
     I   filePrec,
     I   arrType,
     I   nNz,
     O   arr,
     I   irecord,
     I   myThid )
C
C Arguments:
C
C fName     (string)  :: base name for file to write
C filePrec  (integer) :: number of bits per word in file (32 or 64)
C arrType   (char(2)) :: declaration of "arr": either "RS" or "RL"
C nNz       (integer) :: size of third dimension: normally either 1 or Nr
C arr       ( RS/RL ) :: array to write, arr(:,:,nNz,:,:)
C irecord   (integer) :: record number to read
C myThid    (integer) :: thread identifier
C
C Routine now calls MDS_READ_FIELD, just a way to add 2 extra arguments
C to the argument list. The 1rst new argument is to make the difference between
C the vertical dimension (3rd dimension) of the output array and the number
C of levels to read in. This routine assumes they are the same.
C The 2nd new argument (useCurrentDir=.FALSE.) forces to ignore the
C "mdsioLocalDir" parameter and to always read from the current directory.

      IMPLICIT NONE
C Global variables / COMMON blocks
#include "SIZE.h"
c #include "EEPARAMS.h"

C Routine arguments
      CHARACTER*(*) fName
      INTEGER filePrec
      CHARACTER*(2) arrType
      INTEGER nNz
      _RL     arr(*)
      INTEGER irecord
      INTEGER myThid

#ifdef USE_OBSOLETE_MDS_RW_FIELD
C Local variables
      _RL dummyRL(1)
      _RS dummyRS(1)

      IF ( arrType.EQ.'RL' ) THEN
        CALL MDS_READ_FIELD(
     I                fName, filePrec, .TRUE., arrType, nNz, 1, nNz,
     O                arr, dummyRS,
     I                irecord, myThid )
      ELSE
        CALL MDS_READ_FIELD(
     I                fName, filePrec, .TRUE., arrType, nNz, 1, nNz,
     O                dummyRL, arr,
     I                irecord, myThid )
      ENDIF

#else /* USE_OBSOLETE_MDS_RW_FIELD */
      STOP 'ABNORMAL END: S/R MDSREADFIELD_LOC is empty'
#endif /* USE_OBSOLETE_MDS_RW_FIELD */

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      SUBROUTINE MDSWRITEFIELD(
     I   fName,
     I   filePrec,
     I   globalFile,
     I   arrType,
     I   nNz,
     I   arr,
     I   irecord,
     I   myIter,
     I   myThid )
C
C Arguments:
C
C fName     (string)  :: base name for file to write
C filePrec  (integer) :: number of bits per word in file (32 or 64)
C globalFile (logical):: selects between writing a global or tiled file
C arrType   (char(2)) :: declaration of "arr": either "RS" or "RL"
C nNz       (integer) :: size of third dimension: normally either 1 or Nr
C arr       ( RS/RL ) :: array to write, arr(:,:,nNzdim,:,:)
C irecord   (integer) :: record number to write
C myIter    (integer) :: time step number
C myThid    (integer) :: thread identifier
C
C Routine now calls MDS_WRITE_FIELD, just a way to add 2 extra arguments
C to the argument list. The 1rst new argument is to make the difference between
C the vertical dimension (3rd dimension) of an array and the number of levels
C the output routine should process. This routine assumes they are the same.
C The 2nd new argument (useCurrentDir=.FALSE.) allows to write files to
C the "mdsioLocalDir" directory (if it is set).

      IMPLICIT NONE
C Global variables / common blocks
#include "SIZE.h"
c #include "EEPARAMS.h"

C Routine arguments
      CHARACTER*(*) fName
      INTEGER filePrec
      LOGICAL globalFile
      CHARACTER*(2) arrType
      INTEGER nNz
      _RL     arr(1-oLx:sNx+oLx,1-oLy:sNy+oLy,nNz,nSx,nSy)
      INTEGER irecord
      INTEGER myIter
      INTEGER myThid

#ifdef USE_OBSOLETE_MDS_RW_FIELD
C Local variables
      _RL dummyRL(1)
      _RS dummyRS(1)

      IF ( arrType.EQ.'RL' ) THEN
        CALL MDS_WRITE_FIELD(
     I                 fName, filePrec, globalFile, .FALSE.,
     I                 arrType, nNz, 1, nNz, arr, dummyRS,
     I                 irecord, myIter, myThid )
      ELSE
        CALL MDS_WRITE_FIELD(
     I                 fName, filePrec, globalFile, .FALSE.,
     I                 arrType, nNz, 1, nNz, dummyRL, arr,
     I                 irecord, myIter, myThid )
      ENDIF

#else /* USE_OBSOLETE_MDS_RW_FIELD */
      STOP 'ABNORMAL END: S/R MDSWRITEFIELD is retired'
#endif /* USE_OBSOLETE_MDS_RW_FIELD */

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      SUBROUTINE MDSWRITEFIELD_LOC(
     I   fName,
     I   filePrec,
     I   globalFile,
     I   arrType,
     I   nNz,
     I   arr,
     I   irecord,
     I   myIter,
     I   myThid )
C
C Arguments:
C
C fName     (string)  :: base name for file to write
C filePrec  (integer) :: number of bits per word in file (32 or 64)
C globalFile (logical):: selects between writing a global or tiled file
C arrType   (char(2)) :: declaration of "arr": either "RS" or "RL"
C nNz       (integer) :: size of third dimension: normally either 1 or Nr
C arr       ( RS/RL ) :: array to write, arr(:,:,nNzdim,:,:)
C irecord   (integer) :: record number to write
C myIter    (integer) :: time step number
C myThid    (integer) :: thread identifier
C
C Routine now calls mdswritefield_new, just a way to add 2 extra arguments
C to the argument list. The 1rst new argument is to make the difference between
C the vertical dimension (3rd dimension) of an array and the number of levels
C the output routine should process. This routine assumes they are the same.
C The 2nd new argument (useCurrentDir=.TRUE.) forces to ignore the
C "mdsioLocalDir" parameter and to always write to the current directory.

      IMPLICIT NONE
C Global variables / common blocks
#include "SIZE.h"
c #include "EEPARAMS.h"

C Routine arguments
      CHARACTER*(*) fName
      INTEGER filePrec
      LOGICAL globalFile
      CHARACTER*(2) arrType
      INTEGER nNz
      _RL     arr(1-oLx:sNx+oLx,1-oLy:sNy+oLy,nNz,nSx,nSy)
      INTEGER irecord
      INTEGER myIter
      INTEGER myThid

#ifdef USE_OBSOLETE_MDS_RW_FIELD
C Local variables
      _RL dummyRL(1)
      _RS dummyRS(1)

      IF ( arrType.EQ.'RL' ) THEN
        CALL MDS_WRITE_FIELD(
     I                 fName, filePrec, globalFile, .TRUE.,
     I                 arrType, nNz, 1, nNz, arr, dummyRS,
     I                 irecord, myIter, myThid )
      ELSE
        CALL MDS_WRITE_FIELD(
     I                 fName, filePrec, globalFile, .TRUE.,
     I                 arrType, nNz, 1, nNz, dummyRL, arr,
     I                 irecord, myIter, myThid )
      ENDIF

#else /* USE_OBSOLETE_MDS_RW_FIELD */
      STOP 'ABNORMAL END: S/R MDSWRITEFIELD_LOC is empty'
#endif /* USE_OBSOLETE_MDS_RW_FIELD */

      RETURN
      END

#include "MDSIO_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 0
C !ROUTINE: MDS_WR_REC_RS

C !INTERFACE:
      SUBROUTINE MDS_WR_REC_RS(
     I                          arr,
     O                          r4Buf, r8Buf,
     I                          fPrec, dUnit, iRec, nArr, myThid )

C !DESCRIPTION:
C Write one reccord to already opened io-unit "dUnit", from RS array "arr"

C !USES:
      IMPLICIT NONE
#include "EEPARAMS.h"
#include "SIZE.h"
#include "PARAMS.h"

C !INPUT PARAMETERS:
C   arr     RS     :: vector array to write
C   fPrec  integer :: file precision
C   dUnit  integer :: 'Opened' I/O channel
C   iRec   integer :: record number to WRITE
C   nArr   integer :: dimension off array "arr"
C   myThid integer :: my Thread Id number
C !OUTPUT PARAMETERS:
C   r4Buf  real*4  :: buffer array
C   r8Buf  real*8  :: buffer array
      INTEGER fPrec
      INTEGER dUnit
      INTEGER iRec
      INTEGER nArr
      INTEGER myThid
      _RS    arr(nArr)
      Real*4 r4Buf(nArr)
      Real*8 r8Buf(nArr)
CEOP

C !LOCAL VARIABLES:
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      INTEGER k

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
      IF ( debugLevel.GE.debLevD ) THEN
        WRITE(msgBuf,'(A,I9,2x,I9)')
     &      ' MDS_WR_REC_RS: iRec,Dim = ', iRec, nArr
        CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                      SQUEEZE_RIGHT , myThid )
      ENDIF

      IF ( fPrec.EQ.precFloat32 ) THEN
        DO k=1,nArr
          r4Buf(k) = arr(k)
        ENDDO
#ifdef _BYTESWAPIO
        CALL MDS_BYTESWAPR4( nArr, r4Buf )
#endif
        WRITE( dUnit, rec=iRec ) r4Buf
      ELSEIF ( fPrec.EQ.precFloat64 ) THEN
        DO k=1,nArr
          r8Buf(k) = arr(k)
        ENDDO
#ifdef _BYTESWAPIO
        CALL MDS_BYTESWAPR8( nArr, r8Buf )
#endif
        WRITE( dUnit, rec=iRec ) r8Buf
      ELSE
        WRITE(msgBuf,'(A,I9)')
     &        ' MDS_WR_REC_RS: illegal value for fPrec=',fPrec
        CALL PRINT_ERROR( msgBuf, myThid )
        STOP 'ABNORMAL END: S/R MDS_WR_REC_RS'
      ENDIF

      RETURN
      END

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!                                                                   !!
!!                   GNU General Public License                      !!
!!                                                                   !!
!! This file is part of the Flexible Modeling System (FMS).          !!
!!                                                                   !!
!! FMS is free software; you can redistribute it and/or modify       !!
!! it and are expected to follow the terms of the GNU General Public !!
!! License as published by the Free Software Foundation.             !!
!!                                                                   !!
!! FMS is distributed in the hope that it will be useful,            !!
!! but WITHOUT ANY WARRANTY; without even the implied warranty of    !!
!! MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the     !!
!! GNU General Public License for more details.                      !!
!!                                                                   !!
!! You should have received a copy of the GNU General Public License !!
!! along with FMS; if not, write to:                                 !!
!!          Free Software Foundation, Inc.                           !!
!!          59 Temple Place, Suite 330                               !!
!!          Boston, MA  02111-1307  USA                              !!
!! or see:                                                           !!
!!          http://www.gnu.org/licenses/gpl.txt                      !!
!!                                                                   !!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

module constants_mod

! <CONTACT EMAIL="Bruce.Wyman@noaa.gov">
!   Bruce Wyman
! </CONTACT>

! <HISTORY SRC="http://www.gfdl.noaa.gov/fms-cgi-bin/cvsweb.cgi/FMS/"/>

! <OVERVIEW>
!    Defines useful constants for Earth.
! </OVERVIEW>

! <DESCRIPTION>
!   Constants are defined as real parameters,
!   except for PI and RADIAN, which are calculated in constants_init to promote
!   consistency and accuracy among various compilers.
!
!   Constants are accessed through the "use" statement.
! </DESCRIPTION>

!use fms_mod, only: write_version_number

implicit none
private

character(len=128) :: version='$Id: constants_mod.F90,v 1.1 2013/05/08 22:14:14 jmc Exp $'
character(len=128) :: tagname='$Name:  $'
logical :: do_log = .true.
logical :: module_is_initialized = .FALSE.
!dummy variable to use in HUGE initializations
real :: realnumber

!------------ physical constants ---------------
! <DATA NAME="RADIUS" UNITS="m" TYPE="real" DEFAULT="6371.e3">
!   radius of the earth
! </DATA>
! <DATA NAME="OMEGA" UNITS="1/s" TYPE="real" DEFAULT="7.292e-5">
!   rotation rate of the planet (earth)
! </DATA>
! <DATA NAME="GRAV" UNITS="m/s^2" TYPE="real" DEFAULT="9.80">
!   acceleration due to gravity
! </DATA>
! <DATA NAME="RDGAS" UNITS="J/kg/deg" TYPE="real" DEFAULT="287.04">
!   gas constant for dry air
! </DATA>
! <DATA NAME="KAPPA" TYPE="real" DEFAULT="2./7.">
!   RDGAS / CP_AIR
! </DATA>
! <DATA NAME="CP_AIR" UNITS="J/kg/deg" TYPE="real" DEFAULT="RDGAS/KAPPA">
!   specific heat capacity of dry air at constant pressure
! </DATA>
! <DATA NAME="CP_OCEAN" UNITS="J/kg/deg" TYPE="real" DEFAULT="3989.24495292815">
!   specific heat capacity taken from McDougall (2002) "Potential Enthalpy ..."
! </DATA>
! <DATA NAME="RHO0" UNITS="kg/m^3" TYPE="real" DEFAULT="1.035e3">
!   average density of sea water
! </DATA>
! <DATA NAME="RHO0R" UNITS="m^3/kg" TYPE="real" DEFAULT="1.0/RHO0">
!   reciprocal of average density of sea water
! </DATA>
! <DATA NAME="RHO_CP" UNITS="J/m^3/deg" TYPE="real" DEFAULT="RHO0*CP_OCEAN">
!   (kg/m^3)*(cal/kg/deg C)(joules/cal) = (joules/m^3/deg C)
! </DATA>

real, public, parameter :: RADIUS = 6371.0e3
real, public, parameter :: OMEGA  = 7.292e-5
real, public, parameter :: GRAV   = 9.80
real, public, parameter :: RDGAS  = 287.04
real, public, parameter :: KAPPA  = 2./7.
real, public, parameter :: CP_AIR = RDGAS/KAPPA
real, public, parameter :: CP_OCEAN = 3989.24495292815
real, public, parameter :: RHO0    = 1.035e3
real, public, parameter :: RHO0R   = 1.0/RHO0
real, public, parameter :: RHO_CP  = RHO0*CP_OCEAN

!------------ water vapor constants ---------------
! <DATA NAME="RVGAS" UNITS="J/kg/deg" TYPE="real" DEFAULT="461.50">
!   gas constant for water vapor
! </DATA>
! <DATA NAME="DENS_H2O" UNITS="kg/m^3" TYPE="real" DEFAULT="1000.">
!   density of liquid water
! </DATA>
! <DATA NAME="HLV" UNITS="J/kg" TYPE="real" DEFAULT="2.500e6">
!   latent heat of evaporation
! </DATA>
! <DATA NAME="HLF" UNITS="J/kg" TYPE="real" DEFAULT="3.34e5">
!   latent heat of fusion
! </DATA>
! <DATA NAME="HLS" UNITS="J/kg" TYPE="real" DEFAULT="2.834e6">
!   latent heat of sublimation
! </DATA>
! <DATA NAME="TFREEZE" UNITS="degK" TYPE="real" DEFAULT="273.16">
!   temp where fresh water freezes
! </DATA>

real, public, parameter :: RVGAS = 461.50
real, public, parameter :: DENS_H2O = 1000.
real, public, parameter :: HLV = 2.500e6
real, public, parameter :: HLF = 3.34e5
real, public, parameter :: HLS = 2.834e6
real, public, parameter :: TFREEZE = 273.16

!-------------- radiation constants -----------------

! <DATA NAME="WTMAIR" UNITS="AMU" TYPE="real" DEFAULT="2.896440E+01">
!  molecular weight of air
! </DATA>
! <DATA NAME="WTMH2O" UNITS="AMU" TYPE="real" DEFAULT="1.801534E+01">
!  molecular weight of water
! </DATA>
! <DATA NAME="WTMO3" UNITS="AMU" TYPE="real" DEFAULT="47.99820E+01">
!   molecular weight of ozone
! </DATA>
! <DATA NAME="DIFFAC" TYPE="real" DEFAULT="1.660000E+00">
! diffusivity factor
! </DATA>
! <DATA NAME="SECONDS_PER_DAY" UNITS="seconds" TYPE="real" DEFAULT="8.640000E+04">
! seconds in a day
! </DATA>
! <DATA NAME="AVOGNO" UNITS="atoms/mole" TYPE="real" DEFAULT="6.023000E+23">
!  Avogadro's number
! </DATA>
! <DATA NAME="PSTD" UNITS="dynes/cm^2" TYPE="real" DEFAULT="1.013250E+06">
!  mean sea level pressure
! </DATA>
! <DATA NAME="PSTD_MKS" UNITS="Newtons/m^2" TYPE="real" DEFAULT="101325.0">
!  mean sea level pressure
! </DATA>
! <DATA NAME="REARTH" UNITS="cm" TYPE="real" DEFAULT="6.356766E+08">
!  radius of the earth
! </DATA>

real, public, parameter :: WTMAIR = 2.896440E+01
real, public, parameter :: WTMH2O = 1.801534E+01
real, public, parameter :: WTMO3       = 47.99820E+01
real, public, parameter :: DIFFAC = 1.660000E+00
real, public, parameter :: SECONDS_PER_DAY  = 8.640000E+04
real, public, parameter :: AVOGNO = 6.023000E+23
real, public, parameter :: PSTD    = 1.013250E+06
real, public, parameter :: PSTD_MKS    = 101325.0
real, public, parameter :: REARTH  = 6.356766E+08

! <DATA NAME="RADCON" UNITS="deg sec/(cm day)" TYPE="real" DEFAULT="((1.0E+02*GRAV)/(1.0E+04*CP_AIR))*SECONDS_PER_DAY">
!  factor used to convert flux divergence to heating rate in degrees per day
! </DATA>
! <DATA NAME="RADCON_MKS" UNITS="deg sec/(m day)" TYPE="real" DEFAULT="(GRAV/CP_AIR)*SECONDS_PER_DAY">
!  factor used to convert flux divergence to heating rate in degrees per day
! </DATA>
! <DATA NAME="O2MIXRAT" TYPE="real" DEFAULT="2.0953E-01">
! mixing ratio of molecular oxygen in air
! </DATA>
! <DATA NAME="RHOAIR" UNITS="kg/m^3" TYPE="real" DEFAULT="1.292269">
!  reference atmospheric density
! </DATA>
! <DATA NAME="ALOGMIN" TYPE="real" DEFAULT="-50.0">
!  minimum value allowed as argument to log function
! </DATA>
! <DATA NAME="FREZDK" UNITS="deg K" TYPE="real" DEFAULT="273.16">
!   melting point of water
! </DATA>

real, public, parameter :: RADCON = ((1.0E+02*GRAV)/(1.0E+04*CP_AIR))*SECONDS_PER_DAY
real, public, parameter :: RADCON_MKS  = (GRAV/CP_AIR)*SECONDS_PER_DAY
real, public, parameter :: O2MIXRAT    = 2.0953E-01
real, public, parameter :: RHOAIR      = 1.292269
real, public, parameter :: ALOGMIN     = -50.0
real, public, parameter :: FREZDK      = 273.16

!------------ miscellaneous constants ---------------
! <DATA NAME="STEFAN" UNITS="W/m^2/deg^4" TYPE="real" DEFAULT="5.6734e-8">
!   Stefan-Boltzmann constant
! </DATA>
! <DATA NAME="VONKARM"  TYPE="real" DEFAULT="0.40">
!   Von Karman constant
! </DATA>
! <DATA NAME="PI" TYPE="real" DEFAULT="4.0*ATAN(1.0)">
!    ratio of circle circumference to diameter
! </DATA>
! <DATA NAME="RADIAN"  TYPE="real" DEFAULT="180.0/PI">
!   degrees per radian
! </DATA>
! <DATA NAME="C2DBARS" UNITS="dbars" TYPE="real" DEFAULT="1.e-4">
!   converts rho*g*z (in mks) to dbars: 1dbar = 10^4 (kg/m^3)(m/s^2)m
! </DATA>
! <DATA NAME="KELVIN" TYPE="real" DEFAULT="273.15">
!   degrees Kelvin at zero Celsius
! </DATA>
! <DATA NAME="EPSLN" TYPE="real" DEFAULT="1.0e-40">
!   a small number to prevent divide by zero exceptions
! </DATA>

real, public, parameter :: STEFAN  = 5.6734e-8
real, public, parameter :: VONKARM = 0.40
real, public            :: PI      = HUGE(realnumber)
real, public            :: RADIAN  = HUGE(realnumber)
real, public, parameter :: C2DBARS = 1.e-4
real, public, parameter :: KELVIN  = 273.15
real, public, parameter :: EPSLN   = 1.0e-40
!-----------------------------------------------------------------------

public constants_init

contains

! <SUBROUTINE NAME="constants_init">

!   <OVERVIEW>
!     Initialization routine. The purpose of this routine
!     is initialize the value of PI and RADIAN, and to write the
!     version and tag name information to the log file.
!   </OVERVIEW>
!   <DESCRIPTION>
!     If this routine is called more than once or called
!     from other than the root PE it will return silently.
!     There are no arguments.
!   </DESCRIPTION>
!   <TEMPLATE>
!     call constants_init
!   </TEMPLATE>

subroutine constants_init

  if (module_is_initialized) return
  module_is_initialized = .TRUE.

  if (.not.do_log) return
! call write_version_number (version,tagname)
  do_log = .false.

  PI = 4.0*ATAN(1.0)
  RADIAN = 180.0/PI

end subroutine constants_init
! </SUBROUTINE>

!-----------------------------------------------------------------------

end module constants_mod

! <INFO>

!   <FUTURE>
!   1.  Renaming of constants.
!   </FUTURE>
!   <FUTURE>
!   2.  Additional constants.
!   </FUTURE>
!   <NOTE>
!    Constants have been declared as type REAL, PARAMETER.
!
!    The value a constant can not be changed in a users program.
!    New constants can be defined in terms of values from the
!    constants module using a parameter statement.<br><br>
!
!    The name given to a particular constant may be changed.<br><br>
!
!    Constants can be used on the right side on an assignment statement
!    (their value can not be reassigned).
!
!    As PI is calculated, it cannot be a parameter variable.
!    Do not assign a new value to PI.
!
!<TESTPROGRAM NAME="EXAMPLE">
!<PRE>
!    use constants_mod, only:  TFREEZE, grav_new => GRAV
!    real, parameter :: grav_inv = 1.0 / grav_new
!    tempc(:,:,:) = tempk(:,:,:) - TFREEZE
!    geopotential(:,:) = height(:,:) * grav_new
!</PRE>
!</TESTPROGRAM>
!   </NOTE>

! </INFO>

!> \mainpage
!! This is a Fortran9X adaptation of the functionality of Revolve; see Alg. 799 published as \cite Griewank2000ARA .
!! The interface of the routines differs from the cited revolve implementation
!! found in Adol-C and has been designed to be more in line with the
!! Fortran 9X language features. A minor extension is the  optional `bundle` parameter that allows to treat as many loop
!! iterations in one tape/adjoint sweep. If `bundle` is 1, the default, then the behavior is that of Alg. 799.
!!
!! The implementation (written by J. Utke)  is contained in revolve.f90, the use is illustrated in the `Examples` directory.
!!
!! The mercurial repository with the latest version can be found at:
!! <a href="http://mercurial.mcs.anl.gov/ad/RevolveF9X">http://mercurial.mcs.anl.gov/ad/RevolveF9X</a>
!!


!> the module containing the revolve implementation
!!
MODULE revolve
  IMPLICIT NONE

  PUBLIC :: rvInit, rvVerbose, rvNextAction, &
rvGuess, rvFactor, & 
rvStore, rvRestore, &
rvForward, rvFirstUTurn, rvUTurn, rvDone, &
rvError, rvAdjust

  PRIVATE :: & 
ourSteps, ourACP, ourCStart, ourCEnd, ourVerbosity, &
ourNumFwd , ourNumInv, ourNumStore, ourRWCP, ourPrevCEnd, &
ourFirstUTurned, chkRange, forwdCount

  !> store a checkpoint now
  !! equivalent to TAKESHOT in Alg. 799
  INTEGER, PARAMETER :: rvStore      =1 

  !> restore a checkpoint now
  !! equivalent to RESTORE in Alg. 799
  INTEGER, PARAMETER :: rvRestore    =2

  !> execute iteration(s) forward
  !! equivalent to ADVANCE in Alg. 799
  INTEGER, PARAMETER :: rvForward    =3

  !> tape iteration(s); optionally leave to return later;  and (upon return) do the adjoint(s)
  !! equivalent to FIRSTTURN in Alg. 799
  INTEGER, PARAMETER :: rvFirstUTurn =4

  !> tape iteration(s) and do the adjoint(s)
  !! equivalent to YOUTURN in Alg. 799
  INTEGER, PARAMETER :: rvUTurn      =5

  !> we are done with adjoining the loop
  !! equivalent to the `terminate` enum value in Alg. 799
  INTEGER, PARAMETER :: rvDone       =6

  !> an error has occurred
  !! equivalent to the `error` enum value in Alg. 799;
  !! see also `errorMsg` in \ref rvAction
  INTEGER, PARAMETER :: rvError      =7

  !> this encapsulates all the information needed to perfrom the correct action
  !! an instance is returned from \ref rvNextAction
  TYPE rvAction
     !> the action that is to be implemented, termination, or error;
     !! the value must be one of:
     !! `rvStore`, `rvRestore`, `rvForward`,
     !! `rvFirstUTurn`, `rvUTurn`, `rvDone`, `rvError`
     INTEGER :: actionFlag = 0

     !> assumptions:
     !! - the loop iterations are numbered in range [0,`ourSteps`-1]
     !! - the model state is the input to the iteration numbered `startIteration`
     !!
     !! the interpretation is as follows based on the value of `actionFlag`:
     !! - `rvForward`: execute iterations as the loop: `do currentIteration=startIteration, iteration-1`
     !! - `rvRestore`: restores model state at `iteration` (here it has the same value as `startIteration`)
     !! - `rvFirstUTurn`/`rvUTurn`: tape iterations in loop: do currentIteration=startIteration, iteration-1`
     !!    followed by adjoint sweep over iterations in loop: do currentIteration=iteration-1,startIteration,-1
     !!
     !! for all other values of `actionFlag` the value of `iteration` is meaningless
     INTEGER :: iteration  = 0

     !> assuming the loop iterations are in [0,ourSteps-1] and `currentIteration` variable is maintained,
     !! the interpretation is as follows based on the value of `actionFlag`:
     !! - `rvForward`: execute iterations as the loop: `do currentIteration, iteration-1`
     !! - `rvRestore`: set `currentIteration=iteration`
     !!
     !! for all other values of `actionFlag` the value of `iteration` is meaningless
     INTEGER :: startIteration = 0

     !> the checkpoint number to be stored to restored
     !! the value is meaninfull only if `actionFlag` is set to `rvStore` or `rvRestore`;
     !!
     !! This is approximately equivalent to `checks` in Alg. 799.
     INTEGER :: cpNum      = 0

     !> if an error has occurred `actionFlag` will be set to `rvError` and this will contain an error message
     CHARACTER(80) :: errorMsg
  END TYPE rvAction
  
  !> the number of iteration steps; set by calling \ref rvInit; not supposed to be set/used directly by the user;
  !! note that the iterations are expected to range in [0, ourSteps-1];
  !!
  !! equivalent to `steps` in Alg. 799
  INTEGER :: ourSteps    = 0 ! number of steps

  !> the number of iterations that may be bundled for a taping/adjoining sweep;
  !! set by calling \ref rvInit; not supposed to be set/used directly by the user;
  !!
  !! the default is 1 loop iteration which makes it equivalent to Alg. 799
  INTEGER :: ourBundle   = 1

  !> the number of iterations in the last bundle
  !! set by calling \ref rvInit; not supposed to be set/used directly by the user;
  !!
  !! the default is 1 (for `ourBundle` = 1)  which makes it equivalent to Alg. 799
  INTEGER :: ourTail   = 1

  !> the number of checkpoints (ACP=AllowedCheckPoints) that can be stored at any time during the loop execution
  !! set by calling \ref rvInit; not supposed to be set/used directly by the user
  !!
  !! equivalent to `snaps` in Alg. 799
  INTEGER :: ourACP      = 0

  !> current subrange start;
  !! not to be set/referemced directly by the user
  !!
  !! approximately equivalent to `capo` in Alg. 799
  INTEGER :: ourCStart   = 0

  !> current subrange end;
  !! not to be set/referemced directly by the user
  !!
  !! approximately equivalent to `fine` in Alg. 799
  INTEGER :: ourCEnd     = 0

  !> count of the forward steps; diagnostic only
  INTEGER :: ourNumFwd   = 0

  !> count of invocations to \ref rvNextAction ;  diagnostic only
  INTEGER :: ourNumInv   = 0

  !> count of checkpoint stores; diagnostic only
  INTEGER :: ourNumStore = 0

  !> checkpoint currently (re)stored - the first checkpoint is numbered 0;
  !! not to be set/referemced directly by the user
  INTEGER :: ourRWCP     = -1

  !> previous subrange end;
  !! not to be set/referemced directly by the user
  INTEGER :: ourPrevCEnd = 0

  !> have we first uturned already?;
  !! not to be set/referemced directly by the user
  LOGICAL :: ourFirstUturned = .FALSE.

  !> vector of step numbers indexed by checkpoint;
  !! not to be set/referemced directly by the user
  INTEGER, DIMENSION(:), ALLOCATABLE :: ourStepOf

  !> for debugging purposes; values imply:
  !! - 0 includes errors
  !! - 1 includes summary info
  !! - 2 includes iterations with checkpoints stored
  !! - 3 includes all action results
  !!
  !! set via \ref rvVerbose
  INTEGER :: ourVerbosity = 0

CONTAINS

!--------------------------------------------------------------------*

  !> method to initialize the internal state; must be called before any call to \ref rvNextAction
  !! @param steps  the total number of steps in the iteration; equivalent to `steps` in Alg. 799
  !! @param checkpoints the total number of checkpoints allowed to be stored at any time; equivalent to `snaps` in Alg. 799
  !! @param errorMsg set when an error condition occurs; else set to `"none"`
  !! @param anActionInstance  if supplied initializes its contents
  !! @param bundle if supplied initializes `ourBundle`
  !! @return `.true.` if successfull, else `.false.` ansd `errorMsg` will be set
  FUNCTION rvInit(steps,checkpoints,errorMsg,anActionInstance,bundle)
    IMPLICIT NONE
    LOGICAL :: rvInit
    INTEGER, INTENT(IN) :: steps
    INTEGER, INTENT(IN) :: checkpoints
    CHARACTER(*), INTENT(OUT) :: errorMsg
    type(rvAction), optional :: anActionInstance
    INTEGER, INTENT(IN), optional :: bundle
    INTEGER :: predFwdCnt ! predicted forward count 
    rvInit = .TRUE.
    errorMsg ='none'
    IF (present(anActionInstance)) THEN
       ! same as default init above
       anActionInstance%actionFlag = 0
       anActionInstance%iteration  = 0
       anActionInstance%cpNum      = 0
    END IF
    IF (present(bundle)) THEN
       ourBundle = bundle
    END IF
    IF (ourBundle<1 .OR. ourBundle>steps) THEN
       rvInit=.FALSE.
       errorMsg = "revolve::rvInit: bundle parameter out of range [1,steps]"
    ELSEIF (steps<0) THEN
       rvInit=.FALSE.
       errorMsg = 'revolve::rvInit: negative steps'
    ELSEIF (checkpoints<0) THEN
       rvInit=.FALSE.
       errorMsg = 'revolve::rvInit: negative checkpoints'
    ELSE 
       ourCStart       = 0
       ourSteps        = steps
       IF (ourBundle .gt. 1) THEN
          ourTail=modulo(ourSteps,ourBundle)
          ourSteps=ourSteps/ourBundle
          IF (ourTail>0) THEN
             ourSteps=ourSteps+1
          ELSE
             ourTail=ourBundle
          END IF
       END IF
       ourCEnd         = ourSteps
       ourACP          = checkpoints
       ourNumFwd       = 0 
       ourNumInv       = 0 
       ourNumStore     = 0 
       ourRWCP         = -1 
       ourPrevCEnd     = 0 
       ourFirstUTurned = .FALSE.

       IF (ALLOCATED(ourStepOf)) THEN
          DEALLOCATE(ourStepOf)
       END IF
       IF(.NOT.ALLOCATED(ourStepOf)) THEN
          ALLOCATE(ourStepOf(0:ourACP))
       END IF

       IF (ourVerbosity>0) THEN
          predFwdCnt = forwdCount(steps,ourACP,ourBundle)
          IF (predFwdCnt==-1) THEN
             errorMsg='revolve::rvInit: error returned by  revolve::forwdCount'
             rvInit=.FALSE.
             RETURN
          ELSE
             WRITE (*,'(A)') 'prediction:'
             WRITE (*,'(A,I7)')   ' overhead forward steps : ', predFwdCnt
             WRITE (*,'(A,F8.4)') ' overhead factor        : ', dble(predFwdCnt)/(steps)
          END IF
       END IF
    END IF
  END FUNCTION rvInit

!--------------------------------------------------------------------*

  !> method to change the internal state for the total number of steps/checkpoints; must be called after \ref rvInit
  !! @param steps  the total number of steps in the iteration; equivalent to `steps` in Alg. 799
  !! @param errorMsg set when an error condition occurs; else set to `"none"`
  !! @return `.true.` if successfull, else `.false.` ansd `errorMsg` will be set
  FUNCTION rvAdjust(steps,checkpoints,errorMsg)
    IMPLICIT NONE
    LOGICAL :: rvAdjust
    INTEGER, INTENT(IN) :: steps
    INTEGER, INTENT(IN) :: checkpoints
    CHARACTER(*), INTENT(OUT) :: errorMsg
    rvAdjust=.false.
  END FUNCTION

!--------------------------------------------------------------------*

  !> method to set the verbosity to a level in [0-3] as described for `ourVerbosity`
  SUBROUTINE rvVerbose(level)
    IMPLICIT NONE
    INTEGER, INTENT(IN) :: level 
    ourVerbosity=level
  END SUBROUTINE rvVerbose

!--------------------------------------------------------------------*
  !> the method to determine the next action; to be called in an unbound loop after \ref rvInit
  !! @return an instance of `rvAction` set to describe the next action (see the member documentation);
  !!
  !! this method modifies the internal state; it is approximately equivalent to the method `revolve` in Alg. 799
  FUNCTION rvNextAction()
    IMPLICIT NONE
    REAL :: bino1, bino2, bino3, bino4, bino5

    !> available checkpoint slots
    INTEGER :: availCP

    !> local copy of previous subrange start
    INTEGER :: prevCStart

    INTEGER :: range
    INTEGER :: reps
    INTEGER :: i 
    LOGICAL :: rwcpTest
    type(rvAction) :: rvNextAction
    IF (ourNumInv==0) THEN
       ! first invocation
       DO i = 0, ourACP
          ourStepOf(i) = 0
       END DO
       ourStepOf(0) = ourCStart - 1
    END IF
    prevCStart = ourCStart
    ourNumInv = ourNumInv + 1
    rwcpTest=(ourRWCP==(-1))
    IF (.not. rwcpTest) THEN 
       rwcpTest=(ourStepOf(ourRWCP)/=ourCStart)
    END IF
    IF ((ourCEnd-ourCStart)==0) THEN
       ! nothing in current subrange
       IF ((ourRWCP==(-1)) .OR. (ourCStart==ourStepOf(0))) THEN
          ! we are done
          ourRWCP = ourRWCP - 1
          IF (ourVerbosity>2) THEN
             WRITE (*,FMT='(A)') ' done'
          END IF
          IF (ourVerbosity>0) THEN
             WRITE (*,'(A)') 'summary:'
             WRITE (*,'(A,I8)') ' overhead forward steps:', ourNumFwd
             WRITE (*,'(A,I8)') ' CP stores             :', ourNumStore
             WRITE (*,'(A,I8)') ' rvNextAction calls    :', ourNumInv
          END IF
          rvNextAction%actionFlag = rvDone
        ELSE
           ourCStart = ourStepOf(ourRWCP)
           ourPrevCEnd = ourCEnd
           rvNextAction%actionFlag = rvRestore 
        END IF
     ELSE IF ((ourCEnd-ourCStart)==1) THEN
        ourCEnd = ourCEnd - 1
        ourPrevCEnd = ourCEnd
        IF ((ourRWCP>=0) .AND. (ourStepOf(ourRWCP)==ourCStart)) ourRWCP = ourRWCP - 1
        IF (.NOT.ourFirstUTurned) THEN
           rvNextAction%actionFlag = rvFirstUTurn
           ourFirstUTurned = .TRUE.
        ELSE
           rvNextAction%actionFlag = rvUTurn
        END IF
     ELSE IF (rwcpTest) THEN
        ourRWCP = ourRWCP + 1
        IF (ourRWCP+1>ourACP) THEN
           rvNextAction%actionFlag = rvError
           rvNextAction%errorMsg='revolve::rvNextAction: insufficient allowed checkpoints'
           RETURN
        ELSE
           ourStepOf(ourRWCP) = ourCStart
           ourNumStore = ourNumStore + 1
           ourPrevCEnd = ourCEnd
           rvNextAction%actionFlag = rvStore
        END IF
     ELSE IF ((ourPrevCEnd<ourCEnd) .AND. (ourACP==ourRWCP+1)) THEN
        rvNextAction%actionFlag = rvError
        rvNextAction%errorMsg='revolve::rvNextAction: insufficient allowed checkpoints'
     ELSE
        availCP = ourACP - ourRWCP
        IF (availCP<1) THEN
           rvNextAction%actionFlag = rvError
           rvNextAction%errorMsg='revolve::rvNextAction: insufficient allowed checkpoints'
        ELSE
           reps = 0
           range = 1
           DO WHILE (range<ourCEnd-ourCStart)
              reps = reps + 1
              range = range*(reps+availCP)/reps
           END DO
           bino1 = range*reps/(availCP+reps)
           IF (availCP>1) THEN
            bino2 = bino1*availCP/(availCP+reps-1)
          ELSE
            bino2 = 1
          END IF
          IF (availCP==1) THEN
            bino3 = 0
          ELSE IF (availCP>2) THEN
            bino3 = bino2*(availCP-1)/(availCP+reps-2)
          ELSE
            bino3 = 1
          END IF
          bino4 = bino2*(reps-1)/availCP
          IF (availCP<3) THEN
            bino5 = 0
          ELSE IF (availCP>3) THEN
            bino5 = bino3*(availCP-1)/reps
          ELSE
            bino5 = 1
          END IF
          IF (ourCEnd-ourCStart<=bino1+bino3) THEN
            ourCStart = int(ourCStart + bino4)
          ELSE IF (ourCEnd-ourCStart>=range-bino5) THEN
            ourCStart = int(ourCStart + bino1)
          ELSE
            ourCStart = int(ourCEnd - bino2 - bino3)
          END IF
          IF (ourCStart==prevCStart) THEN
            ourCStart = prevCStart + 1
          END IF
          IF (ourCStart==ourSteps) THEN
             ourNumFwd = ourNumFwd + ((ourCStart-1) - prevCStart)*ourBundle + ourTail
          ELSE
             ourNumFwd = ourNumFwd + (ourCStart - prevCStart)*ourBundle
          END IF
          rvNextAction%actionFlag = rvForward
        END IF
      END IF
      rvNextAction%startIteration=prevCStart*ourBundle
      IF (rvNextAction%actionFlag==rvFirstUTurn) THEN
         rvNextAction%iteration=(ourCStart)*ourBundle+ourTail
      ELSE IF (rvNextAction%actionFlag==rvUTurn) THEN
         rvNextAction%iteration=(ourCStart+1)*ourBundle
      ELSE
         rvNextAction%iteration=(ourCStart)*ourBundle
      END IF
      IF (rvNextAction%actionFlag /= rvError) THEN
         IF (ourVerbosity>2) THEN
            SELECT CASE( rvNextAction%actionFlag)
            CASE (rvForward)
               WRITE (*,FMT='(A,I8,A,I8,A)') ' run forward iterations    [', &
               rvNextAction%startIteration, ',', rvNextAction%iteration-1,']'
            CASE (rvRestore)
               WRITE (*,FMT='(A,I8)')        ' restore input of iteration ',&
               rvNextAction%iteration
            CASE (rvFirstUTurn)
               WRITE (*,FMT='(A,I8,A,I8,A)') ' 1st uturn for iterations  [',&
               rvNextAction%startIteration, ',', rvNextAction%iteration-1,']'
            CASE(rvUTurn)      
               WRITE (*,FMT='(A,I8,A,I8,A)') ' uturn for iterations      [',&
               rvNextAction%startIteration, ',', rvNextAction%iteration-1,']'
            END SELECT
         END IF
         IF ((ourVerbosity>1) .AND. (rvNextAction%actionFlag == rvStore)) THEN
                WRITE (*,FMT='(A,I8)')        ' store input of iteration   ',&
                rvNextAction%iteration
         END IF
      END IF
      rvNextAction%cpNum=ourRWCP
    END FUNCTION rvNextAction

!--------------------------------------------------------------------*
    !> estimates the number of checkpoints required; equivalent to `adjust` in Alg. 799
    !! @param steps is the number of iterations
    !! @param bundle is optional; detaults to 1, if specified indicates the number of iterations bundled in one tape/adjoint sweep
    !! @return the number of checkpoints such that the growth in spatial complexity is balanced with the  growth in temporal complexity
    !!
    !! this method does not change the internal state and does not require \ref rvInit
    FUNCTION rvGuess(steps,bundle)
    IMPLICIT NONE
      INTEGER, INTENT(IN) :: steps, bundle
      OPTIONAL :: bundle
      INTEGER :: reps, s, checkpoints, b, tail, bSteps
      INTEGER :: rvGuess
      b=1
      bSteps=steps
      IF (present(bundle)) THEN
         b=bundle
      END IF
      IF (steps<1) THEN
        WRITE (*,fmt=*) 'revolve::rvGuess: error: steps < 1'
        rvGuess = -1
      ELSE IF (b<1) THEN
        WRITE (*,fmt=*) 'revolve::rvGuess: error: bundle < 1'
        rvGuess = -1
      ELSE
        IF (b .gt. 1) THEN
          tail=modulo(bSteps,b)
          bSteps=bSteps/b
          IF (tail>0) THEN
            bSteps=bSteps+1
          END IF
        END IF
        IF (bSteps==1) THEN
          rvGuess=0
        ELSE
          checkpoints = 1
          reps = 1
          s = 0
          DO WHILE (chkRange(checkpoints+s,reps+s)>bSteps)
            s = s - 1
          END DO
          DO WHILE (chkRange(checkpoints+s,reps+s)<bSteps)
            s = s + 1
          END DO
          checkpoints = checkpoints + s
          reps = reps + s
          s = -1
          DO WHILE (chkRange(checkpoints,reps)>=bSteps)
            IF (checkpoints>reps) THEN
              checkpoints = checkpoints - 1
              s = 0
            ELSE
              reps = reps - 1
              s = 1
            END IF
          END DO
          IF (s==0) THEN
            checkpoints = checkpoints + 1
          END IF
          IF (s==1) reps = reps + 1
          rvGuess = checkpoints
        END IF
      END IF
    END FUNCTION rvGuess

!--------------------------------------------------------------------*
    !> computes the run time overhead factor; equivalent to `expense` in Alg. 799
    !! @param steps is the number of iterations
    !! @param checkpoints is the number of allowed checkpoints
    !! @param bundle is optional; detaults to 1, if specified indicates the number of iterations bundled in one tape/adjoint sweep
    !! @return the estimated runtime overhead factor (does not account for the time needed to write checkpoints)
    !!
    !! this method does not change the internal state and does not require \ref rvInit
    FUNCTION rvFactor(steps,checkpoints,bundle)
    IMPLICIT NONE
      INTEGER, INTENT(IN) :: checkpoints, steps, bundle
      OPTIONAL :: bundle
      INTEGER :: b, f
      DOUBLE PRECISION :: rvFactor
      b=1
      IF (present(bundle)) THEN
         b=bundle
      END IF
      f=forwdCount(steps,checkpoints,b)
      IF (f==-1)  THEN
        WRITE (*,fmt=*) 'revolve::rvFactor: error returned by  revolve::forwdCount'
        rvFactor=-1
      ELSE
        rvFactor = dble(f)/steps
      END IF
    END FUNCTION rvFactor

!--------------------------------------------------------------------*
    !> internal method not to be referenced by the user
    FUNCTION chkRange(ss,tt)
    IMPLICIT NONE
      INTEGER :: ss, tt
      DOUBLE PRECISION :: res
      INTEGER :: i
      INTEGER :: chkRange
      res = 1.
      IF (tt<0 .OR. ss<0) THEN
        WRITE (*,fmt=*) 'revolve::chkRange: error: negative parameter '
        chkRange = -1
      ELSE
        DO i = 1, tt
          res = res*(ss+i)
          res = res/i
          IF (res>huge(chkrange)) EXIT
        END DO
        IF (res<huge(chkrange)) THEN
          chkRange = int(res)
        ELSE
          chkRange = huge(chkrange)
          WRITE (*,fmt=*) 'revolve::chkRange: warning: returning maximal integer ',&
          chkRange
        END IF
      END IF
    END FUNCTION chkRange

!--------------------------------------------------------------------*

    !> internal method not to be referenced by the user;
    !> predicts the  number of recomputation-from-checkpoint forwards steps (overhead)
    FUNCTION forwdCount(steps,checkpoints,bundle)
    IMPLICIT NONE
      INTEGER, INTENT(IN) :: checkpoints, steps, bundle
      INTEGER :: range, reps,s,tail
      INTEGER :: forwdCount
      IF (checkpoints<0) THEN
        WRITE (*,fmt=*) 'revolve::forwdCount: error: checkpoints < 0'
        forwdCount = -1
      ELSE IF (steps<1) THEN
        WRITE (*,fmt=*) 'revolve::forwdCount: error: steps < 1'
        forwdCount = -1
      ELSE IF (bundle<1) THEN
        WRITE (*,fmt=*) 'revolve::forwdCount: error: bundle < 1'
        forwdCount = -1
      ELSE
        s=steps
        IF (bundle .gt. 1) THEN
          tail=modulo(s,bundle)
          s=s/bundle
          IF (tail>0) THEN
            s=s+1
          END IF
        END IF
        IF (s==1) THEN
          forwdCount = 0
        ELSE IF (checkpoints==0) THEN
          WRITE (*,fmt=*) &
          'revolve::forwdCount: error: given inputs require checkpoints>0'
          forwdCount = -1
        ELSE
          reps = 0
          range = 1
          DO WHILE (range<s)
            reps = reps + 1
            range = range*(reps+checkpoints)/reps
          END DO
          forwdCount = (reps*s - range*reps/(checkpoints+1))*bundle
        END IF
      END IF
    END FUNCTION forwdCount

!--------------------------------------------------------------------*

END MODULE revolve

#include "DIC_OPTIONS.h"

CBOP
C !ROUTINE: BIO_EXPORT

C !INTERFACE: ==========================================================
      SUBROUTINE BIO_EXPORT( PTR_PO4 ,
#ifdef ALLOW_FE
     I           PTR_FE,
#endif
     O           bioac,
     I           bi,bj,iMin,iMax,jMin,jMax,
     I           myTime, myIter, myThid )

c !DESCRIPTION:
C  Calculate biological activity and export

C !USES: ===============================================================
      IMPLICIT NONE
#include "SIZE.h"
#include "DYNVARS.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "DIC_VARS.h"
#ifdef USE_QSW
#include "FFIELDS.h"
#endif

C !INPUT PARAMETERS: ===================================================
C  PTR_PO4              :: phosphate tracer field
C  PTR_FE               :: iron tracer field
C  myTime               :: current time
C  myIter               :: current timestep
C  myThid               :: thread number
      _RL  PTR_PO4(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
#ifdef ALLOW_FE
      _RL  PTR_FE(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
#endif
      INTEGER iMin, iMax, jMin, jMax, bi, bj
      _RL myTime
      INTEGER myIter
      INTEGER myThid

C !OUTPUT PARAMETERS: ==================================================
C  bioac               :: biological productivity (will be split
C                         between export and dissolved pool)
      _RL bioac(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)

#if (defined ALLOW_PTRACERS && defined DIC_BIOTIC)

C !LOCAL VARIABLES: ====================================================
C  i,j,k                  :: loop indices
       INTEGER i,j,k
#if !defined READ_PAR && !defined USE_QSW
      _RL sfac    (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
#endif
      _RL lit     (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL kall, atten
      _RL nutlimit
      _RL tmppo4
#ifdef ALLOW_FE
      _RL tmpfe
#endif
#ifdef DIC_AD_SAFE
      _RL thx, thy, thaux
#endif
CEOP

#if !defined READ_PAR && !defined USE_QSW
      CALL GCHEM_INSOLATION(
     O     sfac,
     I     iMin, iMax, jMin, jMax, bi, bj,
     I     myTime, myIter, myThid)
#endif
cph: following init assumes nlev=nr
cph: set in dic_init_fixed.F (ALLOW_AUTODIFF)
C$TAF INIT bio_export = static, nsx*nsy*nr
C FORTRAN-77 dynamic memory uses adstore adresto
CRG C$TAF INIT bio_export = memory
      DO j=jMin,jMax
       DO i=iMin,iMax
#ifdef READ_PAR
        lit(i,j)=PAR(i,j,bi,bj)
#elif (defined USE_QSW)
        lit(i,j)=-parfrac*Qsw(i,j,bi,bj)*maskC(i,j,1,bi,bj)
#else
        lit(i,j)=MAX(1. _d -5,sfac(i,j)*parfrac)
#endif
       ENDDO
      ENDDO
      IF ( .NOT. QSW_underice ) THEN
       DO j=jMin,jMax
        DO i=iMin,iMax
c if using Qsw but not seaice/thsice or coupled, then
c ice fraction needs to be taken into account
         lit(i,j)=lit(i,j)*(1. _d 0 - FIce(i,j,bi,bj))
        ENDDO
       ENDDO
      ENDIF

      kall = k0
      DO k=1,nlev
C$TAF STORE lit = bio_export
       DO j=jMin,jMax
        DO i=iMin,iMax
#ifdef LIGHT_CHL
c   Add self-shading effects to light attenuation coefficient
         kall = k0+kchl*CHL(i,j,bi,bj)
#endif
         atten = kall*drF(k)*hFacC(i,j,k,bi,bj)*.5 _d 0
         if (k.gt.1) atten = atten
     &         +( kall*drF(k-1)*hFacC(i,j,k-1,bi,bj)*.5 _d 0 )
         lit(i,j)=lit(i,j)*exp(-atten)
#ifndef TARGET_NEC_SX
C     this statement breaks vectorization and causes a dramatic
C     performance drop on vector computers
          IF (lit(i,j).LT.0. _d 0.OR.lit(i,j).GT.350. _d 0) THEN
           print*,'QQ lit',i,j,lit(i,j)
          ENDIF
#endif
#ifdef DIC_NO_NEG
         tmppo4=max(0. _d 0, PTR_PO4(i,j,k))
         lit(i,j)=max(0. _d 0,lit(i,j))
#else
         tmppo4=PTR_PO4(i,j,k)
#endif

#ifdef ALLOW_FE
#ifdef DIC_NO_NEG
         tmpfe=max(0. _d 0,PTR_FE(i,j,k))
#else
         tmpfe=PTR_FE(i,j,k)
#endif
#ifdef DIC_AD_SAFE
         thx = tmppo4/(tmppo4+KPO4)
         thy = tmpfe/(tmpfe+KFE)
c        thx = PTR_PO4(i,j,k)/(PTR_PO4(i,j,k)+KPO4)
c        thy = PTR_FE(i,j,k)/(PTR_FE(i,j,k)+KFE)
         thaux = tanh( (thx-thy)*1. _d 6 )
         nutlimit= ( 1. _d 0 - thaux ) * thx * 0.5 _d 0
     &        +    ( 1. _d 0 + thaux ) * thy * 0.5 _d 0
#else
         nutlimit=min( tmppo4/(tmppo4+KPO4),tmpfe/(tmpfe+KFE) )
#endif
#else
         nutlimit=     tmppo4/(tmppo4+KPO4)
#endif

         bioac(i,j,k)=alpha(i,j,bi,bj)*
     &        lit(i,j)/(lit(i,j)+lit0)*maskC(i,j,k,bi,bj)*
     &        nutlimit
        ENDDO
       ENDDO
      ENDDO
c
#endif /* definded ALLOW_PTRACERS && defined DIC_BIOTIC */
      RETURN
      END

#include "ATM_PHYS_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 0
C !ROUTINE: ATM_PHYS_READPARMS

C !INTERFACE:
      SUBROUTINE ATM_PHYS_READPARMS( myThid )

C     !DESCRIPTION:
C     Initialize AtmPhys parameters and constants.

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "ATM_PHYS_PARAMS.h"

C     !INPUT PARAMETERS:
      INTEGER myThid
CEOP

#ifdef ALLOW_ATM_PHYS

C     !LOCAL VARIABLES:
C     msgBuf     :: Informational/error message buffer
C     iUnit      :: Work variable for IO unit number
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      INTEGER iUnit
      INTEGER k

      NAMELIST /ATM_PHYS_PARM01/
     &       atmPhys_addTendT, atmPhys_addTendS,
     &       atmPhys_addTendU, atmPhys_addTendV,
     &       atmPhys_tauDampUV, atmPhys_dampUVfac,
     &       atmPhys_stepSST,
     &       atmPhys_sstFile, atmPhys_qFlxFile, atmPhys_mxldFile,
     &       atmPhys_albedoFile, atmPhys_ozoneFile

      _BEGIN_MASTER(myThid)

      IF ( .NOT.useAtm_Phys ) THEN
C-    pkg ATM_PHYS is not used
        _BEGIN_MASTER(myThid)
C-    Track pkg activation status:
C     print a (weak) warning if data.atm_phys is found
         CALL PACKAGES_UNUSED_MSG( 'useAtm_Phys', ' ', ' ' )
        _END_MASTER(myThid)
        RETURN
      ENDIF

C--   Default values for ATM_PHYS
      atmPhys_addTendT  = .TRUE.
      atmPhys_addTendS  = .TRUE.
      atmPhys_addTendU  = .TRUE.
      atmPhys_addTendV  = .TRUE.
      atmPhys_tauDampUV = 0. _d 0
      DO k=1,Nr
        atmPhys_dampUVfac(k) = 1. _d 0
      ENDDO
C-    additional parameters:
      atmPhys_stepSST   = .FALSE.
      atmPhys_sstFile   = ' '
      atmPhys_qFlxFile  = ' '
      atmPhys_mxldFile  = ' '
      atmPhys_albedoFile= ' '
      atmPhys_ozoneFile = ' '

      WRITE(msgBuf,'(A)') 'ATM_PHYS_READPARMS: opening data.atm_phys'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      CALL OPEN_COPY_DATA_FILE(
     I                     'data.atm_phys', 'ATM_PHYS_READPARMS',
     O                     iUnit,
     I                     myThid )

C     Read parameters from open data file
      READ(UNIT=iUnit,NML=ATM_PHYS_PARM01)
      WRITE(msgBuf,'(A)')
     &    'ATM_PHYS_READPARMS: finished reading data.atm_phys'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
C     Close the open data file
#ifdef SINGLE_DISK_IO
      CLOSE(iUnit)
#else
      CLOSE(iUnit,STATUS='DELETE')
#endif /* SINGLE_DISK_IO */

      IF ( atmPhys_tauDampUV.LE.zeroRL ) THEN
       DO k=1,Nr
        atmPhys_dampUVfac(k) = 0. _d 0
       ENDDO
      ELSE
       DO k=1,Nr
        atmPhys_dampUVfac(k) = atmPhys_dampUVfac(k)/atmPhys_tauDampUV
       ENDDO
      ENDIF

C     Make sure that we locally honor the global MNC on/off flag
c     myPa_MNC = myPa_MNC .AND. useMNC
#ifndef ALLOW_MNC
C     Fix to avoid running without getting any output:
c     myPa_MNC = .FALSE.
#endif
c     myPa_MDSIO = (.NOT. myPa_MNC) .OR. outputTypesInclusive

      _END_MASTER(myThid)

C--   Everyone else must wait for the parameters to be loaded
      _BARRIER

#endif /* ALLOW_ATM_PHYS */

      RETURN
      END

#include "FIZHI_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 0
C     !ROUTINE: FIZHI_MNC_INIT

C     !INTERFACE:
      SUBROUTINE FIZHI_READPARMS( myThid )

C     !DESCRIPTION:
C     Read Fizhi Namelist and Get the Model Date and Time from File

C     !USES:
      implicit none

#include "chronos.h"
#include "SIZE.h"
#include "fizhi_ocean_coms.h"
#include "fizhi_io_comms.h"
#include "EEPARAMS.h"
#include "PARAMS.h"

C     !INPUT PARAMETERS:
      integer myThid
CEOP

C     !LOCAL VARIABLES:
      character*(MAX_LEN_MBUF) msgBuf
      integer ku, ku2
      integer nymdbegin, nhmsbegin
      integer nymdcurrent, nhmscurrent
      real runlength
      integer  nincr
      integer mmdd,hhmmss,nsecf2
      integer nymdend,nhmsend
      logical climsst, climsice

      namelist / fizhi_list /
     &     nymdbegin, nhmsbegin,
     &     fizhi_mnc_write_pickup, fizhi_mnc_read_pickup,
     &     runlength, climsst, climsice

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      IF ( .NOT.useFizhi ) THEN
C-    pkg FIZHI is not used
        _BEGIN_MASTER(myThid)
C-    Track pkg activation status:
C     print a (weak) warning if data.fizhi is found
         CALL PACKAGES_UNUSED_MSG( 'useFizhi', ' ', ' ' )
        _END_MASTER(myThid)
        RETURN
      ENDIF

C     Set defaults
      fizhi_mdsio_read_pickup = .TRUE.
      fizhi_mdsio_write_pickup = .TRUE.
      fizhi_mnc_write_pickup = .FALSE.
      fizhi_mnc_read_pickup = .FALSE.
      runlength = 0.0
      climsst = .TRUE.
      climsice = .TRUE.

C     Read Fizhi Namelist
      WRITE(msgBuf,'(A)') ' FIZHI_READPARMS: opening data.fizhi'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,SQUEEZE_RIGHT,1)

      CALL OPEN_COPY_DATA_FILE('data.fizhi', 'FIZHI_READPARMS',
     &     ku,myThid )
      read  (ku,NML=fizhi_list)
#ifdef SINGLE_DISK_IO
      CLOSE(ku)
#else
      CLOSE(ku,STATUS='DELETE')
#endif /* SINGLE_DISK_IO */

C     Read Supplemental Ascii File with Current Time Info
      CALL MDSFINDUNIT( ku2, myThid )
      open(ku2,file='datetime0',form='formatted')
      read(ku2,1000)nymdcurrent,nhmscurrent
      close (ku2)
 1000 format(i8,2x,i6)

C Change the length of the model run, ie, change ntimesteps
C  if runlength has been set in the fizhi namelist

      if(runlength.gt.0.) then
       mmdd = int(runlength)
       hhmmss = int((runlength - int(runlength))*1.e6)
       if(mmdd.lt.100) then
        nincr = nsecf2(hhmmss,mmdd,nymdcurrent)
       else
        call time2freq2(mmdd,nymdcurrent,nhmscurrent,nincr)
       endif
       nTimeSteps = int(nincr/deltaT)
       nEndIter = nIter0 + nTimeSteps
       endTime = startTime + deltaT*float(nTimeSteps)
       WRITE(msgBuf,'(A,I10)')
     &         ' CHANGING NUMBER OF MODEL TIMESTEPS TO',ntimesteps
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,SQUEEZE_RIGHT,1)
       WRITE(msgBuf,'(A,F12.2)') ' CHANGING END TIME TO',endtime
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,SQUEEZE_RIGHT,1)
      endif

C     Fill chronos Common Block with Namelist and Other File Info
      nymd0 = nymdbegin
      nhms0 = nhmsbegin
      nymd = nymdcurrent
      nhms = nhmscurrent

C     Fill ocean params common block with namelist into
      sstclim = climsst
      siceclim = climsice

C     Echo Date and Time Info
      _BEGIN_MASTER(myThid)
      print *, '  Begin Date ',nymd0,'   Begin Time ',nhms0
      print *, 'Current Date ',nymd,' Current Time ',nhms
      _END_MASTER(myThid)

      return
      end

#include "PACKAGES_CONFIG.h"
#include "CPP_OPTIONS.h"
#ifdef ALLOW_AUTODIFF
# include "AUTODIFF_OPTIONS.h"
#endif

CBOP
C     !ROUTINE: SOLVE_TRIDIAGONAL
C     !INTERFACE:
      SUBROUTINE SOLVE_TRIDIAGONAL(
     I                     iMin,iMax, jMin,jMax,
     I                     a3d, b3d, c3d,
     U                     y3d,
     O                     errCode,
     I                     bi, bj, myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R SOLVE_TRIDIAGONAL
C     | o Solve a tri-diagonal system A*X=Y (dimension Nr)
C     *==========================================================*
C     | o Used to solve implicitly vertical advection & diffusion
#ifdef SOLVE_DIAGONAL_LOWMEMORY
C     | o Allows 2 types of call:
C     | 1) with INPUT errCode < 0 (first call):
C     |   Solve system A*X=Y by LU decomposition and return
C     |     inverse matrix as output (in a3d,b3d,c3d)
C     | 2) with INPUT errCode = 0 (subsequent calls):
C     |   Solve system A*Xp=Yp by using inverse matrix coeff
C     |     from first call output.
#endif /* SOLVE_DIAGONAL_LOWMEMORY */
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     == Global data ==
#include "SIZE.h"
#include "EEPARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     -- INPUT: --
C     iMin,iMax,jMin,jMax  :: computational domain
C     a3d     :: matrix lower diagnonal
C     b3d     :: matrix main  diagnonal
C     c3d     :: matrix upper diagnonal
C     y3d     :: Y vector (R.H.S.);
C     bi,bj   :: tile indices
C     myThid  :: thread number
C     -- OUTPUT: --
C     y3d     :: X = solution of A*X=Y
C     errCode :: > 0 if singular matrix
#ifdef SOLVE_DIAGONAL_LOWMEMORY
C     a3d,b3d,c3d :: inverse matrix coeff to enable to find Xp solution
C                    of A*Xp=Yp with subsequent call to this routine
#endif /* SOLVE_DIAGONAL_LOWMEMORY */
      INTEGER iMin,iMax,jMin,jMax
      _RL a3d(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL b3d(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL c3d(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL y3d(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      INTEGER errCode
      INTEGER bi, bj, myThid

C     !LOCAL VARIABLES:
C     == Local variables ==
      INTEGER i,j,k
      _RL tmpVar
#ifndef SOLVE_DIAGONAL_LOWMEMORY
      _RL recVar
      _RL y3d_m1(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
# ifdef SOLVE_DIAGONAL_KINNER
      _RL c3d_m1(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL c3d_prime(Nr)
      _RL y3d_prime(Nr)
      _RL y3d_update(Nr)
#  ifdef ALLOW_AUTODIFF_TAMC
C     kkey :: tape key, depends on i,j,k
      INTEGER kkey
#  endif
# else
      _RL c3d_prime(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL y3d_prime(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
# endif
#endif /* SOLVE_DIAGONAL_LOWMEMORY */
CEOP

#ifdef SOLVE_DIAGONAL_LOWMEMORY

      IF ( errCode .LT. 0 ) THEN
       errCode = 0

C--   forward sweep (starting from top) part-1: matrix L.U decomposition
       DO j=jMin,jMax
        DO i=iMin,iMax
          IF ( b3d(i,j,1).NE.0. _d 0 ) THEN
            b3d(i,j,1) = 1. _d 0 / b3d(i,j,1)
          ELSE
            b3d(i,j,1) = 0. _d 0
            errCode = 1
          ENDIF
        ENDDO
       ENDDO

C-    Middle of forward sweep
       DO k=2,Nr
        DO j=jMin,jMax
         DO i=iMin,iMax
          tmpVar = b3d(i,j,k) - a3d(i,j,k)*c3d(i,j,k-1)*b3d(i,j,k-1)
          IF ( tmpVar .NE. 0. _d 0 ) THEN
            b3d(i,j,k) = 1. _d 0 / tmpVar
          ELSE
            b3d(i,j,k) = 0. _d 0
            errCode = 1
          ENDIF
         ENDDO
        ENDDO
       ENDDO

C--   end if errCode < 0
      ENDIF

C--   forward sweep (starting from top) part-2: process RHS
      DO j=jMin,jMax
       DO i=iMin,iMax
         y3d(i,j,1) = y3d(i,j,1)*b3d(i,j,1)
       ENDDO
      ENDDO
      DO k=2,Nr
       DO j=jMin,jMax
        DO i=iMin,iMax
         y3d(i,j,k) = ( y3d(i,j,k)
     &                - a3d(i,j,k)*y3d(i,j,k-1)
     &                )*b3d(i,j,k)
        ENDDO
       ENDDO
      ENDDO

C--   backward sweep (starting from bottom)
      DO k=Nr-1,1,-1
       DO j=jMin,jMax
        DO i=iMin,iMax
          y3d(i,j,k) = y3d(i,j,k)
     &               - c3d(i,j,k)*b3d(i,j,k)*y3d(i,j,k+1)
        ENDDO
       ENDDO
      ENDDO

#else /* ndef SOLVE_DIAGONAL_LOWMEMORY */

      errCode = 0

#ifdef SOLVE_DIAGONAL_KINNER
#ifdef ALLOW_AUTODIFF_TAMC
CADJ INIT loctape_solvetri = COMMON, Nr*(sNy+2*OLy)*(sNx+2*OLx)
#endif
C--   Temporary array
      DO k=1,Nr
       DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
         c3d_m1(i,j,k) = c3d(i,j,k)
         y3d_m1(i,j,k) = y3d(i,j,k)
        ENDDO
       ENDDO
      ENDDO

C--   Main loop
      DO j=1-OLy,sNy+OLy
       DO i=1-OLx,sNx+OLx

        DO k=1,Nr
         c3d_prime(k) = 0. _d 0
         y3d_prime(k) = 0. _d 0
         y3d_update(k) = 0. _d 0
        ENDDO

C--   Forward sweep
        DO k=1,Nr
#ifdef ALLOW_AUTODIFF_TAMC
          kkey = k + Nr*(i-1+OLx) + Nr*(sNx+2*OLx)*(j-1+OLy)
CADJ STORE c3d_prime(k) = loctape_solvetri, key = kkey
CADJ STORE y3d_prime(k) = loctape_solvetri, key = kkey
#endif
         IF ( k.EQ.1 ) THEN
           IF ( b3d(i,j,1).NE.0. _d 0 ) THEN
             c3d_prime(1) = c3d_m1(i,j,1) / b3d(i,j,1)
             y3d_prime(1) = y3d_m1(i,j,1) / b3d(i,j,1)
           ELSE
             c3d_prime(1) = 0. _d 0
             y3d_prime(1) = 0. _d 0
             errCode = 1
           ENDIF
         ELSE
           tmpVar = b3d(i,j,k) - a3d(i,j,k)*c3d_prime(k-1)
           IF ( tmpVar .NE. 0. _d 0 ) THEN
             recVar = 1. _d 0 / tmpVar
             c3d_prime(k) = c3d_m1(i,j,k)*recVar
             y3d_prime(k) = (y3d_m1(i,j,k) - y3d_prime(k-1)*a3d(i,j,k))
     &                      *recVar
           ELSE
             c3d_prime(k) = 0. _d 0
             y3d_prime(k) = 0. _d 0
             errCode = 1
           ENDIF
         ENDIF
        ENDDO

C--   Backward sweep
        DO k=Nr,1,-1
         IF ( k.EQ.Nr ) THEN
          y3d_update(k)=y3d_prime(k)
         ELSE
          y3d_update(k)=y3d_prime(k)-c3d_prime(k)*y3d_update(k+1)
         ENDIF
        ENDDO

C--   Update array
        DO k=1,Nr
         y3d(i,j,k) = y3d_update(k)
        ENDDO

       ENDDO
      ENDDO

#else  /* ndef SOLVE_DIAGONAL_KINNER */

C--   Init. + copy to temp. array
      DO k=1,Nr
       DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
         c3d_prime(i,j,k) = 0. _d 0
         y3d_prime(i,j,k) = 0. _d 0
         y3d_m1(i,j,k) = y3d(i,j,k)
        ENDDO
       ENDDO
      ENDDO

CADJ loop = sequential
C--   Forward sweep
      DO k=1,Nr

       IF ( k .EQ. 1 ) THEN
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          IF ( b3d(i,j,1).NE.0. _d 0 ) THEN
           recVar = 1. _d 0 / b3d(i,j,1)
           c3d_prime(i,j,1) = c3d(i,j,1)*recVar
           y3d_prime(i,j,1) = y3d_m1(i,j,1)*recVar
          ELSE
           c3d_prime(i,j,1) = 0. _d 0
           y3d_prime(i,j,1) = 0. _d 0
           errCode = 1
          ENDIF
         ENDDO
        ENDDO
       ELSE
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          tmpVar = b3d(i,j,k) - a3d(i,j,k)*c3d_prime(i,j,k-1)
          IF ( tmpVar .NE. 0. _d 0 ) THEN
           recVar = 1. _d 0 / tmpVar
           c3d_prime(i,j,k) = c3d(i,j,k)*recVar
           y3d_prime(i,j,k) = ( y3d_m1(i,j,k)
     &                        - a3d(i,j,k)*y3d_prime(i,j,k-1)
     &                        )*recVar
          ELSE
           c3d_prime(i,j,k) = 0. _d 0
           y3d_prime(i,j,k) = 0. _d 0
           errCode = 1
          ENDIF
         ENDDO
        ENDDO
       ENDIF

C-    end k-loop
      ENDDO

CADJ loop = sequential
C--   Backward sweep
      DO k=Nr,1,-1
       IF ( k.EQ.Nr ) THEN
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          y3d(i,j,k) = y3d_prime(i,j,k)
         ENDDO
        ENDDO
       ELSE
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          y3d(i,j,k) = y3d_prime(i,j,k)
     &               - c3d_prime(i,j,k)*y3d(i,j,k+1)
         ENDDO
        ENDDO
       ENDIF
C-    end k-loop
      ENDDO

#endif /* SOLVE_DIAGONAL_KINNER */

#endif /* SOLVE_DIAGONAL_LOWMEMORY */

      RETURN
      END

#include "ECCO_OPTIONS.h"

CBOP
C     !ROUTINE: ECCO_WRITE_PICKUP
C     !INTERFACE:
      SUBROUTINE ECCO_WRITE_PICKUP( permPickup, suff,
     I                              myTime, myIter, myThid )

C     !DESCRIPTION: \bv
C     *================================================================*
C     | SUBROUTINE ECCO_WRITE_PICKUP
C     | o write ecco pickups
C     *================================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "ECCO_SIZE.h"
#include "ECCO.h"

C     !INPUT/OUTPUT PARAMETERS:
C     permPickup :: write a permanent pickup
C     suff    :: suffix for pickup file (eg. ckptA or 0000000010)
C     myTime  :: Current time in simulation
C     myIter  :: Current iteration number in simulation
C     myThid  :: My Thread Id number
      LOGICAL permPickup
      CHARACTER*(*) suff
      _RL     myTime
      INTEGER myIter
      INTEGER myThid

#ifdef ALLOW_PSBAR_STERIC
C     !LOCAL VARIABLES:
      CHARACTER*(MAX_LEN_FNAM) fn
c     CHARACTER*(MAX_LEN_MBUF) msgBuf
      INTEGER prec, ioUnit
      _RL tmparr(2), dummyRS(1)
CEOP

      WRITE(fn,'(A,A10)') 'pickup_ecco.',suff
      IF ( fn .NE. ' ' ) THEN
        ioUnit = 0
        prec = precFloat64

        tmparr(1) = VOLsumGlob_0
        tmparr(2) = RHOsumGlob_0
#ifdef ALLOW_MDSIO
        CALL MDS_WRITEVEC_LOC(
     I             fn, prec, ioUnit,
     I             'RL', 2, tmparr, dummyRS,
     I             0, 0, 1, myIter, myThid )
#else
        STOP 'ABNORMAL END: S/R ECCO_WRITE_PICKUP: Needs MDSIO pkg'
#endif
      ENDIF

#endif /*  ALLOW_PSBAR_STERIC  */

      RETURN
      END

#include "MYPACKAGE_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C !ROUTINE: MYPACKAGE_INIT_VARIA

C !INTERFACE:
      SUBROUTINE MYPACKAGE_INIT_VARIA( myThid )

C     !DESCRIPTION:
C     Initialize MYPACKAGE variables

C     !USES:
      IMPLICIT NONE
C     == Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "MYPACKAGE.h"

C     !INPUT/OUTPUT PARAMETERS:
C     myThid ::  my Thread Id number
      INTEGER myThid
CEOP

C     !LOCAL VARIABLES:
      INTEGER i,j,k,bi,bj

      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)

C     Initialize arrays in common blocks :
C     3-dim.
        DO k=1,Nr
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
#ifdef MYPACKAGE_3D_STATE
           myPa_StatScal1(i,j,k,bi,bj) = 0. _d 0
           myPa_StatScal2(i,j,k,bi,bj) = 0. _d 0
           myPa_StatVelU (i,j,k,bi,bj) = 0. _d 0
           myPa_StatVelV (i,j,k,bi,bj) = 0. _d 0
#endif /* MYPACKAGE_3D_STATE */
#ifdef MYPACKAGE_TENDENCY
           myPa_TendScal1(i,j,k,bi,bj) = 0. _d 0
           myPa_TendScal2(i,j,k,bi,bj) = 0. _d 0
           myPa_TendVelU (i,j,k,bi,bj) = 0. _d 0
           myPa_TendVelV (i,j,k,bi,bj) = 0. _d 0
#endif /* MYPACKAGE_TENDENCY */
          ENDDO
         ENDDO
        ENDDO

C     2-dim.
#ifdef MYPACKAGE_2D_STATE
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          myPa_Surf1(i,j,bi,bj) = 0. _d 0
          myPa_Surf2(i,j,bi,bj) = 0. _d 0
         ENDDO
        ENDDO
#endif /* MYPACKAGE_2D_STATE */

C- end bi,bj loops
       ENDDO
      ENDDO

      IF ( startTime.EQ.baseTime .AND. nIter0.EQ.0
     &                           .AND. pickupSuff.EQ.' ' ) THEN

C     Prevent loading of new data before everyone has finished initialisation
C     this is done within IO routines => no longer needed
c      _BARRIER

#ifdef MYPACKAGE_3D_STATE
       IF ( myPa_Scal1File .NE. ' ' ) THEN
         CALL READ_FLD_XYZ_RL( myPa_Scal1File, ' ',
     &                         myPa_StatScal1, 0, myThid )
         CALL EXCH_3D_RL( myPa_StatScal1, Nr, myThid )
       ENDIF
       IF ( myPa_Scal2File .NE. ' ' ) THEN
         CALL READ_FLD_XYZ_RL( myPa_Scal2File, ' ',
     &                         myPa_StatScal2, 0, myThid )
         CALL EXCH_3D_RL( myPa_StatScal2, Nr, myThid )
       ENDIF

       IF ( myPa_VelUFile .NE. ' ' ) THEN
         CALL READ_FLD_XYZ_RL( myPa_VelUFile, ' ',
     &                         myPa_StatVelU, 0, myThid )
       ENDIF
       IF ( myPa_VelVFile .NE. ' ' ) THEN
         CALL READ_FLD_XYZ_RL( myPa_VelVFile, ' ',
     &                         myPa_StatVelV, 0, myThid )
       ENDIF
       IF ( myPa_VelUFile .NE. ' ' .OR.
     &      myPa_VelVFile .NE. ' ' ) THEN
        IF ( myPa_StaV_Cgrid ) THEN
         CALL EXCH_UV_3D_RL( myPa_StatVelU, myPa_StatVelV,
     &                       .TRUE., Nr, myThid )
        ELSE
C-      Assume Agrid position:
         CALL EXCH_UV_AGRID_3D_RL( myPa_StatVelU, myPa_StatVelV,
     &                       .TRUE., Nr, myThid )
        ENDIF
       ENDIF
#endif /* MYPACKAGE_3D_STATE */

#ifdef MYPACKAGE_2D_STATE
       IF ( myPa_Surf1File .NE. ' ' ) THEN
         CALL READ_FLD_XY_RL( myPa_Surf1File,' ',
     &                        myPa_Surf1, 0, myThid )
         CALL EXCH_XY_RL( myPa_Surf1, myThid )
       ENDIF
       IF ( myPa_Surf2File .NE. ' ' ) THEN
         CALL READ_FLD_XY_RL( myPa_Surf2File,' ',
     &                        myPa_Surf2, 0, myThid )
         CALL EXCH_XY_RL( myPa_Surf2, myThid )
       ENDIF
#endif /* MYPACKAGE_2D_STATE */

      ELSE
C--   restart from a pickup:
         CALL MYPACKAGE_READ_PICKUP( nIter0, myThid )

C--   end start-from-iter-zero if/else block
      ENDIF

      RETURN
      END

#include "ADMTLM_OPTIONS.h"

      subroutine admtlm_map( myThid )
C     /==========================================================\
C     | subroutine admtlm_map                                    |
C     | o This routine assigns final T,S to cost function        |
C     \==========================================================/
       implicit none

C     == Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#ifdef ALLOW_ADMTLM
# include "adcost.h"
# include "g_cost.h"
#endif

C     ======== Routine arguments ======================
C     myThid - Thread number for this instance of the routine.
      integer myThid

#ifdef ALLOW_ADMTLM
C     ========= Local variables =========================
      integer i, j, k
      integer bi, bj

      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        DO j=1,sNy
         DO i=1,sNx
          DO k=1,4*Nr
            adobjf_state_final(i,j,bi,bj,k) =
     &       g_objf_state_final(i,j,bi,bj,k)
          END DO
           adobjf_state_final(i,j,bi,bj,4*Nr+1) =
     &      g_objf_state_final(i,j,bi,bj,4*Nr+1)
         END DO
        END DO
       END DO
      END DO

#endif

      end

#include "RW_OPTIONS.h"

CBOP
C !ROUTINE: READ_GLVEC_RS
C !INTERFACE:
      SUBROUTINE READ_GLVEC_RS(
     I                          pref, suff,
     O                          array,
     I                          sizArr, iRec, myThid )

C !DESCRIPTION:
C READ_GLVEC_RS
C  is a "front-end" interface to the low-level MDS I/O routines.
C  Reads a global (=tile independent) vector.

C !USES:
      IMPLICIT NONE

C == Global Variables
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"

C !INPUT PARAMETERS:
      CHARACTER*(*) pref,suff
      INTEGER sizArr
      _RS     array(sizArr)
      INTEGER iRec
      INTEGER myThid

C !FUNCTIONS:
      INTEGER  ILNBLNK, IFNBLNK
      EXTERNAL ILNBLNK, IFNBLNK

C !LOCAL VARIABLES:
      _RL     dummyRL(1)
      CHARACTER*(2) fType
      INTEGER ioUnit, bi, bj
      INTEGER s1Lo,s1Hi,s2Lo,s2Hi
      CHARACTER*(MAX_LEN_FNAM) fullName
CEOP

C--   Build file name
C     Name has form 'prefix.suffix'
C     e.g. U.0000000100
      s1Lo = IFNBLNK(pref)
      s1Hi = ILNBLNK(pref)
      IF ( suff .EQ. ' ' ) THEN
       WRITE( fullName, '(A)' ) pref(s1Lo:s1Hi)
      ELSE
       s2Lo = IFNBLNK(suff)
       s2Hi = ILNBLNK(suff)
       WRITE( fullName, '(A,A)' ) pref(s1Lo:s1Hi),suff(s2Lo:s2Hi)
      ENDIF

      ioUnit = 0
      fType ='RS'
      bi = 0
      bj = 0
#ifdef ALLOW_MDSIO
      CALL MDS_READVEC_LOC(
     &                       fullName, readBinaryPrec, ioUnit,
     &                       fType, sizArr, dummyRL, array,
     I                       bi, bj, iRec, myThid )
#else
      STOP 'ABNORMAL END: S/R READ_GLVEC_RS needs MDSIO pkg'
#endif

      RETURN
      END

#include "AUTODIFF_OPTIONS.h"
#include "MDSIO_OPTIONS.h"
#ifdef ALLOW_CTRL
# include "CTRL_OPTIONS.h"
#endif

CBOP
C !ROUTINE: AUTODIFF_WHTAPEIO_SYNC

C !INTERFACE: ==========================================================
      SUBROUTINE AUTODIFF_WHTAPEIO_SYNC(
     I     myLev, myStep, myThid )
C !DESCRIPTION:

C     For myStep = 0, open tape file on disk for checkpoint level myLev
C     and store tape file unit in global variable tapeFileUnitS(myLev).
C
C     For myStep = 1, write fld3d_procbuff_rX to tape files for
C     checkpoint level myLev

C !USES: ===============================================================
      IMPLICIT NONE
C     == Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "CTRL_SIZE.h"
#include "CTRL.h"
#ifndef ALLOW_OPENAD
# include "AUTODIFF.h"
#endif
#ifdef ALLOW_WHIO_3D
# ifdef ALLOW_AUTODIFF_TAMC
#  include "tamc.h"
# endif
# include "MDSIO_BUFF_WH.h"
#endif

C !INPUT PARAMETERS: ===================================================
C     myLev     :: tape level identifier
C     myStep    :: identifies from where this routine is called
C                  (1,0 = before after ad-routines)
C     myThid    :: my Thread Id number
      INTEGER myLev
      INTEGER myStep
      INTEGER myThid

#ifdef ALLOW_AUTODIFF_WHTAPEIO

C !FUNCTIONS: =========================================================
      INTEGER  ILNBLNK
      INTEGER  MDS_RECLEN
      EXTERNAL ILNBLNK
      EXTERNAL MDS_RECLEN

C !LOCAL VARIABLES: ====================================================
      CHARACTER*(MAX_LEN_FNAM) fName
      INTEGER filePrec, IL, length_of_rec
      LOGICAL iAmDoingIO

C     sNxWh :: x tile size with halo included
C     sNyWh :: y tile size with halo included
C     pocNyWh :: processor sum of sNyWh
C     gloNyWh :: global sum of sNyWh
      INTEGER sNxWh
      INTEGER sNyWh
      INTEGER procNyWh
      INTEGER gloNyWh
      PARAMETER ( sNxWh = sNx+2*OLx )
      PARAMETER ( sNyWh = sNy+2*OLy )
      PARAMETER ( procNyWh = sNyWh*nSy*nSx )
      PARAMETER ( gloNyWh = procNyWh*nPy*nPx )
      logical  exst
#ifdef ALLOW_WHIO_3D
      CHARACTER*(MAX_LEN_MBUF) msgBuf
#endif
CEOP

      IF ( .NOT.useAUTODIFF ) THEN
       RETURN
      ENDIF

      IF ( tapeConcatIO ) THEN

       IF ( doSinglePrecTapelev ) THEN
        filePrec = 32
       ELSE
        filePrec = 64
       ENDIF

C Only do I/O if I am the master thread (and mpi process 0 IF tapeSingleCpuIO):
       iAmDoingIO = .FALSE.
       IF ( .NOT.tapeSingleCpuIO .OR. myProcId.EQ.0 ) THEN
        _BEGIN_MASTER( myThid )
        iAmDoingIO = .TRUE.
        _END_MASTER( myThid )
       ENDIF

       IF ( iAmDoingIO ) THEN
        IL = ilnblnk( adTapeDir )
        IF ( .NOT.tapeSingleCpuIO ) THEN
         WRITE(fName,'(2A,I1.1,A,I3.3,A)')
     &         adTapeDir(1:IL),'tapes',myLev,'.',myProcId,'.data'
         length_of_rec = MDS_RECLEN( filePrec,sNxWh*procNyWh,myThid )
        ELSE
         WRITE(fName,'(2A,I1.1,A)')
     &         adTapeDir(1:IL),'tapes',myLev,'.data'
         length_of_rec = MDS_RECLEN( filePrec,sNxWh*gloNyWh,myThid)
        ENDIF
       ENDIF
#ifdef ALLOW_WHIO_3D
       length_of_rec=length_of_rec*nWh
#endif

       tapeFileUnit=tapeFileUnitS(myLev)
       tapeFileCounter=0

       IF ( iAmDoingIO.AND.(myStep.EQ.0).AND.
     &      (myLev.GT.0).AND.(tapeFileUnit.EQ.0) ) THEN
        inquire( file=fName, exist=exst )
#ifdef AUTODIFF_USE_MDSFINDUNITS
        CALL MDSFINDUNIT( tapeFileUnit, myThid )
#else
        CALL AUTODIFF_FINDUNIT( tapeFileUnit, myThid )
#endif
        OPEN( tapeFileUnit, file=fName, status='unknown',
     &         access='direct', recl=length_of_rec )
        tapeFileUnitS(myLev)=tapeFileUnit
#if (defined (ALLOW_INIT_WHTAPEIO) && defined (ALLOW_WHIO_3D))
c exst needs to have been tested before opening the file
        IF (.NOT.exst) then
         iWh=tapeMaxCounter*MAX(nchklev_2,nchklev_3)/nWh+1
         WRITE(msgBuf,'(a,i1,a,i3)') 'whio : create lev ',
     &         myLev,' rec ',iWh
         CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                       SQUEEZE_RIGHT, myThid )
         IF ( .NOT.tapeSingleCpuIO ) then
          IF (filePrec .EQ. precFloat32) THEN
           WRITE(tapeFileUnit,rec=iWh) fld3d_procbuff_r4
          ELSE
           WRITE(tapeFileUnit,rec=iWh) fld3d_procbuff_r8
          ENDIF
         ELSE
#  ifdef INCLUDE_WHIO_GLOBUFF_3D
          IF (filePrec .EQ. precFloat32) THEN
           WRITE(tapeFileUnit,rec=iWh) fld3d_globuff_r4
          ELSE
           WRITE(tapeFileUnit,rec=iWh) fld3d_globuff_r8
          ENDIF
#  endif
         ENDIF
         iWh=0
        ENDIF
#endif
       ENDIF

#ifdef ALLOW_WHIO_3D
       _BARRIER
       IF ((myStep.EQ.1).AND.iAmDoingIO.AND.
     &      tapeBufferIO.AND.writeWh) THEN
        IF (iWh.LT.1) STOP 'S/R AUTODIFF_WHTAPEIO_SYNC: iWh<1'
        WRITE(msgBuf,'(a,i1,a,i3)') 'whio : write lev ',
     &       myLev,' rec ',iWh
        CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
        IF ( .NOT.tapeSingleCpuIO ) then
         IF (filePrec .EQ. precFloat32) THEN
          WRITE(tapeFileUnit,rec=iWh) fld3d_procbuff_r4
         ELSE
          WRITE(tapeFileUnit,rec=iWh) fld3d_procbuff_r8
         ENDIF
        ELSE
#  ifdef INCLUDE_WHIO_GLOBUFF_3D
         IF (filePrec .EQ. precFloat32) THEN
          WRITE(tapeFileUnit,rec=iWh) fld3d_globuff_r4
         ELSE
          WRITE(tapeFileUnit,rec=iWh) fld3d_globuff_r8
         ENDIF
#  endif
        ENDIF
       ENDIF
       _BARRIER

       IF (myStep.EQ.0) THEN
        tapeBufferIO=.TRUE.
       ELSE
        tapeBufferIO=.FALSE.
        writeWh=.FALSE.
       ENDIF
       iWh=0
       jWh=0
#endif /* ALLOW_WHIO_3D */

      ENDIF !IF ( tapeConcatIO ) THEN

#endif /* ALLOW_AUTODIFF_WHTAPEIO */

      RETURN
      END

#include "DIAG_OPTIONS.h"

CBOP
C     !ROUTINE: DIAGNOSTICS_SET_POINTERS
C     !INTERFACE:
      SUBROUTINE DIAGNOSTICS_SET_POINTERS( myThid )

C     !DESCRIPTION: \bv
C     *==================================================================
C     | S/R DIAGNOSTICS_SET_POINTERS
C     | o set pointers for active diagnostics
C     *==================================================================
C     \ev

C     !USES:
      IMPLICIT NONE

C     == Global variables ===
#include "EEPARAMS.h"
#include "SIZE.h"
#include "DIAGNOSTICS_SIZE.h"
#include "DIAGNOSTICS_P2SHARE.h"
#include "DIAGNOSTICS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     myThid :: my Thread Id. number
      INTEGER myThid
CEOP

C     !LOCAL VARIABLES:
C     == Local variables ==
      INTEGER ndiagcount, ndCount
      INTEGER md,ld,nd
      INTEGER mate, nActiveMax
      INTEGER i, j, k, k1, k2, kLev
      LOGICAL found
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      CHARACTER*12 suffix

      _BEGIN_MASTER( myThid)

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C--   In case an output file contains 2 post-processed diags which are computed
C     together (mate of 2nd PP-diag one is 1rst PP-diag), move these 2 diags
C     next to each other (to only computate them once): 1rst one then 2nd one.
      DO ld=1,nlists
       found = .FALSE.
       DO md=1,nfields(ld)
C        Search all possible model diagnostics
         nd = 0
         DO i=1,ndiagt
          IF ( nd.EQ.0 .AND. flds(md,ld).EQ.cdiag(i) ) nd = i
         ENDDO
         j  = 0
         IF ( nd.GE.1 ) THEN
           IF ( gdiag(nd)(5:5).EQ.'P' ) THEN
             mate = hdiag(nd)
             IF ( gdiag(mate)(5:5).EQ.'P' ) THEN
C        Mate of Post-Processed diag "nd" is also Post-Processed
               DO i=1,nfields(ld)
                 IF ( j.EQ.0 .AND. flds(i,ld).EQ.cdiag(mate) ) j = i
               ENDDO
             ENDIF
           ENDIF
         ENDIF
C        And is found in the same output stream "ld" (at rank "j")
         IF ( j.GE.1 .AND. j.NE.md-1 ) THEN
           IF ( .NOT.found ) THEN
             WRITE(msgBuf,'(3A)') 'DIAGNOSTICS_SET_POINTERS: ',
     &             'Re-Order Diags in Outp.Stream: ',fnames(ld)
             CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                           SQUEEZE_RIGHT, myThid )
           ENDIF
           found  = .TRUE.
           IF ( j.LT.md-1 ) THEN
             WRITE(msgBuf,'(2A,2(A,I4),2A)')
     &         ' move ',flds(j,ld),' from ',j,' down to',md-1,
     &         ' just before ',flds(md,ld)
             CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                           SQUEEZE_RIGHT, myThid )
             DO i=j,md-2
               flds(i,ld) = flds(i+1,ld)
             ENDDO
             flds(md-1,ld) = cdiag(mate)
           ELSEIF ( j.GT.md ) THEN
             WRITE(msgBuf,'(2A,2(A,I4),2A)')
     &         ' move ',flds(j,ld),' from ',j,'  up to ',md,
     &         ' just before ',flds(md,ld)
             CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                           SQUEEZE_RIGHT, myThid )
             DO i=j,md+1,-1
               flds(i,ld) = flds(i-1,ld)
             ENDDO
             flds(md,ld) = cdiag(mate)
           ENDIF
         ENDIF
       ENDDO
       IF ( found ) THEN
         WRITE(msgBuf,'(2A,I4,A)') 'DIAGNOSTICS_SET_POINTERS: ',
     &             'Updated list in Outp.Stream #', ld, ' :'
         CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                       SQUEEZE_RIGHT, myThid )
         DO md = 1,nfields(ld),10
           j = MIN(nfields(ld),md+9)
           WRITE(msgBuf,'(21A)') ' Fields:   ',(' ',flds(i,ld),i=md,j)
           CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                         SQUEEZE_RIGHT, myThid )
         ENDDO
       ENDIF
      ENDDO

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C--   Initialize pointer arrays to zero:
      DO ld=1,numLists
       DO md=1,numperList
        idiag(md,ld) = 0
        jdiag(md,ld) = 0
        mdiag(md,ld) = 0
       ENDDO
      ENDDO

C--   Calculate pointers for diagnostics in active output-stream
C                                   (i.e., with defined filename)

      ndiagcount = 0
      nActiveMax = 0
      DO ld=1,nlists
       nActive(ld) = nfields(ld)
       DO md=1,nfields(ld)

         found = .FALSE.
C        Search all possible model diagnostics
         DO nd=1,ndiagt
          IF ( flds(md,ld).EQ.cdiag(nd) ) THEN
            CALL DIAGNOSTICS_SETDIAG(mate,ndiagcount,md,ld,nd,myThid)
            found = .TRUE.
          ENDIF
         ENDDO
         IF ( .NOT.found ) THEN
           CALL DIAGNOSTICS_LIST_CHECK(
     O                      ndCount,
     I                      ld, md, nlists, nfields, flds, myThid )
           IF ( ndCount.EQ.0 ) THEN
             WRITE(msgBuf,'(3A)') 'DIAGNOSTICS_SET_POINTERS: ',
     &                      flds(md,ld),' is not a Diagnostic'
             CALL PRINT_ERROR( msgBuf , myThid )
           ENDIF
           STOP 'ABNORMAL END: S/R DIAGNOSTICS_SET_POINTERS'
         ENDIF

       ENDDO
       nActiveMax = MAX(nActive(ld),nActiveMax)
      ENDDO

      IF (  ndiagcount.LE.numDiags .AND.
     &      nActiveMax.LE.numperList ) THEN
        WRITE(msgBuf,'(A,I8,A)')
     &    '  space allocated for all diagnostics:',
     &    ndiagcount, ' levels'
        CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
      ELSE
       IF ( ndiagcount.GT.numDiags ) THEN
         WRITE(msgBuf,'(2A)')
     &    'DIAGNOSTICS_SET_POINTERS: Not enough space',
     &    ' for all active diagnostics (from data.diagnostics)'
         CALL PRINT_ERROR( msgBuf , myThid )
         WRITE(msgBuf,'(A,I8,A,I8)')
     &    'DIAGNOSTICS_SET_POINTERS: numDiags=', numDiags,
     &    ' but needs at least', ndiagcount
         CALL PRINT_ERROR( msgBuf , myThid )
       ENDIF
       IF ( nActiveMax.GT.numperList ) THEN
         WRITE(msgBuf,'(2A)')
     &    'DIAGNOSTICS_SET_POINTERS: Not enough space',
     &    ' for all active diagnostics (from data.diagnostics)'
         CALL PRINT_ERROR( msgBuf , myThid )
         WRITE(msgBuf,'(A,I6,A,I6)')
     &    'DIAGNOSTICS_SET_POINTERS: numperList=', numperList,
     &    ' but needs at least', nActiveMax
         CALL PRINT_ERROR( msgBuf , myThid )
       ENDIF
       STOP 'ABNORMAL END: S/R DIAGNOSTICS_SET_POINTERS'
      ENDIF

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C--   Set pointer for mate (e.g.vector component mate) if not already done
C     and if it exists. Note: for now, only used to print message.
      DO ld=1,nlists
       DO md=1,nActive(ld)
        IF (mdiag(md,ld).EQ.0 ) THEN

         k = SIGN(1,jdiag(md,ld))
         nd = ABS(jdiag(md,ld))
         mate = hdiag(nd)
         IF ( mate.GT.0 ) THEN
          DO j=1,nlists
           DO i=1,nActive(j)
            IF ( mdiag(md,ld).EQ.0 .AND. (k*jdiag(i,j)).EQ.mate ) THEN
             IF ( freq(j).EQ.freq(ld) .AND. phase(j).EQ.phase(ld)
     &           .AND. averageFreq(j) .EQ.averageFreq(ld)
     &           .AND. averagePhase(j).EQ.averagePhase(ld)
     &           .AND. averageCycle(j).EQ.averageCycle(ld) )
     &          mdiag(md,ld) = ABS(idiag(i,j))
            ENDIF
           ENDDO
          ENDDO
         ENDIF
         IF ( mdiag(md,ld).NE.0 ) THEN
          WRITE(msgBuf,'(A,I6,5A,I6)') '  set mate pointer for diag #',
     &         nd, '  ', cdiag(nd), ' , Parms: ', gdiag(nd)(1:10),
     &             ' , mate:', hdiag(nd)
          CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                        SQUEEZE_RIGHT, myThid )
         ENDIF

        ENDIF
       ENDDO
      ENDDO

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C--   Set internal parameter "useDiag4AdjOutp" if Adj Diagnostics are found
      DO ld=1,nlists
       DO md=1,nfields(ld)
c      DO md=1,nActive(ld)
         nd = ABS(jdiag(md,ld))
         useDiag4AdjOutp = useDiag4AdjOutp
     &                .OR. ( gdiag(nd)(4:4).EQ.'A' )
       ENDDO
      ENDDO

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C--   Set list of levels to write (if not specified in data.diagnostics)

      DO ld=1,nlists
        IF ( nlevels(ld).EQ.-1 ) THEN
C-      set Nb of levels to the minimum size of all diag of this list:
          kLev = numLevels*10
          DO md=1,nfields(ld)
            nd = ABS(jdiag(md,ld))
            kLev = MIN(kdiag(nd),kLev)
          ENDDO
          IF ( kLev.LE.0 ) THEN
            WRITE(msgBuf,'(2A,I4,2A)')
     &      'DIAGNOSTICS_SET_POINTERS: kLev < 1 in',
     &      ' setting levs of list l=',ld,', fnames=', fnames(ld)
            CALL PRINT_ERROR( msgBuf , myThid )
            STOP 'ABNORMAL END: S/R DIAGNOSTICS_SET_POINTERS'
          ELSEIF ( kLev.GT.numLevels ) THEN
            WRITE(msgBuf,'(A,2(I6,A))')
     &      'DIAGNOSTICS_SET_POINTERS: kLev=', kLev,
     &                  ' >', numLevels, ' =numLevels'
            CALL PRINT_ERROR( msgBuf , myThid )
            WRITE(msgBuf,'(2A,I4,2A)') 'DIAGNOSTICS_SET_POINTERS: in',
     &      ' setting levs of list l=',ld,', fnames=', fnames(ld)
            CALL PRINT_ERROR( msgBuf , myThid )
            STOP 'ABNORMAL END: S/R DIAGNOSTICS_SET_POINTERS'
          ENDIF
          nlevels(ld) = kLev
          DO k=1,kLev
           levs(k,ld) = k
          ENDDO
          WRITE(msgBuf,'(3A)') 'DIAGNOSTICS_SET_POINTERS: ',
     &      'Set levels for Outp.Stream: ',fnames(ld)
          CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                        SQUEEZE_RIGHT, myThid )
          suffix = ' Levels:    '
          IF ( fflags(ld)(2:2).EQ.'I' ) suffix = ' Sum Levels:'
          DO k1=1,nlevels(ld),20
            k2 = MIN(nlevels(ld),k1+19)
            WRITE(msgBuf,'(A,20F5.0)') suffix, (levs(k,ld),k=k1,k2)
            CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                          SQUEEZE_RIGHT, myThid )
          ENDDO
        ELSEIF ( fflags(ld)(2:2).NE.'P' ) THEN
C-      if no Vert.Interpolation, check for levels out of range ( > kdiag):
          kLev = 0
          DO k=1,nlevels(ld)
            kLev = MAX(NINT(levs(k,ld)),kLev)
          ENDDO
          DO md=1,nfields(ld)
            nd = ABS(jdiag(md,ld))
            IF ( kLev.GT.kdiag(nd) ) THEN
C- Note: diagnostics_out take care (in some way) of this case
C        so that it does not cause "index out-off bounds" error.
C        However, the output file looks strange.
C- For now, choose to stop, but could change it to just a warning
             WRITE(msgBuf,'(A,I4,A,I6,2A)')
     &       'DIAGNOSTICS_SET_POINTERS: Ask for level=',kLev,
     &         ' in list l=', ld, ', filename: ', fnames(ld)
             CALL PRINT_ERROR( msgBuf , myThid )
             WRITE(msgBuf,'(2A,I4,A,I6,2A)')
     &       'DIAGNOSTICS_SET_POINTERS: ==> exceed Max.Nb of lev.',
     &       '(=',kdiag(nd),') for Diag. #', nd, ' : ',cdiag(nd)
             CALL PRINT_ERROR( msgBuf , myThid )
             WRITE(msgBuf,'(4A)') 'DIAGNOSTICS_SET_POINTERS: ',
     &       ' parsing code >>',gdiag(nd),'<<'
             CALL PRINT_ERROR( msgBuf , myThid )
             STOP 'ABNORMAL END: S/R DIAGNOSTICS_SET_POINTERS'
            ENDIF
          ENDDO
        ENDIF
      ENDDO

      WRITE(msgBuf,'(2A,2(I8,A))') 'DIAGNOSTICS_SET_POINTERS: done',
     &      ', use', ndiagcount, ' levels (numDiags =', numDiags, ' )'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(2A)')
     &   '------------------------------------------------------------'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )

      _END_MASTER( myThid )

      RETURN
      END

#include "PTRACERS_OPTIONS.h"
#ifdef PTRACERS_ALLOW_DYN_STATE

      MODULE PTRACERS_DYN_STATE_MOD

C ptracers internal state data structures
      TYPE PTRACERS_ISTATE
       _RL, POINTER :: som_P(:,:,:,:,:,:)
      END TYPE

      CONTAINS
      SUBROUTINE PTRACERS_INIT_FIXED_DYNAMIC(
     &                                  PTR_ISTATE_ARR,
     &                                  PTRACERS_numInUse,
     &                                  PTRACERS_SOM_Advection,
     &                                  sNx, sNy, Nr, OLx, OLy,
     &                                  nSx, nSy, nSOM,
     &                                  myThid )

        IMPLICIT NONE

        TYPE(PTRACERS_ISTATE), POINTER :: PTR_ISTATE_ARR(:)
        INTEGER PTRACERS_numInUse
        LOGICAL PTRACERS_SOM_Advection(PTRACERS_numInUse)
        INTEGER sNx, sNy, Nr, OLx, OLy, nSx, nSy, nSOM
        INTEGER myThid

        INTEGER iPtr

        ALLOCATE( PTR_ISTATE_ARR(PTRACERS_numInUse) )

        DO iPtr = 1, PTRACERS_numInUse
         IF ( PTRACERS_SOM_Advection(iPtr) ) THEN
          ALLOCATE( PTR_ISTATE_ARR(iPtr)%som_P(1-OLx:sNx+OLx,
     &                                         1-OLy:sNy+OLy,
     &                                         Nr,
     &                                         nSx,
     &                                         nSy,
     &                                         nSOM) )
         ENDIF
        ENDDO

        RETURN
      END SUBROUTINE

      END MODULE
#else
C     some compilers do not like empty files, so ...
      SUBROUTINE PTRACERS_DYN_STATE_MOD_DUMMY
        RETURN
      END
#endif

C Pure tangent mode:

      SUBROUTINE PUSHREAL8_D(V,VD)
      REAL*8 V,VD
      call PUSHREAL8(V)
      call PUSHREAL8(VD)
      END

      SUBROUTINE POPREAL8_D(V,VD)
      REAL*8 V,VD
      call POPREAL8(VD)
      call POPREAL8(V)
      END

      SUBROUTINE PUSHREAL8ARRAY_D(V,VD,size)
      INTEGER size
      REAL*8 V(size),VD(size)
      call PUSHREAL8ARRAY(V,size)
      call PUSHREAL8ARRAY(VD,size)
      END

      SUBROUTINE POPREAL8ARRAY_D(V,VD,size)
      INTEGER size
      REAL*8 V(size),VD(size)
      call POPREAL8ARRAY(VD,size)
      call POPREAL8ARRAY(V,size)
      END

C Multi-directional mode:

      SUBROUTINE PUSHREAL8_DV(V,VD,nbdirs)
      INTEGER nbdirs
      REAL*8 V,VD(nbdirs)
      call PUSHREAL8(V)
      call PUSHREAL8ARRAY(VD,nbdirs)
      END

      SUBROUTINE POPREAL8_DV(V,VD,nbdirs)
      INTEGER nbdirs
      REAL*8 V,VD(nbdirs)
      call POPREAL8ARRAY(VD,nbdirs)
      call POPREAL8(V)
      END

      SUBROUTINE PUSHREAL8ARRAY_DV(V,VD,size,nbdirs)
      INTEGER size,nbdirs
      REAL*8 V(size),VD(size,nbdirs)
      call PUSHREAL8ARRAY(V,size)
      call PUSHREAL8ARRAY(VD,size*nbdirs)
      END

      SUBROUTINE POPREAL8ARRAY_DV(V,VD,size,nbdirs)
      INTEGER size,nbdirs
      REAL*8 V(size),VD(size,nbdirs)
      call POPREAL8ARRAY(VD,size*nbdirs)
      call POPREAL8ARRAY(V,size)
      END

#include "ECCO_OPTIONS.h"

CBOP
C     !ROUTINE: ECCO_READ_PICKUP
C     !INTERFACE:
      SUBROUTINE ECCO_READ_PICKUP( myIter, myThid )

C     !DESCRIPTION: \bv
C     *================================================================*
C     | SUBROUTINE ECCO_READ_PICKUP
C     | o read ecco pickups
C     *================================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "ECCO_SIZE.h"
#include "ECCO.h"

C     !INPUT/OUTPUT PARAMETERS:
C     myThid :: my Thread Id number
      INTEGER myIter
      INTEGER myThid

#ifdef ALLOW_PSBAR_STERIC
C !FUNCTIONS:
      INTEGER ILNBLNK
      EXTERNAL ILNBLNK

C     !LOCAL VARIABLES:
      CHARACTER*(MAX_LEN_FNAM) fn, fntmp
      CHARACTER*(10) suff
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      INTEGER prec, IL, ioUnit
      LOGICAL exst
      _RL tmparr(2), dummyRS(1)
CEOP

C--   Suffix for pickup files
      IF (pickupSuff.EQ.' ') THEN
        IF ( rwSuffixType.EQ.0 ) THEN
          WRITE(suff,'(I10.10)') myIter
        ELSE
          CALL RW_GET_SUFFIX( suff, startTime, myIter, myThid )
        ENDIF
      ELSE
        WRITE(suff,'(A10)') pickupSuff
      ENDIF

      _BEGIN_MASTER(myThid)

      WRITE(fn,'(A,A10)') 'pickup_ecco.', suff
c#ifdef ALLOW_MDSIO
c       useCurrentDir = .FALSE.
c       CALL MDS_CHECK4FILE(
c    I                       fn, '.data', 'ECCO_READ_PICKUP',
c    O                       filNam, fileExist,
c    I                       useCurrentDir, myThid )
c#endif
C-    Check first for global file with simple name (ie. fn)
      INQUIRE( file=fn, exist=exst )
      IF ( .NOT.exst ) THEN
C-    Check for global file with ".data" suffix
        IL  = ILNBLNK( fn )
        WRITE(fntmp,'(2A)') fn(1:IL),'.data'
        INQUIRE( file=fntmp, exist=exst )
      ENDIF

      IF (exst) THEN
        ioUnit = 0
        prec = precFloat64
#ifdef ALLOW_MDSIO
        CALL MDS_READVEC_LOC( fn, prec, ioUnit, 'RL',
     &                        2, tmparr, dummyRS, 0, 0, 1, myThid )
#else
        STOP 'ABNORMAL END: S/R ECCO_READ_PICKUP: Needs MDSIO pkg'
#endif
        VOLsumGlob_0 = tmparr(1)
        RHOsumGlob_0 = tmparr(2)
      ELSE
        WRITE(msgBuf,'(2A)') 'ECCO_READ_PICKUP: ',
     &        fn(1:IL)//' and '//fntmp(1:iL+5)//' not provided.'
        CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
        WRITE(msgBuf,'(2A,I10)') 'ECCO_READ_PICKUP: ',
     &   'sterGloH is referenced to its value at time step:', nIter0
        CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
      ENDIF

      _END_MASTER(myThid)

#endif /*  ALLOW_PSBAR_STERIC  */

      RETURN
      END

#include "DIAG_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 0
C     !ROUTINE: DIAGSTATS_ASCII_OUT

C     !INTERFACE:
      SUBROUTINE DIAGSTATS_ASCII_OUT(
     I                    statGlob, nLev, ndId,
     I                    mId, listId, myIter, myThid )

C     !DESCRIPTION:
C     Write Global statistic to ASCII file

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "DIAGNOSTICS_SIZE.h"
#include "DIAGNOSTICS.h"

C     !INPUT PARAMETERS:
C     statGlob ..... AVERAGED DIAGNOSTIC QUANTITY
C     nLev   ....  2nd Dimension (max Nb of levels) of statGlob array
C     ndId     ... diagnostic Id number (in diagnostics long list)
C     mId    ..... field rank in list "listId"
C     listId ..... current output Stream list
C     myIter ..... current Iteration Number
C     myThid ..... my thread Id number
      INTEGER nLev
      _RL statGlob(0:nStats,0:nLev,0:nRegions)
      INTEGER ndId, mId, listId
      INTEGER myIter, myThid
CEOP

C     !LOCAL VARIABLES:
      INTEGER im, ix, iv
      PARAMETER ( iv = nStats - 2 , im = nStats - 1 , ix = nStats )
      INTEGER i, j, k, kLev, nUnit

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      _BEGIN_MASTER( myThid)

      IF ( diagSt_Ascii .AND. myProcId.EQ.0 ) THEN

       nUnit = diagSt_ioUnit(listId)
       kLev = kdiag(ndId)
C-     single level field: Vertical Integral (k=0) & 1rst level are identical
C      => write only 1 of the 2:
       IF ( kLev.EQ.1 ) kLev = 0
       kLev = MIN( kLev, nLev )
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
       DO j=0,nRegions
        IF ( diagSt_region(j,listId).GE.1 ) THEN
         WRITE(nUnit,'(3A,I10,2(A,I4))') ' field : ', cdiag(ndId),
     &    ' ; Iter =',myIter,' ; region #',j, ' ; nb.Lev =',kdiag(ndId)
c        WRITE(nUnit,'(5A)')       ' k |',
c    &             ' --   Average  --  |', ' --   Std.Dev   -- |',
c    &             ' --      min   --  |', ' --      max    -- |'
c        WRITE(nUnit,'(6A)')     ' k |',
c    &             ' --  Average  -- |', ' --  Std.Dev  -- |',
c    &             ' --    min    -- |', ' --    max    -- |',' --  Vol'
         WRITE(nUnit,'(6A)') ' k |',
     &     ' --   Average    -- |', ' --   Std.Dev    -- |',
     &     ' --     min      -- |', ' --     max      -- |',' --    Vol'
         DO k=0,kLev
C     full precision, do not write the volume:
c         WRITE(nUnit,'(I3,1P4E20.12)') k,(statGlob(i,k,j),i=1,nStats)
C     reduced precision + write the volume (usefull for testing):
c         WRITE(nUnit,'(I3,1P5E18.10)')
c    &       k, (statGlob(i,k,j),i=1,nStats), statGlob(0,k,j)
C     full precision + write the volume:
          WRITE(nUnit,'(I3,1P5E21.13)')
     &       k, (statGlob(i,k,j),i=1,nStats), statGlob(0,k,j)
         ENDDO
        ENDIF
       ENDDO
       WRITE(nUnit,'(A)') ' '
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
      ENDIF

      _END_MASTER( myThid )

      RETURN
      END

#include "DIAG_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 0
C     !ROUTINE: DIAGNOSTICS_STATUS_ERROR

C     !INTERFACE:
      SUBROUTINE DIAGNOSTICS_STATUS_ERROR (
     I                       callerSubR, errMsg, diagName,
     I                       expectStatus, myThid )

C     !DESCRIPTION:
C     Routine to print the appropriate error message when one of the public
C     diagnostics interface S/R (e.g., DIAGNOSTICS_ADDTOLIST or one of the
C     DIAGNOSTICS_[]_FILL S/R) is called at the wrong place in the sequence
C     of calls (initialisation stages or time-stepping part).

C     !USES:
       IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
C- needed to get "useFizhi":
#include "PARAMS.h"
#include "DIAGNOSTICS_SIZE.h"
#include "DIAGNOSTICS.h"

C     !INPUT PARAMETERS:
C     callerSubR   :: name of subroutine which is calling this S/R
C     errMsg       :: additional error message to print
C     diagName     :: diagnostic name (if relevant for this call)
C     expectStatus :: expected pkg-status when this S/R is called
C     myThid       :: my Thread Id number
      CHARACTER*(*) callerSubR
      CHARACTER*(*) errMsg
      CHARACTER*8   diagName
      INTEGER expectStatus
      INTEGER myThid
CEOP

C     !LOCAL VARIABLES:
C     msgBuf :: Informational/error message buffer
      CHARACTER*(MAX_LEN_MBUF) msgBuf

C--   Initialise

      _BEGIN_MASTER( myThid)

C--   Check if this S/R is called from the right place
      WRITE(msgBuf,'(4A)') '*** DIAGNOSTICS_STATUS_ERROR ***',
     &                     ' from: ', callerSubR, ' call'
      CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      IF ( diagName.EQ.blkName ) THEN
        WRITE(msgBuf,'(1A,2(A,I3),2A)') callerSubR,
     &     ': expectStatus=', expectStatus,
     &     ', pkgStatus=',  diag_pkgStatus, ' : ', errMsg
        CALL PRINT_ERROR( msgBuf, myThid )
      ELSE
        WRITE(msgBuf,'(3A,2(A,I3))') callerSubR,
     &     ': diagName="', diagName, '", expectStatus=',
     &     expectStatus, ', pkgStatus=', diag_pkgStatus
        CALL PRINT_ERROR( msgBuf, myThid )
      ENDIF

      IF ( diag_pkgStatus.EQ.-1 ) THEN
        WRITE(msgBuf,'(4A)') callerSubR,
     &    ': cannot be used if useDiagnostics=FALSE (data.pkg)'
        CALL PRINT_ERROR( msgBuf, myThid )
        IF ( .NOT.useFizhi )
     &  STOP 'ABNORMAL END: S/R DIAGNOSTICS_STATUS_ERROR'
      ELSEIF ( diag_pkgStatus.GT.expectStatus ) THEN
C--   case pkgStatus > expectStatus
        WRITE(msgBuf,'(3A)') callerSubR,
     &    ': <== called from the WRONG place, i.e.'
        CALL PRINT_ERROR( msgBuf, myThid )
        IF ( expectStatus.EQ.1 ) THEN
         WRITE(msgBuf,'(3A)') callerSubR, ': after ',
     &    'DIAGNOSTICS_INIT_EARLY call in PACKAGES_INIT_FIXED'
        ELSEIF ( expectStatus.EQ.2 ) THEN
         WRITE(msgBuf,'(3A)') callerSubR, ': after ',
     &    'DIAGNOSTICS_INIT_FIXED call in PACKAGES_INIT_FIXED'
        ELSEIF ( expectStatus.EQ.3 ) THEN
         WRITE(msgBuf,'(3A)') callerSubR, ': after ',
     &    'DIAGNOSTICS_INIT_VARIA call in PACKAGES_INIT_VARIABLES'
        ELSEIF ( expectStatus.EQ.10 ) THEN
         WRITE(msgBuf,'(3A)') callerSubR, ': after ',
     &    'DIAGNOSTICS_SWITCH_ONOFF call in FORWARD_STEP'
        ELSE
         WRITE(msgBuf,'(3A)') callerSubR, ': after ',
     &    'the last DIAGNOSTICS_WRITE call in DO_THE_MODEL_IO'
        ENDIF
        CALL PRINT_ERROR( msgBuf, myThid )
        STOP 'ABNORMAL END: S/R DIAGNOSTICS_STATUS_ERROR'
      ELSEIF ( diag_pkgStatus.GE.1 ) THEN
C--   case pkgStatus < expectStatus
        WRITE(msgBuf,'(2A)') callerSubR,
     &    ': <== called from the WRONG place, i.e.'
        CALL PRINT_ERROR( msgBuf, myThid )
        IF ( expectStatus.EQ.2 ) THEN
         WRITE(msgBuf,'(3A)') callerSubR, ': before ',
     &    'DIAGNOSTICS_INIT_EARLY call in PACKAGES_INIT_FIXED'
        ELSEIF ( expectStatus.EQ.3 ) THEN
         WRITE(msgBuf,'(3A)') callerSubR, ': before ',
     &    'DIAGNOSTICS_INIT_FIXED call in PACKAGES_INIT_FIXED'
        ELSEIF ( expectStatus.EQ.10 ) THEN
         WRITE(msgBuf,'(3A)') callerSubR, ': before ',
     &    'DIAGNOSTICS_INIT_VARIA call in PACKAGES_INIT_VARIABLES'
        ELSEIF ( expectStatus.EQ.20 ) THEN
         WRITE(msgBuf,'(3A)') callerSubR, ': before ',
     &    'DIAGNOSTICS_SWITCH_ONOFF call in FORWARD_STEP'
        ELSE
         WRITE(msgBuf,'(3A)') callerSubR, ': before ',
     &    'the last DIAGNOSTICS_WRITE call in DO_THE_MODEL_IO'
        ENDIF
        CALL PRINT_ERROR( msgBuf, myThid )
        IF ( .NOT.useFizhi )
     &  STOP 'ABNORMAL END: S/R DIAGNOSTICS_STATUS_ERROR'
      ELSE
C--   case pkgStatus < 1 (most likely: pkgStatus=0 )
        WRITE(msgBuf,'(4A)') callerSubR,
     &        ': called but nothing set in pkg/diagnostics'
        CALL PRINT_ERROR( msgBuf, myThid )
        STOP 'ABNORMAL END: S/R DIAGNOSTICS_STATUS_ERROR'
      ENDIF

      _END_MASTER( myThid )

      RETURN
      END

#include "SHAP_FILT_OPTIONS.h"

CBOP
C     !ROUTINE: SHAP_FILT_UV_S1
C     !INTERFACE:
      SUBROUTINE SHAP_FILT_UV_S1(
     U           uFld, vFld, tmpFldU, tmpFldV,
     I           kSize, myTime, myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R SHAP_FILT_UV_S1
C     | o Applies Shapiro filter to velocity field (u & v).
C     | o use filtering function "S1" = [1 - d_xx^n - d_yy^n]
C     |     with no grid spacing (computational Filter) ;
C     |     include No-Slip option.
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     == Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "SHAP_FILT.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments
C     uFld :: velocity field (U component) on which filter applies
C     vFld :: velocity field (V component) on which filter applies
C     tmpFldU :: working temporary array
C     tmpFldV :: working temporary array
C     kSize :: length of 3rd Dim : either =1 (2D field) or =Nr (3D field)
C     myTime :: Current time in simulation
C     myThid :: Thread number for this instance of SHAP_FILT_UV_S1
      INTEGER kSize
      _RL uFld(1-OLx:sNx+OLx,1-OLy:sNy+OLy,kSize,nSx,nSy)
      _RL vFld(1-OLx:sNx+OLx,1-OLy:sNy+OLy,kSize,nSx,nSy)
      _RL tmpFldU(1-OLx:sNx+OLx,1-OLy:sNy+OLy,kSize,nSx,nSy)
      _RL tmpFldV(1-OLx:sNx+OLx,1-OLy:sNy+OLy,kSize,nSx,nSy)
      _RL     myTime
      INTEGER myThid

#ifdef ALLOW_SHAP_FILT

C     !LOCAL VARIABLES: 
C     == Local variables ==
      INTEGER bi,bj,k,i,j,N
      _RL tmpGrdU(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL tmpGrdV(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL maskZj,maskZp
      _RL noSlipFact
      _RL tmpScal
CEOP

      noSlipFact = Shap_noSlip*2. _d 0

      IF (nShapUV.gt.0) THEN

        DO bj=myByLo(myThid),myByHi(myThid)
         DO bi=myBxLo(myThid),myBxHi(myThid)
          DO K=1,kSize
           DO J=1-OLy,sNy+OLy
            DO I=1-OLx,sNx+OLx
             tmpFldU(i,j,k,bi,bj)=uFld(i,j,k,bi,bj)
     &                *_maskW(i,j,k,bi,bj)
             tmpFldV(i,j,k,bi,bj)=vFld(i,j,k,bi,bj)
     &                *_maskS(i,j,k,bi,bj)
            ENDDO
           ENDDO
          ENDDO
         ENDDO
        ENDDO


C      d_xx^n tmpFld 

       DO N=1,nShapUV

        IF (kSize.EQ.Nr) THEN
          CALL EXCH_UV_XYZ_RL(tmpFldU,tmpFldV,.TRUE.,myThid)
        ELSE
          CALL EXCH_UV_XY_RL(tmpFldU,tmpFldV,.TRUE.,myThid)
        ENDIF

        DO bj=myByLo(myThid),myByHi(myThid)
         DO bi=myBxLo(myThid),myBxHi(myThid)
          DO K=1,kSize

C          Uxx
           DO J=1,sNy
            DO I=1,sNx+1
             tmpGrdU(i,j) = -0.25*(
     &          tmpFldU(i-1,j,k,bi,bj) + tmpFldU(i+1,j,k,bi,bj)
     &             - 2.*tmpFldU(i,j,k,bi,bj)
     &            )*_maskW(i,j,k,bi,bj)
            ENDDO
           ENDDO

           DO J=1,sNy
            DO I=1,sNx+1
             tmpFldU(i,j,k,bi,bj) = tmpGrdU(i,j)
            ENDDO
           ENDDO

C          Vyy
           DO J=1,sNy+1
            DO I=1,sNx
             tmpGrdV(i,j) = -0.25*(
     &          tmpFldV(i,j-1,k,bi,bj) + tmpFldV(i,j+1,k,bi,bj)
     &             - 2.*tmpFldV(i,j,k,bi,bj)
     &            )*_maskS(i,j,k,bi,bj)
            ENDDO
           ENDDO

           DO J=1,sNy+1
            DO I=1,sNx
             tmpFldV(i,j,k,bi,bj) = tmpGrdV(i,j)
            ENDDO
           ENDDO

          ENDDO
         ENDDO
        ENDDO

       ENDDO

C      F <-  [1 - d_xx^n *deltaT/tau].F
       DO bj=myByLo(myThid),myByHi(myThid)
        DO bi=myBxLo(myThid),myBxHi(myThid)
         DO K=1,kSize
          DO J=1,sNy
           DO I=1,sNx+1
            tmpScal = uFld(i,j,k,bi,bj)
            uFld(i,j,k,bi,bj) = uFld(i,j,k,bi,bj)
     &         -0.5*tmpFldU(i,j,k,bi,bj)*deltaTmom/Shap_uvtau
            tmpFldU(i,j,k,bi,bj) = tmpScal*_maskW(i,j,k,bi,bj)
           ENDDO
          ENDDO
          DO J=1,sNy+1
           DO I=1,sNx
            tmpScal = vFld(i,j,k,bi,bj)
            vFld(i,j,k,bi,bj) = vFld(i,j,k,bi,bj)
     &         -0.5*tmpFldV(i,j,k,bi,bj)*deltaTmom/Shap_uvtau
            tmpFldV(i,j,k,bi,bj) = tmpScal*_maskS(i,j,k,bi,bj)
           ENDDO
          ENDDO
         ENDDO
        ENDDO
       ENDDO


C      d_yy^n tmpFld 

       DO N=1,nShapUV

        IF (kSize.EQ.Nr) THEN
          CALL EXCH_UV_XYZ_RL(tmpFldU,tmpFldV,.TRUE.,myThid)
        ELSE
          CALL EXCH_UV_XY_RL(tmpFldU,tmpFldV,.TRUE.,myThid)
        ENDIF

        DO bj=myByLo(myThid),myByHi(myThid)
         DO bi=myBxLo(myThid),myBxHi(myThid)
          DO K=1,kSize

C          Uyy
           DO J=1,sNy
            DO I=1,sNx+1
             maskZj=_maskS(i-1, j ,k,bi,bj)
     &             *_maskS( i , j ,k,bi,bj)
             maskZp=_maskS(i-1,j+1,k,bi,bj)
     &             *_maskS( i ,j+1,k,bi,bj)
             tmpGrdU(i,j) = -0.25*(
     &        (tmpFldU(i,j+1,k,bi,bj)-tmpFldU(i, j ,k,bi,bj))*maskZp
     &       -(tmpFldU(i, j ,k,bi,bj)-tmpFldU(i,j-1,k,bi,bj))*maskZj
     &       -noSlipFact*(2.-maskZj-maskZp)*tmpFldU(i,j,k,bi,bj)
     &             )*_maskW(i,j,k,bi,bj)
            ENDDO
           ENDDO

           IF (useCubedSphereExchange) THEN
            DO I=1,sNx+1,sNx
            J=1
             maskZj=maskS(i-1, j ,k,bi,bj)*maskS( i , j ,k,bi,bj)
             maskZp=maskS(i-1,j+1,k,bi,bj)*maskS( i ,j+1,k,bi,bj)
             tmpGrdU(i,j) = -0.25*(
     &        (tmpFldU(i,j+1,k,bi,bj)-tmpFldU(i, j ,k,bi,bj))*maskZp
     &       -(tmpFldU(i, j ,k,bi,bj)-0*tmpFldU(i,j-1,k,bi,bj))*maskZj
     &       -noSlipFact*(2.-maskZj-maskZp)*tmpFldU(i,j,k,bi,bj)
     &             )*_maskW(i,j,k,bi,bj)
            J=sNy
             maskZj=maskS(i-1, j ,k,bi,bj)*maskS( i , j ,k,bi,bj)
             maskZp=maskS(i-1,j+1,k,bi,bj)*maskS( i ,j+1,k,bi,bj)
             tmpGrdU(i,j) = -0.25*(
     &        (0*tmpFldU(i,j+1,k,bi,bj)-tmpFldU(i, j ,k,bi,bj))*maskZp
     &       -(tmpFldU(i, j ,k,bi,bj)-tmpFldU(i,j-1,k,bi,bj))*maskZj
     &       -noSlipFact*(2.-maskZj-maskZp)*tmpFldU(i,j,k,bi,bj)
     &             )*_maskW(i,j,k,bi,bj)
            ENDDO
           ENDIF

           DO J=1,sNy
            DO I=1,sNx+1
             tmpFldU(i,j,k,bi,bj) = tmpGrdU(i,j)
            ENDDO
           ENDDO

C          Vxx
           DO J=1,sNy+1
            DO I=1,sNx
             maskZj=_maskW( i ,j-1,k,bi,bj)
     &             *_maskW( i , j ,k,bi,bj)
             maskZp=_maskW(i+1,j-1,k,bi,bj)
     &             *_maskW(i+1, j ,k,bi,bj)
             tmpGrdV(i,j) = -0.25*(
     &        (tmpFldV(i+1,j,k,bi,bj)-tmpFldV( i ,j,k,bi,bj))*maskZp
     &       -(tmpFldV( i ,j,k,bi,bj)-tmpFldV(i-1,j,k,bi,bj))*maskZj
     &       -noSlipFact*(2.-maskZj-maskZp)*tmpFldV(i,j,k,bi,bj)
     &             )*_maskS(i,j,k,bi,bj)
            ENDDO
           ENDDO

           IF (useCubedSphereExchange) THEN
            DO J=1,sNy+1,sNy
            I=1
             maskZj=maskW( i ,j-1,k,bi,bj)*maskW( i , j ,k,bi,bj)
             maskZp=maskW(i+1,j-1,k,bi,bj)*maskW(i+1, j ,k,bi,bj)
             tmpGrdV(i,j) = -0.25*(
     &        (tmpFldV(i+1,j,k,bi,bj)-tmpFldV( i ,j,k,bi,bj))*maskZp
     &       -(tmpFldV( i ,j,k,bi,bj)-0*tmpFldV(i-1,j,k,bi,bj))*maskZj
     &       -noSlipFact*(2.-maskZj-maskZp)*tmpFldV(i,j,k,bi,bj)
     &             )*_maskS(i,j,k,bi,bj)
            I=sNx
             maskZj=maskW( i ,j-1,k,bi,bj)*maskW( i , j ,k,bi,bj)
             maskZp=maskW(i+1,j-1,k,bi,bj)*maskW(i+1, j ,k,bi,bj)
             tmpGrdV(i,j) = -0.25*(
     &        (0*tmpFldV(i+1,j,k,bi,bj)-tmpFldV( i ,j,k,bi,bj))*maskZp
     &       -(tmpFldV( i ,j,k,bi,bj)-tmpFldV(i-1,j,k,bi,bj))*maskZj
     &       -noSlipFact*(2.-maskZj-maskZp)*tmpFldV(i,j,k,bi,bj)
     &             )*_maskS(i,j,k,bi,bj)
            ENDDO
           ENDIF

           DO J=1,sNy+1
            DO I=1,sNx
             tmpFldV(i,j,k,bi,bj) = tmpGrdV(i,j)
            ENDDO
           ENDDO

          ENDDO
         ENDDO
        ENDDO

       ENDDO

C      F <-  [1 - d_yy^n *deltaT/tau].F
       DO bj=myByLo(myThid),myByHi(myThid)
        DO bi=myBxLo(myThid),myBxHi(myThid)
         DO K=1,kSize
          DO J=1,sNy
           DO I=1,sNx+1
            uFld(i,j,k,bi,bj) = uFld(i,j,k,bi,bj)
     &         -0.5*tmpFldU(i,j,k,bi,bj)*deltaTmom/Shap_uvtau
           ENDDO
          ENDDO
          DO J=1,sNy+1
           DO I=1,sNx
            vFld(i,j,k,bi,bj) = vFld(i,j,k,bi,bj)
     &         -0.5*tmpFldV(i,j,k,bi,bj)*deltaTmom/Shap_uvtau
           ENDDO
          ENDDO
         ENDDO
        ENDDO
       ENDDO

        IF (kSize.EQ.Nr) THEN
          CALL EXCH_UV_XYZ_RL(uFld,vFld,.TRUE.,myThid)
        ELSEIF (kSize.EQ.1) THEN
          CALL EXCH_UV_XY_RL(uFld,vFld,.TRUE.,myThid)
        ELSE
          STOP 'S/R SHAP_FILT_UV_S1: kSize is wrong'
        ENDIF

      ENDIF
#endif /* ALLOW_SHAP_FILT */

      RETURN
      END

#include "FIZHI_OPTIONS.h"
      subroutine fizhi_alarms (nymdb,nhmsb,deltaT)

C***********************************************************************
C  Purpose
C  -------
C     Driver to Set Internal Model Alarms
C
C  Argument Description
C  --------------------
C     nymdb ..... Begining Date to Start Alarm Clock
C     nhmsb ..... Begining Time to Start Alarm Clock
C     ndt ....... Model Timestep
C
C     Note: For ndt = 0, all Intermal Model Alarms are set to 1 second
C
C***********************************************************************
      implicit none

c Input Parameters
c ----------------
      integer  nymdb,nhmsb
      _RL deltaT

      integer  myid

c Physics Frequencies
c -------------------
      integer ndt
      integer  nhmsf, m,n, nd
      integer  ndlw, ndsw, ndturb, ndmoist

      myid = 1

      ndt = deltaT

      if( ndt.ne.0 ) then

C Longwave  Radiation Frequency
      ndlw = 003000
C Shortwave Radiation Frequency
      ndsw = 003000

c Turbulence
c ----------
      ndturb = 2*int( max(1.0,(300./iabs(ndt)+0.5)/2) ) * iabs(ndt)

      n  =  1
      m  = -1
      nd = ndturb
      do while ( mod(3*3600,nd).ne.0 )
      nd = ndturb + 2*n*m*ndt
      m  = -m
      n  =  n+1
      if( nd.lt.ndt ) then
          if( myid.eq.1 ) then
          print *
          print *, 'Turbulence cannot occur with Model Timestep = ',ndt
          print *
          endif
      call my_finalize
      call my_exit (101)
      endif
      enddo
      ndturb  = nhmsf( nd )

c Moist Processes
c ---------------
      ndmoist = int( 600./iabs(ndt) + 0.5 ) * iabs(ndt)

      n  =  1
      m  = -1
      nd = ndmoist
      do while ( mod(3*3600,nd).ne.0 )
      nd = ndmoist + n*m*ndt
      m  = -m
      n  =  n+1
      if( nd.lt.ndt ) then
          if( myid.eq.1 ) then
          print *
          print *, 'Convection cannot occur with Model Timestep = ',ndt
          print *
          endif
      call my_finalize
      call my_exit (101)
      endif
      enddo
      ndmoist = nhmsf( nd )

      else

c For NDT = 0, all Alarms set to 1 second
c ---------------------------------------
C Longwave  Radiation Frequency
      ndlw    = 000001
C Shortwave Radiation Frequency
      ndsw    = 000001
C Turbulence          Frequency
      ndturb  = 000001
C Moist Processes     Frequency
      ndmoist = 000001

      endif

c Set Alarm Clocks
c ----------------

      call set_alarm ( 'radsw',nymdb,nhmsb,ndsw    )
      call set_alarm ( 'radlw',nymdb,nhmsb,ndlw    )
      call set_alarm ( 'turb' ,nymdb,nhmsb,ndturb  )
      call set_alarm ( 'moist',nymdb,nhmsb,ndmoist )
      call set_alarm ( 'pnt',nymdb,nhmsb,0 )

      return
      end

#include "LAYERS_OPTIONS.h"
C--  File layers_save.F:
C--   Contents
C--   o LAYERS_FILL
C--   o LAYERS_FILL_FIELD

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP

      SUBROUTINE LAYERS_FILL(
     I               df, trIdentity, fluxid,
     I               kLev, nLevs, bibjFlg, biArg, bjArg, myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE LAYERS_FILL
C     | "Remember" the merid. advective flux for use later in layers_thermodynamics
C     *==========================================================*
       IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "LAYERS_SIZE.h"
#include "LAYERS.h"
C***********************************************************************
C   This is designed to look and work exactly like the a regular
C   diagnostics_fill call.
C***********************************************************************
C     surfflux  :: The surface temperature flux, the same as what is filled into
C                   the TFLUX and SFLUX diagnostics
C     trIdentity:: Index to let us know what tracer it is (1 for T, 2 for S)
C     kLev      :: Integer flag for vertical levels:
C                  > 0 (any integer): WHICH single level to increment in qdiag.
C                  0,-1 to increment "nLevs" levels in qdiag,
C                  0 : fill-in in the same order as the input array
C                  -1: fill-in in reverse order.
C     nLevs     :: indicates Number of levels of the input field array
C                  (whether to fill-in all the levels (kLev<1) or just one (kLev>0))
C     bibjFlg   :: Integer flag to indicate instructions for bi bj loop
C                  0 indicates that the bi-bj loop must be done here
C                  1 indicates that the bi-bj loop is done OUTSIDE
C                  2 indicates that the bi-bj loop is done OUTSIDE
C                     AND that we have been sent a local array (with overlap regions)
C                  3 indicates that the bi-bj loop is done OUTSIDE
C                     AND that we have been sent a local array
C                     AND that the array has no overlap region (interior only)
C                  NOTE - bibjFlg can be NEGATIVE to indicate not to increment counter
C     biArg     :: X-direction tile number - used for bibjFlg=1-3
C     bjArg     :: Y-direction tile number - used for bibjFlg=1-3

C       _RL df(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
       _RL df(*)
       INTEGER trIdentity, kLev, nLevs, bibjFlg, biArg, bjArg
       INTEGER myThid
       CHARACTER*(3) fluxid

#ifdef LAYERS_THERMODYNAMICS

C !LOCAL VARIABLES: ====================================================
C i,j              :: loop indices
C msgBuf           :: error message buffer
       CHARACTER*(MAX_LEN_MBUF) msgBuf

       IF ((trIdentity.EQ.1).OR.(trIdentity.EQ.2)) THEN

       IF (fluxid.EQ.'SUR') THEN
         CALL LAYERS_FILL_FIELD(df, trIdentity, 1, layers_surfflux,'M',
     &           klev, nLevs, bibjFlg, biArg, bjArg, myThid)
       ELSE IF (fluxid.EQ.'DFX') THEN
         CALL LAYERS_FILL_FIELD(df, trIdentity, Nr, layers_dfx,'U',
     &           kLev, nLevs, bibjFlg, biArg, bjArg, myThid)
       ELSE IF (fluxid.EQ.'DFY') THEN
         CALL LAYERS_FILL_FIELD(df, trIdentity, Nr, layers_dfy,'V',
     &           kLev, nLevs, bibjFlg, biArg, bjArg, myThid)
       ELSE IF (fluxid.EQ.'DFR') THEN
         CALL LAYERS_FILL_FIELD(df, trIdentity, Nr, layers_dfr,'M',
     &           kLev, nLevs, bibjFlg, biArg, bjArg, myThid)
       ELSE IF (fluxid.EQ.'AFX') THEN
         CALL LAYERS_FILL_FIELD(df, trIdentity, Nr, layers_afx,'U',
     &           kLev, nLevs, bibjFlg, biArg, bjArg, myThid)
       ELSE IF (fluxid.EQ.'AFY') THEN
         CALL LAYERS_FILL_FIELD(df, trIdentity, Nr, layers_afy,'V',
     &           kLev, nLevs, bibjFlg, biArg, bjArg, myThid)
       ELSE IF (fluxid.EQ.'AFR') THEN
         CALL LAYERS_FILL_FIELD(df, trIdentity, Nr, layers_afr,'M',
     &           kLev, nLevs, bibjFlg, biArg, bjArg, myThid)
       ELSE IF (fluxid.EQ.'TOT') THEN
         CALL LAYERS_FILL_FIELD(df, trIdentity, Nr, layers_tottend,'M',
     &           kLev, nLevs, bibjFlg, biArg, bjArg, myThid)
       ELSE
         WRITE(msgBuf,'(2A)')
     &          'S/R LAYERS_FILL: ',
     &          'invalid flux ID'
         CALL PRINT_ERROR( msgBuf, myThid )
         STOP 'ABNORMAL END: S/R LAYERS_FILL'
       ENDIF

       ELSE
C  ---- Cannot throw an error for different trIdentity
C       because subroutine also gets called for ptracers.
C       Just have to do nothing

C         WRITE(msgBuf,'(5A,I2)')
C     &          'S/R LAYERS_FILL: ',
C     &          'only works on THETA (1) or SALT (2)',
C     &          'fluxid=', fluxid, 'trId=',
C     &          trIdentity
C         CALL PRINT_ERROR( msgBuf, myThid )
C         STOP 'ABNORMAL END: S/R LAYERS_FILL'
       ENDIF

#endif /* LAYERS_THERMODYNAMICS */

      RETURN
      END
C end of S/R LAYERS_FILL

      SUBROUTINE LAYERS_FILL_FIELD(
     I               df, trIdentity, myNr,
     U               layers_saved_flux,
     I               fldType,
     I               kLev, nLevs, bibjFlg, biArg, bjArg, myThid )

       IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "LAYERS_SIZE.h"
#include "LAYERS.h"

       INTEGER trIdentity, myNr, kLev, nLevs, bibjFlg, biArg, bjArg
       CHARACTER fldType
       _RL layers_saved_flux(1-OLx:sNx+OLx,1-OLy:sNy+OLy,
     &                       myNr,2,nSx,nSy)
C       _RL df(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
       _RL df(*)
       INTEGER myThid

#ifdef LAYERS_THERMODYNAMICS

C !LOCAL VARIABLES: ====================================================
C i,j              :: loop indices
C msgBuf           :: error message buffer
      INTEGER sizI1,sizI2,sizJ1,sizJ2
      INTEGER sizTx,sizTy
      INTEGER iRun, jRun, k, bi, bj
      INTEGER kFirst, kLast
      INTEGER kd, kd0, ksgn
C       CHARACTER*(MAX_LEN_MBUF) msgBuf

C-      select range for 1rst & 2nd indices to accumulate
C         depending on variable location on C-grid,
      IF ( fldType.EQ.'U' ) THEN
       iRun = sNx+1
       jRun = sNy
      ELSEIF ( fldType.EQ.'V' ) THEN
       iRun = sNx
       jRun = sNy+1
      ELSE
       iRun = sNx
       jRun = sNy
      ENDIF
C-      Dimension of the input array:
      IF (abs(bibjFlg).EQ.3) THEN
        sizI1 = 1
        sizI2 = sNx
        sizJ1 = 1
        sizJ2 = sNy
        iRun = sNx
        jRun = sNy
      ELSE
        sizI1 = 1-OLx
        sizI2 = sNx+OLx
        sizJ1 = 1-OLy
        sizJ2 = sNy+OLy
      ENDIF
      IF (abs(bibjFlg).GE.2) THEN
        sizTx = 1
        sizTy = 1
      ELSE
        sizTx = nSx
        sizTy = nSy
      ENDIF

C-      Which part of inpFld to add : k = 3rd index,
C         and do the loop >> do k=kFirst,kLast <<
      IF (kLev.LE.0) THEN
        kFirst = 1
        kLast  = nLevs
      ELSEIF ( nLevs.EQ.1 ) THEN
        kFirst = 1
        kLast  = 1
      ELSEIF ( kLev.LE.nLevs ) THEN
        kFirst = kLev
        kLast  = kLev
      ELSE
        STOP 'ABNORMAL END in LAYERS_SAVE: kLev > nLevs >0'
      ENDIF
C-      Which part of qdiag to update: kd = 3rd index,
C         and do the loop >> do k=kFirst,kLast ; kd = kd0 + k*ksgn <<
      IF ( kLev.EQ.-1 ) THEN
        ksgn = -1
        kd0 = 1 + nLevs
      ELSEIF ( kLev.EQ.0 ) THEN
        ksgn = 1
        kd0 = 0
      ELSE
        ksgn = 0
        kd0 = kLev
      ENDIF

      IF ( bibjFlg.EQ.0 ) THEN

       DO bj=myByLo(myThid), myByHi(myThid)
        DO bi=myBxLo(myThid), myBxHi(myThid)
         DO k = kFirst,kLast
          kd = kd0 + ksgn*k
          CALL LAYERS_CUMULATE(
     U      layers_saved_flux(1-OLx,1-OLy,kd,trIdentity,bi,bj),
     I      df,
     I      sizI1,sizI2,sizJ1,sizJ2,nLevs,sizTx,sizTy,
     I      iRun,jRun,k,bi,bj,
     I      myThid)
         ENDDO
        ENDDO
       ENDDO
      ELSE
        bi = MIN(biArg,sizTx)
        bj = MIN(bjArg,sizTy)
        DO k = kFirst,kLast
          kd = kd0 + ksgn*k
          CALL LAYERS_CUMULATE(
     U      layers_saved_flux(1-OLx,1-OLy,kd,trIdentity,biArg,bjArg),
     I      df,
     I      sizI1,sizI2,sizJ1,sizJ2,nLevs,sizTx,sizTy,
     I      iRun,jRun,k,bi,bj,
     I      myThid)
        ENDDO
      ENDIF

C        IF (bibjFlg.EQ.2) THEN
C C --   called INSIDE the bi-bj loop, with overlap present
C         DO k = kstart,kend
C          DO j = 1-OLy,sNy+OLy
C           DO i = 1-OLx,sNx+OLx
C            layers_saved_flux(i,j,k,trIdentity,biArg,bjArg) =
C      &       layers_saved_flux(i,j,k,trIdentity,biArg,bjArg) +
C      &        df(i,j,1,1)
C           ENDDO
C          ENDDO
C         ENDDO
C        ELSE IF (bibjFlg.EQ.0) THEN
C C --   the bi-bj loop must be done here
C         DO bj=myByLo(myThid), myByHi(myThid)
C          DO bi=myBxLo(myThid), myBxHi(myThid)
C           DO k = kstart,kend
C            DO j = 1-OLy,sNy+OLy
C             DO i = 1-OLx,sNx+OLx
C               layers_saved_flux(i,j,k,trIdentity,bi,bj) =
C      &          layers_saved_flux(i,j,k,trIdentity,bi,bj) +
C      &          df(i,j,bi,bj)
C             ENDDO
C            ENDDO
C           ENDDO
C          ENDDO
C         ENDDO
C        ELSE
C            WRITE(msgBuf,'(2A)')
C      &          'S/R LAYERS_FILL_FIELD: ',
C      &          'got unexpected bibjFlg'
C            CALL PRINT_ERROR( msgBuf, myThid )
C            STOP 'ABNORMAL END: S/R LAYERS_FILL_FIELD'
C        ENDIF

#endif /* LAYERS_THERMODYNAMICS */

      RETURN
      END
C end of S/R LAYERS_FILL_FIELD

      SUBROUTINE LAYERS_CUMULATE(
     U                  cumFld,
     I                  inpFld,
     I                  sizI1,sizI2,sizJ1,sizJ2,sizK,sizTx,sizTy,
     I                  iRun,jRun,k,bi,bj,
     I                  myThid )

C     !DESCRIPTION:
C     Update array cumFld
C     by adding content of input field array inpFld
C     over the range [1:iRun],[1:jRun]

C     !USES:
      IMPLICIT NONE

#include "EEPARAMS.h"
#include "SIZE.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine Arguments ==
C     cumFld      :: cumulative array (updated)
C     inpFld      :: input field array to add to cumFld
C     sizI1,sizI2 :: size of inpFld array: 1rst index range (min,max)
C     sizJ1,sizJ2 :: size of inpFld array: 2nd  index range (min,max)
C     sizK        :: size of inpFld array: 3rd  dimension
C     sizTx,sizTy :: size of inpFld array: tile dimensions
C     iRun,jRun   :: range of 1rst & 2nd index
C     k,bi,bj     :: level and tile indices of inFld array to add to cumFld array
C     myThid      :: my Thread Id number
      _RL cumFld(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER sizI1,sizI2,sizJ1,sizJ2
      INTEGER sizK,sizTx,sizTy
      _RL inpFld(sizI1:sizI2,sizJ1:sizJ2,sizK,sizTx,sizTy)
      INTEGER iRun, jRun, k, bi, bj
      INTEGER myThid
CEOP

C     !LOCAL VARIABLES:
C     i,j    :: loop indices
      INTEGER i, j
C      _RL     tmpFact

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      DO j = 1,jRun
       DO i = 1,iRun
        cumFld(i,j) = cumFld(i,j) + inpFld(i,j,k,bi,bj)
       ENDDO
      ENDDO

      RETURN
      END

#include "AIM_OPTIONS.h"

CBOP
C     !ROUTINE: AIM_DO_PHYSICS
C     !INTERFACE:
      SUBROUTINE AIM_DO_PHYSICS( myTime, myIter, myThid )

C     !DESCRIPTION: \bv
C     *==================================================================*
C     | S/R AIM_DO_PHYSICS
C     *==================================================================*
C     | Interface between atmospheric physics package and the
C     | dynamical model.
C     | Routine calls physics pacakge after setting surface BC.
C     | Package should derive and set tendency terms
C     | which can be included as external forcing terms in the dynamical
C     | tendency routines. Packages should communicate this information
C     | through common blocks.
C     *==================================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     -------------- Global variables ------------------------------------
C-- size for MITgcm & Physics package :
#include "AIM_SIZE.h"

C-- MITgcm
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "DYNVARS.h"
#include "GRID.h"
#include "SURFACE.h"

C-- Physics package
#include "AIM_PARAMS.h"
#include "AIM_FFIELDS.h"
#include "AIM_GRID.h"
#include "com_physvar.h"
#include "com_forcing.h"
#include "AIM2DYN.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     myTime    :: Current time in simulation (s)
C     myIter    :: Current iteration number
C     myThid    :: My Thread Id. number
      _RL     myTime
      INTEGER myIter
      INTEGER myThid
CEOP

#ifdef ALLOW_AIM
C     !FUNCTIONS:
C     !LOCAL VARIABLES:
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C--   Local Variables originally (Speedy) in common bloc (com_forcing.h):
C--   COMMON /FORFIX/ Time invariant forcing fields (initialise in INFORC)
C     phi0       :: surface geopotential
      _RL     phi0   (NGP)
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C     == Local variables ==
C     bi,bj      :: Tile indices
C     i,j,k,I2   :: Loop counters
C     tYear      :: Fraction into year
C     aim_sWght0 :: weight for time interpolation of surface BC
C     aim_sWght1 :: 0/1 = time period before/after the current time
C     prcAtm     :: total precip from the atmosphere [kg/m2/s]
C     snowPr     :: snow precipitation               [kg/m2/s]
      INTEGER bi,bj
      INTEGER i,j,k,I2
      _RL     tYear, yearLength
      _RL     aim_sWght0, aim_sWght1
      _RL prcAtm(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL snowPr(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
#ifdef ALLOW_THSICE
      _RL qPrcRn(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
#endif

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#ifdef ALLOW_AIM_CO2
      CALL AIM_DO_CO2( myTime, myIter, myThid )
#endif

C--   Start loops on tile indices
      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)

C_jmc: Because AIM physics LSC is not applied in the stratosphere (top level),
C      ==> move water wapor from the stratos to the surface level.
        DO j = 1-OLy, sNy+OLy
         DO i = 1-OLx, sNx+OLx
          k = kSurfC(i,j,bi,bj)
          IF (k.LE.Nr)
     &    salt(i,j,k,bi,bj) = salt(i,j,k,bi,bj)
     &                      + salt(i,j,Nr,bi,bj)*drF(Nr)*recip_drF(k)
     &                  *hFacC(i,j,Nr,bi,bj)*recip_hFacC(i,j,k,bi,bj)
          salt(i,j,Nr,bi,bj) = 0.
         ENDDO
        ENDDO

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C-    Physics package needs to know time of year as a fraction
        yearLength = 86400.*360.
        tYear = MOD(myTime/yearLength, 1. _d 0)

C--   Set surface Boundary Conditions for atmos. physics package:
C     (Albedo, Soil moisture, Surf Temp, Land sea mask)
C     includes some parts of S/R FORDATE from F.Molteni SPEDDY code (ver23)
        CALL AIM_SURF_BC(
     U                    tYear,
     O                    aim_sWght0, aim_sWght1,
     I                    bi, bj, myTime, myIter, myThid )

C--   Set surface geopotential: (g * orographic height)
        DO j=1,sNy
         DO i=1,sNx
           I2 = i+(j-1)*sNx
           PHI0(I2) = gravity*topoZ(i,j,bi,bj)
         ENDDO
        ENDDO

C--   Set topographic dependent FOROG var (originally in common SFLFIX);
C      used to compute for wind stress over land

c_FM  IF (IDAY.EQ.0) THEN
c_FM    CALL SFLSET (PHIS0)
        CALL SFLSET (PHI0, fOrogr(1,myThid), bi,bj,myThid)
c_FM  ENDIF
c_FM  CALL SOL_OZ (SOLC,TYEAR)

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C-    Compute atmospheric-physics tendencies (call the main AIM S/R)
        CALL PHY_DRIVER( tYear, useDiagnostics,
     I                    bi, bj, myTime, myIter, myThid )

        CALL AIM_AIM2DYN( bi, bj, myTime, myIter, myThid )

#ifdef ALLOW_LAND
        IF (useLand) THEN
C-    prepare Surface flux over land for land package
          CALL AIM_AIM2LAND( aim_landFr, bi, bj,
     I                       myTime, myIter, myThid )

C-    Step forward land model
          CALL LAND_STEPFWD( aim_landFr, bi, bj,
     I                       myTime, myIter, myThid )

C-    Land diagnostics : write snap-shot & fill diagnostics
          CALL LAND_DO_DIAGS( aim_landFr, bi, bj,
     I                        myTime, myIter, myThid )

        ENDIF
#endif /* ALLOW_LAND */

C-    surface fluxes over ocean (ice-free & ice covered)
C       used for diagnostics, thsice package and coupler
        CALL AIM_AIM2SIOCE( aim_landFr, fmask1(1,3,myThid),
     O                      prcAtm, snowPr,
     I                      bi, bj, myTime, myIter, myThid )

#ifdef ALLOW_THSICE
        IF ( useThSIce ) THEN
C-    Step forward sea-ice model
          DO j = 1-OLy, sNy+OLy
           DO i = 1-OLx, sNx+OLx
            qPrcRn(i,j) = 0.
           ENDDO
          ENDDO
          CALL THSICE_STEP_FWD( bi, bj, 1, sNx, 1, sNy,
     I                          prcAtm, snowPr, qPrcRn,
     I                          myTime, myIter, myThid )
        ENDIF
#endif /* ALLOW_THSICE */

C-    AIM diagnostics : write snap-shot & fill diagnostics
        CALL AIM_DIAGNOSTICS( bi, bj, myTime, myIter, myThid )

C--   end bi,bj loops.
       ENDDO
      ENDDO

#ifdef ALLOW_THSICE
      IF ( useThSIce ) THEN
C--   Exchange fields that are advected by seaice dynamics
        CALL THSICE_DO_EXCH( myThid )
C-    do sea-ice advection after sea-ice thermodynamics
        CALL THSICE_DO_ADVECT(
     I                         0, 0, myTime, myIter, myThid )
        DO bj=myByLo(myThid),myByHi(myThid)
         DO bi=myBxLo(myThid),myBxHi(myThid)
C-    Slab Ocean : step forward ocean mixed-layer temp. & salinity
          CALL THSICE_SLAB_OCEAN(
     I                        aim_sWght0, aim_sWght1,
     O                        dTsurf(1,2,myThid),
     I                        bi, bj, myTime, myIter, myThid )
         ENDDO
        ENDDO
      ENDIF
#endif /* ALLOW_THSICE */

C--   do exchanges for AIM related quantities:
      _EXCH_XY_RL( aim_drag, myThid )

#ifdef COMPONENT_MODULE
      IF ( useCoupler ) THEN
       CALL ATM_STORE_MY_DATA( myTime, myIter, myThid )
      ENDIF
#endif /* COMPONENT_MODULE */

#endif /* ALLOW_AIM */

      RETURN
      END

#include "CTRL_OPTIONS.h"
#ifdef ALLOW_OBCS
# include "OBCS_OPTIONS.h"
#endif

      subroutine ctrl_getobcss(
     I                          myTime, myIter, myThid )

c     ==================================================================
c     SUBROUTINE ctrl_getobcss
c     ==================================================================
c
c     o Get southern obc of the control vector and add it
c       to dyn. fields
c
c     started: heimbach@mit.edu, 29-Aug-2001
c     new flags: gebbie@mit.edu, 25 Jan 2003.
c
c     ==================================================================
c     SUBROUTINE ctrl_getobcss
c     ==================================================================

      implicit none

c     == global variables ==
#ifdef ALLOW_OBCSS_CONTROL
#include "EEPARAMS.h"
#include "SIZE.h"
#include "PARAMS.h"
#include "GRID.h"
#include "OBCS_PARAMS.h"
#include "OBCS_GRID.h"
#include "OBCS_FIELDS.h"
#include "CTRL_SIZE.h"
#include "CTRL.h"
#include "CTRL_DUMMY.h"
#include "CTRL_OBCS.h"
#include "OPTIMCYCLE.h"
#endif /* ALLOW_OBCSS_CONTROL */

c     == routine arguments ==
      _RL     myTime
      integer myIter
      integer myThid

#if ( defined ALLOW_OBCS_SOUTH && defined ALLOW_OBCSS_CONTROL )
c     == external functions ==
      integer  ilnblnk
      external ilnblnk

c     == local variables ==
      integer bi,bj
      integer i,j,k
      integer itlo,ithi
      integer jtlo,jthi
      integer imin,imax
      integer ilobcss
      integer iobcs
      _RL     obcssfac
      logical obcssfirst
      logical obcsschanged
      integer obcsscount0
      integer obcsscount1
      integer jp1
cgg      _RL maskxz   (1-OLx:sNx+OLx,Nr,nSx,nSy)
      _RL tmpfldxz (1-OLx:sNx+OLx,Nr,nSx,nSy)
      logical doglobalread
      logical ladinit
      character*(MAX_LEN_FNAM) fnameobcss
#ifdef ALLOW_OBCS_CONTROL_MODES
      integer nk,nz
      _RL     tmpz (Nr,nSx,nSy)
      _RL     stmp
#endif
      integer ilDir

c     == end of interface ==

      jtlo = myByLo(myThid)
      jthi = myByHi(myThid)
      itlo = myBxLo(myThid)
      ithi = myBxHi(myThid)
      imin = 1-OLx
      imax = sNx+OLx
      jp1  = 1

c--   Now, read the control vector.
      doglobalread = .false.
      ladinit      = .false.

c     Find ctrlDir (w/o trailing blanks) length
      ilDir = ilnblnk(ctrlDir)

      if (optimcycle .ge. 0) then
       ilobcss=ilnblnk( xx_obcss_file )
       write(fnameobcss,'(2a,i10.10)')
     &      ctrlDir(1:ilDir)//xx_obcss_file(1:ilobcss), '.', optimcycle
      endif

c--   Get the counters, flags, and the interpolation factor.
      call ctrl_get_gen_rec(
     I                   xx_obcssstartdate, xx_obcssperiod,
     O                   obcssfac, obcssfirst, obcsschanged,
     O                   obcsscount0,obcsscount1,
     I                   myTime, myIter, myThid )

      do iobcs = 1,nobcs

       if ( obcssfirst ) then
#ifdef ALLOW_AUTODIFF
        call active_read_xz( fnameobcss, tmpfldxz,
     &                       (obcsscount0-1)*nobcs+iobcs,
     &                       doglobalread, ladinit, optimcycle,
     &                       myThid, xx_obcss_dummy )
#else
        CALL READ_REC_XZ_RL( fnameobcss, ctrlprec, Nr, tmpfldxz,
     &                       (obcsscount0-1)*nobcs+iobcs, 1, myThid )
#endif

        do bj = jtlo,jthi
         do bi = itlo,ithi
#ifdef ALLOW_OBCS_CONTROL_MODES
          if (iobcs .gt. 2) then
           do i = imin,imax
            j = OB_Js(i,bi,bj)
            IF ( j.EQ.OB_indexNone ) j = 1
cih    Determine number of open vertical layers.
            nz = 0
            do k = 1,Nr
             if (iobcs .eq. 3) then
              nz = nz + maskS(i,j+jp1,k,bi,bj)
             else
              nz = nz + maskW(i,j,k,bi,bj)
             endif
            end do
cih    Compute absolute velocities from the barotropic-baroclinic modes.
            do k = 1,Nr
             if (k.le.nz) then
              stmp = 0.
              do nk = 1,nz
               stmp = stmp +
     &         modesv(k,nk,nz)*tmpfldxz(i,nk,bi,bj)
              end do
              tmpz(k,bi,bj) = stmp
             else
              tmpz(k,bi,bj) = 0.
             end if
            end do
            do k = 1,Nr
             if (iobcs .eq. 3) then
              tmpfldxz(i,k,bi,bj) = tmpz(k,bi,bj)
     &         *recip_hFacS(i,j+jp1,k,bi,bj)
             else
              tmpfldxz(i,k,bi,bj) = tmpz(k,bi,bj)
     &                           *recip_hFacW(i,j,k,bi,bj)
             endif
            end do
           enddo
          endif
#endif
          do k = 1,Nr
           do i = imin,imax
            xx_obcss1(i,k,bi,bj,iobcs)  = tmpfldxz (i,k,bi,bj)
cgg   &                                        *   maskxz (i,k,bi,bj)
           enddo
          enddo
         enddo
        enddo
       endif

       if ( (obcssfirst) .or. (obcsschanged)) then

        do bj = jtlo,jthi
         do bi = itlo,ithi
          do k = 1,Nr
           do i = imin,imax
            xx_obcss0(i,k,bi,bj,iobcs) = xx_obcss1(i,k,bi,bj,iobcs)
            tmpfldxz (i,k,bi,bj)       = 0. _d 0
           enddo
          enddo
         enddo
        enddo

#ifdef ALLOW_AUTODIFF
        call active_read_xz( fnameobcss, tmpfldxz,
     &                       (obcsscount1-1)*nobcs+iobcs,
     &                       doglobalread, ladinit, optimcycle,
     &                       myThid, xx_obcss_dummy )
#else
        CALL READ_REC_XZ_RL( fnameobcss, ctrlprec, Nr, tmpfldxz,
     &                       (obcsscount1-1)*nobcs+iobcs, 1, myThid )
#endif

        do bj = jtlo,jthi
         do bi = itlo,ithi
#ifdef ALLOW_OBCS_CONTROL_MODES
          if (iobcs .gt. 2) then
           do i = imin,imax
            j = OB_Js(i,bi,bj)
            IF ( j.EQ.OB_indexNone ) j = 1
cih    Determine number of open vertical layers.
            nz = 0
            do k = 1,Nr
             if (iobcs .eq. 3) then
              nz = nz + maskS(i,j+jp1,k,bi,bj)
             else
              nz = nz + maskW(i,j,k,bi,bj)
             endif
            end do
cih    Compute absolute velocities from the barotropic-baroclinic modes.
            do k = 1,Nr
             if (k.le.nz) then
              stmp = 0.
              do nk = 1,nz
               stmp = stmp +
     &         modesv(k,nk,nz)*tmpfldxz(i,nk,bi,bj)
              end do
              tmpz(k,bi,bj) = stmp
             else
              tmpz(k,bi,bj) = 0.
             end if
            end do
            do k = 1,Nr
             if (iobcs .eq. 3) then
              tmpfldxz(i,k,bi,bj) = tmpz(k,bi,bj)
     &         *recip_hFacS(i,j+jp1,k,bi,bj)
             else
              tmpfldxz(i,k,bi,bj) = tmpz(k,bi,bj)
     &                           *recip_hFacW(i,j,k,bi,bj)
             endif
            end do
           enddo
          endif
#endif
          do k = 1,Nr
           do i = imin,imax
            xx_obcss1 (i,k,bi,bj,iobcs) = tmpfldxz (i,k,bi,bj)
cgg   &                                    *   maskxz (i,k,bi,bj)
           enddo
          enddo
         enddo
        enddo
       endif

c--   Add control to model variable.
       do bj = jtlo,jthi
        do bi = itlo,ithi
c--   Calculate mask for tracer cells (0 => land, 1 => water).
         do k = 1,Nr
          do i = 1,sNx
           j = OB_Js(i,bi,bj)
           IF ( j.EQ.OB_indexNone ) j = 1
           if (iobcs .EQ. 1) then
            OBSt(i,k,bi,bj) = OBSt (i,k,bi,bj)
     &           + obcssfac            *xx_obcss0(i,k,bi,bj,iobcs)
     &           + (1. _d 0 - obcssfac)*xx_obcss1(i,k,bi,bj,iobcs)
            OBSt(i,k,bi,bj) = OBSt(i,k,bi,bj)
     &           *maskS(i,j+jp1,k,bi,bj)
           else if (iobcs .EQ. 2) then
            OBSs(i,k,bi,bj) = OBSs (i,k,bi,bj)
     &           + obcssfac            *xx_obcss0(i,k,bi,bj,iobcs)
     &           + (1. _d 0 - obcssfac)*xx_obcss1(i,k,bi,bj,iobcs)
            OBSs(i,k,bi,bj) = OBSs(i,k,bi,bj)
     &           *maskS(i,j+jp1,k,bi,bj)
           else if (iobcs .EQ. 4) then
            OBSu(i,k,bi,bj) = OBSu (i,k,bi,bj)
     &           + obcssfac            *xx_obcss0(i,k,bi,bj,iobcs)
     &           + (1. _d 0 - obcssfac)*xx_obcss1(i,k,bi,bj,iobcs)
            OBSu(i,k,bi,bj) = OBSu(i,k,bi,bj)
     &           *maskW(i,j,k,bi,bj)
           else if (iobcs .EQ. 3) then
            OBSv(i,k,bi,bj) = OBSv (i,k,bi,bj)
     &           + obcssfac            *xx_obcss0(i,k,bi,bj,iobcs)
     &           + (1. _d 0 - obcssfac)*xx_obcss1(i,k,bi,bj,iobcs)
            OBSv(i,k,bi,bj) = OBSv(i,k,bi,bj)
     &           *maskS(i,j+jp1,k,bi,bj)
           endif
          enddo
         enddo
        enddo
       enddo

C--   End over iobcs loop
      enddo

#endif /* defined ALLOW_OBCS_SOUTH && defined ALLOW_OBCSS_CONTROL */

      return
      end

#include "GAD_OPTIONS.h"

CBOP
C     !ROUTINE: GAD_CHECK
C     !INTERFACE:
      SUBROUTINE GAD_CHECK( myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE GAD_CHECK
C     | o Check consistency with model configuration
C     *==========================================================*
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GAD.h"

C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
C     myThid :: my Thread Id number
      INTEGER myThid

#ifdef ALLOW_GENERIC_ADVDIFF
C     !LOCAL VARIABLES:
C     === Local variables ===
C     msgBuf :: Informational/error message buffer
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      INTEGER minOlSize, n
      INTEGER errCount
CEOP

      _BEGIN_MASTER(myThid)
      errCount = 0

       WRITE(msgBuf,'(A)') 'GAD_CHECK: #define ALLOW_GENERIC_ADVDIFF'
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                     SQUEEZE_RIGHT , myThid )

C--  Print out some kee parameters :
C    (better chance to know why it is stopping if print first & check after)

C--  Check Options:
#ifdef DISABLE_MULTIDIM_ADVECTION
c     IF ( useMultiDimAdvec ) THEN
      IF ( useMultiDimAdvec .OR.
     &     tempSOM_Advection .OR. saltSOM_Advection
     &   ) THEN
        WRITE(msgBuf,'(2A)') 'GAD_CHECK: ',
     &  'trying to use Multi-Dim. Advection code that is not compiled'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(2A)') 'GAD_CHECK: Re-compile with: ',
     &    ' #undef DISABLE_MULTIDIM_ADVECTION in GAD_OPTIONS.h'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF
#endif /* DISABLE_MULTIDIM_ADVECTION */

#ifndef GAD_ALLOW_TS_SOM_ADV
      IF ( tempAdvScheme.EQ.ENUM_SOM_PRATHER
     & .OR.saltAdvScheme.EQ.ENUM_SOM_PRATHER
     & .OR.tempAdvScheme.EQ.ENUM_SOM_LIMITER
     & .OR.saltAdvScheme.EQ.ENUM_SOM_LIMITER ) THEN
        WRITE(msgBuf,'(2A)') 'GAD_CHECK: ',
     &  'trying to use 2nd.Order-Moment Advection that is not compiled'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(2A)') 'GAD_CHECK: Re-compile with: ',
     &    ' #define GAD_ALLOW_TS_SOM_ADV in GAD_OPTIONS.h'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF
#endif /* ndef GAD_ALLOW_TS_SOM_ADV */

#ifndef GAD_SMOLARKIEWICZ_HACK
      IF ( temp_stayPositive .OR. salt_stayPositive ) THEN
        WRITE(msgBuf,'(2A)') 'GAD_CHECK: ',
     &  'Smolarkiewicz Hack code (to keep T/S positive) is not compiled'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(2A)') 'GAD_CHECK: Re-compile with: ',
     &    ' #define GAD_SMOLARKIEWICZ_HACK in GAD_OPTIONS.h'
        CALL PRINT_ERROR( msgBuf , myThid)
        errCount = errCount + 1
      ENDIF
#endif /* ndef GAD_SMOLARKIEWICZ_HACK */

C--  Check parameters:

C--  Check internal wave dynamics stability regarding active tracer time-stepping
      IF ( .NOT.(staggerTimeStep.OR.implicitIntGravWave) ) THEN
        IF ( ( tempIsActiveTr .AND. .NOT.AdamsBashforthGt )
     &  .OR. ( saltIsActiveTr .AND. .NOT.AdamsBashforthGs ) ) THEN
C-      issue a warning in Error msg file:
           WRITE(msgBuf,'(2A)') '** WARNING ** GAD_CHECK: ',
     &       'potentially unstable time-stepping (Internal Wave)'
           CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                         SQUEEZE_RIGHT , myThid)
           WRITE(msgBuf,'(2A)') '** WARNING ** GAD_CHECK: ',
     &       'need "staggerTimeStep=.TRUE." in "data", nml PARM01'
           CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                         SQUEEZE_RIGHT , myThid)
        ENDIF
      ENDIF

C--   Check size of overlap region
C--   Note: checking minimum size of overlap due to tracer limitations moved here;
C     previously done in GAD_INIT_FIXED, PTRACERS_INIT_FIXED and GMREDI_CHECK;
C     for mom limitations, done in CONFIG_CHECK, but can move to MOM_INIT_FIXED

      minOlSize = MAX( GAD_OlMinSize(1)+GAD_OlMinSize(2),
     &                 GAD_OlMinSize(2)+GAD_OlMinSize(3),
     &                 GAD_OlMinSize(1)*GAD_OlMinSize(3) )
      IF ( OLx.LT.minOlSize .OR. OLy.LT.minOlSize ) THEN
        WRITE(msgBuf,'(A,2I3,A)') 'GAD_CHECK: Overlap Size OLx,OLy=',
     &                             OLx, OLy,' too small'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(2A)') 'GAD_CHECK: ',
     &     'One tracer (T,S,pTrac, ...) advection scheme'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(2A,I3,A,3I2,A)') 'GAD_CHECK: ',
     &     'needs at least OLx,OLy=', minOlSize,
     &     ' (OlMinSize=', (GAD_OlMinSize(n),n=1,3), ')'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF

C Check compatibility with adjoint
#ifdef ALLOW_AUTODIFF
      IF ( tempAdvScheme.EQ.ENUM_PPM_NULL_LIMIT .OR.
     &     tempAdvScheme.EQ.ENUM_PPM_MONO_LIMIT .OR.
     &     tempAdvScheme.EQ.ENUM_PPM_WENO_LIMIT ) THEN
        WRITE(msgBuf,'(A,3(I3,A))') 'GAD_CHECK: tempAdvection =',
     &      ENUM_PPM_NULL_LIMIT, ',', ENUM_PPM_MONO_LIMIT, ', and',
     &      ENUM_PPM_WENO_LIMIT,
     &   ' are not yet implemented for adjoint'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF
      IF ( tempAdvScheme.EQ.ENUM_PQM_NULL_LIMIT .OR.
     &     tempAdvScheme.EQ.ENUM_PQM_MONO_LIMIT .OR.
     &     tempAdvScheme.EQ.ENUM_PQM_WENO_LIMIT ) THEN
        WRITE(msgBuf,'(A,3(I3,A))') 'GAD_CHECK: tempAdvection =',
     &      ENUM_PQM_NULL_LIMIT, ',', ENUM_PQM_MONO_LIMIT, ', and',
     &      ENUM_PQM_WENO_LIMIT,
     &   ' are not yet implemented for adjoint'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF
      IF ( saltAdvScheme.EQ.ENUM_PPM_NULL_LIMIT .OR.
     &     saltAdvScheme.EQ.ENUM_PPM_MONO_LIMIT .OR.
     &     saltAdvScheme.EQ.ENUM_PPM_WENO_LIMIT ) THEN
        WRITE(msgBuf,'(A,3(I3,A))') 'GAD_CHECK: saltAdvection =',
     &      ENUM_PPM_NULL_LIMIT, ',', ENUM_PPM_MONO_LIMIT, ', and',
     &      ENUM_PPM_WENO_LIMIT,
     &   ' are not yet implemented for adjoint'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF
      IF ( saltAdvScheme.EQ.ENUM_PQM_NULL_LIMIT .OR.
     &     saltAdvScheme.EQ.ENUM_PQM_MONO_LIMIT .OR.
     &     saltAdvScheme.EQ.ENUM_PQM_WENO_LIMIT ) THEN
        WRITE(msgBuf,'(A,3(I3,A))') 'GAD_CHECK: saltAdvection =',
     &      ENUM_PQM_NULL_LIMIT, ',', ENUM_PQM_MONO_LIMIT, ', and',
     &      ENUM_PQM_WENO_LIMIT,
     &   ' are not yet implemented for adjoint'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF
#endif /* ALLOW_AUTODIFF */

      IF ( errCount.GE.1 ) THEN
        WRITE(msgBuf,'(A,I3,A)')
     &       'GAD_CHECK: detected', errCount,' fatal error(s)'
        CALL PRINT_ERROR( msgBuf, myThid )
        CALL ALL_PROC_DIE( 0 )
        STOP 'ABNORMAL END: S/R GAD_CHECK'
      ENDIF

      _END_MASTER(myThid)

#endif /* ALLOW_GENERIC_ADVDIFF */
      RETURN
      END

#include "ECCO_OPTIONS.h"

C--  File cost_generic.F: Generic cost function routines
C--   Contents
C--   o cost_generic
C--   o cost_genloop

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: cost_generic
C     !INTERFACE:
      subroutine cost_generic(
     &     nnzbar, localbarfile, dummy,
     &     nnzobs, localobsfile, localerrfile,
     &     mult_local, nrecloc, nrecobs,
     &     localstartdate, localperiod,
     &     ylocmask, spminloc, spmaxloc, spzeroloc,
     &     preproc, preproc_c, preproc_i, preproc_r,
     &     posproc, posproc_c, posproc_i, posproc_r,
     &     outlev, outname,
     &     objf_local, num_local,
     &     myIter, myTime, myThid )

C     !DESCRIPTION: \bv
C     Generic routine for evaluating time-dependent
c       cost function contribution
C     \ev

C     !USES:
      IMPLICIT NONE

C     == global variables ==
#include "EEPARAMS.h"
#include "SIZE.h"
#include "PARAMS.h"
#include "GRID.h"
#ifdef ALLOW_CAL
# include "cal.h"
#endif
#ifdef ALLOW_ECCO
# include "ECCO_SIZE.h"
# include "ECCO.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
      integer myIter
      integer myThid
      integer nnzbar, nnzobs
      integer nrecloc, nrecobs
      integer localstartdate(4)
      integer outlev
      integer preproc_i(NGENPPROC)
      integer posproc_i(NGENPPROC)

      _RL objf_local(nSx,nSy)
      _RL num_local(nSx,nSy)
      _RL dummy
      _RL mult_local
      _RL myTime
      _RL localperiod
      _RL spminloc
      _RL spmaxloc
      _RL spzeroloc
      _RL preproc_r(NGENPPROC)
      _RL posproc_r(NGENPPROC)

      character*(1) ylocmask
      character*(MAX_LEN_FNAM) localbarfile
      character*(MAX_LEN_FNAM) localobsfile
      character*(MAX_LEN_FNAM) localerrfile
      character*(MAX_LEN_FNAM) preproc(NGENPPROC)
      character*(MAX_LEN_FNAM) preproc_c(NGENPPROC)
      character*(MAX_LEN_FNAM) posproc(NGENPPROC)
      character*(MAX_LEN_FNAM) posproc_c(NGENPPROC)
      character*(MAX_LEN_FNAM) outname

#ifdef ALLOW_ECCO
C     !LOCAL VARIABLES:
      integer bi,bj,k2
      logical domean, doanom
      _RL localdifmean1  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      _RL localdifmean2  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
CEOP

c--   Initialise local variables.

      DO bj = myByLo(myThid), myByHi(myThid)
        DO bi = myBxLo(myThid), myBxHi(myThid)
          objf_local(bi,bj) = 0. _d 0
          num_local(bi,bj) = 0. _d 0
        ENDDO
      ENDDO

      call ecco_zero(localdifmean1,Nr,zeroRL,myThid)
      call ecco_zero(localdifmean2,Nr,zeroRL,myThid)

      domean=.FALSE.
      doanom=.FALSE.
      do k2 = 1, NGENPPROC
          if (preproc(k2).EQ.'mean') domean=.TRUE.
          if (preproc(k2).EQ.'anom') doanom=.TRUE.
      enddo

C Extra time loop to compute time-mean fields and costs
      if ( (.NOT. ( localobsfile.EQ.' ' ) )
     &   .AND. ( domean .OR. doanom ) ) then
        call cost_genloop(
     &     localdifmean1,localdifmean2,.FALSE.,
     &     nnzbar, localbarfile, dummy,
     &     nnzobs, localobsfile, localerrfile,
     &     mult_local, nrecloc, nrecobs,
     &     localstartdate, localperiod,
     &     ylocmask, spminloc, spmaxloc, spzeroloc,
     &     preproc, preproc_c, preproc_i, preproc_r,
     &     posproc, posproc_c, posproc_i, posproc_r,
     &     outlev, outname,
     &     objf_local, num_local,
     &     myIter, myTime, myThid )
      endif

      call ecco_zero(localdifmean1,Nr,zeroRL,myThid)

      if ((.NOT.(localobsfile.EQ.' ')).AND.(.NOT.domean)) then
        call cost_genloop(
     &     localdifmean2,localdifmean1,.TRUE.,
     &     nnzbar, localbarfile, dummy,
     &     nnzobs, localobsfile, localerrfile,
     &     mult_local, nrecloc, nrecobs,
     &     localstartdate, localperiod,
     &     ylocmask, spminloc, spmaxloc, spzeroloc,
     &     preproc, preproc_c, preproc_i, preproc_r,
     &     posproc, posproc_c, posproc_i, posproc_r,
     &     outlev, outname,
     &     objf_local, num_local,
     &     myIter, myTime, myThid )
      endif

#endif /* ALLOW_ECCO */

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: cost_genloop
C     !INTERFACE:
      subroutine cost_genloop(
     &     localdifmeanIn,localdifmeanOut, addVariaCost,
     &     nnzbar, localbarfile, dummy,
     &     nnzobs, localobsfile, localerrfile,
     &     mult_local, nrecloc, nrecobs,
     &     localstartdate, localperiod,
     &     ylocmask, spminloc, spmaxloc, spzeroloc,
     &     preproc, preproc_c, preproc_i, preproc_r,
     &     posproc, posproc_c, posproc_i, posproc_r,
     &     outlev, outname,
     &     objf_local, num_local,
     &     myIter, myTime, myThid )

C     !DESCRIPTION: \bv
C     Generic routine for evaluating time-dependent
c       cost function contribution
C     \ev

C     !USES:
      IMPLICIT NONE

C     == global variables ==
#include "EEPARAMS.h"
#include "SIZE.h"
#include "PARAMS.h"
#include "GRID.h"
#ifdef ALLOW_CAL
# include "cal.h"
#endif
#ifdef ALLOW_ECCO
# include "ECCO_SIZE.h"
# include "ECCO.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
      integer myIter
      integer myThid
      integer nnzbar, nnzobs
      integer nrecloc, nrecobs
      integer localstartdate(4)
      integer outlev
      integer preproc_i(NGENPPROC)
      integer posproc_i(NGENPPROC)

      _RL objf_local(nSx,nSy)
      _RL num_local(nSx,nSy)
      _RL dummy
      _RL mult_local
      _RL myTime
      _RL localperiod
      _RL spminloc
      _RL spmaxloc
      _RL spzeroloc
      _RL preproc_r(NGENPPROC)
      _RL posproc_r(NGENPPROC)

      character*(1) ylocmask
      character*(MAX_LEN_FNAM) localbarfile
      character*(MAX_LEN_FNAM) localobsfile
      character*(MAX_LEN_FNAM) localerrfile
      character*(MAX_LEN_FNAM) preproc(NGENPPROC)
      character*(MAX_LEN_FNAM) preproc_c(NGENPPROC)
      character*(MAX_LEN_FNAM) posproc(NGENPPROC)
      character*(MAX_LEN_FNAM) posproc_c(NGENPPROC)
      character*(MAX_LEN_FNAM) outname

      logical addVariaCost
      _RL localdifmeanIn (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      _RL localdifmeanOut(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)

#ifdef ALLOW_ECCO
C     !FUNCTIONS:
      integer  ilnblnk
      external ilnblnk

C     !LOCAL VARIABLES:
      integer bi,bj
      integer i,j,k
      integer irec, jrec
      integer il, k2
      integer localrec, obsrec
      integer nrecloop, nrecclim, k2smooth
      logical domean, doanom, dovarwei, doclim, dosmooth, dosumsq
      logical dooffset, domaskmindepth

      _RL localmask  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)

      _RL localbar   (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      _RL localweight(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      _RL localtmp   (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      _RL localobs   (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      _RL localdif   (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      _RL difmask    (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)

      _RL localdifmsk(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      _RL localdifsum(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      _RL localdifnum(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)

#ifdef ALLOW_SMOOTH
      _RL tmpfld2D(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RS mask2D(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
#endif

      _RL fac
      _RL topomin

      character*(128) fname1, fname2, fname3

      logical exst
CEOP

      call ecco_zero(localbar,Nr,zeroRL,myThid)
      call ecco_zero(localweight,Nr,zeroRL,myThid)
      call ecco_zero(localtmp,Nr,zeroRL,myThid)
      call ecco_zero(localmask,Nr,zeroRL,myThid)

      call ecco_zero(localobs,Nr,zeroRL,myThid)
      call ecco_zero(localdif,Nr,zeroRL,myThid)
      call ecco_zero(difmask,Nr,zeroRL,myThid)

      call ecco_zero(localdifmsk,Nr,zeroRL,myThid)
      call ecco_zero(localdifsum,Nr,zeroRL,myThid)
      call ecco_zero(localdifnum,Nr,zeroRL,myThid)

      dosumsq=.TRUE.
      domean=.FALSE.
      doanom=.FALSE.
      dovarwei=.FALSE.
      dosmooth=.FALSE.
      dooffset=.FALSE.
      domaskmindepth=.FALSE.
      k2smooth=1
      doclim=.FALSE.
      nrecclim=nrecloc
      fac=oneRL

      do k2 = 1, NGENPPROC
          if (preproc(k2).EQ.'mean') domean=.TRUE.
          if (preproc(k2).EQ.'anom') doanom=.TRUE.
          if (preproc(k2).EQ.'variaweight') dovarwei=.TRUE.
          if (preproc(k2).EQ.'nosumsq') dosumsq=.FALSE.
          if (preproc(k2).EQ.'offset') dooffset=.TRUE.
          if (preproc(k2).EQ.'mindepth') then
           domaskmindepth=.TRUE.
           topomin = preproc_r(k2)
          endif
          if (posproc(k2).EQ.'smooth') then
            dosmooth=.TRUE.
            k2smooth=k2
          endif
          if (preproc(k2).EQ.'clim') then
            doclim=.TRUE.
            nrecclim=preproc_i(k2)
          endif
          if (preproc(k2).EQ.'factor') then
            fac=preproc_r(k2)
          endif
      enddo

C--   Assign mask, write explicitly to include overlaps and
C     avoid exchange later (e.g. in smooth routine), note that
C     the routine ecco_cprsrl does not copy overlaps
      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)

        IF ( ylocmask .EQ. 'C' .OR. ylocmask .EQ. 'c' ) THEN
         DO k = 1, Nr
          DO j = 1-OLy,sNy+OLy
           DO i = 1-OLx,sNx+OLx
            localmask(i,j,k,bi,bj) = maskC(i,j,k,bi,bj)
           ENDDO
          ENDDO
         ENDDO

        ELSEIF ( ylocmask .EQ. 'S' .OR. ylocmask .EQ. 's' ) THEN

         DO k = 1, Nr
          DO j = 1-OLy,sNy+OLy
           DO i = 1-OLx,sNx+OLx
            localmask(i,j,k,bi,bj) = maskS(i,j,k,bi,bj)
           ENDDO
          ENDDO
         ENDDO

        ELSEIF ( ylocmask .EQ. 'W' .OR. ylocmask .EQ. 'w' ) THEN

         DO k = 1, Nr
          DO j = 1-OLy,sNy+OLy
           DO i = 1-OLx,sNx+OLx
            localmask(i,j,k,bi,bj) = maskW(i,j,k,bi,bj)
           ENDDO
          ENDDO
         ENDDO

        ELSE
         CALL ECCO_ERROR('COST_GENLOOP', 'wrong ylocmask', myThid)
        ENDIF

#ifdef ALLOW_SMOOTH
C       Set 2D Mask for 2D smooth routine
        DO j = 1-OLy,sNy+OLy
         DO i = 1-OLx,sNx+OLx
          mask2D(i,j,bi,bj) = localmask(i,j,1,bi,bj)
          tmpFld2D(i,j,bi,bj) = 0. _d 0
         ENDDO
        ENDDO
#endif
C-- end bi/bj loop for setting masks
       ENDDO
      ENDDO

c-- set nrecloop to nrecloc
      nrecloop=nrecloc

c-- reset nrecloop, if needed, according to preproc
      if ( doclim ) nrecloop=MIN(nrecloop,nrecclim)

c--   loop over obsfile records
      do irec = 1, nrecloop

c--     load weights
        exst=.FALSE.
        jrec=1
        if( dovarwei ) jrec = irec
        call cost_gencal(localbarfile, localerrfile,
     &     jrec, localstartdate, localperiod, fname1,
     &     fname3, localrec, obsrec, exst, myThid )
        call ecco_zero(localweight,Nr,zeroRL,myThid)
        if ( (localrec .GT. 0).AND.(obsrec .GT. 0).AND.(exst) )
     &  call ecco_readwei(fname3,localweight,
     &                    localrec,Nr,nnzobs,dosumsq,myThid)

c--     determine records and file names
        exst=.FALSE.
        call cost_gencal(localbarfile, localobsfile,
     &     irec, localstartdate, localperiod, fname1,
     &     fname2, localrec, obsrec, exst, myThid )

c--     load model average and observed average
        call ecco_zero(localbar,Nr,zeroRL,myThid)
        call cost_genread( fname1, localbar, localtmp, irec, Nr, nnzbar,
     &       nrecloc, preproc, preproc_c, preproc_i, preproc_r,
     &       dummy, myThid )
        call ecco_mult(localbar,fac,Nr,nnzbar,myThid)

        call ecco_zero(localobs,Nr,spzeroloc,myThid)
        if ( (localrec .GT. 0).AND.(obsrec .GT. 0).AND.(exst) ) then
         CALL READ_REC_LEV_RL( fname2, cost_iprec, Nr, 1, nnzobs,
     &                         localobs, localrec, 1, myThid )
        endif

c--     Compute masked model-data difference
        call ecco_diffmsk( localbar, localobs, localmask,
     &     Nr, nnzobs, spminloc, spmaxloc, spzeroloc,
     &     localdif, difmask, myThid )

        if ( domaskmindepth ) call ecco_maskmindepth(
     &       difmask, Nr, nnzobs, topomin, myThid )

        if ( doanom ) call ecco_subtract( localdif,
     &       localdifmeanIn, Nr, nnzobs, myThid )

        if ( domean.OR.doanom ) call ecco_addmask(
     &       localdif, difmask, localdifsum,
     &       localdifnum, Nr, nnzobs, myThid )

        if (addVariaCost) then

#ifdef ALLOW_SMOOTH
         IF ( useSMOOTH.AND.dosmooth.AND.
     &     (nnzbar.EQ.1).AND.(nnzobs.EQ.1) ) THEN
          DO bj = myByLo(myThid), myByHi(myThid)
           DO bi = myBxLo(myThid), myBxHi(myThid)
            DO j = 1-OLy,sNy+OLy
             DO i = 1-OLx,sNx+OLx
              tmpFld2D(i,j,bi,bj) = localdif(i,j,1,bi,bj)
             ENDDO
            ENDDO
           ENDDO
          ENDDO
          CALL SMOOTH_HETERO2D(tmpFld2D,mask2D,
     &         posproc_c(k2smooth),posproc_i(k2smooth),myThid)
          DO bj = myByLo(myThid), myByHi(myThid)
           DO bi = myBxLo(myThid), myBxHi(myThid)
            DO j = 1-OLy,sNy+OLy
             DO i = 1-OLx,sNx+OLx
              localdif(i,j,1,bi,bj) = tmpFld2D(i,j,bi,bj)
             ENDDO
            ENDDO
           ENDDO
          ENDDO
         ENDIF
#endif

c--     Compute normalized model-obs cost function
         call ecco_addcost(
     I             localdif, localweight, difmask, Nr, nnzobs, dosumsq,
     U             objf_local, num_local,
     I             myThid
     &             )
c--     output model-data difference to disk
         if ( outlev.GT.0 ) then
          il=ilnblnk(outname)
          write(fname3(1:128),'(2a)') 'misfit_', outname(1:il)
          if ( nnzobs.EQ.1 ) CALL
     &    WRITE_REC_XY_RL( fname3, localdif,irec, eccoiter, myThid )
          if ( nnzobs.EQ.Nr ) CALL
     &    WRITE_REC_XYZ_RL( fname3, localdif,irec, eccoiter, myThid )
         endif

         if ( outlev.GT.1 ) then
          if ( dovarwei ) then
           il=ilnblnk(outname)
           write(fname3(1:128),'(2a)') 'weight_', outname(1:il)
           if ( nnzobs.EQ.1 ) CALL WRITE_REC_XY_RL( fname3,
     &                           localweight, irec, eccoiter, myThid )
           if ( nnzobs.EQ.Nr ) CALL WRITE_REC_XYZ_RL( fname3,
     &                           localweight, irec, eccoiter, myThid )
          endif
         endif
        endif

      enddo
c--   End of loop over obsfile records.

      call ecco_zero(localdifmeanOut,Nr,zeroRL,myThid)
      call ecco_cp      (localdifsum,localdifmeanOut,Nr,nnzobs,myThid)
      call ecco_divfield(localdifmeanOut,localdifnum,Nr,nnzobs,myThid)
      call ecco_cp      (localdifnum,localdifmsk,Nr,nnzobs,myThid)
      call ecco_divfield(localdifmsk,localdifnum,Nr,nnzobs,myThid)

      if (dooffset) then
       il=ilnblnk(localbarfile)
       call ecco_offset(
     I      localbarfile(1:il),
     U      localdifmeanOut,
     I      localdifmsk,Nr,nnzobs,myThid)
      endif

      if ( domean ) then
c--     Compute normalized model-obs cost function
        call ecco_addcost(
     I                    localdifmeanOut, localweight, localdifmsk,
     I                    Nr, nnzobs, dosumsq,
     U                    objf_local, num_local,
     I                    myThid )

c--     output model-data difference to disk
        if ( outlev.GT.0 ) then
          il=ilnblnk(outname)
          write(fname3(1:128),'(2a)') 'misfit_', outname(1:il)
          if ( nnzobs.EQ.1 ) CALL
     &    WRITE_REC_XY_RL(fname3,localdifmeanOut,1,eccoiter,myThid)
          if ( nnzobs.EQ.Nr ) CALL
     &    WRITE_REC_XYZ_RL(fname3,localdifmeanOut,1,eccoiter,myThid)
        endif
      endif
      if ( outlev.GT.1 ) then
       if ( .NOT.dovarwei ) then
          il=ilnblnk(outname)
          write(fname3(1:128),'(2a)') 'weight_', outname(1:il)
          if ( nnzobs.EQ.1 ) CALL
     &    WRITE_REC_XY_RL( fname3, localweight, 1, eccoiter, myThid )
          if ( nnzobs.EQ.Nr ) CALL
     &    WRITE_REC_XYZ_RL( fname3, localweight, 1, eccoiter, myThid )
       endif
      endif

#endif /* ALLOW_ECCO */

      RETURN
      END

#include "CD_CODE_OPTIONS.h"

      SUBROUTINE CD_CODE_INIT_FIXED( myThid )

      IMPLICIT NONE
C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"

C     == Routine arguments ==
C     myThid -  Number of this instance of INI_UVEL 
      INTEGER myThid

C     !LOCAL VARIABLES:
C     == Local variables ==
CEOP

#ifdef ALLOW_CD_CODE

#ifdef ALLOW_MNC
      IF (useMNC) THEN
C       Define grid types for CD_CODE variables
        CALL MNC_CW_ADD_VNAME('uVelD', 'Cen_xy_Hn__C__t',
     &       4,5, myThid)
        CALL MNC_CW_ADD_VATTR_TEXT('uVelD','units','m/s', 
     &       myThid)
        CALL MNC_CW_ADD_VATTR_TEXT('uVelD','long_name',
     &       'CD_CODE_u_velocity', myThid)
        CALL MNC_CW_ADD_VATTR_TEXT('uVelD',
     &       'coordinates','XC YC RC iter', myThid)
        
        CALL MNC_CW_ADD_VNAME('vVelD', 'Cen_xy_Hn__C__t',
     &       4,5, myThid)
        CALL MNC_CW_ADD_VATTR_TEXT('vVelD','units','m/s', 
     &       myThid)
        CALL MNC_CW_ADD_VATTR_TEXT('vVelD','long_name',
     &       'CD_CODE_v_velocity', myThid)
        CALL MNC_CW_ADD_VATTR_TEXT('vVelD',
     &       'coordinates','XC YC RC iter', myThid)
        
        CALL MNC_CW_ADD_VNAME('Unm1', 'Cen_xy_Hn__C__t',
     &       4,5, myThid)
        CALL MNC_CW_ADD_VATTR_TEXT('Unm1','units','m/s', 
     &       myThid)
        CALL MNC_CW_ADD_VATTR_TEXT('Unm1','long_name',
     &       'CD_CODE_u_velocity_at_n-1', myThid)
        CALL MNC_CW_ADD_VATTR_TEXT('Unm1',
     &       'coordinates','XC YC RC iter', myThid)
        
        CALL MNC_CW_ADD_VNAME('Vnm1', 'Cen_xy_Hn__C__t',
     &       4,5, myThid)
        CALL MNC_CW_ADD_VATTR_TEXT('Vnm1','units','m/s', 
     &       myThid)
        CALL MNC_CW_ADD_VATTR_TEXT('Vnm1','long_name',
     &       'CD_CODE_u_velocity_at_n-1', myThid)
        CALL MNC_CW_ADD_VATTR_TEXT('Vnm1',
     &       'coordinates','XC YC RC iter', myThid)
        
        CALL MNC_CW_ADD_VNAME('etaNm1', 'Cen_xy_Hn__-__t',
     &       3,4, myThid)
        CALL MNC_CW_ADD_VATTR_TEXT('etaNm1','units','m', 
     &       myThid)
        CALL MNC_CW_ADD_VATTR_TEXT('etaNm1','long_name',
     &       'CD_CODE_ssh_at_n-1', myThid)
        CALL MNC_CW_ADD_VATTR_TEXT('etaNm1',
     &       'coordinates','XC YC RC iter', myThid)
      ENDIF
#endif /* ALLOW_MNC */

#endif /*  ALLOW_CD_CODE  */

      RETURN
      END

#include "DIAG_OPTIONS.h"

C--   File diagnostics_utils.F: General purpose support routines
C--    Contents:
C--    o DIAGNOSTICS_COUNT
C--    o DIAGNOSTICS_GET_DIAG
C--    o DIAGNOSTICS_GET_POINTERS
C--    o DIAGNOSTICS_SETKLEV
C--    o DIAGS_TRACK_DIVA
C--    o DIAGS_GET_PARMS_I (Function)
C--    o DIAGS_MK_UNITS (Function)
C--    o DIAGS_MK_TITLE (Function)
C--    o DIAGS_RENAMED (Function)

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: DIAGNOSTICS_COUNT
C     !INTERFACE:
      SUBROUTINE DIAGNOSTICS_COUNT( diagName,
     I                              biArg, bjArg, myThid )

C     !DESCRIPTION:
C***********************************************************************
C   routine to increment the diagnostic counter only
C***********************************************************************
C     !USES:
      IMPLICIT NONE

C     == Global variables ===
#include "EEPARAMS.h"
#include "SIZE.h"
#include "DIAGNOSTICS_SIZE.h"
#include "DIAGNOSTICS.h"

C     !INPUT PARAMETERS:
C***********************************************************************
C  Arguments Description
C  ----------------------
C     diagName :: name of diagnostic to increment the counter
C     biArg    :: X-direction tile number, or 0 if called outside bi,bj loops
C     bjArg    :: Y-direction tile number, or 0 if called outside bi,bj loops
C     myThid   :: my thread Id number
C***********************************************************************
      CHARACTER*8 diagName
      INTEGER biArg, bjArg
      INTEGER myThid
CEOP

C     !LOCAL VARIABLES:
C ===============
      INTEGER m, n
      INTEGER bi, bj
      INTEGER ipt, ndId
c     CHARACTER*(MAX_LEN_MBUF) msgBuf

      IF ( biArg.EQ.0 .AND. bjArg.EQ.0 ) THEN
        bi = myBxLo(myThid)
        bj = myByLo(myThid)
      ELSE
        bi = MIN(biArg,nSx)
        bj = MIN(bjArg,nSy)
      ENDIF

C--   Run through list of active diagnostics to find which counter
C     to increment (needs to be a valid & active diagnostic-counter)
      DO n=1,nLists
       DO m=1,nActive(n)
        IF ( diagName.EQ.flds(m,n) .AND. idiag(m,n).GT.0 ) THEN
         ipt = idiag(m,n)
         IF (ndiag(ipt,bi,bj).GE.0) THEN
          ndId = ABS(jdiag(m,n))
          ipt = ipt + pdiag(n,bi,bj)*kdiag(ndId)
C-    Increment the counter for the diagnostic
          IF ( biArg.EQ.0 .AND. bjArg.EQ.0 ) THEN
           DO bj=myByLo(myThid), myByHi(myThid)
            DO bi=myBxLo(myThid), myBxHi(myThid)
             ndiag(ipt,bi,bj) = ndiag(ipt,bi,bj) + 1
            ENDDO
           ENDDO
          ELSE
             ndiag(ipt,bi,bj) = ndiag(ipt,bi,bj) + 1
          ENDIF
C-    Increment is done
         ENDIF
        ENDIF
       ENDDO
      ENDDO

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: DIAGNOSTICS_GET_DIAG

C     !INTERFACE:
      SUBROUTINE DIAGNOSTICS_GET_DIAG(
     I                    kl, undefRL,
     O                    qtmp,
     I                    ndId, mate, ip, im, bi, bj, myThid )

C     !DESCRIPTION:
C     Retrieve time-averaged (or snap-shot) diagnostic field

C     !USES:
      IMPLICIT NONE
#include "EEPARAMS.h"
#include "SIZE.h"
#include "DIAGNOSTICS_SIZE.h"
#include "DIAGNOSTICS.h"

C     !INPUT PARAMETERS:
C     kl      :: level selection: >0 : single selected lev ; =0 : all kdiag levels
C     undefRL :: undefined "_RL" type value
C     ndId    :: diagnostic Id number (in available diagnostics list)
C     mate    :: counter diagnostic number if any ; 0 otherwise
C     ip      :: pointer to storage array location for diag.
C     im      :: pointer to storage array location for mate
C     bi      :: X-direction tile number
C     bj      :: Y-direction tile number
C     myThid  :: my thread Id number
      INTEGER kl
      _RL undefRL
      INTEGER ndId, mate, ip, im
      INTEGER bi, bj, myThid

C     !OUTPUT PARAMETERS:
C     qtmp    :: time-averaged (or snap-shot) diagnostic field
      _RL qtmp(1-OLx:sNx+OLx,1-OLy:sNy+OLy,*)
CEOP

C     !LOCAL VARIABLES:
      _RL factor
      INTEGER i, j, ipnt, ipCt
      INTEGER k, kd, km, kLev

      IF (ndId.GE.1) THEN
       kLev = kdiag(ndId)
       IF ( kl.GE.1 .AND. kl.LE.kLev ) THEN
        kLev = 1
       ELSEIF ( kl.NE.0 ) THEN
        kLev = 0
       ENDIF

       DO k = 1,kLev
        kd = k
        IF ( kl.GE.1 ) kd = kl

        IF ( mate.EQ.0 ) THEN
C-      No counter diagnostics => average = Sum / ndiag :

          ipnt = ip + kd - 1
          factor = FLOAT(ndiag(ip,bi,bj))
          IF (ndiag(ip,bi,bj).NE.0) factor = 1. _d 0 / factor

#ifdef ALLOW_FIZHI
          DO j = 1,sNy+1
            DO i = 1,sNx+1
              IF ( qdiag(i,j,ipnt,bi,bj) .LE. undefRL ) THEN
                qtmp(i,j,k) = qdiag(i,j,ipnt,bi,bj)*factor
              ELSE
                qtmp(i,j,k) = undefRL
              ENDIF
            ENDDO
          ENDDO
#else /* ALLOW_FIZHI */
          DO j = 1,sNy+1
            DO i = 1,sNx+1
              qtmp(i,j,k) = qdiag(i,j,ipnt,bi,bj)*factor
            ENDDO
          ENDDO
#endif /* ALLOW_FIZHI */

        ELSE
C-      With counter diagnostics => average = Sum / counter:

          ipnt = ip + kd - 1
          km = MIN(kd,kdiag(mate))
          ipCt = im + km - 1
          DO j = 1,sNy+1
            DO i = 1,sNx+1
              IF ( qdiag(i,j,ipCt,bi,bj) .NE. 0. ) THEN
                qtmp(i,j,k) = qdiag(i,j,ipnt,bi,bj)
     &                      / qdiag(i,j,ipCt,bi,bj)
              ELSE
                qtmp(i,j,k) = undefRL
              ENDIF
            ENDDO
          ENDDO

        ENDIF
       ENDDO
      ENDIF

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: DIAGNOSTICS_GET_POINTERS
C     !INTERFACE:
      SUBROUTINE DIAGNOSTICS_GET_POINTERS(
     I                       diagName, listId,
     O                       ndId, ip,
     I                       myThid )

C     !DESCRIPTION:
C     *================================================================*
C     | o Returns the diagnostic Id number and diagnostic
C     |   pointer to storage array for a specified diagnostic.
C     *================================================================*
C     | Note: A diagnostics field can be stored multiple times
C     |       (for different output frequency,phase, ...).
C     | operates in 2 ways:
C     | o listId =0 => find 1 diagnostics Id & pointer which name matches.
C     | o listId >0 => find the unique diagnostic Id & pointer with
C     |      the right name and same output time as "listId" output-list
C     | o return ip=0 if did not find the right diagnostic;
C     |   (ndId <>0 if diagnostic exist but output time does not match)
C     *================================================================*

C     !USES:
      IMPLICIT NONE
#include "EEPARAMS.h"
#include "SIZE.h"
#include "DIAGNOSTICS_SIZE.h"
#include "DIAGNOSTICS.h"

C     !INPUT PARAMETERS:
C     diagName :: diagnostic identificator name (8 characters long)
C     listId   :: list number that specify the output frequency
C     myThid   :: my Thread Id number
C     !OUTPUT PARAMETERS:
C     ndId     :: diagnostics  Id number (in available diagnostics list)
C     ip       :: diagnostics  pointer to storage array

      CHARACTER*8 diagName
      INTEGER listId
      INTEGER ndId, ip
      INTEGER myThid
CEOP

C     !LOCAL VARIABLES:
      INTEGER n,m

      ip   = 0
      ndId = 0

      IF ( listId.LE.0 ) THEN
C--   select the 1rst one which name matches:

C-    search for this diag. in the active 2D/3D diagnostics list
        DO n=1,nLists
         DO m=1,nActive(n)
           IF ( ip.EQ.0 .AND. diagName.EQ.flds(m,n)
     &                  .AND. idiag(m,n).NE.0 ) THEN
            ip   = ABS(idiag(m,n))
            ndId = ABS(jdiag(m,n))
           ENDIF
         ENDDO
        ENDDO

      ELSEIF ( listId.LE.nLists ) THEN
C--   select the unique diagnostic with output-time identical to listId

C-    search for this diag. in the active 2D/3D diagnostics list
        DO n=1,nLists
         IF ( ip.EQ.0
     &        .AND. freq(n) .EQ. freq(listId)
     &        .AND. phase(n).EQ.phase(listId)
     &        .AND. averageFreq(n) .EQ.averageFreq(listId)
     &        .AND. averagePhase(n).EQ.averagePhase(listId)
     &        .AND. averageCycle(n).EQ.averageCycle(listId)
     &      ) THEN
          DO m=1,nActive(n)
           IF ( ip.EQ.0 .AND. diagName.EQ.flds(m,n)
     &                  .AND. idiag(m,n).NE.0 ) THEN
            ip   = ABS(idiag(m,n))
            ndId = ABS(jdiag(m,n))
           ENDIF
          ENDDO
         ELSEIF ( ip.EQ.0 ) THEN
          DO m=1,nActive(n)
           IF ( ip.EQ.0 .AND. diagName.EQ.flds(m,n)
     &                  .AND. idiag(m,n).NE.0 ) THEN
            ndId = ABS(jdiag(m,n))
           ENDIF
          ENDDO
         ENDIF
        ENDDO

      ELSE
        STOP 'DIAGNOSTICS_GET_POINTERS: invalid listId number'
      ENDIF

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: DIAGNOSTICS_SETKLEV

C     !INTERFACE:
      SUBROUTINE DIAGNOSTICS_SETKLEV(
     I                                diagName, nLevDiag, myThid )

C     !DESCRIPTION:
C     *==========================================================*
C     | S/R DIAGNOSTICS_SETKLEV
C     | o Define explicitly the number of level (stored in kdiag)
C     |   of a diagnostic field. For most diagnostics, the number
C     |   of levels is derived (in S/R SET_LEVELS) from gdiag(10)
C     |   but occasionally one may want to set it explicitly.
C     *==========================================================*

C     !USES:
      IMPLICIT NONE
#include "EEPARAMS.h"
#include "SIZE.h"
#include "DIAGNOSTICS_SIZE.h"
#include "DIAGNOSTICS.h"

C     !INPUT PARAMETERS:
C     diagName  :: diagnostic identificator name (8 characters long)
C     nLevDiag  :: number of level to set for this diagnostics field
C     myThid    :: my Thread Id number
      CHARACTER*8  diagName
      INTEGER nLevDiag
      INTEGER myThid
CEOP

C     !LOCAL VARIABLES:
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      INTEGER n, ndId

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      _BEGIN_MASTER( myThid)

C--   Check if this S/R is called from the right place ;
C     needs to be after DIAGNOSTICS_INIT_EARLY and before DIAGNOSTICS_INIT_FIXED
      IF ( diag_pkgStatus.NE.ready2setDiags ) THEN
        CALL DIAGNOSTICS_STATUS_ERROR( 'DIAGNOSTICS_SETKLEV',
     &                   ' ', diagName, ready2setDiags, myThid )
      ENDIF

C--   Find this diagnostics in the list of available diag.
      ndId = 0
      DO n = 1,ndiagt
        IF ( diagName.EQ.cdiag(n) ) THEN
          ndId = n
        ENDIF
      ENDDO
      IF ( ndId.EQ.0 ) THEN
        WRITE(msgBuf,'(4A)') 'DIAGNOSTICS_SETKLEV: ',
     &     'diagName="', diagName, '" not known.'
        CALL PRINT_ERROR( msgBuf, myThid )
        STOP 'ABNORMAL END: S/R DIAGNOSTICS_SETKLEV'
      ENDIF

C-    Optional level number diagnostics (X): set number of levels
      IF ( kdiag(ndId).EQ.0
     &   .AND. gdiag(ndId)(10:10).EQ.'X' ) THEN
        kdiag(ndId) = nLevDiag
      ELSEIF ( kdiag(ndId).EQ.nLevDiag
     &   .AND. gdiag(ndId)(10:10).EQ.'X' ) THEN
C-    level number already set to same value: send warning
        WRITE(msgBuf,'(4A,I5)') '** WARNING ** DIAGNOSTICS_SETKLEV: ',
     &     'diagName="', diagName, '" , nLevDiag=', nLevDiag
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                      SQUEEZE_RIGHT , myThid )
        WRITE(msgBuf,'(2A,I5,A)')'** WARNING ** DIAGNOSTICS_SETKLEV:',
     &     ' level Nb (=', kdiag(ndId), ') already set.'
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                      SQUEEZE_RIGHT , myThid )
      ELSEIF ( gdiag(ndId)(10:10).EQ.'X' ) THEN
C-    level number already set to a different value: do not reset but stop
        WRITE(msgBuf,'(4A,I5)') 'DIAGNOSTICS_SETKLEV: ',
     &     'diagName="', diagName, '" , nLevDiag=', nLevDiag
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(2A,I5,3A)') 'DIAGNOSTICS_SETKLEV: ',
     &     'level Nb already set to', kdiag(ndId), ' => STOP'
        CALL PRINT_ERROR( msgBuf, myThid )
      ELSE
C-    for now, do nothing but just send a warning
        WRITE(msgBuf,'(4A,I5)') '** WARNING ** DIAGNOSTICS_SETKLEV: ',
     &     'diagName="', diagName, '" , nLevDiag=', nLevDiag
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                      SQUEEZE_RIGHT , myThid )
        WRITE(msgBuf,'(2A,I5,3A)') '** WARNING ** will set level Nb',
     &     ' from diagCode(ndId=', ndId, ')="', gdiag(ndId)(1:10), '"'
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                      SQUEEZE_RIGHT , myThid )
        WRITE(msgBuf,'(4A)') '** WARNING ** DIAGNOSTICS_SETKLEV',
     &     '("', diagName, '") <== Ignore this call.'
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                      SQUEEZE_RIGHT , myThid )
      ENDIF

      _END_MASTER( myThid)

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: DIAGS_TRACK_DIVA

C     !INTERFACE:
      SUBROUTINE DIAGS_TRACK_DIVA(
     O                 divaFirst,
     I                 myIter, myThid )

C     !DESCRIPTION:
C     Track status of Divided-Adjoint run by returning
C     divaFirst=T if first call, and divaFirst=F otherwise
C     Note:
C     could figure out this with content of "divided.ctrl" file plus
C     all nchklev_{1,2,3,4} and (myIter,nIter0,nEndIter) but easier to
C     just check for first call (this avoids reading file divided.ctrl).

C     !USES:
      IMPLICIT NONE
#include "EEPARAMS.h"
c#include "SIZE.h"

C     !INPUT PARAMETERS:
C     myIter    :: Current iteration number
C     myThid    :: my Thread Id number
      INTEGER myIter
      INTEGER myThid

C     !OUTPUT PARAMETERS:
C     divaFirst :: true if first call, otherwise set to false
      LOGICAL divaFirst

C     !LOCAL VARIABLES:
C     == Local variables in common block ==
      INTEGER keepTrackDivaRun(MAX_NO_THREADS)
      COMMON / LOCAL_DIAGS_TRACK_DIVA / keepTrackDivaRun
C     == Local variables ==
CEOP

      IF ( myIter .EQ. -2 ) THEN
C--   Initialise variable in common block:
        keepTrackDivaRun(myThid) = 0
        divaFirst = .FALSE.
      ELSEIF ( keepTrackDivaRun(myThid).EQ.0 ) THEN
        divaFirst = .TRUE.
        keepTrackDivaRun(myThid) = 1
      ELSE
        divaFirst = .FALSE.
      ENDIF

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: DIAGS_GET_PARMS_I

C     !INTERFACE:
      INTEGER FUNCTION DIAGS_GET_PARMS_I(
     I                            parName, myThid )

C     !DESCRIPTION:
C     *==========================================================*
C     | FUNCTION DIAGS_GET_PARMS_I
C     | o Return the value of integer parameter
C     |   from one of the DIAGNOSTICS.h common blocs
C     *==========================================================*

C     !USES:
      IMPLICIT NONE
#include "EEPARAMS.h"
#include "SIZE.h"
#include "DIAGNOSTICS_SIZE.h"
#include "DIAGNOSTICS.h"

C     !INPUT PARAMETERS:
C     parName   :: string used to identify which parameter to get
C     myThid    :: my Thread Id number
      CHARACTER*(*) parName
      INTEGER myThid
CEOP

C     !LOCAL VARIABLES:
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      INTEGER n

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      n = LEN(parName)
c     write(0,'(3A,I4)')
c    &  'DIAGS_GET_PARMS_I: parName="',parName,'" , length=',n

      IF ( parName.EQ.'LAST_DIAG_ID' ) THEN
         DIAGS_GET_PARMS_I = ndiagt
      ELSE
         WRITE(msgBuf,'(4A)') 'DIAGS_GET_PARMS_I: ',
     &    ' parName="', parName, '" not known.'
         CALL PRINT_ERROR( msgBuf, myThid )
         STOP 'ABNORMAL END: S/R DIAGS_GET_PARMS_I'
      ENDIF

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: DIAGS_MK_UNITS

C     !INTERFACE:
      CHARACTER*16 FUNCTION DIAGS_MK_UNITS(
     I                            diagUnitsInPieces, myThid )

C     !DESCRIPTION:
C     *==========================================================*
C     | FUNCTION DIAGS_MK_UNITS
C     | o Return the diagnostic units string (16c) removing
C     |   blanks from the input string
C     *==========================================================*

C     !USES:
      IMPLICIT NONE
#include "EEPARAMS.h"

C     !INPUT PARAMETERS:
C     diagUnitsInPieces :: string for diagnostic units: in several
C                          pieces, with blanks in between
C     myThid            ::  my thread Id number
      CHARACTER*(*) diagUnitsInPieces
      INTEGER      myThid
CEOP

C     !LOCAL VARIABLES:
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      INTEGER i,j,n,nbc

      DIAGS_MK_UNITS = '                '
      n = LEN(diagUnitsInPieces)

      j = 0
      DO i=1,n
       IF (diagUnitsInPieces(i:i) .NE. ' ' ) THEN
         j = j+1
         IF ( j.LE.16 ) DIAGS_MK_UNITS(j:j) = diagUnitsInPieces(i:i)
       ENDIF
      ENDDO
      nbc = j

      IF ( nbc.GT.16 ) THEN
C-    try to reduce length by changing m^2 & m^3 to m2 & m3:
       DIAGS_MK_UNITS = '                '
       j = 0
       DO i=1,n
        IF ( diagUnitsInPieces(i:i) .NE. ' ' ) THEN
         IF ( j.GE.1 .AND. nbc.GT.16 .AND.
     &         diagUnitsInPieces(i:i).EQ.'^' ) THEN
          IF ( diagUnitsInPieces(i-1:i-1).EQ.'m' ) THEN
            nbc = nbc - 1
          ELSE
           j = j+1
           IF ( j.LE.16 ) DIAGS_MK_UNITS(j:j) = diagUnitsInPieces(i:i)
          ENDIF
         ELSE
          j = j+1
          IF ( j.LE.16 ) DIAGS_MK_UNITS(j:j) = diagUnitsInPieces(i:i)
         ENDIF
        ENDIF
       ENDDO
      ENDIF

      IF ( j.GT.16 ) THEN
         WRITE(msgBuf,'(2A,I4,A)') '** WARNING ** ',
     &   'DIAGS_MK_UNITS: too long (',j,' >16) input string'
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &       SQUEEZE_RIGHT , myThid)
         WRITE(msgBuf,'(3A)') '** WARNING ** ',
     &   'DIAGS_MK_UNITS: input=', diagUnitsInPieces
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &       SQUEEZE_RIGHT , myThid)
      ENDIF

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: DIAGS_MK_TITLE

C     !INTERFACE:
      CHARACTER*80 FUNCTION DIAGS_MK_TITLE(
     I                            diagTitleInPieces, myThid )

C     !DESCRIPTION:
C     *==========================================================*
C     | FUNCTION DIAGS_MK_TITLE
C     | o Return the diagnostic title string (80c) removing
C     |   consecutive blanks from the input string
C     *==========================================================*

C     !USES:
      IMPLICIT NONE
#include "EEPARAMS.h"

C     !INPUT PARAMETERS:
C     diagTitleInPieces :: string for diagnostic units: in several
C                          pieces, with blanks in between
C     myThid            ::  my Thread Id number
      CHARACTER*(*) diagTitleInPieces
      INTEGER      myThid
CEOP

C     !LOCAL VARIABLES:
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      LOGICAL flag
      INTEGER i,j,n

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      DIAGS_MK_TITLE = '                                        '
     &               //'                                        '
      n = LEN(diagTitleInPieces)

      j = 0
      flag = .FALSE.
      DO i=1,n
       IF (diagTitleInPieces(i:i) .NE. ' ' ) THEN
         IF ( flag ) THEN
           j = j+1
           IF (j.LE.80) DIAGS_MK_TITLE(j:j) = ' '
         ENDIF
         j = j+1
         IF ( j.LE.80 ) DIAGS_MK_TITLE(j:j) = diagTitleInPieces(i:i)
         flag = .FALSE.
       ELSE
         flag = j.GE.1
       ENDIF
      ENDDO

      IF ( j.GT.80 ) THEN
         WRITE(msgBuf,'(2A,I4,A)') '** WARNING ** ',
     &   'DIAGS_MK_TITLE: too long (',j,' >80) input string'
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &       SQUEEZE_RIGHT , myThid)
         WRITE(msgBuf,'(3A)') '** WARNING ** ',
     &   'DIAGS_MK_TITLE: input=', diagTitleInPieces
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &       SQUEEZE_RIGHT , myThid)
      ENDIF

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: DIAGS_RENAMED

C     !INTERFACE:
      CHARACTER*8 FUNCTION DIAGS_RENAMED(
     I                           diagName, myThid )

C     !DESCRIPTION:
C     *==========================================================*
C     | FUNCTION DIAGS_RENAMED
C     | o In case of an old diagnostics name,
C     |   provides the corresponding new name
C     *==========================================================*

C     !USES:
      IMPLICIT NONE
#include "EEPARAMS.h"
#include "SIZE.h"
#include "PARAMS.h"
#include "DIAGNOSTICS_SIZE.h"
#include "DIAGNOSTICS.h"

C     !INPUT PARAMETERS:
C     diagName  :: name of diagnostic to rename (or not)
C     myThid    :: my Thread Id number
      CHARACTER*8 diagName
      INTEGER myThid
CEOP

C     !LOCAL VARIABLES:
      CHARACTER*8 newName
      CHARACTER*(MAX_LEN_MBUF) msgBuf

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      newName = blkName

      IF ( useSEAICE ) THEN
       IF ( diagName .EQ. 'SIfu    ' ) newName = 'oceTAUX '
       IF ( diagName .EQ. 'SIfv    ' ) newName = 'oceTAUY '
       IF ( diagName .EQ. 'SIuwind ' ) newName = 'EXFuwind'
       IF ( diagName .EQ. 'SIvwind ' ) newName = 'EXFvwind'
       IF ( diagName .EQ. 'SIsigI  ' ) newName = 'SIsig1  '
       IF ( diagName .EQ. 'SIsigII ' ) newName = 'SIsig2  '
      ENDIF
       IF ( diagName .EQ. 'Um_dPHdx' ) newName = 'Um_dPhiX'
       IF ( diagName .EQ. 'Vm_dPHdy' ) newName = 'Vm_dPhiY'

      IF ( newName.EQ.blkName ) THEN
        DIAGS_RENAMED = diagName
      ELSE
        DIAGS_RENAMED = newName
        WRITE(msgBuf,'(6A)') '** WARNING ** (DIAGS_RENAMED):',
     &    ' diagnostics "', diagName, '" replaced by "', newName, '"'
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                      SQUEEZE_RIGHT , myThid )
        CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                      SQUEEZE_RIGHT , myThid )
      ENDIF

      RETURN
      END

#include "CPP_EEOPTIONS.h"

CBOP
C     !ROUTINE: EEINTRO_MSG

C     !INTERFACE:
      SUBROUTINE EEINTRO_MSG
      IMPLICIT NONE

C     !DESCRIPTION:
C     Write basic WRAPPER introductory message.  This routine could be
C     customised for different platforms.  Output includes which
C     checkpoint of the code is running.  The routine doesnt currently
C     report the user id or machine name correctly.

C     !USES:
#include "BUILD_INFO.h"
#include "SIZE.h"
#include "EEPARAMS.h"
#include "EESUPPORT.h"

C     !LOCAL VARIABLES:
      CHARACTER*(MAX_LEN_MBUF) msgBuf
CEOP

      WRITE(msgBuf,'(A)') '                '
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &     SQUEEZE_RIGHT , 1)
      WRITE(msgBuf,'(A)')
     &     '// ======================================================'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &     SQUEEZE_RIGHT , 1)
      WRITE(msgBuf,'(A)') '//                      MITgcm UV'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &     SQUEEZE_RIGHT , 1)
      WRITE(msgBuf,'(A)') '//                      ========='
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &     SQUEEZE_RIGHT , 1)
      WRITE(msgBuf,'(A)')
     &     '// ======================================================'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &     SQUEEZE_RIGHT , 1)
      WRITE(msgBuf,'(A)') '// execution environment starting up...'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &     SQUEEZE_RIGHT , 1)
      WRITE(msgBuf,'(A)') '   '
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &     SQUEEZE_RIGHT , 1)

#ifdef THISVER
      WRITE(msgBuf,'(2A)') '// MITgcmUV version:  ',
     &     THISVER
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &     SQUEEZE_RIGHT , 1)
#endif
#ifdef THISUSER
      WRITE(msgBuf,'(2A)') '// Build user:        ',
     &     THISUSER
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &     SQUEEZE_RIGHT , 1)
#endif
#ifdef THISHOST
      WRITE(msgBuf,'(2A)') '// Build host:        ',
     &     THISHOST
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &     SQUEEZE_RIGHT , 1)
#endif
#ifdef THISDATE
      WRITE(msgBuf,'(2A)') '// Build date:        ',
     &     THISDATE
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &     SQUEEZE_RIGHT , 1)
#endif

      WRITE(msgBuf,'(A)') '   '
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &     SQUEEZE_RIGHT , 1)
C
      RETURN
      END

#include "PROFILES_OPTIONS.h"
#ifdef ALLOW_CTRL
# include "CTRL_OPTIONS.h"
#endif

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C !ROUTINE: PROFILES_COST

C !INTERFACE:
      SUBROUTINE PROFILES_COST( myTime, myIter, myThid )

C     !DESCRIPTION:
C     Computes the cost for netcdf profiles data
C     Started: Gael Forget 15-March-2006
C-- Note: GLOBAL_SUM/MAX called from single thread block will prevent
C         this routine to work in multi-threaded env.

C     !USES:
      IMPLICIT NONE
C     == Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "DYNVARS.h"
#ifdef ALLOW_CAL
# include "cal.h"
#endif
#ifdef ALLOW_PROFILES
# include "PROFILES_SIZE.h"
# include "profiles.h"
# include "netcdf.inc"
#endif
#ifdef ALLOW_CTRL
# include "OPTIMCYCLE.h"
#endif

C     !INPUT PARAMETERS:
C     myTime :: time counter for this thread
C     myIter :: iteration counter for this thread
C     myThid :: my thread ID number
      _RL     myTime
      INTEGER myIter
      INTEGER myThid
C     !OUTPUT PARAMETERS:

#ifdef ALLOW_PROFILES
C     !FUNCTIONS:
      INTEGER  ILNBLNK
      EXTERNAL ILNBLNK

C     !LOCAL VARIABLES:
      INTEGER kLev, kProf
      INTEGER num_file, num_var, prof_num
      INTEGER bi, bj
      INTEGER err
      _RL prof_traj1D(NLEVELMAX), prof_traj1D_mean(NLEVELMAX)
      _RL prof_data1D(NLEVELMAX), prof_weights1D(NLEVELMAX)
      CHARACTER*(MAX_LEN_MBUF) msgBuf
#ifndef ALLOW_CTRL
      INTEGER optimcycle
#endif
#ifdef ALLOW_PROFILES_SAMPLESPLIT_COST
      INTEGER kC, kCMax
      INTEGER iL
#endif
CEOP

      _RL  objf_prof_tile (nSx,nSy)
      _RL  objf_prof_glo
      _RL  num_prof_tile (nSx,nSy)
      _RL  num_prof_glo

#ifdef ALLOW_PROFILES_SAMPLESPLIT_COST
      INTEGER iavgbin,ikzz
      INTEGER itmp
      INTEGER k2, ix9, iy9, ktmp
      INTEGER cunit
      CHARACTER*(MAX_LEN_FNAM) cfile

      _RL prof_data1D_mean(NLEVELMAX)
      _RL prof_count1D(NLEVELMAX)
      _RL prof_weights1D_mean(NLEVELMAX)
      _RL recip_profiles_mean_indsamples(NVARMAX)

      _RL tmpr6, tmpr7, tmpr8, tmpr9
      REAL*4 tmp99(NAVGBINMAX)
      _RL tmp11, tmp12, tmp_recip_count
      LOGICAL doglbsum

      _RL  objf_prof_mean_tile (nSx,nSy)
      _RL  objf_prof_mean_glo
      _RL  num_prof_mean_tile (nSx,nSy)
      _RL  num_prof_mean_glo
#endif /* ALLOW_PROFILES_SAMPLESPLIT_COST */

#ifndef ALLOW_CTRL
      optimcycle = 0
#endif

      WRITE(msgBuf,'(A)') ' '
      CALL PRINT_MESSAGE( msgBuf,
     &     standardMessageUnit, SQUEEZE_RIGHT , myThid )
      WRITE(msgBuf,'(A)') '== profiles_cost: begin =='
      CALL PRINT_MESSAGE( msgBuf,
     &     standardMessageUnit, SQUEEZE_RIGHT , myThid )

      _BEGIN_MASTER( myThid )

#ifdef ALLOW_PROFILES_SAMPLESPLIT_COST
      NAVGBIN = 0
C Initialize
      DO iavgbin = 1, NAVGBINMAX
        avgbinglbsum(iavgbin) = 0
        DO kCMax = 1, NLEVELCOMBMAX
          DO num_var = 1, NVARMAX
            prof_traj1D_all_mean(iavgbin,kCMax,num_var) = 0. _d 0
            prof_data1D_all_mean(iavgbin,kCMax,num_var) = 0. _d 0
            prof_weights1D_all_mean(iavgbin,kCMax,num_var) = 0. _d 0
            prof_count1D_all_mean(iavgbin,kCMax,num_var) = 0. _d 0
          ENDDO
        ENDDO
      ENDDO

      DO num_var = 1, NVARMAX
        recip_profiles_mean_indsamples(num_var) = 0. _d 0
        IF (profiles_mean_indsamples(num_var).GT.0. _d 0) THEN
          recip_profiles_mean_indsamples(num_var) = 1. _d 0 /
     &     profiles_mean_indsamples(num_var)
        ENDIF
      ENDDO

      DO bj = 1, nSy
        DO bi = 1, nSx
          DO num_file = 1, NFILESPROFMAX
            IF ( (ProfNo(num_file,bi,bj).GT.0) .AND.
     &           (profilesDoNcOutput) ) THEN
C Write data from buffer to .nc file
              err = NF_SYNC( fidforward(num_file,bi,bj) )
              CALL PROFILES_NF_ERROR( 'COST: NF_SYNC fidforward',
     &             err,bi,bj,myThid )

            ENDIF

C Find vertical indices
            DO kLev = 1, NLEVELMAX
              prof_lev_comb(kLev,num_file,bi,bj) = -999

              IF (kLev.LE.ProfDepthNo(num_file,bi,bj)) THEN
                DO kC = 1, NLEVELCOMB
                  IF (prof_depth(num_file,kLev,bi,bj).EQ.
     &                prof_depth_comb(kC,bi,bj) .AND.
     &                prof_depth_comb(kC,bi,bj).GE.0. _d 0 .AND.
     &                prof_lev_comb(kLev,num_file,bi,bj).EQ.-999) THEN
                    prof_lev_comb(kLev,num_file,bi,bj) = kC
                  ENDIF
                ENDDO
              ENDIF

            ENDDO

            DO num_var = 1, NVARMAX
              IF ( vec_quantities(num_file,num_var,bi,bj) ) THEN
                DO prof_num = 1, NOBSGLOB
                  IF (prof_num.LE.ProfNo(num_file,bi,bj)) THEN
                    DO kLev = 1, NLEVELMAX
                      prof_traj1D(kLev) = 0.
                      prof_data1D(kLev) = 0.
                      prof_weights1D(kLev) = 0.
                    ENDDO

                    ix9 = prof_interp_i(num_file,prof_num,1,bi,bj)
                    iy9 = prof_interp_j(num_file,prof_num,1,bi,bj)

                    IF (prof_ind_avgbin(num_file,prof_num,bi,bj).GT.
     &                  NAVGBIN)
     &                NAVGBIN =
     &                 prof_ind_avgbin(num_file,prof_num,bi,bj)

                    IF (ix9 .GE. 0. _d 0 .AND. iy9 .GE. 0. _d 0) THEN
                      itmp = prof_ind_avgbin(num_file,prof_num,bi,bj)
                      IF (avgbinglbsum(itmp).EQ.0)
     &                  avgbinglbsum(itmp) = 1

                      CALL ACTIVE_READ_PROFILE( num_file,
     &                     ProfDepthNo(num_file,bi,bj),prof_traj1D,
     &                     num_var,prof_num,.false.,optimcycle,
     &                     bi,bj,myThid,
     &                     profiles_dummy(num_file,num_var,bi,bj) )

                      CALL PROFILES_READVECTOR( num_file, num_var,
     &                     prof_ind_glob(num_file,prof_num,bi,bj),
     &                     ProfDepthNo(num_file,bi,bj),prof_data1D,
     &                     bi,bj,myThid )

                      CALL PROFILES_READVECTOR( num_file,-num_var,
     &                     prof_ind_glob(num_file,prof_num,bi,bj),
     &                     ProfDepthNo(num_file,bi,bj),prof_weights1D,
     &                     bi,bj,myThid )

                      DO kProf = 1, ProfDepthNo(num_file,bi,bj)
                        IF ( prof_weights1D(kProf).GT.0. _d 0 .AND.
     &                       prof_mask1D_cur(kProf,bi,bj).NE.0. _d 0 )
     &                  THEN
                          prof_traj1D_all_mean(itmp,
     &                     prof_lev_comb(kProf,num_file,bi,bj),
     &                     num_var)
     &                     = prof_traj1D_all_mean(itmp,
     &                        prof_lev_comb(kProf,num_file,bi,bj),
     &                        num_var)
     &                       + prof_traj1D(kProf)

                          prof_data1D_all_mean(itmp,
     &                     prof_lev_comb(kProf,num_file,bi,bj),
     &                     num_var)
     &                     = prof_data1D_all_mean(itmp,
     &                        prof_lev_comb(kProf,num_file,bi,bj),
     &                        num_var)
     &                       + prof_data1D(kProf)

                          prof_weights1D_all_mean(itmp,
     &                     prof_lev_comb(kProf,num_file,bi,bj),
     &                     num_var)
     &                     = prof_weights1D_all_mean(itmp,
     &                        prof_lev_comb(kProf,num_file,bi,bj),
     &                        num_var)
     &                       + 1. _d 0 / prof_weights1D(kProf)

                          prof_count1D_all_mean(itmp,
     &                     prof_lev_comb(kProf,num_file,bi,bj),
     &                     num_var)
     &                     = prof_count1D_all_mean(itmp,
     &                        prof_lev_comb(kProf,num_file,bi,bj),
     &                        num_var)
     &                       + 1. _d 0

                        ENDIF
                      ENDDO !DO kProf = 1, ProfDepthNo

                    ENDIF !IF (ix9.GE.0. _d 0 .AND. iy9.GE.0. _d 0)

                  ENDIF !IF (prof_num.LE.ProfNo(num_file,bi,bj))
                ENDDO !DO prof_num...
              ENDIF !IF vec_quantities(num_file,num_var,bi,bj)
            ENDDO !DO num_var

          ENDDO !DO num_file = 1, NFILESPROFMAX
        ENDDO !DO bi
      ENDDO !DO bj

      NAVGBINRL = NAVGBIN
      _GLOBAL_MAX_RL( NAVGBINRL, myThid )
      NAVGBIN = NAVGBINRL
      DO iavgbin = 1, NAVGBIN
        tmpr6 = avgbinglbsum(iavgbin)
        _GLOBAL_SUM_RL(tmpr6, myThid)
        IF (tmpr6.GT.1.1) avgbinglbsum(iavgbin) = tmpr6
      ENDDO

C Accumulate globally
      DO num_var = 1, NVARMAX
        doglbsum = .FALSE.
        DO bj = 1, nSy
          DO bi = 1, nSx
            DO num_file = 1, NFILESPROFMAX
              IF ( vec_quantities(num_file,num_var,bi,bj) )
     &          doglbsum = .TRUE.
            ENDDO !DO num_file
          ENDDO !DO bi
        ENDDO !DO bj

        IF (doglbsum) THEN
          DO iavgbin = 1, NAVGBIN
             DO kC = 1, NLEVELCOMB
               tmpr6 = prof_count1D_all_mean(iavgbin,kC,num_var)
               _GLOBAL_SUM_RL( tmpr6, myThid )
               prof_count1D_all_mean(iavgbin,kC,num_var) = tmpr6

               tmpr9 = prof_weights1D_all_mean(iavgbin,kC,num_var)
               _GLOBAL_SUM_RL( tmpr9, myThid )
               prof_weights1D_all_mean(iavgbin,kC,num_var) = tmpr9

               tmpr7 = prof_traj1D_all_mean(iavgbin,kC,num_var)
               _GLOBAL_SUM_RL( tmpr7, myThid )
               prof_traj1D_all_mean(iavgbin,kC,num_var) = tmpr7

               tmpr8 = prof_data1D_all_mean(iavgbin,kC,num_var)
               _GLOBAL_SUM_RL( tmpr8, myThid )
               prof_data1D_all_mean(iavgbin,kC,num_var) = tmpr8
             ENDDO !DO kC
          ENDDO !DO iavgbin
        ENDIF
      ENDDO !DO num_var

C Now do the averaging
      DO iavgbin = 1, NAVGBIN
        DO kC = 1, NLEVELCOMB
          DO num_var = 1, NVARMAX
            tmp_recip_count = 0. _d 0
            IF (prof_count1D_all_mean(iavgbin,kC,num_var).GT.0) THEN
              tmp_recip_count = 1. _d 0 /
     &           prof_count1D_all_mean(iavgbin,kC,num_var)

              prof_traj1D_all_mean(iavgbin,kC,num_var)
     &         = prof_traj1D_all_mean(iavgbin,kC,num_var)*
     &           tmp_recip_count

              prof_data1D_all_mean(iavgbin,kC,num_var)
     &         = prof_data1D_all_mean(iavgbin,kC,num_var)*
     &           tmp_recip_count

              prof_weights1D_all_mean(iavgbin,kC,num_var)
     &         = prof_weights1D_all_mean(iavgbin,kC,num_var)*
     &           tmp_recip_count

            ENDIF
          ENDDO !DO num_var
        ENDDO !DO kC
      ENDDO !DO iavgbin

      DO iavgbin = 1, NAVGBIN
        DO kC = 1, NLEVELCOMB
          DO num_var = 1, NVARMAX
            IF (prof_count1D_all_mean(iavgbin,kC,num_var).GT.0) THEN
C Assuming each averaging bin has a max of 9 independent measurements
              tmp11 = prof_weights1D_all_mean(iavgbin,kC,num_var)
     &         / prof_count1D_all_mean(iavgbin,kC,num_var)

              tmp12 = prof_weights1D_all_mean(iavgbin,kC,num_var)
     &         * recip_profiles_mean_indsamples(num_var)

              prof_weights1D_all_mean(iavgbin,kC,num_var) =
     &         MAX(tmp11, tmp12)

C prof_weights1D_all_mean is still sigam^2. Convert to weight
              IF (prof_weights1D_all_mean(iavgbin,kC,num_var)
     &            .NE.0. _d 0)
     &          prof_weights1D_all_mean(iavgbin,kC,num_var) =
     &           1. _d 0 / prof_weights1D_all_mean(iavgbin,kC,num_var)
            ENDIF
          ENDDO !DO num_var
        ENDDO !DO kC
      ENDDO !DO iavgbin

      IF (myProcId.EQ.0) THEN
        DO num_var = 1, NVARMAX
          iL = ILNBLNK( prof_names(1,num_var) )

          WRITE(cfile,'(2A)') prof_names(1,num_var)(1:iL),
     &     '_data_mean.data'
          CALL MDSFINDUNIT( cunit, myThid )
          OPEN( cunit, FILE = cfile, STATUS = 'unknown',
     &          ACCESS = 'direct', RECL = NAVGBINMAX*4 )

          DO kC = 1, NLEVELCOMB
            tmp99(1:NAVGBINMAX) =
     &        prof_data1D_all_mean(1:NAVGBINMAX,kC,num_var)
            WRITE(cunit,REC = kC) tmp99
          ENDDO
          CLOSE( cunit )

          WRITE(cfile,'(2A)') prof_names(1,num_var)(1:iL),
     &     '_model_mean.data'
          CALL MDSFINDUNIT( cunit, myThid )
          OPEN( cunit, FILE = cfile, STATUS = 'unknown',
     &          ACCESS = 'direct', RECL = NAVGBINMAX*4 )

          DO kC = 1, NLEVELCOMB
            tmp99(1:NAVGBINMAX) =
     &        prof_traj1D_all_mean(1:NAVGBINMAX,kC,num_var)
            WRITE(cunit,REC = kC) tmp99
          ENDDO
          CLOSE( cunit )

          WRITE(cfile,'(2A)') prof_names(1,num_var)(1:iL),
     &     '_weight_mean.data'
          CALL MDSFINDUNIT( cunit, myThid )
          OPEN( cunit, FILE = cfile, STATUS = 'unknown',
     &          ACCESS = 'direct', RECL = NAVGBINMAX*4 )

          DO kC = 1, NLEVELCOMB
            tmp99(1:NAVGBINMAX)=
     &        prof_weights1D_all_mean(1:NAVGBINMAX,kC,num_var)
            WRITE(cunit,REC = kC) tmp99
          ENDDO
          CLOSE( cunit )

          WRITE(cfile,'(2A)') prof_names(1,num_var)(1:iL),
     &     '_count_mean.data'
          CALL MDSFINDUNIT( cunit, myThid )
          OPEN( cunit, FILE = cfile, STATUS = 'unknown',
     &          ACCESS = 'direct', RECL = NAVGBINMAX*4 )

          DO kC = 1, NLEVELCOMB
            tmp99(1:NAVGBINMAX) =
     &       prof_count1D_all_mean(1:NAVGBINMAX,kC,num_var)
            WRITE(cunit,REC = kC) tmp99
          ENDDO
          CLOSE( cunit )

        ENDDO !DO num_var
      ENDIF !IF (myProcId.EQ.0)
#endif /* ALLOW_PROFILES_SAMPLESPLIT_COST */

      DO bj = 1, nSy
        DO bi = 1, nSx
          DO num_file = 1, NFILESPROFMAX
            IF ( (ProfNo(num_file,bi,bj).GT.0) .AND.
     &           (profilesDoNcOutput) ) THEN
C Sync file so that data is not lost when run finishes
              err = NF_SYNC( fidforward(num_file,bi,bj) )
              CALL PROFILES_NF_ERROR( 'COST: NF_SYNC fidforward',
     &             err,bi,bj,myThid )

            ENDIF

            DO prof_num = 1, NOBSGLOB
              IF (prof_num.LE.ProfNo(num_file,bi,bj)) THEN
                DO num_var = 1, NVARMAX
                  DO kLev = 1, NLEVELMAX
                    prof_traj1D(kLev) = 0.
                    prof_traj1D_mean(kLev) = 0.
                    prof_mask1D_cur(kLev,bi,bj) = 0.
                    prof_data1D(kLev) = 0.
                    prof_weights1D(kLev) = 0.
#ifdef ALLOW_PROFILES_SAMPLESPLIT_COST
                    prof_data1D_mean(kLev) = 0.
                    prof_weights1D_mean(kLev) = 0.
#endif
                  ENDDO

                  IF ( vec_quantities(num_file,num_var,bi,bj) ) THEN
#ifdef ALLOW_PROFILES_SAMPLESPLIT_COST
                    itmp = prof_ind_avgbin(num_file,prof_num,bi,bj)

                    IF (itmp.GE. 0) THEN
                      DO kProf = 1, ProfDepthNo(num_file,bi,bj)
                        ktmp = prof_lev_comb(kProf,num_file,bi,bj)

                        prof_traj1D_mean(kProf) =
     &                    prof_traj1D_all_mean(itmp,ktmp,num_var)

                        prof_data1D_mean(kProf) =
     &                    prof_data1D_all_mean(itmp,ktmp,num_var)

                        prof_weights1D_mean(kProf) =
     &                    prof_weights1D_all_mean(itmp,ktmp,num_var)

                      ENDDO
                    ENDIF !IF (itmp.GE.0)
#endif /* ALLOW_PROFILES_SAMPLESPLIT_COST */

                    CALL ACTIVE_READ_PROFILE( num_file,
     &                   ProfDepthNo(num_file,bi,bj),prof_traj1D,
     &                   num_var,prof_num,.false.,optimcycle,
     &                   bi,bj,myThid,
     &                   profiles_dummy(num_file,num_var,bi,bj) )

                    CALL PROFILES_READVECTOR( num_file, num_var,
     &                   prof_ind_glob(num_file,prof_num,bi,bj),
     &                   ProfDepthNo(num_file,bi,bj),prof_data1D,
     &                   bi,bj,myThid )

                    CALL PROFILES_READVECTOR( num_file,-num_var,
     &                   prof_ind_glob(num_file,prof_num,bi,bj),
     &                   ProfDepthNo(num_file,bi,bj),prof_weights1D,
     &                   bi,bj,myThid )

                    DO kProf = 1, ProfDepthNo(num_file,bi,bj)
                      IF (prof_weights1D(kProf).GT.0.
#ifdef ALLOW_PROFILES_SAMPLESPLIT_COST
     &                    .AND. prof_data1D_mean(kProf).NE. 0. _d 0
#endif
     &                   ) THEN
                        objf_profiles(num_file,num_var,bi,bj) =
     &                    objf_profiles(num_file,num_var,bi,bj)
     &                    +prof_weights1D(kProf)
     &                    *prof_mask1D_cur(kProf,bi,bj)
     &                    *(prof_traj1D(kProf)-prof_data1D(kProf)
     &                    -prof_traj1D_mean(kProf)
#ifdef ALLOW_PROFILES_SAMPLESPLIT_COST
     &                    +prof_data1D_mean(kProf)
#endif
     &                    )
     &                    *(prof_traj1D(kProf)-prof_data1D(kProf)
     &                    -prof_traj1D_mean(kProf)
#ifdef ALLOW_PROFILES_SAMPLESPLIT_COST
     &                    + prof_data1D_mean(kProf)
#endif
     &                    )

                        num_profiles(num_file,num_var,bi,bj) =
     &                    num_profiles(num_file,num_var,bi,bj)
     &                    +prof_mask1D_cur(kProf,bi,bj)

                      ENDIF
                    ENDDO !DO kProf

                  ENDIF !IF (vec_quantitities

                ENDDO !DO num_var
              ENDIF !IF (prof_num.LE.ProfNo(num_file,bi,bj))
            ENDDO !DO prof_num

#ifdef ALLOW_DEBUG
            IF ( debugLevel .GE. debLevD ) THEN
              IF (ProfNo(num_file,bi,bj).GT.0) THEN
                DO num_var = 1, NVARMAX
                  WRITE(msgBuf,'(A,4I9)') 'bi,bj,prof_num,num_var ',
     &             bi,bj,ProfNo(num_file,bi,bj),num_var
                  CALL PRINT_MESSAGE( msgBuf,
     &                 standardMessageUnit, SQUEEZE_RIGHT , myThid )
                  WRITE(msgBuf,'(A,2D22.15)')
     &             prof_names(num_file,num_var),
     &             objf_profiles(num_file,num_var,bi,bj),
     &             num_profiles(num_file,num_var,bi,bj)
                  CALL PRINT_MESSAGE( msgBuf,
     &                 standardMessageUnit, SQUEEZE_RIGHT , myThid )
                ENDDO !DO num_var
              ENDIF
            ENDIF
#endif /* ALLOW_DEBUG */
          ENDDO !DO num_file

#ifdef ALLOW_PROFILES_SAMPLESPLIT_COST
          DO num_var = 1, NVARMAX
            DO iavgbin = 1, NAVGBINMAX
              DO kC = 1, NLEVELCOMB
                prof_traj1D_mean(1) =
     &           prof_traj1D_all_mean(iavgbin,kC,num_var)
                prof_data1D_mean(1) =
     &           prof_data1D_all_mean(iavgbin,kC,num_var)
                prof_weights1D_mean(1) =
     &           prof_weights1D_all_mean(iavgbin,kC,num_var)

                IF (prof_weights1D_mean(1).GT.0. .AND.
     &              prof_data1D_mean(1).NE. 0. _d 0 .AND.
     &              prof_traj1D_mean(1).NE. 0. _d 0 .AND.
     &              avgbinglbsum(iavgbin).GT.0 ) THEN
                  IF (avgbinglbsum(iavgbin).EQ.1) THEN
                    objf_profiles_mean(num_var,bi,bj) =
     &                objf_profiles_mean(num_var,bi,bj)
     &                + prof_weights1D_mean(1)
     &                * (prof_traj1D_mean(1) - prof_data1D_mean(1))
     &                * (prof_traj1D_mean(1) - prof_data1D_mean(1))

                    num_profiles_mean(num_var,bi,bj) =
     &                num_profiles_mean(num_var,bi,bj) + 1. _d 0

                  ELSE
                    objf_profiles_mean(num_var,bi,bj) =
     &                objf_profiles_mean(num_var,bi,bj)
     &                + prof_weights1D_mean(1)
     &                * (prof_traj1D_mean(1) - prof_data1D_mean(1))
     &                * (prof_traj1D_mean(1) - prof_data1D_mean(1))
     &                / numberOfProcs

                    num_profiles_mean(num_var,bi,bj) =
     &               num_profiles_mean(num_var,bi,bj) + 1. _d 0
     &               /numberOfProcs

                  ENDIF !IF (avgbinglbsum(iavgbin).EQ.1)
                 ENDIF !IF (prof_weights1D_mean(1).GT.0.)

              ENDDO !DO kC
            ENDDO !DO iavgbin
          ENDDO !DO num_var

# ifdef ALLOW_DEBUG
          IF ( debugLevel .GE. debLevD ) THEN
            DO num_var = 1, NVARMAX
              WRITE(msgBuf,'(A,4I9)') 'bi,bj,num_var ',bi,bj,num_var
              CALL PRINT_MESSAGE( msgBuf,
     &             standardMessageUnit, SQUEEZE_RIGHT , myThid )

              WRITE(msgBuf,'(A,A5,2D22.15)') prof_names(1,num_var),
     &         '_mean',
     &         objf_profiles_mean(num_var,bi,bj),
     &         num_profiles_mean(num_var,bi,bj)
              CALL PRINT_MESSAGE( msgBuf,
     &             standardMessageUnit, SQUEEZE_RIGHT , myThid )

            ENDDO !DO num_var
          ENDIF
# endif /* ALLOW_DEBUG */

#endif /* ALLOW_PROFILES_SAMPLESPLIT_COST */

        ENDDO !DO bi
      ENDDO !DO bj

      _END_MASTER( myThid )

C Print cost function values
      DO num_file = 1, NFILESPROFMAX
        DO num_var = 1, NVARMAX

          DO bj = myByLo(myThid), myByHi(myThid)
            DO bi = myBxLo(myThid), myBxHi(myThid)
              objf_prof_tile(bi,bj) =
     &          objf_profiles(num_file,num_var,bi,bj)

              num_prof_tile(bi,bj) =
     &          num_profiles(num_file,num_var,bi,bj)

           ENDDO
          ENDDO

        CALL GLOBAL_SUM_TILE_RL( objf_prof_tile, objf_prof_glo,
     &       myThid )
        CALL GLOBAL_SUM_TILE_RL( num_prof_tile, num_prof_glo,
     &       myThid )

        WRITE(msgBuf,'(2(A,I2),A,2D22.15)')
     &   ' profiles_cost(',num_file,',',num_var,') = ',
     &   objf_prof_glo,num_prof_glo

        IF (num_prof_glo .GT. 0.)
     &    CALL PRINT_MESSAGE( msgBuf,
     &         standardMessageUnit, SQUEEZE_RIGHT , myThid )

        ENDDO !DO num_var
      ENDDO !DO num_file

#ifdef ALLOW_PROFILES_SAMPLESPLIT_COST
      DO num_var = 1, NVARMAX

        DO bj = myByLo(myThid), myByHi(myThid)
          DO bi = myBxLo(myThid), myBxHi(myThid)
            objf_prof_mean_tile(bi,bj) =
     &        objf_profiles_mean(num_var,bi,bj)

            num_prof_mean_tile(bi,bj) =
     &        num_profiles_mean(num_var,bi,bj)

         ENDDO
        ENDDO

        CALL GLOBAL_SUM_TILE_RL( objf_prof_mean_tile,
     &       objf_prof_mean_glo, myThid )
        CALL GLOBAL_SUM_TILE_RL( num_prof_mean_tile,
     &       num_prof_mean_glo, myThid )

        WRITE(msgBuf,'(A,I2,A,2D22.15)')
     &   ' profiles_cost_mean(',num_var,') = ',
     &   objf_prof_mean_glo,num_prof_mean_glo

        IF (num_prof_mean_glo .GT. 0.)
     &    CALL PRINT_MESSAGE( msgBuf,
     &         standardMessageUnit, SQUEEZE_RIGHT, myThid )

      ENDDO !DO num_var
#endif /* ALLOW_PROFILES_SAMPLESPLIT_COST */

      WRITE(msgBuf,'(A)') '== profiles_cost: end   =='
      CALL PRINT_MESSAGE( msgBuf,
     &     standardMessageUnit, SQUEEZE_RIGHT , myThid )
      WRITE(msgBuf,'(A)') ' '
      CALL PRINT_MESSAGE( msgBuf,
     &     standardMessageUnit, SQUEEZE_RIGHT , myThid )

      IF (prof_make_nc) THEN
        CALL PROFILES_MAKE_NCFILE( myThid )
      ENDIF

#endif /* ALLOW_PROFILES */

      RETURN
      END

#include "AUTODIFF_OPTIONS.h"
#ifdef ALLOW_OPENAD
# include "OPENAD_OPTIONS.h"
#endif
#ifdef ALLOW_CTRL
# include "CTRL_OPTIONS.h"
#endif
#ifdef ALLOW_GMREDI
# include "GMREDI_OPTIONS.h"
#endif
#ifdef ALLOW_GGL90
# include "GGL90_OPTIONS.h"
#endif
#ifdef ALLOW_SHELFICE
# include "SHELFICE_OPTIONS.h"
#endif
#ifdef ALLOW_STEEP_ICECAVITY
# include "STIC_OPTIONS.h"
#endif
#include "AD_CONFIG.h"

CBOP
C     !ROUTINE: ADDUMMY_IN_STEPPING
C     !INTERFACE:
      SUBROUTINE ADDUMMY_IN_STEPPING( myTime, myIter, myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE ADDUMMY_IN_STEPPING                           |
C     *==========================================================*
C     Extract adjoint variable from TAF-generated
C     adjoint common blocks, contained in adcommon.h
C     and write fields to file;
C     Make sure common blocks in adcommon.h are up-to-date
C     w.r.t. current adjoint code.
C     *==========================================================*
C     | SUBROUTINE ADDUMMY_IN_STEPPING                           |
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     == Global variables ===
#ifdef ALLOW_OPENAD
      use OAD_active
      use OAD_rev
      use OAD_tape
      use OAD_cp
#endif
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#ifdef ALLOW_AUTODIFF_MONITOR
# ifdef ALLOW_OPENAD
C- Note: Since OpenAD uses modules, the ordering of included headers matters
#  include "DYNVARS.h"
#  include "FFIELDS.h"
#  ifdef ALLOW_GMREDI
#   include "GMREDI.h"
#  endif
#  ifdef ALLOW_GGL90
#   include "GGL90.h"
#  endif
# endif /* ALLOW_OPENAD */
# include "AUTODIFF_PARAMS.h"
# include "AUTODIFF.h"
# ifndef ALLOW_OPENAD
#  include "adcommon.h"
# endif /* ALLOW_OPENAD */
# ifdef ALLOW_MNC
#  include "MNC_PARAMS.h"
# endif
# ifdef ALLOW_DIAGNOSTICS
#  include "DIAGNOSTICS_P2SHARE.h"
# endif
#endif /* ALLOW_AUTODIFF_MONITOR */

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     myTime  :: time counter for this thread
C     myIter  :: iteration counter for this thread
C     myThid  :: Thread number for this instance of the routine.
      _RL     myTime
      INTEGER myIter
      INTEGER myThid

#if (defined (ALLOW_ADJOINT_RUN) || defined (ALLOW_ADMTLM))
#ifdef ALLOW_AUTODIFF_MONITOR

C     !FUNCTIONS:
      LOGICAL  DIFFERENT_MULTIPLE
      EXTERNAL DIFFERENT_MULTIPLE

C     !LOCAL VARIABLES:
C     == local variables ==
C     suff    :: Hold suffix part of a filename
C     msgBuf  :: Error message buffer
c     CHARACTER*(10) suff
c     CHARACTER*(MAX_LEN_MBUF) msgBuf
#ifdef ALLOW_MNC
      _RL var2Du(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL var2Dv(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL var3Du(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      _RL var3Dv(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
#endif
      _RS dumRS(1)
      _RL dumRL(1)
      LOGICAL doExch
      LOGICAL doDump
CEOP

C--- Do dump?
      doDump = DIFFERENT_MULTIPLE( adjDumpFreq, myTime, deltaTClock )

C--- Test for adexch based on dumpAdVarExch flag
      doExch = doDump
#ifdef ALLOW_DIAGNOSTICS
      doExch = doDump .OR. useDiag4AdjOutp
#endif
      doExch = doExch .AND. ( dumpAdVarExch.EQ.1 )

C--- If necessary, do the exchanges
      IF ( doExch ) THEN
#ifdef ALLOW_OPENAD
C--   need to all the correct OpenAD EXCH S/R ; left empty for now
#else /* ALLOW_OPENAD */

#ifdef AUTODIFF_TAMC_COMPATIBILITY
        call adexch_xyz_rl( myThid,adTheta)
        call adexch_xyz_rl( myThid,adSalt)
        call adexch_xyz_rl( myThid,adwVel )
        call adexch_uv_xyz_rl(  .true. ,myThid,aduVel,advVel )

        call adexch_uv_xy_rs( .true., myThid, adfu, adfv )
        call adexch_xy_rs( myThid,adqnet )
        call adexch_xy_rs( myThid,adempmr )
# ifdef ALLOW_EDDYPSI_CONTROL
        call adexch_uv_xyz_rs(  .true. ,myThid,adeddypsix,adeddypsiy )
# endif
# ifdef ALLOW_DIFFKR_CONTROL
        call adexch_xyz_rl( myThid,addiffkr )
# endif
# ifdef ALLOW_KAPGM_CONTROL
        call adexch_xyz_rl( myThid, adKapGM )
# endif
# ifdef ALLOW_KAPREDI_CONTROL
        call adexch_xyz_rl( myThid, adKapRedi )
# endif
# ifdef ALLOW_BOTTOMDRAG_CONTROL
        call adexch_xy_rl( myThid,adbottomdragfld)
# endif
# else /* ndfef AUTODIFF_TAMC_COMPATIBILITY */

#  ifndef ALLOW_BULK_OFFLINE
        CALL ADEXCH_3D_RL( adTheta,Nr, myThid )
        CALL ADEXCH_3D_RL( adSalt, Nr, myThid )
        CALL ADEXCH_3D_RL( adwVel, Nr, myThid )
        CALL ADEXCH_UV_3D_RL( aduVel,advVel, .TRUE., Nr, myThid )
#  endif
C     There are rare cases when adexch_uv_xy_rs and adexch_xy_rs are not
C     generated by TAF and then the following lines will lead to an
C     error in the link step, for example, when there are no 2D forcing
C     fields controls. We should have a cpp flag for that that is
C     automatically defined if any 2D forcing controls are defined. As a
C     hack we use an excluding cpp-flag that needs to be defined if this
C     problem occurs
#ifndef AUTODIFF_EXCLUDE_ADEXCH_RS
        CALL ADEXCH_UV_XY_RS( adFu, adFv, .TRUE., myThid )
        CALL ADEXCH_XY_RS( adQnet, myThid )
        CALL ADEXCH_XY_RS( adEmPmR, myThid )
#endif
# ifdef ALLOW_EDDYPSI_CONTROL
        CALL ADEXCH_UV_XYZ_RS( adEddyPsiX, adEddyPsiY, .TRUE., myThid )
# endif
# ifdef ALLOW_DIFFKR_CONTROL
        CALL ADEXCH_3D_RL( adDiffKr, Nr, myThid )
# endif
# ifdef ALLOW_KAPGM_CONTROL
        CALL ADEXCH_3D_RL( adKapGM, Nr, myThid )
# endif
# ifdef ALLOW_KAPREDI_CONTROL
        CALL ADEXCH_3D_RL( adKapRedi, Nr, myThid )
# endif
# ifdef ALLOW_BOTTOMDRAG_CONTROL
        CALL ADEXCH_3D_RL( adBottomDragFld, 1 , myThid )
# endif
# if (defined ALLOW_SHELFICE && !defined ALLOW_SHITRANSCOEFF_3D)
#  ifndef SHI_ALLOW_GAMMAFRICT
        CALL ADEXCH_XY_RL( adshiTransCoeffT, myThid )
        CALL ADEXCH_XY_RL( adshiTransCoeffS, myThid )
#  else
        CALL ADEXCH_XY_RL( adshiCDragFld, myThid )
#  endif
# endif
# if ( defined ALLOW_SHELFICE && defined ALLOW_SHITRANSCOEFF_3D )
        CALL ADEXCH_3D_RL( adshiTransCoeffT3d, Nr, myThid )
        CALL ADEXCH_3D_RL( adshiTransCoeffS3d, Nr, myThid )
# endif

#endif /* AUTODIFF_TAMC_COMPATIBILITY */
#endif /* ALLOW_OPENAD */
      ENDIF

C=======================================================================
C--  Dump AD-variable to binary files and fill diagnostics
C=======================================================================
      IF ( doDump ) THEN
C     Increment ad dump record number (used only if dumpAdByRec is true)
        dumpAdRecMn = dumpAdRecMn + 1
        CALL TIMER_START('I/O (WRITE)        [ADJOINT LOOP]', myThid )
      ENDIF

#ifndef ALLOW_OPENAD
C========================
C--  TAF AD-variables:
C========================
C-----------------------------------------------------------------------
C--- State variables
C-----------------------------------------------------------------------
      CALL DUMP_ADJ_XYZ(dumRS, adTheta, 'ADJtheta', 'ADJtheta.',
     &                  12, doDump, dumpAdRecMn, myTime, myIter,myThid)

      CALL DUMP_ADJ_XYZ(dumRS, adSalt, 'ADJsalt ', 'ADJsalt.',
     &                  12, doDump, dumpAdRecMn, myTime, myIter,myThid)

      CALL DUMP_ADJ_XYZ(dumRS, adWvel, 'ADJwvel ', 'ADJwvel.',
     &                  12, doDump, dumpAdRecMn, myTime, myIter,myThid)

      CALL DUMP_ADJ_XYZ_UV(
     &     dumRS, adUvel, 'ADJuvel ', 'ADJuvel.',
     &     dumRS, adVvel, 'ADJvvel ', 'ADJvvel.',
     &     34, doDump, dumpAdRecMn, myTime, myIter,myThid)

C-----------------------------------------------------------------------
C--- Surface Forcing
C-----------------------------------------------------------------------
      IF ( .NOT. useSEAICE .AND. .NOT. useEXF ) THEN
       CALL DUMP_ADJ_XY_UV(
     &      adFu, dumRL, 'ADJtaux ', 'ADJtaux.',
     &      adFv, dumRL, 'ADJtauy ', 'ADJtauy.',
     &      33, doDump, dumpAdRecMn, myTime, myIter,myThid)
        CALL DUMP_ADJ_XY(adQnet, dumRL, 'ADJqnet ', 'ADJqnet.',
     &                   11, doDump, dumpAdRecMn, myTime, myIter,myThid)
        CALL DUMP_ADJ_XY(adEmPmR, dumRL, 'ADJempmr', 'ADJempr.',
     &                   11, doDump, dumpAdRecMn, myTime, myIter,myThid)

# ifdef SHORTWAVE_HEATING
        CALL DUMP_ADJ_XY(adQsw, dumRL, 'ADJqsw  ', 'ADJqsw.',
     &                   11, doDump, dumpAdRecMn, myTime, myIter,myThid)
# endif
      ENDIF

C-----------------------------------------------------------------------
C---Various packages and parameters
C-----------------------------------------------------------------------
# ifdef ALLOW_BOTTOMDRAG_CONTROL
      CALL DUMP_ADJ_XY(dumRS, adBottomDragFld,
     &                 'ADJbtdrg','ADJbottomdrag.',
     &                 12, doDump, dumpAdRecMn, myTime, myIter,myThid)
# endif
# ifdef ALLOW_GGL90
      CALL DUMP_ADJ_XYZ(dumRS, adGGL90TKE, 'ADJtke90', 'ADJggl90tke.',
     &                  12, doDump, dumpAdRecMn, myTime, myIter,myThid)
# endif
# ifdef ALLOW_DIFFKR_CONTROL
      CALL DUMP_ADJ_XYZ(dumRS, adDiffKr, 'ADJdifkr', 'ADJdiffkr.',
     &                  12, doDump, dumpAdRecMn, myTime, myIter,myThid)
# endif
# ifdef ALLOW_KAPGM_CONTROL
      CALL DUMP_ADJ_XYZ(dumRS, adKapGM, 'ADJkapgm', 'ADJkapgm.',
     &                  12, doDump, dumpAdRecMn, myTime, myIter,myThid)
# endif
# ifdef ALLOW_KAPREDI_CONTROL
      CALL DUMP_ADJ_XYZ(dumRS, adKapRedi, 'ADJkapre', 'ADJkapredi.',
     &                  12, doDump, dumpAdRecMn, myTime, myIter,myThid)
# endif

# ifdef ALLOW_EDDYPSI_CONTROL
      CALL DUMP_ADJ_XYZ_UV(
     &     adEddyPsiX,dumRL,'ADJepsix','ADJeddipsix.',
     &     adEddyPsiY,dumRL,'ADJepsiy','ADJeddipsiy.',
     &     33, doDump, dumpAdRecMn, myTime, myIter, myThid)
# endif
# if (defined ALLOW_SHELFICE && !defined ALLOW_SHITRANSCOEFF_3D)
#  ifndef SHI_ALLOW_GAMMAFRICT
      CALL DUMP_ADJ_XY(dumRS, adshiTransCoeffT,
     &                 'ADJshict','ADJshict.',
     &                 12, doDump, dumpAdRecMn, myTime, myIter,myThid)
      CALL DUMP_ADJ_XY(dumRS, adshiTransCoeffS,
     &                 'ADJshics','ADJshics.',
     &                 12, doDump, dumpAdRecMn, myTime, myIter,myThid)
#  else
      CALL DUMP_ADJ_XY(dumRS, adshiCDragFld,
     &                 'ADJshicd','ADJshicd.',
     &                 12, doDump, dumpAdRecMn, myTime, myIter,myThid)
#  endif
# endif
# if ( defined ALLOW_SHELFICE && defined ALLOW_SHITRANSCOEFF_3D )
      CALL DUMP_ADJ_XYZ(dumRS, adshiTransCoeffT3d,
     &                 'ADJshict','ADJshict.',
     &                 12, doDump, dumpAdRecMn, myTime, myIter,myThid)
      CALL DUMP_ADJ_XYZ(dumRS, adshiTransCoeffS3d,
     &                 'ADJshics','ADJshics.',
     &                 12, doDump, dumpAdRecMn, myTime, myIter,myThid)
# endif

# ifdef ALLOW_DEPTH_CONTROL
      CALL DUMP_ADJ_XYZ(
     &     adhfacc,dumRL,'ADJhFacC','ADJhFacC.',
     &     11, doDump, dumpAdRecMn, myTime, myIter, myThid)
      CALL DUMP_ADJ_XYZ_UV(
     &     adhfacw,dumRL,'ADJhFacW','ADJhFacW.',
     &     adhfacs,dumRL,'ADJhFacS','ADJhFacS.',
     &     33, doDump, dumpAdRecMn, myTime, myIter, myThid)
      CALL DUMP_ADJ_XYZ(
     &     adrecip_hfacc,dumRL,'ADJrhFcC','ADJrecip_hFacC.',
     &     11, doDump, dumpAdRecMn, myTime, myIter, myThid)
      CALL DUMP_ADJ_XYZ_UV(
     &     adrecip_hfacw,dumRL,'ADJrhFcW','ADJrecip_hFacW.',
     &     adrecip_hfacs,dumRL,'ADJrhFcS','ADJrecip_hFacS.',
     &     33, doDump, dumpAdRecMn, myTime, myIter, myThid)
# endif /* ALLOW_DEPTH_CONTROL */

#else /* ALLOW_OPENAD */
C========================
C--  OpenAD AD-variable:
C========================
C-----------------------------------------------------------------------
C--- State variables
C-----------------------------------------------------------------------
      CALL DUMP_ADJ_XYZ(dumRS, theta%d, 'ADJtheta', 'ADJtheta.',
     &                  12, doDump, dumpAdRecMn, myTime, myIter,myThid)

      CALL DUMP_ADJ_XYZ(dumRS, salt%d, 'ADJsalt ', 'ADJsalt.',
     &                  12, doDump, dumpAdRecMn, myTime, myIter,myThid)

      CALL DUMP_ADJ_XYZ(dumRS, wvel%d, 'ADJwvel ', 'ADJwvel.',
     &                  12, doDump, dumpAdRecMn, myTime, myIter,myThid)

      CALL DUMP_ADJ_XYZ_UV(
     &     dumRS, uvel%d, 'ADJuvel ', 'ADJuvel.',
     &     dumRS, vvel%d, 'ADJvvel ', 'ADJvvel.',
     &     34, doDump, dumpAdRecMn, myTime, myIter,myThid)

C-----------------------------------------------------------------------
C--- Surface Forcing
C-----------------------------------------------------------------------
      IF ( .NOT. useSEAICE .AND. .NOT. useEXF ) THEN
       CALL DUMP_ADJ_XY_UV(
     &      Fu%d, dumRL, 'ADJtaux ', 'ADJtaux.',
     &      Fv%d, dumRL, 'ADJtauy ', 'ADJtauy.',
     &      33, doDump, dumpAdRecMn, myTime, myIter,myThid)
        CALL DUMP_ADJ_XY(Qnet%d, dumRL, 'ADJqnet ', 'ADJqnet.',
     &                   11, doDump, dumpAdRecMn, myTime, myIter,myThid)
        CALL DUMP_ADJ_XY(EmPmR%d, dumRL, 'ADJempmr', 'ADJempr.',
     &                   11, doDump, dumpAdRecMn, myTime, myIter,myThid)

# ifdef SHORTWAVE_HEATING
C     Commented out since only works when Qsw is active
c       CALL DUMP_ADJ_XY(Qsw%d, dumRL, 'ADJqsw  ', 'ADJqsw.',
c    &                   11, doDump, dumpAdRecMn, myTime, myIter,myThid)
# endif
      ENDIF

C-----------------------------------------------------------------------
C---Various packages and parameters
C-----------------------------------------------------------------------
# ifdef ALLOW_BOTTOMDRAG_CONTROL
      CALL DUMP_ADJ_XY(dumRS, BottomDragFld%d,
     &                 'ADJbtdrg','ADJbottomdrag.',
     &                 11, doDump, dumpAdRecMn, myTime, myIter,myThid)
# endif
# ifdef ALLOW_GGL90
      CALL DUMP_ADJ_XYZ(dumRS, GGL90TKE%d, 'ADJtke90', 'ADJggl90tke.',
     &                  12, doDump, dumpAdRecMn, myTime, myIter,myThid)
# endif
# ifdef ALLOW_DIFFKR_CONTROL
      CALL DUMP_ADJ_XYZ(dumRS, DiffKr%d, 'ADJdifkr', 'ADJdiffkr.',
     &                  12, doDump, dumpAdRecMn, myTime, myIter,myThid)
# endif
# if ( defined ALLOW_KAPGM_CONTROL && defined GM_READ_K3D_GM )
      CALL DUMP_ADJ_XYZ(dumRS, GM_inpK3dGM%d, 'ADJkapgm', 'ADJkapgm.',
     &                  12, doDump, dumpAdRecMn, myTime, myIter,myThid)
# endif
# if ( defined ALLOW_KAPREDI_CONTROL && defined GM_READ_K3D_REDI )
      CALL DUMP_ADJ_XYZ(dumRS, GM_inpK3dRedi%d, 'ADJkapre',
     &                  'ADJkapredi.',
     &                  12, doDump, dumpAdRecMn, myTime, myIter,myThid)
# endif

# ifdef ALLOW_EDDYPSI_CONTROL
      CALL DUMP_ADJ_XYZ_UV(
     &     EddyPsiX%d,dumRL,'ADJepsix','ADJeddipsix.',
     &     EddyPsiY%d,dumRL,'ADJepsiy','ADJeddipsiy.',
     &     33, doDump, dumpAdRecMn, myTime, myIter,myThid)
# endif
# if (defined ALLOW_SHELFICE && !defined ALLOW_SHITRANSCOEFF_3D)
#  ifndef SHI_ALLOW_GAMMAFRICT
      CALL DUMP_ADJ_XY(dumRS, shiTransCoeffT%d,
     &                 'ADJshict','ADJshict.',
     &                 12, doDump, dumpAdRecMn, myTime, myIter,myThid)
      CALL DUMP_ADJ_XY(dumRS, shiTransCoeffS%d,
     &                 'ADJshics','ADJshics.',
     &                 12, doDump, dumpAdRecMn, myTime, myIter,myThid)
#  else
      CALL DUMP_ADJ_XY(dumRS, shiCDragFld%d,
     &                 'ADJshicd','ADJshicd.',
     &                 12, doDump, dumpAdRecMn, myTime, myIter,myThid)
#  endif
# endif
# if (defined ALLOW_SHELFICE && defined ALLOW_SHITRANSCOEFF_3D)
      CALL DUMP_ADJ_XYZ(dumRS, shiTransCoeffT3d%d,
     &                 'ADJshict','ADJshict.',
     &                 12, doDump, dumpAdRecMn, myTime, myIter,myThid)
      CALL DUMP_ADJ_XYZ(dumRS, shiTransCoeffS3d%d,
     &                 'ADJshics','ADJshics.',
     &                 12, doDump, dumpAdRecMn, myTime, myIter,myThid)
# endif

# ifdef ALLOW_DEPTH_CONTROL
      CALL DUMP_ADJ_XYZ(
     &     hFacC%d,dumRL,'ADJhFacC','ADJhFacC.',
     &     11, doDump, dumpAdRecMn, myTime, myIter, myThid)
      CALL DUMP_ADJ_XYZ_UV(
     &     hFacW%d,dumRL,'ADJhFacW','ADJhFacW.',
     &     hFacS%d,dumRL,'ADJhFacS','ADJhFacS.',
     &     33, doDump, dumpAdRecMn, myTime, myIter, myThid)
      CALL DUMP_ADJ_XYZ(
     &     recip_hFacC%d,dumRL,'ADJrhFcC','ADJrecip_hFacC.',
     &     11, doDump, dumpAdRecMn, myTime, myIter, myThid)
      CALL DUMP_ADJ_XYZ_UV(
     &     recip_hFacW%d,dumRL,'ADJrhFcW','ADJrecip_hFacW.',
     &     recip_hFacS%d,dumRL,'ADJrhFcS','ADJrecip_hFacS.',
     &     33, doDump, dumpAdRecMn, myTime, myIter, myThid)
# endif /* ALLOW_DEPTH_CONTROL */

#endif /* ALLOW_OPENAD */

C=======================================================================
C--  Dump TAF AD-variable to NetCdF files
C=======================================================================
      IF ( doDump ) THEN
#ifndef ALLOW_OPENAD
#ifdef ALLOW_MNC
        IF (useMNC .AND. autodiff_mnc) THEN
         CALL MNC_CW_SET_UDIM('adstate', -1, myThid)
         CALL MNC_CW_RL_W_S('D','adstate',0,0,'T',myTime,myThid)
         CALL MNC_CW_SET_UDIM('adstate', 0, myThid)
         CALL MNC_CW_I_W_S('I','adstate',0,0,'iter',myIter,myThid)
         CALL MNC_CW_RL_W_S('D','adstate',0,0,'model_time',myTime,
     &        myThid)

         IF ( dumpAdVarExch.EQ.2 ) THEN
          CALL COPY_AD_UV_OUTP( dumRS, dumRS, aduVel, advVel,
     &                          var3Du, var3Dv, Nr, 34, myThid )
          CALL MNC_CW_RL_W('D','adstate',0,0,'adU', var3Du, myThid)
          CALL MNC_CW_RL_W('D','adstate',0,0,'adV', var3Dv, myThid)
          CALL COPY_ADVAR_OUTP( dumRS, adTheta,var3Du, Nr, 12, myThid )
          CALL MNC_CW_RL_W('D','adstate',0,0,'adT', var3Du, myThid)
          CALL COPY_ADVAR_OUTP( dumRS, adSalt,var3Du, Nr, 12, myThid )
          CALL MNC_CW_RL_W('D','adstate',0,0,'adS', var3Du, myThid)
          CALL COPY_ADVAR_OUTP( dumRS, adwVel, var3Du, Nr, 12, myThid )
          CALL MNC_CW_RL_W('D','adstate',0,0,'adW', var3Du, myThid)

          CALL COPY_ADVAR_OUTP( adQnet, dumRL, var2Du, 1, 11, myThid )
          CALL MNC_CW_RL_W('D','adstate',0,0,'adQnet', var2Du, myThid)
          CALL COPY_ADVAR_OUTP( adEmPmR,dumRL, var2Du, 1, 11, myThid )
          CALL MNC_CW_RL_W('D','adstate',0,0,'adEmpmr', var2Du, myThid)
          CALL COPY_AD_UV_OUTP( adFu, adFv, dumRL, dumRL,
     &                          var2Du, var2Dv, 1, 33, myThid )
          CALL MNC_CW_RL_W('D','adstate',0,0,'adFu', var2Du, myThid)
          CALL MNC_CW_RL_W('D','adstate',0,0,'adFv', var2Dv, myThid)

#ifdef ALLOW_BOTTOMDRAG_CONTROL
          CALL COPY_ADVAR_OUTP( dumRS, adBottomDragFld,
     &                                        var2Du, 1, 12, myThid )
          CALL MNC_CW_RL_W('D','adstate',0,0,
     &                     'adBottomDrag', var2Du, myThid)
#endif
#ifdef ALLOW_DIFFKR_CONTROL
          CALL COPY_ADVAR_OUTP( dumRS, adDiffKr,var3Du, Nr, 12,myThid )
          CALL MNC_CW_RL_W('D','adstate',0,0,
     &                     'adDiffkr', var3Du, myThid)
#endif
#ifdef ALLOW_KAPGM_CONTROL
          CALL COPY_ADVAR_OUTP( dumRS, adKapGM, var3Du, Nr, 12,myThid )
          CALL MNC_CW_RL_W('D','adstate',0,0,
     &                     'adkapgm', var3Du, myThid)
#endif
#ifdef ALLOW_KAPREDI_CONTROL
          CALL COPY_ADVAR_OUTP( dumRS,adKapRedi,var3Du, Nr, 12,myThid )
          CALL MNC_CW_RL_W('D','adstate',0,0,
     &                     'adkapredi', var3Du, myThid)
#endif
         ELSE
C     dumpAdVarExch.NE.2
          CALL MNC_CW_RL_W('D','adstate',0,0,'adU', aduVel, myThid)
          CALL MNC_CW_RL_W('D','adstate',0,0,'adV', advVel, myThid)
          CALL MNC_CW_RL_W('D','adstate',0,0,'adT', adTheta, myThid)
          CALL MNC_CW_RL_W('D','adstate',0,0,'adS', adSalt, myThid)
          CALL MNC_CW_RL_W('D','adstate',0,0,'adW', adwVel, myThid)

          CALL MNC_CW_RS_W('D','adstate',0,0,'adQnet', adQnet, myThid)
          CALL MNC_CW_RS_W('D','adstate',0,0,'adEmpmr',adEmpmr, myThid)
          CALL MNC_CW_RS_W('D','adstate',0,0,'adFu', adfu, myThid)
          CALL MNC_CW_RS_W('D','adstate',0,0,'adFv', adfv, myThid)

#ifdef ALLOW_BOTTOMDRAG_CONTROL
          CALL MNC_CW_RL_W('D','adstate',0,0,
     &                     'adBottomDrag', adbottomdragfld, myThid)
#endif
#ifdef ALLOW_DIFFKR_CONTROL
          CALL MNC_CW_RL_W('D','adstate',0,0,
     &                     'adDiffkr', addiffkr, myThid)
#endif
#ifdef ALLOW_KAPGM_CONTROL
          CALL MNC_CW_RL_W('D','adstate',0,0,
     &                     'adkapgm', adKapGM, myThid)
#endif
#ifdef ALLOW_KAPREDI_CONTROL
          CALL MNC_CW_RL_W('D','adstate',0,0,
     &                     'adkapredi', adKapRedi, myThid)
#endif
#ifdef ALLOW_SHELFICE
# ifndef SHI_ALLOW_GAMMAFRICT
#  ifdef ALLOW_SHITRANSCOEFF_3D
          CALL MNC_CW_RL_W('D','adstate',0,0,
     &                     'adshict', adshiTransCoeffT3d, myThid)
          CALL MNC_CW_RL_W('D','adstate',0,0,
     &                     'adshics', adshiTransCoeffS3d, myThid)
#  else
          CALL MNC_CW_RL_W('D','adstate',0,0,
     &                     'adshict', adshiTransCoeffT, myThid)
          CALL MNC_CW_RL_W('D','adstate',0,0,
     &                     'adshics', adshiTransCoeffS, myThid)
#  endif
# else
          CALL MNC_CW_RL_W('D','adstate',0,0,
     &                     'adshicd', adshiCDragFld, myThid)
# endif
#endif
         ENDIF
C     endif mnc
        ENDIF
#endif /* ALLOW_MNC */
#endif /* ALLOW_OPENAD */

        CALL TIMER_STOP( 'I/O (WRITE)        [ADJOINT LOOP]', myThid )

      ENDIF

C=======================================================================
C--  Output AD-variable & fill Diagnostics with pkg specific interface
C=======================================================================
#ifdef ALLOW_SEAICE
        IF ( useSEAICE )
     &   CALL SEAICE_AD_DUMP( myTime, myIter, myThid )
#endif

#ifdef ALLOW_PTRACERS
        IF ( usePTRACERS )
     &   CALL PTRACERS_AD_DUMP( myTime, myIter, myThid )
#endif

#endif /* ALLOW_AUTODIFF_MONITOR */
#endif /* ALLOW_ADJOINT_RUN */

      RETURN
      END

#include "ADMTLM_OPTIONS.h"
#ifdef ALLOW_CTRL
# include "CTRL_OPTIONS.h"
#endif

      subroutine admtlm_model2dsvd(
     &     first, preprocev, mythid )

c     ==================================================================
c     SUBROUTINE admtlm_model2dsvd
c     ==================================================================
c
c     o Compress the control vector such that only ocean points are
c       written to file.
c
c     ==================================================================
c     SUBROUTINE admtlm_model2dsvd
c     ==================================================================

      implicit none

c     == global variables ==

#include "EEPARAMS.h"
#include "SIZE.h"
#include "PARAMS.h"
#include "GRID.h"

#include "CTRL.h"
#include "OPTIMCYCLE.h"

#ifdef ALLOW_COST
# include "cost.h"
#endif
#ifdef ALLOW_ECCO
# include "ecco_cost.h"
#else
# include "ctrl_weights.h"
#endif

c     == routine arguments ==

      logical first
      logical preprocev
      integer mythid

#ifndef EXCLUDE_CTRL_PACK
c     == local variables ==

      integer i, j, k
      integer ii
      integer il
      integer irec
      integer ig,jg
      integer ivartype
      integer iobcs

      logical doglobalread
      logical ladinit
      integer cbuffindex
      logical lxxadxx

      integer cunit
      integer ictrlgrad

      character*(128) cfile
      character*( 80) weighttype

c     == external ==

      integer  ilnblnk
      external ilnblnk

c     == end of interface ==

c--   Tiled files are used.
      doglobalread = .false.

c--   Initialise adjoint variables on active files.
      ladinit = .false.

c--   Initialise global buffer index
      nbuffglobal = 0

cph-new(
      if ( preprocev ) then
         yadprefix = 'ev'
      else
         yadprefix = 'ad'
      endif
      nveccount = 0
cph-new)

c--   Assign file names.

      call ctrl_set_fname(xx_theta_file, fname_theta, mythid)
      call ctrl_set_fname(xx_salt_file, fname_salt, mythid)
      call ctrl_set_fname(xx_hflux_file, fname_hflux, mythid)
      call ctrl_set_fname(xx_sflux_file, fname_sflux, mythid)
      call ctrl_set_fname(xx_tauu_file, fname_tauu, mythid)
      call ctrl_set_fname(xx_tauv_file, fname_tauv, mythid)
      call ctrl_set_fname(xx_atemp_file, fname_atemp, mythid)
      call ctrl_set_fname(xx_aqh_file, fname_aqh, mythid)
      call ctrl_set_fname(xx_precip_file, fname_precip, mythid)
      call ctrl_set_fname(xx_swflux_file, fname_swflux, mythid)
      call ctrl_set_fname(xx_swdown_file, fname_swdown, mythid)
      call ctrl_set_fname(xx_uwind_file, fname_uwind, mythid)
      call ctrl_set_fname(xx_vwind_file, fname_vwind, mythid)
      call ctrl_set_fname(xx_obcsn_file, fname_obcsn, mythid)
      call ctrl_set_fname(xx_obcss_file, fname_obcss, mythid)
      call ctrl_set_fname(xx_obcsw_file, fname_obcsw, mythid)
      call ctrl_set_fname(xx_obcse_file, fname_obcse, mythid)
      call ctrl_set_fname(xx_diffkr_file, fname_diffkr, mythid)
      call ctrl_set_fname(xx_kapgm_file, fname_kapgm, mythid)
      call ctrl_set_fname(xx_tr1_file, fname_tr1, mythid)
      call ctrl_set_fname(xx_sst_file, fname_sst, mythid)
      call ctrl_set_fname(xx_sss_file, fname_sss, mythid)
      call ctrl_set_fname(xx_depth_file, fname_depth, mythid)
      call ctrl_set_fname(xx_efluxy_file, fname_efluxy, mythid)
      call ctrl_set_fname(xx_efluxp_file, fname_efluxp, mythid)
      call ctrl_set_fname(xx_bottomdrag_file, fname_bottomdrag, mythid)
      call ctrl_set_fname(xx_edtaux_file, fname_edtaux, mythid)
      call ctrl_set_fname(xx_edtauy_file, fname_edtauy, mythid)
      call ctrl_set_fname(xx_uvel_file, fname_uvel, mythid)
      call ctrl_set_fname(xx_vvel_file, fname_vvel, mythid)
      call ctrl_set_fname(xx_etan_file, fname_etan, mythid)
      call ctrl_set_fname(xx_relaxsst_file, fname_relaxsst, mythid)
      call ctrl_set_fname(xx_relaxsss_file, fname_relaxsss, mythid)

c--   Only the master thread will do I/O.
      _BEGIN_MASTER( mythid )

      if ( first ) then
c     >>> Initialise control vector for optimcycle=0 <<<
          lxxadxx   = .TRUE.
          ictrlgrad = 1
          write(cfile(1:128),'(4a,i4.4)')
     &         ctrlname(1:9),'_',yctrlid(1:10),
     &         yctrlpospack, optimcycle
          print *, 'ph-pack: packing ', ctrlname(1:9)
      else
c     >>> Write gradient vector <<<
          lxxadxx   = .FALSE.
          ictrlgrad = 2
          write(cfile(1:128),'(4a,i4.4)')
     &         costname(1:9),'_',yctrlid(1:10),
     &         yctrlpospack, optimcycle
          print *, 'ph-pack: packing ', costname(1:9)
       endif

       call mdsfindunit( cunit, mythid )

#ifdef ALLOW_ADMTLM

       if ( preprocev ) then
cph do a dummy write of initial EV fields
          write(cfile(1:128),'(a)') ' '
          write(cfile,'(a,i4.4)')
     &         'admtlm_eigen', optimcycle
       else
          write(cfile(1:128),'(a)') ' '
          write(cfile,'(a,i4.4)')
     &         'admtlm_vector.it', optimcycle + 1
       endif
       print *, 'ph-pack: unpacking ', cfile
cph       open( cunit, file   = cfile,
cph     &      status = 'unknown',
cph     &      form   = 'unformatted',
cph     &      access  = 'sequential'   )

#else /* ndef ALLOW_ADMTLM */

       open( cunit, file   = cfile,
     &      status = 'unknown',
     &      form   = 'unformatted',
     &      access  = 'sequential'   )

c--       Header information.
          write(cunit) nvartype
          write(cunit) nvarlength
          write(cunit) yctrlid
          write(cunit) optimCycle
          write(cunit) fc
C     place holder of obsolete variable iG
          write(cunit) 1
C     place holder of obsolete variable jG
          write(cunit) 1
          write(cunit) nsx
          write(cunit) nsy
          write(cunit) (nWetcGlobal(k), k=1,nr)
          write(cunit) (nWetsGlobal(k), k=1,nr)
          write(cunit) (nWetwGlobal(k), k=1,nr)
#ifdef ALLOW_CTRL_WETV
          write(cunit) (nWetvGlobal(k), k=1,nr)
#endif

#ifdef ALLOW_OBCSN_CONTROL
          write(cunit) ((nWetobcsnGlo(k,iobcs), k=1,nr),iobcs= 1,nobcs)
#endif
#ifdef ALLOW_OBCSS_CONTROL
          write(cunit) ((nWetobcssGlo(k,iobcs), k=1,nr),iobcs= 1,nobcs)
#endif
#ifdef ALLOW_OBCSW_CONTROL
          write(cunit) ((nWetobcswGlo(k,iobcs), k=1,nr),iobcs= 1,nobcs)
#endif
#ifdef ALLOW_OBCSE_CONTROL
          write(cunit) ((nWetobcseGlo(k,iobcs), k=1,nr),iobcs= 1,nobcs)
#endif
          write(cunit) (ncvarindex(i), i=1,maxcvars)
          write(cunit) (ncvarrecs(i),  i=1,maxcvars)
          write(cunit) (ncvarxmax(i),  i=1,maxcvars)
          write(cunit) (ncvarymax(i),  i=1,maxcvars)
          write(cunit) (ncvarnrmax(i), i=1,maxcvars)
          write(cunit) (ncvargrd(i),   i=1,maxcvars)
          write(cunit)

#endif /* ALLOW_ADMTLM */

#ifdef ALLOW_THETA0_CONTROL
          ivartype = 1
          write(weighttype(1:80),'(80a)') ' '
          write(weighttype(1:80),'(a)') "wtheta"
          call ctrl_set_pack_xyz(
     &         cunit, ivartype, fname_theta(ictrlgrad), "maskCtrlC",
     &         weighttype, wtheta, lxxadxx, mythid)
#endif

#ifdef ALLOW_SALT0_CONTROL
          ivartype = 2
          write(weighttype(1:80),'(80a)') ' '
          write(weighttype(1:80),'(a)') "wsalt"
          call ctrl_set_pack_xyz(
     &         cunit, ivartype, fname_salt(ictrlgrad), "maskCtrlC",
     &         weighttype, wsalt, lxxadxx, mythid)
#endif

#if (defined (ALLOW_HFLUX_CONTROL) || defined (ALLOW_HFLUX0_CONTROL))
          ivartype = 3
          write(weighttype(1:80),'(80a)') ' '
          write(weighttype(1:80),'(a)') "whflux"
          call ctrl_set_pack_xy(
     &         cunit, ivartype, fname_hflux(ictrlgrad), "maskCtrlC",
     &         weighttype, lxxadxx, mythid)
#endif

#if (defined (ALLOW_SFLUX_CONTROL) || defined (ALLOW_SFLUX0_CONTROL))
          ivartype = 4
          write(weighttype(1:80),'(80a)') ' '
          write(weighttype(1:80),'(a)') "wsflux"
          call ctrl_set_pack_xy(
     &         cunit, ivartype, fname_sflux(ictrlgrad), "maskCtrlC",
     &         weighttype, lxxadxx, mythid)
#endif

#if (defined (ALLOW_USTRESS_CONTROL) || defined (ALLOW_TAUU0_CONTROL))
          ivartype = 5
          write(weighttype(1:80),'(80a)') ' '
          write(weighttype(1:80),'(a)') "wtauu"
          call ctrl_set_pack_xy(
     &         cunit, ivartype, fname_tauu(ictrlgrad), "maskCtrlW",
     &         weighttype, lxxadxx, mythid)
#endif

#if (defined (ALLOW_VSTRESS_CONTROL) || defined (ALLOW_TAUV0_CONTROL))
          ivartype = 6
          write(weighttype(1:80),'(80a)') ' '
          write(weighttype(1:80),'(a)') "wtauv"
          call ctrl_set_pack_xy(
     &         cunit, ivartype, fname_tauv(ictrlgrad), "maskCtrlS",
     &         weighttype, lxxadxx, mythid)
#endif

#ifdef ALLOW_ATEMP_CONTROL
          ivartype = 7
          write(weighttype(1:80),'(80a)') ' '
          write(weighttype(1:80),'(a)') "watemp"
          call ctrl_set_pack_xy(
     &         cunit, ivartype, fname_atemp(ictrlgrad), "maskCtrlC",
     &         weighttype, lxxadxx, mythid)
#endif

#ifdef ALLOW_AQH_CONTROL
          ivartype = 8
          write(weighttype(1:80),'(80a)') ' '
          write(weighttype(1:80),'(a)') "waqh"
          call ctrl_set_pack_xy(
     &         cunit, ivartype, fname_aqh(ictrlgrad), "maskCtrlC",
     &         weighttype, lxxadxx, mythid)
#endif

#ifdef ALLOW_UWIND_CONTROL
          ivartype = 9
          write(weighttype(1:80),'(80a)') ' '
          write(weighttype(1:80),'(a)') "wuwind"
          call ctrl_set_pack_xy(
     &         cunit, ivartype, fname_uwind(ictrlgrad), "maskCtrlC",
     &         weighttype, lxxadxx, mythid)
#endif

#ifdef ALLOW_VWIND_CONTROL
          ivartype = 10
          write(weighttype(1:80),'(80a)') ' '
          write(weighttype(1:80),'(a)') "wvwind"
          call ctrl_set_pack_xy(
     &         cunit, ivartype, fname_vwind(ictrlgrad), "maskCtrlC",
     &         weighttype, lxxadxx, mythid)
#endif

#ifdef ALLOW_OBCSN_CONTROL
          ivartype = 11
          write(weighttype(1:80),'(80a)') ' '
          write(weighttype(1:80),'(a)') "wobcsn"
          call ctrl_set_pack_xz(
     &         cunit, ivartype, fname_obcsn(ictrlgrad), "maskobcsn",
     &         weighttype, wobcsn, lxxadxx, mythid)
#endif

#ifdef ALLOW_OBCSS_CONTROL
          ivartype = 12
          write(weighttype(1:80),'(80a)') ' '
          write(weighttype(1:80),'(a)') "wobcss"
          call ctrl_set_pack_xz(
     &         cunit, ivartype, fname_obcss(ictrlgrad), "maskobcss",
     &         weighttype, wobcss, lxxadxx, mythid)
#endif

#ifdef ALLOW_OBCSW_CONTROL
          ivartype = 13
          write(weighttype(1:80),'(80a)') ' '
          write(weighttype(1:80),'(a)') "wobcsw"
          call ctrl_set_pack_yz(
     &         cunit, ivartype, fname_obcsw(ictrlgrad), "maskobcsw",
     &         weighttype, wobcsw, lxxadxx, mythid)
#endif

#ifdef ALLOW_OBCSE_CONTROL
          ivartype = 14
          write(weighttype(1:80),'(80a)') ' '
          write(weighttype(1:80),'(a)') "wobcse"
          call ctrl_set_pack_yz(
     &         cunit, ivartype, fname_obcse(ictrlgrad), "maskobcse",
     &         weighttype, wobcse, lxxadxx, mythid)
#endif

#ifdef ALLOW_DIFFKR_CONTROL
          ivartype = 15
          write(weighttype(1:80),'(80a)') ' '
          write(weighttype(1:80),'(a)') "wdiffkr"
          call ctrl_set_pack_xyz(
     &         cunit, ivartype, fname_diffkr(ictrlgrad), "maskCtrlC",
     &         weighttype, wunit, lxxadxx, mythid)
#endif

#ifdef ALLOW_KAPGM_CONTROL
          ivartype = 16
          write(weighttype(1:80),'(80a)') ' '
          write(weighttype(1:80),'(a)') "wkapgm"
          call ctrl_set_pack_xyz(
     &         cunit, ivartype, fname_kapgm(ictrlgrad), "maskCtrlC",
     &         weighttype, wunit, lxxadxx, mythid)
#endif

#ifdef ALLOW_TR10_CONTROL
          ivartype = 17
          write(weighttype(1:80),'(80a)') ' '
          write(weighttype(1:80),'(a)') "wtr1"
          call ctrl_set_pack_xyz(
     &         cunit, ivartype, fname_tr1(ictrlgrad), "maskCtrlC",
     &         weighttype, wunit, lxxadxx, mythid)
#endif

#if (defined (ALLOW_SST_CONTROL) || defined (ALLOW_SST0_CONTROL))
          ivartype = 18
          write(weighttype(1:80),'(80a)') ' '
          write(weighttype(1:80),'(a)') "wsst"
          call ctrl_set_pack_xy(
     &         cunit, ivartype, fname_sst(ictrlgrad), "maskCtrlC",
     &         weighttype, lxxadxx, mythid)
#endif

#if (defined (ALLOW_SSS_CONTROL) || defined (ALLOW_SSS0_CONTROL))
          ivartype = 19
          write(weighttype(1:80),'(80a)') ' '
          write(weighttype(1:80),'(a)') "wsss"
          call ctrl_set_pack_xy(
     &         cunit, ivartype, fname_sss(ictrlgrad), "maskCtrlC",
     &         weighttype, lxxadxx, mythid)
#endif

#ifdef ALLOW_DEPTH_CONTROL
          ivartype = 20
          write(weighttype(1:80),'(80a)') ' '
          write(weighttype(1:80),'(a)') "wdepth"
          call ctrl_set_pack_xy(
     &         cunit, ivartype, fname_depth(ictrlgrad), "maskCtrlC",
     &         weighttype, lxxadxx, mythid)
#endif

#ifdef ALLOW_EFLUXY0_CONTROL
          ivartype = 21
          write(weighttype(1:80),'(80a)') ' '
          write(weighttype(1:80),'(a)') "wefluxy0"
          call ctrl_set_pack_xyz(
     &         cunit, ivartype, fname_efluxy(ictrlgrad), "maskCtrlS",
     &         weighttype, wunit, lxxadxx, mythid)
#endif

#ifdef ALLOW_EFLUXP0_CONTROL
          ivartype = 22
          write(weighttype(1:80),'(80a)') ' '
          write(weighttype(1:80),'(a)') "wefluxp0"
          call ctrl_set_pack_xyz(
     &         cunit, ivartype, fname_efluxp(ictrlgrad), "maskhFacV",
     &         weighttype, wunit, lxxadxx, mythid)
#endif

#ifdef ALLOW_BOTTOMDRAG_CONTROL
          ivartype = 23
          write(weighttype(1:80),'(80a)') ' '
          write(weighttype(1:80),'(a)') "wbottomdrag"
          call ctrl_set_pack_xy(
     &      cunit, ivartype, fname_bottomdrag(ictrlgrad), "maskCtrlC",
     &      weighttype, lxxadxx, mythid)
#endif

#ifdef ALLOW_EDDYPSI_CONTROL
          ivartype = 25
          write(weighttype(1:80),'(80a)') ' '
          write(weighttype(1:80),'(a)') "wedtaux"
          call ctrl_set_pack_xyz(
     &         cunit, ivartype, fname_edtaux(ictrlgrad), "maskCtrlW",
     &         weighttype, wunit, lxxadxx, mythid)

          ivartype = 26
          write(weighttype(1:80),'(80a)') ' '
          write(weighttype(1:80),'(a)') "wedtauy"
          call ctrl_set_pack_xyz(
     &         cunit, ivartype, fname_edtauy(ictrlgrad), "maskCtrlS",
     &         weighttype, wunit, lxxadxx, mythid)
#endif

#ifdef ALLOW_UVEL0_CONTROL
          ivartype = 27
          write(weighttype(1:80),'(80a)') ' '
          write(weighttype(1:80),'(a)') "wuvvel"
          call ctrl_set_pack_xyz(
     &         cunit, ivartype, fname_uvel(ictrlgrad), "maskCtrlW",
     &         weighttype, wuvvel, lxxadxx, mythid)
#endif

#ifdef ALLOW_VVEL0_CONTROL
          ivartype = 28
          write(weighttype(1:80),'(80a)') ' '
          write(weighttype(1:80),'(a)') "wuvvel"
          call ctrl_set_pack_xyz(
     &         cunit, ivartype, fname_vvel(ictrlgrad), "maskCtrlS",
     &         weighttype, wuvvel, lxxadxx, mythid)
#endif

#ifdef ALLOW_ETAN0_CONTROL
          ivartype = 29
          write(weighttype(1:80),'(80a)') ' '
          write(weighttype(1:80),'(a)') "wetan"
          call ctrl_set_pack_xy(
     &         cunit, ivartype, fname_etan(ictrlgrad), "maskCtrlC",
     &         weighttype, lxxadxx, mythid)
#endif

#ifdef ALLOW_RELAXSST_CONTROL
          ivartype = 30
          write(weighttype(1:80),'(80a)') ' '
          write(weighttype(1:80),'(a)') "wrelaxsst"
          call ctrl_set_pack_xy(
     &         cunit, ivartype, fname_relaxsst(ictrlgrad), "maskCtrlC",
     &         weighttype, lxxadxx, mythid)
#endif

#ifdef ALLOW_RELAXSSS_CONTROL
          ivartype = 31
          write(weighttype(1:80),'(80a)') ' '
          write(weighttype(1:80),'(a)') "wrelaxsss"
          call ctrl_set_pack_xy(
     &         cunit, ivartype, fname_relaxsss(ictrlgrad), "maskCtrlC",
     &         weighttype, lxxadxx, mythid)
#endif

#ifdef ALLOW_PRECIP_CONTROL
          ivartype = 32
          write(weighttype(1:80),'(80a)') ' '
          write(weighttype(1:80),'(a)') "wprecip"
          call ctrl_set_pack_xy(
     &         cunit, ivartype, fname_precip(ictrlgrad), "maskCtrlC",
     &         weighttype, lxxadxx, mythid)
#endif

#ifdef ALLOW_SWFLUX_CONTROL
          ivartype = 33
          write(weighttype(1:80),'(80a)') ' '
          write(weighttype(1:80),'(a)') "wswflux"
          call ctrl_set_pack_xy(
     &         cunit, ivartype, fname_swflux(ictrlgrad), "maskCtrlC",
     &         weighttype, lxxadxx, mythid)
#endif

#ifdef ALLOW_SWDOWN_CONTROL
          ivartype = 34
          write(weighttype(1:80),'(80a)') ' '
          write(weighttype(1:80),'(a)') "wswdown"
          call ctrl_set_pack_xy(
     &         cunit, ivartype, fname_swdown(ictrlgrad), "maskCtrlC",
     &         weighttype, lxxadxx, mythid)
#endif

          close ( cunit )

        _END_MASTER( mythid )

#endif /* EXCLUDE_CTRL_PACK */

      return
      end

#include "CPP_OPTIONS.h"

CBOP
C     !ROUTINE: SOLVE_UV_TRIDIAGO
C     !INTERFACE:
      SUBROUTINE SOLVE_UV_TRIDIAGO(
     I                     kSize, ols, solve4u, solve4v,
     I                     aU, bU, cU, rhsU,
     I                     aV, bV, cV, rhsV,
     O                     uFld, vFld,
     O                     errCode,
     I                     subIter, myIter, myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R SOLVE_UV_TRIDIAGO
C     | o Solve a pair of tri-diagonal system along X and Y lines
C     |   (in X-dir for uFld and in Y-dir for vFld)
C     *==========================================================*
C     | o Used, e.g., in linear part of seaice LSR solver
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     == Global data ==
#include "SIZE.h"
#include "EEPARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine Arguments ==
C     kSize    :: size in 3rd dimension
C     ols      :: size of overlap (of input arg array)
C     solve4u  :: logical flag, do solve for u-component if true
C     solve4v  :: logical flag, do solve for v-component if true
C     aU,bU,cU :: u-matrix (lower diagonal, main diagonal & upper diagonal)
C     rhsU     :: RHS vector (u-component)
C     aV,bV,cV :: v-matrix (lower diagonal, main diagonal & upper diagonal)
C     rhsV     :: RHS vector (v-component)
C     uFld     :: X = solution of: A_u * X = rhsU
C     vFld     :: X = solution of: A_v * X = rhsV
C     errCode  :: > 0 if singular matrix
C     subIter  :: current sub-iteration number
C     myIter   :: current iteration number
C     myThid   :: my Thread Id number
      INTEGER kSize, ols
      LOGICAL solve4u, solve4v
      _RL  aU (1-ols:sNx+ols,1-ols:sNy+ols,kSize,nSx,nSy)
      _RL  bU (1-ols:sNx+ols,1-ols:sNy+ols,kSize,nSx,nSy)
      _RL  cU (1-ols:sNx+ols,1-ols:sNy+ols,kSize,nSx,nSy)
      _RL rhsU(1-ols:sNx+ols,1-ols:sNy+ols,kSize,nSx,nSy)
      _RL  aV (1-ols:sNx+ols,1-ols:sNy+ols,kSize,nSx,nSy)
      _RL  bV (1-ols:sNx+ols,1-ols:sNy+ols,kSize,nSx,nSy)
      _RL  cV (1-ols:sNx+ols,1-ols:sNy+ols,kSize,nSx,nSy)
      _RL rhsV(1-ols:sNx+ols,1-ols:sNy+ols,kSize,nSx,nSy)
      _RL uFld(1-OLx:sNx+OLx,1-OLy:sNy+OLy,kSize,nSx,nSy)
      _RL vFld(1-OLx:sNx+OLx,1-OLy:sNy+OLy,kSize,nSx,nSy)
      INTEGER errCode
      INTEGER subIter, myIter, myThid

C     !SHARED LOCAL VARIABLES:
C     aTu, cTu, yTu :: tile edges coeff and RHS for u-component
C     aTv, cTv, yTv :: tile edges coeff and RHS for v-component
      COMMON /SOLVE_UV_3DIAG_LOCAL/
     &  aTu, cTu, yTu, aTv, cTv, yTv
      _RL aTu(2,1:sNy,nSx,nSy)
      _RL cTu(2,1:sNy,nSx,nSy)
      _RL yTu(2,1:sNy,nSx,nSy)
      _RL aTv(2,1:sNx,nSx,nSy)
      _RL cTv(2,1:sNx,nSx,nSy)
      _RL yTv(2,1:sNx,nSx,nSy)

C     !LOCAL VARIABLES:
C     == Local variables ==
      INTEGER bi, bj, bm, bp
      INTEGER i,j,k
      INTEGER ii, im, ip
      INTEGER jj, jm, jp
      _RL tmpVar
      _RL uTmp1, uTmp2, vTmp1, vTmp2
      _RL alpU(1:sNx,1:sNy,nSx,nSy)
      _RL gamU(1:sNx,1:sNy,nSx,nSy)
      _RL yy_U(1:sNx,1:sNy,nSx,nSy)
      _RL alpV(1:sNx,1:sNy,nSx,nSy)
      _RL gamV(1:sNx,1:sNy,nSx,nSy)
      _RL yy_V(1:sNx,1:sNy,nSx,nSy)
CEOP

      errCode = 0
      IF ( .NOT.solve4u .AND. .NOT.solve4v ) RETURN

C--   outside loop on level number k
      DO k = 1,kSize

       IF ( solve4u ) THEN
        DO bj=myByLo(myThid),myByHi(myThid)
         DO bi=myBxLo(myThid),myBxHi(myThid)

C--   work on local copy:
          DO j= 1,sNy
           DO i= 1,sNx
            alpU(i,j,bi,bj) = aU(i,j,k,bi,bj)
            gamU(i,j,bi,bj) = cU(i,j,k,bi,bj)
            yy_U(i,j,bi,bj) = rhsU(i,j,k,bi,bj)
           ENDDO
          ENDDO

C--   Beginning of forward sweep (i=1)
          i = 1
          DO j= 1,sNy
C-    normalise row [1] ( 1 on main diagonal)
            tmpVar = bU(i,j,k,bi,bj)
            IF ( tmpVar.NE.0. _d 0 ) THEN
             tmpVar = 1. _d 0 / tmpVar
            ELSE
             tmpVar = 0. _d 0
             errCode = 1
            ENDIF
            gamU(i,j,bi,bj) = gamU(i,j,bi,bj)*tmpVar
            alpU(i,j,bi,bj) = alpU(i,j,bi,bj)*tmpVar
            yy_U(i,j,bi,bj) = yy_U(i,j,bi,bj)*tmpVar
          ENDDO

C--   Middle of forward sweep (i=2:sNx)
          DO j= 1,sNy
           DO i= 2,sNx
            im = i-1
C-    update row [i] <-- [i] - alp_i * [i-1] and normalise (main diagonal = 1)
            tmpVar = bU(i,j,k,bi,bj) - alpU(i,j,bi,bj)*gamU(im,j,bi,bj)
            IF ( tmpVar.NE.0. _d 0 ) THEN
             tmpVar = 1. _d 0 / tmpVar
            ELSE
             tmpVar = 0. _d 0
             errCode = 1
            ENDIF
            yy_U(i,j,bi,bj) = ( yy_U(i,j,bi,bj)
     &                        - alpU(i,j,bi,bj)*yy_U(im,j,bi,bj)
     &                        )*tmpVar
            gamU(i,j,bi,bj) =   gamU(i,j,bi,bj)*tmpVar
            alpU(i,j,bi,bj) = - alpU(i,j,bi,bj)*alpU(im,j,bi,bj)*tmpVar
           ENDDO
          ENDDO

C--   Backward sweep (i=sNx-1:-1:1)
          DO j= 1,sNy
           DO ii= 1,sNx-1
            i = sNx - ii
            ip = i+1
C-    update row [i] <-- [i] - gam_i * [i+1]
            yy_U(i,j,bi,bj) =  yy_U(i,j,bi,bj)
     &                       - gamU(i,j,bi,bj)*yy_U(ip,j,bi,bj)
            alpU(i,j,bi,bj) =  alpU(i,j,bi,bj)
     &                       - gamU(i,j,bi,bj)*alpU(ip,j,bi,bj)
            gamU(i,j,bi,bj) = -gamU(i,j,bi,bj)*gamU(ip,j,bi,bj)
           ENDDO
          ENDDO

C--    At this stage, the 3-diagonal system is reduced to Identity with two
C      more columns (alp & gam) corresponding to unknow X(i=0) and X(i=sNx+1):
C                                       X_0
C         alp  1 0    ...    0 0 gam    X_1        Y_1
C         alp  0 1    ...    0 0 gam    X_2        Y_2
C
C          .   . .    ...    . .  .      .          .
C       (  .   . .    ...    . .  .  )(  .   ) = (  .   )
C          .   . .    ...    . .  .      .          .
C
C         alp  0 0    ...    1 0 gam    X_n-1      Y_n-1
C         alp  0 0    ...    0 1 gam    X_n        Y_n
C                                       X_n+1
C-----

C--   Store tile edges coeff: (1) <--> i=1 ; (2) <--> i=sNx
          DO j= 1,sNy
            aTu(1,j,bi,bj) = alpU( 1, j,bi,bj)
            cTu(1,j,bi,bj) = gamU( 1, j,bi,bj)
            yTu(1,j,bi,bj) = yy_U( 1, j,bi,bj)
            aTu(2,j,bi,bj) = alpU(sNx,j,bi,bj)
            cTu(2,j,bi,bj) = gamU(sNx,j,bi,bj)
            yTu(2,j,bi,bj) = yy_U(sNx,j,bi,bj)
          ENDDO

C     end bi,bj-loops
         ENDDO
        ENDDO

C--   Solve for tile edges values
        IF ( nPx*nPy.GT.1 .OR. useCubedSphereExchange ) THEN
          STOP 'ABNORMAL END: S/R SOLVE_UV_TRIDIAGO: missing code'
        ENDIF
        _BARRIER
        _BEGIN_MASTER(myThid)
        DO bj=1,nSy
         DO j=1,sNy

          DO bi=2,nSx
           bm = bi-1
C-    update row [1,bi] <- [1,bi] - a(1,bi)*[2,bi-1] (& normalise diag)
            tmpVar = oneRL - aTu(1,j,bi,bj)*cTu(2,j,bm,bj)
            IF ( tmpVar.NE.0. _d 0 ) THEN
             tmpVar = 1. _d 0 / tmpVar
            ELSE
             tmpVar = 0. _d 0
             errCode = 1
            ENDIF
            yTu(1,j,bi,bj) = ( yTu(1,j,bi,bj)
     &                       - aTu(1,j,bi,bj)*yTu(2,j,bm,bj)
     &                       )*tmpVar
            cTu(1,j,bi,bj) =   cTu(1,j,bi,bj)*tmpVar
            aTu(1,j,bi,bj) = - aTu(1,j,bi,bj)*aTu(2,j,bm,bj)*tmpVar

C-    update row [2,bi] <- [2,bi] - a(2,bi)*[2,bi-1] + a(2,bi)*c(2,bi-1)*[1,bi]
            tmpVar = aTu(2,j,bi,bj)*cTu(2,j,bm,bj)
            yTu(2,j,bi,bj) =  yTu(2,j,bi,bj)
     &                      - aTu(2,j,bi,bj)*yTu(2,j,bm,bj)
     &                      + tmpVar*yTu(1,j,bi,bj)
            cTu(2,j,bi,bj) =  cTu(2,j,bi,bj)
     &                      + tmpVar*cTu(1,j,bi,bj)
            aTu(2,j,bi,bj) = -aTu(2,j,bi,bj)*aTu(2,j,bm,bj)
     &                      + tmpVar*aTu(1,j,bi,bj)
          ENDDO

          DO bi=nSx-1,1,-1
           bp = bi+1
           DO i=1,2
C-    update row [1,bi] <- [1,bi] - c(1,bi)*[1,bi+1]
C-    update row [2,bi] <- [2,bi] - c(2,bi)*[1,bi+1]
            aTu(i,j,bi,bj) =  aTu(i,j,bi,bj)
     &                      - cTu(i,j,bi,bj)*aTu(1,j,bp,bj)
            yTu(i,j,bi,bj) =  yTu(i,j,bi,bj)
     &                      - cTu(i,j,bi,bj)*yTu(1,j,bp,bj)
            cTu(i,j,bi,bj) = -cTu(i,j,bi,bj)*cTu(1,j,bp,bj)
           ENDDO
          ENDDO

C--  periodic in X:  X_0 <=> X_Nx and X_(N+1) <=> X_1 ;
C    find the value at the 2 opposite location (i=1 and i=Nx)
          bm = 1
          bp = nSx
          cTu(1,j,bm,bj) = oneRL + cTu(1,j,bm,bj)
          aTu(2,j,bp,bj) = oneRL + aTu(2,j,bp,bj)
          tmpVar = cTu(1,j,bm,bj) * aTu(2,j,bp,bj)
     &           - aTu(1,j,bm,bj) * cTu(2,j,bp,bj)
          IF ( tmpVar.NE.0. _d 0 ) THEN
             tmpVar = 1. _d 0 / tmpVar
          ELSE
             tmpVar = 0. _d 0
             errCode = 1
          ENDIF
          uTmp1 = ( aTu(2,j,bp,bj) * yTu(1,j,bm,bj)
     &            - aTu(1,j,bm,bj) * yTu(2,j,bp,bj)
     &            )*tmpVar
          uTmp2 = ( cTu(1,j,bm,bj) * yTu(2,j,bp,bj)
     &            - cTu(2,j,bp,bj) * yTu(1,j,bm,bj)
     &            )*tmpVar

C-    finalise tile-edges solution (put into RHS "yTu"):
          DO bi=1,nSx
           DO i=1,2
            IF ( bi+i .EQ.2 ) THEN
             yTu(i,j,bi,bj) = uTmp1
            ELSEIF ( bi+i .EQ. nSx+2 ) THEN
             yTu(i,j,bi,bj) = uTmp2
            ELSE
             yTu(i,j,bi,bj) = yTu(i,j,bi,bj)
     &                      - aTu(i,j,bi,bj) * uTmp2
     &                      - cTu(i,j,bi,bj) * uTmp1
            ENDIF
           ENDDO
          ENDDO

         ENDDO
        ENDDO
        _END_MASTER(myThid)
        _BARRIER

        DO bj=myByLo(myThid),myByHi(myThid)
         DO bi=myBxLo(myThid),myBxHi(myThid)
          bm = 1 + MOD(bi-2+nSx,nSx)
          bp = 1 + MOD(bi-0+nSx,nSx)
          DO j= 1,sNy
           DO i= 1,sNx
            uFld(i,j,k,bi,bj) = yy_U(i,j,bi,bj)
     &                      - alpU(i,j,bi,bj) * yTu(2,j,bm,bj)
     &                      - gamU(i,j,bi,bj) * yTu(1,j,bp,bj)
           ENDDO
          ENDDO
         ENDDO
        ENDDO

C     end solve for uFld
       ENDIF

       IF ( solve4v ) THEN
        DO bj=myByLo(myThid),myByHi(myThid)
         DO bi=myBxLo(myThid),myBxHi(myThid)

C--   work on local copy:
          DO j= 1,sNy
           DO i= 1,sNx
            alpV(i,j,bi,bj) = aV(i,j,k,bi,bj)
            gamV(i,j,bi,bj) = cV(i,j,k,bi,bj)
            yy_V(i,j,bi,bj) = rhsV(i,j,k,bi,bj)
           ENDDO
          ENDDO

C--   Beginning of forward sweep (j=1)
          j = 1
          DO i= 1,sNx
C-    normalise row [1] ( 1 on main diagonal)
            tmpVar = bV(i,j,k,bi,bj)
            IF ( tmpVar.NE.0. _d 0 ) THEN
             tmpVar = 1. _d 0 / tmpVar
            ELSE
             tmpVar = 0. _d 0
             errCode = 1
            ENDIF
            gamV(i,j,bi,bj) = gamV(i,j,bi,bj)*tmpVar
            alpV(i,j,bi,bj) = alpV(i,j,bi,bj)*tmpVar
            yy_V(i,j,bi,bj) = yy_V(i,j,bi,bj)*tmpVar
          ENDDO

C--   Middle of forward sweep (j=2:sNy)
          DO i= 1,sNx
           DO j= 2,sNy
            jm = j-1
C-    update row [j] <-- [j] - alp_j * [j-1] and normalise (main diagonal = 1)
            tmpVar = bV(i,j,k,bi,bj) - alpV(i,j,bi,bj)*gamV(i,jm,bi,bj)
            IF ( tmpVar.NE.0. _d 0 ) THEN
             tmpVar = 1. _d 0 / tmpVar
            ELSE
             tmpVar = 0. _d 0
             errCode = 1
            ENDIF
            yy_V(i,j,bi,bj) = ( yy_V(i,j,bi,bj)
     &                        - alpV(i,j,bi,bj)*yy_V(i,jm,bi,bj)
     &                        )*tmpVar
            gamV(i,j,bi,bj) =   gamV(i,j,bi,bj)*tmpVar
            alpV(i,j,bi,bj) = - alpV(i,j,bi,bj)*alpV(i,jm,bi,bj)*tmpVar
           ENDDO
          ENDDO

C--   Backward sweep (j=sNy-1:-1:1)
          DO i= 1,sNx
           DO jj= 1,sNy-1
            j = sNy - jj
            jp = j+1
C-    update row [j] <-- [j] - gam_j * [j+1]
            yy_V(i,j,bi,bj) =  yy_V(i,j,bi,bj)
     &                       - gamV(i,j,bi,bj)*yy_V(i,jp,bi,bj)
            alpV(i,j,bi,bj) =  alpV(i,j,bi,bj)
     &                       - gamV(i,j,bi,bj)*alpV(i,jp,bi,bj)
            gamV(i,j,bi,bj) = -gamV(i,j,bi,bj)*gamV(i,jp,bi,bj)
           ENDDO
          ENDDO

C--    At this stage, the 3-diagonal system is reduced to Identity with two
C      more columns (alp & gam) corresponding to unknow X(j=0) and X(j=sNy+1)

C--   Store tile edges coeff: (1) <--> j=1 ; (2) <--> j=sNy
          DO i= 1,sNx
            aTv(1,i,bi,bj) = alpV(i, 1, bi,bj)
            cTv(1,i,bi,bj) = gamV(i, 1, bi,bj)
            yTv(1,i,bi,bj) = yy_V(i, 1, bi,bj)
            aTv(2,i,bi,bj) = alpV(i,sNy,bi,bj)
            cTv(2,i,bi,bj) = gamV(i,sNy,bi,bj)
            yTv(2,i,bi,bj) = yy_V(i,sNy,bi,bj)
          ENDDO

C     end bi,bj-loops
         ENDDO
        ENDDO

C--   Solve for tile edges values
        IF ( nPx*nPy.GT.1 .OR. useCubedSphereExchange ) THEN
         STOP 'ABNORMAL END: S/R SOLVE_UV_TRIDIAGO: missing code'
        ENDIF
        _BARRIER
        _BEGIN_MASTER(myThid)
        DO bi=1,nSx
         DO i=1,sNx

          DO bj=2,nSy
           bm = bj-1
C-    update row [1,bj] <- [1,bj] - a(1,bj)*[2,bj-1] (& normalise diag)
            tmpVar = oneRL - aTv(1,i,bi,bj)*cTv(2,i,bi,bm)
            IF ( tmpVar.NE.0. _d 0 ) THEN
             tmpVar = 1. _d 0 / tmpVar
            ELSE
             tmpVar = 0. _d 0
             errCode = 1
            ENDIF
            yTv(1,i,bi,bj) = ( yTv(1,i,bi,bj)
     &                       - aTv(1,i,bi,bj)*yTv(2,i,bi,bm)
     &                       )*tmpVar
            cTv(1,i,bi,bj) =   cTv(1,i,bi,bj)*tmpVar
            aTv(1,i,bi,bj) = - aTv(1,i,bi,bj)*aTv(2,i,bi,bm)*tmpVar

C-    update row [2,bj] <- [2,bj] - a(2,bj)*[2,bj-1] + a(2,bj)*c(2,bj-1)*[1,bj]
            tmpVar = aTv(2,i,bi,bj)*cTv(2,i,bi,bm)
            yTv(2,i,bi,bj) =  yTv(2,i,bi,bj)
     &                      - aTv(2,i,bi,bj)*yTv(2,i,bi,bm)
     &                      + tmpVar*yTv(1,i,bi,bj)
            cTv(2,i,bi,bj) =  cTv(2,i,bi,bj)
     &                      + tmpVar*cTv(1,i,bi,bj)
            aTv(2,i,bi,bj) = -aTv(2,i,bi,bj)*aTv(2,i,bi,bm)
     &                      + tmpVar*aTv(1,i,bi,bj)
          ENDDO

          DO bj=nSy-1,1,-1
           bp = bj+1
           DO j=1,2
C-    update row [1,bj] <- [1,bj] - c(1,bj)*[1,bj+1]
C-    update row [2,bj] <- [2,bj] - c(2,bj)*[1,bj+1]
            aTv(j,i,bi,bj) =  aTv(j,i,bi,bj)
     &                      - cTv(j,i,bi,bj)*aTv(1,i,bi,bp)
            yTv(j,i,bi,bj) =  yTv(j,i,bi,bj)
     &                      - cTv(j,i,bi,bj)*yTv(1,i,bi,bp)
            cTv(j,i,bi,bj) = -cTv(j,i,bi,bj)*cTv(1,i,bi,bp)
           ENDDO
          ENDDO

C--  periodic in Y:  X_0 <=> X_Ny and X_(N+1) <=> X_1 ;
C    find the value at the 2 opposite location (j=1 and j=Ny)
          bm = 1
          bp = nSy
          cTv(1,i,bi,bm) = oneRL + cTv(1,i,bi,bm)
          aTv(2,i,bi,bp) = oneRL + aTv(2,i,bi,bp)
          tmpVar = cTv(1,i,bi,bm) * aTv(2,i,bi,bp)
     &           - aTv(1,i,bi,bm) * cTv(2,i,bi,bp)
          IF ( tmpVar.NE.0. _d 0 ) THEN
             tmpVar = 1. _d 0 / tmpVar
          ELSE
             tmpVar = 0. _d 0
             errCode = 1
          ENDIF
          vTmp1 = ( aTv(2,i,bi,bp) * yTv(1,i,bi,bm)
     &            - aTv(1,i,bi,bm) * yTv(2,i,bi,bp)
     &            )*tmpVar
          vTmp2 = ( cTv(1,i,bi,bm) * yTv(2,i,bi,bp)
     &            - cTv(2,i,bi,bp) * yTv(1,i,bi,bm)
     &            )*tmpVar

C-    finalise tile-edges solution (put into RHS "yTv"):
          DO bj=1,nSy
           DO j=1,2
            IF ( bj+j .EQ.2 ) THEN
             yTv(j,i,bi,bj) = vTmp1
            ELSEIF ( bj+j .EQ. nSy+2 ) THEN
             yTv(j,i,bi,bj) = vTmp2
            ELSE
             yTv(j,i,bi,bj) = yTv(j,i,bi,bj)
     &                      - aTv(j,i,bi,bj) * vTmp2
     &                      - cTv(j,i,bi,bj) * vTmp1
            ENDIF
           ENDDO
          ENDDO

         ENDDO
        ENDDO
        _END_MASTER(myThid)
        _BARRIER

        DO bj=myByLo(myThid),myByHi(myThid)
         DO bi=myBxLo(myThid),myBxHi(myThid)
          bm = 1 + MOD(bj-2+nSy,nSy)
          bp = 1 + MOD(bj-0+nSy,nSy)
          DO j= 1,sNy
           DO i= 1,sNx
            vFld(i,j,k,bi,bj) = yy_V(i,j,bi,bj)
     &                      - alpV(i,j,bi,bj) * yTv(2,i,bi,bm)
     &                      - gamV(i,j,bi,bj) * yTv(1,i,bi,bp)
           ENDDO
          ENDDO
         ENDDO
        ENDDO

C     end solve for vFld
       ENDIF

C     end k-loop
      ENDDO

      RETURN
      END

#include "AUTODIFF_OPTIONS.h"
#ifdef ALLOW_CTRL
# include "CTRL_OPTIONS.h"
#endif
#ifdef ALLOW_OBCS
# include "OBCS_OPTIONS.h"
#endif
#ifdef ALLOW_SEAICE
# include "SEAICE_OPTIONS.h"
#endif
#ifdef ALLOW_EXF
# include "EXF_OPTIONS.h"
#endif

      SUBROUTINE AUTODIFF_RESTORE( myThid )

C     ==================================================================
C     SUBROUTINE autodiff_restore
C     ==================================================================
C
C     packing for checkpoint storage
C
C     started: Matt Mazloff mmazloff@mit.edu 03-May-2007
C
C     ==================================================================
C     SUBROUTINE autodiff_restore
C     ==================================================================

      IMPLICIT NONE

C     == global variables ==

#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
C**************************************
C These includes are needed for
C AD-checkpointing.
C They provide the fields to be stored.

#include "GRID.h"
#include "DYNVARS.h"
#include "FFIELDS.h"
#include "SURFACE.h"

#ifdef ALLOW_OBCS
# include "OBCS_PARAMS.h"
# include "OBCS_FIELDS.h"
# include "OBCS_SEAICE.h"
#endif
#ifdef ALLOW_EXF
# include "EXF_FIELDS.h"
# ifdef ALLOW_BULKFORMULAE
#  include "EXF_CONSTANTS.h"
# endif
#endif /* ALLOW_EXF */
#ifdef ALLOW_SEAICE
# include "SEAICE_SIZE.h"
# include "SEAICE.h"
#endif
#ifdef ALLOW_CTRL
# include "CTRL_SIZE.h"
# include "CTRL.h"
# include "CTRL_OBCS.h"
#endif
C     it is important that this file is included after SEAICE_SIZE.h
#include "AUTODIFF_STORE.h"

C     == routine arguments ==
C     myThid   :: my Thread Id number
      INTEGER myThid

#ifdef ALLOW_AUTODIFF_TAMC
C     == local variables ==
#if ( defined AUTODIFF_USE_STORE_RESTORE || \
     ( defined ALLOW_OBCS && defined AUTODIFF_USE_STORE_RESTORE_OBCS ))
      INTEGER bi, bj
      INTEGER I, J, K
#endif
C--   == end of interface ==

#ifdef ALLOW_DEBUG
      IF ( debugMode ) CALL DEBUG_ENTER('AUTODIFF_RESTORE',myThid)
#endif

#ifdef AUTODIFF_USE_STORE_RESTORE
C--   Over all tiles
      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
C-      2D arrays
        DO J=1-OLy,sNy+OLy
         DO I=1-OLx,sNx+OLx
          etaN(I,J,bi,bj)  = StoreDynVars2D(I,J,bi,bj,1)
          taux0(I,J,bi,bj) = StoreDynVars2D(I,J,bi,bj,2)
          taux1(I,J,bi,bj) = StoreDynVars2D(I,J,bi,bj,3)
          tauy0(I,J,bi,bj) = StoreDynVars2D(I,J,bi,bj,4)
          tauy1(I,J,bi,bj) = StoreDynVars2D(I,J,bi,bj,5)
          qnet0(I,J,bi,bj) = StoreDynVars2D(I,J,bi,bj,6)
          qnet1(I,J,bi,bj) = StoreDynVars2D(I,J,bi,bj,7)
          empmr0(I,J,bi,bj) = StoreDynVars2D(I,J,bi,bj,8)
          empmr1(I,J,bi,bj) = StoreDynVars2D(I,J,bi,bj,9)
          sst0(I,J,bi,bj) = StoreDynVars2D(I,J,bi,bj,10)
          sst1(I,J,bi,bj) = StoreDynVars2D(I,J,bi,bj,11)
          sss0(I,J,bi,bj) = StoreDynVars2D(I,J,bi,bj,12)
          sss1(I,J,bi,bj) = StoreDynVars2D(I,J,bi,bj,13)
          saltflux0(I,J,bi,bj) = StoreDynVars2D(I,J,bi,bj,14)
          saltflux1(I,J,bi,bj) = StoreDynVars2D(I,J,bi,bj,15)
#ifdef SHORTWAVE_HEATING
          qsw0(I,J,bi,bj)    = StoreDynVars2D(I,J,bi,bj,16)
          qsw1(I,J,bi,bj)    = StoreDynVars2D(I,J,bi,bj,17)
#endif
#ifdef ATMOSPHERIC_LOADING
          pload0(I,J,bi,bj)  = StoreDynVars2D(I,J,bi,bj,18)
          pload1(I,J,bi,bj)  = StoreDynVars2D(I,J,bi,bj,19)
#endif
          etaH(I,J,bi,bj)    = StoreDynVars2D(I,J,bi,bj,20)
          dEtaHdt(I,J,bi,bj) = StoreDynVars2D(I,J,bi,bj,21)
          PmEpR(I,J,bi,bj)   = StoreDynVars2D(I,J,bi,bj,22)
         ENDDO
        ENDDO
       ENDDO
      ENDDO

C--   Over all tiles
      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
C-      3D arrays
        DO K=1,Nr
         DO J=1-OLy,sNy+OLy
          DO I=1-OLx,sNx+OLx
#ifdef ALLOW_ADAMSBASHFORTH_3
           gtNm(I,J,K,bi,bj,1)   = StoreDynVars3D(I,J,K,bi,bj,1)
           gsNm(I,J,K,bi,bj,1)   = StoreDynVars3D(I,J,K,bi,bj,2)
           guNm(I,J,K,bi,bj,1)   = StoreDynVars3D(I,J,K,bi,bj,3)
           gvNm(I,J,K,bi,bj,1)   = StoreDynVars3D(I,J,K,bi,bj,4)
#else
           gtNm1(I,J,K,bi,bj)    = StoreDynVars3D(I,J,K,bi,bj,1)
           gsNm1(I,J,K,bi,bj)    = StoreDynVars3D(I,J,K,bi,bj,2)
           guNm1(I,J,K,bi,bj)    = StoreDynVars3D(I,J,K,bi,bj,3)
           gvNm1(I,J,K,bi,bj)    = StoreDynVars3D(I,J,K,bi,bj,4)
#endif
           theta(I,J,K,bi,bj)    = StoreDynVars3D(I,J,K,bi,bj,5)
           salt(I,J,K,bi,bj)     = StoreDynVars3D(I,J,K,bi,bj,6)
           uVel(I,J,K,bi,bj)     = StoreDynVars3D(I,J,K,bi,bj,7)
           vVel(I,J,K,bi,bj)     = StoreDynVars3D(I,J,K,bi,bj,8)
           wVel(I,J,K,bi,bj)     = StoreDynVars3D(I,J,K,bi,bj,9)
           totPhiHyd(I,J,K,bi,bj)= StoreDynVars3D(I,J,K,bi,bj,10)
#ifdef ALLOW_ADAMSBASHFORTH_3
           gtNm(I,J,K,bi,bj,2)   = StoreDynVars3D(I,J,K,bi,bj,11)
           gsNm(I,J,K,bi,bj,2)   = StoreDynVars3D(I,J,K,bi,bj,12)
           guNm(I,J,K,bi,bj,2)   = StoreDynVars3D(I,J,K,bi,bj,13)
           gvNm(I,J,K,bi,bj,2)   = StoreDynVars3D(I,J,K,bi,bj,14)
#endif
          ENDDO
         ENDDO
        ENDDO
       ENDDO
      ENDDO

#ifdef ALLOW_EXF
C--   Over all tiles
      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
C-      2D arrays
         DO J=1-OLy,sNy+OLy
          DO I=1-OLx,sNx+OLx
          hflux0(I,J,bi,bj)            = StoreEXF1(I,J,bi,bj,1)
          hflux1(I,J,bi,bj)            = StoreEXF1(I,J,bi,bj,2)
          sflux0(I,J,bi,bj)            = StoreEXF1(I,J,bi,bj,3)
          sflux1(I,J,bi,bj)            = StoreEXF1(I,J,bi,bj,4)
          ustress0(I,J,bi,bj)          = StoreEXF1(I,J,bi,bj,5)
          ustress1(I,J,bi,bj)          = StoreEXF1(I,J,bi,bj,6)
          vstress0(I,J,bi,bj)          = StoreEXF1(I,J,bi,bj,7)
          vstress1(I,J,bi,bj)          = StoreEXF1(I,J,bi,bj,8)
          wspeed0(I,J,bi,bj)           = StoreEXF1(I,J,bi,bj,9)
          wspeed1(I,J,bi,bj)           = StoreEXF1(I,J,bi,bj,10)
# ifdef SHORTWAVE_HEATING
          swflux0(I,J,bi,bj)           = StoreEXF1(I,J,bi,bj,11)
          swflux1(I,J,bi,bj)           = StoreEXF1(I,J,bi,bj,12)
# endif
# ifdef ALLOW_RUNOFF
          runoff0(I,J,bi,bj)           = StoreEXF1(I,J,bi,bj,13)
          runoff1(I,J,bi,bj)           = StoreEXF1(I,J,bi,bj,14)
# endif
# ifdef ATMOSPHERIC_LOADING
          apressure0(I,J,bi,bj)        = StoreEXF1(I,J,bi,bj,15)
          apressure1(I,J,bi,bj)        = StoreEXF1(I,J,bi,bj,16)
          siceload(I,J,bi,bj)          = StoreEXF1(I,J,bi,bj,17)
# endif
# ifdef ALLOW_CLIMSSS_RELAXATION
          climsss0(I,J,bi,bj)          = StoreEXF1(I,J,bi,bj,18)
          climsss1(I,J,bi,bj)          = StoreEXF1(I,J,bi,bj,19)
# endif
# ifdef ALLOW_CLIMSST_RELAXATION
          climsst0(I,J,bi,bj)          = StoreEXF1(I,J,bi,bj,20)
          climsst1(I,J,bi,bj)          = StoreEXF1(I,J,bi,bj,21)
# endif
# ifdef ALLOW_SALTFLX
          saltflx0(I,J,bi,bj)          = StoreEXF1(I,J,bi,bj,22)
          saltflx1(I,J,bi,bj)          = StoreEXF1(I,J,bi,bj,23)
# endif
         ENDDO
        ENDDO
       ENDDO
      ENDDO

C--   Over all tiles
      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
C-      2D arrays
        DO J=1-OLy,sNy+OLy
         DO I=1-OLx,sNx+OLx
# ifdef ALLOW_ATM_TEMP
          aqh0(I,J,bi,bj)            = StoreEXF2(I,J,bi,bj,1)
          aqh1(I,J,bi,bj)            = StoreEXF2(I,J,bi,bj,2)
          atemp0(I,J,bi,bj)          = StoreEXF2(I,J,bi,bj,3)
          atemp1(I,J,bi,bj)          = StoreEXF2(I,J,bi,bj,4)
          precip0(I,J,bi,bj)         = StoreEXF2(I,J,bi,bj,5)
          precip1(I,J,bi,bj)         = StoreEXF2(I,J,bi,bj,6)
          lwflux0(I,J,bi,bj)         = StoreEXF2(I,J,bi,bj,7)
          lwflux1(I,J,bi,bj)         = StoreEXF2(I,J,bi,bj,8)
          snowprecip0(I,J,bi,bj)     = StoreEXF2(I,J,bi,bj,9)
          snowprecip1(I,J,bi,bj)     = StoreEXF2(I,J,bi,bj,10)
#  ifdef ALLOW_READ_TURBFLUXES
          hs0(I,J,bi,bj)             = StoreEXF2(I,J,bi,bj,11)
          hs1(I,J,bi,bj)             = StoreEXF2(I,J,bi,bj,12)
          hl0(I,J,bi,bj)             = StoreEXF2(I,J,bi,bj,13)
          hl1(I,J,bi,bj)             = StoreEXF2(I,J,bi,bj,14)
#  endif /* ALLOW_READ_TURBFLUXES */
#  ifdef EXF_READ_EVAP
          evap0(I,J,bi,bj)           = StoreEXF2(I,J,bi,bj,15)
          evap1(I,J,bi,bj)           = StoreEXF2(I,J,bi,bj,16)
#  else
          evap(I,J,bi,bj)            = StoreEXF2(I,J,bi,bj,15)
#  endif /* EXF_READ_EVAP */
#  ifdef ALLOW_DOWNWARD_RADIATION
          swdown0(I,J,bi,bj)         = StoreEXF2(I,J,bi,bj,17)
          swdown1(I,J,bi,bj)         = StoreEXF2(I,J,bi,bj,18)
          lwdown0(I,J,bi,bj)         = StoreEXF2(I,J,bi,bj,19)
          lwdown1(I,J,bi,bj)         = StoreEXF2(I,J,bi,bj,20)
#  endif
# endif /* ALLOW_ATM_TEMP */
          uwind0(I,J,bi,bj)          = StoreEXF2(I,J,bi,bj,21)
          uwind1(I,J,bi,bj)          = StoreEXF2(I,J,bi,bj,22)
          vwind0(I,J,bi,bj)          = StoreEXF2(I,J,bi,bj,23)
          vwind1(I,J,bi,bj)          = StoreEXF2(I,J,bi,bj,24)
         ENDDO
        ENDDO
       ENDDO
      ENDDO
#endif /* ALLOW_EXF */

#ifdef ALLOW_SEAICE
C--   Over all tiles
      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
C-      2D arrays
        DO J=1-OLy,sNy+OLy
         DO I=1-OLx,sNx+OLx
          AREA  (I,J,bi,bj)            = StoreSEAICE(I,J,bi,bj, 1)
          HEFF  (I,J,bi,bj)            = StoreSEAICE(I,J,bi,bj, 2)
          HSNOW (I,J,bi,bj)            = StoreSEAICE(I,J,bi,bj, 3)
          RUNOFF(I,J,bi,bj)            = StoreSEAICE(I,J,bi,bj, 4)
          UICE  (I,J,bi,bj)            = StoreSEAICE(I,J,bi,bj, 5)
          VICE  (I,J,bi,bj)            = StoreSEAICE(I,J,bi,bj, 6)
          ZETA  (I,J,bi,bj)            = StoreSEAICE(I,J,bi,bj, 7)
          ETA   (I,J,bi,bj)            = StoreSEAICE(I,J,bi,bj, 8)
# ifdef SEAICE_CGRID
          dwatn(I,J,bi,bj)             = StoreSEAICE(I,J,bi,bj, 9)
#  ifdef SEAICE_ALLOW_BOTTOMDRAG
          cbotc(I,J,bi,bj)             = StoreSEAICE(I,J,bi,bj,10)
#  endif /* SEAICE_ALLOW_BOTTOMDRAG */
          stressDivergenceX(I,J,bi,bj) = StoreSEAICE(I,J,bi,bj,11)
          stressDivergenceY(I,J,bi,bj) = StoreSEAICE(I,J,bi,bj,12)
# endif /* SEAICE_CGRID */
# ifdef SEAICE_ALLOW_EVP
          seaice_sigma1    (I,J,bi,bj) = StoreSEAICE(I,J,bi,bj,13)
          seaice_sigma2    (I,J,bi,bj) = StoreSEAICE(I,J,bi,bj,14)
          seaice_sigma12   (I,J,bi,bj) = StoreSEAICE(I,J,bi,bj,15)
# endif /* SEAICE_ALLOW_EVP */
# ifdef SEAICE_VARIABLE_SALINITY
          HSALT            (I,J,bi,bj) = StoreSEAICE(I,J,bi,bj,16)
# endif
         ENDDO
        ENDDO
C--   this 3D array comes last because it has a variable size nITD
        DO K=1,nITD
         DO J=1-OLy,sNy+OLy
          DO I=1-OLx,sNx+OLx
           TICES(I,J,K,bi,bj) = StoreSEAICE(I,J,bi,bj,16+K)
          ENDDO
         ENDDO
        ENDDO
C
       ENDDO
      ENDDO
#endif /* ALLOW_SEAICE */

#endif /* AUTODIFF_USE_STORE_RESTORE */

#if ( defined ALLOW_OBCS && defined AUTODIFF_USE_STORE_RESTORE_OBCS )
# ifdef ALLOW_OBCS_NORTH
C--   Over all tiles
      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
C-      2D arrays
        DO K=1,Nr
         DO I=1-OLx,sNx+OLx
          OBNu(I,K,bi,bj)    = StoreOBCSN(I,K,bi,bj,1)
          OBNv(I,K,bi,bj)    = StoreOBCSN(I,K,bi,bj,2)
          OBNt(I,K,bi,bj)    = StoreOBCSN(I,K,bi,bj,3)
          OBNs(I,K,bi,bj)    = StoreOBCSN(I,K,bi,bj,4)
#  ifdef ALLOW_OBCS_PRESCRIBE
          OBNu0(I,K,bi,bj)   = StoreOBCSN(I,K,bi,bj,5)
          OBNv0(I,K,bi,bj)   = StoreOBCSN(I,K,bi,bj,6)
          OBNt0(I,K,bi,bj)   = StoreOBCSN(I,K,bi,bj,7)
          OBNs0(I,K,bi,bj)   = StoreOBCSN(I,K,bi,bj,8)
          OBNu1(I,K,bi,bj)   = StoreOBCSN(I,K,bi,bj,9)
          OBNv1(I,K,bi,bj)   = StoreOBCSN(I,K,bi,bj,10)
          OBNt1(I,K,bi,bj)   = StoreOBCSN(I,K,bi,bj,11)
          OBNs1(I,K,bi,bj)   = StoreOBCSN(I,K,bi,bj,12)
#  endif
#  ifdef ALLOW_OBCSN_CONTROL
          xx_obcsn0(I,K,bi,bj,1)   = StoreOBCSN(I,K,bi,bj,13)
          xx_obcsn0(I,K,bi,bj,2)   = StoreOBCSN(I,K,bi,bj,14)
          xx_obcsn0(I,K,bi,bj,3)   = StoreOBCSN(I,K,bi,bj,15)
          xx_obcsn0(I,K,bi,bj,4)   = StoreOBCSN(I,K,bi,bj,16)
          xx_obcsn1(I,K,bi,bj,1)   = StoreOBCSN(I,K,bi,bj,17)
          xx_obcsn1(I,K,bi,bj,2)   = StoreOBCSN(I,K,bi,bj,18)
          xx_obcsn1(I,K,bi,bj,3)   = StoreOBCSN(I,K,bi,bj,19)
          xx_obcsn1(I,K,bi,bj,4)   = StoreOBCSN(I,K,bi,bj,20)
#  endif
         ENDDO
        ENDDO
       ENDDO
      ENDDO
# endif /* ALLOW_OBCS_NORTH */

# ifdef ALLOW_OBCS_SOUTH
C--   Over all tiles
      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
C-      2D arrays
        DO K=1,Nr
         DO I=1-OLx,sNx+OLx
          OBSu(I,K,bi,bj)       = StoreOBCSS(I,K,bi,bj,1)
          OBSv(I,K,bi,bj)       = StoreOBCSS(I,K,bi,bj,2)
          OBSt(I,K,bi,bj)       = StoreOBCSS(I,K,bi,bj,3)
          OBSs(I,K,bi,bj)       = StoreOBCSS(I,K,bi,bj,4)
#  ifdef ALLOW_OBCS_PRESCRIBE
          OBSu0(I,K,bi,bj)      = StoreOBCSS(I,K,bi,bj,5)
          OBSv0(I,K,bi,bj)      = StoreOBCSS(I,K,bi,bj,6)
          OBSt0(I,K,bi,bj)      = StoreOBCSS(I,K,bi,bj,7)
          OBSs0(I,K,bi,bj)      = StoreOBCSS(I,K,bi,bj,8)
          OBSu1(I,K,bi,bj)      = StoreOBCSS(I,K,bi,bj,9)
          OBSv1(I,K,bi,bj)      = StoreOBCSS(I,K,bi,bj,10)
          OBSt1(I,K,bi,bj)      = StoreOBCSS(I,K,bi,bj,11)
          OBSs1(I,K,bi,bj)      = StoreOBCSS(I,K,bi,bj,12)
#  endif
#  ifdef ALLOW_OBCSS_CONTROL
          xx_obcss0(I,K,bi,bj,1)   = StoreOBCSS(I,K,bi,bj,13)
          xx_obcss0(I,K,bi,bj,2)   = StoreOBCSS(I,K,bi,bj,14)
          xx_obcss0(I,K,bi,bj,3)   = StoreOBCSS(I,K,bi,bj,15)
          xx_obcss0(I,K,bi,bj,4)   = StoreOBCSS(I,K,bi,bj,16)
          xx_obcss1(I,K,bi,bj,1)   = StoreOBCSS(I,K,bi,bj,17)
          xx_obcss1(I,K,bi,bj,2)   = StoreOBCSS(I,K,bi,bj,18)
          xx_obcss1(I,K,bi,bj,3)   = StoreOBCSS(I,K,bi,bj,19)
          xx_obcss1(I,K,bi,bj,4)   = StoreOBCSS(I,K,bi,bj,20)
#  endif
         ENDDO
        ENDDO
       ENDDO
      ENDDO
# endif /* ALLOW_OBCS_SOUTH */

# ifdef ALLOW_OBCS_EAST
C--   Over all tiles
      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
C-      2D arrays
        DO K=1,Nr
         DO J=1-OLy,sNy+OLy
          OBEu(J,K,bi,bj)      = StoreOBCSE(J,K,bi,bj,1)
          OBEv(J,K,bi,bj)      = StoreOBCSE(J,K,bi,bj,2)
          OBEt(J,K,bi,bj)      = StoreOBCSE(J,K,bi,bj,3)
          OBEs(J,K,bi,bj)      = StoreOBCSE(J,K,bi,bj,4)
#  ifdef ALLOW_OBCS_PRESCRIBE
          OBEu0(J,K,bi,bj)     = StoreOBCSE(J,K,bi,bj,5)
          OBEv0(J,K,bi,bj)     = StoreOBCSE(J,K,bi,bj,6)
          OBEt0(J,K,bi,bj)     = StoreOBCSE(J,K,bi,bj,7)
          OBEs0(J,K,bi,bj)     = StoreOBCSE(J,K,bi,bj,8)
          OBEu1(J,K,bi,bj)     = StoreOBCSE(J,K,bi,bj,9)
          OBEv1(J,K,bi,bj)     = StoreOBCSE(J,K,bi,bj,10)
          OBEt1(J,K,bi,bj)     = StoreOBCSE(J,K,bi,bj,11)
          OBEs1(J,K,bi,bj)     = StoreOBCSE(J,K,bi,bj,12)
#  endif
#  ifdef ALLOW_OBCSE_CONTROL
          xx_obcse0(J,K,bi,bj,1)     = StoreOBCSE(J,K,bi,bj,13)
          xx_obcse0(J,K,bi,bj,2)     = StoreOBCSE(J,K,bi,bj,14)
          xx_obcse0(J,K,bi,bj,3)     = StoreOBCSE(J,K,bi,bj,15)
          xx_obcse0(J,K,bi,bj,4)     = StoreOBCSE(J,K,bi,bj,16)
          xx_obcse1(J,K,bi,bj,1)     = StoreOBCSE(J,K,bi,bj,17)
          xx_obcse1(J,K,bi,bj,2)     = StoreOBCSE(J,K,bi,bj,18)
          xx_obcse1(J,K,bi,bj,3)     = StoreOBCSE(J,K,bi,bj,19)
          xx_obcse1(J,K,bi,bj,4)     = StoreOBCSE(J,K,bi,bj,20)
#  endif
          ENDDO
        ENDDO
       ENDDO
      ENDDO
# endif /* ALLOW_OBCS_EAST */

# ifdef ALLOW_OBCS_WEST
C--   Over all tiles
      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
C-      2D arrays
        DO K=1,Nr
         DO J=1-OLy,sNy+OLy
          OBWu(J,K,bi,bj)      = StoreOBCSW(J,K,bi,bj,1)
          OBWv(J,K,bi,bj)      = StoreOBCSW(J,K,bi,bj,2)
          OBWt(J,K,bi,bj)      = StoreOBCSW(J,K,bi,bj,3)
          OBWs(J,K,bi,bj)      = StoreOBCSW(J,K,bi,bj,4)
#  ifdef ALLOW_OBCS_PRESCRIBE
          OBWu0(J,K,bi,bj)     = StoreOBCSW(J,K,bi,bj,5)
          OBWv0(J,K,bi,bj)     = StoreOBCSW(J,K,bi,bj,6)
          OBWt0(J,K,bi,bj)     = StoreOBCSW(J,K,bi,bj,7)
          OBWs0(J,K,bi,bj)     = StoreOBCSW(J,K,bi,bj,8)
          OBWu1(J,K,bi,bj)     = StoreOBCSW(J,K,bi,bj,9)
          OBWv1(J,K,bi,bj)     = StoreOBCSW(J,K,bi,bj,10)
          OBWt1(J,K,bi,bj)     = StoreOBCSW(J,K,bi,bj,11)
          OBWs1(J,K,bi,bj)     = StoreOBCSW(J,K,bi,bj,12)
#  endif
#  ifdef ALLOW_OBCSW_CONTROL
          xx_obcsw0(J,K,bi,bj,1) = StoreOBCSW(J,K,bi,bj,13)
          xx_obcsw0(J,K,bi,bj,2) = StoreOBCSW(J,K,bi,bj,14)
          xx_obcsw0(J,K,bi,bj,3) = StoreOBCSW(J,K,bi,bj,15)
          xx_obcsw0(J,K,bi,bj,4) = StoreOBCSW(J,K,bi,bj,16)
          xx_obcsw1(J,K,bi,bj,1) = StoreOBCSW(J,K,bi,bj,17)
          xx_obcsw1(J,K,bi,bj,2) = StoreOBCSW(J,K,bi,bj,18)
          xx_obcsw1(J,K,bi,bj,3) = StoreOBCSW(J,K,bi,bj,19)
          xx_obcsw1(J,K,bi,bj,4) = StoreOBCSW(J,K,bi,bj,20)
#  endif
          ENDDO
        ENDDO
       ENDDO
      ENDDO
# endif /* ALLOW_OBCS_WEST */
#endif /* ALLOW_OBCS & AUTODIFF_USE_STORE_RESTORE_OBCS */

#ifdef ALLOW_DEBUG
      IF ( debugMode ) CALL DEBUG_LEAVE('AUTODIFF_RESTORE',myThid)
#endif

#endif /* ALLOW_AUTODIFF_TAMC */
C**************************************

      RETURN
      END

#include "PROFILES_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C !ROUTINE: PROFILES_INI_IO

C !INTERFACE:
      SUBROUTINE PROFILES_INI_IO( myThid )

C     !DESCRIPTION:
C     Create directory for profiles output if needed

C     !USES:
      IMPLICIT NONE
C     == Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "EESUPPORT.h"
#include "PARAMS.h"
#include "PROFILES_SIZE.h"
#include "profiles.h"

C     !INPUT/OUTPUT PARAMETERS:
C     myThid: my thread ID number
      INTEGER myThid
CEOP

C     !FUNCTIONS:
      INTEGER  ILNBLNK
      EXTERNAL ILNBLNK

C     !LOCAL VARIABLES:
#ifndef HAVE_SYSTEM
      CHARACTER*(MAX_LEN_MBUF) msgBuf
#endif
      CHARACTER*(MAX_LEN_FNAM) namBuf
      INTEGER iL, pIL

      _BEGIN_MASTER( myThid )

      IF (profilesDir .NE. ' ') THEN
        iL = ILNBLNK( profilesDir )
C Append "/", if necessary
        IF (iL.LT.MAX_LEN_FNAM .AND. profilesDir(iL:iL).NE.'/') THEN
          namBuf(1:iL) = profilesDir(1:iL)
          WRITE(profilesDir(1:iL+1),'(2A)') namBuf(1:iL),'/'
        ENDIF
#ifdef HAVE_SYSTEM
C Create directory
        iL = ILNBLNK( profilesDir ) -1
        WRITE(namBuf,'(2A)') ' mkdir -p ', profilesDir(1:iL)
        pIL = 1 + ILNBLNK( namBuf )
        WRITE(standardMessageUnit,'(3A)')
     &  '==> SYSTEM CALL (from PROFILES_INI_IO): >',namBuf(1:pIL),'<'
        CALL SYSTEM( namBuf(1:pIL) )
#else
        WRITE(msgBuf,'(2A)') '** WARNING ** PROFILES_INI_IO: cannot ',
     &   'call mkdir -> please create profilesDir manually'
        CALL PRINT_MESSAGE( msgBuf,
     &       errorMessageUnit, SQUEEZE_RIGHT, myThid )
#endif
      ENDIF

      _END_MASTER( myThid )

      RETURN
      END

#include "CPP_OPTIONS.h"

CBOP
C !ROUTINE: CONVECTIVE_WEIGHTS
C !INTERFACE:
      SUBROUTINE CONVECTIVE_WEIGHTS(
     I                              bi, bj, k, rhoKm1, rhoK,
     O                              weightA, weightB, convectCount,
     I                              myThid )

C !DESCRIPTION:
C Calculates the weights used to represent convective mixing
C between two layers.
C
C Mixing is represented by:
C                       T(k-1) = T(k-1) + A * ( T(k) - T(k-1) )
C                       T(k)   = T(k)   + B * ( T(k-1) - T(k) )
C
C In the stable case, A = B = 0
C In the unstable case, A and B are non-zero and are chosen so as to
C conserve total volume of T.

C !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"

C !INPUT/OUTPUT PARAMETERS:
C     bi,bj,k :: indices
C     rhoKm1  :: rho in level k-1
C     rhoK    :: rho in level  k
C     weightA :: weight for tracer @ level k-1
C     weightB :: weight for tracer @ level  k
C     convectCount :: counter to diagnose where convection occurs
C     myThid  :: my Thread Id number
      INTEGER bi,bj,k
      _RL rhoKm1 (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL rhoK   (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL weightA(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL weightB(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL convectCount(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      INTEGER myThid

#if (defined INCLUDE_CONVECT_CALL || defined INCLUDE_CONVECT_INI_CALL)

C !LOCAL VARIABLES:
C     i,j      :: Loop counter
C     dS,d1,d2 :: Layer thicknesses
      INTEGER i,j
      _RL dS,d1,d2
CEOP

      DO j=1-OLy,sNy+OLy
       DO i=1-OLx,sNx+OLx
         IF ( _hFacC(i,j,k-1,bi,bj)* _hFacC(i,j,k,bi,bj) .GT. 0. .AND.
     &        (rhok(i,j)-rhokm1(i,j))*rkSign*gravitySign .LT. 0.
     &      ) THEN

C      Where statically unstable, mix the tracers conserving volume
          d1 = _hFacC(i,j,k-1,bi,bj)*drF(k-1)
          d2 = _hFacC(i,j, k ,bi,bj)*drF( k )
          dS = d1+d2
          weightA(i,j) = d2/dS
          weightB(i,j) = d1/dS
          convectCount(i,j,k) = 1.
         ELSE
C      Where statically stable, do nothing
          weightA(i,j) = 0.
          weightB(i,j) = 0.
          convectCount(i,j,k) = 0.
         ENDIF
       ENDDO
      ENDDO

#endif /* INCLUDE_CONVECT_CALL or INCLUDE_CONVECT_INI_CALL */

      RETURN
      END

#include "CAL_OPTIONS.h"

      INTEGER FUNCTION CAL_ISLEAP(
     I                             year,
     I                             myThid )

C     ==================================================================
C     FUNCTION cal_IsLeap
C     ==================================================================
C
C     o In case the Gregorian calendar is used determine whether the
C       given year is a leap year or not.
C
C     started: Christian Eckert eckert@mit.edu  30-Jun-1999
C     changed: Christian Eckert eckert@mit.edu  29-Dec-1999
C              - restructured the original version in order to have a
C                better interface to the MITgcmUV.
C              Christian Eckert eckert@mit.edu  03-Feb-2000
C              - Introduced new routine and function names, cal_<NAME>,
C                for verion 0.1.3.
C
C     ==================================================================
C     FUNCTION cal_IsLeap
C     ==================================================================

      IMPLICIT NONE

C     == global variables ==
#include "EEPARAMS.h"
#include "cal.h"

C     == routine arguments ==
      INTEGER year
      INTEGER myThid

C     == local variables ==
      CHARACTER*(MAX_LEN_MBUF) msgBuf
C     == end of interface ==

      IF ( cal_setStatus .LT. 1 ) THEN
        WRITE( msgBuf,'(A,2(A,I9))')  'CAL_ISLEAP: ',
     &          'year=', year
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE( msgBuf,'(2A,I2,A)') 'CAL_ISLEAP: ',
     &    'called too early (cal_setStatus=',cal_setStatus,' )'
        CALL PRINT_ERROR( msgBuf, myThid )
        STOP 'ABNORMAL END: FUNCTION CAL_ISLEAP'
      ENDIF

      if ( usingGregorianCalendar ) then
        if ( mod(year,4) .ne. 0 ) then
          cal_IsLeap = 1
        else
          cal_IsLeap = 2
          if ( (mod(year,100) .eq. 0)  .and.
     &         (mod(year,400) .ne. 0) ) then
            cal_IsLeap = 1
          endif
        endif
      else if ( usingJulianCalendar ) then
        if ( mod(year,4) .ne. 0 ) then
          cal_IsLeap = 1
        else
          cal_IsLeap = 2
        endif
      else
       cal_IsLeap = 1
      endif

      RETURN
      END

program cvfloat
   !
   !=======================================================================
   !
   !     converts binary float trajectories to netCDF
   !
   !=======================================================
   !
   !     * uses namelist data.float
   !
   !     Arne Biastoch, abiastoch@ucsd.edu, 11/16/2000
   !     Updated 03/16/2009 Christopher Wolfe, clwolfe@ucsd.edu
   !
   !=======================================================================
   !
   use netcdf
   implicit none
   integer, parameter :: STDIN = 5, STDOUT = 6, STDERR = 6
   
   character(80) :: iotext
   character(32) :: stamp
   integer :: ioun,iargc,m,n,ilen,irec,ip,np
   integer :: icount,itotalrecord,imaxrecord

   ! tile counters
   integer :: iGmax,jGmax,iG,jG

   ! variables for filenames
   integer :: narg, npart
   character(80) :: dataFName
   logical :: exst

   ! number of variables per record
   integer, parameter :: IMAX = 13
   !
   !      integer narg
   logical preflag
   !
   ! netCDF ids
   !
   integer :: ncid
   integer :: partdim,Timedim
   integer :: partid, Timeid
   integer :: xpartid, ypartid, zpartid
   integer :: ipartid, jpartid, kpartid
   integer  tempid, saltid, uvelid, vvelid, presid
   !
   ! attribute vectors
   !
   character(24) :: name*24
   character(16) :: unit*16
   ! 
   ! data variables for NetCDF
   !
   double precision :: rcountstart, rcountdelta
   double precision, dimension(:),   allocatable :: pnum,time
   double precision, dimension(:,:), allocatable :: xpart,ypart,zpart, &
                                                   ipart,jpart,kpart, &
                                                   pres,uvel,vvel,temp,salt
   double precision, dimension(:), allocatable ::  tmp
   !
   ! namelist contains
   !
   character(50) :: outname2, fName="float_trajectories", outname
   character(20) :: startDate="01-JAN-1992:12:00:00"
   character(60) :: expnam = "Experiment name not set"
   logical :: usingSphericalPolarGrid=.true.
   
   namelist /dimensions/ expnam, startDate, usingSphericalPolarGrid
   namelist /floats/ fName

   ioun=11
   open(ioun,file="data.float",status="old",form="formatted")
   read  (unit=ioun, end=666, nml=dimensions)
   write (STDOUT,dimensions)
   close (ioun)
666  continue
   open(ioun,file="data.float",status="old",form="formatted")
   read  (unit=ioun, end=999, nml=floats)
   write (STDOUT,floats)
   close (ioun)
999  continue

   !
   !     PRELIMINARY USE:
   !     IF FLOATS SHOULD BE VIEWED DURING A CURRENT MODEL RUN THE FIRST
   !     LINE OF THE FILE MAY NOT BE UPDATED CORRECTLY, I.E. THERE MIGHT
   !     BE MORE TIMES THAN STATED AT THE BEGINNING. BY GIVING A FLAG
   !     ONLY ICOUNT-1 TIMESTEPS ARE USED
   !
   preflag = .false.
   narg=iargc()
   if ( narg > 0 ) preflag = .true.
   !
   ! check existent files
   !
   iGmax=1
   do m=1,100
      write(dataFname(1:80),"(2a,i3.3,a,i3.3,a)") trim(fName),".",iGmax,".",1,".data"
      inquire( file=dataFname, exist=exst )
      if (exst)  iGmax = iGmax + 1
   enddo
   
   jGmax=1
   do m=1,100
      write(dataFname(1:80),"(2a,i3.3,a,i3.3,a)") trim(fName),".",1,".",jGmax,".data"
      inquire( file=dataFname, exist=exst )
      if (exst)  jGmax = jGmax + 1
   enddo
   
   iGmax = iGmax - 1
   jGmax = jGmax - 1
   print*, "There are ",iGmax," x ",jGmax," files"

   ! open first file and get dimensions (float number and time)
   ilen=IMAX*8
   allocate (tmp(IMAX))

   write(dataFname(1:80),"(2a,a)") trim(fName),".001.001.data"
   open(1,file=dataFname,status="old",form="unformatted",access="direct",recl=ilen)
   
   read(1,rec=1) tmp
!   print*,"tmp:", tmp
   
   rcountstart = tmp(2)
   rcountdelta = tmp(4)
   icount      = INT(tmp(5))
   npart       = INT(tmp(6))
   close(1)
   
   print*, "npart    = ",npart
   print*, "timesteps= ",icount
!    print*,"rcountstart=",rcountstart,"rcountdelta",rcountdelta
   if (preflag) then
      icount=icount-1
      print*, "preliminary --> use timesteps= ",icount
   endif

   !-----------------------------------------------------------------------
   !     allocate variables
   !-----------------------------------------------------------------------
   !
   allocate (pnum(npart))
   allocate (time(icount))
   allocate (xpart(npart,icount))
   allocate (ypart(npart,icount))
   allocate (zpart(npart,icount))
   allocate (ipart(npart,icount))
   allocate (jpart(npart,icount))
   allocate (kpart(npart,icount))
   allocate (uvel(npart,icount))
   allocate (vvel(npart,icount))
   allocate (temp(npart,icount))
   allocate (salt(npart,icount))
   allocate (pres(npart,icount))

   ! initialize arrays
   !
   do m=1,npart
      do n=1,icount
         xpart(m,n) = NF90_FILL_DOUBLE
         ypart(m,n) = NF90_FILL_DOUBLE
         zpart(m,n) = NF90_FILL_DOUBLE
         ipart(m,n) = NF90_FILL_DOUBLE
         jpart(m,n) = NF90_FILL_DOUBLE
         kpart(m,n) = NF90_FILL_DOUBLE
         uvel(m,n) = NF90_FILL_DOUBLE
         vvel(m,n) = NF90_FILL_DOUBLE
         temp(m,n) = NF90_FILL_DOUBLE
         salt(m,n) = NF90_FILL_DOUBLE
         pres(m,n) = NF90_FILL_DOUBLE
      enddo
   enddo

   ! generate axes
   !
   time(1)=rcountstart
   do m=2,icount
      time(m) = time(m-1)+rcountdelta
   enddo
   print*, "time: ",time(1:icount)
   
   do ip=1,npart
      pnum(ip) = FLOAT(ip)
   enddo
   !
   !-----------------------------------------------------------------------
   !     open files and read input
   !-----------------------------------------------------------------------
   !

   itotalrecord = 0
   
   do iG=1,iGmax
      do jG=1,jGmax
   
         write(dataFname(1:80),"(2a,i3.3,a,i3.3,a)") trim(fName),".",iG,".",jG,".data"
         open(1,file=dataFname,status="old",form="unformatted",access="direct",recl=ilen)
   
         read(1,rec=1) tmp
         imaxrecord = INT(tmp(1))
         print "(1x,2a)","read ",dataFname
         itotalrecord = itotalrecord + imaxrecord
   
         do irec=2,imaxrecord+1
   
            read(1,rec=irec) tmp
            ip = INT(tmp(1))
            if (ip > npart) then
               print*,"ip out of order: ",ip,npart
               stop
            endif
            
            ! Note: If the float initial conditions are also written to the data files the time interval
            ! between record 1 and 2 may be somewhat less than rcountdelta. The +0.9999 deals with
            ! this case without upsetting the rest of the indexing.
            np = INT((tmp(2)-rcountstart)/rcountdelta + 1 + 0.9999)
   
            ! this is only for prelimiray results. Use only icount-1 timesteps
            if (preflag .and. (np > icount .or. np < 1)) cycle
   
            if (usingSphericalPolarGrid) then
               xpart(ip,np)  = tmp(3)
               ypart(ip,np)  = tmp(4)
            else
               xpart(ip,np)  = tmp(3)
               ypart(ip,np)  = tmp(4)
            endif
            zpart(ip,np)  = tmp(5)
            ipart(ip,np)  = tmp(6)
            jpart(ip,np)  = tmp(7)
            kpart(ip,np)  = tmp(8)
            pres(ip,np)   = tmp(9)
            uvel(ip,np)   = tmp(10)
            vvel(ip,np)   = tmp(11)
            temp(ip,np)   = tmp(12)
            salt(ip,np)   = tmp(13)
         enddo
   
         close(1)
      enddo
   enddo

   print*,icount," x ",npart," = ",icount*npart," records expected,",& 
      " found ",itotalrecord," float records"
   print*,"==> ",icount*npart-itotalrecord," float records missing"
   !
   !
   !-----------------------------------------------------------------------
   !     define netCDF variables
   !-----------------------------------------------------------------------
   !
   write(STDOUT,*) " Start Converting"
   !
   ! enter define mode
   !
   outname2=trim(fname)//".cdf"
   write (STDOUT,*)" ==>  Writing a trajectories to file ",trim(outname2)
   call nc_check(nf90_create(trim(outname2),NF90_CLOBBER,ncid),__LINE__)
   ! 
   ! define dimensions
   !
   call nc_check(nf90_def_dim(ncid, "Particles", npart, partdim),__LINE__)
   call nc_check(nf90_def_dim(ncid, "Time",      NF90_UNLIMITED, Timedim),__LINE__)
   !
   ! define variables
   !
   call nc_check(nf90_def_var(ncid, "Particles",NF90_DOUBLE, (/partdim/), partid),__LINE__)
   call nc_check(nf90_def_var(ncid, "Time",     NF90_DOUBLE, (/Timedim/), Timeid),__LINE__)
   
   call nc_check(nf90_def_var(ncid, "x",        NF90_DOUBLE, (/partdim,Timedim/), xpartid),__LINE__)
   call nc_check(nf90_def_var(ncid, "y",        NF90_DOUBLE, (/partdim,Timedim/), ypartid),__LINE__)
   call nc_check(nf90_def_var(ncid, "z",        NF90_DOUBLE, (/partdim,Timedim/), zpartid),__LINE__)
   call nc_check(nf90_def_var(ncid, "i",        NF90_DOUBLE, (/partdim,Timedim/), ipartid),__LINE__)
   call nc_check(nf90_def_var(ncid, "j",        NF90_DOUBLE, (/partdim,Timedim/), jpartid),__LINE__)
   call nc_check(nf90_def_var(ncid, "k",        NF90_DOUBLE, (/partdim,Timedim/), kpartid),__LINE__)
   call nc_check(nf90_def_var(ncid, "pressure", NF90_DOUBLE, (/partdim,Timedim/), presid),__LINE__)
   call nc_check(nf90_def_var(ncid, "u",        NF90_DOUBLE, (/partdim,Timedim/), uvelid),__LINE__)
   call nc_check(nf90_def_var(ncid, "v",        NF90_DOUBLE, (/partdim,Timedim/), vvelid),__LINE__)
   call nc_check(nf90_def_var(ncid, "T",        NF90_DOUBLE, (/partdim,Timedim/), tempid),__LINE__)
   call nc_check(nf90_def_var(ncid, "S",        NF90_DOUBLE, (/partdim,Timedim/), saltid),__LINE__)
   !
   !-----------------------------------------------------------------------
   !     assign attributes
   !-----------------------------------------------------------------------
   !
   name = "Particle Number"
   unit = "particle number"
   call nc_check(nf90_put_att(ncid,partid,"long_name",name),__LINE__)
   call nc_check(nf90_put_att(ncid,partid,"units",    unit),__LINE__)
   
   name = "Time"
   unit = "seconds"
   call nc_check(nf90_put_att(ncid,Timeid,"long_name",  name),__LINE__)
   call nc_check(nf90_put_att(ncid,Timeid,"units",      unit),__LINE__)
   call nc_check(nf90_put_att(ncid,Timeid,"time_origin",startDate),__LINE__)
   
   if (usingSphericalPolarGrid) then
      name = "LONGITUDE "
      unit = "degrees_W "
   else
      name = "X_t "
      unit = "meter "
   endif
   call nc_check(nf90_put_att(ncid,xpartid,"long_name",  name),__LINE__)
   call nc_check(nf90_put_att(ncid,xpartid,"units",      unit),__LINE__)
   call nc_check(nf90_put_att(ncid,xpartid,"missing_value",NF90_FILL_DOUBLE),__LINE__)
   call nc_check(nf90_put_att(ncid,xpartid,"_FillValue",   NF90_FILL_DOUBLE),__LINE__)
   
   if (usingSphericalPolarGrid) then
      name = "LATITUDE "
      unit = "degrees_N "
   else
      name = "Y_t "
      unit = "meter "
   endif
   call nc_check(nf90_put_att(ncid,ypartid,"long_name",  name),__LINE__)
   call nc_check(nf90_put_att(ncid,ypartid,"units",      unit),__LINE__)
   call nc_check(nf90_put_att(ncid,ypartid,"missing_value",NF90_FILL_DOUBLE),__LINE__)
   call nc_check(nf90_put_att(ncid,ypartid,"_FillValue",   NF90_FILL_DOUBLE),__LINE__)
   
   name = "DEPTH "
   unit = "meter "
   call nc_check(nf90_put_att(ncid,zpartid,"long_name",  name),__LINE__)
   call nc_check(nf90_put_att(ncid,zpartid,"units",      unit),__LINE__)
   call nc_check(nf90_put_att(ncid,zpartid,"missing_value",NF90_FILL_DOUBLE),__LINE__)
   call nc_check(nf90_put_att(ncid,zpartid,"_FillValue",   NF90_FILL_DOUBLE),__LINE__)
   
   name = "iINDEX "
   unit = "index "
   call nc_check(nf90_put_att(ncid,ipartid,"long_name",  name),__LINE__)
   call nc_check(nf90_put_att(ncid,ipartid,"units",      unit),__LINE__)
   call nc_check(nf90_put_att(ncid,ipartid,"missing_value",NF90_FILL_DOUBLE),__LINE__)
   call nc_check(nf90_put_att(ncid,ipartid,"_FillValue",   NF90_FILL_DOUBLE),__LINE__)
   
   name = "jINDEX "
   unit = "index "
   call nc_check(nf90_put_att(ncid,jpartid,"long_name",  name),__LINE__)
   call nc_check(nf90_put_att(ncid,jpartid,"units",      unit),__LINE__)
   call nc_check(nf90_put_att(ncid,jpartid,"missing_value",NF90_FILL_DOUBLE),__LINE__)
   call nc_check(nf90_put_att(ncid,jpartid,"_FillValue",   NF90_FILL_DOUBLE),__LINE__)
   
   name = "LEVEL "
   unit = "level "
   call nc_check(nf90_put_att(ncid,kpartid,"long_name",  name),__LINE__)
   call nc_check(nf90_put_att(ncid,kpartid,"units",      unit),__LINE__)
   call nc_check(nf90_put_att(ncid,kpartid,"missing_value",NF90_FILL_DOUBLE),__LINE__)
   call nc_check(nf90_put_att(ncid,kpartid,"_FillValue",   NF90_FILL_DOUBLE),__LINE__)
   
   name = "POTENTIAL TEMPERATURE "
   unit = "deg C "
   call nc_check(nf90_put_att(ncid,tempid,"long_name",  name),__LINE__)
   call nc_check(nf90_put_att(ncid,tempid,"units",      unit),__LINE__)
   call nc_check(nf90_put_att(ncid,tempid,"missing_value",NF90_FILL_DOUBLE),__LINE__)
   call nc_check(nf90_put_att(ncid,tempid,"_FillValue",   NF90_FILL_DOUBLE),__LINE__)
   
   name = "SALINITY "
   unit = "PSU "
   call nc_check(nf90_put_att(ncid,saltid,"long_name",  name),__LINE__)
   call nc_check(nf90_put_att(ncid,saltid,"units",      unit),__LINE__)
   call nc_check(nf90_put_att(ncid,saltid,"missing_value",NF90_FILL_DOUBLE),__LINE__)
   call nc_check(nf90_put_att(ncid,saltid,"_FillValue",   NF90_FILL_DOUBLE),__LINE__)
   
   name = "U VELOCITY "
   unit = "m/sec"
   call nc_check(nf90_put_att(ncid,uvelid,"long_name",  name),__LINE__)
   call nc_check(nf90_put_att(ncid,uvelid,"units",      unit),__LINE__)
   call nc_check(nf90_put_att(ncid,uvelid,"missing_value",NF90_FILL_DOUBLE),__LINE__)
   call nc_check(nf90_put_att(ncid,uvelid,"_FillValue",   NF90_FILL_DOUBLE),__LINE__)
   
   name = "V VELOCITY "
   unit = "m/sec"
   call nc_check(nf90_put_att(ncid,vvelid,"long_name",  name),__LINE__)
   call nc_check(nf90_put_att(ncid,vvelid,"units",      unit),__LINE__)
   call nc_check(nf90_put_att(ncid,vvelid,"missing_value",NF90_FILL_DOUBLE),__LINE__)
   call nc_check(nf90_put_att(ncid,vvelid,"_FillValue",   NF90_FILL_DOUBLE),__LINE__)
   
   name = "PRESSURE "
   unit = "N/m^2 "
   call nc_check(nf90_put_att(ncid,presid,"long_name",  name),__LINE__)
   call nc_check(nf90_put_att(ncid,presid,"units",      unit),__LINE__)
   call nc_check(nf90_put_att(ncid,presid,"missing_value",NF90_FILL_DOUBLE),__LINE__)
   call nc_check(nf90_put_att(ncid,presid,"_FillValue",   NF90_FILL_DOUBLE),__LINE__)
   
   
!   expnam= " "
!   stamp = " "
   call nc_check(nf90_put_att(ncid,NF90_GLOBAL,"title",  trim(expnam)),__LINE__)
!   call nc_check(nf90_put_att(ncid,NF90_GLOBAL,"history",stamp),__LINE__)
   !
   !-----------------------------------------------------------------------
   !     leave define mode
   !-----------------------------------------------------------------------
   !
   call nc_check(nf90_enddef(ncid),__LINE__)
   !
   !
   !-----------------------------------------------------------------------
   !     put variables in netCDF file
   !-----------------------------------------------------------------------
   !
   ! store Particles
   call nc_check(nf90_put_var(ncid,partid,pnum),__LINE__)
   !
   ! store Time      
   call nc_check(nf90_put_var(ncid,Timeid,Time),__LINE__)
   !
   ! store values
   call nc_check(nf90_put_var(ncid,xpartid,xpart),__LINE__)
   call nc_check(nf90_put_var(ncid,ypartid,ypart),__LINE__)
   call nc_check(nf90_put_var(ncid,zpartid,zpart),__LINE__)
   call nc_check(nf90_put_var(ncid,ipartid,ipart),__LINE__)
   call nc_check(nf90_put_var(ncid,jpartid,jpart),__LINE__)
   call nc_check(nf90_put_var(ncid,kpartid,kpart),__LINE__)
   call nc_check(nf90_put_var(ncid,tempid, temp),__LINE__)
   call nc_check(nf90_put_var(ncid,saltid, salt),__LINE__)
   call nc_check(nf90_put_var(ncid,uvelid, uvel),__LINE__)
   call nc_check(nf90_put_var(ncid,vvelid, vvel),__LINE__)
   call nc_check(nf90_put_var(ncid,presid, pres),__LINE__)
   
   call nc_check(nf90_close(ncid),__LINE__)
   
   write(STDOUT,*) " End "
      
   !-----------------------------------------------------------------------
   !     internal subroutines
   !-----------------------------------------------------------------------
contains
   subroutine nc_check(status,lineno)
      integer, intent ( in) :: status
      integer, intent ( in) :: lineno
   
      if(status /= nf90_noerr) then
         print *, "Error at line number ",lineno,":"
         print *, trim(nf90_strerror(status))
         stop 2
      end if
   end subroutine nc_check
end program cvfloat

#include "DIAG_OPTIONS.h"
#undef DIAG_MNC_COORD_NEEDSWORK

C--   File diagnostics_mnc_out.F: Routines to write MNC diagnostics output
C--    Contents:
C--    o DIAGNOSTICS_MNC_SET
C--    o DIAGNOSTICS_MNC_OUT

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 0
C     !ROUTINE: DIAGNOSTICS_MNC_SET

C     !INTERFACE:
      SUBROUTINE DIAGNOSTICS_MNC_SET(
     I     nLevOutp, listId, lm,
     O     diag_mnc_bn,
     I     misValLoc, myTime, myIter, myThid )

C     !DESCRIPTION:
C     Set MNC file for writing diagnostics fields.

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "DIAGNOSTICS_SIZE.h"
#include "DIAGNOSTICS.h"


C     !INPUT/OUTPUT PARAMETERS:
C     nLevOutp        :: number of levels to write in output file
C     listId          :: Diagnostics list number being written
C     lm              :: loop index (averageCycle)
C     diag_mnc_bn     :: NetCDF output file name
C     misValLoc       :: local Missing Value
C     myTime          :: current time of simulation (s)
C     myIter          :: current iteration number
C     myThid          :: my Thread Id number
      INTEGER nLevOutp
      INTEGER listId, lm
      CHARACTER*(MAX_LEN_FNAM) diag_mnc_bn
      _RL     misValLoc
      _RL     myTime
      INTEGER myIter, myThid
CEOP

#ifdef ALLOW_MNC
C     !FUNCTIONS:
      INTEGER ILNBLNK
      EXTERNAL ILNBLNK

C     !LOCAL VARIABLES:
      _RL tmpLev
      INTEGER iLen

c     CHARACTER*(MAX_LEN_MBUF) msgBuf
      INTEGER ii, klev
      INTEGER CW_DIMS, NLEN
      PARAMETER ( CW_DIMS = 10 )
      PARAMETER ( NLEN    = 80 )
      INTEGER dim(CW_DIMS), ib(CW_DIMS), ie(CW_DIMS)
      CHARACTER*(NLEN) dn(CW_DIMS)
c     CHARACTER*(NLEN) d_cw_name
c     CHARACTER*(NLEN) dn_blnk
#ifdef DIAG_MNC_COORD_NEEDSWORK
      INTEGER NrMax
      PARAMETER( NrMax = numLevels )
      INTEGER i, j
      CHARACTER*(5) ctmp
      _RS ztmp(NrMax)
#endif
      REAL*8  misval_r8(2)
      REAL*4  misval_r4(2)
      INTEGER misval_int(2)

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
c     IF (useMNC .AND. diag_mnc) THEN

C     Handle missing value attribute (land points)
C     Defaults to UNSET_I
        DO ii=1,2
          misval_r4(ii)  = misValLoc
          misval_r8(ii)  = misValLoc
          misval_int(ii) = UNSET_I
        ENDDO
c       DO i = 1,MAX_LEN_FNAM
c         diag_mnc_bn(i:i) = ' '
c       ENDDO
c       DO i = 1,NLEN
c         dn_blnk(i:i) = ' '
c       ENDDO
        iLen = ILNBLNK(fnames(listId))
        WRITE( diag_mnc_bn, '(A)' ) fnames(listId)(1:iLen)

C       Update the record dimension by writing the iteration number
        klev = myIter + lm - averageCycle(listId)
        tmpLev = myTime + deltaTClock*( lm - averageCycle(listId) )
        CALL MNC_CW_SET_UDIM(diag_mnc_bn, -1, myThid)
        CALL MNC_CW_RL_W_S('D',diag_mnc_bn,0,0,'T',tmpLev,myThid)
        CALL MNC_CW_SET_UDIM(diag_mnc_bn, 0, myThid)
        CALL MNC_CW_I_W_S('I',diag_mnc_bn,0,0,'iter',klev,myThid)

C       NOTE: at some point it would be a good idea to add a time_bounds
C       variable that has dimension (2,T) and clearly denotes the
C       beginning and ending times for each diagnostics period

c       dn(1)(1:NLEN) = dn_blnk(1:NLEN)
        WRITE(dn(1),'(a,i6.6)') 'Zmd', nLevOutp
        dim(1) = nLevOutp
        ib(1)  = 1
        ie(1)  = nLevOutp

        CALL MNC_CW_ADD_GNAME('diag_levels', 1,
     &       dim, dn, ib, ie, myThid)
        CALL MNC_CW_ADD_VNAME('diag_levels', 'diag_levels',
     &       0,0, myThid)
        CALL MNC_CW_ADD_VATTR_TEXT('diag_levels','description',
     &       'Indicies of vertical levels within the source arrays',
     &       myThid)
C     suppress the missing value attribute (iflag = 0)
        CALL MNC_CW_VATTR_MISSING('diag_levels', 0,
     I       misval_r8, misval_r4, misval_int, myThid )

        CALL MNC_CW_RL_W('D',diag_mnc_bn,0,0,
     &       'diag_levels', levs(1,listId), myThid)

        CALL MNC_CW_DEL_VNAME('diag_levels', myThid)
        CALL MNC_CW_DEL_GNAME('diag_levels', myThid)

#ifdef DIAG_MNC_COORD_NEEDSWORK
C       This part has been placed in an #ifdef because, as its currently
C       written, it will only work with variables defined on a dynamics
C       grid.  As we start using diagnostics for physics grids, ice
C       levels, land levels, etc. the different vertical coordinate
C       dimensions will have to be taken into account.

C       20051021 JMC & EH3 : We need to extend this so that a few
C       variables each defined on different grids do not have the same
C       vertical dimension names so we should be using a pattern such
C       as: Z[uml]td000000 where the 't' is the type as specified by
C       gdiag(10)

C       Now define:  Zmdxxxxxx, Zudxxxxxx, Zldxxxxxx
        ctmp(1:5) = 'mul  '
        DO i = 1,3
c         dn(1)(1:NLEN) = dn_blnk(1:NLEN)
          WRITE(dn(1),'(3a,i6.6)') 'Z',ctmp(i:i),'d',nlevels(listId)
          CALL MNC_CW_ADD_GNAME(dn(1), 1, dim, dn, ib, ie, myThid)
          CALL MNC_CW_ADD_VNAME(dn(1), dn(1), 0,0, myThid)

C         The following three ztmp() loops should eventually be modified
C         to reflect the fractional nature of levs(j,l) -- they should
C         do something like:
C            ztmp(j) = rC(INT(FLOOR(levs(j,l))))
C                      + ( rC(INT(FLOOR(levs(j,l))))
C                          + rC(INT(CEIL(levs(j,l)))) )
C                        / ( levs(j,l) - FLOOR(levs(j,l)) )
C         for averaged levels.
          IF (i .EQ. 1) THEN
            DO j = 1,nlevels(listId)
              ztmp(j) = rC(NINT(levs(j,listId)))
            ENDDO
            CALL MNC_CW_ADD_VATTR_TEXT(dn(1),'description',
     &           'Dimensional coordinate value at the mid point',
     &           myThid)
          ELSEIF (i .EQ. 2) THEN
            DO j = 1,nlevels(listId)
              ztmp(j) = rF(NINT(levs(j,listId)) + 1)
            ENDDO
            CALL MNC_CW_ADD_VATTR_TEXT(dn(1),'description',
     &           'Dimensional coordinate value at the upper point',
     &           myThid)
          ELSEIF (i .EQ. 3) THEN
            DO j = 1,nlevels(listId)
              ztmp(j) = rF(NINT(levs(j,listId)))
            ENDDO
            CALL MNC_CW_ADD_VATTR_TEXT(dn(1),'description',
     &           'Dimensional coordinate value at the lower point',
     &           myThid)
          ENDIF
C     suppress the missing value attribute (iflag = 0)
          IF (useMissingValue)
     &          CALL MNC_CW_VATTR_MISSING(dn(1), 0,
     I          misval_r8, misval_r4, misval_int, myThid )
          CALL MNC_CW_RS_W('D',diag_mnc_bn,0,0, dn(1), ztmp, myThid)
          CALL MNC_CW_DEL_VNAME(dn(1), myThid)
          CALL MNC_CW_DEL_GNAME(dn(1), myThid)
        ENDDO
#endif /*  DIAG_MNC_COORD_NEEDSWORK  */

c     ENDIF
#endif /*  ALLOW_MNC  */

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 0
C     !ROUTINE: DIAGNOSTICS_MNC_OUT

C     !INTERFACE:
      SUBROUTINE DIAGNOSTICS_MNC_OUT(
     I     NrMax, nLevOutp, listId, ndId, mate,
     I     diag_mnc_bn, qtmp,
     I     misValLoc, myTime, myIter, myThid )

C     !DESCRIPTION:
C     write diagnostics fields to MNC file.

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "DIAGNOSTICS_SIZE.h"
#include "DIAGNOSTICS.h"

C     !INPUT PARAMETERS:
C     NrMax           :: 3rd dimension of output-field array to write
C     nLevOutp        :: number of levels to write in output file
C     listId          :: Diagnostics list number being written
C     ndId            :: diagnostics Id number (in available diagnostics list)
C     mate            :: counter diagnostic number if any ; 0 otherwise
C     diag_mnc_bn     :: NetCDF output file name
C     qtmp            :: output-field array to write
C     misValLoc       :: local Missing Value
C     myTime          :: current time of simulation (s)
C     myIter          :: current iteration number
C     myThid          :: my Thread Id number
      INTEGER NrMax
      INTEGER nLevOutp
      INTEGER listId, ndId, mate
      CHARACTER*(MAX_LEN_FNAM) diag_mnc_bn
      _RL     qtmp(1-OLx:sNx+OLx,1-OLy:sNy+OLy,NrMax,nSx,nSy)
      _RL     misValLoc
      _RL     myTime
      INTEGER myIter, myThid
CEOP

#ifdef ALLOW_MNC
C     !FUNCTIONS:
c     INTEGER ILNBLNK
c     EXTERNAL ILNBLNK

C     !LOCAL VARIABLES:
C     i,j,k :: loop indices
C     bi,bj :: tile indices
      INTEGER i, j, k
      INTEGER bi, bj

c     CHARACTER*(MAX_LEN_MBUF) msgBuf
c     INTEGER ll, llMx, jj, jjMx
      INTEGER ii, klev
      INTEGER CW_DIMS, NLEN
      PARAMETER ( CW_DIMS = 10 )
      PARAMETER ( NLEN    = 80 )
      INTEGER dim(CW_DIMS), ib(CW_DIMS), ie(CW_DIMS)
      CHARACTER*(NLEN) dn(CW_DIMS)
      CHARACTER*(NLEN) d_cw_name
c     CHARACTER*(NLEN) dn_blnk
      LOGICAL useMisValForThisDiag
      REAL*8  misval_r8(2)
      REAL*4  misval_r4(2)
      INTEGER misval_int(2)

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
c     IF (useMNC .AND. diag_mnc) THEN

        _BEGIN_MASTER( myThid )

         DO ii = 1,CW_DIMS
c          d_cw_name(1:NLEN) = dn_blnk(1:NLEN)
c          dn(ii)(1:NLEN) = dn_blnk(1:NLEN)
           dn(ii) =  ' '
         ENDDO
         DO ii=1,2
           misval_r4(ii)  = misValLoc
           misval_r8(ii)  = misValLoc
           misval_int(ii) = UNSET_I
         ENDDO

C        Note that the "d_cw_name" variable is a hack that hides a
C        subtlety within MNC.  Basically, each MNC-wrapped file is
C        caching its own concept of what each "grid name" (that is, a
C        dimension group name) means.  So one cannot re-use the same
C        "grid" name for different collections of dimensions within a
C        given file.  By appending the "ndId" values to each name, we
C        guarantee uniqueness within each MNC-produced file.
         WRITE(d_cw_name,'(a,i6.6)') 'd_cw_',ndId

C        XY dimensions
         dim(1)       = sNx + 2*OLx
         dim(2)       = sNy + 2*OLy
         ib(1)        = OLx + 1
         ib(2)        = OLy + 1
         IF (gdiag(ndId)(2:2) .EQ. 'M') THEN
           dn(1)(1:2) = 'X'
           ie(1)      = OLx + sNx
           dn(2)(1:2) = 'Y'
           ie(2)      = OLy + sNy
         ELSEIF (gdiag(ndId)(2:2) .EQ. 'U') THEN
           dn(1)(1:3) = 'Xp1'
           ie(1)      = OLx + sNx + 1
           dn(2)(1:2) = 'Y'
           ie(2)      = OLy + sNy
         ELSEIF (gdiag(ndId)(2:2) .EQ. 'V') THEN
           dn(1)(1:2) = 'X'
           ie(1)      = OLx + sNx
           dn(2)(1:3) = 'Yp1'
           ie(2)      = OLy + sNy + 1
         ELSEIF (gdiag(ndId)(2:2) .EQ. 'Z') THEN
           dn(1)(1:3) = 'Xp1'
           ie(1)      = OLx + sNx + 1
           dn(2)(1:3) = 'Yp1'
           ie(2)      = OLy + sNy + 1
         ENDIF

C        Z is special since it varies
         WRITE(dn(3),'(a,i6.6)') 'Zd', nLevOutp
         IF ( (gdiag(ndId)(10:10) .EQ. 'R')
     &        .AND. (gdiag(ndId)(9:9) .EQ. 'M') ) THEN
           WRITE(dn(3),'(a,i6.6)') 'Zmd', nLevOutp
         ENDIF
         IF ( (gdiag(ndId)(10:10) .EQ. 'R')
     &        .AND. (gdiag(ndId)(9:9) .EQ. 'L') ) THEN
           WRITE(dn(3),'(a,i6.6)') 'Zld', nLevOutp
         ENDIF
         IF ( (gdiag(ndId)(10:10) .EQ. 'R')
     &        .AND. (gdiag(ndId)(9:9) .EQ. 'U') ) THEN
           WRITE(dn(3),'(a,i6.6)') 'Zud', nLevOutp
         ENDIF
         dim(3) = NrMax
         ib(3)  = 1
         ie(3)  = nLevOutp

C        Time dimension
         dn(4)(1:1) = 'T'
         dim(4) = -1
         ib(4)  = 1
         ie(4)  = 1

         CALL MNC_CW_ADD_GNAME( d_cw_name, 4,
     &                          dim, dn, ib, ie, myThid )
         CALL MNC_CW_ADD_VNAME( cdiag(ndId), d_cw_name,
     &                          4, 5, myThid )
         CALL MNC_CW_ADD_VATTR_TEXT( cdiag(ndId),'description',
     &                               tdiag(ndId), myThid )
         CALL MNC_CW_ADD_VATTR_TEXT( cdiag(ndId),'units',
     &                               udiag(ndId), myThid )

         useMisValForThisDiag = mate.GT.0
C     Use the missing values for masking out the land points:
C     only for scalar diagnostics at mass points (so far)
         IF ( useMissingValue.AND.gdiag(ndId)(1:2).EQ.'SM' ) THEN
           useMisValForThisDiag = .TRUE.
C     note: better to use 2-D mask if kdiag <> Nr or vert.integral
           DO bj = myByLo(myThid), myByHi(myThid)
            DO bi = myBxLo(myThid), myBxHi(myThid)
             DO k = 1,nLevOutp
              klev = NINT(levs(k,listId))
              IF ( fflags(listId)(2:2).EQ.'I' ) kLev = 1
              DO j = 1-OLy,sNy+OLy
               DO i = 1-OLx,sNx+OLx
                IF ( maskC(i,j,klev,bi,bj) .EQ. 0. )
     &                qtmp(i,j,k,bi,bj) = misValLoc
               ENDDO
              ENDDO
             ENDDO
            ENDDO
           ENDDO
         ENDIF
         IF ( useMisValForThisDiag ) THEN
C     assign missing values and set flag for adding the netCDF atttibute
           CALL MNC_CW_VATTR_MISSING(cdiag(ndId), 2,
     I                misval_r8, misval_r4, misval_int, myThid )
         ELSE
C     suppress the missing value attribute (iflag = 0)
C     Note: We have to call the following subroutine for each mnc that has
C     been created "on the fly" by mnc_cw_add_vname and will be deleted
C     by mnc_cw_del_vname, because all of these variables use the same
C     identifier so that mnc_cw_vfmv(indv) needs to be overwritten for
C     each of these variables
           CALL MNC_CW_VATTR_MISSING( cdiag(ndId), 0,
     I                 misval_r8, misval_r4, misval_int, myThid )
         ENDIF

         IF (  ((writeBinaryPrec .EQ. precFloat32).AND.
     &          (fflags(listId)(1:1) .NE. 'D'))
     &         .OR. (fflags(listId)(1:1) .EQ. 'R') ) THEN
           CALL MNC_CW_RL_W( 'R',diag_mnc_bn,0,0,
     &                       cdiag(ndId), qtmp, myThid)
         ELSEIF ( (writeBinaryPrec .EQ. precFloat64)
     &         .OR.  (fflags(listId)(1:1) .EQ. 'D') ) THEN
           CALL MNC_CW_RL_W( 'D',diag_mnc_bn,0,0,
     &                       cdiag(ndId), qtmp, myThid)
         ENDIF

         CALL MNC_CW_DEL_VNAME(cdiag(ndId), myThid)
         CALL MNC_CW_DEL_GNAME(d_cw_name, myThid)

        _END_MASTER( myThid )

c     ENDIF
#endif /*  ALLOW_MNC  */

      RETURN
      END

#include "STREAMICE_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 0
      SUBROUTINE STREAMICE_UPD_FFRAC_UNCOUPLED ( myThid )

C     !DESCRIPTION:
C     Initialize STREAMICE variables and constants.

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "STREAMICE.h"
#include "GRID.h"

C     !INPUT PARAMETERS:
      INTEGER myThid
CEOP

#ifdef ALLOW_STREAMICE

      INTEGER bi, bj, i, j
      _RL OD, rhoi, rhow, delta, r, h, hf, i_r, rlo
#ifdef STREAMICE_SMOOTH_FLOATATION2
      _RL ETA_GL_STREAMICE
      external ETA_GL_STREAMICE
#endif
#if defined(STREAMICE_SMOOTH_FLOATATION2) || defined(STREAMICE_SMOOTH_FLOATATION)
      _RL PHI_GL_STREAMICE
      external PHI_GL_STREAMICE
#endif
#ifdef STREAMICE_FIRN_CORRECTION
      _RL firn_depth
#endif

      rhoi = streamice_density
      rhow = streamice_density_ocean_avg
      r=rhoi/rhow
      i_r = 1/r
      delta=1-r
#ifdef STREAMICE_FIRN_CORRECTION
      firn_depth = streamice_density * 
     &    streamice_firn_correction
     & / (streamice_density-streamice_density_firn)
#endif


#ifdef STREAMICE_SMOOTH_FLOATATION2

      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
        DO j=1-Oly,sNy+Oly
         DO i=1-Olx,sNx+Olx
          
          if (STREAMICE_hmask(i,j,bi,bj).eq.1.0 .or.
     &        STREAMICE_hmask(i,j,bi,bj).eq.2.0) THEN

           h = H_streamice(i,j,bi,bj)

# ifdef USE_ALT_RLOW
           hf = -1.0 * i_r * R_low_si (i,j,bi,bj) 
# else
           hf = -1.0 * i_r * R_low (i,j,bi,bj) 
# endif

           surf_el_streamice(i,j,bi,bj) =
     &      ETA_GL_STREAMICE (
     &       h-hf, 
     &       delta, 
     &       1. _d 0, 
     &       delta*hf,
     &       streamice_smooth_gl_width)

           base_el_streamice(i,j,bi,bj) =
     &      surf_el_streamice(i,j,bi,bj) - h

           float_frac_streamice(i,j,bi,bj) = 
     &      PHI_GL_STREAMICE (
     &       h-hf, 
     &       streamice_smooth_gl_width)

          ENDIF
         ENDDO
        ENDDO
       ENDDO
      ENDDO

#else 
! STREAMICE_SMOOTH_FLOATATION2

      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
        DO j=1-Oly,sNy+Oly
         DO i=1-Olx,sNx+Olx
          h = H_streamice(i,j,bi,bj)
# ifdef USE_ALT_RLOW
          rlo = R_low_si (i,j,bi,bj)
# else
          rlo = R_low (i,j,bi,bj)
#endif

#ifdef STREAMICE_FIRN_CORRECTION
          if (STREAMICE_apply_firn_correction) then
!           h=h_streamice(i,j,bi,bj)
          if (h_streamice(i,j,bi,bj).lt.firn_depth) then
            OD = -1.0 * rlo - streamice_density_firn/rhow *
     &       h_streamice(i,j,bi,bj)
          else
            OD = -1.0 * rlo - rhoi/rhow * 
     &       (h_streamice(i,j,bi,bj)-streamice_firn_correction)
          endif
          else
#endif
          OD = -1.0 * Rlo - 
     &     H * rhoi/rhow
#ifdef STREAMICE_FIRN_CORRECTION
          endif
#endif

          IF (OD .ge. 0. _d 0) THEN          

c         ice thickness does not take up whole ocean column -> floating
!           float_frac_streamice(i,j,bi,bj) = 0.0
           base_el_streamice(i,j,bi,bj) = Rlo+OD
#ifdef STREAMICE_FIRN_CORRECTION
           if (STREAMICE_apply_firn_correction) then
           if (h.lt.firn_depth) then
            surf_el_streamice(i,j,bi,bj) = 
     &      (1-streamice_density_firn/rhow)*h
           else
            surf_el_streamice(i,j,bi,bj) = 
     &      (1-rhoi/rhow)*h + 
     &        rhoi/rhow*streamice_firn_correction
           endif
           else
#endif
           surf_el_streamice(i,j,bi,bj) = 
     &      (1-rhoi/rhow)*H
#ifdef STREAMICE_FIRN_CORRECTION
           endif
#endif

          ELSE


!           float_frac_streamice(i,j,bi,bj) = 1.0
           base_el_streamice(i,j,bi,bj) = Rlo
           surf_el_streamice(i,j,bi,bj) = Rlo
     &      + H
          ENDIF

#ifndef STREAMICE_SMOOTH_FLOATATION


          IF (OD .ge. 0. _d 0) THEN          
           float_frac_streamice(i,j,bi,bj) = 0.0
          ELSE
           float_frac_streamice(i,j,bi,bj) = 1.0
          ENDIF

#else

          if (STREAMICE_hmask(i,j,bi,bj).eq.1.0 .or.
     &        STREAMICE_hmask(i,j,bi,bj).eq.2.0) THEN
# ifdef USE_ALT_RLOW
           hf = -1.0 * i_r * R_low_si (i,j,bi,bj) 
# else
           hf = -1.0 * i_r * R_low (i,j,bi,bj) 
# endif
           
           float_frac_streamice(i,j,bi,bj) = 
     &      PHI_GL_STREAMICE (
     &       h-hf+streamice_smooth_gl_width/2., 
     &       streamice_smooth_gl_width)

          endif
#endif

         ENDDO
        ENDDO
       ENDDO
      ENDDO

#endif

       _EXCH_XY_RL(float_frac_streamice, myThid )
       _EXCH_XY_RL(base_el_streamice, myThid )
       _EXCH_XY_RL(surf_el_streamice, myThid )

      


#endif /* ALLOW_STREAMICE */

      RETURN
      END

#include "AUTODIFF_OPTIONS.h"

C     ==================================================================
C     active_file_gen_ad.F: Routines to handle the I/O of the active file
C                           for the adjoint calculations.
C     Routines
C    o  adACTIVE_READ_GEN_RL    - Adjoint of ACTIVE_READ_GEN_RL
C    o  adACTIVE_READ_GEN_RS    - Adjoint of ACTIVE_READ_GEN_RS
C
C    o  adACTIVE_WRITE_GEN_RL   - Adjoint of ACTIVE_WRITE_GEN_RL
C    o  adACTIVE_WRITE_GEN_RS   - Adjoint of ACTIVE_WRITE_GEN_RS
C
C     Generic version for each array type (_RL or _RS).
C     Note: the _RL version can replace the 4 x 2 shape-specific
C           (_xy,_xyz,_xz,_yz) and standard or "_loc" routines.
C     ==================================================================

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: adACTIVE_READ_GEN_RL
C     !INTERFACE:
#ifdef AUTODIFF_TAMC_COMPATIBILITY
      SUBROUTINE adACTIVE_READ_GEN_RL(
     I                               activeVar_file,
     I                               arrShape, myNr,
     I                               iRec,
     I                               globalFile,
     I                               useCurrentDir,
     I                               lAdInit,
     I                               myIter,
     I                               myThid,
     O                               adactive_var
     I                               )
#else
      SUBROUTINE adACTIVE_READ_GEN_RL(
     I                               activeVar_file,
     O                               adactive_var,
     I                               arrShape, myNr,
     I                               iRec,
     I                               globalFile,
     I                               useCurrentDir,
     I                               lAdInit,
     I                               myIter,
     I                               myThid,
     I                               dummy,
     O                               addummy )
#endif

C     !DESCRIPTION: \bv
C     ==================================================================
C     SUBROUTINE adACTIVE_READ_GEN_RL
C     ==================================================================
C     o Adjoint of ACTIVE_READ_GEN_RL.
C     Accept active variable of various (XY,XZ,YZ) shape and level
C     number, according to arguments arrShape and myNr.
C     ==================================================================
C     \ev

C     !USES:
      IMPLICIT NONE

C     == global variables ==
#include "EEPARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     activeVar_file :: filename
C     adactive_var   :: adoint variable array
C     arrShape       :: shape of active-var array ('XY','XZ' or 'YZ')
C     myNr           :: number of vertical-levels in active-var array
C     iRec           :: record number in file
C     globalFile     :: used for writing global (if =T) or tiled files
C     useCurrentDir  :: always read from the current directory
C                        (even if "mdsioLocalDir" is set)
C     lAdInit        :: initialisation of corresponding adjoint variable
C                        and write to active file
C     myIter         :: number of optimization iteration (default: 0)
C     myThid         :: my Thread Id number
C     dummy          :: (needed for 2nd derivative code)
      CHARACTER*(*) activeVar_file
      _RL     adactive_var(*)
      CHARACTER*(2) arrShape
      INTEGER myNr
      INTEGER iRec
      LOGICAL globalFile
      LOGICAL useCurrentDir
      LOGICAL lAdInit
      INTEGER myIter
      INTEGER myThid
      _RL     dummy, addummy

C     !LOCAL VARIABLES:
      CHARACTER*(2)  pref
      CHARACTER*(MAX_LEN_FNAM) fName
CEOP

      pref = 'ad'
      CALL ADD_PREFIX( pref, activeVar_file, fName )

      IF ( arrShape.EQ.'XY' ) THEN

        CALL ACTIVE_READ_3D_RL(
     &                 fName, adactive_var, globalFile,
     &                 useCurrentDir, lAdInit, iRec, myNr,
     &                 REVERSE_SIMULATION, myIter, myThid )

      ELSEIF ( arrShape.EQ.'XZ' ) THEN

        CALL ACTIVE_READ_XZ_RL(
     &                 fName, adactive_var, globalFile,
     &                 useCurrentDir, lAdInit, iRec, myNr,
     &                 REVERSE_SIMULATION, myIter, myThid )

      ELSEIF ( arrShape.EQ.'YZ' ) THEN

        CALL ACTIVE_READ_YZ_RL(
     &                 fName, adactive_var, globalFile,
     &                 useCurrentDir, lAdInit, iRec, myNr,
     &                 REVERSE_SIMULATION, myIter, myThid )

      ELSE
        STOP
     &   'ABNORMAL END: S/R adACTIVE_READ_GEN_RL: invalid arrShape'
      ENDIF

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: adACTIVE_READ_GEN_RS
C     !INTERFACE:
#ifdef AUTODIFF_TAMC_COMPATIBILITY
      SUBROUTINE adACTIVE_READ_GEN_RS(
     I                               activeVar_file,
     I                               arrShape, myNr,
     I                               iRec,
     I                               globalFile,
     I                               useCurrentDir,
     I                               lAdInit,
     I                               myIter,
     I                               myThid,
     O                               adactive_var
     I                               )
#else
      SUBROUTINE adACTIVE_READ_GEN_RS(
     I                               activeVar_file,
     O                               adactive_var,
     I                               arrShape, myNr,
     I                               iRec,
     I                               globalFile,
     I                               useCurrentDir,
     I                               lAdInit,
     I                               myIter,
     I                               myThid,
     I                               dummy,
     O                               addummy )
#endif

C     !DESCRIPTION: \bv
C     ==================================================================
C     SUBROUTINE adACTIVE_READ_GEN_RS
C     ==================================================================
C     o Adjoint of ACTIVE_READ_GEN_RS.
C     Accept active variable of various (XY,XZ,YZ) shape and level
C     number, according to arguments arrShape and myNr.
C     ==================================================================
C     \ev

C     !USES:
      IMPLICIT NONE

C     == global variables ==
#include "EEPARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     activeVar_file :: filename
C     adactive_var   :: adoint variable array
C     arrShape       :: shape of active-var array ('XY','XZ' or 'YZ')
C     myNr           :: number of vertical-levels in active-var array
C     iRec           :: record number in file
C     globalFile     :: used for writing global (if =T) or tiled files
C     useCurrentDir  :: always read from the current directory
C                        (even if "mdsioLocalDir" is set)
C     lAdInit        :: initialisation of corresponding adjoint variable
C                        and write to active file
C     myIter         :: number of optimization iteration (default: 0)
C     myThid         :: my Thread Id number
C     dummy          :: (needed for 2nd derivative code)
      CHARACTER*(*) activeVar_file
      _RS     adactive_var(*)
      CHARACTER*(2) arrShape
      INTEGER myNr
      INTEGER iRec
      LOGICAL globalFile
      LOGICAL useCurrentDir
      LOGICAL lAdInit
      INTEGER myIter
      INTEGER myThid
      _RS     dummy, addummy

C     !LOCAL VARIABLES:
      CHARACTER*(2)  pref
      CHARACTER*(MAX_LEN_FNAM) fName
CEOP

      pref = 'ad'
      CALL ADD_PREFIX( pref, activeVar_file, fName )

      IF ( arrShape.EQ.'XY' ) THEN

        CALL ACTIVE_READ_3D_RS(
     &                 fName, adactive_var, globalFile,
     &                 useCurrentDir, lAdInit, iRec, myNr,
     &                 REVERSE_SIMULATION, myIter, myThid )

      ELSEIF ( arrShape.EQ.'XZ' ) THEN

        CALL ACTIVE_READ_XZ_RS(
     &                 fName, adactive_var, globalFile,
     &                 useCurrentDir, lAdInit, iRec, myNr,
     &                 REVERSE_SIMULATION, myIter, myThid )

      ELSEIF ( arrShape.EQ.'YZ' ) THEN

        CALL ACTIVE_READ_YZ_RS(
     &                 fName, adactive_var, globalFile,
     &                 useCurrentDir, lAdInit, iRec, myNr,
     &                 REVERSE_SIMULATION, myIter, myThid )

      ELSE
        STOP
     &   'ABNORMAL END: S/R adACTIVE_READ_GEN_RS: invalid arrShape'
      ENDIF

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: adACTIVE_WRITE_GEN_RL
C     !INTERFACE:
#ifdef AUTODIFF_TAMC_COMPATIBILITY
      SUBROUTINE adACTIVE_WRITE_GEN_RL(
     I                               activeVar_file,
     I                               arrShape, myNr,
     I                               iRec,
     I                               useCurrentDir,
     I                               myIter,
     I                               myThid,
     U                               adactive_var,
     I                               dummy )
#else
      SUBROUTINE adACTIVE_WRITE_GEN_RL(
     I                               activeVar_file,
     U                               adactive_var,
     I                               arrShape, myNr,
     I                               iRec,
     I                               useCurrentDir,
     I                               myIter,
     I                               myThid,
     I                               dummy )
#endif

C     !DESCRIPTION: \bv
C     ==================================================================
C     SUBROUTINE adACTIVE_WRITE_GEN_RL
C     ==================================================================
C     o Adjoint of ACTIVE_WRITE_GEN_RL.
C     Accept active variable of various (XY,XZ,YZ) shape and level
C     number, according to arguments arrShape and myNr.
C     ==================================================================
C     \ev

C     !USES:
      IMPLICIT NONE

C     == global variables ==
#include "EEPARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     activeVar_file :: filename
C     active_var     :: active variable array
C     arrShape       :: shape of active-var array ('XY','XZ' or 'YZ')
C     myNr           :: number of vertical-levels in active-var array
C     iRec           :: record number in file
C     useCurrentDir  :: always write to the current directory
C                        (even if "mdsioLocalDir" is set)
C     myIter         :: number of optimization iteration (default: 0)
C     myThid         :: my Thread Id number
C     dummy          :: (needed for 2nd derivative code)
      CHARACTER*(*) activeVar_file
      _RL     adactive_var(*)
      CHARACTER*(2) arrShape
      INTEGER myNr
      INTEGER iRec
      LOGICAL useCurrentDir
      INTEGER myIter
      INTEGER myThid
      _RL     dummy

C     !LOCAL VARIABLES:
C     globalFile     :: used for writing global (if =T) or tiled files
      CHARACTER*(2)  pref
      CHARACTER*(MAX_LEN_FNAM) fName
      LOGICAL globalFile
CEOP

      pref = 'ad'
      CALL ADD_PREFIX( pref, activeVar_file, fName )
      globalFile = .FALSE.

      IF ( arrShape.EQ.'XY' ) THEN

        CALL ACTIVE_WRITE_3D_RL(
     &                 fName, adactive_var, globalFile,
     &                 useCurrentDir, iRec, myNr,
     &                 REVERSE_SIMULATION, myIter, myThid )

      ELSEIF ( arrShape.EQ.'XZ' ) THEN

        CALL ACTIVE_WRITE_XZ_RL(
     &                 fName, adactive_var, globalFile,
     &                 useCurrentDir, iRec, myNr,
     &                 REVERSE_SIMULATION, myIter, myThid )

      ELSEIF ( arrShape.EQ.'YZ' ) THEN

        CALL ACTIVE_WRITE_YZ_RL(
     &                 fName, adactive_var, globalFile,
     &                 useCurrentDir, iRec, myNr,
     &                 REVERSE_SIMULATION, myIter, myThid )

      ELSE
        STOP
     &   'ABNORMAL END: S/R adACTIVE_WRITE_GEN_RL: invalid arrShape'
      ENDIF

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: adACTIVE_WRITE_GEN_RS
C     !INTERFACE:
#ifdef AUTODIFF_TAMC_COMPATIBILITY
      SUBROUTINE adACTIVE_WRITE_GEN_RS(
     I                               activeVar_file,
     I                               arrShape, myNr,
     I                               iRec,
     I                               useCurrentDir,
     I                               myIter,
     I                               myThid,
     U                               adactive_var,
     I                               dummy )
#else
      SUBROUTINE adACTIVE_WRITE_GEN_RS(
     I                               activeVar_file,
     U                               adactive_var,
     I                               arrShape, myNr,
     I                               iRec,
     I                               useCurrentDir,
     I                               myIter,
     I                               myThid,
     I                               dummy )
#endif

C     !DESCRIPTION: \bv
C     ==================================================================
C     SUBROUTINE adACTIVE_WRITE_GEN_RS
C     ==================================================================
C     o Adjoint of ACTIVE_WRITE_GEN_RS.
C     Accept active variable of various (XY,XZ,YZ) shape and level
C     number, according to arguments arrShape and myNr.
C     ==================================================================
C     \ev

C     !USES:
      IMPLICIT NONE

C     == global variables ==
#include "EEPARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     activeVar_file :: filename
C     active_var     :: active variable array
C     arrShape       :: shape of active-var array ('XY','XZ' or 'YZ')
C     myNr           :: number of vertical-levels in active-var array
C     iRec           :: record number in file
C     useCurrentDir  :: always write to the current directory
C                        (even if "mdsioLocalDir" is set)
C     myIter         :: number of optimization iteration (default: 0)
C     myThid         :: my Thread Id number
C     dummy          :: (needed for 2nd derivative code)
      CHARACTER*(*) activeVar_file
      _RS     adactive_var(*)
      CHARACTER*(2) arrShape
      INTEGER myNr
      INTEGER iRec
      LOGICAL useCurrentDir
      INTEGER myIter
      INTEGER myThid
      _RS     dummy

C     !LOCAL VARIABLES:
C     globalFile     :: used for writing global (if =T) or tiled files
      CHARACTER*(2)  pref
      CHARACTER*(MAX_LEN_FNAM) fName
      LOGICAL globalFile
CEOP

      pref = 'ad'
      CALL ADD_PREFIX( pref, activeVar_file, fName )
      globalFile = .FALSE.

      IF ( arrShape.EQ.'XY' ) THEN

        CALL ACTIVE_WRITE_3D_RS(
     &                 fName, adactive_var, globalFile,
     &                 useCurrentDir, iRec, myNr,
     &                 REVERSE_SIMULATION, myIter, myThid )

      ELSEIF ( arrShape.EQ.'XZ' ) THEN

        CALL ACTIVE_WRITE_XZ_RS(
     &                 fName, adactive_var, globalFile,
     &                 useCurrentDir, iRec, myNr,
     &                 REVERSE_SIMULATION, myIter, myThid )

      ELSEIF ( arrShape.EQ.'YZ' ) THEN

        CALL ACTIVE_WRITE_YZ_RS(
     &                 fName, adactive_var, globalFile,
     &                 useCurrentDir, iRec, myNr,
     &                 REVERSE_SIMULATION, myIter, myThid )

      ELSE
        STOP
     &   'ABNORMAL END: S/R adACTIVE_WRITE_GEN_RS: invalid arrShape'
      ENDIF

      RETURN
      END

#include "DIC_OPTIONS.h"

CStartOfInterface
      SUBROUTINE DIC_STORE_FLUXCO2(  myTime,
     I                               myIter,
     I                               myThid )
C     *==========================================================*
C     | SUBROUTINE DIC_STORE_FLUXCO2                             |
C     | o Routine for controlling storage of air-sea CO2 flux to |
C     |   to the coupling layer.                                 |
C     |==========================================================*
C     | This version talks to the MIT Coupler. It uses the MIT   |
C     | Coupler "checkpoint1" library calls.                     |
C     *==========================================================*
      IMPLICIT NONE

C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
C     == DIC variables
#include "DIC_VARS.h"
#ifdef COMPONENT_MODULE
C     == Global variables for coupling interface ==
# include "CPL_PARAMS.h"
# include "OCNCPL.h"
#endif

C     == Routine arguments ==
C     myThid :: Thread number for this instance of the routine
C     myIter :: Current timestep number
C     myTime :: Current model time
      _RL     myTime
      INTEGER myIter
      INTEGER myThid
CEndOfInterface

#ifdef COMPONENT_MODULE
C     == Local variables ==
C     i,j    :: Loop counters
C     bi,bj  :: Tile index
      INTEGER i,j,bi,bj

      IF ( ocn_cplExch_DIC ) THEN
       DO bj=myByLo(myThid),myByHi(myThid)
        DO bi=myBxLo(myThid),myBxHi(myThid)
         DO j=1,sNy
          DO i=1,sNx
            fluxCO2cpl(i,j,bi,bj) = fluxCO2(i,j,bi,bj)
          ENDDO
         ENDDO
        ENDDO
       ENDDO
      ENDIF

#endif /* COMPONENT_MODULE */

      RETURN
      END

#include "COST_OPTIONS.h"

      SUBROUTINE COST_READPARMS( myThid )

c     ==================================================================
c     SUBROUTINE cost_readparms
c     ==================================================================
c
c     o This routine initialises the package cost.
c
c     started: Ralf Giering 18-Jan-2001
c
c     ==================================================================
c     SUBROUTINE cost_readparms
c     ==================================================================

      IMPLICIT NONE

c     == global variables ==
#include "EEPARAMS.h"
#include "SIZE.h"
#include "GRID.h"
#include "PARAMS.h"
#include "cost.h"

c     == routine arguments ==
      INTEGER myThid

c     == local variables ==
      CHARACTER*(max_len_mbuf) msgbuf
      INTEGER iUnit
c     retired parameter
      _RL     mult_depth

c     == end of interface ==

c--   Read the namelist input.
      NAMELIST /cost_nml/
     &         mult_atl, mult_test, mult_tracer,
     &         multTheta, multSalt, multUvel, multVvel, multEtan,
     &         mult_depth,
#ifdef ALLOW_COST_HFLUXM
     &         mult_temp_tut, mult_hflux_tut,
#endif
     &         lastinterval, cost_mask_file

      _BEGIN_MASTER( myThid )

c--     Set default values.
        mult_atl              =      0. _d 0
        mult_test             =      0. _d 0
        mult_tracer           =      0. _d 0
        multTheta             =      0. _d 0
        multSalt              =      0. _d 0
        multUvel              =      0. _d 0
        multVvel              =      0. _d 0
        multEtan              =      0. _d 0
        mult_depth            =      UNSET_RL
#ifdef ALLOW_COST_HFLUXM
        mult_temp_tut         =      0. _d 0
        mult_hflux_tut        =      0. _d 0
#endif
        cost_mask_file        =      ' '

c--     30*24*3600 = 2592000 = 1 model month
        lastinterval = 2592000.

c--     Next, read the cost data file.
        WRITE(msgBuf,'(A)') 'COST_READPARMS: opening data.cost'
        CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT , 1)

        CALL OPEN_COPY_DATA_FILE(
     I                          'data.cost', 'COST_READPARMS',
     O                          iUnit,
     I                          myThid )

        READ(  iUnit, nml = cost_nml )

        WRITE(msgBuf,'(A)') 'COST_READPARMS: finished reading data.cost'
        CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                  SQUEEZE_RIGHT , 1)

#ifdef SINGLE_DISK_IO
        CLOSE(iUnit)
#else
        CLOSE(iUnit,STATUS='DELETE')
#endif /* SINGLE_DISK_IO */

        IF ( MOD(lastinterval,deltaTClock) .GT. 0. )
     &       lastinterval = MAX(
     &       INT(lastinterval/deltaTClock-1)*deltaTClock,deltaTClock)


#if (defined ALLOW_COST_HFLUXM) || (defined ALLOW_COST_TEMP)
c-- get the weights for the cost functions
      CALL COST_WEIGHTS( myThid )
cgf : to compile previous line user is expected to provide cost_weights.F
#endif

      IF ( mult_depth .NE. UNSET_RL ) THEN
       WRITE(msgBuf,'(a)')
     & 'S/R COST_READPARMS: mult_depth is now longer allow in data.cost'
       CALL PRINT_ERROR( msgBuf, myThid )
       WRITE(msgBuf,'(a)')
     & 'S/R COST_READPARMS: use generic control cost instead'
       CALL PRINT_ERROR( msgBuf, myThid )
       CALL ALL_PROC_DIE( 0 )
       STOP 'ABNORMAL END: S/R COST_READPARMS'
      ENDIF

C--   print cost parameters to stdout for better debugging
      WRITE(msgBuf,'(A)')
     &'// ======================================================='
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(a)') '// cost configuration  >>> START <<<'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)')
     &'// ======================================================='
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )

      CALL WRITE_0D_RL( lastinterval, INDEX_NONE,'lastinterval =',
     &'   /* cost interval over which to average ( s ). */')
C
       CALL WRITE_0D_C( cost_mask_file, -1, INDEX_NONE,
     &  'cost_mask_file =', ' /* file name of cost mask file */')

      WRITE(msgBuf,'(A)')
     &'// ======================================================='
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)') '// cost configuration  >>> END <<<'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)')
     &'// ======================================================='
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)') ' '
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )

      _END_MASTER( myThid )

      _BARRIER

      RETURN
      END

#include "FIZHI_OPTIONS.h"
      SUBROUTINE fizhi_tendency_apply_u(
     U                        gU_arr,
     I                        iMin,iMax,jMin,jMax, kLev, bi, bj,
     I                        myTime, myIter, myThid )
C=======================================================================
C Routine: fizhi_tendency_apply_u
C     Interpolate tendencies from physics grid to dynamics grid and
C     add fizhi tendency terms to U tendency.
C
C INPUT:
C     iMin - Working range of tile for applying forcing.
C     iMax
C     jMin
C     jMax
C     kLev
C
C Notes: Routine works for one level at a time
C        Assumes that U and V tendencies are already on C-Grid
C=======================================================================
      IMPLICIT NONE

#include "SIZE.h"
#include "GRID.h"
#include "EEPARAMS.h"
#include "DYNVARS.h"
#include "fizhi_SIZE.h"
#include "fizhi_land_SIZE.h"
#include "fizhi_coms.h"

      _RL     gU_arr(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER iMin, iMax, jMin, jMax
      INTEGER kLev, bi, bj
      _RL     myTime
      INTEGER myIter
      INTEGER myThid

      _RL rayleighdrag
      _RL tmpdiag(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER i, j
#ifdef ALLOW_DIAGNOSTICS
      LOGICAL  DIAGNOSTICS_IS_ON
      EXTERNAL DIAGNOSTICS_IS_ON
#endif

      IF ( klev.EQ.Nr .OR. rC(klev).LT.1000. ) THEN
       rayleighdrag = 1./(31.*86400.*2.)
      ELSE
       rayleighdrag = 0.
      ENDIF

      DO j=jMin,jMax
       DO i=iMin,iMax
        gU_arr(i,j) = gU_arr(i,j)
     &              + maskW(i,j,kLev,bi,bj)
     &               *( guphy(i,j,kLev,bi,bj)
     &                - rayleighdrag*uVel(i,j,kLev,bi,bj) )
       ENDDO
      ENDDO

      IF ( DIAGNOSTICS_IS_ON('DIABUDYN',myThid) ) THEN
       DO j=jMin,jMax
       DO i=iMin,iMax
        tmpdiag(i,j) = maskW(i,j,kLev,bi,bj)
     &               *( guphy(i,j,kLev,bi,bj)
     &                - rayleighdrag*uVel(i,j,kLev,bi,bj) )
     &               * 86400
       ENDDO
       ENDDO
       CALL DIAGNOSTICS_FILL(tmpdiag,'DIABUDYN',kLev,1,2,bi,bj,myThid)
      ENDIF

      IF ( DIAGNOSTICS_IS_ON('RFU     ',myThid) ) THEN
       DO j=jMin,jMax
       DO i=iMin,iMax
        tmpdiag(i,j) = -1. _d 0 * rayleighdrag *
     &       maskW(i,j,kLev,bi,bj)*uVel(i,j,kLev,bi,bj) * 86400
       ENDDO
       ENDDO
       CALL DIAGNOSTICS_FILL(tmpdiag,'RFU     ',kLev,1,2,bi,bj,myThid)
      ENDIF

      RETURN
      END
      SUBROUTINE fizhi_tendency_apply_v(
     U                        gV_arr,
     I                        iMin,iMax,jMin,jMax, kLev, bi, bj,
     I                        myTime, myIter, myThid )
C=======================================================================
C Routine: fizhi_tendency_apply_v
C     Interpolate tendencies from physics grid to dynamics grid and
C     add fizhi tendency terms to V tendency.
C
C INPUT:
C     iMin - Working range of tile for applying forcing.
C     iMax
C     jMin
C     jMax
C     kLev
C
C Notes: Routine works for one level at a time
C        Assumes that U and V tendencies are already on C-Grid
C=======================================================================
      IMPLICIT NONE

#include "SIZE.h"
#include "GRID.h"
#include "EEPARAMS.h"
#include "DYNVARS.h"
#include "fizhi_SIZE.h"
#include "fizhi_land_SIZE.h"
#include "fizhi_coms.h"

      _RL     gV_arr(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER iMin, iMax, jMin, jMax
      INTEGER kLev, bi, bj
      _RL     myTime
      INTEGER myIter
      INTEGER myThid

      _RL rayleighdrag
      _RL tmpdiag(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER i, j
#ifdef ALLOW_DIAGNOSTICS
      LOGICAL  DIAGNOSTICS_IS_ON
      EXTERNAL DIAGNOSTICS_IS_ON
#endif

      IF ( klev.EQ.Nr .OR. rC(klev).LT.1000. ) THEN
       rayleighdrag = 1./(31.*86400.*2.)
      ELSE
       rayleighdrag = 0.
      ENDIF

      DO j=jMin,jMax
       DO i=iMin,iMax
        gV_arr(i,j) = gV_arr(i,j)
     &              + maskS(i,j,kLev,bi,bj)
     &               *( gvphy(i,j,kLev,bi,bj)
     &                - rayleighdrag*vVel(i,j,kLev,bi,bj) )
       ENDDO
      ENDDO

      IF ( DIAGNOSTICS_IS_ON('DIABVDYN',myThid) ) THEN
       DO j=jMin,jMax
       DO i=iMin,iMax
        tmpdiag(i,j) = maskS(i,j,kLev,bi,bj)
     &               *( gvphy(i,j,kLev,bi,bj)
     &                - rayleighdrag*vVel(i,j,kLev,bi,bj) )
     &               * 86400
       ENDDO
       ENDDO
       CALL DIAGNOSTICS_FILL(tmpdiag,'DIABVDYN',kLev,1,2,bi,bj,myThid)
      ENDIF

      IF ( DIAGNOSTICS_IS_ON('RFV     ',myThid) ) THEN
       DO j=jMin,jMax
       DO i=iMin,iMax
        tmpdiag(i,j) = -1. _d 0 * rayleighdrag *
     &       maskS(i,j,kLev,bi,bj)*vVel(i,j,kLev,bi,bj) * 86400
       ENDDO
       ENDDO
       CALL DIAGNOSTICS_FILL(tmpdiag,'RFV     ',kLev,1,2,bi,bj,myThid)
      ENDIF

      RETURN
      END
      SUBROUTINE fizhi_tendency_apply_t(
     U                        gT_arr,
     I                        iMin,iMax,jMin,jMax, kLev, bi, bj,
     I                        myTime, myIter, myThid )
C=======================================================================
C Routine: fizhi_tendency_apply_t
C     Interpolate tendencies from physics grid to dynamics grid and
C     add fizhi tendency terms to T (theta) tendency.
C
C INPUT:
C     iMin - Working range of tile for applying forcing.
C     iMax
C     jMin
C     jMax
C     kLev
C
C Notes: Routine works for one level at a time
C=======================================================================
      IMPLICIT NONE

#include "SIZE.h"
#include "GRID.h"
#include "EEPARAMS.h"
#include "DYNVARS.h"
#include "fizhi_SIZE.h"
#include "fizhi_land_SIZE.h"
#include "fizhi_coms.h"

      _RL     gT_arr(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER iMin, iMax, jMin, jMax
      INTEGER kLev, bi, bj
      _RL     myTime
      INTEGER myIter
      INTEGER myThid

      _RL rayleighdrag,getcon,cp,kappa,pNrkappa
      _RL tmpdiag(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER i, j
#ifdef ALLOW_DIAGNOSTICS
      LOGICAL  DIAGNOSTICS_IS_ON
      EXTERNAL DIAGNOSTICS_IS_ON
#endif

      IF ( klev.EQ.Nr .OR. rC(klev).LT.1000. ) THEN
       cp = getcon('CP')
       kappa = getcon('KAPPA')
       pNrkappa = (rC(klev)/100000.)**kappa
       rayleighdrag = 1./((31.*86400.*2.)*(pNrkappa*cp))
      ELSE
       rayleighdrag = 0.
      ENDIF

      DO j=jMin,jMax
       DO i=iMin,iMax
        gT_arr(i,j) = gT_arr(i,j)
     &    + ( maskC(i,j,kLev,bi,bj)*gthphy(i,j,kLev,bi,bj)
     &      + rayleighdrag * 0.5
     &        *( maskW(i,j,kLev,bi,bj)
     &              *uVel(i,j,kLev,bi,bj)*uVel(i,j,kLev,bi,bj)
     &         + maskW(i+1,j,kLev,bi,bj)
     &              *uVel(i+1,j,kLev,bi,bj)*uVel(i+1,j,kLev,bi,bj)
     &         + maskS(i,j,kLev,bi,bj)
     &              *vVel(i,j,kLev,bi,bj)*vVel(i,j,kLev,bi,bj)
     &         + maskS(i,j+1,kLev,bi,bj)
     &              *vVel(i,j+1,kLev,bi,bj)*vVel(i,j+1,kLev,bi,bj)
     &         ) )
       ENDDO
      ENDDO

      IF ( DIAGNOSTICS_IS_ON('DIABTDYN',myThid) ) THEN
       DO j=jMin,jMax
       DO i=iMin,iMax
        tmpdiag(i,j) =
     &      ( maskC(i,j,kLev,bi,bj)*gthphy(i,j,kLev,bi,bj)
     &      + rayleighdrag * 0.5
     &        *( maskW(i,j,kLev,bi,bj)
     &              *uVel(i,j,kLev,bi,bj)*uVel(i,j,kLev,bi,bj)
     &         + maskW(i+1,j,kLev,bi,bj)
     &              *uVel(i+1,j,kLev,bi,bj)*uVel(i+1,j,kLev,bi,bj)
     &         + maskS(i,j,kLev,bi,bj)
     &              *vVel(i,j,kLev,bi,bj)*vVel(i,j,kLev,bi,bj)
     &         + maskS(i,j+1,kLev,bi,bj)
     &              *vVel(i,j+1,kLev,bi,bj)*vVel(i,j+1,kLev,bi,bj)
     &         ) ) * 86400
       ENDDO
       ENDDO
       CALL DIAGNOSTICS_FILL(tmpdiag,'DIABTDYN',kLev,1,2,bi,bj,myThid)
      ENDIF

      IF ( DIAGNOSTICS_IS_ON('RFT     ',myThid) ) THEN
       DO j=jMin,jMax
       DO i=iMin,iMax
        tmpdiag(i,j) = ( rayleighdrag * 0.5
     &        *( maskW(i,j,kLev,bi,bj)
     &              *uVel(i,j,kLev,bi,bj)*uVel(i,j,kLev,bi,bj)
     &         + maskW(i+1,j,kLev,bi,bj)
     &              *uVel(i+1,j,kLev,bi,bj)*uVel(i+1,j,kLev,bi,bj)
     &         + maskS(i,j,kLev,bi,bj)
     &              *vVel(i,j,kLev,bi,bj)*vVel(i,j,kLev,bi,bj)
     &         + maskS(i,j+1,kLev,bi,bj)
     &              *vVel(i,j+1,kLev,bi,bj)*vVel(i,j+1,kLev,bi,bj)
     &         ) ) * 86400
       ENDDO
       ENDDO
       CALL DIAGNOSTICS_FILL(tmpdiag,'RFT     ',kLev,1,2,bi,bj,myThid)
      ENDIF

      RETURN
      END
      SUBROUTINE fizhi_tendency_apply_s(
     U                        gS_arr,
     I                        iMin,iMax,jMin,jMax, kLev, bi, bj,
     I                        myTime, myIter, myThid )
C=======================================================================
C Routine: fizhi_tendency_apply_s
C     Interpolate tendencies from physics grid to dynamics grid and
C     add fizhi tendency terms to S tendency.
C
C INPUT:
C     iMin - Working range of tile for applying forcing.
C     iMax
C     jMin
C     jMax
C     kLev
C
C Notes: Routine works for one level at a time
C=======================================================================
      IMPLICIT NONE

#include "SIZE.h"
#include "GRID.h"
#include "EEPARAMS.h"
#include "DYNVARS.h"
#include "fizhi_SIZE.h"
#include "fizhi_land_SIZE.h"
#include "fizhi_coms.h"

      _RL     gS_arr(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER iMin, iMax, jMin, jMax
      INTEGER kLev, bi, bj
      _RL     myTime
      INTEGER myIter
      INTEGER myThid

      _RL tmpdiag(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER i, j
#ifdef ALLOW_DIAGNOSTICS
      LOGICAL  DIAGNOSTICS_IS_ON
      EXTERNAL DIAGNOSTICS_IS_ON
#endif

      DO j=jMin,jMax
       DO i=iMin,iMax
        gS_arr(i,j) = gS_arr(i,j)
     &    + maskC(i,j,kLev,bi,bj)*gsphy(i,j,kLev,bi,bj)
       ENDDO
      ENDDO

      IF ( DIAGNOSTICS_IS_ON('DIABQDYN',myThid) ) THEN
       DO j=jMin,jMax
       DO i=iMin,iMax
        tmpdiag(i,j) = ( maskC(i,j,kLev,bi,bj) * gsphy(i,j,kLev,bi,bj) )
     &    * 86400
       ENDDO
       ENDDO
       CALL DIAGNOSTICS_FILL(tmpdiag,'DIABQDYN',kLev,1,2,bi,bj,myThid)
      ENDIF

      RETURN
      END

#include "SEAICE_OPTIONS.h"
#ifdef ALLOW_OBCS
# include "OBCS_OPTIONS.h"
#endif

CBOP
C     !ROUTINE: SEAICE_BOTTOMDRAG_COEFFS
C     !INTERFACE:
      SUBROUTINE SEAICE_BOTTOMDRAG_COEFFS(
     I     uIceLoc, vIceLoc, HEFFMLoc,
#ifdef SEAICE_ITD
     I     HEFFITDLoc, AREAITDLoc, AREALoc,
#else
     I     HEFFLoc, AREALoc,
#endif
     O     CbotLoc,
     I     iStep, myTime, myIter, myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE SEAICE_BOTTOMDRAG_COEFFS
C     | o Compute the non-linear drag coefficients for ice-bottom
C     |   drag, as a parameterization for grounding fastice
C     |   following
C     |   Lemieux et al. (2015), doi:10.1002/2014JC010678
C     *==========================================================*
C     | written by Martin Losch, Apr 2016
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "DYNVARS.h"
#include "SEAICE_SIZE.h"
#include "SEAICE_PARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
C     u/vIceLoc :: local copies of the current ice velocity
C     HEFFMLoc  :: local copy of land-sea masks
C     CbotLoc   :: drag coefficients
C     iStep     :: current sub-time step iterate
C     myTime    :: Simulation time
C     myIter    :: Simulation timestep number
C     myThid    :: my Thread Id. number
      _RL uIceLoc   (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL vIceLoc   (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL HEFFMLoc  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
#ifdef SEAICE_ITD
      _RL HEFFITDLoc(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nITD,nSx,nSy)
      _RL AREAITDLoc(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nITD,nSx,nSy)
#else
      _RL HEFFLoc   (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
#endif
      _RL AREALoc   (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL CbotLoc   (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      INTEGER iStep
      _RL     myTime
      INTEGER myIter
      INTEGER myThid

#ifdef SEAICE_ALLOW_BOTTOMDRAG
C     === local variables ===
C     i,j,bi,bj,ksrf :: loop indices
      INTEGER i,j,bi,bj
      INTEGER kSrf
#ifdef SEAICE_ITD
      INTEGER k
#endif /* SEAICE_ITD */
      _RL     tmpFld(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL     tmp, hActual, hCrit, recip_k1, u0sq, fac, rFac
CEOP

      IF (SEAICEbasalDragK2.GT.0. _d 0) THEN
C     avoid this computation for a non-zero coefficient
      IF ( usingPCoords ) THEN
       kSrf = Nr
      ELSE
       kSrf = 1
      ENDIF
C     some abbreviations
      u0sq     = SEAICEbasalDragU0*SEAICEbasalDragU0
      recip_k1 = 0. _d 0
      IF ( SEAICEbasalDragK1 .GT. 0. _d 0 )
     &     recip_k1 = 1. _d 0/SEAICEbasalDragK1
C     fac scales the soft maximum for more accuracy
      fac = 10. _d 0
      rFac = 1./fac

      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          CbotLoc(i,j,bi,bj) = 0. _d 0
          tmpFld (i,j)       = 0. _d 0
         ENDDO
        ENDDO
        DO j=1-OLy,sNy+OLy-1
         DO i=1-OLx,sNx+OLx-1
          IF ( AREALoc(i,j,bi,bj) .GT. 0.01 _d 0 ) THEN
#ifdef OBCS_UVICE_OLD
           tmp = 0.25 _d 0*(
     &          (   uIceLoc(i  ,j,bi,bj)+uIceLoc(i+1,j,bi,bj)
     &          )**2
     &          + ( vIceLoc(i, j ,bi,bj)+vIceLoc(i,j+1,bi,bj)
     &          )**2 )
#else /* OBCS_UVICE_OLD */
           tmp = 0.25 _d 0*(
     &          ( uIceLoc(i  ,j,bi,bj)*maskInW( i ,j,bi,bj)
     &          + uIceLoc(i+1,j,bi,bj)*maskInW(i+1,j,bi,bj) )**2
     &        + ( vIceLoc(i,j  ,bi,bj)*maskInS(i,j  ,bi,bj)
     &          + vIceLoc(i,j+1,bi,bj)*maskInS(i,j+1,bi,bj) )**2 )
#endif /* OBCS_UVICE_OLD */
           tmpFld(i,j) = SEAICEbasalDragK2 / SQRT(tmp + u0sq)
          ENDIF
         ENDDO
        ENDDO
#ifdef SEAICE_ITD
        DO k=1,nITD
#endif /* SEAICE_ITD */
         DO j=1-OLy,sNy+OLy-1
          DO i=1-OLx,sNx+OLx-1
           IF ( AREALoc(i,j,bi,bj) .GT. 0.01 _d 0 ) THEN
CML           hActual = HEFFLoc(i,j,bi,bj)
CML     &          /SQRT( AREAITDLoc(i,j,bi,bj)**2 + area_reg_sq )
CML           hActual = SQRT(hActual * hActual + hice_reg_sq)
CML           hCrit   = ABS(R_low(i,j,bi,bj)) * recip_k1
#ifdef SEAICE_ITD
            hActual = HEFFITDLoc(i,j,k,bi,bj)
C     here we do not need recip_k1, because we resolve the very thick ice
            hCrit   = ABS(R_low(i,j,bi,bj))*AREAITDLoc(i,j,k,bi,bj)
#else
            hActual = HEFFLoc(i,j,bi,bj)
            hCrit   = ABS(R_low(i,j,bi,bj))*AREALoc(i,j,bi,bj)*recip_k1
#endif /* SEAICE_ITD */
C     we want to have some soft maximum for better differentiability:
C     max(a,b;k) = ln(exp(k*a)+exp(k*b))/k
C     In our case, b=0, so exp(k*b) = 1.
C     max(a,0;k) = ln(exp(k*a)+1)/k
C     If k*a gets too large, EXP will overflow, but for the anticipated
C     values of hActual < 100m, and k=10, this should be very unlikely
CML             CbotLoc(i,j,bi,bj) =
CML     &            tmpFld(i,j) * MAX( hActual - hCrit, 0. _d 0)
            CbotLoc(i,j,bi,bj) = CbotLoc(i,j,bi,bj)
     &           + tmpFld(i,j)
     &           * LOG(EXP( fac*(hActual - hCrit) ) + 1. _d 0)*rFac
     &           * EXP( - SEAICE_cBasalStar
     &                  *(SEAICE_area_max - AREALoc(i,j,bi,bj)) )
     &           * HEFFMLoc(i,j,bi,bj)
           ENDIF
          ENDDO
         ENDDO
#ifdef SEAICE_ITD
        ENDDO
#endif /* SEAICE_ITD */
       ENDDO
      ENDDO
C     endif SEAICEbasalDragK2.GT.0.
      ENDIF
#endif /* SEAICE_ALLOW_BOTTOMDRAG */

      RETURN
      END

#include "GCHEM_OPTIONS.h"
#ifdef ALLOW_DARWIN
#include "DARWIN_OPTIONS.h"
#endif

C !INTERFACE: ==========================================================
      SUBROUTINE GCHEM_OUTPUT( myTime, myIter, myThid )

C !DESCRIPTION:
C calls subroutine that calculate diagnostic specific to
C any tracer epxperiment
C also calls gchem monitor

C !USES: ===============================================================
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GCHEM.h"

C !INPUT PARAMETERS: ===================================================
C  myThid   :: my Thread Id number
      _RL     myTime
      INTEGER myIter
      INTEGER myThid
CEOP

#ifdef ALLOW_GCHEM
cccccccccccccccccccccc
c diagnostics        c
cccccccccccccccccccccc

#ifdef ALLOW_DARWIN
#ifdef ALLOW_TIMEAVE
      IF ( useDARWIN ) THEN
       CALL DARWIN_DIAGS( myTime, myIter, myThid )
#ifdef ALLOW_CARBON
       CALL DIC_DIAGS( myTime, myIter, myThid )
#endif
      ENDIF
#endif
#endif

#endif /* ALLOW_GCHEM */

      RETURN
      END

#include "GMREDI_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 0
C     !ROUTINE: GMREDI_MNC_INIT

C     !INTERFACE:
      SUBROUTINE GMREDI_MNC_INIT( myThid )

C     !DESCRIPTION:
C     Initialize MNC lookup tables for GMRedi.

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GMREDI.h"

C     !INPUT PARAMETERS:
      INTEGER myThid
CEOP

#ifdef ALLOW_GMREDI
#ifdef ALLOW_MNC

      IF (useMNC) THEN

        CALL MNC_CW_ADD_VNAME('Kux','U_xy_Hn__C__t', 4,5,myThid)
        CALL MNC_CW_ADD_VATTR_TEXT('Kux','units','m^2/s', myThid)
        CALL MNC_CW_ADD_VATTR_TEXT('Kux','description',
     &       'GM Tensor Kux is K_11 element, X direction at U point',
     &       myThid)
C        CALL MNC_CW_ADD_VATTR_TEXT('Kux',
C    &       'coordinates','XC YC RC iter', myThid)

        CALL MNC_CW_ADD_VNAME('Kvy','V_xy_Hn__C__t', 4,5,myThid)
        CALL MNC_CW_ADD_VATTR_TEXT('Kvy','units','m^2/s', myThid)
        CALL MNC_CW_ADD_VATTR_TEXT('Kvy','description',
     &       'GM Tensor Kvy is K_22 element, Y direction at V point',
     &       myThid)

        CALL MNC_CW_ADD_VNAME('Kuz','U_xy_Hn__C__t', 4,5,myThid)
        CALL MNC_CW_ADD_VATTR_TEXT('Kuz','units','m^2/s', myThid)
        CALL MNC_CW_ADD_VATTR_TEXT('Kuz','description',
     &       'GM Tensor Kuz is K_13 element, Z direction at U point',
     &       myThid)

        CALL MNC_CW_ADD_VNAME('Kvz','V_xy_Hn__C__t', 4,5,myThid)
        CALL MNC_CW_ADD_VATTR_TEXT('Kvz','units','m^2/s', myThid)
        CALL MNC_CW_ADD_VATTR_TEXT('Kvz','description',
     &       'GM Tensor Kvz is K_23 element, Z direction at V point',
     &       myThid)

        CALL MNC_CW_ADD_VNAME('Kwx','Cen_xy_Hn__L__t', 4,5,myThid)
        CALL MNC_CW_ADD_VATTR_TEXT('Kwx','units','m^2/s', myThid)
        CALL MNC_CW_ADD_VATTR_TEXT('Kwx','description',
     &       'GM Tensor Kwx is K_31 element, X direction at W point',
     &       myThid)

        CALL MNC_CW_ADD_VNAME('Kwy','Cen_xy_Hn__L__t', 4,5,myThid)
        CALL MNC_CW_ADD_VATTR_TEXT('Kwy','units','m^2/s', myThid)
        CALL MNC_CW_ADD_VATTR_TEXT('Kwy','description',
     &       'GM Tensor Kwy is K_32 element, Y direction at W point',
     &       myThid)

        CALL MNC_CW_ADD_VNAME('Kwz','Cen_xy_Hn__L__t', 4,5,myThid)
        CALL MNC_CW_ADD_VATTR_TEXT('Kwz','units','m^2/s', myThid)
        CALL MNC_CW_ADD_VATTR_TEXT('Kwz','description',
     &       'GM Tensor Kwz is K_33 element, Z direction at W point',
     &       myThid)

        CALL MNC_CW_ADD_VNAME('VisbK','Cen_xy_Hn__-__t',3,4,myThid)
        CALL MNC_CW_ADD_VATTR_TEXT('VisbK','units','m^2/s', myThid)
        CALL MNC_CW_ADD_VATTR_TEXT('VisbK','description',
     &       'GM mixing/stirring coef after Visbeck et al.',
     &       myThid)

        CALL MNC_CW_ADD_VNAME('PsiX','Cen_xy_Hn__C__t',4,5,myThid)
        CALL MNC_CW_ADD_VATTR_TEXT('PsiX','units','m^2/s', myThid)
        CALL MNC_CW_ADD_VATTR_TEXT('PsiX','description',
     &       'GM bolus velocity streamfunction in X',
     &       myThid)

        CALL MNC_CW_ADD_VNAME('PsiY','Cen_xy_Hn__C__t',4,5,myThid)
        CALL MNC_CW_ADD_VATTR_TEXT('PsiY','units','m^2/s', myThid)
        CALL MNC_CW_ADD_VATTR_TEXT('PsiY','description',
     &       'GM bolus velocity streamfunction in Y', 
     &       myThid)

      ENDIF

#endif /* ALLOW_MNC */
#endif /* ALLOW_GMREDI */

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#include "PACKAGES_CONFIG.h"
#include "CPP_OPTIONS.h"

CBOP
C     !ROUTINE: INITIALISE_FIXED
C     !INTERFACE:
      SUBROUTINE INITIALISE_FIXED( myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE INITIALISE_FIXED
C     | o Routine for setting fixed model arrays such as
C     |   topography, grid, solver matrices, etc.
C     *==========================================================*
C     | INITIALISE_FIXED is invoked at the start of the model to
C     | set fixed model arrays. It reads data from an input file
C     | and from various binary files.
C     | Each thread invokes an instance of this routine as does
C     | each process in a multi-process parallel environment like
C     | MPI.
C     *==========================================================*
C     \ev

C     !CALLING SEQUENCE:
C     INITIALISE_FIXED
C      |
C      |-- INI_PARMS
C      |
C      |-- PACKAGES_BOOT
C      |
C      |-- CPL_IMPORT_CPLPARMS
C      |
C      |-- PACKAGES_READPARMS
C      |  |- ${PKG}_READPARMS
C      |
C      |-- SET_PARMS
C      |
C      |-- INI_MODEL_IO
C      |  |- MNC_INIT + MNC_CW_INIT
C      |  |- MON_INIT
C      |
C      |-- INI_GRID
C      |
C      |-- LOAD_REF_FILES
C      |
C      |-- INI_EOS
C      |
C      |-- SET_REF_STATE
C      |
C      |-- SET_GRID_FACTORS
C      |
C      |-- INI_DEPTHS
C      |
C      |-- INI_MASKS_ETC
C      |
C      |-- PACKAGES_INIT_FIXED
C      |  |- ${PKG}_INIT_FIXED
C      |
C      |-- INI_GLOBAL_DOMAIN
C      |
C      |-- INI_LINEAR_PHISURF
C      |
C      |-- INI_CORI
C      |
C      |-- INI_CG2D
C      |
C      |-- INI_CG3D
C      |
C      |-- CONFIG_SUMMARY
C      |
C      |-- PACKAGES_CHECK
C      |  |- ${PKG}_CHECK
C      |
C      |-- CONFIG_CHECK
C      |
C      |-- WRITE_GRID
C      |
C      |-- CPL_EXCH_CONFIGS

C     !USES:
      IMPLICIT NONE
C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
      INTEGER myThid
CEOP

#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_ENTER('INITIALISE_FIXED',myThid)
#endif

C-    here is a way to deliberately break the barrier syncronization
C     by adding a BARRIER on thread XXX only ; Used to test BAR_CHECK.
c     IF ( myThid.EQ.XXX ) THEN
c       _BARRIER
c       CALL SYSTEM('sleep 1')
c     ENDIF
C--   Check barrier synchronization:
      CALL BAR_CHECK( 2, myThid )

C--   Set model parameters.
C     Parameters are set to defaults and then updates are read from
C     an input file called data.
#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_CALL('INI_PARMS',myThid)
#endif
      CALL INI_PARMS( myThid )

C--   Configure packages
#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_CALL('PACKAGES_BOOT',myThid)
#endif
      CALL PACKAGES_BOOT( myThid )

#ifdef COMPONENT_MODULE
C--   Import coupling exchange parameters from coupler
      IF ( useCoupler ) THEN
# ifdef ALLOW_DEBUG
        IF (debugMode) CALL DEBUG_CALL('CPL_IMPORT_CPLPARMS',myThid)
# endif
        CALL CPL_IMPORT_CPLPARMS( myThid )
      ENDIF
#endif /* COMPONENT_MODULE */

C--   Read configuration parameters for packages
#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_CALL('PACKAGES_READPARMS',myThid)
#endif
      CALL PACKAGES_READPARMS( myThid )

C--   Set (or reset) parameters (at this point, know which packages are used);
C     after this call, main model parameters are not supposed to be modified.
#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_CALL('SET_PARMS',myThid)
#endif
      CALL SET_PARMS( myThid )

C--   Write units/set precision/etc for I/O (pickup, MDS/RW, MNC, MONITOR):
#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_CALL('INI_MODEL_IO',myThid)
#endif
      CALL INI_MODEL_IO( myThid )

C--   Set model grid.
C     Variables defining model grid spacing are defined.
#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_CALL('INI_GRID',myThid)
#endif
#ifdef ALLOW_OPENAD
      CALL OpenAD_INI_GRID( myThid )
#else
      CALL INI_GRID( myThid )
#endif

C--   Load reference profiles from files
#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_CALL('LOAD_REF_FILES',myThid)
#endif
      CALL LOAD_REF_FILES( myThid )

C--   Set equation of state parameters.
#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_CALL('INI_EOS',myThid)
#endif
      CALL INI_EOS( myThid )

C--   Set reference state (vertical reference profiles)
#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_CALL('SET_REF_STATE',myThid)
#endif
      CALL SET_REF_STATE( myThid )

C--   Set remaining grid factors
#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_CALL('SET_GRID_FACTORS',myThid)
#endif
      CALL SET_GRID_FACTORS( myThid )

C--   Initialise map of depths
#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_CALL('INI_DEPTHS',myThid)
#endif
#ifdef ALLOW_OPENAD
      CALL OpenAD_INI_DEPTHS( myThid )
#else
      CALL INI_DEPTHS( myThid )
#endif

C--   Derive masks, lopping factors and recipricols of quantities.
C     Volumes and areas are set according to grid and depth map.
#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_CALL('INI_MASKS_ETC',myThid)
#endif
#ifdef ALLOW_OPENAD
      CALL OpenAD_INI_MASKS_ETC( myThid )
#else
      CALL INI_MASKS_ETC( myThid )
#endif

C--   Synchronize all threads after setting masks and before pkgs init.
      _BARRIER

C--   Call fixed data initialization phase of packages
#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_CALL('PACKAGES_INIT_FIXED',myThid)
#endif
      CALL PACKAGES_INIT_FIXED( myThid )

C--   Set some domain-dependent (global) constant (e.g., globalArea)
#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_CALL('INI_GLOBAL_DOMAIN',myThid)
#endif
      CALL INI_GLOBAL_DOMAIN( myThid )

C--   Set Bo_surf => define the Linear Relation: Phi_surf(eta)
#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_CALL('INI_LINEAR_PHISURF',myThid)
#endif
#ifdef ALLOW_OPENAD
      CALL OpenAD_INI_LINEAR_PHISURF( myThid )
#else
      CALL INI_LINEAR_PHISURF( myThid )
#endif

C--   Set coriolis operators
#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_CALL('INI_CORI',myThid)
#endif
#ifdef ALLOW_OPENAD
      CALL OpenAD_INI_CORI( myThid )
#else
      CALL INI_CORI( myThid )
#endif

C--   Set laplace operators for use in 2D conjugate gradient solver.
#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_CALL('INI_CG2D',myThid)
#endif
#ifdef ALLOW_OPENAD
      CALL OpenAD_INI_CG2D( myThid )
#else
      CALL INI_CG2D( myThid )
#endif

#ifdef ALLOW_NONHYDROSTATIC
C--   Set laplace operators for use in 3D conjugate gradient solver.
#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_CALL('INI_CG3D',myThid)
#endif
      CALL INI_CG3D( myThid )
#endif

C--   Finally summarise the model configuration
#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_CALL('CONFIG_SUMMARY',myThid)
#endif
      CALL CONFIG_SUMMARY( myThid )

C--   Check packages configuration (& print summary)
#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_CALL('PACKAGES_CHECK',myThid)
#endif
      CALL PACKAGES_CHECK( myThid )

C--   Check parameters and model configuration
#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_CALL('CONFIG_CHECK',myThid)
#endif
      CALL CONFIG_CHECK( myThid )

C--   Write grid data and geometry arrays
      IF ( debugLevel.GE.debLevA .OR. startTime.EQ.baseTime ) THEN
#ifdef ALLOW_DEBUG
        IF (debugMode) CALL DEBUG_CALL('WRITE_GRID',myThid)
#endif
        CALL WRITE_GRID( myThid )
      ENDIF

#ifdef COMPONENT_MODULE
C--   Post component-model configuration information to coupler
C     and get config. info for other component(s).
      IF ( useCoupler ) THEN
# ifdef ALLOW_DEBUG
        IF (debugMode) CALL DEBUG_CALL('CPL_EXCH_CONFIGS',myThid)
# endif
        CALL CPL_EXCH_CONFIGS( myThid )
      ENDIF
#endif /* COMPONENT_MODULE */

C--   Check barrier synchronization:
      CALL BAR_CHECK( 3, myThid )

#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_LEAVE('INITIALISE_FIXED',myThid)
#endif

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      RETURN
      END

#include "DIAG_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 0
C     !ROUTINE: DIAGSTATS_GLOBAL

C     !INTERFACE:
      SUBROUTINE DIAGSTATS_GLOBAL(
     O                    qtmp1, qtmp2,
     I                    undef, nLev, jReg,
     I                    ndId, mate, iSp, iSm, myThid )

C     !DESCRIPTION:
C     Retrieve averaged model diagnostic

C     !USES:
      IMPLICIT NONE
#include "EEPARAMS.h"
#include "SIZE.h"
#include "DIAGNOSTICS_SIZE.h"
#include "DIAGNOSTICS.h"

C     !INPUT PARAMETERS:
C     undef     :: Undefined value
C     nLev      :: 2nd Dimension (max Nb of levels) of qtmp1,2 arrays
C     jReg      :: region Index to be process.
C     ndId      :: diagnostic Id number (in available diagnostics list)
C     mate      :: counter mate Id number if any ; 0 otherwise
C     iSp       :: diagnostics  pointer to storage array
C     iSm       :: counter-mate pointer to storage array
C     myThid    :: my thread Id number
      _RL undef
      INTEGER nLev, jReg, ndId, mate, iSp, iSm
      INTEGER myThid

C     !OUTPUT PARAMETERS:
C     qtmp1    ..... AVERAGED DIAGNOSTIC QUANTITY
C     qtmp2    ..... working array (used for counter mate statistics)
      _RL qtmp1(0:nStats,0:nLev)
      _RL qtmp2(0:nStats,0:nLev)
CEOP

C     !LOCAL VARIABLES:
      INTEGER im, ix, iv
      PARAMETER ( iv = nStats - 2 , im = nStats - 1 , ix = nStats )
      INTEGER bi, bj
      INTEGER i, k, kd, kCnt, klev, kMlev
      _RL     tmpMin, tmpMax, tmpVol

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C--   Initialize to zero :
      DO k=0,nLev
        DO i=0,nStats
          qtmp1(i,k) = 0.
          qtmp2(i,k) = 0.
        ENDDO
      ENDDO

      klev = kdiag(ndId)
      IF ( mate.GT.0 ) kMlev = kdiag(mate)

      IF (klev.LE.nLev) THEN
C---    Compute global statistics :

C--     Retrieve tile statistics first
        DO bj=myByLo(myThid),myByHi(myThid)
         DO bi=myBxLo(myThid),myBxHi(myThid)

          DO k=1,klev
            kd = iSp + k - 1
            IF ( qSdiag(0,jReg,kd,bi,bj).GT.0. ) THEN
             IF ( qtmp1(0,k).LE.0. ) THEN
              DO i=0,nStats
                qtmp1(i,k) = qSdiag(i,jReg,kd,bi,bj)
              ENDDO
             ELSE
              DO i=0,iv
                qtmp1(i,k) = qtmp1(i,k) + qSdiag(i,jReg,kd,bi,bj)
              ENDDO
              qtmp1(im,k) = MIN( qtmp1(im,k),qSdiag(im,jReg,kd,bi,bj) )
              qtmp1(ix,k) = MAX( qtmp1(ix,k),qSdiag(ix,jReg,kd,bi,bj) )
             ENDIF
            ENDIF
          ENDDO
          IF ( mate.GT.0 ) THEN
           DO k=1,kMlev
            kd = iSm + k - 1
            IF ( qSdiag(0,jReg,kd,bi,bj).GT.0. ) THEN
             IF ( qtmp2(0,k).LE.0. ) THEN
              DO i=0,1
                qtmp2(i,k) = qSdiag(i,jReg,kd,bi,bj)
              ENDDO
             ELSE
              DO i=0,1
                qtmp2(i,k) = qtmp2(i,k) + qSdiag(i,jReg,kd,bi,bj)
              ENDDO
             ENDIF
            ENDIF
           ENDDO
          ENDIF

C-       end tile index loops
         ENDDO
        ENDDO

C--     Global min,max & sum (at each level) over all thread & processors :
        DO k=1,klev
           tmpVol = qtmp1(0,k)
           DO i=0,iv
            _GLOBAL_SUM_RL(qtmp1(i,k),myThid)
           ENDDO
           IF ( qtmp1(0,k).GT.0. .AND. tmpVol.LE.0. ) THEN
C-      In case 1 processor has only empty tiles:
             tmpMax = qtmp1(1,k)/qtmp1(0,k)
             tmpmin = -tmpMax
           ELSE
             tmpMin = -qtmp1(im,k)
             tmpMax =  qtmp1(ix,k)
           ENDIF
           _GLOBAL_MAX_RL(tmpMin,myThid)
           _GLOBAL_MAX_RL(tmpMax,myThid)
           qtmp1(im,k) = -tmpMin
           qtmp1(ix,k) =  tmpMax
        ENDDO
        IF ( mate.GT.0 ) THEN
         DO k=1,kMlev
           DO i=0,1
            _GLOBAL_SUM_RL(qtmp2(i,k),myThid)
           ENDDO
         ENDDO
        ENDIF

C--     Vertical integral, min & max :
        DO k=1,klev
          IF ( qtmp1(0,k).GT.0. ) THEN
           IF ( qtmp1(0,0).LE.0. ) THEN
             DO i=0,nStats
              qtmp1(i,0) = qtmp1(i,k)
             ENDDO
           ELSE
             DO i=0,iv
              qtmp1(i,0) = qtmp1(i,0) + qtmp1(i,k)
             ENDDO
              qtmp1(im,0) = MIN(qtmp1(im,0),qtmp1(im,k))
              qtmp1(ix,0) = MAX(qtmp1(ix,0),qtmp1(ix,k))
           ENDIF
          ENDIF
        ENDDO
        IF ( mate.GT.0 ) THEN
         DO k=1,kMlev
          IF ( qtmp2(0,k).GT.0. ) THEN
           IF ( qtmp2(0,0).LE.0. ) THEN
             DO i=0,1
              qtmp2(i,0) = qtmp2(i,k)
             ENDDO
           ELSE
             DO i=0,1
              qtmp2(i,0) = qtmp2(i,0) + qtmp2(i,k)
             ENDDO
           ENDIF
          ENDIF
         ENDDO
        ENDIF

C--     Average, Standard.Dev.:
C-      no counter diagnostics => average = Sum / vol :
        IF ( mate.EQ.0 ) THEN
          DO k=0,klev
           IF ( qtmp1(0,k).LE.0. ) THEN
             DO i=1,nStats
              qtmp1(i,k) = undef
             ENDDO
           ELSE
             DO i=1,iv
              qtmp1(i,k) = qtmp1(i,k) / qtmp1(0,k)
             ENDDO
C            Variance :
             qtmp1(iv,k) = qtmp1(iv,k) - qtmp1(1,k)*qtmp1(1,k)
C            Standard deviation :
             IF (qtmp1(iv,k).GT.0.) qtmp1(iv,k) = SQRT(qtmp1(iv,k))
           ENDIF
          ENDDO
C         return global (& vertically integrated) volume in qtmp2(0,0):
          qtmp2(0,0) = qtmp1(0,0)
        ELSE
C       With counter diagnostics => average = Sum / Sum(counter) :
          DO k=0,klev
           kCnt = min(k,kMlev)
           IF ( qtmp2(0,kCnt).LE.0. ) THEN
             DO i=1,nStats
              qtmp1(i,k) = undef
             ENDDO
           ELSEIF ( qtmp2(1,kCnt).LE.0. ) THEN
             DO i=1,iv
              qtmp1(i,k) = undef
             ENDDO
           ELSE
             DO i=1,iv
              qtmp1(i,k) = qtmp1(i,k) / qtmp2(1,kCnt)
             ENDDO
C jmc: looks like there is a Pb with how Variance is computed
C            Variance :
             qtmp1(iv,k) = qtmp1(iv,k) - qtmp1(1,k)*qtmp1(1,k)
C            Standard deviation :
             IF (qtmp1(iv,k).GT.0.) qtmp1(iv,k) = SQRT(qtmp1(iv,k))
           ENDIF
          ENDDO
        ENDIF

      ENDIF

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      RETURN
      END

#include "SEAICE_OPTIONS.h"
#ifdef ALLOW_OBCS
# include "OBCS_OPTIONS.h"
#else
# define OBCS_UVICE_OLD
#endif
#ifdef ALLOW_AUTODIFF
# include "AUTODIFF_OPTIONS.h"
#endif

CBOP
C     !ROUTINE: SEAICE_EVP
C     !INTERFACE:
      SUBROUTINE SEAICE_EVP( myTime, myIter, myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE SEAICE_EVP
C     | o Ice dynamics using an EVP solver following
C     |   E. C. Hunke and J. K. Dukowicz. An
C     |   Elastic-Viscous-Plastic Model for Sea Ice Dynamics,
C     |   J. Phys. Oceanogr., 27, 1849-1867 (1997).
C     *==========================================================*
C     | written by Martin Losch, March 2006
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "DYNVARS.h"
#include "GRID.h"
#include "SEAICE_SIZE.h"
#include "SEAICE_PARAMS.h"
#include "SEAICE_GRID.h"
#include "SEAICE.h"

#ifdef ALLOW_AUTODIFF_TAMC
# include "tamc.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
C     myTime :: Simulation time
C     myIter :: Simulation timestep number
C     myThid :: my Thread Id. number
      _RL     myTime
      INTEGER myIter
      INTEGER myThid

#if ( defined SEAICE_CGRID &&  defined SEAICE_ALLOW_EVP )

C     === Local variables ===
C     i,j,bi,bj      :: Loop counters
C     kSrf           :: vertical index of surface layer
C     nEVPstep       :: number of timesteps within the EVP solver
C     iEVPstep       :: Loop counter
C     SIN/COSWAT     :: sine/cosine of turning angle
C     (recip_)ecc2   :: (one over) eccentricity squared
C     recip_evpAlpha :: 1/SEAICE_evpAlpha
C     recip_deltaT   :: 1/SEAICE_deltaTdyn
C     evpStarFac     :: 1 if SEAICEuseEVPstar = .true., 0 otherwise
C     betaFac        :: SEAICE_evpBeta/SEAICE_deltaTdyn=1/SEAICE_deltaTevp
C     betaFacP1      :: betaFac + evpStarFac/SEAICE_deltaTdyn
C     e11,e12,e22    :: components of strain rate tensor
C     seaice_div     :: divergence strain rates at C-points times P
C                       /divided by Delta minus 1
C     seaice_tension :: tension    strain rates at C-points times P
C                       /divided by Delta
C     seaice_shear   :: shear      strain rates, defined at Z-points times P
C                       /divided by Delta
C     sig11, sig22   :: sum and difference of diagonal terms of stress tensor
C     modification for adaptive alpha and beta
C               (see Kimmritz, Danilov, Losch 2015 for gamma << alpha beta)
C     EVPcFac        :: SEAICE_deltaTdyn*SEAICEaEVPcStar*(SEAICEaEVPcoeff*PI)**2
C                        with
C     SEAICEaEVPcStar:: multiple of stabilty factor: alpha*beta = cstar*gamma
C     SEAICEaEVPcoeff:: largest stabilized frequency according to
C                        gamma = zeta * (cfac/cellarea)*deltaT/m
C                                with   (cfac/cellarea) <= pi**2/cellarea
C     evpAlphaC/Z    :: alpha field on C points and on Z points
C                        := sqrt(cstar gamma)
C     evpBetaU/V     :: beta field on u and on v points
C                        := sqrt(cstar gamma)
C     evpAlphaMin    :: lower limit of alpha and beta, regularisation
C                     to prevent singularities of system matrix,
C                     e.g. when ice concentration is too low.
C     betaFacP1U/V   :: = betaFacP1 in standard case,
C                          with varying beta in the adaptive case
C                           on u and on v point
C     betaFacU/V     :: analog betaFacP1U/V

      INTEGER i, j, bi, bj
      INTEGER kSrf
      INTEGER nEVPstep, iEVPstep
#ifndef ALLOW_AUTODIFF
      INTEGER nEVPstepMax
#endif
#ifdef ALLOW_AUTODIFF_TAMC
C     evpkey :: tape key (depends on evp iteration)
C     tkey   :: tape key (depends on tile indices and evpkey)
      INTEGER evpkey, tkey
#endif

      _RL COSWAT
      _RS SINWAT
      _RL ecc2, recip_ecc2, recip_evpAlpha, recip_deltaT
      _RL betaFacP1, betaFac, evpStarFac, evpRevFac, recip_evpRevFac

      _RL seaice_div    (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL seaice_tension(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL seaice_shear  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL sig11         (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL sig22         (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
C     fractional area at velocity points
      _RL areaW         (1:sNx,1:sNy,nSx,nSy)
      _RL areaS         (1:sNx,1:sNy,nSx,nSy)
C     auxilliary variables
      _RL ep            (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL em            (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL e12Csq        (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL pressC        (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL zetaC         (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL deltaZ        (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
C     _RL zetaZ         (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
#ifdef SEAICE_ALLOW_MOM_ADVECTION
C     tendency due to advection of momentum
      _RL gUmom         (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL gVmom         (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
#endif /*  SEAICE_ALLOW_MOM_ADVECTION */
      _RL deltaCreg, deltaSq, deltaMinSq, tmp
#ifdef SEAICE_ALLOW_TEM
      _RL etaDenC, zetaMaxC, etaDenZ, zetaMaxZ
#endif /* SEAICE_ALLOW_TEM */
#ifdef SEAICE_ALLOW_CLIPZETA
      _RL zMaxZ, zMinZ, fac
#endif /* SEAICE_ALLOW_CLIPZETA */
      _RL denom1   (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL denom2   (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL sumNorm, denomU, denomV
      _RL locMaskU, locMaskV
      _RL EVPcFac
      _RL evpAlphaC(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL evpAlphaZ(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL evpBetaU (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL evpBetaV (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL betaFacP1U,  betaFacP1V
      _RL betaFacU,    betaFacV
      LOGICAL useAdaptiveEVP

#ifdef ALLOW_SEAICE_EVP_RESIDUAL
      _RL resTile(nSx,nSy)
      _RL resLoc
      _RL uIcePm1 (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL vIcePm1 (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL sig11pm1(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL sig22pm1(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL sig12pm1(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)

      LOGICAL printResidual
C     CHARACTER*(10) suff
C     !FUNCTIONS:
      LOGICAL  DIFFERENT_MULTIPLE
      EXTERNAL DIFFERENT_MULTIPLE
#endif /* ALLOW_SEAICE_EVP_RESIDUAL */
CEOP

C     set tuning parameters for adaptive EVP
      useAdaptiveEVP = .FALSE.
      IF ( SEAICEaEvpCoeff .NE. UNSET_RL ) useAdaptiveEVP = .TRUE.
      EVPcFac = 0. _d 0
      IF ( useAdaptiveEVP )
     &     EVPcFac = SEAICE_deltaTdyn*SEAICEaEVPcStar
     &                * (SEAICEaEvpCoeff * PI)**2

#ifdef ALLOW_SEAICE_EVP_RESIDUAL
      printResidual = debugLevel.GE.debLevA
     &  .AND. DIFFERENT_MULTIPLE( SEAICE_monFreq, myTime, deltaTClock )
#endif /* ALLOW_SEAICE_EVP_RESIDUAL */
C     surface level
      IF ( usingPCoords ) THEN
       kSrf = Nr
      ELSE
       kSrf = 1
      ENDIF
C--   introduce turning angles
      SINWAT=SIN(SEAICE_waterTurnAngle*deg2rad)
      COSWAT=COS(SEAICE_waterTurnAngle*deg2rad)

C     abbreviation eccentricity squared
      ecc2=SEAICE_eccen**2
      recip_ecc2 = 0. _d 0
      IF ( ecc2 .NE. 0. _d 0 ) recip_ecc2=ONE/ecc2
      deltaMinSq = SEAICE_deltaMin**2
C     copy number of internal time steps from previously defined parameter
      nEVPstep = SEAICEnEVPstarSteps
C     SEAICE_evpAlpha = 2. * SEAICE_evpTauRelax/SEAICE_deltaTevp
      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          denom1(i,j,bi,bj) = 1. _d 0 / ( SEAICE_evpAlpha + 1. _d 0 )
          denom2(i,j,bi,bj) = 1. _d 0 / ( SEAICE_evpAlpha + ecc2 )
         ENDDO
        ENDDO
       ENDDO
      ENDDO
      recip_deltaT = 1. _d 0 / SEAICE_deltaTdyn
      recip_evpAlpha = 0. _d 0
      IF ( SEAICE_evpAlpha .GT. 0. _d 0 )
     &     recip_evpAlpha = 1. _d 0 / SEAICE_evpAlpha
      evpStarFac = 0. _d 0
      evpRevFac  = 0. _d 0
      recip_evpRevFac = 1. _d 0
      IF ( SEAICEuseEVPstar ) evpStarFac = 1. _d 0
      IF ( SEAICEuseEVPrev  ) THEN
C     the Bouillon et al. (2013) discretization in time has  more
C     explicit terms
       evpRevFac       = 1. _d 0
       evpStarFac      = 1. _d 0
       recip_evpRevFac = recip_ecc2
       DO bj=myByLo(myThid),myByHi(myThid)
        DO bi=myBxLo(myThid),myBxHi(myThid)
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           denom1(i,j,bi,bj)     = 1. _d 0 / SEAICE_evpAlpha
           denom2(i,j,bi,bj)     = denom1(i,j,bi,bj)
          ENDDO
         ENDDO
        ENDDO
       ENDDO
      ENDIF
C
      betaFac    = SEAICE_evpBeta*recip_deltaT
      betaFacU   = betaFac
      betaFacV   = betaFac
C
      betaFacP1  = betaFac + evpStarFac*recip_deltaT
      betaFacP1U = betaFacP1
      betaFacP1V = betaFacP1
#ifndef ALLOW_AUTODIFF
      nEVPstepMax = nEVPstep
#endif

      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
C     use u/vIce as work arrays: copy previous time step to u/vIceNm1
          uIceNm1(i,j,bi,bj)   = uIce(i,j,bi,bj)
          vIceNm1(i,j,bi,bj)   = vIce(i,j,bi,bj)
C     initialise strain rates
          e11  (i,j,bi,bj)     = 0. _d 0
          e22  (i,j,bi,bj)     = 0. _d 0
          e12  (i,j,bi,bj)     = 0. _d 0
C     initialise adative-EVP-specific fields
          evpAlphaC(i,j,bi,bj) = SEAICE_evpAlpha
          evpAlphaZ(i,j,bi,bj) = SEAICE_evpAlpha
          evpBetaU (i,j,bi,bj) = SEAICE_evpBeta
          evpBetaV (i,j,bi,bj) = SEAICE_evpBeta
         ENDDO
        ENDDO
C     initialise fractional areas at velocity points
        IF ( SEAICEscaleSurfStress ) THEN
         DO j=1,sNy
          DO i=1,sNx
           areaW(i,j,bi,bj) =
     &          0.5 _d 0*(AREA(i,j,bi,bj)+AREA(i-1,j,bi,bj))
           areaS(i,j,bi,bj) =
     &          0.5 _d 0*(AREA(i,j,bi,bj)+AREA(i,j-1,bi,bj))
          ENDDO
         ENDDO
        ELSE
         DO j=1,sNy
          DO i=1,sNx
           areaW(i,j,bi,bj) = 1. _d 0
           areaS(i,j,bi,bj) = 1. _d 0
          ENDDO
         ENDDO
        ENDIF
       ENDDO
      ENDDO
#ifdef SEAICE_ALLOW_CLIPZETA
C     damping constraint (Hunke, J.Comp.Phys.,2001)
      IF ( SEAICE_evpDampC .GT. 0. _d 0 ) THEN
CML       fac = HALF * SEAICE_evpDampC * SEAICE_evpTauRelax
CML     &      /SEAICE_deltaTevp**2
       fac = 0.25 _d 0 * SEAICE_evpDampC * SEAICE_evpAlpha
     &      /SEAICE_deltaTevp
       DO bj=myByLo(myThid),myByHi(myThid)
        DO bi=myBxLo(myThid),myBxHi(myThid)
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           SEAICE_zMax(i,j,bi,bj) = _rA(i,j,bi,bj) * fac
          ENDDO
         ENDDO
        ENDDO
       ENDDO
      ENDIF
#endif /* SEAICE_ALLOW_CLIPZETA */
C
C     start of the main time loop
      DO iEVPstep = 1, nEVPstepMax
       IF (iEVPstep.LE.nEVPstep) THEN
C
#ifdef ALLOW_AUTODIFF_TAMC
        evpkey = iEVPstep + (ikey_dynamics-1)*nEVPstepMax
CADJ STORE uice           = comlev1_evp, key = evpkey, byte = isbyte
CADJ STORE vice           = comlev1_evp, key = evpkey, byte = isbyte
CADJ STORE seaice_sigma1  = comlev1_evp, key = evpkey, byte = isbyte
CADJ STORE seaice_sigma2  = comlev1_evp, key = evpkey, byte = isbyte
CADJ STORE seaice_sigma12 = comlev1_evp, key = evpkey, byte = isbyte
#endif /* ALLOW_AUTODIFF_TAMC */
C
C     first calculate strain rates and bulk moduli/viscosities
C
        CALL SEAICE_CALC_STRAINRATES(
     I       uIce, vIce,
     O       e11, e22, e12,
     I       iEVPstep, myTime, myIter, myThid )

#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE e11 = comlev1_evp,key = evpkey, byte = isbyte
CADJ STORE e22 = comlev1_evp,key = evpkey, byte = isbyte
CADJ STORE e12 = comlev1_evp,key = evpkey, byte = isbyte
#endif /* ALLOW_AUTODIFF_TAMC */

        DO bj=myByLo(myThid),myByHi(myThid)
         DO bi=myBxLo(myThid),myBxHi(myThid)
#ifdef ALLOW_AUTODIFF_TAMC
          tkey = bi + (bj-1)*nSx + (evpkey-1)*nSx*nSy
#endif /* ALLOW_AUTODIFF_TAMC */
#ifdef ALLOW_SEAICE_EVP_RESIDUAL
C     save previous (p-1) iteration
          IF ( printResidual ) THEN
           DO j=1,sNy
            DO i=1,sNx
             sig11Pm1(i,j,bi,bj) = seaice_sigma1(i,j,bi,bj)
             sig22Pm1(i,j,bi,bj) = seaice_sigma2(i,j,bi,bj)
             sig12Pm1(i,j,bi,bj) = seaice_sigma12(i,j,bi,bj)
             uIcePm1 (i,j,bi,bj) = uIce(i,j,bi,bj)
             vIcePm1 (i,j,bi,bj) = vIce(i,j,bi,bj)
            ENDDO
           ENDDO
          ENDIF
#endif /* ALLOW_SEAICE_EVP_RESIDUAL */
          DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
            seaice_div    (i,j) = 0. _d 0
            seaice_tension(i,j) = 0. _d 0
            seaice_shear  (i,j) = 0. _d 0
            pressC        (i,j) = 0. _d 0
            e12Csq        (i,j) = 0. _d 0
            zetaC         (i,j) = 0. _d 0
            deltaZ        (i,j) = 0. _d 0
            zetaZ   (i,j,bi,bj) = 0. _d 0
            deltaC  (i,j,bi,bj) = 0. _d 0
           ENDDO
          ENDDO
          DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
            ep(i,j) = e11(i,j,bi,bj) + e22(i,j,bi,bj)
            em(i,j) = e11(i,j,bi,bj) - e22(i,j,bi,bj)
           ENDDO
          ENDDO
C     need to do this beforehand for easier vectorization after
C     TAFization
C     average strain rates to C points
          IF ( SEAICEetaZmethod .EQ. 0 ) THEN
           DO j=1-OLy+1,sNy+OLy-1
            DO i=1-OLx+1,sNx+OLx-1
             tmp = 0.25 *
     &            ( e12(i,j  ,bi,bj) + e12(i+1,j  ,bi,bj)
     &            + e12(i,j+1,bi,bj) + e12(i+1,j+1,bi,bj) )
             e12Csq(i,j) = tmp*tmp
            ENDDO
           ENDDO
          ELSEIF ( SEAICEetaZmethod .EQ. 3 ) THEN
           DO j=1-OLy+1,sNy+OLy-1
            DO i=1-OLx+1,sNx+OLx-1
C     area weighted average of the squares of e12 is more accurate
C     (and energy conserving) according to Bouillon et al. 2013, eq (11)
             e12Csq(i,j) = 0.25 _d 0 * recip_rA(i,j,bi,bj) *
     &            ( rAz(i  ,j  ,bi,bj)*e12(i  ,j  ,bi,bj)**2
     &            + rAz(i+1,j  ,bi,bj)*e12(i+1,j  ,bi,bj)**2
     &            + rAz(i  ,j+1,bi,bj)*e12(i  ,j+1,bi,bj)**2
     &            + rAz(i+1,j+1,bi,bj)*e12(i+1,j+1,bi,bj)**2 )
            ENDDO
           ENDDO
          ENDIF
          DO j=0,sNy+1
           DO i=0,sNx+1
            deltaSq = ep(i,j)**2 + recip_ecc2 * em(i,j)**2
     &           + recip_ecc2 * 4. _d 0 * e12Csq(i,j)
#ifdef ALLOW_AUTODIFF
C     avoid sqrt of 0
            deltaC(i,j,bi,bj) = 0. _d 0
            IF ( deltaSq .GT. 0. _d 0 )
     &           deltaC(i,j,bi,bj) = SQRT(deltaSq)
#else
            deltaC(i,j,bi,bj) = SQRT(deltaSq)
#endif /* ALLOW_AUTODIFF */
#ifdef SEAICE_DELTA_SMOOTHREG
C     smooth regularization (without max-function) of delta for
C     better differentiability
CML            deltaCreg  = SQRT(deltaSq + deltaMinSq)
            deltaCreg  = deltaC(i,j,bi,bj) + SEAICE_deltaMin
#else
            deltaCreg  = MAX(deltaC(i,j,bi,bj),SEAICE_deltaMin)
#endif /* SEAICE_DELTA_SMOOTHREG */
            zetaC(i,j) = HALF*( press0(i,j,bi,bj)
     &           * ( 1. _d 0 + tensileStrFac(i,j,bi,bj) )
     &           )/deltaCreg
           ENDDO
          ENDDO
          IF ( useAdaptiveEVP ) THEN
           DO j=0,sNy+1
            DO i=0,sNx+1
CML   I do not like these hidden regularisations, why do we need to
CML   divide by mass?
#ifdef ALLOW_AUTODIFF
             evpAlphaC(i,j,bi,bj) = SEAICE_evpAlpha
             IF ( zetaC(i,j) .GT. 0. _d 0 ) THEN
#endif
             evpAlphaC(i,j,bi,bj) = SQRT(zetaC(i,j)
     &            * EVPcFac / MAX(seaiceMassC(i,j,bi,bj), 1.D-04)
     &            * recip_rA(i,j,bi,bj) ) * HEFFM(i,j,bi,bj)
#ifdef ALLOW_AUTODIFF
             ENDIF
#endif
             evpAlphaC(i,j,bi,bj) =
     &            MAX(evpAlphaC(i,j,bi,bj),SEAICEaEVPalphaMin)
            ENDDO
           ENDDO
          ENDIF
C     compute zetaZ and deltaZ by simple averaging (following
C     Bouillon et al., 2013)
          DO j=1,sNy+1
           DO i=1,sNx+1
            sumNorm = HEFFM(i,j,  bi,bj)+HEFFM(i-1,j,  bi,bj)
     &              + HEFFM(i,j-1,bi,bj)+HEFFM(i-1,j-1,bi,bj)
            IF ( sumNorm.GT.0. _d 0 ) sumNorm = 1. _d 0 / sumNorm
            zetaZ(i,j,bi,bj) = sumNorm *
     &           ( zetaC(i,  j) + zetaC(i-1,j-1)
     &           + zetaC(i-1,j) + zetaC(i,  j-1) )
            deltaZ(i,j) = sumNorm *
     &           ( deltaC(i,  j,bi,bj) + deltaC(i-1,j-1,bi,bj)
     &           + deltaC(i-1,j,bi,bj) + deltaC(i,  j-1,bi,bj) )
           ENDDO
          ENDDO
#ifdef SEAICE_ALLOW_CLIPZETA
#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE zetac            = comlev1_bibj_evp, key = tkey, byte=isbyte
CADJ STORE zetaz(:,:,bi,bj) = comlev1_bibj_evp, key = tkey, byte=isbyte
#endif /* ALLOW_AUTODIFF_TAMC */
C     regularize zeta if necessary
          DO j=0,sNy+1
           DO i=0,sNx+1
            zetaC(i,j)  = MAX( SEAICE_zMin(i,j,bi,bj),
     &           MIN( SEAICE_zMax(i,j,bi,bj), zetaC(i,j) ) )
CML            zetaC(I,J)   = zetaC(I,J)*HEFFM(I,J,bi,bj)
C
C     zMin, zMax are defined at C-points, make sure that they are not
C     masked by boundaries/land points
            zMaxZ       = MAX(
     &        MAX(SEAICE_zMax(i,  j,bi,bj),SEAICE_zMax(i,  j-1,bi,bj)),
     &        MAX(SEAICE_zMax(i-1,j,bi,bj),SEAICE_zMax(i-1,j-1,bi,bj)) )
            zMinZ       = MAX(
     &        MAX(SEAICE_zMin(i,  j,bi,bj),SEAICE_zMin(i,  j-1,bi,bj)),
     &        MAX(SEAICE_zMin(i-1,j,bi,bj),SEAICE_zMin(i-1,j-1,bi,bj)) )
            zetaZ(i,j,bi,bj) = MAX(zMinZ,MIN(zMaxZ,zetaZ(i,j,bi,bj)))
           ENDDO
          ENDDO
#endif /* SEAICE_ALLOW_CLIPZETA */
C     recompute pressure
          DO j=0,sNy+1
           DO i=0,sNx+1
            pressC(i,j) =
     &           ( press0(i,j,bi,bj) * ( 1. _d 0 - SEAICEpressReplFac )
     &           + TWO*zetaC(i,j)*deltaC(i,j,bi,bj)*SEAICEpressReplFac
     &             /(1. _d 0 + tensileStrFac(i,j,bi,bj))
     &           ) * (1. _d 0 - tensileStrFac(i,j,bi,bj))
           ENDDO
          ENDDO
#ifdef ALLOW_DIAGNOSTICS
          IF ( useDiagnostics ) THEN
C     save eta, zeta, and pressure for diagnostics
           DO j=1,sNy
            DO i=1,sNx
             press(i,j,bi,bj) = pressC(i,j)
             zeta (i,j,bi,bj) = zetaC(i,j)
             eta  (i,j,bi,bj) = zetaC(i,j)*recip_ecc2
            ENDDO
           ENDDO
          ENDIF
#endif /* ALLOW_DIAGNOSTICS */
C     Calculate the RHS of the stress equations. Do this now in order to
C     avoid multiple divisions by Delta
C     P * ( D_d/Delta - 1 ) = 2*zeta*D_d - P = 2*zeta*D_d - 2*zeta*Delta
C     P * ( D_t/Delta     ) = 2*zeta*D_t
C     P * ( D_s/Delta     ) = 2*zeta*D_s
#ifdef SEAICE_ALLOW_TEM
          IF ( SEAICEuseTEM ) THEN
           DO j=0,sNy
            DO i=0,sNx
             etaDenC   = em(i,j)**2 + 4. _d 0 * e12Csq(i,j)
             etaDenC  = SQRT(MAX(deltaMinSq,etaDenC))
             zetaMaxC = ecc2*zetaC(i,j)
     &            *(deltaC(i,j,bi,bj)-ep(i,j))/etaDenC
#ifdef ALLOW_DIAGNOSTICS
C     save new eta for diagnostics
             eta(i,j,bi,bj) = MIN(zetaC(i,j),zetaMaxC)*recip_ecc2
#endif /* ALLOW_DIAGNOSTICS */
             seaice_div    (i,j) =
     &            ( 2. _d 0 *zetaC(i,j)*ep(i,j) - pressC(i,j)
     &            ) * HEFFM(i,j,bi,bj)
             seaice_tension(i,j) = 2. _d 0*MIN(zetaC(i,j),zetaMaxC)
     &            * em(i,j) * HEFFM(i,j,bi,bj)
            ENDDO
           ENDDO
           DO j=1,sNy+1
            DO i=1,sNx+1
             sumNorm = 0.25 _d 0
CML            sumNorm = 1.0 _d 0
CML     &           / MAX(1.D0,HEFFM(I,  J,  bi,bj)
CML     &           +          HEFFM(I-1,J,  bi,bj)
CML     &           +          HEFFM(I,  J-1,bi,bj)
CML     &           +          HEFFM(I-1,J-1,bi,bj) )
C     Averaging the squares gives more accurate viscous-plastic behavior
C     than squaring the averages
             etaDenZ  =
     &            sumNorm * recip_rAz(i,j,bi,bj) *
     &                    ( _rA(i  ,j  ,bi,bj) * em(i,  j  )**2
     &                    + _rA(i-1,j-1,bi,bj) * em(i-1,j-1)**2
     &                    + _rA(i-1,j  ,bi,bj) * em(i-1,j  )**2
     &                    + _rA(i  ,j-1,bi,bj) * em(i,  j-1)**2 )
     &                    + 4. _d 0*e12(i,j,bi,bj)**2
             etaDenZ  = SQRT(MAX(deltaMinSq,etaDenZ))
             zetaMaxZ = ecc2*zetaZ(i,j,bi,bj) * ( deltaZ(i,j)
     &            - sumNorm * ( ep(i,j  ) + ep(i-1,j  )
     &                        + ep(i,j-1) + ep(i-1,j-1) )
     &            )/etaDenZ
             seaice_shear  (i,j) =
     &            2. _d 0*MIN(zetaZ(i,j,bi,bj),zetaMaxZ)
     &            * 2. _d 0*e12(i,j,bi,bj)
            ENDDO
           ENDDO
          ELSE
#else
          IF (.TRUE. ) THEN
#endif /* SEAICE_ALLOW_TEM */
           DO j=0,sNy
            DO i=0,sNx
             seaice_div    (i,j) =
     &            ( 2. _d 0 *zetaC(i,j)*ep(i,j) - pressC(i,j)
     &            ) * HEFFM(i,j,bi,bj)
             seaice_tension(i,j) = 2. _d 0*zetaC(i,j)
     &            * em(i,j) * HEFFM(i,j,bi,bj)
            ENDDO
           ENDDO
           DO j=1,sNy+1
            DO i=1,sNx+1
             seaice_shear  (i,j) =
     &            2. _d 0*zetaZ(i,j,bi,bj)*e12(i,j,bi,bj)
            ENDDO
           ENDDO
          ENDIF
#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE evpAlphaC(:,:,bi,bj) =comlev1_bibj_evp,key=tkey,byte=isbyte
CADJ STORE seaice_div        = comlev1_bibj_evp, key=tkey, byte=isbyte
CADJ STORE seaice_tension    = comlev1_bibj_evp, key=tkey, byte=isbyte
CADJ STORE seaice_shear      = comlev1_bibj_evp, key=tkey, byte=isbyte
#endif /* ALLOW_AUTODIFF_TAMC */
C
C     first step stress equations
C
          IF ( useAdaptiveEVP ) THEN
           DO j=0,sNy
            DO i=0,sNx
             denom1(i,j,bi,bj) = 1. _d 0 /  evpAlphaC(i,j,bi,bj)
             denom2(i,j,bi,bj) = denom1(i,j,bi,bj)
            ENDDO
           ENDDO
          ENDIF
#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE denom1(:,:,bi,bj) = comlev1_bibj_evp, key=tkey, byte=isbyte
CADJ STORE denom2(:,:,bi,bj) = comlev1_bibj_evp, key=tkey, byte=isbyte
#endif /* ALLOW_AUTODIFF_TAMC */
          DO j=0,sNy
           DO i=0,sNx
C     sigma1 and sigma2 are computed on C points
            seaice_sigma1 (i,j,bi,bj) = ( seaice_sigma1 (i,j,bi,bj)
     &           * ( evpAlphaC(i,j,bi,bj) - evpRevFac )
     &           + seaice_div(i,j)
     &           ) * denom1(i,j,bi,bj)
     &           *HEFFM(i,j,bi,bj)
            seaice_sigma2 (i,j,bi,bj) = ( seaice_sigma2 (i,j,bi,bj)
     &           * ( evpAlphaC(i,j,bi,bj) - evpRevFac )
     &           + seaice_tension(i,j)*recip_evpRevFac
     &           ) * denom2(i,j,bi,bj)
     &         *HEFFM(i,j,bi,bj)
#ifdef SEAICE_EVP_ELIMINATE_UNDERFLOWS
C     Code to avoid very small numbers that can degrade performance.
C     Many compilers can handle this more efficiently with the help of
C     a flag (copied from CICE after correspondence with Elizabeth Hunke)
            seaice_sigma1(i,j,bi,bj) = SIGN(MAX(
     &           ABS( seaice_sigma1(i,j,bi,bj) ), SEAICE_EPS ),
     &           seaice_sigma1(i,j,bi,bj) )
            seaice_sigma2(i,j,bi,bj) = SIGN(MAX(
     &           ABS( seaice_sigma2(i,j,bi,bj) ), SEAICE_EPS ),
     &           seaice_sigma2(i,j,bi,bj) )
#endif /* SEAICE_EVP_ELIMINATE_UNDERFLOWS */
C     recover sigma11 and sigma22
            sig11(i,j) = 0.5 _d 0 *
     &           ( seaice_sigma1(i,j,bi,bj)+seaice_sigma2(i,j,bi,bj) )
            sig22(i,j) = 0.5 _d 0 *
     &           ( seaice_sigma1(i,j,bi,bj)-seaice_sigma2(i,j,bi,bj) )
           ENDDO
          ENDDO

C     sigma12 is computed on Z points
          IF ( useAdaptiveEVP ) THEN
           DO j=1,sNy+1
            DO i=1,sNx+1
             evpAlphaZ(i,j,bi,bj) = 0.25 _d 0 *
     &            ( evpAlphaC(i,  j,bi,bj)+evpAlphaC(i-1,j-1,bi,bj)
     &            + evpAlphaC(i-1,j,bi,bj)+evpAlphaC(i,  j-1,bi,bj) )
             denom2(i,j,bi,bj) = 1. _d 0 /  evpAlphaZ(i,j,bi,bj)
            ENDDO
           ENDDO
          ENDIF
#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE denom2   (:,:,bi,bj) = comlev1_bibj_evp,key=tkey,byte=isbyte
CADJ STORE evpAlphaZ(:,:,bi,bj) = comlev1_bibj_evp,key=tkey,byte=isbyte
#endif /* ALLOW_AUTODIFF_TAMC */
          DO j=1,sNy+1
           DO i=1,sNx+1
            seaice_sigma12(i,j,bi,bj) = ( seaice_sigma12(i,j,bi,bj)
     &           * ( evpAlphaZ(i,j,bi,bj) - evpRevFac )
     &           + seaice_shear(i,j)*recip_evpRevFac
     &           ) * denom2(i,j,bi,bj)
#ifdef SEAICE_EVP_ELIMINATE_UNDERFLOWS
            seaice_sigma12(i,j,bi,bj) = SIGN(MAX(
     &           ABS( seaice_sigma12(i,j,bi,bj) ), SEAICE_EPS ),
     &           seaice_sigma12(i,j,bi,bj) )
#endif /* SEAICE_EVP_ELIMINATE_UNDERFLOWS */
           ENDDO
          ENDDO
C
C     compute divergence of stress tensor
C
          DO j=1,sNy
           DO i=1,sNx
            stressDivergenceX(i,j,bi,bj) =
     &           ( sig11(i  ,j  ) * _dyF(i  ,j,bi,bj)
     &           - sig11(i-1,j  ) * _dyF(i-1,j,bi,bj)
     &           + seaice_sigma12(i,j+1,bi,bj) * _dxV(i,j+1,bi,bj)
     &           - seaice_sigma12(i,j  ,bi,bj) * _dxV(i,j  ,bi,bj)
     &           ) * recip_rAw(i,j,bi,bj)
C     extra metric terms
     &           + k2AtU(i,j,bi,bj)
     &           * HALF*( seaice_sigma12(i,j+1,bi,bj)
     &                  + seaice_sigma12(i,j  ,bi,bj) )
     &           - k1AtU(i,j,bi,bj)
     &           * HALF*( sig22(i,j) + sig22(i-1,j) )
            stressDivergenceY(i,j,bi,bj) =
     &           ( sig22(i,j  ) * _dxF(i,j  ,bi,bj)
     &           - sig22(i,j-1) * _dxF(i,j-1,bi,bj)
     &           + seaice_sigma12(i+1,j,bi,bj) * _dyU(i+1,j,bi,bj)
     &           - seaice_sigma12(i  ,j,bi,bj) * _dyU(i  ,j,bi,bj)
     &           ) * recip_rAs(i,j,bi,bj)
C     extra metric terms
     &           + k1AtV(i,j,bi,bj)
     &           * HALF*( seaice_sigma12(i  ,j,bi,bj)
     &                  + seaice_sigma12(i+1,j,bi,bj) )
     &           - k2AtV(i,j,bi,bj)
     &           * HALF*( sig11(i,j) + sig11(i,j-1) )
           ENDDO
          ENDDO
         ENDDO
        ENDDO

#ifdef ALLOW_SEAICE_EVP_RESIDUAL
        IF ( printResidual ) THEN
         DO bj=myByLo(myThid),myByHi(myThid)
          DO bi=myBxLo(myThid),myBxHi(myThid)
           resTile(bi,bj) = 0. _d 0
           DO j=1,sNy
            DO i=1,sNx
             sig11Pm1(i,j,bi,bj)  =
     &            seaice_sigma1(i,j,bi,bj)-sig11pm1(i,j,bi,bj)
             sig22Pm1(i,j,bi,bj)  =
     &            seaice_sigma2(i,j,bi,bj)-sig22pm1(i,j,bi,bj)
             sig12Pm1(i,j,bi,bj)  =
     &            seaice_sigma12(i,j,bi,bj)-sig12Pm1(i,j,bi,bj)
             sig11Pm1(i,j,bi,bj)  =
     &            evpAlphaC(i,j,bi,bj) * sig11Pm1(i,j,bi,bj)
             sig22Pm1(i,j,bi,bj)  =
     &            evpAlphaC(i,j,bi,bj) * sig22Pm1(i,j,bi,bj)
             sig12Pm1(i,j,bi,bj)  =
     &            evpAlphaZ(i,j,bi,bj) * sig12Pm1(i,j,bi,bj)
            ENDDO
           ENDDO
           IF ( .NOT. SEAICEscaleSurfStress ) THEN
C     multiply with mask (concentration) to only count ice contributions
            DO j=1,sNy
             DO i=1,sNx
              resTile(bi,bj) = resTile(bi,bj) + AREA(i,j,bi,bj) *
     &             ( sig11Pm1(i,j,bi,bj)*sig11Pm1(i,j,bi,bj)
     &             + sig22Pm1(i,j,bi,bj)*sig22Pm1(i,j,bi,bj)
     &             + sig12Pm1(i,j,bi,bj)*sig12Pm1(i,j,bi,bj) )
             ENDDO
            ENDDO
           ELSE
C     in this case the scaling with AREA is already done
            DO j=1,sNy
             DO i=1,sNx
              resTile(bi,bj) = resTile(bi,bj)
     &             + sig11Pm1(i,j,bi,bj)*sig11Pm1(i,j,bi,bj)
     &             + sig22Pm1(i,j,bi,bj)*sig22Pm1(i,j,bi,bj)
     &             + sig12Pm1(i,j,bi,bj)*sig12Pm1(i,j,bi,bj)
             ENDDO
            ENDDO
           ENDIF
          ENDDO
         ENDDO
         resloc = 0. _d 0
         CALL GLOBAL_SUM_TILE_RL( resTile, resloc, myThid )
         resloc = SQRT(resloc)
         WRITE(standardMessageUnit,'(A,1X,I6,1PE16.8)')
     &   ' SEAICE_EVP: iEVPstep, residual sigma = ', iEVPstep, resLoc
        ENDIF
#endif /* ALLOW_SEAICE_EVP_RESIDUAL */
#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE stressDivergenceX = comlev1_evp, key = evpkey, byte=isbyte
CADJ STORE stressDivergenceY = comlev1_evp, key = evpkey, byte=isbyte
# ifdef SEAICE_DYN_STABLE_ADJOINT
Cgf zero out adjoint fields to stabilize pkg/seaice dyna. adjoint
      CALL ZERO_ADJ( 1, stressDivergenceX, myThid)
      CALL ZERO_ADJ( 1, stressDivergenceY, myThid)
# endif /* SEAICE_DYN_STABLE_ADJOINT */
#endif /* ALLOW_AUTODIFF_TAMC */

C
C     set up rhs for stepping the velocity field
C
        CALL SEAICE_OCEANDRAG_COEFFS(
     I       uIce, vIce, HEFFM,
     O       DWATN,
     I       iEVPstep, myTime, myIter, myThid )
#ifdef SEAICE_ALLOW_BOTTOMDRAG
        CALL SEAICE_BOTTOMDRAG_COEFFS(
     I       uIce, vIce, HEFFM,
#ifdef SEAICE_ITD
     I       HEFFITD, AREAITD, AREA,
#else
     I       HEFF, AREA,
#endif
     O       CbotC,
     I       iEVPstep, myTime, myIter, myThid )
#endif /* SEAICE_ALLOW_BOTTOMDRAG */
#ifdef SEAICE_ALLOW_SIDEDRAG
        IF ( SEAICEsideDrag .NE. 0. _d 0 ) CALL SEAICE_SIDEDRAG_STRESS(
     I       uIce, vIce, coastRoughU, coastRoughV, AREA,
     O       sideDragU, sideDragV,
     I       iEVPstep, myTime, myIter, myThid )
#endif /* SEAICE_ALLOW_SIDEDRAG */

#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE DWATN = comlev1_evp, key = evpkey, byte=isbyte
# ifdef SEAICE_ALLOW_BOTTOMDRAG
CADJ STORE CbotC = comlev1_evp, key = evpkey, byte=isbyte
# endif
# ifdef SEAICE_ALLOW_SIDEDRAG
CADJ STORE sideDragU = comlev1_evp, key = evpkey, byte=isbyte
CADJ STORE sideDragV = comlev1_evp, key = evpkey, byte=isbyte
# endif
#endif
        DO bj=myByLo(myThid),myByHi(myThid)
         DO bi=myBxLo(myThid),myBxHi(myThid)
#ifdef ALLOW_AUTODIFF_TAMC
          tkey = bi + (bj-1)*nSx + (evpkey-1)*nSx*nSy
CADJ STORE uIce(:,:,bi,bj) = comlev1_bibj_evp, key=tkey, byte=isbyte
CADJ STORE vIce(:,:,bi,bj) = comlev1_bibj_evp, key=tkey, byte=isbyte
#endif /* ALLOW_AUTODIFF_TAMC */
          DO j=1,sNy
           DO i=1,sNx
C     over open water, all terms that contain sea ice mass drop out and
C     the balance is determined by the atmosphere-ice and ice-ocean stress;
C     the staggering of uIce and vIce can cause stripes in the open ocean
C     solution when the turning angle is non-zero (SINWAT.NE.0);
C     we mask this term here in order to avoid the stripes and because
C     over open ocean, u/vIce do not advect anything, so that the associated
C     error is small and most likely only confined to the ice edge but may
C     propagate into the ice covered regions.
            locMaskU = seaiceMassU(i,j,bi,bj)
            locMaskV = seaiceMassV(i,j,bi,bj)
            IF ( locMaskU .NE. 0. _d 0 ) locMaskU = 1. _d 0
            IF ( locMaskV .NE. 0. _d 0 ) locMaskV = 1. _d 0
C     to recover old results replace the above lines with the line below
C           locMaskU = 1. _d 0
C           locMaskV = 1. _d 0
C     set up anti symmetric drag force and add in ice ocean stress
C     ( remember to average to correct velocity points )
            FORCEX(i,j,bi,bj)=FORCEX0(i,j,bi,bj)+
     &           ( 0.5 _d 0 * ( DWATN(i,j,bi,bj)+DWATN(i-1,j,bi,bj) ) *
     &           COSWAT * uVel(i,j,kSrf,bi,bj)
     &           - SIGN(SINWAT, _fCori(i,j,bi,bj))* 0.5 _d 0 *
     &           ( DWATN(i  ,j,bi,bj) * 0.5 _d 0 *
     &            (vVel(i  ,j  ,kSrf,bi,bj)-vIce(i  ,j  ,bi,bj)
     &            +vVel(i  ,j+1,kSrf,bi,bj)-vIce(i  ,j+1,bi,bj))
     &           + DWATN(i-1,j,bi,bj) * 0.5 _d 0 *
     &            (vVel(i-1,j  ,kSrf,bi,bj)-vIce(i-1,j  ,bi,bj)
     &            +vVel(i-1,j+1,kSrf,bi,bj)-vIce(i-1,j+1,bi,bj))
     &           )*locMaskU ) * areaW(i,j,bi,bj)
            FORCEY(i,j,bi,bj)=FORCEY0(i,j,bi,bj)+
     &           ( 0.5 _d 0 * ( DWATN(i,j,bi,bj)+DWATN(i,j-1,bi,bj) ) *
     &           COSWAT * vVel(i,j,kSrf,bi,bj)
     &           + SIGN(SINWAT, _fCori(i,j,bi,bj)) * 0.5 _d 0 *
     &           ( DWATN(i,j  ,bi,bj) * 0.5 _d 0 *
     &            (uVel(i  ,j  ,kSrf,bi,bj)-uIce(i  ,j  ,bi,bj)
     &            +uVel(i+1,j  ,kSrf,bi,bj)-uIce(i+1,j  ,bi,bj))
     &           + DWATN(i,j-1,bi,bj) * 0.5 _d 0 *
     &            (uVel(i  ,j-1,kSrf,bi,bj)-uIce(i  ,j-1,bi,bj)
     &            +uVel(i+1,j-1,kSrf,bi,bj)-uIce(i+1,j-1,bi,bj))
     &           )*locMaskV ) * areaS(i,j,bi,bj)
C     coriols terms
            FORCEX(i,j,bi,bj)=FORCEX(i,j,bi,bj) + 0.5 _d 0*(
     &             seaiceMassC(i  ,j,bi,bj) * _fCori(i  ,j,bi,bj)
     &           * 0.5 _d 0*( vIce(i  ,j,bi,bj)+vIce(i  ,j+1,bi,bj) )
     &           + seaiceMassC(i-1,j,bi,bj) * _fCori(i-1,j,bi,bj)
     &           * 0.5 _d 0*( vIce(i-1,j,bi,bj)+vIce(i-1,j+1,bi,bj) )
     &           )
            FORCEY(i,j,bi,bj)=FORCEY(i,j,bi,bj) - 0.5 _d 0*(
     &             seaiceMassC(i,j  ,bi,bj) * _fCori(i,j  ,bi,bj)
     &           * 0.5 _d 0*( uIce(i,j  ,bi,bj)+uIce(i+1,  j,bi,bj) )
     &           + seaiceMassC(i,j-1,bi,bj) * _fCori(i,j-1,bi,bj)
     &           * 0.5 _d 0*( uIce(i,j-1,bi,bj)+uIce(i+1,j-1,bi,bj) )
     &           )
           ENDDO
          ENDDO
#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE FORCEX(:,:,bi,bj) = comlev1_bibj_evp, key=tkey, byte=isbyte
CADJ STORE FORCEY(:,:,bi,bj) = comlev1_bibj_evp, key=tkey, byte=isbyte
#endif /* ALLOW_AUTODIFF_TAMC */
#ifdef SEAICE_ALLOW_MOM_ADVECTION
          IF ( SEAICEmomAdvection ) THEN
           DO j=1-OLy,sNy+OLy
            DO i=1-OLx,sNx+OLx
             gUmom(i,j) = 0. _d 0
             gVmom(i,j) = 0. _d 0
            ENDDO
           ENDDO
           CALL SEAICE_MOM_ADVECTION(
     I          bi,bj,1,sNx,1,sNy,
     I          uIce, vIce,
     O          gUmom, gVmom,
     I          myTime, myIter, myThid )
           DO j=1,sNy
            DO i=1,sNx
             FORCEX(i,j,bi,bj) = FORCEX(i,j,bi,bj) + gUmom(i,j)
             FORCEY(i,j,bi,bj) = FORCEY(i,j,bi,bj) + gVmom(i,j)
            ENDDO
           ENDDO
          ENDIF
#endif /* SEAICE_ALLOW_MOM_ADVECTION */
C
C     step momentum equations with ice-ocean stress term treated implicitly
C
          IF ( useAdaptiveEVP ) THEN
           DO j=1,sNy
            DO i=1,sNx
C     compute and adjust parameters that are constant otherwise
             evpBetaU(i,j,bi,bj) = 0.5 _d 0*(evpAlphaC(i-1,j,bi,bj)
     &                                      +evpAlphaC(i,  j,bi,bj))
             evpBetaV(i,j,bi,bj) = 0.5 _d 0*(evpAlphaC(i,j-1,bi,bj)
     &                                      +evpAlphaC(i,j,  bi,bj))

            ENDDO
           ENDDO
          ENDIF
#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE evpBetaU(:,:,bi,bj) = comlev1_bibj_evp,key=tkey,byte=isbyte
CADJ STORE evpBetaV(:,:,bi,bj) = comlev1_bibj_evp,key=tkey,byte=isbyte
CADJ STORE uIce(:,:,bi,bj) = comlev1_bibj_evp, key=tkey, byte=isbyte
CADJ STORE vIce(:,:,bi,bj) = comlev1_bibj_evp, key=tkey, byte=isbyte
#endif /* ALLOW_AUTODIFF_TAMC */
          DO j=1,sNy
           DO i=1,sNx
            betaFacU   = evpBetaU(i,j,bi,bj)*recip_deltaT
            betaFacV   = evpBetaV(i,j,bi,bj)*recip_deltaT
            tmp        = evpStarFac*recip_deltaT
            betaFacP1V = betaFacV + tmp
            betaFacP1U = betaFacU + tmp
            IF ( SEAICE_evpAreaReg .GT. 0. _d 0 ) THEN
             denomU = MAX(seaiceMassU(i,j,bi,bj),SEAICE_evpAreaReg
     &           * seaice_rhoIce)*betaFacP1U
     &           + 0.5 _d 0*( DWATN(i,j,bi,bj) + DWATN(i-1,j,bi,bj) )
     &           * COSWAT * MAX(areaW(i,j,bi,bj),SEAICE_evpAreaReg)
             denomV = MAX(seaiceMassV(i,j,bi,bj),SEAICE_evpAreaReg
     &           * seaice_rhoIce)*betaFacP1V
     &           + 0.5 _d 0*( DWATN(i,j,bi,bj) + DWATN(i,j-1,bi,bj) )
     &           * COSWAT * MAX(areaS(i,j,bi,bj),SEAICE_evpAreaReg)
            ELSE
             denomU = seaiceMassU(i,j,bi,bj)*betaFacP1U
     &           + 0.5 _d 0*( DWATN(i,j,bi,bj) + DWATN(i-1,j,bi,bj) )
     &           * COSWAT * areaW(i,j,bi,bj)
             denomV = seaiceMassV(i,j,bi,bj)*betaFacP1V
     &           + 0.5 _d 0*( DWATN(i,j,bi,bj) + DWATN(i,j-1,bi,bj) )
     &           * COSWAT * areaS(i,j,bi,bj)
            ENDIF
#ifdef SEAICE_ALLOW_BOTTOMDRAG
            denomU = denomU + areaW(i,j,bi,bj)
     &           * 0.5 _d 0*( CbotC(i,j,bi,bj) + CbotC(i-1,j,bi,bj) )
            denomV = denomV + areaS(i,j,bi,bj)
     &           * 0.5 _d 0*( CbotC(i,j,bi,bj) + CbotC(i,j-1,bi,bj) )
#endif /* SEAICE_ALLOW_BOTTOMDRAG */
#ifdef SEAICE_ALLOW_SIDEDRAG
            denomU = denomU + sideDragU(i,j,bi,bj)
            denomV = denomV + sideDragV(i,j,bi,bj)
#endif
            IF ( denomU .EQ. 0. _d 0 ) denomU = 1. _d 0
            IF ( denomV .EQ. 0. _d 0 ) denomV = 1. _d 0
            uIce(i,j,bi,bj) = seaiceMaskU(i,j,bi,bj) *
     &           ( seaiceMassU(i,j,bi,bj)*betaFacU
     &           * uIce(i,j,bi,bj)
     &           + seaiceMassU(i,j,bi,bj)*recip_deltaT*evpStarFac
     &           * uIceNm1(i,j,bi,bj)
     &           + FORCEX(i,j,bi,bj)
     &           + stressDivergenceX(i,j,bi,bj) ) / denomU
            vIce(i,j,bi,bj) = seaiceMaskV(i,j,bi,bj) *
     &           ( seaiceMassV(i,j,bi,bj)*betaFacV
     &           * vIce(i,j,bi,bj)
     &           + seaiceMassV(i,j,bi,bj)*recip_deltaT*evpStarFac
     &           * vIceNm1(i,j,bi,bj)
     &           + FORCEY(i,j,bi,bj)
     &           + stressDivergenceY(i,j,bi,bj) ) / denomV
C--   to change results  of lab_sea.hb87 test exp. (only preserve 2 digits for cg2d)
c           uIce(i,j,bi,bj) = uIceNm1(i,j,bi,bj)
c    &                       +( uIce(i,j,bi,bj) - uIceNm1(i,j,bi,bj) )
c           vIce(i,j,bi,bj) = vIceNm1(i,j,bi,bj)
c    &                       +( vIce(i,j,bi,bj) - vIceNm1(i,j,bi,bj) )
           ENDDO
          ENDDO
#ifndef OBCS_UVICE_OLD
#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE uIce(:,:,bi,bj) = comlev1_bibj_evp, key=tkey, byte=isbyte
CADJ STORE vIce(:,:,bi,bj) = comlev1_bibj_evp, key=tkey, byte=isbyte
#endif /* ALLOW_AUTODIFF_TAMC */
          DO j=1,sNy
           DO i=1,sNx
            locMaskU = maskInC(i,j,bi,bj)*maskInC(i-1,j,bi,bj)
            locMaskV = maskInC(i,j,bi,bj)*maskInC(i,j-1,bi,bj)
            uIce(i,j,bi,bj) = uIce(i,j,bi,bj)*locMaskU
     &                       + uIceNm1(i,j,bi,bj)*(ONE-locMaskU)
            vIce(i,j,bi,bj) = vIce(i,j,bi,bj)*locMaskV
     &                       + vIceNm1(i,j,bi,bj)*(ONE-locMaskV)
           ENDDO
          ENDDO
#endif /* OBCS_UVICE_OLD */
         ENDDO
        ENDDO

        CALL EXCH_UV_XY_RL(uIce,vIce,.TRUE.,myThid)

#ifdef ALLOW_SEAICE_EVP_RESIDUAL
        IF ( printResidual ) THEN
         DO bj=myByLo(myThid),myByHi(myThid)
          DO bi=myBxLo(myThid),myBxHi(myThid)
           resTile(bi,bj) = 0. _d 0
           DO j=1,sNy
            DO i=1,sNx
             uIcePm1(i,j,bi,bj) = seaiceMaskU(i,j,bi,bj) *
     &            ( uIce(i,j,bi,bj)-uIcePm1(i,j,bi,bj) )
     &            * evpBetaU(i,j,bi,bj)
             vIcePm1(i,j,bi,bj) = seaiceMaskV(i,j,bi,bj) *
     &            ( vIce(i,j,bi,bj)-vIcePm1(i,j,bi,bj) )
     &            * evpBetaV(i,j,bi,bj)
            ENDDO
           ENDDO
           IF ( .NOT. SEAICEscaleSurfStress ) THEN
C     multiply with mask (concentration) to only count ice contributions
            DO j=1,sNy
             DO i=1,sNx
              resTile(bi,bj) = resTile(bi,bj) + AREA(i,j,bi,bj) *
     &             ( uIcePm1(i,j,bi,bj)*uIcePm1(i,j,bi,bj)
     &             + vIcePm1(i,j,bi,bj)*vIcePm1(i,j,bi,bj) )
             ENDDO
            ENDDO
           ELSE
            DO j=1,sNy
             DO i=1,sNx
              resTile(bi,bj) = resTile(bi,bj)
     &             + uIcePm1(i,j,bi,bj)*uIcePm1(i,j,bi,bj)
     &             + vIcePm1(i,j,bi,bj)*vIcePm1(i,j,bi,bj)
             ENDDO
            ENDDO
           ENDIF
          ENDDO
         ENDDO
         resloc = 0. _d 0
         CALL GLOBAL_SUM_TILE_RL( resTile, resloc, myThid )
         resloc = SQRT(resloc)
         WRITE(standardMessageUnit,'(A,1X,I6,1PE16.8)')
     &        ' SEAICE_EVP: iEVPstep, residual U = ', iEVPstep, resLoc
        ENDIF
CML        WRITE(suff,'(I10.10)') myIter*100000+iEvpStep
CML        CALL WRITE_FLD_XY_RL( 'DELTA.',suff,deltaC,
CML     &       myIter*100000+iEvpStep,myThid)
CML        CALL WRITE_FLD_XY_RL( 'RSIG1.',suff,sig11pm1,
CML     &       myIter*100000+iEvpStep,myThid)
CML        CALL WRITE_FLD_XY_RL( 'RSIG2.',suff,sig22pm1,
CML     &       myIter*100000+iEvpStep,myThid)
CML        CALL WRITE_FLD_XY_RL( 'RSIG12.',suff,sig12pm1,
CML     &       myIter*100000+iEvpStep,myThid)
CML        CALL WRITE_FLD_XY_RL( 'RUICE.',suff,uIcePm1,
CML     &       myIter*100000+iEvpStep,myThid)
CML        CALL WRITE_FLD_XY_RL( 'RVICE.',suff,vIcePm1,
CML     &       myIter*100000+iEvpStep,myThid)

#endif /* ALLOW_SEAICE_EVP_RESIDUAL */

       ENDIF
C     end of the main time loop
      ENDDO

#endif /* SEAICE_CGRID and SEAICE_ALLOW_EVP */

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 0
C     !ROUTINE: GETCON

C     !INTERFACE:
      FUNCTION GETCON(NAME)

C     !DESCRIPTION:
C     Generic function getcon is a repository of global variables,
C     i.e. a memory for scalar values needed throughout a large
C     program.  This function remembers floating point values.  The
C     function is called with a character name to interrogate a value.
      
C     !USES:
      implicit none
#include "CPP_EEOPTIONS.h"

C     !INPUT PARAMETERS:
      CHARACTER*(*) NAME
CEOP

      integer I
      INTEGER MAXCON
      PARAMETER (MAXCON=46)
      CHARACTER*16 ANAME(MAXCON)
      _RL  ACON (MAXCON)
      _RL  GETCON
      _RL  VECMAX, UNDEF, OB, ECC, AE, EQNX, SOLS, S0, GRAV, 
     &     SRFPRS, PIMEAN, PSTD, TSTD, SDAY, SSALB, CO2, 
     &     CFC11, CFC12, CFC22, ATMPOPA, PI, CPD, CPV, ALHL, ALHS, 
     &     STFBOL, AIRMW, H2OMW, RUNIV, RGAS, RVAP, RKAP, HEATW, 
     &     HEATI, TICE, VKRM, DEG2RAD, CALTOJ, EPS, VIRTCON, EPSFAC,
     &     YRLEN, DAYSCY, PERHDEG, OBLDEG

C     COMPUTATIONAL CONSTANTS
C     -----------------------
      PARAMETER ( VECMAX = 65535.5    )
      PARAMETER ( UNDEF  = 1.d15      )

C     ASTRONOMICAL CONSTANTS
C     ----------------------
      PARAMETER ( OB     = 23.45      )
      PARAMETER ( AE     = 6371E3     )
      PARAMETER ( SOLS   = 176.5      )
      PARAMETER ( S0     = 1365.0     )
      PARAMETER ( EQNX   = 80.9028    )
      PARAMETER ( ECC    = 0.0167     )
      PARAMETER ( PERHDEG= 102.0      )
      PARAMETER ( OBLDEG = 23.45      )

C     TERRESTRIAL CONSTANTS
C     ---------------------
      PARAMETER ( GRAV   = 9.81d0     )
      PARAMETER ( SRFPRS = 984.7      )
      PARAMETER ( PIMEAN = 984.7      )
      PARAMETER ( PSTD   = 1000.0     )
      PARAMETER ( TSTD   = 280.0      )
      PARAMETER ( SDAY   = 86400.0    )
      PARAMETER ( SSALB  = 0.99       )
      PARAMETER ( CO2    = 355.0      )
      PARAMETER ( CFC11  = 0.3        )
      PARAMETER ( CFC12  = 0.5        )
      PARAMETER ( CFC22  = 0.2        )
      PARAMETER ( ATMPOPA= 1.d5       )
      PARAMETER ( PI     = 3.14159d0  )
      PARAMETER ( YRLEN  = 365.25     )
      PARAMETER ( DAYSCY = 365 *4 +1  )

C     THERMODYNAMIC CONSTANTS
C     -----------------------
      PARAMETER ( CPD    = 1004.16d0  )
      PARAMETER ( CPV    = 1869.46    )
      PARAMETER ( ALHL   = 2.499E6    )
      PARAMETER ( ALHS   = 2.845E6    )
      PARAMETER ( STFBOL = 5.67E-8    )
      PARAMETER ( AIRMW  = 28.97d0    )
      PARAMETER ( H2OMW  = 18.01d0    )
      PARAMETER ( RUNIV  = 8314.3d0   )
      PARAMETER ( RGAS   = RUNIV/AIRMW)
      PARAMETER ( RVAP   = RUNIV/H2OMW)
      PARAMETER ( RKAP   = RGAS/CPD   )
      PARAMETER ( HEATW  = 597.2      )
      PARAMETER ( HEATI  = 680.0      )
      PARAMETER ( TICE   = 273.16     )

C     TURBULENCE CONSTANTS
C     --------------------
      PARAMETER ( VKRM   = 0.4        )

C     CONVERSION CONSTANTS
C     --------------------
      PARAMETER ( DEG2RAD  = PI/180.d0)
      PARAMETER ( CALTOJ = 4184.      )

C     MOISTURE CONSTANTS
C     ------------------
      PARAMETER ( EPS    = 0.622      )
      PARAMETER ( VIRTCON= 0.609      )
      PARAMETER ( EPSFAC = EPS*HEATW/RGAS*CALTOJ )


       DATA ANAME(1 ),ACON(1 ) / 'CP              ', CPD    /
       DATA ANAME(2 ),ACON(2 ) / 'RGAS            ', RGAS   /
       DATA ANAME(3 ),ACON(3 ) / 'KAPPA           ', RKAP   /
       DATA ANAME(4 ),ACON(4 ) / 'LATENT HEAT COND', ALHL   /
       DATA ANAME(5 ),ACON(5 ) / 'GRAVITY         ', GRAV   /
       DATA ANAME(6 ),ACON(6 ) / 'STEFAN-BOLTZMAN ', STFBOL /
       DATA ANAME(7 ),ACON(7 ) / 'VON KARMAN      ', VKRM   /
       DATA ANAME(8 ),ACON(8 ) / 'EARTH RADIUS    ', AE     /
       DATA ANAME(9 ),ACON(9 ) / 'OBLIQUITY       ', OB     /
       DATA ANAME(10),ACON(10) / 'ECCENTRICITY    ', ECC    /
       DATA ANAME(11),ACON(11) / 'PERIHELION      ', PERHDEG/
       DATA ANAME(12),ACON(12) / 'VERNAL EQUINOX  ', EQNX   /
       DATA ANAME(13),ACON(13) / 'SUMMER SOLSTICE ', SOLS   /
       DATA ANAME(14),ACON(14) / 'MAX VECT LENGTH ', VECMAX /
       DATA ANAME(15),ACON(15) / 'MOL WT H2O      ', H2OMW  /
       DATA ANAME(16),ACON(16) / 'MOL WT AIR      ', AIRMW  /
       DATA ANAME(17),ACON(17) / 'CPV             ', CPV    /
       DATA ANAME(18),ACON(18) / 'CPD             ', CPD    /
       DATA ANAME(19),ACON(19) / 'UNIV GAS CONST  ', RUNIV  /
       DATA ANAME(20),ACON(20) / 'LATENT HEAT SBLM', ALHS   /
       DATA ANAME(21),ACON(21) / 'FREEZING-POINT  ', TICE   /
       DATA ANAME(23),ACON(23) / 'CALTOJ          ', CALTOJ /
       DATA ANAME(24),ACON(24) / 'EPS             ', EPS    /
       DATA ANAME(25),ACON(25) / 'HEATW           ', HEATW  /
       DATA ANAME(26),ACON(26) / 'EPSFAC          ', EPSFAC /
       DATA ANAME(27),ACON(27) / 'VIRTCON         ', VIRTCON/
       DATA ANAME(28),ACON(28) / 'PIMEAN          ', PIMEAN /
       DATA ANAME(29),ACON(29) / 'SDAY            ', SDAY   /
       DATA ANAME(30),ACON(30) / 'HEATI           ', HEATI  /
       DATA ANAME(31),ACON(31) / 'S0              ', S0     /
       DATA ANAME(32),ACON(32) / 'PSTD            ', PSTD   /
       DATA ANAME(33),ACON(33) / 'TSTD            ', TSTD   /
       DATA ANAME(34),ACON(34) / 'SSALB           ', SSALB  /
       DATA ANAME(35),ACON(35) / 'UNDEF           ', UNDEF  /
       DATA ANAME(36),ACON(36) / 'CO2             ', CO2    /
       DATA ANAME(37),ACON(37) / 'RVAP            ', RVAP   /
       DATA ANAME(38),ACON(38) / 'CFC11           ', CFC11  /
       DATA ANAME(39),ACON(39) / 'CFC12           ', CFC12  /
       DATA ANAME(40),ACON(40) / 'CFC22           ', CFC22  /
       DATA ANAME(41),ACON(41) / 'DEG2RAD         ', DEG2RAD /
       DATA ANAME(42),ACON(42) / 'ATMPOPA         ', ATMPOPA/
       DATA ANAME(43),ACON(43) / 'PI              ', PI     /
       DATA ANAME(44),ACON(44) / 'YRLEN           ', YRLEN  /
       DATA ANAME(45),ACON(45) / 'DAYSCY          ',DAYSCY  /
       DATA ANAME(46),ACON(46) / 'OBLDEG          ',OBLDEG  /

      DO 10 I=1,MAXCON
      IF(NAME.EQ.ANAME(I)) THEN
         GETCON = ACON(I)
         RETURN
      ENDIF
10    CONTINUE

900   PRINT *,' CANNOT FIND FLOATING POINT CONSTANT - ',NAME
      PRINT *,' GETCON - CANNOT FIND CONSTANT REQUESTED'
      RETURN
      END

#include "SEAICE_OPTIONS.h"

      SUBROUTINE SEAICE_COST_INIT_VARIA( myThid )

C     ==================================================================
C     SUBROUTINE SEAICE_COST_INIT_VARIA
C     ==================================================================
C     o Initialise the variable cost function part.
C     added sea-ice term: menemenlis@jpl.nasa.gov 26-Feb-2003
C
C     ==================================================================

      IMPLICIT NONE

C     == global variables ==
#include "EEPARAMS.h"
#include "SIZE.h"
#ifdef ALLOW_COST
# include "SEAICE_SIZE.h"
# include "SEAICE_COST.h"
#endif

C     == routine arguments ==
      INTEGER myThid

#ifdef ALLOW_COST
C     == local variables ==
      INTEGER bi,bj
#ifdef ALLOW_SEAICE_COST_EXPORT
      INTEGER i,j
#endif
C     == end of interface ==

C--   Initialize the tiled cost function contributions.
      DO bj = myByLo(myThid), myByHi(myThid)
        DO bi = myBxLo(myThid), myBxHi(myThid)
          objf_ice(bi,bj)        = 0. _d 0
          objf_ice_export(bi,bj) = 0. _d 0
          num_ice(bi,bj)         = 0. _d 0
#ifdef ALLOW_SEAICE_COST_EXPORT
          DO j=1-OLy,sNy+OLy
            DO i=1-OLx,sNx+OLx
               uHeffExportCell(i,j,bi,bj) = 0. _d 0
               vHeffExportCell(i,j,bi,bj) = 0. _d 0
            ENDDO
          ENDDO
#endif
        ENDDO
      ENDDO

#endif /* ALLOW_COST */

      RETURN
      END

#include "CPP_EEOPTIONS.h"
#ifdef USE_LIBHPM
# include "f_hpm.h"
#endif

CBOP
      SUBROUTINE EEDIE
C     *==========================================================*
C     | SUBROUTINE EEDIE                                         |
C     | o Close execution "environment", particularly perform    |
C     |   steps to terminate parallel processing.                |
C     *==========================================================*
C     | Note: This routine can also be compiled with CPP         |
C     | directives set so that no multi-processing is initialised|
C     | This is OK and should work fine.                         |
C     *==========================================================*
      IMPLICIT NONE

C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "EESUPPORT.h"
CEOP

C     == Local variables ==
C     msgBuf       :: I/O Buffer
C     nThreadsDone :: Used to count number of completed threads.
C     I            :: Loop counter.
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      INTEGER nThreadsDone
      INTEGER I
#ifdef ALLOW_USE_MPI
C     mpiRC        :: Error code reporting variable used with MPI.
      INTEGER mpiRC
#endif /* ALLOW_USE_MPI */

      IF ( eeBootError ) THEN
C--   Skip ended threads counting if earlier error was found
        WRITE(msgBuf,'(2A)')
     &   'EEDIE: earlier error in multi-proc/thread setting'
        CALL PRINT_ERROR( msgBuf, 1 )
        fatalError = .TRUE.

      ELSE
C--   Check that all the threads have ended
C     No thread should reach this loop before all threads have set
C     threadIsComplete to TRUE. If they do then either there is a bug
C     in the code or the behaviour of the parallel compiler directives
C     are not right for this code. In the latter case different
C     directives may be available or the compiler itself may have a
C     bug or you may need a different parallel compiler for main.F
        nThreadsDone = 0
        DO I = 1, nThreads
         IF ( threadIsComplete(I) ) nThreadsDone = nThreadsDone+1
        ENDDO
        IF ( nThreadsDone .LT. nThreads ) THEN
         WRITE(msgBuf,'(A,I5,A)')
     &    'S/R EEDIE: Only',nThreadsDone,' threads have completed,'
         CALL PRINT_ERROR( msgBuf, 1 )
         WRITE(msgBuf,'(A,I5,A)')
     &    'S/R EEDIE:',nThreads,' are expected for this config !'
         CALL PRINT_ERROR( msgBuf, 1 )
         eeEndError = .TRUE.
         fatalError = .TRUE.
        ENDIF

C--   end if/else eebootError
      ENDIF

#ifdef USE_LIBHPM
      CALL F_HPMTERMINATE(myProcId)
#endif

C--   Flush IO-unit before MPI termination
      CALL MDS_FLUSH( errorMessageUnit, 1 )
c#ifdef ALLOW_USE_MPI
      CALL MDS_FLUSH( standardMessageUnit, 1 )
c#endif /* ALLOW_USE_MPI */

#ifdef ALLOW_USE_MPI
C- Note: since MPI_INIT is always called, better to also always terminate MPI
C        (even if usingMPI=F) --> comment out test on usingMPI
c     IF ( usingMPI ) THEN

C--   MPI style multiple-process termination
C--   ======================================
#ifdef COMPONENT_MODULE
       IF ( useCoupler) CALL MPI_BARRIER( MPI_COMM_WORLD, mpiRC )
#endif
#ifdef ALLOW_OASIS
       IF ( useOASIS ) CALL OASIS_FINALIZE
#endif
       CALL MPI_FINALIZE  ( mpiRC )
       IF ( mpiRC .NE. MPI_SUCCESS ) THEN
        eeEndError = .TRUE.
        fatalError = .TRUE.
        WRITE(msgBuf,'(A,I5)')
     &       'S/R FIN_PROCS: MPI_FINALIZE return code',
     &       mpiRC
        CALL PRINT_ERROR( msgBuf, 1 )
       ENDIF

c     ENDIF
#endif /* ALLOW_USE_MPI */

      RETURN
      END

#include "GAD_OPTIONS.h"

CBOP
C !ROUTINE: GAD_C4_ADV_X

C !INTERFACE: ==========================================================
      SUBROUTINE GAD_C4_ADV_X(
     I           bi,bj,k,
     I           uTrans, maskLocW,
     I           tracer,
     O           uT,
     I           myThid )

C !DESCRIPTION:
C Calculates the area integrated zonal flux due to advection of a tracer
C using centered fourth-order interpolation:
C \begin{equation*}
C F^x_{adv} = U \overline{ \theta - \frac{1}{6} \delta_{ii} \theta }^i
C \end{equation*}
C Near boundaries, the scheme reduces to a second if the flow is away
C from the boundary and to third order if the flow is towards
C the boundary.

C !USES: ===============================================================
      IMPLICIT NONE
#include "SIZE.h"
#include "GRID.h"
#include "GAD.h"

C !INPUT PARAMETERS: ===================================================
C  bi,bj        :: tile indices
C  k            :: vertical level
C  uTrans       :: zonal volume transport
C  maskLocW     :: mask (either 0 or 1) at grid-cell western edge
C  tracer       :: tracer field
C  myThid       :: my thread Id number
      INTEGER bi,bj,k
      _RL uTrans  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RS maskLocW(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL tracer  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER myThid

C !OUTPUT PARAMETERS: ==================================================
C  uT           :: zonal advective flux
      _RL uT      (1-OLx:sNx+OLx,1-OLy:sNy+OLy)

C !LOCAL VARIABLES: ====================================================
C  i,j                  :: loop indices
C  Rjm,Rj,Rjp           :: differences at i-1,i,i+1
C  Rjjm,Rjjp            :: second differences at i-1,i
      INTEGER i,j
      _RL Rjm,Rj,Rjp,Rjjm,Rjjp
CEOP

      DO j=1-Oly,sNy+Oly
       uT(1-Olx,j)=0.
       uT(2-Olx,j)=0.
       uT(sNx+Olx,j)=0.
      ENDDO
      DO j=1-Oly,sNy+Oly
       DO i=1-Olx+2,sNx+Olx-1
        Rjp = (tracer(i+1,j)-tracer( i ,j))*maskLocW(i+1,j)
        Rj  = (tracer( i ,j)-tracer(i-1,j))*maskLocW( i ,j)
        Rjm = (tracer(i-1,j)-tracer(i-2,j))*maskLocW(i-1,j)
        Rjjp=(Rjp-Rj)
        Rjjm=(Rj-Rjm)
        uT(i,j) =
     &   uTrans(i,j)*(
     &     Tracer(i,j)+Tracer(i-1,j)-oneSixth*( Rjjp+Rjjm )
     &               )*0.5 _d 0
     &  +ABS( uTrans(i,j) )*0.5 _d 0*oneSixth*( Rjjp-Rjjm )
     &    *( 1. _d 0 - maskW(i-1,j,k,bi,bj)*maskW(i+1,j,k,bi,bj) )
c    &    *( 1. _d 0 - maskLocW(i-1,j)*maskLocW(i+1,j) )
       ENDDO
      ENDDO

      RETURN
      END

#include "ATM_CPL_OPTIONS.h"

CBOP
C     !ROUTINE: ATM_STORE_DYNVARS
C     !INTERFACE:
      SUBROUTINE ATM_STORE_DYNVARS(
     I                     bi, bj,
     I                     myTime, myIter, myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE ATM_STORE_DYNVARS
C     | o Routine for saving dynamical fields (e.g.,  atmos.
C     |   sea-level pressure ) for export to coupling layer.
C     *==========================================================*
C     | This version interfaces to the main model
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "CPL_PARAMS.h"
C     == Global variables (main model)
#include "DYNVARS.h"
C     == Global variables for coupling interface ==
#include "ATMCPL.h"

C     !INPUT/OUTPUT PARAMETERS:
C     bi, bj    :: Tile indices
C     myTime    :: Current time in simulation (s)
C     myIter    :: Current iteration number
C     myThid    :: My Thread Id. number
      INTEGER bi, bj
      _RL     myTime
      INTEGER myIter
      INTEGER myThid

C     !LOCAL VARIABLES:
C     i, j      :: Loop counters
      INTEGER i,j
c     _RL cplTimeFraction
CEOP

C     o Accumulate Sea-level pressure anomaly from dynamical core
C       to the coupling layer. Eta is in Pa
c      cplTimeFraction = 1. _d 0 / DFLOAT(cplSendFrq_iter)
c      atmSLPrTime(bi,bj) = atmSLPrTime(bi,bj) + cplTimeFraction
       atmSLPrTime(bi,bj) = 1. _d 0
       DO j=1,sNy
        DO i=1,sNx
c         atmSLPr(i,j,bi,bj) = atmSLPr(i,j,bi,bj)
c    &                 + etaN(i,j,bi,bj)*cplTimeFraction
          atmSLPr(i,j,bi,bj) = etaN(i,j,bi,bj)
        ENDDO
       ENDDO

      RETURN
      END

#include "CPP_EEOPTIONS.h"

      SUBROUTINE SCATTER_XZ( global, local, myThid )
C     Scatter elements of a x-z array from mpi process 0 to all processes.
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "EESUPPORT.h"
C     mythid - thread number for this instance of the routine.
C     global,local - working arrays used to transfer 2-D fields
      INTEGER mythid
      Real*8  global(Nx)
      _RL     local(1-OLx:sNx+OLx,nSx,nSy)

      INTEGER iG, i, bi, bj
#ifdef ALLOW_USE_MPI

      _RL     temp(1-OLx:sNx+OLx,nSx,nSy)

      INTEGER istatus(MPI_STATUS_SIZE), ierr
      INTEGER isource, itag, npe
      INTEGER lbuff
#endif /* ALLOW_USE_MPI */

C--   Make everyone wait except for master thread.
      _BARRIER
      _BEGIN_MASTER( myThid )

#ifndef ALLOW_USE_MPI

      DO bj=1,nSy
         DO bi=1,nSx
               DO i=1,sNx
                  iG = myXGlobalLo-1+(bi-1)*sNx+i
                  local(i,bi,bj) = global(iG)
               ENDDO
         ENDDO
      ENDDO

#else /* ALLOW_USE_MPI */

      lbuff=(sNx+2*OLx)*nSx*nSy
      isource = 0
      itag = 0

      IF( mpiMyId .EQ. 0 ) THEN

C--   Process 0 fills-in its local data
         npe = 0
         DO bj=1,nSy
            DO bi=1,nSx
                  DO i=1,sNx
                     iG = mpi_myXGlobalLo(npe+1)-1+(bi-1)*sNx+i
                     local(i,bi,bj) = global(iG)
                  ENDDO
            ENDDO
         ENDDO

C--   Process 0 sends local arrays to all other processes
         DO npe = 1, numberOfProcs-1
            DO bj=1,nSy
               DO bi=1,nSx
                     DO i=1,sNx
                        iG = mpi_myXGlobalLo(npe+1)-1+(bi-1)*sNx+i
                        temp(i,bi,bj) = global(iG)
                     ENDDO
               ENDDO
            ENDDO
            CALL MPI_SEND (temp, lbuff, MPI_DOUBLE_PRECISION,
     &           npe, itag, MPI_COMM_MODEL, ierr)
         ENDDO

      ELSE

C--   All proceses except 0 receive local array from process 0
         CALL MPI_RECV (local, lbuff, MPI_DOUBLE_PRECISION,
     &        isource, itag, MPI_COMM_MODEL, istatus, ierr)

      ENDIF

#endif /* ALLOW_USE_MPI */

      _END_MASTER( myThid )
      _BARRIER

C--   Fill in edges.
CMM      _EXCH_XY_RL( local, myThid )

      RETURN
      END

#include "GRDCHK_OPTIONS.h"
#ifdef ALLOW_CTRL
# include "CTRL_OPTIONS.h"
#endif

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: GRDCHK_LOC

C     !INTERFACE:
      SUBROUTINE GRDCHK_LOC(
     I                      icomp,
     I                      ichknum,
     O                      icvrec,
     O                      itile,
     O                      jtile,
     O                      layer,
     O                      obcspos,
     O                      itilepos,
     O                      jtilepos,
     O                      icglom1,
     O                      itest,
     O                      ierr,
     I                      myThid )

C     !DESCRIPTION:
C     ==================================================================
C     SUBROUTINE GRDCHK_LOC
C     ==================================================================
C     o Get the location of a given component of the control vector for
C       the current process.
C     started: Christian Eckert eckert@mit.edu 04-Apr-2000
C     continued: heimbach@mit.edu: 13-Jun-2001
C     ==================================================================

C     !USES:
      IMPLICIT NONE
C     == Global variables ===
#include "EEPARAMS.h"
#include "SIZE.h"
#include "GRID.h"
#include "CTRL_SIZE.h"
#include "CTRL.h"
#ifdef ALLOW_OBCS_CONTROL
C     CTRL_OBCS.h must be included before GRDCHK.h
# include "CTRL_OBCS.h"
#endif
#include "GRDCHK.h"
#ifdef ALLOW_OBCS
# include "OBCS_GRID.h"
#endif
#ifdef ALLOW_SHELFICE
# include "SHELFICE.h"
#endif /* ALLOW_SHELFICE */

C     !INPUT/OUTPUT PARAMETERS:
      INTEGER icomp
      INTEGER ichknum
      INTEGER icvrec
      INTEGER jtile
      INTEGER itile
      INTEGER layer
      INTEGER obcspos
      INTEGER itilepos
      INTEGER jtilepos
      INTEGER itest
      INTEGER ierr
      INTEGER myThid

#ifdef ALLOW_GRDCHK
C--   == external ==
      INTEGER  ILNBLNK
      EXTERNAL ILNBLNK

C     !LOCAL VARIABLES:
      INTEGER bi,bj
      INTEGER i,j,k, kk
      INTEGER itmp,jtmp
      INTEGER iobcs
c     INTEGER biwrk,bjwrk
      INTEGER iwrk, jwrk, kwrk
c     INTEGER iobcswrk
      INTEGER irec, irecwrk
      INTEGER icglo, icglom1
      INTEGER icomptest
      INTEGER icomploc
      INTEGER nobcsmax
CEOP

      _BEGIN_MASTER( myThid )

C     initialise parameters
      ierr    = -5
      icglom1 = 0
      icomploc= 0

cph(
      print *, 'ph-test icomp, ncvarcomp, ichknum ',
     &     icomp, ncvarcomp, ichknum
cph)
      IF ( icomp.GT.0 ) THEN
       IF ( icomp.LE.ncvarcomp ) THEN
C--     A valid component of the control variable has been selected.
        IF ( ichknum.EQ.1 ) THEN
          itest     = 0
          icomptest = 0
          irecwrk   = 1
c         bjwrk     = 1
c         biwrk     = 1
          kwrk      = 1
c         iobcswrk  = 1
          jwrk      = 1
          iwrk      = 1
          icglo     = 0
        ELSE
          itest     = itestmem (ichknum-1)
          icomptest = icompmem (ichknum-1)
          irecwrk   = irecmem  (ichknum-1)
c         bjwrk     = bjmem    (ichknum-1)
c         biwrk     = bimem    (ichknum-1)
          kwrk      = klocmem  (ichknum-1)
c         iobcswrk  = iobcsmem (ichknum-1)
          icglo     = icglomem (ichknum-1)
          jwrk      = jlocmem  (ichknum-1)
          iwrk      = ilocmem  (ichknum-1)
          iwrk      = iwrk + 1
        ENDIF

C--   set max loop index for obcs multiplicities
        IF ( ncvargrd(grdchkvarindex).EQ.'m' ) THEN
#ifdef ALLOW_OBCS_CONTROL
         nobcsmax = nobcs
#else
         print *, 'S/R grdchk_loc: Ooops!'
#endif
        ELSE
          nobcsmax = 1
        ENDIF

cph(
cph-print        print *, 'ph-grd _loc: icomp, ichknum ',
cph-print     &       icomp, ichknum, ncvarcomp
cpj)
C--   Start to loop over records.
        DO irec = irecwrk, ncvarrecs(grdchkvarindex)
c        do iobcs = iobcswrk, nobcsmax
         iobcs = MOD((irec-1),nobcsmax) + 1
c        do bj = bjwrk, nSy
c         do bi = biwrk, nSx
           bj = jLocTile
           bi = iLocTile

           DO k = kwrk, ncvarnrmax(grdchkvarindex)
             icglo   = icglo + nwettile(bi,bj,k,iobcs)
             icglom1 = icglo - nwettile(bi,bj,k,iobcs)
cph(
        print *, 'ph-grd _loc: bi, bj, icomptest, ichknum ',
     &       bi, bj, icomptest, ichknum
cph-print        print *, 'ph-grd _loc: icglo ',
cph-print     &       k, icglo, icglom1, iwetsum(bi,bj,k)
cpj)
             IF ( (ierr .NE. 0) .AND.
     &            (icomp .GT. icglom1 .AND. icomp .LE. icglo) ) THEN
cph
cph             if ( (ierr .NE. 0) .AND.
cph     &            (icomp .GT.
cph     &              (iobcs-1)*iwetsum(bi,bj,nr)+iwetsum(bi,bj,k-1))
cph     &              .AND.
cph     &            (icomp .LE.
cph     &              (iobcs-1)*iwetsum(bi,bj,nr)+iwetsum(bi,bj,k))) then
cph
               IF ( icomptest .EQ. 0 ) THEN
                  icomptest = icglom1
               ENDIF

               icomploc = icomp
               icvrec = irec
               itile  = bi
               jtile  = bj
cph(
cph-print               print *, 'ph-grd irec, bj, bi, k ', irec, bj, bi, k
cpj)
               DO j = jwrk, ncvarymax(grdchkvarindex)
                DO i = iwrk, ncvarxmax(grdchkvarindex)
                 IF ( ierr.NE.0 ) THEN
                  IF ( ncvargrd(grdchkvarindex).EQ.'c' ) THEN
                     IF ( maskC(i,j,k,bi,bj).GT.0. ) THEN
                        icomptest = icomptest + 1
                        itmp = i
                        jtmp = j
                     ENDIF
                  ELSEIF ( ncvargrd(grdchkvarindex).EQ.'s' ) THEN
                     IF ( _maskS(i,j,k,bi,bj).GT.0. ) THEN
                        icomptest = icomptest + 1
                        itmp = i
                        jtmp = j
                     ENDIF
                  ELSEIF ( ncvargrd(grdchkvarindex).EQ.'w' ) THEN
                     IF ( _maskW(i,j,k,bi,bj).GT.0. ) THEN
                        icomptest = icomptest + 1
                        itmp = i
                        jtmp = j
                     ENDIF
#ifdef ALLOW_SHELFICE
                  ELSEIF ( ncvargrd(grdchkvarindex).EQ.'i' ) THEN
                     IF ( maskSHI(i,j,k,bi,bj).GT.0. ) THEN
                        icomptest = icomptest + 1
                        itmp = i
                        jtmp = j
                     ENDIF
#endif /* ALLOW_SHELFICE */
#ifdef ALLOW_OBCS_CONTROL
                  ELSEIF ( ncvargrd(grdchkvarindex).EQ.'m' ) THEN
                     IF ( ncvarfname(grdchkvarindex)
     &                  .EQ.xx_obcsn_file ) THEN
# ifdef ALLOW_OBCSN_CONTROL
                        IF ( grdchk_maskxz(i,k,bi,bj,iobcs).GT.0.
     &                       .AND. j.EQ.OB_Jn(i,bi,bj) ) THEN
                           icomptest = icomptest + 1
                           itmp = i
                           jtmp = OB_Jn(i,bi,bj)
                        ENDIF
# endif
                     ELSEIF ( ncvarfname(grdchkvarindex)
     &                       .EQ.xx_obcss_file ) THEN
# ifdef ALLOW_OBCSS_CONTROL
                        IF ( grdchk_maskxz(i,k,bi,bj,iobcs).GT.0.
     &                       .AND. j.EQ.OB_Js(i,bi,bj) ) THEN
                           icomptest = icomptest + 1
                           itmp = i
                           jtmp = OB_Js(i,bi,bj)
                        ENDIF
# endif
                     ELSEIF ( ncvarfname(grdchkvarindex)
     &                       .EQ.xx_obcse_file ) THEN
# ifdef ALLOW_OBCSE_CONTROL
                        IF ( grdchk_maskyz(j,k,bi,bj,iobcs).GT.0.
     &                       .AND. i.EQ.OB_Ie(j,bi,bj) ) THEN
                           icomptest = icomptest + 1
                           itmp = OB_Ie(j,bi,bj)
                           jtmp = j
                        ENDIF
# endif
                     ELSEIF ( ncvarfname(grdchkvarindex)
     &                       .EQ.xx_obcsw_file ) THEN
# ifdef ALLOW_OBCSW_CONTROL
                        IF ( grdchk_maskyz(j,k,bi,bj,iobcs).GT.0.
     &                       .AND. i.EQ.OB_Iw(j,bi,bj) ) THEN
                           icomptest = icomptest + 1
                           itmp = OB_Iw(j,bi,bj)
                           jtmp = j
                        ENDIF
# endif
                     ENDIF
#endif /* ALLOW_OBCS_CONTROL */
                  ENDIF
cph(
cph-print                  print *, 'ph-grd icomp, icomptest, icomploc, i, j ',
cph-print     &                 icomp, icomptest, icomploc, i, j
cpj)
                  IF ( icomploc .EQ. icomptest ) THEN
                     itilepos = itmp
                     jtilepos = jtmp
                     layer    = k
                     obcspos  = iobcs
                     ierr     = 0
cph                     itest    = iwetsum(bi,bj,k)
cph(
                     print *, 'ph-grd -->hit<-- ', itmp,jtmp,k,iobcs
                     goto 1234
cph)
                  ENDIF
                 ENDIF

                ENDDO
                iwrk = 1
               ENDDO
               jwrk = 1

             ELSEIF ( ierr.NE.0 ) THEN
               IF ( icomptest.EQ.icomp-1 ) THEN
                 icomptest = icomptest
               ELSE
C Start icomptest on next vertical layer
                 icomptest = 0
                 DO kk = 1, k
                   icomptest = icomptest + nwettile(bi,bj,kk,iobcs)
                 ENDDO
               ENDIF

               iwrk      = 1
               jwrk      = 1

             ENDIF

C--   End of loop over k
           ENDDO
           kwrk = 1
C--   End of loop over bi
c         enddo
c         biwrk = 1
C--   End of loop over bj
c        enddo
c        bjwrk = 1
C--   End of loop over iobcs
c        enddo
c        iobcswrk = 1
C--   End of loop over irec records.
        ENDDO

       ELSE
C--   else icomp > ncvarcomp
         IF ( icomp .GT. maxncvarcomps ) THEN
C--        Such a component does not exist.
           ierr     = -4
           icvrec   = -1
           jtile    = -1
           itile    = -1
           layer    = -1
           obcspos  = -1
           jtilepos = -1
           itilepos = -1
         ELSE
C--        The component is a land point.
           ierr     = -3
           icvrec   = -1
           jtile    = -1
           itile    = -1
           layer    = -1
           obcspos  = -1
           jtilepos = -1
           itilepos = -1
         ENDIF
C--   End if/else block icomp =< ncvarcomp
       ENDIF
      ELSE
C--   else not( icomp > 0 )
         IF ( icomp .LT. 0 ) THEN
C--         Such a component does not exist.
            ierr     = -2
            icvrec   = -1
            jtile    = -1
            itile    = -1
            layer    = -1
            obcspos  = -1
            jtilepos = -1
            itilepos = -1
         ELSE
C--         Component zero.
            ierr     = -1
            icvrec   = -1
            jtile    = -1
            itile    = -1
            layer    = -1
            obcspos  = -1
            jtilepos = -1
            itilepos = -1
         ENDIF
C--   End if/else block icomp > 0
      ENDIF

 1234 CONTINUE

      _END_MASTER( myThid )

      _BARRIER

#endif /* ALLOW_GRDCHK */

      RETURN
      END

#include "LAND_OPTIONS.h"

CBOP
C     !ROUTINE: LAND_IMPL_TEMP
C     !INTERFACE:
      SUBROUTINE LAND_IMPL_TEMP(
     I                land_frc, 
     I                dTskin, sFlx,
     O                dTsurf,
     I                bi, bj, myTime, myIter, myThid)

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R LAND_IMPL_TEMP
C     | o solve ground temp. and surface temp. implicitly 
C     *==========================================================*
C     | o account for snow layer (with no heat capacity) 
C     |   and ground water freezing/melting
C     | o surf. heat flux is linearly dependent on surf. temp.
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     == Global variables ===
C-- size for MITgcm & Land package :
#include "LAND_SIZE.h" 

#include "EEPARAMS.h"
#include "LAND_PARAMS.h"
#include "LAND_VARS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     land_frc :: land fraction [0-1]
C     dTskin   :: temp. correction for daily-cycle heating [K]
C     sFlx     :: surf. heat flux (+=down) function of surface temp. Ts:
C                 0: Flx(Ts=0) ; 1: Flx(Ts=Ts^n) ; 2: d.Flx/dTs(Ts=Ts^n)
C     dTsurf   :: surf. temp adjusment: Ts^n+1 - Ts^n
C     bi,bj    :: Tile index
C     myTime   :: Current time of simulation ( s )
C     myIter   :: Current iteration number in simulation
C     myThid   :: Number of this instance of the routine
      _RS land_frc(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL dTskin(sNx,sNy), sFlx(sNx,sNy,0:2) 
      _RL dTsurf(sNx,sNy)
      INTEGER bi, bj, myIter, myThid
      _RL myTime
CEOP

#ifdef ALLOW_LAND

C     == Local variables ==
C-  local variables used in solving the ground temp. implicitly :
C     aLoc         :: ground Conductivity * delT / delZ_12    [J/K]
C     bLoc         :: minus surf. flux derivative ./. Ts      [W/m2/K]
C     cLoc         :: temporary value for level.1 heat capacity [J/m2/K]
C     eLoc         :: temporary value for level.1 ground enthalpy [J/m2]
C     fLoc         :: temporary value for surface heat flux [W/m2]
C     alpha        :: snow thicknes / snow conductivity [m2.K/W]
C     beta         :: local coeff = 1/(1+alpha*bLoc)    [1]
C     tSurf        :: surf.  temperature   [oC]
C     tg           :: ground temperature   [oC]    (2 levels)
C     eg           :: ground enthalpy      [J/m2]  (2 levels)
C     cg           :: ground heat capacity [J/m2/K](2 levels)
C     mW           :: ground water mass    [kg/m2] (2 levels)
C     temp_af      :: ground temperature if above freezing
C     temp_bf      :: ground temperature if below freezing
C     mSnow        :: mass of snow         [kg/m2]
C     dMsn         :: mass of melting snow [kg/m2]
C     delT         :: time step            [s]
C     mSnEpsil     :: small snow mass      [kg/m2]
C     i,j,k        :: loop counters
C     msgBuf       :: Informational/error meesage buffer
C     tmpFlag      :: temp. flag, =.T. until found final groung temp
      _RL aLoc, bLoc, cLoc, eLoc, fLoc, alpha, beta
      _RL tSurf, tg(land_nLev), eg(land_nLev)
      _RL cg(land_nLev), mW(land_nLev)
      _RL temp_af, temp_bf
      _RL mSnow, dMsn, delT
      _RL mSnEpsil
      _RL tmp1, tmp2
      INTEGER i,j,k
      LOGICAL tmpFlag

#ifdef LAND_DEBUG
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      LOGICAL dBug, debugFlag
      INTEGER iprt,jprt,lprt
      DATA iprt, jprt , lprt / 19 , 20 , 6 /
      DATA debugFlag / .FALSE. /
 1010 FORMAT(A,I3,1P4E11.3)
#endif

      DATA    mSnEpsil / 1. _d -6 /

C-------------------------------------------------------------------------
C  solve implicitly the coupled 3 eq. (time level n+1 omitted) :
C    1a : if hs=0 : Flx = Flx^o + d.F/dT*(Ts - Ts^n) & Ts=Tg1
C    1b : if hs>0 : Flx = (Ts-Tg1)*Ks/hs =< Flx^o + d.F/dT*(Ts - Ts^n)
C         & difference used to melt the snow, maintaining Ts=0 
C    2  : Eg1 - Eg1^n  = delT*Flx - (lambda*delT/delZ_12)*(Tg1-Tg2)
C    3  : Eg2 - Eg2^n  = (lambda*delT/delZ_12)*(Tg1-Tg2)
C    were  lambda = ground Conductivity ; Ks = snow Conductivity
C          k=1,2: Eg_k = Cg_k * Tg_k - Lfreez * mIce_k
C
C  using local variables:
C   a = lambda*delT/delZ_12 ; b = - d.F/dT ;  f = Flx^o + b*Ts^n
C                         alpha = hs/Ks ;  beta = 1/(1+alpha*b)
C  3.eq system becomes: 
C   o if Ts*hs =< 0
C     1a,b:  Ts = ( Tg1 + alpha*F)*beta
C      2  : Eg1 + a*(Tg1-Tg2) + (b*delT)*beta*Tg1 = Eg1^n + delT*f*beta
C      3  : Eg2 + a*(Tg2-Tg1) = Eg2^n
C   o else: 
C     1.b : Ts=0 , f = Flx(ts=0) ; snowMelt = (f + Tg1/alpha)/Lfreez
C      2  : Eg1 + a*(Tg1-Tg2) + (delT/alpha)*Tg1 = Eg1^n
C      3  : Eg2 + a*(Tg2-Tg1) = Eg2^n
C-------------------------------------------------------------------------

C---  Solve implicitely for ground temp. & surface temp

      delT = land_deltaT
      aLoc = land_grdLambda*land_deltaT*land_rec_dzC(2)
      DO j=1,sNy
       DO i=1,sNx
        IF ( land_frc(i,j,bi,bj).GT.0. ) THEN

C--   initialise local variables
          tmpFlag = .TRUE.
          tSurf = land_skinT(i,j,bi,bj)
          mSnow = land_rhoSnow*land_hSnow(i,j,bi,bj)
          bLoc  = -sFlx(i,j,2)
          fLoc  = sFlx(i,j,1)+bLoc*tSurf
          alpha = land_hSnow(i,j,bi,bj)/diffKsnow
          beta  = 1. _d 0/(1. _d 0+alpha*bLoc)
          DO k=1,land_nLev
            eg(k) = land_dzF(k)*land_enthalp(i,j,k,bi,bj)
            mW(k) = land_dzF(k)*land_groundW(i,j,k,bi,bj)
     &                         *land_waterCap*land_rhoLiqW
            mW(k) = MAX( mW(k), 0. _d 0 )
            cg(k) = land_dzF(k)*land_heatCs + mW(k)*land_CpWater
            tg(k) = land_groundT(i,j,k,bi,bj)
          ENDDO
#ifdef LAND_DEBUG
          dBug = bi.eq.lprt .AND. i.EQ.iprt .AND. j.EQ.jprt
          IF (dBug) write(6,1010)
     &         'LAND_IMPL_TEMP: 0 , ts,tg1&2,mSw=',0,tSurf,tg,mSnow
          IF (dBug) write(6,1010)
     &         'LAND_IMPL_TEMP: 0 , sFlx=', 0,(sFlx(i,j,k),k=0,2)
#endif

C---   Solve for temp as if no freezing/melting was occuring :
          tg(1) = ( cg(1)*tg(1) + fLoc*delT*beta
     &                          + cg(2)*tg(2)*aLoc/(cg(2)+aLoc)
     &            )
     &          / ( cg(1) + aLoc + bLoc*delT*beta
     &                           - aLoc*aLoc/(cg(2)+aLoc) 
     &            )
          tg(2) = ( cg(2)*tg(2) + aLoc*tg(1) ) / (cg(2)+aLoc)
          tSurf = ( tg(1) + alpha*fLoc ) * beta
          
#ifdef LAND_DEBUG
          IF (dBug) write(6,1010)
     &         'LAND_IMPL_TEMP: 1 , ts,tg1&2,mW1=',1,tSurf,tg,mW(1)
#endif
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C---   If melting/freezing (top of snow layer, ground water level 1 or 2)
C      set corresponding temp to freezing point and update enthalpy 
C--------------

          IF ( tg(2)*land_groundT(i,j,2,bi,bj) .LE. 0. _d 0 
     &         .AND. tmpFlag .AND. tSurf*mSnow .LE. 0. _d 0 ) THEN
C--    freezing/melting in level 2: set Tg2 to freezing point
           tmp1 = tg(1)
           tmp2 = tg(2)
           tg(2) = 0.
           eLoc = eg(1) + fLoc*delT*beta
           cLoc = cg(1) + aLoc + bLoc*delT*beta
           temp_bf = (eLoc+land_Lfreez*mW(1))/cLoc
           temp_af =  eLoc/cLoc
           tg(1) = MIN( temp_bf, MAX(temp_af, 0. _d 0) )
           tSurf = ( tg(1) + alpha*fLoc ) * beta
           IF ( tSurf*mSnow .LE. 0. _d 0 ) THEN
             tmpFlag = .FALSE.
             eg(1) = eLoc - (aLoc + bLoc*delT*beta)*tg(1)
             eg(2) = eg(2) + aLoc*tg(1) 
#ifdef LAND_DEBUG
           ELSEIF ( debugFlag ) THEN
             WRITE(msgBuf,'(A,2I4,2I3,I10)')
     &             'LAND_IMPL_TEMP: i,j,bi,bj,Iter=',
     &             i,j,bi,bj,myIter
             CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
             WRITE(msgBuf,'(A,1P4E12.4)')
     &             'LAND_IMPL_TEMP: groundT,t2,ts=',
     &             land_groundT(i,j,1,bi,bj),land_groundT(i,j,2,bi,bj),
     &             tmp2,(tmp1+alpha*fLoc)*beta
             CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
             WRITE(msgBuf,'(A,1P4E12.4)')
     &             'LAND_IMPL_TEMP: Tg,tSurf,mSnw=',
     &              tg,tSurf,mSnow
             CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
             WRITE(msgBuf,'(A,1P4E14.6)')
     &             'LAND_IMPL_TEMP: eg,mW=', eg,mW
             CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
#endif
           ENDIF

C-  if tg2_new*tg2_old < 0 : end
          ENDIF

C--------------

          IF ( tg(1)*land_groundT(i,j,1,bi,bj) .LE. 0. _d 0 
     &         .AND. tmpFlag .AND. tSurf*mSnow .LE. 0. _d 0 ) THEN
C--    freezing/melting in level 1: set Tg1 to freezing point
           tmp1 = tg(1)
           tg(1) = 0.
           tg(2) = cg(2)*tg(2) / (cg(2)+aLoc)
           tSurf = alpha*fLoc * beta
           IF ( tSurf*mSnow .LE. 0. _d 0 ) THEN
             tmpFlag = .FALSE.
             eg(2) = eg(2) - aLoc*tg(2) 
             eg(1) = eg(1) + aLoc*tg(2) + fLoc*delT*beta
             IF ( eg(1)*mSnow .GT. 0. _d 0 ) THEN
C-           melt snow from bottom
              dMsn = MIN( mSnow, eg(1)*recip_Lfreez )
              land_Pr_m_Ev(i,j,bi,bj) = dMsn/delT
              land_hSnow(i,j,bi,bj) = (mSnow - dMsn)/land_rhoSnow 
              eg(1) = eg(1) - dMsn*land_Lfreez
#ifdef LAND_DEBUG
              IF (dBug) write(6,1010)
     &         'LAND_IMPL_TEMP: Bot-Melt : dMsn,dEg1,eg1=',
     &         1, dMsn, -dMsn*land_Lfreez, eg(1) 
#endif
             ENDIF
#ifdef LAND_DEBUG
           ELSEIF ( debugFlag ) THEN
             WRITE(msgBuf,'(A,2I4,2I3,I10)')
     &             'LAND_IMPL_TEMP: i,j,bi,bj,Iter=',
     &             i,j,bi,bj,myIter
             CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
             WRITE(msgBuf,'(A,4F11.6)')
     &             'LAND_IMPL_TEMP: groundT,t1,ts=',
     &             land_groundT(i,j,1,bi,bj),land_groundT(i,j,2,bi,bj),
     &             tmp1,(tmp1+alpha*fLoc)*beta
             CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
             WRITE(msgBuf,'(A,4F12.7)')
     &             'LAND_IMPL_TEMP: Tg,tSurf,mSnow=',
     &             tg,tSurf,mSnow
             CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
             WRITE(msgBuf,'(A,1P4E14.6)')
     &             'LAND_IMPL_TEMP: eg,mW=', eg,mW
             CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
             WRITE(msgBuf,'(A)')  
     &             'LAND_IMPL_TEMP: snow with ts > 0 ! but continue'
             CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
#endif
           ENDIF

C-  if tg1_new*tg1_old < 0 : end
          ENDIF

C--------------

          IF ( tmpFlag .AND. tSurf*mSnow .GT. 0. _d 0 ) THEN
C--    snow is melting at the surface: set ts=0 & use fixed heat flux Flx(ts=0)
#ifdef LAND_DEBUG
              IF (dBug) write(6,1010)
     &         'LAND_IMPL_TEMP: Top-Melt : fx0, fx1, fx1-b*Ts =',
     &         1, sFlx(i,j,0), fLoc, fLoc-bLoc*tSurf
#endif
           tSurf = 0. _d 0
           fLoc = sFlx(i,j,0)
           dTsurf(i,j) = 1000.
           tg(1) = land_groundT(i,j,1,bi,bj)
           tg(2) = land_groundT(i,j,2,bi,bj)

           eLoc = cg(1)*tg(1)
     &          + delT*fLoc - land_Lfreez*mSnow + aLoc*tg(2)
           IF ( eLoc .GT. 0. _d 0 .OR. mSnow.LT.mSnEpsil ) THEN
C-     all snow melt: do not solve diffusion of heat in snow layer
C      but put surf. heat flux directly to 1rst level and set tg1=0
             dMsn = mSnow
             tg(1) = 0. _d 0
             tg(2) = cg(2)*tg(2) / (cg(2)+aLoc)
           ELSE
C-     solve diffusion of heat in snow layer ; heat flux difference 
C      (surf.Flx - diffusion.Flx) is used to melt the snow from top.
            tg(1) = ( cg(1)*tg(1) + cg(2)*tg(2)*aLoc/(cg(2)+aLoc) )
     &       / ( cg(1)+aLoc + delT/alpha - aLoc*aLoc/(cg(2)+aLoc) )
            tg(2) = ( cg(2)*tg(2) + aLoc*tg(1) ) / (cg(2)+aLoc)
            IF ( tg(2)*land_groundT(i,j,2,bi,bj).LE.0. _d 0 ) THEN
              tg(2) = 0.
              tg(1) = cg(1)*tg(1) / ( cg(1)+aLoc + delT/alpha )
            ELSEIF ( tg(1)*land_groundT(i,j,1,bi,bj).LE.0. _d 0 ) THEN
              tg(1) = 0.
              tg(2) = cg(2)*tg(2) / (cg(2)+aLoc)
            ENDIF
            dMsn = ( fLoc+tg(1)/alpha )*delT*recip_Lfreez
#ifdef LAND_DEBUG
              IF (dBug) write(6,1010)
     &         'LAND_IMPL_TEMP: Surf-Melt: dMsn,fLoc,tg1/alpha=',
     &          2, dMsn, fLoc,tg(1)/alpha
#endif
C-  note: Fx0 < -tg(1)/alpha can happen (due to non-linearity in Fx(Ts)), 
C-     => do not melt nor accumulate snow but put d.Flx in Eg1
            dMsn = MIN( MAX(dMsn, 0. _d 0), mSnow )
           ENDIF
           tmpFlag = .FALSE.
           eg(2) = eg(2) + aLoc*(tg(1)-tg(2))
           eg(1) = eg(1) - aLoc*(tg(1)-tg(2))
     &           + delT*fLoc - land_Lfreez*dMsn
           land_Pr_m_Ev(i,j,bi,bj) = dMsn/delT
           land_hSnow(i,j,bi,bj) = (mSnow - dMsn)/land_rhoSnow 

C-  if ts*hSnow > 0 , else:
          ELSEIF ( tmpFlag ) THEN
C--   snow is not melting & no freezing/melting in ground level 1 & 2
           eg(2) = eg(2) + aLoc*(tg(1)-tg(2))
           eg(1) = eg(1) - aLoc*(tg(1)-tg(2))
     &           + delT*(fLoc-bLoc*Tsurf)
           tmpFlag = .FALSE.
          ENDIF

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C---  Save new values :
          IF ( dTsurf(i,j) .LE. 999. ) 
     &         dTsurf(i,j) = tSurf - land_skinT(i,j,bi,bj)
          land_skinT(i,j,bi,bj) = tSurf
          DO k=1,land_nLev
            land_enthalp(i,j,k,bi,bj) = eg(k)/land_dzF(k)
            land_groundT(i,j,k,bi,bj) = tg(k)
          ENDDO

#ifdef LAND_DEBUG
          IF (dBug) write(6,1010) 'LAND_IMPL_TEMP: 9, ts,tg1&2,dTs=',9,
     &         tSurf, tg, dTsurf(i,j)
          IF (dBug) write(6,1010) 'LAND_IMPL_TEMP: 9, Eg1,Eg2,mPmE=',9,
     &       (land_enthalp(i,j,k,bi,bj),k=1,2), land_Pr_m_Ev(i,j,bi,bj)
#endif

        ENDIF
       ENDDO
      ENDDO

#endif /* ALLOW_LAND */

      RETURN
      END

#include "AUTODIFF_OPTIONS.h"

c     ==================================================================
c
c     adopen_adclose.F: Routines to handle the I/O of the TAF generated
c                       code. All files are direct access files.
c     Routines:
c
c     o  adopen  - Open file  (here a dummy routine).
c     o  adclose - Close file (here a dummy routine).
c
c
c     The following input veriables are used throughout in the argument
c     lists:
c
c     name   -  character
c                 On entry, name is the extended tape name.
c     len    -  integer
c                 On entry, len is the number of characters in name.
c     tid    -  integer
c                 On entry, tid identifies the tape.
c     vid    -  integer
c                 On entry, vid identifies the variable to be stored on
c                 the tape.
c     var    -  real array of dimension length
c                 On entry, var contains the values to be stored.
c                           var must not be changed.
c     size   -  integer
c                 On entry, size is the size in bytes of the type of
c                           variable var.
c     length -  integer
c                 On entry, length is the dimension of the variable
c                           stored on the tape.
c     irec   -  integer
c                 On entry, irec is the record number to be written.
c     mythid -  integer
c                 On entry, mythid is the number of the thread or
c                           instance of the program.
c     myiter -  integer
c                 On entry, myiter is the current iteration step during
c                           the integration.
c
c     TAF does not provide the two leading arguments mythid and myiter
c     when compiling the MITgcmUV code. Instead the is a sed script avail-
c     able that does change the TAF-generated adjoint code.
c
c     Only the master thread is allowed to write data and only gobal
c     model arrays are allowed to be written be the subsequent routines.
c     Tiled data are to be stored in common blocks. This implies that at
c     least a two level checkpointing for the adjoint code has to be
c     available.
c
c     ==================================================================


CBOP
C     !ROUTINE: adopen
C     !INTERFACE:
      subroutine adopen(
     I                   mythid,
cph(
cph     I                   myiter,
cph)
     I                   name,
     I                   len,
     I                   tid,
     I                   vid,
     I                   size,
     I                   length
     &                 )

C     !DESCRIPTION: \bv
c     ==================================================================
c     SUBROUTINE adopen
c     ==================================================================
c     o Dummy routine expected to be available by TAF I/O.
c     This routine is simply a dummy routine expected to be available by
c     the Transformation of Algorithm in Fortran (TAF). Files are opened
c     and closed by the routines that are called by *adread* and
c     *adwrite*.
c     started: Christian Eckert eckert@mit.edu 30-Jun-1999
c     ==================================================================
c     SUBROUTINE adopen
c     ==================================================================
C     \ev

C     !USES:
      implicit none

c     == global variables ==

C     !INPUT/OUTPUT PARAMETERS:
c     == routine arguments ==
c     name   -  extended tape name.
c     len    -  number of characters in name.
c     tid    -  tape identifier.
c     vid    -  identifies the variable to be stored on tape.
c     size   -  size in bytes of the type of variable var.
c     length -  dimension of the variable stored on the tape.
c     mythid -  number of the thread or instance of the program.

      integer mythid
cph(
cph      integer myiter
cph)
      character*(*) name
      integer len
      integer tid
      integer vid
      integer size
      integer length

C     !LOCAL VARIABLES:
c     == local variables ==

c     == end of interface ==
CEOP

      return
      end


CBOP
C     !ROUTINE: adclose
C     !INTERFACE:
      subroutine adclose(
     I                    mythid,
cph(
cph     I                    myiter,
cph)
     I                    name,
     I                    len,
     I                    tid,
     I                    vid,
     I                    size,
     I                    length
     &                  )


C     !DESCRIPTION: \bv
c     ==================================================================
c     SUBROUTINE adclose
c     ==================================================================
c     o Dummy routine expected to be available by TAF I/O.
c     This routine is simply a dummy routine expected to be available by
c     the Transformation of Algorithm in Fortran (TAF). Files are opened
c     and closed by the routines that are called by *adread* and
c     *adwrite*.
c     started: Christian Eckert eckert@mit.edu 30-Jun-1999
c     ==================================================================
c     SUBROUTINE adclose
c     ==================================================================
C     \ev

C     !USES:
      implicit none

c     == global variables ==

C     !INPUT/OUTPUT PARAMETERS:
c     == routine arguments ==
c     name   -  extended tape name.
c     len    -  number of characters in name.
c     tid    -  tape identifier.
c     vid    -  identifies the variable to be stored on tape.
c     size   -  size in bytes of the type of variable var.
c     length -  dimension of the variable stored on the tape.
c     mythid -  number of the thread or instance of the program.

      integer mythid
cph(
cph      integer myiter
cph)
      character*(*) name
      integer len
      integer tid
      integer vid
      integer size
      integer length

C     !LOCAL VARIABLES:
c     == local variables ==

c     == end of interface ==
CEOP

      return
      end

#include "ctrparam.h"
#include "ATM2D_OPTIONS.h"

C     !INTERFACE:
      SUBROUTINE SUM_YR_END_DIAGS(  myTime, myIter, myThid )
C     *==========================================================*
C     | Tabulate year-end annual mean diagnostics                |
c     | Called at top of coupled period, after seaice growth/melt|
C     *==========================================================*
        IMPLICIT NONE

C     === Global Atmosphere Variables ===
#include "ATMSIZE.h"
#include "SIZE.h"
#include "GRID.h"
#include "EEPARAMS.h"
#include "THSICE_VARS.h"
#include "ATM2D_VARS.h"


C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
C     myTime - current simulation time (ocean model time)
C     myIter - iteration number (ocean model)
C     myThid - Thread no. that called this routine.
      _RL     myTime
      INTEGER myIter
      INTEGER myThid

C     LOCAL VARIABLES:
      INTEGER i,j
      _RL iceArea

      iceArea = 0. _d 0
      DO j=1,int(sNy/2)
        DO i=1,sNx
          IF (iceMask(i,j,1,1).GT. 0. _d 0)
     &        iceArea = iceArea + rA(i,j,1,1)*iceMask(i,j,1,1)
        ENDDO
      ENDDO
      SHice_min=min(SHice_min,iceArea)
      SHice_max=max(SHice_max,iceArea)

      iceArea = 0. _d 0
      DO j=int(sNy/2),sNy
        DO i=1,sNx
          IF (iceMask(i,j,1,1).GT. 0. _d 0)
     &        iceArea = iceArea + rA(i,j,1,1)*iceMask(i,j,1,1)
        ENDDO
      ENDDO
      NHice_min=min(NHice_min,iceArea)
      NHice_max=max(NHice_max,iceArea)

      DO j=1,sNy
        DO i=1,sNx

          IF (maskC(i,j,1,1,1) .EQ. 1.) THEN
            sst_tave= sst_tave + rA(i,j,1,1)*sstFromOcn(i,j)
            sss_tave= sss_tave + rA(i,j,1,1)*sssFromOcn(i,j)
            HF2ocn_tave = HF2ocn_tave + rA(i,j,1,1)*pass_qnet(i,j)
            FW2ocn_tave = FW2ocn_tave + rA(i,j,1,1)*
     &       (pass_precip(i,j) + pass_evap(i,j) + pass_runoff(i,j))

            CO2flx_tave = CO2flx_tave + rA(i,j,1,1)*oFluxCO2(i,j)
          ENDIF

        ENDDO
      ENDDO

      RETURN
      END

#include "COST_OPTIONS.h"

      SUBROUTINE cost_accumulate_mean( myThid )
C     *==========================================================*
C     | SUBROUTINE cost_accumulate_mean                          |
C     | o accumulate mean state for cost evalualtion             |
C     *==========================================================*
      IMPLICIT NONE

C     == Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "DYNVARS.h"
#include "GRID.h"

#include "cost.h"

C     == Routine arguments ==
C     myThid - Thread number for this instance of the routine.
      INTEGER myThid

#ifdef ALLOW_COST
C     == Local variables
      INTEGER i, j, k
      INTEGER bi, bj
      _RL     deltaTfrac

      deltaTfrac = deltaTClock/lastinterval

C--   Calculate cost function on tile of this instance
      DO bj = myByLo(myThid), myByHi(myThid)
        DO bi = myBxLo(myThid), myBxHi(myThid)
          DO k = 1, Nr
            DO j=1,sNy
              DO i=1,sNx
                cMeanTheta(i,j,k,bi,bj) = cMeanTheta(i,j,k,bi,bj)
     &                + theta(i,j,k,bi,bj) * deltaTfrac
                cMeanUVel(i,j,k,bi,bj) = cMeanUVel(i,j,k,bi,bj)
     &               + uVel(i,j,k,bi,bj) * deltaTfrac
                cMeanVVel(i,j,k,bi,bj) = cMeanVVel(i,j,k,bi,bj)
     &               + vVel(i,j,k,bi,bj) * deltaTfrac

                cMeanThetaUVel(i,j,k,bi,bj) =
     &               cMeanThetaUVel(i,j,k,bi,bj)
     &               + halfRL*(theta(i,j,k,bi,bj)+theta(i-1,j,k,bi,bj))
     &                 *uvel(i,j,k,bi,bj)
     &                 *maskW(i,j,k,bi,bj)*maskC(i,j,k,bi,bj)
     &                 *deltaTfrac
                cMeanThetaVVel(i,j,k,bi,bj) =
     &               cMeanThetaVVel(i,j,k,bi,bj)
     &               + halfRL*(theta(i,j,k,bi,bj)+theta(i,j-1,k,bi,bj))
     &                 *vvel(i,j,k,bi,bj)
     &                 *maskS(i,j,k,bi,bj)*maskC(i,j,k,bi,bj)
     &                 *deltaTfrac
              ENDDO
            ENDDO
          ENDDO
        ENDDO
      ENDDO

#endif

      RETURN
      END

#include "LAND_OPTIONS.h"

CBOP
C     !ROUTINE: LAND_MONITOR
C     !INTERFACE:
      SUBROUTINE LAND_MONITOR( land_frc, myTime, myIter, myThid )

C     !DESCRIPTION:
C     Do land global and Hemispheric diagnostic

C     !USES:
      IMPLICIT NONE
#include "LAND_SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "LAND_PARAMS.h"
#include "LAND_VARS.h"
#ifdef ALLOW_MONITOR
# include "MONITOR.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     land_frc :: land fraction [0-1]
C     myTime   :: Current time of simulation ( s )
C     myIter   :: Iteration number
C     myThid   ::  Number of this instance of INI_FORCING
      _RS land_frc(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL     myTime
      INTEGER myIter
      INTEGER myThid
CEOP

#ifdef ALLOW_LAND
#ifdef ALLOW_MONITOR

C     === Functions ====
      LOGICAL  DIFFERENT_MULTIPLE
      EXTERNAL DIFFERENT_MULTIPLE
      LOGICAL  MASTER_CPU_IO
      EXTERNAL MASTER_CPU_IO

C     == Local variables ==
C     nLatBnd    :: Number of latitude bands
C     msgBuf     :: Informational/error message buffer
C     mon_var    :: Variable sufix name
C     mon_sufx   :: Latitude band sufix
C     n, k       :: loop counter
C     yBand      :: latitude separation
C     locDr      :: thickness (= 1. here)
C     theMin     :: lat. band minimum value
C     theMax     :: lat. band maximum value
C     theMean    :: lat. band mean value
C     theVar     :: lat. band variance
C     theVol     :: lat. band volume (or area if locDr=1.)
C     theMeanG   :: global mean value
C     theVarG    :: global variance
C     theVolG    :: global volume (or area if locDr=1.)
C     theEng     :: lat. band energy content
C     theEnergy  :: total energy
      INTEGER nLatBnd
      PARAMETER ( nLatBnd = 3 )
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      CHARACTER*10 mon_var
      CHARACTER*2 mon_sufx(0:nLatBnd)
      INTEGER n, k
      _RS yBand(nLatBnd), locDr(land_nLev)
      _RL theMin(nLatBnd), theMax(nLatBnd)
      _RL theMean(nLatBnd), theVar(nLatBnd), theVol(nLatBnd)
      _RL theMeanG, theVolG
      _RL theEng(nLatBnd), theEnergy

      DATA yBand /  0. , -24. , 24. /
      DATA mon_sufx / '_G' , '_S' , '_T' , '_N' /

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      IF ( DIFFERENT_MULTIPLE(land_monFreq,myTime,deltaTClock)
     &     .OR. myIter.EQ.nIter0 ) THEN

        IF ( MASTER_CPU_IO(myThid) ) THEN
C--   only the master thread is allowed to switch On/Off mon_write_stdout
C     & mon_write_mnc (since it is the only thread that uses those flags):

         IF ( land_mon_stdio ) THEN
           mon_write_stdout = .TRUE.
         ELSE
           mon_write_stdout = .FALSE.
         ENDIF
         mon_write_mnc    = .FALSE.
#ifdef ALLOW_MNC
         IF ( useMNC .AND. land_mon_mnc ) THEN
           DO k = 1,MAX_LEN_MBUF
             mon_fname(k:k) = ' '
           ENDDO
           mon_fname(1:12) = 'monitor_land'
           CALL MNC_CW_APPEND_VNAME(
     &          'T', '-_-_--__-__t', 0,0, myThid)
           CALL MNC_CW_SET_UDIM(mon_fname, -1, myThid)
           CALL MNC_CW_I_W_S(
     &         'I',mon_fname,1,1,'T', myIter, myThid)
           CALL MNC_CW_SET_UDIM(mon_fname, 0, myThid)
           mon_write_mnc = .TRUE.
         ENDIF
#endif /* ALLOW_MNC */

         IF ( mon_write_stdout ) THEN
            WRITE(msgBuf,'(2A)') '// ===========================',
     &           '============================'
            CALL PRINT_MESSAGE(msgBuf, mon_ioUnit, SQUEEZE_RIGHT, 1)
            WRITE(msgBuf,'(A)') '// Begin MONITOR Land statistics'
            CALL PRINT_MESSAGE(msgBuf, mon_ioUnit, SQUEEZE_RIGHT, 1)
            WRITE(msgBuf,'(2A)') '// ===========================',
     &           '============================'
            CALL PRINT_MESSAGE(msgBuf, mon_ioUnit, SQUEEZE_RIGHT, 1)
          ENDIF

C--   endif master cpu io
        ENDIF

        CALL MON_SET_PREF('land_',myThid)
        CALL MON_OUT_RL('time_sec', myTime,mon_string_none,myThid)

        DO k=1,land_nLev
          locDr(k)= 1.
        ENDDO

C-- Snow thickness :
        CALL MON_STATS_LATBND_RL(
     I                1, 1, 1, nLatBnd, yBand,
     I                land_hSnow, land_frc, maskInC, rA, yC, locDr,
     O                theMin, theMax, theMean, theVar, theVol,
     I                myThid )
        theVolG = 0.
        theMeanG= 0.
        DO n=1,nLatBnd
         theVolG  = theVolG  + theVol(n)
         theMeanG = theMeanG + theMean(n)*theVol(n)
         theEng(n)= -land_rhoSnow*land_Lfreez*theMean(n)*theVol(n)
        ENDDO
        IF (theVolG.GT.0.) theMeanG = theMeanG / theVolG

        mon_var='SnwH_ave'
        CALL MON_OUT_RL(mon_var,theMeanG  , mon_sufx(0), myThid)
        CALL MON_OUT_RL(mon_var,theMean(1), mon_sufx(1), myThid)
        CALL MON_OUT_RL(mon_var,theMean(2), mon_sufx(2), myThid)
        CALL MON_OUT_RL(mon_var,theMean(3), mon_sufx(3), myThid)
        mon_var='SnwH_max'
        CALL MON_OUT_RL(mon_var, theMax(1), mon_sufx(1), myThid)
        CALL MON_OUT_RL(mon_var, theMax(2), mon_sufx(2), myThid)
        CALL MON_OUT_RL(mon_var, theMax(3), mon_sufx(3), myThid)

        IF ( myIter.EQ.1+nIter0 ) THEN
          _BEGIN_MASTER(myThid)
          WRITE(msgBuf,'(A,1PE16.9,A,0P9F7.2)') '%MON LAND : Area=',
     &      theVolG, ' ; Lat sep=', (yBand(n),n=2,nLatBnd)
          CALL PRINT_MESSAGE( msgBuf, mon_ioUnit, SQUEEZE_RIGHT , 1)
          WRITE(msgBuf,'(A,1P9E16.9)') '%MON LAND : LatA=',
     &                              (theVol(n),n=1,nLatBnd)
          CALL PRINT_MESSAGE( msgBuf, mon_ioUnit, SQUEEZE_RIGHT , 1)
          _END_MASTER(myThid)
        ENDIF

C-- Surface Temp. :
        CALL MON_STATS_LATBND_RL(
     I                1, 1, 1, nLatBnd, yBand,
     I                land_skinT, land_frc, maskInC, rA, yC, locDr,
     O                theMin, theMax, theMean, theVar, theVol,
     I                myThid )
        theVolG = 0.
        theMeanG= 0.
        DO n=1,nLatBnd
         theVolG  = theVolG  + theVol(n)
         theMeanG = theMeanG + theMean(n)*theVol(n)
        ENDDO
        IF (theVolG.GT.0.) theMeanG = theMeanG / theVolG

        mon_var='Tsrf_ave'
        CALL MON_OUT_RL(mon_var,theMeanG  , mon_sufx(0), myThid)
        CALL MON_OUT_RL(mon_var,theMean(1), mon_sufx(1), myThid)
        CALL MON_OUT_RL(mon_var,theMean(2), mon_sufx(2), myThid)
        CALL MON_OUT_RL(mon_var,theMean(3), mon_sufx(3), myThid)
        mon_var='Tsrf_min'
        CALL MON_OUT_RL(mon_var, theMin(1), mon_sufx(1), myThid)
        CALL MON_OUT_RL(mon_var, theMin(2), mon_sufx(2), myThid)
        CALL MON_OUT_RL(mon_var, theMin(3), mon_sufx(3), myThid)
        mon_var='Tsrf_max'
        CALL MON_OUT_RL(mon_var, theMax(1), mon_sufx(1), myThid)
        CALL MON_OUT_RL(mon_var, theMax(2), mon_sufx(2), myThid)
        CALL MON_OUT_RL(mon_var, theMax(3), mon_sufx(3), myThid)

C-- 1rst level (volume-mean) Temp. :
        CALL MON_STATS_LATBND_RL(
     I                land_nLev, 1, 1, nLatBnd, yBand,
     I                land_groundT, land_frc, maskInC, rA, yC, locDr,
     O                theMin, theMax, theMean, theVar, theVol,
     I                myThid )
        theVolG = 0.
        theMeanG= 0.
        DO n=1,nLatBnd
         theVolG  = theVolG  + theVol(n)
         theMeanG = theMeanG + theMean(n)*theVol(n)
        ENDDO
        IF (theVolG.GT.0.) theMeanG = theMeanG / theVolG

        mon_var='Tgr1_ave'
        CALL MON_OUT_RL(mon_var,theMeanG  , mon_sufx(0), myThid)
        CALL MON_OUT_RL(mon_var,theMean(1), mon_sufx(1), myThid)
        CALL MON_OUT_RL(mon_var,theMean(2), mon_sufx(2), myThid)
        CALL MON_OUT_RL(mon_var,theMean(3), mon_sufx(3), myThid)
        mon_var='Tgr1_min'
        CALL MON_OUT_RL(mon_var, theMin(1), mon_sufx(1), myThid)
        CALL MON_OUT_RL(mon_var, theMin(2), mon_sufx(2), myThid)
        CALL MON_OUT_RL(mon_var, theMin(3), mon_sufx(3), myThid)
        mon_var='Tgr1_max'
        CALL MON_OUT_RL(mon_var, theMax(1), mon_sufx(1), myThid)
        CALL MON_OUT_RL(mon_var, theMax(2), mon_sufx(2), myThid)
        CALL MON_OUT_RL(mon_var, theMax(3), mon_sufx(3), myThid)

C-- 2nd  level (volume-mean) Temp. :
        CALL MON_STATS_LATBND_RL(
     I                land_nLev, 1, 2, nLatBnd, yBand,
     I                land_groundT, land_frc, maskInC, rA, yC, locDr,
     O                theMin, theMax, theMean, theVar, theVol,
     I                myThid )
        theVolG = 0.
        theMeanG= 0.
        DO n=1,nLatBnd
         theVolG  = theVolG  + theVol(n)
         theMeanG = theMeanG + theMean(n)*theVol(n)
        ENDDO
        IF (theVolG.GT.0.) theMeanG = theMeanG / theVolG

        mon_var='Tgr2_ave'
        CALL MON_OUT_RL(mon_var,theMeanG  , mon_sufx(0), myThid)
        CALL MON_OUT_RL(mon_var,theMean(1), mon_sufx(1), myThid)
        CALL MON_OUT_RL(mon_var,theMean(2), mon_sufx(2), myThid)
        CALL MON_OUT_RL(mon_var,theMean(3), mon_sufx(3), myThid)
        mon_var='Tgr2_min'
        CALL MON_OUT_RL(mon_var, theMin(1), mon_sufx(1), myThid)
        CALL MON_OUT_RL(mon_var, theMin(2), mon_sufx(2), myThid)
        CALL MON_OUT_RL(mon_var, theMin(3), mon_sufx(3), myThid)
        mon_var='Tgr2_max'
        CALL MON_OUT_RL(mon_var, theMax(1), mon_sufx(1), myThid)
        CALL MON_OUT_RL(mon_var, theMax(2), mon_sufx(2), myThid)
        CALL MON_OUT_RL(mon_var, theMax(3), mon_sufx(3), myThid)

C-- Total Energy :
        DO k=1,land_nLev
          locDr(k)= land_dzF(k)
        ENDDO
        CALL MON_STATS_LATBND_RL(
     I                land_nLev, 1, 0, nLatBnd, yBand,
     I                land_enthalp, land_frc, maskInC, rA, yC, locDr,
     O                theMin, theMax, theMean, theVar, theVol,
     I                myThid )
        theEnergy = 0.
        DO n=1,nLatBnd
         theEng(n) = theEng(n) + theMean(n)*theVol(n)
         theEnergy = theEnergy + theEng(n)
        ENDDO
        mon_var='TotEnerg'
        CALL MON_OUT_RL(mon_var,theEnergy, mon_sufx(0), myThid)
        CALL MON_OUT_RL(mon_var,theEng(1), mon_sufx(1), myThid)
        CALL MON_OUT_RL(mon_var,theEng(2), mon_sufx(2), myThid)
        CALL MON_OUT_RL(mon_var,theEng(3), mon_sufx(3), myThid)

C-- Soil water content (level 1+2):
        CALL MON_STATS_LATBND_RL(
     I                land_nLev, 1, 0, nLatBnd, yBand,
     I                land_groundW, land_frc, maskInC, rA, yC, locDr,
     O                theMin, theMax, theMean, theVar, theVol,
     I                myThid )
        theVolG = 0.
        theMeanG= 0.
        DO n=1,nLatBnd
         theVolG  = theVolG  + theVol(n)
         theMeanG = theMeanG + theMean(n)*theVol(n)
        ENDDO
        IF (theVolG.GT.0.) theMeanG = theMeanG / theVolG

        mon_var='grdW_ave'
        CALL MON_OUT_RL(mon_var,theMeanG  , mon_sufx(0), myThid)
        CALL MON_OUT_RL(mon_var,theMean(1), mon_sufx(1), myThid)
        CALL MON_OUT_RL(mon_var,theMean(2), mon_sufx(2), myThid)
        CALL MON_OUT_RL(mon_var,theMean(3), mon_sufx(3), myThid)
        mon_var='grdW_min'
        CALL MON_OUT_RL(mon_var, theMin(1), mon_sufx(1), myThid)
        CALL MON_OUT_RL(mon_var, theMin(2), mon_sufx(2), myThid)
        CALL MON_OUT_RL(mon_var, theMin(3), mon_sufx(3), myThid)
c       mon_var='grdW_max'
c       CALL MON_OUT_RL(mon_var, theMax(1), mon_sufx(1), myThid)
c       CALL MON_OUT_RL(mon_var, theMax(2), mon_sufx(2), myThid)
c       CALL MON_OUT_RL(mon_var, theMax(3), mon_sufx(3), myThid)

        IF ( MASTER_CPU_IO(myThid) ) THEN
C--   only the master thread is allowed to switch On/Off mon_write_stdout
C     & mon_write_mnc (since it is the only thread that uses those flags):

          IF (mon_write_stdout) THEN
            WRITE(msgBuf,'(2A)') '// ===========================',
     &           '============================'
            CALL PRINT_MESSAGE(msgBuf, mon_ioUnit, SQUEEZE_RIGHT, 1)
            WRITE(msgBuf,'(A)') '// End MONITOR Land statistics'
            CALL PRINT_MESSAGE(msgBuf, mon_ioUnit, SQUEEZE_RIGHT, 1)
            WRITE(msgBuf,'(2A)') '// ===========================',
     &           '============================'
            CALL PRINT_MESSAGE(msgBuf, mon_ioUnit, SQUEEZE_RIGHT, 1)
          ENDIF

          mon_write_stdout = .FALSE.
          mon_write_mnc    = .FALSE.

C--   endif master cpu io
        ENDIF

C     endif different multiple
      ENDIF

#endif /* ALLOW_MONITOR */
#endif /* ALLOW_LAND */

      RETURN
      END

#include "SHELFICE_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: SHELFICE_READ_PICKUP

C     !INTERFACE:
      SUBROUTINE SHELFICE_READ_PICKUP( seqFlag, myIter, myThid )

C     !DESCRIPTION:
C     Reads current state of SHELFICE from a pickup file

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "SHELFICE.h"

C     !INPUT PARAMETERS:
C     seqFlag :: flag that indicate where this S/R is called from:
C             :: =0 called early on, from: ini_masks_etc.F
C             :: =1 called from INIT_VARIA (i.e. usual place)
C     myIter  :: my time-step number
C     myThid  :: my Thread Id number
      INTEGER seqFlag
      INTEGER myIter
      INTEGER myThid

#ifdef ALLOW_SHELFICE
C     !LOCAL VARIABLES:
C     fn          :: character buffer for creating filename
C     fp          :: precision of pickup files
C     filePrec    :: pickup-file precision (read from meta file)
C     nbFields    :: number of fields in pickup file (read from meta file)
C     missFldList :: List of missing fields   (attempted to read but not found)
C     missFldDim  :: Dimension of missing fields list array: missFldList
C     nMissing    :: Number of missing fields (attempted to read but not found)
C     j           :: loop index
C     nj          :: record number
C     ioUnit      :: temp for writing msg unit
C     msgBuf      :: Informational/error message buffer
      INTEGER fp
      INTEGER filePrec, nbFields
      INTEGER missFldDim, nMissing
      INTEGER j, nj, ioUnit
      PARAMETER( missFldDim = 12 )
      CHARACTER*(10) suff
      CHARACTER*(MAX_LEN_FNAM) fn
      CHARACTER*(8) missFldList(missFldDim)
      CHARACTER*(MAX_LEN_MBUF) msgBuf
CEOP

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      IF ( pickupSuff.EQ.' ' ) THEN
        IF ( rwSuffixType.EQ.0 ) THEN
          WRITE(fn,'(A,I10.10)') 'pickup_shelfice.', nIter0
        ELSE
          CALL RW_GET_SUFFIX( suff, startTime, nIter0, myThid )
          WRITE(fn,'(A,A)') 'pickup_shelfice.', suff
        ENDIF
      ELSE
        WRITE(fn,'(A,A10)')    'pickup_shelfice.', pickupSuff
      ENDIF
      fp = precFloat64

      CALL READ_MFLDS_SET(
     I                      fn,
     O                      nbFields, filePrec,
     I                      Nr, nIter0, myThid )

      _BEGIN_MASTER( myThid )
      IF ( nbFields.GE.0 .AND. filePrec.NE.fp ) THEN
         WRITE(msgBuf,'(2A,I4)') 'SHELFICE_READ_PICKUP: ',
     &    'pickup-file binary precision do not match !'
         CALL PRINT_ERROR( msgBuf, myThid )
         WRITE(msgBuf,'(A,2(A,I4))') 'SHELFICE_READ_PICKUP: ',
     &    'file prec.=', filePrec, ' but expecting prec.=', fp
         CALL PRINT_ERROR( msgBuf, myThid )
         CALL ALL_PROC_DIE( 0 )
         STOP 'ABNORMAL END: S/R SHELFICE_READ_PICKUP (data-prec Pb)'
      ENDIF
      _END_MASTER( myThid )

      IF ( nbFields.LE.0 ) THEN
C-      No meta-file or old meta-file without List of Fields
        ioUnit = errorMessageUnit
        IF ( pickupStrictlyMatch ) THEN
          WRITE(msgBuf,'(4A)') 'SHELFICE_READ_PICKUP: ',
     &      'no field-list found in meta-file',
     &      ' => cannot check for strick-matching'
          CALL PRINT_ERROR( msgBuf, myThid )
          WRITE(msgBuf,'(4A)') 'SHELFICE_READ_PICKUP: ',
     &      'try with " pickupStrictlyMatch=.FALSE.,"',
     &      ' in file: "data", NameList: "PARM03"'
          CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
          CALL ALL_PROC_DIE( myThid )
          STOP 'ABNORMAL END: S/R SHELFICE_READ_PICKUP'
        ELSE
          WRITE(msgBuf,'(4A)') 'WARNING >> SHELFICE_READ_PICKUP: ',
     &      ' no field-list found'
          CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
         IF ( nbFields.EQ.-1 ) THEN
C-      No meta-file
          WRITE(msgBuf,'(4A)') 'WARNING >> ',
     &      ' try to read pickup as currently written'
          CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
         ELSE
C-      Old meta-file without List of Fields
c         WRITE(msgBuf,'(4A)') 'WARNING >> ',
c    &      ' try to read pickup as it used to be written'
c         CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
c         WRITE(msgBuf,'(4A)') 'WARNING >> ',
c    &      ' until checkpoint59l (2007 Dec 17)'
c         CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
          WRITE(msgBuf,'(4A)') 'SHELFICE_READ_PICKUP: ',
     &      'no field-list found in meta-file'
          CALL PRINT_ERROR( msgBuf, myThid )
          CALL ALL_PROC_DIE( myThid )
          STOP 'ABNORMAL END: S/R SHELFICE_READ_PICKUP'
         ENDIF
        ENDIF
      ENDIF

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      IF ( nbFields.EQ.0 ) THEN
C---  Old way to read pickup:

      ELSE
C---  New way to read SHELFICE pickup:
        nj = 0
C-    read SHELFICE 3-D fields for restart
        nj = nj*Nr
C-    read SHELFICE 2-D fields for restart

        IF ( seqFlag.EQ.1 .AND. SHELFICEMassStepping ) THEN
          CALL READ_MFLDS_3D_RL( 'SHI_mass', shelficeMass,
     &                                 nj, fp, 1 , nIter0, myThid )
        ENDIF

#ifdef ALLOW_SHELFICE_REMESHING
        IF ( seqFlag.EQ.0 .AND. SHELFICEremeshFrequency.GT.zeroRL ) THEN
          CALL READ_MFLDS_LEV_RS( 'R_Shelfi', R_shelfIce,
     &                            nj, fp, 1, 1, 1, nIter0, myThid )
        ENDIF
#endif /* ALLOW_SHELFICE_REMESHING */

C--   end: new way to read pickup file
      ENDIF

C--   Check for missing fields:
      nMissing = missFldDim
      CALL READ_MFLDS_CHECK(
     O                     missFldList,
     U                     nMissing,
     I                     nIter0, myThid )
      IF ( nMissing.GT.missFldDim ) THEN
         WRITE(msgBuf,'(2A,I4)') 'SHELFICE_READ_PICKUP: ',
     &     'missing fields list has been truncated to', missFldDim
         CALL PRINT_ERROR( msgBuf, myThid )
         CALL ALL_PROC_DIE( myThid )
         STOP 'ABNORMAL END: S/R SHELFICE_READ_PICKUP (list-size Pb)'
      ENDIF
      IF ( nMissing.GE.1 ) THEN
        ioUnit = errorMessageUnit
        DO j=1,nMissing
         WRITE(msgBuf,'(4A)') 'SHELFICE_READ_PICKUP: ',
     &       'cannot restart without field "',missFldList(nj),'"'
         CALL PRINT_ERROR( msgBuf, myThid )
        ENDDO
        CALL ALL_PROC_DIE( myThid )
        STOP 'ABNORMAL END: S/R SHELFICE_READ_PICKUP'
      ENDIF

C--   Update overlap regions:
      IF ( seqFlag.EQ.1 .AND. SHELFICEMassStepping ) THEN
        CALL EXCH_XY_RL( shelficeMass, myThid )
      ENDIF
#ifdef ALLOW_SHELFICE_REMESHING
      IF ( seqFlag.EQ.0 .AND. SHELFICEremeshFrequency.GT.zeroRL ) THEN
        CALL EXCH_XY_RS( R_shelfIce, myThid )
      ENDIF
#endif

#endif /* ALLOW_SHELFICE */

      RETURN
      END

#include "FIZHI_OPTIONS.h"

      SUBROUTINE FIZHI_INIT_VEG(myThid,vegdata,im,jm,nSx,nSy,Nxg,Nyg,
     & maxtyp,nchp,nchptot,nchpland,lons,lats,surftype,tilefrac,
     & igrd,ityp,chfr,chlt,chlon)
C***********************************************************************
C Subroutine fizhi_init_veg - routine to read in the land surface types,
C      interpolate to the models grid, and set up tile space for use by
C      the land surface model, the albedo calculation and the surface
C      roughness calculation.
C
C INPUT:
C
C myThid   - thread number (processor number)
C vegdata  - Character*40 Vegetation Dataset name
C im       - longitude dimension
C jm       - latitude dimension (number of lat. points)
C nSx      - Number of processors in x-direction
C nSy      - Number of processors in y-direction
C maxtyp   - maximum allowable number of land surface types per grid box
C nchp     - integer per-processor number of tiles in tile space
C lons     - longitude in degrees [im,jm,nSx,nSy]
C lats     - latitude in degrees [im,jm,nSx,nSy]
C
C OUTPUT:
C
C surftype - integer array of land surface types [im,jm,maxtyp,nSx,nSy]
C tilefrac - real array of corresponding land surface type fractions
C            [im,jm,maxtyp,nSx,nSy]
C igrd     - integer array in tile space of grid point number for each
C            tile [nchp,nSx,nSy]
C ityp     - integer array in tile space of land surface type for each
C            tile [nchp,nSx,nSy]
C chfr     - real array in tile space of land surface type fraction for
C            each tile [nchp,nSx,nSy]
C
C NOTES:
C       Vegetation type as follows:
C                  1:  BROADLEAF EVERGREEN TREES
C                  2:  BROADLEAF DECIDUOUS TREES
C                  3:  NEEDLELEAF TREES
C                  4:  GROUND COVER
C                  5:  BROADLEAF SHRUBS
C                  6:  DWARF TREES (TUNDRA)
C                  7:  BARE SOIL
C                  8:  DESERT
C                  9:  GLACIER
C                 10:  DARK DESERT
C                100:  OCEAN
C***********************************************************************
      IMPLICIT NONE
#include "EEPARAMS.h"

      INTEGER myThid,im,jm,maxtyp,nchp,nSx,nSy,Nxg,Nyg
      INTEGER nchptot(nSx,nSy), nchpland(nSx,nSy)
      INTEGER surftype(im,jm,maxtyp,nSx,nSy)
      INTEGER igrd(nchp,nSx,nSy),ityp(nchp,nSx,nSy)
      _RL tilefrac(im,jm,maxtyp,nSx,nSy)
      _RL lats(im,jm,nSx,nSy), lons(im,jm,nSx,nSy)
      _RL chfr(nchp,nSx,nSy),chlt(nchp,nSx,nSy),chlon(nchp,nSx,nSy)

C-    local variables:
      CHARACTER*40 vegdata
      INTEGER i,j,k,bi,bj

      WRITE(standardMessageUnit,'(2A)') ' FIZHI_INIT_VEG: ',
     &   'defining surface type and fraction: ----------------------'

      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)

        do j = 1,jm
         do i = 1,im
           surftype(i,j,1,bi,bj) = 100
           tilefrac(i,j,1,bi,bj) = 0.99 _d 0
           surftype(i,j,2,bi,bj) = 100
           tilefrac(i,j,2,bi,bj) = 0.01 _d 0
         enddo
        enddo
        do k = 3,maxtyp
         do j = 1,jm
          do i = 1,im
           surftype(i,j,k,bi,bj) = 0
           tilefrac(i,j,k,bi,bj) = 0.
          enddo
         enddo
        enddo

       ENDDO
      ENDDO

C     create chip arrays for :
C      igrd :  grid index
C      ityp :  veg. type
C      chfr :  vegetation fraction
C      chlon:  chip longitude
C      chlt :  chip latitude

C     nchpland<=nchptot is the actual number of land chips
      WRITE(standardMessageUnit,'(2A)') ' FIZHI_INIT_VEG: ',
     &   'setting surface Tiles:'

      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)

C-       initialise grid index array:
         do i=1,nchp
           igrd(i,bi,bj) = 1
         enddo

C-       land points:
         nchpland(bi,bj) = 0

C-       ocean points:
         nchptot(bi,bj) = nchpland(bi,bj)
         do k=1,maxtyp
          do j=1,jm
           do i=1,im
             if(surftype(i,j,k,bi,bj).ge.100 .and.
     &            tilefrac(i,j,k,bi,bj).gt.0.) then
               nchptot(bi,bj)  = nchptot(bi,bj) + 1
               igrd (nchptot(bi,bj),bi,bj) = i + (j-1)*im
               ityp (nchptot(bi,bj),bi,bj) = surftype(i,j,k,bi,bj)
               chfr (nchptot(bi,bj),bi,bj) = tilefrac(i,j,k,bi,bj)
               chlon(nchptot(bi,bj),bi,bj) = lons(i,j,bi,bj)
               chlt (nchptot(bi,bj),bi,bj) = lats(i,j,bi,bj)
             endif
           enddo
          enddo
         enddo

         WRITE(standardMessageUnit,'(2(A,I4),2(A,I10))') '  bi=', bi,
     &    ', bj=', bj, ', # of Land Tiles=', nchpland(bi,bj),
     &                 ', Total # of Tiles=', nchptot(bi,bj)

       ENDDO
      ENDDO

      WRITE(standardMessageUnit,'(2A)') ' FIZHI_INIT_VEG: done'

      RETURN
      END

#include "SEAICE_OPTIONS.h"
#ifdef ALLOW_THSICE
# include "THSICE_OPTIONS.h"
#endif /* ALLOW_THSICE */
#ifdef ALLOW_AUTODIFF
# include "AUTODIFF_OPTIONS.h"
#endif

CStartOfInterface
      SUBROUTINE SEAICE_MAP_THSICE( myTime, myIter, myThid )
C     *==========================================================*
C     | SUBROUTINE SEAICE_MAP_THSICE                             |
C     | o Map thermodynamic thsice variable iceMask and          |
C     |   to seaice variables HEFF and AREA                      |
C     *==========================================================*
C     | written by Martin Losch, June 2006                       |
C     *==========================================================*
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "SEAICE_SIZE.h"
#include "SEAICE_PARAMS.h"
#include "SEAICE.h"
#ifdef ALLOW_THSICE
# include "THSICE_VARS.h"
#endif /* ALLOW_THSICE */
#ifdef ALLOW_AUTODIFF_TAMC
# include "tamc.h"
#endif

C     === Routine arguments ===
C     myTime - Simulation time
C     myIter - Simulation timestep number
C     myThid - Thread no. that called this routine.
      _RL     myTime
      INTEGER myIter
      INTEGER myThid
CEndOfInterface

#ifdef ALLOW_THSICE
C     === Local variables ===
C     i,j,bi,bj - Loop counters

      INTEGER i, j, bi, bj

# ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE icemask   = comlev1, key=ikey_dynamics, kind=isbyte
CADJ STORE iceheight = comlev1, key=ikey_dynamics, kind=isbyte
#endif

      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          AREA(i,j,bi,bj) = iceMask(i,j,bi,bj)
          HEFF(i,j,bi,bj) = iceMask(i,j,bi,bj)*iceHeight(i,j,bi,bj)
         ENDDO
        ENDDO
       ENDDO
      ENDDO
      IF ( SEAICEaddSnowMass ) THEN
# ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE snowheight = comlev1, key=ikey_dynamics, kind=isbyte
#endif
       DO bj=myByLo(myThid),myByHi(myThid)
        DO bi=myBxLo(myThid),myBxHi(myThid)
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           HSNOW(i,j,bi,bj) = iceMask(i,j,bi,bj)*snowHeight(i,j,bi,bj)
          ENDDO
         ENDDO
        ENDDO
       ENDDO
      ENDIF

#endif /* ALLOW_THSICE */
      RETURN
      END

#include "BULK_FORCE_OPTIONS.h"

CBOP
C     !ROUTINE: BULKF_FORMULA_LAY
C     !INTERFACE:
      SUBROUTINE BULKF_FORMULA_LAY(
     I                           uw, vw, ws, Ta, Qa, tsfCel,
     O                           flwupa, flha, fsha, df0dT,
     O                           ust, vst, evp, ssq, dEvdT,
     I                           iceornot, i,j,bi,bj,myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE BULKF_FORMULA_LAY
C     | o Calculate bulk formula fluxes over open ocean or seaice
C     |   Large and Yeager, 2004, NCAR/TN-460+STR.
C     *==========================================================*
C     \ev
C
C === Turbulent Fluxes :
C  * use the approach "B": shift coeff to height & stability of the
C    atmosphere state (instead of "C": shift temp & humid to the height
C    of wind, then shift the coeff to this height & stability of the atmos).
C  * similar to EXF (except over sea-ice) ; default parameter values
C    taken from Large & Yeager.
C  * assume that Qair & Tair inputs are from the same height (zq=zt)
C  * formulae in short:
C     wind stress = (ust,vst) = rhoA * Cd * Ws * (del.u,del.v)
C     Sensib Heat flux = fsha = rhoA * Ch * Ws * del.T * CpAir
C     Latent Heat flux = flha = rhoA * Ce * Ws * del.Q * Lvap
C                      = -Evap * Lvap
C   with Ws = wind speed = sqrt(del.u^2 +del.v^2) ;
C        del.T = Tair - Tsurf ; del.Q = Qair - Qsurf ;
C        Cd,Ch,Ce = drag coefficient, Stanton number and Dalton number
C              respectively [no-units], function of height & stability

C     !USES:
       IMPLICIT NONE
C     === Global variables ===
#include "EEPARAMS.h"
#include "SIZE.h"
#include "PARAMS.h"
#include "BULKF_PARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     input:
      _RL uw                 ! zonal wind speed (at grid center) [m/s]
      _RL vw                 ! meridional wind speed (at grid center) [m/s]
      _RL ws                 ! wind speed        [m/s]   at height zwd
      _RL Ta                 ! air temperature   [K]     at height zth
      _RL Qa                 ! specific humidity [kg/kg] at heigth zth
      _RL tsfCel             ! sea-ice or sea surface temperature [oC]
      INTEGER iceornot       ! 0=open water, 1=sea-ice, 2=sea-ice with snow
      INTEGER i,j, bi,bj     !current grid point indices
      INTEGER myThid         ! my Thread Id number
C     output:
      _RL flwupa             ! upward long wave radiation (>0 upward) [W/m2]
      _RL flha               ! latent heat flux         (>0 downward) [W/m2]
      _RL fsha               ! sensible heat flux       (>0 downward) [W/m2]
      _RL df0dT              ! derivative of heat flux with respect to Tsf [W/m2/K]
      _RL ust                ! zonal wind stress (at grid center)     [N/m2]
      _RL vst                ! meridional wind stress (at grid center)[N/m2]
      _RL evp                ! evaporation rate (over open water) [kg/m2/s]
      _RL ssq                ! surface specific humidity          [kg/kg]
      _RL dEvdT              ! derivative of evap. with respect to Tsf [kg/m2/s/K]
CEOP

#ifdef ALLOW_BULK_FORCE

C     == Local variables ==
      _RL dflhdT             ! derivative of latent heat with respect to T
      _RL dfshdT             ! derivative of sensible heat with respect to T
      _RL dflwupdT           ! derivative of long wave with respect to T

      _RL Tsf                ! surface temperature [K]
      _RL Ts2                ! surface temperature square [K^2]
c     _RL ht                 ! height for air temperature [m]
c     _RL hq                 ! height for humidity [m]
c     _RL hu                 ! height for wind speed [m]
c     _RL zref               ! reference height [m]
      _RL wsm                ! limited wind speed [m/s] (> umin)
      _RL usn                ! neutral, zref (=10m) wind speed [m/s]
      _RL usm                ! usn but limited [m/s] (> umin)
c     _RL umin               ! minimum wind speed used for drag-coeff [m/s]
      _RL lath               ! latent heat of vaporization or sublimation [J/kg]
      _RL t0                 ! virtual temperature [K]
      _RL delth              ! potential temperature diff [K]
      _RL delq               ! specific humidity difference [kg/kg]
      _RL ustar              ! friction velocity [m/s]
      _RL tstar              ! temperature scale [K]
      _RL qstar              ! humidity scale  [kg/kg]
      _RL rd                 ! = sqrt(Cd)          [-]
      _RL re                 ! = Ce / sqrt(Cd)     [-]
      _RL rh                 ! = Ch / sqrt(Cd)     [-]
      _RL rdn, ren, rhn      ! neutral, zref (=10m) values of rd, re, rh
      _RL stable             ! = 1 if stable ; = 0 if unstable
      _RL huol               ! stability parameter at zwd [-] (=z/Monin-Obuklov length)
      _RL htol               ! stability parameter at zth [-]
      _RL x                  ! stability function  [-]
      _RL xsq                ! = x^2               [-]
      _RL psimh              ! momentum stability function
      _RL psixh              ! latent & sensib. stability function
      _RL czol               ! = zref*Karman_cst*gravity
      _RL zwln               ! = log(zwd/zref)
      _RL ztln               ! = log(zth/zref)
c     _RL cdalton            ! coeff to evaluate Dalton Number
c     _RL mixratio
c     _RL ea
c     _RL psim_fac
      _RL tau                ! surface stress  coef = rhoA * Ws * Cd
      _RL csha               ! sensib.heat flx coef = rhoA * Ws * Ch * CpAir
      _RL clha               ! latent heat flx coef = rhoA * Ws * Ce * Lvap
c     _RL zice
c     _RL ssq0, ssq1, ssq2   ! constant used in saturated specific humidity
c     _RL p0                 ! reference sea-level atmospheric pressure [mb]
      _RL qs1w, qs2w         !   above freezing saturated specific humidity
      _RL qs1i, qs2i         !   below freezing saturated specific humidity
      _RL tmpBlk
      _RL half, one, two
      INTEGER iter

C     == external Functions

C--   Constant
      DATA   half,      one,      two
     &     / 0.5 _d 0 , 1. _d 0 , 2. _d 0 /
c     DATA   ssq0,           ssq1,           ssq2
c    &     / 3.797915 _d 0 , 7.93252 _d -6 , 2.166847 _d -3 /
c     DATA   p0 / 1013. _d 0 /
      DATA   qs1w,           qs2w
     &     /   640.38 _d 3 , 5107.0 _d -0 /
      DATA   qs1i,           qs2i
     &     / 11637.80 _d 3 , 5897.8 _d -0 /

C-- Set surface parameters :
c             zice = 0.0005 _d 0
              zwln = LOG(zwd/zref)
              ztln = LOG(zth/zref)
              czol = zref*xkar*gravity

C-   Surface Temp.
              Tsf = tsfCel+Tf0kel
              Ts2 = Tsf*Tsf
C-   Wind speed
              IF (ws.EQ.0. _d 0) THEN
                ws = SQRT(uw*uw + vw*vw)
              ENDIF
              wsm = MAX(ws,umin)

C--- Compute turbulent surface fluxes
C-   Pot. Temp and saturated specific humidity
              t0     = Ta*(one + humid_fac*Qa)
              IF ( iceornot.EQ.0 ) THEN
                lath=Lvap
                ssq = saltQsFac*qs1w*EXP( -qs2w/Tsf ) / rhoA
                dEvdT = qs2w
              ELSE
                lath = Lvap+Lfresh
                ssq =           qs1i*EXP( -qs2i/Tsf ) / rhoA
                dEvdT = qs2i
              ENDIF
c             ssq = ssq0*EXP( lath*(ssq1-ssq2/Tsf) ) / p0
c             dEvdT = lath*ssq2

              delth  = Ta + gamma_blk*zth - Tsf
              delq   = Qa - ssq

C--  initial guess for exchange coefficients:
C    take U_N = del.U ; stability from del.Theta ;
              stable = half + SIGN(half, delth)
              tmpBlk = cdrag_1/wsm + cdrag_2 + cdrag_3*wsm
              rdn = SQRT(tmpBlk)
              rhn = stable*cStantonS + (one-stable)*cStantonU
              ren = cDalton
c             rdn=xkar/(LOG(zref/zice))
c             rhn=rdn
c             ren=rdn
C--  calculate turbulent scales
              ustar=rdn*wsm
              tstar=rhn*delth
              qstar=ren*delq

C--- iterate with psi-functions to find transfer coefficients
              DO iter=1,blk_nIter

                 huol   = ( tstar/t0
     &                     +qstar/(Qa + one/humid_fac)
     &                    )*czol/(ustar*ustar)
                 huol   = SIGN( MIN(abs(huol),10. _d 0), huol)
                 stable = half + SIGN(half, huol)
                 xsq    = SQRT( ABS(one - huol*16. _d 0) )
                 x      = SQRT(xsq)
                 psimh = -5. _d 0*huol*stable
     &             + (one-stable)*
     &                    ( LOG( (one + two*x + xsq)*(one+xsq)*.125 )
     &                     -two*ATAN(x) + half*pi )
                 htol   = huol*zth/zwd
                 xsq    = SQRT( ABS(one - htol*16. _d 0) )
                 psixh  = -5. _d 0*htol*stable
     &             + (one-stable)*( two*LOG(half*(one+xsq)) )

C-   Shift wind speed using old coefficient
                 usn = ws/(one + rdn/xkar*(zwln-psimh) )
                 usm = MAX(usn, umin)

C-   Update the 10m, neutral stability transfer coefficients
                 tmpBlk = cdrag_1/usm + cdrag_2 + cdrag_3*usm
                 rdn = SQRT(tmpBlk)
                 rhn = stable*cStantonS + (one-stable)*cStantonU
                 ren = cDalton

C-   Shift all coefficients to the measurement height and stability.
                 rd = rdn/(1. _d 0 + rdn*(zwln-psimh)/xkar)
                 rh = rhn/(1. _d 0 + rhn*(ztln-psixh)/xkar)
                 re = ren/(1. _d 0 + ren*(ztln-psixh)/xkar)

C--  Update ustar, tstar, qstar using updated, shifted coefficients.
                 ustar = rd*wsm
                 qstar = re*delq
                 tstar = rh*delth

              ENDDO

C-   Coeff:
              tau   = rhoA*rd*ws
              csha  = cpAir*tau*rh
              clha  =  lath*tau*re

C-   Turbulent Fluxes
              fsha  = csha*delth
              flha  = clha*delq
              evp   = -flha/lath
              ust   = tau*rd*uw
              vst   = tau*rd*vw

C-   surf.Temp derivative of turbulent Fluxes
              dEvdT  =  tau*re*ssq*dEvdT/Ts2
              dflhdT = -lath*dEvdT
              dfshdT = -csha

C--- Upward long wave radiation
              IF ( iceornot.EQ.0 ) THEN
                flwupa  = ocean_emissivity*stefan*Ts2*Ts2
                dflwupdT= ocean_emissivity*stefan*Ts2*Tsf*4. _d 0
              ELSEIF (iceornot.EQ.2) THEN
                flwupa   = snow_emissivity*stefan*Ts2*Ts2
                dflwupdT = snow_emissivity*stefan*Ts2*Tsf*4. _d 0
              ELSE
                flwupa   =  ice_emissivity*stefan*Ts2*Ts2
                dflwupdT =  ice_emissivity*stefan*Ts2*Tsf*4. _d 0
              ENDIF

C-   Total derivative with respect to surface temperature
              df0dT = -dflwupdT+dfshdT+dflhdT

#endif /*ALLOW_BULK_FORCE*/

      RETURN
      END

#include "ATM_CPL_OPTIONS.h"

CBOP
C     !ROUTINE: ATM_APPLY_IMPORT
C     !INTERFACE:
      SUBROUTINE ATM_APPLY_IMPORT(
     I               land_frc,
     U               atmSST, atmSIfrc,
     I               myTime, myIter, bi, bj, myThid )

C     !DESCRIPTION: \bv
C     *================================================================*
C     | S/R ATM_APPLY_IMPORT
C     | o Apply imported coupling data to ATM surface BC over ocean
C     *================================================================*
C     | Note: when using sea-ice, fill in Mixed layer fields instead
C     |      to be used later as SST by Atmos. + Sea-Ice
C     *================================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     == Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "CPL_PARAMS.h"

#ifdef ALLOW_THSICE
# include "THSICE_VARS.h"
#endif

C-- Coupled to the Ocean :
#include "ATMCPL.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     land_frc :: land fraction [0-1]
C     atmSST   :: sea surface temp [K], used in ATM component
C     atmSIfrc :: sea-ice fraction [0-1], used in ATM component
C     myTime   :: Current time of simulation ( s )
C     myIter   :: Current iteration number in simulation
C     bi,bj    :: Tile index
C     myThid   :: Number of this instance of the routine
      _RS  land_frc(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL  atmSST  (sNx,sNy)
      _RL  atmSIfrc(sNx,sNy)
      _RL myTime
      INTEGER myIter, bi, bj, myThid
CEOP

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#ifdef COMPONENT_MODULE
C     == Local variables ==
C     i,j    :: Loop counters
      INTEGER i,j

#ifdef ALLOW_THSICE
      IF ( useImportThSIce .AND. useThSIce ) THEN
       IF ( MOD(myIter,cplSendFrq_iter).EQ.0 ) THEN
C--   Put thSIce imported fields from the ocean component in thSIce common block
        DO j=1,sNy
         DO i=1,sNx
           iceMask   (i,j,bi,bj) = sIceFrac_cpl (i,j,bi,bj)
           iceHeight (i,j,bi,bj) = sIceThick_cpl(i,j,bi,bj)
           snowHeight(i,j,bi,bj) = sIceSnowH_cpl(i,j,bi,bj)
           Qice1     (i,j,bi,bj) = sIceQ1_cpl   (i,j,bi,bj)
           Qice2     (i,j,bi,bj) = sIceQ2_cpl   (i,j,bi,bj)
         ENDDO
        ENDDO
       ENDIF
C--   end if useImportThSIce & useThSIce
      ENDIF
#endif /* ALLOW_THSICE */

#ifdef ALLOW_THSICE
      IF ( useThSIce ) THEN
C--   Put fields from the ocean component in Mixed-layer arrays:

C-    fill in hOceMxL with Mixed-layer Depth from the ocean component
       IF ( useImportMxlD ) THEN
        DO j=1,sNy
         DO i=1,sNx
          IF ( land_frc(i,j,bi,bj) .LT. 1. ) THEN
            hOceMxL(i,j,bi,bj) = ocMxlD(i,j,bi,bj)
          ENDIF
         ENDDO
        ENDDO
       ENDIF

C-    fill in tOceMxL with Sea-Surface Temp. from the ocean component
       IF ( useImportSST ) THEN
        DO j=1,sNy
         DO i=1,sNx
          IF ( land_frc(i,j,bi,bj) .LT. 1. ) THEN
            tOceMxL(i,j,bi,bj) = SSTocn(i,j,bi,bj)
          ENDIF
         ENDDO
        ENDDO
       ENDIF

C-    fill in sOceMxL with Sea-Surf Salinity from the ocean component
       IF ( useImportSSS ) THEN
        DO j=1,sNy
         DO i=1,sNx
          IF ( land_frc(i,j,bi,bj) .LT. 1. ) THEN
            sOceMxL(i,j,bi,bj) = SSSocn(i,j,bi,bj)
          ENDIF
         ENDDO
        ENDDO
       ENDIF

C-    fill in v2ocMxL with surf. velocity^2  from the ocean component
       IF ( useImportVsq ) THEN
        DO j=1,sNy
         DO i=1,sNx
          IF ( land_frc(i,j,bi,bj) .LT. 1. ) THEN
            v2ocMxL(i,j,bi,bj) = vSqocn(i,j,bi,bj)
          ENDIF
         ENDDO
        ENDDO
       ENDIF

      ELSEIF ( useAtm_Phys ) THEN
#else /* ALLOW_THSICE */
      IF ( useAtm_Phys ) THEN
#endif /* ALLOW_THSICE */
C--   supply imported fields to Atm_Phys pkg:

       IF ( useImportSST ) THEN
        DO j=1,sNy
         DO i=1,sNx
          IF ( ocMxlD(i,j,bi,bj) .GT. 0. ) THEN
            atmSST(i,j) = SSTocn(i,j,bi,bj)+celsius2K
          ENDIF
         ENDDO
        ENDDO
       ENDIF

      ELSE
C--   supply imported fields to AIM (Phys) pkg:

       IF ( useImportSST ) THEN
        DO j=1,sNy
         DO i=1,sNx
          IF ( land_frc(i,j,bi,bj) .LT. 1. ) THEN

C--   take SST from the ocean compon where Sea-Ice fraction is zero
           IF ( atmSIfrc(i,j).EQ.0. ) THEN
            atmSST(i,j) = SSTocn(i,j,bi,bj)+celsius2K
           ELSEIF ( SSTocn(i,j,bi,bj).GE. -1. _d 0)  THEN
C--   take SST from the ocean compon if clearly warmer than freezing
C       then reset sea-ice fraction
            atmSST(i,j) = SSTocn(i,j,bi,bj)+celsius2K
            atmSIfrc(i,j) = 0.
           ENDIF

          ENDIF
         ENDDO
        ENDDO
       ENDIF

C-- if useThSIce / else / endif
      ENDIF

#endif /* COMPONENT_MODULE */

      RETURN
      END

#include "GAD_OPTIONS.h"
#ifdef ALLOW_PTRACERS
# include "PTRACERS_OPTIONS.h"
#endif
#ifdef ALLOW_AUTODIFF
# include "AUTODIFF_OPTIONS.h"
#endif

CBOP
C !ROUTINE: GAD_SOM_ADV_R

C !INTERFACE: ==========================================================
      SUBROUTINE GAD_SOM_ADV_R(
     I           bi,bj,k, kUp, kDw,
     I           deltaTloc, rTrans, maskUp, maskIn,
     U           sm_v,  sm_o,  sm_x,  sm_y,  sm_z,
     U           sm_xx, sm_yy, sm_zz, sm_xy, sm_xz, sm_yz,
     U           alp,   aln,   fp_v,  fn_v,  fp_o,  fn_o,
     U           fp_x,  fn_x,  fp_y,  fn_y,  fp_z,  fn_z,
     U           fp_xx, fn_xx, fp_yy, fn_yy, fp_zz, fn_zz,
     U           fp_xy, fn_xy, fp_xz, fn_xz, fp_yz, fn_yz,
     O           wT,
     I           myThid )

C !DESCRIPTION:
C  Calculates the area integrated vertical flux due to advection
C  of a tracer using
C--
C        Second-Order Moments Advection of tracer in Z-direction
C        ref: M.J.Prather, 1986, JGR, 91, D6, pp 6671-6681.
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C      The 3-D grid has dimension  (Nx,Ny,Nz) with corresponding
C      velocity field (U,V,W).  Parallel subroutine calculate
C      advection in the X- and Y- directions.
C      The moment [Si] are as defined in the text, Sm refers to
C      the total mass in each grid box
C      the moments [Fi] are similarly defined and used as temporary
C      storage for portions of the grid boxes in transit.
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C !USES: ===============================================================
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "GAD.h"
#ifdef ALLOW_AUTODIFF_TAMC
# include "tamc.h"
#endif

C !INPUT PARAMETERS: ===================================================
C  bi,bj        :: tile indices
C  k            :: vertical level
C  kUp          :: index into 2 1/2D array, toggles between 1 and 2
C  kDw          :: index into 2 1/2D array, toggles between 2 and 1
C  rTrans       :: vertical volume transport
C  maskUp       :: 2-D array mask for W points
C  maskIn       :: 2-D array Interior mask
C  myThid       :: my Thread Id. number
      INTEGER bi,bj,k, kUp, kDw
      _RL deltaTloc
      _RL rTrans(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RS maskUp(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RS maskIn(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER myThid

C !OUTPUT PARAMETERS: ==================================================
C  sm_v         :: volume of grid cell
C  sm_o         :: tracer content of grid cell (zero order moment)
C  sm_x,y,z     :: 1rst order moment of tracer distribution, in x,y,z direction
C  sm_xx,yy,zz  ::  2nd order moment of tracer distribution, in x,y,z direction
C  sm_xy,xz,yz  ::  2nd order moment of tracer distr., in cross direction xy,xz,yz
C  wT           :: vertical advective flux
      _RL sm_v  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL sm_o  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL sm_x  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL sm_y  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL sm_z  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL sm_xx (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL sm_yy (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL sm_zz (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL sm_xy (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL sm_xz (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL sm_yz (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL  alp  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,2)
      _RL  aln  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,2)
      _RL  fp_v (1-OLx:sNx+OLx,1-OLy:sNy+OLy,2)
      _RL  fn_v (1-OLx:sNx+OLx,1-OLy:sNy+OLy,2)
      _RL  fp_o (1-OLx:sNx+OLx,1-OLy:sNy+OLy,2)
      _RL  fn_o (1-OLx:sNx+OLx,1-OLy:sNy+OLy,2)
      _RL  fp_x (1-OLx:sNx+OLx,1-OLy:sNy+OLy,2)
      _RL  fn_x (1-OLx:sNx+OLx,1-OLy:sNy+OLy,2)
      _RL  fp_y (1-OLx:sNx+OLx,1-OLy:sNy+OLy,2)
      _RL  fn_y (1-OLx:sNx+OLx,1-OLy:sNy+OLy,2)
      _RL  fp_z (1-OLx:sNx+OLx,1-OLy:sNy+OLy,2)
      _RL  fn_z (1-OLx:sNx+OLx,1-OLy:sNy+OLy,2)
      _RL  fp_xx(1-OLx:sNx+OLx,1-OLy:sNy+OLy,2)
      _RL  fn_xx(1-OLx:sNx+OLx,1-OLy:sNy+OLy,2)
      _RL  fp_yy(1-OLx:sNx+OLx,1-OLy:sNy+OLy,2)
      _RL  fn_yy(1-OLx:sNx+OLx,1-OLy:sNy+OLy,2)
      _RL  fp_zz(1-OLx:sNx+OLx,1-OLy:sNy+OLy,2)
      _RL  fn_zz(1-OLx:sNx+OLx,1-OLy:sNy+OLy,2)
      _RL  fp_xy(1-OLx:sNx+OLx,1-OLy:sNy+OLy,2)
      _RL  fn_xy(1-OLx:sNx+OLx,1-OLy:sNy+OLy,2)
      _RL  fp_xz(1-OLx:sNx+OLx,1-OLy:sNy+OLy,2)
      _RL  fn_xz(1-OLx:sNx+OLx,1-OLy:sNy+OLy,2)
      _RL  fp_yz(1-OLx:sNx+OLx,1-OLy:sNy+OLy,2)
      _RL  fn_yz(1-OLx:sNx+OLx,1-OLy:sNy+OLy,2)
      _RL wT    (1-OLx:sNx+OLx,1-OLy:sNy+OLy)

#if ( defined GAD_ALLOW_TS_SOM_ADV || defined PTRACERS_ALLOW_DYN_STATE )
C !LOCAL VARIABLES: ====================================================
C  i,j          :: loop indices
C  wLoc         :: volume transported (per time step)
      _RL three
      PARAMETER( three = 3. _d 0 )
      INTEGER i,j
      INTEGER km1
      LOGICAL noFlowAcrossSurf
      _RL  recip_dT
      _RL  wLoc, alf1, alf1q, alpmn
      _RL  alfp, alpq, alp1, locTp
      _RL  alfn, alnq, aln1, locTn
CEOP

#ifdef ALLOW_AUTODIFF
# ifdef ALLOW_AUTODIFF_TAMC
CADJ INIT somtape_r = COMMON, 1
# endif
      alp(1,1,kDw) = alp(1,1,kDw)
      aln(1,1,kDw) = aln(1,1,kDw)
      fp_v(1,1,kDw) = fp_v(1,1,kDw)
      fn_v(1,1,kDw) = fn_v(1,1,kDw)
      fp_o(1,1,kDw) = fp_o(1,1,kDw)
      fn_o(1,1,kDw) = fn_o(1,1,kDw)
      fp_x(1,1,kDw) = fp_x(1,1,kDw)
      fn_x(1,1,kDw) = fn_x(1,1,kDw)
      fp_y(1,1,kDw) = fp_y(1,1,kDw)
      fn_y(1,1,kDw) = fn_y(1,1,kDw)
      fp_z(1,1,kDw) = fp_z(1,1,kDw)
      fn_z(1,1,kDw) = fn_z(1,1,kDw)
      fp_xx(1,1,kDw) = fp_xx(1,1,kDw)
      fn_xx(1,1,kDw) = fn_xx(1,1,kDw)
      fp_yy(1,1,kDw) = fp_yy(1,1,kDw)
      fn_yy(1,1,kDw) = fn_yy(1,1,kDw)
      fp_zz(1,1,kDw) = fp_zz(1,1,kDw)
      fn_zz(1,1,kDw) = fn_zz(1,1,kDw)
      fp_xy(1,1,kDw) = fp_xy(1,1,kDw)
      fn_xy(1,1,kDw) = fn_xy(1,1,kDw)
      fp_xz(1,1,kDw) = fp_xz(1,1,kDw)
      fn_xz(1,1,kDw) = fn_xz(1,1,kDw)
      fp_yz(1,1,kDw) = fp_yz(1,1,kDw)
      fn_yz(1,1,kDw) = fn_yz(1,1,kDw)
#endif

      recip_dT = zeroRL
      IF ( deltaTloc.GT.zeroRL ) recip_dT = 1.0 _d 0 / deltaTloc
      noFlowAcrossSurf = rigidLid .OR. nonlinFreeSurf.GE.1
     &                            .OR. select_rStar.NE.0

#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE sm_o,sm_v,sm_x,sm_xz,sm_y,sm_yz,sm_z,sm_zz
CADJ &     = somtape_r, key = 1, kind = isbyte
#endif
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C---  part.1 : calculate flux for all moments
      DO j=jMinAdvR,jMaxAdvR
        DO i=iMinAdvR,iMaxAdvR
          wLoc = rTrans(i,j)*deltaTloc
C--    Flux from (k) to (k-1) when W>0 (i.e., take upper side of box k)
C- note: Linear free surface case: this takes care of w_surf advection out
C       of the domain since for this particular case, rTrans is not masked
          fp_v (i,j,kUp) = MAX( zeroRL,  wLoc )
          alp  (i,j,kUp) = fp_v(i,j,kUp)/sm_v(i,j,k)
          alpq           = alp(i,j,kUp)*alp(i,j,kUp)
          alp1           = 1. _d 0 - alp(i,j,kUp)
C-     Create temporary moments/masses for partial boxes in transit
C       use same indexing as velocity, "p" for positive W
          fp_o (i,j,kUp) = alp(i,j,kUp)*
     &                   ( sm_o(i,j, k ) + alp1*sm_z(i,j, k )
     &                   + alp1*(alp1-alp(i,j,kUp))*sm_zz(i,j, k )
     &                   )
          fp_z (i,j,kUp) = alpq*
     &                   ( sm_z(i,j, k ) + three*alp1*sm_zz(i,j, k ) )
          fp_zz(i,j,kUp) = alp(i,j,kUp)*alpq*sm_zz(i,j, k )
          fp_x (i,j,kUp) = alp(i,j,kUp)*
     &                   ( sm_x(i,j, k ) + alp1*sm_xz(i,j, k ) )
          fp_y (i,j,kUp) = alp(i,j,kUp)*
     &                   ( sm_y(i,j, k ) + alp1*sm_yz(i,j, k ) )
          fp_xz(i,j,kUp) = alpq        *sm_xz(i,j, k )
          fp_yz(i,j,kUp) = alpq        *sm_yz(i,j, k )
          fp_xx(i,j,kUp) = alp(i,j,kUp)*sm_xx(i,j, k )
          fp_yy(i,j,kUp) = alp(i,j,kUp)*sm_yy(i,j, k )
          fp_xy(i,j,kUp) = alp(i,j,kUp)*sm_xy(i,j, k )
        ENDDO
      ENDDO
      IF ( k.EQ.1 ) THEN
C--   Linear free surface, calculate w_surf (<0) advection term
       km1 = 1
       DO j=jMinAdvR,jMaxAdvR
        DO i=iMinAdvR,iMaxAdvR
          wLoc = rTrans(i,j)*deltaTloc
C-     Flux from above to (k) when W<0 , surface case:
C      take box k=1, assuming zero 1rst & 2nd moment in Z dir.
          fn_v (i,j,kUp) = MAX( zeroRL, -wLoc )
          aln  (i,j,kUp) = fn_v(i,j,kUp)/sm_v(i,j,km1)
          alnq           = aln(i,j,kUp)*aln(i,j,kUp)
          aln1           = 1. _d 0 - aln(i,j,kUp)
C-     Create temporary moments/masses for partial boxes in transit
C       use same indexing as velocity, "n" for negative W
          fn_o (i,j,kUp) = aln(i,j,kUp)*sm_o(i,j,km1)
          fn_z (i,j,kUp) = zeroRL
          fn_zz(i,j,kUp) = zeroRL
          fn_x (i,j,kUp) = aln(i,j,kUp)*sm_x(i,j,km1)
          fn_y (i,j,kUp) = aln(i,j,kUp)*sm_y(i,j,km1)
          fn_xz(i,j,kUp) = zeroRL
          fn_yz(i,j,kUp) = zeroRL
          fn_xx(i,j,kUp) = aln(i,j,kUp)*sm_xx(i,j,km1)
          fn_yy(i,j,kUp) = aln(i,j,kUp)*sm_yy(i,j,km1)
          fn_xy(i,j,kUp) = aln(i,j,kUp)*sm_xy(i,j,km1)
C--    Save zero-order flux:
          wT(i,j) = ( fp_o(i,j,kUp) - fn_o(i,j,kUp) )*recip_dT
        ENDDO
       ENDDO
      ELSE
C--   Interior only: mask rTrans (if not already done)
       km1 = k-1
       DO j=jMinAdvR,jMaxAdvR
        DO i=iMinAdvR,iMaxAdvR
          wLoc = maskUp(i,j)*rTrans(i,j)*deltaTloc
C-     Flux from (k-1) to (k) when W<0 (i.e., take lower side of box k-1)
          fn_v (i,j,kUp) = MAX( zeroRL, -wLoc )
          aln  (i,j,kUp) = fn_v(i,j,kUp)/sm_v(i,j,km1)
          alnq           = aln(i,j,kUp)*aln(i,j,kUp)
          aln1           = 1. _d 0 - aln(i,j,kUp)
C-     Create temporary moments/masses for partial boxes in transit
C       use same indexing as velocity, "n" for negative W
          fn_o (i,j,kUp) = aln(i,j,kUp)*
     &                   ( sm_o(i,j,km1) - aln1*sm_z(i,j,km1)
     &                   + aln1*(aln1-aln(i,j,kUp))*sm_zz(i,j,km1)
     &                   )
          fn_z (i,j,kUp) = alnq*
     &                   ( sm_z(i,j,km1) - three*aln1*sm_zz(i,j,km1) )
          fn_zz(i,j,kUp) = aln(i,j,kUp)*alnq*sm_zz(i,j,km1)
          fn_x (i,j,kUp) = aln(i,j,kUp)*
     &                   ( sm_x(i,j,km1) - aln1*sm_xz(i,j,km1) )
          fn_y (i,j,kUp) = aln(i,j,kUp)*
     &                   ( sm_y(i,j,km1) - aln1*sm_yz(i,j,km1) )
          fn_xz(i,j,kUp) = alnq        *sm_xz(i,j,km1)
          fn_yz(i,j,kUp) = alnq        *sm_yz(i,j,km1)
          fn_xx(i,j,kUp) = aln(i,j,kUp)*sm_xx(i,j,km1)
          fn_yy(i,j,kUp) = aln(i,j,kUp)*sm_yy(i,j,km1)
          fn_xy(i,j,kUp) = aln(i,j,kUp)*sm_xy(i,j,km1)
C--    Save zero-order flux:
          wT(i,j) = ( fp_o(i,j,kUp) - fn_o(i,j,kUp) )*recip_dT
        ENDDO
       ENDDO
C--   end surface/interior cases for W<0 advective fluxes
      ENDIF
      IF ( .NOT.uniformFreeSurfLev .AND. k.NE.1 .AND.
     &     .NOT.noFlowAcrossSurf ) THEN
C--   Linear free surface, but surface not @ k=1 :
C     calculate w_surf (<0) advection term from current level
C     moments assuming zero 1rst & 2nd moment in Z dir. ;
C     and add to previous fluxes; note: identical to resetting fluxes
C     since previous fluxes are zero in this case (=> let TAF decide)
       km1 = k
       DO j=jMinAdvR,jMaxAdvR
        DO i=iMinAdvR,iMaxAdvR
         wLoc = rTrans(i,j)*deltaTloc
         IF ( k.EQ.kSurfC(i,j,bi,bj) ) THEN
C-     Flux from (k-1) to (k) when W<0 (special surface case, take box k)
          fn_v (i,j,kUp) = MAX( zeroRL, -wLoc )
          aln  (i,j,kUp) = fn_v(i,j,kUp)/sm_v(i,j,km1)
C-     Create temporary moments/masses for partial boxes in transit
C       use same indexing as velocity, "n" for negative W
          fn_o (i,j,kUp) = aln(i,j,kUp)*sm_o(i,j,km1)
          fn_x (i,j,kUp) = aln(i,j,kUp)*sm_x(i,j,km1)
          fn_y (i,j,kUp) = aln(i,j,kUp)*sm_y(i,j,km1)
          fn_xx(i,j,kUp) = aln(i,j,kUp)*sm_xx(i,j,km1)
          fn_yy(i,j,kUp) = aln(i,j,kUp)*sm_yy(i,j,km1)
          fn_xy(i,j,kUp) = aln(i,j,kUp)*sm_xy(i,j,km1)
C--    Save zero-order flux:
          wT(i,j) = ( fp_o(i,j,kUp) - fn_o(i,j,kUp) )*recip_dT
         ENDIF
        ENDDO
       ENDDO
      ENDIF

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C---  part.2 : re-adjust moments remaining in the box
C      take off from grid box (k): negative W(kDw) and positive W(kUp)
      DO j=jMinAdvR,jMaxAdvR
       DO i=iMinAdvR,iMaxAdvR
#ifdef ALLOW_OBCS
        IF ( maskIn(i,j).NE.zeroRS ) THEN
#endif /* ALLOW_OBCS */
        alf1  = 1. _d 0 - aln(i,j,kDw) - alp(i,j,kUp)
        alf1q = alf1*alf1
        alpmn = alp(i,j,kUp) - aln(i,j,kDw)
        sm_v (i,j,k) = sm_v (i,j,k) - fn_v (i,j,kDw) - fp_v (i,j,kUp)
        sm_o (i,j,k) = sm_o (i,j,k) - fn_o (i,j,kDw) - fp_o (i,j,kUp)
        sm_z (i,j,k) = alf1q*( sm_z(i,j,k) - three*alpmn*sm_zz(i,j,k) )
        sm_zz(i,j,k) = alf1*alf1q*sm_zz(i,j,k)
        sm_xz(i,j,k) = alf1q*sm_xz(i,j,k)
        sm_yz(i,j,k) = alf1q*sm_yz(i,j,k)
        sm_x (i,j,k) = sm_x (i,j,k) - fn_x (i,j,kDw) - fp_x (i,j,kUp)
        sm_xx(i,j,k) = sm_xx(i,j,k) - fn_xx(i,j,kDw) - fp_xx(i,j,kUp)
        sm_y (i,j,k) = sm_y (i,j,k) - fn_y (i,j,kDw) - fp_y (i,j,kUp)
        sm_yy(i,j,k) = sm_yy(i,j,k) - fn_yy(i,j,kDw) - fp_yy(i,j,kUp)
        sm_xy(i,j,k) = sm_xy(i,j,k) - fn_xy(i,j,kDw) - fp_xy(i,j,kUp)
#ifdef ALLOW_OBCS
        ENDIF
#endif /* ALLOW_OBCS */
       ENDDO
      ENDDO

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C---  part.3 : Put the temporary moments into appropriate neighboring boxes
C      add into grid box (k): positive W(kDw) and negative W(kUp)
      DO j=jMinAdvR,jMaxAdvR
       DO i=iMinAdvR,iMaxAdvR
#ifdef ALLOW_OBCS
        IF ( maskIn(i,j).NE.zeroRS ) THEN
#endif /* ALLOW_OBCS */
        sm_v (i,j,k) = sm_v (i,j,k) + fp_v (i,j,kDw) + fn_v (i,j,kUp)
        alfp = fp_v(i,j,kDw)/sm_v(i,j,k)
        alfn = fn_v(i,j,kUp)/sm_v(i,j,k)
        alf1 = 1. _d 0 - alfp - alfn
        alp1 = 1. _d 0 - alfp
        aln1 = 1. _d 0 - alfn
        alpmn = alfp - alfn
        locTp = alfp*sm_o(i,j,k) - alp1*fp_o(i,j,kDw)
        locTn = alfn*sm_o(i,j,k) - aln1*fn_o(i,j,kUp)
        sm_zz(i,j,k) = alf1*alf1*sm_zz(i,j,k) + alfp*alfp*fp_zz(i,j,kDw)
     &                                        + alfn*alfn*fn_zz(i,j,kUp)
     &     - 5. _d 0*(-alpmn*alf1*sm_z(i,j,k) + alfp*alp1*fp_z(i,j,kDw)
     &                                        - alfn*aln1*fn_z(i,j,kUp)
     &               + twoRL*alfp*alfn*sm_o(i,j,k) + (alp1-alfp)*locTp
     &                                             + (aln1-alfn)*locTn
     &               )
        sm_xz(i,j,k) = alf1*sm_xz(i,j,k) + alfp*fp_xz(i,j,kDw)
     &                                   + alfn*fn_xz(i,j,kUp)
     &       + three*( alpmn*sm_x(i,j,k) - alp1*fp_x(i,j,kDw)
     &                                   + aln1*fn_x(i,j,kUp)
     &               )
        sm_yz(i,j,k) = alf1*sm_yz(i,j,k) + alfp*fp_yz(i,j,kDw)
     &                                   + alfn*fn_yz(i,j,kUp)
     &       + three*( alpmn*sm_y(i,j,k) - alp1*fp_y(i,j,kDw)
     &                                   + aln1*fn_y(i,j,kUp)
     &               )
        sm_z (i,j,k) = alf1*sm_z(i,j,k) + alfp*fp_z(i,j,kDw)
     &                                  + alfn*fn_z(i,j,kUp)
     &               + three*( locTp - locTn )
        sm_o (i,j,k) = sm_o (i,j,k) + fp_o (i,j,kDw) + fn_o (i,j,kUp)
        sm_x (i,j,k) = sm_x (i,j,k) + fp_x (i,j,kDw) + fn_x (i,j,kUp)
        sm_xx(i,j,k) = sm_xx(i,j,k) + fp_xx(i,j,kDw) + fn_xx(i,j,kUp)
        sm_y (i,j,k) = sm_y (i,j,k) + fp_y (i,j,kDw) + fn_y (i,j,kUp)
        sm_yy(i,j,k) = sm_yy(i,j,k) + fp_yy(i,j,kDw) + fn_yy(i,j,kUp)
        sm_xy(i,j,k) = sm_xy(i,j,k) + fp_xy(i,j,kDw) + fn_xy(i,j,kUp)
#ifdef ALLOW_OBCS
        ENDIF
#endif /* ALLOW_OBCS */
       ENDDO
      ENDDO
#endif /* GAD_ALLOW_TS_SOM_ADV or PTRACERS_ALLOW_DYN_STATE */

      RETURN
      END

#include "FIZHI_OPTIONS.h"
       subroutine update_ocean_exports (myTime, myIter, myThid)
c----------------------------------------------------------------------
c  Subroutine update_ocean_exports - 'Wrapper' routine to update
c        the fields related to the ocean surface that are needed
c        by fizhi (sst and sea ice extent).
c
c Call:  getsst  (Return the current sst field-read dataset if needed)
c        getsice (Return the current sea ice field-read data if needed)
c-----------------------------------------------------------------------
       implicit none
#include "SIZE.h"
#include "GRID.h"
#include "fizhi_ocean_coms.h"
#include "EEPARAMS.h"
#include "chronos.h"

       integer myIter, myThid
       _RL myTime

       integer i, j, bi, bj, biglobal, bjglobal
       integer im1, im2, jm1, jm2, idim1, idim2, jdim1, jdim2
       integer nSxglobal, nSyglobal
       _RL        sstmin 
       parameter ( sstmin = 273.16 )

       idim1 = 1-OLx
       idim2 = sNx+OLx
       jdim1 = 1-OLy
       jdim2 = sNy+OLy
       im1 = 1
       im2 = sNx
       jm1 = 1
       jm2 = sNy
       nSxglobal = nSx*nPx
       nSyglobal = nSy*nPy

C***********************************************************************

       DO BJ = myByLo(myThid),myByHi(myThid)
       DO BI = myBxLo(myThid),myBxHi(myThid)

       biglobal=bi+(myXGlobalLo-1)/im2
       bjglobal=bj+(myYGlobalLo-1)/jm2

       call getsst(ksst,idim1,idim2,jdim1,jdim2,im1,im2,jm1,jm2,nSx,
     .  nSy,nSxglobal,nSyglobal,bi,bj,biglobal,bjglobal,nymd,nhms,sst)
       call getsice(kice,idim1,idim2,jdim1,jdim2,im1,im2,jm1,jm2,nSx,
     .  nSy,nSxglobal,nSyglobal,bi,bj,biglobal,bjglobal,nymd,nhms,sice)

c Check for Minimum Open-Water SST
c --------------------------------
       do j=jm1,jm2
       do i=im1,im2
       if(sice(i,j,bi,bj).eq.0.0 .and. sst(i,j,bi,bj).lt.sstmin)
     .                                          sst(i,j,bi,bj) = sstmin
       enddo
       enddo

       ENDDO
       ENDDO

       return
       end

       subroutine getsice(iunit,idim1,idim2,jdim1,jdim2,im1,im2,jm1,jm2,
     .     nSumx,nSumy,nPgx,nPgy,bi,bj,biglobal,bjglobal,nymd,nhms,sice)
C************************************************************************
C
C!ROUTINE:	GETSICE
C!DESCRIPTION:	GETSICE returns the sea ice depth.
C!		This routine is adaptable for any frequency
C!		data upto a daily frequency.  
C!		note: for diurnal data ndmax should be increased.
C
C!INPUT PARAMETERS:
C!	iunit     Unit number assigned to the sice data file
C!      idim1     Start dimension in x-direction
C!      idim2     End dimension in x-direction
C!      jdim1     Start dimension in y-direction
C!      jdim2     End dimension in y-direction
C!      im1       Begin of x-direction span for filling sice
C!      im2       End of x-direction span for filling sice
C!      jm1       Begin of y-direction span for filling sice
C!      jm2       End of y-direction span for filling sice
C!      nSumx     Number of processors in x-direction (local processor)
C!      nSumy     Number of processors in y-direction (local processor)
C!      nPgx      Number of processors in x-direction (global)
C!      nPgx      Number of processors in y-direction (global)
C!      bi        Processor number in x-direction (local to processor)
C!      bj        Processor number in y-direction (local to processor)
C!      biglobal  Processor number in x-direction (global)
C!      bjglobal  Processor number in y-direction (global)
C!	nymd	  YYMMDD of the current model timestep
C!	nhms	  HHMMSS of the model time
C
C!OUTPUT PARAMETERS:
C!	sice(idim1:idim2,jdim1:jdim2,nSumx,nSumy) Sea ice depth in meters
C
C!ROUTINES CALLED:
C
C!	bcdata	     Reads the data for a given unit number
C!	bcheader     Reads the header info for a given unit number
C!      interp_time  Returns weights for linear interpolation
C
C--------------------------------------------------------------------------

      implicit none
#include "SIZE.h"

      integer iunit,idim1,idim2,jdim1,jdim2,im1,im2,jm1,jm2,nSumx,nSumy
      integer nPgx,nPgy,bi,bj,biglobal,bjglobal,nymd,nhms

      _RL sice(idim1:idim2,jdim1:jdim2,nSumx,nSumy)

      integer i,j

      do j = jm1,jm2
      do i = im1,im2
       sice(i,j,bi,bj) = 0.
      enddo
      enddo

      return
      end
      subroutine getsst(iunit,idim1,idim2,jdim1,jdim2,im1,im2,jm1,jm2,
     .      nSumx,nSumy,nPgx,nPgy,bi,bj,biglobal,bjglobal,nymd,nhms,sst)
C************************************************************************
C
C!ROUTINE:	GETSST
C!DESCRIPTION:	GETSST gets the SST data.
C!		This routine is adaptable for any frequency
C!		data upto a daily frequency.  
C!		note: for diurnal data ndmax should be increased.
C
C!INPUT PARAMETERS:
C!	iunit     Unit number assigned to the sice data file
C!      idim1     Start dimension in x-direction
C!      idim2     End dimension in x-direction
C!      jdim1     Start dimension in y-direction
C!      jdim2     End dimension in y-direction
C!      im1       Begin of x-direction span for filling sice
C!      im2       End of x-direction span for filling sice
C!      jm1       Begin of y-direction span for filling sice
C!      jm2       End of y-direction span for filling sice
C!      nSumx     Number of processors in x-direction (local processor)
C!      nSumy     Number of processors in y-direction (local processor)
C!      nPgx      Number of processors in x-direction (global)
C!      nPgy      Number of processors in y-direction (global)
C!      bi        Processor number in x-direction (local to processor)
C!      bj        Processor number in y-direction (local to processor)
C!      biglobal  Processor number in x-direction (global)
C!      bjglobal  Processor number in y-direction (global)
C!	nymd	  YYMMDD of the current model timestep
C!	nhms	  HHMMSS of the model time
C
C!OUTPUT PARAMETERS:
C!	sst(idim1:idim2,jdim1:jdim2,nSumx,nSumy) Sea surface temperature (K)
C
C!ROUTINES CALLED:
C
C!	bcdata		Reads the data for a given unit number
C!	bcheader	Reads the header info for a given unit number
C!     interp_time   Returns weights for linear interpolation
C
C--------------------------------------------------------------------------

      implicit none
#include "SIZE.h"

      integer iunit,idim1,idim2,jdim1,jdim2,im1,im2,jm1,jm2,nSumx,nSumy
      integer nPgx,nPgy,bi,bj,biglobal,bjglobal,nymd,nhms

      _RL sst(idim1:idim2,jdim1:jdim2,nSumx,nSumy)

      integer i,j

      do j = jm1,jm2
      do i = im1,im2
       sst(i,j,bi,bj) = 280.
      enddo
      enddo
 
      return
      end

#include "CPP_EEOPTIONS.h"

CBOP
C     !ROUTINE: MASTER_CPU_IO

C     !INTERFACE:
      LOGICAL FUNCTION MASTER_CPU_IO( myThid )

C     !DESCRIPTION:
C     return TRUE if master thread (case not using SingleCpuIO) and
C                 if master CPU & master thread (case using SingleCpuIO)

C     !USES:
      IMPLICIT NONE

C Global variables
#include "SIZE.h"
#include "EEPARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
C   myThid        :: my Thread Id number
C   MASTER_CPU_IO :: true if master thread
C                    and, if using SingleCpuIO, if master CPU
      INTEGER myThid
CEOP

C     !LOCAL VARIABLES:

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      MASTER_CPU_IO = .FALSE.

      IF ( .NOT.useSingleCPUIO .OR. myProcId.EQ.0 ) THEN
        _BEGIN_MASTER( myThid )
        MASTER_CPU_IO = .TRUE.
        _END_MASTER( myThid )
      ENDIF

      RETURN
      END

#include "KL10_OPTIONS.h"

CBOP
C !ROUTINE: KL10_READPARMS

C !INTERFACE: ==========================================================
      SUBROUTINE KL10_READPARMS( myThid )

C !DESCRIPTION:
C     Initialize KL10 parameters, read in data.kl10

C !USES: ===============================================================
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "KL10.h"
#include "PARAMS.h"

C !INPUT PARAMETERS: ===================================================
C  myThid               :: thread number
      INTEGER myThid

C !OUTPUT PARAMETERS: ==================================================
C  none

#ifdef ALLOW_KL10

C !LOCAL VARIABLES: ====================================================
C  iUnit                :: unit number for I/O
C  msgBuf               :: message buffer
      INTEGER iUnit
      CHARACTER*(MAX_LEN_MBUF) msgBuf
C--   retired parameters:
      _RL KLtaveFreq
CEOP

      NAMELIST /KL10_PARM01/
     &     KLviscMax,
     &     KLdumpFreq,
     &     KLwriteState,
     &     KLtaveFreq

      IF ( .NOT.useKL10 ) THEN
C-    pkg KL10 is not used
        _BEGIN_MASTER(myThid)
C-    Track pkg activation status:
         KL10isON = .FALSE.
C     print a (weak) warning if data.kl10 is found
         CALL PACKAGES_UNUSED_MSG( 'useKL10', ' ', ' ' )
        _END_MASTER(myThid)
        RETURN
      ENDIF

      _BEGIN_MASTER(myThid)

C This routine has been called by the main model so we set our
C internal flag to indicate we are in business
      KL10isON = .TRUE.

C Set defaults values for parameters in KL10.h
      KLviscMax    = 300. _d 0
      KLdumpFreq   = dumpFreq
      KLwriteState = .FALSE.
      KLtaveFreq   = UNSET_RL

C Open and read the data.kl10 file
      WRITE(msgBuf,'(A)') ' KL10_READPARMS: opening data.kl10'
      CALL PRINT_MESSAGE(msgBuf, standardMessageUnit,
     &                   SQUEEZE_RIGHT , 1)
      CALL OPEN_COPY_DATA_FILE(
     I                   'data.kl10', 'KL10_READPARMS',
     O                   iUnit,
     I                   myThid )
      READ(UNIT=iUnit,NML=KL10_PARM01)
      WRITE(msgBuf,'(A)')
     &  ' KL10_READPARMS: finished reading data.kl10'
      CALL PRINT_MESSAGE(msgBuf, standardMessageUnit,
     &                   SQUEEZE_RIGHT , 1)

C Close the open data file
#ifdef SINGLE_DISK_IO
      CLOSE(iUnit)
#else
      CLOSE(iUnit,STATUS='DELETE')
#endif /* SINGLE_DISK_IO */

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C--   Check for retired parameters:
      IF ( KLtaveFreq .NE. UNSET_RL ) THEN
        WRITE(msgBuf,'(2A)') 'KL10_READPARMS: "KLtaveFreq"',
     &    ' is no longer allowed in file "data.kl10"'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(2A)') 'KL10_READPARMS: ',
     &    ' since "pkg/timeave" has been removed.'
        CALL PRINT_ERROR( msgBuf, myThid )
c       errCount = errCount + 1
        STOP 'ABNORMAL END: S/R KL10_READPARMS'
      ENDIF

C Now set-up any remaining parameters that result from the input parameters
      IF ( KLviscMax .LE. 0. ) THEN
        WRITE(msgBuf,'(A)') 'KLviscMax must be greater than zero'
        CALL PRINT_ERROR( msgBuf , 1)
        STOP 'ABNORMAL END: S/R KL10_READPARMS'
      ENDIF

      _END_MASTER(myThid)

C Everyone else must wait for the parameters to be loaded
      _BARRIER
#endif /* ALLOW_KL10 */

      RETURN
      END

#include "RBCS_OPTIONS.h"

C !INTERFACE: ==========================================================
      SUBROUTINE RBCS_INIT_FIXED( myThid )

C !DESCRIPTION:
C calls subroutines that initializes fixed variables for relaxed
c boundary conditions

C !USES: ===============================================================
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#ifdef ALLOW_PTRACERS
# include "PTRACERS_SIZE.h"
# include "PTRACERS_PARAMS.h"
#endif
#include "RBCS_SIZE.h"
#include "RBCS_PARAMS.h"
#include "RBCS_FIELDS.h"

C !INPUT PARAMETERS: ===================================================
C  myThid               :: my Thread Id number
      INTEGER myThid
CEOP

#ifdef ALLOW_RBCS
C     !FUNCTIONS:
      INTEGER  ILNBLNK
      EXTERNAL ILNBLNK

C     !LOCAL VARIABLES:
C     i,j,k,bi,bj,irbc  :: loop indices
C     msgBuf      :: Informational/error message buffer
      INTEGER i,j,k,bi,bj
      INTEGER irbc, iLen
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      CHARACTER*(12) filName
#ifdef ALLOW_PTRACERS
      INTEGER iTr
#endif

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C     Report RBCS mask setting

      _BEGIN_MASTER(myThid)

      WRITE(msgBuf,'(2A)') ' '
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(2A)') ' ---  RBCS_INIT_FIXED:',
     &                     ' setting RBCS mask  ---'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )

      IF ( useRBCtemp ) THEN
        irbc = MIN(maskLEN,1)
        IF ( relaxMaskTrFile(irbc).EQ.' ' ) THEN
         WRITE(msgBuf,'(2A,I3,2A)') '** WARNING ** RBCS_INIT_FIXED:',
     &     ' relaxMaskFile(irbc=', irbc, ') unset ==> No relaxation',
     &     ' for Temp'
         CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                       SQUEEZE_RIGHT, myThid )
         WRITE(msgBuf,'(2A,I3,2A)') 'Warning:',
     &     ' relaxMaskFile(irbc=', irbc, ') unset ==> No relaxation',
     &     ' for Temp'
         CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                       SQUEEZE_RIGHT, myThid )
        ELSE
         iLen = ILNBLNK(relaxMaskTrFile(irbc))
         WRITE(msgBuf,'(A,I3,3A)') 'Use relaxMaskFile(irbc=', irbc,
     &     ') = "', relaxMaskTrFile(irbc)(1:iLen), '"'
         CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                       SQUEEZE_RIGHT, myThid )
         WRITE(msgBuf,'(A,1PE21.13)')
     &     ' for Temp  relaxation with tauRelaxT =', tauRelaxT
         CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                       SQUEEZE_RIGHT, myThid )
        ENDIF
      ENDIF
      IF ( useRBCsalt ) THEN
        irbc = MIN(maskLEN,2)
        IF ( relaxMaskTrFile(irbc).EQ.' ' ) THEN
         WRITE(msgBuf,'(2A,I3,2A)') '** WARNING ** RBCS_INIT_FIXED:',
     &     ' relaxMaskFile(irbc=', irbc, ') unset ==> No relaxation',
     &     ' for Salt'
         CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                       SQUEEZE_RIGHT, myThid )
         WRITE(msgBuf,'(2A,I3,2A)') 'Warning:',
     &     ' relaxMaskFile(irbc=', irbc, ') unset ==> No relaxation',
     &     ' for Salt'
         CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                       SQUEEZE_RIGHT, myThid )
        ELSE
         iLen = ILNBLNK(relaxMaskTrFile(irbc))
         WRITE(msgBuf,'(A,I3,3A)') 'Use relaxMaskFile(irbc=', irbc,
     &     ') = "', relaxMaskTrFile(irbc)(1:iLen), '"'
         CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                       SQUEEZE_RIGHT, myThid )
         WRITE(msgBuf,'(A,1PE21.13)')
     &     ' for Salt  relaxation with tauRelaxS =', tauRelaxS
         CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                       SQUEEZE_RIGHT, myThid )
        ENDIF
      ENDIF
      IF ( useRBCuVel ) THEN
        IF ( relaxMaskUFile.EQ. ' ' ) THEN
         WRITE(msgBuf,'(2A)') '** WARNING ** RBCS_INIT_FIXED:',
     &     ' relaxMaskUFile unset ==> use Temp mask instead'
         CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                       SQUEEZE_RIGHT, myThid )
         WRITE(msgBuf,'(2A)') 'Warning:',
     &     ' relaxMaskUFile unset ==> use Temp mask instead'
         CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                       SQUEEZE_RIGHT, myThid )
        ELSE
         iLen = ILNBLNK(relaxMaskUFile)
         WRITE(msgBuf,'(A,3A)') 'Use relaxMaskUFile',
     &     ' = "', relaxMaskUFile(1:iLen), '"'
         CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                       SQUEEZE_RIGHT, myThid )
        ENDIF
         WRITE(msgBuf,'(A,1PE21.13)')
     &     ' for U-Vel relaxation with tauRelaxU =', tauRelaxU
         CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                       SQUEEZE_RIGHT, myThid )
      ENDIF
      IF ( useRBCvVel ) THEN
        IF ( relaxMaskVFile.EQ. ' ' ) THEN
         WRITE(msgBuf,'(2A)') '** WARNING ** RBCS_INIT_FIXED:',
     &     ' relaxMaskVFile unset ==> use Temp mask instead'
         CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                       SQUEEZE_RIGHT, myThid )
         WRITE(msgBuf,'(2A)') 'Warning:',
     &     ' relaxMaskVFile unset ==> use Temp mask instead'
         CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                       SQUEEZE_RIGHT, myThid )
        ELSE
         iLen = ILNBLNK(relaxMaskVFile)
         WRITE(msgBuf,'(A,3A)') 'Use relaxMaskVFile',
     &     ' = "', relaxMaskVFile(1:iLen), '"'
         CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                       SQUEEZE_RIGHT, myThid )
        ENDIF
         WRITE(msgBuf,'(A,1PE21.13)')
     &     ' for V-Vel relaxation with tauRelaxV =', tauRelaxV
         CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                       SQUEEZE_RIGHT, myThid )
      ENDIF
#ifdef ALLOW_PTRACERS
      IF ( usePTRACERS .AND. PTRACERS_numInUse.GE.1 ) THEN
       DO iTr=1,PTRACERS_numInUse
        IF ( useRBCpTrNum(iTr) ) THEN
         irbc = MIN(maskLEN,2+iTr)
         IF ( relaxMaskTrFile(irbc).EQ.' ' ) THEN
          WRITE(msgBuf,'(2A,I3,2A,I3)')
     &     '** WARNING ** RBCS_INIT_FIXED:',
     &     ' relaxMaskFile(irbc=', irbc, ') unset ==> No relaxation',
     &     ' for pTr=', iTr
          CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                        SQUEEZE_RIGHT, myThid )
          WRITE(msgBuf,'(2A,I3,2A,I3)') 'Warning:',
     &     ' relaxMaskFile(irbc=', irbc, ') unset ==> No relaxation',
     &     ' for pTr=', iTr
          CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                        SQUEEZE_RIGHT, myThid )
         ELSE
          iLen = ILNBLNK(relaxMaskTrFile(irbc))
          WRITE(msgBuf,'(A,I3,3A)') 'Use relaxMaskFile(irbc=', irbc,
     &     ') = "', relaxMaskTrFile(irbc)(1:iLen), '"'
          CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                        SQUEEZE_RIGHT, myThid )
          WRITE(msgBuf,'(A,I3,A,1PE21.13)')
     &     ' for pTr=', iTr, ' relaxation, tauRelaxPTR =',
     &                          tauRelaxPTR(iTr)
          CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                        SQUEEZE_RIGHT, myThid )
         ENDIF
        ENDIF
       ENDDO
      ENDIF
#endif /* ALLOW_PTRACERS */

      _END_MASTER(myThid)

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#ifndef DISABLE_RBCS_MOM
C     Loop over tiles
      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
         DO k=1,Nr
          DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
             RBC_maskU(i,j,k,bi,bj) = 0. _d 0
             RBC_maskV(i,j,k,bi,bj) = 0. _d 0
           ENDDO
          ENDDO
         ENDDO
       ENDDO
      ENDDO
#endif /* DISABLE_RBCS_MOM */

C     Loop over mask index
      DO irbc=1,maskLEN

C     Loop over tiles
        DO bj = myByLo(myThid), myByHi(myThid)
         DO bi = myBxLo(myThid), myBxHi(myThid)

C        Initialize arrays in common blocks :
           DO k=1,Nr
            DO j=1-OLy,sNy+OLy
             DO i=1-OLx,sNx+OLx
               RBC_mask(i,j,k,bi,bj,irbc) = 0. _d 0
             ENDDO
            ENDDO
           ENDDO

C        end bi,bj loops
         ENDDO
        ENDDO
C     end of mask index loop
      ENDDO

C read in mask for relaxing
      DO irbc=1,maskLEN
       IF ( relaxMaskTrFile(irbc).NE. ' ' ) THEN
         CALL READ_FLD_XYZ_RS( relaxMaskTrFile(irbc), ' ',
     &                RBC_mask(1-OLx,1-OLy,1,1,1,irbc), 0, myThid )
         CALL EXCH_XYZ_RS( RBC_mask(1-OLx,1-OLy,1,1,1,irbc), myThid )
C--   Apply mask:
         DO bj = myByLo(myThid), myByHi(myThid)
          DO bi = myBxLo(myThid), myBxHi(myThid)
           DO k=1,Nr
            DO j=1-OLy,sNy+OLy
             DO i=1-OLx,sNx+OLx
               RBC_mask(i,j,k,bi,bj,irbc) = RBC_mask(i,j,k,bi,bj,irbc)
     &                                    * maskC(i,j,k,bi,bj)
             ENDDO
            ENDDO
           ENDDO
          ENDDO
         ENDDO
         IF ( debugLevel.GE.debLevC ) THEN
           WRITE(filName,'(A,I3.3)') 'RBC_mask_',irbc
           CALL WRITE_FLD_XYZ_RS( filName,' ',
     &                RBC_mask(1-OLx,1-OLy,1,1,1,irbc), 0, myThid )
         ENDIF
       ENDIF
      ENDDO

#ifndef DISABLE_RBCS_MOM
      IF ( useRBCuVel .AND. relaxMaskUFile.NE. ' ' ) THEN
        CALL READ_FLD_XYZ_RS(relaxMaskUFile,' ',RBC_maskU, 0, myThid)
      ELSEIF( useRBCuVel ) THEN
        DO bj = myByLo(myThid), myByHi(myThid)
         DO bi = myBxLo(myThid), myBxHi(myThid)
           DO k=1,Nr
            DO j=1-OLy,sNy+OLy
             DO i=2-OLx,sNx+OLx
               RBC_maskU(i,j,k,bi,bj) =
     &                  ( RBC_mask(i-1,j,k,bi,bj,1)
     &                  + RBC_mask( i ,j,k,bi,bj,1) )*0.5 _d 0
             ENDDO
            ENDDO
           ENDDO
         ENDDO
        ENDDO
      ENDIF
      IF ( useRBCvVel .AND. relaxMaskVFile.NE. ' ' ) THEN
        CALL READ_FLD_XYZ_RS(relaxMaskVFile,' ',RBC_maskV, 0, myThid)
      ELSEIF( useRBCvVel ) THEN
        DO bj = myByLo(myThid), myByHi(myThid)
         DO bi = myBxLo(myThid), myBxHi(myThid)
           DO k=1,Nr
            DO j=2-OLy,sNy+OLy
             DO i=1-OLx,sNx+OLx
               RBC_maskV(i,j,k,bi,bj) =
     &                  ( RBC_mask(i,j-1,k,bi,bj,1)
     &                  + RBC_mask(i, j ,k,bi,bj,1) )*0.5 _d 0
             ENDDO
            ENDDO
           ENDDO
         ENDDO
        ENDDO
      ENDIF
      IF( useRBCuVel .OR. useRBCvVel ) THEN
         CALL EXCH_UV_XYZ_RS( RBC_maskU, RBC_maskV, .FALSE., myThid )
C--   Apply mask:
         DO bj = myByLo(myThid), myByHi(myThid)
          DO bi = myBxLo(myThid), myBxHi(myThid)
           DO k=1,Nr
            DO j=1-OLy,sNy+OLy
             DO i=1-OLx,sNx+OLx
               RBC_maskU(i,j,k,bi,bj) = RBC_maskU(i,j,k,bi,bj)
     &                                * maskW(i,j,k,bi,bj)
               RBC_maskV(i,j,k,bi,bj) = RBC_maskV(i,j,k,bi,bj)
     &                                * maskS(i,j,k,bi,bj)
             ENDDO
            ENDDO
           ENDDO
          ENDDO
         ENDDO
         IF ( debugLevel.GE.debLevC ) THEN
           CALL WRITE_FLD_XYZ_RS('RBC_maskU',' ',RBC_maskU,0,myThid )
           CALL WRITE_FLD_XYZ_RS('RBC_maskV',' ',RBC_maskV,0,myThid )
         ENDIF
      ENDIF
#endif /* DISABLE_RBCS_MOM */

      _BEGIN_MASTER(myThid)
      WRITE(msgBuf,'(2A)') ' ---  RBCS_INIT_FIXED:',
     &                     ' setting RBCS mask done'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      _END_MASTER(myThid)

#endif /* ALLOW_RBCS */

      RETURN
      END

#include "BULK_FORCE_OPTIONS.h"

CBOP
C     !ROUTINE: BULKF_FORCING
C     !INTERFACE:
      SUBROUTINE BULKF_FORCING(
     I                          myTime, myIter, myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE BULKF_FORCING
C     *==========================================================*
C     \ev

C     o Get the surface fluxes used to force ocean model
C       Output:
C       ------
C       ustress, vstress :: wind stress
C       qnet             :: net heat flux
C       empmr            :: freshwater flux
C       ---------
C
C       Input:
C       ------
C       uwind, vwind  :: mean wind speed (m/s)     at height hu (m)
C       Tair  :: mean air temperature (K)  at height ht (m)
C       Qair  :: mean air humidity (kg/kg) at height hq (m)
C       theta(k=1) :: sea surface temperature (K)
C       rain   :: precipitation
C       runoff :: river(ice) runoff
C
C     ==================================================================
C     SUBROUTINE bulkf_forcing
C     ==================================================================

C     !USES:
      IMPLICIT NONE
C     == global variables ==
#include "EEPARAMS.h"
#include "SIZE.h"
#include "PARAMS.h"
#include "DYNVARS.h"
#include "GRID.h"
#include "FFIELDS.h"
#include "BULKF_PARAMS.h"
#include "BULKF.h"
#include "BULKF_INT.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == routine arguments ==
      _RL     myTime
      INTEGER myIter
      INTEGER myThid
CEOP

#ifdef ALLOW_BULK_FORCE
C     == Local variables ==
      INTEGER bi,bj
      INTEGER i,j
      INTEGER ks, iceornot

      _RL     df0dT, hfl, evp, dEvdT
#ifdef ALLOW_FORMULA_AIM
      _RL     SHF(1), EVPloc(1), SLRU(1)
      _RL     dEvp(1), sFlx(0:2)
#endif

C-    surface level index:
      ks = 1
      IF ( usingPcoords ) ks = Nr

C-    Compute surface fluxes over ice-free ocean only:
      iceornot = 0

      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)

         DO j = 1-OLy,sNy+OLy
          DO i = 1-OLx,sNx+OLx
           IF ( maskC(i,j,ks,bi,bj).NE.0. _d 0 ) THEN

#ifdef ALLOW_FORMULA_AIM
             IF ( useFluxFormula_AIM ) THEN
               CALL BULKF_FORMULA_AIM(
     I            gcmSST(i,j,bi,bj), flwdwn(i,j,bi,bj),
     I            thAir(i,j,bi,bj), Tair(i,j,bi,bj),
     I            Qair(i,j,bi,bj), wspeed(i,j,bi,bj),
     O            SHF, EVPloc, SLRU,
     O            dEvp, sFlx,
     I            iceornot, myThid )

                  flwup(i,j,bi,bj)= ocean_emissivity*SLRU(1)
C-    reverse sign (AIM convention -> BULKF convention):
                  fsh(i,j,bi,bj) = -SHF(1)
                  flh(i,j,bi,bj) = -Lvap*EVPloc(1)
C-    Convert from g/m2/s to m/s
                  evap(i,j,bi,bj) = EVPloc(1) * 1. _d -3 / rhoFW
                  dEvdT = dEvp(1) * 1. _d -3
                  df0dT = sFlx(2)

             ELSEIF ( blk_nIter.EQ.0 ) THEN
#else  /* ALLOW_FORMULA_AIM */
             IF ( blk_nIter.EQ.0 ) THEN
#endif /* ALLOW_FORMULA_AIM */
               CALL BULKF_FORMULA_LANL(
     I            uwind(i,j,bi,bj),vwind(i,j,bi,bj),wspeed(i,j,bi,bj),
     I            Tair(i,j,bi,bj), Qair(i,j,bi,bj),
     I            cloud(i,j,bi,bj), gcmSST(i,j,bi,bj),
     O            flwup(i,j,bi,bj), flh(i,j,bi,bj),
     O            fsh(i,j,bi,bj), df0dT,
     O            ustress(i,j,bi,bj), vstress(i,j,bi,bj),
     O            evp, savssq(i,j,bi,bj), dEvdT,
     I            iceornot, myThid )
C               Note that the LANL flux conventions are opposite
C               of what they are in the model.

C-             Convert from kg/m2/s to m/s
               evap(i,j,bi,bj) = evp/rhoFW

             ELSE
               CALL BULKF_FORMULA_LAY(
     I            uwind(i,j,bi,bj), vwind(i,j,bi,bj),
     I            wspeed(i,j,bi,bj), Tair(i,j,bi,bj),
     I            Qair(i,j,bi,bj), gcmSST(i,j,bi,bj),
     O            flwup(i,j,bi,bj), flh(i,j,bi,bj),
     O            fsh(i,j,bi,bj), df0dT,
     O            ustress(i,j,bi,bj), vstress(i,j,bi,bj),
     O            evp, savssq(i,j,bi,bj), dEvdT,
     I            iceornot, i,j,bi,bj,myThid )

C-             Convert from kg/m2/s to m/s
               evap(i,j,bi,bj) = evp/rhoFW

             ENDIF

C- use down long wave data
             flwupnet(i,j,bi,bj)=flwup(i,j,bi,bj)-flwdwn(i,j,bi,bj)
C- using down solar, need to have water albedo -- .1
             fswnet(i,j,bi,bj) = solar(i,j,bi,bj)
     &                         *( 1. _d 0 - ocean_albedo )
           ElSE
             ustress(i,j,bi,bj) = 0. _d 0
             vstress(i,j,bi,bj) = 0. _d 0
             fsh(i,j,bi,bj)     = 0. _d 0
             flh(i,j,bi,bj)     = 0. _d 0
             flwup(i,j,bi,bj)   = 0. _d 0
             evap(i,j,bi,bj)    = 0. _d 0
             fswnet(i,j,bi,bj)  = 0. _d 0
             savssq(i,j,bi,bj)  = 0. _d 0
           ENDIF
          ENDDO
         ENDDO

         IF ( calcWindStress ) THEN
C-  move wind stresses to u and v points
           DO j = 1-OLy,sNy+OLy
            DO i = 1-OLx+1,sNx+OLx
              fu(i,j,bi,bj) = maskW(i,j,1,bi,bj)
     &          *(ustress(i,j,bi,bj)+ustress(i-1,j,bi,bj))*0.5 _d 0
            ENDDO
           ENDDO
           DO j = 1-OLy+1,sNy+OLy
            DO i = 1-OLx,sNx+OLx
              fv(i,j,bi,bj) = maskS(i,j,1,bi,bj)
     &          *(vstress(i,j,bi,bj)+vstress(i,j-1,bi,bj))*0.5 _d 0
            ENDDO
           ENDDO
         ENDIF

C-    Add all contributions.
         DO j = 1-OLy,sNy+OLy
          DO i = 1-OLx,sNx+OLx
            IF ( maskC(i,j,ks,bi,bj).NE.0. _d 0 ) THEN
C-       Net downward surface heat flux :
              hfl = 0. _d 0
              hfl = hfl + fsh(i,j,bi,bj)
              hfl = hfl + flh(i,j,bi,bj)
              hfl = hfl - flwupnet(i,j,bi,bj)
              hfl = hfl + fswnet(i,j,bi,bj)
C- Heat flux:
              Qnet(i,j,bi,bj) = -hfl
              Qsw (i,j,bi,bj) = -fswnet(i,j,bi,bj)
#ifdef COUPLE_MODEL
              dFdT(i,j,bi,bj) = df0dT
#endif
C- Fresh-water flux from Precipitation and Evaporation.
              EmPmR(i,j,bi,bj) = (evap(i,j,bi,bj)-rain(i,j,bi,bj)
     &                           - runoff(i,j,bi,bj))*rhoConstFresh
C---- cheating: now done in S/R BULKF_FLUX_ADJUST, over ice-free ocean only
c            Qnet(i,j,bi,bj) = Qnetch(i,j,bi,bj)
c            EmPmR(i,j,bi,bj) = EmPch(i,j,bi,bj)
C----
            ELSE
              Qnet(i,j,bi,bj) = 0. _d 0
              Qsw (i,j,bi,bj) = 0. _d 0
              EmPmR(i,j,bi,bj)= 0. _d 0
#ifdef COUPLE_MODEL
              dFdT(i,j,bi,bj) = 0. _d 0
#endif
            ENDIF
          ENDDO
         ENDDO

         IF ( temp_EvPrRn .NE. UNSET_RL ) THEN
C--   Account for energy content of Precip + RunOff & Evap. Assumes:
C     1) Rain has same temp as Air
C     2) Snow has no heat capacity (consistent with seaice & thsice pkgs)
C     3) No distinction between sea-water Cp and fresh-water Cp
C     4) Run-Off comes at the temp of surface water (with same Cp)
C     5) Evap is released to the Atmos @ surf-temp (=SST); should be using
C        the water-vapor heat capacity here and consistently in Bulk-Formulae;
C        Could also be put directly into Latent Heat flux.
c         IF ( SnowFile .NE. ' ' ) THEN
C--   Melt snow (if provided) into the ocean and account for rain-temp
c          DO j = 1-OLy,sNy+OLy
c           DO i = 1-OLx,sNx+OLx
c             Qnet(i,j,bi,bj) = Qnet(i,j,bi,bj)
c    &              + Lfresh*snowPrecip(i,j,bi,bj)*rhoConstFresh
c    &              - HeatCapacity_Cp
c    &               *( Tair(i,j,bi,bj) - Tf0kel - temp_EvPrRn )
c    &               *( rain(i,j,bi,bj)- snowPrecip(i,j,bi,bj) )
c    &               *rhoConstFresh
c           ENDDO
c          ENDDO
c         ELSE
C--   Make snow (according to Air Temp) and melt it in the ocean
C     note: here we just use the same criteria as over seaice but would be
C           better to consider a higher altitude air temp, e.g., 850.mb
           DO j = 1-OLy,sNy+OLy
            DO i = 1-OLx,sNx+OLx
             IF ( Tair(i,j,bi,bj).LE.Tf0kel ) THEN
               Qnet(i,j,bi,bj) = Qnet(i,j,bi,bj)
     &              + Lfresh*rain(i,j,bi,bj)*rhoConstFresh
              ELSE
C--   Account for rain-temp
               Qnet(i,j,bi,bj) = Qnet(i,j,bi,bj)
     &              - HeatCapacity_Cp
     &               *( Tair(i,j,bi,bj) - Tf0kel - temp_EvPrRn )
     &               *rain(i,j,bi,bj)*rhoConstFresh
              ENDIF
            ENDDO
           ENDDO
c         ENDIF
C--   Account for energy content of Evap and RunOff:
          DO j = 1-OLy,sNy+OLy
            DO i = 1-OLx,sNx+OLx
c             Qnet(i,j,bi,bj) = Qnet(i,j,bi,bj)
c    &              + ( theta(i,j,ks,bi,bj) - temp_EvPrRn )
c    &               *( evap(i,j,bi,bj)*cpwv
c    &                - runoff(i,j,bi,bj)*HeatCapacity_Cp
c    &                )*rhoConstFresh
              Qnet(i,j,bi,bj) = Qnet(i,j,bi,bj)
     &              + ( theta(i,j,ks,bi,bj) - temp_EvPrRn )
     &               *( evap(i,j,bi,bj) - runoff(i,j,bi,bj) )
     &               *HeatCapacity_Cp*rhoConstFresh
              Qnet(i,j,bi,bj) = Qnet(i,j,bi,bj)*maskC(i,j,ks,bi,bj)
            ENDDO
          ENDDO
         ENDIF

C--   end bi,bj loops
       ENDDO
      ENDDO

C--   Update the tile edges.
C jmc: Is it necessary ?
c     _EXCH_XY_RS(Qnet,   myThid)
c     _EXCH_XY_RS(EmPmR,   myThid)
c     CALL EXCH_UV_XY_RS(fu, fv, .TRUE., myThid)

#endif  /*ALLOW_BULK_FORCE*/

      RETURN
      END

#include "GRDCHK_OPTIONS.h"
#ifdef ALLOW_CTRL
# include "CTRL_OPTIONS.h"
#endif

      SUBROUTINE GRDCHK_READPARMS( myThid )

C     ==================================================================
C     SUBROUTINE grdchk_readparms
C     ==================================================================
C
C     o Read Gradient-check package parameters
C
C     started: Christian Eckert eckert@mit.edu 03-Mar-2000
C     continued: heimbach@mit.edu: 13-Jun-2001
C
C     ==================================================================
C     SUBROUTINE grdchk_readparms
C     ==================================================================

      IMPLICIT NONE

C     == global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"

#include "CTRL_SIZE.h"
#include "CTRL.h"
#ifdef ALLOW_OBCS_CONTROL
C     CTRL_OBCS.h must be included before GRDCHK.h
# include "CTRL_OBCS.h"
#endif
#include "GRDCHK.h"

C     == routine arguments ==
      INTEGER myThid

#ifdef ALLOW_GRDCHK
C     == local variables ==
      INTEGER iGloTile, jGloTile
      INTEGER iUnit
      CHARACTER*(MAX_LEN_MBUF) msgBuf
C     == end of interface ==

C--   Gradient-Check parameters.
      NAMELIST /grdchk_nml/
     &                  grdchk_eps,
     &                  nbeg,
     &                  nstep,
     &                  nend,
     &                  grdchkvarname,
     &                  grdchkvarindex,
     &                  useCentralDiff,
     &                  grdchkwhichproc,
     &                  iGloPos,
     &                  jGloPos,
     &                  kGloPos,
     &                  iGloTile,
     &                  jGloTile,
     &                  idep,
     &                  jdep,
     &                  obcsglo,
     &                  recglo

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      IF ( .NOT.useGrdChk ) THEN
C-    pkg GRDCHK is not used
        _BEGIN_MASTER(myThid)
C-    Track pkg activation status:
C     print a (weak) warning if data.grdchk is found
         CALL PACKAGES_UNUSED_MSG( 'useGrdChk', ' ', ' ' )
        _END_MASTER(myThid)
        RETURN
      ENDIF

      _BEGIN_MASTER( myThid )

C--     Set default values.
        grdchk_eps      = 1. _d 0
        nbeg            = 0
        nend            = 0
        nstep           = 0
        useCentralDiff  = .TRUE.
        grdchkwhichproc = -1
        iGloPos         = 0
        jGloPos         = 0
        kGloPos         = 1
        iGloTile        = 1
        jGloTile        = 1
        idep            = 1
        jdep            = 1
        obcsglo         = 1
        recglo          = 1
        grdchkvarname   = ' '
        grdchkvarindex  = UNSET_I

C       Next, read the GRDCHK parameter file.
        WRITE(msgBuf,'(A)') 'GRDCHK_READPARMS: opening data.grdchk'
        CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )

        CALL OPEN_COPY_DATA_FILE(
     I                          'data.grdchk', 'GRDCHK_READPARMS',
     O                          iUnit,
     I                          myThid )

        READ(unit = iUnit, nml = grdchk_nml)

        WRITE(msgBuf,'(A)')
     &     'GRDCHK_READPARMS: finished reading data.grdchk'
        CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                SQUEEZE_RIGHT , 1)

#ifdef SINGLE_DISK_IO
        CLOSE(iUnit)
#else
        CLOSE(iUnit,STATUS='DELETE')
#endif /* SINGLE_DISK_IO */

        IF ( iGloPos .GT. sNx .OR. jGloPos .GT. sNy ) THEN
           WRITE(msgBuf,'(A)') 'i/j GloPos must be <= sNx/y'
           CALL PRINT_ERROR( msgBuf, myThid )
           STOP 'ABNORMAL END: S/R GRDCHK_READPARMS'
        ENDIF
        IF ( iGloTile .GT. nSx*nPx .OR. jGloTile .GT. nSy*nPy ) THEN
           WRITE(msgBuf,'(A)') 'i/j GloTile must be <= nSx*nPx/y'
           CALL PRINT_ERROR( msgBuf, myThid )
           STOP 'ABNORMAL END: S/R GRDCHK_READPARMS'
        ENDIF
        IF ( grdchkwhichproc .NE. -1 ) THEN
           WRITE(msgBuf,'(2A)') 'S/R GRDCHK_READPARMS: ',
     &         'grdchkwhichproc no longer allowed in namelist'
           CALL PRINT_ERROR( msgBuf, myThid )
           STOP 'ABNORMAL END: S/R GRDCHK_READPARMS'
        ENDIF

C--    From Tile Global-Indices, set Tile Local-Indices and proc. number
        iLocTile = iGloTile - (myXGlobalLo-1)/sNx
        jLocTile = jGloTile - (myYGlobalLo-1)/sNy
        IF ( iLocTile.GE.1 .AND. iLocTile.LE.nSx .AND.
     &       jLocTile.GE.1 .AND. jLocTile.LE.nSy ) THEN
          grdchkwhichproc = myProcId
        ENDIF

      _END_MASTER( myThid )
      _BARRIER

#endif /* ALLOW_GRDCHK */

      RETURN
      END

#include "BULK_FORCE_OPTIONS.h"

C     !ROUTINE: BULKF_FIELDS_LOAD
C     !INTERFACE:
      SUBROUTINE BULKF_FIELDS_LOAD( myTime, myIter, myThid )

C     !DESCRIPTION:
C     *==========================================================*
C     | SUBROUTINE BULKF_FIELDS_LOAD
C     | o Control reading of fields from external source.
C     *==========================================================*
C     | Bulk formula External source field loading routine.
C     | This routine is called every time we want to
C     | load a a set of external fields. The routine decides
C     | which fields to load and then reads them in.
C     | This routine needs to be customised for particular
C     | experiments.
C     | Notes
C     | =====
C     | Two-dimensional and three-dimensional I/O are handled in
C     | the following way under MITgcmUV. A master thread
C     | performs I/O using system calls. This threads reads data
C     | into a temporary buffer. At present the buffer is loaded
C     | with the entire model domain. This is probably OK for now
C     | Each thread then copies data from the buffer to the
C     | region of the proper array it is responsible for.
C     | =====
C     | Conversion of flux fields are described in FFIELDS.h
C     *==========================================================*

C     !USES:
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "BULKF_PARAMS.h"
#include "BULKF.h"

C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
C     myTime :: Simulation time
C     myIter :: Simulation timestep number
C     myThid :: Thread no. that called this routine.
      _RL     myTime
      INTEGER myIter
      INTEGER myThid

#ifdef ALLOW_BULK_FORCE

C     !LOCAL VARIABLES:
C     === Local arrays in common block ===
C     bulkfRec   :: time-record currently loaded (in temp arrays *[1])
C     tair[01]   :: Temp. for air temperature
C     qair[01]   :: Temp. for air specific humidity
C     solar[01]  :: Temp. for incoming solar radition
C     flwdwn[01] :: Temp. for downward longwave flux
C     cloud[01]  :: Temp for cloud
C     wspeed[01] :: Temp. for wind speed
C     uwind[01]  :: Temp. for zonal wind speed
C     vwind[01]  :: Temp. for meridional wind speed
C     rain[01]   :: Temp. for rain
C     runoff[01] :: Temp. for runoff
C     snow[01]   :: Temp  for snow
C     thAir[01]  :: Temp for Air potential temp. in the BL [K]
c     qnetch[01] :: Temp for qnet (cheating)
C     empch[01]  :: Temp for empmr (cheating)
C     [01]       :: End points for interpolation

      COMMON /BULKF_FIELDS_LOAD_I/ bulkfRec
      COMMON /BULKF_FIELDS_LOAD_RS/
     &                 tair0, tair1, qair0, qair1,
     &                 solar0, solar1, flwdwn0, flwdwn1,
     &                 cloud0, cloud1, wspeed0, wspeed1,
     &                 uwind0, uwind1, vwind0, vwind1,
     &                 rain0, rain1, runoff0, runoff1,
     &                 snow0, snow1,
#ifdef ALLOW_FORMULA_AIM
     &                 thAir0, thAir1,
#endif
     &                 qnetch0, qnetch1, empch0, empch1

      INTEGER bulkfRec(nSx,nSy)
      _RS  tair0   (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RS  tair1   (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RS  qair0   (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RS  qair1   (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RS  solar0  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RS  solar1  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RS  flwdwn0 (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RS  flwdwn1 (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RS  cloud0  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RS  cloud1  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RS  wspeed0 (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RS  wspeed1 (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RS  uwind0  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RS  uwind1  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RS  vwind0  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RS  vwind1  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RS  rain0   (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RS  rain1   (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RS  runoff0 (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RS  runoff1 (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RS  snow0   (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RS  snow1   (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
#ifdef ALLOW_FORMULA_AIM
      _RS  thAir0  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RS  thAir1  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
#endif
      _RS  qnetch0 (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RS  qnetch1 (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RS  empch0  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RS  empch1  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)

C     === Local variables ===
C     aWght, bWght :: Interpolation weights
      _RL  aWght,bWght
      INTEGER intimeP, intime0, intime1
      INTEGER bi, bj, i, j
CEOP

      IF ( periodicExternalForcing ) THEN

C First call requires that we initialize everything to zero for safety
      IF ( myIter .EQ. nIter0 ) THEN
        DO bj=myByLo(myThid),myByHi(myThid)
         DO bi=myBxLo(myThid),myBxHi(myThid)
           bulkfRec(bi,bj) = 0
           DO j = 1-Oly,sNy+Oly
            DO i = 1-Olx,sNx+Olx
              tair0(i,j,bi,bj)   = 0. _d 0
              tair1(i,j,bi,bj)   = 0. _d 0
              qair0(i,j,bi,bj)   = 0. _d 0
              qair1(i,j,bi,bj)   = 0. _d 0
              rain0(i,j,bi,bj)   = 0. _d 0
              rain1(i,j,bi,bj)   = 0. _d 0
              solar0(i,j,bi,bj)  = 0. _d 0
              solar1(i,j,bi,bj)  = 0. _d 0
              flwdwn0(i,j,bi,bj) = 0. _d 0
              flwdwn1(i,j,bi,bj) = 0. _d 0
              cloud0(i,j,bi,bj)  = 0. _d 0
              cloud1(i,j,bi,bj)  = 0. _d 0
              wspeed0(i,j,bi,bj) = 0. _d 0
              wspeed1(i,j,bi,bj) = 0. _d 0
              uwind0(i,j,bi,bj)  = 0. _d 0
              uwind1(i,j,bi,bj)  = 0. _d 0
              vwind0(i,j,bi,bj)  = 0. _d 0
              vwind1(i,j,bi,bj)  = 0. _d 0
              runoff0(i,j,bi,bj) = 0. _d 0
              runoff1(i,j,bi,bj) = 0. _d 0
              snow0(i,j,bi,bj)   = 0. _d 0
              snow1(i,j,bi,bj)   = 0. _d 0
#ifdef ALLOW_FORMULA_AIM
              thAir0(i,j,bi,bj)  = 0. _d 0
              thAir1(i,j,bi,bj)  = 0. _d 0
#endif
              qnetch0(i,j,bi,bj) = 0. _d 0
              qnetch1(i,j,bi,bj) = 0. _d 0
              empch0(i,j,bi,bj)  = 0. _d 0
              empch1(i,j,bi,bj)  = 0. _d 0
            ENDDO
           ENDDO
         ENDDO
        ENDDO
      ENDIF

C--   Now calculate whether it is time to update the forcing arrays
      CALL GET_PERIODIC_INTERVAL(
     O                  intimeP, intime0, intime1, bWght, aWght,
     I                  externForcingCycle, externForcingPeriod,
     I                  deltaTclock, myTime, myThid )

      bi = myBxLo(myThid)
      bj = myByLo(myThid)
#ifdef ALLOW_DEBUG
      IF ( debugLevel.GE.debLevB ) THEN
        _BEGIN_MASTER(myThid)
        WRITE(standardMessageUnit,'(A,I10,A,4I5,A,2F14.10)')
     &   ' BULKF_FIELDS_LOAD,', myIter,
     &   ' : iP,iLd,i0,i1=', intimeP,bulkfRec(bi,bj), intime0,intime1,
     &   ' ; Wght=', bWght, aWght
        _END_MASTER(myThid)
      ENDIF
#endif /* ALLOW_DEBUG */

C-    Make no assumption on sequence of calls to BULKF_FIELDS_LOAD ;
C     This is the correct formulation (works in Adjoint run).
      IF ( intime1.NE.bulkfRec(bi,bj) ) THEN

       _BARRIER

C--   If the above condition is met then we need to read in
C     data for the period ahead and the period behind myTime.
       IF ( debugLevel.GE.debLevZero ) THEN
         _BEGIN_MASTER(myThid)
        WRITE(standardMessageUnit,'(A,I10,A,2(2I5,A))')
     &   ' BULKF_FIELDS_LOAD, it=', myIter,
     &   ' : Reading new data, i0,i1=', intime0, intime1,
     &    ' (prev=', intimeP, bulkfRec(bi,bj), ' )'
        _END_MASTER(myThid)
       ENDIF

      IF ( AirTempFile .NE. ' '  ) THEN
       CALL READ_REC_XY_RS( AirTempFile,tair0,intime0,
     &       myIter,myThid )
       CALL READ_REC_XY_RS( AirTempFile,tair1,intime1,
     &       myIter,myThid )
      ENDIF
      IF ( AirHumidityFile .NE. ' '  ) THEN
       CALL READ_REC_XY_RS( AirhumidityFile,qair0,intime0,
     &       myIter,myThid )
       CALL READ_REC_XY_RS( AirhumidityFile,qair1,intime1,
     &       myIter,myThid )
      ENDIF
      IF ( SolarFile .NE. ' '  ) THEN
       CALL READ_REC_XY_RS( SolarFile,solar0,intime0,
     &       myIter,myThid )
       CALL READ_REC_XY_RS( SolarFile,solar1,intime1,
     &       myIter,myThid )
      ENDIF
      IF ( LongwaveFile .NE. ' '  ) THEN
       CALL READ_REC_XY_RS( LongwaveFile,flwdwn0,intime0,
     &       myIter,myThid )
       CALL READ_REC_XY_RS( LongwaveFile,flwdwn1,intime1,
     &       myIter,myThid )
      ENDIF
      IF ( CloudFile .NE. ' '  ) THEN
       CALL READ_REC_XY_RS( CloudFile,cloud0,intime0,
     &       myIter,myThid )
       CALL READ_REC_XY_RS( CloudFile,cloud1,intime1,
     &       myIter,myThid )
      ENDIF

      IF ( WSpeedFile .NE. ' '  ) THEN
       CALL READ_REC_XY_RS( WSpeedFile,wspeed0,intime0,
     &       myIter,myThid )
       CALL READ_REC_XY_RS( WSpeedFile,wspeed1,intime1,
     &       myIter,myThid )
      ENDIF
      IF ( UwindFile .NE. ' '  ) THEN
       CALL READ_REC_XY_RS( UWindFile,uwind0,intime0,
     &       myIter,myThid )
       CALL READ_REC_XY_RS( UWindFile,uwind1,intime1,
     &       myIter,myThid )
      ENDIF
      IF ( VwindFile .NE. ' '  ) THEN
       CALL READ_REC_XY_RS( VWindFile,vwind0,intime0,
     &       myIter,myThid )
       CALL READ_REC_XY_RS( VWindFile,vwind1,intime1,
     &       myIter,myThid )
      ENDIF

      IF ( RainFile .NE. ' '  ) THEN
       CALL READ_REC_XY_RS( RainFile,rain0,intime0,
     &       myIter,myThid )
       CALL READ_REC_XY_RS( RainFile,rain1,intime1,
     &       myIter,myThid )
      ENDIF
      IF ( RunoffFile .NE. ' '  ) THEN
       CALL READ_REC_XY_RS( RunoffFile,runoff0,intime0,
     &       myIter,myThid )
       CALL READ_REC_XY_RS( RunoffFile,runoff1,intime1,
     &       myIter,myThid )
      ENDIF
      IF ( SnowFile .NE. ' '  ) THEN
       CALL READ_REC_XY_RS( SnowFile,snow0,intime0,
     &       myIter,myThid )
       CALL READ_REC_XY_RS( SnowFile,snow1,intime1,
     &       myIter,myThid )
      ENDIF

#ifdef ALLOW_FORMULA_AIM
      IF ( airPotTempFile .NE. ' '  ) THEN
       CALL READ_REC_XY_RS( airPotTempFile, thAir0, intime0,
     &       myIter,myThid )
       CALL READ_REC_XY_RS( airPotTempFile, thAir1, intime1,
     &       myIter,myThid )
      ENDIF
#endif

      IF ( QnetFile .NE. ' '  ) THEN
       CALL READ_REC_XY_RS( QnetFile,qnetch0,intime0,
     &       myIter,myThid )
       CALL READ_REC_XY_RS( QnetFile,qnetch1,intime1,
     &       myIter,myThid )
      ENDIF
      IF ( EmPFile .NE. ' '  ) THEN
       CALL READ_REC_XY_RS( EmpFile,empch0,intime0,
     &       myIter,myThid )
       CALL READ_REC_XY_RS( EmpFile,empch1,intime1,
     &       myIter,myThid )
c      IF ( convertEmP2rUnit.EQ.mass2rUnit ) THEN
C-     EmPmR is now (after c59h) expressed in kg/m2/s (fresh water mass flux)
        _BARRIER
        DO bj = myByLo(myThid), myByHi(myThid)
         DO bi = myBxLo(myThid), myBxHi(myThid)
          DO j=1-Oly,sNy+Oly
           DO i=1-Olx,sNx+Olx
            empch0(i,j,bi,bj) = empch0(i,j,bi,bj)*rhoConstFresh
            empch1(i,j,bi,bj) = empch1(i,j,bi,bj)*rhoConstFresh
           ENDDO
          ENDDO
         ENDDO
        ENDDO
c      ENDIF
      ENDIF

C note: no need for extra barrier here since EXCH contains threads synchronization
c      _BARRIER

       _EXCH_XY_RS(tair0 , myThid )
       _EXCH_XY_RS(tair1 , myThid )
       _EXCH_XY_RS(qair0 , myThid )
       _EXCH_XY_RS(qair1 , myThid )
       _EXCH_XY_RS(solar0, myThid )
       _EXCH_XY_RS(solar1, myThid )
       _EXCH_XY_RS(flwdwn0, myThid )
       _EXCH_XY_RS(flwdwn1, myThid )
       _EXCH_XY_RS(cloud0, myThid )
       _EXCH_XY_RS(cloud1, myThid )
       _EXCH_XY_RS(wspeed0, myThid )
       _EXCH_XY_RS(wspeed1, myThid )
c      _EXCH_XY_RS(uwind0, myThid )
c      _EXCH_XY_RS(uwind1, myThid )
c      _EXCH_XY_RS(vwind0, myThid )
c      _EXCH_XY_RS(vwind1, myThid )
       CALL EXCH_UV_AGRID_3D_RS( uwind0, vwind0, .TRUE., 1, myThid )
       CALL EXCH_UV_AGRID_3D_RS( uwind1, vwind1, .TRUE., 1, myThid )
       _EXCH_XY_RS(rain0, myThid )
       _EXCH_XY_RS(rain1, myThid )
       _EXCH_XY_RS(runoff0, myThid )
       _EXCH_XY_RS(runoff1, myThid )
       _EXCH_XY_RS(snow0 , myThid )
       _EXCH_XY_RS(snow1 , myThid )
#ifdef ALLOW_FORMULA_AIM
       IF ( useFluxFormula_AIM ) THEN
         _EXCH_XY_RS( thAir0, myThid )
         _EXCH_XY_RS( thAir1, myThid )
       ENDIF
#endif
       _EXCH_XY_RS(qnetch0, myThid )
       _EXCH_XY_RS(qnetch1, myThid )
       _EXCH_XY_RS(empch0, myThid )
       _EXCH_XY_RS(empch1, myThid )

C-    save newly loaded time-record
        DO bj = myByLo(myThid), myByHi(myThid)
         DO bi = myBxLo(myThid), myBxHi(myThid)
           bulkfRec(bi,bj) = intime1
         ENDDO
        ENDDO

C--   end if-block for loading new time-records
      ENDIF

C--   Interpolate TAIR, QAIR, RAIN, SOLAR
      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
        DO j=1-Oly,sNy+Oly
         DO i=1-Olx,sNx+Olx
Cswdblkf -- QQQQQ check if tair is K or C ------
C        -- dasilva data in C, ncep data in K ---
          TAIR(i,j,bi,bj)   = bWght*tair0(i,j,bi,bj)
     &                       +aWght*tair1(i,j,bi,bj)
c                            +273.15 _d 0
Cswdblkf -- QQQQQ set to kg.kg??? ---
C       -- dasilva data in g, ncep in kg ---
          QAIR(i,j,bi,bj)    =(bWght*qair0(i,j,bi,bj)
     &                        +aWght*qair1(i,j,bi,bj) )
          SOLAR(i,j,bi,bj)   = bWght*solar0(i,j,bi,bj)
     &                        +aWght*solar1(i,j,bi,bj)
          FLWDWN(i,j,bi,bj)  = bWght*flwdwn0(i,j,bi,bj)
     &                        +aWght*flwdwn1(i,j,bi,bj)
          CLOUD(i,j,bi,bj)   = bWght*cloud0(i,j,bi,bj)
     &                        +aWght*cloud1(i,j,bi,bj)
          WSPEED(i,j,bi,bj)  = bWght*wspeed0(i,j,bi,bj)
     &                        +aWght*wspeed1(i,j,bi,bj)
          UWIND(i,j,bi,bj)   = bWght*uwind0(i,j,bi,bj)
     &                        +aWght*uwind1(i,j,bi,bj)
          VWIND(i,j,bi,bj)   = bWght*vwind0(i,j,bi,bj)
     &                        +aWght*vwind1(i,j,bi,bj)
          RAIN(i,j,bi,bj)    = bWght*rain0(i,j,bi,bj)
     &                        +aWght*rain1(i,j,bi,bj)
          RUNOFF(i,j,bi,bj)  = bWght*runoff0(i,j,bi,bj)
     &                        +aWght*runoff1(i,j,bi,bj)
c#ifdef ALLOW_THSICE
c         SNOW(i,j,bi,bj)    = bWght*snow0(i,j,bi,bj)
c    &                        +aWght*snow1(i,j,bi,bj)
c#endif
          Qnetch(i,j,bi,bj)  = bWght*qnetch0(i,j,bi,bj)
     &                        +aWght*qnetch1(i,j,bi,bj)
          EmPch(i,j,bi,bj)   = bWght*empch0(i,j,bi,bj)
     &                        +aWght*empch1(i,j,bi,bj)
         ENDDO
        ENDDO
#ifdef ALLOW_FORMULA_AIM
        IF ( useFluxFormula_AIM ) THEN
         DO j=1-Oly,sNy+Oly
          DO i=1-Olx,sNx+Olx
            thAir(i,j,bi,bj)  = bWght*thAir0(i,j,bi,bj)
     &                        + aWght*thAir1(i,j,bi,bj)
          ENDDO
         ENDDO
        ENDIF
#endif
       ENDDO
      ENDDO

C- jmc: not needed since local fields have been exchanged.
c      _EXCH_XY_RL(tair , myThid )

C-- Diagnostics
c      IF (myThid.EQ.1 .AND. myTime.LT.62208000.) THEN
c        write(*,'(a,1p5e12.4,2i6,2e12.4)')
c     &   'time,TAIR,QAIR,RAIN,SOLAR,i0,i1,a,b = ',
c     &   myTime,
c     &   TAIR(1,sNy,1,1),QAIR(1,sNy,1,1),
c     &   RAIN(1,sNy,1,1),SOLAR(1,sNy,1,1),
c     &   intime0,intime1,aWght,bWght
c        write(*,'(a,1p4e12.4,2e12.4)')
c     &   'time,tair0,tair1,TAIR = ',
c     &   myTime,
c     &   tair0(1,sNy,1,1),tair1(1,sNy,1,1),TAIR(1,sNy,1,1),
c     &   aWght,bWght
c      ENDIF

C endif for periodicForcing
      ENDIF

#endif /*ALLOW_BULK_FORCE*/

      RETURN
      END

#include "ECCO_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C !ROUTINE: STERGLOH_OUTPUT

C !INTERFACE:
      SUBROUTINE STERGLOH_OUTPUT( myTime, myIter, myThid )

C !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE STERGLOH_OUTPUT
C     | o Ouput the global steric height change (Greatbatch correction)
C     *==========================================================*

C !USES:
      IMPLICIT NONE
C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#ifdef ALLOW_ECCO
# include "ECCO_SIZE.h"
# include "ECCO.h"
#endif

C !INPUT PARAMETERS:
C     myTime    :: my time in simulation ( s )
C     myIter    :: my Iteration number
C     myThid    :: my Thread Id number
      _RL     myTime
      INTEGER myIter
      INTEGER myThid

#ifdef ALLOW_ECCO
#ifdef ALLOW_PSBAR_STERIC

C !FUNCTIONS:
c     LOGICAL  DIFFERENT_MULTIPLE
c     EXTERNAL DIFFERENT_MULTIPLE

C--   Local variables shared by S/R within this file (stergloh_output.F)
C     IOunit_outpFile :: IO-unit of binary output file
      INTEGER IOunit_outpFile
      COMMON /STERGLOH_OUTPUT_LOCAL/ IOunit_outpFile

C !LOCAL VARIABLES:
C     fName     :: output file name
C     msgBuf    :: Informational/error message buffer
      CHARACTER*(10) suff
      CHARACTER*(MAX_LEN_FNAM) fName
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      INTEGER irecord
      INTEGER ioUnit
      _RL     tmpVar(1)
      _RS     dummyRS(1)

C-----------------------------------------------------------------
C     Save the global mean steric heigt change at every time step
C-----------------------------------------------------------------

      IF ( ecco_output_sterGloH ) THEN
        irecord = myIter - nIter0 + 1

#ifdef ALLOW_MDSIO
        IF ( rwSuffixType.EQ.0 ) THEN
          WRITE(fName,'(A,I10.10)') 'sterGloH_global.', nIter0
        ELSE
          CALL RW_GET_SUFFIX( suff, startTime, nIter0, myThid )
          WRITE(fName,'(A,A)') 'sterGloH_global.', suff
        ENDIF

        IF ( ecco_keepTSeriesOutp_open ) THEN
          IF ( myIter .EQ. nIter0 ) THEN
C-    to open new IO unit and keep it open
            ioUnit = -1
          ELSE
C-    to write to already open IO unit
            ioUnit = IOunit_outpFile
          ENDIF
C-    skip writing meta file (unless last time to write to file)
          IF ( myIter .NE. nEndIter ) irecord = -irecord
        ELSE
C-    to open new IO unit, write and close it all within same call
          ioUnit  = 0
        ENDIF

        tmpVar(1) = sterGloH
        CALL MDS_WRITEVEC_LOC(
     I             fName, precFloat64, ioUnit,
     I             'RL', 1, tmpVar, dummyRS,
     I             0, 0, irecord, myIter, myThid )

        IF ( ecco_keepTSeriesOutp_open ) THEN
C-      multi-threaded: only master-thread save IO-unit to shared variable
C                 (in common block) and close open file (after last write)
          _BEGIN_MASTER(myThid)
          IF ( myIter .EQ. nIter0 ) THEN
C-      save for next write to same file:
            IOunit_outpFile = ioUnit
          ENDIF
          IF ( myIter .EQ. nEndIter .AND. ioUnit .GT. 0 ) THEN
C-      after last write, close IO-unit:
            IF ( debugLevel.GE.debLevC ) THEN
              WRITE(msgBuf,'(A,I8,3A)')
     &          ' STERGLOH_OUTPUT: close ioUnit=', ioUnit,
     &          ', file: ', fName(1:26), '.data'
              CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                            SQUEEZE_RIGHT, myThid )
            ENDIF
            CLOSE( ioUnit )
          ELSEIF ( myIter .EQ. nEndIter .AND. debugMode ) THEN
            WRITE(msgBuf,'(2A,I10,A)')
     &          ' STERGLOH_OUTPUT: no file to close',
     &          ' (ioUnit=', ioUnit, ' )'
            CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                          SQUEEZE_RIGHT, myThid )
          ENDIF
          _END_MASTER(myThid)
        ENDIF

#endif /* ALLOW_MDSIO */
      ENDIF

#endif /* ALLOW_PSBAR_STERIC */
#endif /* ALLOW_ECCO */

      RETURN
      END

#include "CAL_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 0
C !ROUTINE: CAL_INIT_FIXED

C !INTERFACE:
      SUBROUTINE CAL_INIT_FIXED( myThid )

C     !DESCRIPTION:
C     Initialise CAL variables that are kept fixed during the run.

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     myThid ::  my Thread Id number
      INTEGER myThid
CEOP

C     !LOCAL VARIABLES:
C     === Local variables ===

#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_ENTER('CAL_INIT_FIXED',myThid)
#endif

C     Check consistency of the date specifications with the MITgcm
C     startTime, endTime, and nTimeSteps, then set all the calendar
C     parameters.
      CALL CAL_SET(
     I              startTime, endTime, deltaTclock,
     I              nIter0, nEndIter, nTimeSteps,
     I              myThid )

      CALL CAL_SUMMARY( myThid )

#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_LEAVE('CAL_INIT_FIXED',myThid)
#endif

      RETURN
      END

#include "PACKAGES_CONFIG.h"
#include "CPP_OPTIONS.h"
#ifdef ALLOW_OPENAD
# include "OPENAD_OPTIONS.h"
#endif
c#ifdef ALLOW_AUTODIFF
c# include "AUTODIFF_OPTIONS.h"
c#endif
#ifdef ALLOW_GENERIC_ADVDIFF
# include "GAD_OPTIONS.h"
#endif
#ifdef ALLOW_GGL90
# include "GGL90_OPTIONS.h"
#endif
#ifdef ALLOW_GMREDI
# include "GMREDI_OPTIONS.h"
#endif
#ifdef ALLOW_OBCS
# include "OBCS_OPTIONS.h"
#endif
#ifdef ALLOW_SEAICE
# include "SEAICE_OPTIONS.h"
#endif
#ifdef ALLOW_GCHEM
# include "GCHEM_OPTIONS.h"
#endif
#ifdef ALLOW_DIC
# include "DIC_OPTIONS.h"
#endif
#ifdef ALLOW_EXF
# include "EXF_OPTIONS.h"
#endif
#ifdef ALLOW_STREAMICE
# include "STREAMICE_OPTIONS.h"
#endif
#ifdef ALLOW_COST
# include "COST_OPTIONS.h"
#endif
#ifdef ALLOW_CTRL
# include "CTRL_OPTIONS.h"
#endif
c#ifdef ALLOW_ECCO
c# include "ECCO_OPTIONS.h"
c#endif
#ifdef ALLOW_TAPENADE
# ifdef ALLOW_SALT_PLUME
# include "SALT_PLUME_OPTIONS.h"
# endif
#ifdef ALLOW_ECCO
# include "ECCO_OPTIONS.h"
#endif
c# ifdef ALLOW_THSICE
c# include "THSICE_OPTIONS.h"
c# endif
#endif
#ifdef ALLOW_BLING
# include "BLING_OPTIONS.h"
#endif
CBOP
C     !ROUTINE: MAIN_DO_LOOP
C     !INTERFACE:
      SUBROUTINE MAIN_DO_LOOP( iloop, myTime, myIter, myThid )

C     !DESCRIPTION:
C     *================================================================*
C     | SUBROUTINE MAIN_DO_LOOP
C     | o Interface S/R that calls FORWARD_STEP
C     *================================================================*
C     | This S/R contains the model main "do-loop" for OpenAD built
C     | (i.e., ALLOW_OPENAD defined), with a call to FORWARD_STEP
C     | inside the loop.
C     | But without OpenAD, this S/R just calls directly FORWARD_STEP
C     | (in this case the main do-loop is done in S/R THE_MAIN_LOOP).
C     *================================================================*

C     !USES:
      IMPLICIT NONE
C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"

c**************************************
#if (defined ALLOW_OPENAD || defined ALLOW_TAPENADE)

# ifdef ALLOW_CTRL
#  include "CTRL_SIZE.h"
#  include "CTRL.h"
#  include "CTRL_DUMMY.h"
#  include "CTRL_GENARR.h"
#  include "CTRL_OBCS.h"
# endif
# ifdef ALLOW_COST
#  include "cost.h"
# endif

# ifdef ALLOW_PTRACERS
#  include "PTRACERS_SIZE.h"
#  include "PTRACERS_FIELDS.h"
#  include "PTRACERS_START.h"
# endif
# ifdef ALLOW_GCHEM
#  include "GCHEM_SIZE.h"
#  include "GCHEM_FIELDS.h"
# endif
# ifdef ALLOW_CFC
#  include "CFC.h"
# endif
# ifdef ALLOW_DIC
#  include "DIC_VARS.h"
#  include "DIC_LOAD.h"
#  include "DIC_ATMOS.h"
#  include "DIC_CTRL.h"
#  include "DIC_COST.h"
# endif
# ifdef ALLOW_OBCS
#  include "OBCS_PARAMS.h"
#  include "OBCS_FIELDS.h"
#  include "OBCS_SEAICE.h"
#  ifdef ALLOW_PTRACERS
#   include "OBCS_PTRACERS.h"
#  endif
# endif
# ifdef ALLOW_SHELFICE
#  include "SHELFICE.h"
#  include "SHELFICE_COST.h"
# endif
# ifdef ALLOW_STREAMICE
#  include "STREAMICE.h"
#  include "STREAMICE_ADV.h"
#  include "STREAMICE_BDRY.h"
#  include "STREAMICE_CG.h"
# endif

#endif /* ALLOW_OPENAD or ALLOW_TAPENADE */

#ifdef ALLOW_TAPENADE
# ifdef ALLOW_EXF
#  include "EXF_PARAM.h"
#  include "EXF_INTERP_SIZE.h"
#  include "EXF_INTERP_PARAM.h"
#  include "EXF_FIELDS.h"
# endif
# ifdef ALLOW_CD_CODE
#  include "CD_CODE_VARS.h"
# endif
# ifdef ALLOW_GMREDI
#  include "GMREDI.h"
# endif
# include "FFIELDS.h"
# include "DYNVARS.h"
# include "SURFACE.h"
# include "GRID.h"
# ifdef ALLOW_SEAICE
#  include "SEAICE_SIZE.h"
#  include "SEAICE.h"
# endif
# ifdef ALLOW_KPP
#  include "KPP.h"
c#  include "KPP_PARAMS.h"
# endif
# ifdef ALLOW_DOWN_SLOPE
#  include "DWNSLP_SIZE.h"
#  include "DWNSLP_VARS.h"
# endif
# ifdef ALLOW_THSICE
#  include "THSICE_VARS.h"
# endif
# ifdef ALLOW_SALT_PLUME
#  include "SALT_PLUME.h"
# endif
# ifdef ALLOW_ECCO
#  include "ECCO_SIZE.h"
#  include "ECCO.h"
# endif
# ifdef ALLOW_BLING
#  include "BLING_VARS.h"
#  include "BLING_LOAD.h"
# endif
#endif /* ALLOW_TAPENADE */

c**************************************

C     !INPUT/OUTPUT PARAMETERS:
C     myTime :: time counter for this thread
C     myIter :: iteration counter for this thread
C     myThid :: thread number for this instance of the routine.
      INTEGER iloop
      _RL     myTime
      INTEGER myIter
      INTEGER myThid

C     !LOCAL VARIABLES:
CEOP

#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_ENTER('MAIN_DO_LOOP',myThid)
#endif

#ifdef ALLOW_OPENAD
C     >>>>>>>>>>>>>>>>>>>>>>>>>>>   LOOP   <<<<<<<<<<<<<<<<<<<<<<<<<<<<
C     >>>>>>>>>>>>>>>>>>>>>>>>>>>  STARTS  <<<<<<<<<<<<<<<<<<<<<<<<<<<<
# ifdef ALLOW_OPENAD_DIVA
      DO iloop = 1, nTimeSteps_l2
# else
      DO iloop = 1, nTimeSteps
# endif
#endif /* ALLOW_OPENAD */

#ifdef ALLOW_DEBUG
        IF (debugMode) CALL DEBUG_CALL('FORWARD_STEP',myThid)
#endif

#ifndef ALLOW_OPENAD
# ifdef ALLOW_ATM2D
        CALL TIMER_START('FORWARD_STEP_ATM2D  [MAIN_DO_LOOP]',myThid)
        CALL FORWARD_STEP_ATM2D( iloop, myTime, myIter, myThid )
        CALL TIMER_STOP ('FORWARD_STEP_ATM2D  [MAIN_DO_LOOP]',myThid)
# else
        CALL TIMER_START('FORWARD_STEP        [MAIN_DO_LOOP]',myThid)
        CALL FORWARD_STEP( iloop, myTime, myIter, myThid )
        CALL TIMER_STOP ('FORWARD_STEP        [MAIN_DO_LOOP]',myThid)
# endif
#else /* ALLOW_OPENAD */
# ifdef ALLOW_OPENAD_DIVA
        CALL TIMER_START('INNER_DO_LOOP       [MAIN_DO_LOOP]',myThid)
        nTimeSteps_l2 = 2
        CALL INNER_DO_LOOP( iloop, myTime, myIter, myThid )
        CALL TIMER_STOP ('INNER_DO_LOOP       [MAIN_DO_LOOP]',myThid)
# else
        CALL TIMER_START('FORWARD_STEP        [MAIN_DO_LOOP]',myThid)
        nTimeSteps_l2 = 2
        CALL FORWARD_STEP( iloop, myTime, myIter, myThid )
        CALL TIMER_STOP ('FORWARD_STEP        [MAIN_DO_LOOP]',myThid)
# endif
#endif /* ALLOW_OPENAD */

#ifdef ALLOW_OPENAD
      ENDDO
C     >>>>>>>>>>>>>>>>>>>>>>>>>>>   LOOP   <<<<<<<<<<<<<<<<<<<<<<<<<<<<
C     >>>>>>>>>>>>>>>>>>>>>>>>>>>  STOPS   <<<<<<<<<<<<<<<<<<<<<<<<<<<<
#endif /* ALLOW_OPENAD */

#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_LEAVE('MAIN_DO_LOOP',myThid)
#endif

      RETURN
      END

#include "BLING_OPTIONS.h"
#ifdef ALLOW_AUTODIFF
# include "AUTODIFF_OPTIONS.h"
#endif

CBOP
      SUBROUTINE BLING_BIO(
     I           PTR_O2, PTR_FE, PTR_PO4, PTR_DOP,
     O           G_DIC, G_ALK, G_O2, G_FE,
     O           G_PO4, G_DOP,
     I           bi, bj, imin, imax, jmin, jmax,
     I           myTime, myIter, myThid)

C     =================================================================
C     | subroutine bling_bio_nitrogen
C     | o Nutrient uptake and partitioning between organic pools.
C     | - Phytoplankton biomass-specific growth rate is calculated
C     |   as a function of light, nutrient limitation, and
C     |   temperature.
C     | - A simple relationship between growth rate,
C     |   biomass, and uptake is derived by assuming that growth is
C     |   exactly balanced by losses.
C     | o Organic matter export and remineralization.
C     | - Calculate the nutrient flux to depth from bio activity
C     | - Iron source from sediments
C     | - Iron scavenging
C     =================================================================

      IMPLICIT NONE

C     === Global variables ===
C     phyto_sm     :: Small phytoplankton biomass
C     phyto_lg     :: Large phytoplankton biomass
C     phyto_diaz   :: Diazotroph phytoplankton biomass
C *** if ADVECT_PHYTO, these are fraction of total biomass instead ***

#include "SIZE.h"
#include "DYNVARS.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "BLING_VARS.h"
#include "PTRACERS_SIZE.h"
#include "PTRACERS_PARAMS.h"
#ifdef ALLOW_AUTODIFF_TAMC
# include "tamc.h"
#endif

C     === Routine arguments ===
C     bi,bj         :: tile indices
C     iMin,iMax     :: computation DOPain: 1rst index range
C     jMin,jMax     :: computation DOPain: 2nd  index range
C     myTime        :: current time
C     myIter        :: current timestep
C     myThid        :: thread Id. number
      INTEGER bi, bj, imin, imax, jmin, jmax
      _RL     myTime
      INTEGER myIter
      INTEGER myThid
C     === Input ===
C     PTR_O2        :: oxygen concentration
C     PTR_FE        :: iron concentration
C     PTR_PO4       :: phosphate concentration
C     PTR_DOP       :: dissolved organic phosphorus concentration
      _RL     PTR_O2 (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL     PTR_FE (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL     PTR_PO4(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL     PTR_DOP(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
C     === Output ===
C     G_xxx         :: tendency term for tracer xxx
      _RL     G_DIC     (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL     G_ALK     (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL     G_O2      (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL     G_FE      (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL     G_PO4     (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL     G_DOP     (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)

#ifdef ALLOW_BLING
# ifdef USE_BLING_V1
C     === Local variables ===
C     i,j,k         :: loop indices
C     Phy_lg_local  :: biomass in large phytoplankton
C     Phy_sm_local  :: biomass in small phytoplankton
C     PO4_lim       :: phosphate limitation
C     Fe_lim        :: iron limitation for phytoplankton
C     FetoP_up      :: iron to phosphorus uptake ratio
C     light_lim     :: light limitation
C     expkT         :: temperature function
C     Pc_m          :: light-saturated max photosynthesis rate for phyto
C     Pc_tot        :: carbon-specific photosynthesis rate
C     theta_Fe      :: Chl:C ratio
C     theta_Fe_inv  :: C:Chl ratio
C     theta_Fe_max  :: Fe-replete maximum Chl:C ratio
C     alpha_Fe      :: initial slope of the P-I curve
C     irrk          :: nut-limited efficiency of algal photosystems
C     irr_inst      :: instantaneous light
C     irr_eff       :: effective irradiance
C     mld           :: mixed layer depth
C     mu            :: net carbon-specific growth rate for phyt
C     biomass_sm    :: nutrient concentration in small phyto biomass
C     biomass_lg    :: nutrient concentration in large phyto biomass
C     P_uptake      :: PO4 utilization by phytoplankton
C     Fe_uptake     :: dissolved Fe utilization by phytoplankton
C     CaCO3_uptake  :: Calcium carbonate uptake for shell formation
C     CaCO3_diss    :: Calcium carbonate dissolution
C     G_CaCO3       :: tendency of calcium carbonate
C     DOP_prod      :: production of dissolved organic phosphorus
C     DOP_remin     :: remineralization of dissolved organic phosphorus
C     frac_exp      :: fraction of sinking particulate organic matter
C     P_spm         :: particulate sinking of phosphorus
C     Fe_spm        :: particulate sinking of iron
C     P_recycle     :: recycling of newly-produced organic phosphorus
C     Fe_recycle    :: recycling of newly-produced organic iron
C     P_reminp      :: remineralization of particulate organic phosphorus
C     Fe_reminsum   :: iron remineralization and adsorption
C     POC_flux      :: particulate organic carbon flux
C     NPP           :: net primary production
C     NCP           :: net community production
C     depth_l       :: depth of lower interface
C     *flux_u       :: "*" flux through upper interface
C     *flux_l       :: "*" flux through lower interface
C     *_export      :: vertically-integrated export of "*"
C     zremin        :: remineralization lengthscale for nutrients
C     zremin_caco3  :: remineralization lengthscale for CaCO3
C     wsink         :: speed of sinking particles
C     POC_sed       :: flux of particulate organic carbon to sediment
C     Fe_sed        :: sediment iron efflux
C     kFe_eq_lig    :: iron ligand stability constant
C     FreeFe        :: free (unbound) iron concentration
C     Fe_ads_inorg  :: iron adsorption
C     Fe_ads_org    :: iron adsorption  (2nd order)
C
      INTEGER i,j,k
      INTEGER bottomlayer
      _RL Phy_lg_local(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL Phy_sm_local(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL PO4_lim(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL Fe_lim(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL FetoP_up(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL light_lim(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL expkT(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL Pc_m
      _RL Pc_tot
      _RL theta_Fe(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL theta_Fe_inv(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL theta_Fe_max
      _RL alpha_Fe
      _RL irrk(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL irr_inst(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL irr_eff(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL mld(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL mu(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL biomass_sm
      _RL biomass_lg
      _RL P_uptake(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL Fe_uptake(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL CaCO3_uptake(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL CaCO3_diss(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL G_CaCO3(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL DOP_prod(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL DOP_remin(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL frac_exp
      _RL P_spm(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL Fe_spm(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL P_recycle(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL Fe_recycle(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL P_reminp(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL Fe_reminp(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL Fe_reminsum(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL POC_flux(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL NPP(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL NCP(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL depth_l
      _RL POPflux_u
      _RL POPflux_l
      _RL PFEflux_u
      _RL PFEflux_l
      _RL CaCO3flux_u
      _RL CaCO3flux_l
      _RL POP_export(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL PFE_export(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL CaCO3_export(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL zremin
      _RL zremin_caco3
      _RL wsink
      _RL POC_sed
      _RL Fe_sed(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL kFe_eq_lig
      _RL FreeFe
      _RL Fe_ads_inorg(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL Fe_ads_org(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL Fe_burial(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL po4_adj(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL fe_adj(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL o2_adj(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL dop_adj(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
#ifdef ML_MEAN_PHYTO
      _RL tmp_p_sm_ML
      _RL tmp_p_lg_ML
      _RL tmp_p_diaz_ML
      _RL tmp_ML
#endif
#ifdef ALLOW_AUTODIFF_TAMC
C     tkey :: tape key (tile dependent)
      INTEGER tkey
#endif
CEOP

#ifdef ALLOW_AUTODIFF_TAMC
      tkey = bi + (bj - 1)*nSx + (ikey_dynamics - 1)*nSx*nSy
#endif

c ---------------------------------------------------------------------
c  Initialize output and diagnostics
      DO j=jmin,jmax
       DO i=imin,imax
        mld(i,j)           = 0. _d 0
        POP_export(i,j)    = 0. _d 0
        PFE_export(i,j)    = 0. _d 0
        CaCO3_export(i,j)  = 0. _d 0
       ENDDO
      ENDDO
       DO k=1,Nr
        DO j=jmin,jmax
          DO i=imin,imax
              G_DIC(i,j,k)          = 0. _d 0
              G_ALK(i,j,k)          = 0. _d 0
              G_O2(i,j,k)           = 0. _d 0
              G_FE(i,j,k)           = 0. _d 0
              G_PO4(i,j,k)          = 0. _d 0
              G_DOP(i,j,k)          = 0. _d 0
              G_CaCO3(i,j,k)        = 0. _d 0
              Phy_lg_local(i,j,k)   = 0. _d 0
              Phy_sm_local(i,j,k)   = 0. _d 0
              PO4_lim(i,j,k)        = 0. _d 0
              Fe_lim(i,j,k)         = 0. _d 0
              FetoP_up(i,j,k)       = 0. _d 0
              light_lim(i,j,k)      = 0. _d 0
              expkT(i,j,k)          = 0. _d 0
              theta_Fe(i,j,k)       = 0. _d 0
              theta_Fe_inv(i,j,k)   = 0. _d 0
              irrk(i,j,k)           = 0. _d 0
              irr_inst(i,j,k)       = 0. _d 0
              irr_eff(i,j,k)        = 0. _d 0
              mu(i,j,k)             = 0. _d 0
              P_uptake(i,j,k)       = 0. _d 0
              Fe_uptake(i,j,k)      = 0. _d 0
              CaCO3_uptake(i,j,k)   = 0. _d 0
              CaCO3_diss(i,j,k)     = 0. _d 0
              DOP_prod(i,j,k)       = 0. _d 0
              DOP_remin(i,j,k)      = 0. _d 0
              P_spm(i,j,k)          = 0. _d 0
              Fe_spm(i,j,k)         = 0. _d 0
              P_recycle(i,j,k)      = 0. _d 0
              Fe_recycle(i,j,k)     = 0. _d 0
              P_reminp(i,j,k)       = 0. _d 0
              Fe_reminp(i,j,k)      = 0. _d 0
              Fe_reminsum(i,j,k)    = 0. _d 0
              POC_flux(i,j,k)       = 0. _d 0
              NPP(i,j,k)            = 0. _d 0
              NCP(i,j,k)            = 0. _d 0
              Fe_sed(i,j,k)         = 0. _d 0
              Fe_ads_org(i,j,k)     = 0. _d 0
              Fe_ads_inorg(i,j,k)   = 0. _d 0
          ENDDO
       ENDDO
      ENDDO

c-----------------------------------------------------------
c  avoid negative nutrient concentrations that can result from
c  advection when low concentrations

#ifdef BLING_NO_NEG
      CALL BLING_MIN_VAL(PTR_O2,  1. _d -11, o2_adj,  bi, bj)
      CALL BLING_MIN_VAL(PTR_FE,  1. _d -11, fe_adj,  bi, bj)
      CALL BLING_MIN_VAL(PTR_PO4, 1. _d -8,  po4_adj, bi, bj)
      CALL BLING_MIN_VAL(PTR_DOP, 1. _d -11, dop_adj, bi, bj)
#endif

c-----------------------------------------------------------
c  Phytoplankton size classes

       DO k=1,Nr
        DO j=jmin,jmax
         DO i=imin,imax
          Phy_lg_local(i,j,k) = phyto_lg(i,j,k,bi,bj)
          Phy_sm_local(i,j,k) = phyto_sm(i,j,k,bi,bj)
         ENDDO
        ENDDO
       ENDDO

c-----------------------------------------------------------
c  Mixed layer depth calculation for light, phytoplankton and dvm.
c  Do not need to calculate if not using ML_MEAN_LIGHT, ML_MEAN_PHYTO,
c  and USE_BLING_DVM
c  (with BLING_ADJOINT_SAFE flag, USE_BLING_DVM is undefined)

#if ( defined (ML_MEAN_LIGHT) || \
      defined (ML_MEAN_PHYTO) || \
      defined (USE_BLING_DVM) )
       CALL BLING_MIXEDLAYER(
     U                         mld,
     I                         bi, bj, imin, imax, jmin, jmax,
     I                         myTime, myIter, myThid)
#endif

c  Phytoplankton mixing
c  The mixed layer is assumed to homogenize vertical gradients of phytoplankton.
c  This allows for basic Sverdrup dynamics in a qualitative sense.
c  This has not been thoroughly tested, and care should be
c  taken with its interpretation.

#ifdef ML_MEAN_PHYTO
      DO j=jmin,jmax
       DO i=imin,imax

        tmp_p_sm_ML = 0. _d 0
        tmp_p_lg_ML = 0. _d 0
        tmp_ML  = 0. _d 0

        DO k=1,Nr

         IF (hFacC(i,j,k,bi,bj).gt.0. _d 0) THEN
         IF ((-rf(k+1) .le. mld(i,j)).and.
     &               (-rf(k+1).lt.MLmix_max)) THEN
          tmp_p_sm_ML = tmp_p_sm_ML+Phy_sm_local(i,j,k)*drF(k)
     &                  *hFacC(i,j,k,bi,bj)
          tmp_p_lg_ML = tmp_p_lg_ML+Phy_lg_local(i,j,k)*drF(k)
     &                  *hFacC(i,j,k,bi,bj)
          tmp_ML = tmp_ML + drF(k)
         ENDIF
         ENDIF

        ENDDO

        DO k=1,Nr

         IF (hFacC(i,j,k,bi,bj).gt.0. _d 0) THEN
         IF ((-rf(k+1) .le. mld(i,j)).and.
     &               (-rf(k+1).lt.MLmix_max)) THEN

          Phy_lg_local(i,j,k)   = max(1. _d -8,tmp_p_lg_ML/tmp_ML)
          Phy_sm_local(i,j,k)   = max(1. _d -8,tmp_p_sm_ML/tmp_ML)

         ENDIF
         ENDIF

        ENDDO
       ENDDO
      ENDDO

#endif

c-----------------------------------------------------------
c  light availability for biological production

       CALL BLING_LIGHT(
     I                    mld,
     U                    irr_inst, irr_eff,
     I                    bi, bj, imin, imax, jmin, jmax,
     I                    myTime, myIter, myThid )

c  phytoplankton photoadaptation to local light level
c  This represents the fact that phytoplankton cells are adapted
c  to the averaged light field to which they've been exposed over
c  their lifetimes, rather than the instantaneous light. The
c  timescale is set by gamma_irr_mem.

      DO k=1,Nr
       DO j=jmin,jmax
        DO i=imin,imax

          irr_mem(i,j,k,bi,bj) = irr_mem(i,j,k,bi,bj) +
     &           (irr_eff(i,j,k) - irr_mem(i,j,k,bi,bj))*
     &           min( 1. _d 0, gamma_irr_mem*PTRACERS_dTLev(k) )

        ENDDO
       ENDDO
      ENDDO

c ---------------------------------------------------------------------
c  Nutrient uptake and partitioning between organic pools

c  Phytoplankton are assumed to grow according to the general properties
c  described in Geider (1997). This formulation gives a biomass-specific
c  growthrate as a function of light, nutrient limitation, and
c  temperature. We modify this relationship slightly here, as described
c  below, and also use the assumption of steady state growth vs. loss to
c  derive a simple relationship between growth rate, biomass and uptake.

      DO k=1,Nr
       DO j=jmin,jmax
        DO i=imin,imax

         IF (hFacC(i,j,k,bi,bj) .gt. 0. _d 0) THEN

c ---------------------------------------------------------------------
c  First, calculate the limitation terms for PO4 and Fe, and the
c  Fe-limited Chl:C maximum. The light-saturated maximal photosynthesis
c  rate term (Pc_m) is simply the product of a prescribed maximal
c  photosynthesis rate (Pc_0), the Eppley temperature dependence, and a
c  resource limitation term. The iron limitation term has a lower limit
c  of Fe_lim_min and is scaled by (k_Fe2P + Fe2P_max) / Fe2P_max so that
c  it approaches 1 as Fe approaches infinity. Thus, it is of comparable
c  magnitude to the macro-nutrient limitation term.

c  Macro-nutrient limitation

          PO4_lim(i,j,k) = PTR_PO4(i,j,k)/(PTR_PO4(i,j,k)+k_PO4)

c  Iron to macro-nutrient uptake. More iron is utilized relative
c  to macro-nutrient under iron-replete conditions.

          FetoP_up(i,j,k) = FetoP_max*PTR_FE(i,j,k)/(k_Fe+PTR_FE(i,j,k))

c  Iron limitation

          Fe_lim(i,j,k) = Fe_lim_min + (1-Fe_lim_min)*
     &                    (FetoP_up(i,j,k)/(k_FetoP + FetoP_up(i,j,k)))*
     &                    (k_FetoP+FetoP_max)/FetoP_max

c ---------------------------------------------------------------------
c  Light-saturated maximal photosynthesis rate

c  NB: The temperature effect of Eppley (1972) is used instead of that in
c  Geider et al (1997) for both simplicity and to incorporate combined
c  effects on uptake, incorporation into organic matter and photorespiration.
c  Values of PCc_m are normalized to 0C rather than 20C in Geider et al. (1997)

          expkT(i,j,k) = exp(kappa_eppley * theta(i,j,k,bi,bj))

c  For the effective resource limitation, there is an option to replace
c  the default Liebig limitation (the minimum of Michaelis-Menton
c  PO4-limitation, or iron-limitation) by the product (safer for adjoint)

#ifdef MIN_NUT_LIM
          Pc_m = Pc_0*expkT(i,j,k)
     &           *min(PO4_lim(i,j,k), Fe_lim(i,j,k))*maskC(i,j,k,bi,bj)
#else
          Pc_m = Pc_0*expkT(i,j,k)
     &           *PO4_lim(i,j,k)*Fe_lim(i,j,k)*maskC(i,j,k,bi,bj)
#endif

c ---------------------------------------------------------------------
c  Fe limitation 1) reduces photosynthetic efficiency (alpha_Fe)
c  and 2) reduces the maximum achievable Chl:C ratio (theta_Fe)
c  below a prescribed, Fe-replete maximum value (theta_Fe_max),
c  to approach a prescribed minimum Chl:C (theta_Fe_min) under extreme
c  Fe-limitation.

          alpha_Fe = alpha_min + (alpha_max-alpha_min)*Fe_lim(i,j,k)

          theta_Fe_max = theta_Fe_max_lo+
     &                  (theta_Fe_max_hi-theta_Fe_max_lo)*Fe_lim(i,j,k)

          theta_Fe(i,j,k) = theta_Fe_max/(1. _d 0 + alpha_Fe
     &                  *theta_Fe_max*irr_mem(i,j,k,bi,bj)/
     &                  (2. _d 0*Pc_m))

c  for diagnostics: C:Chl ratio in g C / g Chl

          IF ( theta_Fe(i,j,k) .EQ.0. ) THEN
           theta_Fe_inv(i,j,k) = 0.
          ELSE
           theta_Fe_inv(i,j,k) = 1./theta_Fe(i,j,k)
          ENDIF

c ---------------------------------------------------------------------
c  Nutrient-limited efficiency of algal photosystems, irrk, is calculated
c  with the iron limitation term included as a multiplier of the
c  theta_Fe_max to represent the importance of Fe in forming chlorophyll
c  accessory antennae, which do not affect the Chl:C but still affect the
c  phytoplankton ability to use light (eg Stzrepek & Harrison, Nature 2004).

          irrk(i,j,k) = Pc_m/(epsln + alpha_Fe*theta_Fe_max) +
     &              irr_mem(i,j,k,bi,bj)/2. _d 0

          light_lim(i,j,k) = ( 1. _d 0 - exp(-irr_eff(i,j,k)
     &               /(epsln + irrk(i,j,k))))

c  Carbon-specific photosynthesis rate

          Pc_tot = Pc_m * light_lim(i,j,k)

c ---------------------------------------------------------------------
c  Account for the maintenance effort that phytoplankton must exert in
c  order to combat decay. This is prescribed as a fraction of the
c  light-saturated photosynthesis rate, resp_frac. The result of this
c  is to set a level of energy availability below which net growth
c  (and therefore nutrient uptake) is zero, given by resp_frac * Pc_m.

          mu(i,j,k) = max(0. _d 0, Pc_tot - resp_frac*Pc_m)

c ---------------------------------------------------------------------
c  In order to convert this net carbon-specific growth rate to nutrient
c  uptake rates, the quantities we are interested in, a biomass is required.
c  This is determined by the balance between growth and grazing.

c  Since there is no explicit biomass tracer, use the result of Dunne
c  et al. (GBC, 2005) to calculate an implicit biomass from the uptake
c  rate through the application of a simple idealized grazing law.

c  instantaneous nutrient concentration in phyto biomass

          biomass_lg = pivotal*(mu(i,j,k)/(lambda_0
     &                *expkT(i,j,k)))**3

          biomass_sm = pivotal*(mu(i,j,k)/(lambda_0
     &                *expkT(i,j,k)))

c  phytoplankton biomass diagnostic
c  for no lag: set gamma_biomass to 0

          phy_sm_local(i,j,k) = phy_sm_local(i,j,k) +
     &       (biomass_sm - phy_sm_local(i,j,k))
     &       *min(1., gamma_biomass*PTRACERS_dTLev(k))

          phy_lg_local(i,j,k) = phy_lg_local(i,j,k) +
     &       (biomass_lg - phy_lg_local(i,j,k))
     &       *min(1., gamma_biomass*PTRACERS_dTLev(k))

c  use the diagnostic biomass to calculate the chl concentration
c  in mg/m3 (carbon = 12.01 g/mol)

          chl(i,j,k,bi,bj) = max(chl_min, CtoP * 12.01 * 1. _d 3 *
     &           theta_Fe(i,j,k) *
     &           (Phy_lg_local(i,j,k) + Phy_sm_local(i,j,k)))

c  Nutrient uptake

          P_uptake(i,j,k) = mu(i,j,k)*(phy_sm_local(i,j,k)
     &                        + phy_lg_local(i,j,k))

c  Iron is then taken up as a function of nutrient uptake and iron
c  limitation, with a maximum Fe:P uptake ratio of Fe2p_max

          Fe_uptake(i,j,k) = P_uptake(i,j,k)*FetoP_up(i,j,k)

         ENDIF
        ENDDO
       ENDDO
      ENDDO

c  Separate loop for adjoint stores
#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE Phy_sm_local   = comlev1_bibj, key=tkey, kind=isbyte
CADJ STORE Phy_lg_local   = comlev1_bibj, key=tkey, kind=isbyte
#endif

      DO k=1,Nr
       DO j=jmin,jmax
        DO i=imin,imax

         IF (hFacC(i,j,k,bi,bj) .gt. 0. _d 0) THEN

c  update biomass
          phyto_lg(i,j,k,bi,bj) = Phy_lg_local(i,j,k)
          phyto_sm(i,j,k,bi,bj) = Phy_sm_local(i,j,k)

         ENDIF
        ENDDO
       ENDDO
      ENDDO

c ---------------------------------------------------------------------
c  Partitioning between organic pools

c  The uptake of nutrients is assumed to contribute to the growth of
c  phytoplankton, which subsequently die and are consumed by heterotrophs.
c  This can involve the transfer of nutrient elements between many
c  organic pools, both particulate and dissolved, with complex histories.
c  We take a simple approach here, partitioning the total uptake into two
c  fractions - sinking and non-sinking - as a function of temperature,
c  following Dunne et al. (2005).
c  Then, the non-sinking fraction is further subdivided, such that the
c  majority is recycled instantaneously to the inorganic nutrient pool,
c  representing the fast turnover of labile dissolved organic matter via
c  the microbial loop, and the remainder is converted to semi-labile
c  dissolved organic matter. Iron and macro-nutrient are treated
c  identically for the first step, but all iron is recycled
c  instantaneously in the second step (i.e. there is no dissolved organic
c  iron pool).

      DO k=1,Nr
       DO j=jmin,jmax
        DO i=imin,imax

         IF (hFacC(i,j,k,bi,bj) .gt. 0. _d 0) THEN

c  sinking particulate organic matter

          frac_exp = (phi_sm + phi_lg *
     &               (mu(i,j,k)/(lambda_0*expkT(i,j,k)))**2.)/
     &               (1. + (mu(i,j,k)/(lambda_0*expkT(i,j,k)))**2.)*
     &               exp(kappa_remin * theta(i,j,k,bi,bj))

          P_spm(i,j,k) = frac_exp * P_uptake(i,j,k)

          Fe_spm(i,j,k) = P_spm(i,j,k)*FetoP_up(i,j,k)

c  the remainder is divided between instantaneously recycled and
c  long-lived dissolved organic matter.
c  (recycling = P_uptake - P_spm - DOP_prod)

          DOP_prod(i,j,k) = phi_DOM*(P_uptake(i,j,k)
     &                      - P_spm(i,j,k))

          P_recycle(i,j,k) = P_uptake(i,j,k) - P_spm(i,j,k)
     &                        - DOP_prod(i,j,k)

          Fe_recycle(i,j,k) = Fe_uptake(i,j,k) - Fe_spm(i,j,k)

c  Carbon flux diagnostic

          POC_flux(i,j,k) = CtoP*P_spm(i,j,k)

c ---------------------------------------------------------------------
c  Calcium carbonate production

c  Alkalinity is consumed through the production of CaCO3. Here, this is
c  simply a linear function of the implied growth rate of small
c  phytoplankton, which gave a reasonably good fit to the global
c  observational synthesis of Dunne (2009). This is consistent
c  with the findings of Jin et al. (GBC,2006).

          CaCO3_uptake(i,j,k) = phy_sm_local(i,j,k)*phi_sm
     &           *expkT(i,j,k)*mu(i,j,k)*CatoP

         ENDIF
        ENDDO
       ENDDO
      ENDDO

c ---------------------------------------------------------------------
c  Nutrients export/remineralization, CaCO3 export/dissolution
c
c  The flux at the bottom of a grid cell equals
C  Fb = (Ft + prod*dz) / (1 + zremin*dz)
C  where Ft is the flux at the top, and prod*dz is the integrated
C  production of new sinking particles within the layer.
C  Ft = 0 in the first layer.

C$TAF LOOP = parallel
       DO j=jmin,jmax
C$TAF LOOP = parallel
        DO i=imin,imax

C  Initialize upper flux

        POPflux_u            = 0. _d 0
        PFEflux_u            = 0. _d 0
        CaCO3flux_u          = 0. _d 0

        DO k=1,Nr

C Initialization here helps taf

         Fe_ads_org(i,j,k)    = 0. _d 0

c  check if we are at a bottom cell

         bottomlayer = 1
          IF (k.LT.Nr) THEN
           IF (hFacC(i,j,k+1,bi,bj).GT.0) THEN
c  not a bottom cell
            bottomlayer = 0
           ENDIF
          ENDIF

         IF ( hFacC(i,j,k,bi,bj).gt.0. _d 0 ) THEN

C  Sinking speed is evaluated at the bottom of the cell

          depth_l=-rF(k+1)
          IF (depth_l .LE. wsink0z)  THEN
           wsink = wsink0_2d(i,j,bi,bj)
          ELSE
           wsink = wsinkacc * (depth_l - wsink0z) + wsink0_2d(i,j,bi,bj)
          ENDIF

C  Nutrient remineralization lengthscale
C  Not an e-folding scale: this term increases with remineralization.

          zremin = gamma_POM_2d(i,j,bi,bj) * ( PTR_O2(i,j,k)**2 /
     &               (k_O2**2 + PTR_O2(i,j,k)**2) * (1-remin_min)
     &               + remin_min )/(wsink + epsln)

C  Calcium remineralization relaxed toward the inverse of the
C  ca_remin_depth constant value as the calcite saturation approaches 0.

          zremin_caco3 = 1. _d 0/ca_remin_depth*(1. _d 0 - min(1. _d 0,
     &               omegaC(i,j,k,bi,bj) + epsln ))

C  POM flux leaving the cell

          POPflux_l = (POPflux_u+P_spm(i,j,k)*drF(k)
     &           *hFacC(i,j,k,bi,bj))/(1+zremin*drF(k)
     &           *hFacC(i,j,k,bi,bj))

C  CaCO3 flux leaving the cell

          CaCO3flux_l = (caco3flux_u+CaCO3_uptake(i,j,k)*drF(k)
     &           *hFacC(i,j,k,bi,bj))/(1+zremin_caco3*drF(k)
     &           *hFacC(i,j,k,bi,bj))

C  Begin iron uptake calculations by determining ligand bound and free iron.
C  Both forms are available for biology, but only free iron is scavenged
C  onto particles and forms colloids.

          kFe_eq_lig = kFe_eq_lig_max-(kFe_eq_lig_max-kFe_eq_lig_min)
     &             *(irr_inst(i,j,k)**2
     &             /(kFe_eq_lig_irr**2+irr_inst(i,j,k)**2))
     &             *max(epsln,min(1. _d 0,(PTR_FE(i,j,k)
     &             -kFe_eq_lig_Femin)/
     &             (PTR_FE(i,j,k)+epsln)*1.2 _d 0))

C  Use the quadratic equation to solve for binding between iron and ligands

          FreeFe = (-(1+kFe_eq_lig*(ligand-PTR_FE(i,j,k)))
     &            +((1+kFe_eq_lig*(ligand-PTR_FE(i,j,k)))**2+4*
     &            kFe_eq_lig*PTR_FE(i,j,k))**(0.5))/(2*
     &            kFe_eq_lig)

C  Iron scavenging does not occur in anoxic water (Fe2+ is soluble), so set
C  FreeFe = 0 when anoxic.  FreeFe should be interpreted the free iron that
C  participates in scavenging.

          IF (PTR_O2(i,j,k) .LT. oxic_min)  THEN
           FreeFe = 0. _d 0
          ENDIF

C  Two mechanisms for iron uptake, in addition to biological production:
C  colloidal scavenging and scavenging by organic matter.

           Fe_ads_inorg(i,j,k) =
     &       kFe_inorg*(max(1. _d -8,FreeFe))**(1.5)

C  Scavenging of iron by organic matter:
C  The POM value used is the bottom boundary flux. This does not occur in
C  oxic waters, but FreeFe is set to 0 in such waters earlier.

           IF ( POPflux_l .GT. 0. _d 0 ) THEN
            Fe_ads_org(i,j,k) =
     &           kFE_org*(POPflux_l/(epsln + wsink)
     &             * MasstoN*NtoP)**(0.58)*FreeFe
           ENDIF

C  If water is oxic then the iron is remineralized normally. Otherwise
C  it is completely remineralized (fe 2+ is soluble, but unstable
C  in oxidizing environments).

           IF ( PTR_O2(i,j,k) .LT. oxic_min ) THEN
            PFEflux_l = 0. _d 0
           ELSE
            PFEflux_l = (PFEflux_u+(Fe_spm(i,j,k)+Fe_ads_inorg(i,j,k)
     &            +Fe_ads_org(i,j,k))*drF(k)
     &            *hFacC(i,j,k,bi,bj))/(1+zremin*drF(k)
     &            *hFacC(i,j,k,bi,bj))
           ENDIF

C  Nutrient accumulation in a cell is given by the biological production
C  (and instant remineralization) of particulate organic matter
C  plus flux thought upper interface minus flux through lower interface.
C  If this layer is adjacent to bottom topography or it is the deepest
C  cell of the domain, then remineralize/dissolve in this grid cell
C  i.e. do not subtract off lower boundary fluxes when calculating remin

C  For the deepest cells:

          IF (bottomlayer.EQ.1) THEN

           POPflux_l   = 0. _d 0
           CACO3flux_l = 0. _d 0

C  Efflux Fed out of sediments
C  The phosphate flux hitting the bottom boundary
C  is used to scale the return of iron to the water column.
C  Maximum value added for numerical stability.

           POC_sed = POPflux_l * CtoP

           Fe_sed(i,j,k) = max(epsln, FetoC_sed * POC_sed * recip_drF(k)
     &                   * recip_hFacC(i,j,k,bi,bj))

          ELSE

           Fe_sed(i,j,k) = 0. _d 0

          ENDIF

          P_reminp(i,j,k) = (POPflux_u + P_spm(i,j,k) * drF(k)
     &                      * hFacC(i,j,k,bi,bj) - POPflux_l)
     &                      * recip_drF(k) * recip_hFacC(i,j,k,bi,bj)

          CaCO3_diss(i,j,k) = (CaCO3flux_u + CaCO3_uptake(i,j,k)
     &                      * drF(k) * hFacC(i,j,k,bi,bj) - CaCO3flux_l)
     &                      * recip_drF(k) * recip_hFacC(i,j,k,bi,bj)

          Fe_sed(i,j,k) = 0. _d 0

          Fe_reminp(i,j,k) = (PFEflux_u + (Fe_spm(i,j,k)
     &                     + Fe_ads_inorg(i,j,k) + Fe_ads_org(i,j,k))
     &                     * drF(k) * hFacC(i,j,k,bi,bj) - PFEflux_l)
     &                     * recip_drF(k) * recip_hFacC(i,j,k,bi,bj)

          Fe_reminsum(i,j,k) = Fe_reminp(i,j,k) + Fe_sed(i,j,k)
     &                       - Fe_ads_org(i,j,k) - Fe_ads_inorg(i,j,k)

C  Added the burial flux of sinking particulate iron here as a
C  diagnostic, needed to calculate mass balance of iron.
C  this is calculated last for the deepest cell

           Fe_burial(i,j) = PFEflux_l

C  Prepare the tracers for the next layer down

           POPflux_u   = POPflux_l
           PFEflux_u   = PFEflux_l
           CaCO3flux_u = CaCO3flux_l

         ENDIF

        ENDDO
       ENDDO
      ENDDO

C-----------------------------------------------------------
C  add all tendencies

       DO k=1,Nr
         DO j=jmin,jmax
          DO i=imin,imax

C  Dissolved organic matter slow remineralization

#ifdef BLING_NO_NEG
           DOP_remin(i,j,k) = MAX(maskC(i,j,k,bi,bj)*gamma_DOP
     &                    *PTR_DOP(i,j,k),0. _d 0)
#else
           DOP_remin(i,j,k) = maskC(i,j,k,bi,bj)*gamma_DOP
     &                    *PTR_DOP(i,j,k)
#endif

c  Tendencies

           G_PO4(i,j,k) = -P_uptake(i,j,k) + P_recycle(i,j,k)
     &                    + DOP_remin(i,j,k)
     &                    + (1-phi_DOM) * P_reminp(i,j,k)

           G_DOP(i,j,k) = DOP_prod(i,j,k) - DOP_remin(i,j,k)
     &                   + phi_DOM * P_reminp(i,j,k)

           if ( PTR_O2(i,j,k) .GT. oxic_min ) then
             G_O2(i,j,k) = -O2toP*G_PO4(i,j,k)
           else
             G_O2(i,j,k) = 0. _d 0
           endif

           G_FE(i,j,k) = - Fe_uptake(i,j,k) + Fe_reminsum(i,j,k)
     &                   + Fe_recycle(i,j,k)

C  Carbon system diagnostics
C  Change in DIC from primary production, from recycling and
C  remineralization, change in carbonate ions concentration
C  from biological activity:

           G_CaCO3(i,j,k) = CaCO3_diss(i,j,k) - CaCO3_uptake(i,j,k)

           NPP(i,j,k) = P_uptake(i,j,k) * CtoP

           NCP(i,j,k) = -G_PO4(i,j,k)*CtoP

           G_ALK(i,j,k) = 2. _d 0*G_CaCO3(i,j,k) - NtoP*G_PO4(i,j,k)

           G_DIC(i,j,k) = -NCP(i,j,k) + G_CaCO3(i,j,k)

c  Carbon flux diagnostic

           POC_flux(i,j,k) = CtoP * P_spm(i,j,k)

c  for diagnostics: convert to mol C/m3

           Phy_lg_local(i,j,k) = Phy_lg_local(i,j,k) * CtoP
           Phy_sm_local(i,j,k) = Phy_sm_local(i,j,k) * CtoP

c  for constraints determine POC, assuming that phytoplankton carbon
c  is 30% of POC

           poc(i,j,k,bi,bj) = (Phy_lg_local(i,j,k) +
     &                        Phy_sm_local(i,j,k)) * 3.33333 _d 0

          ENDDO
         ENDDO
       ENDDO

c ---------------------------------------------------------------------

#ifdef ALLOW_DIAGNOSTICS
      IF ( useDiagnostics ) THEN

c 3d global variables
        CALL DIAGNOSTICS_FILL(chl,    'BLGCHL  ',0,Nr,1,bi,bj,myThid)
        CALL DIAGNOSTICS_FILL(poc,    'BLGPOC  ',0,Nr,1,bi,bj,myThid)
        CALL DIAGNOSTICS_FILL(irr_mem,'BLGIMEM ',0,Nr,1,bi,bj,myThid)
c 3d local variables
        CALL DIAGNOSTICS_FILL(G_DIC   ,'BLGBIOC ',0,Nr,2,bi,bj,myThid)
        CALL DIAGNOSTICS_FILL(G_ALK   ,'BLGBIOAL',0,Nr,2,bi,bj,myThid)
        CALL DIAGNOSTICS_FILL(G_O2    ,'BLGBIOO2',0,Nr,2,bi,bj,myThid)
        CALL DIAGNOSTICS_FILL(G_Fe    ,'BLGBIOFE',0,Nr,2,bi,bj,myThid)
        CALL DIAGNOSTICS_FILL(G_PO4   ,'BLGBIOP ',0,Nr,2,bi,bj,myThid)
        CALL DIAGNOSTICS_FILL(Phy_sm_local,'BLGPSM  ',0,Nr,2,bi,bj,
     &       myThid)
        CALL DIAGNOSTICS_FILL(Phy_lg_local,'BLGPLG  ',0,Nr,2,bi,bj,
     &       myThid)
        CALL DIAGNOSTICS_FILL(irrk,    'BLGIRRK ',0,Nr,2,bi,bj,myThid)
        CALL DIAGNOSTICS_FILL(irr_eff, 'BLGIEFF ',0,Nr,2,bi,bj,myThid)
        CALL DIAGNOSTICS_FILL(theta_Fe,'BLGCHL2C',0,Nr,2,bi,bj,myThid)
        CALL DIAGNOSTICS_FILL(theta_Fe_inv,'BLGC2CHL',0,Nr,2,bi,bj,
     &       myThid)
        CALL DIAGNOSTICS_FILL(Fe_lim,  'BLGFELIM',0,Nr,2,bi,bj,myThid)
        CALL DIAGNOSTICS_FILL(PO4_lim, 'BLGPLIM ',0,Nr,2,bi,bj,myThid)
        CALL DIAGNOSTICS_FILL(light_lim,'BLGLLIM ',0,Nr,2,bi,bj,myThid)
        CALL DIAGNOSTICS_FILL(POC_flux,'BLGPOCF ',0,Nr,2,bi,bj,myThid)
        CALL DIAGNOSTICS_FILL(NPP,     'BLGNPP  ',0,Nr,2,bi,bj,myThid)
        CALL DIAGNOSTICS_FILL(NCP,     'BLGNCP  ',0,Nr,2,bi,bj,myThid)
        CALL DIAGNOSTICS_FILL(Fe_spm,  'BLGFESPM',0,Nr,2,bi,bj,myThid)
        CALL DIAGNOSTICS_FILL(Fe_recycle,'BLGFEREC',0,Nr,2,bi,bj,
     &       myThid)
        CALL DIAGNOSTICS_FILL(Fe_uptake,'BLGFEUP ',0,Nr,2,bi,bj,myThid)
        CALL DIAGNOSTICS_FILL(DOP_prod, 'BLGDOPP ',0,Nr,2,bi,bj,myThid)
        CALL DIAGNOSTICS_FILL(DOP_remin,'BLGDOPR ',0,Nr,2,bi,bj,myThid)
        CALL DIAGNOSTICS_FILL(P_spm,    'BLGPSPM ',0,Nr,2,bi,bj,myThid)
        CALL DIAGNOSTICS_FILL(P_recycle,'BLGPREC ',0,Nr,2,bi,bj,myThid)
        CALL DIAGNOSTICS_FILL(P_reminp, 'BLGPREM ',0,Nr,2,bi,bj,myThid)
        CALL DIAGNOSTICS_FILL(P_uptake, 'BLGPUP  ',0,Nr,2,bi,bj,myThid)
        CALL DIAGNOSTICS_FILL(mu,       'BLGMU   ',0,Nr,2,bi,bj,myThid)
        CALL DIAGNOSTICS_FILL(CaCO3_diss,'BLGCCdis',0,Nr,2,bi,bj,
     &       myThid)
        CALL DIAGNOSTICS_FILL(CaCO3_uptake,'BLGCCpro',0,Nr,2,bi,bj,
     &       myThid)
c 2d local variables
        CALL DIAGNOSTICS_FILL(mld,       'BLGMLD  ',0,1,1,bi,bj,myThid)
      ENDIF
#endif /* ALLOW_DIAGNOSTICS */

#endif /* USE_BLING_V1 */

#endif /* ALLOW_BLING */

      RETURN
      END

#include "PTRACERS_OPTIONS.h"

CBOP
C     !ROUTINE: PTRACERS_SWITCH_ONOFF

C     !INTERFACE:
      SUBROUTINE PTRACERS_SWITCH_ONOFF(
     I                    myTime, myIter, myThid )

C     !DESCRIPTION:
C     Decide to switch on/off individual tracer time-stepping

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
c#include "PARAMS.h"
#include "PTRACERS_SIZE.h"
#include "PTRACERS_PARAMS.h"
#include "PTRACERS_START.h"

C     !INPUT PARAMETERS:
C     myTime    :: model time
C     myIter    :: time-step number
C     myThid    :: thread number
      _RL myTime
      INTEGER myIter
      INTEGER myThid
CEOP

#ifdef ALLOW_PTRACERS
C     !LOCAL VARIABLES:
#ifndef ALLOW_AUTODIFF
      INTEGER iTracer
#endif

      IF ( .NOT.PTRACERS_startAllTrc ) THEN

#ifdef ALLOW_AUTODIFF
         STOP 'ABNORMAL END: S/R PTRACERS_SWITCH_ONOFF'
#else /* ALLOW_AUTODIFF */

        _BARRIER
        _BEGIN_MASTER(myThid)

        DO iTracer=1,PTRACERS_numInUse
          IF ( myTime.GE.PTRACERS_startStepFwd(iTracer) ) THEN
            PTRACERS_StepFwd(iTracer) = .TRUE.
          ELSE
            PTRACERS_StepFwd(iTracer) = .FALSE.
          ENDIF
        ENDDO

        _END_MASTER(myThid)
        _BARRIER

#endif /* ALLOW_AUTODIFF */

      ENDIF

#endif /* ALLOW_PTRACERS */

      RETURN
      END

#include "GRIDALT_OPTIONS.h"

       subroutine gridalt_initialise (myThid)
c-----------------------------------------------------------------------
c  Routine to initialise the gridalt package.
c
c  Input: myThid       - Process number calling this routine
c
c  Notes:
c   When used with fizhi, this routine is the interface
c                                       to make_phys_grid
c  Calls: make_phys_grid (define the physics grid and mappings)
c         when diagnostics are used, call gridalt_diagnostics_init
c-----------------------------------------------------------------------
       implicit none
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "fizhi_SIZE.h"
#include "gridalt_mapping.h"
#include "SURFACE.h"

       integer myThid

       integer nlph
       integer bi, bj
       integer im1, im2, jm1, jm2, idim1, idim2, jdim1, jdim2

       im1 = 1-OLx
       im2 = sNx+OLx
       jm1 = 1-OLy
       jm2 = sNy+OLy
       idim1 = 1
       idim2 = sNx
       jdim1 = 1
       jdim2 = sNy

#ifdef ALLOW_FIZHI
       if(usefizhi) then
        do bj = myByLo(myThid), myByHi(myThid)
        do bi = myBxLo(myThid), myBxHi(myThid)

         call make_phys_grid(drF,hfacC,im1,im2,jm1,jm2,Nr,Nsx,Nsy,
     .       1,sNx,1,sNy,bi,bj,Nrphys,ksurfC,dpphys0,nlph,nlperdyn)

         if( NrPhys.ne.nlph ) then
          print *,' ERROR CONDITION - Model has been brought down '
          print *,' Physics dimension in fizhi_size is ',Nrphys,
     .                     ' New grid has ',nlph,' levels '
          stop
         endif

        enddo
        enddo
       endif

#ifdef ALLOW_DIAGNOSTICS
      if ( useDiagnostics ) then
        call gridalt_diagnostics_init( myThid )
      endif
#endif

#endif

       return
       end

#include "CPP_OPTIONS.h"

CBOP
C     !ROUTINE: CYCLE_TRACER
C     !INTERFACE:
      SUBROUTINE CYCLE_TRACER(
     I                   bi, bj,
     U                   tracer, gTracer,
     I                   myTime, myIter, myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R CYCLE_TRACER
C     *==========================================================*
C     | o Cycles the time-stepping arrays for a tracer field
C     *==========================================================*
C     \ev
C     !USES:
      IMPLICIT NONE
C Common
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
C     !INPUT/OUTPUT PARAMETERS:
C     == Routine Arguments ==
C     bi, bj                  :: current tile indices
C     tracer, gTracer, gTrNm1 :: Tracer field, with tendencies
C     myTime                  :: Current simulation time for this instance.
C     myIter                  :: Current time-step number
C     myThid                  :: my Thread Id number
      INTEGER bi,bj
c     INTEGER iMin,iMax,jMin,jMax
      _RL tracer (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL gTracer(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
c     _RL gTrNm1 (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL myTime
      INTEGER myIter, myThid

C     !LOCAL VARIABLES:
C     == Local variables ==
      INTEGER i,j,k
CEOP

C     Rotate tracer/gTracer
      DO k=1,Nr
       DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
         tracer(i,j,k) = gTracer(i,j,k)
        ENDDO
       ENDDO
      ENDDO

      RETURN
      END

#include "SEAICE_OPTIONS.h"
#ifdef ALLOW_COST
#include "COST_OPTIONS.h"
#endif
#ifdef ALLOW_CTRL
#include "CTRL_OPTIONS.h"
#endif

CBOP
C     !ROUTINE: SEAICE_COST_FINAL
C     !INTERFACE:
      SUBROUTINE SEAICE_COST_FINAL( ifc, optimcycle, myThid )

C     !DESCRIPTION:
C     *==========================================================*
C     | SUBROUTINE SEAICE_COST_FINAL
C     *==========================================================*

C     !USES:
      IMPLICIT NONE

C     == global variables ==
#include "EEPARAMS.h"
#include "SIZE.h"
#include "PARAMS.h"
#include "SEAICE_SIZE.h"
#include "SEAICE_PARAMS.h"
#include "SEAICE_COST.h"
#ifdef ALLOW_COST
# include "cost.h"
#endif
#ifdef ALLOW_CTRL
# include "CTRL_SIZE.h"
# include "CTRL.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     ifc        :: file unit for costfunction_seaice.XXXX
C     optimcycle :: cycle number of the off-line optimization.
C     myThid     :: my Thread Id number
      INTEGER ifc
      INTEGER optimcycle
      INTEGER myThid

#if (defined ALLOW_COST && defined ALLOW_COST_ICE)
C     !LOCAL VARIABLES:
      INTEGER bi, bj
      _RL f_ice
      _RL no_ice
      CHARACTER*24 cfname
c     CHARACTER*(MAX_LEN_MBUF) msgBuf
CEOP

      f_ice      = 0. _d 0
      no_ice     = 0. _d 0

#ifdef ALLOW_SEAICE_COST_EXPORT
      CALL SEAICE_COST_EXPORT( myThid )
#endif

C--   Sum up all contributions.
      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)

          tile_fc(bi,bj) = tile_fc(bi,bj)
     &          + mult_ice_export * objf_ice_export(bi,bj)
     &          + mult_ice        * objf_ice(bi,bj)

       ENDDO
      ENDDO

C--   Note: global summation (tile_fc --> fc) is done only in cost_final

C--   Do global summation for each part of the cost function

      CALL GLOBAL_SUM_TILE_RL( objf_ice,     f_ice,     myThid )
      CALL GLOBAL_SUM_TILE_RL( num_ice,     no_ice,     myThid )

      WRITE(standardMessageUnit,'(A,1PE22.14,1PE22.14,1X,1PE9.2)')
     &     ' --> f_ice     =',f_ice, no_ice, mult_ice

C--   Each process has calculated the global part for itself.
      IF ( ifc .NE. -1 ) THEN

        WRITE(cfname,'(A,i4.4)') 'costfunction_seaice.',optimcycle
        OPEN(unit=ifc,file=cfname)

C     makes little sense to print this now, because it is zero at this point
c       WRITE(ifc,*) 'fc =', fc
        WRITE(ifc,'(A,1PE22.14,1PE22.14,1X,1PE9.2)')
     &       'f_ice   =', f_ice, no_ice, mult_ice

        CLOSE(ifc)

      ENDIF

#endif /* ALLOW_COST and ALLOW_COST_ICE */

      RETURN
      END

#include "EBM_OPTIONS.h"

CBOP 0
C !ROUTINE: EBM_INI_VARS

C !INTERFACE:
      SUBROUTINE EBM_INI_VARS( myThid )

C     !DESCRIPTION:
C     *==========================================================*
C     | S/R INITIALISE VARIABLES FOR EBM
C     *==========================================================*

C     !USES:
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
c#include "DYNVARS.h"
c#include "GRID.h"
c#include "FFIELDS.h"
#ifdef ALLOW_EBM
# include "EBM.h"
#endif

C     !INPUT PARAMETERS:
C     myThid  :: my Thread Id number
      INTEGER myThid
CEOP

#ifdef ALLOW_EBM
C     !LOCAL VARIABLES:
C     == Local variables ==
C     i, j, k :: Loop counters
      INTEGER bi,bj,i,j

C--   initially all forcing fields are zero
      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          Run    (i,j,bi,bj) = 0.
          winPert(i,j,bi,bj) = 0.
         ENDDO
        ENDDO
       ENDDO
      ENDDO

      CALL EBM_LOAD_CLIMATOLOGY( myThid )

c     CALL EBM_DRIVER( startTime, niter0, myThid )

c     print *, TmlS - 273.15, TtS - 273.15
c     print *, TmlN - 273.15, TtN - 273.15

#endif /* ALLOW_EBM */

      RETURN
      END

#include "KPP_OPTIONS.h"

      SUBROUTINE KPP_CALC_DIFF_T( 
     I        bi,bj,iMin,iMax,jMin,jMax,kArg,kSize,
     O        KappaRT,
     I        myThid)

C     /==========================================================\
C     | SUBROUTINE KPP_CALC_DIFF_T                               |
C     | o Return contribution to net diffusivity from KPP mixing |
C     \==========================================================/
      IMPLICIT NONE

C     == GLobal variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "DYNVARS.h"
#include "GRID.h"
#ifdef ALLOW_KPP
#include "KPP.h"
#endif

C     == Routine arguments ==
C     bi, bj,   :: tile indices
C     iMin,iMax :: Range of points for which calculation is done
C     jMin,jMax :: Range of points for which calculation is done
C     kArg      :: = 0 -> do the k-loop here and treat all levels
C                  > 0 -> k-loop is done outside and treat only level k=kArg
C     kSize     :: 3rd Dimension of the vertical diffusivity array KappaRT
C     KappaRT   :: vertical diffusivity array
C     myThid    :: Instance number for this innvocation of KPP_CALC_DIFF_T
C
      INTEGER bi,bj,iMin,iMax,jMin,jMax,kArg,kSize
      _RL KappaRT(1-Olx:sNx+Olx,1-Oly:sNy+Oly,kSize)
      INTEGER myThid

#ifdef ALLOW_KPP

C     == Local variables ==
C     i,j,k     :: Loop counters
      INTEGER i,j,k

C--   Set vertical diffusivity contribution from KPP
      IF ( kArg .EQ. 0 ) THEN
C-    do all levels :
       DO k=1,MIN(Nr,kSize)
        DO j=jMin,jMax
         DO i=iMin,iMax
          KappaRT(i,j,k) = KPPdiffKzT(i,j,k,bi,bj)
         ENDDO
        ENDDO
       ENDDO
      ELSE
C-    do level k=kArg only :
       k = MIN(kArg,kSize)
       DO j=jMin,jMax
        DO i=iMin,iMax
         KappaRT(i,j,k) = KPPdiffKzT(i,j,kArg,bi,bj)
        ENDDO
       ENDDO
      ENDIF

#endif /* ALLOW_KPP */

      RETURN
      END

#include "MYPACKAGE_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: MYPACKAGE_READ_PICKUP

C     !INTERFACE:
      SUBROUTINE MYPACKAGE_READ_PICKUP( myIter, myThid )

C     !DESCRIPTION:
C     Reads current state of MYPACKAGE from a pickup file

C     !USES:
      IMPLICIT NONE
C     == Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "MYPACKAGE.h"

C     !INPUT PARAMETERS:
C     myIter            :: time-step number
C     myThid            :: thread number
      INTEGER myIter
      INTEGER myThid

#if (defined MYPACKAGE_3D_STATE) || (defined MYPACKAGE_2D_STATE)

C     !LOCAL VARIABLES:
C     fn          :: character buffer for creating filename
C     fp          :: precision of pickup files
C     filePrec    :: pickup-file precision (read from meta file)
C     nbFields    :: number of fields in pickup file (read from meta file)
C     missFldList :: List of missing fields   (attempted to read but not found)
C     missFldDim  :: Dimension of missing fields list array: missFldList
C     nMissing    :: Number of missing fields (attempted to read but not found)
C     j           :: loop index
C     nj          :: record number
C     ioUnit      :: temp for writing msg unit
C     msgBuf      :: Informational/error message buffer
      INTEGER fp
      INTEGER filePrec, nbFields
      INTEGER missFldDim, nMissing
      INTEGER j, nj, ioUnit
      PARAMETER( missFldDim = 12 )
      CHARACTER*(10) suff
      CHARACTER*(MAX_LEN_FNAM) fn
      CHARACTER*(8) missFldList(missFldDim)
      CHARACTER*(MAX_LEN_MBUF) msgBuf
CEOP

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

       IF ( pickupSuff.EQ.' ' ) THEN
        IF ( rwSuffixType.EQ.0 ) THEN
          WRITE(fn,'(A,I10.10)') 'pickup_mypackage.', myIter
        ELSE
          CALL RW_GET_SUFFIX( suff, startTime, myIter, myThid )
          WRITE(fn,'(A,A)') 'pickup_mypackage.', suff
        ENDIF
       ELSE
        WRITE(fn,'(A,A10)') 'pickup_mypackage.', pickupSuff
       ENDIF
       fp = precFloat64

       CALL READ_MFLDS_SET(
     I                      fn,
     O                      nbFields, filePrec,
     I                      Nr, myIter, myThid )
       _BEGIN_MASTER( myThid )
c      IF ( filePrec.NE.0 .AND. filePrec.NE.fp ) THEN
       IF ( nbFields.GE.0 .AND. filePrec.NE.fp ) THEN
         WRITE(msgBuf,'(2A,I4)') 'MYPACKAGE_READ_PICKUP: ',
     &    'pickup-file binary precision do not match !'
         CALL PRINT_ERROR( msgBuf, myThid )
         WRITE(msgBuf,'(A,2(A,I4))') 'MYPACKAGE_READ_PICKUP: ',
     &    'file prec.=', filePrec, ' but expecting prec.=', fp
         CALL PRINT_ERROR( msgBuf, myThid )
         CALL ALL_PROC_DIE( 0 )
         STOP 'ABNORMAL END: S/R MYPACKAGE_READ_PICKUP (data-prec Pb)'
       ENDIF
       _END_MASTER( myThid )

       IF ( nbFields.LE.0 ) THEN
C-      No meta-file or old meta-file without List of Fields
        ioUnit = errorMessageUnit
        IF ( pickupStrictlyMatch ) THEN
          WRITE(msgBuf,'(4A)') 'MYPACKAGE_READ_PICKUP: ',
     &      'no field-list found in meta-file',
     &      ' => cannot check for strick-matching'
          CALL PRINT_ERROR( msgBuf, myThid )
          WRITE(msgBuf,'(4A)') 'MYPACKAGE_READ_PICKUP: ',
     &      'try with " pickupStrictlyMatch=.FALSE.,"',
     &      ' in file: "data", NameList: "PARM03"'
          CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
          CALL ALL_PROC_DIE( myThid )
          STOP 'ABNORMAL END: S/R MYPACKAGE_READ_PICKUP'
        ELSE
          WRITE(msgBuf,'(4A)') 'WARNING >> MYPACKAGE_READ_PICKUP: ',
     &      ' no field-list found'
          CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
         IF ( nbFields.EQ.-1 ) THEN
C-      No meta-file
          WRITE(msgBuf,'(4A)') 'WARNING >> ',
     &      ' try to read pickup as currently written'
          CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
         ELSE
C-      Old meta-file without List of Fields
c         WRITE(msgBuf,'(4A)') 'WARNING >> ',
c    &      ' try to read pickup as it used to be written'
c         CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
c         WRITE(msgBuf,'(4A)') 'WARNING >> ',
c    &      ' until checkpoint59l (2007 Dec 17)'
c         CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
          WRITE(msgBuf,'(4A)') 'MYPACKAGE_READ_PICKUP: ',
     &      'no field-list found in meta-file'
          CALL PRINT_ERROR( msgBuf, myThid )
          CALL ALL_PROC_DIE( myThid )
          STOP 'ABNORMAL END: S/R MYPACKAGE_READ_PICKUP'
         ENDIF
        ENDIF
       ENDIF

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

       IF ( nbFields.EQ.0 ) THEN
C---   Old way to read pickup:

       ELSE
C---   New way to read MYPACKAGE pickup:
        nj = 0
C---    read MYPACKAGE 3-D fields for restart
#ifdef MYPACKAGE_3D_STATE
        CALL READ_MFLDS_3D_RL( 'myPaSta1', myPa_StatScal1,
     &                                 nj, fp, Nr, myIter, myThid )
        CALL READ_MFLDS_3D_RL( 'myPaSta2', myPa_StatScal2,
     &                                 nj, fp, Nr, myIter, myThid )
        CALL READ_MFLDS_3D_RL( 'myPaStaU', myPa_StatVelU,
     &                                 nj, fp, Nr, myIter, myThid )
        CALL READ_MFLDS_3D_RL( 'myPaStaV', myPa_StatVelV,
     &                                 nj, fp, Nr, myIter, myThid )
#endif /* MYPACKAGE_3D_STATE */
        nj = nj*Nr
C---    read MYPACKAGE 2-D fields for restart
#ifdef MYPACKAGE_2D_STATE
        CALL READ_MFLDS_3D_RL( 'myPaSur1', myPa_Surf1,
     &                                 nj, fp, 1 , myIter, myThid )
        CALL READ_MFLDS_3D_RL( 'myPaSur2', myPa_Surf2,
     &                                 nj, fp, 1 , myIter, myThid )
#endif /* MYPACKAGE_2D_STATE */

C--    end: new way to read pickup file
       ENDIF

C--    Check for missing fields:
       nMissing = missFldDim
       CALL READ_MFLDS_CHECK(
     O                     missFldList,
     U                     nMissing,
     I                     myIter, myThid )
       IF ( nMissing.GT.missFldDim ) THEN
         WRITE(msgBuf,'(2A,I4)') 'MYPACKAGE_READ_PICKUP: ',
     &     'missing fields list has been truncated to', missFldDim
         CALL PRINT_ERROR( msgBuf, myThid )
         CALL ALL_PROC_DIE( myThid )
         STOP 'ABNORMAL END: S/R MYPACKAGE_READ_PICKUP (list-size Pb)'
       ENDIF
       IF ( nMissing.GE.1 ) THEN
        ioUnit = errorMessageUnit
        DO j=1,nMissing
         WRITE(msgBuf,'(4A)') 'MYPACKAGE_READ_PICKUP: ',
     &       'cannot restart without field "',missFldList(nj),'"'
         CALL PRINT_ERROR( msgBuf, myThid )
        ENDDO
        CALL ALL_PROC_DIE( myThid )
        STOP 'ABNORMAL END: S/R MYPACKAGE_READ_PICKUP'
       ENDIF

C--    Update overlap regions:
#ifdef MYPACKAGE_3D_STATE
        CALL EXCH_3D_RL( myPa_StatScal1, Nr, myThid )
        CALL EXCH_3D_RL( myPa_StatScal2, Nr, myThid )
        IF ( myPa_StaV_Cgrid ) THEN
         CALL EXCH_UV_3D_RL( myPa_StatVelU, myPa_StatVelV,
     &                       .TRUE., Nr, myThid )
        ELSE
C-      Assume Agrid position:
         CALL EXCH_UV_AGRID_3D_RL( myPa_StatVelU, myPa_StatVelV,
     &                       .TRUE., Nr, myThid )
        ENDIF
#endif /* MYPACKAGE_3D_STATE */
#ifdef MYPACKAGE_2D_STATE
        CALL EXCH_XY_RL( myPa_Surf1, myThid )
        CALL EXCH_XY_RL( myPa_Surf2, myThid )
#endif /* MYPACKAGE_2D_STATE */

#endif /* MYPACKAGE_3D_STATE or MYPACKAGE_2D_STATE */

      RETURN
      END

#include "LONGSTEP_OPTIONS.h"

CBOP
C     !ROUTINE: LONGSTEP_INIT_FIXED

C     !INTERFACE:
      SUBROUTINE LONGSTEP_INIT_FIXED( myThid )

C     !DESCRIPTION:
C     Initialize longstep constants

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"

C     !INPUT PARAMETERS:
      INTEGER myThid
CEOP

#ifdef ALLOW_LONGSTEP

C     !LOCAL VARIABLES:

#ifdef ALLOW_DIAGNOSTICS
      IF ( useDiagnostics ) THEN
        CALL LONGSTEP_DIAGNOSTICS_INIT( myThid )
      ENDIF
#endif

#endif /* ALLOW_LONGSTEP */

      RETURN
      END

#include "RW_OPTIONS.h"

CBOP
C     !ROUTINE: WRITE_FLD_S3D_RS
C     !INTERFACE:
      SUBROUTINE WRITE_FLD_S3D_RS(
     I                 pref, suff, Ovl, nNz, field, myIter, myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE WRITE_FLD_S3D_RS
C     |  Front-end interface to low-level I/O subroutine (MDSIO).
C     |  Write short (smaller overlap) 3-D "RS" type field
C     |   to binary file (prefix,suffix).
C     *==========================================================*
C     | Note: Use a local copy to full overlap array
C     |  - not very efficient
C     |  - max number of level is limited (set to kSiz)
C     |  But since it is used mainly for debugging purpose,
C     |   no attempt to improve efficiency/flexibility
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     === Global data ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     myThid    :: my Thread Id number
      CHARACTER*(*) pref,suff
      INTEGER Ovl
      INTEGER nNz
      _RS field(1-Ovl:sNx+Ovl,1-Ovl:sNy+Ovl,nNz,nSx,nSy)
      INTEGER myIter
      INTEGER myThid

#ifndef RW_DISABLE_SMALL_OVERLAP
C     !FUNCTIONS:
      INTEGER  ILNBLNK, IFNBLNK
      EXTERNAL ILNBLNK, IFNBLNK

C     !LOCAL VARIABLES:
C     msgBuf     :: Informational/error message buffer
      INTEGER kSiz
      PARAMETER ( kSiz = Nr )
      _RS locVar(1-OLx:sNx+OLx,1-OLy:sNy+OLy,kSiz,nSx,nSy)

      CHARACTER*(MAX_LEN_MBUF) msgBuf
      CHARACTER*(MAX_LEN_FNAM) fName
      INTEGER fPrec, iRec
      INTEGER i,j,k,bi,bj
      INTEGER s1Lo,s1Hi,s2Lo,s2Hi

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      IF ( Ovl.GT.OLx .OR. Ovl.GT.OLy ) THEN
        WRITE(msgBuf,'(2A,2(I3,A))') 'WRITE_FLD_S3D_RS:',
     &  ' Argument Ovl (=', Ovl, ' ) too large (>', MIN(OLx,OLy), ' )'
        CALL PRINT_ERROR( msgBuf, myThid )
        STOP 'ABNORMAL END: S/R WRITE_FLD_S3D_RS'
      ENDIF
      IF ( nNz.GT.kSiz ) THEN
        WRITE(msgBuf,'(2A,2(I3,A))') 'WRITE_FLD_S3D_RS:',
     &  ' Argument nNz (=', nNz, ' ) too large (> kSiz=', kSiz, ' )'
        CALL PRINT_ERROR( msgBuf, myThid )
        STOP 'ABNORMAL END: S/R WRITE_FLD_S3D_RS'
      ENDIF

      s1Lo = IFNBLNK(pref)
      s1Hi = ILNBLNK(pref)
      IF ( suff .EQ. ' ' ) THEN
       WRITE( fName, '(A)' ) pref(s1Lo:s1Hi)
      ELSEIF ( suff .EQ. 'I10' ) THEN
       WRITE( fName, '(A,A,I10.10)' ) pref(s1Lo:s1Hi),'.',myIter
      ELSE
       s2Lo = IFNBLNK(suff)
       s2Hi = ILNBLNK(suff)
       WRITE( fName, '(A,A)' ) pref(s1Lo:s1Hi),suff(s2Lo:s2Hi)
      ENDIF

      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
         DO k=1,nNz
          DO j=1,sNy
           DO i=1,sNx
            locVar(i,j,k,bi,bj) = field(i,j,k,bi,bj)
           ENDDO
          ENDDO
         ENDDO
       ENDDO
      ENDDO

      fPrec = writeBinaryPrec
      iRec  = 1
      CALL WRITE_REC_LEV_RS(
     I                       fName, fPrec, kSiz, 1, nNz, locVar,
     I                       iRec, myIter, myThid )

#else  /* RW_DISABLE_SMALL_OVERLAP */

      STOP 'ABNORMAL END: S/R WRITE_FLD_S3D_RS empty'

#endif /* RW_DISABLE_SMALL_OVERLAP */

      RETURN
      END

#include "DIC_OPTIONS.h"
#undef USE_OLD_READ_PICKUP

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: DIC_INIT_VARIA

C     !INTERFACE:
      SUBROUTINE DIC_INIT_VARIA( myThid )

C     !DESCRIPTION:
C     Initialize variable quantities

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "DIC_VARS.h"
#include "DIC_ATMOS.h"
#include "PTRACERS_SIZE.h"
#include "PTRACERS_PARAMS.h"
#ifdef ALLOW_COST
# include "DIC_COST.h"
#endif
C     !INPUT PARAMETERS:
C     myThid               :: my Thread Id number
      INTEGER myThid
CEOP

#ifdef ALLOW_DIC
      INTEGER i,j, bi,bj
# ifdef DIC_CALCITE_SAT
      INTEGER k
# endif
c     CHARACTER*(MAX_LEN_MBUF) msgBuf

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C--   Initialise variable in common block DIC_ATMOS
#ifndef ALLOW_AUTODIFF
      _BEGIN_MASTER(myThid)
#endif
      total_atmos_carbon = 0. _d 0
      total_ocean_carbon = 0. _d 0
      total_atmos_carbon_year  = 0. _d 0
      total_atmos_carbon_start = 0. _d 0
      total_ocean_carbon_year  = 0. _d 0
      total_ocean_carbon_start = 0. _d 0
      atpco2 = 0. _d 0
#ifdef ALLOW_COST
      totcost =  0. _d 0
#endif
C 2d surface pH
      pH_isLoaded(1) = .FALSE.
C 3d full ocean pH
      pH_isLoaded(2) = .FALSE.
#ifndef ALLOW_AUTODIFF
      _END_MASTER(myThid)
      _BARRIER
#endif

C--   Initialise variables other than forcing (done in ini_forcing):
      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
           FluxCO2(i,j,bi,bj)  = 0. _d 0
           pH(i,j,bi,bj)       = 8. _d 0
         ENDDO
        ENDDO
#ifdef DIC_BIOTIC
C-    Initialise alpha & rain_ratio fields with fixed (& Uniform) values
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
           alpha(i,j,bi,bj)      = alphaUniform
           rain_ratio(i,j,bi,bj) = rainRatioUniform
         ENDDO
        ENDDO
#endif /* DIC_BIOTIC */
#ifdef DIC_CALCITE_SAT
        DO k = 1, Nr
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           omegaC(i,j,k,bi,bj) = 0. _d 0
           pH3D(i,j,k,bi,bj)   = 7.9 _d 0
          ENDDO
         ENDDO
        ENDDO
#endif /* DIC_CALCITE_SAT */
       ENDDO
      ENDDO

C--   Initialise forcing field variables (was called from gchem_init_vari.F)
      CALL DIC_INI_FORCING(myThid)

C-  read pickup
      IF ( nIter0.GT.PTRACERS_Iter0 .OR.
     &    (nIter0.EQ.PTRACERS_Iter0 .AND. pickupSuff.NE.' ')
     &   ) THEN
C       Read pH from a pickup file if needed
        CALL DIC_READ_PICKUP( nIter0, myThid )
      ENDIF

C-    Move these S/R call here (were previously in gchem_init_vari.F), except
C     DIC_INI_ATMOS which was called from the top of DIC_SURFFORCING_INIT
      CALL DIC_INI_ATMOS( startTime, nIter0, myThid )
      CALL DIC_SURFFORCING_INIT(myThid)
# ifdef ALLOW_CTRL
      CALL DIC_SET_CONTROL(myThid)
# endif

#endif /* ALLOW_DIC */

      RETURN
      END

#include "OCN_CPL_OPTIONS.h"

CBOP 0
C !ROUTINE: OCN_EXPORT_OCNCONFIG

C !INTERFACE:
      SUBROUTINE OCN_EXPORT_OCNCONFIG( myThid )

C !DESCRIPTION:
C     *==========================================================*
C     | SUBROUTINE OCN_EXPORT_OCNCONFIG
C     | o Routine for exporting ocean config to coupling level.
C     *==========================================================*
C     | This version talks to the MIT Coupler. It uses the MIT
C     | Coupler "checkpoint1" library calls.
C     *==========================================================*

C !USES:
      IMPLICIT NONE
C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "OCNIDS.h"
#include "OCNCPL.h"

C !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     myThid :: Thread number for this instance of the routine
      INTEGER myThid

C !LOCAL VARIABLES:
      INTEGER i,j,bi,bj
      INTEGER tmpFld(1)
CEOP

      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          ocMxlD2cpl(i,j,bi,bj) = hFacC(i,j,1,bi,bj)*drF(1)
         ENDDO
        ENDDO
       ENDDO
      ENDDO

C     Send my configuration information to the coupler
      _BARRIER
      _BEGIN_MASTER( myThid )

C     o Send number of coupler time-steps to do for this run
      tmpFld(1) = nTimeSteps
      CALL COMPSEND_I4VEC( 'nCouplingSteps', 1, tmpFld )

C     o Send ocean model bathymetry map
      CALL COMPSEND_R8TILES(
     I              ocnMxlDName, sNx, OLx, sNy, OLy, 1, nSx, nSy,
     I              ocMxlD2cpl )

      _END_MASTER( myThid )
      _BARRIER

      RETURN
      END

#include "MY82_OPTIONS.h"

      SUBROUTINE MY82_INIT_VARIA( myThid )
C     *==========================================================*
C     | SUBROUTINE MY82_INIT_VARIA                               |
C     | o Routine to initialize MY82 parameters and variables.   |
C     *==========================================================*
C     | Initialize MY92 parameters and variables.                |
C     *==========================================================*
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "MY82.h"

C     === Routine arguments ===
C     myThid -  Number of this instance of MY_INIT
      INTEGER myThid

#ifdef ALLOW_MY82

C     === Local variables ===
C     i,j,k,bi,bj - Loop counters

      INTEGER i, j, k, bi, bj
      _RL gam1, gam2

C     magic parameters( M. Satoh, p. 314)
      gam1 = 1. _d 0/3. _d 0 - 2. _d 0 *A1/B1
      gam2 = (B2+6. _d 0*A1)/B1
      alpha1 = 3. _d 0 *A2*gam1
      alpha2 = 3. _d 0 *A2*(gam1+gam2)
      beta1  = A1*B1*(gam1-C1)
      beta2  = A1*(B1*(gam1-C1) + 6. _d 0 *A1 + 3. _d 0 *A2)
      beta3  = A2*B1*gam1
      beta4  = A2*(B1*(gam1+gam2) - 3. _d 0 *A1)

C-----------------------------------------------------------------------
C Initialize MY82 variables MYviscAr, MYdiffKrT
C-----------------------------------------------------------------------

      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
        DO k = 1, Nr
         DO j = 1-OLy, sNy+OLy
          DO i = 1-OLx, sNx+OLx
           MYhbl    (i,j  ,bi,bj) = 0. _d 0
           MYviscAr (i,j,k,bi,bj) = viscArNr(k)
           MYdiffKr (i,j,k,bi,bj) = diffKrNrS(k)
          ENDDO
         ENDDO
        ENDDO
       ENDDO
      ENDDO

#endif /* ALLOW_MY82 */

      RETURN
      END

#include "COST_OPTIONS.h"

      SUBROUTINE COST_INIT_VARIA( mythid )

c     ==================================================================
c     SUBROUTINE cost_init_varia
c     ==================================================================
c
c     o Initialise the variable cost function part.
c
c     started: Christian Eckert eckert@mit.edu 30-Jun-1999
c
c     changed: Christian Eckert eckert@mit.edu 18-Apr-2000
c
c              - Restructured the code in order to create a package
c                for the MITgcmUV.
c
c     ==================================================================
c     SUBROUTINE cost_init_varia
c     ==================================================================

      implicit none

c     == global variables ==

#include "EEPARAMS.h"
#include "SIZE.h"
#include "cost.h"

c     == routine arguments ==
      integer mythid

c     == local variables ==
      integer i,j,k
      integer bi,bj
c     == end of interface ==

c--   Initialize the tiled cost function contributions.
      DO bj=myByLo(myThid),myByHi(myThid)
        DO bi=myBxLo(myThid),myBxHi(myThid)
          tile_fc(bi,bj)   = 0. _d 0
          objf_atl(bi,bj)  = 0. _d 0
          objf_test(bi,bj) = 0. _d 0
          objf_tracer(bi,bj) = 0. _d 0
#ifdef ALLOW_COST_VECTOR
          do i=1,sNx
            objf_vector(i,bi,bj) = 0. _d 0
          end do
#endif
c
#ifdef ALLOW_COST
          do k=1,Nr
            do j=1,sNy
              do i=1,sNx
                cMeanTheta(i,j,k,bi,bj) = 0. _d 0
                cMeanUVel(i,j,k,bi,bj)  = 0. _d 0
                cMeanVVel(i,j,k,bi,bj)  = 0. _d 0
                cMeanThetaUVel(i,j,k,bi,bj) = 0. _d 0
                cMeanThetaVVel(i,j,k,bi,bj) = 0. _d 0
              end do
            end do
          end do
#endif
c
#ifdef ALLOW_COST_STATE_FINAL
            do j=1,sNy
             do i=1,sNx
              do k=1,4*Nr
                objf_state_final(i,j,bi,bj,k) = 0. _d 0
              enddo
              objf_state_final(i,j,bi,bj,4*Nr+1) = 0. _d 0
cph No init. of cost_state_final here,
cph because we need it in ADM*TLM
              end do
            end do
#endif
       ENDDO
      ENDDO

#ifdef ALLOW_SEAICE
      call seaice_cost_init_varia( mythid )
#endif

#ifdef ALLOW_THSICE
      call thsice_cost_init_varia( mythid )
#endif

c--   Initialise the "global" parts of the cost function.
      _BEGIN_MASTER( mythid )
        fc         = 0. _d 0
        glofc      = 0. _d 0
      _END_MASTER( mythid )

      _BARRIER

      RETURN
      END

#include "DWNSLP_OPTIONS.h"

CBOP
C     !ROUTINE: DWNSLP_INIT_FIXED
C     !INTERFACE:
      SUBROUTINE DWNSLP_INIT_FIXED( myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE DWNSLP_INIT_FIXED
C     | o Routine to initialize Down-Sloping arrays ;
C     |   find potential location of Down-Sloping flow.
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "DWNSLP_SIZE.h"
#include "DWNSLP_PARAMS.h"
#include "DWNSLP_VARS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
      INTEGER myThid

#ifdef ALLOW_DOWN_SLOPE

C     !LOCAL VARIABLES:
C     === Local variables ===
C     msgBuf     :: Informational/error message buffer
C     logFname,STATUS='UNKNOWN')
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      CHARACTER*(19) logFname
      INTEGER i, j, k
      INTEGER bi, bj
      INTEGER n, ncount, ijd, ijr
      INTEGER ideep, jdeep, kdeep, dkMx
      INTEGER ishelf,jshelf,kshelf
      INTEGER downward
      _RL     dz_bottom
      _RL     drFlowMin
CEOP

      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C-    Initialize common bloc arrays :

        DWNSLP_NbSite(bi,bj) = 0
        DO n=1,DWNSLP_size
         DWNSLP_ijDeep(n,bi,bj) = 0
         DWNSLP_shVsD(n,bi,bj)  = 0
         DWNSLP_deepK(n,bi,bj)  = 0
         DWNSLP_Gamma(n,bi,bj)  = 0.
         DWNSLP_Transp(n,bi,bj) = 0.
        ENDDO

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C---- set list of bathymetric step (= potential location of Down-Sloping flow)
        ncount = 0

        IF ( gravitySign.GT.0. ) THEN
C--   gravity > 0 (p-Coord)

C-    in X direction (U-flow):
         DO j=1,sNy
          DO i=1,sNx+1
           IF ( kSurfW(i,j,bi,bj).LE.Nr ) THEN

            IF ( kSurfC(i,j,bi,bj).LT.kSurfC(i-1,j,bi,bj) ) THEN
             ncount = ncount + 1
             IF ( ncount.LE.DWNSLP_size ) THEN
              DWNSLP_ijDeep(ncount,bi,bj) =
     &          1 + (i+OLx-1) + (j+OLy-1)*xSize
              DWNSLP_shVsD(ncount,bi,bj) = -1
             ENDIF
            ENDIF

            IF ( kSurfC(i,j,bi,bj).GT.kSurfC(i-1,j,bi,bj) ) THEN
             ncount = ncount + 1
             IF ( ncount.LE.DWNSLP_size ) THEN
              DWNSLP_ijDeep(ncount,bi,bj) =
     &          1 + (i-1+OLx-1) + (j+OLy-1)*xSize
              DWNSLP_shVsD(ncount,bi,bj) = 1
             ENDIF
            ENDIF

           ENDIF
          ENDDO
         ENDDO

C-    in Y direction (V-flow):

         DO j=1,sNy+1
          DO i=1,sNx
           IF (  kSurfS(i,j,bi,bj).LE.Nr ) THEN

            IF ( kSurfC(i,j,bi,bj).LT.kSurfC(i,j-1,bi,bj) ) THEN
             ncount = ncount + 1
             IF ( ncount.LE.DWNSLP_size ) THEN
              DWNSLP_ijDeep(ncount,bi,bj) =
     &          1 + (i+OLx-1) + (j+OLy-1)*xSize
              DWNSLP_shVsD(ncount,bi,bj) = -xSize
             ENDIF
            ENDIF

            IF ( kSurfC(i,j,bi,bj).GT.kSurfC(i,j-1,bi,bj) ) THEN
             ncount = ncount + 1
             IF ( ncount.LE.DWNSLP_size ) THEN
              DWNSLP_ijDeep(ncount,bi,bj) =
     &          1 + (i+OLx-1) + (j-1+OLy-1)*xSize
              DWNSLP_shVsD(ncount,bi,bj) = xSize
             ENDIF
            ENDIF

           ENDIF
          ENDDO
         ENDDO

        ELSE
C--   gravity < 0 (z-Coord)

C-    in X direction (U-flow):

         DO j=1,sNy
          DO i=1,sNx+1
           IF ( kSurfW(i,j,bi,bj).LE.Nr ) THEN

            IF ( kLowC(i,j,bi,bj).GT.kLowC(i-1,j,bi,bj) ) THEN
             ncount = ncount + 1
             IF ( ncount.LE.DWNSLP_size ) THEN
              DWNSLP_ijDeep(ncount,bi,bj) =
     &          1 + (i+OLx-1) + (j+OLy-1)*xSize
              DWNSLP_shVsD(ncount,bi,bj) = -1
             ENDIF
            ENDIF

            IF ( kLowC(i,j,bi,bj).LT.kLowC(i-1,j,bi,bj) ) THEN
             ncount = ncount + 1
             IF ( ncount.LE.DWNSLP_size ) THEN
              DWNSLP_ijDeep(ncount,bi,bj) =
     &          1 + (i-1+OLx-1) + (j+OLy-1)*xSize
              DWNSLP_shVsD(ncount,bi,bj) = 1
             ENDIF
            ENDIF

           ENDIF
          ENDDO
         ENDDO

C-    in Y direction (V-flow):

         DO j=1,sNy+1
          DO i=1,sNx
           IF (  kSurfS(i,j,bi,bj).LE.Nr ) THEN

            IF ( kLowC(i,j,bi,bj).GT.kLowC(i,j-1,bi,bj) ) THEN
             ncount = ncount + 1
             IF ( ncount.LE.DWNSLP_size ) THEN
              DWNSLP_ijDeep(ncount,bi,bj) =
     &          1 + (i+OLx-1) + (j+OLy-1)*xSize
              DWNSLP_shVsD(ncount,bi,bj) = -xSize
             ENDIF
            ENDIF

            IF ( kLowC(i,j,bi,bj).LT.kLowC(i,j-1,bi,bj) ) THEN
             ncount = ncount + 1
             IF ( ncount.LE.DWNSLP_size ) THEN
              DWNSLP_ijDeep(ncount,bi,bj) =
     &          1 + (i+OLx-1) + (j-1+OLy-1)*xSize
              DWNSLP_shVsD(ncount,bi,bj) = xSize
             ENDIF
            ENDIF

           ENDIF
          ENDDO
         ENDDO

C--     end if gravitySign block
        ENDIF

C-    Store the Nb of bathymetric steps (=maximum Nb of Downsloping-flow site)
        DWNSLP_NbSite(bi,bj) = ncount

C-    Check dimension :
        IF (ncount.GT.DWNSLP_size) THEN
          WRITE(msgBuf,'(A,I8,A)')
     &      ' DWNSLP_INIT: DWNSLP_size=',DWNSLP_size,' too small !'
          CALL PRINT_ERROR( msgBuf, myThid )
          WRITE(msgBuf,'(A,2I4,A,I8)')
     &      ' DWNSLP_INIT: min needed for tile',bi,bj,' :', ncount
          CALL PRINT_ERROR( msgBuf, myThid )
          STOP 'ABNORMAL END: S/R DWNSLP_INIT'
        ENDIF

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C-    Compute geometric factor Gamma = slope * effective cross section area
        DO n=1,DWNSLP_NbSite(bi,bj)

          ijd = DWNSLP_ijDeep(n,bi,bj)
          ideep = 1-OLx + MOD(ijd-1,xSize)
          jdeep = 1-Oly + (ijd-1)/xSize
          ijr = DWNSLP_shVsD(n,bi,bj)
          ishelf = ideep + MOD(ijr,xSize)
          jshelf = jdeep + ijr/xSize
          IF ( usingPCoords ) THEN
            kdeep  = kSurfC(ideep, jdeep, bi,bj)
            kshelf = kSurfC(ishelf,jshelf,bi,bj)
            downward = -1
          ELSE
            kdeep  = kLowC (ideep, jdeep, bi,bj)
            kshelf = kLowC (ishelf,jshelf,bi,bj)
            downward = 1
          ENDIF

          i= MAX(ideep,ishelf)
          j= MAX(jdeep,jshelf)

C--   calculate the minimum level thickness between kshelf & kdeep:
          drFlowMin = DWNSLP_drFlow
          DO k = kshelf,kdeep,downward
            drFlowMin = MIN( drFlowMin,
     &                       drF(k)*hFacC(ideep,jdeep,k,bi,bj) )
          ENDDO

          IF (DWNSLP_slope.NE.0.) THEN
C--   Use fixed slope = DWNSLP_slope :
           IF (ABS(ijr).EQ.1) THEN
C-    slope along X dir:
            DWNSLP_Gamma(n,bi,bj) = DWNSLP_slope*dyG(i,j,bi,bj)
     &       *MIN( drF(kshelf)*hFacW(i,j,kshelf,bi,bj), drFlowMin )
           ELSE
C-    slope along Y dir:
            DWNSLP_Gamma(n,bi,bj) = DWNSLP_slope*dxG(i,j,bi,bj)
     &       *MIN( drF(kshelf)*hFacS(i,j,kshelf,bi,bj), drFlowMin )
           ENDIF
          ELSE
C--   Compute and use the local slope :
           IF ( usingPCoords ) THEN
            dz_bottom = Ro_surf(ideep,jdeep,bi,bj)
     &                - Ro_surf(ishelf,jshelf,bi,bj)
C     a quick way to convert Delta.P to Delta.Z :
            dz_bottom = dz_bottom*recip_gravity*recip_rhoConst
           ELSE
            dz_bottom = R_low(ishelf,jshelf,bi,bj)
     &                - R_low(ideep,jdeep,bi,bj)
           ENDIF
           IF (ABS(ijr).EQ.1) THEN
C-    slope along X dir:
            DWNSLP_Gamma(n,bi,bj) = dz_bottom*recip_dxC(i,j,bi,bj)
     &       *dyG(i,j,bi,bj)
     &       *MIN( drF(kshelf)*hFacW(i,j,kshelf,bi,bj), drFlowMin )
           ELSE
C-    slope along Y dir:
            DWNSLP_Gamma(n,bi,bj) = dz_bottom*recip_dyC(i,j,bi,bj)
     &       *dxG(i,j,bi,bj)
     &       *MIN( drF(kshelf)*hFacS(i,j,kshelf,bi,bj), drFlowMin )
           ENDIF

          ENDIF

        ENDDO

C-    end bi,bj loops.
       ENDDO
      ENDDO

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C- Print usefull variables :
      _BARRIER
      _BEGIN_MASTER(myThid)

      DWNSLP_ioUnit = 0
      IF ( debugLevel.GE.debLevA ) THEN
        CALL MDSFINDUNIT( DWNSLP_ioUnit, myThid )
      ENDIF
      IF ( DWNSLP_ioUnit.GT.0 ) THEN
        WRITE(logFname,'(A11,I4.4,A4)') 'down_slope.',myProcId,'.log'
        OPEN(DWNSLP_ioUnit,FILE=logFname,STATUS='UNKNOWN')
      ENDIF

      DO bj = 1,nSy
       DO bi = 1,nSx

        WRITE(msgBuf,'(A,2I4,I8)')
     &      'DWNSLP_INIT: DWNSLP_NbSite=',bi,bj,DWNSLP_NbSite(bi,bj)
        CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
C---
        IF ( DWNSLP_ioUnit.GT.0 ) THEN
         WRITE(DWNSLP_ioUnit,'(A,2I4,2I8)')
     &     ' DWNSLP_INIT: bi,bj, DWNSLP_NbSite, xSize =',
     &        bi,bj, DWNSLP_NbSite(bi,bj), xSize
         WRITE(DWNSLP_ioUnit,'(A)')
     &   '  bi  bj     n :     ijd  is  js ,   ijr  ks dkMx  Gamma :'
         DO n=1,DWNSLP_NbSite(bi,bj)
          ijd = DWNSLP_ijDeep(n,bi,bj)
          ideep = 1-OLx + MOD(ijd-1,xSize)
          jdeep = 1-Oly + (ijd-1)/xSize
          ijr = DWNSLP_shVsD(n,bi,bj)
          ishelf = ideep + MOD(ijr,xSize)
          jshelf = jdeep + ijr/xSize
          IF ( usingPCoords ) THEN
            kshelf = kSurfC(ishelf,jshelf,bi,bj)
            dkMx = kshelf - kSurfC(ideep,jdeep,bi,bj)
          ELSE
            kshelf = kLowC (ishelf,jshelf,bi,bj)
            dkMx = kLowC (ideep,jdeep,bi,bj) - kshelf
          ENDIF
          WRITE(DWNSLP_ioUnit,'(2I4,I6,A,I8,2I4,A,I6,2I4,1PE14.6)')
     &      bi,bj,n, ' :', ijd, ideep, jdeep,
     &      ' ,', ijr, kshelf, dkMx, DWNSLP_Gamma(n,bi,bj)
         ENDDO
         WRITE(DWNSLP_ioUnit,*)
        ENDIF
C---
       ENDDO
      ENDDO
      IF ( DWNSLP_ioUnit.GT.0 .AND. debugLevel.LT.debLevD ) THEN
        CLOSE(DWNSLP_ioUnit)
        DWNSLP_ioUnit = 0
      ENDIF

      _END_MASTER(myThid)

#ifdef ALLOW_DIAGNOSTICS
      IF ( useDiagnostics ) THEN
        CALL DWNSLP_DIAGNOSTICS_INIT( myThid )
      ENDIF
#endif

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#endif /* ALLOW_DOWN_SLOPE */
      RETURN
      END

#include "GCHEM_OPTIONS.h"

CBOP
C !ROUTINE: GCHEM_INSOLATION

C !INTERFACE: ==========================================================
      SUBROUTINE GCHEM_INSOLATION(
     O     solar_radiation,
     I     iMin, iMax, jMin, jMax, bi, bj,
     I     myTime, myIter, myThid )

C !DESCRIPTION:
C find daily mean insolation as function of date and latitude based on
C Paltridge, G. W. and C. M. R. Platt. 1976. Radiative Processes in
C Meteorology and Climatology. Elsevier Sci. 318 p.

C !USES: ===============================================================
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "GCHEM.h"

C !INPUT PARAMETERS: ===================================================
C     bi,bj         :: tile indices
C     iMin,iMax     :: computation domain: 1rst index range
C     jMin,jMax     :: computation domain: 2nd  index range
C     myTime        :: current time
C     myIter        :: current timestep
C     myThid        :: thread Id. number
      INTEGER bi, bj, iMin, iMax, jMin, jMax
      _RL     myTime
      INTEGER myIter
      INTEGER myThid

C !OUPUT PARAMETERS: ===================================================
      _RL     solar_radiation(1-OLx:sNx+OLx,1-OLy:sNy+OLy)

C !FUNCTIONS: ==========================================================

C !LOCAL VARIABLES: ====================================================
      INTEGER i,j
      _RL solar, albedo
      _RL dayfrac, yday, delta
      _RL lat, sun1, dayhrs
      _RL cosz, frac
CEOP

C constants
      solar  = 1360. _d 0   !solar constant
      albedo = 0.6 _d 0     !planetary albedo

C find day (****NOTE for year starting in winter*****)
C fraction of year
      dayfrac=MOD( myTime,gchem_secondsPerYear )/ gchem_secondsPerYear
C convert to radians
      yday = 2. _d 0*PI*dayfrac
C cosine zenith angle (paltridge+platt)
      delta = (0.006918 _d 0
     &       -(0.399912 _d 0*COS(yday))
     &       +(0.070257 _d 0*SIN(yday))
     &       -(0.006758 _d 0*COS(2. _d 0*yday))
     &       +(0.000907 _d 0*SIN(2. _d 0*yday))
     &       -(0.002697 _d 0*COS(3. _d 0*yday))
     &       +(0.001480 _d 0*SIN(3. _d 0*yday)) )

      DO j = jMin, jMax
       DO i = iMin, iMax
C latitude in radians
        lat=YC(i,j,bi,bj)*deg2rad
C     latitute in radians, backed out from coriolis parameter
C     (makes latitude independent of grid)
        IF ( usingCartesianGrid .OR. usingCylindricalGrid )
     &       lat = ASIN( fCori(i,j,bi,bj)/(2. _d 0*omega) )
C--    sun1 = -TAN(delta) * TAN(lat) ! why not use that?
        sun1 = -SIN(delta)/COS(delta) * SIN(lat)/COS(lat)
        IF (sun1.LE.-0.999 _d 0) sun1=-0.999 _d 0
        IF (sun1.GE. 0.999 _d 0) sun1= 0.999 _d 0
        dayhrs = ABS(ACOS(sun1))
C average zenith angle
        cosz = ( SIN(delta)*SIN(lat)
     &         +(COS(delta)*COS(lat)*SIN(dayhrs)/dayhrs) )
        IF (cosz.LE.5. _d -3) cosz= 5. _d -3
C fraction of daylight in day
        frac = dayhrs/PI

        solar_radiation(i,j) = solar*(1. _d 0-albedo)*cosz*frac

       ENDDO
      ENDDO

      RETURN
      END

#include "AIM_OPTIONS.h"
c#ifdef ALLOW_THSICE
c#include "THSICE_OPTIONS.h"
c#endif

CBOP
C     !ROUTINE: AIM_SICE_IMPL
C     !INTERFACE:
      SUBROUTINE AIM_SICE_IMPL(
     I               FMASK, netSW, sFlx,
     I               Shf0, dShf, Evp0, dEvp, Slr0, dSlr,
     U               Tsurf, SHF, EVAP, SLRU,
     O               dTsurf,
     I               bi, bj, myTime, myIter, myThid)

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R AIM_SICE_IMPL
C     | o AIM Interface to the implicit part of the sea-ice model
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     == Global variables ===
C-- size for MITgcm & Physics package :
#include "AIM_SIZE.h"

#include "EEPARAMS.h"
#include "PARAMS.h"

#include "AIM_FFIELDS.h"
#include "com_physcon.h"
c #include "com_physvar.h"

#ifdef ALLOW_THSICE
c#include "THSICE_SIZE.h"
c#include "THSICE_PARAMS.h"
c#include "THSICE_VARS.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     FMASK    :: sea-ice fraction [0-1]
C     netSW    :: net Short Wave surf. flux (+=down) [W/m2]
C     sFlx     :: net heat flux (+=down) except SW, function of surf. temp Ts:
C                 0: Flux(Ts=0.oC) ; 1: Flux(Ts^n) ; 2: d.Flux/d.Ts(Ts^n)
C     Shf0     :: sensible heat flux over freezing surf.
C     dShf     :: sensible heat flux derivative relative to surf. temp
C     Evp0     :: evaporation computed over freezing surface (Ts=0.oC)
C     dEvp     :: evaporation derivative relative to surf. temp
C     Slr0     :: upward long wave radiation over freezing surf.
C     Tsurf    :: surface temperature        (2-dim)
C     SHF      :: sensible heat flux              (2-dim)
C     EVAP     :: evaporation [g/(m^2 s)]         (2-dim)
C     SLRU     :: sfc lw radiation (upward flux)  (2-dim)
C     dTsurf   :: surf. temp change after 1 implicit time step [oC]
C     bi,bj    :: Tile index
C     myTime   :: Current time of simulation ( s )
C     myIter   :: Current iteration number in simulation
C     myThid   :: Number of this instance of the routine
      _RL  FMASK(NGP), netSW(NGP), sFlx(NGP,0:2)
      _RL  Shf0(NGP), dShf(NGP), Evp0(NGP), dEvp(NGP)
      _RL  Slr0(NGP), dSlr(NGP)
      _RL  Tsurf(NGP), SHF(NGP), EVAP(NGP), SLRU(NGP)
      _RL  dTsurf(NGP)
      INTEGER bi, bj, myIter, myThid
      _RL myTime
CEOP

#ifdef ALLOW_AIM
#ifdef ALLOW_THSICE
C     == Local variables ==
C       J          :: loop counters
      INTEGER J

C--   Physics tendency term

      IF ( useThSIce ) THEN

       DO J=1,NGP
C-    total surface downward heat flux :

C-    initialize temp. changes and fresh water flux :
         dTsurf(J) = 0.
       ENDDO

       CALL THSICE_IMPL_TEMP(
     I               netSW, sFlx,
     O               dTsurf,
     I               bi, bj, myTime, myIter, myThid)

C-     Update Surf.Temp., Evap, Upward SW according to surf. temp. changes
       DO J=1,NGP
        IF ( dTsurf(J) .GT. 999. ) THEN
         dTsurf(J)= tFreeze - Tsurf(J)
         Tsurf(J) = tFreeze
         SHF (J)  = Shf0(J)
         EVAP(J)  = Evp0(J)
         SLRU(J)  = Slr0(J)
        ELSE
         Tsurf(J) = Tsurf(J)+ dTsurf(J)
         SHF (J)  = SHF (J) + dTsurf(J)*dShf(J)
         EVAP(J)  = EVAP(J) + dTsurf(J)*dEvp(J)
         SLRU(J)  = SLRU(J) + dTsurf(J)*dSlr(J)
        ENDIF
       ENDDO

      ENDIF

#endif /* ALLOW_THSICE */
#endif /* ALLOW_AIM */

      RETURN
      END

#include "OFFLINE_OPTIONS.h"
#ifdef ALLOW_DIC
#include "DIC_OPTIONS.h"
#endif
#ifdef ALLOW_DARWIN
#include "DARWIN_OPTIONS.h"
#endif

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 0
C !ROUTINE: OFFLINE_CHECK

C !INTERFACE:
      SUBROUTINE OFFLINE_CHECK( myThid )

C     !DESCRIPTION:
C     Check dependances with other packages

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "OFFLINE.h"
#include "OFFLINE_SWITCH.h"

C     !INPUT PARAMETERS:
C     myThid   :: my Thread Id number
      INTEGER myThid
CEOP

#ifdef ALLOW_OFFLINE
C     !LOCAL VARIABLES:
C     msgBuf   :: Informational/error message buffer
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      INTEGER errCount

      _BEGIN_MASTER(myThid)

       WRITE(msgBuf,'(A)') 'OFFLINE_CHECK: #define OFFLINE'
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                     SQUEEZE_RIGHT, myThid )

C--   Print out some kee parameters :
       CALL WRITE_0D_L( offlineLoadGMRedi, INDEX_NONE,
     & 'offlineLoadGMRedi=', ' /* load (not compute) GMRedi tensor */')
       CALL WRITE_0D_L( offlineLoadKPP, INDEX_NONE,
     & 'offlineLoadKPP=', ' /* load (not compute) KPP mixing coeff */')
       CALL WRITE_0D_L( offlineLoadConvec, INDEX_NONE,
     & 'offlineLoadConvec=', ' /* load (not compute) Convect Mix */')
       CALL WRITE_0D_I( offlineIter0, INDEX_NONE,
     &   'offlineIter0 =', ' /* initial offline field timestep */')
       CALL WRITE_0D_RL( offlineTimeOffset, INDEX_NONE,
     &   'offlineTimeOffset =', ' /* time offset [s] */')
       CALL WRITE_0D_I( offlineLoadPrec, INDEX_NONE,
     &   'offlineLoadPrec =',
     &   ' /* precision (32,64) of offline files */')
       CALL WRITE_0D_RL( deltaToffline, INDEX_NONE,
     &   'deltaToffline =', ' /* time-step to load offline files */')
       CALL WRITE_0D_RL( offlineForcingPeriod, INDEX_NONE,
     &   'offlineForcingPeriod=',
     &   ' /* time interval between reccords [s] */')
       CALL WRITE_0D_RL( offlineForcingCycle, INDEX_NONE,
     &   'offlineForcingCycle =', ' /* length of 1 cycle [s] */')
       CALL WRITE_0D_C( UvelFile, -1, INDEX_NONE, 'UvelFile =',
     &  ' /* file name of loaded uVel field */')

C--   Check parameters:
       errCount = 0

C-    Put stops here if some flags are wrongly chosen.

C-    better not to modify temperature that was loaded from file:
C     => disable allowFreezing
       IF ( allowFreezing ) THEN
        WRITE(msgBuf,'(A)') 'allowFreezing=T not allowed if useOffLine'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount =  errCount + 1
       ENDIF

C-    stop if files are specified but not used.
       IF ( HFluxFile.NE.' ' ) THEN
        WRITE(msgBuf,'(A)') 'HFluxFile is set but not used'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount =  errCount + 1
       ENDIF
#ifndef ALLOW_OLD_VIRTUALFLUX
       IF ( SFluxFile.NE.' ' ) THEN
        WRITE(msgBuf,'(A)') 'SFluxFile is set but not used'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount =  errCount + 1
       ENDIF
#endif /* ndef ALLOW_OLD_VIRTUALFLUX */
       IF ( IceFile.NE.' ' ) THEN
        WRITE(msgBuf,'(A)') 'IceFile is set but not used'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount =  errCount + 1
       ENDIF
       IF ( offlineLoadGMRedi .AND. .NOT.useGMRedi ) THEN
        WRITE(msgBuf,'(A)') 'some GMxxFile are set but not used'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount =  errCount + 1
       ENDIF
       IF ( offlineLoadKPP .AND. .NOT.useKPP ) THEN
        WRITE(msgBuf,'(A)') 'some KPP_xxxxxFile are set but not used'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount =  errCount + 1
       ENDIF
       IF ( offlineLoadConvec .AND. ivdc_kappa.EQ.0. ) THEN
        WRITE(msgBuf,'(A)') 'ConvFile is set but not used'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount =  errCount + 1
       ENDIF

       IF ( errCount.GE.1 ) THEN
        WRITE(msgBuf,'(A,I3,A)')
     &       'OFFLINE_CHECK: detected', errCount,' fatal error(s)'
        CALL PRINT_ERROR( msgBuf, myThid )
        CALL ALL_PROC_DIE( 0 )
        STOP 'ABNORMAL END: S/R OFFLINE_CHECK'
       ENDIF

       WRITE(msgBuf,'(A)') 'OFFLINE_CHECK: done'
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                     SQUEEZE_RIGHT, myThid )

      _END_MASTER(myThid)

#endif /* ALLOW_OFFLINE */

      RETURN
      END

#include "PACKAGES_CONFIG.h"
#include "CPP_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: READ_PICKUP
C     !INTERFACE:
      SUBROUTINE READ_PICKUP(
     I                        myIter, myThid )

C     !DESCRIPTION:
C     This is the controlling routine for IO to read restart (or
C     "pickup" or "checkpoint" ) files.  It calls routines from other
C     packages (\textit{eg.} rw and mnc) to do the per-variable
C     reads.

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "RESTART.h"
#include "DYNVARS.h"
#include "NH_VARS.h"
#include "SURFACE.h"
#include "FFIELDS.h"
#ifdef ALLOW_GENERIC_ADVDIFF
# include "GAD.h"
#endif
#ifdef ALLOW_MNC
# include "MNC_PARAMS.h"
#endif
#if defined(ALLOW_EDDYPSI) && defined(ALLOW_GMREDI)
# include "GMREDI.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     myIter :: Iteration number
C     myThid :: my Thread Id. number
      INTEGER myIter
      INTEGER myThid
CEOP

C     !LOCAL VARIABLES:
C     fp          :: pickup-file precision
C     fn          :: Temp. for building file name.
C     suff        :: suffix of pickup file to read
C     filePrec    :: pickup-file precision (read from meta file)
C     nbFields    :: number of fields in pickup file (read from meta file)
C     missFldList :: List of missing fields   (attempted to read but not found)
C     missFldDim  :: Dimension of missing fields list array: missFldList
C     nMissing    :: Number of missing fields (attempted to read but not found)
C     m1, m2      :: 6.th dim index (AB-3) corresponding to time-step N-1 & N-2
C     j           :: loop index
C     nj          :: record number
C     ioUnit      :: temp for writing msg unit
C     msgBuf      :: Informational/error message buffer
      INTEGER fp
      CHARACTER*(MAX_LEN_FNAM) fn
      CHARACTER*(10) suff
      INTEGER filePrec, nbFields
      INTEGER missFldDim, nMissing
      PARAMETER( missFldDim = 20 )
      CHARACTER*(8) missFldList(missFldDim)
#ifdef ALLOW_ADAMSBASHFORTH_3
      INTEGER j, m1, m2
#endif
      INTEGER nj, ioUnit
      CHARACTER*(MAX_LEN_MBUF) msgBuf
#ifndef ALLOW_GENERIC_ADVDIFF
      LOGICAL AdamsBashforthGt
      LOGICAL AdamsBashforthGs
      LOGICAL AdamsBashforth_T
      LOGICAL AdamsBashforth_S
      PARAMETER ( AdamsBashforthGt = .FALSE. ,
     &            AdamsBashforthGs = .FALSE. ,
     &            AdamsBashforth_T = .FALSE. ,
     &            AdamsBashforth_S = .FALSE. )
#endif

C     Suffix for pickup files
      IF (pickupSuff .EQ. ' ') THEN
        IF ( rwSuffixType.EQ.0 ) THEN
          WRITE(suff,'(I10.10)') myIter
        ELSE
          CALL RW_GET_SUFFIX( suff, startTime, myIter, myThid )
        ENDIF
      ELSE
        WRITE(suff,'(A10)') pickupSuff
      ENDIF
      WRITE(fn,'(A,A10)') 'pickup.',suff

C     Going to really do some IO. Make everyone except master thread wait.
C     this is done within IO routines => no longer needed
c     _BARRIER

      IF (pickup_read_mdsio) THEN

       fp = precFloat64
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

       CALL READ_MFLDS_SET(
     I                      fn,
     O                      nbFields, filePrec,
     I                      Nr, myIter, myThid )

       _BEGIN_MASTER( myThid )
c      IF ( filePrec.NE.0 .AND. filePrec.NE.fp ) THEN
       IF ( nbFields.GE.0 .AND. filePrec.NE.fp ) THEN
         WRITE(msgBuf,'(2A,I4)') 'READ_PICKUP: ',
     &    'pickup-file binary precision do not match !'
         CALL PRINT_ERROR( msgBuf, myThid )
         WRITE(msgBuf,'(A,2(A,I4))') 'READ_PICKUP: ',
     &    'file prec.=', filePrec, ' but expecting prec.=', fp
         CALL PRINT_ERROR( msgBuf, myThid )
         STOP 'ABNORMAL END: S/R READ_PICKUP (data-prec Pb)'
       ENDIF
       _END_MASTER( myThid )

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

       IF ( nbFields.LE.0 ) THEN
C-      No meta-file or old meta-file without List of Fields
        ioUnit = errorMessageUnit
        IF ( pickupStrictlyMatch ) THEN
          WRITE(msgBuf,'(4A)') 'READ_PICKUP: ',
     &      'no field-list found in meta-file',
     &      ' => cannot check for strick-matching'
c         CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
          CALL PRINT_ERROR( msgBuf, myThid )
          WRITE(msgBuf,'(4A)') 'READ_PICKUP: ',
     &      'try with " pickupStrictlyMatch=.FALSE.,"',
     &      ' in file: "data", NameList: "PARM03"'
          CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
          STOP 'ABNORMAL END: S/R READ_PICKUP'
        ELSE
          WRITE(msgBuf,'(4A)') 'WARNING >> READ_PICKUP: ',
     &      ' no field-list found'
          CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
         IF ( nbFields.EQ.-1 ) THEN
C-      No meta-file
          WRITE(msgBuf,'(4A)') 'WARNING >> ',
     &      ' try to read pickup as currently written'
          CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
         ELSE
C-      Old meta-file without List of Fields
          WRITE(msgBuf,'(4A)') 'WARNING >> ',
     &      ' try to read pickup as it used to be written'
          CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
          WRITE(msgBuf,'(4A)') 'WARNING >> ',
     &      ' until checkpoint59i (2007 Oct 22)'
          CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
         ENDIF
        ENDIF
       ENDIF

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C---   Old way to read model fields:
       IF ( nbFields.EQ.0 ) THEN
        IF ( usePickupBeforeC54 ) THEN
#ifndef ALLOW_ADAMSBASHFORTH_3
          CALL READ_REC_3D_RL( fn, fp, Nr, uVel,  1, myIter,myThid )
          CALL READ_REC_3D_RL( fn, fp, Nr, gU,    2, myIter,myThid )
          CALL READ_REC_3D_RL( fn, fp, Nr, guNm1, 3, myIter,myThid )
          CALL READ_REC_3D_RL( fn, fp, Nr, vVel,  4, myIter,myThid )
          CALL READ_REC_3D_RL( fn, fp, Nr, gV,    5, myIter,myThid )
          CALL READ_REC_3D_RL( fn, fp, Nr, gvNm1, 6, myIter,myThid )
          CALL READ_REC_3D_RL( fn, fp, Nr, theta, 7, myIter,myThid )
c         CALL READ_REC_3D_RL( fn, fp, Nr, gT,    8, myIter,myThid )
          CALL READ_REC_3D_RL( fn, fp, Nr, gtNm1, 9, myIter,myThid )
          CALL READ_REC_3D_RL( fn, fp, Nr, salt, 10, myIter,myThid )
c         CALL READ_REC_3D_RL( fn, fp, Nr, gS,   11, myIter,myThid )
          CALL READ_REC_3D_RL( fn, fp, Nr, gsNm1,12, myIter,myThid )
#endif /*  ALLOW_ADAMSBASHFORTH_3 */
          CALL READ_REC_3D_RL( fn, fp,  1, etaN,
     &                                      12*Nr+1, myIter,myThid )
#ifdef NONLIN_FRSURF
          IF (nonlinFreeSurf .GE. 0) THEN
           CALL READ_REC_3D_RL(fn, fp,  1, etaH,
     &                                      12*Nr+2, myIter,myThid )
          ENDIF
#endif
        ELSE
#ifdef ALLOW_ADAMSBASHFORTH_3
          j = 3
          IF ( startFromPickupAB2 ) j = 2
          nj = 0
          CALL READ_REC_3D_RL( fn, fp, Nr, uVel, nj+1, myIter,myThid )
          CALL READ_REC_3D_RL( fn, fp, Nr, guNm(1-OLx,1-OLy,1,1,1,1),
     &                                           nj+2, myIter,myThid )
          CALL READ_REC_3D_RL( fn, fp, Nr, guNm(1-OLx,1-OLy,1,1,1,2),
     &                                           nj+j, myIter,myThid )
          nj = j
          CALL READ_REC_3D_RL( fn, fp, Nr, vVel, nj+1, myIter,myThid )
          CALL READ_REC_3D_RL( fn, fp, Nr, gvNm(1-OLx,1-OLy,1,1,1,1),
     &                                           nj+2, myIter,myThid )
          CALL READ_REC_3D_RL( fn, fp, Nr, gvNm(1-OLx,1-OLy,1,1,1,2),
     &                                           nj+j, myIter,myThid )
          nj = 2*j
          CALL READ_REC_3D_RL( fn, fp, Nr, theta,nj+1, myIter,myThid )
          CALL READ_REC_3D_RL( fn, fp, Nr, gtNm(1-OLx,1-OLy,1,1,1,1),
     &                                           nj+2, myIter,myThid )
          CALL READ_REC_3D_RL( fn, fp, Nr, gtNm(1-OLx,1-OLy,1,1,1,2),
     &                                           nj+j, myIter,myThid )
          nj = 3*j
          CALL READ_REC_3D_RL( fn, fp, Nr, salt, nj+1, myIter,myThid )
          CALL READ_REC_3D_RL( fn, fp, Nr, gsNm(1-OLx,1-OLy,1,1,1,1),
     &                                           nj+2, myIter,myThid )
          CALL READ_REC_3D_RL( fn, fp, Nr, gsNm(1-OLx,1-OLy,1,1,1,2),
     &                                           nj+j, myIter,myThid )
          nj = 4*j
#else /*  ALLOW_ADAMSBASHFORTH_3 */
          CALL READ_REC_3D_RL( fn, fp, Nr, uVel,  1, myIter,myThid )
          CALL READ_REC_3D_RL( fn, fp, Nr, guNm1, 2, myIter,myThid )
          CALL READ_REC_3D_RL( fn, fp, Nr, vVel,  3, myIter,myThid )
          CALL READ_REC_3D_RL( fn, fp, Nr, gvNm1, 4, myIter,myThid )
          CALL READ_REC_3D_RL( fn, fp, Nr, theta, 5, myIter,myThid )
          CALL READ_REC_3D_RL( fn, fp, Nr, gtNm1, 6, myIter,myThid )
          CALL READ_REC_3D_RL( fn, fp, Nr, salt,  7, myIter,myThid )
          CALL READ_REC_3D_RL( fn, fp, Nr, gsNm1, 8, myIter,myThid )
          nj = 8
#endif /*  ALLOW_ADAMSBASHFORTH_3 */
          CALL READ_REC_3D_RL( fn,fp,1, etaN, nj*Nr+1, myIter,myThid )
          IF ( exactConserv ) THEN
           CALL READ_REC_3D_RL(fn,fp,1,dEtaHdt,nj*Nr+2,myIter,myThid )
          ENDIF
          IF ( nonlinFreeSurf.GT.0 ) THEN
           CALL READ_REC_3D_RL(fn,fp,1, etaH, nj*Nr+3, myIter,myThid )
          ENDIF
        ENDIF

        IF ( storePhiHyd4Phys ) THEN
          WRITE(fn,'(A,A10)') 'pickup_ph.',suff
          CALL READ_REC_3D_RL( fn, fp, Nr, totPhiHyd,1,myIter,myThid )
        ENDIF
#ifdef ALLOW_NONHYDROSTATIC
        IF ( use3Dsolver ) THEN
          WRITE(fn,'(A,A10)') 'pickup_nh.',suff
          CALL READ_REC_3D_RL( fn, fp, Nr, phi_nh,  1, myIter,myThid )
#ifdef ALLOW_ADAMSBASHFORTH_3
          CALL READ_REC_3D_RL( fn, fp, Nr, gwNm(1-OLx,1-OLy,1,1,1,1),
     &                                              2, myIter,myThid )
          CALL READ_REC_3D_RL( fn, fp, Nr, gwNm(1-OLx,1-OLy,1,1,1,2),
     &                                              2, myIter,myThid )
#else /*  ALLOW_ADAMSBASHFORTH_3 */
          CALL READ_REC_3D_RL( fn, fp, Nr, gwNm1,   2, myIter,myThid )
#endif /*  ALLOW_ADAMSBASHFORTH_3 */
        ENDIF
#endif /* ALLOW_NONHYDROSTATIC */
       ELSE
C---   New way to read model fields:
          nj = 0
C---    read State 3-D fields for restart
          CALL READ_MFLDS_3D_RL( 'Uvel    ', uVel,
     &                                     nj, fp, Nr, myIter, myThid )
          CALL READ_MFLDS_3D_RL( 'Vvel    ', vVel,
     &                                     nj, fp, Nr, myIter, myThid )
#if defined(ALLOW_EDDYPSI) && defined(ALLOW_GMREDI)
          IF (GM_InMomAsStress) THEN
            CALL READ_MFLDS_3D_RL( 'UEulerM ', uEulerMean,
     &                                      nj, fp, Nr, myIter, myThid )
            CALL READ_MFLDS_3D_RL( 'VEulerM ', vEulerMean,
     &                                      nj, fp, Nr, myIter, myThid )
          ENDIF
#endif
          CALL READ_MFLDS_3D_RL( 'Theta   ', theta,
     &                                     nj, fp, Nr, myIter, myThid )
          CALL READ_MFLDS_3D_RL( 'Salt    ', salt,
     &                                     nj, fp, Nr, myIter, myThid )
C---    read 3-D fields for AB-restart
#ifdef ALLOW_ADAMSBASHFORTH_3

         m1 = 1 + MOD(myIter+1,2)
         m2 = 1 + MOD( myIter ,2)
        IF ( momStepping ) THEN
C--     U velocity:
         IF ( alph_AB.NE.0. .OR. beta_AB.NE.0. ) THEN
          CALL READ_MFLDS_3D_RL( 'GuNm1   ',guNm(1-OLx,1-OLy,1,1,1,m1),
     &                                     nj, fp, Nr, myIter, myThid )
         ENDIF
         IF ( beta_AB.NE.0. ) THEN
          CALL READ_MFLDS_3D_RL( 'GuNm2   ',guNm(1-OLx,1-OLy,1,1,1,m2),
     &                                     nj, fp, Nr, myIter, myThid )
         ENDIF
C--     V velocity:
         IF ( alph_AB.NE.0. .OR. beta_AB.NE.0. ) THEN
          CALL READ_MFLDS_3D_RL( 'GvNm1   ',gvNm(1-OLx,1-OLy,1,1,1,m1),
     &                                     nj, fp, Nr, myIter, myThid )
         ENDIF
         IF ( beta_AB.NE.0. ) THEN
          CALL READ_MFLDS_3D_RL( 'GvNm2   ',gvNm(1-OLx,1-OLy,1,1,1,m2),
     &                                     nj, fp, Nr, myIter, myThid )
         ENDIF
        ENDIF
C--     Temperature:
        IF ( AdamsBashforthGt ) THEN
         IF ( alph_AB.NE.0. .OR. beta_AB.NE.0. ) THEN
          CALL READ_MFLDS_3D_RL( 'GtNm1   ',gtNm(1-OLx,1-OLy,1,1,1,m1),
     &                                     nj, fp, Nr, myIter, myThid )
         ENDIF
         IF ( beta_AB.NE.0. ) THEN
          CALL READ_MFLDS_3D_RL( 'GtNm2   ',gtNm(1-OLx,1-OLy,1,1,1,m2),
     &                                     nj, fp, Nr, myIter, myThid )
         ENDIF
        ELSEIF ( AdamsBashforth_T ) THEN
         IF ( alph_AB.NE.0. .OR. beta_AB.NE.0. ) THEN
          CALL READ_MFLDS_3D_RL( 'TempNm1 ',gtNm(1-OLx,1-OLy,1,1,1,m1),
     &                                     nj, fp, Nr, myIter, myThid )
         ENDIF
         IF ( beta_AB.NE.0. ) THEN
          CALL READ_MFLDS_3D_RL( 'TempNm2 ',gtNm(1-OLx,1-OLy,1,1,1,m2),
     &                                     nj, fp, Nr, myIter, myThid )
         ENDIF
        ENDIF
C--     Salinity:
        IF ( AdamsBashforthGs ) THEN
         IF ( alph_AB.NE.0. .OR. beta_AB.NE.0. ) THEN
          CALL READ_MFLDS_3D_RL( 'GsNm1   ',gsNm(1-OLx,1-OLy,1,1,1,m1),
     &                                     nj, fp, Nr, myIter, myThid )
         ENDIF
         IF ( beta_AB.NE.0. ) THEN
          CALL READ_MFLDS_3D_RL( 'GsNm2   ',gsNm(1-OLx,1-OLy,1,1,1,m2),
     &                                     nj, fp, Nr, myIter, myThid )
         ENDIF
        ELSEIF ( AdamsBashforth_S ) THEN
         IF ( alph_AB.NE.0. .OR. beta_AB.NE.0. ) THEN
          CALL READ_MFLDS_3D_RL( 'SaltNm1 ',gsNm(1-OLx,1-OLy,1,1,1,m1),
     &                                     nj, fp, Nr, myIter, myThid )
         ENDIF
         IF ( beta_AB.NE.0. ) THEN
          CALL READ_MFLDS_3D_RL( 'SaltNm2 ',gsNm(1-OLx,1-OLy,1,1,1,m2),
     &                                     nj, fp, Nr, myIter, myThid )
         ENDIF
        ENDIF
#ifdef ALLOW_NONHYDROSTATIC
        IF ( nonHydrostatic ) THEN
C--     W velocity:
         IF ( alph_AB.NE.0. .OR. beta_AB.NE.0. ) THEN
          CALL READ_MFLDS_3D_RL( 'GwNm1   ',gwNm(1-OLx,1-OLy,1,1,1,m1),
     &                                     nj, fp, Nr, myIter, myThid )
         ENDIF
         IF ( beta_AB.NE.0. ) THEN
          CALL READ_MFLDS_3D_RL( 'GwNm2   ',gwNm(1-OLx,1-OLy,1,1,1,m2),
     &                                     nj, fp, Nr, myIter, myThid )
         ENDIF
        ENDIF
#endif /* ALLOW_NONHYDROSTATIC */
#ifdef ALLOW_QHYD_STAGGER_TS
C--     Quasi-Hydrostatic Adams-Bashforth variables:
        IF ( quasiHydrostatic .AND. staggerTimeStep ) THEN
         IF ( alph_AB.NE.0. .OR. beta_AB.NE.0. ) THEN
          CALL READ_MFLDS_3D_RL( 'QH_GwNm1',
     O                           QHydGwNm(1-OLx,1-OLy,1,1,1,m1),
     I                                     nj, fp, Nr, myIter, myThid )
         ENDIF
         IF ( beta_AB.NE.0. ) THEN
          CALL READ_MFLDS_3D_RL( 'QH_GwNm2',
     O                           QHydGwNm(1-OLx,1-OLy,1,1,1,m2),
     I                                     nj, fp, Nr, myIter, myThid )
         ENDIF
        ENDIF
#endif /* ALLOW_QHYD_STAGGER_TS */

#else /*  ALLOW_ADAMSBASHFORTH_3 */
        IF ( momStepping ) THEN
C--     U velocity:
          CALL READ_MFLDS_3D_RL( 'GuNm1   ', guNm1,
     &                                     nj, fp, Nr, myIter, myThid )
C--     V velocity:
          CALL READ_MFLDS_3D_RL( 'GvNm1   ', gvNm1,
     &                                     nj, fp, Nr, myIter, myThid )
        ENDIF
C--     Temperature
        IF ( AdamsBashforthGt ) THEN
          CALL READ_MFLDS_3D_RL( 'GtNm1   ', gtNm1,
     &                                     nj, fp, Nr, myIter, myThid )
        ELSEIF ( AdamsBashforth_T ) THEN
          CALL READ_MFLDS_3D_RL( 'TempNm1 ', gtNm1,
     &                                     nj, fp, Nr, myIter, myThid )
        ENDIF
C--     Salinity
        IF ( AdamsBashforthGs ) THEN
          CALL READ_MFLDS_3D_RL( 'GsNm1   ', gsNm1,
     &                                     nj, fp, Nr, myIter, myThid )
        ELSEIF ( AdamsBashforth_S ) THEN
          CALL READ_MFLDS_3D_RL( 'SaltNm1 ', gsNm1,
     &                                     nj, fp, Nr, myIter, myThid )
        ENDIF
#ifdef ALLOW_NONHYDROSTATIC
        IF ( nonHydrostatic ) THEN
          CALL READ_MFLDS_3D_RL( 'GwNm1   ', gwNm1,
     &                                     nj, fp, Nr, myIter, myThid )
        ENDIF
#endif /* ALLOW_NONHYDROSTATIC */
#ifdef ALLOW_QHYD_STAGGER_TS
C--     Quasi-Hydrostatic Adams-Bashforth variables:
        IF ( quasiHydrostatic .AND. staggerTimeStep ) THEN
          CALL READ_MFLDS_3D_RL( 'QH_GwNm1', QHydGwNm,
     &                                     nj, fp, Nr, myIter, myThid )
        ENDIF
#endif /* ALLOW_QHYD_STAGGER_TS */

#endif /*  ALLOW_ADAMSBASHFORTH_3 */

C-      read Full Pressure for EOS in pressure:
        IF ( storePhiHyd4Phys ) THEN
          CALL READ_MFLDS_3D_RL( 'PhiHyd  ', totPhiHyd,
     &                                     nj, fp, Nr, myIter, myThid )
        ENDIF
#ifdef ALLOW_NONHYDROSTATIC
        IF ( use3Dsolver ) THEN
          CALL READ_MFLDS_3D_RL( 'Phi_NHyd', phi_nh,
     &                                     nj, fp, Nr, myIter, myThid )
        ENDIF
#endif /* ALLOW_NONHYDROSTATIC */
#ifdef ALLOW_SMAG_3D_DIFFUSIVITY
C-    With synchronous time-stepping, Smag-3D diffusivity is lagging by 1 time-step
C     (i.e., used before being updated meaning field is from previous time-step calc)
C     --> needs to be read-in from pickup file
        IF ( smag3D_diffCoeff.GT.zeroRL
     &       .AND. .NOT.staggerTimeStep ) THEN
          CALL READ_MFLDS_3D_RL( 'SmagDiff', smag3D_diffK,
     &                                     nj, fp, Nr, myIter, myThid )
        ENDIF
#endif /* ALLOW_SMAG_3D_DIFFUSIVITY */
#ifdef ALLOW_ADDFLUID
C-    read mass source/sink of fluid
        IF ( selectAddFluid.GE.1 ) THEN
          CALL READ_MFLDS_3D_RL( 'AddMass ', addMass,
     &                                     nj, fp, Nr, myIter, myThid )
        ENDIF
#endif /* ALLOW_ADDFLUID */
#ifdef ALLOW_FRICTION_HEATING
C-    needs frictional heating when using synchronous time-stepping
        IF ( addFrictionHeating .AND. .NOT.staggerTimeStep ) THEN
          CALL READ_MFLDS_LEV_RS( 'FricHeat', frictionHeating,
     &                              nj, fp, Nr, 1, Nr, myIter, myThid )
        ENDIF
#endif /* ALLOW_FRICTION_HEATING */

C---    read 2-D fields, starting with Eta:
          nj = nj*Nr
          CALL READ_MFLDS_3D_RL( 'EtaN    ', etaN,
     &                                     nj, fp, 1 , myIter, myThid )
        IF ( usingPCoords .AND. useSEAICE ) THEN
          CALL READ_MFLDS_3D_RL( 'Phi_rLow', phiHydLow,
     &                                     nj, fp, 1 , myIter, myThid )
        ENDIF
#ifdef ALLOW_NONHYDROSTATIC
        IF ( selectNHfreeSurf.GE.1 ) THEN
          CALL READ_MFLDS_3D_RL( 'dPhiNH  ', dPhiNH,
     &                                     nj, fp, 1 , myIter, myThid )
        ENDIF
#endif /* ALLOW_NONHYDROSTATIC */
        IF ( exactConserv ) THEN
          CALL READ_MFLDS_3D_RL( 'dEtaHdt ', dEtaHdt,
     &                                     nj, fp, 1 , myIter, myThid )
        ENDIF
        IF ( nonlinFreeSurf.GT.0 ) THEN
          CALL READ_MFLDS_3D_RL( 'EtaH    ', etaH,
     &                                     nj, fp, 1 , myIter, myThid )
        ENDIF
C--    end: new way to read pickup file
       ENDIF

C--    Check for missing fields:
       nMissing = missFldDim
       CALL READ_MFLDS_CHECK(
     O                    missFldList,
     U                    nMissing,
     I                    myIter, myThid )
       IF ( nMissing.GT.missFldDim ) THEN
         WRITE(msgBuf,'(2A,I4)') 'READ_PICKUP: ',
     &     'missing fields list has been truncated to', missFldDim
         CALL PRINT_ERROR( msgBuf, myThid )
         STOP 'ABNORMAL END: S/R READ_PICKUP (list-size Pb)'
       ENDIF
       CALL CHECK_PICKUP(
     I                    missFldList,
     I                    nMissing, nbFields,
     I                    myIter, myThid )

C--   end: pickup_read_mdsio
      ENDIF

#ifdef ALLOW_MNC
      IF (useMNC .AND. pickup_read_mnc) THEN
        WRITE(fn,'(A)') 'pickup'
        CALL MNC_FILE_CLOSE_ALL_MATCHING(fn, myThid)
        CALL MNC_CW_SET_UDIM(fn, 1, myThid)
        CALL MNC_CW_SET_CITER(fn, 3, 3, myIter, -1, myThid)
        CALL MNC_CW_RL_R('D',fn,0,0,'U',uVel, myThid)
        CALL MNC_CW_RL_R('D',fn,0,0,'V',vVel, myThid)
#if defined(ALLOW_EDDYPSI) && defined(ALLOW_GMREDI)
        IF (GM_InMomAsStress) THEN
          CALL MNC_CW_RL_R('D',fn,0,0,'UEulerM',uEulerMean, myThid)
          CALL MNC_CW_RL_R('D',fn,0,0,'VEulerM',vEulerMean, myThid)
        ENDIF
#endif
        CALL MNC_CW_RL_R('D',fn,0,0,'Temp',theta, myThid)
        CALL MNC_CW_RL_R('D',fn,0,0,'S',salt, myThid)
        CALL MNC_CW_RL_R('D',fn,0,0,'Eta',etaN, myThid)
#ifndef ALLOW_ADAMSBASHFORTH_3
        CALL MNC_CW_RL_R('D',fn,0,0,'gUnm1',guNm1, myThid)
        CALL MNC_CW_RL_R('D',fn,0,0,'gVnm1',gvNm1, myThid)
        CALL MNC_CW_RL_R('D',fn,0,0,'gTnm1',gtNm1, myThid)
        CALL MNC_CW_RL_R('D',fn,0,0,'gSnm1',gsNm1, myThid)
#endif /* ALLOW_ADAMSBASHFORTH_3 */
C#ifdef NONLIN_FRSURF
C        IF ( nonlinFreeSurf.GE.0 .AND. usePickupBeforeC54 )
C     &    CALL MNC_CW_RL_R('D',fn,0,0,'EtaH', etaH, myThid)
C#endif
        IF (exactConserv) THEN
          CALL MNC_CW_RL_R('D',fn,0,0,'dEtaHdt',dEtaHdt,myThid)
        ENDIF
        IF (nonlinFreeSurf .GT. 0) THEN
          CALL MNC_CW_RL_R('D',fn,0,0,'EtaH', etaH, myThid)
        ENDIF
#ifdef ALLOW_NONHYDROSTATIC
        IF (use3Dsolver) THEN
          CALL MNC_CW_RL_R('D',fn,0,0,'phi_nh', phi_nh, myThid)
c         CALL MNC_CW_RL_R('D',fn,0,0,'gW', gW, myThid)
#ifndef ALLOW_ADAMSBASHFORTH_3
          CALL MNC_CW_RL_R('D',fn,0,0,'gWnm1', gwNm1, myThid)
#endif
        ENDIF
#endif /*  ALLOW_NONHYDROSTATIC */
        IF ( storePhiHyd4Phys ) THEN
          CALL MNC_CW_RL_R('D',fn,0,0,'phiHyd',totPhiHyd,myThid)
        ENDIF
      ENDIF
#endif /*  ALLOW_MNC  */

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C     Fill in edge regions
      CALL EXCH_UV_3D_RL( uVel, vVel, .TRUE., Nr, myThid )
#if defined(ALLOW_EDDYPSI) && defined(ALLOW_GMREDI)
      IF (GM_InMomAsStress) THEN
        CALL EXCH_UV_3D_RL( uEulerMean, vEulerMean, .TRUE., Nr, myThid )
      ENDIF
#endif
      CALL EXCH_3D_RL( theta, Nr, myThid )
      CALL EXCH_3D_RL( salt,  Nr, myThid )
#ifdef ALLOW_ADAMSBASHFORTH_3
      CALL EXCH_UV_3D_RL( guNm(1-OLx,1-OLy,1,1,1,1),
     &                    gvNm(1-OLx,1-OLy,1,1,1,1),.TRUE.,Nr,myThid )
      CALL EXCH_UV_3D_RL( guNm(1-OLx,1-OLy,1,1,1,2),
     &                    gvNm(1-OLx,1-OLy,1,1,1,2),.TRUE.,Nr,myThid )
      CALL EXCH_3D_RL( gtNm(1-OLx,1-OLy,1,1,1,1), Nr, myThid )
      CALL EXCH_3D_RL( gtNm(1-OLx,1-OLy,1,1,1,2), Nr, myThid )
      CALL EXCH_3D_RL( gsNm(1-OLx,1-OLy,1,1,1,1), Nr, myThid )
      CALL EXCH_3D_RL( gsNm(1-OLx,1-OLy,1,1,1,2), Nr, myThid )
#else /* ALLOW_ADAMSBASHFORTH_3 */
      CALL EXCH_UV_3D_RL( guNm1, gvNm1, .TRUE., Nr, myThid )
      CALL EXCH_3D_RL( gtNm1, Nr, myThid )
      CALL EXCH_3D_RL( gsNm1, Nr, myThid )
#endif /* ALLOW_ADAMSBASHFORTH_3 */
      CALL EXCH_XY_RL( etaN, myThid )
      CALL EXCH_XY_RL( etaH, myThid )
      CALL EXCH_XY_RL( detaHdt, myThid )

      IF ( storePhiHyd4Phys )
     &  CALL EXCH_3D_RL( totPhiHyd, Nr, myThid )
      IF ( usingPCoords .AND. useSEAICE )
     &  CALL EXCH_XY_RL( phiHydLow, myThid )

#ifdef ALLOW_NONHYDROSTATIC
      IF ( use3Dsolver ) THEN
        CALL EXCH_3D_RL( phi_nh, Nr, myThid )
      ENDIF
      IF ( nonHydrostatic ) THEN
#ifdef ALLOW_ADAMSBASHFORTH_3
        CALL EXCH_3D_RL( gwNm(1-OLx,1-OLy,1,1,1,1), Nr, myThid )
        CALL EXCH_3D_RL( gwNm(1-OLx,1-OLy,1,1,1,2), Nr, myThid )
#else /* ALLOW_ADAMSBASHFORTH_3 */
        CALL EXCH_3D_RL( gwNm1,  Nr, myThid )
#endif /* ALLOW_ADAMSBASHFORTH_3 */
      ENDIF
      IF ( selectNHfreeSurf.GE.1 ) THEN
        CALL EXCH_XY_RL( dPhiNH, myThid )
      ENDIF
#endif /* ALLOW_NONHYDROSTATIC */
#ifdef ALLOW_QHYD_STAGGER_TS
      IF ( quasiHydrostatic .AND. staggerTimeStep ) THEN
#ifdef ALLOW_ADAMSBASHFORTH_3
        CALL EXCH_3D_RL( QHydGwNm(1-OLx,1-OLy,1,1,1,1), Nr, myThid )
        CALL EXCH_3D_RL( QHydGwNm(1-OLx,1-OLy,1,1,1,2), Nr, myThid )
#else /* ALLOW_ADAMSBASHFORTH_3 */
        CALL EXCH_3D_RL( QHydGwNm, Nr, myThid )
#endif /* ALLOW_ADAMSBASHFORTH_3 */
      ENDIF
#endif /* ALLOW_QHYD_STAGGER_TS */

      RETURN
      END

#include "THSICE_OPTIONS.h"
#ifdef ALLOW_SALT_PLUME
# include "SALT_PLUME_OPTIONS.h"
#endif

CBOP
C     !ROUTINE: THSICE_SALT_PLUME
C     !INTERFACE:
      SUBROUTINE THSICE_SALT_PLUME(
     I                  sOce,
     I                  frzSeaWat,
     I                  iMin,iMax, jMin,jMax, bi, bj,
     I                  myTime, myIter, myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE THSICE_SALT_PLUME
C     | o Interface Routine to pkg/salt_plume:
C     |   Fill in saltPlumeFlux array (see SALT_PLUME.h)
C     *==========================================================*
C     \ev
C     !USES:
      IMPLICIT NONE

C     === Global variables ===
#include "EEPARAMS.h"
#include "SIZE.h"
#include "PARAMS.h"
#include "THSICE_PARAMS.h"
#ifdef ALLOW_SALT_PLUME
# include "SALT_PLUME.h"
#endif
#ifdef ALLOW_ATM_COMPON_INTERF
# include "CPL_PARAMS.h"
# include "ATMCPL.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     sOce       :: surface level oceanic salinity [g/kg]
C     frzSeaWat  :: seawater freezing rate (expressed as mass flux) [kg/m^2/s]
C     iMin,iMax  :: computation domain: 1rst index range
C     jMin,jMax  :: computation domain: 2nd  index range
C     bi,bj      :: tile indices
C     myTime     :: current Time of simulation [s]
C     myIter     :: current Iteration number in simulation
C     myThid     :: my Thread Id number
      _RL     sOce     (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL     frzSeaWat(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER iMin, iMax
      INTEGER jMin, jMax
      INTEGER bi,bj
      _RL     myTime
      INTEGER myIter
      INTEGER myThid
CEOP

#if defined(ALLOW_SALT_PLUME) || defined(ALLOW_ATM_COMPON_INTERF)
C     !LOCAL VARIABLES:
      LOGICAL fillCplVar
      INTEGER i,j
      _RL locVar(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
#ifdef ALLOW_ATM_COMPON_INTERF
      _RL cplTimeFraction
#endif

      fillCplVar = .FALSE.
#ifdef ALLOW_ATM_COMPON_INTERF
      IF ( useCoupler ) fillCplVar = atm_cplExch_SaltPl
#endif

      IF ( useSALT_PLUME .OR. fillCplVar ) THEN
C-    Initialisation:
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
           locVar(i,j) = 0. _d 0
         ENDDO
        ENDDO
C-    salt rejected when seawater freeze (frw2oc < 0, frzSeaWat > 0):
        DO j = jMin, jMax
         DO i = iMin, iMax
           locVar(i,j) = frzSeaWat(i,j)*( sOce(i,j) - saltIce )
         ENDDO
        ENDDO
      ENDIF

#ifdef ALLOW_SALT_PLUME
      IF ( useSALT_PLUME ) THEN
C-    Take a fraction of it to store in saltPlumeFlux ; used for
C     vertical redistribution in water column (see pkg in Salt-Plume)
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
           saltPlumeFlux(i,j,bi,bj) = locVar(i,j)*SPsalFRAC
         ENDDO
        ENDDO
      ENDIF
#endif /* ALLOW_SALT_PLUME */

#ifdef ALLOW_ATM_COMPON_INTERF
      IF ( fillCplVar ) THEN
C-    Cumulate salt-flux for export to Coupler interface
C Note: SPsalFRAC will be applied when Ocean Compon is applying
C       CPL-imported field to saltPlumeFlux in S/R SALT_PLUME_DO_EXCH
        cplTimeFraction = 1. _d 0 / DFLOAT(cplSendFrq_iter)
        saltPlmFlxTime(bi,bj) = saltPlmFlxTime(bi,bj) + cplTimeFraction
        DO j=1,sNy
         DO i=1,sNx
           saltPlmFlx_cpl(i,j,bi,bj) = saltPlmFlx_cpl(i,j,bi,bj)
     &                               + locVar(i,j)*cplTimeFraction
         ENDDO
        ENDDO
      ENDIF
#endif

#endif /* ALLOW_SALT_PLUME or ALLOW_ATM_COMPON_INTERF */

      RETURN
      END

#include "GAD_OPTIONS.h"

CBOP
C     !ROUTINE: GAD_SOM_PREP_CS_CORNER
C     !INTERFACE:
      SUBROUTINE GAD_SOM_PREP_CS_CORNER(
     U           smVol, smTr0, smTr, smCorners,
     I           prep4dirX, overlapOnly, interiorOnly,
     I           N_edge, S_edge, E_edge, W_edge,
     I           iPass, k, myNz, bi, bj, myThid )


C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE GAD_SOM_PREP_CS_CORNER
C     | o Prepare for Horizontal SOM Advection :
C     |   when using Cubed-Sphere Grid, fill corner-halo regions
C     |   of all Tracer-moments with proper values
C     *==========================================================*
C     \ev
C     !USES:
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "GAD.h"

C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
C     smVol      :: grid-cell volume
C     smTr0      :: tracer Zero Order moment
C     smTr       :: tracer 1rst & 2nd Order moments
C     smCorners  :: Temporary storage of Corner-halo-regions values
C                   ( 3rd dim = Number of corners = 4 : SW, SE, NE, NW )
C     prep4dirX  :: True = prepare for X direction advection
C                   otherwise, prepare for Y direction advection.
C  overlapOnly   :: only update the edges of myTile, but not the interior
C  interiorOnly  :: only update the interior of myTile, but not the edges
C [N,S,E,W]_edge :: true if N,S,E,W edge of myTile is an Edge of the cube
C     iPass      :: current passage index in SOM_ADVECT
C     k          :: current level index
C     myNz       :: 3rd dimension of array to exchange
C     bi,bj      :: current tile indices
C     myThid     :: my Thread Id number
      INTEGER myNz
      _RL     smVol(1-OLx:sNx+OLx,1-OLy:sNy+OLy,myNz)
      _RL     smTr0(1-OLx:sNx+OLx,1-OLy:sNy+OLy,myNz)
      _RL     smTr (1-OLx:sNx+OLx,1-OLy:sNy+OLy,myNz,nSx,nSy,nSOM)
      _RL     smCorners(OLx,OLy,4,-1:nSOM)
      LOGICAL prep4dirX, overlapOnly, interiorOnly
      LOGICAL N_edge, S_edge, E_edge, W_edge
      INTEGER iPass, k, bi, bj
      INTEGER myThid
CEOP

C     !LOCAL VARIABLES:
C     === Local variables ===
      INTEGER i,j, jPass, n
      LOGICAL southWestCorner
      LOGICAL southEastCorner
      LOGICAL northEastCorner
      LOGICAL northWestCorner

      southWestCorner = S_edge .AND. W_edge
      southEastCorner = S_edge .AND. E_edge
      northEastCorner = N_edge .AND. E_edge
      northWestCorner = N_edge .AND. W_edge

      IF ( overlapOnly ) THEN
C--   to avoid repeating 2 times the full sequence of FILL_CS_CORNER calls,
C     add a loop on jPass (from iPass to 2) to reproduce the following logic:
C     1 ) overlapOnly & iPass = 1  (face 3 & 6)
C         - fill corners for the other direction
C         - then store the corner values
C     2 ) IF overlapOnly           :: fill corners for the current direction
C         ELSEIF .NOT.interiorOnly :: get the corner values back from storage
C         ENDIF
       DO jPass = iPass,2

        IF ( ( jPass.EQ.2 .AND. prep4dirX ) .OR.
     &       ( jPass.EQ.1 .AND. .NOT.prep4dirX ) ) THEN
C--   Fill corners to prepare for calculations in X
          CALL GAD_SOM_FILL_CS_CORNER( .TRUE.,
     U                                 smVol(1-OLx,1-OLy,k),
     U                                 smTr0(1-OLx,1-OLy,k),
     U                                 smTr(1-OLx,1-OLy,k,bi,bj,1),
     U                                 smTr(1-OLx,1-OLy,k,bi,bj,2),
     U                                 smTr(1-OLx,1-OLy,k,bi,bj,3),
     U                                 smTr(1-OLx,1-OLy,k,bi,bj,4),
     U                                 smTr(1-OLx,1-OLy,k,bi,bj,5),
     U                                 smTr(1-OLx,1-OLy,k,bi,bj,6),
     U                                 smTr(1-OLx,1-OLy,k,bi,bj,7),
     U                                 smTr(1-OLx,1-OLy,k,bi,bj,8),
     U                                 smTr(1-OLx,1-OLy,k,bi,bj,9),
     I                                 bi, bj, myThid )
C--   End of filling for X dir
c       ENDIF

        ELSE
C Note: the 2 IF tests are equivalent to just 1 if/else test;
C       use this later option and leave the former commented.

c       IF ( ( jPass.EQ.1 .AND. prep4dirX ) .OR.
c    &       ( jPass.EQ.2 .AND. .NOT.prep4dirX ) ) THEN
C--   Fill corners to prepare for calculations in Y
          CALL GAD_SOM_FILL_CS_CORNER( .FALSE.,
     U                                 smVol(1-OLx,1-OLy,k),
     U                                 smTr0(1-OLx,1-OLy,k),
     U                                 smTr(1-OLx,1-OLy,k,bi,bj,1),
     U                                 smTr(1-OLx,1-OLy,k,bi,bj,2),
     U                                 smTr(1-OLx,1-OLy,k,bi,bj,3),
     U                                 smTr(1-OLx,1-OLy,k,bi,bj,4),
     U                                 smTr(1-OLx,1-OLy,k,bi,bj,5),
     U                                 smTr(1-OLx,1-OLy,k,bi,bj,6),
     U                                 smTr(1-OLx,1-OLy,k,bi,bj,7),
     U                                 smTr(1-OLx,1-OLy,k,bi,bj,8),
     U                                 smTr(1-OLx,1-OLy,k,bi,bj,9),
     I                                 bi, bj, myThid )
C--   End of filling for Y dir
        ENDIF

        IF ( jPass.EQ.1 ) THEN
C--   Store corner values (to be used on the next iPass)
         IF ( southWestCorner ) THEN
          DO j=1,OLy
           DO i=1,OLx
            smCorners(i,j,1,-1) = smVol(i-OLx,j-OLy,k)
            smCorners(i,j,1, 0) = smTr0(i-OLx,j-OLy,k)
            DO n=1,nSOM
             smCorners(i,j,1,n) = smTr (i-OLx,j-OLy,k,bi,bj,n)
            ENDDO
           ENDDO
          ENDDO
         ENDIF
         IF ( southEastCorner ) THEN
          DO j=1,OLy
           DO i=1,OLx
            smCorners(i,j,2,-1) = smVol(sNx+i,j-OLy,k)
            smCorners(i,j,2, 0) = smTr0(sNx+i,j-OLy,k)
            DO n=1,nSOM
             smCorners(i,j,2,n) = smTr (sNx+i,j-OLy,k,bi,bj,n)
            ENDDO
           ENDDO
          ENDDO
         ENDIF
         IF ( northEastCorner ) THEN
          DO j=1,OLy
           DO i=1,OLx
            smCorners(i,j,3,-1) = smVol(sNx+i,sNy+j,k)
            smCorners(i,j,3, 0) = smTr0(sNx+i,sNy+j,k)
            DO n=1,nSOM
             smCorners(i,j,3,n) = smTr (sNx+i,sNy+j,k,bi,bj,n)
            ENDDO
           ENDDO
          ENDDO
         ENDIF
         IF ( northWestCorner ) THEN
          DO j=1,OLy
           DO i=1,OLx
            smCorners(i,j,4,-1) = smVol(i-OLx,sNy+j,k)
            smCorners(i,j,4, 0) = smTr0(i-OLx,sNy+j,k)
            DO n=1,nSOM
             smCorners(i,j,4,n) = smTr (i-OLx,sNy+j,k,bi,bj,n)
            ENDDO
           ENDDO
          ENDDO
         ENDIF
C--   End storing block
        ENDIF

C--   End of loop on jPass
       ENDDO

      ELSEIF ( .NOT.interiorOnly ) THEN

C--   Get back corner values from storage
        IF ( southWestCorner ) THEN
          DO j=1,OLy
           DO i=1,OLx
            smVol(i-OLx,j-OLy,k )        = smCorners(i,j,1,-1)
            smTr0(i-OLx,j-OLy,k )        = smCorners(i,j,1, 0)
            DO n=1,nSOM
             smTr(i-OLx,j-OLy,k,bi,bj,n) = smCorners(i,j,1, n)
            ENDDO
           ENDDO
          ENDDO
        ENDIF
        IF ( southEastCorner ) THEN
          DO j=1,OLy
           DO i=1,OLx
            smVol(sNx+i,j-OLy,k )        = smCorners(i,j,2,-1)
            smTr0(sNx+i,j-OLy,k )        = smCorners(i,j,2, 0)
            DO n=1,nSOM
             smTr(sNx+i,j-OLy,k,bi,bj,n) = smCorners(i,j,2, n)
            ENDDO
           ENDDO
          ENDDO
        ENDIF
        IF ( northEastCorner ) THEN
          DO j=1,OLy
           DO i=1,OLx
            smVol(sNx+i,sNy+j,k )        = smCorners(i,j,3,-1)
            smTr0(sNx+i,sNy+j,k )        = smCorners(i,j,3, 0)
            DO n=1,nSOM
             smTr(sNx+i,sNy+j,k,bi,bj,n) = smCorners(i,j,3, n)
            ENDDO
           ENDDO
          ENDDO
        ENDIF
        IF ( northWestCorner ) THEN
          DO j=1,OLy
           DO i=1,OLx
            smVol(i-OLx,sNy+j,k )        = smCorners(i,j,4,-1)
            smTr0(i-OLx,sNy+j,k )        = smCorners(i,j,4, 0)
            DO n=1,nSOM
             smTr(i-OLx,sNy+j,k,bi,bj,n) = smCorners(i,j,4, n)
            ENDDO
           ENDDO
          ENDDO
        ENDIF
C--   End getting back corner values from storage

C---  End if/else - overlapOnly - block
      ENDIF

      RETURN
      END

#include "PACKAGES_CONFIG.h"
#include "CPP_EEOPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: FILL_CS_CORNER_TR_RL

C     !INTERFACE:
      SUBROUTINE FILL_CS_CORNER_TR_RL(
     I     fill4dir, withSigns,
     U     trFld,
     I     bi,bj, myThid)

C     !DESCRIPTION:
C     *==========================================================*
C     | SUBROUTINE FILL_CS_CORNER_TR_RL
C     | o Fill the corner-halo region of CS-grid,
C     |   for a tracer variable (center of grid cell)
C     *==========================================================*
C     | o the corner halo region is filled with valid values
C     |   in order to compute (later on) gradient in X or Y
C     |   direction on a wide stencil.
C     *==========================================================*

C     !USES:
      IMPLICIT NONE

C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#ifdef ALLOW_EXCH2
#include "W2_EXCH2_SIZE.h"
#include "W2_EXCH2_TOPOLOGY.h"
#endif /* ALLOW_EXCH2 */

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C
C     fill4dir  :: = 0 fill corner with zeros
C                  = 1 copy to prepare for X direction calculations
C                  = 2 copy to prepare for Y direction calculations
C                  = 3 fill corner with averaged value
C     withSigns :: True = account for sign of X & Y directions
C     trFld     :: tracer field array with empty corners to fill
C     bi,bj     :: tile indices
C     myThid    :: thread number
      INTEGER fill4dir
      LOGICAL withSigns
      _RL trFld(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER bi,bj
      INTEGER myThid

C     !LOCAL VARIABLES:
C     == Local variables ==
C      i,j           :: loop indices
C      myTile        :: tile number
      INTEGER i,j
      LOGICAL southWestCorner
      LOGICAL southEastCorner
      LOGICAL northWestCorner
      LOGICAL northEastCorner
      _RL     negOne
#ifdef ALLOW_EXCH2
      INTEGER myTile
#endif
CEOP

      negOne = 1.
      IF (withSigns) negOne = -1.

      IF (useCubedSphereExchange) THEN

#ifdef ALLOW_EXCH2
       myTile = W2_myTileList(bi,bj)
       southWestCorner = exch2_isWedge(myTile).EQ.1
     &             .AND. exch2_isSedge(myTile).EQ.1
       southEastCorner = exch2_isEedge(myTile).EQ.1
     &             .AND. exch2_isSedge(myTile).EQ.1
       northEastCorner = exch2_isEedge(myTile).EQ.1
     &             .AND. exch2_isNedge(myTile).EQ.1
       northWestCorner = exch2_isWedge(myTile).EQ.1
     &             .AND. exch2_isNedge(myTile).EQ.1
#else
       southWestCorner = .TRUE.
       southEastCorner = .TRUE.
       northWestCorner = .TRUE.
       northEastCorner = .TRUE.
#endif

       IF ( fill4dir .EQ. 0 ) THEN
C--    Just fill corner with zero (e.g., used for 6 tracer points average)

         IF ( southWestCorner ) THEN
          DO j=1,OLy
           DO i=1,OLx
            trFld( 1-i , 1-j ) = 0. _d 0
           ENDDO
          ENDDO
         ENDIF
         IF ( southEastCorner ) THEN
          DO j=1,OLy
           DO i=1,OLx
            trFld(sNx+i, 1-j ) = 0. _d 0
           ENDDO
          ENDDO
         ENDIF
         IF ( northWestCorner ) THEN
          DO j=1,OLy
           DO i=1,OLx
            trFld( 1-i ,sNy+j) = 0. _d 0
           ENDDO
          ENDDO
         ENDIF
         IF ( northEastCorner ) THEN
          DO j=1,OLy
           DO i=1,OLx
            trFld(sNx+i,sNy+j) = 0. _d 0
           ENDDO
          ENDDO
         ENDIF

       ELSEIF ( fill4dir .EQ. 1 ) THEN
C--    Internal exchange for calculations in X

C-     For cube face corners we need to duplicate the
C-     i-1 and i+1 values into the null space as follows:
C
C
C      o NW corner: copy T(    0,sNy  ) into T(    0,sNy+1) e.g.
C                      |
C         x T(0,sNy+1) |
C        /\            |
C      --||------------|-----------
C        ||            |
C         x T(0,sNy)   |   x T(1,sNy)
C                      |
C
C      o SW corner: copy T(0,1) into T(0,0) e.g.
C                      |
C         x T(0,1)     |  x T(1,1)
C        ||            |
C      --||------------|-----------
C        \/            |
C         x T(0,0)     |
C                      |
C
C      o NE corner: copy T(sNx+1,sNy  ) into T(sNx+1,sNy+1) e.g.
C                      |
C                      |   x T(sNx+1,sNy+1)
C                      |  /\
C      ----------------|--||-------
C                      |  ||
C         x T(sNx,sNy) |   x T(sNx+1,sNy  )
C                      |
C      o SE corner: copy T(sNx+1,1    ) into T(sNx+1,0    ) e.g.
C                      |
C         x T(sNx,1)   |   x T(sNx+1,    1)
C                      |  ||
C      ----------------|--||-------
C                      |  \/
C                      |   x T(sNx+1,    0)
         IF ( southWestCorner ) THEN
          DO j=1,OLy
           DO i=1,OLx
            trFld( 1-i , 1-j ) = negOne*trFld( 1-j , i  )
           ENDDO
          ENDDO
         ENDIF
         IF ( southEastCorner ) THEN
          DO j=1,OLy
           DO i=1,OLx
            trFld(sNx+i, 1-j ) = negOne*trFld(sNx+j, i  )
           ENDDO
          ENDDO
         ENDIF
         IF ( northWestCorner ) THEN
          DO j=1,OLy
           DO i=1,OLx
            trFld( 1-i ,sNy+j) = negOne*trFld( 1-j , sNy+1-i )
           ENDDO
          ENDDO
         ENDIF
         IF ( northEastCorner ) THEN
          DO j=1,OLy
           DO i=1,OLx
            trFld(sNx+i,sNy+j) = negOne*trFld(sNx+j, sNy+1-i )
           ENDDO
          ENDDO
         ENDIF

C--   End of X direction ; start Y direction case.

       ELSEIF ( fill4dir .EQ. 2 ) THEN
C--    Internal exchange for calculations in Y

C-     For cube face corners we need to duplicate the
C-     j-1 and j+1 values into the null space as follows:
C
C      o SW corner: copy T(0,1) into T(0,0) e.g.
C                      |
C                      |  x T(1,1)
C                      |
C      ----------------|-----------
C                      |
C         x T(0,0)<====== x T(1,0)
C                      |
C
C      o NW corner: copy T(    0,sNy  ) into T(    0,sNy+1) e.g.
C                      |
C         x T(0,sNy+1)<=== x T(1,sNy+1)
C                      |
C      ----------------|-----------
C                      |
C                      |   x T(1,sNy)
C                      |
C
C      o NE corner: copy T(sNx+1,sNy  ) into T(sNx+1,sNy+1) e.g.
C                      |
C      x T(sNx,sNy+1)=====>x T(sNx+1,sNy+1)
C                      |
C      ----------------|-----------
C                      |
C      x T(sNx,sNy)    |
C                      |
C      o SE corner: copy T(sNx+1,1    ) into T(sNx+1,0    ) e.g.
C                      |
C         x T(sNx,1)   |
C                      |
C      ----------------|-----------
C                      |
C         x T(sNx,0) =====>x T(sNx+1,    0)
         IF ( southWestCorner ) THEN
          DO j=1,Oly
           DO i=1,Olx
            trFld( 1-i , 1-j ) = negOne*trFld(   j   , 1-i )
           ENDDO
          ENDDO
         ENDIF
         IF ( southEastCorner ) THEN
          DO j=1,Oly
           DO i=1,Olx
            trFld(sNx+i, 1-j ) = negOne*trFld(sNx+1-j, 1-i )
           ENDDO
          ENDDO
         ENDIF
         IF ( northWestCorner ) THEN
          DO j=1,Oly
           DO i=1,Olx
            trFld( 1-i ,sNy+j) = negOne*trFld(   j   ,sNy+i)
           ENDDO
          ENDDO
         ENDIF
         IF ( northEastCorner ) THEN
          DO j=1,Oly
           DO i=1,Olx
            trFld(sNx+i,sNy+j) = negOne*trFld(sNx+1-j,sNy+i)
           ENDDO
          ENDDO
         ENDIF

C-     End of Y direction case.
       ELSE
         STOP 'FILL_CS_CORNER_TR_RL: fill4dir has illegal value'
       ENDIF

C--   End useCubedSphereExchange
      ENDIF

      RETURN
      END

#include "MONITOR_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: MON_WRITESTATS_RS

C     !INTERFACE:
      SUBROUTINE MON_WRITESTATS_RS(
     I     myNr, arr, arrName,
     I     arrhFac, arrMask, arrArea, arrDr,
     O     arrStats,
     I     myThid )

C     !DESCRIPTION:
C     Compute the statistics of global array "\_RS arr" (account for
C     volume and mask) and write them to STDOUT with label "arrName".

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "MONITOR.h"

C     !INPUT PARAMETERS:
      INTEGER myNr
      _RS arr    (1-OLx:sNx+OLx,1-OLy:sNy+OLy,myNr,nSx,nSy)
      _RS arrhFac(1-OLx:sNx+OLx,1-OLy:sNy+OLy,myNr,nSx,nSy)
      _RS arrMask(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RS arrArea(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RS arrDr(myNr)
      CHARACTER*(*) arrName
      INTEGER myThid

C     !OUTPUT PARAMETERS:
C     arrStats :: statistics of the global array (min, max ...)
      _RL arrStats(*)
CEOP

C     !LOCAL VARIABLES:
      _RL theMin, theMax, theMean, theSD, theDel2, theVol

      CALL MON_CALC_STATS_RS(
     I     myNr, arr, arrhFac, arrMask, arrArea, arrDr,
     O     theMin, theMax, theMean, theSD, theDel2, theVol,
     I     myThid )

      arrStats(1) = theMin
      arrStats(2) = theMax
      arrStats(3) = theMean
      arrStats(4) = theSD
      arrStats(5) = theDel2
      arrStats(6) = theVol

      CALL MON_OUT_RL( arrName, theMax,  mon_foot_max,  myThid )
      CALL MON_OUT_RL( arrName, theMin,  mon_foot_min,  myThid )
      CALL MON_OUT_RL( arrName, theMean, mon_foot_mean, myThid )
      CALL MON_OUT_RL( arrName, theSD,   mon_foot_sd,   myThid )
      CALL MON_OUT_RL( arrName, theDel2, mon_foot_del2, myThid )
c     CALL MON_OUT_RL( arrName, theVol,  mon_foot_vol,  myThid )

      RETURN
      END

#include "SHELFICE_OPTIONS.h"

CBOP
C     !ROUTINE: SHELFICE_REMESHING
C     !INTERFACE:
      SUBROUTINE SHELFICE_REMESHING(
     I                    myTime, myIter, myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE SHELFICE_REMESHING
C     | o When myTime is a multiple of SHELFICEremeshFrequency
C     |   checks if etaN under shelfice triggers a remesh
C     *==========================================================*
C     \ev

C     !CALLING SEQUENCE:
C     SHELFICE_REMESHING
C       |
C       |-- SHELFICE_REMESH_C_MASK
C       |-- SHELFICE_REMESH_UV_MASK
C       |
C       |-- CALC_SURF_DR
C       |-- UPDATE_SURF_DR
C       |-- CALC_SURF_DR
C       |
C       |-- SHELFICE_REMESH_STATE
C       |
C       |-- SHELFICE_REMESH_CALC_W

C     !USES:
      IMPLICIT NONE
C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "SURFACE.h"
#include "DYNVARS.h"
#include "SHELFICE.h"

C     !INPUT/OUTPUT PARAMETERS:
C     myTime    :: Current time in simulation
C     myIter    :: Current iteration number
C     myThid    :: my Thread Id number
      _RL myTime
      INTEGER myIter
      INTEGER myThid

#ifdef ALLOW_SHELFICE_REMESHING
C     !FUNCTIONS:
      LOGICAL  DIFFERENT_MULTIPLE
      EXTERNAL DIFFERENT_MULTIPLE

C     !LOCAL VARIABLES:
C     k1SurfC   :: surface level index (at cell center) before remeshing
C     k1SurfW   :: surface level index (at cell W.Edge) before remeshing
C     k1SurfS   :: surface level index (at cell S.Edge) before remeshing
C     mergeFacC :: merging weight for tracers (cell center)
C     mergeFacW :: merging weight for U component velocity
C     mergeFacS :: merging weight for V component velocity
      INTEGER k1SurfC(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      INTEGER k1SurfW(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      INTEGER k1SurfS(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL mergeFacC(1-OLx:sNx+OLx,1-OLy:sNy+OLy,2,nSx,nSy)
      _RL mergeFacW(1-OLx:sNx+OLx,1-OLy:sNy+OLy,2,nSx,nSy)
      _RL mergeFacS(1-OLx:sNx+OLx,1-OLy:sNy+OLy,2,nSx,nSy)
CEOP

      IF ( SHELFICEremeshFrequency.GT.zeroRL
     &                        .AND. myTime.GT.baseTime ) THEN
       IF (  DIFFERENT_MULTIPLE( SHELFICEremeshFrequency,
     &                           myTime, deltaTClock ) ) THEN
         CALL SHELFICE_REMESH_C_MASK(
     O                 k1SurfC, mergeFacC,
     I                 myTime, myIter, myThid )
         CALL SHELFICE_REMESH_UV_MASK(
     O                 k1SurfW, k1SurfS, mergeFacW, mergeFacS,
     I                 myTime, myIter, myThid )

         CALL CALC_SURF_DR( etaHnm1, myTime, myIter, myThid )
         CALL UPDATE_SURF_DR(.TRUE., myTime, myIter, myThid )
         CALL CALC_SURF_DR( etaH, myTime, myIter, myThid )

         CALL SHELFICE_REMESH_STATE(
     I                 k1SurfC, k1SurfW, k1SurfS, mergeFacC,
     U                 mergeFacW, mergeFacS,
     I                 myTime, myIter, myThid )
         CALL SHELFICE_REMESH_CALC_W(
     I                 uVel, vVel,
     O                 wVel,
     I                 myIter, myThid )
       ENDIF
      ENDIF
#endif /* ALLOW_SHELFICE_REMESHING */

      RETURN
      END

#include "EBM_OPTIONS.h"

      SUBROUTINE EBM_DRIVER( myTime, myIter, myThid )
C     |==========================================================|
C     | S/R top level for EBM                                    |
C     |==========================================================|
C      References:
C      * X. Wang, P. Stone and J. Marotzke, 1999:
C        Global thermohaline circulation. Part I:
C        Sensitivity to atmospheric moisture transport.
C        J. Climate 12(1), 71-82
C      * X. Wang, P. Stone and J. Marotzke, 1999:
C        Global thermohaline circulation. Part II:
C        Sensitivity with interactive transport.
C        J. Climate 12(1), 83-91
C      * M. Nakamura, P. Stone and J. Marotzke, 1994:
C        Destabilization of the thermohaline circulation
C        by atmospheric eddy transports.
C        J. Climate 7(12), 1870-1882

      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "FFIELDS.h"
#include "DYNVARS.h"
#include "GRID.h"
#ifdef ALLOW_EBM
# include "EBM.h"
#endif

C     === Routine arguments ===
C     myThid - Instance number for this innvocation 
      INTEGER myThid
      INTEGER myIter
      _RL myTime

CEndOfInterface
C     == Local variables ==

#ifdef ALLOW_EBM

c--   Compute zonal mean SST
      CALL EBM_ZONALMEAN  ( myTime, myIter, myThid )

c--   Compute area mean SST in NH/SH tropica and mid-lat
      CALL EBM_AREA_T    ( myTime, myIter, myThid )

c--   Comopute qnet, empmr via EBM
      CALL EBM_ATMOSPHERE ( myTime, myIter, myThid )

c--   Compute random wind perturbation
      CALL EBM_WIND_PERTURB( myTime, myIter, myThid )

#endif /* ALLOW_EBM */

      RETURN
      END

#include "ATM_CPL_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 0
C !ROUTINE: CPL_DIAGNOSTICS_FILL

C !INTERFACE:
      SUBROUTINE CPL_DIAGNOSTICS_FILL(
     I                     myTime, myIter, myThid )

C     !DESCRIPTION:
C     Fill-in diagnostics array for ATM_CPL variables

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "CPL_PARAMS.h"
#include "ATMCPL.h"

C     !INPUT PARAMETERS:
C     myTime   :: Current time of simulation ( s )
C     myIter   :: Current iteration number in simulation
C     myThid   :: my Thread Id number
      _RL     myTime
      INTEGER myIter, myThid
CEOP

#ifdef ALLOW_DIAGNOSTICS
C     !FUNCTIONS:
#ifdef ALLOW_THSICE
      LOGICAL  DIAGNOSTICS_IS_ON
      EXTERNAL DIAGNOSTICS_IS_ON
#endif /* ALLOW_THSICE */

C     !LOCAL VARIABLES:
#ifdef ALLOW_THSICE
      INTEGER bi,bj
      INTEGER i,j
      _RL tmpFld(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL tmpFac
#endif /* ALLOW_THSICE */

      IF ( useDiagnostics ) THEN

        CALL DIAGNOSTICS_FILL( ocMxlD ,   'CPL_MxlD',
     I                          0, 1, 0, 1, 1, myThid )
        CALL DIAGNOSTICS_FILL( SSTocn ,   'CPL_SST ',
     I                          0, 1, 0, 1, 1, myThid )
        CALL DIAGNOSTICS_FILL( SSSocn ,   'CPL_SSS ',
     I                          0, 1, 0, 1, 1, myThid )
        CALL DIAGNOSTICS_FILL( vSqocn ,   'CPL_Vel2',
     I                          0, 1, 0, 1, 1, myThid )
#ifdef ALLOW_AIM
        IF ( atm_cplExch_DIC ) THEN
         CALL DIAGNOSTICS_FILL( flxCO2ocn, 'CPL_fCO2',
     I                          0, 1, 0, 1, 1, myThid )
        ENDIF
#endif /* ALLOW_AIM */
#ifdef ALLOW_THSICE
        IF ( atm_cplExch2W_sIce ) THEN
         CALL DIAGNOSTICS_FILL( sIceFrac_cpl , 'CPL_icFr',
     I                          0, 1, 0, 1, 1, myThid )
C      Ice-fraction weighted quantities:
         tmpFac = 1. _d 0
         CALL DIAGNOSTICS_FRACT_FILL(
     I                          sIceThick_cpl, sIceFrac_cpl,
     I                          tmpFac, 1, 'CPL_iceH',
     I                          0, 1, 0, 1, 1, myThid )
         CALL DIAGNOSTICS_FRACT_FILL(
     I                          sIceSnowH_cpl, sIceFrac_cpl,
     I                          tmpFac, 1, 'CPL_snwH',
     I                          0, 1, 0, 1, 1, myThid )

C      Ice-Volume weighted quantities:
         IF ( DIAGNOSTICS_IS_ON('CPL_Qic1',myThid) .OR.
     &        DIAGNOSTICS_IS_ON('CPL_Qic2',myThid) ) THEN
          DO bj=myByLo(myThid),myByHi(myThid)
           DO bi=myBxLo(myThid),myBxHi(myThid)

            DO j=1-OLy,sNy+OLy
             DO i=1-OLx,sNx+OLx
              tmpFld(i,j) = sIceFrac_cpl(i,j,bi,bj)
     &                    * sIceThick_cpl(i,j,bi,bj)
             ENDDO
            ENDDO
            CALL DIAGNOSTICS_FRACT_FILL(
     I                          sIceQ1_cpl(1-OLx,1-OLy,bi,bj),
     I                          tmpFld, tmpFac, 1, 'CPL_Qic1',
     I                          0, 1, 2,bi,bj, myThid )
            CALL DIAGNOSTICS_FRACT_FILL(
     I                          sIceQ2_cpl(1-OLx,1-OLy,bi,bj),
     I                          tmpFld, tmpFac, 1, 'CPL_Qic2',
     I                          0, 1, 2,bi,bj, myThid )

           ENDDO
          ENDDO
         ENDIF

        ENDIF
#endif /* ALLOW_THSICE */

      ENDIF

#endif /* ALLOW_DIAGNOSTICS */
      RETURN
      END

#include "PTRACERS_OPTIONS.h"
#ifdef PTRACERS_ALLOW_DYN_STATE

      MODULE PTRACERS_DYN_STATE_DATA_MOD

      use ptracers_dyn_state_mod

C     instance of ptracers internal state data structure:
C     array with one PTRACERS_ISTATE for each Ptracer
      TYPE(PTRACERS_ISTATE), POINTER :: PtrISt(:)

      END MODULE
#else
C     some compilers do not like empty files, so ...
      SUBROUTINE PTRACERS_DYN_STATE_DATA_DUMMY
        RETURN
      END
#endif

#include "SALT_PLUME_OPTIONS.h"

CBOP 0
C     !ROUTINE: SALT_PLUME_CHECK
C     !INTERFACE:
      SUBROUTINE SALT_PLUME_CHECK( myThid )

C     !DESCRIPTION:
C     Check dependances with other packages

C     !USES:
      IMPLICIT NONE
#include "EEPARAMS.h"
#include "SIZE.h"
#include "SALT_PLUME.h"

C     !INPUT PARAMETERS:
C     myThid :: my Thread Id number
      INTEGER myThid
CEOP

#ifdef ALLOW_SALT_PLUME

C     !LOCAL VARIABLES:
C     msgBuf      - Informational/error meesage buffer
      CHARACTER*(MAX_LEN_MBUF) msgBuf

      _BEGIN_MASTER(myThid)

       WRITE(msgBuf,'(A)') 'SALT_PLUME_CHECK: #define SALT_PLUME'
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                     SQUEEZE_RIGHT , myThid )

#ifdef SALT_PLUME_SPLIT_BASIN
      IF ( (SPsalFRAC(1) .LT. 0. _d 0).OR.
     &     (SPsalFRAC(1) .GT. 1. _d 0) ) then
       WRITE(msgBuf,'(2A)') 'SALT_PLUME_CHECK:',
     &  ' SPsalFRAC(1) needs to lie between 0. and 1.'
       CALL PRINT_ERROR( msgBuf, myThid )
       STOP 'ABNORMAL END: S/R SALT_PLUME_CHECK'
      ENDIF
      IF ( (SPsalFRAC(2) .LT. 0. _d 0).OR.
     &     (SPsalFRAC(2) .GT. 1. _d 0) ) then
       WRITE(msgBuf,'(2A)') 'SALT_PLUME_CHECK:',
     &  ' SPsalFRAC(2) needs to lie between 0. and 1.'
       CALL PRINT_ERROR( msgBuf, myThid )
       STOP 'ABNORMAL END: S/R SALT_PLUME_CHECK'
      ENDIF
#else
      IF ( (SPsalFRAC .LT. 0. _d 0).OR.(SPsalFRAC .GT. 1. _d 0) ) then
       WRITE(msgBuf,'(2A)') 'SALT_PLUME_CHECK:',
     &  ' SPsalFRAC needs to lie between 0. and 1.'
       CALL PRINT_ERROR( msgBuf, myThid )
       STOP 'ABNORMAL END: S/R SALT_PLUME_CHECK'
      ENDIF
#endif

#ifdef SALT_PLUME_IN_LEADS
      IF ( (SPinflectionPoint .LT. 0. _d 0).OR.
     &     (SPinflectionPoint .GT. 1. _d 0) ) then
       WRITE(msgBuf,'(2A)') 'SALT_PLUME_CHECK:',
     &  ' SPinflectionPoint needs to lie between 0. and 1.'
       CALL PRINT_ERROR( msgBuf, myThid )
       STOP 'ABNORMAL END: S/R SALT_PLUME_CHECK'
      ENDIF
#endif
#ifdef SALT_PLUME_VOLUME
      IF ( (SPbrineSconst .LT. 0. _d 0).OR.
     &     (SPbrineSconst .GT. SPbrineSaltmax) ) then
       WRITE(msgBuf,'(2A,F6.1,A)') 'SALT_PLUME_CHECK:',
     &  ' SPbrineSconst valid range: [0.,',SPbrineSaltmax,']'
       CALL PRINT_ERROR( msgBuf, myThid )
       STOP 'ABNORMAL END: S/R SALT_PLUME_CHECK'
      ENDIF
#endif

      _END_MASTER(myThid)

#endif /* ALLOW_SALT_PLUME */

      RETURN
      END

#include "FIZHI_OPTIONS.h"
       SUBROUTINE DO_FIZHI(myIter,myid,
     & idim1,idim2,jdim1,jdim2,Nrphin,nSxin,nSyin,im1,im2,jm1,jm2,bi,bj,
     & turbStart, nchp,nchptot,nchpland,
     & uphy,vphy,thphy,sphy,pephy,lons,lats,Zsurf,
     & ctmt,xxmt,yymt,zetamt,xlmt,khmt,tke,
     & tgz,sst,sice,phis_var,landtype,fracland,emiss,albnirdr,albnirdf,
     & albvisdr,albvisdf,ityp,chfr,alai,agrn,igrd,chlat,chlon,
     & tcanopy,tdeep,ecanopy,swetshal,swetroot,swetdeep,snodep,capac,
     & o3,qstr,co2,cfc11,cfc12,cfc22,n2o,methane,
     & iras,nlwcld,cldtotlwin,cldraslwin,cldlsplwin,nlwlz,lwlzin,
     & nswcld,cldtotswin,cldrasswin,cldlspswin,nswlz,swlzin,imstturbsw,
     & imstturblw,qliqaveswin,qliqavelwin,fccaveswin,fccavelwin,
     & rainconin,rainlspin,snowfallin,
     & duphy,dvphy,dthphy,dsphy)
c-----------------------------------------------------------------------
c Interface routine to calculate physics increments - calls fizhi_driver.
c Purpose of this routine is to set up arrays local to fizhi and 'save'
c them from one iteration to the next, and act as interface between the
c model common blocks (held in fizhi_wrapper) and fizhi_driver.
c Copies of variables that are 'shadowed' are made here without shadows
c for passing to fizhi_driver.
c Note: routine is called from inside a bi-bj loop
c
c-----------------------------------------------------------------------
      IMPLICIT NONE
#include "SIZE.h"
#include "fizhi_SIZE.h"
#include "chronos.h"

C Argument list declarations
      INTEGER myIter,myid,im1,im2,jm1,jm2,idim1,idim2,jdim1,jdim2
      INTEGER Nrphin,nSxin,nSyin,bi,bj,nchp
      LOGICAL turbStart
      INTEGER nchptot(nSxin,nSyin),nchpland(nSxin,nSyin)
      _RL uphy(idim1:idim2,jdim1:jdim2,Nrphin,nSxin,nSyin)
      _RL vphy(idim1:idim2,jdim1:jdim2,Nrphin,nSxin,nSyin)
      _RL thphy(idim1:idim2,jdim1:jdim2,Nrphin,nSxin,nSyin)
      _RL sphy(idim1:idim2,jdim1:jdim2,Nrphin,nSxin,nSyin)
      _RL pephy(idim1:idim2,jdim1:jdim2,Nrphin+1,nSxin,nSyin)
      _RS lons(idim1:idim2,jdim1:jdim2,nSxin,nSyin)
      _RS lats(idim1:idim2,jdim1:jdim2,nSxin,nSyin)
      _RS Zsurf(idim1:idim2,jdim1:jdim2,nSxin,nSyin)
      _RL ctmt(nchp,nSxin,nSyin),xxmt(nchp,nSxin,nSyin)
      _RL yymt(nchp,nSxin,nSyin)
      _RL zetamt(nchp,nSxin,nSyin)
      _RL xlmt(nchp,Nrphin,nSxin,nSyin),khmt(nchp,Nrphin,nSxin,nSyin)
      _RL tke(nchp,Nrphin,nSxin,nSyin)
      _RL tgz(im2,jm2,nSxin,nSyin)
      _RL sst(idim1:idim2,jdim1:jdim2,nSxin,nSyin)
      _RL sice(idim1:idim2,jdim1:jdim2,nSxin,nSyin)
      _RL phis_var(im2,jm2,nSxin,nSyin)
      INTEGER landtype(im2,jm2,nSxin,nSyin)
      _RL fracland(im2,jm2,nSxin,nSyin),emiss(im2,jm2,10,nSxin,nSyin)
      _RL albvisdr(im2,jm2,nSxin,nSyin),albvisdf(im2,jm2,nSxin,nSyin)
      _RL albnirdr(im2,jm2,nSxin,nSyin),albnirdf(im2,jm2,nSxin,nSyin)
      _RL chfr(nchp,nSxin,nSyin),alai(nchp,nSxin,nSyin)
      _RL agrn(nchp,nSxin,nSyin)
      INTEGER ityp(nchp,nSxin,nSyin),igrd(nchp,nSxin,nSyin)
      _RL chlat(nchp,nSxin,nSyin),chlon(nchp,nSxin,nSyin)
      _RL tcanopy(nchp,nSxin,nSyin),tdeep(nchp,nSxin,nSyin)
      _RL ecanopy(nchp,nSxin,nSyin),swetshal(nchp,nSxin,nSyin)
      _RL swetroot(nchp,nSxin,nSyin),swetdeep(nchp,nSxin,nSyin)
      _RL snodep(nchp,nSxin,nSyin),capac(nchp,nSxin,nSyin)
      _RL o3(im2,jm2,Nrphin,nSxin,nSyin)
      _RL qstr(im2,jm2,Nrphin,nSxin,nSyin)
      _RL co2,cfc11,cfc12,cfc22,n2o(Nrphin),methane(Nrphin)

      INTEGER iras(nSxin,nSyin)
      INTEGER nlwcld(nSxin,nSyin),nlwlz(nSxin,nSyin)
      INTEGER nswcld(nSxin,nSyin),nswlz(nSxin,nSyin)
      INTEGER imstturbsw(nSxin,nSyin),imstturblw(nSxin,nSyin)
      _RL cldtotlwin(idim1:idim2,jdim1:jdim2,Nrphin,nSxin,nSyin)
      _RL cldraslwin(idim1:idim2,jdim1:jdim2,Nrphin,nSxin,nSyin)
      _RL cldlsplwin(idim1:idim2,jdim1:jdim2,Nrphin,nSxin,nSyin)
      _RL lwlzin(idim1:idim2,jdim1:jdim2,Nrphin,nSxin,nSyin)
      _RL cldtotswin(idim1:idim2,jdim1:jdim2,Nrphin,nSxin,nSyin)
      _RL cldrasswin(idim1:idim2,jdim1:jdim2,Nrphin,nSxin,nSyin)
      _RL cldlspswin(idim1:idim2,jdim1:jdim2,Nrphin,nSxin,nSyin)
      _RL swlzin(idim1:idim2,jdim1:jdim2,Nrphin,nSxin,nSyin)
      _RL qliqaveswin(idim1:idim2,jdim1:jdim2,Nrphin,nSxin,nSyin)
      _RL qliqavelwin(idim1:idim2,jdim1:jdim2,Nrphin,nSxin,nSyin)
      _RL fccaveswin(idim1:idim2,jdim1:jdim2,Nrphin,nSxin,nSyin)
      _RL fccavelwin(idim1:idim2,jdim1:jdim2,Nrphin,nSxin,nSyin)
      _RL rainlspin(idim1:idim2,jdim1:jdim2,nSxin,nSyin)
      _RL rainconin(idim1:idim2,jdim1:jdim2,nSxin,nSyin)
      _RL snowfallin(idim1:idim2,jdim1:jdim2,nSxin,nSyin)


      _RL duphy(idim1:idim2,jdim1:jdim2,Nrphin,nSxin,nSyin)
      _RL dvphy(idim1:idim2,jdim1:jdim2,Nrphin,nSxin,nSyin)
      _RL dthphy(idim1:idim2,jdim1:jdim2,Nrphin,nSxin,nSyin)
      _RL dsphy(idim1:idim2,jdim1:jdim2,Nrphin,nSxin,nSyin)


c Local Variables
      INTEGER ptracer,ntracer
      PARAMETER (ptracer = 1)
      PARAMETER (ntracer = 1)

      _RL xlats(sNx,sNy),xlons(sNx,sNy),sea_ice(sNx,sNy)
      _RL p(sNx,sNy,nSx,nSy)
      _RL u(sNx,sNy,Nrphys),v(sNx,sNy,Nrphys),t(sNx,sNy,Nrphys)
      _RL q(sNx,sNy,Nrphys,ntracer)
      _RL pl(sNx,sNy,Nrphys,nSx,nSy),pkl(sNx,sNy,Nrphys,nSx,nSy)
      _RL ple(sNx,sNy,Nrphys+1,nSx,nSy)
      _RL pkle(sNx,sNy,Nrphys+1,nSx,nSy)
      _RL dpres(sNx,sNy,Nrphys,nSx,nSy)
      _RL lwdt(sNx,sNy,Nrphys,nSx,nSy)
      _RL lwdtclr(sNx,sNy,Nrphys,nSx,nSy)
      _RL swdt(sNx,sNy,Nrphys,nSx,nSy)
      _RL swdtclr(sNx,sNy,Nrphys,nSx,nSy)
      _RL turbu(sNx,sNy,Nrphys,nSx,nSy)
      _RL turbv(sNx,sNy,Nrphys,nSx,nSy)
      _RL turbt(sNx,sNy,Nrphys,nSx,nSy)
      _RL turbq(sNx,sNy,Nrphys,ntracer,nSx,nSy)
      _RL moistu(sNx,sNy,Nrphys,nSx,nSy)
      _RL moistv(sNx,sNy,Nrphys,nSx,nSy)
      _RL moistt(sNx,sNy,Nrphys,nSx,nSy)
      _RL moistq(sNx,sNy,Nrphys,ntracer,nSx,nSy)
      _RL radswt(sNx,sNy,nSx,nSy),radswg(sNx,sNy,nSx,nSy)
      _RL swgclr(sNx,sNy,nSx,nSy)
      _RL fdirpar(sNx,sNy,nSx,nSy),fdifpar(sNx,sNy,nSx,nSy)
      _RL osr(sNx,sNy,nSx,nSy),osrclr(sNx,sNy,nSx,nSy)
      _RL tg0(sNx,sNy,nSx,nSy),radlwg(sNx,sNy,nSx,nSy)
      _RL lwgclr(sNx,sNy,nSx,nSy),st4(sNx,sNy,nSx,nSy)
      _RL dst4(sNx,sNy,nSx,nSy),dlwdtg(sNx,sNy,Nrphys,nSx,nSy)
      _RL qq(sNx,sNy,Nrphys,nSx,nSy)
      INTEGER i,j,L
      _RL getcon, kappa, p0kappa, s0, ra
      _RL cosz(sNx,sNy)
      _RL cldtot_lw(sNx,sNy,Nrphys)
      _RL cldras_lw(sNx,sNy,Nrphys)
      _RL cldlsp_lw(sNx,sNy,Nrphys)
      _RL lwlz(sNx,sNy,Nrphys)
      _RL cldtot_sw(sNx,sNy,Nrphys)
      _RL cldras_sw(sNx,sNy,Nrphys)
      _RL cldlsp_sw(sNx,sNy,Nrphys)
      _RL swlz(sNx,sNy,Nrphys)
      _RL qliqavesw(sNx,sNy,Nrphys)
      _RL qliqavelw(sNx,sNy,Nrphys)
      _RL fccavesw(sNx,sNy,Nrphys)
      _RL fccavelw(sNx,sNy,Nrphys)
      _RL rainlsp(sNx,sNy)
      _RL raincon(sNx,sNy)
      _RL snowfall(sNx,sNy)

      _RL tempij(sNx,sNy)
      _RL tempi(2)

      _RL kF,sigma_b,ks,ka,deg2rad,pi,atm_po,atm_kappa,termp,kv,kT
      _RL term1,term2,thetalim,thetaeq,recip_p0g

      LOGICAL alarm
      EXTERNAL alarm

C***********************************************************************

       kF=1. _d 0/86400. _d 0
       sigma_b = 0.7 _d 0
       ka=1. _d 0/(40. _d 0*86400. _d 0)
       ks=1. _d 0/(4. _d 0 *86400. _d 0)
       pi = getcon('PI')
       atm_kappa = getcon('KAPPA')
       atm_po = getcon('ATMPOPA')
       deg2rad = getcon('DEG2RAD')

       do L = 1,Nrphys
        do j = jm1,jm2
        do i = im1,im2
         recip_P0g= 1. _d 0 / pephy(i,j,Nrphys+1,bi,bj)
c U  and V terms:
         termP=0.5 _d 0*((pephy(i,j,L,bi,bj)+pephy(i,j,L+1,bi,bj))
     &                   *recip_P0g )
         kV=kF*MAX( 0. _d 0, (termP-sigma_b)/(1. _d 0-sigma_b) )
         duphy(i,j,L,bi,bj)= -kV*uphy(i,j,L,bi,bj)
         dvphy(i,j,L,bi,bj)= -kV*vphy(i,j,L,bi,bj)

c T terms
C--   Forcing term(s)
         term1=60. _d 0*(sin(lats(I,J,bi,bj)*deg2rad)**2)
         termP=0.5 _d 0*( pephy(i,j,L,bi,bj) + pephy(i,j,L+1,bi,bj) )
         term2=10. _d 0*log(termP/atm_po)
     &            *(cos(lats(I,J,bi,bj)*deg2rad)**2)
         thetaLim = 200. _d 0/ ((termP/atm_po)**atm_kappa)
         thetaEq=315. _d 0-term1-term2
         thetaEq=MAX(thetaLim,thetaEq)
         kT=ka+(ks-ka)
     &     *MAX(0. _d 0,
     &       (termP*recip_P0g-sigma_b)/(1. _d 0-sigma_b) )
     &     *COS((lats(I,J,bi,bj)*deg2rad))**4
         if(termP*recip_P0g.gt.0.04)then
          dthphy(i,j,L,bi,bj)=- kT*( thphy(I,J,L,bi,bj)-thetaEq )
         else
          dthphy(i,j,L,bi,bj)=0.
         endif

c S terms (hs runs dry - no moisture)
C--   Forcing term(s)
         dsphy(i,j,L,bi,bj)=0.

        enddo
        enddo
       enddo

      return
      end

#include "AUTODIFF_OPTIONS.h"

      SUBROUTINE G_AUTODIFF_INADMODE_SET( myTime, myIter, myThid )
C     *==========================================================*
C     | SUBROUTINE G_ADAUTODIFF_INADMODE_SET
C     *==========================================================*

C     !USES:
      IMPLICIT NONE
C     == Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "AUTODIFF_PARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     myTime    :: Current time in simulation
C     myIter    :: Current iteration number
C     myThid    :: my Thread Id number
      _RL     myTime
      INTEGER myIter
      INTEGER myThid

      inAdmode = .FALSE.

      RETURN
      END

#include "ECCO_OPTIONS.h"

      subroutine cost_sla_read(
     I                sla_file, sla_startdate, sla_period, use_mon,
     I                sla_intercept, sla_slope,
     O                sla_obs, sla_mask,
     I                irec, myThid )

c     ==================================================================
c     SUBROUTINE cost_sla_read
c     ==================================================================
c
c     o Read a given record of the SLA data.
c
c     started: Gael Forget 20-Oct-2009
c
c     Apr-2023: argument use_mon, switches read daily to monthly if true
c
c     ==================================================================
c     SUBROUTINE cost_sla_read
c     ==================================================================

      implicit none

c     == global variables ==

#include "EEPARAMS.h"
#include "SIZE.h"
#include "PARAMS.h"
#include "GRID.h"

#include "cal.h"
#include "ECCO_SIZE.h"
#include "ECCO.h"

c     == routine arguments ==
C     use_mon :: switch from using daily to monthly data if true
      character*(MAX_LEN_FNAM) sla_file
      integer sla_startdate(4)
      _RL sla_period
      logical use_mon
      _RL sla_intercept
      _RL sla_slope
      _RL sla_obs (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL sla_mask(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      integer irec
      integer myThid

c     == external functions ==
      integer  ilnblnk
      external ilnblnk

c     == local variables ==
      integer bi,bj
      integer i,j,k
      integer itlo,ithi
      integer jtlo,jthi
      integer jmin,jmax
      integer imin,imax
      integer sshrec
      integer difftime(4)
      integer tempDate_1
      integer middate(4)
      _RL diffsecs
      _RL spval
      _RL factor
cnew(
      integer  il
      _RL obstime
      integer obsiter
      integer obsdate(4)
      integer yobs, ymod
      integer md, dd, sd, ld, wd
      character*(MAX_LEN_FNAM) fnametmp
      logical exst
cnew)
      integer mody, modm
      _RL daysperavgperiod

c     == end of interface ==

      jtlo = myByLo(myThid)
      jthi = myByHi(myThid)
      itlo = myBxLo(myThid)
      ithi = myBxHi(myThid)
      jmin = 1
      jmax = sNy
      imin = 1
      imax = sNx

      factor = 0.01
      spval = -9990.

      IF (use_mon) THEN
        daysperavgperiod = 30.5
        mody = modelstartdate(1)/10000
        modm = modelstartdate(1)/100 - mody*100
        yobs = mody + INT((modm-1+irec-1)/12)
        sshrec = 1 + MOD(modm-1+irec-1,12)

      ELSE

        daysperavgperiod = 1.0
c select data record to read
        obstime = FLOAT(secondsperday*(irec-1)) + modelstart
        obsiter = hoursperday*(irec-1)+modeliter0
        call cal_getdate( obsiter, obstime, obsdate, myThid )
        call cal_convdate( obsdate,yobs,md,dd,sd,ld,wd,myThid )
        ymod = sla_startdate(1)/10000

        IF ( ymod .GE. yobs ) THEN
           call cal_FullDate( sla_startdate(1), 0, middate, myThid)
        ELSE
           tempDate_1 = yobs*10000+100+1
           call cal_FullDate( tempDate_1, 0, middate, myThid)
        ENDIF

        call cal_TimePassed( middate, obsdate, difftime, myThid )
        call cal_ToSeconds( difftime, diffsecs, myThid )
c        sshrec = floor(diffsecs/sla_period) + 1
        sshrec = int(diffsecs/sla_period) + 1
      ENDIF !use_mon

      il=ilnblnk(sla_file)
      WRITE(fnametmp,'(2a,i4)')
     &     sla_file(1:il), '_', yobs
      inquire( file=fnametmp, exist=exst )

c read data:
      IF ( (sshrec .GT. 0).AND.(exst) ) THEN
       CALL READ_REC_3D_RL( fnametmp, cost_iprec, 1,
     &                      sla_obs, sshrec, 1, myThid )
      ELSE
       DO bj = jtlo,jthi
        DO bi = itlo,ithi
         DO j = jmin,jmax
          DO i = imin,imax
            sla_obs(i,j,bi,bj) = spval
          ENDDO
         ENDDO
        ENDDO
       ENDDO
      ENDIF

c mask data:
      DO bj = jtlo,jthi
        DO bi = itlo,ithi
          k = 1
          DO j = jmin,jmax
            DO i = imin,imax
              IF (_hFacC(i,j,k,bi,bj) .EQ. 0.) THEN
                 sla_mask(i,j,bi,bj) = 0. _d 0
              ELSE
                 sla_mask(i,j,bi,bj) = 1. _d 0
              ENDIF
              IF (sla_obs(i,j,bi,bj) .LE. spval) THEN
                sla_mask(i,j,bi,bj) = 0. _d 0
              ENDIF
              IF (abs(sla_obs(i,j,bi,bj)) .LT. 1.d-8 ) THEN
                 sla_mask(i,j,bi,bj) = 0. _d 0
              ENDIF

#ifndef ALLOW_SHALLOW_ALTIMETRY
              IF ( R_low(i,j,bi,bj) .GT. -200. ) THEN
                sla_mask(i,j,bi,bj) = 0. _d 0
              ENDIF
#endif
#ifndef ALLOW_HIGHLAT_ALTIMETRY
              IF ( abs(YC(i,j,bi,bj)) .GT. 66. ) THEN
                sla_mask(i,j,bi,bj) = 0. _d 0
              ENDIF
#endif

              sla_mask(i,j,bi,bj) = sla_mask(i,j,bi,bj)*frame(i,j)
              sla_obs(i,j,bi,bj)  = sla_mask(i,j,bi,bj)*factor*
     &             ( sla_obs(i,j,bi,bj) -
     &               ( sla_intercept + sla_slope*irec*hoursperday
     &                *daysperavgperiod  ) )
            ENDDO
          ENDDO
        ENDDO
      ENDDO

      RETURN
      END

#include "LAYERS_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      SUBROUTINE LAYERS_READPARMS( myThid )

C     Read LAYERS parameters from data file.

      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "LAYERS_SIZE.h"
#include "LAYERS_P2SHARE.h"
#include "LAYERS.h"

C     INPUT PARAMETERS:
      INTEGER myThid

#ifdef ALLOW_LAYERS
C     === Local variables ===
C     msgBuf     :: Informational/error message buffer
C     iUnit      :: Work variable for IO unit number
C     k          :: index
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      INTEGER iUnit, k, iLa
      INTEGER errCount

C--   old pkg/layers parameter setting (only single tracer layers diagnostics):
C      layers_G :: boundaries of tracer layers
      INTEGER LAYER_nb, layers_kref
      LOGICAL useBOLUS
      _RL layers_G(Nlayers+1)

C-    retired parameters:
      _RL layers_taveFreq

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      NAMELIST /LAYERS_PARM01/
     &       layers_G, layers_taveFreq, layers_diagFreq,
     &       LAYER_nb, layers_kref, useBOLUS, layers_bolus,
     &       layers_name, layers_bounds, layers_krho

       _BEGIN_MASTER(myThid)
       layers_useThermo = .FALSE.
       _END_MASTER(myThid)

      IF ( .NOT.useLayers ) THEN
C-    pkg LAYERS is not used
        _BEGIN_MASTER(myThid)
C-    Track pkg activation status:
C     print a (weak) warning if data.layers is found
         CALL PACKAGES_UNUSED_MSG( 'useLayers', ' ', ' ' )
        _END_MASTER(myThid)
        RETURN
      ENDIF

      _BEGIN_MASTER(myThid)
      errCount = 0
      layers_taveFreq = UNSET_RL

C--   Default values for LAYERS
#ifdef LAYERS_THERMODYNAMICS
C-    Currently, there is no run-time switch for doing the "layers thermodynamics"
C       part and this is turned on at compile time (with CPP option above):
      layers_useThermo = .TRUE.
#endif
      layers_diagFreq = dumpFreq
C     The MNC stuff is not working yet
      layers_MNC = .FALSE.
      layers_MDSIO = .TRUE.

      DO iLa=1,layers_maxNum
        layers_name(iLa) = ' '
        layers_krho(iLa)= 1
        layers_bolus(iLa) = useGMRedi
        DO k=1,Nlayers+1
          layers_bounds(k,iLa) = UNSET_RL
        ENDDO
      ENDDO

C--   old params default:
      LAYER_nb = 0
      layers_kref = 1
      useBOLUS = useGMRedi
      DO k=1,Nlayers+1
        layers_G(k) = UNSET_RL
      ENDDO

      WRITE(msgBuf,'(A)') 'LAYERS_READPARMS: opening data.layers'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT , 1)
      CALL OPEN_COPY_DATA_FILE(
     I                     'data.layers', 'LAYERS_READPARMS',
     O                     iUnit,
     I                     myThid )

C     Read parameters from open data file
      READ(UNIT=iUnit,NML=LAYERS_PARM01)
      WRITE(msgBuf,'(A)')
     &    'LAYERS_READPARMS: finished reading data.layers'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &    SQUEEZE_RIGHT , 1)
C     Close the open data file
#ifdef SINGLE_DISK_IO
      CLOSE(iUnit)
#else
      CLOSE(iUnit,STATUS='DELETE')
#endif /* SINGLE_DISK_IO */

C--   Process old params setting (single averaging tracer)
      IF ( LAYER_nb.LT.0 .OR. LAYER_nb.GT.3 ) THEN
        WRITE(msgBuf,'(2A,I2,A,I9)') 'LAYERS_READPARMS: ',
     &    'Invalid LAYER_nb=', LAYER_nb
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF
      IF ( LAYER_nb.EQ.0 ) THEN
        IF ( layers_kref.NE.1 )         errCount = errCount + 1
        DO k=1,Nlayers+1
         IF ( layers_G(k).NE.UNSET_RL ) errCount = errCount + 1
        ENDDO
      ELSE
        DO iLa=1,layers_maxNum
         IF ( layers_name(iLa).NE.' ' ) errCount = errCount + 1
         IF ( layers_krho(iLa).NE.1 )   errCount = errCount + 1
         DO k=1,Nlayers+1
          IF ( layers_bounds(k,iLa).NE.UNSET_RL ) errCount = errCount+1
         ENDDO
        ENDDO
C-    Transfert to new params setting:
        IF ( LAYER_nb.EQ.1 ) layers_name(1) = 'TH '
        IF ( LAYER_nb.EQ.2 ) layers_name(1) = 'SLT'
        IF ( LAYER_nb.EQ.3 ) layers_name(1) = 'RHO'
        layers_krho(1) = layers_kref
        layers_bolus(1) = useBOLUS
        DO k=1,Nlayers+1
          layers_bounds(k,1) = layers_G(k)
        ENDDO
      ENDIF
      IF ( errCount.GE.1 ) THEN
        WRITE(msgBuf,'(2A)') 'LAYERS_READPARMS: ',
     &    'Cannot mix old params setting (LAYER_nb > 0)'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(2A)') 'LAYERS_READPARMS: ',
     &    ' with new params setting (layer_name(#)= ...)'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(2A,I4,A)') 'LAYERS_READPARMS: ',
     &    'Detected', errCount,' fatal error/conflict(s)'
        CALL PRINT_ERROR( msgBuf, myThid )
        CALL ALL_PROC_DIE( 0 )
        STOP 'ABNORMAL END: S/R LAYERS_READPARMS'
      ENDIF

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C--   Check for retired parameters:
      IF ( layers_taveFreq .NE. UNSET_RL ) THEN
        WRITE(msgBuf,'(2A)') 'LAYERS_READPARMS: "layers_taveFreq"',
     &    ' is no longer allowed in file "data.layers"'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(2A)') 'LAYERS_READPARMS: ',
     &    ' since "pkg/timeave" has been removed.'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF

C--   Set layers_num according to layers_name:
      DO iLa=1,layers_maxNum
        layers_num(iLa) = 0
        IF ( layers_name(iLa).EQ.'TH ' ) layers_num(iLa) = 1
        IF ( layers_name(iLa).EQ.'SLT' ) layers_num(iLa) = 2
        IF ( layers_name(iLa).EQ.'RHO' ) layers_num(iLa) = 3
        IF ( layers_name(iLa).EQ.'MSE' ) layers_num(iLa) = 4
        IF ( layers_name(iLa).NE.' ' .AND.
     &       layers_num(iLa).EQ.0 ) THEN
          WRITE(msgBuf,'(2A,I2,3A)') 'LAYERS_READPARMS: ',
     &    'invalid layers_name(',iLa,')= "',layers_name(iLa),'"'
          CALL PRINT_ERROR( msgBuf, myThid )
          errCount = errCount + 1
        ENDIF
C--   bolus contribution only available if using GMRedi
        layers_bolus(iLa) = layers_bolus(iLa) .AND. useGMRedi
      ENDDO

C--   Make sure the layers_bounds we just read is big enough
      DO iLa=1,layers_maxNum
       IF ( layers_num(iLa).NE.0 ) THEN
        DO k=1,Nlayers+1
         IF ( layers_bounds(k,iLa).EQ.UNSET_RL ) THEN
          WRITE(msgBuf,'(2A,I4,A,I3,A)') 'LAYERS_READPARMS: ',
     &        'No value for layers_bounds(k=',k,', iLa=', iLa, ')'
          CALL PRINT_ERROR( msgBuf, myThid )
          errCount = errCount + 1
         ENDIF
        ENDDO
       ENDIF
#ifndef LAYERS_PRHO_REF
       IF ( layers_num(iLa).EQ.3 ) THEN
        WRITE(msgBuf,'(2A,I4)')
     &      'S/R LAYERS_READPARMS: ',
     &      'Layering in density requires to define LAYERS_PRHO_REF'
          CALL PRINT_ERROR( msgBuf, myThid )
          errCount = errCount + 1
       ENDIF
#endif
#ifndef LAYERS_MSE
       IF ( layers_num(iLa).EQ.4 ) THEN
        WRITE(msgBuf,'(2A,I4)')
     &      'S/R LAYERS_READPARMS: ',
     &      'Layering in MSE requires to define LAYERS_MSE'
          CALL PRINT_ERROR( msgBuf, myThid )
          errCount = errCount + 1
       ENDIF
#endif
C- Check MSE is not used with grey atmosphere nor with fizhi
       IF ( layers_num(iLa).EQ.4 ) THEN
        IF ( useAtm_Phys .OR. useFizhi ) THEN
         WRITE(msgBuf,'(2A,I4)')
     &       'S/R LAYERS_READPARMS: ',
     &       'Layering in MSE only work with Aim_v23'
          CALL PRINT_ERROR( msgBuf, myThid )
          errCount = errCount + 1
        ENDIF
       ENDIF
      ENDDO

C--   Make sure that we locally honor the global MNC on/off flag
      layers_MNC = layers_MNC .AND. useMNC
#ifndef ALLOW_MNC
C     Fix to avoid running without getting any output:
      layers_MNC = .FALSE.
#endif
      layers_MDSIO = (.NOT. layers_MNC) .OR. outputTypesInclusive

      IF ( errCount.GE.1 ) THEN
        WRITE(msgBuf,'(A,I3,A)')
     &    'LAYERS_READPARMS: detected', errCount,' fatal error(s)'
        CALL PRINT_ERROR( msgBuf, myThid )
        CALL ALL_PROC_DIE( 0 )
        STOP 'ABNORMAL END: S/R LAYERS_READPARMS'
      ENDIF

      _END_MASTER(myThid)

C--   Everyone else must wait for the parameters to be loaded
      _BARRIER

#endif /* ALLOW_LAYERS */

      RETURN
      END

#include "GAD_OPTIONS.h"

      SUBROUTINE GAD_DST3FL_ADV_X(
     I           bi,bj,k, calcCFL, deltaTloc,
     I           uTrans, uFld,
     I           maskLocW, tracer,
     O           uT,
     I           myThid )
C     /==========================================================\
C     | SUBROUTINE GAD_DST3FL_ADV_X                              |
C     | o Compute Zonal advective Flux of Tracer using           |
C     |   3rd Order DST Sceheme with flux limiting               |
C     |==========================================================|
      IMPLICIT NONE

C     == GLobal variables ==
#include "SIZE.h"
#include "GRID.h"
#include "GAD.h"

C     == Routine arguments ==
      INTEGER bi,bj,k
      LOGICAL calcCFL
      _RL deltaTloc
      _RL uTrans(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL uFld  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RS maskLocW(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL tracer(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL uT    (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER myThid

C     == Local variables ==
      INTEGER i,j
      _RL Rjm,Rj,Rjp,uCFL,d0,d1,psiP,psiM,thetaP,thetaM
      _RL thetaMax
      PARAMETER( thetaMax = 1.D+20 )

C- jmc: an alternative would be to compute directly psiM*Rj & psiP*Rj
C       (if Rj*Rjm < 0 => psiP*Rj = 0 , elsef Rj > 0 ... , else  ... )
C       with no need to compute thetaM (might be easier to differentiate)

      DO j=1-OLy,sNy+OLy
       uT(1-OLx,j)=0. _d 0
       uT(2-OLx,j)=0. _d 0
       uT(sNx+OLx,j)=0. _d 0
      ENDDO
      DO j=1-OLy,sNy+OLy
       DO i=1-OLx+2,sNx+OLx-1
#if (defined ALLOW_AUTODIFF && defined TARGET_NEC_SX)
C     These lines make TAF create vectorizable code
        thetaP = 0. _d 0
        thetaM = 0. _d 0
#endif
        Rjp=(tracer(i+1,j)-tracer( i ,j))*maskLocW(i+1,j)
        Rj =(tracer( i ,j)-tracer(i-1,j))*maskLocW( i ,j)
        Rjm=(tracer(i-1,j)-tracer(i-2,j))*maskLocW(i-1,j)

        uCFL = uFld(i,j)
        IF ( calcCFL ) uCFL = ABS( uFld(i,j)*deltaTloc
     &                  *recip_dxC(i,j,bi,bj)*recip_deepFacC(k) )
        d0=(2. _d 0 -uCFL)*(1. _d 0 -uCFL)*oneSixth
        d1=(1. _d 0 -uCFL*uCFL)*oneSixth

C-      the old version: can produce overflow, division by zero,
c       and is wrong for tracer with low concentration:
c       thetaP=Rjm/(1.D-20+Rj)
c       thetaM=Rjp/(1.D-20+Rj)
C-      the right expression, but not bounded:
c       thetaP=0.D0
c       thetaM=0.D0
c       IF (Rj.NE.0.D0) thetaP=Rjm/Rj
c       IF (Rj.NE.0.D0) thetaM=Rjp/Rj
C-      prevent |thetaP,M| to reach too big value:
        IF ( ABS(Rj)*thetaMax .LE. ABS(Rjm) ) THEN
          thetaP=SIGN(thetaMax,Rjm*Rj)
        ELSE
          thetaP=Rjm/Rj
        ENDIF
        IF ( ABS(Rj)*thetaMax .LE. ABS(Rjp) ) THEN
          thetaM=SIGN(thetaMax,Rjp*Rj)
        ELSE
          thetaM=Rjp/Rj
        ENDIF

        psiP=d0+d1*thetaP
        psiP=MAX(0. _d 0,MIN(MIN(1. _d 0,psiP),
     &                       thetaP*(1. _d 0 -uCFL)/(uCFL+1. _d -20) ))
        psiM=d0+d1*thetaM
        psiM=MAX(0. _d 0,MIN(MIN(1. _d 0,psiM),
     &                       thetaM*(1. _d 0 -uCFL)/(uCFL+1. _d -20) ))

        uT(i,j)=
     &   0.5*(uTrans(i,j)+ABS(uTrans(i,j)))
     &      *( Tracer(i-1,j) + psiP*Rj )
     &  +0.5*(uTrans(i,j)-ABS(uTrans(i,j)))
     &      *( Tracer( i ,j) - psiM*Rj )

       ENDDO
      ENDDO

      RETURN
      END

#include "CTRL_OPTIONS.h"
#include "AD_CONFIG.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: CTRL_INIT_CTRLVAR

C     !INTERFACE: ======================================================
      SUBROUTINE CTRL_INIT_CTRLVAR(
     I       xx_fname,
     I       ivar,
     I       varIndex,
     I       varRecs,
     I       varStartRec,
     I       varEndRec,
     I       varNxMax,
     I       varNyMax,
     I       varNrMax,
     I       varGrid,
     I       varType,
     I       costfinal_exists,
     I       myThid )

C     !DESCRIPTION:
C
C     Generic routine to initialize control variable xx_fname and store
C     specifier in global arrays for later reference.
C
C     Called from S/R CTRL_INIT_FIXED, this is where the crucial
C     information for a given control variable is set.
C
C     started: heimbach@mit.edu 28-Oct-2003

C     !USES: ===========================================================
      IMPLICIT NONE
C     == Global variables ===
#include "EEPARAMS.h"
#include "SIZE.h"
#include "PARAMS.h"
#include "GRID.h"
#include "CTRL_SIZE.h"
#include "CTRL.h"
#include "OPTIMCYCLE.h"

C     !INPUT PARAMETERS: ===============================================
C     ivar   :: if > 0, index in ctrl-var list to store ctrl-var settings
C               if == 0, skip storing of ctrl-var settings
C     myThid ::  my Thread Id number
      CHARACTER*(MAX_LEN_FNAM) xx_fname
      INTEGER ivar
      INTEGER varIndex
      INTEGER varRecs
      INTEGER varStartRec
      INTEGER varEndRec
      INTEGER varNxMax
      INTEGER varNyMax
      INTEGER varNrMax
      CHARACTER*(1) varGrid
      CHARACTER*(5) varType
      LOGICAL costfinal_exists
      INTEGER myThid

C     !OUTPUT PARAMETERS: ==============================================
C     none

C     === Functions ====
      INTEGER  ILNBLNK
      EXTERNAL ILNBLNK

C     !LOCAL VARIABLES:
      INTEGER il,ilDir
      CHARACTER*(MAX_LEN_FNAM) fname(3), gfname
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      LOGICAL g_exst
CEOP

c     _BEGIN_MASTER( myThid )
C     First check if the control variable index is within the allowed range.
      IF ( ivar .LT. 0 .OR. ivar .GT. maxcvars ) THEN
        WRITE(msgBuf,'(A,I4,A)') 'S/R CTRL_INIT_CTRLVAR: ivar = ',
     &       ivar, ' is not valid.'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(2A,I4)')
     &       'S/R CTRL_INIT_CTRLVAR: allowed values: ',
     &       '0 < ivar <= maxcvars = ', maxcvars
        CALL PRINT_ERROR( msgBuf, myThid )
        STOP 'ABNORMAL END: S/R CTRL_INIT_CTRLVAR'
      ELSEIF ( ivar .NE. 0 ) THEN
C     Save this ctrl-var setting in ctrl-var list:
        ncvarindex(ivar)    = varIndex
        ncvarrecs (ivar)    = varRecs
        ncvarrecstart(ivar) = varStartRec
        ncvarrecsend(ivar)  = varEndRec
        ncvarxmax (ivar)    = varNxMax
        ncvarymax (ivar)    = varNyMax
        ncvarnrmax(ivar)    = varNrMax
        ncvargrd  (ivar)    = varGrid
        ncvartype (ivar)    = varType
        ncvarfname(ivar)    = xx_fname
      ENDIF
c     _END_MASTER( myThid )

cph add following flag to make pack/unpack only less error-prone
#ifndef CTRL_DO_PACK_UNPACK_ONLY

      ilDir = ILNBLNK( ctrlDir )
      CALL CTRL_SET_FNAME( ctrlDir(1:ilDir)//xx_fname, fname, myThid )

C     In an adjoint run, adxx_ files should always be initialized with zeros
C     For TLM, all zeros means zero sensitivity, so check
C     for existing perturbation file g_xx_, otherwise
C     initialize to zero and warn user
      IF (yadprefix.EQ.'g_') THEN
        il = ILNBLNK(fname(2))
        WRITE(gfname,'(2a)') fname(2)(1:il),'.data'
        INQUIRE(file=gfname,exist=g_exst)
        IF (.NOT. g_exst) THEN
            WRITE(msgBuf,'(3A)')'** WARNING ** CTRL_INIT_CTRLVAR: ',
     &          'could not find ', gfname(1:il+5)
            CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                          SQUEEZE_RIGHT, myThid )
            WRITE(msgBuf,'(3A)')'** WARNING ** ',
     &          'for TLM perturbation ',
     &          'so will initialize this file with all zeros'
            CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                          SQUEEZE_RIGHT, myThid )
        ENDIF
      ELSE
        g_exst = .FALSE.
      ENDIF

      IF ( .NOT. costfinal_exists ) THEN

        IF ( varType .EQ. 'Arr3D' ) THEN
#if (defined (ALLOW_ADJOINT_RUN) || defined (ALLOW_TANGENTLINEAR_RUN))
          IF ( yadprefix.EQ.'ad' .OR. .NOT.(g_exst .OR. doAdmTlm) )
     &      CALL CTRL_SET_GLOBFLD_XYZ( fname(2),
     &                                 varRecs, ctrlprec, myThid )
#endif
          IF ( ( doInitXX .AND. optimcycle.EQ.0 ) .OR. doAdmTlm )
     &      CALL CTRL_SET_GLOBFLD_XYZ( fname(1),
     &                                 varRecs, ctrlprec, myThid )
        ELSEIF ( varType(4:5) .EQ. '2D' ) THEN
#if (defined (ALLOW_ADJOINT_RUN) || defined (ALLOW_TANGENTLINEAR_RUN))
          IF ( yadprefix.EQ.'ad' .OR. .NOT.(g_exst .OR. doAdmTlm) )
     &      CALL CTRL_SET_GLOBFLD_XY( fname(2),
     &                                 varRecs, ctrlprec, myThid )
#endif
          IF ( ( doInitXX .AND. optimcycle.EQ.0 ) .OR. doAdmTlm )
     &      CALL CTRL_SET_GLOBFLD_XY( fname(1),
     &                                 varRecs, ctrlprec, myThid )
        ELSEIF ( varType .EQ. 'SecXZ' ) THEN
#if (defined (ALLOW_ADJOINT_RUN) || defined (ALLOW_TANGENTLINEAR_RUN))
          IF ( yadprefix.EQ.'ad' .OR. .NOT.(g_exst .OR. doAdmTlm) )
     &      CALL CTRL_SET_GLOBFLD_XZ( fname(2),
     &                                 varRecs, ctrlprec, myThid )
#endif
          IF ( ( doInitXX .AND. optimcycle.EQ.0 ) .OR. doAdmTlm )
     &      CALL CTRL_SET_GLOBFLD_XZ( fname(1),
     &                                 varRecs, ctrlprec, myThid )
        ELSEIF ( varType .EQ. 'SecYZ' ) THEN
#if (defined (ALLOW_ADJOINT_RUN) || defined (ALLOW_TANGENTLINEAR_RUN))
          IF ( yadprefix.EQ.'ad' .OR. .NOT.(g_exst .OR. doAdmTlm) )
     &      CALL CTRL_SET_GLOBFLD_YZ( fname(2),
     &                                 varRecs, ctrlprec, myThid )
#endif
          IF ( ( doInitXX .AND. optimcycle.EQ.0 ) .OR. doAdmTlm )
     &      CALL CTRL_SET_GLOBFLD_YZ( fname(1),
     &                                 varRecs, ctrlprec, myThid )
        ELSE
          STOP 'CTRL_INIT_CTRLVAR: varType option not implemented'
        ENDIF

      ENDIF

#endif /* CTRL_DO_PACK_UNPACK_ONLY */

      RETURN
      END

#include "PACKAGES_CONFIG.h"
#include "CPP_OPTIONS.h"
#ifdef ALLOW_AUTODIFF
# include "AUTODIFF_OPTIONS.h"
#endif
#ifdef ALLOW_CTRL
# include "CTRL_OPTIONS.h"
#endif

CBOP
C     !ROUTINE: INTEGR_CONTINUITY
C     !INTERFACE:
      SUBROUTINE INTEGR_CONTINUITY(
     I                             uFld, vFld,
     I                             myTime, myIter, myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE INTEGR_CONTINUITY
C     | o Integrate the continuity Eq : compute vertical velocity
C     |   and free surface "r-anomaly" (etaN,etaH) to satisfy
C     |   exactly the conservation of the Total Volume
C     | o Routine dummy_for_etan located here in order to print the
C     |   correct adjoint variable for etaN
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     == Global variables
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "DYNVARS.h"
#include "GRID.h"
#include "SURFACE.h"
#include "FFIELDS.h"
#ifdef ALLOW_AUTODIFF_TAMC
# include "tamc.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     uFld     :: Zonal velocity ( m/s )
C     vFld     :: Meridional velocity ( m/s )
C     myTime   :: Current time in simulation
C     myIter   :: Current iteration number in simulation
C     myThid   :: my Thread Id. number
      _RL myTime
      INTEGER myIter
      INTEGER myThid
      _RL uFld(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      _RL vFld(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)

C     !LOCAL VARIABLES:
C     Local variables in common block

C     Local variables
C     bi,bj    :: tile index
C     i,j,k    :: Loop counters
C     uTrans   :: Volume transports ( uVel.xA )
C     vTrans   :: Volume transports ( vVel.yA )
C     hDivFlow :: Div. Barotropic Flow [transport unit m3/s]
      INTEGER k,bi,bj
      INTEGER i, j
      INTEGER ks
      _RL uTrans(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL vTrans(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL hDivFlow(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL facEmP, facMass
#ifndef ALLOW_ADDFLUID
      _RL addMass(1)
#endif /* ndef ALLOW_ADDFLUID */
#if (defined NONLIN_FRSURF) && !(defined DISABLE_RSTAR_CODE)
      _RL rStarDhDt(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
# if (defined ALLOW_AUTODIFF_TAMC) && (defined ALLOW_DEPTH_CONTROL)
C     tkey :: tape key (tile dependent)
      INTEGER tkey
# endif
#else
      _RL rStarDhDt(1)
#endif
CEOP

C--   Start bi,bj loops
      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      IF ( exactConserv ) THEN

       facEmP = 0.
       IF ( fluidIsWater.AND.useRealFreshWaterFlux ) facEmP=mass2rUnit
       facMass = 0.
       IF ( selectAddFluid.GE.1 .AND. myIter.NE.0 ) facMass = mass2rUnit

C--   Compute the Divergence of The Barotropic Flow :

C-    Initialise
       DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
         hDivFlow(i,j)      = 0. _d 0
         utrans(i,j)        = 0. _d 0
         vtrans(i,j)        = 0. _d 0
        ENDDO
       ENDDO

       DO k=1,Nr

C-    Calculate velocity field "volume transports" through tracer cell faces
C     anelastic: uTrans,vTrans are scaled by rhoFacC (~ mass transport).
        DO j=1,sNy+1
         DO i=1,sNx+1
          uTrans(i,j) = uFld(i,j,k,bi,bj)*_dyG(i,j,bi,bj)
     &                 *deepFacC(k)*rhoFacC(k)
     &                 *drF(k)*_hFacW(i,j,k,bi,bj)
          vTrans(i,j) = vFld(i,j,k,bi,bj)*_dxG(i,j,bi,bj)
     &                 *deepFacC(k)*rhoFacC(k)
     &                 *drF(k)*_hFacS(i,j,k,bi,bj)
         ENDDO
        ENDDO

C-    Integrate vertically the Horizontal Divergence
        DO j=1,sNy
         DO i=1,sNx
           hDivFlow(i,j) = hDivFlow(i,j)
     &       +maskC(i,j,k,bi,bj)*( uTrans(i+1,j)-uTrans(i,j)
     &                            +vTrans(i,j+1)-vTrans(i,j) )
#ifdef ALLOW_ADDFLUID
     &       -facMass*addMass(i,j,k,bi,bj)
#endif /* ALLOW_ADDFLUID */
         ENDDO
        ENDDO

C-    End DO k=1,Nr
       ENDDO

C------------------------------------
C note: deep-model not implemented for P-coordinate + realFreshWaterFlux ;
C       anelastic: always assumes that rhoFacF(1) = 1
       IF ( myIter.EQ.nIter0 .AND. myIter.NE.0
     &    .AND. fluidIsWater .AND. useRealFreshWaterFlux ) THEN

C     needs previous time-step value of E-P-R, that has not been loaded
C     and was not in old pickup-file ; try to use etaN & etaH instead.
         IF ( usePickupBeforeC54 ) THEN
          DO j=1,sNy
           DO i=1,sNx
            dEtaHdt(i,j,bi,bj) = (etaN(i,j,bi,bj)-etaH(i,j,bi,bj))
     &                         / (implicDiv2Dflow*deltaTFreeSurf)
           ENDDO
          ENDDO
         ENDIF

         DO j=1,sNy
          DO i=1,sNx
            PmEpR(i,j,bi,bj) = dEtaHdt(i,j,bi,bj)
     &                       + hDivFlow(i,j)*recip_rA(i,j,bi,bj)
     &                                      *recip_deepFac2F(1)
            PmEpR(i,j,bi,bj) = PmEpR(i,j,bi,bj)*rUnit2mass
          ENDDO
         ENDDO
       ELSEIF ( myIter.EQ.nIter0 ) THEN
         DO j=1,sNy
          DO i=1,sNx
            ks = kSurfC(i,j,bi,bj)
            PmEpR(i,j,bi,bj) = 0. _d 0
            dEtaHdt(i,j,bi,bj) = -hDivFlow(i,j)*recip_rA(i,j,bi,bj)
     &                                         *recip_deepFac2F(ks)
          ENDDO
         ENDDO
       ELSE
C--    Needs to get valid PmEpR (for T,S forcing) also in overlap regions
C       (e.g., if using KPP) => set over full index range
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
            PmEpR(i,j,bi,bj) = -EmPmR(i,j,bi,bj)
          ENDDO
         ENDDO
         DO j=1,sNy
          DO i=1,sNx
            ks = kSurfC(i,j,bi,bj)
            dEtaHdt(i,j,bi,bj) = -hDivFlow(i,j)*recip_rA(i,j,bi,bj)
     &                                         *recip_deepFac2F(ks)
     &                           -facEmP*EmPmR(i,j,bi,bj)
          ENDDO
         ENDDO
       ENDIF
C------------------------------------

#ifdef ALLOW_OBCS
C--    reset dEtaHdt to zero outside the OB interior region
       IF ( useOBCS ) THEN
         DO j=1,sNy
          DO i=1,sNx
            dEtaHdt(i,j,bi,bj) = dEtaHdt(i,j,bi,bj)*maskInC(i,j,bi,bj)
          ENDDO
         ENDDO
       ENDIF
#endif /* ALLOW_OBCS */

C-- end if exactConserv block
      ENDIF

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      IF ( exactConserv .AND. myIter.NE.nIter0 ) THEN
C--   Update etaN at the end of the time step :
C     Incorporate the Implicit part of -Divergence(Barotropic_Flow)

       IF ( implicDiv2Dflow.EQ.zeroRL ) THEN
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
           etaN(i,j,bi,bj) = etaH(i,j,bi,bj)
         ENDDO
        ENDDO
       ELSE
        DO j=1,sNy
         DO i=1,sNx
           etaN(i,j,bi,bj) = etaH(i,j,bi,bj)
     &      + implicDiv2Dflow*dEtaHdt(i,j,bi,bj)*deltaTFreeSurf
         ENDDO
        ENDDO
       ENDIF

#ifdef ALLOW_OBCS
C--    Was added on Dec 30, 2004 (to fix unrealistic etaN ?), but no longer
C      needed with proper masking in solver (matrix+cg2d_b,x) and masking
C      of dEtaHdt above. etaN next to OB does not enter present algorithm but
C      leave it commented out in case we would implement an aternative scheme.
c      IF ( useOBCS ) CALL OBCS_APPLY_ETA( bi, bj, etaN, myThid )
#endif /* ALLOW_OBCS */

C-- end if exactConserv and not myIter=nIter0 block
      ENDIF

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

# ifdef NONLIN_FRSURF
#  if (defined ALLOW_AUTODIFF_TAMC) && \
      (defined ALLOW_DEPTH_CONTROL) && (!defined DISABLE_RSTAR_CODE)
      tkey = bi + (bj-1)*nSx + (ikey_dynamics-1)*nSx*nSy
CADJ STORE dEtaHdt(:,:,bi,bj) = comlev1_bibj, key = tkey, kind = isbyte
#  endif
      IF ( select_rStar.NE.0 ) THEN
#  ifndef DISABLE_RSTAR_CODE
C-- note: rStarDhDt is similar to rStarDhCDt from S/R CALC_R_STAR
C         except for deep-factor and rho factor.
        DO j=1,sNy
         DO i=1,sNx
           ks = kSurfC(i,j,bi,bj)
           rStarDhDt(i,j) = dEtaHdt(i,j,bi,bj)
     &                     *deepFac2F(ks)*rhoFacF(ks)
     &                     *recip_Rcol(i,j,bi,bj)
         ENDDO
        ENDDO
#  endif /* DISABLE_RSTAR_CODE */
      ENDIF
#  if (defined ALLOW_AUTODIFF_TAMC) && \
      (defined ALLOW_DEPTH_CONTROL) && (!defined DISABLE_RSTAR_CODE)
CADJ STORE rStarDhDt = comlev1_bibj, key = tkey, kind = isbyte
#  endif
# endif /* NONLIN_FRSURF */

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      DO k=Nr,1,-1
C--    Integrate continuity vertically for vertical velocity

       CALL INTEGRATE_FOR_W(
     I                       bi, bj, k, uFld, vFld,
     I                       addMass, rStarDhDt,
     O                       wVel,
     I                       myIter, myThid )

       IF ( k.EQ.Nr .AND. myIter.NE.0 .AND. usingPCoords
     &      .AND. fluidIsWater .AND. useRealFreshWaterFlux ) THEN

         DO j=1,sNy
          DO i=1,sNx
            wVel(i,j,k,bi,bj) = wVel(i,j,k,bi,bj)
     &               +mass2rUnit*PmEpR(i,j,bi,bj)*maskC(i,j,k,bi,bj)
          ENDDO
         ENDDO

       ENDIF

#ifdef ALLOW_OBCS
C--    reset W to zero outside the OB interior region
       IF ( useOBCS ) THEN
         DO j=1,sNy
          DO i=1,sNx
             wVel(i,j,k,bi,bj) = wVel(i,j,k,bi,bj)*maskInC(i,j,bi,bj)
          ENDDO
         ENDDO
       ENDIF
C--    Apply OBC to W (non-hydrostatic):
       IF ( useOBCS.AND.nonHydrostatic )
     &                CALL OBCS_APPLY_W( bi, bj, k, wVel, myThid )
#endif /* ALLOW_OBCS */

C-    End DO k=Nr,1,-1
      ENDDO

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C--   End bi,bj loops
       ENDDO
      ENDDO

#ifdef ALLOW_AUTODIFF_MONITOR
C     In reverse, print adjoint variable for etaN
      CALL DUMMY_FOR_ETAN( myTime, myIter, myThid )
      _EXCH_XY_RL( etaN , myThid )
#else /* ALLOW_AUTODIFF_MONITOR */
      IF ( exactConserv .AND. myIter.NE.nIter0
     &                  .AND. implicDiv2Dflow .NE. 0. _d 0 )
     &    _EXCH_XY_RL( etaN , myThid )
#endif /* ALLOW_AUTODIFF_MONITOR */

      IF ( implicitIntGravWave .OR. myIter.EQ.nIter0 )
     &    _EXCH_XYZ_RL( wVel , myThid )

C--   Update etaH (from etaN and dEtaHdt):
      IF ( exactConserv ) THEN
c       IF ( useRealFreshWaterFlux .AND. myIter.EQ.nIter0 )
c    &    _EXCH_XY_RL( PmEpR, myThid )
#ifdef ALLOW_DEBUG
        IF ( debugMode ) CALL DEBUG_CALL('UPDATE_ETAH',myThid)
#endif
        CALL UPDATE_ETAH( myTime, myIter, myThid )
      ENDIF

#ifdef NONLIN_FRSURF
# ifndef DISABLE_SIGMA_CODE
      IF ( nonlinFreeSurf.GT.0 .AND. selectSigmaCoord.NE.0 ) THEN
        CALL EXCH_XY_RL( dEtaHdt, myThid )
        CALL UPDATE_ETAWS( myTime, myIter, myThid )
      ENDIF
# endif /* DISABLE_SIGMA_CODE */
#endif /* NONLIN_FRSURF */

      RETURN
      END

#include "MDSIO_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C !ROUTINE: MDS_WR_METAFILES
C !INTERFACE:
      SUBROUTINE MDS_WR_METAFILES(
     I   fName,
     I   filePrec,
     I   globalFile,
     I   useCurrentDir,
     I   nNx, nNy, nNz,
     I   titleLine,
     I   nFlds, fldList,
     I   nTimRec, timList,
     I   misVal,
     I   irecord,
     I   myIter,
     I   myThid )

C !DESCRIPTION:
C
C MDS_WR_METAFILES creates either a file of the form "fName.meta" IF the
C logical flag "globalFile" or "useSingleCPUIO" are set true. Otherwise
C it creates MDS tiled files of the form "fName.xxx.yyy.meta".
C Currently, the meta-files are not read because it is difficult
C to parse files in fortran. We should read meta information before
C adding records to an existing multi-record file.
C The precision of the file is decsribed by filePrec, set either
C to floatPrec32 or floatPrec64.
C nNz=1 implies a 2-D model field and nNz=Nr implies a 3-D model field.
C irecord is the record number to be written and must be >= 1.
C NOTE: It is currently assumed that
C the highest record number in the file was the last record written.
C Nor is there a consistency check between the routine arguments and file.
C ie. if you write record 2 after record 4 the meta information
C will record the number of records to be 2. This, again, is because
C we have read the meta information. To be fixed.

C     !USES:
      IMPLICIT NONE
C Global variables / COMMON blocks
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#ifdef ALLOW_EXCH2
#include "W2_EXCH2_SIZE.h"
#include "W2_EXCH2_TOPOLOGY.h"
#include "W2_EXCH2_PARAMS.h"
#endif /* ALLOW_EXCH2 */
C Arguments:
C
C fName     (string)  :: base name for file to write
C filePrec  (integer) :: number of bits per word in file (32 or 64)
C globalFile (logical):: selects between writing a global or tiled file
C useCurrentDir(logic):: always write to the current directory (even if
C                        "mdsioLocalDir" is set)
C nNx,nNy   (integer) :: used for writing YZ or XZ slice
C nNz       (integer) :: number of vertical levels to be written
C titleLine (string)  :: title or any descriptive comments
C nFlds     (integer) :: number of fields from "fldList" to write
C fldList   (string)  :: array of fields name to write
C nTimRec   (integer) :: number of time-info from "fldList" to write
C timList   (real)    :: array of time-info to write
C misVal    (real)    :: missing value (ignored if = 1.)
C irecord   (integer) :: record number to write
C myIter    (integer) :: time step number
C myThid    (integer) :: thread identifier
C
C Routine arguments
      CHARACTER*(*) fName
      INTEGER filePrec
      LOGICAL globalFile
      LOGICAL useCurrentDir
      INTEGER nNx, nNy, nNz
      CHARACTER*(*) titleLine
      INTEGER nFlds
      CHARACTER*(8) fldList(*)
      INTEGER nTimRec
      _RL     timList(*)
      _RL     misVal
      INTEGER irecord
      INTEGER myIter
      INTEGER myThid
CEOP

C Functions
      INTEGER  ILNBLNK
      EXTERNAL ILNBLNK
      LOGICAL  MASTER_CPU_IO
      EXTERNAL MASTER_CPU_IO
C Local variables
      CHARACTER*(MAX_LEN_FNAM) dataFName, metaFName, pfName
      INTEGER iG,jG, bi,bj, IL,pIL
      INTEGER dimList(3,3), nDims, map2gl(2)
      INTEGER xSize, ySize
      INTEGER tBx, tBy
#ifdef ALLOW_EXCH2
      INTEGER tN
#endif /* ALLOW_EXCH2 */

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C-    Set dimensions:
      xSize = Nx
      ySize = Ny
#ifdef ALLOW_EXCH2
      IF ( W2_useE2ioLayOut ) THEN
        xSize = exch2_global_Nx
        ySize = exch2_global_Ny
      ENDIF
#endif /* ALLOW_EXCH2 */
      IF (nNx.EQ.1) xSize = 1
      IF (nNy.EQ.1) ySize = 1

C Only do I/O if I am the master thread (and mpi process 0 IF useSingleCpuIO):
      IF ( MASTER_CPU_IO(myThid) ) THEN

       IF ( useSingleCpuIO .OR. globalFile ) THEN

         IL  = ILNBLNK( fName )
         WRITE(dataFName,'(2A)') fName(1:IL),'.data'
         WRITE(metaFName,'(2A)') fName(1:IL),'.meta'
         dimList(1,1) = xSize
         dimList(2,1) = 1
         dimList(3,1) = xSize
         dimList(1,2) = ySize
         dimList(2,2) = 1
         dimList(3,2) = ySize
         dimList(1,3) = nNz
         dimList(2,3) = 1
         dimList(3,3) = nNz
         nDims=3
         IF (nNz.EQ.1) nDims=2
         map2gl(1) = 0
         map2gl(2) = 1
         CALL MDS_WRITE_META(
     I              metaFName, dataFName, the_run_name, titleLine,
     I              filePrec, nDims,dimList,map2gl, nFlds, fldList,
     I              nTimRec, timList, misVal, irecord, myIter, myThid )

       ELSE

C Assign special directory
        pIL = ILNBLNK( mdsioLocalDir )
        IF ( useCurrentDir .OR. pIL.EQ.0 ) THEN
          pfName = fName
        ELSE
          IL  = ILNBLNK( fName )
          WRITE(pfName,'(2A)') mdsioLocalDir(1:pIL), fName(1:IL)
        ENDIF
        pIL=ILNBLNK( pfName )

C Loop over all tiles
        DO bj=1,nSy
         DO bi=1,nSx
C If we are writing to a tiled MDS file then we open each one here
           iG=bi+(myXGlobalLo-1)/sNx
           jG=bj+(myYGlobalLo-1)/sNy
           WRITE(dataFName,'(2a,i3.3,a,i3.3,a)')
     &              pfName(1:pIL),'.',iG,'.',jG,'.data'
C Create meta-file for each tile IF we are tiling
           WRITE(metaFname,'(2a,i3.3,a,i3.3,a)')
     &              pfName(1:pIL),'.',iG,'.',jG,'.meta'
           tBx = myXGlobalLo-1 + (bi-1)*sNx
           tBy = myYGlobalLo-1 + (bj-1)*sNy
           map2gl(1) = 0
           map2gl(2) = 1
#ifdef ALLOW_EXCH2
           IF ( W2_useE2ioLayOut ) THEN
             tN = W2_myTileList(bi,bj)
             tBx = exch2_txGlobalo(tN) - 1
             tBy = exch2_tyGlobalo(tN) - 1
             IF (nNx.EQ.0 .AND. nNy.EQ.0) THEN
              IF   ( exch2_mydNx(tN) .GT. xSize ) THEN
C-            face x-size larger than glob-size : fold it
                map2gl(1) = 0
                map2gl(2) = exch2_mydNx(tN) / xSize
              ELSEIF ( exch2_tNy(tN) .GT. ySize ) THEN
C-            tile y-size larger than glob-size : make a long line
                map2gl(1) = exch2_mydNx(tN)
                map2gl(2) = 0
              ELSE
C-            default (face fit into global-IO-array)
                map2gl(1) = 0
                map2gl(2) = 1
              ENDIF
             ENDIF
           ENDIF
#endif /* ALLOW_EXCH2 */
           dimList(1,1) = xSize
           dimList(2,1) = tBx + 1
           dimList(3,1) = tBx + sNx
           dimList(1,2) = ySize
           dimList(2,2) = tBy + 1
           dimList(3,2) = tBy + sNy
           dimList(1,3) = nNz
           dimList(2,3) = 1
           dimList(3,3) = nNz
           nDims=3
           IF (nNz.EQ.1) nDims=2
           IF (nNx.EQ.1) dimList(2,1) = 1
           IF (nNx.EQ.1) dimList(3,1) = 1
           IF (nNy.EQ.1) dimList(2,2) = 1
           IF (nNy.EQ.1) dimList(3,2) = 1
           CALL MDS_WRITE_META(
     I              metaFName, dataFName, the_run_name, titleLine,
     I              filePrec, nDims,dimList,map2gl, nFlds, fldList,
     I              nTimRec, timList, misVal, irecord, myIter, myThid )
C End of bi,bj loops
         ENDDO
        ENDDO

C endif useSingleCpuIO or globalFile
       ENDIF

C endif MASTER_CPU_IO
      ENDIF

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      RETURN
      END

#include "OBCS_OPTIONS.h"

CBOP
C     !ROUTINE: OBCS_OUTPUT

C     !INTERFACE:
      SUBROUTINE OBCS_OUTPUT( myTime, myIter, myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE OBCS_OUTPUT
C     | o General routine for OBCS output
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     == Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "OBCS_PARAMS.h"
#include "OBCS_FIELDS.h"

C     !INPUT PARAMETERS:
C     myTime :: my time in simulation ( s )
C     myIter :: my Iteration number
C     myThid :: my Thread Id number
      _RL     myTime
      INTEGER myIter
      INTEGER myThid
CEOP

#ifdef ALLOW_OBCS
C     !FUNCTIONS:
      LOGICAL  DIFFERENT_MULTIPLE
      EXTERNAL DIFFERENT_MULTIPLE
c     INTEGER  ILNBLNK
c     EXTERNAL ILNBLNK

C     !LOCAL VARIABLES:
      CHARACTER*(10) suff
      CHARACTER*(MAX_LEN_FNAM) fn
      INTEGER prec

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      IF ( DIFFERENT_MULTIPLE( dumpFreq, myTime, deltaTClock )
     &     .AND. OBCSprintDiags .AND. myIter.NE.nIter0
     &   ) THEN

C--   Generaly only thread 1 does IO here. It can not start until
C--   all threads fields are ready.
       _BARRIER

#ifdef ALLOW_OBCS_NORTH
        CALL PLOT_FIELD_XZRL( OBNu, 'OBNu' , Nr, myIter, myThid )
        CALL PLOT_FIELD_XZRL( OBNv, 'OBNv' , Nr, myIter, myThid )
        CALL PLOT_FIELD_XZRL( OBNt, 'OBNt' , Nr, myIter, myThid )
        CALL PLOT_FIELD_XZRL( OBNs, 'OBNs' , Nr, myIter, myThid )
#endif

#ifdef ALLOW_OBCS_SOUTH
        CALL PLOT_FIELD_XZRL( OBSu, 'OBSu' , Nr, myIter, myThid )
        CALL PLOT_FIELD_XZRL( OBSv, 'OBSv' , Nr, myIter, myThid )
        CALL PLOT_FIELD_XZRL( OBSt, 'OBSt' , Nr, myIter, myThid )
        CALL PLOT_FIELD_XZRL( OBSs, 'OBSs' , Nr, myIter, myThid )
#endif

#ifdef ALLOW_OBCS_EAST
        CALL PLOT_FIELD_YZRL( OBEu, 'OBEu' , Nr, myIter, myThid )
        CALL PLOT_FIELD_YZRL( OBEv, 'OBEv' , Nr, myIter, myThid )
        CALL PLOT_FIELD_YZRL( OBEt, 'OBEt' , Nr, myIter, myThid )
        CALL PLOT_FIELD_YZRL( OBEs, 'OBEs' , Nr, myIter, myThid )
#endif

#ifdef ALLOW_OBCS_WEST
        CALL PLOT_FIELD_YZRL( OBWu, 'OBWu' , Nr, myIter, myThid )
        CALL PLOT_FIELD_YZRL( OBWv, 'OBWv' , Nr, myIter, myThid )
        CALL PLOT_FIELD_YZRL( OBWt, 'OBWt' , Nr, myIter, myThid )
        CALL PLOT_FIELD_YZRL( OBWs, 'OBWs' , Nr, myIter, myThid )
#endif

      ENDIF

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C--   Write OB aray to binary files (mainly for debugging => use "diagFreq")
      IF ( DIFFERENT_MULTIPLE( diagFreq, myTime, deltaTClock )
     &     .AND. myIter.NE.nIter0
     &   ) THEN

       _BARRIER
c       IF ( rwSuffixType.EQ.0 ) THEN
          WRITE(suff,'(I10.10)') myIter
c       ELSE
c         CALL RW_GET_SUFFIX( suff, myTime, myIter, myThid )
c       ENDIF
        prec = writeBinaryPrec

#ifdef ALLOW_OBCS_NORTH
C     Write Northern OB arrays
        WRITE(fn,'(A,A)') 'obcs_N.', suff
        CALL WRITE_REC_XZ_RL(fn,prec,Nr,OBNu,1,myIter,myThid)
        CALL WRITE_REC_XZ_RL(fn,prec,Nr,OBNv,2,myIter,myThid)
        CALL WRITE_REC_XZ_RL(fn,prec,Nr,OBNt,3,myIter,myThid)
        CALL WRITE_REC_XZ_RL(fn,prec,Nr,OBNs,4,myIter,myThid)
# ifdef ALLOW_NONHYDROSTATIC
       IF ( nonHydrostatic ) THEN
        CALL WRITE_REC_XZ_RL(fn,prec,Nr,OBNw,5,myIter,myThid)
       ENDIF
# endif
#endif

#ifdef ALLOW_OBCS_SOUTH
C     Write Southern OB arrays
        WRITE(fn,'(A,A)') 'obcs_S.', suff
        CALL WRITE_REC_XZ_RL(fn,prec,Nr,OBSu,1,myIter,myThid)
        CALL WRITE_REC_XZ_RL(fn,prec,Nr,OBSv,2,myIter,myThid)
        CALL WRITE_REC_XZ_RL(fn,prec,Nr,OBSt,3,myIter,myThid)
        CALL WRITE_REC_XZ_RL(fn,prec,Nr,OBSs,4,myIter,myThid)
# ifdef ALLOW_NONHYDROSTATIC
       IF ( nonHydrostatic ) THEN
        CALL WRITE_REC_XZ_RL(fn,prec,Nr,OBSw,5,myIter,myThid)
       ENDIF
# endif
#endif

#ifdef ALLOW_OBCS_EAST
C     Write Eastern OB arrays
        WRITE(fn,'(A,A)') 'obcs_E.', suff
        CALL WRITE_REC_YZ_RL(fn,prec,Nr,OBEu,1,myIter,myThid)
        CALL WRITE_REC_YZ_RL(fn,prec,Nr,OBEv,2,myIter,myThid)
        CALL WRITE_REC_YZ_RL(fn,prec,Nr,OBEt,3,myIter,myThid)
        CALL WRITE_REC_YZ_RL(fn,prec,Nr,OBEs,4,myIter,myThid)
# ifdef ALLOW_NONHYDROSTATIC
       IF ( nonHydrostatic ) THEN
        CALL WRITE_REC_YZ_RL(fn,prec,Nr,OBEw,5,myIter,myThid)
       ENDIF
# endif
#endif

#ifdef ALLOW_OBCS_WEST
C     Write Western OB arrays
        WRITE(fn,'(A,A)') 'obcs_W.', suff
        CALL WRITE_REC_YZ_RL(fn,prec,Nr,OBWu,1,myIter,myThid)
        CALL WRITE_REC_YZ_RL(fn,prec,Nr,OBWv,2,myIter,myThid)
        CALL WRITE_REC_YZ_RL(fn,prec,Nr,OBWt,3,myIter,myThid)
        CALL WRITE_REC_YZ_RL(fn,prec,Nr,OBWs,4,myIter,myThid)
# ifdef ALLOW_NONHYDROSTATIC
       IF ( nonHydrostatic ) THEN
        CALL WRITE_REC_YZ_RL(fn,prec,Nr,OBWw,5,myIter,myThid)
       ENDIF
# endif
#endif

       _BARRIER

      ENDIF

C--   Compute and print statistics of dynamic fields at OB:
      CALL OBCS_MONITOR( myTime, myIter, myThid )

#endif /* ALLOW_OBCS */

      RETURN
      END

#include "FLT_OPTIONS.h"

C     ==================================================================
C
C     Float Package for the MIT Model
C
C     Main Routines:
C
C     o flt_main       - Integrates the floats forward and stores
C                        positions and vertical profiles at specific
C                        time intervals.
C     o flt_readparms  - Read parameter file
C     o flt_init_fixed - Initialise fixed
C     o flt_init_varia - Initialise the floats
C     o flt_restart    - Writes restart data to file (=> renamed: flt_write_pickup)
C
C     Second Level Subroutines:
C
C     o flt_runga2     - Second order Runga-Kutta inetgration (default)
C     o flt_exchg      - Does a new distribution of floats over tiles
C                        after every integration step.
C     o flt_up         - moves float to the surface (if flag is set)
C                        and stores profiles to file
C     o flt_down       - moves float to its target depth (if flag is set)
C     o flt_traj       - stores positions and data to file
C     o flt_interp_linear  - contains blinear interpolation scheme
C     o flt_mapping        - contains mapping functions & subroutine
C     o flt_mdsreadvector  - modified mdsreadvector to read files
C
C     ToDo:
C
C     o avoid exchanges when arrays empty
C     o 3D advection of floats
C
C     ==================================================================
C
C     Documentation:
C
C     To be made....
C
C
C     started: Arne Biastoch abiastoch@ucsd.edu 10-Jan-2000
C              (adopted from version written by Detlef Stammer
C               for the old model code)
C
C     changed: Arne Biastoch abiastoch@ucsd.edu 21-JUN-2001
C
C     ==================================================================

CBOP 0
C !ROUTINE: FLT_MAIN

C !INTERFACE:
      SUBROUTINE FLT_MAIN (
     I                      myTime, myIter, myThid )

C     !DESCRIPTION:
C     ==================================================================
C     SUBROUTINE FLT_MAIN
C     ==================================================================
C     o This routine steps floats forward in time and samples the model
C       state at float position every flt_int_traj time steps.
C       Also moves the float up and down and samples vertical profiles.
C
C     o Uses  2nd or fourth order runga-kutta
C     o Spatial interpolation is bilinear close to boundaries and otherwise
C       a polynomial interpolation.
C     o Particles are kept in grid space (with position of dp taken as
C       x(south), y(east) grid cell point)
C     o Calls profile every flt_int_prof time steps; in that event the
C       profile over the whole water column is written to file and the
C       float might be moved upwards to the surface (depending on its
C       configuration).
C     ==================================================================

C     !USES:
      IMPLICIT NONE
C     == global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "FLT_SIZE.h"
#include "FLT.h"

C     !INPUT PARAMETERS:
C     myTime :: current time in simulation
C     myIter :: current iteration number
C     myThid :: my Thread Id number
      _RL myTime
      INTEGER myIter, myThid

C     !FUNCTIONS:
      LOGICAL  DIFFERENT_MULTIPLE
      EXTERNAL DIFFERENT_MULTIPLE

C     !LOCAL VARIABLES:
CEOP

#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_ENTER( 'FLT_MAIN', myThid )
#endif

C--   integration of the float trajectories
#ifdef ALLOW_DEBUG
         IF (debugMode) CALL DEBUG_CALL('FLT_RUNGA*', myThid )
#endif
#ifdef FLT_SECOND_ORDER_RUNGE_KUTTA
c         WRITE(0,*) ' bf call flt_runga2', myIter
         CALL TIMER_START('FLOATS RUNGA2      [FLT  LOOP]',myThid)
         CALL FLT_RUNGA2( myTime, myIter, myThid )
         CALL TIMER_STOP ('FLOATS RUNGA2      [FLT  LOOP]',myThid)
c         WRITE(0,*) ' af call flt_runga2', myIter
#else
c         WRITE(0,*) ' bf call flt_runga4', myIter
         CALL TIMER_START('FLOATS RUNGA4      [FLT  LOOP]',myThid)
         CALL FLT_RUNGA4( myTime, myIter, myThid )
         CALL TIMER_STOP ('FLOATS RUNGA4      [FLT  LOOP]',myThid)
c         WRITE(0,*) ' af call flt_runga4', myIter
#endif

C--   do exchanges between tiles if necessary

#ifdef ALLOW_DEBUG
         IF (debugMode) CALL DEBUG_CALL('FLT_EXCH*', myThid )
#endif
         CALL TIMER_START('FLOATS EXCHG       [FLT  LOOP]',myThid)
#ifdef ALLOW_EXCH2
         CALL FLT_EXCH2( myTime, myIter, myThid )
#else
         CALL FLT_EXCHG( myTime, myIter, myThid )
#endif
         CALL TIMER_STOP ('FLOATS EXCHG       [FLT  LOOP]',myThid)

C--   store profiles every flt_int_prof time steps and move floats up and down

         IF (  DIFFERENT_MULTIPLE( flt_int_prof, myTime, deltaTClock )
     &      ) THEN
#ifdef ALLOW_DEBUG
           IF (debugMode) CALL DEBUG_CALL('FLT_UP', myThid )
#endif
           CALL TIMER_START('FLOATS UP          [FLT  LOOP]',myThid)
           CALL FLT_UP( myTime, myIter, myThid )
           CALL TIMER_STOP ('FLOATS UP          [FLT  LOOP]',myThid)
         ENDIF

#ifdef ALLOW_DEBUG
         IF (debugMode) CALL DEBUG_CALL('FLT_DOWN', myThid )
#endif
c         WRITE(0,*) ' bf call flt_down', myIter
           CALL TIMER_START('FLOATS DOWN        [FLT  LOOP]',myThid)
           CALL FLT_DOWN( myTime, myIter, myThid )
           CALL TIMER_STOP ('FLOATS DOWN        [FLT  LOOP]',myThid)
c         WRITE(0,*) ' af call flt_down', myIter

C--   store particles every flt_int_traj timesteps:

         IF (  DIFFERENT_MULTIPLE( flt_int_traj, myTime, deltaTClock )
     &      ) THEN
#ifdef ALLOW_DEBUG
           IF (debugMode) CALL DEBUG_CALL('FLT_TRAJ', myThid )
#endif
c         WRITE(0,*) ' bf call flt_traj', myIter
           CALL TIMER_START('FLOATS TRAJ        [FLT  LOOP]',myThid)
           CALL FLT_TRAJ( myTime, myIter, myThid )
           CALL TIMER_STOP ('FLOATS TRAJ        [FLT  LOOP]',myThid)
c         WRITE(0,*) ' af call flt_traj', myIter
         ENDIF

#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_LEAVE( 'FLT_MAIN', myThid )
#endif

      RETURN
      END

#include "MOM_FLUXFORM_OPTIONS.h"

CBOP
C !ROUTINE: MOM_U_ADV_VU

C !INTERFACE: ==========================================================
      SUBROUTINE MOM_U_ADV_VU(
     I        bi, bj, k,
     I        vTrans, uFld,
     O        AdvectFluxVU,
     I        myThid )

C !DESCRIPTION:
C Calculates the meridional advective flux of zonal momentum:
C \begin{equation*}
C F^y = \overline{V}^i \overline{u}^{j}
C \end{equation*}

C !USES: ===============================================================
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"

C !INPUT PARAMETERS: ===================================================
C  bi, bj               :: tile indices
C  k                    :: vertical level
C  vTrans               :: meridional transport
C  uFld                 :: zonal velocity
C  myThid               :: my Thread Id number
      INTEGER bi, bj, k
      _RL vTrans(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL uFld(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER myThid

C !OUTPUT PARAMETERS: ==================================================
C  AdvectFluxVU         :: advective flux
      _RL AdvectFluxVU(1-OLx:sNx+OLx,1-OLy:sNy+OLy)

C !LOCAL VARIABLES: ====================================================
C  i,j                  :: loop indices
      INTEGER i,j
CEOP

      IF ( selectMetricTerms.NE.3 ) THEN
        DO j=1-OLy+1,sNy+OLy
         DO i=1-OLx+1,sNx+OLx
          AdvectFluxVU(i,j) = 0.25 _d 0
     &        *( vTrans(i,j) + vTrans(i-1,j) )
#ifdef MOM_BOUNDARY_CONSERVE
     &        *(   uFld(i,j)*_maskW(i,j-1,k,bi,bj)
     &         + uFld(i,j-1)*_maskW(i,j,k,bi,bj) )
#else
     &        *( uFld(i,j) + uFld(i,j-1) )
#endif
#ifdef OLD_ADV_BCS
     &        *_maskW(i,j,k,bi,bj)
     &        *_maskW(i,j-1,k,bi,bj)
#endif /* OLD_ADV_BCS */
         ENDDO
        ENDDO
      ELSE
C-    Advect u*dxC (--> account for metric term u*v*tanPhi/R)
        DO j=1-OLy+1,sNy+OLy
         DO i=1-OLx+1,sNx+OLx
          AdvectFluxVU(i,j) = 0.25 _d 0
     &        *( vTrans(i,j) + vTrans(i-1,j) )
#ifdef MOM_BOUNDARY_CONSERVE
     &        *( uFld(i, j )*dxC(i, j, bi,bj)*_maskW(i,j-1,k,bi,bj)
     &         + uFld(i,j-1)*dxC(i,j-1,bi,bj)*_maskW(i, j, k,bi,bj) )
#else
     &        *( uFld(i, j )*dxC(i, j, bi,bj)
     &         + uFld(i,j-1)*dxC(i,j-1,bi,bj) )
#endif
         ENDDO
        ENDDO
      ENDIF

      RETURN
      END

!=======================================================================
      subroutine MITCPLR_init1( myTypeStr, couplerFlag )
      implicit none

! MPI variables
#include "mpif.h"

! Predefined constants/arrays
#include "CPLR_SIG.h"

! Arguments
      character*(*) myTypeStr
      logical couplerFlag

! Functions
      integer mitcplr_match_comp
      external mitcplr_match_comp

! Local
      integer myid, numprocs, ierr
      integer n,j
      integer MPI_GROUP_World
      integer MPI_GROUP_Tmp
      integer lenbuf
      integer compind
      integer ibuf(MAX_IBUF)
      character*(MAXLEN_COMP_NAME) cbuf

!     ------------------------------------------------------------------

! Find-out my position (rank) in the "world" communicator
      call MPI_COMM_RANK( MPI_COMM_WORLD, myid, ierr )
      if (ierr.ne.0) write(0,*) 'MITCPLR_init1: ',myid,' ',myTypeStr,
     &     ' Rank = ',myid,' MPI_COMM_RANK ierr=',ierr
! How big is the "world"?
      call MPI_COMM_SIZE( MPI_COMM_WORLD, numprocs, ierr )
      if (ierr.ne.0) write(0,*) 'MITCPLR_init1: ',myid,' ',myTypeStr,
     &     ' Size = ',numprocs,' MPI_COMM_RANK ierr=',ierr
      if (DEBUG) write(0,*) 'MITCPLR_init1: ',myid,' ',myTypeStr,
     &     ' Rank/Size = ',myid,' /',numprocs

!     - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

! Registration: collect/bcast lists of who is who

! Assume nothing
      num_components = 0
      num_coupler_procs = 0

! Receive a message from each of the other processes
      do n=0,numprocs-1
       ibuf(1)=myid
       ibuf(2)=0
       if ( couplerFlag ) ibuf(2)=MITCPLR_COUPLER
       ibuf(3)=0
       ibuf(4)=0
       ibuf(5)=0
       ibuf(6)=0
       ibuf(7)=0
       call mitcplr_char2int( myTypeStr, ibuf(8) )
       lenbuf=8+MAXLEN_COMP_NAME
       call MPI_Bcast(
     &               ibuf, lenbuf, MPI_INTEGER,
     &               n,
     &               MPI_COMM_WORLD, ierr )
       if (DEBUG) write(0,*) 'MITCPLR_init1: ',myid,' ',myTypeStr,
     &    ' MPI_Bcast from ',ibuf(1),ibuf(2),' ierr=',ierr
       call mitcplr_int2char( ibuf(8), cbuf )
       if (DEBUG) write(0,*) 'MITCPLR_init1: ',myid,' ',myTypeStr,
     &    ' Bcast cbuf=',cbuf,'x'

       if ( ibuf(2).eq.MITCPLR_COUPLER ) then
! If the broadcaster is the "coupler"
        num_coupler_procs=num_coupler_procs + 1
        rank_coupler_procs(num_coupler_procs) = ibuf(1)
        coupler_Name=cbuf
       else
! If the broadcaster is a "component"
        compind=mitcplr_match_comp( cbuf )
        if (DEBUG) write(0,*) 'MITCPLR_init1: ',myid,' ',myTypeStr,
     &    ' compind=',compind
        num_component_procs(compind)=num_component_procs(compind) + 1
        j=num_component_procs(compind)
        rank_component_procs(j,compind)=ibuf(1)
       endif

      enddo

      if ( num_coupler_procs .ne. 1 ) then
       STOP 'MITCPLR_init1: I can only handle one coupler process'
      endif

      do compind=1,num_components
       num_compcplr_procs(compind)=num_component_procs(compind) + 1
       do j=1,num_compcplr_procs(compind)
        rank_compcplr_procs(j,compind)=rank_component_procs(j,compind)
       enddo
       j=num_compcplr_procs(compind)
       rank_compcplr_procs(j,compind)=rank_coupler_procs(1)
       call mitcplr_sortranks( j, rank_compcplr_procs(1,compind) )
      enddo

      if (DEBUG) write(0,*) 'MITCPLR_init1: ',myid,' ',myTypeStr,
     &   ' coupler=',coupler_Name,
     &   ( rank_coupler_procs(j),j=1,num_coupler_procs )
      do n=1,num_components
       if (DEBUG) write(0,*) 'MITCPLR_init1: ',myid,' ',myTypeStr,
     &    ' component=',component_Name(n),
     &    ( rank_component_procs(j,n),j=1,num_component_procs(n) )
       if (DEBUG) write(0,*) 'MITCPLR_init1: ',myid,' ',myTypeStr,
     &    ' comp+cplr=',component_Name(n),
     &    ( rank_compcplr_procs(j,n),j=1,num_compcplr_procs(n) )
      enddo

!     - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

! Create new groups and communicators

! Establish MPI_GROUP_World associated with MPI_COMM_WORLD
      call MPI_Comm_group( MPI_COMM_WORLD, MPI_GROUP_World, ierr )
      if (DEBUG) write(0,*) 'MITCPLR_init1: ',myid,' ',myTypeStr,
     &    ' MPI_Comm_group MPI_GROUP_World=',MPI_GROUP_World,
     &    ' ierr=',ierr

      do n=1,num_components

! Create group MPI_GROUP_Tmp
       call MPI_Group_incl(
     &   MPI_GROUP_World,
     &   num_component_procs(n),
     &   rank_component_procs(1,n),
     &   MPI_GROUP_Tmp,
     &   ierr )
       if (DEBUG) write(0,*) 'MITCPLR_init1: ',myid,' ',myTypeStr,
     &   ' MPI_Group_incl MPI_GROUP_Tmp=',
     &   MPI_GROUP_Tmp,' ierr=',ierr

! Create communicator MPI_COMM_component
       call MPI_Comm_create(
     &   MPI_COMM_WORLD,
     &   MPI_GROUP_Tmp,
     &   MPI_COMM_component(n),
     &   ierr )
       if (DEBUG) write(0,*) 'MITCPLR_init1: ',myid,' ',myTypeStr,
     &   ' MPI_Comm_create MPI_COMM_component=',MPI_COMM_component(n),
     &   ' ierr=',ierr

! Create group MPI_GROUP_Tmp
       call MPI_Group_incl(
     &   MPI_GROUP_World,
     &   num_compcplr_procs(n),
     &   rank_compcplr_procs(1,n),
     &   MPI_GROUP_Tmp,
     &   ierr )
       if (DEBUG) write(0,*) 'MITCPLR_init1: ',myid,' ',myTypeStr,
     &   ' MPI_Group_incl MPI_GROUP_Tmp=',
     &   MPI_GROUP_Tmp,' ierr=',ierr

! Create communicator MPI_COMM_compcplr
       call MPI_Comm_create(
     &   MPI_COMM_WORLD,
     &   MPI_GROUP_Tmp,
     &   MPI_COMM_compcplr(n),
     &   ierr )
       if (DEBUG) write(0,*) 'MITCPLR_init1: ',myid,' ',myTypeStr,
     &   ' MPI_Comm_create MPI_COMM_compcplr=',MPI_COMM_compcplr(n),
     &   ' ierr=',ierr

      enddo

!     - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -

      if ( couplerFlag ) then
       my_component_ind=-1
       MPI_COMM_mylocal=MPI_COMM_World
       MPI_COMM_myglobal=MPI_COMM_World
       my_component_name=coupler_Name
      else
       compind=mitcplr_match_comp( myTypeStr )
       my_component_ind=compind
       MPI_COMM_mylocal=MPI_COMM_component( compind )
       MPI_COMM_myglobal=MPI_COMM_compcplr( compind )
       my_component_name=component_Name( compind )
      endif

      if (DEBUG) write(0,*) 'MITCPLR_init1: ',myid,' ',myTypeStr,
     &   ' component num=',compind,
     &   ' MPI_COMM=',MPI_COMM_mylocal,MPI_COMM_myglobal

      if ( couplerFlag ) then
       do n=1,num_components
! Find-out my position (rank) in the "global" communicator
        call MPI_COMM_RANK( MPI_COMM_compcplr(n), j, ierr )
        if (ierr.ne.0) write(0,*) 'MITCPLR_init1: ',myid,' ',myTypeStr,
     &     ' Rank = ',j,' MPI_COMM_RANK ierr=',ierr
! How big is the "global" communicator?
        call MPI_COMM_SIZE( MPI_COMM_compcplr(n), numprocs, ierr )
        if (ierr.ne.0) write(0,*) 'MITCPLR_init1: ',myid,' ',myTypeStr,
     &     ' Size = ',numprocs,' MPI_COMM_SIZE ierr=',ierr
        if (DEBUG) write(0,*) 'MITCPLR_init1: ',myid,' ',myTypeStr,
     &     ' Rank/Size = ',j,' /',numprocs,
     &     ' in Component =',n
       enddo
      else
! Find-out my position (rank) in the "global" communicator
       call MPI_COMM_RANK( MPI_COMM_myglobal, j, ierr )
       if (ierr.ne.0) write(0,*) 'MITCPLR_init1: ',myid,' ',myTypeStr,
     &     ' Rank = ',j,' MPI_COMM_RANK ierr=',ierr
! How big is the "global" communicator?
       call MPI_COMM_SIZE( MPI_COMM_myglobal, numprocs, ierr )
       if (ierr.ne.0) write(0,*) 'MITCPLR_init1: ',myid,' ',myTypeStr,
     &     ' Size = ',numprocs,' MPI_COMM_SIZE ierr=',ierr
       if (DEBUG) write(0,*) 'MITCPLR_init1: ',myid,' ',myTypeStr,
     &     ' Rank/Size = ',j,' /',numprocs
      endif

! Open log file
      if ( couplerFlag ) j=myid
      write(cbuf(1:MAXLEN_COMP_NAME),'(2a,i4.4,a)')
     &   myTypeStr,'.',j,'.clog'
      open(LogUnit,file=cbuf,status='unknown',form='formatted')
      write(LogUnit,'(2a)') '========================================',
     & '========================================'
      write(LogUnit,*) 'This is "',myTypeStr,'"'
      write(LogUnit,*) 'myid in MPI_COMM_World = ',myid
      if (.not.couplerFlag)
     &  write(LogUnit,*) 'myid in MPI_COMM_Global = ',j

!     ------------------------------------------------------------------
      return
      end
!=======================================================================

#include "CPP_EEOPTIONS.h"
      subroutine template()
      use OAD_tape
      use OAD_rev

!$TEMPLATE_PRAGMA_DECLARATIONS

      type(modeType) :: our_orig_mode

c lovcal vars:
      INTEGER , PARAMETER :: nArgsHelper=9 
      INTEGER argsHelper(nArgsHelper)
      _RL     array_p( 1-myOLw:sNx+myOLe,
     &               1-myOLs:sNy+myOLn,
     &               myNz, nSx, nSy )

#ifdef OAD_DEBUG_SPLIT1
      character*(80):: indentation='                                        
     +                                         '
      our_indent=our_indent+1

      write(standardmessageunit, '(A,A,A)', ADVANCE='NO') 
     +'OAD:',indentation(1:our_indent), 'enter __SRNAME__:'
      call oad_dump_revmod(); call oad_dump_tapestats()
      write(standardmessageunit,*) 
#endif

      if (our_rev_mode%plain) then
#ifdef OAD_DEBUG_SPLIT1
         write(standardmessageunit,'(A,A,A)') 
     +'OAD:',indentation(1:our_indent), 
     +' __SRNAME__: entering plain'
#endif
c copy the values
         array_p = array%v
c keep the mode
         our_orig_mode=our_rev_mode
c set up for plain execution
         call OAD_revPlain()
c do it
         call EXCH1_RL( 
     U                 array_p,
     I                 myOLw, myOLe, myOLs, myOLn, myNz,
     I                 exchWidthX, exchWidthY,
     I                 cornerMode, myThid )
c reset the mode
         our_rev_mode=our_orig_mode
c copy back
         array%v = array_p
      end if
      if (our_rev_mode%tape) then
#ifdef OAD_DEBUG_SPLIT1
         write(standardmessageunit,'(A,A,A)') 
     +'OAD:',indentation(1:our_indent), 
     +' __SRNAME__: entering tape'
#endif
c copy the values
         array_p = array%v
c copy the args in case they are overwritte
         argsHelper=(/myOLw, myOLe, myOLs, myOLn, myNz,exchWidthX, 
     +exchWidthY,cornerMode, myThid/)
c keep the mode
         our_orig_mode=our_rev_mode
c set up for plain execution
         call OAD_revPlain()
c do it
         call EXCH1_RL(
     U                 array_p,
     I                 myOLw, myOLe, myOLs, myOLn, myNz,
     I                 exchWidthX, exchWidthY,
     I                 cornerMode, myThid )
c reset the mode
         our_rev_mode=our_orig_mode
c copy back
         array%v = array_p
c store the args:
         if(oad_it_sz.lt. oad_it_ptr+nArgsHelper) call oad_it_grow()
         oad_it(oad_it_ptr:oad_it_ptr+nArgsHelper-1)=argsHelper
         oad_it_ptr=oad_it_ptr+nArgsHelper
      end if
      if (our_rev_mode%adjoint) then
c restore the args:
      oad_it_ptr=oad_it_ptr-nArgsHelper
      argsHelper=oad_it(oad_it_ptr:oad_it_ptr+nArgsHelper-1)
#ifdef OAD_DEBUG_SPLIT1
         write(standardmessageunit,'(A,A,A)') 
     +'OAD:',indentation(1:our_indent), 
     +' __SRNAME__: entering adjoint'
#endif
c copy the adjoints
         array_p = array%d
c keep the mode
         our_orig_mode=our_rev_mode
c set up for plain execution
         call OAD_revPlain()
c call the manual adjoint
         call EXCH1_RL_AD(
     U                 array_p,
     I                 argsHelper(1),argsHelper(2),argsHelper(3),
     I                 argsHelper(4),argsHelper(5),argsHelper(6),
     I                 argsHelper(7),argsHelper(8),argsHelper(9) )
c reset the mode
         our_rev_mode=our_orig_mode
c copy back
         array%d = array_p
      end if

#ifdef OAD_DEBUG_SPLIT1
      write(standardmessageunit,'(A,A,A)', ADVANCE='NO') 
     +'OAD:',indentation(1:our_indent), 'leave __SRNAME__:'
      call oad_dump_revmod(); call oad_dump_tapestats()
      write(standardmessageunit,*) 

      our_indent=our_indent-1
#endif

      end subroutine template

#include "CAL_OPTIONS.h"

      SUBROUTINE CAL_GETDATE(
     I                        myIter,
     I                        myTime,
     O                        mydate,
     I                        myThid )

C     ==================================================================
C     SUBROUTINE cal_GetDate
C     ==================================================================
C
C     o Determine the current date given the iteration number and/or the
C       current time of integration.
C     <- changed to be function of current time only (less ambiguous)
C
C     started: Christian Eckert eckert@mit.edu  30-Jun-1999
C     changed: Christian Eckert eckert@mit.edu  29-Dec-1999
C              - restructured the original version in order to have a
C                better interface to the MITgcmUV.
C              Christian Eckert eckert@mit.edu  03-Feb-2000
C              - Introduced new routine and function names, cal_<NAME>,
C                for verion 0.1.3.
C
C     ==================================================================
C     SUBROUTINE cal_GetDate
C     ==================================================================

      IMPLICIT NONE

C     == global variables ==
#include "EEPARAMS.h"
#include "cal.h"

C     == routine arguments ==
      INTEGER myIter
      _RL     myTime
      INTEGER mydate(4)
      INTEGER myThid

C     == local variables ==
      _RL     secs
      INTEGER workdate(4)
      CHARACTER*(MAX_LEN_MBUF) msgBuf
C     == end of interface ==

      IF ( myIter .EQ. -1 ) THEN

C-    Special case to return starDate_1 & _2 :
        mydate(1) = startdate_1
        mydate(2) = startdate_2
        mydate(3) = 1
        mydate(4) = 1

      ELSEIF ( cal_setStatus .LT. 3 ) THEN

        WRITE( msgBuf,'(2A,I10,A,F19.2)') 'CAL_GETDATE: ',
     &       'myIter=', myIter, ' , myTime=', myTime
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE( msgBuf,'(2A,I2,A)') 'CAL_GETDATE: ',
     &    'called too early (cal_setStatus=',cal_setStatus,' )'
        CALL PRINT_ERROR( msgBuf, myThid )
        STOP 'ABNORMAL END: S/R CAL_GETDATE'

c     ELSEIF ( myIter.EQ.modelIter0 .OR. myTime.EQ.modelStart ) THEN
      ELSEIF ( myTime.EQ.modelStart ) THEN

C-    faster to just copy modelStartDate:
        mydate(1) = modelStartDate(1)
        mydate(2) = modelStartDate(2)
        mydate(3) = modelStartDate(3)
        mydate(4) = modelStartDate(4)

      ELSE

c       if ( myTime.lt.0. ) then
c         if (myIter .ge. 0) then
c           secs = float(myIter - modelIter0)*modelStep
c         else
c           print*,' cal_GetDate: Not a valid input!'
c           STOP 'ABNORMAL END: S/R CAL_GETDATE'
c         endif
c       else
          secs = myTime - modelStart
c       endif

        CALL CAL_TIMEINTERVAL( secs, 'secs', workdate, myThid )
        CALL CAL_ADDTIME( modelStartDate, workdate, mydate, myThid )

      ENDIF

      RETURN
      END

#include "AIM_OPTIONS.h"

CBOP
C     !ROUTINE: PHY_DRIVER
C     !INTERFACE:
      SUBROUTINE PHY_DRIVER( tYear, usePkgDiag,
     I                       bi, bj, myTime, myIter, myThid )

C     !DESCRIPTION: \bv
C------------------------
C--   SUBROUTINE PHYDRIVER (tYear, myTime, bi, bj, myThid )
C--   Purpose: stand-alone driver for physical parametrization routines
C--   Input  :  TYEAR  : fraction of year (0 = 1jan.00, 1 = 31dec.24)
C--             grid-point model fields in common block: PHYGR1
C--             forcing fields in common blocks : LSMASK, FORFIX, FORCIN
C--   Output :  Diagnosed upper-air variables in common block: PHYGR2
C--             Diagnosed surface variables in common block: PHYGR3
C--             Physical param. tendencies in common block: PHYTEN
C--             Surface and upper boundary fluxes in common block: FLUXES
C-------
C     Note: tendencies are not /dpFac here but later in AIM_AIM2DYN
C-------
C from SPEDDY code: (part of original code left with c_FM)
C * S/R PHYPAR : except interp. dynamical Var. from Spectral of grid point
C                here dynamical var. are loaded within S/R AIM_DYN2AIM.
C * S/R FORDATE: only the CALL SOL_OZ (done once / day in SPEEDY)
C------------------------
C     \ev

C     !USES:
      IMPLICIT NONE

C     == Global variables ===

C-- size for MITgcm & Physics package :
#include "AIM_SIZE.h"
#include "EEPARAMS.h"

C-- Physics package
#include "AIM_PARAMS.h"
#include "AIM_GRID.h"
#include "AIM_CO2.h"

C     Constants + functions of sigma and latitude
#include "com_physcon.h"

C     Model variables, tendencies and fluxes on gaussian grid
#include "com_physvar.h"

C     Surface forcing fields (time-inv. or functions of seasonal cycle)
#include "com_forcing.h"

C     Constants for forcing fields:
#include "com_forcon.h"

C     Radiation scheme variables
#include "com_radvar.h"

C     Radiation constants
#include "com_radcon.h"

C     Logical flags
c_FM  include "com_lflags.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     tYear      :: Fraction into year
C     usePkgDiag :: logical flag, true if using Diagnostics PKG
C     bi, bj     :: Tile index
C     myTime     :: Current time of simulation ( s )
C     myIter     :: Current iteration number in simulation
C     myThid     :: Number of this instance of the routine
      _RL     tYear
      LOGICAL usePkgDiag
      INTEGER bi,bj
      _RL     myTime
      INTEGER myIter, myThid
CEOP

#ifdef ALLOW_AIM
C     !FUNCTIONS:
C     !LOCAL VARIABLES:
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C--   Local Variables originally (Speedy) in common bloc (com_physvar.h):
C      TG1     :: absolute temperature
C      QG1     :: specific humidity (g/kg)
C      VsurfSq :: Square of surface wind speed (grid position = as T,Q)
C      SE      :: dry static energy <- replaced by Pot.Temp.
C      QSAT    :: saturation specific humidity (g/kg)
C      PSG     :: surface pressure (normalized)
      _RL TG1    (NGP,NLEV)
      _RL QG1    (NGP,NLEV)
      _RL VsurfSq(NGP)
      _RL SE   (NGP,NLEV)
      _RL QSAT (NGP,NLEV)
      _RL PSG   (NGP)
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C-- Local variables:
C    absLW_CO2 :: LW absorbtion in CO2 band (uniform value)
C    kGround   :: Ground level index              (2-dim)
C    dpFac  :: cell delta_P fraction           (3-dim)
C    dTskin :: temp. correction for daily-cycle heating [K]
C    T1s    :: near-surface air temperature (from Pot.Temp)
C    DENVV  :: surface flux (sens,lat.) coeff. (=Rho*|V|) [kg/m2/s]
C    Shf0   :: sensible heat flux over freezing surf.
C    dShf   :: sensible heat flux derivative relative to surf. temp
C    Evp0   :: evaporation computed over freezing surface (Ts=0.oC)
C    dEvp   :: evaporation derivative relative to surf. temp
C    Slr0   :: upward long wave radiation over freezing surf.
C    dSlr   :: upward long wave rad. derivative relative to surf. temp
C    sFlx   :: net surface flux (+=down) function of surf. temp Ts:
C              0: Flux(Ts=0.oC) ; 1: Flux(Ts^n) ; 2: d.Flux/d.Ts(Ts^n)
      LOGICAL LRADSW
      INTEGER ICLTOP(NGP)
      INTEGER kGround(NGP)
      _RL absLW_CO2
      _RL dpFac(NGP,NLEV)
c_FM  REAL    RPS(NGP), ST4S(NGP)
      _RL ST4S(NGP)
      _RL PSG_1(NGP), RPS_1
      _RL dTskin(NGP), T1s(NGP), DENVV(NGP)
      _RL Shf0(NGP), dShf(NGP), Evp0(NGP), dEvp(NGP)
      _RL Slr0(NGP), dSlr(NGP), sFlx(NGP,0:2)
      _RL UPSWG(NGP)

      INTEGER J, K

#ifdef ALLOW_CLR_SKY_DIAG
      _RL dummyR(NGP)
      INTEGER dummyI(NGP)
#endif
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C--   1. Compute grid-point fields

C-    1.1 Convert model spectral variables to grid-point variables

      CALL AIM_DYN2AIM(
     O                 TG1, QG1, SE, VsurfSq, PSG, dpFac, kGround,
     I                 bi, bj, myTime, myIter, myThid )

C-    1.2 Compute thermodynamic variables

C-    1.2.a Surface pressure (ps), 1/ps and surface temperature
      RPS_1 = 1. _d 0
      DO J=1,NGP
       PSG_1(J)=1. _d 0
c_FM   PSG(J)=EXP(PSLG1(J))
c_FM   RPS(J)=1./PSG(J)
      ENDDO

C     1.2.b Dry static energy
C      <= replaced by Pot.Temp in aim_dyn2aim
c     DO K=1,NLEV
c      DO J=1,NGP
c_FM    SE(J,K)=CP*TG1(J,K)+PHIG1(J,K)
c      ENDDO
c     ENDDO

C     1.2.c Relative humidity and saturation spec. humidity

      DO K=1,NLEV
c_FM   CALL SHTORH (1,NGP,TG1(1,K),PSG,SIG(K),QG1(1,K),
c_FM &              RH(1,K),QSAT(1,K))
       CALL SHTORH (1,NGP,TG1(1,K),PSG_1,SIG(K),QG1(1,K),
     O              RH(1,K,myThid),QSAT(1,K),
     I              myThid)
      ENDDO

C--   2. Precipitation

C     2.1 Deep convection

c_FM  CALL CONVMF (PSG,SE,QG1,QSAT,
c_FM &             ICLTOP,CBMF,PRECNV,TT_CNV,QT_CNV)
      CALL CONVMF (PSG,dpFac,SE,QG1,QSAT,
     O             ICLTOP,CBMF(1,myThid),PRECNV(1,myThid),
     O             TT_CNV(1,1,myThid),QT_CNV(1,1,myThid),
     I             kGround,bi,bj,myThid)

      DO K=2,NLEV
       DO J=1,NGP
        TT_CNV(J,K,myThid)=TT_CNV(J,K,myThid)*RPS_1*GRDSCP(K)
        QT_CNV(J,K,myThid)=QT_CNV(J,K,myThid)*RPS_1*GRDSIG(K)
       ENDDO
      ENDDO

C     2.2 Large-scale condensation

c_FM  CALL LSCOND (PSG,QG1,QSAT,
c_FM &             PRECLS,TT_LSC,QT_LSC)
      CALL LSCOND (PSG,dpFac,QG1,QSAT,
     O             PRECLS(1,myThid),TT_LSC(1,1,myThid),
     O             QT_LSC(1,1,myThid),
     I             kGround,bi,bj,myThid)

      IF ( aim_energPrecip ) THEN
C     2.3 Snow Precipitation (update TT_CNV & TT_LSC)
        CALL SNOW_PRECIP (
     I             PSG, dpFac, SE, ICLTOP,
     I             PRECNV(1,myThid), QT_CNV(1,1,myThid),
     I             PRECLS(1,myThid), QT_LSC(1,1,myThid),
     U             TT_CNV(1,1,myThid), TT_LSC(1,1,myThid),
     O             EnPrec(1,myThid),
     I             kGround,bi,bj,myThid)
      ELSE
        DO J=1,NGP
          EnPrec(J,myThid) = 0. _d 0
        ENDDO
      ENDIF

C--   3. Radiation (shortwave and longwave) and surface fluxes

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C --> from FORDATE (in SPEEDY) :

C     3.0 Compute Incomming shortwave rad. (from FORDATE in SPEEDY)

c_FM  CALL SOL_OZ (SOLC,TYEAR)
      CALL SOL_OZ (SOLC,tYear, snLat(1,myThid), csLat(1,myThid),
     O             FSOL, OZONE, OZUPP, ZENIT, STRATZ,
     I             bi,bj,myThid)

C <-- from FORDATE (in SPEEDY).
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C     3.1 Compute shortwave tendencies and initialize lw transmissivity

C     Set LW absorption in CO2 band
      IF ( aim_select_pCO2.EQ.1 .OR. aim_select_pCO2.EQ.3 ) THEN
        absLW_CO2 = ABLCO2
     &            + aim_abs_pCO2*LOG( aim_pCO2/aim_ref_pCO2 )
      ELSE
        absLW_CO2 = ABLCO2
      ENDIF

C     The sw radiation may be called at selected time steps
      LRADSW = .TRUE.

      IF (LRADSW) THEN

c_FM    CALL RADSW (PSG,QG1,RH,ALB1,
c_FM &              ICLTOP,CLOUDC,TSR,SSR,TT_RSW)
       ICLTOP(1) = 1
       CALL RADSW (PSG,dpFac,QG1,RH(1,1,myThid),ALB1(1,0,myThid),
     I             FSOL, OZONE, OZUPP, ZENIT, STRATZ,
     O             TAU2, STRATC,
     O             ICLTOP,CLOUDC(1,myThid),
     O             TSR(1,myThid),SSR(1,0,myThid),
     O             UPSWG,TT_RSW(1,1,myThid),
     I             absLW_CO2, kGround, bi, bj, myThid )

        DO J=1,NGP
          CLTOP(J,myThid)=SIGH(ICLTOP(J)-1)*PSG_1(J)
        ENDDO

        DO K=1,NLEV
         DO J=1,NGP
          TT_RSW(J,K,myThid)=TT_RSW(J,K,myThid)*RPS_1*GRDSCP(K)
         ENDDO
        ENDDO

#ifdef ALLOW_DIAGNOSTICS
      IF ( usePkgDiag ) THEN
        CALL DIAGNOSTICS_FILL( UPSWG,
     &                        'UPSWG   ', 1, 1 , 3,bi,bj, myThid )
      ENDIF
#endif

      ENDIF

C     3.2 Compute downward longwave fluxes

c_FM  CALL RADLW (-1,TG1,TS,ST4S,
c_FM &            OLR,SLR,TT_RLW)
      CALL RADLW (-1,TG1,TS(1,myThid),ST4S,
     &            OZUPP, STRATC, TAU2, FLUX, ST4A,
     O            OLR(1,myThid),SLR(1,0,myThid),TT_RLW(1,1,myThid),
     I            kGround,bi,bj,myThid)

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C     3.3. Compute surface fluxes and land skin temperature

c_FM  CALL SUFLUX (PSG,UG1,VG1,TG1,QG1,RH,PHIG1,
c_FM &             PHIS0,FMASK1,STL1,SST1,SOILW1,SSR,SLR,
c_FM &             USTR,VSTR,SHF,EVAP,ST4S,
c_FM &             TS,TSKIN,U0,V0,T0,Q0)
      CALL SUFLUX_PREP(
     I             PSG, TG1, QG1, RH(1,1,myThid), SE, VsurfSq,
     I             WVSurf(1,myThid),csLat(1,myThid),fOrogr(1,myThid),
     I             FMASK1(1,1,myThid),STL1(1,myThid),SST1(1,myThid),
     I             sti1(1,myThid), SSR(1,0,myThid),
     O             SPEED0(1,myThid),DRAG(1,0,myThid),DENVV,
     O             dTskin,T1s,T0(1,myThid),Q0(1,myThid),
     I             kGround,bi,bj,myThid)

      CALL SUFLUX_LAND (
     I             PSG, FMASK1(1,1,myThid), EMISFC,
     I             STL1(1,myThid), dTskin,
     I             SOILW1(1,myThid), SSR(1,1,myThid), SLR(1,0,myThid),
     I             T1s, T0(1,myThid), Q0(1,myThid), DENVV,
     O             SHF(1,1,myThid), EVAP(1,1,myThid), SLR(1,1,myThid),
     O             Shf0, dShf, Evp0, dEvp, Slr0, dSlr, sFlx,
     O             TS(1,myThid), TSKIN(1,myThid),
     I             bi,bj,myThid)
#ifdef ALLOW_LAND
      CALL AIM_LAND_IMPL(
     I             FMASK1(1,1,myThid), dTskin,
     I             Shf0, dShf, Evp0, dEvp, Slr0, dSlr,
     U             sFlx, STL1(1,myThid),
     U             SHF(1,1,myThid), EVAP(1,1,myThid), SLR(1,1,myThid),
     O             dTsurf(1,1,myThid),
     I             bi, bj, myTime, myIter, myThid)
#endif /* ALLOW_LAND */

      CALL SUFLUX_OCEAN(
     I             PSG, FMASK1(1,2,myThid),
     I             SST1(1,myThid),
     I             SSR(1,2,myThid), SLR(1,0,myThid),
     O             T1s, T0(1,myThid), Q0(1,myThid), DENVV,
     O             SHF(1,2,myThid), EVAP(1,2,myThid), SLR(1,2,myThid),
     I             bi,bj,myThid)

      IF ( aim_splitSIOsFx ) THEN
        CALL SUFLUX_SICE (
     I             PSG, FMASK1(1,3,myThid), EMISFC,
     I             STI1(1,myThid), dTskin,
     I             SSR(1,3,myThid), SLR(1,0,myThid),
     I             T1s, T0(1,myThid), Q0(1,myThid), DENVV,
     O             SHF(1,3,myThid), EVAP(1,3,myThid), SLR(1,3,myThid),
     O             Shf0, dShf, Evp0, dEvp, Slr0, dSlr, sFlx,
     O             TS(1,myThid), TSKIN(1,myThid),
     I             bi,bj,myThid)
#ifdef ALLOW_THSICE
        CALL AIM_SICE_IMPL(
     I             FMASK1(1,3,myThid), SSR(1,3,myThid), sFlx,
     I             Shf0, dShf, Evp0, dEvp, Slr0, dSlr,
     U             STI1(1,myThid),
     U             SHF(1,3,myThid), EVAP(1,3,myThid), SLR(1,3,myThid),
     O             dTsurf(1,3,myThid),
     I             bi, bj, myTime, myIter, myThid)
#endif /* ALLOW_THSICE */
      ELSE
        DO J=1,NGP
          SHF (J,3,myThid) = 0. _d 0
          EVAP(J,3,myThid) = 0. _d 0
          SLR (J,3,myThid) = 0. _d 0
        ENDDO
      ENDIF

      CALL SUFLUX_POST(
     I             FMASK1(1,1,myThid), EMISFC,
     I             STL1(1,myThid), SST1(1,myThid), sti1(1,myThid),
     I             dTskin, SLR(1,0,myThid),
     I             T0(1,myThid), Q0(1,myThid), DENVV,
     U             DRAG(1,0,myThid), SHF(1,0,myThid),
     U             EVAP(1,0,myThid), SLR(1,1,myThid),
     O             ST4S, TS(1,myThid), TSKIN(1,myThid),
     I             bi,bj,myThid)

#ifdef ALLOW_DIAGNOSTICS
      IF ( usePkgDiag ) THEN
        CALL DIAGNOSTICS_FILL( SLR(1,0,myThid),
     &                        'DWNLWG  ', 1, 1 , 3,bi,bj, myThid )
      ENDIF
#endif
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C     3.4 Compute upward longwave fluxes, convert them to tendencies
C         and add shortwave tendencies

c_FM  CALL RADLW (1,TG1,TS,ST4S,
c_FM &            OLR,SLR,TT_RLW)
      CALL RADLW (1,TG1,TS(1,myThid),ST4S,
     &            OZUPP, STRATC, TAU2, FLUX, ST4A,
     O            OLR(1,myThid),SLR(1,0,myThid),TT_RLW(1,1,myThid),
     I            kGround,bi,bj,myThid)

      DO K=1,NLEV
       DO J=1,NGP
        TT_RLW(J,K,myThid)=TT_RLW(J,K,myThid)*RPS_1*GRDSCP(K)
c_FM    TTEND (J,K)=TTEND(J,K)+TT_RSW(J,K)+TT_RLW(J,K)
       ENDDO
      ENDDO

#ifdef ALLOW_CLR_SKY_DIAG
C     3.5 Compute clear-sky radiation (for diagnostics only)
      IF ( aim_clrSkyDiag ) THEN

C      3.5.1 Compute shortwave tendencies
       dummyI(1) = -1
       CALL RADSW (PSG,dpFac,QG1,RH(1,1,myThid),ALB1(1,0,myThid),
     I             FSOL, OZONE, OZUPP, ZENIT, STRATZ,
     O             TAU2, STRATC,
     O             dummyI, dummyR,
     O  TSWclr(1,myThid), SSWclr(1,myThid), UPSWG, TT_SWclr(1,1,myThid),
     I             absLW_CO2, kGround, bi, bj, myThid )

#ifdef ALLOW_DIAGNOSTICS
      IF ( usePkgDiag ) THEN
        CALL DIAGNOSTICS_FILL( UPSWG,
     &                        'UPSWGclr', 1, 1 , 3,bi,bj, myThid )
      ENDIF
#endif

C      3.5.2 Compute downward longwave fluxes

       CALL RADLW (-1,TG1,TS(1,myThid),ST4S,
     &             OZUPP, STRATC, TAU2, FLUX, ST4A,
     O      OLWclr(1,myThid), SLWclr(1,myThid), TT_LWclr(1,1,myThid),
     I             kGround,bi,bj,myThid)

C      3.5.3 Compute upward longwave fluxes, convert them to tendencies

       CALL RADLW (1,TG1,TS(1,myThid),ST4S,
     &            OZUPP, STRATC, TAU2, FLUX, ST4A,
     O      OLWclr(1,myThid), SLWclr(1,myThid), TT_LWclr(1,1,myThid),
     I            kGround,bi,bj,myThid)

       DO K=1,NLEV
        DO J=1,NGP
          TT_SWclr(J,K,myThid)=TT_SWclr(J,K,myThid)*RPS_1*GRDSCP(K)
          TT_LWclr(J,K,myThid)=TT_LWclr(J,K,myThid)*RPS_1*GRDSCP(K)
        ENDDO
       ENDDO

      ENDIF
#endif /* ALLOW_CLR_SKY_DIAG */

C--   4. PBL interactions with lower troposphere

C     4.1 Vertical diffusion and shallow convection

c_FM  CALL VDIFSC (UG1,VG1,SE,RH,QG1,QSAT,PHIG1,
c_FM &             UT_PBL,VT_PBL,TT_PBL,QT_PBL)
      CALL VDIFSC (dpFac, SE, RH(1,1,myThid), QG1, QSAT,
     O             TT_PBL(1,1,myThid),QT_PBL(1,1,myThid),
     I             kGround,bi,bj,myThid)

C     4.2 Add tendencies due to surface fluxes

      DO J=1,NGP
c_FM   UT_PBL(J,NLEV)=UT_PBL(J,NLEV)+USTR(J,3)*RPS(J)*GRDSIG(NLEV)
c_FM   VT_PBL(J,NLEV)=VT_PBL(J,NLEV)+VSTR(J,3)*RPS(J)*GRDSIG(NLEV)
c_FM   TT_PBL(J,NLEV)=TT_PBL(J,NLEV)+ SHF(J,3)*RPS(J)*GRDSCP(NLEV)
c_FM   QT_PBL(J,NLEV)=QT_PBL(J,NLEV)+EVAP(J,3)*RPS(J)*GRDSIG(NLEV)
       K = kGround(J)
       IF ( K.GT.0 ) THEN
        TT_PBL(J,K,myThid) = TT_PBL(J,K,myThid)
     &                     + SHF(J,0,myThid) *RPS_1*GRDSCP(K)
        QT_PBL(J,K,myThid) = QT_PBL(J,K,myThid)
     &                     + EVAP(J,0,myThid)*RPS_1*GRDSIG(K)
       ENDIF
      ENDDO

c_FM  DO K=1,NLEV
c_FM   DO J=1,NGP
c_FM    UTEND(J,K)=UTEND(J,K)+UT_PBL(J,K)
c_FM    VTEND(J,K)=VTEND(J,K)+VT_PBL(J,K)
c_FM    TTEND(J,K)=TTEND(J,K)+TT_PBL(J,K)
c_FM    QTEND(J,K)=QTEND(J,K)+QT_PBL(J,K)
c_FM   ENDDO
c_FM  ENDDO

#endif /* ALLOW_AIM */

      RETURN
      END

#include "RBCS_OPTIONS.h"

CBOP
C !ROUTINE: RBCS_ADD_TENDENCY

C !INTERFACE: ==========================================================
      SUBROUTINE RBCS_ADD_TENDENCY(
     U                    gTendency,
     I                    k, bi, bj, tracerNum,
     I                    myTime, myIter, myThid )

C !DESCRIPTION:
C     Add to tendency array the contribution from 3-D field relaxation

C !USES: ===============================================================
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
c#include "GRID.h"
#include "DYNVARS.h"
#ifdef ALLOW_PTRACERS
#include "PTRACERS_SIZE.h"
#include "PTRACERS_FIELDS.h"
#endif
#include "RBCS_SIZE.h"
#include "RBCS_PARAMS.h"
#include "RBCS_FIELDS.h"

C !INPUT/OUTPUT PARAMETERS: ============================================
C  gTendency      :: the tendency array
C  k              :: vertical level index
C  bi,bj          :: tile indices
C  tracerNum      :: tracer number (1=Temp, 2=Salt, >2 : ptracer)
C  myTime         :: current time
C  myIter         :: current timestep
C  myThid         :: my Thread Id number
      _RL gTendency(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER k, bi, bj
      INTEGER tracerNum
      _RL myTime
      INTEGER myIter
      INTEGER myThid

C !LOCAL VARIABLES: ====================================================
C  i,j            :: loop indices
      INTEGER i,j
      INTEGER irbc
      _RL rbcsVanishingFac
      _RL rec_tauRlx
#ifdef ALLOW_PTRACERS
      INTEGER iTracer
#endif
CEOP

#ifdef ALLOW_RBCS

      IF ( rbcsVanishingTime.GT.0. _d 0 ) THEN
        rbcsVanishingFac =
     &      MAX( 0. _d 0 , 1. _d 0 - myTime / rbcsVanishingTime )
      ELSE
        rbcsVanishingFac = 1. _d 0
      ENDIF

#ifndef DISABLE_RBCS_MOM
      IF ( tracerNum.EQ.-1 .AND. useRBCuVel ) THEN
        rec_tauRlx = rbcsVanishingFac/tauRelaxU
        DO j=0,sNy+1
         DO i=0,sNx+1
          gTendency(i,j) = gTendency(i,j)
     &       - RBC_maskU(i,j,k,bi,bj)*rec_tauRlx
     &        *( uVel(i,j,k,bi,bj)- RBCuVel(i,j,k,bi,bj) )
         ENDDO
        ENDDO
      ENDIF
      IF ( tracerNum.EQ.-2 .AND. useRBCvVel ) THEN
        rec_tauRlx = rbcsVanishingFac/tauRelaxV
        DO j=0,sNy+1
         DO i=0,sNx+1
          gTendency(i,j) = gTendency(i,j)
     &       - RBC_maskV(i,j,k,bi,bj)*rec_tauRlx
     &        *( vVel(i,j,k,bi,bj)- RBCvVel(i,j,k,bi,bj) )
         ENDDO
        ENDDO
      ENDIF
#endif /* DISABLE_RBCS_MOM */

      IF ( tracerNum.EQ.1 .AND. useRBCtemp ) THEN
        irbc = MIN(maskLEN,tracerNum)
        rec_tauRlx = rbcsVanishingFac/tauRelaxT
        DO j=0,sNy+1
         DO i=0,sNx+1
          gTendency(i,j) = gTendency(i,j)
     &       - RBC_mask(i,j,k,bi,bj,irbc)*rec_tauRlx
     &        *( theta(i,j,k,bi,bj)- RBCtemp(i,j,k,bi,bj) )

         ENDDO
        ENDDO
      ENDIF

      IF ( tracerNum.EQ.2 .AND. useRBCsalt ) THEN
        irbc = MIN(maskLEN,tracerNum)
        rec_tauRlx = rbcsVanishingFac/tauRelaxS
        DO j=0,sNy+1
         DO i=0,sNx+1
          gTendency(i,j) = gTendency(i,j)
     &       - RBC_mask(i,j,k,bi,bj,irbc)*rec_tauRlx
     &        *( salt(i,j,k,bi,bj)- RBCsalt(i,j,k,bi,bj) )
         ENDDO
        ENDDO
      ENDIF

#ifdef ALLOW_PTRACERS
      IF ( usePTRACERS .AND. tracerNum.GT.2 ) THEN
       iTracer = tracerNum-2
       IF ( useRBCpTrNum(iTracer) ) THEN
        irbc = MIN(maskLEN,tracerNum)
        rec_tauRlx = rbcsVanishingFac/tauRelaxPTR(iTracer)
        DO j=0,sNy+1
         DO i=0,sNx+1
          gTendency(i,j) = gTendency(i,j)
     &       - RBC_mask(i,j,k,bi,bj,irbc)*rec_tauRlx
     &        *( pTracer(i,j,k,bi,bj,iTracer)
     &           - RBC_ptracers(i,j,k,bi,bj,iTracer) )
         ENDDO
        ENDDO
       ENDIF
      ENDIF
#endif /* ALLOW_PTRACERS */

#endif /* ALLOW_RBCS */

      RETURN
      END

#include "CAL_OPTIONS.h"

      subroutine cal_DaysForMonth( 
     I                             imonth,
     O                             firstday,
     O                             lastday,
     O                             ndays,
     I                             mythid
     &                           )

c     ==================================================================
c     SUBROUTINE cal_DaysForMonth
c     ==================================================================
c
c     o Given the current month of the integration this routine returns
c       first, the last and the number of calendar days that will have
c       to be performed.
c
c       This routine also checks consistency of variables quite
c       extensively.
c
c     started: Christian Eckert eckert@mit.edu  06-Apr-2000
c
c     changed: 
c
c     ==================================================================
c     SUBROUTINE cal_DaysForMonth
c     ==================================================================

      implicit none

c     == global variables ==

#include "cal.h"

c     == routine arguments ==

      integer imonth
      integer firstday
      integer lastday
      integer ndays
      integer mythid

c     == local variables ==

      integer i
      integer ierr
      integer nummonths
      integer numdays
      integer firstyear
      integer firstmonth
      integer firstd
      integer lyfirst
      integer lastyear
      integer lastmonth
      integer lastd
      integer lastsecs
      integer lylast
      integer currentyear
      integer currentmonth
      integer lycurrent

c     == external ==

      integer  cal_IntMonths
      external cal_IntMonths
      integer  cal_IsLeap
      external cal_IsLeap

c     == end of interface ==

      lyfirst     = cal_IsLeap( firstyear, mythid )
      lylast      = cal_IsLeap( lastyear, mythid )

      nummonths   = cal_Intmonths( mythid )

      firstyear   = modelstartdate(1)/10000
      firstmonth  = mod(modelstartdate(1)/100,100)
      firstd      = mod(modelstartdate(1),100)
      lastyear    = modelenddate(1)/10000
      lastmonth   = mod(modelenddate(1)/100,100)
      lastd       = mod(modelenddate(1),100)
      lastsecs    = modelenddate(2)/10000*secondsperhour +
     &              mod(modelenddate(2)/100,100)*secondsperminute +
     &              mod(modelenddate(2),100)

      if ( nummonths .eq. 1 ) then
        if ( imonth .eq. 1 ) then
c--       Get the number of days in the first month.
          if ( firstmonth .eq. lastmonth ) then
            if (lastsecs .eq. 0) then
c--           Not really another day.
              lastday  = lastd - 1
            else
              lastday  = lastd
            endif
            firstday = 1
          else if ( mod(firstmonth+1,nmonthyear) .eq. lastmonth ) then
c--         This can only happen if we end at midnight of the first
c--         day of the next month.
            if ( ( modelenddate(2) .eq. 0 ) .and.
     &           ( mod(modelenddate(1),100) .eq. 1 ) ) then
              firstday = firstd
              lastday  = ndaymonth(firstmonth,lyfirst)
            else
c--           We do not end at midnight of the first day of
c--           the next month.
              ierr = 2704
              call cal_PrintError( ierr, mythid )
              stop ' stopped in cal_DaysForMonth.'
            endif
          else
c--         The first and the last month are inconsistent with imonth.
            ierr = 2703
            call cal_PrintError( ierr, mythid )
            stop ' stopped in cal_DaysForMonth.'
          endif
        else
c--       The variables nummonths and imonth are inconsistent;
c--       ( imonth .gt. nummonths ).
          ierr = 2702
          call cal_PrintError( ierr, mythid )
          stop ' stopped in cal_DaysForMonth.'
        endif

      else if ( nummonths .gt. 1 ) then
c--     More than one month of integration.
        if ( imonth .eq. 1 ) then
          firstday = 1
          lastday  = ndaymonth(firstmonth,lyfirst) - firstd + 1
        else if ( ( imonth .gt.     1     )        .and.
     &            ( imonth .lt. nummonths )       ) then
c--       Somewhere between first and last month.
          currentmonth = firstmonth
          currentyear  = firstyear
          numdays      = ndaymonth(firstmonth,lyfirst) - firstd + 1
          do i = 2,imonth-1
c--         Accumulate days of the intermediate months.
            currentmonth = mod(currentmonth+1,nmonthyear)
            if ( currentmonth .eq. 0 ) then
              currentmonth = 12
            endif
            if ( currentmonth .eq. 1 ) then
              currentyear = currentyear + 1
            endif
            lycurrent = cal_IsLeap( currentyear, mythid )
            numdays   = numdays + ndaymonth(currentmonth,lycurrent)
          enddo
          currentmonth = mod(currentmonth+1,nmonthyear)
          if ( currentmonth .eq. 0 ) then
             currentmonth = 12
          endif
          if ( currentmonth .eq. 1 ) then
            currentyear = currentyear + 1
          endif
          lycurrent = cal_IsLeap( currentyear, mythid )
          firstday  = numdays + 1
          lastday   = numdays + ndaymonth(currentmonth,lycurrent)
        else if ( imonth .eq. nummonths ) then
c--       The last month of the integration.
          currentmonth = firstmonth
          currentyear  = firstyear
          numdays      = ndaymonth(firstmonth,lyfirst) - firstd + 1
          do i = 2,nummonths-1
c--         Accumulate days of the intermediate months.
            currentmonth = mod(currentmonth+1,nmonthyear)
            if ( currentmonth .eq. 0 ) then
              currentmonth = 12
            endif
            if ( currentmonth .eq. 1 ) then
              currentyear = currentyear + 1
            endif
            lycurrent = cal_IsLeap( currentyear, mythid )
            numdays   = numdays + ndaymonth(currentmonth,lycurrent)
          enddo
c--       Prepare for the last month of integration.
          currentmonth = mod(currentmonth+1,nmonthyear)
          if ( currentmonth .eq. 0 ) then
             currentmonth = 12
          endif
          if ( currentmonth .eq. 1 ) then
            currentyear = currentyear + 1
          endif
          lycurrent = cal_IsLeap( currentyear, mythid )
          if ( ( modelenddate(2) .eq. 0 ) .and.
     &         ( mod(modelenddate(1),100) .eq. 1 ) ) then
c--         This can only happen if we end at midnight of the first
c--         day of the next month.
            lastday  = numdays + ndaymonth(currentmonth,lycurrent)
          else
c--         We do not stop at midnight of the first day of the
c--         next month.
            if (lastsecs .eq. 0) then
c--           But we might stop at midnight of a day.
              lastday = numdays + lastd - 1
            else
              lastday = numdays + lastd
            endif
          endif
          firstday = numdays + 1
        else
c--       The variables imonth and nummonths are inconsistent.
          ierr = 2705
          call cal_PrintError( ierr, mythid )
          stop ' stopped in cal_DaysForMonth.'
        endif
      else
c--     The number of months to integrate is wrong; check cal_IntMonths.
        ierr = 2701
        call cal_PrintError( ierr, mythid )
        stop ' stopped in cal_DaysForMonth.'
      endif

c--   The number of days to integrate in the given month.
      ndays = lastday - firstday + 1

      return
      end

#include "GAD_OPTIONS.h"

CBOP
C !ROUTINE: GAD_U3_ADV_R

C !INTERFACE: ==========================================================
      SUBROUTINE GAD_U3_ADV_R(
     I           bi, bj, k,
     I           rTrans,
     I           tracer,
     O           wT,
     I           myThid )

C !DESCRIPTION:
C Calculates the area integrated vertical flux due to advection of a tracer
C using upwind biased third-order interpolation (or the $\kappa=1/3$ scheme):
C \begin{equation*}
C F^r_{adv} = W \overline{ \theta  - \frac{1}{6} \delta_{kk} \theta }^k
C                 + \frac{1}{12} |W| \delta_{kkk} \theta
C \end{equation*}
C Near boundaries, mask all the gradients ==> still 3rd O.

C !USES: ===============================================================
      IMPLICIT NONE
#include "SIZE.h"
#include "GRID.h"
#include "GAD.h"

C !INPUT PARAMETERS: ===================================================
C  bi,bj                :: tile indices
C  k                    :: vertical level
C  rTrans               :: vertical volume transport
C  tracer               :: tracer field
C  myThid               :: thread number
      INTEGER bi,bj,k
      _RL rTrans(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL tracer(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      INTEGER myThid

C !OUTPUT PARAMETERS: ==================================================
C  wT                   :: vertical advective flux
      _RL wT    (1-OLx:sNx+OLx,1-OLy:sNy+OLy)

C !LOCAL VARIABLES: ====================================================
C  i,j                  :: loop indices
C  kp1                  :: =min( k+1 , Nr )
C  km1                  :: =max( k-1 , 1 )
C  km2                  :: =max( k-2 , 1 )
C  Rjm,Rj,Rjp           :: differences at i-1,i,i+1
C  Rjjm,Rjjp            :: second differences at i-1,i
      INTEGER i,j,kp1,km1,km2
      _RL Rjm,Rj,Rjp,Rjjm,Rjjp
CEOP

      km2=MAX(1,k-2)
      km1=MAX(1,k-1)
      kp1=MIN(Nr,k+1)

      IF ( k.EQ.1 .OR. k.GT.Nr ) THEN
       DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
         wT(i,j) = 0.
        ENDDO
       ENDDO
      ELSE
       DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
         Rjp = (tracer(i,j,kp1)-tracer(i,j, k ))*maskC(i,j,kp1,bi,bj)
         Rj  = (tracer(i,j, k )-tracer(i,j,km1))
         Rjm = (tracer(i,j,km1)-tracer(i,j,km2))*maskC(i,j,km2,bi,bj)
         Rjjp = Rjp-Rj
         Rjjm = Rj-Rjm
         wT(i,j) = maskC(i,j,km1,bi,bj)*(
     &     rTrans(i,j)*( (tracer(i,j,k)+tracer(i,j,km1))*0.5 _d 0
     &                  -oneSixth*(Rjjm+Rjjp)*0.5 _d 0  )
     &    +ABS(rTrans(i,j))*
     &                   oneSixth*(Rjjm-Rjjp)*0.5 _d 0
     &                                  )
        ENDDO
       ENDDO
      ENDIF

      RETURN
      END

#include "OBCS_OPTIONS.h"

CBOP
C     !ROUTINE: OBCS_SAVE_UV_N
C     !INTERFACE:
      SUBROUTINE OBCS_SAVE_UV_N(  bi, bj, iMin, iMax, jMin, jMax, kArg,
     I                          uFld, vFld,
     I                          myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE OBCS_SAVE_UV_N
C     | Save normal velocities at the OB location to be used
C     | in the next time step for Stevens boundary conditions
C     *==========================================================*
C     \ev
C     !USES:
      IMPLICIT NONE
C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "OBCS_PARAMS.h"
#include "OBCS_GRID.h"
#include "OBCS_FIELDS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine Arguments ==
C    bi, bj    :: indices of current tile
C    iMin,iMax :: array boundaries
C    jMin,jMax ::
C    kArg      :: index of current level which OBC applies to
C                 or, if zero, apply to all levels
C    uFld      :: horizontal velocity field, 1rst component (zonal)
C    vFld      :: horizontal velocity field, 2nd  component (meridional)
C    myThid    :: my Thread Id number
      INTEGER bi, bj
      INTEGER iMin, iMax
      INTEGER jMin, jMax
      INTEGER kArg
      _RL uFld(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      _RL vFld(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      INTEGER myThid
CEOP

#ifdef ALLOW_OBCS_STEVENS

C     !LOCAL VARIABLES:
C     == Local variables ==
      INTEGER k, kLo, kHi
      INTEGER i, j
      INTEGER Iobc, Jobc

C--   Save model velocity normal to OB for next time step.
      IF ( kArg.EQ.0 ) THEN
        kLo = 1
        kHi = Nr
      ELSE
        kLo = kArg
        kHi = kArg
      ENDIF

#ifdef ALLOW_OBCS_NORTH
      IF ( tileHasOBN(bi,bj) .AND. useStevensNorth ) THEN
C Northern boundary
       DO i=iMin,iMax
        Jobc = OB_Jn(i,bi,bj)
        IF ( Jobc.NE.OB_indexNone ) THEN
         DO k = kLo,kHi
          OBNvStevens(i,k,bi,bj) = vFld(i,Jobc,k,bi,bj)
     &         *_maskS(i,Jobc,k,bi,bj)
         ENDDO
        ENDIF
       ENDDO
      ENDIF
#endif
#ifdef ALLOW_OBCS_SOUTH
      IF ( tileHasOBS(bi,bj) .AND. useStevensSouth ) THEN
C Southern boundary
       DO i=iMin,iMax
        Jobc = OB_Js(i,bi,bj)
        IF ( Jobc.NE.OB_indexNone ) THEN
         DO k = kLo,kHi
          OBSvStevens(i,k,bi,bj) = vFld(i,Jobc+1,k,bi,bj)
     &         *_maskS(i,Jobc+1,k,bi,bj)
         ENDDO
        ENDIF
       ENDDO
      ENDIF
#endif

#ifdef ALLOW_OBCS_EAST
      IF ( tileHasOBE(bi,bj) .AND. useStevensEast ) THEN
C Eastern boundary
       DO j=jMin,jMax
        Iobc = OB_Ie(j,bi,bj)
        IF ( Iobc.NE.OB_indexNone ) THEN
         DO k = kLo,kHi
          OBEuStevens(j,k,bi,bj) = uFld(Iobc,j,k,bi,bj)
     &         *_maskW(Iobc,j,k,bi,bj)
         ENDDO
        ENDIF
       ENDDO
      ENDIF
#endif
#ifdef ALLOW_OBCS_WEST
      IF ( tileHasOBW(bi,bj) .AND. useStevensWest ) THEN
C Western boundary
       DO j=jMin,jMax
        Iobc = OB_Iw(j,bi,bj)
        IF ( Iobc.NE.OB_indexNone ) THEN
         DO k = kLo,kHi
          OBWuStevens(j,k,bi,bj) = uFld(Iobc+1,j,k,bi,bj)
     &         *_maskW(Iobc+1,j,k,bi,bj)
         ENDDO
        ENDIF
       ENDDO
      ENDIF
#endif
#endif /* ALLOW_OBCS_STEVENS */

      RETURN
      END

#include "OBSFIT_OPTIONS.h"

CBOP
C     !ROUTINE: OBSFIT_READPARMS

C     !INTERFACE:
      SUBROUTINE OBSFIT_READPARMS( myThid )

C     !DESCRIPTION:
C     ==================================================================
C     | Initialize ObsFit variables and constants
C     ==================================================================

C     !USES:
      IMPLICIT NONE
C     == Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "OBSFIT_SIZE.h"
#include "OBSFIT.h"

C     !INPUT PARAMETERS:
      INTEGER myThid
CEOP

C     !FUNCTIONS:
      INTEGER  ILNBLNK
      EXTERNAL ILNBLNK

C     !LOCAL VARIABLES:
C     msgBuf :: Informational/error message buffer
C     iUnit  :: Work variable for IO unit number
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      INTEGER   iUnit, num_file, IL
      LOGICAL   exst
      CHARACTER*(128) fname

      NAMELIST /obsfit_nml/
     &                 obsfitDir,
     &                 obsfitFiles,
     &                 mult_obsfit,
     &                 obsfit_facmod,
     &                 obsfitDoNcOutput,
     &                 obsfitDoGenGrid

      IF ( .NOT.useOBSFIT ) THEN
        _BEGIN_MASTER(myThid)
C Track pkg activation status:
C Print a (weak) warning if data.obsfit is found
        CALL PACKAGES_UNUSED_MSG( 'useOBSFIT', ' ', ' ' )
        _END_MASTER(myThid)
        RETURN
      ENDIF

      _BEGIN_MASTER(myThid)

C Default values for ObsFit
      obsfitDir = ' '

      DO num_file = 1, NFILESMAX_OBS
        obsfitFiles(num_file) = ' '
      ENDDO

      DO num_file = 1, NFILESMAX_OBS
        mult_obsfit(num_file) = 1. _d 0
        obsfit_facmod(num_file) = 1. _d 0
      ENDDO

      obsfitDoNcOutput = .false.

      IF ( (.NOT.usingSphericalPolarGrid .OR. rotateGrid) ) THEN
        obsfitDoGenGrid = .true.
      ELSE
        obsfitDoGenGrid = .false.
      ENDIF

C Read ObsFit cost data file
      WRITE( msgBuf,'(A)' ) 'OBSFIT_READPARMS: opening data.obsfit'
      CALL PRINT_MESSAGE( msgBuf,
     &     standardMessageUnit, SQUEEZE_RIGHT, 1 )

      CALL OPEN_COPY_DATA_FILE(
     I     'data.obsfit', 'OBSFIT_READPARMS',
     O     iUnit,
     I     myThid )

      READ( iUnit, nml = obsfit_nml )

      WRITE( msgBuf,'(2A)' ) 'OBSFIT_READPARMS: ',
     & 'finished reading data.obsfit'
      CALL PRINT_MESSAGE( msgBuf,
     &     standardMessageUnit, SQUEEZE_RIGHT, 1 )

#ifdef SINGLE_DISK_IO
      CLOSE( iUnit )
#else
      CLOSE( iUnit,STATUS='DELETE' )
#endif /* SINGLE_DISK_IO */

      DO num_file = 1, NFILESMAX_OBS

        IF ( obsfitFiles(num_file) .NE. ' ' ) THEN
          IL  = ILNBLNK( obsfitFiles(num_file) )
          fname = obsfitFiles(num_file)(1:IL)//'.nc'
          INQUIRE( file=fname, exist=exst )
          IF (.NOT.exst) THEN
C Warn user as we override obsfitFiles
            WRITE( msgBuf,'(3A)' )
     &       '** WARNING ** OBSFIT_READPARMS: missing file: ',
     &       obsfitFiles(num_file)(1:IL),' gets switched off'
            CALL PRINT_MESSAGE( msgBuf,
     &           errorMessageUnit, SQUEEZE_RIGHT, myThid )

C Switch off this file (and potential cost function term)
            obsfitFiles(num_file) = ' '

          ENDIF
        ENDIF

      ENDDO !DO num_file

      _END_MASTER( myThid )

      _BARRIER

      RETURN
      END

#include "MY82_OPTIONS.h"

CBOP
C !ROUTINE: MY82_RI_NUMBER

C !INTERFACE: ==========================================================
      subroutine MY82_RI_NUMBER(
     I     bi, bj, K, iMin, iMax, jMin, jMax,
     O     RiNumber, buoyFreq, vertShear,
     I     myTime, myThid )

C !DESCRIPTION: \bv
C     /==========================================================\
C     | SUBROUTINE MY82_RI_NUMBER                                |
C     | o Compute gradient Richardson number for Mellor and      |
C     |   Yamada (1981) turbulence model                         |
C     \==========================================================/
      IMPLICIT NONE
c
c-------------------------------------------------------------------------

c \ev

C !USES: ===============================================================
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "DYNVARS.h"
#include "MY82.h"
#include "GRID.h"

C !INPUT PARAMETERS: ===================================================
C Routine arguments
C     bi, bj - array indices on which to apply calculations
C     iMin, iMax, jMin, jMax
C            - array boundaries
C     k      - depth level
C     myTime - Current time in simulation
C     RiNumber  - (output) Richardson number
C     buoyFreq  - (output) (neg.) buoyancy frequency -N^2
C     vertShear - (output) vertical shear of velocity
      INTEGER bi, bj, iMin, iMax, jMin, jMax, k
      INTEGER myThid
      _RL     myTime
      _RL     RiNumber  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL     buoyFreq  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL     vertShear (1-OLx:sNx+OLx,1-OLy:sNy+OLy)

#ifdef ALLOW_MY82

C !LOCAL VARIABLES: ====================================================
C     I,J,kUp      - loop indices
C     p0-125       - averaging coefficients
C     tempu, tempv - temporary variables
C     rhoK, rhoKm1 - Density below and above current interface
C     epsilon      - small number
      INTEGER I,J,Km1
      _RL        p5    , p125
      PARAMETER( p5=0.5D0, p125=0.125D0 )
      _RL tempu, tempv
      _RL epsilon
      PARAMETER    (  epsilon = 1.D-10 )
      _RL rhoKm1   (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL rhoK     (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
#ifdef MY82_SMOOTH_RI
      _RL RiTmp   (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
#endif /* MY82_SMOOTH_RI */
CEOP

      Km1   = MAX(1,K-1)
C     Not sure what is correct for pressure coordinates:
C     RiFlux is always correct because it quadratic
C     buoyFreq should also be correct in pressure coordinates:
C     N^2=g^2drho/dp and K=1 at the bottom leads to the correct sign
C     So the following is wrong:
CML      IF ( buoyancyRelation .EQ. 'OCEANIC') THEN
CML       kUp   = MAX(1,K-1)
CML       kDown = K
CML      ELSEIF  ( buoyancyRelation .EQ. 'OCEANIP') THEN
CML       kUp   = K
CML       kDown = MAX(1,K-1)
CML      ELSE
CML       STOP 'MY82_RI_NUMBER: We should never reach this point'
CML      ENDIF
C     preparation: find density a kth and k-1st level
      CALL FIND_RHO_2D(
     I     iMin, iMax, jMin, jMax, K,
     I     theta(1-OLx,1-OLy,Km1,bi,bj), salt(1-OLx,1-OLy,Km1,bi,bj),
     O     rhoKm1,
     I     Km1, bi, bj, myThid )
      CALL FIND_RHO_2D(
     I     iMin, iMax, jMin, jMax, K,
     I     theta(1-OLx,1-OLy,K,bi,bj), salt(1-OLx,1-OLy,K,bi,bj),
     O     rhoK,
     I     K, bi, bj, myThid )

C     first step:  calculate flux Richardson number.
C     calculate (du/dz)^2 + (dv/dz)^2 on W (between T) points.
      DO J= jMin, jMax
       DO I = iMin, iMax
        tempu= .5 _d 0*(  uVel(I,J,Km1,bi,bj)+uVel(I+1,J,Km1,bi,bj)
     &            - (uVel(I,J,K  ,bi,bj)+uVel(I+1,J,K  ,bi,bj)) )
     &       *recip_drC(K)
        tempv= .5 _d 0*(  vVel(I,J,Km1,bi,bj)+vVel(I,J+1,Km1,bi,bj)
     &            - (vVel(I,J,K  ,bi,bj)+vVel(I,J+1,K  ,bi,bj)) )
     &       *recip_drC(K)
        vertShear(I,J) = tempu*tempu+tempv*tempv

C
C     calculate g*(drho/dz)/rho0= -N^2  .
C
        buoyFreq(I,J) = gravity*mass2rUnit *
     &       (rhoKm1(I,J) - rhoK(I,J))*recip_drC(K)
C
C     calculates gradient Richardson number, bounded by
C     a very large negative value.
C
        RiNumber(I,J) = -buoyFreq(I,J)/max(vertShear(I,J),epsilon)

       ENDDO
      ENDDO

#ifdef MY82_SMOOTH_RI
C     average Richardson number horizontally
      DO J=jMin,jMax
       DO I=iMin,iMax
        RiTmp(I,J) = RiNumber(I,J)
       ENDDO
      ENDDO
      DO J=1-Oly+1,sNy+Oly-1
       DO I=1-Olx+1,sNx+Olx-1
        RiNumber(I,J) = p5*RiTmp(I,J)
     &       + p125*RiTmp(I-1,J) + p125*RiTmp(I+1,J)
     &       + p125*RiTmp(I,J-1) + p125*RiTmp(I,J+1)
       ENDDO
      ENDDO
#endif /* MY82_SMOOTH_RI */

#endif /* ALLOW_MY82 */

      RETURN
      END

#include "PACKAGES_CONFIG.h"
#include "CPP_OPTIONS.h"
#define USE_FACTORIZED_POLY

C--  File find_alpha.F: Calculate expansion Coeff
C--   Contents
C--   o FIND_ALPHA
C--   o FIND_BETA

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: FIND_ALPHA
C     !INTERFACE:
      SUBROUTINE FIND_ALPHA (
     I     bi, bj, iMin, iMax, jMin, jMax,  k, kRef,
     O     alphaLoc,
     I     myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | o SUBROUTINE FIND_ALPHA
C     |   Calculates [drho(S,T,z) / dT] of a horizontal slice
C     *==========================================================*
C     | k        - is the Theta/Salt level
C     | kRef     - determines pressure reference level
C     |            (not used in 'LINEAR' mode)
C     | alphaLoc - drho / dT (kg/m^3/C)
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     === Global variables ===
#include "SIZE.h"
#include "DYNVARS.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "EOS.h"
#include "GRID.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     k      :: Level of Theta/Salt slice
C     kRef   :: Pressure reference level
c     myThid :: thread number for this instance of the routine
      INTEGER myThid
      INTEGER bi,bj,iMin,iMax,jMin,jMax
      INTEGER k
      INTEGER kRef
      _RL alphaLoc(1-OLx:sNx+OLx,1-OLy:sNy+OLy)

C     !LOCAL VARIABLES:
C     == Local variables ==
      INTEGER i,j
      _RL refTemp, refSalt, tP, sP, dp0
      _RL t1, t2, t3, s1, s3o2, p1, p2, sp5, p1t1
      _RL ct, sa, sqrtsa, p
      _RL drhoP0dtheta, drhoP0dthetaFresh, drhoP0dthetaSalt
      _RL dKdtheta, dKdthetaFresh, dKdthetaSalt, dKdthetaPres
      _RL locPres(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL rhoP0  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL bulkMod(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL dnum_dtheta, dden_dtheta
      _RL rhoDen (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL rhoLoc (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
CEOP

#ifdef CHECK_SALINITY_FOR_NEGATIVE_VALUES
c     CALL LOOK_FOR_NEG_SALINITY(
c    I          iMin, iMax, jMin, jMax,
c    U          sFld,
c    I          k, bi, bj, myThid )
#endif

      IF (equationOfState.EQ.'LINEAR') THEN

         DO j=jMin,jMax
            DO i=iMin,iMax
               alphaLoc(i,j) = -rhonil * tAlpha
            ENDDO
         ENDDO

      ELSEIF (equationOfState.EQ.'POLY3') THEN

         refTemp=eosRefT(kRef)
         refSalt=eosRefS(kRef)

         DO j=jMin,jMax
            DO i=iMin,iMax
               tP=theta(i,j,k,bi,bj)-refTemp
               sP=salt(i,j,k,bi,bj)-refSalt
#ifdef USE_FACTORIZED_POLY
               alphaLoc(i,j) =
     &     ( eosC(6,kRef)
     &         *tP*3.
     &        +(eosC(7,kRef)*sP + eosC(3,kRef))*2.
     &       )*tP
     &      +(eosC(8,kRef)*sP + eosC(4,kRef) )*sP + eosC(1,kRef)
     &
#else
               alphaLoc(i,j) =
     &              eosC(1,kRef)                +
     &              eosC(3,kRef)*tP*2.          +
     &              eosC(4,kRef)         *sP    +
     &              eosC(6,kRef)*tP*tP*3.       +
     &              eosC(7,kRef)*tP*2.   *sP    +
     &              eosC(8,kRef)         *sP*sP
#endif
            ENDDO
         ENDDO

      ELSEIF ( equationOfState(1:5).EQ.'JMD95'
     &        .OR. equationOfState.EQ.'UNESCO' ) THEN
C     nonlinear equation of state in pressure coordinates
         dp0 = surf_pRef - eosRefP0

         CALL PRESSURE_FOR_EOS(
     I        bi, bj, iMin, iMax, jMin, jMax,  kRef, dp0,
     O        locPres,
     I        myThid )

         CALL FIND_RHOP0(
     I        iMin, iMax, jMin, jMax,
     I        theta(1-OLx,1-OLy,k,bi,bj), salt(1-OLx,1-OLy,k,bi,bj),
     O        rhoP0,
     I        myThid )

         CALL FIND_BULKMOD(
     I        iMin, iMax, jMin, jMax, locPres,
     I        theta(1-OLx,1-OLy,k,bi,bj), salt(1-OLx,1-OLy,k,bi,bj),
     O        bulkMod,
     I        myThid )

         DO j=jMin,jMax
            DO i=iMin,iMax

C     abbreviations
               t1 = theta(i,j,k,bi,bj)
               t2 = t1*t1
               t3 = t2*t1

#if (defined ALLOW_AUTODIFF && defined TARGET_NEC_SX)
C     this line makes TAF create vectorizable code
               s3o2 = 0. _d 0
#endif
               s1  = salt(i,j,k,bi,bj)
              IF ( s1 .GT. 0. _d 0 ) THEN
               s3o2 = SQRT(s1*s1*s1)
              ELSE
               s1   = 0. _d 0
               s3o2 = 0. _d 0
              ENDIF

               p1  = locPres(i,j)*SItoBar
               p2 = p1*p1

C     d(rho)/d(theta)
C     of fresh water at p = 0
               drhoP0dthetaFresh =
     &                eosJMDCFw(2)
     &           + 2.*eosJMDCFw(3)*t1
     &           + 3.*eosJMDCFw(4)*t2
     &           + 4.*eosJMDCFw(5)*t3
     &           + 5.*eosJMDCFw(6)*t3*t1
C     of salt water at p = 0
               drhoP0dthetaSalt =
     &        s1*(
     &                eosJMDCSw(2)
     &           + 2.*eosJMDCSw(3)*t1
     &           + 3.*eosJMDCSw(4)*t2
     &           + 4.*eosJMDCSw(5)*t3
     &           )
     &       + s3o2*(
     &           +    eosJMDCSw(7)
     &           + 2.*eosJMDCSw(8)*t1
     &           )
C     d(bulk modulus)/d(theta)
C     of fresh water at p = 0
               dKdthetaFresh =
     &                eosJMDCKFw(2)
     &           + 2.*eosJMDCKFw(3)*t1
     &           + 3.*eosJMDCKFw(4)*t2
     &           + 4.*eosJMDCKFw(5)*t3
C     of sea water at p = 0
               dKdthetaSalt =
     &        s1*(    eosJMDCKSw(2)
     &           + 2.*eosJMDCKSw(3)*t1
     &           + 3.*eosJMDCKSw(4)*t2
     &           )
     &    + s3o2*(    eosJMDCKSw(6)
     &           + 2.*eosJMDCKSw(7)*t1
     &           )
C     of sea water at p
               dKdthetaPres =
     &        p1*(    eosJMDCKP(2)
     &           + 2.*eosJMDCKP(3)*t1
     &           + 3.*eosJMDCKP(4)*t2
     &           )
     &   + p1*s1*(    eosJMDCKP(6)
     &           + 2.*eosJMDCKP(7)*t1
     &           )
     &      + p2*(    eosJMDCKP(10)
     &           + 2.*eosJMDCKP(11)*t1
     &           )
     &   + p2*s1*(    eosJMDCKP(13)
     &           + 2.*eosJMDCKP(14)*t1
     &           )

               drhoP0dtheta  = drhoP0dthetaFresh
     &                       + drhoP0dthetaSalt
               dKdtheta      = dKdthetaFresh
     &                       + dKdthetaSalt
     &                       + dKdthetaPres
               alphaLoc(i,j) =
     &              ( bulkmod(i,j)**2*drhoP0dtheta
     &              - bulkmod(i,j)*p1*drhoP0dtheta
     &              - rhoP0(i,j)*p1*dKdtheta )
     &              /( bulkmod(i,j) - p1 )**2

            ENDDO
         ENDDO
      ELSEIF ( equationOfState.EQ.'MDJWF' ) THEN
         dp0 = surf_pRef - eosRefP0

         CALL PRESSURE_FOR_EOS(
     I        bi, bj, iMin, iMax, jMin, jMax,  kRef, dp0,
     O        locPres,
     I        myThid )

         CALL FIND_RHONUM(
     I        iMin, iMax, jMin, jMax, locPres,
     I        theta(1-OLx,1-OLy,k,bi,bj), salt(1-OLx,1-OLy,k,bi,bj),
     O        rhoLoc,
     I        myThid )

         CALL FIND_RHODEN(
     I        iMin, iMax, jMin, jMax, locPres,
     I        theta(1-OLx,1-OLy,k,bi,bj), salt(1-OLx,1-OLy,k,bi,bj),
     O        rhoDen,
     I        myThid )

         DO j=jMin,jMax
            DO i=iMin,iMax
               t1  = theta(i,j,k,bi,bj)
               t2  = t1*t1
               s1  = salt(i,j,k,bi,bj)
#if (defined ALLOW_AUTODIFF && defined TARGET_NEC_SX)
C     this line makes TAF create vectorizable code
               sp5 = 0. _d 0
#endif
              IF ( s1 .GT. 0. _d 0 ) THEN
               sp5 = SQRT(s1)
              ELSE
               s1  = 0. _d 0
               sp5 = 0. _d 0
              ENDIF

               p1   = locPres(i,j)*SItodBar
               p1t1 = p1*t1

               dnum_dtheta = eosMDJWFnum(1)
     &              + t1*(2.*eosMDJWFnum(2) + 3.*eosMDJWFnum(3)*t1)
     &              + eosMDJWFnum(5)*s1
     &              + p1t1*(2.*eosMDJWFnum(8) + 2.*eosMDJWFnum(11)*p1)

               dden_dtheta = eosMDJWFden(1)
     &              + t1*(2.*eosMDJWFden(2)
     &              +     t1*(3.*eosMDJWFden(3)
     &              +         4.*eosMDJWFden(4)*t1 ) )
     &              + s1*(eosMDJWFden(6)
     &              +     t1*(3.*eosMDJWFden(7)*t1
     &              +         2.*eosMDJWFden(9)*sp5 ) )
     &              + p1*p1*(3.*eosMDJWFden(11)*t2 + eosMDJWFden(12)*p1)

               alphaLoc(i,j)    = rhoDen(i,j)*(dnum_dtheta
     &              - (rhoLoc(i,j)*rhoDen(i,j))*dden_dtheta)

         ENDDO
      ENDDO

      ELSEIF ( equationOfState.EQ.'TEOS10' ) THEN
       dp0 = surf_pRef - eosRefP0

       CALL PRESSURE_FOR_EOS(
     I      bi, bj, iMin, iMax, jMin, jMax,  kRef, dp0,
     O      locPres,
     I      myThid )

       CALL FIND_RHOTEOS(
     I      iMin, iMax, jMin, jMax, locPres,
     I      theta(1-OLx,1-OLy,k,bi,bj), salt(1-OLx,1-OLy,k,bi,bj),
     O      rhoLoc, rhoDen,
     I      myThid )

       DO j=jMin,jMax
        DO i=iMin,iMax
         ct      = theta(i,j,k,bi,bj)
         sa      = salt(i,j,k,bi,bj)
#if (defined ALLOW_AUTODIFF && defined TARGET_NEC_SX)
C     this line makes TAF create vectorizable code
         sqrtsa  = 0. _d 0
#endif
         IF ( sa .GT. 0. _d 0 ) THEN
          sqrtsa = SQRT(sa)
         ELSE
          sa     = 0. _d 0
          sqrtsa = 0. _d 0
         ENDIF
         p       = locPres(i,j)*SItodBar

         dnum_dtheta = teos(02)
     &   + ct*(2.*teos(03) + 3.*teos(04)*ct)
     &   + sa*(teos(06) + 2.*teos(07)*ct
     &   + sqrtsa*(teos(09) + ct*(2.*teos(10) + 3.*teos(11)*ct)))
     &   + p*(     teos(13) + 2.*teos(14)*ct  + sa*2.*teos(16)
     &        + p*(teos(18) + 2.*teos(19)*ct))

         dden_dtheta = teos(22)
     &   + ct*(2.*teos(23) + ct*(3.*teos(24) + 4.*teos(25)*ct))
     &   + sa*(teos(27)
     &   + ct*(2.*teos(28) + ct*(3.*teos(29) + 4.*teos(30)*ct))
     &   + sqrtsa*(teos(32)
     &   + ct*(2.*teos(33) + ct*(3.*teos(34) + 4.*teos(35)*ct))))
     &   + p*(teos(38) + ct*(2.*teos(39) + 3.*teos(40)*ct)
     &   + teos(42)
     &   + p*(teos(44) + 2.*teos(45)*ct + teos(46)*sa
     &   + p*teos(48) ))

         alphaLoc(i,j)    = rhoDen(i,j)*(dnum_dtheta
     &        - (rhoLoc(i,j)*rhoDen(i,j))*dden_dtheta)

        ENDDO
       ENDDO

      ELSE
         WRITE(*,*) 'FIND_ALPHA: equationOfState = ',equationOfState
         STOP 'FIND_ALPHA: "equationOfState" has illegal value'
      ENDIF

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: FIND_BETA
C     !INTERFACE:
      SUBROUTINE FIND_BETA (
     I     bi, bj, iMin, iMax, jMin, jMax,  k, kRef,
     O     betaLoc,
     I     myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | o SUBROUTINE FIND_BETA
C     |   Calculates [drho(S,T,z) / dS] of a horizontal slice
C     |==========================================================*
C     | k       - is the Theta/Salt level
C     | kRef    - determines pressure reference level
C     |           (not used in 'LINEAR' mode)
C     | betaLoc - drho / dS (kg/m^3/(g/kg))
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     === Global variables ===
#include "SIZE.h"
#include "DYNVARS.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "EOS.h"
#include "GRID.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     k      :: Level of Theta/Salt slice
C     kRef   :: Pressure reference level
c     myThid :: thread number for this instance of the routine
      INTEGER myThid
      INTEGER bi,bj,iMin,iMax,jMin,jMax
      INTEGER k
      INTEGER kRef
      _RL betaLoc(1-OLx:sNx+OLx,1-OLy:sNy+OLy)

C     !LOCAL VARIABLES:
C     == Local variables ==
      INTEGER i,j
      _RL refTemp, refSalt, tP, sP, dp0
      _RL t1, t2, t3, s1, s3o2, p1, sp5, p1t1
      _RL ct, sa, sqrtsa, p
      _RL drhoP0dS
      _RL dKdS, dKdSSalt, dKdSPres
      _RL locPres(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL rhoP0  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL bulkMod(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL dnum_dsalt, dden_dsalt
      _RL rhoDen (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL rhoLoc (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
CEOP

#ifdef CHECK_SALINITY_FOR_NEGATIVE_VALUES
c     CALL LOOK_FOR_NEG_SALINITY(
c    I          iMin, iMax, jMin, jMax,
c    U          sFld,
c    I          k, bi, bj, myThid )
#endif

      IF (equationOfState.EQ.'LINEAR') THEN

         DO j=jMin,jMax
            DO i=iMin,iMax
               betaLoc(i,j) = rhonil * sBeta
            ENDDO
         ENDDO

      ELSEIF (equationOfState.EQ.'POLY3') THEN

         refTemp=eosRefT(kRef)
         refSalt=eosRefS(kRef)

         DO j=jMin,jMax
            DO i=iMin,iMax
               tP=theta(i,j,k,bi,bj)-refTemp
               sP=salt(i,j,k,bi,bj)-refSalt
#ifdef USE_FACTORIZED_POLY
               betaLoc(i,j) =
     &    ( eosC(9,kRef)*sP*3. + eosC(5,kRef)*2. )*sP + eosC(2,kRef)
     &   + ( eosC(7,kRef)*tP
     &      +eosC(8,kRef)*sP*2. + eosC(4,kRef)
     &     )*tP
#else
               betaLoc(i,j) =
     &              eosC(2,kRef)                +
     &              eosC(4,kRef)*tP             +
     &              eosC(5,kRef)         *sP*2. +
     &              eosC(7,kRef)*tP*tP          +
     &              eosC(8,kRef)*tP      *sP*2. +
     &              eosC(9,kRef)         *sP*sP*3.
#endif
            ENDDO
         ENDDO

      ELSEIF ( equationOfState(1:5).EQ.'JMD95'
     &        .OR. equationOfState.EQ.'UNESCO' ) THEN
C     nonlinear equation of state in pressure coordinates
         dp0 = surf_pRef - eosRefP0

         CALL PRESSURE_FOR_EOS(
     I        bi, bj, iMin, iMax, jMin, jMax,  kRef, dp0,
     O        locPres,
     I        myThid )

         CALL FIND_RHOP0(
     I        iMin, iMax, jMin, jMax,
     I        theta(1-OLx,1-OLy,k,bi,bj), salt(1-OLx,1-OLy,k,bi,bj),
     O        rhoP0,
     I        myThid )

         CALL FIND_BULKMOD(
     I        iMin, iMax, jMin, jMax, locPres,
     I        theta(1-OLx,1-OLy,k,bi,bj), salt(1-OLx,1-OLy,k,bi,bj),
     O        bulkMod,
     I        myThid )

         DO j=jMin,jMax
            DO i=iMin,iMax

C     abbreviations
               t1 = theta(i,j,k,bi,bj)
               t2 = t1*t1
               t3 = t2*t1

               s1  = salt(i,j,k,bi,bj)
#if (defined ALLOW_AUTODIFF && defined TARGET_NEC_SX)
C     this line makes TAF create vectorizable code
               s3o2 = 0. _d 0
#endif
              IF ( s1 .GT. 0. _d 0 ) THEN
               s3o2 = 1.5*SQRT(s1)
              ELSE
               s1   = 0. _d 0
               s3o2 = 0. _d 0
              ENDIF

               p1  = locPres(i,j)*SItoBar

C     d(rho)/d(S)
C     of fresh water at p = 0
               drhoP0dS = 0. _d 0
C     of salt water at p = 0
               drhoP0dS = drhoP0dS
     &              + eosJMDCSw(1)
     &              + eosJMDCSw(2)*t1
     &              + eosJMDCSw(3)*t2
     &              + eosJMDCSw(4)*t3
     &              + eosJMDCSw(5)*t3*t1
     &       + s3o2*(
     &                eosJMDCSw(6)
     &              + eosJMDCSw(7)*t1
     &              + eosJMDCSw(8)*t2
     &              )
     &              + 2*eosJMDCSw(9)*s1
C     d(bulk modulus)/d(S)
C     of fresh water at p = 0
               dKdS = 0. _d 0
C     of sea water at p = 0
               dKdSSalt =
     &                eosJMDCKSw(1)
     &              + eosJMDCKSw(2)*t1
     &              + eosJMDCKSw(3)*t2
     &              + eosJMDCKSw(4)*t3
     &       + s3o2*( eosJMDCKSw(5)
     &              + eosJMDCKSw(6)*t1
     &              + eosJMDCKSw(7)*t2
     &              )

C     of sea water at p
               dKdSPres =
     &           p1*( eosJMDCKP(5)
     &              + eosJMDCKP(6)*t1
     &              + eosJMDCKP(7)*t2
     &              )
     &        + s3o2*p1*eosJMDCKP(8)
     &      + p1*p1*( eosJMDCKP(12)
     &              + eosJMDCKP(13)*t1
     &              + eosJMDCKP(14)*t2
     &              )

               dKdS = dKdSSalt + dKdSPres

               betaLoc(i,j) =
     &              ( bulkmod(i,j)**2*drhoP0dS
     &              - bulkmod(i,j)*p1*drhoP0dS
     &              - rhoP0(i,j)*p1*dKdS )
     &              /( bulkmod(i,j) - p1 )**2

            ENDDO
         ENDDO
      ELSEIF ( equationOfState.EQ.'MDJWF' ) THEN
         dp0 = surf_pRef - eosRefP0

         CALL PRESSURE_FOR_EOS(
     I        bi, bj, iMin, iMax, jMin, jMax,  kRef, dp0,
     O        locPres,
     I        myThid )

         CALL FIND_RHONUM(
     I        iMin, iMax, jMin, jMax, locPres,
     I        theta(1-OLx,1-OLy,k,bi,bj), salt(1-OLx,1-OLy,k,bi,bj),
     O        rhoLoc,
     I        myThid )

         CALL FIND_RHODEN(
     I        iMin, iMax, jMin, jMax, locPres,
     I        theta(1-OLx,1-OLy,k,bi,bj), salt(1-OLx,1-OLy,k,bi,bj),
     O        rhoDen,
     I        myThid )

         DO j=jMin,jMax
            DO i=iMin,iMax
               t1  = theta(i,j,k,bi,bj)
               t2  = t1*t1
               s1  = salt(i,j,k,bi,bj)
#if (defined ALLOW_AUTODIFF && defined TARGET_NEC_SX)
C     this line makes TAF create vectorizable code
               sp5 = 0. _d 0
#endif
              IF ( s1 .GT. 0. _d 0 ) THEN
               sp5 = SQRT(s1)
              ELSE
               s1  = 0. _d 0
               sp5 = 0. _d 0
              ENDIF

               p1   = locPres(i,j)*SItodBar
               p1t1 = p1*t1

               dnum_dsalt = eosMDJWFnum(4)
     &              + eosMDJWFnum(5)*t1
     &              + 2.*eosMDJWFnum(6)*s1 + eosMDJWFnum(9)*p1
               dden_dsalt = eosMDJWFden(5)
     &              + t1*( eosMDJWFden(6) + eosMDJWFden(7)*t2 )
     &              + 1.5*sp5*(eosMDJWFden(8) + eosMDJWFden(9)*t2)

               betaLoc(i,j) = rhoDen(i,j)*( dnum_dsalt
     &              - (rhoLoc(i,j)*rhoDen(i,j))*dden_dsalt )

            ENDDO
         ENDDO

      ELSEIF ( equationOfState.EQ.'TEOS10' ) THEN
       dp0 = surf_pRef - eosRefP0

       CALL PRESSURE_FOR_EOS(
     I      bi, bj, iMin, iMax, jMin, jMax,  kRef, dp0,
     O      locPres,
     I      myThid )

       CALL FIND_RHOTEOS(
     I      iMin, iMax, jMin, jMax, locPres,
     I      theta(1-OLx,1-OLy,k,bi,bj), salt(1-OLx,1-OLy,k,bi,bj),
     O      rhoLoc, rhoDen,
     I      myThid )

       DO j=jMin,jMax
        DO i=iMin,iMax
         ct      = theta(i,j,k,bi,bj)
         sa      = salt(i,j,k,bi,bj)
#if (defined ALLOW_AUTODIFF && defined TARGET_NEC_SX)
C     this line makes TAF create vectorizable code
         sqrtsa  = 0. _d 0
#endif
         IF ( sa .GT. 0. _d 0 ) THEN
          sqrtsa = SQRT(sa)
         ELSE
          sa     = 0. _d 0
          sqrtsa = 0. _d 0
         ENDIF
         p       = locPres(i,j)*SItodBar

         dnum_dsalt =  teos(05) + ct*(teos(06) + teos(07)*ct)
     &   + 1.5*sqrtsa*(teos(08)
     &           + ct*(teos(09) + ct*(teos(10) + teos(11)*ct)))
     &   + p*(teos(15) + teos(16)*ct + p*teos(20))

         dden_dsalt = teos(26)
     &   + ct*(teos(27) + ct*(teos(28) + ct*(teos(29) + teos(30)*ct)))
     &   + 2.*teos(36)*sa
     &   + 1.5*sqrtsa*(teos(31) + ct*(teos(32) + ct*(teos(33)
     &                          + ct*(teos(34) + teos(35)*ct))))
     &   + p*(teos(41) + teos(42)*ct + p*teos(46))

         betaLoc(i,j) = rhoDen(i,j)*( dnum_dsalt
     &        - (rhoLoc(i,j)*rhoDen(i,j))*dden_dsalt )

        ENDDO
       ENDDO

      ELSE
         WRITE(*,*) 'FIND_BETA: equationOfState = ',equationOfState
         STOP 'FIND_BETA: "equationOfState" has illegal value'
      ENDIF

      RETURN
      END

#include "THSICE_OPTIONS.h"

CBOP
C     !ROUTINE: THSICE_DIAGNOSTICS_INIT
C     !INTERFACE:
      SUBROUTINE THSICE_DIAGNOSTICS_INIT( myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE THSICE_DIAGNOSTICS_INIT
C     | o Routine to initialize list of all available diagnostics
C     |   for THSICE package
C     *==========================================================*
C     \ev
C     !USES:
      IMPLICIT NONE

C     === Global variables ===
#include "EEPARAMS.h"
c #include "SIZE.h"
c #include "PARAMS.h"
#include "THSICE_SIZE.h"
c #include "THSICE_PARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
C     myThid ::  My Thread Id. number
      INTEGER myThid
CEOP

#ifdef ALLOW_DIAGNOSTICS
C     !LOCAL VARIABLES:
C     === Local variables ===
C     diagNum   :: diagnostics number in the (long) list of available diag.
C     diagMate  :: diag. mate number in the (long) list of available diag.
C     diagName  :: local short name (8c) of a diagnostics
C     diagCode  :: local parser field with characteristics of the diagnostics
C              cf head of S/R DIAGNOSTICS_INIT_EARLY or DIAGNOSTICS_MAIN_INIT
C     diagUnits :: local string (16c): physical units of a diagnostic field
C     diagTitle :: local string (80c): description of field in diagnostic
      INTEGER       diagNum
      INTEGER       diagMate
      CHARACTER*8   diagName
      CHARACTER*16  diagCode
      CHARACTER*16  diagUnits
      CHARACTER*(80) diagTitle
      INTEGER       numFract, numThick, numFrcFx
      INTEGER       n
      LOGICAL       flag
      CHARACTER*16  locName
      CHARACTER*4   THSICE_DIAG_SUFX, diagSufx
      EXTERNAL      THSICE_DIAG_SUFX

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

c     IF ( useDiagnotics ) THEN

        diagName  = 'SI_Fract'
        diagTitle = 'Sea-Ice fraction  [0-1]'
        diagUnits = '0-1             '
        diagCode  = 'SM P    M1      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I            diagName, diagCode, diagUnits, diagTitle, 0, myThid )
        numFract  = diagNum
        numFrcFx  = diagNum

        diagName  = 'SI_Thick'
        diagTitle = 'Sea-Ice thickness (area weighted average)'
        diagUnits = 'm               '
        diagCode  = 'SM PC   M1      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, numFract, myThid )
        numThick  = diagNum

        diagName  = 'SI_SnowH'
        diagTitle = 'Snow thickness over Sea-Ice (area weighted)'
        diagUnits = 'm               '
        diagCode  = 'SM PC   M1      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, numFract, myThid )

        diagName  = 'SI_Tsrf '
        diagTitle = 'Surface Temperature over Sea-Ice (area weighted)'
        diagUnits = 'degC            '
        diagCode  = 'SM  C   M1      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, numFract, myThid )

        diagName  = 'SI_Tice1'
        diagTitle = 'Sea-Ice Temperature, 1srt layer (area weighted)'
        diagUnits = 'degC            '
        diagCode  = 'SM  C   M1      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, numFract, myThid )

        diagName  = 'SI_Tice2'
        diagTitle = 'Sea-Ice Temperature, 2nd  layer (area weighted)'
        diagUnits = 'degC            '
        diagCode  = 'SM  C   M1      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, numFract, myThid )

        diagName  = 'SI_Qice1'
        diagTitle = 'Sea-Ice enthalpy, 1srt layer (mass weighted)'
        diagUnits = 'J/kg            '
        diagCode  = 'SM  C   M1      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, numThick, myThid )

        diagName  = 'SI_Qice2'
        diagTitle = 'Sea-Ice enthalpy, 2nd  layer (mass weighted)'
        diagUnits = 'J/kg            '
        diagCode  = 'SM  C   M1      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, numThick, myThid )

        diagName  = 'SIsnwAge'
        diagTitle = 'snow age over Sea-Ice'
        diagUnits = 's               '
        diagCode  = 'SM P    M1      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I            diagName, diagCode, diagUnits, diagTitle, 0, myThid )

        diagName  = 'SIalbedo'
        diagTitle = 'Sea-Ice Albedo [0-1] (area weighted average)'
        diagUnits = '0-1             '
        diagCode  = 'SM PC   M1      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, numFrcFx, myThid )

        diagName  = 'SIsnwPrc'
        diagTitle = 'snow precip. (+=dw) over Sea-Ice (area weighted)'
        diagUnits = 'kg/m^2/s        '
        diagCode  = 'SM  C   M1      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, numFrcFx, myThid )

        diagName  = 'SIflxAtm'
        diagTitle = 'net heat flux from the Atmosphere (+=dw)'
        diagUnits = 'W/m^2           '
        diagCode  = 'SM      M1      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I            diagName, diagCode, diagUnits, diagTitle, 0, myThid )

        diagName  = 'SIfrwAtm'
        diagTitle = 'fresh-water flux to the Atmosphere (+=up)'
        diagUnits = 'kg/m^2/s        '
        diagCode  = 'SM      M1      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I            diagName, diagCode, diagUnits, diagTitle, 0, myThid )

        diagName  = 'SIflx2oc'
        diagTitle = 'heat flux out of the ocean (+=up)'
        diagUnits = 'W/m^2           '
        diagCode  = 'SM      M1      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I            diagName, diagCode, diagUnits, diagTitle, 0, myThid )

        diagName  = 'SIfrw2oc'
        diagTitle = 'fresh-water flux out of the ocean (+=up)'
        diagUnits = 'kg/m^2/s        '
        diagCode  = 'SM      M1      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I            diagName, diagCode, diagUnits, diagTitle, 0, myThid )

        diagName  = 'SIsaltFx'
        diagTitle = 'salt flux out of the ocean (+=up)'
        diagUnits = 'g/m^2/s         '
        diagCode  = 'SM      M1      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I            diagName, diagCode, diagUnits, diagTitle, 0, myThid )

        diagName  = 'SItOcMxL'
        diagTitle = 'ocean mixed layer temperature'
        diagUnits = 'degC            '
        diagCode  = 'SM      M1      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I            diagName, diagCode, diagUnits, diagTitle, 0, myThid )

        diagName  = 'SIsOcMxL'
        diagTitle = 'ocean mixed layer salinity'
        diagUnits = 'g/kg            '
        diagCode  = 'SM P    M1      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I            diagName, diagCode, diagUnits, diagTitle, 0, myThid )

       DO n=-5,-9,-1
        flag = .TRUE.
        IF     ( n .EQ. GAD_SI_FRAC  ) THEN
          locName   = 'SeaIce Fraction '
          diagUnits = 'm^2/s           '
        ELSEIF ( n .EQ. GAD_SI_HSNOW ) THEN
          locName   = 'Snow Thickness  '
          diagUnits = 'm^3/s           '
        ELSEIF ( n .EQ. GAD_SI_HICE  ) THEN
          locName   = 'SeaIce Thickness'
          diagUnits = 'm^3/s           '
        ELSEIF ( n .EQ. GAD_SI_QICE1 ) THEN
          locName   = 'Ice enthalpy l=1'
          diagUnits = 'J/kg.m^3/s      '
c         diagUnits = 'W.m^3/kg        '
        ELSEIF ( n .EQ. GAD_SI_QICE2 ) THEN
          locName   = 'Ice enthalpy l=2'
          diagUnits = 'J/kg.m^3/s      '
        ELSE
          flag = .FALSE.
        ENDIF
        IF ( flag ) THEN
C-     Advective flux:
        diagSufx = THSICE_DIAG_SUFX( n, myThid )
        diagName  = 'ADVx'//diagSufx
        diagTitle = 'Zonal      Advective Flux of '//locName
        diagCode  = 'UU      M1      '
        diagMate  = diagNum + 2
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )
        diagName  = 'ADVy'//diagSufx
        diagTitle = 'Meridional Advective Flux of '//locName
        diagCode  = 'VV      M1      '
        diagMate  = diagNum
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )
        ENDIF
      ENDDO

C--   Intermediate State, just before advection:
        locName   = 'before advection'
        diagName  = 'SI_AdvFr'
        diagTitle = 'Sea-Ice fraction  [0-1] ('//locName//')'
        diagUnits = '0-1             '
        diagCode  = 'SM P    M1      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I            diagName, diagCode, diagUnits, diagTitle, 0, myThid )
        numFract  = diagNum

        diagName  = 'SI_AdvHi'
        diagTitle = 'Sea-Ice thickness ('//locName//')'
        diagUnits = 'm               '
        diagCode  = 'SM PC   M1      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, numFract, myThid )
        numThick  = diagNum

        diagName  = 'SI_AdvHs'
        diagTitle = 'Snow thickness over Sea-Ice ('//locName//')'
        diagUnits = 'm               '
        diagCode  = 'SM PC   M1      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, numFract, myThid )

        diagName  = 'SI_AdvQ1'
        diagTitle = 'Sea-Ice enthalpy, 1srt layer ('//locName//')'
        diagUnits = 'J/kg            '
        diagCode  = 'SM  C   M1      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, numThick, myThid )

        diagName  = 'SI_AdvQ2'
        diagTitle = 'Sea-Ice enthalpy, 2nd  layer ('//locName//')'
        diagUnits = 'J/kg            '
        diagCode  = 'SM  C   M1      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, numThick, myThid )

c     ENDIF

#endif /* ALLOW_DIAGNOSTICS */

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

CBOP 0
C     !ROUTINE: THSICE_DIAG_SUFX

C     !INTERFACE:
      CHARACTER*4 FUNCTION THSICE_DIAG_SUFX( tracerId, myThid )

C     !DESCRIPTION:
C     *==========================================================*
C     | FUNCTION THSICE_DIAG_SUFX
C     | o Return diagnostic suffix (4 character long) for the
C     |   "tracerId" tracer (used to build diagnostic names).
C     *==========================================================*

C     !USES:
      IMPLICIT NONE
#include "EEPARAMS.h"
#include "THSICE_SIZE.h"

C     !INPUT PARAMETERS:
C     tracerId   ::  tracer identifier
C     myThid     ::  my thread Id number
      INTEGER      tracerId
      INTEGER      myThid
CEOP

C     !LOCAL VARIABLES:

C--   Set diagnostic suffix (4 character long) for the "tracerId" tracer
      IF    ( tracerId.EQ.GAD_SI_FRAC  ) THEN
        THSICE_DIAG_SUFX = 'SIfr'
      ELSEIF( tracerId.EQ.GAD_SI_HSNOW ) THEN
        THSICE_DIAG_SUFX = 'SIhs'
      ELSEIF( tracerId.EQ.GAD_SI_HICE  ) THEN
        THSICE_DIAG_SUFX = 'SIhi'
      ELSEIF( tracerId.EQ.GAD_SI_QICE1 ) THEN
        THSICE_DIAG_SUFX = 'SIq1'
      ELSEIF( tracerId.EQ.GAD_SI_QICE2 ) THEN
        THSICE_DIAG_SUFX = 'SIq2'
      ELSE
        THSICE_DIAG_SUFX = 'iiii'
      ENDIF

      RETURN
      END

#include "MYPACKAGE_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C !ROUTINE: MYPACKAGE_CHECK

C !INTERFACE:
      SUBROUTINE MYPACKAGE_CHECK( myThid )

C     !DESCRIPTION:
C     Check dependances with other packages

C     !USES:
      IMPLICIT NONE
C     == Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "MYPACKAGE.h"

C     !INPUT PARAMETERS:
C     myThid   :: my Thread Id number
      INTEGER myThid
CEOP

C     !LOCAL VARIABLES:
C     msgBuf   :: Informational/error message buffer
      CHARACTER*(MAX_LEN_MBUF) msgBuf

      _BEGIN_MASTER(myThid)

       WRITE(msgBuf,'(A)') 'MYPACKAGE_CHECK: #define MYPACKAGE'
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                     SQUEEZE_RIGHT, myThid )

C--  Print out some kee parameters :
       CALL WRITE_0D_L( myPa_StaV_Cgrid, INDEX_NONE,
     &  'myPa_StaV_Cgrid =', ' /* state vector on C-grid */')
       CALL WRITE_0D_L( myPa_Tend_Cgrid, INDEX_NONE,
     &  'myPa_Tend_Cgrid =', ' /* vector tendency on C-grid */')
       CALL WRITE_0D_L( myPa_applyTendT, INDEX_NONE,
     &  'myPa_applyTendT =',
     &  ' /* apply MYPA tendency to Temperature Eq.*/')
       CALL WRITE_0D_L( myPa_applyTendS, INDEX_NONE,
     &  'myPa_applyTendS =',
     &  ' /* apply MYPA tendency to Salinity Eq.*/')
       CALL WRITE_0D_L( myPa_applyTendU, INDEX_NONE,
     &  'myPa_applyTendU =',
     &  ' /* apply MYPA tendency to U momentum Eq.*/')
       CALL WRITE_0D_L( myPa_applyTendV, INDEX_NONE,
     &  'myPa_applyTendV =',
     &  ' /* apply MYPA tendency to V momentum Eq.*/')
C-   add some other as example:
       CALL WRITE_0D_I( myPa_index1, INDEX_NONE, ' myPa_index1 =',
     &  ' /* user defined parameter */')
       CALL WRITE_0D_RL( myPa_param1, INDEX_NONE, ' myPa_param1 =',
     &  ' /* user defined parameter */')
       CALL WRITE_0D_C( myPa_string1,-1,INDEX_NONE,'myPa_string1 =',
     &  ' /* user defined parameter */')

C--  Check parameters:

C-     Put stops here if some flags are wrongly chosen.
C-     For example, require this package to use tempStepping
       IF ( .NOT.tempStepping .AND. myPa_applyTendT ) THEN
        WRITE(msgBuf,'(A)') 'An example requirement is:'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(A)') 'myPa_applyTendT needs tempStepping=.true.'
        CALL PRINT_ERROR( msgBuf, myThid )
        CALL ALL_PROC_DIE( 0 )
        STOP 'ABNORMAL END: S/R MYPACKAGE_CHECK'
       ENDIF

      _END_MASTER(myThid)

      RETURN
      END

#include "DIAG_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: DIAGNOSTICS_INIT_VARIA

C     !INTERFACE:
      SUBROUTINE DIAGNOSTICS_INIT_VARIA( myThid )

C     !DESCRIPTION:
C     Initialize the qdiag array which accumulates during integration

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "DIAGNOSTICS_SIZE.h"
#include "DIAGNOSTICS.h"

C     !INPUT PARAMETERS:
      INTEGER myThid
CEOP

C     !LOCAL VARIABLES:
      INTEGER i,j,k,bi,bj

C--   Track diagnostics pkg activation status:
      _BARRIER
      _BEGIN_MASTER( myThid )
c      IF ( diag_pkgStatus.NE.3 ) STOP
       diag_pkgStatus = 10
      _END_MASTER( myThid )
      _BARRIER

C--   Set I/O unit and open diag-stats ASCII output file:
      CALL DIAGSTATS_INI_IO( myThid )

C--   Zero out the qdiag array which accumulates during integration
      DO bj = myByLo(myThid), myByHi(myThid)
        DO bi = myBxLo(myThid), myBxHi(myThid)
          DO k = 1,numDiags
            DO j = 1-OLy,sNy+OLy
              DO i = 1-OLx,sNx+OLx
                qdiag(i,j,k,bi,bj) = 0. _d 0
              ENDDO
            ENDDO
C-    Zero out the counters for the qdiag array
            ndiag(k,bi,bj) = 0
          ENDDO
          DO k = 1,numLists
C-    Zero out the index array for periodic averaging diagnostic
            pdiag(k,bi,bj) = 0
          ENDDO
        ENDDO
      ENDDO

C--   Zero out the qSdiag array (statistics) which accumulates during integration
      DO bj = myByLo(myThid), myByHi(myThid)
        DO bi = myBxLo(myThid), myBxHi(myThid)
          DO k = 1,diagSt_size
            DO j = 0,nRegions
              DO i = 0,nStats
                qSdiag(i,j,k,bi,bj) = 0. _d 0
              ENDDO
            ENDDO
          ENDDO
        ENDDO
      ENDDO

      CALL DIAGNOSTICS_READ_PICKUP( myThid )

      CALL DIAGNOSTICS_SUMMARY( 0, startTime, nIter0, myThid )

      RETURN
      END

#include "COST_OPTIONS.h"

      SUBROUTINE COST_DEPENDENT_INIT( myThid )

c     ==================================================================
c     SUBROUTINE cost_dependent_init
c     ==================================================================
c
c     o Initialise the variable ad cost function part.
c
c     started: heimbach@mit.edu 17-Jan-2002
c
c     ==================================================================
c     SUBROUTINE cost_dependent_init
c     ==================================================================

      IMPLICIT NONE

c     == global variables ==
#include "EEPARAMS.h"
#include "SIZE.h"
#include "cost.h"
#include "adcost.h"
#ifdef ALLOW_TAPENADE
# include "COST_TAP_ADJ.h"
#endif

c     == routine arguments ==
      INTEGER myThid

c     == local variables ==
#if ( defined ALLOW_COST_VECTOR || defined  ALLOW_COST_STATE_FINAL )
      INTEGER i
#endif
#ifdef ALLOW_COST_STATE_FINAL
      INTEGER j, k
#endif
      INTEGER bi,bj
c     == end of interface ==

#ifdef ALLOW_OPENAD
      fc%v = 0.0
#else
      fc   = 0. _d 0
#endif

#ifdef ALLOW_AUTODIFF

#ifdef ALLOW_TAPENADE
      fcb = 0. _d 0
      IF ( myProcId .EQ. 0 ) fcb = 1. _d 0
#endif

#ifdef ALLOW_OPENAD
      adfc = 1.0
#else
      adfc = 0. _d 0
      IF ( myProcId .EQ. 0 ) adfc = 1. _d 0
#endif

      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
#ifdef ALLOW_COST_VECTOR
         DO i=1,sNx
          objf_vector(i,bi,bj) = 0. _d 0
          adobjf_vector(i,bi,bj) = 1. _d 0
         ENDDO
#endif
#ifdef ALLOW_COST_STATE_FINAL
         DO k=1,4*Nr+1
          DO j=1,sNy
           DO i=1,sNx
            objf_state_final(i,j,bi,bj,k) = 0. _d 0
           ENDDO
          ENDDO
         ENDDO
cph No init. of cost_state_final here,
cph because we need it in ADM*TLM
#endif
       ENDDO
      ENDDO

#endif /* ALLOW_AUTODIFF */

      RETURN
      END

#include "CPP_OPTIONS.h"

#undef USE_BACKWARD_COMPATIBLE_GRID

CBOP
C     !ROUTINE: INI_SPHERICAL_POLAR_GRID
C     !INTERFACE:
      SUBROUTINE INI_SPHERICAL_POLAR_GRID( myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE INI_SPHERICAL_POLAR_GRID
C     | o Initialise model coordinate system arrays
C     *==========================================================*
C     | These arrays are used throughout the code in evaluating
C     | gradients, integrals and spatial avarages. This routine
C     | is called separately by each thread and initialise only
C     | the region of the domain it is "responsible" for.
C     | Under the spherical polar grid mode primitive distances
C     | in X and Y are in degrees. Distance in Z are in m or Pa
C     | depending on the vertical gridding mode.
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     myThid  :: my Thread Id Number
      INTEGER myThid

C     !LOCAL VARIABLES:
C     == Local variables ==
C     bi,bj   :: tile indices
C     i, j    :: loop counters
C     lat     :: Temporary variables used to hold latitude values.
C     dlat    :: Temporary variables used to hold latitudes increment.
C     dlon    :: Temporary variables used to hold longitude increment.
C     delXloc :: mesh spacing in X direction
C     delYloc :: mesh spacing in Y direction
C     xGloc   :: mesh corner-point location (local "Long" real array type)
C     yGloc   :: mesh corner-point location (local "Long" real array type)
      LOGICAL skipCalcAngleC
      INTEGER bi, bj
      INTEGER i,  j
      INTEGER gridNx, gridNy
      _RL lat, dlat, dlon
C NOTICE the extended range of indices!!
      _RL delXloc(0-OLx:sNx+OLx)
      _RL delYloc(0-OLy:sNy+OLy)
C NOTICE the extended range of indices!!
      _RL xGloc(1-OLx:sNx+OLx+1,1-OLy:sNy+OLy+1)
      _RL yGloc(1-OLx:sNx+OLx+1,1-OLy:sNy+OLy+1)
CEOP

C--   For each tile ...
      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)

C--     set tile local mesh (same units as delX,deY)
C       corresponding to coordinates of cell corners for N+1 grid-lines
        CALL INI_LOCAL_GRID(
     O                       xGloc, yGloc,
     O                       delXloc, delYloc,
     O                       gridNx, gridNy,
     I                       bi, bj, myThid )

C--     Make a permanent copy of [xGloc,yGloc] in [xG,yG]
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          xG(i,j,bi,bj) = xGloc(i,j)
          yG(i,j,bi,bj) = yGloc(i,j)
         ENDDO
        ENDDO

C--     Calculate [xC,yC], coordinates of cell centers
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
C         by averaging
          xC(i,j,bi,bj) = 0.25 _d 0*(
     &     xGloc(i,j)+xGloc(i+1,j)+xGloc(i,j+1)+xGloc(i+1,j+1) )
          yC(i,j,bi,bj) = 0.25 _d 0*(
     &     yGloc(i,j)+yGloc(i+1,j)+yGloc(i,j+1)+yGloc(i+1,j+1) )
         ENDDO
        ENDDO

C--     Calculate [dxF,dyF], lengths between cell faces (through center)
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
C         by averaging
c         dxF(i,j,bi,bj) = 0.5*(dxG(i,j,bi,bj)+dxG(i,j+1,bi,bj))
c         dyF(i,j,bi,bj) = 0.5*(dyG(i,j,bi,bj)+dyG(i+1,j,bi,bj))
C         by formula
          lat = yC(i,j,bi,bj)
          dlon = delXloc(i)
          dlat = delYloc(j)
          dxF(i,j,bi,bj) = rSphere*COS(lat*deg2rad)*dlon*deg2rad
          dyF(i,j,bi,bj) = rSphere*dlat*deg2rad
         ENDDO
        ENDDO

C--     Calculate [dxG,dyG], lengths along cell boundaries
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
C         by averaging
c         dxG(i,j,bi,bj) = 0.5*(dxF(i,j,bi,bj)+dxF(i,j-1,bi,bj))
c         dyG(i,j,bi,bj) = 0.5*(dyF(i,j,bi,bj)+dyF(i-1,j,bi,bj))
C         by formula
          lat = 0.5 _d 0*(yGloc(i,j)+yGloc(i+1,j))
          dlon = delXloc(i)
          dlat = delYloc(j)
          dxG(i,j,bi,bj) = rSphere*COS(deg2rad*lat)*dlon*deg2rad
          IF (dxG(i,j,bi,bj).LT.1.) dxG(i,j,bi,bj)=0.
          dyG(i,j,bi,bj) = rSphere*dlat*deg2rad
         ENDDO
        ENDDO

C--     The following arrays are not defined in some parts of the halo
C       region. We set them to zero here for safety. If they are ever
C       referred to, especially in the denominator then it is a mistake!
C       Note: this is now done earlier in main S/R INI_GRID
c       DO j=1-OLy,sNy+OLy
c        DO i=1-OLx,sNx+OLx
c         dxC(i,j,bi,bj) = 0.
c         dyC(i,j,bi,bj) = 0.
c         dxV(i,j,bi,bj) = 0.
c         dyU(i,j,bi,bj) = 0.
c         rAw(i,j,bi,bj) = 0.
c         rAs(i,j,bi,bj) = 0.
c        ENDDO
c       ENDDO

C--     Calculate [dxC], zonal length between cell centers
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx+1,sNx+OLx ! NOTE range
C         by averaging
          dxC(i,j,bi,bj) = 0.5 _d 0*(dxF(i,j,bi,bj)+dxF(i-1,j,bi,bj))
C         by formula
c         lat = 0.5*(yC(i,j,bi,bj)+yC(i-1,j,bi,bj))
c         dlon = 0.5*( delXloc(i) + delXloc(i-1) )
c         dxC(i,j,bi,bj) = rSphere*COS(deg2rad*lat)*dlon*deg2rad
C         by difference
c         lat = 0.5*(yC(i,j,bi,bj)+yC(i-1,j,bi,bj))
c         dlon = (xC(i,j,bi,bj)-xC(i-1,j,bi,bj))
c         dxC(i,j,bi,bj) = rSphere*COS(deg2rad*lat)*dlon*deg2rad
         ENDDO
        ENDDO

C--     Calculate [dyC], meridional length between cell centers
        DO j=1-OLy+1,sNy+OLy ! NOTE range
         DO i=1-OLx,sNx+OLx
C         by averaging
          dyC(i,j,bi,bj) = 0.5 _d 0*(dyF(i,j,bi,bj)+dyF(i,j-1,bi,bj))
C         by formula
c         dlat = 0.5*( delYloc(j) + delYloc(j-1) )
c         dyC(i,j,bi,bj) = rSphere*dlat*deg2rad
C         by difference
c         dlat = (yC(i,j,bi,bj)-yC(i,j-1,bi,bj))
c         dyC(i,j,bi,bj) = rSphere*dlat*deg2rad
         ENDDO
        ENDDO

C--     Calculate [dxV,dyU], length between velocity points (through corners)
        DO j=1-OLy+1,sNy+OLy ! NOTE range
         DO i=1-OLx+1,sNx+OLx ! NOTE range
C         by averaging (method I)
          dxV(i,j,bi,bj) = 0.5 _d 0*(dxG(i,j,bi,bj)+dxG(i-1,j,bi,bj))
          dyU(i,j,bi,bj) = 0.5 _d 0*(dyG(i,j,bi,bj)+dyG(i,j-1,bi,bj))
C         by averaging (method II)
c         dxV(i,j,bi,bj) = 0.5*(dxG(i,j,bi,bj)+dxG(i-1,j,bi,bj))
c         dyU(i,j,bi,bj) = 0.5*(dyC(i,j,bi,bj)+dyC(i-1,j,bi,bj))
         ENDDO
        ENDDO

C--     Calculate vertical face area (tracer cells)
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          lat=0.5 _d 0*(yGloc(i,j)+yGloc(i+1,j))
          dlon = delXloc(i)
          dlat = delYloc(j)
          rA(i,j,bi,bj) = rSphere*rSphere*dlon*deg2rad
     &        *ABS( SIN((lat+dlat)*deg2rad)-SIN(lat*deg2rad) )
#ifdef USE_BACKWARD_COMPATIBLE_GRID
          lat = yC(i,j,bi,bj) - delYloc(j)*0.5 _d 0
          dlat= yC(i,j,bi,bj) + delYloc(j)*0.5 _d 0
          rA(i,j,bi,bj) = dyF(i,j,bi,bj)
     &    *rSphere*(SIN(dlat*deg2rad)-SIN(lat*deg2rad))
#endif /* USE_BACKWARD_COMPATIBLE_GRID */
         ENDDO
        ENDDO

C--     Calculate vertical face area (u cells)
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx+1,sNx+OLx ! NOTE range
C         by averaging
          rAw(i,j,bi,bj) = 0.5 _d 0*(rA(i,j,bi,bj)+rA(i-1,j,bi,bj))
C         by formula
c         lat=yGloc(i,j)
c         dlon = 0.5*( delXloc(i) + delXloc(i-1) )
c         dlat = delYloc(j)
c         rAw(i,j,bi,bj) = rSphere*rSphere*dlon*deg2rad
c    &        *abs( sin((lat+dlat)*deg2rad)-sin(lat*deg2rad) )
         ENDDO
        ENDDO

C--     Calculate vertical face area (v cells)
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
C         by formula
          lat=yC(i,j,bi,bj)
          dlon = delXloc(i)
          dlat = 0.5 _d 0*( delYloc(j) + delYloc(j-1) )
#ifdef USE_BACKWARD_COMPATIBLE_GRID
          dlat= delYloc(j)
#endif /* USE_BACKWARD_COMPATIBLE_GRID */
          rAs(i,j,bi,bj) = rSphere*rSphere*dlon*deg2rad
     &        *ABS( SIN(lat*deg2rad)-SIN((lat-dlat)*deg2rad) )
          IF (ABS(lat).GT.90..OR.ABS(lat-dlat).GT.90.) rAs(i,j,bi,bj)=0.
         ENDDO
        ENDDO

C--     Calculate vertical face area (vorticity points)
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
C         by formula
          lat  = 0.5 _d 0*(yGloc(i,j)+yGloc(i,j+1))
          dlon = 0.5 _d 0*( delXloc(i) + delXloc(i-1) )
          dlat = 0.5 _d 0*( delYloc(j) + delYloc(j-1) )
          rAz(i,j,bi,bj) = rSphere*rSphere*dlon*deg2rad
     &     *ABS( SIN(lat*deg2rad)-SIN((lat-dlat)*deg2rad) )
          IF (ABS(lat).GT.90..OR.ABS(lat-dlat).GT.90.) rAz(i,j,bi,bj)=0.
         ENDDO
        ENDDO

C--     Calculate trigonometric terms & grid orientation:
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          lat=0.5 _d 0*(yGloc(i,j)+yGloc(i,j+1))
          tanPhiAtU(i,j,bi,bj)=TAN(lat*deg2rad)
          lat=0.5 _d 0*(yGloc(i,j)+yGloc(i+1,j))
          tanPhiAtV(i,j,bi,bj)=TAN(lat*deg2rad)
C       Note: this is now done earlier in main S/R INI_GRID
c         angleCosC(i,j,bi,bj) = 1.
c         angleSinC(i,j,bi,bj) = 0.
         ENDDO
        ENDDO

C--     Cosine(lat) scaling
        DO j=1-OLy,sNy+OLy
         i = 1
         IF (cosPower.NE.0.) THEN
          lat = 0.5 _d 0*(yGloc(i,j)+yGloc(i,j+1))
          cosFacU(j,bi,bj) = ABS( COS(lat*deg2rad) )**cosPower
          lat = 0.5 _d 0*(yGloc(i,j)+yGloc(i+1,j))
          cosFacV(j,bi,bj) = ABS( COS(lat*deg2rad) )**cosPower
          sqcosFacU(j,bi,bj) = SQRT(cosFacU(j,bi,bj))
          sqcosFacV(j,bi,bj) = SQRT(cosFacV(j,bi,bj))
         ELSE
          cosFacU(j,bi,bj) = 1.
          cosFacV(j,bi,bj) = 1.
          sqcosFacU(j,bi,bj)=1.
          sqcosFacV(j,bi,bj)=1.
         ENDIF
        ENDDO

C--   end bi,bj loops
       ENDDO
      ENDDO

      IF ( rotateGrid ) THEN
       CALL ROTATE_SPHERICAL_POLAR_GRID( xC, yC, myThid )
       CALL ROTATE_SPHERICAL_POLAR_GRID( xG, yG, myThid )
       skipCalcAngleC = .FALSE.
       CALL CALC_GRID_ANGLES( skipCalcAngleC, myThid )
      ENDIF

      RETURN
      END

#     include "GAD_OPTIONS.h"

      SUBROUTINE GAD_PPM_HAT_X(bi,bj,kk,iy,
     &           method,mask,fbar,edge,
     &           ohat,fhat,myThid)
C     |================================================================|
C     | PPM_HAT_X: reconstruct grid-cell PPM polynomials.              |
C     |================================================================|

          implicit none

C     =============================================== global variables
#         include "SIZE.h"
#         include "GRID.h"
#         include "GAD.h"

C     ====================================================== arguments
C       bi,bj     :: tile indexing.
C       kk        :: r-indexing.
C       iy        :: y-indexing.
C       method    :: advection scheme.
C       mask      :: row of cell-wise masking values.
C       fbar      :: row of cell-wise values.
C       edge      :: row of edge-wise values.
C       ohat      :: row of oscl. coeff.
C                    - OHAT(1,:) = D^1F/DS^1.
C                    - OHAT(2,:) = D^2F/DS^2.
C       fhat      :: row of poly. coeff.
C                    - FHAT(:,I) = PPM coeff.
C       myThid    :: thread number.
C     ================================================================
          integer bi,bj,kk,iy
          integer method
          _RL mask(1-OLx:sNx+OLx)
          _RL fbar(1-OLx:sNx+OLx)
          _RL edge(1-OLx:sNx+OLx)
          _RL ohat(1:2,
     &             1-OLx:sNx+OLx)
          _RL fhat(1:3,
     &             1-OLx:sNx+OLx)
          integer myThid

C     ====================================================== variables
C       ii,ix     :: local x-indexing.
C       ff00      :: centre-biased cell mean.
C       ffll,ffrr :: left-, and right-biased cell values.
C       fell,ferr :: left-, and right-biased edge values.
C       dfds      :: linear slope estimates.
C       uhat      :: "NULL" limited poly. coeff.
C       lhat      :: "MONO" limited poly. coeff.
C       scal      :: "WENO" weights.
C       fmag,fdel :: local perturbation indicators.
C     ================================================================
          integer ii,ix
          _RL ff00,ffll,ffrr
          _RL fell,ferr
          _RL dfds(-1:+1)
          _RL uhat(+1:+3)
          _RL lhat(+1:+3)
          _RL scal(+1:+2)
          _RL fmag,fdel
          integer  mono

          do  ix = 1-OLx+2, sNx+OLx-2

C     =============================== assemble cell mean + edge values
              ff00 = fbar(ix+0)
              ffll = ff00
     &             + mask(ix-1)*(fbar(ix-1)-ff00)
              ffrr = ff00
     &             + mask(ix+1)*(fbar(ix+1)-ff00)

              fell = edge(ix-0)
              ferr = edge(ix+1)

c             select case(method)
c             case(ENUM_PPM_NULL_LIMIT)
              if ( method.eq.ENUM_PPM_NULL_LIMIT ) then
C     =============================== "NULL" limited grid-cell profile
              CALL GAD_PPM_FUN_NULL ( ff00,fell,ferr,
     &             lhat,mono)

c             case(ENUM_PPM_MONO_LIMIT)
              elseif ( method.eq.ENUM_PPM_MONO_LIMIT ) then
C     =============================== "MONO" limited grid-cell profile
              CALL GAD_PLM_FUN_U(ffll,ff00,ffrr,dfds)

              CALL GAD_PPM_FUN_MONO ( ff00,ffll,ffrr,
     &             fell,ferr,dfds,lhat,mono)

c             case(ENUM_PPM_WENO_LIMIT)
              elseif ( method.eq.ENUM_PPM_WENO_LIMIT ) then
C     =============================== "WENO" limited grid-cell profile
              CALL GAD_PLM_FUN_U(ffll,ff00,ffrr,dfds)

              CALL GAD_PPM_FUN_NULL ( ff00,fell,ferr,
     &             uhat,mono)

              CALL GAD_PPM_FUN_MONO ( ff00,ffll,ffrr,
     &             fell,ferr,dfds,lhat,mono)

              if ( mono .gt. 0) then

C     =============================== only apply WENO if it is worth it
              fdel = abs(ffrr-ff00)+abs(ff00-ffll)
              fmag = abs(ffll)+abs(ff00)+abs(ffrr)

              if (fdel .gt. 1. _d -6 * fmag) then

C     =============================== calc. WENO oscillation weighting
                  CALL GAD_OSC_MUL_X(ix,+2,mask,
     &                 ohat,scal)

                  do  ii = +1, +3
C     =============================== blend limited/un-limited profile
                  lhat(ii) = scal(1) * uhat(ii)
     &                     + scal(2) * lhat(ii)
                  end do

              end if

              end if

c             end select
              endif

              do  ii = +1, +3
C     =============================== copy polynomial onto output data
                  fhat(ii,ix) = lhat(ii)
              end do

          end do

          return

c     end subroutine GAD_PPM_HAT_X
      end

#include "MONITOR_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: MON_PRINTSTATS_RL

C     !INTERFACE:
      SUBROUTINE MON_PRINTSTATS_RL(
     I     myNr, arr, arrName,
     I     arrMask,arrhFac,arrArea,arrDr,
     I     myThid )

C     !DESCRIPTION:
C     Prints to STDOUT the bare statistics of global array "\_RL arr"
C     with label "arrName".

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "MONITOR.h"

C     !INPUT PARAMETERS:
      INTEGER myNr
      _RL arr(1-OLx:sNx+OLx,1-OLy:sNy+OLy,myNr,nSx,nSy)
      _RS arrMask(1-OLx:sNx+OLx,1-OLy:sNy+OLy,myNr,nSx,nSy)
      _RS arrhFac(1-OLx:sNx+OLx,1-OLy:sNy+OLy,myNr,nSx,nSy)
      _RS arrArea(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RS arrDr(myNr)
      CHARACTER*(*) arrName
      INTEGER myThid
CEOP

C     !LOCAL VARIABLES:
      _RL theMin, theMax, theMean, theSD, theDel2, theVol

C     Since 2009/12/21 MON_WRITESTATS_RL replaces MON_PRINTSTATS_RL
C     which is now disabled
      STOP 'ABNORMAL END: S/R MON_PRINTSTATS_RL no longer maintained'

      CALL MON_STATS_RL(
     I     myNr, arr, arrMask, arrhFac, arrArea, arrDr,
     O     theMin, theMax, theMean, theSD, theDel2, theVol,
     I     myThid )

      CALL MON_OUT_RL( arrName, theMax,  mon_foot_max  ,myThid)
      CALL MON_OUT_RL( arrName, theMin,  mon_foot_min  ,myThid)
      CALL MON_OUT_RL( arrName, theMean, mon_foot_mean ,myThid)
      CALL MON_OUT_RL( arrName, theSD,   mon_foot_sd   ,myThid)
      CALL MON_OUT_RL( arrName, theDel2, mon_foot_del2 ,myThid)
c     CALL MON_OUT_RL( arrName, theVol,  mon_foot_vol  ,myThid)

      RETURN
      END

#include "GAD_OPTIONS.h"
#include "PTRACERS_OPTIONS.h"

CBOP
C     !ROUTINE: PTRACERS_READ_PICKUP

C     !INTERFACE:
      SUBROUTINE PTRACERS_READ_PICKUP( myIter, myThid )

C     !DESCRIPTION:
C     Reads current state of passive tracers from a pickup file

C     !USES:
#include "PTRACERS_MOD.h"
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GAD.h"
#include "PTRACERS_SIZE.h"
#include "PTRACERS_PARAMS.h"
#include "PTRACERS_START.h"
#include "PTRACERS_FIELDS.h"

C     !INPUT PARAMETERS:
C     myIter            :: time-step number
C     myThid            :: thread number
      INTEGER myIter
      INTEGER myThid

#ifdef ALLOW_PTRACERS

C     !LOCAL VARIABLES:
C     iTracer     :: tracer index
C     iRec        :: record number
C     fn          :: character buffer for creating filename
C     prec        :: precision of pickup files
C     filePrec    :: pickup-file precision (read from meta file)
C     nbFields    :: number of fields in pickup file (read from meta file)
C     fldName     :: Name of the field to read
C     missFldList :: List of missing fields   (attempted to read but not found)
C     missFldDim  :: Dimension of missing fields list array: missFldList
C     nMissing    :: Number of missing fields (attempted to read but not found)
C     j           :: loop index
C     nj          :: record number
C     ioUnit      :: temp for writing msg unit
C     msgBuf      :: Informational/error message buffer
      INTEGER iTracer, iRec, prec
      INTEGER filePrec, nbFields
      INTEGER missFldDim, nMissing
      INTEGER nj, ioUnit
      PARAMETER( missFldDim = 2*PTRACERS_num )
      CHARACTER*(10) suff
      CHARACTER*(MAX_LEN_FNAM) fn
      CHARACTER*(8) fldName, missFldList(missFldDim)
      CHARACTER*(MAX_LEN_MBUF) msgBuf
#ifdef PTRACERS_ALLOW_DYN_STATE
      CHARACTER*(MAX_LEN_FNAM) filNam
      LOGICAL useCurrentDir, fileExist
      INTEGER n
#endif
CEOP

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#ifdef ALLOW_MNC
      IF ( PTRACERS_pickup_read_mnc ) THEN
C       Read variables from the pickup file
        WRITE(fn,'(a)') 'pickup_ptracers'
        CALL MNC_FILE_CLOSE_ALL_MATCHING(fn, myThid)
        CALL MNC_CW_SET_UDIM(fn, 1, myThid)
        CALL MNC_CW_SET_CITER(fn, 3, 3, myIter, -1, myThid)
        DO iTracer = 1, PTRACERS_numInUse
          CALL MNC_CW_RL_R('D',fn,0,0, PTRACERS_names(iTracer),
     &         gpTrNm1(1-OLx,1-OLy,1,1,1,iTracer),myThid)
          CALL EXCH_3D_RL( gpTrNm1(1-OLx,1-OLy,1,1,1,iTracer),
     &                     Nr, myThid )
        ENDDO
        CALL MNC_CW_SET_UDIM(fn, 2, myThid)
        DO iTracer = 1, PTRACERS_numInUse
          CALL MNC_CW_RL_R('D',fn,0,0, PTRACERS_names(iTracer),
     &         pTracer(1-OLx,1-OLy,1,1,1,iTracer),myThid)
          CALL EXCH_3D_RL( pTracer(1-OLx,1-OLy,1,1,1,iTracer),
     &                     Nr, myThid )
        ENDDO
      ENDIF
      IF ( useMNC .AND. PTRACERS_pickup_read_mnc ) THEN
       DO iTracer = 1, PTRACERS_numInUse
        IF ( PTRACERS_SOM_Advection(iTracer) ) THEN
         WRITE(msgBuf,'(3A)')'PTRACERS_READ_PICKUP: MNC not yet coded',
     &                       ' for SOM advection',
     &                       ' => read bin file instead'
         CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                       SQUEEZE_RIGHT, myThid)
        ENDIF
       ENDDO
      ENDIF
#endif /*  ALLOW_MNC  */

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      IF ( PTRACERS_pickup_read_mdsio ) THEN

       IF ( pickupSuff.EQ.' ' ) THEN
        IF ( rwSuffixType.EQ.0 ) THEN
          WRITE(fn,'(A,I10.10)') 'pickup_ptracers.', myIter
        ELSE
          CALL RW_GET_SUFFIX( suff, startTime, myIter, myThid )
          WRITE(fn,'(A,A)') 'pickup_ptracers.', suff
        ENDIF
       ELSE
        WRITE(fn,'(A,A10)') 'pickup_ptracers.', pickupSuff
       ENDIF
       prec = precFloat64

       CALL READ_MFLDS_SET(
     I                      fn,
     O                      nbFields, filePrec,
     I                      Nr, myIter, myThid )
       _BEGIN_MASTER( myThid )
c      IF ( filePrec.NE.0 .AND. filePrec.NE.prec ) THEN
       IF ( nbFields.GE.0 .AND. filePrec.NE.prec ) THEN
         WRITE(msgBuf,'(2A,I4)') 'PTRACERS_READ_PICKUP: ',
     &    'pickup-file binary precision do not match !'
         CALL PRINT_ERROR( msgBuf, myThid )
         WRITE(msgBuf,'(A,2(A,I4))') 'PTRACERS_READ_PICKUP: ',
     &    'file prec.=', filePrec, ' but expecting prec.=', prec
         CALL PRINT_ERROR( msgBuf, myThid )
         STOP 'ABNORMAL END: S/R PTRACERS_READ_PICKUP (data-prec Pb)'
       ENDIF
       _END_MASTER( myThid )

       IF ( nbFields.LE.0 ) THEN
C-      No meta-file or old meta-file without List of Fields
        ioUnit = errorMessageUnit
        IF ( pickupStrictlyMatch ) THEN
          WRITE(msgBuf,'(4A)') 'PTRACERS_READ_PICKUP: ',
     &      'no field-list found in meta-file',
     &      ' => cannot check for strick-matching'
          CALL PRINT_ERROR( msgBuf, myThid )
          WRITE(msgBuf,'(4A)') 'PTRACERS_READ_PICKUP: ',
     &      'try with " pickupStrictlyMatch=.FALSE.,"',
     &      ' in file: "data", NameList: "PARM03"'
          CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
          STOP 'ABNORMAL END: S/R PTRACERS_READ_PICKUP'
        ELSE
          WRITE(msgBuf,'(4A)') 'WARNING >> PTRACERS_READ_PICKUP: ',
     &      ' no field-list found'
          CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
         IF ( nbFields.EQ.-1 ) THEN
C-      No meta-file
          WRITE(msgBuf,'(4A)') 'WARNING >> ',
     &      ' try to read pickup as currently written'
          CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
         ELSE
C-      Old meta-file without List of Fields
          WRITE(msgBuf,'(4A)') 'WARNING >> ',
     &      ' try to read pickup as it used to be written'
          CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
          WRITE(msgBuf,'(4A)') 'WARNING >> ',
     &      ' until checkpoint59l (2007 Dec 17)'
          CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
         ENDIF
        ENDIF
       ENDIF

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C---   Very Old way to read ptracer pickup:
       IF ( nbFields.EQ.0 .AND. usePickupBeforeC54 ) THEN
C       Read fields as consecutive records
        DO iTracer = 1, PTRACERS_numInUse
          iRec = iTracer
          CALL READ_REC_3D_RL( fn, prec, Nr,
     O         pTracer(1-OLx,1-OLy,1,1,1,iTracer),
     I         iRec, myIter, myThid )
          CALL EXCH_3D_RL( pTracer(1-OLx,1-OLy,1,1,1,iTracer),
     &                     Nr, myThid )
        ENDDO

C       Read historical tendencies as consecutive records
c       DO iTracer = 1,PTRACERS_numInUse
c         iRec = iTracer + PTRACERS_num
c         CALL READ_REC_3D_RL( fn, prec, Nr,
c    O         gPtr(1-OLx,1-OLy,1,1,1,iTracer),
c    I         iRec, myIter, myThid )
c         CALL EXCH_3D_RL( gPtr(1-OLx,1-OLy,1,1,1,iTracer),
c    &                     Nr, myThid )
c       ENDDO
        DO iTracer = 1, PTRACERS_numInUse
          iRec = iTracer + PTRACERS_num*2
          CALL READ_REC_3D_RL( fn, prec, Nr,
     O         gpTrNm1(1-OLx,1-OLy,1,1,1,iTracer),
     I         iRec, myIter, myThid )
          CALL EXCH_3D_RL( gpTrNm1(1-OLx,1-OLy,1,1,1,iTracer),
     &                     Nr, myThid )
        ENDDO

       ELSEIF ( nbFields.EQ.0 ) THEN
C---   Old way to read ptracer pickup:
C       Read fields & tendencies (needed for AB) as consecutive records,
C       one tracer after the other, only for tracers "InUse".  Note:
C       this allow to restart from a pickup with a different number of
C       tracers, with write_pickup dumping all of them (PTRACERS_num).
        DO iTracer = 1, PTRACERS_numInUse
          iRec = 2*iTracer -1
          CALL READ_REC_3D_RL( fn, prec, Nr,
     O         pTracer(1-OLx,1-OLy,1,1,1,iTracer),
     I         iRec, myIter, myThid )
          iRec = 2*iTracer
          CALL READ_REC_3D_RL( fn, prec, Nr,
     O         gpTrNm1(1-OLx,1-OLy,1,1,1,iTracer),
     I         iRec, myIter, myThid )
          CALL EXCH_3D_RL( pTracer(1-OLx,1-OLy,1,1,1,iTracer),
     &                     Nr, myThid )
          CALL EXCH_3D_RL( gpTrNm1(1-OLx,1-OLy,1,1,1,iTracer),
     &                     Nr, myThid )
        ENDDO

       ELSE
C---   New way to read ptracer pickup:
        nj = 0
        DO iTracer = 1, PTRACERS_numInUse
C---    read pTracer 3-D fields for restart
          fldName = 'pTr'//PTRACERS_ioLabel(iTracer)//'   '
          CALL READ_MFLDS_3D_RL( fldName,
     O                     pTracer(1-OLx,1-OLy,1,1,1,iTracer),
     &                     nj, prec, Nr, myIter, myThid )
          CALL EXCH_3D_RL( pTracer(1-OLx,1-OLy,1,1,1,iTracer),
     &                     Nr, myThid )
        ENDDO
        DO iTracer = 1, PTRACERS_numInUse
C---    read pTracer 3-D tendencies for AB-restart
         IF ( PTRACERS_AdamsBashGtr(iTracer) .OR.
     &        PTRACERS_AdamsBash_Tr(iTracer) ) THEN
          IF ( PTRACERS_AdamsBashGtr(iTracer) )
     &      fldName = 'gPtr'//PTRACERS_ioLabel(iTracer)//'m1'
          IF ( PTRACERS_AdamsBash_Tr(iTracer) )
     &      fldName = 'pTr'//PTRACERS_ioLabel(iTracer)//'Nm1'
          CALL READ_MFLDS_3D_RL( fldName,
     O                     gpTrNm1(1-OLx,1-OLy,1,1,1,iTracer),
     &                     nj, prec, Nr, myIter, myThid )
          CALL EXCH_3D_RL( gpTrNm1(1-OLx,1-OLy,1,1,1,iTracer),
     &                     Nr, myThid )
         ENDIF
        ENDDO

C--    end: new way to read pickup file
       ENDIF

C--    Check for missing fields:
       nMissing = missFldDim
       CALL READ_MFLDS_CHECK(
     O                     missFldList,
     U                     nMissing,
     I                     myIter, myThid )
       IF ( nMissing.GT.missFldDim ) THEN
         WRITE(msgBuf,'(2A,I4)') 'PTRACERS_READ_PICKUP: ',
     &     'missing fields list has been truncated to', missFldDim
         CALL PRINT_ERROR( msgBuf, myThid )
         STOP 'ABNORMAL END: S/R PTRACERS_READ_PICKUP (list-size Pb)'
       ENDIF
       CALL PTRACERS_CHECK_PICKUP(
     I                     missFldList,
     I                     nMissing, nbFields,
     I                     myIter, myThid )

C--   end: pickup_read_mdsio
      ENDIF

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#ifdef PTRACERS_ALLOW_DYN_STATE
c     IF ( PTRACERS_pickup_read_mdsio ) THEN

C--   Read pickup file with 2nd.Order moment fields
       prec = precFloat64
       DO iTracer = 1, PTRACERS_numInUse
        IF ( PTRACERS_SOM_Advection(iTracer) ) THEN

         IF ( pickupSuff.EQ.' ' ) THEN
           IF ( rwSuffixType.EQ.0 ) THEN
             WRITE(fn,'(3A,I10.10)') 'pickup_somTRAC',
     &                     PTRACERS_ioLabel(iTracer),'.', myIter
           ELSE
             CALL RW_GET_SUFFIX( suff, startTime, myIter, myThid )
             WRITE(fn,'(3A,A)') 'pickup_somTRAC',
     &                     PTRACERS_ioLabel(iTracer),'.', suff
           ENDIF
         ELSE
           WRITE(fn,'(3A,A10)') 'pickup_somTRAC',
     &                     PTRACERS_ioLabel(iTracer),'.', pickupSuff
         ENDIF
         ioUnit = standardMessageUnit
         WRITE(msgBuf,'(A,I3,A)')'PTRACERS_READ_PICKUP: iTracer = ',
     &            iTracer, ' : reading 2nd-order moments from file:'
         CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
         CALL PRINT_MESSAGE( fn,     ioUnit, SQUEEZE_RIGHT, myThid )

C-      First check if pickup file exist
#ifdef ALLOW_MDSIO
         useCurrentDir = .FALSE.
         CALL MDS_CHECK4FILE(
     I                       fn, '.data', 'PTRACERS_READ_PICKUP',
     O                       filNam, fileExist,
     I                       useCurrentDir, myThid )
#else
         STOP 'ABNORMAL END: S/R PTRACERS_READ_PICKUP: Needs MDSIO pkg'
#endif

         IF ( fileExist ) THEN
C-       Read 2nd Order moments as consecutive records
          DO n=1,nSOM
           iRec = n
           CALL READ_REC_3D_RL( fn, prec, Nr,
     O               _Ptracers_som(:,:,:,:,:,n,iTracer),
     I               iRec, myIter, myThid )
          ENDDO
          CALL GAD_EXCH_SOM( _Ptracers_som(:,:,:,:,:,:,iTracer),
     &                       Nr, myThid )
         ELSE
          ioUnit = errorMessageUnit
          IF ( pickupStrictlyMatch ) THEN
            WRITE(msgBuf,'(4A)') 'PTRACERS_READ_PICKUP: ',
     &        'try with " pickupStrictlyMatch=.FALSE.,"',
     &        ' in file: "data", NameList: "PARM03"'
            CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
            STOP 'ABNORMAL END: S/R PTRACERS_READ_PICKUP'
          ELSE
            WRITE(msgBuf,'(2A)') 'WARNING >> PTRACERS_READ_PICKUP: ',
     &        'approximated restart: reset Ptr_SOM to zero'
            CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
          ENDIF
         ENDIF
        ENDIF
       ENDDO

C--   end: pickup_read_mdsio, SOM pickups
c     ENDIF
#endif /* PTRACERS_ALLOW_DYN_STATE */

#endif /* ALLOW_PTRACERS */

      RETURN
      END

#include "AUTODIFF_OPTIONS.h"
#include "AD_CONFIG.h"

CBOP
C !ROUTINE: DUMP_ADJ_XYZ_UV
C !INTERFACE:
      SUBROUTINE DUMP_ADJ_XYZ_UV(
     I           u3DRS, u3DRL, uDiagName, uDumpName,
     I           v3DRS, v3DRL, vDiagName, vDumpName,
     I           vType, doDump, dumpAdRec, myTime, myIter, myThid )

C !DESCRIPTION:
C     Helper subroutine to dump to file and fill corresponding diagnostics
C     for 3-D 2-component vector field given the millions of autodiff options

C !USES:
      IMPLICIT NONE

C     == Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "AUTODIFF_PARAMS.h"
#ifdef ALLOW_AUTODIFF_MONITOR
# ifdef ALLOW_DIAGNOSTICS
#  include "DIAGNOSTICS_P2SHARE.h"
# endif
#endif /* ALLOW_AUTODIFF_MONITOR */

C !INPUT/OUTPUT PARAMETERS:
C   u3DRS   ( RS ) :: input 3-D, u-component AD-variable field
C   u3DRL   ( RL ) :: input 3-D, u-component AD-variable field
C   uDiagName (C ) :: u-component diagnostics name
C   uDumpName (C ) :: u-component output file prefix
C   v3DRS   ( RS ) :: input 3-D, v-component AD-variable field
C   v3DRL   ( RL ) :: input 3-D, v-component AD-variable field
C   vDiagName (C ) :: v-component diagnostics name
C   vDumpName (C ) :: v-component output file prefix
C   vType  ( Int ) :: type of AD-variable (select which ADEXCH to use)
C       vType (1rst digit):
C           = 1,3 : process RS input field ; = 2,4 : process RL input field
C           = 1,2 : without sign. ;          = 3,4 : with sign.
C       vType (2nd digit) = 10 : A-grid location (i.e., grid-cell center)
C                         = 20 : B-grid location (i.e., grid-cell corner)
C                         = 30 : C-grid location ; = 40 : D-grid location
C   doDump   ( L ) :: do write field to file
C   dumpAdRec (I ) :: record number in file
C   myTime         :: time counter for this thread
C   myIter         :: iteration counter for this thread
C   myThid         :: Thread number for this instance of the routine.
      _RS u3DRS(*)
      _RL u3DRL(*)
      _RS v3DRS(*)
      _RL v3DRL(*)
      CHARACTER*(8) uDiagName
      CHARACTER*(8) vDiagName
      CHARACTER*(*) uDumpName
      CHARACTER*(*) vDumpName
      INTEGER vType
      LOGICAL doDump
      INTEGER dumpAdRec
      _RL     myTime
      INTEGER myIter
      INTEGER myThid

#if (defined (ALLOW_ADJOINT_RUN) || defined (ALLOW_ADMTLM))
#ifdef ALLOW_AUTODIFF_MONITOR

C !LOCAL VARIABLES:
C   suff           :: Hold suffix part of a filename
C   uCopy  ( RL )  :: copy of u-component input field
C   vCopy  ( RL )  :: copy of v-component input field
      CHARACTER*(10) suff
      _RL uCopy(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      _RL vCopy(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
CEOP

C-----------------------------------------------------------------------
C--- Output adj variables in diagnostics
C-----------------------------------------------------------------------

C --- 1. Write out dump fields
      IF ( doDump ) THEN

C--     Set suffix for this set of data files.
        IF ( rwSuffixType.EQ.0 ) THEN
          WRITE(suff,'(I10.10)') myIter
        ELSE
          CALL RW_GET_SUFFIX( suff, myTime, myIter, myThid )
        ENDIF

        IF ( dumpAdVarExch.EQ.2 ) THEN

C--       Copy first
          CALL COPY_AD_UV_OUTP( u3DRS, v3DRS, u3DRL, v3DRL,
     &                          uCopy, vCopy, Nr, vType, myThid )
          IF ( dumpAdByRec ) THEN
            CALL WRITE_REC_XYZ_RL( uDumpName, uCopy, dumpAdRec,
     &                             myIter, myThid )
            CALL WRITE_REC_XYZ_RL( vDumpName, vCopy, dumpAdRec,
     &                             myIter, myThid )
          ELSE
            CALL WRITE_FLD_XYZ_RL( uDumpName, suff, uCopy,
     &                             myIter, myThid )
            CALL WRITE_FLD_XYZ_RL( vDumpName, suff, vCopy,
     &                             myIter, myThid )
          ENDIF

        ELSE ! dumpAdVarExch.eq.2

C--       Write directly
          IF ( MOD(vType,2).NE.1 ) THEN
            IF ( dumpAdByRec ) THEN
              CALL WRITE_REC_XYZ_RL( uDumpName, u3DRL, dumpAdRec,
     &                               myIter, myThid )
              CALL WRITE_REC_XYZ_RL( vDumpName, v3DRL, dumpAdRec,
     &                               myIter, myThid )
            ELSE
              CALL WRITE_FLD_XYZ_RL( uDumpName, suff,u3DRL,
     &                               myIter, myThid )
              CALL WRITE_FLD_XYZ_RL( vDumpName, suff,v3DRL,
     &                               myIter, myThid )
            ENDIF
          ELSE ! is RL
            IF ( dumpAdByRec ) THEN
              CALL WRITE_REC_XYZ_RS( uDumpName, u3DRS, dumpAdRec,
     &                               myIter, myThid )
              CALL WRITE_REC_XYZ_RS( uDumpName, v3DRS, dumpAdRec,
     &                               myIter, myThid )
            ELSE
              CALL WRITE_FLD_XYZ_RS( uDumpName, suff, u3DRS,
     &                               myIter, myThid )
              CALL WRITE_FLD_XYZ_RS( vDumpName, suff, v3DRS,
     &                               myIter, myThid )
            ENDIF
          ENDIF

        ENDIF
      ENDIF

C --- 2. Fill diagnostics
#ifdef ALLOW_DIAGNOSTICS
      IF ( useDiag4AdjOutp .AND. uDiagName.NE.'- None -'
     &                     .AND. vDiagName.NE.'- None -' ) THEN
        IF ( dumpAdVarExch.EQ.2 ) THEN
          IF ( .NOT.doDump )
     &      CALL COPY_AD_UV_OUTP( u3DRS, v3DRS, u3DRL, v3DRL,
     &                            uCopy, vCopy, Nr, vType, myThid )
          CALL DIAGNOSTICS_FILL( uCopy, uDiagName, 0,Nr,0,1,1, myThid )
          CALL DIAGNOSTICS_FILL( vCopy, vDiagName, 0,Nr,0,1,1, myThid )
        ELSE
          IF ( MOD(vType,2).NE.1 ) THEN
            CALL DIAGNOSTICS_FILL( u3DRL, uDiagName,
     &                             0, Nr, 0, 1, 1, myThid )
            CALL DIAGNOSTICS_FILL( v3DRL, vDiagName,
     &                             0, Nr, 0, 1, 1, myThid )
          ELSE
            CALL DIAGNOSTICS_FILL_RS( u3DRS, uDiagName,
     &                             0, Nr, 0, 1, 1, myThid )
            CALL DIAGNOSTICS_FILL_RS( v3DRS, vDiagName,
     &                             0, Nr, 0, 1, 1, myThid )
          ENDIF
        ENDIF
      ENDIF
#endif /* ALLOW_DIAGNOSTICS */

#endif /* ALLOW_AUTODIFF_MONITOR */
#endif /* ALLOW_ADJOINT_RUN */

      RETURN
      END

#include "CTRL_OPTIONS.h"
#ifdef ALLOW_OBCS
# include "OBCS_OPTIONS.h"
#endif

      subroutine ctrl_getobcsn(
     I                          myTime, myIter, myThid )

c     ==================================================================
c     SUBROUTINE ctrl_getobcsn
c     ==================================================================
c
c     o Get northern obc of the control vector and add it
c       to dyn. fields
c
c     started: heimbach@mit.edu, 29-Aug-2001
c     modified: gebbie@mit.edu, 18-Mar-2003
c
c     ==================================================================
c     SUBROUTINE ctrl_getobcsn
c     ==================================================================

      implicit none

c     == global variables ==
#ifdef ALLOW_OBCSN_CONTROL
#include "EEPARAMS.h"
#include "SIZE.h"
#include "PARAMS.h"
#include "GRID.h"
#include "OBCS_PARAMS.h"
#include "OBCS_GRID.h"
#include "OBCS_FIELDS.h"
#include "CTRL_SIZE.h"
#include "CTRL.h"
#include "CTRL_DUMMY.h"
#include "CTRL_OBCS.h"
#include "OPTIMCYCLE.h"
#endif /* ALLOW_OBCSN_CONTROL */

c     == routine arguments ==
      _RL     myTime
      integer myIter
      integer myThid

#if ( defined ALLOW_OBCS_NORTH && defined ALLOW_OBCSN_CONTROL )
c     == external functions ==
      integer  ilnblnk
      external ilnblnk

c     == local variables ==
      integer bi,bj
      integer i,j,k
      integer itlo,ithi
      integer jtlo,jthi
      integer imin,imax
      integer ilobcsn
      integer iobcs
      integer jp1
      _RL     obcsnfac
      logical obcsnfirst
      logical obcsnchanged
      integer obcsncount0
      integer obcsncount1
cgg      _RL maskxz   (1-OLx:sNx+OLx,Nr,nSx,nSy)
      _RL tmpfldxz (1-OLx:sNx+OLx,Nr,nSx,nSy)
      logical doglobalread
      logical ladinit
      character*(MAX_LEN_FNAM) fnameobcsn
#ifdef ALLOW_OBCS_CONTROL_MODES
      integer nk,nz
      _RL     tmpz (Nr,nSx,nSy)
      _RL     stmp
#endif
      integer ilDir

c     == end of interface ==

      jtlo = myByLo(myThid)
      jthi = myByHi(myThid)
      itlo = myBxLo(myThid)
      ithi = myBxHi(myThid)
cgg      imin = 1-olx
cgg      imax = snx+olx
      imin = 1
      imax = sNx
      jp1  = 0

c--   Now, read the control vector.
      doglobalread = .false.
      ladinit      = .false.

c     Find ctrlDir (w/o trailing blanks) length
      ilDir = ilnblnk(ctrlDir)

      if (optimcycle .ge. 0) then
        ilobcsn=ilnblnk( xx_obcsn_file )
        write(fnameobcsn,'(2a,i10.10)')
     &       ctrlDir(1:ilDir)//xx_obcsn_file(1:ilobcsn), '.', optimcycle
      endif

c--   Get the counters, flags, and the interpolation factor.
      call ctrl_get_gen_rec(
     I                   xx_obcsnstartdate, xx_obcsnperiod,
     O                   obcsnfac, obcsnfirst, obcsnchanged,
     O                   obcsncount0,obcsncount1,
     I                   myTime, myIter, myThid )

      do iobcs = 1,nobcs

       if ( obcsnfirst ) then
#ifdef ALLOW_AUTODIFF
        call active_read_xz( fnameobcsn, tmpfldxz,
     &                       (obcsncount0-1)*nobcs+iobcs,
     &                       doglobalread, ladinit, optimcycle,
     &                       myThid, xx_obcsn_dummy )
#else
        CALL READ_REC_XZ_RL( fnameobcsn, ctrlprec, Nr, tmpfldxz,
     &                       (obcsncount0-1)*nobcs+iobcs, 1, myThid )
#endif

        do bj = jtlo,jthi
         do bi = itlo,ithi
#ifdef ALLOW_OBCS_CONTROL_MODES
          if (iobcs .gt. 2) then
           do i = imin,imax
            j = OB_Jn(i,bi,bj)
            IF ( j.EQ.OB_indexNone ) j = 1
cih    Determine number of open vertical layers.
            nz = 0
            do k = 1,Nr
             if (iobcs .eq. 3) then
              nz = nz + maskS(i,j+jp1,k,bi,bj)
             else
              nz = nz + maskW(i,j,k,bi,bj)
             endif
            end do
cih    Compute absolute velocities from the barotropic-baroclinic modes.
            do k = 1,Nr
             if (k.le.nz) then
              stmp = 0.
              do nk = 1,nz
               stmp = stmp +
     &         modesv(k,nk,nz)*tmpfldxz(i,nk,bi,bj)
              end do
              tmpz(k,bi,bj) = stmp
             else
              tmpz(k,bi,bj) = 0.
             end if
            end do
            do k = 1,Nr
             if (iobcs .eq. 3) then
              tmpfldxz(i,k,bi,bj) = tmpz(k,bi,bj)
     &         *recip_hFacS(i,j+jp1,k,bi,bj)
             else
              tmpfldxz(i,k,bi,bj) = tmpz(k,bi,bj)
     &                           *recip_hFacW(i,j,k,bi,bj)
             endif
            end do
           enddo
          endif
#endif
          do k = 1,Nr
           do i = imin,imax
            xx_obcsn1(i,k,bi,bj,iobcs)  = tmpfldxz (i,k,bi,bj)
cgg   &                                    *   maskxz (i,k,bi,bj)
           enddo
          enddo
         enddo
        enddo
       endif

       if ( (obcsnfirst) .or. (obcsnchanged)) then

        do bj = jtlo,jthi
         do bi = itlo,ithi
          do k = 1,Nr
           do i = imin,imax
            xx_obcsn0(i,k,bi,bj,iobcs) = xx_obcsn1(i,k,bi,bj,iobcs)
            tmpfldxz (i,k,bi,bj)       = 0. _d 0
           enddo
          enddo
         enddo
        enddo

#ifdef ALLOW_AUTODIFF
        call active_read_xz( fnameobcsn, tmpfldxz,
     &                       (obcsncount1-1)*nobcs+iobcs,
     &                       doglobalread, ladinit, optimcycle,
     &                       myThid, xx_obcsn_dummy )
#else
        CALL READ_REC_XZ_RL( fnameobcsn, ctrlprec, Nr, tmpfldxz,
     &                       (obcsncount1-1)*nobcs+iobcs, 1, myThid )
#endif

        do bj = jtlo,jthi
         do bi = itlo,ithi
#ifdef ALLOW_OBCS_CONTROL_MODES
          if (iobcs .gt. 2) then
           do i = imin,imax
            j = OB_Jn(i,bi,bj)
            IF ( j.EQ.OB_indexNone ) j = 1
cih    Determine number of open vertical layers.
            nz = 0
            do k = 1,Nr
             if (iobcs .eq. 3) then
              nz = nz + maskS(i,j+jp1,k,bi,bj)
             else
              nz = nz + maskW(i,j,k,bi,bj)
             endif
            end do
cih    Compute absolute velocities from the barotropic-baroclinic modes.
            do k = 1,Nr
             if (k.le.nz) then
              stmp = 0.
              do nk = 1,nz
               stmp = stmp +
     &         modesv(k,nk,nz)*tmpfldxz(i,nk,bi,bj)
              end do
              tmpz(k,bi,bj) = stmp
             else
              tmpz(k,bi,bj) = 0.
             end if
            end do
            do k = 1,Nr
             if (iobcs .eq. 3) then
              tmpfldxz(i,k,bi,bj) = tmpz(k,bi,bj)
     &         *recip_hFacS(i,j+jp1,k,bi,bj)
             else
              tmpfldxz(i,k,bi,bj) = tmpz(k,bi,bj)
     &                           *recip_hFacW(i,j,k,bi,bj)
             endif
            end do
           enddo
          endif
#endif
          do k = 1,Nr
           do i = imin,imax
            xx_obcsn1 (i,k,bi,bj,iobcs) = tmpfldxz (i,k,bi,bj)
cgg   &                                        *   maskxz (i,k,bi,bj)
           enddo
          enddo
         enddo
        enddo
       endif

c--   Add control to model variable.
       do bj = jtlo,jthi
        do bi = itlo,ithi
c--   Calculate mask for tracer cells (0 => land, 1 => water).
         do k = 1,Nr
          do i = 1,sNx
           j = OB_Jn(i,bi,bj)
           IF ( j.EQ.OB_indexNone ) j = 1
           if (iobcs .EQ. 1) then
            OBNt(i,k,bi,bj) = OBNt (i,k,bi,bj)
     &           + obcsnfac            *xx_obcsn0(i,k,bi,bj,iobcs)
     &           + (1. _d 0 - obcsnfac)*xx_obcsn1(i,k,bi,bj,iobcs)
            OBNt(i,k,bi,bj) = OBNt(i,k,bi,bj)
     &           *maskS(i,j+jp1,k,bi,bj)
           else if (iobcs .EQ. 2) then
            OBNs(i,k,bi,bj) = OBNs (i,k,bi,bj)
     &           + obcsnfac            *xx_obcsn0(i,k,bi,bj,iobcs)
     &           + (1. _d 0 - obcsnfac)*xx_obcsn1(i,k,bi,bj,iobcs)
            OBNs(i,k,bi,bj) = OBNs(i,k,bi,bj)
     &           *maskS(i,j+jp1,k,bi,bj)
           else if (iobcs .EQ. 4) then
            OBNu(i,k,bi,bj) = OBNu (i,k,bi,bj)
     &           + obcsnfac            *xx_obcsn0(i,k,bi,bj,iobcs)
     &           + (1. _d 0 - obcsnfac)*xx_obcsn1(i,k,bi,bj,iobcs)
            OBNu(i,k,bi,bj) = OBNu(i,k,bi,bj)
     &           *maskW(i,j,k,bi,bj)
           else if (iobcs .EQ. 3) then
            OBNv(i,k,bi,bj) = OBNv (i,k,bi,bj)
     &           + obcsnfac            *xx_obcsn0(i,k,bi,bj,iobcs)
     &           + (1. _d 0 - obcsnfac)*xx_obcsn1(i,k,bi,bj,iobcs)
            OBNv(i,k,bi,bj) = OBNv(i,k,bi,bj)
     &           *maskS(i,j+jp1,k,bi,bj)
           endif
          enddo
         enddo
        enddo
       enddo

C--   End over iobcs loop
      enddo

#endif /* defined ALLOW_OBCS_NORTH && defined ALLOW_OBCSN_CONTROL */

      return
      end

!=======================================================================
      subroutine comprecv_r8tiles( dataname, Ni,Oi,Nj,Oj,Nk,Tx,Ty, arr )
      implicit none
! Arguments
      character*(*) dataname
      integer Ni,Oi,Nj,Oj,Io,Jo,Nk,Tx,Ty
      real*8 arr(1-Oi:Ni+Oi,1-Oj:Nj+Oj,Nk,Tx,Ty)
! Predefined constants/arrays
#include "CPLR_SIG.h"
! MPI variables
#include "mpif.h"
      integer count,dtype,rank,tag,comm,ierr
      integer stat(MPI_STATUS_SIZE)
! Functions
      integer generate_tag
! Local
      integer i,j,ij,nx,ny,k,bibj,bi,bj
      character*(MAXLEN_COMP_NAME) recvdname
!     ------------------------------------------------------------------

      if (HEADER_SIZE+Ni*Nj.gt.MAX_R8_BUFLEN)
     &    stop 'comprecv_r8tiles: Nx*Ny too big'

! Foreach tile which is non-blank
      do bibj=1,my_num_tiles

       bi=my_tile_bi(bibj)
       bj=my_tile_bj(bibj)

! Receive message
       count=MAX_R8_BUFLEN
       dtype=MPI_DOUBLE_PRECISION
       tag=generate_tag(123,bibj,dataname)
       rank=my_coupler_rank
       comm=MPI_COMM_myglobal

       if (VERB) then
        write(LogUnit,*) 'comprecv_r8tiles: calling MPI_Recv rank=',rank
        write(LogUnit,*) 'comprecv_r8tiles: dataname=',dataname
        call flush(LogUnit)
       endif
       call MPI_Recv(r8buf, count, dtype, rank, tag, comm, stat, ierr)
       if (VERB) then
        write(LogUnit,*) 'comprecv_r8tiles: returned ierr=',ierr
        call flush(LogUnit)
       endif

       if (ierr.ne.0) then
        write(LogUnit,*) 'comprecv_r8tiles: rank(W,G)=',
     &            my_rank_in_world,my_rank_in_global,
     &            ' ierr=',ierr
        stop 'comprecv_r8tiles: MPI_Recv failed'
       endif

! Extract buffer
       Io=int(0.5+r8buf(1))
       Jo=int(0.5+r8buf(2))
       nx=int(0.5+r8buf(3))
       ny=int(0.5+r8buf(4))
       call mitcplr_dbl2char( r8buf(9), recvdname )

       if (Io.ne.my_tile_i0(bibj)) stop 'comprecv_r8tiles: bad Io'
       if (Jo.ne.my_tile_j0(bibj)) stop 'comprecv_r8tiles: bad Jo'
       if (nx.ne.my_tile_nx(bibj)) stop 'comprecv_r8tiles: bad nx'
       if (ny.ne.my_tile_ny(bibj)) stop 'comprecv_r8tiles: bad ny'
       if (recvdname .ne. dataname) then
        write(LogUnit,*) 'comprecv_r8tiles: recvdname = ',recvdname
        write(LogUnit,*) 'comprecv_r8tiles:  dataname = ',dataname
        stop 'comprecv_r8tiles: recvdname != dataname'
       endif

! Copy buffer to interior of tile
       k=1
       do j=1,Nj
        do i=1,Ni
         ij=HEADER_SIZE+i+Ni*(j-1)
         arr(i,j,k,bi,bj)=r8buf(ij)
        enddo
       enddo

      enddo ! bibj

!     ------------------------------------------------------------------
      return
      end
!=======================================================================

#include "KPP_OPTIONS.h"
#ifdef ALLOW_GMREDI
# include "GMREDI_OPTIONS.h"
#endif
#undef  MULTIPLE_RECORD_KPP_STATE_FILES

CBOP
C     !ROUTINE: KPP_OUTPUT

C     !INTERFACE:
      SUBROUTINE KPP_OUTPUT( myTime, myIter, myThid )

C     !DESCRIPTION:
C     Create the KPP diagnostic output.
C
C     The following CPP flag (MULTIPLE_RECORD_KPP_STATE_FILES) is
C     #define/#undefed here since it is specific to this routine and
C     very user-preference specific.
C
C     If #undefed (default) the state files are written as in all
C     versions prior to checkpoint32, where a file is created per
C     variable, per time and per tile. This *has* to be the default
C     because most users use this mode and all utilities and scripts
C     (diagnostic) assume this form.  It is also robust, as explained
C     below.
C
C     If #defined, subsequent snap-shots are written as records in the
C     same file (no iteration number in filenames).
C
C     Advantages:
C     - fewer files
C     - for small problems, is easy to copy the output around
C     Disadvantages:
C     - breaks a lot of diagnostic scripts
C     - for large or long problems this creates huge files
C     - is an unexpected, unsolicited change in behaviour which came
C     as a surprise (in c32) and inconvenience to several users
C     - can not accomodate changing the frequency of output
C     after a pickup (this is trivial in previous method
C     but needs new code and parameters in this new method)

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "KPP.h"
#include "KPP_PARAMS.h"
#ifdef ALLOW_GMREDI
# include "GMREDI.h"
#endif
#ifdef ALLOW_MNC
# include "MNC_PARAMS.h"
#endif
#ifdef ALLOW_OFFLINE
# include "OFFLINE_SWITCH.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     myTime :: my time in simulation ( s )
C     myIter :: my Iteration number
C     myThid :: my Thread Id number
      _RL     myTime
      INTEGER myIter
      INTEGER myThid

#ifdef ALLOW_KPP

C     !FUNCTIONS:
      LOGICAL  DIFFERENT_MULTIPLE
      EXTERNAL DIFFERENT_MULTIPLE
#ifdef ALLOW_DIAGNOSTICS
      LOGICAL  DIAGNOSTICS_IS_ON
      EXTERNAL DIAGNOSTICS_IS_ON
#endif

C     !LOCAL VARIABLES:
C     variable in local common block:
C     kpp_drctrec  :: next record to dump for KPP files
      INTEGER kpp_drctrec
      COMMON / KPP_RECORDNUM1 / kpp_drctrec
C     local variable:
      CHARACTER*(10) suff
#ifdef ALLOW_DIAGNOSTICS
      INTEGER bi, bj
      INTEGER i, j, k
      _RL tmpFac
      _RL tmpLoc(1:sNx,1:sNy,Nr)
#endif
#ifdef ALLOW_MNC
      CHARACTER*(1) pf
#endif
CEOP

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#ifdef ALLOW_OFFLINE
      IF ( .NOT.(useOffLine.AND.offlineLoadKPP) ) THEN
#else
      IF ( .TRUE. ) THEN
#endif

C     Initialize record numbers
      IF ( myIter.EQ.nIter0 ) THEN
        _BEGIN_MASTER( myThid )
        kpp_drctrec = 1
        _END_MASTER( myThid )
        _BARRIER
      ENDIF

C----------------------------------------------------------------
C     Dump snapshot of KPP variables.

      IF ( myIter.NE.nIter0 .AND.
     &     DIFFERENT_MULTIPLE(kpp_dumpFreq,myTime,deltaTClock)
     &     ) THEN

        IF (KPPwriteState .AND. snapshot_mdsio) THEN
#ifdef MULTIPLE_RECORD_KPP_STATE_FILES
C         Write each snap-shot as a new record in one file per variable
C         - creates relatively few files but these files can become huge
C         NOTE: file size and number problems are *SOLVED* by MNC
          CALL WRITE_REC_XYZ_RL('KPPviscAz',KPPviscAz,kpp_drctrec,
     &         myIter,myThid)
          CALL WRITE_REC_XYZ_RL('KPPdiffKzT',KPPdiffKzT,kpp_drctrec,
     &         myIter,myThid)
          CALL WRITE_REC_XYZ_RL('KPPdiffKzS',KPPdiffKzS,kpp_drctrec,
     &         myIter,myThid)
          CALL WRITE_REC_XYZ_RL('KPPghat',KPPghat,kpp_drctrec,
     &         myIter,myThid)
          CALL WRITE_REC_XY_RL('KPPhbl',KPPhbl,kpp_drctrec,
     &         myIter,myThid)
C--     Increment record counter
          _BARRIER
          _BEGIN_MASTER( myThid )
          kpp_drctrec = kpp_drctrec + 1
          _END_MASTER( myThid )
          _BARRIER
#else /* MULTIPLE_RECORD_KPP_STATE_FILES */
C         Write each snap-shot as a new file - creates many files but
C         for large configurations is easier to transfer
C         NOTE: file size and number problems are *SOLVED* by MNC
          IF ( rwSuffixType.EQ.0 ) THEN
            WRITE(suff,'(I10.10)') myIter
          ELSE
            CALL RW_GET_SUFFIX( suff, myTime, myIter, myThid )
          ENDIF
          CALL WRITE_FLD_XYZ_RL('KPPviscAz.',suff,KPPviscAz,
     &         myIter,myThid)
          CALL WRITE_FLD_XYZ_RL('KPPdiffKzT.',suff,KPPdiffKzT,
     &         myIter,myThid)
          CALL WRITE_FLD_XYZ_RL('KPPdiffKzS.',suff,KPPdiffKzS,
     &         myIter,myThid)
          CALL WRITE_FLD_XYZ_RL('KPPghat.',suff,KPPghat,
     &         myIter,myThid)
          CALL WRITE_FLD_XY_RL('KPPhbl.',suff,KPPhbl,
     &         myIter,myThid)
#endif /* MULTIPLE_RECORD_KPP_STATE_FILES */
        ENDIF

#ifdef ALLOW_MNC
        IF (KPPwriteState .AND. useMNC .AND. snapshot_mnc) THEN
          IF ( writeBinaryPrec .EQ. precFloat64 ) THEN
            pf(1:1) = 'D'
          ELSE
            pf(1:1) = 'R'
          ENDIF
          CALL MNC_CW_SET_UDIM('kpp_state', -1, myThid)
          CALL MNC_CW_RL_W_S('D','kpp_state',0,0,'T',myTime,myThid)
          CALL MNC_CW_SET_UDIM('kpp_state', 0, myThid)
          CALL MNC_CW_I_W_S('I','kpp_state',0,0,'iter',myIter,myThid)
          CALL MNC_CW_RL_W(pf,'kpp_state',0,0,
     &         'KPPviscAz', KPPviscAz, myThid)
          CALL MNC_CW_RL_W(pf,'kpp_state',0,0,
     &         'KPPdiffKzT', KPPdiffKzT, myThid)
          CALL MNC_CW_RL_W(pf,'kpp_state',0,0,
     &         'KPPdiffKzS', KPPdiffKzS, myThid)
          CALL MNC_CW_RL_W(pf,'kpp_state',0,0,
     &         'KPPGHAT', KPPghat, myThid)
          CALL MNC_CW_RL_W(pf,'kpp_state',0,0,
     &         'KPPHBL', KPPhbl, myThid)
        ENDIF
#endif /*  ALLOW_MNC  */

      ENDIF

C----------------------------------------------------------------

#ifdef ALLOW_DIAGNOSTICS
C     do not fill during call from INITIALISE_VARIA
      IF ( useDiagnostics .AND. myIter.NE.nIter0 ) THEN
       CALL DIAGNOSTICS_FILL(KPPviscAz ,'KPPviscA',0,Nr,0,1,1,myThid)
       CALL DIAGNOSTICS_FILL(KPPdiffKzS,'KPPdiffS',0,Nr,0,1,1,myThid)
       CALL DIAGNOSTICS_FILL(KPPdiffKzT,'KPPdiffT',0,Nr,0,1,1,myThid)
       IF ( DIAGNOSTICS_IS_ON( 'KPPghatK', myThid ) ) THEN
        IF ( useGMRedi .AND. KPP_ghatUseTotalDiffus ) THEN
          tmpFac = 1. _d 0
        ELSE
          tmpFac = 0. _d 0
        ENDIF
        DO bj = myByLo(myThid), myByHi(myThid)
         DO bi = myBxLo(myThid), myBxHi(myThid)
          DO j=1,sNy
            DO i=1,sNx
              tmpLoc(i,j,1) = 0. _d 0
            ENDDO
          ENDDO
          DO k=2,Nr
           DO j=1,sNy
            DO i=1,sNx
              tmpLoc(i,j,k) = KPPghat(i,j,k-1,bi,bj)*
     &                      ( KPPdiffKzS(i,j,k,bi,bj)
#ifdef ALLOW_GMREDI
     &                      + tmpFac*Kwz(i,j,k,bi,bj)
#endif
     &                      )
            ENDDO
           ENDDO
          ENDDO
          CALL DIAGNOSTICS_FILL(tmpLoc,'KPPghatK',0,Nr,3,bi,bj,myThid)
         ENDDO
        ENDDO
       ENDIF
       CALL DIAGNOSTICS_FILL(KPPhbl    ,'KPPhbl  ',0,1 ,0,1,1,myThid)
       CALL DIAGNOSTICS_FILL(KPPfrac   ,'KPPfrac ',0,1 ,0,1,1,myThid)
#ifdef ALLOW_SALT_PLUME
       CALL DIAGNOSTICS_FILL(KPPplumefrac,'KPPpfrac',0,1 ,0,1,1,myThid)
#endif /* ALLOW_SALT_PLUME */
      ENDIF
#endif /* ALLOW_DIAGNOSTICS */

C--   end if useOffLine
      ENDIF

#endif /* ALLOW_KPP */

      RETURN
      END

#include "STREAMICE_OPTIONS.h"

      SUBROUTINE template()
      use OAD_cp
      use OAD_tape
      use OAD_rev

C
C     **** Global Variables & Derived Type Definitions ****
C

C
C     **** Parameters and Result ****
C
#if (defined(ALLOW_STREAMICE_FP_ADJ) && defined(ALLOW_OPENAD))

       err_max = 0. _d 0
       err_sum = 0. _d 0
       if (streamice_err_norm .lt. 1. _d 0) conj_norm = 1.0
       if (streamice_err_norm .eq. 1. _d 0) conj_norm = 0.0
       if (streamice_err_norm .gt. 1. _d 0) conj_norm =
     & streamice_err_norm / (streamice_err_norm - 1.0)

       DO bj = myByLo(myThid), myByHi(myThid)
        DO bi = myBxLo(myThid), myBxHi(myThid)
         err_sum_tile(bi,bj) = 0. _d 0
        ENDDO
       ENDDO

      if (our_rev_mode%plain) then

       if (streamice_err_norm .lt. 1.0) then

       DO bj = myByLo(myThid), myByHi(myThid)
        DO bi = myBxLo(myThid), myBxHi(myThid)
         DO j=1,sNy
          DO i=1,sNx
           err_tempu = 0. _d 0
           err_tempv = 0. _d 0
           IF (STREAMICE_umask(i,j,bi,bj).eq.1) THEN
            err_tempu =
     &       ABS (U_streamice(i,j,bi,bj)%v-u_new_SI(i,j,bi,bj)%v)
           ENDIF
           IF (STREAMICE_vmask(i,j,bi,bj).eq.1) THEN
            err_tempv = MAX( err_tempu,
     &       ABS (V_streamice(i,j,bi,bj)%v-v_new_SI(i,j,bi,bj)%v))
           ENDIF
           IF (err_tempv .ge. err_max) err_max = err_tempv
          ENDDO
         ENDDO
        ENDDO
       ENDDO

       CALL GLOBAL_MAX_R8 (err_max, myThid)

       ELSE

       DO bj = myByLo(myThid), myByHi(myThid)
        DO bi = myBxLo(myThid), myBxHi(myThid)
         DO j=1,sNy
          DO i=1,sNx
           IF (STREAMICE_umask(i,j,bi,bj).eq.1) THEN
            err_sum_tile(bi,bj) = err_sum_tile(bi,bj) +
     &       (ABS(U_streamice(i,j,bi,bj)%v-
     &              u_new_SI(i,j,bi,bj)%v))**streamice_err_norm
           ENDIF
           IF (STREAMICE_vmask(i,j,bi,bj).eq.1) THEN
            err_sum_tile(bi,bj) = err_sum_tile(bi,bj) +
     &       (ABS(v_streamice(i,j,bi,bj)%v-
     &              v_new_SI(i,j,bi,bj)%v))**streamice_err_norm
           ENDIF
          ENDDO
         ENDDO
        ENDDO
       ENDDO

       CALL GLOBAL_SUM_TILE_RL( err_sum_tile, err_sum, myThid )

       err_max = err_sum ** (1./streamice_err_norm)

       ENDIF

      end if

      if (our_rev_mode%tape) then

       IF (streamice_err_norm .lt. 1.0) then

       DO bj = myByLo(myThid), myByHi(myThid)
        DO bi = myBxLo(myThid), myBxHi(myThid)
         DO j=1,sNy
          DO i=1,sNx
           err_tempu = 0. _d 0
           err_tempv = 0. _d 0
           IF (STREAMICE_umask(i,j,bi,bj).eq.1) THEN
            err_tempu =
     &       ABS (U_streamice(i,j,bi,bj)%v-u_new_SI(i,j,bi,bj)%v)
           ENDIF
           IF (STREAMICE_vmask(i,j,bi,bj).eq.1) THEN
            err_tempv = MAX( err_tempu,
     &       ABS (V_streamice(i,j,bi,bj)%v-v_new_SI(i,j,bi,bj)%v))
           ENDIF
           IF (err_tempv .ge. err_max) err_max = err_tempv
          ENDDO
         ENDDO
        ENDDO
       ENDDO

       CALL GLOBAL_MAX_R8 (err_max, myThid)

       ELSE

       DO bj = myByLo(myThid), myByHi(myThid)
        DO bi = myBxLo(myThid), myBxHi(myThid)
         DO j=1,sNy
          DO i=1,sNx
           IF (STREAMICE_umask(i,j,bi,bj).eq.1) THEN
            err_sum_tile(bi,bj) = err_sum_tile(bi,bj) +
     &       (ABS(U_streamice(i,j,bi,bj)%v-
     &              u_new_SI(i,j,bi,bj)%v))**streamice_err_norm
           ENDIF
           IF (STREAMICE_vmask(i,j,bi,bj).eq.1) THEN
            err_sum_tile(bi,bj) = err_sum_tile(bi,bj) +
     &       (ABS(v_streamice(i,j,bi,bj)%v-
     &              v_new_SI(i,j,bi,bj)%v))**streamice_err_norm
           ENDIF
          ENDDO
         ENDDO
        ENDDO
       ENDDO

       CALL GLOBAL_SUM_TILE_RL( err_sum_tile, err_sum, myThid )

       err_max = err_sum ** (1./streamice_err_norm)

       ENDIF

      end if

      if (our_rev_mode%adjoint) then

       if (conj_norm .lt. 1.0) then

       DO bj = myByLo(myThid), myByHi(myThid)
        DO bi = myBxLo(myThid), myBxHi(myThid)
         DO j=1,sNy
          DO i=1,sNx
           err_tempu = 0. _d 0
           err_tempv = 0. _d 0
           IF (STREAMICE_umask(i,j,bi,bj).eq.1) THEN
            err_tempu =
     &       ABS (U_streamice(i,j,bi,bj)%d-u_new_SI(i,j,bi,bj)%d)
           ENDIF
           IF (STREAMICE_vmask(i,j,bi,bj).eq.1) THEN
            err_tempv = MAX( err_tempu,
     &       ABS (V_streamice(i,j,bi,bj)%d-v_new_SI(i,j,bi,bj)%d))
           ENDIF
           IF (err_tempv .ge. err_max) err_max = err_tempv
          ENDDO
         ENDDO
        ENDDO
       ENDDO

       CALL GLOBAL_MAX_R8 (err_max, myThid)

       ELSE

       DO bj = myByLo(myThid), myByHi(myThid)
        DO bi = myBxLo(myThid), myBxHi(myThid)
         DO j=1,sNy
          DO i=1,sNx
           IF (STREAMICE_umask(i,j,bi,bj).eq.1) THEN
            err_sum_tile(bi,bj) = err_sum_tile(bi,bj) +
     &       (ABS(U_streamice(i,j,bi,bj)%d-
     &              u_new_SI(i,j,bi,bj)%d))**conj_norm
           ENDIF
           IF (STREAMICE_vmask(i,j,bi,bj).eq.1) THEN
            err_sum_tile(bi,bj) = err_sum_tile(bi,bj) +
     &       (ABS(v_streamice(i,j,bi,bj)%d-
     &              v_new_SI(i,j,bi,bj)%d))**conj_norm
           ENDIF
          ENDDO
         ENDDO
        ENDDO
       ENDDO

       CALL GLOBAL_SUM_TILE_RL( err_sum_tile, err_sum, myThid )

       err_max = err_sum ** (1./conj_norm)

       ENDIF

      end if
#endif
      end subroutine template

c #include "PACKAGES_CONFIG.h"
#include "CPP_OPTIONS.h"

CBOP
C     !ROUTINE: LOAD_REF_FILES
C     !INTERFACE:
      SUBROUTINE LOAD_REF_FILES( myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE LOAD_REF_FILES
C     | o Read reference vertical profile from files
C     |   (Pot.Temp., Salinity/Specif.Humid., density ... )
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     myThid     :: my Thread Id number
      INTEGER myThid

C     !FUNCTIONS:
      INTEGER  ILNBLNK
      EXTERNAL ILNBLNK

C     !LOCAL VARIABLES:
C     == Local variables ==
C     k          :: loop index
C     msgBuf     :: Informational/error message buffer
      _RL    tracerDefault
      INTEGER  k, kLen
      CHARACTER*(MAX_LEN_MBUF) msgBuf
CEOP

      _BEGIN_MASTER( myThid )

C--   Set reference Potential Temperature
      IF ( tRefFile .EQ. ' ' ) THEN
C-    set default vertical profile for temperature: tRef
        tracerDefault = 20.
        IF ( fluidIsAir ) tracerDefault = 300.
        IF ( thetaConst.NE.UNSET_RL ) tracerDefault = thetaConst
        DO k=1,Nr
          IF (tRef(k).EQ.UNSET_RL) tRef(k) = tracerDefault
          tracerDefault = tRef(k)
        ENDDO
      ELSE
C-    check for multiple definitions:
        DO k=1,Nr
         IF (tRef(k).NE.UNSET_RL) THEN
          WRITE(msgBuf,'(2A,I4,A)') 'S/R LOAD_REF_FILES: ',
     &      'Cannot set both tRef(k=', k, ') and tRefFile'
          CALL PRINT_ERROR( msgBuf, myThid )
          STOP 'ABNORMAL END: S/R INI_PARMS'
         ENDIF
        ENDDO
      ENDIF
C-    read from file:
      IF ( tRefFile .NE. ' ' ) THEN
        kLen = ILNBLNK(tRefFile)
        CALL READ_GLVEC_RL( tRefFile, ' ', tRef, Nr, 1, myThid )
        WRITE(msgBuf,'(3A)') 'S/R LOAD_REF_FILES: ',
     &    'tRef loaded from file: ', tRefFile(1:kLen)
        CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
      ENDIF
      IF ( thetaConst.EQ.UNSET_RL ) thetaConst = tRef(1)

C--   Set reference Salinity/Specific Humidity
      IF ( sRefFile .EQ. ' ' ) THEN
C-    set default vertical profile for salinity/water-vapour: sRef
        tracerDefault = 30.
        IF ( fluidIsAir ) tracerDefault = 0.
        DO k=1,Nr
          IF (sRef(k).EQ.UNSET_RL) sRef(k) = tracerDefault
          tracerDefault = sRef(k)
        ENDDO
      ELSE
C-    check for multiple definitions:
        DO k=1,Nr
         IF (sRef(k).NE.UNSET_RL) THEN
          WRITE(msgBuf,'(2A,I4,A)') 'S/R LOAD_REF_FILES: ',
     &      'Cannot set both sRef(k=', k, ') and sRefFile'
          CALL PRINT_ERROR( msgBuf, myThid )
          STOP 'ABNORMAL END: S/R INI_PARMS'
         ENDIF
        ENDDO
      ENDIF
C-    read from file:
      IF ( sRefFile .NE. ' ' ) THEN
        kLen = ILNBLNK(sRefFile)
        CALL READ_GLVEC_RL( sRefFile, ' ', sRef, Nr, 1, myThid )
        WRITE(msgBuf,'(3A)') 'S/R LOAD_REF_FILES: ',
     &    'sRef loaded from file: ', sRefFile(1:kLen)
        CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
      ENDIF

C--   Set reference Density
      IF ( rhoRefFile .NE. ' ' ) THEN
        kLen = ILNBLNK(rhoRefFile)
C-    read from file:
        CALL READ_GLVEC_RL( rhoRefFile, ' ', rho1Ref, Nr, 1, myThid )
        WRITE(msgBuf,'(3A)') 'S/R LOAD_REF_FILES: ',
     &    'rho1Ref loaded from file: ', rhoRefFile(1:kLen)
        CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
      ENDIF

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C--   Set gravity vertical profile
      IF ( gravityFile .NE. ' ' ) THEN
        kLen = ILNBLNK(gravityFile)
C-    read from file and store, for now, in gravFacC:
        CALL READ_GLVEC_RL( gravityFile, ' ', gravFacC, Nr, 1, myThid )
        WRITE(msgBuf,'(3A)') 'S/R LOAD_REF_FILES: ',
     &    'gravity vert. prof. loaded from file: ', gravityFile(1:kLen)
        CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )

C-    Set gravity vertical profile factor: assume surface-interface
C     density-factor to be 1 (grav. acceleration @ rF(1) = gravity)
C- Note: done here (instead of in set_ref_state.F) since gravity fac 
C       might be needed to initialise EOS coeffs (in ini_eos.F)
        gravFacF(1)   = 1. _d 0
C       gravFac(k) = gravity ratio between layer k and top interface
        DO k=1,Nr
          gravFacC(k) = gravFacC(k)*recip_gravity
        ENDDO
        DO k=2,Nr
C       since rkSign=-1, recip_drC(k) = 1./(rC(k-1)-rC(k))
          gravFacF(k) = ( gravFacC(k-1)*(rF(k)-rC(k))
     &                  + gravFacC(k)*(rC(k-1)-rF(k)) )*recip_drC(k)
        ENDDO
C       extrapolate down to the bottom:
        gravFacF(Nr+1) = ( gravFacC(Nr)*(rF(Nr+1)-rF(Nr))
     &                   + gravFacF(Nr)*(rC(Nr)-rF(Nr+1))
     &                   ) / (rC(Nr)-rF(Nr))
C-      set reciprocal gravity-factor:
        DO k=1,Nr
          recip_gravFacC(k) = 1. _d 0/gravFacC(k)
        ENDDO
        DO k=1,Nr+1
          recip_gravFacF(k) = 1. _d 0/gravFacF(k)
        ENDDO

      ELSE
C-    Initialise gravity vertical profile factor:
        DO k=1,Nr
          gravFacC(k) = 1. _d 0
          recip_gravFacC(k) = 1. _d 0
        ENDDO
        DO k=1,Nr+1
          gravFacF(k) = 1. _d 0
          recip_gravFacF(k) = 1. _d 0
        ENDDO
      ENDIF

      _END_MASTER(myThid)
C--   Everyone else must wait for the parameters to be loaded
      _BARRIER

      RETURN
      END

#include "CPP_OPTIONS.h"

C--  File remove_mean.F:
C--   Contents
C--   o REMOVE_MEAN_RL
C--   o REMOVE_MEAN_RS

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: REMOVE_MEAN_RL
C     !INTERFACE:
      SUBROUTINE REMOVE_MEAN_RL(
     I                myNr,
     U                arrFld,
     I                arrhFac, arrMask, arrArea, arrDr,
     I                arrName, myTime, myIter, myThid )
C     !DESCRIPTION: \bv
C     Correct for global-mean imbalance of global "_RL" array "arrFld"
C      (i.e., output arrFld has zero mean):
C     Apply either (if arrDr(1) > 0) uniform correction
C      or (if arrDr(1) < 0) a correction scaled by "arrhFac" weight.
C     The global mean imbalance is computed as area (arrArea), mask
C      (arrMask) and thickness (arrDr) weighted, as well as thickness
C      factor (arrhFac) weighted (1rst case) or not (2nd case).
C     Comment: currently this S/R is only applied to 2-D field.
C     \ev

C     !USES:
      IMPLICIT NONE
C     === Global data ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"

C     !INPUT/OUTPUT PARAMETERS:
C     myNr      :: third dimension of field to correct
C     arrFld    :: field array to correct for imbalance
C     arrhFac   :: same size as arrFld ; thickness factor (1rst case)
C               :: or correction scaling factor (2nd case)
C     arrMask   :: 2-D mask for global mean calculation
C     arrArea   :: 2-D grid-cell area for global mean calculation
C     arrDr     :: myNr long vector (level thickness)
C     arrName   :: name of field to correct
C     myTime    :: Current time in simulation
C     myIter    :: Current iteration number in simulation
C     myThid    :: my Thread ID number
      INTEGER myNr
      _RL arrFld (1-OLx:sNx+OLx,1-OLy:sNy+OLy,myNr,nSx,nSy)
      _RS arrhFac(1-OLx:sNx+OLx,1-OLy:sNy+OLy,myNr,nSx,nSy)
      _RS arrMask(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RS arrArea(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RS arrDr(myNr)
      CHARACTER*(*) arrName
      _RL myTime
      INTEGER myIter
      INTEGER myThid

C     !LOCAL VARIABLES:
      INTEGER bi, bj, i, j, k
      _RL volTile(nSx,nSy), sumTile(nSx,nSy)
      _RL tmpVol, volGlob, sumGlob, theMean
      _RL meanCorr
      CHARACTER*(MAX_LEN_MBUF) msgBuf
CEOP

      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        volTile(bi,bj) = 0. _d 0
        sumTile(bi,bj) = 0. _d 0
        IF ( arrDr(1).GE.zeroRS ) THEN
C--   do (arrhFac) weighted average to apply uniform correction
         DO k=1,myNr
          DO j=1,sNy
           DO i=1,sNx
            tmpVol = arrArea(i,j,bi,bj)*arrMask(i,j,bi,bj)
     &             * arrhFac(i,j,k,bi,bj)*arrDr(k)
            volTile(bi,bj) = volTile(bi,bj) + tmpVol
            sumTile(bi,bj) = sumTile(bi,bj) + tmpVol*arrFld(i,j,k,bi,bj)
           ENDDO
          ENDDO
         ENDDO
        ELSE
C-    do simple average to apply (arrhFac) weighted correction
         DO k=1,myNr
          DO j=1,sNy
           DO i=1,sNx
            tmpVol = arrArea(i,j,bi,bj)*arrMask(i,j,bi,bj)
     &             * ABS(arrDr(k))
            volTile(bi,bj) = volTile(bi,bj)
     &                     + tmpVol*arrhFac(i,j,k,bi,bj)
            sumTile(bi,bj) = sumTile(bi,bj)
     &                     + tmpVol*arrFld(i,j,k,bi,bj)
           ENDDO
          ENDDO
         ENDDO
        ENDIF
       ENDDO
      ENDDO

      CALL GLOBAL_SUM_TILE_RL( volTile, volGlob, myThid )
      CALL GLOBAL_SUM_TILE_RL( sumTile, sumGlob, myThid )

      IF ( volGlob.GT.zeroRL ) THEN
       meanCorr = sumGlob/volGlob
       DO bj=myByLo(myThid),myByHi(myThid)
        DO bi=myBxLo(myThid),myBxHi(myThid)
         IF ( arrDr(1).GE.zeroRS ) THEN
C--   apply uniform correction
          DO k=1,myNr
           DO j=1-OLy,sNy+OLy
            DO i=1-OLx,sNx+OLx
             IF ( arrhFac(i,j,k,bi,bj).NE.zeroRS ) THEN
              arrFld(i,j,k,bi,bj) = arrFld(i,j,k,bi,bj) - meanCorr
             ENDIF
            ENDDO
           ENDDO
          ENDDO
         ELSE
C-    apply (arrhFac) weighted correction
          DO k=1,myNr
           DO j=1-OLy,sNy+OLy
            DO i=1-OLx,sNx+OLx
             IF ( arrMask(i,j,bi,bj).NE.zeroRS ) THEN
              arrFld(i,j,k,bi,bj) = arrFld(i,j,k,bi,bj)
     &                            - meanCorr*arrhFac(i,j,k,bi,bj)
             ENDIF
            ENDDO
           ENDDO
          ENDDO
C-    end type correction selection
         ENDIF
        ENDDO
       ENDDO
      ELSE
       meanCorr = 0. _d 0
      ENDIF

C     Print the global mean to standard output, this is a measure
C     of the magnitude of the correction to array arrFld
      IF ( balancePrintMean ) THEN
       _BEGIN_MASTER( myThid )
       IF ( arrDr(1).GE.zeroRS ) THEN
        theMean = meanCorr
        WRITE(msgBuf,'(3A,1PE21.14,A,I10)')
     &        'REMOVE_MEAN_RL: Global mean of ', arrName, ' = ',
     &        theMean, '  @ it=', myIter
        CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
       ELSE
        theMean = 0. _d 0
        IF ( globalArea.GT.zeroRL ) theMean = sumGlob/globalArea
        WRITE(msgBuf,'(3A,2(1PE21.14,A),I10)')
     &        'REMOVE_MEAN_RL: ', arrName, ' Global mean= ',
     &        theMean, ', remove: ', meanCorr, ' @ it=', myIter
        CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
       ENDIF
       _END_MASTER( myThid )
      ENDIF

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: REMOVE_MEAN_RS
C     !INTERFACE:
      SUBROUTINE REMOVE_MEAN_RS(
     I                myNr,
     U                arrFld,
     I                arrhFac, arrMask, arrArea, arrDr,
     I                arrName, myTime, myIter, myThid )
C     !DESCRIPTION: \bv
C     Correct for global-mean imbalance of global "_RS" array "arrFld"
C      (i.e., output arrFld has zero mean):
C     Apply either (if arrDr(1) > 0) uniform correction
C      or (if arrDr(1) < 0) a correction scaled by "arrhFac" weight.
C     The global mean imbalance is computed as area (arrArea), mask
C      (arrMask) and thickness (arrDr) weighted, as well as thickness
C      factor (arrhFac) weighted (1rst case) or not (2nd case).
C     Comment: currently this S/R is only applied to 2-D field.
C     \ev

C     !USES:
      IMPLICIT NONE
C     === Global data ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"

C     !INPUT/OUTPUT PARAMETERS:
C     myNr      :: third dimension of field to correct
C     arrFld    :: field array to correct for imbalance
C     arrhFac   :: same size as arrFld ; thickness factor (1rst case)
C               :: or correction scaling factor (2nd case)
C     arrMask   :: 2-D mask for global mean calculation
C     arrArea   :: 2-D grid-cell area for global mean calculation
C     arrDr     :: myNr long vector (level thickness)
C     arrName   :: name of field to correct
C     myTime    :: Current time in simulation
C     myIter    :: Current iteration number in simulation
C     myThid    :: my Thread ID number
      INTEGER myNr
      _RS arrFld (1-OLx:sNx+OLx,1-OLy:sNy+OLy,myNr,nSx,nSy)
      _RS arrhFac(1-OLx:sNx+OLx,1-OLy:sNy+OLy,myNr,nSx,nSy)
      _RS arrMask(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RS arrArea(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RS arrDr(myNr)
      CHARACTER*(*) arrName
      _RL myTime
      INTEGER myIter
      INTEGER myThid

C     !LOCAL VARIABLES:
      INTEGER bi, bj, i, j, k
      _RL volTile(nSx,nSy), sumTile(nSx,nSy)
      _RL tmpVol, volGlob, sumGlob, theMean
      _RS meanCorr
      CHARACTER*(MAX_LEN_MBUF) msgBuf
CEOP

      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        volTile(bi,bj) = 0. _d 0
        sumTile(bi,bj) = 0. _d 0
        IF ( arrDr(1).GE.zeroRS ) THEN
C--   do (arrhFac) weighted average to apply uniform correction
         DO k=1,myNr
          DO j=1,sNy
           DO i=1,sNx
            tmpVol = arrArea(i,j,bi,bj)*arrMask(i,j,bi,bj)
     &             * arrhFac(i,j,k,bi,bj)*arrDr(k)
            volTile(bi,bj) = volTile(bi,bj) + tmpVol
            sumTile(bi,bj) = sumTile(bi,bj) + tmpVol*arrFld(i,j,k,bi,bj)
           ENDDO
          ENDDO
         ENDDO
        ELSE
C-    do simple average to apply (arrhFac) weighted correction
         DO k=1,myNr
          DO j=1,sNy
           DO i=1,sNx
            tmpVol = arrArea(i,j,bi,bj)*arrMask(i,j,bi,bj)
     &             * ABS(arrDr(k))
            volTile(bi,bj) = volTile(bi,bj)
     &                     + tmpVol*arrhFac(i,j,k,bi,bj)
            sumTile(bi,bj) = sumTile(bi,bj)
     &                     + tmpVol*arrFld(i,j,k,bi,bj)
           ENDDO
          ENDDO
         ENDDO
        ENDIF
       ENDDO
      ENDDO

      CALL GLOBAL_SUM_TILE_RL( volTile, volGlob, myThid )
      CALL GLOBAL_SUM_TILE_RL( sumTile, sumGlob, myThid )

      IF ( volGlob.GT.zeroRL ) THEN
       meanCorr = sumGlob/volGlob
       DO bj=myByLo(myThid),myByHi(myThid)
        DO bi=myBxLo(myThid),myBxHi(myThid)
         IF ( arrDr(1).GE.zeroRS ) THEN
C--   apply uniform correction
          DO k=1,myNr
           DO j=1-OLy,sNy+OLy
            DO i=1-OLx,sNx+OLx
             IF ( arrhFac(i,j,k,bi,bj).NE.zeroRS ) THEN
              arrFld(i,j,k,bi,bj) = arrFld(i,j,k,bi,bj) - meanCorr
             ENDIF
            ENDDO
           ENDDO
          ENDDO
         ELSE
C-    apply (arrhFac) weighted correction
          DO k=1,myNr
           DO j=1-OLy,sNy+OLy
            DO i=1-OLx,sNx+OLx
             IF ( arrMask(i,j,bi,bj).NE.zeroRS ) THEN
              arrFld(i,j,k,bi,bj) = arrFld(i,j,k,bi,bj)
     &                            - meanCorr*arrhFac(i,j,k,bi,bj)
             ENDIF
            ENDDO
           ENDDO
          ENDDO
C-    end type correction selection
         ENDIF
        ENDDO
       ENDDO
      ELSE
       meanCorr = 0. _d 0
      ENDIF

C     Print the global mean to standard output, this is a measure
C     of the magnitude of the correction to array arrFld
      IF ( balancePrintMean ) THEN
       _BEGIN_MASTER( myThid )
       IF ( arrDr(1).GE.zeroRS ) THEN
        theMean = meanCorr
        WRITE(msgBuf,'(3A,1PE21.14,A,I10)')
     &        'REMOVE_MEAN_RS: Global mean of ', arrName, ' = ',
     &        theMean, '  @ it=', myIter
        CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
       ELSE
        theMean = 0. _d 0
        IF ( globalArea.GT.zeroRL ) theMean = sumGlob/globalArea
        WRITE(msgBuf,'(3A,2(1PE21.14,A),I10)')
     &        'REMOVE_MEAN_RS: ', arrName, ' Global mean= ',
     &        theMean, ', remove: ', meanCorr, ' @ it=', myIter
        CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
       ENDIF
       _END_MASTER( myThid )
      ENDIF

      RETURN
      END

#include "COST_OPTIONS.h"

      subroutine cost_vector( myThid )
C     /==========================================================\
C     | subroutine cost_vector                                   |
C     | o This routine computes the meridional heat transport.   |
C     |   The current indices are for North Atlantic 29N         |
C     |   2x2 global setup.                                      |
C     \==========================================================/
       implicit none

C     == Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "DYNVARS.h"

#include "cost.h"

C     ======== Routine arguments ======================
C     myThid - Thread number for this instance of the routine.
      integer myThid

#ifdef ALLOW_COST_VECTOR
C     ========= Local variables =========================
      integer    isecbeg      , isecend      , jsec
      integer    kmaxdepth
      integer i, j, k
      integer ig, jg
      integer bi, bj
      _RL     locfc
      _RL        vVel_bar(Nr), theta_bar(Nr), count(Nr)
      _RL     petawatt
      _RL     sum
      parameter( petawatt = 1.e+15 )

C     80W - 0W at 24N
      parameter( isecbeg = 70, isecend = 90, jsec = 27 )
      parameter ( kmaxdepth = 15 )
C     80W - 0W at 48N
C      parameter( isecbeg = 70, isecend = 90, jsec = 33 )
C      parameter ( kmaxdepth = 14 )



C------------------------------------------------------
C     Accumulate meridionally integrated transports
C     Note bar(V)*bar(T) not bar(VT)
C     Attention pYFaceA [m^2*gravity*rhoConst]
C------------------------------------------------------

      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)

        locfc = 0.0
        do j=1,sNy
         jg = myYGlobalLo-1+(bj-1)*sNy+j
         if (jg .eq. jsec) then

          do i=1,sNx
           ig = myXGlobalLo-1+(bi-1)*sNx+i
           if ((ig .ge. isecbeg) .and. (ig .le. isecend)) then
            sum = 0. _d 0
            do k = 1, kmaxdepth
             sum = sum
     &             + vVel(i,j,k,bi,bj) * maskS(i,j,k,bi,bj)
     &             * drF(k)
C     &             * 0.5*(theta(i,j,k,bi,bj)+theta(i,j-1,k,bi,bj))
            end do
            objf_vector(i,bi,bj) = sum*dxG(i,j,bi,bj)
           end if
          end do

         end if
        end do

        do i = 1,sNx
           print*,' --> objf_vector(i,bi,bj)  = ',
     &          objf_vector(i,bi,bj)
        end do

       END DO
      END DO

#endif

      end

#include "GCHEM_OPTIONS.h"

CBOP
C     !ROUTINE: CFC_READPARMS
C     !INTERFACE:
      SUBROUTINE CFC_READPARMS( myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R CFC_READPARMS
C     | o Initialise and read cfc package parameters
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "CFC.h"
#ifdef ALLOW_PTRACERS
# include "PTRACERS_SIZE.h"
# include "PTRACERS_PARAMS.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
C     myThid    :: My Thread Id. number
      INTEGER myThid
CEOP

#ifdef ALLOW_CFC

C     === Local variables ===
C     msgBuf    :: Informational/error message buffer
C     iUnit     :: Work variable for IO unit number
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      INTEGER iUnit

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      NAMELIST /CFC_FORCING/
     &          atmCFC_inpFile, atmCFC_recSepTime, atmCFC_timeOffset,
     &          atmCFC_yNorthBnd, atmCFC_ySouthBnd,
     &          CFC_windFile, CFC_atmospFile, CFC_iceFile,
     &          CFC_forcingPeriod, CFC_forcingCycle

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      _BEGIN_MASTER(myThid)

       atmCFC_inpFile    = 'cfc1112.atm'
       atmCFC_recSepTime = 360. _d 0 * 86400. _d 0
       atmCFC_timeOffset = UNSET_RL
       atmCFC_yNorthBnd  =  10. _d 0
       atmCFC_ySouthBnd  = -10. _d 0
       CFC_windFile  = ' '
       CFC_atmospFile= ' '
       CFC_iceFile   = ' '
c default periodic forcing to same as for physics
       CFC_forcingPeriod = externForcingPeriod
       CFC_forcingCycle  = externForcingCycle

      WRITE(msgBuf,'(A)') ' CFC_READPARMS: opening data.cfc'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     I                    SQUEEZE_RIGHT, myThid )

      CALL OPEN_COPY_DATA_FILE( 'data.cfc', 'CFC_READPARMS',
     O                          iUnit, myThid )

C--   Read parameters from open data file:

C-    forcing filenames and parameters
      READ(UNIT=iUnit,NML=CFC_FORCING)

      WRITE(msgBuf,'(A)')
     &   ' CFC_READPARMS: finished reading data.cfc'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     I                    SQUEEZE_RIGHT, myThid )

C--   Close the open data file
#ifdef SINGLE_DISK_IO
      CLOSE(iUnit)
#else
      CLOSE(iUnit,STATUS='DELETE')
#endif /* SINGLE_DISK_IO */

      IF ( atmCFC_timeOffset .EQ. UNSET_RL ) THEN
C-    Assume that cfcTime=0 corresponds to the beginning of the 1rst record
C     time-period. This is consistent with 1rst record value = time-averaged
C     atmos-CFC over time period: cfcTime= 0 to cfcTime= 1 x atmCFC_recSepTime
C-    To reproduce previous time interpolation (formerly in cfc12_forcing.F),
C     set default timeOffset according to PTRACERS_Iter0 :
        atmCFC_timeOffset = atmCFC_recSepTime
     &                     - deltaTClock*PTRACERS_Iter0
      ENDIF

      CFC_monFreq = 0. _d 0
      IF ( debugLevel.GE.debLevB ) CFC_monFreq = PTRACERS_monitorFreq

      _END_MASTER(myThid)

C--   Everyone else must wait for the parameters to be loaded
      _BARRIER

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#endif /* ALLOW_CFC */

      RETURN
      END

#include "CTRL_OPTIONS.h"

      subroutine optim_initmod(
     I                    nn,
     O                    xx
     &                  )

c     ==================================================================
c     SUBROUTINE optim_initmod
c     ==================================================================
c
c     o Optim_Initmod is called before the optimization. It sets a first guess
c       of the parameter vector. It may also contain the initialization
c       of the model.
c
c     started: Christian Eckert eckert@mit.edu 15-Feb-2000
c
c     changed: Christian Eckert eckert@mit.edu 10-Mar-2000
c
c              - Added ECCO layout.
c
c     changed:  Patrick Heimbach heimbach@mit.edu 19-Jun-2000
c               - finished, revised and debugged
c
c     ==================================================================
c     SUBROUTINE optim_initmod
c     ==================================================================

      IMPLICIT NONE

c     == global variables ==

#include "EEPARAMS.h"
#include "SIZE.h"
#include "CTRL_SIZE.h"
#include "CTRL.h"
#include "optim.h"

c     == routine arguments ==

      integer nn
      _RL   xx(nn)

c     == local variables ==

      character*(80) fname

c     == end of interface ==

c--   Generate file name for the scaling of the control vector
c--   contributions.
      write(fname(1:80),'(80a)') ' '
      write(fname(1:80),'(4a,i10.10,a)')
     &  scalname(1:9),'_',yctrlid,'.',optimcycle,'.data'

c--   Read the scaling for the control vector.

c     --> Presently not implemented, since the control vector and the
c         gradient of the cost function can already be non-dimensionalized
c         by *ecco_ControlPack* and *ecco_ControlUnPack*.
c
c         To do this set:
c
c           #define  USE_NONDIMENSIONAL_CONTROL_IO
c
c         in CPP_OPTIONS.h. The subroutine *ecco_ControlPack* will then
c         non-dimensionalize its output and *ecco_ControlUnPack* will
c         dimensionalize its input.

      return
      end

#include "PTRACERS_OPTIONS.h"
#ifdef ALLOW_AUTODIFF
# include "AUTODIFF_OPTIONS.h"
#endif

CBOP
C !ROUTINE: PTRACERS_CONVECT

C !INTERFACE: ==========================================================
      SUBROUTINE PTRACERS_CONVECT( bi,bj,k,weightA,weightB,myThid )

C !DESCRIPTION:
C     do passive tracers convection

C !USES: ===============================================================
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PTRACERS_SIZE.h"
#include "PTRACERS_PARAMS.h"
#include "PTRACERS_START.h"
#include "PTRACERS_FIELDS.h"
#ifdef ALLOW_AUTODIFF_TAMC
# include "tamc.h"
#endif

C !INPUT PARAMETERS: ===================================================
C  bi,bj,k :: tile indices
C  weightA :: weight for level K-1
C  weightB :: weight for level K
C  myThid  :: thread number
      INTEGER bi,bj,k
      _RL weightA(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL weightB(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER myThid

C !OUTPUT PARAMETERS: ==================================================
C  none

#ifdef ALLOW_PTRACERS

C !LOCAL VARIABLES: ====================================================
C  iTracer :: tracer index
      INTEGER iTracer
#if ( defined NONLIN_FRSURF && defined ALLOW_AUTODIFF_TAMC )
C     kkey :: tape key (depends on levels, tracer, and tiles)
      INTEGER kkey
#endif
CEOP

C Loop over tracers
      DO iTracer=1,PTRACERS_numInUse
       IF ( PTRACERS_StepFwd(iTracer) ) THEN

#if ( defined NONLIN_FRSURF && defined ALLOW_AUTODIFF_TAMC )
        kkey = bi + (bj-1)*nSx + (ikey_dynamics-1)*nSx*nSy
        kkey = iTracer + (kkey-1)*PTRACERS_num
        kkey = (kkey-1)*Nr + k
CADJ STORE pTracer(:,:,k,bi,bj,iTracer)
CADJ &      = comlev1_bibj_k_ptracers, key=kkey, byte=isbyte
#endif

        CALL CONVECTIVELY_MIXTRACER(
     I           bi,bj,k,weightA,weightB,
     U           pTracer(1-OLx,1-OLy,1,1,1,iTracer),
     I           myThid )

C End of tracer loop
       ENDIF
      ENDDO

#endif /* ALLOW_PTRACERS */

      RETURN
      END

#include "CPP_EEOPTIONS.h"

C--   File utils.F: General purpose support routines
C--    Contents
C-- U DATE            - Returns date and time.
C--   IFNBLNK         - Returns index of first non-blank string character.
C--   ILNBLNK         - Returns index of last non-blank string character.
C--   IO_ERRCOUNT     - Reads IO error counter.
C--   LCASE           - Translates to lower case.
C--UM MACHINE         - Returns character string identifying computer.
C--   UCASE           - Translates to upper case.
C--   Routines marked "M" contain specific machine dependent code.
C--   Routines marked "U" contain UNIX OS calls.

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: DATE

C     !INTERFACE:
      SUBROUTINE DATE ( string , myThreadId )
      IMPLICIT NONE

C     !DESCRIPTION:
C     *==========================================================*
C     | SUBROUTINE DATE                                          |
C     | o Return current date                                    |
C     *==========================================================*

C     !USES:
#include "SIZE.h"
#include "EEPARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     string     :: Date returned in string
C     myThreadId :: My thread number
      CHARACTER*(*) string
      INTEGER myThreadId

C     !LOCAL VARIABLES:
C     lDate     :: Length of date string
C     msgBuffer :: Temp. for building error messages
      INTEGER lDate
      CHARACTER*(MAX_LEN_MBUF) msgBuffer
CEOP

      lDate = 24
      IF ( LEN(string) .LT. lDate ) GOTO 901
      string = ' '
#ifdef HAVE_FDATE
      CALL FDATE( string )
#endif

 1000 CONTINUE
      RETURN
  901 CONTINUE
      WRITE(msgBuffer,'(A)')
     &'                                                       '
      CALL PRINT_MESSAGE(msgBuffer,standardMessageUnit,
     &SQUEEZE_RIGHT,myThreadId)
      WRITE(msgBuffer,'(A)')
     &'*** WARNING WARNING WARNING WARNING WARNING WARNING ***'
      CALL PRINT_MESSAGE(msgBuffer,standardMessageUnit,
     &SQUEEZE_RIGHT,myThreadId)
      WRITE(msgBuffer,'(A)')
     &'procedure: "DATE".'
      CALL PRINT_MESSAGE(msgBuffer,standardMessageUnit,
     &SQUEEZE_RIGHT,myThreadId)
      WRITE(msgBuffer,'(A)')
     &'Variable passed to S/R DATE is too small.'
      CALL PRINT_MESSAGE(msgBuffer,standardMessageUnit,
     &SQUEEZE_RIGHT,myThreadId)
      WRITE(msgBuffer,'(A)')
     &' Argument must be at least',lDate,'characters long.'
      CALL PRINT_MESSAGE(msgBuffer,standardMessageUnit,
     &SQUEEZE_RIGHT,myThreadId)
      WRITE(msgBuffer,'(A)')
     &'*******************************************************'
      CALL PRINT_MESSAGE(msgBuffer,standardMessageUnit,
     &SQUEEZE_RIGHT,myThreadId)
      GOTO 1000
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: IFNBLNK

C     !INTERFACE:
      INTEGER FUNCTION IFNBLNK( string )
      IMPLICIT NONE

C     !DESCRIPTION:
C     *==========================================================*
C     | FUNCTION IFNBLNK                                         |
C     | o Find first non-blank in character string.              |
C     *==========================================================*

C     !INPUT PARAMETERS:
C     string :: String to find first non-blank in.
      CHARACTER*(*) string

C     !LOCAL VARIABLES:
C     L, LS :: Temps for string locations
      INTEGER L, LS
CEOP

      LS     = LEN(string)
      IFNBLNK = 0
      DO 10 L = 1, LS
       IF ( string(L:L) .EQ. ' ' ) GOTO 10
        IFNBLNK = L
        GOTO 11
   10 CONTINUE
   11 CONTINUE

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: ILNBLNK

C     !INTERFACE:
      INTEGER FUNCTION ILNBLNK( string )
      IMPLICIT NONE

C     !DESCRIPTION:
C     *==========================================================*
C     | FUNCTION ILNBLNK                                         |
C     | o Find last non-blank in character string.               |
C     *==========================================================*

C     !INPUT PARAMETERS:
C     string :: string to scan
      CHARACTER*(*) string

C     !LOCAL VARIABLES:
C     L, LS :: Temps. used in scanning string
      INTEGER L, LS
CEOP

      LS      = LEN(string)
c     ILNBLNK = LS
      ILNBLNK = 0
      DO 10 L = LS, 1, -1
        IF ( string(L:L) .EQ. ' ' ) GOTO 10
         ILNBLNK = L
         GOTO 11
   10 CONTINUE
   11 CONTINUE

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: IO_ERRCOUNT

C     !INTERFACE:
      INTEGER FUNCTION IO_ERRCOUNT(myThid)
      IMPLICIT NONE

C     !DESCRIPTION:
C     *==========================================================*
C     | FUNCTION IO\_ERRCOUNT                                     |
C     | o Reads IO error counter.                                |
C     *==========================================================*

C     !USES:
C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"

C     !INPUT PARAMETERS:
C     == Routine arguments ==
C     myThid :: My thread number
      INTEGER myThid

CEOP

      IO_ERRCOUNT = ioErrorCount(myThid)

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: LCASE

C     !INTERFACE:
      SUBROUTINE LCASE ( string )
      IMPLICIT NONE

C     !DESCRIPTION:
C     *==========================================================*
C     | SUBROUTINE LCASE                                         |
C     | o Convert character string to all lower case.            |
C     *==========================================================*

C     !INPUT/OUTPUT PARAMETERS:
      CHARACTER*(*) string

C     !LOCALVARIABLES:
      CHARACTER*26  LOWER
      DATA LOWER /'abcdefghijklmnopqrstuvwxyz'/
      SAVE LOWER
      CHARACTER*26  UPPER
      DATA UPPER /'ABCDEFGHIJKLMNOPQRSTUVWXYZ'/
      SAVE UPPER
      INTEGER   I, L
CEOP

      DO 10 I = 1, LEN(string)
        L = INDEX(UPPER,string(I:I))
        IF ( L .EQ. 0 ) GOTO 10
         string(I:I) = LOWER(L:L)
   10 CONTINUE

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: MACHINE

C     !INTERFACE:
      SUBROUTINE MACHINE ( string )
      IMPLICIT NONE

C     !DESCRIPTION:
C     *==========================================================*
C     | SUBROUTINE MACHINE                                       |
C     | o Return computer identifier in string.                  |
C     *==========================================================*

C     !USES:
#include "SIZE.h"
#include "EEPARAMS.h"
      INTEGER  IFNBLNK
      INTEGER  ILNBLNK
      EXTERNAL IFNBLNK
      EXTERNAL ILNBLNK

C     !OUTPUT PARAMETERS:
C     string :: Machine identifier
      CHARACTER*(*) string

C     !LOCAL VARIABLES:
C     iFirst, iLast,      :: String indexing temps.
C     iEnd, iFree, idSize
C     strTmp, idString    :: Temps. for strings.
      INTEGER  iFirst
      INTEGER  iLast
      INTEGER  iEnd
      INTEGER  iFree
      INTEGER  idSize
      CHARACTER*1024 strTmp
      CHARACTER*1024 idString
CEOP

      strTmp = 'UNKNOWN'
      iFree  = 1
      idSize = LEN(string)
#if (defined (TARGET_T3E) || defined (TARGET_CRAY_VECTOR) && !defined (TARGET_NEC_VECTOR))
      IFirst = 0
      CALL PXFGETENV('USER',iFirst,strTmp,ILast,Iend  )
#else
      CALL GETENV('USER',strTmp  )
#endif
      IF ( strTmp .NE. ' ' ) THEN
        iFirst = IFNBLNK(strTmp)
        iLast  = ILNBLNK(strTmp)
        iEnd   = iLast-iFirst+1
        IF (iEnd .GE. 0 ) THEN
         idString(iFree:) = strTmp(iFirst:iFirst+iEnd)
        ENDIF
        iFree = iFree+iEnd+1
        IF ( iFree .LE. idSize ) THEN
          idString(iFree:iFree) = '@'
          iFree = iFree+1
        ENDIF
      ENDIF
      strTmp = 'UNKNOWN'
#if (defined (TARGET_T3E) || defined (TARGET_CRAY_VECTOR) && !defined (TARGET_NEC_VECTOR))
      IFirst = 0
      CALL PXFGETENV('HOST',iFirst,strTmp,ILast,Iend  )
#else
      CALL GETENV('HOST',strTmp  )
#endif
      IF ( strTmp .NE. ' ' ) THEN
        iFirst = IFNBLNK(strTmp)
        iLast  = ILNBLNK(strTmp)
        iEnd   = iLast-iFirst+1
        iEnd   = MIN(iEnd,idSize-iFree)
        iEnd   = iEnd-1
        IF (iEnd .GE. 0 ) THEN
          idString(iFree:) = strTmp(iFirst:iFirst+iEnd)
        ENDIF
        iFree = iFree+iEnd+1
      ENDIF

      string = idString

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: UCASE

C     !INTERFACE:
      SUBROUTINE UCASE ( string )
      IMPLICIT NONE

C     !DESCRIPTION:
C     Translate string to upper case.

C     !INPUT/OUTPUT PARAMETERS:
      CHARACTER*(*) string

C     !LOCAL VARIABLES:
      CHARACTER*26  LOWER
      DATA LOWER /'abcdefghijklmnopqrstuvwxyz'/
      SAVE LOWER
      CHARACTER*26  UPPER
      DATA UPPER /'ABCDEFGHIJKLMNOPQRSTUVWXYZ'/
      SAVE UPPER
      INTEGER   I, L
CEOP

      DO 10 I = 1, LEN(string)
        L = INDEX(LOWER,string(I:I))
        IF ( L .EQ. 0 ) GOTO 10
          string(I:I) = UPPER(L:L)
   10 CONTINUE

      RETURN
      END

#include "PACKAGES_CONFIG.h"
#include "CPP_OPTIONS.h"
#ifdef ALLOW_AUTODIFF
# include "AUTODIFF_OPTIONS.h"
#endif
#ifdef ALLOW_CTRL
# include "CTRL_OPTIONS.h"
#endif
#ifdef ALLOW_MOM_COMMON
# include "MOM_COMMON_OPTIONS.h"
#endif
#ifdef ALLOW_OBCS
# include "OBCS_OPTIONS.h"
#endif

#undef DYNAMICS_GUGV_EXCH_CHECK

CBOP
C     !ROUTINE: DYNAMICS
C     !INTERFACE:
      SUBROUTINE DYNAMICS(myTime, myIter, myThid)
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE DYNAMICS
C     | o Controlling routine for the explicit part of the model
C     |   dynamics.
C     *==========================================================*
C     \ev
C     !USES:
      IMPLICIT NONE
C     == Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "DYNVARS.h"
#include "FFIELDS.h"
#ifdef ALLOW_MOM_COMMON
# include "MOM_VISC.h"
#endif
#ifdef ALLOW_CD_CODE
# include "CD_CODE_VARS.h"
#endif
#ifdef ALLOW_AUTODIFF
# ifdef ALLOW_AUTODIFF_TAMC
#  include "tamc.h"
# endif
# include "EOS.h"
# ifdef ALLOW_KPP
#  include "KPP.h"
# endif
# ifdef ALLOW_PTRACERS
#  include "PTRACERS_SIZE.h"
#  include "PTRACERS_FIELDS.h"
# endif
# ifdef ALLOW_OBCS
#  include "OBCS_PARAMS.h"
#  include "OBCS_FIELDS.h"
#  ifdef ALLOW_PTRACERS
#   include "OBCS_PTRACERS.h"
#  endif
# endif
# ifdef ALLOW_MOM_FLUXFORM
#  include "MOM_FLUXFORM.h"
# endif
#endif /* ALLOW_AUTODIFF */

C     !CALLING SEQUENCE:
C     DYNAMICS()
C      |
C      |-- CALC_EP_FORCING
C      |
C      |-- CALC_GRAD_PHI_SURF
C      |
C      |-- CALC_VISCOSITY
C      |
C      |-- MOM_CALC_3D_STRAIN
C      |
C      |-- CALC_EDDY_STRESS
C      |
C      |-- CALC_PHI_HYD
C      |
C      |-- MOM_FLUXFORM
C      |
C      |-- MOM_VECINV
C      |
C      |-- MOM_CALC_SMAG_3D
C      |-- MOM_UV_SMAG_3D
C      |
C      |-- TIMESTEP
C      |
C      |-- MOM_U_IMPLICIT_R
C      |-- MOM_V_IMPLICIT_R
C      |
C      |-- IMPLDIFF
C      |
C      |-- OBCS_APPLY_UV
C      |
C      |-- CALC_GW
C      |
C      |-- DIAGNOSTICS_FILL
C      |-- DEBUG_STATS_RL

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     myTime :: Current time in simulation
C     myIter :: Current iteration number in simulation
C     myThid :: Thread number for this instance of the routine.
      _RL myTime
      INTEGER myIter
      INTEGER myThid

C     !FUNCTIONS:
#ifdef ALLOW_DIAGNOSTICS
c     LOGICAL  DIAGNOSTICS_IS_ON
c     EXTERNAL DIAGNOSTICS_IS_ON
#endif

C     !LOCAL VARIABLES:
C     == Local variables
C     fVer[UV]               o fVer: Vertical flux term - note fVer
C                                    is "pipelined" in the vertical
C                                    so we need an fVer for each
C                                    variable.
C     phiHydC    :: hydrostatic potential anomaly at cell center
C                   In z coords phiHyd is the hydrostatic potential
C                      (=pressure/rho0) anomaly
C                   In p coords phiHyd is the geopotential height anomaly.
C     phiHydF    :: hydrostatic potential anomaly at middle between 2 centers
C     dPhiHydX,Y :: Gradient (X & Y directions) of hydrostatic potential anom.
C     phiSurfX,  ::  gradient of Surface potential (Pressure/rho, ocean)
C     phiSurfY             or geopotential (atmos) in X and Y direction
C     guDissip   :: dissipation tendency (all explicit terms), u component
C     gvDissip   :: dissipation tendency (all explicit terms), v component
C     kappaRU    :: vertical viscosity for velocity U-component
C     kappaRV    :: vertical viscosity for velocity V-component
C     iMin, iMax :: Ranges and sub-block indices on which calculations
C     jMin, jMax    are applied.
C     bi, bj     :: tile indices
C     k          :: current level index
C     km1, kp1   :: index of level above (k-1) and below (k+1)
C     kUp, kDown :: Index for interface above and below. kUp and kDown are
C                   are switched with k to be the appropriate index into fVerU,V
      _RL fVerU   (1-OLx:sNx+OLx,1-OLy:sNy+OLy,2)
      _RL fVerV   (1-OLx:sNx+OLx,1-OLy:sNy+OLy,2)
      _RL phiHydF (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL phiHydC (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL dPhiHydX(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL dPhiHydY(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL phiSurfX(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL phiSurfY(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL guDissip(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL gvDissip(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL kappaRU (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr+1)
      _RL kappaRV (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr+1)
#ifdef ALLOW_SMAG_3D
C     str11       :: strain component Vxx @ grid-cell center
C     str22       :: strain component Vyy @ grid-cell center
C     str33       :: strain component Vzz @ grid-cell center
C     str12       :: strain component Vxy @ grid-cell corner
C     str13       :: strain component Vxz @ above uVel
C     str23       :: strain component Vyz @ above vVel
C     viscAh3d_00 :: Smagorinsky viscosity @ grid-cell center
C     viscAh3d_12 :: Smagorinsky viscosity @ grid-cell corner
C     viscAh3d_13 :: Smagorinsky viscosity @ above uVel
C     viscAh3d_23 :: Smagorinsky viscosity @ above vVel
C     addDissU    :: zonal momentum tendency from 3-D Smag. viscosity
C     addDissV    :: merid momentum tendency from 3-D Smag. viscosity
      _RL str11(1-OLx:sNx+OLx,1-OLy:sNy+OLy, Nr )
      _RL str22(1-OLx:sNx+OLx,1-OLy:sNy+OLy, Nr )
      _RL str33(1-OLx:sNx+OLx,1-OLy:sNy+OLy, Nr )
      _RL str12(1-OLx:sNx+OLx,1-OLy:sNy+OLy, Nr )
      _RL str13(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr+1)
      _RL str23(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr+1)
      _RL viscAh3d_00(1-OLx:sNx+OLx,1-OLy:sNy+OLy, Nr )
      _RL viscAh3d_12(1-OLx:sNx+OLx,1-OLy:sNy+OLy, Nr )
      _RL viscAh3d_13(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr+1)
      _RL viscAh3d_23(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr+1)
      _RL addDissU(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL addDissV(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
#elif ( defined ALLOW_NONHYDROSTATIC )
      _RL str13(1), str23(1), str33(1)
      _RL viscAh3d_00(1), viscAh3d_13(1), viscAh3d_23(1)
#endif

      INTEGER bi, bj
      INTEGER i, j
      INTEGER k, km1, kp1, kUp, kDown
      INTEGER iMin, iMax
      INTEGER jMin, jMax
      PARAMETER( iMin = 0 , iMax = sNx+1 )
      PARAMETER( jMin = 0 , jMax = sNy+1 )
#ifdef ALLOW_AUTODIFF_TAMC
C     tkey :: tape key (tile dependent)
C     kkey :: tape key (level and tile dependent)
      INTEGER tkey, kkey
#endif

#ifdef ALLOW_DIAGNOSTICS
c     LOGICAL dPhiHydDiagIsOn
      _RL tmpFac
#endif /* ALLOW_DIAGNOSTICS */

C---    The algorithm...
C
C       "Correction Step"
C       =================
C       Here we update the horizontal velocities with the surface
C       pressure such that the resulting flow is either consistent
C       with the free-surface evolution or the rigid-lid:
C         U[n] = U* + dt x d/dx P
C         V[n] = V* + dt x d/dy P
C
C       "Calculation of Gs"
C       ===================
C       This is where all the accelerations and tendencies (ie.
C       physics, parameterizations etc...) are calculated
C         rho = rho ( theta[n], salt[n] )
C         Ph  = Ph(rho, z)
C         K33 = K33 ( rho )
C         Gu[n] = Gu( u[n], v[n], wVel, Ph, ... )
C         Gv[n] = Gv( u[n], v[n], wVel, Ph, ... )
C         Gt[n] = Gt( theta[n], u[n], v[n], wVel, K33, ... )
C         Gs[n] = Gs( salt[n], u[n], v[n], wVel, K33, ... )
C
C       "Time-stepping" or "Prediction"
C       ================================
C       The models variables are stepped forward with the appropriate
C       time-stepping scheme (currently we use Adams-Bashforth II)
C       - For momentum, the result is always *only* a "prediction"
C       in that the flow may be divergent and will be "corrected"
C       later with a surface pressure gradient.
C       - Normally for tracers the result is the new field at time
C       level [n+1} *BUT* in the case of implicit diffusion the result
C       is also *only* a prediction.
C       - We denote "predictors" with an asterisk (*).
C         U* = U[n] + dt x ( 3/2 Gu[n] - 1/2 Gu[n-1] )
C         V* = V[n] + dt x ( 3/2 Gv[n] - 1/2 Gv[n-1] )
C         theta[n+1] = theta[n] + dt x ( 3/2 Gt[n] - 1/2 Gt[n-1] )
C         salt[n+1]  = salt[n]  + dt x ( 3/2 Gs[n] - 1/2 Gs[n-1] )
C       With implicit diffusion:
C         theta* = theta[n] + dt x ( 3/2 Gt[n] - 1/2 Gt[n-1] )
C         salt*  = salt[n]  + dt x ( 3/2 Gs[n] - 1/2 Gs[n-1] )
C         (1 - dt * K * d_zz) theta[n+1] = theta*
C         (1 - dt * K * d_zz) salt[n+1]  = salt*
C---
CEOP

#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_ENTER( 'DYNAMICS', myThid )
#endif

#ifdef ALLOW_DIAGNOSTICS
c     dPhiHydDiagIsOn = .FALSE.
c     IF ( useDiagnostics )
c    &  dPhiHydDiagIsOn = DIAGNOSTICS_IS_ON( 'Um_dPHdx', myThid )
c    &               .OR. DIAGNOSTICS_IS_ON( 'Vm_dPHdy', myThid )
#endif

C-- Call to routine for calculation of Eliassen-Palm-flux-forced
C    U-tendency, if desired:
#ifdef INCLUDE_EP_FORCING_CODE
      CALL CALC_EP_FORCING(myThid)
#endif

#ifdef ALLOW_AUTODIFF_MONITOR_DIAG
      CALL DUMMY_IN_DYNAMICS( myTime, myIter, myThid )
#endif

#ifdef ALLOW_AUTODIFF_TAMC
C--   HPF directive to help TAF
CHPF$ INDEPENDENT
#endif /* ALLOW_AUTODIFF_TAMC */

      DO bj=myByLo(myThid),myByHi(myThid)

#ifdef ALLOW_AUTODIFF_TAMC
C--    HPF directive to help TAF
CHPF$  INDEPENDENT, NEW (fVerU,fVerV
CHPF$&                  ,phiHydF
CHPF$&                  ,kappaRU,kappaRV
CHPF$&                  )
#endif /* ALLOW_AUTODIFF_TAMC */

       DO bi=myBxLo(myThid),myBxHi(myThid)

#ifdef ALLOW_AUTODIFF_TAMC
        tkey = bi + (bj-1)*nSx + (ikey_dynamics-1)*nSx*nSy
#endif /* ALLOW_AUTODIFF_TAMC */

C--   Set up work arrays with valid (i.e. not NaN) values
C     These initial values do not alter the numerical results. They
C     just ensure that all memory references are to valid floating
C     point numbers. This prevents spurious hardware signals due to
C     uninitialised but inert locations.

#ifdef ALLOW_AUTODIFF
        DO k=1,Nr
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
c--   need some re-initialisation here to break dependencies
           gU(i,j,k,bi,bj) = 0. _d 0
           gV(i,j,k,bi,bj) = 0. _d 0
          ENDDO
         ENDDO
        ENDDO
#endif /* ALLOW_AUTODIFF */
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          fVerU  (i,j,1) = 0. _d 0
          fVerU  (i,j,2) = 0. _d 0
          fVerV  (i,j,1) = 0. _d 0
          fVerV  (i,j,2) = 0. _d 0
          phiHydF (i,j)  = 0. _d 0
          phiHydC (i,j)  = 0. _d 0
#ifndef INCLUDE_PHIHYD_CALCULATION_CODE
          dPhiHydX(i,j)  = 0. _d 0
          dPhiHydY(i,j)  = 0. _d 0
#endif
          phiSurfX(i,j)  = 0. _d 0
          phiSurfY(i,j)  = 0. _d 0
          guDissip(i,j)  = 0. _d 0
          gvDissip(i,j)  = 0. _d 0
#ifdef ALLOW_AUTODIFF
          phiHydLow(i,j,bi,bj) = 0. _d 0
# if (defined NONLIN_FRSURF) && (defined ALLOW_MOM_FLUXFORM)
#  ifndef DISABLE_RSTAR_CODE
          dWtransC(i,j,bi,bj) = 0. _d 0
          dWtransU(i,j,bi,bj) = 0. _d 0
          dWtransV(i,j,bi,bj) = 0. _d 0
#  endif
# endif
#endif /* ALLOW_AUTODIFF */
         ENDDO
        ENDDO
        IF ( useDiagnostics ) THEN
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           botDragU(i,j,bi,bj)  = 0. _d 0
           botDragV(i,j,bi,bj)  = 0. _d 0
          ENDDO
         ENDDO
        ENDIF

C--     Start computation of dynamics

#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE wVel (:,:,:,bi,bj) = comlev1_bibj, key=tkey, byte=isbyte
#endif /* ALLOW_AUTODIFF_TAMC */

C--     Explicit part of the Surface Potential Gradient (add in TIMESTEP)
C       (note: this loop will be replaced by CALL CALC_GRAD_ETA)
        IF (implicSurfPress.NE.1.) THEN
          CALL CALC_GRAD_PHI_SURF(
     I         bi,bj,iMin,iMax,jMin,jMax,
     I         etaN,
     O         phiSurfX,phiSurfY,
     I         myThid )
        ENDIF

#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE uVel     (:,:,:,bi,bj) = comlev1_bibj, key=tkey, byte=isbyte
CADJ STORE vVel     (:,:,:,bi,bj) = comlev1_bibj, key=tkey, byte=isbyte
#ifdef ALLOW_KPP
CADJ STORE KPPviscAz(:,:,:,bi,bj) = comlev1_bibj, key=tkey, byte=isbyte
#endif /* ALLOW_KPP */
#endif /* ALLOW_AUTODIFF_TAMC */

#ifndef ALLOW_AUTODIFF
        IF ( .NOT.momViscosity ) THEN
#endif
          DO k=1,Nr+1
           DO j=1-OLy,sNy+OLy
            DO i=1-OLx,sNx+OLx
             kappaRU(i,j,k) = 0. _d 0
             kappaRV(i,j,k) = 0. _d 0
            ENDDO
           ENDDO
          ENDDO
#ifndef ALLOW_AUTODIFF
        ENDIF
#endif
#ifdef INCLUDE_CALC_DIFFUSIVITY_CALL
C--     Calculate the total vertical viscosity
        IF ( momViscosity ) THEN
          CALL CALC_VISCOSITY(
     I            bi,bj, iMin,iMax,jMin,jMax,
     O            kappaRU, kappaRV,
     I            myThid )
        ENDIF
#endif /* INCLUDE_CALC_DIFFUSIVITY_CALL */

#ifdef ALLOW_SMAG_3D
        IF ( useSmag3D ) THEN
          CALL MOM_CALC_3D_STRAIN(
     O         str11, str22, str33, str12, str13, str23,
     I         bi, bj, myThid )
        ENDIF
#endif /* ALLOW_SMAG_3D */

#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE kappaRU(:,:,:) = comlev1_bibj, key=tkey, byte=isbyte
CADJ STORE kappaRV(:,:,:) = comlev1_bibj, key=tkey, byte=isbyte
#endif /* ALLOW_AUTODIFF_TAMC */

#ifdef ALLOW_OBCS
C--   For Stevens boundary conditions velocities need to be extrapolated
C     (copied) to a narrow strip outside the domain
        IF ( useOBCS ) THEN
          CALL OBCS_COPY_UV_N(
     U         uVel(1-OLx,1-OLy,1,bi,bj),
     U         vVel(1-OLx,1-OLy,1,bi,bj),
     I         Nr, bi, bj, myThid )
        ENDIF
#endif /* ALLOW_OBCS */

#ifdef ALLOW_EDDYPSI
        CALL CALC_EDDY_STRESS(bi,bj,myThid)
#endif

C--     Start of dynamics loop
        DO k=1,Nr

C--       km1    Points to level above k (=k-1)
C--       kup    Cycles through 1,2 to point to layer above
C--       kDown  Cycles through 2,1 to point to current layer

          km1  = MAX(1,k-1)
          kp1  = MIN(k+1,Nr)
          kup  = 1+MOD(k+1,2)
          kDown= 1+MOD(k,2)

#ifdef ALLOW_AUTODIFF_TAMC
         kkey = k + (tkey-1)*Nr
CADJ STORE totPhiHyd (:,:,k,bi,bj)
CADJ &     = comlev1_bibj_k, key=kkey, byte=isbyte
CADJ STORE phiHydLow (:,:,bi,bj)
CADJ &     = comlev1_bibj_k, key=kkey, byte=isbyte
CADJ STORE theta (:,:,k,bi,bj)
CADJ &     = comlev1_bibj_k, key=kkey, byte=isbyte
CADJ STORE salt  (:,:,k,bi,bj)
CADJ &     = comlev1_bibj_k, key=kkey, byte=isbyte
# ifdef NONLIN_FRSURF
cph-test
CADJ STORE  phiHydC (:,:)
CADJ &     = comlev1_bibj_k, key=kkey, byte=isbyte
CADJ STORE  phiHydF (:,:)
CADJ &     = comlev1_bibj_k, key=kkey, byte=isbyte
CADJ STORE gU(:,:,k,bi,bj)
CADJ &     = comlev1_bibj_k, key=kkey, byte=isbyte
CADJ STORE gV(:,:,k,bi,bj)
CADJ &     = comlev1_bibj_k, key=kkey, byte=isbyte
#  ifndef ALLOW_ADAMSBASHFORTH_3
CADJ STORE guNm1(:,:,k,bi,bj)
CADJ &     = comlev1_bibj_k, key=kkey, byte=isbyte
CADJ STORE gvNm1(:,:,k,bi,bj)
CADJ &     = comlev1_bibj_k, key=kkey, byte=isbyte
#  else
CADJ STORE guNm(:,:,k,bi,bj,1)
CADJ &     = comlev1_bibj_k, key=kkey, byte=isbyte
CADJ STORE guNm(:,:,k,bi,bj,2)
CADJ &     = comlev1_bibj_k, key=kkey, byte=isbyte
CADJ STORE gvNm(:,:,k,bi,bj,1)
CADJ &     = comlev1_bibj_k, key=kkey, byte=isbyte
CADJ STORE gvNm(:,:,k,bi,bj,2)
CADJ &     = comlev1_bibj_k, key=kkey, byte=isbyte
#  endif
#  ifdef ALLOW_CD_CODE
CADJ STORE uNM1(:,:,k,bi,bj)
CADJ &     = comlev1_bibj_k, key=kkey, byte=isbyte
CADJ STORE vNM1(:,:,k,bi,bj)
CADJ &     = comlev1_bibj_k, key=kkey, byte=isbyte
CADJ STORE uVelD(:,:,k,bi,bj)
CADJ &     = comlev1_bibj_k, key=kkey, byte=isbyte
CADJ STORE vVelD(:,:,k,bi,bj)
CADJ &     = comlev1_bibj_k, key=kkey, byte=isbyte
#  endif
# endif /* NONLIN_FRSURF */
#endif /* ALLOW_AUTODIFF_TAMC */

C--      Integrate hydrostatic balance for phiHyd with BC of phiHyd(z=0)=0
         CALL CALC_PHI_HYD(
     I        bi,bj,iMin,iMax,jMin,jMax,k,
     U        phiHydF,
     O        phiHydC, dPhiHydX, dPhiHydY,
     I        myTime, myIter, myThid )

C--      Calculate accelerations in the momentum equations (gU, gV, ...)
C        and step forward storing the result in gU, gV, etc...
         IF ( momStepping ) THEN
#ifdef ALLOW_AUTODIFF
           DO j=1-OLy,sNy+OLy
            DO i=1-OLx,sNx+OLx
              guDissip(i,j)  = 0. _d 0
              gvDissip(i,j)  = 0. _d 0
            ENDDO
           ENDDO
#endif /* ALLOW_AUTODIFF */
#ifdef ALLOW_AUTODIFF_TAMC
# if (defined NONLIN_FRSURF) && (defined ALLOW_MOM_FLUXFORM)
#  ifndef DISABLE_RSTAR_CODE
CADJ STORE dWtransC(:,:,bi,bj)
CADJ &     = comlev1_bibj_k, key=kkey, byte=isbyte
CADJ STORE dWtransU(:,:,bi,bj)
CADJ &     = comlev1_bibj_k, key=kkey, byte=isbyte
CADJ STORE dWtransV(:,:,bi,bj)
CADJ &     = comlev1_bibj_k, key=kkey, byte=isbyte
#  endif
# endif /* NONLIN_FRSURF and ALLOW_MOM_FLUXFORM */
# if (defined NONLIN_FRSURF) || (defined ALLOW_DEPTH_CONTROL)
CADJ STORE fVerU(:,:,:) = comlev1_bibj_k, key=kkey, byte=isbyte
CADJ STORE fVerV(:,:,:) = comlev1_bibj_k, key=kkey, byte=isbyte
# endif
#endif /* ALLOW_AUTODIFF_TAMC */
           IF (.NOT. vectorInvariantMomentum) THEN
#ifdef ALLOW_MOM_FLUXFORM
              CALL MOM_FLUXFORM(
     I         bi,bj,k,iMin,iMax,jMin,jMax,
     I         kappaRU, kappaRV,
     U         fVerU(1-OLx,1-OLy,kUp),   fVerV(1-OLx,1-OLy,kUp),
     O         fVerU(1-OLx,1-OLy,kDown), fVerV(1-OLx,1-OLy,kDown),
     O         guDissip, gvDissip,
     I         myTime, myIter, myThid)
#endif
           ELSE
#ifdef ALLOW_MOM_VECINV
             CALL MOM_VECINV(
     I         bi,bj,k,iMin,iMax,jMin,jMax,
     I         kappaRU, kappaRV,
     I         fVerU(1-OLx,1-OLy,kUp),   fVerV(1-OLx,1-OLy,kUp),
     O         fVerU(1-OLx,1-OLy,kDown), fVerV(1-OLx,1-OLy,kDown),
     O         guDissip, gvDissip,
     I         myTime, myIter, myThid)
#endif
           ENDIF

#ifdef ALLOW_SMAG_3D
           IF ( useSmag3D ) THEN
             CALL MOM_CALC_SMAG_3D(
     I         str11, str22, str33, str12, str13, str23,
     O         viscAh3d_00, viscAh3d_12, viscAh3d_13, viscAh3d_23,
     I         smag3D_hLsC, smag3D_hLsW, smag3D_hLsS, smag3D_hLsZ,
     I         k, bi, bj, myThid )
             CALL MOM_UV_SMAG_3D(
     I         str11, str22, str12, str13, str23,
     I         viscAh3d_00, viscAh3d_12, viscAh3d_13, viscAh3d_23,
     O         addDissU, addDissV,
     I         iMin,iMax,jMin,jMax, k, bi, bj, myThid )
             DO j= jMin,jMax
              DO i= iMin,iMax
               guDissip(i,j) = guDissip(i,j) + addDissU(i,j)
               gvDissip(i,j) = gvDissip(i,j) + addDissV(i,j)
              ENDDO
             ENDDO
           ENDIF
#endif /* ALLOW_SMAG_3D */

           CALL TIMESTEP(
     I         bi,bj,iMin,iMax,jMin,jMax,k,
     I         dPhiHydX,dPhiHydY, phiSurfX, phiSurfY,
     I         guDissip, gvDissip,
     I         myTime, myIter, myThid)

         ENDIF

C--     end of dynamics k loop (1:Nr)
        ENDDO

C--     Implicit Vertical advection & viscosity
#if (defined (INCLUDE_IMPLVERTADV_CODE) && \
     defined (ALLOW_MOM_COMMON) && !(defined ALLOW_AUTODIFF))
        IF ( momImplVertAdv .OR. implicitViscosity
     &                      .OR. selectImplicitDrag.GE.1 ) THEN
C      to recover older (prior to 2016-10-05) results:
c       IF ( momImplVertAdv ) THEN
          CALL MOM_U_IMPLICIT_R( kappaRU,
     I                           bi, bj, myTime, myIter, myThid )
          CALL MOM_V_IMPLICIT_R( kappaRV,
     I                           bi, bj, myTime, myIter, myThid )
        ELSEIF ( implicitViscosity ) THEN
#else /* INCLUDE_IMPLVERTADV_CODE */
        IF     ( implicitViscosity ) THEN
#endif /* INCLUDE_IMPLVERTADV_CODE */
#ifdef    ALLOW_AUTODIFF_TAMC
CADJ STORE gU(:,:,:,bi,bj) = comlev1_bibj , key=tkey, byte=isbyte
#endif    /* ALLOW_AUTODIFF_TAMC */
          CALL IMPLDIFF(
     I         bi, bj, iMin, iMax, jMin, jMax,
     I         -1, kappaRU, recip_hFacW(1-OLx,1-OLy,1,bi,bj),
     U         gU(1-OLx,1-OLy,1,bi,bj),
     I         myThid )
#ifdef    ALLOW_AUTODIFF_TAMC
CADJ STORE gV(:,:,:,bi,bj) = comlev1_bibj , key=tkey, byte=isbyte
#endif    /* ALLOW_AUTODIFF_TAMC */
          CALL IMPLDIFF(
     I         bi, bj, iMin, iMax, jMin, jMax,
     I         -2, kappaRV, recip_hFacS(1-OLx,1-OLy,1,bi,bj),
     U         gV(1-OLx,1-OLy,1,bi,bj),
     I         myThid )
        ENDIF

#ifdef ALLOW_OBCS
C--      Apply open boundary conditions
        IF ( useOBCS ) THEN
C--      but first save intermediate velocities to be used in the
C        next time step for the Stevens boundary conditions
          CALL OBCS_SAVE_UV_N(
     I        bi, bj, iMin, iMax, jMin, jMax, 0,
     I        gU, gV, myThid )
          CALL OBCS_APPLY_UV( bi, bj, 0, gU, gV, myThid )
        ENDIF
#endif /* ALLOW_OBCS */

#ifdef    ALLOW_CD_CODE
        IF (implicitViscosity.AND.useCDscheme) THEN
#ifdef    ALLOW_AUTODIFF_TAMC
CADJ STORE vVelD(:,:,:,bi,bj) = comlev1_bibj , key=tkey, byte=isbyte
#endif    /* ALLOW_AUTODIFF_TAMC */
          CALL IMPLDIFF(
     I         bi, bj, iMin, iMax, jMin, jMax,
     I         0, kappaRU, recip_hFacW(1-OLx,1-OLy,1,bi,bj),
     U         vVelD(1-OLx,1-OLy,1,bi,bj),
     I         myThid )
#ifdef    ALLOW_AUTODIFF_TAMC
CADJ STORE uVelD(:,:,:,bi,bj) = comlev1_bibj , key=tkey, byte=isbyte
#endif    /* ALLOW_AUTODIFF_TAMC */
          CALL IMPLDIFF(
     I         bi, bj, iMin, iMax, jMin, jMax,
     I         0, kappaRV, recip_hFacS(1-OLx,1-OLy,1,bi,bj),
     U         uVelD(1-OLx,1-OLy,1,bi,bj),
     I         myThid )
        ENDIF
#endif    /* ALLOW_CD_CODE */
C--     End implicit Vertical advection & viscosity

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#ifdef ALLOW_NONHYDROSTATIC
C--   Step forward W field in N-H algorithm
        IF ( nonHydrostatic ) THEN
#ifdef ALLOW_DEBUG
         IF (debugMode) CALL DEBUG_CALL('CALC_GW', myThid )
#endif
         CALL TIMER_START('CALC_GW          [DYNAMICS]',myThid)
         CALL CALC_GW(
     I                 bi,bj, kappaRU, kappaRV,
     I                 str13, str23, str33,
     I                 viscAh3d_00, viscAh3d_13, viscAh3d_23,
     I                 myTime, myIter, myThid )
        ENDIF
        IF ( nonHydrostatic.OR.implicitIntGravWave )
     &   CALL TIMESTEP_WVEL( bi,bj, myTime, myIter, myThid )
        IF ( nonHydrostatic )
     &   CALL TIMER_STOP ('CALC_GW          [DYNAMICS]',myThid)
#endif

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C-    end of bi,bj loops
       ENDDO
      ENDDO

#ifdef ALLOW_OBCS
      IF (useOBCS) THEN
        CALL OBCS_EXCHANGES( myThid )
      ENDIF
#endif

Cml(
C     In order to compare the variance of phiHydLow of a p/z-coordinate
C     run with etaH of a z/p-coordinate run the drift of phiHydLow
C     has to be removed by something like the following subroutine:
C      CALL REMOVE_MEAN_RL( 1, phiHydLow, maskInC, maskInC, rA, drF,
C     &                     'phiHydLow', myTime, myIter, myThid )
Cml)

#ifdef INCLUDE_SOUNDSPEED_CALC_CODE
      CALL DIAGS_SOUND_SPEED( myThid )
#endif

#ifdef ALLOW_DIAGNOSTICS
      IF ( useDiagnostics ) THEN

       CALL DIAGNOSTICS_FILL(totPhihyd,'PHIHYD  ',0,Nr,0,1,1,myThid)
       CALL DIAGNOSTICS_FILL(phiHydLow,'PHIBOT  ',0, 1,0,1,1,myThid)
       tmpFac = 1. _d 0
       CALL DIAGNOSTICS_SCALE_FILL(totPhihyd,tmpFac,2,
     &                                 'PHIHYDSQ',0,Nr,0,1,1,myThid)

       CALL DIAGNOSTICS_SCALE_FILL(phiHydLow,tmpFac,2,
     &                                 'PHIBOTSQ',0, 1,0,1,1,myThid)

       IF ( selectImplicitDrag.EQ.0 .AND.
     &      (  no_slip_bottom
     &    .OR. selectBotDragQuadr.GE.0
     &    .OR. bottomDragLinear.NE.0. ) ) THEN
        CALL DIAGNOSTICS_FILL_RS( botDragU, 'botTauX ',
     &                            0, 1, 0, 1, 1, myThid )
        CALL DIAGNOSTICS_FILL_RS( botDragV, 'botTauY ',
     &                            0, 1, 0, 1, 1, myThid )
       ENDIF

      ENDIF
#endif /* ALLOW_DIAGNOSTICS */

#ifdef ALLOW_DEBUG
      IF ( debugLevel .GE. debLevD ) THEN
       CALL DEBUG_STATS_RL(1,EtaN,'EtaN (DYNAMICS)',myThid)
       CALL DEBUG_STATS_RL(Nr,uVel,'Uvel (DYNAMICS)',myThid)
       CALL DEBUG_STATS_RL(Nr,vVel,'Vvel (DYNAMICS)',myThid)
       CALL DEBUG_STATS_RL(Nr,wVel,'Wvel (DYNAMICS)',myThid)
       CALL DEBUG_STATS_RL(Nr,theta,'Theta (DYNAMICS)',myThid)
       CALL DEBUG_STATS_RL(Nr,salt,'Salt (DYNAMICS)',myThid)
       CALL DEBUG_STATS_RL(Nr,gU,'Gu (DYNAMICS)',myThid)
       CALL DEBUG_STATS_RL(Nr,gV,'Gv (DYNAMICS)',myThid)
#ifndef ALLOW_ADAMSBASHFORTH_3
       CALL DEBUG_STATS_RL(Nr,guNm1,'GuNm1 (DYNAMICS)',myThid)
       CALL DEBUG_STATS_RL(Nr,gvNm1,'GvNm1 (DYNAMICS)',myThid)
       CALL DEBUG_STATS_RL(Nr,gtNm1,'GtNm1 (DYNAMICS)',myThid)
       CALL DEBUG_STATS_RL(Nr,gsNm1,'GsNm1 (DYNAMICS)',myThid)
#endif
      ENDIF
#endif

#ifdef DYNAMICS_GUGV_EXCH_CHECK
C- jmc: For safety checking only: This Exchange here should not change
C       the solution. If solution changes, it means something is wrong,
C       but it does not mean that it is less wrong with this exchange.
      IF ( debugLevel .GE. debLevE ) THEN
       CALL EXCH_UV_XYZ_RL(gU,gV,.TRUE.,myThid)
      ENDIF
#endif

#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_LEAVE( 'DYNAMICS', myThid )
#endif

      RETURN
      END

#include "KL10_OPTIONS.h"

      SUBROUTINE KL10_CALC_DIFF(
     I        bi,bj,iMin,iMax,jMin,jMax,kArg,kSize,
     U        KappaRx,
     I        myThid)

C     *==========================================================*
C     | SUBROUTINE KL10_CALC_DIFF                                |
C     | o Add contrubution to net diffusivity from KL10 mixing   |
C     *==========================================================*
      IMPLICIT NONE

C     == GLobal variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
c#include "GRID.h"
#ifdef ALLOW_3D_DIFFKR
# include "DYNVARS.h"
#endif
#ifdef ALLOW_KL10
# include "KL10.h"
#endif

C     == Routine arguments ==
C     bi, bj,   :: tile indices
C     iMin,iMax :: Range of points for which calculation is done
C     jMin,jMax :: Range of points for which calculation is done
C     kArg      :: = 0 -> do the k-loop here and treat all levels
C                  > 0 -> k-loop is done outside and treat only level k=kArg
C     kSize     :: 3rd Dimension of the vertical diffusivity array KappaRx
C     KappaRx   :: vertical diffusivity array
C     myThid    :: Instance number for this innvocation of KL10_CALC_DIFF

      INTEGER bi,bj,iMin,iMax,jMin,jMax,kArg,kSize
      _RL KappaRx(1-OLx:sNx+OLx,1-OLy:sNy+OLy,kSize)
      INTEGER myThid

#ifdef ALLOW_KL10

C     == Local variables ==
C     i,j,k     :: Loop counters
      INTEGER i,j,k

C--   Add Vertical diffusivity contribution from KL10
      IF ( kArg .EQ. 0 ) THEN
C-    do all levels :
        DO k=1,MIN(Nr,kSize)
         DO j=jMin,jMax
          DO i=iMin,iMax
            KappaRx(i,j,k) = KappaRx(i,j,k)
     &                  +( KLdiffKr(i,j,k,bi,bj)
#ifdef ALLOW_3D_DIFFKR
     &                     - diffKr(i,j,k,bi,bj) )
#else
     &                     - diffKrNrS(k) )
#endif
          ENDDO
         ENDDO
        ENDDO
      ELSE
C-    do level k=kArg only :
         k = MIN(kArg,kSize)
         DO j=jMin,jMax
          DO i=iMin,iMax
            KappaRx(i,j,k) = KappaRx(i,j,k)
     &                  +( KLdiffKr(i,j,kArg,bi,bj)
#ifdef ALLOW_3D_DIFFKR
     &                     - diffKr(i,j,kArg,bi,bj) )
#else
     &                     - diffKrNrS(kArg) )
#endif
          ENDDO
         ENDDO
      ENDIF

#endif /* ALLOW_KL10 */

      RETURN
      END

#include "AUTODIFF_OPTIONS.h"
#ifdef ALLOW_CTRL
# include "CTRL_OPTIONS.h"
#endif

C--   File cg2d_mad.F: Code for hand-written (manual) adjoint of cg2d
C--    Contents
C--   CG2D_MAD        - computes the adjoint of cg2d
C--   CG2D_STORE      - saves input field to or restores from a common block

CBOP
C     !ROUTINE: CG2D_MAD
C     !INTERFACE:
      SUBROUTINE CG2D_MAD(
     U                    cg2d_b_ad,
     U                    cg2d_x_ad,
     U                    numIters, nIterMin,
     I                    myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE CG2D_MAD
C     | o Manual ADjoint version of CG2D, the two-dimensional
C     |   grid problem conjugate-gradient inverter.
C     *==========================================================*
C     | This routine is called from solve_for_pressure_ad that
C     | is generated by TAF. We want a self-adjoint cg2d
C     | to avoid too many complications, so we provide flow
C     | directives in cg2d.flow and add the missing AD
C     | contributions manually (hence the name mad=Manuad ADjoint).
C     |
C     | This routine calls cg2d with reversed order of argumgent
C     | cg2d_x_ad and cg2d_b_ad, and sets dependendcies to zero
C     | that a non-self-adjoint cg2d would have produced.
C     | In addition, when runtime parameter cg2dFullAdjoint = T,
C     | it computes sensitivities to matrix coefficients. This
C     | makes it the full adjoint of cg2d, only if cg2d converges
C     | completely. Otherwise it is an excellent approximation.
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     === Global data ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#if ( defined NONLIN_FRSURF || defined ALLOW_DEPTH_CONTROL )
# include "CG2D.h"
#endif
#ifdef ALLOW_AUTODIFF_TAMC
# include "AUTODIFF_PARAMS.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
C     cg2d_b_ad :: Adjoint of source term (on input = 0)
C     cg2d_x_ad :: Adjoint of the solution
C     firstResidual :: the initial residual before any iterations
C     minResidualSq :: the lowest residual reached (squared)
C     lastResidual  :: the actual residual reached
C     numIters  :: Inp: the maximum number of iterations allowed
C                  Out: the actual number of iterations used
C     nIterMin  :: Inp: decide to store (if >=0) or not (if <0) lowest res. sol.
C                  Out: iteration number corresponding to lowest residual
C     myThid    :: Thread on which I am working.
      _RL  cg2d_b_ad(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL  cg2d_x_ad(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
c     _RL  firstResidual, minResidualSq, lastResidual
      INTEGER numIters
      INTEGER nIterMin
      INTEGER myThid

#ifdef ALLOW_AUTODIFF_TAMC
#if ( defined NONLIN_FRSURF || defined ALLOW_DEPTH_CONTROL )
C     directly imported from TAF-generated code, make sure that they are
C     consistent with what is found in S/R update_cg2d_ad
      _RS aW2d_ad(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RS aS2d_ad(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RS aC2d_ad(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RS pW_ad  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RS pS_ad  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RS pC_ad  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      COMMON /ADCG2D_I_RS/
     &     aW2d_ad, aS2d_ad, aC2d_ad, pW_ad, pS_ad, pC_ad
#endif /* NONLIN_FRSURF or ALLOW_DEPTH_CONTROL */

C     !LOCAL VARIABLES:
C     === Local variables ===
C     bi,bj  :: tile indices
C     i,j    :: Loop counters
C     cg2d_x :: local copy of cg2d_x to be restored from "tape"
      INTEGER i,j,bi,bj
      _RL  firstResidual, minResidualSq, lastResidual
#if ( defined NONLIN_FRSURF || defined ALLOW_DEPTH_CONTROL )
      INTEGER numItersFwd, nIterMinFwd
      _RL  recip_cg2dNorm
      _RL  cg2d_x(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
#endif
      CHARACTER*(MAX_LEN_MBUF) msgBuf
CEOP

C--   mark output of cg2d as being called from here
      IF ( debugLevel .GE. debLevZero ) THEN
       _BEGIN_MASTER( myThid )
       WRITE(standardMessageUnit,'(A)')
     &      ' Calling cg2d from S/R CG2D_MAD'
       _END_MASTER( myThid )
      ENDIF

#if ( defined NONLIN_FRSURF || defined ALLOW_DEPTH_CONTROL )
C     make local copies because we need them later
      numItersFwd = numIters
      nIterMinFwd = nIterMin
#endif

#ifdef ALLOW_SRCG
      IF ( useSRCGSolver ) THEN
C--   Call the single reduce CG solver
       CALL CG2D_SR(
     U      cg2d_x_ad, cg2d_b_ad,
     O      firstResidual, minResidualSq, lastResidual,
     U      numIters, nIterMin,
     I      myThid )
      ELSE
#else
      IF (.TRUE.) THEN
#endif /* ALLOW_SRCG */
C--   Call the default CG solver
       CALL CG2D(
     U      cg2d_x_ad, cg2d_b_ad,
     O      firstResidual, minResidualSq, lastResidual,
     U      numIters, nIterMin,
     I      myThid )
      ENDIF

CML      CALL ADEXCH_XY_RL( cg2d_b_ad, myThid )
CML       _EXCH_XY_RL( cg2d_b_ad, myThid )

C     cg2d_x_ad is reset to zero, because we assume that the solution of
C     the self-adjoint solver does not depend in the intial conditions
C     so that no sensitivities should be passed back to the caller.
      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          cg2d_x_ad(i,j,bi,bj) = 0. _d 0
         ENDDO
        ENDDO
       ENDDO
      ENDDO

C--   dump CG2D output
C     Since there is no clean way in importing myTime into this routine,
C     we just call it every timestep but only for a higher debugLevel
      IF ( debugLevel .GE. debLevC .OR. printResidualFreq.GE.0 ) THEN
       _BEGIN_MASTER( myThid )
       WRITE(msgBuf,'(A30,1PE23.14)')
     &       'CG2D_MAD: cg2d_init_res =', firstResidual
       CALL PRINT_MESSAGE(msgBuf,standardMessageUnit,SQUEEZE_RIGHT,1)
       WRITE(msgBuf,'(A37,2I8)')
     &       'CG2D_MAD: cg2d_iters(min,last) =', nIterMin, numIters
       CALL PRINT_MESSAGE(msgBuf,standardMessageUnit,SQUEEZE_RIGHT,1)
       IF ( minResidualSq.GE.0. ) THEN
        minResidualSq = SQRT(minResidualSq)
        WRITE(msgBuf,'(A30,1PE23.14)')
     &        'CG2D_MAD: cg2d_min_res  =', minResidualSq
        CALL PRINT_MESSAGE(msgBuf,standardMessageUnit,SQUEEZE_RIGHT,1)
       ENDIF
       WRITE(msgBuf,'(A30,1PE23.14)')
     &       'CG2D_MAD: cg2d_last_res =',lastResidual
       CALL PRINT_MESSAGE(msgBuf,standardMessageUnit,SQUEEZE_RIGHT,1)
       _END_MASTER( myThid )
      ENDIF

#if ( defined NONLIN_FRSURF || defined ALLOW_DEPTH_CONTROL )
      recip_cg2dNorm = 1.0 _d 0
      IF ( cg2dNorm .NE. 0. _d 0 ) THEN
       recip_cg2dNorm = 1. _d 0 / cg2dNorm
      ENDIF

      IF ( cg2dFullAdjoint ) THEN
C     restore cg2d_x
       CALL CG2D_STORE( cg2d_x, .FALSE., myThid )

C     Compute derivative of coefficient matrix.
       DO bj=myByLo(myThid),myByHi(myThid)
        DO bi=myBxLo(myThid),myBxHi(myThid)
         DO j=1,sNy
          DO i=1,sNx
           aC2d_ad(i,j,bi,bj)   = aC2d_ad(i,j,bi,bj)
     &          - cg2d_b_ad(i,j,bi,bj) * cg2d_x(i,j,bi,bj)
     &          * recip_cg2dNorm
           aW2d_ad(i,  j,bi,bj) = aW2d_ad(i,j,bi,bj)
     &          - cg2d_b_ad(i,j,bi,bj) * cg2d_x(i-1,j,bi,bj)
     &          * recip_cg2dNorm
           aW2d_ad(i+1,j,bi,bj) = aW2d_ad(i+1,j,bi,bj)
     &          - cg2d_b_ad(i,j,bi,bj) * cg2d_x(i+1,j,bi,bj)
     &          * recip_cg2dNorm
           aS2d_ad(i,j,  bi,bj) = aS2d_ad(i,j,bi,bj)
     &          - cg2d_b_ad(i,j,bi,bj) * cg2d_x(i,j-1,bi,bj)
     &          * recip_cg2dNorm
           aS2d_ad(i,j+1,bi,bj) = aS2d_ad(i,j+1,bi,bj)
     &          - cg2d_b_ad(i,j,bi,bj) * cg2d_x(i,j+1,bi,bj)
     &          * recip_cg2dNorm
C     The sensitivities of preconditioner are something like
C          pC_ad = pC_ad + cg2d_z_ad * cg2d_r
C     and similar (cg2d_z = preconditioner * cg2d_r). That is, when the
C     solver has converged, cg2d_r -> 0 and pC_ad -> 0, unless cg2d_z_ad
C     is large, which would mean an instability. Therefore we set the
C     preconditioner adjoint to zero. This also reflects the fact, that
C     in an ideal world, the preconditioner does not have any effect on
C     the solution, but only on the rate of convergence.
           pW_ad(i,j,bi,bj) = 0. _d 0
           pS_ad(i,j,bi,bj) = 0. _d 0
           pC_ad(i,j,bi,bj) = 0. _d 0
          ENDDO
         ENDDO
        ENDDO
       ENDDO
      ELSE
C     Initialise AD fields to zero for an adjoint neglecting the
C     contributions from the matrix coefficients (default for now).
       DO bj=myByLo(myThid),myByHi(myThid)
        DO bi=myBxLo(myThid),myBxHi(myThid)
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           aW2d_ad(i,j,bi,bj) = 0. _d 0
           aS2d_ad(i,j,bi,bj) = 0. _d 0
           aC2d_ad(i,j,bi,bj) = 0. _d 0
           pW_ad  (i,j,bi,bj) = 0. _d 0
           pS_ad  (i,j,bi,bj) = 0. _d 0
           pC_ad  (i,j,bi,bj) = 0. _d 0
          ENDDO
         ENDDO
        ENDDO
       ENDDO
      ENDIF
#endif /* NONLIN_FRSURF or ALLOW_DEPTH_CONTROL */
#endif /* ALLOW_AUTODIFF_TAMC */

      RETURN
      END

C--------1---------2---------3---------4---------5---------6---------7--

CBOP
C     !ROUTINE: CG2D_STORE
C     !INTERFACE:
      SUBROUTINE CG2D_STORE(
     U                      cg2d_x,
     I                      doStore,
     I                      myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE CG2D_STORE
C     | o Hand written tape routine
C     *==========================================================*
C     | This routine is called from solve_for_pressure to
C     | to force TAF to store cg2d_x
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     === Global data ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "AUTODIFF_PARAMS.h"
#ifdef ALLOW_AUTODIFF_TAMC
# include "tamc.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
C     cg2d_x    :: The solution to be stored and restored
C     doStore   :: Store or restore based on the logical
C     myThid    :: Thread on which I am working.
      _RL  cg2d_x(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      LOGICAL doStore
      INTEGER myThid

#ifdef ALLOW_AUTODIFF_TAMC
#if ( defined NONLIN_FRSURF || defined ALLOW_DEPTH_CONTROL )
      _RL cg2d_tape(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy,nchklev_1)
      COMMON /CG2D_TAPE_RL/ cg2d_tape

C     !LOCAL VARIABLES:
C     === Local variables ===
C     bi,bj  :: tile indices
C     i,j    :: Loop counters
      INTEGER i,j,bi,bj
CEOP

C--   mark output of cg2d as being called from here
      IF ( debugLevel .GE. debLevZero ) THEN
       _BEGIN_MASTER( myThid )
       WRITE(standardMessageUnit,'(A,L1)')
     &      ' Calling CG2D_STORE with doStore = ', doStore
       WRITE(standardMessageUnit,'(A,I6)')
     &      ' Calling CG2D_STORE with ikey_dynamics=', ikey_dynamics
       _END_MASTER( myThid )
      ENDIF

      IF ( doStore ) THEN
C     Save input cg2d_x to local common block
       DO bj = myByLo(myThid), myByHi(myThid)
        DO bi = myBxLo(myThid), myBxHi(myThid)
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           cg2d_tape(i,j,bi,bj,ikey_dynamics) = cg2d_x(i,j,bi,bj)
          ENDDO
         ENDDO
        ENDDO
       ENDDO
      ELSE
C     Restore output cg2d_x from local common block
       DO bj = myByLo(myThid), myByHi(myThid)
        DO bi = myBxLo(myThid), myBxHi(myThid)
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           cg2d_x(i,j,bi,bj) = cg2d_tape(i,j,bi,bj,ikey_dynamics)
          ENDDO
         ENDDO
        ENDDO
       ENDDO
      ENDIF
#endif /* NONLIN_FRSURF or ALLOW_DEPTH_CONTROL */
#endif /* ALLOW_AUTODIFF_TAMC */

      RETURN
      END

#include "CPP_EEOPTIONS.h"

C--  File zero_adj.F:
C--   Contents
C--   o ZERO_ADJ_1D
C--   o ZERO_ADJ_LOC
C--   o ZERO_ADJ

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: ZERO_ADJ_1D
C     !INTERFACE:
      SUBROUTINE ZERO_ADJ_1D(
     I                NrIn, fieldFwd, myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | o zero out a one dimensional adjoint field
C     | ... nothing happens in forward mode
C     | author: Gael Forget
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     myThid :: my Thread Id number
      INTEGER NrIn, myThid
      _RL fieldFwd(NrIn)
CEOP

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: ZERO_ADJ_LOC
C     !INTERFACE:
      SUBROUTINE ZERO_ADJ_LOC(
     I                NrIn, fieldFwd, myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | o zero out a local (no nsx,nsy dims.) adjoint field
C     | ... nothing happens in forward mode
C     | author: Gael Forget
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     myThid :: my Thread Id number
      INTEGER NrIn, myThid
      _RL fieldFwd(1-OLx:sNx+OLx,1-OLy:sNy+OLy,NrIn)
CEOP

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: ZERO_ADJ
C     !INTERFACE:
      SUBROUTINE ZERO_ADJ(
     I                NrIn, fieldFwd, myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | o zero out a full (incl. nsx,nsy dims.) adjoint field
C     | ... nothing happens in forward mode
C     | author: Gael Forget
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     myThid :: my Thread Id number
      INTEGER NrIn, myThid
      _RL fieldFwd(1-OLx:sNx+OLx,1-OLy:sNy+OLy,NrIn,nSx,nSy)
CEOP

      RETURN
      END

#include "PACKAGES_CONFIG.h"
#include "CPP_OPTIONS.h"

#ifdef ALLOW_AUTODIFF
# include "AUTODIFF_OPTIONS.h"
#endif
#ifdef ALLOW_GENERIC_ADVDIFF
# include "GAD_OPTIONS.h"
#endif
#ifdef ALLOW_GGL90
# include "GGL90_OPTIONS.h"
#endif
#ifdef ALLOW_GMREDI
# include "GMREDI_OPTIONS.h"
#endif
#ifdef ALLOW_OBCS
# include "OBCS_OPTIONS.h"
#endif
#ifdef ALLOW_THSICE
# include "THSICE_OPTIONS.h"
#endif
#ifdef ALLOW_SEAICE
# include "SEAICE_OPTIONS.h"
#endif
#ifdef ALLOW_SALT_PLUME
# include "SALT_PLUME_OPTIONS.h"
#endif
#ifdef ALLOW_PTRACERS
# include "PTRACERS_OPTIONS.h"
#endif
#ifdef ALLOW_GCHEM
# include "GCHEM_OPTIONS.h"
#endif
#ifdef ALLOW_DIC
# include "DIC_OPTIONS.h"
#endif
#ifdef ALLOW_BLING
# include "BLING_OPTIONS.h"
#endif
#ifdef ALLOW_EXF
# include "EXF_OPTIONS.h"
#endif
#ifdef ALLOW_STREAMICE
# include "STREAMICE_OPTIONS.h"
#endif
#ifdef ALLOW_SHELFICE
# include "SHELFICE_OPTIONS.h"
#endif
#ifdef ALLOW_COST
# include "COST_OPTIONS.h"
#endif
#ifdef ALLOW_CTRL
# include "CTRL_OPTIONS.h"
#endif
#ifdef ALLOW_ECCO
# include "ECCO_OPTIONS.h"
#endif
#ifdef ALLOW_RBCS
# include "RBCS_OPTIONS.h"
#endif

#define ALLOW_MOM_STEPPING
#if ( defined (ALLOW_AUTODIFF) && defined (ALLOW_OFFLINE) )
# undef ALLOW_MOM_STEPPING
#endif

CBOP
C     !ROUTINE: FORWARD_STEP
C     !INTERFACE:
      SUBROUTINE FORWARD_STEP( iloop, myTime, myIter, myThid )

C     !DESCRIPTION: \bv
C     *=================================================================
C     | SUBROUTINE forward_step
C     | o Step forward in time the model variables for one time-step
C     *=================================================================
C     | The algorithm...
C     |
C     | "Calculation of Gs"
C     | ===================
C     | This is where all the accelerations and tendencies (ie.
C     | physics, parameterizations etc...) are calculated
C     |   rho = rho ( theta[n], salt[n] )
C     |   b   = b(rho, theta)
C     |   K31 = K31 ( rho )
C     |   Gu[n] = Gu( u[n], v[n], wVel, b, ... )
C     |   Gv[n] = Gv( u[n], v[n], wVel, b, ... )
C     |   Gt[n] = Gt( theta[n], u[n], v[n], wVel, K31, ... )
C     |   Gs[n] = Gs( salt[n], u[n], v[n], wVel, K31, ... )
C     |
C     | "Time-stepping" or "Prediction"
C     | ================================
C     | The models variables are stepped forward with the appropriate
C     | time-stepping scheme (currently we use Adams-Bashforth II)
C     | - For momentum, the result is always *only* a "prediction"
C     | in that the flow may be divergent and will be "corrected"
C     | later with a surface pressure gradient.
C     | - Normally for tracers the result is the new field at time
C     | level [n+1} *BUT* in the case of implicit diffusion the result
C     | is also *only* a prediction.
C     | - We denote "predictors" with an asterisk (*).
C     |   U* = U[n] + dt x ( 3/2 Gu[n] - 1/2 Gu[n-1] )
C     |   V* = V[n] + dt x ( 3/2 Gv[n] - 1/2 Gv[n-1] )
C     |   theta[n+1] = theta[n] + dt x ( 3/2 Gt[n] - 1/2 atG[n-1] )
C     |   salt[n+1]  = salt[n] + dt x ( 3/2 Gt[n] - 1/2 atG[n-1] )
C     | With implicit diffusion:
C     |   theta* = theta[n] + dt x ( 3/2 Gt[n] - 1/2 atG[n-1] )
C     |   salt*  = salt[n] + dt x ( 3/2 Gt[n] - 1/2 atG[n-1] )
C     |   (1 + dt * K * d_zz) theta[n+1] = theta*
C     |   (1 + dt * K * d_zz) salt[n+1]  = salt*
C     |
C     | "Correction Step"
C     | =================
C     | Here we update the horizontal velocities with the surface
C     | pressure such that the resulting flow is either consistent
C     | with the free-surface evolution or the rigid-lid:
C     |   U[n] = U* + dt x d/dx P
C     |   V[n] = V* + dt x d/dy P
C     |   W[n] = W* + dt x d/dz P  (NH mode)
C     *=================================================================
C     \ev

C     !CALLING SEQUENCE:
C     FORWARD_STEP
C       |
C       |-- AUTODIFF_INADMODE_UNSET
C       |
C       |-- SHELFICE_REMESHING
C       |
C       |-- RESET_NLFS_VARS
C       |-- UPDATE_R_STAR
C       |-- UPDATE_SURF_DR
C       |
C       |-- PTRACERS_SWITCH_ONOFF
C       |
C       |-- DIAGNOSTICS_SWITCH_ONOFF
C       |-- DO_STATEVARS_DIAGS
C       |
C       |-- NEST_CHILD_SETMEMO
C       |-- NEST_PARENT_IO_1
C       |
C       |-- LOAD_FIELDS_DRIVER
C       |
C       |-- BULKF_FORCING
C       |
C       |-- CHEAPAML
C       |
C       |-- CTRL_MAP_FORCING
C       |-- DUMMY_IN_STEPPING
C       |
C       |-- CPL_EXPORT_IMPORT_DATA
C       |
C       |-- OASIS_PUT
C       |-- OASIS_GET
C       |
C       |-- EBM_DRIVER
C       |
C       |-- DO_ATMOSPHERIC_PHYS
C       |
C       |-- DO_OCEANIC_PHYS
C       |
C       |-- STREAMICE_TIMESTEP
C       |
C       |-- GCHEM_CALC_TENDENCY
C       |
C       |-- LONGSTEP_AVERAGE
C       |-- LONGSTEP_THERMODYNAMICS
C       |
C       |-- THERMODYNAMICS
C       |
C       |-- LONGSTEP_AVERAGE
C       |-- LONGSTEP_THERMODYNAMICS
C       |
C       |-- DO_STAGGER_FIELDS_EXCHANGES
C       |
C       |-- DYNAMICS
C       |
C       |-- MNC_UPDATE_TIME
C       |
C       |-- OFFLINE_FIELDS_LOAD
C       |
C       |-- UPDATE_R_STAR
C       |-- UPDATE_SIGMA
C       |-- UPDATE_SURF_DR
C       |-- UPDATE_CG2D
C       |
C       |-- SHAP_FILT_APPLY_UV
C       |-- ZONAL_FILT_APPLY_UV
C       |
C       |-- SOLVE_FOR_PRESSURE
C       |
C       |-- MOMENTUM_CORRECTION_STEP
C       |
C       |-- INTEGR_CONTINUITY
C       |
C       |-- CALC_R_STAR
C       |-- CALC_SURF_DR
C       |
C       |-- DO_STAGGER_FIELDS_EXCHANGES
C       |
C       |-- DO_STATEVARS_DIAGS
C       |
C       |-- THERMODYNAMICS
C       |
C       |-- TRACERS_CORRECTION_STEP
C       |
C       |-- LONGSTEP_AVERAGE
C       |-- LONGSTEP_THERMODYNAMICS
C       |
C       |-- GCHEM_FORCING_SEP
C       |
C       |-- DO_FIELDS_BLOCKING_EXCHANGES
C       |
C       |-- DO_STATEVARS_DIAGS
C       |
C       |-- GRIDALT_UPDATE
C       |-- STEP_FIZHI_CORR
C       |
C       |-- FLT_MAIN
C       |
C       |-- NEST_PARENT_IO_2
C       |-- NEST_CHILD_TRANSP
C       |
C       |-- MONITOR
C       |
C       |-- COST_TILE
C       |
C       |-- DO_THE_MODEL_IO
C       |
C       |-- PTRACERS_RESET
C       |
C       |-- DO_WRITE_PICKUP
C       |
C       |-- AUTODIFF_INADMODE_SET
C       |
C       |-- SHOWFLOPS_INLOOP

C     !USES:
      IMPLICIT NONE
C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "DYNVARS.h"

#ifdef HAVE_SIGREG
#include "SIGREG.h"
#endif

#ifdef ALLOW_SHAP_FILT
# include "SHAP_FILT.h"
#endif
#ifdef ALLOW_ZONAL_FILT
# include "ZONAL_FILT.h"
#endif

#ifdef ALLOW_LONGSTEP
# include "LONGSTEP_PARAMS.h"
# include "LONGSTEP.h"
#endif

#ifdef ALLOW_AUTODIFF
# include "FFIELDS.h"
# include "SURFACE.h"

# ifdef ALLOW_AUTODIFF_TAMC
#  include "tamc.h"
# endif
# ifdef ALLOW_CTRL
#  include "CTRL_SIZE.h"
#  include "CTRL.h"
#  include "CTRL_DUMMY.h"
#  include "CTRL_GENARR.h"
#  include "CTRL_OBCS.h"
# endif
# ifdef ALLOW_COST
#  include "cost.h"
# endif
# ifdef ALLOW_ECCO
#  include "ecco_cost.h"
# endif
# include "EOS.h"
# if (defined NONLIN_FRSURF) || (defined ALLOW_DEPTH_CONTROL)
#  include "GRID.h"
# endif
# ifdef ALLOW_GMREDI
#  include "GMREDI.h"
# endif
# ifdef ALLOW_EXF
#  ifdef ALLOW_BULKFORMULAE
#   include "EXF_CONSTANTS.h"
#  endif
#  include "EXF_INTERP_SIZE.h"
#  include "EXF_FIELDS.h"
# endif
# ifdef ALLOW_CD_CODE
#  include "CD_CODE_VARS.h"
# endif
# ifdef ALLOW_GENERIC_ADVDIFF
#  include "GAD.h"
#  include "GAD_SOM_VARS.h"
# endif
# ifdef ALLOW_GGL90
#  include "GGL90.h"
# endif
# ifdef ALLOW_PTRACERS
#  include "PTRACERS_SIZE.h"
#  include "PTRACERS_FIELDS.h"
# endif
# ifdef ALLOW_GCHEM
#  include "GCHEM_SIZE.h"
#  include "GCHEM_FIELDS.h"
# endif
# ifdef ALLOW_CFC
#  include "CFC.h"
# endif
# ifdef ALLOW_DIC
#  include "DIC_VARS.h"
#  include "DIC_LOAD.h"
#  include "DIC_ATMOS.h"
#  include "DIC_COST.h"
# endif
# ifdef ALLOW_BLING
#  include "BLING_VARS.h"
#  include "BLING_LOAD.h"
# endif
# ifdef ALLOW_OBCS
#  include "OBCS_PARAMS.h"
#  include "OBCS_FIELDS.h"
#  include "OBCS_SEAICE.h"
#  ifdef ALLOW_PTRACERS
#   include "OBCS_PTRACERS.h"
#  endif
# endif
# ifdef ALLOW_THSICE
#  include "THSICE_PARAMS.h"
#  include "THSICE_SIZE.h"
#  include "THSICE_VARS.h"
#  include "THSICE_COST.h"
# endif
# ifdef ALLOW_SEAICE
#  include "SEAICE_SIZE.h"
#  include "SEAICE_GRID.h"
#  include "SEAICE.h"
#  include "SEAICE_COST.h"
# endif
# ifdef ALLOW_SALT_PLUME
#  include "SALT_PLUME.h"
# endif
# ifdef ALLOW_DOWN_SLOPE
#  include "DWNSLP_SIZE.h"
#  include "DWNSLP_VARS.h"
# endif
# ifdef ALLOW_SHELFICE
#  include "SHELFICE.h"
#  include "SHELFICE_COST.h"
# endif
# ifdef ALLOW_STREAMICE
#  include "STREAMICE.h"
#  include "STREAMICE_ADV.h"
#  include "STREAMICE_BDRY.h"
#  include "STREAMICE_CG.h"
# endif
# ifdef ALLOW_EBM
#  include "EBM.h"
# endif
# ifdef ALLOW_KPP
#  include "KPP.h"
# endif
# ifdef ALLOW_RBCS
#  include "RBCS_SIZE.h"
#  include "RBCS_FIELDS.h"
# endif
# ifdef ALLOW_OFFLINE
#  include "OFFLINE.h"
# endif
# if (defined ALLOW_CG2D_NSA || defined NONLIN_FRSURF || \
      defined ALLOW_DEPTH_CONTROL)
#  include "CG2D.h"
# endif
#endif /* ALLOW_AUTODIFF */

#ifdef ALLOW_TAPENADE
c# ifdef ALLOW_KPP
c#  include "KPP_PARAMS.h"
c# endif
# ifdef ALLOW_MOM_FLUXFORM
#  include "MOM_FLUXFORM.h"
# endif
# ifdef ALLOW_EXF
#  include "EXF_PARAM.h"
#  include "EXF_INTERP_PARAM.h"
# endif
#endif /* ALLOW_TAPENADE */

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     note: under the multi-threaded model myIter and
C           myTime are local variables passed around as routine
C           arguments. Although this is fiddly it saves the need to
C           impose additional synchronisation points when they are
C           updated.
C     myTime :: time counter for this thread
C     myIter :: iteration counter for this thread
C     myThid :: thread number for this instance of the routine.
      INTEGER iloop
      _RL     myTime
      INTEGER myIter
      INTEGER myThid

C     !LOCAL VARIABLES:
C     == Local variables ==
C     modelEnd  :: true if reaching the end of the run
C     myTimeBeg :: time at beginning of time step (needed by longstep)
C     myIterBeg :: iteration number at beginning of time step
      LOGICAL modelEnd
#ifdef ALLOW_LONGSTEP
      INTEGER myIterBeg
      _RL myTimeBeg
#endif /* ALLOW_LONGSTEP */
CEOP

#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_ENTER('FORWARD_STEP',myThid)
#endif

#ifdef ALLOW_AUTODIFF
C--   Reset the model iteration counter and the model time.
      myIter = nIter0 + (iloop-1)
      myTime = startTime + deltaTClock*(iLoop-1)
#endif

#ifdef ALLOW_AUTODIFF
      CALL AUTODIFF_INADMODE_UNSET( myTime, myIter, myThid )
#endif

#ifdef ALLOW_LONGSTEP
C     store this for longstep_average with staggerTimeStep
C     which is called after myIter and myTime are incremented
C     but needs iter/time at beginning of time step
      myIterBeg = myIter
      myTimeBeg = myTime
#endif /* ALLOW_LONGSTEP */

#ifdef ALLOW_AUTODIFF_TAMC
c**************************************
#include "checkpoint_lev1_directives.h"
#include "checkpoint_lev1_template.h"
c**************************************
#endif

#ifdef ALLOW_SHELFICE_REMESHING
      IF ( useShelfIce ) THEN
C--   Remesh shelfice
        CALL TIMER_START('SHELFICE_REMESHING     [FORWARD_STEP]',myThid)
        CALL SHELFICE_REMESHING ( myTime, myIter, myThid )
        CALL TIMER_STOP('SHELFICE_REMESHING     [FORWARD_STEP]',myThid)
      ENDIF
#endif /* ALLOW_SHELFICE_REMESHING */

C--   Reset geometric factors (hFacC,W,S & recip_hFac) to their current values:
C     added to simplify adjoint derivation - no effect in forward run
#ifdef NONLIN_FRSURF
#ifndef ALLOW_AUTODIFF
      IF ( doResetHFactors ) THEN
#endif
       CALL RESET_NLFS_VARS( myTime, myIter, myThid )
       IF ( select_rStar.GT.0 ) THEN
# ifndef DISABLE_RSTAR_CODE
# ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE rStarFacC, rStarFacS, rStarFacW =
CADJ &     comlev1, key = ikey_dynamics, kind = isbyte
# endif
        CALL TIMER_START('UPDATE_R_STAR       [FORWARD_STEP]',myThid)
        CALL UPDATE_R_STAR( .FALSE., myTime, myIter, myThid )
        CALL TIMER_STOP ('UPDATE_R_STAR       [FORWARD_STEP]',myThid)
# endif /* DISABLE_RSTAR_CODE */
       ELSE
#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE hFac_surfC, hFac_surfS, hFac_surfW
CADJ &     = comlev1, key = ikey_dynamics, kind = isbyte
#endif
        CALL TIMER_START('UPDATE_SURF_DR      [FORWARD_STEP]',myThid)
        CALL UPDATE_SURF_DR( .FALSE., myTime, myIter, myThid )
        CALL TIMER_STOP ('UPDATE_SURF_DR      [FORWARD_STEP]',myThid)
       ENDIF
#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE hFacC, hFacS, hFacW =
CADJ &     comlev1, key = ikey_dynamics, kind = isbyte
CADJ STORE recip_hFacC, recip_hFacS, recip_hFacW  =
CADJ &     comlev1, key = ikey_dynamics, kind = isbyte
#endif
#ifndef ALLOW_AUTODIFF
      ENDIF
#endif
#endif /* NONLIN_FRSURF */

#ifdef ALLOW_PTRACERS
C--   Switch on/off individual tracer time-stepping
      IF ( usePTRACERS ) THEN
        CALL PTRACERS_SWITCH_ONOFF( myTime, myIter, myThid )
      ENDIF
#endif /* ALLOW_PTRACERS */

C--   Switch on/off diagnostics for snap-shot output:
#ifdef ALLOW_DIAGNOSTICS
      IF ( useDiagnostics ) THEN
        CALL DIAGNOSTICS_SWITCH_ONOFF( 1, myTime, myIter, myThid )
C--   State-variables diagnostics
        CALL TIMER_START('DO_STATEVARS_DIAGS  [FORWARD_STEP]',myThid)
        CALL DO_STATEVARS_DIAGS( myTime, 0, myIter, myThid )
        CALL TIMER_STOP ('DO_STATEVARS_DIAGS  [FORWARD_STEP]',myThid)
      ENDIF
#endif /* ALLOW_DIAGNOSTICS */

#ifdef ALLOW_NEST_CHILD
      IF ( useNEST_CHILD) THEN
        CALL NEST_CHILD_SETMEMO( myTime, myIter, myThid )
      ENDIF
#endif /* ALLOW_NEST_CHILD */

#ifdef ALLOW_NEST_PARENT
      IF ( useNEST_PARENT) THEN
        CALL NEST_PARENT_IO_1( myTime, myIter, myThid )
      ENDIF
#endif /* ALLOW_NEST_PARENT */

C--   Call driver to load external forcing fields from file
#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_CALL('LOAD_FIELDS_DRIVER',myThid)
#endif
#ifdef ALLOW_AUTODIFF_TAMC
cph Important STORE that avoids hidden recomp. of load_fields_driver
CADJ STORE theta      = comlev1, key = ikey_dynamics,
CADJ &     kind = isbyte
CADJ STORE uVel, vVel = comlev1, key = ikey_dynamics,
CADJ &     kind = isbyte
#endif
      CALL TIMER_START('LOAD_FIELDS_DRIVER  [FORWARD_STEP]',myThid)
      CALL LOAD_FIELDS_DRIVER( myTime, myIter, myThid )
      CALL TIMER_STOP ('LOAD_FIELDS_DRIVER  [FORWARD_STEP]',myThid)

C--   Call Bulk-Formulae forcing package
#ifdef ALLOW_BULK_FORCE
      IF ( useBulkForce ) THEN
#ifdef ALLOW_DEBUG
        IF (debugMode) CALL DEBUG_CALL('BULKF_FORCING',myThid)
#endif
        CALL TIMER_START('BULKF_FORCING       [FORWARD_STEP]',myThid)
C-    calculate qnet and empmr (and wind stress)
        CALL BULKF_FORCING( myTime, myIter, myThid )
        CALL TIMER_STOP ('BULKF_FORCING       [FORWARD_STEP]',myThid)
      ENDIF
#endif /* ALLOW_BULK_FORCE */

C--   Call external chepaml forcing package
#ifdef ALLOW_CHEAPAML
      IF ( useCheapAML  ) THEN
#ifdef ALLOW_DEBUG
        IF (debugMode) CALL DEBUG_CALL('CHEAPAML',myThid)
#endif
        CALL TIMER_START('CHEAPAML      [FORWARD_STEP]',myThid)
C-    calculate qnet (and wind stress)
        CALL CHEAPAML( myTime, myIter,myThid )
        CALL TIMER_STOP ('CHEAPAML      [FORWARD_STEP]',myThid)
      ENDIF
#endif /*ALLOW_CHEAPAML */

#ifdef ALLOW_CTRL
C--   Add control vector for forcing and parameter fields
      IF ( useCTRL ) THEN
       CALL TIMER_START('CTRL_MAP_FORCING  [FORWARD_STEP]',myThid)
       CALL CTRL_MAP_FORCING( myTime, myIter, myThid )
       CALL TIMER_STOP ('CTRL_MAP_FORCING  [FORWARD_STEP]',myThid)
      ENDIF
#endif

#ifdef ALLOW_AUTODIFF_MONITOR
      CALL DUMMY_IN_STEPPING( myTime, myIter, myThid )
#endif

#ifdef COMPONENT_MODULE
      IF ( useCoupler ) THEN
C      Post coupling data that I export.
C      Read in coupling data that I import.
         CALL TIMER_START('CPL_EXPORT-IMPORT  [FORWARD_STEP]',myThid)
         CALL CPL_EXPORT_IMPORT_DATA( myTime, myIter, myThid )
         CALL TIMER_STOP ('CPL_EXPORT-IMPORT  [FORWARD_STEP]',myThid)
      ENDIF
#endif /* COMPONENT_MODULE */
#ifdef ALLOW_OASIS
      IF ( useOASIS ) THEN
       CALL TIMER_START('OASIS_PUT-GET  [FORWARD_STEP]',myThid)
C      Post coupling data that I export.
       CALL OASIS_PUT( myTime, myIter, myThid )
C      Read in coupling data that I import.
       CALL OASIS_GET( myTime, myIter, myThid )
       CALL TIMER_STOP ('OASIS_PUT-GET  [FORWARD_STEP]',myThid)
      ENDIF
#endif /* ALLOW_OASIS */

#ifdef ALLOW_EBM
      IF ( useEBM ) THEN
# ifdef ALLOW_DEBUG
        IF (debugMode) CALL DEBUG_CALL('EBM',myThid)
# endif
        CALL TIMER_START('EBM                [FORWARD_STEP]',myThid)
        CALL EBM_DRIVER ( myTime, myIter, myThid )
        CALL TIMER_STOP ('EBM                [FORWARD_STEP]',myThid)
      ENDIF
#endif /* ALLOW_EBM */

#ifdef ALLOW_AUTODIFF_TAMC
C******************************************************
C     Store surface forcing fields if required to avoid
C     calling load_fields_driver in forward_step_ad
# include "check_lev1_dir_forcing.h"
C******************************************************
#endif /* ALLOW_AUTODIFF_TAMC */

C--     Step forward fields and calculate time tendency terms.

#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_CALL('DO_ATMOSPHERIC_PHYS',myThid)
#endif
      CALL TIMER_START('DO_ATMOSPHERIC_PHYS [FORWARD_STEP]',myThid)
      CALL DO_ATMOSPHERIC_PHYS( myTime, myIter, myThid )
      CALL TIMER_STOP ('DO_ATMOSPHERIC_PHYS [FORWARD_STEP]',myThid)

#ifdef ALLOW_AUTODIFF_TAMC
# ifdef ALLOW_KPP
CADJ STORE uVel, vVel = comlev1, key = ikey_dynamics, kind = isbyte
# endif /* ALLOW_KPP */
CADJ STORE EmPmR      = comlev1, key = ikey_dynamics, kind = isbyte
CADJ STORE PmEpR      = comlev1, key = ikey_dynamics, kind = isbyte
# ifdef ALLOW_OBCS
CADJ STORE salt       = comlev1, key = ikey_dynamics, kind = isbyte
CADJ STORE totphihyd  = comlev1, key = ikey_dynamics, kind = isbyte
# endif /* ALLOW_OBCS */
# ifdef ALLOW_PTRACERS
CADJ STORE pTracer    = comlev1, key = ikey_dynamics, kind = isbyte
# endif /* ALLOW_PTRACERS */
# ifdef ALLOW_DEPTH_CONTROL
CADJ STORE hFacC      = comlev1, key = ikey_dynamics, kind = isbyte
#  ifdef ALLOW_SEAICE
CADJ STORE hFacS      = comlev1, key = ikey_dynamics, kind = isbyte
CADJ STORE hFacW      = comlev1, key = ikey_dynamics, kind = isbyte
CADJ STORE recip_hFacC= comlev1, key = ikey_dynamics, kind = isbyte
#  endif
# endif
#endif /* ALLOW_AUTODIFF_TAMC */

#ifdef ALLOW_DEBUG
       IF (debugMode) CALL DEBUG_CALL('DO_OCEANIC_PHYS',myThid)
#endif
       CALL TIMER_START('DO_OCEANIC_PHYS     [FORWARD_STEP]',myThid)
       CALL DO_OCEANIC_PHYS( myTime, myIter, myThid )
       CALL TIMER_STOP ('DO_OCEANIC_PHYS     [FORWARD_STEP]',myThid)

#ifdef ALLOW_STREAMICE
       IF (useStreamIce) THEN
         CALL STREAMICE_TIMESTEP ( myThid, myIter,
     &                             iLoop, myTime )
       ENDIF
#endif

#ifdef ALLOW_AUTODIFF_TAMC
C***********************************************************************
C     This block of store directives is for variables that have been
C     computed in do_oceanics_phys. Storing them here avoids calling
C     do_oceanic_phys again in forward_step_ad, which should improve
C     performance because expensive parts of the model are not
C     recomputed (e.g. seaice).
# include "check_lev1_dir_ocephys.h"
C***********************************************************************
#endif /* ALLOW_AUTODIFF_TAMC */

#ifdef GCHEM_ADD2TR_TENDENCY
#ifndef ALLOW_AUTODIFF
      IF ( useGCHEM ) THEN
#endif
#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE pTracer     = comlev1, key=ikey_dynamics, kind=isbyte
CADJ STORE theta, salt = comlev1, key=ikey_dynamics, kind=isbyte
#endif
#ifdef ALLOW_DEBUG
        IF (debugMode) CALL DEBUG_CALL('GCHEM_CALC_TENDENCY',myThid)
#endif
        CALL TIMER_START('GCHEM_CALC_TENDENCY [FORWARD_STEP]',myThid)
        CALL GCHEM_CALC_TENDENCY( myTime, myIter, myThid )
        CALL TIMER_STOP ('GCHEM_CALC_TENDENCY [FORWARD_STEP]',myThid)
#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE gchemTendency = comlev1, key=ikey_dynamics, kind=isbyte
#endif
#ifndef ALLOW_AUTODIFF
      ENDIF
#endif
#endif /* GCHEM_ADD2TR_TENDENCY */

#ifdef ALLOW_LONGSTEP
      IF ( usePTRACERS .AND. LS_whenToSample .EQ. 0 ) THEN
C       Average all variables before advection (but after do_oceanic_phys
C       where Qsw, KPP and GMRedi stuff is computed).
C       This is like diagnostics package and will reproduce offline
C       results.
#ifdef ALLOW_DEBUG
        IF (debugMode) CALL DEBUG_CALL('LONGSTEP_AVERAGE',myThid)
#endif
        CALL TIMER_START('LONGSTEP_AVERAGE    [FORWARD_STEP]',myThid)
        CALL LONGSTEP_AVERAGE( myTime, myIter, myThid )
        CALL TIMER_STOP ('LONGSTEP_AVERAGE    [FORWARD_STEP]',myThid)

#ifdef ALLOW_DEBUG
        IF (debugMode)
     &    CALL DEBUG_CALL('LONGSTEP_THERMODYNAMICS',myThid)
#endif
        CALL TIMER_START('LONGSTEP_THERMODYNAMICS      [FORWARD_STEP]',
     &                   myThid)
        CALL LONGSTEP_THERMODYNAMICS( myTime, myIter, myThid )
        CALL TIMER_STOP ('LONGSTEP_THERMODYNAMICS      [FORWARD_STEP]',
     &                    myThid)
      ENDIF
#endif /* ALLOW_LONGSTEP */

      IF ( .NOT.staggerTimeStep ) THEN
#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE wVel = comlev1, key = ikey_dynamics, kind = isbyte
#endif
#ifdef ALLOW_DEBUG
        IF (debugMode) CALL DEBUG_CALL('THERMODYNAMICS',myThid)
#endif
        CALL TIMER_START('THERMODYNAMICS      [FORWARD_STEP]',myThid)
        CALL THERMODYNAMICS( myTime, myIter, myThid )
        CALL TIMER_STOP ('THERMODYNAMICS      [FORWARD_STEP]',myThid)
C--     if not staggerTimeStep: end
      ENDIF
#if (defined ALLOW_AUTODIFF_TAMC) && (defined ALLOW_OBCS)
CADJ STORE salt, theta = comlev1, key = ikey_dynamics, kind = isbyte
#endif /* ALLOW_AUTODIFF_TAMC && ALLOW_OBCS */

#ifdef ALLOW_LONGSTEP
      IF ( usePTRACERS .AND. LS_whenToSample .EQ. 1 ) THEN
C       Average T and S after thermodynamics, but U,V,W before dynamics.
C       This will reproduce online results with staggerTimeStep=.FALSE.
C       for LS_nIter=1
#ifdef ALLOW_DEBUG
        IF (debugMode) CALL DEBUG_CALL('LONGSTEP_AVERAGE',myThid)
#endif
        CALL TIMER_START('LONGSTEP_AVERAGE    [FORWARD_STEP]',myThid)
        CALL LONGSTEP_AVERAGE( myTime, myIter, myThid )
        CALL TIMER_STOP ('LONGSTEP_AVERAGE    [FORWARD_STEP]',myThid)

#ifdef ALLOW_DEBUG
        IF (debugMode)
     &    CALL DEBUG_CALL('LONGSTEP_THERMODYNAMICS',myThid)
#endif
        CALL TIMER_START('LONGSTEP_THERMODYNAMICS      [FORWARD_STEP]',
     &                   myThid)
        CALL LONGSTEP_THERMODYNAMICS( myTime, myIter, myThid )
        CALL TIMER_STOP ('LONGSTEP_THERMODYNAMICS      [FORWARD_STEP]',
     &                   myThid)
      ENDIF
#endif /* ALLOW_LONGSTEP */

c #ifdef ALLOW_NONHYDROSTATIC
      IF ( implicitIntGravWave ) THEN
        CALL TIMER_START('BLOCKING_EXCHANGES  [FORWARD_STEP]',myThid)
        CALL DO_STAGGER_FIELDS_EXCHANGES( myTime, myIter, myThid )
        CALL TIMER_STOP ('BLOCKING_EXCHANGES  [FORWARD_STEP]',myThid)
      ENDIF
c #endif

#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE etaN = comlev1, key = ikey_dynamics, kind = isbyte
# ifdef ALLOW_DEPTH_CONTROL
CADJ STORE hFacC, hFacS, hFacW
CADJ &     = comlev1, key = ikey_dynamics, kind = isbyte
CADJ STORE recip_hFacC, recip_hFacS, recip_hFacW
CADJ &     = comlev1, key = ikey_dynamics, kind = isbyte
# endif /* ALLOW_DEPTH_CONTROL */
#endif /* ALLOW_AUTODIFF_TAMC */

C--   Step forward fields and calculate time tendency terms.
#ifdef ALLOW_MOM_STEPPING
#ifndef ALLOW_AUTODIFF
      IF ( momStepping ) THEN
#endif
#ifdef ALLOW_DEBUG
        IF (debugMode) CALL DEBUG_CALL('DYNAMICS',myThid)
#endif
        CALL TIMER_START('DYNAMICS            [FORWARD_STEP]',myThid)
        CALL DYNAMICS( myTime, myIter, myThid )
        CALL TIMER_STOP ('DYNAMICS            [FORWARD_STEP]',myThid)
#ifndef ALLOW_AUTODIFF
      ENDIF
#endif
#endif /* ALLOW_MOM_STEPPING */

#ifdef ALLOW_AUTODIFF_TAMC
# if (defined NONLIN_FRSURF) || (defined ALLOW_DEPTH_CONTROL)
CADJ STORE gU, gV  = comlev1, key = ikey_dynamics,
CADJ &     kind = isbyte
# endif
#endif

C--   Update time-counter
      myIter = nIter0 + iLoop
      myTime = startTime + deltaTClock*iLoop

#ifdef ALLOW_MNC
C     Update MNC time information
      IF ( useMNC ) THEN
         CALL MNC_UPDATE_TIME( myTime, myIter, myThid )
      ENDIF
#endif /* ALLOW_MNC */

#ifdef ALLOW_OFFLINE
C     Load new Offline fields and update state-variable
      IF ( useOffLine ) THEN
#ifdef ALLOW_DEBUG
        IF (debugMode) CALL DEBUG_CALL('OFFLINE_FIELDS_LOAD',myThid)
#endif /* ALLOW_DEBUG */
        CALL TIMER_START('OFFLINE_FLDS_LOAD   [FORWARD_STEP]',myThid)
        CALL OFFLINE_FIELDS_LOAD( myTime, myIter, myThid )
        CALL TIMER_STOP ('OFFLINE_FLDS_LOAD   [FORWARD_STEP]',myThid)
      ENDIF
#endif /* ALLOW_OFFLINE */

C--   Update geometric factors:
#ifdef NONLIN_FRSURF
C-    update hfacC,W,S and recip_hFac according to etaH(n+1) :
      IF ( select_rStar.GT.0 ) THEN
# ifndef DISABLE_RSTAR_CODE
# ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE rStarFacC, rStarFacS, rStarFacW =
CADJ &     comlev1, key = ikey_dynamics, kind = isbyte
# endif
        CALL TIMER_START('UPDATE_R_STAR       [FORWARD_STEP]',myThid)
        CALL UPDATE_R_STAR( .TRUE., myTime, myIter, myThid )
        CALL TIMER_STOP ('UPDATE_R_STAR       [FORWARD_STEP]',myThid)
# endif /* DISABLE_RSTAR_CODE */
      ELSEIF ( selectSigmaCoord.NE.0 ) THEN
# ifndef DISABLE_SIGMA_CODE
        CALL UPDATE_SIGMA( etaH, myTime, myIter, myThid )
# endif /* DISABLE_RSTAR_CODE */
      ELSE
# ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE hFac_surfC, hFac_surfS, hFac_surfW
CADJ &     = comlev1, key = ikey_dynamics, kind = isbyte
# endif
        CALL TIMER_START('UPDATE_SURF_DR      [FORWARD_STEP]',myThid)
        CALL UPDATE_SURF_DR( .TRUE., myTime, myIter, myThid )
        CALL TIMER_STOP ('UPDATE_SURF_DR      [FORWARD_STEP]',myThid)
      ENDIF
# ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE hFacC, hFacS, hFacW =
CADJ &     comlev1, key = ikey_dynamics, kind = isbyte
CADJ STORE recip_hFacC, recip_hFacS, recip_hFacW  =
CADJ &     comlev1, key = ikey_dynamics, kind = isbyte
# endif
#endif /* NONLIN_FRSURF */

#if ( defined NONLIN_FRSURF || defined ALLOW_SOLVE4_PS_AND_DRAG || \
      defined ALLOW_CG2D_NSA || defined ALLOW_DEPTH_CONTROL )
C-    update CG2D matrix (and preconditioner)
      IF ( momStepping .AND.
     &     ( nonlinFreeSurf.GT.2 .OR. selectImplicitDrag.EQ.2 ) ) THEN
        CALL TIMER_START('UPDATE_CG2D         [FORWARD_STEP]',myThid)
        CALL UPDATE_CG2D( myTime, myIter, myThid )
        CALL TIMER_STOP ('UPDATE_CG2D         [FORWARD_STEP]',myThid)
      ENDIF
# ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE aW2d, aS2d, aC2d, pC, pS, pW =
CADJ &     comlev1, key = ikey_dynamics, kind = isbyte
# endif
#endif /* NONLIN_FRSURF or ALLOW_SOLVE4_PS_AND_DRAG */

C--   Apply Filters to u*,v* before SOLVE_FOR_PRESSURE
#ifdef ALLOW_SHAP_FILT
      IF (useSHAP_FILT .AND. shap_filt_uvStar) THEN
        CALL TIMER_START('SHAP_FILT_UV        [FORWARD_STEP]',myThid)
        CALL SHAP_FILT_APPLY_UV( gU, gV, myTime, myIter, myThid )
        CALL TIMER_STOP ('SHAP_FILT_UV        [FORWARD_STEP]',myThid)
      ENDIF
#endif
#ifdef ALLOW_ZONAL_FILT
      IF (useZONAL_FILT .AND. zonal_filt_uvStar) THEN
        CALL TIMER_START('ZONAL_FILT_UV       [FORWARD_STEP]',myThid)
        CALL ZONAL_FILT_APPLY_UV( gU, gV, myThid )
        CALL TIMER_STOP ('ZONAL_FILT_UV       [FORWARD_STEP]',myThid)
      ENDIF
#endif

C--   Solve elliptic equation(s).
C     Two-dimensional only for conventional hydrostatic or
C     three-dimensional for non-hydrostatic and/or IGW scheme.
      IF ( momStepping ) THEN
#ifdef ALLOW_AUTODIFF_TAMC
# if (defined NONLIN_FRSURF) || (defined ALLOW_DEPTH_CONTROL)
CADJ STORE hFacS, hFacW = comlev1, key = ikey_dynamics, kind = isbyte
# endif
#endif
        CALL TIMER_START('SOLVE_FOR_PRESSURE  [FORWARD_STEP]',myThid)
        CALL SOLVE_FOR_PRESSURE( myTime, myIter, myThid )
        CALL TIMER_STOP ('SOLVE_FOR_PRESSURE  [FORWARD_STEP]',myThid)
      ENDIF

C--   Correct divergence in flow field and cycle time-stepping momentum
#ifdef ALLOW_MOM_STEPPING
#ifndef ALLOW_AUTODIFF
      IF ( momStepping ) THEN
#endif
        CALL TIMER_START('MOM_CORRECTION_STEP [FORWARD_STEP]',myThid)
        CALL MOMENTUM_CORRECTION_STEP( myTime, myIter, myThid )
        CALL TIMER_STOP ('MOM_CORRECTION_STEP [FORWARD_STEP]',myThid)
#ifndef ALLOW_AUTODIFF
      ENDIF
#endif
#endif /* ALLOW_MOM_STEPPING */
#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE uVel, vVel = comlev1, key = ikey_dynamics, kind = isbyte
#endif

      IF ( calc_wVelocity ) THEN
C--     Integrate continuity vertically for vertical velocity
C       (+ update "etaN" & "etaH", exact volume conservation):
        CALL TIMER_START('INTEGR_CONTINUITY   [FORWARD_STEP]',myThid)
        CALL INTEGR_CONTINUITY( uVel, vVel, myTime, myIter, myThid)
        CALL TIMER_STOP ('INTEGR_CONTINUITY   [FORWARD_STEP]',myThid)
      ENDIF
#ifdef ALLOW_AUTODIFF_TAMC
C--   These store directives avoid an (expensive) extra
C     "call solve_for_pressure" in forward_step_ad
CADJ STORE wVel = comlev1, key = ikey_dynamics, kind = isbyte
CADJ STORE etaN = comlev1, key = ikey_dynamics, kind = isbyte
#endif

#ifdef NONLIN_FRSURF
      IF ( select_rStar.NE.0 ) THEN
# ifndef DISABLE_RSTAR_CODE
#  ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE etaH
CADJ &     = comlev1, key = ikey_dynamics, kind = isbyte
CADJ STORE rStarFacC,rStarFacS,rStarFacW
CADJ &     = comlev1, key = ikey_dynamics, kind = isbyte
#  endif
C--   r* : compute the future level thickness according to etaH(n+1)
        CALL TIMER_START('CALC_R_STAR         [FORWARD_STEP]',myThid)
        CALL CALC_R_STAR(etaH, myTime, myIter, myThid )
        CALL TIMER_STOP ('CALC_R_STAR         [FORWARD_STEP]',myThid)
# endif /* DISABLE_RSTAR_CODE */
      ELSEIF ( nonlinFreeSurf.GT.0 .AND. selectSigmaCoord.EQ.0 ) THEN
C--   compute the future surface level thickness according to etaH(n+1)
# ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE etaH          = comlev1, key = ikey_dynamics,
CADJ &     kind = isbyte
# endif
        CALL TIMER_START('CALC_SURF_DR      [FORWARD_STEP]',myThid)
        CALL CALC_SURF_DR(etaH, myTime, myIter, myThid )
        CALL TIMER_STOP ('CALC_SURF_DR      [FORWARD_STEP]',myThid)
      ENDIF
# ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE rStarExpC
CADJ &     = comlev1, key = ikey_dynamics, kind = isbyte
CADJ STORE hFac_surfC       = comlev1, key = ikey_dynamics,
CADJ &     kind = isbyte
CADJ STORE salt,theta = comlev1, key = ikey_dynamics,
CADJ &     kind = isbyte
#  ifdef ALLOW_PTRACERS
CADJ STORE pTracer    = comlev1, key = ikey_dynamics, kind = isbyte
#  endif /* ALLOW_PTRACERS */
# endif
#endif /* NONLIN_FRSURF */

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
      IF ( staggerTimeStep ) THEN
C--   do exchanges of U,V (needed for multiDim) when using stagger time-step :
#ifdef ALLOW_DEBUG
        IF (debugMode)
     &   CALL DEBUG_CALL('DO_STAGGER_FIELDS_EXCH.',myThid)
#endif
        CALL TIMER_START('BLOCKING_EXCHANGES  [FORWARD_STEP]',myThid)
        CALL DO_STAGGER_FIELDS_EXCHANGES( myTime, myIter, myThid )
        CALL TIMER_STOP ('BLOCKING_EXCHANGES  [FORWARD_STEP]',myThid)

#ifdef ALLOW_DIAGNOSTICS
C--   State-variables diagnostics
        IF ( useDiagnostics ) THEN
          CALL TIMER_START('DO_STATEVARS_DIAGS  [FORWARD_STEP]',myThid)
          CALL DO_STATEVARS_DIAGS( myTime, 1, myIter, myThid )
          CALL TIMER_STOP ('DO_STATEVARS_DIAGS  [FORWARD_STEP]',myThid)
        ENDIF
#endif

#ifdef ALLOW_AUTODIFF_TAMC
C     these store directives prevent calling do_stagger_fields_exchanges
C     again in the AD-part of forward_step_ad
CADJ STORE salt, theta = comlev1, key = ikey_dynamics, kind = isbyte
CADJ STORE wVel        = comlev1, key = ikey_dynamics, kind = isbyte
#endif
#ifdef ALLOW_DEBUG
        IF (debugMode) CALL DEBUG_CALL('THERMODYNAMICS',myThid)
#endif
        CALL TIMER_START('THERMODYNAMICS      [FORWARD_STEP]',myThid)
        CALL THERMODYNAMICS( myTime, myIter, myThid )
        CALL TIMER_STOP ('THERMODYNAMICS      [FORWARD_STEP]',myThid)

C--    if staggerTimeStep: end
      ENDIF
#ifdef ALLOW_AUTODIFF_TAMC
C     this may not be necessary, but it does not do any harm (i.e. it is
C     ignored by TAF if not needed)
CADJ STORE salt, theta = comlev1, key = ikey_dynamics, kind = isbyte
#endif /* ALLOW_AUTODIFF_TAMC */
C---+--------+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#ifdef ALLOW_AUTODIFF_TAMC
cph This is needed because convective_adjustment calls
cph find_rho which may use pressure()
CADJ STORE totPhiHyd  = comlev1, key = ikey_dynamics,
CADJ &     kind = isbyte
#endif
C--   Apply adjustments to Tracers arrays (T,S,+pTracers)
      CALL TIMER_START('TRC_CORRECTION_STEP [FORWARD_STEP]',myThid)
      CALL TRACERS_CORRECTION_STEP(myTime, myIter, myThid)
      CALL TIMER_STOP ('TRC_CORRECTION_STEP [FORWARD_STEP]',myThid)

#ifdef ALLOW_LONGSTEP
      IF ( usePTRACERS ) THEN
       IF ( LS_whenToSample .EQ. 2 ) THEN
C       Average everything at the end of the timestep.  This will
C       reproduce online results with staggerTimeStep=.TRUE.
C       when LS_nIter=1
#ifdef ALLOW_DEBUG
        IF (debugMode) CALL DEBUG_CALL('LONGSTEP_AVERAGE',myThid)
#endif
        CALL TIMER_START('LONGSTEP_AVERAGE    [FORWARD_STEP]',myThid)
C       myIter has been update after dynamics, but the averaging window
C       should be determined by myIter at beginning of timestep
        CALL LONGSTEP_AVERAGE( myTimeBeg, myIterBeg, myThid )
        CALL TIMER_STOP ('LONGSTEP_AVERAGE    [FORWARD_STEP]',myThid)

#ifdef ALLOW_DEBUG
        IF (debugMode)
     &    CALL DEBUG_CALL('LONGSTEP_THERMODYNAMICS',myThid)
#endif
        CALL TIMER_START('LONGSTEP_THERMODYNAMICS      [FORWARD_STEP]',
     &                   myThid)
        CALL LONGSTEP_THERMODYNAMICS( myTime, myIter, myThid )
        CALL TIMER_STOP ('LONGSTEP_THERMODYNAMICS      [FORWARD_STEP]',
     &                   myThid)
C--    if LS_whenToSample.EQ.2: end
       ENDIF

C--   Apply adjustments to passive Tracers arrays (pTracers)
c      CALL TIMER_START('LS_CORRECTION_STEP  [FORWARD_STEP]',myThid)
c      CALL LONGSTEP_CORRECTION_STEP(myTime, myIter, myThid)
c      CALL TIMER_STOP ('LS_CORRECTION_STEP  [FORWARD_STEP]',myThid)
C--    if usePTRACERS: end
      ENDIF
#endif /* ALLOW_LONGSTEP */

#ifdef ALLOW_GCHEM
C     Add separate timestepping of chemical/biological/forcing
C     of ptracers here in GCHEM_FORCING_SEP
#ifdef ALLOW_LONGSTEP
      IF ( useGCHEM .AND. LS_doTimeStep ) THEN
#else
      IF ( useGCHEM ) THEN
#endif
# ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE theta, salt = comlev1, key = ikey_dynamics, kind = isbyte
#  ifdef ALLOW_PTRACERS
CADJ STORE pTracer     = comlev1, key = ikey_dynamics, kind = isbyte
#  endif /* ALLOW_PTRACERS */
# endif
#ifdef ALLOW_DEBUG
        IF (debugMode) CALL DEBUG_CALL('GCHEM_FORCING_SEP',myThid)
#endif /* ALLOW_DEBUG */
        CALL TIMER_START('GCHEM_FORCING_SEP  [FORWARD_STEP]',myThid)
        CALL GCHEM_FORCING_SEP( myTime,myIter,myThid )
        CALL TIMER_STOP ('GCHEM_FORCING_SEP  [FORWARD_STEP]',myThid)
      ENDIF
#endif /* ALLOW_GCHEM */

C--   Do "blocking" sends and receives for tendency "overlap" terms
c     CALL TIMER_START('BLOCKING_EXCHANGES  [FORWARD_STEP]',myThid)
c     CALL DO_GTERM_BLOCKING_EXCHANGES( myThid )
c     CALL TIMER_STOP ('BLOCKING_EXCHANGES  [FORWARD_STEP]',myThid)

C--   Do "blocking" sends and receives for field "overlap" terms
      CALL TIMER_START('BLOCKING_EXCHANGES  [FORWARD_STEP]',myThid)
      CALL DO_FIELDS_BLOCKING_EXCHANGES( myThid )
      CALL TIMER_STOP ('BLOCKING_EXCHANGES  [FORWARD_STEP]',myThid)
#ifdef ALLOW_AUTODIFF_TAMC
C     These store directives avoid extra subroutine calls, for example,
C     thermodynamics, tracers_correction_step, gchem_forcing_sep, and
C     do_fields_blocking_exchages
CADJ STORE theta, salt = comlev1, key = ikey_dynamics, kind = isbyte
CADJ STORE uvel,  vvel = comlev1, key = ikey_dynamics, kind = isbyte
CADJ STORE totPhiHyd   = comlev1, key = ikey_dynamics, kind = isbyte
# ifdef ALLOW_PTRACERS
CADJ STORE pTracer     = comlev1, key = ikey_dynamics, kind = isbyte
# endif
#endif

#ifdef ALLOW_DIAGNOSTICS
      IF ( useDiagnostics ) THEN
       CALL TIMER_START('DO_STATEVARS_DIAGS  [FORWARD_STEP]',myThid)
       CALL DO_STATEVARS_DIAGS( myTime, 2, myIter, myThid )
       CALL TIMER_STOP ('DO_STATEVARS_DIAGS  [FORWARD_STEP]',myThid)
      ENDIF
#endif

#ifdef ALLOW_GRIDALT
      IF (useGRIDALT) THEN
         CALL GRIDALT_UPDATE(myThid)
      ENDIF
#endif

#ifdef ALLOW_FIZHI
      IF (useFIZHI) THEN
         CALL TIMER_START('FIZHI               [FORWARD_STEP]',myThid)
         CALL STEP_FIZHI_CORR ( myTime, myIter, myThid, dTtracerLev(1) )
         CALL TIMER_STOP ('FIZHI               [FORWARD_STEP]',myThid)
      ENDIF
#endif

#ifdef ALLOW_FLT
C--   Calculate float trajectories
      IF (useFLT) THEN
        CALL TIMER_START('FLOATS            [FORWARD_STEP]',myThid)
        CALL FLT_MAIN( myTime, myIter, myThid )
        CALL TIMER_STOP ('FLOATS            [FORWARD_STEP]',myThid)
      ENDIF
#endif

#ifdef ALLOW_NEST_PARENT
      IF ( useNEST_PARENT) THEN
        CALL NEST_PARENT_IO_2( myTime, myIter, myThid )
      ENDIF
#endif /* ALLOW_NEST_PARENT */

#ifdef ALLOW_NEST_CHILD
      IF ( useNEST_CHILD) THEN
            CALL NEST_CHILD_TRANSP( myTime, myIter, myThid )
      ENDIF
#endif /* ALLOW_NEST_CHILD */

#ifdef ALLOW_MONITOR
      IF ( monitorFreq.GT.0. .OR. adjMonitorFreq.GT.0. ) THEN
C--   Check status of solution (statistics, cfl, etc...)
        CALL TIMER_START('MONITOR             [FORWARD_STEP]',myThid)
        CALL MONITOR( myTime, myIter, myThid )
        CALL TIMER_STOP ('MONITOR             [FORWARD_STEP]',myThid)
      ENDIF
#endif /* ALLOW_MONITOR */

#ifdef ALLOW_COST
C--     compare model with data and compute cost function
C--     this is done after exchanges to allow interpolation
      CALL TIMER_START('COST_TILE           [FORWARD_STEP]',myThid)
      CALL COST_TILE  ( myTime, myIter, myThid )
      CALL TIMER_STOP ('COST_TILE           [FORWARD_STEP]',myThid)
#endif

#ifdef ALLOW_ECCO
C--   Diagnose variables for pkg/ecco averaging and cost function purposes
      IF ( useECCO ) CALL ECCO_PHYS( myTime, myIter, myThid )
#endif

C--   Check if it has reached the end of simulation
      modelEnd = myTime.EQ.endTime .OR. myIter.EQ.nEndIter
#ifdef HAVE_SIGREG
      IF ( useSIGREG ) THEN
        modelEnd = modelEnd .OR. ( i_got_signal.GT.0 )
      ENDIF
#endif /* HAVE_SIGREG */

C--   Do IO if needed.
      CALL TIMER_START('DO_THE_MODEL_IO     [FORWARD_STEP]',myThid)
      CALL DO_THE_MODEL_IO( modelEnd, myTime, myIter, myThid )
      CALL TIMER_STOP ('DO_THE_MODEL_IO     [FORWARD_STEP]',myThid)

#ifdef ALLOW_PTRACERS
C     Reset the ptracers (but after the io is done)
      IF ( usePTRACERS ) THEN
        CALL TIMER_START('PTRACERS_RESET      [FORWARD_STEP]',myThid)
        CALL PTRACERS_RESET( myTime, myIter, myThid )
        CALL TIMER_STOP ('PTRACERS_RESET      [FORWARD_STEP]',myThid)
      ENDIF
#endif /* ALLOW_PTRACERS */

C--   Save state for restarts
      CALL TIMER_START('DO_WRITE_PICKUP     [FORWARD_STEP]',myThid)
      CALL DO_WRITE_PICKUP( modelEnd, myTime, myIter, myThid )
      CALL TIMER_STOP ('DO_WRITE_PICKUP     [FORWARD_STEP]',myThid)

#ifdef HAVE_SIGREG
      IF ( useSIGREG ) THEN
        IF ( modelEnd .AND. i_got_signal.GT.0 ) THEN
          STOP 'Checkpoint completed -- killed by signal handler'
        ENDIF
      ENDIF
#endif /* HAVE_SIGREG */

#ifdef ALLOW_AUTODIFF
      CALL AUTODIFF_INADMODE_SET( myTime, myIter, myThid )
#endif

#ifdef ALLOW_SHOWFLOPS
      CALL TIMER_START('SHOWFLOPS_INLOOP   [THE_MAIN_LOOP]', myThid)
      CALL SHOWFLOPS_INLOOP( iloop, myThid )
      CALL TIMER_STOP ('SHOWFLOPS_INLOOP   [THE_MAIN_LOOP]', myThid)
#endif

#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_LEAVE('FORWARD_STEP',myThid)
#endif

      RETURN
      END

#include "ATM2D_OPTIONS.h"
#ifdef ATM2D_MPI_ON

CStartOfInterface
      SUBROUTINE CPL_SEND_OCN_FIELDS
C     /==========================================================\
C     | SUBROUTINE CPL_SEND_OCN_FIELDS                           |
C     | o Routine for sending surface flux to ocean component    |
C     |==========================================================|
C     | This version talks to the MITgcm general circulation     |
C     | model.                                                   |
C     \==========================================================/
      IMPLICIT NONE

C     == Global variables ==
#include "OCNSIZE.h"
#include "OCNVARS.h"
#include "OCNIDS.h"

C     == Routine arguments ==

C     == Local variables ==

CEndOfInterface

C     Send Sea Level atmos. pressure to ocean component
      CALL COUPSEND_R8TILES( ocnCompName, ocnSLPrName,
     I                       Nx_ocn, Ny_ocn, atmSLPr_ocn )

C     Send (net) heatflux. to ocean component
      CALL COUPSEND_R8TILES( ocnCompName, ocnHeatFluxName,
     I                       Nx_ocn, Ny_ocn, HeatFlux_ocn )

C     Send net shortwave radiation to ocean component
      CALL COUPSEND_R8TILES( ocnCompName, ocnQshortWaveName,
     I                       Nx_ocn, Ny_ocn, qShortWave_ocn )

C     Send Zonal momentum flux to ocean component
      CALL COUPSEND_R8TILES( ocnCompName, ocnTauXName,
     I                       Nx_ocn, Ny_ocn, TauX_ocn )

C     Send Meridional momentum flux to ocean component
      CALL COUPSEND_R8TILES( ocnCompName, ocnTauYName,
     I                       Nx_ocn, Ny_ocn, TauY_ocn )

C     Send E-P-R to ocean component
      CALL COUPSEND_R8TILES( ocnCompName, ocnFWFluxName,
     I                       Nx_ocn, Ny_ocn, FWFlux_ocn )

C     Send salt flux to ocean component
      CALL COUPSEND_R8TILES( ocnCompName, ocnSaltFxName,
     I                       Nx_ocn, Ny_ocn, SaltFlx_ocn )

C     Send sea-ice mass to ocean component
      CALL COUPSEND_R8TILES( ocnCompName, ocnSeaIceName,
     I                       Nx_ocn, Ny_ocn, sIceMass_ocn )

      IF ( ocnCpl_exchange_DIC ) THEN

C       Send atmos CO2 to ocean component
        CALL COUPSEND_R8TILES( ocnCompName, ocnAirCO2Name,
     I                       Nx_ocn, Ny_ocn, aCO2_ocn )

C       Send surface windspeed to ocean component
        CALL COUPSEND_R8TILES( ocnCompName, ocnWSpdName,
     I                       Nx_ocn, Ny_ocn, wSpeed_ocn )

C       Send sea-ice fraction to ocean component
        CALL COUPSEND_R8TILES( ocnCompName, ocnFIceName,
     I                       Nx_ocn, Ny_ocn, SIceFrac_ocn )

      ENDIF

      RETURN
      END

#endif

#include "GMREDI_OPTIONS.h"
#ifdef ALLOW_AUTODIFF
# include "AUTODIFF_OPTIONS.h"
#endif

C     !ROUTINE: GMREDI_RTRANSPORT
C     !INTERFACE:
      SUBROUTINE GMREDI_RTRANSPORT(
     I     trIdentity, bi, bj, k,
     I     iMin, iMax, jMin, jMax,
     I     maskUp, Tracer,
     U     df,
     I     myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | o SUBROUTINE GMREDI_RTRANSPORT                           |
C     |   Add vertical transport terms from GM/Redi              |
C     |   parameterization.                                      |
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     == GLobal variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "GMREDI.h"
#include "GAD.h"
#ifdef ALLOW_LONGSTEP
#include "LONGSTEP.h"
#endif

#ifdef ALLOW_AUTODIFF_TAMC
# include "tamc.h"
# ifdef ALLOW_PTRACERS
#  include "PTRACERS_SIZE.h"
# endif
#endif /* ALLOW_AUTODIFF_TAMC */

C     !INPUT/OUTPUT PARAMETERS:
C     trIdentity   :: tracer Id number
C     bi, bj       :: current tile indices
C     k            :: current level index
C     iMin,iMax    :: Range of 1rst index where results will be set
C     jMin,jMax    :: Range of 2nd  index where results will be set
C     maskUp       :: 2-D array for mask at W points
C     Tracer       :: 3D Tracer field
C     df           :: Diffusive flux component work array.
C     myThid       :: my Thread Id number
      INTEGER trIdentity
      INTEGER bi, bj, k
      INTEGER iMin, iMax, jMin, jMax
      _RS maskUp(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL Tracer(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL df    (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER myThid
CEOP

#ifdef ALLOW_GMREDI
C     !LOCAL VARIABLES:
C     i, j    ::  Loop counters
      INTEGER i, j
#ifdef ALLOW_AUTODIFF_TAMC
C     kkey :: tape key (depends on levels, tiles, and tracers)
      INTEGER kkey
      CHARACTER*(MAX_LEN_MBUF) msgBuf
#endif
      _RL dTdx  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL dTdy  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
#ifdef GM_BOLUS_ADVEC
      _RL rTrans(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
#endif

#ifdef ALLOW_AUTODIFF_TAMC
      kkey = bi + (bj-1)*nSx + (ikey_dynamics-1)*nSx*nSy
      kkey = trIdentity + (kkey-1)*maxpass
      kkey = k + (kkey-1)*Nr
      IF (trIdentity.GT.maxpass) THEN
       WRITE(msgBuf,'(A,2I5)')
     &      'GMREDI_RTRANSPORT: trIdentity > maxpass ',
     &      trIdentity, maxpass
       CALL PRINT_ERROR( msgBuf, myThid )
       STOP 'ABNORMAL END: S/R GMREDI_RTRANSPORT'
      ENDIF
#endif /* ALLOW_AUTODIFF_TAMC */

C     Surface flux is zero
      IF ( useGMRedi .AND. k.GT.1 ) THEN

C-    Horizontal gradients interpolated to W points
      DO j=jMin,jMax
       DO i=iMin,iMax
        dTdx(i,j) = op5*(
     &    op5*recip_deepFacC(k)
     &       *( _maskW(i+1,j,k,bi,bj)*_recip_dxC(i+1,j,bi,bj)
     &             *( Tracer(i+1,j,k) - Tracer( i ,j,k) )
     &        + _maskW( i ,j,k,bi,bj) *_recip_dxC(i,j,bi,bj)
     &             *( Tracer( i ,j,k) - Tracer(i-1,j,k) )
     &        )
     &   +op5*recip_deepFacC(k-1)
     &       *( _maskW(i+1,j,k-1,bi,bj)*_recip_dxC(i+1,j,bi,bj)
     &             *( Tracer(i+1,j,k-1) - Tracer( i ,j,k-1) )
     &         +_maskW( i ,j,k-1,bi,bj)*_recip_dxC( i ,j,bi,bj)
     &             *( Tracer( i ,j,k-1) - Tracer(i-1,j,k-1) )
     &        )          )

        dTdy(i,j) = op5*(
     &    op5*recip_deepFacC(k)
     &       *( _maskS(i,j+1,k,bi,bj)*_recip_dyC(i,j+1,bi,bj)
     &             *( Tracer(i,j+1,k) - Tracer(i,j,k) )
     &        + _maskS(i, j ,k,bi,bj)*_recip_dyC(i, j ,bi,bj)
     &             *( Tracer(i,j,k) - Tracer(i,j-1,k) )
     &        )
     &   +op5*recip_deepFacC(k-1)
     &       *( _maskS(i,j+1,k-1,bi,bj)*_recip_dyC(i,j+1,bi,bj)
     &             *( Tracer(i,j+1,k-1) - Tracer(i,j,k-1) )
     &        + _maskS(i, j ,k-1,bi,bj)*_recip_dyC(i, j ,bi,bj)
     &             *( Tracer(i,j,k-1) - Tracer(i,j-1,k-1) )
     &        )          )
       ENDDO
      ENDDO

#ifdef GM_AUTODIFF_EXCESSIVE_STORE
CADJ STORE dTdx(:,:) =
CADJ &     comlev1_gmredi_k_gad, key=kkey, byte=isbyte
CADJ STORE dTdy(:,:) =
CADJ &     comlev1_gmredi_k_gad, key=kkey, byte=isbyte
#endif

C-    Off-diagonal components of vertical flux
#ifdef ALLOW_LONGSTEP
      IF ( trIdentity .GE. GAD_TR1 ) THEN
        DO j=jMin,jMax
         DO i=iMin,iMax
          df(i,j) = df(i,j)
     &      - _rA(i,j,bi,bj)*deepFac2F(k)*maskInC(i,j,bi,bj)
     &       *( LS_Kwx(i,j,k,bi,bj)*dTdx(i,j)
     &        + LS_Kwy(i,j,k,bi,bj)*dTdy(i,j) )*maskUp(i,j)
         ENDDO
        ENDDO
      ELSE
#endif /* ALLOW_LONGSTEP */
        DO j=jMin,jMax
         DO i=iMin,iMax
          df(i,j) = df(i,j)
     &      - _rA(i,j,bi,bj)*deepFac2F(k)*maskInC(i,j,bi,bj)
     &       *( Kwx(i,j,k,bi,bj)*dTdx(i,j)
     &        + Kwy(i,j,k,bi,bj)*dTdy(i,j) )*maskUp(i,j)
         ENDDO
        ENDDO
#ifdef ALLOW_LONGSTEP
      ENDIF
#endif /* ALLOW_LONGSTEP */

#ifdef GM_BOLUS_ADVEC
      IF (GM_AdvForm .AND. GM_AdvSeparate
     & .AND. .NOT.GM_InMomAsStress) THEN
C      Since bolus transport is computed as curl of stream-function, needs to
C      flip sign when using Left-Handed Coordinate system such as P-coordinate
c      flipSign4LHCoord = -gravitySign
#ifdef ALLOW_LONGSTEP
       IF ( trIdentity .GE. GAD_TR1 ) THEN
        DO j=jMin,jMax
         DO i=iMin,iMax
          rTrans(i,j) = -gravitySign*(
     &       dyG(i+1,j,bi,bj)*LS_PsiX(i+1,j,k,bi,bj)
     &      -dyG( i ,j,bi,bj)*LS_PsiX( i ,j,k,bi,bj)
     &      +dxG(i,j+1,bi,bj)*LS_PsiY(i,j+1,k,bi,bj)
     &      -dxG(i, j ,bi,bj)*LS_PsiY(i, j ,k,bi,bj)
     &                               )*deepFacF(k)
         ENDDO
        ENDDO
       ELSE
#endif /* ALLOW_LONGSTEP */
        DO j=jMin,jMax
         DO i=iMin,iMax
          rTrans(i,j) = -gravitySign*(
     &       dyG(i+1,j,bi,bj)*GM_PsiX(i+1,j,k,bi,bj)
     &      -dyG( i ,j,bi,bj)*GM_PsiX( i ,j,k,bi,bj)
     &      +dxG(i,j+1,bi,bj)*GM_PsiY(i,j+1,k,bi,bj)
     &      -dxG(i, j ,bi,bj)*GM_PsiY(i, j ,k,bi,bj)
     &                               )*deepFacF(k)
         ENDDO
        ENDDO
#ifdef ALLOW_LONGSTEP
       ENDIF
#endif /* ALLOW_LONGSTEP */
#ifdef GM_AUTODIFF_EXCESSIVE_STORE
CADJ STORE rtrans(:,:) =
CADJ &     comlev1_gmredi_k_gad, key=kkey, byte=isbyte
#endif
       DO j=jMin,jMax
        DO i=iMin,iMax
         df(i,j) = df(i,j)
     &    + rTrans(i,j)*op5
     &                 *( Tracer(i,j,k) + Tracer(i,j,k-1) )
     &                 *maskInC(i,j,bi,bj)*maskUp(i,j)
        ENDDO
       ENDDO
      ENDIF
#endif /* GM_BOLUS_ADVEC */

c     IF (.NOT.implicitDiffusion) THEN
C This vertical diffusion term is currently implemented
C by adding the Kwz diffusivity to KappaRT/S
C See calc_diffusivity.F and calc_gt.F (calc_gs.F)
c     ENDIF

      ENDIF
#endif /* ALLOW_GMREDI */

      RETURN
      END

#include "GMREDI_OPTIONS.h"
#ifdef ALLOW_PTRACERS
# include "PTRACERS_OPTIONS.h"
#endif

CBOP
C     !ROUTINE: GMREDI_CHECK
C     !INTERFACE:
      SUBROUTINE GMREDI_CHECK( myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE GMREDI_CHECK
C     | o Check consistency with model configuration
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GMREDI.h"
#ifdef ALLOW_GENERIC_ADVDIFF
# include "GAD.h"
#endif
#ifdef ALLOW_PTRACERS
# include "PTRACERS_SIZE.h"
# include "PTRACERS_PARAMS.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     myThid :: my Thread Id number
      INTEGER myThid

#ifdef ALLOW_GMREDI
C     !FUNCTIONS:
      INTEGER ILNBLNK
      EXTERNAL ILNBLNK

C     !LOCAL VARIABLES:
C     msgBuf :: Informational/error message buffer
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      INTEGER iL, errCount
      _RL     tmpVar
CEOP
#ifdef ALLOW_PTRACERS
      INTEGER iTr
      LOGICAL redFlag
#endif

      _BEGIN_MASTER(myThid)
      errCount = 0

       WRITE(msgBuf,'(A)') 'GMREDI_CHECK: #define GMREDI'
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                     SQUEEZE_RIGHT , myThid )

C- print out some key parameters :
       CALL WRITE_0D_L( GM_AdvForm, INDEX_NONE,
     &  'GM_AdvForm =', '     /* if FALSE => use SkewFlux Form */')
       CALL WRITE_0D_L( GM_InMomAsStress, INDEX_NONE,
     &  'GM_InMomAsStress =', ' /* if TRUE => apply as Eddy Stress */')
       CALL WRITE_0D_L( GM_AdvSeparate, INDEX_NONE,
     & 'GM_AdvSeparate =',' /* Calc Bolus & Euler Adv. separately */')
       CALL WRITE_0D_L( GM_ExtraDiag, INDEX_NONE,
     &  'GM_ExtraDiag =','   /* Tensor Extra Diag (line 1&2) non 0 */')
       CALL WRITE_0D_RL( GM_isopycK, INDEX_NONE, 'GM_isopycK =',
     &  '    /* Background Isopyc. Diffusivity [m^2/s] */')
c      CALL WRITE_0D_RL( GM_background_K, INDEX_NONE,
c    &  'GM_background_K =',
c    &  ' /* Background GM (=Bolus) Diffusivity [m^2/s] */')
       tmpVar = GM_background_K*( oneRL - GM_skewflx )
       CALL WRITE_0D_RL( tmpVar, INDEX_NONE, 'GM_advec*K =',
     &  '    /* Backg. GM-Advec(=Bolus) Diffusivity [m^2/s] */')
       CALL WRITE_0D_RL( GM_background_K*GM_skewflx, INDEX_NONE,
     &  'GM_skewflx*K =',
     &  '  /* Background GM_SkewFlx Diffusivity [m^2/s] */')
       CALL WRITE_0D_RL( GM_isoFac_calcK, INDEX_NONE,
     &  'GM_isoFac_calcK =',
     &  ' /* Fraction of dynamic K added to Redi tensor */')
       CALL WRITE_0D_RL( GM_Kmin_horiz, INDEX_NONE, 'GM_Kmin_horiz =',
     &  ' /* Minimum Horizontal Diffusivity [m^2/s] */')
       CALL WRITE_0D_RL( GM_Visbeck_alpha, INDEX_NONE,
     &  'GM_Visbeck_alpha =', ' /* Visbeck alpha coeff. [-] */')
       CALL WRITE_0D_RL( GM_Small_Number, INDEX_NONE,
     &  'GM_Small_Number =', '  /* epsilon used in slope calc */')
       CALL WRITE_0D_RL( GM_slopeSqCutoff, INDEX_NONE,
     &  'GM_slopeSqCutoff =', ' /* Slope^2 cut-off value */')
       CALL WRITE_0D_C( GM_taper_scheme, 0, INDEX_NONE,
     &  'GM_taper_scheme =',
     &  '  /* Type of Tapering/Clipping scheme */')
       CALL WRITE_0D_RL( GM_maxSlope, INDEX_NONE,
     &  'GM_maxSlope =', '  /* Maximum Slope (Tapering/Clipping) */')
       CALL WRITE_0D_RL( GM_facTrL2dz, INDEX_NONE,
     &  'GM_facTrL2dz =',
     &  ' /* Minimum Trans.Layer Thick. (factor of dz) */')
       CALL WRITE_0D_RL( GM_facTrL2ML, INDEX_NONE,
     &  'GM_facTrL2ML =',
     &  ' /* Max.Trans.Layer Thick. (factor of MxL Depth)*/')
       CALL WRITE_0D_RL( GM_maxTransLay, INDEX_NONE,
     &  'GM_maxTransLay =',
     &  ' /* Maximum Transition Layer Thickness [m] */')
       CALL WRITE_0D_L( GM_UseBVP, INDEX_NONE,
     &  'GM_UseBVP =',
     &  ' /* if TRUE => use bvp a la Ferrari et al. (2010) */')
       CALL WRITE_0D_I( GM_BVP_ModeNumber, INDEX_NONE,
     &  'GM_BVP_ModeNumber =',
     &  ' /* Vertical mode number for BVP wave speed */')
       CALL WRITE_0D_RL( GM_BVP_cMin, INDEX_NONE,
     &  'GM_BVP_cMin =',
     &  ' /* Minimum wave speed for BVP [m/s] */')
       CALL WRITE_0D_L( GM_useSubMeso, INDEX_NONE,
     &  'GM_useSubMeso =',
     &  ' /* if TRUE => use Sub-Meso param. (B.Fox-Kemper) */')
       CALL WRITE_0D_RL( subMeso_Ceff, INDEX_NONE,
     &  'subMeso_Ceff =',
     &  ' /* efficiency coeff. of Mixed-Layer Eddies [-] */')
       CALL WRITE_0D_RL( subMeso_invTau, INDEX_NONE,
     &  'subMeso_invTau =',
     &  ' /* inverse of Sub-Meso mixing time-scale [/s] */')
       CALL WRITE_0D_RL( subMeso_LfMin, INDEX_NONE,
     &  'subMeso_LfMin =',' /* minimum length-scale "Lf" [m] */')
       CALL WRITE_0D_RS( subMeso_Lmax, INDEX_NONE,
     &  'subMeso_Lmax =',' /* maximum grid-scale length [m] */')
       CALL WRITE_0D_L( GM_useLeithQG, INDEX_NONE,
     &  'GM_useLeithQG =',
     &  ' /* if TRUE => add QG Leith viscosity to GMRedi tensor */')
       CALL WRITE_0D_L( GM_useGEOM, INDEX_NONE,
     &  'GM_useGEOM =', ' /* using GEOMETRIC */')

C--  Check parameters:

C-     GM/Redi needs implicit diffusion (will be packaged later)
      IF ( .NOT.implicitDiffusion ) THEN
        WRITE(msgBuf,'(A)') 'GM/Redi needs implicitDiffusion=.true.'
        CALL PRINT_ERROR( msgBuf , myThid )
        errCount = errCount + 1
      ENDIF

#ifndef GM_READ_K3D_REDI
      IF ( GM_K3dRediFile.NE.' ' ) THEN
       WRITE(msgBuf,'(A)')
     &   'GMREDI_CHECK: GM_K3dRediFile is set in data.gmredi'
       CALL PRINT_ERROR( msgBuf, myThid )
       WRITE(msgBuf,'(A)')
     &   'GMREDI_CHECK: without #define GM_READ_K3D_REDI'
       CALL PRINT_ERROR( msgBuf, myThid )
       errCount = errCount + 1
      ENDIF
#endif
#ifndef GM_READ_K3D_GM
      IF ( GM_K3dGMFile.NE.' ' ) THEN
       WRITE(msgBuf,'(A)')
     &   'GMREDI_CHECK: GM_K3dGMFile is set in data.gmredi'
       CALL PRINT_ERROR( msgBuf, myThid )
       WRITE(msgBuf,'(A)')
     &   'GMREDI_CHECK: without #define GM_READ_K3D_GM'
       CALL PRINT_ERROR( msgBuf, myThid )
       errCount = errCount + 1
      ENDIF
#endif

#ifndef GM_VISBECK_VARIABLE_K
C     Make sure we are not trying to use something that is unavailable
      IF ( GM_Visbeck_alpha.NE.0. ) THEN
       WRITE(msgBuf,'(A)')
     &   'GMREDI_CHECK: Visbeck variables used in data.gmredi'
       CALL PRINT_ERROR( msgBuf, myThid )
       WRITE(msgBuf,'(A)')
     &   'GMREDI_CHECK: without #define GM_VISBECK_VARIABLE_K'
       CALL PRINT_ERROR( msgBuf, myThid )
       errCount = errCount + 1
      ENDIF
#endif
#ifdef OLD_VISBECK_CALC
C Was to use old calculation (before 2007/05/24) of Visbeck etal K_GM+Redi
C (which depends on tapering scheme); got removed late 2025.
c     IF ( GM_Visbeck_alpha.NE.0. ) THEN
       WRITE(msgBuf,'(2A)') 'GMREDI_CHECK: ',
     &   '#define OLD_VISBECK_CALC not allowed in GMREDI_OPTIONS.h'
       CALL PRINT_ERROR( msgBuf, myThid )
       WRITE(msgBuf,'(2A)') 'GMREDI_CHECK: ',
     &   ' since OLD_VISBECK_CALC code has been removed'
       CALL PRINT_ERROR( msgBuf, myThid )
       errCount = errCount + 1
c     ENDIF
#endif

#ifdef GM_GEOM_VARIABLE_K
      IF ( GM_useGEOM ) THEN
       CALL WRITE_0D_RL( GEOM_alpha, INDEX_NONE,
     &  'GEOM_alpha      =', ' /* GEOM alpha coeff. [-] */')
       CALL WRITE_0D_RL( GEOM_lmbda, INDEX_NONE,
     &  'GEOM_lmbda      =', ' /* GEOM ene diss rate [/s] */')
       CALL WRITE_0D_RL( GEOM_diffKh_EKE, INDEX_NONE,
     &  'GEOM_diffKh_EKE =', ' /* GEOM Eke diffusion coeff [m2/s] */')
       CALL WRITE_0D_L( GEOM_vert_struc, INDEX_NONE,
     &  'GEOM_vert_struc =', ' /* GEOM vertical structure function */')
       CALL WRITE_0D_RL( GEOM_vert_struc_min, INDEX_NONE,
     &  'GEOM_vert_struc_min =', ' /* vert struc min [-] */')
       CALL WRITE_0D_RL( GEOM_vert_struc_max, INDEX_NONE,
     &  'GEOM_vert_struc_min =', ' /* vert struc min [-] */')
       CALL WRITE_0D_RL( GEOM_minVal_K, INDEX_NONE,
     &  'GEOM_minVal_K   =', ' /* GEOM_K3d lower bound [m2/s] */')
       CALL WRITE_0D_RL( GEOM_maxVal_K, INDEX_NONE,
     &  'GEOM_maxVal_K   =', ' /* GEOM_K3d upper bound [m2/s] */')
       IF (usingPcoords) THEN
        WRITE(msgBuf,'(3A)') 'GMREDI_CHECK:',
     &       ' p-coords not yet implemented with GM_useGEOM'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
       ENDIF
      ENDIF
#else /* GM_GEOM_VARIABLE_K */
C     Make sure we are not trying to use something that is unavailable
      IF ( GM_useGEOM ) THEN
       WRITE(msgBuf,'(A)')
     &   ' GMREDI_CHECK: GEOM variables used in data.gmredi'
       CALL PRINT_ERROR( msgBuf, myThid )
       WRITE(msgBuf,'(A)')
     &   ' GMREDI_CHECK: without #define GM_GEOM_VARIABLE_K'
       CALL PRINT_ERROR( msgBuf, myThid )
       errCount = errCount + 1
      ENDIF
#endif /* GM_GEOM_VARIABLE_K */

#ifndef GM_BOLUS_ADVEC
C     Make sure we are not trying to use some arrays that are unavailable
      IF ( GM_AdvForm ) THEN
       WRITE(msgBuf,'(A)')
     &   'GMREDI_CHECK: GM Advection form used in data.gmredi'
       CALL PRINT_ERROR( msgBuf, myThid )
       WRITE(msgBuf,'(A)')
     &   'GMREDI_CHECK: without #define GM_BOLUS_ADVEC'
       CALL PRINT_ERROR( msgBuf, myThid )
       errCount = errCount + 1
      ENDIF
#endif

#ifdef GM_BATES_K3D
# ifndef HAVE_LAPACK
c     IF ( GM_useBatesK3d ) THEN
        WRITE(msgBuf, '(A)')
     &     'Must use CPP option HAVE_LAPACK when using BatesK3d'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
c     ENDIF
# endif
      IF ( GM_useBatesK3d ) THEN
        CALL WRITE_0D_L( GM_useBatesK3d, INDEX_NONE,
     &   'GM_useBatesK3d =',
     &   ' /* if TRUE => use BatesK3d for GM diffusivity */')
        IF ( GM_Bates_use_constK ) THEN
          CALL WRITE_0D_L( GM_Bates_use_constK, INDEX_NONE,
     &         'GM_Bates_use_constK =',
     &         ' /* if TRUE => Uses a constant K for'//
     &         ' the eddy transport closure */')
          CALL WRITE_0D_L( GM_Bates_smooth, INDEX_NONE,
     &         'GM_Bates_smooth =',
     &         ' /* if TRUE => Expands in terms of baroclinic modes */')
          IF ( GM_Bates_smooth ) THEN
            CALL WRITE_0D_I( GM_Bates_NModes, INDEX_NONE,
     &           'GM_Bates_NModes =',
     &           ' /* Number of modes for expansion */')
          ENDIF
        ELSE
          CALL WRITE_0D_I( GM_Bates_NModes, INDEX_NONE,
     &         'GM_Bates_NModes =',
     &         ' /* Number of modes for expansion */')
        ENDIF
      ENDIF

C     Make sure that we use BatesK3d with the advective form only.
C     The skew form is not presently supported.
      IF ( GM_useBatesK3d .AND. .NOT.GM_AdvForm ) THEN
        WRITE(msgBuf,'(2A)') 'GMREDI_CHECK: ',
     &       'GM_useBatesK3d=.TRUE. but GM_AdvForm=.FALSE.'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(A)')
     &       'GMREDI_CHECK: To use BatesK3d set GM_AdvForm=.TRUE.'
       CALL PRINT_ERROR( msgBuf, myThid )
       errCount = errCount + 1
      ENDIF
      IF ( GM_useBatesK3d .AND. deepAtmosphere ) THEN
        WRITE(msgBuf,'(2A)') 'GMREDI_CHECK: GM_useBatesK3d',
     &   ' not yet fixed for deep geometry (deepAtmosphere=T)'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF

#else /* GM_BATES_K3D */
C     Make sure we are not trying to use something that is unavailable
      IF ( GM_useBatesK3d ) THEN
       WRITE(msgBuf,'(A)')
     &   'GMREDI_CHECK: GM_useBatesK3d is set to True in data.gmredi'
       CALL PRINT_ERROR( msgBuf, myThid )
       WRITE(msgBuf,'(A)')
     &   'GMREDI_CHECK: without #define GM_BATES_K3D'
       CALL PRINT_ERROR( msgBuf, myThid )
       errCount = errCount + 1
      ENDIF
#endif /* GM_BATES_K3D */

#ifndef GM_EXTRA_DIAGONAL
C     Make sure we are not trying to use some arrays that are unavailable
      IF ( GM_ExtraDiag ) THEN
       WRITE(msgBuf,'(A)')
     &   'GMREDI_CHECK: GM_skew_Flux_K & GM_isopycK not equal'
       CALL PRINT_ERROR( msgBuf, myThid )
       WRITE(msgBuf,'(A)')
     &   'GMREDI_CHECK: without #define GM_EXTRA_DIAGONAL'
       CALL PRINT_ERROR( msgBuf, myThid )
       errCount = errCount + 1
      ENDIF
#endif

#ifndef GM_NON_UNITY_DIAGONAL
      IF ( GM_iso2dFile .NE. ' ' .OR.
     &     GM_iso1dFile .NE. ' ' ) THEN
       WRITE(msgBuf,'(A)')
     &   'GMREDI_CHECK: needs #define GM_NON_UNITY_DIAGONAL'
       CALL PRINT_ERROR( msgBuf, myThid )
       WRITE(msgBuf,'(A)')
     &   'GMREDI_CHECK: to use GM_iso2dFile or GM_iso1dFile'
       CALL PRINT_ERROR( msgBuf, myThid )
       errCount = errCount + 1
      ENDIF
      IF ( GM_isoFac_calcK .NE. zeroRL .AND.
     &     ( GM_Visbeck_alpha.NE.zeroRL .OR.
     &       GM_useBatesK3d .OR. GM_useLeithQG ) ) THEN
       WRITE(msgBuf,'(A)')
     &   'GMREDI_CHECK: needs #define GM_NON_UNITY_DIAGONAL'
       CALL PRINT_ERROR( msgBuf, myThid )
       IF ( GM_Visbeck_alpha.NE.zeroRL ) THEN
        WRITE(msgBuf,'(A)')
     &   'GMREDI_CHECK: to use Visbeck computed K'
        CALL PRINT_ERROR( msgBuf, myThid )
       ENDIF
       IF ( GM_useBatesK3d .OR. GM_useLeithQG ) THEN
        WRITE(msgBuf,'(A)')
     &   'GMREDI_CHECK: to use GM_useBatesK3d or GM_useLeithQG'
        CALL PRINT_ERROR( msgBuf, myThid )
       ENDIF
       errCount = errCount + 1
      ENDIF
      IF ( errCount .EQ. 0 ) THEN
        WRITE(msgBuf,'(2A)') '** WARNING ** GMREDI_CHECK: ',
     &       '#undef GM_NON_UNITY_DIAGONAL not recommended'
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
      ENDIF
#endif

#ifndef ALLOW_GM_LEITH_QG
      IF ( GM_useLeithQG ) THEN
       WRITE(msgBuf,'(A)')
     &   'GMREDI_CHECK: GM_useLeithQG used in data.gmredi without'
       CALL PRINT_ERROR( msgBuf, myThid )
       WRITE(msgBuf,'(A)')
     &   'GMREDI_CHECK: #define ALLOW_GM_LEITH_QG'
       CALL PRINT_ERROR( msgBuf, myThid )
       errCount = errCount + 1
      ENDIF
#endif
      IF ( GM_useLeithQG .AND. .NOT.momStepping ) THEN
        WRITE(msgBuf,'(2A)') 'GMREDI_CHECK: ',
     &   'cannot use GM_useLeithQG with "momStepping= FALSE"'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF

#ifdef GM_EXCLUDE_SUBMESO
      IF ( GM_useSubMeso ) THEN
        WRITE(msgBuf,'(2A)') 'GMREDI_CHECK: ',
     &   'cannot use Sub-Meso (GM_useSubMeso=T)'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(2A)') 'GMREDI_CHECK: ',
     &   'when compiled with #define GM_EXCLUDE_SUBMESO'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF
#endif /* GM_EXCLUDE_SUBMESO */

      IF ( GM_useSubMeso .AND. .NOT.GM_AdvForm ) THEN
        WRITE(msgBuf,'(2A)') 'GMREDI_CHECK: ',
     &   'Sub-Meso only implemented within GM_AdvForm'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF

      IF ( GM_InMomAsStress ) THEN
#ifdef ALLOW_EDDYPSI
        IF ( .NOT.GM_useBatesK3d ) THEN
          WRITE(msgBuf,'(3A)') 'GMREDI_CHECK: ',
     &         'Using GM_InMomAsStress and not GM_useBatesK3d. ',
     &         'GM_InMomAsStress=T has only been tested with BatesK3d'
          CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                        SQUEEZE_RIGHT, myThid )
        ENDIF
#else /* ALLOW_EDDYPSI */
       WRITE(msgBuf,'(2A)')
     &  'GMREDI_CHECK: need to define ALLOW_EDDYPSI in CPP_OPTIONS.h',
     &  ' to use GM_InMomAsStress'
       CALL PRINT_ERROR( msgBuf, myThid )
       errCount = errCount + 1
#endif /* ALLOW_EDDYPSI */
      ENDIF
      IF ( GM_InMomAsStress .AND. .NOT.GM_AdvForm ) THEN
       WRITE(msgBuf,'(A)')
     &   'GMREDI_CHECK: need GM_AdvForm=T to use GM_InMomAsStress'
       CALL PRINT_ERROR( msgBuf, myThid )
       errCount = errCount + 1
      ENDIF

      IF ( usingPcoords ) THEN
C-    Some GM pieces of code have not been fixed to work in Pressure-coordinates
       IF ( GM_taper_scheme.EQ.'fm07' .OR.
     &      GM_taper_scheme.EQ.'stableGmAdjTap' ) THEN
        iL = ILNBLNK(GM_taper_scheme)
        WRITE(msgBuf,'(3A)') 'GMREDI_CHECK: GM_taper_scheme "',
     &   GM_taper_scheme(1:iL), '" not yet fixed for P-Coordinate'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
       ENDIF
       IF ( GM_useBVP ) THEN
        WRITE(msgBuf,'(2A)') 'GMREDI_CHECK: GM_useBVP',
     &    ' code not yet fixed for P-Coordinate'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
       ENDIF
       IF ( GM_Visbeck_alpha.NE.zeroRL ) THEN
        WRITE(msgBuf,'(2A)') 'GMREDI_CHECK: Visbeck',
     &    'scheme not yet fixed for P-Coordinate'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
       ENDIF
       IF ( GM_useBatesK3d ) THEN
        WRITE(msgBuf,'(2A,I3)') '** WARNING ** GMREDI_CHECK: ',
     &    'GM_useBatesK3d potentially unsafe with P-Coordinate'
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
       ENDIF
       IF ( GM_useLeithQG ) THEN
        WRITE(msgBuf,'(2A)') 'GMREDI_CHECK: GM_useLeithQG',
     &    ' code not yet fixed for P-Coordinate'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
       ENDIF
       IF ( GM_useSubMeso ) THEN
        WRITE(msgBuf,'(2A)') 'GMREDI_CHECK: GM_useSubMeso',
     &   ' not yet fixed for P-Coordinate'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
       ENDIF
      ENDIF

      IF ( useShelfIce .OR. topoFile.NE.' ' ) THEN
C-    Some GM options are likely to not work when some dry grid cells are found
C     near the top (e.g., under ice-shelf). This might change as more pieces of
C     code get fixed (e.g., once Mixed-Layer depth is fixed) but for now safer
C     to just stop here if it is the case.
       IF ( GM_taper_scheme.EQ.'ldd97' .OR.
     &      GM_taper_scheme.EQ.'fm07' ) THEN
        iL = ILNBLNK(GM_taper_scheme)
        WRITE(msgBuf,'(3A)') 'GMREDI_CHECK: GM_taper_scheme "',
     &   GM_taper_scheme(1:iL), '" not yet fixed for dry cell @ top'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
       ENDIF
       IF ( GM_useSubMeso ) THEN
        WRITE(msgBuf,'(2A)') 'GMREDI_CHECK: GM_useSubMeso',
     &   ' not yet fixed for dry cell @ top'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
       ENDIF
       IF ( GM_useBatesK3d ) THEN
        WRITE(msgBuf,'(2A,I3)') '** WARNING ** GMREDI_CHECK: ',
     &    'GM_useBatesK3d potentially unsafe with dry cell @ top'
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
       ENDIF
       IF ( GM_Visbeck_alpha.NE.zeroRL ) THEN
        WRITE(msgBuf,'(2A,I3)') '** Warning ** GMREDI_CHECK: ',
     &    'Visbeck scheme not fully tested with dry cell @ top'
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
       ENDIF
       IF ( GM_useLeithQG ) THEN
        WRITE(msgBuf,'(2A,I3)') '** Warning ** GMREDI_CHECK: ',
     &    'GM_useLeithQG not fully tested with dry cell @ top'
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
       ENDIF
C-    end special check for dry cell @ top
      ENDIF

#ifdef ALLOW_PTRACERS
      IF ( GM_AdvForm .AND. .NOT.GM_AdvSeparate
     &       .AND. usePTRACERS ) THEN
        redFlag = .FALSE.
        DO iTr=1,PTRACERS_numInUse
         IF ( .NOT.PTRACERS_useGMRedi(iTr) ) THEN
          redFlag = .TRUE.
          WRITE(msgBuf,'(2A,I3,A,L5)') 'GMREDI_CHECK:',
     &     ' pTracers_useGMRedi(',iTr,' )=', PTRACERS_useGMRedi(iTr)
          CALL PRINT_ERROR( msgBuf, myThid )
         ENDIF
        ENDDO
        IF ( redFlag ) THEN
          WRITE(msgBuf,'(2A)') 'GMREDI_CHECK:',
     &     ' but GM Advective Form applies to all tracers !'
          CALL PRINT_ERROR( msgBuf, myThid )
          errCount = errCount + 1
        ENDIF
      ENDIF
#endif /* ALLOW_PTRACERS */

#ifdef ALLOW_GENERIC_ADVDIFF
C     Check size of overlap region
      IF ( GM_AdvForm .AND. .NOT.GM_AdvSeparate
     &       .AND. GM_Visbeck_alpha.NE.0.
     &       .AND. useMultiDimAdvec ) THEN
C       Visbeck variable K requires 1 more row/column in the overlap:
C       might need to increase OLx,OLy from 2 to 3 if GM advective
C       form & multi-dim advection are used. This happens when:
C       a) using a 5 points stencil advection scheme ; or
C       b) using a 3 points stencil advection scheme on CS-grid
        GAD_OlMinSize(2) = MAX( GAD_OlMinSize(2), 1)
        WRITE(msgBuf,'(A,9I3)')
     &      'GMREDI_CHECK: GAD_OlMinSize=', GAD_OlMinSize
        CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                      SQUEEZE_RIGHT , myThid )
      ENDIF
#endif /* ALLOW_GENERIC_ADVDIFF */

      IF ( errCount.GE.1 ) THEN
        WRITE(msgBuf,'(A,I3,A)')
     &       'GMREDI_CHECK: detected', errCount,' fatal error(s)'
        CALL PRINT_ERROR( msgBuf, myThid )
        CALL ALL_PROC_DIE( 0 )
        STOP 'ABNORMAL END: S/R GMREDI_CHECK'
      ENDIF
      _END_MASTER(myThid)

#endif /* ALLOW_GMREDI */
      RETURN
      END

#include "SEAICE_OPTIONS.h"

CBOP
C     !ROUTINE: SEAICE_DIFFUSION
C     !INTERFACE:
      SUBROUTINE SEAICE_DIFFUSION(
     I     tracerIdentity,
     I     diffKh, fac,
     I     iceFld, iceMask, xA, yA,
     U     gFld,
     I     bi, bj, myTime, myIter, myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE SEAICE_DIFFUSION
C     | o Add tendency from horizontal diffusion
C     *==========================================================*
C     *==========================================================*

C     !USES:
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "SEAICE_SIZE.h"
#include "SEAICE_PARAMS.h"
CML#include "SEAICE_GRID.h"

C     !INPUT PARAMETERS:
C     === Routine arguments ===
C     afx        :: horizontal advective flux, x direction
C     afy        :: horizontal advective flux, y direction
C     myThid     :: my Thread Id number
      _RL iceFld (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL gFld   (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL iceMask(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RS xA     (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RS yA     (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL diffKh, fac
      INTEGER tracerIdentity
      INTEGER bi,bj
      _RL     myTime
      INTEGER myIter
      INTEGER myThid
#ifdef ALLOW_GENERIC_ADVDIFF
#ifdef ALLOW_DIAGNOSTICS
      CHARACTER*8 diagName
      CHARACTER*4 SEAICE_DIAG_SUFX, diagSufx
      EXTERNAL    SEAICE_DIAG_SUFX
#endif
CEOP

C     !LOCAL VARIABLES:
C     === Local variables ===
C     i,j :: Loop counters
      INTEGER i, j, k
      _RL fZon   (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL fMer   (1-OLx:sNx+OLx,1-OLy:sNy+OLy)

      IF ( diffKh .GT. 0. _d 0 ) THEN
#ifdef ALLOW_DIAGNOSTICS
C--   Set diagnostic suffix for the current tracer
       IF ( useDiagnostics ) THEN
        diagSufx = SEAICE_DIAG_SUFX( tracerIdentity, myThid )
       ENDIF
#endif
C--   Tendency due to horizontal diffusion
        k = 1
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          fZon  (i,j) = 0. _d 0
          fMer  (i,j) = 0. _d 0
         ENDDO
        ENDDO
C--   X-direction
        CALL GAD_DIFF_X(bi,bj,k,xA,diffKh,iceFld,fZon,myThid)
C--   Y-direction
        CALL GAD_DIFF_Y(bi,bj,k,yA,diffKh,iceFld,fMer,myThid)
C--   Divergence of fluxes: update scalar field
        DO j=1-OLy,sNy+OLy-1
         DO i=1-OLx,sNx+OLx-1
          gFld(i,j)= gFld(i,j)
     &        - fac*iceMask(i,j,bi,bj)*recip_rA(i,j,bi,bj)
     &        *( (fZon(i+1,j)-fZon(i,j))
     &         + (fMer(i,j+1)-fMer(i,j)) )
         ENDDO
        ENDDO
#ifdef ALLOW_DIAGNOSTICS
C-    Diagnostics of Tracer flux in Y dir (mainly Diffusive terms),
C     excluding advective terms:
        IF ( useDiagnostics .AND. diffKh.NE.0. ) THEN
         diagName = 'DFxE'//diagSufx
         CALL DIAGNOSTICS_FILL(fZon,diagName, k,1, 2,bi,bj, myThid)
         diagName = 'DFyE'//diagSufx
         CALL DIAGNOSTICS_FILL(fMer,diagName, k,1, 2,bi,bj, myThid)
        ENDIF
#endif
C     endif do horizontal diffusion
      ENDIF
#endif /* ALLOW_GENERIC_ADVDIFF */

      RETURN
      END

#include "CAL_OPTIONS.h"

      SUBROUTINE CAL_SET(
     I                    modstart, modend, modstep,
     I                    moditerini, moditerend, modintsteps,
     I                    myThid )

C     ==================================================================
C     SUBROUTINE cal_Set
C     ==================================================================
C
C     o This routine initialises the calendar according to the user
C       specifications in "data".
C
C     Purpose: Precalculations for the calendar.
C              Given the type of calendar that should be used date
C              arrays and some additional information is returned.
C              Check for consistency with other specifications such
C              as modintsteps.
C
C     started: Christian Eckert eckert@mit.edu  30-Jun-1999
C     changed: Christian Eckert eckert@mit.edu  29-Dec-1999
C              - restructured the original version in order to have a
C                better interface to the MITgcmUV.
C              Christian Eckert eckert@mit.edu  19-Jan-2000
C              - Changed the role of the routine arguments. Chris Hill
C                proposed to make the calendar less "invasive". The tool
C                now assumes that the MITgcmUV already provides an ade-
C                quate set of time stepping parameters. The calendar
C                only associates a date with the given starttime of the
C                numerical model. startdate corresponds to zero start-
C                time. So, given niter0 or startdate .ne. zero the actual
C                startdate of the current integration is shifted by the
C                time interval correponding to niter0, startdate respec-
C                tively.
C              Christian Eckert eckert@mit.edu  03-Feb-2000
C              - Introduced new routine and function names, cal_<NAME>,
C                for verion 0.1.3.
C              Christian Eckert eckert@mit.edu  23-Feb-2000
C              - Corrected the declaration of *modelrundate*
C                --> integer modelrundate(4)
C
C     ==================================================================
C     SUBROUTINE cal_Set
C     ==================================================================

      IMPLICIT NONE

C     == global variables ==

#include "cal.h"

C     == routine arguments ==
C     modstart        :: start time of the model integration
C     modend          :: end time of the model integration
C     modstep         :: timestep of the numerical model
C     moditerini      :: initial iteration number of the model
C     moditerend      :: last iteration number of the model
C     modintsteps     :: number of timesteps that are to be performed.
C     myThid          :: my Thread Id number

      _RL     modstart
      _RL     modend
      _RL     modstep
      INTEGER moditerini
      INTEGER moditerend
      INTEGER modintsteps
      INTEGER myThid

C     == local variables ==
C     modelBaseDate :: full date array for startdate_1,startdate_2
C                       (corresponds to model baseTime, iter=0)
      INTEGER i,j,k
      INTEGER ierr
      INTEGER timediff(4)
      INTEGER iterinitime(4)
      INTEGER modelBaseDate(4)
      _RL     runtimesecs
      _RL     iterinisecs
C     == end of interface ==

      _BEGIN_MASTER(myThid)

C-    Initialise some variables.
      usingNoLeapYearCal     = .FALSE.
      usingGregorianCalendar = .FALSE.
      usingModelCalendar     = .FALSE.
      usingJulianCalendar    = .FALSE.

C-    Set calendar parameters which are independent of the calendar choice:
      hoursPerDay      = 24
      minutesPerHour   = 60
      minutesPerDay    = minutesPerHour*hoursPerDay
      secondsPerMinute = 60
      secondsPerHour   = secondsPerMinute*minutesPerHour
      secondsPerDay    = secondsPerMinute*minutesPerDay

C-    Select which calendar type to use:
      IF ( theCalendar .EQ. 'gregorian') THEN
        usingGregorianCalendar = .TRUE.
c     ELSE IF ( theCalendar .EQ. 'julian') THEN
c       usingJulianCalendar = .TRUE.
c       STOP ' stopped in cal_Set (Julian Calendar).'
      ELSE IF ( theCalendar .EQ. 'noLeapYear') THEN
        usingNoLeapYearCal = .TRUE.
      ELSE IF ( theCalendar .EQ. 'model') THEN
        usingModelCalendar = .TRUE.
c     ELSE IF ( theCalendar .EQ. 'none') THEN
c       usingNoCalendar = .TRUE.
c       STOP ' stopped in cal_Set (No Calendar).'
      ELSE
        ierr = 101
        CALL cal_PrintError( ierr, myThid )
        STOP
      ENDIF

C-    Set calendar parameters according to the calendar type:

      IF ( usingGregorianCalendar .OR. usingNoLeapYearCal ) THEN
C       The reference date for the Gregorian Calendar.
C       and its format: ( yymmdd , hhmmss , leap year, weekday )
C                                             (1/2)    (1 - 7)
C       The Gregorian calendar starts on Friday, 15 Oct. 1582.
        refDate(1) = 15821015
        refDate(2) = 0
        refDate(3) = 1
        refDate(4) = 1

C       Number of months per year and other useful numbers.
        nDaysNoLeap      = 365
        nDaysLeap        = 366
        nMaxDayMonth     = 31

C       Number of days per month.
C       The "magic" number 2773 derives from the sequence: 101010110101
C         read in reverse and interpreted as a dual number. An
C         alternative would be to take 2741 with the loop being
C         executed in reverse order. Accidentially, the latter
C         is a prime number.
        k=2773
        DO i=1,nMonthYear
          j = MOD(k,2)
          k = (k-j)/2
          nDayMonth(i,1) = 30+j
          nDayMonth(i,2) = 30+j
        ENDDO
        nDayMonth(2,1) = 28
        nDayMonth(2,2) = 29

C       Week days.
        dayOfWeek(1) = 'FRI'
        dayOfWeek(2) = 'SAT'
        dayOfWeek(3) = 'SUN'
        dayOfWeek(4) = 'MON'
        dayOfWeek(5) = 'TUE'
        dayOfWeek(6) = 'WED'
        dayOfWeek(7) = 'THU'
      ENDIF

      IF ( usingModelCalendar ) THEN
C       Assume a model calendar having 12 months with thirty days each.
C       Reference date is the first day of year 0 at 0am, and model day 1.
        refDate(1) = 00000101
        refDate(2) = 0
        refDate(3) = 1
        refDate(4) = 1

C       Some useful numbers.
        nDaysNoLeap      = 360
        nDaysLeap        = 360
        nMaxDayMonth     = 30
        DO i=1,nMonthYear
          nDayMonth(i,1) = 30
          nDayMonth(i,2) = 30
        ENDDO

C       Week days (Model Day 1 - 7).
        dayOfWeek(1) = 'MD1'
        dayOfWeek(2) = 'MD2'
        dayOfWeek(3) = 'MD3'
        dayOfWeek(4) = 'MD4'
        dayOfWeek(5) = 'MD5'
        dayOfWeek(6) = 'MD6'
        dayOfWeek(7) = 'MD7'

      ENDIF

C-    Record completion of calendar settings: stage 1 = calendar is defined
      cal_setStatus = 1

C     Map the numerical model parameters. --> common blocks in CALENDAR.h
      modelStart       = modstart
      modelEnd         = modend
      modelStep        = modstep
      modelIter0       = moditerini
      modelIterEnd     = moditerend
      modelIntSteps    = modintsteps

C     Do first consistency checks
C     o Time step.
      IF ( modelStep .LE. 0. ) THEN
        ierr = 102
        CALL cal_PrintError( ierr, myThid )
        STOP ' stopped in cal_Set.'
      ENDIF
      IF ( modelStep .LT. 1. ) THEN
        ierr = 103
        CALL cal_PrintError( ierr, myThid )
        STOP ' stopped in cal_Set.'
      ENDIF
      IF ( ABS(modelStep - NINT(modelStep)) .GT. 0.000001 ) THEN
        ierr = 104
        CALL cal_PrintError( ierr, myThid )
        STOP ' stopped in cal_Set.'
      ELSE
        modelStep = FLOAT(NINT(modelStep))
      ENDIF

C-    Record completion of calendar settings: stage 2 = numerical model parms
      cal_setStatus = 2

C     Complete the start date specification to get a full date array.
      CALL cal_FullDate( startdate_1, startdate_2,
     &                   modelBaseDate, myThid )

C     From here on, the final calendar settings are determined by the
C     following variables:
C               modelStart, modelStep*modelIntSteps & modelBaseDate

      runtimesecs = modelIntSteps*modelStep

C     Determine the startdate of the integration.
c     iterinisecs = float(modelIter0)*modelStep
C-jmc: above does not work if baseTime <> 0 ; fix it below:
      iterinisecs = modelStart
      CALL cal_TimeInterval( iterinisecs, 'secs', iterinitime, myThid )
      CALL cal_AddTime( modelBaseDate, iterinitime, modelStartDate,
     &                  myThid )

      CALL cal_TimeInterval( runtimesecs, 'secs', timediff, myThid )
      CALL cal_AddTime( modelStartDate, timediff, modelEndDate,
     &                  myThid )

C-    Record completion of calendar settings: stage 3 = fully set-up.
      cal_setStatus = 3

      _END_MASTER(myThid)

C     Everyone else must wait for the parameters to be set
      _BARRIER

      RETURN
      END

#include "REGRID_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 0
C     !ROUTINE: REGRID_INIT_FIXED

C     !INTERFACE:
      SUBROUTINE REGRID_INIT_FIXED( myThid )

C     !DESCRIPTION:
C     Initialize REGRID variables that are kept fixed during the run.

C     !USES:
      IMPLICIT NONE
#include "EEPARAMS.h"
#include "SIZE.h"
#include "PARAMS.h"
#include "REGRID_SIZE.h"
#include "REGRID.h"

C     !INPUT/OUTPUT PARAMETERS:
      INTEGER myThid
CEOP

C     !LOCAL VARIABLES:

#ifdef ALLOW_MNC
      IF (useMNC) THEN
        CALL REGRID_MNC_INIT( myThid )
      ENDIF
#endif /* ALLOW_MNC */

      RETURN
      END

#include "SEAICE_OPTIONS.h"

CBOP
C     !ROUTINE: SEAICE_CALC_RHS
C     !INTERFACE:
      SUBROUTINE SEAICE_CALC_RHS(
     O     uIceRHS, vIceRHS,
     I     newtonIter, krylovIter, myTime, myIter, myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE SEAICE_CALC_RHS
C     | o Right-hand side of momentum equations, i.e. all terms
C     |   that do not depend on the ice velocities of the current
C     |   iterate of the Newton-Krylov iteration
C     *==========================================================*
C     | written by Martin Losch, Oct 2012
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "DYNVARS.h"
#include "GRID.h"
#include "SEAICE_SIZE.h"
#include "SEAICE_PARAMS.h"
#include "SEAICE.h"

C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
C     myTime :: Simulation time
C     myIter :: Simulation timestep number
C     myThid :: my Thread Id. number
C     newtonIter :: current iterate of Newton iteration
C     krylovIter :: current iterate of Krylov iteration
      _RL     myTime
      INTEGER myIter
      INTEGER myThid
      INTEGER newtonIter
      INTEGER krylovIter
C     u/vIceRHS :: RHS of momentum equations
      _RL uIceRHS(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL vIceRHS(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)

#if ( defined SEAICE_CGRID \
      && ( defined SEAICE_ALLOW_JFNK || defined SEAICE_ALLOW_KRYLOV ) )
C     i,j,bi,bj,kSrf :: loop indices
      INTEGER i,j,bi,bj
      INTEGER kSrf
      _RS     SINWAT
      _RL     COSWAT
C     fractional area at velocity points
      _RL areaW(1:sNx,1:sNy)
      _RL areaS(1:sNx,1:sNy)
CEOP

      IF ( usingPCoords ) THEN
       kSrf = Nr
      ELSE
       kSrf = 1
      ENDIF
C--   introduce turning angles
      SINWAT=SIN(SEAICE_waterTurnAngle*deg2rad)
      COSWAT=COS(SEAICE_waterTurnAngle*deg2rad)

C     initialise fractional areas at velocity points
      DO J=1,sNy
       DO I=1,sNx
        areaW(I,J) = 1. _d 0
        areaS(I,J) = 1. _d 0
       ENDDO
      ENDDO

      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        IF ( SEAICEscaleSurfStress ) THEN
         DO J=1,sNy
          DO I=1,sNx
           areaW(I,J) = 0.5 _d 0*(AREA(I,J,bi,bj)+AREA(I-1,J,bi,bj))
           areaS(I,J) = 0.5 _d 0*(AREA(I,J,bi,bj)+AREA(I,J-1,bi,bj))
          ENDDO
         ENDDO
        ENDIF
        DO J=1,sNy
         DO I=1,sNx
C     ice-velocity independent contribution to drag terms
C     - Cdrag*(uVel*cosWat - vVel*sinWat)/(vVel*cosWat + uVel*sinWat)
C     ( remember to average to correct velocity points )
          uIceRHS(I,J,bi,bj) = FORCEX(I,J,bi,bj) + (
     &         0.5 _d 0 * ( DWATN(I,J,bi,bj)+DWATN(I-1,J,bi,bj) ) *
     &         COSWAT * uVel(I,J,kSrf,bi,bj)
     &         - SIGN(SINWAT, _fCori(I,J,bi,bj))* 0.5 _d 0 *
     &         ( DWATN(I  ,J,bi,bj) * 0.5 _d 0 *
     &          ( vVel(I  ,J,kSrf,bi,bj)+vVel(I  ,J+1,kSrf,bi,bj) )
     &         + DWATN(I-1,J,bi,bj) * 0.5 _d 0 *
     &          ( vVel(I-1,J,kSrf,bi,bj)+vVel(I-1,J+1,kSrf,bi,bj) )
     &         ) )*areaW(I,J)
          vIceRHS(I,J,bi,bj) = FORCEY(I,J,bi,bj) + (
     &         0.5 _d 0 * ( DWATN(I,J,bi,bj)+DWATN(I,J-1,bi,bj) ) *
     &         COSWAT * vVel(I,J,kSrf,bi,bj)
     &         + SIGN(SINWAT, _fCori(I,J,bi,bj)) * 0.5 _d 0 *
     &         ( DWATN(I,J  ,bi,bj) * 0.5 _d 0 *
     &          ( uVel(I,J  ,kSrf,bi,bj)+uVel(I+1,J  ,kSrf,bi,bj))
     &         + DWATN(I,J-1,bi,bj) * 0.5 _d 0 *
     &          ( uVel(I,J-1,kSrf,bi,bj)+uVel(I+1,J-1,kSrf,bi,bj))
     &         ) )*areaS(I,J)
C     apply masks for interior (important when we have open boundaries)
          uIceRHS(I,J,bi,bj) = uIceRHS(I,J,bi,bj)*maskinW(I,J,bi,bj)
          vIceRHS(I,J,bi,bj) = vIceRHS(I,J,bi,bj)*maskinS(I,J,bi,bj)
         ENDDO
        ENDDO
       ENDDO
      ENDDO

#endif /* SEAICE_CGRID, SEAICE_ALLOW_JFNK and KRYLOV */

      RETURN
      END

#include "ECCO_OPTIONS.h"


      subroutine cost_AveragesFlags(
     I                               myiter,
     I                               mytime,
     I                               mythid,
     O                               first,
     O                               last,
     O                               startofday,
     O                               startofmonth,
     O                               startofyear,
     O                               inday,
     O                               inmonth,
     O                               inyear,
     O                               endofday,
     O                               endofmonth,
     O                               endofyear,
     O                               sum1day,
     O                               dayrec,
     O                               sum1mon,
     O                               monrec,
     O                               sum1year,
     O                               yearrec
     &                             )

c     ==================================================================
c     SUBROUTINE cost_AveragesFlags
c     ==================================================================
c
c     o Get flags for the daily and monthly time averaging.
c
c     started: Christian Eckert eckert@mit.edu 24-Feb-2000
c
c              - Introduced in order to create a package for the
c                MITgcmUV.
c
c     changed:
c
c     ==================================================================
c     SUBROUTINE cost_AveragesFlags
c     ==================================================================

      implicit none

c     == global variables ==

#include "EEPARAMS.h"
#include "SIZE.h"

#include "cal.h"

c     == routine arguments ==

      integer myiter
      _RL     mytime
      integer mythid
      logical first
      logical startofday
      logical startofmonth
      logical startofyear
      logical inday
      logical inmonth
      logical inyear
      logical last
      logical endofday
      logical endofmonth
      logical endofyear
      integer sum1day
      integer dayrec
      integer sum1mon
      integer monrec
      integer sum1year
      integer yearrec

c     == local variables ==

      integer mydate(4)
      integer nextdate(4)
      integer prevdate(4)
      integer timediff(4)
      integer datediff(4)
      integer targetdate(4)
      integer targetdate1
      integer targetdate2
      integer mydateday
      integer mydatemonth
      integer mydateyear
      integer nextdateday
      integer nextdatemonth
      integer nextdateyear
      integer prevdateday
      integer prevdatemonth
      integer prevdateyear

      logical equal

c     == external functions ==

      logical  cal_CompDates
      external cal_CompDates

      integer  cal_NumInts
      external cal_NumInts

c     == end of interface ==

c--   First, get some dates.
      call cal_GetDate( myiter,   mytime,           mydate,   mythid )
      call cal_GetDate( myiter+1, mytime+modelstep, nextdate, mythid )

      call cal_TimeInterval( -modelstep, 'secs', timediff, mythid )
      call cal_AddTime( mydate, timediff, prevdate, mythid )

ce      print*,' time average flags:   mydate = ', mydate
ce      print*,' time average flags: nextdate = ', nextdate
ce      print*,' time average flags: prevdate = ', prevdate

c--   Where are we with respect to the calendar?

c--   The very first model step?
      equal = cal_CompDates(modelstartdate,mydate,mythid)
      if ( equal ) then
        first  = .true.
        dayrec = 0
        monrec = 0
        yearrec = 0
      else
        first = .false.
      endif

c--   The very last model step?
      equal = cal_CompDates(modelenddate,mydate,mythid)
      if ( equal ) then
        last = .true.
      else
        last = .false.
      endif

c--   Start of a calendar day?
      mydateday   = mod(mydate(1),100)
      prevdateday = mod(prevdate(1),100)
      if ( mydateday .ne. prevdateday ) then
        startofday = .true.
      else
        startofday = .false.
      endif

c--   End of a calendar day?
      mydateday   = mod(mydate(1),100)
      nextdateday = mod(nextdate(1),100)
      if ( mydateday .ne. nextdateday ) then
        endofday = .true.
      else
        endofday = .false.
      endif

c--   In a calendar day? As coded here, inday can not be true
c--   for either the first or the last timestep in the day.
c--   So the cases are mutually exclusive.
      if ( ( mydateday .eq. prevdateday ) .and.
     &     ( mydateday .eq. nextdateday )       ) then
        inday = .true.
      else
        inday = .false.
      endif

c--   Determine sum1day and dayrec explicitly.
      if ( last .or. endofday ) then
        if ( mydate(1) .eq. modelstartdate(1) ) then
          call cal_CopyDate( modelstartdate, targetdate, mythid )
          dayrec = 1
        else
          targetdate(1) = mydate(1)
          targetdate(2) = 0
          targetdate(3) = mydate(3)
          targetdate(4) = mydate(4)
          call cal_TimePassed( modelstartdate, targetdate, datediff,
     &                         mythid )
          if ( datediff(2) .eq. 0) then
            dayrec = datediff(1) + 1
          else
            dayrec = datediff(1) + 2
          endif
        endif
        call cal_TimeInterval( modelstep, 'secs', timediff, mythid )

        sum1day =
     &    cal_NumInts( targetdate, mydate, timediff, mythid ) + 1
      else
        sum1day = 0
      endif

c--   Start of a calendar month?
      mydatemonth   = mod(mydate(1)/100,100)
      prevdatemonth = mod(prevdate(1)/100,100)
      if ( mydatemonth .ne. prevdatemonth ) then
        startofmonth = .true.
      else
        startofmonth = .false.
      endif

c--   End of a calendar month?
      mydatemonth   = mod(mydate(1)/100,100)
      nextdatemonth = mod(nextdate(1)/100,100)
      if ( mydatemonth .ne. nextdatemonth ) then
        endofmonth = .true.
      else
        endofmonth = .false.
      endif

c--   In a calendar month? As coded here, inmonth can not be true
c--   for either the first or the last timestep in the month.
c--   So the cases are mutually exclusive.
      if ( ( mydatemonth .eq. prevdatemonth ) .and.
     &     ( mydatemonth .eq. nextdatemonth )       ) then
        inmonth = .true.
      else
        inmonth = .false.
      endif

c--   Determine sum1mon and monrec explicitly.
      if ( last .or. endofmonth ) then
        if ( (mydate(1)/100)*100 .eq. (modelstartdate(1)/100)*100 ) then
          call cal_CopyDate( modelstartdate, targetdate, mythid )
          monrec  = 1
        else
          targetdate1 = (mydate(1)/100)*100+1
          targetdate2 = 0
          call cal_FullDate( targetdate1, targetdate2, targetdate,
     &                       mythid )
          if ( mydate(1)/10000 .eq. modelstartdate(1)/10000 ) then
            monrec = mod(         mydate(1)/100, 100 )
     &             - mod( modelstartdate(1)/100, 100 ) + 1
          else
            monrec = mod( mydate(1)/100, 100 )
     &             + nmonthyear - mod(modelstartdate(1)/100,100) + 1
     &             + ( mydate(1)/10000 - modelstartdate(1)/10000 - 1)*
     &                nmonthyear
          endif
        endif
        call cal_TimeInterval( modelstep, 'secs', timediff, mythid )

        sum1mon =
     &    cal_NumInts( targetdate, mydate, timediff, mythid ) + 1
      else
        sum1mon = 0
      endif

c--   Start of a Year?
      mydateyear   = int(mydate(1)/10000)
      prevdateyear = int(prevdate(1)/10000)
      if ( mydateyear .ne. prevdateyear ) then
        startofyear = .true.
      else
        startofyear = .false.
      endif

c--   End of a Year?
      mydateyear   = int(mydate(1)/10000)
      nextdateyear = int(nextdate(1)/10000)
      if ( mydateyear .ne. nextdateyear ) then
        endofyear = .true.
      else
        endofyear = .false.
      endif

c--   In a calendar year? As coded here, inyear can not be true
c--   for either the first or the last timestep in the year.
c--   So the cases are mutually exclusive.
      if ( ( mydateyear .eq. prevdateyear ) .and.
     &     ( mydateyear .eq. nextdateyear )       ) then
        inyear = .true.
      else
        inyear = .false.
      endif

c--   Determine sum1year and yearrec explicitly.
      if ( last .or. endofyear ) then
        if (  int(mydate(1)/10000) .eq.
     &        int(modelstartdate(1)/10000) ) then
          call cal_CopyDate( modelstartdate, targetdate, mythid )
          yearrec  = 1
        else
          targetdate1 = int(mydate(1)/10000)*10000+101
          targetdate2 = 0
          call cal_FullDate( targetdate1, targetdate2, targetdate,
     &                       mythid )
          yearrec  = mydate(1)/10000 - modelstartdate(1)/10000 + 1
        endif
c
        call cal_TimeInterval( modelstep, 'secs', timediff, mythid )

        sum1year =
     &    cal_NumInts( targetdate, mydate, timediff, mythid ) + 1
      else
        sum1year = 0
      endif

      end

#include "FLT_OPTIONS.h"

CBOP 0
C !ROUTINE: FLT_UP

C !INTERFACE:
      SUBROUTINE FLT_UP (
     I                    myTime, myIter, myThid )

C     !DESCRIPTION:
C     *==========================================================*
C     | SUBROUTINE FLT_UP
C     | o This routine moves particles vertical from the target
C     |   depth to the surface and samples the model state over
C     |   the full water column at horizontal float position
C     |   every flt_int_prof time steps and writes output.
C     *==========================================================*

C     !USES:
      IMPLICIT NONE
C     == global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "DYNVARS.h"
#include "FLT_SIZE.h"
#include "FLT.h"
#include "FLT_BUFF.h"

C     !INPUT PARAMETERS:
C     myTime :: current time in simulation
C     myIter :: current iteration number
C     myThid :: my Thread Id number
      _RL myTime
      INTEGER myIter, myThid

C     !FUNCTIONS:
      _RL FLT_MAP_K2R
      EXTERNAL FLT_MAP_K2R

C     !LOCAL VARIABLES:
      INTEGER bi, bj, nFlds
      INTEGER ip, k, ii
      INTEGER imax
      PARAMETER (imax=(9+4*Nr))
      _RL tmp(imax)
      _RL ix, jy, i0x, j0y, xx, yy, zz
      _RL uu,vv,tt,ss, pp
      _RL npart_read, npart_times
      _RS dummyRS(1)
      INTEGER fp, ioUnit, irecord
      CHARACTER*(MAX_LEN_FNAM) fn
      CHARACTER*(MAX_LEN_MBUF) msgBuf
CEOP

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C--   set number of fields to write
      nFlds = 0
      IF ( flt_selectProfOutp.GE.1 ) nFlds = nFlds + 8
      IF ( flt_selectProfOutp.GE.2 ) nFlds = nFlds + 1 + 4*Nr

C--   check buffer size
      IF ( nFlds.GT.fltBufDim ) THEN
         _BEGIN_MASTER(myThid)
         WRITE(msgBuf,'(3(A,I4))') ' FLT_UP: fltBufDim=', fltBufDim,
     &                             ' too small (<', nFlds, ' )'
         CALL PRINT_ERROR( msgBuf, myThid )
         WRITE(msgBuf,'(2A)')     ' FLT_UP: => increase fltBufDim',
     &                            ' in "FLT_SIZE.h" & recompile'
         CALL PRINT_ERROR( msgBuf, myThid )
         _END_MASTER(myThid)
         CALL ALL_PROC_DIE( myThid )
         STOP 'ABNORMAL END: S/R FLT_UP'
      ENDIF

      IF ( myIter.EQ.nIter0 ) RETURN

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C--   Calculate position + other fields at float position and fill up IO-buffer

      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)

         i0x = DFLOAT( myXGlobalLo-1 + (bi-1)*sNx )
         j0y = DFLOAT( myYGlobalLo-1 + (bj-1)*sNy )
         DO ip=1,npart_tile(bi,bj)

C     Move float to the surface
           IF ( myTime.GE.tstart(ip,bi,bj) .AND.
     &         (tend(ip,bi,bj).EQ.-1..OR.myTime.LE.tend(ip,bi,bj))
     &         .AND.
     &          kpart(ip,bi,bj).EQ.kfloat(ip,bi,bj) .AND.
     &          iup(ip,bi,bj).GT.0.
     &        ) THEN

             IF ( MOD(myTime,iup(ip,bi,bj)).EQ.0.)
     &       kpart(ip,bi,bj) = flt_surf

           ENDIF

C     If float has died move to level 0
           IF ( tend(ip,bi,bj).NE.-1..AND.myTime.GT.tend(ip,bi,bj)
     &        ) THEN
             kpart(ip,bi,bj) = 0.
           ENDIF

           IF ( flt_selectProfOutp.GE.1 ) THEN
C     Convert to coordinates
             ix = ipart(ip,bi,bj)
             jy = jpart(ip,bi,bj)
             CALL FLT_MAP_IJLOCAL2XY( xx, yy,
     I                                ix, jy, bi,bj, myThid )
             zz = FLT_MAP_K2R( kpart(ip,bi,bj),bi,bj,myThid )

             tmp(1) = npart(ip,bi,bj)
             tmp(2) = myTime
             tmp(3) = xx
             tmp(4) = yy
             tmp(5) = zz
             tmp(6) = ix + i0x
             tmp(7) = jy + j0y
             tmp(8) = kpart(ip,bi,bj)
           ENDIF

           IF ( ( flt_selectProfOutp.GE.2 )    .AND.
     &          ( myTime.GE.tstart(ip,bi,bj) ) .AND.
     &          ( tend(ip,bi,bj).EQ.-1..OR.myTime.LE.tend(ip,bi,bj) )
     &        ) THEN
             CALL FLT_BILINEAR2D(ix,jy,pp,etaN,0,bi,bj,myThid)
             tmp(9) = pp
             DO k=1,Nr
               CALL FLT_BILINEAR  (ix,jy,uu,uVel,  k,1,bi,bj,myThid)
               CALL FLT_BILINEAR  (ix,jy,vv,vVel,  k,2,bi,bj,myThid)
               CALL FLT_BILINEAR  (ix,jy,tt,theta, k,0,bi,bj,myThid)
               CALL FLT_BILINEAR  (ix,jy,ss,salt,  k,0,bi,bj,myThid)
               tmp(9+k     ) = uu
               tmp(9+k+1*Nr) = vv
               tmp(9+k+2*Nr) = tt
               tmp(9+k+3*Nr) = ss
             ENDDO
           ELSEIF ( flt_selectProfOutp.GE.2 ) THEN
             DO ii=9,nFlds
               tmp(ii) = flt_nan
             ENDDO
           ENDIF

           DO ii=1,nFlds
             flt_io_buff(ii,ip,bi,bj) = tmp(ii)
           ENDDO

         ENDDO

       ENDDO
      ENDDO

      IF ( flt_selectProfOutp.LE.0 ) RETURN

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C--   Write shared buffer to file

      _BARRIER
      _BEGIN_MASTER(myThid)

      fn = 'float_profiles'
      fp = writeBinaryPrec

      DO bj=1,nSy
       DO bi=1,nSx

C (1) read actual number floats from file (if exists)
         ioUnit = -2
         CALL MDS_READVEC_LOC(  fn, fp, ioUnit, 'RL', nFlds,
     &                          tmp, dummyRS,
     &                          bi, bj, 1, myThid )
         IF ( ioUnit.GT. 0 ) THEN
            npart_read  = tmp(1)
            npart_times = tmp(5)
            ii = NINT(tmp(7))
C-       for backward compatibility with old profile files:
            IF ( ii.EQ.0 ) ii = 9+4*Nr
            IF ( ii.NE.nFlds ) THEN
              WRITE(msgBuf,'(A,I4,A)')
     &            'FLT_UP: nFlds=', nFlds,' different from'
              CALL PRINT_ERROR( msgBuf, myThid )
              WRITE(msgBuf,'(3A,I4,A)')
     &            'previous file (',fn(1:14),') value =',ii
              CALL PRINT_ERROR( msgBuf, myThid )
              CALL ALL_PROC_DIE( 0 )
              STOP 'ABNORMAL END: S/R FLT_UP'
            ENDIF
C-       close the read-unit (safer to use a different unit for writing)
            CLOSE( ioUnit )
         ELSE
            npart_read  = 0.
            npart_times = 0.
            tmp(2)      = myTime
         ENDIF

C (2) write new actual number floats and time into file
C-    the standard routine mds_writevec_loc can be used here

C     total number of records in this file
         tmp(1) = DBLE(npart_tile(bi,bj))+npart_read
C     first time of writing floats (do not change when written)
c        tmp(2) = tmp(2)
C     current time
         tmp(3) = myTime
C     timestep
         tmp(4) = flt_int_prof
C     total number of timesteps
         tmp(5) = npart_times + 1.
C     total number of floats
         tmp(6) = max_npart
C     total number of fields
         tmp(7) = nFlds
         DO ii=8,nFlds
           tmp(ii) = 0.
         ENDDO
         ioUnit = -1
         CALL MDS_WRITEVEC_LOC( fn, fp, ioUnit, 'RL', nFlds,
     &                          tmp, dummyRS,
     &                          bi, bj, -1, myIter, myThid )

         DO ip=1,npart_tile(bi,bj)
C (3) write float positions into file
           irecord = npart_read+ip+1
           IF ( ip.NE.npart_tile(bi,bj) ) irecord = -irecord
           CALL MDS_WRITEVEC_LOC( fn, fp, ioUnit, 'RL', nFlds,
     &                            flt_io_buff(1,ip,bi,bj), dummyRS,
     &                            bi, bj, irecord, myIter, myThid )
         ENDDO
         CLOSE( ioUnit )

       ENDDO
      ENDDO

      _END_MASTER(myThid)
      _BARRIER

      RETURN
      END

#include "GMREDI_OPTIONS.h"

C     !ROUTINE: GMREDI_CALC_BATES_K
C     !INTERFACE:
      SUBROUTINE GMREDI_CALC_BATES_K(
     I                  iMin, iMax, jMin, jMax,
     I                  sigmaX, sigmaY, sigmaR,
     I                  bi, bj, myTime, myIter, myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE GMREDI_CALC_BATES_K
C     | o Calculates the 3D diffusivity as per Bates et al. (2014)
C     *==========================================================*
C     \ev

      IMPLICIT NONE

C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "DYNVARS.h"
#include "FFIELDS.h"
#include "GMREDI.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     bi, bj    :: tile indices
C     myTime    :: Current time in simulation
C     myIter    :: Current iteration number in simulation
C     myThid    :: My Thread Id. number

      INTEGER iMin,iMax,jMin,jMax
      _RL sigmaX(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL sigmaY(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL sigmaR(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      INTEGER bi, bj
      _RL myTime
      INTEGER myIter
      INTEGER myThid

#ifdef GM_BATES_K3D

C     === Functions ====
      LOGICAL  DIFFERENT_MULTIPLE
      EXTERNAL DIFFERENT_MULTIPLE

C     !LOCAL VARIABLES:
C     == Local variables ==
      INTEGER i,j,k,kk,m,kp1

C     update_modes :: Whether to update the eigenmodes
      LOGICAL update_modes

C     surfk  :: index of the depth of the surface layer
C     kLow_C :: Local version of the index of deepest wet grid cell on tracer grid
C     kLow_U :: Local version of the index of deepest wet grid cell on U grid
C     kLow_V :: Local version of the index of deepest wet grid cell on V grid
      INTEGER surfk(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER kLow_C(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER kLow_U(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER kLow_V(1-OLx:sNx+OLx,1-OLy:sNy+OLy)

C     N2loc  :: local N**2
C     slope  :: local slope
C     Req    :: local equatorial deformation radius (m)
C     deltaH :: local thickness of Eady integration (m)
C     g_reciprho_sq :: (gravity*recip_rhoConst)**2
C     M4loc  :: local M**4
C     maxDRhoDz :: maximum value of d(rho)/dz (derived from GM_Bates_minN2)
C     sigx   :: local d(rho)/dx
C     sigy   :: local d(rho)/dy
C     sigz   :: local d(rho)/dz
C     hsurf  :: local surface layer depth
C     small  :: a small number (to avoid floating point exceptions)
      _RL N2loc(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL slope
      _RL slopeC(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL Req
      _RL deltaH(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL g_reciprho_sq
      _RL M4loc(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL M4onN2(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL maxDRhoDz
      _RL sigx, sigy, sigz
      _RL hsurf, mskp1
      _RL small

C     dfdy    :: gradient of the Coriolis paramater, df/dy, 1/(m*s)
C     dfdx    :: gradient of the Coriolis paramater, df/dx, 1/(m*s)
C     Rurms  :: a local mixing length used in calculation of urms (m)
C     RRhines :: The Rhines scale (m)
C     Rmix    :: Mixing length
C     N2      :: Square of the buoyancy frequency (1/s**2)
C     N2W     :: Square of the buoyancy frequency (1/s**2) averaged to west of grid cell
C     N2S     :: Square of the buoyancy frequency (1/s**2) averaged to south of grid cell
C     N       :: Buoyancy frequency, SQRT(N2)
C     BVint   :: The vertical integral of N (m/s)
C     ubar    :: Zonal velocity on a tracer point (m/s)
C     Ubaro   :: Barotropic velocity (m/s)
      _RL dfdy(   1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL dfdx(   1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL dummy(  1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL Rurms(  1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL RRhines(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL Rmix(   1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL N2(     1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL N2W(    1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL N2S(    1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL N(      1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL BVint(  1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL Ubaro(  1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL ubar(   1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)

      _RL tmpU(  1-OLx:sNx+OLx,1-OLy:sNy+OLy )
      _RL tmpV(  1-OLx:sNx+OLx,1-OLy:sNy+OLy )
      _RL uFldX( 1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr )
      _RL vFldY( 1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr )

C     Rmid     :: Rossby radius (m)
C     KPV      :: Diffusivity (m**2/s)
C     Kdqdx    :: diffusivity multiplied by zonal PV gradient
C     Kdqdy    :: diffusivity multiplied by meridional PV gradient
C     SlopeX   :: isopycnal slope in x direction
C     SlopeY   :: isopycnal slope in y direction
C     dSigmaDx :: sigmaX averaged onto tracer grid
C     dSigmaDy :: sigmaY averaged onto tracer grid
C     tfluxX   :: thickness flux in x direction
C     tfluxY   :: thickness flux in y direction
C     fCoriU   :: Coriolis parameter averaged to U points
C     fCoriV   :: Coriolis parameter averaged to V points
C     coriU    :: As fCoriU, but limited
C     coriV    :: As fCoriV, but limited
C     surfkz   :: Depth of surface layer (in r units)
      _RL Rmid(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL KPV(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL Kdqdy(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL Kdqdx(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL SlopeX(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL SlopeY(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL dSigmaDx(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL dSigmaDy(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL tfluxX(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL tfluxY(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL coriU(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL coriV(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL fCoriU(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL fCoriV(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL surfkz(1-OLx:sNx+OLx,1-OLy:sNy+OLy)

C     centreX,centreY :: used for calculating averages at centre of cell
C     numerator,denominator :: of the renormalisation factor
C     uInt      :: column integral of u velocity (sum u*dz)
C     vInt      :: column integral of v velocity (sum v*dz)
C     KdqdxInt  :: column integral of K*dqdx (sum K*dqdx*dz)
C     KdqdyInt  :: column integral of K*dqdy (sum K*dqdy*dz)
C     uKdqdyInt :: column integral of u*K*dqdy (sum u*K*dqdy*dz)
C     vKdqdxInt :: column integral of v*K*dqdx (sum v*K*dqdx*dz)
C     uXiyInt   :: column integral of u*Xiy (sum u*Xiy*dz)
C     vXixInt   :: column integral of v*Xix (sum v*Xix*dz)
C     Renorm    :: renormalisation factor at the centre of a cell
C     RenormU   :: renormalisation factor at the western face of a cell
C     RenormV   :: renormalisation factor at the southern face of a cell
      _RL centreX, centreY
      _RL numerator, denominator
      _RL uInt(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL vInt(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL KdqdxInt(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL KdqdyInt(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL uKdqdyInt(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL vKdqdxInt(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL uXiyInt(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL vXixInt(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL Renorm(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL RenormU(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL RenormV(1-OLx:sNx+OLx,1-OLy:sNy+OLy)

C     gradqx   :: Potential vorticity gradient in x direction
C     gradqy   :: Potential vorticity gradient in y direction
C     XimX     :: Vertical integral of phi_m*K*gradqx
C     XimY     :: Vertical integral of phi_m*K*gradqy
C     cDopp    :: Quasi-Doppler shifted long Rossby wave speed (m/s)
C     umc      :: ubar-c (m/s)
C     eady     :: Eady growth rate (1/s)
C     urms     :: the rms eddy velocity (m/s)
C     supp     :: The suppression factor
C     ustar    :: The eddy induced velocity in the x direction
C     vstar    :: The eddy induced velocity in the y direction
C     Xix      :: Xi in the x direction (m/s**2)
C     Xiy      :: Xi in the y direction (m/s**2)
      _RL gradqx(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL gradqy(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL XimX(GM_Bates_NModes,1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL XimY(GM_Bates_NModes,1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL cDopp(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL umc(  1-OLx:sNx+OLx,1-OLy:sNy+OLy,1:Nr)
      _RL eady( 1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL urms( 1-OLx:sNx+OLx,1-OLy:sNy+OLy,1:Nr)
      _RL supp( 1-OLx:sNx+OLx,1-OLy:sNy+OLy,1:Nr)
      _RL ustar(1-OLx:sNx+OLx,1-OLy:sNy+OLy,1:Nr)
      _RL vstar(1-OLx:sNx+OLx,1-OLy:sNy+OLy,1:Nr)
      _RL Xix(   1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL Xiy(   1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
#ifdef GM_BATES_PASSIVE
C     psistar :: eddy induced streamfunction in the y direction
      _RL psistar(1-OLx:sNx+OLx,1-OLy:sNy+OLy,1:Nr)
#endif

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C     ======================================
C     Initialise some variables
C     ======================================
      small = TINY(zeroRL)
      update_modes=.FALSE.
      IF ( DIFFERENT_MULTIPLE(GM_Bates_vecFreq,myTime,deltaTClock) )
     &     update_modes=.TRUE.

      DO j=1-OLy,sNy+OLy
       DO i=1-OLx,sNx+OLx
        kLow_C(i,j) = kLowC(i,j,bi,bj)
       ENDDO
      ENDDO
      DO j=1-OLy,sNy+OLy
       DO i=1-OLx+1,sNx+OLx
        kLow_U(i,j) = MIN( kLow_C(i,j), kLow_C(i-1,j) )
       ENDDO
      ENDDO
      DO j=1-OLy+1,sNy+OLy
       DO i=1-OLx,sNx+OLx
        kLow_V(i,j) = MIN( kLow_C(i,j), kLow_C(i,j-1) )
       ENDDO
      ENDDO

C     Dummy values for the edges. This does not affect the results
C     but avoids problems when solving for the eigenvalues.
      i=1-OLx
      DO j=1-OLy,sNy+OLy
       kLow_U(i,j) = 0
      ENDDO
      j=1-OLy
      DO i=1-OLx,sNx+OLx
       kLow_V(i,j) = 0
      ENDDO

      g_reciprho_sq = (gravity*recip_rhoConst)**2
C     Gradient of Coriolis
      DO j=1-OLy+1,sNy+OLy
       DO i=1-OLx+1,sNx+OLx
        dfdx(i,j) = ( fCori(i,j,bi,bj)-fCori(i-1,j,bi,bj) )
     &              *recip_dxC(i,j,bi,bj)
        dfdy(i,j) = ( fCori(i,j,bi,bj)-fCori(i,j-1,bi,bj) )
     &              *recip_dyC(i,j,bi,bj)
       ENDDO
      ENDDO

C     Coriolis at U and V points enforcing a minimum value so
C     that it is defined at the equator
      DO j=1-OLy,sNy+OLy
       DO i=1-OLx+1,sNx+OLx
C       Not limited
        fCoriU(i,j)= op5*( fCori(i,j,bi,bj)+fCori(i-1,j,bi,bj) )
C       Limited so that the inverse is defined at the equator
        coriU(i,j) = SIGN( MAX( ABS(fCoriU(i,j)),GM_Bates_minCori ),
     &                              fCoriU(i,j) )
       ENDDO
      ENDDO
      DO j=1-OLy+1,sNy+OLy
       DO i=1-OLx,sNx+OLx
C       Not limited
        fCoriV(i,j)= op5*( fCori(i,j,bi,bj)+fCori(i,j-1,bi,bj) )
C       Limited so that the inverse is defined at the equator
        coriV(i,j) = SIGN( MAX( ABS(fCoriV(i,j)),GM_Bates_minCori ),
     &                              fCoriV(i,j) )
       ENDDO
      ENDDO
C     Some dummy values at the edges
      i=1-OLx
      DO j=1-OLy,sNy+OLy
       fCoriU(i,j)= fCori(i,j,bi,bj)
       coriU(i,j) = SIGN( MAX( ABS(fCori(i,j,bi,bj)),GM_Bates_minCori ),
     &                             fCori(i,j,bi,bj) )
      ENDDO
      j=1-OLy
      DO i=1-OLx,sNx+OLx
       fCoriV(i,j)= fCori(i,j,bi,bj)
       coriV(i,j) = SIGN( MAX( ABS(fCori(i,j,bi,bj)),GM_Bates_minCori ),
     &                             fCori(i,j,bi,bj) )
      ENDDO

C     Zeroing some cumulative fields
      DO j=1-OLy,sNy+OLy
       DO i=1-OLx,sNx+OLx
        eady(i,j)   = zeroRL
        BVint(i,j)  = zeroRL
        Ubaro(i,j)  = zeroRL
        deltaH(i,j) = zeroRL
       ENDDO
      ENDDO
      DO k=1,Nr
       DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
         slopeC(i,j,k)=zeroRL
        ENDDO
       ENDDO
      ENDDO

C     initialise remaining 2d variables
      DO j=1-OLy,sNy+OLy
       DO i=1-OLx,sNx+OLx
        Rurms(i,j)=zeroRL
        RRhines(i,j)=zeroRL
        Rmix(i,j)=zeroRL
       ENDDO
      ENDDO
C     initialise remaining 3d variables
      DO k=1,Nr
       DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
         N2loc(i,j,k)=GM_Bates_minN2
         N2W(i,j,k) = GM_Bates_minN2
         N2S(i,j,k) = GM_Bates_minN2
         M4loc(i,j,k)=zeroRL
         M4onN2(i,j,k)=zeroRL
         urms(i,j,k)=zeroRL
         SlopeX(i,j,k)=zeroRL
         SlopeY(i,j,k)=zeroRL
         dSigmaDx(i,j,k)=zeroRL
         dSigmaDy(i,j,k)=zeroRL
         gradqx(i,j,k)=zeroRL
         gradqy(i,j,k)=zeroRL
        ENDDO
       ENDDO
      ENDDO

C     Find the zonal velocity at the cell centre
#ifdef ALLOW_EDDYPSI
      IF (GM_InMomAsStress) THEN
        DO k=1,Nr
         DO i = 1-OLx,sNx+OLx
          DO j = 1-OLy,sNy+OLy
           uFldX(i,j,k) = uEulerMean(i,j,k,bi,bj)
           vFldY(i,j,k) = vEulerMean(i,j,k,bi,bj)
          ENDDO
         ENDDO
        ENDDO
      ELSE
#endif
        DO k=1,Nr
         DO i = 1-OLx,sNx+OLx
          DO j = 1-OLy,sNy+OLy
           uFldX(i,j,k) = uVel(i,j,k,bi,bj)
           vFldY(i,j,k) = vVel(i,j,k,bi,bj)
          ENDDO
         ENDDO
        ENDDO
#ifdef ALLOW_EDDYPSI
      ENDIF
#endif

C     The following comes from rotate_uv2en_rl
C     This code does two things:
C     1) go from C grid velocity points to A grid velocity points
C     2) go from model grid directions to east/west directions
      DO k = 1,Nr
       DO i = 1-OLx,sNx+OLx
        j=sNy+OLy
        tmpU(i,j)=zeroRL
        tmpV(i,j)=zeroRL
       ENDDO
       DO j = 1-OLy,sNy+OLy-1
        i=sNx+OLx
        tmpU(i,j)=zeroRL
        tmpV(i,j)=zeroRL
        DO i = 1-OLx,sNx+OLx-1
         tmpU(i,j) = 0.5 _d 0
     &        *( uFldX(i+1,j,k) + uFldX(i,j,k) )
         tmpV(i,j) = 0.5 _d 0
     &        *( vFldY(i,j+1,k) + vFldY(i,j,k) )

         tmpU(i,j) = tmpU(i,j) * maskC(i,j,k,bi,bj)
         tmpV(i,j) = tmpV(i,j) * maskC(i,j,k,bi,bj)
        ENDDO
       ENDDO
C     Rotation
       DO j = 1-OLy,sNy+OLy
        DO i = 1-OLx,sNx+OLx
         ubar(i,j,k) =
     &        angleCosC(i,j,bi,bj)*tmpU(i,j)
     &        -angleSinC(i,j,bi,bj)*tmpV(i,j)
        ENDDO
       ENDDO
      ENDDO

C     Calculate the barotropic velocity by vertically integrating
C     and the dividing by the depth of the water column
C     Note that Ubaro is at the C-point.
      DO k=1,Nr
       DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
         Ubaro(i,j) = Ubaro(i,j) +
     &        drF(k)*hfacC(i,j,k,bi,bj)*ubar(i,j,k)
        ENDDO
       ENDDO
      ENDDO
      DO j=1-OLy,sNy+OLy
       DO i=1-OLx,sNx+OLx
        IF (kLow_C(i,j).GT.0) THEN
C         The minus sign is because r_Low<0
          Ubaro(i,j) = -Ubaro(i,j)/r_Low(i,j,bi,bj)
        ENDIF
       ENDDO
      ENDDO

C     Square of the buoyancy frequency at the top of a grid cell
C     Enforce a minimum N2
C     Mask N2, so it is zero at bottom
      DO k=2,Nr
       DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
         N2(i,j,k) = -gravity*recip_rhoConst*sigmaR(i,j,k)
         N2(i,j,k) = MAX(N2(i,j,k),GM_Bates_minN2)*maskC(i,j,k,bi,bj)
         N(i,j,k)  = SQRT(N2(i,j,k))
        ENDDO
       ENDDO
      ENDDO
C     N2(k=1) is always zero
      DO j=1-OLy,sNy+OLy
       DO i=1-OLx,sNx+OLx
        N2(i,j,1) = zeroRL
        N(i,j,1)  = zeroRL
       ENDDO
      ENDDO
C     Calculate the minimum drho/dz
      maxDRhoDz = -rhoConst*GM_Bates_minN2/gravity

C     Integrate the buoyancy frequency vertically using the trapezoidal method.
C     Assume that N(z=-H)=0
      DO k=1,Nr
       kp1 = min(k+1,Nr)
       mskp1 = oneRL
       IF ( k.EQ.Nr ) mskp1 = zeroRL
       DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
           BVint(i,j) = BVint(i,j) + hFacC(i,j,k,bi,bj)*drF(k)
     &                         *op5*(N(i,j,k)+mskp1*N(i,j,kp1))
        ENDDO
       ENDDO
      ENDDO

C     Calculate the eigenvalues and eigenvectors
      IF (update_modes) THEN
        CALL GMREDI_CALC_EIGS(
     I       iMin,iMax,jMin,jMax,bi,bj,N2,myThid,
     I       kLow_C, maskC(:,:,:,bi,bj),
     I       hfacC(:,:,:,bi,bj), recip_hfacC(:,:,:,bi,bj),
     I       R_Low(:,:,bi,bj), 1, .TRUE.,
     O       Rmid, modesC(:,:,:,:,bi,bj))

C       Calculate the Rossby Radius
        DO j=1-OLy+1,sNy+OLy
         DO i=1-OLx+1,sNx+OLx
          Req  = SQRT(BVint(i,j)/(2. _d 0*pi*gradf(i,j,bi,bj)))
          Rdef(i,j,bi,bj) = MIN(Rmid(i,j),Req)
         ENDDO
        ENDDO
      ENDIF

C     Average dsigma/dx and dsigma/dy onto the centre points
      DO k=1,Nr
       DO j=1-OLy,sNy+OLy-1
        DO i=1-OLx,sNx+OLx-1
         dSigmaDx(i,j,k) = op5*(sigmaX(i,j,k)+sigmaX(i+1,j,k))
         dSigmaDy(i,j,k) = op5*(sigmaY(i,j,k)+sigmaY(i,j+1,k))
        ENDDO
       ENDDO
      ENDDO

C     ===============================
C     Calculate the Eady growth rate
C     ===============================
      DO k=1,Nr

       kp1 = min(k+1,Nr)
       mskp1 = oneRL
       IF ( k.EQ.Nr ) mskp1 = zeroRL

       DO j=1-OLy,sNy+OLy-1
        DO i=1-OLx,sNx+OLx-1
         M4loc(i,j,k) = g_reciprho_sq*( dSigmaDx(i,j,k)**2
     &                                 +dSigmaDy(i,j,k)**2 )
         N2loc(i,j,k) = op5*(N2(i,j,k)+mskp1*N2(i,j,kp1))
        ENDDO
       ENDDO
C      The bottom of the grid cell is shallower than the top
C      integration level, so, advance the depth.
       IF (-rF(k+1) .LE. GM_Bates_EadyMinDepth) CYCLE

C      Do not bother going any deeper since the top of the
C      cell is deeper than the bottom integration level
       IF (-rF(k).GE.GM_Bates_EadyMaxDepth) EXIT

C      We are in the integration depth range
       DO j=1-OLy,sNy+OLy-1
        DO i=1-OLx,sNx+OLx-1
         IF ( (kLow_C(i,j).GE.k) .AND.
     &        (-hMixLayer(i,j,bi,bj).LE.-rC(k)) ) THEN

           slopeC(i,j,k) = SQRT(M4loc(i,j,k))/N2loc(i,j,k)
C          Limit the slope.  Note, this is not all the Eady calculations.
           IF (slopeC(i,j,k).LE.GM_maxSlope) THEN
             M4onN2(i,j,k) = M4loc(i,j,k)/N2loc(i,j,k)
           ELSE
             slopeC(i,j,k) = GM_maxslope
             M4onN2(i,j,k) = SQRT(M4loc(i,j,k))*GM_maxslope
           ENDIF
           eady(i,j)   = eady(i,j)
     &                   + hfacC(i,j,k,bi,bj)*drF(k)*M4onN2(i,j,k)
           deltaH(i,j) = deltaH(i,j) + drF(k)
         ENDIF
        ENDDO
       ENDDO
      ENDDO

      DO j=1-OLy,sNy+OLy
       DO i=1-OLx,sNx+OLx
C       If the minimum depth for the integration is deeper than the ocean
C       bottom OR the mixed layer is deeper than the maximum depth of
C       integration, we set the Eady growth rate to something small
C       to avoid floating point exceptions.
C       Later, these areas will be given a small diffusivity.
        IF (deltaH(i,j).EQ.zeroRL) THEN
          eady(i,j) = small

C       Otherwise, divide over the integration and take the square root
C       to actually find the Eady growth rate.
        ELSE
          eady(i,j) = SQRT(eady(i,j)/deltaH(i,j))

        ENDIF

       ENDDO
      ENDDO

C     ======================================
C     Calculate the diffusivity
C     ======================================
      DO j=1-OLy+1,sNy+OLy
       DO i=1-OLx+1,sNx+OLx-1
C       Calculate the Visbeck velocity
        Rurms(i,j) = MIN(Rdef(i,j,bi,bj),GM_Bates_Rmax)
        urms(i,j,1) = GM_Bates_Lambda*eady(i,j)*Rurms(i,j)
C       Set the bottom urms to zero
        k=kLow_C(i,j)
        IF (k.GT.0) urms(i,j,k) = 0.0

C       Calculate the Rhines scale
        RRhines(i,j) = SQRT(urms(i,j,1)/gradf(i,j,bi,bj))

C       Calculate the estimated length scale
        Rmix(i,j) = MIN(Rdef(i,j,bi,bj), RRhines(i,j))
        Rmix(i,j) = MAX(Rmix(i,j),GM_Bates_Rmin)

C       Calculate the Doppler shifted long Rossby wave speed
C       Ubaro is at the C-point.
        cDopp(i,j) = Ubaro(i,j)
     &                - gradf(i,j,bi,bj)*Rdef(i,j,bi,bj)*Rdef(i,j,bi,bj)
C       Limit the wave speed to the namelist variable GM_Bates_maxC
        IF (ABS(cDopp(i,j)).GT.GM_Bates_maxC) THEN
          cDopp(i,j) = MAX(GM_Bates_maxC, cDopp(i,j))
        ENDIF

       ENDDO
      ENDDO

C     Project the surface urms to the subsurface using the first baroclinic mode
      CALL GMREDI_CALC_URMS(
     I     iMin,iMax,jMin,jMax,bi,bj,N2,myThid,
     U     urms)

C     Calculate the diffusivity (on the mass grid)
      DO k=1,Nr
       DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
         IF (k.LE.kLow_C(i,j)) THEN
           IF (deltaH(i,j).EQ.zeroRL) THEN
             GM_BatesK3d(i,j,k,bi,bj) = GM_Bates_smallK
           ELSE
             IF (urms(i,j,k).EQ.0.0) THEN
               GM_BatesK3d(i,j,k,bi,bj) = GM_Bates_smallK
             ELSE
              umc(i,j,k) =ubar(i,j,k) - cDopp(i,j)
              supp(i,j,k) = 1./
     &               ( 1. + GM_Bates_b1*umc(i,j,k)**2/urms(i,j,1)**2 )
C              2*Rmix gives the diameter
              GM_BatesK3d(i,j,k,bi,bj) = GM_Bates_gamma*urms(i,j,k)
     &                           *2.*Rmix(i,j)*supp(i,j,k)
             ENDIF

C            Enforce lower and upper bounds on the diffusivity
             GM_BatesK3d(i,j,k,bi,bj) =
     &               MIN( GM_BatesK3d(i,j,k,bi,bj), GM_Bates_maxK )
             GM_BatesK3d(i,j,k,bi,bj) =
     &               MAX( GM_BatesK3d(i,j,k,bi,bj), GM_Bates_smallK )
           ENDIF
         ENDIF
        ENDDO
       ENDDO
      ENDDO

C     ======================================
C     Find the PV gradient
C     ======================================
C     Calculate the surface layer thickness.
C     Use hMixLayer (calculated in model/src/calc_oce_mxlayer)
C     for the mixed layer depth.

C     Enforce a minimum surface layer depth
      DO j=1-OLy,sNy+OLy
       DO i=1-OLx,sNx+OLx
        surfkz(i,j) = MIN(-GM_Bates_surfMinDepth,-hMixLayer(i,j,bi,bj))
        surfkz(i,j) = MAX(surfkz(i,j),R_low(i,j,bi,bj))
        IF(maskC(i,j,1,bi,bj).EQ.0.0) surfkz(i,j)=0.0
        surfk(i,j) = 0
       ENDDO
      ENDDO
      DO k=1,Nr
       DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
         IF (rF(k).GT.surfkz(i,j) .AND. surfkz(i,j).GE.rF(k+1))
     &        surfk(i,j) = k
        ENDDO
       ENDDO
      ENDDO

C     Calculate the isopycnal slope
      DO j=1-OLy,sNy+OLy-1
       DO i=1-OLx,sNx+OLx-1
        SlopeX(i,j,1) = zeroRL
        SlopeY(i,j,1) = zeroRL
       ENDDO
      ENDDO
      DO k=2,Nr
       DO j=1-OLy+1,sNy+OLy
        DO i=1-OLx+1,sNx+OLx
         IF(surfk(i,j).GE.kLowC(i,j,bi,bj)) THEN
C          If the surface layer is thinner than the water column
C          the set the slope to zero to avoid problems.
           SlopeX(i,j,k) = zeroRL
           SlopeY(i,j,k) = zeroRL

         ELSE
C          Calculate the zonal slope at the western cell face (U grid)
           sigz  = MIN( op5*(sigmaR(i,j,k)+sigmaR(i-1,j,k)), maxDRhoDz )
           sigx  = op5*( sigmaX(i,j,k)+sigmaX(i,j,k-1) )
           slope = sigx/sigz
           IF(ABS(slope).GT.GM_maxSlope)
     &          slope = SIGN(GM_maxSlope,slope)
           SlopeX(i,j,k)=-maskW(i,j,k-1,bi,bj)*maskW(i,j,k,bi,bj)*slope

C          Calculate the meridional slope at the southern cell face (V grid)
           sigz  = MIN( op5*(sigmaR(i,j,k)+sigmaR(i,j-1,k)), maxDRhoDz )
           sigy  = op5*( sigmaY(i,j,k) + sigmaY(i,j,k-1) )
           slope = sigy/sigz
           IF(ABS(slope).GT.GM_maxSlope)
     &          slope = SIGN(GM_maxSlope,slope)
           SlopeY(i,j,k)=-maskS(i,j,k-1,bi,bj)*maskS(i,j,k,bi,bj)*slope
         ENDIF
        ENDDO
       ENDDO
      ENDDO

C     Calculate gradients of PV stretching term and PV diffusivity.
C     These may be altered later depending on namelist options.
C     Enforce a zero slope bottom boundary condition for the bottom most cells (k=Nr)
      k=Nr
      DO j=1-OLy,sNy+OLy
       DO i=1-OLx,sNx+OLx
C          Zonal gradient of PV stretching term: at the western cell face
           tfluxX(i,j,k) = -fCoriU(i,j)*SlopeX(i,j,k)
     &                      *recip_drF(k)*recip_hFacW(i,j,k,bi,bj)
C     Meridional gradient of PV stretching term: at the southern cell face
           tfluxY(i,j,k) = -fCoriV(i,j)*SlopeY(i,j,k)
     &                     *recip_drF(k)*recip_hFacS(i,j,k,bi,bj)

C          Use the interior diffusivity. Note: if we are using a
C          constant diffusivity KPV is overwritten later
           KPV(i,j,k) = GM_BatesK3d(i,j,k,bi,bj)

       ENDDO
      ENDDO

C     Calculate gradients of PV stretching term and PV diffusivity: for other cells (k<Nr)
      DO k=Nr-1,1,-1
       DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
C          Zonal gradient of PV stretching term: at the western cell face
         tfluxX(i,j,k)=-fCoriU(i,j)*(SlopeX(i,j,k)-SlopeX(i,j,k+1))
     &        *recip_drF(k)*recip_hFacW(i,j,k,bi,bj)
     &        *maskW(i,j,k,bi,bj)
C     Meridional gradient of PV stretching term: at the southern cell face
         tfluxY(i,j,k)=-fCoriV(i,j)*(SlopeY(i,j,k)-SlopeY(i,j,k+1))
     &        *recip_drF(k)*recip_hFacS(i,j,k,bi,bj)
     &        *maskS(i,j,k,bi,bj)

C        Use the interior diffusivity. Note: if we are using a
C        constant diffusivity KPV is overwritten later
         KPV(i,j,k) = GM_BatesK3d(i,j,k,bi,bj)
        ENDDO
       ENDDO
      ENDDO

C     Special treatment for the surface layer (if necessary), which overwrites
C     values in the previous loops.
      IF (GM_Bates_ThickSheet .OR. GM_Bates_surfK) THEN
        DO k=Nr-1,1,-1
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           IF(k.LE.surfk(i,j)) THEN
C            We are in the surface layer.  Change the thickness flux
C            and diffusivity as necessary.

             IF (GM_Bates_ThickSheet) THEN
C              We are in the surface layer, so set the thickness flux
C              based on the average slope over the surface layer
C              If we are on the edge of a "cliff" the surface layer at the
C              centre of the grid point could be deeper than the U or V point.
C              So, we ensure that we always take a sensible slope.
               IF(kLow_U(i,j).LT.surfk(i,j)) THEN
                 kk=kLow_U(i,j)
                 hsurf = -rLowW(i,j,bi,bj)
               ELSE
                 kk=surfk(i,j)
                 hsurf = -surfkz(i,j)
               ENDIF
               IF(kk.GT.0) THEN
                 IF(kk.EQ.Nr) THEN
                   tfluxX(i,j,k) = -fCoriU(i,j)*maskW(i,j,k,bi,bj)
     &                  *SlopeX(i,j,kk)/hsurf
                 ELSE
                   tfluxX(i,j,k) = -fCoriU(i,j)*maskW(i,j,k,bi,bj)
     &                  *( SlopeX(i,j,kk)-SlopeX(i,j,kk+1) )/hsurf
                 ENDIF
               ELSE
                 tfluxX(i,j,k) = zeroRL
               ENDIF

               IF(kLow_V(i,j).LT.surfk(i,j)) THEN
                 kk=kLow_V(i,j)
                 hsurf = -rLowS(i,j,bi,bj)
               ELSE
                 kk=surfk(i,j)
                 hsurf = -surfkz(i,j)
               ENDIF
               IF(kk.GT.0) THEN
                 IF(kk.EQ.Nr) THEN
                   tfluxY(i,j,k) = -fCoriV(i,j)*maskS(i,j,k,bi,bj)
     &                  *SlopeY(i,j,kk)/hsurf
                 ELSE
                   tfluxY(i,j,k) = -fCoriV(i,j)*maskS(i,j,k,bi,bj)
     &                  *( SlopeY(i,j,kk)-SlopeY(i,j,kk+1) )/hsurf
                 ENDIF
               ELSE
                 tfluxY(i,j,k) = zeroRL
               ENDIF
             ENDIF

             IF (GM_Bates_surfK) THEN
C              Use a constant K in the surface layer.
               KPV(i,j,k) = GM_Bates_constK
             ENDIF
           ENDIF
          ENDDO
         ENDDO
        ENDDO
      ENDIF

C     Calculate gradq
      IF (GM_Bates_beta_eq_0) THEN
C       Ignore beta in the calculation of grad(q)
        DO k=1,Nr
         DO j=1-OLy+1,sNy+OLy
          DO i=1-OLx+1,sNx+OLx
           gradqx(i,j,k) = maskW(i,j,k,bi,bj)*tfluxX(i,j,k)
           gradqy(i,j,k) = maskS(i,j,k,bi,bj)*tfluxY(i,j,k)
          ENDDO
         ENDDO
        ENDDO

      ELSE
C       Do not ignore beta
        DO k=1,Nr
         DO j=1-OLy+1,sNy+OLy
          DO i=1-OLx+1,sNx+OLx
           gradqx(i,j,k) = maskW(i,j,k,bi,bj)*(dfdx(i,j)+tfluxX(i,j,k))
           gradqy(i,j,k) = maskS(i,j,k,bi,bj)*(dfdy(i,j)+tfluxY(i,j,k))
          ENDDO
         ENDDO
        ENDDO
      ENDIF

C     ======================================
C     Find Xi and the eddy induced velocities
C     ======================================
C     Find the buoyancy frequency at the west and south faces of a cell
C     This is necessary to find the eigenvectors at those points
      DO k=1,Nr
       DO j=1-OLy+1,sNy+OLy
        DO i=1-OLx+1,sNx+OLx
         N2W(i,j,k) = maskW(i,j,k,bi,bj)
     &                *( N2(i,j,k)+N2(i-1,j,k) )
         N2S(i,j,k) = maskS(i,j,k,bi,bj)
     &                *( N2(i,j,k)+N2(i,j-1,k) )
        ENDDO
       ENDDO
      ENDDO

C     If GM_Bates_use_constK=T, the diffusivity for the eddy transport is
C     set to a constant equal to GM_Bates_constK.
C     If the diffusivity is constant the method here is the same as GM.
C     If GM_Bates_constRedi=T, BatesK3d will be set to GM_Bates_constK later.
      IF(GM_Bates_use_constK) THEN
        DO k=1,Nr
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           KPV(i,j,k) = GM_Bates_constK
          ENDDO
         ENDDO
        ENDDO
      ENDIF

      IF (.NOT. GM_Bates_smooth) THEN
C       Do not expand K grad(q) => no smoothing
C       May only be done with a constant K, otherwise the
C       integral constraint is violated.
        DO k=1,Nr
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           Xix(i,j,k) = -maskW(i,j,k,bi,bj)*KPV(i,j,k)*gradqx(i,j,k)
           Xiy(i,j,k) = -maskS(i,j,k,bi,bj)*KPV(i,j,k)*gradqy(i,j,k)
          ENDDO
         ENDDO
        ENDDO

      ELSE
C       Expand K grad(q) in terms of baroclinic modes to smooth
C       and satisfy the integral constraint

C       Start with the X direction
C       ------------------------------
C       Calculate the eigenvectors at the West face of a cell
        IF (update_modes) THEN
          CALL GMREDI_CALC_EIGS(
     I         iMin,iMax,jMin,jMax,bi,bj, N2W, myThid,
     I         kLow_U, maskW(:,:,:,bi,bj),
     I         hfacW(:,:,:,bi,bj), recip_hfacW(:,:,:,bi,bj),
     I         rLowW(:,:,bi,bj), GM_Bates_NModes, .FALSE.,
     O         dummy, modesW(:,:,:,:,bi,bj) )
        ENDIF

C       Calculate Xi_m at the west face of a cell
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          DO m=1,GM_Bates_NModes
           XimX(m,i,j) = zeroRL
          ENDDO
         ENDDO
        ENDDO
        DO k=1,Nr
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           DO m=1,GM_Bates_NModes
            Kdqdx(i,j,k) = KPV(i,j,k)*gradqx(i,j,k)
            XimX(m,i,j) = XimX(m,i,j)
     &           - maskW(i,j,k,bi,bj)*drF(k)*hfacW(i,j,k,bi,bj)
     &           *Kdqdx(i,j,k)*modesW(m,i,j,k,bi,bj)
           ENDDO
          ENDDO
         ENDDO
        ENDDO

C     Calculate Xi in the X direction at the west face
        DO k=1,Nr
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           Xix(i,j,k) = zeroRL
          ENDDO
         ENDDO
        ENDDO
        DO k=1,Nr
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           DO m=1,GM_Bates_NModes
            Xix(i,j,k) = Xix(i,j,k)
     &           + maskW(i,j,k,bi,bj)*XimX(m,i,j)*modesW(m,i,j,k,bi,bj)
           ENDDO
          ENDDO
         ENDDO
        ENDDO

C     Now the Y direction
C     ------------------------------
C     Calculate the eigenvectors at the West face of a cell
        IF (update_modes) THEN
          CALL GMREDI_CALC_EIGS(
     I         iMin,iMax,jMin,jMax,bi,bj, N2S, myThid,
     I         kLow_V, maskS(:,:,:,bi,bj),
     I         hfacS(:,:,:,bi,bj), recip_hfacS(:,:,:,bi,bj),
     I         rLowS(:,:,bi,bj), GM_Bates_NModes, .FALSE.,
     O         dummy, modesS(:,:,:,:,bi,bj) )
        ENDIF

        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          DO m=1,GM_Bates_NModes
           XimY(m,i,j) = zeroRL
          ENDDO
         ENDDO
        ENDDO
        DO k=1,Nr
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           DO m=1,GM_Bates_NModes
            Kdqdy(i,j,k) = KPV(i,j,k)*gradqy(i,j,k)
            XimY(m,i,j) = XimY(m,i,j)
     &           - drF(k)*hfacS(i,j,k,bi,bj)
     &           *Kdqdy(i,j,k)*modesS(m,i,j,k,bi,bj)
           ENDDO
          ENDDO
         ENDDO
        ENDDO

C     Calculate Xi for Y direction at the south face
        DO k=1,Nr
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           Xiy(i,j,k) = zeroRL
          ENDDO
         ENDDO
        ENDDO
        DO k=1,Nr
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           DO m=1,GM_Bates_NModes
            Xiy(i,j,k) = Xiy(i,j,k)
     &           + maskS(i,j,k,bi,bj)*XimY(m,i,j)*modesS(m,i,j,k,bi,bj)
           ENDDO
          ENDDO
         ENDDO
        ENDDO

C     ENDIF (.NOT. GM_Bates_smooth)
      ENDIF

C     Calculate the renormalisation factor
      DO j=1-OLy,sNy+OLy
       DO i=1-OLx,sNx+OLx
        uInt(i,j)=zeroRL
        vInt(i,j)=zeroRL
        KdqdyInt(i,j)=zeroRL
        KdqdxInt(i,j)=zeroRL
        uKdqdyInt(i,j)=zeroRL
        vKdqdxInt(i,j)=zeroRL
        uXiyInt(i,j)=zeroRL
        vXixInt(i,j)=zeroRL
        Renorm(i,j)=oneRL
        RenormU(i,j)=oneRL
        RenormV(i,j)=oneRL
       ENDDO
      ENDDO
      DO k=1,Nr
       DO j=1-OLy,sNy+OLy-1
        DO i=1-OLx,sNx+OLx-1
         centreX = op5*(uVel(i,j,k,bi,bj)+uVel(i+1,j,k,bi,bj))
         centreY = op5*(Kdqdy(i,j,k)     +Kdqdy(i,j+1,k)     )
C        For the numerator
         uInt(i,j) = uInt(i,j)
     &        + centreX*hfacC(i,j,k,bi,bj)*drF(k)
         KdqdyInt(i,j) = KdqdyInt(i,j)
     &        + centreY*hfacC(i,j,k,bi,bj)*drF(k)
         uKdqdyInt(i,j) = uKdqdyInt(i,j)
     &        + centreX*centreY*hfacC(i,j,k,bi,bj)*drF(k)
C        For the denominator
         centreY = op5*(Xiy(i,j,k) + Xiy(i,j+1,k))
         uXiyInt(i,j) = uXiyInt(i,j)
     &        + centreX*centreY*hfacC(i,j,k,bi,bj)*drF(k)

         centreX = op5*(Kdqdx(i,j,k)     +Kdqdx(i+1,j,k))
         centreY = op5*(vVel(i,j,k,bi,bj)+vVel(i,j+1,k,bi,bj) )
C        For the numerator
         vInt(i,j) = vInt(i,j)
     &        + centreY*hfacC(i,j,k,bi,bj)*drF(k)
         KdqdxInt(i,j) = KdqdxInt(i,j)
     &        + CentreX*hfacC(i,j,k,bi,bj)*drF(k)
         vKdqdxInt(i,j) = vKdqdxInt(i,j)
     &        + centreY*centreX*hfacC(i,j,k,bi,bj)*drF(k)
C        For the denominator
         centreX = op5*(Xix(i,j,k) + Xix(i+1,j,k))
         vXixInt(i,j) = vXixInt(i,j)
     &        + centreY*centreX*hfacC(i,j,k,bi,bj)*drF(k)

        ENDDO
       ENDDO
      ENDDO

      DO j=1-OLy,sNy+OLy-1
       DO i=1-OLx,sNx+OLx-1
        IF (kLowC(i,j,bi,bj).GT.0) THEN
          numerator =
     &         (uKdqdyInt(i,j)-uInt(i,j)*KdqdyInt(i,j)/R_low(i,j,bi,bj))
     &        -(vKdqdxInt(i,j)-vInt(i,j)*KdqdxInt(i,j)/R_low(i,j,bi,bj))
          denominator = uXiyInt(i,j) - vXixInt(i,j)
C         We can have troubles with floating point exceptions if the denominator
C         of the renormalisation if the ocean is resting (e.g. intial conditions).
C         So we make the renormalisation factor one if the denominator is very small
C         The renormalisation factor is supposed to correct the error in the extraction of
C         potential energy associated with the truncation of the expansion. Thus, we
C         enforce a minimum value for the renormalisation factor.
C         We also enforce a maximum renormalisation factor.
          IF (denominator.GT.small) THEN
            Renorm(i,j) = ABS(numerator/denominator)
            Renorm(i,j) = MAX(Renorm(i,j),GM_Bates_minRenorm)
            Renorm(i,j) = MIN(Renorm(i,j),GM_Bates_maxRenorm)
          ENDIF
        ENDIF
       ENDDO
      ENDDO
C     Now put it back on to the velocity grids
      DO j=1-OLy+1,sNy+OLy-1
       DO i=1-OLx+1,sNx+OLx-1
        RenormU(i,j) = op5*(Renorm(i-1,j)+Renorm(i,j))
        RenormV(i,j) = op5*(Renorm(i,j-1)+Renorm(i,j))
       ENDDO
      ENDDO

C     Calculate the eddy induced velocity in the X direction at the west face
      DO k=1,Nr
       DO j=1-OLy+1,sNy+OLy
        DO i=1-OLx+1,sNx+OLx
         ustar(i,j,k) = -RenormU(i,j)*Xix(i,j,k)/coriU(i,j)
        ENDDO
       ENDDO
      ENDDO

C     Calculate the eddy induced velocity in the Y direction at the south face
      DO k=1,Nr
       DO j=1-OLy+1,sNy+OLy
        DO i=1-OLx+1,sNx+OLx
         vstar(i,j,k) = -RenormV(i,j)*Xiy(i,j,k)/coriV(i,j)
        ENDDO
       ENDDO
      ENDDO

C     ======================================
C     Calculate the eddy induced overturning streamfunction
C     ======================================
#ifdef GM_BATES_PASSIVE
      k=Nr
      DO j=1-OLy,sNy+OLy
       DO i=1-OLx,sNx+OLx
        psistar(i,j,Nr) = -hfacS(i,j,k,bi,bj)*drF(k)*vstar(i,j,k)
       ENDDO
      ENDDO
      DO k=Nr-1,1,-1
       DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
           psistar(i,j,k) = psistar(i,j,k+1)
     &          - hfacS(i,j,k,bi,bj)*drF(k)*vstar(i,j,k)
        ENDDO
       ENDDO
      ENDDO

#else

      IF (GM_AdvForm) THEN
        k=Nr
        DO j=1-OLy+1,sNy+1
         DO i=1-OLx+1,sNx+1
          GM_PsiX(i,j,k,bi,bj) = -hfacW(i,j,k,bi,bj)*drF(k)*ustar(i,j,k)
          GM_PsiY(i,j,k,bi,bj) = -hfacS(i,j,k,bi,bj)*drF(k)*vstar(i,j,k)
         ENDDO
        ENDDO
        DO k=Nr-1,1,-1
         DO j=1-OLy+1,sNy+1
          DO i=1-OLx+1,sNx+1
           GM_PsiX(i,j,k,bi,bj) = GM_PsiX(i,j,k+1,bi,bj)
     &          - hfacW(i,j,k,bi,bj)*drF(k)*ustar(i,j,k)
           GM_PsiY(i,j,k,bi,bj) = GM_PsiY(i,j,k+1,bi,bj)
     &          - hfacS(i,j,k,bi,bj)*drF(k)*vstar(i,j,k)
          ENDDO
         ENDDO
        ENDDO

      ENDIF
#endif

#ifdef ALLOW_DIAGNOSTICS
C     Diagnostics
      IF ( useDiagnostics ) THEN
        CALL DIAGNOSTICS_FILL( GM_BatesK3d, 'GM_BaK  ',
     I                         0, Nr, 1, bi, bj, myThid )
        CALL DIAGNOSTICS_FILL(KPV,    'GM_KPV  ',0,Nr,2,bi,bj,myThid)
        CALL DIAGNOSTICS_FILL(urms,   'GM_URMS ',0,Nr,2,bi,bj,myThid)
        CALL DIAGNOSTICS_FILL(Rdef,   'GM_RDEF ',0, 1,1,bi,bj,myThid)
        CALL DIAGNOSTICS_FILL(Rurms,  'GM_RURMS',0, 1,2,bi,bj,myThid)
        CALL DIAGNOSTICS_FILL(RRhines,'GM_RRHNS',0, 1,2,bi,bj,myThid)
        CALL DIAGNOSTICS_FILL(Rmix,   'GM_RMIX ',0, 1,2,bi,bj,myThid)
        CALL DIAGNOSTICS_FILL(supp,   'GM_SUPP ',0,Nr,2,bi,bj,myThid)
        CALL DIAGNOSTICS_FILL(Xix,    'GM_Xix  ',0,Nr,2,bi,bj,myThid)
        CALL DIAGNOSTICS_FILL(Xiy,    'GM_Xiy  ',0,Nr,2,bi,bj,myThid)
        CALL DIAGNOSTICS_FILL(cDopp,  'GM_C    ',0, 1,2,bi,bj,myThid)
        CALL DIAGNOSTICS_FILL(Ubaro,  'GM_UBARO',0, 1,2,bi,bj,myThid)
        CALL DIAGNOSTICS_FILL(eady,   'GM_EADY ',0, 1,2,bi,bj,myThid)
        CALL DIAGNOSTICS_FILL(SlopeX, 'GM_Sx   ',0,Nr,2,bi,bj,myThid)
        CALL DIAGNOSTICS_FILL(SlopeY, 'GM_Sy   ',0,Nr,2,bi,bj,myThid)
        CALL DIAGNOSTICS_FILL(tfluxX, 'GM_TFLXX',0,Nr,2,bi,bj,myThid)
        CALL DIAGNOSTICS_FILL(tfluxY, 'GM_TFLXY',0,Nr,2,bi,bj,myThid)
        CALL DIAGNOSTICS_FILL(gradqx, 'GM_dqdx ',0,Nr,2,bi,bj,myThid)
        CALL DIAGNOSTICS_FILL(gradqy, 'GM_dqdy ',0,Nr,2,bi,bj,myThid)
        CALL DIAGNOSTICS_FILL(Kdqdy,  'GM_Kdqdy',0,Nr,2,bi,bj,myThid)
        CALL DIAGNOSTICS_FILL(Kdqdx,  'GM_Kdqdx',0,Nr,2,bi,bj,myThid)
        CALL DIAGNOSTICS_FILL(surfkz, 'GM_SFLYR',0, 1,2,bi,bj,myThid)
        CALL DIAGNOSTICS_FILL(ustar,  'GM_USTAR',0,Nr,2,bi,bj,myThid)
        CALL DIAGNOSTICS_FILL(vstar,  'GM_VSTAR',0,Nr,2,bi,bj,myThid)
        CALL DIAGNOSTICS_FILL(umc,    'GM_UMC  ',0,Nr,2,bi,bj,myThid)
        CALL DIAGNOSTICS_FILL(ubar,   'GM_UBAR ',0,Nr,2,bi,bj,myThid)
        CALL DIAGNOSTICS_FILL(modesC, 'GM_MODEC',0,Nr,1,bi,bj,myThid)
        CALL DIAGNOSTICS_FILL(M4loc,  'GM_M4   ',0,Nr,2,bi,bj,myThid)
        CALL DIAGNOSTICS_FILL(N2loc,  'GM_N2   ',0,Nr,2,bi,bj,myThid)
        CALL DIAGNOSTICS_FILL(M4onN2, 'GM_M4_N2',0,Nr,2,bi,bj,myThid)
        CALL DIAGNOSTICS_FILL(slopeC, 'GM_SLOPE',0,Nr,2,bi,bj,myThid)
        CALL DIAGNOSTICS_FILL(Renorm, 'GM_RENRM',0, 1,2,bi,bj,myThid)
#ifdef GM_BATES_PASSIVE
        CALL DIAGNOSTICS_FILL(psistar,'GM_PSTAR',0,Nr,2,bi,bj,myThid)
#endif
      ENDIF
#endif

C     For the Redi diffusivity, we set GM_BatesK3d to a constant if
C     GM_Bates_constRedi=.TRUE.
      IF (GM_Bates_constRedi) THEN
        DO k=1,Nr
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           GM_BatesK3d(i,j,k,bi,bj) = GM_Bates_constK
          ENDDO
         ENDDO
        ENDDO
      ENDIF

#ifdef ALLOW_DIAGNOSTICS
      IF ( useDiagnostics )
     &  CALL DIAGNOSTICS_FILL( GM_BatesK3d, 'GM_BaK_T',
     I                         0, Nr, 1, bi, bj, myThid )
#endif

#endif /* GM_BATES_K3D */
      RETURN
      END

#include "CPP_OPTIONS.h"

CBOP 0
C !ROUTINE: CPL_READ_PARAMS

C !INTERFACE:
      SUBROUTINE CPL_READ_PARAMS( msgUnit )

C !DESCRIPTION:
C     *==========================================================*
C     | SUBROUTINE CPL_READ_PARAMS
C     | o Read coupler and mapping parameters
C     *==========================================================*

C !USES:
      IMPLICIT NONE
C     == Global variables ==
#include "CPL_PARAMS.h"

C !INPUT/OUTPUT PARAMETERS:
C     msgUnit          :: log-file I/O unit
      INTEGER msgUnit

C !LOCAL VARIABLES:
      INTEGER ioUnit
      LOGICAL fileExist
CEOP

      NAMELIST /COUPLER_PARAMS/
     &     cpl_sequential,
     &     cpl_exchange_RunOff,
     &     cpl_exchange1W_sIce, cpl_exchange2W_sIce,
     &     cpl_exchange_SaltPl, cpl_exchange_DIC,
     &     runOffMapSize, runOffMapFile

C--   Default values for Coupler parameters
      cpl_sequential = 0
C     default coupling-exch selector value: fit a simple warm
C     aqua-planet (no land, no seaice, no CO2/DIC coupling)
      cpl_exchange_RunOff = 0
      cpl_exchange1W_sIce = 0
      cpl_exchange2W_sIce = 0
      cpl_exchange_SaltPl = 0
      cpl_exchange_DIC    = 0
      runOffMapSize = 0
      runOffMapFile = ' '
C-    other parameters:
      cplErrorCount = 0
      fileExist = .FALSE.

C--   Read-in parameter file:
      INQUIRE( FILE='data.cpl', EXIST=fileExist )
      IF ( fileExist ) THEN
        WRITE(msgUnit,'(2A)') 'CPL_READ_PARAMS: ',
     &                        'Reading parameter file "data.cpl"'
        ioUnit = 88
        OPEN( ioUnit, FILE='data.cpl',STATUS='old')
        READ( ioUnit, COUPLER_PARAMS )
        CLOSE(ioUnit )
      ELSE
        cplErrorCount = 1
        WRITE(msgUnit,'(2A)') ' *** ERROR *** CPL_READ_PARAMS: ',
     &                'parameter file "data.cpl" not found'
        WRITE(msgUnit,'(2A,I4,A)') ' *** ERROR *** CPL_READ_PARAMS: ',
     &                '==> set ErrorCount=', cplErrorCount, ' (Fatal)'
      ENDIF

C--   Check parameter consistency:
      IF ( cpl_exchange2W_sIce.EQ.3 .AND. cpl_sequential.EQ.0 ) THEN
        cplErrorCount = cplErrorCount + 1
        WRITE(msgUnit,'(2A)') ' *** ERROR *** CPL_READ_PARAMS: ',
     &       'needs "cpl_sequential=1" to use: cpl_exchange2W_sIce=3'
        WRITE(msgUnit,'(2A,I4,A)') ' *** ERROR *** CPL_READ_PARAMS: ',
     &                '==> set ErrorCount=', cplErrorCount, ' (Fatal)'
      ENDIF
      IF ( cpl_exchange2W_sIce.EQ.1 .AND. cpl_sequential.EQ.1 ) THEN
        cplErrorCount = cplErrorCount + 1
        WRITE(msgUnit,'(2A)') ' *** ERROR *** CPL_READ_PARAMS: ',
     &       'needs "cpl_sequential=0" to use: cpl_exchange2W_sIce=1'
        WRITE(msgUnit,'(2A,I4,A)') ' *** ERROR *** CPL_READ_PARAMS: ',
     &                '==> set ErrorCount=', cplErrorCount, ' (Fatal)'
      ENDIF

C--   Print summary of Coupler parameters value
      IF ( cplErrorCount.EQ.0 ) THEN
        WRITE(msgUnit,'(2A)') 'CPL_READ_PARAMS: ',
     &   '------  Coupler parameter Summary:  -----------------'

C-    main coupling time-stepping selector:
        WRITE(msgUnit,'(2A,I4)') 'CPL_READ_PARAMS: ',
     &           ' cpl_sequential = ', cpl_sequential

C-    cpl_exchange field selector:
        WRITE(msgUnit,'(2A,I4)') 'CPL_READ_PARAMS: ',
     &           ' cpl_exchange_RunOff =', cpl_exchange_RunOff
        WRITE(msgUnit,'(2A,I4)') 'CPL_READ_PARAMS: ',
     &           ' cpl_exchange1W_sIce =', cpl_exchange1W_sIce
        WRITE(msgUnit,'(2A,I4)') 'CPL_READ_PARAMS: ',
     &           ' cpl_exchange2W_sIce =', cpl_exchange2W_sIce
        WRITE(msgUnit,'(2A,I4)') 'CPL_READ_PARAMS: ',
     &           ' cpl_exchange_SaltPl =', cpl_exchange_SaltPl
        WRITE(msgUnit,'(2A,I4)') 'CPL_READ_PARAMS: ',
     &           ' cpl_exchange_DIC    =', cpl_exchange_DIC

C-    run-off mapping parameters:
        WRITE(msgUnit,'(2A,I8)') 'CPL_READ_PARAMS: ',
     &                ' runOffMapSize=', runOffMapSize
        WRITE(msgUnit,'(3A)') 'CPL_READ_PARAMS: ',
     &                ' runOffMapFile=', runOffMapFile

        WRITE(msgUnit,'(2A)') 'CPL_READ_PARAMS: ',
     &   '------  End of Coupler parameter Summary ------------'
      ENDIF

      RETURN
      END

#include "ECCO_OPTIONS.h"

      SUBROUTINE ECCO_INIT_VARIA( myThid )

C     ==================================================================
C     SUBROUTINE ecco_init_varia
C     ==================================================================
C
C     o Initialise ecco variables.
C
C     ==================================================================
C     SUBROUTINE ecco_cost_init_varia
C     ==================================================================

      IMPLICIT NONE

C     == global variables ==
#include "EEPARAMS.h"
#include "SIZE.h"
#include "PARAMS.h"
#include "GRID.h"
#include "ECCO_SIZE.h"
#include "ECCO.h"
#ifdef ALLOW_COST
# include "cost.h"
#endif

C     == routine arguments ==
      INTEGER myThid

C     == local variables ==

C     == end of interface ==

#ifdef ALLOW_PSBAR_STERIC
# ifndef ALLOW_AUTODIFF
      _BEGIN_MASTER(myThid)
# endif
      RHOsumGlob_0 = 0. _d 0
      VOLsumGlob_0 = 0. _d 0
# ifndef ALLOW_AUTODIFF
      _END_MASTER(myThid)
# endif
      IF ( .NOT. ( startTime .EQ. baseTime .AND.  nIter0 .EQ. 0
     &     .AND. pickupSuff .EQ. ' ') ) THEN
        CALL ECCO_READ_PICKUP ( nIter0, myThid )
      ENDIF
#endif /* ALLOW_PSBAR_STERIC */

      CALL ECCO_PHYS( startTime, -1, myThid )

#ifdef ALLOW_PSBAR_STERIC
C RHO/VOLsumGlob_0 are zeros if S/R ECCO_READ_PICKUP is not called
C or pickup files (pickup_ecco.*.data/meta) do not exist. Assign
C RHO/VOLsumGlob calculated in S/R ECCO_PHYS to RHO/VOLsumGlob_0.
      _BEGIN_MASTER(myThid)
      IF ( RHOsumGlob_0 .EQ. 0. _d 0 .AND.
     &     VOLsumGlob_0 .EQ. 0. _d 0 ) THEN
        RHOsumGlob_0 = RHOsumGlob
        VOLsumGlob_0 = VOLsumGlob
      ENDIF
      _END_MASTER(myThid)
#endif

      CALL ECCO_COST_INIT_VARIA( myThid )

      _BARRIER

      RETURN
      END

#include "RW_OPTIONS.h"

CBOP
C     !ROUTINE: RW_GET_SUFFIX
C     !INTERFACE:

      SUBROUTINE RW_GET_SUFFIX(
     O                  suff,
     I                  myTime, myIter, myThid )

C     !DESCRIPTION: \bv
C     Return a suffix for file names to read/write.
C     Default is myIter. Options are for seconds, hours etc, as below

C     !USES:
      IMPLICIT NONE

C     Global variables:
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"

C     !INPUT PARAMETERS:
C     myTime :: Current time in simulation
C     myIter :: Current iteration number in simulation
C     myThid :: My Thread Id number
      _RL     myTime
      INTEGER myIter
      INTEGER myThid

C     !OUTPUT PARAMETERS:
C     suff   :: file-name suffix (10.c long)
      CHARACTER*(*) suff

C     !LOCAL VARIABLES:
CEOP

      IF ( rwSuffixType.EQ.1 ) THEN
C     100ths of a second
         WRITE(suff,'(I10.10)') NINT( myTime*100. _d 0 )
      ELSEIF ( rwSuffixType.EQ.2 ) THEN
C     seconds
         WRITE(suff,'(I10.10)') NINT( myTime )
      ELSEIF ( rwSuffixType.EQ.3 ) THEN
C     10ths hours
         WRITE(suff,'(I10.10)') NINT( myTime/360. _d 0 )
      ELSEIF ( rwSuffixType.EQ.4 ) THEN
C     hours
         WRITE(suff,'(I10.10)') NINT( myTime/3600. _d 0 )
      ELSE
C     default, iteration number
         WRITE(suff,'(I10.10)') myIter
      ENDIF

      RETURN
      END

!=======================================================================
      integer function generate_tag( iarg1, iarg2, carg )
      implicit none
! Predefined constants/arrays
#include "CPLR_SIG.h"
! Arguments
      integer iarg1
      integer iarg2
      character*(*) carg
! Local
c     integer j,hash,pow
c     integer itrans(MAXLEN_COMP_NAME)
!     ------------------------------------------------------------------

! Convert the characters to an integer array
c     call mitcplr_char2int( carg, itrans )

! Hash the integer array
c     hash=1
c     pow=1
c     do j=1,MAXLEN_COMP_NAME
c      hash=abs(hash+itrans(j)*pow)
c      pow=mod(pow*128,256*256)
c     enddo

c     generate_tag=(hash*256+iarg2)*128+iarg1
c     generate_tag=abs(mod(generate_tag,256*256*256))
      generate_tag = iarg1*MAX_TILES + iarg2

c     if (DEBUG)
c    & write(0,*) 'generate_tag = ',generate_tag,iarg1,iarg2,carg

!     ------------------------------------------------------------------
      return
      end
!=======================================================================

#include "MONITOR_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: MON_STATS_RL

C     !INTERFACE:
      SUBROUTINE MON_STATS_RL(
     I     myNr, arr, arrMask,arrhFac, arrArea, arrDr,
     O     theMin,theMax,theMean,theSD,theDel2,theVol,
     I     myThid )

C     Calculate bare statistics of global array ``\_RL arr''.

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"

C     !INPUT PARAMETERS:
      INTEGER myNr
      _RL arr(1-OLx:sNx+OLx,1-OLy:sNy+OLy,myNr,nSx,nSy)
      _RS arrMask(1-OLx:sNx+OLx,1-OLy:sNy+OLy,myNr,nSx,nSy)
      _RS arrhFac(1-OLx:sNx+OLx,1-OLy:sNy+OLy,myNr,nSx,nSy)
      _RS arrArea(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RS arrDr(myNr)
      _RL theMin, theMax, theMean, theSD, theDel2, theVol
      INTEGER myThid
CEOP

C     !LOCAL VARIABLES:
      INTEGER bi,bj,I,J,K
      INTEGER numPnts
      LOGICAL noPnts
      _RL tmpVal,rNumPnts
      _RL theVar
      _RL tmpVol
      _RL tileMean(nSx,nSy)
      _RL tileVar (nSx,nSy)
      _RL tileSD  (nSx,nSy)
      _RL tileDel2(nSx,nSy)
      _RL tileVol (nSx,nSy)

C     Since 2009/12/21 MON_CALC_STATS_RL replaces MON_STATS_RL
C     which is now disabled
      STOP 'ABNORMAL END: S/R MON_STATS_RL no longer maintained'

      theMin=0.
      theMax=0.
      theMean=0.
      theSD=0.
      theVar=0.
      theDel2=0.
      theVol=0.
      numPnts=0
      noPnts=.TRUE.

      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        tileDel2(bi,bj) = 0.
        tileVol (bi,bj) = 0.
        tileMean(bi,bj) = 0.
        tileVar (bi,bj) = 0.
        DO K=1,myNr
         DO J=1,sNy
          DO I=1,sNx
           tmpVal=arr(I,J,K,bi,bj)
           IF (arrMask(I,J,K,bi,bj).NE.0. .AND. noPnts) THEN
            theMin=tmpVal
            theMax=tmpVal
            noPnts=.FALSE.
           ENDIF
           IF (arrMask(I,J,K,bi,bj).NE.0.) THEN
            theMin=min(theMin,tmpVal)
            theMax=max(theMax,tmpVal)
            tileDel2(bi,bj) = tileDel2(bi,bj)
     &      + 0.25*ABS(
     &         (arr(I+1,J,K,bi,bj)-tmpVal)*arrMask(I+1,J,K,bi,bj)
     &        +(arr(I-1,J,K,bi,bj)-tmpVal)*arrMask(I-1,J,K,bi,bj)
     &        +(arr(I,J+1,K,bi,bj)-tmpVal)*arrMask(I,J+1,K,bi,bj)
     &        +(arr(I,J-1,K,bi,bj)-tmpVal)*arrMask(I,J-1,K,bi,bj)
     &                )
            numPnts=numPnts+1
            tmpVol = arrArea(I,J,bi,bj)*arrhFac(I,J,K,bi,bj)*arrDr(K)
     &                                 *arrMask(I,J,K,bi,bj)
            tileVol (bi,bj) = tileVol (bi,bj) + tmpVol
            tileMean(bi,bj) = tileMean(bi,bj) + tmpVol*tmpVal
            tileVar (bi,bj) = tileVar (bi,bj) + tmpVol*tmpVal*tmpVal
           ENDIF
          ENDDO
         ENDDO
        ENDDO
c       theDel2 = theDel2 + tileDel2(bi,bj)
c       theVol  = theVol  + tileVol(bi,bj)
c       theMean = theMean + tileMean(bi,bj)
c       theVar  = theVar  + tileVar (bi,bj)
       ENDDO
      ENDDO

c     _GLOBAL_SUM_RL(theDel2,myThid)
c     _GLOBAL_SUM_RL(theVol,myThid)
c     _GLOBAL_SUM_RL(theMean,myThid)
c     _GLOBAL_SUM_RL(theVar,myThid)
      CALL GLOBAL_SUM_TILE_RL( tileDel2, theDel2, myThid )
      CALL GLOBAL_SUM_TILE_RL( tileVol , theVol , myThid )
      CALL GLOBAL_SUM_TILE_RL( tileMean, theMean, myThid )
      CALL GLOBAL_SUM_TILE_RL( tileVar , theVar , myThid )
      tmpVal=FLOAT(numPnts)
      _GLOBAL_SUM_RL(tmpVal,myThid)
      numPnts=NINT(tmpVal)

      IF (tmpVal.GT.0.) THEN
       rNumPnts=1. _d 0/tmpVal
       theDel2=theDel2*rNumPnts
      ENDIF

      IF (theVol.GT.0.) THEN
       theMean=theMean/theVol
       theVar=theVar/theVol
       IF ( noPnts ) theMin = theMean
       theMin=-theMin
       _GLOBAL_MAX_RL(theMin,myThid)
       theMin=-theMin
       IF ( noPnts ) theMax = theMean
       _GLOBAL_MAX_RL(theMax,myThid)

       DO bj=myByLo(myThid),myByHi(myThid)
        DO bi=myBxLo(myThid),myBxHi(myThid)
         tileSD(bi,bj)=0.
         DO K=1,myNr
          DO J=1,sNy
           DO I=1,sNx
            tmpVal=arr(I,J,K,bi,bj)
            IF (arrMask(I,J,K,bi,bj).NE.0.) THEN
             tmpVol=arrArea(I,J,bi,bj)*arrhFac(I,J,K,bi,bj)*arrDr(K)
     &                                *arrMask(I,J,K,bi,bj)
             tileSD(bi,bj) = tileSD(bi,bj)
     &                     + tmpVol*(tmpVal-theMean)*(tmpVal-theMean)
            ENDIF
           ENDDO
          ENDDO
         ENDDO
c        theSD = theSD + tileSD(bi,bj)
        ENDDO
       ENDDO

c      _GLOBAL_SUM_RL(theSD,myThid)
       CALL GLOBAL_SUM_TILE_RL( tileSD, theSD, myThid )

       theSD = SQRT(theSD/theVol)
c      theSD = SQRT(theVar-theMean*theMean)
      ENDIF

      RETURN
      END

#include "GMREDI_OPTIONS.h"

CBOP
C !ROUTINE: GMREDI_CALC_QGLEITH

C !INTERFACE: ==========================================================
      SUBROUTINE GMREDI_CALC_QGLEITH(
     O             leithQG_K,
     I             bi, bj, myTime, myIter, myThid )

C     !DESCRIPTION:
C     *==========================================================*
C     | SUBROUTINE GMREDI_CALC_QGLEITH
C     | Calculate QG Leith contribution to GMRedi tensor.
C     | leithQG_K is located at the cell centre.
C     *==========================================================*

C !USES: ===============================================================
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "DYNVARS.h"
#ifdef ALLOW_MOM_COMMON
# include "MOM_VISC.h"
#endif

C !INPUT PARAMETERS: ===================================================
C     bi, bj    :: tile indices
C     myTime    :: Current time in simulation
C     myIter    :: Current iteration number in simulation
C     myThid    :: My Thread Id. number
      INTEGER bi, bj
      _RL     myTime
      INTEGER myIter
      INTEGER myThid

C !OUTPUT PARAMETERS: ==================================================
C  leithQG_K    :: Horizontal LeithQG viscosity, to add to GM coefficient
      _RL leithQG_K(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)

#ifdef ALLOW_GM_LEITH_QG
#ifdef ALLOW_MOM_COMMON

C !LOCAL VARIABLES: ====================================================
      _RS hFacZ   (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RS r_hFacZ (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL uFld    (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL vFld    (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL stretching(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL Nsquare (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL vort3   (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL hDiv    (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL divDx(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL divDy(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL vrtDx(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL vrtDy(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL grdVrt, grdDiv
      _RL leithQG2fac
      _RL deepFac3, L3, sqarg
C     i,j,k    :: Loop counters
      INTEGER i,j,k
CEOP

C--   Initialise terms

      IF (useFullLeith) THEN
C     Uses correct calculation for gradients, but might not work on cube sphere
        leithQG2fac = (viscC2LeithQG/pi)**6
      ELSE
C     Uses approximate gradients, but works on cube sphere. No reason to use this
C      unless `useFullLeith` fails for your setup.
        leithQG2fac = (viscC2LeithQG/pi)**3
      ENDIF

      DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
          hFacZ(i,j)         = 0. _d 0
          r_hFacZ(i,j)       = 0. _d 0
          uFld(i,j)          = 0. _d 0
          vFld(i,j)          = 0. _d 0
          stretching(i,j)    = 0. _d 0
          Nsquare(i,j)       = 0. _d 0
          vort3(i,j)         = 0. _d 0
          hDiv(i,j)          = 0. _d 0
          divDx(i,j)         = 0. _d 0
          divDy(i,j)         = 0. _d 0
          vrtDx(i,j)         = 0. _d 0
          vrtDy(i,j)         = 0. _d 0
        ENDDO
      ENDDO

C     start k loop since momentum code is inside one
      DO k=1,Nr

        deepFac3 = deepFac2C(k)*deepFacC(k)

C--     Calculate open water fraction at vorticity points
        CALL MOM_CALC_HFACZ(bi,bj,k,hFacZ,r_hFacZ,myThid)

C       Make local copies of horizontal flow field
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          uFld(i,j) = uVel(i,j,k,bi,bj)
          vFld(i,j) = vVel(i,j,k,bi,bj)
         ENDDO
        ENDDO

        CALL MOM_CALC_RELVORT3( bi,bj,k,uFld,vFld,hFacZ,vort3,myThid )
        CALL MOM_CALC_HDIV( bi,bj,k,2,uFld,vFld,hDiv,myThid )

C vorticity needs to be masked if using vector invariant momentum
#ifdef ALLOW_MOM_VECINV
C-      mask vort3
        DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
            IF ( hFacZ(i,j).EQ.zeroRS ) THEN
              vort3(i,j)   = 0.
            ENDIF
          ENDDO
        ENDDO
#endif /* ALLOW_MOM_VECINV */

C     Having calculated the quantitites, use them to calculate
C       LeithQG coefficient

        CALL MOM_VISC_QGL_STRETCH(bi,bj,k,
     O                                   stretching, Nsquare,
     I                                   myTime, myIter, myThid)
        CALL MOM_VISC_QGL_LIMIT(bi,bj,k,
     O                                 stretching,
     I                                 Nsquare, uFld,vFld,vort3,
     I                                 myTime, myIter, myThid)

C--     horizontal gradient of horizontal divergence:
C-       gradient in x direction:
        IF (useCubedSphereExchange) THEN
C        to compute d/dx(hDiv), fill corners with appropriate values:
          CALL FILL_CS_CORNER_TR_RL( 1, .FALSE.,
     &                                hDiv, bi,bj, myThid )
        ENDIF
        DO j=2-OLy,sNy+OLy-1
          DO i=2-OLx,sNx+OLx-1
            divDx(i,j) = (hDiv(i,j)-hDiv(i-1,j))
     &                  *recip_dxC(i,j,bi,bj)*recip_deepFacC(k)
          ENDDO
        ENDDO

C-      gradient in y direction:
        IF (useCubedSphereExchange) THEN
C        to compute d/dy(hDiv), fill corners with appropriate values:
          CALL FILL_CS_CORNER_TR_RL( 2, .FALSE.,
     &                                hDiv, bi,bj, myThid )
        ENDIF
        DO j=2-OLy,sNy+OLy-1
          DO i=2-OLx,sNx+OLx-1
            divDy(i,j) = (hDiv(i,j)-hDiv(i,j-1))
     &                  *recip_dyC(i,j,bi,bj)*recip_deepFacC(k)
          ENDDO
        ENDDO

C       horizontal gradient of vorticity and vortex stretching:
C        In the case of using QG Leith, we want to add a term
C        before calculating vector magnitude.
C        gradient in x direction:
        DO j=2-OLy,sNy+OLy
          DO i=2-OLx,sNx+OLx-1
            vrtDx(i,j) = (vort3(i+1,j)-vort3(i,j))
     &                  *recip_dxG(i,j,bi,bj)*recip_deepFacC(k)
     &                  *maskS(i,j,k,bi,bj)
#ifdef ALLOW_OBCS
     &                  *maskInS(i,j,bi,bj)
#endif
C        Average d/dx of stretching onto V-points to match vrtDX
     &                 + halfRL*halfRL*
     &                    ((stretching(i+1,j)-stretching(i,j))
     &                      *recip_dxC(i+1,j,bi,bj)*recip_deepFacC(k)
     &                    + (stretching(i,j)-stretching(i-1,j))
     &                      *recip_dxC(i,j,bi,bj)*recip_deepFacC(k)
     &                    + (stretching(i+1,j-1)-stretching(i,j-1))
     &                      *recip_dxC(i,j-1,bi,bj)*recip_deepFacC(k)
     &                    + (stretching(i,j-1)-stretching(i-1,j-1))
     &                      *recip_dxC(i-1,j-1,bi,bj)*recip_deepFacC(k)
     &                    )*maskS(i,j,k,bi,bj)
#ifdef ALLOW_OBCS
     &                     *maskInS(i,j,bi,bj)
#endif
          ENDDO
        ENDDO
C-       gradient in y direction:
        DO j=2-OLy,sNy+OLy-1
          DO i=2-OLx,sNx+OLx
            vrtDy(i,j) = (vort3(i,j+1)-vort3(i,j))
     &                  *recip_dyG(i,j,bi,bj)*recip_deepFacC(k)
     &                  *maskW(i,j,k,bi,bj)
#ifdef ALLOW_OBCS
     &                  *maskInW(i,j,bi,bj)
#endif
C        Average d/dy of stretching onto U-points to match vrtDy
     &                 + halfRL*halfRL*
     &                    ((stretching(i,j+1)-stretching(i,j))
     &                      *recip_dyC(i,j+1,bi,bj)*recip_deepFacC(k)
     &                    + (stretching(i,j)-stretching(i,j-1))
     &                      *recip_dyC(i,j,bi,bj)*recip_deepFacC(k)
     &                    + (stretching(i-1,j+1)-stretching(i-1,j))
     &                      *recip_dyC(i-1,j+1,bi,bj)*recip_deepFacC(k)
     &                    + (stretching(i-1,j)-stretching(i-1,j-1))
     &                      *recip_dyC(i-1,j,bi,bj)*recip_deepFacC(k)
     &                    )*maskW(i,j,k,bi,bj)
#ifdef ALLOW_OBCS
     &                     *maskInW(i,j,bi,bj)
#endif
          ENDDO
        ENDDO

        DO j=2-OLy,sNy+OLy-1
          DO i=2-OLx,sNx+OLx-1

C These are (powers of) length scales
            L3 = L3_D(i,j,bi,bj)*deepFac3

            IF (useFullLeith) THEN
C This is the vector magnitude of the vorticity gradient squared
              grdVrt=0.25 _d 0*( (vrtDx(i,j+1)*vrtDx(i,j+1)
     &                        + vrtDx(i,j)*vrtDx(i,j) )
     &                     + (vrtDy(i+1,j)*vrtDy(i+1,j)
     &                        + vrtDy(i,j)*vrtDy(i,j) )  )

C This is the vector magnitude of grad (div.v) squared
C Using it in Leith serves to damp instabilities in w.
              grdDiv=0.25 _d 0*( (divDx(i+1,j)*divDx(i+1,j)
     &                        + divDx(i,j)*divDx(i,j) )
     &                     + (divDy(i,j+1)*divDy(i,j+1)
     &                        + divDy(i,j)*divDy(i,j) )  )

              sqarg = leithQG2fac*(grdVrt+grdDiv)
#ifdef ALLOW_AUTODIFF
C avoid derivative of SQRT(0)
              IF (sqarg .GT. 0. _d 0) sqarg = SQRT(sqarg)
#else
              sqarg = SQRT(sqarg)
#endif
              LeithQG_K(i,j,k) = sqarg*L3

            ELSE
C but this approximation will work on cube (and differs by as much as 4X)
              grdVrt=MAX( ABS(vrtDx(i,j+1)), ABS(vrtDx(i,j)) )
              grdVrt=MAX( grdVrt, ABS(vrtDy(i+1,j)) )
              grdVrt=MAX( grdVrt, ABS(vrtDy(i,j))   )

C This approximation is good to the same order as above...
              grdDiv=MAX( ABS(divDx(i+1,j)), ABS(divDx(i,j)) )
              grdDiv=MAX( grdDiv, ABS(divDy(i,j+1)) )
              grdDiv=MAX( grdDiv, ABS(divDy(i,j))   )

              LeithQG_K(i,j,k) = leithQG2fac*(grdVrt + grdDiv)*L3

            ENDIF
          ENDDO
        ENDDO

      ENDDO /* k loop */

#ifdef ALLOW_DIAGNOSTICS
      IF ( useDiagnostics ) THEN
        CALL DIAGNOSTICS_FILL( LeithQG_K, 'GM_LTHQG',
     &                         0, Nr, 2, bi, bj, myThid )
      ENDIF
#endif /* ALLOW_DIAGNOSTICS */

#endif /* ALLOW_MOM_COMMON */
#endif /* ALLOW_GM_LEITH_QG */

      RETURN
      END

      subroutine template()
      use OAD_cp
      use OAD_tape
      use OAD_rev

!$TEMPLATE_PRAGMA_DECLARATIONS

      integer :: cp_loop_variable_1,cp_loop_variable_2,
     +     cp_loop_variable_3,cp_loop_variable_4

      type(modeType) :: our_orig_mode

      integer iaddr
      external iaddr

      Real*8 cg_Uin_p (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      Real*8 cg_Vin_p (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      Real*8 cg_Bu_p  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      Real*8 cg_Bv_p  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      Real*8 A_uu_p (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy,-1:1,-1:1)
      Real*8 A_vu_p (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy,-1:1,-1:1)
      Real*8 A_uv_p (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy,-1:1,-1:1)
      Real*8 A_vv_p (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy,-1:1,-1:1)
      Real*8 cg_Uin_d (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      Real*8 cg_Vin_d (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      Real*8 cg_Bu_d  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      Real*8 cg_Bv_d  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      Real*8 A_uu_d (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy,-1:1,-1:1)
      Real*8 A_vu_d (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy,-1:1,-1:1)
      Real*8 A_uv_d (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy,-1:1,-1:1)
      Real*8 A_vv_d (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy,-1:1,-1:1)

#ifdef OAD_DEBUG_JOINT
      character*(80):: indentation='                                        
     +                                         '
      our_indent=our_indent+1

      write(standardmessageunit, '(A,A,A)', ADVANCE='NO') 
     +'OAD:',indentation(1:our_indent), 'enter __SRNAME__:'
      call oad_dump_revmod(); call oad_dump_tapestats()
      write(standardmessageunit,*) 
#endif
      if (our_rev_mode%plain) then
#ifdef OAD_DEBUG_JOINT
         write(standardmessageunit,'(A,A,A)') 
     +'OAD:',indentation(1:our_indent), 
     +' __SRNAME__: entering plain'
#endif
c set up for plain execution
         our_orig_mode=our_rev_mode
         our_rev_mode%arg_store=.FALSE.
         our_rev_mode%arg_restore=.FALSE.
         our_rev_mode%plain=.TRUE.
         our_rev_mode%tape=.FALSE.
         our_rev_mode%adjoint=.FALSE.
#ifdef OAD_DEBUG_JOINT
         write(standardmessageunit,'(A,A,A)') 
     +'OAD:',indentation(1:our_indent), 
     +' __SRNAME__: runninng plain / down plain'
#endif
         cg_Uin_p = cg_Uin%v
         cg_Vin_p = cg_Vin%v
         cg_Bu_p  = cg_Bu%v
         cg_Bv_p  = cg_Bv%v
         A_uu_p  = A_uu%v
         A_uv_p  = A_uv%v
         A_vu_p  = A_vu%v
         A_vv_p  = A_vv%v
         call STREAMICE_CG_SOLVE( 
     U        cg_Uin_p,     
     U        cg_Vin_p,     
     I        cg_Bu_p,      
     I        cg_Bv_p,      
     I        A_uu_p,       
     I        A_uv_p,       
     I        A_vu_p,       
     I        A_vv_p,       
     I        tolerance, 
     O        iters,
     I        maxIter,
     I        myThid )
         cg_Uin%v = cg_Uin_p
         cg_Vin%v = cg_Vin_p
c reset the mode
         our_rev_mode=our_orig_mode
      end if
      if (our_rev_mode%tape) then

#ifdef OAD_DEBUG_JOINT
         write(standardmessageunit,'(A,A,A)') 
     +'OAD:',indentation(1:our_indent), 
     +' __SRNAME__: entering tape'
#endif
c set up for plain execution
         our_orig_mode=our_rev_mode
         our_rev_mode%arg_store=.FALSE.
         our_rev_mode%arg_restore=.FALSE.
         our_rev_mode%plain=.TRUE.
         our_rev_mode%tape=.FALSE.
         our_rev_mode%adjoint=.FALSE.
#ifdef OAD_DEBUG_JOINT
         write(standardmessageunit,'(A,A,A)') 
     +'OAD:',indentation(1:our_indent), 
     +' __SRNAME__: runninng plain / down plain'
#endif
         cg_Uin_p = cg_Uin%v
         cg_Vin_p = cg_Vin%v
         cg_Bu_p  = cg_Bu%v
         cg_Bv_p  = cg_Bv%v
         A_uu_p  = A_uu%v
         A_uv_p  = A_uv%v
         A_vu_p  = A_vu%v
         A_vv_p  = A_vv%v
         call oad_tape_push(cg_Bu_p)      
         call oad_tape_push(cg_Bv_p)      
         call oad_tape_push(A_uu_p)       
         call oad_tape_push(A_uv_p)       
         call oad_tape_push(A_vu_p)       
         call oad_tape_push(A_vv_p)       
         call oad_tape_push(tolerance)
         call oad_tape_push(mythid)
         call STREAMICE_CG_SOLVE( 
     U        cg_Uin_p,     
     U        cg_Vin_p,     
     I        cg_Bu_p,      
     I        cg_Bv_p,      
     I        A_uu_p,       
     I        A_uv_p,       
     I        A_vu_p,       
     I        A_vv_p,       
     I        tolerance, 
     O        iters,
     I        maxIter,
     I        myThid )
         call oad_tape_push(cg_Uin_p)     
         call oad_tape_push(cg_Vin_p)     
         cg_Uin%v = cg_Uin_p
         cg_Vin%v = cg_Vin_p
c reset the mode
         our_rev_mode=our_orig_mode
      end if
      if (our_rev_mode%adjoint) then
#ifdef OAD_DEBUG_JOINT
         write(standardmessageunit,'(A,A,A)') 
     +'OAD:',indentation(1:our_indent), 
     +' __SRNAME__: entering adjoint'
#endif
         call oad_tape_pop(cg_Vin_p)     
         call oad_tape_pop(cg_Uin_p)     
         call oad_tape_pop(mythid)
         call oad_tape_pop(tolerance)
         call oad_tape_pop(A_vv_p)       
         call oad_tape_pop(A_vu_p)       
         call oad_tape_pop(A_uv_p)       
         call oad_tape_pop(A_uu_p)       
         call oad_tape_pop(cg_Bv_p)      
         call oad_tape_pop(cg_Bu_p)   
c set up for plain execution
         our_orig_mode=our_rev_mode
         our_rev_mode%arg_store=.FALSE.
         our_rev_mode%arg_restore=.FALSE.
         our_rev_mode%plain=.TRUE.
         our_rev_mode%tape=.FALSE.
         our_rev_mode%adjoint=.FALSE.
#ifdef OAD_DEBUG_JOINT
         write(standardmessageunit,'(A,A,A)') 
     +'OAD:',indentation(1:our_indent), 
     +' __SRNAME__: runninng self adjoint / down plain'
#endif
         cg_Uin_d = cg_Uin%d
         cg_Vin_d = cg_Vin%d
         cg_Bu_d  = cg_Bu%d
         cg_Bv_d  = cg_Bv%d
         A_uu_d  = A_uu%d
         A_uv_d  = A_uv%d
         A_vu_d  = A_vu%d
         A_vv_d  = A_vv%d
      call ADSTREAMICE_CG_SOLVE(
     U                               cg_Uin_p,   ! velocities - solution 
     I                               cg_Uin_d,      ! adjoint of vel (input)
     U                               cg_Vin_p,   ! velocities - solution
     I                               cg_Vin_d,      ! adjoint of vel (input)
     I                               cg_Bu_p,    ! to recalc velocities
     U                               cg_Bu_d,     ! adjoint of RHS (output)
     I                               cg_Bv_p,    ! to recalc velocities
     U                               cg_Bv_d,     ! adjoint of RHS (output)
     I                               A_uu_p,     ! section of matrix that multiplies u and projects on u
     U                               A_uu_d,     ! adjoint of matrix coeffs (output)
     I                               A_uv_p,     ! section of matrix that multiplies v and projects on u
     U                               A_uv_d,     ! adjoint of matrix coeffs (output)
     I                               A_vu_p,     ! section of matrix that multiplies u and projects on v
     U                               A_vu_d,     ! adjoint of matrix coeffs (output)
     I                               A_vv_p,     ! section of matrix that multiplies v and projects on v
     U                               A_vv_d,     ! adjoint of matrix coeffs (output)
     I                               tolerance,
     I                               maxIter,
     I                               myThid )
c reset the mode
         cg_Uin%d = cg_Uin_d
         cg_Vin%d = cg_Vin_d
         cg_Bu%d  = cg_Bu_d
         cg_Bv%d  = cg_Bv_d
         A_uu%d  = A_uu_d
         A_uv%d  = A_uv_d
         A_vu%d  = A_vu_d
         A_vv%d  = A_vv_d
         our_rev_mode=our_orig_mode
      end if 
#ifdef OAD_DEBUG_JOINT
      write(standardmessageunit,'(A,A,A)', ADVANCE='NO') 
     +'OAD:',indentation(1:our_indent), 'leave __SRNAME__:'
      call oad_dump_revmod(); call oad_dump_tapestats()
      write(standardmessageunit,*) 

      our_indent=our_indent-1
#endif

      end subroutine template

#include "PACKAGES_CONFIG.h"
#include "CPP_OPTIONS.h"

CBOP
C     !ROUTINE: EXTERNAL_FIELDS_LOAD
C     !INTERFACE:
      SUBROUTINE EXTERNAL_FIELDS_LOAD( myTime, myIter, myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE EXTERNAL_FIELDS_LOAD
C     | o Control reading of fields from external source.
C     *==========================================================*
C     | External source field loading routine.
C     | This routine is called every time we want to
C     | load a a set of external fields. The routine decides
C     | which fields to load and then reads them in.
C     | This routine needs to be customised for particular
C     | experiments.
C     | Notes
C     | =====
C     | Two-dimensional and three-dimensional I/O are handled in
C     | the following way under MITgcmUV. A master thread
C     | performs I/O using system calls. This threads reads data
C     | into a temporary buffer. At present the buffer is loaded
C     | with the entire model domain. This is probably OK for now
C     | Each thread then copies data from the buffer to the
C     | region of the proper array it is responsible for.
C     | =====
C     | Conversion of flux fields are described in FFIELDS.h
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "FFIELDS.h"
#include "GRID.h"
#include "DYNVARS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
C     myTime :: Simulation time
C     myIter :: Simulation timestep number
C     myThid :: Thread no. that called this routine.
      _RL     myTime
      INTEGER myIter
      INTEGER myThid

#ifndef EXCLUDE_FFIELDS_LOAD

C     !LOCAL VARIABLES:
C     === Local arrays ===
C     aWght, bWght :: Interpolation weights
      INTEGER bi, bj, i, j
      INTEGER intimeP, intime0, intime1
      _RL aWght, bWght
CEOP

      IF ( periodicExternalForcing ) THEN

C--   First call requires that we initialize everything to zero for safety
cph   has been shifted to ini_forcing.F

C--   Now calculate whether it is time to update the forcing arrays
      CALL GET_PERIODIC_INTERVAL(
     O                  intimeP, intime0, intime1, bWght, aWght,
     I                  externForcingCycle, externForcingPeriod,
     I                  deltaTClock, myTime, myThid )

      bi = myBxLo(myThid)
      bj = myByLo(myThid)
#ifdef ALLOW_DEBUG
      IF ( debugLevel.GE.debLevB ) THEN
        _BEGIN_MASTER(myThid)
        WRITE(standardMessageUnit,'(A,I10,A,4I5,A,2F14.10)')
     &   ' EXTERNAL_FIELDS_LOAD,', myIter,
     &   ' : iP,iLd,i0,i1=', intimeP,loadedRec(bi,bj), intime0,intime1,
     &   ' ; Wght=', bWght, aWght
        _END_MASTER(myThid)
      ENDIF
#endif /* ALLOW_DEBUG */
#ifdef ALLOW_AUTODIFF
C-    assuming that we call S/R EXTERNAL_FIELDS_LOAD at each time-step and
C     with increasing time, this will catch when we need to load new records;
C     But with Adjoint run, this is not always the case => might end-up using
C     the wrong time-records
# ifndef STORE_LOADEDREC_TEST
      IF ( intime0.NE.intimeP .OR. myIter.EQ.nIter0 ) THEN
# else
      IF ( intime1.NE.loadedRec(bi,bj) ) THEN
# endif
#else /* ALLOW_AUTODIFF */
C-    Make no assumption on sequence of calls to EXTERNAL_FIELDS_LOAD ;
C     This is the correct formulation (works in Adjoint run).
C     Unfortunatly, produces many recomputations <== not used until it is fixed
      IF ( intime1.NE.loadedRec(bi,bj) ) THEN
#endif /* ALLOW_AUTODIFF */

C--   If the above condition is met then we need to read in
C     data for the period ahead and the period behind myTime.
        IF ( debugLevel.GE.debLevZero ) THEN
         _BEGIN_MASTER(myThid)
         WRITE(standardMessageUnit,'(A,I10,A,2(2I5,A))')
     &    ' EXTERNAL_FIELDS_LOAD, it=', myIter,
     &    ' : Reading new data, i0,i1=', intime0, intime1,
     &    ' (prev=', intimeP, loadedRec(bi,bj), ' )'
         _END_MASTER(myThid)
        ENDIF

        IF ( zonalWindFile .NE. ' '  ) THEN
         CALL READ_REC_XY_RS( zonalWindFile, taux0,
     &                        intime0, myIter, myThid )
         CALL READ_REC_XY_RS( zonalWindFile, taux1,
     &                        intime1, myIter, myThid )
        ENDIF
        IF ( meridWindFile .NE. ' '  ) THEN
         CALL READ_REC_XY_RS( meridWindFile, tauy0,
     &                        intime0, myIter, myThid )
         CALL READ_REC_XY_RS( meridWindFile, tauy1,
     &                        intime1, myIter, myThid )
        ENDIF
        IF ( surfQFile .NE. ' '  ) THEN
         CALL READ_REC_XY_RS( surfQFile, Qnet0,
     &                        intime0, myIter, myThid )
         CALL READ_REC_XY_RS( surfQFile, Qnet1,
     &                        intime1, myIter, myThid )
        ELSEIF ( surfQnetFile .NE. ' '  ) THEN
         CALL READ_REC_XY_RS( surfQnetFile, Qnet0,
     &                        intime0, myIter, myThid )
         CALL READ_REC_XY_RS( surfQnetFile, Qnet1,
     &                        intime1, myIter, myThid )
        ENDIF
        IF ( EmPmRfile .NE. ' '  ) THEN
         CALL READ_REC_XY_RS( EmPmRfile, EmPmR0,
     &                        intime0, myIter, myThid )
         CALL READ_REC_XY_RS( EmPmRfile, EmPmR1,
     &                        intime1, myIter, myThid )
c        IF ( convertEmP2rUnit.EQ.mass2rUnit ) THEN
C-    EmPmR is now (after c59h) expressed in kg/m2/s (fresh water mass flux)
          DO bj = myByLo(myThid), myByHi(myThid)
           DO bi = myBxLo(myThid), myBxHi(myThid)
            DO j=1-OLy,sNy+OLy
             DO i=1-OLx,sNx+OLx
              EmPmR0(i,j,bi,bj) = EmPmR0(i,j,bi,bj)*rhoConstFresh
              EmPmR1(i,j,bi,bj) = EmPmR1(i,j,bi,bj)*rhoConstFresh
             ENDDO
            ENDDO
           ENDDO
          ENDDO
c        ENDIF
        ENDIF
        IF ( saltFluxFile .NE. ' '  ) THEN
         CALL READ_REC_XY_RS( saltFluxFile, saltFlux0,
     &                        intime0, myIter, myThid )
         CALL READ_REC_XY_RS( saltFluxFile, saltFlux1,
     &                        intime1, myIter, myThid )
        ENDIF
        IF ( thetaClimFile .NE. ' '  ) THEN
         CALL READ_REC_XY_RS( thetaClimFile, SST0,
     &                        intime0, myIter, myThid )
         CALL READ_REC_XY_RS( thetaClimFile, SST1,
     &                        intime1, myIter, myThid )
        ENDIF
        IF ( saltClimFile .NE. ' '  ) THEN
         CALL READ_REC_XY_RS( saltClimFile, SSS0,
     &                        intime0, myIter, myThid )
         CALL READ_REC_XY_RS( saltClimFile, SSS1,
     &                        intime1, myIter, myThid )
        ENDIF
#ifdef SHORTWAVE_HEATING
        IF ( surfQswFile .NE. ' '  ) THEN
         CALL READ_REC_XY_RS( surfQswFile, Qsw0,
     &                        intime0, myIter, myThid )
         CALL READ_REC_XY_RS( surfQswFile, Qsw1,
     &                        intime1, myIter, myThid )
         IF ( surfQFile .NE. ' '  ) THEN
C-    Qnet is now (after c54) the net Heat Flux (including SW)
          DO bj = myByLo(myThid), myByHi(myThid)
           DO bi = myBxLo(myThid), myBxHi(myThid)
            DO j=1-OLy,sNy+OLy
             DO i=1-OLx,sNx+OLx
              Qnet0(i,j,bi,bj) = Qnet0(i,j,bi,bj) + Qsw0(i,j,bi,bj)
              Qnet1(i,j,bi,bj) = Qnet1(i,j,bi,bj) + Qsw1(i,j,bi,bj)
             ENDDO
            ENDDO
           ENDDO
          ENDDO
         ENDIF
        ENDIF
#endif
#ifdef ALLOW_GEOTHERMAL_FLUX
        IF ( geothermalFile .NE. ' '  ) THEN
         CALL READ_REC_XY_RS( geothermalFile, geothFlux0,
     &                        intime0, myIter, myThid )
         CALL READ_REC_XY_RS( geothermalFile, geothFlux1,
     &                        intime1, myIter, myThid )
         _EXCH_XY_RS( geothFlux0, myThid )
         _EXCH_XY_RS( geothFlux1, myThid )
        ENDIF
#endif
#ifdef ATMOSPHERIC_LOADING
        IF ( pLoadFile .NE. ' '  ) THEN
         CALL READ_REC_XY_RS( pLoadFile, pLoad0,
     &                        intime0, myIter, myThid )
         CALL READ_REC_XY_RS( pLoadFile, pLoad1,
     &                        intime1, myIter, myThid )
        ENDIF
#endif

C-    thread synchronisation (barrier) is part of the EXCH S/R calls
        _EXCH_XY_RS(SST0  , myThid )
        _EXCH_XY_RS(SST1  , myThid )
        _EXCH_XY_RS(SSS0  , myThid )
        _EXCH_XY_RS(SSS1  , myThid )
        CALL EXCH_UV_XY_RS(taux0,tauy0,.TRUE.,myThid)
        CALL EXCH_UV_XY_RS(taux1,tauy1,.TRUE.,myThid)
        _EXCH_XY_RS(Qnet0, myThid )
        _EXCH_XY_RS(Qnet1, myThid )
        _EXCH_XY_RS(EmPmR0, myThid )
        _EXCH_XY_RS(EmPmR1, myThid )
        _EXCH_XY_RS(saltFlux0, myThid )
        _EXCH_XY_RS(saltFlux1, myThid )
#ifdef SHORTWAVE_HEATING
        _EXCH_XY_RS(Qsw0, myThid )
        _EXCH_XY_RS(Qsw1, myThid )
#endif
#ifdef ATMOSPHERIC_LOADING
        _EXCH_XY_RS(pLoad0, myThid )
        _EXCH_XY_RS(pLoad1, myThid )
#endif

C-    save newly loaded time-record
        DO bj = myByLo(myThid), myByHi(myThid)
         DO bi = myBxLo(myThid), myBxHi(myThid)
           loadedRec(bi,bj) = intime1
         ENDDO
        ENDDO

C--   end if-block for loading new time-records
      ENDIF

C--   Interpolate fu,fv,Qnet,EmPmR,SST,SSS,Qsw
      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
        IF ( thetaClimFile .NE. ' '  ) THEN
          DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
            SST(i,j,bi,bj)   = bWght*SST0(i,j,bi,bj)
     &                       + aWght*SST1(i,j,bi,bj)
           ENDDO
          ENDDO
        ENDIF
        IF ( saltClimFile .NE. ' '  ) THEN
          DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
            SSS(i,j,bi,bj)   = bWght*SSS0(i,j,bi,bj)
     &                       + aWght*SSS1(i,j,bi,bj)
           ENDDO
          ENDDO
        ENDIF
        IF ( zonalWindFile .NE. ' '  ) THEN
          DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
            fu(i,j,bi,bj)    = bWght*taux0(i,j,bi,bj)
     &                       + aWght*taux1(i,j,bi,bj)
           ENDDO
          ENDDO
        ENDIF
        IF ( meridWindFile .NE. ' '  ) THEN
          DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
            fv(i,j,bi,bj)    = bWght*tauy0(i,j,bi,bj)
     &                       + aWght*tauy1(i,j,bi,bj)
           ENDDO
          ENDDO
        ENDIF
        IF ( surfQnetFile .NE. ' '
     &     .OR. surfQFile .NE. ' '  ) THEN
          DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
            Qnet(i,j,bi,bj)  = bWght*Qnet0(i,j,bi,bj)
     &                       + aWght*Qnet1(i,j,bi,bj)
           ENDDO
          ENDDO
        ENDIF
        IF ( EmPmRfile .NE. ' '  ) THEN
          DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
            EmPmR(i,j,bi,bj) = bWght*EmPmR0(i,j,bi,bj)
     &                       + aWght*EmPmR1(i,j,bi,bj)
           ENDDO
          ENDDO
        ENDIF
        IF ( saltFluxFile .NE. ' '  ) THEN
          DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
            saltFlux(i,j,bi,bj) = bWght*saltFlux0(i,j,bi,bj)
     &                          + aWght*saltFlux1(i,j,bi,bj)
           ENDDO
          ENDDO
        ENDIF
#ifdef SHORTWAVE_HEATING
        IF ( surfQswFile .NE. ' '  ) THEN
          DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
            Qsw(i,j,bi,bj)   = bWght*Qsw0(i,j,bi,bj)
     &                       + aWght*Qsw1(i,j,bi,bj)
           ENDDO
          ENDDO
        ENDIF
#endif
#ifdef ALLOW_GEOTHERMAL_FLUX
        IF ( geothermalFile .NE. ' '  ) THEN
          DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
            geothermalFlux(i,j,bi,bj) = bWght*geothFlux0(i,j,bi,bj)
     &                                + aWght*geothFlux1(i,j,bi,bj)
           ENDDO
          ENDDO
        ENDIF
#endif
#ifdef ATMOSPHERIC_LOADING
        IF ( pLoadFile .NE. ' '  ) THEN
          DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
            pLoad(i,j,bi,bj) = bWght*pLoad0(i,j,bi,bj)
     &                       + aWght*pLoad1(i,j,bi,bj)
           ENDDO
          ENDDO
        ENDIF
#endif
       ENDDO
      ENDDO

C-- Print for checking:
#ifdef ALLOW_DEBUG
      IF ( debugLevel.GE.debLevC ) THEN
        _BEGIN_MASTER( myThid )
        WRITE(standardMessageUnit,'(A,1P4E12.4)')
     &   ' EXTERNAL_FIELDS_LOAD: (fu0,1),fu,fv=',
     &        taux0(1,sNy,1,1), taux1(1,sNy,1,1),
     &           fu(1,sNy,1,1),    fv(1,sNy,1,1)
        WRITE(standardMessageUnit,'(A,1P4E12.4)')
     &   ' EXTERNAL_FIELDS_LOAD: SST,SSS,Q,E-P=',
     &          SST(1,sNy,1,1),   SSS(1,sNy,1,1),
     &         Qnet(1,sNy,1,1), EmPmR(1,sNy,1,1)
        _END_MASTER( myThid )
      ENDIF
#endif /* ALLOW_DEBUG */

C endif for periodicForcing
      ENDIF

#endif /* EXCLUDE_FFIELDS_LOAD */

      RETURN
      END

#include "SEAICE_OPTIONS.h"

CBOP
C     !ROUTINE: SEAICE_SUMMARY
      SUBROUTINE SEAICE_SUMMARY( myThid )

C     !DESCRIPTION:
C     *==========================================================*
C     | SUBROUTINE SEAICE_SUMMARY
C     | o Summarize pkg/seaice parameters.
C     *==========================================================*

C     !USES:
      IMPLICIT NONE
C     == global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "SEAICE_SIZE.h"
#include "SEAICE_PARAMS.h"
#ifdef ALLOW_SITRACER
# include "SEAICE_TRACER.h"
#endif

C     !INPUT PARAMETERS:
C     == routine arguments ==
C     myThid     :: my Thread Id. number
      INTEGER myThid
CEOP

C     !LOCAL VARIABLES:
C     == local variables ==
C     msgBuf     :: Informational/error message buffer
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      INTEGER buffI(1)
      CHARACTER*10 endList
      INTEGER ioUnit
#ifdef ALLOW_SITRACER
      INTEGER iTracer
#endif

C     == end of interface ==

      _BARRIER
      _BEGIN_MASTER(myThid)

      endList = '    ;     '
      ioUnit = standardMessageUnit

      WRITE(msgBuf,'(A)')
     &'// ======================================================='
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)')
     &'// Seaice configuration (SEAICE_PARM01) >>> START <<<'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)')
     &'// ======================================================='
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )

C--  Time-stepping related param.

      WRITE(msgBuf,'(A)') ' '
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)')
     &'   Seaice time stepping configuration   > START <  '
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)')
     &'   ----------------------------------------------'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )

      CALL WRITE_0D_RL( SEAICE_deltaTtherm,INDEX_NONE,
     & 'SEAICE_deltaTtherm=', ' /* thermodynamic timestep */')
      CALL WRITE_0D_RL( SEAICE_deltaTdyn  ,INDEX_NONE,
     & 'SEAICE_deltaTdyn  =', ' /* dynamic timestep */')
#ifdef SEAICE_ALLOW_EVP
      CALL WRITE_0D_RL( SEAICE_deltaTevp  ,INDEX_NONE,
     & 'SEAICE_deltaTevp  =', ' /* EVP timestep */')
#endif
      CALL WRITE_0D_L ( SEAICEuseBDF2, INDEX_NONE,
     & 'SEAICEuseBDF2  =',' /* use backw. differencing for mom. eq. */')
      CALL WRITE_0D_L ( SEAICEupdateOceanStress, INDEX_NONE,
     & 'SEAICEupdateOceanStress=', ' /* update Ocean surf. stress */')
      CALL WRITE_0D_L ( SEAICErestoreUnderIce, INDEX_NONE,
     & 'SEAICErestoreUnderIce  =', ' /* restore T and S under ice */')

      WRITE(msgBuf,'(A)') ' '
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)')
     &'   Seaice dynamics configuration   > START <  '
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)')
     &'   ------------------------------------------'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )

C--  Seaice-Dynamics parameters
      CALL WRITE_0D_L ( SEAICEuseDYNAMICS, INDEX_NONE,
     & 'SEAICEuseDYNAMICS =', ' /* use dynamics */')

      IF (.NOT.SEAICEuseDYNAMICS) THEN
      WRITE(msgBuf,'(A)') '   pkg/seaice dynamics is OFF  '
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      ELSE

#ifdef SEAICE_CGRID
      CALL WRITE_0D_C( 'C-GRID', -1, INDEX_NONE,
     & 'model grid type   =', ' /* type of sea ice model grid */')
#else /* not SEAICE_CGRID */
      CALL WRITE_0D_C( 'B-GRID', -1, INDEX_NONE,
     & 'model grid type   =', ' /* type of sea ice model grid */')
#endif /* SEAICE_CGRID */
      CALL WRITE_0D_L ( SEAICEuseStrImpCpl, INDEX_NONE,
     & 'SEAICEuseStrImpCpl =', ' /* use strongly implicit coupling */')
      CALL WRITE_0D_L ( SEAICEusePicardAsPrecon, INDEX_NONE,
     & 'SEAICEusePicardAsPrecon =', ' /* Picard as preconditioner */')
      CALL WRITE_0D_L ( SEAICEuseLSR, INDEX_NONE,
     & 'SEAICEuseLSR      =', ' /* use default Picard-LSR solver */')
      CALL WRITE_0D_L ( SEAICEuseLSRflex, INDEX_NONE,
     & 'SEAICEuseLSRflex  =', ' /* with residual norm criterion */')
      CALL WRITE_0D_L ( SEAICEuseKrylov, INDEX_NONE,
     & 'SEAICEuseKrylov   =', ' /* use Picard-Krylov solver */')
      CALL WRITE_0D_L ( SEAICEuseEVP, INDEX_NONE,
     & 'SEAICEuseEVP      =', ' /* use EVP solver rather than LSR */')
      CALL WRITE_0D_L ( SEAICEuseJFNK, INDEX_NONE,
     & 'SEAICEuseJFNK     =', ' /* use JFNK solver */')
#ifdef SEAICE_ALLOW_FREEDRIFT
      CALL WRITE_0D_L ( SEAICEuseFREEDRIFT, INDEX_NONE,
     & 'SEAICEuseFREEDRIFT =', ' /* use free drift solution */')
#endif /* SEAICE_ALLOW_FREEDRIFT */
      CALL WRITE_0D_RL( OCEAN_drag        ,INDEX_NONE,
     & 'OCEAN_drag        =', ' /* air-ocean drag coefficient */')
      CALL WRITE_0D_RL( SEAICE_drag       ,INDEX_NONE,
     & 'SEAICE_drag       =', ' /* air-ice drag coefficient */')
      CALL WRITE_0D_RL( SEAICE_drag_south       ,INDEX_NONE,
     & 'SEAICE_drag_south      =', ' /* Southern Ocean SEAICE_drag */')
      CALL WRITE_0D_RL( SEAICE_waterDrag  ,INDEX_NONE,
     & 'SEAICE_waterDrag  =', ' /* water-ice drag (no units) */')
      CALL WRITE_0D_RL( SEAICE_waterDrag_south  ,INDEX_NONE,
     & 'SEAICE_waterDrag_south =',
     & ' /* Southern Ocean waterDrag (no units) */')
      CALL WRITE_0D_RL( SEAICEdWatMin ,INDEX_NONE, 'SEAICEdWatMin =',
     & ' /* minimum linear water-ice drag (in m/s) */')
#ifdef SEAICE_ALLOW_BOTTOMDRAG
      IF ( SEAICEbasalDragK2 .NE. 0. _d 0 ) THEN
       CALL WRITE_0D_RL( SEAICE_cBasalStar ,INDEX_NONE,
     &      'SEAICE_cBasalStar =', ' /* Basal drag parameter */')
       CALL WRITE_0D_RL( SEAICEbasalDragU0 ,INDEX_NONE,
     &      'SEAICEbasalDragU0 =', ' /* Basal drag parameter */')
       CALL WRITE_0D_RL( SEAICEbasalDragK1 ,INDEX_NONE,
     &      'SEAICEbasalDragK1 =', ' /* Basal drag parameter */')
      ENDIF
      CALL WRITE_0D_RL( SEAICEbasalDragK2 ,INDEX_NONE,
     &     'SEAICEbasalDragK2 =', ' /* Basal drag parameter */')
#endif /* SEAICE_ALLOW_BOTTOMDRAG */
#ifdef SEAICE_ALLOW_SIDEDRAG
      CALL WRITE_0D_RL( SEAICEsideDrag ,INDEX_NONE,
     &     'SEAICEsideDrag =', ' /* lateral drag parameter */')
      CALL WRITE_0D_C( uCoastLineFile, -1, INDEX_NONE,
     &  'uCoastLineFile =', ' /* u-coastline length file */')
      CALL WRITE_0D_C( vCoastLineFile, -1, INDEX_NONE,
     &  'vCoastLineFile =', ' /* v-coastline length file */')
#endif /* SEAICE_ALLOW_SIDEDRAG */
      CALL WRITE_0D_L ( SEAICEuseTilt, INDEX_NONE,
     & 'SEAICEuseTilt     =', ' /* include surface tilt in dyna. */')
      CALL WRITE_0D_L ( SEAICEuseTEM, INDEX_NONE,
     & 'SEAICEuseTEM      =', ' /* use truncated ellipse rheology */')
      CALL WRITE_0D_RL( SEAICE_strength   ,INDEX_NONE,
     & 'SEAICE_strength   =', ' /* sea-ice strength Pstar */')
      CALL WRITE_0D_RL( SEAICE_cStar   ,INDEX_NONE,
     & 'SEAICE_cStar      =', ' /* sea-ice strength parameter cStar */')
      CALL WRITE_0D_RL( SEAICEpressReplFac,INDEX_NONE,
     & 'SEAICEpressReplFac=', ' /* press. replacement method factor */')
      CALL WRITE_0D_RL( SEAICE_tensilFac   ,INDEX_NONE,
     & 'SEAICE_tensilFac  =', ' /* sea-ice tensile strength factor */')
      CALL WRITE_0D_RL( SEAICE_tensilDepth ,INDEX_NONE,
     & 'SEAICE_tensilDepth=', ' /* crit. depth for tensile strength */')
      CALL WRITE_0D_RL( SEAICEpresH0   ,INDEX_NONE,
     & 'SEAICEpresH0   =', ' /* sea-ice strength Heff threshold */')
       CALL WRITE_0D_I ( SEAICEpresPow0,    INDEX_NONE,
     & 'SEAICEpresPow0 =', ' /* exponent for Heff<SEAICEpresH0 */')
       CALL WRITE_0D_I ( SEAICEpresPow1,    INDEX_NONE,
     & 'SEAICEpresPow1 =', ' /* exponent for Heff>SEAICEpresH0 */')
       CALL WRITE_0D_I ( SEAICEetaZmethod,  INDEX_NONE,
     & 'SEAICEetaZmethod =', ' /* method computing eta at Z-point */')
      CALL WRITE_0D_RL( SEAICE_zetaMaxFac  ,INDEX_NONE,
     & 'SEAICE_zetaMaxFac =', ' /* factor for upper viscosity bound */')
      CALL WRITE_0D_RL( SEAICE_zetaMin  ,INDEX_NONE,
     & 'SEAICE_zetaMin    =', ' /* lower bound for viscosity */')
      CALL WRITE_0D_RL( SEAICE_eccen,INDEX_NONE,'SEAICE_eccen    =',
     & ' /* elliptical yield curve eccent */')
      CALL WRITE_0D_RL( SEAICEstressFactor,INDEX_NONE,
     & 'SEAICEstressFactor    =',' /* wind stress scaling factor */')
      CALL WRITE_0D_RL( SEAICE_airTurnAngle,INDEX_NONE,
     & 'SEAICE_airTurnAngle    =',' /* air-ice turning angle */')
      CALL WRITE_0D_RL( SEAICE_waterTurnAngle,INDEX_NONE,
     & 'SEAICE_waterTurnAngle  =',' /* ice-water turning angle */')
      CALL WRITE_0D_I ( SEAICEselectMetricTerms, INDEX_NONE,
     & 'SEAICEselectMetricTerms =',
     & ' /* metric terms selector for div(sigma) */')
      CALL WRITE_0D_L ( SEAICE_no_slip, INDEX_NONE,
     & 'SEAICE_no_slip    =', ' /* no slip boundary conditions */')
      CALL WRITE_0D_L ( SEAICE_2ndOrderBC, INDEX_NONE,
     & 'SEAICE_2ndOrderBC =',
     & ' /* 2nd order no slip boundary conditions */')
      CALL WRITE_0D_L ( SEAICE_clipVelocities, INDEX_NONE,
     & 'SEAICE_clipVeloctities =', ' /* impose max. vels. */')
      CALL WRITE_0D_L ( useHB87stressCoupling, INDEX_NONE,
     & 'useHB87stressCoupling  =', ' /* altern. ice-ocean stress */')
      CALL WRITE_0D_L ( SEAICEscaleSurfStress, INDEX_NONE,
     & 'SEAICEscaleSurfStress  =',
     & ' /* scale atm. and ocean-surface stress with AREA */')
      CALL WRITE_0D_L ( SEAICE_maskRHS, INDEX_NONE,
     & 'SEAICE_maskRHS    =', ' /* mask RHS of solver */')
      CALL WRITE_0D_L ( SEAICEaddSnowMass, INDEX_NONE,
     & 'SEAICEaddSnowMass =', ' /* add snow mass to seaiceMassC/U/V */')
      IF (.NOT.SEAICEuseEVP) THEN
       CALL WRITE_0D_I ( LSR_mixIniGuess, INDEX_NONE,
     & 'LSR_mixIniGuess =',
     & ' /* mix free-drift sol. into LSR initial Guess */')
       CALL WRITE_0D_RL( SEAICE_LSRrelaxU  ,INDEX_NONE,
     & 'SEAICE_LSRrelaxU  =', ' /* LSR solver: relaxation parameter */')
       CALL WRITE_0D_RL( SEAICE_LSRrelaxV  ,INDEX_NONE,
     & 'SEAICE_LSRrelaxV  =', ' /* LSR solver: relaxation parameter */')
       CALL WRITE_0D_RL( LSR_ERROR         ,INDEX_NONE,
     & 'LSR_ERROR         =', ' /* sets accuracy of LSR solver */')
       CALL WRITE_0D_I ( SOLV_NCHECK,       INDEX_NONE,
     & 'SOLV_NCHECK       =', ' /* test interval for LSR solver */')
       CALL WRITE_0D_L ( SEAICEuseMultiTileSolver, INDEX_NONE,
     & 'SEAICEuseMultiTileSolver =',
     & ' /* use full domain tri-diag solver */')
       CALL WRITE_0D_I ( SEAICE_OLx,  INDEX_NONE,
     & 'SEAICE_OLx =', ' /* overlap for LSR/preconditioner */')
       CALL WRITE_0D_I ( SEAICE_OLy,  INDEX_NONE,
     & 'SEAICE_OLy =', ' /* overlap for LSR/preconditioner */')
       CALL WRITE_0D_I ( SEAICEnonLinIterMax,  INDEX_NONE,
     & 'SEAICEnonLinIterMax =',
     & ' /* max. number of nonlinear solver steps */')
       CALL WRITE_0D_I ( SEAICElinearIterMax,  INDEX_NONE,
     & 'SEAICElinearIterMax =',
     & ' /* max. number of linear solver steps */')
       CALL WRITE_0D_RL( SEAICEnonLinTol  ,INDEX_NONE,
     & 'SEAICEnonLinTol     =', ' /* non-linear solver tolerance */')
#if (defined SEAICE_ALLOW_JFNK) || (defined SEAICE_ALLOW_KRYLOV)
       IF ( SEAICEuseJFNK.OR.SEAICEuseKrylov ) THEN
        CALL WRITE_0D_I ( SEAICEpreconLinIter,  INDEX_NONE,
     & 'SEAICEpreconLinIter =',
     & ' /* number of linear preconditioner steps */')
        CALL WRITE_0D_I ( SEAICEpreconNL_Iter,  INDEX_NONE,
     & 'SEAICEpreconNL_Iter =',
     & ' /* number of non-linear preconditioner steps */')
        CALL WRITE_0D_L ( SEAICEuseIMEX, INDEX_NONE,
     &  'SEAICEuseIMEX  =', ' /* IMEX scheme with JFNK-solver */')
       ENDIF
       IF ( SEAICEuseJFNK ) THEN
        CALL WRITE_0D_I ( SEAICE_JFNK_lsIter,  INDEX_NONE,
     & 'SEAICE_JFNK_lsIter =', ' /* start of line search */')
        CALL WRITE_0D_I ( SEAICE_JFNK_lsLmax,  INDEX_NONE,
     & 'SEAICE_JFNK_lsLmax =', ' /* max. number line search iters */')
        CALL WRITE_0D_RL( SEAICE_JFNK_lsGamma,  INDEX_NONE,
     & 'SEAICE_JFNK_lsGamma =', ' /* line search step size param */')
        CALL WRITE_0D_I ( SEAICE_JFNK_tolIter,  INDEX_NONE,
     & 'SEAICE_JFNK_tolIter =', ' /* tol. is relaxed after this */')
        CALL WRITE_0D_RL( JFNKres_t  ,INDEX_NONE,
     & 'JFNKres_t=', ' /* JFNK parameter */')
        CALL WRITE_0D_RL( JFNKres_tFac  ,INDEX_NONE,
     & 'JFNKres_tFac=', ' /* JFNK parameter */')
        CALL WRITE_0D_RL( SEAICE_JFNKepsilon, INDEX_NONE,
     & 'SEAICE_JFNKepsilon=', ' /* JFNK: FD-gradient step size */')
        CALL WRITE_0D_RL( SEAICE_JFNKphi, INDEX_NONE,
     & 'SEAICE_JFNKphi =', ' /* JFNK: inexact Newtow parameter */')
        CALL WRITE_0D_RL( SEAICE_JFNKalpha, INDEX_NONE,
     &  'SEAICE_JFNKalpha =', ' /* JFNK: inexact Newtow parameter */')
       ENDIF
#endif /* SEAICE_ALLOW_JFNK or SEAICE_ALLOW_KRYLOV */
#ifdef SEAICE_ALLOW_EVP
      ELSE
       CALL WRITE_0D_RL( SEAICE_elasticParm  ,INDEX_NONE,
     & 'SEAICE_elasticParm=', ' /* EVP elastic parameter */')
       CALL WRITE_0D_RL( SEAICE_evpTauRelax  ,INDEX_NONE,
     & 'SEAICE_evpTauRelax=', ' /* EVP relaxation timescale */')
       CALL WRITE_0D_RL( SEAICE_evpDampC  ,INDEX_NONE,
     & 'SEAICE_evpDampC   =', ' /* EVP damping parameter */')
       CALL WRITE_0D_L ( SEAICEuseEVPstar, INDEX_NONE,
     & 'SEAICEuseEVPstar  =', ' /* use EVP* solver */')
       CALL WRITE_0D_L ( SEAICEuseEVPrev, INDEX_NONE,
     & 'SEAICEuseEVPrev   =', ' /* use "revisited EVP" solver */')
       CALL WRITE_0D_RL( SEAICE_evpAlpha  ,INDEX_NONE,
     & 'SEAICE_evpAlpha   =', ' /* EVP* parameter*/')
       CALL WRITE_0D_RL( SEAICE_evpBeta   ,INDEX_NONE,
     & 'SEAICE_evpBeta    =', ' /* EVP*  parameter */')
       CALL WRITE_0D_RL( SEAICEaEVPcoeff ,INDEX_NONE,
     & 'SEAICEaEVPcoeff   =', ' /* adaptive EVP parameter*/')
       CALL WRITE_0D_RL( SEAICEaEVPcStar ,INDEX_NONE,
     & 'SEAICEaEVPcStar   =', ' /* adaptive EVP parameter*/')
       CALL WRITE_0D_RL( SEAICEaEVPalphaMin ,INDEX_NONE,
     & 'SEAICEaEVPalphaMin=', ' /* adaptive EVP parameter*/')
       CALL WRITE_0D_I ( SEAICEnEVPstarSteps,  INDEX_NONE,
     & 'SEAICEnEVPstarSteps =', ' /* num. of EVP* steps */')
       CALL WRITE_0D_L ( SEAICEuseEVPpickup, INDEX_NONE,
     & 'SEAICEuseEVPpickup=', ' /* start EVP solver with EVP pickup*/')
       CALL WRITE_0D_RL ( SEAICE_evpAreaReg, INDEX_NONE,
     & 'SEAICE_evpAreaReg   =', ' /* EVP DenomU/V regularizations*/')
#endif /* SEAICE_ALLOW_EVP */
      ENDIF

C     end if SEAICEuseDYNAMICS bloc
      ENDIF

      WRITE(msgBuf,'(A)') ' '
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)')
     &'   Seaice advection diffusion config,   > START <  '
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)')
     &'   -----------------------------------------------'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )

      CALL WRITE_0D_L ( SEAICEmomAdvection, INDEX_NONE,
     & 'SEAICEmomAdvection =', ' /* advect sea ice momentum */')
#ifdef SEAICE_ALLOW_MOM_ADVECTION
      IF ( SEAICEmomAdvection ) THEN
      CALL WRITE_0D_I( SEAICEselectKEscheme, INDEX_NONE,
     & 'SEAICEselectKEscheme=',
     &              ' /* V.I Kinetic Energy scheme selector */')
      CALL WRITE_0D_I( SEAICEselectKEscheme, INDEX_NONE,
     & 'SEAICEselectVortscheme=',
     &              ' /* V.I Vorticity scheme selector */')
      CALL WRITE_0D_L ( SEAICEhighOrderVorticity, INDEX_NONE,
     & 'SEAICEhighOrderVorticity =',
     &              ' /* V.I Scheme selector for Vorticity-Term */')
      CALL WRITE_0D_L ( SEAICEupwindVorticity, INDEX_NONE,
     & 'SEAICEupwindVorticity =',
     &             ' /* V.I High order vort. advect. flag */')
      CALL WRITE_0D_L ( SEAICEuseAbsVorticity, INDEX_NONE,
     & 'SEAICEuseAbsVorticity =',
     &              ' /* V.I Works with f+zeta in Coriolis */')
      CALL WRITE_0D_L ( SEAICEuseJamartMomAdv, INDEX_NONE,
     & 'SEAICEuseJamartMomAdv =',
     &              ' /* V.I Non-linear terms Jamart flag */')
      ENDIF
#endif

      IF ( useThSIce ) THEN
       WRITE(msgBuf,'(A)')
     &  '   ==> advection diffusion done in pkg ThSIce'
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                     SQUEEZE_RIGHT, myThid )
      ELSE
       CALL WRITE_0D_L ( SEAICEadvHeff, INDEX_NONE,
     &  'SEAICEadvHeff =', ' /* advect effective ice thickness */')
       CALL WRITE_0D_L ( SEAICEadvArea, INDEX_NONE,
     &  'SEAICEadvArea =', ' /* advect fractional ice area */')
       CALL WRITE_0D_L ( SEAICEadvSnow, INDEX_NONE,
     &  'SEAICEadvSnow =', ' /* advect snow layer together with ice */')
#ifdef SEAICE_VARIABLE_SALINITY
       CALL WRITE_0D_L ( SEAICEadvSalt, INDEX_NONE,
     &  'SEAICEadvSalt =', ' /* advect salinity together with ice */')
#endif
       CALL WRITE_0D_L ( SEAICEmultiDimAdvection, INDEX_NONE,
     &  'SEAICEmultiDimAdvection =', ' /* multidimadvec */')
       CALL WRITE_0D_I ( SEAICEadvScheme,   INDEX_NONE,
     &  'SEAICEadvScheme   =', ' /* advection scheme for ice */')
       IF ( SEAICEadvScheme .EQ. 2 )
     &  CALL WRITE_0D_L ( SEAICEuseFluxForm,   INDEX_NONE,
     &  'SEAICEuseFluxForm =', ' /* advection in FV flux form */')
       IF ( SEAICEadvArea )
     &  CALL WRITE_0D_I ( SEAICEadvSchArea,   INDEX_NONE,
     &  'SEAICEadvSchArea  =', ' /* advection scheme for area */')
       IF ( SEAICEadvHeff )
     &  CALL WRITE_0D_I ( SEAICEadvSchHeff,   INDEX_NONE,
     &  'SEAICEadvSchHeff  =', ' /* advection scheme for thickness */')
       IF ( SEAICEadvSnow )
     &  CALL WRITE_0D_I ( SEAICEadvSchSnow,   INDEX_NONE,
     &  'SEAICEadvSchSnow  =', ' /* advection scheme for snow */')
#ifdef SEAICE_VARIABLE_SALINITY
       IF ( SEAICEadvSalt )
     &  CALL WRITE_0D_I ( SEAICEadvSchSalt,   INDEX_NONE,
     &  'SEAICEadvSchSalt  =', ' /* advection scheme for salt */')
#endif
       CALL WRITE_0D_RL( SEAICEdiffKhArea,   INDEX_NONE,
     &  'SEAICEdiffKhArea  =', ' /* diffusivity (m^2/s) for area */')
       CALL WRITE_0D_RL( SEAICEdiffKhHeff,   INDEX_NONE,
     &  'SEAICEdiffKhHeff  =', ' /* diffusivity (m^2/s) for heff */')
       CALL WRITE_0D_RL( SEAICEdiffKhSnow,   INDEX_NONE,
     &  'SEAICEdiffKhSnow  =', ' /* diffusivity (m^2/s) for snow */')
       IF ( SEAICEadvSalt )
     &  CALL WRITE_0D_RL( SEAICEdiffKhSalt,   INDEX_NONE,
     &  'SEAICEdiffKhSalt  =', ' /* diffusivity (m^2/s) for salt */')
       CALL WRITE_0D_RL( DIFF1, INDEX_NONE, 'DIFF1             =',
     &                   ' /* parameter used in advect.F [m/s] */')
C     end if useThSIce bloc
      ENDIF

#ifdef SEAICE_ITD
C--   ITD parameters
      WRITE(msgBuf,'(A)') ' '
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)')
     &'   Seaice ice thickness distribution configuration   > START <  '
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)')
     &'   -----------------------------------------------------------'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      CALL WRITE_0D_I (SEAICE_multDim,INDEX_NONE,'nITD              ='
     & , ' /* number of ice thickness categories */')
      CALL WRITE_1D_RL( Hlimit(1), nITD, INDEX_K, 'Hlimit =',
     & ' /* seaice thickness category bin limits ( m ), Hlimit(0)=0 */')
      CALL WRITE_0D_L ( SEAICEuseLinRemapITD, INDEX_NONE,
     & 'SEAICEuseLinRemapITD  =',
     & ' /* select linear remapping scheme for ITD */')
      CALL WRITE_0D_L ( useHibler79IceStrength, INDEX_NONE,
     & 'useHibler79IceStrength  =',
     & ' /* select ice strength parameterizationd */')
      CALL WRITE_0D_L ( SEAICEsimpleRidging, INDEX_NONE,
     & 'SEAICEsimpleRidging  =',
     & ' /* select ridging scheme */')
      CALL WRITE_0D_I (SEAICEpartFunc,INDEX_NONE,
     &     'SEAICEpartFunc   ='
     & , ' /* select ridging participation function */')
      CALL WRITE_0D_I (SEAICEredistFunc,INDEX_NONE,
     &     'SEAICEredistFunc ='
     & , ' /* select ridging redistribution function */')
      CALL WRITE_0D_RL( SEAICE_cf  ,INDEX_NONE,
     & 'SEAICE_cf  =', ' /* ice strength parameter */')
      CALL WRITE_0D_RL( SEAICEshearParm  ,INDEX_NONE,
     & 'SEAICEshearParm  =', ' /* amount of energy lost to shear */')
      CALL WRITE_0D_RL( SEAICEgStar  ,INDEX_NONE,
     & 'SEAICEgStar  =', ' /* ridging parameter */')
      CALL WRITE_0D_RL( SEAICEhStar  ,INDEX_NONE,
     & 'SEAICEhStar  =', ' /* ridging parameter */')
      CALL WRITE_0D_RL( SEAICEaStar  ,INDEX_NONE,
     & 'SEAICEaStar  =', ' /* ridging parameter */')
      CALL WRITE_0D_RL( SEAICEmuRidging  ,INDEX_NONE,
     & 'SEAICEmuRidging  =', ' /* ridging parameter */')
      CALL WRITE_0D_RL( SEAICEmaxRaft  ,INDEX_NONE,
     & 'SEAICEmaxRaft  =', ' /* ridging parameter */')
      CALL WRITE_0D_RL( SEAICEsnowFracRidge ,INDEX_NONE,
     & 'SEAICEsnowFracRidge  =',
     &     ' /* fraction of snow remaining on ridges */')
#endif

C--   Thermodynamics parameters
      WRITE(msgBuf,'(A)') ' '
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)')
     &'   Seaice thermodynamics configuration   > START <  '
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)')
     &'   -----------------------------------------------'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
C- note: air and seaice (+ snow ?) density are used in both dynamics & thermo
      CALL WRITE_0D_RL( SEAICE_rhoIce     ,INDEX_NONE,
     & 'SEAICE_rhoIce     =', ' /* density of sea ice (kg/m3) */')
      CALL WRITE_0D_RL( SEAICE_rhoSnow     ,INDEX_NONE,
     & 'SEAICE_rhoSnow    =', ' /* density of snow (kg/m3) */')
      CALL WRITE_0D_RL( SEAICE_rhoAir     ,INDEX_NONE,
     & 'SEAICE_rhoAir     =', ' /* density of air (kg/m3) */')

      CALL WRITE_0D_L ( usePW79thermodynamics, INDEX_NONE,
     & 'usePW79thermodynamics  =', ' /* default 0-layer TD */')
      IF (.NOT.usePW79thermodynamics) THEN
      WRITE(msgBuf,'(A)') '   pkg/seaice thermodynamics is OFF  '
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      ELSE
#ifdef SEAICE_USE_GROWTH_ADX
      WRITE(msgBuf,'(2A)')
     &      'SEAICE_USE_GROWTH_ADX defined, ',
     &      'using seaice_growth_adx code'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &     SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A,1PE24.17)') ' SINegFac  = ', SINegFac
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &     SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)') ' '
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &     SQUEEZE_RIGHT, myThid )
#endif /* SEAICE_USE_GROWTH_ADX */

      CALL WRITE_0D_RL( SEAICE_lhEvap     ,INDEX_NONE,
     & 'SEAICE_lhEvap     =', ' /* latent heat of evaporation */')
      CALL WRITE_0D_RL( SEAICE_lhFusion   ,INDEX_NONE,
     & 'SEAICE_lhFusion   =', ' /* latent heat of fusion */')
      CALL WRITE_0D_RL ( SEAICE_mcPheePiston,   INDEX_NONE,
     & 'SEAICE_mcPheePiston =',
     & ' /* turbulent flux "piston velocity" a la McPhee (m/s) */')
      CALL WRITE_0D_RL ( SEAICE_mcPheeTaper,     INDEX_NONE,
     & 'SEAICE_mcPheeTaper =',
     & ' /* tapering of turbulent flux (0.< <1.) for AREA=1. */')
      CALL WRITE_0D_L ( SEAICE_mcPheeStepFunc,   INDEX_NONE,
     & 'SEAICE_mcPheeStepFunc =',
     & ' /* replace linear tapering with step funct. */')
      CALL WRITE_0D_RL ( SEAICE_frazilFrac,   INDEX_NONE,
     & 'SEAICE_frazilFrac =',
     & ' /* frazil (T<tempFrz) to seaice conversion rate (0.< <1.) */')
      CALL WRITE_0D_RL( SEAICE_tempFrz0   ,INDEX_NONE,
     & 'SEAICE_tempFrz0   =',
     & ' /* freezing temp. of sea water (intercept) */')
      CALL WRITE_0D_RL( SEAICE_dTempFrz_dS,INDEX_NONE,
     & 'SEAICE_dTempFrz_dS=',
     & ' /* freezing temp. of sea water (slope) */')
      CALL WRITE_0D_L ( SEAICE_growMeltByConv , INDEX_NONE,
     & 'SEAICE_growMeltByConv  =', ' /* grow,melt by vert. conv. */')
      CALL WRITE_0D_L ( SEAICE_doOpenWaterGrowth , INDEX_NONE,
     & 'SEAICE_doOpenWaterGrowth =', ' /* grow by open water */')
      CALL WRITE_0D_L ( SEAICE_doOpenWaterMelt , INDEX_NONE,
     & 'SEAICE_doOpenWaterMelt =', ' /* melt by open water */')
c print the various values meining for SEAICE_areaGain/LossFormula
      WRITE(msgBuf,'(2A)') 'SEAICE_areaGainFormula =',
     & ' /* ice cover gain formula (1,2)*/'
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      buffI(1) = SEAICE_areaGainFormula
      CALL PRINT_LIST_I( buffI, 1, 1, INDEX_NONE,
     &                   .FALSE., .TRUE., ioUnit )
      WRITE(msgBuf,'(A)') '    1=from growth by ATM '
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)') '    2=from predicted growth by ATM'
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      CALL PRINT_MESSAGE(endList, ioUnit, SQUEEZE_RIGHT, myThid )
c
      WRITE(msgBuf,'(2A)') 'SEAICE_areaLossFormula =',
     & ' /* ice cover loss formula (1,2)*/'
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      buffI(1) = SEAICE_areaLossFormula
      CALL PRINT_LIST_I( buffI, 1, 1, INDEX_NONE,
     &                   .FALSE., .TRUE., ioUnit )
      WRITE(msgBuf,'(2A)') '    1=from all but only melt ',
     &                     'conributions by ATM and OCN'
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)') '    2=from net melt-grow>0 by ATM and OCN'
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)') '    3=from predicted melt by ATM'
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      CALL PRINT_MESSAGE(endList, ioUnit, SQUEEZE_RIGHT, myThid )
c
#ifdef EXF_SEAICE_FRACTION
      CALL WRITE_0D_RL( SEAICE_tauAreaObsRelax,INDEX_NONE,
     & 'SEAICE_tauAreaObsRelax=',
     & ' /* relaxation timescale of sea-ice concentration */')
#endif
c
      CALL WRITE_0D_RL( HO                ,INDEX_NONE,
     & 'HO                =', ' /* nominal thickness of new ice */')
      CALL WRITE_0D_RL( HO_south          ,INDEX_NONE,
     & 'HO_south               =', ' /* Southern Ocean HO */')
      CALL WRITE_0D_RL( SEAICE_area_max          ,INDEX_NONE,
     & 'SEAICE_area_max        =',
     & ' /* set to les than 1. to mimic open leads */')
#ifdef SEAICE_VARIABLE_SALINITY
      WRITE(msgBuf,'(A)')
     &'   Sea ice has a variable salinity such that '
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      CALL WRITE_0D_RL( SEAICE_saltFrac, INDEX_NONE,
     & 'SEAICE_saltFrac =',
     & ' /* fraction of ocn salinity in new ice */')
#else
      CALL WRITE_0D_RL( SEAICE_salt0,   INDEX_NONE,
     & 'SEAICE_salt0   =', ' /* constant sea ice salinity */')
#endif
      CALL WRITE_0D_L ( SEAICE_salinityTracer,   INDEX_NONE,
     & 'SEAICE_salinityTracer =', ' /* test SITR varia. salinity */')
      CALL WRITE_0D_L ( SEAICEuseFlooding, INDEX_NONE,
     & 'SEAICEuseFlooding =', ' /* turn submerged snow into ice */')

      WRITE(msgBuf,'(A)') ' '
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)')
     &'   Seaice air-sea fluxes configuration,   > START <  '
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)')
     &'   -----------------------------------------------'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )

      CALL WRITE_0D_L ( SEAICEheatConsFix,  INDEX_NONE,
     & 'SEAICEheatConsFix  =',
     & ' /* accound for ocn<->seaice advect. heat flux */')
#ifndef SEAICE_ITD
      CALL WRITE_0D_I (SEAICE_multDim,INDEX_NONE,'SEAICE_multDim    ='
     & , ' /* number of ice categories (1 or 7) */')
      CALL WRITE_0D_L (SEAICE_useMultDimSnow, INDEX_NONE,
     &     'SEAICE_useMultDimSnow =',
     &     ' /* use separate snow thickness for each category */')
#endif
      CALL WRITE_1D_RL( SEAICE_PDF,nITD,INDEX_K, 'SEAICE_PDF        =',
     &  ' /* sea-ice distribution (-) */')
      CALL WRITE_0D_I ( IMAX_TICE,         INDEX_NONE,
     & 'IMAX_TICE         =', ' /* iterations for ice surface temp */')
      CALL WRITE_0D_I ( postSolvTempIter,  INDEX_NONE,
     & 'postSolvTempIter=',
     & ' /* flux calculation after surf. temp iter */')
#ifndef SEAICE_EXTERNAL_FLUXES
      CALL WRITE_0D_RL( SEAICE_waterAlbedo,INDEX_NONE,
     & 'SEAICE_waterAlbedo=', ' /* water albedo */')
      CALL WRITE_0D_RL( SEAICE_emissivity, INDEX_NONE,
     & 'SEAICE_emissivity =', ' /* ocean-surface emissivity */')
#endif /* SEAICE_EXTERNAL_FLUXES */
      CALL WRITE_0D_RL( SEAICE_dryIceAlb  ,INDEX_NONE,
     & 'SEAICE_dryIceAlb  =', ' /* winter albedo */')
      CALL WRITE_0D_RL( SEAICE_wetIceAlb  ,INDEX_NONE,
     & 'SEAICE_wetIceAlb  =', ' /* summer albedo */')
      CALL WRITE_0D_RL( SEAICE_drySnowAlb ,INDEX_NONE,
     & 'SEAICE_drySnowAlb =', ' /* dry snow albedo */')
      CALL WRITE_0D_RL( SEAICE_wetSnowAlb ,INDEX_NONE,
     & 'SEAICE_wetSnowAlb =', ' /* wet snow albedo */')
      CALL WRITE_0D_RL( SEAICE_dryIceAlb_south  ,INDEX_NONE,
     & 'SEAICE_dryIceAlb_south =', ' /* Southern Ocean dryIceAlb */')
      CALL WRITE_0D_RL( SEAICE_wetIceAlb_south  ,INDEX_NONE,
     & 'SEAICE_wetIceAlb_south =', ' /* Southern Ocean wetIceAlb */')
      CALL WRITE_0D_RL( SEAICE_drySnowAlb_south ,INDEX_NONE,
     & 'SEAICE_drySnowAlb_south=', ' /* Southern Ocean drySnowAlb */')
      CALL WRITE_0D_RL( SEAICE_wetSnowAlb_south ,INDEX_NONE,
     & 'SEAICE_wetSnowAlb_south=', ' /* Southern Ocean wetSnowAlb */')
      CALL WRITE_0D_RL( SEAICE_wetAlbTemp ,INDEX_NONE,
     & 'SEAICE_wetAlbTemp=',
     & ' /* Temp (o.C) threshold for wet-albedo */')
      CALL WRITE_0D_RL( SEAICE_snow_emiss ,INDEX_NONE,
     & 'SEAICE_snow_emiss =', ' /* snow emissivity */')
      CALL WRITE_0D_RL( SEAICE_ice_emiss ,INDEX_NONE,
     & 'SEAICE_ice_emiss =', ' /* seaice emissivity */')
      CALL WRITE_0D_RL( SEAICE_cpAir      ,INDEX_NONE,
     & 'SEAICE_cpAir      =', ' /* heat capacity of air */')
      CALL WRITE_0D_RL( SEAICE_dalton     ,INDEX_NONE,
     & 'SEAICE_dalton     =', ' /* constant dalton number */')
      CALL WRITE_0D_RL( SEAICE_iceConduct ,INDEX_NONE,
     & 'SEAICE_iceConduct =', ' /* sea-ice conductivity */')
      CALL WRITE_0D_RL( SEAICE_snowConduct,INDEX_NONE,
     & 'SEAICE_snowConduct=', ' /* snow conductivity */')
      CALL WRITE_0D_RL( SEAICE_snowThick  ,INDEX_NONE,
     & 'SEAICE_snowThick  =',
     & ' /* cutoff snow thickness (for albedo) */')
      CALL WRITE_0D_RL( SEAICE_shortwave  ,INDEX_NONE,
     & 'SEAICE_shortwave  =', ' /* penetration shortwave radiation */')
      CALL WRITE_0D_L ( useMaykutSatVapPoly, INDEX_NONE,
     & 'useMaykutSatVapPoly =',
     & ' /* use Maykut Polynomial for Sat.Vap.Pr */')
      CALL WRITE_0D_RL( MIN_ATEMP         ,INDEX_NONE,
     & 'MIN_ATEMP         =', ' /* minimum air temperature */')
      CALL WRITE_0D_RL( MIN_LWDOWN        ,INDEX_NONE,
     & 'MIN_LWDOWN        =', ' /* minimum downward longwave */')
      CALL WRITE_0D_RL( MIN_TICE          ,INDEX_NONE,
     & 'MIN_TICE          =', ' /* minimum ice temperature */')

C     end if usePW79thermodynamics bloc
      ENDIF

      WRITE(msgBuf,'(A)') ' '
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)')
     &'   Seaice initialization and IO config.,   > START <  '
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)')
     &'   -------------------------------------------------'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )

C--  Initial Condition/Input related param.
      CALL WRITE_0D_RL( SEAICE_initialHEFF,INDEX_NONE,
     & 'SEAICE_initialHEFF=', ' /* initial sea-ice thickness */')
      CALL WRITE_0D_C( AreaFile, -1, INDEX_NONE,
     &  'AreaFile =', ' /* Initial ice concentration File */')
      CALL WRITE_0D_C( HeffFile, -1, INDEX_NONE,
     &  'HeffFile =', ' /* Initial effective ice thickness File */')
      CALL WRITE_0D_C( HsnowFile, -1, INDEX_NONE,
     &  'HsnowFile =', ' /* Initial snow thickness File */')
#ifdef SEAICE_VARIABLE_SALINITY
      CALL WRITE_0D_C( HsaltFile, -1, INDEX_NONE,
     &  'HsaltFile =', ' /* Initial HSALT File */')
#endif
      CALL WRITE_0D_C( uIceFile, -1, INDEX_NONE,
     &  'uIceFile =', ' /* Initial U-ice velocity File */')
      CALL WRITE_0D_C( vIceFile, -1, INDEX_NONE,
     &  'vIceFile =', ' /* Initial V-ice velocity File */')

C--  Output related param.
      CALL WRITE_0D_L ( SEAICEwriteState,  INDEX_NONE,
     & 'SEAICEwriteState  =', ' /* write sea ice state to file */')
      CALL WRITE_0D_RL( SEAICE_monFreq,  INDEX_NONE,
     & 'SEAICE_monFreq  =',' /* monitor frequency */')
      CALL WRITE_0D_RL( SEAICE_dumpFreq   ,INDEX_NONE,
     & 'SEAICE_dumpFreq   =', ' /* dump frequency */')
      CALL WRITE_0D_L ( SEAICE_mon_stdio,  INDEX_NONE,
     & 'SEAICE_mon_stdio  =',' /* write monitor to std-outp */')
      CALL WRITE_0D_L ( SEAICE_dump_mdsio,  INDEX_NONE,
     & 'SEAICE_dump_mdsio =',' /* write snap-shot   using MDSIO */')
#ifdef ALLOW_MNC
      CALL WRITE_0D_L ( SEAICE_mon_mnc,  INDEX_NONE,
     & 'SEAICE_mon_mnc    =',' /* write monitor to netcdf file */')
      CALL WRITE_0D_L ( SEAICE_dump_mnc,  INDEX_NONE,
     & 'SEAICE_dump_mnc   =',' /* write snap-shot   using MNC */')
#endif /* ALLOW_MNC */

#ifdef ALLOW_SITRACER
       CALL WRITE_0D_I ( SItrNumInUse, INDEX_NONE,
     & 'SItrNumInUse =',
     & ' /* number of tracers that are in use (<SItrMaxNum) */')
      DO iTracer = 1, SItrNumInUse
       IF (SItrName(iTracer).NE.' ') THEN
      WRITE(msgBuf,'(A,I3,A)') '== SItracer no. ',iTracer,
     &' is in use and defined as'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
       CALL WRITE_0D_C ( SItrMate(iTracer), -1, INDEX_NONE,
     & '  -- SItrMate =',' /* tracer of HEFF or AREA */')
       CALL WRITE_0D_C ( SItrName(iTracer), -1, INDEX_NONE,
     & '  -- SItrName =',' /* tracer name*/')
       CALL WRITE_0D_C ( SItrNameLong(iTracer), -1, INDEX_NONE,
     & '  -- SItrNameLong =',' /* tracer long name*/')
       CALL WRITE_0D_C ( SItrFile(iTracer), -1, INDEX_NONE,
     & '  -- SItrFile =',' /* tracer initial condition file */')
       CALL WRITE_0D_C ( SItrUnit(iTracer), -1, INDEX_NONE,
     & '  -- SItrUnit =',' /* tracer unit */')
      CALL WRITE_0D_RL ( SItrFromOcean0(iTracer),     INDEX_NONE,
     & '  -- SItrFromOcean0 =',' /* for new ice from freeze */')
      CALL WRITE_0D_RL ( SItrFromOceanFrac(iTracer),  INDEX_NONE,
     & '  -- SItrFromOceanFrac =',' /* for new ice from freeze */')
      CALL WRITE_0D_RL ( SItrFromFlood0(iTracer),     INDEX_NONE,
     & '  -- SItrFromFlood0 =',' /* for new ice from freeze */')
      CALL WRITE_0D_RL ( SItrFromFloodFrac(iTracer),  INDEX_NONE,
     & '  -- SItrFromFloodFrac =',' /* for new ice from freeze */')
      CALL WRITE_0D_RL ( SItrExpand0(iTracer),     INDEX_NONE,
     & '  -- SItrExpand0 =',' /* for ice cover thermo. expans. */')

       ENDIF
      ENDDO
#endif /* ALLOW_SITRACER */

      WRITE(msgBuf,'(A)') ' '
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)')
     &'   Seaice regularization numbers,   > START <  '
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)')
     &'   -----------------------------------------------'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )

      CALL WRITE_0D_RL( SEAICE_deltaMin   ,INDEX_NONE,
     & 'SEAICE_deltaMin   =', ' /* reduce singularities in Delta */')
      CALL WRITE_0D_RL( SEAICE_EPS        ,INDEX_NONE,
     & 'SEAICE_EPS        =', ' /* small number */')
      CALL WRITE_0D_RL( SEAICE_EPS_SQ        ,INDEX_NONE,
     & 'SEAICE_EPS_SQ     =', ' /* small number squared */')
      CALL WRITE_0D_RL( SEAICE_area_reg        ,INDEX_NONE,
     & 'SEAICE_area_reg   =', ' /* reduce derivative singularities */')
      CALL WRITE_0D_RL( SEAICE_hice_reg        ,INDEX_NONE,
     & 'SEAICE_hice_reg   =', ' /* reduce derivative singularities */')
      CALL WRITE_0D_RL( SEAICE_area_floor        ,INDEX_NONE,
     & 'SEAICE_area_floor =', ' /* reduce derivative singularities */')

      WRITE(msgBuf,'(A)') ' '
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)')
     &'// ======================================================='
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)')
     &'// Seaice configuration (SEAICE_PARM01) >>> END <<<'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)')
     &'// ======================================================='
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)') ' '
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )

      _END_MASTER(myThid)

      RETURN
      END

#include "CPP_OPTIONS.h"
#ifdef TARGET_NEC_SX
C     set a sensible default for the outer loop unrolling parameter that can
C     be overriden in the Makefile with the DEFINES macro or in CPP_OPTIONS.h
#ifndef CG2D_OUTERLOOPITERS
# define CG2D_OUTERLOOPITERS 10
#endif
#endif /* TARGET_NEC_SX */

CBOP
C     !ROUTINE: CG2D_SR
C     !INTERFACE:
      SUBROUTINE CG2D_SR(
     U                cg2d_b, cg2d_x,
     O                firstResidual, minResidualSq, lastResidual,
     U                numIters, nIterMin,
     I                myThid )
C     !DESCRIPTION: \bv
C     *================================================================*
C     | SUBROUTINE CG2D_SR
C     | o Two-dimensional grid problem conjugate-gradient inverter
C     |   (with preconditioner).
C     | o This version used the more efficient (with less global
C     |   communications) "Single Reduction" (SR) implementation from
C     |   d Azevedo, Eijkhout, and Romine (Lapack Working Note 56, 1999)
C     | Author:  C. Wolfe, November 2009, clwolfe@ucsd.edu
C     *================================================================*
C     | Con. grad is an iterative procedure for solving Ax = b.
C     | It requires the A be symmetric.
C     | This implementation assumes A is a five-diagonal matrix
C     | of the form that arises in the discrete representation of
C     | the del^2 operator in a two-dimensional space.
C     *================================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     === Global data ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "CG2D.h"

C     !INPUT/OUTPUT PARAMETERS:
C     cg2d_b    :: The source term or "right hand side" (output: normalised RHS)
C     cg2d_x    :: The solution (input: first guess)
C     firstResidual :: the initial residual before any iterations
C     minResidualSq :: the lowest residual reached (squared)
C     lastResidual  :: the actual residual reached
C     numIters  :: Inp: the maximum number of iterations allowed
C                  Out: the actual number of iterations used
C     nIterMin  :: Inp: decide to store (if >=0) or not (if <0) lowest res. sol.
C                  Out: iteration number corresponding to lowest residual
C     myThid    :: Thread on which I am working.
      _RL  cg2d_b(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL  cg2d_x(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL  firstResidual
      _RL  minResidualSq
      _RL  lastResidual
      INTEGER numIters
      INTEGER nIterMin
      INTEGER myThid

#ifdef ALLOW_SRCG
C     !LOCAL VARIABLES:
C     bi, bj     :: tile index in X and Y.
C     i, j, it2d :: Loop counters ( it2d counts CG iterations )
C     actualIts  :: actual CG iteration number
C     err_sq     :: Measure of the square of the residual of Ax - b.
C     eta_qrN    :: Used in computing search directions; suffix N and NM1
C     eta_qrNM1     denote current and previous iterations respectively.
C     cgBeta     :: coeff used to update conjugate direction vector "s".
C     alpha      :: coeff used to update solution & residual
C     sumRHS     :: Sum of right-hand-side. Sometimes this is a useful
C                   debugging/trouble shooting diagnostic. For neumann problems
C                   sumRHS needs to be ~0 or it converge at a non-zero residual.
C     sumVec     :: output vector for GLOBAL_SUM_VECTOR call
C     tiledVec   :: input  vector for GLOBAL_SUM_VECTOR call
C     cg2d_min   :: used to store solution corresponding to lowest residual.
C     msgBuf     :: Informational/error message buffer
C--   local working array (used to be in CG2D.h common block:
C     cg2d_y     :: residual scaled by preconditioner
C     cg2d_v     :: z times the operator
C     cg2d_q     :: Intermediate matrix-vector product term
C     cg2d_r     ::   *same*
C     cg2d_s     ::   *same*
      INTEGER bi, bj
      INTEGER i, j, it2d
c     INTEGER actualIts
      _RL    err_sq,  errTile(nSx,nSy)
      _RL    eta_qrN, eta_qrNtile(nSx,nSy)
      _RL    eta_qrNM1
      _RL    cgBeta
      _RL    alpha,  alphaTile(nSx,nSy)
      _RL    sigma
      _RL    delta,  deltaTile(nSx,nSy)
      _RL    sumRHS, sumRHStile(nSx,nSy)
      _RL    sumVec(3), tiledVec(nSx,nSy,3)
      _RL    rhsMax
      _RL    rhsNorm
      _RL    cg2d_min(1:sNx,1:sNy,nSx,nSy)
      _RL    cg2d_v(1:sNx,1:sNy,nSx,nSy)
      _RL    cg2d_q(1:sNx,1:sNy,nSx,nSy)
      _RL    cg2d_y(1-1:sNx+1,1-1:sNy+1,nSx,nSy)
      _RL    cg2d_r(1-1:sNx+1,1-1:sNy+1,nSx,nSy)
      _RL    cg2d_s(1-1:sNx+1,1-1:sNy+1,nSx,nSy)
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      LOGICAL printResidual
CEOP

C--   Initialise auxiliary constant, some output variable and inverter
      minResidualSq = -1. _d 0
      eta_qrNM1     =  1. _d 0

C--   Normalise RHS
      rhsMax = 0. _d 0
      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        DO j=1,sNy
         DO i=1,sNx
          cg2d_b(i,j,bi,bj) = cg2d_b(i,j,bi,bj)*cg2dNorm
          rhsMax = MAX(ABS(cg2d_b(i,j,bi,bj)),rhsMax)
         ENDDO
        ENDDO
       ENDDO
      ENDDO

      IF (cg2dNormaliseRHS) THEN
C-  Normalise RHS :
      _GLOBAL_MAX_RL( rhsMax, myThid )
      rhsNorm = 1. _d 0
      IF ( rhsMax .NE. 0. ) rhsNorm = 1. _d 0 / rhsMax
      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        DO j=1,sNy
         DO i=1,sNx
          cg2d_b(i,j,bi,bj) = cg2d_b(i,j,bi,bj)*rhsNorm
          cg2d_x(i,j,bi,bj) = cg2d_x(i,j,bi,bj)*rhsNorm
         ENDDO
        ENDDO
       ENDDO
      ENDDO
C- end Normalise RHS
      ENDIF

C--   Update overlaps
      CALL EXCH_XY_RL( cg2d_x, myThid )

C--   Initial residual calculation
      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
C-    Initialise local working arrays:
        DO j=1,sNy
         DO i=1,sNx
          cg2d_v(i,j,bi,bj) = 0. _d 0
          cg2d_q(i,j,bi,bj) = 0. _d 0
         ENDDO
        ENDDO
        DO j=0,sNy+1
         DO i=0,sNx+1
          cg2d_y(i,j,bi,bj) = 0. _d 0
          cg2d_r(i,j,bi,bj) = 0. _d 0
          cg2d_s(i,j,bi,bj) = 0. _d 0
         ENDDO
        ENDDO
        IF ( nIterMin.GE.0 ) THEN
C-    Initialise saved solution
         DO j=1,sNy
          DO i=1,sNx
           cg2d_min(i,j,bi,bj) = cg2d_x(i,j,bi,bj)
          ENDDO
         ENDDO
        ENDIF
        sumRHStile(bi,bj) = 0. _d 0
        errTile(bi,bj)    = 0. _d 0
#ifdef TARGET_NEC_SX
!CDIR OUTERUNROLL=CG2D_OUTERLOOPITERS
#endif /* TARGET_NEC_SX */
        DO j=1,sNy
         DO i=1,sNx
          cg2d_r(i,j,bi,bj) = cg2d_b(i,j,bi,bj) -
     &    (aW2d(i  ,j  ,bi,bj)*cg2d_x(i-1,j  ,bi,bj)
     &    +aW2d(i+1,j  ,bi,bj)*cg2d_x(i+1,j  ,bi,bj)
     &    +aS2d(i  ,j  ,bi,bj)*cg2d_x(i  ,j-1,bi,bj)
     &    +aS2d(i  ,j+1,bi,bj)*cg2d_x(i  ,j+1,bi,bj)
     &    +aC2d(i  ,j  ,bi,bj)*cg2d_x(i  ,j  ,bi,bj)
     &    )
          errTile(bi,bj)    = errTile(bi,bj)
     &                      + cg2d_r(i,j,bi,bj)*cg2d_r(i,j,bi,bj)
          sumRHStile(bi,bj) = sumRHStile(bi,bj) + cg2d_b(i,j,bi,bj)
         ENDDO
        ENDDO
       ENDDO
      ENDDO

      CALL EXCH_S3D_RL( cg2d_r, 1,  myThid )

      CALL GLOBAL_SUM_TILE_RL( sumRHStile, sumRHS, myThid )
      CALL GLOBAL_SUM_TILE_RL( errTile,    err_sq, myThid )

      it2d      = 0
c     actualIts = 0
      firstResidual = SQRT(err_sq)
      IF ( nIterMin.GE.0 ) THEN
        nIterMin = 0
        minResidualSq = err_sq
      ENDIF

      printResidual = .FALSE.
      IF ( debugLevel .GE. debLevZero ) THEN
        _BEGIN_MASTER( myThid )
        printResidual = printResidualFreq.GE.1
        WRITE(standardMessageUnit,'(A,1P2E22.14)')
     &  ' cg2d: Sum(rhs),rhsMax = ', sumRHS,rhsMax
        _END_MASTER( myThid )
      ENDIF

      IF ( err_sq .LT. cg2dTolerance_sq ) GOTO 11

C DER (1999) do one iteration outside of the loop to start things up.
C--    Solve preconditioning equation and update
C--    conjugate direction vector "s".
      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        eta_qrNtile(bi,bj) = 0. _d 0
#ifdef TARGET_NEC_SX
!CDIR OUTERUNROLL=CG2D_OUTERLOOPITERS
#endif /* TARGET_NEC_SX */
        DO j=1,sNy
         DO i=1,sNx
           cg2d_y(i,j,bi,bj) =
     &       pC(i  ,j  ,bi,bj)*cg2d_r(i  ,j  ,bi,bj)
     &      +pW(i  ,j  ,bi,bj)*cg2d_r(i-1,j  ,bi,bj)
     &      +pW(i+1,j  ,bi,bj)*cg2d_r(i+1,j  ,bi,bj)
     &      +pS(i  ,j  ,bi,bj)*cg2d_r(i  ,j-1,bi,bj)
     &      +pS(i  ,j+1,bi,bj)*cg2d_r(i  ,j+1,bi,bj)
           cg2d_s(i,j,bi,bj)  = cg2d_y(i,j,bi,bj)
           eta_qrNtile(bi,bj) = eta_qrNtile(bi,bj)
     &      +cg2d_y(i,j,bi,bj)*cg2d_r(i,j,bi,bj)
         ENDDO
        ENDDO
       ENDDO
      ENDDO

      CALL EXCH_S3D_RL( cg2d_s, 1, myThid )
      CALL GLOBAL_SUM_TILE_RL( eta_qrNtile,eta_qrN,myThid )

      eta_qrNM1 = eta_qrN

C==    Evaluate laplace operator on conjugate gradient vector
C==    q = A.s
      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        alphaTile(bi,bj) = 0. _d 0
#ifdef TARGET_NEC_SX
!CDIR OUTERUNROLL=CG2D_OUTERLOOPITERS
#endif /* TARGET_NEC_SX */
        DO j=1,sNy
         DO i=1,sNx
          cg2d_q(i,j,bi,bj) =
     &      aW2d(i  ,j  ,bi,bj)*cg2d_s(i-1,j  ,bi,bj)
     &     +aW2d(i+1,j  ,bi,bj)*cg2d_s(i+1,j  ,bi,bj)
     &     +aS2d(i  ,j  ,bi,bj)*cg2d_s(i  ,j-1,bi,bj)
     &     +aS2d(i  ,j+1,bi,bj)*cg2d_s(i  ,j+1,bi,bj)
     &     +aC2d(i  ,j  ,bi,bj)*cg2d_s(i  ,j  ,bi,bj)
          alphaTile(bi,bj) = alphaTile(bi,bj)
     &                     + cg2d_s(i,j,bi,bj)*cg2d_q(i,j,bi,bj)
         ENDDO
        ENDDO
       ENDDO
      ENDDO

      CALL GLOBAL_SUM_TILE_RL( alphaTile,  alpha,  myThid )

      sigma = eta_qrN/alpha

C==   Update simultaneously solution and residual vectors (and Iter number)
C     Now compute "interior" points.
      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        DO j=1,sNy
         DO i=1,sNx
          cg2d_x(i,j,bi,bj)=cg2d_x(i,j,bi,bj)+sigma*cg2d_s(i,j,bi,bj)
          cg2d_r(i,j,bi,bj)=cg2d_r(i,j,bi,bj)-sigma*cg2d_q(i,j,bi,bj)
         ENDDO
        ENDDO
       ENDDO
      ENDDO
c     actualIts = 1

      CALL EXCH_S3D_RL( cg2d_r,1, myThid )

C     >>>>>>>>>>>>>>> BEGIN SOLVER <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
      DO 10 it2d=1, numIters-1
c      actualIts = it2d

C--    Solve preconditioning equation and update
C--    conjugate direction vector "s".
C--    z = M^-1 r
       DO bj=myByLo(myThid),myByHi(myThid)
        DO bi=myBxLo(myThid),myBxHi(myThid)
#ifdef TARGET_NEC_SX
!CDIR OUTERUNROLL=CG2D_OUTERLOOPITERS
#endif /* TARGET_NEC_SX */
         DO j=1,sNy
          DO i=1,sNx
           cg2d_y(i,j,bi,bj) =
     &       pC(i  ,j  ,bi,bj)*cg2d_r(i  ,j  ,bi,bj)
     &      +pW(i  ,j  ,bi,bj)*cg2d_r(i-1,j  ,bi,bj)
     &      +pW(i+1,j  ,bi,bj)*cg2d_r(i+1,j  ,bi,bj)
     &      +pS(i  ,j  ,bi,bj)*cg2d_r(i  ,j-1,bi,bj)
     &      +pS(i  ,j+1,bi,bj)*cg2d_r(i  ,j+1,bi,bj)
          ENDDO
         ENDDO
        ENDDO
       ENDDO

       CALL EXCH_S3D_RL( cg2d_y, 1, myThid )

C==    v = A.z
C--    eta_qr = <z,r>
C--    delta = <z,v>
C--    Do the error calcuation here to consolidate global reductions
       DO bj=myByLo(myThid),myByHi(myThid)
        DO bi=myBxLo(myThid),myBxHi(myThid)
         eta_qrNtile(bi,bj) = 0. _d 0
         deltaTile(bi,bj)   = 0. _d 0
         errTile(bi,bj) = 0. _d 0
#ifdef TARGET_NEC_SX
!CDIR OUTERUNROLL=CG2D_OUTERLOOPITERS
#endif /* TARGET_NEC_SX */
         DO j=1,sNy
          DO i=1,sNx
           cg2d_v(i,j,bi,bj) =
     &       aW2d(i  ,j  ,bi,bj)*cg2d_y(i-1,j  ,bi,bj)
     &      +aW2d(i+1,j  ,bi,bj)*cg2d_y(i+1,j  ,bi,bj)
     &      +aS2d(i  ,j  ,bi,bj)*cg2d_y(i  ,j-1,bi,bj)
     &      +aS2d(i  ,j+1,bi,bj)*cg2d_y(i  ,j+1,bi,bj)
     &      +aC2d(i  ,j  ,bi,bj)*cg2d_y(i  ,j  ,bi,bj)
           eta_qrNtile(bi,bj) = eta_qrNtile(bi,bj)
     &      +cg2d_y(i,j,bi,bj)*cg2d_r(i,j,bi,bj)
           deltaTile(bi,bj) = deltaTile(bi,bj)
     &      +cg2d_y(i,j,bi,bj)*cg2d_v(i,j,bi,bj)
           errTile(bi,bj) = errTile(bi,bj)
     &                    + cg2d_r(i,j,bi,bj)*cg2d_r(i,j,bi,bj)
          ENDDO
         ENDDO
         tiledVec(bi,bj,1) = eta_qrNtile(bi,bj)
         tiledVec(bi,bj,2) = deltaTile(bi,bj)
         tiledVec(bi,bj,3) = errTile(bi,bj)
        ENDDO
       ENDDO

       CALL GLOBAL_SUM_VECTOR_RL( 3, tiledVec, sumVec, myThid )

       eta_qrN = sumVec(1)
       delta   = sumVec(2)
       err_sq  = sumVec(3)

       IF ( printResidual ) THEN
        IF ( MOD( it2d-1, printResidualFreq ).EQ.0 ) THEN
         WRITE(msgBuf,'(A,I6,A,1PE21.14)')
     &    ' cg2d: iter=', it2d, ' ; resid.= ', SQRT(err_sq)
         CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                       SQUEEZE_RIGHT, myThid )
        ENDIF
       ENDIF
       IF ( err_sq .LT. cg2dTolerance_sq ) GOTO 11
       IF ( err_sq .LT. minResidualSq ) THEN
C-     Store lowest residual solution
         minResidualSq = err_sq
         nIterMin = it2d
         DO bj=myByLo(myThid),myByHi(myThid)
          DO bi=myBxLo(myThid),myBxHi(myThid)
           DO j=1,sNy
            DO i=1,sNx
             cg2d_min(i,j,bi,bj) = cg2d_x(i,j,bi,bj)
            ENDDO
           ENDDO
          ENDDO
         ENDDO
       ENDIF

       cgBeta   = eta_qrN/eta_qrNM1
       eta_qrNM1 = eta_qrN
       alpha = delta - (cgBeta*cgBeta)*alpha
       sigma = eta_qrN/alpha

C==    Update simultaneously solution and residual vectors (and Iter number)
       DO bj=myByLo(myThid),myByHi(myThid)
        DO bi=myBxLo(myThid),myBxHi(myThid)
         DO j=1,sNy
          DO i=1,sNx
           cg2d_s(i,j,bi,bj) = cg2d_y(i,j,bi,bj)
     &                       + cgBeta*cg2d_s(i,j,bi,bj)
           cg2d_x(i,j,bi,bj) = cg2d_x(i,j,bi,bj)
     &                       + sigma*cg2d_s(i,j,bi,bj)
           cg2d_q(i,j,bi,bj) = cg2d_v(i,j,bi,bj)
     &                       + cgBeta*cg2d_q(i,j,bi,bj)
           cg2d_r(i,j,bi,bj) = cg2d_r(i,j,bi,bj)
     &                       - sigma*cg2d_q(i,j,bi,bj)
          ENDDO
         ENDDO
        ENDDO
       ENDDO
c      actualIts = it2d + 1

       CALL EXCH_S3D_RL( cg2d_r, 1, myThid )

   10 CONTINUE
      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        errTile(bi,bj) = 0. _d 0
        DO j=1,sNy
         DO i=1,sNx
          errTile(bi,bj) = errTile(bi,bj)
     &                   + cg2d_r(i,j,bi,bj)*cg2d_r(i,j,bi,bj)
         ENDDO
        ENDDO
       ENDDO
      ENDDO
      CALL GLOBAL_SUM_TILE_RL( errTile,    err_sq, myThid )
   11 CONTINUE

      IF ( nIterMin.GE.0 .AND. err_sq .GT. minResidualSq ) THEN
C-    use the lowest residual solution (instead of current one = last residual)
        DO bj=myByLo(myThid),myByHi(myThid)
         DO bi=myBxLo(myThid),myBxHi(myThid)
          DO j=1,sNy
           DO i=1,sNx
             cg2d_x(i,j,bi,bj) = cg2d_min(i,j,bi,bj)
           ENDDO
          ENDDO
         ENDDO
        ENDDO
      ENDIF

      IF (cg2dNormaliseRHS) THEN
C--   Un-normalise the answer
        DO bj=myByLo(myThid),myByHi(myThid)
         DO bi=myBxLo(myThid),myBxHi(myThid)
          DO j=1,sNy
           DO i=1,sNx
            cg2d_x(i,j,bi,bj) = cg2d_x(i,j,bi,bj)/rhsNorm
           ENDDO
          ENDDO
         ENDDO
        ENDDO
      ENDIF

C--   Return parameters to caller
      lastResidual = SQRT(err_sq)
      numIters = it2d
c     numIters = actualIts

#endif /* ALLOW_SRCG */
      RETURN
      END

#include "SEAICE_OPTIONS.h"

CBOP
C     !ROUTINE: SEAICE_READ_PICKUP
C     !INTERFACE:
      SUBROUTINE SEAICE_READ_PICKUP ( myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE SEAICE_READ_PICKUP
C     | o Read in sea ice pickup file for restarting.
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     == Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "SEAICE_SIZE.h"
#include "SEAICE_PARAMS.h"
#include "SEAICE.h"
#include "SEAICE_TRACER.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     myThid :: My Thread Id. number
      INTEGER myThid

C     !LOCAL VARIABLES:
C     == Local variables ==
C     fp          :: pickup-file precision
C     fn          :: Temp. for building file name.
C     filePrec    :: pickup-file precision (read from meta file)
C     nbFields    :: number of fields in pickup file (read from meta file)
C     missFldList :: List of missing fields   (attempted to read but not found)
C     missFldDim  :: Dimension of missing fields list array: missFldList
C     nMissing    :: Number of missing fields (attempted to read but not found)
C     nj          :: record & field number
C     ioUnit      :: temp for writing msg unit
C     msgBuf      :: Informational/error message buffer
C     i,j,k       :: loop indices
C     bi,bj       :: tile indices
      INTEGER fp
      CHARACTER*(10) suff
      CHARACTER*(MAX_LEN_FNAM) fn
      INTEGER filePrec, nbFields
      INTEGER missFldDim, nMissing
      PARAMETER( missFldDim = 20 )
      CHARACTER*(8) missFldList(missFldDim)
      INTEGER nj, ioUnit
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      INTEGER i,j,k,bi,bj
      LOGICAL doMapTice
#ifdef ALLOW_SITRACER
      CHARACTER*(8) fldName
      INTEGER iTrac
#endif
CEOP

      IF ( pickupSuff .EQ. ' ' ) THEN
        IF ( rwSuffixType.EQ.0 ) THEN
          WRITE(fn,'(A,I10.10)') 'pickup_seaice.', nIter0
        ELSE
          CALL RW_GET_SUFFIX( suff, startTime, nIter0, myThid )
          WRITE(fn,'(A,A)') 'pickup_seaice.', suff
        ENDIF
      ELSE
        WRITE(fn,'(A,A10)') 'pickup_seaice.', pickupSuff
      ENDIF
      fp = precFloat64
      doMapTice = .FALSE.

C     Going to really do some IO. Make everyone except master thread wait.
      _BARRIER

c     IF ( seaice_pickup_read_mdsio ) THEN

C--    Read meta file (if exist) and prepare for reading Multi-Fields file
       CALL READ_MFLDS_SET(
     I                      fn,
     O                      nbFields, filePrec,
     I                      nITD, nIter0, myThid )

       _BEGIN_MASTER( myThid )
       IF ( nbFields.GE.0 .AND. filePrec.NE.fp ) THEN
         WRITE(msgBuf,'(2A,I4)') 'SEAICE_READ_PICKUP: ',
     &    'pickup-file binary precision do not match !'
         CALL PRINT_ERROR( msgBuf, myThid )
         WRITE(msgBuf,'(A,2(A,I4))') 'SEAICE_READ_PICKUP: ',
     &    'file prec.=', filePrec, ' but expecting prec.=', fp
         CALL PRINT_ERROR( msgBuf, myThid )
         STOP 'ABNORMAL END: S/R SEAICE_READ_PICKUP (data-prec Pb)'
       ENDIF
       _END_MASTER( myThid )

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

       IF ( nbFields.LE.0 ) THEN
C-      No meta-file or old meta-file without List of Fields
        ioUnit = errorMessageUnit
        IF ( pickupStrictlyMatch ) THEN
          WRITE(msgBuf,'(4A)') 'SEAICE_READ_PICKUP: ',
     &      'no field-list found in meta-file',
     &      ' => cannot check for strict-matching'
          CALL PRINT_ERROR( msgBuf, myThid )
          WRITE(msgBuf,'(4A)') 'SEAICE_READ_PICKUP: ',
     &      'try with " pickupStrictlyMatch=.FALSE.,"',
     &      ' in file: "data", NameList: "PARM03"'
          CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
          STOP 'ABNORMAL END: S/R SEAICE_READ_PICKUP'
        ELSE
          WRITE(msgBuf,'(4A)') 'WARNING >> SEAICE_READ_PICKUP: ',
     &      ' no field-list found'
          CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
         IF ( nbFields.EQ.-1 ) THEN
C-      No meta-file
          WRITE(msgBuf,'(4A)') 'WARNING >> ',
     &      ' try to read pickup as currently written'
          CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
         ELSE
C-      Old meta-file without List of Fields
          WRITE(msgBuf,'(4A)') 'WARNING >> ',
     &      ' try to read pickup as it used to be written'
          CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
          WRITE(msgBuf,'(4A)') 'WARNING >> ',
     &      ' until checkpoint59j (2007 Nov 25)'
          CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
         ENDIF
        ENDIF
       ENDIF

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C---   Old way to read seaice fields:
       IF ( nbFields.EQ.0 ) THEN

C--    Read ice model fields
        nj = 1
        IF (SEAICE_multDim.GT.1) THEN
         CALL READ_REC_3D_RL( fn,fp,nITD, TICES, nj,nIter0,myThid )
         nj = nj + nITD
        ELSE
         doMapTice = .TRUE.
         CALL READ_REC_LEV_RL( fn, fp, nITD,1,1, TICES,
     I                         nj, nIter0, myThid )
         nj = nj + 1
        ENDIF
        nj = nj + 1
        CALL READ_REC_3D_RL( fn, fp, 1, HSNOW    , nj, nIter0, myThid )
        nj = nj + 1
        CALL READ_REC_3D_RL( fn, fp, 1, UICE    , nj, nIter0, myThid )
        nj = nj + 3
        CALL READ_REC_3D_RL( fn, fp, 1, VICE    , nj, nIter0, myThid )
        nj = nj + 3
        CALL READ_REC_3D_RL( fn, fp, 1, HEFF    , nj, nIter0, myThid )
        nj = nj + 3
        CALL READ_REC_3D_RL( fn, fp, 1, AREA    , nj, nIter0, myThid )
        nj = nj + 3
#ifdef SEAICE_ITD
C--     no ITD information available with old pickup files
C       use log-normal distribution based on mean thickness instead
        CALL SEAICE_ITD_PICKUP( nIter0, myThid )
#endif
#if (defined(SEAICE_CGRID) && defined(SEAICE_ALLOW_EVP))
        IF ( SEAICEuseEVP .AND. SEAICEuseEVPpickup ) THEN
         CALL READ_REC_3D_RL(fn,fp,1,seaice_sigma1,nj, nIter0, myThid )
         nj = nj + 1
         CALL READ_REC_3D_RL(fn,fp,1,seaice_sigma2,nj, nIter0, myThid )
         nj = nj + 1
         CALL READ_REC_3D_RL(fn,fp,1,seaice_sigma12,nj,nIter0, myThid )
         nj = nj + 1
        ENDIF
#endif /* SEAICE_ALLOW_EVP */
#ifdef SEAICE_VARIABLE_SALINITY
        CALL READ_REC_3D_RL( fn, fp, 1, HSALT    , nj, nIter0, myThid )
        nj = nj + 1
#endif

       ELSE
C---   New way to read model fields:
         nj = 0
C--    read Sea-Ice Thermodynamics State variables, starting with 3-D fields:
        IF ( .NOT.useThSIce ) THEN
         IF (SEAICE_multDim.GT.1) THEN
          CALL READ_MFLDS_3D_RL( 'siTICES ', TICES,
     &                                nj, fp, nITD, nIter0, myThid )
          nj = nj*nITD
          IF ( nj.EQ.0 ) THEN
           doMapTice = .TRUE.
           CALL READ_MFLDS_LEV_RL( 'siTICE  ', TICES,
     &                            nj, fp, nITD,1,1, nIter0, myThid )
          ENDIF
         ELSE
C     SEAICE_multDim.EQ.1
          doMapTice = .TRUE.
          CALL READ_MFLDS_LEV_RL( 'siTICE  ', TICES,
     &                            nj, fp, nITD,1,1, nIter0, myThid )
          IF ( nj.EQ.0 ) THEN
           CALL READ_MFLDS_LEV_RL( 'siTICES ', TICES,
     &                            nj, fp, nITD,1,1, nIter0, myThid )
          ENDIF
         ENDIF
C--    continue with 2-D fields:
#ifdef SEAICE_ITD
         CALL READ_MFLDS_3D_RL( 'siAREAn ', AREAITD,
     &                                   nj, fp, nITD, nIter0, myThid )
         IF ( nj.EQ.0 ) THEN
C        no multi-category fields available
C        -> read average fields ...
#endif
         CALL READ_MFLDS_3D_RL( 'siAREA  ', AREA,
     &                                      nj, fp, 1, nIter0, myThid )
         CALL READ_MFLDS_3D_RL( 'siHEFF  ', HEFF,
     &                                      nj, fp, 1, nIter0, myThid )
         CALL READ_MFLDS_3D_RL( 'siHSNOW ', HSNOW,
     &                                      nj, fp, 1, nIter0, myThid )
#ifdef SEAICE_ITD
C        ... and redistribute over categories
C            assuming a log-normal distribtuion
          CALL SEAICE_ITD_PICKUP( nIter0, myThid )
C
         ELSE
C        multi-category fields available, continue reading
          CALL READ_MFLDS_3D_RL( 'siHEFFn ', HEFFITD,
     &                                   nj, fp, nITD, nIter0, myThid )
          CALL READ_MFLDS_3D_RL( 'siHSNOWn ', HSNOWITD,
     &                                   nj, fp, nITD, nIter0, myThid )
C        update total ice area as well as mean ice and snow thickness
          DO bj=myByLo(myThid),myByHi(myThid)
           DO bi=myBxLo(myThid),myBxHi(myThid)
            CALL SEAICE_ITD_SUM( bi, bj, startTime, nIter0, myThid )
           ENDDO
          ENDDO
         ENDIF
#endif
#ifdef SEAICE_VARIABLE_SALINITY
         CALL READ_MFLDS_3D_RL( 'siHSALT ', HSALT,
     &                                      nj, fp, 1, nIter0, myThid )
#endif
#ifdef ALLOW_SITRACER
         DO iTrac = 1, SItrNumInUse
          WRITE(fldName,'(A6,I2.2)') 'siTrac', iTrac
          CALL READ_MFLDS_3D_RL( fldName,
     &         SItracer(1-OLx,1-OLy,1,1,iTrac),
     &         nj, fp, 1, nIter0, myThid )
          _EXCH_XY_RL(SItracer(1-OLx,1-OLy,1,1,iTrac),myThid)
         ENDDO
#endif /* ALLOW_SITRACER */

        ENDIF

C--    read Sea-Ice Dynamics variables (all 2-D fields):
         CALL READ_MFLDS_3D_RL( 'siUICE  ', UICE,
     &                                      nj, fp, 1, nIter0, myThid )
         CALL READ_MFLDS_3D_RL( 'siVICE  ', VICE,
     &                                      nj, fp, 1, nIter0, myThid )
         IF ( SEAICEuseBDF2 ) THEN
          CALL READ_MFLDS_3D_RL('siUicNm1', uIceNm1,
     &                                      nj, fp, 1, nIter0, myThid )
          CALL READ_MFLDS_3D_RL('siVicNm1', vIceNm1,
     &                                      nj, fp, 1, nIter0, myThid )
         ENDIF
#if (defined(SEAICE_CGRID) && defined(SEAICE_ALLOW_EVP))
        IF ( SEAICEuseEVP ) THEN
         CALL READ_MFLDS_3D_RL( 'siSigm1 ', seaice_sigma1,
     &                                      nj, fp, 1, nIter0, myThid )
         CALL READ_MFLDS_3D_RL( 'siSigm2 ', seaice_sigma2,
     &                                      nj, fp, 1, nIter0, myThid )
         CALL READ_MFLDS_3D_RL( 'siSigm12', seaice_sigma12,
     &                                      nj, fp, 1, nIter0, myThid )
        ENDIF
#endif /* SEAICE_CGRID & SEAICE_ALLOW_EVP */

C---   end: new way to read pickup file
       ENDIF

C--    Check for missing fields:
       nMissing = missFldDim
       CALL READ_MFLDS_CHECK(
     O                    missFldList,
     U                    nMissing,
     I                    nIter0, myThid )
       IF ( nMissing.GT.missFldDim ) THEN
         WRITE(msgBuf,'(2A,I4)') 'SEAICE_READ_PICKUP: ',
     &     'missing fields list has been truncated to', missFldDim
         CALL PRINT_ERROR( msgBuf, myThid )
         STOP 'ABNORMAL END: S/R SEAICE_READ_PICKUP (list-size Pb)'
       ENDIF
       CALL SEAICE_CHECK_PICKUP(
     I                    missFldList,
     I                    nMissing, nbFields,
     I                    nIter0, myThid )

C--   end: seaice_pickup_read_mdsio
c     ENDIF

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

       IF ( doMapTice ) THEN
C      copy TICES(k=1) to TICES(k)
         DO bj=myByLo(myThid),myByHi(myThid)
          DO bi=myBxLo(myThid),myBxHi(myThid)
           DO k=2,nITD
            DO j=1,sNy
             DO i=1,sNx
               TICES(i,j,k,bi,bj) = TICES(i,j,1,bi,bj)
             ENDDO
            ENDDO
           ENDDO
          ENDDO
         ENDDO
       ENDIF

C--    Update overlap regions
       CALL EXCH_UV_XY_RL( uIce, vIce,.TRUE.,myThid)
       _EXCH_XY_RL( HEFF, myThid )
       _EXCH_XY_RL( AREA, myThid )
       CALL EXCH_3D_RL( TICES, nITD, myThid )
       _EXCH_XY_RL(HSNOW, myThid )
#if (defined(SEAICE_CGRID) && defined(SEAICE_ALLOW_EVP))
       IF ( SEAICEuseEVP ) THEN
          _EXCH_XY_RL(seaice_sigma1 , myThid )
          _EXCH_XY_RL(seaice_sigma2 , myThid )
          _EXCH_XY_RL(seaice_sigma12, myThid )
       ENDIF
#endif /* SEAICE_CGRID SEAICE_ALLOW_EVP */
#ifdef SEAICE_VARIABLE_SALINITY
       _EXCH_XY_RL(HSALT, myThid )
#endif
#ifdef SEAICE_ITD
       CALL EXCH_3D_RL( HEFFITD,  nITD, myThid )
       CALL EXCH_3D_RL( AREAITD,  nITD, myThid )
       CALL EXCH_3D_RL( HSNOWITD, nITD, myThid )
#endif /* SEAICE_ITD */

      RETURN
      END

#include "GAD_OPTIONS.h"

CBOP
C !ROUTINE: GAD_DST3_ADV_R

C !INTERFACE: ==========================================================
      SUBROUTINE GAD_DST3_ADV_R(
     I           bi,bj,k,dTarg,
     I           rTrans, wFld,
     I           tracer,
     O           wT,
     I           myThid )

C !DESCRIPTION:
C  Calculates the area integrated vertical flux due to advection of a tracer
C  using 3rd-order Direct Space and Time (DST-3) Advection Scheme

C !USES: ===============================================================
      IMPLICIT NONE

C     == GLobal variables ==
#include "SIZE.h"
#ifdef OLD_DST3_FORMULATION
#include "EEPARAMS.h"
#include "PARAMS.h"
#endif
#include "GRID.h"
#include "GAD.h"

C     == Routine arguments ==
C !INPUT PARAMETERS: ===================================================
C  bi,bj             :: tile indices
C  k                 :: vertical level
C  deltaTloc         :: local time-step (s)
C  rTrans            :: vertical volume transport
C  wFld              :: vertical flow
C  tracer            :: tracer field
C  myThid            :: thread number
      INTEGER bi,bj,k
      _RL dTarg
      _RL rTrans(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL wFld  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL tracer(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      INTEGER myThid

C !OUTPUT PARAMETERS: ==================================================
C  wT                :: vertical advective flux
      _RL wT    (1-OLx:sNx+OLx,1-OLy:sNy+OLy)

C     == Local variables ==
C !LOCAL VARIABLES: ====================================================
C  i,j               :: loop indices
C  km1               :: =max( k-1 , 1 )
C  wLoc              :: velocity, vertical component
C  wCFL              :: Courant-Friedrich-Levy number
      INTEGER i,j,kp1,km1,km2
      _RL wLoc
      _RL Rjm,Rj,Rjp,cfl,d0,d1
#ifdef OLD_DST3_FORMULATION
      _RL psiP,psiM,thetaP,thetaM
      _RL smallNo

c     IF (inAdMode .AND. useApproxAdvectionInAdMode) THEN
c      smallNo = 1.0D-20
c     ELSE
       smallNo = 1.0D-20
c     ENDIF
#endif

      km2=MAX(1,k-2)
      km1=MAX(1,k-1)
      kp1=MIN(Nr,k+1)

      DO j=1-OLy,sNy+OLy
       DO i=1-OLx,sNx+OLx
        Rjp=(tracer(i,j,k)-tracer(i,j,kp1))
     &         *maskC(i,j,kp1,bi,bj)
        Rj =(tracer(i,j,km1)-tracer(i,j,k))
     &         *maskC(i,j,k,bi,bj)*maskC(i,j,km1,bi,bj)
        Rjm=(tracer(i,j,km2)-tracer(i,j,km1))
     &         *maskC(i,j,km1,bi,bj)

        wLoc = wFld(i,j)
c       wLoc = rTrans(i,j)*recip_rA(i,j,bi,bj)
        cfl=ABS(wLoc*dTarg*recip_drC(k))
        d0=(2.-cfl)*(1.-cfl)*oneSixth
        d1=(1.-cfl*cfl)*oneSixth
#ifdef OLD_DST3_FORMULATION
        IF ( ABS(Rj).LT.smallNo .OR.
     &       ABS(Rjm).LT.smallNo ) THEN
         thetaP=0.
         psiP=0.
        ELSE
         thetaP=(Rjm+smallNo)/(smallNo+Rj)
         psiP=d0+d1*thetaP
        ENDIF
        IF ( ABS(Rj).LT.smallNo .OR.
     &       ABS(Rjp).LT.smallNo ) THEN
         thetaM=0.
         psiM=0.
        ELSE
         thetaM=(Rjp+smallNo)/(smallNo+Rj)
         psiM=d0+d1*thetaM
        ENDIF
         wT(i,j)=
     &    0.5*(rTrans(i,j)+ABS(rTrans(i,j)))
     &       *( tracer(i,j, k ) + psiM*Rj )
     &   +0.5*(rTrans(i,j)-ABS(rTrans(i,j)))
     &       *( tracer(i,j,km1) - psiP*Rj )
#else /* OLD_DST3_FORMULATION */
        wT(i,j)=
     &    0.5*(rTrans(i,j)+ABS(rTrans(i,j)))
     &       *( tracer(i,j, k ) + (d0*Rj+d1*Rjp) )
     &   +0.5*(rTrans(i,j)-ABS(rTrans(i,j)))
     &       *( tracer(i,j,km1) - (d0*Rj+d1*Rjm) )
#endif /* OLD_DST3_FORMULATION */

       ENDDO
      ENDDO

      RETURN
      END

#include "GGL90_OPTIONS.h"

CBOP
C !ROUTINE: GGL90_ADD_STOKESDRIFT

C !INTERFACE: ==========================================================
      SUBROUTINE GGL90_ADD_STOKESDRIFT(
     O                 uRes, vRes,
     I                 uFld, vFld,
     I                 k, bi, bj, myThid )

C !DESCRIPTION:
C  Add Stokes-drift contribution to Eulerien velocity to get residual flow

C !USES: ===============================================================
      IMPLICIT NONE
C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "FFIELDS.h"
#include "GGL90.h"

C !INPUT/OUTPUT PARAMETERS: ===================================================
C   uRes, vRes   :: residual flow with Stokes-drift added
C   uFld, vFld   :: Eulerien horizontal velocity, 2 compon.
C   k            :: current vertical level
C   bi, bj       :: current tile indices
C   myThid       :: my Thread Id number
      _RL uRes   (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL vRes   (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL uFld   (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL vFld   (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER k, bi, bj
      INTEGER myThid

#ifdef ALLOW_GGL90_LANGMUIR
C !LOCAL VARIABLES: ====================================================
C   i, j         :: loop indices
C   uStar, vStar :: frictional velocity component
      INTEGER i,j
      _RL uStar, vStar, recip_Lasq, depthFac
      _RL stokesU(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL stokesV(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
CEOP

      IF ( useLANGMUIR ) THEN

C-    Calculate Stokes-Drift (fct of wind-stress)
C     surface Stokes-Drift velocity is just (uStar,vStar)/ LC_num^2
        recip_Lasq = 1. _d 0 / LC_num
        recip_Lasq = recip_Lasq * recip_Lasq
        depthFac = recip_Lasq*EXP( 4. _d 0 *PI/LC_lambda*rC(k) )
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
           uStar = SIGN( SQRT(ABS(surfaceForcingU(i,j,bi,bj))),
     &                   surfaceForcingU(i,j,bi,bj) )
           stokesU(i,j) = uStar * depthFac
           vStar = SIGN( SQRT(ABS(surfaceForcingV(i,j,bi,bj))),
     &                   surfaceForcingV(i,j,bi,bj) )
           stokesV(i,j) = vStar * depthFac
         ENDDO
        ENDDO

C-    Add Stokes-Drift to Eulerien velocity to get residual flow:
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
           uRes(i,j) = uFld(i,j) + stokesU(i,j)*maskW(i,j,k,bi,bj)
           vRes(i,j) = vFld(i,j) + stokesV(i,j)*maskS(i,j,k,bi,bj)
         ENDDO
        ENDDO

      ENDIF

#endif /* ALLOW_GGL90_LANGMUIR */

      RETURN
      END

#include "BULK_FORCE_OPTIONS.h"

      SUBROUTINE BULKF_SH2RH_AIM(IMODE,NGP,TA,PS,SIG,QA,RH,QSAT,myThid)
C--
C--   SUBROUTINE SHTORH (IMODE,NGP,TA,PS,SIG,QA,RH,QSAT)
C--
C--   Purpose: compute saturation specific humidity and
C--            relative hum. from specific hum. (or viceversa)
C--   Input:   IMODE  : mode of operation
C--            NGP    : no. of grid-points
C--            TA     : abs. temperature
C--            PS     : normalized pressure   (=  p/1000_hPa) [if SIG < 0]
C--                   : normalized sfc. pres. (= ps/1000_hPa) [if SIG > 0]
C--            SIG    : sigma level
C--            QA     : specific humidity in g/kg [if IMODE = 1]
C--            RH     : relative humidity         [if IMODE < 0]
C--   Output:  RH     : relative humidity         [if IMODE = 1]
C--            QA     : specific humidity in g/kg [if IMODE < 0]
C--            QSAT   : saturation spec. hum. in g/kg
C--            RH     : d.Qsat/d.T  in g/kg/K     [if IMODE = 2]
C--

      IMPLICIT NONE

C-- Routine arguments:
      INTEGER IMODE, NGP
      INTEGER  myThid
c     _RL TA(NGP), PS(NGP), QA(NGP), RH(NGP), QSAT(NGP)
      _RL TA(NGP), PS(NGP), QSAT(NGP), QA(*), RH(*)

C- jmc: declare all routine arguments:
      _RL SIG

#ifdef ALLOW_BULK_FORCE

C-- Local variables:
      INTEGER  J

C- jmc: declare all local variables:
      _RL E0, C1, C2, T0, T1, T2, QS1, QS2
      _RL sigP, recT, tmpQ
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C---  1. Compute Qsat (g/kg) from T (degK) and normalized pres. P (= p/1000_hPa)
C        If SIG > 0, P = Ps * sigma, otherwise P = Ps(1) = const.
C
      E0=  6.108 _d -3
      C1= 17.269 _d 0
      C2= 21.875 _d 0
      T0=273.16 _d 0
      T1= 35.86 _d 0
      T2=  7.66 _d 0
      QS1= 622. _d 0
      QS2= .378 _d 0


      IF (IMODE.EQ.2) THEN
C-    Compute Qsat and d.Qsat/d.T :
        DO J=1,NGP
         QSAT(J)=0.
         sigP = PS(1)
         IF (SIG.GT.0.0) sigP=SIG*PS(J)
         IF (TA(J).GE.T0) THEN
          tmpQ   = E0*EXP(C1*(TA(J)-T0)/(TA(J)-T1))
          QSAT(J)= QS1*tmpQ/(sigP-QS2*tmpQ)
          recT   = 1. _d 0 / (TA(J)-T1)
          RH(J)  = QSAT(J)*C1*(T0-T1)*recT*recT*sigP/(sigP-QS2*tmpQ)
         ELSE IF ( TA(J).GT.T2) THEN
          tmpQ   = E0*EXP(C2*(TA(J)-T0)/(TA(J)-T2))
          QSAT(J)= QS1*tmpQ/(sigP-QS2*tmpQ)
          recT   = 1. _d 0 / (TA(J)-T2)
          RH(J)  = QSAT(J)*C2*(T0-T2)*recT*recT*sigP/(sigP-QS2*tmpQ)
         ENDIF
        ENDDO
        RETURN
      ENDIF

      DO 110 J=1,NGP
        QSAT(J)=0.
        IF (TA(J).GE.T0) THEN
          QSAT(J)=E0*EXP(C1*(TA(J)-T0)/(TA(J)-T1))
        ELSE IF ( TA(J).GT.T2) THEN
          QSAT(J)=E0*EXP(C2*(TA(J)-T0)/(TA(J)-T2))
        ENDIF
  110 CONTINUE
C
      IF (SIG.LE.0.0) THEN
        DO 120 J=1,NGP
          QSAT(J)= QS1*QSAT(J)/( PS(1)   - QS2*QSAT(J))
  120   CONTINUE
      ELSE
        DO 130 J=1,NGP
          QSAT(J)= QS1*QSAT(J)/(SIG*PS(J)- QS2*QSAT(J))
  130   CONTINUE
      ENDIF
C
C---  2. Compute rel.hum. RH=Q/Qsat (IMODE>0), or Q=RH*Qsat (IMODE<0)
C
      IF (IMODE.GT.0) THEN
        DO 210 J=1,NGP
          IF(QSAT(J).NE.0.) then
            RH(J)=QA(J)/QSAT(J)
          ELSE
            RH(J)=0.
          ENDIF
  210   CONTINUE
      ELSE IF (IMODE.LT.0) THEN
        DO 220 J=1,NGP
          QA(J)=RH(J)*QSAT(J)
  220   CONTINUE
      ENDIF

#endif /* ALLOW_BULK_FORCE */
      RETURN
      END

#include "BLING_OPTIONS.h"
#ifdef ALLOW_EXF
# include "EXF_OPTIONS.h"
#endif
#ifdef ALLOW_AUTODIFF
# include "AUTODIFF_OPTIONS.h"
#endif

CBOP
      SUBROUTINE BLING_AIRSEAFLUX(
     I           PTR_DIC, PTR_ALK, PTR_O2, PTR_PO4,
#ifdef USE_SIBLING
     I           PTR_SI,
#endif
     O           SGDIC, SGO2, FluxO2,
     I           bi, bj, imin, imax, jmin, jmax,
     I           myTime, myIter, myThid)

C     =================================================================
C     | subroutine bling_airseaflux
C     | o Calculate the carbon and oxygen air-sea flux terms
C     |   Adapted from pkg/dic/dic_surfforcing.F
C     | - Get atmospheric pCO2 value
C     |   Option 1: constant value, default 268.d-6, can be changed
C     |             in data.bling
C     |   Option 2: read 2D field using EXF pkg
C     | - Update pCO2 and pH
C     =================================================================

      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "DYNVARS.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "FFIELDS.h"
#ifdef ALLOW_EXF
# include "EXF_INTERP_SIZE.h"
#endif
#include "BLING_VARS.h"
#ifdef ALLOW_AUTODIFF_TAMC
# include "tamc.h"
#endif

C     === Routine arguments ===
C     myTime           :: current time
C     myIter           :: current timestep
C     myThid           :: thread Id. number
      _RL myTime
      INTEGER myIter
      INTEGER myThid
      INTEGER iMin, iMax, jMin, jMax, bi, bj
C     === Input ===
C     PTR_DIC          :: DIC tracer field
C     PTR_ALK          :: alkalinity tracer field
C     PTR_PO4          :: phosphate tracer field
C     PTR_O2           :: oxygen tracer field
      _RL  PTR_DIC(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL  PTR_ALK(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL  PTR_PO4(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL  PTR_O2 (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
#ifdef USE_SIBLING
      _RL  PTR_SI (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
#endif
C     === Output ===
C     SGDIC            :: surface tendency of DIC due to air-sea exchange
C     SGO2             :: surface tendency of O2 due to air-sea exchange
C     FluxO2           :: air-sea flux of O2
C     (FluxCO2 is a global variable)
      _RL  SGDIC(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL  SGO2(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL  FluxO2(1-OLx:sNx+OLx,1-OLy:sNy+OLy)

#ifdef ALLOW_PTRACERS

C     === Local variables ===
C     i,j              :: Loop counters
      INTEGER i,j,klev
C Number of iterations for pCO2 solvers
      _RL co3dummy
      _RL Kwexch_Pre   (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
C Solubility relation coefficients
      _RL SchmidtNoDIC (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL pCO2sat      (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL Kwexch       (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL pisvel       (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
C local variables for carbon chem
      _RL surfalk      (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL surfphos     (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL surfsi       (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL surftemp     (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL surfsalt     (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL surfdic      (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
C o2 solubility relation coefficients
      _RL SchmidtNoO2  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL O2sat        (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL O2sat_percent(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL Kwexch_o2    (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL aTT
      _RL aTK
      _RL aTS
      _RL aTS2
      _RL aTS3
      _RL aTS4
      _RL aTS5
      _RL o2s
      _RL ttemp
      _RL stemp
      _RL oCnew
#ifdef ALLOW_AUTODIFF_TAMC
C     tkey :: tape key (tile dependent)
      INTEGER tkey
#endif
CEOP

#ifdef ALLOW_AUTODIFF_TAMC
      tkey = bi + (bj - 1)*nSx + (ikey_dynamics - 1)*nSx*nSy
#endif

C----------------------------------------------------------------------
C First, carbon
C----------------------------------------------------------------------
        klev=1
C determine inorganic carbon chem coefficients
        DO j=jmin,jmax
         DO i=imin,imax

             surfalk(i,j)  = PTR_ALK(i,j,1)
     &                          * maskC(i,j,1,bi,bj)
             surfphos(i,j) = PTR_PO4(i,j,1)
     &                          * maskC(i,j,1,bi,bj)

C FOR NON-INTERACTIVE Si
             surftemp(i,j) = theta(i,j,1,bi,bj)
             surfsalt(i,j) = salt(i,j,1,bi,bj)
             surfdic(i,j)  = PTR_DIC(i,j,1)
#ifdef USE_SIBLING
             surfsi(i,j)   = PTR_SI(i,j,1)
#else
             surfsi(i,j)   = silica(i,j,bi,bj) * maskC(i,j,1,bi,bj)
#endif

          ENDDO
         ENDDO

#ifdef CARBONCHEM_SOLVESAPHE
#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_CALL('CARBON_COEFFS_SOLVESAPHE',myThid)
#endif
        CALL DIC_COEFFS_SURF(
     I                       surftemp,surfsalt,
     I                       bi,bj,iMin,iMax,jMin,jMax,myThid)
#else
#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_CALL('CARBON_COEFFS',myThid)
#endif
         CALL CARBON_COEFFS(
     I                       surftemp,surfsalt,
     I                       bi,bj,iMin,iMax,jMin,jMax,myThid)
#endif

       DO j=jmin,jmax
        DO i=imin,imax

C Pre-compute part of exchange coefficient: pisvel*(1-fice)
C which is re-used for flux of O2
C Schmidt number is accounted for later

              pisvel(i,j) = 0.337 _d 0 * wind(i,j,bi,bj)**2/3.6 _d 5

              Kwexch_Pre(i,j) = pisvel(i,j)* (1. _d 0 - FIce(i,j,bi,bj))

        ENDDO
       ENDDO

c pCO2 solver...

#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE ph(:,:,:,bi,bj) = comlev1_bibj, key=tkey, kind=isbyte
#endif

C$TAF LOOP = parallel
       DO j=jmin,jmax
C$TAF LOOP = parallel
        DO i=imin,imax

          IF ( maskC(i,j,klev,bi,bj).NE.0. _d 0 ) THEN
#ifdef CARBONCHEM_SOLVESAPHE
             IF ( selectPHsolver.GT.0 ) THEN
C Use Munhoven (2013) Solvesaphe routine to calculate pH and pCO2
#ifdef ALLOW_DEBUG
                IF (debugMode) CALL DEBUG_CALL(
     &     'CALC_PCO2_SOLVESAPHE from DIC_SURFFORCING',myThid)
#endif
                CALL CALC_PCO2_SOLVESAPHE(
     I        surftemp(i,j),surfsalt(i,j),
     I        surfdic(i,j), surfphos(i,j),
     I        surfsi(i,j),surfalk(i,j),
     U        pH(i,j,klev,bi,bj),pCO2(i,j,bi,bj),co3dummy,
     I        i,j,klev,bi,bj,myIter, myThid )
             ELSE
C Use the original Follows et al. (2006) solver
#endif /* CARBONCHEM_SOLVESAPHE */
#ifdef ALLOW_DEBUG
                IF (debugMode) CALL DEBUG_CALL(
     &        'CALC_PCO2_APPROX',myThid)
#endif

            CALL CALC_PCO2_APPROX(
     I        surftemp(i,j),surfsalt(i,j),
     I        surfdic(i,j), surfphos(i,j),
     I        surfsi(i,j),surfalk(i,j),
     I        ak1(i,j,bi,bj),ak2(i,j,bi,bj),
     I        ak1p(i,j,bi,bj),ak2p(i,j,bi,bj),ak3p(i,j,bi,bj),
     I        aks(i,j,bi,bj),akb(i,j,bi,bj),akw(i,j,bi,bj),
     I        aksi(i,j,bi,bj),akf(i,j,bi,bj),
     I        ak0(i,j,bi,bj), fugf(i,j,bi,bj),
     I        ff(i,j,bi,bj),
     I        bt(i,j,bi,bj),st(i,j,bi,bj),ft(i,j,bi,bj),
     U        pH(i,j,klev,bi,bj),pCO2(i,j,bi,bj),co3dummy,
     I        i,j,klev,bi,bj,myIter,myThid )

#ifdef CARBONCHEM_SOLVESAPHE
             ENDIF
#endif /* CARBONCHEM_SOLVESAPHE */

          ELSE
            pCO2(i,j,bi,bj) = 0. _d 0
          ENDIF

        ENDDO
       ENDDO
#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE pCO2(:,:,bi,bj) = comlev1_bibj, key = tkey, kind = isbyte
#endif

       DO j=jmin,jmax
        DO i=imin,imax

          IF ( maskC(i,j,1,bi,bj).NE.0. _d 0 ) THEN
C calculate SCHMIDT NO. for CO2
              SchmidtNoDIC(i,j) =
     &            sca1
     &          + sca2 * theta(i,j,1,bi,bj)
     &          + sca3 * theta(i,j,1,bi,bj)*theta(i,j,1,bi,bj)
     &          + sca4 * theta(i,j,1,bi,bj)*theta(i,j,1,bi,bj)
     &                *theta(i,j,1,bi,bj)
c make sure Schmidt number is not negative (will happen if temp>39C)
             SchmidtNoDIC(i,j) = max(1.0 _d -2, SchmidtNoDIC(i,j))

C First determine local saturation pCO2
c Correct for atmospheric pressure
              pCO2sat(i,j) = apco2(i,j,bi,bj) * AtmosP(i,j,bi,bj)

C then account for Schmidt number
              Kwexch(i,j) = Kwexch_Pre(i,j)
     &                    / sqrt(SchmidtNoDIC(i,j)/660.0 _d 0)

C Calculate flux in terms of DIC units using K0, solubility
c Flux = kw*rho*(ff*pCO2atm-k0*FugFac*pCO2ocean)
               FluxCO2(i,j,bi,bj) =
     &          Kwexch(i,j)*(
     &            ff(i,j,bi,bj)*pCO2sat(i,j) -
     &            pCO2(i,j,bi,bj)*fugf(i,j,bi,bj)
     &            *ak0(i,j,bi,bj) )
     &
          ELSE
              FluxCO2(i,j,bi,bj) = 0. _d 0
          ENDIF

C convert flux (mol kg-1 m s-1) to (mol m-2 s-1)
          FluxCO2(i,j,bi,bj) = FluxCO2(i,j,bi,bj)/permil

          ENDDO
         ENDDO

C update tendency
         DO j=jmin,jmax
          DO i=imin,imax
           SGDIC(i,j)= recip_drF(1)*recip_hFacC(i,j,1,bi,bj)
     &              *FluxCO2(i,j,bi,bj)
          ENDDO
         ENDDO

C----------------------------------------------------------------------
C Now oxygen
C----------------------------------------------------------------------

C calculate SCHMIDT NO. for O2
        DO j=jmin,jmax
          DO i=imin,imax
            IF (maskC(i,j,1,bi,bj).NE.0.) THEN
              ttemp = theta(i,j,1,bi,bj)
              stemp = salt(i,j,1,bi,bj)

              SchmidtNoO2(i,j) =
     &            sox1
     &          + sox2 * ttemp
     &          + sox3 * ttemp*ttemp
     &          + sox4 * ttemp*ttemp*ttemp

C Determine surface flux of O2
C exchange coeff accounting for ice cover and Schmidt no.
C Kwexch_Pre= pisvel*(1-fice): previously computed above

              Kwexch_o2(i,j) = Kwexch_Pre(i,j)
     &                    / sqrt(SchmidtNoO2(i,j)/660.0 _d 0)

C determine saturation O2
C using Garcia and Gordon (1992), L&O (mistake in original ?)
              aTT  = 298.15 _d 0 -ttemp
              aTK  = 273.15 _d 0 +ttemp
              aTS  = log(aTT/aTK)
              aTS2 = aTS*aTS
              aTS3 = aTS2*aTS
              aTS4 = aTS3*aTS
              aTS5 = aTS4*aTS

              oCnew  = oA0 + oA1*aTS + oA2*aTS2 + oA3*aTS3 +
     &            oA4*aTS4 + oA5*aTS5
     &          + stemp*(oB0 + oB1*aTS + oB2*aTS2 + oB3*aTS3)
     &          + oC0*(stemp*stemp)

              o2s = EXP(oCnew)

c Convert from ml/l to mol/m^3
              O2sat(i,j) = o2s/22391.6 _d 0 * 1. _d 3
c Calculate percent saturation for diagnostic
              O2sat_percent(i,j) = PTR_O2(i,j,1)/O2sat(i,j)*100

C Determine flux, incl. correction for local atmos surface pressure
              FluxO2(i,j) = Kwexch_o2(i,j)*
     &                     (AtmosP(i,j,bi,bj)*O2sat(i,j)
     &                      - PTR_O2(i,j,1))
            ELSE
              FluxO2(i,j) = 0. _d 0
            ENDIF

          ENDDO
        ENDDO

C update surface tendencies
        DO j=jmin,jmax
          DO i=imin,imax
           SGO2(i,j)= FluxO2(i,j)
     &         *recip_drF(1) * recip_hFacC(i,j,1,bi,bj)
          ENDDO
        ENDDO

        _EXCH_XY_RL( pCO2, myThid )
        _EXCH_XYZ_RL( pH, myThid )

#ifdef ALLOW_DIAGNOSTICS
      IF ( useDiagnostics ) THEN
        CALL DIAGNOSTICS_FILL(O2sat_percent,'BLGO2SAT',0,1,2,bi,bj,
     &       myThid)
      ENDIF
#endif /* ALLOW_DIAGNOSTICS */

#endif /* ALLOW_PTRACER */

        RETURN
        END

#include "SEAICE_OPTIONS.h"
#ifdef ALLOW_EXF
# include "EXF_OPTIONS.h"
#endif
#ifdef ALLOW_AUTODIFF
# include "AUTODIFF_OPTIONS.h"
#endif

CBOP
C     !ROUTINE: SEAICE_SOLVE4TEMP
C     !INTERFACE:
      SUBROUTINE SEAICE_SOLVE4TEMP(
     I   UG, HICE_ACTUAL, HSNOW_ACTUAL,
#ifdef SEAICE_CAP_SUBLIM
     I   F_lh_max,
#endif
     I   TSURFin,
     O   TSURFout,
#ifdef SEAICE_USE_GROWTH_ADX
     O   F_io_net, F_ia_net,
#endif /* SEAICE_USE_GROWTH_ADX */
     O   F_ia, IcePenetSW,
     O   FWsublim,
     I   bi, bj, myTime, myIter, myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE SOLVE4TEMP
C     | o Calculate ice growth rate, surface fluxes and
C     |   temperature of ice surface.
C     |   see Hibler, MWR, 108, 1943-1973, 1980
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     === Global variables ===
#include "SIZE.h"
#include "GRID.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "FFIELDS.h"
#include "SEAICE_SIZE.h"
#include "SEAICE_PARAMS.h"
#include "SEAICE.h"
#include "DYNVARS.h"
#ifdef ALLOW_EXF
# include "EXF_FIELDS.h"
#endif
#ifdef ALLOW_AUTODIFF_TAMC
# include "tamc.h"
#endif

C     !INPUT PARAMETERS:
C     UG           :: atmospheric wind speed (m/s)
C     HICE_ACTUAL  :: actual ice thickness
C     HSNOW_ACTUAL :: actual snow thickness
C     TSURFin    :: surface temperature of ice/snow in Kelvin
C     bi,bj      :: tile indices
C     myTime     :: current time in simulation
C     myIter     :: iteration number in simulation
C     myThid     :: my Thread Id number
C     !OUTPUT PARAMETERS:
C     TSURFout   :: updated surface temperature of ice/snow in Kelvin
C     F_io_net   :: upward conductive heat flux through seaice+snow
C     F_ia_net   :: net heat flux divergence at the sea ice/snow surface:
C                 includes ice conductive fluxes and atmospheric fluxes (W/m^2)
C     F_ia       :: upward seaice/snow surface heat flux to atmosphere (W/m^2)
C     IcePenetSW :: short wave heat flux transmitted through ice (+=upward)
C     FWsublim   :: fresh water (mass) flux due to sublimation (+=up)(kg/m^2/s)
C---- Notes:
C     1) should add IcePenetSW to F_ia to get the net surface heat flux
C        from the atmosphere (IcePenetSW not currently included in F_ia)
C     2) since zero ice/snow heat capacity is assumed, all the absorbed Short
C        -Wave is used to warm the ice/snow surface (heating profile ignored).
C----------
      _RL UG          (1:sNx,1:sNy)
      _RL HICE_ACTUAL (1:sNx,1:sNy)
      _RL HSNOW_ACTUAL(1:sNx,1:sNy)
#ifdef SEAICE_CAP_SUBLIM
      _RL F_lh_max    (1:sNx,1:sNy)
#endif
      _RL TSURFin     (1:sNx,1:sNy)
      _RL TSURFout    (1:sNx,1:sNy)
      _RL F_io_net    (1:sNx,1:sNy)
      _RL F_ia_net    (1:sNx,1:sNy)
      _RL F_ia        (1:sNx,1:sNy)
      _RL IcePenetSW  (1:sNx,1:sNy)
      _RL FWsublim    (1:sNx,1:sNy)
      INTEGER bi, bj
      _RL     myTime
      INTEGER myIter, myThid
CEOP

#if defined(ALLOW_ATM_TEMP) && defined(ALLOW_DOWNWARD_RADIATION)
C     !LOCAL VARIABLES:
C     === Local variables ===
C     i, j  :: Loop counters
C     kSurface  :: vertical index of surface layer
      INTEGER i, j
      INTEGER kSurface
      INTEGER ITER
      _RL D1, D1I
      _RL D3(1:sNx,1:sNy)
      _RL TMELT, XKI, XKS, HCUT, recip_HCUT, XIO
C     SurfMeltTemp :: Temp (K) above which wet-albedo values are used
      _RL SurfMeltTemp
C     effConduct :: effective conductivity of combined ice and snow
      _RL effConduct(1:sNx,1:sNy)
C     lhSublim :: latent heat of sublimation (SEAICE_lhEvap + SEAICE_lhFusion)
      _RL lhSublim
C     t1,t2,t3,t4 :: powers of temperature
      _RL  t1, t2, t3, t4

C-    Constants to calculate Saturation Vapor Pressure
C     Maykut Polynomial Coeff. for Sat. Vapor Press
      _RL C1, C2, C3, C4, C5, QS1
C     Extended temp-range expon. relation Coeff. for Sat. Vapor Press
      _RL lnTEN
      _RL aa1,aa2,bb1,bb2,Ppascals,cc0,cc1,cc2,cc3t
C     specific humidity at ice surface variables
      _RL mm_pi,mm_log10pi

C     tempFrz  :: ocean temperature in contact with ice
C                 (=seawater freezing point) (K)
C     F_c      :: conductive heat flux through seaice+snow (+=upward)
C     F_lwu    :: upward long-wave surface heat flux (+=upward)
C     F_sens   :: sensible surface heat flux         (+=upward)
C     F_lh     :: latent heat flux (sublimation) (+=upward)
C     qhice    :: saturation vapor pressure of snow/ice surface
C     dqh_dTs  :: derivative of qhice w.r.t snow/ice surf. temp
C     dFia_dTs :: derivative of surf heat flux (F_ia) w.r.t surf. temp
      _RL tempFrz    (1:sNx,1:sNy)
      _RL F_c        (1:sNx,1:sNy)
      _RL F_lwu      (1:sNx,1:sNy)
      _RL F_sens     (1:sNx,1:sNy)
      _RL F_lh       (1:sNx,1:sNy)
      _RL qhice      (1:sNx,1:sNy)
      _RL dqh_dTs    (1:sNx,1:sNy)
      _RL dFia_dTs   (1:sNx,1:sNy)
      _RL absorbedSW (1:sNx,1:sNy)
      _RL penetSWFrac
      _RL delTsurf

C     local copies of global variables
      _RL tsurfLoc   (1:sNx,1:sNy)
      _RL tsurfPrev  (1:sNx,1:sNy)
      _RL atempLoc   (1:sNx,1:sNy)
      _RL lwdownLoc  (1:sNx,1:sNy)
      _RL ALB        (1:sNx,1:sNy)
      _RL ALB_ICE    (1:sNx,1:sNy)
      _RL ALB_SNOW   (1:sNx,1:sNy)
C     iceOrNot :: this is HICE_ACTUAL.GT.0.
      LOGICAL iceOrNot(1:sNx,1:sNy)
#ifdef ALLOW_AUTODIFF_TAMC
C     ikey :: tape key (depends on iteration)
      INTEGER ikey
#endif
#ifdef SEAICE_DEBUG
#endif /* SEAICE_DEBUG */

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#ifdef ALLOW_AUTODIFF_TAMC
C     Since this is a "local" tape, is does not need to include number
C     of threads or tiles per mpi-process. It does not even lead to a
C     common block.
CADJ INIT loctape_solve4temp = COMMON, NMAX_TICE
#endif /* ALLOW_AUTODIFF_TAMC */

C-    MAYKUT CONSTANTS FOR SAT. VAP. PRESSURE TEMP. POLYNOMIAL
      C1=    2.7798202  _d -06
      C2=   -2.6913393  _d -03
      C3=    0.97920849 _d +00
      C4= -158.63779    _d +00
      C5= 9653.1925     _d +00
      QS1=0.622 _d +00/1013.0 _d +00
C-    Extended temp-range expon. relation Coeff. for Sat. Vapor Press
      lnTEN = LOG(10.0 _d 0)
      aa1 = 2663.5 _d 0
      aa2 = 12.537 _d 0
      bb1 = 0.622 _d 0
      bb2 = 1.0 _d 0 - bb1
      Ppascals = 100000. _d 0
C     cc0 = TEN ** aa2
      cc0 = EXP(aa2*lnTEN)
      cc1 = cc0*aa1*bb1*Ppascals*lnTEN
      cc2 = cc0*bb2

      IF ( usingPCoords ) THEN
       kSurface        = Nr
      ELSE
       kSurface        = 1
      ENDIF

C     SENSIBLE HEAT CONSTANT
      D1=SEAICE_dalton*SEAICE_cpAir*SEAICE_rhoAir

C     ICE LATENT HEAT CONSTANT
      lhSublim = SEAICE_lhEvap + SEAICE_lhFusion
      D1I=SEAICE_dalton*lhSublim*SEAICE_rhoAir

C     MELTING TEMPERATURE OF ICE
      TMELT        = celsius2K

C     ICE CONDUCTIVITY
      XKI=SEAICE_iceConduct

C     SNOW CONDUCTIVITY
      XKS=SEAICE_snowConduct

C     CUTOFF SNOW THICKNESS
C     Snow-Thickness above HCUT: SW optically thick snow (=> snow-albedo).
C     Snow-Thickness below HCUT: linear transition to ice-albedo
      HCUT = SEAICE_snowThick
      recip_HCUT = 0. _d 0
      IF ( HCUT.GT.0. _d 0 ) recip_HCUT = 1. _d 0 / HCUT

C     PENETRATION SHORTWAVE RADIATION FACTOR
      XIO=SEAICE_shortwave

C     Temperature Threshold for wet-albedo:
      SurfMeltTemp = TMELT + SEAICE_wetAlbTemp
C     old SOLVE4TEMP_LEGACY setting, consistent with former celsius2K value:
c     TMELT        = 273.16  _d +00
c     SurfMeltTemp = 273.159 _d +00

C     Initialize variables
      DO J=1,sNy
       DO I=1,sNx
C     initialise output arrays:
        TSURFout (I,J) = TSURFin(I,J)
        F_ia     (I,J) = 0. _d 0
        F_ia_net (I,J) = 0. _d 0
        F_io_net (I,J) = 0. _d 0
        IcePenetSW(I,J)= 0. _d 0
        FWsublim (I,J) = 0. _d 0
C     HICE_ACTUAL is modified in this routine, but at the same time
C     used to decided where there is ice, therefore we save this information
C     here in a separate array
        iceOrNot  (I,J) = HICE_ACTUAL(I,J) .GT. 0. _d 0
        absorbedSW(I,J) = 0. _d 0
        qhice    (I,J) = 0. _d 0
        dqh_dTs  (I,J) = 0. _d 0
        F_lh     (I,J) = 0. _d 0
        F_lwu    (I,J) = 0. _d 0
        F_sens   (I,J) = 0. _d 0
C     Make a local copy of LW, surface & atmospheric temperatures
        tsurfLoc (I,J) = TSURFin(I,J)
c       tsurfLoc (I,J) = MIN( celsius2K+MAX_TICE, TSURFin(I,J) )
        lwdownLoc(I,J) = MAX( MIN_LWDOWN, LWDOWN(I,J,bi,bj) )
        atempLoc (I,J) = MAX( celsius2K+MIN_ATEMP, ATEMP(I,J,bi,bj) )

c     FREEZING TEMP. OF SEA WATER (K)
        tempFrz(I,J) = SEAICE_dTempFrz_dS *salt(I,J,kSurface,bi,bj)
     &     + SEAICE_tempFrz0 + celsius2K

C     Now determine fixed (relative to tsurf) forcing term in heat budget

        IF(HSNOW_ACTUAL(I,J).GT.0.0) THEN
C     Stefan-Boltzmann constant times emissivity
         D3(I,J)=SEAICE_snow_emiss*SEAICE_boltzmann
#ifdef EXF_LWDOWN_WITH_EMISSIVITY
C     This is now [(1-emiss)*lwdown - lwdown]
         lwdownLoc(I,J) = SEAICE_snow_emiss*lwdownLoc(I,J)
#else /* use the old hard wired inconsistent value  */
         lwdownLoc(I,J) = 0.97 _d 0*lwdownLoc(I,J)
#endif /* EXF_LWDOWN_WITH_EMISSIVITY */
        ELSE
C     Stefan-Boltzmann constant times emissivity
         D3(I,J)=SEAICE_ice_emiss*SEAICE_boltzmann
#ifdef EXF_LWDOWN_WITH_EMISSIVITY
C     This is now [(1-emiss)*lwdown - lwdown]
         lwdownLoc(I,J) = SEAICE_ice_emiss*lwdownLoc(I,J)
#else /* use the old hard wired inconsistent value  */
         lwdownLoc(I,J) = 0.97 _d 0*lwdownLoc(I,J)
#endif /* EXF_LWDOWN_WITH_EMISSIVITY */
        ENDIF
       ENDDO
      ENDDO

      DO J=1,sNy
       DO I=1,sNx

C     DECIDE ON ALBEDO
        IF ( iceOrNot(I,J) ) THEN

         IF ( YC(I,J,bi,bj) .LT. 0.0 _d 0 ) THEN
          IF (tsurfLoc(I,J) .GE. SurfMeltTemp) THEN
           ALB_ICE (I,J)   = SEAICE_wetIceAlb_south
           ALB_SNOW(I,J)   = SEAICE_wetSnowAlb_south
          ELSE                  ! no surface melting
           ALB_ICE (I,J)   = SEAICE_dryIceAlb_south
           ALB_SNOW(I,J)   = SEAICE_drySnowAlb_south
          ENDIF
         ELSE                   !/ Northern Hemisphere
          IF (tsurfLoc(I,J) .GE. SurfMeltTemp) THEN
           ALB_ICE (I,J)   = SEAICE_wetIceAlb
           ALB_SNOW(I,J)   = SEAICE_wetSnowAlb
          ELSE                  ! no surface melting
           ALB_ICE (I,J)   = SEAICE_dryIceAlb
           ALB_SNOW(I,J)   = SEAICE_drySnowAlb
          ENDIF
         ENDIF                  !/ Albedo for snow and ice

C     If actual snow thickness exceeds the cutoff thickness, use snow albedo
         IF (HSNOW_ACTUAL(I,J) .GT. HCUT) THEN
          ALB(I,J) = ALB_SNOW(I,J)
         ELSEIF ( HCUT.LE.ZERO ) THEN
          ALB(I,J) = ALB_ICE(I,J)
         ELSE
C     otherwise, use linear transition between ice and snow albedo
          ALB(I,J) = MIN( ALB_ICE(I,J) + HSNOW_ACTUAL(I,J)*recip_HCUT
     &                                 *(ALB_SNOW(I,J) -ALB_ICE(I,J))
     &                  , ALB_SNOW(I,J) )
         ENDIF

C     Determine the fraction of shortwave radiative flux remaining
C     at ocean interface after scattering through the snow and ice.
C     If snow is present, no radiation penetrates through snow+ice
         IF (HSNOW_ACTUAL(I,J) .GT. 0.0 _d 0) THEN
          penetSWFrac = 0.0 _d 0
         ELSE
          penetSWFrac = XIO*EXP(-1.5 _d 0 * HICE_ACTUAL(I,J))
         ENDIF
C     The shortwave radiative flux leaving ocean beneath ice (+=up).
         IcePenetSW(I,J) = -(1.0 _d 0 - ALB(I,J))
     &                    *penetSWFrac * SWDOWN(I,J,bi,bj)
C     The shortwave radiative flux convergence in the seaice.
         absorbedSW(I,J) =  (1.0 _d 0 - ALB(I,J))
     &        *(1.0 _d 0 - penetSWFrac)* SWDOWN(I,J,bi,bj)

C     The effective conductivity of the two-layer snow/ice system.
C     Set a minimum sea ice thickness of 5 cm to bound
C     the magnitude of conductive heat fluxes.
Cif   * now taken care of by SEAICE_hice_reg in seaice_growth
c        hice_tmp = max(HICE_ACTUAL(I,J),5. _d -2)
         effConduct(I,J) = XKI * XKS /
     &        (XKS * HICE_ACTUAL(I,J) + XKI * HSNOW_ACTUAL(I,J))

#ifdef SEAICE_DEBUG
         IF ( (I .EQ. SEAICE_debugPointI) .AND.
     &        (J .EQ. SEAICE_debugPointJ) ) THEN
          print '(A,i6)','-----------------------------------'
          print '(A,i6)','ibi merged initialization ', myIter
          print '(A,i6,4(1x,D24.15))',
     &         'ibi iter, TSL, TS     ',myIter,
     &         tsurfLoc(I,J), TSURFin(I,J)
          print '(A,i6,4(1x,D24.15))',
     &         'ibi iter, TMELT       ',myIter,TMELT
          print '(A,i6,4(1x,D24.15))',
     &         'ibi iter, HIA, EFKCON ',myIter,
     &         HICE_ACTUAL(I,J), effConduct(I,J)
          print '(A,i6,4(1x,D24.15))',
     &         'ibi iter, HSNOW       ',myIter,
     &         HSNOW_ACTUAL(I,J), ALB(I,J)
          print '(A,i6)','-----------------------------------'
          print '(A,i6)','ibi energy balance iterat ', myIter
         ENDIF
#endif /* SEAICE_DEBUG */

        ENDIF                   !/* iceOrNot */
       ENDDO                    !/* i */
      ENDDO                     !/* j */

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
      DO ITER=1,IMAX_TICE
#ifdef ALLOW_AUTODIFF_TAMC
       ikey = ITER
CADJ STORE tsurfLoc = loctape_solve4temp, key = ikey, byte = isbyte
#endif
       DO J=1,sNy
        DO I=1,sNx

C-    save tsurf from previous iter
         tsurfPrev(I,J) = tsurfLoc(I,J)
         IF ( iceOrNot(I,J) ) THEN

          t1 = tsurfLoc(I,J)
          t2 = t1*t1
          t3 = t2*t1
          t4 = t2*t2

C--   Calculate the specific humidity in the BL above the snow/ice
          IF ( useMaykutSatVapPoly ) THEN
C-    Use the Maykut polynomial
           qhice(I,J)=QS1*(C1*t4+C2*t3 +C3*t2+C4*t1+C5)
           dqh_dTs(I,J) = 0. _d 0
          ELSE
C-    Use exponential relation approx., more accurate at low temperatures
C     log 10 of the sat vap pressure
           mm_log10pi = -aa1 / t1 + aa2
C     The saturation vapor pressure (SVP) in the surface
C     boundary layer (BL) above the snow/ice.
c          mm_pi = TEN **(mm_log10pi)
C     The following form does the same, but is faster
           mm_pi = EXP(mm_log10pi*lnTEN)
           qhice(I,J) = bb1*mm_pi/( Ppascals -(1.0 _d 0 - bb1)*mm_pi )
C     A constant for SVP derivative w.r.t TICE
c          cc3t = TEN **(aa1 / t1)
C     The following form does the same, but is faster
           cc3t = EXP(aa1 / t1 * lnTEN)
C     d(qh)/d(TICE)
           dqh_dTs(I,J) = cc1*cc3t/((cc2-cc3t*Ppascals)**2 *t2)
          ENDIF

C     Calculate the flux terms based on the updated tsurfLoc
          F_c(I,J)    = effConduct(I,J)*(tempFrz(I,J)-t1)
          F_lh(I,J)   = D1I*UG(I,J)*(qhice(I,J)-AQH(I,J,bi,bj))
#ifdef SEAICE_CAP_SUBLIM
C     if the latent heat flux implied by tsurfLoc exceeds
C     F_lh_max, cap F_lh and decouple the flux magnitude from tIce (tsurfLoc)
          IF (F_lh(I,J) .GT. F_lh_max(I,J)) THEN
             F_lh(I,J)  = F_lh_max(I,J)
             dqh_dTs(I,J) = ZERO
          ENDIF
#endif /* SEAICE_CAP_SUBLIM */

          F_lwu(I,J) = t4 * D3(I,J)
          F_sens(I,J)= D1 * UG(I,J) * (t1 - atempLoc(I,J))
          F_ia(I,J) = -lwdownLoc(I,J) -absorbedSW(I,J) + F_lwu(I,J)
     &              +  F_sens(I,J) + F_lh(I,J)
C     d(F_ia)/d(Tsurf)
          dFia_dTs(I,J) = 4.0 _d 0*D3(I,J)*t3 + D1*UG(I,J)
     &                  + D1I*UG(I,J)*dqh_dTs(I,J)

#ifdef SEAICE_DEBUG
          IF ( (I .EQ. SEAICE_debugPointI) .AND.
     &         (J .EQ. SEAICE_debugPointJ) ) THEN
           print '(A,i6,4(1x,D24.15))',
     &          'ice-iter qhICE,       ', ITER,qhIce(I,J)
           print '(A,i6,4(1x,D24.15))',
     &          'ice-iter dFiDTs1 F_ia ', ITER,
     &          dFia_dTs(I,J)+effConduct(I,J), F_ia(I,J)-F_c(I,J)
          ENDIF
#endif /* SEAICE_DEBUG */

C-    Update tsurf as solution of : Fc = Fia + d/dT(Fia - Fc) *delta.tsurf
          tsurfLoc(I,J) = tsurfLoc(I,J)
     &    + ( F_c(I,J)-F_ia(I,J) ) / ( effConduct(I,J)+dFia_dTs(I,J) )

         ENDIF
        ENDDO
       ENDDO
       IF ( useMaykutSatVapPoly ) THEN
#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE tsurfLoc = loctape_solve4temp, key = ikey, byte = isbyte
#endif
        DO J=1,sNy
         DO I=1,sNx
          tsurfLoc(I,J) = MAX( celsius2K+MIN_TICE, tsurfLoc(I,J) )
C     If the search leads to tsurfLoc < 50 Kelvin, restart the search at
C     tsurfLoc = TMELT. Note that one solution to the energy balance problem is
C     an extremely low temperature - a temperature far below realistic values.
c         IF (tsurfLoc(I,J) .LT. 50.0 _d 0 ) tsurfLoc(I,J) = TMELT
C   Comments & code above not relevant anymore (from older version, when
C   trying Maykut-Polynomial & dqh_dTs > 0 ?): commented out
         ENDDO
        ENDDO
       ENDIF
#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE tsurfLoc = loctape_solve4temp, key = ikey, byte = isbyte
#endif
       DO J=1,sNy
        DO I=1,sNx
         tsurfLoc(I,J) = MIN( tsurfLoc(I,J), TMELT )

#ifdef SEAICE_DEBUG
         IF ( (I .EQ. SEAICE_debugPointI) .AND.
     &        (J .EQ. SEAICE_debugPointJ) ) THEN
          print '(A,i6,4(1x,D24.15))',
     &         'ice-iter tsurfLc,|dif|', ITER,
     &         tsurfLoc(I,J),
     &         LOG10(ABS(tsurfLoc(I,J) - tsurfPrev(I,J)))
         ENDIF
#endif /* SEAICE_DEBUG */

        ENDDO                   !/* i */
       ENDDO                    !/* j */
      ENDDO                     !/* Iterations */
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#ifdef SEAICE_MODIFY_GROWTH_ADJ
Cgf no additional dependency through solver, snow, etc.
      IF ( SEAICEadjMODE.GE.2 ) THEN
       DO J=1,sNy
        DO I=1,sNx
         IF ( iceOrNot(I,J) ) THEN
          CALL ZERO_ADJ_1D( 1, TSURFin(I,J), myThid)
          absorbedSW(I,J) = 0.3 _d 0 *SWDOWN(I,J,bi,bj)
          IcePenetSW(I,J)= 0. _d 0
         ENDIF
        ENDDO
       ENDDO
      ENDIF
      IF ( postSolvTempIter.EQ.2 .OR. SEAICEadjMODE.GE.2 ) THEN
       DO J=1,sNy
        DO I=1,sNx
         IF ( iceOrNot(I,J) ) THEN
          t1 = TSURFin(I,J)
#else /* SEAICE_MODIFY_GROWTH_ADJ */
      IF ( postSolvTempIter.EQ.2 ) THEN
       DO J=1,sNy
        DO I=1,sNx
         IF ( iceOrNot(I,J) ) THEN
C     Recalculate the fluxes based on the (possibly) adjusted TSURF
          t1 = tsurfLoc(I,J)
#endif /* SEAICE_MODIFY_GROWTH_ADJ */
          t2 = t1*t1
          t3 = t2*t1
          t4 = t2*t2

          IF ( useMaykutSatVapPoly ) THEN
           qhice(I,J)=QS1*(C1*t4+C2*t3 +C3*t2+C4*t1+C5)
          ELSE
C     log 10 of the sat vap pressure
           mm_log10pi = -aa1 / t1 + aa2
C     saturation vapor pressure
c          mm_pi = TEN **(mm_log10pi)
C     The following form does the same, but is faster
           mm_pi = EXP(mm_log10pi*lnTEN)
C     over ice specific humidity
           qhice(I,J) = bb1*mm_pi/( Ppascals -(1.0 _d 0 - bb1)*mm_pi )
          ENDIF
          F_c(I,J)  = effConduct(I,J) * (tempFrz(I,J) - t1)
          F_lh(I,J) = D1I * UG(I,J)*(qhice(I,J)-AQH(I,J,bi,bj))
#ifdef SEAICE_CAP_SUBLIM
          IF (F_lh(I,J) .GT. F_lh_max(I,J)) THEN
             F_lh(I,J)  = F_lh_max(I,J)
          ENDIF
#endif /* SEAICE_CAP_SUBLIM */
          F_lwu(I,J)  = t4 * D3(I,J)
          F_sens(I,J) = D1 * UG(I,J) * (t1 - atempLoc(I,J))
C     The flux between the ice/snow surface and the atmosphere.
          F_ia(I,J) = -lwdownLoc(I,J) -absorbedSW(I,J) + F_lwu(I,J)
     &              +  F_sens(I,J) + F_lh(I,J)

C IGF_SIR-b
          IF (-F_c(I,J) .LT. ZERO) THEN
C note that F_c is flipped sign in this rewrite for some reason
            F_io_net(I,J) = F_c(I,J)
            F_ia_net(I,J) = ZERO
          ELSE
            F_io_net(I,J) = ZERO
            F_ia_net(I,J) = F_ia(I,J)
          ENDIF
C IGF_SIR-e

         ENDIF
        ENDDO
       ENDDO
      ELSEIF ( postSolvTempIter.EQ.1 ) THEN
       DO J=1,sNy
        DO I=1,sNx
         IF ( iceOrNot(I,J) ) THEN
C     Update fluxes (consistent with the linearized formulation)
          delTsurf  = tsurfLoc(I,J)-tsurfPrev(I,J)
          F_c(I,J)  = effConduct(I,J)*(tempFrz(I,J)-tsurfLoc(I,J))
          F_ia(I,J) = F_ia(I,J) + dFia_dTs(I,J)*delTsurf
          F_lh(I,J) = F_lh(I,J)
     &              + D1I*UG(I,J)*dqh_dTs(I,J)*delTsurf

c        ELSEIF ( postSolvTempIter.EQ.0 ) THEN
C     Take fluxes from last iteration

         ENDIF
        ENDDO
       ENDDO
      ENDIF
      DO J=1,sNy
       DO I=1,sNx
        IF ( iceOrNot(I,J) ) THEN

C     Save updated tsurf and finalize the flux terms
         TSURFout(I,J) = tsurfLoc(I,J)
C     Fresh water flux (kg/m^2/s) from latent heat of sublimation.
C     F_lh is positive upward (sea ice looses heat) and FWsublim
C     is also positive upward (atmosphere gains freshwater)
         FWsublim(I,J) = F_lh(I,J)/lhSublim

#ifdef SEAICE_DEBUG
         IF ( (I .EQ. SEAICE_debugPointI) .AND.
     &        (J .EQ. SEAICE_debugPointJ) ) THEN
          print '(A)','----------------------------------------'
          print '(A,i6)','ibi complete ', myIter
          print '(A,4(1x,D24.15))',
     &         'ibi T(SURF, surfLoc,atmos) ',
     &         TSURFout(I,J), tsurfLoc(I,J),atempLoc(I,J)
          print '(A,4(1x,D24.15))',
     &         'ibi LWL                    ', lwdownLoc(I,J)
          print '(A,4(1x,D24.15))',
     &         'ibi QSW(Total, Penetrating)',
     &         SWDOWN(I,J,bi,bj), IcePenetSW(I,J)
          print '(A,4(1x,D24.15))',
     &         'ibi qh(ATM ICE)            ',
     &         AQH(I,J,bi,bj),qhice(I,J)
         print '(A,4(1x,D24.15))',
     &         'ibi F(lwd,swi,lwu)         ',
     &         -lwdownLoc(I,J), -absorbedSW(I,J), F_lwu(I,J)
         print '(A,4(1x,D24.15))',
     &         'ibi F(c,lh,sens)           ',
     &         F_c(I,J), F_lh(I,J), F_sens(I,J)
#ifdef SEAICE_CAP_SUBLIM
         IF (F_lh_max(I,J) .GT. ZERO) THEN
             print '(A,4(1x,D24.15))',
     &         'ibi F_lh_max,  F_lh/lhmax) ',
     &         F_lh_max(I,J), F_lh(I,J)/ F_lh_max(I,J)
         ELSE
             print '(A,4(1x,D24.15))',
     &         'ibi F_lh_max = ZERO! '
         ENDIF
         print '(A,4(1x,D24.15))',
     &         'ibi FWsub, FWsubm*dT/rhoI  ',
     &          FWsublim(I,J),
     &          FWsublim(I,J)*SEAICE_deltaTtherm/SEAICE_rhoICE
#endif /* SEAICE_CAP_SUBLIM */
          print '(A,4(1x,D24.15))',
     &         'ibi F_ia, F_ia_net, F_c    ',
     &         F_ia(I,J), F_ia_net(I,J), F_c(I,J)
          print '(A)','----------------------------------------'
         ENDIF
#endif /* SEAICE_DEBUG */

        ENDIF                   !/* iceOrNot */
       ENDDO                    !/* i */
      ENDDO                     !/* j */

#endif /* ALLOW_ATM_TEMP && ALLOW_DOWNWARD_RADIATION */
      RETURN
      END

#include "STREAMICE_OPTIONS.h"
c#ifdef ALLOW_AUTODIFF
c# include "AUTODIFF_OPTIONS.h"
c#endif
#ifdef ALLOW_COST
# include "COST_OPTIONS.h"
#endif

      subroutine streamice_cost_surf_accum ( myIter, myThid )
C     *==========================================================*
C     | subroutine streamice_cost_surf_accum                     |
C     | o this routine calculates the surface misfit contri-     |
C     |   bution to the per-timestep STREAMICE cost              |
C     *==========================================================*
C     |                                                          |
C     | Notes                                                    |
C     | =====                                                    |
C     *==========================================================*
      IMPLICIT NONE

C     == Global variables ===
#include "SIZE.h"
#include "GRID.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "DYNVARS.h"
#ifdef ALLOW_STREAMICE
# include "STREAMICE.h"
#endif

#ifdef ALLOW_COST
# include "cost.h"
#endif
c#ifdef ALLOW_AUTODIFF_TAMC
c# include "tamc.h"
c#endif

C     == Routine arguments ==
C     myThid - Thread number for this instance of the routine.
      integer myIter, myThid

#ifdef ALLOW_STREAMICE_TC_COST
C     == Local variables
      _RL HAF
      integer i, j, k, bi, bj
      integer ig, jg
      integer itlo,ithi
      integer jtlo,jthi
      integer il
      CHARACTER*(10) myIterStr
      INTEGER  ILNBLNK
      EXTERNAL ILNBLNK
      CHARACTER*(MAX_LEN_FNAM) surffilename, errsurffilename
      _RL surfobs (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL errsurfobs (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL rhoi, rhow, r, i_r, i_numcells, surf_err, h, hf
      WRITE(myIterStr,'(I10.10)') myIter
      surffilename=STREAMICEsurfOptimTCBasename(1:
     & ILNBLNK(STREAMICEsurfOptimTCBasename))//myIterStr//".bin"
      errsurffilename=STREAMICEsurfOptimTCBasename(1:
     & ILNBLNK(STREAMICEsurfOptimTCBasename))//myIterStr//"err.bin"
      CALL READ_FLD_XY_RL( surffilename, ' ', surfobs,
     &  0, myThid )
      CALL READ_FLD_XY_RL( errsurffilename, ' ', errsurfobs,
     &  0, myThid )

c#ifdef ALLOW_AUTODIFF_TAMC
cCADJ STORE surf_el_streamice  = comlev1, key = ikey_dynamics,
cCADJ &     kind = isbyte
cCADJ STORE H_streamice_prev  = comlev1, key = ikey_dynamics,
cCADJ &     kind = isbyte
cCADJ STORE H_streamice  = comlev1, key = ikey_dynamics,
cCADJ &     kind = isbyte
c#endif

      rhoi = streamice_density
      rhow = streamice_density_ocean_avg
      r=rhoi/rhow
      i_r = 1./r
      i_numcells = 1.0/(Nx*Ny)

C--   Calculate cost function on tile of this instance
      DO bj=myByLo(myThid),myByHi(myThid)
        DO bi=myBxLo(myThid),myBxHi(myThid)
          do j=1,sNy
            do i=1,sNx
             if (SURFOBS(i,j,bi,bj).ge.-999990. .and.
     &           streamice_hmask(i,j,bi,bj).eq.1.0) THEN

             h = H_streamice(i,j,bi,bj)
             hf = -1.0 * i_r * R_low_si (i,j,bi,bj)

              if (((h-hf) .gt. 5.) .OR.
     &             STREAMICE_shelf_dhdt_ctrl) then

               surf_err = streamice_wgt_surf * i_numcells *
     &         (surf_el_streamice(i,j,bi,bj) -
     &          surfobs(i,j,bi,bj))**2 /
     &          (.001 + errSurfObs(i,j,bi,bj)**2)

               cost_func1_streamice (bi,bj) =
     &         cost_func1_streamice (bi,bj) +
     &              surf_err
               cost_surf_streamice (bi,bj) =
     &         cost_surf_streamice (bi,bj) +
     &              surf_err

              endif

             endif

            end do
          end do
        end do
      end do

#endif

      RETURN
      END

#include "OBCS_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: OBCS_ADD_TIDES

C     !INTERFACE:
      SUBROUTINE OBCS_ADD_TIDES( myTime, myIter, myThid )

C     !DESCRIPTION:
C     *==========================================================*
C     | SUBROUTINE OBCS_ADD_TIDES
C     | o Add barotropic tidal velocity to OB value
C     *==========================================================*

C     !USES:
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "OBCS_PARAMS.h"
#include "OBCS_GRID.h"
#include "OBCS_FIELDS.h"

C     !INPUT/OUTPUT PARAMETERS:
      _RL myTime
      INTEGER myIter
      INTEGER myThid
CEOP

#ifdef ALLOW_OBCS
#ifdef ALLOW_OBCS_TIDES
C     !FUNCTIONS:

C     !LOCAL VARIABLES:
C     bi, bj       :: tile indices
C     i,j,k        :: loop indices
C     iB, jB       :: local index of open boundary
C     msgBuf       :: Informational/error message buffer
      INTEGER bi, bj
      INTEGER i, j, k, iB, jB
      INTEGER td
      _RL  timePhase, timeCos, timeSin
      _RL  uTide, vTide

#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_ENTER('OBCS_ADD_TIDES',myThid)
#endif

C--   Add tidal currents:
      DO td=1,OBCS_nTidalComp
       IF ( OBCS_tidalPeriod(td) .NE. zeroRL ) THEN

        timePhase = myTime * twoRL * PI / OBCS_tidalPeriod(td)
        timeCos = COS( timePhase )
        timeSin = SIN( timePhase )
        DO bj=myByLo(myThid),myByHi(myThid)
         DO bi=myBxLo(myThid),myBxHi(myThid)

#ifdef ALLOW_OBCS_EAST
          IF ( tileHasOBE(bi,bj) ) THEN
           DO j=1-OLy,sNy+OLy
            iB = OB_Ie(j,bi,bj)
            IF ( iB.NE.OB_indexNone ) THEN
             uTide = OBE_uTideCs(j,td,bi,bj) * timeCos
     &             + OBE_uTideSn(j,td,bi,bj) * timeSin
             vTide = OBE_vTideCs(j,td,bi,bj) * timeCos
     &             + OBE_vTideSn(j,td,bi,bj) * timeSin
             DO k=1,Nr
              OBEu(j,k,bi,bj) = OBEu(j,k,bi,bj)
     &                        + uTide * maskW(iB,j,k,bi,bj)
              OBEv(j,k,bi,bj) = OBEv(j,k,bi,bj)
     &                        + vTide * maskS(iB,j,k,bi,bj)
             ENDDO
            ENDIF
           ENDDO
          ENDIF
#endif /* ALLOW_OBCS_EAST */

#ifdef ALLOW_OBCS_WEST
          IF ( tileHasOBW(bi,bj) ) THEN
           DO j=1-OLy,sNy+OLy
            iB = OB_Iw(j,bi,bj)
            IF ( iB.NE.OB_indexNone ) THEN
             uTide = OBW_uTideCs(j,td,bi,bj) * timeCos
     &             + OBW_uTideSn(j,td,bi,bj) * timeSin
             vTide = OBW_vTideCs(j,td,bi,bj) * timeCos
     &             + OBW_vTideSn(j,td,bi,bj) * timeSin
             DO k=1,Nr
              OBWu(j,k,bi,bj) = OBWu(j,k,bi,bj)
     &                        + uTide * maskW(1+iB,j,k,bi,bj)
              OBWv(j,k,bi,bj) = OBWv(j,k,bi,bj)
     &                        + vTide * maskS(iB,j,k,bi,bj)
             ENDDO
            ENDIF
           ENDDO
          ENDIF
#endif /* ALLOW_OBCS_WEST */

#ifdef ALLOW_OBCS_NORTH
          IF ( tileHasOBN(bi,bj) ) THEN
           DO i=1-OLx,sNx+OLx
            jB = OB_Jn(i,bi,bj)
            IF ( jB.NE.OB_indexNone ) THEN
             uTide = OBN_uTideCs(i,td,bi,bj) * timeCos
     &             + OBN_uTideSn(i,td,bi,bj) * timeSin
             vTide = OBN_vTideCs(i,td,bi,bj) * timeCos
     &             + OBN_vTideSn(i,td,bi,bj) * timeSin
             DO k=1,Nr
              OBNu(i,k,bi,bj) = OBNu(i,k,bi,bj)
     &                        + uTide * maskW(i,jB,k,bi,bj)
              OBNv(i,k,bi,bj) = OBNv(i,k,bi,bj)
     &                        + vTide * maskS(i,jB,k,bi,bj)
             ENDDO
            ENDIF
           ENDDO
          ENDIF
#endif /* ALLOW_OBCS_NORTH */

#ifdef ALLOW_OBCS_SOUTH
          IF ( tileHasOBS(bi,bj) ) THEN
           DO i=1-OLx,sNx+OLx
            jB = OB_Js(i,bi,bj)
            IF ( jB.NE.OB_indexNone ) THEN
             uTide = OBS_uTideCs(i,td,bi,bj) * timeCos
     &             + OBS_uTideSn(i,td,bi,bj) * timeSin
             vTide = OBS_vTideCs(i,td,bi,bj) * timeCos
     &             + OBS_vTideSn(i,td,bi,bj) * timeSin
             DO k=1,Nr
              OBSu(i,k,bi,bj) = OBSu(i,k,bi,bj)
     &                        + uTide * maskW(i,jB,k,bi,bj)
              OBSv(i,k,bi,bj) = OBSv(i,k,bi,bj)
     &                        + vTide * maskS(i,1+jB,k,bi,bj)
             ENDDO
            ENDIF
           ENDDO
          ENDIF
#endif /* ALLOW_OBCS_SOUTH */

C    end bi,bj loops
         ENDDO
        ENDDO

C    end if (tidalPeriod <> 0) and end loop on td (= tidal comp. index)
       ENDIF
      ENDDO

#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_LEAVE('OBCS_ADD_TIDES',myThid)
#endif

#endif /* ALLOW_OBCS_TIDES */
#endif /* ALLOW_OBCS */

      RETURN
      END

#include "MOM_FLUXFORM_OPTIONS.h"

CBOP
C     !ROUTINE: MOM_CALC_RTRANS
C     !INTERFACE:
      SUBROUTINE MOM_CALC_RTRANS(
     I                          k, bi, bj,
     O                          rTransU, rTransV,
     I                          myTime, myIter, myThid)
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE MOM_CALC_RTRANS
C     | o Calculate vertical transports at interface k
C     |   above U & V points (West & South face)
C     *==========================================================*
C     | r coordinate (z or p):
C     |  is simply half of the 2 vert. Transp at Center location
C     | r* coordinate: less simple since
C     |  d.eta/dt / H has to be evaluated locally at U & V points
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     == GLobal variables ==
#include "SIZE.h"
#include "DYNVARS.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "SURFACE.h"
#include "MOM_FLUXFORM.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     k       :: vertical level
C     bi,bj   :: tile indices
C     rTransU :: vertical transport (above U point)
C     rTransV :: vertical transport (above V point)
C     myTime  :: current time
C     myIter  :: current iteration number
C     myThid  :: thread number

      INTEGER k, bi, bj, myIter, myThid
      _RL myTime
      _RL rTransU(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL rTransV(1-OLx:sNx+OLx,1-OLy:sNy+OLy)

C     !LOCAL VARIABLES:
#ifdef NONLIN_FRSURF
C     == Local variables in common block ==
C     dWtransC :: vertical transp. difference between r & r* coordinates
C     dWtransU :: same but above u.point location (West  face)
C     dWtransV :: same but above v.point location (South face)
cph need this in a header for the adjoint
cph      COMMON /LOCAL_MOM_CALC_RTRANS/
cph     &       dWtransC, dWtransU, dWtransV
cph      _RL dWtransC(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
cph      _RL dWtransU(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
cph      _RL dWtransV(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
#endif /* NONLIN_FRSURF */
C     == Local variables ==
C     I, J :: Loop counters
      INTEGER i,j
CEOP

#ifdef NONLIN_FRSURF
      IF ( k.EQ.Nr+1 .AND.
     &     useRealFreshWaterFlux .AND. usingPCoords ) THEN
C note: deep-model not implemented for P-coordinate + realFreshWaterFlux ;
C       anelastic: always assumes that rhoFacF(1) = 1
        DO j=1-OLy+1,sNy+OLy
         DO i=1-OLx+1,sNx+OLx
          rTransU(i,j) = mass2rUnit*
     &      0.5 _d 0*( PmEpR( i ,j,bi,bj)*rA( i ,j,bi,bj)
     &                +PmEpR(i-1,j,bi,bj)*rA(i-1,j,bi,bj) )
          rTransV(i,j) = mass2rUnit*
     &      0.5 _d 0*( PmEpR(i, j ,bi,bj)*rA(i, j ,bi,bj)
     &                +PmEpR(i,j-1,bi,bj)*rA(i,j-1,bi,bj) )
         ENDDO
        ENDDO
      ELSEIF ( k.GT.Nr ) THEN
#else /* NONLIN_FRSURF */
       IF ( k.GT.Nr ) THEN
#endif /* NONLIN_FRSURF */
        DO j=1-OLy+1,sNy+OLy
         DO i=1-OLx+1,sNx+OLx
          rTransU(i,j) = 0.
          rTransV(i,j) = 0.
         ENDDO
        ENDDO
      ELSE
C-    Calculate vertical transports above U & V points (West & South face):
        DO j=1-OLy+1,sNy+OLy
         DO i=1-OLx+1,sNx+OLx
          rTransU(i,j) =
     &         0.5 _d 0*( wVel(i-1,j,k,bi,bj)*rA(i-1,j,bi,bj)
     &                   +wVel( i ,j,k,bi,bj)*rA( i ,j,bi,bj)
     &                  )*deepFac2F(k)*rhoFacF(k)
          rTransV(i,j) =
     &         0.5 _d 0*( wVel(i,j-1,k,bi,bj)*rA(i,j-1,bi,bj)
     &                   +wVel(i, j ,k,bi,bj)*rA(i, j ,bi,bj)
     &                  )*deepFac2F(k)*rhoFacF(k)
         ENDDO
        ENDDO
      ENDIF

#ifdef NONLIN_FRSURF
C---  Modify rTransU & rTransV when using r* coordinate:
C     note: not implemented neither for anelastic nor deep-model.
      IF ( select_rStar.NE.0 ) THEN
# ifndef DISABLE_RSTAR_CODE

       IF ( k.EQ.1) THEN
C-    Initialise dWtrans :
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          dWtransC(i,j,bi,bj) = rStarDhCDt(i,j,bi,bj)
     &         *(Ro_surf(i,j,bi,bj)-R_low(i,j,bi,bj))
     &         *rA(i,j,bi,bj)
         ENDDO
        ENDDO
        DO j=1-OLy+1,sNy+OLy
         DO i=1-OLx+1,sNx+OLx
          dWtransU(i,j,bi,bj) =
     &          0.5 _d 0*(dWtransC(i-1,j,bi,bj)+dWtransC(i,j,bi,bj))
          dWtransV(i,j,bi,bj) =
     &          0.5 _d 0*(dWtransC(i,j-1,bi,bj)+dWtransC(i,j,bi,bj))
         ENDDO
        ENDDO

       ELSEIF (k.LE.Nr) THEN
C-    Update dWtrans from previous value (interface k-1):
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          dWtransC(i,j,bi,bj) = dWtransC(i,j,bi,bj)
     &     - rStarDhCDt(i,j,bi,bj)*drF(k-1)*h0FacC(i,j,k-1,bi,bj)
     &                            *rA(i,j,bi,bj)
         ENDDO
        ENDDO
        DO j=1-OLy+1,sNy+OLy
         DO i=1-OLx+1,sNx+OLx
          dWtransU(i,j,bi,bj) = dWtransU(i,j,bi,bj)
     &     - rStarDhWDt(i,j,bi,bj)*drF(k-1)*h0FacW(i,j,k-1,bi,bj)
     &                            *rAw(i,j,bi,bj)
          dWtransV(i,j,bi,bj) = dWtransV(i,j,bi,bj)
     &     - rStarDhSDt(i,j,bi,bj)*drF(k-1)*h0FacS(i,j,k-1,bi,bj)
     &                            *rAs(i,j,bi,bj)
         ENDDO
        ENDDO
C-    Modify rTransU & rTransV :
        DO j=1-OLy+1,sNy+OLy
         DO i=1-OLx+1,sNx+OLx
          rTransU(i,j) = rTransU(i,j)-dWtransU(i,j,bi,bj)
     &       + (dWtransC(i-1,j,bi,bj)+dWtransC(i,j,bi,bj))*0.5 _d 0
          rTransV(i,j) = rTransV(i,j)-dWtransV(i,j,bi,bj)
     &       + (dWtransC(i,j-1,bi,bj)+dWtransC(i,j,bi,bj))*0.5 _d 0
         ENDDO
        ENDDO

       ENDIF

# endif /* DISABLE_RSTAR_CODE */
      ENDIF

#endif /* NONLIN_FRSURF */

      RETURN
      END

#include "PROFILES_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C !ROUTINE: PROFILES_INIT_VARIA

C !INTERFACE:
      SUBROUTINE PROFILES_INIT_VARIA( myThid )

C     !DESCRIPTION:
C     Initialise the variable cost function part.
C     Started: Christian Eckert eckert@mit.edu 30-Jun-1999
C     Changed: Christian Eckert eckert@mit.edu 18-Apr-2000
C              - Restructured the code in order to create a package
C                for the MITgcmUV.
C              heimbach@mit.edu 05-Nov-2003
C              - Now ecco part of cost

C     !USES:
      IMPLICIT NONE
C     == Global variables ===
#include "EEPARAMS.h"
#include "SIZE.h"
#include "GRID.h"

#ifdef ALLOW_PROFILES
# include "PROFILES_SIZE.h"
# include "profiles.h"
#endif

#ifdef ALLOW_GRDCHK
# include "netcdf.inc"
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     myThid: my thread ID number
      INTEGER myThid
CEOP

C     !LOCAL VARIABLES:
      INTEGER bi,bj
      INTEGER num_file,num_var
#ifdef ALLOW_GRDCHK
      INTEGER err
#endif /* ALLOW_GRDCHK */

C Initialize tiled cost function contributions.
      DO bj = myByLo(myThid), myByHi(myThid)
        DO bi = myBxLo(myThid), myBxHi(myThid)
          DO num_file = 1, NFILESPROFMAX
            DO num_var = 1, NVARMAX
              objf_profiles(num_file,num_var,bi,bj) = 0. _d 0
              num_profiles(num_file,num_var,bi,bj)  = 0. _d 0
              profiles_dummy(num_file,num_var,bi,bj) = 0. _d 0
            ENDDO !DO num_var
          ENDDO !DO num_file

          DO num_var = 1,NVARMAX
            objf_profiles_mean(num_var,bi,bj) = 0. _d 0
            num_profiles_mean(num_var,bi,bj) = 0. _d 0
          ENDDO !DO num_var

#ifdef ALLOW_GRDCHK
          IF (profilesDoNcOutput) THEN
            DO num_file = 1, NFILESPROFMAX
              IF (ProfNo(num_file,bi,bj).GT.0) THEN
C Write data from buffer to .nc file
                err = NF_SYNC( fidforward(num_file,bi,bj) )
                CALL PROFILES_NF_ERROR(
     &               'INIT_VARIA: NF_SYNC fidforward',
     &               err,bi,bj,myThid )

# ifdef ALLOW_TANGENTLINEAR_RUN
                IF (TANGENT_SIMULATION) THEN
                  err = NF_SYNC( fidtangent(num_file,bi,bj) )
                  CALL PROFILES_NF_ERROR(
     &                 'INIT_VARIA: NF_SYNC fidtangent',
     &                 err,bi,bj,myThid )
                ENDIF
# endif /* ALLOW_TANGENTLINEAR_RUN */

              ENDIF !IF (ProfNo
            ENDDO !DO num_file
          ENDIF !IF (profilesDoNcOutput)
#endif /* ALLOW_GRDCHK */

        ENDDO !DO bi
      ENDDO !DO bj

      _BARRIER

      RETURN
      END

#include "GCHEM_OPTIONS.h"

CBOP
C !ROUTINE: GCHEM_CALC_TENDENCY

C !INTERFACE: ==========================================================
      SUBROUTINE GCHEM_CALC_TENDENCY(
     I     myTime, myIter, myThid )

C !DESCRIPTION:
C In the case of GCHEM_SEPARATE_FORCING not defined,
C this subroutine computes the tracer tendencies due to a
C bio-geogchemistry or ecosystem model and stores them on an array
C gchemTendency, that will be incorporated into regular timestepping in
C in ptracers_intergrate.F
C The current example uses the CFC package, but his is meant to
C be replaced by anything that the user provides.

C !USES: ===============================================================
      IMPLICIT NONE
#include "SIZE.h"
#include "GRID.h"
#include "DYNVARS.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "PTRACERS_SIZE.h"
#include "PTRACERS_PARAMS.h"
#include "PTRACERS_FIELDS.h"
#include "GCHEM.h"
#ifdef ALLOW_CFC
# include "CFC_SIZE.h"
#endif
#ifdef ALLOW_SPOIL
# include "SPOIL_SIZE.h"
#endif
#include "GCHEM_SIZE.h"
#include "GCHEM_FIELDS.h"

C !INPUT PARAMETERS: ===================================================
C  myTime               :: current time
C  myIter               :: current timestep
C  myThid               :: thread number
      _RL myTime
      INTEGER myIter, myThid
CEOP

#ifdef GCHEM_ADD2TR_TENDENCY
C !LOCAL VARIABLES: ====================================================
C  i,j                  :: loop indices
C  iTr                  :: ptracer number
C  jTr                  :: corresponding tracer tendency number
C  bi,bj                :: tile indices
C  k                    :: vertical level
      INTEGER i,j
      INTEGER iTr, jTr
      INTEGER bi,bj,iMin,iMax,jMin,jMax,k

C     gchemTendency is re-initialized here
      DO jTr = 1, GCHEM_tendTr_num
       DO bj=myByLo(myThid),myByHi(myThid)
        DO bi=myBxLo(myThid),myBxHi(myThid)
         DO k = 1, Nr
          DO j = 1-OLy, sNy+OLy
           DO i = 1-OLx, sNx+OLx
            gchemTendency(i,j,k,bi,bj,jTr) = 0. _d 0
           ENDDO
          ENDDO
         ENDDO
        ENDDO
       ENDDO
      ENDDO

#ifdef ALLOW_AUTODIFF
      IF ( useGCHEM ) THEN
#endif
C     Here is the place for code to compute bio-geochemical
C     tendency terms (sometimes referred to as source-minus-sink
C     terms). The tendencies are stored on gchemTendency, as show
C     in the CFC-example.
C
C     loop over tiles
      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
C     define horizontal loop ranges
        iMin = 1
        iMax = sNx
        jMin = 1
        jMax = sNy
c       DO jTr = 1, GCHEM_tendTr_num
c        iTr = jTr + gchem_sepFTr_num
c        DO k = 1, Nr
c         DO j = 1-OLy, sNy+OLy
c          DO i = 1-OLx, sNx+OLx
c           gchemTendency(i,j,k,bi,bj,jTr) = your specific model
c          ENDDO
c         ENDDO
c        ENDDO
c       ENDDO

C------------------------
C chemical forcing      |
C------------------------
#ifdef ALLOW_SPOIL
        IF ( useSPOIL ) THEN
          CALL SPOIL_CALC_TENDENCY( bi, bj,
     I                              myTime, myIter, myThid )
        ENDIF
#endif /* ALLOW_SPOIL */

#ifdef ALLOW_CFC
        IF ( useCFC ) THEN
         iTr = CFC_pTr_i1
         jTr = iTr - gchem_sepFTr_num
         CALL CFC11_FORCING(
     I                       pTracer     (1-OLx,1-OLy,1,bi,bj,iTr),
     U                       gchemTendency(1-OLx,1-OLy,1,bi,bj,jTr),
     I                       bi, bj, iMin, iMax, jMin, jMax,
     I                       myTime, myIter, myThid )
         iTr = CFC_pTr_i1 + 1
         jTr = iTr - gchem_sepFTr_num
         CALL CFC12_FORCING(
     I                       pTracer     (1-OLx,1-OLy,1,bi,bj,iTr),
     U                       gchemTendency(1-OLx,1-OLy,1,bi,bj,jTr),
     I                       bi, bj, iMin, iMax, jMin, jMax,
     I                       myTime, myIter, myThid )
        ENDIF
#endif /* ALLOW_CFC */

C     end of tile-loops
       ENDDO
      ENDDO
#ifdef ALLOW_AUTODIFF
      ENDIF
#endif
#endif /* GCHEM_ADD2TR_TENDENCY */

      RETURN
      END

#include "OFFLINE_OPTIONS.h"

C !INTERFACE: ==========================================================
      SUBROUTINE OFFLINE_INIT_VARIA( myThid )

C !DESCRIPTION:
C calls subroutines that initializes variables for offline code

C !USES: ===============================================================
      IMPLICIT NONE
#include "SIZE.h"
#include "GRID.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "OFFLINE.h"

C !INPUT PARAMETERS: ===================================================
C  myThid               :: thread number
      INTEGER myThid
CEOP

C     !LOCAL VARIABLES:
C     i,j,k,bi,bj  :: loop indices
      INTEGER i,j,k,bi,bj

      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
         offlineLdRec(bi,bj) = 0
         offline_Wght(1,bi,bj) = 0. _d 0
         offline_Wght(2,bi,bj) = 0. _d 0
         DO k=1,Nr
          DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
             uvel0(i,j,k,bi,bj) = 0. _d 0
             uvel1(i,j,k,bi,bj) = 0. _d 0
             vvel0(i,j,k,bi,bj) = 0. _d 0
             vvel1(i,j,k,bi,bj) = 0. _d 0
             wvel0(i,j,k,bi,bj) = 0. _d 0
             wvel1(i,j,k,bi,bj) = 0. _d 0
             tave0(i,j,k,bi,bj) = 0. _d 0
             tave1(i,j,k,bi,bj) = 0. _d 0
             save0(i,j,k,bi,bj) = 0. _d 0
             save1(i,j,k,bi,bj) = 0. _d 0
             gmkx0(i,j,k,bi,bj) = 0. _d 0
             gmkx1(i,j,k,bi,bj) = 0. _d 0
             gmky0(i,j,k,bi,bj) = 0. _d 0
             gmky1(i,j,k,bi,bj) = 0. _d 0
             gmkz0(i,j,k,bi,bj) = 0. _d 0
             gmkz1(i,j,k,bi,bj) = 0. _d 0
             conv0(i,j,k,bi,bj) = 0. _d 0
             conv1(i,j,k,bi,bj) = 0. _d 0
             kdfs0(i,j,k,bi,bj) = 0. _d 0
             kdfs1(i,j,k,bi,bj) = 0. _d 0
             kght0(i,j,k,bi,bj) = 0. _d 0
             kght1(i,j,k,bi,bj) = 0. _d 0
           ENDDO
          ENDDO
         ENDDO
         DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
c            hflx0(i,j,bi,bj) = 0. _d 0
c            hflx1(i,j,bi,bj) = 0. _d 0
             sflx0(i,j,bi,bj) = 0. _d 0
             sflx1(i,j,bi,bj) = 0. _d 0
c            icem0(i,j,bi,bj) = 0. _d 0
c            icem1(i,j,bi,bj) = 0. _d 0
           ENDDO
         ENDDO
C--   end bi,bj loops.
       ENDDO
      ENDDO

C     Load offline fields from files (for beginning of first time-step)
      CALL OFFLINE_FIELDS_LOAD( startTime, nIter0, myThid )

      RETURN
      END

#include "COST_OPTIONS.h"

      subroutine cost_state_final( myThid )
C     /==========================================================\
C     | subroutine cost_state_final                              |
C     | o This routine assigns final T,S to cost function        |
C     \==========================================================/
       implicit none

C     == Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "DYNVARS.h"

#include "cost.h"

C     ======== Routine arguments ======================
C     myThid - Thread number for this instance of the routine.
      integer myThid

#ifdef ALLOW_COST_STATE_FINAL
C     ========= Local variables =========================
      integer i, j, k
      integer bi, bj

      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        DO j=1,sNy
         DO i=1,sNx
          DO k=1,nr
           objf_state_final(i,j,bi,bj,0*Nr+k) = theta(i,j,k,bi,bj)
           objf_state_final(i,j,bi,bj,1*Nr+k) = salt(i,j,k,bi,bj)
           objf_state_final(i,j,bi,bj,2*Nr+k) = uvel(i,j,k,bi,bj)
           objf_state_final(i,j,bi,bj,3*Nr+k) = vvel(i,j,k,bi,bj)
          END DO
          objf_state_final(i,j,bi,bj,4*Nr+1) = etan(i,j,bi,bj)
         END DO
        END DO
       END DO
      END DO

cph      fc = objf_state_final(45,4,1,1,1)
cph      _GLOBAL_SUM_RL( fc , myThid )
cph      print *, 'fc for admtlm test at 83,33 : ', fc

#endif

      end

#include "COST_OPTIONS.h"

      subroutine cost_test( myThid )
C     *==========================================================*
C     | subroutine cost_test
C     | o this routine computes the cost function for the tiles
C     |   of this processor
C     *==========================================================*
C     | Notes
C     *==========================================================*
      IMPLICIT NONE

C     == Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "DYNVARS.h"
#include "GRID.h"

#include "cost.h"

C     == Routine arguments ==
C     myThid - Thread number for this instance of the routine.
      integer myThid

#ifdef ALLOW_COST_TEST
C     == Local variables
      integer bi, bj
      integer i, j, k
      integer ig, jg
      integer itlo,ithi
      integer jtlo,jthi
      _RL vol_trans
C--   index values at which the transport is to be calculated
      INTEGER iysecmin, iysecmax, ixsec
      PARAMETER (ixsec = 4, iysecmin = 3, iysecmax = 3)

      jtlo = mybylo(mythid)
      jthi = mybyhi(mythid)
      itlo = mybxlo(mythid)
      ithi = mybxhi(mythid)

      DO bj=jtlo,jthi
       DO bi=itlo,ithi
        vol_trans = 0.
        DO J=1,sNy
         jg = myYGlobalLo-1+(bj-1)*sNy+J
         IF ( jg .ge. iysecmin .and. jg .le. iysecmax ) THEN
          DO I=1,sNx
           ig = myXGlobalLo-1+(bi-1)*sNx+I
           IF ( ig .eq. ixsec ) THEN
            DO K=1,Nr
             IF ( maskW(I,J,K,BI,BJ) .NE. 0. ) THEN
              vol_trans = vol_trans
     &             + uVel(I,J,K,BI,BJ)
     &             *_hFacW(I,J,K,BI,BJ)
     &             *dyG(I,J,BI,BJ)*drF(K)
             ENDIF
            ENDDO
           ENDIF
          ENDDO
         ENDIF
        ENDDO
        objf_test(bi,bj) = vol_trans*1.0e-06
       END DO
      END DO
CML      objf_test(1,1) = vVel(3,3,1,1,1)* _hFacS(3,3,1,1,1)
Cml      iLocOut =  6
Cml      jLocOut =  35
Cml      kLocOut =  1
Cml
Cmlce    some reference temperature
Cml      thetaRef = 24.0 _d 0
Cml
CmlC--   Calculate cost function on tile of this instance
Cml      do bj = jtlo,jthi
Cml        do bi = itlo,ithi
Cml          do j=1,sNy
Cml          jg = myYGlobalLo-1+(bj-1)*sNy+j
Cml            do i=1,sNx
Cml            ig = myXGlobalLo-1+(bi-1)*sNx+i
Cml
Cml            if ((ig .eq. iLocOut) .and. (jg .eq. jLocOut)) then
Cml               write(*,'(a,3(x,i4),a,4(x,i4))')
Cml     &              'COST    ',ig,jg,kLocOut,' TILE ',i,j,bi,bj
Cml               objf_test(bi,bj) = theta(i,j,kLocOut,bi,bj)
Cml            endif
Cml
Cml            enddo
Cml          enddo
Cml        enddo
Cml      enddo

#endif /* ALLOW_COST_TEST */

      RETURN
      END

#include "LAYERS_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      SUBROUTINE LAYERS_CHECK( myThid )

C     Check dependances with other packages

      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "EOS.h"
#include "LAYERS_SIZE.h"
#include "LAYERS_P2SHARE.h"
#include "LAYERS.h"

C     myThid   :: my Thread Id number
      INTEGER myThid

C     LOCAL VARIABLES:
C     msgBuf   :: Informational/error message buffer
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      CHARACTER*(40) tmpName
      CHARACTER*(1) sfx
      INTEGER iLa, k, errCount
      _RL tmpVar

#ifdef ALLOW_LAYERS
      _BEGIN_MASTER(myThid)

       WRITE(msgBuf,'(A)') 'LAYERS_CHECK: #define LAYERS'
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                     SQUEEZE_RIGHT, myThid )

C--   Print out some key parameters :
       CALL WRITE_0D_I( NZZ, INDEX_NONE, 'NZZ =',
     &  ' /* number of levels in the fine vertical grid */')
       CALL WRITE_1D_RL( dZZf, NZZ, INDEX_K, 'dZZf =',
     &  ' /* fine vertical grid spacing for isopycnal interp */')

      DO iLa=1,layers_maxNum
       IF ( layers_num(iLa).NE.0 ) THEN
        sfx = '#'
        IF ( iLa.LE.9 ) WRITE(sfx,'(I1)') iLa

        WRITE(tmpName,'(3A)') 'layers_num(', sfx, ') ='
        CALL WRITE_0D_I( layers_num(iLa), INDEX_NONE, tmpName(1:15),
     &   ' /* averaging field: 1= theta, 2= salt, 3= prho */' )
        WRITE(tmpName,'(3A)') 'layers_name(', sfx, ') ='
        CALL WRITE_0D_C( layers_name(iLa),-1,INDEX_NONE, tmpName(1:16),
     &   ' /* averaging field: TH = theta, SLT= salt, RHO= prho */' )
        WRITE(tmpName,'(3A)') 'layers_bolus(', sfx, ') ='
        IF ( useGMRedi )
     &  CALL WRITE_0D_L ( layers_bolus(iLa), INDEX_NONE, tmpName(1:17),
     &   ' /* include potential GM bolus velocity */')
        WRITE(tmpName,'(3A)') 'layers_krho(', sfx, ') ='
        IF ( layers_num(iLa).EQ.3 )
     &  CALL WRITE_0D_I( layers_krho(iLa), INDEX_NONE, tmpName(1:16),
     &   ' /* model level to reference potential density to */' )
        WRITE(tmpName,'(3A)') 'layers_bounds(*,', sfx, ') ='
        CALL WRITE_1D_RL( layers_bounds(1,iLa), Nlayers+1, INDEX_K,
     &   tmpName(1:20), ' /* boundaries of tracer-averaging bins */')

       ENDIF !IF ( layers_num(iLa).NE.0 ) THEN
      ENDDO !DO iLa=1,layers_maxNum

C--   Check parameters:
      errCount = 0
      DO iLa=1,layers_maxNum

       IF ( layers_num(iLa).NE.0 ) THEN
C-    Check for inconsistent density layers_bounds specification
C     a) make sure layers_bounds is increasing:
        DO k=1,Nlayers
         IF ( layers_bounds(k,iLa).GE.layers_bounds(k+1,iLa) ) THEN
          WRITE(msgBuf,'(A,I2,A,I4)') 'LAYERS_CHECK(iLa=', iLa,
     &      '): layers_bounds k -> k+1 not increasing at k=', k
          CALL PRINT_ERROR( msgBuf, myThid )
          errCount = errCount + 1
         ENDIF
        ENDDO
       ENDIF

       IF ( layers_num(iLa).EQ.3 ) THEN
C     Pot.Density is now expressed as rho-1000 (previously just rho):
C     b) check for realistic layers_bounds values:
        tmpVar = layers_bounds(Nlayers+1,iLa) - layers_bounds(1,iLa)
        IF ( tmpVar.LE.50. .AND. layers_bounds(1,iLa).GE.950. ) THEN
          WRITE(msgBuf,'(A,I2,A)') 'LAYERS_CHECK(iLa=', iLa,
     &      '): layers_bounds seems to be expressed as "rho"'
          CALL PRINT_ERROR( msgBuf, myThid )
          WRITE(msgBuf,'(A,I2,A)') 'LAYERS_CHECK(iLa=', iLa,
     &      '): while it should be expressed as "rho - 1000"'
          CALL PRINT_ERROR( msgBuf, myThid )
          errCount = errCount + 1
        ENDIF
C-     Check for valid density reference level:
        IF ( layers_krho(iLa).LT.1 .OR. layers_krho(iLa).GT.Nr ) THEN
          WRITE(msgBuf,'(2A,I3,A,I9)') 'LAYERS_CHECK: ',
     &        'Invalid layer_krho(iLa=', iLa,') =', layers_krho(iLa)
          CALL PRINT_ERROR( msgBuf, myThid )
          errCount = errCount + 1
        ENDIF
       ENDIF

      ENDDO

      IF ( layers_useThermo .AND. .NOT. useDiagnostics ) THEN
        WRITE(msgBuf,'(2A)') 'LAYERS_CHECK: ',
     &    'layers-thermodynamics part requires useDiagnostics=T'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF

      IF ( errCount.GE.1 ) THEN
        WRITE(msgBuf,'(A,I3,A)')
     &       'LAYERS_CHECK: detected', errCount,' fatal error(s)'
        CALL PRINT_ERROR( msgBuf, myThid )
        CALL ALL_PROC_DIE( 0 )
        STOP 'ABNORMAL END: S/R LAYERS_CHECK'
      ELSE
       WRITE(msgBuf,'(A)') 'LAYERS_CHECK: done'
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                     SQUEEZE_RIGHT, myThid )
      ENDIF

      _END_MASTER(myThid)
#endif /* ALLOW_LAYERS */

      RETURN
      END

module vert_turb_driver_mod

!-----------------------------------------------------------------------
!
!       driver for compuing vertical diffusion coefficients
!
!         choose either:
!              1) mellor-yamada 2.5 (with tke)
!              2) non-local K scheme
!
!-----------------------------------------------------------------------
!---------------- modules ---------------------

use      my25_turb_mod, only: my25_turb_init, my25_turb_end,  &
                              my25_turb, tke_surf, tke

use    diffusivity_mod, only: diffusivity, molecular_diff

use   shallow_conv_mod, only: shallow_conv_init, shallow_conv

!use   diag_manager_mod, only: register_diag_field, send_data

!use   time_manager_mod, only: time_type, get_time, operator(-)

use     gcm_params_mod, only: gcm_LEN_MBUF, gcm_SQZ_R, gcm_stdMsgUnit
use      constants_mod, only: rdgas, rvgas, kappa

!use            fms_mod, only: error_mesg, open_namelist_file, file_exist, &
!                              check_nml_error, mpp_root_pe,      &
!                              mpp_pe, close_file, FATAL, stdlog, &
!                              write_version_number

implicit none
private

!---------------- interfaces ---------------------

public   vert_turb_driver_init, vert_turb_driver_end, vert_turb_driver

!-----------------------------------------------------------------------
!--------------------- version number ----------------------------------

character(len=128) :: version = '$Id: vert_turb_driver_mod.F90,v 1.2 2017/08/11 20:48:51 jmc Exp $'
character(len=128) :: tag = '$Name:  $'

!-----------------------------------------------------------------------
 real, parameter :: p00    = 1000.0E2
 real, parameter :: p00inv = 1./p00
 real, parameter :: d622   = rdgas/rvgas
 real, parameter :: d378   = 1.-d622
 real, parameter :: d608   = d378/d622

!---------------- private data -------------------

 logical :: do_init = .true.

 real :: gust_zi = 1000.   ! constant for computed gustiness (meters)

!-----------------------------------------------------------------------
!-------------------- namelist -----------------------------------------

 logical :: do_shallow_conv  = .false.
 logical :: do_mellor_yamada = .true.
 logical :: use_tau          = .true.
 logical :: do_molecular_diffusion = .false.

 character(len=24) :: gust_scheme  = 'constant' ! valid schemes are:
                                                !   => 'constant'
                                                !   => 'beljaars'
 real              :: constant_gust = 1.0

 namelist /vert_turb_driver_nml/ do_shallow_conv, do_mellor_yamada, &
                                 gust_scheme, constant_gust, use_tau, &
                                 do_molecular_diffusion

!-------------------- diagnostics fields -------------------------------

integer :: id_tke,    id_lscale, id_lscale_0, id_z_pbl, id_gust,  &
           id_diff_t, id_diff_m, id_diff_sc, id_z_full, id_z_half,&
           id_uwnd,   id_vwnd

real :: missing_value = -999.

character(len=9) :: mod_name = 'vert_turb'

!-----------------------------------------------------------------------

contains

!#######################################################################

subroutine vert_turb_driver (is, js, Time, Time_next, dt, frac_land,   &
                             p_half, p_full, z_half, z_full,           &
                             u_star, b_star, rough,                    &
                             uu, vv, tt, qq,                           &
                             diff_t, diff_m, gust,                     &
                             myThid, mask, kbot                                )
!                            u, v, t, q, um, vm, tm, qm,               &
!                            udt, vdt, tdt, qdt,                       &

!-----------------------------------------------------------------------
integer,         intent(in)         :: is, js
!type(time_type), intent(in)         :: Time, Time_next
   real,         intent(in)         :: Time, Time_next
   real,         intent(in)         :: dt
   real, intent(in), dimension(:,:) :: frac_land,   &
                                       u_star, b_star, rough
   real, intent(in), dimension(:,:,:) :: p_half, p_full, &
                                         z_half, z_full, &
                                         uu, vv, tt, qq
!                                        u, v, t, q, um, vm, tm, qm, &
!                                        udt, vdt, tdt, qdt
   real, intent(out),   dimension(:,:,:) :: diff_t, diff_m
   real, intent(out),   dimension(:,:)   :: gust
   integer, intent(in)                   :: myThid
   real, intent(in),optional, dimension(:,:,:) :: mask
integer, intent(in),optional, dimension(:,:) :: kbot
!-----------------------------------------------------------------------
real   , dimension(size(tt,1),size(tt,2),size(tt,3))   :: ape, thv
!logical, dimension(size(tt,1),size(tt,2),size(tt,3)+1) :: lmask
!real   , dimension(size(tt,1),size(tt,2),size(tt,3)+1) :: diag3
real   , dimension(size(tt,1),size(tt,2),size(tt,3)+1) :: el
real   , dimension(size(tt,1),size(tt,2))             :: el0, z_pbl
real   , dimension(size(diff_t,1),size(diff_t,2), &
                                  size(diff_t,3))   :: diff_sc
!real   , dimension(size(t,1),size(t,2),size(t,3))   :: tt, qq, uu, vv
real    :: dt_tke
integer :: ie, je, nlev, sec, day
logical :: used
!-----------------------------------------------------------------------
!----------------------- vertical turbulence ---------------------------
!-----------------------------------------------------------------------

      if (do_init)  CALL PRINT_ERROR(  &
                      'vert_turb_driver in vert_turb_driver_mod'//  &
                      'initialization has not been called', myThid )
!     if (do_init)  call error_mesg  &
!                    ('vert_turb_driver in vert_turb_driver_mod',  &
!                     'initialization has not been called', FATAL)

     nlev = size(p_full,3)
     ie = is + size(p_full,1) - 1
     je = js + size(p_full,2) - 1

!-----------------------------------------------------------------------
!---- set up state variable used by this module ----

!     if (use_tau) then
!     !-- variables at time tau
!         uu = u
!         vv = v
!         tt = t
!         qq = q
!     else
!     !-- variables at time tau+1
!         uu = um + dt*udt
!         vv = vm + dt*vdt
!         tt = tm + dt*tdt
!         qq = qm + dt*qdt
!     endif

!-----------------------------------------------------------------------

!---------------------------
 if (do_mellor_yamada) then
!---------------------------

!    ----- time step for prognostic tke calculation -----
!    call get_time (Time_next-Time, sec, day)
!    dt_tke = real(sec+day*86400)
     dt_tke = dt

!    ----- virtual temp ----------
     ape(:,:,:)=(p_full(:,:,:)*p00inv)**(-kappa)
     thv(:,:,:)=tt(:,:,:)*(qq(:,:,:)*d608+1.0)*ape(:,:,:)
     if (present(mask)) where (mask < 0.5) thv = 200.

!    --------------------- update tke-----------------------------------
!    ---- compute surface tke --------
!    ---- compute tke, master length scale (el0),  -------------
!    ---- length scale (el), and vert mix coeffs (diff_t,diff_m) ----

     call tke_surf  (u_star, tke(is:ie,js:je,:), kbot=kbot)

     if ( id_z_pbl > 0 ) then
     !------ compute pbl depth from k_profile if diagnostic needed -----
     call my25_turb (dt_tke, frac_land, p_half, p_full, thv, uu, vv, &
                     z_half, z_full, rough, tke(is:ie,js:je,:),      &
                     el0, el, diff_m, diff_t, &
                     mask=mask, kbot=kbot, &
                     ustar=u_star,bstar=b_star,h=z_pbl)
     else
     call my25_turb (dt_tke, frac_land, p_half, p_full, thv, uu, vv, &
                     z_half, z_full, rough, tke(is:ie,js:je,:),      &
                     el0, el, diff_m, diff_t, &
                     mask=mask, kbot=kbot)
     end if

!---------------------------
 else
!--------------------------------------------------------------------
!----------- compute molecular diffusion, if desired  ---------------

    if (do_molecular_diffusion) then
      call molecular_diff (tt, p_half, diff_m, diff_t, myThid )
    else
      diff_m = 0.0
      diff_t = 0.0
    endif

!---------------------------
!------------------- non-local K scheme --------------

    call diffusivity ( tt, qq, uu, vv, p_full, p_half, z_full, z_half,   &
                       u_star, b_star, z_pbl, diff_m, diff_t, myThid, &
                       kbot = kbot)

!---------------------------
 endif
!-----------------------------------------------------------------------
!------------------ shallow convection ???? ----------------------------

   if (do_shallow_conv) then
        call shallow_conv (tt, qq, p_full, p_half, diff_sc, kbot)
        diff_t = diff_t + diff_sc
   endif

!-----------------------------------------------------------------------
!------------- define gustiness ------------

     if ( trim(gust_scheme) == 'constant' ) then
          gust = constant_gust
     else if ( trim(gust_scheme) == 'beljaars' ) then
!    --- from Beljaars (1994) and Beljaars and Viterbo (1999) ---
          where (b_star > 0.)
             gust = (u_star*b_star*gust_zi)**(1./3.)
          elsewhere
             gust = 0.
          endwhere
     endif

!-----------------------------------------------------------------------
!------------------------ diagnostics section --------------------------

if (do_mellor_yamada) then

!     --- set up local mask for fields with surface data ---
      if ( present(mask) ) then
!        lmask(:,:,1)        = .true.
!        lmask(:,:,2:nlev+1) = mask(:,:,1:nlev) > 0.5
      else
!        lmask = .true.
      endif

!------- tke --------------------------------
      if ( id_tke > 0 ) then
!        used = send_data ( id_tke, tke(is:ie,js:je,:), Time_next,  &
!                           is, js, 1, mask=lmask )
      endif

!------- length scale (at half levels) ------
      if ( id_lscale > 0 ) then
!        used = send_data ( id_lscale, el, Time_next, is, js, 1,  &
!                           mask=lmask )
      endif

!------- master length scale -------
      if ( id_lscale_0 > 0 ) then
!        used = send_data ( id_lscale_0, el0, Time_next, is, js )
      endif

end if

!------- boundary layer depth -------
      if ( id_z_pbl > 0 ) then
!        used = send_data ( id_z_pbl, z_pbl, Time_next, is, js )
      endif

!------- gustiness -------
      if ( id_gust > 0 ) then
!        used = send_data ( id_gust, gust, Time_next, is, js )
      endif

!------- output diffusion coefficients ---------

  if ( id_diff_t > 0 .or. id_diff_m > 0 .or. id_diff_sc > 0 ) then
!       --- set up local mask for fields without surface data ---
        if (present(mask)) then
!           lmask(:,:,1:nlev) = mask(:,:,1:nlev) > 0.5
!           lmask(:,:,nlev+1) = .false.
        else
!           lmask(:,:,1:nlev) = .true.
!           lmask(:,:,nlev+1) = .false.
        endif
!       -- dummy data at surface --
!       diag3(:,:,nlev+1)=0.0
  endif

!------- diffusion coefficient for heat/moisture -------
   if ( id_diff_t > 0 ) then
!     diag3(:,:,1:nlev) = diff_t(:,:,1:nlev)
!     used = send_data ( id_diff_t, diag3, Time_next, is, js, 1, mask=lmask )
   endif

!------- diffusion coefficient for momentum -------
   if ( id_diff_m > 0 ) then
!     diag3(:,:,1:nlev) = diff_m(:,:,1:nlev)
!     used = send_data ( id_diff_m, diag3, Time_next, is, js, 1, mask=lmask )
   endif

!------- diffusion coefficient for shallow conv -------
 if (do_shallow_conv) then
   if ( id_diff_sc > 0 ) then
!     diag3(:,:,1:nlev) = diff_sc(:,:,1:nlev)
!     used = send_data ( id_diff_sc, diag3, Time_next, is, js, 1, mask=lmask)
   endif
 endif

!--- geopotential height relative to the surface on full and half levels ----

   if ( id_z_half > 0 ) then
      !--- set up local mask for fields with surface data ---
      if ( present(mask) ) then
!        lmask(:,:,1)        = .true.
!        lmask(:,:,2:nlev+1) = mask(:,:,1:nlev) > 0.5
      else
!        lmask = .true.
      endif
!     used = send_data ( id_z_half, z_half, Time_next, is, js, 1, mask=lmask )
   endif

   if ( id_z_full > 0 ) then
!     used = send_data ( id_z_full, z_full, Time_next, is, js, 1, rmask=mask)
   endif

!--- zonal and meridional wind on mass grid -------

   if ( id_uwnd > 0 ) then
!     used = send_data ( id_uwnd, uu, Time_next, is, js, 1, rmask=mask)
   endif

   if ( id_vwnd > 0 ) then
!     used = send_data ( id_vwnd, vv, Time_next, is, js, 1, rmask=mask)
   endif

!-----------------------------------------------------------------------

end subroutine vert_turb_driver

!#######################################################################

subroutine vert_turb_driver_init (id, jd, kd, axes, Time, myThid)

!-----------------------------------------------------------------------
   integer,         intent(in) :: id, jd, kd, axes(4)
!  type(time_type), intent(in) :: Time
   real,            intent(in) :: Time
   integer, intent(in)         :: myThid
!-----------------------------------------------------------------------
   integer, dimension(3) :: full = (/1,2,3/), half = (/1,2,4/)
   integer :: ierr, unit, io

integer         :: iUnit
CHARACTER*(gcm_LEN_MBUF) :: msgBuf

      if (.not.do_init) CALL PRINT_ERROR(  &
                    'vert_turb_driver_init in vert_turb_driver_mod'//  &
                    'attempting to call initialization twice', myThid )
!     if (.not.do_init)  &
!         call error_mesg  &
!                  ('vert_turb_driver_init in vert_turb_driver_mod',  &
!                   'attempting to call initialization twice', FATAL)

!-----------------------------------------------------------------------
!--------------- read namelist ------------------

!    _BARRIER
!    _BEGIN_MASTER(myThid)
     CALL BARRIER(myThid)
     IF ( myThid.EQ.1 ) THEN

     WRITE(msgBuf,'(A)') 'VERT_TURB_DRIVER_INIT: opening data.atm_gray'
     CALL PRINT_MESSAGE( msgBuf, gcm_stdMsgUnit, gcm_SQZ_R, myThid )
     CALL OPEN_COPY_DATA_FILE(                                      &
                           'data.atm_gray', 'VERT_TURB_DRIVER_INIT',       &
                           iUnit,                                   &
                           myThid )
!    Read parameters from open data file
     READ(UNIT=iUnit,NML=vert_turb_driver_nml)
     WRITE(msgBuf,'(A)')                                            &
          'VERT_TURB_DRIVER_INIT: finished reading data.atm_gray'
     CALL PRINT_MESSAGE( msgBuf, gcm_stdMsgUnit, gcm_SQZ_R, myThid )
!    Close the open data file
#ifdef SINGLE_DISK_IO
     CLOSE(iUnit)
#else
     CLOSE(iUnit,STATUS='DELETE')
#endif /* SINGLE_DISK_IO */

!     if (file_exist('input.nml')) then
!        unit = open_namelist_file ()
!        ierr=1; do while (ierr /= 0)
!           read  (unit, nml=vert_turb_driver_nml, iostat=io, end=10)
!           ierr = check_nml_error (io, 'vert_turb_driver_nml')
!        enddo
! 10     call close_file (unit)
!     endif

!---------- output namelist --------------------------------------------

!     call write_version_number(version, tag)
!     if ( mpp_pe() == mpp_root_pe() ) write (stdlog(), nml=vert_turb_driver_nml)

!     --- check namelist option ---
      if ( trim(gust_scheme) /= 'constant' .and. &
           trim(gust_scheme) /= 'beljaars' ) CALL PRINT_ERROR(  &
          'vert_turb_driver_mod'//'invalid value for namelist'// &
          ' variable GUST_SCHEME', myThid )
!          trim(gust_scheme) /= 'beljaars' ) call error_mesg &
!        ('vert_turb_driver_mod', 'invalid value for namelist &
!         &variable GUST_SCHEME', FATAL)

      if (do_molecular_diffusion .and. do_mellor_yamada) CALL PRINT_ERROR(  &
          'vert_turb_driver_mod'//' cannot activate'//  &
          ' molecular diffusion with mellor_yamada', myThid )
!     if (do_molecular_diffusion .and. do_mellor_yamada)  &
!         call error_mesg ( 'vert_turb_driver_mod', 'cannot activate &
!  &molecular diffusion with mellor_yamada', FATAL)

!-----------------------------------------------------------------------

      if (do_mellor_yamada) call my25_turb_init (id, jd, kd)

      if (do_shallow_conv)  call shallow_conv_init (kd)

!-----------------------------------------------------------------------
!----- initialize diagnostic fields -----

       id_tke      = 0
       id_lscale   = 0
       id_lscale_0 = 0
       id_z_pbl    = 0
       id_gust     = 0
       id_diff_t   = 0
       id_diff_m   = 0
       id_diff_sc  = 0
       id_z_full   = 0
       id_z_half   = 0
       id_uwnd     = 0
       id_vwnd     = 0
!  id_uwnd = register_diag_field ( mod_name, 'uwnd', axes(full), Time, &
!       'zonal wind on mass grid', 'meters/second' ,                   &
!missing_value=missing_value    )

!  id_vwnd = register_diag_field ( mod_name, 'vwnd', axes(full), Time, &
!       'meridional wind on mass grid', 'meters/second' ,              &
!missing_value=missing_value    )

!  id_z_full = &
!  register_diag_field ( mod_name, 'z_full', axes(full), Time,    &
!       'geopotential height relative to surface at full levels', &
!               'meters' , missing_value=missing_value    )

!  id_z_half = &
!  register_diag_field ( mod_name, 'z_half', axes(half), Time,    &
!       'geopotential height relative to surface at half levels', &
!               'meters' , missing_value=missing_value    )

if (do_mellor_yamada) then

!  id_tke = &
!  register_diag_field ( mod_name, 'tke', axes(half), Time,      &
!                       'turbulent kinetic energy',  'm2/s2'   , &
!                       missing_value=missing_value               )

!  id_lscale = &
!  register_diag_field ( mod_name, 'lscale', axes(half), Time,    &
!                       'turbulent length scale',  'm'   ,        &
!                       missing_value=missing_value               )

!  id_lscale_0 = &
!  register_diag_field ( mod_name, 'lscale_0', axes(1:2), Time,   &
!                       'master length scale',  'm'               )
endif

!  id_z_pbl = &
!  register_diag_field ( mod_name, 'z_pbl', axes(1:2), Time,       &
!                       'depth of planetary boundary layer',  'm'  )

!  id_gust = &
!  register_diag_field ( mod_name, 'gust', axes(1:2), Time,        &
!                       'wind gustiness in surface layer',  'm/s'  )

!  id_diff_t = &
!  register_diag_field ( mod_name, 'diff_t', axes(half), Time,    &
!                       'vert diff coeff for temp',  'm2/s'   ,   &
!                       missing_value=missing_value               )

!  id_diff_m = &
!  register_diag_field ( mod_name, 'diff_m', axes(half), Time,      &
!                       'vert diff coeff for momentum',  'm2/s'   , &
!                       missing_value=missing_value               )

if (do_shallow_conv) then

!  id_diff_sc = &
!  register_diag_field ( mod_name, 'diff_sc', axes(half), Time,      &
!                       'vert diff coeff for shallow conv', 'm2/s' , &
!                       missing_value=missing_value               )
endif

!-----------------------------------------------------------------------

   do_init=.false.

     ENDIF
     CALL BARRIER(myThid)

!-----------------------------------------------------------------------

end subroutine vert_turb_driver_init

!#######################################################################

subroutine vert_turb_driver_end(myThid)

integer, intent(in) :: myThid

!-----------------------------------------------------------------------
      if (do_mellor_yamada) call my25_turb_end
!-----------------------------------------------------------------------

end subroutine vert_turb_driver_end

!#######################################################################

end module vert_turb_driver_mod

#include "GMREDI_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: MYPACKAGE_READ_PICKUP

C     !INTERFACE:
      SUBROUTINE GMREDI_READ_PICKUP( myIter, myThid )

C     !DESCRIPTION:
C     Reads current state of MYPACKAGE from a pickup file

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GMREDI.h"

C     !INPUT PARAMETERS:
C     myIter            :: time-step number
C     myThid            :: thread number
      INTEGER myIter
      INTEGER myThid

#if ( defined GM_BATES_K3D || defined GM_GEOM_VARIABLE_K )
C     !FUNCTIONS:
      INTEGER  ILNBLNK
      EXTERNAL ILNBLNK

C     !LOCAL VARIABLES:
C     fn          :: character buffer for creating filename
C     fp          :: precision of pickup files
C     filePrec    :: pickup-file precision (read from meta file)
C     nbFields    :: number of fields in pickup file (read from meta file)
C     missFldList :: List of missing fields   (attempted to read but not found)
C     missFldDim  :: Dimension of missing fields list array: missFldList
C     nMissing    :: Number of missing fields (attempted to read but not found)
C     j           :: loop index
C     nj          :: record number
C     ioUnit      :: temp for writing msg unit
C     msgBuf      :: Informational/error message buffer
      INTEGER fp
      INTEGER filePrec, nbFields
      INTEGER missFldDim, nMissing
      INTEGER j, nj, ioUnit, iL
#ifdef GM_BATES_K3D
      INTEGER i, k, n, bi, bj
      _RL vec(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
# ifdef GM_GEOM_VARIABLE_K
      PARAMETER( missFldDim = 5+2*GM_Bates_NModes )
# else
      PARAMETER( missFldDim = 2+2*GM_Bates_NModes )
# endif
#else /* GM_BATES_K3D */
      PARAMETER( missFldDim = 3 )
#endif /* GM_BATES_K3D */
      CHARACTER*(10) suff
      CHARACTER*(MAX_LEN_FNAM) fn, tmpNam
      CHARACTER*(8) missFldList(missFldDim)
      CHARACTER*(8) fieldname
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      LOGICAL useCurrentDir, fileExist, StopFlag
CEOP

      IF ( GM_useBatesK3d .OR. GM_useGEOM ) THEN
       ioUnit = errorMessageUnit

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

       IF ( pickupSuff.EQ.' ' ) THEN
        IF ( rwSuffixType.EQ.0 ) THEN
          WRITE(fn,'(A,I10.10)') 'pickup_gmredi.', myIter
        ELSE
          CALL RW_GET_SUFFIX( suff, startTime, myIter, myThid )
          WRITE(fn,'(A,A)') 'pickup_gmredi.', suff
        ENDIF
       ELSE
        WRITE(fn,'(A,A10)') 'pickup_gmredi.', pickupSuff
       ENDIF
       fp = precFloat64

       CALL READ_MFLDS_SET(
     I                      fn,
     O                      nbFields, filePrec,
     I                      Nr, myIter, myThid )
       _BEGIN_MASTER( myThid )
c      IF ( filePrec.NE.0 .AND. filePrec.NE.fp ) THEN
       IF ( nbFields.GE.0 .AND. filePrec.NE.fp ) THEN
         WRITE(msgBuf,'(2A,I4)') 'GMREDI_READ_PICKUP: ',
     &    'pickup-file binary precision do not match !'
         CALL PRINT_ERROR( msgBuf, myThid )
         WRITE(msgBuf,'(A,2(A,I4))') 'GMREDI_READ_PICKUP: ',
     &    'file prec.=', filePrec, ' but expecting prec.=', fp
         CALL PRINT_ERROR( msgBuf, myThid )
         CALL ALL_PROC_DIE( 0 )
         STOP 'ABNORMAL END: S/R GMREDI_READ_PICKUP (data-prec Pb)'
       ENDIF
       _END_MASTER( myThid )

       IF ( nbFields.LE.0 ) THEN
C-      No meta-file or old meta-file without List of Fields
        IF ( pickupStrictlyMatch ) THEN
         WRITE(msgBuf,'(4A)') 'GMREDI_READ_PICKUP: ',
     &      'no field-list found in meta-file',
     &      ' => cannot check for strick-matching'
         CALL PRINT_ERROR( msgBuf, myThid )
         WRITE(msgBuf,'(4A)') 'GMREDI_READ_PICKUP: ',
     &      'try with " pickupStrictlyMatch=.FALSE.,"',
     &      ' in file: "data", NameList: "PARM03"'
         CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
         CALL ALL_PROC_DIE( myThid )
         STOP 'ABNORMAL END: S/R GMREDI_READ_PICKUP'
        ELSE
         IF ( nbFields.EQ.-1 ) THEN
C-      No meta-file: then check if binary pickup file (i.e., ".data") exist
#ifdef ALLOW_MDSIO
          useCurrentDir = .FALSE.
          CALL MDS_CHECK4FILE(
     I                     fn, '.data', 'GMREDI_READ_PICKUP',
     O                     tmpNam, fileExist,
     I                     useCurrentDir, myThid )
#else
          STOP 'ABNORMAL END: S/R DIC_READ_PICKUP: Needs MDSIO pkg'
#endif
          IF ( fileExist ) THEN
           WRITE(msgBuf,'(4A)') 'WARNING >> GMREDI_READ_PICKUP: ',
     &      ' no field-list found'
           CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
           WRITE(msgBuf,'(4A)') 'WARNING >> ',
     &      ' try to read pickup as currently written'
           CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
          ELSE
           iL = ILNBLNK(fn)
           WRITE(msgBuf,'(4A)') 'WARNING >> GMREDI_READ_PICKUP: ',
     &      'missing both "meta" & "data" files for "', fn(1:iL), '"'
           CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
           nbFields = -2
#ifdef GM_GEOM_VARIABLE_K
           _BEGIN_MASTER( myThid )
           IF ( GM_useGEOM ) THEN
            GEOM_startAB = 0
            WRITE(msgBuf,'(4A)') 'WARNING >> GMREDI_READ_PICKUP: ',
     &      'restart with uniform GEOM_EKE = GEOM_ini_EKE'
            CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
           _END_MASTER( myThid )
           ENDIF
#endif
          ENDIF
         ELSE
C-      Old meta-file without List of Fields
c         WRITE(msgBuf,'(4A)') 'WARNING >> ',
c    &      ' try to read pickup as it used to be written'
c         CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
c         WRITE(msgBuf,'(4A)') 'WARNING >> ',
c    &      ' until checkpoint59l (2007 Dec 17)'
c         CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
          WRITE(msgBuf,'(4A)') 'GMREDI_READ_PICKUP: ',
     &      'no field-list found in meta-file'
          CALL PRINT_ERROR( msgBuf, myThid )
          CALL ALL_PROC_DIE( myThid )
          STOP 'ABNORMAL END: S/R GMREDI_READ_PICKUP'
         ENDIF
        ENDIF
       ENDIF

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

       IF ( nbFields.EQ.0 ) THEN
C---   Old way to read pickup:

c        WRITE(msgBuf,'(2A,I4)') 'GMREDI_READ_PICKUP: ',
c    &        'old way of reading pickups not implemented, continuing'
c        CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )

       ELSEIF ( nbFields.NE.-2 ) THEN

        nj = 0
C---   read GMREDI fields for restart

#ifdef GM_BATES_K3D
        IF ( GM_useBatesK3d ) THEN

C        Center mode
         fieldname = 'mode01C '
         CALL READ_MFLDS_3D_RL( fieldname, vec,
     &                          nj, fp, Nr, myIter, myThid )
         CALL EXCH_3D_RL( vec, Nr, myThid )
         DO bj=myByLo(myThid),myByHi(myThid)
          DO bi=myBxLo(myThid),myBxHi(myThid)
           DO k=1,Nr
            DO j=1-OLy,sNy+OLy
             DO i=1-OLx,sNx+OLx
              modesC(1,i,j,k,bi,bj) = vec(i,j,k,bi,bj)
             ENDDO
            ENDDO
           ENDDO
          ENDDO
         ENDDO

C      Western Mode
         DO n=1,GM_Bates_NModes
          WRITE(fieldname, '(A,I2.2,A)') 'mode',n,'W'
          CALL READ_MFLDS_3D_RL( fieldname, vec,
     &                           nj, fp, Nr, myIter, myThid )
          CALL EXCH_3D_RL( vec, Nr, myThid )
          DO bj=myByLo(myThid),myByHi(myThid)
           DO bi=myBxLo(myThid),myBxHi(myThid)
            DO k=1,Nr
             DO j=1-OLy,sNy+OLy
              DO i=1-OLx,sNx+OLx
               modesW(n,i,j,k,bi,bj) = vec(i,j,k,bi,bj)
              ENDDO
             ENDDO
            ENDDO
           ENDDO
          ENDDO
         ENDDO

C      Southern Mode
         DO n=1,GM_Bates_NModes
          WRITE(fieldname, '(A,I2.2,A)') 'mode',n,'S'
          CALL READ_MFLDS_3D_RL( fieldname, vec,
     &                           nj, fp, Nr, myIter, myThid )
          CALL EXCH_3D_RL( vec, Nr, myThid )
          DO bj=myByLo(myThid),myByHi(myThid)
           DO bi=myBxLo(myThid),myBxHi(myThid)
            DO k=1,Nr
             DO j=1-OLy,sNy+OLy
              DO i=1-OLx,sNx+OLx
               modesS(n,i,j,k,bi,bj) = vec(i,j,k,bi,bj)
              ENDDO
             ENDDO
            ENDDO
           ENDDO
          ENDDO
         ENDDO

C     Switch to - 2D fields :
         nj = nj*Nr
C       Deformation radius
         fieldname = 'Rdef    '
         CALL READ_MFLDS_3D_RL( fieldname, Rdef,
     &                          nj, fp, 1, myIter, myThid )
         CALL EXCH_XY_RL( Rdef, myThid )

c     GM_useBates3D
        ENDIF
#endif /* GM_BATES_K3D */

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#ifdef GM_GEOM_VARIABLE_K
        IF ( GM_useGEOM ) THEN

C     Continue with GEOMETRIC - 2D fields :
C        GEOMETRIC energy
         fieldname = 'GEOM_EKE'
         CALL READ_MFLDS_3D_RL( fieldname, GEOM_EKE,
     &                          nj, fp, 1, myIter, myThid )
         CALL EXCH_XY_RL( GEOM_EKE, myThid )

         fieldname = 'GEKE_Nm1'
         CALL READ_MFLDS_3D_RL( fieldname, GEOM_gEKE_Nm1,
     &                          nj, fp, 1, myIter, myThid )
         CALL EXCH_XY_RL( GEOM_gEKE_Nm1, myThid )

        ENDIF
#endif /* GM_GEOM_VARIABLE_K */

C--   end: new way to read pickup file
       ENDIF

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C--    Check for missing fields:
       nMissing = missFldDim
       CALL READ_MFLDS_CHECK(
     O       missFldList,
     U       nMissing,
     I       myIter, myThid )

       _BEGIN_MASTER( myThid )
       IF ( nMissing.GT.missFldDim ) THEN
        WRITE(msgBuf,'(2A,I4)') 'GMREDI_READ_PICKUP: ',
     &       'missing fields list has been truncated to', missFldDim
        CALL PRINT_ERROR( msgBuf, myThid )
        CALL ALL_PROC_DIE( 0 )
        STOP 'ABNORMAL END: S/R GMREDI_READ_PICKUP (list-size Pb)'
       ENDIF
       IF ( nMissing.GE.1 ) THEN
        stopFlag = .FALSE.
        IF ( pickupStrictlyMatch ) THEN
         WRITE(msgBuf,'(4A)') 'GMREDI_READ_PICKUP: ',
     &      'try with " pickupStrictlyMatch=.FALSE.,"',
     &      ' in file: "data", NameList: "PARM03"'
         CALL PRINT_ERROR( msgBuf, myThid )
         stopFlag = .TRUE.
        ELSE
         DO j=1,nMissing
          IF ( missFldList(j).EQ.'GEOM_EKE' ) THEN
#ifdef GM_GEOM_VARIABLE_K
           GEOM_startAB = 0
           WRITE(msgBuf,'(4A)') '** WARNING ** GMREDI_READ_PICKUP: ',
     &      'restart with uniform GEOM_EKE = GEOM_ini_EKE'
           CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
          ELSEIF ( missFldList(j).EQ.'GEKE_Nm1' ) THEN
           GEOM_startAB = 0
           WRITE(msgBuf,'(4A)') '** WARNING ** GMREDI_READ_PICKUP: ',
     &     'Will get only an approximated Restart (GEOM_startAB=0)'
           CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
#endif /* GM_GEOM_VARIABLE_K */
          ELSE
           stopFlag = .TRUE.
           WRITE(msgBuf,'(4A)') 'GMREDI_READ_PICKUP: ',
     &          'cannot restart without field "',missFldList(j),'"'
           CALL PRINT_ERROR( msgBuf, myThid )
          ENDIF
         ENDDO
        ENDIF
        IF ( stopFlag ) THEN
         CALL ALL_PROC_DIE( 0 )
         STOP 'ABNORMAL END: S/R GMREDI_READ_PICKUP'
        ENDIF

       ENDIF
       _END_MASTER( myThid )
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C     end if GM_useBatesK3d or GM_useGEOM block
      ENDIF
#endif /* GM_BATES_K3D or GM_GEOM_VARIABLE_K */

      RETURN
      END

#include "ctrparam.h"
#include "ATM2D_OPTIONS.h"

C
      SUBROUTINE ATM2D_READPARMS( myThid )
C     /==========================================================\
C     | SUBROUTINE ATM2D_READPARMS                               |
C     |==========================================================|
C     | Initialize ATM2D parameters, read in data.atm2d          |
C     \==========================================================/
      IMPLICIT NONE

#include "ATMSIZE.h"
#include "SIZE.h"
#include "EEPARAMS.h"
#include "ATM2D_VARS.h"

C     === Routine arguments ===
      INTEGER myThid

      NAMELIST /PARM01_ATM2D/
     &        atmosTauuFile, atmosTauvFile,atmosWindFile

      NAMELIST /PARM02_ATM2D/
     &        tauuFile, tauvFile, windFile,
     &        qnetFile, evapFile, precipFile

      NAMELIST /PARM03_ATM2D/
     &        thetaRelaxFile, saltRelaxFile,
     &        tauThetaRelax, tauSaltRelax,
     &        nttyperelax, nstyperelax

      NAMELIST /PARM04_ATM2D/
     &        runoffFile, runoffMapFile,
     &        numbands, rband

      NAMELIST /PARM05_ATM2D/
     &        useObsEmP,useObsRunoff,useAltDeriv


C     === Local variables ===
C     msgBuf      - Informational/error meesage buffer
C     iUnit       - Work variable for IO unit number
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      INTEGER iUnit
      INTEGER j     ! loop counter


      WRITE(msgBuf,'(A)') ' ATM2D_READPARMS: opening data.atm2d'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT , 1)

      CALL OPEN_COPY_DATA_FILE(
     I                          'data.atm2d', 'ATM2D_READPARMS',
     O                          iUnit,
     I                          myThid )

C--   Default values
      atmosTauuFile=' '
      atmosTauvFile=' '
      atmosWindFile=' '
      tauuFile=' '
      tauvFile=' '
      windFile=' '
      qnetFile=' '
      evapFile=' '
      precipFile=' '
      runoffFile=' '
      thetaRelaxFile=' '
      saltRelaxFile=' '
      runoffFile=' '
      runoffMapFile=' '
C
      useObsEmP=.FALSE.
      useObsRunoff=.FALSE.
      useAltDeriv=.FALSE.
C
      r_tauThetaRelax=0. _d 0
      r_tauSaltRelax=0. _d 0
      ntTypeRelax=0
      nsTypeRelax=0

      numBands=1
      do j=1,sNy
        rband(j)=0
      enddo

c--   Read parameters from open data file
      READ(UNIT=iUnit,NML=PARM01_ATM2D)
c
      READ(UNIT=iUnit,NML=PARM02_ATM2D)
c
      READ(UNIT=iUnit,NML=PARM03_ATM2D)
c
      READ(UNIT=iUnit,NML=PARM04_ATM2D)
c
      READ(UNIT=iUnit,NML=PARM05_ATM2D)
c
      WRITE(msgBuf,'(A)') ' ATM2D_READPARMS: read PARM01_ATM2D'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT , 1)

C--   Close the open data file
#ifdef SINGLE_DISK_IO
      CLOSE(iUnit)
#else
      CLOSE(iUnit,STATUS='DELETE')
#endif /* SINGLE_DISK_IO */

      IF (tauThetaRelax .NE. 0. _d 0)
     &                  r_tauThetaRelax= 1. _d 0/tauThetaRelax
      IF (tauSaltRelax .NE. 0. _d 0)
     &                  r_tauSaltRelax= 1. _d 0/tauSaltRelax

      RETURN
      END

#include "OCN_CPL_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: CPL_INIT_FIXED

C     !INTERFACE:
      SUBROUTINE CPL_INIT_FIXED( myThid )

C     !DESCRIPTION:
C     Initialise non evolving (fixed) coupling interface package,
C     Oceanic version

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"

C     !INPUT PARAMETERS:
      INTEGER myThid
CEOP

#ifdef ALLOW_DIAGNOSTICS
      IF ( useDiagnostics ) THEN
        CALL CPL_DIAGNOSTICS_INIT( myThid )
      ENDIF
#endif

      RETURN
      END

#include "CPP_OPTIONS.h"

CBOP 0
C !ROUTINE: CPL_CHECK_CPLCONFIG

C !INTERFACE:
      SUBROUTINE CPL_CHECK_CPLCONFIG(
     I                     msgUnit,
     U                     errFlag, errMsg )

C !DESCRIPTION:
C     *==========================================================*
C     | SUBROUTINE CPL_CHECK_CPLCONFIG
C     | o Routine to check Coupler config
C     *==========================================================*
C     | This routine also set the number of coupler time-step
C     |  to run
C     *==========================================================*

C !USES:
      IMPLICIT NONE
C     == Global variables ==
#include "ATMSIZE.h"
#include "OCNSIZE.h"
#include "ATMVARS.h"
#include "OCNVARS.h"
#include "CPL_PARAMS.h"
#include "CPL_MAP2GRIDS.h"

C !INPUT/OUTPUT PARAMETERS:
C     msgUnit  :: log-file I/O unit
C     errFlag  :: logical flag to report an error
C     errMsg   :: error message to print to clog file
      INTEGER msgUnit
      LOGICAL errFlag
      CHARACTER*(*) errMsg

C !LOCAL VARIABLES:
      INTEGER i, j, n
      INTEGER ijo, ija
      LOGICAL tmpVar(Nx_atm,Ny_atm)
CEOP

C--   Report previously found errors
      IF ( cplErrorCount.NE.0 ) THEN
        errFlag = .TRUE.
        WRITE(msgUnit,'(2A,I4,A)')
     &    ' *** ERROR *** CPL_CHECK_CPLCONFIG: ',
     &    ' cplErrorCount=', cplErrorCount, ' (from previous error)'
      ENDIF

C--   Define length of the run (number of coupler time-step)
      WRITE(msgUnit,'(2A,I9)') ' CPL_CHECK_CPLCONFIG: ',
     &    'Nb of time-steps to run (ATM) =', nSteps_atm
      WRITE(msgUnit,'(2A,I9)') ' CPL_CHECK_CPLCONFIG: ',
     &    'Nb of time-steps to run (OCN) =', nSteps_ocn
      IF ( nSteps_atm .EQ. nSteps_ocn ) THEN
        nCouplingSteps = nSteps_ocn
        WRITE(msgUnit,'(2A,I9)') ' CPL_CHECK_CPLCONFIG: ',
     &    'Nb of time-steps to run (CPL) =', nCouplingSteps
      ELSE
        errFlag = .TRUE.
        nCouplingSteps = 0
        WRITE(msgUnit,'(2A)') ' *** ERROR *** CPL_CHECK_CPLCONFIG: ',
     &    ' wrong Nb of time-steps to run'
      ENDIF

C--   Check for consistent RunOff mapping regarding Land/Sea mask:
      DO j=1,Ny_atm
       DO i=1,Nx_atm
        tmpVar(i,j) = landMask_atm(i,j) .EQ. 1. _d 0
       ENDDO
      ENDDO
      DO n=1,nROmap
C     a) check that RunOff drain a land point
        ija = ijROatm(n) - 1
        i = 1 + MOD(ija,Nx_atm)
        j = 1 + ija/Nx_atm
        IF ( landMask_atm(i,j).EQ.0. ) THEN
          errFlag = .TRUE.
          WRITE(msgUnit,'(A,2I8,A)')
     &    ' *** ERROR *** RunOff Mapp: i,j=', i, j, ' not Land point'
        ENDIF
        tmpVar(i,j) = .FALSE.
C     b) and supply an ocean point
        ijo = ijROocn(n) - 1
        i = 1 + MOD(ijo,Nx_ocn)
        j = 1 + ijo/Nx_ocn
        IF ( OcMxlD_ocn(i,j).EQ.0. ) THEN
          errFlag = .TRUE.
          WRITE(msgUnit,'(A,2I8,A)')
     &    ' *** ERROR *** RunOff Mapp: i,j=', i, j, ' not Oce point'
        ENDIF
      ENDDO
C     c) check that all land-points are drained,
C  note: would need to know ATM grid-cell area to check that
C        RunOff Mapping conserve water.
      IF ( cplErrorCount.EQ.0 ) THEN
       DO j=1,Ny_atm
        DO i=1,Nx_atm
         IF ( tmpVar(i,j) ) THEN
          WRITE(msgUnit,'(A,2I8,A)')
     &    ' ** WARNING ** Land point: i,j=', i, j, ' not drained'
         ENDIF
        ENDDO
       ENDDO
      ENDIF

      IF ( errFlag ) THEN
        errMsg = 'CPL_CHECK_CPLCONFIG: inconsistent CPL/ATM/OCN config'
      ELSE
        WRITE(msgUnit,'(2A)') ' CPL_CHECK_CPLCONFIG: ','done'
      ENDIF

      RETURN
      END

#include "SHELFICE_OPTIONS.h"

CBOP
C !ROUTINE: SHELFICE_MASK_SEAICE

C !INTERFACE: ==========================================================
      SUBROUTINE SHELFICE_MASK_SEAICE(
     U                    SIfield,
     I                    bi, bj, myIter, myThid )

C !DESCRIPTION:
C  Mask seaice field (mask) to prevent seaice to spread
C         in grid-cells that are occupied by ice-shelf

C !USES: ===============================================================
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "SHELFICE.h"

C !INPUT/OUTPUT PARAMETERS: ============================================
C     SIfield     :: seaice field @ grid-cell center
C     bi, bj      :: Current tile indices
C     myIter      :: Current iteration number in simulation
C     myThid      :: my Thread Id number
      _RL SIfield(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      INTEGER bi, bj
      INTEGER myIter
      INTEGER myThid

C !LOCAL VARIABLES: ====================================================
C     i, j        :: Loop counters
      INTEGER i, j
CEOP
C     msgBuf      :: Informational/error message buffer
c     CHARACTER*(MAX_LEN_MBUF) msgBuf

c     DO bj=myByLo(myThid),myByHi(myThid)
c      DO bi=myBxLo(myThid),myBxHi(myThid)

        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          IF ( kTopC(i,j,bi,bj).NE.0 ) SIfield(i,j,bi,bj) = zeroRL
         ENDDO
        ENDDO

c      ENDDO
c     ENDDO

      RETURN
      END

#include "AUTODIFF_OPTIONS.h"

CBOP
C     !ROUTINE: ADD_PREFIX
C     !INTERFACE:
      SUBROUTINE ADD_PREFIX( prefix, actvarf, fname )

C     !DESCRIPTION: \bv
C     ==================================================================
C     SUBROUTINE ADD_PREFIX
C     ==================================================================
C     o Helper S/R to add 2 character prefix to file-name
C     started: ou.wang@jpl.nasa.gov 24-Aug-2022
C     ==================================================================
C     \ev

C     !USES:
      IMPLICIT NONE

C     !INPUT/OUTPUT PARAMETERS:
C     prefix  :: (input)  2 character prefix to add
C     actvarf :: (input)  active-variable file-name
C     fname   :: (output) file-name with added prefix
      CHARACTER*(2) prefix
      CHARACTER*(*) actvarf
      CHARACTER*(*) fname

C     !FUNCTIONS:
      INTEGER  ILNBLNK
      EXTERNAL ILNBLNK

C     !LOCAL VARIABLES:
      INTEGER il, ic, l
CEOP

      il = ILNBLNK( actvarf )
      ic = 0
      IF ( il .GT. 0 .AND. (il+2) .LE. LEN(fname) ) THEN
        l = il
        DO WHILE ( ic .EQ. 0 .AND. l .GE. 1 )
          IF ( actvarf(l:l) .EQ. '/' ) ic = l
          l = l -1
        ENDDO
      ELSE
        STOP 'ABNORMAL END: S/R ADD_PREFIX'
      ENDIF
      WRITE(fname,'(3A)') actvarf(1:ic), prefix, actvarf(ic+1:il)

      RETURN
      END

#include "SEAICE_OPTIONS.h"
#ifdef ALLOW_EXF
# include "EXF_OPTIONS.h"
#endif
#ifdef ALLOW_AUTODIFF
# include "AUTODIFF_OPTIONS.h"
#endif

CStartOfInterface
      SUBROUTINE DYNSOLVER( myTime, myIter, myThid )
C     *==========================================================*
C     | SUBROUTINE DYNSOLVER                                     |
C     | o B-grid version of ice dynamics using LSR solver        |
C     |   Zhang and Hibler, JGR, 102, 8691-8702, 1997            |
C     *==========================================================*
C     *==========================================================*
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "DYNVARS.h"
#include "FFIELDS.h"
#include "SEAICE_SIZE.h"
#include "SEAICE_PARAMS.h"
#include "SEAICE_GRID.h"
#include "SEAICE.h"
#ifdef ALLOW_EXF
# include "EXF_FIELDS.h"
#endif
#ifdef ALLOW_AUTODIFF_TAMC
# include "tamc.h"
#endif

C     === Routine arguments ===
C     myTime - Simulation time
C     myIter - Simulation timestep number
C     myThid - Thread no. that called this routine.
      _RL     myTime
      INTEGER myIter
      INTEGER myThid
CEndOfInterface

#ifdef SEAICE_BGRID_DYNAMICS

#ifdef EXPLICIT_SSH_SLOPE
#include "SURFACE.h"
      _RL phiSurf(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
#endif

C     === Local variables ===
C     i,j,bi,bj - Loop counters

      INTEGER i, j, bi, bj
      _RL RHOICE, RHOAIR
      _RL COSWIN
      _RS SINWIN
      _RL ECCEN, ECM2, PSTAR, AAA
      _RL U1, V1

      _RL COR_ICE    (1-OLx:sNx+OLx,1-OLy:sNy+OLy,  nSx,nSy)

C--   FIRST SET UP BASIC CONSTANTS
      RHOICE=SEAICE_rhoIce
      RHOAIR=SEAICE_rhoAir
      ECCEN=SEAICE_eccen
      ECM2=ONE/(ECCEN**2)
      PSTAR=SEAICE_strength

C--   introduce turning angle (default is zero)
      SINWIN=SIN(SEAICE_airTurnAngle*deg2rad)
      COSWIN=COS(SEAICE_airTurnAngle*deg2rad)

C--   Compute proxy for geostrophic velocity,
      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        DO j=0,sNy+1
         DO i=0,sNx+1
          GWATX(i,j,bi,bj)=HALF*(uVel(i,j,KGEO(i,j,bi,bj),bi,bj)
     &                         +uVel(i,j-1,KGEO(i,j,bi,bj),bi,bj))
          GWATY(i,j,bi,bj)=HALF*(vVel(i,j,KGEO(i,j,bi,bj),bi,bj)
     &                         +vVel(i-1,j,KGEO(i,j,bi,bj),bi,bj))
#ifdef SEAICE_DEBUG
c          write(*,'(2i4,2i2,f7.1,7f12.3)')
c     &     ,i,j,bi,bj,UVM(I,J,bi,bj)
c     &     ,GWATX(I,J,bi,bj),GWATY(I,J,bi,bj)
c     &     ,uVel(i+1,j,3,bi,bj),uVel(i+1,j+1,3,bi,bj)
c     &     ,vVel(i,j+1,3,bi,bj),vVel(i+1,j+1,3,bi,bj)
#endif
         ENDDO
        ENDDO
       ENDDO
      ENDDO

C--   NOW SET UP MASS PER UNIT AREA AND CORIOLIS TERM
      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          COR_ICE(i,j,bi,bj) = 0.
         ENDDO
        ENDDO
        DO j=1,sNy
         DO i=1,sNx
          AMASS(i,j,bi,bj)=RHOICE*QUART*(
     &          HEFF(i,j  ,bi,bj) + HEFF(i-1,j  ,bi,bj)
     &         +HEFF(i,j-1,bi,bj) + HEFF(i-1,j-1,bi,bj) )
          COR_ICE(i,j,bi,bj)=AMASS(i,j,bi,bj) * _fCoriG(i,j,bi,bj)
         ENDDO
        ENDDO
       ENDDO
      ENDDO

C--   NOW SET UP FORCING FIELDS

C--   Wind stress is computed on South-West B-grid U/V
C     locations from wind on tracer locations
      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        DO j=1,sNy
         DO i=1,sNx
          U1=QUART*(UWIND(i-1,j-1,bi,bj)+UWIND(i-1,j,bi,bj)
     &             +UWIND(i  ,j-1,bi,bj)+UWIND(i  ,j,bi,bj))
          V1=QUART*(VWIND(i-1,j-1,bi,bj)+VWIND(i-1,j,bi,bj)
     &             +VWIND(i  ,j-1,bi,bj)+VWIND(i  ,j,bi,bj))
          AAA=U1**2+V1**2
          IF ( AAA .LE. SEAICE_EPS_SQ ) THEN
             AAA=SEAICE_EPS
          ELSE
             AAA=SQRT(AAA)
          ENDIF
C first ocean surface stress
          DAIRN(i,j,bi,bj)=RHOAIR*OCEAN_drag
     &         *(2.70 _d 0+0.142 _d 0*AAA+0.0764 _d 0*AAA*AAA)
          WINDX(i,j,bi,bj)=DAIRN(i,j,bi,bj)*
     &         (COSWIN*U1-SIGN(SINWIN, _fCori(i,j,bi,bj))*V1)
          WINDY(i,j,bi,bj)=DAIRN(i,j,bi,bj)*
     &         (SIGN(SINWIN, _fCori(i,j,bi,bj))*U1+COSWIN*V1)

C now ice surface stress
          IF ( YC(i,j,bi,bj) .LT. ZERO ) THEN
           DAIRN(i,j,bi,bj) =
     &          RHOAIR*(SEAICE_drag_south*AAA*AREA(i,j,bi,bj)
     &          +OCEAN_drag*(2.70 _d 0+0.142 _d 0*AAA
     &          +0.0764 _d 0*AAA*AAA)*(ONE-AREA(i,j,bi,bj)))
          ELSE
           DAIRN(i,j,bi,bj) =
     &          RHOAIR*(SEAICE_drag*AAA*AREA(i,j,bi,bj)
     &          +OCEAN_drag*(2.70 _d 0+0.142 _d 0*AAA
     &          +0.0764 _d 0*AAA*AAA)*(ONE-AREA(i,j,bi,bj)))
          ENDIF
          FORCEX(i,j,bi,bj)=DAIRN(i,j,bi,bj)*
     &         (COSWIN*U1-SIGN(SINWIN, _fCori(i,j,bi,bj))*V1)
          FORCEY(i,j,bi,bj)=DAIRN(i,j,bi,bj)*
     &         (SIGN(SINWIN, _fCori(i,j,bi,bj))*U1+COSWIN*V1)
         ENDDO
        ENDDO
       ENDDO
      ENDDO

      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
#ifdef EXPLICIT_SSH_SLOPE
C--   Compute surface pressure at z==0:
C-    use actual sea surface height for tilt computations
        DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
            phiSurf(i,j) = Bo_surf(i,j,bi,bj)*etaN(i,j,bi,bj)
          ENDDO
        ENDDO
#ifdef ATMOSPHERIC_LOADING
C-    add atmospheric loading and Sea-Ice loading
        IF ( useRealFreshWaterFlux ) THEN
          DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
            phiSurf(i,j) = phiSurf(i,j)
     &                   + ( pload(i,j,bi,bj)
     &                      +sIceLoad(i,j,bi,bj)*gravity*sIceLoadFac
     &                     )*recip_rhoConst
           ENDDO
          ENDDO
        ELSE
          DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
            phiSurf(i,j) = phiSurf(i,j)
     &                   + pload(i,j,bi,bj)*recip_rhoConst
           ENDDO
          ENDDO
        ENDIF
#endif /* ATMOSPHERIC_LOADING */
        DO j=1-OLy+1,sNy+OLy
         DO i=1-OLx+1,sNx+OLx
C--   NOW ADD IN TILT
          FORCEX(i,j,bi,bj)=FORCEX(i,j,bi,bj)
     &      -AMASS(i,j,bi,bj)
     &         *( (phiSurf(i, j )-phiSurf(i-1, j ))*SIMaskU(i, j ,bi,bj)
     &           +(phiSurf(i,j-1)-phiSurf(i-1,j-1))*SIMaskV(i,j-1,bi,bj)
     &          )*HALF*_recip_dxV(i,j,bi,bj)
          FORCEY(i,j,bi,bj)=FORCEY(i,j,bi,bj)
     &      -AMASS(i,j,bi,bj)
     &         *( (phiSurf( i ,j)-phiSurf( i ,j-1))*SIMaskV( i ,j,bi,bj)
     &           +(phiSurf(i-1,j)-phiSurf(i-1,j-1))*SIMaskV(i-1,j,bi,bj)
     &          )*HALF*_recip_dyU(i,j,bi,bj)
C NOW KEEP FORCEX0
          FORCEX0(i,j,bi,bj)=FORCEX(i,j,bi,bj)
          FORCEY0(i,j,bi,bj)=FORCEY(i,j,bi,bj)
         ENDDO
        ENDDO
#endif /* EXPLICIT_SSH_SLOPE */
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
#ifndef EXPLICIT_SSH_SLOPE
C--   NOW ADD IN TILT
          FORCEX(i,j,bi,bj)=FORCEX(i,j,bi,bj)
     &         -COR_ICE(i,j,bi,bj)*GWATY(i,j,bi,bj)
          FORCEY(i,j,bi,bj)=FORCEY(i,j,bi,bj)
     &         +COR_ICE(i,j,bi,bj)*GWATX(i,j,bi,bj)
C NOW KEEP FORCEX0
          FORCEX0(i,j,bi,bj)=FORCEX(i,j,bi,bj)
          FORCEY0(i,j,bi,bj)=FORCEY(i,j,bi,bj)
#endif /* EXPLICIT_SSH_SLOPE */
C--   NOW SET UP ICE PRESSURE AND VISCOSITIES
          PRESS0(i,j,bi,bj)=PSTAR*HEFF(i,j,bi,bj)
     &         *EXP(-SEAICE_cStar*(ONE-AREA(i,j,bi,bj)))
CML          SEAICE_zMax(I,J,bi,bj)=(5.0 _d +12/(2.0 _d +04))*PRESS0(I,J,bi,bj)
          SEAICE_zMax(i,j,bi,bj)=SEAICE_zetaMaxFac*PRESS0(i,j,bi,bj)
CML          SEAICE_zMin(I,J,bi,bj)=4.0 _d +08
          SEAICE_zMin(i,j,bi,bj)=SEAICE_zetaMin
          PRESS0(i,j,bi,bj)=PRESS0(i,j,bi,bj)*HEFFM(i,j,bi,bj)
         ENDDO
        ENDDO
       ENDDO
      ENDDO

      IF ( SEAICEuseDYNAMICS ) THEN

#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE uice = comlev1, key=ikey_dynamics
CADJ STORE vice = comlev1, key=ikey_dynamics
#endif /* ALLOW_AUTODIFF_TAMC */

crg what about ETA,ZETA

crg later c$taf loop = iteration uice,vice

cdm c$taf store uice,vice = comlev1_seaice_ds,
cdm c$taf&                key = kii + (ikey_dynamics-1)
C NOW DO PREDICTOR TIME STEP
      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          UICENM1(i,j,bi,bj)=UICE(i,j,bi,bj)
          VICENM1(i,j,bi,bj)=VICE(i,j,bi,bj)
          UICEB(i,j,bi,bj)=UICE(i,j,bi,bj)
          VICEB(i,j,bi,bj)=VICE(i,j,bi,bj)
         ENDDO
        ENDDO
       ENDDO
      ENDDO

C NOW LSR SCHEME (ZHANG-J/HIBLER 1997)
CADJ STORE uice = comlev1, key=ikey_dynamics
CADJ STORE vice = comlev1, key=ikey_dynamics
      CALL LSR( 1, myThid )
CADJ STORE uice = comlev1, key=ikey_dynamics
CADJ STORE vice = comlev1, key=ikey_dynamics

C NOW DO MODIFIED EULER STEP
      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          UICE(i,j,bi,bj)=HALF*(UICE(i,j,bi,bj)+UICENM1(i,j,bi,bj))
          VICE(i,j,bi,bj)=HALF*(VICE(i,j,bi,bj)+VICENM1(i,j,bi,bj))
          UICEB(i,j,bi,bj)=UICE(i,j,bi,bj)
          VICEB(i,j,bi,bj)=VICE(i,j,bi,bj)
         ENDDO
        ENDDO
       ENDDO
      ENDDO

C NOW LSR SCHEME (ZHANG-J/HIBLER 1997)
      CALL LSR( 2, myThid )

cdm c$taf store uice,vice = comlev1, key=ikey_dynamics

      ENDIF

#ifdef ALLOW_DIAGNOSTICS
      IF ( useDiagnostics ) THEN
       CALL DIAGNOSTICS_FILL(zeta   ,'SIzeta  ',0,1 ,0,1,1,myThid)
       CALL DIAGNOSTICS_FILL(eta    ,'SIeta   ',0,1 ,0,1,1,myThid)
       CALL DIAGNOSTICS_FILL(press  ,'SIpress ',0,1 ,0,1,1,myThid)
      ENDIF
#endif /* ALLOW_DIAGNOSTICS */

C Calculate ocean surface stress
      CALL OSTRES ( COR_ICE, myThid )

#ifdef SEAICE_ALLOW_CLIPVELS
      IF ( SEAICEuseDYNAMICS .AND. SEAICE_clipVelocities) THEN
#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE uice = comlev1, key=ikey_dynamics
CADJ STORE vice = comlev1, key=ikey_dynamics
#endif /* ALLOW_AUTODIFF_TAMC */
c Put a cap on ice velocity
c limit velocity to 0.40 m s-1 to avoid potential CFL violations
c in open water areas (drift of zero thickness ice)
      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
#ifdef SEAICE_DEBUG
c          write(*,'(2i4,2i2,f7.1,7f12.3)')
c     &      i,j,bi,bj,UVM(I,J,bi,bj),amass(i,j,bi,bj)
c     &     ,gwatx(I,J,bi,bj),gwaty(i,j,bi,bj)
c     &     ,forcex(I,J,bi,bj),forcey(i,j,bi,bj)
c     &     ,uice(i,j,bi,bj)
c     &     ,vice(i,j,bi,bj)
#endif /* SEAICE_DEBUG */
          UICE(i,j,bi,bj)=min(UICE(i,j,bi,bj),0.40 _d +00)
          VICE(i,j,bi,bj)=min(VICE(i,j,bi,bj),0.40 _d +00)
         ENDDO
        ENDDO
       ENDDO
      ENDDO
#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE uice = comlev1, key=ikey_dynamics
CADJ STORE vice = comlev1, key=ikey_dynamics
#endif /* ALLOW_AUTODIFF_TAMC */
      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          UICE(i,j,bi,bj)=max(UICE(i,j,bi,bj),-0.40 _d +00)
          VICE(i,j,bi,bj)=max(VICE(i,j,bi,bj),-0.40 _d +00)
         ENDDO
        ENDDO
       ENDDO
      ENDDO

      ENDIF
#endif /* SEAICE_ALLOW_CLIPVELS */
#endif /* SEAICE_BGRID_DYNAMICS */

      RETURN
      END

#include "ECCO_OPTIONS.h"

      subroutine cost_bp_read(
     I localobsfile, localstartdate,
     O localobs, localmask,
     I irec, myThid )

c     ==================================================================
c     SUBROUTINE cost_bp_read
c     ==================================================================
c
c     o Read a given record of the GRACE data.
c
c     started: Gael Forget Oct-2009
c
c     ==================================================================
c     SUBROUTINE cost_bp_read
c     ==================================================================

      implicit none

c     == global variables ==

#include "EEPARAMS.h"
#include "SIZE.h"
#include "PARAMS.h"
#include "GRID.h"

#ifdef ALLOW_CAL
# include "cal.h"
#endif
#ifdef ALLOW_ECCO
# include "ECCO_SIZE.h"
# include "ECCO.h"
#endif

c     == routine arguments ==
      character*(MAX_LEN_FNAM) localobsfile
      integer localstartdate(4)
      _RL localobs   (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL localmask  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      integer irec
      integer myThid

#ifdef ALLOW_ECCO
c     == external functions ==
      integer  ilnblnk
      external ilnblnk

c     == local variables ==
      integer bi,bj
      integer i,j,k
      integer jmin,jmax
      integer imin,imax
      integer nobs
      INTEGER beginlocal, beginmodel, obsrec
      _RL spval
cnew(
      integer  il
      integer mody, modm
      integer iyear, imonth
      character*(MAX_LEN_FNAM) fnametmp
      logical exst
cnew)

c     == end of interface ==

      parameter (spval = -998. )
ce    --> there is certainly a better place for this.

      jmin = 1
      jmax = sNy
      imin = 1
      imax = sNx

       beginlocal = localstartdate(1)/10000
       beginmodel = modelstartdate(1)/10000
       obsrec =  ( beginmodel - beginlocal )*nmonthyear
     &         + ( mod(modelstartdate(1)/100,100)
     &            -mod(localstartdate(1)/100,100) )
     &         + irec

      mody = modelstartdate(1)/10000
      modm = modelstartdate(1)/100 - mody*100
      iyear = mody + INT((modm-1+irec-1)/12)
      imonth = 1 + MOD(modm-1+irec-1,12)

      il=ilnblnk(localobsfile)
      write(fnametmp,'(2a,i4)')
     &     localobsfile(1:il), '_', iyear
      inquire( file=fnametmp, exist=exst )
      if (.NOT. exst) then
         write(fnametmp,'(a)') localobsfile(1:il)
         imonth = obsrec
      endif

      if ( (obsrec.GT.0).AND.(imonth.GT.0) ) then
       CALL READ_REC_3D_RL( fnametmp, cost_iprec, 1,
     &                      localobs, imonth, 0, myThid )
      else
        do bj = myByLo(myThid), myByHi(myThid)
         do bi = myBxLo(myThid), myBxHi(myThid)
          do j = jmin,jmax
           do i = imin,imax
            localobs(i,j,bi,bj) = spval
           enddo
          enddo
         enddo
        enddo
      endif

      nobs = 0

      do bj = myByLo(myThid), myByHi(myThid)
        do bi = myBxLo(myThid), myBxHi(myThid)
          k = 1
          do j = jmin,jmax
            do i = imin,imax
c              if (maskC(i,j,k,bi,bj) .eq. 0.) then
c                localmask(i,j,bi,bj) = 0. _d 0
c              else
c                localmask(i,j,bi,bj) = 1. _d 0
c              endif
              if (localobs(i,j,bi,bj) .le. spval) then
                localmask(i,j,bi,bj) = 0. _d 0
              else
                localmask(i,j,bi,bj) = 1. _d 0
              endif
              localobs(i,j,bi,bj) = localobs(i,j,bi,bj)*
     &                              localmask(i,j,bi,bj)
              nobs = nobs + int(localmask(i,j,bi,bj))
            enddo
          enddo
        enddo
      enddo

#endif

      RETURN
      END

#include "OBCS_OPTIONS.h"

CBOP
C     !ROUTINE: OBCS_APPLY_ETA
C     !INTERFACE:
      SUBROUTINE OBCS_APPLY_ETA( bi, bj,
     U                           etaFld,
     I                           myThid )

C     !DESCRIPTION:
C     *==========================================================*
C     | S/R OBCS_APPLY_ETA
C     |   Apply surface position anomaly (Eta) OB values
C     |   to corresponding field array
C     *==========================================================*

C     !USES:
      IMPLICIT NONE
C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "SURFACE.h"
#include "OBCS_PARAMS.h"
#include "OBCS_GRID.h"
#include "OBCS_FIELDS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine Arguments ==
C    bi, bj   :: indices of current tile
C    etaFld   :: surface r-position anomaly field
C    myThid   :: my Thread Id number
      INTEGER bi, bj
      _RL etaFld(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      INTEGER myThid
CEOP

#ifdef NONLIN_FRSURF
C     !LOCAL VARIABLES:
C     == Local variables ==
      INTEGER i, j
      INTEGER Iobc, Jobc

c     IF ( nonlinFreeSurf.GT.0 ) THEN

C     Set model variable to OB values on North/South Boundaries
        IF ( tileHasOBN(bi,bj) ) THEN
C Northern boundary
         DO i=1-OLx,sNx+OLx
          Jobc = OB_Jn(i,bi,bj)
          IF ( Jobc.NE.OB_indexNone ) THEN
            IF ( kSurfS(i,Jobc,bi,bj).LE.Nr )
     &        etaFld(i,Jobc,bi,bj) = OBNeta(i,bi,bj)
          ENDIF
         ENDDO
        ENDIF
        IF ( tileHasOBS(bi,bj) ) THEN
C Southern boundary
         DO i=1-OLx,sNx+OLx
          Jobc = OB_Js(i,bi,bj)
          IF ( Jobc.NE.OB_indexNone ) THEN
            IF ( kSurfS(i,Jobc+1,bi,bj).LE.Nr )
     &        etaFld(i,Jobc,bi,bj) = OBSeta(i,bi,bj)
          ENDIF
         ENDDO
        ENDIF

C     Set model variables to OB values on East/West Boundaries
        IF ( tileHasOBE(bi,bj) ) THEN
C Eastern boundary
         DO j=1-OLy,sNy+OLy
          Iobc = OB_Ie(j,bi,bj)
          IF ( Iobc.NE.OB_indexNone ) THEN
            IF ( kSurfW(Iobc,j,bi,bj).LE.Nr )
     &        etaFld(Iobc,j,bi,bj) = OBEeta(j,bi,bj)
          ENDIF
         ENDDO
        ENDIF
        IF ( tileHasOBW(bi,bj) ) THEN
C Western boundary
         DO j=1-OLy,sNy+OLy
          Iobc = OB_Iw(j,bi,bj)
          IF ( Iobc.NE.OB_indexNone ) THEN
            IF ( kSurfW(Iobc+1,j,bi,bj).LE.Nr )
     &        etaFld(Iobc,j,bi,bj) = OBWeta(j,bi,bj)
          ENDIF
         ENDDO
        ENDIF

c     ENDIF
#endif /* NONLIN_FRSURF */

      RETURN
      END

#include "FLT_OPTIONS.h"

      SUBROUTINE FLT_INIT_VARIA ( myThid  )

C     ==================================================================
C     SUBROUTINE FLT_INIT_VARIA
C     ==================================================================
C     o This routine initializes the start/restart positions.
C     o Either read initial position from file "flt_file" or
C       read pickup file. The 2 type of files are similar, except
C       initial positions are given on grid-coordinate (distance/degree
C       depending on the grid) whereas in pickup file, positions are
C       fractional indices along the grid and local to the tile.
C       For this reason global pickup file is not supported.
C       Initialisation:
C     o First it check for global file, and when found, reads the global file
C       (that has the same format as local files) and sorts those floats
C       that exist on the specific tile into the local array.
C     o If no global file is available or in a case of a restart (pickup
C       file from a previous integration) then read tiled file without
C       any further check (because they exist on the specific tile).
C     ==================================================================

C     !USES:
      IMPLICIT NONE

#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "FLT_SIZE.h"
#include "FLT.h"

C     == routine arguments ==
C     myThid - thread number for this instance of the routine.
      INTEGER myThid

C     == Functions ==
      INTEGER  ILNBLNK
      EXTERNAL ILNBLNK
      _RL      FLT_MAP_R2K
      EXTERNAL FLT_MAP_R2K

C     == local variables ==
      INTEGER bi, bj
      INTEGER ip, iL
      INTEGER imax
      PARAMETER(imax=9)
      _RL tmp(imax)
      _RS dummyRS(1)
      _RL ix, jy, kz
      _RL iLo, iHi, jLo, jHi
      INTEGER fp, ioUnit
      CHARACTER*(MAX_LEN_FNAM) fn
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      CHARACTER*(10) suff

C     number of active record in the file (might be lower than the
C     total number of records because the tile could have contained
C     more floats at an earlier restart
      INTEGER npart_read
      _RL     npart_dist

C     == end of interface ==

C-    Tile boundary on index map:
      iLo = 0.5 _d 0
      iHi = 0.5 _d 0 + DFLOAT(sNx)
      jLo = 0.5 _d 0
      jHi = 0.5 _d 0 + DFLOAT(sNy)

C-    all threads initialise local var:
      npart_read = 0
      npart_dist = 0.

      _BEGIN_MASTER(myThid)

      DO bj = 1,nSy
       DO bi = 1,nSx
        npart_tile(bi,bj) = 0
       ENDDO
      ENDDO

C read floats initial condition from file
      IF ( nIter0.EQ.FLT_Iter0 ) THEN
        fn = flt_file
        fp = readBinaryPrec
      ELSEIF ( nIter0.GT.FLT_Iter0 ) THEN
        IF ( pickupSuff .EQ. ' ' ) THEN
          IF ( rwSuffixType.EQ.0 ) THEN
            WRITE(suff,'(I10.10)') nIter0
          ELSE
            CALL RW_GET_SUFFIX( suff, startTime, nIter0, myThid )
          ENDIF
        ELSE
          WRITE(suff,'(A10)') pickupSuff
        ENDIF
        WRITE(fn,'(A,A10)') 'pickup_flt.',suff
        fp = precFloat64
      ELSE
        WRITE(msgBuf,'(2A,I3,A)') 'FLT_INIT_VARIA:',
     &       ' wrong setting of FLT_Iter0 :'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(2A,I3,A)') 'FLT_INIT_VARIA:',
     &       ' nIter0 < FLT_Iter0 not supported'
        CALL PRINT_ERROR( msgBuf, myThid )
        STOP 'ABNORMAL END: S/R FLT_INIT_VARIA'
      ENDIF
      iL = ILNBLNK(fn)
      WRITE(msgBuf,'(2A)')
     &   'FLT_INIT_VARIA: reading Floats from: ', fn(1:iL)
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C--   Initial position: first try to read from a global file.
      ioUnit = -2
      bi = 0
      bj = 0
      IF ( nIter0.EQ.FLT_Iter0 ) THEN
C-    read actual number of floats from file
        CALL MDS_READVEC_LOC( fn, fp, ioUnit,
     &                        'RL', imax, tmp, dummyRS,
     &                        bi, bj, 1, myThid )
      ENDIF

      IF ( ioUnit.GT.0 .AND. mapIniPos2Index ) THEN
C--   Found a global file
        WRITE(msgBuf,'(A,2I4,A,1P2E15.8)')
     &    ' bi,bj=', bi, bj, ' , npart,max_npart=', tmp(1), tmp(6)
        CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                       SQUEEZE_RIGHT, myThid )
        npart_read = NINT(tmp(1))
        max_npart  = tmp(6)
        DO ip=1,npart_read
C-    read individual float position from file
          CALL MDS_READVEC_LOC( fn, fp, ioUnit,
     &                          'RL', imax, tmp, dummyRS,
     &                          bi, bj, ip+1, myThid )
          DO bj = 1,nSy
           DO bi = 1,nSx
C-    For initial condition only, convert coordinates to index map:
            CALL FLT_MAP_XY2IJLOCAL( ix, jy,
     I                               tmp(3), tmp(4),bi,bj,myThid )
            kz = FLT_MAP_R2K( tmp(5), bi, bj, myThid )
C-    Check if float exists on this tile. If not, try next tile
            IF ( ix.GE.iLo .AND. ix.LT.iHi .AND.
     &           jy.GE.jLo .AND. jy.LT.jHi ) THEN
             npart_tile(bi,bj) = npart_tile(bi,bj) + 1
             IF ( npart_tile(bi,bj).LE.max_npart_tile ) THEN

              npart( npart_tile(bi,bj),bi,bj) = tmp(1)
              tstart(npart_tile(bi,bj),bi,bj) = tmp(2)
              ipart( npart_tile(bi,bj),bi,bj) = ix
              jpart( npart_tile(bi,bj),bi,bj) = jy
              kpart( npart_tile(bi,bj),bi,bj) = kz
              kfloat(npart_tile(bi,bj),bi,bj) = tmp(6)
              iup(   npart_tile(bi,bj),bi,bj) = tmp(7)
              itop(  npart_tile(bi,bj),bi,bj) = tmp(8)
              tend(  npart_tile(bi,bj),bi,bj) = tmp(9)

             ENDIF
            ENDIF
C-      end bi,bj loops
           ENDDO
          ENDDO

        ENDDO
        CLOSE( ioUnit )

      ELSEIF ( ioUnit.GT.0 ) THEN
         WRITE(msgBuf,'(2A)') 'FLT_INIT_VARIA:',
     &                ' need mapIniPos2Index=T for global file'
         CALL PRINT_ERROR( msgBuf , myThid)
         STOP 'ABNORMAL END: S/R FLT_INIT_VARIA'

      ELSE
C--   then try to read from a tiled file:

        DO bj = 1,nSy
         DO bi = 1,nSx
           ioUnit = -1
C-    read actual number floats from file
           CALL MDS_READVEC_LOC( fn, fp, ioUnit,
     &                           'RL', imax, tmp, dummyRS,
     &                           bi, bj, 1, myThid )
           WRITE(msgBuf,'(A,2I4,A,1P2E15.8)')
     &     ' bi,bj=', bi, bj, ' , npart,max_npart=', tmp(1), tmp(6)
           CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                         SQUEEZE_RIGHT, myThid )

           npart_tile(bi,bj) = NINT(tmp(1))
           max_npart  = tmp(6)
           npart_read = MIN( npart_tile(bi,bj), max_npart_tile )
           DO ip=1,npart_read
C-    read individual float position from file
             CALL MDS_READVEC_LOC( fn, fp, ioUnit,
     &                             'RL', imax, tmp, dummyRS,
     &                             bi, bj, ip+1, myThid )
             IF ( nIter0.EQ.FLT_Iter0 .AND. mapIniPos2Index ) THEN
C--   For initial condition only, convert coordinates to index map:
              CALL FLT_MAP_XY2IJLOCAL( ix, jy,
     I                                 tmp(3), tmp(4),bi,bj,myThid )
              kz = FLT_MAP_R2K( tmp(5), bi, bj, myThid )
             ELSE
              ix = tmp(3)
              jy = tmp(4)
              kz = tmp(5)
             ENDIF
C     not a global file: assume that all particles from this tiled-file
C     belong to this current tile (=> do not no check)
             npart(ip,bi,bj)  = tmp(1)
             tstart(ip,bi,bj) = tmp(2)
             ipart(ip,bi,bj)  = ix
             jpart(ip,bi,bj)  = jy
             kpart(ip,bi,bj)  = kz
             kfloat(ip,bi,bj) = tmp(6)
             iup(  ip,bi,bj)  = tmp(7)
             itop( ip,bi,bj)  = tmp(8)
             tend( ip,bi,bj)  = tmp(9)
           ENDDO
           CLOSE( ioUnit )
C-      end bi,bj loops
         ENDDO
        ENDDO

C--   end global-file / tiled-file separated treatment
      ENDIF

      DO bj = 1,nSy
       DO bi = 1,nSx
         npart_dist = npart_dist + DBLE(npart_tile(bi,bj))
         IF ( npart_tile(bi,bj).GT.max_npart_tile ) THEN
           WRITE(msgBuf,'(2A,2I4,2(A,I8))') 'FLT_INIT_VARIA:',
     &       ' bi,bj=', bi, bj,
     &       ' npart_tile=', npart_tile(bi,bj),
     &       ' > max_npart_tile=', max_npart_tile
           CALL PRINT_ERROR( msgBuf , myThid)
           STOP 'ABNORMAL END: S/R FLT_INIT_VARIA'
         ENDIF
       ENDDO
      ENDDO
      _END_MASTER( myThid )
      _BARRIER

      _GLOBAL_SUM_RL( npart_dist, myThid )

      _BEGIN_MASTER( myThid )
        WRITE(msgBuf,'(A,2(A,I9))') 'FLT_INIT_VARIA:',
     &          ' max npart=', NINT(max_npart),
     &   ' , sum npart_tile=', NINT(npart_dist)
        CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
        WRITE(msgBuf,'(A)') ' '
        CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
      _END_MASTER( myThid )

C--   Initial call just to check which variables to write
      IF ( flt_int_prof.NE.0. )
     &  CALL FLT_UP( startTime, nIter0, myThid )
      IF ( flt_int_traj.NE.0. )
     &  CALL FLT_TRAJ( startTime, nIter0, myThid )

      RETURN
      END

#include "MONITOR_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: MON_STATS_RS

C     !INTERFACE:
      SUBROUTINE MON_STATS_RS(
     I     myNr, arr,
     O     theMin,theMax,theMean,theSD,
     I     myThid )

C     !DESCRIPTION:
C     Calculate bare statistics of global array ``\_RS arr''.

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"

C     !INPUT PARAMETERS:
      INTEGER myNr
      _RS arr(1-OLx:sNx+OLx,1-OLy:sNy+OLy,myNr,nSx,nSy)
      _RL theMin, theMax, theMean, theSD
      INTEGER myThid
CEOP

C     !LOCAL VARIABLES:
      INTEGER bi,bj,I,J,K
      INTEGER numPnts
      LOGICAL noPnts
      _RL tmpVal,rNumPnts
      _RL theVar
      _RL tileMean(nSx,nSy)
      _RL tileVar (nSx,nSy)
      _RL tileSD  (nSx,nSy)

      theMin = 0.
      theMax = 0.
      theMean= 0.
      theSD  = 0.
      theVar = 0.
      numPnts= 0
      noPnts = .TRUE.

      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        tileMean(bi,bj) = 0.
        tileVar (bi,bj) = 0.
        DO K=1,myNr
         DO J=1,sNy
          DO I=1,sNx
           tmpVal=arr(I,J,K,bi,bj)
c          IF (tmpVal.NE.0. .AND. noPnts) THEN
           IF ( noPnts ) THEN
            theMin = tmpVal
            theMax = tmpVal
            noPnts = .FALSE.
           ENDIF
c          IF (tmpVal.NE.0.) THEN
            theMin = MIN(theMin,tmpVal)
            theMax = MAX(theMax,tmpVal)
            tileMean(bi,bj)=tileMean(bi,bj)+tmpVal
            tileVar (bi,bj)=tileVar (bi,bj)+tmpVal*tmpVal
            numPnts=numPnts+1
c          ENDIF
          ENDDO
         ENDDO
        ENDDO
c       theMean=theMean+tileMean(bi,bj)
c       theVar =theVar +tileVar (bi,bj)
       ENDDO
      ENDDO

c     _GLOBAL_SUM_RL(theMean,myThid)
c     _GLOBAL_SUM_RL(theVar,myThid)
      CALL GLOBAL_SUM_TILE_RL( tileMean, theMean, myThid )
      CALL GLOBAL_SUM_TILE_RL( tileVar , theVar , myThid )
      tmpVal=FLOAT(numPnts)
      _GLOBAL_SUM_RL(tmpVal,myThid)
      numPnts=NINT(tmpVal)

      IF (tmpVal.GT.0.) THEN
       rNumPnts=1. _d 0/tmpVal
       theMean=theMean*rNumPnts
       theVar=theVar*rNumPnts
       IF ( noPnts ) theMin = theMean
       theMin=-theMin
       _GLOBAL_MAX_RL(theMin,myThid)
       theMin=-theMin
       IF ( noPnts ) theMax = theMean
       _GLOBAL_MAX_RL(theMax,myThid)

       DO bj=myByLo(myThid),myByHi(myThid)
        DO bi=myBxLo(myThid),myBxHi(myThid)
         tileSD(bi,bj)=0.
         DO K=1,myNr
          DO J=1,sNy
           DO I=1,sNx
            tmpVal=arr(I,J,K,bi,bj)
c           IF (tmpVal.NE.0.) THEN
             tileSD(bi,bj) = tileSD(bi,bj)
     &                     + (tmpVal-theMean)*(tmpVal-theMean)
c           ENDIF
           ENDDO
          ENDDO
         ENDDO
c        theSD = theSD + tileSD(bi,bj)
        ENDDO
       ENDDO

c      _GLOBAL_SUM_RL(theSD,myThid)
       CALL GLOBAL_SUM_TILE_RL( tileSD, theSD, myThid )

       theSD = SQRT(theSD*rNumPnts)
c      theSD = SQRT(theVar-theMean*theMean)
      ENDIF

      RETURN
      END

#include "CTRL_OPTIONS.h"
#ifdef ALLOW_COST
# include "COST_OPTIONS.h"
#endif
#ifdef ALLOW_ECCO
# include "ECCO_OPTIONS.h"
#endif

      subroutine ctrl_unpack( first, myThid )

c     ==================================================================
c     SUBROUTINE ctrl_unpack
c     ==================================================================
c
c     o Unpack the control vector such that the land points are filled
c       in.
c
c     started: Christian Eckert eckert@mit.edu  10-Mar-2000
c
c     changed: Patrick Heimbach heimbach@mit.edu 06-Jun-2000
c              - Transferred some filename declarations
c                from here to namelist in ctrl_init_fixed
c
c              Patrick Heimbach heimbach@mit.edu 16-Jun-2000
c              - single file name convention with or without
c                ALLOW_ECCO_OPTIMIZATION
C
c              Armin Koehl akoehl@ucsd.edu 05-Dec-2000
c              - single processor reads global parameter file
c               and writes multiple xx* and adxx* files
c
c              G Gebbie gebbie@mit.edu 18-Mar-2003
c              - open boundary packing
c
c              heimbach@mit.edu totally restructured 28-Oct-2003
c
c     ==================================================================
c     SUBROUTINE ctrl_unpack
c     ==================================================================

      IMPLICIT NONE

c     == global variables ==

#include "EEPARAMS.h"
#include "SIZE.h"
#include "PARAMS.h"
#include "GRID.h"

#ifdef ALLOW_CTRL
# include "CTRL_SIZE.h"
# include "CTRL.h"
# include "CTRL_GENARR.h"
# include "OPTIMCYCLE.h"
# include "CTRL_OBCS.h"
#endif
#ifdef ALLOW_COST
# include "cost.h"
#endif

c     == routine arguments ==

      logical first
      integer myThid

#ifndef EXCLUDE_CTRL_PACK
c     == external functions ==

      integer  ilnblnk
      external ilnblnk

c     == local variables ==

      integer k, ivar, iarr
      integer ictrlgrad
      integer cunit
      logical lxxadxx
      CHARACTER*(128) cfile
      integer il, ilDir

C     These are variables needed to read the header, but subsequently
C     they are not used.
      INTEGER maxLocal, numLoc
#ifdef READ_OLD_CTRL_PACK_FILE
      PARAMETER( maxLocal = old_maxcvars )
#else
      PARAMETER( maxLocal = maxcvars )
#endif
      INTEGER file_nvarType
      INTEGER file_nvarLength
      CHARACTER*(10) file_YctrlId
      INTEGER file_OptimCycle
      _RL     file_fc
      INTEGER file_Ig
      INTEGER file_Jg
      INTEGER file_nSx
      INTEGER file_nSy
      INTEGER file_nWetcGlobal(Nr)
      INTEGER file_nWetsGlobal(Nr)
      INTEGER file_nWetwGlobal(Nr)
c     INTEGER file_nWetvGlobal(Nr)
#ifdef ALLOW_SHELFICE
      INTEGER file_nWetiGlobal(Nr)
#endif
      INTEGER file_varIndex(maxLocal)
      INTEGER file_varRecs(maxLocal)
      INTEGER file_varNxMax(maxLocal)
      INTEGER file_varNyMax(maxLocal)
      INTEGER file_varNrMax(maxLocal)
      CHARACTER*(1) file_varGrid(maxLocal)
      CHARACTER*(5) file_varType(maxLocal)

      CHARACTER*(MAX_LEN_FNAM) fname_local(3)
#if ( defined ALLOW_GENARR2D_CONTROL || defined ALLOW_GENTIM2D_CONTROL )
      integer nwettmp(Nr)
      CHARACTER*(9) mskNameForSetUnpack
#endif

#ifdef ALLOW_OBCS
      INTEGER iobcs
#ifdef ALLOW_OBCSN_CONTROL
      INTEGER file_nWetobcsnGlo(Nr,nobcs)
#endif
#ifdef ALLOW_OBCSS_CONTROL
      INTEGER file_nWetobcssGlo(Nr,nobcs)
#endif
#ifdef ALLOW_OBCSW_CONTROL
      INTEGER file_nWetobcswGlo(Nr,nobcs)
#endif
#ifdef ALLOW_OBCSE_CONTROL
      INTEGER file_nWetobcseGlo(Nr,nobcs)
#endif
#endif /* ALLOW_OBCS */

c     == end of interface ==

c--   Initialise
      nbuffGlobal = 0
      DO k = 1, Nr
       file_nWetcGlobal(k) = 0
       file_nWetsGlobal(k) = 0
       file_nWetwGlobal(k) = 0
c      file_nWetvGlobal(k) = 0
      ENDDO
      DO ivar = 1, maxLocal
       file_varIndex(ivar) = 0
       file_varRecs(ivar)  = 0
       file_varNxMax(ivar) = 0
       file_varNyMax(ivar) = 0
       file_varNrMax(ivar) = 0
       file_varGrid(ivar)  = ' '
       file_varType(ivar)  = '     '
      ENDDO

c--   Find ctrlDir (w/o trailing blanks) length
      ilDir = ilnblnk(ctrlDir)

c--   Only the master thread will do I/O.
      _BEGIN_MASTER( myThid )

c *********************************************************************

      if ( first ) then
c     >>> Initialise control vector for optimcycle=0 <<<
          lxxadxx   = .TRUE.
          ictrlgrad = 1
          write(cfile(1:128),'(4a,i4.4)')
     &         ctrlname(1:9),'_',yctrlid(1:10),
     &         yctrlposunpack(1:4), optimcycle
          write(standardMessageUnit,*) 'ph-pack: unpacking ',
     &         ctrlname(1:9)
      else
c     >>> Write gradient vector <<<
          lxxadxx   = .FALSE.
          ictrlgrad = 2
          write(cfile(1:128),'(4a,i4.4)')
     &         costname(1:9),'_',yctrlid(1:10),
     &         yctrlposunpack(1:4), optimcycle
          write(standardMessageUnit,*) 'ph-pack: unpacking ',
     &         costname(1:9)
       endif

c--   Only Proc 0 will do I/O.
      IF ( myProcId .eq. 0 ) THEN

          call mdsfindunit( cunit, myThid )

#ifndef ALLOW_ADMTLM

          open( cunit, file = cfile,
     &          status = 'old',
     &          form   = 'unformatted',
     &          access = 'sequential' )

c--       Header information.
          read(cunit)  file_nvarType
          read(cunit)  file_nvarLength
          read(cunit)  file_YctrlId
          read(cunit)  file_OptimCycle
          read(cunit)  file_fc
          read(cunit)  file_Ig
          read(cunit)  file_Jg
          read(cunit)  file_nSx
          read(cunit)  file_nSy
          read(cunit) (file_nWetcGlobal(k), k=1,Nr)
          read(cunit) (file_nWetsGlobal(k), k=1,Nr)
          read(cunit) (file_nWetwGlobal(k), k=1,Nr)
c#ifdef ALLOW_CTRL_WETV
c         read(cunit) (file_nWetvGlobal(k), k=1,Nr)
c#endif
#ifdef ALLOW_SHELFICE
          read(cunit) (file_nWetiGlobal(k), k=1,Nr)
c         read(cunit)  file_nWetiGlobal(1)
#endif

#ifdef ALLOW_OBCS
cgg(     Add OBCS mask information to the header.
#ifdef ALLOW_OBCSN_CONTROL
          read(cunit) ((file_nWetobcsnGlo(k,iobcs),
     &         k=1,Nr), iobcs= 1,nobcs)
#endif
#ifdef ALLOW_OBCSS_CONTROL
          read(cunit) ((file_nWetobcssGlo(k,iobcs),
     &         k=1,Nr), iobcs= 1,nobcs)
#endif
#ifdef ALLOW_OBCSW_CONTROL
          read(cunit) ((file_nWetobcswGlo(k,iobcs),
     &         k=1,Nr), iobcs= 1,nobcs)
#endif
#ifdef ALLOW_OBCSE_CONTROL
          read(cunit) ((file_nWetobcseGlo(k,iobcs),
     &         k=1,Nr), iobcs= 1,nobcs)
#endif
cgg)
#endif /* ALLOW_OBCS */

C--       Check file header info.

          if ( file_nvarType .NE. nvartype ) then
             print *, 'ERROR: wrong nvartype ',
     &            file_nvarType, nvartype
             STOP 'in S/R ctrl_unpack'
          endif
          if ( file_nvarLength .NE. nvarlength ) then
             print *, 'WARNING: wrong nvarlength ',
     &            file_nvarLength, nvarlength
             STOP 'in S/R ctrl_unpack'
          elseif ( file_nSx .NE. nSx .OR. file_nSy .NE. nSy ) then
             print *, 'WARNING: wrong nSx or nSy ',
     &            file_nSx, nSx, file_nSy, nSy
             STOP 'in S/R ctrl_unpack'
          endif
          do k = 1, Nr
             if ( file_nWetcGlobal(k) .NE. nWetcGlobal(k) .OR.
c    &            file_nWetvGlobal(k) .NE. nWetvGlobal(k) .OR.
     &            file_nWetsGlobal(k) .NE. nWetsGlobal(k) .OR.
     &            file_nWetwGlobal(k) .NE. nWetwGlobal(k)  ) then
                print *, 'WARNING: wrong nWet?Global for k = ', k
                print *, 'c', file_nWetcGlobal(k), nWetcGlobal(k)
                print *, 's', file_nWetsGlobal(k), nWetsGlobal(k)
                print *, 'w', file_nWetwGlobal(k), nWetwGlobal(k)
c               print *, 'v', file_nWetvGlobal(k), nWetvGlobal(k)
                STOP
             endif
          end do
#ifdef ALLOW_SHELFICE
          do k=1,1
           if ( file_nWetiGlobal(k) .NE. nWetiGlobal(k) ) then
            print *, 'WARNING: wrong nWetiGlobal for k = ', k
            STOP
           endif
          enddo
#endif /* ALLOW_SHELFICE */

#ifdef ALLOW_OBCS
cgg(   Lets also check the OBCS mask info in the header.
#ifdef ALLOW_OBCSN_CONTROL
       do iobcs = 1, nobcs
         do k = 1, Nr
           if (file_nWetobcsnGlo(k,iobcs) .NE.
     &           nWetobcsnGlo(k,iobcs)) then
             print *, 'WARNING: OBCSN wrong nWet?Global for k = ', k
             STOP
           endif
         end do
       end do
#endif
#ifdef ALLOW_OBCSS_CONTROL
       do iobcs = 1, nobcs
         do k = 1, Nr
           if (file_nWetobcssGlo(k,iobcs) .NE.
     &           nWetobcssGlo(k,iobcs)) then
             print *, 'WARNING: OBCSS wrong nWet?Global for k = ', k
             STOP
           endif
         end do
       end do
#endif
#ifdef ALLOW_OBCSW_CONTROL
       do iobcs = 1, nobcs
         do k = 1, Nr
           if (file_nWetobcswGlo(k,iobcs) .NE.
     &           nWetobcswGlo(k,iobcs)) then
             print *, 'WARNING: OBCSW wrong nWet?Global for k = ', k
             STOP
           endif
         end do
       end do
#endif
#ifdef ALLOW_OBCSE_CONTROL
       do iobcs = 1, nobcs
         do k = 1, Nr
           if (file_nWetobcseGlo(k,iobcs) .NE.
     &           nWetobcseGlo(k,iobcs)) then
             print *, 'WARNING: OBCSE wrong nWet?Global for k = ', k
             STOP
           endif
         end do
       end do
#endif
cgg)  End OBCS mask check.
#endif /* ALLOW_OBCS */

C--   Finish to read header information.
          numLoc = nvartype
#ifdef READ_OLD_CTRL_PACK_FILE
          numLoc = maxLocal
#endif
          read(cunit) ( file_varIndex(ivar), ivar=1,numLoc )
          read(cunit) ( file_varRecs(ivar),  ivar=1,numLoc )
          read(cunit) ( file_varNxMax(ivar), ivar=1,numLoc )
          read(cunit) ( file_varNyMax(ivar), ivar=1,numLoc )
          read(cunit) ( file_varNrMax(ivar), ivar=1,numLoc )
          read(cunit) ( file_varGrid(ivar),  ivar=1,numLoc )
#ifdef READ_OLD_CTRL_PACK_FILE
          read(cunit)
          CALL CTRL_CONVERT_HEADER(
     I              maxLocal, file_nvarType, errorMessageUnit,
     U              file_varIndex, file_varRecs,
     U              file_varNxMax, file_varNyMax, file_varNrMax,
     U              file_varGrid, file_varType,
     I              myThid )
#else
          read(cunit) ( file_varType(ivar),  ivar=1,numLoc )
#endif

#endif /* ndef ALLOW_ADMTLM */

#ifdef ALLOW_PACKUNPACK_METHOD2
      ENDIF
      _END_MASTER( myThid )
      _BARRIER
#endif

c----------------------------------------------------------------------

c     do ivar = 1, maxcvars
      do ivar = 1, nvartype
       if ( ncvarindex(ivar) .GE. 0 ) THEN
        il = ilnblnk(ncvarfname(ivar))
        iarr = ncvarindex(ivar)
        call ctrl_set_fname(ctrlDir(1:ilDir)//ncvarfname(ivar),
     &                      fname_local, myThid )
        if ( ncvargrd(ivar).EQ.'m' ) then
#ifdef ALLOW_OBCS
         if ( iarr.EQ.1 ) then
# ifdef ALLOW_OBCSN_CONTROL
          call ctrl_set_unpack_xz( cunit, ivar, fname_local(ictrlgrad),
     &            'maskobcsn', 'wobcsn', wobcsn, nWetobcsnGlo, myThid )
# endif
         elseif ( iarr.EQ.2 ) then
# ifdef ALLOW_OBCSS_CONTROL
          call ctrl_set_unpack_xz( cunit, ivar, fname_local(ictrlgrad),
     &            'maskobcss', 'wobcss', wobcss, nWetobcssGlo, myThid )
# endif
         elseif ( iarr.EQ.3 ) then
# ifdef ALLOW_OBCSE_CONTROL
          call ctrl_set_unpack_yz( cunit, ivar, fname_local(ictrlgrad),
     &            'maskobcse', 'wobcse', wobcse, nWetobcseGlo, myThid )
# endif
         elseif ( iarr.EQ.4 ) then
# ifdef ALLOW_OBCSW_CONTROL
          call ctrl_set_unpack_yz( cunit, ivar, fname_local(ictrlgrad),
     &            'maskobcsw', 'wobcsw', wobcsw, nWetobcswGlo, myThid )
# endif
         endif
#endif /* ALLOW_OBCS */

#ifdef ALLOW_GENARR2D_CONTROL
        elseif ( ncvartype(ivar).EQ.'Arr2D' ) then
         if ( xx_genarr2d_weight(iarr).NE.' ') then
          mskNameForSetUnpack='maskCtrlC'
          DO k=1,Nr
           nwettmp(k) = nwetcglobal(k)
          ENDDO
# ifdef ALLOW_SHELFICE
          if ( ncvargrd(ivar).EQ.'i' ) then
           mskNameForSetUnpack='maskCtrlI'
           DO k=1,Nr
            nwettmp(k) = nwetiglobal(k)
           ENDDO
          endif
# endif
          call ctrl_set_unpack_xy(
     &         lxxadxx, cunit, ivar, genarr2dPrecond(iarr),
     &         fname_local(ictrlgrad), mskNameForSetUnpack,
     &         xx_genarr2d_weight(iarr),
     &         nwettmp, myThid )
         endif
#endif /* ALLOW_GENARR2D_CONTROL */

#ifdef ALLOW_GENARR3D_CONTROL
        elseif ( ncvartype(ivar).EQ.'Arr3D' ) then
         if ( xx_genarr3d_weight(iarr).NE.' ') then
          call ctrl_set_unpack_xyz( lxxadxx, cunit, ivar,
     &         fname_local(ictrlgrad), 'maskCtrlC',
     &         xx_genarr3d_weight(iarr),
     &         wunit, nwetcglobal, myThid )
         endif
#endif /* ALLOW_GENARR3D_CONTROL */

#ifdef ALLOW_GENTIM2D_CONTROL
        elseif ( ncvartype(ivar).EQ.'Tim2D' ) then
         if ( xx_gentim2d_weight(iarr).NE.' ') then
          mskNameForSetUnpack='maskCtrlC'
          DO k=1,Nr
           nwettmp(k) = nwetcglobal(k)
          ENDDO
# ifdef ALLOW_SHELFICE
          if ( ncvargrd(ivar).EQ.'i' ) then
           mskNameForSetUnpack='maskCtrlI'
           DO k=1,Nr
            nwettmp(k) = nwetiglobal(k)
           ENDDO
          endif
# endif
          call ctrl_set_unpack_xy(
     &         lxxadxx, cunit, ivar, gentim2dPrecond(iarr),
     &         fname_local(ictrlgrad), mskNameForSetUnpack,
     &         xx_gentim2d_weight(iarr),
     &         nwettmp, myThid )
         endif
#endif /* ALLOW_GENTIM2D_CONTROL */
        endif
C     if ( ncvarindex(ivar) .ge. 0 ) then
       endif
C     do ivar = 1, maxcvars
      enddo

#ifdef ALLOW_PACKUNPACK_METHOD2
      _BEGIN_MASTER( myThid )
      IF ( myProcId .eq. 0 ) THEN
#endif

      close ( cunit )
      ENDIF !IF ( myProcId .eq. 0 )
      _END_MASTER( myThid )
      _BARRIER
#endif /* EXCLUDE_CTRL_PACK */

      RETURN
      END

#include "DIAG_OPTIONS.h"

CBOP
C     !ROUTINE: DIAGNOSTICS_FILL_STATE
C     !INTERFACE:
      SUBROUTINE DIAGNOSTICS_FILL_STATE( selectVars, myIter, myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE DIAGNOSTICS_FILL_STATE
C     | o Fill-in main code, state-variables diagnostics
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     == Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "SURFACE.h"
#include "DYNVARS.h"
#include "NH_VARS.h"
#ifdef ALLOW_GENERIC_ADVDIFF
# include "GAD.h"
#endif
#ifdef ALLOW_LAYERS
# include "LAYERS_P2SHARE.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     selectVars :: select which group of dianostics variables to fill-in
C            = 1 :: fill-in diagnostics for tracer   variables only
C            = 2 :: fill-in diagnostics for momentum variables only
C            = 3 :: fill-in diagnostics for momentum & tracer variables
C            = 4 :: fill-in state variable tendency diagnostics the second time
C     myIter     :: current Iteration number
C     myThid     :: my Thread Id number
      INTEGER selectVars
      INTEGER myIter
      INTEGER myThid

#ifdef ALLOW_DIAGNOSTICS
C     !LOCAL VARIABLES:
C     == Local variables ==
      LOGICAL  DIAGNOSTICS_IS_ON
      EXTERNAL DIAGNOSTICS_IS_ON
      _RL tmpMk(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      _RL tmp1k(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL tmpU (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL tmpV (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL tmpFac, uBarC, vBarC
#ifdef ALLOW_FIZHI
      _RL dummy1, dummy2, dummy3, dummy4, kappa, getcon
#endif
#ifdef ALLOW_ADAMSBASHFORTH_3
      INTEGER m1
#endif
      INTEGER i,j,k,bi,bj
      INTEGER km1

      IF ( selectVars.EQ.2 .OR. selectVars.EQ.3 ) THEN
C--   fill momentum state-var diagnostics:

        CALL DIAGNOSTICS_FILL(etaN, 'ETAN    ',0, 1,0,1,1,myThid)

        IF ( DIAGNOSTICS_IS_ON('RSURF   ',myThid) ) THEN
         DO bj = myByLo(myThid), myByHi(myThid)
          DO bi = myBxLo(myThid), myBxHi(myThid)
           DO j = 1,sNy
            DO i = 1,sNx
              tmp1k(i,j,bi,bj) = Ro_surf(i,j,bi,bj) + etaH(i,j,bi,bj)
            ENDDO
           ENDDO
          ENDDO
         ENDDO
         CALL DIAGNOSTICS_FILL(tmp1k,'RSURF   ',0,1,0,1,1,myThid)
        ENDIF

        CALL DIAGNOSTICS_SCALE_FILL( etaN, oneRL, 2,
     &                              'ETANSQ  ',0, 1,0,1,1,myThid)
        CALL DIAGNOSTICS_SCALE_FILL( dEtaHdt, oneRL, 2,
     &                              'DETADT2 ',0, 1,0,1,1,myThid)

#ifdef ALLOW_NONHYDROSTATIC
        IF ( use3Dsolver ) THEN
          CALL DIAGNOSTICS_FILL( phi_nh,'PHI_NH  ',0,Nr,0,1,1,myThid )
        ENDIF
#endif

        IF ( nonlinFreeSurf.GT.0 ) THEN
         CALL DIAGNOSTICS_FILL_RS( hFacW,'hFactorW',0,Nr,0,1,1,myThid )
         CALL DIAGNOSTICS_FILL_RS( hFacS,'hFactorS',0,Nr,0,1,1,myThid )
        ENDIF

        CALL DIAGNOSTICS_FILL(uVel, 'UVEL    ',0,Nr,0,1,1,myThid)
        CALL DIAGNOSTICS_FILL(vVel, 'VVEL    ',0,Nr,0,1,1,myThid)
        CALL DIAGNOSTICS_FILL(wVel, 'WVEL    ',0,Nr,0,1,1,myThid)

        CALL DIAGNOSTICS_SCALE_FILL( uVel, oneRL, 2,
     &                              'UVELSQ  ',0,Nr,0,1,1,myThid)
        CALL DIAGNOSTICS_SCALE_FILL( vVel, oneRL, 2,
     &                              'VVELSQ  ',0,Nr,0,1,1,myThid)
        CALL DIAGNOSTICS_SCALE_FILL( wVel, oneRL, 2,
     &                              'WVELSQ  ',0,Nr,0,1,1,myThid)

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

        IF ( DIAGNOSTICS_IS_ON('VSHEARSQ',myThid) ) THEN
         DO bj = myByLo(myThid), myByHi(myThid)
          DO bi = myBxLo(myThid), myBxHi(myThid)
           DO j = 1,sNy
            DO i = 1,sNx
              tmpMk(i,j,1,bi,bj) = 0. _d 0
            ENDDO
           ENDDO
           DO k=2,Nr
            DO j = 1,sNy+1
             DO i = 1,sNx+1
              tmpU(i,j) = ( uVel(i,j,k,bi,bj) - uVel(i,j,k-1,bi,bj) )
c                       * maskW(i,j,k,bi,bj)*maskW(i,j,k-1,bi,bj)
              tmpV(i,j) = ( vVel(i,j,k,bi,bj) - vVel(i,j,k-1,bi,bj) )
c                       * maskS(i,j,k,bi,bj)*maskS(i,j,k-1,bi,bj)
             ENDDO
            ENDDO
            DO j = 1,sNy
             DO i = 1,sNx
              tmpMk(i,j,k,bi,bj) = recip_drC(k)*recip_drC(k)*halfRL
     &           *( ( tmpU(i,j)*tmpU(i,j) + tmpU(i+1,j)*tmpU(i+1,j) )
     &            + ( tmpV(i,j)*tmpV(i,j) + tmpV(i,j+1)*tmpV(i,j+1) )
     &            )
             ENDDO
            ENDDO
           ENDDO
          ENDDO
         ENDDO
         CALL DIAGNOSTICS_FILL(tmpMk,'VSHEARSQ',0,Nr,0,1,1,myThid)
        ENDIF

        IF ( DIAGNOSTICS_IS_ON('UE_VEL_C',myThid) .OR.
     &       DIAGNOSTICS_IS_ON('VN_VEL_C',myThid) .OR.
     &       DIAGNOSTICS_IS_ON('UV_VEL_C',myThid) ) THEN
         DO bj = myByLo(myThid), myByHi(myThid)
          DO bi = myBxLo(myThid), myBxHi(myThid)
           DO k=1,Nr
            DO j = 1,sNy
             DO i = 1,sNx
              uBarC = 0.5 _d 0
     &           *(uVel(i,j,k,bi,bj)+uVel(i+1,j,k,bi,bj))
              vBarC = 0.5 _d 0
     &           *(vVel(i,j,k,bi,bj)+vVel(i,j+1,k,bi,bj))
              tmpU(i,j) = angleCosC(i,j,bi,bj)*uBarC
     &                   -angleSinC(i,j,bi,bj)*vBarC
              tmpV(i,j) = angleSinC(i,j,bi,bj)*uBarC
     &                   +angleCosC(i,j,bi,bj)*vBarC
              tmpMk(i,j,k,bi,bj) = tmpU(i,j)*tmpV(i,j)
             ENDDO
            ENDDO
            CALL DIAGNOSTICS_FILL(tmpU,'UE_VEL_C',k,1,2,bi,bj,myThid)
            CALL DIAGNOSTICS_FILL(tmpV,'VN_VEL_C',k,1,2,bi,bj,myThid)
           ENDDO
          ENDDO
         ENDDO
         CALL DIAGNOSTICS_FILL(tmpMk,'UV_VEL_C',0,Nr,0,1,1,myThid)
        ENDIF

        IF ( DIAGNOSTICS_IS_ON('UV_VEL_Z',myThid) ) THEN
         DO bj = myByLo(myThid), myByHi(myThid)
          DO bi = myBxLo(myThid), myBxHi(myThid)
           DO k=1,Nr
            DO j = 1,sNy+1
             DO i = 1,sNx+1
              tmpMk(i,j,k,bi,bj) = 0.25 _d 0
     &           *(uVel(i,j-1,k,bi,bj)+uVel(i,j,k,bi,bj))
     &           *(vVel(i-1,j,k,bi,bj)+vVel(i,j,k,bi,bj))
             ENDDO
            ENDDO
           ENDDO
          ENDDO
         ENDDO
         CALL DIAGNOSTICS_FILL(tmpMk,'UV_VEL_Z',0,Nr,0,1,1,myThid)
        ENDIF

        IF ( DIAGNOSTICS_IS_ON('WU_VEL  ',myThid) ) THEN
         DO bj = myByLo(myThid), myByHi(myThid)
          DO bi = myBxLo(myThid), myBxHi(myThid)
           DO k=1,Nr
            km1 = MAX(k-1,1)
            DO j = 1,sNy
             DO i = 1,sNx+1
              tmpMk(i,j,k,bi,bj) = 0.25 _d 0
     &           *(uVel(i,j,km1,bi,bj)+uVel(i,j,k,bi,bj))
     &           *(wVel(i-1,j,k,bi,bj)*rA(i-1,j,bi,bj)
     &            +wVel( i ,j,k,bi,bj)*rA( i ,j,bi,bj)
     &            )*recip_rAw(i,j,bi,bj)
             ENDDO
            ENDDO
           ENDDO
          ENDDO
         ENDDO
         CALL DIAGNOSTICS_FILL(tmpMk,'WU_VEL  ',0,Nr,0,1,1,myThid)
        ENDIF

        IF ( DIAGNOSTICS_IS_ON('WV_VEL  ',myThid) ) THEN
         DO bj = myByLo(myThid), myByHi(myThid)
          DO bi = myBxLo(myThid), myBxHi(myThid)
           DO k=1,Nr
            km1 = MAX(k-1,1)
            DO j = 1,sNy+1
             DO i = 1,sNx
              tmpMk(i,j,k,bi,bj) = 0.25 _d 0
     &           *(vVel(i,j,km1,bi,bj)+vVel(i,j,k,bi,bj))
     &           *(wVel(i,j-1,k,bi,bj)*rA(i,j-1,bi,bj)
     &            +wVel(i, j ,k,bi,bj)*rA(i, j ,bi,bj)
     &            )*recip_rAs(i,j,bi,bj)
             ENDDO
            ENDDO
           ENDDO
          ENDDO
         ENDDO
         CALL DIAGNOSTICS_FILL(tmpMk,'WV_VEL  ',0,Nr,0,1,1,myThid)
        ENDIF

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

        IF ( DIAGNOSTICS_IS_ON('UVELTH  ',myThid) ) THEN
         DO bj = myByLo(myThid), myByHi(myThid)
          DO bi = myBxLo(myThid), myBxHi(myThid)
           DO k=1,Nr
            DO j = 1,sNy
             DO i = 1,sNx+1
               tmpMk(i,j,k,bi,bj) = uVel(i,j,k,bi,bj)*0.5 _d 0
     &                  *(theta(i,j,k,bi,bj)+theta(i-1,j,k,bi,bj))
             ENDDO
            ENDDO
           ENDDO
          ENDDO
         ENDDO
         CALL DIAGNOSTICS_FILL(tmpMk,'UVELTH  ',0,Nr,0,1,1,myThid)
        ENDIF

        IF ( DIAGNOSTICS_IS_ON('VVELTH  ',myThid) ) THEN
         DO bj = myByLo(myThid), myByHi(myThid)
          DO bi = myBxLo(myThid), myBxHi(myThid)
           DO k=1,Nr
            DO j = 1,sNy+1
             DO i = 1,sNx
               tmpMk(i,j,k,bi,bj) = vVel(i,j,k,bi,bj)*0.5 _d 0
     &                  *(theta(i,j,k,bi,bj)+theta(i,j-1,k,bi,bj))
             ENDDO
            ENDDO
           ENDDO
          ENDDO
         ENDDO
         CALL DIAGNOSTICS_FILL(tmpMk,'VVELTH  ',0,Nr,0,1,1,myThid)
        ENDIF

        IF ( DIAGNOSTICS_IS_ON('WVELTH  ',myThid) ) THEN
         DO bj = myByLo(myThid), myByHi(myThid)
          DO bi = myBxLo(myThid), myBxHi(myThid)
           DO k=1,Nr
            km1 = MAX(k-1,1)
            DO j = 1,sNy
             DO i = 1,sNx
               tmpMk(i,j,k,bi,bj) = wVel(i,j,k,bi,bj)*0.5 _d 0
     &                  *(theta(i,j,k,bi,bj)+theta(i,j,km1,bi,bj))
             ENDDO
            ENDDO
           ENDDO
          ENDDO
         ENDDO
         CALL DIAGNOSTICS_FILL(tmpMk,'WVELTH  ',0,Nr,0,1,1,myThid)
        ENDIF

        IF ( DIAGNOSTICS_IS_ON('UVELSLT ',myThid) ) THEN
         DO bj = myByLo(myThid), myByHi(myThid)
          DO bi = myBxLo(myThid), myBxHi(myThid)
           DO k=1,Nr
            DO j = 1,sNy
             DO i = 1,sNx+1
               tmpMk(i,j,k,bi,bj) = uVel(i,j,k,bi,bj)*0.5 _d 0
     &                  *(salt(i,j,k,bi,bj)+salt(i-1,j,k,bi,bj))
             ENDDO
            ENDDO
           ENDDO
          ENDDO
         ENDDO
         CALL DIAGNOSTICS_FILL(tmpMk,'UVELSLT ',0,Nr,0,1,1,myThid)
        ENDIF

        IF ( DIAGNOSTICS_IS_ON('VVELSLT ',myThid) ) THEN
         DO bj = myByLo(myThid), myByHi(myThid)
          DO bi = myBxLo(myThid), myBxHi(myThid)
           DO k=1,Nr
            DO j = 1,sNy+1
             DO i = 1,sNx
               tmpMk(i,j,k,bi,bj) = vVel(i,j,k,bi,bj)*0.5 _d 0
     &                  *(salt(i,j,k,bi,bj)+salt(i,j-1,k,bi,bj))
             ENDDO
            ENDDO
           ENDDO
          ENDDO
         ENDDO
         CALL DIAGNOSTICS_FILL(tmpMk,'VVELSLT ',0,Nr,0,1,1,myThid)
        ENDIF

        IF ( DIAGNOSTICS_IS_ON('WVELSLT ',myThid) ) THEN
         DO bj = myByLo(myThid), myByHi(myThid)
          DO bi = myBxLo(myThid), myBxHi(myThid)
           DO k=1,Nr
            km1 = MAX(k-1,1)
            DO j = 1,sNy
             DO i = 1,sNx
               tmpMk(i,j,k,bi,bj) = wVel(i,j,k,bi,bj)*0.5 _d 0
     &                  *(salt(i,j,k,bi,bj)+salt(i,j,km1,bi,bj))
             ENDDO
            ENDDO
           ENDDO
          ENDDO
         ENDDO
         CALL DIAGNOSTICS_FILL(tmpMk,'WVELSLT ',0,Nr,0,1,1,myThid)
        ENDIF

        IF ( DIAGNOSTICS_IS_ON('UVELPHI ',myThid) ) THEN
         DO bj = myByLo(myThid), myByHi(myThid)
          DO bi = myBxLo(myThid), myBxHi(myThid)
           DO k=1,Nr
            DO j = 1,sNy
             DO i = 1,sNx+1
               tmpMk(i,j,k,bi,bj) = uVel(i,j,k,bi,bj)*hFacW(i,j,k,bi,bj)
     &       *0.5 _d 0*(totPhiHyd(i,j,k,bi,bj)+totPhiHyd(i-1,j,k,bi,bj))
             ENDDO
            ENDDO
           ENDDO
          ENDDO
         ENDDO
         CALL DIAGNOSTICS_FILL(tmpMk,'UVELPHI ',0,Nr,0,1,1,myThid)
        ENDIF

        IF ( DIAGNOSTICS_IS_ON('VVELPHI ',myThid) ) THEN
         DO bj = myByLo(myThid), myByHi(myThid)
          DO bi = myBxLo(myThid), myBxHi(myThid)
           DO k=1,Nr
            DO j = 1,sNy+1
             DO i = 1,sNx
               tmpMk(i,j,k,bi,bj) = vVel(i,j,k,bi,bj)*hFacS(i,j,k,bi,bj)
     &       *0.5 _d 0*(totPhiHyd(i,j,k,bi,bj)+totPhiHyd(i,j-1,k,bi,bj))
             ENDDO
            ENDDO
           ENDDO
          ENDDO
         ENDDO
         CALL DIAGNOSTICS_FILL(tmpMk,'VVELPHI ',0,Nr,0,1,1,myThid)
        ENDIF

        IF ( DIAGNOSTICS_IS_ON('RCENTER ',myThid) ) THEN
         DO bj = myByLo(myThid), myByHi(myThid)
          DO bi = myBxLo(myThid), myBxHi(myThid)
           DO j = 1,sNy
            DO i = 1,sNx
              tmp1k(i,j,bi,bj) = R_low(i,j,bi,bj)
            ENDDO
           ENDDO
           DO k = Nr,1,-1
            DO j = 1,sNy
             DO i = 1,sNx
              tmpMk(i,j,k,bi,bj) = tmp1k(i,j,bi,bj)
     &             + (rF(k+1)-rC(k))*hFacC(i,j,k,bi,bj)*rkSign
C         above: more general (setInterFDr/setCenterDr) than line below
c    &                      + drF(k)*hFacC(i,j,k,bi,bj)*0.5 _d 0
              tmp1k(i,j,bi,bj) =   tmp1k(i,j,bi,bj)
     &                      + drF(k)*hFacC(i,j,k,bi,bj)
             ENDDO
            ENDDO
           ENDDO
          ENDDO
         ENDDO
         CALL DIAGNOSTICS_FILL(tmpMk,'RCENTER ',0,Nr,0,1,1,myThid)
        ENDIF

C First fill sequence for state variable tendency diagnostics: subtract state variable
C NOTE: send a '0' for the bibjflag and allow counter to be incremented
C     (next fill for these diagnostics will NOT allow counter to be incremented)

        tmpFac = -86400. _d 0/deltaTMom
        CALL DIAGNOSTICS_SCALE_FILL( uVel, tmpFac, 1,
     &                              'TOTUTEND',0,Nr,0,1,1,myThid )
        CALL DIAGNOSTICS_SCALE_FILL( vVel, tmpFac, 1,
     &                              'TOTVTEND',0,Nr,0,1,1,myThid )

        IF ( DIAGNOSTICS_IS_ON('TOTTTEND',myThid)
#ifdef ALLOW_LAYERS
     &     .OR. layers_useThermo
#endif
     &     ) THEN
         DO bj = myByLo(myThid), myByHi(myThid)
          DO bi = myBxLo(myThid), myBxHi(myThid)
           DO k=1,Nr
            tmpFac = -86400. _d 0/dTtracerLev(k)
            DO j = 1,sNy
             DO i = 1,sNx
               tmpMk(i,j,k,bi,bj) = tmpFac*theta(i,j,k,bi,bj)
             ENDDO
            ENDDO
           ENDDO
          ENDDO
         ENDDO
         CALL DIAGNOSTICS_FILL(tmpMk,'TOTTTEND',0,Nr,0,1,1,myThid)
#ifdef ALLOW_LAYERS
         IF ( layers_useThermo ) THEN
          CALL LAYERS_FILL(tmpMk,1,'TOT',0,Nr,0,1,1,myThid)
         ENDIF
#endif /* ALLOW_LAYERS */
        ENDIF

        IF ( DIAGNOSTICS_IS_ON('TOTSTEND',myThid)
#ifdef ALLOW_LAYERS
     &     .OR. layers_useThermo
#endif
     &     ) THEN
         DO bj = myByLo(myThid), myByHi(myThid)
          DO bi = myBxLo(myThid), myBxHi(myThid)
           DO k=1,Nr
            tmpFac = -86400. _d 0/dTtracerLev(k)
            DO j = 1,sNy
             DO i = 1,sNx
               tmpMk(i,j,k,bi,bj) = tmpFac*salt(i,j,k,bi,bj)
             ENDDO
            ENDDO
           ENDDO
          ENDDO
         ENDDO
         CALL DIAGNOSTICS_FILL(tmpMk,'TOTSTEND',0,Nr,0,1,1,myThid)
#ifdef ALLOW_LAYERS
         IF ( layers_useThermo ) THEN
          CALL LAYERS_FILL(tmpMk,2,'TOT',0,Nr,0,1,1,myThid)
         ENDIF
#endif /* ALLOW_LAYERS */
        ENDIF

C--   fill momentum state-var diagnostics: end
      ENDIF

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      IF ( selectVars.EQ.1 .OR. selectVars.EQ.3 ) THEN
C--   fill tracer state-var diagnostics:

        IF ( nonlinFreeSurf.GT.0 ) THEN
         CALL DIAGNOSTICS_FILL_RS( hFacC,'hFactorC',0,Nr,0,1,1,myThid )
        ENDIF

        CALL DIAGNOSTICS_FILL(theta,'THETA   ',0,Nr,0,1,1,myThid)
        CALL DIAGNOSTICS_FILL(salt, 'SALT    ',0,Nr,0,1,1,myThid)

#ifdef ALLOW_FIZHI
      IF ( useFIZHI .AND. DIAGNOSTICS_IS_ON('RELHUM  ',myThid) ) THEN
       kappa = getcon('KAPPA')
       DO bj = myByLo(myThid), myByHi(myThid)
        DO bi = myBxLo(myThid), myBxHi(myThid)
         DO j = 1,sNy
          DO i = 1,sNx
           DO k = 1,Nr
            dummy1 = theta(i,j,k,bi,bj) * ((rC(k)/100.)/1000.)**kappa
            dummy2 = rC(k) / 100.
            CALL QSAT(dummy1,dummy2,dummy3,dummy4,.false.)
            tmpMk(i,j,k,bi,bj) = hFacC(i,j,k,bi,bj)
     &                          *salt(i,j,k,bi,bj)*100. / dummy3
           ENDDO
          ENDDO
         ENDDO
        ENDDO
       ENDDO
       CALL DIAGNOSTICS_FILL(tmpMk, 'RELHUM  ',0,Nr,0,1,1,myThid)
      ENDIF
#endif /* ALLOW_FIZHI */

        CALL DIAGNOSTICS_SCALE_FILL( theta, oneRL, 2,
     &                              'THETASQ ',0,Nr,0,1,1,myThid)
        CALL DIAGNOSTICS_SCALE_FILL( salt, oneRL, 2,
     &                              'SALTSQ  ',0,Nr,0,1,1,myThid)

#ifdef ALLOW_GENERIC_ADVDIFF
# ifdef ALLOW_ADAMSBASHFORTH_3
      IF ( selectVars.EQ.1 ) THEN
C-    stagger time-step: fill diags after updating myIter
        m1 = 1 + MOD(myIter,2)
      ELSE
C-    synchronous time-step: fill diags before updating myIter
        m1 = 1 + MOD(myIter+1,2)
      ENDIF
      IF ( AdamsBashforthGt )
     & CALL DIAGNOSTICS_FILL( gtNm(1-OLx,1-OLy,1,1,1,m1),
     &                        'gTinAB  ',0,Nr,0,1,1,myThid )
      IF ( AdamsBashforthGs )
     & CALL DIAGNOSTICS_FILL( gsNm(1-OLx,1-OLy,1,1,1,m1),
     &                        'gSinAB  ',0,Nr,0,1,1,myThid )
# else /* ALLOW_ADAMSBASHFORTH_3 */
      IF ( AdamsBashforthGt )
     & CALL DIAGNOSTICS_FILL( gtNm1,'gTinAB  ',0,Nr,0,1,1,myThid )
      IF ( AdamsBashforthGs )
     & CALL DIAGNOSTICS_FILL( gsNm1,'gSinAB  ',0,Nr,0,1,1,myThid )
# endif /* ALLOW_ADAMSBASHFORTH_3 */
#endif /* ALLOW_GENERIC_ADVDIFF */

c       IF ( DIAGNOSTICS_IS_ON('SST     ',myThid) ) THEN
c        DO bj = myByLo(myThid), myByHi(myThid)
c         DO bi = myBxLo(myThid), myBxHi(myThid)
c          DO j = 1,sNy
c           DO i = 1,sNx
c             tmp1k(i,j,bi,bj) = THETA(i,j,1,bi,bj)
c           ENDDO
c          ENDDO
c         ENDDO
c        ENDDO
c        CALL DIAGNOSTICS_FILL(tmp1k,'SST     ',0,1,0,1,1,myThid)
c       ENDIF

c       IF ( DIAGNOSTICS_IS_ON('SSS     ',myThid) ) THEN
c        DO bj = myByLo(myThid), myByHi(myThid)
c         DO bi = myBxLo(myThid), myBxHi(myThid)
c          DO j = 1,sNy
c           DO i = 1,sNx
c             tmp1k(i,j,bi,bj) = SALT(i,j,1,bi,bj)
c           ENDDO
c          ENDDO
c         ENDDO
c        ENDDO
c        CALL DIAGNOSTICS_FILL(tmp1k,'SSS     ',0,1,0,1,1,myThid)
c       ENDIF

        IF ( fluidIsWater .AND.
     &       ( DIAGNOSTICS_IS_ON('SALTanom',myThid)
     &     .OR.DIAGNOSTICS_IS_ON('SALTSQan',myThid) ) ) THEN
         DO bj = myByLo(myThid), myByHi(myThid)
          DO bi = myBxLo(myThid), myBxHi(myThid)
           DO k=1,Nr
            DO j = 1,sNy
             DO i = 1,sNx
               tmpMk(i,j,k,bi,bj) = salt(i,j,k,bi,bj)-35. _d 0
             ENDDO
            ENDDO
           ENDDO
          ENDDO
         ENDDO
         CALL DIAGNOSTICS_FILL( tmpMk,'SALTanom',0,Nr,0,1,1,myThid)
         CALL DIAGNOSTICS_SCALE_FILL( tmpMk, oneRL, 2,
     &                                'SALTSQan',0,Nr,0,1,1,myThid)
        ENDIF

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

        IF ( DIAGNOSTICS_IS_ON('UVELMASS',myThid) ) THEN
         DO bj = myByLo(myThid), myByHi(myThid)
          DO bi = myBxLo(myThid), myBxHi(myThid)
           DO k=1,Nr
            DO j = 1,sNy
              DO i = 1,sNx+1
                tmpMk(i,j,k,bi,bj)
     &               = uVel(i,j,k,bi,bj)*hFacW(i,j,k,bi,bj)
              ENDDO
            ENDDO
           ENDDO
          ENDDO
         ENDDO
         CALL DIAGNOSTICS_FILL(tmpMk,'UVELMASS',0,Nr,0,1,1,myThid)
        ENDIF

        IF ( DIAGNOSTICS_IS_ON('VVELMASS',myThid) ) THEN
         DO bj = myByLo(myThid), myByHi(myThid)
          DO bi = myBxLo(myThid), myBxHi(myThid)
           DO k=1,Nr
            DO j = 1,sNy+1
              DO i = 1,sNx
                tmpMk(i,j,k,bi,bj)
     &               = vVel(i,j,k,bi,bj)*hFacS(i,j,k,bi,bj)
              ENDDO
            ENDDO
           ENDDO
          ENDDO
         ENDDO
         CALL DIAGNOSTICS_FILL(tmpMk,'VVELMASS',0,Nr,0,1,1,myThid)
        ENDIF

        CALL DIAGNOSTICS_FILL(wVel, 'WVELMASS',0,Nr,0,1,1,myThid)

        IF ( DIAGNOSTICS_IS_ON('UTHMASS ',myThid) ) THEN
         DO bj = myByLo(myThid), myByHi(myThid)
          DO bi = myBxLo(myThid), myBxHi(myThid)
           DO k=1,Nr
            DO j = 1,sNy
             DO i = 1,sNx+1
               tmpMk(i,j,k,bi,bj) = uVel(i,j,k,bi,bj)*0.5 _d 0
     &                  *(theta(i,j,k,bi,bj)+theta(i-1,j,k,bi,bj))
     &                  * hFacW(i,j,k,bi,bj)
             ENDDO
            ENDDO
           ENDDO
          ENDDO
         ENDDO
         CALL DIAGNOSTICS_FILL(tmpMk,'UTHMASS ',0,Nr,0,1,1,myThid)
        ENDIF

        IF ( DIAGNOSTICS_IS_ON('VTHMASS ',myThid) ) THEN
         DO bj = myByLo(myThid), myByHi(myThid)
          DO bi = myBxLo(myThid), myBxHi(myThid)
           DO k=1,Nr
            DO j = 1,sNy+1
             DO i = 1,sNx
               tmpMk(i,j,k,bi,bj) = vVel(i,j,k,bi,bj)*0.5 _d 0
     &                  *(theta(i,j,k,bi,bj)+theta(i,j-1,k,bi,bj))
     &                  * hFacS(i,j,k,bi,bj)
             ENDDO
            ENDDO
           ENDDO
          ENDDO
         ENDDO
         CALL DIAGNOSTICS_FILL(tmpMk,'VTHMASS ',0,Nr,0,1,1,myThid)
        ENDIF

        IF ( DIAGNOSTICS_IS_ON('WTHMASS ',myThid) ) THEN
         DO bj = myByLo(myThid), myByHi(myThid)
          DO bi = myBxLo(myThid), myBxHi(myThid)
           DO k=1,Nr
            km1 = MAX(k-1,1)
            DO j = 1,sNy
             DO i = 1,sNx
               tmpMk(i,j,k,bi,bj) = wVel(i,j,k,bi,bj)*0.5 _d 0
     &                  *(theta(i,j,k,bi,bj)+theta(i,j,km1,bi,bj))
             ENDDO
            ENDDO
           ENDDO
          ENDDO
         ENDDO
         CALL DIAGNOSTICS_FILL(tmpMk,'WTHMASS ',0,Nr,0,1,1,myThid)
        ENDIF

        IF ( DIAGNOSTICS_IS_ON('USLTMASS',myThid) ) THEN
         DO bj = myByLo(myThid), myByHi(myThid)
          DO bi = myBxLo(myThid), myBxHi(myThid)
           DO k=1,Nr
            DO j = 1,sNy
             DO i = 1,sNx+1
               tmpMk(i,j,k,bi,bj) = uVel(i,j,k,bi,bj)*0.5 _d 0
     &                  *(salt(i,j,k,bi,bj)+salt(i-1,j,k,bi,bj))
     &                  * hFacW(i,j,k,bi,bj)
             ENDDO
            ENDDO
           ENDDO
          ENDDO
         ENDDO
         CALL DIAGNOSTICS_FILL(tmpMk,'USLTMASS',0,Nr,0,1,1,myThid)
        ENDIF

        IF ( DIAGNOSTICS_IS_ON('VSLTMASS',myThid) ) THEN
         DO bj = myByLo(myThid), myByHi(myThid)
          DO bi = myBxLo(myThid), myBxHi(myThid)
           DO k=1,Nr
            DO j = 1,sNy+1
             DO i = 1,sNx
               tmpMk(i,j,k,bi,bj) = vVel(i,j,k,bi,bj)*0.5 _d 0
     &                  *(salt(i,j,k,bi,bj)+salt(i,j-1,k,bi,bj))
     &                  * hFacS(i,j,k,bi,bj)
             ENDDO
            ENDDO
           ENDDO
          ENDDO
         ENDDO
         CALL DIAGNOSTICS_FILL(tmpMk,'VSLTMASS',0,Nr,0,1,1,myThid)
        ENDIF

        IF ( DIAGNOSTICS_IS_ON('WSLTMASS',myThid) ) THEN
         DO bj = myByLo(myThid), myByHi(myThid)
          DO bi = myBxLo(myThid), myBxHi(myThid)
           DO k=1,Nr
            km1 = MAX(k-1,1)
            DO j = 1,sNy
             DO i = 1,sNx
               tmpMk(i,j,k,bi,bj) = wVel(i,j,k,bi,bj)*0.5 _d 0
     &                  *(salt(i,j,k,bi,bj)+salt(i,j,km1,bi,bj))
             ENDDO
            ENDDO
           ENDDO
          ENDDO
         ENDDO
         CALL DIAGNOSTICS_FILL(tmpMk,'WSLTMASS',0,Nr,0,1,1,myThid)
        ENDIF

C--   fill tracer state-var diagnostics: end
      ENDIF

      IF ( selectVars.EQ.4 ) THEN
C Second fill sequence for state variable tendency diagnostics: add state variable
C NOTE: send a '-1' for the bibjflag and do not increment counter
C     (previous fill for these diagnostics DID allow counter to be incremented)

        tmpFac = 86400. _d 0/deltaTMom
        DO bj = myByLo(myThid), myByHi(myThid)
         DO bi = myBxLo(myThid), myBxHi(myThid)
          CALL DIAGNOSTICS_SCALE_FILL( uVel, tmpFac, 1,
     &                           'TOTUTEND',0,Nr,-1,bi,bj,myThid )
          CALL DIAGNOSTICS_SCALE_FILL( vVel, tmpFac, 1,
     &                           'TOTVTEND',0,Nr,-1,bi,bj,myThid )
         ENDDO
        ENDDO

        IF ( DIAGNOSTICS_IS_ON('TOTTTEND',myThid)
#ifdef ALLOW_LAYERS
     &     .OR. layers_useThermo
#endif
     &     ) THEN
         DO bj = myByLo(myThid), myByHi(myThid)
          DO bi = myBxLo(myThid), myBxHi(myThid)
           DO k=1,Nr
            tmpFac = 86400. _d 0/dTtracerLev(k)
            DO j = 1,sNy
             DO i = 1,sNx
               tmpMk(i,j,k,bi,bj) = tmpFac*theta(i,j,k,bi,bj)
             ENDDO
            ENDDO
           ENDDO
           CALL DIAGNOSTICS_FILL(tmpMk,'TOTTTEND',0,Nr,-1,bi,bj,myThid)
#ifdef ALLOW_LAYERS
           IF ( layers_useThermo ) THEN
            CALL LAYERS_FILL(tmpMk,1,'TOT',0,Nr,-1,bi,bj,myThid)
           ENDIF
#endif /* ALLOW_LAYERS */
          ENDDO
         ENDDO
        ENDIF

        IF ( DIAGNOSTICS_IS_ON('TOTSTEND',myThid)
#ifdef ALLOW_LAYERS
     &     .OR. layers_useThermo
#endif
     &     ) THEN
         DO bj = myByLo(myThid), myByHi(myThid)
          DO bi = myBxLo(myThid), myBxHi(myThid)
           DO k=1,Nr
            tmpFac = 86400. _d 0/dTtracerLev(k)
            DO j = 1,sNy
             DO i = 1,sNx
               tmpMk(i,j,k,bi,bj) = tmpFac*salt(i,j,k,bi,bj)
             ENDDO
            ENDDO
           ENDDO
           CALL DIAGNOSTICS_FILL(tmpMk,'TOTSTEND',0,Nr,-1,bi,bj,myThid)
#ifdef ALLOW_LAYERS
           IF ( layers_useThermo ) THEN
            CALL LAYERS_FILL(tmpMk,2,'TOT',0,Nr,-1,bi,bj,myThid)
           ENDIF
#endif /* ALLOW_LAYERS */
          ENDDO
         ENDDO
        ENDIF

C--   fill state tendency diagnostics the second time: end
      ENDIF

#endif /* ALLOW_DIAGNOSTICS */

      RETURN
      END

#include "EXF_OPTIONS.h"
#ifdef ALLOW_CTRL
# include "CTRL_OPTIONS.h"
#endif
#ifdef ALLOW_AUTODIFF
# include "AUTODIFF_OPTIONS.h"
#endif

      SUBROUTINE EXF_WIND( myTime, myIter, myThid )

C     ==================================================================
C     SUBROUTINE exf_wind
C     ==================================================================
C
C     o Prepare wind speed and stress fields
C
C     ==================================================================
C     SUBROUTINE exf_wind
C     ==================================================================

      IMPLICIT NONE

C     == global variables ==

#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"

#include "EXF_PARAM.h"
#include "EXF_FIELDS.h"
#include "EXF_CONSTANTS.h"
#include "DYNVARS.h"

#ifdef ALLOW_AUTODIFF_TAMC
#include "tamc.h"
#endif
#ifdef ALLOW_GENTIM2D_CONTROL
# include "CTRL_SIZE.h"
# include "CTRL.h"
# include "CTRL_GENARR.h"
#endif

C     == routine arguments ==

      _RL     myTime
      INTEGER myIter
      INTEGER myThid

C     == external functions ==

C     == local variables ==

      INTEGER bi,bj
      INTEGER i,j,ks
      _RL     urelw(1:sNx,1:sNy)
      _RL     vrelw(1:sNx,1:sNy)
      _RL     wsLoc(1:sNx,1:sNy)
      _RL     wsSq
#ifdef ALLOW_BULKFORMULAE
      _RL     usSq, recip_sqrtRhoA, ustar
      _RL     tmp1, tmp2, tmp3, tmp4
#endif /* ALLOW_BULKFORMULAE */
      _RL     oneThirdRL
      PARAMETER ( oneThirdRL = 1.d0 / 3.d0 )
#if !(defined ALLOW_BULKFORMULAE) || !(defined ALLOW_ATM_TEMP)
      _RL wsm, tmpbulk
#endif
#ifdef ALLOW_GENTIM2D_CONTROL
      INTEGER iarr
#endif
#ifdef ALLOW_AUTODIFF_TAMC
      INTEGER ikey
#endif
C     == end of interface ==

C--   Use atmospheric state to compute surface fluxes.

      ks = 1
      IF ( usingPCoords ) ks = Nr

C     Loop over tiles.
      DO bj = myByLo(myThid),myByHi(myThid)
       DO bi = myBxLo(myThid),myBxHi(myThid)

#ifdef ALLOW_AUTODIFF_TAMC
        ikey = bi + (bj-1)*nSx + (ikey_dynamics-1)*nSx*nSy
#endif /* ALLOW_AUTODIFF_TAMC */

C--   Initialise
        DO j = 1,sNy
         DO i = 1,sNx
          wsLoc(i,j) = 0. _d 0
          urelw(i,j) = uwind(i,j,bi,bj)
          vrelw(i,j) = vwind(i,j,bi,bj)
          cw(i,j,bi,bj) = 0. _d 0
          sw(i,j,bi,bj) = 0. _d 0
          sh(i,j,bi,bj) = 0. _d 0
          wStress(i,j,bi,bj) = 0. _d 0
         ENDDO
        ENDDO

        IF (useRelativeWind) THEN
C     Subtract uVel and vVel from uwind and vwind.
         DO j = 1,sNy
          DO i = 1,sNx
           urelw(i,j) = uwind(i,j,bi,bj) - 0.5 _d 0
     &          * (uVel(i,j,ks,bi,bj)+uVel(i+1,j,ks,bi,bj))
           vrelw(i,j) = vwind(i,j,bi,bj) - 0.5 _d 0
     &          * (vVel(i,j,ks,bi,bj)+vVel(i,j+1,ks,bi,bj))
          ENDDO
         ENDDO
#ifdef ALLOW_DIAGNOSTICS
         IF ( useDiagnostics ) THEN
          CALL DIAGNOSTICS_FILL( urelw,'EXFurelw',0,1,3,bi,bj,myThid )
          CALL DIAGNOSTICS_FILL( vrelw,'EXFvrelw',0,1,3,bi,bj,myThid )
         ENDIF
#endif
        ENDIF

#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE urelw (:,:)       = comlev1_bibj, key=ikey, byte=isbyte
CADJ STORE vrelw (:,:)       = comlev1_bibj, key=ikey, byte=isbyte
CADJ STORE wspeed(:,:,bi,bj) = comlev1_bibj, key=ikey, byte=isbyte
#endif

        IF ( useAtmWind ) THEN

C--   Wind speed and direction.
         DO j = 1,sNy
          DO i = 1,sNx
           wsSq = urelw(i,j)*urelw(i,j)
     &          + vrelw(i,j)*vrelw(i,j)
           IF ( wsSq .NE. 0. _d 0 ) THEN
             wsLoc(i,j) = SQRT(wsSq)
             cw(i,j,bi,bj) = urelw(i,j)/wsLoc(i,j)
             sw(i,j,bi,bj) = vrelw(i,j)/wsLoc(i,j)
           ELSE
             wsLoc(i,j) = 0. _d 0
             cw(i,j,bi,bj) = 0. _d 0
             sw(i,j,bi,bj) = 0. _d 0
           ENDIF
          ENDDO
         ENDDO
         IF ( wspeedfile .EQ. ' ' ) THEN
C-    wind-speed is not loaded from file: save local array into common block
          DO j = 1,sNy
           DO i = 1,sNx
             wspeed(i,j,bi,bj) = wsLoc(i,j)
           ENDDO
          ENDDO
         ENDIF

#ifdef ALLOW_BULKFORMULAE
        ELSE
C--     case useAtmWind=F

C--   Wind stress and direction.
         DO j = 1,sNy
          DO i = 1,sNx
           IF ( stressIsOnCgrid ) THEN
             usSq = ( ustress(i,  j,bi,bj)*ustress(i  ,j,bi,bj)
     &               +ustress(i+1,j,bi,bj)*ustress(i+1,j,bi,bj)
     &               +vstress(i,j,  bi,bj)*vstress(i,j  ,bi,bj)
     &               +vstress(i,j+1,bi,bj)*vstress(i,j+1,bi,bj)
     &              )*0.5 _d 0
           ELSE
             usSq = ustress(i,j,bi,bj)*ustress(i,j,bi,bj)
     &             +vstress(i,j,bi,bj)*vstress(i,j,bi,bj)
           ENDIF
           IF ( usSq .NE. 0. _d 0 ) THEN
             wStress(i,j,bi,bj) = SQRT(usSq)
c            ustar = SQRT(usSq/atmrho)
             cw(i,j,bi,bj) = ustress(i,j,bi,bj)/wStress(i,j,bi,bj)
             sw(i,j,bi,bj) = vstress(i,j,bi,bj)/wStress(i,j,bi,bj)
           ELSE
             wStress(i,j,bi,bj) = 0. _d 0
             cw(i,j,bi,bj)      = 0. _d 0
             sw(i,j,bi,bj)      = 0. _d 0
           ENDIF
          ENDDO
         ENDDO

         IF ( wspeedfile .EQ. ' ' ) THEN
C--   wspeed is not loaded ; derive wind-speed by inversion of
C     wind-stress=fct(wind-speed) relation:
C             The variables us, sh and rdn have to be computed from
C             given wind stresses inverting relationship for neutral
C             drag coeff. cdn.
C             The inversion is based on linear and quadratic form of
C             cdn(umps); ustar can be directly computed from stress;
          recip_sqrtRhoA = 1. _d 0 / SQRT(atmrho)
          DO j = 1,sNy
           DO i = 1,sNx
C     check for zero wStress to please AD tools
            IF ( wStress(i,j,bi,bj) .LE. 0. _d 0 ) THEN
             ustar      = 0. _d 0
             wsloc(i,j) = 0. _d 0
            ELSE
             ustar = SQRT(wStress(i,j,bi,bj))*recip_sqrtRhoA
             IF ( ustar .LT. ustofu11 ) THEN
              tmp1 = -cquadrag_2/cquadrag_1*exf_half
              tmp2 = SQRT(tmp1*tmp1 + ustar*ustar/cquadrag_1)
              wsLoc(i,j) = SQRT(tmp1 + tmp2)
             ELSE
              tmp1 = clindrag_2/clindrag_1*oneThirdRL
              tmp2 = ustar*ustar/clindrag_1*exf_half
     &             - tmp1*tmp1*tmp1
              tmp3 = SQRT( ustar*ustar/clindrag_1*
     &             (ustar*ustar/clindrag_1*0.25 _d 0 - tmp1*tmp1*tmp1 )
     &                    )
              tmp4 = (tmp2 + tmp3)**oneThirdRL
              wsLoc(i,j) = tmp4 + tmp1*tmp1 / tmp4 - tmp1
c             wsLoc(i,j) = (tmp2 + tmp3)**oneThirdRL +
c    &             tmp1*tmp1 * (tmp2 + tmp3)**(-oneThirdRL) - tmp1
             ENDIF
            ENDIF
           ENDDO
          ENDDO
C-    save local array wind-speed to common block
          DO j = 1,sNy
           DO i = 1,sNx
            wspeed(i,j,bi,bj) = wsLoc(i,j)
           ENDDO
          ENDDO
C-    end if wspeedfile = empty
         ENDIF

#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE wspeed(:,:,bi,bj) = comlev1_bibj, key=ikey, byte=isbyte
CADJ STORE uwind (:,:,bi,bj) = comlev1_bibj, key=ikey, byte=isbyte
CADJ STORE vwind (:,:,bi,bj) = comlev1_bibj, key=ikey, byte=isbyte
CADJ STORE cw    (:,:,bi,bj) = comlev1_bibj, key=ikey, byte=isbyte
CADJ STORE sw    (:,:,bi,bj) = comlev1_bibj, key=ikey, byte=isbyte
#endif

C--   infer wind field from wind-speed & wind-stress direction
         DO j = 1,sNy
          DO i = 1,sNx
           uwind(i,j,bi,bj) = wspeed(i,j,bi,bj)*cw(i,j,bi,bj)
           vwind(i,j,bi,bj) = wspeed(i,j,bi,bj)*sw(i,j,bi,bj)
          ENDDO
         ENDDO

#endif /* ALLOW_BULKFORMULAE */
C--   end if/else useAtmWind
        ENDIF

#ifdef ALLOW_GENTIM2D_CONTROL
        DO j = 1,sNy
         DO i = 1,sNx
           do iarr = 1, maxCtrlTim2D
           if (xx_gentim2d_file(iarr)(1:9).EQ.'xx_wspeed')
     &       wspeed(i,j,bi,bj)=wspeed(i,j,bi,bj)+
     &                         xx_gentim2d(i,j,bi,bj,iarr)
           enddo
         ENDDO
        ENDDO
#endif

#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE wspeed(:,:,bi,bj) = comlev1_bibj, key=ikey, byte=isbyte
#endif

C--   set wind-speed lower limit
        DO j = 1,sNy
         DO i = 1,sNx
           sh(i,j,bi,bj) = MAX(wspeed(i,j,bi,bj),uMin)
         ENDDO
        ENDDO

#if !(defined ALLOW_BULKFORMULAE) || !(defined ALLOW_ATM_TEMP)
C     Note: In case ALLOW_BULKFORMULAE and ALLOW_ATM_TEMP are defined,
C     wind-stress is computed (if needed) within S/R EXF_BULKFORMULAE
        IF ( useAtmWind ) THEN
c#ifdef ALLOW_ATM_WIND
C--   Computes wind-stress:
         DO j = 1,sNy
          DO i = 1,sNx
           wsm     = sh(i,j,bi,bj)
# ifdef  ALLOW_DRAG_LARGEYEAGER09
C     Large and Yeager (2009), Climate Dynamics, equation 11a/b
           tmpbulk =  cdrag_1/wsm + cdrag_2 + cdrag_3*wsm
     &          + cdrag_8 * wsm**6
           tmpbulk = exf_scal_BulkCdn * (
     &            ( halfRL - SIGN(halfRL, wsm-umax) )*tmpbulk
     &          + ( halfRL + SIGN(halfRL, wsm-umax) )*cdragMax
     &          )
# else
           tmpbulk = exf_scal_BulkCdn
     &             * ( cdrag_1/wsm + cdrag_2 + cdrag_3*wsm )
# endif
           ustress(i,j,bi,bj) = atmrho*tmpbulk*wspeed(i,j,bi,bj)
     &                        * urelw(i,j)
           vstress(i,j,bi,bj) = atmrho*tmpbulk*wspeed(i,j,bi,bj)
     &                        * vrelw(i,j)
          ENDDO
         ENDDO
c#else /* ALLOW_ATM_WIND */
c        STOP 'ABNORMAL END: S/R EXF_WIND: missing code for useAtmWind'
c#endif /* ALLOW_ATM_WIND */
C--   end if useAtmWind
        ENDIF
#endif /* ndef ALLOW_BULKFORMULAE or ndef ALLOW_ATM_TEMP */

C--   end bi,bj loops
       ENDDO
      ENDDO

      RETURN
      END

#include "CHEAPAML_OPTIONS.h"

      SUBROUTINE CHEAPAML(
     I                           myTime, myIter, myThid )

C     ==================================================================
C     SUBROUTINE cheapaml
C     ==================================================================
C
C     o Get the surface fluxes used to force ocean model
C
C       Output:
C       ------
C       ustress, vstress - wind stress
C       Qnet             - net heat flux
C       EmPmR            - net freshwater flux
C       Tair  - mean air temperature (K)  at height ht (m)
C       Qair - Specific humidity kg/kg
C       Cheaptracer - passive tracer
C       ---------
C
C       Input:
C       ------
C       uWind, vWind  - mean wind speed (m/s)
C       Tr - Relaxation profile for Tair on boundaries (C)
C       qr - Relaxation profile for specific humidity (kg/kg)
C       CheaptracerR - Relaxation profile for passive tracer
C     ==================================================================
C     SUBROUTINE cheapaml
C     ==================================================================

      IMPLICIT NONE

C     == global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "EESUPPORT.h"
#include "PARAMS.h"
#include "DYNVARS.h"
#include "GRID.h"
#include "FFIELDS.h"
#include "CHEAPAML.h"

C     == routine arguments ==
      _RL     myTime
      INTEGER myIter
      INTEGER myThid

C     == Local variables ==
      INTEGER bi,bj
      INTEGER i,j, nt, startAB
      INTEGER iMin, iMax
      INTEGER jMin, jMax
      LOGICAL writeDbug
      CHARACTER*10 sufx
      LOGICAL xIsPeriodic, yIsPeriodic

C tendencies of atmospheric temperature, current and past
        _RL gTair(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
        _RL gqair(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
        _RL gCheaptracer(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
C zonal and meridional transports
        _RL uTrans(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
        _RL vTrans(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
C       AML timestep
        _RL deltaTTracer,deltaTm,ts,xalwu
        _RL dm,pt,xalwd,xlwnet
        _RL dtemp,xflu,xfld,dq,dtr
c       _RL Fclouds, ttt2
        _RL q,precip,ttt,entrain
        _RL uRelWind(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
        _RL vRelWind(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
        _RL windSq  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
        _RL fsha(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
        _RL flha(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
        _RL evp (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
        _RL xolw(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
        _RL ssqt(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
        _RL q100(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
        _RL cdq (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
C     surfDrag   :: surface drag coeff (for wind stress)
        _RL surfDrag(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
        _RL dumArg(6)
        _RL fsha0, flha0, evp_0, xolw0, ssqt0, q100_0, cdq_0
        _RL Tsurf  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
        _RL iceFrac(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
        _RL icFrac, opFrac
C temp var
        _RL tmpFld(1-OLx:sNx+OLx,1-OLy:sNy+OLy)

C useful values
C inverse of time step
        deltaTm=1. _d 0/deltaT

C atmospheric timestep
        deltaTtracer = deltaT/FLOAT(cheapaml_ntim)

c       writeDbug = debugLevel.GE.debLevC .AND.
c     &             DIFFERENT_MULTIPLE(diagFreq, myTime, deltaTClock)
        writeDbug = debugLevel.GE.debLevC .AND. diagFreq.GT.0.

#ifdef ALLOW_DIAGNOSTICS
C--   fill-in diagnostics for cheapAML state variables:
      IF ( useDiagnostics ) THEN
       CALL DIAGNOSTICS_FILL( Tair, 'CH_TAIR ', 0,1,0,1,1, myThid )
       IF (useFreshWaterFlux)
     & CALL DIAGNOSTICS_FILL( Qair, 'CH_QAIR ', 0,1,0,1,1, myThid )
      ENDIF
#endif /* ALLOW_DIAGNOSTICS */

      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
C initialize net heat flux and fresh water flux arrays
         DO j = 1-OLy,sNy+OLy
          DO i = 1-OLx,sNx+OLx
            Qnet(i,j,bi,bj) = 0. _d 0
            EmPmR(i,j,bi,bj)= 0. _d 0
          ENDDO
         ENDDO
       ENDDO
      ENDDO

C this is a reprogramming to speed up cheapaml
C the short atmospheric time step is applied to
C advection and diffusion only.  diabatic forcing is computed
C once and used for the entire oceanic time step.

C cycle through atmospheric advective/diffusive
C surface temperature evolution

      DO nt=1,cheapaml_ntim

        DO bj=myByLo(myThid),myByHi(myThid)
         DO bi=myBxLo(myThid),myBxHi(myThid)

C compute advective and diffusive flux divergence
          DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
             gTair(i,j,bi,bj)=0. _d 0
             uTrans(i,j) = uWind(i,j,bi,bj)*dyG(i,j,bi,bj)
             vTrans(i,j) = vWind(i,j,bi,bj)*dxG(i,j,bi,bj)
           ENDDO
          ENDDO
          CALL CHEAPAML_CALC_RHS(
     I           bi, bj, 1-OLx,sNx+OLx, 1-OLy,sNy+OLy,
     I           uTrans, vTrans,
     I           uWind, vWind,
     I           cheapaml_kdiff, Tair,
     I           deltaTtracer, zu, useFluxLimit,
     I           cheapamlXperiodic, cheapamlYperiodic,
     O           wWind,
     U           gTair,
     I           myTime, myIter, myThid )
         IF  (.NOT.useFluxLimit ) THEN
           startAB = cheapTairStartAB + nt - 1
           CALL ADAMS_BASHFORTH2(
     I           bi, bj, 1, 1,
     U           gTair(1-OLx,1-OLy,bi,bj),
     U           gTairm(1-OLx,1-OLy,bi,bj), tmpFld,
     I           startAB, myIter, myThid )
         ENDIF
         CALL CHEAPAML_TIMESTEP(
     I           bi, bj, 1-OLx,sNx+OLx, 1-OLy,sNy+OLy, deltaTtracer,
     I           gTair,
     U           Tair,
     I           nt, myIter, myThid )
C close bi,bj loops
         ENDDO
        ENDDO
C update edges
        _EXCH_XY_RL(Tair,myThid)

       IF (useFreshWaterFlux) THEN
C do water
        DO bj=myByLo(myThid),myByHi(myThid)
         DO bi=myBxLo(myThid),myBxHi(myThid)
          DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
             gqair(i,j,bi,bj)=0. _d 0
             uTrans(i,j) = uWind(i,j,bi,bj)*dyG(i,j,bi,bj)
             vTrans(i,j) = vWind(i,j,bi,bj)*dxG(i,j,bi,bj)
           ENDDO
          ENDDO
          CALL CHEAPAML_CALC_RHS(
     I           bi, bj, 1-OLx,sNx+OLx, 1-OLy,sNy+OLy,
     I           uTrans, vTrans,
     I           uWind, vWind,
     I           cheapaml_kdiff, qair,
     I           deltaTtracer, zu, useFluxLimit,
     I           cheapamlXperiodic, cheapamlYperiodic,
     O           wWind,
     U           gqair,
     I           myTime, myIter, myThid )
          IF  (.NOT.useFluxLimit ) THEN
           startAB = cheapTairStartAB + nt - 1
           CALL ADAMS_BASHFORTH2(
     I           bi, bj, 1, 1,
     U           gqair(1-OLx,1-OLy,bi,bj),
     U           gqairm(1-OLx,1-OLy,bi,bj), tmpFld,
     I           startAB, myIter, myThid )
          ENDIF
          CALL CHEAPAML_TIMESTEP(
     I           bi, bj, 1-OLx,sNx+OLx, 1-OLy,sNy+OLy, deltaTtracer,
     I           gqair,
     U           qair,
     I           nt, myIter, myThid )
C close bi, bj loops
         ENDDO
        ENDDO
C update edges
        _EXCH_XY_RL(qair,myThid)
       ENDIF         ! if use freshwater

       IF (useCheapTracer) THEN
C     do tracer
        DO bj=myByLo(myThid),myByHi(myThid)
         DO bi=myBxLo(myThid),myBxHi(myThid)
          DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
             gCheaptracer(i,j,bi,bj)=0. _d 0
             uTrans(i,j) = uWind(i,j,bi,bj)*dyG(i,j,bi,bj)
             vTrans(i,j) = vWind(i,j,bi,bj)*dxG(i,j,bi,bj)
           ENDDO
          ENDDO
          CALL CHEAPAML_CALC_RHS(
     I           bi, bj, 1-OLx,sNx+OLx, 1-OLy,sNy+OLy,
     I           uTrans, vTrans,
     I           uWind, vWind,
     I           cheapaml_kdiff, Cheaptracer,
     I           deltaTtracer, zu, useFluxLimit,
     I           cheapamlXperiodic, cheapamlYperiodic,
     O           wWind,
     U           gCheaptracer,
     I           myTime, myIter, myThid )
          IF  (.NOT.useFluxLimit ) THEN
           startAB = cheapTracStartAB + nt - 1
           CALL ADAMS_BASHFORTH2(
     I           bi, bj, 1, 1,
     U           gCheaptracer(1-OLx,1-OLy,bi,bj),
     U           gCheaptracerm(1-OLx,1-OLy,bi,bj), tmpFld,
     I           startAB, myIter, myThid )
          ENDIF
          CALL CHEAPAML_TIMESTEP(
     I           bi, bj, 1-OLx,sNx+OLx, 1-OLy,sNy+OLy, deltaTtracer,
     I           gCheaptracer,
     U           Cheaptracer,
     I           nt, myIter, myThid )
C     close bi, bj loops
         ENDDO
        ENDDO
C     update edges
        _EXCH_XY_RL(Cheaptracer,myThid)
       ENDIF                   ! if use tracer

C reset boundaries to open boundary profile
       IF ( .NOT.(cheapamlXperiodic.AND.cheapamlYperiodic) ) THEN
        DO bj=myByLo(myThid),myByHi(myThid)
         DO bi=myBxLo(myThid),myBxHi(myThid)
           CALL CHEAPAML_COPY_EDGES(
     I                   cheapamlXperiodic, cheapamlYperiodic,
     I                   Tr(1-OLx,1-OLy,bi,bj),
     U                   Tair(1-OLx,1-OLy,bi,bj),
     I                   bi, bj, myIter, myThid )
          IF (useFreshWaterFlux) THEN
           CALL CHEAPAML_COPY_EDGES(
     I                   cheapamlXperiodic, cheapamlYperiodic,
     I                   qr(1-OLx,1-OLy,bi,bj),
     U                   qair(1-OLx,1-OLy,bi,bj),
     I                   bi, bj, myIter, myThid )
          ENDIF
          IF (useCheapTracer) THEN
           CALL CHEAPAML_COPY_EDGES(
     I                   cheapamlXperiodic, cheapamlYperiodic,
     I                   CheaptracerR(1-OLx,1-OLy,bi,bj),
     U                   Cheaptracer(1-OLx,1-OLy,bi,bj),
     I                   bi, bj, myIter, myThid )
          ENDIF
         ENDDO
        ENDDO
       ENDIF

C--   end loop on nt (short time-step loop)
      ENDDO
      IF ( writeDbug ) THEN
       WRITE(sufx,'(I10.10)') myIter
       CALL WRITE_FLD_XY_RL('tAir_afAdv.', sufx, Tair, myIter, myThid )
       IF (useFreshWaterFlux)
     & CALL WRITE_FLD_XY_RL('qAir_afAdv.', sufx, qair, myIter, myThid )
      ENDIF

C cycling on short atmospheric time step is now done

C     now continue with diabatic forcing
      iMin = 1
      iMax = sNx
      jMin = 1
      jMax = sNy

      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)

           DO j = 1-OLy, sNy+OLy
             DO i = 1-OLx, sNx+OLx
               surfDrag(i,j,bi,bj) = 0.
             ENDDO
           ENDDO

         IF (useRelativeWind) THEN
           DO j = 1-OLy, sNy+OLy
             DO i = 1-OLx, sNx+OLx
               uRelWind(i,j) = uWind(i,j,bi,bj)-uVel(i,j,1,bi,bj)
               vRelWind(i,j) = vWind(i,j,bi,bj)-vVel(i,j,1,bi,bj)
             ENDDO
           ENDDO

           DO j = jMin,jMax
             DO i = iMin,iMax
               windSq(i,j) = ( uRelWind( i ,j)*uRelWind( i ,j)
     &            + uRelWind(i+1,j)*uRelWind(i+1,j)
     &            + vRelWind(i, j )*vRelWind(i, j )
     &            + vRelWind(i,j+1)*vRelWind(i,j+1)
     &            )*0.5 _d 0
#ifdef INCONSISTENT_WIND_LOCATION
               windSq(i,j) = uRelWind(i,j)*uRelWind(i,j)
     &            + vRelWind(i,j)*vRelWind(i,j)
#endif
             ENDDO
           ENDDO
         ELSE
           DO j = jMin,jMax
             DO i = iMin,iMax
               windSq(i,j) = ( uWind( i ,j,bi,bj)*uWind( i ,j,bi,bj)
     &            + uWind(i+1,j,bi,bj)*uWind(i+1,j,bi,bj)
     &            + vWind(i, j ,bi,bj)*vWind(i, j,bi,bj )
     &            + vWind(i,j+1,bi,bj)*vWind(i,j+1,bi,bj)
     &            )*0.5 _d 0
#ifdef INCONSISTENT_WIND_LOCATION
               windSq(i,j) = uWind(i,j,bi,bj)*uWind(i,j,bi,bj)
     &            + vWind(i,j,bi,bj)*vWind(i,j,bi,bj)
#endif
             ENDDO
           ENDDO

         ENDIF

         IF ( useThSIce ) THEN
           CALL CHEAPAML_SEAICE(
     I                    solar(1-OLx,1-OLy,bi,bj),
     I                    cheapdlongwave(1-OLx,1-OLy,bi,bj),
     I                    uWind(1-OLx,1-OLy,bi,bj),
     I                    vWind(1-OLx,1-OLy,bi,bj), lath,
     O                    fsha, flha, evp, xolw, ssqt, q100, cdq,
     O                    Tsurf, iceFrac, Qsw(1-OLx,1-OLy,bi,bj),
     I                    bi, bj, myTime, myIter, myThid )
           DO j = jMin,jMax
            DO i = iMin,iMax
              CALL CHEAPAML_COARE3_FLUX(
     I                      i, j, bi, bj, 0,
     I                      theta(1-OLx,1-OLy,1,bi,bj), windSq,
     O                      fsha0, flha0, evp_0, xolw0,
     O                      ssqt0, q100_0, cdq_0,
     O                      surfDrag(i,j,bi,bj),
     O                      dumArg(1), dumArg(2), dumArg(3), dumArg(4),
     I                      myIter, myThid )
              Qnet(i,j,bi,bj) = (
     &                           -solar(i,j,bi,bj)
     &                           +xolw0 - cheapdlongwave(i,j,bi,bj)
     &                           +fsha0
     &                           +flha0
     &                          )*maskC(i,j,1,bi,bj)
              EmPmR(i,j,bi,bj) = evp_0
              icFrac  = iceFrac(i,j)
              opFrac = 1. _d 0 - icFrac
C-     Qsw (from FFIELDS.h) has opposite (and annoying) sign convention:
              Qsw(i,j,bi,bj) = - ( icFrac*Qsw(i,j,bi,bj)
     &                           + opFrac*solar(i,j,bi,bj) )
              fsha(i,j) = icFrac*fsha(i,j) + opFrac*fsha0
              flha(i,j) = icFrac*flha(i,j) + opFrac*flha0
              evp(i,j)  = icFrac*evp(i,j)  + opFrac*evp_0
              xolw(i,j) = icFrac*xolw(i,j) + opFrac*xolw0
              ssqt(i,j) = icFrac*ssqt(i,j) + opFrac*ssqt0
              q100(i,j) = icFrac*q100(i,j) + opFrac*q100_0
              cdq(i,j)  = icFrac*cdq(i,j)  + opFrac*cdq_0
            ENDDO
           ENDDO
         ELSE
           DO j = jMin,jMax
            DO i = iMin,iMax
             IF (FluxFormula.EQ.'LANL') THEN
              CALL cheapaml_LANL_flux(
     I                      i, j, bi, bj,
     O                      fsha(i,j), flha(i,j), evp(i,j),
     O                      xolw(i,j), ssqt(i,j), q100(i,j) )
             ELSEIF (FluxFormula.EQ.'COARE3') THEN
              CALL CHEAPAML_COARE3_FLUX(
     I                      i, j, bi, bj, 0,
     I                      theta(1-OLx,1-OLy,1,bi,bj), windSq,
     O                      fsha(i,j), flha(i,j), evp(i,j), xolw(i,j),
     O                      ssqt(i,j), q100(i,j), cdq(i,j),
     O                      surfDrag(i,j,bi,bj),
     O                      dumArg(1), dumArg(2), dumArg(3), dumArg(4),
     I                      myIter, myThid )
             ENDIF
             IF (useFreshWaterFlux) THEN
              EmPmR(i,j,bi,bj) = evp(i,j)
             ENDIF
            ENDDO
           ENDDO
         ENDIF

         DO j = jMin,jMax
          DO i = iMin,iMax

C atmospheric upwelled long wave
           ttt = Tair(i,j,bi,bj)-gamma_blk*(CheapHgrid(i,j,bi,bj)-zt)
c          xalwu = stefan*(ttt+celsius2K)**4*0.5 _d 0
           xalwu = stefan*(0.5*Tair(i,j,bi,bj)+0.5*ttt+celsius2K)**4
     &                   *0.5 _d 0
C atmospheric downwelled long wave
           xalwd = stefan*(Tair(i,j,bi,bj)+celsius2K)**4*0.5 _d 0
C total flux at upper atmospheric layer interface
           xflu = ( -solar(i,j,bi,bj) + xalwu + flha(i,j)
     &            )*xef*maskC(i,j,1,bi,bj)
C lower flux calculation.
           xfld = ( -solar(i,j,bi,bj) - xalwd + xolw(i,j)
     &              + fsha(i,j) + flha(i,j)
     &            )*xef*maskC(i,j,1,bi,bj)

           IF (useDLongWave) THEN
             xlwnet = xolw(i,j)-cheapdlongwave(i,j,bi,bj)
           ELSE
C net long wave (see Josey et al. JGR 1997)
C coef lambda replaced by 0.5+lat/230
C convert spec humidity in water vapor pressure (mbar) using coef 1000/0.622=1607.7
             xlwnet = 0.98 _d 0*stefan*(theta(i,j,1,bi,bj)+celsius2K)**4
     &          *(0.39 _d 0 - 0.05 _d 0*SQRT(ABS(qair(i,j,bi,bj))
     &          *     1607.7 _d 0))
     &        *( oneRL - (halfRL+ABS(yG(i,j,bi,bj))/230. _d 0)
     &                   *cheapclouds(i,j,bi,bj)**2 )
     &        + 4.0*0.98 _d 0*stefan*(theta(i,j,1,bi,bj)+celsius2K)**3
     &          *(theta(i,j,1,bi,bj)-Tair(i,j,bi,bj))

c            xlwnet = xolw-stefan*(theta(i,j,1,bi,bj)+celsius2K)**4.
c     &       *(0.65+11.22*qair(i,j,bi,bj) + 0.25*cheapclouds(i,j,bi,bj)
c     &       -8.23*qair(i,j,bi,bj)*cheapclouds(i,j,bi,bj))
           ENDIF
C clouds
c          ttt2=Tair(i,j,bi,bj)-1.5*gamma_blk*CheapHgrid(i,j,bi,bj)
c          Fclouds = stefan*ttt2**4*(0.4*cheapclouds(i,j,bi,bj)+1-0.4)/2
c          ttt2=Tair(i,j,bi,bj)-3*gamma_blk*CheapHgrid(i,j,bi,bj)+celsius2K
c          Fclouds = 0.3*stefan*ttt2**4 + 0.22*xolw*cheapclouds(i,j,bi,bj)
C add flux divergences into atmospheric temperature tendency
           gTair(i,j,bi,bj)= (xfld-xflu)/CheapHgrid(i,j,bi,bj)
           IF ( .NOT.useThSIce ) THEN
            Qnet(i,j,bi,bj) = (
     &                         -solar(i,j,bi,bj)
c    &                         -xalwd
c    &                         -Fclouds
c    &                         +xolw
     &                         +xlwnet
     &                         +fsha(i,j)
     &                         +flha(i,j)
     &                        )*maskC(i,j,1,bi,bj)
             Qsw(i,j,bi,bj) = -solar(i,j,bi,bj)
           ENDIF

C need to precip?
           IF (useFreshWaterFlux) THEN
             q=q100(i,j)
C compute saturation specific humidity at atmospheric
C layer top
C first, what is the pressure there?
C ts is surface atmospheric temperature
            ts=Tair(i,j,bi,bj)+gamma_blk*zt+celsius2K
            pt=p0*(1-gamma_blk*CheapHgrid(i,j,bi,bj)/ts)
     &          **(gravity/gamma_blk/gasR)

             IF (.NOT.usePrecip) THEN
C factor to compute rainfall from specific humidity
              dm=100.*(p0-pt)*recip_gravity
C     Large scale precip
              precip = 0.
              IF ( wWind(i,j,bi,bj).GT.0. .AND.
     &             q.GT.ssqt(i,j)*0.7 _d 0 ) THEN
                precip = precip
     &               + ( (q-ssqt(i,j)*0.7 _d 0)*dm/cheap_pr2 )
     &                 *(wWind(i,j,bi,bj)/0.75 _d -5)**2
              ENDIF

C     Convective precip
              IF (q.GT.0.0214 _d 0 .AND. q.GT.ssqt(i,j)*0.9 _d 0) THEN
                precip = precip + ((q-ssqt(i,j)*0.9 _d 0)*dm/cheap_pr1)
              ENDIF

              cheapPrecip(i,j,bi,bj) = precip*1200/CheapHgrid(i,j,bi,bj)
            ENDIF

              entrain = cdq(i,j)*q*0.25

c           gqair(i,j,bi,bj)=(evp-precip-entrain)/CheapHgrid(i,j,bi,bj)
            gqair(i,j,bi,bj) = (evp(i,j)-entrain)/CheapHgrid(i,j,bi,bj)
     &                        /rhoa*maskC(i,j,1,bi,bj)
            EmPmR(i,j,bi,bj) = ( EmPmR(i,j,bi,bj)
     &                          -cheapPrecip(i,j,bi,bj)
     &                         )*maskC(i,j,1,bi,bj)
           ENDIF

          ENDDO
         ENDDO

C it is not necessary to use the Adams2d subroutine as
C the forcing is always computed at the current time step.
C note: full oceanic time step deltaT is used below
         CALL CHEAPAML_TIMESTEP(
     I           bi, bj, iMin, iMax, jMin, jMax, deltaT,
     I           gTair,
     U           Tair,
     I           0, myIter, myThid )
C       do implicit time stepping over land
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
            dtemp=tr(i,j,bi,bj)-Tair(i,j,bi,bj)
            Tair(i,j,bi,bj)=Tair(i,j,bi,bj)+dtemp*xrelf(i,j,bi,bj)
          ENDDO
         ENDDO

C do water
        IF (useFreshWaterFlux) THEN
         CALL CHEAPAML_TIMESTEP(
     I           bi, bj, iMin, iMax, jMin, jMax, deltaT,
     I           gqair,
     U           qair,
     I           0, myIter, myThid )
C     do implicit time stepping over land and or buffer
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
            dq=qr(i,j,bi,bj)-qair(i,j,bi,bj)
            qair(i,j,bi,bj)=qair(i,j,bi,bj)+dq*xrelf(i,j,bi,bj)
            IF (qair(i,j,bi,bj).LT.0.0) qair(i,j,bi,bj) = 0.0 _d 0
          ENDDO
         ENDDO
        ENDIF

C do tracer
        IF (useCheapTracer) THEN
C     do implicit time stepping over land and or buffer
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
            dtr=CheaptracerR(i,j,bi,bj)-Cheaptracer(i,j,bi,bj)
            Cheaptracer(i,j,bi,bj) = Cheaptracer(i,j,bi,bj)
     &                             + dtr*xrelf(i,j,bi,bj)
          ENDDO
         ENDDO
        ENDIF

#ifdef ALLOW_DIAGNOSTICS
        IF ( useDiagnostics ) THEN
         CALL DIAGNOSTICS_FILL( fsha,'CH_SH   ',0,1,2,bi,bj,myThid )
         CALL DIAGNOSTICS_FILL( flha,'CH_LH   ',0,1,2,bi,bj,myThid )
         CALL DIAGNOSTICS_FILL( q100,'CH_q100 ',0,1,2,bi,bj,myThid )
         CALL DIAGNOSTICS_FILL( ssqt,'CH_ssqt ',0,1,2,bi,bj,myThid )
        ENDIF
#endif /* ALLOW_DIAGNOSTICS */

C close bi,bj loops
       ENDDO
      ENDDO

C update edges
       _EXCH_XY_RL(Tair,myThid)
       _EXCH_XY_RS(Qnet,myThid)
      IF (useFreshWaterFlux) THEN
       _EXCH_XY_RL(qair,myThid)
       _EXCH_XY_RS(EmPmR,myThid)
      ENDIF
      IF (useCheapTracer) THEN
       _EXCH_XY_RL(Cheaptracer,myThid)
      ENDIF
      IF (.NOT.useStressOption) THEN
       IF ( FluxFormula.EQ.'COARE3' ) THEN
        _EXCH_XY_RL( surfDrag, myThid )
       ELSE
        CALL EXCH_UV_AGRID_3D_RL( ustress, vstress, .TRUE., 1, myThid )
       ENDIF
      ENDIF

C reset edges to open boundary profiles
c     IF ( .NOT.(cheapamlXperiodic.AND.cheapamlYperiodic) ) THEN
      IF ( notUsingXPeriodicity.OR.notUsingYPeriodicity ) THEN
        xIsPeriodic = .NOT.notUsingXPeriodicity
        yIsPeriodic = .NOT.notUsingYPeriodicity
        DO bj=myByLo(myThid),myByHi(myThid)
         DO bi=myBxLo(myThid),myBxHi(myThid)
           CALL CHEAPAML_COPY_EDGES(
c    I                   cheapamlXperiodic, cheapamlYperiodic,
     I                   xIsPeriodic, yIsPeriodic,
     I                   Tr(1-OLx,1-OLy,bi,bj),
     U                   Tair(1-OLx,1-OLy,bi,bj),
     I                   bi, bj, myIter, myThid )
          IF (useFreshWaterFlux) THEN
           CALL CHEAPAML_COPY_EDGES(
c    I                   cheapamlXperiodic, cheapamlYperiodic,
     I                   xIsPeriodic, yIsPeriodic,
     I                   qr(1-OLx,1-OLy,bi,bj),
     U                   qair(1-OLx,1-OLy,bi,bj),
     I                   bi, bj, myIter, myThid )
          ENDIF
          IF (useCheapTracer) THEN
           CALL CHEAPAML_COPY_EDGES(
c    I                   cheapamlXperiodic, cheapamlYperiodic,
     I                   xIsPeriodic, yIsPeriodic,
     I                   CheaptracerR(1-OLx,1-OLy,bi,bj),
     U                   Cheaptracer(1-OLx,1-OLy,bi,bj),
     I                   bi, bj, myIter, myThid )
          ENDIF
         ENDDO
        ENDDO
      ENDIF

c     CALL PLOT_FIELD_XYRS( gTair, 'S/R CHEAPAML gTair',1,myThid)
c     CALL PLOT_FIELD_XYRS( Tair, 'S/R CHEAPAML Tair',1,myThid)
c     CALL PLOT_FIELD_XYRS( Qnet, 'S/R CHEAPAML Qnet',1,myThid)

      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)

        IF ( .NOT.useStressOption .AND. FluxFormula.EQ.'COARE3' ) THEN
          IF (useRelativeWind) THEN

          DO j = 1-OLy+1,sNy+OLy
          DO i = 1-OLx+1,sNx+OLx
            fu(i,j,bi,bj) = maskW(i,j,1,bi,bj)*0.5 _d 0
     &          *( surfDrag(i-1,j,bi,bj) + surfDrag(i,j,bi,bj) )
     &          *( uWind(i,j,bi,bj)-uVel(i,j,1,bi,bj) )
            fv(i,j,bi,bj) = maskS(i,j,1,bi,bj)*0.5 _d 0
     &          *( surfDrag(i,j-1,bi,bj) + surfDrag(i,j,bi,bj) )
     &          *( vWind(i,j,bi,bj)-vVel(i,j,1,bi,bj) )
          ENDDO
         ENDDO
#ifdef INCONSISTENT_WIND_LOCATION
         DO j = 1-OLy,sNy+OLy
          DO i = 1-OLx+1,sNx+OLx
            fu(i,j,bi,bj) = maskW(i,j,1,bi,bj)*0.5 _d 0
     &          *( surfDrag(i-1,j,bi,bj)
     &             *( uWind(i-1,j,bi,bj)-uVel(i-1,j,1,bi,bj) )
     &           + surfDrag(i,j,bi,bj)
     &             *( uWind(i,j,bi,bj) - uVel(i,j,1,bi,bj) ) )
          ENDDO
         ENDDO
         DO j = 1-OLy+1,sNy+OLy
          DO i = 1-OLx,sNx+OLx
            fv(i,j,bi,bj) = maskS(i,j,1,bi,bj)*0.5 _d 0
     &          *( surfDrag(i,j-1,bi,bj)
     &             *( vWind(i,j-1,bi,bj)-vVel(i,j-1,1,bi,bj) )
     &           + surfDrag(i,j,bi,bj)
     &             *( vWind(i,j,bi,bj) - vVel(i,j,1,bi,bj) ) )
          ENDDO
         ENDDO
#endif /* INCONSISTENT_WIND_LOCATION */
       ELSE ! relative wind

          DO j = 1-OLy+1,sNy+OLy
          DO i = 1-OLx+1,sNx+OLx
            fu(i,j,bi,bj) = maskW(i,j,1,bi,bj)*0.5 _d 0
     &          *( surfDrag(i-1,j,bi,bj) + surfDrag(i,j,bi,bj) )
     &          *uWind(i,j,bi,bj)
            fv(i,j,bi,bj) = maskS(i,j,1,bi,bj)*0.5 _d 0
     &          *( surfDrag(i,j-1,bi,bj) + surfDrag(i,j,bi,bj) )
     &          *vWind(i,j,bi,bj)
          ENDDO
         ENDDO
#ifdef INCONSISTENT_WIND_LOCATION
         DO j = 1-OLy,sNy+OLy
          DO i = 1-OLx+1,sNx+OLx
            fu(i,j,bi,bj) = maskW(i,j,1,bi,bj)*0.5 _d 0
     &          *( surfDrag(i-1,j,bi,bj)
     &             *uWind(i-1,j,bi,bj)
     &           + surfDrag(i,j,bi,bj)
     &             *uWind(i,j,bi,bj))
          ENDDO
         ENDDO
         DO j = 1-OLy+1,sNy+OLy
          DO i = 1-OLx,sNx+OLx
            fv(i,j,bi,bj) = maskS(i,j,1,bi,bj)*0.5 _d 0
     &          *( surfDrag(i,j-1,bi,bj)
     &             *vWind(i,j-1,bi,bj)
     &           + surfDrag(i,j,bi,bj)
     &             *vWind(i,j,bi,bj))
          ENDDO
         ENDDO
#endif /* INCONSISTENT_WIND_LOCATION */
         ENDIF !relative wind

       ELSE
Cswd move wind stresses to u and v points
         DO j = 1-OLy,sNy+OLy
          DO i = 1-OLx+1,sNx+OLx
            fu(i,j,bi,bj) = maskW(i,j,1,bi,bj)*0.5 _d 0
     &          *( ustress(i,j,bi,bj) + ustress(i-1,j,bi,bj) )
          ENDDO
         ENDDO
         DO j = 1-OLy+1,sNy+OLy
          DO i = 1-OLx,sNx+OLx
            fv(i,j,bi,bj) = maskS(i,j,1,bi,bj)*0.5 _d 0
     &          *( vstress(i,j,bi,bj) + vstress(i,j-1,bi,bj) )
          ENDDO
         ENDDO
        ENDIF

C--   end bi,bj loops
       ENDDO
      ENDDO

#ifdef ALLOW_DIAGNOSTICS
C- note: with thSIce, CH_QNET and CH_EmP correspond to the fluxes over the
C     open-ocean fraction of the grid-cell (similar to EXFqnet and EXFempmr).
C     Use instead diagnostics SIflxAtm & SIfrwAtm to get the grid-cell
C      averaged (open-ocean fraction + ice-covered fraction).
      IF ( useDiagnostics ) THEN
       CALL DIAGNOSTICS_FILL(uWind,  'CH_Uwind',0,1,0,1,1,myThid)
       CALL DIAGNOSTICS_FILL(vWind,  'CH_Vwind',0,1,0,1,1,myThid)
       CALL DIAGNOSTICS_FILL_RS(Qnet,'CH_QNET ',0,1,0,1,1,myThid)
       IF (useFreshWaterFlux) THEN
        CALL DIAGNOSTICS_FILL_RS( EmPmR, 'CH_EmP  ', 0,1,0,1,1,myThid)
        CALL DIAGNOSTICS_FILL(cheapPrecip,'CH_Prec ',0,1,0,1,1,myThid)
       ENDIF
       IF (useCheapTracer) THEN
        CALL DIAGNOSTICS_FILL(Cheaptracer,'CH_Trace',0,1,0,1,1,myThid)
       ENDIF
      ENDIF
#endif /* ALLOW_DIAGNOSTICS */

c     DO bj=myByLo(myThid),myByHi(myThid)
c      DO bi=myBxLo(myThid),myBxHi(myThid)
c        DO j = 1-OLy,sNy+OLy
c         DO i = 1-OLx+1,sNx+OLx
c           fu(i,j,bi,bj) = 0.0
c           fv(i,j,bi,bj) = 0.0
c           Qnet(i,j,bi,bj) = 0.0
c           EmPmR(i,j,bi,bj) = 0.0
c         ENDDO
c        ENDDO
c      ENDDO
c     ENDDO

      RETURN
      END

#include "PROFILES_OPTIONS.h"
#ifdef ALLOW_COST
#include "COST_OPTIONS.h"
#endif

CBOP
C     !ROUTINE: PROFILES_COST_FINAL
C     !INTERFACE:
      SUBROUTINE PROFILES_COST_FINAL( ifc, optimcycle, myThid )

C     !DESCRIPTION:
C     *==========================================================*
C     | SUBROUTINE PROFILES_COST_FINAL
C     *==========================================================*

C     !USES:
      IMPLICIT NONE

C     == global variables ==
#include "EEPARAMS.h"
#include "SIZE.h"
#include "PARAMS.h"
#ifdef ALLOW_COST
# include "cost.h"
#endif
#include "PROFILES_SIZE.h"
#include "profiles.h"

C     !INPUT/OUTPUT PARAMETERS:
C     ifc        :: file unit for costfunction_profiles.XXXX
C     optimcycle :: cycle number of the off-line optimization.
C     myThid     :: my Thread Id number
      INTEGER ifc
      INTEGER optimcycle
      INTEGER myThid

#ifdef ALLOW_COST
C     ! FUNCTIONS:
      INTEGER  ILNBLNK
      EXTERNAL ILNBLNK

C     !LOCAL VARIABLES:
      INTEGER bi, bj, num_var
      INTEGER num_file
      _RL f_profiles(NFILESPROFMAX,NVARMAX)
      _RL f_profiles_mean(NVARMAX)
      _RL no_profiles(NFILESPROFMAX,NVARMAX)
      _RL no_profiles_mean(NVARMAX)

      CHARACTER*26 cfname
      INTEGER IL
      CHARACTER*(MAX_LEN_MBUF) msgBuf
CEOP

C     Initialise cost function variables zo zero
      DO num_var=1,NVARMAX
       DO num_file=1,NFILESPROFMAX
        f_profiles(num_file,num_var)= 0. _d 0
        no_profiles(num_file,num_var)= 0. _d 0
       ENDDO
       f_profiles_mean(num_var)= 0. _d 0
       no_profiles_mean(num_var)= 0. _d 0
      ENDDO

c--   Sum up all contributions.
      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)

        DO num_var=1,NVARMAX
         DO num_file=1,NFILESPROFMAX
          tile_fc(bi,bj) = tile_fc(bi,bj)
     &            + mult_profiles(num_file,num_var)
     &            *objf_profiles(num_file,num_var,bi,bj)
          f_profiles(num_file,num_var)=f_profiles(num_file,num_var)
     &            +objf_profiles(num_file,num_var,bi,bj)
          no_profiles(num_file,num_var)=no_profiles(num_file,num_var)
     &            +num_profiles(num_file,num_var,bi,bj)
         ENDDO
         tile_fc(bi,bj) = tile_fc(bi,bj)
     &           + mult_profiles_mean(num_var)
     &           *objf_profiles_mean(num_var,bi,bj)
         f_profiles_mean(num_var)=f_profiles_mean(num_var)
     &           +objf_profiles_mean(num_var,bi,bj)
         no_profiles_mean(num_var)=no_profiles_mean(num_var)
     &           +num_profiles_mean(num_var,bi,bj)
        ENDDO

C-   end bi,bj loops
       ENDDO
      ENDDO

c--   Do global summation for each part of the cost function
      DO num_var=1,NVARMAX
       DO num_file=1,NFILESPROFMAX
        _GLOBAL_SUM_RL(f_profiles(num_file,num_var), myThid )
        _GLOBAL_SUM_RL(no_profiles(num_file,num_var), myThid )
       ENDDO
       _GLOBAL_SUM_RL(f_profiles_mean(num_var), myThid )
       _GLOBAL_SUM_RL(no_profiles_mean(num_var), myThid )
      ENDDO

C     start printing to STDOUT
      DO num_file=1,NFILESPROFMAX
       DO num_var=1,NVARMAX
        IF ( no_profiles(num_file,num_var).GT.zeroRL ) THEN
         WRITE(msgBuf,'(A,1PE22.14,2I3,1X,1PE9.2)')
     &     ' --> f_profiles =',f_profiles(num_file,num_var),
     &      num_file, num_var, mult_profiles(num_file,num_var)

         CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                       SQUEEZE_RIGHT, myThid )
        ENDIF
       ENDDO
      ENDDO
      DO num_var=1,NVARMAX
       IF ( no_profiles_mean(num_var).GT.zeroRL ) THEN
        WRITE(msgBuf,'(A,1PE22.14,I3,1X,1PE9.2)')
     &     ' --> f_profiles_mean =',f_profiles_mean(num_var),
     &      num_var, mult_profiles_mean(num_var)

        CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
       ENDIF
      ENDDO

c--   Each process has calculated the global part for itself.

C     only master thread of master CPU open and write to file
      IF ( ifc .NE. -1 ) THEN

       WRITE(cfname,'(A,I4.4)') 'costfunction_profiles.',optimcycle
       OPEN(unit=ifc,file=cfname)
       WRITE(msgBuf,'(A,A)')
     &      'Writing profiles cost function info to ', cfname
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                     SQUEEZE_RIGHT, myThid )

       DO num_file=1,NFILESPROFMAX
        DO num_var=1,NVARMAX
         IF ( no_profiles(num_file,num_var).GT.zeroRL ) THEN
          IL = ILNBLNK( profilesfiles(num_file) )
          IL = MAX(IL,30)
          WRITE(ifc,'(4A,1PE22.14,1PE22.14,1X,1PE9.2)')
     &         profilesfiles(num_file)(1:IL),' ',
     &         prof_names(num_file,num_var), ' = ',
     &         f_profiles(num_file,num_var),
     &         no_profiles(num_file,num_var),
     &         mult_profiles(num_file,num_var)
         ENDIF
        ENDDO
       ENDDO
       DO num_var=1,NVARMAX
        IF ( no_profiles_mean(num_var).GT.zeroRL ) THEN
         WRITE(ifc,'(3A,1PE22.14,1PE22.14,1X,1PE9.2)')
     &        'profile_mean ', prof_names(1,num_var), ' = ',
     &        f_profiles_mean(num_var), no_profiles_mean(num_var),
     &        mult_profiles_mean(num_var)
        ENDIF
       ENDDO
       CLOSE(ifc)

      ENDIF

#endif /* ALLOW_COST */

      RETURN
      END

#include "PACKAGES_CONFIG.h"
! Copied from default CPP_EEMACROS.h
! To avoid this, we need to find a way to include CPP_EEMACROS.h
#define _RL Real*8

!BOP
!     !ROUTINE: COST_TEST_LOCAL
!     !INTERFACE:
subroutine cost_test_local ( &
     sNx, sNy, nSx, nSy, OLx, OLy, Nr, &
     myBxLo, myBxHi, myByLo, myByHi, &
     myXGlobalLo, myYGlobalLo, &
     theta, &
     objf_test, &
     myThid )
  !     *==========================================================*
  !     | SUBROUTINE COST_TEST_LOCAL
  !     | o the subroutine computes the sum of temperatures
  !     |   in a band 30 < j < 40
  !     *==========================================================*
  !
  !     !USES:
  implicit none

  !   !INPUT/OUTPUT PARAMETERS:
  ! sNx,sNy,nSx,nSy,OLx,OLy,Nr  :: array boundaries (set it SIZE.h)
  ! myBxLo,myBxHi,myByLo,myByHi :: bi/bj loop boundaries for myThid
  ! myXGlobalLo, myYGlobalLo    :: smallest indices of global fields
  ! theta         :: temperature
  ! objf_test     :: objective/cost function contribution defined in cost.h
  ! myThid        :: my Thread Id number
  ! This requires TAF_FORTRAN_VERS > F77
  integer, intent(in) :: sNx, sNy, nSx, nSy, OLx, OLy, Nr
  integer, intent(in) :: myBxLo, myBxHi, myByLo, myByHi
  integer, intent(in) :: myXGlobalLo, myYGlobalLo
  _RL, intent(in)     :: theta(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
  _RL, intent(inout)  :: objf_test(nSx,nSy)
  integer, intent(in) :: myThid

#ifdef ALLOW_COST
  !   !LOCAL VARIABLES:
  ! loop indices
  integer :: i, j, k, ig, jg
  integer :: bi, bj
!EOP

  do bj=myByLo,myByHi
   do bi=myBxLo,myBxHi
    objf_test(bi,bj)= 0. _d 0
   enddo
  enddo

  k = 1

  ! Calculate cost function on tile of this instance
  do bj=myByLo,myByHi
   do bi=myBxLo,myBxHi
    do j=1,sNy
     jg = myYGlobalLo-1+(bj-1)*sNy+j
     do i=1,sNx
      ig = myXGlobalLo-1+(bi-1)*sNx+i
      if ((jg .gt.30) .and. (jg .lt.40)) then
       objf_test(bi,bj) = objf_test(bi,bj) + theta(i,j,k,bi,bj)
       write(*,'(a,F10.1,3(x,i4),a,4(x,i4))') &
            'objf_test  ', objf_test(bi,bj), ig, jg, k, ' TILE ', i, j, bi, bj
      endif
     enddo
    enddo

    objf_test(bi,bj) = objf_test(bi,bj) / 9. _d 0

   enddo
  enddo
#endif /* ALLOW_COST */

  return
  ! This requires TAF_FORTRAN_VERS > F77
end subroutine cost_test_local

#include "PACKAGES_CONFIG.h"
#include "CPP_OPTIONS.h"

CBOP
C     !ROUTINE: INI_THETA
C     !INTERFACE:
      SUBROUTINE INI_THETA( myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE INI_THETA
C     | o Set model initial temperature field.
C     *==========================================================*
C     | There are several options for setting the initial
C     | temperature file
C     |  1. Inline code
C     |  2. Vertical profile ( uniform T in X and Y )
C     |  3. Three-dimensional data from a file. For example from
C     |     Levitus or from a checkpoint file from a previous
C     |     integration.
C     | In addition to setting the temperature field we also
C     | set the initial temperature tendency term here.
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "DYNVARS.h"
#ifdef ALLOW_MNC
#include "MNC_PARAMS.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     myThid :: Number of this instance of INI_THETA
      INTEGER myThid

C     !LOCAL VARIABLES:
C     == Local variables ==
C     bi,bj  :: Tile indices
C     i,j,k  :: Loop counters
      INTEGER bi, bj
      INTEGER i, j, k, localWarnings
      _RL     Tfreezing
      CHARACTER*(MAX_LEN_MBUF) msgBuf
CEOP

C--   Initialise temperature field to the vertical reference profile
      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
        DO k=1,Nr
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           theta(i,j,k,bi,bj) = tRef(k)
          ENDDO
         ENDDO
        ENDDO
       ENDDO
      ENDDO

      IF ( hydrogThetaFile .NE. ' ' ) THEN
#ifdef ALLOW_MNC
        IF ( useMNC.AND.mnc_read_theta ) THEN
          CALL MNC_FILE_CLOSE_ALL_MATCHING(hydrogThetaFile, myThid)
          CALL MNC_CW_SET_UDIM(hydrogThetaFile, 1, myThid)
          CALL MNC_CW_SET_CITER(hydrogThetaFile, 2, -1, -1, -1, myThid)
          CALL MNC_CW_SET_UDIM(hydrogThetaFile, 1, myThid)
          CALL MNC_CW_RL_R('D',hydrogThetaFile,0,0,'Temp',theta,myThid)
          CALL MNC_FILE_CLOSE_ALL_MATCHING(hydrogThetaFile, myThid)
        ELSE
#endif /*  ALLOW_MNC  */
          CALL READ_FLD_XYZ_RL( hydrogThetaFile, ' ', theta, 0, myThid )
#ifdef ALLOW_MNC
        ENDIF
#endif /*  ALLOW_MNC  */
        _EXCH_XYZ_RL(theta,myThid)
      ENDIF

C--   Apply mask and test consistency
      localWarnings=0
      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
        DO k=1,Nr
         IF ( maskIniTemp ) THEN
          DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
            IF (maskC(i,j,k,bi,bj).EQ.0.) theta(i,j,k,bi,bj) = 0.
           ENDDO
          ENDDO
         ENDIF
         IF ( tRef(k).NE.0. ) THEN
          DO j=1,sNy
           DO i=1,sNx
            IF (  maskC(i,j,k,bi,bj).NE.0.
     &      .AND. theta(i,j,k,bi,bj).EQ.0. ) THEN
              localWarnings=localWarnings+1
            ENDIF
           ENDDO
          ENDDO
         ENDIF
        ENDDO
       ENDDO
      ENDDO
      IF (localWarnings.NE.0) THEN
       IF ( checkIniTemp ) THEN
        WRITE(msgBuf,'(A,I10,A)')
     &   ' INI_THETA: found', localWarnings,
     &   ' wet grid-pts with theta=0 identically.'
        CALL PRINT_ERROR( msgBuf , myThid)
        WRITE(msgBuf,'(A,A)')
     &  ' If this is intentional, you need to',
     &  ' set checkIniTemp=.FALSE. in "data", namelist PARM05'
        CALL PRINT_ERROR( msgBuf , myThid)
        STOP 'ABNORMAL END: S/R INI_THETA'
       ELSE
        WRITE(msgBuf,'(A,I10,A)')
     &   '** WARNINGS ** INI_THETA: found', localWarnings,
     &   ' wet grid-pts with theta=0 identically.'
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
       ENDIF
      ENDIF

C--   Check that there are no values of temperature below freezing point.
      IF ( checkIniTemp .AND. allowFreezing ) THEN
       Tfreezing=-1.9 _d 0
       DO bj = myByLo(myThid), myByHi(myThid)
        DO bi = myBxLo(myThid), myBxHi(myThid)
         DO k=1,Nr
          DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
            IF (theta(i,j,k,bi,bj) .LT. Tfreezing) THEN
               theta(i,j,k,bi,bj) = Tfreezing
            ENDIF
           ENDDO
          ENDDO
         ENDDO
        ENDDO
       ENDDO
c     ELSEIF ( allowFreezing ) THEN
c      CALL FREEZE_SURFACE( startTime, nIter0, myThid )
      ENDIF

      IF ( plotLevel.GE.debLevC ) THEN
        CALL PLOT_FIELD_XYZRL( theta, 'Initial Temperature',
     &                         Nr, 1, myThid )
      ENDIF

      RETURN
      END

#include "ECCO_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C !ROUTINE: ECCO_INIT_FIXED

C !INTERFACE:
      SUBROUTINE ECCO_INIT_FIXED( myThid )

C     !DESCRIPTION:
C     Initialize ECCO variables that are kept fixed during the run.

C     !USES:
      IMPLICIT NONE
#include "EEPARAMS.h"
#include "SIZE.h"
#include "PARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     myThid  :: my Thread Id number
      INTEGER myThid

C     !LOCAL VARIABLES:
CEOP

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C--   Initialise ecco-specific cost function. This needs to preceed
C     the call ctrl_init_fixed in order to provide the weight files.
#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_CALL('ECCO_COST_INIT_FIXED',myThid)
#endif
      CALL ECCO_COST_INIT_FIXED( myThid )

#ifdef ALLOW_DIAGNOSTICS
      IF ( useDiagnostics ) THEN
        CALL ECCO_DIAGNOSTICS_INIT( myThid )
      ENDIF
#endif

      RETURN
      END

#include "ZONAL_FILT_OPTIONS.h"

      SUBROUTINE ZONAL_FILT_POSTSMOOTH( 
     I                           holeMask, 
     U                           field, 
     O                           avgField,
     I                           lField,
     I                           myThid )
C     /==========================================================\
C     | S/R ZONAL_FILT_POSTSMOOTH                                |
C     | o After FFT filtering processing.                        |
C     |==========================================================|
C     | Restore the mean value that was removed prior to FFT.    |
C     \==========================================================/
      IMPLICIT NONE

C     == Global data ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"

C     == Routine arguments ==
C     holeMask - Array with 0 for holes and != 0 for valid data.
C     lField   - Length of field to smooth (assumed periodic)
C     field    - Field smoothed.
C     avgField - Mean value of the field.
C     myThid   - Thread number of this instance of FFT_PRESMOOTH_IN_X
      INTEGER lField
      Real*8  holeMask(lField)
      Real*8  field(lField)
      Real*8  avgField
      INTEGER myThid

#ifdef ALLOW_ZONAL_FILT

C     == Local variables ====
C     I         - Loop counter
C 
      INTEGER I

C
C     Add fields mean value back in.
      DO I=1,lField
       IF ( holeMask(I) .NE. 0. ) THEN 
        field(I) = field(I) + avgField
       ELSE
        field(I) = 0.
       ENDIF
      ENDDO

#endif /* ALLOW_ZONAL_FILT */

      RETURN
      END

#include "SEAICE_OPTIONS.h"
#ifdef ALLOW_OBCS
# include "OBCS_OPTIONS.h"
#endif

CBOP
C     !ROUTINE: SEAICE_OCEANDRAG_COEFFS
C     !INTERFACE:
      SUBROUTINE SEAICE_OCEANDRAG_COEFFS(
     I     uIceLoc, vIceLoc, HEFFMLoc,
     O     CwatC,
     I     iStep, myTime, myIter, myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE SEAICE_OCEANDRAG_COEFFS
C     | o Compute the drag coefficients for ice-ocean drag,
C     |   so that we can use the same code for different solvers
C     *==========================================================*
C     | written by Martin Losch, Oct 2012
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "DYNVARS.h"
#include "SEAICE_SIZE.h"
#include "SEAICE_PARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
C     myTime :: Simulation time
C     myIter :: Simulation timestep number
C     myThid :: my Thread Id. number
C     iStep  :: current sub-time step iterate
      _RL     myTime
      INTEGER myIter
      INTEGER myThid
      INTEGER iStep
C     u/vIceLoc :: local copies of the current ice velocity
      _RL uIceLoc(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL vIceLoc(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
C     HEFFMLoc  :: local copy of land-sea masks
      _RL HEFFMLoc  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
C     CwatC     :: drag coefficients
      _RL CwatC(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)

#ifdef SEAICE_CGRID
C     === local variables ===
C     i,j,bi,bj,ksrf :: loop indices
      INTEGER i,j,bi,bj
      INTEGER kSrf
      _RL     tempVar, tempMin
      _RL     dragCoeff
CEOP

      IF ( usingPCoords ) THEN
       kSrf = Nr
      ELSE
       kSrf = 1
      ENDIF
      tempMin = SEAICEdWatMin*SEAICEdWatMin

      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        DO j=1-OLy,sNy+OLy-1
         DO i=1-OLx,sNx+OLy-1
C     non-linear water drag coefficients CwatC (DWATN)
#ifdef OBCS_UVICE_OLD
          tempVar = 0.25 _d 0*(
     &            ( ( uIceLoc(i  ,j,bi,bj)-uVel(i  ,j,kSrf,bi,bj) )
     &             +( uIceLoc(i+1,j,bi,bj)-uVel(i+1,j,kSrf,bi,bj) )
     &            )**2
     &          + ( ( vIceLoc(i, j ,bi,bj)-vVel(i, j ,kSrf,bi,bj) )
     &             +( vIceLoc(i,j+1,bi,bj)-vVel(i,j+1,kSrf,bi,bj) )
     &            )**2 )
#else /* OBCS_UVICE_OLD */
          tempVar = 0.25 _d 0*(
     &            ( ( uIceLoc(i  ,j,bi,bj)-uVel(i  ,j,kSrf,bi,bj) )
     &             *maskInW( i ,j,bi,bj)
     &             +( uIceLoc(i+1,j,bi,bj)-uVel(i+1,j,kSrf,bi,bj) )
     &             *maskInW(i+1,j,bi,bj) )**2
     &          + ( ( vIceLoc(i,j  ,bi,bj)-vVel(i,j  ,kSrf,bi,bj) )
     &             *maskInS(i, j ,bi,bj)
     &             +( vIceLoc(i,j+1,bi,bj)-vVel(i,j+1,kSrf,bi,bj) )
     &             *maskInS(i,j+1,bi,bj) )**2 )
#endif /* OBCS_UVICE_OLD */
          IF ( YC(i,j,bi,bj) .LT. ZERO ) THEN
           dragCoeff = SEAICE_waterDrag_south*rhoConst
          ELSE
           dragCoeff = SEAICE_waterDrag      *rhoConst
          ENDIF
          CwatC(i,j,bi,bj) = SEAICEdWatMin
C     This is the AD-proof version of
C         IF ( dragCoeff * SQRT(tempVar) .GT. SEAICEdWatMin )
C     which was previously implemented as
C         IF ( tempVar .GT. (SEAICEdWatMin/dragCoeff)**2 )
C     I like this better:
          IF ( dragCoeff*dragCoeff * tempVar .GT. tempMin )
     &         CwatC(i,j,bi,bj) = dragCoeff*SQRT(tempVar)
          CwatC(i,j,bi,bj) = CwatC(i,j,bi,bj) * HEFFMLoc(i,j,bi,bj)
         ENDDO
        ENDDO
       ENDDO
      ENDDO

#endif /* SEAICE_CGRID */

      RETURN
      END

module diffusivity_mod

!=======================================================================
!
!                          DIFFUSIVITY MODULE
!
!     Routines for computing atmospheric diffusivities in the
!       planetary boundary layer and in the free atmosphere
!
!=======================================================================

use gcm_params_mod, only: gcm_LEN_MBUF, gcm_SQZ_R, gcm_stdMsgUnit
use constants_mod, only : grav, vonkarm, cp_air, rdgas, rvgas

!use       fms_mod, only:  error_mesg, FATAL, file_exist,   &
!                          check_nml_error, open_namelist_file,      &
!                          mpp_pe, mpp_root_pe, close_file, stdlog,  &
!                          write_version_number

use monin_obukhov_mod, only : mo_diff

implicit none
private

! public interfaces
!=======================================================================

 public diffusivity, pbl_depth, molecular_diff

!=======================================================================

! form of iterfaces

!=======================================================================
! subroutine diffusivity (t, q, u, v, p_full, p_half, z_full, z_half,
!                         u_star, b_star, h, k_m, k_t)

! input:

!        t     : real, dimension(:,:,:) -- (:,:,pressure), third index running
!                          from top of atmosphere to bottom
!                 temperature (K)
!
!        q     : real, dimension(:,:,:)
!                 water vapor specific humidity (nondimensional)
!
!        u     : real, dimension(:,:)
!                 zonal wind (m/s)
!
!        v     : real, dimension(:,:,:)
!                 meridional wind (m/s)
!
!        z_full  : real, dimension(:,:,:
!                 height of full levels (m)
!                 1 = top of atmosphere; size(p_half,3) = surface
!                 size(z_full,3) = size(t,3)
!
!        z_half  : real, dimension(:,:,:)
!                 height of  half levels (m)
!                 size(z_half,3) = size(t,3) +1
!              z_half(:,:,size(z_half,3)) must be height of surface!
!                                  (if you are not using eta-model)
!
!        u_star: real, dimension(:,:)
!                friction velocity (m/s)
!
!        b_star: real, dimension(:,:)
!                buoyancy scale (m/s**2)

!   (u_star and b_star can be obtained by calling
!     mo_drag in monin_obukhov_mod)

! output:

!        h     : real, dimension(:,:,)
!                 depth of planetary boundary layer (m)
!
!        k_m   : real, dimension(:,:,:)
!                diffusivity for momentum (m**2/s)
!
!                defined at half-levels
!                size(k_m,3) should be at least as large as size(t,3)
!                only the returned values at
!                      levels 2 to size(t,3) are meaningful
!                other values will be returned as zero
!
!        k_t   : real, dimension(:,:,:)
!                diffusivity for temperature and scalars (m**2/s)
!
!
!=======================================================================

!--------------------- version number ----------------------------------

character(len=128) :: version = '$Id: diffusivity_mod.F90,v 1.2 2017/08/11 20:48:50 jmc Exp $'
character(len=128) :: tag = '$Name:  $'

!=======================================================================

!  DEFAULT VALUES OF NAMELIST PARAMETERS:

logical :: fixed_depth         = .false.
logical :: do_virtual_non_mcm  = .false.  ! applies only to non-'mcm' pbl scheme
real    :: depth_0             =  5000.0
real    :: frac_inner          =  0.1
real    :: rich_crit_pbl       =  1.0
real    :: entr_ratio          =  0.2
real    :: parcel_buoy         =  2.0
real    :: znom                =  1000.0
logical :: free_atm_diff       = .false.
logical :: free_atm_skyhi_diff = .false.
logical :: pbl_mcm             = .false.
real    :: rich_crit_diff      =  0.25
real    :: mix_len             = 30.
real    :: rich_prandtl        =  1.00
real    :: background_m        =  0.0
real    :: background_t        =  0.0
logical :: ampns               = .false. ! include delta z factor in
                                         ! defining ri ?
real    :: ampns_max           = 1.0E20  ! limit to reduction factor
                                         ! applied to ri due to delta z
                                         ! factor

namelist /diffusivity_nml/ fixed_depth, depth_0, frac_inner,&
                           rich_crit_pbl, entr_ratio, parcel_buoy,&
                           znom, free_atm_diff, free_atm_skyhi_diff,&
                           pbl_mcm, rich_crit_diff, mix_len, rich_prandtl,&
                           background_m, background_t, ampns, ampns_max, &
                           do_virtual_non_mcm

!=======================================================================

!  OTHER MODULE VARIABLES

real    :: small  = 1.e-04
real    :: gcp    = grav/cp_air
logical :: init   = .false.
real    :: beta   = 1.458e-06
real    :: rbop1  = 110.4
real    :: rbop2  = 1.405

real, parameter :: d608 = (rvgas-rdgas)/rdgas

contains

!=======================================================================

subroutine diffusivity_init(myThid)

integer, intent(in) :: myThid
integer :: unit, ierr, io

integer         :: iUnit
CHARACTER*(gcm_LEN_MBUF) :: msgBuf

!------------------- read namelist input -------------------------------

! read namelist and copy to logfile

!    _BARRIER
!    _BEGIN_MASTER(myThid)
     CALL BARRIER(myThid)
     IF ( myThid.EQ.1 ) THEN

     WRITE(msgBuf,'(A)') 'DIFFUSIVITY_INIT: opening data.atm_gray'
     CALL PRINT_MESSAGE( msgBuf, gcm_stdMsgUnit, gcm_SQZ_R, myThid )
     CALL OPEN_COPY_DATA_FILE(                                      &
                           'data.atm_gray', 'DIFFUSIVITY_INIT',       &
                           iUnit,                                   &
                           myThid )
!    Read parameters from open data file
     READ(UNIT=iUnit,NML=diffusivity_nml)
     WRITE(msgBuf,'(A)')                                            &
          'DIFFUSIVITY_INIT: finished reading data.atm_gray'
     CALL PRINT_MESSAGE( msgBuf, gcm_stdMsgUnit, gcm_SQZ_R, myThid )
!    Close the open data file
#ifdef SINGLE_DISK_IO
     CLOSE(iUnit)
#else
     CLOSE(iUnit,STATUS='DELETE')
#endif /* SINGLE_DISK_IO */

!     if (file_exist('input.nml')) then
!        unit = open_namelist_file ()
!        ierr=1; do while (ierr /= 0)
!           read  (unit, nml=diffusivity_nml, iostat=io, end=10)
!           ierr = check_nml_error(io,'diffusivity_nml')
!        enddo
! 10     call close_file (unit)

!------------------- dummy checks --------------------------------------
         if (frac_inner .le. 0. .or. frac_inner .ge. 1.) &
            CALL PRINT_ERROR( 'diffusivity_init'//  &
            'frac_inner must be between 0 and 1', myThid)
!           call error_mesg ('diffusivity_init',  &
!           'frac_inner must be between 0 and 1', FATAL)
         if (rich_crit_pbl .lt. 0.) &
            CALL PRINT_ERROR( 'diffusivity_init'//  &
           'rich_crit_pbl must be greater than or equal to zero', myThid )
!           call error_mesg ('diffusivity_init',  &
!          'rich_crit_pbl must be greater than or equal to zero', FATAL)
         if (entr_ratio .lt. 0.) &
            CALL PRINT_ERROR( 'diffusivity_init'//  &
            'entr_ratio must be greater than or equal to zero', myThid )
!           call error_mesg ('diffusivity_init',  &
!           'entr_ratio must be greater than or equal to zero', FATAL)
         if (znom .le. 0.) &
            CALL PRINT_ERROR( 'diffusivity_init'//  &
            'znom must be greater than zero', myThid )
!           call error_mesg ('diffusivity_init',  &
!           'znom must be greater than zero', FATAL)
         if (.not.free_atm_diff .and. free_atm_skyhi_diff)&
            CALL PRINT_ERROR( 'diffusivity_init'//  &
            'free_atm_diff must be set to true if '//&
            'free_atm_skyhi_diff = .true.', myThid )
!           call error_mesg ('diffusivity_init',  &
!           'free_atm_diff must be set to true if '//&
!           'free_atm_skyhi_diff = .true.', FATAL)
         if (rich_crit_diff .le. 0.) &
            CALL PRINT_ERROR( 'diffusivity_init'//  &
            'rich_crit_diff must be greater than zero', myThid )
!           call error_mesg ('diffusivity_init',  &
!           'rich_crit_diff must be greater than zero', FATAL)
         if (mix_len .lt. 0.) &
            CALL PRINT_ERROR( 'diffusivity_init'//  &
            'mix_len must be greater than or equal to zero', myThid )
!           call error_mesg ('diffusivity_init',  &
!           'mix_len must be greater than or equal to zero', FATAL)
         if (rich_prandtl .lt. 0.) &
            CALL PRINT_ERROR( 'diffusivity_init'//  &
            'rich_prandtl must be greater than or equal to zero', myThid )
!           call error_mesg ('diffusivity_init',  &
!           'rich_prandtl must be greater than or equal to zero', FATAL)
         if (background_m .lt. 0.) &
            CALL PRINT_ERROR( 'diffusivity_init'//  &
            'background_m must be greater than or equal to zero', myThid )
!           call error_mesg ('diffusivity_init',  &
!           'background_m must be greater than or equal to zero', FATAL)
         if (background_t .lt. 0.) &
            CALL PRINT_ERROR( 'diffusivity_init'//  &
            'background_t must be greater than or equal to zero', myThid )
!           call error_mesg ('diffusivity_init',  &
!           'background_t must be greater than or equal to zero', FATAL)
         if (ampns_max .lt. 1.) &
            CALL PRINT_ERROR( 'diffusivity_init'//  &
            'ampns_max must be greater than or equal to one', myThid )
!           call error_mesg ('diffusivity_init',  &
!           'ampns_max must be greater than or equal to one', FATAL)
         if (ampns .and. .not. free_atm_skyhi_diff) &
            CALL PRINT_ERROR( 'diffusivity_init'//  &
            'ampns is only valid when free_atm_skyhi_diff is & also true', myThid )
!           call error_mesg ('diffusivity_init',  &
!           'ampns is only valid when free_atm_skyhi_diff is &
!                  & also true', FATAL)

!     endif  !end of reading input.nml

!---------- output namelist to log-------------------------------------

!     call write_version_number(version, tag)
!     if ( mpp_pe() == mpp_root_pe() ) write (stdlog(), nml=diffusivity_nml)

      init = .true.

     ENDIF
     CALL BARRIER(myThid)

return
end subroutine diffusivity_init

!=======================================================================

subroutine diffusivity(t, q, u, v, p_full, p_half, z_full, z_half,  &
                       u_star, b_star, h, k_m, k_t, myThid, kbot)

real,    intent(in),           dimension(:,:,:) :: t, q, u, v
real,    intent(in),           dimension(:,:,:) :: p_full, p_half
real,    intent(in),           dimension(:,:,:) :: z_full, z_half
real,    intent(in),           dimension(:,:)   :: u_star, b_star
real,    intent(inout),        dimension(:,:,:) :: k_m, k_t
real,    intent(out),          dimension(:,:)   :: h
integer, intent (in)                            :: myThid
integer, intent(in), optional, dimension(:,:)   :: kbot

real, dimension(size(t,1),size(t,2),size(t,3))  :: svcp,z_full_ag, &
                                                   k_m_save, k_t_save
real, dimension(size(t,1),size(t,2),size(t,3)+1):: z_half_ag
real, dimension(size(t,1),size(t,2))            :: z_surf
integer                                         :: i,j,k,nlev,nlat,nlon

if(.not.init) call diffusivity_init(myThid)

nlev = size(t,3)

k_m_save = k_m
k_t_save = k_t

!compute height of surface
if (present(kbot)) then
   nlat = size(t,2)
   nlon = size(t,1)
   do j=1,nlat
   do i=1,nlon
          z_surf(i,j) = z_half(i,j,kbot(i,j)+1)
   enddo
   enddo
else
   z_surf(:,:) = z_half(:,:,nlev+1)
end if

!compute density profile, and heights relative to surface
do k = 1, nlev

  z_full_ag(:,:,k) = z_full(:,:,k) - z_surf(:,:)
  z_half_ag(:,:,k) = z_half(:,:,k) - z_surf(:,:)

  if (do_virtual_non_mcm) then
   svcp(:,:,k)  =   t(:,:,k)*(1. + d608*q(:,:,k)) + gcp*(z_full_ag(:,:,k))
  else
   svcp(:,:,k)  =   t(:,:,k) + gcp*(z_full_ag(:,:,k))
  endif

end do
z_half_ag(:,:,nlev+1) = z_half(:,:,nlev+1) - z_surf(:,:)

if(fixed_depth)  then
   h = depth_0
else
   call pbl_depth(svcp,u,v,z_full_ag,u_star,b_star,h, myThid, kbot=kbot)
end if

if(pbl_mcm) then
   call diffusivity_pbl_mcm (u,v, t, p_full, p_half, &
                             z_full_ag, z_half_ag, h, k_m, k_t, myThid)
else
   call diffusivity_pbl  (svcp, u, v, z_half_ag, h, u_star, b_star,&
                       k_m, k_t, myThid, kbot=kbot)
end if
if(free_atm_diff) &
   call diffusivity_free (svcp, u, v, z_full_ag, z_half_ag, h, k_m, k_t, myThid)

k_m = k_m + k_m_save
k_t = k_t + k_t_save

!NOTE THAT THIS LINE MUST FOLLOW DIFFUSIVITY_FREE SO THAT ENTRAINMENT
!K's DO NOT GET OVERWRITTEN IN DIFFUSIVITY_FREE SUBROUTINE
if(entr_ratio .gt. 0. .and. .not. fixed_depth) &
    call diffusivity_entr(svcp,z_full_ag,h,u_star,b_star,k_m,k_t, myThid)

!set background diffusivities
if(background_m.gt.0.0) k_m = max(k_m,background_m)
if(background_t.gt.0.0) k_t = max(k_t,background_t)

return
end subroutine diffusivity

!=======================================================================

subroutine pbl_depth(t, u, v, z, u_star, b_star, h, myThid, kbot)

real,   intent(in) ,           dimension(:,:,:) :: t, u, v, z
real,   intent(in) ,           dimension(:,:)   :: u_star,b_star
real,   intent(out),           dimension(:,:)   :: h
integer, intent(in)                             :: myThid
integer,intent(in) , optional, dimension(:,:)   :: kbot

real,    dimension(size(t,1),size(t,2),size(t,3))  :: rich
real,    dimension(size(t,1),size(t,2))            :: ws,k_t_ref,&
                                                      h_inner,tbot
real                                               :: rich1, rich2,&
                                                      h1,h2,svp,t1,t2
integer, dimension(size(t,1),size(t,2))            :: ibot
integer                                            :: i,j,k,nlon,&
                                                      nlat, nlev

nlev = size(t,3)
nlat = size(t,2)
nlon = size(t,1)

!assign ibot, compute tbot (virtual temperature at lowest level)
if (present(kbot)) then
    ibot(:,:) = kbot
    do j = 1,nlat
    do i = 1,nlon
          tbot(i,j) = t(i,j,ibot(i,j))
    enddo
    enddo
else
    ibot(:,:) = nlev
    tbot(:,:) = t(:,:,nlev)
end if

!compute richardson number for use in pbl depth of neutral/stable side
do k = 1,nlev
  rich(:,:,k) =  z(:,:,k)*grav*(t(:,:,k)-tbot(:,:))/tbot(:,:)&
                /(u(:,:,k)*u(:,:,k) + v(:,:,k)*v(:,:,k) + small )
end do

!compute ws to be used in evaluating parcel buoyancy
!ws = u_star / phi(h_inner,u_star,b_star)  .  To find phi
!a call to mo_diff is made.

h_inner(:,:)=frac_inner*znom
call mo_diff(h_inner, u_star, b_star, ws, k_t_ref, myThid )
ws = max(small,ws/vonkarm/h_inner)

do j = 1, nlat
 do i = 1, nlon

        !do neutral or stable case
        if (b_star(i,j).le.0.) then

              h1     = z(i,j,ibot(i,j))
              h(i,j) = h1
              rich1  = rich(i,j,ibot(i,j))
              do k = ibot(i,j)-1, 1, -1
                       rich2 = rich(i,j,k)
                       h2    = z(i,j,k)
                       if(rich2.gt.rich_crit_pbl) then
                             h(i,j) = h2 + (h1 - h2)*(rich2 - rich_crit_pbl)&
                                                    /(rich2 - rich1        )
                             go to 10
                       endif
                       rich1 = rich2
                       h1    = h2
              enddo

        !do unstable case
        else

              svp    = tbot(i,j)*(1.+ &
                       (parcel_buoy*u_star(i,j)*b_star(i,j)/grav/ws(i,j)) )
              h1     = z(i,j,ibot(i,j))
              h(i,j) = h1
              t1     = tbot(i,j)
              do k = ibot(i,j)-1 , 1, -1
                       h2 = z(i,j,k)
                       t2 = t(i,j,k)
                       if (t2.gt.svp) then
                             h(i,j) = h2 + (h1 - h2)*(t2 - svp)/(t2 - t1 )
                             go to 10
                       end if
                       h1 = h2
                       t1 = t2
              enddo

        end if
10 continue
  enddo
enddo

return
end subroutine pbl_depth

!=======================================================================

subroutine diffusivity_pbl(t, u, v, z_half, h, u_star, b_star, &
                           k_m, k_t, myThid, kbot)

real,    intent(in)  ,           dimension(:,:,:) :: t, u, v, z_half
real,    intent(in)  ,           dimension(:,:)   :: h, u_star, b_star
real,    intent(inout) ,           dimension(:,:,:) :: k_m, k_t
integer, intent (in)                                :: myThid
integer, intent(in)  , optional, dimension(:,:)   :: kbot

real, dimension(size(t,1),size(t,2))              :: h_inner, k_m_ref,&
                                                     k_t_ref, factor
real, dimension(size(t,1),size(t,2),size(t,3)+1)  :: zm
real                                              :: h_inner_max
integer                                           :: i,j, k, kk, nlev

nlev = size(t,3)

!assign z_half to zm, and set to zero any values of zm < 0.
!the setting to zero is necessary so that when using eta model
!below ground half levels will have zero k_m and k_t
zm = z_half
if (present(kbot)) then
   where(zm < 0.)
        zm = 0.
   end where
end if

h_inner    = frac_inner*h
h_inner_max = maxval(h_inner)

kk = nlev
do k = 2, nlev
  if( minval(zm(:,:,k)) < h_inner_max) then
      kk = k
      exit
  end if
end do

k_m = 0.0
k_t = 0.0

call mo_diff(h_inner        , u_star, b_star, k_m_ref         , k_t_ref, myThid )
call mo_diff(zm(:,:,kk:nlev), u_star, b_star, k_m(:,:,kk:nlev), k_t(:,:,kk:nlev), &
              myThid )

do k = 2, nlev
  where(zm(:,:,k) >= h_inner .and. zm(:,:,k) < h)
    factor = (zm(:,:,k)/h_inner)* &
             (1.0 - (zm(:,:,k) - h_inner)/(h - h_inner))**2
    k_m(:,:,k) = k_m_ref*factor
    k_t(:,:,k) = k_t_ref*factor
  end where
end do

return
end subroutine diffusivity_pbl

!=======================================================================

subroutine diffusivity_pbl_mcm(u, v, t, p_full, p_half, z_full, z_half, &
                               h, k_m, k_t, myThid)

real, intent(in)  , dimension(:,:,:) :: u, v, t, z_full, z_half
real, intent(in)  , dimension(:,:,:) :: p_full, p_half
real, intent(in)  , dimension(:,:)   :: h
real, intent(inout) , dimension(:,:,:) :: k_m, k_t
integer, intent(in)                    :: myThid

integer                                        :: k, nlev
real, dimension(size(z_full,1),size(z_full,2)) :: elmix, htcrit
real, dimension(size(z_full,1),size(z_full,2)) :: delta_u, delta_v, delta_z

real :: htcrit_ss
real :: h_ss
real, dimension(size(z_full,1),size(z_full,2)) :: sig_half, z_half_ss, elmix_ss

!  htcrit_ss = height at which mixing length is a maximum (75m)

!  h_ss   = height at which mixing length vanishes (4900m)
!  elmix_ss   = mixing length

! Define some constants:
!  salaps = standard atmospheric lapse rate (K/m)
!  tsfc   = idealized global mean surface temperature (15C)
real :: tsfc = 288.16
real :: salaps = -6.5e-3

nlev = size(z_full,3)

k_m = 0.

h_ss = depth_0
htcrit_ss = frac_inner*h_ss

do k = 2, nlev

! TK mods 8/13/01:  (code derived from SS)
! Compute the height of each half level assuming a constant
! standard lapse rate using the above procedure.
! WARNING: These should be used with caution.  They will
!  have large errors above the tropopause.

! In order to determine the height, the layer mean temperature
! from the surface to that level is required.  A surface
! temperature of 15 deg Celsius and a standard lapse rate of
! -6.5 deg/km will be used to estimate an average temperature
! profile.

   sig_half = p_half(:,:,k)/p_half(:,:,nlev+1)
   z_half_ss = -rdgas * .5*(tsfc+tsfc*(sig_half**(-rdgas*salaps/grav))) * alog(sig_half)/grav

   !compute mixing length as in SS (no geographical variation)
    elmix_ss = 0.

    where (z_half_ss < htcrit_ss .and. z_half_ss > 0.)
         elmix_ss = vonkarm*z_half_ss
    endwhere
    where (z_half_ss >= htcrit_ss .and. z_half_ss < h_ss)
         elmix_ss = vonkarm*htcrit_ss*(h_ss-z_half_ss)/(h_ss-htcrit_ss)
    endwhere

   delta_z = rdgas*0.5*(t(:,:,k)+t(:,:,k-1))*(p_full(:,:,k)-p_full(:,:,k-1))/&
             (grav*p_half(:,:,k))
   delta_u =      u(:,:,k-1) -      u(:,:,k)
   delta_v =      v(:,:,k-1) -      v(:,:,k)

   k_m(:,:,k) =   elmix_ss * elmix_ss *&
                  sqrt(delta_u*delta_u + delta_v*delta_v)/delta_z

end do

k_t = k_m

return
end subroutine diffusivity_pbl_mcm

!=======================================================================

subroutine diffusivity_free(t, u, v, z, zz, h, k_m, k_t, myThid)

real, intent(in)    , dimension(:,:,:) :: t, u, v, z, zz
real, intent(in)    , dimension(:,:)   :: h
real, intent(inout) , dimension(:,:,:) :: k_m, k_t
integer, intent(in)                    :: myThid

real, dimension(size(t,1),size(t,2))   :: dz, b, speed2, rich, fri, &
                                          alpz, fri2
integer                                :: k

do k = 2, size(t,3)

!----------------------------------------------------------------------
!  define the richardson number. set it to zero if it is negative. save
!  a copy of it for later use (rich2).
!----------------------------------------------------------------------
  dz     = z(:,:,k-1) - z(:,:,k)
  b      = grav*(t(:,:,k-1)-t(:,:,k))/t(:,:,k)
  speed2 = (u(:,:,k-1) - u(:,:,k))**2 + (v(:,:,k-1) - v(:,:,k))**2
  rich= b*dz/(speed2+small)
  rich = max(rich, 0.0)

  if (free_atm_skyhi_diff) then
!---------------------------------------------------------------------
!   limit the standard richardson number to between 0 and the critical
!   value (rich2). compute the richardson number factor needed in the
!   eddy mixing coefficient using this standard richardson number.
!---------------------------------------------------------------------
    where (rich(:,:) >= rich_crit_diff)
      fri2(:,:) = 0.0
    elsewhere
      fri2(:,:)  = (1.0 - rich/rich_crit_diff)**2
    endwhere
  endif

!---------------------------------------------------------------------
!  if ampns is activated, compute the delta z factor. define rich
!  including this factor.
!---------------------------------------------------------------------
  if (ampns) then
    alpz(:,:) = MIN ( (1.  + 1.e-04*(dz(:,:)**1.5)), ampns_max)
    rich(:,:) = rich(:,:) / alpz(:,:)
  endif

!---------------------------------------------------------------------
!   compute the richardson number factor to be used in the eddy
!   mixing coefficient. if ampns is on, this value includes it; other-
!   wise it does not.
!---------------------------------------------------------------------
  fri(:,:)   = (1.0 - rich/rich_crit_diff)**2

!---------------------------------------------------------------------
!   compute the eddy mixing coefficients in the free atmosphere ( zz
!   > h). in the non-ampns case, values are obtained only when the
!   standard richardson number is sub-critical; in the ampns case values
!   are obtained only when the richardson number computed with the
!   ampns factor is sub critical. when the ampns factor is activated,
!   it is also included in the mixing coefficient. the value of mixing
!   for temperature, etc. is reduced dependent on the ri stability
!   factor calculated without the ampns factor.
!---------------------------------------------------------------------
  if (free_atm_skyhi_diff) then

!---------------------------------------------------------------------
!   this is the skyhi-like formulation -- possible ampns factor, ratio
!   of k_m to k_t defined based on computed stability factor.
!---------------------------------------------------------------------
    if (ampns) then
      where (rich < rich_crit_diff .and. zz(:,:,k) > h)
           k_m(:,:,k) = mix_len*mix_len*sqrt(speed2)*fri(:,:)* &
                        ( 1.  + 1.e-04*(dz(:,:)**1.5))/dz
           k_t(:,:,k) = k_m(:,:,k)* (0.1 + 0.9*fri2(:,:))
      end where
    else
      where (rich < rich_crit_diff .and. zz(:,:,k) > h)
        k_m(:,:,k) = mix_len*mix_len*sqrt(speed2)*fri(:,:)/dz
        k_t(:,:,k) = k_m(:,:,k)* (0.1 + 0.9*fri2(:,:))
      end where
    endif
  else

!---------------------------------------------------------------------
!   this is the non-skyhi-like formulation -- no ampns factor, ratio
!   of k_m to k_t defined by rich_prandtl.
!---------------------------------------------------------------------
    where (rich < rich_crit_diff .and. zz(:,:,k) > h)
         k_t(:,:,k) = mix_len*mix_len*sqrt(speed2)*fri(:,:)/dz
         k_m(:,:,k) = k_t(:,:,k)*rich_prandtl
    end where
  end if
end do

end subroutine diffusivity_free

!=======================================================================

subroutine molecular_diff ( temp, press, k_m, k_t, myThid)

real, intent(in),    dimension (:,:,:)  ::  temp, press
real, intent(inout), dimension (:,:,:)  ::  k_m, k_t
integer, intent(in)                     :: myThid

      real, dimension (size(temp,1), size(temp,2)) :: temp_half, &
                                                      rho_half, rbop2d
      integer      :: k

!---------------------------------------------------------------------

      do k=2,size(temp,3)
        temp_half(:,:) = 0.5*(temp(:,:,k) + temp(:,:,k-1))
        rho_half(:,:) = press(:,:,k)/(rdgas*temp_half(:,:) )
        rbop2d(:,:)  = beta*temp_half(:,:)*sqrt(temp_half(:,:))/  &
                       (rho_half(:,:)*(temp_half(:,:)+rbop1))
        k_m(:,:,k) = rbop2d(:,:)
        k_t(:,:,k) = rbop2d(:,:)*rbop2
      end do

      k_m(:,:,1) = 0.0
      k_t(:,:,1) = 0.0

end subroutine molecular_diff

!=======================================================================

subroutine diffusivity_entr(t, z,  h, u_star, b_star, k_m, k_t, myThid)

real, intent(in)    , dimension(:,:,:) :: t, z
real, intent(in)    , dimension(:,:)   :: h, u_star, b_star
real, intent(inout) , dimension(:,:,:) :: k_m, k_t
integer, intent(in)                    :: myThid

integer                                :: k, nlev

nlev=size(t,3)

do k = 2,nlev
    where (b_star .gt. 0. .and. z(:,:,k-1) .gt. h .and. &
                                z(:,:,k)   .le. h)
        k_t(:,:,k) = (z(:,:,k-1)-z(:,:,k))*entr_ratio*t(:,:,k)* &
                      u_star*b_star/grav/max(small,t(:,:,k-1)-t(:,:,k))
        k_m(:,:,k) = k_t(:,:,k)
    end where
enddo
end subroutine diffusivity_entr

!=======================================================================

end module diffusivity_mod

#include "DIC_OPTIONS.h"

CBOP
C !ROUTINE: CAR_FLUX_OMEGA_TOP

C !INTERFACE: ==========================================================
      SUBROUTINE CAR_FLUX_OMEGA_TOP( bioac, cflux,
     I           bi,bj,imin,imax,jmin,jmax,
     I           myTime, myIter, myThid )

C !DESCRIPTION:
C  Calculate carbonate fluxes
C  HERE ONLY HAVE DISSOLUTION WHEN OMEGA < 1.0
C  Karsten Friis and Mick Follows Sep 2004

C !USES: ===============================================================
      IMPLICIT NONE
#include "SIZE.h"
#include "DYNVARS.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "DIC_VARS.h"

C !INPUT PARAMETERS: ===================================================
C  bioac                :: biological productivity
C  myTime               :: current time
C  myIter               :: current timestep
C  myThid               :: thread number
      _RL  bioac(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      INTEGER imin, imax, jmin, jmax, bi, bj
      _RL myTime
      INTEGER myIter
      INTEGER myThid

C !OUTPUT PARAMETERS: ===================================================
C cflux                :: carbonate flux
      _RL  cflux(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)

#if ( defined DIC_BIOTIC && defined DIC_CALCITE_SAT )
C !LOCAL VARIABLES: ====================================================
C  i,j,k                  :: loop indices
C  ko                     :: loop-within-loop index
C caexport                :: flux of carbonate from base each "productive"
C                            layer
C depth_u, depth_l        :: depths of upper and lower interfaces
C flux_u, flux_l          :: flux through upper and lower interfaces
       _RL caexport(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
       INTEGER i,j,k, ko, kBottom
       _RL flux_u, flux_l
C variables for calcium carbonate dissolution
       _RL DissolutionRate
       _RL dumrate

C diagnostics
c     _RL   exp_tot
c     _RL   flx_tot
c     integer knum
c     _RL   omeg_bot
c     _RL   tmp

CEOP
C initialize fluxes
      flux_u = 0. _d 0
      flux_l = 0. _d 0

C to either remineralize in bottom or top layer if flux reaches bottom layer
C      selectCalciteBottomRemin =0 : in bottom layer, =1 : in top layer
C set some nominal particulate sinking rate, try 100m/day:
C       WsinkPIC = 100. _d 0/86400. _d 0
C calculate carbonate flux from base of each nlev
       DO j=jmin,jmax
        DO i=imin,imax
c        exp_tot=0
         do k=1,Nr
            cflux(i,j,k)=0. _d 0
         enddo

         kBottom   = kLowC(i,j,bi,bj)

         DO k=1,nLev
          if (hFacC(i,j,k,bi,bj).gt.0. _d 0) then
           caexport(i,j)= R_CP*rain_ratio(i,j,bi,bj)*bioac(i,j,k)*
     &           (1. _d 0-DOPfraction)*drF(k)*hFacC(i,j,k,bi,bj)
c          exp_tot=exp_tot+caexport(i,j)
C calculate flux to each layer from base of k
           DO ko=k+1,Nr
            if (hFacC(i,j,ko,bi,bj).gt.0. _d 0) then
              if (ko .eq. k+1) then
                flux_u = caexport(i,j)
              else
                flux_u = flux_l
              endif

C flux through lower face of cell
              if (omegaC(i,j,ko,bi,bj) .gt. 1. _d 0) then
                flux_l = flux_u

C if at bottom, remineralize remaining flux
                if (ko.eq.kBottom) then
                  if (selectCalciteBottomRemin.EQ.1) then
C ... at surface
                     cflux(i,j,1)=cflux(i,j,1)+
     &                  ( (flux_l)/(drF(1)*hFacC(i,j,1,bi,bj)) )
                  else

C ... at bottom
                     flux_l=0. _d 0
                  endif
                endif
              else
C if dissolution
               IF (selectCalciteDissolution .eq. 0) THEN
C Use constant dissolution rate
                flux_l = flux_u
     &                 *(1.0-calciteDissolRate(1)*drF(k)/WsinkPIC)
               ELSEIF (selectCalciteDissolution .eq. 1) THEN
C Use Micks version of dissolution rate based on vertical sinking/remin balance
                DissolutionRate = calciteDissolRate(1)*(
     &             (
     &              1. _d 0-omegaC(i,j,ko,bi,bj)
     &             )**calciteDissolExp(1)
     &             )/(86400. _d 0)

                dumrate = -1. _d 0*DissolutionRate*drF(ko)*
     &                       hFacC(i,j,ko,bi,bj)/WsinkPIC
                flux_l = flux_u*exp(dumrate)
               ELSEIF (selectCalciteDissolution .eq. 2) THEN
C Use Karstens version of dissolution rate based on from Keir (1980) Geochem.
C  Cosmochem. Acta, and bugfix H/T Oliver Jahn (Keir,s dissolution rate in log(%))
                DissolutionRate = EXP(calciteDissolRate(1))*(
     &             (
     &              1. _d 0-omegaC(i,j,ko,bi,bj)
     &             )**calciteDissolExp(1)
     &             )/(100. _d 0 * 86400. _d 0)

                flux_l = flux_u*(1.0-DissolutionRate*drF(k)/WsinkPIC)
               ELSEIF (selectCalciteDissolution .eq. 3) THEN
C Use Naviaux et al. 2019, Marine Chemistry dissolution rates
C  The value of 0.8272 differs slightly from the paper (0.8)), but reduces the
C  large discontinuity in dissolution rates between the two states.
                IF (omegaC(i,j,ko,bi,bj) .GT. 0.8272 _d 0) THEN
                 DissolutionRate = calciteDissolRate(1) * (
     &             (
     &              1. _d 0-omegaC(i,j,ko,bi,bj)
     &             )**calciteDissolExp(1))
                ELSE
                 DissolutionRate = calciteDissolRate(2) * (
     &             (
     &              1. _d 0-omegaC(i,j,ko,bi,bj)
     &             )**calciteDissolExp(2))
                ENDIF
                flux_l = flux_u*(1.0-DissolutionRate*drF(k)/WsinkPIC)
               ENDIF

C TEST ............................
c           if(i .eq. 76 .and. j .eq. 36)then
c            write(6,*)'k,flux_l/flux_u',ko,(flux_l/flux_u)
c            write(6,*)'K, DissolutionRate, drF(k), drF(ko), WsinkPIC,OmegaC'
c            write(6,*)ko,DissolutionRate,drF(k),drF(ko),WsinkPIC,
c    &            omegaC(i,j,ko,bi,bj)
c           endif
C TEST ............................
C no flux to ocean bottom
                 if (ko.eq.kBottom)
     &                      flux_l=0. _d 0
              endif

C flux divergence
              cflux(i,j,ko)=cflux(i,j,ko) +
     &          ( (flux_u-flux_l)/(drF(ko)*hFacC(i,j,ko,bi,bj)) )
C TEST ............................
c            if(i .eq. 76 .and. j .eq. 36)then
c               write(6,*)'k,flux_l/flux_u',ko,(flux_l/flux_u)
c              write(6,*)'k,flux_l,cflux ',ko,flux_l,cflux(i,j,ko)
c            endif
C TEST ............................
            else
C if no layer below initial layer, remineralize
               if (ko.eq.k+1) then
                if ( selectCalciteBottomRemin.EQ.1 .AND.
     &                  omegaC(i,j,k,bi,bj) .GT. 1. _d 0 ) then
C ... at surface
                   cflux(i,j,1)=cflux(i,j,1)
     &                  +bioac(i,j,k)*(1. _d 0-DOPfraction)*
     &                    R_CP*rain_ratio(i,j,bi,bj)
     &                   *drF(k)*hFacC(i,j,k,bi,bj)/
     &                    (drF(1)*hFacC(i,j,1,bi,bj) )
                else
C ... at bottom
                  cflux(i,j,k)=cflux(i,j,k)
     &                  +bioac(i,j,k)*(1. _d 0-DOPfraction)*
     &                    R_CP*rain_ratio(i,j,bi,bj)
                endif
               endif
            endif
           ENDDO

          endif
         ENDDO
C diagnostic
c        flx_tot=0
c        k=0
c        do k=1,nR
c          flx_tot=flx_tot+cflux(i,j,k)*drF(k)*hFacC(i,j,k,bi,bj)
c          if (hFacC(i,j,k,bi,bj).gt.0 _d 0) then
c             knum=k
c             omeg_bot=omegaC(i,j,k,bi,bj)
c          endif
c        enddo
c        if (hFacC(i,j,k,bi,bj).gt. 0. _d 0) then
c         tmp=abs(exp_tot-flx_tot)
c         if (tmp>1 _d -20) then
c          print*,'QQ car_flux', knum,
c    &                 omeg_bot, exp_tot, flx_tot, exp_tot-flx_tot
c         endif
c        endif
C end diagnostic
        ENDDO
       ENDDO
c
#endif /* DIC_BIOTIC and DIC_CALCITE_SAT */
       RETURN
       END

#include "CAL_OPTIONS.h"

      SUBROUTINE CAL_TIMEINTERVAL(
     I                             timeint,
     I                             timeunit,
     O                             date,
     I                             myThid )

C     ==================================================================
C     SUBROUTINE cal_TimeInterval
C     ==================================================================
C
C     o Create an array in date format given a time interval measured in
C       units of timeunit.
C       Available time units: 'secs'
C                             'model'
C       Fractions of seconds are not resolved in this version.
C
C     started: Christian Eckert eckert@mit.edu  30-Jun-1999
C     changed: Christian Eckert eckert@mit.edu  29-Dec-1999
C              - restructured the original version in order to have a
C                better interface to the MITgcmUV.
C              Christian Eckert eckert@mit.edu  03-Feb-2000
C              - Introduced new routine and function names, cal_<NAME>,
C                for verion 0.1.3.
C
C     ==================================================================
C     SUBROUTINE cal_TimeInterval
C     ==================================================================

      IMPLICIT NONE

C     == global variables ==
#include "EEPARAMS.h"
#include "cal.h"

C     == routine arguments ==
      INTEGER date(4)
      _RL     timeint
      CHARACTER*(*) timeunit
      INTEGER myThid

C     == local variables ==
      INTEGER fac
      INTEGER nsecs
      INTEGER hhmmss
      INTEGER ierr
      _RL     tmp1, tmp2
      CHARACTER*(MAX_LEN_MBUF) msgBuf
C     == end of interface ==

      fac = 1
      if (timeint .lt. 0) fac = -1

      date(4) = -1
      date(3) =  0
      if (timeunit .eq. 'secs') then

        IF ( cal_setStatus .LT. 1 ) THEN
          WRITE( msgBuf,'(2A,F19.2,2A)')  'CAL_TIMEINTERVAL: ',
     &          'timeint=',timeint,' , timeunit=',timeunit
          CALL PRINT_ERROR( msgBuf, myThid )
          WRITE( msgBuf,'(2A,I2,A)') 'CAL_TIMEINTERVAL: ',
     &      'called too early (cal_setStatus=',cal_setStatus,' )'
          CALL PRINT_ERROR( msgBuf, myThid )
          STOP 'ABNORMAL END: S/R CAL_TIMEINTERVAL'
        ENDIF
        date(1) = int(timeint/float(secondsperday))
        tmp1    = date(1)
        tmp2    = secondsperday
        nsecs   = int(timeint - tmp1 * tmp2 )

      else if (timeunit .eq. 'model') then

        IF ( cal_setStatus .LT. 2 ) THEN
          WRITE( msgBuf,'(2A,F15.2,2A)')  'CAL_TIMEINTERVAL: ',
     &          'timeint=',timeint,' , timeunit=',timeunit
          CALL PRINT_ERROR( msgBuf, myThid )
          WRITE( msgBuf,'(2A,I2,A)') 'CAL_TIMEINTERVAL: ',
     &      'called too early (cal_setStatus=',cal_setStatus,' )'
          CALL PRINT_ERROR( msgBuf, myThid )
          STOP 'ABNORMAL END: S/R CAL_TIMEINTERVAL'
        ENDIF
        date(1) = int(timeint*modelstep/float(secondsperday))
        nsecs   = int(timeint*modelstep -
     &                float(date(1)) * float(secondsperday))

      else

        ierr = 701
        call cal_PrintError( ierr, myThid )
        stop ' stopped in cal_TimeInterval.'

      endif

      hhmmss  = nsecs/secondsperminute
      date(2) = hhmmss/minutesperhour*10000 +
     &          (mod(fac*hhmmss,minutesperhour)*100 +
     &           mod(fac*nsecs,secondsperminute))*fac

      RETURN
      END

#include "LAND_OPTIONS.h"

CBOP
C     !ROUTINE: LAND_STEPFWD
C     !INTERFACE:
      SUBROUTINE LAND_STEPFWD(
     I                land_frc, bi, bj, myTime, myIter, myThid)

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R LAND_STEPFWD
C     | o Land model main S/R: step forward land variables
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     == Global variables ===
C-- size for MITgcm & Land package :
#include "LAND_SIZE.h"

#include "EEPARAMS.h"
#include "LAND_PARAMS.h"
#include "LAND_VARS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     land_frc :: land fraction [0-1]
C     bi,bj    :: Tile index
C     myTime   :: Current time of simulation ( s )
C     myIter   :: Current iteration number in simulation
C     myThid   :: Number of this instance of the routine
      _RS land_frc(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      INTEGER bi, bj, myIter, myThid
      _RL myTime
CEOP

#ifdef ALLOW_LAND
C     == Local variables ==
C     i,j,k        :: loop counters
C     kp1          :: k+1
C     grd_HeatCp   :: Heat capacity of the ground [J/m3/K]
C     enthalpGrdW  :: enthalpy of ground water [J/m3]
C     fieldCapac   :: field capacity (of water) [m]
C     mWater       :: water content of the ground [kg/m3]
C     groundWnp1   :: hold temporary future soil moisture []
C     grdWexcess   :: ground water in excess [m/s]
C     fractRunOff  :: fraction of water in excess which leaves as runoff
C     flxkup       :: downward flux of water, upper interface (k-1,k)
C     flxdwn       :: downward flux of water, lower interface (k,k+1)
C     flxEngU      :: downward energy flux associated with water flux (W/m2)
C                     upper interface (k-1,k)
C     flxEngL      :: downward energy flux associated with water flux (W/m2)
C                     lower interface (k,k+1)
C     temp_af      :: ground temperature if above freezing
C     temp_bf      :: ground temperature if below freezing
C     mPmE         :: hold temporary (liquid) Precip minus Evap [kg/m2/s]
C     enWfx        :: hold temporary energy flux of Precip [W/m2]
C     enGr1        :: ground enthalpy of level 1  [J/m2]
C     mSnow        :: mass of snow         [kg/m2]
C     dMsn         :: mass of melting snow [kg/m2]
C     snowPrec     :: snow precipitation [kg/m2/s]
C     hNewSnow     :: fresh snow accumulation [m]
C     dhSnowMx     :: potential snow increase [m]
C     dhSnow       :: effective snow increase [m]
C     mIceDt       :: ground-ice growth rate (<- excess of snow) [kg/m2/s]
C     ageFac       :: snow aging factor [1]
      _RL grd_HeatCp, enthalpGrdW
      _RL fieldCapac, mWater
      _RL groundWnp1, grdWexcess, fractRunOff
      _RL flxkup(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL flxkdw(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL flxEngU(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL flxEngL, temp_af, temp_bf, mPmE, enWfx, enGr1
      _RL mSnow, dMsn, snowPrec
      _RL hNewSnow, dhSnowMx, dhSnow, mIceDt, ageFac
      INTEGER i,j,k,kp1

#ifdef LAND_DEBUG
      LOGICAL dBug
      INTEGER iprt,jprt,lprt
      DATA iprt, jprt , lprt / 19 , 20 , 6 /
 1010 FORMAT(A,I3,1P4E11.3)
#endif

      IF (land_calc_grT .AND. .NOT.land_impl_grT ) THEN
C--   Step forward ground temperature:

      DO k=1,land_nLev
       kp1 = MIN(k+1,land_nLev)

       IF (k.EQ.1) THEN
        DO j=1,sNy
         DO i=1,sNx
           flxkup(i,j) = land_HeatFlx(i,j,bi,bj)
         ENDDO
        ENDDO
       ELSE
        DO j=1,sNy
         DO i=1,sNx
           flxkup(i,j) = flxkdw(i,j)
         ENDDO
        ENDDO
       ENDIF

       DO j=1,sNy
        DO i=1,sNx
         IF ( land_frc(i,j,bi,bj).GT.0. ) THEN
C-     Thermal conductivity flux, lower interface (k,k+1):
          flxkdw(i,j) = land_grdLambda*
     &             ( land_groundT(i,j,k,bi,bj)
     &              -land_groundT(i,j,kp1,bi,bj) )
     &            *land_rec_dzC(kp1)

C-     Step forward ground enthalpy, level k :
          land_enthalp(i,j,k,bi,bj) = land_enthalp(i,j,k,bi,bj)
     &       + land_deltaT * (flxkup(i,j)-flxkdw(i,j))/land_dzF(k)

         ENDIF
        ENDDO
       ENDDO

      ENDDO
C--   step forward ground temperature: end
      ENDIF

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      IF ( land_calc_grW .OR. land_calc_snow ) THEN
C--   Initialize run-off arrays.
        DO j=1,sNy
         DO i=1,sNx
           land_runOff(i,j,bi,bj) = 0. _d 0
           land_enRnOf(i,j,bi,bj) = 0. _d 0
         ENDDO
        ENDDO
      ENDIF

#ifdef LAND_OLD_VERSION
      IF ( .TRUE. ) THEN
#else
      IF ( land_calc_grW ) THEN
#endif
C--   need (later on) ground temp. to be consistent with updated enthalpy:
        DO k=1,land_nLev
         DO j=1,sNy
          DO i=1,sNx
           IF ( land_frc(i,j,bi,bj).GT.0. ) THEN
            mWater = land_rhoLiqW*land_waterCap
     &              *land_groundW(i,j,k,bi,bj)
            mWater = MAX( mWater, 0. _d 0 )
            grd_HeatCp = land_heatCs + land_CpWater*mWater
            temp_bf = (land_enthalp(i,j,k,bi,bj)+land_Lfreez*mWater)
     &                                           / grd_HeatCp
            temp_af =  land_enthalp(i,j,k,bi,bj) / grd_HeatCp
            land_groundT(i,j,k,bi,bj) =
     &              MIN( temp_bf, MAX(temp_af, 0. _d 0) )
#ifdef LAND_DEBUG
            dBug = bi.eq.lprt .AND. i.EQ.iprt .AND. j.EQ.jprt
            IF (dBug) write(6,1010)
     &        'LAND_STEPFWD: k,temp,af,bf=',
     &       k,land_groundT(i,j,k,bi,bj),temp_af,temp_bf
#endif
           ENDIF
          ENDDO
         ENDDO
        ENDDO
      ENDIF

      IF ( land_calc_snow ) THEN
C--   Step forward Snow thickness (also account for rain temperature)
        ageFac = 1. _d 0 - land_deltaT/timeSnowAge
        DO j=1,sNy
         DO i=1,sNx
          IF ( land_frc(i,j,bi,bj).GT.0. ) THEN
           mPmE  = land_Pr_m_Ev(i,j,bi,bj)
           enWfx = land_EnWFlux(i,j,bi,bj)
           enGr1 = land_enthalp(i,j,1,bi,bj)*land_dzF(1)
#ifdef LAND_DEBUG
           dBug = bi.eq.lprt .AND. i.EQ.iprt .AND. j.EQ.jprt
           IF (dBug) write(6,1010)
     &       'LAND_STEPFWD:mPmE,enWfx,enGr1/dt,hSnow=',0,
     &       mPmE,enWfx,enGr1/land_deltaT,land_hSnow(i,j,bi,bj)
#endif
C-    snow aging:
           land_snowAge(i,j,bi,bj) =
     &         ( land_deltaT + land_snowAge(i,j,bi,bj)*ageFac )
           IF ( enWfx.LT.0. ) THEN
C-    snow precip in excess ( > Evap of snow) or snow prec & Evap of Liq.Water:
C     => start to melt (until ground at freezing point) and then accumulate
            snowPrec = -enWfx -MAX( enGr1/land_deltaT, 0. _d 0 )
C-    snow accumulation cannot be larger that net precip
            snowPrec = MAX( 0. _d 0 ,
     &                      MIN( snowPrec*recip_Lfreez, mPmE ) )
            mPmE = mPmE - snowPrec
            flxEngU(i,j) = enWfx + land_Lfreez*snowPrec
            hNewSnow = land_deltaT * snowPrec / land_rhoSnow
C-    refresh snow age:
            land_snowAge(i,j,bi,bj) = land_snowAge(i,j,bi,bj)
     &                          *EXP( -hNewSnow/hNewSnowAge )
C-    update snow thickness:
c           land_hSnow(i,j,bi,bj) = land_hSnow(i,j,bi,bj) + hNewSnow
C     glacier & ice-sheet missing: excess of snow put directly into run-off
            dhSnowMx = MAX( 0. _d 0,
     &                      land_hMaxSnow - land_hSnow(i,j,bi,bj) )
            dhSnow = MIN( hNewSnow, dhSnowMx )
            land_hSnow(i,j,bi,bj) = land_hSnow(i,j,bi,bj) + dhSnow
            mIceDt = land_rhoSnow * (hNewSnow-dhSnow) / land_deltaT
            land_runOff(i,j,bi,bj) =  mIceDt
            land_enRnOf(i,j,bi,bj) = -mIceDt*land_Lfreez
#ifdef LAND_DEBUG
            IF (dBug) write(6,1010)
     &        'LAND_STEPFWD: 3,snP,mPmE,hNsnw,hSnw=',
     &         3,snowPrec,mPmE,hNewSnow,land_hSnow(i,j,bi,bj)
#endif
           ELSE
C-    rain precip (whatever Evap is) or Evap of snow exceeds snow precip:
C     => snow melts or sublimates
c           snowMelt = MIN( enWfx*recip_Lfreez ,
c    &                 land_hSnow(i,j,bi,bj)*land_rhoSnow/land_deltaT )
            mSnow = land_hSnow(i,j,bi,bj)*land_rhoSnow
            dMsn = enWfx*recip_Lfreez*land_deltaT
            IF ( dMsn .GE. mSnow ) THEN
              dMsn = mSnow
              land_hSnow(i,j,bi,bj) = 0. _d 0
              flxEngU(i,j) = enWfx - land_Lfreez*mSnow/land_deltaT
            ELSE
              flxEngU(i,j) = 0. _d 0
              land_hSnow(i,j,bi,bj) = land_hSnow(i,j,bi,bj)
     &                              - dMsn / land_rhoSnow
            ENDIF
c           IF (mPmE.GT.0.) land_snowAge(i,j,bi,bj) = timeSnowAge
            mPmE = mPmE + dMsn/land_deltaT
#ifdef LAND_DEBUG
            IF (dBug) write(6,1010)
     &        'LAND_STEPFWD: 4,dMsn,mPmE,hSnw,enWfx=',
     &         4,dMsn,mPmE,land_hSnow(i,j,bi,bj),flxEngU(i,j)
#endif
           ENDIF
           flxkup(i,j) = mPmE/land_rhoLiqW
c          land_Pr_m_Ev(i,j,bi,bj) = mPmE
           IF ( land_hSnow(i,j,bi,bj).LE. 0. _d 0 )
     &          land_snowAge(i,j,bi,bj) = 0. _d 0
C-    avoid negative (but very small, < 1.e-34) hSnow that occurs because
C      of truncation error. Might need to rewrite this part.
c          IF ( land_hSnow(i,j,bi,bj).LE. 0. _d 0 ) THEN
c             land_hSnow(i,j,bi,bj)   = 0. _d 0
c             land_snowAge(i,j,bi,bj) = 0. _d 0
c          ENDIF
          ENDIF
         ENDDO
        ENDDO
      ELSE
        DO j=1,sNy
         DO i=1,sNx
           flxkup(i,j) = land_Pr_m_Ev(i,j,bi,bj)/land_rhoLiqW
           flxEngU(i,j) = 0. _d 0
         ENDDO
        ENDDO
      ENDIF

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      IF (land_calc_grW) THEN
C--   Step forward ground Water:

      DO k=1,land_nLev
       IF (k.EQ.land_nLev) THEN
        kp1 = k
        fractRunOff = 1. _d 0
       ELSE
        kp1 = k+1
        fractRunOff = land_fractRunOff
       ENDIF
       fieldCapac = land_waterCap*land_dzF(k)

       DO j=1,sNy
        DO i=1,sNx
         IF ( land_frc(i,j,bi,bj).GT.0. ) THEN
#ifdef LAND_DEBUG
          dBug = bi.eq.lprt .AND. i.EQ.iprt .AND. j.EQ.jprt
#endif

#ifdef LAND_OLD_VERSION
          IF ( .TRUE. ) THEN
           IF ( k.EQ.land_nLev ) THEN
#else
          IF ( land_groundT(i,j,k,bi,bj).LT.0. _d 0 ) THEN
C-     Frozen level: only account for upper level fluxes
           IF ( flxkup(i,j) .LT. 0. _d 0 ) THEN
C-     Step forward soil moisture (& enthapy), level k :
            land_groundW(i,j,k,bi,bj) = land_groundW(i,j,k,bi,bj)
     &       + land_deltaT * flxkup(i,j) / fieldCapac
            IF ( land_calc_snow )
     &      land_enthalp(i,j,k,bi,bj) = land_enthalp(i,j,k,bi,bj)
     &       + land_deltaT * flxEngU(i,j) / land_dzF(k)
           ELSE
C-     Frozen level: incoming water flux goes directly into run-off
            land_runOff(i,j,bi,bj) = land_runOff(i,j,bi,bj)
     &                             + flxkup(i,j)*land_rhoLiqW
            land_enRnOf(i,j,bi,bj) = land_enRnOf(i,j,bi,bj)
     &                             + flxEngU(i,j)
           ENDIF
C-     prepare fluxes for next level:
           flxkup(i,j)  = 0. _d 0
           flxEngU(i,j) = 0. _d 0

          ELSE

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C-     Diffusion flux of water, lower interface (k,k+1):
           IF ( k.EQ.land_nLev .OR.
     &         land_groundT(i,j,kp1,bi,bj).LT.0. _d 0 ) THEN
#endif /* LAND_OLD_VERSION */
C-     no Diffusion of water if one level is frozen :
             flxkdw(i,j) = 0. _d 0
             flxEngL =     0. _d 0
           ELSE
             flxkdw(i,j) = fieldCapac*
     &                   ( land_groundW(i,j,k,bi,bj)
     &                    -land_groundW(i,j,kp1,bi,bj) )
     &                   / land_wTauDiff
C-     energy flux associated with water flux: take upwind Temp
             IF ( flxkdw(i,j).GE.0. ) THEN
              flxEngL = flxkdw(i,j)*land_rhoLiqW*land_CpWater
     &                 *land_groundT(i,j,k,bi,bj)
             ELSE
              flxEngL = flxkdw(i,j)*land_rhoLiqW*land_CpWater
     &                 *land_groundT(i,j,kp1,bi,bj)
             ENDIF
           ENDIF

C-     Step forward soil moisture, level k :
           groundWnp1 = land_groundW(i,j,k,bi,bj)
     &       + land_deltaT * (flxkup(i,j)-flxkdw(i,j)) / fieldCapac

#ifdef LAND_DEBUG
           IF(dBug)write(6,1010)'LAND_STEPFWD: grdW-1,fx_ku,kd,grdW-1='
     &      ,5,land_groundW(i,j,k,bi,bj)-1.,
     &         flxkup(i,j),flxkdw(i,j),groundWnp1-1.
#endif

C-     Water in excess will leave as run-off or go to level below
           land_groundW(i,j,k,bi,bj) = MIN(1. _d 0, groundWnp1)
           grdWexcess = ( groundWnp1 - MIN(1. _d 0, groundWnp1) )
     &                 *fieldCapac/land_deltaT

C-     Run off: fraction 1-fractRunOff enters level below
           land_runOff(i,j,bi,bj) = land_runOff(i,j,bi,bj)
     &                        + fractRunOff*grdWexcess*land_rhoLiqW
C-     prepare fluxes for next level:
           flxkup(i,j) = flxkdw(i,j)
     &              + (1. _d 0-fractRunOff)*grdWexcess

           IF ( land_calc_snow ) THEN
            enthalpGrdW = land_rhoLiqW*land_CpWater
     &                   *land_groundT(i,j,k,bi,bj)
C--    Account for water fluxes in energy budget: update ground Enthalpy
            land_enthalp(i,j,k,bi,bj) = land_enthalp(i,j,k,bi,bj)
     &         + ( flxEngU(i,j) - flxEngL - grdWexcess*enthalpGrdW
     &           )*land_deltaT/land_dzF(k)

            land_enRnOf(i,j,bi,bj) = land_enRnOf(i,j,bi,bj)
     &                        + fractRunOff*grdWexcess*enthalpGrdW
C-     prepare fluxes for next level:
            flxEngU(i,j) = flxEngL
     &              + (1. _d 0-fractRunOff)*grdWexcess*enthalpGrdW
           ENDIF
#ifdef LAND_DEBUG
           IF (dBug) write(6,1010) 'LAND_STEPFWD: Temp,FlxE,FlxW=',
     &      7, land_groundT(i,j,k,bi,bj), flxEngU(i,j), flxkup(i,j)
#endif
          ENDIF
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
#ifdef LAND_DEBUG
           IF (dBug) write(6,1010) 'LAND_STEPFWD: RO,enRO=',
     &      8, land_runOff(i,j,bi,bj),land_enRnOf(i,j,bi,bj)
#endif

         ENDIF
        ENDDO
       ENDDO

      ENDDO
C--   step forward ground Water: end
      ENDIF

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      IF ( land_calc_grT ) THEN
C--   Compute ground temperature from enthalpy (if not already done):

       DO k=1,land_nLev
        DO j=1,sNy
         DO i=1,sNx
C-     Ground Heat capacity, layer k:
          mWater = land_rhoLiqW*land_waterCap
     &            *land_groundW(i,j,k,bi,bj)
          mWater = MAX( mWater, 0. _d 0 )
          grd_HeatCp = land_heatCs + land_CpWater*mWater
C         temperature below freezing:
          temp_bf = (land_enthalp(i,j,k,bi,bj)+land_Lfreez*mWater)
     &                                         / grd_HeatCp
C         temperature above freezing:
          temp_af =  land_enthalp(i,j,k,bi,bj) / grd_HeatCp
#ifdef LAND_OLD_VERSION
          land_enthalp(i,j,k,bi,bj) =
     &          grd_HeatCp*land_groundT(i,j,k,bi,bj)
#else
          land_groundT(i,j,k,bi,bj) =
     &            MIN( temp_bf, MAX(temp_af, 0. _d 0) )
#endif
         ENDDO
        ENDDO
       ENDDO

       IF ( land_impl_grT ) THEN
        DO j=1,sNy
         DO i=1,sNx
          IF ( land_hSnow(i,j,bi,bj).GT.0. _d 0 ) THEN
           land_skinT(i,j,bi,bj) = MIN(land_skinT(i,j,bi,bj), 0. _d 0)
          ELSE
           land_skinT(i,j,bi,bj) = land_groundT(i,j,1,bi,bj)
          ENDIF
         ENDDO
        ENDDO
       ELSE
        DO j=1,sNy
         DO i=1,sNx
           land_skinT(i,j,bi,bj) = land_groundT(i,j,1,bi,bj)
         ENDDO
        ENDDO
       ENDIF

C--   Compute ground temperature: end
      ENDIF

#endif /* ALLOW_LAND */

      RETURN
      END

#include "CTRL_OPTIONS.h"

CBOP
C !ROUTINE: CTRL_COST_DRIVER

C !INTERFACE: ==========================================================
      SUBROUTINE CTRL_COST_DRIVER(
     I                             myTime, myIter, myThid )

C !DESCRIPTION:
C Calculate cost function terms of ctrl variables (Tikhonov
C regularisation) at the end of the model run, called from
C S/R COST_DRIVER

C !USES: ===============================================================
      IMPLICIT NONE
C     == Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"

#ifdef ALLOW_CTRL
# include "CTRL_SIZE.h"
# include "CTRL.h"
# include "CTRL_DUMMY.h"
# include "CTRL_GENARR.h"
#endif

C !INPUT PARAMETERS: ===================================================
C myTime    :: Current time in simulation
C myIter    :: Current time-step number
C myThid    :: my Thread Id number
      _RL     myTime
      INTEGER myIter, myThid

C !OUTPUT PARAMETERS: ==================================================

#ifdef ALLOW_COST
C !LOCAL VARIABLES: ====================================================
      INTEGER ivar
#ifdef ALLOW_GENTIM2D_CONTROL
      INTEGER startrec
      INTEGER endrec
#endif

#if ( defined ALLOW_GENTIM2D_CONTROL \
   || defined ALLOW_GENARR2D_CONTROL \
   || defined ALLOW_GENARR3D_CONTROL )
      INTEGER iarr
      LOGICAL dodimensionalcost
      INTEGER k2
#endif
#if ( defined ALLOW_GENTIM2D_CONTROL \
   || defined ALLOW_GENARR2D_CONTROL )
      _RS mask2D(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
#endif
#ifdef ALLOW_GENARR3D_CONTROL
      _RS mask3D(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
#endif
CEOP

c--   Evaluate the individual cost function contributions.

      if ( useCtrlCostContribution ) then
      do ivar = 1, maxcvars
#ifdef ALLOW_GENTIM2D_CONTROL
       if ( ncvartype(ivar) .EQ. 'Tim2D' ) then
        iarr = ncvarindex(ivar)

        dodimensionalcost=.FALSE.
        do k2 = 1, maxCtrlProc
         if (xx_gentim2d_preproc(k2,iarr).EQ.'noscaling') then
          dodimensionalcost=.TRUE.
         endif
        enddo

        if (xx_gentim2d_weight(iarr).NE.' ') then
         startrec = ncvarrecstart(ivar)
         endrec   = ncvarrecsend(ivar)
         do k2 = 1, maxCtrlProc
          if (xx_gentim2d_preproc(k2,iarr).EQ.'replicate') then
           if (xx_gentim2d_preproc_i(k2,iarr).NE.0) then
            endrec=min(endrec,xx_gentim2d_preproc_i(k2,iarr))
           endif
          endif
         enddo

C --- Get appropriate mask for field
         call ctrl_get_mask2D(xx_gentim2d_file(iarr),mask2D,myThid)

         call ctrl_cost_gen2d (
     &     startrec, endrec,
     &     xx_gentim2d_file(iarr),xx_gentim2d_dummy(iarr),
     &     xx_gentim2d_period(iarr),
     &     wgentim2d(1-OLx,1-OLy,1,1,iarr),
     &     dodimensionalcost,
     &     num_gentim2d(1,1,iarr),
     &     objf_gentim2d(1,1,iarr),
     &     mask2D, myThid )
        endif

       endif
#endif

#ifdef ALLOW_GENARR2D_CONTROL
       if ( ncvartype(ivar) .EQ. 'Arr2D' ) then
        iarr = ncvarindex(ivar)

        dodimensionalcost=.FALSE.
        do k2 = 1, maxCtrlProc
         if (xx_genarr2d_preproc(k2,iarr).EQ.'noscaling') then
          dodimensionalcost=.TRUE.
         endif
        enddo

C --- Get appropriate mask for field
        call ctrl_get_mask2D(xx_genarr2d_file(iarr),mask2D,myThid)

        if (xx_genarr2d_weight(iarr).NE.' ') then
         call ctrl_cost_gen2d (
     &     1,1,
     &     xx_genarr2d_file(iarr),xx_genarr2d_dummy(iarr),
     &     zeroRL, wgenarr2d(1-OLx,1-OLy,1,1,iarr),
     &     dodimensionalcost,
     &     num_genarr2d(1,1,iarr), objf_genarr2d(1,1,iarr),
     &     mask2D, myThid )
        endif

       endif
#endif

#ifdef ALLOW_GENARR3D_CONTROL
       if ( ncvartype(ivar) .EQ. 'Arr3D' ) then
        iarr = ncvarindex(ivar)

        dodimensionalcost=.FALSE.
        do k2 = 1, maxCtrlProc
         if (xx_genarr3d_preproc(k2,iarr).EQ.'noscaling') then
          dodimensionalcost=.TRUE.
         endif
        enddo

C --- Get appropriate mask for field
        call ctrl_get_mask3D(xx_genarr3d_file(iarr),mask3D,myThid)

        if (xx_genarr3d_weight(iarr).NE.' ') then
         call ctrl_cost_gen3d (
     &     xx_genarr3d_file(iarr),xx_genarr3d_dummy(iarr),
     &     wgenarr3d(1-OLx,1-OLy,1,1,1,iarr),
     &     dodimensionalcost,
     &     num_genarr3d(1,1,iarr), objf_genarr3d(1,1,iarr),
     &     mask3D, myThid )
        endif

       endif
#endif
      enddo
C     useCtrlCostContribution
      endif

#endif /* ALLOW_COST */

      RETURN
      END

#include "OBCS_OPTIONS.h"
#ifdef ALLOW_AUTODIFF
# include "AUTODIFF_OPTIONS.h"
#endif
#undef CHECK_BALANCE

C--   File obcs_calc_stevens.F:
C--    Contents
C--    o OBCS_CALC_STEVENS
C--    o OBCS_STEVENS_CALC_TRACER_EAST
C--    o OBCS_STEVENS_CALC_TRACER_WEST
C--    o OBCS_STEVENS_CALC_TRACER_NORTH
C--    o OBCS_STEVENS_CALC_TRACER_SOUTH
C--    o OBCS_STEVENS_SAVE_TRACER

CBOP
C     !ROUTINE: OBCS_CALC_STEVENS
C     !INTERFACE:
      SUBROUTINE OBCS_CALC_STEVENS(
     I     futureTime, futureIter,
     I     myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE OBCS_CALC_STEVENS
C     | o Calculate future boundary data at open boundaries
C     |   at time = futureTime
C     |   from input data following Stevens(1990), and some
C     |   MOM3 legacy code
C     |
C     | o the code works like this
C     |  - the "barotropic" (= vertically averaged) velocity
C     |    normal to the boundary is assumed to be in
C     |    OBE/W/N/Su/v (normal) when this routine is entered
C     |  - the vertically averaged velocity is corrected
C     |    by the "baroclinic" (= deviation from vertically
C     |    averaged velocity) velocity to give a new OB?u/v;
C     |    the "barolinic" velocity is estimated from the previous
C     |    time step which makes this boundary condition depend on
C     |    a restart file. If OBCS_STEVENS_USE_INTERIOR_VELOCITY
C     |    is defined the velocity is simply copied from the model
C     |    interior to the boundary, thereby avoiding a restart
C     |    file or complicated reconstruction, but this solution
C     |    can give unexpected results.
C     |    (Note: in this context the terms barotropic and baroclinic
C     |    are MOM jargon and --- to my mind ---- should not be used)
C     |  - a wave phase speed is estimated from temporal and
C     |    horizontal variations of the tracer fields for each
C     |    tracer individually, this similar to Orlanski BCs,
C     |    but for simplicity the fields of the previous time step
C     |    are used, and the time derivative is estimated
C     |    independently of the time stepping procedure by simple
C     |    differencing
C     |  - velocity tangential to the boundary is always zero
C     |    (although this could be changed)
C     |  - a new tracer is computed from a local advection equation
C     |    with an upwind scheme: tracer from the interior is
C     |    advected out of the domain, and tracer from the boundary
C     |    is "advected" into the domain by a restoring mechanism
C     |  - for the advection equation only values from the
C     |    the current (not the updated) time level are used
C     |
C     *==========================================================*
C     | Feb, 2009: started by Martin Losch (Martin.Losch@awi.de)
C     *==========================================================*
C     \ev
C     !USES:
      IMPLICIT NONE
C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "OBCS_PARAMS.h"
#include "OBCS_GRID.h"
#include "OBCS_FIELDS.h"
#include "DYNVARS.h"
#ifdef ALLOW_PTRACERS
#include "PTRACERS_SIZE.h"
#include "PTRACERS_PARAMS.h"
#include "PTRACERS_FIELDS.h"
#include "OBCS_PTRACERS.h"
#endif /* ALLOW_PTRACERS */
#ifdef ALLOW_AUTODIFF_TAMC
# include "tamc.h"
#endif /* ALLOW_AUTODIFF_TAMC */

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
      _RL futureTime
      INTEGER futureIter
      INTEGER myThid

#ifdef ALLOW_OBCS_STEVENS

C     !LOCAL VARIABLES:
C     == Local variables ==
C     I,J,K        :: loop indices
C     msgBuf       :: Informational/error message buffer
C     uMer/vZonBar :: vertically averaged velocity at open boundary
C     drFBar       :: local depth for vertical average
C     uMer/vZonPri :: velocity anomalies applied to the open boundaries
C     gammat/s     :: restoring parameters (1./(T/SrelaxStevens - time scale))
C     auxillary variables
C     cflMer/Zon   :: ratio of grid spacing and time step
C     aFac         :: switch (0 or 1) that turns on advective contribution
C     gFacM/Z      :: switch (0 or 1) that turns on restoring boundary condition
C     pFac         :: switch that turns on/off phase velocity contribution
      INTEGER bi, bj
      INTEGER i, j, k
c     CHARACTER*(MAX_LEN_MBUF) msgBuf
      _RL cflMer (1-OLy:sNy+OLy,Nr)
      _RL gFacM  (1-OLy:sNy+OLy,Nr)
      _RL uMerPri(Nr)
      _RL uMerBar
      _RL cflZon (1-OLx:sNx+OLx,Nr)
      _RL gFacZ  (1-OLx:sNx+OLx,Nr)
      _RL vZonPri(Nr)
      _RL vZonBar
      _RL drFBar
      _RL gammat, gammas, pFac, aFac
#ifdef ALLOW_PTRACERS
c     INTEGER iTracer
#endif /* ALLOW_PTRACERS */
#ifdef ALLOW_AUTODIFF_TAMC
C     tkey :: tape key (depends on tiles)
      INTEGER tkey
#endif /* ALLOW_AUTODIFF_TAMC */
#ifdef CHECK_BALANCE
      _RL uVelLoc, vVelLoc
      _RL vPhase
#endif
CEOP

#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_ENTER('OBCS_CALC_STEVENS',myThid)
#endif

      aFac   = 1. _d 0
      IF (.NOT. useStevensAdvection ) aFac   = 0. _d 0
      pFac   = 1. _d 0
      IF (.NOT. useStevensPhaseVel )  pFac   = 0. _d 0
      gammat = 0. _d 0
      IF (TrelaxStevens .GT. 0. _d 0) gammat = 1./TrelaxStevens
      gammas = 0. _d 0
      IF (SrelaxStevens .GT. 0. _d 0) gammas = 1./SrelaxStevens

      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)

#ifdef ALLOW_AUTODIFF_TAMC
        tkey = bi + (bj-1)*nSx + (ikey_dynamics-1)*nSx*nSy
# ifdef ALLOW_OBCS_EAST
CADJ STORE OBEt(:,:,bi,bj) = comlev1_bibj, key=tkey, kind=isbyte
CADJ STORE OBEs(:,:,bi,bj) = comlev1_bibj, key=tkey, kind=isbyte
CADJ STORE OBEu(:,:,bi,bj) = comlev1_bibj, key=tkey, kind=isbyte
# endif
# ifdef ALLOW_OBCS_WEST
CADJ STORE OBWt(:,:,bi,bj) = comlev1_bibj, key=tkey, kind=isbyte
CADJ STORE OBWs(:,:,bi,bj) = comlev1_bibj, key=tkey, kind=isbyte
CADJ STORE OBWu(:,:,bi,bj) = comlev1_bibj, key=tkey, kind=isbyte
# endif
# ifdef ALLOW_OBCS_NORTH
CADJ STORE OBNt(:,:,bi,bj) = comlev1_bibj, key=tkey, kind=isbyte
CADJ STORE OBNs(:,:,bi,bj) = comlev1_bibj, key=tkey, kind=isbyte
CADJ STORE OBNv(:,:,bi,bj) = comlev1_bibj, key=tkey, kind=isbyte
# endif
# ifdef ALLOW_OBCS_SOUTH
CADJ STORE OBSt(:,:,bi,bj) = comlev1_bibj, key=tkey, kind=isbyte
CADJ STORE OBSs(:,:,bi,bj) = comlev1_bibj, key=tkey, kind=isbyte
CADJ STORE OBSv(:,:,bi,bj) = comlev1_bibj, key=tkey, kind=isbyte
# endif
#endif /* ALLOW_AUTODIFF_TAMC */

#ifdef ALLOW_OBCS_EAST
        IF ( useStevensEast ) THEN
C     Eastern OB
#ifdef ALLOW_DEBUG
         IF (debugMode)
     &        CALL DEBUG_MSG('OBCS_CALC_STEVENS: East',myThid)
#endif
C     compute vertical average and deviation from vertical
C     average for I_obe
         DO j=1-OLy,sNy+OLy
          i = OB_Ie(j,bi,bj)
          IF ( i.NE.OB_indexNone ) THEN
C     first initialize some fields
           drFbar  = 0. _d 0
           uMerBar = 0. _d 0
           DO k=1,Nr
            uMerPri(k) = 0. _d 0
           ENDDO
           DO k=1,Nr
#ifdef OBCS_STEVENS_USE_INTERIOR_VELOCITY
            uMerBar = uMerBar + uVel(i-1,j,k,bi,bj)
#else
            uMerBar = uMerBar + OBEuStevens(j,k,bi,bj)
#endif /*  OBCS_STEVENS_USE_INTERIOR_VELOCITY */
     &           *drF(k)* _hFacW(i,j,k,bi,bj)
            drFBar = drFBar + drF(k)* _hFacW(i,j,k,bi,bj)
           ENDDO
           IF ( drFBar .GT. 0. _d 0 ) uMerBar = uMerBar/drFBar
           DO k=1,Nr
#ifdef OBCS_STEVENS_USE_INTERIOR_VELOCITY
            uMerPri(k) = (uVel(i-1,j,k,bi,bj)-uMerBar)
#else
            uMerPri(k) = (OBEuStevens(j,k,bi,bj)-uMerBar)
#endif /*  OBCS_STEVENS_USE_INTERIOR_VELOCITY */
     &           * _maskW(i,j,k,bi,bj)
           ENDDO
C     vertical average of input field
           drFbar  = 0. _d 0
           uMerBar = 0. _d 0
           DO k=1,Nr
            uMerBar = uMerBar + OBEu(j,k,bi,bj)
     &           *drF(k)* _hFacW(i,j,k,bi,bj)
            drFBar = drFBar + drF(k)* _hFacW(i,j,k,bi,bj)
           ENDDO
           IF ( drFBar .GT. 0. _d 0 ) uMerBar = uMerBar/drFBar
C     Now the absolute velocity normal to the boundary is
C     uMerBar + uMerPri(K).
           DO k=1,Nr
            OBEu(j,k,bi,bj) = (uMerBar + uMerPri(k))
     &           * _maskW(i,j,k,bi,bj)
CML            OBEv(J,K,bi,bj) = 0. _d 0
#ifdef ALLOW_NONHYDROSTATIC
            OBEw(j,k,bi,bj)=0.
#endif
           ENDDO
          ENDIF
         ENDDO
#ifdef NONLIN_FRSURF
C     this is a bit of a hack
         IF ( nonlinFreeSurf.GT.0 ) THEN
          DO j=1-OLy,sNy+OLy
           i = OB_Ie(j,bi,bj)
           IF ( i.NE.OB_indexNone ) THEN
            OBEeta(j,bi,bj) = etaN(i-1,j,bi,bj)
           ENDIF
          ENDDO
         ENDIF
#endif /* NONLIN_FRSURF */
C     Next, we compute the phase speed correction, which depends on the
C     tracer!
         DO k=1,Nr
          DO j=1-OLy,sNy+OLy
           i = OB_Ie(j,bi,bj)
           IF ( i.NE.OB_indexNone ) THEN
            cflMer(j,k) = 0.5 _d 0 * _dxC(i-1,j,bi,bj)/dTtracerLev(k)
CML         gFacM(J,K)  = 0. _d 0
CML         IF ( uVel(I,J,K,bi,bj) .LT. 0. _d 0 ) gFacM(J,K) = 1. _d 0
            gFacM(j,k)  = ABS(MIN(SIGN(1.D0,uVel(i,j,k,bi,bj)),0.D0))
           ELSE
            cflMer(j,k) = 0. _d 0
            gFacM (j,k) = 0. _d 0
           ENDIF
          ENDDO
         ENDDO
# ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE cflMer, gFacM = comlev1_bibj, key=tkey, kind=isbyte
# endif
C     theta
         CALL OBCS_STEVENS_CALC_TRACER_EAST(
     U        OBEt,
     I        OBEtStevens, theta, gammat,
     I        uVel, cflMer, gFacM, pFac, aFac,
     I        OB_Ie, OB_indexNone, bi, bj,
     I        futureTime, futureIter,
     I        myThid )
C     salinity
         CALL OBCS_STEVENS_CALC_TRACER_EAST(
     U        OBEs,
     I        OBEsStevens, salt, gammas,
     I        uVel, cflMer, gFacM, pFac, aFac,
     I        OB_Ie, OB_indexNone, bi, bj,
     I        futureTime, futureIter,
     I        myThid )
C     Template for passive tracers, requires work
CML#ifdef ALLOW_PTRACERS
CMLC     ptracers
CML         IF ( usePtracers ) THEN
CML          DO itracer = 1, PTRACERnumInUse
CML           CALL OBCS_STEVENS_CALC_TRACER_EAST(
CML     O          OBEptr       (1-OLy,1,1,1,iTracer),
CML     I          OBEpStevens  (1-OLy,1,1,1,iTracer),
CML     I          pTracer(1-OLx,1-OLy,1,1,1,iTracer), gammas,
CML     I          uVel, cflMer, gFacM, pFac, aFac,
CML     I          OB_Ie, OB_indexNone, bi, bj,
CML     I          futureTime, futureIter,
CML     I          myThid )
CML          ENDDO
CML         ENDIF
CML#endif /* ALLOW_PTRACERS */
C     IF ( useStevensEast ) THEN
        ENDIF
#endif /* ALLOW_OBCS_EAST */

C ------------------------------------------------------------------------------

#ifdef ALLOW_OBCS_WEST
        IF ( useStevensWest ) THEN
C     Western OB
#ifdef ALLOW_DEBUG
         IF (debugMode)
     &        CALL DEBUG_MSG('OBCS_CALC_STEVENS: West',myThid)
#endif
C     compute vertical average and deviation from vertical
C     average for I_obw+1
         DO j=1-OLy,sNy+OLy
          i = OB_Iw(j,bi,bj)
          IF ( i.NE.OB_indexNone ) THEN
C     first initialize some fields
           drFBar  = 0. _d 0
           uMerBar = 0. _d 0
           DO k=1,Nr
            uMerPri(k) = 0. _d 0
           ENDDO
           DO k=1,Nr
#ifdef OBCS_STEVENS_USE_INTERIOR_VELOCITY
            uMerBar = uMerBar + uVel(i+2,j,k,bi,bj)
#else
            uMerBar = uMerBar + OBWuStevens(j,k,bi,bj)
#endif /* OBCS_STEVENS_USE_INTERIOR_VELOCITY */
     &           *drF(k)* _hFacW(i+1,j,k,bi,bj)
            drFBar = drFBar + drF(k)* _hFacW(i+1,j,k,bi,bj)
           ENDDO
           IF ( drFBar .GT. 0. _d 0 ) uMerBar = uMerBar/drFBar
           DO k=1,Nr
#ifdef OBCS_STEVENS_USE_INTERIOR_VELOCITY
            uMerPri(k) = (uVel(i+2,j,k,bi,bj)-uMerBar)
#else
            uMerPri(k) = (OBWuStevens(j,k,bi,bj)-uMerBar)
#endif /*  OBCS_STEVENS_USE_INTERIOR_VELOCITY */
     &           * _maskW(i+1,j,k,bi,bj)
           ENDDO
C     vertical average of input field
           drFBar  = 0. _d 0
           uMerBar = 0. _d 0
           DO k=1,Nr
            uMerBar = uMerBar + OBWu(j,k,bi,bj)
     &           *drF(k)* _hFacW(i+1,j,k,bi,bj)
            drFBar = drFBar + drF(k)* _hFacW(i+1,j,k,bi,bj)
           ENDDO
           IF ( drFBar .GT. 0. _d 0 ) uMerBar = uMerBar/drFBar
C     Now the absolute velocity normal to the boundary is
C     uMerBar + uMerPri(K).
           DO k=1,Nr
            OBWu(j,k,bi,bj) = (uMerBar + uMerPri(k))
     &          * _maskW(i+1,j,k,bi,bj)
CML            OBWv(J,K,bi,bj) = 0. _d 0
#ifdef ALLOW_NONHYDROSTATIC
            OBWw(j,k,bi,bj)=0.
#endif
           ENDDO
          ENDIF
         ENDDO
#ifdef NONLIN_FRSURF
C     this is a bit of a hack
         IF ( nonlinFreeSurf.GT.0 ) THEN
          DO j=1-OLy,sNy+OLy
           i = OB_Iw(j,bi,bj)
           IF ( i.NE.OB_indexNone ) THEN
            OBWeta(j,bi,bj) = etaN(i+1,j,bi,bj)
           ENDIF
          ENDDO
         ENDIF
#endif /* NONLIN_FRSURF */
C     Next, we compute the phase speed correction, which depends on the
C     tracer!
         DO k=1,Nr
          DO j=1-OLy,sNy+OLy
           i = OB_Iw(j,bi,bj)
           IF ( i.NE.OB_indexNone ) THEN
            cflMer(j,k) = 0.5 _d 0 * _dxC(i+2,j,bi,bj)/dTtracerLev(k)
CML         gFacM = 0. _d 0
CML         IF ( uVel(I+1,J,K,bi,bj) .GT. 0. _d 0 ) gFacM = 1. _d 0
            gFacM(j,k)  = ABS(MAX(SIGN(1.D0,uVel(i+1,j,k,bi,bj)),0.D0))
           ELSE
            cflMer(j,k) = 0. _d 0
            gFacM (j,k) = 0. _d 0
           ENDIF
          ENDDO
         ENDDO
# ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE cflMer, gFacM = comlev1_bibj, key=tkey, kind=isbyte
# endif
C     theta
         CALL OBCS_STEVENS_CALC_TRACER_WEST(
     U        OBWt,
     I        OBWtStevens, theta, gammat,
     I        uVel, cflMer, gFacM, pFac, aFac,
     I        OB_Iw, OB_indexNone, bi, bj,
     I        futureTime, futureIter,
     I        myThid )
C     salinity
         CALL OBCS_STEVENS_CALC_TRACER_WEST(
     U        OBWs,
     I        OBWsStevens, salt, gammas,
     I        uVel, cflMer, gFacM, pFac, aFac,
     I        OB_Iw, OB_indexNone, bi, bj,
     I        futureTime, futureIter,
     I        myThid )
C     ptracers
C     IF ( useStevensWest ) THEN
        ENDIF
#endif /* ALLOW_OBCS_WEST */

C ------------------------------------------------------------------------------

#ifdef ALLOW_OBCS_NORTH
        IF ( useStevensNorth ) THEN
C         Northern OB
#ifdef ALLOW_DEBUG
         IF (debugMode)
     &        CALL DEBUG_MSG('OBCS_CALC_STEVENS: North',myThid)
#endif
C     compute vertical average and deviation from vertical
C     average for J_obn
         DO i=1-OLx,sNx+OLx
          j = OB_Jn(i,bi,bj)
          IF ( j.NE.OB_indexNone ) THEN
C     first initialize some fields
           drFBar  = 0. _d 0
           vZonBar = 0. _d 0
           DO k=1,Nr
            vZonPri(k) = 0. _d 0
           ENDDO
           DO k=1,Nr
#ifdef OBCS_STEVENS_USE_INTERIOR_VELOCITY
            vZonBar = vZonBar + vVel(i,j-1,k,bi,bj)
#else
            vZonBar = vZonBar + OBNvStevens(i,k,bi,bj)
#endif /*  OBCS_STEVENS_USE_INTERIOR_VELOCITY */
     &           *drF(k)* _hFacS(i,j,k,bi,bj)
            drFBar = drFBar + drF(k)* _hFacS(i,j,k,bi,bj)
           ENDDO
           IF ( drFBar .GT. 0. _d 0 ) vZonBar = vZonBar/drFBar
           DO k=1,Nr
#ifdef OBCS_STEVENS_USE_INTERIOR_VELOCITY
            vZonPri(k) = (vVel(i,j-1,k,bi,bj)-vZonBar)
#else
            vZonPri(k) = (OBNvStevens(i,k,bi,bj)-vZonBar)
#endif /*  OBCS_STEVENS_USE_INTERIOR_VELOCITY */
     &           * _maskS(i,j,k,bi,bj)
           ENDDO
C     vertical average of input field
           drFBar  = 0. _d 0
           vZonBar = 0. _d 0
           DO k=1,Nr
            vZonBar = vZonBar + OBNv(i,k,bi,bj)
     &           *drF(k)* _hFacS(i,j,k,bi,bj)
            drFBar = drFBar + drF(k)* _hFacS(i,j,k,bi,bj)
           ENDDO
           IF ( drFBar .GT. 0. _d 0 ) vZonBar = vZonBar/drFBar
C     Now the absolute velocity normal to the boundary is
C     vZonBar + vZonPri(K).
           DO k=1,Nr
            OBNv(i,k,bi,bj) = (vZonBar + vZonPri(k))
     &           * _maskS(i,j,k,bi,bj)
CML            OBNu(I,K,bi,bj) = 0. _d 0
#ifdef ALLOW_NONHYDROSTATIC
            OBNw(i,k,bi,bj)=0.
#endif
           ENDDO
          ENDIF
         ENDDO
#ifdef NONLIN_FRSURF
C     this is a bit of a hack
         IF ( nonlinFreeSurf.GT.0 ) THEN
          DO i=1-OLx,sNx+OLx
           j = OB_Jn(i,bi,bj)
           IF ( j.NE.OB_indexNone ) THEN
            OBNeta(i,bi,bj) = etaN(i,j-1,bi,bj)
           ENDIF
          ENDDO
         ENDIF
#endif /* NONLIN_FRSURF */
C     Next, we compute the phase speed correction, which depends on the
C     tracer!
         DO k=1,Nr
          DO i=1-OLx,sNx+OLx
           j = OB_Jn(i,bi,bj)
           IF ( j.NE.OB_indexNone ) THEN
            cflZon(i,k) = 0.5 _d 0 * _dyC(i,j-1,bi,bj)/dTtracerLev(k)
CML         gFacZ(I,K) = 0. _d 0
CML         IF ( vVel(I,J,K,bi,bj) .LT. 0. _d 0 ) gFacZ(I,K) = 1. _d 0
            gFacZ(i,k)  = ABS(MIN(SIGN(1.D0,vVel(i,j,k,bi,bj)),0.D0))
           ELSE
            cflZon(i,k) = 0. _d 0
            gFacZ (i,k) = 0. _d 0
           ENDIF
          ENDDO
         ENDDO
# ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE cflZon, gFacZ = comlev1_bibj, key=tkey, kind=isbyte
# endif
C     theta
         CALL OBCS_STEVENS_CALC_TRACER_NORTH(
     U        OBNt,
     I        OBNtStevens, theta, gammat,
     I        vVel, cflZon, gFacZ, pFac, aFac,
     I        OB_Jn, OB_indexNone, bi, bj,
     I        futureTime, futureIter,
     I        myThid )
C     salinity
         CALL OBCS_STEVENS_CALC_TRACER_NORTH(
     U        OBNs,
     I        OBNsStevens, salt, gammas,
     I        vVel, cflZon, gFacZ, pFac, aFac,
     I        OB_Jn, OB_indexNone, bi, bj,
     I        futureTime, futureIter,
     I        myThid )
C     ptracers
C     IF ( useStevensNorth ) THEN
        ENDIF
#endif /* ALLOW_OBCS_NORTH */

C ------------------------------------------------------------------------------

#ifdef ALLOW_OBCS_SOUTH
        IF ( useStevensSouth ) THEN
C         Southern OB
#ifdef ALLOW_DEBUG
         IF (debugMode)
     &        CALL DEBUG_MSG('OBCS_CALC_STEVENS: South',myThid)
#endif
C     compute vertical average and deviation from vertical
C     average for J_obs+1
         DO i=1-OLx,sNx+OLx
          j = OB_Js(i,bi,bj)
          IF ( j.NE.OB_indexNone ) THEN
C     first initialize some fields
           drFBar  = 0. _d 0
           vZonBar = 0. _d 0
           DO k=1,Nr
            vZonPri(k) = 0. _d 0
           ENDDO
           DO k=1,Nr
#ifdef OBCS_STEVENS_USE_INTERIOR_VELOCITY
            vZonBar = vZonBar + vVel(i,j+2,k,bi,bj)
#else
            vZonBar = vZonBar + OBSvStevens(i,k,bi,bj)
#endif /*  OBCS_STEVENS_USE_INTERIOR_VELOCITY */
     &           *drF(k)* _hFacS(i,j+1,k,bi,bj)
            drFBar = drFBar + drF(k)* _hFacS(i,j+1,k,bi,bj)
           ENDDO
           IF ( drFBar .GT. 0. _d 0 ) vZonBar = vZonBar/drFBar
           DO k=1,Nr
#ifdef OBCS_STEVENS_USE_INTERIOR_VELOCITY
            vZonPri(k) = (vVel(i,j+2,k,bi,bj)-vZonBar)
#else
            vZonPri(k) = (OBSvStevens(i,k,bi,bj)-vZonBar)
#endif /*  OBCS_STEVENS_USE_INTERIOR_VELOCITY */
     &           * _maskS(i,j+1,k,bi,bj)
           ENDDO
C     vertical average of input field
           drFBar  = 0. _d 0
           vZonBar = 0. _d 0
           DO k=1,Nr
            vZonBar = vZonBar + OBSv(i,k,bi,bj)
     &           *drF(k)* _hFacS(i,j+1,k,bi,bj)
            drFBar = drFBar + drF(k)* _hFacS(i,j+1,k,bi,bj)
           ENDDO
           IF ( drFBar .GT. 0. _d 0 ) vZonBar = vZonBar/drFBar
C     Now the absolute velocity normal to the boundary is
C     vZonBar + vZonPri(K).
           DO k=1,Nr
            OBSv(i,k,bi,bj) = (vZonBar + vZonPri(k))
     &          * _maskS(i,j+1,k,bi,bj)
CML            OBSu(I,K,bi,bj) = 0. _d 0
#ifdef ALLOW_NONHYDROSTATIC
            OBSw(i,k,bi,bj)=0.
#endif
           ENDDO
          ENDIF
         ENDDO
#ifdef NONLIN_FRSURF
C     this is a bit of a hack
         IF ( nonlinFreeSurf.GT.0 ) THEN
          DO i=1-OLx,sNx+OLx
           j = OB_Js(i,bi,bj)
           IF ( j.NE.OB_indexNone ) THEN
            OBSeta(i,bi,bj) = etaN(i,j+1,bi,bj)
           ENDIF
          ENDDO
         ENDIF
#endif /* NONLIN_FRSURF */
C     Next, we compute the phase speed correction, which depends on the
C     tracer!
         DO k=1,Nr
          DO i=1-OLx,sNx+OLx
           j = OB_Js(i,bi,bj)
           IF ( j.NE.OB_indexNone ) THEN
            cflZon(i,k) = 0.5 _d 0 * _dyC(i,j+2,bi,bj)/dTtracerLev(k)
CML         gFacZ = 0. _d 0
CML         IF ( vVel(I,J+1,K,bi,bj) .GT. 0. _d 0 ) gFacZ = 1. _d 0
            gFacZ(i,k)  = ABS(MAX(SIGN(1.D0,vVel(i,j+1,k,bi,bj)),0.D0))
           ELSE
            cflZon(i,k) = 0. _d 0
            gFacZ (i,k) = 0. _d 0
           ENDIF
          ENDDO
         ENDDO
# ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE cflZon, gFacZ = comlev1_bibj, key=tkey, kind=isbyte
# endif
C     theta
         CALL OBCS_STEVENS_CALC_TRACER_SOUTH(
     U        OBSt,
     I        OBStStevens, theta, gammat,
     I        vVel, cflZon, gFacZ, pFac, aFac,
     I        OB_Js, OB_indexNone, bi, bj,
     I        futureTime, futureIter,
     I        myThid )
C     salinity
         CALL OBCS_STEVENS_CALC_TRACER_SOUTH(
     U        OBSs,
     I        OBSsStevens, salt, gammas,
     I        vVel, cflZon, gFacZ, pFac, aFac,
     I        OB_Js, OB_indexNone, bi, bj,
     I        futureTime, futureIter,
     I        myThid )
C     ptracers
C     IF ( useStevensSouth ) THEN
        ENDIF
#endif /* ALLOW_OBCS_SOUTH */

C     end bi/bj-loops
       ENDDO
      ENDDO

C     save the tracer fields of the previous time step for the next time step
      CALL OBCS_STEVENS_SAVE_TRACERS(
     I     futureTime, futureIter,
     I     myThid )
C ------------------------------------------------------------------------------

#ifdef CHECK_BALANCE
      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        uPhase=0.
        vPhase=0.
        uVelLoc = 0.
        DO j=1-OLy,sNy+OLy
         uMerBar=0. _d 0
         DO k=1,Nr
          i = OB_Ie(j,bi,bj)
          IF ( i.EQ.OB_indexNone ) i = 1
          uPhase = uPhase + OBEu(j,k,bi,bj)
     &         *drF(k)* _hFacW(i,j,k,bi,bj)*dyG(i,j,bi,bj)
          i = OB_Iw(j,bi,bj)
          IF ( i.EQ.OB_indexNone ) i = 1
          vPhase = vPhase + OBWu(j,k,bi,bj)
     &         *drF(k)* _hFacW(i+1,j,k,bi,bj)*dyG(i+1,j,bi,bj)
CML          uVelLoc = uVelLoc + uMerPri(J,K)
CML     &         *drF(k)* _hFacW(I+1,J,K,bi,bj)*dyG(I+1,J,bi,bj)
CML          uMerBar(J)=uMerBar(J) + uMerPri(J,K)
CML     &         *drF(k)* _hFacW(I+1,J,K,bi,bj)
         ENDDO
CML         print *, 'ml-obcs: uBar = ', j,uMerBar(J)
        ENDDO
C     end bi/bj-loops
       ENDDO
      ENDDO
      _GLOBAL_SUM_RL( uPhase, myThid )
      _GLOBAL_SUM_RL( vPhase, myThid )
CML      _GLOBAL_SUM_RL( uVelLoc, myThid )
      print *, 'ml-obcs: OBE  = ',  uPhase*1 _d -6, ' Sv'
      print *, 'ml-obcs: OBW  = ',  vPhase*1 _d -6, ' Sv'
CML      print *, 'ml-obcs: OBWp = ', uVelLoc*1 _d -6, ' Sv'
#endif /* CHECK_BALANCE */

#ifdef ALLOW_DEBUG
         IF (debugMode) CALL DEBUG_LEAVE('OBCS_CALC_STEVENS',myThid)
#endif

#endif /* ALLOW_OBCS_STEVENS */
      RETURN
      END

CBOP
C     !ROUTINE: OBCS_STEVENS_CALC_TRACER_EAST
C     !INTERFACE:
      SUBROUTINE OBCS_STEVENS_CALC_TRACER_EAST(
     U     OBEf,
     I     OBE_Stevens, tracer, gammaf,
     I     uVel, cflMer, gFacM, pFac, aFac,
     I     OB_I, OB_indexNone, bi, bj,
     I     futureTime, futureIter,
     I     myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE OBCS_STEVENS_CALC_TRACER_EAST
C     | Calculate tracer value at the eastern OB location
C     *==========================================================*
C     \ev
C     !USES:
      IMPLICIT NONE
C     == Global variables ==
#include "SIZE.h"
#include "GRID.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C    myThid    :: my Thread Id number
C    bi, bj    :: indices of current tile
      _RL futureTime
      INTEGER futureIter
      INTEGER myThid
      INTEGER bi, bj
      INTEGER OB_indexNone
      INTEGER OB_I             (1-OLy:sNy+OLy,nSx,nSy)
      _RL cflMer               (1-OLy:sNy+OLy,Nr)
      _RL gFacM                (1-OLy:sNy+OLy,Nr)
      _RL gammaf, pFac, aFac
      _RL OBEf                 (1-OLy:sNy+OLy,Nr,nSx,nSy)
      _RL OBE_Stevens          (1-OLy:sNy+OLy,Nr,nSx,nSy)
      _RL tracer (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      _RL uVel   (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)

#ifdef ALLOW_OBCS_STEVENS
C     !LOCAL VARIABLES:
C     i,j,k        :: loop indices
C     uPhase       :: estimate of phase velocity for radiation condition
C     dtracSpace   :: horizontal difference of tracer
C     dtracTime    :: temporal difference of tracer
      INTEGER i,j,k
      _RL uPhase
      _RL dtracSpace
      _RL dTracTime
CEOP
      DO k=1,Nr
       DO j=1-OLy,sNy+OLy
        i = OB_I(j,bi,bj)
        IF ( i.NE.OB_indexNone ) THEN
         dTracSpace = (tracer(i-1,j,k,bi,bj)-tracer(i-2,j,k,bi,bj))
     &        * _maskW(i-1,j,k,bi,bj)
         dTracTime  = (tracer(i-1,j,k,bi,bj)-OBE_Stevens(j,k,bi,bj))
         uPhase = cflMer(j,k) * pFac
         IF ( dTracSpace .NE. 0. _d 0 ) THEN
          uPhase = MIN( cflMer(j,k),
     &         MAX( 0.D0, -cflMer(j,k)*dTracTime/dTracSpace )
     &         ) * pFac
         ENDIF
C     Compute the tracer tendency here, the tracer will be updated
C     with a simple Euler forward step in S/R obcs_apply_ts
         OBEf(j,k,bi,bj) = _maskW(i,j,k,bi,bj) * (
     &        - ( aFac*MAX(0.D0,uVel(i,j,k,bi,bj)) + uPhase )
     &        *(tracer(i,j,k,bi,bj)-tracer(i-1,j,k,bi,bj))
     &        * _recip_dxC(i,j,bi,bj)
     &        - gFacM(j,k) * gammaf
     &        * (tracer(i,j,k,bi,bj)-OBEf(j,k,bi,bj)) )
        ENDIF
       ENDDO
      ENDDO

#endif /* ALLOW_OBCS_STEVENS */
      RETURN
      END

CBOP
C     !ROUTINE: OBCS_STEVENS_CALC_TRACER_WEST
C     !INTERFACE:
      SUBROUTINE OBCS_STEVENS_CALC_TRACER_WEST(
     U     OBWf,
     I     OBW_Stevens, tracer, gammaf,
     I     uVel, cflMer, gFacM, pFac, aFac,
     I     OB_I, OB_indexNone, bi, bj,
     I     futureTime, futureIter,
     I     myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE OBCS_STEVENS_CALC_TRACER_WEST
C     | Calculate tracer value at the western OB location
C     *==========================================================*
C     \ev
C     !USES:
      IMPLICIT NONE
C     == Global variables ==
#include "SIZE.h"
#include "GRID.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C    myThid    :: my Thread Id number
C    bi, bj    :: indices of current tile
      _RL futureTime
      INTEGER futureIter
      INTEGER myThid
      INTEGER bi, bj
      INTEGER OB_indexNone
      INTEGER OB_I             (1-OLy:sNy+OLy,nSx,nSy)
      _RL cflMer               (1-OLy:sNy+OLy,Nr)
      _RL gFacM                (1-OLy:sNy+OLy,Nr)
      _RL gammaf, pFac, aFac
      _RL OBWf                 (1-OLy:sNy+OLy,Nr,nSx,nSy)
      _RL OBW_Stevens          (1-OLy:sNy+OLy,Nr,nSx,nSy)
      _RL tracer (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      _RL uVel   (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)

#ifdef ALLOW_OBCS_STEVENS
C     !LOCAL VARIABLES:
C     i,j,k        :: loop indices
C     uPhase       :: estimate of phase velocity for radiation condition
C     dtracSpace   :: horizontal difference of tracer
C     dtracTime    :: temporal difference of tracer
      INTEGER i,j,k
      _RL uPhase
      _RL dtracSpace
      _RL dTracTime
CEOP

      DO k=1,Nr
       DO j=1-OLy,sNy+OLy
        i = OB_I(j,bi,bj)
        IF ( i.NE.OB_indexNone ) THEN
         dTracSpace = (tracer(i+2,j,k,bi,bj)-tracer(i+1,j,k,bi,bj))
     &        * _maskW(i+2,j,k,bi,bj)
         dTracTime  = (tracer(i+1,j,k,bi,bj)-OBW_Stevens(j,k,bi,bj))
         uPhase = -cflMer(j,k) * pFac
         IF ( dTracSpace .NE. 0. _d 0 ) THEN
          uPhase = MAX( -cflMer(j,k),
     &         MIN( 0.D0, -cflMer(j,k)*dTracTime/dTracSpace )
     &         ) * pFac
         ENDIF
C     Compute the tracer tendency here, the tracer will be updated
C     with a simple Euler forward step in S/R obcs_apply_ts
         OBWf(j,k,bi,bj) = _maskW(i+1,j,k,bi,bj) * (
     &        - ( aFac*MIN(0.D0,uVel(i+1,j,k,bi,bj)) + uPhase )
     &        *(tracer(i+1,j,k,bi,bj)-tracer(i,j,k,bi,bj))
     &        * _recip_dxC(i+1,j,bi,bj)
     &        - gFacM(j,k) * gammaf
     &        * (tracer(i,j,k,bi,bj)-OBWf(j,k,bi,bj)) )
        ENDIF
       ENDDO
      ENDDO

#endif /* ALLOW_OBCS_STEVENS */
      RETURN
      END

CBOP
C     !ROUTINE: OBCS_STEVENS_CALC_TRACER_NORTH
C     !INTERFACE:
      SUBROUTINE OBCS_STEVENS_CALC_TRACER_NORTH(
     U     OBNf,
     I     OBN_Stevens, tracer, gammaf,
     I     vVel, cflZon, gFacZ, pFac, aFac,
     I     OB_J, OB_indexNone, bi, bj,
     I     futureTime, futureIter,
     I     myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE OBCS_STEVENS_CALC_TRACER_NORTH
C     | Calculate tracer value at the northern OB location
C     *==========================================================*
C     \ev
C     !USES:
      IMPLICIT NONE
C     == Global variables ==
#include "SIZE.h"
#include "GRID.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C    myThid    :: my Thread Id number
C    bi, bj    :: indices of current tile
      _RL futureTime
      INTEGER futureIter
      INTEGER myThid
      INTEGER bi, bj
      INTEGER OB_indexNone
      INTEGER OB_J             (1-OLx:sNx+OLx,nSx,nSy)
      _RL cflZon               (1-OLx:sNx+OLx,Nr)
      _RL gFacZ                (1-OLx:sNx+OLx,Nr)
      _RL gammaf, pFac, aFac
      _RL OBNf                 (1-OLx:sNx+OLx,Nr,nSx,nSy)
      _RL OBN_Stevens          (1-OLx:sNx+OLx,Nr,nSx,nSy)
      _RL tracer (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      _RL vVel   (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)

#ifdef ALLOW_OBCS_STEVENS
C     !LOCAL VARIABLES:
C     i,j,k        :: loop indices
C     vPhase       :: estimate of phase velocity for radiation condition
C     dtracSpace   :: horizontal difference of tracer
C     dtracTime    :: temporal difference of tracer
      INTEGER i,j,k
      _RL vPhase
      _RL dtracSpace
      _RL dTracTime
CEOP
      DO k=1,Nr
       DO i=1-OLx,sNx+OLx
        j = OB_J(i,bi,bj)
        IF ( j.NE.OB_indexNone ) THEN
C     Theta first:
         dTracSpace = (tracer(i,j-1,k,bi,bj)-tracer(i,j-2,k,bi,bj))
     &        * _maskS(i,j-1,k,bi,bj)
         dTracTime  = (tracer(i,j-1,k,bi,bj)-OBN_Stevens(i,k,bi,bj))
         vPhase = cflZon(i,k) * pFac
         IF ( dTracSpace .NE. 0. _d 0 ) THEN
          vPhase = MIN( cflZon(i,k),
     &         MAX( 0.D0, -cflZon(i,k)*dTracTime/dTracSpace )
     &         ) * pFac
         ENDIF
C     Compute the tracer tendency here, the tracer will be updated
C     with a simple Euler forward step in S/R obcs_apply_ts
         OBNf(i,k,bi,bj) = _maskS(i,j,k,bi,bj) * (
     &        - ( aFac*MAX(0.D0,vVel(i,j,k,bi,bj)) + vPhase )
     &        *(tracer(i,j,k,bi,bj)-tracer(i,j-1,k,bi,bj))
     &        * _recip_dyC(i,j,bi,bj)
     &        - gFacZ(i,k) * gammaf
     &        * (tracer(i,j,k,bi,bj)-OBNf(i,k,bi,bj)) )
        ENDIF
       ENDDO
      ENDDO

#endif /* ALLOW_OBCS_STEVENS */
      RETURN
      END

CBOP
C     !ROUTINE: OBCS_STEVENS_CALC_TRACER_SOUTH
C     !INTERFACE:
      SUBROUTINE OBCS_STEVENS_CALC_TRACER_SOUTH(
     U     OBSf,
     I     OBS_Stevens, tracer, gammaf,
     I     vVel, cflZon, gFacZ, pFac, aFac,
     I     OB_J, OB_indexNone, bi, bj,
     I     futureTime, futureIter,
     I     myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE OBCS_STEVENS_CALC_TRACER_SOUTH
C     | Calculate tracer value at the southern OB location
C     *==========================================================*
C     \ev
C     !USES:
      IMPLICIT NONE
C     == Global variables ==
#include "SIZE.h"
#include "GRID.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C    myThid    :: my Thread Id number
C    bi, bj    :: indices of current tile
      _RL futureTime
      INTEGER futureIter
      INTEGER myThid
      INTEGER bi, bj
      INTEGER OB_indexNone
      INTEGER OB_J             (1-OLx:sNx+OLx,nSx,nSy)
      _RL cflZon               (1-OLx:sNx+OLx,Nr)
      _RL gFacZ                (1-OLx:sNx+OLx,Nr)
      _RL gammaf, pFac, aFac
      _RL OBSf                 (1-OLx:sNx+OLx,Nr,nSx,nSy)
      _RL OBS_Stevens          (1-OLx:sNx+OLx,Nr,nSx,nSy)
      _RL tracer (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      _RL vVel   (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)

#ifdef ALLOW_OBCS_STEVENS
C     !LOCAL VARIABLES:
C     i,j,k        :: loop indices
C     vPhase       :: estimate of phase velocity for radiation condition
C     dtracSpace   :: horizontal difference of tracer
C     dtracTime    :: temporal difference of tracer
      INTEGER i,j,k
      _RL vPhase
      _RL dtracSpace
      _RL dTracTime
CEOP
      DO k=1,Nr
       DO i=1-OLx,sNx+OLx
        j = OB_J(i,bi,bj)
        IF ( j.NE.OB_indexNone ) THEN
         dTracSpace = (tracer(i,j+2,k,bi,bj)-tracer(i,j+1,k,bi,bj))
     &        * _maskS(i,j+2,k,bi,bj)
         dTracTime  = (tracer(i,j+1,k,bi,bj)-OBS_Stevens(i,k,bi,bj))
         vPhase = -cflZon(i,k) * pFac
         IF ( dTracSpace .NE. 0. _d 0 ) THEN
          vPhase = MAX( -cflZon(i,k),
     &         MIN( 0.D0, -cflZon(i,k)*dTracTime/dTracSpace )
     &         ) * pFac
         ENDIF
C     Compute the tracer tendency here, the tracer will be updated
C     with a simple Euler forward step in S/R obcs_apply_ts
         OBSf(i,k,bi,bj) = _maskS(i,j+1,k,bi,bj) * (
     &        - ( aFac*MIN(0.D0,vVel(i,j+1,k,bi,bj)) + vPhase )
     &        *(tracer(i,j+1,k,bi,bj)-tracer(i,j,k,bi,bj))
     &        * _recip_dyC(i,j+1,bi,bj)
     &        - gFacZ(i,k) * gammaf
     &        * (tracer(i,j,k,bi,bj)-OBSf(i,k,bi,bj)) )
        ENDIF
       ENDDO
      ENDDO

#endif /* ALLOW_OBCS_STEVENS */
      RETURN
      END

CBOP
C     !ROUTINE: OBCS_STEVENS_SAVE_TRACERS
C     !INTERFACE:
      SUBROUTINE OBCS_STEVENS_SAVE_TRACERS(
     I     futureTime, futureIter,
     I     myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE OBCS_STEVENS_SAVE_TRACERS
C     | Save tracers (of previous time step) at the OB location
C     | to be used in the next time step for Stevens boundary
C     | conditions
C     *==========================================================*
C     \ev
C     !USES:
      IMPLICIT NONE
C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "GRID.h"
#include "OBCS_PARAMS.h"
#include "OBCS_GRID.h"
#include "OBCS_FIELDS.h"
#include "DYNVARS.h"
CML#ifdef ALLOW_PTRACERS
CML#include "PTRACERS_SIZE.h"
CML#include "PTRACERS_PARAMS.h"
CML#include "PTRACERS_FIELDS.h"
CML#include "OBCS_PTRACERS.h"
CML#endif /* ALLOW_PTRACERS */

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C    myThid    :: my Thread Id number
      _RL futureTime
      INTEGER futureIter
      INTEGER myThid

#ifdef ALLOW_OBCS_STEVENS
C     !LOCAL VARIABLES:
C     bi, bj     :: indices of current tile
C     i,j,k      :: loop indices
C     Iobc, Jobc :: position-index of open boundary
      INTEGER bi,bj,i,j,k,Iobc,Jobc
CEOP

      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
#ifdef ALLOW_OBCS_NORTH
        IF ( tileHasOBN(bi,bj) .AND. useStevensNorth ) THEN
C Northern boundary
         DO i=1-OLx,sNx+OLx
          Jobc = OB_Jn(i,bi,bj)
          IF ( Jobc.NE.OB_indexNone ) THEN
           DO k = 1,Nr
            OBNtStevens(i,k,bi,bj) = theta(i,Jobc-1,k,bi,bj)
     &           *maskC(i,Jobc+1,k,bi,bj)
            OBNsStevens(i,k,bi,bj) = salt(i,Jobc-1,k,bi,bj)
     &           *maskC(i,Jobc+1,k,bi,bj)
           ENDDO
          ENDIF
         ENDDO
        ENDIF
#endif /* ALLOW_OBCS_NORTH */
#ifdef ALLOW_OBCS_SOUTH
        IF ( tileHasOBS(bi,bj) .AND. useStevensSouth ) THEN
C Southern boundary
         DO i=1-OLx,sNx+OLx
          Jobc = OB_Js(i,bi,bj)
          IF ( Jobc.NE.OB_indexNone ) THEN
           DO k = 1,Nr
            OBStStevens(i,k,bi,bj) = theta(i,Jobc+1,k,bi,bj)
     &           *maskC(i,Jobc+1,k,bi,bj)
            OBSsStevens(i,k,bi,bj) = salt(i,Jobc+1,k,bi,bj)
     &           *maskC(i,Jobc+1,k,bi,bj)
           ENDDO
          ENDIF
         ENDDO
        ENDIF
#endif /* ALLOW_OBCS_SOUTH */
#ifdef ALLOW_OBCS_EAST
        IF ( tileHasOBE(bi,bj) .AND. useStevensEast ) THEN
C Eastern boundary
         DO j=1-OLy,sNy+OLy
          Iobc = OB_Ie(j,bi,bj)
          IF ( Iobc.NE.OB_indexNone ) THEN
           DO k = 1,Nr
            OBEtStevens(j,k,bi,bj) = theta(Iobc-1,j,k,bi,bj)
     &           *maskC(Iobc-1,j,k,bi,bj)
            OBEsStevens(j,k,bi,bj) = salt(Iobc-1,j,k,bi,bj)
     &           *maskC(Iobc-1,j,k,bi,bj)
           ENDDO
          ENDIF
         ENDDO
        ENDIF
#endif /* ALLOW_OBCS_EAST */
#ifdef ALLOW_OBCS_WEST
        IF ( tileHasOBW(bi,bj) .AND. useStevensWest ) THEN
C Western boundary
         DO j=1-OLy,sNy+OLy
          Iobc = OB_Iw(j,bi,bj)
          IF ( Iobc.NE.OB_indexNone ) THEN
           DO k = 1,Nr
            OBWtStevens(j,k,bi,bj) = theta(Iobc+1,j,k,bi,bj)
     &           *maskC(Iobc+1,j,k,bi,bj)
            OBWsStevens(j,k,bi,bj) = salt(Iobc+1,j,k,bi,bj)
     &           *maskC(Iobc+1,j,k,bi,bj)
           ENDDO
          ENDIF
         ENDDO
        ENDIF
#endif /* ALLOW_OBCS_WEST */
       ENDDO
      ENDDO
#endif /* ALLOW_OBCS_STEVENS */
      RETURN
      END

#include "CAL_OPTIONS.h"

      subroutine cal_TimeStamp(
     I                          myiter,
     I                          mytime,
     O                          mydate,
     I                          mythid
     &                        )

c     ==================================================================
c     SUBROUTINE cal_TimeStamp
c     ==================================================================
c
c     o Get and print time step information for the numerical model.
c
c     started: Christian Eckert eckert@mit.edu 04-May-2000
c
c              - Adapted to calendar from the ECCO release routine
c                ecco_TimeStamp.
c
c     ==================================================================
c     SUBROUTINE cal_TimeStamp
c     ==================================================================

      implicit none

c     == global variables ==

#include "EEPARAMS.h"

c     == routine arguments ==

      integer myiter
      _RL     mytime
      integer mydate(4)
      integer mythid

      character*(max_len_mbuf) msgbuf

c     == local variables ==

c     == end of interface ==

c--   Get the current date.

      call cal_GetDate( myiter, mytime, mydate, mythid )

c--   Print integration step, time, and the corresponding date
c--   if this is the master thread instance of this routine.

      _BEGIN_MASTER(mythid)
        write(msgbuf,'(a)')
     &  ' '
        call print_message( msgbuf, standardmessageunit,
     &                      SQUEEZE_RIGHT , mythid)
        write(msgbuf,'(a,i10,a,e15.8)')
     &  ' cal_TimeStamp: iter = ',myiter,' time = ',mytime
        call print_message( msgbuf, standardmessageunit,
     &                      SQUEEZE_RIGHT , mythid)
        write(msgbuf,'(a,i10,2x,i10)')
     &  '                date = ',mydate(1),mydate(2)
        call print_message( msgbuf, standardmessageunit,
     &                      SQUEEZE_RIGHT , mythid)
        write(msgbuf,'(a)')
     &  ' '
        call print_message( msgbuf, standardmessageunit,
     &                      SQUEEZE_RIGHT , mythid)
      _END_MASTER(mythid)

      return
      end

#include "GCHEM_OPTIONS.h"

CBOP
C     !ROUTINE: CFC_TR_REGISTER
C     !INTERFACE:
      SUBROUTINE CFC_TR_REGISTER(
     U                            tracer_num, sepFTr_num,
     I                            myThid )

C     !DESCRIPTION:
C     *==========================================================*
C     | SUBROUTINE CFC_TR_REGISTER
C     | o Register CFC tracer indices
C     *==========================================================*

C     !USES:
      IMPLICIT NONE

C     == GLobal variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
c#include "PARAMS.h"
#include "CFC_SIZE.h"

C     !INPUT/OUTPUT PARAMETERS:
C     tracer_num :: current number of registered tracers
C     sepFTr_num :: number of registered tracers that use Separate Forcing
C     myThid     :: my Thread Id number
      INTEGER tracer_num
      INTEGER sepFTr_num
      INTEGER myThid

C     !LOCAL VARIABLES:
C     msgBuf     :: message buffer
      CHARACTER*(MAX_LEN_MBUF) msgBuf
CEOP

      CFC_pTr_i1 = tracer_num + 1
      tracer_num = tracer_num + CFC_Tr_num

      WRITE(msgBuf,'(2A,2I5)') '  CFC_TR_REGISTER: ',
     &     ' number of CFC tracers=', CFC_Tr_num
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(2A,2I5)') '  CFC_TR_REGISTER: ',
     &     '  starting at pTrc num=', CFC_pTr_i1
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )

      WRITE(msgBuf,'(2A,2I5)') '  CFC_TR_REGISTER: ',
     &     ' Numb. Trac & SepForc Trac:', tracer_num, sepFTr_num
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )

      RETURN
      END

#include "GAD_OPTIONS.h"

CBOP
C !ROUTINE: GAD_SOM_LIM_R

C !INTERFACE: ==========================================================
      SUBROUTINE GAD_SOM_LIM_R(
     I           bi,bj, limiter,
     U           sm_v,  sm_o,  sm_x,  sm_y,  sm_z,
     U           sm_xx, sm_yy, sm_zz, sm_xy, sm_xz, sm_yz,
     I           myThid )

C !DESCRIPTION:
C  Apply limiter before calculating vertical advection
C        Second-Order Moments Advection of tracer in Z-direction
C        ref: M.J.Prather, 1986, JGR, 91, D6, pp 6671-6681.
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C !USES: ===============================================================
      IMPLICIT NONE
#include "SIZE.h"
c #include "GRID.h"
#include "GAD.h"

C !INPUT PARAMETERS: ===================================================
C  bi,bj        :: tile indices
C  limiter      :: 0: no limiter ; 1: Prather, 1986 limiter
C  myThid       :: my Thread Id. number
      INTEGER bi,bj
      INTEGER limiter
c     _RL tracer(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER myThid

C !OUTPUT PARAMETERS: ==================================================
C  sm_v         :: volume of grid cell
C  sm_o         :: tracer content of grid cell (zero order moment)
C  sm_x,y,z     :: 1rst order moment of tracer distribution, in x,y,z direction
C  sm_xx,yy,zz  ::  2nd order moment of tracer distribution, in x,y,z direction
C  sm_xy,xz,yz  ::  2nd order moment of tracer distr., in cross direction xy,xz,yz
      _RL sm_v  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL sm_o  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL sm_x  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL sm_y  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL sm_z  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL sm_xx (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL sm_yy (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL sm_zz (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL sm_xy (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL sm_xz (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL sm_yz (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)

C !LOCAL VARIABLES: ====================================================
C  i,j,k        :: loop indices
      _RL  three
      PARAMETER( three = 3. _d 0 )
      INTEGER i,j,k
      _RL  slpmax, s1max, s1new, s2new
CEOP

      IF ( limiter.EQ.1 ) THEN
       DO k=1,Nr
        DO j=jMinAdvR,jMaxAdvR
         DO i=iMinAdvR,iMaxAdvR
C     If flux-limiting transport is to be applied, place limits on
C     appropriate moments before transport.
          slpmax = 0.
          IF ( sm_o(i,j,k).GT.0. ) slpmax = sm_o(i,j,k)
          s1max = slpmax*1.5 _d 0
          s1new = MIN(  s1max, MAX(-s1max,sm_z(i,j,k)) )
          s2new = MIN( (slpmax+slpmax-ABS(s1new)/three),
     &                 MAX(ABS(s1new)-slpmax,sm_zz(i,j,k))  )
          sm_xz(i,j,k) = MIN( slpmax, MAX(-slpmax,sm_xz(i,j,k)) )
          sm_yz(i,j,k) = MIN( slpmax, MAX(-slpmax,sm_yz(i,j,k)) )
          sm_z (i,j,k) = s1new
          sm_zz(i,j,k) = s2new
         ENDDO
        ENDDO
       ENDDO
      ENDIF

      RETURN
      END

#include "GGL90_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C !ROUTINE: GGL90_DIAGNOSTICS_INIT
C !INTERFACE:
      SUBROUTINE GGL90_DIAGNOSTICS_INIT( myThid )

C     !DESCRIPTION: \bv
C     *================================================================*
C     | Initialize list of all available diagnostics
C     *================================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     === Global variables ===
#include "EEPARAMS.h"
#include "SIZE.h"
#include "GGL90.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     myThid ::  my Thread Id number
      INTEGER myThid
CEOP

#ifdef ALLOW_DIAGNOSTICS
C     !LOCAL VARIABLES:
C     === Local variables ===
C     diagNum   :: diagnostics number in the (long) list of available diag.
C     diagMate  :: diag. mate number in the (long) list of available diag.
C     diagName  :: local short name (8c) of a diagnostics
C     diagCode  :: local parser field with characteristics of the diagnostics
C              cf head of S/R DIAGNOSTICS_INIT_EARLY or DIAGNOSTICS_MAIN_INIT
C     diagUnits :: local string (16c): physical units of a diagnostic field
C     diagTitle :: local string (80c): description of field in diagnostic
      INTEGER       diagNum
c     INTEGER       diagMate
      CHARACTER*8   diagName
      CHARACTER*16  diagCode
      CHARACTER*16  diagUnits
      CHARACTER*(80) diagTitle
CEOP
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

        diagName  = 'GGL90TKE'
        diagTitle = 'GGL90 sub-grid turbulent kinetic energy'
        diagUnits = 'm^2/s^2         '
        diagCode  = 'SM      LR      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

        diagName  = 'GGL90Emn'
        diagTitle = 'rate of TKE energy added by applying GGL90TKEmin'
        diagUnits = 'm^2/s^3         '
        diagCode  = 'SM      LR      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

        diagName  = 'GGL90Lmx'
        diagTitle = 'Mixing length scale              '
        diagUnits = 'm               '
        diagCode  = 'SM      LR      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

        diagName  = 'GGL90Prl'
        diagTitle = 'Prandtl number used in GGL90'
        diagUnits = '1               '
        diagCode  = 'SM      LR      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

        diagName  = 'GGL90ArU'
        diagTitle = 'GGL90 eddy viscosity at U-point'
        diagUnits = 'm^2/s           '
        diagCode  = 'SM      LR      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

        diagName  = 'GGL90ArV'
        diagTitle = 'GGL90 eddy viscosity at V-point'
        diagUnits = 'm^2/s           '
        diagCode  = 'SM      LR      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

        diagName  = 'GGL90Kr '
        diagTitle = 'GGL90 diffusion coefficient for temperature'
        diagUnits = 'm^2/s           '
        diagCode  = 'SM      LR      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

        diagName  = 'GGL90KN2'
        diagTitle = 'GGL90 diffusivity times buoyancy frequency'
        diagUnits = 'm^2/s^3         '
        diagCode  = 'SM      LR      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

        diagName  = 'GGL90flx'
        diagTitle = 'Surface flux of TKE                       '
        diagUnits = 'm^3/s^3         '
        diagCode  = 'SM      L1      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

        diagName  = 'GGL90tau'
        diagTitle = 'Work done by the wind                     '
        diagUnits = 'm^3/s^3         '
        diagCode  = 'SM      L1      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

#ifdef ALLOW_GGL90_IDEMIX
        diagName  = 'IDEMIX_E'
        diagTitle = 'IDEMIX internal wave energy            '
        diagUnits = 'm^2/s^2         '
        diagCode  = 'SM      LR      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

        diagName  = 'IDEMgTKE'
        diagTitle = 'IDEMIX tendency: tau_d times IDEMIX_E^2'
        diagUnits = 'm^2/s^3         '
        diagCode  = 'SM      LR      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

        diagName  = 'IDEMIX_c'
        diagTitle = 'IDEMIX vertical group velocity             '
        diagUnits = 'm/s             '
        diagCode  = 'SM      LR      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

        diagName  = 'IDEMIX_v'
        diagTitle = 'IDEMIX horizontal group velocity           '
        diagUnits = 'm/s             '
        diagCode  = 'SM      LR      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

        diagName  = 'IDEMIX_t'  ! m^2/s^3 /(m^4/s^4)
        diagTitle = 'IDEMIX dissipation constant                '
        diagUnits = 's/m^2           '
        diagCode  = 'SM      LR      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

        diagName  = 'IDEMIX_K'
        diagTitle = 'IDEMIX vertical diffusivity                '
        diagUnits = 'm^2/s           '
        diagCode  = 'SM      LR      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

        diagName  = 'IDEMIX_F'
        diagTitle = 'IDEMIX Forcing by gm                       '
        diagUnits = 'm^2/s^3         '
        diagCode  = 'SM      LR      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

        diagName  = 'IDEM_F_b'
        diagTitle = 'Tidal forcing at bottom                    '
        diagUnits = 'm^3/s^3         '
        diagCode  = 'SM      L1      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

        diagName  = 'IDEM_F_s'
        diagTitle = 'Wind forcing at surface                   '
        diagUnits = 'm^3/s^3         '
        diagCode  = 'SM      L1      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

        diagName  = 'IDEM_F_g'
        diagTitle = 'Integrated GM forcing                     '
        diagUnits = 'm^3/s^3         '
        diagCode  = 'SM      L1      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

#endif

#ifdef ALLOW_AUTODIFF
      diagName  = 'ADJtke90'
      diagTitle = 'dJ/dTKE: Sensitivity to GGL90 TKE'
      diagUnits = 'dJ/(m^2/s^2)   '
      diagCode  = 'SMRA    MR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )
#endif

#endif /* ALLOW_DIAGNOSTICS */

      RETURN
      END

#include "CPP_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: PACKAGES_PRINT_MSG
C     !INTERFACE:
      SUBROUTINE PACKAGES_PRINT_MSG( usePKG, pkgName, pkgMsg )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE PACKAGES_PRINT_MSG
C     | o Print status (used or not) of a compiled package
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
C     pkgName ::  package name
C     pkgMsg  ::  package On/Off flag name
C     usePKG  ::  package On/Off flag
C     myThid  ::  My thread Id number
      LOGICAL usePKG
      CHARACTER*(*) pkgName, pkgMsg
c     INTEGER myThid

C     !LOCAL VARIABLES:
C     === Local variables ===
C     msgBuf :: Informational/error message buffer
c     CHARACTER*(MAX_LEN_MBUF) msgBuf
      CHARACTER*(MAX_LEN_MBUF) pkgLwc
      CHARACTER*(MAX_LEN_MBUF) pkgUse
      CHARACTER*(20) prtFmt
      INTEGER iLen, pLen
      PARAMETER( pLen = 24 )
CEOP

      WRITE(pkgLwc,'(A)') ' '
      WRITE(pkgUse,'(A)') ' '
      WRITE(prtFmt,'(A,I2,A)') '(2(A,A', pLen, ',A),L2,A)'
c     print *, prtFmt

      iLen = LEN(pkgName)
      pkgLwc(1:iLen+4) = 'pkg/'//pkgName
      CALL LCASE(pkgLwc(1:iLen+4))

      IF ( pkgMsg .EQ. 'None' ) THEN
        WRITE(standardMessageUnit,prtFmt)
     &   ' ', pkgLwc(1:pLen), ' compiled   ( used ? )'
        RETURN
      ELSEIF ( pkgMsg .EQ. 'Used' ) THEN
        WRITE(standardMessageUnit,prtFmt)
     &   ' ', pkgLwc(1:pLen), ' compiled   and   used'
        RETURN
      ENDIF

      IF ( pkgMsg .EQ. ' ' ) THEN
        pkgUse(1:iLen+3) = 'use'//pkgName
      ELSE
        iLen = LEN(pkgMsg)
        pkgUse(1:iLen) = pkgMsg
      ENDIF
      IF ( usePKG ) THEN
        WRITE(standardMessageUnit,prtFmt)
     &   ' ', pkgLwc(1:pLen), ' compiled   and   used',
     &   ' ( ', pkgUse(1:pLen), ' =', usePKG, ' )'
      ELSE
        WRITE(standardMessageUnit,prtFmt)
     &   ' ', pkgLwc(1:pLen), ' compiled but not used',
     &   ' ( ', pkgUse(1:pLen), ' =', usePKG, ' )'
      ENDIF

      RETURN
      END

#include "SEAICE_OPTIONS.h"
#ifdef ALLOW_AUTODIFF
# include "AUTODIFF_OPTIONS.h"
#endif

CBOP
CStartOfInterface
      SUBROUTINE SEAICE_CALC_VISCOSITIES(
     I     e11, e22, e12, zMin, zMax, HEFFM, press0, tnsFac,
     O     eta, etaZ, zeta, zetaZ, press, deltaC,
     I     iStep, myTime, myIter, myThid )
C     *==========================================================*
C     | SUBROUTINE  SEAICE_CALC_VISCOSITIES                      |
C     | o compute shear and bulk viscositites eta, zeta and the  |
C     |   corrected ice strength P                               |
C     |   (see Zhang and Hibler,   JGR, 102, 8691-8702, 1997)    |
C     *==========================================================*
C     | started by Martin Losch, Mar 2006                        |
C     *==========================================================*
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "SEAICE_SIZE.h"
#include "SEAICE_PARAMS.h"

C     === Routine arguments ===
C     iStep  :: Sub-time-step number
C     myTime :: Simulation time
C     myIter :: Simulation timestep number
C     myThid :: My Thread Id. number
      INTEGER iStep
      _RL     myTime
      INTEGER myIter
      INTEGER myThid
C     strain rate tensor
      _RL e11   (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL e22   (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL e12   (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
C
      _RL zMin  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL zMax  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL HEFFM (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
C
      _RL press0(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL press (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
C
      _RL deltaC(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
C     factor k to compute tensile strength from k*press0
      _RL tnsFac(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
C     bulk viscosity
      _RL  eta  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL  etaZ (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
C     shear viscosity
      _RL zeta  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL zetaZ (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
CEndOfInterface

#ifdef SEAICE_CGRID
C     === Local variables ===
C     i,j,bi,bj - Loop counters
C     e11, e12, e22 - components of strain rate tensor
C     recip_e2      - inverse of square of ratio of yield curve main axes
C     ep            - e11+e22 (abbreviation)
C     em            - e11-e22 (abbreviation)
      INTEGER i, j, bi, bj
      _RL recip_e2, deltaCsq, deltaMinSq, tmp, ep, em, smallNbr
      _RL recip_efr4, recip_efr2, oneThird, oneNinth, smallNbrSq
      _RL e12Csq     (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL deltaCreg  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL recip_shear(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL shearDefSq, shearDef
#ifdef SEAICE_ALLOW_TEARDROP
      _RL k,ksq,x,a,ap1,etamax_TD,zetamax_TD,cyc,xma, etapr
#endif /* SEAICE_ALLOW_TEARDROP */
#if (defined SEAICE_ALLOW_MCE || defined SEAICE_ALLOW_TEM)
      _RL etaMaxFac
#endif /* SEAICE_ALLOW_MCE or SEAICE_ALLOW_TEM */
      _RL sumNorm, maskZ
#ifdef SEAICE_ZETA_SMOOTHREG
      _RL argTmp
#endif /* SEAICE_ZETA_SMOOTHREG */
CEOP

C--   basic constants
      oneThird = 1. _d 0 / 3. _d 0
      oneNinth = 1. _d 0 / 9. _d 0
      smallNbr = 1. _d -20
      smallNbrSq = smallNbr * smallNbr

      recip_e2=0. _d 0
      IF ( SEAICE_eccen .NE. 0. _d 0 ) recip_e2=ONE/(SEAICE_eccen**2)
      recip_efr2=0. _d 0
      recip_efr4=0. _d 0
      IF( SEAICE_eccfr .NE. 0. _d 0) THEN
       recip_efr2=ONE/(SEAICE_eccfr**2)
       recip_efr4=(SEAICE_eccen**2) / (SEAICE_eccfr**4)
      ENDIF
      deltaMinSq = SEAICE_deltaMin**2
C
      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
#ifdef ALLOW_AUTODIFF
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          deltaCreg  (i,j) = SEAICE_deltaMin
          e12Csq     (i,j) = 0. _d 0
          recip_shear(i,j) = 0. _d 0
         ENDDO
        ENDDO
#endif /* ALLOW_AUTODIFF */
C     need to do this beforehand for easier vectorization after
C     TAFization
        IF ( SEAICEetaZmethod .EQ. 0 ) THEN
         DO j=1-OLy+1,sNy+OLy-1
          DO i=1-OLx+1,sNx+OLx-1
           tmp = 0.25 *
     &          ( e12(i,j  ,bi,bj) + e12(i+1,j  ,bi,bj)
     &          + e12(i,j+1,bi,bj) + e12(i+1,j+1,bi,bj) )
           e12Csq(i,j) = tmp*tmp
          ENDDO
         ENDDO
        ELSEIF ( SEAICEetaZmethod .EQ. 3 ) THEN
         DO j=1-OLy+1,sNy+OLy-1
          DO i=1-OLx+1,sNx+OLx-1
C     area weighted average of the squares of e12 is more accurate
C     (and energy conserving)
           e12Csq(i,j) = 0.25 _d 0 * recip_rA(i,j,bi,bj) *
     &          ( rAz(i  ,j  ,bi,bj)*e12(i  ,j  ,bi,bj)**2
     &          + rAz(i+1,j  ,bi,bj)*e12(i+1,j  ,bi,bj)**2
     &          + rAz(i  ,j+1,bi,bj)*e12(i  ,j+1,bi,bj)**2
     &          + rAz(i+1,j+1,bi,bj)*e12(i+1,j+1,bi,bj)**2 )
          ENDDO
         ENDDO
        ENDIF
        DO j=1-OLy+1,sNy+OLy-1
         DO i=1-OLx+1,sNx+OLx-1
          em = e11(i,j,bi,bj)-e22(i,j,bi,bj)
          shearDefSq = em*em + 4. _d 0 * e12Csq(i,j)
#ifdef SEAICE_DELTA_SMOOTHREG
          recip_shear(i,j) = 1. _d 0
     &                / SQRT( shearDefSq + smallNbrSq )
C         recip_shear(i,j) = 1. _d 0 / ( shearDef + smallNbr )
#else
# ifdef ALLOW_AUTODIFF
C     avoid sqrt of 0
          shearDef = 0. _d 0
          IF ( shearDefSq .GT. 0. _d 0 ) shearDef = SQRT(shearDefSq)
# else
          shearDef = SQRT(shearDefSq)
# endif /* ALLOW_AUTODIFF */
          recip_shear(i,j) = 1. _d 0 / MAX( ShearDef, smallNbr )
#endif /* SEAICE_DELTA_SMOOTHREG */
         ENDDO
        ENDDO

C     select between different yield curves; default: elliptical yield curve
        IF ( .FALSE. ) THEN
C     do nothing (hack to be able add code with different cpp-flag)
#ifdef SEAICE_ALLOW_TEARDROP
        ELSEIF ( SEAICEuseTD ) THEN

         DO j=1-OLy+1,sNy+OLy-1
          DO i=1-OLx+1,sNx+OLx-1
           ep = e11(i,j,bi,bj)+e22(i,j,bi,bj)
           em = e11(i,j,bi,bj)-e22(i,j,bi,bj)
C            shearDef = SQRT(em*em + 4. _d 0 * e12Csq(i,j))

           k   = ep * recip_shear(i,j)
           ksq = k * k
           a   = tnsFac(i,j,bi,bj)

C     cyc: coordinate of the maximum point of the yield curve,
C     where eI changes sign
           cyc=( TWO - tnsFac(i,j,bi,bj) ) * oneThird
           ap1 = a + ONE

C     handle floating point errors when k is negative and very large
           IF ( k .LT. -1. _d 3 ) THEN
            x = (3. _d 0 * ap1)
     &        * ( - 1. _d 0 + 0.125 _d 0 *(3. _d 0 * ap1 ) / ksq )
           ELSE
            x = TWO * ksq + TWO *k*SQRT(ksq + 3. _d 0 * ap1 )
           ENDIF
           x = (x - (6. _d 0 * ap1) ) * oneNinth + a
C     original formulation of Zhang 2005:
C          x = ( TWO * ksq + TWO *k*sqrt(ksq + 3. _d 0 * ap1 )
C      &          - (6. _d 0 * ap1) ) * oneNinth + a

C     Teardrop yield curve:
C     capping x at a is probably better that setting it to a for x>1,
C     but still not ideal (because non-differentiable)
C     possible alternative: log(exp(rho*x)+exp(rho*a))/rho, with rho=O(100)
           x = MIN( x, a )
C          x = MAX( x,-1 _d 0 ) ! to be sure

#ifdef SEAICE_DELTA_SMOOTHREG
           zeta(i,j,bi,bj) = (x + cyc) * press0(i,j,bi,bj)
     &          / SIGN( SQRT(ep*ep+smallNbrSq), ep)
#else
           zeta(i,j,bi,bj) = (x + cyc) * press0(i,j,bi,bj)
     &          / SIGN( MAX( ABS(ep),smallNbr ), ep)
#endif /* SEAICE_DELTA_SMOOTHREG */
C      original formulation of Zhang 2005
C          zeta(i,j,bi,bj) = (x + 0.5 _d 0) * press0(i,j,bi,bj)
C      &        / SIGN( ABS(ep) + SEAICE_deltaMin, ep)
C      &        / SIGN( MAX( ABS(ep),deltaMinSq ), 0.5 _d 0 * ep)

           eta(i,j,bi,bj) = -(x-a) * SQRT(ONE+x) * press0(i,j,bi,bj)
     &                     * recip_shear(i,j)

C      define the max values for eta and zeta
           etamax_TD = zMax(i,j,bi,bj) * MIN(eta(i,j,bi,bj)
     &               /(ABS(zeta(i,j,bi,bj)) + smallNbr), ONE)
           zetamax_TD =zMax(i,j,bi,bj) * MIN(zeta(i,j,bi,bj)
     &               /(ABS(eta(i,j,bi,bj)) + smallNbr), ONE )

C      apply the max values
           zeta(i,j,bi,bj) = MIN(zeta(i,j,bi,bj), zetamax_TD)
           eta (i,j,bi,bj) = MIN( eta(i,j,bi,bj),  etamax_TD)
C      original formulation of Zhang 2005
C          zeta(i,j,bi,bj) = MIN(zeta(i,j,bi,bj), zMax(i,j,bi,bj))
C          eta (i,j,bi,bj) = MIN( eta(i,j,bi,bj), zMax(i,j,bi,bj))

C      compute the replacement pressure
           press(i,j,bi,bj) = TWO * cyc * (
     &          press0(i,j,bi,bj)*( ONE - SEAICEpressReplFac )
     &         + SEAICEpressReplFac * ep * zeta(i,j,bi,bj)
     &         / SIGN(MAX(ABS(x+cyc), smallNbr), x+cyc) )

C      reduce eta according to replacement pressure
           etapr = -(x-a) * SQRT(ONE + x) * press(i,j,bi,bj)/(ONE-a)
     &                    * recip_shear(i,j)
           etapr = MIN( etapr, etamax_TD )
           eta(i,j,bi,bj) =  SEAICEpressReplFac * etapr
     &          + eta(i,j,bi,bj) * ( ONE - SEAICEpressReplFac )

          ENDDO ! x loop
         ENDDO ! y loop

        ELSEIF ( SEAICEusePL ) THEN

         DO j=1-OLy+1,sNy+OLy-1
          DO i=1-OLx+1,sNx+OLx-1

           ep = e11(i,j,bi,bj)+e22(i,j,bi,bj)
           k = ep * recip_shear(i,j)
           a = tnsFac(i,j,bi,bj)
           x = 0.5 _d 0 * (k - 1. _d 0 + a)
           x = MAX( x, -1. _d 0 )
           x = MIN( x, a )
           xma = x + 0.5 _d 0 *(1. _d 0 - a )
C     compute zeta
#ifdef SEAICE_DELTA_SMOOTHREG
           zeta(i,j,bi,bj) = xma * press0(i,j,bi,bj)
     &                    / SIGN( SQRT(ep*ep + smallNbrSq) , ep)
#else
           zeta(i,j,bi,bj) = xma * press0(i,j,bi,bj)
     &                    / SIGN( MAX(ABS(ep),smallNbr) , ep)
#endif /* SEAICE_DELTA_SMOOTHREG */
C      original formulation of Zhang 2005
C          zeta(i,j,bi,bj) = (x + 0.5 _d 0) * press0(i,j,bi,bj)
C      &        / SIGN( ABS(ep) + SEAICE_deltaMin, ep)
C      &        / SIGN( MAX( ABS(ep),deltaMinSq ), 0.5 _d 0 * ep)

C     compute eta
           eta(i,j,bi,bj) = -(x-a) * (ONE + x) * press0(i,j,bi,bj)
     &                    * recip_shear(i,j)

C     maximum of eta and zeta
           etamax_TD = zMax(i,j,bi,bj) * MIN(eta(i,j,bi,bj)
     &               /(ABS(zeta(i,j,bi,bj)) + smallNbr),ONE )
           zetamax_TD =zMax(i,j,bi,bj) * MIN(zeta(i,j,bi,bj)
     &               /(ABS(eta(i,j,bi,bj))  + smallNbr),ONE )

C     apply the maxiums on zeta and eta
           zeta(i,j,bi,bj) = MIN(zeta(i,j,bi,bj),zetamax_TD)
           eta (i,j,bi,bj) = MIN( eta(i,j,bi,bj), etamax_TD)

C     replacement pressure
           press(i,j,bi,bj) =
     &          ( press0(i,j,bi,bj)*( ONE - SEAICEpressReplFac )
     &          + zeta(i,j,bi,bj) * ep * SEAICEpressReplFac
     &          / SIGN(ABS(xma) + smallNbr, xma ) )
     &          * ( ONE - a )

C     change eta according to replacement pressure
           etapr = -(x-a) * (ONE + x) * press(i,j,bi,bj)/(ONE-a)
     &                    * recip_shear(i,j)
           etapr = MIN( etapr, etamax_TD )
           eta(i,j,bi,bj) =  SEAICEpressReplFac * etapr
     &          + eta(i,j,bi,bj) * ( ONE - SEAICEpressReplFac )
          ENDDO !i loop
         ENDDO !j loop
#endif /* SEAICE_ALLOW_TEARDROP */
#ifdef SEAICE_ALLOW_MCS
        ELSEIF ( SEAICEuseMCS ) THEN
C     Full Mohr-Coulomb following IP et al. 1991
         DO j=1-OLy+1,sNy+OLy-1
          DO i=1-OLx+1,sNx+OLx-1

C     compute eI = ep
           ep = e11(i,j,bi,bj)+e22(i,j,bi,bj)

C     compute zeta
#ifdef SEAICE_DELTA_SMOOTHREG
           zeta(i,j,bi,bj) = press0(i,j,bi,bj)*(ONE+tnsFac(i,j,bi,bj))
     &                      / (TWO * SQRT(ep*ep+deltaMinSq) )
#else
           zeta(i,j,bi,bj) = press0(i,j,bi,bj)*(ONE+tnsFac(i,j,bi,bj))
     &                      / (TWO * MAX(ABS(ep),SEAICE_deltaMin) )
#endif /* SEAICE_DELTA_SMOOTHREG */

C     replacement pressure
           press(i,j,bi,bj) = ( ONE - tnsFac(i,j,bi,bj) )
     &      * ( press0(i,j,bi,bj) * ( ONE - SEAICEpressReplFac )
     &      + SEAICEpressReplFac * TWO * zeta(i,j,bi,bj) * ABS(ep)
     &      / ( ONE + tnsFac(i,j,bi,bj) ) )

C     compute eta  (eMax=zMax)
           eta(i,j,bi,bj) = SEAICEmcMU * (0.5 _d 0 * press(i,j,bi,bj)
     &      - zeta(i,j,bi,bj)*ep+press0(i,j,bi,bj)*tnsFac(i,j,bi,bj))
     &       * recip_shear(i,j)

C     maximum for eta (high compressive stresses)
           eta(i,j,bi,bj) = MIN(eta(i,j,bi,bj) , zMax(i,j,bi,bj))

          ENDDO
         ENDDO
#endif /* SEAICE_ALLOW_MCS */
        ELSE
C     For all elliptic yield curves, the computation of deltaC and zeta
C     is identical so we do it first.
         DO j=1-OLy+1,sNy+OLy-1
          DO i=1-OLx+1,sNx+OLx-1
           ep = e11(i,j,bi,bj)+e22(i,j,bi,bj)
           em = e11(i,j,bi,bj)-e22(i,j,bi,bj)
           shearDefSq = em*em + 4. _d 0*e12Csq(i,j)
           deltaCsq   = ep*ep + recip_efr4*shearDefSq
CML The old formulation does not ensure that deltaC**2 is always positive,
CML but in case you need it to reproduce old results, here it is:
CML          deltaCsq =
CML     &         (e11(i,j,bi,bj)**2+e22(i,j,bi,bj)**2)*(ONE+recip_e2)
CML     &         + 4. _d 0*recip_e2*e12Csq(i,j)
CML     &         + 2. _d 0*e11(i,j,bi,bj)*e22(i,j,bi,bj)*(ONE-recip_e2)
#ifdef ALLOW_AUTODIFF
C     avoid sqrt of 0
           deltaC(i,j,bi,bj) = 0. _d 0
           IF ( deltaCsq .GT. 0. _d 0 )
     &          deltaC(i,j,bi,bj) = SQRT(deltaCsq)
#else
           deltaC(i,j,bi,bj) = SQRT(deltaCsq)
#endif /* ALLOW_AUTODIFF */
#ifdef SEAICE_DELTA_SMOOTHREG
C     smooth regularization (without max-function) of delta for
C     better differentiability
           deltaCreg(i,j) = SQRT(deltaCsq + deltaMinSq)
CML          deltaCreg(i,j) = deltaC(i,j,bi,bj) + SEAICE_deltaMin
#else
           deltaCreg(i,j) = MAX(deltaC(i,j,bi,bj),SEAICE_deltaMin)
#endif /* SEAICE_DELTA_SMOOTHREG */
#ifdef SEAICE_ZETA_SMOOTHREG
C     regularize zeta to zmax with a smooth tanh-function instead
C     of a min(zeta,zmax). This improves convergence of iterative
C     solvers (Lemieux and Tremblay 2009, JGR). No effect on EVP
           argTmp = exp(-1. _d 0/(deltaCreg(i,j)*SEAICE_zetaMaxFac))
           zeta (i,j,bi,bj) = zMax(i,j,bi,bj)
     &          *(1. _d 0 - argTmp)/(1. _d 0 + argTmp)
     &          *(1. _d 0 + tnsFac(i,j,bi,bj) )
#else
           zeta (i,j,bi,bj) = HALF*( press0(i,j,bi,bj)
     &          * ( 1. _d 0 + tnsFac(i,j,bi,bj) )
     &          )/deltaCreg(i,j)
C     put min and max viscosities in
           zeta (i,j,bi,bj) = MIN(zMax(i,j,bi,bj),zeta(i,j,bi,bj))
#endif /*  SEAICE_ZETA_SMOOTHREG */
           zeta (i,j,bi,bj) = MAX(zMin(i,j,bi,bj),zeta(i,j,bi,bj))
C     set viscosities to zero at HEFFM flow pts
           zeta (i,j,bi,bj) = zeta(i,j,bi,bj)*HEFFM(i,j,bi,bj)
C     "replacement pressure"
           press(i,j,bi,bj) =
     &          ( press0(i,j,bi,bj)*( 1. _d 0 - SEAICEpressReplFac )
     &          + TWO*zeta(i,j,bi,bj)*deltaC(i,j,bi,bj)
     &          * SEAICEpressReplFac/( 1. _d 0 + tnsFac(i,j,bi,bj) )
     &          ) * ( 1. _d 0 - tnsFac(i,j,bi,bj) )
CML          press(i,j,bi,bj) = press0(i,j,bi,bj) *
CML     &         ( 1. _d 0 + SEAICEpressReplFac
CML     &                  * ( deltaC(i,j,bi,bj)/deltaCreg(i,j) - 1. _d 0 )
CML     &         ) * ( 1. _d 0 - tnsFac(i,j,bi,bj) )
          ENDDO
         ENDDO
C     The elliptical yield curves differ in the way eta is computed.
#if (defined SEAICE_ALLOW_MCE) || (defined SEAICE_ALLOW_TEM)
         IF ( SEAICEuseMCE .OR. SEAICEuseTEM ) THEN
C     MC yield curve with non-normal flow rule (elliptical plastic potential)
C     or Truncated Ellipse method with Coulombic limbs
          DO j=1-OLy+1,sNy+OLy-1
           DO i=1-OLx+1,sNx+OLx-1
            ep = e11(i,j,bi,bj)+e22(i,j,bi,bj)
C     compute eta:
C     In principle, we need to recompute zeta here, because we need the
C     unlimited version
C          zetaLoc = HALF*( press0(i,j,bi,bj)
C    &          * ( 1. _d 0 + tnsFac(i,j,bi,bj) )
C    &          )/deltaCreg(i,j)
C           eta(i,j,bi,bj) = SEAICEmcMU * (0.5 * press0(i,j,bi,bj)
C    &           * ( 1. _d 0 - tnsFac(i,j,bi,bj) ) - zetaLoc * ep
C    &           + press0(i,j,bi,bj)*tnsFac(i,j,bi,bj)) / shearDef
C     but in this formulation, only ep/deltaCreg(i,j) remains
            eta(i,j,bi,bj) = SEAICEmcMU * HALF * press0(i,j,bi,bj)
     &           * ( 1. _d 0 + tnsFac(i,j,bi,bj) )
     &           * ( 1. _d 0 - ep/deltaCreg(i,j) ) * recip_shear(i,j)
C     compute etaMaxFac = zMax/zetaLoc
            etaMaxFac = SEAICE_zetaMaxFac * 2. _d 0 * deltaCreg(i,j)
     &           / ( 1. _d 0 + tnsFac(i,j,bi,bj) )
C     apply maximum from Mohr-Coulomb limbs
            eta(i,j,bi,bj) = eta(i,j,bi,bj) * MIN( 1. _d 0, etaMaxFac )
C     apply maximum from Elliptical formulation (to be sure)
            eta(i,j,bi,bj) =
     &           MIN( eta(i,j,bi,bj), zMax(i,j,bi,bj)*recip_efr2 )
           ENDDO
          ENDDO
C     close the coulombic limbs with the ellipse for compression
          IF ( SEAICEuseTEM) THEN
           DO j=1-OLy+1,sNy+OLy-1
            DO i=1-OLx+1,sNx+OLx-1
             eta(i,j,bi,bj) = MIN( eta(i,j,bi,bj),
     &                             zeta(i,j,bi,bj) * recip_efr2 )
            ENDDO
           ENDDO
          ENDIF
         ELSE
#endif /* SEAICE_ALLOW_MCE or SEAICE_ALLOW_TEM */
C     default elliptical yield curve
          DO j=1-OLy+1,sNy+OLy-1
           DO i=1-OLx+1,sNx+OLx-1
            eta(i,j,bi,bj) = zeta(i,j,bi,bj) * recip_efr2
           ENDDO
          ENDDO
#if (defined SEAICE_ALLOW_MCE) || (defined SEAICE_ALLOW_TEM)
C     end of elliptical yield curve options
         ENDIF
#endif /* SEAICE_ALLOW_MCE or SEAICE_ALLOW_TEM */
C     end of yield curve options
        ENDIF

C     compute eta at Z-points by simple averaging
        DO j=1-OLy+1,sNy+OLy-1
         DO i=1-OLx+1,sNx+OLx-1
          sumNorm  = HEFFM(i,j,  bi,bj)+HEFFM(i-1,j,  bi,bj)
     &             + HEFFM(i,j-1,bi,bj)+HEFFM(i-1,j-1,bi,bj)
          IF ( sumNorm.GT.0. _d 0 ) sumNorm = 1. _d 0 / sumNorm
          etaZ(i,j,bi,bj) = sumNorm *
     &         ( eta (i,j  ,bi,bj)  + eta (i-1,j  ,bi,bj)
     &         + eta (i,j-1,bi,bj)  + eta (i-1,j-1,bi,bj) )
          zetaZ(i,j,bi,bj) = sumNorm *
     &         ( zeta(i,j  ,bi,bj)  + zeta(i-1,j  ,bi,bj)
     &         + zeta(i,j-1,bi,bj)  + zeta(i-1,j-1,bi,bj) )
         ENDDO
        ENDDO
C     free-slip means no lateral stress, which is best achieved by masking
C     eta on vorticity(=Z)-points; from now on we only need to worry
C     about the no-slip boundary conditions
        IF (.NOT.SEAICE_no_slip) THEN
         DO j=1-OLy+1,sNy+OLy-1
          DO i=1-OLx+1,sNx+OLx-1
           maskZ = HEFFM(i,j,  bi,bj)*HEFFM(i-1,j,  bi,bj)
     &          *  HEFFM(i,j-1,bi,bj)*HEFFM(i-1,j-1,bi,bj)
           etaZ (i,j,bi,bj) =  etaZ(i,j,bi,bj) * maskZ
           zetaZ(i,j,bi,bj) = zetaZ(i,j,bi,bj) * maskZ
          ENDDO
         ENDDO
        ENDIF
       ENDDO
      ENDDO

#endif /* SEAICE_CGRID */
      RETURN
      END

#include "PACKAGES_CONFIG.h"
#include "CPP_OPTIONS.h"
#ifdef ALLOW_EXCH2
# include "W2_OPTIONS.h"
#endif /* ALLOW_EXCH2 */
#ifdef ALLOW_MOM_COMMON
# include "MOM_COMMON_OPTIONS.h"
#endif

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: CONFIG_SUMMARY

C     !INTERFACE:
      SUBROUTINE CONFIG_SUMMARY( myThid )

C     !DESCRIPTION:
C     This routine summarizes the model parameter settings by writing a
C     tabulated list of the kernel model configuration variables.  It
C     describes all the parameter settings in force and the meaning and
C     units of those parameters. Individal packages report a similar
C     table for each package using the same format as employed here. If
C     parameters are missing or incorrectly described or dimensioned
C     please contact <MITgcm-support@mitgcm.org>

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#ifdef ALLOW_EXCH2
# include "W2_EXCH2_SIZE.h"
# include "W2_EXCH2_TOPOLOGY.h"
#endif /* ALLOW_EXCH2 */
#include "EOS.h"
#include "GRID.h"
#ifdef ALLOW_MOM_COMMON
# include "MOM_VISC.h"
#endif
C- need to put SET_GRID in last position for module conversion with OpenAD
#include "SET_GRID.h"
#ifdef ALLOW_MNC
#include "MNC_PARAMS.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     myThid ::  Number of this instance of CONFIG_SUMMARY
      INTEGER myThid
CEOP

C     !FUNCTIONS:
      INTEGER  ILNBLNK
      EXTERNAL ILNBLNK

C     !LOCAL VARIABLES:
C     msgBuf :: Temp. for building output string.
C     rUnits :: vertical coordinate units
C     ioUnit :: Temp. for fortran I/O unit
C     i, k   :: Loop counters.
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      CHARACTER*2 rUnits
      CHARACTER*10 endList
      INTEGER ioUnit
      INTEGER i, k
      _RL     bufRL(Nr+1)
      INTEGER buffI(1)
      INTEGER coordLine
      INTEGER tileLine
      INTEGER gridNx, gridNy

      _BARRIER
      _BEGIN_MASTER(myThid)

      ioUnit = standardMessageUnit
      rUnits = ' m'
      endList = '    ;     '
      IF ( usingPCoords ) rUnits = 'Pa'
#ifdef ALLOW_EXCH2
      gridNx = exch2_mydNx(1)
      gridNy = exch2_mydNy(1)
#else /* ALLOW_EXCH2 */
      gridNx = Nx
      gridNy = Ny
#endif /* ALLOW_EXCH2 */

      WRITE(msgBuf,'(A)')
     &'// ======================================================='
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)') '// Model configuration'
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)')
     &'// ======================================================='
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )

      WRITE(msgBuf,'(A)') '//  '
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)')
     & '// "Physical" paramters ( PARM01 in namelist ) '
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)') '//  '
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      CALL WRITE_0D_C( buoyancyRelation, -1, INDEX_NONE,
     & 'buoyancyRelation =', ' /* Type of relation to get Buoyancy */')
      CALL WRITE_0D_L( fluidIsAir,   INDEX_NONE,
     & 'fluidIsAir   =', '  /* fluid major constituent is Air */')
      CALL WRITE_0D_L( fluidIsWater, INDEX_NONE,
     & 'fluidIsWater =', '  /* fluid major constituent is Water */')
      CALL WRITE_0D_L( usingPCoords, INDEX_NONE,
     & 'usingPCoords =', '  /* use p (or p*) vertical coordinate */')
      CALL WRITE_0D_L( usingZCoords, INDEX_NONE,
     & 'usingZCoords =', '  /* use z (or z*) vertical coordinate */')
      CALL WRITE_1D_RL( tRef, Nr, INDEX_K, 'tRef =',
     & '   /* Reference temperature profile ( oC or K ) */')
      CALL WRITE_1D_RL( sRef, Nr, INDEX_K, 'sRef =',
     & '   /* Reference salinity profile ( g/kg ) */')
      CALL WRITE_1D_RL( rhoRef, Nr, INDEX_K, 'rhoRef =',
     & '   /* Density vertical profile from (Ref,sRef)( kg/m^3 ) */')
      CALL WRITE_1D_RL( dBdrRef,  Nr,   INDEX_K, 'dBdrRef =',
     & ' /* Vertical grad. of reference buoyancy [(m/s/r)^2] */')
C-    Horizontal viscosity parameters:
#ifdef ALLOW_MOM_COMMON
      CALL WRITE_0D_L( useStrainTensionVisc, INDEX_NONE,
     & 'useStrainTensionVisc=',
     & ' /* Use StrainTension Form of Viscous Operator */')
      CALL WRITE_0D_L( useVariableVisc, INDEX_NONE,
     & 'useVariableVisc =', ' /* Use variable horizontal viscosity */')
      CALL WRITE_0D_L( useHarmonicVisc, INDEX_NONE,
     & 'useHarmonicVisc =', ' /* Use harmonic horizontal viscosity */')
      CALL WRITE_0D_L( useBiharmonicVisc, INDEX_NONE,
     & 'useBiharmonicVisc=', ' /* Use biharmonic horiz.  viscosity */')
      CALL WRITE_0D_L( useSmag3D, INDEX_NONE,
     & 'useSmag3D =', ' /* Use isotropic 3-D Smagorinsky viscosity */')
      IF ( useSmag3D )
     & CALL WRITE_0D_RL( smag3D_coeff, INDEX_NONE, 'smag3D_coeff =',
     & ' /* Smagorinsky 3-D coefficient (Cs^2) (-) */')
      IF ( smag3D_diffCoeff.GT.zeroRL )
     & CALL WRITE_0D_RL( smag3D_diffCoeff, INDEX_NONE,
     & 'smag3D_diffCoeff =',
     & ' /* Smagorinsky 3-D diffusion coefficient (-) */')
      CALL WRITE_0D_RL( viscAh, INDEX_NONE, 'viscAh  =  ',
     & ' /* Lateral harmonic viscosity ( m^2/s ) */')
      IF ( viscAhD.NE.viscAh )
     & CALL WRITE_0D_RL( viscAhD, INDEX_NONE, 'viscAhD =  ',
     & ' /* Lateral harmonic viscosity (Divergence)( m^2/s ) */')
      IF ( viscAhZ.NE.viscAh )
     & CALL WRITE_0D_RL( viscAhZ, INDEX_NONE, 'viscAhZ =  ',
     & ' /* Lateral harmonic viscosity (Vorticity) ( m^2/s ) */')
      IF ( nonHydrostatic )
     & CALL WRITE_0D_RL( viscAhW, INDEX_NONE, 'viscAhW =  ',
     & ' /* Lateral harmonic viscosity in W eq. ( m^2/s ) */')
      IF ( useVariableVisc ) THEN
       CALL WRITE_0D_RL( viscAhMax, INDEX_NONE, 'viscAhMax =',
     & ' /* Maximum lateral harmonic viscosity ( m^2/s ) */')
       CALL WRITE_0D_RL( viscAhGrid, INDEX_NONE, 'viscAhGrid =',
     & ' /* Grid dependent lateral harmonic viscosity ( non-dim. ) */')
       CALL WRITE_0D_L( useFullLeith, INDEX_NONE, 'useFullLeith =',
     & ' /* Use Full Form of Leith Viscosity on/off flag*/')
       CALL WRITE_0D_L( useAreaViscLength, INDEX_NONE,
     & 'useAreaViscLength =',
     & ' /* Use area for visc length instead of geom. mean*/')
       CALL WRITE_0D_RL( viscC2leith, INDEX_NONE, 'viscC2leith =',
     & ' /* Leith harmonic visc. factor (on grad(vort),non-dim.) */')
       CALL WRITE_0D_RL( viscC2leithD, INDEX_NONE, 'viscC2leithD =',
     & ' /* Leith harmonic viscosity factor (on grad(div),non-dim.)*/')
       CALL WRITE_0D_RL( viscC2LeithQG, INDEX_NONE, 'viscC2LeithQG =',
     & ' /* QG Leith harmonic viscosity factor (non-dim.)*/')
       CALL WRITE_0D_RL( viscC2smag, INDEX_NONE, 'viscC2smag =',
     & ' /* Smagorinsky harmonic viscosity factor (non-dim.) */')
      ENDIF
      CALL WRITE_0D_RL( viscA4, INDEX_NONE, 'viscA4  =  ',
     & ' /* Lateral biharmonic viscosity ( m^4/s ) */')
      IF ( viscA4D.NE.viscA4 )
     & CALL WRITE_0D_RL( viscA4D, INDEX_NONE, 'viscA4D =  ',
     & ' /* Lateral biharmonic viscosity (Divergence)( m^4/s ) */')
      IF ( viscA4Z.NE.viscA4 )
     & CALL WRITE_0D_RL( viscA4Z, INDEX_NONE, 'viscA4Z =  ',
     & ' /* Lateral biharmonic viscosity (Vorticity) ( m^4/s ) */')
      IF ( nonHydrostatic )
     & CALL WRITE_0D_RL( viscA4W, INDEX_NONE, 'viscA4W =  ',
     & ' /* Lateral biharmonic viscosity in W eq. ( m^2/s ) */')
      IF ( useVariableVisc ) THEN
       CALL WRITE_0D_RL( viscA4Max, INDEX_NONE, 'viscA4Max =',
     & ' /* Maximum biharmonic viscosity ( m^2/s ) */')
       CALL WRITE_0D_RL( viscA4Grid, INDEX_NONE, 'viscA4Grid =',
     & ' /* Grid dependent biharmonic viscosity ( non-dim. ) */')
       CALL WRITE_0D_RL( viscC4leith, INDEX_NONE,'viscC4leith =',
     & ' /* Leith biharm viscosity factor (on grad(vort), non-dim.)*/')
       CALL WRITE_0D_RL( viscC4leithD, INDEX_NONE,'viscC4leithD =',
     & ' /* Leith biharm viscosity factor (on grad(div), non-dim.) */')
       CALL WRITE_0D_RL( viscC4Smag, INDEX_NONE,'viscC4Smag =',
     & ' /* Smagorinsky biharm viscosity factor (non-dim) */')
      ENDIF
      CALL WRITE_0D_L( no_slip_sides, INDEX_NONE,
     & 'no_slip_sides =', '  /* Viscous BCs: No-slip sides */')
      CALL WRITE_0D_RL( sideDragFactor, INDEX_NONE, 'sideDragFactor =',
     & ' /* side-drag scaling factor (non-dim) */')
C-    Vertical viscosity parameters:
      CALL WRITE_1D_RL( viscArNr, Nr, INDEX_K, 'viscArNr =',
     &  ' /* vertical profile of vertical viscosity ('
     &  //rUnits//'^2/s )*/')
      CALL WRITE_0D_L( no_slip_bottom, INDEX_NONE,
     & 'no_slip_bottom =', '  /* Viscous BCs: No-slip bottom */')
      CALL WRITE_0D_L( bottomVisc_pCell, INDEX_NONE,
     & 'bottomVisc_pCell =', ' /* Partial-cell in bottom Visc. BC */')
      CALL WRITE_0D_RL( bottomDragLinear, INDEX_NONE,
     & 'bottomDragLinear =',
     & ' /* linear bottom-drag coefficient ( m/s ) */')
      CALL WRITE_0D_RL( bottomDragQuadratic, INDEX_NONE,
     & 'bottomDragQuadratic =',
     & ' /* quadratic bottom-drag coefficient (-) */')
# ifdef ALLOW_BOTTOMDRAG_ROUGHNESS
      CALL WRITE_0D_RL( zRoughBot, INDEX_NONE, 'zRoughBot =',
     & ' /* roughness length for bottom friction (m) */')
# endif
      CALL WRITE_0D_I( selectBotDragQuadr, INDEX_NONE,
     & 'selectBotDragQuadr =',
     & ' /* select quadratic bottom drag options */')
#endif /* ALLOW_MOM_COMMON */
      CALL WRITE_0D_RL( diffKhT, INDEX_NONE,'diffKhT =',
     &'   /* Laplacian diffusion of heat laterally ( m^2/s ) */')
      CALL WRITE_0D_RL( diffK4T, INDEX_NONE,'diffK4T =',
     &'   /* Biharmonic diffusion of heat laterally ( m^4/s ) */')
      CALL WRITE_0D_RL( diffKhS, INDEX_NONE,'diffKhS =',
     &'   /* Laplacian diffusion of salt laterally ( m^2/s ) */')
      CALL WRITE_0D_RL( diffK4S, INDEX_NONE,'diffK4S =',
     &'   /* Biharmonic diffusion of salt laterally ( m^4/s ) */')
      CALL WRITE_1D_RL( diffKrNrT, Nr, INDEX_K, 'diffKrNrT =',
     &  ' /* vertical profile of vertical diffusion of Temp ('
     &  //rUnits//'^2/s )*/')
      IF ( tempVertDiff4 )
     & CALL WRITE_1D_RL( diffKr4T, Nr, INDEX_K, 'diffKr4T =',
     &  ' /* profile of vertical biharmonic diffusion of Temp ('
     &  //rUnits//'^4/s )*/')
      CALL WRITE_1D_RL( diffKrNrS, Nr, INDEX_K, 'diffKrNrS =',
     &  ' /* vertical profile of vertical diffusion of Salt ('
     &  //rUnits//'^2/s )*/')
      IF ( saltVertDiff4 )
     & CALL WRITE_1D_RL( diffKr4S, Nr, INDEX_K, 'diffKr4S =',
     &  ' /* profile of vertical biharmonic diffusion of Salt ('
     &  //rUnits//'^4/s )*/')
      CALL WRITE_0D_RL( diffKrBL79surf, INDEX_NONE,'diffKrBL79surf =',
     &  ' /* Surface diffusion for Bryan and Lewis 79 ( m^2/s ) */')
      CALL WRITE_0D_RL( diffKrBL79deep, INDEX_NONE,'diffKrBL79deep =',
     &  ' /* Deep diffusion for Bryan and Lewis 1979 ( m^2/s ) */')
      CALL WRITE_0D_RL( diffKrBL79scl, INDEX_NONE,'diffKrBL79scl =',
     &  ' /* Depth scale for Bryan and Lewis 1979 ( m ) */')
      CALL WRITE_0D_RL( diffKrBL79Ho, INDEX_NONE,'diffKrBL79Ho =',
     &  ' /* Turning depth for Bryan and Lewis 1979 ( m ) */')
      CALL WRITE_0D_RL( ivdc_kappa, INDEX_NONE,'ivdc_kappa =',
     &  ' /* Implicit Vertical Diffusivity for Convection ('
     &  //rUnits//'^2/s) */')
      CALL WRITE_0D_RL( hMixCriteria, INDEX_NONE,'hMixCriteria=',
     & '  /* Criteria for mixed-layer diagnostic */')
      CALL WRITE_0D_RL( dRhoSmall, INDEX_NONE,'dRhoSmall =',
     & '  /* Parameter for mixed-layer diagnostic */')
      CALL WRITE_0D_RL( hMixSmooth, INDEX_NONE,'hMixSmooth=',
     & '  /* Smoothing parameter for mixed-layer diagnostic */')
C-----
      CALL WRITE_0D_C( eosType, 0, INDEX_NONE, 'eosType =',
     & '  /* Type of Equation of State */')
      IF ( eosType .EQ. 'LINEAR' ) THEN
        CALL WRITE_0D_RL( tAlpha,  INDEX_NONE,'tAlpha =',
     &  ' /* Linear EOS thermal expansion coefficient ( 1/oC ) */')
        CALL WRITE_0D_RL( sBeta,   INDEX_NONE,'sBeta  =',
     & ' /* Linear EOS haline contraction coefficient ( 1/(g/kg) ) */')
        CALL WRITE_0D_RL( rhoNil,  INDEX_NONE, 'rhoNil    =',
     &  ' /* Reference density for Linear EOS ( kg/m^3 ) */')
      ELSEIF ( eosType .EQ. 'POLY3 ' ) THEN
        WRITE(msgBuf,'(A)')
     &   'Polynomial EQS parameters ( from POLY3.COEFFS ):'
        CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
        DO k = 1, Nr
         WRITE(msgBuf,'(I3,13F8.3)')
     &   k,eosRefT(k),eosRefS(k),eosSig0(k), (eosC(i,k),i=1,9)
         CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
        ENDDO
        WRITE(msgBuf,'(A)') '    ;'
        CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      ELSEIF ( eosType .NE. 'IDEALG' ) THEN
        CALL WRITE_0D_RL( eosRefP0, INDEX_NONE, 'eosRefP0 =',
     &  ' /* Reference atmospheric pressure for EOS ( Pa ) */')
      ENDIF
      IF ( usingZCoords ) THEN
       WRITE(msgBuf,'(2A)') 'selectP_inEOS_Zc =',
     &      ' /* select pressure to use in EOS (0,1,2,3) */'
       CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
       buffI(1) = selectP_inEOS_Zc
       CALL PRINT_LIST_I( buffI, 1, 1, INDEX_NONE,
     &                   .FALSE., .TRUE., ioUnit )
       WRITE(msgBuf,'(2A)') '    0= -g*rhoConst*z ; ',
     &      '1= pRef (from tRef,sRef); 2= Hyd P ; 3= Hyd+NH P'
       CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
       CALL PRINT_MESSAGE(endList, ioUnit, SQUEEZE_RIGHT, myThid )
      ENDIF
C-----
      CALL WRITE_0D_RL( surf_pRef, INDEX_NONE, 'surf_pRef =',
     &  ' /* Surface reference pressure ( Pa ) */')
      IF ( fluidIsWater ) THEN
       CALL WRITE_0D_RL( HeatCapacity_Cp, INDEX_NONE,
     &   'HeatCapacity_Cp =',
     &   '  /* Specific heat capacity ( J/kg/K ) */')
      ENDIF
      CALL WRITE_0D_RL( celsius2K, INDEX_NONE, 'celsius2K =',
     &  ' /* 0 degree Celsius converted to Kelvin ( K ) */')
      IF ( fluidIsAir ) THEN
       CALL WRITE_0D_RL( atm_Rd, INDEX_NONE, 'atm_Rd =  ',
     & '  /* gas constant for dry air ( J/kg/K ) */')
       CALL WRITE_0D_RL( atm_Cp, INDEX_NONE, 'atm_Cp =  ',
     & '  /* specific heat (Cp) of dry air ( J/kg/K ) */')
       CALL WRITE_0D_RL( atm_kappa, INDEX_NONE, 'atm_kappa =',
     &  ' /* kappa (=Rd/Cp ) of dry air */')
       CALL WRITE_0D_RL( atm_Rq, INDEX_NONE, 'atm_Rq = ',
     &  ' /* water vap. specific vol. anomaly relative to dry air */')
       CALL WRITE_0D_RL( atm_Po, INDEX_NONE, 'atm_Po =  ',
     & '  /* standard reference pressure ( Pa ) */')
       CALL WRITE_0D_RL( thetaConst, INDEX_NONE, 'thetaConst=',
     &  ' /* constant reference for potential temperature ( K ) */')
       CALL WRITE_0D_I( integr_GeoPot, INDEX_NONE, 'integr_GeoPot =',
     & '  /* select how the geopotential is integrated */')
       CALL WRITE_0D_I( selectFindRoSurf, INDEX_NONE,
     & 'selectFindRoSurf=',
     & '  /* select how Surf.Ref. pressure is defined */')
      ENDIF
      CALL WRITE_0D_RL( rhoConst, INDEX_NONE,'rhoConst  =',
     &  ' /* Reference density (Boussinesq)  ( kg/m^3 ) */')
      CALL WRITE_1D_RL( rhoFacC, Nr,   INDEX_K, 'rhoFacC = ',
     &  ' /* normalized Reference density @ cell-Center (-) */')
      CALL WRITE_1D_RL( rhoFacF, Nr+1, INDEX_K, 'rhoFacF = ',
     &  ' /* normalized Reference density @ W-Interface (-) */')
      CALL WRITE_0D_RL( rhoConstFresh, INDEX_NONE,'rhoConstFresh =',
     &  ' /* Fresh-water reference density ( kg/m^3 ) */')
      CALL WRITE_0D_RL( gravity, INDEX_NONE,'gravity =',
     &'   /* Gravitational acceleration ( m/s^2 ) */')
      CALL WRITE_0D_RL( gBaro,   INDEX_NONE,'gBaro =',
     &'   /* Barotropic gravity ( m/s^2 ) */')
      CALL WRITE_1D_RL( gravFacC, Nr,   INDEX_K, 'gravFacC = ',
     &  ' /* gravity factor (vs surf.) @ cell-Center (-) */')
      CALL WRITE_1D_RL( gravFacF, Nr+1, INDEX_K, 'gravFacF = ',
     &  ' /* gravity factor (vs surf.) @ W-Interface (-) */')
      CALL WRITE_0D_RL(rotationPeriod,INDEX_NONE,'rotationPeriod =',
     &'   /* Rotation Period ( s ) */')
      CALL WRITE_0D_RL( omega,   INDEX_NONE,'omega =',
     &'   /* Angular velocity ( rad/s ) */')
      CALL WRITE_0D_RL( f0,      INDEX_NONE,'f0 =',
     &'   /* Reference coriolis parameter ( 1/s ) */')
      CALL WRITE_0D_RL( beta,    INDEX_NONE,'beta =',
     &'   /* Beta ( 1/(m.s) ) */')
      CALL WRITE_0D_RL( fPrime,  INDEX_NONE,'fPrime =',
     &'   /* Second coriolis parameter ( 1/s ) */')
      CALL WRITE_0D_L( rigidLid, INDEX_NONE, 'rigidLid =',
     &'   /* Rigid lid on/off flag */')
      CALL WRITE_0D_L( implicitFreeSurface, INDEX_NONE,
     &                 'implicitFreeSurface =',
     &'   /* Implicit free surface on/off flag */')
      CALL WRITE_0D_RL( freeSurfFac, INDEX_NONE,'freeSurfFac =',
     &'   /* Implicit free surface factor */')
      CALL WRITE_0D_RL( implicSurfPress, INDEX_NONE,
     & 'implicSurfPress =',
     & '  /* Surface Pressure implicit factor (0-1) */')
      CALL WRITE_0D_RL( implicDiv2DFlow, INDEX_NONE,
     & 'implicDiv2DFlow =',
     & '  /* Barot. Flow Div. implicit factor (0-1) */')
      CALL WRITE_0D_L( uniformLin_PhiSurf, INDEX_NONE,
     & 'uniformLin_PhiSurf =',
     & ' /* use uniform Bo_surf on/off flag */')
      CALL WRITE_0D_L( uniformFreeSurfLev, INDEX_NONE,
     & 'uniformFreeSurfLev =',
     & ' /* free-surface level-index is uniform */')
      CALL WRITE_0D_RL( sIceLoadFac, INDEX_NONE, 'sIceLoadFac =',
     & '  /* scale factor for sIceLoad (0-1) */')
      CALL WRITE_0D_RL( hFacMin, INDEX_NONE, 'hFacMin = ',
     & '  /* minimum partial cell factor (hFac) */')
      CALL WRITE_0D_RL( hFacMinDr, INDEX_NONE, 'hFacMinDr =',
     &  ' /* minimum partial cell thickness ('//rUnits//') */')
#ifdef EXACT_CONSERV
      WRITE(msgBuf,'(2A)') '** Warning ** CONFIG_SUMMARY: ',
     &  'should remove retired EXACT_CONSERV from CPP_OPTIONS.h'
      CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
#endif
      CALL WRITE_0D_L( exactConserv, INDEX_NONE,
     &  'exactConserv =',
     &  ' /* Update etaN from continuity Eq on/off flag */')
      CALL WRITE_0D_L( linFSConserveTr, INDEX_NONE,
     &  'linFSConserveTr =',
     &  ' /* Tracer correction for Lin Free Surface on/off flag */')
      WRITE(msgBuf,'(2A)') 'nonlinFreeSurf =',
     &  ' /* Non-linear Free Surf. options (-1,0,1,2,3)*/'
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      buffI(1) = nonlinFreeSurf
      CALL PRINT_LIST_I( buffI, 1, 1, INDEX_NONE,
     &                   .FALSE., .TRUE., ioUnit )
      WRITE(msgBuf,'(2A)') '     -1,0= Off ; 1,2,3= On,',
     &  ' 2=+rescale gU,gV, 3=+update cg2d solv.'
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      CALL PRINT_MESSAGE(endList, ioUnit, SQUEEZE_RIGHT, myThid )
      CALL WRITE_0D_RL( hFacInf, INDEX_NONE, 'hFacInf = ',
     & '  /* lower threshold for hFac (nonlinFreeSurf only)*/')
      CALL WRITE_0D_RL( hFacSup, INDEX_NONE, 'hFacSup = ',
     & '  /* upper threshold for hFac (nonlinFreeSurf only)*/')
      CALL WRITE_0D_I( select_rStar, INDEX_NONE,
     & 'select_rStar =',
     &  ' /* r* Vertical coord. options (=0 r coord.; >0 uses r*)*/')
      CALL WRITE_0D_L( useRealFreshWaterFlux, INDEX_NONE,
     & 'useRealFreshWaterFlux =',
     &  ' /* Real Fresh Water Flux on/off flag*/')
      CALL WRITE_0D_RL( temp_EvPrRn, INDEX_NONE,
     & 'temp_EvPrRn =',
     &  ' /* Temp. of Evap/Prec/R (UNSET=use local T)(oC)*/')
      CALL WRITE_0D_RL( salt_EvPrRn, INDEX_NONE,
     &  'salt_EvPrRn =',
     &  ' /* Salin. of Evap/Prec/R (UNSET=use local S)(g/kg)*/')
      CALL WRITE_0D_I( selectAddFluid, INDEX_NONE,
     & 'selectAddFluid =',
     &  ' /* option for mass source/sink of fluid (=0: off) */')
      CALL WRITE_0D_RL( temp_addMass, INDEX_NONE,
     & 'temp_addMass =',
     &  ' /* Temp. of addMass array (UNSET=use local T)(oC)*/')
      CALL WRITE_0D_RL( salt_addMass, INDEX_NONE,
     & 'salt_addMass =',
     &  ' /* Salin. of addMass array (UNSET=use local S)(g/kg)*/')
      IF ( .NOT.useRealFreshWaterFlux .OR. selectAddFluid.EQ.-1
     &                                .OR. nonlinFreeSurf.LE.0 ) THEN
      CALL WRITE_0D_RL( convertFW2Salt, INDEX_NONE,
     & 'convertFW2Salt =',
     & ' /* convert F.W. Flux to Salt Flux (-1=use local S)(g/kg)*/')
      ENDIF

      CALL WRITE_0D_L( use3Dsolver, INDEX_NONE,
     & 'use3Dsolver =', ' /* use 3-D pressure solver on/off flag */')
      CALL WRITE_0D_L( nonHydrostatic, INDEX_NONE,
     & 'nonHydrostatic =', '  /* Non-Hydrostatic on/off flag */')
      CALL WRITE_0D_RL( nh_Am2, INDEX_NONE, 'nh_Am2 =',
     & ' /* Non-Hydrostatic terms scaling factor */')
      CALL WRITE_0D_RL( implicitNHPress, INDEX_NONE,
     & 'implicitNHPress =',
     & ' /* Non-Hyd Pressure implicit factor (0-1)*/')
      CALL WRITE_0D_I( selectNHfreeSurf, INDEX_NONE,
     & 'selectNHfreeSurf =',
     & ' /* Non-Hyd (free-)Surface option */')
      CALL WRITE_0D_L( quasiHydrostatic, INDEX_NONE,
     & 'quasiHydrostatic =', ' /* Quasi-Hydrostatic on/off flag */')
      CALL WRITE_0D_L( calc_wVelocity, INDEX_NONE, 'calc_wVelocity =',
     &             ' /* vertical velocity calculation on/off flag */')
      CALL WRITE_0D_L( momStepping,  INDEX_NONE,
     & 'momStepping =', '  /* Momentum equation on/off flag */')
      CALL WRITE_0D_L( vectorInvariantMomentum,  INDEX_NONE,
     & 'vectorInvariantMomentum=',
     & ' /* Vector-Invariant Momentum on/off */')
      CALL WRITE_0D_L( momAdvection, INDEX_NONE,
     & 'momAdvection =', '  /* Momentum advection on/off flag */')
      CALL WRITE_0D_L( momViscosity, INDEX_NONE,
     & 'momViscosity =', '  /* Momentum viscosity on/off flag */')
      CALL WRITE_0D_L( momImplVertAdv, INDEX_NONE, 'momImplVertAdv=',
     &                ' /* Momentum implicit vert. advection on/off*/')
      CALL WRITE_0D_L( implicitViscosity, INDEX_NONE,
     & 'implicitViscosity =', ' /* Implicit viscosity on/off flag */')
      WRITE(msgBuf,'(2A)')
     & 'selectImplicitDrag=', ' /* Implicit bot Drag options (0,1,2)*/'
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      buffI(1) = selectImplicitDrag
      CALL PRINT_LIST_I( buffI, 1, 1, INDEX_NONE,
     &                   .FALSE., .TRUE., ioUnit )
      WRITE(msgBuf,'(2A)') '    0= Expl. ; 1= Impl. on provis. Vel ;',
     &  ' 2= Fully Impl (with surf.P)'
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      CALL PRINT_MESSAGE(endList, ioUnit, SQUEEZE_RIGHT, myThid )
C---  report Metric-Term selection
      IF ( .NOT.vectorInvariantMomentum ) THEN
       WRITE(msgBuf,'(2A)') 'selectMetricTerms=',
     &              ' /* Scheme selector for Horizontal Metric Terms */'
       CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
       buffI(1) = selectMetricTerms
       CALL PRINT_LIST_I( buffI, 1, 1, INDEX_NONE,
     &                    .FALSE., .TRUE., ioUnit )
       WRITE(msgBuf,'(2A)') '   = 0 : Off (ignore ',
     &                      'Spherical/Cylindrical Metric Terms)'
       CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
       WRITE(msgBuf,'(2A)') '   = 1 : original discretization'
       CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
       WRITE(msgBuf,'(2A)') '   = 2 : using (Spherical) grid-spacing'
       CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
       WRITE(msgBuf,'(2A)') '   = 3 : as 2 but gU-Metric',
     &                      ' inside Advection'
       CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
       CALL PRINT_MESSAGE(endList, ioUnit, SQUEEZE_RIGHT, myThid )
      ENDIF
      CALL WRITE_0D_L( useNHMTerms,  INDEX_NONE, 'useNHMTerms =',
     &              ' /* Non-Hydrostatic Metric-Terms on/off */')
C---  report Coriolis selection
      CALL WRITE_0D_L( useCoriolis,  INDEX_NONE,
     & 'useCoriolis =', '  /* Coriolis on/off flag */')
      CALL WRITE_0D_L( useCDscheme,  INDEX_NONE,
     & 'useCDscheme =', '  /* CD scheme on/off flag */')
      WRITE(msgBuf,'(2A)')
     & 'selectCoriMap =', ' /* Coriolis Map options (0,1,2,3)*/'
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      buffI(1) = selectCoriMap
      CALL PRINT_LIST_I( buffI, 1, 1, INDEX_NONE,
     &                   .FALSE., .TRUE., ioUnit )
      WRITE(msgBuf,'(2A)') '    0= f-Plane ; 1= Beta-Plane ;',
     &  ' 2= Spherical ; 3= read from file'
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      CALL PRINT_MESSAGE(endList, ioUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(2A)') 'select3dCoriScheme=',
     &              ' /* Scheme selector for 3-D Coriolis-Term */'
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      buffI(1) = select3dCoriScheme
      CALL PRINT_LIST_I( buffI, 1, 1, INDEX_NONE,
     &                   .FALSE., .TRUE., ioUnit )
      WRITE(msgBuf,'(2A)')  '   = 0 : Off (ignore 3-D Coriolis',
     &                      ' Terms in Omega.Cos(Lat) )'
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(2A)')  '   = 1 : original discretization',
     &                      ' ; = 2 : using averaged Transport'
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(2A)')  '   = 3 : same as 2 with hFac in gW_Cor'
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      CALL PRINT_MESSAGE(endList, ioUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(2A)') 'selectCoriScheme=',
     &              ' /* Scheme selector for Coriolis-Term */'
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      buffI(1) = selectCoriScheme
      CALL PRINT_LIST_I( buffI, 1, 1, INDEX_NONE,
     &                   .FALSE., .TRUE., ioUnit )
      WRITE(msgBuf,'(2A)')  '   = 0 : original discretization',
     &                      ' (simple averaging, no hFac)'
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(2A)')  '   = 1 : Wet-point averaging',
     &                      ' (Jamar & Ozer 1986)'
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      IF ( vectorInvariantMomentum ) THEN
       WRITE(msgBuf,'(2A)') '   = 2 : hFac weighted average',
     &                      ' (Angular Mom. conserving)'
       CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
       WRITE(msgBuf,'(2A)') '   = 3 : energy conserving scheme',
     &                      ' using hFac weighted average'
       CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      ELSE
       WRITE(msgBuf,'(2A)') '   = 2 : energy conserving scheme',
     &                      ' (no hFac weight)'
       CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
       WRITE(msgBuf,'(2A)') '   = 3 : energy conserving scheme',
     &                      ' using Wet-point averaging'
       CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
       WRITE(msgBuf,'(2A)') '   = 4 : hFac weighted average',
     &                      ' (Angular Mom. conserving)'
       CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      ENDIF
      CALL PRINT_MESSAGE( endList, ioUnit, SQUEEZE_RIGHT, myThid )
      IF ( vectorInvariantMomentum ) THEN
C---  report here some vector-invariant parameters
       CALL WRITE_0D_L( useAbsVorticity,  INDEX_NONE,
     & 'useAbsVorticity=',' /* V.I Works with f+zeta in Coriolis */')
       WRITE(msgBuf,'(2A)') 'selectVortScheme=',
     &              ' /* V.I Scheme selector for Vorticity-Term */'
       CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
       buffI(1) = selectVortScheme
       CALL PRINT_LIST_I( buffI, 1, 1, INDEX_NONE,
     &                    .FALSE., .TRUE., ioUnit )
       WRITE(msgBuf,'(2A)') '   = 0 : enstrophy (Shallow-Water Eq.)',
     &                  ' conserving scheme by Sadourny, JAS 75'
       CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
       WRITE(msgBuf,'(2A)') '   = 1 : same as 0 with modified hFac'
       CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
       WRITE(msgBuf,'(2A)') '   = 2 : energy conserving scheme',
     &         ' (used by Sadourny in JAS 75 paper)'
       CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
       WRITE(msgBuf,'(2A)') '   = 3 : energy (general)',
     &             ' and enstrophy (2D, nonDiv.) conserving scheme'
       CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
       WRITE(msgBuf,'(2A)') '         from Sadourny',
     &                     ' (Burridge & Haseler, ECMWF Rep.4, 1977)'
       CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
       WRITE(msgBuf,'(2A)') '   = 4 : shift 1/hFac from Vorticity',
     &                      ' to gU,gV tend. (Ang.Mom. conserving)'
       CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
       CALL PRINT_MESSAGE(endList, ioUnit, SQUEEZE_RIGHT, myThid )
       CALL WRITE_0D_L( useJamartMomAdv,  INDEX_NONE,
     & 'useJamartMomAdv=',' /* V.I Non-linear terms Jamart flag */')
       CALL WRITE_0D_L( upwindVorticity,  INDEX_NONE,
     & 'upwindVorticity=',' /* V.I Upwind bias vorticity flag */')
       CALL WRITE_0D_L( highOrderVorticity,  INDEX_NONE,
     & 'highOrderVorticity=',' /* V.I High order vort. advect. flag */')
       CALL WRITE_0D_L( upwindShear,  INDEX_NONE,
     & 'upwindShear=',' /* V.I Upwind vertical Shear advection flag */')
       CALL WRITE_0D_I( selectKEscheme, INDEX_NONE,
     & 'selectKEscheme=',' /* V.I Kinetic Energy scheme selector */')
C---  report of some vector-invariant parameters ends here
      ENDIF
      CALL WRITE_0D_L( momForcing,   INDEX_NONE,
     & 'momForcing =', '  /* Momentum forcing on/off flag */')
      IF ( momForcing )
     & CALL WRITE_0D_L( momTidalForcing, INDEX_NONE,
     & 'momTidalForcing =',' /* Momentum Tidal forcing on/off flag */')
      CALL WRITE_0D_L( momPressureForcing, INDEX_NONE,
     & 'momPressureForcing =',
     & '  /* Momentum pressure term on/off flag */')
      CALL WRITE_0D_L( implicitIntGravWave, INDEX_NONE,
     &  'implicitIntGravWave=',
     &  ' /* Implicit Internal Gravity Wave flag */')
      CALL WRITE_0D_L( staggerTimeStep, INDEX_NONE,
     & 'staggerTimeStep = ',
     & '   /* Stagger time stepping on/off flag */')
      CALL WRITE_0D_L( doResetHFactors, INDEX_NONE,
     & 'doResetHFactors =',
     & ' /* reset thickness factors @ each time-step */')
      CALL WRITE_0D_L( multiDimAdvection, INDEX_NONE,
     & 'multiDimAdvection =',
     & '  /* enable/disable Multi-Dim Advection */')
      CALL WRITE_0D_L( useMultiDimAdvec, INDEX_NONE,
     & 'useMultiDimAdvec =',
     &'   /* Multi-Dim Advection is/is-not used */')
      CALL WRITE_0D_L( implicitDiffusion, INDEX_NONE,
     & 'implicitDiffusion =',' /* Implicit Diffusion on/off flag */')
      CALL WRITE_0D_L( tempStepping,  INDEX_NONE,
     & 'tempStepping =', '  /* Temperature equation on/off flag */')
      CALL WRITE_0D_L( tempAdvection,  INDEX_NONE,
     & 'tempAdvection =', ' /* Temperature advection on/off flag */')
      CALL WRITE_0D_L( tempImplVertAdv,INDEX_NONE,'tempImplVertAdv =',
     &                ' /* Temp. implicit vert. advection on/off */')
      CALL WRITE_0D_L( tempForcing,  INDEX_NONE,
     & 'tempForcing  =', '  /* Temperature forcing on/off flag */')
#ifdef ALLOW_FRICTION_HEATING
      CALL WRITE_0D_L( addFrictionHeating, INDEX_NONE,
     & 'addFrictionHeating=',' /* account for frictional heating */')
#endif
      CALL WRITE_0D_I( selectPenetratingSW, INDEX_NONE,
     &                'selectPenetratingSW =',
     &                ' /* short wave penetration selector */' )
#ifdef ALLOW_BALANCE_FLUXES
      CALL WRITE_0D_L( balanceQnet, INDEX_NONE, 'balanceQnet  =',
     &             '  /* balance net heat-flux on/off flag */')
#endif
      CALL WRITE_0D_L( doThetaClimRelax, INDEX_NONE,
     & 'doThetaClimRelax =', ' /* apply SST relaxation on/off flag */')
#ifdef ALLOW_BALANCE_RELAX
      CALL WRITE_0D_L( balanceThetaClimRelax, INDEX_NONE,
     &             'balanceThetaClimRelax=',
     &             ' /* balance SST relaxation on/off flag */')
#endif
      CALL WRITE_0D_L( tempIsActiveTr, INDEX_NONE, 'tempIsActiveTr =',
     & ' /* Temp. is a dynamically Active Tracer */')
      CALL WRITE_0D_L( saltStepping,  INDEX_NONE,
     & 'saltStepping =', '  /* Salinity equation on/off flag */')
      CALL WRITE_0D_L( saltAdvection,  INDEX_NONE,
     & 'saltAdvection =', ' /* Salinity advection on/off flag */')
      CALL WRITE_0D_L( saltImplVertAdv,INDEX_NONE,'saltImplVertAdv =',
     &                ' /* Sali. implicit vert. advection on/off */')
      CALL WRITE_0D_L( saltForcing,  INDEX_NONE,
     & 'saltForcing  =', '  /* Salinity forcing on/off flag */')
#ifdef ALLOW_BALANCE_FLUXES
      CALL WRITE_0D_I( selectBalanceEmPmR, INDEX_NONE,
     &                'selectBalanceEmPmR =',
     &                ' /* balancing glob.mean EmPmR selector */' )
#endif
      CALL WRITE_0D_L( doSaltClimRelax, INDEX_NONE,
     & 'doSaltClimRelax =', ' /* apply SSS relaxation on/off flag */')
#ifdef ALLOW_BALANCE_RELAX
      CALL WRITE_0D_L( balanceSaltClimRelax, INDEX_NONE,
     &             'balanceSaltClimRelax=',
     &             ' /* balance SSS relaxation on/off flag */')
#endif
      CALL WRITE_0D_L( saltIsActiveTr, INDEX_NONE, 'saltIsActiveTr =',
     & ' /* Salt  is a dynamically Active Tracer */')
      CALL WRITE_0D_I( readBinaryPrec, INDEX_NONE, ' readBinaryPrec =',
     &  ' /* Precision used for reading binary files */')
      CALL WRITE_0D_I(writeBinaryPrec, INDEX_NONE, 'writeBinaryPrec =',
     &  ' /* Precision used for writing binary files */')
#ifdef ALLOW_BALANCE_FLUXES
      CALL WRITE_0D_L( balancePrintMean, INDEX_NONE,
     &                'balancePrintMean =',
     &                ' /* print means for balancing fluxes */')
#endif
C---
c     CALL WRITE_0D_I(rwSuffixType, INDEX_NONE, 'rwSuffixType =',
c    &  ' /* Select format of mds file suffix */')
      WRITE(msgBuf,'(2A)') ' rwSuffixType =  ',
     &             ' /* select format of mds file suffix */'
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      buffI(1) = rwSuffixType
      CALL PRINT_LIST_I( buffI, 1, 1, INDEX_NONE,
     &                   .FALSE., .TRUE., ioUnit )
      WRITE(msgBuf,'(2A)') '   = 0 : myIter (I10.10) ;',
     &                     '   = 1 : 100*myTime (100th sec) ;'
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(2A)') '   = 2 : myTime (seconds);',
     &                     '   = 3 : myTime/360 (10th of hr);'
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(2A)') '   = 4 : myTime/3600 (hours)'
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      CALL PRINT_MESSAGE(endList, ioUnit, SQUEEZE_RIGHT, myThid )
C---
      CALL WRITE_0D_L( globalFiles,  INDEX_NONE,
     & ' globalFiles =',' /* write "global" (=not per tile) files */')
      CALL WRITE_0D_L( useSingleCpuIO,  INDEX_NONE,
     & ' useSingleCpuIO =', ' /* only master MPI process does I/O */')
      CALL WRITE_0D_L( useSingleCpuInput,  INDEX_NONE,
     & ' useSingleCpuInput =', ' /* only master process reads input */')
      WRITE(msgBuf,'(2A)') '/* debLev[*]  :',
     &             ' level of debug & auxiliary message printing */'
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A,I3,A)') 'debLevZero =', debLevZero,
     &             ' ; /* level of disabled aux. msg printing */'
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A,I3,A)') '   debLevA =', debLevA,
     &             ' ; /* level of minimum  aux. msg printing */'
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A,I3,A)') '   debLevB =', debLevB,
     &   ' ; /* level of low aux. print (report read-file opening)*/'
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A,I3,A)') '   debLevC =', debLevC,
     &   ' ; /* level of moderate debug prt (most pkgs debug msg) */'
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A,I3,A)') '   debLevD =', debLevD,
     &   ' ; /* level of enhanced debug prt (add DEBUG_STATS prt) */'
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A,I3,A)') '   debLevE =', debLevE,
     &             ' ; /* level of extensive debug printing */'
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      CALL WRITE_0D_I( debugLevel, INDEX_NONE,
     &   'debugLevel =', '  /* select debug printing level */')
      CALL WRITE_0D_I( plotLevel, INDEX_NONE,
     &   ' plotLevel =', '  /* select PLOT_FIELD printing level */')

      WRITE(msgBuf,'(A)') '//  '
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)')
     & '// Elliptic solver(s) paramters ( PARM02 in namelist ) '
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)') '//  '
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      CALL WRITE_0D_I( cg2dMaxIters,   INDEX_NONE,'cg2dMaxIters =',
     &'   /* Upper limit on 2d con. grad iterations  */')
      CALL WRITE_0D_I( cg2dMinItersNSA, INDEX_NONE,'cg2dMinItersNSA =',
     &'   /* Minimum number of iterations of 2d con. grad solver  */')
      CALL WRITE_0D_I( cg2dUseMinResSol, INDEX_NONE,
     &  'cg2dUseMinResSol=',
     &  ' /* use cg2d last-iter(=0) / min-resid.(=1) solution */')
      CALL WRITE_0D_RL( cg2dTargetResidual, INDEX_NONE,
     & 'cg2dTargetResidual =',
     &'   /* 2d con. grad target residual  */')
      CALL WRITE_0D_RL( cg2dTargetResWunit, INDEX_NONE,
     & 'cg2dTargetResWunit =',
     &'   /* CG2d target residual [W units] */')
      CALL WRITE_0D_I( cg2dPreCondFreq, INDEX_NONE,'cg2dPreCondFreq =',
     &'   /* Freq. for updating cg2d preconditioner */')
      CALL WRITE_0D_L( useSRCGSolver, INDEX_NONE,
     & 'useSRCGSolver =', '  /* use single reduction CG solver(s) */')
      CALL WRITE_0D_L( useNSACGSolver, INDEX_NONE,
     & 'useNSACGSolver =', '  /* use not-self-adjoint CG solver */')
      CALL WRITE_0D_I( printResidualFreq, INDEX_NONE,
     & 'printResidualFreq =', ' /* Freq. for printing CG residual */')
      IF ( use3Dsolver ) THEN
       CALL WRITE_0D_I( cg3dMaxIters, INDEX_NONE, 'cg3dMaxIters =',
     & '   /* Upper limit on CG3d iterations  */')
       CALL WRITE_0D_RL( cg3dTargetResidual, INDEX_NONE,
     & 'cg3dTargetResidual =',
     & '   /* CG3d target residual [normalise RHS] */')
       CALL WRITE_0D_RL( cg3dTargetResWunit, INDEX_NONE,
     & 'cg3dTargetResWunit =',
     & '   /* CG3d target residual [W units] */')
      ENDIF

      WRITE(msgBuf,'(A)') '//  '
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)')
     & '// Time stepping paramters ( PARM03 in namelist ) '
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)') '//  '
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      CALL WRITE_0D_RL( deltaTMom, INDEX_NONE,'deltaTMom =',
     &'   /* Momentum equation timestep ( s ) */')
      CALL WRITE_0D_RL( deltaTFreeSurf,INDEX_NONE,'deltaTFreeSurf =',
     &  ' /* FreeSurface equation timestep ( s ) */')
      CALL WRITE_1D_RL( dTtracerLev, Nr, INDEX_K, 'dTtracerLev =',
     & '  /* Tracer equation timestep ( s ) */')
      CALL WRITE_0D_RL( deltaTClock, INDEX_NONE,'deltaTClock  =',
     &'   /* Model clock timestep ( s ) */')
      CALL WRITE_0D_RL( cAdjFreq, INDEX_NONE,'cAdjFreq =',
     &'   /* Convective adjustment interval ( s ) */')
      CALL WRITE_0D_I( momForcingOutAB, INDEX_NONE, 'momForcingOutAB =',
     & ' /* =1: take Momentum Forcing out of Adams-Bash. stepping */')
      CALL WRITE_0D_I( tracForcingOutAB, INDEX_NONE,
     & 'tracForcingOutAB =',
     & ' /* =1: take T,S,pTr Forcing out of Adams-Bash. stepping */')
      CALL WRITE_0D_L( momDissip_In_AB,INDEX_NONE,'momDissip_In_AB =',
     & ' /* put Dissipation Tendency in Adams-Bash. stepping */')
      CALL WRITE_0D_L( doAB_onGtGs, INDEX_NONE, 'doAB_onGtGs =',
     &  ' /* apply AB on Tendencies (rather than on T,S)*/')
      CALL WRITE_0D_RL( abEps, INDEX_NONE,'abEps =',
     &'   /* Adams-Bashforth-2 stabilizing weight */')
#ifdef ALLOW_ADAMSBASHFORTH_3
      CALL WRITE_0D_RL( alph_AB, INDEX_NONE,'alph_AB =',
     &'   /* Adams-Bashforth-3 primary factor */')
      CALL WRITE_0D_RL( beta_AB, INDEX_NONE,'beta_AB =',
     &'   /* Adams-Bashforth-3 secondary factor */')
      CALL WRITE_0D_L( startFromPickupAB2, INDEX_NONE,
     & 'startFromPickupAB2=',' /* start from AB-2 pickup */')
#endif
      CALL WRITE_0D_L( applyExchUV_early, INDEX_NONE,
     & 'applyExchUV_early =',
     & ' /* Apply EXCH to U,V earlier in time-step */')
      IF (useCDscheme) THEN
      CALL WRITE_0D_RL( tauCD, INDEX_NONE,'tauCD =',
     &'   /* CD coupling time-scale ( s ) */')
      CALL WRITE_0D_RL( rCD, INDEX_NONE,'rCD =',
     &'   /* Normalised CD coupling parameter */')
      CALL WRITE_0D_RL( epsAB_CD, INDEX_NONE,'epsAB_CD =',
     &  ' /* AB-2 stabilizing weight for CD-scheme*/')
      ENDIF
      i = ILNBLNK(pickupSuff)
      IF ( i.GT.0 ) THEN
        CALL WRITE_0D_C( pickupSuff, 0, INDEX_NONE,
     & 'pickupSuff =', ' /* Suffix of pickup-file to restart from */')
      ENDIF
      CALL WRITE_0D_L( pickupStrictlyMatch, INDEX_NONE,
     & 'pickupStrictlyMatch=',
     & ' /* stop if pickup do not strictly match */')
      CALL WRITE_0D_I( nIter0, INDEX_NONE, 'nIter0   =',
     &'   /* Run starting timestep number */')
      CALL WRITE_0D_I( nTimeSteps, INDEX_NONE,'nTimeSteps =',
     &  ' /* Number of timesteps */')
      CALL WRITE_0D_I( nEndIter, INDEX_NONE, 'nEndIter =',
     &'   /* Run ending timestep number */')
      CALL WRITE_0D_RL( baseTime, INDEX_NONE,'baseTime =',
     &'   /* Model base time ( s ) */')
      CALL WRITE_0D_RL( startTime, INDEX_NONE,'startTime =',
     & '  /* Run start time ( s ) */')
      CALL WRITE_0D_RL( endTime, INDEX_NONE,'endTime  =',
     &'   /* Integration ending time ( s ) */')
      CALL WRITE_0D_RL( pChkPtFreq, INDEX_NONE,'pChkPtFreq =',
     &  ' /* Permanent restart/pickup file interval ( s ) */')
      CALL WRITE_0D_RL( chkPtFreq, INDEX_NONE,'chkPtFreq  =',
     &  ' /* Rolling restart/pickup file interval ( s ) */')
      CALL WRITE_0D_L(pickup_write_mdsio,INDEX_NONE,
     &     'pickup_write_mdsio =', '   /* Model IO flag. */')
      CALL WRITE_0D_L(pickup_read_mdsio,INDEX_NONE,
     &     'pickup_read_mdsio =', '   /* Model IO flag. */')
#ifdef ALLOW_MNC
      CALL WRITE_0D_L(pickup_write_mnc,INDEX_NONE,
     &     'pickup_write_mnc =', '   /* Model IO flag. */')
      CALL WRITE_0D_L(pickup_read_mnc,INDEX_NONE,
     &     'pickup_read_mnc =', '   /* Model IO flag. */')
#endif
c     CALL WRITE_0D_L(pickup_write_immed,INDEX_NONE,
c    &     'pickup_write_immed =','   /* Model IO flag. */')
      CALL WRITE_0D_L(writePickupAtEnd,INDEX_NONE,
     &     'writePickupAtEnd =','   /* Model IO flag. */')
      CALL WRITE_0D_RL( dumpFreq, INDEX_NONE,'dumpFreq =',
     &'   /* Model state write out interval ( s ). */')
      CALL WRITE_0D_L(dumpInitAndLast,INDEX_NONE,'dumpInitAndLast=',
     &  ' /* write out Initial & Last iter. model state */')
      CALL WRITE_0D_L(snapshot_mdsio,INDEX_NONE,
     &     'snapshot_mdsio =', '   /* Model IO flag. */')
#ifdef ALLOW_MNC
      CALL WRITE_0D_L(snapshot_mnc,INDEX_NONE,
     &     'snapshot_mnc =', '   /* Model IO flag. */')
#endif
      CALL WRITE_0D_RL( monitorFreq, INDEX_NONE,'monitorFreq =',
     &'   /* Monitor output interval ( s ). */')
      CALL WRITE_0D_I( monitorSelect, INDEX_NONE, 'monitorSelect =',
     & ' /* select group of variables to monitor */')
      CALL WRITE_0D_L(monitor_stdio,INDEX_NONE,
     &     'monitor_stdio =', '   /* Model IO flag. */')
#ifdef ALLOW_MNC
      CALL WRITE_0D_L(monitor_mnc,INDEX_NONE,
     &     'monitor_mnc =', '   /* Model IO flag. */')
#endif
      CALL WRITE_0D_RL( externForcingPeriod, INDEX_NONE,
     &   'externForcingPeriod =', '   /* forcing period (s) */')
      CALL WRITE_0D_RL( externForcingCycle, INDEX_NONE,
     &   'externForcingCycle =', '   /* period of the cyle (s). */')
      CALL WRITE_0D_RL( tauThetaClimRelax, INDEX_NONE,
     &   'tauThetaClimRelax =', '   /* relaxation time scale (s) */')
      CALL WRITE_0D_RL( tauSaltClimRelax, INDEX_NONE,
     &   'tauSaltClimRelax =',  '   /* relaxation time scale (s) */')
      CALL WRITE_0D_RL( latBandClimRelax, INDEX_NONE,
     &   'latBandClimRelax =', '   /* max. Lat. where relaxation */')

      WRITE(msgBuf,'(A)') '//  '
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)')
     & '// Gridding paramters ( PARM04 in namelist ) '
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)') '//  '
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      CALL WRITE_0D_L( usingCartesianGrid, INDEX_NONE,
     & 'usingCartesianGrid =',
     & ' /* Cartesian coordinates flag ( True/False ) */')
      CALL WRITE_0D_L( usingCylindricalGrid, INDEX_NONE,
     & 'usingCylindricalGrid =',
     & ' /* Cylindrical coordinates flag ( True/False ) */')
      CALL WRITE_0D_L( usingSphericalPolarGrid, INDEX_NONE,
     & 'usingSphericalPolarGrid =',
     & ' /* Spherical coordinates flag ( True/False ) */')
      CALL WRITE_0D_L( usingCurvilinearGrid, INDEX_NONE,
     & 'usingCurvilinearGrid =',
     & ' /* Curvilinear coordinates flag ( True/False ) */')
      CALL WRITE_0D_L( useMin4hFacEdges, INDEX_NONE,
     & 'useMin4hFacEdges =',
     & ' /* set hFacW,S as minimum of adjacent hFacC factor */')
      CALL WRITE_0D_L( interViscAr_pCell, INDEX_NONE,
     & 'interViscAr_pCell =',
     & ' /* account for partial-cell in interior vert. viscosity */')
      CALL WRITE_0D_L( interDiffKr_pCell, INDEX_NONE,
     & 'interDiffKr_pCell =',
     & ' /* account for partial-cell in interior vert. diffusion */')
      CALL WRITE_0D_I( pCellMix_select, INDEX_NONE,
     & 'pCellMix_select =',
     & ' /* option to enhance mixing near surface & bottom */')
      IF ( pCellMix_select.NE.0 ) THEN
       CALL WRITE_0D_RL( pCellMix_maxFac, INDEX_NONE,
     &  'pCellMix_maxFac =', ' /* maximum enhanced mixing factor */')
       CALL WRITE_0D_RL( pCellMix_delR, INDEX_NONE, 'pCellMix_delR =',
     &  ' /* thickness criteria for too thin partial-cell ( '
     &  //rUnits//' ) */')
       CALL WRITE_1D_RL( pCellMix_viscAr, Nr, INDEX_K,
     &  'pCellMix_viscAr = ',
     &  ' /* vertical viscosity   for too thin partial-cell */')
       CALL WRITE_1D_RL( pCellMix_diffKr, Nr, INDEX_K,
     &  'pCellMix_diffKr = ',
     &  ' /* vertical diffusivity for too thin partial-cell */')
      ENDIF
      CALL WRITE_0D_I( selectSigmaCoord, INDEX_NONE,
     & 'selectSigmaCoord =',
     & ' /* Hybrid-Sigma Vert. Coordinate option */')
      CALL WRITE_0D_RL( rSigmaBnd, INDEX_NONE, 'rSigmaBnd =',
     &  ' /* r/sigma transition ( units of r == '//rUnits//' ) */')
      CALL WRITE_0D_RL( rkSign, INDEX_NONE,'rkSign =',
     &'   /* index orientation relative to vertical coordinate */')
      CALL WRITE_0D_RL( gravitySign, INDEX_NONE,'gravitySign =',
     &  ' /* gravity orientation relative to vertical coordinate */')
      CALL WRITE_0D_RL( seaLev_Z, INDEX_NONE, 'seaLev_Z =',
     & '  /* reference height of sea-level [m] */')
      IF ( usingZCoords ) THEN
       CALL WRITE_0D_RL( top_Pres, INDEX_NONE, 'top_Pres =',
     & '  /* reference pressure at the top [Pa] */')
       CALL WRITE_0D_RL( mass2rUnit, INDEX_NONE,'mass2rUnit =',
     &  ' /* convert mass per unit area [kg/m2] to r-units [m] */')
       CALL WRITE_0D_RL( rUnit2mass, INDEX_NONE,'rUnit2mass =',
     &  ' /* convert r-units [m] to mass per unit area [kg/m2] */')
      ENDIF
      IF ( usingPCoords ) THEN
       CALL WRITE_0D_RL( top_Pres, INDEX_NONE, 'top_Pres =',
     & '  /* pressure at the top (r-axis origin) [Pa] */')
       CALL WRITE_0D_RL( mass2rUnit, INDEX_NONE,'mass2rUnit =',
     &  ' /* convert mass per unit area [kg/m2] to r-units [Pa] */')
       CALL WRITE_0D_RL( rUnit2mass, INDEX_NONE,'rUnit2mass =',
     &  ' /* convert r-units [Pa] to mass per unit area [kg/m2] */')
      ENDIF
      CALL WRITE_COPY1D_RS( bufRL, drC,Nr+1,INDEX_K, 'drC = ',
     &'   /* C spacing ( units of r ) */')
      CALL WRITE_COPY1D_RS( bufRL, drF, Nr, INDEX_K, 'drF = ',
     &'   /* W spacing ( units of r ) */')
      IF ( selectSigmaCoord.NE.0 ) THEN
       CALL WRITE_COPY1D_RS( bufRL,dAHybSigF,Nr,INDEX_K,'dAHybSigF =',
     &  ' /* vertical increment of Hybrid-sigma Coeff. (-) */')
       CALL WRITE_COPY1D_RS( bufRL,dBHybSigF,Nr,INDEX_K,'dBHybSigF =',
     &  ' /* vertical increment of Hybrid-sigma Coeff. (-) */')
      ENDIF
      IF ( usingCurvilinearGrid ) THEN
       CALL WRITE_0D_RL( radius_fromHorizGrid, INDEX_NONE,
     &  'radius_fromHorizGrid = ',
     &  '/* sphere Radius of input horiz. grid */')
      ELSE
       CALL WRITE_1D_RL( delX, gridNx, INDEX_I, 'delX = ',
     &  ' /* U spacing ( m - cartesian, degrees - spherical ) */')
       CALL WRITE_1D_RL( delY, gridNy, INDEX_J, 'delY = ',
     &  ' /* V spacing ( m - cartesian, degrees - spherical ) */')
       CALL WRITE_0D_RL( xgOrigin, INDEX_NONE,'xgOrigin = ',
     & '/* X-axis origin of West  edge (cartesian: m, lat-lon: deg) */')
       CALL WRITE_0D_RL( ygOrigin, INDEX_NONE,'ygOrigin = ',
     & '/* Y-axis origin of South edge (cartesian: m, lat-lon: deg) */')
      ENDIF
      CALL WRITE_0D_RL( rSphere, INDEX_NONE,'rSphere = ',
     &  ' /* Radius ( ignored - cartesian, m - spherical ) */')
      CALL WRITE_0D_L(deepAtmosphere,INDEX_NONE, 'deepAtmosphere =',
     &  ' /* Deep/Shallow Atmosphere flag (True/False) */')
      coordLine = 1
      tileLine  = 1
      CALL WRITE_XY_XLINE_RS( xC, coordLine, tileLine, 'xC',
     I         ': P-point X coord ( deg. or m if cartesian)')
      CALL WRITE_XY_YLINE_RS( yC, coordLine, tileLine, 'yC',
     I         ': P-point Y coord ( deg. or m if cartesian)')
      CALL WRITE_COPY1D_RS( bufRL, rC, Nr, INDEX_K, 'rcoord =',
     &  ' /* P-point R coordinate (  units of r ) */')
      CALL WRITE_COPY1D_RS( bufRL, rF,Nr+1,INDEX_K, 'rF = ',
     &'   /* W-Interf. R coordinate (  units of r ) */')
      IF ( selectSigmaCoord.NE.0 ) THEN
       CALL WRITE_COPY1D_RS(bufRL,aHybSigmF,Nr+1,INDEX_K,'aHybSigmF =',
     &  ' /* Hybrid-sigma vert. Coord coeff. @ W-Interface (-) */')
       CALL WRITE_COPY1D_RS(bufRL,bHybSigmF,Nr+1,INDEX_K,'bHybSigmF =',
     &  ' /* Hybrid-sigma vert. Coord coeff. @ W-Interface (-) */')
      ENDIF
      CALL WRITE_1D_RL( deepFacC, Nr,   INDEX_K, 'deepFacC = ',
     &  ' /* deep-model grid factor @ cell-Center (-) */')
      CALL WRITE_1D_RL( deepFacF, Nr+1, INDEX_K, 'deepFacF = ',
     &  ' /* deep-model grid factor @ W-Interface (-) */')
      IF ( usingPCoords ) THEN
       CALL WRITE_1D_RL( rVel2wUnit, Nr+1, INDEX_K, 'rVel2wUnit =',
     &  ' /* convert units: rVel [Pa/s] -> wSpeed [m/s] */')
       CALL WRITE_1D_RL( wUnit2rVel, Nr+1, INDEX_K, 'wUnit2rVel =',
     &  ' /* convert units: wSpeed [m/s] -> rVel [Pa/s] */')
       CALL WRITE_1D_RL( rUnit2z, Nr, INDEX_K, 'rUnit2z =',
     &  ' /* convert units (@ center): dr [Pa] -> dz [m] */')
       CALL WRITE_1D_RL( z2rUnit, Nr, INDEX_K, 'z2rUnit =',
     &  ' /* convert units (@ center): dz [m] -> dr [Pa] */')
      ENDIF
      CALL WRITE_0D_L( rotateGrid, INDEX_NONE,
     & 'rotateGrid =',' /* use rotated grid ( True/False ) */')
      CALL WRITE_0D_RL( phiEuler, INDEX_NONE,'phiEuler =',
     &' /* Euler angle, rotation about original z-coordinate [rad] */')
      CALL WRITE_0D_RL( thetaEuler, INDEX_NONE,'thetaEuler =',
     & ' /* Euler angle, rotation about new x-coordinate [rad] */')
      CALL WRITE_0D_RL( psiEuler, INDEX_NONE,'psiEuler =',
     & ' /* Euler angle, rotation about new z-coordinate [rad] */')

C     Grid along selected grid lines
      coordLine = 1
      tileLine  = 1
      CALL WRITE_XY_XLINE_RS( dxF, coordLine, tileLine, 'dxF',
     I              '( units: m )' )
      CALL WRITE_XY_YLINE_RS( dxF, coordLine, tileLine, 'dxF',
     I              '( units: m )' )
      CALL WRITE_XY_XLINE_RS( dyF, coordLine, tileLine, 'dyF',
     I              '( units: m )' )
      CALL WRITE_XY_YLINE_RS( dyF, coordLine, tileLine, 'dyF',
     I              '( units: m )' )
      CALL WRITE_XY_XLINE_RS( dxG, coordLine, tileLine, 'dxG',
     I              '( units: m )' )
      CALL WRITE_XY_YLINE_RS( dxG, coordLine, tileLine, 'dxG',
     I              '( units: m )' )
      CALL WRITE_XY_XLINE_RS( dyG, coordLine, tileLine, 'dyG',
     I              '( units: m )' )
      CALL WRITE_XY_YLINE_RS( dyG, coordLine, tileLine, 'dyG',
     I              '( units: m )' )
      CALL WRITE_XY_XLINE_RS( dxC, coordLine, tileLine, 'dxC',
     I              '( units: m )' )
      CALL WRITE_XY_YLINE_RS( dxC, coordLine, tileLine, 'dxC',
     I              '( units: m )' )
      CALL WRITE_XY_XLINE_RS( dyC, coordLine, tileLine, 'dyC',
     I              '( units: m )' )
      CALL WRITE_XY_YLINE_RS( dyC, coordLine, tileLine, 'dyC',
     I              '( units: m )' )
      CALL WRITE_XY_XLINE_RS( dxV, coordLine, tileLine, 'dxV',
     I              '( units: m )' )
      CALL WRITE_XY_YLINE_RS( dxV, coordLine, tileLine, 'dxV',
     I              '( units: m )' )
      CALL WRITE_XY_XLINE_RS( dyU, coordLine, tileLine, 'dyU',
     I              '( units: m )' )
      CALL WRITE_XY_YLINE_RS( dyU, coordLine, tileLine, 'dyU',
     I              '( units: m )' )
      CALL WRITE_XY_XLINE_RS( rA , coordLine, tileLine, 'rA ',
     I              '( units: m^2 )' )
      CALL WRITE_XY_YLINE_RS( rA , coordLine, tileLine, 'rA ',
     I              '( units: m^2 )' )
      CALL WRITE_XY_XLINE_RS( rAw, coordLine, tileLine, 'rAw',
     I              '( units: m^2 )' )
      CALL WRITE_XY_YLINE_RS( rAw, coordLine, tileLine, 'rAw',
     I              '( units: m^2 )' )
      CALL WRITE_XY_XLINE_RS( rAs, coordLine, tileLine, 'rAs',
     I              '( units: m^2 )' )
      CALL WRITE_XY_YLINE_RS( rAs, coordLine, tileLine, 'rAs',
     I              '( units: m^2 )' )

      CALL WRITE_0D_RL( globalArea, INDEX_NONE, 'globalArea =',
     & ' /* Integrated horizontal Area (m^2) */')
      CALL WRITE_0D_RL( rAc_3dMean, INDEX_NONE, 'rAc_3dMean =',
     & ' /* 3-D Averaged grid-cell Area (m^2) */')
      CALL WRITE_0D_RL( n2dWetPts, INDEX_NONE, 'n2dWetPts =',
     & ' /* Number of wet surface points (-) */')
      CALL WRITE_0D_RL( n3dWetPts, INDEX_NONE, 'n3dWetPts =',
     & ' /* Number of wet grid points (-) */')
      IF ( useCubedSphereExchange ) THEN
       CALL WRITE_0D_L( hasWetCSCorners,INDEX_NONE,'hasWetCSCorners =',
     &  ' /* Domain contains CS corners (True/False) */')
      ENDIF

      i = ILNBLNK(the_run_name)
      IF ( i.GT.0 ) THEN
        CALL WRITE_0D_C( the_run_name, i, INDEX_NONE,
     &    'the_run_name = ', '/* Name of this simulation */' )
      ENDIF

      WRITE(msgBuf,'(A)')
     &'// ======================================================='
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)') '// End of Model config. summary'
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)')
     &'// ======================================================='
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)') ' '
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )

      _END_MASTER(myThid)
      _BARRIER

      RETURN
      END

#include "CPP_OPTIONS.h"

      SUBROUTINE MOM_VI_MASK_VORT3(
     I        bi,bj,k,
     O        hFacZ,r_hFacZ,
     U        vort3,
     I        myThid)
      IMPLICIT NONE
C
C     Compute hFactor and recip_hFactor at the corner (Z-point)
C     and set vort3 to zero where hFac = 0 (apply a mask)
C

C     == Global variables ==
#include "SIZE.h"
#include "GRID.h"

C     == Routine arguments ==
      INTEGER bi,bj,k
      _RS hFacZ(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RS r_hFacZ(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL vort3(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RS hFacZOpen
      INTEGER myThid

C     == Local variables ==
      INTEGER I,J

C--   Calculate open water fraction at vorticity points

c     DO i=1-Olx,sNx+Olx
c      hFacZ(i,1-Oly)=0.
c      r_hFacZ(i,1-Oly)=0.
c     ENDDO

      DO j=2-Oly,sNy+Oly
c      hFacZ(1-Olx,j)=0.
c      r_hFacZ(1-Olx,j)=0.
       DO i=2-Olx,sNx+Olx
        hFacZOpen=min(_hFacW(i,j,k,bi,bj),
     &                _hFacW(i,j-1,k,bi,bj))
        hFacZOpen=min(_hFacS(i,j,k,bi,bj),hFacZOpen)
        hFacZOpen=min(_hFacS(i-1,j,k,bi,bj),hFacZOpen)
        hFacZ(i,j)=hFacZOpen
        IF (hFacZ(i,j).EQ.0.) THEN
         r_hFacZ(i,j)=0.
         vort3(i,j)=0.
        ELSE
         r_hFacZ(i,j)=1./hFacZ(i,j)
        ENDIF
       ENDDO
      ENDDO

      RETURN
      END

#include "PACKAGES_CONFIG.h"
#include "CPP_OPTIONS.h"
c#ifdef ALLOW_AUTODIFF
c# include "AUTODIFF_OPTIONS.h"
c#endif
#ifdef ALLOW_COST
# include "COST_OPTIONS.h"
#endif
#ifdef ALLOW_CTRL
# include "CTRL_OPTIONS.h"
#endif
#ifdef ALLOW_OBCS
# include "OBCS_OPTIONS.h"
#endif
#ifdef ALLOW_SEAICE
# include "SEAICE_OPTIONS.h"
#endif
#ifdef ALLOW_GMREDI
# include "GMREDI_OPTIONS.h"
#endif

C start with a copy of THE_MAIN_LOOP
C and remove some the obvious extras
      SUBROUTINE openad_dumpAdjoint( myTime, myIter, myThid )
      IMPLICIT NONE

C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"

c**************************************
#ifdef ALLOW_AUTODIFF

c These includes are needed for
c AD-checkpointing.
c They provide the fields to be stored.

# include "GRID.h"
# include "DYNVARS.h"
# include "SURFACE.h"
# include "FFIELDS.h"
# include "EOS.h"
# ifdef ALLOW_GENERIC_ADVDIFF
#  include "GAD.h"
# endif
# ifdef ALLOW_CD_CODE
#  include "CD_CODE_VARS.h"
# endif
# ifdef ALLOW_PTRACERS
#  include "PTRACERS_SIZE.h"
#  include "PTRACERS_FIELDS.h"
# endif
# ifdef ALLOW_OBCS
#  include "OBCS_PARAMS.h"
#  include "OBCS_GRID.h"
#  include "OBCS_FIELDS.h"
#  include "OBCS_SEAICE.h"
# endif
# ifdef ALLOW_EXF
#  include "EXF_FIELDS.h"
#  include "EXF_PARAM.h"
#  ifdef ALLOW_BULKFORMULAE
#   include "EXF_CONSTANTS.h"
#  endif
# endif /* ALLOW_EXF */
# ifdef ALLOW_SEAICE
#  include "SEAICE.h"
# endif
# ifdef ALLOW_EBM
#  include "EBM.h"
# endif
# ifdef ALLOW_KPP
#  include "KPP.h"
#  include "KPP_PARAMS.h"
# endif

# include "CTRL_SIZE.h"
# include "CTRL.h"
# include "CTRL_DUMMY.h"
# include "cost.h"

#endif /* ALLOW_AUTODIFF */

      _RL     myTime
      INTEGER myIter
      INTEGER myThid

      _RL     foo4(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL     foo5(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      CHARACTER*(10) suff

      IF ( MOD(myIter,360).EQ.0 ) THEN
         IF ( rwSuffixType.EQ.0 ) THEN
           WRITE(suff,'(I10.10)') myIter
         ELSE
           CALL RW_GET_SUFFIX( suff, myTime, myIter, myThid )
         ENDIF
# ifndef ALLOW_STREAMICE
         foo5=theta%d
         call write_fld_xyz_rl('adjtheta.',suff,foo5,myIter,1)
         foo5=salt%d
         call write_fld_xyz_rl('adjsalt.',suff,foo5,myIter,1)
         foo5=uvel%d
         call write_fld_xyz_rl('adjuvel.',suff,foo5,myIter,1)
         foo5=vvel%d
         call write_fld_xyz_rl('adjvvel.',suff,foo5,myIter,1)
         foo5=wvel%d
         call write_fld_xyz_rl('adjwvel.',suff,foo5,myIter,1)
         foo4=etan%d
         call write_fld_xy_rl('adjetan.',suff,foo4,myIter,1)
# endif
# ifdef ALLOW_DIFFKR_CONTROL
         foo5=diffkr%d
         call write_fld_xy_rl('adjdiffkr.',suff,foo5,myIter,1)
# endif
      ENDIF

      RETURN
      END

#include "GCHEM_OPTIONS.h"

C !INTERFACE: ==========================================================
      SUBROUTINE GCHEM_SURFMEAN(
     I                    tracer,
     O                    gsm_tracer,
     I                    myThid )

C !DESCRIPTION:
C  Calculate surface mean of tracer

C !USES: ===============================================================
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"

C !INPUT PARAMETERS: ===================================================
C  myThid               :: thread number
      INTEGER myThid
      _RL tracer (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)

C !OUTPUT PARAMETERS: ===================================================
C  gcm_tracer           :: surface mean of tracer
      _RL gsm_tracer

C !LOCAL VARIABLES: ====================================================
      INTEGER i,j,bi,bj
      INTEGER ks
      _RL sumTracerTile(nSx,nSy)
      _RL sumTracer
CEOP

      IF ( usingPCoords ) THEN
       ks = Nr
      ELSE
       ks = 1
      ENDIF

       DO bj=myByLo(myThid),myByHi(myThid)
        DO bi=myBxLo(myThid),myBxHi(myThid)
         sumTracerTile(bi,bj) = 0. _d 0
         DO j=1,sNy
          DO i=1,sNx
            sumTracerTile(bi,bj) = sumTracerTile(bi,bj)
     &        + tracer(i,j,ks,bi,bj)*rA(i,j,bi,bj)*maskInC(i,j,bi,bj)
          ENDDO
         ENDDO
        ENDDO
       ENDDO
       CALL GLOBAL_SUM_TILE_RL(sumTracerTile,sumTracer,myThid)
       gsm_tracer = sumTracer/globalArea

      RETURN
      END

#include "PP81_OPTIONS.h"

      SUBROUTINE PP81_INIT_VARIA( myThid )
C     *==========================================================*
C     | SUBROUTINE PP81_INIT_VARIA
C     | o Routine to initialize PP81 parameters and variables.
C     *==========================================================*
C     | Initialize PP81 parameters and variables.
C     *==========================================================*
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
c#include "GRID.h"
#include "PP81.h"

C     === Routine arguments ===
C     myThid -  Number of this instance of PP81_INIT
      INTEGER myThid

#ifdef ALLOW_PP81

C     === Local variables ===
C     i,j,k,bi,bj - Loop counters

      INTEGER i, j, k, bi, bj

C-----------------------------------------------------------------------
C Initialize PP variables PPviscAr, PPdiffKrT
C-----------------------------------------------------------------------

      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
        DO k = 1, Nr
         DO j = 1-OLy, sNy+OLy
          DO i = 1-OLx, sNx+OLx
           PPviscAr (i,j,k,bi,bj) = viscArNr(k)
           PPdiffKr (i,j,k,bi,bj) = diffKrNrS(k)
          ENDDO
         ENDDO
        ENDDO
       ENDDO
      ENDDO

#endif /* ALLOW_PP81 */

      RETURN
      END

#include "PACKAGES_CONFIG.h"
#include "CPP_EEOPTIONS.h"
#undef DBUG_EXCH_VEC

C--   Contents
C--   o EXCH2_RECV_GET_VEC_RL

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 0
C !ROUTINE: EXCH2_RECV_GET_VEC_RL

C !INTERFACE:
      SUBROUTINE EXCH2_RECV_GET_VEC_RL(
     U                        array,
     I                        theHandle,
     I                        myd1, myThid )
C     !DESCRIPTION:
C     *==========================================================*
C     | SUBROUTINE EXCH2_RECV_GET_VEC_RL
C     | o "Receive" edges for RL array.
C     *==========================================================*
C     | Routine that invokes actual message passing receive
C     | of data to update buffer
C     *==========================================================*

C     !USES:
      IMPLICIT NONE

C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "EESUPPORT.h"
#ifdef ALLOW_EXCH2
#include "W2_EXCH2_SIZE.h"
#include "W2_EXCH2_TOPOLOGY.h"
#endif
#include "FLT_SIZE.h"

C     !INPUT/OUTPUT PARAMETERS:
C     arrayE        :: buffer array to collect Eastern Neighbour values
C     arrayW        :: buffer array to collect Western Neighbour values
C     myd1          :: size
C     myThid        :: my Thread Id. number
      INTEGER myd1
      _RL array(myd1, nSx, nSy, 4)
#ifdef ALLOW_EXCH2
      INTEGER theHandle(2,W2_maxNeighbours,nSx,nSy)
#else
      INTEGER theHandle
#endif
      INTEGER myThid
CEOP

#ifdef ALLOW_EXCH2
#ifdef ALLOW_USE_MPI
C     !LOCAL VARIABLES:
C     bi, bj        :: tile indices
C     theProc       :: Variables used in message building
C     theTag        :: Variables used in message building
C     theType       :: Variables used in message building
C     theSize       :: Variables used in message building
      INTEGER bi, bj
      INTEGER ioUnit
      INTEGER thisTile, nN, tgT, oNb, dir
      INTEGER theProc, theTag, theType, theSize
      INTEGER wHandle
      INTEGER mpiStatus(MPI_STATUS_SIZE,4), mpiRc
      INTEGER imax, imax2
      PARAMETER(imax=9)
      PARAMETER(imax2=imax*max_npart_exch)
      INTEGER pi(2), pj(2), oi, oj, ip, itb, jtb, isb, jsb
      _RL itc,jtc, itmp, jtmp

C--   Under a "put" scenario we
C--     i. set completetion signal for buffer we put into.
C--    ii. wait for completetion signal indicating data has been put in
C--        our buffer.
C--   Under a messaging mode we "receive" the message.
C--   Under a "get" scenario <= not implemented, we
C--     i. Check that the data is ready.
C--    ii. Read the data.
C--   iii. Set data read flag + memory sync.

      ioUnit = errorMessageUnit

      _BEGIN_MASTER(myThid)

      DO bj=1,nSy
       DO bi=1,nSx
         thisTile = W2_myTileList(bi,bj)

C- loop over neighboring tiles
         DO nN=1,exch2_nNeighbours(thisTile)

          tgT = exch2_neighbourId(nN, thisTile )
          oNb = exch2_opposingSend(nN, thisTile )
          dir = exch2_neighbourDir(nN,thisTile)

#ifdef DBUG_EXCH_VEC
          write(ioUnit,'(A,5I6)') 'RECV,0 :',myProcId,bi,bj
#endif
          IF ( W2_myCommFlag(nN,bi,bj) .EQ. 'M' ) THEN
           theProc = W2_tileProc(tgT) - 1
           theTag  = (tgT-1)*W2_maxNeighbours + oNb
           theSize = myd1
           theType = _MPI_TYPE_RL
#ifdef DBUG_EXCH_VEC
           write(ioUnit,'(A,5I5,I8)') 'qq2xW: ',myProcId,bi,bj,
     &           theProc,theTag,theSize
#endif
           CALL MPI_Recv( array(1,bi,bj,dir), theSize, theType,
     &                    theProc, theTag, MPI_COMM_MODEL,
     &                    mpiStatus, mpiRc )

C- apply exch2_pij to rotate or shift indices
           itb = exch2_tBasex(tgT)
           jtb = exch2_tBasey(tgT)
           isb = exch2_tBasex(thisTile)
           jsb = exch2_tBasey(thisTile)
           pi(1)=exch2_pij(1,nN,thisTile)
           pi(2)=exch2_pij(2,nN,thisTile)
           pj(1)=exch2_pij(3,nN,thisTile)
           pj(2)=exch2_pij(4,nN,thisTile)
           oi  = exch2_oi(nN,thisTile)
           oj  = exch2_oj(nN,thisTile)

#ifdef DBUG_EXCH_VEC
           DO ip=1,max_npart_exch
            IF (array(imax*(ip-1)+1,bi,bj,dir).NE.0.) THEN
             itc=array(imax*(ip-1)+3,bi,bj,dir)+itb
             jtc=array(imax*(ip-1)+4,bi,bj,dir)+jtb
             itmp = pi(1)*itc+pi(2)*jtc+oi-isb
             jtmp = pj(1)*itc+pj(2)*jtc+oj-jsb          
             write(ioUnit,'(A,3I6)') 'LOC,1 :',thisTile,tgT,dir
             write(ioUnit,'(A,8F10.3)') 'LOC,2 :',
     &       array(imax*(ip-1)+1,bi,bj,dir),
     &       array(imax*(ip-1)+2,bi,bj,dir),
     &       array(imax*(ip-1)+3,bi,bj,dir),
     &       array(imax*(ip-1)+4,bi,bj,dir),
     &       itc,jtc,itmp,jtmp
            ENDIF
           ENDDO
#endif

           DO ip=1,max_npart_exch
            IF (array(imax*(ip-1)+1,bi,bj,dir).NE.0.) THEN
             itc=array(imax*(ip-1)+3,bi,bj,dir)+itb
             jtc=array(imax*(ip-1)+4,bi,bj,dir)+jtb
             array(imax*(ip-1)+3,bi,bj,dir) = pi(1)*itc+pi(2)*jtc+oi-isb
             array(imax*(ip-1)+4,bi,bj,dir) = pj(1)*itc+pj(2)*jtc+oj-jsb
            ENDIF
           ENDDO

          ENDIF
#ifdef DBUG_EXCH_VEC
          write(ioUnit,'(A,5I6)') 'RECV,1 :',myProcId,bi,bj
#endif
C-       nN
         ENDDO
C-     bj,bi
       ENDDO
      ENDDO
#ifdef DBUG_EXCH_VEC
       write(ioUnit,'(A,5I6,I12)') 'RECV:',myProcId
#endif

C--   Clear message handles/locks
      DO bj=1,nSy
       DO bi=1,nSx
         thisTile = W2_myTileList(bi,bj)
         DO nN=1,exch2_nNeighbours(thisTile)
c          tgT = exch2_neighbourId(nN, thisTile )

C-    Note: In a between process tile-tile data transport using
C           MPI the sender needs to clear an Isend wait handle here.
C           In a within process tile-tile data transport using true
C           shared address space/or direct transfer through commonly
C           addressable memory blocks the receiver needs to assert
C           that he has consumed the buffer the sender filled here.
           IF ( W2_myCommFlag(nN,bi,bj) .EQ. 'M' ) THEN
            wHandle = theHandle(1,nN,bi,bj)
            CALL MPI_Wait( wHandle, mpiStatus, mpiRc )
           ENDIF

         ENDDO
       ENDDO
      ENDDO

      _END_MASTER(myThid)

C--   need to sync threads after master has received data
      _BARRIER

#endif /* ALLOW_USE_MPI */
#endif /* ALLOW_EXCH2 */

      RETURN
      END

#include "COST_OPTIONS.h"

      subroutine cost_tracer( bi, bj, myThid )
C     /==========================================================\
C     | subroutine cost_tracer                                   |
C     | o this routine computes the cost function for the tiles  |
C     |   of this processor                                      |
C     |==========================================================|
C     |                                                          |
C     | Notes                                                    |
C     | =====                                                    |
C     \==========================================================/
      IMPLICIT NONE

C     == Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "DYNVARS.h"
#include "GRID.h"
#ifdef ALLOW_COST_TRACER
# ifdef ALLOW_PTRACERS
#  include "PTRACERS_SIZE.h"
#  include "PTRACERS_PARAMS.h"
#  include "PTRACERS_FIELDS.h"
# endif
#endif

#include "cost.h"

C     == Routine arguments ==
C     myThid - Thread number for this instance of the routine.
      integer bi, bj
      integer myThid

#ifdef ALLOW_COST_TRACER
C     == Local variables
      _RL thetaRef
      _RL locfc

      integer i, j, k
      integer ig, jg
ce    some reference temperature
      thetaRef = 24.0D0

      locfc = 0. _d 0

      k=1
      DO j=1,sNy
         DO i=1,sNx
#ifdef ALLOW_PTRACERS
            locfc = locfc + maskC(i,j,k,bi,bj)*
     &           ptracer(i,j,k,bi,bj,6)*
     &           rA(i,j,bi,bj)*drF(k)
#endif
         ENDDO
      ENDDO

      objf_tracer(bi,bj) = objf_tracer(bi,bj) + locfc

#ifdef ALLOW_PTRACERS
      print *, 'COST TRACER nach', objf_tracer(bi,bj),
     &     ptracer(83,33,1,1,1,1), ptracer(83,33,2,1,1,1)
#endif

#endif /* ALLOW_COST_TRACER */

      RETURN
      END

#include "PACKAGES_CONFIG.h"
#include "CPP_OPTIONS.h"
#ifdef ALLOW_MOM_COMMON
# include "MOM_COMMON_OPTIONS.h"
#endif
#ifdef ALLOW_AUTODIFF
# include "AUTODIFF_OPTIONS.h"
#endif
#ifdef ALLOW_CTRL
# include "CTRL_OPTIONS.h"
#endif
#ifdef ALLOW_SALT_PLUME
# include "SALT_PLUME_OPTIONS.h"
#endif
#ifdef ALLOW_ECCO
# include "ECCO_OPTIONS.h"
#endif

#ifdef ALLOW_AUTODIFF
# ifdef ALLOW_GGL90
#  include "GGL90_OPTIONS.h"
# endif
# ifdef ALLOW_GMREDI
#  include "GMREDI_OPTIONS.h"
# endif
# ifdef ALLOW_KPP
#  include "KPP_OPTIONS.h"
# endif
# ifdef ALLOW_SEAICE
#  include "SEAICE_OPTIONS.h"
# endif
# ifdef ALLOW_EXF
#  include "EXF_OPTIONS.h"
# endif
#ifdef ALLOW_OBCS
# include "OBCS_OPTIONS.h"
#endif
#endif /* ALLOW_AUTODIFF */

CBOP
C     !ROUTINE: DO_OCEANIC_PHYS
C     !INTERFACE:
      SUBROUTINE DO_OCEANIC_PHYS(myTime, myIter, myThid)
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE DO_OCEANIC_PHYS
C     | o Controlling routine for oceanic physics and
C     |   parameterization
C     *==========================================================*
C     | o originally, part of S/R thermodynamics
C     *==========================================================*
C     \ev

C     !CALLING SEQUENCE:
C     DO_OCEANIC_PHYS
C       |
C       |-- OBCS_CALC
C       |
C       |-- OCN_APPLY_IMPORT
C       |
C       |-- FRAZIL_CALC_RHS
C       |
C       |-- THSICE_MAIN
C       |
C       |-- SEAICE_FAKE
C       |-- SEAICE_MODEL
C       |-- SEAICE_COST_SENSI
C       |
C       |-- OCN_EXPORT_DATA
C       |
C       |-- STIC_THERMODYNAMICS
C       |-- SHELFICE_THERMODYNAMICS
C       |
C       |-- ICEFRONT_THERMODYNAMICS
C       |
C       |-- SALT_PLUME_DO_EXCH
C       |
C       |-- FREEZE_SURFACE
C       |
C       |-- EXTERNAL_FORCING_SURF
C       |
C       |-- OBCS_ADJUST
C       |
C       |- k loop (Nr:1):
C       | - DWNSLP_CALC_RHO
C       | - BBL_CALC_RHO
C       | - FIND_RHO_2D @ p(k)
C       | - FIND_RHO_2D @ p(k-1)
C       | - GRAD_SIGMA
C       | - CALC_IVDC
C       | - DIAGS_RHO_L
C       |- end k loop.
C       |
C       |-- CALC_OCE_MXLAYER
C       |
C       |-- SALT_PLUME_CALC_DEPTH
C       |-- SALT_PLUME_VOLFRAC
C       |-- SALT_PLUME_APPLY
C       |-- SALT_PLUME_APPLY
C       |-- SALT_PLUME_FORCING_SURF
C       |
C       |-- KPP_CALC
C       |-- KPP_CALC_DUMMY
C       |
C       |-- PP81_CALC
C       |
C       |-- KL10_CALC
C       |
C       |-- MY82_CALC
C       |
C       |-- GGL90_CALC
C       |
C       |-- GMREDI_CALC_TENSOR
C       |-- GMREDI_CALC_TENSOR_DUMMY
C       |
C       |-- DWNSLP_CALC_FLOW
C       |-- DWNSLP_CALC_FLOW
C       |
C       |-- OFFLINE_GET_DIFFUS
C       |
C       |-- BBL_CALC_RHS
C       |
C       |-- MYPACKAGE_CALC_RHS
C       |
C       |-- GMREDI_DO_EXCH
C       |
C       |-- KPP_DO_EXCH
C       |
C       |-- GGL90_EXCHANGES
C       |
C       |-- DIAGS_RHO_G
C       |-- DIAGS_OCEANIC_SURF_FLUX
C       |-- SALT_PLUME_DIAGNOSTICS_FILL
C       |
C       |-- ECCO_PHYS

C     !USES:
      IMPLICIT NONE
C     == Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "DYNVARS.h"
#ifdef ALLOW_OFFLINE
# include "OFFLINE_SWITCH.h"
#endif

#ifdef ALLOW_AUTODIFF
# ifdef ALLOW_AUTODIFF_TAMC
#  include "tamc.h"
# endif
# include "FFIELDS.h"
# include "SURFACE.h"
# include "EOS.h"
# ifdef ALLOW_GMREDI
#  include "GMREDI.h"
# endif
# ifdef ALLOW_KPP
#  include "KPP.h"
# endif
# ifdef ALLOW_GGL90
#  include "GGL90.h"
# endif
# ifdef ALLOW_EBM
#  include "EBM.h"
# endif
# ifdef ALLOW_EXF
#  ifdef ALLOW_CTRL
#   include "CTRL_SIZE.h"
#   include "CTRL.h"
#  endif
#  include "EXF_FIELDS.h"
#  ifdef ALLOW_BULKFORMULAE
#   include "EXF_CONSTANTS.h"
#  endif
# endif
# ifdef ALLOW_SEAICE
#  include "SEAICE_SIZE.h"
#  include "SEAICE.h"
#  include "SEAICE_PARAMS.h"
# endif
# ifdef ALLOW_THSICE
#  include "THSICE_VARS.h"
# endif
# ifdef ALLOW_SALT_PLUME
#  include "SALT_PLUME.h"
# endif
# ifdef ALLOW_OBCS
#  include "OBCS_PARAMS.h"
#  include "OBCS_FIELDS.h"
# endif
#endif /* ALLOW_AUTODIFF */

#ifdef ALLOW_TAPENADE
c# ifdef ALLOW_KPP
c#  include "KPP_PARAMS.h"
c# endif
# ifdef ALLOW_SHELFICE
#  include "SHELFICE.h"
# endif
#endif /* ALLOW_TAPENADE */

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     myTime :: Current time in simulation
C     myIter :: Current iteration number in simulation
C     myThid :: Thread number for this instance of the routine.
      _RL myTime
      INTEGER myIter
      INTEGER myThid

C     !LOCAL VARIABLES:
C     == Local variables
C     rhoKp1,rhoKm1 :: Density at current level, and @ level minus one
C     iMin, iMax    :: Ranges and sub-block indices on which calculations
C     jMin, jMax       are applied.
C     bi, bj        :: tile indices
C     msgBuf        :: Temp. for building output string
C     i,j,k         :: loop indices
C     kSrf          :: surface index
      _RL rhoKp1  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL rhoKm1  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL sigmaX  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL sigmaY  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL sigmaR  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      INTEGER iMin, iMax
      INTEGER jMin, jMax
      INTEGER bi, bj
      INTEGER i, j, k, kSrf
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      INTEGER doDiagsRho
      LOGICAL calcGMRedi, calcKPP, calcConvect
#ifdef ALLOW_DIAGNOSTICS
      LOGICAL  DIAGNOSTICS_IS_ON
      EXTERNAL DIAGNOSTICS_IS_ON
#endif /* ALLOW_DIAGNOSTICS */
#ifdef ALLOW_AUTODIFF
      _RL thetaRef
#endif /* ALLOW_AUTODIFF */
#ifdef ALLOW_AUTODIFF_TAMC
C     tkey :: tape key (tile dependent)
      INTEGER tkey
#endif
CEOP

      kSrf = 1
      IF ( usingPCoords ) kSrf = Nr

#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_ENTER('DO_OCEANIC_PHYS',myThid)
#endif

      doDiagsRho = 0
#ifdef ALLOW_DIAGNOSTICS
      IF ( useDiagnostics .AND. fluidIsWater ) THEN
        IF ( DIAGNOSTICS_IS_ON('MXLDEPTH',myThid) )
     &       doDiagsRho = doDiagsRho + 1
        IF ( DIAGNOSTICS_IS_ON('DRHODR  ',myThid) )
     &       doDiagsRho = doDiagsRho + 2
        IF ( DIAGNOSTICS_IS_ON('WdRHO_P ',myThid) )
     &       doDiagsRho = doDiagsRho + 4
        IF ( DIAGNOSTICS_IS_ON('WdRHOdP ',myThid) )
     &       doDiagsRho = doDiagsRho + 8
      ENDIF
#endif /* ALLOW_DIAGNOSTICS */

      calcGMRedi  = useGMRedi
      calcKPP     = useKPP
      calcConvect = ivdc_kappa.NE.0.
#ifdef ALLOW_OFFLINE
      IF ( useOffLine ) THEN
        calcGMRedi = useGMRedi .AND. .NOT.offlineLoadGMRedi
        calcKPP    = useKPP    .AND. .NOT.offlineLoadKPP
        calcConvect=calcConvect.AND. .NOT.offlineLoadConvec
      ENDIF
#endif /* ALLOW_OFFLINE */

#if ( defined ALLOW_GCHEM && defined SHORTWAVE_HEATING )
C--   This is the place where the 3D array SWFrac3D would need to be
C     updated to reflect the current amount of surface radiation
C     avaiable in each layer. The routine to do this depends very much
C     on the bio-geo-chemical model used to compute turbidity or
C     concentration of organic matter in the water column, and has not
C     yet been written.
C     IF ( useGCHEM .AND. selectPenetratingSW .GT. 1 )
C    &     CALL GCHEM_SWFRAC( myTime, myIter, myThid )
#endif

#ifdef  ALLOW_OBCS
      IF (useOBCS) THEN
C--   Calculate future values on open boundaries
C--   moved before SEAICE_MODEL call since SEAICE_MODEL needs seaice-obcs fields
# ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE theta = comlev1, key=ikey_dynamics, kind=isbyte
CADJ STORE salt  = comlev1, key=ikey_dynamics, kind=isbyte
CADJ STORE etaN  = comlev1, key=ikey_dynamics, kind=isbyte
#  ifdef ALLOW_OBCS_STEVENS
CADJ STORE uVel  = comlev1, key=ikey_dynamics, kind=isbyte
CADJ STORE vVel  = comlev1, key=ikey_dynamics, kind=isbyte
#   ifdef ALLOW_OBCS_EAST
CADJ STORE OBEtStevens = comlev1, key=ikey_dynamics, kind=isbyte
CADJ STORE OBEsStevens = comlev1, key=ikey_dynamics, kind=isbyte
#   endif
#   ifdef ALLOW_OBCS_WEST
CADJ STORE OBWtStevens = comlev1, key=ikey_dynamics, kind=isbyte
CADJ STORE OBWsStevens = comlev1, key=ikey_dynamics, kind=isbyte
#   endif
#   ifdef ALLOW_OBCS_NORTH
CADJ STORE OBNtStevens = comlev1, key=ikey_dynamics, kind=isbyte
CADJ STORE OBNsStevens = comlev1, key=ikey_dynamics, kind=isbyte
#   endif
#   ifdef ALLOW_OBCS_SOUTH
CADJ STORE OBStStevens = comlev1, key=ikey_dynamics, kind=isbyte
CADJ STORE OBSsStevens = comlev1, key=ikey_dynamics, kind=isbyte
#   endif
#  endif /* ALLOW_OBCS_STEVENS */
# endif
# ifdef ALLOW_DEBUG
       IF (debugMode) CALL DEBUG_CALL('OBCS_CALC',myThid)
# endif
       CALL OBCS_CALC( myTime+deltaTClock, myIter+1,
     I                 uVel, vVel, wVel, theta, salt, myThid )
      ENDIF
# if ( defined ALLOW_AUTODIFF_TAMC && defined ALLOW_OBCS_BALANCE )
C     This needs to be done ***after*** the if-block to avoid calling
C     S/R OBCS_CALC in the AD code.
#  ifdef ALLOW_OBCS_NORTH
CADJ STORE OBNv        = comlev1, key=ikey_dynamics, kind=isbyte
#  endif
#  ifdef ALLOW_OBCS_SOUTH
CADJ STORE OBSv        = comlev1, key=ikey_dynamics, kind=isbyte
#  endif
#  ifdef ALLOW_OBCS_EAST
CADJ STORE OBEu        = comlev1, key=ikey_dynamics, kind=isbyte
#  endif
#  ifdef ALLOW_OBCS_WEST
CADJ STORE OBWu        = comlev1, key=ikey_dynamics, kind=isbyte
#  endif
# endif /* ALLOW_AUTODIFF_TAMC and ALLOW_OBCS_BALANCE */
#endif  /* ALLOW_OBCS */

#ifdef ALLOW_OCN_COMPON_INTERF
C--    Apply imported data (from coupled interface) to forcing fields
C jmc: moved here before any freezing/seaice pkg adjustment of surf-fluxes
      IF ( useCoupler ) THEN
         CALL OCN_APPLY_IMPORT( .TRUE., myTime, myIter, myThid )
      ENDIF
#endif /* ALLOW_OCN_COMPON_INTERF */

#ifdef ALLOW_AUTODIFF
      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          adjustColdSST_diag(i,j,bi,bj) = 0. _d 0
# ifdef ALLOW_SALT_PLUME
          saltPlumeDepth(i,j,bi,bj) = 0. _d 0
          saltPlumeFlux(i,j,bi,bj)  = 0. _d 0
# endif
         ENDDO
        ENDDO
       ENDDO
      ENDDO
#endif /* ALLOW_AUTODIFF */

#ifdef ALLOW_FRAZIL
      IF ( useFRAZIL ) THEN
C--   Freeze water in the ocean interior and let it rise to the surface
CADJ STORE theta = comlev1, key=ikey_dynamics, kind=isbyte
CADJ STORE salt  = comlev1, key=ikey_dynamics, kind=isbyte
       CALL FRAZIL_CALC_RHS( myTime, myIter, myThid )
      ENDIF
#endif /* ALLOW_FRAZIL */

#if (defined ALLOW_THSICE) && !(defined ALLOW_ATM2D)
      IF ( useThSIce .AND. fluidIsWater ) THEN
# ifdef ALLOW_AUTODIFF_TAMC
#  ifdef ALLOW_SEAICE
CADJ STORE uice,vice         = comlev1, key=ikey_dynamics, kind=isbyte
#  endif
CADJ STORE iceMask,iceHeight = comlev1, key=ikey_dynamics, kind=isbyte
CADJ STORE snowHeight, Tsrf  = comlev1, key=ikey_dynamics, kind=isbyte
CADJ STORE Qice1, Qice2      = comlev1, key=ikey_dynamics, kind=isbyte
CADJ STORE sHeating,snowAge  = comlev1, key=ikey_dynamics, kind=isbyte
CADJ STORE hocemxl, icflxsw  = comlev1, key=ikey_dynamics, kind=isbyte
CADJ STORE salt,theta        = comlev1, key=ikey_dynamics, kind=isbyte
CADJ STORE uvel,vvel         = comlev1, key=ikey_dynamics, kind=isbyte
CADJ STORE qnet,qsw, empmr   = comlev1, key=ikey_dynamics, kind=isbyte
CADJ STORE atemp,aqh,precip  = comlev1, key=ikey_dynamics, kind=isbyte
CADJ STORE swdown,lwdown     = comlev1, key=ikey_dynamics, kind=isbyte
#  ifdef NONLIN_FRSURF
CADJ STORE hFac_surfC        = comlev1, key=ikey_dynamics, kind=isbyte
#  endif
# endif /* ALLOW_AUTODIFF_TAMC */
# ifdef ALLOW_DEBUG
        IF (debugMode) CALL DEBUG_CALL('THSICE_MAIN',myThid)
# endif
C--     Step forward Therm.Sea-Ice variables
C       and modify forcing terms including effects from ice
        CALL TIMER_START('THSICE_MAIN     [DO_OCEANIC_PHYS]', myThid)
        CALL THSICE_MAIN( myTime, myIter, myThid )
        CALL TIMER_STOP( 'THSICE_MAIN     [DO_OCEANIC_PHYS]', myThid)
      ENDIF
#endif /* ALLOW_THSICE */

#ifdef ALLOW_SEAICE
# ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE qnet  = comlev1, key=ikey_dynamics, kind=isbyte
CADJ STORE qsw   = comlev1, key=ikey_dynamics, kind=isbyte
CADJ STORE fu,fv = comlev1, key=ikey_dynamics, kind=isbyte
#  if (defined ALLOW_EXF) && (defined ALLOW_ATM_TEMP)
CADJ STORE evap  = comlev1, key=ikey_dynamics, kind=isbyte
#  endif
CADJ STORE etan      = comlev1, key=ikey_dynamics, kind=isbyte
CADJ STORE theta     = comlev1, key=ikey_dynamics, kind=isbyte
CADJ STORE salt      = comlev1, key=ikey_dynamics, kind=isbyte
CADJ STORE uvel,vvel = comlev1, key=ikey_dynamics, kind=isbyte
CADJ STORE phiHydLow = comlev1, key=ikey_dynamics, byte=isbyte
# endif
      IF ( useSEAICE ) THEN
# ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE uvel,vvel         = comlev1, key=ikey_dynamics, kind=isbyte
CADJ STORE uice,vice         = comlev1, key=ikey_dynamics, kind=isbyte
#  ifdef SEAICE_USE_GROWTH_ADX
CADJ STORE tices             = comlev1, key=ikey_dynamics, kind=isbyte
#  endif
#  ifdef ALLOW_EXF
CADJ STORE atemp,aqh,precip  = comlev1, key=ikey_dynamics, kind=isbyte
CADJ STORE swdown,lwdown     = comlev1, key=ikey_dynamics, kind=isbyte
CADJ STORE uwind,vwind       = comlev1, key=ikey_dynamics, kind=isbyte
#  endif
#  ifdef SEAICE_VARIABLE_SALINITY
CADJ STORE hsalt             = comlev1, key=ikey_dynamics, kind=isbyte
#  endif
#  ifdef ATMOSPHERIC_LOADING
CADJ STORE pload, siceload   = comlev1, key=ikey_dynamics, kind=isbyte
#  endif
#  ifdef NONLIN_FRSURF
CADJ STORE recip_hfacc       = comlev1, key=ikey_dynamics, kind=isbyte
#  endif
#  ifdef ALLOW_THSICE
C-- store thSIce vars before advection (called from SEAICE_MODEL) updates them:
CADJ STORE iceMask,iceHeight = comlev1, key=ikey_dynamics, kind=isbyte
CADJ STORE snowHeight,hOceMxL= comlev1, key=ikey_dynamics, kind=isbyte
CADJ STORE Qice1, Qice2      = comlev1, key=ikey_dynamics, kind=isbyte
#  endif /* ALLOW_THSICE */
# endif /* ALLOW_AUTODIFF_TAMC */
# ifdef ALLOW_DEBUG
        IF (debugMode) CALL DEBUG_CALL('SEAICE_MODEL',myThid)
# endif
        CALL TIMER_START('SEAICE_MODEL    [DO_OCEANIC_PHYS]', myThid)
        CALL SEAICE_MODEL( myTime, myIter, myThid )
        CALL TIMER_STOP ('SEAICE_MODEL    [DO_OCEANIC_PHYS]', myThid)
# ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE tices = comlev1, key=ikey_dynamics, kind=isbyte
CADJ STORE heff  = comlev1, key=ikey_dynamics, kind=isbyte
CADJ STORE hsnow = comlev1, key=ikey_dynamics, kind=isbyte
CADJ STORE area  = comlev1, key=ikey_dynamics, kind=isbyte
CADJ STORE uIce  = comlev1, key=ikey_dynamics, kind=isbyte
CADJ STORE vIce  = comlev1, key=ikey_dynamics, kind=isbyte
# endif
# ifdef ALLOW_COST
        CALL SEAICE_COST_SENSI ( myTime, myIter, myThid )
# endif
# ifdef ALLOW_AUTODIFF
      ELSEIF ( SEAICEadjMODE .EQ. -1 ) THEN
#  ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE area = comlev1, key=ikey_dynamics, kind=isbyte
#  endif
        CALL SEAICE_FAKE( myTime, myIter, myThid )
# endif /* ALLOW_AUTODIFF */
      ENDIF
#endif /* ALLOW_SEAICE */

#if (defined ALLOW_OCN_COMPON_INTERF) && (defined ALLOW_THSICE)
C--   After seaice-dyn and advection of pkg/thsice fields,
C     Export ocean coupling fields to coupled interface (only with pkg/thsice)
      IF ( useCoupler ) THEN
# ifdef ALLOW_DEBUG
        IF (debugMode) CALL DEBUG_CALL('OCN_EXPORT_DATA',myThid)
# endif
         CALL TIMER_START('OCN_EXPORT_DATA [DO_OCEANIC_PHYS]', myThid)
         CALL OCN_EXPORT_DATA( myTime, myIter, myThid )
         CALL TIMER_STOP ('OCN_EXPORT_DATA [DO_OCEANIC_PHYS]', myThid)
      ENDIF
#endif /* ALLOW_OCN_COMPON_INTERF & ALLOW_THSICE */

#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE sst, sss          = comlev1, key=ikey_dynamics, kind=isbyte
CADJ STORE qsw               = comlev1, key=ikey_dynamics, kind=isbyte
# ifdef ALLOW_SEAICE
CADJ STORE area              = comlev1, key=ikey_dynamics, kind=isbyte
# endif
#endif

#ifdef ALLOW_SHELFICE
      IF ( useShelfIce .AND. fluidIsWater ) THEN
#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE salt, theta       = comlev1, key=ikey_dynamics, kind=isbyte
CADJ STORE uvel, vvel        = comlev1, key=ikey_dynamics, kind=isbyte
#endif
#ifdef ALLOW_STEEP_ICECAVITY
       IF ( useSTIC ) THEN
# ifdef ALLOW_DEBUG
        IF (debugMode) CALL DEBUG_CALL('STIC_THERMODYNAMICS',myThid)
# endif
C     use stic_thermodynamics that includes icefront melt processes
        CALL TIMER_START('STIC_THERMODYNAMICS [DO_OCEANIC_PHYS]',myThid)
        CALL STIC_THERMODYNAMICS( myTime, myIter, myThid )
        CALL TIMER_STOP ('STIC_THERMODYNAMICS [DO_OCEANIC_PHYS]',myThid)
       ELSE
#else
       IF ( .TRUE. ) THEN
#endif
#ifdef ALLOW_DEBUG
        IF (debugMode) CALL DEBUG_CALL('SHELFICE_THERMODYNAMICS',myThid)
#endif
C     compute temperature and (virtual) salt flux at the
C     shelf-ice ocean interface
        CALL TIMER_START('SHELFICE_THERMODYNAMICS [DO_OCEANIC_PHYS]',
     &       myThid)
        CALL SHELFICE_THERMODYNAMICS( myTime, myIter, myThid )
        CALL TIMER_STOP ('SHELFICE_THERMODYNAMICS [DO_OCEANIC_PHYS]',
     &       myThid)
       ENDIF
      ENDIF
#endif /* ALLOW_SHELFICE */

#ifdef ALLOW_ICEFRONT
      IF ( useICEFRONT .AND. fluidIsWater ) THEN
#ifdef ALLOW_DEBUG
       IF (debugMode) CALL DEBUG_CALL('ICEFRONT_THERMODYNAMICS',myThid)
#endif
C     compute temperature and (virtual) salt flux at the
C     ice-front ocean interface
       CALL TIMER_START('ICEFRONT_THERMODYNAMICS [DO_OCEANIC_PHYS]',
     &       myThid)
       CALL ICEFRONT_THERMODYNAMICS( myTime, myIter, myThid )
       CALL TIMER_STOP( 'ICEFRONT_THERMODYNAMICS [DO_OCEANIC_PHYS]',
     &      myThid)
      ENDIF
#endif /* ALLOW_ICEFRONT */

#ifdef ALLOW_SALT_PLUME
      IF ( useSALT_PLUME ) THEN
Catn: exchanging saltPlumeFlux:
        CALL SALT_PLUME_DO_EXCH( myTime, myIter, myThid )
      ENDIF
#endif /* ALLOW_SALT_PLUME */

C--   Freeze water at the surface
      IF ( allowFreezing ) THEN
#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE theta             = comlev1, key=ikey_dynamics, kind=isbyte
#endif
        CALL FREEZE_SURFACE( myTime, myIter, myThid )
      ENDIF

      iMin = 1-OLx
      iMax = sNx+OLx
      jMin = 1-OLy
      jMax = sNy+OLy

C---  Determines forcing terms based on external fields
C     relaxation terms, etc.
#ifdef ALLOW_AUTODIFF
# ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE salt, theta       = comlev1, key=ikey_dynamics, kind=isbyte
# endif
#else  /* ALLOW_AUTODIFF */
C--   if fluid is not water, by-pass surfaceForcing, find_rho, gmredi
C     and all vertical mixing schemes, but keep OBCS_CALC
      IF ( fluidIsWater ) THEN
#endif /* ALLOW_AUTODIFF */
#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_CALL('EXTERNAL_FORCING_SURF',myThid)
#endif
        CALL EXTERNAL_FORCING_SURF(
     I             iMin, iMax, jMin, jMax,
     I             myTime, myIter, myThid )
#ifdef ALLOW_AUTODIFF_TAMC
C     Avoid calling S/R EXTERNAL_FORCING_SURF in AD routine.
CADJ STORE EmPmR             = comlev1, key=ikey_dynamics, kind=isbyte
CADJ STORE uvel, vvel        = comlev1, key=ikey_dynamics, kind=isbyte
#endif

#ifdef  ALLOW_OBCS
      IF (useOBCS) THEN
C--   After all surface fluxes are known apply balancing fluxes and
C--   apply tidal forcing to open boundaries
# ifdef ALLOW_DEBUG
       IF (debugMode) CALL DEBUG_CALL('OBCS_ADJUST',myThid)
# endif
       CALL OBCS_ADJUST(
     I      myTime+deltaTClock, myIter+1, myThid )
      ENDIF
#endif  /* ALLOW_OBCS */

#ifdef ALLOW_AUTODIFF_TAMC
C--   HPF directive to help TAF
CHPF$ INDEPENDENT
#endif /* ALLOW_AUTODIFF_TAMC */
      DO bj=myByLo(myThid),myByHi(myThid)
#ifdef ALLOW_AUTODIFF_TAMC
C--   HPF directive to help TAF
CHPF$ INDEPENDENT
#endif /* ALLOW_AUTODIFF_TAMC */
       DO bi=myBxLo(myThid),myBxHi(myThid)

#ifdef ALLOW_AUTODIFF_TAMC
        tkey = bi + (bj-1)*nSx + (ikey_dynamics-1)*nSx*nSy
#endif /* ALLOW_AUTODIFF_TAMC */

C--   Set up work arrays with valid (i.e. not NaN) values
C     These inital values do not alter the numerical results. They
C     just ensure that all memory references are to valid floating
C     point numbers. This prevents spurious hardware signals due to
C     uninitialised but inert locations.
        DO k=1,Nr
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
C This is currently used by GMRedi, IVDC, MXL-depth  and Diagnostics
           sigmaX(i,j,k) = 0. _d 0
           sigmaY(i,j,k) = 0. _d 0
           sigmaR(i,j,k) = 0. _d 0
          ENDDO
         ENDDO
        ENDDO

        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          rhoKm1 (i,j)   = 0. _d 0
          rhoKp1 (i,j)   = 0. _d 0
         ENDDO
        ENDDO
#ifdef ALLOW_AUTODIFF
cph all the following init. are necessary for TAF
cph although some of these are re-initialised later.
        DO k=1,Nr
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           rhoInSitu(i,j,k,bi,bj) = 0.
# ifdef ALLOW_GGL90
           GGL90viscArU(i,j,k,bi,bj)  = 0. _d 0
           GGL90viscArV(i,j,k,bi,bj)  = 0. _d 0
           GGL90diffKr(i,j,k,bi,bj)  = 0. _d 0
# endif /* ALLOW_GGL90 */
# ifdef ALLOW_SALT_PLUME
#  ifdef SALT_PLUME_VOLUME
           SPforcingS(i,j,k,bi,bj) = 0. _d 0
           SPforcingT(i,j,k,bi,bj) = 0. _d 0
#  endif
# endif /* ALLOW_SALT_PLUME */
          ENDDO
         ENDDO
        ENDDO
#ifdef ALLOW_OFFLINE
       IF ( calcConvect ) THEN
#endif
        DO k=1,Nr
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           IVDConvCount(i,j,k,bi,bj) = 0.
          ENDDO
         ENDDO
        ENDDO
#ifdef ALLOW_OFFLINE
       ENDIF
       IF ( calcGMRedi ) THEN
#endif
# ifdef ALLOW_GMREDI
        DO k=1,Nr
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           Kwx(i,j,k,bi,bj)  = 0. _d 0
           Kwy(i,j,k,bi,bj)  = 0. _d 0
           Kwz(i,j,k,bi,bj)  = 0. _d 0
           Kux(i,j,k,bi,bj)  = 0. _d 0
           Kvy(i,j,k,bi,bj)  = 0. _d 0
#  ifdef GM_EXTRA_DIAGONAL
           Kuz(i,j,k,bi,bj)  = 0. _d 0
           Kvz(i,j,k,bi,bj)  = 0. _d 0
#  endif
#  ifdef GM_BOLUS_ADVEC
           GM_PsiX(i,j,k,bi,bj)  = 0. _d 0
           GM_PsiY(i,j,k,bi,bj)  = 0. _d 0
#  endif
#  ifdef GM_VISBECK_VARIABLE_K
           VisbeckK(i,j,bi,bj)   = 0. _d 0
#  endif
          ENDDO
         ENDDO
        ENDDO
# endif /* ALLOW_GMREDI */
#ifdef ALLOW_OFFLINE
       ENDIF
       IF ( calcKPP ) THEN
#endif
# ifdef ALLOW_KPP
        DO k=1,Nr
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           KPPdiffKzS(i,j,k,bi,bj)  = 0. _d 0
           KPPdiffKzT(i,j,k,bi,bj)  = 0. _d 0
          ENDDO
         ENDDO
        ENDDO
# endif /* ALLOW_KPP */
#ifdef ALLOW_OFFLINE
       ENDIF
#endif
#endif /* ALLOW_AUTODIFF */

#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE theta(:,:,:,bi,bj)     = comlev1_bibj, key=tkey, kind=isbyte
CADJ STORE salt (:,:,:,bi,bj)     = comlev1_bibj, key=tkey, kind=isbyte
CADJ STORE totphihyd(:,:,:,bi,bj) = comlev1_bibj, key=tkey, kind=isbyte
# ifdef ALLOW_KPP
CADJ STORE uvel (:,:,:,bi,bj)     = comlev1_bibj, key=tkey, kind=isbyte
CADJ STORE vvel (:,:,:,bi,bj)     = comlev1_bibj, key=tkey, kind=isbyte
# endif
#endif /* ALLOW_AUTODIFF_TAMC */

C--   Always compute density (stored in common block) here; even when it is not
C     needed here, will be used anyway in calc_phi_hyd (data flow easier this way)
#ifdef ALLOW_DEBUG
        IF (debugMode) CALL DEBUG_CALL('FIND_RHO_2D (xNr)',myThid)
#endif
#ifdef ALLOW_AUTODIFF
        IF ( fluidIsWater ) THEN
#endif /* ALLOW_AUTODIFF */
#ifdef ALLOW_DOWN_SLOPE
         IF ( useDOWN_SLOPE ) THEN
           DO k=1,Nr
            CALL DWNSLP_CALC_RHO(
     I                  theta, salt,
     O                  rhoInSitu(1-OLx,1-OLy,k,bi,bj),
     I                  k, bi, bj, myTime, myIter, myThid )
           ENDDO
         ENDIF
#endif /* ALLOW_DOWN_SLOPE */
#ifdef ALLOW_BBL
         IF ( useBBL ) THEN
C     pkg/bbl requires in-situ bbl density for depths equal to and deeper
C     than the bbl. To reduce computation and storage requirement,
C     these densities are stored in the dry grid boxes of rhoInSitu.
C     See BBL_CALC_RHO for details.
           DO k=Nr,1,-1
            CALL BBL_CALC_RHO(
     I                  theta, salt,
     O                  rhoInSitu,
     I                  k, bi, bj, myTime, myIter, myThid )

           ENDDO
         ENDIF
#endif /* ALLOW_BBL */
         IF ( .NOT. ( useDOWN_SLOPE .OR. useBBL ) ) THEN
           DO k=1,Nr
            CALL FIND_RHO_2D(
     I                iMin, iMax, jMin, jMax, k,
     I                theta(1-OLx,1-OLy,k,bi,bj),
     I                salt (1-OLx,1-OLy,k,bi,bj),
     O                rhoInSitu(1-OLx,1-OLy,k,bi,bj),
     I                k, bi, bj, myThid )
           ENDDO
         ENDIF
#ifdef ALLOW_AUTODIFF
        ELSE
C-        fluid is not water:
          DO k=1,Nr
           IF ( select_rStar.GE.1 .OR. selectSigmaCoord.GE.1 ) THEN
C-    isothermal (theta=const) reference state
             thetaRef = thetaConst
           ELSE
C-    horizontally uniform (tRef) reference state
             thetaRef = tRef(k)
           ENDIF
           DO j=1-OLy,sNy+OLy
            DO i=1-OLx,sNx+OLx
             rhoInSitu(i,j,k,bi,bj) =
     &         ( theta(i,j,k,bi,bj)
     &              *( salt(i,j,k,bi,bj)*atm_Rq + oneRL )
     &         - thetaRef )*maskC(i,j,k,bi,bj)
            ENDDO
           ENDDO
          ENDDO
        ENDIF
# ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE rhoInSitu(:,:,:,bi,bj) = comlev1_bibj, key=tkey, kind=isbyte
# endif
#endif /* ALLOW_AUTODIFF */

#ifdef ALLOW_DEBUG
        IF (debugMode) THEN
          WRITE(msgBuf,'(A,2(I4,A))')
     &         'ENTERING UPWARD K LOOP (bi=', bi, ', bj=', bj,')'
          CALL DEBUG_MSG(msgBuf(1:43),myThid)
        ENDIF
#endif

C--     Start of diagnostic loop
        DO k=Nr,1,-1

C--       Calculate gradients of potential density for isoneutral
C         slope terms (e.g. GM/Redi tensor or IVDC diffusivity)
          IF ( calcGMRedi .OR. (k.GT.1 .AND. calcConvect)
     &         .OR. usePP81 .OR. useKL10
     &         .OR. useMY82 .OR. useGGL90
     &         .OR. useSALT_PLUME .OR. doDiagsRho.GE.1 ) THEN
            IF (k.GT.1) THEN
             IF ( usingZCoords ) THEN
              DO j=jMin,jMax
               DO i=iMin,iMax
                rhoKp1(i,j) = rhoInSitu(i,j,k,bi,bj)
               ENDDO
              ENDDO
              CALL FIND_RHO_2D(
     I                 iMin, iMax, jMin, jMax, k,
     I                 theta(1-OLx,1-OLy,k-1,bi,bj),
     I                 salt (1-OLx,1-OLy,k-1,bi,bj),
     O                 rhoKm1,
     I                 k-1, bi, bj, myThid )
             ELSE
              CALL FIND_RHO_2D(
     I                 iMin, iMax, jMin, jMax, k-1,
     I                 theta(1-OLx,1-OLy,k,bi,bj),
     I                 salt (1-OLx,1-OLy,k,bi,bj),
     O                 rhoKp1,
     I                 k, bi, bj, myThid )
              DO j=jMin,jMax
               DO i=iMin,iMax
                rhoKm1(i,j) = rhoInSitu(i,j,k-1,bi,bj)
               ENDDO
              ENDDO
             ENDIF
            ENDIF
#ifdef ALLOW_DEBUG
            IF (debugMode) CALL DEBUG_CALL('GRAD_SIGMA',myThid)
#endif
            CALL GRAD_SIGMA(
     I             bi, bj, iMin, iMax, jMin, jMax, k,
     I             rhoInSitu(1-OLx,1-OLy,k,bi,bj), rhoKm1, rhoKp1,
     O             sigmaX, sigmaY, sigmaR,
     I             myThid )

#ifdef ALLOW_LEITH_QG
            DO j=jMin,jMax
             DO i=iMin,iMax
              sigmaRfield(i,j,k,bi,bj)=sigmaR(i,j,k)
             ENDDO
            ENDDO
#endif /* ALLOW_LEITH_QG */

#ifdef ALLOW_AUTODIFF
#ifdef GMREDI_WITH_STABLE_ADJOINT
cgf zero out adjoint fields to stabilize pkg/gmredi adjoint
cgf -> cuts adjoint dependency from slope to state
            CALL ZERO_ADJ_LOC( Nr, sigmaX, myThid)
            CALL ZERO_ADJ_LOC( Nr, sigmaY, myThid)
            CALL ZERO_ADJ_LOC( Nr, sigmaR, myThid)
#endif
#endif /* ALLOW_AUTODIFF */
          ENDIF

C--       Implicit Vertical Diffusion for Convection
          IF (k.GT.1 .AND. calcConvect) THEN
#ifdef ALLOW_DEBUG
            IF (debugMode) CALL DEBUG_CALL('CALC_IVDC',myThid)
#endif
            CALL CALC_IVDC(
     I        bi, bj, iMin, iMax, jMin, jMax, k,
     I        sigmaR,
     I        myTime, myIter, myThid)
          ENDIF

#ifdef ALLOW_DIAGNOSTICS
          IF ( doDiagsRho.GE.4 ) THEN
            CALL DIAGS_RHO_L( doDiagsRho, k, bi, bj,
     I                        rhoInSitu(1-OLx,1-OLy,1,bi,bj),
     I                        rhoKm1, wVel,
     I                        myTime, myIter, myThid )
          ENDIF
#endif

C--     end of diagnostic k loop (Nr:1)
        ENDDO

#ifdef ALLOW_AUTODIFF_TAMC
C     Avoid recomputing sigmaR and IVDConvCount in AD routine.
CADJ STORE sigmaR                   =comlev1_bibj,key=tkey,kind=isbyte
CADJ STORE IVDConvCount(:,:,:,bi,bj)=comlev1_bibj,key=tkey,kind=isbyte
#endif

C--     Diagnose Mixed Layer Depth:
        IF ( calcGMRedi .OR. MOD(doDiagsRho,2).EQ.1 ) THEN
          CALL CALC_OCE_MXLAYER(
     I              rhoInSitu(1-OLx,1-OLy,kSrf,bi,bj), sigmaR,
     I              bi, bj, myTime, myIter, myThid )
        ENDIF

#ifdef ALLOW_SALT_PLUME
        IF ( useSALT_PLUME ) THEN
          CALL SALT_PLUME_CALC_DEPTH(
     I              rhoInSitu(1-OLx,1-OLy,kSrf,bi,bj), sigmaR,
     I              bi, bj, myTime, myIter, myThid )
#ifdef SALT_PLUME_VOLUME
          CALL SALT_PLUME_VOLFRAC(
     I              bi, bj, myTime, myIter, myThid )
C-- get forcings for kpp
          CALL SALT_PLUME_APPLY(
     I              1, bi, bj, recip_hFacC(1-OLx,1-OLy,kSrf,bi,bj),
     I              theta, 0,
     I              myTime, myIter, myThid )
          CALL SALT_PLUME_APPLY(
     I              2, bi, bj, recip_hFacC(1-OLx,1-OLy,kSrf,bi,bj),
     I              salt, 0,
     I              myTime, myIter, myThid )
C-- need to call this S/R from here to apply just before kpp
          CALL SALT_PLUME_FORCING_SURF(
     I              bi, bj, iMin, iMax, jMin, jMax,
     I              myTime, myIter, myThid )
#endif /* SALT_PLUME_VOLUME */
        ENDIF
# ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE saltplumedepth(:,:,bi,bj)= comlev1_bibj,key=tkey,kind=isbyte
CADJ STORE saltplumeflux(:,:,bi,bj) = comlev1_bibj,key=tkey,kind=isbyte
# endif /* ALLOW_AUTODIFF_TAMC */
#endif /* ALLOW_SALT_PLUME */

#ifdef ALLOW_DIAGNOSTICS
        IF ( MOD(doDiagsRho,4).GE.2 ) THEN
          CALL DIAGNOSTICS_FILL (sigmaR, 'DRHODR  ', 0, Nr,
     &         2, bi, bj, myThid)
        ENDIF
#endif /* ALLOW_DIAGNOSTICS */

C--    This is where EXTERNAL_FORCING_SURF(bi,bj) used to be called;
C      now called earlier, before bi,bj loop.

#ifdef ALLOW_AUTODIFF_TAMC
cph needed for KPP
CADJ STORE surfaceForcingU(:,:,bi,bj)=comlev1_bibj,key=tkey,kind=isbyte
CADJ STORE surfaceForcingV(:,:,bi,bj)=comlev1_bibj,key=tkey,kind=isbyte
CADJ STORE surfaceForcingS(:,:,bi,bj)=comlev1_bibj,key=tkey,kind=isbyte
CADJ STORE surfaceForcingT(:,:,bi,bj)=comlev1_bibj,key=tkey,kind=isbyte
#endif /* ALLOW_AUTODIFF_TAMC */

#ifdef  ALLOW_KPP
C--     Compute KPP mixing coefficients
        IF ( calcKPP ) THEN
#ifdef ALLOW_DEBUG
          IF (debugMode) CALL DEBUG_CALL('KPP_CALC',myThid)
#endif
          CALL TIMER_START('KPP_CALC [DO_OCEANIC_PHYS]', myThid)
          CALL KPP_CALC(
     I                  bi, bj, myTime, myIter, myThid )
          CALL TIMER_STOP ('KPP_CALC [DO_OCEANIC_PHYS]', myThid)
#if (defined ALLOW_AUTODIFF) && !(defined ALLOW_OFFLINE)
        ELSE
          CALL KPP_CALC_DUMMY(
     I                  bi, bj, myTime, myIter, myThid )
#endif /* ALLOW_AUTODIFF and not ALLOW_OFFLINE */
        ENDIF
#endif  /* ALLOW_KPP */

#ifdef  ALLOW_PP81
C--     Compute PP81 mixing coefficients
        IF (usePP81) THEN
#ifdef ALLOW_DEBUG
          IF (debugMode) CALL DEBUG_CALL('PP81_CALC',myThid)
#endif
          CALL PP81_CALC(
     I                     bi, bj, sigmaR, myTime, myIter, myThid )
        ENDIF
#endif /* ALLOW_PP81 */

#ifdef  ALLOW_KL10
C--     Compute KL10 mixing coefficients
        IF (useKL10) THEN
#ifdef ALLOW_DEBUG
          IF (debugMode) CALL DEBUG_CALL('KL10_CALC',myThid)
#endif
          CALL KL10_CALC(
     I                     bi, bj, sigmaR, myTime, myIter, myThid )
        ENDIF
#endif /* ALLOW_KL10 */

#ifdef  ALLOW_MY82
C--     Compute MY82 mixing coefficients
        IF (useMY82) THEN
#ifdef ALLOW_DEBUG
          IF (debugMode) CALL DEBUG_CALL('MY82_CALC',myThid)
#endif
          CALL MY82_CALC(
     I                     bi, bj, sigmaR, myTime, myIter, myThid )
        ENDIF
#endif /* ALLOW_MY82 */

#ifdef  ALLOW_GGL90
#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE GGL90TKE(:,:,:,bi,bj) = comlev1_bibj, key=tkey, kind=isbyte
#endif /* ALLOW_AUTODIFF_TAMC */
C--     Compute GGL90 mixing coefficients
        IF ( useGGL90 .AND. Nr.GT.1 ) THEN
#ifdef ALLOW_DEBUG
          IF (debugMode) CALL DEBUG_CALL('GGL90_CALC',myThid)
#endif
          CALL TIMER_START('GGL90_CALC [DO_OCEANIC_PHYS]', myThid)
          CALL GGL90_CALC(
     I                     bi, bj, sigmaR, myTime, myIter, myThid )
          CALL TIMER_STOP ('GGL90_CALC [DO_OCEANIC_PHYS]', myThid)
        ENDIF
#endif /* ALLOW_GGL90 */

#ifdef ALLOW_GMREDI
#ifdef ALLOW_AUTODIFF_TAMC
# ifndef GM_EXCLUDE_CLIPPING
cph storing here is needed only for one GMREDI_OPTIONS:
cph define GM_BOLUS_ADVEC
cph keep it although TAF says you dont need to.
cph but I have avoided the #ifdef for now, in case more things change
CADJ STORE sigmaX(:,:,:) = comlev1_bibj, key = tkey, kind = isbyte
CADJ STORE sigmaY(:,:,:) = comlev1_bibj, key = tkey, kind = isbyte
CADJ STORE sigmaR(:,:,:) = comlev1_bibj, key = tkey, kind = isbyte
# endif
#endif /* ALLOW_AUTODIFF_TAMC */

C--     Calculate iso-neutral slopes for the GM/Redi parameterisation
        IF ( calcGMRedi ) THEN
#ifdef ALLOW_DEBUG
          IF (debugMode) CALL DEBUG_CALL('GMREDI_CALC_TENSOR',myThid)
#endif
          CALL GMREDI_CALC_TENSOR(
     I             iMin, iMax, jMin, jMax,
     I             sigmaX, sigmaY, sigmaR,
     I             bi, bj, myTime, myIter, myThid )
#if (defined ALLOW_AUTODIFF) && !(defined ALLOW_OFFLINE)
        ELSE
          CALL GMREDI_CALC_TENSOR_DUMMY(
     I             iMin, iMax, jMin, jMax,
     I             sigmaX, sigmaY, sigmaR,
     I             bi, bj, myTime, myIter, myThid )
#endif /* ALLOW_AUTODIFF and not ALLOW_OFFLINE */
        ENDIF
#endif /* ALLOW_GMREDI */

#ifdef ALLOW_DOWN_SLOPE
        IF ( useDOWN_SLOPE ) THEN
C--     Calculate Downsloping Flow for Down_Slope parameterization
         IF ( usingPCoords ) THEN
          CALL DWNSLP_CALC_FLOW(
     I                bi, bj, kSurfC, rhoInSitu,
     I                myTime, myIter, myThid )
         ELSE
          CALL DWNSLP_CALC_FLOW(
     I                bi, bj, kLowC, rhoInSitu,
     I                myTime, myIter, myThid )
         ENDIF
        ENDIF
#endif /* ALLOW_DOWN_SLOPE */

C--   end bi,bj loops.
       ENDDO
      ENDDO

#ifndef ALLOW_AUTODIFF
C---  if fluid Is Water: end
      ENDIF
#endif

#ifdef ALLOW_OFFLINE
      IF ( useOffLine ) THEN
#ifdef ALLOW_DEBUG
        IF (debugMode) CALL DEBUG_CALL('OFFLINE_GET_DIFFUS',myThid)
#endif /* ALLOW_DEBUG */
        CALL OFFLINE_GET_DIFFUS( myTime, myIter, myThid )
      ENDIF
#endif /* ALLOW_OFFLINE */

#ifdef ALLOW_BBL
      IF ( useBBL ) THEN
       CALL BBL_CALC_RHS(
     I                          myTime, myIter, myThid )
      ENDIF
#endif /* ALLOW_BBL */

#ifdef ALLOW_MYPACKAGE
      IF ( useMYPACKAGE ) THEN
       CALL MYPACKAGE_CALC_RHS(
     I                          myTime, myIter, myThid )
      ENDIF
#endif /* ALLOW_MYPACKAGE */

#ifdef ALLOW_GMREDI
      IF ( calcGMRedi ) THEN
        CALL GMREDI_DO_EXCH( myTime, myIter, myThid )
      ENDIF
#endif /* ALLOW_GMREDI */

#ifdef ALLOW_KPP
      IF ( calcKPP ) THEN
        CALL KPP_DO_EXCH( myThid )
      ENDIF
#endif /* ALLOW_KPP */

#ifdef ALLOW_GGL90
      IF ( useGGL90 )
     &  CALL GGL90_EXCHANGES( myThid )
#endif /* ALLOW_GGL90 */

#ifdef ALLOW_DIAGNOSTICS
      IF ( fluidIsWater .AND. useDiagnostics ) THEN
        CALL DIAGS_RHO_G(
     I                    rhoInSitu, uVel, vVel, wVel,
     I                    myTime, myIter, myThid )
      ENDIF
      IF ( useDiagnostics ) THEN
        CALL DIAGS_OCEANIC_SURF_FLUX( myTime, myIter, myThid )
      ENDIF
      IF ( calcConvect .AND. useDiagnostics ) THEN
        CALL DIAGNOSTICS_FILL( IVDConvCount, 'CONVADJ ',
     &                               0, Nr, 0, 1, 1, myThid )
      ENDIF
#ifdef ALLOW_SALT_PLUME
      IF ( useDiagnostics )
     &      CALL SALT_PLUME_DIAGNOSTICS_FILL(bi,bj,myThid)
#endif
#endif

#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_LEAVE('DO_OCEANIC_PHYS',myThid)
#endif

      RETURN
      END

#include "STREAMICE_OPTIONS.h"

      MODULE STREAMICE_ARG_PETSC_mod
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#ifdef ALLOW_STREAMICE
#ifdef ALLOW_PETSC
#ifdef STREAMICE_PETSC_3_8

C     THE FOLLOWING VARIABLES ARE OF DEFINED TYPES IN THE PETSC
C     LIBRARY, USED BY STREAMICE WHEN AVAILABLE TO ACCELERATE
C     SOLVES OF LINEAR SYSTEMS

C     THE STORING OF PETSC OBJECTS IN COMMON BLOCKS IS
C     FORBIDDEN BY PETSC 3.8.x AND ABOVE, SO A MODULE IS USED

#include "petsc/finclude/petsc.h"
#include "petsc/finclude/petscvec.h"
      use petscvec
#include "petsc/finclude/petscmat.h"
      use petscmat
#include "petsc/finclude/petscksp.h"
      use petscksp
#include "petsc/finclude/petscpc.h"
      use petscpc

      Mat matrix
      Mat mumpsFac
      KSP ksp
      PC  pc

#endif /* ALLOW_STREAMICE */
#endif
#endif
       END MODULE

CEH3 ;;; Local Variables: ***
CEH3 ;;; mode:fortran ***
CEH3 ;;; End: ***

#include "KPP_OPTIONS.h"

CBOP
C     !ROUTINE: KPP_DO_EXCH
C     !INTERFACE:
      SUBROUTINE KPP_DO_EXCH( myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE KPP_DO_EXCH
C     | o fill overlap regions of KPP arrays by calling exchanges
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
c#include "PARAMS.h"
c#include "KPP_PARAMS.h"
#include "KPP.h"

C     !INPUT/OUTPUT PARAMETERS:
C     myThid    :: My Thread Id number
      INTEGER myThid

#ifdef ALLOW_KPP
C     !LOCAL VARIABLES:
CEOP

#ifndef ALLOW_AUTODIFF
      CALL EXCH_3D_RL( KPPviscAz, Nr, myThid )
#else
      _EXCH_XYZ_RL( KPPviscAz, myThid )
#endif

#endif /* ALLOW_KPP */

      RETURN
      END

#include "MOM_FLUXFORM_OPTIONS.h"

CBOP
C !ROUTINE: MOM_UV_BOUNDARY

C !INTERFACE: ==========================================================
      SUBROUTINE MOM_UV_BOUNDARY (
     I               bi,bj,k,
     I               uFld, vFld,
     O               uBnd, vBnd,
     I               myTime, myIter, myThid )

C !DESCRIPTION:
C Set velocity at a boundary for a momentum conserving advection
C  Note: really conserve momentum when "steps" (vertical plane)
C  or coastline (horizontal plane) are only 1 grid-point wide.

C !USES: ===============================================================
C     == Global variables ==
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"

C !INPUT PARAMETERS: ===================================================
C  bi,bj          :: tile indices
C  k              :: vertical level
C  uFld           :: zonal      velocity
C  vFld           :: meridional velocity
C  myTime         :: current time
C  myIter         :: current iteration number
C  myThid         :: My Thread Id. number
      INTEGER bi,bj
      INTEGER k
      _RL uFld(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      _RL vFld(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      _RL     myTime
      INTEGER myIter
      INTEGER myThid

C !OUTPUT PARAMETERS: ==================================================
C  uBnd           :: zonal      velocity extended to boundaries
C  vBnd           :: meridional velocity extended to boundaries
      _RL uBnd(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL vBnd(1-OLx:sNx+OLx,1-OLy:sNy+OLy)

#ifdef MOM_BOUNDARY_CONSERVE
C !LOCAL VARIABLES: ====================================================
C  i,j            :: loop indices
      INTEGER i,j
      INTEGER km1,kp1
      _RL maskM1, maskP1
      _RL uTrans(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL vTrans(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL  aBndU(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL  aBndV(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL  aBndW(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL tmpVar
      LOGICAL useMomBndConserve
      PARAMETER ( useMomBndConserve = .TRUE. )
CEOP

C     Initialise output array
      DO j=1-OLy,sNy+OLy
       DO i=1-OLx,sNx+OLx
         uBnd(i,j) = uFld(i,j,k,bi,bj)
         vBnd(i,j) = vFld(i,j,k,bi,bj)
       ENDDO
      ENDDO

      IF ( useMomBndConserve ) THEN

C-    Initialise intermediate arrays:
        km1 = MAX( k-1, 1 )
        kp1 = MIN( k+1, Nr )
        maskM1 = 1.
        maskP1 = 1.
        IF ( k.EQ.1  ) maskM1 = 0.
        IF ( k.EQ.Nr ) maskP1 = 0.
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          aBndU(i,j) = 0.
          aBndV(i,j) = 0.
          aBndW(i,j) = 0.
         ENDDO
        ENDDO

C-      Calculate Divergence in 3 directions:
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          uTrans(i,j) = uFld(i,j,k,bi,bj)
     &                * dyG(i,j,bi,bj)*deepFacC(k)
     &                * drF(k)*hFacW(i,j,k,bi,bj)*rhoFacC(k)
          vTrans(i,j) = vFld(i,j,k,bi,bj)
     &                * dxG(i,j,bi,bj)*deepFacC(k)
     &                * drF(k)*hFacS(i,j,k,bi,bj)*rhoFacC(k)
         ENDDO
        ENDDO
        DO j=1-OLy,sNy+OLy-1
         DO i=1-OLx,sNx+OLx-1
          aBndU(i,j) = uTrans(i+1,j)-uTrans(i,j)
          aBndV(i,j) = vTrans(i,j+1)-vTrans(i,j)
          aBndW(i,j) = ABS(aBndU(i,j)+aBndV(i,j))
          aBndU(i,j) = ABS(aBndU(i,j))
          aBndV(i,j) = ABS(aBndV(i,j))
         ENDDO
        ENDDO
C-      Normalise by the sum:
        DO j=1-OLy,sNy+OLy-1
         DO i=1-OLx,sNx+OLx-1
          tmpVar = aBndU(i,j)+aBndV(i,j)+aBndW(i,j)
          IF ( tmpVar.GT.0. ) THEN
            tmpVar = 1. _d 0 / tmpVar
            aBndU(i,j) = aBndU(i,j)*tmpVar
            aBndV(i,j) = aBndV(i,j)*tmpVar
            aBndW(i,j) = aBndW(i,j)*tmpVar
          ENDIF
         ENDDO
        ENDDO

C-      At a boundary, replace uFld,vFld by a weighted average
C       Note: multiply by 2 to cancel the 1/2 factor in advections S/R
        DO j=1-OLy+1,sNy+OLy-1
         DO i=1-OLx+1,sNx+OLx-1
          IF (maskW(i,j,k,bi,bj).EQ.0.) THEN
C       Note: only 1 set of aBnd_U,V,W is non-zero (either i-1 or i)
C        and  only 1 uFld is non-zero (either i-1 or i+1)
C        and  only 1 uFld is non-zero (either k-1 or k+1)
            uBnd(i,j) = (
     &        (aBndU(i-1,j)+aBndU(i,j))
     &                     *(uFld(i-1,j,k,bi,bj)+uFld(i+1,j,k,bi,bj))
     &       +(aBndV(i-1,j)+aBndV(i,j))
     &                     *(uFld(i,j-1,k,bi,bj)+uFld(i,j+1,k,bi,bj))
     &       +(aBndW(i-1,j)+aBndW(i,j))
     &                     *(uFld(i,j,km1,bi,bj)*maskM1
     &                      +uFld(i,j,kp1,bi,bj)*maskP1)
     &                  )*2. _d 0
          ENDIF
          IF (maskS(i,j,k,bi,bj).EQ.0.) THEN
C       Note: only 1 set of aBnd_U,V,W is non-zero (either j-1 or j)
C        and  only 1 vFld is non-zero (either j-1 or j+1)
C        and  only 1 vFld is non-zero (either k-1 or k+1)
            vBnd(i,j) = (
     &        (aBndU(i,j-1)+aBndU(i,j))
     &                     *(vFld(i-1,j,k,bi,bj)+vFld(i+1,j,k,bi,bj))
     &       +(aBndV(i,j-1)+aBndV(i,j))
     &                     *(vFld(i,j-1,k,bi,bj)+vFld(i,j+1,k,bi,bj))
     &       +(aBndW(i,j-1)+aBndW(i,j))
     &                     *(vFld(i,j,km1,bi,bj)*maskM1
     &                      +vFld(i,j,kp1,bi,bj)*maskP1)
     &                  )*2. _d 0
          ENDIF
         ENDDO
        ENDDO
      ENDIF
#endif /* MOM_BOUNDARY_CONSERVE */

      RETURN
      END

#include "STREAMICE_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 0
C !ROUTINE: STREAMICE_INIT_FIXED

C !INTERFACE:
      SUBROUTINE STREAMICE_INIT_FIXED( myThid )

C     !DESCRIPTION:
C     Initialize STREAMICE variables that are kept fixed during the run.

C     !USES:
      IMPLICIT NONE
#include "EEPARAMS.h"
#include "SIZE.h"
#include "PARAMS.h"
#include "STREAMICE.h"
#include "STREAMICE_FP.h"
#include "STREAMICE_CG.h"
#include "STREAMICE_BDRY.h"
#include "GRID.h"
#ifdef ALLOW_STREAMICE_FLUX_CONTROL
#include "STREAMICE_CTRL_FLUX.h"
#endif

C     myThid ::  my Thread Id number
      INTEGER myThid
CEOP

#ifdef ALLOW_STREAMICE
C     !LOCAL VARIABLES:
C     === Local variables ===
      INTEGER bi, bj, i, j, Gi, Gj, m
      _RL x, y
      CHARACTER*(MAX_LEN_MBUF) msgBuf

#ifdef STREAMICE_GEOM_FILE_SETUP
      INTEGER maskFlag, hmaskFlag
      _RS temp_ufacemask (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RS temp_vfacemask (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RS temp_hmask (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
#endif

#ifdef ALLOW_CTRL
      _RS dummyRS
      INTEGER k
#endif

#ifdef ALLOW_PETSC
      if (streamice_use_petsc) then
      CALL STREAMICE_INITIALIZE_PETSC
      endif
#endif

#ifdef ALLOW_MNC
      IF ( useMNC .AND. (streamice_tave_mnc.OR.streamice_dump_mnc)
     &    ) THEN
C        CALL STREAMICE_MNC_INIT( myThid )
      ENDIF
#endif /* ALLOW_MNC */

#ifdef ALLOW_DIAGNOSTICS
      IF ( useDiagnostics ) THEN
        CALL STREAMICE_INIT_DIAGNOSTICS( myThid )
      ENDIF
#endif

c     CALVING MASK - LIMIT OF ICE SHELF FRONT ADVANCE

      IF ( STREAMICE_calve_to_mask ) THEN
       IF ( STREAMICEcalveMaskFile .NE. ' ') THEN
        _BARRIER
C       The 0 is the "iteration" argument. The ' ' is an empty suffix
        CALL READ_FLD_XY_RS( STREAMICEcalveMaskFile, ' ',
     &   STREAMICE_calve_mask, 0, myThid )
       ELSE
        WRITE(msgBuf,'(A)') 'INIT CALVE MASK - NOT IMPLENTED'
        CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT , 1)

        DO bj = myByLo(myThid), myByHi(myThid)
         DO bi = myBxLo(myThid), myBxHi(myThid)
          DO j=1,sNy
           DO i=1,sNx
            streamice_calve_mask(i,j,bi,bj) = 0. _d 0
           ENDDO
          ENDDO
         ENDDO
        ENDDO

       ENDIF
      ENDIF

c  INITIALIZE SIGMA COORD
      IF (STREAMICEsigcoordInit.eq.'FILE') THEN
       WRITE(msgBuf,'(A)') 'SIG FROM FILE - NOT IMPLENTED'
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT , 1)
      ELSEIF (STREAMICEsigcoordInit.eq.'UNIFORM') THEN
       do m=1,Nr
        streamice_sigma_coord (m) = 1./Nr * (m-0.5)
        streamice_delsigma (m) = 1./Nr
       enddo
      ELSE
       WRITE(msgBuf,'(A)') 'SIG COORD INIT - NOT IMPLENTED'
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT , 1)
      ENDIF

#ifdef ALLOW_COST
       IF ( STREAMICEcostMaskFile .NE. ' ') THEN
        _BARRIER
C       The 0 is the "iteration" argument. The ' ' is an empty suffix
        CALL READ_FLD_XY_RS( STREAMICEcostMaskFile, ' ',
     &   STREAMICE_cost_mask, 0, myThid )
       ELSE
        WRITE(msgBuf,'(A)') 'COST MASK - NOT IMPLENTED'
        CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT , 1)

        DO bj = myByLo(myThid), myByHi(myThid)
         DO bi = myBxLo(myThid), myBxHi(myThid)
          DO j=1,sNy
           DO i=1,sNx
            STREAMICE_cost_mask (i,j,bi,bj) = 1.0
           ENDDO
          ENDDO
         ENDDO
        ENDDO
       ENDIF
#endif
#ifdef ALLOW_STREAMICE_TC_COST
       IF ( STREAMICEBglenCostMaskFile .NE. ' ') THEN
        _BARRIER
C       The 0 is the "iteration" argument. The ' ' is an empty suffix
        CALL READ_FLD_XY_RS( STREAMICEBglenCostMaskFile, ' ',
     &   B_glen0, 0, myThid )
       ELSE
        WRITE(msgBuf,'(A)') 'BGLEN COST MASK - NOT IMPLENTED'
        CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT , 1)

        DO bj = myByLo(myThid), myByHi(myThid)
         DO bi = myBxLo(myThid), myBxHi(myThid)
          DO j=1,sNy
           DO i=1,sNx
            b_glen0 (i,j,bi,bj) = 0.0
           ENDDO
          ENDDO
         ENDDO
        ENDDO
       ENDIF
#endif

c    READ IN FILES FOR BOUNDARY MASKS AND DIRICH VALUES
#ifdef STREAMICE_GEOM_FILE_SETUP

      IF ( STREAMICEuFaceBdryFile .NE. ' ') THEN
        _BARRIER
       CALL READ_FLD_XY_RS ( STREAMICEuFaceBdryFile, ' ',
     &   temp_ufacemask, 0, myThid )
      ELSE
       WRITE(msgBuf,'(A)') 'U FACE MASK - NOT SET'
       CALL PRINT_ERROR( msgBuf, myThid)
      ENDIF

      IF ( STREAMICEvFaceBdryFile .NE. ' ') THEN
        _BARRIER
       CALL READ_FLD_XY_RS ( STREAMICEvFaceBdryFile, ' ',
     &   temp_vfacemask, 0, myThid )
      ELSE
       WRITE(msgBuf,'(A)') 'V FACE MASK - NOT SET'
       CALL PRINT_ERROR( msgBuf, myThid)
      ENDIF

      _EXCH_XY_RS(temp_ufacemask,myThid)
      _EXCH_XY_RS(temp_vfacemask,myThid)

      IF ( STREAMICEuDirichValsFile .NE. ' ') THEN
        _BARRIER
       CALL READ_FLD_XY_RL ( STREAMICEuDirichValsFile, ' ',
#ifdef ALLOW_STREAMICE_FLUX_CONTROL
     &   u_bdry_values_SI_base, 0, myThid )
#else
     &   u_bdry_values_SI, 0, myThid )
#endif
      ELSE
       WRITE(msgBuf,'(A)') 'U DIRICH VALS - NOT SET'
       CALL PRINT_ERROR( msgBuf, myThid)
      ENDIF

      IF ( STREAMICEvDirichValsFile .NE. ' ') THEN
        _BARRIER
       CALL READ_FLD_XY_RL ( STREAMICEvDirichValsFile, ' ',
#ifdef ALLOW_STREAMICE_FLUX_CONTROL
     &   v_bdry_values_SI_base, 0, myThid )
#else
     &   v_bdry_values_SI, 0, myThid )
#endif
      ELSE
       WRITE(msgBuf,'(A)') 'V DIRICH VALS - NOT SET'
       CALL PRINT_ERROR( msgBuf, myThid)
      ENDIF

      IF ( STREAMICEHBCxFile .NE. ' ') THEN
        _BARRIER
       CALL READ_FLD_XY_RL ( STREAMICEHBCxFile, ' ',
     &   h_ubdry_values_SI, 0, myThid )
      ELSE
       WRITE(msgBuf,'(A)') 'THICK BC AT U FACE - NOT SET'
       CALL PRINT_ERROR( msgBuf, myThid)
      ENDIF

      IF ( STREAMICEHBCyFile .NE. ' ') THEN
        _BARRIER
       CALL READ_FLD_XY_RL ( STREAMICEHBCyFile, ' ',
     &   h_vbdry_values_SI, 0, myThid )
      ELSE
       WRITE(msgBuf,'(A)') 'THICK BC AT V FACE - NOT SET'
       CALL PRINT_ERROR( msgBuf, myThid)
      ENDIF

      IF ( streamiceumassfluxfile .NE. ' ') THEN
        _BARRIER
       CALL READ_FLD_XY_RL ( streamiceumassfluxfile , ' ',
     &   u_flux_bdry_SI, 0, myThid )
      ELSE
       WRITE(msgBuf,'(A)') 'MASS FLUX AT U FACE - NOT SET'
       CALL PRINT_ERROR( msgBuf, myThid)
      ENDIF

      IF ( streamicevmassfluxfile .NE. ' ') THEN
        _BARRIER
       CALL READ_FLD_XY_RL ( streamicevmassfluxfile , ' ',
     &   v_flux_bdry_SI, 0, myThid )
      ELSE
       WRITE(msgBuf,'(A)') 'MASS FLUX AT V FACE - NOT SET'
       CALL PRINT_ERROR( msgBuf, myThid)
      ENDIF

#ifdef ALLOW_STREAMICE_2DTRACER

      IF ( STREAMICETrac2dBCxFile .NE. ' ') THEN
        _BARRIER
       CALL READ_FLD_XY_RL ( STREAMICETrac2dBCxFile, ' ',
     &   trac2d_ubdry_values_SI, 0, myThid )
      ELSE
       WRITE(msgBuf,'(A)') 'TRAC BC AT U FACE - NOT SET'
       CALL PRINT_ERROR( msgBuf, myThid)
      ENDIF

      IF ( STREAMICETRAC2DBCyFile .NE. ' ') THEN
        _BARRIER
       CALL READ_FLD_XY_RL ( STREAMICETrac2dBCyFile, ' ',
     &   trac2d_vbdry_values_SI, 0, myThid )
      ELSE
       WRITE(msgBuf,'(A)') 'TRAC BC AT V FACE - NOT SET'
       CALL PRINT_ERROR( msgBuf, myThid)
      ENDIF

#endif

c with this setup hmask is initialized here rather than in init_varia,
c because it is needed to set no-flow boundaries, even though the field
c could potentially change due to ice shelf front advance and calving
c (POTENTIAL PROBLEMS WITH TAF ? USE TEMP FIELD HERE AND SET HMASK IN INIT_VARIA ?)

      IF ( STREAMICEhMaskFile .NE. ' ') THEN
        _BARRIER
       CALL READ_FLD_XY_RS ( STREAMICEhMaskFile, ' ',
     &   temp_hmask, 0, myThid )
      ELSE
       WRITE(msgBuf,'(A)') 'H MASK FILE - NOT SET'
       CALL PRINT_ERROR( msgBuf, myThid)
      ENDIF

      _EXCH_XY_RS(temp_hmask,myThid)

#ifdef ALLOW_CTRL
      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
        DO j=1,sNy
         DO i=1,sNx
          IF (temp_hmask(i,j,bi,bj) .eq. 1.0) THEN
           DO k=1,Nr
           STREAMICE_ctrl_mask(i,j,k,bi,bj) = 1. _d 0
           ENDDO
          ENDIF
         ENDDO
        ENDDO
       ENDDO
      ENDDO
#endif

#ifdef ALLOW_STREAMICE_FLUX_CONTROL
     DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
        DO j=1,sNy
         DO i=1,sNx
          u_bdry_values_SI (i,j,bi,bj) =
     &     u_bdry_values_SI_base (i,j,bi,bj)
          v_bdry_values_SI (i,j,bi,bj) =
     &     v_bdry_values_SI_base (i,j,bi,bj)
         ENDDO
        ENDDO
       ENDDO
      ENDDO
#endif

#endif /* STREAMICE_GEOM_FILE_SETUP */

c!!!!!!!!!!!!!!!!!!!!!!!!

C- fill in the overlap (+ BARRIER):
      _EXCH_XY_RS(STREAMICE_calve_mask, myThid )

      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
        DO j=1,sNy
         DO i=1,sNx

C         INIT VALUES FOR METRIC TERMS

          IF (.not.usingCartesianGrid) THEN

           k1AtC_str(i,j,bi,bj) = recip_rA(i,j,bi,bj) *
     &      (dxG(i+1,j,bi,bj)-dxG(i,j,bi,bj))
           k2AtC_str(i,j,bi,bj) = recip_rA(i,j,bi,bj) *
     &      (dyG(i,j+1,bi,bj)-dyG(i,j,bi,bj))

          ELSE

           k1AtC_str(i,j,bi,bj) = 0. _d 0
           k2AtC_str(i,j,bi,bj) = 0. _d 0

          ENDIF

#ifdef STREAMICE_HYBRID_STRESS
          streamice_basal_geom (i,j,bi,bj) = 1.0
#endif

C         INIT BDRY CONDITIONS

#ifndef STREAMICE_GEOM_FILE_SETUP

          Gi = (myXGlobalLo-1)+(bi-1)*sNx+i
          Gj = (myYGlobalLo-1)+(bj-1)*sNy+j
          x = xC(i,j,bi,bj)
          y = yC(i,j,bi,bj)

          STREAMICE_ufacemask_bdry (i,j,bi,bj) = -1.0
          STREAMICE_vfacemask_bdry (i,j,bi,bj) = -1.0

          IF (Gi.EQ.1 .AND. .NOT. STREAMICE_EW_periodic) THEN
C         INITIALIZE BOUNDARY CONDS AT WEST
           IF ((y .gt. min_y_noflow_WEST) .AND.
     &         (y .le. max_y_noflow_WEST)) THEN
            STREAMICE_ufacemask_bdry (i,j,bi,bj) = 0.0
           ENDIF
           IF ((y .gt. min_y_noStress_WEST) .AND.
     &         (y .le. max_y_noStress_WEST)) THEN
            STREAMICE_ufacemask_bdry (i,j,bi,bj) = 1.0
           ENDIF
           IF ((y .gt. min_y_FluxBdry_WEST) .AND.
     &         (y .le. max_y_FluxBdry_WEST)) THEN
            STREAMICE_ufacemask_bdry (i,j,bi,bj) = 4.0
            u_flux_bdry_SI (i,j,bi,bj) = flux_bdry_val_WEST
           ENDIF
           IF ((y .gt. min_y_Dirich_WEST) .AND.
     &         (y .le. max_y_Dirich_WEST)) THEN
            STREAMICE_ufacemask_bdry (i,j,bi,bj) = 3.0
            u_bdry_values_SI (i,j,bi,bj) = 0.0
           ENDIF
           IF ((y .gt. min_y_CFBC_WEST) .AND.
     &         (y .le. max_y_CFBC_WEST)) THEN
            STREAMICE_ufacemask_bdry (i,j,bi,bj) = 2.0
           ENDIF
          ENDIF

          IF (Gi.EQ.Nx .AND. .NOT. STREAMICE_EW_periodic) THEN
C         INITIALIZE BOUNDARY CONDS AT EAST
           IF ((y .gt. min_y_noflow_EAST) .AND.
     &         (y .le. max_y_noflow_EAST)) THEN
            STREAMICE_ufacemask_bdry (i,j,bi,bj) = 0.0
           ENDIF
           IF ((y .gt. min_y_noStress_EAST) .AND.
     &         (y .le. max_y_noStress_EAST)) THEN
            STREAMICE_ufacemask_bdry (i,j,bi,bj) = 1.0
           ENDIF
           IF ((y .gt. min_y_FluxBdry_EAST) .AND.
     &         (y .le. max_y_FluxBdry_EAST)) THEN
            STREAMICE_ufacemask_bdry (i,j,bi,bj) = 4.0
            u_flux_bdry_SI (i,j,bi,bj) = flux_bdry_val_EAST
           ENDIF
           IF ((y .gt. min_y_Dirich_EAST) .AND.
     &         (y .le. max_y_Dirich_EAST)) THEN
            STREAMICE_ufacemask_bdry (i,j,bi,bj) = 3.0
            u_bdry_values_SI (i,j,bi,bj) = 0. _d 0
           ENDIF
           IF ((y .gt. min_y_CFBC_EAST) .AND.
     &         (y .le. max_y_CFBC_EAST)) THEN
            STREAMICE_ufacemask_bdry (i,j,bi,bj) = 2.0
           ENDIF
          ENDIF

          IF (Gj.EQ.1 .AND. .NOT. STREAMICE_NS_periodic) THEN
C         INITIALIZE BOUNDARY CONDS AT SOUTH
           IF ((x .gt. min_x_noflow_SOUTH) .AND.
     &         (x .le. max_x_noflow_SOUTH)) THEN
            STREAMICE_vfacemask_bdry (i,j,bi,bj) = 0.0
           ENDIF
           IF ((x .gt. min_x_noStress_SOUTH) .AND.
     &         (x .le. max_x_noStress_SOUTH)) THEN
            STREAMICE_vfacemask_bdry (i,j,bi,bj) = 1.0
           ENDIF
           IF ((x .gt. min_x_FluxBdry_SOUTH) .AND.
     &         (x .le. max_x_FluxBdry_SOUTH)) THEN
            STREAMICE_vfacemask_bdry (i,j,bi,bj) = 4.0
            v_flux_bdry_SI (i,j,bi,bj) = flux_bdry_val_SOUTH
           ENDIF
           IF ((x .gt. min_x_Dirich_SOUTH) .AND.
     &         (x .le. max_x_Dirich_SOUTH)) THEN
            STREAMICE_vfacemask_bdry (i,j,bi,bj) = 3.0
            u_bdry_values_SI (i,j,bi,bj) = 0. _d 0
           ENDIF
           IF ((x .gt. min_x_CFBC_SOUTH) .AND.
     &         (x .le. max_x_CFBC_SOUTH)) THEN
            STREAMICE_vfacemask_bdry (i,j,bi,bj) = 2.0
           ENDIF
          ENDIF

          IF (Gj.EQ.Ny .AND. .NOT. STREAMICE_NS_periodic) THEN
C         INITIALIZE BOUNDARY CONDS AT NORTH
           IF ((x .gt. min_x_noflow_NORTH) .AND.
     &         (x .le. max_x_noflow_NORTH)) THEN
            STREAMICE_vfacemask_bdry (i,j,bi,bj) = 0. _d 0
           ENDIF
           IF ((x .gt. min_x_noStress_NORTH) .AND.
     &         (x .le. max_x_noStress_NORTH)) THEN
            STREAMICE_vfacemask_bdry (i,j,bi,bj) = 1.0
           ENDIF
           IF ((x .gt. min_x_FluxBdry_NORTH) .AND.
     &         (x .le. max_x_FluxBdry_NORTH)) THEN
            STREAMICE_vfacemask_bdry (i,j,bi,bj) = 4.0
            v_flux_bdry_SI (i,j,bi,bj) = flux_bdry_val_NORTH
           ENDIF
           IF ((x .gt. min_x_Dirich_NORTH) .AND.
     &         (x .le. max_x_Dirich_NORTH)) THEN
            STREAMICE_vfacemask_bdry (i,j,bi,bj) = 3.0
            v_bdry_values_SI (i,j,bi,bj) = 0. _d 0
           ENDIF
           IF ((x .gt. min_x_CFBC_NORTH) .AND.
     &         (x .le. max_x_CFBC_NORTH)) THEN
            STREAMICE_vfacemask_bdry (i,j,bi,bj) = 2.0
           ENDIF
          ENDIF

#else /* ifndef STREAMICE_GEOM_FILE_SETUP */
c BOUNDARY MASK CONFIGURED FROM FILES

          IF (temp_hmask(i,j,bi,bj).eq.1.0 .or.
     &        temp_hmask(i,j,bi,bj).eq.0.0 .or.
     &        temp_hmask(i-1,j,bi,bj).eq.1.0) THEN

C          WEST FACE OF CELL
           maskFlag=INT(temp_ufacemask(i,j,bi,bj))
           IF (maskFlag.eq.2) THEN
            STREAMICE_ufacemask_bdry (i,j,bi,bj) = 2.0
           ELSEIF (maskflag.eq.4.0) THEN
            STREAMICE_ufacemask_bdry (i,j,bi,bj) = 4.0
           ELSEIF (maskFlag.eq.3) THEN
            STREAMICE_ufacemask_bdry (i,j,bi,bj) = 3.0
           ELSEIF (maskFlag.eq.1) THEN
            STREAMICE_ufacemask_bdry (i,j,bi,bj) = 1.0
           ELSEIF ((maskFlag.eq.0) .or.
     &      ((maskFlag.eq.-1) .and.
     &       (temp_hmask(i-1,j,bi,bj).eq.-1.0))) THEN
            STREAMICE_ufacemask_bdry (i,j,bi,bj) = 0.0
           ELSEIF (temp_hmask(i,j,bi,bj).eq.-1.0) THEN
            STREAMICE_ufacemask_bdry (i,j,bi,bj) = 0.0
           ELSE
            STREAMICE_ufacemask_bdry (i,j,bi,bj) = -1.0
           ENDIF

          ENDIF

          IF (temp_hmask(i,j,bi,bj).eq.1.0 .or.
     &        temp_hmask(i,j,bi,bj).eq.0.0) THEN

C          EAST FACE OF CELL
           maskFlag=INT(temp_ufacemask(i+1,j,bi,bj))
           IF (maskFlag.eq.2) THEN
            STREAMICE_ufacemask_bdry (i+1,j,bi,bj) = 2.0
           ELSEIF (maskFlag.eq.4.0) THEN
            STREAMICE_ufacemask_bdry (i+1,j,bi,bj) = 4.0
           ELSEIF (maskFlag.eq.3) THEN
            STREAMICE_ufacemask_bdry (i+1,j,bi,bj) = 3.0
           ELSEIF (maskFlag.eq.1) THEN
            STREAMICE_ufacemask_bdry (i+1,j,bi,bj) = 1.0
           ELSEIF ((maskFlag.eq.0) .or.
     &      ((maskFlag.eq.-1) .and.
     &       (temp_hmask(i+1,j,bi,bj).eq.-1.0))) THEN
            STREAMICE_ufacemask_bdry (i+1,j,bi,bj) = 0.0
           ELSE
            STREAMICE_ufacemask_bdry (i+1,j,bi,bj) = -1.0
           ENDIF

          ENDIF

          IF (temp_hmask(i,j,bi,bj).eq.1.0 .or.
     &        temp_hmask(i,j,bi,bj).eq.0.0 .or.
     &        temp_hmask(i,j-1,bi,bj).eq.1.0) THEN

C          SOUTH FACE OF CELL
           maskFlag=INT(temp_vfacemask(i,j,bi,bj))
           IF (maskFlag.eq.2) THEN
            STREAMICE_vfacemask_bdry (i,j,bi,bj) = 2.0
           ELSEIF (maskFlag.eq.4.0) THEN
            STREAMICE_vfacemask_bdry (i,j,bi,bj) = 4.0
           ELSEIF (maskFlag.eq.3) THEN
            STREAMICE_vfacemask_bdry (i,j,bi,bj) = 3.0
           ELSEIF (maskFlag.eq.1) THEN
            STREAMICE_vfacemask_bdry (i,j,bi,bj) = 1.0
           ELSEIF ((maskFlag.eq.0) .or.
     &      ((maskFlag.eq.-1) .and.
     &       (temp_hmask(i,j-1,bi,bj).eq.-1.0))) THEN
            STREAMICE_vfacemask_bdry (i,j,bi,bj) = 0.0
           ELSEIF (temp_hmask(i,j,bi,bj).eq.-1.0) THEN
            STREAMICE_vfacemask_bdry (i,j,bi,bj) = 0.0
           ELSE
            STREAMICE_vfacemask_bdry (i,j,bi,bj) = -1.0
           ENDIF

          ENDIF

          IF (temp_hmask(i,j,bi,bj).eq.1.0 .or.
     &        temp_hmask(i,j,bi,bj).eq.0.0) THEN

C          NORTH FACE OF CELL
           maskFlag=INT(temp_vfacemask(i,j+1,bi,bj))
           IF (maskFlag.eq.2) THEN
            STREAMICE_vfacemask_bdry (i,j+1,bi,bj) = 2.0
           ELSEIF (maskFlag.eq.4.0) THEN
            STREAMICE_vfacemask_bdry (i,j+1,bi,bj) = 4.0
           ELSEIF (maskFlag.eq.3) THEN
            STREAMICE_vfacemask_bdry (i,j+1,bi,bj) = 3.0
           ELSEIF (maskFlag.eq.1) THEN
            STREAMICE_vfacemask_bdry (i,j+1,bi,bj) = 1.0
           ELSEIF ((maskFlag.eq.0) .or.
     &      ((maskFlag.eq.-1) .and.
     &       (temp_hmask(i,j+1,bi,bj).eq.-1.0))) THEN
            STREAMICE_vfacemask_bdry (i,j+1,bi,bj) = 0.0
           ELSE
            STREAMICE_vfacemask_bdry (i,j+1,bi,bj) = -1.0
           ENDIF

          ENDIF ! hmask==1 or hmask==0

#endif /* ifndef STREAMICE_GEOM_FILE_SETUP */

         ENDDO
        ENDDO
       ENDDO
      ENDDO

#ifdef ALLOW_CTRL
      CALL ACTIVE_WRITE_GEN_RS( 'maskCtrlL', STREAMICE_ctrl_mask,
     &  'XY', Nr, 1, .FALSE., 0, myThid, dummyRS )
#endif

#ifdef ALLOW_COST
c      _EXCH_XY_RL(STREAMICE_ctrl_mask, myThid )
      CALL WRITE_FLD_XY_RS ( 'maskCost', '',
     & STREAMICE_cost_mask, 0, myThid )
#endif

      _EXCH_XY_RL(k1AtC_str, myThid )
      _EXCH_XY_RL(k2AtC_str, myThid )
      _EXCH_XY_RS(STREAMICE_ufacemask_bdry, myThid )
      _EXCH_XY_RS(STREAMICE_vfacemask_bdry, myThid )
      _EXCH_XY_RL(u_bdry_values_SI, myThid )
      _EXCH_XY_RL(v_bdry_values_SI, myThid )
      _EXCH_XY_RL(u_flux_bdry_SI, myThid )
      _EXCH_XY_RL(v_flux_bdry_SI, myThid )

      Xquad (1) = .5 * (1.-1./sqrt(3.))
      Xquad (2) = .5 * (1.+1./sqrt(3.))

      CALL STREAMICE_INIT_PHI( myThid )

#ifdef ALLOW_STREAMICE_FP_ADJ
#ifdef ALLOW_PETSC
      STREAMICE_need2createmat = .true.
      STREAMICE_need2destroymat = .true.
#endif
#ifdef ALLOW_TAPENADE
      DO i=1,5
        refCumuls(i) = 0.0
        prevCumuls(i) = 0.0
        adjIters(i) = 0
      ENDDO
      fpDepth = 0
#endif

#endif

#endif /* ALLOW_STREAMICE */

      RETURN
      END

#include "PTRACERS_OPTIONS.h"
#include "GAD_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: PTRACERS_READPARMS

C     !INTERFACE:
      SUBROUTINE PTRACERS_READPARMS( myThid )

C     !DESCRIPTION:
C     Initialize PTRACERS parameters, read in data.ptracers

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#ifdef ALLOW_LONGSTEP
#include "LONGSTEP_PARAMS.h"
#endif
#include "PTRACERS_SIZE.h"
#include "PTRACERS_PARAMS.h"
#include "PARAMS.h"
#ifdef ALLOW_MNC
#include "MNC_PARAMS.h"
#endif

C     !INPUT PARAMETERS:
      INTEGER myThid
CEOP

#ifdef ALLOW_PTRACERS
C     !LOCAL VARIABLES:
C     k,iTracer  :: loop indices
C     iUnit      :: unit number for I/O
C     errCount   :: error counter
C     msgBuf     :: message buffer
C     tauTr1ClimRelax :: old parameter (will be removed 1 day)
      INTEGER k, iTracer
      INTEGER iUnit, errCount
      INTEGER ic
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      _RL PTRACERS_diffKr(PTRACERS_num)
      _RL tauTr1ClimRelax
C--   retired parameters:
C     PTRACERS_taveFreq :: Frequency with which time-averaged PTRACERS
C                          are written to post-processing files.
      _RL PTRACERS_taveFreq
      LOGICAL PTRACERS_timeave_mnc

      NAMELIST /PTRACERS_PARM01/
     &     tauTr1ClimRelax,
     &     PTRACERS_numInUse,
     &     PTRACERS_Iter0,
     &     PTRACERS_doAB_onGpTr,
     &     PTRACERS_addSrelax2EmP,
     &     PTRACERS_startStepFwd,
     &     PTRACERS_resetFreq,
     &     PTRACERS_resetPhase,
     &     PTRACERS_advScheme,
     &     PTRACERS_ImplVertAdv,
     &     PTRACERS_diffKh,
     &     PTRACERS_diffK4,
     &     PTRACERS_diffKr,
     &     PTRACERS_diffKrNr,
     &     PTRACERS_ref,
     &     PTRACERS_EvPrRn,
     &     PTRACERS_useGMRedi,
     &     PTRACERS_useDWNSLP,
     &     PTRACERS_useKPP,
     &     PTRACERS_linFSConserve,
     &     PTRACERS_stayPositive,
     &     PTRACERS_initialFile,
     &     PTRACERS_names,
     &     PTRACERS_long_names,
     &     PTRACERS_units,
     &     PTRACERS_useRecords,
     &     PTRACERS_dumpFreq,
     &     PTRACERS_taveFreq,
     &     PTRACERS_monitorFreq,
     &     PTRACERS_timeave_mnc,
     &     PTRACERS_snapshot_mnc,
     &     PTRACERS_monitor_mnc,
     &     PTRACERS_pickup_write_mnc,
     &     PTRACERS_pickup_read_mnc

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      IF ( .NOT.usePTRACERS ) THEN
C-    pkg PTRACERS is not used
        _BEGIN_MASTER(myThid)
C-    Track pkg activation status:
C     print a (weak) warning if data.ptracers is found
         CALL PACKAGES_UNUSED_MSG( 'usePTRACERS', ' ', ' ' )
        _END_MASTER(myThid)
        RETURN
      ENDIF

      _BEGIN_MASTER(myThid)

      errCount = 0
C     Set ptracer IO & diagnostics labels (2 characters long)
      CALL PTRACERS_SET_IOLABEL(
     O                           PTRACERS_ioLabel,
     I                           PTRACERS_num, myThid )

C     Set defaults values for parameters in PTRACERS.h
      PTRACERS_dumpFreq    = dumpFreq
      PTRACERS_monitorFreq = monitorFreq
      PTRACERS_Iter0   = 0
      PTRACERS_numInUse=-1
      DO iTracer=1,PTRACERS_num
        PTRACERS_startStepFwd(iTracer) = baseTime
        PTRACERS_resetFreq (iTracer) = 0.
        PTRACERS_resetPhase(iTracer) = 0.
        PTRACERS_advScheme(iTracer)=saltAdvScheme
        PTRACERS_ImplVertAdv(iTracer) = .FALSE.
        PTRACERS_diffKh(iTracer)=diffKhS
        PTRACERS_diffK4(iTracer)=diffK4S
        PTRACERS_diffKr(iTracer)=UNSET_RL
        DO k=1,Nr
          PTRACERS_diffKrNr(k,iTracer)=diffKrNrS(k)
          PTRACERS_ref     (k,iTracer)=0. _d 0
        ENDDO
        PTRACERS_EvPrRn(iTracer)=UNSET_RL
        PTRACERS_useGMRedi(iTracer)=useGMRedi
        PTRACERS_useDWNSLP(iTracer)=useDOWN_SLOPE
        PTRACERS_useKPP(iTracer)   =useKPP
        PTRACERS_linFSConserve(iTracer)= .FALSE.
#ifdef GAD_SMOLARKIEWICZ_HACK
        PTRACERS_stayPositive(iTracer) = .TRUE.
#else
        PTRACERS_stayPositive(iTracer) = .FALSE.
#endif
        PTRACERS_initialFile(iTracer)=' '
        DO ic = 1,MAX_LEN_FNAM
          PTRACERS_names(iTracer)(ic:ic) = ' '
          PTRACERS_long_names(iTracer)(ic:ic) = ' '
          PTRACERS_units(iTracer)(ic:ic) = ' '
        ENDDO
      ENDDO
      PTRACERS_doAB_onGpTr      = doAB_onGtGs
      PTRACERS_addSrelax2EmP    = .FALSE.
      PTRACERS_useRecords       = .FALSE.
#ifdef ALLOW_MNC
      PTRACERS_snapshot_mnc     = useMNC .AND. snapshot_mnc
      PTRACERS_monitor_mnc      = useMNC .AND. monitor_mnc
      PTRACERS_pickup_write_mnc = useMNC .AND. pickup_write_mnc
      PTRACERS_pickup_read_mnc  = useMNC .AND. pickup_read_mnc
#else
      PTRACERS_snapshot_mnc     = .FALSE.
      PTRACERS_monitor_mnc      = .FALSE.
      PTRACERS_pickup_write_mnc = .FALSE.
      PTRACERS_pickup_read_mnc  = .FALSE.
#endif
      tauTr1ClimRelax = 0.
      DO k = 1,Nr
#ifdef ALLOW_LONGSTEP
        PTRACERS_dTLev(k) = LS_nIter*dTtracerLev(k)
#else
        PTRACERS_dTLev(k) = dTtracerLev(k)
#endif
      ENDDO
C-    retired params default:
      PTRACERS_taveFreq    = UNSET_RL
      PTRACERS_timeave_mnc = .FALSE.

C     Open and read the data.ptracers file
      WRITE(msgBuf,'(A)') ' PTRACERS_READPARMS: opening data.ptracers'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT , myThid )
      CALL OPEN_COPY_DATA_FILE(
     I                   'data.ptracers', 'PTRACERS_READPARMS',
     O                   iUnit,
     I                   myThid )
      READ(UNIT=iUnit,NML=PTRACERS_PARM01)
      WRITE(msgBuf,'(A)')
     &  ' PTRACERS_READPARMS: finished reading data.ptracers'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT , myThid )

C     Close the open data file
#ifdef SINGLE_DISK_IO
      CLOSE(iUnit)
#else
      CLOSE(iUnit,STATUS='DELETE')
#endif /* SINGLE_DISK_IO */

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C--   Check for retired parameters:
      IF ( PTRACERS_taveFreq .NE. UNSET_RL ) THEN
        WRITE(msgBuf,'(2A)') 'PTRACERS_READPARMS: "PTRACERS_taveFreq"',
     &    ' is no longer allowed in file "data.ptracers"'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(2A)') 'PTRACERS_READPARMS: ',
     &    ' since "pkg/timeave" has been removed.'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF
      IF ( PTRACERS_timeave_mnc ) THEN
        WRITE(msgBuf,'(3A)') 'PTRACERS_READPARMS: ',
     &    '"PTRACERS_timeave_mnc" is no longer allowed ',
     &    'in file "data.ptracers"'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(2A)') 'PTRACERS_READPARMS: ',
     &    ' since "pkg/timeave" has been removed.'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF

C     Tracer 1 climatology relaxation time scale (<- but the code is gone !)
      IF ( tauTr1ClimRelax .NE. 0. ) THEN
#ifndef ALLOW_COST
        WRITE(msgBuf,'(2A)')' PTRACERS_READPARMS: ',
     &       'tauTr1ClimRelax has been removed (code is gone)'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
#else
       lambdaTr1ClimRelax = 1./tauTr1ClimRelax
      ELSE
       lambdaTr1ClimRelax = 0.
#endif
      ENDIF

C--   Now set-up any remaining parameters that result from other params

C     If PTRACERS_numInUse was not set in data.ptracers then we can
C     assume that all PTRACERS fields will be in use
      IF (PTRACERS_numInUse.LT.0) THEN
        PTRACERS_numInUse=PTRACERS_num
      ENDIF

C     Check we are not trying to use more tracers than allowed
      IF (PTRACERS_numInUse.GT.PTRACERS_num) THEN
        WRITE(msgBuf,'(A,I4,A,I4,A)')
     &       ' PTRACERS_READPARMS: You requested',PTRACERS_numInUse,
     &       ' tracers at run time when only',PTRACERS_num,
     &       ' were specified at compile time. Naughty! '
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF

C     Set vertical diffusion array
      DO iTracer=1,PTRACERS_numInUse
        IF ( PTRACERS_diffKr(iTracer).NE.UNSET_RL ) THEN
         DO k=1,Nr
          PTRACERS_diffKrNr(k,iTracer)=PTRACERS_diffKr(iTracer)
         ENDDO
        ENDIF
      ENDDO

C     Set flag to check when each tracer starts
      PTRACERS_startAllTrc = .TRUE.
      DO iTracer=1,PTRACERS_numInUse
        IF ( PTRACERS_startStepFwd(iTracer) .NE. baseTime )
     &    PTRACERS_startAllTrc = .FALSE.
      ENDDO
#ifdef ALLOW_AUTODIFF
      IF ( .NOT.PTRACERS_startAllTrc ) THEN
        WRITE(msgBuf,'(A)')
     &   'PTRACERS_READPARMS: Compiling AD code does not allow'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(A)')
     &   'to use different starting time (PTRACERS_startStepFwd)'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF
#endif /* ALLOW_AUTODIFF */

C     Whether to compute linear surface correction
C     (this may also be enabled elsewhere)
      PTRACERS_calcSurfCor = .FALSE.
      DO iTracer=1,PTRACERS_num
        IF (PTRACERS_linFSConserve(iTracer)) PTRACERS_calcSurfCor=.TRUE.
      ENDDO

#ifdef ALLOW_MNC
      PTRACERS_snapshot_mnc     = useMNC .AND. PTRACERS_snapshot_mnc
      PTRACERS_monitor_mnc      = useMNC .AND. PTRACERS_monitor_mnc
      PTRACERS_pickup_write_mnc = useMNC .AND. PTRACERS_pickup_write_mnc
      PTRACERS_pickup_read_mnc  = useMNC .AND. PTRACERS_pickup_read_mnc

      PTRACERS_snapshot_mdsio     = (.NOT. PTRACERS_snapshot_mnc)
     &     .OR. outputTypesInclusive
      PTRACERS_monitor_stdio      = (.NOT. PTRACERS_monitor_mnc)
     &     .OR. outputTypesInclusive
      PTRACERS_pickup_write_mdsio = (.NOT. PTRACERS_pickup_write_mnc)
     &     .OR. outputTypesInclusive
      PTRACERS_pickup_read_mdsio  = (.NOT. PTRACERS_pickup_read_mnc)
     &     .OR. outputTypesInclusive
#else
      PTRACERS_snapshot_mnc       = .FALSE.
      PTRACERS_monitor_mnc        = .FALSE.
      PTRACERS_pickup_write_mnc   = .FALSE.
      PTRACERS_pickup_read_mnc    = .FALSE.
      PTRACERS_snapshot_mdsio     = .TRUE.
      PTRACERS_monitor_stdio      = .TRUE.
      PTRACERS_pickup_write_mdsio = .TRUE.
      PTRACERS_pickup_read_mdsio  = .TRUE.
#endif

C--   Print a summary of pTracer parameter values: <- done in PTRACERS_CHECK

      IF ( errCount.GE.1 ) THEN
        WRITE(msgBuf,'(A,I3,A)')
     &       'PTRACERS_READPARMS: detected', errCount,' fatal error(s)'
        CALL PRINT_ERROR( msgBuf, myThid )
        CALL ALL_PROC_DIE( 0 )
        STOP 'ABNORMAL END: S/R PTRACERS_READPARMS'
      ENDIF

      _END_MASTER(myThid)
C     Everyone else must wait for the parameters to be loaded
      _BARRIER

#endif /* ALLOW_PTRACERS */

      RETURN
      END

#include "FIZHI_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 0
C     !INTERFACE:
      SUBROUTINE FIZHI_WRITE_DATETIME( myTime, myIter, myThid )

C     !DESCRIPTION:
C     Write Fizhi date and time to ascii file

      implicit none

#include "chronos.h"

C     !INPUT PARAMETERS:
      integer myIter, myThid
      _RL myTime
CEOP

      integer ku

      if( myThid.eq.1) then
C      Write Supplemental Ascii File with Current Time Info
       CALL MDSFINDUNIT( ku, myThid )
       open(ku,file='datetime',form='formatted')
       write(ku,1000)nymd,nhms
       print *,' Writing datetime file: NYMD = ',nymd,' NHMS = ',nhms
       close (ku)
      endif
 1000 format(i8,2x,i6)

      return
      end

#include "STREAMICE_OPTIONS.h"

CStartOfInterface
      SUBROUTINE STREAMICE_FIELDS_LOAD(
     I                            myTime, myIter, myThid )
C     *==========================================================*
C     | SUBROUTINE AIM_FIELDS_LOAD
C     | o Control reading of AIM fields from external source.
C     *==========================================================*
C     | Loads surface boundary condition datasets for AIM.
C     | The routine is called every timetep and periodically
C     | loads a set of external fields.
C     | Monthly climatology files are read either for
C     | a) a direct use (useMMsurfFc):
C     |   Albedo, Soil moisture, Surface Temperature
C     | b) time interpolation (useFMsurfBC):
C     |   Sea & Land surf. Temp, snow, sea-ice, soil-water (2-lev)
C     | + (1rst.iter) ground albedo, vegetation, land-sea fraction
C     | Most of the work is done by the master thread while
C     | the other threads spin (but all inside MDSIO S/R).
C     *==========================================================*
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "STREAMICE.h"

C     === Routine arguments ===
C     myTime :: Simulation time
C     myIter :: Simulation timestep number
C     myThid :: Thread no. that called this routine.
      _RL     myTime
      INTEGER myIter
      INTEGER myThid
CEndOfInterface

C     === Functions ===

#ifdef ALLOW_STREAMICE
#ifdef ALLOW_STREAMICE_TIMEDEP_FORCING
C     === Local variables ===
C     bi,bj, i,j  :: Loop counters
C     tYear       :: Fraction within year of myTime
C     mnthIndex   :: Current time in whole months
C     prevMnthIndex
C     fNam        :: Strings used in constructing file names
C     mnthNam
C     pfact       :: used to convert Pot.Temp. to in-situ Temp.
C     loadNewData :: true when need to load new data from file
      INTEGER bi,bj,i,j
c     _RL pfact
      LOGICAL first, changed
C--   for use with useMMsurfFc:
      CHARACTER*(MAX_LEN_FNAM) fNam
      LOGICAL upd_cfric, upd_bdot_maxmelt, upd_bglen

      INTEGER nm0, nm1, nmP
      _RL myRelTime, fac, tmpFac

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C--   find which month to use for surface BC
C     aim_surfForc_TimePeriod :: Length of forcing time period (e.g. 1 month)
C     aim_surfForc_NppCycle   :: Number of time period per Cycle (e.g. 12)

      upd_cfric = .FALSE.
      upd_bdot_maxmelt = .FALSE.
      upd_bglen = .FALSE.
      IF ( bdotMaxmeltTimeDepFile .NE. ' ' .and.
     &  STREAMICEbasalTracConfig.eq.'FILE' ) THEN
        upd_bdot_maxmelt = .TRUE.
      ENDIF
      IF ( bglenTimeDepFile .NE. ' ' .and.
     &  STREAMICEGlenConstConfig.eq.'FILE' ) THEN
        upd_bglen = .TRUE.
      ENDIF
      IF ( cfricTimeDepFile .NE. ' '  ) THEN
        upd_cfric = .TRUE.
      ENDIF

      myRelTime = myTime - startTime
      first = (myRelTime .lt. 0.5*deltaTClock)
      if ( streamice_forcing_period .eq. 0.D0 ) THEN
c     &     .or. externForcingCycle .eq. 0.D0 ) then
C     control parameter is constant in time and only needs to be updated
C     once in the beginning
       changed = .false.
       nm0  = 1
       nm1  = 1
       fac     = 1.D0
      else

C--   Now calculate whether it is time to update the forcing arrays
       if (externForcingCycle .eq. 0.0 ) THEN
        CALL GET_PERIODIC_INTERVAL(
     O                   nmP, nm0, nm1, tmpFac, fac,
     I                   externForcingCycle, streamice_forcing_period,
     I                   deltaTClock,
     I                   myTime+0.5*streamice_forcing_period,
     I                   myThid )
        fac = 1.D0 - fac
       else
        CALL GET_PERIODIC_INTERVAL(
     O                   nmP, nm0, nm1, tmpFac, fac,
     I                   externForcingCycle, streamice_forcing_period,
     I                   deltaTClock, myTime,
     I                   myThid )
       endif

       IF ( nm0.NE.nmP ) THEN
        changed = .true.
       ELSE
        changed = .false.
       ENDIF
       IF ( first ) changed = .false.
      endif

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C-     Load new data:

C-    Only one thread updates parameter in common block
C-    Wait for everyone to set loadNewData before Master updates prevMnthIndex
        _BARRIER

        IF ( first ) THEN

#ifdef STREAMICE_STRESS_BOUNDARY_CONTROL

         IF ( STREAMICEuNormalTimeDepFile .NE. ' '  ) THEN
          CALL READ_REC_XY_RL(STREAMICEuNormalTimeDepFile,
     &                        streamice_u_normal_stress1,
     &                        nm0,myIter,myThid)
         ENDIF

         IF ( STREAMICEvNormalTimeDepFile .NE. ' '  ) THEN
          CALL READ_REC_XY_RL(STREAMICEvNormalTimeDepFile,
     &                        streamice_v_normal_stress1,
     &                        nm0,myIter,myThid)
         ENDIF

         IF ( STREAMICEuShearTimeDepFile .NE. ' '  ) THEN
          CALL READ_REC_XY_RL(STREAMICEuShearTimeDepFile,
     &                        streamice_u_shear_stress1,
     &                        nm0,myIter,myThid)
         ENDIF

         IF ( STREAMICEvShearTimeDepFile .NE. ' '  ) THEN
          CALL READ_REC_XY_RL(STREAMICEvShearTimeDepFile,
     &                        streamice_v_shear_stress1,
     &                        nm0,myIter,myThid)
         ENDIF

#endif
#ifdef ALLOW_STREAMICE_FLUX_CONTROL
         IF ( STREAMICEuFluxTimeDepFile .NE. ' '  ) THEN
          CALL READ_REC_XY_RL(STREAMICEuFluxTimeDepFile,
     &                        u_flux_bdry_SI_1,
     &                        nm0,myIter,myThid)
         ENDIF
         IF ( STREAMICEvFluxTimeDepFile .NE. ' '  ) THEN
          CALL READ_REC_XY_RL(STREAMICEvFluxTimeDepFile,
     &                        u_flux_bdry_SI_1,
     &                        nm0,myIter,myThid)
         ENDIF
#endif

         IF ( STREAMICEBdotTimeDepFile .NE. ' '  ) THEN
          CALL READ_REC_XY_RL(STREAMICEBdotTimeDepFile,
     &                        bdot_streamice1,
     &                        nm0,myIter,myThid)
         ENDIF

         IF ( bdotMaxmeltTimeDepFile .NE. ' '  ) THEN
          CALL READ_REC_XY_RL(bdotMaxmeltTimeDepFile,
     &                        streamice_bdot_maxmelt1,
     &                        nm0,myIter,myThid)
         ENDIF

         IF ( bglenTimeDepFile .NE. ' '  ) THEN
          CALL READ_REC_XY_RL(bglenTimeDepFile,
     &                        streamice_bglen1,
     &                        nm0,myIter,myThid)
         ENDIF

         IF ( cfricTimeDepFile .NE. ' '  ) THEN
          CALL READ_REC_XY_RL(cfricTimeDepFile,
     &                        streamice_beta1,
     &                        nm0,myIter,myThid)
         ENDIF

C-      endif 1rst iter.
        ENDIF

        IF ( first .OR. changed) THEN

#ifdef STREAMICE_STRESS_BOUNDARY_CONTROL

         DO bj=myByLo(myThid),myByHi(myThid)
          DO bi=myBxLo(myThid),myBxHi(myThid)
           DO j=1,sNy
            DO i=1,sNx

             streamice_u_normal_stress0(i,j,bi,bj) =
     &        streamice_u_normal_stress1(i,j,bi,bj)
             streamice_v_normal_stress0(i,j,bi,bj) =
     &        streamice_v_normal_stress1(i,j,bi,bj)
             streamice_u_shear_stress0(i,j,bi,bj) =
     &        streamice_u_shear_stress1(i,j,bi,bj)
             streamice_v_shear_stress0(i,j,bi,bj) =
     &        streamice_v_shear_stress1(i,j,bi,bj)
            ENDDO
           ENDDO
          ENDDO
         ENDDO

         IF ( STREAMICEuNormalTimeDepFile .NE. ' '  ) THEN
          CALL READ_REC_XY_RL(STREAMICEuNormalTimeDepFile,
     &                        streamice_u_normal_stress1,
     &                        nm1,myIter,myThid)
         ENDIF

         IF ( STREAMICEvNormalTimeDepFile .NE. ' '  ) THEN
          CALL READ_REC_XY_RL(STREAMICEvNormalTimeDepFile,
     &                        streamice_v_normal_stress1,
     &                        nm1,myIter,myThid)
         ENDIF

         IF ( STREAMICEuShearTimeDepFile .NE. ' '  ) THEN
          CALL READ_REC_XY_RL(STREAMICEuShearTimeDepFile,
     &                        streamice_u_shear_stress1,
     &                        nm1,myIter,myThid)
         ENDIF

         IF ( STREAMICEvShearTimeDepFile .NE. ' '  ) THEN
          CALL READ_REC_XY_RL(STREAMICEvShearTimeDepFile,
     &                        streamice_v_shear_stress1,
     &                        nm1,myIter,myThid)
         ENDIF

#endif
#ifdef ALLOW_STREAMICE_FLUX_CONTROL

         DO bj=myByLo(myThid),myByHi(myThid)
          DO bi=myBxLo(myThid),myBxHi(myThid)
           DO j=1,sNy
            DO i=1,sNx

             u_flux_bdry_SI_0(i,j,bi,bj) =
     &        u_flux_bdry_SI_1(i,j,bi,bj)
             v_flux_bdry_SI_0(i,j,bi,bj) =
     &        v_flux_bdry_SI_1(i,j,bi,bj)

            ENDDO
           ENDDO
          ENDDO
         ENDDO

         IF ( STREAMICEuFluxTimeDepFile .NE. ' '  ) THEN
          CALL READ_REC_XY_RL(STREAMICEuFluxTimeDepFile,
     &                        u_flux_bdry_SI_1,
     &                        nm1,myIter,myThid)
         ENDIF

         IF ( STREAMICEuFluxTimeDepFile .NE. ' '  ) THEN
          CALL READ_REC_XY_RL(STREAMICEvFluxTimeDepFile,
     &                        v_flux_bdry_SI_1,
     &                        nm1,myIter,myThid)
         ENDIF

#endif

         DO bj=myByLo(myThid),myByHi(myThid)
          DO bi=myBxLo(myThid),myBxHi(myThid)
           DO j=1,sNy
            DO i=1,sNx
             bdot_streamice0(i,j,bi,bj) =
     &        bdot_streamice1(i,j,bi,bj)
            ENDDO
           ENDDO
          ENDDO
         ENDDO

         DO bj=myByLo(myThid),myByHi(myThid)
          DO bi=myBxLo(myThid),myBxHi(myThid)
           DO j=1,sNy
            DO i=1,sNx
             streamice_bdot_maxmelt0(i,j,bi,bj) =
     &        streamice_bdot_maxmelt1(i,j,bi,bj)
            ENDDO
           ENDDO
          ENDDO
         ENDDO

         DO bj=myByLo(myThid),myByHi(myThid)
          DO bi=myBxLo(myThid),myBxHi(myThid)
           DO j=1,sNy
            DO i=1,sNx
             streamice_bglen0(i,j,bi,bj) =
     &        streamice_bglen1(i,j,bi,bj)
            ENDDO
           ENDDO
          ENDDO
         ENDDO

         DO bj=myByLo(myThid),myByHi(myThid)
          DO bi=myBxLo(myThid),myBxHi(myThid)
           DO j=1,sNy
            DO i=1,sNx
             streamice_beta0(i,j,bi,bj) =
     &        streamice_beta1(i,j,bi,bj)
            ENDDO
           ENDDO
          ENDDO
         ENDDO

         IF ( STREAMICEBdotTimeDepFile .NE. ' '  ) THEN
          CALL READ_REC_XY_RL(STREAMICEBdotTimeDepFile,
     &                        bdot_streamice1,
     &                        nm1,myIter,myThid)
         ENDIF

         IF ( bdotMaxmeltTimeDepFile .NE. ' '  ) THEN
          CALL READ_REC_XY_RL(bdotMaxmeltTimeDepFile,
     &                        streamice_bdot_maxmelt1,
     &                        nm0,myIter,myThid)
         ENDIF

         IF ( bglenTimeDepFile .NE. ' '  ) THEN
          CALL READ_REC_XY_RL(bglenTimeDepFile,
     &                        streamice_bglen1,
     &                        nm0,myIter,myThid)
         ENDIF

         IF ( cfricTimeDepFile .NE. ' '  ) THEN
          CALL READ_REC_XY_RL(cfricTimeDepFile,
     &                        streamice_beta1,
     &                        nm0,myIter,myThid)
         ENDIF

C-      endif 1rst iter.
        ENDIF

        DO bj=myByLo(myThid),myByHi(myThid)
         DO bi=myBxLo(myThid),myBxHi(myThid)
          DO j=1,sNy
           DO i=1,sNx
#ifdef STREAMICE_STRESS_BOUNDARY_CONTROL
             streamice_u_normal_stress(i,j,bi,bj) =
     &        fac    * streamice_u_normal_stress0(i,j,bi,bj)
     &     + (1-fac) * streamice_u_normal_stress1(i,j,bi,bj)
             streamice_v_normal_stress(i,j,bi,bj) =
     &        fac    * streamice_v_normal_stress0(i,j,bi,bj)
     &     + (1-fac) * streamice_v_normal_stress1(i,j,bi,bj)
             streamice_u_shear_stress(i,j,bi,bj) =
     &        fac    * streamice_u_shear_stress0(i,j,bi,bj)
     &     + (1-fac) * streamice_u_shear_stress1(i,j,bi,bj)
             streamice_v_shear_stress(i,j,bi,bj) =
     &        fac    * streamice_v_shear_stress0(i,j,bi,bj)
     &     + (1-fac) * streamice_v_shear_stress1(i,j,bi,bj)
#endif
#ifdef ALLOW_STREAMICE_FLUX_CONTROL
             u_flux_bdry_pert(i,j,bi,bj) =
     &        fac    * u_flux_bdry_SI_0(i,j,bi,bj)
     &     + (1-fac) * u_flux_bdry_SI_1(i,j,bi,bj)
             v_flux_bdry_pert(i,j,bi,bj) =
     &        fac    * v_flux_bdry_SI_0(i,j,bi,bj)
     &     + (1-fac) * v_flux_bdry_SI_1(i,j,bi,bj)
#endif
             bdot_streamice (i,j,bi,bj) =
     &        fac    * bdot_streamice0(i,j,bi,bj)
     &     + (1-fac) * bdot_streamice1(i,j,bi,bj)
             if (upd_bdot_maxmelt) then
              streamice_bdot_maxmelt_v (i,j,bi,bj) =
     &         fac    * streamice_bdot_maxmelt0(i,j,bi,bj)
     &     +  (1-fac) * streamice_bdot_maxmelt1(i,j,bi,bj)
             endif
             if (upd_bglen) then
              b_glen (i,j,bi,bj) =
     &         fac    * streamice_bglen0(i,j,bi,bj)
     &     +  (1-fac) * streamice_bglen1(i,j,bi,bj)
             endif
             if (upd_cfric) then
              C_basal_friction (i,j,bi,bj) =
     &         fac    * streamice_beta0(i,j,bi,bj)
     &     +  (1-fac) * streamice_beta1(i,j,bi,bj)
             endif

           ENDDO
          ENDDO
         ENDDO
        ENDDO

#ifdef STREAMICE_STRESS_BOUNDARY_CONTROL
      CALL EXCH_XY_RL
     & (streamice_v_shear_stress, myThid)
      CALL EXCH_XY_RL
     & (streamice_u_shear_stress, myThid)
      CALL EXCH_XY_RL
     & (streamice_v_normal_stress, myThid)
      CALL EXCH_XY_RL
     & (streamice_u_normal_stress, myThid)
#endif

       _EXCH_XY_RL(bdot_streamice, myThid )
       _EXCH_XY_RL(streamice_bdot_maxmelt_v, myThid )
       _EXCH_XY_RL(b_glen, myThid )
       _EXCH_XY_RL(C_basal_friction, myThid )
#ifdef ALLOW_STREAMICE_FLUX_CONTROL
      CALL EXCH_XY_RL
     & (u_flux_bdry_pert, myThid)
      CALL EXCH_XY_RL
     & (v_flux_bdry_pert, myThid)
#endif

c      print *, "GOT HERE STREAMICE FIELDS LOAD",
c     &  first,changed,nm0,nm1,fac
#endif
#endif

      RETURN
      END

#include "EXF_OPTIONS.h"
#ifdef ALLOW_CTRL
# include "CTRL_OPTIONS.h"
#endif
#ifdef ALLOW_ECCO
# include "ECCO_OPTIONS.h"
#endif

CBOP
C     !ROUTINE: EXF_GETSURFACEFLUXES
C     !INTERFACE:
      SUBROUTINE EXF_GETSURFACEFLUXES(
     I                                 mytime,
     I                                 myiter,
     I                                 mythid
     &                               )
C     !DESCRIPTION: \bv
c     ==================================================================
c     SUBROUTINE EXF_GETSURFACEFLUXES
c     ==================================================================
c
c     o Mid-level routine for enabling the use of flux fields as control
c       variables.
c
c     started: Christian Eckert eckert@mit.edu  30-Jun-1999
c
c     changed: Christian Eckert eckert@mit.edu  14-Jan-2000
c              - Restructured the code in order to create a package
c                for the MITgcmUV.
c
c              Christian Eckert eckert@mit.edu  12-Feb-2000
c              - Changed Routine names (package prefix: exf_)
c
c     mods for pkg/seaice: menemenlis@jpl.nasa.gov 20-Dec-2002
c
c     ==================================================================
c     SUBROUTINE EXF_GETSURFACEFLUXES
c     ==================================================================
C     \ev
C     !USES:
      IMPLICIT NONE

C     == Global variables ==
#include "EEPARAMS.h"
#include "SIZE.h"
#include "PARAMS.h"
#include "GRID.h"

#include "EXF_FIELDS.h"
#include "EXF_PARAM.h"
#ifdef ALLOW_CTRL
# include "CTRL_SIZE.h"
# include "CTRL.h"
# include "CTRL_DUMMY.h"
# include "CTRL_GENARR.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     myTime :: Current time in simulation
C     myIter :: Current iteration number in simulation
C     myThid :: Thread number for this instance of the routine.
      _RL mytime
      INTEGER myiter
      INTEGER mythid

C     !LOCAL VARIABLES:
C     == Local variables
#ifdef ALLOW_CTRL
# ifdef ALLOW_ROTATE_UV_CONTROLS
      _RL     tmpUE(1-olx:snx+olx,1-oly:sny+oly,nsx,nsy)
      _RL     tmpVN(1-olx:snx+olx,1-oly:sny+oly,nsx,nsy)
      _RL     tmpUX(1-olx:snx+olx,1-oly:sny+oly,nsx,nsy)
      _RL     tmpVY(1-olx:snx+olx,1-oly:sny+oly,nsx,nsy)
# endif

#ifdef ALLOW_GENTIM2D_CONTROL
      INTEGER iarr
#endif

#if (defined (ALLOW_ROTATE_UV_CONTROLS) || defined (ALLOW_GENTIM2D_CONTROL))
      INTEGER i,j,bi,bj
#endif
CEOP

#ifdef ALLOW_ROTATE_UV_CONTROLS
      if ( useCTRL ) then
        DO bj = mybylo(mythid),mybyhi(mythid)
         DO bi = mybxlo(mythid),mybxhi(mythid)
          DO j = 1-oly,sny+oly
           DO i = 1-olx,snx+olx
             tmpUE(i,j,bi,bj) = 0. _d 0
             tmpVN(i,j,bi,bj) = 0. _d 0
             tmpUX(i,j,bi,bj) = 0. _d 0
             tmpVY(i,j,bi,bj) = 0. _d 0
           ENDDO
          ENDDO
         ENDDO
        ENDDO
      endif
#endif

#if (defined (ALLOW_CTRL) && \
     defined (ALLOW_GENTIM2D_CONTROL))
      IF ( useCTRL) THEN
       DO bj = myByLo(myThid),myByHi(myThid)
        DO bi = myBxLo(myThid),mybxhi(myThid)
         DO j = 1,sNy
          DO i = 1,sNx
           DO iarr = 1, maxCtrlTim2D
#ifndef ALLOW_ROTATE_UV_CONTROLS
           if (xx_gentim2d_file(iarr)(1:7).EQ.'xx_tauu')
     &       ustress(i,j,bi,bj)=ustress(i,j,bi,bj)+
     &                         xx_gentim2d(i,j,bi,bj,iarr)
           if (xx_gentim2d_file(iarr)(1:7).EQ.'xx_tauv')
     &       vstress(i,j,bi,bj)=vstress(i,j,bi,bj)+
     &                         xx_gentim2d(i,j,bi,bj,iarr)
#else
           if (xx_gentim2d_file(iarr)(1:7).EQ.'xx_tauu')
     &       tmpUE(i,j,bi,bj)=tmpUE(i,j,bi,bj)
     &          +xx_gentim2d(i,j,bi,bj,iarr)
           if (xx_gentim2d_file(iarr)(1:7).EQ.'xx_tauv')
     &       tmpVN(i,j,bi,bj)=tmpVN(i,j,bi,bj)
     &          +xx_gentim2d(i,j,bi,bj,iarr)
#endif
           if (xx_gentim2d_file(iarr)(1:8).EQ.'xx_hflux')
     &       hflux(i,j,bi,bj)=hflux(i,j,bi,bj)+
     &                         xx_gentim2d(i,j,bi,bj,iarr)
           if (xx_gentim2d_file(iarr)(1:8).EQ.'xx_sflux')
     &       sflux(i,j,bi,bj)=sflux(i,j,bi,bj)+
     &                         xx_gentim2d(i,j,bi,bj,iarr)
           ENDDO
          ENDDO
         ENDDO
        ENDDO
       ENDDO
      ENDIF !if (useCTRL) then
#endif

      IF ( (useCTRL).AND.(.NOT.useAtmWind) ) THEN

#ifdef ALLOW_ROTATE_UV_CONTROLS
      _EXCH_XY_RL(tmpUE,myThid)
      _EXCH_XY_RL(tmpVN,myThid)

      CALL ROTATE_UV2EN_RL(tmpUX,tmpVY,tmpUE,tmpVN,
     &     .FALSE.,stressIsOnCgrid,.TRUE.,1,mythid)

      IF ( stressIsOnCgrid ) THEN
        CALL EXCH_UV_XY_RL( tmpUX, tmpVY, .TRUE., myThid )
      ELSE
        CALL EXCH_UV_AGRID_3D_RL( tmpUX, tmpVY, .TRUE., 1, myThid)
      ENDIF

        DO bj = mybylo(mythid),mybyhi(mythid)
         DO bi = mybxlo(mythid),mybxhi(mythid)
          DO j = 1-oly,sny+oly
           DO i = 1-olx,snx+olx
             ustress(i,j,bi,bj)=ustress(i,j,bi,bj)+tmpUX(i,j,bi,bj)
             vstress(i,j,bi,bj)=vstress(i,j,bi,bj)+tmpVY(i,j,bi,bj)
           ENDDO
          ENDDO
         ENDDO
        ENDDO
#endif /* ALLOW_ROTATE_UV_CONTROLS */

      ENDIF !( .NOT.useAtmWind )

#endif /* ALLOW_CTRL */

      END

#include "GCHEM_OPTIONS.h"

C !INTERFACE: ==========================================================
      SUBROUTINE GCHEM_INIT_FIXED(myThid )

C !DESCRIPTION:
C calls subroutines that initialized fixed variables for any tracer
C experiment

C !USES: ===============================================================
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GCHEM.h"

C !INPUT PARAMETERS: ===================================================
C  myThid               :: thread number
      INTEGER myThid
CEOP

#ifdef ALLOW_GCHEM

C     !LOCAL VARIABLES:

C jmc: simpler to put MASTER thread directive within individual S/R :
C      that leave the choice, for each S/R, to do either single (master)
C      thread tasks or Multi-threaded tasks.
c        _BEGIN_MASTER( myThid )
ccccccccccccccccccccccccccc
c initialize parameters   c
ccccccccccccccccccccccccccc
#ifdef ALLOW_CFC
      IF ( useCFC ) THEN
         print*,'QQ start cfc params'
         CALL CFC_PARAM( myThid )
         print*,'QQ read cfc atmos data'
         CALL CFC_ATMOS( myThid )
      ENDIF
#endif /* ALLOW_CFC */
#ifdef ALLOW_DIC
      IF ( useDIC ) THEN
         print*,'QQ load dic parameters, initial fixed'
         CALL DIC_INIT_FIXED( myThid )
      ENDIF
#endif /* ALLOW_DIC */
#ifdef ALLOW_BLING
      IF ( useBLING ) THEN
         CALL BLING_INIT_FIXED( myThid )
      ENDIF
#endif /* ALLOW_BLING */
c         _END_MASTER( myThid )

#ifdef ALLOW_DARWIN
      IF ( useDARWIN ) THEN
         CALL DARWIN_INIT_FIXED(myThid)
      ENDIF
#endif

#ifdef ALLOW_SPOIL
      IF ( useSPOIL ) THEN
         CALL SPOIL_INIT_FIXED( myThid )
      ENDIF
#endif

#ifdef ALLOW_DIAGNOSTICS
C     Define diagnostics Names :
      IF ( useDiagnostics ) THEN
        CALL GCHEM_DIAGNOSTICS_INIT( myThid )
      ENDIF
#endif /* ALLOW_DIAGNOSTICS */

#endif /* ALLOW_GCHEM */

      RETURN
      END

#include "EBM_OPTIONS.h"
#ifdef ALLOW_AUTODIFF
# include "AUTODIFF_OPTIONS.h"
#endif

CBOP 0
C !ROUTINE: EBM_AREA_T

C !INTERFACE:
      SUBROUTINE EBM_AREA_T( myTime, myIter, myThid )

C     !DESCRIPTION:
C     *==========================================================*
C     | CALCULATE MEAN TEMPERATURE OVER 4 LAT. BAND
C     *==========================================================*

C     !USES:
      IMPLICIT NONE
C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "DYNVARS.h"
#include "FFIELDS.h"
#ifdef ALLOW_EBM
# include "EBM.h"
#endif
#ifdef ALLOW_AUTODIFF_TAMC
# include "tamc.h"
#endif

C     !INPUT PARAMETERS:
C     myThid     :: my Thread Id number
      _RL myTime
      INTEGER myIter
      INTEGER myThid
CEOP

#ifdef ALLOW_EBM
C     !LOCAL VARIABLES:
C     i, j, k  :: Loop counters
      INTEGER i, j, k, bi, bj
      _RL TmlS_tile(nSx, nSy)
      _RL TmlN_tile(nSx, nSy)
      _RL TtS_tile(nSx, nSy)
      _RL TtN_tile(nSx, nSy)
      _RL CountmlS_tile(nSx, nSy)
      _RL CountmlN_tile(nSx, nSy)
      _RL CounttS_tile(nSx, nSy)
      _RL CounttN_tile(nSx, nSy)
      _RL CountmlS
      _RL CountmlN
      _RL CounttS
      _RL CounttN

C--   Top layer only
      k = 1

      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)

        TmlS_tile(bi,bj) = 0.
        TmlN_tile(bi,bj) = 0.
        TtS_tile(bi,bj) = 0.
        TtN_tile(bi,bj) = 0.
        CountmlS_tile(bi,bj) = 0.
        CountmlN_tile(bi,bj) = 0.
        CounttS_tile(bi,bj) = 0.
        CounttN_tile(bi,bj) = 0.

C--   Calculate sum of temperatures over each tile
        DO j = 1,sNy
         DO i = 1, sNx
          IF ( yC(i,j,bi,bj) .GE. -latBnd(3) .AND.
     &         yC(i,j,bi,bj) .LE. -latBnd(2) ) THEN
            TmlS_tile(bi,bj) = TmlS_tile(bi,bj)
     &                       + maskC(i,j,k,bi,bj)*theta(i,j,k,bi,bj)
            CountmlS_tile(bi,bj) = CountmlS_tile(bi,bj)
     &                       + maskC(i,j,k,bi,bj)
          ELSEIF ( yC(i,j,bi,bj) .GT. -latBnd(2) .AND.
     &             yC(i,j,bi,bj) .LT. -latBnd(1) ) THEN
            TtS_tile(bi,bj) = TtS_tile(bi,bj)
     &                       + maskC(i,j,k,bi,bj)*theta(i,j,k,bi,bj)
            CounttS_tile(bi,bj) = CounttS_tile(bi,bj)
     &                       + maskC(i,j,k,bi,bj)
          ELSEIF ( yC(i,j,bi,bj) .GT. latBnd(1) .AND.
     &             yC(i,j,bi,bj) .LT. latBnd(2) ) THEN
            TtN_tile(bi,bj) = TtN_tile(bi,bj)
     &                       + maskC(i,j,k,bi,bj)*theta(i,j,k,bi,bj)
            CounttN_tile(bi,bj) = CounttN_tile(bi,bj)
     &                       + maskC(i,j,k,bi,bj)
          ELSEIF ( yC(i,j,bi,bj) .GE. latBnd(2) .AND.
     &             yC(i,j,bi,bj) .LT. latBnd(3) ) THEN
            TmlN_tile(bi,bj) = TmlN_tile(bi,bj)
     &                       + maskC(i,j,k,bi,bj)*theta(i,j,k,bi,bj)
            CountmlN_tile(bi,bj) = CountmlN_tile(bi,bj)
     &                       + maskC(i,j,k,bi,bj)
          ENDIF
         ENDDO
        ENDDO

       ENDDO
      ENDDO

      CALL GLOBAL_SUM_TILE_RL( TmlS_tile, TmlS, myThid )
      CALL GLOBAL_SUM_TILE_RL( TmlN_tile, TmlN, myThid )
      CALL GLOBAL_SUM_TILE_RL( TtS_tile,  TtS,  myThid )
      CALL GLOBAL_SUM_TILE_RL( TtN_tile,  TtN,  myThid )

      CALL GLOBAL_SUM_TILE_RL( CountmlS_tile, CountmlS, myThid )
      CALL GLOBAL_SUM_TILE_RL( CountmlN_tile, CountmlN, myThid )
      CALL GLOBAL_SUM_TILE_RL( CounttS_tile,  CounttS,  myThid )
      CALL GLOBAL_SUM_TILE_RL( CounttN_tile,  CounttN,  myThid )

#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE CountmlS = comlev1, key = ikey_dynamics
CADJ STORE CountmlN = comlev1, key = ikey_dynamics
CADJ STORE CounttS  = comlev1, key = ikey_dynamics
CADJ STORE CounttN  = comlev1, key = ikey_dynamics
#endif
      _BEGIN_MASTER(myThid)
      IF ( CountmlS .NE. 0.) TmlS = TmlS/CountmlS
      IF ( CountmlN .NE. 0.) TmlN = TmlN/CountmlN
      IF ( CounttS  .NE. 0.) TtS  = TtS /CounttS
      IF ( CounttN  .NE. 0.) TtN  = TtN /CounttN
      TmlS = TmlS + t_mlt
      TmlN = TmlN + t_mlt
      TtS  = TtS  + t_mlt
      TtN  = TtN  + t_mlt
      _END_MASTER(myThid)
      _BARRIER

#endif /* ALLOW_EBM */

      RETURN
      END

#include "SALT_PLUME_OPTIONS.h"

CBOP 0
C     !ROUTINE: SALT_PLUME_DIAGNOSTICS_FILL
C     !INTERFACE:
      SUBROUTINE SALT_PLUME_DIAGNOSTICS_FILL(
     I             bi, bj, myThid )

C     !DESCRIPTION:
C     Provide the information for the diagnostics

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "SALT_PLUME.h"

C     !INPUT PARAMETERS:
      INTEGER bi,bj
      INTEGER myThid
CEOP

#ifdef ALLOW_SALT_PLUME
#ifdef ALLOW_DIAGNOSTICS
C     !LOCAL VARIABLES:

      IF ( useDiagnostics ) THEN

C-    Salt plume depth (>0), [m]
       CALL DIAGNOSTICS_FILL( SaltPlumeDepth,
     &                             'oceSPDep',0, 1,0,1,1,myThid )

C-    net Salt plume flux into the ocean during freezing (+=down), [g/m2/s]
       CALL DIAGNOSTICS_FILL( saltPlumeFlux,
     &                             'oceSPflx',0, 1,0,1,1,myThid )
#ifdef SALT_PLUME_VOLUME
       CALL DIAGNOSTICS_FILL(
     &      SPbrineVolFlux,'oceSPvol',0,1,0,1,1,myThid )
       CALL DIAGNOSTICS_FILL(
     &      SPforcS1,'SPforcS1',0,1,0,1,1,myThid )
       CALL DIAGNOSTICS_FILL(
     &      SPforcT1,'SPforcT1',0,1,0,1,1,myThid )
       CALL DIAGNOSTICS_FILL(
     &      dSPvolSurf2kLev, 'SPVsuf2k',0,Nr,0,1,1,myThid )
       CALL DIAGNOSTICS_FILL(
     &      dSPvolkLev2Above,'SPVk2m  ',0,Nr,0,1,1,myThid )
#endif
      ENDIF

#endif /* ALLOW_DIAGNOSTICS */
#endif /* ALLOW_SALT_PLUME */

      RETURN
      END

#include "SEAICE_OPTIONS.h"

      subroutine seaice_cost_export( myThid )
C     *==========================================================*
C     | subroutine seaice_cost_export
C     | o Poor man ice export through Fram Strait
C     |   Parameters currently hard-wired for arctic210x192x50
C     *==========================================================*
       implicit none

C     == Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "SEAICE_SIZE.h"
#include "SEAICE.h"
#include "SEAICE_COST.h"

C     ======== Routine arguments ======================
C     myThid - Thread number for this instance of the routine.
      integer myThid

#ifdef ALLOW_SEAICE_COST_EXPORT
C     ========= Local variables =========================
      integer    isecbeg      , isecend      , jsec
      integer    jsecbeg      , jsecend      , isec
      integer    kmaxdepth
      integer i, j, k
      integer ig, jg
      integer bi, bj

#if (defined (SEAICE_COST_EXPORT_FRAM))
      parameter ( isec = 74, jsecbeg = 60, jsecend = 89 )
#elif (defined (SEAICE_COST_EXPORT_CANARCH))
      parameter ( isec = 202, jsecbeg = 236, jsecend = 242 )
#else
      parameter ( isec = 1, jsecbeg = 1, jsecend = 1)
#endif
      parameter ( kmaxdepth = 1 )

      do bj=myByLo(myThid),myByHi(myThid)
       do bi=myBxLo(myThid),myBxHi(myThid)
        do i=1,sNx
         ig = myXGlobalLo-1+(bi-1)*sNx+i
         if (ig .eq. isec) then
          do k = 1, kmaxdepth
           do j=1,sNy
            jg = myYGlobalLo-1+(bj-1)*sNy+j
            if ((jg .ge. jsecbeg) .and. (jg .le. jsecend)) then
             objf_ice_export(bi,bj) = objf_ice_export(bi,bj)
     &              - uHeffExportCell(i,j,bi,bj)
cph(
cph             print *, 'ph-canarch pos i, ig, j, jg, X, Y ',
cph     &        i, ig, j, jg, xC(i,j,bi,bj), yC(i,j,bi,bj)
cph)
            end if
           enddo
          enddo
         end if
        end do
c--   end of bi,bj loop
       end do
      end do

#endif

      return
      end

#include "STREAMICE_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

CBOP
      SUBROUTINE ADSTREAMICE_CG_SOLVE(
     U                               U_state,    ! velocities - need to be recalc ed
     I                               cg_Bu,      ! adjoint of vel (input)
     U                               V_state,    ! velocities - need to be recalc ed
     I                               cg_Bv,      ! adjoint of vel (input)
     I                               Bu_state,   ! to recalc velocities
     U                               cg_Uin,     ! adjoint of RHS (output)
     I                               Bv_state,   ! to recalc velocities
     U                               cg_Vin,     ! adjoint of RHS (output)
     I                               A_uu,       ! section of matrix that multiplies u and projects on u
     U                               adA_uu,     ! adjoint of matrix coeffs (output)
     I                               A_uv,       ! section of matrix that multiplies v and projects on u
     U                               adA_uv,     ! adjoint of matrix coeffs (output)
     I                               A_vu,       ! section of matrix that multiplies u and projects on v
     U                               adA_vu,     ! adjoint of matrix coeffs (output)
     I                               A_vv,       ! section of matrix that multiplies v and projects on v
     U                               adA_vv,     ! adjoint of matrix coeffs (output)
     I                               tolerance,
     I                               maxiters,
     I                               myThid)
C     *============================================================*
C     | SUBROUTINE ADSTREAMICE_CG_SOLVE                            |
C     | o wrapper for ADSTREAMICE_CG_SOLVE_RECALC                  |
C     *============================================================*

C     !USES:
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"

C     !INPUT/OUTPUT ARGUMENTS
C     cg_Uin, cg_Vin - input and output velocities
C     cg_Bu, cg_Bv - driving stress
      _RL cg_Uin (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL cg_Vin (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL cg_Bu (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL cg_Bv (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL U_state (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL V_state (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL Bu_state (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL Bv_state (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL
     & A_uu (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy,-1:1,-1:1),
     & A_vu (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy,-1:1,-1:1),
     & A_uv (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy,-1:1,-1:1),
     & A_vv (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy,-1:1,-1:1),
     & adA_uu (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy,-1:1,-1:1),
     & adA_vu (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy,-1:1,-1:1),
     & adA_uv (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy,-1:1,-1:1),
     & adA_vv (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy,-1:1,-1:1)
      _RL tolerance
      INTEGER maxiters
      INTEGER myThid

#ifdef ALLOW_STREAMICE
      INTEGER recalc_vel

      recalc_vel = 0
      CALL ADSTREAMICE_CG_SOLVE_RECALC(
     U                               U_state,    ! velocities - need to be recalc ed
     I                               cg_Bu,      ! adjoint of vel (input)
     U                               V_state,    ! velocities - need to be recalc ed
     I                               cg_Bv,      ! adjoint of vel (input)
     I                               Bu_state,   ! to recalc velocities
     U                               cg_Uin,     ! adjoint of RHS (output)
     I                               Bv_state,   ! to recalc velocities
     U                               cg_Vin,     ! adjoint of RHS (output)
     I                               A_uu,       ! section of matrix that multiplies u and projects on u
     U                               adA_uu,     ! adjoint of matrix coeffs (output)
     I                               A_uv,       ! section of matrix that multiplies v and projects on u
     U                               adA_uv,     ! adjoint of matrix coeffs (output)
     I                               A_vu,       ! section of matrix that multiplies u and projects on v
     U                               adA_vu,     ! adjoint of matrix coeffs (output)
     I                               A_vv,       ! section of matrix that multiplies v and projects on v
     U                               adA_vv,     ! adjoint of matrix coeffs (output)
     I                               tolerance,
     I                               maxiters,
     I                               recalc_vel,
     I                               myThid)

c       iters = streamice_max_cg_iter

#endif
      RETURN
      END
CEOP

CBOP
      SUBROUTINE ADSTREAMICE_CG_SOLVE_RECALC(
     U                               U_state,    ! velocities - need to be recalc ed
     I                               cg_Bu,      ! adjoint of vel (input)
     U                               V_state,    ! velocities - need to be recalc ed
     I                               cg_Bv,      ! adjoint of vel (input)
     I                               Bu_state,   ! to recalc velocities
     U                               cg_Uin,     ! adjoint of RHS (output)
     I                               Bv_state,   ! to recalc velocities
     U                               cg_Vin,     ! adjoint of RHS (output)
     I                               A_uu,       ! section of matrix that multiplies u and projects on u
     U                               adA_uu,     ! adjoint of matrix coeffs (output)
     I                               A_uv,       ! section of matrix that multiplies v and projects on u
     U                               adA_uv,     ! adjoint of matrix coeffs (output)
     I                               A_vu,       ! section of matrix that multiplies u and projects on v
     U                               adA_vu,     ! adjoint of matrix coeffs (output)
     I                               A_vv,       ! section of matrix that multiplies v and projects on v
     U                               adA_vv,     ! adjoint of matrix coeffs (output)
     I                               tolerance,
     I                               maxiters,
     I                               recalc_vel,
     I                               myThid )
C     *============================================================*
C     | SUBROUTINE ADSTREAMICE_CG_SOLVE_RECALC                     |
C     | o called by ADSTREAMICE_CG_SOLVE or directly               |
C     | o can enable recalc of velocity if needed                  |
C     *============================================================*

C     !USES:
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "STREAMICE.h"
#include "STREAMICE_CG.h"

C     !INPUT/OUTPUT ARGUMENTS
C     cg_Uin, cg_Vin - input and output velocities
C     cg_Bu, cg_Bv - driving stress
      _RL cg_Uin (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL cg_Vin (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL cg_Bu (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL cg_Bv (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL U_state (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL V_state (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL Bu_state (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL Bv_state (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL
     & A_uu (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy,-1:1,-1:1),
     & A_vu (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy,-1:1,-1:1),
     & A_uv (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy,-1:1,-1:1),
     & A_vv (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy,-1:1,-1:1),
     & adA_uu (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy,-1:1,-1:1),
     & adA_vu (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy,-1:1,-1:1),
     & adA_uv (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy,-1:1,-1:1),
     & adA_vv (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy,-1:1,-1:1)
      _RL tolerance
      INTEGER maxiters
      INTEGER recalc_vel ! 1 = recalculate forward velocity
                         !     before solving adjoint
                         ! 0 = velocity already correct
      INTEGER myThid

C     !LOCAL VARIABLES
      INTEGER i, j, bi, bj, conv_flag, tmpiter
      INTEGER colx, coly
      _RL Utemp (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL Vtemp (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL UtempSt (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL VtempSt (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL ad_tolerance
      CHARACTER*(MAX_LEN_MBUF) msgBuf
CEOP

c       iters = streamice_max_cg_iter

#ifdef ALLOW_STREAMICE

      WRITE(msgBuf,'(A)') 'CALLING MANUAL CG ADJOINT'
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                     SQUEEZE_RIGHT , 1)

      conv_flag = 0
      ad_tolerance = 1.e-14

      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          Utemp (i,j,bi,bj) =
     &     cg_Uin (i,j,bi,bj)
          Vtemp (i,j,bi,bj) =
     &     cg_Vin (i,j,bi,bj)
          UtempSt (i,j,bi,bj) =
     &     U_state (i,j,bi,bj)
          VtempSt (i,j,bi,bj) =
     &     V_state (i,j,bi,bj)
         ENDDO
        ENDDO
       ENDDO
      ENDDO

!#if !defined(ALLOW_OPENAD) & !defined(ALLOW_TAPENADE)
      if (recalc_vel .eq. 1) then
       CALL STREAMICE_CG_SOLVE(
     &  U_state,
     &  V_state,
     &  Bu_state,
     &  Bv_state,
     &  A_uu,
     &  A_uv,
     &  A_vu,
     &  A_vv,
     &  tolerance,
     &  tmpiter,
     &  maxiters,
     &  myThid )
      endif
!#endif

      tmpiter = 0

      _EXCH_XY_RL( cg_Bu, myThid )
      _EXCH_XY_RL( cg_Bv, myThid )

      CALL STREAMICE_CG_SOLVE(
     &  cg_Uin,
     &  cg_Vin,
     &  cg_Bu,
     &  cg_Bv,
     &  A_uu,
     &  A_uv,
     &  A_vu,
     &  A_vv,
     &  ad_tolerance,
     &  tmpiter,
     &  maxiters,
     &  myThid )

      _EXCH_XY_RL( cg_Uin, myThid )
      _EXCH_XY_RL( cg_Vin, myThid )
      _EXCH_XY_RL( U_state, myThid )
      _EXCH_XY_RL( V_state, myThid )

      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
        DO j=1,sNy
         DO i=1,sNx
          DO colx=-1,1
           DO coly=-1,1

            if (STREAMICE_umask(i,j,bi,bj).eq.1) then
             if (STREAMICE_umask(i+colx,j+coly,bi,bj).eq.1) then
                adA_uu(i,j,bi,bj,colx,coly) =
     &           adA_uu(i,j,bi,bj,colx,coly) -
     &           cg_Uin(i,j,bi,bj) *
     &           U_state(i+colx,j+coly,bi,bj)

             endif
             if (STREAMICE_vmask(i+colx,j+coly,bi,bj).eq.1) then
                adA_uv(i,j,bi,bj,colx,coly) =
     &           adA_uv(i,j,bi,bj,colx,coly) -
     &           cg_Uin(i,j,bi,bj) *
     &           V_state(i+colx,j+coly,bi,bj)
             endif
            endif

            if (STREAMICE_vmask(i,j,bi,bj).eq.1) then
             if (STREAMICE_umask(i+colx,j+coly,bi,bj).eq.1) then
                adA_vu(i,j,bi,bj,colx,coly) =
     &           adA_vu(i,j,bi,bj,colx,coly) -
     &           cg_Vin(i,j,bi,bj) *
     &           U_state(i+colx,j+coly,bi,bj)
             endif
             if (STREAMICE_vmask(i+colx,j+coly,bi,bj).eq.1) then
                adA_vv(i,j,bi,bj,colx,coly) =
     &           adA_vv(i,j,bi,bj,colx,coly) -
     &           cg_Vin(i,j,bi,bj) *
     &           V_state(i+colx,j+coly,bi,bj)
             endif
            endif

           enddo
          enddo
         enddo
        enddo
       enddo
      enddo

      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          if (i.lt.1.or.i.gt.sNx.or.
     &        j.lt.1.or.j.gt.sNy) then
           cg_Uin (i,j,bi,bj) = 0.0
           cg_Vin (i,j,bi,bj) = 0.0

           DO colx=-1,1
            DO coly=-1,1
             ada_uu(i,j,bi,bj,colx,coly)=0.0
             ada_uv(i,j,bi,bj,colx,coly)=0.0
             ada_vu(i,j,bi,bj,colx,coly)=0.0
             ada_vv(i,j,bi,bj,colx,coly)=0.0
            enddo
           enddo

          endif
          cg_Uin (i,j,bi,bj) =
     &     cg_Uin (i,j,bi,bj) +
     &     Utemp (i,j,bi,bj)
          cg_Vin (i,j,bi,bj) =
     &     cg_Vin (i,j,bi,bj) +
     &     Vtemp (i,j,bi,bj)
          cg_bu (i,j,bi,bj) = 0.
          cg_bv (i,j,bi,bj) = 0.
          U_state (i,j,bi,bj) =
     &     UtempSt (i,j,bi,bj)
          V_state (i,j,bi,bj) =
     &     VtempSt (i,j,bi,bj)
         ENDDO
        ENDDO
       ENDDO
      ENDDO

      WRITE(msgBuf,'(A,I5,A)') 'DONE WITH MANUAL CG ADJOINT:',tmpiter,
     & 'ITERS'
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                     SQUEEZE_RIGHT , 1)

#endif
      RETURN
      END

#include "SEAICE_OPTIONS.h"

CBOP
C !ROUTINE: SEAICE_INIT_FIXED

C !INTERFACE: ==========================================================
      SUBROUTINE SEAICE_INIT_FIXED( myThid )
C !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE SEAICE_INIT_FIXED
C     | o Initialization of sea ice model.
C     *==========================================================*
C     *==========================================================*
      IMPLICIT NONE
C \ev

C !USES: ===============================================================
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "FFIELDS.h"
#include "SEAICE_SIZE.h"
#include "SEAICE_PARAMS.h"
#include "SEAICE_GRID.h"
#include "SEAICE.h"
#include "SEAICE_TRACER.h"

C !INPUT PARAMETERS: ===================================================
C     myThid - Thread no. that called this routine.
      INTEGER myThid
CEndOfInterface

C !LOCAL VARIABLES: ====================================================
#ifdef SEAICE_ITD
C     msgBuf      :: Informational/error message buffer
      CHARACTER*(MAX_LEN_MBUF) msgBuf
C     k - loop counter for ITD categories
      INTEGER k
      _RL tmpVar
      LOGICAL computeHlimit
#endif
C     i,j, bi,bj  :: Loop counters
      INTEGER i, j, bi, bj
      INTEGER kSrf
#ifdef ALLOW_SITRACER
      INTEGER iTracer
#endif
C     local copy of surface layer thickness in meters
      _RL dzSurf
#ifdef SEAICE_BGRID_DYNAMICS
      _RL mask_uice
#endif
#ifdef SEAICE_ALLOW_SIDEDRAG
      LOGICAL readCoastLineFields
#endif
CEOP

      IF ( usingPCoords ) THEN
       kSrf        = Nr
      ELSE
       kSrf        = 1
      ENDIF

C     Initialize MNC variable information for SEAICE
      IF ( useMNC .AND. ( seaice_dump_mnc .OR. SEAICE_mon_mnc ) ) THEN
        CALL SEAICE_MNC_INIT( myThid )
      ENDIF

C     Only Master Thread updates parameter in commom block:
      _BEGIN_MASTER(myThid)

C     restart parameter
      SEAICEmomStartBDF = 0
      IF ( SEAICEuseBDF2 ) SEAICEmomStartBDF = nIter0

C--   Set mcPheePiston coeff (if still unset)
       dzSurf = drF(kSrf)
       IF ( usingPCoords )
     &      dzSurf = drF(kSrf) * recip_rhoConst * recip_gravity
      IF ( SEAICE_mcPheePiston.EQ.UNSET_RL ) THEN
        IF ( SEAICE_availHeatFrac.NE.UNSET_RL ) THEN
          SEAICE_mcPheePiston = SEAICE_availHeatFrac
     &                        * dzSurf/SEAICE_deltaTtherm
        ELSE
          SEAICE_mcPheePiston = MCPHEE_TAPER_FAC
     &                        * STANTON_NUMBER * USTAR_BASE
          SEAICE_mcPheePiston = MIN( SEAICE_mcPheePiston,
     &                          dzSurf/SEAICE_deltaTtherm )
        ENDIF

      ENDIF

C--   SItracer specifications for basic tracers
#ifdef ALLOW_SITRACER
      DO iTracer = 1, SItrNumInUse
C     "ice concentration" tracer that should remain .EQ.1.
       IF (SItrName(iTracer).EQ.'one') THEN
         SItrFromOcean0(iTracer)    =ONE
         SItrFromFlood0(iTracer)    =ONE
         SItrExpand0(iTracer)       =ONE
         SItrFromOceanFrac(iTracer) =ZERO
         SItrFromFloodFrac(iTracer) =ZERO
       ENDIF
C     age tracer: no age in ocean, or effect from ice cover changes
       IF (SItrName(iTracer).EQ.'age') THEN
         SItrFromOcean0(iTracer)    =ZERO
         SItrFromFlood0(iTracer)    =ZERO
         SItrExpand0(iTracer)       =ZERO
         SItrFromOceanFrac(iTracer) =ZERO
         SItrFromFloodFrac(iTracer) =ZERO
       ENDIf
C     salinity tracer:
       IF (SItrName(iTracer).EQ.'salinity') THEN
         SItrMate(iTracer)          ='HEFF'
         SItrExpand0(iTracer)       =ZERO
         IF ( SEAICE_salinityTracer ) THEN
           SEAICE_salt0    = ZERO
           SEAICE_saltFrac = ZERO
         ENDIF
       ENDIF
C     simple, made up, ice surface roughness index prototype
       IF (SItrName(iTracer).EQ.'ridge') THEN
         SItrMate(iTracer)          ='AREA'
         SItrFromOcean0(iTracer)    =ZERO
         SItrFromFlood0(iTracer)    =ZERO
         SItrExpand0(iTracer)       =ZERO
         SItrFromOceanFrac(iTracer) =ZERO
         SItrFromFloodFrac(iTracer) =ZERO
       ENDIF
#ifdef SEAICE_GREASE
C     grease ice tracer:
c     (Smedrud and Martin, 2014, Ann. Glac.)
       IF (SItrName(iTracer).EQ.'grease') THEN
         SItrMate(iTracer)          ='HEFF'
         SItrFromOcean0(iTracer)    =ZERO
         SItrFromFlood0(iTracer)    =ZERO
         SItrExpand0(iTracer)       =ZERO
         SItrFromOceanFrac(iTracer) =ZERO
         SItrFromFloodFrac(iTracer) =ZERO
       ENDIF
#endif /* SEAICE_GREASE */
      ENDDO
#endif /* ALLOW_SITRACER */

#ifdef SEAICE_ITD
C     zeroth category needs to be zero
      Hlimit(0)    = 0. _d 0
C     thickest category is unlimited
      Hlimit(nITD) = 999.9 _d 0
      computeHlimit=.FALSE.
C     check if Hlimit contains useful values
      DO k = 1, nITD
       IF ( Hlimit(k).EQ.UNSET_RL )    computeHlimit=.TRUE.
       IF ( Hlimit(k).LE.Hlimit(k-1) ) computeHlimit=.TRUE.
      ENDDO
      IF ( computeHlimit ) THEN
       WRITE(msgBuf,'(A,I2,A)') 'SEAICE_INIT_FIXED: Computing ',
     &      nITD, ' thickness category limits with'
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                     SQUEEZE_RIGHT, myThid )
       CALL WRITE_0D_RL( Hlimit_c1  ,INDEX_NONE,
     &      'Hlimit_c1  =', ' /* ITD bin parameter */')
       CALL WRITE_0D_RL( Hlimit_c2  ,INDEX_NONE,
     &      'Hlimit_c2  =', ' /* ITD bin parameter */')
       CALL WRITE_0D_RL( Hlimit_c3  ,INDEX_NONE,
     &      'Hlimit_c3  =', ' /* ITD bin parameter */')
       WRITE(msgBuf,'(A)') ' '
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                     SQUEEZE_RIGHT, myThid )
C     use Equ. 22 of Lipscomb et al. (2001, JGR) to generate ice
C     thickness category limits:
C     - dependends on given number of categories nITD
C     - choose between original parameters of Lipscomb et al. (2001):
C       c1=3.0/N, c2=15*c1, c3=3.0
C       or emphasize thin end of ITD (in order to enhance ice growth):
C       c1=1.5/N, c2=42*c1, c3=3.3
C       -> HINT: set parameters c1, c2 and c3 in seaice_readparms.F
       IF ( nITD.GT.1 ) THEN
        tmpVar = nITD
        tmpVar = oneRL / tmpVar
        Hlimit_c1 = Hlimit_c1*tmpVar
        Hlimit_c2 = Hlimit_c2*Hlimit_c1
        DO k=1,nITD-1
         Hlimit(k) = Hlimit(k-1)
     &             + Hlimit_c1
     &             + Hlimit_c2
     &    *( oneRL + TANH( Hlimit_c3 *( FLOAT(k-1)*tmpVar - oneRL ) ) )
        ENDDO
       ENDIF
      ENDIF
C     thickest category is unlimited
      Hlimit(nITD) = 999.9 _d 0

#endif /* SEAICE_ITD */

C     Only Master Thread updates parameter in common block:
      _END_MASTER(myThid)

#ifdef SEAICE_ALLOW_JFNK
C     Only Master Thread updates parameter in common block:
      _BEGIN_MASTER(myThid)
C     initialise some diagnostic counters for the JFNK solver
      totalNewtonIters   = 0
      totalNewtonFails   = 0
      totalKrylovIters   = 0
      totalKrylovFails   = 0
      totalJFNKtimeSteps = 0
      _END_MASTER(myThid)
C     this cannot be done here, because globalArea is only defined
C     after S/R PACKAGES_INIT_FIXED, so we move it to S/R SEAICE_INIT_VARIA
CML      CALL SEAICE_MAP2VEC( nVec, rAw, rAs,
CML     &     scalarProductMetric, .TRUE., myThid )
CML      DO bj=myByLo(myThid),myByHi(myThid)
CML       DO bi=myBxLo(myThid),myBxHi(myThid)
CML        DO i=1,nVec
CML         scalarProductMetric(i,1,bi,bj) =
CML     &        scalarProductMetric(i,1,bi,bj)/globalArea
CML        ENDDO
CML       ENDDO
CML      ENDDO
#endif /* SEAICE_ALLOW_JFNK */

C--   all threads wait for master to finish initialisation of shared params
      _BARRIER

#ifdef ALLOW_DIAGNOSTICS
      IF ( useDiagnostics ) THEN
        CALL SEAICE_DIAGNOSTICS_INIT( myThid )
      ENDIF
#endif

C--   Summarise pkg/seaice configuration
      CALL SEAICE_SUMMARY( myThid )

C--   Initialise grid parameters that do no change during the integration

C--   Initialise grid info
      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
C-    loops on tile indices bi,bj:
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          HEFFM  (i,j,bi,bj) = maskC(i,j,kSrf,bi,bj)
#ifdef SEAICE_CGRID
          SIMaskU(i,j,bi,bj) = maskW(i,j,kSrf,bi,bj)
          SIMaskV(i,j,bi,bj) = maskS(i,j,kSrf,bi,bj)
#endif
         ENDDO
        ENDDO
#ifdef SEAICE_BGRID_DYNAMICS
        DO j=1-OLy+1,sNy+OLy
         DO i=1-OLx+1,sNx+OLx
          UVM(i,j,bi,bj)=0. _d 0
          mask_uice=HEFFM(i,j,  bi,bj)+HEFFM(i-1,j-1,bi,bj)
     &             +HEFFM(i,j-1,bi,bj)+HEFFM(i-1,j,  bi,bj)
          IF(mask_uice.GT.3.5 _d 0) UVM(i,j,bi,bj)=1. _d 0
         ENDDO
        ENDDO
#endif

C     coefficients for metric terms
#if ( defined SEAICE_CGRID || defined SEAICE_BGRID_DYNAMICS )
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          k1AtC(i,j,bi,bj) = 0.0 _d 0
          k2AtC(i,j,bi,bj) = 0.0 _d 0
          k1AtU(i,j,bi,bj) = 0.0 _d 0
          k1AtV(i,j,bi,bj) = 0.0 _d 0
          k2AtU(i,j,bi,bj) = 0.0 _d 0
          k2AtV(i,j,bi,bj) = 0.0 _d 0
# ifdef SEAICE_CGRID
          k1AtZ(i,j,bi,bj) = 0.0 _d 0
          k2AtZ(i,j,bi,bj) = 0.0 _d 0
# endif
         ENDDO
        ENDDO
        IF ( SEAICEselectMetricTerms .GT. 0 ) THEN
         IF ( usingSphericalPolarGrid ) THEN
C     This is the only case where tan(phi) is not zero. In this case
C     C and U points, and Z and V points have the same phi, so that we
C     only need a copy here. Do not use tan(YC) and tan(YG), because
C     these
C     can be the geographical coordinates and not the correct grid
C     coordinates when the grid is rotated (phi/theta/psiEuler .NE. 0)
          DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
            k2AtC(i,j,bi,bj) = - _tanPhiAtU(i,j,bi,bj)*recip_rSphere
            k2AtU(i,j,bi,bj) = - _tanPhiAtU(i,j,bi,bj)*recip_rSphere
            k2AtV(i,j,bi,bj) = - _tanPhiAtV(i,j,bi,bj)*recip_rSphere
# ifdef SEAICE_CGRID
            k2AtZ(i,j,bi,bj) = - _tanPhiAtV(i,j,bi,bj)*recip_rSphere
# endif
           ENDDO
          ENDDO
         ELSEIF ( usingCurvilinearGrid ) THEN
C     compute metric term coefficients from finite difference
C     approximation
          DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx-1
            k1AtC(i,j,bi,bj) = _recip_dyF(i,j,bi,bj)
     &           * ( _dyG(i+1,j,bi,bj) - _dyG(i,j,bi,bj) )
     &           * _recip_dxF(i,j,bi,bj)
           ENDDO
          ENDDO
          DO j=1-OLy,sNy+OLy-1
           DO i=1-OLx,sNx+OLx
            k2AtC(i,j,bi,bj) = _recip_dxF(i,j,bi,bj)
     &           * ( _dxG(i,j+1,bi,bj) - _dxG(i,j,bi,bj) )
     &           * _recip_dyF(i,j,bi,bj)
           ENDDO
          ENDDO
          DO j=1-OLy,sNy+OLy
           DO i=1-OLx+1,sNx+OLx
            k1AtU(i,j,bi,bj) = _recip_dyG(i,j,bi,bj)
     &           * ( _dyF(i,j,bi,bj) - _dyF(i-1,j,bi,bj) )
     &           * _recip_dxC(i,j,bi,bj)
           ENDDO
          ENDDO
          DO j=1-OLy,sNy+OLy-1
           DO i=1-OLx,sNx+OLx
            k2AtU(i,j,bi,bj) = _recip_dxC(i,j,bi,bj)
     &           * ( _dxV(i,j+1,bi,bj) - _dxV(i,j,bi,bj) )
     &           * _recip_dyG(i,j,bi,bj)
           ENDDO
          ENDDO
          DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx-1
            k1AtV(i,j,bi,bj) = _recip_dyC(i,j,bi,bj)
     &           * ( _dyU(i+1,j,bi,bj) - _dyU(i,j,bi,bj) )
     &           * _recip_dxG(i,j,bi,bj)
           ENDDO
          ENDDO
          DO j=1-OLy+1,sNy+OLy
           DO i=1-OLx,sNx+OLx
            k2AtV(i,j,bi,bj) = _recip_dxG(i,j,bi,bj)
     &           * ( _dxF(i,j,bi,bj) - _dxF(i,j-1,bi,bj) )
     &           * _recip_dyC(i,j,bi,bj)
           ENDDO
          ENDDO
# ifdef SEAICE_CGRID
          DO j=1-OLy,sNy+OLy
           DO i=1-OLx+1,sNx+OLx
            k1AtZ(i,j,bi,bj) = _recip_dyU(i,j,bi,bj)
     &           * ( _dyC(i,j,bi,bj) - _dyC(i-1,j,bi,bj) )
     &           * _recip_dxV(i,j,bi,bj)
           ENDDO
          ENDDO
          DO j=1-OLy+1,sNy+OLy
           DO i=1-OLx,sNx+OLx
            k2AtZ(i,j,bi,bj) = _recip_dxV(i,j,bi,bj)
     &           * ( _dxC(i,j,bi,bj) - _dxC(i,j-1,bi,bj) )
     &           * _recip_dyU(i,j,bi,bj)
           ENDDO
          ENDDO
# endif /* SEAICE_CGRID */
         ENDIF
        ENDIF
#endif /* SEAICE_CGRID or SEAICE_BGRID_DYNAMICS */

#ifdef SEAICE_CGRID
        IF ( SEAICEselectMetricTerms .LT. 2 ) THEN
C     Resetting metric factors at U,V-pointw to zero removes the extra
C     terms in the stress divergence
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           k1AtU(i,j,bi,bj) = 0.0 _d 0
           k2AtU(i,j,bi,bj) = 0.0 _d 0
           k1AtV(i,j,bi,bj) = 0.0 _d 0
           k2AtV(i,j,bi,bj) = 0.0 _d 0
          ENDDO
         ENDDO
        ENDIF
#endif /* SEAICE_CGRID */

#ifdef SEAICE_BGRID_DYNAMICS
C--   Choose a proxy level for geostrophic velocity,
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          KGEO(i,j,bi,bj)   = 0
         ENDDO
        ENDDO
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
#ifdef SEAICE_BICE_STRESS
          KGEO(i,j,bi,bj) = 1
#else /* SEAICE_BICE_STRESS */
          IF (klowc(i,j,bi,bj) .LT. 2) THEN
           KGEO(i,j,bi,bj) = 1
          ELSE
           KGEO(i,j,bi,bj) = 2
           DO WHILE ( abs(rC(KGEO(i,j,bi,bj))) .LT. 50.0 _d 0 .AND.
     &          KGEO(i,j,bi,bj) .LT. (klowc(i,j,bi,bj)-1) )
              KGEO(i,j,bi,bj) = KGEO(i,j,bi,bj) + 1
           ENDDO
          ENDIF
#endif /* SEAICE_BICE_STRESS */
         ENDDO
        ENDDO
#endif /* SEAICE_BGRID_DYNAMICS */
C-    end bi,bj loops
       ENDDO
      ENDDO

#ifdef SEAICE_ALLOW_SIDEDRAG
      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        DO j=1-OLy+1,sNy+OLy-1
         DO i=1-OLx+1,sNx+OLx-1
          coastRoughU(i,j,bi,bj) = ( 3. _d 0
     &         - SIMaskU(i,j-1,bi,bj)
     &         - SIMaskU(i,j,bi,bj)
     &         - SIMaskU(i,j+1,bi,bj)) * SIMaskU(i,j,bi,bj)
          coastRoughV(i,j,bi,bj) = ( 3. _d 0
     &         - SIMaskV(i-1,j,bi,bj)
     &         - SIMaskV(i,j,bi,bj)
     &         - SIMaskV(i+1,j,bi,bj) ) * SIMaskV(i,j,bi,bj)
         ENDDO
        ENDDO
       ENDDO
      ENDDO

      readCoastLineFields =
     &     uCoastLineFile .NE. ' ' .OR. vCoastLineFile .NE. ' '
      IF ( readCoastLineFields ) THEN
       IF ( uCoastLineFile .NE. ' ' ) THEN
        CALL READ_FLD_XY_RL( uCoastLineFile,' ',coastRoughU,0,myThid )
        DO bj=myByLo(myThid),myByHi(myThid)
         DO bi=myBxLo(myThid),myBxHi(myThid)
          DO j=1-OLy,sNy+OLy-1
           DO i=1-OLx,sNx+OLx
            coastRoughU(i,j,bi,bj) = coastRoughU(i,j,bi,bj)
     &           * SIMaskU(i,j,bi,bj) * recip_dxC(i,j,bi,bj)
           ENDDO
          ENDDO
         ENDDO
        ENDDO
       ENDIF
       IF ( vCoastLineFile .NE. ' ' ) THEN
        CALL READ_FLD_XY_RL( vCoastLineFile,' ',coastRoughV,0,myThid )
        DO bj=myByLo(myThid),myByHi(myThid)
         DO bi=myBxLo(myThid),myBxHi(myThid)
          DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx-1
            coastRoughV(i,j,bi,bj) = coastRoughV(i,j,bi,bj)
     &           * SIMaskV(i,j,bi,bj) * recip_dyC(i,j,bi,bj)
           ENDDO
          ENDDO
         ENDDO
        ENDDO
       ENDIF
      ENDIF

      CALL EXCH_UV_XY_RL( coastRoughU, coastRoughV, .FALSE., myThid )
C     Write coastRoughU/V fields only we are actually going to use them
C     to reduce unnecessary output
      IF ( SEAICEsideDrag .NE. 0. _d 0 ) THEN
       CALL WRITE_FLD_XY_RL( 'coastRoughUnormalized',
     &      ' ', coastRoughU, -1, myThid )
       CALL WRITE_FLD_XY_RL( 'coastRoughVnormalized',
     &      ' ', coastRoughV, -1, myThid )
      ENDIF
#endif /* SEAICE_ALLOW_SIDEDRAG */

#ifdef ALLOW_SHELFICE
      IF ( useShelfIce ) THEN
       DO bj=myByLo(myThid),myByHi(myThid)
        DO bi=myBxLo(myThid),myBxHi(myThid)
C--   Prevent seaice to form where Ice-Shelf is present
          CALL SHELFICE_MASK_SEAICE(
     U                  HEFFM,
     I                  bi, bj, -1, myThid )
          DO j=2-OLy,sNy+OLy
           DO i=2-OLx,sNx+OLx
            IF ( HEFFM(i-1,j,bi,bj).EQ.zeroRL .OR.
     &           HEFFM( i, j,bi,bj).EQ.zeroRL )
     &           SIMaskU(i,j,bi,bj) = zeroRL
            IF ( HEFFM(i,j-1,bi,bj).EQ.zeroRL .OR.
     &           HEFFM(i, j, bi,bj).EQ.zeroRL )
     &           SIMaskV(i,j,bi,bj) = zeroRL
           ENDDO
          ENDDO
        ENDDO
       ENDDO
       CALL EXCH_UV_XY_RL( SIMaskU, SIMaskV, .FALSE., myThid )
      ENDIF
#endif /* ALLOW_SHELFICE */

      RETURN
      END

#include "FIZHI_OPTIONS.h"
       subroutine update_ocean_exports (myTime, myIter, myThid)
c----------------------------------------------------------------------
c  Subroutine update_ocean_exports - 'Wrapper' routine to update
c        the fields related to the ocean surface that are needed
c        by fizhi (sst and sea ice extent).
c
c Call:  getsst  (Return the current sst field-read dataset if needed)
c        getsice (Return the current sea ice field-read data if needed)
c-----------------------------------------------------------------------
       implicit none
#include "SIZE.h"
#include "GRID.h"
#include "fizhi_ocean_coms.h"
#include "EEPARAMS.h"
#include "chronos.h"
#ifdef ALLOW_EXCH2
#include "W2_EXCH2_SIZE.h"
#include "W2_EXCH2_TOPOLOGY.h"
#endif /* ALLOW_EXCH2 */

       integer myIter, myThid
       _RL myTime

       INTEGER xySize
#if defined(ALLOW_EXCH2)
       PARAMETER ( xySize = W2_ioBufferSize )
#else
       PARAMETER ( xySize = Nx*Ny )
#endif
       integer i, j, bi, bj, bislot, bjslot
       integer im1, im2, jm1, jm2, idim1, idim2, jdim1, jdim2
       integer xsize, ysize
       _RL        sstmin
       parameter ( sstmin = 273.16 )

       _RL sst1 (xySize), sst2 (xySize)
       _RL sice1(xySize), sice2(xySize)
c      _RL sst1(xsize,ysize),sst2(xsize,ysize)
c      _RL sice1(xsize,ysize),sice2(xsize,ysize)
       integer nymd1sst(nSx,nSy),nymd2sst(nSx,nSy)
       integer nymd1sice(nSx,nSy),nymd2sice(nSx,nSy)
       integer nhms1sst(nSx,nSy),nhms2sst(nSx,nSy)
       integer nhms1sice(nSx,nSy),nhms2sice(nSx,nSy)
       integer sstdates(370,nSx,nSy),sicedates(370,nSx,nSy)
       integer ssttimes(370,nSx,nSy),sicetimes(370,nSx,nSy)
       logical first(nSx,nSy)
       integer nSxnSy
       parameter(nSxnSy = nSx*nSy)
       data first/nSxnSy*.true./

       save nymd1sst,nymd2sst,nymd1sice,nymd2sice
       save nhms1sst,nhms2sst,nhms1sice,nhms2sice
       save sst1, sst2, sice1, sice2
       save sstdates, sicedates
       save ssttimes, sicetimes

#if defined(ALLOW_EXCH2)
       xsize = exch2_global_Nx
       ysize = exch2_global_Ny
#else
       xsize = Nx
       ysize = Ny
#endif
       idim1 = 1-OLx
       idim2 = sNx+OLx
       jdim1 = 1-OLy
       jdim2 = sNy+OLy
       im1 = 1
       im2 = sNx
       jm1 = 1
       jm2 = sNy

C***********************************************************************

       DO BJ = myByLo(myThid),myByHi(myThid)
       DO BI = myBxLo(myThid),myBxHi(myThid)
#if defined(ALLOW_EXCH2)
       bislot = exch2_txglobalo(W2_myTileList(bi,bj))-1
       bjslot = exch2_tyglobalo(W2_myTileList(bi,bj))-1
#else
       bislot = myXGlobalLo-1+(bi-1)*sNx
       bjslot = myYGlobalLo-1+(bj-1)*sNy
#endif

       call getsst(ksst,sstclim,idim1,idim2,jdim1,jdim2,im1,im2,
     .  jm1,jm2,nSx,nSy,xsize,ysize,bi,bj,bislot,bjslot,nymd,nhms,
     .  sst1,sst2,first(bi,bj),nymd1sst(bi,bj),nymd2sst(bi,bj),
     .  nhms1sst(bi,bj),nhms2sst(bi,bj),sstdates(1,bi,bj),
     .  ssttimes(1,bi,bj),sst,myThid)
       call getsice(kice,siceclim,idim1,idim2,jdim1,jdim2,im1,im2,
     .  jm1,jm2,nSx,nSy,xsize,ysize,bi,bj,bislot,bjslot,nymd,nhms,
     .  sice1,sice2,first(bi,bj),nymd1sice(bi,bj),nymd2sice(bi,bj),
     .  nhms1sice(bi,bj),nhms2sice(bi,bj),sicedates(1,bi,bj),
     .  sicetimes(1,bi,bj),sice,myThid)

c Check for Minimum Open-Water SST
c --------------------------------
       do j=jm1,jm2
       do i=im1,im2
       if(sice(i,j,bi,bj).eq.0.0 .and. sst(i,j,bi,bj).lt.sstmin)
     .                                          sst(i,j,bi,bj) = sstmin
       enddo
       enddo

       ENDDO
       ENDDO
       _EXCH_XY_RL(sst,myThid)
       _EXCH_XY_RL(sice,myThid)

       return
       end

       subroutine getsice(iunit,clim,idim1,idim2,jdim1,jdim2,im1,im2,
     .   jm1,jm2,nSumx,nSumy,xsize,ysize,bi,bj,bislot,bjslot,nymd,nhms,
     .   sicebc1,sicebc2,first,nymdbc1,nymdbc2,nhmsbc1,nhmsbc2,
     .   nymdbc,nhmsbc,sice,mythid)
C***********************************************************************
C
C!ROUTINE: GETSICE
C!DESCRIPTION: GETSICE returns the sea ice depth.
C!             This routine is adaptable for any frequency
C!             data upto a daily frequency.
C!             note: for diurnal data ndmax should be increased.
C
C!INPUT PARAMETERS:
C!      iunit     Unit number assigned to the sice data file
C!      idim1     Start dimension in x-direction
C!      idim2     End dimension in x-direction
C!      jdim1     Start dimension in y-direction
C!      jdim2     End dimension in y-direction
C!      im1       Begin of x-direction span for filling sice
C!      im2       End of x-direction span for filling sice
C!      jm1       Begin of y-direction span for filling sice
C!      jm2       End of y-direction span for filling sice
C!      nSumx     Number of processors in x-direction (local processor)
C!      nSumy     Number of processors in y-direction (local processor)
C!      xsize      Number of processors in x-direction (global)
C!      ysize      Number of processors in y-direction (global)
C!      bi        Processor number in x-direction (local to processor)
C!      bj        Processor number in y-direction (local to processor)
C!      bislot  Processor number in x-direction (global)
C!      bjslot  Processor number in y-direction (global)
C!      nymd   YYMMDD of the current model timestep
C!      nhms   HHMMSS of the model time
C
C!OUTPUT PARAMETERS:
C!      sice(idim1:idim2,jdim1:jdim2,nSumx,nSumy) Sea ice depth in meters
C
C!ROUTINES CALLED:
C
C!      bcdata      Reads the data for a given unit number
C!      bcheader     Reads the header info for a given unit number
C!      interp_time  Returns weights for linear interpolation
C
C--------------------------------------------------------------------------

      implicit none
#include "SIZE.h"
#include "GRID.h"

      integer iunit,idim1,idim2,jdim1,jdim2,im1,im2,jm1,jm2,nSumx,nSumy
      integer xsize,ysize,bi,bj,bislot,bjslot,nymd,nhms,mythid

      _RL sicebc1(xsize,ysize)
      _RL sicebc2(xsize,ysize)
      _RL sice(idim1:idim2,jdim1:jdim2,nSumx,nSumy)
      integer nhmsbc1,nhmsbc2,nymdbc1,nymdbc2
      logical first
      logical clim

C Maximum number of dates in one year for the data
      integer   ndmax
      parameter (ndmax = 370)
      integer nymdbc(ndmax),nhmsbc(ndmax)

      integer i,j

      do j = jm1,jm2
      do i = im1,im2
       sice(i,j,bi,bj) = 0.
      enddo
      enddo

      return
      end
      subroutine getsst(iunit,clim,idim1,idim2,jdim1,jdim2,im1,im2,
     .   jm1,jm2,nSumx,nSumy,xsize,ysize,bi,bj,bislot,bjslot,nymd,nhms,
     .   sstbc1,sstbc2,first,nymdbc1,nymdbc2,nhmsbc1,nhmsbc2,
     .   nymdbc,nhmsbc,sst,mythid)
C***********************************************************************
C
C!ROUTINE: GETSST
C!DESCRIPTION: GETSST gets the SST data.
C!             This routine is adaptable for any frequency
C!             data upto a daily frequency.
C!             note: for diurnal data ndmax should be increased.
C
C!INPUT PARAMETERS:
C!      iunit     Unit number assigned to the sice data file
C!      idim1     Start dimension in x-direction
C!      idim2     End dimension in x-direction
C!      jdim1     Start dimension in y-direction
C!      jdim2     End dimension in y-direction
C!      im1       Begin of x-direction span for filling sst
C!      im2       End of x-direction span for filling sst
C!      jm1       Begin of y-direction span for filling sst
C!      jm2       End of y-direction span for filling sst
C!      nSumx     Number of processors in x-direction (local processor)
C!      nSumy     Number of processors in y-direction (local processor)
C!      xsize     x-dimension of global array
C!      ysize     y-dimension of global array
C!      bi        Processor number in x-direction (local to processor)
C!      bj        Processor number in y-direction (local to processor)
C!      bislot    Slot number into global array in x-direction (global)
C!      bjslot    Slot number into global array in y-direction (global)
C!      nymd      YYMMDD of the current model timestep
C!      nhms      HHMMSS of the model time
C
C!OUTPUT PARAMETERS:
C!     sst(idim1:idim2,jdim1:jdim2,nSumx,nSumy) Sea surface temperature (K)
C
C!ROUTINES CALLED:
C
C!     bcdata      Reads the data for a given unit number
C!     bcheader     Reads the header info for a given unit number
C!     interp_time      Returns weights for linear interpolation
C
C--------------------------------------------------------------------------

      implicit none
#include "SIZE.h"
#include "GRID.h"

      integer iunit,idim1,idim2,jdim1,jdim2,im1,im2,jm1,jm2,nSumx,nSumy
      integer xsize,ysize,bi,bj,bislot,bjslot,nymd,nhms,mythid

      _RL sstbc1(xsize,ysize)
      _RL sstbc2(xsize,ysize)
      _RL sst(idim1:idim2,jdim1:jdim2,nSumx,nSumy)
      integer nhmsbc1,nhmsbc2,nymdbc1,nymdbc2
      logical first
      logical clim

C Maximum number of dates in one year for the data
      integer   ndmax
      parameter (ndmax = 370)
      integer nymdbc(ndmax),nhmsbc(ndmax)

      _RL getcon
      _RL pi,pio2,pio3,mpio3,pio36,deg2rad,sinarg 
c     _RL factor,cosarg1,cosarg2

      integer i,j

      deg2rad = getcon('DEG2RAD')
      pi = getcon('PI')
      pio2 = pi / 2. _d 0
      pio3 = pi / 3. _d 0
      pio36 = pi / 36. _d 0
      mpio3 = -1. _d 0 * pi / 3. _d 0

      do j = jm1,jm2
      do i = im1,im2
C Control - max sst on equator, zonally symmetric
       if( abs(yc(i,j,bi,bj)*deg2rad)  .lt. pio3 ) then
        sinarg = 3.*yc(i,j,bi,bj)*deg2rad/2.
        sst(i,j,bi,bj) = 273.16 + 27.*(1.-(sin(sinarg)*sin(sinarg)))
       else
        sst(i,j,bi,bj) = 273.16
       endif
C Experiment 2 - Peaked
C      if( abs(yc(i,j,bi,bj)*deg2rad)  .lt. pio3 ) then
C       factor = 3.*abs(yc(i,j,bi,bj))*deg2rad/pi
C       sst(i,j,bi,bj) = 273.16 + 27.*(1.-factor)
C      else
C       sst(i,j,bi,bj) = 273.16
C      endif
C Experiment 3 - Flat
C      if( abs(yc(i,j,bi,bj)*deg2rad)  .lt. pio3 ) then
C       sinarg = 3.*yc(i,j,bi,bj)*deg2rad/2.
C       sst(i,j,bi,bj) = 273.16 +
C    .        27.*(1.-(sin(sinarg)*sin(sinarg)*sin(sinarg)*sin(sinarg)))
C      else
C       sst(i,j,bi,bj) = 273.16
C      endif
C Experiment 4 - Qobs - average of control and exp 3
C      if( abs(yc(i,j,bi,bj)*deg2rad)  .lt. pio3 ) then
C       sinarg = 3.*yc(i,j,bi,bj)*deg2rad/2.
C       sst(i,j,bi,bj) = 273.16 + 0.5*27*
C    .   (2.- (sin(sinarg)*sin(sinarg)) -
C    .        (sin(sinarg)*sin(sinarg)*sin(sinarg)*sin(sinarg)))
C      else
C       sst(i,j,bi,bj) = 273.16
C      endif
C Experiment 5 - max sst at 5N, zonally symmetric
C      if( (yc(i,j,bi,bj)*deg2rad  .lt. pio3 ) .and.
C    .     (yc(i,j,bi,bj)*deg2rad  .gt. pio36 ) ) then
C       sinarg = (90./55.)*(yc(i,j,bi,bj)*deg2rad-pio36)
C       sst(i,j,bi,bj) = 273.16 + 27.*(1.-(sin(sinarg)*sin(sinarg)))
C      elseif ( (yc(i,j,bi,bj)*deg2rad  .le. pio36 ) .and.
C    .     (yc(i,j,bi,bj)*deg2rad  .gt. mpio3 ) ) then
C       sinarg = (90./65.)*(yc(i,j,bi,bj)*deg2rad-pio36)
C       sst(i,j,bi,bj) = 273.16 + 27.*(1.-(sin(sinarg)*sin(sinarg)))
C      else
C       sst(i,j,bi,bj) = 273.16
C      endif
C Experiment 6 - 1KEQ max sst at equator, + anomaly centered at greenwich
C   first set the control sst profile
C      if( abs(yc(i,j,bi,bj)*deg2rad)  .lt. pio3 ) then
C       sinarg = 3.*yc(i,j,bi,bj)*deg2rad/2.
C       sst(i,j,bi,bj) = 273.16 + 27.*(1.-(sin(sinarg)*sin(sinarg)))
C      else
C       sst(i,j,bi,bj) = 273.16
C      endif
C   and now add the anomaly
C      if( (abs(yc(i,j,bi,bj)) .lt. 15. _d 0) .and.
C    .     (abs(xc(i,j,bi,bj)) .lt. 30. _d 0) ) then
C       cosarg1 = pio2*(xc(i,j,bi,bj)/30. _d 0)
C       cosarg2 = pio2*(yc(i,j,bi,bj)/15. _d 0)
C       sst(i,j,bi,bj) = sst(i,j,bi,bj) +
C    .     cos(cosarg1)*cos(cosarg1)*cos(cosarg2)*cos(cosarg2)
C      endif
C Experiment 7 - 3KEQ max sst at equator, + anomaly centered at greenwich
C   first set the control sst profile
C      if( abs(yc(i,j,bi,bj)*deg2rad)  .lt. pio3 ) then
C       sinarg = 3.*yc(i,j,bi,bj)*deg2rad/2.
C       sst(i,j,bi,bj) = 273.16 + 27.*(1.-(sin(sinarg)*sin(sinarg)))
C      else
C       sst(i,j,bi,bj) = 273.16
C      endif
C   and now add the anomaly
C      if( (abs(yc(i,j,bi,bj)) .lt. 15. _d 0) .and.
C    .     (abs(xc(i,j,bi,bj)) .lt. 30. _d 0) ) then
C       cosarg1 = pio2*(xc(i,j,bi,bj)/30. _d 0)
C       cosarg2 = pio2*(yc(i,j,bi,bj)/15. _d 0)
C       sst(i,j,bi,bj) = sst(i,j,bi,bj) +
C    .     3.*cos(cosarg1)*cos(cosarg1)*cos(cosarg2)*cos(cosarg2)
C      endif
C Experiment 8 - 3KW1 max sst at equator, +/- anomaly centered at greenwich
C   first set the control sst profile
C      if( abs(yc(i,j,bi,bj)*deg2rad)  .lt. pio3 ) then
C       sinarg = 3.*yc(i,j,bi,bj)*deg2rad/2.
C       sst(i,j,bi,bj) = 273.16 + 27.*(1.-(sin(sinarg)*sin(sinarg)))
C      else
C       sst(i,j,bi,bj) = 273.16
C      endif
C   and now add the anomaly
C      if( abs(yc(i,j,bi,bj))  .lt. 30.0 _d 0 ) then
C       cosarg1 = (xc(i,j,bi,bj))*deg2rad
C       cosarg2 = pio2*(yc(i,j,bi,bj)/30.0 _d 0)
C       sst(i,j,bi,bj) = sst(i,j,bi,bj) +
C    .             3.*cos(cosarg1)*cos(cosarg2)*cos(cosarg2)
C      endif
      enddo
      enddo

      return
      end

#include "ctrparam.h"
#ifdef OCEAN_3D
#  include "ATM2D_OPTIONS.h"
#endif
C
      SUBROUTINE FORWARD_STEP_ATM2D(iloop, myTime, myIter, myThid)
C     |==========================================================|
C     | Does time loop for one coupled period. The main loop     |
C     | this is the MITGCM main loop OR a separate driver for    |
C     | IGSM 2.2                                                 |
C     \==========================================================/
      IMPLICIT NONE

#include "ATMSIZE.h"
#include "DRIVER.h"

#ifdef OCEAN_3D
#  include "SIZE.h"
#  include "EEPARAMS.h"
#  include "PARAMS.h"
#  include "ATM2D_VARS.h"
#endif

#ifdef NCEPWIND
      COMMON  /SEED/JSEED,IFRST,NEXTN
      INTEGER JSEED,IFRST,NEXTN
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     iloop  - loop counter for coupled period time steps (main time loop)
C     myIter - iteration counter for this thread (ocean times steps +nIter0)
C     myTime - time counter for this thread (ocean time, from starttTime)
C     myThid - thread number for this instance of the routine.
      INTEGER iloop
      REAL*8  myTime
      INTEGER myIter
      INTEGER myThid

C     === Local variables ===
      INTEGER idyear ! year # of simulation, starting at year 1
      INTEGER iyr    ! year # of simulation, starting from specified inyear
      INTEGER inyr   ! hours into the current year, end of coupled period
      INTEGER monid  ! current month of the year
      INTEGER inday  ! hour of the day, end of the coupled period
      INTEGER dayid  ! day of the current month
      INTEGER j,mn,na,no   !loop counters
      INTEGER jdofmhr(0:12)
      DATA jdofmhr/0,744,1416,2160,2880,3624,4344,5088,
     &                  5832,6552,7296,8016,8760/
C i.e. 0,31*24,59*24,90*24,120*24,151*24,181*24,
C      212*24,243*24,273*24,304*24,334*24,365*24
#ifdef CPL_TEM
      INTEGER ndmonth(12)
      DATA ndmonth/31,28,31,30,31,30,31,31,30,31,30,31/
      REAL*4 totup, aduptt
      REAL*8 tcumn
#endif
#if (defined CPL_TEM) || (defined CPL_OCEANCO2)
      REAL*8 nepan
      REAL*8 ocuptp
#endif
#ifdef OCEAN_3D
      INTEGER iloop_ocn, i
      _RL qPrcRn(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
#  ifdef NCEPWIND
      REAL*8  RAND
      CHARACTER *4 ncep_yr
#  endif
#endif
#ifdef DATA4TEM
      CHARACTER *40 f4tem,f4clm,f24tem,f34tem
      CHARACTER *4  cfile
      CHARACTER *8  f14tem,f14clm
      character *9 f124tem,f134tem
      f14tem='data4tem'
      f14clm='data4clm'
      f124tem='data24tem'
      f134tem='data34tem'
      nfile=1
#endif

C     print *,'*** Top of forwrdstep_atm',iloop,myTime,myIter
      idyear= int((iloop-1)*dtcouple/365.0/24.0) + 1
      iyr= idyear + startYear -1
      inyr = mod(iloop*dtcouple, 365*24)
      IF (inyr .EQ. 0) inyr=jdofmhr(12)
      DO mn=1,12
        IF ((inyr.GT.jdofmhr(mn-1)).AND.(inyr.LE.jdofmhr(mn))) monid=mn
      ENDDO
      inday= mod(iloop*dtcouple, 24)
      dayid= int((inyr-dtcouple-jdofmhr(monid-1))/24.0) +1
C     print *,'*** idyear,iyr,inyr,monid,inday,dayid',
C    &             idyear,iyr,inyr,monid,inday,dayid

      IF (inyr.EQ.dtcouple) THEN !do this block at start of new year
        PRINT *,'*** Starting a new year'
#ifdef NCEPWIND
        WRITE(ncep_yr,'(I4)') (NINT(RAND()*60.0+0.5) + 1947)
        PRINT *,'Using NCEP wind variations from year: ',ncep_yr
         OPEN(6007,
     &     FILE='ncep_taux_variations_'//ncep_yr//'.bin',STATUS='old',
     &     ACCESS='direct', RECL=4*sNx*sNy,
     &     FORM='unformatted')
         OPEN(6008,
     &     FILE='ncep_tauy_variations_'//ncep_yr//'.bin',STATUS='old',
     &     ACCESS='direct', RECL=4*sNx*sNy,
     &     FORM='unformatted')
         OPEN(6009,
     &     FILE='ncep_speed_variations_'//ncep_yr//'.bin',STATUS='old',
     &     ACCESS='direct', RECL=4*sNx*sNy,
     &     FORM='unformatted')
         ncep_counter = 1
#endif
#ifdef DATA4TEM
        IF (nfile.gt.1)THEN
          CLOSE(935)
          CLOSE(937)
          CLOSE(938)
          CLOSE(939)
        ENDIF
        IF(iyr.gt.1000) THEN
           nfile=iyr
        ELSE
          nfile=1000+iyr
        ENDIF
        WRITE (cfile,'i4'),nfile
        f4tem=f14tem//cfile
        f4clm=f14clm//cfile
        f24tem=f124tem//cfile
        f34tem=f134tem//cfile
        OPEN(935,file=f4clm,form='unformatted',status='new')
        OPEN(937,file=f4tem,form='unformatted',status='new')
        OPEN(938,file=f24tem,form='unformatted',status='new')
        OPEN(939,file=f34tem,form='unformatted',status='new')
        nfile=nfile+1
#endif
#ifdef CPL_TEM
        nepan=0.0
        ch4ann=0.0
        n2oann=0.0
        xco2ann=0.0
#endif
#ifdef CPL_OCEANCO2
        temuptann=0.
        DO j=1,jm0
          co24ocnan(j)=0.0
        ENDDO
#  ifdef ML_2D
          call kvcarbon(iyr)
#  endif
#endif
#ifdef CPL_TEM
        DO j=1,jm0
          antemnep(j)=0.
        ENDDO
#  ifndef CPL_CHEM
        CALL robso3(iyr)
#  endif
C For land use
        CALL updatelcluc(idyear)
#endif
#ifdef CPL_CHEM
        print *,' Before eppaemission'
        CALL eppaemission (iyr)
#endif
      ENDIF   !end block done at year-start

      IF (inyr.EQ.jdofmhr(monid-1)+dtcouple) THEN !do this block month start
       PRINT *,'***Starting a new month'
#ifdef CPL_TEM
        CALL zclimate2tem
#endif
#ifdef CPL_OCEANCO2
        ocumn=0.0
        DO j=1,jm0
          fluxco2mn(j)=0.0
        ENDDO
#endif
#ifdef OCEAN_3D
        new_mon= .TRUE.
#endif
      ENDIF  !end block at start of the month
C
C------------------- Top of Coupled Period Loop --------------------------
C

#ifdef OCEAN_3D
#  ifdef NCEPWIND
C     Read in the next timestep of ncep wind stress variations
C      PRINT *,'*** Read in next NCEP record'
      READ(6007, REC=ncep_counter), fu_ncep
      READ(6008, REC=ncep_counter), fv_ncep
      READ(6009, REC=ncep_counter), fs_ncep
      ncep_counter=ncep_counter+1
#  endif
#  ifdef ATM2D_MPI_ON
      CALL CPL_RECV_OCN_FIELDS
#  endif
      CALL GET_OCNVARS( myTime, myIter, myThid)
      IF ( (iloop.NE.1).OR. (iloop.EQ.1.AND.
     &      (startTime.NE.baseTime .OR. nIter0.NE.0)) ) THEN
C       don't run the ice growth/melt on step 1 if "cold" start
        DO j = 1-OLy, sNy+OLy
         DO i = 1-OLx, sNx+OLx
          qPrcRn(i,j) = 0.
         ENDDO
        ENDDO
        CALL THSICE_STEP_FWD( 1, 1, 1, sNx, 1, sNy,
     I                        pass_prcAtm, snowPrc, qPrcRn,
     &                        myTime, myIter, myThid )
        CALL THSICE_AVE( 1,1, myTime, myIter, myThid )
      ENDIF
      CALL CALC_ZONAL_MEANS(.TRUE.,myThid)
      CALL PUT_OCNVARS(myTime,myIter,myThid)
      CALL SUM_YR_END_DIAGS(myTime,myIter,myThid)
#  ifdef ATM2D_MPI_ON
      CALL CPL_SEND_OCN_FIELDS
#  endif
#endif

C      PRINT *,'Top of ncall_atm Loop'
      DO na=1,ncall_atm    !loop for atmos forward time steps
        CALL atmosphere(dtatm,monid)
#ifdef OCEAN_3D
        CALL ATM2OCN_MAIN(iloop, na, monid, myIter, myThid)
        CALL SUM_OCN_FLUXES(myThid)
        CALL PASS_THSICE_FLUXES(myThid)
        CALL THSICE_IMPL_TEMP(netSW, sFlx, dTsurf, 1,1,
     &                        myTime, myIter, myThid)
        CALL SUM_THSICE_OUT(myThid)
        CALL CALC_ZONAL_MEANS(.FALSE.,myThid) !just mean Tsrf recalculated
#endif
      ENDDO  ! ncall_atm loop

C      PRINT *,'Top of ncall_ocean Loop'
      DO no=1,ncall_ocean   !loop for each ocean forward step

#ifdef OCEAN_3D
        iloop_ocn = nint((iloop-1)*dtcouplo/deltaTClock) + no
#  ifndef ATM2D_MPI_ON
        CALL FORWARD_STEP(iloop_ocn, myTime, myIter, myThid )
#  else
        myIter = nIter0 + iloop_ocn
        myTime = startTime + deltaTClock *float (iloop_ocn)
        CALL DO_THE_MODEL_IO( .FALSE., myTime, myIter, myThid )
        CALL DO_WRITE_PICKUP( .FALSE., myTime, myIter, myThid )
#  endif
#endif
#ifdef ML_2D
        CALL ocean_ml(dtocn*3600.,dtatm*3600.)
#endif

      ENDDO ! ncall_ocean loop

C Start of code done at the end of every coupled period

#ifdef OCEAN_3D
      CALL NORM_OCN_FLUXES(myThid)
      CALL ATM2D_WRITE_PICKUP(.FALSE., myTime, myIter, myThid)
#endif

C
C--------------------- End of coupled period loop --------------------
C
      IF (inday.EQ.0) THEN  !do this block if end-of-day
C        PRINT *,'***block at end of day'
      ENDIF  !end block end-of-day

      IF (inyr.EQ.jdofmhr(monid)) THEN !do block if month-end
        PRINT *,'***end of month reached'
#ifdef CLM
#  ifdef CPL_TEM
        CALL climate2tem(monid,ndmonth(monid))
c        PRINT *,'From driver before call tem',' idyear=',idyear
        CALL tem(idyear,monid-1)
        CALL tem2climate(idyear,monid-1)
        ch4mn=0.0
        n2omn=0.0
        nepmn=0.0
        DO j=1,jm0
          ch4mn=ch4mn+temch4(j)
          n2omn=n2omn+temn2o(j)
          nepmn=nepmn+temco2(j)
        ENDDO
#    ifdef CPL_NEM
        PRINT *,'Month=',monid
        PRINT *,'CH4=',ch4mn/1.e9,' N2O=',n2omn/1.e9
        OPEN(277,ACCESS='APPEND',FILE=fnememiss,form='unformatted'
     &     ,STATUS='old')
        WRITE (277) iyr,monid,ch4mn,n2omn,nepmn,
     &          temch4,temn2o,temco2
        CLOSE(277)
#    endif
        DO j=1,jm0
          temnep(monid,j)=temco2(j)
        ENDDO
        DO j=1,jm0
          antemnep(j)=antemnep(j)+temnep(monid,j)
          nepan=nepan+temnep(monid,j)
          ch4ann=ch4ann+temch4(j)
          n2oann=n2oann+temn2o(j)
        ENDDO

#  endif
#endif

#ifdef OCEAN_3D
        CALL MONTH_END_DIAGS( monid, myTime, myIter, myThid)
#endif

#ifdef CPL_OCEANCO2
        IF (monid.EQ.12) THEN
          ocupt=ocupt*12.e-15
C   12.e-15 from moles to Gt carbon
          ocuptp=ocupt
          ocupt=0.0
        ENDIF
#endif

#ifdef IPCC_EMI
        PRINT *,'Month=',monid
        nepmn=nepmn/1000.
C         nepmn is converted from Tg/mn to Gt/mn of C
        ocumn=ocumn*12.e-15
C         ocumn is converted from mole(C) to Gt (C)
C        tnow= jyear + (jday-.5)/365.
C        CALL emissipcc(tnow,nepmn,ocumn,CO2,xco2ann)
         print *,nepmn,ocumn,xco2ann
C         ch4mn is in kg/mn of CH4
C         nepmn is in Gt/mn of C
         tcumn=nepmn-ch4mn*12./16.*1.e-12
         print *,'tcumn,ocumn,xco2ann'
         print *,tcumn,ocumn,xco2ann
        CALL emissipcc_mn(tcumn,ocumn,xco2ann)
C       CALL emissipcc_mn(nepmn,ocumn,xco2ann)
#endif
      ENDIF  !end block done at month-end

      IF (inyr .EQ. jdofmhr(12)) THEN ! do this block at year-end
        PRINT *,'***end of year reached'
#ifdef CPL_TEM
        nepan=nepan/1000.
        IF (iyr.ge.1981.and.iyr.le.1990) THEN
          PRINT *,'Uptake avegaging year=',iyr
          nepav=nepav+nepan
          aocuav=aocuav+OCUPTP
          IF (iyr.eq.1990) THEN
            nepav=nepav/10.
            aocuav=aocuav/10.
            totup=nepav+aocuav
            aduptt=4.1-totup
            PRINT *,' Carbon uptake for spinup'
            PRINT *,' totup=',totup,' aocuav=',aocuav
            PRINT *,' nepav=',nepav,' aduptt=',aduptt
          ENDIF
        ENDIF

        IF (iyr.eq.endYear) THEN
C         NEM emissions and NEP for start of climate-chemistry run
          adupt=aduptt
           CALL wr_rstrt_nem
        ENDIF

#endif

#ifdef ML_2D
C    Data for the restart of the 2D ML model
        CALL wrrstrt_ocean
#endif

#ifdef OCEAN_3D
        IF ((mod(iyr,taveDump).EQ.0).AND.(idyear.GE.taveDump)) THEN
          CALL TAVE_END_DIAGS( taveDump, myTime, myIter, myThid)
        ELSEIF (mod(iyr,taveDump).EQ.0) THEN
          CALL TAVE_END_DIAGS( idyear, myTime, myIter, myThid)
        ENDIF
        CALL YR_END_DIAGS(iyr,myTime,myIter,myThid)
C If necessary, next line can be moved outside OCEAN_3D for IGSM2.2 cleanups
        IF (iloop.EQ.nTimeSteps) CALL ATM2D_FINISH(myThid)
#  ifdef NCEPWIND
        OPEN(unit=334,file='rand_state_new.dat',status='replace')
        WRITE(334,*) JSEED,IFRST,NEXTN
        CLOSE(334)
#  endif
#endif

#if (defined CPL_TEM) || (defined CPL_OCEANCO2)
        PRINT '(a6,i6,2(a5,f10.4))','Year=',iyr,
     &         ' NEP=',nepan,' OCU=',OCUPTP
#  ifdef IPCC_EMI
        PRINT '(a6,i6,(a5,f10.4))','Year=',iyr,
     &         ' CO2AN=',xco2ann/12.
        CALL emissipcc_yr
#  endif

#  ifdef CPL_NEM
        PRINT *,' CH4=',ch4ann,' N2O=',n2oann
#  endif
        OPEN(333,ACCESS='APPEND',FILE=caruptfile,STATUS='old')
#    ifndef CPL_TEM
C       For ocean carbon model only
        WRITE(333,'(i7,3e15.5)')iyr,ocuptp
#    else
#      ifndef CPL_OCEANCO2
C       For ocean TEM only
        WRITE(333,'(i7,3e15.5)')iyr,nepan,nepan-1.e-12*ch4ann*12./16.
#      else
C        For ocean both TEM OCM
        WRITE(333,'(i7,3e15.5)')iyr,nepan,nepan-1.e-12*ch4ann*12./16.
     &                  ,ocuptp
#      endif
#    endif
        CLOSE(333)
#  if (defined CPL_OCEANCO2) && (defined ML_2D)
        WRITE(602)iyr
        CALL wrgary
        CALL zerogary
#  endif
#endif

#ifdef CPL_OCEANCO2
        DO j=1,jm0
#  ifdef OCEAN_3D
          co24ocnan(j)=co24ocnan(j)*dtatm/24.0/365.0
#  else
          co24ocnan(j)=co24ocnan(j)/365.0
#  endif
        ENDDO
        PRINT *,' CO2 for ocean model',' ncallatm=',ncall_atm
        PRINT '(12f7.1,/,2(11f7.1,/),12f7.1)',co24ocnan
#endif

#ifdef CPL_CHEM
        PRINT *,' TEMUPTANN=',temuptann,' TOTAL UPTAKE='
     &          ,ocuptp+temuptann
#endif
      ENDIF  !year-end block

      RETURN
      END

#ifdef NCEPWIND
      REAL*8 FUNCTION RAND()
C
C  This function returns a pseudo-random number for each invocation.
C  It is a FORTRAN 77 adaptation of the "Integer Version 2" minimal
C  standard number generator whose Pascal code appears in the article:
C
C     Park, Steven K. and Miller, Keith W., "Random Number Generators:
C     Good Ones are Hard to Find", Communications of the ACM,
C     October, 1988.
C
      PARAMETER (MPLIER=16807,MODLUS=2147483647,MOBYMP=127773,
     +           MOMDMP=2836)
C
      COMMON  /SEED/JSEED,IFRST,NEXTN
      INTEGER JSEED,IFRST,NEXTN
      INTEGER HVLUE, LVLUE, TESTV
C
      IF (IFRST .EQ. 0) THEN
        NEXTN = JSEED
        IFRST = 1
      ENDIF
C
      HVLUE = NEXTN / MOBYMP
      LVLUE = MOD(NEXTN, MOBYMP)
      TESTV = MPLIER*LVLUE - MOMDMP*HVLUE
      IF (TESTV .GT. 0) THEN
        NEXTN = TESTV
      ELSE
        NEXTN = TESTV + MODLUS
      ENDIF
      RAND = REAL(NEXTN)/REAL(MODLUS)
C
      RETURN
      END
#endif

#include "SEAICE_OPTIONS.h"
#ifdef ALLOW_EXF
# include "EXF_OPTIONS.h"
#endif
#ifdef ALLOW_AUTODIFF
# include "AUTODIFF_OPTIONS.h"
#endif

CBOP
C     !ROUTINE: SEAICE_REG_RIDGE
C     !INTERFACE:
      SUBROUTINE SEAICE_REG_RIDGE( myTime, myIter, myThid )
C     !DESCRIPTION: \bv
C     *=================================================================*
C     | SUBROUTINE seaice_reg_ridge
C     | o this routine has two purposes:
C     |   (1) clean up after advection (undershoots etc.);
C     |       after advection, the sea ice variables may have unphysical
C     |       values, e.g. < 0 or very thin ice, that are regularized
C     |       here.
C     |   (2) driver for ice ridging;
C     |       concentration as a special case may be > 1 in convergent
C     |       motion and a ridging algorithm redistributes the ice to
C     |       limit the concentration to 1.
C     | o called after S/R seaice_advdiff
C     *=================================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "SEAICE_SIZE.h"
#include "SEAICE_PARAMS.h"
#ifdef SEAICE_VARIABLE_SALINITY
# include "SEAICE_GRID.h"
#endif
#include "SEAICE.h"
#include "SEAICE_TRACER.h"
#ifdef ALLOW_EXF
# include "EXF_FIELDS.h"
#endif
#ifdef ALLOW_AUTODIFF_TAMC
# include "tamc.h"
#endif /* ALLOW_AUTODIFF_TAMC */

C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
C     myTime :: Simulation time
C     myIter :: Simulation timestep number
C     myThid :: Thread no. that called this routine.
      _RL myTime
      INTEGER myIter, myThid

#ifdef ALLOW_SEAICE
C     !LOCAL VARIABLES:
C     === Local variables ===
C     i,j,bi,bj :: Loop counters
      INTEGER i, j, bi, bj
C     number of surface interface layer
C     IT :: ice thickness category index (ITD and SEAICE_multDim code)
      INTEGER IT
C     reciprocal of time step
      _RL recip_deltaTtherm
C     temporary variables available for the various computations
      _RL tmpscal1, tmpscal2
#ifdef SEAICE_ITD
      _RL tmpscal1itd(1:sNx,1:sNy), tmpscal2itd(1:sNx,1:sNy)
      _RL tmpscal3itd(1:sNx,1:sNy)
C     reciprocal number of ice classes nITD
      _RL recip_nitd
#endif /* SEAICE_ITD */
#ifdef ALLOW_DIAGNOSTICS
C     Helper variables for diagnostics
      _RL DIAGarrayA    (1:sNx,1:sNy)
#endif /* ALLOW_DIAGNOSTICS */
#ifdef ALLOW_AUTODIFF_TAMC
C     tkey :: tape key (depends on tiles)
      INTEGER tkey
#endif
CEOP

C
C     === Routine body ===
C
      recip_deltaTtherm = ONE / SEAICE_deltaTtherm

      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)

#ifdef ALLOW_AUTODIFF_TAMC
        tkey = bi + (bj-1)*nSx + (ikey_dynamics-1)*nSx*nSy
#endif /* ALLOW_AUTODIFF_TAMC */

        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          d_HEFFbyNEG(i,j,bi,bj)    = 0.0 _d 0
          d_HSNWbyNEG(i,j,bi,bj)    = 0.0 _d 0
#ifdef EXF_SEAICE_FRACTION
          d_AREAbyRLX(i,j,bi,bj)    = 0.0 _d 0
          d_HEFFbyRLX(i,j,bi,bj)    = 0.0 _d 0
#endif /* EXF_SEAICE_FRACTION */
#ifdef SEAICE_VARIABLE_SALINITY
          saltFluxAdjust(i,j,bi,bj) = 0.0 _d 0
#endif /* SEAICE_VARIABLE_SALINITY */
         ENDDO
        ENDDO

C =====================================================================
C ========== PART 1: treat pathological cases (post advdiff) ==========
C =====================================================================

#if (defined ALLOW_AUTODIFF && defined SEAICE_MODIFY_GROWTH_ADJ)
Cgf no dependency through pathological cases treatment
        IF ( SEAICEadjMODE.EQ.0 ) THEN
#endif

#ifdef EXF_SEAICE_FRACTION
CADJ STORE heff(:,:,bi,bj) = comlev1_bibj, key = tkey,byte=isbyte
CADJ STORE area(:,:,bi,bj) = comlev1_bibj, key = tkey,byte=isbyte
C--   (0) relax sea ice concentration towards observation
        IF ( SEAICE_tauAreaObsRelax .GT. zeroRL ) THEN
         DO j=1,sNy
          DO i=1,sNx
           IF ( exf_iceFraction(i,j,bi,bj).GT.AREA(i,j,bi,bj) ) THEN
            d_AREAbyRLX(i,j,bi,bj) =
     &       SEAICE_deltaTtherm/SEAICE_tauAreaObsRelax
     &       * (exf_iceFraction(i,j,bi,bj) - AREA(i,j,bi,bj))
           ENDIF
           IF ( exf_iceFraction(i,j,bi,bj).GT.zeroRS .AND.
     &          AREA(i,j,bi,bj).EQ.0. _d 0) THEN
C           d_HEFFbyRLX(i,j,bi,bj) = 1. _d 1 * siEps * d_AREAbyRLX(i,j,bi,bj)
            d_HEFFbyRLX(i,j,bi,bj) = 1. _d 1 * siEps
           ENDIF
#ifdef SEAICE_ITD
           AREAITD(i,j,1,bi,bj) = AREAITD(i,j,1,bi,bj)
     &                          +  d_AREAbyRLX(i,j,bi,bj)
           HEFFITD(i,j,1,bi,bj) = HEFFITD(i,j,1,bi,bj)
     &                          +  d_HEFFbyRLX(i,j,bi,bj)
#endif /* SEAICE_ITD */
           AREA(i,j,bi,bj) = AREA(i,j,bi,bj) +  d_AREAbyRLX(i,j,bi,bj)
           HEFF(i,j,bi,bj) = HEFF(i,j,bi,bj) +  d_HEFFbyRLX(i,j,bi,bj)
          ENDDO
         ENDDO
        ENDIF
#endif /* EXF_SEAICE_FRACTION */

C--   (1) treat the case of negative values:

#ifdef SEAICE_ITD
        DO IT=1,SEAICE_multDim
         DO j=1,sNy
          DO i=1,sNx
           tmpscal1=0. _d 0
           tmpscal2=0. _d 0
           tmpscal1=MAX(-HEFFITD(i,j,IT,bi,bj),0. _d 0)
           HEFFITD(i,j,IT,bi,bj)=HEFFITD(i,j,IT,bi,bj)+tmpscal1
           d_HEFFbyNEG(i,j,bi,bj)=d_HEFFbyNEG(i,j,bi,bj)+tmpscal1
           tmpscal2=MAX(-HSNOWITD(i,j,IT,bi,bj),0. _d 0)
           HSNOWITD(i,j,IT,bi,bj)=HSNOWITD(i,j,IT,bi,bj)+tmpscal2
           d_HSNWbyNEG(i,j,bi,bj)=d_HSNWbyNEG(i,j,bi,bj)+tmpscal2
           AREAITD(i,j,IT,bi,bj)=MAX(AREAITD(i,j,IT,bi,bj),0. _d 0)
C     AREA, HEFF, and HSNOW will be updated at end of PART 1
C     by calling SEAICE_ITD_SUM
          ENDDO
         ENDDO
        ENDDO
C     update mean thicknesses HEFF and HSNOW and total ice
C     concentration AREA to match single category values
        CALL SEAICE_ITD_SUM   ( bi, bj, myTime, myIter, myThid )
#else /* ndef SEAICE_ITD */
#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE heff(:,:,bi,bj)  = comlev1_bibj, key = tkey,byte=isbyte
CADJ STORE hsnow(:,:,bi,bj) = comlev1_bibj, key = tkey,byte=isbyte
CADJ STORE area(:,:,bi,bj)  = comlev1_bibj, key = tkey,byte=isbyte
#endif /* ALLOW_AUTODIFF_TAMC */
        DO j=1,sNy
         DO i=1,sNx
          d_HEFFbyNEG(i,j,bi,bj)=MAX(-HEFF(i,j,bi,bj),0. _d 0)
          HEFF(i,j,bi,bj)=HEFF(i,j,bi,bj)+d_HEFFbyNEG(i,j,bi,bj)
          d_HSNWbyNEG(i,j,bi,bj)=MAX(-HSNOW(i,j,bi,bj),0. _d 0)
          HSNOW(i,j,bi,bj)=HSNOW(i,j,bi,bj)+d_HSNWbyNEG(i,j,bi,bj)
          AREA(i,j,bi,bj)=MAX(AREA(i,j,bi,bj),0. _d 0)
         ENDDO
        ENDDO
#endif /* SEAICE_ITD */

C--   (2) treat the case of very thin ice:

#ifdef SEAICE_ITD
C     Here we risk that even though HEFF may be larger than siEps (=1e-5)
C     HEFFITD can have classes with very small (< siEps) non-zero ice volume.
C     We avoid applying the correction to each class because that leads to
C     funny structures in the net heat and freshwater flux into the ocean.
C     Let us keep our fingers crossed, that the model will be benign!
        DO IT=1,SEAICE_multDim
         DO j=1,sNy
          DO i=1,sNx
           IF (HEFF(i,j,bi,bj).LE.siEps) THEN
            HEFFITD(i,j,IT,bi,bj) = 0. _d 0
            HSNOWITD(i,j,IT,bi,bj) = 0. _d 0
           ENDIF
          ENDDO
         ENDDO
        ENDDO
#endif /* SEAICE_ITD */
#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE heff(:,:,bi,bj) = comlev1_bibj, key = tkey,byte=isbyte
C     The following statement helps TAF to understand that TICES is not
C     modified/reset everywhere so that it is correctly stored in the
C     outer checkpoint levels. This is a TAF bug and this statement can
C     probably be removed again, once this bug is fixed (but it does not
C     hurt, either).
CADJ INCOMPLETE TICES
#endif /* ALLOW_AUTODIFF_TAMC */
        DO j=1,sNy
         DO i=1,sNx
          tmpscal1=0. _d 0
          tmpscal2=0. _d 0
          IF (HEFF(i,j,bi,bj).LE.siEps) THEN
           tmpscal1=-HEFF(i,j,bi,bj)
           tmpscal2=-HSNOW(i,j,bi,bj)
           DO IT=1,SEAICE_multDim
            TICES(i,j,IT,bi,bj)=celsius2K
           ENDDO
          ENDIF
          HEFF(i,j,bi,bj)=HEFF(i,j,bi,bj)+tmpscal1
          HSNOW(i,j,bi,bj)=HSNOW(i,j,bi,bj)+tmpscal2
          d_HEFFbyNEG(i,j,bi,bj)=d_HEFFbyNEG(i,j,bi,bj)+tmpscal1
          d_HSNWbyNEG(i,j,bi,bj)=d_HSNWbyNEG(i,j,bi,bj)+tmpscal2
         ENDDO
        ENDDO

C--   (3) treat the case of area but no ice/snow:

#ifdef SEAICE_ITD
        DO IT=1,SEAICE_multDim
         DO j=1,sNy
          DO i=1,sNx
           IF ( (HEFFITD(i,j,IT,bi,bj) .EQ.0. _d 0).AND.
     &          (HSNOWITD(i,j,IT,bi,bj).EQ.0. _d 0))
     &          AREAITD(i,j,IT,bi,bj)=0. _d 0
          ENDDO
         ENDDO
        ENDDO
#else /* ndef SEAICE_ITD */
#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE heff(:,:,bi,bj)  = comlev1_bibj, key = tkey,byte=isbyte
CADJ STORE hsnow(:,:,bi,bj) = comlev1_bibj, key = tkey,byte=isbyte
#endif /* ALLOW_AUTODIFF_TAMC */
         DO j=1,sNy
          DO i=1,sNx
           IF ((HEFF(i,j,bi,bj).EQ.0. _d 0).AND.
     &        (HSNOW(i,j,bi,bj).EQ.0. _d 0)) AREA(i,j,bi,bj)=0. _d 0
         ENDDO
        ENDDO
#endif /* SEAICE_ITD */

C--   (4) treat the case of very small area:

#ifndef DISABLE_AREA_FLOOR
#ifdef SEAICE_ITD
        recip_nitd = 1. _d 0 / float(SEAICE_multDim)
        DO IT=1,SEAICE_multDim
         DO j=1,sNy
          DO i=1,sNx
           IF ((HEFFITD(i,j,IT,bi,bj).GT.0).OR.
     &          (HSNOWITD(i,j,IT,bi,bj).GT.0)) THEN
C     SEAICE_area_floor*SEAICE_multDim cannot be allowed to exceed 1
C     hence use SEAICE_area_floor devided by SEAICE_multDim
C     (or install a warning in e.g. seaice_readparms.F)
            AREAITD(i,j,IT,bi,bj)=
     &        MAX(AREAITD(i,j,IT,bi,bj),SEAICE_area_floor*recip_nitd)
          ENDIF
         ENDDO
        ENDDO
       ENDDO
#else /* ndef SEAICE_ITD */
#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE area(:,:,bi,bj)  = comlev1_bibj, key = tkey,byte=isbyte
#endif /* ALLOW_AUTODIFF_TAMC */
       DO j=1,sNy
        DO i=1,sNx
         IF ((HEFF(i,j,bi,bj).GT.0).OR.(HSNOW(i,j,bi,bj).GT.0)) THEN
          AREA(i,j,bi,bj)=MAX(AREA(i,j,bi,bj),SEAICE_area_floor)
         ENDIF
        ENDDO
       ENDDO
#endif /* SEAICE_ITD */
#endif /* DISABLE_AREA_FLOOR */

C     (5) treat sea ice salinity pathological cases
#ifdef SEAICE_VARIABLE_SALINITY
#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE hsalt(:,:,bi,bj) = comlev1_bibj, key = tkey,byte=isbyte
CADJ STORE heff(:,:,bi,bj)  = comlev1_bibj, key = tkey,byte=isbyte
#endif /* ALLOW_AUTODIFF_TAMC */
        DO j=1,sNy
         DO i=1,sNx
          IF ( (HSALT(i,j,bi,bj) .LT. 0.0).OR.
     &         (HEFF(i,j,bi,bj) .EQ. 0.0)  ) THEN
             saltFluxAdjust(i,j,bi,bj) = - HEFFM(i,j,bi,bj) *
     &            HSALT(i,j,bi,bj) * recip_deltaTtherm
             HSALT(i,j,bi,bj) = 0.0 _d 0
          ENDIF
         ENDDO
        ENDDO
#endif /* SEAICE_VARIABLE_SALINITY */

C =====================================================================
C ========== PART 2: ridging algorithm  ===============================
C =====================================================================

C     treat case of excessive ice cover, e.g., due to ridging:

#ifdef SEAICE_ITD

C     catch up with item (2) that involves category sums AREA and HEFF
        DO j=1,sNy
         DO i=1,sNx
          tmpscal1itd(i,j) = 0. _d 0
          tmpscal2itd(i,j) = 0. _d 0
          tmpscal3itd(i,j) = 0. _d 0
         ENDDO
        ENDDO
        DO IT=1,SEAICE_multDim
         DO j=1,sNy
          DO i=1,sNx
C     TICES was changed above (item 2), now update TICE as ice volume
C     weighted average of TICES
           tmpscal1itd(i,j)=tmpscal1itd(i,j)
     &          +        TICES(i,j,IT,bi,bj) * HEFFITD(i,j,IT,bi,bj)
           tmpscal2itd(i,j)=tmpscal2itd(i,j) + HEFFITD(i,j,IT,bi,bj)
C     also compute total of AREAITD for diagnostics and SItrArea
           tmpscal3itd(i,j)=tmpscal3itd(i,j) + AREAITD(i,j,IT,bi,bj)
          ENDDO
         ENDDO
        ENDDO
        DO j=1,sNy
         DO i=1,sNx
C     save pre-ridging ice concentration for diagnostics:
C     these lines are executed before "ridging" is applied to AREA
C     hence we execute them here before SEAICE_ITD_REDIST is called
C     although this means that AREA has not been completely regularized
#ifdef ALLOW_DIAGNOSTICS
          DIAGarrayA(i,j) = tmpscal3itd(i,j)
#endif
#ifdef ALLOW_SITRACER
          SItrAREA(i,j,bi,bj,1)=tmpscal3itd(i,j)
#endif
         ENDDO
        ENDDO
C     ridge ice according to Lipscomb et al. (2007), Bitz et al. (2001)
C     Thorndyke et al. (1975), Hibler (1980)
        CALL SEAICE_DO_RIDGING( bi, bj, myTime, myIter, myThid )
C     check that all ice thickness categories meet their limits
C     (includes Hibler-type ridging)
        CALL SEAICE_ITD_REDIST( bi, bj, myTime, myIter, myThid )
C     update mean thicknesses HEFF and HSNOW and total ice
C     concentration AREA to match single category values
        CALL SEAICE_ITD_SUM   ( bi, bj, myTime, myIter, myThid )

#else /* ifndef SEAICE_ITD */

#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE area(:,:,bi,bj)  = comlev1_bibj, key = tkey,byte=isbyte
#endif /* ALLOW_AUTODIFF_TAMC */
        DO j=1,sNy
         DO i=1,sNx
C     save pre-ridging ice concentration for diagnostics
#ifdef ALLOW_DIAGNOSTICS
          DIAGarrayA(i,j) = AREA(i,j,bi,bj)
#endif /*  ALLOW_DIAGNOSTICS */
#ifdef ALLOW_SITRACER
          SItrAREA(i,j,bi,bj,1)=AREA(i,j,bi,bj)
#endif /*  ALLOW_SITRACER */
C     this is the simple Hibler (1979)-type ridging (capping of
C     concentrations > 1) for the non-ITD sea ice model
          AREA(i,j,bi,bj)=MIN(AREA(i,j,bi,bj),SEAICE_area_max)
         ENDDO
        ENDDO

#endif /* SEAICE_ITD */

#if (defined ALLOW_AUTODIFF && defined SEAICE_MODIFY_GROWTH_ADJ)
C        end SEAICEadjMODE.EQ.0 statement:
        ENDIF
#endif

#ifdef ALLOW_DIAGNOSTICS
        IF ( useDiagnostics ) THEN
         CALL DIAGNOSTICS_FILL(DIAGarrayA,'SIareaPR',0,1,3,bi,bj,myThid)
        ENDIF
#endif /* ALLOW_DIAGNOSTICS */

C close bi,bj loops
       ENDDO
      ENDDO

#endif /* ALLOW_SEAICE */
      RETURN
      END

#include "CPP_OPTIONS.h"

      _RL FUNCTION ETA_GL_PRIME_STREAMICE (X, M1, M2, Y0, W)

!      This function returns the derivative of ETA_GL_STREAMICE
!      w.r.t. its first argument


!     X: input variable
!     M1: slope of y where x<0
!     M2: slope of y where x>0
!     Y0: value of y at 0
!     W: width of smoothing

       _RL X, M1, M2, Y0, W
       _RL TMP1, PI


       IF (X.le.-0.5*W) THEN
         ETA_GL_PRIME_STREAMICE = M1
       ELSEIF(X.gt.0.5*W) THEN
         ETA_GL_PRIME_STREAMICE = M2
       ELSE
         PI = 3.14159265358979323844D0
         TMP1 = SIN (PI*X/W)
         ETA_GL_PRIME_STREAMICE = 
     &     0.5*M1 * (1-TMP1) + 
     &     0.5*M2 * (1+TMP1)
       ENDIF

       RETURN
       END 

#include "STREAMICE_OPTIONS.h"
#ifdef ALLOW_AUTODIFF
# include "AUTODIFF_OPTIONS.h"
#endif
#include "AD_CONFIG.h"

CBOP
C     !ROUTINE: adstreamice_dump
C     !INTERFACE:
      subroutine adstreamice_dump( myTime, myIter, myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE adstreamice_dump                              |
C     *==========================================================*
C     Extract adjoint variable from TAF-generated
C     adjoint common blocks, contained in adcommon.h
C     and write fields to file;
C     Make sure common blocks in adcommon.h are up-to-date
C     w.r.t. current adjoint code.
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     == Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "STREAMICE.h"
#include "GRID.h"
#ifdef ALLOW_AUTODIFF_MONITOR
# include "adcommon.h"
#endif

      LOGICAL  DIFFERENT_MULTIPLE
      EXTERNAL DIFFERENT_MULTIPLE
      INTEGER  IO_ERRCOUNT
      EXTERNAL IO_ERRCOUNT

C     !INPUT/OUTPUT PARAMETERS:
C     myTime - time counter for this thread
C     myIter - iteration counter for this thread
C     myThid - Thread number for this instance of the routine.
      _RL     myTime
      integer myIter
      integer myThid

#if (defined (ALLOW_ADJOINT_RUN) || defined (ALLOW_ADMTLM))

C     !LOCAL VARIABLES:
C     suff - Hold suffix part of a filename
C     beginIOErrCount - Begin and end IO error counts
C     endIOErrCount
C     msgBuf - Error message buffer
      CHARACTER*(MAX_LEN_FNAM) suff
      INTEGER beginIOErrCount
      INTEGER endIOErrCount
      CHARACTER*(MAX_LEN_MBUF) msgBuf

      double precision :: area_shelf_streamice_ad(1-OLx:sNx+OLx,1-OLy:
     $sNy+OLy,nSx,nSy)
      double precision :: b_glen_ad(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      double precision :: bdot_streamice_ad(1-OLx:sNx+OLx,1-OLy:sNy+OLy,
     $nSx,nSy)
      double precision :: c_basal_friction_ad(1-OLx:sNx+OLx,1-OLy:sNy+
     $OLy,nSx,nSy)
      double precision :: float_frac_streamice_ad(1-OLx:sNx+OLx,1-OLy:
     $sNy+OLy,nSx,nSy)
      double precision :: h_streamice_ad(1-OLx:sNx+OLx,1-OLy:sNy+OLy,
     $nSx,nSy)
      double precision :: surf_el_streamice_ad(1-OLx:sNx+OLx,1-OLy:sNy+
     $OLy,nSx,nSy)
      double precision :: tau_beta_eff_streamice_ad(1-OLx:sNx+OLx,1-OLy:
     $sNy+OLy,nSx,nSy)
      double precision :: u_streamice_ad(1-OLx:sNx+OLx,1-OLy:sNy+OLy,
     $nSx,nSy)
      double precision :: v_streamice_ad(1-OLx:sNx+OLx,1-OLy:sNy+OLy,
     $nSx,nSy)
      double precision :: visc_streamice_ad(1-OLx:sNx+OLx,1-OLy:sNy+OLy,
     $nSx,nSy)
      common /streamice_fields_rl_ad/ h_streamice_ad, u_streamice_ad,
     $v_streamice_ad, visc_streamice_ad, tau_beta_eff_streamice_ad,
     $float_frac_streamice_ad, surf_el_streamice_ad,
     $area_shelf_streamice_ad, c_basal_friction_ad, b_glen_ad,
     $bdot_streamice_ad

#ifdef USE_ALT_RLOW
      double precision :: r_low_si_ad(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,
     $nSy)
      common /streamice_rlow_ad/ r_low_si_ad
#endif
CEOP

      IF (
     &  DIFFERENT_MULTIPLE(streamice_adjDump,myTime,deltaTClock)
     & ) THEN

C--     Set suffix for this set of data files.
        WRITE(suff,'(I10.10)') myIter

C--     Read IO error counter
        beginIOErrCount = IO_ERRCOUNT(myThid)

        CALL WRITE_REC_3D_RL(
     &       'ADJc_basal_friction.'//suff, writeBinaryPrec,
     &       1,  c_basal_friction_ad, 1, myIter, myThid )
        CALL WRITE_REC_3D_RL(
     &       'ADJh_streamice.'//suff, writeBinaryPrec,
     &       1,  h_streamice_ad, 1, myIter, myThid )
#ifdef USE_ALT_RLOW
        CALL WRITE_REC_3D_RL(
     &       'ADJr_low.'//suff, writeBinaryPrec,
     &       1,  r_low_si_ad, 1, myIter, myThid )
#endif
        CALL WRITE_REC_3D_RL(
     &       'ADJb_glen.'//suff, writeBinaryPrec,
     &       1,  b_glen_ad, 1, myIter, myThid )
        CALL WRITE_REC_3D_RL(
     &       'ADJbdot.'//suff, writeBinaryPrec,
     &       1,  bdot_streamice_ad, 1, myIter, myThid )

      ENDIF

#endif /* ALLOW_ADJOINT_RUN */

      RETURN
      END

#include "STREAMICE_OPTIONS.h"
#ifdef ALLOW_AUTODIFF
# include "AUTODIFF_OPTIONS.h"
#endif
#ifdef ALLOW_COST
# include "COST_OPTIONS.h"
#endif

      subroutine streamice_cost_reg_accum ( myIter, myThid )
C     *==========================================================*
C     | subroutine streamice_cost_reg_accum                      |
C     | o this routine calculates the regularisation contri-     |
C     |   bution to the per-timestep STREAMICE cost              |
C     *==========================================================*
C     |                                                          |
C     | Notes                                                    |
C     | =====                                                    |
C     *==========================================================*
      IMPLICIT NONE

C     == Global variables ===
#include "SIZE.h"
#include "GRID.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "DYNVARS.h"
#ifdef ALLOW_STREAMICE
# include "STREAMICE.h"
#endif

#ifdef ALLOW_COST
# include "cost.h"
#endif
#ifdef ALLOW_AUTODIFF_TAMC
# include "tamc.h"
#endif

C     == Routine arguments ==
C     myThid - Thread number for this instance of the routine.
      integer myIter, myThid

#ifdef ALLOW_STREAMICE_TC_COST
C     == Local variables
      _RL HAF
      integer i, j, k, bi, bj
      integer ig, jg
      integer itlo,ithi
      integer jtlo,jthi
      integer il
      logical calc_prior_cost_bglen

      _RL i_numcells, dCdx, dCdy, dBdx, dBdy, gridtimfac, dMdx, dMdy
      _RL rhoi, rhow, r, i_r, surf_err, h, hf
      _RL cfricval, bglenval, cfricvalp1, bglenvalp1

      if (STREAMICEBglenCostMaskFile .ne. ' ') then
       calc_prior_cost_bglen = .true.
      else
       calc_prior_cost_bglen = .false.
      endif

      rhoi = streamice_density
      rhow = streamice_density_ocean_avg
      r=rhoi/rhow
      i_r = 1./r
      i_numcells = 1.0/(Nx*Ny)
      gridtimfac = i_numcells / nTimeSteps

C--   Calculate cost function on tile of this instance
      DO bj=myByLo(myThid),myByHi(myThid)
        DO bi=myBxLo(myThid),myBxHi(myThid)
          do j=1,sNy
            do i=1,sNx

             cfricval = C_basal_friction(i,j,bi,bj)
             bglenval = B_glen(i,j,bi,bj)

             cfricvalp1 = C_basal_friction(i+1,j,bi,bj)
             dCdx = (Cfricvalp1-cfricval)/
     &              (dxC(i+1,j,bi,bj))
             cfricvalp1 = C_basal_friction(i,j+1,bi,bj)
             dCdy = (Cfricvalp1-cfricval)/
     &              (dxC(i,j+1,bi,bj))

             bglenvalp1 = B_glen(i+1,j,bi,bj)
             dBdx = (bglenvalp1-
     &               bglenval) /
     &              (dxC(i+1,j,bi,bj))
             bglenvalp1 = B_glen(i,j+1,bi,bj)
             dBdy = (bglenvalp1-
     &               bglenval) /
     &               (dyC(i,j+1,bi,bj))
             dMdx = (streamice_bdot_maxmelt_v(i+1,j,bi,bj)-
     &               streamice_bdot_maxmelt_v(i,j,bi,bj)) /
     &              (dxC(i+1,j,bi,bj))
             dMdy = (streamice_bdot_maxmelt_v(i,j+1,bi,bj)-
     &               streamice_bdot_maxmelt_v(i,j,bi,bj)) /
     &              (dyC(i+1,j,bi,bj))

             if (streamice_hmask(i,j,bi,bj).eq.1.0) then

              cost_func1_streamice(bi,bj) =
     &         cost_func1_streamice(bi,bj) +
     &         streamice_wgt_tikh_beta * (dCdx**2+dCdy**2) * gridtimfac
              cost_smooth_fric_streamice(bi,bj) =
     &         cost_smooth_fric_streamice(bi,bj) +
     &         streamice_wgt_tikh_beta * (dCdx**2+dCdy**2) * gridtimfac

              cost_func1_streamice(bi,bj) =
     &         cost_func1_streamice(bi,bj) +
     &         streamice_wgt_tikh_bglen * (dBdx**2+dBdy**2) * gridtimfac
              cost_smooth_glen_streamice(bi,bj) =
     &         cost_smooth_glen_streamice(bi,bj) +
     &         streamice_wgt_tikh_bglen * (dBdx**2+dBdy**2) * gridtimfac

              cost_func1_streamice(bi,bj) =
     &         cost_func1_streamice(bi,bj) +
     &         streamice_wgt_tikh_gen * (dMdx**2+dMdy**2) * gridtimfac
              cost_smooth_bdotmelt_streamice(bi,bj) =
     &         cost_smooth_bdotmelt_streamice(bi,bj) +
     &         streamice_wgt_tikh_gen * (dMdx**2+dMdy**2) * gridtimfac

              h = H_streamice(i,j,bi,bj)
              hf = -1.0 * i_r * R_low_si (i,j,bi,bj)

              IF ((h-hf) .gt. 5. .AND. B_glen0(i,j,bi,bj).gt.0.0 .and.
     &            calc_prior_cost_bglen) then

                 cost_func1_streamice(bi,bj) =
     &            cost_func1_streamice(bi,bj) +
     &            streamice_wgt_prior_bglen * gridtimfac *
     &            (B_glen(i,j,bi,bj)-B_glen0(i,j,bi,bj))**2
                 cost_prior_streamice(bi,bj) =
     &            cost_prior_streamice(bi,bj) +
     &            streamice_wgt_prior_bglen * gridtimfac *
     &            (B_glen(i,j,bi,bj)-B_glen0(i,j,bi,bj))**2

              ENDIF

             endif

            end do
          end do
        end do
      end do

#endif

      RETURN
      END

#include "CPP_EEOPTIONS.h"

      SUBROUTINE SET_WRITE_GLOBAL_FLD ( flag )
      IMPLICIT NONE
C SET_WRITE_GLOBAL_FLD( flag ) sets an internal logical state to
C indicate whether files written by subsequent call to the
C READ_WRITE_FLD package should create "global" or "tiled" files.
C   flag = .TRUE.  indicates "global" files
C   flag = .FALSE. indicates "tiled" files
C
C Arguments (input)
      LOGICAL flag
C Common
      COMMON /RD_WR_FLD/ globalFile
      LOGICAL globalFile
C
      globalFile=flag
C
      RETURN
      END

#include "MOM_FLUXFORM_OPTIONS.h"

CBOP
C !ROUTINE: MOM_V_ADV_UV

C !INTERFACE: ==========================================================
      SUBROUTINE MOM_V_ADV_UV(
     I        bi,bj,k,
     I        uTrans, vFld,
     O        AdvectFluxUV,
     I        myThid)

C !DESCRIPTION:
C Calculates the zonal advective flux of meridional momentum:
C \begin{equation*}
C F^x = \overline{U}^j \overline{v}^{i}
C \end{equation*}

C !USES: ===============================================================
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"

C !INPUT PARAMETERS: ===================================================
C  bi,bj                :: tile indices
C  k                    :: vertical level
C  uTrans               :: zonal transport
C  vFld                 :: meridional flow
C  myThid               :: thread number
      INTEGER bi,bj,k
      _RL uTrans(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL vFld(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER myThid
C !OUTPUT PARAMETERS: ==================================================
C  AdvectFluxUV         :: advective flux
      _RL AdvectFluxUV(1-OLx:sNx+OLx,1-OLy:sNy+OLy)

C !LOCAL VARIABLES: ====================================================
C  i,j                  :: loop indices
      INTEGER i,j
CEOP

      DO j=1-Oly+1,sNy+Oly
       DO i=1-Olx+1,sNx+Olx
        AdvectFluxUV(i,j) =
     &  0.25*( uTrans(i,j) + uTrans(i,j-1) )
#ifdef MOM_BOUNDARY_CONSERVE
     &      *(   vFld(i,j)*_maskS(i-1,j,k,bi,bj)
     &         + vFld(i-1,j)*_maskS(i,j,k,bi,bj) )
#else
     &      *(   vFld(i,j) +   vFld(i-1,j) )
#endif
#ifdef OLD_ADV_BCS
     &      *_maskS(i,j,k,bi,bj)
     &      *_maskS(i-1,j,k,bi,bj)
#endif /* OLD_ADV_BCS */
       ENDDO
      ENDDO

      RETURN
      END

#include "DIAG_OPTIONS.h"

      SUBROUTINE DIAGNOSTICS_WRITE(
     I                              modelEnd,
     I                              myTime, myIter, myThid )
C***********************************************************************
C  Purpose
C  -------
C    Output sequence for the (multiple) diagnostics output files
C
C  Arguments  Description
C  ----------------------
C     modelEnd :: true if call at end of model run.
C     myTime   :: Current time of simulation ( s )
C     myIter   :: Current Iteration Number
C     myThid   :: my Thread Id number
C***********************************************************************
       IMPLICIT NONE
#include "EEPARAMS.h"
#include "SIZE.h"
#include "PARAMS.h"
#include "DIAGNOSTICS_SIZE.h"
#include "DIAGNOSTICS_P2SHARE.h"
#include "DIAGNOSTICS.h"

C     !INPUT PARAMETERS:
      LOGICAL modelEnd
      _RL     myTime
      INTEGER myIter, myThid

C     !FUNCTIONS:
      LOGICAL  DIFF_PHASE_MULTIPLE
      EXTERNAL DIFF_PHASE_MULTIPLE
#ifdef ALLOW_FIZHI
      LOGICAL  ALARM2
      EXTERNAL ALARM2
#endif

c Local variables
c ===============
      INTEGER   n, nd
      INTEGER   myItM1, wrIter
      LOGICAL   dump2fileNow, write2file
      LOGICAL   writeDiags(numLists), writeStats(numLists)
      _RL       phiSec, freqSec, wrTime
#ifdef ALLOW_FIZHI
      CHARACTER *9 tagname
#endif

      IF ( myIter.NE.nIter0 ) THEN
        myItM1 = myIter - 1

C***********************************************************************
C***   Check to see if its time for Diagnostic Output                ***
C***********************************************************************

        write2file = .FALSE.
        DO n = 1,nlists
          freqSec = freq(n)
          phiSec = phase(n)

          IF ( freqSec.LT.0. ) THEN
C--     write snap-shot with suffix = myIter to be consistent with
C       time-average diagnostics (e.g., freq=-1 & freq=1):
c           wrIter = myIter
c           wrTime = myTime
C--     write snap-shot with suffix = myIter-1 to be consistent with
C       state-variable time-step:
            wrIter = myItM1
            wrTime = myTime - deltaTClock
          ELSE
            wrIter = myIter
            wrTime = myTime
          ENDIF
          dump2fileNow = DIFF_PHASE_MULTIPLE( phiSec, freqSec,
     &                                        wrTime, deltaTClock )
#ifdef ALLOW_FIZHI
          IF ( useFIZHI ) THEN
            WRITE(tagname,'(A,I2.2)')'diagtag',n
            dump2fileNow = ALARM2(tagname)
          ENDIF
#endif
#ifdef ALLOW_CAL
          IF ( useCAL ) THEN
            CALL CAL_TIME2DUMP( phiSec, freqSec, deltaTClock,
     U                          dump2fileNow,
     I                          wrTime, myIter, myThid )
          ENDIF
#endif /* ALLOW_CAL */
          IF ( dumpAtLast .AND. modelEnd
     &                    .AND. freqSec.GE.0. ) dump2fileNow = .TRUE.
          IF ( useDiag4AdjOutp ) THEN
            nd = ABS(jdiag(1,n))
            IF ( gdiag(nd)(4:4).EQ.'A' ) dump2fileNow = .FALSE.
          ENDIF
          IF ( dump2fileNow ) THEN
            write2file = .TRUE.
            CALL DIAGNOSTICS_OUT(n,wrTime,wrIter,myThid)
          ENDIF
          writeDiags(n) = dump2fileNow
C-      end loop on list id number n
        ENDDO

C---   Check to see if its time for Statistics Diag. Output

        DO n = 1,diagSt_nbLists
          freqSec = diagSt_freq(n)
          phiSec = diagSt_phase(n)

          IF ( freqSec.LT.0. ) THEN
C--     write snap-shot with suffix = myIter to be consistent with
C       time-average diagnostics (e.g., freq=-1 & freq=1):
c           wrIter = myIter
c           wrTime = myTime
C--     write snap-shot with suffix = myIter-1 to be consistent with
C       state-variable time-step:
            wrIter = myItM1
            wrTime = myTime - deltaTClock
          ELSE
            wrIter = myIter
            wrTime = myTime
          ENDIF
          dump2fileNow = DIFF_PHASE_MULTIPLE( phiSec, freqSec,
     &                                        wrTime, deltaTClock )
#ifdef ALLOW_FIZHI
          IF ( useFIZHI ) THEN
           WRITE(tagname,'(A,I2.2)')'diagStg',n
           dump2fileNow = ALARM2(tagname)
          ENDIF
#endif
#ifdef ALLOW_CAL
          IF ( useCAL ) THEN
            CALL CAL_TIME2DUMP( phiSec, freqSec, deltaTClock,
     U                          dump2fileNow,
     I                          wrTime, myIter, myThid )
          ENDIF
#endif /* ALLOW_CAL */
          IF ( dumpAtLast .AND. modelEnd
     &                    .AND. freqSec.GE.0. ) dump2fileNow = .TRUE.
          IF ( dump2fileNow ) THEN
            write2file = .TRUE.
            CALL DIAGSTATS_OUTPUT(n,wrTime,wrIter,myThid)
          ENDIF
          writeStats(n) = dump2fileNow
C-      end loop on list id number n
        ENDDO

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

        IF ( write2file ) THEN
          IF ( diag_dBugLevel.GE.debLevC ) THEN
            CALL DIAGNOSTICS_SUMMARY( 1, myTime, myIter, myThid )
          ENDIF
C-      wait for everyone before setting arrays to zero:
          _BARRIER
        ENDIF
        IF ( modelEnd ) THEN
C-      Track diagnostics pkg activation status:
c         IF ( diag_pkgStatus.NE.ready2fillDiags ) STOP
          _BARRIER
          _BEGIN_MASTER(myThid)
          diag_pkgStatus = 99
          _END_MASTER(myThid)
          _BARRIER
C       Close all Stat-diags output files
          CALL DIAGSTATS_CLOSE_IO( myThid )
        ENDIF

C--     Clear storage space:
        DO n = 1,nlists
          IF ( writeDiags(n) ) CALL DIAGNOSTICS_CLEAR(n,myThid)
        ENDDO
        DO n = 1,diagSt_nbLists
          IF ( writeStats(n) ) CALL DIAGSTATS_CLEAR( n, myThid )
        ENDDO

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
      ENDIF

      RETURN
      END

#include "PROFILES_OPTIONS.h"
#ifdef ALLOW_AUTODIFF
# include "AUTODIFF_OPTIONS.h"
#endif
#ifdef ALLOW_ECCO
# include "ECCO_OPTIONS.h"
#endif
#ifdef ALLOW_BLING
# include "BLING_OPTIONS.h"
#endif

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C !ROUTINE: PROFILES_INTERP

C !INTERFACE:
      SUBROUTINE PROFILES_INTERP(
     O                            traj_cur_out,
     I                            i_cur, j_cur,
     I                            weights_cur,
     I                            var_cur,
     I                            itr_cur,
     I                            file_cur,
     I                            myTime,
     I                            bi, bj,
     I                            myThid )

C     !DESCRIPTION:
C     3D interpolation of model counterparts for netcdf profiles data

C     !USES:
      IMPLICIT NONE
C     == Global variables ===
#include "EEPARAMS.h"
#include "SIZE.h"
#include "PARAMS.h"
#include "GRID.h"
#include "DYNVARS.h"
#ifdef ALLOW_ECCO
# include "ECCO_SIZE.h"
# include "ECCO.h"
#endif
#ifdef ALLOW_PROFILES
# include "PROFILES_SIZE.h"
# include "profiles.h"
#endif
#ifdef ALLOW_PTRACERS
# include "PTRACERS_SIZE.h"
# include "PTRACERS_FIELDS.h"
#endif
#ifdef ALLOW_BLING
# include "BLING_VARS.h"
#endif

C     !INPUT PARAMETERS:
C     i/j_cur     :: i/j - index arrays of model grid points
C     weights_cur :: weights array for profile data
C     var_cur     :: current variable name
C     itr_cur     :: index of current variable
C     file_cur    :: current filenumber
C     myTime      :: time counter for this thread
C     bi,bj       :: Tile indices
C     myThid      :: my thread ID number
#ifdef ALLOW_PROFILES
      INTEGER i_cur(NUM_INTERP_POINTS)
      INTEGER j_cur(NUM_INTERP_POINTS)
      _RL weights_cur(NUM_INTERP_POINTS)
#else
      INTEGER i_cur, j_cur
      _RL weights_cur
#endif
      CHARACTER*(8) var_cur
      INTEGER itr_cur
      INTEGER file_cur
      _RL  myTime
      INTEGER bi, bj
      INTEGER myThid

C     !OUTPUT PARAMETERS:
C     traj_cur_out :: profile of interpolated model data
#ifdef ALLOW_PROFILES
      _RL traj_cur_out(NLEVELMAX)
#else
      _RL traj_cur_out
#endif
CEOP

C     !FUNCTIONS:
      INTEGER ILNBLNK
      EXTERNAL ILNBLNK

C     !LOCAL VARIABLES:
#ifdef ALLOW_PROFILES
      INTEGER kProf, kLev
      INTEGER q, k, kcur, ierr
      _RL tab_coeffs1(NUM_INTERP_POINTS)
      _RL tab_coeffs3(NUM_INTERP_POINTS)
      _RL ponderations(NUM_INTERP_POINTS), pondsSUM
      _RL traj_cur(Nr), mask_cur(Nr)
      _RL tmp_coeff

      ierr = 0
C Horizontal interpolation:
      DO k = 1, Nr
        pondsSUM = 0. _d 0
        DO q = 1, NUM_INTERP_POINTS
          IF (var_cur.EQ.'theta') THEN
            tab_coeffs1(q) = theta(i_cur(q),j_cur(q),k,bi,bj)
          ELSEIF (var_cur.EQ.'salt') THEN
            tab_coeffs1(q) = salt(i_cur(q),j_cur(q),k,bi,bj)
          ELSEIF (var_cur.EQ.'pTracer') THEN
# ifdef ALLOW_PTRACERS
            tab_coeffs1(q) =
     &       pTracer(i_cur(q),j_cur(q),k,bi,bj,itr_cur)
# else
            tab_coeffs1(q) = 0. _d 0
# endif
# ifdef ALLOW_BLING
          ELSEIF (var_cur.EQ.'PCO') THEN
            tab_coeffs1(q) = pCO2(i_cur(q),j_cur(q),bi,bj)
          ELSEIF (var_cur.EQ.'PH') THEN
            tab_coeffs1(q) = pH(i_cur(q),j_cur(q),k,bi,bj)
          ELSEIF (var_cur.EQ.'CHL') THEN
            tab_coeffs1(q) = CHL(i_cur(q),j_cur(q),k,bi,bj)
          ELSEIF (var_cur.EQ.'POC') THEN
            tab_coeffs1(q) = POC(i_cur(q),j_cur(q),k,bi,bj)
# endif
# ifdef ALLOW_ECCO
          ELSEIF (var_cur.EQ.'eta') THEN
            tab_coeffs1(q) = m_eta(i_cur(q),j_cur(q),bi,bj)
# endif
          ELSEIF (var_cur.EQ.'UE') THEN
            tab_coeffs1(q) = m_UE(i_cur(q),j_cur(q),k,bi,bj)
          ELSEIF (var_cur.EQ.'VN') THEN
            tab_coeffs1(q) = m_VN(i_cur(q),j_cur(q),k,bi,bj)
          ELSE
            tab_coeffs1(q) = 0. _d 0
          ENDIF !IF (var_cur.EQ.

          tab_coeffs3(q) = maskC(i_cur(q),j_cur(q),k,bi,bj)

          ponderations(q) = tab_coeffs3(q)*weights_cur(q)
          pondsSUM = pondsSUM+ponderations(q)

        ENDDO !DO q

        IF (pondsSUM.GT.zeroRL) THEN
          traj_cur(k) = 0. _d 0
          mask_cur(k) = 1. _d 0
          pondsSUM = 1. _d 0 / pondsSUM

          DO q = 1, NUM_INTERP_POINTS
            traj_cur(k)=traj_cur(k)
     &       +tab_coeffs1(q)*ponderations(q)*pondsSUM
          ENDDO

        ELSE
          traj_cur(k) = 0. _d 0
          mask_cur(k) = 0. _d 0

        ENDIF !IF (pondsSUM.GT.zeroRL)

      ENDDO !DO k

# ifdef ALLOW_AUTODIFF_TAMC
C This is necessary, because TAF does not recognise prof_mask1D_cur
C as active and does not include it in the TL-version of this
C routine leading to prof_mask1D_cur=0 and also to
C objf_profiles_tl=0.
C$TAF INCOMPLETE prof_mask1D_cur

# endif
C Vertical interpolation:
      DO kLev = 1, NLEVELMAX
        traj_cur_out(kLev) = 0. _d 0
        prof_mask1D_cur(kLev,bi,bj) = 0. _d 0
      ENDDO

      DO kProf = 1, ProfDepthNo(file_cur,bi,bj)
C Case 1: above first grid center => first grid center value
        IF (prof_depth(file_cur,kProf,bi,bj).LT.-rC(1)) THEN
          traj_cur_out(kProf) = traj_cur(1)
          prof_mask1D_cur(kProf,bi,bj) = mask_cur(1)

C Case 2: just below last grid center => last cell value
        ELSEIF (prof_depth(file_cur,kProf,bi,bj).GE.-rC(Nr)) THEN
          IF ( prof_depth(file_cur,kProf,bi,bj).LT.
     &         (-rC(Nr)+drC(Nr)*halfRS) ) THEN
            traj_cur_out(kProf) = traj_cur(Nr)
            prof_mask1D_cur(kProf,bi,bj) = mask_cur(Nr)

          ENDIF

C Case 3: between two grid centers
        ELSE
          kcur = 0
          DO k = 1, Nr-1
            IF ( (prof_depth(file_cur,kProf,bi,bj).GE.-rC(k)).AND.
     &           (prof_depth(file_cur,kProf,bi,bj).LT.-rC(k+1))) THEN
              kcur = k
            ENDIF
          ENDDO

          IF (kcur.EQ.0) THEN
            WRITE(errorMessageUnit,'(A)')
     &       'ERROR in PROFILES_INTERP: unexpected case 1'

            ierr = ierr + 1

          ENDIF

          IF (mask_cur(kcur+1).EQ.oneRL) THEN
C Subcase 1: 2 wet points => linear interpolation
            tmp_coeff = (prof_depth(file_cur,kProf,bi,bj)+rC(kcur))/
     &       (-rC(kcur+1)+rC(kcur))

            traj_cur_out(kProf) = (1-tmp_coeff)*traj_cur(kcur)
     &       +tmp_coeff*traj_cur(kcur+1)

            prof_mask1D_cur(kProf,bi,bj) = 1. _d 0

            IF (mask_cur(kcur).EQ.zeroRL) THEN
              WRITE(errorMessageUnit,'(A)')
     &         'ERROR in PROFILES_INTERP: unexpected case 2'

              ierr = ierr + 1

            ENDIF

          ELSEIF (prof_depth(file_cur,kProf,bi,bj).LT.-rF(kcur+1))
     &    THEN
C Subcase 2: only 1 wet point just above => upper cell value
            traj_cur_out(kProf) = traj_cur(kcur)
            prof_mask1D_cur(kProf,bi,bj) = mask_cur(kcur)

          ENDIF !IF (mask_cur(kcur+1).EQ.oneRL)

        ENDIF !IF (prof_depth(file_cur,kProf,bi,bj).LT.-rC(1))

      ENDDO !DO kProf

      IF (ierr.GT.0) STOP 'ABNORMAL END: S/R PROFILES_INTERP'

#endif /* ALLOW_PROFILES */

      RETURN
      END

#include "CPP_OPTIONS.h"

CBOP 0
C !ROUTINE: SET_RUNOFFMAP

C !INTERFACE:
      SUBROUTINE SET_RUNOFFMAP( msgUnit )

C !DESCRIPTION:
C     *==========================================================*
C     | SUBROUTINE SET_RUNOFFMAP
C     | o define runoff mapping from atmos. grid (land) to
C     |   ocean grid
C     *==========================================================*

C !USES:
      IMPLICIT NONE
C     == Global variables ==
#include "ATMSIZE.h"
#include "OCNSIZE.h"
#include "CPL_PARAMS.h"
#include "CPL_MAP2GRIDS.h"

C !INPUT/OUTPUT PARAMETERS:
C     msgUnit    :: log-file I/O unit
      INTEGER msgUnit

C !LOCAL VARIABLES:
      INTEGER n, ijo, ija
      INTEGER lengthName, lengthRec, iRec
      Real*8  r8seg(3)
      Real*8  tmpfld(3,ROsize), rAc(Nx_ocn*Ny_ocn)
CEOP

      WRITE(msgUnit,'(2A)') 'SET_RUNOFFMAP: ','entering'

C-    Initialize to zero :
        DO n=1,ROsize
          ijROocn(n)=0
          ijROatm(n)=0
          arROmap(n)=0.
        ENDDO

        nROmap = runOffMapSize
c       lengthName=ILNBLNK( runOffMapFile ) ! eesup/src/utils.F not compiled here
        lengthName=0
        DO n=1,LEN( runOffMapFile )
         IF ( runOffMapFile(n:n).NE.' ' ) lengthName=n
        ENDDO
        WRITE(msgUnit,'(3A,I6)')
     &     ' runOffMapFile =>>', runOffMapFile(1:lengthName),
     &   '<<= , runOffMapSize=', runOffMapSize
        IF ( lengthName.EQ.0 ) nROmap=0
        IF ( nROmap.EQ.0 ) THEN
          WRITE(msgUnit,'(2A,I9,A)') 'SET_RUNOFFMAP: ',
     &                'nothing to set (nROmap=', nROmap, ' )'
          RETURN
        ENDIF
        IF ( nROmap.GT.ROsize ) THEN
          WRITE(msgUnit,'(2A)') '*** ERROR *** SET_RUNOFFMAP: ',
     &                          'runOffMapSize exceeds ROsize'
          STOP 'ABNORMAL END: S/R SET_RUNOFFMAP'
        ENDIF

C-    Read area catchment from file ;
      WRITE(msgUnit,'(2A)') 'SET_RUNOFFMAP: ','reading runOffMapFile'
c       lengthRec=3*nROmap*WORDLENGTH*2
c       OPEN(88, FILE=runOffMapFile(1:lengthName), STATUS='OLD',
c    &       ACCESS='direct', RECL=lengthRec )
c       READ(88,rec=1) tmpfld
        lengthRec=3*WORDLENGTH*2
        OPEN(88, FILE=runOffMapFile(1:lengthName), STATUS='OLD',
     &       ACCESS='direct', RECL=lengthRec )
        DO n=1,nROmap
         iRec = n
         READ(88,rec=iRec) r8seg
         tmpfld(1,n) = r8seg(1)
         tmpfld(2,n) = r8seg(2)
         tmpfld(3,n) = r8seg(3)
        ENDDO
        CLOSE(88)
#ifdef _BYTESWAPIO
         CALL MDS_BYTESWAPR8( 3*nROmap, tmpfld )
#endif
c       n=nROmap
c       WRITE(msgUnit,'(A,3I5,F11.6)') 'ROmap:',n,nint(tmpfld(1,n)),
c    &                            NINT(tmpfld(2,n)),tmpfld(3,n)*1.d-9

C-    Read (ocean) grid cell area from file ;
      WRITE(msgUnit,'(2A)') 'SET_RUNOFFMAP: ','reading OCN grid area'
        lengthRec=Nx_ocn*Ny_ocn*WORDLENGTH*2
        OPEN(88, FILE='RA.bin', STATUS='OLD',
     &       ACCESS='direct', RECL=lengthRec )
        iRec = 1
        READ(88,rec=iRec) rAc
        CLOSE(88)
#ifdef _BYTESWAPIO
        CALL MDS_BYTESWAPR8( Nx_ocn*Ny_ocn, rAc )
#endif
c       WRITE(msgUnit,*) 'rAc=', rAc(1), rAc(17), rAc(17+16*Nx_ocn)

C----------------------------------------------------------

C-    Define mapping :
        DO n=1,nROmap
          ija = NINT(tmpfld(1,n))
          ijo = NINT(tmpfld(2,n))
          IF ( ija.LT.1 .OR. ija.GT.Nx_atm*Ny_atm ) THEN
            WRITE(msgUnit,'(2A)') '*** ERROR *** SET_RUNOFFMAP: ',
     &                            'ijROatm out of range !'
            STOP 'ABNORMAL END: S/R SET_RUNOFFMAP'
          ENDIF
          ijROatm(n) = ija
          IF ( ijo.LT.1 .OR. ijo.GT.Nx_ocn*Ny_ocn ) THEN
            WRITE(msgUnit,'(2A)') '*** ERROR *** SET_RUNOFFMAP: ',
     &                            'ijROocn out of range !'
            STOP 'ABNORMAL END: S/R SET_RUNOFFMAP'
          ELSEIF ( rAc(ijo).GT.0. ) THEN
            arROmap(n) = tmpfld(3,n)/rAc(ijo);
          ELSE
            arROmap(n) = 0.
          ENDIF
          ijROocn(n) = ijo
        ENDDO

C-      print to check :
        n = 1
        WRITE(msgUnit,'(A,3I5,F9.6)') ' check ROmap:',
     &                          n,ijROatm(n),ijROocn(n),arROmap(n)
        n = nROmap
        WRITE(msgUnit,'(A,3I5,F9.6)') ' check ROmap:',
     &                          n,ijROatm(n),ijROocn(n),arROmap(n)

      WRITE(msgUnit,'(2A,I9,A)') 'SET_RUNOFFMAP: ',
     &                     'done (nROmap=', nROmap, ' )'

      RETURN
      END

#include "CPP_OPTIONS.h"

CBOP 0
C !ROUTINE: CPL_SEND_OCN_ATMCONFIG

C !INTERFACE:
      SUBROUTINE CPL_SEND_OCN_ATMCONFIG

C !DESCRIPTION:
C     *==========================================================*
C     | SUBROUTINE CPL_SEND_OCN_ATMCONFIG
C     | o Routine for sending atmos. config to ocean component.
C     *==========================================================*
C     | This version talks to the MITgcm general circulation
C     | model. For now just send atmosphere land/sea mask.
C     *==========================================================*

C !USES:
      IMPLICIT NONE
C     == Global variables ==
c#include "CPL_PARAMS.h"
#include "ATMIDS.h"
#include "ATMSIZE.h"
#include "ATMVARS.h"
#include "OCNIDS.h"
#include "OCNSIZE.h"
#include "OCNVARS.h"

C !INPUT/OUTPUT PARAMETERS:
C !LOCAL VARIABLES:
CEOP

C-    Map atmos. land-mask onto ocean grid
      CALL ATM_TO_OCN_MAPXYR8(
     I     Nx_atm, Ny_atm,
     I     landMask_atm,
     I     Nx_ocn, Ny_ocn,
     O     landMask_ocn)

C-    Send atmos. config to ocean component
      CALL COUPSEND_R8TILES( ocnCompName, atmLandName, Nx_ocn, Ny_ocn,
     &                       landMask_ocn )

      RETURN
      END

#     include "GAD_OPTIONS.h"

      SUBROUTINE GAD_PPM_FLX_Y(bi,bj,kk,ix,
     &           calc_CFL,delT,vvel,
     &           vfac,fhat,flux,myThid )
C     |================================================================|
C     | PPM_FLX_Y: evaluate PPM flux on grid-cell edges.               |
C     |================================================================|

          implicit none

C     =============================================== global variables
#         include "SIZE.h"
#         include "GRID.h"
#         include "GAD.h"

C     ================================================================
C       bi,bj     :: tile indexing.
C       kk        :: r-index.
C       ix        :: x-index.
C       calc_CFL  :: TRUE to calc. CFL from vel.
C       delT      :: time-step.
C       vvel      :: vel.-comp in y-direction.
C       vfac      :: vel.-flux in y-direction.
C       fhat      :: row of poly. coeff.
C       flux      :: adv.-flux in y-direction.
C       myThid    :: thread number.
C     ================================================================
          integer bi,bj,kk,ix
          logical calc_CFL
          _RL delT
          _RL vvel(1-OLx:sNx+OLx,
     &             1-OLy:sNy+OLy)
          _RL vfac(1-OLx:sNx+OLx,
     &             1-OLy:sNy+OLy)
          _RL fhat(1:3,
     &             1-OLy:sNy+OLy)
          _RL flux(1-OLx:sNx+OLx,
     &             1-OLy:sNy+OLy)
          integer myThid

C     ================================================================
C       iy        :: y-indexing.
C       vCFL      :: CFL number.
C       intF      :: upwind tracer edge-value.
C       ss11,ss22 :: int. endpoints.
C       ivec      :: int. basis vec.
C     ================================================================
          integer iy
          _RL vCFL,intF
          _RL ss11,ss22
          _RL ivec(1:3)

C     ================================================================
C       (1): calc. "departure-points" for each grid-cell edge by int-
C            egrating edge position backward in time over one single
C            time-step. This is a "single-cell" implementation: requ-
C            ires CFL <= 1.0.
C       (2): calc. flux as the integral of the upwind grid-cell poly-
C            nomial over the deformation interval found in (1).
C     ================================================================

          do  iy = 1-OLy+3, sNy+OLy-2

              if (vvel(ix,iy) .eq. 0. _d 0) then

                  flux(ix,iy)    = 0. _d 0

              else

              if (vvel(ix,iy) .gt. 0. _d 0) then

C     ==================== integrate PPM profile over upwind cell IY-1
              if ( calc_CFL ) then
              vCFL = vvel(ix,iy) * delT
     &             * recip_dyF(ix,iy-1,bi,bj)
     &             * recip_deepFacC(kk)
              else
              vCFL = vvel(ix,iy)
              end if

              ss11 = +1. _d 0 - 2. _d 0 * vCFL
              ss22 = +1. _d 0

C     ==================== integrate profile over region swept by face
              ivec(1) = ss22 - ss11
              ivec(2) =(ss22 ** 2
     &                - ss11 ** 2)*(1. _d 0 / 2. _d 0)
              ivec(3) =(ss22 ** 3
     &                - ss11 ** 3)*(1. _d 0 / 3. _d 0)

              intF = ivec(1) * fhat(1,iy-1)
     &             + ivec(2) * fhat(2,iy-1)
     &             + ivec(3) * fhat(3,iy-1)

CML              intF = intF / (ss22 - ss11)

              else

C     ==================== integrate PPM profile over upwind cell IY+0
              if ( calc_CFL ) then
              vCFL = vvel(ix,iy) * delT
     &             * recip_dyF(ix,iy-0,bi,bj)
     &             * recip_deepFacC(kk)
              else
              vCFL = vvel(ix,iy)
              end if

              ss11 = -1. _d 0 - 2. _d 0 * vCFL
              ss22 = -1. _d 0

C     ==================== integrate profile over region swept by face
              ivec(1) = ss22 - ss11
              ivec(2) =(ss22 ** 2
     &                - ss11 ** 2)*(1. _d 0 / 2. _d 0)
              ivec(3) =(ss22 ** 3
     &                - ss11 ** 3)*(1. _d 0 / 3. _d 0)

              intF = ivec(1) * fhat(1,iy-0)
     &             + ivec(2) * fhat(2,iy-0)
     &             + ivec(3) * fhat(3,iy-0)

CML              intF = intF / (ss22 - ss11)

              end if

c             intF = 0.5 _d 0 * intF / vCFL
C-    to avoid potential underflow:
              intF = 0.5 _d 0 * intF / sign(max(abs(vCFL),1.d-20),vCFL)

C     ==================== calc. flux = upwind tracer * face-transport
              flux(ix,iy) = + vfac(ix,iy) * intF

              end if

          end do

          return

c     end subroutine GAD_PPM_FLX_Y
      end

#include "RW_OPTIONS.h"

CBOP
C !ROUTINE: WRITE_GLVEC_RL
C !INTERFACE:
      SUBROUTINE WRITE_GLVEC_RL(
     I           pref, suff, array, sizArr, myIter, myThid )

C !DESCRIPTION:
C WRITE_GLVEC_RL
C  is a "front-end" interface to the low-level MDS I/O routines. 
C  Writes a global (=tile independent) vector.

C !USES:
      IMPLICIT NONE

C == Global Variables
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"

C !INPUT PARAMETERS:
      CHARACTER*(*) pref,suff
      INTEGER sizArr
      _RL     array(sizArr)
      INTEGER myIter
      INTEGER myThid

C !FUNCTIONS:
      INTEGER  ILNBLNK, IFNBLNK
      EXTERNAL ILNBLNK, IFNBLNK

C !LOCAL VARIABLES:
      _RS     dummyRS(1)
      CHARACTER*(2) fType
      INTEGER ioUnit, bi, bj, iRec
      INTEGER s1Lo,s1Hi,s2Lo,s2Hi
      CHARACTER*(MAX_LEN_FNAM) fullName
CEOP

C--   Build file name
C     Name has form 'prefix.suffix'
C     e.g. U.0000000100
      s1Lo = IFNBLNK(pref)
      s1Hi = ILNBLNK(pref)
      IF ( suff .EQ. ' ' ) THEN
       WRITE( fullName, '(A)' ) pref(s1Lo:s1Hi)
      ELSE
       s2Lo = IFNBLNK(suff)
       s2Hi = ILNBLNK(suff)
       WRITE( fullName, '(A,A)' ) pref(s1Lo:s1Hi),suff(s2Lo:s2Hi)
      ENDIF

      ioUnit = 0
      fType ='RL'
      bi = 0
      bj = 0
      iRec = 1
#ifdef ALLOW_MDSIO
      CALL MDS_WRITEVEC_LOC(
     I                       fullName, writeBinaryPrec, ioUnit,
     I                       fType, sizArr, array, dummyRS,
     I                       bi, bj, iRec, myIter, myThid )
#endif

      RETURN
      END

#include "ATM_PHYS_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 0
C !ROUTINE: ATM_PHYS_DIAGNOSTICS_INIT

C !INTERFACE:
      SUBROUTINE ATM_PHYS_DIAGNOSTICS_INIT( myThid )

C     !DESCRIPTION:
C     Initialize list of all available diagnostics for pkg AtmPhys

C     !USES:
      IMPLICIT NONE
#include "EEPARAMS.h"
#include "SIZE.h"
c#include "ATM_PHYS_PARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     myThid ::  my Thread Id number
      INTEGER myThid
CEOP

#ifdef ALLOW_DIAGNOSTICS
C     !LOCAL VARIABLES:
C     === Local variables ===
C     diagNum   :: diagnostics number in the (long) list of available diag.
C     diagMate  :: diag. mate number in the (long) list of available diag.
C     diagName  :: local short name (8c) of a diagnostics
C     diagCode  :: local parser field with characteristics of the diagnostics
C              cf head of S/R DIAGNOSTICS_INIT_EARLY or DIAGNOSTICS_MAIN_INIT
C     diagUnits :: local string (16c): physical units of a diagnostic field
C     diagTitle :: local string (80c): description of field in diagnostic
      INTEGER       diagNum
      INTEGER       diagMate
      CHARACTER*8   diagName
      CHARACTER*16  diagCode
      CHARACTER*16  diagUnits
      CHARACTER*(80) diagTitle

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

c     IF ( useDiagnotics ) THEN

        diagName  = 'AtPh_SST'
        diagTitle = 'Sea Surface Temperature in Atm_Phys package'
        diagUnits = 'K               '
        diagCode  = 'SM      L1      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

        diagName  = 'AtPhdTdt'
        diagTitle = ' Pot.Temp. tendency from package ATM_PHYS'
        diagUnits = 'K/s             '
        diagCode  = 'SMR     MR      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

        diagName  = 'AtPhdQdt'
        diagTitle = ' Spec.Humid tendency from package ATM_PHYS'
        diagUnits = '1/s             '
        diagCode  = 'SMR     MR      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

        diagName  = 'AtPhdUdt'
        diagTitle = 'u-Velocity tendency from package ATM_PHYS'
        diagUnits = 'm/s^2           '
        diagCode  = 'UMR     MR      '
        diagMate  = diagNum + 2
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I   diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

        diagName  = 'AtPhdVdt'
        diagTitle = 'v-Velocity tendency from package ATM_PHYS'
        diagUnits = 'm/s^2           '
        diagCode  = 'VMR     MR      '
        diagMate  = diagNum
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I   diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

        diagName  = 'AtPhDifT'
        diagTitle = 'ATM_PHYS: Vertical Diffusion for Temp & Q'
        diagUnits = 'unit            '
        diagCode  = 'WM      LR      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )
        diagName  = 'AtPhDifM'
        diagTitle = 'ATM_PHYS: Vertical Diffusion for Momentum'
        diagUnits = 'unit            '
        diagCode  = 'WM      LR      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

        diagName  = 'AtPhCnvP'
        diagTitle = 'ATM_PHYS: Convective Precip'
        diagUnits = 'kg/m^2/s        '
        diagCode  = 'SM      L1      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )
        diagName  = 'AtPhLscP'
        diagTitle = 'ATM_PHYS: Large-Scale Precip'
        diagUnits = 'kg/m^2/s        '
        diagCode  = 'SM      L1      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )
        diagName  = 'AtPhdTlc'
        diagTitle = 'ATM_PHYS: lsc cond. tendency of Temp'
        diagUnits = 'K/s             '
        diagCode  = 'SMR     MR      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

C--     Radiation & Surface fluxes:
        diagName  = 'AtPhdTrd'
        diagTitle = 'ATM_PHYS: radiation tendency of Temp'
        diagUnits = 'K/s             '
        diagCode  = 'SMR     MR      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )
        diagName  = 'AtPhNSR '
        diagTitle = 'ATM_PHYS: Net Shortwave Radiation (3D,+=dw)'
        diagUnits = 'W/m^2           '
        diagCode  = 'SM      LX      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )
        CALL DIAGNOSTICS_SETKLEV( diagName, Nr+1, myThid )
        diagName  = 'AtPhNLR '
        diagTitle = 'ATM_PHYS: Net Longwave  Radiation (3D,+=up)'
        diagUnits = 'W/m^2           '
        diagCode  = 'SM      LX      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )
        CALL DIAGNOSTICS_SETKLEV( diagName, Nr+1, myThid )
        diagName  = 'AtPhDSR '
        diagTitle = 'ATM_PHYS: Downward Shortwave Radiation (3D,+=dw)'
        diagUnits = 'W/m^2           '
        diagCode  = 'SM P    LX      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )
        CALL DIAGNOSTICS_SETKLEV( diagName, Nr+1, myThid )
        diagName  = 'AtPhDLR '
        diagTitle = 'ATM_PHYS: Downward Longwave  Radiation (3D,+=dw)'
        diagUnits = 'W/m^2           '
        diagCode  = 'SM P    LX      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )
        CALL DIAGNOSTICS_SETKLEV( diagName, Nr+1, myThid )
        diagName  = 'AtPhInSR'
        diagTitle = 'ATM_PHYS: Incoming Shortwave Radiation (+=dw)'
        diagUnits = 'W/m^2           '
        diagCode  = 'SM P    U1      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )
        diagName  = 'AtPhNTSR'
        diagTitle = 'ATM_PHYS: Net Top Shortwave Radiation (+=dw)'
        diagUnits = 'W/m^2           '
        diagCode  = 'SM P    U1      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )
        diagName  = 'AtPhOLR '
        diagTitle = 'ATM_PHYS: Outgoing Longwave  Radiation (+=up)'
        diagUnits = 'W/m^2           '
        diagCode  = 'SM P    U1      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )
        diagName  = 'AtPhDSSR'
        diagTitle = 'ATM_PHYS: Downward Surface Shortwave Rad. (+=dw)'
        diagUnits = 'W/m^2           '
        diagCode  = 'SM P    U1      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )
        diagName  = 'AtPhNSSR'
        diagTitle = 'ATM_PHYS: Net Surface Shortwave Radiation (+=dw)'
        diagUnits = 'W/m^2           '
        diagCode  = 'SM P    L1      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )
        diagName  = 'AtPhDSLR'
        diagTitle = 'ATM_PHYS: Downward Surface Longwave Rad. (+=dw)'
        diagUnits = 'W/m^2           '
        diagCode  = 'SM P    L1      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )
        diagName  = 'AtPhUSLR'
        diagTitle = 'ATM_PHYS: Upward Surface Longwave Rad. (+=up)'
        diagUnits = 'W/m^2           '
        diagCode  = 'SM P    L1      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )
        diagName  = 'AtPhSens'
        diagTitle = 'ATM_PHYS: surface sensible heat flux (+=up)'
        diagUnits = 'W/m^2           '
        diagCode  = 'SM      L1      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )
        diagName  = 'AtPhEvap'
        diagTitle = 'ATM_PHYS: surface evaporation'
        diagUnits = 'kg/m^2/s        '
        diagCode  = 'SM      L1      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )
        diagName  = 'AtPhTauX'
        diagTitle = 'ATM_PHYS: Zonal comp of surface stress'
        diagUnits = 'N/m^2           '
        diagCode  = 'UM      L1      '
        diagMate  = diagNum + 2
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I   diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )
        diagName  = 'AtPhTauY'
        diagTitle = 'ATM_PHYS: Meridional comp of surface stress'
        diagUnits = 'N/m^2           '
        diagCode  = 'VM      L1      '
        diagMate  = diagNum
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I   diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

C--     Dargan BettsMiller Convection:
        diagName  = 'AtPhCAPE'
        diagTitle = 'ATM_PHYS: Convective Avail. Pot. Energy: CAPE'
        diagUnits = 'J/kg            '
        diagCode  = 'SM      L1      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )
        diagName  = 'AtPhCnIn'
        diagTitle = 'ATM_PHYS: Convection inhibition'
        diagUnits = '1               '
        diagCode  = 'SM      L1      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )
        diagName  = 'AtPhKlzb'
        diagTitle = 'ATM_PHYS: Level of zero buoyancy (=klzb, Convect)'
        diagUnits = '1               '
        diagCode  = 'SM      L1      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )
        diagName  = 'AtPhConv'
        diagTitle = 'ATM_PHYS: B.M. Convection Flag '
     &            //'(0:no, 1:shallow, 2:Deep)'
        diagUnits = '1               '
        diagCode  = 'SM      L1      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )
        diagName  = 'AtPhRlxT'
        diagTitle = 'ATM_PHYS: Temp. Relax. inv time-scale (Convection)'
        diagUnits = '1/s             '
        diagCode  = 'SM      L1      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )
        diagName  = 'AtPhRlxQ'
        diagTitle = 'ATM_PHYS: Humid Relax. inv time-scale (Convection)'
        diagUnits = '1/s             '
        diagCode  = 'SM      L1      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )
        diagName  = 'AtPh_Trf'
        diagTitle = 'ATM_PHYS: Ref Temp for convection (Moist Adiabat)'
        diagUnits = 'K               '
        diagCode  = 'SM      MR      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )
        diagName  = 'AtPh_Qrf'
        diagTitle = 'ATM_PHYS: Ref Humid for convection (Saturated)'
        diagUnits = 'kg/kg           '
        diagCode  = 'SM      MR      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )
        diagName  = 'AtPhdTcv'
        diagTitle = 'ATM_PHYS: convection tendency of Temp'
        diagUnits = 'K/s             '
        diagCode  = 'SMR     MR      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

        diagName  = 'AtPhdtTg'
        diagTitle = 'ATM_PHYS: vertical diff. tendency of Temp.'
        diagUnits = 'K/s             '
        diagCode  = 'SMR     MR      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )
        diagName  = 'AtPhdtQg'
        diagTitle = 'ATM_PHYS: vertical diff. tendency of spec.humid'
        diagUnits = '1/s             '
        diagCode  = 'SMR     MR      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )
        diagName  = 'AtPhDisH'
        diagTitle = 'ATM_PHYS: heating from dissipation'
        diagUnits = 'K/s             '
        diagCode  = 'SMR     MR      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

c     ENDIF

#endif /* ALLOW_DIAGNOSTICS */

      RETURN
      END

#include "ICEFRONT_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 0
C !ROUTINE: ICEFRONT_DIAGNOSTICS_INIT

C !INTERFACE:
      SUBROUTINE ICEFRONT_DIAGNOSTICS_INIT( myThid )

C     !DESCRIPTION:
C     Initialize list of all available diagnostics

C     !USES:
      IMPLICIT NONE
#include "EEPARAMS.h"
#include "SIZE.h"
#include "ICEFRONT.h"

C     !INPUT/OUTPUT PARAMETERS:
C     myThid ::  my Thread Id number
      INTEGER myThid
CEOP

#ifdef ALLOW_DIAGNOSTICS
C     !LOCAL VARIABLES:
C     === Local variables ===
C     diagNum   :: diagnostics number in the (long) list of available diag.
C     diagName  :: local short name (8c) of a diagnostics
C     diagCode  :: local parser field with characteristics of the diagnostics
C              cf head of S/R DIAGNOSTICS_INIT_EARLY or DIAGNOSTICS_MAIN_INIT
C     diagUnits :: local string (16c): physical units of a diagnostic field
C     diagTitle :: local string (80c): description of field in diagnostic
      INTEGER       diagNum
      CHARACTER*8   diagName
      CHARACTER*16  diagCode
      CHARACTER*16  diagUnits
      CHARACTER*(80) diagTitle

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      diagName  = 'ICFfwFlx'
      diagTitle = 'Ice front freshwater flux (+ve increases ocean salt)'
      diagUnits = 'kg/m^2/s        '
      diagCode  = 'SM      MR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'ICFhtFlx'
      diagTitle = 'Ice front heat flux  (+ve cools ocean)'
      diagUnits = 'W/m^2           '
      diagCode  = 'SM      MR      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

#endif /* ALLOW_DIAGNOSTICS */

      RETURN
      END

#include "LAYERS_OPTIONS.h"
C--  File layers_thermodynamics.F:
C--   Contents
C--   o LAYERS_CALC_RHS

CBOP 0
C     !ROUTINE: LAYERS_CALC_RHS
C     !INTERFACE:
      SUBROUTINE LAYERS_CALC_RHS(
     I                  myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE LAYERS_CALC_RHS
C     | Recalculate the divergence of the RHS terms in T and S eqns.
C     | Replaces the values of layers_surfflux, layers_df? IN PLACE
C     | with the corresponding tendencies (same units as GT and GS)
C     *==========================================================*
C     \ev

C !USES:
      IMPLICIT NONE
C     == Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "FFIELDS.h"
#include "LAYERS_SIZE.h"
#include "LAYERS.h"

C !INPUT PARAMETERS:
C     myThid    :: my Thread Id number
      INTEGER myThid
CEOP

#ifdef ALLOW_LAYERS
#ifdef LAYERS_THERMODYNAMICS
C !LOCAL VARIABLES:
C     bi, bj   :: tile indices
C     i,j      :: horizontal indices
C     k        :: vertical index for model grid
C     kdown    :: temporary placeholder
C     fluxfac  :: scaling factor for converting surface flux to tendency
C     fluxfac  :: scaling factor for converting diffusive flux to tendency
C     downfac  :: mask for lower point

      INTEGER bi, bj
      INTEGER i,j,k,kdown,iTracer
      _RL fluxfac(2), downfac, tmpfac
c     CHARACTER*(MAX_LEN_MBUF) msgBuf
      _RL minusone
      PARAMETER (minusOne=-1.)

C --  These factors convert the units of TFLUX and SFLUX diagnostics
C --  back to surfaceForcingT and surfaceForcingS units
      fluxfac(1) = 1.0/(HeatCapacity_Cp*rUnit2mass)
      fluxfac(2) = 1.0/rUnit2mass

        DO bj = myByLo(myThid), myByHi(myThid)
         DO bi = myBxLo(myThid), myBxHi(myThid)

          DO iTracer = 1,2
           k = 1
C --       Loop for surface fluxes
           DO j=1-OLy,sNy+OLy
            DO i=1-OLx,sNx+OLx

#ifdef SHORTWAVE_HEATING
C --      Have to remove the shortwave from the surface flux because it is added later
             IF (iTracer.EQ.1) THEN
               layers_surfflux(i,j,k,iTracer,bi,bj) =
     &           layers_surfflux(i,j,k,iTracer,bi,bj)
C --      Sign convention for Qsw means we have to add it to subtract it
     &           +Qsw(i,j,bi,bj)
             ENDIF
#endif /* SHORTWAVE_HEATING */

             layers_surfflux(i,j,k,iTracer,bi,bj) =
     &       layers_surfflux(i,j,k,iTracer,bi,bj)
     &       *recip_drF(1)*_recip_hFacC(i,j,1,bi,bj)
     &       *fluxfac(iTracer)
            ENDDO
           ENDDO

C --       Loop for diffusive fluxes
C --       If done correctly, we can overwrite the flux array in place
C --       with its own divergence
           DO k=1,Nr
            downFac = 1. _d 0
C     note: here kdown is for the mask below current level k
            IF ( usingZCoords ) THEN
             kdown = MIN(k+1,Nr)
             IF ( k.EQ.Nr ) downFac = 0. _d 0
            ELSE
C     this is the oceanic pressure coordinate case
             kdown = MAX(k-1,1)
             IF ( k.EQ.1  ) downFac = 0. _d 0
            ENDIF
            DO j=1-OLy,sNy+OLy-1
             DO i=1-OLx,sNx+OLx-1
C -- Diffusion
              tmpfac = -_recip_hFacC(i,j,k,bi,bj)*recip_drF(k)
     &          *recip_rA(i,j,bi,bj)*recip_deepFac2C(k)*recip_rhoFacC(k)
              layers_dfx(i,j,k,iTracer,bi,bj) = maskInC(i,j,bi,bj) *
     &         tmpfac * ( layers_dfx(i+1,j,k,iTracer,bi,bj) -
     &          layers_dfx(i,j,k,iTracer,bi,bj) )
              layers_dfy(i,j,k,iTracer,bi,bj) = maskInC(i,j,bi,bj) *
     &         tmpfac * ( layers_dfy(i,j+1,k,iTracer,bi,bj) -
     &          layers_dfy(i,j,k,iTracer,bi,bj) )
              layers_dfr(i,j,k,iTracer,bi,bj) = tmpfac * rkSign *
     &        ( layers_dfr(i,j,kdown,iTracer,bi,bj)*downfac -
     &          layers_dfr(i,j,k,iTracer,bi,bj) )
C -- Advection
              layers_afx(i,j,k,iTracer,bi,bj) = maskInC(i,j,bi,bj) *
     &         tmpfac * ( layers_afx(i+1,j,k,iTracer,bi,bj) -
     &          layers_afx(i,j,k,iTracer,bi,bj) )
              layers_afy(i,j,k,iTracer,bi,bj) = maskInC(i,j,bi,bj) *
     &         tmpfac * ( layers_afy(i,j+1,k,iTracer,bi,bj) -
     &          layers_afy(i,j,k,iTracer,bi,bj) )
              layers_afr(i,j,k,iTracer,bi,bj) = tmpfac * rkSign *
     &        ( layers_afr(i,j,kdown,iTracer,bi,bj)*downfac -
     &          layers_afr(i,j,k,iTracer,bi,bj) )

#ifdef SHORTWAVE_HEATING
              IF (iTracer.EQ.1) THEN
                layers_sw(i,j,k,iTracer,bi,bj) =
     &            layers_sw(i,j,k,iTracer,bi,bj)
     &            + Qsw(i,j,bi,bj)*gravitySign
     &            *( SWFrac3D(i,j,k,bi,bj) - SWFrac3D(i,j,k+1,bi,bj) )
     &            *fluxfac(1)
     &            *recip_drF(k)*_recip_hFacC(i,j,k,bi,bj)
              ENDIF
#endif /* SHORTWAVE_HEATING */

             ENDDO
            ENDDO
           ENDDO
          ENDDO
         ENDDO
        ENDDO

C-    TFLUX (=total heat flux, match heat-content variations, [W/m2])
C       IF ( fluidIsWater .AND.
C      &     DIAGNOSTICS_IS_ON('TFLUX   ',myThid) ) THEN
C        DO bj = myByLo(myThid), myByHi(myThid)
C         DO bi = myBxLo(myThid), myBxHi(myThid)
C          DO j = 1,sNy
C           DO i = 1,sNx
C            tmp1k(i,j,bi,bj) =
C #ifdef SHORTWAVE_HEATING
C      &      -Qsw(i,j,bi,bj)+
C #endif
C      &      (surfaceForcingT(i,j,bi,bj)+surfaceForcingTice(i,j,bi,bj))
C      &      *HeatCapacity_Cp*rUnit2mass
C           ENDDO
C          ENDDO
C #ifdef NONLIN_FRSURF
C          IF ( (nonlinFreeSurf.GT.0 .OR. usingPCoords)
C      &        .AND. useRealFreshWaterFlux ) THEN
C           DO j=1,sNy
C            DO i=1,sNx
C             tmp1k(i,j,bi,bj) = tmp1k(i,j,bi,bj)
C      &       + PmEpR(i,j,bi,bj)*theta(i,j,ks,bi,bj)*HeatCapacity_Cp
C            ENDDO
C           ENDDO
C          ENDIF
C #endif /* NONLIN_FRSURF */
C         ENDDO
C        ENDDO
C        CALL DIAGNOSTICS_FILL( tmp1k,'TFLUX   ',0,1,0,1,1,myThid )
C       ENDIF
C
C C-    SFLUX (=total salt flux, match salt-content variations [g/m2/s])
C       IF ( fluidIsWater .AND.
C      &     DIAGNOSTICS_IS_ON('SFLUX   ',myThid) ) THEN
C        DO bj = myByLo(myThid), myByHi(myThid)
C         DO bi = myBxLo(myThid), myBxHi(myThid)
C          DO j = 1,sNy
C           DO i = 1,sNx
C            tmp1k(i,j,bi,bj) =
C      &      surfaceForcingS(i,j,bi,bj)*rUnit2mass
C           ENDDO
C          ENDDO
C
C #ifdef NONLIN_FRSURF
C          IF ( (nonlinFreeSurf.GT.0 .OR. usingPCoords)
C      &        .AND. useRealFreshWaterFlux ) THEN
C           DO j=1,sNy
C            DO i=1,sNx
C             tmp1k(i,j,bi,bj) = tmp1k(i,j,bi,bj)
C      &       + PmEpR(i,j,bi,bj)*salt(i,j,ks,bi,bj)
C            ENDDO
C           ENDDO
C          ENDIF
C #endif /* NONLIN_FRSURF */
C
C         ENDDO
C        ENDDO
C        CALL DIAGNOSTICS_FILL( tmp1k,'SFLUX   ',0,1,0,1,1,myThid )
C       ENDIF

C     Ocean: Add temperature surface forcing (e.g., heat-flux) in surface level
C      IF ( kLev .EQ. kSurface ) THEN
C       DO j=1,sNy
C        DO i=1,sNx
C          gT(i,j,kLev,bi,bj)=gT(i,j,kLev,bi,bj)
C     &      +surfaceForcingT(i,j,bi,bj)
C     &      *recip_drF(kLev)*_recip_hFacC(i,j,kLev,bi,bj)
C        ENDDO
C       ENDDO
C      ELSEIF ( kSurface.EQ.-1 ) THEN
C       DO j=1,sNy
C        DO i=1,sNx
C         IF ( kSurfC(i,j,bi,bj).EQ.kLev ) THEN
C          gT(i,j,kLev,bi,bj)=gT(i,j,kLev,bi,bj)
C     &      +surfaceForcingT(i,j,bi,bj)
C     &      *recip_drF(kLev)*_recip_hFacC(i,j,kLev,bi,bj)
C         ENDIF
C        ENDDO
C       ENDDO
C      ENDIF

C--   Divergence of fluxes
C     Anelastic: scale vertical fluxes by rhoFac and leave Horizontal fluxes unchanged
C     for Stevens OBC: keep only vertical diffusive contribution on boundaries
C     DO j=1-OLy,sNy+OLy-1
C      DO i=1-OLx,sNx+OLx-1
C       gTracer(i,j,k,bi,bj)=gTracer(i,j,k,bi,bj)
C    &   -_recip_hFacC(i,j,k,bi,bj)*recip_drF(k)
C    &   *recip_rA(i,j,bi,bj)*recip_deepFac2C(k)*recip_rhoFacC(k)
C    &   *( (fZon(i+1,j)-fZon(i,j))*maskInC(i,j,bi,bj)
C    &     +(fMer(i,j+1)-fMer(i,j))*maskInC(i,j,bi,bj)
C    &     +(fVerT(i,j,kDown)-fVerT(i,j,kUp))*rkSign
C    &     -localT(i,j)*( (uTrans(i+1,j)-uTrans(i,j))*advFac
C    &                   +(vTrans(i,j+1)-vTrans(i,j))*advFac
C    &                   +(rTransKp1(i,j)-rTrans(i,j))*rAdvFac
C    &                  )*maskInC(i,j,bi,bj)
C    &    )
C      ENDDO
C     ENDDO

#endif /* LAYERS_THERMODYNAMICS */
#endif /* USE_LAYERS */
      RETURN
      END
C -- end of S/R LAYERS_CALC_RHS

#include "DIC_OPTIONS.h"

CBOP
C !ROUTINE: CALCITE_SATURATION

C !INTERFACE: ==========================================================
      SUBROUTINE CALCITE_SATURATION( PTR_DIC, PTR_ALK, PTR_PO4,
     I           bi,bj,imin,imax,jmin,jmax,
     I           myTime, myIter, myThid )

C !DESCRIPTION:
C  Calculate carbonate fluxes:
C   - determine carbonate ion concentration through full domain
C   - calculate calcite saturation state

C !USES: ===============================================================
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "DYNVARS.h"
#include "DIC_VARS.h"

C !INPUT PARAMETERS: ===================================================
C  myTime               :: current time
C  myIter               :: current timestep
C  myThid               :: thread number
       _RL  PTR_DIC(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
       _RL  PTR_ALK(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
       _RL  PTR_PO4(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      INTEGER imin, imax, jmin, jmax, bi, bj
      _RL myTime
      INTEGER myIter
      INTEGER myThid

C !OUTPUT PARAMETERS: ===================================================

#if ( defined DIC_BIOTIC && defined DIC_CALCITE_SAT )

C !LOCAL VARIABLES: ====================================================
C  i,j,k                  :: loop indices
       INTEGER i,j,k
       LOGICAL doIni_pH, debugPrt
       _RL carbonate(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
       _RL calcium
       _RL sitlocal
       _RL po4local
       _RL diclocal
       _RL alklocal
       _RL pCO2local(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
       _RL locTemp(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
       _RL locSalt(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
       INTEGER doIterCO3, CO3ITER
CEOP

       doIni_pH = ( myIter.EQ.(nIter0 + 1) ) .AND. .NOT.pH_isLoaded(2)
C-   set number of iterations for 3-D pH (for case selectPHsolver=0):
       IF ( doIni_pH .OR.
     &      ( calcOmegaCalciteFreq.GT.deltaTClock ) ) THEN
C    Since we start cold with an arbitrary pH, we must iterate pH solver
C    to ensure accurate estimate of CO3 at depth
C    OR we may call this for deep ocean infrequently and in this case
C    can afford to make several iterations
         doIterCO3 = nIterCO3
       ELSE
         doIterCO3 = 1
       ENDIF
c      IF ( bi+bj .EQ. 2 ) THEN
c       WRITE(standardMessageUnit,'(A,L5,I4,I10)')
c    &  '--- CALCITE_SATURATION: doIni_pH, doIterCO3, myIter=',
c    &                           doIni_pH, doIterCO3, myIter
c      ENDIF

       DO k=1,Nr
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
            locTemp(i,j) = theta(i,j,k,bi,bj)
            locSalt(i,j) = salt (i,j,k,bi,bj)
            carbonate(i,j) = 0. _d 0
            pCO2local(i,j) = 0. _d 0
         ENDDO
        ENDDO
#ifdef CARBONCHEM_SOLVESAPHE
#ifdef ALLOW_DEBUG
        IF (debugMode) CALL DEBUG_CALL( 'DIC_COEFFS_DEEP',myThid )
#endif
C Calculate carbon coefficients
        CALL DIC_COEFFS_SURF(
     I                       locTemp, locSalt,
     I                       bi,bj,iMin,iMax,jMin,jMax,myThid)

C Now correct the coefficients for pressure dependence
        CALL DIC_COEFFS_DEEP(
     I                       locTemp, locSalt,
     I                       bi,bj,iMin,iMax,jMin,jMax,
     I                       k,myThid)
#else
#ifdef ALLOW_DEBUG
        IF (debugMode) CALL DEBUG_CALL(
     &      'CARBON_COEFFS_PRESSURE_DEP',myThid)
#endif
        CALL CARBON_COEFFS_PRESSURE_DEP(
     I                       locTemp, locSalt,
     I                       bi,bj,iMin,iMax,jMin,jMax,
     I                       k,myThid)
#endif

        debugPrt = debugMode
        DO j=jmin,jmax
         DO i=imin,imax

          IF ( maskC(i,j,k,bi,bj).EQ.oneRS ) THEN
#ifdef CARBONCHEM_SOLVESAPHE
C calcium concentration already calculated in S/R DIC_COEFFS_SURF
           calcium = cat(i,j,bi,bj)
#else
           calcium = 1.028 _d -2*salt(i,j,k,bi,bj)/35. _d 0
#endif

C SilicaDeep filled with constant value of 0.03 mol/m3 unless
C     DIC_deepSilicaFile provided.
           sitlocal = silicaDeep(i,j,k,bi,bj)
           po4local = PTR_PO4(i,j,k)
           diclocal = PTR_DIC(i,j,k)
           alklocal = PTR_ALK(i,j,k)

#ifdef CARBONCHEM_SOLVESAPHE
           IF ( selectPHsolver.GT.0 ) THEN
C Use Munhoven (2013) Solvesaphe routine to calculate pH and pCO2
            IF ( doIni_pH ) THEN
#ifdef ALLOW_DEBUG
             IF (debugPrt) CALL DEBUG_CALL('AHINI_FOR_AT',myThid)
#endif
C call AHINI_FOR_AT to get better initial guess of pH
             CALL AHINI_FOR_AT(alklocal*permil,
     I              diclocal*permil,
     I              bt(i,j,bi,bj),
     O              pH3d(i,j,k,bi,bj),
     I              i,j,k,bi,bj,myIter,myThid )
            ENDIF /* 3d pH is not loaded */
#ifdef ALLOW_DEBUG
            IF (debugPrt) CALL DEBUG_CALL('CALC_PCO2_SOLVESAPHE',myThid)
#endif
            CALL CALC_PCO2_SOLVESAPHE(
     I          locTemp(i,j), locSalt(i,j),
     I          diclocal, po4local,
     I          sitlocal, alklocal,
     U          pH3d(i,j,k,bi,bj), pCO2local(i,j), carbonate(i,j),
     I          i,j,k,bi,bj, debugPrt,myIter,myThid )

C- convert carbonate to mol kg^-1-SW for calculation of saturation state
            carbonate(i,j) = carbonate(i,j)*permil
           ELSE
C Use the original Follows et al. (2006) solver
#endif /* CARBONCHEM_SOLVESAPHE */
#ifdef ALLOW_DEBUG
            IF (debugPrt) CALL DEBUG_CALL('CALC_PCO2_APPROX',myThid)
#endif
            DO CO3iter = 1, doIterCO3
             CALL CALC_PCO2_APPROX(
     I          locTemp(i,j), locSalt(i,j),
     I          diclocal, po4local,
     I          sitlocal, alklocal,
     I          ak1(i,j,bi,bj),ak2(i,j,bi,bj),
     I          ak1p(i,j,bi,bj),ak2p(i,j,bi,bj),ak3p(i,j,bi,bj),
     I          aks(i,j,bi,bj),akb(i,j,bi,bj),akw(i,j,bi,bj),
     I          aksi(i,j,bi,bj),akf(i,j,bi,bj),
     I          ak0(i,j,bi,bj), fugf(i,j,bi,bj), ff(i,j,bi,bj),
     I          bt(i,j,bi,bj),st(i,j,bi,bj),ft(i,j,bi,bj),
     U          pH3d(i,j,k,bi,bj), pCO2local(i,j), carbonate(i,j),
     I          i,j,k,bi,bj,myIter,myThid )
            ENDDO

#ifdef CARBONCHEM_SOLVESAPHE
           ENDIF
#endif /* CARBONCHEM_SOLVESAPHE */

           omegaC(i,j,k,bi,bj) = calcium * carbonate(i,j)
     &                         / Ksp_TP_Calc(i,j,bi,bj)
           debugPrt = .FALSE.

Cmick...................................................
c            if(omegaC(i,j,k,bi,bj) .eq. 0.) then
c             if(i .eq. 76 .and. j .eq. 36  .and. k .eq. 15) then
c               write(6,*)'i,j,k,KS,CO3,pHCa,T,S,hfacc,omega',
c     &                 i,j,k,
c     &                 Ksp_TP_Calc(i,j,bi,bj),
c     &                 carbonate(i,j), calcium, pH3d(i,j,k,bi,bj),
c     &                 locTemp(i,j), locSalt(i,j),
c     &                 hfacc(i,j,k,bi,bj),omegaC(i,j,k,bi,bj)
c              write(6,*)'Ksp_TP_Calc',
c     &                 Ksp_TP_Calc(i,j,bi,bj)
c               write(6,*)'dic, alk, po4 ',
c     &                 diclocal, alklocal,po4local
c               write(6,*)'k1, k2, k1p, k2p, k3p ',
c     &                 ak1(i,j,bi,bj),ak2(i,j,bi,bj),
c     &                ak1p(i,j,bi,bj),ak2p(i,j,bi,bj),ak3p(i,j,bi,bj)
c               write(6,*)'ks, kb, kw, ksi ',
c     &                aks(i,j,bi,bj),akb(i,j,bi,bj),akw(i,j,bi,bj),
c     &                aksi(i,j,bi,bj)
c               write(6,*)'akf, ff, bt, st, ft ',
c     &                akf(i,j,bi,bj),ff(i,j,bi,bj),
c     &                bt(i,j,bi,bj),st(i,j,bi,bj),ft(i,j,bi,bj)
c             end if
Cmick....................................................
          ELSE
C-        else (case maskC = 0 , dry point)
           omegaC(i,j,k,bi,bj) = 0. _d 0
          ENDIF

         ENDDO
        ENDDO

#ifdef ALLOW_DIAGNOSTICS
C Fill up pCO2 and carbonate diagnostics from local arrays
        IF ( useDiagnostics ) THEN
         CALL DIAGNOSTICS_FILL(pCO2local,'DIC3DPCO',k,1,2,bi,bj,myThid)
         CALL DIAGNOSTICS_FILL(carbonate,'DIC3DCO3',k,1,2,bi,bj,myThid)
        ENDIF
#endif /* ALLOW_DIAGNOSTICS */

C-     end k loop
       ENDDO

#ifdef ALLOW_DIAGNOSTICS
C Fill up 3d pH, omegaC and silicate diagnostics
       IF ( useDiagnostics ) THEN
        CALL DIAGNOSTICS_FILL(pH3d      ,'DIC3DPH ',0,Nr,1,bi,bj,myThid)
        CALL DIAGNOSTICS_FILL(omegaC    ,'OMEGAC  ',0,Nr,1,bi,bj,myThid)
        CALL DIAGNOSTICS_FILL(silicaDeep,'DIC3DSIT',0,Nr,1,bi,bj,myThid)
       ENDIF
#endif /* ALLOW_DIAGNOSTICS */

#endif /* DIC_BIOTIC and DIC_CALCITE_SAT */
       RETURN
       END

#include "CTRL_OPTIONS.h"
#include "AD_CONFIG.h"
#ifdef ALLOW_ECCO
# include "ECCO_OPTIONS.h"
#endif
#ifdef ALLOW_GMREDI
# include "GMREDI_OPTIONS.h"
#endif
#ifdef ALLOW_EXF
# include "EXF_OPTIONS.h"
#endif
#ifdef ALLOW_SHELFICE
# include "SHELFICE_OPTIONS.h"
#endif
#ifdef ALLOW_OBCS
# include "OBCS_OPTIONS.h"
#endif

CBOP
C     !ROUTINE: CTRL_CHECK
C     !INTERFACE:
      SUBROUTINE CTRL_CHECK( myThid )

C     !DESCRIPTION: \bv
C     *=================================================================
C     | SUBROUTINE CTRK_CHECK
C     | o Validate basic ctrl package setup and inter-package
C     | dependencies.
C     *=================================================================
C     \ev

C     !USES:
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "CTRL_SIZE.h"
#include "CTRL.h"
#ifdef ALLOW_EXF
# include "EXF_PARAM.h"
#endif
#include "CTRL_GENARR.h"

C     !INPUT/OUTPUT PARAMETERS:
C     myThid     :: my Thread Id number
      INTEGER myThid

#if (defined (ALLOW_GENARR3D_CONTROL) && defined(ALLOW_PTRACERS))
C     !FUNCTIONS:
      INTEGER  ILNBLNK
      EXTERNAL ILNBLNK
#endif

C     !LOCAL VARIABLES:
C     msgBuf     :: Informational/error message buffer
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      INTEGER errCount
#if ( defined ALLOW_GENARR2D_CONTROL || defined ALLOW_GENARR3D_CONTROL || defined ALLOW_GENTIM2D_CONTROL )
      INTEGER iarr
#endif
#if ( defined ALLOW_GENARR2D_CONTROL || defined ALLOW_GENARR3D_CONTROL )
      INTEGER k2
#endif
#if ( defined ALLOW_GENARR3D_CONTROL && defined ALLOW_PTRACERS )
      INTEGER iLen, iPtr, ascii_1
#endif
#ifdef ECCO_CTRL_DEPRECATED
      INTEGER ioUnit
      CHARACTER*(16) w_sfx
#endif
CEOP

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      _BEGIN_MASTER(myThid)
      errCount = 0

      WRITE(msgBuf,'(2A)') 'CTRL_CHECK: ',
     &                     ' --> Starts to check CTRL set-up'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )

#ifdef ALLOW_TANGENTLINEAR_RUN
      IF ( yadmark .NE. 'g_' ) THEN
        WRITE(msgBuf,'(A)')
     &        'yadmark very likely wrong in data.ctrl for case '
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(A)')
     &        'ALLOW_TANGENTLINEAR_RUN; should be g_ '
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF
#endif

#ifdef ALLOW_GENTIM2D_CONTROL
      IF ( .NOT.useCAL ) THEN
        WRITE(msgBuf,'(2A)') '** WARNING ** CTRL_CHECK: ',
     &    'ALLOW_GENTIM2D_CONTROL is unsafe'
     &    //' without pkg/cal (currently: useCAL=F)'
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
      ENDIF
#endif

#ifndef ALLOW_OPENAD

#ifdef ALLOW_GENARR2D_CONTROL
      DO iarr = 1, maxCtrlArr2D
        IF (((xx_genarr2d_weight(iarr).NE.' ').AND.
     &         (xx_genarr2d_file(iarr).EQ.' ')).OR.
     &        ((xx_genarr2d_weight(iarr).EQ.' ').AND.
     &         (xx_genarr2d_file(iarr).NE.' '))) THEN
          WRITE(msgBuf,'(3A)') 'CTRL_CHECK: ',
     &      'Cannot define xx_genarr2d_weight or xx_genarr2d_file ',
     &      'separately'
          CALL PRINT_ERROR( msgBuf, myThid )
          errCount = errCount + 1
        ENDIF
      ENDDO
#endif /* ALLOW_GENARR2D_CONTROL */

#ifdef ALLOW_GENARR3D_CONTROL
      DO iarr = 1, maxCtrlArr3D
        IF (((xx_genarr3d_weight(iarr).NE.' ').AND.
     &         (xx_genarr3d_file(iarr).EQ.' ')).OR.
     &        ((xx_genarr3d_weight(iarr).EQ.' ').AND.
     &         (xx_genarr3d_file(iarr).NE.' '))) THEN
          WRITE(msgBuf,'(3A)') 'CTRL_CHECK: ',
     &      'Cannot define xx_genarr3d_weight or xx_genarr3d_file ',
     &      'separately'
          CALL PRINT_ERROR( msgBuf, myThid )
          errCount = errCount + 1
        ENDIF
      ENDDO
# ifdef ALLOW_PTRACERS
C     Check for valid gen-ctrl file name that mactch a ptracer index
      IF ( usePTRACERS ) THEN
        DO iarr = 1, maxCtrlArr3D
          iLen = ILNBLNK(xx_genarr3d_file(iarr))
          IF ( iLen.EQ.7 .AND.
     &         xx_genarr3d_file(iarr)(1:6).EQ.'xx_ptr' ) THEN
            ascii_1 = ICHAR( xx_genarr3d_file(iarr)(7:7) )
C     character 0 to 9 <-> 48 to 57
            IF ( ascii_1.GE.49 .AND. ascii_1.LE.57 ) THEN
              READ(xx_genarr3d_file(iarr)(7:7),*) iPtr
              WRITE(msgBuf,'(2A,I4,A)') 'CTRL_CHECK: ',
     &              'pTracer #', iPtr, ' in Gen-CTRL'
              CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                            SQUEEZE_RIGHT, myThid )
            ELSE
              WRITE(msgBuf,'(4A)') 'CTRL_CHECK: ',
     &          'Gen-CTRL file "', xx_genarr3d_file(iarr)(1:iLen), '"'
              CALL PRINT_ERROR( msgBuf, myThid )
              WRITE(msgBuf,'(2A,I3,A)') 'CTRL_CHECK:  <-- ',
     &             'do not match any pTr number (ascii=', ascii_1, ')'
              CALL PRINT_ERROR( msgBuf, myThid )
              errCount = errCount + 1
            ENDIF
          ENDIF
        ENDDO
      ENDIF
# endif /* ALLOW_PTRACERS */
#endif /* ALLOW_GENARR3D_CONTROL */

#ifdef ALLOW_GENTIM2D_CONTROL
      DO iarr = 1, maxCtrlTim2D
        IF (((xx_gentim2d_weight(iarr).NE.' ').AND.
     &         (xx_gentim2d_file(iarr).EQ.' ')).OR.
     &        ((xx_gentim2d_weight(iarr).EQ.' ').AND.
     &         (xx_gentim2d_file(iarr).NE.' '))) THEN
          WRITE(msgBuf,'(3A)') 'CTRL_CHECK: ',
     &      'Cannot define xx_gentim2d_weight or xx_gentim2d_file ',
     &      'separately'
          CALL PRINT_ERROR( msgBuf, myThid )
          errCount = errCount + 1
        ENDIF
      ENDDO
#endif /* ALLOW_GENTIM2D_CONTROL */

#endif /* ndef ALLOW_OPENAD */

#ifdef ALLOW_DIFFKR_CONTROL
C-    to use DIFFKR_CONTROL, needs to define ALLOW_3D_DIFFKR in CPP_OPTIONS.h
# ifndef ALLOW_3D_DIFFKR
      WRITE(msgBuf,'(A)')
     &        'Needs to define ALLOW_3D_DIFFKR to use DIFFKR_CONTROL'
      CALL PRINT_ERROR( msgBuf, myThid )
      errCount = errCount + 1
# endif
#endif /* ALLOW_DIFFKR_CONTROL */

#ifdef ALLOW_KAPGM_CONTROL
C-    to use KAPGM_CONTROL, needs to define GM_READ_K3D_GM in GMREDI_OPTIONS.h
# ifndef GM_READ_K3D_GM
      WRITE(msgBuf,'(A)')
     &        'Needs to define GM_READ_K3D_GM to use KAPGM_CONTROL'
      CALL PRINT_ERROR( msgBuf, myThid )
      errCount = errCount + 1
# endif
#endif /* ALLOW_KAPGM_CONTROL */

#ifdef ALLOW_KAPREDI_CONTROL
C-    to use KAPREDI_CONTROL, needs to define GM_READ_K3D_REDI in GMREDI_OPTIONS.h
# ifndef GM_READ_K3D_REDI
      WRITE(msgBuf,'(A)')
     &        'Needs to define GM_READ_K3D_REDI to use KAPREDI_CONTROL'
      CALL PRINT_ERROR( msgBuf, myThid )
      errCount = errCount + 1
# endif
#endif /* ALLOW_KAPREDI_CONTROL */

#ifndef ALLOW_PACKUNPACK_METHOD2
# ifndef EXCLUDE_CTRL_PACK
      IF ( useSingleCpuIO ) THEN
        WRITE(msgBuf,'(3A)') '** WARNING ** CTRL_CHECK: ',
     &        'relying on mdsio_gl.F to pack/unpack the control',
     &        'vector is unsafe when useSingleCpuIO is true.'
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &  SQUEEZE_RIGHT, myThid )
      ENDIF
# endif
#endif /* ndef ALLOW_PACKUNPACK_METHOD2 */

#ifdef ALLOW_PACKUNPACK_METHOD2
# ifndef EXCLUDE_CTRL_PACK
#  ifdef ALLOW_OBCS_CONTROL
      WRITE(msgBuf,'(2A)')
     &        'ALLOW_PACKUNPACK_METHOD2 does not work with',
     &        'open boundary controls (see verif/obcs_ctrl).'
      CALL PRINT_ERROR( msgBuf, myThid )
      errCount = errCount + 1
#  endif
# endif /* ndef EXCLUDE_CTRL_PACK */
#endif /* ALLOW_PACKUNPACK_METHOD2 */

#if ( defined ALLOW_OBCSN_CONTROL && !defined ALLOW_OBCS_NORTH )
      WRITE(msgBuf,'(2A)') 'CTRL_CHECK: ',
     &     'CPP-flag ALLOW_OBCSN_CONTROL is defined,'
      CALL PRINT_ERROR( msgBuf, myThid )
      WRITE(msgBuf,'(2A)') 'CTRL_CHECK: ',
     &     'but CPP-flag ALLOW_OBCS_NORTH is not defined.'
      CALL PRINT_ERROR( msgBuf, myThid )
      errCount = errCount + 1
#endif

#if ( defined ALLOW_OBCSS_CONTROL && !defined ALLOW_OBCS_SOUTH )
      WRITE(msgBuf,'(2A)') 'CTRL_CHECK: ',
     &     'CPP-flag ALLOW_OBCSS_CONTROL is defined,'
      CALL PRINT_ERROR( msgBuf, myThid )
      WRITE(msgBuf,'(2A)') 'CTRL_CHECK: ',
     &     'but CPP-flag ALLOW_OBCS_SOUTH is not defined.'
      CALL PRINT_ERROR( msgBuf, myThid )
      errCount = errCount + 1
#endif

#if ( defined ALLOW_OBCSE_CONTROL && !defined ALLOW_OBCS_EAST )
      WRITE(msgBuf,'(2A)') 'CTRL_CHECK: ',
     &     'CPP-flag ALLOW_OBCSE_CONTROL is defined,'
      CALL PRINT_ERROR( msgBuf, myThid )
      WRITE(msgBuf,'(2A)') 'CTRL_CHECK: ',
     &     'but CPP-flag ALLOW_OBCS_EAST is not defined.'
      CALL PRINT_ERROR( msgBuf, myThid )
      errCount = errCount + 1
#endif

#if ( defined ALLOW_OBCSW_CONTROL && !defined ALLOW_OBCS_WEST )
      WRITE(msgBuf,'(2A)') 'CTRL_CHECK: ',
     &     'CPP-flag ALLOW_OBCSW_CONTROL is defined,'
      CALL PRINT_ERROR( msgBuf, myThid )
      WRITE(msgBuf,'(2A)') 'CTRL_CHECK: ',
     &     'but CPP-flag ALLOW_OBCS_WEST is not defined.'
      CALL PRINT_ERROR( msgBuf, myThid )
      errCount = errCount + 1
#endif

#ifdef ALLOW_HFLUXM_CONTROL
      WRITE(msgBuf,'(2A)') 'CTRL_CHECK: ',
     &     'CPP-flag ALLOW_HFLUXM_CONTROL has been retired.'
      CALL PRINT_ERROR( msgBuf, myThid )
      WRITE(msgBuf,'(2A)') 'CTRL_CHECK: ',
     &     'tutorial_global_oce_optim, which was the only experiment'
      CALL PRINT_ERROR( msgBuf, myThid )
      WRITE(msgBuf,'(2A)') 'CTRL_CHECK: ',
     &     'that used this flag, now uses the generic control xx_qnet'
      CALL PRINT_ERROR( msgBuf, myThid )
      WRITE(msgBuf,'(2A)') 'CTRL_CHECK: ',
     &     'to achieve the same thing.'
      CALL PRINT_ERROR( msgBuf, myThid )
      errCount = errCount + 1
#endif /* ALLOW_HFLUXM_CONTROL */

#ifdef ALLOW_HFACC_CONTROL
      WRITE(msgBuf,'(2A)') 'CTRL_CHECK: ',
     &     'CPP-flag ALLOW_HFACC_CONTROL has been retired.'
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      errCount = errCount + 1
#endif
#ifdef ALLOW_HFACC3D_CONTROL
      WRITE(msgBuf,'(2A)') 'CTRL_CHECK: ',
     &     'CPP-flag ALLOW_HFACC3D_CONTROL has been retired.'
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      errCount = errCount + 1
#endif

#ifdef ALLOW_GENARR2D_CONTROL
C     doscaling must be true to do log10 ctrl
      DO iarr = 1, maxCtrlArr2D
        DO k2 = 1, maxCtrlProc
          IF ( (xx_genarr2d_preproc(k2,iarr).EQ.'noscaling') .AND.
     &       (xx_genarr2d_preproc_c(k2,iarr).EQ.'log10ctrl') ) THEN
            WRITE(msgBuf,'(A)')
     &      'CTRL_CHECK: conflicting preproc_c & preproc flags '
            CALL PRINT_ERROR( msgBuf, myThid )
            WRITE(msgBuf,'(A,I2,A)')
     &      'log10ctrl and noscaling set for xx_genarr2d(',iarr,').'
            CALL PRINT_ERROR( msgBuf, myThid )
            errCount = errCount + 1
          ENDIF
        ENDDO
      ENDDO
# ifdef ALLOW_SHELFICE
#  ifdef SHI_ALLOW_GAMMAFRICT
C     Cannot have shiTransCoeffT/S as control variables in gammafrict form
      DO iarr = 1, maxCtrlArr2D
        IF ( (xx_genarr2d_file(iarr)(1:11).EQ.'xx_shicoeff')) THEN
          WRITE(msgBuf,'(2A,I2,A)')
     &    'shiTransCoeffT or S set as control variable for ',
     &    'xx_genarr2d(', iarr,'). '
          CALL PRINT_ERROR( msgBuf, myThid )
          WRITE(msgBuf,'(2A)')
     &    'Cannot use shiTransCoeffT/S when SHI_ALLOW_GAMMAFRICT ',
     &    'is defined'
          CALL PRINT_ERROR( msgBuf, myThid )
          errCount = errCount + 1
        ENDIF
      ENDDO
#  else
C     Cannot have shiCDrag as control variable without gammafrict form
C     this could be changed to control cdrag for momentum equation only,
C     but is probably not what the user wants or expects.
      DO iarr = 1, maxCtrlArr2D
        IF ( (xx_genarr2d_file(iarr)(1:11).EQ.'xx_shicdrag')) THEN
          WRITE(msgBuf,'(2A,I2,A)')
     &    'shiCDrag set as control variable for ',
     &    'xx_genarr2d(', iarr,'). '
          CALL PRINT_ERROR( msgBuf, myThid )
          WRITE(msgBuf,'(2A)')
     &    'Cannot use shiCDrag when SHI_ALLOW_GAMMAFRICT ',
     &    'is NOT defined'
          CALL PRINT_ERROR( msgBuf, myThid )
          errCount = errCount + 1
        ENDIF
      ENDDO
#  endif /* SHI_ALLOW_GAMMAFRICT */
# endif /* ALLOW_SHELFICE */
#endif /* ALLOW_GENARR2D_CONTROL */

#ifdef ALLOW_GENARR3D_CONTROL
C     doscaling must be true to do log10 ctrl
      DO iarr = 1, maxCtrlArr3D
        DO k2 = 1, maxCtrlProc
          IF ( (xx_genarr3d_preproc(k2,iarr).EQ.'noscaling') .AND.
     &       (xx_genarr3d_preproc_c(k2,iarr).EQ.'log10ctrl') ) THEN
            WRITE(msgBuf,'(A)')
     &      'CTRL_CHECK: conflicting preproc_c & preproc flags '
            CALL PRINT_ERROR( msgBuf, myThid )
            WRITE(msgBuf,'(A,I2,A)')
     &      'log10ctrl and noscaling set for xx_genarr2d(',iarr,'). '
            CALL PRINT_ERROR( msgBuf, myThid )
            errCount = errCount + 1
          ENDIF
        ENDDO
      ENDDO
#endif

#ifdef ECCO_CTRL_DEPRECATED
      WRITE(msgBuf,'(2A)') 'CTRL_CHECK: CPP-flag ECCO_CTRL_DEPRECATED',
     &                     ' is no longer available.'
      CALL PRINT_ERROR( msgBuf, myThid )
      ioUnit = errorMessageUnit
      w_sfx = '** WARNING ** : '
      WRITE(msgBuf,'(2A)') '** WARNING ** CTRL_CHECK: ',
     &     'Along with ECCO_CTRL_DEPRECATED a long list'
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(2A)') '** WARNING ** CTRL_CHECK: ',
     &     ' of CPP-flags have no effect anymore:'
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
C---- long list starts
      WRITE(msgBuf,'(2A)') w_sfx, 'ALLOW_APRESSURE_CONTROL'
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(2A)') w_sfx, 'ALLOW_APRESSURE_COST_CONTRIBUTION'
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(2A)') w_sfx, 'ALLOW_AQH_CONTROL'
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(2A)') w_sfx, 'ALLOW_ARGO_SALT_COST_CONTRIBUTION'
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(2A)') w_sfx, 'ALLOW_ARGO_THETA_COST_CONTRIBUTION'
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(2A)') w_sfx, 'ALLOW_ATEMP_CONTROL'
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(2A)') w_sfx, 'ALLOW_ATM_MEAN_CONTROL'
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(2A)') w_sfx, 'ALLOW_AUTODIFF_INIT_OLD'
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(2A)') w_sfx, 'ALLOW_BOTTOMDRAG_CONTROL_NONGENERIC'
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(2A)') w_sfx, 'ALLOW_BOTTOMDRAG_COST_CONTRIBUTION'
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(2A)') w_sfx, 'ALLOW_BP_COST_CONTRIBUTION'
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(2A)') w_sfx, 'ALLOW_CTDS_COST_CONTRIBUTION'
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(2A)') w_sfx, 'ALLOW_CTDT_COST_CONTRIBUTION'
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(2A)') w_sfx, 'ALLOW_CTRL_SMOOTH'
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(2A)') w_sfx, 'ALLOW_DAILYSCAT_COST_CONTRIBUTION'
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(2A)') w_sfx, 'ALLOW_DAILYSST_COST_CONTRIBUTION'
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
c     WRITE(msgBuf,'(2A)') w_sfx, 'ALLOW_diffkr_COST_CONTRIBUTION'
      WRITE(msgBuf,'(2A)') w_sfx, 'ALLOW_DIFFKR_COST_CONTRIBUTION'
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(2A)') w_sfx, 'ALLOW_DRIFTER_COST_CONTRIBUTION'
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(2A)') w_sfx, 'ALLOW_DRIFTW_COST_CONTRIBUTION'
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
c     WRITE(msgBuf,'(2A)') w_sfx, 'ALLOW_ECCO_DIAGNOSTIC_RUN'
c     WRITE(msgBuf,'(2A)') w_sfx, 'ALLOW_ECCO_FORWARD_RUN'
      WRITE(msgBuf,'(2A)') w_sfx, 'ALLOW_EDDYPSI_COST_CONTRIBUTION'
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(2A)') w_sfx, 'ALLOW_EFLUXY0_CONTROL'
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
c     WRITE(msgBuf,'(2A)') w_sfx, 'ALLOW_EGM96_ERROR_COV'
      WRITE(msgBuf,'(2A)') w_sfx, 'ALLOW_EGM96_ERROR_DIAG'
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(2A)') w_sfx, 'ALLOW_ETAN0_COST_CONTRIBUTION'
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(2A)') w_sfx, 'ALLOW_EVAP_CONTROL'
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(2A)') w_sfx, 'ALLOW_EVAP_COST_CONTRIBUTION'
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(2A)') w_sfx, 'ALLOW_GEN2D_CONTROL'
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(2A)') w_sfx, 'ALLOW_GEN3D_CONTROL'
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
c     WRITE(msgBuf,'(2A)') w_sfx, 'ALLOW_GRADIENT_CHECK'
      WRITE(msgBuf,'(2A)') w_sfx, 'ALLOW_HFLUX_COST_CONTRIBUTION'
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(2A)') w_sfx, 'ALLOW_IESTAU_COST_CONTRIBUTION'
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(2A)') w_sfx, 'ALLOW_KAPGM_COST_CONTRIBUTION'
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(2A)') w_sfx, 'ALLOW_KAPREDI_COST_CONTRIBUTION'
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(2A)') w_sfx, 'ALLOW_LWDOWN_CONTROL'
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(2A)') w_sfx, 'ALLOW_LWDOWN_COST_CONTRIBUTION'
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(2A)') w_sfx, 'ALLOW_LWFLUX_CONTROL'
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(2A)') w_sfx, 'ALLOW_LWFLUX_COST_CONTRIBUTION'
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(2A)') w_sfx, 'ALLOW_MEAN_HFLUX_COST_CONTRIBUTION'
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(2A)') w_sfx, 'ALLOW_NEW_SSH_COST'
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
c     WRITE(msgBuf,'(2A)') w_sfx, 'ALLOW_NO_DYNAMICS'
      WRITE(msgBuf,'(2A)') w_sfx, 'ALLOW_PRECIP_CONTROL'
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(2A)') w_sfx, 'ALLOW_PRECIP_COST_CONTRIBUTION'
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
c     WRITE(msgBuf,'(2A)') w_sfx, 'ALLOW_READ_EGM_DATA'
      WRITE(msgBuf,'(2A)') w_sfx, 'ALLOW_RELAXSSS_CONTROL'
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(2A)') w_sfx, 'ALLOW_RELAXSST_CONTROL'
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(2A)') w_sfx, 'ALLOW_RUNOFF_CONTROL'
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(2A)') w_sfx, 'ALLOW_RUNOFF_COST_CONTRIBUTION'
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(2A)') w_sfx, 'ALLOW_SALT0_COST_CONTRIBUTION'
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(2A)') w_sfx, 'ALLOW_SALT_COST_CONTRIBUTION'
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(2A)') w_sfx, 'ALLOW_SCAT_COST_CONTRIBUTION'
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(2A)') w_sfx, 'ALLOW_SFLUX_COST_CONTRIBUTION'
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(2A)') w_sfx, 'ALLOW_SMOOTH_BC_COST_CONTRIBUTION'
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(2A)') w_sfx, 'ALLOW_SMOOTH_CTRL3D'
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(2A)') w_sfx, 'ALLOW_SNOWPRECIP_CONTROL'
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(2A)') w_sfx, 'ALLOW_SNOWPRECIP_COST_CONTRIBUTION'
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
c     WRITE(msgBuf,'(2A)') w_sfx, 'ALLOW_SPH_PROJECTION'
      WRITE(msgBuf,'(2A)') w_sfx, 'ALLOW_SSH_COST_CONTRIBUTION'
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(2A)') w_sfx, 'ALLOW_SSH_ERSANOM_COST_CONTRIBUTION'
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(2A)') w_sfx, 'ALLOW_SSH_GFOANOM_COST_CONTRIBUTION'
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(2A)') w_sfx, 'ALLOW_SSH_MEAN_COST_CONTRIBUTION'
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(2A)') w_sfx, 'ALLOW_SSH_TOT'
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(2A)') w_sfx, 'ALLOW_SSH_TPANOM_COST_CONTRIBUTION'
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(2A)') w_sfx, 'ALLOW_SSHV4_COST'
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(2A)') w_sfx, 'ALLOW_SSS_CONTROL'
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(2A)') w_sfx, 'ALLOW_SSS_COST_CONTRIBUTION'
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(2A)') w_sfx, 'ALLOW_SST_CONTROL'
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(2A)') w_sfx, 'ALLOW_SST_COST_CONTRIBUTION'
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
c     WRITE(msgBuf,'(2A)') w_sfx, 'ALLOW_STEPPING_CALL'
      WRITE(msgBuf,'(2A)') w_sfx, 'ALLOW_STRESS_MEAN_COST_CONTRIBUTION'
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(2A)') w_sfx, 'ALLOW_SWDOWN_CONTROL'
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(2A)') w_sfx, 'ALLOW_SWDOWN_COST_CONTRIBUTION'
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(2A)') w_sfx, 'ALLOW_SWFLUX_CONTROL'
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(2A)') w_sfx, 'ALLOW_SWFLUX_COST_CONTRIBUTION'
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(2A)') w_sfx, 'ALLOW_THETA0_COST_CONTRIBUTION'
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(2A)') w_sfx, 'ALLOW_THETA_COST_CONTRIBUTION'
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(2A)') w_sfx, 'ALLOW_TMI_SST_COST_CONTRIBUTION'
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(2A)') w_sfx, 'ALLOW_TRANSPORT_COST_CONTRIBUTION'
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(2A)') w_sfx, 'ALLOW_USTRESS_COST_CONTRIBUTION'
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(2A)') w_sfx, 'ALLOW_UVEL0_COST_CONTRIBUTION'
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(2A)') w_sfx, 'ALLOW_UWIND_CONTROL'
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(2A)') w_sfx, 'ALLOW_UWIND_COST_CONTRIBUTION'
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(2A)') w_sfx, 'ALLOW_VSTRESS_COST_CONTRIBUTION'
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(2A)') w_sfx, 'ALLOW_VVEL0_COST_CONTRIBUTION'
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(2A)') w_sfx, 'ALLOW_VWIND_CONTROL'
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(2A)') w_sfx, 'ALLOW_VWIND_COST_CONTRIBUTION'
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(2A)') w_sfx, 'ALLOW_XBT_COST_CONTRIBUTION'
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
c     WRITE(msgBuf,'(2A)') w_sfx, 'ALLOW_YMDS_TREE'
c     WRITE(msgBuf,'(2A)') w_sfx, 'APPLY_HFLUX_COST_CONTRIBUTION'
c     WRITE(msgBuf,'(2A)') w_sfx, 'APPLY_SALT_COST_CONTRIBUTION'
c     WRITE(msgBuf,'(2A)') w_sfx, 'APPLY_SFLUX_COST_CONTRIBUTION'
c     WRITE(msgBuf,'(2A)') w_sfx, 'APPLY_SSH_COST_CONTRIBUTION'
c     WRITE(msgBuf,'(2A)') w_sfx, 'APPLY_SST_COST_CONTRIBUTION'
c     WRITE(msgBuf,'(2A)') w_sfx, 'APPLY_THETA_COST_CONTRIBUTION'
c     WRITE(msgBuf,'(2A)') w_sfx, 'APPLY_USTRESS_COST_CONTRIBUTION'
c     WRITE(msgBuf,'(2A)') w_sfx, 'APPLY_VSTRESS_COST_CONTRIBUTION'
      WRITE(msgBuf,'(2A)') w_sfx, 'DISABLE_CTRL_THETA_LIMIT'
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(2A)') w_sfx, 'GENERIC_BAR_MONTH'
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
C---- long list ends
      WRITE(msgBuf,'(2A)') '** WARNING ** CTRL_CHECK: ',
     &     'end of CPP-flag list that have no effect anymore.'
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      errCount = errCount + 1
#endif /* ECCO_CTRL_DEPRECATED */

      IF ( errCount.GE.1 ) THEN
        WRITE(msgBuf,'(A,I3,A)')
     &       'CTRL_CHECK: detected', errCount,' fatal error(s)'
        CALL PRINT_ERROR( msgBuf, myThid )
        CALL ALL_PROC_DIE( 0 )
        STOP 'ABNORMAL END: S/R CTRL_CHECK'
      ENDIF

      WRITE(msgBuf,'(2A)') 'CTRL_CHECK: ',
     &                     ' <-- Ends Normally'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(2A)') ' '
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      _END_MASTER(myThid)

      RETURN
      END

#include "CPP_EEOPTIONS.h"

      SUBROUTINE GLOBAL_SUM_TILE_RL_D(phiTile, phiTiled,
     &     sumPhi, sumPhid, myThid)
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "EESUPPORT.h"
#include "GLOBAL_SUM.h"
      _RL     phiTile(nSx,nSy)
      _RL     phiTiled(nSx,nSy)
      _RL     sumPhid
      _RL     sumPhi
      INTEGER myThid
      CALL GLOBAL_SUM_TILE_RL(phiTiled, sumPhid, myThid)
      CALL GLOBAL_SUM_TILE_RL(phiTile, sumPhi, myThid)
      END

      SUBROUTINE GLOBAL_SUM_R8_D(sumPhi, sumPhid, myThid)
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "EESUPPORT.h"
#include "GLOBAL_SUM.h"
      _RL sumPhi
      _RL sumPhid
      INTEGER myThid
      CALL GLOBAL_SUM_R8(sumPhid, myThid)
      CALL GLOBAL_SUM_R8(sumPhi, myThid)
      END

      SUBROUTINE CG2D_D(cg2d_b, cg2d_bd, cg2d_x,
     &                cg2d_xd, firstResidual, minResidualSq,
     &                lastResidual,numIters, nIterMin,myThid )
      IMPLICIT NONE
#include "SIZE.h"
      _RL  cg2d_b(1-OLx:sNx+OLx, 1-OLy:sNy+OLy, nSx, nSy)
      _RL  cg2d_bd(1-OLx:sNx+OLx, 1-OLy:sNy+OLy, nSx, nSy)
      _RL  cg2d_x(1-OLx:sNx+OLx, 1-OLy:sNy+OLy, nSx, nSy)
      _RL  cg2d_xd(1-OLx:sNx+OLx, 1-OLy:sNy+OLy, nSx, nSy)
      _RL  firstResidual
      _RL  minResidualSq
      _RL  lastResidual
      INTEGER numIters
      INTEGER nIterMin
      INTEGER myThid
      INTEGER copyIt1, copyIt2

      copyIt1 = numIters
      copyIt2 = nIterMin
! [llh] it seems the input 2nd arg of cg2d() pollutes its output value:
      cg2d_xd = 0.d0
      CALL CG2D(cg2d_bd, cg2d_xd, firstResidual,
     &        minResidualSq, lastResidual, numIters,
     &        nIterMin, myThid)
! [llh] we assume the downstream cg2d_b is passive:
      cg2d_bd = 0.d0
      CALL CG2D(cg2d_b, cg2d_x, firstResidual,
     &        minResidualSq, lastResidual, copyIt1,
     &        copyIt2, myThid)
      END

      SUBROUTINE GLOBAL_MAX_R8_D(rhsmax, rhsmaxd, myThid)
      IMPLICIT NONE
      _RL     rhsmax
      _RL     rhsmaxd
      INTEGER myThid
      print *, "NOT IMPLEMENTED GLOBAL_MAX_R8_D yet."
      RETURN
      END

#include "CAL_OPTIONS.h"

      integer function cal_IntDays(
     I                              mythid
     &                            )

c     ==================================================================
c     FUNCTION cal_IntDays
c     ==================================================================
c
c     o Return the number of calendar days that are affected by the 
c       current model integration.
c
c              
c     started: Christian Eckert eckert@mit.edu  30-Jun-1999
c
c     changed: Christian Eckert eckert@mit.edu  29-Dec-1999
c
c              - restructured the original version in order to have a
c                better interface to the MITgcmUV.
c
c              Christian Eckert eckert@mit.edu  03-Feb-2000
c
c              - Introduced new routine and function names, cal_<NAME>,
c                for verion 0.1.3.
c
c     ==================================================================
c     FUNCTION cal_IntDays
c     ==================================================================

      implicit none

c     == global variables ==

#include "cal.h"

c     == routine arguments ==

      integer mythid

c     == local variables ==

      integer tempdate(4)
      integer timediff(4)

c     == end of interface ==

      tempdate(1) = modelstartdate(1)
      tempdate(2) = 0
      tempdate(3) = modelstartdate(3)
      tempdate(4) = modelstartdate(4)

      call cal_SubDates( modelenddate, tempdate, timediff, mythid )

      if ( timediff(2) .ne. 0 ) then
        cal_IntDays = timediff(1) + 1
      else
        cal_IntDays = timediff(1)
      endif

      return
      end

#include "KPP_OPTIONS.h"
#ifdef ALLOW_GMREDI
# include "GMREDI_OPTIONS.h"
#endif

      SUBROUTINE KPP_TRANSPORT_PTR (
     I     iMin, iMax, jMin, jMax,
     I     bi, bj, k, km1, iTr,
     O     df,
     I     myTime, myIter, myThid )
C     *==========================================================*
C     | o SUBROUTINE KPP_TRANSPORT_PTR
C     |   Add non local KPP transport term (ghat) to diffusive
C     |   passive tracer flux.
C     *==========================================================*
C     | The nonlocal transport term is nonzero only for scalars
C     | in unstable (convective) forcing conditions.
C     | Note: We do not have a specific KPP diffusion for a
C     |       passive tracer; use Salinity diffusion instead
C     | Note: KPPdiffKzS(-,k) is defined at the top of grid cell
C     |       k while KPPghat(i,j,k,bi,bj) is defined at the
C     |       bottom of grid cell k.
C     |       For K=1, KPPdiffKzS(-,k) = 0 which insures no flux
C     |       through the surface.
C     *==========================================================*
      IMPLICIT NONE

C     == GLobal variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "FFIELDS.h"
#include "KPP.h"
#include "KPP_PARAMS.h"
#ifdef ALLOW_PTRACERS
# include "PTRACERS_SIZE.h"
c#include "PTRACERS_PARAMS.h"
# include "PTRACERS_FIELDS.h"
#endif
#ifdef ALLOW_GMREDI
# include "GMREDI.h"
#endif
#ifdef ALLOW_LONGSTEP
# include "LONGSTEP.h"
#endif
#ifdef ALLOW_OFFLINE
# include "OFFLINE_SWITCH.h"
#endif

C     == Routine arguments ==
C     iMin,iMax :: Range of points for which calculation is done
C     jMin,jMax :: Range of points for which calculation is done
C     bi, bj,   :: tile indices
C     k, km1    :: current flux and KPP ghat level index
C     iTr       :: tracer index
C     df        :: Diffusive flux component work array.
C     myTime    :: Current time in simulation
C     myIter    :: Current iteration number in simulation
C     myThid    :: My Thread Id. number
      INTEGER iMin, iMax, jMin, jMax
      INTEGER bi, bj, k, km1, iTr
      _RL df      (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL     myTime
      INTEGER myIter
      INTEGER myThid

#if defined(ALLOW_KPP) && defined(KPP_GHAT) && defined(ALLOW_PTRACERS)

C     == Local variables ==
C     i, j      :: Loop counters
      INTEGER i, j
      _RL tmpFac
#ifndef ALLOW_OFFLINE
      LOGICAL offlineLoadKPP
      offlineLoadKPP = .FALSE.
#endif

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      IF ( useOffLine.AND.offlineLoadKPP ) THEN

C--   Note: in this case (offline) KPPghat array already contains
C           the product ghat*diffKzS which has been loaded from file
        DO j=jMin,jMax
         DO i=iMin,iMax
          df(i,j) = - _rA(i,j,bi,bj)
     &        *KPPghat(i,j,k,bi,bj)
     &        *surfaceForcingPTr(i,j,bi,bj,iTr)
         ENDDO
        ENDDO

      ELSE

        IF ( useGMRedi .AND. KPP_ghatUseTotalDiffus ) THEN
          tmpFac = 1. _d 0
        ELSE
          tmpFac = 0. _d 0
        ENDIF
        DO j=jMin,jMax
         DO i=iMin,iMax
          df(i,j) = - _rA(i,j,bi,bj)
#ifdef ALLOW_LONGSTEP
     &        *( LS_KPPdiffKzS(i,j,k,bi,bj)
#ifdef ALLOW_GMREDI
     &         + tmpFac*LS_Kwz(i,j,k,bi,bj)
#endif
     &         )*LS_KPPghat(i,j,km1,bi,bj)
#else /* ALLOW_LONGSTEP */
     &        *( KPPdiffKzS(i,j,k,bi,bj)
#ifdef ALLOW_GMREDI
     &         + tmpFac*Kwz(i,j,k,bi,bj)
#endif
     &         )*KPPghat(i,j,km1,bi,bj)
#endif /* ALLOW_LONGSTEP */
     &        *surfaceForcingPTr(i,j,bi,bj,iTr)
         ENDDO
        ENDDO

      ENDIF

#endif /* ALLOW_KPP and KPP_GHAT and PTRACERS */

      RETURN
      END

#include "OBCS_OPTIONS.h"

      SUBROUTINE OBCS_EXCHANGES( myThid )
C     *==========================================================*
C     | S/R OBCS_EXCHANGES
C     *==========================================================*
C     | Exchanges are needed in case obcs are read from file.
C     | EXch of xz, yz fields are avoided, so we exchange full
C     | fields after obcs have been added.
c     | Only needed for velocity fields, tracer fields wont be
C     | affected before they get exchanged at the end of
C     | time stepping loop.
C     | Note (jmc): EXCH of velocity fields do not seem needed,
C     |   except EXCH gU,gV with OBCSsponge (partly because how
C     |   OBCSsponge is written)
C     *==========================================================*

      IMPLICIT NONE
C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "DYNVARS.h"
#include "OBCS_PARAMS.h"

C     == Routine Arguments ==
      INTEGER myThid

#ifdef ALLOW_OBCS
c#ifdef ALLOW_OBCS_PRESCRIBE
#ifdef ALLOW_OBCS_SPONGE

C     == Local variables ==

c     IF (useOBCSprescribe) THEN
c      CALL EXCH_UV_XYZ_RL(uVel,vVel,.TRUE.,myThid)
c      CALL EXCH_UV_XYZ_RL(gU,gV,.TRUE.,myThid)
c     ENDIF
      IF ( useOBCSsponge ) THEN
        CALL EXCH_UV_XYZ_RL( gU, gV, .TRUE., myThid )
      ENDIF

#endif
c#endif
#endif

      RETURN
      END

#include "CAL_OPTIONS.h"

      integer function cal_NumInts(
     I                              date_a,
     I                              date_b,
     I                              timeint,
     I                              mythid
     &                            )

c     ==================================================================
c     SUBROUTINE cal_NumInts
c     ==================================================================
c
c     o Determine the number of time intervals of size timeint between
c       date_a and date_b.
c
c     Note: date_a and date_b should also be checked.
c           treat case ((passed(1) .ne. 0) .and. (timeint(1) .ne. 0))
c
c     started: Christian Eckert eckert@mit.edu  
c
c              - Introduced to version 0.1.4
c
c     changed: 
c
c
c     ==================================================================
c     SUBROUTINE cal_NumInts
c     ==================================================================

      implicit none

c     == global variables ==

#include "cal.h"

c     == routine arguments ==

      integer date_a(4)
      integer date_b(4)
      integer timeint(4)
      integer mythid

c     == local variables ==

      _RL     timeintsecs
      integer passed(4)
      _RL     passedsecs
      integer ierr

c     == end of interface ==

      if ( timeint(4) .eq. -1 ) then
        call cal_TimePassed( date_a, date_b, passed, mythid )

        call cal_ToSeconds( passed,  passedsecs,  mythid )
        call cal_ToSeconds( timeint, timeintsecs, mythid )

        cal_NumInts = abs( passedsecs/timeintsecs )
      else
        ierr = 2501
        call cal_PrintError( ierr, mythid )
        stop ' stopped in cal_NumInts.'
      endif

      return
      end

#include "ATM2D_OPTIONS.h"

CBOP 0
C !ROUTINE: EXCH_COMPONENT_CONFIGS

C !INTERFACE:
      SUBROUTINE EXCH_COMPONENT_CONFIGS( msgUnit )

C !DESCRIPTION:
C     *==========================================================*
C     | SUBROUTINE EXCH_COMPONENT_CONFIGS
C     | o Routine which controls exchange of component model
C     |   configuration information to other components.
C     *==========================================================*

C !USES:
      IMPLICIT NONE
C     == Global variables ==
C     Data on ocean grid
c#include "OCNSIZE.h"
c#include "OCNVARS.h"
C     Data on atmos grid
c#include "ATMSIZE.h"
c#include "ATMVARS.h"

C !INPUT/OUTPUT PARAMETERS:
C     msgUnit   :: log-file I/O unit
      INTEGER msgUnit

#ifdef ATM2D_MPI_ON
C !LOCAL VARIABLES:
      LOGICAL errFlag
      CHARACTER*70 errMsg
CEOP

      errFlag = .FALSE.
      errMsg  = ' '

C--   1) collect configs from all components

C     Receive ocean config (OCNCONFIG) from ocean component (OCN).
      CALL CPL_RECV_OCN_OCNCONFIG

C     Receive atmos config (ATCONFIG) from atmos.  component (ATM).
c     CALL CPL_RECV_ATM_ATMCONFIG

C--   2) send to all components the configs of the other component

C     Send atmos. config (ATMCONFIG) to ocean component (OCN).
      CALL CPL_SEND_OCN_ATMCONFIG

C     Send ocean config (OCNCONFIG) to atmos. component (ATM).
c     CALL CPL_SEND_ATM_OCNCONFIG

C--   3) define length of the run (number of coupler time-step)
C        and check for consistent Coupler config (vs components)
c     CALL CPL_CHECK_CPLCONFIG(
c    I                          msgUnit,
c    U                          errFlag, errMsg )

C--   All procs in World check for error and stop if any
      CALL MITCPLR_ALL_CHECK( errFlag, errMsg )

#endif /* ATM2D_MPI_ON */

      RETURN
      END

#include "MOM_COMMON_OPTIONS.h"
#ifdef ALLOW_CTRL
# include "CTRL_OPTIONS.h"
#endif

CBOP
C !ROUTINE: MOM_V_BOTDRAG_COEFF

C !INTERFACE: ==========================================================
      SUBROUTINE MOM_V_BOTDRAG_COEFF(
     I                 bi, bj, k, inp_KE,
     I                 uFld, vFld, kappaRV,
     U                 KE,
     O                 cDrag,
     I                 myIter, myThid )

C !DESCRIPTION:
C Compute bottom-drag coefficient (Cd) for V component momentum,
C   such that bottom stress: taux_{bot} = -Cd * V_{bot} * rUnit2mass ;
C include linear and quadratic bottom drag and friction (no-slip BC) at bottom

C !USES: ===============================================================
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#ifdef ALLOW_BOTTOMDRAG_ROUGHNESS
# include "MOM_VISC.h"
#endif
#ifdef ALLOW_CTRL
# include "CTRL_FIELDS.h"
#endif

C !INPUT PARAMETERS: ===================================================
C  bi,bj          :: tile indices
C  k              :: vertical level to process
C  inp_KE         :: =T : KE is provided as input ; =F : to compute here
C  uFld           :: velocity, zonal component
C  vFld           :: velocity, meridional component
C  kappaRV        :: vertical viscosity
C  KE             :: Kinetic energy (input when inp_KE = T)
C  myIter         :: current iteration number
C  myThid         :: my Thread Id number
      INTEGER bi, bj, k
      LOGICAL inp_KE
      _RL uFld   (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL vFld   (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL kappaRV(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr+1)
      _RL KE     (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER myIter, myThid

C !OUTPUT PARAMETERS: ==================================================
C  KE             :: Kinetic energy (output when inp_KE = F)
C  cDrag          :: bottom drag coefficient
      _RL cDrag  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)

C !LOCAL VARIABLES: ====================================================
C  i,j            :: loop indices
      INTEGER i, j
      INTEGER kDown,kLowF,kBottom
      _RL viscFac, dragFac, vSq
      _RL recDrC
CEOP

C-  No-slip BCs impose a drag at bottom
      viscFac = 0.
      IF (no_slip_bottom) viscFac = 2.

c     DO k= k1,k2

       IF ( usingZCoords ) THEN
        kBottom = Nr
        kDown   = MIN(k+1,Nr)
        kLowF   = k+1
c       dragFac = mass2rUnit*rhoConst
c       dragFac = wUnit2rVel(k+1)
        dragFac = 1. _d 0
       ELSE
        kBottom = 1
        kDown   = MAX(k-1,1)
        kLowF   = k
        dragFac = mass2rUnit*rhoConst
c       dragFac = wUnit2rVel(k)
       ENDIF
       IF ( k.EQ.kBottom ) THEN
        recDrC = recip_drF(k)
       ELSE
        recDrC = recip_drC(kLowF)
       ENDIF

#ifdef ALLOW_AUTODIFF
C--   Initialise drag-coeff
       DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
          cDrag(i,j) = 0. _d 0
        ENDDO
       ENDDO
#endif

C--   Linear bottom drag contribution to cDrag:
       DO j=1-OLy+1,sNy+OLy
        DO i=1-OLx,sNx+OLx
          cDrag(i,j) = bottomDragLinear*dragFac
#ifdef ALLOW_BOTTOMDRAG_CONTROL
     &      + halfRL*( bottomDragFld(i,j-1,bi,bj)
     &               + bottomDragFld(i,j,bi,bj) )*dragFac
#endif
        ENDDO
       ENDDO

C--   Add friction at the bottom (no-slip BC) to cDrag:
       IF ( no_slip_bottom .AND. bottomVisc_pCell ) THEN
C-    bottom friction accounts for true distance (including hFac) to the bottom
        DO j=1-OLy+1,sNy+OLy-1
         DO i=1-OLx,sNx+OLx-1
           cDrag(i,j) = cDrag(i,j)
     &      + kappaRV(i,j,kLowF)*recDrC*viscFac
     &                          *_recip_hFacS(i,j,k,bi,bj)
         ENDDO
        ENDDO
       ELSEIF ( no_slip_bottom ) THEN
C-    ignores partial-cell reduction of the distance to the bottom
        DO j=1-OLy+1,sNy+OLy-1
         DO i=1-OLx,sNx+OLx-1
           cDrag(i,j) = cDrag(i,j)
     &      + kappaRV(i,j,kLowF)*recDrC*viscFac
         ENDDO
        ENDDO
       ENDIF

C--   Add quadratic bottom drag to cDrag:
       IF ( selectBotDragQuadr.EQ.0 ) THEN
        IF ( .NOT.inp_KE ) THEN
          DO j=1-OLy,sNy+OLy-1
           DO i=1-OLx,sNx+OLx-1
            KE(i,j) = 0.25*(
     &          ( uFld( i , j )*uFld( i , j )*_hFacW(i,j,k,bi,bj)
     &           +uFld(i+1, j )*uFld(i+1, j )*_hFacW(i+1,j,k,bi,bj) )
     &        + ( vFld( i , j )*vFld( i , j )*_hFacS(i,j,k,bi,bj)
     &           +vFld( i ,j+1)*vFld( i ,j+1)*_hFacS(i,j+1,k,bi,bj) )
     &                     )*_recip_hFacC(i,j,k,bi,bj)
           ENDDO
          ENDDO
        ENDIF
C-    average grid-cell-center KE to get velocity norm @ V.pt
        DO j=1-OLy+1,sNy+OLy-1
         DO i=1-OLx,sNx+OLx-1
          IF ( (KE(i,j)+KE(i,j-1)).GT.zeroRL ) THEN
           cDrag(i,j) = cDrag(i,j)
     &      + (
#ifdef ALLOW_BOTTOMDRAG_ROUGHNESS
     &          bottomDragCoeffS(i,j,bi,bj)
#else
     &          bottomDragQuadratic
#endif
     &          )*SQRT(KE(i,j)+KE(i,j-1))*dragFac
          ENDIF
         ENDDO
        ENDDO
       ELSEIF ( selectBotDragQuadr.EQ.1 ) THEN
C-    calculate locally velocity norm @ V.pt (local V & 4 U averaged)
        DO j=1-OLy+1,sNy+OLy-1
         DO i=1-OLx,sNx+OLx-1
          vSq = vFld(i,j)*vFld(i,j)
     &     + ( (uFld( i ,j-1)*uFld( i ,j-1)*hFacW( i ,j-1,k,bi,bj)
     &         +uFld( i , j )*uFld( i , j )*hFacW( i , j ,k,bi,bj))
     &       + (uFld(i+1,j-1)*uFld(i+1,j-1)*hFacW(i+1,j-1,k,bi,bj)
     &         +uFld(i+1, j )*uFld(i+1, j )*hFacW(i+1, j ,k,bi,bj))
     &       )*recip_hFacS(i,j,k,bi,bj)*0.25 _d 0
          IF ( vSq.GT.zeroRL ) THEN
           cDrag(i,j) = cDrag(i,j)
     &      + (
#ifdef ALLOW_BOTTOMDRAG_ROUGHNESS
     &          bottomDragCoeffS(i,j,bi,bj)
#else
     &          bottomDragQuadratic
#endif
     &          )*SQRT(vSq)*dragFac
          ENDIF
         ENDDO
        ENDDO
       ELSEIF ( selectBotDragQuadr.EQ.2 ) THEN
C-    same as above but using wet-point method to average 4 U
        DO j=1-OLy+1,sNy+OLy-1
         DO i=1-OLx,sNx+OLx-1
          vSq = ( hFacW( i ,j-1,k,bi,bj) + hFacW( i , j ,k,bi,bj) )
     &        + ( hFacW(i+1,j-1,k,bi,bj) + hFacW(i+1, j ,k,bi,bj) )
          IF ( vSq.GT.zeroRL ) THEN
           vSq = vFld(i,j)*vFld(i,j)
     &      + ( (uFld( i ,j-1)*uFld( i ,j-1)*hFacW( i ,j-1,k,bi,bj)
     &          +uFld( i , j )*uFld( i , j )*hFacW( i , j ,k,bi,bj))
     &        + (uFld(i+1,j-1)*uFld(i+1,j-1)*hFacW(i+1,j-1,k,bi,bj)
     &          +uFld(i+1, j )*uFld(i+1, j )*hFacW(i+1, j ,k,bi,bj))
     &        )/vSq
          ELSE
           vSq = vFld(i,j)*vFld(i,j)
          ENDIF
          IF ( vSq.GT.zeroRL ) THEN
           cDrag(i,j) = cDrag(i,j)
     &      + (
#ifdef ALLOW_BOTTOMDRAG_ROUGHNESS
     &          bottomDragCoeffS(i,j,bi,bj)
#else
     &          bottomDragQuadratic
#endif
     &          )*SQRT(vSq)*dragFac
          ENDIF
         ENDDO
        ENDDO
       ELSEIF ( selectBotDragQuadr.NE.-1 ) THEN
        STOP 'MOM_V_BOTDRAG_COEFF: invalid selectBotDragQuadr value'
       ENDIF

C--   Apply bottom mask (i.e., zero except at bottom):
       IF ( k.EQ.kBottom ) THEN
        DO j=1-OLy+1,sNy+OLy
         DO i=1-OLx,sNx+OLx
           cDrag(i,j) = cDrag(i,j)*_maskS(i,j,k,bi,bj)
         ENDDO
        ENDDO
       ELSE
        DO j=1-OLy+1,sNy+OLy
         DO i=1-OLx,sNx+OLx
           cDrag(i,j) = cDrag(i,j)*_maskS(i,j,k,bi,bj)
     &                * ( oneRS -_maskS(i,j,kDown,bi,bj) )
         ENDDO
        ENDDO
       ENDIF

C-    end k loop
c     ENDDO

      RETURN
      END

#include "CAL_OPTIONS.h"

      SUBROUTINE CAL_TOSECONDS(
     I                          date,
     O                          timeint,
     I                          myThid )

C     ==================================================================
C     SUBROUTINE cal_ToSeconds
C     ==================================================================
C
C     o Given a time interval as a date array return the number of
C       seconds in that time interval.
C
C       If one wanted to use calendar dates in this routine, then
C       the date should be after the calendar refdate and timeint
C       would be the number of seconds that have elapsed since the
C       refdate. Of course this can also be done by first calling
C       sub cal_TimePassed and then calling this routine with the
C       resulting time interval array.
C
C     started: Christian Eckert eckert@mit.edu  30-Jun-1999
C     changed: Christian Eckert eckert@mit.edu  29-Dec-1999
C              - restructured the original version in order to have a
C                better interface to the MITgcmUV.
C              Christian Eckert eckert@mit.edu  03-Feb-2000
C              - Introduced new routine and function names, cal_<NAME>,
C                for verion 0.1.3.
C              21-Sep-2003: fixed check_sign logic to work with
C              negative intervals (menemenlis@jpl.nasa.gov)
C
C     ==================================================================
C     SUBROUTINE cal_ToSeconds
C     ==================================================================

      IMPLICIT NONE

C     == global variables ==
#include "EEPARAMS.h"
#include "cal.h"

C     == routine arguments ==
      INTEGER date(4)
      _RL     timeint
      INTEGER myThid

C     == local variables ==
      _RL     fac, nsecs, ndays
      INTEGER ierr, check_sign, hhmmss
      CHARACTER*(MAX_LEN_MBUF) msgBuf
C     == end of interface ==

c     print *,'cal_toseconds: date',date
c     print *,'cal_toseconds: timeint',timeint

      IF ( cal_setStatus .LT. 1 ) THEN
        WRITE( msgBuf,'(2A,4I9)') 'CAL_TOSECONDS: ',
     &       'date=',date(1),date(2),date(3),date(4)
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE( msgBuf,'(2A,I2,A)') 'CAL_TOSECONDS: ',
     &    'called too early (cal_setStatus=',cal_setStatus,' )'
        CALL PRINT_ERROR( msgBuf, myThid )
        STOP 'ABNORMAL END: S/R CAL_CONVDATE'
      ENDIF

      check_sign = 1
      if ( ( (date(1).lt.0) .and. date(2).gt.0 ) .or.
     &     ( (date(1).gt.0) .and. date(2).lt.0 ) )
     &     check_sign = -1

      if (((date(4) .eq. -1) .and.
     &    (date(3) .eq.  0) .and.
     &    (check_sign .ge. 0)) .or.
     &    usingModelCalendar) then
        if ((date(1) .lt. 0) .or.
     &      (date(2) .lt. 0)) then
          ndays  = -date(1)
          hhmmss = -date(2)
          fac    = -1
        else
          ndays  = date(1)
          hhmmss = date(2)
          fac    = 1
        endif
        nsecs   = ndays*secondsperday +
     &            (hhmmss/10000)*secondsperhour +
     &            mod(hhmmss/100,100)*secondsperminute +
     &            mod(hhmmss,100)
        timeint = fac*nsecs
      else

        ierr = 1001
        call cal_PrintError( ierr, myThid )
        stop ' stopped in cal_ToSeconds.'

      endif

      RETURN
      END

#include "RBCS_OPTIONS.h"

C !INTERFACE: ==========================================================
      SUBROUTINE RBCS_INIT_VARIA( myThid )

C !DESCRIPTION:
C calls subroutines that initialized variables for relaxed
c boundary conditions

C !USES: ===============================================================
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#ifdef ALLOW_PTRACERS
#include "PTRACERS_SIZE.h"
#endif
#include "RBCS_SIZE.h"
c#include "RBCS_PARAMS.h"
#include "RBCS_FIELDS.h"

C !INPUT PARAMETERS: ===================================================
C  myThid               :: thread number
      INTEGER myThid
CEOP

#ifdef ALLOW_RBCS

C     !LOCAL VARIABLES:
C     i,j,k,bi,bj,iTracer  :: loop indices
      INTEGER i,j,k,bi,bj
#ifdef ALLOW_PTRACERS
      INTEGER iTracer
#endif

      DO bj = myByLo(myThid), myByHi(myThid)
        DO bi = myBxLo(myThid), myBxHi(myThid)
          rbcsLdRec(bi,bj) = 0
          DO k=1,Nr
            DO j=1-Oly,sNy+OLy
              DO i=1-Olx,sNx+Olx
#ifndef DISABLE_RBCS_MOM
                rbcu0(i,j,k,bi,bj) = 0. _d 0
                rbcv0(i,j,k,bi,bj) = 0. _d 0
                rbcu1(i,j,k,bi,bj) = 0. _d 0
                rbcv1(i,j,k,bi,bj) = 0. _d 0
                RBCuVel(i,j,k,bi,bj) = 0. _d 0
                RBCvVel(i,j,k,bi,bj) = 0. _d 0
#endif
                rbct0(i,j,k,bi,bj) = 0. _d 0
                rbcs0(i,j,k,bi,bj) = 0. _d 0
                rbct1(i,j,k,bi,bj) = 0. _d 0
                rbcs1(i,j,k,bi,bj) = 0. _d 0
                RBCtemp(i,j,k,bi,bj) = 0. _d 0
                RBCsalt(i,j,k,bi,bj) = 0. _d 0
              ENDDO
            ENDDO
          ENDDO
        ENDDO
      ENDDO

#ifdef ALLOW_PTRACERS
C     Loop over tracers
      DO iTracer = 1, PTRACERS_num
        DO bj = myByLo(myThid), myByHi(myThid)
         DO bi = myBxLo(myThid), myBxHi(myThid)
           DO k=1,Nr
             DO j=1-Oly,sNy+OLy
               DO i=1-Olx,sNx+Olx
                rbcptr0(i,j,k,bi,bj,iTracer) = 0. _d 0
                rbcptr1(i,j,k,bi,bj,iTracer) = 0. _d 0
                RBC_ptracers(i,j,k,bi,bj,iTracer) = 0. _d 0
               ENDDO
              ENDDO
            ENDDO
          ENDDO
        ENDDO
C       end of Tracer loop
      ENDDO
#endif /* ALLOW_PTRACERS */

#endif /* ALLOW_RBCS */

      RETURN
      END

#include "SALT_PLUME_OPTIONS.h"

CBOP 0
C     !ROUTINE: SALT_PLUME_TENDENCY_APPLY_T
C     !INTERFACE:
      SUBROUTINE SALT_PLUME_TENDENCY_APPLY_T(
     U                      gT_arr,
     I                      iMin,iMax,jMin,jMax, k, bi, bj,
     I                      myTime, myIter, myThid )

C     !DESCRIPTION:
C     Add salt_plume tendency terms to T tendency.
C     Routine works for one level at a time.
C     SaltPlume is the amount of salt rejected by ice while freezing;
C     it is here redistributed to multiple vertical levels as per
C     Duffy et al. (GRL 1999).

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
c#include "DYNVARS.h"
#include "SALT_PLUME.h"

C     !INPUT/OUTPUT PARAMETERS:
C     gT_arr    :: the tendency array
C     iMin,iMax :: Working range of x-index for applying forcing.
C     jMin,jMax :: Working range of y-index for applying forcing.
C     k         :: Current vertical level index
C     bi,bj     :: Current tile indices
C     myTime    :: Current time in simulation
C     myIter    :: Current iteration number
C     myThid    :: my Thread Id number
      _RL     gT_arr(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER iMin, iMax, jMin, jMax
      INTEGER k, bi, bj
      _RL     myTime
      INTEGER myIter
      INTEGER myThid
CEOP

#ifdef ALLOW_SALT_PLUME
#ifdef SALT_PLUME_VOLUME

C     !LOCAL VARIABLES:
      INTEGER i, j
Catn unit plumeEtend [m/s * kg/m3 * J/kg/degC * degC] = [W/m2]
      _RL plumeEtend(1-OLx:sNx+OLx,1-OLy:sNy+OLy)

Catn define local Tfrz -1.9degC when sea-ice forms
      DO j=jMin,jMax
       DO i=iMin,iMax
        IF ( SaltPlumeDepth(i,j,bi,bj) .GT. ABS(rF(k)) ) THEN
         plumeEtend(i,j) = SPforcingT(i,j,k,bi,bj)
         gT_arr(i,j) = gT_arr(i,j) + plumeEtend(I,J)
     &        *recip_drF(k)*mass2rUnit*_recip_hFacC(i,j,k,bi,bj)
     &        /HeatCapacity_Cp
        ELSE
         plumeEtend(i,j) = 0. _d 0
        ENDIF
       ENDDO
      ENDDO

#ifdef ALLOW_DIAGNOSTICS
      IF ( useDiagnostics ) THEN
       CALL DIAGNOSTICS_FILL (
     &      plumeEtend,'oceEPtnd',k,1,2,bi,bj,myThid )
      ENDIF
#endif /* ALLOW_DIAGNOSTICS */

#endif /* SALT_PLUME_VOLUME */
#endif /* ALLOW_SALT_PLUME */

      RETURN
      END

#include "COST_OPTIONS.h"
#ifdef ALLOW_AUTODIFF
# include "AUTODIFF_OPTIONS.h"
#endif

CBOP
C     !ROUTINE: COST_FINAL_RESTORE

C     !INTERFACE:
      SUBROUTINE COST_FINAL_RESTORE( lastDiva, myThid )

C     !DESCRIPTION:
C     Restore cost function value
C     This is required in conjunction with DIVA
C     heimbach@mit.edu 5-Mar-2003

C     !USES:
      IMPLICIT NONE
C     == Global variables ===
#include "EEPARAMS.h"
#include "SIZE.h"
#include "cost.h"

C     !INPUT/OUTPUT PARAMETERS:
C     lastDiva :: True if last AD run from DIVA sequence, False otherwise
C     myThid   :: my Thread Id number
      LOGICAL lastDiva
      INTEGER myThid

#ifdef ALLOW_DIVIDED_ADJOINT
C     !LOCAL VARIABLES:
      LOGICAL exst
      INTEGER idivbeg, idivend
CEOP

      _BEGIN_MASTER( myThid )

        INQUIRE(FILE='divided.ctrl',EXIST=exst)
        IF (exst) THEN
          OPEN(UNIT=76,FILE='divided.ctrl',FORM='formatted')
          READ(UNIT=76,FMT=*) idivbeg,idivend
          CLOSE(UNIT=76)
        ELSE
          idivbeg = -2
        ENDIF

        IF ( idivbeg .EQ. 0 ) THEN
          lastDiva = .TRUE.
          OPEN(UNIT=76,FILE='costfinal')
          READ(76,*) fc
          CLOSE(76)
        ELSE
          lastDiva = .FALSE.
        ENDIF

      _END_MASTER( myThid )
      _BARRIER

#endif /* ALLOW_DIVIDED_ADJOINT */

      RETURN
      END

#include "PACKAGES_CONFIG.h"
#include "CPP_OPTIONS.h"
#ifdef ALLOW_AUTODIFF
# include "AUTODIFF_OPTIONS.h"
#endif
#ifdef ALLOW_GENERIC_ADVDIFF
# include "GAD_OPTIONS.h"
#endif
#ifdef ALLOW_GGL90
# include "GGL90_OPTIONS.h"
#endif
#ifdef ALLOW_GMREDI
# include "GMREDI_OPTIONS.h"
#endif
#ifdef ALLOW_OBCS
# include "OBCS_OPTIONS.h"
#endif
#ifdef ALLOW_SEAICE
# include "SEAICE_OPTIONS.h"
#endif
#ifdef ALLOW_SALT_PLUME
# include "SALT_PLUME_OPTIONS.h"
#endif
#ifdef ALLOW_GCHEM
# include "GCHEM_OPTIONS.h"
#endif
#ifdef ALLOW_DIC
# include "DIC_OPTIONS.h"
#endif
#ifdef ALLOW_BLING
# include "BLING_OPTIONS.h"
#endif
#ifdef ALLOW_EXF
# include "EXF_OPTIONS.h"
#endif
#ifdef ALLOW_STREAMICE
# include "STREAMICE_OPTIONS.h"
#endif
#ifdef ALLOW_SHELFICE
# include "SHELFICE_OPTIONS.h"
#endif
#ifdef ALLOW_COST
# include "COST_OPTIONS.h"
#endif
#ifdef ALLOW_CTRL
# include "CTRL_OPTIONS.h"
#endif
#ifdef ALLOW_ECCO
# include "ECCO_OPTIONS.h"
#endif
#ifdef ALLOW_PROFILES
# include "PROFILES_OPTIONS.h"
#endif
#ifdef ALLOW_OBSFIT
# include "OBSFIT_OPTIONS.h"
#endif
#ifdef ALLOW_RBCS
# include "RBCS_OPTIONS.h"
#endif

CBOP
C     !ROUTINE: THE_MAIN_LOOP
C     !INTERFACE:
      SUBROUTINE THE_MAIN_LOOP( myTime, myIter, myThid )

C     !DESCRIPTION: \bv
C     *================================================================*
C     | SUBROUTINE the_main_loop
C     | o Run the ocean model and evaluate the specified cost function.
C     *================================================================*
C     | THE_MAIN_LOOP is the toplevel routine for the Transformation of
C     | Algorithm in Fortran (TAF).
C     | For this purpose the initialization of the model was split into
C     | two parts. Variables that are kept independent of control
C     | parameters (e.g. horizontal grid dxC, etc.) are set in
C     | INITIALISE_FIXED, whereas variables that can (potentially) be
C     | modified by control parameters (e.g. initial temperature and
C     | salinity) are initialized in INITIALISE_VARIA.
C     *================================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"

c**************************************
#ifdef ALLOW_AUTODIFF
# ifndef ALLOW_OPENAD

c These includes are needed for
c AD-checkpointing.
c They provide the fields to be stored.

#  include "GRID.h"
#  include "DYNVARS.h"
#  include "SURFACE.h"
#  include "FFIELDS.h"
#  include "EOS.h"
#  include "AUTODIFF.h"

#  ifdef ALLOW_GENERIC_ADVDIFF
#   include "GAD.h"
#   include "GAD_SOM_VARS.h"
#  endif
#  ifdef ALLOW_MOM_FLUXFORM
#   include "MOM_FLUXFORM.h"
#  endif
#  ifdef ALLOW_CD_CODE
#   include "CD_CODE_VARS.h"
#  endif
#  ifdef ALLOW_PTRACERS
#   include "PTRACERS_SIZE.h"
#   include "PTRACERS_FIELDS.h"
#   include "PTRACERS_START.h"
#  endif
#  ifdef ALLOW_GCHEM
#   include "GCHEM_SIZE.h"
#   include "GCHEM_FIELDS.h"
#  endif
#  ifdef ALLOW_CFC
#   include "CFC.h"
#  endif
#  ifdef ALLOW_DIC
#   include "DIC_VARS.h"
#   include "DIC_LOAD.h"
#   include "DIC_ATMOS.h"
#   include "DIC_CTRL.h"
#   include "DIC_COST.h"
#  endif
#  ifdef ALLOW_OBCS
#   include "OBCS_PARAMS.h"
#   include "OBCS_FIELDS.h"
#   include "OBCS_SEAICE.h"
#   ifdef ALLOW_PTRACERS
#    include "OBCS_PTRACERS.h"
#   endif
#  endif
#  ifdef ALLOW_EXF
#   ifdef ALLOW_BULKFORMULAE
#    include "EXF_CONSTANTS.h"
#   endif
#   include "EXF_INTERP_SIZE.h"
#   include "EXF_FIELDS.h"
#  endif /* ALLOW_EXF */
#  ifdef ALLOW_BLING
#   include "BLING_VARS.h"
#   include "BLING_LOAD.h"
#  endif
#  ifdef ALLOW_SEAICE
#   include "SEAICE_SIZE.h"
#   include "SEAICE.h"
#   include "SEAICE_PARAMS.h"
#   include "SEAICE_COST.h"
#   include "SEAICE_TRACER.h"
#  endif
#  ifdef ALLOW_SALT_PLUME
#   include "SALT_PLUME.h"
#  endif
#  ifdef ALLOW_THSICE
#   include "THSICE_SIZE.h"
#   include "THSICE_VARS.h"
#   include "THSICE_COST.h"
#  endif
#  ifdef ALLOW_SHELFICE
#   include "SHELFICE.h"
#   include "SHELFICE_COST.h"
#  endif
#  ifdef ALLOW_STREAMICE
#   include "STREAMICE.h"
#   include "STREAMICE_ADV.h"
#   include "STREAMICE_BDRY.h"
#   include "STREAMICE_CG.h"
#  endif
#  ifdef ALLOW_EBM
#   include "EBM.h"
#  endif
#  ifdef ALLOW_RBCS
#   include "RBCS_SIZE.h"
#   include "RBCS_FIELDS.h"
#  endif
#  ifdef ALLOW_OFFLINE
#   include "OFFLINE.h"
#  endif
# if (defined ALLOW_CG2D_NSA || defined NONLIN_FRSURF || \
      defined ALLOW_DEPTH_CONTROL)
#   include "CG2D.h"
#  endif
#  ifdef ALLOW_DIVIDED_ADJOINT
#   ifdef ALLOW_USE_MPI
#    include "mpif.h"
#   endif
#  endif

C-- keep tamc.h here without ALLOW_AUTODIFF_TAMC for ALLOW_TAMC_CHECKPOINTING
#  include "tamc.h"

#  ifdef ALLOW_GGL90
#   include "GGL90.h"
#  endif
#  ifdef ALLOW_PROFILES
#   include "PROFILES_SIZE.h"
#   include "profiles.h"
#  endif
#  ifdef ALLOW_OBSFIT
#   include "OBSFIT_SIZE.h"
#   include "OBSFIT.h"
#  endif
#  ifdef ALLOW_ECCO
#   include "ecco_cost.h"
#  endif
C     it is important that this file is included after SEAICE_SIZE.h
#  include "AUTODIFF_STORE.h"
# endif /* undef ALLOW_OPENAD */

# ifdef ALLOW_CTRL
# include "CTRL_SIZE.h"
# include "CTRL.h"
# include "CTRL_DUMMY.h"
# include "CTRL_GENARR.h"
# include "CTRL_OBCS.h"
# endif
# ifdef ALLOW_COST
#  include "cost.h"
# endif

#endif /* ALLOW_AUTODIFF */

#ifdef ALLOW_TAPENADE
# ifdef ALLOW_GMREDI
#  include "GMREDI.h"
# endif
# ifdef ALLOW_KPP
#  include "KPP.h"
c#  include "KPP_PARAMS.h"
# endif
# ifdef ALLOW_EXF
#  include "EXF_PARAM.h"
#  include "EXF_INTERP_PARAM.h"
# endif
# ifdef ALLOW_DOWN_SLOPE
#  include "DWNSLP_SIZE.h"
#  include "DWNSLP_VARS.h"
# endif
# ifdef ALLOW_PTRACERS
#  include "PTRACERS_PARAMS.h"
# endif
#endif /* ALLOW_TAPENADE */

c**************************************

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     note: under the multi-threaded model myIter and
C           myTime are local variables passed around as routine
C           arguments. Although this is fiddly it saves the need to
C           impose additional synchronisation points when they are
C           updated.
C     myTime :: time counter for this thread
C     myIter :: iteration counter for this thread
C     myThid :: thread number for this instance of the routine.
      _RL     myTime
      INTEGER myIter
      INTEGER myThid

C     !FUNCTIONS:
C     == Functions ==

C     !LOCAL VARIABLES:
C     == Local variables ==
      INTEGER iloop
#ifdef STORE_LOADEDREC_TEST
      INTEGER bi,bj
#endif /* STORE_LOADEDREC_TEST */
#ifdef ALLOW_AUTODIFF
# ifdef ALLOW_TAMC_CHECKPOINTING
      INTEGER ilev_1
      INTEGER ilev_2, max_lev2
#  ifndef AUTODIFF_2_LEVEL_CHECKPOINT
      INTEGER ilev_3, max_lev3
#  endif
#  ifdef AUTODIFF_4_LEVEL_CHECKPOINT
      INTEGER ilev_4, max_lev4
#  endif
# endif /* ALLOW_TAMC_CHECKPOINTING */
#endif /* ALLOW_AUTODIFF */
CEOP

#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_ENTER('THE_MAIN_LOOP',myThid)
#endif

#ifdef ALLOW_AUTODIFF_TAMC
c--   Initialize storage for the cost function evaluation.
c---------------------------------------------------------
c--   Initialize storage for the initialisation phase.
# if ( defined ALLOW_AUTODIFF_WHTAPEIO && !defined ALLOW_DIVIDED_ADJOINT )
CADJ INIT tapelev_init       = COMMON, 1
# else
CADJ INIT tapelev_init       = USER
# endif
c--   this tape is never used
cCADJ INIT tapelev_ini_bibj   = USER
# ifdef INCLUDE_CONVECT_INI_CALL
c--   currently only used in convective_adjustement_ini.F
#  if ( defined ALLOW_AUTODIFF_WHTAPEIO && !defined ALLOW_DIVIDED_ADJOINT )
CADJ INIT tapelev_ini_bibj_k = COMMON, nSx*nSy*Nr
#  else
CADJ INIT tapelev_ini_bibj_k = USER
#  endif
# endif
# ifdef ALLOW_GENTIM2D_CONTROL
c--   exclusive tape for variables with suffix "_dummy"
CADJ INIT dummytape          = COMMON, 1
# endif

c--   Initialize storage for the outermost loop.
# ifdef ALLOW_TAMC_CHECKPOINTING
#  if (defined (AUTODIFF_2_LEVEL_CHECKPOINT))
CADJ  INIT tapelev2 = USER
CADJ  INIT tapelvi2 = USER,'adi'
#  elif (defined (AUTODIFF_4_LEVEL_CHECKPOINT))
CADJ  INIT tapelev4 = USER
CADJ  INIT tapelvi4 = USER,'adi'
#  else
CADJ  INIT tapelev3 = USER
CADJ  INIT tapelvi3 = USER,'adi'
#  endif
# endif
#endif /* ALLOW_AUTODIFF_TAMC */

#ifdef ALLOW_AUTODIFF
      nIter0 = NINT( (startTime-baseTime)/deltaTClock )
#endif

#ifdef ALLOW_AUTODIFF_TAMC
      ikey_dynamics = 1
# if ( defined ALLOW_AUTODIFF_WHTAPEIO && defined ALLOW_DIVIDED_ADJOINT )
C     this needs to happen before any store directive to taplev_init
      CALL AUTODIFF_WHTAPEIO_SYNC( 1 , 0, myThid )
# endif
# ifdef ALLOW_GENTIM2D_CONTROL
CADJ STORE xx_gentim2d_dummy = dummytape, key = 1 , kind = isbyte
# endif
# ifdef ALLOW_SHELFICE
CADJ STORE shelficeLoadAnomaly = tapelev_init, key=1, kind=isbyte
# endif
# ifdef ALLOW_STREAMICE
CADJ STORE H_streamice              = tapelev_init, key=1
CADJ STORE B_glen                   = tapelev_init, key=1
CADJ STORE bdot_streamice           = tapelev_init, key=1
CADJ STORE c_basal_friction         = tapelev_init, key=1
CADJ STORE streamice_bdot_maxmelt_v = tapelev_init, key=1
#  ifdef USE_ALT_RLOW
CADJ STORE r_low_si                 = tapelev_init, key=1
#  endif
# endif
# ifdef ALLOW_DIC
CADJ STORE co2atmos = tapelev_init, key = 1
CADJ STORE alpha    = tapelev_init, key = 1
# endif
#endif

#ifdef ALLOW_OPENAD
# ifdef ALLOW_GENARR2D_CONTROL
cphc$openad INDEPENDENT(xx_genarr2d)
c$openad INDEPENDENT(xx_genarr2d_dummy)
# endif
# ifdef ALLOW_GENARR3D_CONTROL
cphc$openad INDEPENDENT(xx_genarr3d)
c$openad INDEPENDENT(xx_genarr3d_dummy)
# endif
# ifdef ALLOW_GENTIM2D_CONTROL
cphc$openad INDEPENDENT(xx_gentim2d)
c$openad INDEPENDENT(xx_gentim2d_dummy)
# endif
#endif /* ALLOW_OPENAD */

#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_CALL('INITIALISE_VARIA',myThid)
#endif
C--   Set initial conditions (variable arrays)
      CALL TIMER_START('INITIALISE_VARIA    [THE_MAIN_LOOP]', myThid)
      CALL INITIALISE_VARIA( myThid )
      CALL TIMER_STOP ('INITIALISE_VARIA    [THE_MAIN_LOOP]', myThid)

#ifdef ALLOW_SHOWFLOPS
      CALL TIMER_START('SHOWFLOPS_INIT      [THE_MAIN_LOOP]', myThid)
      CALL SHOWFLOPS_INIT( myThid )
      CALL TIMER_STOP ('SHOWFLOPS_INIT      [THE_MAIN_LOOP]', myThid)
#endif

c--   Do the model integration.
      CALL TIMER_START('MAIN LOOP           [THE_MAIN_LOOP]', myThid)

c     >>>>>>>>>>>>>>>>>>>>>>>>>>>   LOOP   <<<<<<<<<<<<<<<<<<<<<<<<<<<<
c     >>>>>>>>>>>>>>>>>>>>>>>>>>>  STARTS  <<<<<<<<<<<<<<<<<<<<<<<<<<<<

#ifdef USE_PDAF
c     Initialize PDAF
      CALL TIMER_START('INIT_PDAF           [THE_MAIN_LOOP]', myThid)
      CALL INIT_PDAF( nIter0, myTime, myIter, myThid )
      CALL TIMER_STOP ('INIT_PDAF           [THE_MAIN_LOOP]', myThid)
#endif

#if ( defined ALLOW_AUTODIFF_WHTAPEIO && defined ALLOW_DIVIDED_ADJOINT )
C     end of initialisation and use of tapelev_init: write buffer to disk
      CALL AUTODIFF_WHTAPEIO_SYNC( 1 , 1, myThid )
#endif

c++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
#ifndef ALLOW_OPENAD
# ifdef ALLOW_AUTODIFF
#  ifdef ALLOW_TAMC_CHECKPOINTING
c++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

#   ifdef AUTODIFF_4_LEVEL_CHECKPOINT
      max_lev4=nTimeSteps/(nchklev_1*nchklev_2*nchklev_3)+1
#   endif
#   ifndef AUTODIFF_2_LEVEL_CHECKPOINT
      max_lev3=nTimeSteps/(nchklev_1*nchklev_2)+1
#   endif
      max_lev2=nTimeSteps/nchklev_1+1

c**************************************
#   ifdef ALLOW_DIVIDED_ADJOINT
CADJ loop = divided
#   endif
c**************************************

#   ifdef AUTODIFF_4_LEVEL_CHECKPOINT
      do ilev_4 = 1,nchklev_4
         if(ilev_4.le.max_lev4) then
c**************************************
#    ifdef ALLOW_AUTODIFF_WHTAPEIO
            CALL AUTODIFF_WHTAPEIO_SYNC( 4 , 0, myThid )
#    endif
            CALL AUTODIFF_STORE( myThid )
#include "checkpoint_lev4_directives.h"
            CALL AUTODIFF_RESTORE( myThid )
#    ifdef ALLOW_AUTODIFF_WHTAPEIO
            CALL AUTODIFF_WHTAPEIO_SYNC( 4 , 1, myThid )
#    endif
c**************************************
c--     Initialise storage for the middle loop.
CADJ    INIT tapelev3 = USER
CADJ    INIT tapelvi3 = USER,'adi'
#   endif /* AUTODIFF_4_LEVEL_CHECKPOINT */

#   ifndef AUTODIFF_2_LEVEL_CHECKPOINT
      do ilev_3 = 1,nchklev_3
         if(ilev_3.le.max_lev3) then
c**************************************
#    ifdef ALLOW_AUTODIFF_WHTAPEIO
            CALL AUTODIFF_WHTAPEIO_SYNC( 3 , 0, myThid )
#    endif
            CALL AUTODIFF_STORE( myThid )
#include "checkpoint_lev3_directives.h"
            CALL AUTODIFF_RESTORE( myThid )
#    ifdef ALLOW_AUTODIFF_WHTAPEIO
            CALL AUTODIFF_WHTAPEIO_SYNC( 3 , 1, myThid )
#    endif
c**************************************
c--     Initialise storage for the middle loop.
CADJ    INIT tapelev2 = USER
CADJ    INIT tapelvi2 = USER,'adi'
#   endif /* AUTODIFF_2_LEVEL_CHECKPOINT */

        do ilev_2 = 1,nchklev_2
         if(ilev_2.le.max_lev2) then
c**************************************
#   ifdef ALLOW_AUTODIFF_WHTAPEIO
            CALL AUTODIFF_WHTAPEIO_SYNC( 2 , 0, myThid )
#   endif
            CALL AUTODIFF_STORE( myThid )
#include "checkpoint_lev2_directives.h"
            CALL AUTODIFF_RESTORE( myThid )
#   ifdef ALLOW_AUTODIFF_WHTAPEIO
            CALL AUTODIFF_WHTAPEIO_SYNC( 2 , 1, myThid )
#   endif
c**************************************

#  endif /* ALLOW_TAMC_CHECKPOINTING */

#  ifdef ALLOW_AUTODIFF_TAMC
c**************************************
c--       Initialize storage for the innermost loop.
c--       Always check common block sizes for the checkpointing!
c--
CADJ INIT comlev1        = COMMON,nchklev_1
CADJ INIT comlev1_bibj   = COMMON,nchklev_1*nSx*nSy
CADJ INIT comlev1_bibj_k = COMMON,nchklev_1*nSx*nSy*Nr
#   ifdef ALLOW_BLING
CADJ INIT comlev1_bibj_ijk = COMMON,
CADJ &    nchklev_1*nSx*nSy*Nr*(2*OLy+sNy)*(2*OLx+sNx)
#   endif
c--
#   ifdef ALLOW_KPP
CADJ INIT comlev1_kpp    = COMMON,nchklev_1*nSx*nSy
CADJ INIT comlev1_kpp_k  = COMMON,nchklev_1*nSx*nSy*Nr
#   endif /* ALLOW_KPP */
c--
#   ifdef ALLOW_GMREDI
CADJ INIT comlev1_gmredi_k_gad = COMMON,nchklev_1*nSx*nSy*Nr*maxpass
cCADJ INIT comlev1_gmredi_slope = COMMON,nchklev_1*nSx*nSy*Nr*3
#   endif /* ALLOW_GMREDI */
c--
#   ifdef ALLOW_PTRACERS
CADJ INIT comlev1_bibj_ptracers = COMMON,
CADJ &    nchklev_1*nSx*nSy*PTRACERS_num
CADJ INIT comlev1_bibj_k_ptracers = COMMON,
CADJ &    nchklev_1*nSx*nSy*PTRACERS_num*Nr
#   endif /* ALLOW_PTRACERS */
c--
#   ifdef ALLOW_MOM_COMMON
#   ifndef AUTODIFF_DISABLE_LEITH
CADJ INIT comlev1_mom_ijk_loop
CADJ &     = COMMON,nchklev_1*(sNx+2*OLx)*nSx*(sNy+2*OLy)*nSy*Nr
#   endif /* AUTODIFF_DISABLE_LEITH */
#   endif /* ALLOW_MOM_COMMON */
c--
#   if (defined ALLOW_EXF && defined ALLOW_BULKFORMULAE)
CADJ INIT comlev1_exf_1 = COMMON,nchklev_1*sNx*nSx*sNy*nSy
CADJ INIT comlev1_exf_2 = COMMON,niter_bulk*nchklev_1*sNx*nSx*sNy*nSy
#   endif /* ALLOW_BULKFORMULAE */
c--
#   ifdef ALLOW_SEAICE
#    ifdef SEAICE_CGRID
CADJ INIT comlev1_dynsol = COMMON,nchklev_1*MPSEUDOTIMESTEPS
#     ifdef SEAICE_LSR_ADJOINT_ITER
CADJ INIT comlev1_lsr = COMMON,nchklev_1*MPSEUDOTIMESTEPS*SOLV_MAX_FIXED
CADJ INIT comlev1_bibj_lsr = COMMON,
CADJ &  nchklev_1*nSx*nSy*MPSEUDOTIMESTEPS*SOLV_MAX_FIXED
#     else /* make the common blocks smaller to reduce memory footprint */
CADJ INIT comlev1_lsr      = COMMON,        nchklev_1*MPSEUDOTIMESTEPS
CADJ INIT comlev1_bibj_lsr = COMMON,nSx*nSy*nchklev_1*MPSEUDOTIMESTEPS
#     endif
#     ifdef SEAICE_ALLOW_EVP
CADJ INIT comlev1_evp      = COMMON,        nEVPstepMax*nchklev_1
CADJ INIT comlev1_bibj_evp = COMMON,nSx*nSy*nEVPstepMax*nchklev_1
#     endif
#    endif
CML#   ifdef SEAICE_MULTICATEGORY
CMLCADJ INIT comlev1_multdim = COMMON,nchklev_1*nSx*nSy*nitd
CML#   endif
#    ifndef DISABLE_MULTIDIM_ADVECTION
CADJ INIT comlev1_bibj_k_gadice = COMMON,
CADJ &    nchklev_1*nSx*nSy*maxpass
CADJ INIT comlev1_bibj_k_gadice_pass = COMMON,
CADJ &    nchklev_1*nSx*nSy*maxpass*maxcube
#    endif /* DISABLE_MULTIDIM_ADVECTION */
#   endif /* ALLOW_SEAICE */
c--
#   ifdef ALLOW_THSICE
C     Tape for thsice_advection, which is called for thSIce_nAdv (=5)
C     different variables (thSIce_nAdv is set in THSICE_SIZE.h)
CADJ INIT comlev1_thsice_adv  = COMMON,
CADJ &    nchklev_1*nSx*nSy*maxcube*thSIce_nAdv
CADJ INIT comlev1_thsice_nlyr = COMMON,nchklev_1*nSx*nSy*nlyr
CADJ INIT comlev1_thsice_s4t  = COMMON,nchklev_1*nSx*nSy*MaxTsf
#    if (defined ALLOW_EXF && defined ALLOW_BULKFORMULAE)
C     These tapes are only used within thsice_get_exf.F
CADJ INIT comlev1_thsice_exf       = COMMON,
CADJ &    nchklev_1*nSx*nSy*(MaxTsf+1)
CADJ INIT comlev1_thsice_exf_niter = COMMON,
CADJ &    nchklev_1*nSx*nSy*(MaxTsf+1)*niter_bulk
CADJ INIT comlev1_thsice_exf_ij    = COMMON,
CADJ &    nchklev_1*nSx*nSy*(MaxTsf+1)*niter_bulk*sNx*sNy
#    endif
#   endif /* ALLOW_THSICE */
c--
#   ifdef ALLOW_STEEP_ICECAVITY
CADJ INIT comlev1_stic_bibj_ijk = COMMON,
CADJ &    nchklev_1*nSx*nSy*Nr*(2*OLy+sNy)*(2*OLx+sNx)
#   endif
c--
#   ifdef ALLOW_STREAMICE
CADJ INIT comlev1_stream_nl    = COMMON,nchklev_1*streamice_max_nl
CADJ INIT comlev1_stream_front = COMMON,nchklev_1*4
CADJ INIT comlev1_stream_ij
CADJ &     = COMMON,nchklev_1*4*(sNx+2)*nSx*(sNy+2)*nSy
CADJ INIT comlev1_stream_hybrid = COMMON,nchklev_1*sNx*nSx*sNy*nSy*Nr
#   endif
c--
#   ifdef ALLOW_CG2D_NSA
CADJ INIT comlev1_cg2d      = COMMON,nchklev_1
CADJ INIT comlev1_cg2d_iter = COMMON,nchklev_1*numItersMax
#   endif
#  endif /* ALLOW_AUTODIFF_TAMC */
c--
#  ifdef ALLOW_GENCOST_CONTRIBUTION
CADJ INIT comlev1_ngencost = COMMON,nchklev_1*NGENCOST
#  endif
c**************************************

#  ifdef STORE_LOADEDREC_TEST
          DO bj = myByLo(myThid), myByHi(myThid)
           DO bi = myBxLo(myThid), myBxHi(myThid)
            loadedRec(bi,bj) = 0
           ENDDO
          ENDDO
#  endif /* STORE_LOADEDREC_TEST */

#  if ( defined ALLOW_AUTODIFF_TAMC && defined ALLOW_OFFLINE )
C     The following statement forces TAF to store wVel correctly in some
C     outer checkpoint levels in some cases when it does not do it
C     automatically (similar to TICES in seaice_reg_ridge.F). This is a
C     TAF bug and this statement can probably be removed again, once
C     this bug is fixed (but it does not hurt, either).
#   ifndef AUTODIFF_USE_STORE_RESTORE
CADJ INCOMPLETE wVel
#   endif
#  endif
#  ifdef ALLOW_TAMC_CHECKPOINTING

          do ilev_1 = 1,nchklev_1

c--         The if-statement below introduces a some flexibility in the
c--         choice of the 3-tupel ( nchklev_1, nchklev_2, nchklev_3 ).

            iloop = (ilev_2 - 1)*nchklev_1 + ilev_1
#   ifndef AUTODIFF_2_LEVEL_CHECKPOINT
     &            + (ilev_3 - 1)*nchklev_2*nchklev_1
#   endif
#   ifdef AUTODIFF_4_LEVEL_CHECKPOINT
     &            + (ilev_4 - 1)*nchklev_3*nchklev_2*nchklev_1
#   endif

            if ( iloop .le. nTimeSteps ) then

#  else /* ALLOW_TAMC_CHECKPOINTING  undefined */

      DO iloop = 1, nTimeSteps

c++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
#  endif /* ALLOW_TAMC_CHECKPOINTING */
# endif /* ALLOW_AUTODIFF */
#endif /* undef ALLOW_OPENAD */
c++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

#ifndef ALLOW_AUTODIFF
      DO iloop = 1, nTimeSteps
#endif /* ALLOW_AUTODIFF */

c--     >>> Loop body start <<<

#ifdef ALLOW_AUTODIFF
      nIter0 = NINT( (startTime-baseTime)/deltaTClock )
C--   Reset the model iteration counter and the model time.
      myIter = nIter0 + (iloop-1)
      myTime = startTime + deltaTClock*(iloop-1)
# ifdef ALLOW_AUTODIFF_TAMC
#  ifdef ALLOW_TAMC_CHECKPOINTING
      ikey_dynamics = ilev_1
#  else
      ikey_dynamics = iloop
#  endif
# endif
#endif /* ALLOW_AUTODIFF */

#ifdef ALLOW_ECCO
      IF ( useECCO ) THEN
# ifdef ALLOW_DEBUG
        IF (debugMode) CALL DEBUG_CALL('COST_AVERAGESFIELDS',myThid)
# endif
c--   Accumulate time averages of temperature, salinity
        CALL TIMER_START('COST_AVERAGESFIELDS [MAIN_DO_LOOP]',myThid)
        CALL COST_AVERAGESFIELDS( myTime, myThid )
        CALL TIMER_STOP ('COST_AVERAGESFIELDS [MAIN_DO_LOOP]',myThid)
      ENDIF
#endif /* ALLOW_ECCO */

#ifdef ALLOW_PROFILES
      IF ( usePROFILES ) THEN
#ifdef ALLOW_DEBUG
        IF (debugMode) CALL DEBUG_CALL('PROFILES_INLOOP',myThid)
#endif
c--     Accumulate in-situ time averages of theta, salt, and SSH.
        CALL TIMER_START('PROFILES_INLOOP    [MAIN_DO_LOOP]', myThid)
        CALL PROFILES_INLOOP( myTime, myThid )
        CALL TIMER_STOP ('PROFILES_INLOOP    [MAIN_DO_LOOP]', myThid)
      ENDIF
#endif /* ALLOW_PROFILES */

#ifdef ALLOW_OBSFIT
      IF ( useOBSFIT ) THEN
#ifdef ALLOW_DEBUG
        IF (debugMode) CALL DEBUG_CALL('OBSFIT_INLOOP',myThid)
#endif
c--     Accumulate in-situ time averages of theta, salt, and SSH.
        CALL TIMER_START('OBSFIT_INLOOP      [MAIN_DO_LOOP]', myThid)
        CALL OBSFIT_INLOOP( myTime, myIter, myThid )
        CALL TIMER_STOP ('OBSFIT_INLOOP      [MAIN_DO_LOOP]', myThid)
      ENDIF
#endif /* ALLOW_OBSFIT */

      CALL TIMER_START('MAIN_DO_LOOP        [THE_MAIN_LOOP]', myThid)
      CALL MAIN_DO_LOOP( iloop, myTime, myIter, myThid )
      CALL TIMER_STOP ('MAIN_DO_LOOP        [THE_MAIN_LOOP]', myThid)

#ifdef USE_PDAF
C     PDAF analysis step
      CALL TIMER_START('ASSIMILATE_PDAF     [THE_MAIN_LOOP]', myThid)
      CALL ASSIMILATE_PDAF( myTime, myIter, myThid )
      CALL TIMER_STOP ('ASSIMILATE_PDAF     [THE_MAIN_LOOP]', myThid)
#endif

c--     >>> Loop body end <<<
#ifndef ALLOW_OPENAD
# ifdef ALLOW_AUTODIFF
#   ifdef ALLOW_TAMC_CHECKPOINTING
            endif
          enddo
          endif
        enddo
#    ifndef AUTODIFF_2_LEVEL_CHECKPOINT
        endif
      enddo
#    endif
#    ifdef AUTODIFF_4_LEVEL_CHECKPOINT
       endif
      enddo
#    endif
#   else /* ndef ALLOW_TAMC_CHECKPOINTING */
      ENDDO
#   endif /* ALLOW_TAMC_CHECKPOINTING */
# else /* ALLOW_AUTODIFF */
      ENDDO
# endif /* ALLOW_AUTODIFF */
#endif /* undef ALLOW_OPENAD */

c     >>>>>>>>>>>>>>>>>>>>>>>>>>>   LOOP   <<<<<<<<<<<<<<<<<<<<<<<<<<<<
c     >>>>>>>>>>>>>>>>>>>>>>>>>>>  STOPS   <<<<<<<<<<<<<<<<<<<<<<<<<<<<

#ifdef ALLOW_ECCO
c--     Accumulate time averages of temperature, salinity
      CALL TIMER_START('COST_AVERAGESFIELDS [THE_MAIN_LOOP]',myThid)
      CALL COST_AVERAGESFIELDS( endtime, myThid )
      CALL TIMER_STOP ('COST_AVERAGESFIELDS [THE_MAIN_LOOP]',myThid)
#endif /* ALLOW_ECCO */

#ifdef ALLOW_PROFILES
      IF ( usePROFILES ) THEN
c--   Accumulate in-situ time averages of temperature, salinity, SSH.
        CALL TIMER_START('PROFILES_INLOOP    [THE_MAIN_LOOP]', myThid)
        CALL PROFILES_INLOOP( endtime, myThid )
        CALL TIMER_STOP ('PROFILES_INLOOP    [THE_MAIN_LOOP]', myThid)
c--   Compute all profiles cost function contributions.
        CALL PROFILES_COST( myTime, myIter, myThid )
      ENDIF
#endif /* ALLOW_PROFILES */

#ifdef ALLOW_OBSFIT
      IF ( useOBSFIT ) THEN
c--   Accumulate in-situ time averages of temperature, salinity, SSH.
        CALL TIMER_START('OBSFIT_INLOOP      [THE_MAIN_LOOP]', myThid)
        CALL OBSFIT_INLOOP( endtime, myIter, myThid )
        CALL TIMER_STOP ('OBSFIT_INLOOP      [THE_MAIN_LOOP]', myThid)
c--   Compute all obsfit cost function contributions.
        CALL OBSFIT_COST( myTime, myIter, myThid )
      ENDIF
#endif /* ALLOW_OBSFIT */

#ifdef ALLOW_COST
c--   Compute all cost function contributions.
      CALL TIMER_START('COST_DRIVER        [THE_MAIN_LOOP]', myThid)
      CALL COST_DRIVER ( endTime, myIter, myThid )
      CALL TIMER_STOP ('COST_DRIVER        [THE_MAIN_LOOP]', myThid)

c--   Sum all cost function contributions.
      CALL TIMER_START('COST_FINAL         [THE_MAIN_LOOP]', myThid)
      CALL COST_FINAL ( myThid )
      CALL TIMER_STOP ('COST_FINAL         [THE_MAIN_LOOP]', myThid)

# ifdef ALLOW_OPENAD
c$openad DEPENDENT(fc)
# endif /* ALLOW_OPENAD */

#endif /* ALLOW_COST */

#ifdef USE_PDAF
C     PDAF finalization
      CALL FINALIZE_PDAF( )
#endif

      _BARRIER
      CALL TIMER_STOP ('MAIN LOOP           [THE_MAIN_LOOP]', myThid)

#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_LEAVE('THE_MAIN_LOOP',myThid)
#endif

      RETURN
      END

#include "GCHEM_OPTIONS.h"
#ifdef ALLOW_DARWIN
#include "DARWIN_OPTIONS.h"
#endif

CBOP
C !ROUTINE: GCHEM_WRITE_PICKUP

C !INTERFACE: ==========================================================
      SUBROUTINE GCHEM_WRITE_PICKUP( permPickup, suff,
     I                               myTime, myIter, myThid )

C !DESCRIPTION:
C     Writes pickup files needed for a restart
C     (wrapper interface to GCHEM sub-packages)

C !USES: ===============================================================
      IMPLICIT NONE
C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
c#include "PARAMS.h"
#include "GCHEM.h"

C !INPUT PARAMETERS: ===================================================
C     permPickup :: write a permanent pickup
C     suff       :: suffix for pickup file (eg. ckptA or 0000000010)
C     myTime     :: Current time in simulation
C     myIter     :: Current iteration number in simulation
C     myThid     :: My Thread Id number
      LOGICAL permPickup
      CHARACTER*(*) suff
      _RL     myTime
      INTEGER myIter
      INTEGER myThid
CEOP

#ifdef ALLOW_GCHEM
C     !LOCAL VARIABLES:

#ifdef ALLOW_DIC
      IF ( useDIC ) THEN
        CALL DIC_WRITE_PICKUP( permPickup, suff,
     I                         myTime, myIter, myThid )
      ENDIF
#endif /* ALLOW_DIC */

#ifdef ALLOW_BLING
      IF ( useBLING ) THEN
        CALL BLING_WRITE_PICKUP( permPickup, suff,
     I                         myTime, myIter, myThid )
      ENDIF
#endif /* ALLOW_BLING */

#ifdef ALLOW_DARWIN
      IF ( useDARWIN ) THEN
        CALL DARWIN_WRITE_PICKUP( permPickup, suff,
     I                            myTime, myIter, myThid )
#ifdef ALLOW_CARBON
        CALL DIC_WRITE_PICKUP( permPickup, suff,
     I                         myTime, myIter, myThid )
#endif
      ENDIF
#endif /* ALLOW_DARWIN */

#endif /* ALLOW_GCHEM */
      RETURN
      END

#include "DIAG_OPTIONS.h"

CBOP
C     !ROUTINE: DIAGSTATS_SETDIAG
C     !INTERFACE:
      SUBROUTINE DIAGSTATS_SETDIAG(
     O                      mate,
     U                      ndiagmx,
     I                      mId, listId, ndId, myThid )

C     !DESCRIPTION: \bv
C     *==================================================================
C     | S/R DIAGSTATS_SETDIAG
C     | o activate statistics diagnostic "ndId":
C     |   set pointer locations for this diagnostic ;
C     |   look for a counter mate and set it
C     *==================================================================
C     \ev

C     !USES:
      IMPLICIT NONE

C     == Global variables ===
#include "EEPARAMS.h"
#include "SIZE.h"
#include "DIAGNOSTICS_SIZE.h"
#include "DIAGNOSTICS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     mate    :: counter-mate number in available diagnostics list
C     ndiagmx :: current space allocated in storage array
C     mId    :: current field index in list "listId"
C     listId :: current list number that contains field "mId"
C     ndId   :: diagnostic number in available diagnostics list
C     myThid :: Thread number for this instance of the routine.
      INTEGER mate
      INTEGER ndiagmx
      INTEGER mId, listId, ndId
      INTEGER myThid
CEOP

C     !LOCAL VARIABLES:
C     == Local variables ==
      INTEGER stdUnit, errUnit
      INTEGER k, l
      LOGICAL flag

      CHARACTER*10 gcode
      CHARACTER*(MAX_LEN_MBUF) msgBuf


C **********************************************************************
C ****                SET POINTERS FOR DIAGNOSTIC ndId              ****
C **********************************************************************

      gcode   = gdiag(ndId)(1:8)
      stdUnit = standardMessageUnit
      errUnit = errorMessageUnit

C--   Seach for the same diag (with same freq) to see if already set
      flag = .TRUE.
      DO l=1,listId
       IF (flag .AND. diagSt_freq(l) .EQ. diagSt_freq(listId)
     &          .AND. diagSt_phase(l).EQ.diagSt_phase(listId) ) THEN
        DO k=1,MIN(diagSt_nbActv(l),numperlist)
         IF (flag .AND. jSdiag(k,l).GT.0) THEN
          IF (cdiag(ndId).EQ.cdiag(jSdiag(k,l)) ) THEN
C-    diagnostics already set ; use the same slot:
           flag = .FALSE.
           iSdiag(mId,listId) = -ABS(iSdiag(k,l))
           mSdiag(mId,listId) = mSdiag(k,l)
          ENDIF
         ENDIF
        ENDDO
       ENDIF
      ENDDO

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      IF ( flag ) THEN
        IF (ndiagmx+kdiag(ndId).GT.diagSt_size) THEN
         WRITE(msgBuf,'(A,I6,1X,A)')
     &    'SETDIAG: Not enough space for Stats-Diag #',ndId,cdiag(ndId)
         CALL PRINT_MESSAGE(msgBuf, errUnit, SQUEEZE_RIGHT, myThid)
        ELSE
         WRITE(msgBuf,'(A,I3,A,I6,1X,A)') 'SETDIAG: Allocate',
     &    kdiag(ndId), ' Levels for Stats-Diag #', ndId, cdiag(ndId)
         CALL PRINT_MESSAGE(msgBuf, stdUnit, SQUEEZE_RIGHT, myThid)
        ENDIF
        iSdiag(mId,listId) = ndiagmx + 1
        ndiagmx = ndiagmx + kdiag(ndId)
      ELSE
        WRITE(msgBuf,'(A,I6,1X,2A)')
     &    '- NOTE - SETDIAG: Stats-Diag #', ndId, cdiag(ndId),
     &    ' has already been set'
        CALL PRINT_MESSAGE(msgBuf, stdUnit, SQUEEZE_RIGHT, myThid)
      ENDIF

C---  Check for Counter Diagnostic

      mate = 0
      IF ( gcode(5:5).EQ.'C') THEN
        mate = hdiag(ndId)

C--     Seach for the same diag (with same freq) to see if already set
        flag = .TRUE.
        DO l=1,listId
         IF (flag .AND. diagSt_freq(l) .EQ. diagSt_freq(listId)
     &            .AND. diagSt_phase(l).EQ.diagSt_phase(listId) ) THEN
          DO k=1,MIN(diagSt_nbActv(l),numperlist)
           IF (flag .AND. jSdiag(k,l).GT.0) THEN
            IF (cdiag(mate).EQ.cdiag(jSdiag(k,l)) ) THEN
C-    diagnostics already set ; use the same slot:
             flag = .FALSE.
             mSdiag(mId,listId) = ABS(iSdiag(k,l))
            ENDIF
           ENDIF
          ENDDO
         ENDIF
        ENDDO

        IF ( flag ) THEN
          IF (ndiagmx+kdiag(mate).GT.diagSt_size) THEN
           WRITE(msgBuf,'(A,I6,1X,A)')
     &      'SETDIAG: Not enough space for Counter Diagnostic #',
     &      mate, cdiag(mate)
           CALL PRINT_MESSAGE(msgBuf, errUnit, SQUEEZE_RIGHT, myThid)
          ELSE
           WRITE(msgBuf,'(A,I3,A,I6,1X,A)') 'SETDIAG: Allocate',
     &     kdiag(mate), ' Levels for Count.Diag #', mate, cdiag(mate)
           CALL PRINT_MESSAGE(msgBuf, stdUnit, SQUEEZE_RIGHT, myThid)
          ENDIF
          mSdiag(mId,listId) = ndiagmx + 1
          ndiagmx = ndiagmx + kdiag(mate)
        ELSE
          WRITE(msgBuf,'(A,I6,1X,2A)')
     &    '- NOTE - SETDIAG: Counter Diagnostic #', mate, cdiag(mate),
     &    ' has already been set'
          CALL PRINT_MESSAGE(msgBuf, stdUnit, SQUEEZE_RIGHT, myThid)
          mate = -mate
        ENDIF
      ENDIF

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
      RETURN
      END

#include "CPP_EEOPTIONS.h"

CBOP
C     !ROUTINE: EXCH2_GET_UV_BOUNDS

C     !INTERFACE:
      SUBROUTINE EXCH2_GET_UV_BOUNDS(
     I                 fCode, eWdth, updateCorners,
     I                 tgTile, tgNb,
     O                 tIlo1, tIhi1, tJlo1, tJhi1,
     O                 tIlo2, tIhi2, tJlo2, tJhi2,
     O                 tiStride, tjStride,
     O                 e2_oi1, e2_oj1, e2_oi2, e2_oj2,
     I                 myThid )

C     !DESCRIPTION:
C     Return the index range & step of the part of the array (overlap-region)
C     which is going to be updated by the exchange with 1 neighbour.
C     2 components vector field (UV) version.


C     !USES:
      IMPLICIT NONE
C     == Global data ==
#include "SIZE.h"
#include "W2_EXCH2_SIZE.h"
#include "W2_EXCH2_TOPOLOGY.h"

C     !INPUT/OUTPUT PARAMETERS:
C     fCode         :: field code (position on staggered grid)
C     eWdth         :: width of data region to exchange
C     updateCorners :: flag, do update corner halo region if true
C     tgTile        :: target tile
C     tgNb          :: target Neighbour entry
C     tIlo1, tIhi1  :: index range in I that will be filled in 1rst comp. array
C     tJlo1, tJhi1  :: index range in J that will be filled in 1rst comp. array
C     tIlo2, tIhi2  :: index range in I that will be filled in 2nd  comp. array
C     tJlo2, tJhi2  :: index range in J that will be filled in 2nd  comp. array
C     tiStride      :: index step  in I that will be filled in target arrays
C     tjStride      :: index step  in J that will be filled in target arrays
C     e2_oi1        :: index offset in target to source-1 index relation
C     e2_oj1        :: index offset in target to source-1 index relation
C     e2_oi2        :: index offset in target to source-2 index relation
C     e2_oj2        :: index offset in target to source-2 index relation
C     myThid        :: my Thread Id. number

      CHARACTER*2 fCode
      INTEGER     eWdth
      LOGICAL     updateCorners
      INTEGER     tgTile, tgNb
      INTEGER     tIlo1, tIhi1, tJlo1, tJhi1
      INTEGER     tIlo2, tIhi2, tJlo2, tJhi2
      INTEGER     tiStride, tjStride
      INTEGER     e2_oi1, e2_oj1
      INTEGER     e2_oi2, e2_oj2
      INTEGER     myThid
C
C     !LOCAL VARIABLES:
C     soTile        :: source tile
C     soNb          :: source Neighbour entry
      INTEGER  soTile
      INTEGER  soNb
      INTEGER  tIlo,  tIhi,  tJlo,  tJhi
      INTEGER  i, e2_pij(4)

C---  exch2 target to source index relation:
C     is = pij(1)*it + pij(2)*jt + oi
C     js = pij(3)*it + pij(4)*jt + oj

C---  Initialise index range from Topology values:
      tIlo = exch2_iLo(tgNb,tgTile)
      tIhi = exch2_iHi(tgNb,tgTile)
      tJlo = exch2_jLo(tgNb,tgTile)
      tJhi = exch2_jHi(tgNb,tgTile)
      soNb = exch2_opposingSend(tgNb,tgTile)
      soTile = exch2_neighbourId(tgNb,tgTile)
      e2_oi1 = exch2_oi(soNb,soTile)
      e2_oj1 = exch2_oj(soNb,soTile)
      DO i=1,4
        e2_pij(i) = exch2_pij(i,soNb,soTile)
      ENDDO

C---  Expand index range according to exchange-Width "eWdth"
      IF ( tIlo.EQ.tIhi .AND. tIlo.EQ.0 ) THEN
C      Filling a west edge overlap
       tIlo1 = 1-eWdth
       tIhi1 = 0
       tiStride = 1
       IF ( tJlo.LE.tJhi ) THEN
        tjStride=1
       ELSE
        tjStride=-1
       ENDIF
       IF ( updateCorners ) THEN
        tJlo1 = tJlo-tjStride*(eWdth-1)
        tJhi1 = tJhi+tjStride*(eWdth-1)
       ELSE
        tJlo1 = tJlo+tjStride
        tJhi1 = tJhi-tjStride
       ENDIF
      ENDIF
      IF ( tIlo.EQ.tIhi .AND. tIlo.GT.1 ) THEN
C      Filling an east edge overlap
       tIlo1 = tIlo
       tIhi1 = tIhi+eWdth-1
       tiStride = 1
       IF ( tJlo.LE.tJhi ) THEN
        tjStride = 1
       ELSE
        tjStride =-1
       ENDIF
       IF ( updateCorners ) THEN
        tJlo1 = tJlo-tjStride*(eWdth-1)
        tJhi1 = tJhi+tjStride*(eWdth-1)
       ELSE
        tJlo1 = tJlo+tjStride
        tJhi1 = tJhi-tjStride
       ENDIF
      ENDIF
      IF ( tJlo.EQ.tJhi .AND. tJlo.EQ.0 ) THEN
C      Filling a south edge overlap
       tJlo1 = 1-eWdth
       tJhi1 = 0
       tjStride = 1
       IF ( tIlo .LE. tIhi ) THEN
        tiStride = 1
       ELSE
        tiStride =-1
       ENDIF
       IF ( updateCorners ) THEN
        tIlo1 = tIlo-tiStride*(eWdth-1)
        tIhi1 = tIhi+tiStride*(eWdth-1)
       ELSE
        tIlo1 = tIlo+tiStride
        tIhi1 = tIhi-tiStride
       ENDIF
      ENDIF
      IF ( tJlo.EQ.tJhi .AND. tJlo.GT.1 ) THEN
C      Filling a north edge overlap
       tJlo1 = tJlo
       tJhi1 = tJhi+eWdth-1
       tjStride = 1
       IF ( tIlo.LE.tIhi ) THEN
        tiStride = 1
       ELSE
        tiStride =-1
       ENDIF
       IF ( updateCorners ) THEN
        tIlo1 = tIlo-tiStride*(eWdth-1)
        tIhi1 = tIhi+tiStride*(eWdth-1)
       ELSE
        tIlo1 = tIlo+tiStride
        tIhi1 = tIhi-tiStride
       ENDIF
      ENDIF

C---  copy to 2nd set of indices
      tIlo2 = tIlo1
      tIhi2 = tIhi1
      tJlo2 = tJlo1
      tJhi2 = tJhi1
      e2_oi2 = e2_oi1
      e2_oj2 = e2_oj1

      IF ( fCode.EQ.'Cg' ) THEN
C---  UV C-Grid specific code: start here

C---  half grid-cell location with inverse index relation
C     => increase the offset by 1 (relative to tracer cell-centered offset)
C     if pij(1) is -1 then +i in source aligns with -i in target
C     if pij(3) is -1 then +j in source aligns with -i in target
        IF ( e2_pij(1) .EQ. -1 ) THEN
         e2_oi1 = e2_oi1 + 1
        ENDIF
        IF ( e2_pij(3) .EQ. -1 ) THEN
         e2_oj1 = e2_oj1 + 1
        ENDIF
C     if pij(2) is -1 then +i in source aligns with -j in target
C     if pij(4) is -1 then +j in source aligns with -j in target
        IF ( e2_pij(2) .EQ. -1 ) THEN
         e2_oi2 = e2_oi2 + 1
        ENDIF
        IF ( e2_pij(4) .EQ. -1 ) THEN
         e2_oj2 = e2_oj2 + 1
        ENDIF

C---  adjust index lower and upper bounds (fct of updateCorners):
       IF ( updateCorners ) THEN

C--   as a consequence, need also to increase the index lower bound
C     (avoid "out-of bounds" problems ; formerly itlreduce,jtlreduce)
        IF ( e2_pij(1).EQ.-1 .OR. e2_pij(3).EQ.-1 ) tIlo1 = tIlo1+1
        IF ( e2_pij(2).EQ.-1 .OR. e2_pij(4).EQ.-1 ) tJlo2 = tJlo2+1

C---  Avoid updating (some) tile-corner halo region if across faces
c       IF ( tIlo.EQ.tIhi .AND. tIlo.EQ.0 ) THEN
c         IF ( exch2_isSedge(tgTile).EQ.1 ) THEN
C-      West edge is touching the face S edge
c           tJlo1 = tJlo+1
c           tJlo2 = tJlo+1
c         ENDIF
c         IF ( exch2_isNedge(tgTile).EQ.1 ) THEN
C-      West edge is touching the face N edge
c           tJhi1 = tJhi-1
c           tJhi2 = tJhi
c         ENDIF
c       ENDIF
        IF ( tIlo.EQ.tIhi .AND. tIlo.GT.1 ) THEN
          IF ( exch2_isSedge(tgTile).EQ.1 ) THEN
C-      East edge is touching the face S edge
            tJlo1 = tJlo+1
            tJlo2 = tJlo+1
          ENDIF
          IF ( exch2_isNedge(tgTile).EQ.1 ) THEN
C-      East edge is touching the face N edge
            tJhi1 = tJhi-1
            tJhi2 = tJhi
          ENDIF
        ENDIF
c       IF ( tJlo.EQ.tJhi .AND. tJlo.EQ.0 ) THEN
c         IF ( exch2_isWedge(tgTile).EQ.1 ) THEN
C-      South edge is touching the face W edge
c           tIlo1 = tIlo+1
c           tIlo2 = tIlo+1
c         ENDIF
c         IF ( exch2_isEedge(tgTile).EQ.1 ) THEN
C-      South Edge is touching the face E edge
c           tIhi1 = tIhi
c           tIhi2 = tIhi-1
c         ENDIF
c       ENDIF
        IF ( tJlo.EQ.tJhi .AND. tJlo.GT.1 ) THEN
          IF ( exch2_isWedge(tgTile).EQ.1 ) THEN
C-      North edge is touching the face W edge
            tIlo1 = tIlo+1
            tIlo2 = tIlo+1
          ENDIF
          IF ( exch2_isEedge(tgTile).EQ.1 ) THEN
C-      North Edge is touching the face E edge
            tIhi1 = tIhi
            tIhi2 = tIhi-1
          ENDIF
        ENDIF

       ELSE
C---  adjust index lower and upper bounds (updateCorners = F case):
        IF ( e2_pij(1).EQ.-1 .OR. e2_pij(3).EQ.-1 ) THEN
          tIlo1 = tIlo1+1
          tIhi1 = tIhi1+1
        ENDIF
        IF ( e2_pij(2).EQ.-1 .OR. e2_pij(4).EQ.-1 ) THEN
          tJlo2 = tJlo2+1
          tJhi2 = tJhi2+1
        ENDIF
       ENDIF

C---  UV C-Grid specific code: end

      ELSEIF ( fCode.NE.'Ag' ) THEN
        STOP 'ABNORMAL END: S/R EXCH2_GET_UV_BOUNDS (wrong fCode)'
      ENDIF

      RETURN
      END

#include "PACKAGES_CONFIG.h"
#include "CPP_OPTIONS.h"

#undef  MULTIPLE_RECORD_STATE_FILES

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: WRITE_STATE

C     !INTERFACE:
      SUBROUTINE WRITE_STATE ( myTime, myIter, myThid )

C     !DESCRIPTION:
C     This is the controlling routine for writing mid-level IO.  It
C     includes code for diagnosing W and RHO for output.

C     The CPP flag (MULTIPLE_RECORD_STATE_FILES) is #define/#undefed
C     here since it is specific to this routine and very user-preference
C     specific. If #undefed (default) the state files are written as in
C     all versions prior to checkpoint32, where a file is created per
C     variable, per time and per tile. This *has* to be the default
C     because most users use this mode and all utilities and scripts
C     (diagnostic) assume this form.  It is also robust, as explained
C     below.
C
C     If #defined, subsequent snap-shots are written as records in the
C     same file (no iteration number in filenames). The main advantage
C     is fewer files.  The disadvantages are that:
C       (1) it breaks a lot of diagnostic scripts,
C       (2) for large or long problems this creates huge files,
C       (3) its an unexpected, unsolicited change in behaviour which
C           came as a surprise (in c32) and is an inconvenience to
C           several users
C       (4) it can not accomodate changing the frequency of output
C           after a pickup (this is trivial in previous method but
C           needs new code and parameters in this new method)
C
C      Known Bugs include:
C       (1) if the length of integration is not exactly an integer
C           times the output frequency then the last record written
C           (at end of integration) overwrites a previously written
C           record corresponding to an earier time. *BE WARNED*

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "DYNVARS.h"
#ifdef ALLOW_NONHYDROSTATIC
#include "NH_VARS.h"
#endif
#ifdef ALLOW_MNC
#include "MNC_PARAMS.h"
#endif

      LOGICAL  DIFFERENT_MULTIPLE
      EXTERNAL DIFFERENT_MULTIPLE
      INTEGER  IO_ERRCOUNT
      EXTERNAL IO_ERRCOUNT

C     !INPUT/OUTPUT PARAMETERS:
C     myThid - Thread number for this instance of the routine.
C     myIter - Iteration number
C     myTime - Current time of simulation ( s )
      _RL     myTime
      INTEGER myThid
      INTEGER myIter

C     !LOCAL VARIABLES:
      CHARACTER*(MAX_LEN_MBUF) suff
      INTEGER iRec
#ifdef ALLOW_MNC
      CHARACTER*(1) pf
#endif
CEOP

      IF (
     &     DIFFERENT_MULTIPLE(dumpFreq,myTime,deltaTClock)
     &  .OR. dumpInitAndLast.AND.( myTime.EQ.endTime .OR.
     &                             myTime.EQ.startTime  )
     &   ) THEN
        IF ( dumpFreq .EQ. 0.0 ) THEN
          iRec = 1
        ELSE
          iRec = 1 + NINT( (myTime-startTime) / dumpFreq )
        ENDIF

C       Going to really do some IO. Make everyone except master thread wait.
C       this is done within IO routines => no longer needed
c       _BARRIER

C       Write model fields
        IF (snapshot_mdsio) THEN

#ifdef MULTIPLE_RECORD_STATE_FILES

C         Write each snap-shot as a new record in one file per variable
C         - creates relatively few files but these files can become huge
          CALL WRITE_REC_XYZ_RL( 'U',  uVel,iRec,myIter,myThid)
          CALL WRITE_REC_XYZ_RL( 'V',  vVel,iRec,myIter,myThid)
          CALL WRITE_REC_XYZ_RL( 'T', theta,iRec,myIter,myThid)
          CALL WRITE_REC_XYZ_RL( 'S',  salt,iRec,myIter,myThid)
          CALL WRITE_REC_XY_RL('Eta',etaN,iRec,myIter,myThid)
          CALL WRITE_REC_XYZ_RL( 'W',wVel,iRec,myIter,myThid)
#ifdef ALLOW_NONHYDROSTATIC
          IF (nonHydroStatic) THEN
            CALL WRITE_REC_XYZ_RL( 'PNH',phi_nh,iRec,myIter,myThid)
          ENDIF
#endif /* ALLOW_NONHYDROSTATIC */
#ifdef NONLIN_FRSURF
c         CALL WRITE_REC_XYZ_RS('hFacC.',hFacC,iRec,myIter,myThid)
c         CALL WRITE_REC_XYZ_RS('hFacW.',hFacW,iRec,myIter,myThid)
c         CALL WRITE_REC_XYZ_RS('hFacS.',hFacS,iRec,myIter,myThid)
#endif /* NONLIN_FRSURF */

#else /* MULTIPLE_RECORD_STATE_FILES */

C         Write each snap-shot as a new file (original and default
C         method) -- creates many files but for large configurations is
C         easier to transfer analyse a particular snap-shots
          IF ( rwSuffixType.EQ.0 ) THEN
            WRITE(suff,'(I10.10)') myIter
          ELSE
            CALL RW_GET_SUFFIX( suff, myTime, myIter, myThid )
          ENDIF

#ifdef ALLOW_OPENAD
# ifndef ALLOW_STREAMICE
          CALL WRITE_FLD_XYZ_RL( 'U.',suff,uVel%v,myIter,myThid)
          CALL WRITE_FLD_XYZ_RL( 'V.',suff,vVel%v,myIter,myThid)
          CALL WRITE_FLD_XYZ_RL( 'T.',suff,theta%v,myIter,myThid)
          CALL WRITE_FLD_XYZ_RL( 'S.',suff,salt%v,myIter,myThid)
          CALL WRITE_FLD_XY_RL('Eta.',suff,etaN%v,myIter,myThid)
          CALL WRITE_FLD_XYZ_RL( 'W.',suff,wVel%v,myIter,myThid)
          IF ( storePhiHyd4Phys .OR. myIter.NE.nIter0 ) THEN
            CALL WRITE_FLD_XYZ_RL('PH.',suff,totPhiHyd%v,myIter,myThid)
          ENDIF
# endif
#else
          CALL WRITE_FLD_XYZ_RL( 'U.',suff,uVel,myIter,myThid)
          CALL WRITE_FLD_XYZ_RL( 'V.',suff,vVel,myIter,myThid)
          CALL WRITE_FLD_XYZ_RL( 'T.',suff,theta,myIter,myThid)
          CALL WRITE_FLD_XYZ_RL( 'S.',suff,salt,myIter,myThid)
          CALL WRITE_FLD_XY_RL('Eta.',suff,etaN,myIter,myThid)
          CALL WRITE_FLD_XYZ_RL( 'W.',suff,wVel,myIter,myThid)
          IF ( storePhiHyd4Phys .OR. myIter.NE.nIter0 ) THEN
            CALL WRITE_FLD_XYZ_RL('PH.',suff,totPhiHyd,myIter,myThid)
          ENDIF
#endif

          IF ( fluidIsWater .AND. (myIter.NE.nIter0) ) THEN
            CALL WRITE_FLD_XY_RL('PHL.',suff,phiHydLow,myIter,myThid)
          ENDIF
#ifdef ALLOW_NONHYDROSTATIC
          IF (nonHydroStatic) THEN
            CALL WRITE_FLD_XYZ_RL( 'PNH.',suff,phi_nh,myIter,myThid )
          ENDIF
          IF ( selectNHfreeSurf.GE.1 ) THEN
            CALL WRITE_FLD_XY_RL( 'dPnh.',suff,dPhiNH,myIter,myThid )
          ENDIF
#endif /* ALLOW_NONHYDROSTATIC */
#ifdef NONLIN_FRSURF
c         CALL WRITE_FLD_XYZ_RS('hFacC.',suff,hFacC,myIter,myThid)
c         CALL WRITE_FLD_XYZ_RS('hFacW.',suff,hFacW,myIter,myThid)
c         CALL WRITE_FLD_XYZ_RS('hFacS.',suff,hFacS,myIter,myThid)
#endif /* NONLIN_FRSURF */

#endif /* MULTIPLE_RECORD_STATE_FILES */

        ENDIF

#ifdef ALLOW_MNC
        IF (useMNC .AND. snapshot_mnc) THEN

          IF ( writeBinaryPrec .EQ. precFloat64 ) THEN
            pf(1:1) = 'D'
          ELSE
            pf(1:1) = 'R'
          ENDIF

C         Write dynvars using the MNC package
          CALL MNC_CW_SET_UDIM('state', -1, myThid)
          CALL MNC_CW_RL_W_S('D','state',0,0,'T', myTime, myThid)
          CALL MNC_CW_SET_UDIM('state', 0, myThid)
          CALL MNC_CW_I_W_S('I','state',0,0,'iter', myIter, myThid)
C         CALL MNC_CW_RL_W_S('D','state',0,0,'model_time',myTime,myThid)
          CALL MNC_CW_RL_W(pf,'state',0,0,'U', uVel, myThid)
          CALL MNC_CW_RL_W(pf,'state',0,0,'V', vVel, myThid)
          CALL MNC_CW_RL_W(pf,'state',0,0,'Temp', theta, myThid)
          CALL MNC_CW_RL_W(pf,'state',0,0,'S', salt, myThid)
          CALL MNC_CW_RL_W(pf,'state',0,0,'Eta', etaN, myThid)
          CALL MNC_CW_RL_W(pf,'state',0,0,'W', wVel, myThid)
          IF ( storePhiHyd4Phys .OR. myIter.NE.nIter0 ) THEN
            CALL MNC_CW_SET_UDIM('phiHyd', -1, myThid)
            CALL MNC_CW_RL_W_S('D','phiHyd',0,0,'T',myTime,myThid)
            CALL MNC_CW_SET_UDIM('phiHyd', 0, myThid)
            CALL MNC_CW_I_W_S('I','phiHyd',0,0,'iter',myIter,myThid)
            CALL MNC_CW_RL_W(pf,'phiHyd',0,0,'phiHyd',
     &           totPhiHyd, myThid)
          ENDIF
          IF ( fluidIsWater .AND. (myIter .NE. nIter0) ) THEN
            CALL MNC_CW_SET_UDIM('phiHydLow', -1, myThid)
            CALL MNC_CW_RL_W_S('D','phiHydLow',0,0,'T', myTime, myThid)
            CALL MNC_CW_SET_UDIM('phiHydLow', 0, myThid)
            CALL MNC_CW_I_W_S('I','phiHydLow',0,0,'iter',myIter,myThid)
            CALL MNC_CW_RL_W(pf,'phiHydLow',0,0,'phiHydLow',
     &           phiHydLow, myThid)
          ENDIF
#ifdef ALLOW_NONHYDROSTATIC
          IF (nonHydroStatic) THEN
            CALL MNC_CW_RL_W(pf,'state',0,0,'phi_nh',phi_nh,myThid)
          ENDIF
#endif /* ALLOW_NONHYDROSTATIC */
        ENDIF
#endif /*  ALLOW_MNC  */

      ENDIF

      RETURN
      END

#include "PACKAGES_CONFIG.h"
#include "CPP_EEOPTIONS.h"

C--  File exch_tap_d.F: Tapenade Tangent Linear EXCH1 routines
C--   Contents
C--   o  EXCH1_UV_RL_CUBE_D
C--   o  EXCH1_UV_RS_CUBE_D
C--   o  EXCH1_RL_CUBE_D
C--   o  EXCH1_RS_CUBE_D
C--   o  EXCH1_RL_D
C--   o  EXCH1_RS_D

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      SUBROUTINE EXCH1_UV_RL_CUBE_D(
     U                 Uarray, Uarrayd, Varray, Varrayd,
     I                 withSigns,
     I                 myOLw, myOLe, myOLs, myOLn, myNz,
     I                 exchWidthX, exchWidthY,
     I                 cornerMode, myThid )
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"

      INTEGER myOLw, myOLe, myOLs, myOLn, myNz
      _RL     Uarray( 1-myOLw:sNx+myOLe,
     &                1-myOLs:sNy+myOLn,
     &                myNz, nSx, nSy )
      _RL     Uarrayd( 1-myOLw:sNx+myOLe,
     &                1-myOLs:sNy+myOLn,
     &                myNz, nSx, nSy )
      _RL     Varray( 1-myOLw:sNx+myOLe,
     &                1-myOLs:sNy+myOLn,
     &                myNz, nSx, nSy )
      _RL     Varrayd( 1-myOLw:sNx+myOLe,
     &                1-myOLs:sNy+myOLn,
     &                myNz, nSx, nSy )
      LOGICAL withSigns
      INTEGER exchWidthX
      INTEGER exchWidthY
      INTEGER cornerMode
      INTEGER myThid

      CALL EXCH1_UV_RL_CUBE(
     &                 Uarray, Varray,
     &                 withSigns,
     &                 myOLw, myOLe, myOLs, myOLn, myNz,
     &                 exchWidthX, exchWidthY,
     &                 cornerMode, myThid )

      CALL EXCH1_UV_RL_CUBE(
     &                 Uarrayd, Varrayd,
     &                 withSigns,
     &                 myOLw, myOLe, myOLs, myOLn, myNz,
     &                 exchWidthX, exchWidthY,
     &                 cornerMode, myThid )

      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      SUBROUTINE EXCH1_UV_RS_CUBE_D(
     U                 Uarray, Uarrayd, Varray, Varrayd,
     I                 withSigns,
     I                 myOLw, myOLe, myOLs, myOLn, myNz,
     I                 exchWidthX, exchWidthY,
     I                 cornerMode, myThid )
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"

      INTEGER myOLw, myOLe, myOLs, myOLn, myNz
      _RS     Uarray( 1-myOLw:sNx+myOLe,
     &                1-myOLs:sNy+myOLn,
     &                myNz, nSx, nSy )
      _RS     Uarrayd( 1-myOLw:sNx+myOLe,
     &                1-myOLs:sNy+myOLn,
     &                myNz, nSx, nSy )
      _RS     Varray( 1-myOLw:sNx+myOLe,
     &                1-myOLs:sNy+myOLn,
     &                myNz, nSx, nSy )
      _RS     Varrayd( 1-myOLw:sNx+myOLe,
     &                1-myOLs:sNy+myOLn,
     &                myNz, nSx, nSy )
      LOGICAL withSigns
      INTEGER exchWidthX
      INTEGER exchWidthY
      INTEGER cornerMode
      INTEGER myThid

      CALL EXCH1_UV_RS_CUBE(
     &                 Uarray, Varray,
     &                 withSigns,
     &                 myOLw, myOLe, myOLs, myOLn, myNz,
     &                 exchWidthX, exchWidthY,
     &                 cornerMode, myThid )

      CALL EXCH1_UV_RS_CUBE(
     &                 Uarrayd, Varrayd,
     &                 withSigns,
     &                 myOLw, myOLe, myOLs, myOLn, myNz,
     &                 exchWidthX, exchWidthY,
     &                 cornerMode, myThid )

      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      SUBROUTINE EXCH1_RL_CUBE_D(
     U                 array, arrayd,
     I                 withSigns,
     I                 myOLw, myOLe, myOLs, myOLn, myNz,
     I                 exchWidthX, exchWidthY,
     I                 cornerMode, myThid )
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"

      INTEGER myOLw, myOLe, myOLs, myOLn, myNz
      _RL     array( 1-myOLw:sNx+myOLe,
     &               1-myOLs:sNy+myOLn,
     &               myNz, nSx, nSy )
      _RL     arrayd( 1-myOLw:sNx+myOLe,
     &               1-myOLs:sNy+myOLn,
     &               myNz, nSx, nSy )
      LOGICAL withSigns
      INTEGER exchWidthX
      INTEGER exchWidthY
      INTEGER cornerMode
      INTEGER myThid

      CALL EXCH1_RL_CUBE(arrayd, withSigns,myOLw, myOLe, myOLs, myOLn,
     &     myNz, exchWidthX , exchWidthY, cornerMode, myThid )

      CALL EXCH1_RL_CUBE(array, withSigns,myOLw, myOLe, myOLs, myOLn,
     &     myNz, exchWidthX , exchWidthY, cornerMode, myThid )

      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      SUBROUTINE EXCH1_RS_CUBE_D(
     U                 array, arrayd,
     I                 withSigns,
     I                 myOLw, myOLe, myOLs, myOLn, myNz,
     I                 exchWidthX, exchWidthY,
     I                 cornerMode, myThid )
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"

      INTEGER myOLw, myOLe, myOLs, myOLn, myNz
      _RS     array( 1-myOLw:sNx+myOLe,
     &               1-myOLs:sNy+myOLn,
     &               myNz, nSx, nSy )
      _RS     arrayd( 1-myOLw:sNx+myOLe,
     &               1-myOLs:sNy+myOLn,
     &               myNz, nSx, nSy )
      LOGICAL withSigns
      INTEGER exchWidthX
      INTEGER exchWidthY
      INTEGER cornerMode
      INTEGER myThid

      CALL EXCH1_RS_CUBE(arrayd, withSigns,myOLw, myOLe, myOLs, myOLn,
     &     myNz, exchWidthX , exchWidthY, cornerMode, myThid )

      CALL EXCH1_RS_CUBE(array, withSigns,myOLw, myOLe, myOLs, myOLn,
     &     myNz, exchWidthX , exchWidthY, cornerMode, myThid )

      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      SUBROUTINE EXCH1_RL_D(
     U                 array, arrayd,
     I                 myOLw, myOLe, myOLs, myOLn, myNz,
     I                 exchWidthX, exchWidthY,
     I                 cornerMode, myThid )
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "EXCH.h"

      INTEGER myOLw, myOLe, myOLs, myOLn, myNz
      _RL     array( 1-myOLw:sNx+myOLe,
     &               1-myOLs:sNy+myOLn,
     &               myNz, nSx, nSy )
      _RL     arrayd( 1-myOLw:sNx+myOLe,
     &               1-myOLs:sNy+myOLn,
     &               myNz, nSx, nSy )
      INTEGER exchWidthX
      INTEGER exchWidthY
      INTEGER cornerMode
      INTEGER myThid

      CALL EXCH1_RL(arrayd,myOLw, myOLe, myOLs, myOLn,
     &     myNz, exchWidthX , exchWidthY, cornerMode, myThid )
      CALL EXCH1_RL(array,myOLw, myOLe, myOLs, myOLn,
     &     myNz, exchWidthX , exchWidthY, cornerMode, myThid )
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      SUBROUTINE EXCH1_RS_D(
     U                 array, arrayd,
     I                 myOLw, myOLe, myOLs, myOLn, myNz,
     I                 exchWidthX, exchWidthY,
     I                 cornerMode, myThid )
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "EXCH.h"

      INTEGER myOLw, myOLe, myOLs, myOLn, myNz
      _RS     array( 1-myOLw:sNx+myOLe,
     &               1-myOLs:sNy+myOLn,
     &               myNz, nSx, nSy )
      _RS     arrayd( 1-myOLw:sNx+myOLe,
     &               1-myOLs:sNy+myOLn,
     &               myNz, nSx, nSy )
      INTEGER exchWidthX
      INTEGER exchWidthY
      INTEGER cornerMode
      INTEGER myThid

      CALL EXCH1_RS(arrayd, myOLw, myOLe, myOLs,
     &     myOLn, myNz, exchWidthX, exchWidthY,
     &     cornerMode, myThid)

      CALL EXCH1_RS(array, myOLw, myOLe, myOLs,
     &     myOLn, myNz, exchWidthX, exchWidthY,
     &     cornerMode, myThid)

      END

#include "CPP_EEOPTIONS.h"
#include "PACKAGES_CONFIG.h"

CBOP
C     !ROUTINE: EEBOOT

C     !INTERFACE:
      SUBROUTINE EEBOOT( myComm )

C     !DESCRIPTION:
C     *==========================================================*
C     | SUBROUTINE EEBOOT
C     | o Set up execution "environment", particularly perform
C     |   steps to initialise parallel processing.
C     *==========================================================*
C     | Note: This routine can also be compiled with CPP
C     | directives set so that no multi-processing is initialised
C     | This is OK and works fine.
C     *==========================================================*

C     !CALLING SEQUENCE:
C     eeboot()
C       |
C       |-- eeboot_minimal() :: Minimal startup. Just enough to
C       |                       allow basic I/O.
C       |
C       |-- eeintro_msg()    :: Write startup greeting.
C       |
C       |-- eeset_parms()    :: Set WRAPPER parameters
C       |
C       |-- eewrite_eeenv()  :: Print WRAPPER parameter settings
C       |
C       |-- ini_procs()      :: Associate processes with grid regions.
C       |
C       |-- ini_threading_environment() :: Associate threads with grid regions.
C       |
C       |-- cpl_register()   :: Pass attributes to the coupler
C       |
C       |-- w2_eeboot()      :: Initialise WRAPPER2 execution environment

C     !USES:
      IMPLICIT NONE
C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "EESUPPORT.h"

C     !ROUTINE ARGUMENTS
C     == Routine arguments ==
C     myComm     :: Communicator that is passed down from
C                   upper level driver (if there is one).
      INTEGER myComm

C     !LOCAL VARIABLES:
C     == Local variables ==
C     I :: Loop counter
      INTEGER I
      LOGICAL doReport
CEOP

C--   Set error reporting flags and I/O streams
C     fatalError is a flag used to indicate that the program
C                ended abnormally.
C     errorMessageUnit is the Fortran unit number used for
C                      writing error messages.
C     standardMessageUnit is the Fortran unit number used for
C                          writing textual, informational output.
C     eeBootError is a flag used to indicate an error in the
C                "execution environment" startup pahse as opposed
C                to the simulation pahse of the execution.
C     eeEndError is used to indicate an "execution environment" shutdown
C                error.
C     thError flag used to allow a thread to report an error.
C             This is only really used during the startup process,
C             although it could be used elsewhere.
C     allMyEdgesAreSharedMemory flag which says for a particular
C                               set of blocks the only form of communication
C                               it does is using shared memory.
C     threadIsRunning used during startup to enable check that all
C                     the threads are running.
      fatalError          = .FALSE.
      eeBootError         = .FALSE.
      eeEndError          = .FALSE.
      DO I=1, MAX_NO_THREADS
       thError(I)                   = .FALSE.
       allMyEdgesAreSharedMemory(I) = .TRUE.
       threadIsRunning(I)           = .FALSE.
       threadIsComplete(I)          = .FALSE.
       ioErrorCount(I)              = 0
      ENDDO
      standardMessageUnit = 6
#ifdef HACK_FOR_GMAO_CPL
      scrUnit1            = 31
      scrUnit2            = 32
      eeDataUnit          = 33
      modelDataUnit       = 34
      errorMessageUnit    = 35
      standardMessageUnit = 36
#else
      scrUnit1            = 11
      scrUnit2            = 12
      eeDataUnit          = 13
      modelDataUnit       = 14
      errorMessageUnit    = 15
cph   errorMessageUnit = 0 is not allowed on some platforms, e.g. SP3
#endif

C--   Start minimal environment so that we can do I/O to report errors.
C     Notes
C     =====
C     o Here we start MPI and setup the I/O environment
C       that is needed for error reporting.
C     o Under MPI I/O support is very variable until
C       MPI is started. This makes is hard to trap the case
C       where mpirun is used to start a non-MPI run or
C       we try to start MPI when mpirun was not used.
C       after it is started.
C jmc: test:
C     If necessary ( COMPONENT_MODULE defined ) add a 1rst preliminary
C     call to eeset_params (in EEBOOT_MINIMAL) to set useCoupler (needed
C     very early, and the stardard call eeset_params below comes too late)
C jmc: This needs to be sorted-out in a cleaner way.
      CALL EEBOOT_MINIMAL( myComm )
      IF ( eeBootError ) GOTO 999

C--   Now we can write a startup message
      CALL EEINTRO_MSG

C--   Initialise parameters associated with execution environment.
      doReport = .TRUE.
      CALL EESET_PARMS ( myProcId, doReport )
      IF ( eeBootError ) GOTO 999

C--   Write summary of execution environment configuration for this run
      CALL EEWRITE_EEENV

C--   Now do the rest of the multi-process startup.
C     o Here we map processes to the model grid.
C     o Print tables of process-grid mappings.
C     o Do other miscellaneous multi-processing set up steps. For
C       example under MPI we create datatypes for communication
C       of array edges.
      CALL INI_PROCS
      IF ( eeBootError ) GOTO 999

C--   Initialise variables to support "nThreads" of computation.
C     o Note the program is still running with a single thread of
C       execution at this stage.
      CALL INI_THREADING_ENVIRONMENT
      IF ( eeBootError ) GOTO 999

#ifdef ALLOW_EXCH2
C--   Initialise WRAPPER2 execution environment
      CALL W2_EEBOOT
#endif /* ALLOW_EXCH2 */

C--   Pass attributes to the coupler
#ifdef COMPONENT_MODULE
      IF ( useCoupler ) CALL CPL_REGISTER
#endif

  999 CONTINUE
      RETURN
      END

#include "LAYERS_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      SUBROUTINE LAYERS_MNC_INIT( myThid )

C     Initialize MNC lookup tables for LAYERS.

      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "LAYERS_SIZE.h"
#include "LAYERS.h"

C     !INPUT PARAMETERS:
      INTEGER myThid
CEOP

#ifdef ALLOW_LAYERS
#ifdef ALLOW_MNC

      IF (useMNC) THEN

C--     Need to figure out how to create new grids. We need
C           'U_xy_Hn__G__t'
C           'V_xy_Hn__G__t'

        CALL MNC_CW_ADD_VNAME('UFlux','U_xy_Hn__G__t', 4,5,myThid)
        CALL MNC_CW_ADD_VATTR_TEXT('UFlux','units','m^2/s', myThid)
        CALL MNC_CW_ADD_VATTR_TEXT('UFlux','description',
     &       'Eastward Velocity Integrated Over Isopycnal Layer',
     &       myThid)

        CALL MNC_CW_ADD_VNAME('VFlux','V_xy_Hn__G__t', 4,5,myThid)
        CALL MNC_CW_ADD_VATTR_TEXT('VFlux','units','m^2/s', myThid)
        CALL MNC_CW_ADD_VATTR_TEXT('VFlux','description',
     &       'Northward Velocity Integrated Over Isopycnal Layer',
     &       myThid)


      ENDIF

#endif /* ALLOW_MNC */
#endif /* ALLOW_GMREDI */

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#include "OBCS_OPTIONS.h"
#ifdef ALLOW_CTRL
# include "CTRL_OPTIONS.h"
#endif

CBOP
C !ROUTINE: OBCS_COST_OB_N

C !INTERFACE: ==========================================================
      SUBROUTINE OBCS_COST_OB_N(
     I                           startrec, endrec,
     I                           myTime, myIter, myThid )

C !DESCRIPTION:
C     - Calculatesd cost function contribution (Tikhonov regulariation)
C       of northern open-boundary
C     - modified from pkg/ecco/cost_obcsn.F

C !USES: ===============================================================
      IMPLICIT NONE
C     == Global variables ==
#include "EEPARAMS.h"
#include "SIZE.h"
#include "PARAMS.h"
#include "GRID.h"
#ifdef ALLOW_CTRL
# ifndef ALLOW_AUTODIFF
#  include "CTRL_SIZE.h"
#  include "CTRL.h"
# endif
# include "OPTIMCYCLE.h"
# include "CTRL_OBCS.h"
#endif

C !INPUT PARAMETERS: ===================================================
      INTEGER startrec, endrec
      _RL     myTime
      INTEGER myIter
      INTEGER myThid

#if defined ALLOW_CTRL && defined ALLOW_OBCSN_CONTROL && defined ALLOW_COST
C !FUNCTIONS: ==========================================================
      INTEGER  ILNBLNK
      EXTERNAL ILNBLNK

C !LOCAL VARIABLES: ====================================================
      INTEGER bi,bj
      INTEGER i,k
      INTEGER imin,imax
      INTEGER irec
      INTEGER iobcs
      INTEGER nrec
      INTEGER ilfld
      INTEGER igg
      _RL fctile
      _RL fcthread
#ifdef ALLOW_AUTODIFF
      _RL dummy
#endif
      _RL gg
      _RL tmpx
      _RL tmpfield (1-OLx:sNx+OLx,Nr,nSx,nSy)
      _RL maskxz   (1-OLx:sNx+OLx,Nr,nSx,nSy)
      CHARACTER*(MAX_LEN_FNAM) fnamefld
      LOGICAL doglobalread
      LOGICAL ladinit
      CHARACTER*(MAX_LEN_MBUF) msgBuf
CEOP

      imin = 1
      imax = sNx

c--   Read tiled data.
      doglobalread = .false.
      ladinit      = .false.

c     Number of records to be used.
      nrec = endrec-startrec+1

c     jp1 = 0
      fcthread = 0. _d 0

      IF ( debugLevel.GE.debLevC ) THEN
       _BEGIN_MASTER( myThid )
       WRITE(msgBuf,'(a)') ' '
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                     SQUEEZE_RIGHT, myThid )
       WRITE(msgBuf,'(a)') ' '
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                     SQUEEZE_RIGHT, myThid )
       WRITE(msgBuf,'(a,i9.8)')
     &      ' OBCS_COST_OB_N: number of records to process: ',nrec
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                     SQUEEZE_RIGHT, myThid )
       WRITE(msgBuf,'(a)') ' '
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                     SQUEEZE_RIGHT, myThid )
       _END_MASTER( myThid )
      ENDIF

      IF (optimcycle .GE. 0) THEN
       ilfld=ILNBLNK( xx_obcsN_file )
       WRITE(fnamefld,'(2a,i10.10)')
     &      xx_obcsN_file(1:ilfld), '.', optimcycle
      ENDIF

c--   Loop over records.
      DO irec = 1,nrec

#ifdef ALLOW_AUTODIFF
       CALL ACTIVE_READ_XZ( fnamefld, tmpfield, irec,
     &                      doglobalread, ladinit, optimcycle,
     &                      myThid, xx_obcsN_dummy )
#else
       CALL READ_REC_XZ_RL( fnamefld, ctrlprec, Nr,
     &                      tmpfield, irec, 1, myThid )
#endif

cgg    Need to solve for iobcs would have been.
       gg    = (irec-1)/nobcs
       igg   = int(gg)
       iobcs = irec - igg*nobcs

#ifdef ALLOW_AUTODIFF
       CALL ACTIVE_READ_XZ( 'maskobcsn', maskxz, iobcs,
     &                      doglobalread, ladinit, 0,
     &                      myThid, dummy )
#else
       CALL READ_REC_XZ_RL( 'maskobcsn', ctrlprec, Nr,
     &                      maskxz, iobcs, 1, myThid )
#endif

c--   Loop over this thread s tiles.
       DO bj = myByLo(myThid), myByHi(myThid)
        DO bi = myBxLo(myThid), myBxHi(myThid)

c--   Determine the weights to be used.
         fctile = 0. _d 0

         DO k = 1, Nr
          DO i = imin,imax
c          j = OB_Jn(I,bi,bj)
cgg        IF (maskS(i,j+jp1,k,bi,bj) .NE. 0.) THEN
           tmpx = tmpfield(i,k,bi,bj)
CMM        fctile = fctile + wobcsN2(i,k,bi,bj,iobcs)
           fctile = fctile + wobcsN(k,iobcs)
     &                       *tmpx*tmpx*maskxz(i,k,bi,bj)
cgg        ENDIF
CMM        IF (wobcsN2(i,k,bi,bj,iobcs)*maskxz(i,k,bi,bj).NE.0.)
           IF (wobcsN(k,iobcs)*maskxz(i,k,bi,bj).NE.0.)
     &          num_obcsN(bi,bj) = num_obcsN(bi,bj) + 1. _d 0
cgg        PRINT*,'S fctile',fctile
          ENDDO
         ENDDO

         objf_obcsN(bi,bj) = objf_obcsN(bi,bj) + fctile
         fcthread          = fcthread + fctile
        ENDDO
       ENDDO

       IF ( debugLevel.GE.debLevC ) THEN
c--     Print cost function for all tiles.
        _GLOBAL_SUM_RL( fcthread , myThid )
        WRITE(msgBuf,'(a)') ' '
        CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
        WRITE(msgBuf,'(a,i8.8)')
     &    ' OBCS_COST_OB_N: irec = ',irec
        CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
        WRITE(msgBuf,'(a,a,d22.15)')
     &    ' global cost function value',
     &    ' (obcsN) = ',fcthread
        CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
        WRITE(msgBuf,'(a)') ' '
        CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
       ENDIF

      ENDDO
c--   End of loop over records.

#endif /* ALLOW_CTRL etc */

      RETURN
      END

#include "FIZHI_OPTIONS.h"
       subroutine step_fizhi_corr (myTime, myIter, myThid, dt)
c----------------------------------------------------------------------
c  Subroutine step_fizhi_corr - 'Wrapper' routine to advance
c        the physics state and make the new value.
c        At this point, increment with the "correction term"
c        which includes the dynamics tendency and the integral
c        constraint to enforce agreement with the dynamics state
c        Also: Set up "bi, bj loop" and some timers and clocks here.
c
c Call:phys2dyn (4) (interpolate physics state to dynamics grid
c                           for use in the correction terms)
c      AtoC         (convert physics state on dynamics grid to C-Grid)
c      CtoA         (convert correction term on dynamics grid to A-Grid)
c      dyn2phys (4) (interpolate A-Grid correction term to physics grid)
c      step_physics (advance physics state by correction term)
c-----------------------------------------------------------------------
       implicit none
#include "SIZE.h"
#include "GRID.h"
#include "fizhi_SIZE.h"
#include "fizhi_land_SIZE.h"
#include "DYNVARS.h"
#include "fizhi_coms.h"
#include "gridalt_mapping.h"
#include "EEPARAMS.h"
#include "SURFACE.h"
#ifdef ALLOW_DIAGNOSTICS
#include "fizhi_SHP.h"
#endif

       integer myIter, myThid
       _RL myTime
#ifdef ALLOW_DIAGNOSTICS
      logical  diagnostics_is_on
      external diagnostics_is_on
#endif

c pe on dynamics and physics grid refers to bottom edge
       _RL pephy(1-OLx:sNx+Olx,1-Oly:sNy+Oly,Nrphys+1,nSx,nSy)
       _RL pedyn(1-Olx:sNx+Olx,1-Oly:sNy+Oly,Nr+1,nSx,nSy)
       _RL windphy(1-Olx:sNx+Olx,1-Oly:sNy+Oly,Nrphys,nSx,nSy)
       _RL udyntemp(1-Olx:sNx+Olx,1-Oly:sNy+Oly,Nr,nSx,nSy)
       _RL vdyntemp(1-Olx:sNx+Olx,1-Oly:sNy+Oly,Nr,nSx,nSy)
       _RL thdyntemp(1-Olx:sNx+Olx,1-Oly:sNy+Oly,Nr,nSx,nSy)
       _RL sdyntemp(1-Olx:sNx+Olx,1-Oly:sNy+Oly,Nr,nSx,nSy)
       _RL uphytemp(1-Olx:sNx+Olx,1-Oly:sNy+Oly,Nrphys,nSx,nSy)
       _RL vphytemp(1-Olx:sNx+Olx,1-Oly:sNy+Oly,Nrphys,nSx,nSy)
       _RL thphytemp(1-Olx:sNx+Olx,1-Oly:sNy+Oly,Nrphys,nSx,nSy)
       _RL sphytemp(1-Olx:sNx+Olx,1-Oly:sNy+Oly,Nrphys,nSx,nSy)
       _RL tempphy(1-Olx:sNx+Olx,1-Oly:sNy+Oly,Nrphys,nSx,nSy)

       integer i, j, L, Lbotij, bi, bj
       integer im1, im2, jm1, jm2, idim1, idim2, jdim1, jdim2
       _RL dt

       _RL tempij(sNx,sNy)
       _RL dtfake
       _RL dtinv

       im1 = 1-OLx
       im2 = sNx+OLx
       jm1 = 1-OLy
       jm2 = sNy+OLy
       idim1 = 1
       idim2 = sNx
       jdim1 = 1
       jdim2 = sNy
       dtfake = 1. _d 0
       dtinv = 1. _d 0 / dt

       do bj = myByLo(myThid), myByHi(myThid)
       do bi = myBxLo(myThid), myBxHi(myThid)

C Construct Pressures on physics and dynamics grids
        do j = 1,sNy
        do i = 1,sNx
         do L = 1,Nr
          pedyn(i,j,L,bi,bj) = 0.
         enddo
        enddo
        enddo
        do j = 1,sNy
        do i = 1,sNx
         Lbotij = ksurfC(i,j,bi,bj)
         if(Lbotij.lt.nr+1)
     .    pedyn(i,j,Lbotij,bi,bj) = Ro_surf(i,j,bi,bj) + etaH(i,j,bi,bj)
        enddo
        enddo
        do j = 1,sNy
        do i = 1,sNx
         Lbotij = ksurfC(i,j,bi,bj)
         do L = Lbotij+1,Nr+1
          pedyn(i,j,L,bi,bj) = pedyn(i,j,L-1,bi,bj) -
     .               drF(L-1)* rStarExpC(i,j,bi,bj)*hfacC(i,j,L-1,bi,bj)
         enddo
c Do not use a zero field as the top edge pressure for interpolation
         if(pedyn(i,j,Nr+1,bi,bj).lt.1.e-5)
     .                               pedyn(i,j,Nr+1,bi,bj) = 1.e-5
        enddo
        enddo

        do j = 1,sNy
        do i = 1,sNx
         pephy(i,j,1,bi,bj)=Ro_surf(i,j,bi,bj) + etaH(i,j,bi,bj)
         do L = 2,Nrphys+1
          pephy(i,j,L,bi,bj)=pephy(i,j,L-1,bi,bj)-dpphys(i,j,L-1,bi,bj)
         enddo
c Do not use a zero field as the top edge pressure for interpolation
         if(pephy(i,j,Nrphys+1,bi,bj).lt.1.e-5)
     .                               pephy(i,j,Nrphys+1,bi,bj) = 1.e-5
        enddo
        enddo
c
c Create a wind magnitude field on the physics grid -
c   (Load the wind speed bottom up for use by dyn2phys)
        do L = 1,Nrphys
        do j = 1,sNy
        do i = 1,sNx
         windphy(i,j,L,bi,bj) =
     .     sqrt(uphy(i,j,Nrphys+1-L,bi,bj)*uphy(i,j,Nrphys+1-L,bi,bj)
     .        + vphy(i,j,Nrphys+1-L,bi,bj)*vphy(i,j,Nrphys+1-L,bi,bj))
        enddo
        enddo
        enddo
       enddo
       enddo

       CALL TIMER_START('PHYS2DYN          [STEP_FIZHI_CORR]',mythid)
       do bj = myByLo(myThid), myByHi(myThid)
       do bi = myBxLo(myThid), myBxHi(myThid)

c Compute correction term (new dyn state-phys state to dyn) on physics grid:
c    First: interp physics state to dynamics grid
C Note: physics field levels are numbered top down - need bottom up
        do L = 1,Nrphys
        do j = 1,sNy
        do i = 1,sNx
         tempphy(i,j,Nrphys+1-L,bi,bj) = uphy(i,j,L,bi,bj)
        enddo
        enddo
        enddo
        call phys2dyn(tempphy,pephy,im1,im2,jm1,jm2,Nrphys,Nsx,Nsy,
     .        1,sNx,1,sNy,bi,bj,pedyn,ksurfC,Nr,nlperdyn,udyntemp)
        do L = 1,Nrphys
        do j = 1,sNy
        do i = 1,sNx
         tempphy(i,j,Nrphys+1-L,bi,bj) = vphy(i,j,L,bi,bj)
        enddo
        enddo
        enddo
        call phys2dyn(tempphy,pephy,im1,im2,jm1,jm2,Nrphys,Nsx,Nsy,
     .        1,sNx,1,sNy,bi,bj,pedyn,ksurfC,Nr,nlperdyn,vdyntemp)
        do L = 1,Nrphys
        do j = 1,sNy
        do i = 1,sNx
         tempphy(i,j,Nrphys+1-L,bi,bj) = thphy(i,j,L,bi,bj)
        enddo
        enddo
        enddo
        call phys2dyn(tempphy,pephy,im1,im2,jm1,jm2,Nrphys,Nsx,Nsy,
     .        1,sNx,1,sNy,bi,bj,pedyn,ksurfC,Nr,nlperdyn,thdyntemp)
        do L = 1,Nrphys
        do j = 1,sNy
        do i = 1,sNx
         tempphy(i,j,Nrphys+1-L,bi,bj) = sphy(i,j,L,bi,bj)
        enddo
        enddo
        enddo
        call phys2dyn(tempphy,pephy,im1,im2,jm1,jm2,Nrphys,Nsx,Nsy,
     .        1,sNx,1,sNy,bi,bj,pedyn,ksurfC,Nr,nlperdyn,sdyntemp)

       enddo
       enddo
       CALL TIMER_STOP('PHYS2DYN          [STEP_FIZHI_CORR]',mythid)

c    Second: Convert physics state on dynamics grid to C-Grid

       CALL TIMER_START('ATOC              [STEP_FIZHI_CORR]',mythid)
       call AtoC(myThid,udyntemp,vdyntemp,maskC,im1,im2,jm1,jm2,Nr,
     .                     Nsx,Nsy,1,sNx,1,sNy,udyntemp,vdyntemp)
       CALL TIMER_STOP('ATOC              [STEP_FIZHI_CORR]',mythid)

c    Third: Subtract Phys state on dyn. grid from new dynamics state
       do bj = myByLo(myThid), myByHi(myThid)
       do bi = myBxLo(myThid), myBxHi(myThid)

        do L = 1,Nr
        do j = jdim1,jdim2
        do i = idim1,idim2
        udyntemp(i,j,L,bi,bj)=uvel(i,j,L,bi,bj)-udyntemp(i,j,L,bi,bj)
        vdyntemp(i,j,L,bi,bj)=vvel(i,j,L,bi,bj)-vdyntemp(i,j,L,bi,bj)
        thdyntemp(i,j,L,bi,bj)=theta(i,j,L,bi,bj)-thdyntemp(i,j,L,bi,bj)
        sdyntemp(i,j,L,bi,bj)=salt(i,j,L,bi,bj)-sdyntemp(i,j,L,bi,bj)
        enddo
        enddo
        enddo

       enddo
       enddo

c    Fourth: Convert correction terms to A-Grid
       CALL TIMER_START('CTOA              [STEP_FIZHI_CORR]',mythid)
        call CtoA(myThid,udyntemp,vdyntemp,maskW,maskS,im1,im2,jm1,jm2,
     .     Nr,Nsx,Nsy,1,sNx,1,sNy,udyntemp,vdyntemp)
       CALL TIMER_STOP('CTOA              [STEP_FIZHI_CORR]',mythid)

c    Fifth: Interpolate correction terms to physics grid
       CALL TIMER_START('DYN2PHYS          [STEP_FIZHI_CORR]',mythid)
       do bj = myByLo(myThid), myByHi(myThid)
       do bi = myBxLo(myThid), myBxHi(myThid)

        call dyn2phys(udyntemp,pedyn,im1,im2,jm1,jm2,Nr,Nsx,Nsy,1,sNx,
     .      1,sNy,bi,bj,windphy,pephy,ksurfC,Nrphys,nlperdyn,1,tempphy)
C Note: correction term is now bottom up - needed in top down arrays
        do L = 1,Nrphys
        do j = 1,sNy
        do i = 1,sNx
         uphytemp(i,j,Nrphys+1-L,bi,bj) = tempphy(i,j,L,bi,bj)
        enddo
        enddo
        enddo
        call dyn2phys(vdyntemp,pedyn,im1,im2,jm1,jm2,Nr,Nsx,Nsy,1,sNx,
     .      1,sNy,bi,bj,windphy,pephy,ksurfC,Nrphys,nlperdyn,1,tempphy)
        do L = 1,Nrphys
        do j = 1,sNy
        do i = 1,sNx
         vphytemp(i,j,Nrphys+1-L,bi,bj) = tempphy(i,j,L,bi,bj)
        enddo
        enddo
        enddo
        call dyn2phys(thdyntemp,pedyn,im1,im2,jm1,jm2,Nr,Nsx,Nsy,1,sNx,
     .     1,sNy,bi,bj,windphy,pephy,ksurfC,Nrphys,nlperdyn,0,tempphy)
        do L = 1,Nrphys
        do j = 1,sNy
        do i = 1,sNx
         thphytemp(i,j,Nrphys+1-L,bi,bj) = tempphy(i,j,L,bi,bj)
        enddo
        enddo
        enddo
        call dyn2phys(sdyntemp,pedyn,im1,im2,jm1,jm2,Nr,Nsx,Nsy,1,sNx,
     .      1,sNy,bi,bj,windphy,pephy,ksurfC,Nrphys,nlperdyn,0,tempphy)
        do L = 1,Nrphys
        do j = 1,sNy
        do i = 1,sNx
         sphytemp(i,j,Nrphys+1-L,bi,bj) = tempphy(i,j,L,bi,bj)
        enddo
        enddo
        enddo
       enddo
       enddo
       CALL TIMER_STOP('DYN2PHYS          [STEP_FIZHI_CORR]',mythid)

c    Last: Increment physics state by the correction term
       do bj = myByLo(myThid), myByHi(myThid)
       do bi = myBxLo(myThid), myBxHi(myThid)
        call step_physics(uphy,vphy,thphy,sphy,dtfake,im1,im2,jm1,jm2,
     .   Nrphys,Nsx,Nsy,1,sNx,1,sNy,bi,bj,
     .                            uphytemp,vphytemp,thphytemp,sphytemp)

        call qcheck (im1,im2,jm1,jm2,Nrphys,Nsx,Nsy,idim1,idim2,
     .         jdim1,jdim2,bi,bj,dpphys,sphy)

       enddo
       enddo

#ifdef ALLOW_DIAGNOSTICS
      call diagnostics_fill(uphy,'UAVE    ',0,Nrphys,0,1,1,myThid)
      call diagnostics_fill(vphy,'VAVE    ',0,Nrphys,0,1,1,myThid)
      call diagnostics_fill(thphy,'TAVE    ',0,Nrphys,0,1,1,myThid)
      call diagnostics_fill(sphy,'QAVE    ',0,Nrphys,0,1,1,myThid)
#endif

#ifdef ALLOW_DIAGNOSTICS
      do bj = myByLo(myThid), myByHi(myThid)
      do bi = myBxLo(myThid), myBxHi(myThid)
      do L=1,Nrphys

c Total Tendency on Fizhi Grid for U (m/sec/day)
c -----------------------------------------------
       if(diagnostics_is_on('TENDUFIZ',myThid) ) then
        do j=jm1,jm2
        do i=im1,im2
         tempij(i,j) = (uphy (i,j,L,bi,bj)-ubef(i,j,L,bi,bj) )
     .                     * 86400. _d 0 * dtinv
        enddo
        enddo
        call diagnostics_fill(tempij,'TENDUFIZ',L,1,3,bi,bj,myThid)
       endif

c Total Tendency on Fizhi Grid for V (m/sec/day)
c -----------------------------------------------
       if(diagnostics_is_on('TENDVFIZ',myThid) ) then
        do j=jm1,jm2
        do i=im1,im2
         tempij(i,j) = (vphy (i,j,L,bi,bj)-vbef(i,j,L,bi,bj) )
     .                     * 86400. _d 0 * dtinv
        enddo
        enddo
        call diagnostics_fill(tempij,'TENDVFIZ',L,1,3,bi,bj,myThid)
       endif

c Total Tendency on Fizhi Grid for U (m/sec/day)
c -----------------------------------------------
       if(diagnostics_is_on('TENDTFIZ',myThid) ) then
        do j=jm1,jm2
        do i=im1,im2
         tempij(i,j) = (thphy (i,j,L,bi,bj)-thbef(i,j,L,bi,bj) )
     .                     * 86400. _d 0 * dtinv
        enddo
        enddo
        call diagnostics_fill(tempij,'TENDTFIZ',L,1,3,bi,bj,myThid)
       endif

c Total Tendency on Fizhi Grid for U (m/sec/day)
c -----------------------------------------------
       if(diagnostics_is_on('TENDQFIZ',myThid) ) then
        do j=jm1,jm2
        do i=im1,im2
         tempij(i,j) = (sphy (i,j,L,bi,bj)-sbef(i,j,L,bi,bj) )
     .                     * 86400. _d 0 * dtinv
        enddo
        enddo
        call diagnostics_fill(tempij,'TENDQFIZ',L,1,3,bi,bj,myThid)
       endif

      enddo
      enddo
      enddo

c Gridalt Correction Term Tendency for U and V (m/sec/day)
c --------------------------------------------------------
      if(diagnostics_is_on('CORRDU  ',myThid) .or.
     .    diagnostics_is_on('CORRDV  ',myThid)   ) then

C gridalt correction term - first step is to compute adv+filters tendency
C                           on dynamics grid (total - physics tend)
      do bj = myByLo(myThid), myByHi(myThid)
      do bi = myBxLo(myThid), myBxHi(myThid)
       do L=1,Nr
       do j=jm1,jm2
       do i=im1,im2
        udyntemp(i,j,L,bi,bj) =
     .    (uvel(i,j,L,bi,bj)-udynbef(i,j,L,bi,bj))*dtinv -
     .                                        guphy(i,j,L,bi,bj)
        vdyntemp(i,j,L,bi,bj) =
     .    (vvel(i,j,L,bi,bj)-vdynbef(i,j,L,bi,bj))*dtinv -
     .                                        gvphy(i,j,L,bi,bj)
       enddo
       enddo
       enddo
C Next step - interpolate to fizhi grid
C  first put the u and v tendencies on an a-grid
       CALL TIMER_START('CTOA              [STEP_FIZHI_CORR]',mythid)
       call CtoA(myThid,udyntemp,vdyntemp,maskW,maskS,im1,im2,jm1,jm2,
     .     Nr,Nsx,Nsy,1,sNx,1,sNy,udyntemp,vdyntemp)
       CALL TIMER_STOP('CTOA              [STEP_FIZHI_CORR]',mythid)
C  then do vertical interpolation
       do L = 1,Nrphys
       do j = 1,sNy
       do i = 1,sNx
        windphy(i,j,L,bi,bj) =
     .     sqrt(uphy(i,j,Nrphys+1-L,bi,bj)*uphy(i,j,Nrphys+1-L,bi,bj)
     .        + vphy(i,j,Nrphys+1-L,bi,bj)*vphy(i,j,Nrphys+1-L,bi,bj))
       enddo
       enddo
       enddo
       CALL TIMER_START('DYN2PHYS          [STEP_FIZHI_CORR]',mythid)
        call dyn2phys(udyntemp,pedyn,im1,im2,jm1,jm2,Nr,Nsx,Nsy,1,sNx,
     .      1,sNy,bi,bj,windphy,pephy,ksurfC,Nrphys,nlperdyn,1,tempphy)
       CALL TIMER_STOP('DYN2PHYS          [STEP_FIZHI_CORR]',mythid)
C Note: adv+filters term is now bottom up - needed in top down arrays
       do L = 1,Nrphys
       do j = 1,sNy
       do i = 1,sNx
         uphytemp(i,j,Nrphys+1-L,bi,bj) = tempphy(i,j,L,bi,bj)
       enddo
       enddo
       enddo
       call dyn2phys(vdyntemp,pedyn,im1,im2,jm1,jm2,Nr,Nsx,Nsy,1,sNx,
     .      1,sNy,bi,bj,windphy,pephy,ksurfC,Nrphys,nlperdyn,1,tempphy)
       do L = 1,Nrphys
       do j = 1,sNy
       do i = 1,sNx
         vphytemp(i,j,Nrphys+1-L,bi,bj) = tempphy(i,j,L,bi,bj)
       enddo
       enddo
       enddo
C Last Step - subtract adv+filters and physics tend from total tend on physics grid
       do L = 1,Nrphys
       do j = 1,sNy
       do i = 1,sNx
        uphytemp(i,j,L,bi,bj)=
     .    ( (uphy(i,j,L,bi,bj)-ubef(i,j,L,bi,bj))*dtinv
     .     - duphy(i,j,L,bi,bj) - uphytemp(i,j,L,bi,bj) ) * 86400. _d 0
        vphytemp(i,j,L,bi,bj)=
     .    ( (vphy(i,j,L,bi,bj)-vbef(i,j,L,bi,bj))*dtinv
     .     - dvphy(i,j,L,bi,bj) - vphytemp(i,j,L,bi,bj) ) * 86400. _d 0
       enddo
       enddo
       enddo
      enddo
      enddo

      if(diagnostics_is_on('CORRDU  ',myThid)) then
       call diagnostics_fill(uphytemp,'CORRDU  ',0,Nrphys,0,1,1,myThid)
      endif
      if(diagnostics_is_on('CORRDV  ',myThid)) then
       call diagnostics_fill(vphytemp,'CORRDV  ',0,Nrphys,0,1,1,myThid)
      endif

      endif

c Gridalt Correction Term Tendency for TH (deg K/day)
c --------------------------------------------------------
      if(diagnostics_is_on('CORRDT  ',myThid))  then

C gridalt correction term - first step is to compute adv+filters tendency
C                           on dynamics grid (total - physics tend)
      do bj = myByLo(myThid), myByHi(myThid)
      do bi = myBxLo(myThid), myBxHi(myThid)
       do L=1,Nr
       do j=jm1,jm2
       do i=im1,im2
        thdyntemp(i,j,L,bi,bj) =
     .    (theta(i,j,L,bi,bj)-thdynbef(i,j,L,bi,bj))*dtinv -
     .                                        gthphy(i,j,L,bi,bj)
       enddo
       enddo
       enddo
C Next step - interpolate to fizhi grid
       CALL TIMER_START('DYN2PHYS          [STEP_FIZHI_CORR]',mythid)
       call dyn2phys(thdyntemp,pedyn,im1,im2,jm1,jm2,Nr,Nsx,Nsy,1,sNx,
     .     1,sNy,bi,bj,windphy,pephy,ksurfC,Nrphys,nlperdyn,0,tempphy)
       CALL TIMER_STOP('DYN2PHYS          [STEP_FIZHI_CORR]',mythid)
C Note: adv+filters term is now bottom up - needed in top down arrays
       do L = 1,Nrphys
       do j = 1,sNy
       do i = 1,sNx
         thphytemp(i,j,Nrphys+1-L,bi,bj) = tempphy(i,j,L,bi,bj)
       enddo
       enddo
       enddo
C Last Step - subtract adv+filters and physics tend from total tend on physics grid
       do L = 1,Nrphys
       do j = 1,sNy
       do i = 1,sNx
        thphytemp(i,j,L,bi,bj)=
     .    ( (thphy(i,j,L,bi,bj)-thbef(i,j,L,bi,bj))*dtinv
     .     - dthphy(i,j,L,bi,bj) - thphytemp(i,j,L,bi,bj)
     .    ) * 86400. _d 0
       enddo
       enddo
       enddo
      enddo
      enddo

      call diagnostics_fill(thphytemp,'CORRDT  ',0,Nrphys,0,1,1,myThid)
      endif

c Gridalt Correction Term Tendency for Q (kg/kg/day)
c --------------------------------------------------------
      if(diagnostics_is_on('CORRDQ  ',myThid))  then

C gridalt correction term - first step is to compute adv+filters tendency
C                           on dynamics grid (total - physics tend)
      do bj = myByLo(myThid), myByHi(myThid)
      do bi = myBxLo(myThid), myBxHi(myThid)
       do L=1,Nr
       do j=jm1,jm2
       do i=im1,im2
        sdyntemp(i,j,L,bi,bj) =
     .    (salt(i,j,L,bi,bj)-sdynbef(i,j,L,bi,bj))*dtinv -
     .                                        gsphy(i,j,L,bi,bj)
       enddo
       enddo
       enddo
C Next step - interpolate to fizhi grid
       CALL TIMER_START('DYN2PHYS          [STEP_FIZHI_CORR]',mythid)
       call dyn2phys(sdyntemp,pedyn,im1,im2,jm1,jm2,Nr,Nsx,Nsy,1,sNx,
     .      1,sNy,bi,bj,windphy,pephy,ksurfC,Nrphys,nlperdyn,0,tempphy)
       CALL TIMER_STOP('DYN2PHYS          [STEP_FIZHI_CORR]',mythid)
C Note: adv+filters term is now bottom up - needed in top down arrays
       do L = 1,Nrphys
       do j = 1,sNy
       do i = 1,sNx
         sphytemp(i,j,Nrphys+1-L,bi,bj) = tempphy(i,j,L,bi,bj)
       enddo
       enddo
       enddo
C Last Step - subtract adv+filters and physics tend from total tend on physics grid
       do L = 1,Nrphys
       do j = 1,sNy
       do i = 1,sNx
        sphytemp(i,j,L,bi,bj)=
     .    ( (sphy(i,j,L,bi,bj)-sbef(i,j,L,bi,bj))*dtinv
     .     - dsphy(i,j,L,bi,bj) - sphytemp(i,j,L,bi,bj) ) * 86400. _d 0
       enddo
       enddo
       enddo
      enddo
      enddo

      call diagnostics_fill(sphytemp,'CORRDQ  ',0,Nrphys,0,1,1,myThid)
      endif
#endif

      return
      end

#include "FIZHI_OPTIONS.h"
      subroutine fizhi_diagalarms (myThid)

C***********************************************************************        
C  Purpose                                                                      
C  -------                                                                      
C     Routine to Set Alarms for diagnostic output
C
C  Argument Description                                                         
C  --------------------                                                          
C     myThid .... Process ID
C
C NOTE: This routine ASSUMES that fizhi_init_fixed has been called
C       IT WILL NOT WORK OTHERWISE
C***********************************************************************        
      implicit none
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "DIAGNOSTICS_SIZE.h"
#include "DIAGNOSTICS.h"
#include "chronos.h"

c Input Parameters
c ----------------
      integer  myThid

c Local variables
c -------------------
      integer  nhmsf, n, nincr 
      integer mmdd,hhmmss,nsecf2
      character *9 tagname
      integer  nymdb,nhmsb
      _RL absfreq

c Set Alarm Clocks
c ----------------
c To Set Begin Time for Alarm Clocks:
c  Increment  < 1 month - counting starts at model start time
c  Increment >= 1 month - counting starts at beginning of start month
c ----------------------------------------------------------------------

C-    2D/3D field diagnostics:
      do n = 1,nlists
       absfreq = abs(freq(n))
       if(absfreq.lt.100.) then
        nymdb = nymd
        nhmsb = nhms
       else
        nymdb = int(nymd/100) * 100 + 1
        nhmsb = 0
       endif
       write(tagname,'(A,I2.2)')'diagtag',n
       mmdd = int(absfreq)
       hhmmss = int((absfreq - int(absfreq))*1.e6)
       nincr = mmdd * 1.e6 + hhmmss
       call set_alarm(tagname,nymdb,nhmsb,nincr)
      enddo

C-    Global/Regional statistics diagnostics:
      do n = 1,diagSt_nbLists
       absfreq = abs(diagSt_freq(n))
       if(absfreq.lt.100.) then
        nymdb = nymd
        nhmsb = nhms
       else
        nymdb = int(nymd/100) * 100 + 1
        nhmsb = 0
       endif
       write(tagname,'(A,I2.2)')'diagStg',n
       mmdd = int(absfreq)
       hhmmss = int((absfreq - int(absfreq))*1.e6)
       nincr = mmdd * 1.e6 + hhmmss
       call set_alarm(tagname,nymdb,nhmsb,nincr)
      enddo

      return
      end

#include "THSICE_OPTIONS.h"
#ifdef ALLOW_GENERIC_ADVDIFF
# include "GAD_OPTIONS.h"
#endif
#ifdef ALLOW_AUTODIFF
# include "AUTODIFF_OPTIONS.h"
#endif

CBOP
C !ROUTINE: THSICE_ADVDIFF

C !INTERFACE: ==========================================================
      SUBROUTINE THSICE_ADVDIFF(
     U                  uIce, vIce,
     I                  bi, bj, myTime, myIter, myThid )

C !DESCRIPTION: \bv
C     *===========================================================*
C     | SUBROUTINE THSICE_ADVDIFF
C     | o driver for different advection routines
C     |   calls an adaption of gad_advection to call different
C     |   advection routines of pkg/generic_advdiff
C     *===========================================================*
C \ev

C !USES: ===============================================================
      IMPLICIT NONE

C     === Global variables ===
C   oceFWfx   :: fresh water flux to the ocean  [kg/m^2/s]
C   oceSflx   :: salt flux to the ocean         [g/m^2/s]
C   oceQnet   :: heat flux to the ocean         [W/m^2]

#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "THSICE_SIZE.h"
#include "THSICE_PARAMS.h"
#include "THSICE_VARS.h"
#ifdef ALLOW_GENERIC_ADVDIFF
# include "GAD.h"
#endif
#ifdef ALLOW_AUTODIFF_TAMC
# include "tamc.h"
#endif

C !INPUT PARAMETERS: ===================================================
C     === Routine arguments ===
C     uIce/vIce :: ice velocity on C-grid [m/s]
C     bi,bj     :: Tile indices
C     myTime    :: Current time in simulation (s)
C     myIter    :: Current iteration number
C     myThid    :: My Thread Id. number
      _RL     uIce  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL     vIce  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER bi,bj
      _RL     myTime
      INTEGER myIter
      INTEGER myThid
CEndOfInterface

#ifdef ALLOW_THSICE
C !LOCAL VARIABLES: ====================================================
C     === Local variables ===
C     i,j,      :: Loop counters
C     uTrans    :: sea-ice area transport, x direction
C     vTrans    :: sea-ice area transport, y direction
C     uTrIce    :: sea-ice volume transport, x direction
C     vTrIce    :: sea-ice volume transport, y direction
C     afx       :: horizontal advective flux, x direction
C     afy       :: horizontal advective flux, y direction
C     iceFrc    :: (new) sea-ice fraction
C     iceVol    :: temporary array used in advection S/R
C     oldVol    :: (old) sea-ice volume
C     msgBuf    :: Informational/error message buffer
      INTEGER i, j
      LOGICAL thSIce_multiDimAdv
      CHARACTER*(MAX_LEN_MBUF) msgBuf

      _RL uTrans    (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL vTrans    (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL uTrIce    (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL vTrIce    (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL afx       (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL afy       (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RS maskOce   (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL iceFrc    (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL iceVol    (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL oldVol    (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL iceTmp    (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL r_minArea
      _RL meanCellArea, areaEpsil, vol_Epsil
#ifdef ALLOW_DIAGNOSTICS
      CHARACTER*8 diagName
      CHARACTER*4 THSICE_DIAG_SUFX, diagSufx
      EXTERNAL    THSICE_DIAG_SUFX
      LOGICAL  DIAGNOSTICS_IS_ON
      EXTERNAL DIAGNOSTICS_IS_ON
      _RL tmpFac
#endif
#ifdef ALLOW_AUTODIFF_TAMC
C     tkey :: tape key (depends on tiles)
      INTEGER tkey
#endif
#ifdef ALLOW_DBUG_THSICE
      _RL tmpVar, sumVar1, sumVar2
#endif
      LOGICAL dBugFlag
#include "THSICE_DEBUG.h"
CEOP

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#ifdef ALLOW_AUTODIFF_TAMC
      tkey = bi + (bj-1)*nSx + (ikey_dynamics-1)*nSx*nSy
#endif /* ALLOW_AUTODIFF_TAMC */

C     areaEpsil, vol_Epsil are 2 small numbers for ice area & ice volume:
C     if ice area (=ice fraction * grid-cell area) or ice volume (= effective
C     thickness * grid-cell area) are too small (i.e.: < areaEpsil,vol_Epsil)
C     will assume that ice is gone, and will loose mass or energy.
C     However, if areaEpsil,vol_Epsil are much smaller than minimun ice area
C     (iceMaskMin*rAc) and minimum ice volume (iceMaskMin*hIceMin*rAc),
C     good chance that this will never happen within 1 time step.

      dBugFlag = debugLevel.GE.debLevC

C-    definitively not an accurate computation of mean grid-cell area;
C     but what matter here is just to have the right order of magnitude.
      meanCellArea = Nx*Ny
      meanCellArea = globalArea / meanCellArea
      areaEpsil = 1. _d -10 * meanCellArea
      vol_Epsil = 1. _d -15 * meanCellArea

      r_minArea = 0. _d 0
      IF ( iceMaskMin.GT.0. _d 0 ) r_minArea = 1. _d 0 / iceMaskMin

      thSIce_multiDimAdv = .TRUE.
#ifdef ALLOW_GENERIC_ADVDIFF
      IF ( thSIceAdvScheme.EQ.ENUM_CENTERED_2ND
     & .OR.thSIceAdvScheme.EQ.ENUM_UPWIND_3RD
     & .OR.thSIceAdvScheme.EQ.ENUM_CENTERED_4TH ) THEN
       thSIce_multiDimAdv = .FALSE.
      ENDIF
#endif /* ALLOW_GENERIC_ADVDIFF */

#ifdef ALLOW_DIAGNOSTICS
      IF ( useDiagnostics ) THEN
        CALL DIAGNOSTICS_FILL(iceMask,'SI_AdvFr',0,1,1,bi,bj,myThid)
C-     Ice-fraction weighted quantities:
        tmpFac = 1. _d 0
        CALL DIAGNOSTICS_FRACT_FILL(
     I                   iceHeight, iceMask,tmpFac,1,'SI_AdvHi',
     I                   0,1,1,bi,bj,myThid)
        CALL DIAGNOSTICS_FRACT_FILL(
     I                   snowHeight,iceMask,tmpFac,1,'SI_AdvHs',
     I                   0,1,1,bi,bj,myThid)
C-     Ice-Volume weighted quantities:
        IF ( DIAGNOSTICS_IS_ON('SI_AdvQ1',myThid) .OR.
     &       DIAGNOSTICS_IS_ON('SI_AdvQ2',myThid) ) THEN
         DO j=1,sNy
          DO i=1,sNx
           iceTmp(i,j) = iceMask(i,j,bi,bj)*iceHeight(i,j,bi,bj)
          ENDDO
         ENDDO
         CALL DIAGNOSTICS_FRACT_FILL(
     I                   Qice1(1-OLx,1-OLy,bi,bj),
     I                   iceTmp,tmpFac,1,'SI_AdvQ1',
     I                   0,1,2,bi,bj,myThid)
         CALL DIAGNOSTICS_FRACT_FILL(
     I                   Qice2(1-OLx,1-OLy,bi,bj),
     I                   iceTmp,tmpFac,1,'SI_AdvQ2',
     I                   0,1,2,bi,bj,myThid)
        ENDIF
      ENDIF
#endif /* ALLOW_DIAGNOSTICS */

C--   Initialisation (+ build oceanic mask)
      DO j=1-OLy,sNy+OLy
       DO i=1-OLx,sNx+OLx
         maskOce(i,j) = 0. _d 0
         IF ( hOceMxL(i,j,bi,bj).GT.0. ) maskOce(i,j) = 1.
         iceVol(i,j) = 0. _d 0
         uTrans(i,j) = 0. _d 0
         vTrans(i,j) = 0. _d 0
         uTrIce(i,j) = 0. _d 0
         vTrIce(i,j) = 0. _d 0
         oceFWfx(i,j,bi,bj) = 0. _d 0
         oceSflx(i,j,bi,bj) = 0. _d 0
         oceQnet(i,j,bi,bj) = 0. _d 0
       ENDDO
      ENDDO

#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE iceHeight (:,:,bi,bj) = comlev1_bibj,key=tkey,byte=isbyte
CADJ STORE snowHeight(:,:,bi,bj) = comlev1_bibj,key=tkey,byte=isbyte
#endif
      IF ( thSIce_diffK .GT. 0. ) THEN
        CALL THSICE_DIFFUSION(
     I              maskOce,
     U              uIce, vIce,
     I              bi, bj, myTime, myIter, myThid )
      ENDIF

      IF ( thSIce_multiDimAdv ) THEN

C-    Calculate ice transports through tracer cell faces.
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx+1,sNx+OLx
          uTrIce(i,j) = uIce(i,j)*_dyG(i,j,bi,bj)
     &                *maskOce(i-1,j)*maskOce(i,j)
         ENDDO
        ENDDO
        DO j=1-OLy+1,sNy+OLy
         DO i=1-OLx,sNx+OLx
          vTrIce(i,j) = vIce(i,j)*_dxG(i,j,bi,bj)
     &                *maskOce(i,j-1)*maskOce(i,j)
         ENDDO
        ENDDO

C--   Fractional area
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          iceFrc(i,j) = iceMask(i,j,bi,bj)
         ENDDO
        ENDDO
#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE utrice = comlev1_bibj, key=tkey, byte=isbyte
CADJ STORE vtrice = comlev1_bibj, key=tkey, byte=isbyte
#endif
        CALL THSICE_ADVECTION(
     I       GAD_SI_FRAC,  thSIceAdvScheme, .TRUE.,
     I       uTrIce, vTrIce, maskOce, thSIce_deltaT, areaEpsil,
     U       iceVol, iceFrc,
     O       uTrans, vTrans,
     I       bi, bj, myTime, myIter, myThid )

C--   Snow thickness
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          iceVol(i,j) = iceMask(i,j,bi,bj)*rA(i,j,bi,bj)
         ENDDO
        ENDDO
#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE uTrans                = comlev1_bibj,key=tkey,byte=isbyte
CADJ STORE vTrans                = comlev1_bibj,key=tkey,byte=isbyte
#endif
        CALL THSICE_ADVECTION(
     I       GAD_SI_HSNOW, thSIceAdvScheme, .FALSE.,
     I       uTrans, vTrans, maskOce, thSIce_deltaT, areaEpsil,
     U       iceVol, snowHeight(1-OLx,1-OLy,bi,bj),
     O       afx, afy,
     I       bi, bj, myTime, myIter, myThid )

#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE iceHeight (:,:,bi,bj) = comlev1_bibj,key=tkey,byte=isbyte
CADJ STORE iceMask   (:,:,bi,bj) = comlev1_bibj,key=tkey,byte=isbyte
#endif
C--   sea-ice Thickness
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          iceVol(i,j) = iceMask(i,j,bi,bj)*rA(i,j,bi,bj)
          oldVol(i,j) = iceVol(i,j)*iceHeight(i,j,bi,bj)
         ENDDO
        ENDDO
        CALL THSICE_ADVECTION(
     I       GAD_SI_HICE,  thSIceAdvScheme, .FALSE.,
     I       uTrans, vTrans, maskOce, thSIce_deltaT, areaEpsil,
     U       iceVol, iceHeight(1-OLx,1-OLy,bi,bj),
     O       uTrIce, vTrIce,
     I       bi, bj, myTime, myIter, myThid )

#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE utrice      = comlev1_bibj, key=tkey, byte=isbyte
CADJ STORE vtrice      = comlev1_bibj, key=tkey, byte=isbyte
#endif

#ifdef ALLOW_DBUG_THSICE
        IF ( dBugFlag ) THEN
         sumVar1 = 0.
         sumVar2 = 0.
         DO j=1,sNy
          DO i=1,sNx
C-      Check that updated iceVol = iceFrc*rA
           tmpVar = ABS(iceVol(i,j)-iceFrc(i,j)*rA(i,j,bi,bj))
           IF ( tmpVar.GT.0. ) THEN
             sumVar1 = sumVar1 + 1.
             sumVar2 = sumVar2 + tmpVar
           ENDIF
           IF ( tmpVar.GT.vol_Epsil ) THEN
            WRITE(6,'(A,2I4,2I2,I12)') 'ARE_ADV: ij,bij,it=',
     &                                  i,j,bi,bj,myIter
            WRITE(6,'(2(A,1P2E14.6))') 'ARE_ADV: iceVol,iceFrc*rA=',
     &                        iceVol(i,j),iceFrc(i,j)*rA(i,j,bi,bj),
     &            ' , diff=', tmpVar
           ENDIF
           IF ( dBug(i,j,bi,bj) ) THEN
            WRITE(6,'(A,2I4,2I2,I12)') 'ICE_ADV: ij,bij,it=',
     &                                  i,j,bi,bj,myIter
            WRITE(6,'(2(A,1P2E14.6))')
     &       'ICE_ADV: uIce=', uIce(i,j), uIce(i+1,j),
     &             ' , vIce=', vIce(i,j), vIce(i,j+1)
            WRITE(6,'(2(A,1P2E14.6))')
     &       'ICE_ADV: area_b,a=', iceMask(i,j,bi,bj), iceFrc(i,j),
     &       ' , Heff_b,a=', oldVol(i,j)*recip_rA(i,j,bi,bj),
     &                       iceHeight(i,j,bi,bj)*iceFrc(i,j)
           ENDIF
          ENDDO
         ENDDO
         IF ( sumVar2.GT.vol_Epsil )
     &   WRITE(6,'(A,2I2,I10,A,I4,1P2E14.6)') 'ARE_ADV: bij,it:',
     &                    bi,bj,myIter, ' ; Npts,aveDiff,Epsil=',
     &                    INT(sumVar1),sumVar2/sumVar1,vol_Epsil
        ENDIF
#endif
#ifdef ALLOW_DIAGNOSTICS
C--     Diagnosse advective fluxes (ice-fraction, snow & ice thickness):
        IF ( useDiagnostics ) THEN
          diagSufx = THSICE_DIAG_SUFX( GAD_SI_FRAC, myThid )
          diagName = 'ADVx'//diagSufx
          CALL DIAGNOSTICS_FILL( uTrans, diagName, 1,1,2,bi,bj, myThid )
          diagName = 'ADVy'//diagSufx
          CALL DIAGNOSTICS_FILL( vTrans, diagName, 1,1,2,bi,bj, myThid )

          diagSufx = THSICE_DIAG_SUFX( GAD_SI_HSNOW, myThid )
          diagName = 'ADVx'//diagSufx
          CALL DIAGNOSTICS_FILL( afx, diagName, 1,1,2,bi,bj, myThid )
          diagName = 'ADVy'//diagSufx
          CALL DIAGNOSTICS_FILL( afy, diagName, 1,1,2,bi,bj, myThid )

          diagSufx = THSICE_DIAG_SUFX( GAD_SI_HICE, myThid )
          diagName = 'ADVx'//diagSufx
          CALL DIAGNOSTICS_FILL( uTrIce, diagName, 1,1,2,bi,bj, myThid )
          diagName = 'ADVy'//diagSufx
          CALL DIAGNOSTICS_FILL( vTrIce, diagName, 1,1,2,bi,bj, myThid )
        ENDIF
#endif

C--   Enthalpy in layer 1
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          iceVol(i,j) = oldVol(i,j)
         ENDDO
        ENDDO
        CALL THSICE_ADVECTION(
     I       GAD_SI_QICE1, thSIceAdvScheme, .FALSE.,
     I       uTrIce, vTrIce, maskOce, thSIce_deltaT, vol_Epsil,
     U       iceVol, Qice1(1-OLx,1-OLy,bi,bj),
     O       afx, afy,
     I       bi, bj, myTime, myIter, myThid )
#ifdef ALLOW_DBUG_THSICE
        IF ( dBugFlag ) THEN
         DO j=1,sNy
          DO i=1,sNx
           IF ( dBug(i,j,bi,bj) ) THEN
c           WRITE(6,'(A,1P4E14.6)') 'ICE_ADV: Qice1_b,a=',
c    &             Qice1(i,j,bi,bj),
c    &        ( iceFld(i,j) + thSIce_deltaT * gFld(i,j)
c    &          ) * recip_heff(i,j)
c           WRITE(6,'(A,1P4E14.6)') 'ICE_ADV: q1Fx=', gFld(i,j)
           ENDIF
          ENDDO
         ENDDO
        ENDIF
#endif
#ifdef ALLOW_DIAGNOSTICS
        IF ( useDiagnostics ) THEN
          diagSufx = THSICE_DIAG_SUFX( GAD_SI_QICE1, myThid )
          diagName = 'ADVx'//diagSufx
          CALL DIAGNOSTICS_FILL( afx, diagName, 1,1,2,bi,bj, myThid )
          diagName = 'ADVy'//diagSufx
          CALL DIAGNOSTICS_FILL( afy, diagName, 1,1,2,bi,bj, myThid )
        ENDIF
#endif

C--   Enthalpy in layer 2
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          iceVol(i,j) = oldVol(i,j)
         ENDDO
        ENDDO
        CALL THSICE_ADVECTION(
     I       GAD_SI_QICE2, thSIceAdvScheme, .FALSE.,
     I       uTrIce, vTrIce, maskOce, thSIce_deltaT, vol_Epsil,
     U       iceVol, Qice2(1-OLx,1-OLy,bi,bj),
     O       afx, afy,
     I       bi, bj, myTime, myIter, myThid )
#ifdef ALLOW_DBUG_THSICE
        IF ( dBugFlag ) THEN
         sumVar1 = 0.
         sumVar2 = 0.
         DO j=1,sNy
          DO i=1,sNx
C-      Check that updated iceVol = Hic*Frc*rA
           tmpVar = ABS(iceVol(i,j)
     &             -iceHeight(i,j,bi,bj)*iceFrc(i,j)*rA(i,j,bi,bj))
           IF ( tmpVar.GT.0. ) THEN
             sumVar1 = sumVar1 + 1.
             sumVar2 = sumVar2 + tmpVar
           ENDIF
           IF ( tmpVar.GT.vol_Epsil ) THEN
            WRITE(6,'(A,2I4,2I2,I12)') 'VOL_ADV: ij,bij,it=',
     &                                  i,j,bi,bj,myIter
            WRITE(6,'(2(A,1P2E14.6))') 'VOL_ADV: iceVol,Hic*Frc*rA=',
     &      iceVol(i,j),iceHeight(i,j,bi,bj)*iceFrc(i,j)*rA(i,j,bi,bj),
     &             ' , diff=', tmpVar
           ENDIF
           IF ( dBug(i,j,bi,bj) ) THEN
c           WRITE(6,'(A,1P4E14.6)') 'ICE_ADV: Qice2_b,a=',
c    &             Qice2(i,j,bi,bj),
c    &        ( iceFld(i,j) + thSIce_deltaT * gFld(i,j)
c    &          ) * recip_heff(i,j)
c           WRITE(6,'(A,1P4E14.6)') 'ICE_ADV: q2Fx=', gFld(i,j)
           ENDIF
          ENDDO
         ENDDO
         IF ( sumVar2.GT.vol_Epsil )
     &   WRITE(6,'(A,2I2,I10,A,I4,1P2E14.6)') 'VOL_ADV: bij,it:',
     &                    bi,bj,myIter, ' ; Npts,aveDiff,Epsil=',
     &                    INT(sumVar1),sumVar2/sumVar1,vol_Epsil
        ENDIF
#endif
#ifdef ALLOW_DIAGNOSTICS
        IF ( useDiagnostics ) THEN
          diagSufx = THSICE_DIAG_SUFX( GAD_SI_QICE2, myThid )
          diagName = 'ADVx'//diagSufx
          CALL DIAGNOSTICS_FILL( afx, diagName, 1,1,2,bi,bj, myThid )
          diagName = 'ADVy'//diagSufx
          CALL DIAGNOSTICS_FILL( afy, diagName, 1,1,2,bi,bj, myThid )
        ENDIF
#endif

#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE iceHeight (:,:,bi,bj) = comlev1_bibj,key=tkey,byte=isbyte
CADJ STORE snowHeight(:,:,bi,bj) = comlev1_bibj,key=tkey,byte=isbyte
CADJ STORE iceFrc                = comlev1_bibj,key=tkey,byte=isbyte
#endif

C--   Update Ice Fraction: ensure that fraction is > iceMaskMin & < 1
C      and adjust Ice thickness and snow thickness accordingly
        DO j=1,sNy
         DO i=1,sNx
          IF ( iceFrc(i,j) .GT. 1. _d 0 ) THEN
c           IF ( dBug(i,j,bi,bj) )
            iceMask(i,j,bi,bj)    = 1. _d 0
            iceHeight(i,j,bi,bj)  = iceHeight(i,j,bi,bj) *iceFrc(i,j)
            snowHeight(i,j,bi,bj) = snowHeight(i,j,bi,bj)*iceFrc(i,j)
          ELSEIF ( iceFrc(i,j) .LT. iceMaskMin ) THEN
c           IF ( dBug(i,j,bi,bj) )
            iceMask(i,j,bi,bj)    = iceMaskMin
            iceHeight(i,j,bi,bj)  = iceHeight(i,j,bi,bj)
     &                             *iceFrc(i,j)*r_minArea
            snowHeight(i,j,bi,bj) = snowHeight(i,j,bi,bj)
     &                             *iceFrc(i,j)*r_minArea
          ELSE
            iceMask(i,j,bi,bj)    = iceFrc(i,j)
          ENDIF
         ENDDO
        ENDDO
#ifdef ALLOW_AUTODIFF_TAMC
C     Store directives to avoid recomputing of this routine in ad-code
CADJ STORE iceHeight (:,:,bi,bj) = comlev1_bibj,key=tkey,byte=isbyte
CADJ STORE snowHeight(:,:,bi,bj) = comlev1_bibj,key=tkey,byte=isbyte
CADJ STORE iceMask   (:,:,bi,bj) = comlev1_bibj,key=tkey,byte=isbyte
CADJ STORE qIce1     (:,:,bi,bj) = comlev1_bibj,key=tkey,byte=isbyte
CADJ STORE qIce2     (:,:,bi,bj) = comlev1_bibj,key=tkey,byte=isbyte
#endif
C-     adjust sea-ice state if ice is too thin.
        DO j=1,sNy
         DO i=1,sNx
          IF ( iceHeight(i,j,bi,bj).LT.hIceMin ) THEN
           iceVol(i,j) = iceMask(i,j,bi,bj)*iceHeight(i,j,bi,bj)
c          IF ( dBug(i,j,bi,bj) )
           IF ( iceVol(i,j).GE.hIceMin*iceMaskMin ) THEN
            iceMask(i,j,bi,bj)    = iceVol(i,j)/hIceMin
            snowHeight(i,j,bi,bj) = snowHeight(i,j,bi,bj)
     &                             *hIceMin/iceHeight(i,j,bi,bj)
            iceHeight(i,j,bi,bj)  = hIceMin
           ELSE
C-    Not enough ice, melt the tiny amount of snow & ice:
C     and return fresh-water, salt & energy to the ocean (flx > 0 = into ocean)
C- -  Note: using 1rst.Order Upwind, I can get the same results as when
C     using seaice_advdiff (with SEAICEadvScheme=1) providing I comment
C     out the following lines (and then loose conservation).
C- -
            oceFWfx(i,j,bi,bj) =  ( rhos*snowHeight(i,j,bi,bj)
     &                             +rhoi*iceHeight(i,j,bi,bj)
     &                            )*iceMask(i,j,bi,bj)/thSIce_deltaT
            oceSflx(i,j,bi,bj) =    rhoi*iceHeight(i,j,bi,bj)*saltIce
     &                             *iceMask(i,j,bi,bj)/thSIce_deltaT
            oceQnet(i,j,bi,bj) = -( rhos*snowHeight(i,j,bi,bj)*qsnow
     &                             +rhoi*iceHeight(i,j,bi,bj)
     &                                  *( Qice1(i,j,bi,bj)
     &                                    +Qice2(i,j,bi,bj) )*0.5 _d 0
     &                            )*iceMask(i,j,bi,bj)/thSIce_deltaT
C- -
c           flx2oc (i,j) = flx2oc (i,j) +
c           frw2oc (i,j) = frw2oc (i,j) +
c           fsalt  (i,j) = fsalt  (i,j) +
            iceMask   (i,j,bi,bj) = 0. _d 0
            iceHeight (i,j,bi,bj) = 0. _d 0
            snowHeight(i,j,bi,bj) = 0. _d 0
            Qice1     (i,j,bi,bj) = 0. _d 0
            Qice2     (i,j,bi,bj) = 0. _d 0
            snowAge   (i,j,bi,bj) = 0. _d 0
           ENDIF
          ENDIF
         ENDDO
        ENDDO

#ifdef ALLOW_DBUG_THSICE
        IF ( dBugFlag ) THEN
         DO j=1,sNy
          DO i=1,sNx
           IF ( dBug(i,j,bi,bj) ) THEN
            WRITE(6,'(2(A,1P2E14.6))')
c    &       'ICE_ADV: area_b,a=', AREA(i,j,2,bi,bj),AREA(i,j,1,bi,bj)
c           WRITE(6,'(A,1P4E14.6)') 'ICE_ADV: mFx=', gFld(i,j)
           ENDIF
          ENDDO
         ENDDO
        ENDIF
#endif

      ELSE
C---  if not multiDimAdvection

        WRITE(msgBuf,'(2A)') 'S/R THSICE_ADVDIFF: ',
     &       'traditional advection/diffusion not yet implemented'
        CALL PRINT_ERROR( msgBuf , myThid)
        WRITE(msgBuf,'(2A)') '                    ',
     &       'for ThSice variable Qice1, Qice2, SnowHeight. Sorry!'
        CALL PRINT_ERROR( msgBuf , myThid)
          STOP 'ABNORMAL: END: S/R THSICE_ADVDIFF'

C---  end if multiDimAdvection
      ENDIF

#endif /* ALLOW_THSICE */

      RETURN
      END

#include "AIM_OPTIONS.h"

C--  File phy_radiat.F:
C--   Contents
C--   o SOL_OZ
C--   o RADSW
C--   o RADLW
C--   o RADSET

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C !ROUTINE: SOL_OZ (SOLC,TYEAR)
C !INTERFACE:
      SUBROUTINE SOL_OZ (SOLC, TYEAR, SLAT, CLAT,
     O                   FSOL, OZONE, OZUPP, ZENIT, STRATZ,
     I                   bi, bj, myThid)
C !DESCRIPTION: \bv
C   Purpose: Compute the flux of incoming solar radiation
C            and a climatological ozone profile for SW absorption
C   Input:   SOLC   = solar constant (area averaged)
C            TYEAR  = time as fraction of year (0-1, 0 = 1jan.h00)
C            SLAT   = sin(lat)
C            CLAT   = cos(lat)
C   Output:  FSOL   = flux of incoming solar radiation
C            OZONE  = flux absorbed by ozone (lower stratos.)
C            OZUPP  = flux absorbed by ozone (upper stratos.)
C            ZENIT  = function of solar zenith angle
C            STRATZ = ?
C   Updated common blocks: RADZON
C *==========================================================*
C \ev

C !USES:
      IMPLICIT NONE

C     Resolution parameters
C-- size for MITgcm & Physics package :
#include "AIM_SIZE.h"

#include "EEPARAMS.h"
#include "PARAMS.h"
#include "AIM_PARAMS.h"

C     Constants + functions of sigma and latitude
#include "com_physcon.h"
C     Radiation constants
#include "com_radcon.h"

C !INPUT/OUTPUT PARAMETERS:
      INTEGER  bi, bj, myThid
      _RL SOLC, TYEAR
      _RL SLAT(NGP), CLAT(NGP)
      _RL FSOL(NGP), OZONE(NGP), OZUPP(NGP), ZENIT(NGP), STRATZ(NGP)
CEOP

#ifdef ALLOW_AIM
C !LOCAL VARIABLES:
      INTEGER J, NZEN
      _RL ALPHA, CSR1, CSR2, COZ1, COZ2
      _RL AZEN, RZEN, CZEN, SZEN, AST, FS0, FLAT2
#ifdef ALLOW_INSOLATION
      _RL TanDelcl, cosH, HourAng, TanLat
      _RL largeTan
      largeTan = 1. _d 16
#endif

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C     ALPHA = year phase ( 0 - 2pi, 0 = winter solstice = 22dec.h00 )
      ALPHA = 4. _d 0*ASIN(1. _d 0)*(TYEAR+10. _d 0/365. _d 0)

      CSR1=-0.796 _d 0*COS(ALPHA)
      CSR2= 0.147 _d 0*COS(2. _d 0*ALPHA)-0.477 _d 0
      COZ1= 1.0 _d 0 * COS(ALPHA)
      COZ2= 1.8 _d 0
C
      AZEN=1.0
      NZEN=2

#ifdef ALLOW_INSOLATION
      SZEN = - SIN(  OBLIQ * PI/180. _d 0) * COS(ALPHA)
      RZEN = ASIN( SZEN )
      CZEN =  COS( RZEN )
      IF ( SZEN .EQ. 1. _d 0 ) THEN
         TanDelcl = largeTan
      ELSEIF ( SZEN .EQ. -1. _d 0 ) THEN
         TanDelcl =-largeTan
      ELSE
         TanDelcl = SZEN / CZEN
      ENDIF
#else
      RZEN=-COS(ALPHA)*23.45 _d 0*ASIN(1. _d 0)/90. _d 0
      CZEN=COS(RZEN)
      SZEN=SIN(RZEN)
#endif

      AST=0.025 _d 0
      FS0=10. _d 0
C     FS0=16.-8.*COS(ALPHA)

      DO J=1,NGP

        FLAT2 = 1.5 _d 0*SLAT(J)**2 - 0.5 _d 0

#ifndef ALLOW_INSOLATION
C       solar radiation at the top
        FSOL(J) = SOLC*
     &     MAX( 0. _d 0, 1. _d 0+CSR1*SLAT(J)+CSR2*FLAT2 )
#else
        IF ( CLAT(J) .EQ. 0. _d 0 ) THEN
           TanLat = SIGN(1. _d 0, SLAT(J) ) * largeTan
        ELSE
           TanLat = SLAT(J)/CLAT(J)
        ENDIF
        cosH     = - TanLat * TanDelcl
        cosH     = MAX(MIN(cosH,1. _d 0), -1. _d 0)
        HourAng  =  ACOS( cosH )
        FSOL(J)  = 4. _d 0 / PI * SOLC *
     &   (SLAT(J)*SZEN*HourAng+CLAT(J)*CZEN*SIN(HourAng))
#endif

C       ozone depth in upper and lower stratosphere
        OZUPP(J) = EPSSW*(1.-FLAT2)
        OZONE(J) = EPSSW*(1.+COZ1*SLAT(J)+COZ2*FLAT2)

C       zenith angle correction to (downward) absorptivity
        ZENIT(J) = 1. + AZEN*
     &    (1. _d 0-(CLAT(J)*CZEN+SLAT(J)*SZEN))**NZEN

C       ozone absorption in upper and lower stratosphere
        OZUPP(J)=FSOL(J)*OZUPP(J)*ZENIT(J)
        OZONE(J)=FSOL(J)*OZONE(J)*ZENIT(J)
        STRATZ(J)=AST*FSOL(J)*CLAT(J)**3
     &           +MAX( FS0-FSOL(J), 0. _d 0 )

      ENDDO

#ifdef ALLOW_DIAGNOSTICS
      IF ( useDiagnostics ) THEN
        CALL DIAGNOSTICS_FILL( FSOL,
     &                        'FSOL    ', 1, 1, 3,bi,bj, myThid )
      ENDIF
#endif

#endif /* ALLOW_AIM */
      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

CBOP
C !ROUTINE: RADSW (PSA,QA,RH,ALB,
C    &             ICLTOP,CLOUDC,FTOP,FSFC,DFABS)
C !INTERFACE:
      SUBROUTINE RADSW (PSA,dpFac,QA,RH,ALB,
     I                  FSOL, OZONE, OZUPP, ZENIT, STRATZ,
     O                  TAU2, STRATC,
     O                  ICLTOP,CLOUDC,FTOP,FSFC,UPSWG,DFABS,
     I                  absCO2, kGrd,bi,bj,myThid)
C !DESCRIPTION: \bv
C   Purpose: Compute the absorption of shortwave radiation and
C            initialize arrays for longwave-radiation routines
C   Input:   PSA    = norm. surface pressure [p/p0]           (2-dim)
C            dpFac  = cell delta_P fraction                   (3-dim)
C            QA     = specific humidity [g/kg]                (3-dim)
C            RH     = relative humidity                       (3-dim)
C            ALB    = surface albedo                          (2-dim)
C   Output:  ICLTOP = cloud top level                             (2-dim)
C            CLOUDC = total cloud cover                           (2-dim)
C            FTOP   = net downw. flux of sw rad. at the atm. top  (2-dim)
C            FSFC   = net downw. flux of sw rad. at the surface   (2-dim)
C            UPSWG  = upward flux of sw rad. at the surface       (2-dim)
C            DFABS  = flux of sw rad. absorbed by each atm. layer (3-dim)
C  Input:    absCO2 = LW absorbtion in CO2 band (uniform value)
C            kGrd   = Ground level index                      (2-dim)
C            bi,bj  = tile index
C            myThid = Thread number for this instance of the routine

C !USES:
      IMPLICIT NONE

C     Resolution parameters

C-- size for MITgcm & Physics package :
#include "AIM_SIZE.h"

#include "EEPARAMS.h"
#include "PARAMS.h"

C     Constants + functions of sigma and latitude
#include "com_physcon.h"
C     Radiation parameters
#include "com_radcon.h"

C !INPUT/OUTPUT PARAMETERS:
      _RL PSA(NGP),dpFac(NGP,NLEV),QA(NGP,NLEV),RH(NGP,NLEV)
      _RL ALB(NGP,0:3)
      INTEGER  ICLTOP(NGP)
      _RL CLOUDC(NGP), FTOP(NGP), FSFC(NGP,0:3), DFABS(NGP,NLEV)
      _RL UPSWG(NGP)

      _RL FSOL(NGP), OZONE(NGP), OZUPP(NGP), ZENIT(NGP), STRATZ(NGP)
      _RL TAU2(NGP,NLEV,NBAND),STRATC(NGP)
c     _RL FLUX(NGP,4)

      _RL absCO2
      INTEGER  kGrd(NGP)
      INTEGER  bi, bj, myThid
CEOP

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#ifdef ALLOW_AIM
C !LOCAL VARIABLES:
c     _RL  QCLOUD(NGP), ACLOUD(NGP), PSAZ(NGP),
      _RL  QCLOUD(NGP), ACLOUD(NGP),
     &     ALBTOP(NGP,NLEV), FREFL(NGP,NLEV), FLUX(NGP,2)
#ifdef ALLOW_CLOUD_3D
C_DE       CLDCLW = Local cloud cover                           (3-dim)
      _RL CLDCLW(NGP,NLEV), ACLDLW(NGP,NLEV)
#endif

C-  jmc: define "FLUX" as a local variable & remove Equivalences:
c     EQUIVALENCE (ALBTOP(1,1),TAU2(1,1,3))
c     EQUIVALENCE ( FREFL(1,1),TAU2(1,1,4))
      INTEGER NL1(NGP)
      INTEGER K, J
      LOGICAL makeClouds
      _RL FBAND1, FBAND2, RRCL, RQCL, DQACL, QACL3
      _RL ABS1, DELTAP

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      FBAND2=0.05 _d 0
      FBAND1=1.-FBAND2

      DO J=1,NGP
        NL1(J)=kGrd(J)-1
      ENDDO

C--   1.  Cloud cover:
C         defined as a linear fun. of the maximum relative humidity
C         in all tropospheric layers above PBL:
C         CLOUDC =  0 for RHmax < RHCL1, = 1 for RHmax > RHCL2.
C         This value is reduced by a factor (Qbase/QACL) if the
C         cloud-base absolute humidity Qbase < QACL.
C
      makeClouds = ICLTOP(1) .GE. 0
      RRCL=1./(RHCL2-RHCL1)
      RQCL=1./QACL2
C
      DO J=1,NGP
        CLOUDC(J)=0.
        QCLOUD(J)=0.
        ICLTOP(J)=NLEV+1
        FREFL(J,1)=0.
      ENDDO

      DO K=1,NLEV
       DO J=1,NGP
         ALBTOP(J,K)=0.
#ifdef ALLOW_CLOUD_3D
         CLDCLW(J,K)=0.
#endif
       ENDDO
      ENDDO
C
      IF ( makeClouds ) THEN
C-    skipp this part for clear-sky diagnostics

       DQACL=(QACL2-QACL1)/(0.5 _d 0 - SIG(2))
       DO J=1,NGP
        ICLTOP(J)= kGrd(J)
        DO K=NL1(J),2,-1
         QACL3=MIN(QACL2,QACL1+DQACL*(SIG(K)-SIG(2)))
         IF (RH(J,K).GT.RHCL1.AND.QA(J,K).GT.QACL1) THEN
            CLOUDC(J)=MAX(CLOUDC(J),RH(J,K)-RHCL1)
            IF (QA(J,K).GT.QACL3) ICLTOP(J)=K
#ifdef ALLOW_CLOUD_3D
            CLDCLW(J,K)=MAX(0. _d 0,RH(J,K)-RHCL1)
            CLDCLW(J,K)=MIN(1. _d 0,CLDCLW(J,K)*RRCL)
#endif
         ENDIF
        ENDDO
       ENDDO

       DO J=1,NGP
        IF (kGrd(J).NE.0)
     &  QCLOUD(J)= MAX( QA(J,kGrd(J)), QA(J,NL1(J)) )
        CLOUDC(J)=MIN(1. _d 0,CLOUDC(J)*RRCL)
        IF (CLOUDC(J).GT.0.0) THEN
          CLOUDC(J)=CLOUDC(J)*MIN(1. _d 0,QCLOUD(J)*RQCL)
#ifdef ALLOW_CLOUD_3D
          DO K=NL1(J),2,-1
             CLDCLW(J,K)=CLDCLW(J,K)*MIN(1. _d 0,QCLOUD(J)*RQCL)
          ENDDO
#endif
          ALBTOP(J,ICLTOP(J))=ALBCL*CLOUDC(J)
        ELSE
          ICLTOP(J)=NLEV+1
        ENDIF
       ENDDO

C-    end if makeClouds
      ENDIF

C
C--   2. Shortwave transmissivity:
C        function of layer mass, ozone (in the statosphere),
C        abs. humidity and cloud cover (in the troposphere)

      DO J=1,NGP
c_FM    PSAZ(J)=PSA(J)*ZENIT(J)
        ACLOUD(J)=CLOUDC(J)*(ABSCL1+ABSCL2*QCLOUD(J))
      ENDDO

      DO J=1,NGP
c_FM    DELTAP=PSAZ(J)*DSIG(1)
        DELTAP=ZENIT(J)*DSIG(1)*dpFac(J,1)
        TAU2(J,1,1)=EXP(-DELTAP*ABSDRY)
      ENDDO
C
      DO J=1,NGP
       DO K=2,NL1(J)
c_FM     ABS1=ABSDRY+ABSAER*SIG(K)**2
c_FM     DELTAP=PSAZ(J)*DSIG(K)
         ABS1=ABSDRY+ABSAER*(SIG(K)/PSA(J))**2
         DELTAP=ZENIT(J)*DSIG(K)*dpFac(J,K)
         IF (K.EQ.ICLTOP(J)) THEN
           TAU2(J,K,1)=EXP(-DELTAP*
     &                 (ABS1+ABSWV1*QA(J,K)+2.*ACLOUD(J)))
         ELSE IF (K.GT.ICLTOP(J)) THEN
           TAU2(J,K,1)=EXP(-DELTAP*
     &                 (ABS1+ABSWV1*QA(J,K)+ACLOUD(J)))
         ELSE
           TAU2(J,K,1)=EXP(-DELTAP*(ABS1+ABSWV1*QA(J,K)))
         ENDIF
       ENDDO
      ENDDO

c_FM  ABS1=ABSDRY+ABSAER*SIG(NLEV)**2
      DO J=1,NGP
       K = kGrd(J)
       ABS1=ABSDRY+ABSAER*(SIG(K)/PSA(J))**2
c_FM    DELTAP=PSAZ(J)*DSIG(NLEV)
        DELTAP=ZENIT(J)*DSIG(K)*dpFac(J,K)
        TAU2(J,K,1)=EXP(-DELTAP*(ABS1+ABSWV1*QA(J,K)))
      ENDDO

      DO J=1,NGP
       DO K=2,kGrd(J)
         DELTAP=ZENIT(J)*DSIG(K)*dpFac(J,K)
         TAU2(J,K,2)=EXP(-DELTAP*ABSWV2*QA(J,K))
       ENDDO
      ENDDO
C
C---  3. Shortwave downward flux
C
C     3.1  Absorption in the stratosphere

C     3.1.1 Initialization of fluxes (subtracting
C           ozone absorption in the upper stratosphere)

      DO J=1,NGP
        FTOP(J)  =FSOL(J)
        FLUX(J,1)=FSOL(J)*FBAND1-OZUPP(J)
        FLUX(J,2)=FSOL(J)*FBAND2
        STRATC(J)=STRATZ(J)*PSA(J)
      ENDDO

C     3.1.2 Ozone and dry-air absorption
C           in the lower (modelled) stratosphere

      DO J=1,NGP
        DFABS(J,1)=FLUX(J,1)
        FLUX (J,1)=TAU2(J,1,1)*(FLUX(J,1)-OZONE(J)*PSA(J))
        DFABS(J,1)=DFABS(J,1)-FLUX(J,1)
      ENDDO

C     3.3  Absorption and reflection in the troposphere
C
      DO J=1,NGP
       DO K=2,kGrd(J)
         FREFL(J,K)=FLUX(J,1)*ALBTOP(J,K)
         FLUX (J,1)=FLUX(J,1)-FREFL(J,K)
         DFABS(J,K)=FLUX(J,1)
         FLUX (J,1)=TAU2(J,K,1)*FLUX(J,1)
         DFABS(J,K)=DFABS(J,K)-FLUX(J,1)
       ENDDO
      ENDDO

      DO J=1,NGP
       DO K=2,kGrd(J)
         DFABS(J,K)=DFABS(J,K)+FLUX(J,2)
         FLUX (J,2)=TAU2(J,K,2)*FLUX(J,2)
         DFABS(J,K)=DFABS(J,K)-FLUX(J,2)
       ENDDO
      ENDDO

C
C---  4. Shortwave upward flux
C
C     4.1  Absorption and reflection at the surface
C
      DO J=1,NGP
C      for each surface type:
        FSFC(J,1)=FLUX(J,1)*(1.-ALB(J,1))+FLUX(J,2)
        FSFC(J,2)=FLUX(J,1)*(1.-ALB(J,2))+FLUX(J,2)
        FSFC(J,3)=FLUX(J,1)*(1.-ALB(J,3))+FLUX(J,2)
C      weighted average according to land/sea/sea-ice fraction:
        FSFC(J,0)=FLUX(J,1)+FLUX(J,2)
        FLUX(J,1)=FLUX(J,1)*ALB(J,0)
        FSFC(J,0)=FSFC(J,0)-FLUX(J,1)
      ENDDO

C--   Store upward shortwave flux at the surface for diagnostics purpose
      DO J=1,NGP
        UPSWG(J)=FLUX(J,1)
      ENDDO
C
C     4.2  Absorption of upward flux
C
      DO K=NLEV,1,-1
       DO J=1,NGP
        IF ( K .LE. kGrd(J) ) THEN
         DFABS(J,K)=DFABS(J,K)+FLUX(J,1)
         FLUX (J,1)=TAU2(J,K,1)*FLUX(J,1)
         DFABS(J,K)=DFABS(J,K)-FLUX(J,1)
         FLUX (J,1)=FLUX(J,1)+FREFL(J,K)
        ELSE
         DFABS(J,K)= 0. _d 0
        ENDIF
       ENDDO
      ENDDO
C
C     4.3  Net solar radiation = incoming - outgoing
C
      DO J=1,NGP
        FTOP(J)=FTOP(J)-FLUX(J,1)
      ENDDO

C
C---  5.  Initialization of longwave radiation model
C
C     5.1  Longwave transmissivity:
C          function of layer mass, abs. humidity and cloud cover.

#ifdef ALLOW_CLOUD_3D
      DO K=2,NLEV
        DO J=1,NGP
          ACLDLW(J,K)=CLDCLW(J,K)*(ABLCL1+ABLCL2*QCLOUD(J))
        ENDDO
      ENDDO
#else
      DO J=1,NGP
        ACLOUD(J)=CLOUDC(J)*(ABLCL1+ABLCL2*QCLOUD(J))
      ENDDO
#endif

      DO J=1,NGP
c_FM    DELTAP=PSA(J)*DSIG(1)
        DELTAP=DSIG(1)*dpFac(J,1)
        TAU2(J,1,1)=EXP(-DELTAP*ABLWIN)
        TAU2(J,1,2)=EXP(-DELTAP*absCO2)
        TAU2(J,1,3)=1.
        TAU2(J,1,4)=1.
      ENDDO

      DO K=2,NLEV
       DO J=1,NGP
c_FM     DELTAP=PSA(J)*DSIG(K)
         DELTAP=DSIG(K)*dpFac(J,K)
         IF ( K.GE.ICLTOP(J).AND.K.NE.kGrd(J) ) THEN
#ifdef ALLOW_CLOUD_3D
           TAU2(J,K,1)=EXP(-DELTAP*(ABLWIN+ACLDLW(J,K)))
#else
           TAU2(J,K,1)=EXP(-DELTAP*(ABLWIN+ACLOUD(J)))
#endif
         ELSE
           TAU2(J,K,1)=EXP(-DELTAP*ABLWIN)
         ENDIF
         TAU2(J,K,2)=EXP(-DELTAP*absCO2)
         TAU2(J,K,3)=EXP(-DELTAP*ABLWV1*QA(J,K))
         TAU2(J,K,4)=EXP(-DELTAP*ABLWV2*QA(J,K))
       ENDDO
      ENDDO

#if (defined ALLOW_CLOUD_3D && defined ALLOW_DIAGNOSTICS)
      IF ( useDiagnostics ) THEN
        CALL DIAGNOSTICS_FILL( CLDCLW,
     &                        'CLDCLW  ',-1, Nr, 3,bi,bj, myThid )
      ENDIF
#endif

#endif /* ALLOW_AIM */

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

CBOP
C !ROUTINE: RADLW (IMODE,TA,TS,ST4S,
C    &             FTOP,FSFC,DFABS)
C !INTERFACE:
      SUBROUTINE RADLW (IMODE,TA,TS,ST4S,
     I                  OZUPP, STRATC, TAU2,
     &                  FLUX, ST4A,
     &                  FTOP,FSFC,DFABS,
     I                  kGrd,bi,bj,myThid)

C !DESCRIPTION: \bv
C   Purpose: Compute the absorption of longwave radiation
C   Input:   IMODE  = index for operation mode
C                     -1 : downward flux only
C                      0 : downward + upward flux
C                     +1 : upward flux only
C            TA     = absolute temperature (3-dim)
C            TS     = surface temperature                  [if IMODE=0,1]
C            ST4S   = surface blackbody emission             [if IMODE=1]
C            FSFC   = FSFC  output from RADLW(-1,... )       [if IMODE=1]
C            DFABS  = DFABS output from RADLW(-1,... )       [if IMODE=1]
C   Output:  ST4S   = surface blackbody emission             [if IMODE=0]
C            FTOP   = outgoing flux of lw rad. at the top  [if IMODE=0,1]
C            FSFC   = downward flux of lw rad. at the sfc. [if IMODE= -1]
C                     net upw. flux of lw rad. at the sfc. [if IMODE=0,1]
C            DFABS  = flux of lw rad. absorbed by each atm. layer (3-dim)
C  Input:    kGrd   = Ground level index                      (2-dim)
C            bi,bj  = tile index
C            myThid = Thread number for this instance of the routine

C !USES:
      IMPLICIT NONE

C     Resolution parameters
C-- size for MITgcm & Physics package :
#include "AIM_SIZE.h"
#include "EEPARAMS.h"

C     Number of radiation bands with tau < 1
c     INTEGER NBAND
c     PARAMETER ( NBAND=4 )
C     Constants + functions of sigma and latitude
#include "com_physcon.h"
C     Radiation parameters
#include "com_radcon.h"

C !INPUT/OUTPUT PARAMETERS:
      INTEGER IMODE
      _RL TA(NGP,NLEV), TS(NGP), ST4S(NGP)
      _RL FTOP(NGP), FSFC(NGP), DFABS(NGP,NLEV)
      _RL OZUPP(NGP), STRATC(NGP)
      _RL TAU2(NGP,NLEV,NBAND), FLUX(NGP,NBAND), ST4A(NGP,NLEV,2)

      INTEGER kGrd(NGP)
      INTEGER bi,bj,myThid
CEOP

#ifdef ALLOW_AIM
C !LOCAL VARIABLES:
      INTEGER K, J, JB
c     INTEGER J0, Jl, I2
      INTEGER NL1(NGP)
      _RL REFSFC, BRAD, EMIS

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      DO J=1,NGP
        NL1(J)=kGrd(J)-1
      ENDDO

      REFSFC=1.-EMISFC

      IF (IMODE.EQ.1) GO TO 410

C---  1. Blackbody emission from atmospheric full and half levels.
C        Temperature is interpolated as a linear function of ln sigma.
C        At the lower boundary, the emission is linearly extrapolated;
C        at the upper boundary, the atmosphere is assumed isothermal.

      DO K=1,NLEV
       DO J=1,NGP
         ST4A(J,K,1)=TA(J,K)*TA(J,K)
         ST4A(J,K,1)=SBC*ST4A(J,K,1)*ST4A(J,K,1)
       ENDDO
      ENDDO
C
      DO K=1,NLEV-1
       DO J=1,NGP
         ST4A(J,K,2)=TA(J,K)+WVI(K,2)*(TA(J,K+1)-TA(J,K))
         ST4A(J,K,2)=ST4A(J,K,2)*ST4A(J,K,2)
         ST4A(J,K,2)=SBC*ST4A(J,K,2)*ST4A(J,K,2)
       ENDDO
      ENDDO
C
      DO J=1,NGP
c       ST4A(J,NLEV,2)=ST4A(J,NLEV,1)
        K=kGrd(J)
        ST4A(J,K,2)=2.*ST4A(J,K,1)-ST4A(J,NL1(J),2)
      ENDDO

C---  2. Initialization
C---     (including the stratospheric correction term)

      DO J=1,NGP
        FTOP(J)   = 0.
        FSFC(J)   = STRATC(J)
        DFABS(J,1)=-STRATC(J)
      ENDDO

      DO K=2,NLEV
       DO J=1,NGP
         DFABS(J,K)=0.
       ENDDO
      ENDDO

C---  3. Emission ad absorption of longwave downward flux.
C        Downward emission is an average of the emission from the full level
C        and the half-level below, weighted according to the transmissivity
C        of the layer.

C     3.1  Stratosphere

      K=1
      DO JB=1,2
       DO J=1,NGP
         BRAD=ST4A(J,K,2)+TAU2(J,K,JB)*(ST4A(J,K,1)-ST4A(J,K,2))
         EMIS=FBAND(NINT(TA(J,K)),JB)*(1.-TAU2(J,K,JB))
         FLUX(J,JB)=EMIS*BRAD
         DFABS(J,K)=DFABS(J,K)-FLUX(J,JB)
       ENDDO
      ENDDO

      DO JB=3,NBAND
       DO J=1,NGP
         FLUX(J,JB)=0.
       ENDDO
      ENDDO

C     3.2  Troposphere

      DO JB=1,NBAND
       DO J=1,NGP
        DO K=2,kGrd(J)
          BRAD=ST4A(J,K,2)+TAU2(J,K,JB)*(ST4A(J,K,1)-ST4A(J,K,2))
          EMIS=FBAND(NINT(TA(J,K)),JB)*(1.-TAU2(J,K,JB))
          DFABS(J,K)=DFABS(J,K)+FLUX(J,JB)
          FLUX(J,JB)=TAU2(J,K,JB)*FLUX(J,JB)+EMIS*BRAD
          DFABS(J,K)=DFABS(J,K)-FLUX(J,JB)
        ENDDO
       ENDDO
      ENDDO

      DO JB=1,NBAND
       DO J=1,NGP
         FSFC(J)=FSFC(J)+EMISFC*FLUX(J,JB)
       ENDDO
      ENDDO

      IF (IMODE.EQ.-1) RETURN

C---  4. Emission ad absorption of longwave upward flux
C        Upward emission is an average of the emission from the full level
C        and the half-level above, weighted according to the transmissivity
C        of the layer (for the top layer, full-level emission is used).
C        Surface lw emission in "band 0" goes directly into FTOP.

C     4.1  Surface

      DO J=1,NGP
        ST4S(J)=TS(J)*TS(J)
        ST4S(J)=SBC*ST4S(J)*ST4S(J)
        ST4S(J)=EMISFC*ST4S(J)
      ENDDO

C     Entry point for upward-only mode (IMODE=1)
 410  CONTINUE

      DO J=1,NGP
        FSFC(J)=ST4S(J)-FSFC(J)
        FTOP(J)=FTOP(J)+FBAND(NINT(TS(J)),0)*ST4S(J)
      ENDDO

      DO JB=1,NBAND
       DO J=1,NGP
         FLUX(J,JB)=FBAND(NINT(TS(J)),JB)*ST4S(J)
     &              +REFSFC*FLUX(J,JB)
       ENDDO
      ENDDO

C     4.2  Troposphere

      DO JB=1,NBAND
       DO J=1,NGP
        DO K=kGrd(J),2,-1
          BRAD=ST4A(J,K-1,2)+TAU2(J,K,JB)*(ST4A(J,K,1)-ST4A(J,K-1,2))
          EMIS=FBAND(NINT(TA(J,K)),JB)*(1.-TAU2(J,K,JB))
          DFABS(J,K)=DFABS(J,K)+FLUX(J,JB)
          FLUX(J,JB)=TAU2(J,K,JB)*FLUX(J,JB)+EMIS*BRAD
          DFABS(J,K)=DFABS(J,K)-FLUX(J,JB)
        ENDDO
       ENDDO
      ENDDO

C     4.3  Stratosphere

      K=1
      DO JB=1,2
       DO J=1,NGP
         EMIS=FBAND(NINT(TA(J,K)),JB)*(1.-TAU2(J,K,JB))
         DFABS(J,K)=DFABS(J,K)+FLUX(J,JB)
         FLUX(J,JB)=TAU2(J,K,JB)*FLUX(J,JB)+EMIS*ST4A(J,K,1)
         DFABS(J,K)=DFABS(J,K)-FLUX(J,JB)
       ENDDO
      ENDDO

C     4.4  Outgoing longwave radiation

      DO JB=1,NBAND
       DO J=1,NGP
         FTOP(J)=FTOP(J)+FLUX(J,JB)
       ENDDO
      ENDDO

      DO J=1,NGP
        FTOP(J)=FTOP(J)+OZUPP(J)
      ENDDO

#endif /* ALLOW_AIM */

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

CBOP
C !ROUTINE: RADSET
C !INTERFACE:
      SUBROUTINE RADSET( myThid )

C !DESCRIPTION: \bv
C   Purpose: compute energy fractions in LW bands
C            as a function of temperature
C   Initialized common blocks: RADFIX

C !USES:
      IMPLICIT NONE

C     Resolution parameters
C-- size for MITgcm & Physics package :
#include "AIM_SIZE.h"
#include "EEPARAMS.h"

C     Radiation constants
#include "com_radcon.h"

C !INPUT/OUTPUT PARAMETERS:
      INTEGER myThid
CEOP

#ifdef ALLOW_AIM
C !LOCAL VARIABLES:
      INTEGER JTEMP, JB
      _RL EPS3

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      EPS3=0.95 _d 0

      DO JTEMP=200,320
        FBAND(JTEMP,0)= EPSLW
        FBAND(JTEMP,2)= 0.148 _d 0 - 3.0 _d -6 *(JTEMP-247)**2
        FBAND(JTEMP,3)=(0.375 _d 0 - 5.5 _d -6 *(JTEMP-282)**2)*EPS3
        FBAND(JTEMP,4)= 0.314 _d 0 + 1.0 _d -5 *(JTEMP-315)**2
        FBAND(JTEMP,1)= 1. _d 0 -(FBAND(JTEMP,0)+FBAND(JTEMP,2)
     &                           +FBAND(JTEMP,3)+FBAND(JTEMP,4))
      ENDDO

      DO JB=0,NBAND
        DO JTEMP=lwTemp1,199
          FBAND(JTEMP,JB)=FBAND(200,JB)
        ENDDO
        DO JTEMP=321,lwTemp2
          FBAND(JTEMP,JB)=FBAND(320,JB)
        ENDDO
      ENDDO

#endif /* ALLOW_AIM */

      RETURN
      END

#include "SHAP_FILT_OPTIONS.h"

CBOP
C     !ROUTINE: SHAP_FILT_COMPUTVORT
C     !INTERFACE:
      SUBROUTINE SHAP_FILT_COMPUTVORT(
     I           uFld, vFld,
     O           vort,
     I           k, bi,bj, myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R SHAP_FILT_COMPUTVORT
C     | o Calculate delta_i[vFld]-delta_j[uFld]
C     *==========================================================*
C     | o used in computational-mode filter to replace relative
C     |   vorticity
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     == Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#ifdef ALLOW_EXCH2
#include "W2_EXCH2_SIZE.h"
#include "W2_EXCH2_TOPOLOGY.h"
#endif /* ALLOW_EXCH2 */

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments
C     uFld :: velocity field (U component) on which filter applies
C     vFld :: velocity field (V component) on which filter applies
C     myThid :: Thread number for this instance of SHAP_FILT_UV_S2
      _RL uFld(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL vFld(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL vort(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER k, bi,bj
      INTEGER myThid

#ifdef ALLOW_SHAP_FILT

C     !LOCAL VARIABLES:
C     == Local variables ==
      INTEGER i,j
      _RS maskZ
      LOGICAL northWestCorner, northEastCorner,
     &        southWestCorner, southEastCorner
      INTEGER myFace
#ifdef ALLOW_EXCH2
      INTEGER myTile
#endif /* ALLOW_EXCH2 */
CEOP

#ifdef ALLOW_AUTODIFF
C-    Initialisation :
      DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
          vort(i,j)= 0.
        ENDDO
      ENDDO
#endif

C-    replace Physical calc Div & Vort by computational one :
      DO j=2-OLy,sNy+OLy
        DO i=2-OLx,sNx+OLx
          vort(i,j) = ( vFld(i,j)-vFld(i-1,j) )
     &              - ( uFld(i,j)-uFld(i,j-1) )
          maskZ = (maskW(i,j,k,bi,bj)+maskW(i,j-1,k,bi,bj))
     &           *(maskS(i,j,k,bi,bj)+maskS(i-1,j,k,bi,bj))
          IF (maskZ.LT.1.) vort(i,j)=0.
        ENDDO
      ENDDO

C-    Special stuff for Cubed Sphere
      IF (useCubedSphereExchange) THEN
#ifdef ALLOW_EXCH2
         myTile = W2_myTileList(bi,bj)
         myFace = exch2_myFace(myTile)
         southWestCorner = exch2_isWedge(myTile).EQ.1
     &               .AND. exch2_isSedge(myTile).EQ.1
         southEastCorner = exch2_isEedge(myTile).EQ.1
     &               .AND. exch2_isSedge(myTile).EQ.1
         northEastCorner = exch2_isEedge(myTile).EQ.1
     &               .AND. exch2_isNedge(myTile).EQ.1
         northWestCorner = exch2_isWedge(myTile).EQ.1
     &               .AND. exch2_isNedge(myTile).EQ.1
#else
         myFace = bi
         southWestCorner = .TRUE.
         southEastCorner = .TRUE.
         northWestCorner = .TRUE.
         northEastCorner = .TRUE.
#endif /* ALLOW_EXCH2 */
C---
         IF ( southWestCorner ) THEN
           i=1
           j=1
           maskZ = maskW(i,j,k,bi,bj)+maskW(i,j-1,k,bi,bj)
     &            +maskS(i,j,k,bi,bj)
           IF (maskZ.GE.2.) THEN
             vort(i,j)=
     &          (+vFld(i,j) -uFld(i,j) ) +uFld(i,j-1)
             vort(i,j)=vort(i,j)*4. _d 0 / 3. _d 0
           ELSE
             vort(i,j)=0.
           ENDIF
         ENDIF
C---
         IF ( southEastCorner ) THEN
           i=sNx+1
           j=1
           maskZ = maskW(i,j,k,bi,bj)+maskW(i,j-1,k,bi,bj)
     &                               +maskS(i-1,j,k,bi,bj)
           IF (maskZ.GE.2.) THEN
             IF ( myFace.EQ.2 ) THEN
              vort(i,j)=
     &          (-uFld(i,j) -vFld(i-1,j) ) +uFld(i,j-1)
             ELSEIF ( myFace.EQ.4 ) THEN
              vort(i,j)=
     &          (-vFld(i-1,j) +uFld(i,j-1) ) -uFld(i,j)
             ELSE
              vort(i,j)=
     &          (+uFld(i,j-1) -uFld(i,j) ) -vFld(i-1,j)
             ENDIF
             vort(i,j)=vort(i,j)*4. _d 0 / 3. _d 0
           ELSE
             vort(i,j)=0.
           ENDIF
         ENDIF
C---
         IF ( northWestCorner ) THEN
           i=1
           j=sNy+1
           maskZ = maskW(i,j,k,bi,bj)+maskW(i,j-1,k,bi,bj)
     &            +maskS(i,j,k,bi,bj)
           IF (maskZ.GE.2.) THEN
             IF ( myFace.EQ.1 ) THEN
              vort(i,j)=
     &          (+uFld(i,j-1) +vFld(i,j) ) -uFld(i,j)
             ELSEIF ( myFace.EQ.3 ) THEN
              vort(i,j)=
     &          (-uFld(i,j) +uFld(i,j-1) ) +vFld(i,j)
             ELSE
              vort(i,j)=
     &          (+vFld(i,j) -uFld(i,j) ) +uFld(i,j-1)
             ENDIF
             vort(i,j)=vort(i,j)*4. _d 0 / 3. _d 0
           ELSE
             vort(i,j)=0.
           ENDIF
         ENDIF
C---
         IF ( northEastCorner ) THEN
           i=sNx+1
           j=sNy+1
           maskZ = maskW(i,j,k,bi,bj)+maskW(i,j-1,k,bi,bj)
     &                               +maskS(i-1,j,k,bi,bj)
           IF (maskZ.GE.2.) THEN
             IF ( MOD(myFace,2).EQ.1 ) THEN
              vort(i,j)=
     &          (-uFld(i,j) -vFld(i-1,j) ) +uFld(i,j-1)
             ELSE
              vort(i,j)=
     &          (+uFld(i,j-1) -uFld(i,j) ) -vFld(i-1,j)
             ENDIF
             vort(i,j)=vort(i,j)*4. _d 0 / 3. _d 0
           ELSE
             vort(i,j)=0.
           ENDIF
         ENDIF
C---  end if useCubedSphereExchange:
      ENDIF

c---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#endif /* ALLOW_SHAP_FILT */

      RETURN
      END

#include "DIAG_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 0
C     !ROUTINE: DIAGNOSTICS_INTERP_VERT

C     !INTERFACE:
      SUBROUTINE DIAGNOSTICS_INTERP_VERT(
     I                        listId, md, ndId, ip, im, lm,
     U                        qtmp1,
     O                        qtmp2,
     I                        undefRL,
     I                        myTime, myIter, myThid )

C     !DESCRIPTION:
C     Interpolate vertically a diagnostics field before writing to file.
C       presently implemented (for Atmospheric fields only):
C         Interpolation (linear in p^kappa) to standard pressure levels
C

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "DIAGNOSTICS_SIZE.h"
#include "DIAGNOSTICS.h"

      INTEGER NrMax
      PARAMETER( NrMax = numLevels )


C     !INPUT PARAMETERS:
C     listId  :: Diagnostics list number being written
C     md      :: field number in the list "listId".
C     ndId    :: diagnostics  Id number (in available diagnostics list)
C     ip      :: diagnostics  pointer to storage array
C     im      :: counter-mate pointer to storage array
C     lm      :: index in the averageCycle
C     qtmp1   :: diagnostics field output array
C     qtmp2   :: temp working array (same size as output array)
C     undefRL ::
C     myTime  :: current time of simulation (s)
C     myIter  :: current iteration number
C     myThid  :: my Thread Id number
      INTEGER listId, md, ndId, ip, im, lm
      _RL     qtmp1(1-OLx:sNx+OLx,1-OLy:sNy+OLy,NrMax,nSx,nSy)
      _RL     qtmp2(1-OLx:sNx+OLx,1-OLy:sNy+OLy,NrMax,nSx,nSy)
      _RL     undefRL
      _RL     myTime
      INTEGER myIter, myThid
CEOP

C     !FUNCTIONS:
#ifdef ALLOW_FIZHI
      _RL   getcon
      EXTERNAL getcon
#endif

C     !LOCAL VARIABLES:
C     i,j,k :: loop indices
      INTEGER i, j, k
      INTEGER bi, bj
      _RL   qtmpsrf(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      INTEGER kLev
      _RL   qprs (sNx,sNy)
      _RL   qinp (sNx,sNy,NrMax)
      _RL   pkz  (sNx,sNy,NrMax)
      _RL   pksrf(sNx,sNy)
      _RL   pk, pkTop
      _RL   kappa
      INTEGER jpoint1, ipoint1
      INTEGER jpoint2, ipoint2
      LOGICAL pInc
      CHARACTER*(MAX_LEN_MBUF) msgBuf

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      IF (fflags(listId)(2:2).EQ.'P') THEN
        pkTop = 0. _d 0
        kappa = atm_kappa
#ifdef ALLOW_FIZHI
        IF ( useFIZHI ) kappa = getcon('KAPPA')
#endif

C--   If nonlinear free surf is active, need averaged pressures
        IF (select_rStar.GT.0) THEN
          CALL DIAGNOSTICS_GET_POINTERS( 'RSURF   ', listId,
     &                                   jpoint1, ipoint1, myThid )
C-    IF fizhi is being  used, may need to get physics grid pressures
          IF ( useFIZHI .AND.
     &          gdiag(ndId)(10:10) .EQ. 'L') THEN
           CALL DIAGNOSTICS_GET_POINTERS('FIZPRES ', listId,
     &                                   jpoint2, ipoint2, myThid )
          ELSE
           CALL DIAGNOSTICS_GET_POINTERS('RCENTER ', listId,
     &                                   jpoint2, ipoint2, myThid )
          ENDIF
          IF ( ipoint1.EQ.0 .OR. ipoint2.EQ.0 ) THEN
            WRITE(msgBuf,'(2A,I6,2A)') 'DIAGNOSTICS_INTERP_VERT: ',
     &      'fails to interpolate diag.(#', ndId,'): ',flds(md,listId)
            CALL PRINT_ERROR( msgBuf , myThid )
            STOP 'ABNORMAL END: S/R DIAGNOSTICS_INTERP_VERT'
          ENDIF
C-    averageCycle: move pointer
          ipoint1 = ipoint1 + kdiag(jpoint1)*(lm-1)
          ipoint2 = ipoint2 + kdiag(jpoint2)*(lm-1)

          DO bj = myByLo(myThid), myByHi(myThid)
           DO bi = myBxLo(myThid), myBxHi(myThid)
             CALL DIAGNOSTICS_GET_DIAG( 1, undefRL,
     O                     qtmpsrf(1-OLx,1-OLy,bi,bj),
     I                     jpoint1,0,ipoint1,0, bi,bj,myThid )
c            WRITE(0,*) 'rSurf:',bi,bj,qtmpsrf(15,15,bi,bj)
             CALL DIAGNOSTICS_GET_DIAG( 0, undefRL,
     O                     qtmp2(1-OLx,1-OLy,1,bi,bj),
     I                     jpoint2,0,ipoint2,0, bi,bj,myThid )
           ENDDO
          ENDDO

        ELSE
C-    If nonlinear free surf is off, get pressures from rC and rF arrays

          DO bj = myByLo(myThid), myByHi(myThid)
           DO bi = myBxLo(myThid), myBxHi(myThid)
            DO j = 1-OLy,sNy+OLy
             DO i = 1-OLx,sNx+OLx
               qtmpsrf(i,j,bi,bj) = Ro_surf(i,j,bi,bj)
             ENDDO
            ENDDO
            DO k = 1,kdiag(ndId)
             DO j = 1-OLy,sNy+OLy
              DO i = 1-OLx,sNx+OLx
               qtmp2(i,j,k,bi,bj) = rC(k)
              ENDDO
             ENDDO
            ENDDO
           ENDDO
          ENDDO

C-    end if nonlinear/linear free-surf
        ENDIF

C--   start loops on tile indices bi,bj:
        DO bj = myByLo(myThid), myByHi(myThid)
         DO bi = myBxLo(myThid), myBxHi(myThid)
C-    Load p to the kappa into a temporary array
           DO j = 1,sNy
            DO i = 1,sNx
              pksrf(i,j)    = qtmpsrf(i,j,bi,bj)**kappa
            ENDDO
           ENDDO
           IF ( useFIZHI.AND.gdiag(ndId)(10:10).EQ.'L') THEN
            pInc = .TRUE.
            DO k = 1,kdiag(ndId)
             DO j = 1,sNy
              DO i = 1,sNx
                qinp(i,j,k) = qtmp1(i,j,k,bi,bj)
                pkz(i,j,k)  = qtmp2(i,j,k,bi,bj)**kappa
              ENDDO
             ENDDO
            ENDDO
           ELSE
            DO k = 1,kdiag(ndId)
             pInc = .TRUE.
             kLev = kdiag(ndId)-k+1
c            pInc = .FALSE.
c            kLev = k
             DO j = 1,sNy
              DO i = 1,sNx
                IF (maskC(i,j,kLev,bi,bj).NE.0.) THEN
                 qinp(i,j,k)= qtmp1(i,j,kLev,bi,bj)
                ELSE
                 qinp(i,j,k)= undefRL
                ENDIF
                pkz(i,j,k)  = qtmp2(i,j,kLev,bi,bj)**kappa
              ENDDO
             ENDDO
            ENDDO
           ENDIF

C-    Interpolate, level per level, and put interpolated field in qprs:
           DO k = 1,nlevels(listId)
             pk = levs(k,listId)**kappa
             CALL DIAGNOSTICS_INTERP_P2P(
     O                        qprs,
     I                        qinp,pkz,pksrf,pkTop,pk,
     I                        undefRL,pInc,sNx*sNy,kdiag(ndId),myThid )
C-    Transfert qprs to qtmp1:
             DO j = 1,sNy
              DO i = 1,sNx
               IF (qprs(i,j).EQ.undefRL) THEN
                 qtmp1(i,j,k,bi,bj) = 0.
               ELSE
                 qtmp1(i,j,k,bi,bj) =  qprs(i,j)
               ENDIF
              ENDDO
             ENDDO
           ENDDO

C-   end bi,bj loops
         ENDDO
        ENDDO

      ENDIF

      RETURN
      END

#include "SHELFICE_OPTIONS.h"
#ifdef ALLOW_STREAMICE
# include "STREAMICE_OPTIONS.h"
#endif

C--   File shelfice_step_icemass.F:
C--    Contents:
C--    o SHELFICE_STEP_ICEMASS
C--    o SHELFICE_NETMASSFLUX_SURF

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C !ROUTINE: SHELFICE_STEP_ICEMASS

C !INTERFACE: ==========================================================
      SUBROUTINE SHELFICE_STEP_ICEMASS(
     I                        myTime, myIter, myThid )

C !DESCRIPTION:
C Serves as a "stub" for ice dynamics
C will later be used to

C !USES: ===============================================================
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "SHELFICE.h"
#ifdef ALLOW_STREAMICE
# include "STREAMICE.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     myTime      :: current time in simulation
C     myIter      :: current iteration number insimulation
C     myThid      :: my thread Id number
      _RL  myTime
      INTEGER myIter
      INTEGER myThid
CEOP

#ifdef ALLOW_SHELFICE
C !LOCAL VARIABLES : ====================================================
C     i,j, bi,bj  :: loop indices
      INTEGER bi,bj,i,j

      IF ( SHELFICEMassStepping ) THEN

       IF (useStreamIce) THEN

#ifdef ALLOW_STREAMICE
        DO bj = myByLo(myThid), myByHi(myThid)
         DO bi = myBxLo(myThid), myBxHi(myThid)
          DO j=1-OLy,sNy+OLy-1
           DO i=1-OLx+1,sNx+OLx-1
            IF ( streamice_hmask(i,j,bi,bj).EQ.1 .OR.
     &           streamice_hmask(i,j,bi,bj).EQ.2 ) THEN
             shelficeMass(i,j,bi,bj) =
     &        H_streamice(i,j,bi,bj) * streamice_density
            ENDIF
           ENDDO
          ENDDO
         ENDDO
        ENDDO
#endif /* ALLOW_STREAMICE */

       ELSE

        DO bj = myByLo(myThid), myByHi(myThid)
         DO bi = myBxLo(myThid), myBxHi(myThid)

           IF ( .NOT.SHELFICEDynMassOnly ) THEN
            DO j=1-OLy,sNy+OLy
             DO i=1-OLx,sNx+OLx
              shelficeMass(i,j,bi,bj) = shelficeMass(i,j,bi,bj)
     &              + shelfIceFreshWaterFlux(i,j,bi,bj)*deltaT
             ENDDO
            ENDDO
           ENDIF

           DO j=1-OLy,sNy+OLy
            DO i=1-OLx,sNx+OLx
              shelficeMass(i,j,bi,bj) = shelficeMass(i,j,bi,bj)
     &              + shelfIceMassDynTendency(i,j,bi,bj)*deltaT
            ENDDO
           ENDDO

C--    quick fix to prevent ice-shelf mass to become negative
           DO j=1-OLy,sNy+OLy
            DO i=1-OLx,sNx+OLx
              shelficeMass(i,j,bi,bj) =
     &              MAX( shelficeMass(i,j,bi,bj), zeroRL )
            ENDDO
           ENDDO

         ENDDO
        ENDDO
       ENDIF

       _EXCH_XY_RL( shelficeMass, myThid )

#ifndef ALLOW_OPENAD
C--  Calculate new loading anomaly (in case the ice-shelf mass was updated)
       DO bj = myByLo(myThid), myByHi(myThid)
        DO bi = myBxLo(myThid), myBxHi(myThid)
         DO j = 1-OLy, sNy+OLy
          DO i = 1-OLx, sNx+OLx
           shelficeLoadAnomaly(i,j,bi,bj) = gravity
     &      *( shelficeMass(i,j,bi,bj) + rhoConst*Ro_surf(i,j,bi,bj) )
          ENDDO
         ENDDO
        ENDDO
       ENDDO
#endif

      ENDIF

#ifdef ALLOW_DIAGNOSTICS
      IF (useDiagnostics) THEN
        CALL DIAGNOSTICS_FILL( shelficeMass, 'SHI_mass',
     I                         0, 1, 0, 1, 1, myThid )
      ENDIF
#endif /* ALLOW_DIAGNOSTICS */
#endif /* ALLOW_SHELFICE */

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C !ROUTINE: SHELFICE_NETMASSFLUX_SURF

C !INTERFACE: ==========================================================
      SUBROUTINE SHELFICE_NETMASSFLUX_SURF(
     O                        shelfIceNetMassFlux,
     I                        myTime, myIter, myThid )

C !DESCRIPTION:
C compute the net mass flux implied by S/R SHELFICE_STEP_MASS

C !USES: ===============================================================
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "SHELFICE.h"
#ifdef ALLOW_STREAMICE
# include "STREAMICE.h"
#endif
#include "DYNVARS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     myTime      :: current time in simulation
C     myIter      :: current iteration number insimulation
C     myThid      :: my thread Id number
      _RL  myTime
      INTEGER myIter
      INTEGER myThid
C     net mass flux in m^3/s
      _RL shelfIceNetMassFlux
CEOP

#ifdef ALLOW_SHELFICE
C !LOCAL VARIABLES : ====================================================
C     i,j, bi,bj  :: loop indices
      INTEGER bi,bj,i,j
      _RL shelfIceNetMassFluxTile(nSx,nSy)

      shelfIceNetMassFlux = 0. _d 0

      IF ( SHELFICEMassStepping ) THEN

       IF (useStreamIce) THEN

#ifdef ALLOW_STREAMICE
        DO bj = myByLo(myThid), myByHi(myThid)
         DO bi = myBxLo(myThid), myBxHi(myThid)
          shelfIceNetMassFluxTile(bi,bj) = 0. _d 0
          DO j=1,sNy
           DO i=1,sNx
            IF ( streamice_hmask(i,j,bi,bj).EQ.1 .OR.
     &           streamice_hmask(i,j,bi,bj).EQ.2 ) THEN
C--   this assumes that the change in H_streamice include the melting flux
CML             shelfIceNetMassFluxTile(bi,bj) =
CML     &              shelfIceNetMassFluxTile(bi,bj)
CML     &            +(H_streamice(i,j,bi,bj)-H_streamice_prev(i,j,bi,bj))
CML     &            /deltaT * streamice_density * mass2rUnit
CML     &            * _rA(i,j,bi,bj) * maskInC(i,j,bi,bj)
            ENDIF
           ENDDO
          ENDDO
         ENDDO
        ENDDO
#endif /* ALLOW_STREAMICE */

       ELSE

        DO bj = myByLo(myThid), myByHi(myThid)
         DO bi = myBxLo(myThid), myBxHi(myThid)
          shelfIceNetMassFluxTile(bi,bj) = 0. _d 0
          DO j=1,sNy
           DO i=1,sNx
C--   Flux of new ice will raise the sea level
            shelfIceNetMassFluxTile(bi,bj) =
     &             shelfIceNetMassFluxTile(bi,bj)
     &           + shelfIceMassDynTendency(i,j,bi,bj)
     &           * _rA(i,j,bi,bj) * maskInC(i,j,bi,bj)
            IF ( .NOT.SHELFICEDynMassOnly ) THEN
C--   Freshwater flux by thermodynamic processes. In the case of
C     melting this will be negative (positive upward) so it will reduce
C     the amount of added ice mass. The same freshwater flux is added
C     to the ocean in EmPmR and will raise the sea level, so that this
C     contribution is canceled.
             shelfIceNetMassFluxTile(bi,bj) =
     &              shelfIceNetMassFluxTile(bi,bj)
     &            + shelfIceFreshWaterFlux(i,j,bi,bj)
     &            * _rA(i,j,bi,bj) * maskInC(i,j,bi,bj)
            ENDIF
           ENDDO
          ENDDO
         ENDDO
        ENDDO

       ENDIF

       CALL GLOBAL_SUM_TILE_RL( shelficeNetMassFluxTile,
     &      shelficeNetMassFlux, myThid )

      ENDIF

#endif /* ALLOW_SHELFICE */

      RETURN
      END

#include "MNC_OPTIONS.h"
      
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 0
C     !ROUTINE: MNC_DIM_INIT

C     !INTERFACE:
      SUBROUTINE MNC_DIM_INIT( 
     I     fname, 
     I     dname, 
     I     dlen, 
     I     myThid )

C     !DESCRIPTION:
C     Create a dimension within the MNC look-up tables.

C     !INPUT PARAMETERS:
      integer myThid, dlen
      character*(*) fname, dname
CEOP

      CALL MNC_DIM_INIT_ALL(fname, dname, dlen, 'Y', myThid)

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 1
C     !ROUTINE: MNC_DIM_INIT_ALL

C     !INTERFACE:
      SUBROUTINE MNC_DIM_INIT_ALL( 
     I     fname, 
     I     dname, 
     I     dlen, 
     I     doWrite, 
     I     myThid ) 

C     !DESCRIPTION:
C     Create a dimension within the MNC look-up tables.

C     !USES:
      implicit none

C     !INPUT PARAMETERS:
      integer myThid, dlen
      character*(*) fname, dname
      character*(1) doWrite
CEOP

      CALL MNC_DIM_INIT_ALL_CV(fname,dname,dlen,doWrite,-1,-1,myThid)
      
      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 1
C     !ROUTINE: MNC_DIM_INIT_ALL_CV

C     !INTERFACE:
      SUBROUTINE MNC_DIM_INIT_ALL_CV( 
     I     fname, 
     I     dname, 
     I     dlen, 
     I     doWrite, 
     I     bi,bj,
     I     myThid ) 

C     !DESCRIPTION:
C     Create a dimension within the MNC look-up tables.

C     !USES:
      implicit none
#include "MNC_COMMON.h"
#include "EEPARAMS.h"
#include "netcdf.inc"

C     !INPUT PARAMETERS:
      integer myThid, dlen, bi,bj
      character*(*) fname, dname
      character*(1) doWrite
CEOP

C     !LOCAL VARIABLES:
      integer i,j, indf,indd, n,nf, dnf,dnl
      integer ntmp, idd, err, tlen
      character*(MAX_LEN_MBUF) msgbuf

C     Functions
      integer ILNBLNK, IFNBLNK

      nf = ILNBLNK(fname)

      dnf = IFNBLNK(dname)
      dnl = ILNBLNK(dname)

C     Verify that the file exists
      CALL MNC_GET_IND(MNC_MAX_FID, fname, mnc_f_names, indf, myThid)
      IF ( indf .LT. 1 ) THEN
        write(msgbuf,'(3a)') 'MNC ERROR: file ''', fname(1:nf),
     &       ''' does not exist'
        CALL print_error( msgbuf, mythid )
        stop 'ABNORMAL END: S/R MNC_DIM_INIT'
      ENDIF

C     Verify that the dim is not currently defined within the file
      n = mnc_f_alld(indf,1)
      DO i = 1,n
        j = mnc_f_alld(indf,i+1)
        ntmp = ILNBLNK(mnc_d_names(j))
        IF ((ntmp .EQ. (dnl-dnf+1)) 
     &       .AND. (dname(dnf:dnl) .EQ. mnc_d_names(j)(1:ntmp))) THEN
          IF (mnc_d_size(j) .NE. dlen) THEN
            IF ((mnc_d_size(j) .GT. 0) .OR. (dlen .GT. 0)) THEN
              write(msgbuf,'(5a)') 'MNC ERROR: dimension ''', 
     &             dname(dnf:dnl), ''' already exists within file ''', 
     &             fname(1:nf), ''' and its size cannot be changed'
              CALL print_error(msgbuf, mythid)
              stop 'ABNORMAL END: S/R MNC_DIM_INIT'
            ELSE
C             Its OK, the names are the same and both are specifying the
C             unlimited dimension
              RETURN
            ENDIF
          ELSE
C           Its OK, the names and sizes are identical
            RETURN
          ENDIF
        ENDIF
      ENDDO

      CALL MNC_GET_NEXT_EMPTY_IND(MNC_MAX_ID, mnc_d_names, 
     &     'mnc_d_names', indd, myThid)

C     Create the dim within the file
      IF (doWrite(1:1) .EQ. 'Y') THEN

        tlen = dlen
        IF (dlen .LT. 1)  tlen = NF_UNLIMITED

        CALL MNC_FILE_REDEF(fname, myThid)
        err = NF_DEF_DIM(mnc_f_info(indf,2), dname(dnf:dnl), tlen, idd)
        write(msgbuf,'(5a)') 'MNC_DIM_INIT ERROR: cannot create ',
     &       'dim ''', dname(dnf:dnl), ''' in file ''', fname(1:nf)
        CALL MNC_HANDLE_ERR(err, msgbuf, myThid)

C       Create and write the associated CF-convention
C       coordinate variable
        IF (bi .GT. -1) THEN
          CALL MNC_CW_WRITE_CVAR(fname, dname(dnf:dnl), 
     &         mnc_f_info(indf,2), idd, bi, bj, myThid)
        ENDIF

      ENDIF

C     Add to tables
      mnc_d_names(indd)(1:(dnl-dnf+1)) = dname(dnf:dnl)
      mnc_d_size(indd) = dlen
      mnc_d_ids(indd) = idd
      mnc_f_alld(indf,1) = n + 1
      mnc_f_alld(indf,n+2) = indd

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 1
C     !ROUTINE: MNC_DIM_UNLIM_SIZE

C     !INTERFACE:
      SUBROUTINE MNC_DIM_UNLIM_SIZE( 
     I     fname, 
     I     unlim_sz, 
     I     myThid )

C     !DESCRIPTION:
C     Get the size of the unlimited dimension.
      
C     !USES:
      implicit none
#include "MNC_COMMON.h"
#include "EEPARAMS.h"
#include "netcdf.inc"

C     !INPUT PARAMETERS:
      integer myThid, unlim_sz
      character*(*) fname
CEOP

C     !LOCAL VARIABLES:
      integer i,j, nf, indf, fid, unlimid, err
      character*(MAX_LEN_MBUF) msgbuf

C     Functions
      integer ILNBLNK

      nf = ILNBLNK(fname)

C     Verify that the file exists
      CALL MNC_GET_IND(MNC_MAX_FID, fname, mnc_f_names, indf, myThid)
      IF (indf .LT. 1) THEN
        write(msgbuf,'(3a)') 'MNC ERROR: file ''', fname(1:nf),
     &       ''' does not exist'
        CALL print_error(msgbuf, mythid)
        stop 'ABNORMAL END: S/R MNC_DIM_UNLIM_SIZE'
      ENDIF
      fid = mnc_f_info(indf,2)

C     Find the unlimited dim and its current size
      unlim_sz = -1
      DO i = 1,mnc_f_alld(indf,1)
        j = mnc_f_alld(indf,i+1)
        IF (mnc_d_size(j) .EQ. -1) THEN
          unlimid = mnc_d_ids(j)
          err = NF_INQ_DIMLEN(fid, unlimid, unlim_sz)
          write(msgbuf,'(3a)') 'MNC_DIM_UNLIM_SIZE ERROR: cannot ',
     &         'determine unlimited dim size in file ''', fname(1:nf)
          CALL MNC_HANDLE_ERR(err, msgbuf, myThid)
          RETURN
        ENDIF
      ENDDO

      RETURN
      END


C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#include "GGL90_OPTIONS.h"

      SUBROUTINE GGL90_CHECK( myThid )
C     *==========================================================*
C     | SUBROUTINE GGL90_CHECK                                   |
C     | o Validate basic package setup and inter-package         |
C     | dependencies.                                            |
C     *==========================================================*
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GGL90.h"
#ifdef ALLOW_AUTODIFF
# include "AUTODIFF_PARAMS.h"
#endif

C     === Routine arguments ===
C     myThid   :: Number of this instance of GGL90_CHECK
      INTEGER myThid

#ifdef ALLOW_GGL90

C     === Local variables ===
C     errCount :: error counter
C     msgBuf   :: Informational/error message buffer
      INTEGER errCount
      CHARACTER*(MAX_LEN_MBUF) msgBuf

      _BEGIN_MASTER(myThid)
      errCount = 0

      WRITE(msgBuf,'(A)') 'GGL90_CHECK: #define ALLOW_GGL90'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )

C     Convective adjustment might be needed even with ggl90
      IF ( cAdjFreq.NE.0. .OR. ivdc_kappa.NE.0. ) THEN
         WRITE(msgBuf,'(A)')
     &  'GGL90_CHECK: Some form of convection has been enabled'
         CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                       SQUEEZE_RIGHT, myThid )
      ENDIF

#ifdef ALLOW_GGL90_HORIZDIFF
#ifdef ALLOW_GGL90_SMOOTH
      IF ( GGL90diffTKEh .NE. 0. _d 0 ) THEN
         WRITE(msgBuf,'(A)')
     &      'Horizontal diffusion of TKE and smoothing are both on'
         CALL PRINT_ERROR( msgBuf, myThid )
         errCount = errCount + 1
      ENDIF
#endif
#else
      IF ( GGL90diffTKEh .NE. 0. _d 0 ) THEN
         WRITE(msgBuf,'(2A)')
     &      'Define ALLOW_GGL90_HORIZDIFF in GGL90_OPTIONS.h',
     &      ' to get diffusion of TKE'
         CALL PRINT_ERROR( msgBuf, myThid )
         errCount = errCount + 1
      ENDIF
#endif
#ifndef ALLOW_GGL90_LANGMUIR
      IF (useLANGMUIR ) THEN
         WRITE(msgBuf,'(2A)')
     &      'Define ALLOW_GGL90_LANGMUIR in GGL90_OPTIONS.h',
     &      ' to use Langmuir Parameterization'
         CALL PRINT_ERROR( msgBuf, myThid )
         errCount = errCount + 1
      ENDIF
#endif

C     GGL90 needs implicit vertical diffusion and viscosity
      IF (.NOT.implicitDiffusion ) THEN
         WRITE(msgBuf,'(A)')
     &      'GGL90 needs implicitDiffusion to be enabled'
         CALL PRINT_ERROR( msgBuf, myThid )
         errCount = errCount + 1
      ENDIF
      IF (.NOT.implicitViscosity) THEN
         WRITE(msgBuf,'(A)')
     &      'GGL90 needs implicitViscosity to be enabled'
         CALL PRINT_ERROR( msgBuf, myThid )
         errCount = errCount + 1
      ENDIF

C     Limitation of Langmuir Parameterization implementation:
      IF ( useLANGMUIR .AND. useAbsVorticity ) THEN
         WRITE(msgBuf,'(2A)') 'GGL90_CHECK: ',
     &      'with useAbsVorticity, missing Coriolis'
         CALL PRINT_ERROR( msgBuf, myThid )
         WRITE(msgBuf,'(2A)') 'GGL90_CHECK: ',
     &      ' contrib from Langmuir Parameterization'
         CALL PRINT_ERROR( msgBuf, myThid )
         errCount = errCount + 1
      ENDIF
      IF ( useLANGMUIR .AND. useCDscheme ) THEN
         WRITE(msgBuf,'(2A)') 'GGL90_CHECK: ',
     &      'with useCDscheme, missing Coriolis'
         CALL PRINT_ERROR( msgBuf, myThid )
         WRITE(msgBuf,'(2A)') 'GGL90_CHECK: ',
     &      ' contrib from Langmuir Parameterization'
         CALL PRINT_ERROR( msgBuf, myThid )
         errCount = errCount + 1
      ENDIF

C     Compatibility with the use of other pkgs:
      IF ( useKPP ) THEN
         WRITE(msgBuf,'(A)')
     &      'GGL90 and KPP cannot be turned on at the same time'
         CALL PRINT_ERROR( msgBuf, myThid )
         errCount = errCount + 1
      ENDIF

      IF ( usePP81 ) THEN
         WRITE(msgBuf,'(A)')
     &      'GGL90 and PP81 cannot be turned on at the same time'
         CALL PRINT_ERROR( msgBuf, myThid )
         errCount = errCount + 1
      ENDIF

      IF ( useMY82 ) THEN
         WRITE(msgBuf,'(A)')
     &      'GGL90 and MY82 cannot be turned on at the same time'
         CALL PRINT_ERROR( msgBuf, myThid )
         errCount = errCount + 1
      ENDIF

#ifdef ALLOW_AUTODIFF
C     Not everything works stably with AD code
      IF ( useGGL90inAdMode .AND. adMxlMaxFlag .GT. 1 ) THEN
       WRITE(msgBuf,'(2A,L1,A,I2,A)') '** WARNING ** GGL90_CHECK: ',
     &      'useGGL90inAdMode = ', useGGL90inAdMode,
     &      ' with adMxlMaxFlag =', adMxlMaxFlag, ' (> 1)'
       CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                     SQUEEZE_RIGHT, myThid )
       WRITE(msgBuf,'(2A)') '** WARNING ** GGL90_CHECK: ',
     &      'tends to be unstable, use (ad)mxlMaxFlag = 0 or 1.'
       CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                     SQUEEZE_RIGHT, myThid )
      ENDIF
      IF ( useGGL90inAdMode .AND. adMxlMaxFlag .NE. mxlMaxFlag ) THEN
       WRITE(msgBuf,'(2A,I2,A)') '** WARNING ** GGL90_CHECK: ',
     &      'In AD-mode only, using adMxlMaxFlag =', adMxlMaxFlag,
     &      ' (instead of mxlMaxFlag).'
       CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                     SQUEEZE_RIGHT, myThid )
      ENDIF
#endif

C-    Stop cleanly when error was detected
      IF ( errCount.GE.1 ) THEN
         WRITE(msgBuf,'(A,I3,A)')
     &       'GGL90_CHECK: detected', errCount,' fatal error(s)'
         CALL PRINT_ERROR( msgBuf, myThid )
         CALL ALL_PROC_DIE( 0 )
         STOP 'ABNORMAL END: S/R GGL90_CHECK'
      ENDIF
      _END_MASTER(myThid)

#endif /* ALLOW_GGL90 */

      RETURN
      END

#include "AIM_OPTIONS.h"

CBOP
C     !ROUTINE: AIM_MNC_INIT

C     !INTERFACE:
      SUBROUTINE AIM_MNC_INIT( myThid )

C     !DESCRIPTION:
C     Initialize MNC variables for AIM.

C     !USES:
      IMPLICIT NONE
#include "AIM_SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "AIM_PARAMS.h"
#ifdef ALLOW_MNC
#include "MNC_SIZE.h"
#include "MNC_PARAMS.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
      INTEGER myThid
CEOP

#ifdef ALLOW_MNC
C     == Local variables ==
      INTEGER i,j, ndim
      INTEGER CW_MAX_LOC
      PARAMETER ( CW_MAX_LOC = 6 )
      CHARACTER*(MNC_MAX_CHAR) dn(CW_MAX_LOC)
      INTEGER dim(CW_MAX_LOC), ib(CW_MAX_LOC), ie(CW_MAX_LOC)

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C     Non-halo-ed variables
      DO i = 1,CW_MAX_LOC
        DO j = 1,MNC_MAX_CHAR
          dn(i)(j:j) = ' '
        ENDDO
        dim(i) = 0
        ib(i) = 0
        ie(i) = 0
      ENDDO

      ndim = 1
      dn(ndim)(1:1) = 'X'
      dim(ndim) = sNx
      ib(ndim)  = 1
      ie(ndim)  = sNx
      ndim = ndim + 1
      dn(ndim)(1:1) = 'Y'
      dim(ndim) = sNy
      ib(ndim)  = 1
      ie(ndim)  = sNy
      ndim = ndim + 1
      dn(ndim)(1:1) = 'T'
      dim(ndim) = -1
      ib(ndim)  = 1
      ie(ndim)  = 1
      CALL MNC_CW_ADD_GNAME('AIM_xyt',  ndim, dim,dn,ib,ie, myThid)
      ndim = 3
      dn(ndim)(1:4) = 'Zaim'
      dim(ndim) = NLEV
      ib(ndim)  = 1
      ie(ndim)  = NLEV
      ndim = ndim + 1
      dn(ndim)(1:1) = 'T'
      dim(ndim) = -1
      ib(ndim)  = 1
      ie(ndim)  = 1
      CALL MNC_CW_ADD_GNAME('AIM_xyzt', ndim, dim,dn,ib,ie, myThid)

      CALL MNC_CW_ADD_VNAME('aim_DRAG0','AIM_xyt',0,0,myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('aim_DRAG0','units','---',myThid)

      CALL MNC_CW_ADD_VNAME('aim_SPEED0','AIM_xyt',0,0,myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('aim_SPEED0','units','---',myThid)

      CALL MNC_CW_ADD_VNAME('aim_TSR','AIM_xyt',0,0,myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('aim_TSR','units','---',myThid)

      CALL MNC_CW_ADD_VNAME('aim_OLR','AIM_xyt',0,0,myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('aim_OLR','units','---',myThid)

      CALL MNC_CW_ADD_VNAME('aim_SSR0','AIM_xyt',0,0,myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('aim_SSR0','units','---',myThid)

      CALL MNC_CW_ADD_VNAME('aim_SLR0','AIM_xyt',0,0,myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('aim_SLR0','units','---',myThid)

      CALL MNC_CW_ADD_VNAME('aim_SHF0','AIM_xyt',0,0,myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('aim_SHF0','units','---',myThid)

      CALL MNC_CW_ADD_VNAME('aim_EVAP0','AIM_xyt',0,0,myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('aim_EVAP0','units','---',myThid)

      CALL MNC_CW_ADD_VNAME('aim_PRECNV','AIM_xyt',0,0,myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('aim_PRECNV','units','---',myThid)

      CALL MNC_CW_ADD_VNAME('aim_PRECLS','AIM_xyt',0,0,myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('aim_PRECLS','units','---',myThid)

      CALL MNC_CW_ADD_VNAME('aim_CLOUDC','AIM_xyt',0,0,myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('aim_CLOUDC','units','---',myThid)

      CALL MNC_CW_ADD_VNAME('aim_CLTOP','AIM_xyt',0,0,myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('aim_CLTOP','units','---',myThid)

      CALL MNC_CW_ADD_VNAME('aim_CBMF','AIM_xyt',0,0,myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('aim_CBMF','units','---',myThid)

      CALL MNC_CW_ADD_VNAME('aim_T0','AIM_xyt',0,0,myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('aim_T0','units','---',myThid)

      CALL MNC_CW_ADD_VNAME('aim_Q0','AIM_xyt',0,0,myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('aim_Q0','units','---',myThid)

      CALL MNC_CW_ADD_VNAME('aim_EnPrec','AIM_xyt',0,0,myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('aim_EnPrec','units','J/g',myThid)

      CALL MNC_CW_ADD_VNAME('aim_alb10','AIM_xyt',0,0,myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('aim_alb10','units','---',myThid)

      CALL MNC_CW_ADD_VNAME('aim_dTsurf1','AIM_xyt',0,0,myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('aim_dTsurf1','units','---',myThid)

      CALL MNC_CW_ADD_VNAME('aim_TSWclr','AIM_xyt',0,0,myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('aim_TSWclr','units','---',myThid)

      CALL MNC_CW_ADD_VNAME('aim_OLWclr','AIM_xyt',0,0,myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('aim_OLWclr','units','---',myThid)

      CALL MNC_CW_ADD_VNAME('aim_SSWclr','AIM_xyt',0,0,myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('aim_SSWclr','units','---',myThid)

      CALL MNC_CW_ADD_VNAME('aim_SLWclr','AIM_xyt',0,0,myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('aim_SLWclr','units','---',myThid)

#endif /* ALLOW_MNC */

      RETURN
      END

#include "CPP_OPTIONS.h"
CBOP
C     !ROUTINE: CALC_IVDC
C     !INTERFACE:
      SUBROUTINE CALC_IVDC( 
     I       bi, bj, iMin, iMax, jMin, jMax, K,
     I       sigmaR,
     I       myTime,myIter, myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE CALC_IVDC                                      
C     | o Calculates Implicit Vertical Diffusivity for Convection 
C     \==========================================================*
C     \ev
C     !USES:
      IMPLICIT NONE
C     == Global data ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "DYNVARS.h"
#include "GRID.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     bi,bj,iMin,iMax,jMin,jMax,K :: Loop counters
C     rhoKm1 :: rho in layer above
C     rhoKp1 :: rho in layer below
C     myTime :: Current time in simulation
C     myIter :: Current iteration in simulation
C     myThid :: Thread number of this instance of S/R CALC_IVDC
      INTEGER bi,bj,iMin,iMax,jMin,jMax,K
      _RL sigmaR(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL myTime
      INTEGER myIter
      INTEGER myThid

C     !LOCAL VARIABLES:
C     == Local variables ==
C     i,j :: Loop counters
      INTEGER i,j
CEOP

C--    Where statically unstable, mix the heat and salt
       DO j=jMin,jmax
        DO i=iMin,imax
         IF ( -sigmaR(i,j,k)*gravitySign.GT.0. ) THEN
          IVDConvCount(i,j,k,bi,bj) = 1. _d 0
         ELSE
          IVDConvCount(i,j,k,bi,bj) = 0. _d 0
         ENDIF
        ENDDO
       ENDDO
       
      RETURN
      END

#include "ATM_CPL_OPTIONS.h"

CBOP
C     !ROUTINE: ATM_STORE_THSICE
C     !INTERFACE:
      SUBROUTINE ATM_STORE_THSICE(
     I                     bi, bj,
     I                     myTime, myIter, myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE ATM_STORE_THSICE
C     | o Routine for saving Sea-Ice fields from thSIce pkg
C     |   for export to coupling layer.
C     *==========================================================*
C     | This version interfaces to the THSICE package.
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     == Global variables ==
#include "SIZE.h"

#include "EEPARAMS.h"
#include "PARAMS.h"
#include "CPL_PARAMS.h"
#ifdef ALLOW_THSICE
# include "THSICE_PARAMS.h"
# include "THSICE_VARS.h"
#endif
C     == Global variables for coupling interface ==
#include "ATMCPL.h"

C     !INPUT/OUTPUT PARAMETERS:
C     bi, bj  :: Tile indices
C     myTime :: Current model time
C     myIter :: Current timestep number
C     myThid :: my Thread Id number
      INTEGER bi, bj
      _RL     myTime
      INTEGER myIter
      INTEGER myThid
CEOP

#ifdef ALLOW_THSICE
C     !LOCAL VARIABLES:
C     i, j   :: Loop counters
      INTEGER i,j

      IF ( atm_cplExch1W_sIce ) THEN
C     o Accumulate Sea-Ice Mass from thSIce pkg that will be exported
C       to the coupling layer. seaIceMass is per surface unit, in kg/m2.
c      cplTimeFraction = 1. _d 0 / DFLOAT(cplSendFrq_iter)
c      sIceMassTime(bi,bj) = sIceMassTime(bi,bj) + cplTimeFraction
C-     Needs really to store the last time-step value and not the average
        sIceMassTime(bi,bj) = 1. _d 0
        DO j=1,sNy
         DO i=1,sNx
c          seaIceMass(i,j,bi,bj) = seaIceMass(i,j,bi,bj) + cplTimeFraction*
           seaIceMass(i,j,bi,bj) =
     &                   ( snowHeight(i,j,bi,bj)*rhos
     &                    + iceHeight(i,j,bi,bj)*rhoi
     &                   )*iceMask(i,j,bi,bj)
         ENDDO
        ENDDO
      ENDIF

      IF ( ( atm_cplExch1W_sIce.AND.atm_cplExch_DIC )
     &  .OR. atm_cplExch2W_sIce ) THEN
C     o Store Sea-Ice concentration (no-units) from thSIce pkg
C       that will be exported to the coupling layer.
        sIceFracTime(bi,bj) = 1. _d 0
        DO j=1,sNy
         DO i=1,sNx
           sIceFrac_cpl(i,j,bi,bj) = iceMask(i,j,bi,bj)
         ENDDO
        ENDDO
      ENDIF

      IF ( atm_cplExch2W_sIce ) THEN
C     o Store other thSIce state-vars
C       that will be exported to the coupling layer.
        sIceThickTime(bi,bj) = 1. _d 0
        sIceSnowHTime(bi,bj) = 1. _d 0
        sIceQ1Time   (bi,bj) = 1. _d 0
        sIceQ2Time   (bi,bj) = 1. _d 0
        DO j=1,sNy
         DO i=1,sNx
           sIceThick_cpl(i,j,bi,bj) = iceHeight(i,j,bi,bj)
           sIceSnowH_cpl(i,j,bi,bj) = snowHeight(i,j,bi,bj)
           sIceQ1_cpl   (i,j,bi,bj) = Qice1(i,j,bi,bj)
           sIceQ2_cpl   (i,j,bi,bj) = Qice2(i,j,bi,bj)
         ENDDO
        ENDDO
      ENDIF

#endif /* ALLOW_THSICE */

      RETURN
      END

#include "CPP_OPTIONS.h"

CBOP
C     !ROUTINE: INI_VEL
C     !INTERFACE:
      SUBROUTINE INI_VEL( myThid )

C     !DESCRIPTION: \bv
C     *=================================================================
C     | SUBROUTINE INI_VEL
C     | o Initialize flow field (either to zero or from input files)
C     *=================================================================
C     \ev

C     !USES:
      IMPLICIT NONE
C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "DYNVARS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     myThid :: my Thread Id number
      INTEGER myThid

C     !LOCAL VARIABLES:
C     i,j,k  :: Loop counters
C     bi,bj  :: tile indices
      INTEGER i, j, k
      INTEGER bi, bj
      INTEGER ip1, jp1
      _RL psi, omegaprime, fac
CEOP

C     internal function:
      psi(i,j,bi,bj) = fac*fCoriG(i,j,bi,bj)

C--   Initialise velocity fields to zero
C
C     If you want to specify an analytic initial state for the flow
C     field then customize the following section of code.
C     It is, however, often easier to generate initial conditions
C     off-line and read them from input files...
C
C     this relative rotation corresponds to a 5.day rotation period:
      omegaprime = 80. _d 0 / rSphere
      fac = -(rSphere*rSphere)*omegaprime/(2. _d 0*Omega)
      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
        DO k=1,Nr
         DO j=1-OLy,sNy+OLy
          jp1 = MIN(j+1,sNy+OLy)
          DO i=1-OLx,sNx+OLx
           ip1 = MIN(i+1,sNx+OLx)
           uVel(i,j,k,bi,bj) = 0. _d 0
     &      + (psi(i,j,bi,bj)-psi(i,jp1,bi,bj))*recip_dyG(i,j,bi,bj)
           vVel(i,j,k,bi,bj) = 0. _d 0
     &      + (psi(ip1,j,bi,bj)-psi(i,j,bi,bj))*recip_dxG(i,j,bi,bj)
          ENDDO
         ENDDO
        ENDDO
       ENDDO
      ENDDO

c     IF ( uVelInitFile .NE. ' ' .OR. vVelInitFile .NE. ' ' ) THEN
C     Read an initial state for each component if required
       IF ( uVelInitFile .NE. ' ' )
     & CALL READ_FLD_XYZ_RL( uVelInitFile, ' ', uVel, 0, myThid )

       IF ( vVelInitFile .NE. ' ' )
     & CALL READ_FLD_XYZ_RL( vVelInitFile, ' ', vVel, 0, myThid )

       CALL EXCH_UV_XYZ_RL(uVel,vVel,.TRUE.,myThid)
c     ENDIF

      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
        DO k=1,Nr
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           uVel(i,j,k,bi,bj) = uVel(i,j,k,bi,bj)*_maskW(i,j,k,bi,bj)
           vVel(i,j,k,bi,bj) = vVel(i,j,k,bi,bj)*_maskS(i,j,k,bi,bj)
          ENDDO
         ENDDO
        ENDDO
       ENDDO
      ENDDO

      RETURN
      END

#include "PTRACERS_OPTIONS.h"
#include "GAD_OPTIONS.h"

CBOP
C !ROUTINE: PTRACERS_FIELDS_BLOCKING_EXCH

C !INTERFACE: ==========================================================
      SUBROUTINE PTRACERS_FIELDS_BLOCKING_EXCH( myThid )

C !DESCRIPTION:
C     Exchange data to update overlaps for passive tracers

C !USES: ===============================================================
#include "PTRACERS_MOD.h"
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "PTRACERS_SIZE.h"
#include "PTRACERS_PARAMS.h"
#include "PTRACERS_START.h"
#include "PTRACERS_FIELDS.h"

C !INPUT PARAMETERS: ===================================================
C  myThid         :: thread number
      INTEGER myThid

C !OUTPUT PARAMETERS: ==================================================
C  none

#ifdef ALLOW_PTRACERS

C !LOCAL VARIABLES: ====================================================
C  iTracer        :: loop indices
C  bi, bj         :: tile indices
      INTEGER iTracer
#ifdef ALLOW_OBCS
c     INTEGER bi, bj
#endif /* ALLOW_OBCS */
CEOP

C Loop over passive tracers
      DO iTracer=1,PTRACERS_numInUse
       IF ( PTRACERS_StepFwd(iTracer) ) THEN

C Exchange overlaps
        CALL EXCH_3D_RL( pTracer(1-OLx,1-OLy,1,1,1,iTracer),
     &                   Nr, myThid )
#ifdef PTRACERS_ALLOW_DYN_STATE
        IF ( PTRACERS_SOM_Advection(iTracer) ) THEN
          CALL GAD_EXCH_SOM( _Ptracers_som(:,:,:,:,:,:,iTracer),
     &                       Nr, myThid )
        ENDIF
#endif /* PTRACERS_ALLOW_DYN_STATE */

C End of tracer loop
       ENDIF
      ENDDO

#endif /* ALLOW_PTRACERS */

      RETURN
      END

#include "CPP_OPTIONS.h"

CBOP
C     !ROUTINE: CPL_SEND_OCN_FIELDS
C     !INTERFACE:
      SUBROUTINE CPL_SEND_OCN_FIELDS( msgUnit, iter )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE CPL_SEND_OCN_FIELDS
C     | o Routine for sending surface flux to ocean component
C     *==========================================================*
C     | This version talks to the MITgcm general circulation
C     | model.
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     == Global variables ==
#include "CPL_PARAMS.h"
#include "ATMSIZE.h"
#include "ATMVARS.h"
#include "OCNSIZE.h"
#include "OCNVARS.h"
#include "OCNIDS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     msgUnit   :: log-file I/O unit
C     iter      :: current iteration number
      INTEGER msgUnit, iter

C     !LOCAL VARIABLES:
      _RL tmpFld(Nx_ocn,Ny_ocn)
CEOP

C--   Map Sea Level atmos. pressure onto ocean grid
      CALL ATM_TO_OCN_MAPXYR8(
     I         Nx_atm, Ny_atm, atmSLPr_atm, Nx_ocn, Ny_ocn,
     O                         atmSLPr_ocn )
C     Send Sea Level atmos. pressure to ocean component
      CALL COUPSEND_R8TILES( ocnCompName, ocnSLPrName,
     I                       Nx_ocn, Ny_ocn, atmSLPr_ocn )

C--   Map heatflux onto ocean grid
      CALL ATM_TO_OCN_MAPXYR8(
     I         Nx_atm, Ny_atm, HeatFlux_atm, Nx_ocn, Ny_ocn,
     O                         HeatFlux_ocn )
      IF ( cpl_exchange_RunOff.GE.2 ) THEN
C     Map Energy flux carried by RunOff onto ocean grid and substract it
C       from previous (direct) FWFlux => total Heat-Flux = Qnet - EnRunOff
        CALL ATM_TO_OCN_MAPRUNOFF(
     I           ROEnFx_atm,
     O           tmpFld,
     U           HeatFlux_ocn )
      ENDIF
C     Send (net) heatflux. to ocean component
      CALL COUPSEND_R8TILES( ocnCompName, ocnHeatFluxName,
     I                       Nx_ocn, Ny_ocn, HeatFlux_ocn )

C--   Map net shortwave radiation onto ocean grid
      CALL ATM_TO_OCN_MAPXYR8(
     I         Nx_atm, Ny_atm, qShortWave_atm, Nx_ocn, Ny_ocn,
     O                         qShortWave_ocn )
C     Send net shortwave radiation to ocean component
      CALL COUPSEND_R8TILES( ocnCompName, ocnQshortWaveName,
     I                       Nx_ocn, Ny_ocn, qShortWave_ocn )

C--   Map Zonal momentum flux onto ocean grid
      CALL ATM_TO_OCN_MAPXYR8(
     I         Nx_atm, Ny_atm, TauX_atm, Nx_ocn, Ny_ocn,
     O                         TauX_ocn )
C     Send Zonal momentum flux to ocean component
      CALL COUPSEND_R8TILES( ocnCompName, ocnTauXName,
     I                       Nx_ocn, Ny_ocn, TauX_ocn )

C--   Map Meridional momentum flux onto ocean grid
      CALL ATM_TO_OCN_MAPXYR8(
     I         Nx_atm, Ny_atm, TauY_atm, Nx_ocn, Ny_ocn,
     O                         TauY_ocn )
C     Send Meridional momentum flux to ocean component
      CALL COUPSEND_R8TILES( ocnCompName, ocnTauYName,
     I                       Nx_ocn, Ny_ocn, TauY_ocn )

C--   Map atmos. fresh water flux onto ocean grid : Evap - Precip
      CALL ATM_TO_OCN_MAPXYR8(
     I         Nx_atm, Ny_atm, EvMPr_atm, Nx_ocn, Ny_ocn,
     O                         FWFlux_ocn )
      IF ( cpl_exchange_RunOff.GE.2 ) THEN
C     Map atmos. runOff from land onto ocean grid and substract it
C       from previous (direct) FWFlux => total FWFlux = E-P-R
        CALL ATM_TO_OCN_MAPRUNOFF(
     I           RunOff_atm,
     O           RunOff_ocn,
     U           FWFlux_ocn )
      ENDIF
C     Send E-P-R to ocean component
      CALL COUPSEND_R8TILES( ocnCompName, ocnFWFluxName,
     I                       Nx_ocn, Ny_ocn, FWFlux_ocn )

      IF ( MOD(cpl_exchange1W_sIce,2).EQ.1 ) THEN
C--   Map salt flux from sea-ice compon. onto ocean grid
        CALL ATM_TO_OCN_MAPXYR8(
     I           Nx_atm, Ny_atm, SaltFlx_atm, Nx_ocn, Ny_ocn,
     O                         SaltFlx_ocn )
C     Send salt flux to ocean component
        CALL COUPSEND_R8TILES( ocnCompName, ocnSaltFxName,
     I                         Nx_ocn, Ny_ocn, SaltFlx_ocn )

C--   Map sea-ice mass onto ocean grid
        CALL ATM_TO_OCN_MAPXYR8(
     I           Nx_atm, Ny_atm, sIceMass_atm, Nx_ocn, Ny_ocn,
     O                           sIceMass_ocn )
C     Send sea-ice mass to ocean component
        CALL COUPSEND_R8TILES( ocnCompName, ocnSIceMassName,
     I                         Nx_ocn, Ny_ocn, sIceMass_ocn )
      ENDIF

      IF ( MOD(cpl_exchange_SaltPl,2).EQ.1 ) THEN
C--   Map Salt-Plume flux onto ocean grid
        CALL ATM_TO_OCN_MAPXYR8(
     I           Nx_atm, Ny_atm, saltPlmFlx_atm, Nx_ocn, Ny_ocn,
     O                           saltPlmFlx_ocn )
C     Send Salt-Plume flux to ocean component
        CALL COUPSEND_R8TILES( ocnCompName, ocnSaltPlmFlxName,
     I                         Nx_ocn, Ny_ocn, saltPlmFlx_ocn  )
      ENDIF

      IF ( MOD(cpl_exchange_RunOff,2).EQ.1 ) THEN
C     Send Run-Off flux to ocean component
        CALL COUPSEND_R8TILES( ocnCompName, ocnRunOffName,
     I                         Nx_ocn, Ny_ocn, RunOff_ocn  )
      ENDIF

      IF ( MOD(cpl_exchange_DIC,2).EQ.1 ) THEN
C--   Map atmos CO2 onto ocean grid
        CALL ATM_TO_OCN_MAPXYR8(
     I           Nx_atm, Ny_atm, aCO2_atm, Nx_ocn, Ny_ocn,
     O                           aCO2_ocn )
C     Send atmos CO2 to ocean component
        CALL COUPSEND_R8TILES( ocnCompName, ocnAirCO2Name,
     I                         Nx_ocn, Ny_ocn, aCO2_ocn )

C--   Map surface wind speed onto ocean grid
        CALL ATM_TO_OCN_MAPXYR8(
     I           Nx_atm, Ny_atm, wSpeed_atm, Nx_ocn, Ny_ocn,
     O                           wSpeed_ocn )
C     Send surface windspeed to ocean component
        CALL COUPSEND_R8TILES( ocnCompName, ocnWindSpdName,
     I                         Nx_ocn, Ny_ocn, wSpeed_ocn )
      ENDIF

      IF ( ( MOD(cpl_exchange1W_sIce,2).EQ.1
     &     .AND.MOD(cpl_exchange_DIC,2).EQ.1 )
     &  .OR. MOD(cpl_exchange2W_sIce,2).EQ.1 ) THEN
C--   Map seaice fraction from atmos. compon. onto ocean grid
       IF ( ( cpl_exchange1W_sIce.GE.2
     &      .AND.cpl_exchange_DIC.GE.2 )
     &   .OR. cpl_exchange2W_sIce.GE.2 ) THEN
        CALL ATM_TO_OCN_MAPXYR8(
     I           Nx_atm, Ny_atm, SIceFrac_atm, Nx_ocn, Ny_ocn,
     O                           SIceFrac_ocn )
       ENDIF
C     Send sea-ice fraction to ocean component
        CALL COUPSEND_R8TILES( ocnCompName, ocnSIceFracName,
     I                         Nx_ocn, Ny_ocn, SIceFrac_ocn )
      ENDIF

      IF ( cpl_exchange2W_sIce.EQ.3 ) THEN
C--   Map other pkg/thsice fields onto ocean grid:
C     Map seaice thickness
        CALL ATM_TO_OCN_MAPXYR8(
     I           Nx_atm, Ny_atm, sIceThick_atm, Nx_ocn, Ny_ocn,
     O                           sIceThick_ocn )
C     Map snow thickness
        CALL ATM_TO_OCN_MAPXYR8(
     I           Nx_atm, Ny_atm, sIceSnowH_atm, Nx_ocn, Ny_ocn,
     O                           sIceSnowH_ocn )
C     Map seaice enthalpy (layer 1)
        CALL ATM_TO_OCN_MAPXYR8(
     I           Nx_atm, Ny_atm, sIceQ1_atm, Nx_ocn, Ny_ocn,
     O                           sIceQ1_ocn )
C     Map seaice enthalpy (layer 2)
        CALL ATM_TO_OCN_MAPXYR8(
     I           Nx_atm, Ny_atm, sIceQ2_atm, Nx_ocn, Ny_ocn,
     O                           sIceQ2_ocn )
      ENDIF
      IF ( MOD(cpl_exchange2W_sIce,2).EQ.1 ) THEN
C--   Map other pkg/thsice fields to ocean component:
C     Send seaice thickness
        CALL COUPSEND_R8TILES( ocnCompName, ocnSIceThickName,
     I                         Nx_ocn, Ny_ocn, sIceThick_ocn )
C     Send snow thickness
        CALL COUPSEND_R8TILES( ocnCompName, ocnSIceSnowName,
     I                         Nx_ocn, Ny_ocn, sIceSnowH_ocn )
C     Send seaice enthalpy (layer 1)
        CALL COUPSEND_R8TILES( ocnCompName, ocnSIceQ1Name,
     I                         Nx_ocn, Ny_ocn, sIceQ1_ocn )
C     Send seaice enthalpy (layer 2)
        CALL COUPSEND_R8TILES( ocnCompName, ocnSIceQ2Name,
     I                         Nx_ocn, Ny_ocn, sIceQ2_ocn )
      ENDIF

      RETURN
      END

#include "KL10_OPTIONS.h"

      SUBROUTINE KL10_INIT_VARIA( myThid )
C     *==========================================================*
C     | SUBROUTINE KL10_INIT_VARIA
C     | o Routine to initialize KL10 parameters and variables.
C     *==========================================================*
C     | Initialize KL10 parameters and variables.
C     *==========================================================*
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
c#include "GRID.h"
#include "KL10.h"

C     === Routine arguments ===
C     myThid -  Number of this instance of KL10_INIT
      INTEGER myThid

#ifdef ALLOW_KL10

C     === Local variables ===
C     i,j,k,bi,bj - Loop counters

      INTEGER i, j, k, bi, bj

C-----------------------------------------------------------------------
C Initialize KL variables KLviscAr, KLdiffKrT
C-----------------------------------------------------------------------

      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
        DO k = 1, Nr
         DO j = 1-OLy, sNy+OLy
          DO i = 1-OLx, sNx+OLx
           KLviscAr (i,j,k,bi,bj) = viscArNr(k)
           KLdiffKr (i,j,k,bi,bj) = diffKrNrS(k)
          ENDDO
         ENDDO
        ENDDO
       ENDDO
      ENDDO

#endif /* ALLOW_KL10 */

      RETURN
      END

#include "OBCS_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: OBCS_DIAG_BALANCE

C     !INTERFACE:
      SUBROUTINE OBCS_DIAG_BALANCE(
     U                              div2d,
     I                              uTrans, vTrans, k,
     I                              myTime, myIter, myThid )

C     !DESCRIPTION:
C     *==========================================================*
C     | SUBROUTINE OBCS_DIAG_BALANCE
C     | o For diagnostics purpose, modify horizontal divergence
C     |   next (but outside) OB to ensure zero net inflow
C     *==========================================================*

C     !USES:
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "OBCS_PARAMS.h"
#include "OBCS_GRID.h"
#include "OBCS_FIELDS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     div2d   :: horizontal divergence x grid-cell volume [m^3/s]
C     uTrans  :: horizontal transport to balance [m^3/s]
C     vTrans  :: horizontal transport to balance [m^3/s]
C     k       :: current level index
C     myTime  :: current time of simulation (s)
C     myIter  :: current iteration number
C     myThid  :: my Thread Id number
      _RL div2d (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL uTrans(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL vTrans(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      INTEGER k
      _RL myTime
      INTEGER myIter
      INTEGER myThid
CEOP

#ifdef ALLOW_OBCS
#ifdef ALLOW_DIAGNOSTICS

C     !FUNCTIONS:

C     !LOCAL VARIABLES:
C     bi, bj       :: tile indices
C     i,j,k        :: loop indices
C     iB, jB       :: local index of open boundary
C     msgBuf       :: Informational/error message buffer
      INTEGER bi, bj, n
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      _RL areaOB(OBCS_maxConnect), tmpA
      _RL inFlow(OBCS_maxConnect)
      _RL tileAreaOB(nSx,nSy,OBCS_maxConnect)
      _RL tileInFlow(nSx,nSy,OBCS_maxConnect)
#if (defined ALLOW_OBCS_EAST ) || (defined ALLOW_OBCS_WEST )
      INTEGER j, iB
#endif
#ifdef ALLOW_OBCS_WEST
      INTEGER iBt
#endif
#if (defined ALLOW_OBCS_NORTH) || (defined ALLOW_OBCS_SOUTH)
      INTEGER i, jB
#endif
#ifdef ALLOW_OBCS_SOUTH
      INTEGER jBt
#endif

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_ENTER('OBCS_DIAG_BALANCE',myThid)
#endif

C--   Integrate the transport through each OB
      DO n=1,OB_connectNumber(k)
        areaOB(n)= 0. _d 0
        inFlow(n)= 0. _d 0
        DO bj=myByLo(myThid),myByHi(myThid)
         DO bi=myBxLo(myThid),myBxHi(myThid)
          tileAreaOB(bi,bj,n) = 0.
          tileInFlow(bi,bj,n) = 0.
         ENDDO
        ENDDO
      ENDDO

#ifdef ALLOW_OBCS_EAST
      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        IF ( tileHasOBE(bi,bj) ) THEN
         DO j=1,sNy
           iB = OB_Ie(j,bi,bj)
           IF ( iB.NE.OB_indexNone .AND. iB.GT.1 ) THEN
            n = OBE_connect(j,k,bi,bj)
            IF ( n.GE.1 ) THEN
              tmpA = drF(k)*hFacW(iB,j,k,bi,bj)*dyG(iB,j,bi,bj)
     &                     *maskInW(iB,j,bi,bj)
              tileAreaOB(bi,bj,n) = tileAreaOB(bi,bj,n) + tmpA
              tileInFlow(bi,bj,n) = tileInFlow(bi,bj,n)
     &                            - uTrans(iB,j,bi,bj)
            ENDIF
           ENDIF
         ENDDO
        ENDIF
       ENDDO
      ENDDO
#endif /* ALLOW_OBCS_EAST */

#ifdef ALLOW_OBCS_WEST
      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        IF ( tileHasOBW(bi,bj) ) THEN
         DO j=1,sNy
           iB = OB_Iw(j,bi,bj)
           IF ( iB.NE.OB_indexNone .AND. iB.LT.sNx ) THEN
            n = OBW_connect(j,k,bi,bj)
            IF ( n.GE.1 ) THEN
              iB = 1+iB
              tmpA = drF(k)*hFacW(iB,j,k,bi,bj)*dyG(iB,j,bi,bj)
     &                     *maskInW(iB,j,bi,bj)
              tileAreaOB(bi,bj,n) = tileAreaOB(bi,bj,n) + tmpA
              tileInFlow(bi,bj,n) = tileInFlow(bi,bj,n)
     &                            + uTrans(iB,j,bi,bj)
            ENDIF
           ENDIF
         ENDDO
        ENDIF
       ENDDO
      ENDDO
#endif /* ALLOW_OBCS_WEST */

#ifdef ALLOW_OBCS_NORTH
      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        IF ( tileHasOBN(bi,bj) ) THEN
         DO i=1,sNx
           jB = OB_Jn(i,bi,bj)
           IF ( jB.NE.OB_indexNone .AND. jB.GT.1 ) THEN
            n = OBN_connect(i,k,bi,bj)
            IF ( n.GE.1 ) THEN
              tmpA = drF(k)*hFacS(i,jB,k,bi,bj)*dxG(i,jB,bi,bj)
     &                     *maskInS(i,jB,bi,bj)
              tileAreaOB(bi,bj,n) = tileAreaOB(bi,bj,n) + tmpA
              tileInFlow(bi,bj,n) = tileInFlow(bi,bj,n)
     &                            - vTrans(i,jB,bi,bj)
            ENDIF
           ENDIF
         ENDDO
        ENDIF
       ENDDO
      ENDDO
#endif /* ALLOW_OBCS_NORTH */

#ifdef ALLOW_OBCS_SOUTH
      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        IF ( tileHasOBS(bi,bj) ) THEN
         DO i=1,sNx
           jB = OB_Js(i,bi,bj)
           IF ( jB.NE.OB_indexNone .AND. jB.LT.sNy ) THEN
            n = OBS_connect(i,k,bi,bj)
            IF ( n.GE.1 ) THEN
              jB = 1+jB
              tmpA = drF(k)*hFacS(i,jB,k,bi,bj)*dxG(i,jB,bi,bj)
     &                     *maskInS(i,jB,bi,bj)
              tileAreaOB(bi,bj,n) = tileAreaOB(bi,bj,n) + tmpA
              tileInFlow(bi,bj,n) = tileInFlow(bi,bj,n)
     &                            + vTrans(i,jB,bi,bj)
            ENDIF
           ENDIF
         ENDDO
        ENDIF
       ENDDO
      ENDDO
#endif /* ALLOW_OBCS_SOUTH */

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C--   For each set of OB connected points, calculate a unique velocity
C     correction and correct to the corresponding OB point divergence

      DO n=1,OB_connectNumber(k)
       CALL GLOBAL_SUM_TILE_RL( tileAreaOB(1,1,n), areaOB(n), myThid )
       IF ( areaOB(n).GT.0. ) THEN
        CALL GLOBAL_SUM_TILE_RL( tileInFlow(1,1,n), inFlow(n), myThid )
        IF ( debugLevel.GE.debLevC ) THEN
          WRITE(msgBuf,'(A,I9,2I4,A,1P2E16.8)')
     &     'OBCS_DIAG_BALANCE (it,k,n=', myIter, k, n,
     &       ' ) inFlow:',inFlow(n),inFlow(n)/areaOB(n)
          CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                        SQUEEZE_RIGHT, myThid )
        ENDIF
        inFlow(n) = inFlow(n) / areaOB(n)
       ENDIF
      ENDDO

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C--   Add correction:

      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
#ifdef ALLOW_OBCS_EAST
         IF ( tileHasOBE(bi,bj) ) THEN
c          DO j=1-OLy,sNy+OLy
           DO j=1,sNy
            IF ( OB_Ie(j,bi,bj).NE.OB_indexNone ) THEN
             iB = OB_Ie(j,bi,bj)
             n = OBE_connect(j,k,bi,bj)
             IF ( n.EQ.0 ) THEN
               div2d(iB ,j,bi,bj) = div2d(iB ,j,bi,bj)
     &                            - uTrans(iB,j,bi,bj)
             ELSE
               div2d(iB ,j,bi,bj) = div2d(iB,j,bi,bj)
     &                 + inFlow(n)*drF(k)*hFacW(iB,j,k,bi,bj)
     &                            *dyG(iB,j,bi,bj)*maskInW(iB,j,bi,bj)
             ENDIF
            ENDIF
           ENDDO
         ENDIF
#endif /* ALLOW_OBCS_EAST */

#ifdef ALLOW_OBCS_WEST
         IF ( tileHasOBW(bi,bj) ) THEN
c          DO j=1-OLy,sNy+OLy
           DO j=1,sNy
            IF ( OB_Iw(j,bi,bj).NE.OB_indexNone ) THEN
             iBt = OB_Iw(j,bi,bj)
             iB = 1+iBt
             n = OBW_connect(j,k,bi,bj)
             IF ( n.EQ.0 ) THEN
               div2d(iBt,j,bi,bj) = div2d(iBt,j,bi,bj)
     &                            + uTrans(iB,j,bi,bj)
             ELSE
               div2d(iBt,j,bi,bj) = div2d(iBt,j,bi,bj)
     &                 + inFlow(n)*drF(k)*hFacW(iB,j,k,bi,bj)
     &                            *dyG(iB,j,bi,bj)*maskInW(iB,j,bi,bj)
             ENDIF
            ENDIF
           ENDDO
         ENDIF
#endif /* ALLOW_OBCS_WEST */

#ifdef ALLOW_OBCS_NORTH
         IF ( tileHasOBN(bi,bj) ) THEN
c          DO i=1-OLx,sNx+OLx
           DO i=1,sNx
            IF ( OB_Jn(i,bi,bj).NE.OB_indexNone ) THEN
             jB = OB_Jn(i,bi,bj)
             n = OBN_connect(i,k,bi,bj)
             IF ( n.EQ.0 ) THEN
               div2d(i,jB ,bi,bj) = div2d(i,jB ,bi,bj)
     &                            - vTrans(i,jB,bi,bj)
             ELSE
               div2d(i,jB ,bi,bj) = div2d(i,jB ,bi,bj)
     &                 + inFlow(n)*drF(k)*hFacS(i,jB,k,bi,bj)
     &                            *dxG(i,jB,bi,bj)*maskInS(i,jB,bi,bj)
             ENDIF
            ENDIF
           ENDDO
         ENDIF
#endif /* ALLOW_OBCS_NORTH */

#ifdef ALLOW_OBCS_SOUTH
         IF ( tileHasOBS(bi,bj) ) THEN
c          DO i=1-OLx,sNx+OLx
           DO i=1,sNx
            IF ( OB_Js(i,bi,bj).NE.OB_indexNone ) THEN
             jBt = OB_Js(i,bi,bj)
             jB = 1+jBt
             n = OBS_connect(i,k,bi,bj)
             IF ( n.EQ.0 ) THEN
               div2d(i,jBt,bi,bj) = div2d(i,jBt,bi,bj)
     &                            + vTrans(i,jB,bi,bj)
             ELSE
               div2d(i,jBt,bi,bj) = div2d(i,jBt,bi,bj)
     &                 + inFlow(n)*drF(k)*hFacS(i,jB,k,bi,bj)
     &                            *dxG(i,jB,bi,bj)*maskInS(i,jB,bi,bj)
             ENDIF
            ENDIF
           ENDDO
         ENDIF
#endif /* ALLOW_OBCS_SOUTH */

       ENDDO
      ENDDO

#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_LEAVE('OBCS_DIAG_BALANCE',myThid)
#endif

#endif /* ALLOW_DIAGNOSTICS */
#endif /* ALLOW_OBCS */

      RETURN
      END

#include "CPP_EEOPTIONS.h"

CBOP
C     !ROUTINE: BAR2_INIT

C     !INTERFACE:
      SUBROUTINE BAR2_INIT( myThid )
      IMPLICIT NONE

C     !DESCRIPTION:
C     *=====================================================================*
C     | SUBROUTINE BAR2\_INIT
C     | o Setup global barrier data structures.
C     *=====================================================================*
C     | Initialise global barrier data structures that can be used in
C     | conjunction with MPI or that can also be used to create
C     *=====================================================================*

C     !USES:
C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "EESUPPORT.h"
#include "BAR2.h"
C

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     myThid :: Thread number of this instance of BAR2_INIT
      INTEGER myThid

C     !LOCAL VARIABLES:
C     == Local variables ==
C     I :: Loop counter
      INTEGER I
CEOP

C
      DO I = 1, lShare4
       BAR2_level(I,myThid) = 0
       BAR2_barrierCount(I,myThid) = 0
       BAR2_spinsCount(I,myThid) = 0
       BAR2_spinsCount(I,myThid) = 0
       BAR2_spinsMax  (I,myThid) = 0
       BAR2_spinsMin  (I,myThid) = 1000000000
      ENDDO
C
      bar2CollectStatistics = .TRUE.
C
      RETURN
      END

CBOP

C     !ROUTINE: BAR2

C     !INTERFACE:
      SUBROUTINE BAR2( myThid )
      IMPLICIT NONE

C     !DESCRIPTION:
C     *=====================================================================*
C     | SUBROUTINE BAR2
C     | o Global barrier routine.
C     *=====================================================================*
C     | Implements a simple true shared memory barrier that uses a global
C     | heap array that all threads can access to synchronise. Each thread
C     | writes to a predefined location. One thread polls the locations. Other
C     | threads poll an all clear assertion location. Once the polling
C     | thread that is looping over locations sees writes for each thread is
C     | writes the all clear assertion location and everyone proceeds. A
C     | cyclic series of locations is used to ensure that race conditions do
C     | not occur. A few simple statistics are recorded giving number of
C     | barrier calls, max, min and aggregate polling loop counts.
C     *=====================================================================*

C     !USES:
C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "EESUPPORT.h"
#include "BAR2.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     myThid :: Thread number of this instance of BAR2
      INTEGER myThid

C     !LOCAL VARIABLES:
C     == Local variables ==
C     myLevel   :: Temp. to hold "active" barrier level
C     nDone     :: Temp. for counting number of threads that
C                  have reached the barrier.
C     I         :: Loop counter
C     spinCount :: Temp. for doing statistics on how many
C                  times barrier code looped.
      INTEGER myLevel
      INTEGER nDone
      INTEGER I
      INTEGER spinCount
CEOP

#ifdef USE_OMP_THREADING
C$OMP BARRIER
      BAR2_barrierCount(1,myThid) = BAR2_barrierCount(1,myThid)+1
Cdbg C$OMP BARRIER
Cdbg       DO I = 2, nThreads
Cdbg        IF ( BAR2_barrierCount(1,I) .NE. BAR2_barrierCount(1,1) ) THEN
Cdbg         PRINT *, BAR2_barrierCount(1,1:nThreads)
Cdbg         CALL SYSTEM('sleep 1')
Cdbg         PRINT *, BAR2_barrierCount(1,1:nThreads)
Cdbg         Stop ' bar2 OUT OF SYNC '
Cdbg        ENDIF
Cdbg       ENDDO
Cdbg C$OMP BARRIER
      RETURN
#endif

      spinCount = 0

      IF ( myThid .NE. 1 ) THEN

       BAR2_level(1,myThid) = BAR2_level(1,myThid)+1
       myLevel              = BAR2_level(1,myThid)
   10  CONTINUE
        IF ( BAR2_level(1,1) .EQ. myLevel  ) GOTO 11
        spinCount = spinCount+1
        CALL FOOL_THE_COMPILER( BAR2_level(1,1) )
       GOTO 10
   11  CONTINUE

      ELSE

       myLevel = BAR2_level(1,1)
   12  CONTINUE
        CALL FOOL_THE_COMPILER( BAR2_level(1,1) )
        nDone   = 1
        DO I = 2, nThreads
         IF ( BAR2_level(1,1) .EQ. BAR2_level(1,I)-1 ) nDone = nDone+1
        ENDDO
        spinCount = spinCount+1
       IF ( nDone .LT. nThreads ) GOTO 12

       BAR2_level(1,1) = myLevel+1

      ENDIF

      BAR2_barrierCount(1,myThid) = BAR2_barrierCount(1,myThid)+1
      BAR2_spinsCount(1,myThid) = BAR2_spinsCount(1,myThid)+spinCount
      BAR2_spinsMax  (1,myThid) = MAX(BAR2_spinsMax(1,myThid),spinCount)
      BAR2_spinsMin  (1,myThid) = MIN(BAR2_spinsMin(1,myThid),spinCount)

      RETURN
      END

c#include "PACKAGES_CONFIG.h"
#include "CPP_OPTIONS.h"

CBOP
C     !ROUTINE: INI_SIGMA_HFAC
C     !INTERFACE:
      SUBROUTINE INI_SIGMA_HFAC( myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE INI_SIGMA_HFAC
C     | o Initialise grid factors when using Sigma coordiante
C     *==========================================================*
C     | These arrays are used throughout the code and describe
C     | fractional height factors.
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "SURFACE.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     myThid  ::  Number of this instance of INI_SIGMA_HFAC
      INTEGER myThid

C     !LOCAL VARIABLES:
C     == Local variables ==
C     bi, bj     :: tile indices
C     i, j, k    :: Loop counters
C     rEmpty     :: empty column r-position
C     rFullDepth :: maximum depth of a full column
C     tmpFld     :: Temporary array used to compute & write Total Depth
C     min_hFac   :: actual minimum of cell-centered hFac
C     msgBuf     :: Informational/error message buffer
      INTEGER bi, bj
      INTEGER i, j, k
      _RS rEmpty
      _RL rFullDepth
      _RL tmpFld(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL min_hFac
      _RL hFactmp
      CHARACTER*(MAX_LEN_MBUF) msgBuf
CEOP

C     r(ij,k,t) = rLow(ij) + aHybSigm(k)*[rF(1)-rF(Nr+1)]
C               + bHybSigm(k)*[eta(ij,t)+Ro_surf(ij) - rLow(ij)]

      IF ( usingPCoords ) rEmpty = rF(Nr+1)
      IF ( usingZCoords ) rEmpty = rF(1)
      rFullDepth = rF(1)-rF(Nr+1)

C---  Calculate partial-cell factor hFacC :
      min_hFac = 1.
      DO bj=myByLo(myThid), myByHi(myThid)
       DO bi=myBxLo(myThid), myBxHi(myThid)
C-    Remove column (mask=0) thinner than hFacMin*rFullDepth
C       ensures hFac > hFacMin (assuming we use pure Sigma)
C Note: because of unfortunate hFacMin default value (=1) (would produce
C       unexpected empty column), for now, use hFacInf instead of hFacMin
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
           tmpFld(i,j) = Ro_surf(i,j,bi,bj)-R_low(i,j,bi,bj)
c          IF ( tmpFld(i,j).LT.hFacMin*rFullDepth )
           IF ( tmpFld(i,j).LT.hFacInf*rFullDepth )
     &       tmpFld(i,j) = 0. _d 0
         ENDDO
        ENDDO
c#ifdef ALLOW_SHELFICE
C--   Would need a specific call here similar to SHELFICE_UPDATE_MASKS
c     IF ( useShelfIce ) THEN
c     ENDIF
c#endif /* ALLOW_SHELFICE */
C-    Set (or reset) other 2-D cell-centered fields
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
           IF ( tmpFld(i,j).GT.0. _d 0 ) THEN
             kSurfC (i,j,bi,bj) = 1
             kLowC  (i,j,bi,bj) = Nr
             maskInC(i,j,bi,bj) = 1.
             recip_Rcol(i,j,bi,bj) = 1. _d 0 / tmpFld(i,j)
           ELSE
             kSurfC (i,j,bi,bj) = Nr+1
             kLowC  (i,j,bi,bj) = 0
             maskInC(i,j,bi,bj) = 0.
             recip_Rcol(i,j,bi,bj) = 0. _d 0
             Ro_surf(i,j,bi,bj) = rEmpty
             R_low(i,j,bi,bj)   = rEmpty
           ENDIF
         ENDDO
        ENDDO
C-    Set 3-D hFacC
        DO k=1, Nr
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           IF ( maskInC(i,j,bi,bj).NE.0. _d 0 ) THEN
             hFactmp = ( dAHybSigF(k)*rFullDepth
     &                 + dBHybSigF(k)*tmpFld(i,j)
     &                 )*recip_drF(k)
             hFacC(i,j,k,bi,bj) = hFactmp
             min_hFac = MIN( min_hFac, hFactmp )
           ELSE
             hFacC(i,j,k,bi,bj) = 0.
           ENDIF
          ENDDO
         ENDDO
        ENDDO
C-    end bi,bj loops.
       ENDDO
      ENDDO

      WRITE(msgBuf,'(A,1PE14.6)')
     &     'S/R INI_SIGMA_HFAC: minimum hFacC=', min_hFac
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )

c     CALL PLOT_FIELD_XYRS(R_low,
c    &         'Model R_low (ini_masks_etc)', 1, myThid)
c     CALL PLOT_FIELD_XYRS(Ro_surf,
c    &         'Model Ro_surf (ini_masks_etc)', 1, myThid)

C--   Set Western & Southern fields (at U and V points)
      DO bj=myByLo(myThid), myByHi(myThid)
       DO bi=myBxLo(myThid), myBxHi(myThid)
C-    set 2-D mask and rLow & reference rSurf at Western & Southern edges
        i = 1-OlX
        DO j=1-OLy,sNy+OLy
           rSurfW(i,j,bi,bj) = rEmpty
           rLowW (i,j,bi,bj) = rEmpty
           maskInW(i,j,bi,bj)= 0.
        ENDDO
        j = 1-OLy
        DO i=1-OLx,sNx+OLx
           rSurfS(i,j,bi,bj) = rEmpty
           rLowS (i,j,bi,bj) = rEmpty
           maskInS(i,j,bi,bj)= 0.
        ENDDO
        DO j=1-OLy,sNy+OLy
         DO i=2-OLx,sNx+OLx
           maskInW(i,j,bi,bj)= maskInC(i-1,j,bi,bj)*maskInC(i,j,bi,bj)
           rSurfW(i,j,bi,bj) =
     &               ( Ro_surf(i-1,j,bi,bj)
     &               + Ro_surf( i, j,bi,bj) )*0.5 _d 0
           rLowW(i,j,bi,bj)  =
     &                 ( R_low(i-1,j,bi,bj)
     &                 + R_low( i, j,bi,bj) )*0.5 _d 0
c          rSurfW(i,j,bi,bj) =
c    &               ( Ro_surf(i-1,j,bi,bj)*rA(i-1,j,bi,bj)
c    &               + Ro_surf( i, j,bi,bj)*rA( i, j,bi,bj)
c    &               )*recip_rAw(i,j,bi,bj)*0.5 _d 0
c          rLowW(i,j,bi,bj)  =
c    &                 ( R_low(i-1,j,bi,bj)*rA(i-1,j,bi,bj)
c    &                 + R_low( i, j,bi,bj)*rA( i, j,bi,bj)
c    &                 )*recip_rAw(i,j,bi,bj)*0.5 _d 0
           IF ( maskInW(i,j,bi,bj).EQ.0. ) THEN
             rSurfW(i,j,bi,bj) = rEmpty
             rLowW (i,j,bi,bj) = rEmpty
           ENDIF
         ENDDO
        ENDDO
        DO j=2-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
           maskInS(i,j,bi,bj)= maskInC(i,j-1,bi,bj)*maskInC(i,j,bi,bj)
           rSurfS(i,j,bi,bj) =
     &               ( Ro_surf(i,j-1,bi,bj)
     &               + Ro_surf(i, j, bi,bj) )*0.5 _d 0
           rLowS(i,j,bi,bj)  =
     &                 ( R_low(i,j-1,bi,bj)
     &                 + R_low(i, j, bi,bj) )*0.5 _d 0
c          rSurfS(i,j,bi,bj) =
c    &               ( Ro_surf(i,j-1,bi,bj)*rA(i,j-1,bi,bj)
c    &               + Ro_surf(i, j, bi,bj)*rA(i, j, bi,bj)
c    &               )*recip_rAs(i,j,bi,bj)*0.5 _d 0
c          rLowS(i,j,bi,bj)  =
c    &                 ( R_low(i,j-1,bi,bj)*rA(i,j-1,bi,bj)
c    &                 + R_low(i, j, bi,bj)*rA(i, j, bi,bj)
c    &                 )*recip_rAs(i,j,bi,bj)*0.5 _d 0
           IF ( maskInS(i,j,bi,bj).EQ.0. ) THEN
             rSurfS(i,j,bi,bj) = rEmpty
             rLowS (i,j,bi,bj) = rEmpty
           ENDIF
         ENDDO
        ENDDO
       ENDDO
      ENDDO
      CALL EXCH_UV_XY_RS( rSurfW,  rSurfS,  .FALSE., myThid )
      CALL EXCH_UV_XY_RS( rLowW,   rLowS,   .FALSE., myThid )
      CALL EXCH_UV_XY_RS( maskInW, maskInS, .FALSE., myThid )

C-    Set hFacW and hFacS (at U and V points)
      DO bj=myByLo(myThid), myByHi(myThid)
       DO bi=myBxLo(myThid), myBxHi(myThid)
        DO k=1, Nr
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
            hFactmp =
     &          ( dAHybSigF(k)*rFullDepth
     &          + dBHybSigF(k)*( rSurfW(i,j,bi,bj)-rLowW(i,j,bi,bj) )
     &          )*recip_drF(k)
            hFacW(i,j,k,bi,bj) = hFactmp*maskInW(i,j,bi,bj)
          ENDDO
         ENDDO
        ENDDO
        DO k=1, Nr
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
            hFactmp =
     &          ( dAHybSigF(k)*rFullDepth
     &          + dBHybSigF(k)*( rSurfS(i,j,bi,bj)-rLowS(i,j,bi,bj) )
     &          )*recip_drF(k)
            hFacS(i,j,k,bi,bj) = hFactmp*maskInS(i,j,bi,bj)
          ENDDO
         ENDDO
        ENDDO
C-    Set surface k index for interface W & S (U & V points)
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
           kSurfW(i,j,bi,bj) = Nr+1
           kSurfS(i,j,bi,bj) = Nr+1
           IF ( maskInW(i,j,bi,bj).NE.0. ) kSurfW(i,j,bi,bj) = 1
           IF ( maskInS(i,j,bi,bj).NE.0. ) kSurfS(i,j,bi,bj) = 1
         ENDDO
        ENDDO
C-    end bi,bj loops.
       ENDDO
      ENDDO

C--   Additional closing of Western and Southern grid-cell edges: for example,
C     a) might add some "thin walls" in specific location
C     b) close non-periodic N & S boundaries of lat-lon grid at the N/S poles.
C     new: location now reccorded as kSurfW/S = Nr+2
      CALL ADD_WALLS2MASKS( rEmpty, myThid )

      RETURN
      END

#include "PACKAGES_CONFIG.h"
#include "CPP_OPTIONS.h"

CBOP
C     !ROUTINE: LONGSTEP_CORRECTION_STEP
C     !INTERFACE:
      SUBROUTINE LONGSTEP_CORRECTION_STEP(myTime, myIter, myThid)
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE LONGSTEP_CORRECTION_STEP
C     *==========================================================*
C     | part of tracer_correction_step that affect ptracers
C     | (except convective adjustment): -> empty
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     == Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "LONGSTEP.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     myTime :: Current time in simulation
C     myIter :: Current iteration number in simulation
C     myThid :: Thread number for this instance of the routine.
      _RL myTime
      INTEGER myIter
      INTEGER myThid

#ifdef ALLOW_GENERIC_ADVDIFF
C     !LOCAL VARIABLES:
C     == Local variables
c     INTEGER bi,bj
CEOP

#ifdef ALLOW_LONGSTEP
C     only cycle if we have computed gPtr in this time step
      IF ( LS_doTimeStep ) THEN
#else
      IF ( .TRUE. ) THEN
#endif

C     endif LS_doTimeStep
      ENDIF

#endif /* ALLOW_GENERIC_ADVDIFF */

      RETURN
      END

#include "ATM_PHYS_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 0
C !ROUTINE: ATM_PHYS_CHECK

C !INTERFACE:
      SUBROUTINE ATM_PHYS_CHECK( myThid )

C     !DESCRIPTION:
C     Check dependances with other packages

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "ATM_PHYS_PARAMS.h"

C     !INPUT PARAMETERS:
C     myThid   :: my Thread Id number
      INTEGER myThid
CEOP

#ifdef ALLOW_ATM_PHYS
C     !LOCAL VARIABLES:
C     msgBuf   :: Informational/error message buffer
      CHARACTER*(MAX_LEN_MBUF) msgBuf

      _BEGIN_MASTER(myThid)

       WRITE(msgBuf,'(A)') 'ATM_PHYS_CHECK: #define ALLOW_ATM_PHYS'
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                     SQUEEZE_RIGHT , 1)

C--  Print out some kee parameters :
       CALL WRITE_0D_L( atmPhys_addTendT, INDEX_NONE,
     &  'atmPhys_addTendT =',
     &  ' /* apply Atm-Phys tendency to Temperature Eq.*/')
       CALL WRITE_0D_L( atmPhys_addTendS, INDEX_NONE,
     &  'atmPhys_addTendS =',
     &  ' /* apply Atm-Phys tendency to Salinity Eq.*/')
       CALL WRITE_0D_L( atmPhys_addTendU, INDEX_NONE,
     &  'atmPhys_addTendU =',
     &  ' /* apply Atm-Phys tendency to U momentum Eq.*/')
       CALL WRITE_0D_L( atmPhys_addTendV, INDEX_NONE,
     &  'atmPhys_addTendV =',
     &  ' /* apply Atm-Phys tendency to V momentum Eq.*/')
       CALL WRITE_0D_L( atmPhys_stepSST, INDEX_NONE,
     &  'atmPhys_stepSST =', ' /* step forward SST field */')
       IF ( atmPhys_tauDampUV.LE.zeroRL ) THEN
        CALL WRITE_0D_RL( atmPhys_tauDampUV, INDEX_NONE,
     &  'atmPhys_tauDampUV =', ' /* U,V damping time-scale (s) */')
       ELSE
        CALL WRITE_1D_RL( atmPhys_dampUVfac, Nr, INDEX_K,
     &  'atmPhys_dampUVfac =', ' /* U,V danping coefficient (1/s) */')
       ENDIF

       CALL WRITE_0D_C( atmPhys_sstFile, -1, INDEX_NONE,
     &  'atmPhys_sstFile =',' /* SST input file */')
       CALL WRITE_0D_C( atmPhys_QflxFile, -1, INDEX_NONE,
     &  'atmPhys_qFlxFile =',' /* Q-flux input file */')
       CALL WRITE_0D_C( atmPhys_mxldFile, -1, INDEX_NONE,
     &  'atmPhys_mxldFile =',' /* Mixed-Layer Depth inp. file */')
       CALL WRITE_0D_C( atmPhys_albedoFile, -1, INDEX_NONE,
     &  'atmPhys_albedoFile =',' /* Albedo input file */')

C--  Check parameters:

C-     Put stops here if some flags are wrongly chosen.
C-     For example, require this package to use tempStepping
       IF ( .NOT.tempStepping .AND. atmPhys_addTendT ) THEN
        WRITE(msgBuf,'(A)') 'An example requirement is:'
        CALL PRINT_ERROR( msgBuf , 1)
        WRITE(msgBuf,'(A)') 'atmPhys_addTendT needs tempStepping=.true.'
        CALL PRINT_ERROR( msgBuf , 1)
        CALL ALL_PROC_DIE( 0 )
        STOP 'ABNORMAL END: S/R ATM_PHYS_CHECK'
       ENDIF

       WRITE(msgBuf,'(A)') ' '
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                     SQUEEZE_RIGHT , 1)
      _END_MASTER(myThid)

#endif /* ALLOW_ATM_PHYS */

      RETURN
      END

#include "BLING_OPTIONS.h"
#ifdef ALLOW_EXF
# include "EXF_OPTIONS.h"
#endif

CBOP
      SUBROUTINE BLING_FIELDS_LOAD (
     I           myTime, myIter, myThid )

C     *========================================================*
C     | subroutine bling_fields_load
C     | o Read in fields needed for CO2, O2 flux terms, silica
C     |   for pH calculation
C     | o Update fields from EXF package
C     *========================================================*

      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#ifdef ALLOW_EXF
# include "EXF_PARAM.h"
# include "EXF_INTERP_SIZE.h"
# include "EXF_FIELDS.h"
#endif
#include "BLING_VARS.h"
#include "BLING_LOAD.h"
#ifdef ALLOW_THSICE
# include "THSICE_VARS.h"
#endif
#ifdef ALLOW_SEAICE
# include "SEAICE_SIZE.h"
# include "SEAICE.h"
#endif

C !INPUT PARAMETERS: ===================================================
C  myThid               :: thread number
C  myIter               :: current timestep
C  myTime               :: current time
      INTEGER myIter
      _RL myTime
      INTEGER myThid

#ifdef ALLOW_BLING

C !LOCAL VARIABLES: ===================================================
      INTEGER bi, bj, i, j
      INTEGER intimeP, intime0, intime1
      _RL aWght,bWght
CEOP

      IF (  BLING_forcingCycle.gt.0. _d 0 ) THEN

C--   Now calculate whether it is time to update the forcing arrays
       CALL GET_PERIODIC_INTERVAL(
     O                   intimeP, intime0, intime1, bWght, aWght,
     I                   BLING_forcingCycle, BLING_forcingPeriod,
     I                   deltaTClock, myTime, myThid )

       bi = myBxLo(myThid)
       bj = myByLo(myThid)
#ifdef ALLOW_DEBUG
       IF ( debugLevel.GE.debLevB ) THEN
        _BEGIN_MASTER(myThid)
        WRITE(standardMessageUnit,'(A,I10,A,4I5,A,2F14.10)')
     &   ' BLING_FIELDS_LOAD,', myIter,
     &   ' : iP,iLd,i0,i1=', intimeP,BLING_ldRec(bi,bj), intime0,
     &                       intime1,
     &   ' ; Wght=', bWght, aWght
        _END_MASTER(myThid)
       ENDIF
#endif /* ALLOW_DEBUG */

#ifdef ALLOW_AUTODIFF
C-    assuming that we call S/R BLING_FIELDS_LOAD at each time-step and
C     with increasing time, this will catch when we need to load new records;
C     But with Adjoint run, this is not always the case => might end-up using
C     the wrong time-records
       IF ( intime0.NE.intimeP .OR. myIter.EQ.nIter0 ) THEN
#else /* ALLOW_AUTODIFF */
C-    Make no assumption on sequence of calls to BLING_FIELDS_LOAD ;
C     This is the correct formulation (works in Adjoint run).
C     Unfortunatly, produces many recomputations <== not used until it is fixed
       IF ( intime1.NE.BLING_ldRec(bi,bj) ) THEN
#endif /* ALLOW_AUTODIFF */

C--   If the above condition is met then we need to read in
C     data for the period ahead and the period behind myTime.
        IF ( debugLevel.GE.debLevZero ) THEN
         _BEGIN_MASTER(myThid)
         WRITE(standardMessageUnit,'(A,I10,A,2(2I5,A))')
     &    ' BLING_FIELDS_LOAD, it=', myIter,
     &    ' : Reading new data, i0,i1=', intime0, intime1,
     &    ' (prev=', intimeP, BLING_ldRec(bi,bj), ' )'
         _END_MASTER(myThid)
        ENDIF

        _BARRIER

        IF ( BLING_windFile .NE. ' '  ) THEN
         CALL READ_REC_XY_RS( BLING_windFile,dicwind0,intime0,
     &        myIter,myThid )
         CALL READ_REC_XY_RS( BLING_windFile,dicwind1,intime1,
     &        myIter,myThid )
        ENDIF
        IF ( BLING_atmospFile .NE. ' '  ) THEN
         CALL READ_REC_XY_RS( BLING_atmospFile,atmosp0,intime0,
     &        myIter,myThid )
         CALL READ_REC_XY_RS( BLING_atmospFile,atmosp1,intime1,
     &        myIter,myThid )
        ENDIF
        IF ( BLING_silicaFile .NE. ' '  ) THEN
         CALL READ_REC_XY_RS( BLING_silicaFile,silica0,intime0,
     &        myIter,myThid )
         CALL READ_REC_XY_RS( BLING_silicaFile,silica1,intime1,
     &        myIter,myThid )
        ENDIF
        IF ( BLING_iceFile .NE. ' '  ) THEN
         CALL READ_REC_XY_RS( BLING_iceFile,ice0,intime0,
     &       myIter,myThid )
         CALL READ_REC_XY_RS( BLING_iceFile,ice1,intime1,
     &       myIter,myThid )
        ENDIF
        IF ( BLING_ironFile .NE. ' '  ) THEN
         CALL READ_REC_XY_RS( BLING_ironFile,feinput0,intime0,
     &       myIter,myThid )
         CALL READ_REC_XY_RS( BLING_ironFile,feinput1,intime1,
     &       myIter,myThid )
        ENDIF

C--   fill-in overlap after loading temp arrays:
        _EXCH_XY_RS(dicwind0, myThid )
        _EXCH_XY_RS(dicwind1, myThid )
        _EXCH_XY_RS(atmosp0, myThid )
        _EXCH_XY_RS(atmosp1, myThid )
        _EXCH_XY_RS(ice0, myThid )
        _EXCH_XY_RS(ice1, myThid )
        _EXCH_XY_RS(feinput0, myThid )
        _EXCH_XY_RS(feinput1, myThid )
        _EXCH_XY_RS(silica0, myThid )
        _EXCH_XY_RS(silica1, myThid )

C-    save newly loaded time-record
        DO bj = myByLo(myThid), myByHi(myThid)
         DO bi = myBxLo(myThid), myBxHi(myThid)
           BLING_ldRec(bi,bj) = intime1
         ENDDO
        ENDDO

C-     end if-bloc (time to load new fields)
       ENDIF

       DO bj = myByLo(myThid), myByHi(myThid)
        DO bi = myBxLo(myThid), myBxHi(myThid)
         IF ( BLING_windFile .NE. ' '  ) THEN
           DO j=1-OLy,sNy+OLy
            DO i=1-OLx,sNx+OLx
             wind(i,j,bi,bj) = bWght*dicwind0(i,j,bi,bj)
     &                       + aWght*dicwind1(i,j,bi,bj)
            ENDDO
           ENDDO
         ENDIF

         IF ( BLING_atmospFile .NE. ' '  ) THEN
           DO j=1-OLy,sNy+OLy
            DO i=1-OLx,sNx+OLx
             atmosP(i,j,bi,bj) = bWght*atmosp0(i,j,bi,bj)
     &                         + aWght*atmosp1(i,j,bi,bj)
            ENDDO
           ENDDO
         ENDIF

         IF ( BLING_silicaFile .NE. ' '  ) THEN
           DO j=1-OLy,sNy+OLy
            DO i=1-OLx,sNx+OLx
             silica(i,j,bi,bj) = bWght*silica0(i,j,bi,bj)
     &                         + aWght*silica1(i,j,bi,bj)
            ENDDO
           ENDDO
         ENDIF

         IF ( BLING_iceFile .NE. ' '  ) THEN
           DO j=1-OLy,sNy+OLy
            DO i=1-OLx,sNx+OLx
             fIce(i,j,bi,bj) = bWght*ice0(i,j,bi,bj)
     &                       + aWght*ice1(i,j,bi,bj)
            ENDDO
           ENDDO
         ENDIF

         IF ( BLING_ironFile .NE. ' '  ) THEN
           DO j=1-OLy,sNy+OLy
            DO i=1-OLx,sNx+OLx
             InputFe(i,j,bi,bj) = bWght*feinput0(i,j,bi,bj)
     &                          + aWght*feinput1(i,j,bi,bj)
            ENDDO
           ENDDO
         ENDIF
        ENDDO
       ENDDO

C endif for BLING_forcingCycle
      ENDIF

C-----------------------------------------------------------
C Get ice fraction from PKG/SEAICE or PKG/THSICE
      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
#ifdef ALLOW_SEAICE
         IF ( useSEAICE ) THEN
           DO j=1-OLy,sNy+OLy
            DO i=1-OLx,sNx+OLx
             fIce(i,j,bi,bj) = AREA(i,j,bi,bj)
            ENDDO
           ENDDO
         ENDIF
#endif
#ifdef ALLOW_THSICE
         IF ( useThSIce ) THEN
           DO j=1-OLy,sNy+OLy
            DO i=1-OLx,sNx+OLx
             fIce(i,j,bi,bj) = iceMask(i,j,bi,bj)
            ENDDO
           ENDDO
         ENDIF
#endif
       ENDDO
      ENDDO

C-----------------------------------------------------------
C Get winds from PKG/EXF
      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
#ifdef ALLOW_EXF
         IF ( useEXF ) THEN
          IF ( uwindfile .NE. ' '  ) THEN
          IF ( vwindfile .NE. ' '  ) THEN
           DO j=1-OLy,sNy+OLy
            DO i=1-OLx,sNx+OLx
             wind(i,j,bi,bj) = wspeed(i,j,bi,bj)
            ENDDO
           ENDDO
          ENDIF
          ENDIF
         ENDIF
#endif
       ENDDO
      ENDDO

C-----------------------------------------------------------
C Get atmospheric pressure from PKG/EXF
      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
#ifdef ALLOW_EXF
         IF ( useEXF ) THEN
          IF ( apressurefile .NE. ' '  ) THEN
           DO j=1-OLy,sNy+OLy
            DO i=1-OLx,sNx+OLx
C Atm pressure in Pascals, convert to atm
             AtmosP(i,j,bi,bj) = apressure(i,j,bi,bj)/Pa2atm
            ENDDO
           ENDDO
          ENDIF
         ENDIF
#endif
       ENDDO
      ENDDO

C-----------------------------------------------------------
C Get Atmospheric carbon dioxide concentration from PKG/EXF
#ifdef ALLOW_EXF
C     Atmospheric carbon dioxide concentration
      IF ( useEXF ) THEN
       IF ( apco2file .NE. ' '  ) THEN
        CALL EXF_SET_FLD(
     I     'apco2', apco2file, apco2mask,
     I     apco2StartTime, apco2period, apco2RepCycle,
     I     exf_inscal_apco2,
     I     apco2_exfremo_intercept, apco2_exfremo_slope,
     U     apco2, apco20, apco21,
# ifdef USE_EXF_INTERPOLATION
     I     apco2_lon0, apco2_lon_inc, apco2_lat0, apco2_lat_inc,
     I     apco2_nlon, apco2_nlat, xC, yC, apco2_interpMethod,
# endif
     I     myTime, myIter, myThid )
       ENDIF
      ENDIF
#endif

#endif /* ALLOW_BLING */
      RETURN
      END

#include "CPP_OPTIONS.h"

      SUBROUTINE MOM_VI_HFACZ_DISS(
     I        bi,bj,k,
     O        hFacZ,r_hFacZ,
     I        myThid)
      IMPLICIT NONE
C
C     Compute hFactor (and reciprol) at the corner (Z-point)
C       used for vorticity,divergence form of viscous term 
C        (also in Shap_S2 formulation)
C

C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"

C     == Routine arguments ==
      INTEGER bi,bj,k
      _RS hFacZ(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RS r_hFacZ(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RS hFacZOpen
      INTEGER myThid

C     == Local variables ==
      INTEGER I,J

C--   Calculate open water fraction at vorticity points

      DO i=1-Olx,sNx+Olx
       hFacZ(i,1-Oly)=0.
       r_hFacZ(i,1-Oly)=0.
      ENDDO

      DO j=2-Oly,sNy+Oly
       hFacZ(1-Olx,j)=0.
       r_hFacZ(1-Olx,j)=0.
       DO i=2-Olx,sNx+Olx
        hFacZOpen=MIN(_hFacW(i,j,k,bi,bj)
     &              + _hFacW(i,j-1,k,bi,bj)
     &              , _hFacS(i,j,k,bi,bj)
     &              + _hFacS(i-1,j,k,bi,bj)
     &               )
        hFacZ(i,j)=0.5*hFacZOpen         
        IF (hFacZ(i,j).EQ.0.) THEN
         r_hFacZ(i,j)=0.
        ELSE
         r_hFacZ(i,j)=1./hFacZ(i,j)
        ENDIF
       ENDDO
      ENDDO

C-    Special stuff for Cubed Sphere 
C      above formula is ambiguous when only 3 edges instead of 4,
C      => return to min-3 definition at the Cubed-Sphere corners
      IF (useCubedSphereExchange) THEN
       DO j=1,sNy+1,sNy
        DO i=1,sNx+1,sNx
         hFacZOpen=MIN( _hFacW(i,j,k,bi,bj)
     &                , _hFacW(i,j-1,k,bi,bj)
     &                , _hFacS(i,j,k,bi,bj)
     &                , _hFacS(i-1,j,k,bi,bj)
     &                )
         hFacZ(i,j)=hFacZOpen
         IF (hFacZOpen.EQ.0.) THEN
          r_hFacZ(i,j)=0.
         ELSE
          r_hFacZ(i,j)=1./hFacZOpen
         ENDIF
        ENDDO
       ENDDO
      ENDIF

      RETURN
      END

#include "AUTODIFF_OPTIONS.h"

CBOP
C     !ROUTINE: DAMP_ADJ
C     !INTERFACE:
      SUBROUTINE DAMP_ADJ(
     I       NrIn, minRef, maxRef, timeDamp,
     I       fieldRef, fieldDamp, myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | author: Gael Forget
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     myThid :: my Thread Id number
      INTEGER NrIn, myThid
      _RL minRef,maxRef,timeDamp
      _RL fieldRef(1-OLx:sNx+OLx,1-OLy:sNy+OLy,NrIn,nSx,nSy)
      _RL fieldDamp(1-OLx:sNx+OLx,1-OLy:sNy+OLy,NrIn,nSx,nSy)
CEOP

      RETURN
      END

      subroutine template()
      use OAD_rev

!$TEMPLATE_PRAGMA_DECLARATIONS

      type(modeType) :: our_orig_mode

c lovcal vars:

#ifdef OAD_DEBUG_SPLIT2

      character*(80):: indentation='                                        
     +                                         '
      our_indent=our_indent+1

      write(standardmessageunit, '(A,A,A)', ADVANCE='NO') 
     +'OAD:',indentation(1:our_indent), 'enter __SRNAME__:'
      call oad_dump_revmod(); call oad_dump_tapestats()
      write(standardmessageunit,*) 
#endif

      if (our_rev_mode%plain .OR. our_rev_mode%tape) then
#ifdef OAD_DEBUG_SPLIT2
         write(standardmessageunit,'(A,A,A)') 
     +'OAD:',indentation(1:our_indent), 
     +' __SRNAME__: entering plain or tape'
#endif
c set up for plain execution
         our_orig_mode=our_rev_mode
         our_rev_mode%arg_store=.FALSE.
         our_rev_mode%arg_restore=.FALSE.
         our_rev_mode%plain=.TRUE.
         our_rev_mode%tape=.FALSE.
         our_rev_mode%adjoint=.FALSE.
         call dummy_in_stepping( myTime, myIter, myThid )
c reset the mode
         our_rev_mode=our_orig_mode
c copy back
      end if
      if (our_rev_mode%adjoint) then
#ifdef OAD_DEBUG_SPLIT2
         write(standardmessageunit,'(A,A,A)') 
     +'OAD:',indentation(1:our_indent), 
     +' __SRNAME__: entering adjoint'
#endif
c set up for plain execution
         our_orig_mode=our_rev_mode
         our_rev_mode%arg_store=.FALSE.
         our_rev_mode%arg_restore=.FALSE.
         our_rev_mode%plain=.TRUE.
         our_rev_mode%tape=.FALSE.
         our_rev_mode%adjoint=.FALSE.
         call addummy_in_stepping(myTime, myIter, myThid)
c reset the mode
         our_rev_mode=our_orig_mode
c copy back
      end if

#ifdef OAD_DEBUG_SPLIT2
      write(standardmessageunit,'(A,A,A)', ADVANCE='NO') 
     +'OAD:',indentation(1:our_indent), 'leave __SRNAME__:'
      call oad_dump_revmod(); call oad_dump_tapestats()
      write(standardmessageunit,*) 

      our_indent=our_indent-1
#endif

      end subroutine template

#include "CPP_EEOPTIONS.h"

CBOP
C     !ROUTINE: MASTER_CPU_THREAD

C     !INTERFACE:
      LOGICAL FUNCTION MASTER_CPU_THREAD( myThid )

C     !DESCRIPTION:
C     return TRUE if master CPU & master thread

C     !USES:
      IMPLICIT NONE

C Global variables
#include "SIZE.h"
#include "EEPARAMS.h"
#ifdef ALLOW_USE_MPI
# include "EESUPPORT.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
C   myThid            :: my Thread Id number
C   MASTER_CPU_THREAD :: true if master CPU & master thread
      INTEGER myThid
CEOP

C     !LOCAL VARIABLES:

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      MASTER_CPU_THREAD = .FALSE.

#ifdef ALLOW_USE_MPI
      IF ( mpiMyId.EQ.0 ) THEN
        _BEGIN_MASTER( myThid )
        MASTER_CPU_THREAD = .TRUE.
        _END_MASTER( myThid )
      ENDIF
#else /* ALLOW_USE_MPI */
        _BEGIN_MASTER( myThid )
        MASTER_CPU_THREAD = .TRUE.
        _END_MASTER( myThid )
#endif /* ALLOW_USE_MPI */

      RETURN
      END

#include "AUTODIFF_OPTIONS.h"

CBOP
C     !ROUTINE: DUMMY_IN_STEPPING
C     !INTERFACE:
      SUBROUTINE DUMMY_IN_STEPPING( myTime, myIter, myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE DUMMY_IN_STEPPING                             |
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     == Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     myTime :: time counter for this thread
C     myIter :: iteration counter for this thread
C     myThid :: Thread number for this instance of the routine.
      _RL     myTime
      INTEGER myIter
      INTEGER myThid

C     !LOCAL VARIABLES:
CEOP

      RETURN
      END

#include "CPP_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: ROTATE_SPHERICAL_POLAR_GRID
C     !INTERFACE:
      SUBROUTINE ROTATE_SPHERICAL_POLAR_GRID(
     U                  X, Y,
     I                  myThid )

C     !DESCRIPTION: \bv
C     *===================================================================*
C     | SUBROUTINE ROTATE_SPHERICAL_POLAR_GRID
C     | o rotate the model coordinates on the input arrays to
C     |   geographical coordinates
C     | o this is useful when a rotated spherical grid is used,
C     |   e.g., in order to avoid the pole singularity.
C     | The three Euler angles PhiEuler, ThetaEuler, and PsiEuler
C     | define the rotation about the original z-axis (of an sphere
C     | centered cartesian grid), the new x-axis, and the new z-axis,
C     | respectively.
C     | The input coordinates X, Y are assumed to be the model coordinates
C     | on a rotated grid defined by the Euler angles. In this S/R they
C     | are rotated *BACK* to the geographical coordinate; that is why
C     | all rotation matrices are the inverses of the original matrices.
C     | On exit X and Y are the geographical coordinates, that are
C     | used to compute the Coriolis parameter and also to interpolate
C     | forcing fields to as in pkg/exf/exf_interf.F
C     | Naturally, this feature does not work with all packages, so the
C     | some combinations are prohibited in config_summary (flt,
C     | flt_zonal, ecco, profiles), because there the coordinates are
C     | assumed to be regular spherical grid coordinates.
C     *===================================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     X, Y   :: on entry: model coordinate location
C            :: on exit: geographical coordinate location
C     myThid :: my Thread Id Number
      _RS X(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RS Y(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      INTEGER myThid
CEOP

C     !LOCAL VARIABLES:
C     == Local variables ==
C     bi,bj  :: Tile indices
C     i, j   :: Loop counters
      INTEGER bi, bj
      INTEGER  I,  J, iA, jA, kA
C     Euler angles in radians
      _RL phiRad, thetaRad, psiRad
C     inverted rotation matrix
      _RL Ainv(3,3), Binv(3,3), Cinv(3,3), Dinv(3,3), CB(3,3)
C     cartesian coordinates
      _RL XYZgeo(3), XYZrot(3)
C     some auxilliary variables
      _RL hypotxy
CEOP

C     convert to radians
      phiRad    = phiEuler  *deg2rad
      thetaRad  = thetaEuler*deg2rad
      psiRad    = psiEuler  *deg2rad

C     create inverse of full rotation matrix
      Dinv(1,1) =  COS(phiRad)
      Dinv(1,2) = -SIN(phiRad)
      Dinv(1,3) =  0. _d 0
C
      Dinv(2,1) =  SIN(phiRad)
      Dinv(2,2) =  COS(phiRad)
      Dinv(2,3) =  0. _d 0
C
      Dinv(3,1) =  0. _d 0
      Dinv(3,2) =  0. _d 0
      Dinv(3,3) =  1. _d 0
C
      Cinv(1,1) =  1. _d 0
      Cinv(1,2) =  0. _d 0
      Cinv(1,3) =  0. _d 0
C
      Cinv(2,1) =  0. _d 0
      Cinv(2,2) =  COS(thetaRad)
      Cinv(2,3) = -SIN(thetaRad)
C
      Cinv(3,1) =  0. _d 0
      Cinv(3,2) =  SIN(thetaRad)
      Cinv(3,3) =  COS(thetaRad)
C
      Binv(1,1) =  COS(psiRad)
      Binv(1,2) = -SIN(psiRad)
      Binv(1,3) =  0. _d 0
C
      Binv(2,1) =  SIN(psiRad)
      Binv(2,2) =  COS(psiRad)
      Binv(2,3) =  0. _d 0
C
      Binv(3,1) =  0. _d 0
      Binv(3,2) =  0. _d 0
      Binv(3,3) =  1. _d 0
C     Ainv = Binv*Cinv*Dinv (matrix multiplications)
      DO jA=1,3
       DO iA=1,3
        Ainv(iA,jA) = 0. _d 0
        CB  (iA,jA) = 0. _d 0
       ENDDO
      ENDDO
      DO jA=1,3
       DO iA=1,3
        DO kA=1,3
         CB  (iA,jA) = CB  (iA,jA) + Cinv(iA,kA)*Binv(kA,jA)
        ENDDO
       ENDDO
      ENDDO
      DO jA=1,3
       DO iA=1,3
        DO kA=1,3
         Ainv(iA,jA) = Ainv(iA,jA) + Dinv(iA,kA)*CB(kA,jA)
        ENDDO
       ENDDO
      ENDDO
C

C     For each tile ...
      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)

C     loop over grid points
        DO J = 1-OLy,sNy+OLy
         DO I = 1-OLx,sNx+OLx
C     transform spherical coordinates with unit radius
C     to sphere centered cartesian coordinates
          XYZrot(1) =
     &         COS( Y(I,J,bi,bj)*deg2rad )*COS( X(I,J,bi,bj)*deg2rad )
          XYZrot(2) =
     &         COS( Y(I,J,bi,bj)*deg2rad )*SIN( X(I,J,bi,bj)*deg2rad )
          XYZrot(3) = SIN( Y(I,J,bi,bj)*deg2rad )
C     rotate cartesian coordinate (matrix multiplication)
          DO iA=1,3
           XYZgeo(iA) = 0. _d 0
          ENDDO
          DO iA=1,3
           DO jA=1,3
            XYZgeo(iA) = XYZgeo(iA) + Ainv(iA,jA)*XYZrot(jA)
           ENDDO
          ENDDO
C     tranform cartesian coordinates back to spherical coordinates
          hypotxy = SQRT( ABS(XYZgeo(1))*ABS(XYZgeo(1))
     &                  + ABS(XYZgeo(2))*ABS(XYZgeo(2)) )
          IF(XYZgeo(1) .EQ. 0. _d 0 .AND. XYZgeo(2) .EQ. 0. _d 0)THEN
C     happens exactly at the poles
           X(I,J,bi,bj) = 0. _d 0
          ELSE
           X(I,J,bi,bj) = ATAN2(XYZgeo(2),XYZgeo(1))/deg2rad
           IF ( X(I,J,bi,bj) .LT. 0. _d 0 )
     &          X(I,J,bi,bj) = X(I,J,bi,bj) + 360. _d 0
          ENDIF
          IF(hypotxy .EQ. 0. _d 0 .AND. XYZgeo(3) .EQ. 0. _d 0)THEN
C     this can not happen for a sphere with unit radius
           Y(I,J,bi,bj) = 0. _d 0
          ELSE
           Y(I,J,bi,bj) = ATAN2(XYZgeo(3),hypotxy)/deg2rad
          ENDIF
         ENDDO
        ENDDO
C     bi,bj-loops
       ENDDO
      ENDDO

      RETURN
      END

#include "ctrparam.h"
#include "ATM2D_OPTIONS.h"

C     !INTERFACE:
      SUBROUTINE NORM_OCN_FLUXES( myThid )
C     *==========================================================*
C     | Converts non-seaice quantities to MITGCM ocn sign/units. |
c     | Seaice quantities put into seaice model sign/units.      |
C     *==========================================================*
        IMPLICIT NONE

#include "ATMSIZE.h"
#include "SIZE.h"
#include "GRID.h"
#include "EEPARAMS.h"
#include "FFIELDS.h"

C     === Global SeaIce Variables ===
#include "THSICE_VARS.h"

C     === Atmos/Ocean/Seaice Interface Variables ===
#include "ATM2D_VARS.h"


C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
C     myThid - Thread no. that called this routine.
      INTEGER myThid

C     LOCAL VARIABLES:
      INTEGER i,j
      _RS nper    ! number of atm steps in a coupled period

      nper= dtcouplo/dtatmo

      DO j=1, sNy
        DO i=1, sNx

          IF (maskC(i,j,1,1,1) .EQ. 1.) THEN

            pass_runoff(i,j)= sum_runoff(i,j)/nper
            pass_precip(i,j)= sum_precip(i,j)/nper
            pass_evap(i,j)= -sum_evap(i,j)/nper   !convert sign convention here
            pass_qnet(i,j)= sum_qnet(i,j)/nper
            pass_fu(i,j)= sum_fu(i,j)/nper
            pass_fv(i,j)= sum_fv(i,j)/nper
            pass_wspeed(i,j)= sum_wspeed(i,j)/nper
            pass_solarnet(i,j)= -sum_solarnet(i,j)/nper !change sign
            pass_slp(i,j)= sum_slp(i,j)/nper*100. _d 0  !convert to Pa
            pass_pCO2(i,j)= sum_pCO2(i,j)*1. _d -6/nper

            sHeating(i,j,1,1) = sum_sHeat(i,j)/nper ! from temp-solve step
            flxCndBt(i,j,1,1)= sum_flxCnB(i,j)/nper ! from temp-solve step
            pass_PrcAtm(i,j)= sum_prcIce(i,j)/nper
            icFrwAtm(i,j,1,1)= sum_evapIce(i,j)/nper

C            pass_sIceLoad(i,j)=sIceLoad(i,j,1,1) !do this in thsice_step_fwd

C  Load the following directly into the seaice common block
            snowPrc(i,j)= sum_snowPrc(i,j)/nper

C  Double check that wspeed>0 (unlikely, but possible given anomaly coupling)
            IF ( pass_wspeed(i,j) .LT. 0. _d 0)
     &         pass_wspeed(i,j) = 0. _d 0

C  Seaice diagnostics - tally at end of coupled period
            sum_iceMask(i,j)=sum_iceMask(i,j) +
     &                       iceMask(i,j,1,1)*dtcouplo
            sum_iceHeight(i,j)= sum_iceHeight(i,j) +
     &                          iceHeight(i,j,1,1)*dtcouplo
            IF (iceMask(i,j,1,1) .NE. 0. _d 0)
     &           sum_iceTime(i,j)= sum_iceTime(i,j) + dtcouplo
            sum_oceMxLT(i,j)=sum_oceMxLT(i,j) +
     &                       tOceMxL(i,j,1,1)*dtcouplo
            sum_oceMxLS(i,j)=sum_oceMxLS(i,j) +
     &                       sOceMxL(i,j,1,1)*dtcouplo

          ENDIF

        ENDDO
      ENDDO

      CALL INIT_SUMVARS( myThid)

      RETURN
      END

#include "GAD_OPTIONS.h"

CBOP
C !ROUTINE: GAD_GRAD_X

C !INTERFACE: ==========================================================
      SUBROUTINE GAD_GRAD_X(
     I           bi,bj,k,
     I           xA,
     U           tracer,
     O           dTdx,
     I           myThid )

C !DESCRIPTION:
C Calculates the zonal gradient of a tracer: $\partial_x \theta
C = \frac{1}{\Delta x_c} \delta_i \theta$
C and multiplies by the area.

C !USES: ===============================================================
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "GRID.h"

C !INPUT PARAMETERS: ===================================================
C  bi,bj            :: tile indices
C  k                :: vertical level
C  myThid           :: thread number
      INTEGER bi,bj,k
      _RS xA    (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER myThid

C !UPDATED PARAMETERS: =================================================
C  tracer           :: tracer field
C    (NOTE: only udate the corner-halo region when using CS-grid)
      _RL tracer(1-OLx:sNx+OLx,1-OLy:sNy+OLy)

C !OUTPUT PARAMETERS: ==================================================
C  dTdx             :: zonal gradient (units = [Tr_units]*[r_units])
      _RL dTdx  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)

C !LOCAL VARIABLES: ====================================================
C  i,j              :: loop indices
      INTEGER i,j
CEOP

cph-exch2#ifndef ALLOW_AUTODIFF_TAMC
C--   Internal exchange for calculations in X
      IF (useCubedSphereExchange) THEN
        CALL FILL_CS_CORNER_TR_RL( 1, .FALSE.,
     &                             tracer, bi,bj, myThid )
      ENDIF
cph-exch2#endif

C     o Zonal tracer gradient
      DO j=1-Oly,sNy+Oly
       dTdx(1-Olx,j)=0.
       DO i=1-Olx+1,sNx+Olx
        dTdx(i,j) = xA(i,j)
     &            *_recip_dxC(i,j,bi,bj)*recip_deepFacC(k)
     &            *(tracer(i,j)-tracer(i-1,j))
#ifdef COSINEMETH_III
     &            *sqCosFacU(j,bi,bj)
#endif
#ifdef ALLOW_OBCS
     &            *maskInW(i,j,bi,bj)
#endif
       ENDDO
      ENDDO

      RETURN
      END

#include "PACKAGES_CONFIG.h"
#include "CPP_OPTIONS.h"

CBOP
C     !ROUTINE: FREEZE_SURFACE
C     !INTERFACE:
      SUBROUTINE FREEZE_SURFACE( myTime, myIter, myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R FREEZE_SURFACE
C     | o Check water temperature and limit range of temperature
C     | appropriately.
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "DYNVARS.h"
#include "GRID.h"
#include "FFIELDS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine Arguments ==
C     myTime - Current time in simulation
C     myIter - Current iteration number in simulation
C     myThid :: Thread no. that called this routine.
      _RL myTime
      INTEGER myIter
      INTEGER myThid

C     !LOCAL VARIABLES:
C     == Local variables ==
C     Tfreezing :: Freezing threshold temperature.
      INTEGER bi,bj,i,j,k
      _RL Tfreezing
CEOP

      IF ( usingPCoords ) THEN
        k = Nr
      ELSE
        k = 1
      ENDIF

      Tfreezing = -1.9 _d 0

C     Check for water that should have frozen
      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          IF (theta(i,j,k,bi,bj) .LT. Tfreezing) THEN
             adjustColdSST_diag(i,j,bi,bj) =
     &            ( Tfreezing - theta(i,j,k,bi,bj) )
     &                    *drF(k)*_hFacC(i,j,k,bi,bj) / dTtracerLev(k)
             theta(i,j,k,bi,bj) = Tfreezing
          ELSE
             adjustColdSST_diag(i,j,bi,bj) = 0. _d 0
          ENDIF
         ENDDO
        ENDDO
       ENDDO
      ENDDO

      RETURN
      END

#include "CPP_OPTIONS.h"

CBOP 0
C !ROUTINE: ATM_TO_OCN_MAPRUNOFF

C !INTERFACE:
      SUBROUTINE ATM_TO_OCN_MAPRUNOFF(
     I           fld_atm,
     O           fld_ocn,
     U           add2ocn )

C !DESCRIPTION:
C     *==========================================================*
C     | SUBROUTINE ATM_TO_OCN_MAPRUNOFF
C     | o maps RunOff from atmos. grid (land) to ocean grid
C     |    and Incorporate (substract) to ocean FreshWater flux
C     *==========================================================*

C !USES:
      IMPLICIT NONE
C     == Global variables ==
#include "ATMSIZE.h"
#include "OCNSIZE.h"
#include "CPL_MAP2GRIDS.h"

C !INPUT/OUTPUT PARAMETERS:
C     fld_atm :: Atmos. grid Run-Off field
C     fld_ocn :: Ocean grid Run-Off field (atmos field will be mapped to this)
C     add2ocn :: Ocean grid FreshWater field to update by substracting Run-Off
      _RL  fld_atm(Nx_atm*Ny_atm)
      _RL  fld_ocn(Nx_ocn*Ny_ocn)
      _RL  add2ocn(Nx_ocn*Ny_ocn)
CEOP

C !LOCAL VARIABLES:
      INTEGER n, ijo, ija

C       Set to zero everywhere
        DO ijo=1,Nx_ocn*Ny_ocn
          fld_ocn(ijo) = 0.
        ENDDO

C       Maps Runoff from land grid point to ocean grid point
C       and update oceanic FreshWater flux (substract RunOff)
        DO n=1,nROmap
          ijo=ijROocn(n)
          ija=ijROatm(n)
          fld_ocn(ijo) = fld_ocn(ijo)
     &                 + fld_atm(ija)*arROmap(n)
          add2ocn(ijo) = add2ocn(ijo)
     &                 - fld_atm(ija)*arROmap(n)
        ENDDO

      RETURN
      END

#include "FLT_OPTIONS.h"


      SUBROUTINE FLT_WRITE_PICKUP(
     I                     suff, myTime, myIter, myThid )

C     ==================================================================
C     SUBROUTINE FLT_WRITE_PICKUP
C     ==================================================================
C     o This routine writes the actual float positions to a local files
C       that can be used as restarts
C     ==================================================================

C     !USES:
      IMPLICIT NONE

C     == global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "FLT_SIZE.h"
#include "FLT.h"

C     == routine arguments ==
C     suff    :: suffix for pickup file (eg. ckptA or 0000000010)
C     myTime  :: current time
C     myIter  :: time-step number
C     myThid  :: my Thread Id number
      CHARACTER*(*) suff
      _RL myTime
      INTEGER myIter, myThid

C     == Functions ==
      INTEGER  ILNBLNK
      EXTERNAL ILNBLNK

C     == local variables ==
      CHARACTER*(MAX_LEN_FNAM) fn
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      INTEGER ioUnit, irecord
      INTEGER bi, bj, imax, iLen
      PARAMETER(imax=9)
      INTEGER ip
      _RL tmp(imax)
      _RL npart_dist
      _RS dummyRS(1)

C     == end of interface ==

      iLen = ILNBLNK(suff)
      WRITE(fn,'(A,A)') 'pickup_flt.', suff(1:iLen)
      npart_dist = 0.

      _BEGIN_MASTER( myThid )
       DO bj=1,nSy
        DO bi=1,nSx

C the standard routine mds_writevec_loc can be used here
C (1) write actual number floats and time into file

          tmp(1) = npart_tile(bi,bj)
          tmp(2) = myIter
          tmp(3) = myTime
          tmp(4) = 0.
          tmp(5) = 0.
          tmp(6) = max_npart
          tmp(7) = imax
          tmp(8) = 0.
          tmp(9) = 0.

          ioUnit = -1
          CALL MDS_WRITEVEC_LOC( fn, precFloat64, ioUnit,
     &                           'RL', imax, tmp, dummyRS,
     &                           bi,bj,-1, myIter, myThid )

          DO ip=1,npart_tile(bi,bj)

            tmp(1) =   npart(ip,bi,bj)
            tmp(2) =  tstart(ip,bi,bj)
            tmp(3) =   ipart(ip,bi,bj)
            tmp(4) =   jpart(ip,bi,bj)
            tmp(5) =   kpart(ip,bi,bj)
            tmp(6) =  kfloat(ip,bi,bj)
            tmp(7) =     iup(ip,bi,bj)
            tmp(8) =    itop(ip,bi,bj)
            tmp(9) =    tend(ip,bi,bj)

C (2) write float positions into file
            irecord = ip+1
            IF ( ip.NE.npart_tile(bi,bj) ) irecord = -irecord
            CALL MDS_WRITEVEC_LOC( fn, precFloat64, ioUnit,
     &                             'RL', imax, tmp, dummyRS,
     &                             bi,bj,irecord, myIter, myThid )

          ENDDO
          CLOSE( ioUnit )

          npart_dist = npart_dist + DBLE(npart_tile(bi,bj))

        ENDDO
       ENDDO
      _END_MASTER( myThid )

      _GLOBAL_SUM_RL( npart_dist, myThid )
      _BEGIN_MASTER( myThid )
        WRITE(msgBuf,'(A,F16.2,A)') ' FLT_WRITE_PICKUP:',
     &                  npart_dist, ' floats written'
        CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
      _END_MASTER( myThid )

      RETURN
      END

!=======================================================================
      subroutine coupsend_r8( component, dataname, Nx, Ny, arr )
      implicit none
! Predefined constants/arrays
#include "CPLR_SIG.h"
! MPI variables
#include "mpif.h"
! Arguments
      character*(*) component
      character*(*) dataname
      integer Nx,Ny
      real*8 arr(Nx,Ny)
! Functions
      integer mitcplr_match_comp
      integer generate_tag
      external mitcplr_match_comp
      external generate_tag
! Local
      integer count,dtype,dest,tag,comm,ierr
      integer compind,numprocs
      integer i,j,ij,n
      integer Ni,Io,Nj,Jo
!     ------------------------------------------------------------------

! Establish who I am communicating with
      compind=mitcplr_match_comp( component )
      if (compind.le.0) stop 'coupsend_r8: Bad component id'
      comm=MPI_COMM_compcplr( compind )
      numprocs=num_component_procs(compind)
      if (numprocs.lt.1) then
       write(LogUnit,*) 'coupsend_r8: compind = ',compind
       stop 'coupsend_r8: numprocs < 1'
      endif
      if (VERB)
     &  write(LogUnit,*) 'coupsend_r8: ',component_Name(compind)
      if (VERB)
     &  write(LogUnit,*) 'coupsend_r8: dataname=',dataname

! Foreach component process
      do n=1,numprocs

! Create header
       Io=component_tile_i0(1,n,compind)
       Jo=component_tile_j0(1,n,compind)
       Ni=component_tile_nx(1,n,compind)
       Nj=component_tile_ny(1,n,compind)
       r8buf(1)=float( Io )
       r8buf(2)=float( Jo )
       r8buf(3)=float( Ni )
       r8buf(4)=float( Nj )
       call mitcplr_char2dbl( dataname, r8buf(9) )

! Pack data
       do j=1,Nj
        do i=1,Ni
         ij=HEADER_SIZE+i+Ni*(j-1)
         r8buf(ij)=arr(Io+i-1,Jo+j-1)
        enddo
       enddo

! Send message
       count=HEADER_SIZE+Ni*Nj
       dtype=MPI_DOUBLE_PRECISION
       tag=generate_tag(121,n,dataname)
       dest=rank_component_procs(n,compind)

       if (VERB) then
        write(LogUnit,*) 'coupsend_r8: calling MPI_Send dest=',dest,
     &    ' proc=',n,'/',numprocs
        call flush(LogUnit)
       endif
       call MPI_Send( r8buf, count, dtype, dest, tag, comm, ierr )
       if (VERB) then
        write(LogUnit,*) 'coupsend_r8: returned ierr=',ierr
        call flush(LogUnit)
       endif

       if (ierr.ne.0) then
        write(LogUnit,*) 'coupsend_r8tiles: rank(W,G)=',
     &            my_rank_in_world,my_rank_in_global,
     &            ' ierr=',ierr
        stop 'coupsend_r8: MPI_Send failed'
       endif

      enddo ! n

!     ------------------------------------------------------------------
      return
      end
!=======================================================================

#include "GMREDI_OPTIONS.h"

C     !ROUTINE: EIGENVAL
C     !INTERFACE:
      SUBROUTINE GMREDI_CALC_URMS(
     I     iMin, iMax, jMin, jMax,
     I     bi, bj, N2, myThid,
     U     urms)

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE GMREDI_CALC_URMS
C     | o Calculate the vertical structure of the rms eddy
C     |   velocity based on baroclinic modal decomposition
C     *==========================================================*
C     \ev

      IMPLICIT NONE

C     == Global variables ==
#include "SIZE.h"
#include "GRID.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GMREDI.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     bi, bj    :: tile indices
      INTEGER iMin,iMax,jMin,jMax
      INTEGER bi, bj
      INTEGER myThid
      _RL N2(  1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL urms(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)

#ifdef GM_BATES_K3D

C     !LOCAL VARIABLES:
C     == Local variables ==
      INTEGER i,j,k
C     bbs   :: bottom boundary condition (set to zero for now)
C     const :: a constant for each water column
      _RL bbc(   1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL const( 1-OLx:sNx+OLx,1-OLy:sNy+OLy)

C     Constant zero bottom boundary condition
      DO j=1-OLy,sNy+OLy
       DO i=1-OLx,sNx+OLx
        bbc(i,j) = zeroRL
       ENDDO
      ENDDO

C     Fit urms to the first baroclinic mode using the SBC and BBC
C     We need at least two cells to do this
      DO j=1-OLy,sNy+OLy
       DO i=1-OLx,sNx+OLx
        k = kLowC(i,j,bi,bj)
        IF (k.GT.2) THEN
          const(i,j) = (urms(i,j,k)-urms(i,j,1))
     &         /(modesC(1,i,j,k,bi,bj)-modesC(1,i,j,1,bi,bj))
        ELSE
          const(i,j) = zeroRL
        ENDIF
       ENDDO
      ENDDO

      DO k=2,Nr
       DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
         IF (k.LT.kLowC(i,j,bi,bj)) THEN
           urms(i,j,k) = urms(i,j,1) +
     &          const(i,j)*(modesC(1,i,j,k,bi,bj)-modesC(1,i,j,1,bi,bj))
         ELSE
           urms(i,j,k)=zeroRL
         ENDIF
        ENDDO
       ENDDO
      ENDDO

C     Land, so, we fill with zeros
      DO j=1-OLy,sNy+OLy
       DO i=1-OLx,sNx+OLx
        if (kLowC(i,j,bi,bj).EQ.0) urms(i,j,1) = zeroRL
       ENDDO
      ENDDO

#endif /* GM_BATES_K3D */

      RETURN
      END

#include "EXF_OPTIONS.h"

CBOP
C     !ROUTINE: EXF_ADJOINT_SNAPSHOTS
C     !INTERFACE:
      SUBROUTINE EXF_ADJOINT_SNAPSHOTS(
     I               iwhen, myTime, myIter, myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE EXF_ADJOINT_SNAPSHOTS                         |
C     *==========================================================*
C     Forward version of EXF Adjoint-variable output subroutine:
C     does nothing to forward variables version (empty S/R) but
C     argument list matters (for ADM and TLM version and calls)
C     *==========================================================*
C     | SUBROUTINE EXF_ADJOINT_SNAPSHOTS                         |
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     == Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     iwhen  :: indicates where this S/R is called from
C     myIter :: Iteration counter for this thread
C     myTime :: Time counter for this thread
C     myThid :: Thread number for this instance of the routine.
      INTEGER iwhen
      _RL     myTime
      INTEGER myIter
      INTEGER myThid

C     !LOCAL VARIABLES:
C     msgBuf :: Error message buffer
c     CHARACTER*(MAX_LEN_MBUF) msgBuf
CEOP

      RETURN
      END

#include "MONITOR_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: MON_OUT_I

C     !INTERFACE:
      SUBROUTINE MON_OUT_I( pref, value, foot, myThid )

C     !DESCRIPTION:
C     Formatted integer I/O for monitor print out.

C     !INPUT PARAMETERS:
C     pref   - Field prefix ( ignored if == mon_string_none )
C     value  - Value to print
C     foot   - Field suffix ( ignored if == mon_string_none )
      CHARACTER*(*) pref
      INTEGER       value
      CHARACTER*(*) foot
      INTEGER  myThid
CEOP

      CALL MON_OUT_ALL(pref, foot, 1, value, 0.0d0, myThid)
      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: MON_OUT_RS

C     !INTERFACE:
      SUBROUTINE MON_OUT_RS( pref, value, foot, myThid )

C     !DESCRIPTION:
C     Formatted RS I/O for monitor print out.

C     !INPUT PARAMETERS:
C     pref   - Field prefix ( ignored if == mon_string_none )
C     value  - Value to print
C     foot   - Field suffix ( ignored if == mon_string_none )
      CHARACTER*(*) pref
      _RS           value
      CHARACTER*(*) foot
      INTEGER  myThid
CEOP
      REAL*8 dtmp
      dtmp = value

      CALL MON_OUT_ALL(pref, foot, 2, 0, dtmp, myThid)
      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: MON_OUT_RL

C     !INTERFACE:
      SUBROUTINE MON_OUT_RL( pref, value, foot, myThid )

C     !DESCRIPTION:
C     Formatted RL I/O for monitor print out.

C     !INPUT PARAMETERS:
C     pref   - Field prefix ( ignored if == mon_string_none )
C     value  - Value to print
C     foot   - Field suffix ( ignored if == mon_string_none )
      CHARACTER*(*) pref
      _RL           value
      CHARACTER*(*) foot
      INTEGER  myThid
CEOP
      REAL*8 dtmp
      dtmp = value

      CALL MON_OUT_ALL(pref, foot, 2, 0, dtmp, myThid)
      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 1
C     !ROUTINE: MON_OUT_ALL

C     !INTERFACE:
      SUBROUTINE MON_OUT_ALL(
     I     pref, foot,
     I     itype, ival, dval,
     I     myThid )

C     !DESCRIPTION:
C     Formatted I/O for monitor output.

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "MONITOR.h"

C     !INPUT PARAMETERS:
C     pref   - Field prefix ( ignored if == mon_string_none )
C     foot   - Field suffix ( ignored if == mon_string_none )
      CHARACTER*(*) pref, foot
      INTEGER itype
      INTEGER ival
      REAL*8  dval
      INTEGER myThid
CEOP

C     === Functions ====
      INTEGER IFNBLNK
      INTEGER ILNBLNK
      LOGICAL  MASTER_CPU_IO
      EXTERNAL MASTER_CPU_IO

C     !LOCAL VARIABLES:
C     msgBuf - Buffer for building output string
C     lBuf   - Buffer for length
C     I0     - Temps used in calculating string length
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      INTEGER  lBuf
      INTEGER  i, I0,I1, IL
      CHARACTER*(100) mon_vname
      INTEGER  nvname
      INTEGER  ivarr(1)
      REAL*8   dvarr(1)

      IF ( MASTER_CPU_IO(myThid) ) THEN

        ivarr(1) = ival
        dvarr(1) = dval

        msgBuf = ' '
        lBuf   = 0

        DO i = 1,100
          mon_vname(i:i) = ' '
        ENDDO

        I0 = IFNBLNK(mon_head)
        I1 = ILNBLNK(mon_head)
        IL = I1-I0+1
        IF ( IL .GT. 0 .AND. lBuf+IL+1 .LE. MAX_LEN_MBUF ) THEN
          msgBuf(1:IL) = mon_head
          lBuf = IL+1
          msgBuf(lBuf:lBuf) = ' '
        ENDIF

        IF ( mon_pref(1:mon_prefL) .NE. mon_string_none .AND.
     &       lBuf+mon_prefL+1      .LE. MAX_LEN_MBUF ) THEN
          lBuf = lBuf+1
          msgBuf(lBuf:lBuf+mon_prefL-1) = mon_pref(1:mon_prefL)
          lBuf = lBuf+mon_prefL-1
          mon_vname(1:mon_prefL) = mon_pref(1:mon_prefL)
          nvname = mon_prefL
        ELSE
          nvname = 0
        ENDIF

        I0 = IFNBLNK(pref)
        I1 = ILNBLNK(pref)
        IL = I1-I0+1
        IF ( IL .GT. 0 ) THEN
          IF ( pref(I0:I1) .NE. mon_string_none .AND.
     &         lBuf+IL+1   .LE. MAX_LEN_MBUF ) THEN
            lBuf = lBuf+1
            msgBuf(lBuf:lBuf+IL-1) = pref(I0:I1)
            lBuf = lBuf+IL-1
            mon_vname((nvname+1):(nvname+IL)) = pref(I0:I1)
            nvname = nvname + IL
          ENDIF
        ENDIF

        I0 = IFNBLNK(foot)
        I1 = ILNBLNK(foot)
        IL = I1-I0+1
        IF ( IL .GT. 0 ) THEN
          IF ( foot(I0:I1) .NE. mon_string_none .AND.
     &         lBuf+IL+1   .LE. MAX_LEN_MBUF ) THEN
            lBuf = lBuf+1
            msgBuf(lBuf:lBuf+IL-1) = foot(I0:I1)
            lBuf = lBuf+IL-1
            mon_vname((nvname+1):(nvname+IL)) = foot(I0:I1)
            nvname = nvname + IL
          ENDIF
        ENDIF

C       write(*,*) 'mon_vname = ''', mon_vname(1:nvname), ''''
C       write(*,*) 'mon_write_mnc = ''', mon_write_mnc, ''''
C       write(*,*) 'mon_write_stdout = ''', mon_write_stdout, ''''

        msgBuf(35:35) = '='

        IF (mon_write_stdout) THEN
          IF (itype .EQ. 1)
     &         WRITE(msgBuf(36:57),'(1X,I21)')       ival
          IF (itype .EQ. 2)
     &         WRITE(msgBuf(36:57),'(1X,1P1E21.13)') dval
C       &           WRITE(msgBuf(35:57),'(1X,1P1E22.13E3)') dval

C         Note that the above call fixes problems where there is
C         insufficient space in the output format to handle variables
C         such as 1.234500000E107 which, although they are wildly large,
C         they may actually happen in some situations.  But, changing
C         the monitor output format also means changing the routines
C         that parse the monitor output for testreport.

          CALL PRINT_MESSAGE(msgBuf, mon_ioUnit, SQUEEZE_RIGHT, 1)
        ENDIF

#ifdef ALLOW_MNC
        IF (useMNC .AND. mon_write_mnc) THEN
          CALL MNC_CW_APPEND_VNAME(
     &         mon_vname, '-_-_--__-__t', 0,0, myThid)
          IF (itype .EQ. 1)
     &         CALL MNC_CW_I_W(
     &         'I',mon_fname,1,1,mon_vname, ivarr, myThid)
          IF (itype .EQ. 2)
     &         CALL MNC_CW_RL_W(
     &         'D',mon_fname,1,1,mon_vname, dvarr, myThid)
        ENDIF
#endif /*  ALLOW_MNC  */

C--   endif master cpu io
      ENDIF

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#include "MNC_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 0
C     !ROUTINE: MNC_UPDATE_TIME

C     !INTERFACE:
      SUBROUTINE MNC_UPDATE_TIME(
     I                            myTime, myIter,  myThid )

C     !DESCRIPTION:
C     Update MNC time and iteration information

C     !USES:
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "MNC_PARAMS.h"

C     !INPUT PARAMETERS:
C     myTime   :: my current time in simulation
C     myIter   :: my current iteration number in simulation
C     myThid   :: my Thread Id. number
      _RL     myTime
      INTEGER myIter
      INTEGER myThid
CEOP

#ifdef ALLOW_MNC
C     !FUNCTIONS:
      EXTERNAL DIFFERENT_MULTIPLE
      LOGICAL  DIFFERENT_MULTIPLE

C     !LOCAL VARIABLES:

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

c     IF ( useMNC ) THEN

C     Update the default next iter for MNC
         CALL MNC_CW_CITER_SETG( 1, 1, -1, myIter , myThid )

C        TODO: Logic should be added here so that users can specify, on
C        a per-citer-group basis, when it is time to update the
C        "current" (and not just the "next") iteration

C        TODO: the following is just a temporary band-aid (mostly, for
C        Baylor) until someone writes a routine that better handles time
C        boundaries such as weeks, months, years, etc.
         IF ( mnc_filefreq .GT. 0 ) THEN
           IF (DIFFERENT_MULTIPLE(mnc_filefreq,myTime,deltaTClock))
     &          THEN
             CALL MNC_CW_CITER_SETG( 1, 1, myIter, -1 , myThid )
           ENDIF
         ENDIF

c     ENDIF
#endif /* ALLOW_MNC */

      RETURN
      END

#include "DIC_OPTIONS.h"

CBOP
C !ROUTINE: PHOS_FLUX

C !INTERFACE: ==========================================================
      SUBROUTINE PHOS_FLUX( BIOac, pflux, exportflux,
     I           bi,bj,imin,imax,jmin,jmax,
     I           myTime, myIter, myThid )

C !DESCRIPTION:
C Calculate the PO4 flux to depth from bio activity

C !USES: ===============================================================
      IMPLICIT NONE
#include "SIZE.h"
#include "DYNVARS.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "DIC_VARS.h"

C !INPUT PARAMETERS: ===================================================
C  BIOac                :: biological productivity
C  myTime               :: current time
C  myIter               :: current timestep
C  myThid               :: thread number
      _RL  BIOac(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      INTEGER imin, imax, jmin, jmax, bi, bj
      _RL myTime
      INTEGER myIter
      INTEGER myThid

C !OUTPUT PARAMETERS: ===================================================
C  pflux                :: changes to PO4 due to flux and reminerlization
      _RL pflux     (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL exportflux(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)

#if (defined ALLOW_PTRACERS && defined DIC_BIOTIC)

C !LOCAL VARIABLES: ====================================================
C  i,j,k                  :: loop indices
c  ko                     :: loop-within-loop index
c  bexport                :: flux of phosphorus from base each "productive"
c                            layer
c  depth_l                :: depth and lower interface
c  flux_u, flux_l         :: flux through upper and lower interfaces
c  reminFac               :: abbreviation
c  zbase                  :: depth of bottom of current productive layer
      INTEGER i,j,k, ko, kop1
      _RL zbase
      _RL bexport(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL reminFac
      _RL depth_l
      _RL flux_u (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL flux_l
CEOP

C- Calculate PO4 flux from base of each layer
      DO k=1,nlev
       DO j=jmin,jmax
        DO i=imin,imax
         bexport(i,j) = 0. _d 0
         IF ( _hFacC(i,j,k,bi,bj).gt.0. _d 0 ) THEN
C--   If no layer below initial layer (because of bottom or
C--   topography), then remineralize in here
          IF (k.EQ.Nr) THEN
           pflux(i,j,k)=pflux(i,j,k)+BIOac(i,j,k)*(1. _d 0-DOPfraction)
          ELSEIF (hFacC(i,j,k+1,bi,bj).EQ.0. _d 0) THEN
           pflux(i,j,k)=pflux(i,j,k)+BIOac(i,j,k)*(1. _d 0-DOPfraction)
          ELSE
C- flux out of layer k
           bexport(i,j)=BIOac(i,j,k)*(1. _d 0-DOPfraction)
     &          *drF(k) * _hFacC(i,j,k,bi,bj)
          ENDIF
         ENDIF
        ENDDO
       ENDDO
C--   If available, flux phosphate downward;
C--   calculate flux to each layer from base of k
       zbase=-rF(k+1)
C--   Upper flux
       DO j=jmin,jmax
        DO i=imin,imax
         flux_u(i,j)  = bexport(i,j)
        ENDDO
       ENDDO
C     Instead of running the loop to ko=Nr and masking the last
C     flux_l, let ko reach only Nr-1 and do a special loop for ko=Nr,
C     in order to save a few expensive exp-function calls
       DO ko=k+1,Nr-1
        kop1   = MIN(Nr,ko+1)
#ifndef NONLIN_FRSURF
C     For the linear free surface, hFacC can be omitted, buying another
C     performance increase of a factor of six on a vector computer.
C     For now this is not implemented via run time flags, in order to
C     avoid making this code too complicated.
        depth_l  = -rF(ko) + drF(ko)
C       reminFac = (depth_l/zbase)**(-Kremin)
C     The following form does the same, but is faster
        reminFac = exp(-Kremin*log(depth_l/zbase))
#endif
        DO j=jmin,jmax
         DO i=imin,imax
          IF ( bexport(i,j) .NE. 0. _d 0 ) THEN
C--   Lower flux (no flux to ocean bottom)
#ifdef NONLIN_FRSURF
           depth_l  = -rF(ko) + drF(ko) * _hFacC(i,j,ko,bi,bj)
C          reminFac = (depth_l/zbase)**(-Kremin)
C     The following form does the same, but is faster
           reminFac = exp(-Kremin*log(depth_l/zbase))
#endif
           flux_l   = bexport(i,j)*reminFac
     &          *maskC(i,j,kop1,bi,bj)
C
           pflux(i,j,ko)=pflux(i,j,ko) + (flux_u(i,j)-flux_l)
     &          *recip_drF(ko) * _recip_hFacC(i,j,ko,bi,bj)
           exportflux(i,j,ko)=exportflux(i,j,ko)+flux_u(i,j)
C--   Store flux through upper layer for the next k-level
           flux_u(i,j) = flux_l
C     endif bexport .ne. 0
          ENDIF
C     i,j-loops
         ENDDO
        ENDDO
C     ko-loop
       ENDDO
C     now do ko = Nr
       ko = Nr
       flux_l = 0. _d 0
       DO j=jmin,jmax
        DO i=imin,imax
         pflux(i,j,ko)=pflux(i,j,ko) + (flux_u(i,j)-flux_l)
     &        *recip_drF(ko) * _recip_hFacC(i,j,ko,bi,bj)
         exportflux(i,j,ko)=exportflux(i,j,ko)+flux_u(i,j)
        ENDDO
       ENDDO
C     k-loop
      ENDDO
c
#endif /* defined ALLOW_PTRACERS && defined DIC_BIOTIC */
      RETURN
      END

#include "CPP_EEOPTIONS.h"

CBOP
C     !ROUTINE: EEWRITE_EEENV

C     !INTERFACE:
      SUBROUTINE EEWRITE_EEENV

C     !DESCRIPTION:
C     *==========================================================*
C     | SUBROUTINE EERWITE\_EEENV
C     | o Write execution environment summary
C     *==========================================================*
C     | Write a summary of the execution environment as
C     | configured for this run. The execution environment is
C     | the computational mode in which the model operatoes. It
C     | includes the computational grid but does not include any
C     | model specific numerical parameters.
C     *==========================================================*

C     !USES:
      IMPLICIT NONE
C     == Global data ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "EESUPPORT.h"

C     !LOCAL VARIABLES:
C     == Local variables ==
C     msgBuf :: Temp. for building text messages.
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      CHARACTER*(8) fmtStr
      INTEGER iTmp
CEOP

      iTmp = MAX(5,1 + INT(LOG10(DFLOAT(MAX(Nx,Ny)))))
      WRITE(fmtStr,'(A,I1,A)') '(A,I',iTmp,',A)'

      WRITE(msgBuf,'(A)')
     & '// ======================================================='
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &  SQUEEZE_RIGHT , 1)

      WRITE(msgBuf,'(A)')
     & '// Computational Grid Specification ( see files "SIZE.h" )'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &  SQUEEZE_RIGHT , 1)

      WRITE(msgBuf,'(A)')
     & '//                                  ( and "eedata"       )'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &  SQUEEZE_RIGHT , 1)

      WRITE(msgBuf,'(A)')
     & '// ======================================================='
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &  SQUEEZE_RIGHT , 1)

      WRITE(msgBuf,fmtStr) '     nPx =',nPx,
     & ' ; /* No. processes in X */'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &  SQUEEZE_RIGHT , 1)

      WRITE(msgBuf,fmtStr) '     nPy =',nPy,
     & ' ; /* No. processes in Y */'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &  SQUEEZE_RIGHT , 1)

      WRITE(msgBuf,fmtStr) '     nSx =',nSx,
     & ' ; /* No. tiles in X per process */'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &  SQUEEZE_RIGHT , 1)

      WRITE(msgBuf,fmtStr) '     nSy =',nSy,
     & ' ; /* No. tiles in Y per process */'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &  SQUEEZE_RIGHT , 1)

      WRITE(msgBuf,fmtStr) '     sNx =',sNx,
     & ' ; /* Tile size in X */'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &  SQUEEZE_RIGHT , 1)

      WRITE(msgBuf,fmtStr) '     sNy =',sNy,
     & ' ; /* Tile size in Y */'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &  SQUEEZE_RIGHT , 1)

      WRITE(msgBuf,fmtStr) '     OLx =',OLx,
     & ' ; /* Tile overlap distance in X */'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &  SQUEEZE_RIGHT , 1)

      WRITE(msgBuf,fmtStr) '     OLy =',OLy,
     & ' ; /* Tile overlap distance in Y */'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &  SQUEEZE_RIGHT , 1)

      WRITE(msgBuf,fmtStr) '     nTx =',nTx,
     & ' ; /* No. threads in X per process */'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &  SQUEEZE_RIGHT , 1)

      WRITE(msgBuf,fmtStr) '     nTy =',nTy,
     & ' ; /* No. threads in Y per process */'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &  SQUEEZE_RIGHT , 1)

      WRITE(msgBuf,fmtStr) '      Nr =', Nr,
     & ' ; /* No. levels in the vertical   */ '
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &  SQUEEZE_RIGHT , 1)

      WRITE(msgBuf,fmtStr) '      Nx =', Nx,
     & ' ; /* Total domain size in X ( = nPx*nSx*sNx ) */'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &  SQUEEZE_RIGHT , 1)

      WRITE(msgBuf,fmtStr) '      Ny =', Ny,
     & ' ; /* Total domain size in Y ( = nPy*nSy*sNy ) */'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &  SQUEEZE_RIGHT , 1)

      WRITE(msgBuf,fmtStr) '  nTiles =', nSx*nSy,
     & ' ; /* Total no. tiles per process ( = nSx*nSy ) */'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &  SQUEEZE_RIGHT , 1)

      WRITE(msgBuf,fmtStr) '  nProcs =', nPx*nPy,
     & ' ; /* Total no. processes ( = nPx*nPy ) */'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &  SQUEEZE_RIGHT , 1)

      WRITE(msgBuf,fmtStr) 'nThreads =', nTx*nTy,
     & ' ; /* Total no. threads per process ( = nTx*nTy ) */'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &  SQUEEZE_RIGHT , 1)

      WRITE(fmtStr,'(A,I1,A)') '(A,L',iTmp,',A)'
      WRITE(msgBuf,fmtStr) 'usingMPI =', usingMPI,
     & ' ; /* Flag used to control whether MPI is in use */'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &  SQUEEZE_RIGHT , 1)

      WRITE(fmtStr,'(A,I1,A)') '(A,A',iTmp,',A)'
      WRITE(msgBuf,fmtStr) '          ', '     ' ,
     & '   /*  note: To execute a program with MPI calls */'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &  SQUEEZE_RIGHT , 1)

      WRITE(msgBuf,fmtStr) '          ', '     ' ,
     & '   /*  it must be launched appropriately e.g     */'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &  SQUEEZE_RIGHT , 1)

      WRITE(msgBuf,fmtStr) '          ', '     ' ,
     & '   /*  "mpirun -np 64 ......"                    */'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &  SQUEEZE_RIGHT , 1)

      WRITE(fmtStr,'(A,I1,A)') '(A,L',iTmp-1,',A)'
      WRITE(msgBuf,fmtStr) 'useCoupler=', useCoupler,
     & ' ; /* Flag used to control communications with   */'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &  SQUEEZE_RIGHT , 1)
      WRITE(fmtStr,'(A,I1,A)') '(A,A',iTmp,',A)'
      WRITE(msgBuf,fmtStr)  '           ', '     ',
     & '  /*  other model components, through a coupler */'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &  SQUEEZE_RIGHT , 1)

      WRITE(msgBuf,'(A,L5,A)') 'useNest2W_parent =', useNest2W_parent,
     & ' ;/* Control 2-W Nesting comm */'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &  SQUEEZE_RIGHT , 1)
      WRITE(msgBuf,'(A,L5,A)') 'useNest2W_child  =', useNest2W_child,
     & ' ;/* Control 2-W Nesting comm */'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &  SQUEEZE_RIGHT , 1)

      WRITE(msgBuf,'(A,L5,A)') 'debugMode =', debugMode,
     & ' ; /* print debug msg. (sequence of S/R calls)  */'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT , 1)
      WRITE(msgBuf,'(A,L5,A)')
     &  'printMapIncludesZeros=', printMapIncludesZeros,
     &  ' ; /* print zeros in Std.Output maps */'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT , 1)
      WRITE(msgBuf,'(A,I5,A)') 'maxLengthPrt1D=', maxLengthPrt1D,
     &           ' /* maxLength of 1D array printed to StdOut */'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT , 1)

      WRITE(msgBuf,'(A)') '                '
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &  SQUEEZE_RIGHT , 1)

      RETURN
      END

#include "SEAICE_OPTIONS.h"
#ifdef ALLOW_AUTODIFF
# include "AUTODIFF_OPTIONS.h"
#endif

C--  File seaice_calc_stressdiv.F
C--   Contents
C--   o SEAICE_CALC_STRESSDIV
C--   o SEAICE_CALC_STRESS

CBOP
C !ROUTINE: SEAICE_CALC_STRESSDIV
C !INTERFACE: ==========================================================
      SUBROUTINE SEAICE_CALC_STRESSDIV(
     I     e11, e22, e12, press, zeta, eta, etaZ,
     O     stressDivergenceX, stressDivergenceY,
     I     bi, bj, myTime, myIter, myThid )

C !DESCRIPTION: \bv
C     *===========================================================*
C     | SUBROUTINE SEAICE_CALC_STRESSDIV
C     | o compute ice internal stress divergence
C     |
C     | Martin Losch, May 2017, Martin.Losch@awi.de
C     *===========================================================*
C \ev

C !USES: ===============================================================
      IMPLICIT NONE

#include "SIZE.h"
#include "EEPARAMS.h"
#include "GRID.h"
#include "SEAICE_GRID.h"

C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
C     e11/e22/e12 :: strain rate tensor components
C     press  :: maximal compressive strength
C     zeta   :: bulk viscosity
C     eta    :: shear viscosity
C     etaZ   :: shear viscosity at vorticity points
C     stressDivergenceX/Y :: x/y-component of stress divergence
C     myTime :: Simulation time
C     myIter :: Simulation timestep number
C     myThid :: my Thread Id. number
      _RL e11  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL e22  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL e12  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL press(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL zeta (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL eta  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL etaZ (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL stressDivergenceX(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL stressDivergenceY(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      INTEGER bi, bj
      _RL     myTime
      INTEGER myIter
      INTEGER myThid
CEOP

#ifdef SEAICE_CGRID
C !LOCAL VARIABLES: ====================================================
C     === Local variables ===
C     i,j       :: inner loop counters
      _RL sig11(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL sig22(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL sig12(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER i, j

      CALL SEAICE_CALC_STRESS(
     I     e11, e22, e12, press, zeta, eta, etaZ,
     O     sig11, sig22, sig12,
     I     bi, bj, myTime, myIter, myThid )

C     compute divergence of stress tensor

      DO j=1,sNy+1
       DO i=1,sNx+1
        stressDivergenceX(i,j,bi,bj) =
     &       ( sig11(i  ,j  ) * _dyF(i  ,j,bi,bj)
     &       - sig11(i-1,j  ) * _dyF(i-1,j,bi,bj)
     &       + sig12(i  ,j+1) * _dxV(i,j+1,bi,bj)
     &       - sig12(i  ,j  ) * _dxV(i,j  ,bi,bj)
     &       ) * recip_rAw(i,j,bi,bj)
C     extra metric terms
     &       + k2AtU(i,j,bi,bj) * halfRL*( sig12(i,j) + sig12(i,j+1) )
     &       - k1AtU(i,j,bi,bj) * halfRL*( sig22(i,j) + sig22(i-1,j) )
        stressDivergenceY(i,j,bi,bj) =
     &       ( sig22(i  ,j  ) * _dxF(i,j  ,bi,bj)
     &       - sig22(i  ,j-1) * _dxF(i,j-1,bi,bj)
     &       + sig12(i+1,j  ) * _dyU(i+1,j,bi,bj)
     &       - sig12(i  ,j  ) * _dyU(i  ,j,bi,bj)
     &       ) * recip_rAs(i,j,bi,bj)
C     extra metric terms
     &       + k1AtV(i,j,bi,bj) * halfRL*( sig12(i,j) + sig12(i+1,j) )
     &       - k2AtV(i,j,bi,bj) * halfRL*( sig11(i,j) + sig11(i,j-1) )
       ENDDO
      ENDDO

      RETURN
      END

CBOP
C !ROUTINE: SEAICE_CALC_STRESS
C !INTERFACE: ==========================================================
      SUBROUTINE SEAICE_CALC_STRESS(
     I     e11, e22, e12, press, zeta, eta, etaZ,
     O     sig11, sig22, sig12,
     I     bi, bj, myTime, myIter, myThid )

C !DESCRIPTION: \bv
C     *===========================================================*
C     | SUBROUTINE SEAICE_CALC_STRESS
C     | o compute ice internal stress according to rheology
C     |
C     | Martin Losch, May 2017, Martin.Losch@awi.de
C     *===========================================================*
C \ev

C !USES: ===============================================================
      IMPLICIT NONE

#include "SIZE.h"
#include "EEPARAMS.h"
#include "GRID.h"

C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
C     myTime :: Simulation time
C     myIter :: Simulation timestep number
C     myThid :: my Thread Id. number
C     e11/e22/e12 :: strain rate tensor components
C     press  :: maximal compressive strength
C     zeta   :: bulk viscosity
C     eta    :: shear viscosity
C     etaZ   :: shear viscosity at vorticity points
C     sig11/sig22/sig12   :: stress tensor components
      _RL     myTime
      INTEGER myIter
      INTEGER myThid
      INTEGER bi, bj
      _RL e11  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL e22  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL e12  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL press(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL zeta (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL eta  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL etaZ (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL sig11(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL sig22(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL sig12(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
CEOP

C !LOCAL VARIABLES: ====================================================
C     === Local variables ===
C     i,j           :: inner loop counters
C     eplus, eminus :: convenient abbreviations for e11+e22, e11-e22
      INTEGER i, j
      _RL     eplus, eminus

C     compute components of stress tensor from current strain rate tensor
      DO j=1-OLy,sNy+OLy
       DO i=1-OLx,sNx+OLx
        sig11(i,j) = 0. _d 0
        sig22(i,j) = 0. _d 0
        sig12(i,j) = 0. _d 0
       ENDDO
      ENDDO

      DO j=0,sNy+1
       DO i=0,sNx+1
        eplus = e11(i,j,bi,bj) + e22(i,j,bi,bj)
        eminus= e11(i,j,bi,bj) - e22(i,j,bi,bj)
        sig11(i,j) = zeta(i,j,bi,bj)*eplus + eta(i,j,bi,bj)*eminus
     &       - 0.5 _d 0 * press(i,j,bi,bj)
        sig22(i,j) = zeta(i,j,bi,bj)*eplus - eta(i,j,bi,bj)*eminus
     &       - 0.5 _d 0 * press(i,j,bi,bj)
       ENDDO
      ENDDO

      DO j=1,sNy+2
       DO i=1,sNx+2
        sig12(i,j) = 2. _d 0 * e12(i,j,bi,bj) * etaZ(i,j,bi,bj)
       ENDDO
      ENDDO
#endif /* SEAICE_CGRID */
      RETURN
      END

#include "DIAG_OPTIONS.h"

C--   File diagnostics_fill_field.F:
C--    Contents:
C--    o DIAGNOSTICS_FILL_FIELD
C--    o DIAGNOSTICS_HF_CUMUL
C--    o DIAGNOSTICS_CUMULATE

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: DIAGNOSTICS_FILL_FIELD
C     !INTERFACE:
      SUBROUTINE DIAGNOSTICS_FILL_FIELD(
     I               inpFldRL, fracFldRL, inpFldRS, fracFldRS,
     I               scaleFact, power, arrType, nLevFrac,
     I               ndId, ipointer, kLev, nLevs,
     I               bibjFlg, biArg, bjArg, myThid )

C     !DESCRIPTION:
C***********************************************************************
C   Increment the diagnostics array with a 2D/3D field
C     using a scaling factor & square option (power=2),
C     and with the option to use a fraction-weight (assumed
C         to be the counter-mate of the current diagnostics)
C***********************************************************************
C     !USES:
      IMPLICIT NONE

C     == Global variables ===
#include "EEPARAMS.h"
#include "SIZE.h"
#include "DIAGNOSTICS_SIZE.h"
#include "DIAGNOSTICS.h"

C     !INPUT PARAMETERS:
C***********************************************************************
C  Arguments Description
C  ----------------------
C     inpFldRL  :: Field to increment diagnostics array (arrType=0,1)
C     fracFldRL :: fraction used for weighted average diagnostics (arrType=0,2)
C     inpFldRS  :: Field to increment diagnostics array (arrType=2,3)
C     fracFldRS :: fraction used for weighted average diagnostics (arrType=1,3)
C     scaleFact :: scaling factor
C     power     :: option to fill-in with the field square (power=2)
C     arrType   :: select which array & fraction (RL/RS) to process:
C                  0: both RL ; 1: inpRL & fracRS ; 2: inpRS,fracRL ; 3: both RS
C     nLevFrac  :: >0: number of levels of the fraction field ; =0: no fraction
C               :: used ; =-1: use thickness factor "hFac"
C     ndId      :: Diagnostics Id number (in available diag list) of diag to process
C     ipointer  :: Pointer to the slot in qdiag to fill
C     kLev      :: Integer flag for vertical levels:
C                  > 0 (any integer): WHICH single level to increment in qdiag.
C                  0,-1 to increment "nLevs" levels in qdiag,
C                  0 : fill-in in the same order as the input array
C                  -1: fill-in in reverse order.
C     nLevs     :: indicates Number of levels of the input field array
C                  (whether to fill-in all the levels (kLev<1) or just one (kLev>0))
C     bibjFlg   :: Integer flag to indicate instructions for bi bj loop
C                  0 indicates that the bi-bj loop must be done here
C                  1 indicates that the bi-bj loop is done OUTSIDE
C                  2 indicates that the bi-bj loop is done OUTSIDE
C                     AND that we have been sent a local array (with overlap regions)
C                  3 indicates that the bi-bj loop is done OUTSIDE
C                     AND that we have been sent a local array
C                     AND that the array has no overlap region (interior only)
C                  NOTE - bibjFlg can be NEGATIVE to indicate not to increment counter
C     biArg     :: X-direction tile number - used for bibjFlg=1-3
C     bjArg     :: Y-direction tile number - used for bibjFlg=1-3
C     myThid    :: my thread Id number
C***********************************************************************
C                  NOTE: User beware! If a local (1 tile only) array
C                        is sent here, bibjFlg MUST NOT be set to 0
C                        or there will be out of bounds problems!
C***********************************************************************
      _RL inpFldRL(*)
      _RL fracFldRL(*)
      _RS inpFldRS(*)
      _RS fracFldRS(*)
      _RL scaleFact
      INTEGER power
      INTEGER arrType
      INTEGER nLevFrac
      INTEGER ndId, ipointer
      INTEGER kLev, nLevs, bibjFlg, biArg, bjArg
      INTEGER myThid
CEOP

C     !LOCAL VARIABLES:
C ===============
C     useFract  :: flag to increment (or not) with fraction-weighted inpFld
C     thickFac  :: if > 0, to increment with thickness-weighted inpFld
      LOGICAL useFract
      INTEGER sizF, thickFac
      INTEGER sizI1,sizI2,sizJ1,sizJ2
      INTEGER sizTx,sizTy
      INTEGER iRun, jRun, k, bi, bj
      INTEGER kFirst, kLast
      INTEGER kd, kd0, ksgn, km, kStore
      CHARACTER*8 parms1
      CHARACTER*(MAX_LEN_MBUF) msgBuf

C If-sequence to see if we are a valid and an active diagnostic
c     IF ( ndId.NE.0 .AND. ipointer.NE.0 ) THEN

       IF ( bibjFlg.GE.0 .AND. ABS(kLev).LE.1 ) THEN
C Increment the counter for the diagnostic
        IF ( bibjFlg.EQ.0 ) THEN
         DO bj=myByLo(myThid), myByHi(myThid)
          DO bi=myBxLo(myThid), myBxHi(myThid)
           ndiag(ipointer,bi,bj) = ndiag(ipointer,bi,bj) + 1
          ENDDO
         ENDDO
        ELSE
           bi = MIN(biArg,nSx)
           bj = MIN(bjArg,nSy)
           ndiag(ipointer,bi,bj) = ndiag(ipointer,bi,bj) + 1
        ENDIF
       ENDIF

C-      select range for 1rst & 2nd indices to accumulate
C         depending on variable location on C-grid,
        thickFac = 0
        parms1 = gdiag(ndId)(1:8)
        IF ( parms1(2:2).EQ.'M' ) THEN
         iRun = sNx
         jRun = sNy
         thickFac = 1
        ELSEIF ( parms1(2:2).EQ.'U' ) THEN
         iRun = sNx+1
         jRun = sNy
         thickFac = 2
        ELSEIF ( parms1(2:2).EQ.'V' ) THEN
         iRun = sNx
         jRun = sNy+1
         thickFac = 3
        ELSEIF ( parms1(2:2).EQ.'Z' ) THEN
         iRun = sNx+1
         jRun = sNy+1
        ELSE
         iRun = sNx
         jRun = sNy
        ENDIF

C-      Dimension of the input array:
        IF (ABS(bibjFlg).EQ.3) THEN
          sizI1 = 1
          sizI2 = sNx
          sizJ1 = 1
          sizJ2 = sNy
          iRun = sNx
          jRun = sNy
        ELSE
          sizI1 = 1-OLx
          sizI2 = sNx+OLx
          sizJ1 = 1-OLy
          sizJ2 = sNy+OLy
        ENDIF
        IF (ABS(bibjFlg).GE.2) THEN
         sizTx = 1
         sizTy = 1
        ELSE
         sizTx = nSx
         sizTy = nSy
        ENDIF
C-      Which part of inpFld to add : k = 3rd index,
C         and do the loop >> do k=kFirst,kLast <<
        IF (kLev.LE.0) THEN
          kFirst = 1
          kLast  = nLevs
        ELSEIF ( nLevs.EQ.1 ) THEN
          kFirst = 1
          kLast  = 1
        ELSEIF ( kLev.LE.nLevs ) THEN
          kFirst = kLev
          kLast  = kLev
        ELSE
          STOP 'ABNORMAL END in DIAGNOSTICS_FILL_FIELD: kLev > nLevs >0'
        ENDIF
C-      Which part of qdiag to update: kd = 3rd index,
C         and do the loop >> do k=kFirst,kLast ; kd = kd0 + k*ksgn <<
        IF ( kLev.EQ.-1 ) THEN
          ksgn = -1
          kd0 = ipointer + nLevs
        ELSEIF ( kLev.EQ.0 ) THEN
          ksgn = 1
          kd0 = ipointer - 1
        ELSE
          ksgn = 0
          kd0 = ipointer + kLev - 1
        ENDIF
C-      Set thickness and fraction-weight option :
        IF ( nLevFrac.GE.0 ) thickFac = 0
        useFract = nLevFrac.GT.0
        IF ( useFract ) THEN
          sizF = nLevFrac
        ELSE
          sizF = 1
        ENDIF

C-      Check for consistency with Nb of levels reserved in storage array
        kStore = kd0 + MAX(ksgn*kFirst,ksgn*kLast) - ipointer + 1
        IF ( kStore.GT.kdiag(ndId) ) THEN
         _BEGIN_MASTER(myThid)
          WRITE(msgBuf,'(2A,I4,A)') 'DIAGNOSTICS_FILL_FIELD: ',
     &     'exceed Nb of levels(=',kdiag(ndId),' ) reserved '
          CALL PRINT_ERROR( msgBuf , myThid )
          WRITE(msgBuf,'(2A,I6,2A)') 'DIAGNOSTICS_FILL_FIELD: ',
     &     'for Diagnostics #', ndId, ' : ', cdiag(ndId)
          CALL PRINT_ERROR( msgBuf , myThid )
          WRITE(msgBuf,'(2A,2I4,I3)') 'calling DIAGNOSTICS_FILL_FIELD ',
     I     'with kLev,nLevs,bibjFlg=', kLev,nLevs,bibjFlg
          CALL PRINT_ERROR( msgBuf , myThid )
          WRITE(msgBuf,'(2A,I6,A)') 'DIAGNOSTICS_FILL_FIELD: ',
     I     '==> trying to store up to ', kStore, ' levels'
          CALL PRINT_ERROR( msgBuf , myThid )
          STOP 'ABNORMAL END: S/R DIAGNOSTICS_FILL_FIELD'
         _END_MASTER(myThid)
        ENDIF

        IF ( bibjFlg.EQ.0 ) THEN

         DO bj=myByLo(myThid), myByHi(myThid)
          DO bi=myBxLo(myThid), myBxHi(myThid)
           DO k = kFirst,kLast
            kd = kd0 + ksgn*k
            IF ( thickFac.EQ.0 ) THEN
             CALL DIAGNOSTICS_CUMULATE(
     U                  qdiag(1-OLx,1-OLy,kd,bi,bj),
     I                  inpFldRL, fracFldRL, inpFldRS, fracFldRS,
     I                  scaleFact, power, arrType, useFract, sizF,
     I                  sizI1,sizI2,sizJ1,sizJ2,nLevs,sizTx,sizTy,
     I                  iRun, jRun, k, bi, bj,
     I                  myThid )
            ELSE
             km = kd - ipointer + 1
             CALL DIAGNOSTICS_HF_CUMUL(
     U                  qdiag(1-OLx,1-OLy,kd,bi,bj),
     I                  inpFldRL, inpFldRS,
     I                  scaleFact, power, arrType, thickFac,
     I                  sizI1,sizI2,sizJ1,sizJ2,nLevs,sizTx,sizTy,
     I                  iRun, jRun, k, km,
     I                  bi, bj, myThid )
            ENDIF
           ENDDO
          ENDDO
         ENDDO
        ELSE
          bi = MIN(biArg,sizTx)
          bj = MIN(bjArg,sizTy)
          DO k = kFirst,kLast
            kd = kd0 + ksgn*k
            IF ( thickFac.EQ.0 ) THEN
             CALL DIAGNOSTICS_CUMULATE(
     U                  qdiag(1-OLx,1-OLy,kd,biArg,bjArg),
     I                  inpFldRL, fracFldRL, inpFldRS, fracFldRS,
     I                  scaleFact, power, arrType, useFract, sizF,
     I                  sizI1,sizI2,sizJ1,sizJ2,nLevs,sizTx,sizTy,
     I                  iRun, jRun, k, bi, bj,
     I                  myThid )
            ELSE
             km = kd - ipointer + 1
             CALL DIAGNOSTICS_HF_CUMUL(
     U                  qdiag(1-OLx,1-OLy,kd,biArg,bjArg),
     I                  inpFldRL, inpFldRS,
     I                  scaleFact, power, arrType, thickFac,
     I                  sizI1,sizI2,sizJ1,sizJ2,nLevs,sizTx,sizTy,
     I                  iRun, jRun, k, km,
     I                  biArg, bjArg, myThid )
            ENDIF
          ENDDO
        ENDIF

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
c     ELSE
c     IF (myThid.EQ.1) WRITE(6,1000) cdiag(ndId)

c     ENDIF

c1000 format(' ',' Warning: Trying to write to diagnostic ',a8,
c    &        ' But it is not a valid (or active) name ')
      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

CBOP
C     !ROUTINE: DIAGNOSTICS_HF_CUMUL
C     !INTERFACE:
      SUBROUTINE DIAGNOSTICS_HF_CUMUL(
     U                  cumFld,
     I                  inpFldRL, inpFldRS,
     I                  scaleFact, power, arrType, thickFac,
     I                  sizI1,sizI2,sizJ1,sizJ2,sizK,sizTx,sizTy,
     I                  iRun, jRun, k, km,
     I                  bi, bj, myThid )

C     !DESCRIPTION:
C     Update array cumFld
C     by adding content of input field array inpFld
C     weighted by thickness factor "hFac"
C     over the range [1:iRun],[1:jRun]

C     !USES:
      IMPLICIT NONE

#include "EEPARAMS.h"
#include "SIZE.h"
#include "GRID.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine Arguments ==
C     cumFld      :: cumulative array (updated)
C     inpFldRL    :: input field array to add to cumFld (arrType=0,1)
C     inpFldRS    :: input field array to add to cumFld (arrType=2,3)
C     scaleFact   :: scaling factor
C     power       :: option to fill-in with the field square (power=2)
C     arrType     :: select which array & fraction (RL/RS) to process:
C                    0: both RL ; 1: inpRL & fracRS ; 2: inpRS,fracRL ; 3: both RS
C     thickFac    :: which hFac array to use: 1,2,3 = hFacC,W,S
C     sizI1,sizI2 :: size of inpFld array: 1rst index range (min,max)
C     sizJ1,sizJ2 :: size of inpFld array: 2nd  index range (min,max)
C     sizK        :: size of inpFld array: 3rd  dimension
C     sizTx,sizTy :: size of inpFld array: tile dimensions
C     iRun,jRun   :: range of 1rst & 2nd index
C     k           :: level of inpFld array to add to cumFld array
C     km          :: level of hFac array to use as weight for inpFld
C     bi, bj      :: indices of tile to process (cumulate in qdiag)
C     myThid      :: my Thread Id number
      _RL cumFld(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER sizI1,sizI2,sizJ1,sizJ2
      INTEGER sizK,sizTx,sizTy
      _RL inpFldRL(sizI1:sizI2,sizJ1:sizJ2,sizK,sizTx,sizTy)
      _RS inpFldRS(sizI1:sizI2,sizJ1:sizJ2,sizK,sizTx,sizTy)
      _RL scaleFact
      INTEGER power
      INTEGER arrType, thickFac
      INTEGER iRun, jRun, k, km, bi, bj
      INTEGER myThid
CEOP

C     !LOCAL VARIABLES:
C     i, j     :: loop indices
C     ti, tj   :: tile indices of inpFld to process
      INTEGER i, j
      INTEGER ti, tj
      _RL tmpFld(sNx+1,sNy+1)

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      ti = MIN(bi,sizTx)
      tj = MIN(bj,sizTy)
      IF ( arrType.EQ.0 .OR. arrType.EQ.1 ) THEN
        DO j = 1,jRun
         DO i = 1,iRun
          tmpFld(i,j) = scaleFact*inpFldRL(i,j,k,ti,tj)
         ENDDO
        ENDDO
      ELSEIF ( arrType.EQ.2 .OR. arrType.EQ.3 ) THEN
        DO j = 1,jRun
         DO i = 1,iRun
          tmpFld(i,j) = scaleFact*inpFldRS(i,j,k,ti,tj)
         ENDDO
        ENDDO
      ELSE
        STOP 'DIAGNOSTICS_HF_CUMUL: invalid arrType'
      ENDIF

      IF ( power.EQ.2 ) THEN
        DO j = 1,jRun
         DO i = 1,iRun
          tmpFld(i,j) = tmpFld(i,j)*tmpFld(i,j)
         ENDDO
        ENDDO
      ENDIF

      IF ( thickFac.EQ.1 ) THEN
        DO j = 1,jRun
         DO i = 1,iRun
          cumFld(i,j) = cumFld(i,j)
     &                + tmpFld(i,j)*hFacC(i,j,km,bi,bj)
         ENDDO
        ENDDO
      ELSEIF ( thickFac.EQ.2 ) THEN
        DO j = 1,jRun
         DO i = 1,iRun
          cumFld(i,j) = cumFld(i,j)
     &                + tmpFld(i,j)*hFacW(i,j,km,bi,bj)
         ENDDO
        ENDDO
      ELSEIF ( thickFac.EQ.3 ) THEN
        DO j = 1,jRun
         DO i = 1,iRun
          cumFld(i,j) = cumFld(i,j)
     &                + tmpFld(i,j)*hFacS(i,j,km,bi,bj)
         ENDDO
        ENDDO
      ELSE
        DO j = 1,jRun
         DO i = 1,iRun
          cumFld(i,j) = cumFld(i,j) + tmpFld(i,j)
         ENDDO
        ENDDO
      ENDIF

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

CBOP
C     !ROUTINE: DIAGNOSTICS_CUMULATE
C     !INTERFACE:
      SUBROUTINE DIAGNOSTICS_CUMULATE(
     U                  cumFld,
     I                  inpFldRL, frcFldRL, inpFldRS, frcFldRS,
     I                  scaleFact, power, arrType, useFract, sizF,
     I                  sizI1,sizI2,sizJ1,sizJ2,sizK,sizTx,sizTy,
     I                  iRun, jRun, k, bi, bj,
     I                  myThid )

C     !DESCRIPTION:
C     Update array cumFld
C     by adding content of input field array inpFld
C     over the range [1:iRun],[1:jRun]

C     !USES:
      IMPLICIT NONE

#include "EEPARAMS.h"
#include "SIZE.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine Arguments ==
C     cumFld      :: cumulative array (updated)
C     inpFldRL    :: input field array to add to cumFld (arrType=0,1)
C     frcFldRL    :: fraction used for weighted-average diagnostics (arrType=0,2)
C     inpFldRS    :: input field array to add to cumFld (arrType=2,3)
C     frcFldRS    :: fraction used for weighted-average diagnostics (arrType=1,3)
C     scaleFact   :: scaling factor
C     power       :: option to fill-in with the field square (power=2)
C     arrType     :: select which array & fraction (RL/RS) to process:
C                    0: both RL ; 1: inpRL & fracRS ; 2: inpRS,fracRL ; 3: both RS
C     useFract    :: if True, use fraction-weight
C     sizF        :: size of frcFld array: 3rd  dimension
C     sizI1,sizI2 :: size of inpFld array: 1rst index range (min,max)
C     sizJ1,sizJ2 :: size of inpFld array: 2nd  index range (min,max)
C     sizK        :: size of inpFld array: 3rd  dimension
C     sizTx,sizTy :: size of inpFld array: tile dimensions
C     iRun,jRun   :: range of 1rst & 2nd index
C     k,bi,bj     :: level and tile indices of inpFld array to add to cumFld array
C     myThid      :: my Thread Id number
      _RL cumFld(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER sizI1,sizI2,sizJ1,sizJ2
      INTEGER sizF,sizK,sizTx,sizTy
      _RL inpFldRL(sizI1:sizI2,sizJ1:sizJ2,sizK,sizTx,sizTy)
      _RL frcFldRL(sizI1:sizI2,sizJ1:sizJ2,sizF,sizTx,sizTy)
      _RS inpFldRS(sizI1:sizI2,sizJ1:sizJ2,sizK,sizTx,sizTy)
      _RS frcFldRS(sizI1:sizI2,sizJ1:sizJ2,sizF,sizTx,sizTy)
      _RL scaleFact
      INTEGER power
      INTEGER arrType
      LOGICAL useFract
      INTEGER iRun, jRun, k, bi, bj
      INTEGER myThid
CEOP

C     !LOCAL VARIABLES:
C     i,j    :: loop indices
      INTEGER i, j, l
      _RL     tmpFact

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      tmpFact = scaleFact
      IF ( power.EQ.2 ) tmpFact = scaleFact*scaleFact

      IF ( useFract .AND. power.EQ.2 ) THEN
       l = MIN(k,sizF)

       IF ( arrType.EQ.0 ) THEN
        DO j = 1,jRun
         DO i = 1,iRun
          cumFld(i,j) = cumFld(i,j)
     &                + tmpFact*inpFldRL(i,j,k,bi,bj)
     &                         *inpFldRL(i,j,k,bi,bj)
     &                         *frcFldRL(i,j,l,bi,bj)
         ENDDO
        ENDDO
       ELSEIF ( arrType.EQ.1 ) THEN
        DO j = 1,jRun
         DO i = 1,iRun
          cumFld(i,j) = cumFld(i,j)
     &                + tmpFact*inpFldRL(i,j,k,bi,bj)
     &                         *inpFldRL(i,j,k,bi,bj)
     &                         *frcFldRS(i,j,l,bi,bj)
         ENDDO
        ENDDO
       ELSEIF ( arrType.EQ.2 ) THEN
        DO j = 1,jRun
         DO i = 1,iRun
          cumFld(i,j) = cumFld(i,j)
     &                + tmpFact*inpFldRS(i,j,k,bi,bj)
     &                         *inpFldRS(i,j,k,bi,bj)
     &                         *frcFldRL(i,j,l,bi,bj)
         ENDDO
        ENDDO
       ELSEIF ( arrType.EQ.3 ) THEN
        DO j = 1,jRun
         DO i = 1,iRun
          cumFld(i,j) = cumFld(i,j)
     &                + tmpFact*inpFldRS(i,j,k,bi,bj)
     &                         *inpFldRS(i,j,k,bi,bj)
     &                         *frcFldRS(i,j,l,bi,bj)
         ENDDO
        ENDDO
       ELSE
        STOP 'DIAGNOSTICS_CUMULATE: invalid arrType'
       ENDIF

      ELSEIF ( useFract ) THEN
       l = MIN(k,sizF)

       IF ( arrType.EQ.0 ) THEN
        DO j = 1,jRun
         DO i = 1,iRun
          cumFld(i,j) = cumFld(i,j)
     &                + tmpFact*inpFldRL(i,j,k,bi,bj)
     &                         *frcFldRL(i,j,l,bi,bj)
         ENDDO
        ENDDO
       ELSEIF ( arrType.EQ.1 ) THEN
        DO j = 1,jRun
         DO i = 1,iRun
          cumFld(i,j) = cumFld(i,j)
     &                + tmpFact*inpFldRL(i,j,k,bi,bj)
     &                         *frcFldRS(i,j,l,bi,bj)
         ENDDO
        ENDDO
       ELSEIF ( arrType.EQ.2 ) THEN
        DO j = 1,jRun
         DO i = 1,iRun
          cumFld(i,j) = cumFld(i,j)
     &                + tmpFact*inpFldRS(i,j,k,bi,bj)
     &                         *frcFldRL(i,j,l,bi,bj)
         ENDDO
        ENDDO
       ELSEIF ( arrType.EQ.3 ) THEN
        DO j = 1,jRun
         DO i = 1,iRun
          cumFld(i,j) = cumFld(i,j)
     &                + tmpFact*inpFldRS(i,j,k,bi,bj)
     &                         *frcFldRS(i,j,l,bi,bj)
         ENDDO
        ENDDO
       ELSE
        STOP 'DIAGNOSTICS_CUMULATE: invalid arrType'
       ENDIF

      ELSEIF ( power.EQ.2 ) THEN

       IF ( arrType.EQ.0 .OR. arrType.EQ.1 ) THEN
        DO j = 1,jRun
         DO i = 1,iRun
          cumFld(i,j) = cumFld(i,j)
     &                + tmpFact*inpFldRL(i,j,k,bi,bj)
     &                         *inpFldRL(i,j,k,bi,bj)
         ENDDO
        ENDDO
       ELSEIF ( arrType.EQ.2 .OR. arrType.EQ.3 ) THEN
        DO j = 1,jRun
         DO i = 1,iRun
          cumFld(i,j) = cumFld(i,j)
     &                + tmpFact*inpFldRS(i,j,k,bi,bj)
     &                         *inpFldRS(i,j,k,bi,bj)
         ENDDO
        ENDDO
       ELSE
        STOP 'DIAGNOSTICS_CUMULATE: invalid arrType'
       ENDIF

      ELSE

       IF ( arrType.EQ.0 .OR. arrType.EQ.1 ) THEN
        DO j = 1,jRun
         DO i = 1,iRun
C- jmc: try with fixed ranges, that are known at compiling stage
C        (might produce a better cash optimisation ?)
c       DO j = 1,sNy
c        DO i = 1,sNx
          cumFld(i,j) = cumFld(i,j)
     &                + tmpFact*inpFldRL(i,j,k,bi,bj)
         ENDDO
        ENDDO
       ELSEIF ( arrType.EQ.2 .OR. arrType.EQ.3 ) THEN
        DO j = 1,jRun
         DO i = 1,iRun
          cumFld(i,j) = cumFld(i,j)
     &                + tmpFact*inpFldRS(i,j,k,bi,bj)
         ENDDO
        ENDDO
       ELSE
        STOP 'DIAGNOSTICS_CUMULATE: invalid arrType'
       ENDIF

      ENDIF

      RETURN
      END

#include "ATM_CPL_OPTIONS.h"
#ifdef ALLOW_AIM
# include "AIM_OPTIONS.h"
#endif

CBOP
C     !ROUTINE: ATM_STORE_AIM_WNDSTR
C     !INTERFACE:
      SUBROUTINE ATM_STORE_AIM_WNDSTR(
     I                     bi, bj,
     I                     myTime, myIter, myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE ATM_STORE_AIM_WNDSTR
C     | o Routine for saving AIM surface wind-stress fields
C     |   for export to coupling layer.
C     *==========================================================*
C     | This version interfaces to the AIM package.
C     *==========================================================*

C     !USES:
      IMPLICIT NONE

C     == Global variables ==
#ifdef ALLOW_AIM
# include "AIM_SIZE.h"
#else
# include "SIZE.h"
#endif

#include "EEPARAMS.h"
#include "PARAMS.h"
#include "CPL_PARAMS.h"
#include "GRID.h"
#include "DYNVARS.h"
#ifdef ALLOW_AIM
# include "AIM2DYN.h"
c #include "AIM_FFIELDS.h"
#endif
#ifdef ALLOW_THSICE
# include "THSICE_PARAMS.h"
# include "THSICE_VARS.h"
#endif
C     == Global variables for coupling interface ==
#include "ATMCPL.h"

C     !INPUT/OUTPUT PARAMETERS:
C     bi, bj    :: Tile indices
C     myTime    :: Current time in simulation (s)
C     myIter    :: Current iteration number
C     myThid    :: My Thread Id. number
      INTEGER bi, bj
      _RL     myTime
      INTEGER myIter
      INTEGER myThid
CEOP

#ifdef ALLOW_AIM
C     !LOCAL VARIABLES:
C     i, j      :: Loop counters
C     ks        :: surface level index
      INTEGER i, j, ks
      _RL cplTimeFraction
      _RL uStr_tmp, vStr_tmp

C     o Accumulate momentum surface flux that will be exported to the
C       coupling layer. Momentum flux is in N/m^2 with same sign as the wind.
       cplTimeFraction = 1. _d 0 / DFLOAT(cplSendFrq_iter)
       ks = 1

       tauXTime(bi,bj) = tauXTime(bi,bj) + cplTimeFraction
       tauYTime(bi,bj) = tauYTime(bi,bj) + cplTimeFraction
#ifdef ALLOW_THSICE
      IF ( useThSIce .AND. stressReduction.GT. 0. _d 0 ) THEN
C--   Reduce wind stress applied to ocean where sea-ice is present
       DO j=1,sNy
        DO i=1,sNx
c         IF ( aim_landFr(i-1,j,bi,bj)*aim_landFr(i,j,bi,bj) .NE. 1. ) THEN
          IF ( hFacW(i,j,ks,bi,bj) .NE. 0. ) THEN
           uStr_tmp =
     &      ( aim_drag(i-1,j,bi,bj)
     &       *(1. _d 0 - iceMask(i-1,j,bi,bj)*stressReduction)
     &      + aim_drag( i ,j,bi,bj)
     &       *(1. _d 0 - iceMask( i ,j,bi,bj)*stressReduction)
     &      )* 0.5 _d 0 * uVel(i,j,ks,bi,bj)
           tauX(i,j,bi,bj) = tauX(i,j,bi,bj)
     &                     + uStr_tmp*cplTimeFraction
          ENDIF
        ENDDO
       ENDDO
       DO j=1,sNy
        DO i=1,sNx
c         IF ( aim_landFr(i,j-1,bi,bj)*aim_landFr(i,j,bi,bj) .NE. 1. ) THEN
          IF ( hFacS(i,j,ks,bi,bj) .NE. 0. ) THEN
           vStr_tmp =
     &      ( aim_drag(i,j-1,bi,bj)
     &       *(1. _d 0 - iceMask(i,j-1,bi,bj)*stressReduction)
     &      + aim_drag(i, j ,bi,bj)
     &       *(1. _d 0 - iceMask(i, j ,bi,bj)*stressReduction)
     &      )* 0.5 _d 0 * vVel(i,j,ks,bi,bj)
           tauY(i,j,bi,bj) = tauY(i,j,bi,bj)
     &                     + vStr_tmp*cplTimeFraction
          ENDIF
        ENDDO
       ENDDO
      ELSE
#else  /*ALLOW_THSICE*/
      IF (.TRUE.) THEN
#endif  /*ALLOW_THSICE*/
       DO j=1,sNy
        DO i=1,sNx
c         IF ( aim_landFr(i-1,j,bi,bj)*aim_landFr(i,j,bi,bj) .NE. 1. ) THEN
          IF ( hFacW(i,j,ks,bi,bj) .NE. 0. ) THEN
           uStr_tmp =
     &      ( aim_drag(i-1,j,bi,bj)+aim_drag(i,j,bi,bj) )
     &       * 0.5 _d 0 * uVel(i,j,ks,bi,bj)
           tauX(i,j,bi,bj) = tauX(i,j,bi,bj)
     &                     + uStr_tmp*cplTimeFraction
          ENDIF
        ENDDO
       ENDDO
       DO j=1,sNy
        DO i=1,sNx
c         IF ( aim_landFr(i,j-1,bi,bj)*aim_landFr(i,j,bi,bj) .NE. 1. ) THEN
          IF ( hFacS(i,j,ks,bi,bj) .NE. 0. ) THEN
           vStr_tmp =
     &      ( aim_drag(i,j-1,bi,bj)+aim_drag(i,j,bi,bj) )
     &       * 0.5 _d 0 * vVel(i,j,ks,bi,bj)
           tauY(i,j,bi,bj) = tauY(i,j,bi,bj)
     &                     + vStr_tmp*cplTimeFraction
          ENDIF
        ENDDO
       ENDDO
      ENDIF

#endif /* ALLOW_AIM */

      RETURN
      END

#include "CAL_OPTIONS.h"

      SUBROUTINE CAL_TIMEPASSED(
     I                           initialdate,
     I                           finaldate,
     O                           numdays,
     I                           myThid )

C     ==================================================================
C     SUBROUTINE cal_TimePassed
C     ==================================================================
C
C     o Calculate the time that passed between initialdate and
C       finaldate.
C
C     started: Christian Eckert eckert@mit.edu  30-Jun-1999
C     changed: Christian Eckert eckert@mit.edu  29-Dec-1999
C              - restructured the original version in order to have a
C                better interface to the MITgcmUV.
C              Christian Eckert eckert@mit.edu  03-Feb-2000
C              - Introduced new routine and function names, cal_<NAME>,
C                for verion 0.1.3.
C
C     ==================================================================
C     SUBROUTINE cal_TimePassed
C     ==================================================================

      IMPLICIT NONE

C     == global variables ==
#include "EEPARAMS.h"
#include "cal.h"

C     == routine arguments ==
      INTEGER initialdate(4)
      INTEGER finaldate(4)
      INTEGER numdays(4)
      INTEGER myThid

C     == external ==
      INTEGER  cal_IsLeap
      EXTERNAL cal_IsLeap

C     == local variables ==
      INTEGER yi,yf
      INTEGER mi,mf
      INTEGER di,df
      INTEGER si,sf
      INTEGER li,lf
      INTEGER wi,wf
      INTEGER cdi,cdf
      INTEGER csi,csf
      INTEGER ndays
      INTEGER nsecs
      INTEGER hhmmss
      INTEGER imon
      INTEGER iyr
      INTEGER ierr
      LOGICAL swap
      LOGICAL caldates
      LOGICAL nothingtodo
      CHARACTER*(MAX_LEN_MBUF) msgBuf

C     == end of interface ==

      IF ( cal_setStatus .LT. 1 ) THEN
        WRITE( msgBuf,'(2A,4I9)') 'CAL_TIMEPASSED: ', 'initialdate=',
     &    initialdate(1),initialdate(2),initialdate(3),initialdate(4)
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE( msgBuf,'(2A,4I9)') 'CAL_TIMEPASSED: ', 'finaldate=',
     &    finaldate(1),finaldate(2),finaldate(3),finaldate(4)
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE( msgBuf,'(2A,I2,A)') 'CAL_TIMEPASSED: ',
     &    'called too early (cal_setStatus=',cal_setStatus,' )'
        CALL PRINT_ERROR( msgBuf, myThid )
        STOP 'ABNORMAL END: S/R CAL_TIMEPASSED'
      ENDIF

      nothingtodo = .false.

C     Initialise output.
      numdays(1) =  0
      numdays(2) =  0
      numdays(3) =  0
      numdays(4) = -1

      if ((initialdate(4) .gt. 0) .eqv.
     &    (  finaldate(4) .gt. 0)) then

        caldates = (initialdate(4) .gt. 0) .and.
     &             (  finaldate(4) .gt. 0)

C       Check relation between initial and final dates.
        if (initialdate(1) .eq. finaldate(1)) then
          if (initialdate(2) .eq. finaldate(2)) then
            nothingtodo = .true.
          else if (initialdate(2) .gt. finaldate(2)) then
            swap = .true.
          else
            swap = .false.
          endif
        else if (initialdate(1) .gt. finaldate(1)) then
          swap = .true.
        else
          swap = .false.
        endif

        if (.not. nothingtodo) then

          if (swap) then
            call cal_ConvDate(   finaldate,yi,mi,di,si,li,wi,myThid )
            call cal_ConvDate( initialdate,yf,mf,df,sf,lf,wf,myThid )
          else
            call cal_ConvDate( initialdate,yi,mi,di,si,li,wi,myThid )
            call cal_ConvDate(   finaldate,yf,mf,df,sf,lf,wf,myThid )
          endif

C         Determine the time interval.
          if (.not. caldates) then
            ndays = df - di
            nsecs = sf - si
            if (nsecs .lt. 0) then
              nsecs = nsecs + secondsperday
              ndays = ndays - 1
            endif
            ndays = ndays + nsecs/secondsperday
            nsecs = mod(nsecs,secondsperday)
          else
            si = si + (di-1)*secondsperday
            sf = sf + (df-1)*secondsperday
            cdi = 0
            do imon = 1,mod(mi-1,12)
              cdi = cdi + ndaymonth(imon,li)
            enddo
            csi = si
            cdf = 0
            do imon = 1,mod(mf-1,12)
              cdf = cdf + ndaymonth(imon,lf)
            enddo
            csf = sf

            if (yi .eq. yf) then
              ndays = (cdf + csf/secondsperday) -
     &                (cdi + csi/secondsperday)
              nsecs = (csf - (csf/secondsperday)*secondsperday) -
     &                (csi - (csi/secondsperday)*secondsperday)
              if (nsecs .lt. 0) then
                nsecs = nsecs + secondsperday
                ndays = ndays - 1
              endif
            else
              ndays = (ndaysnoleap - 1) + cal_IsLeap( yi, myThid ) -
     &                cdi - ndaymonth(mi,li)
              do iyr = yi+1,yf-1
                ndays = ndays + (ndaysnoleap - 1) +
     &                  cal_IsLeap( iyr, myThid )
              enddo
              ndays = ndays + cdf
              csi   = ndaymonth(mi,li)*secondsperday - csi
              nsecs = csi + csf
            endif
          endif

C         Convert to calendar format.
          numdays(1) = ndays + nsecs/secondsperday
          nsecs      = mod(nsecs,secondsperday)
          hhmmss     = nsecs/secondsperminute
          numdays(2) = hhmmss/minutesperhour*10000 +
     &                 mod(hhmmss,minutesperhour)*100 +
     &                 mod(nsecs,secondsperminute)
          if (swap) then
            numdays(1) = -numdays(1)
            numdays(2) = -numdays(2)
          endif

        else
C         Dates are equal.
        endif

      else

        ierr = 501
        call cal_PrintError( ierr, myThid )
        stop ' stopped in cal_TimePassed'

      endif

      RETURN
      END

c     ==================================================================
c
c     prgopti.F: Routines for doing an off-line optimization after the
c                ECCO forward and adjoint model have been run.
c
c     main     - Driver routine.
c     opti     - Mid-level routine to do the spin up and spin down.
c     optimum  - Routine that calls the minimization.
c
c     Documentation:
c
c     The collection of these routines originated mainly from Ralf
c     Giering. Patrick Heimbach improved and corrected considerable
c     parts of the original code. Christian Eckert contributed the
c     interface to the ECCO release of the MITgcmUV in order to get
c     the offline version going.
c
c     How to use the off-line optimization.
c
c       Doing an off-line optimization means that one alternately
c       calls the adjoint model and the optimization routines.
c
c       The adjoint model yields at iteration i the cost function
c       value and the gradient of the cost function with respect to
c       the control variables. The optimization routines then use
c       this information to reduce the cost function and give a
c       new estimate of the control variables which can then be used
c       in the next cycle to yield a new cost function and the
c       corresponding gradient.
c
c     started:  Ralf Giering      (lsoptv1)
c
c               Patrick Heimbach  heimbach@mit.edu  28-Feb-2000
c
c               - Corrected and restructured the original lsoptv1
c                 code.
c
c               Christian Eckert  eckert@mit.edu    15-Feb-2000
c
c               - Off-line capability and some cosmetic changes
c                 of the optimization wrapper.
c
c     changed:
c
c     ==================================================================


      program optim_main

c     ==================================================================
c     PROGRAM optim_main
c     ==================================================================
c
c     o Driver routine for the ECCO optimization package.
c
c     started: Christian Eckert eckert@mit.edu 15-Feb-2000
c
c     changed: Christian Eckert eckert@mit.edu 10-Mar-2000
c
c              - Added ECCO layout.
c
c     ==================================================================
c     SUBROUTINE
c     ==================================================================

      implicit none

c     == global variables ==

#include "blas1.h"

c     == routine arguments ==

c     == local variables ==

      integer nn

c     == end of interface ==

c--   Headline.
      print*
      print*,' =================================================='
      print*,' Large Scale Optimization with off-line capability.'
      print*,' =================================================='
      print*
      print*,'                Version 2.1.0'
      print*

c--   Get the number of control variables.
      call optim_numbmod( nn )

cph(
      print *, 'pathei: vor optim_sub'
cph)
c--   Call the subroutine.
      call optim_sub( nn )

c--   Succesful termination.
      print*
      print*,' ======================================'
      print*,' Large Scale Optimization run finished.'
      print*,' ======================================'
      print*

      end

CStartOfInterface
      INTEGER FUNCTION IFNBLNK( string )
C     /==========================================================\
C     | FUNCTION IFNBLNK                                         |
C     | o Find first non-blank in character string.              |
C     \==========================================================/
      IMPLICIT NONE
C
      CHARACTER*(*) string
CEndOfInterface
C
      INTEGER L, LS
C
      LS     = LEN(string)
      IFNBLNK = 0
      DO 10 L = 1, LS
       IF ( string(L:L) .EQ. ' ' ) GOTO 10
        IFNBLNK = L
        GOTO 11
   10 CONTINUE
   11 CONTINUE
C
      RETURN
      END

CStartOfInterface
      INTEGER FUNCTION ILNBLNK( string )
C     /==========================================================\
C     | FUNCTION ILNBLNK                                         |
C     | o Find last non-blank in character string.               |
C     \==========================================================/
      IMPLICIT NONE
      CHARACTER*(*) string
CEndOfInterface
      INTEGER L, LS
C
      LS      = LEN(string)
      ILNBLNK = LS
      DO 10 L = LS, 1, -1
        IF ( string(L:L) .EQ. ' ' ) GOTO 10
         ILNBLNK = L
         GOTO 11
   10 CONTINUE
   11 CONTINUE
C
      RETURN
      END

#include "CAL_OPTIONS.h"

      subroutine cal_PrintError(
     I                           calerr,
     I                           mythid
     &                         )

c     ==================================================================
c     SUBROUTINE cal_PrintError
c     ==================================================================
c
c     Purpose: Use the MITgcmuvs print routines to document errors that
c              occured during the execution of the calendar tool.
c
c     o Calling this routine allows to print out an error message for
c       several errors that might occur.
c
c       The error codes for the calendar tool are specified by a four
c       digit integer:
c                         RRCC
c
c       The RR digits identify the routine that detected the error.
c       The CC digits identify the specific error in the routine that
c          detected the error.
c
c       RR translates to routines in the following way:
c
c         cal_Init             0
c         cal_Set              1
c         cal_GetDate          2
c         cal_FullDate         3
c         cal_IsLeap           4
c         cal_TimePassed       5
c         cal_AddTime          6
c         cal_TimeInterval     7
c         cal_SubDates         8
c         cal_ConvDate         9
c         cal_ToSeconds       10
c         cal_StepsPerDay     11
c         cal_DaysPerMonth    12
c         cal_MonthsPerYear   13
c         cal_IntYears        14
c         cal_IntMonths       15
c         cal_IntDays         16
c         cal_nStepDay        17
c         cal_CheckDate       18
c         cal_PrintError      19
c         cal_PrintDate       20
c         cal_NumInts         25
c
c
c     started: Christian Eckert eckert@mit.edu  30-Jun-1999
c
c     changed: Christian Eckert eckert@mit.edu  29-Dec-1999
c
c              Christian Eckert eckert@mit.edu  10-Jan-2000
c
c              - Corrected the print statement for error code 104.
c                It contained more than 72 characters in one line.
c
c              Christian Eckert eckert@mit.edu  03-Feb-2000
c
c              - Introduced new routine and function names, cal_<NAME>,
c                for verion 0.1.3.
c
c              Christian Eckert eckert@mit.edu  24-Feb-2000
c
c              - Included cal_NumInts error code.
c
c     ==================================================================
c     SUBROUTINE cal_PrintError
c     ==================================================================

      implicit none

C     == global variables ==

#include "EEPARAMS.h"
#include "SIZE.h"
#include "PARAMS.h"

C     == routine arguments ==

C     mythid - thread number for this instance of the routine.
C     calerr - error code

      integer mythid
      integer calerr

C     == local variables ==

      integer nroutine
      integer nerrcode
      logical missingerrcode
      CHARACTER*(MAX_LEN_MBUF) msgBuf

C     == end of interface ==

      nerrcode = mod(calerr,100)
      nroutine = (calerr - nerrcode)/100
      missingerrcode = .false.

c     if (nroutine .eq. 0) then
C     Error in cal_Init

c       if (nerrcode .eq. 1) then
c        WRITE(msgBuf,'(A)')
c    &    '  cal_Init: Unable to open calendar parameter file'
c        CALL PRINT_MESSAGE(msgBuf,standardMessageUnit,SQUEEZE_RIGHT,1)
c        CALL PRINT_ERROR( msgBuf , 1)
c        WRITE(msgBuf,'(A)')
c    &    '            file "data.calendar".'
c        CALL PRINT_MESSAGE(msgBuf,standardMessageUnit,SQUEEZE_RIGHT,1)
c        CALL PRINT_ERROR( msgBuf , 1)
c       endif

c     else if (nroutine .eq. 1) then
      if (nroutine .eq. 1) then
C     Error in cal_Set

        if (nerrcode .eq. 1) then
         WRITE(msgBuf,'(A)')
     &    '  cal_Set: No appropriate calendar has been specified.'
         CALL PRINT_MESSAGE(msgBuf,standardMessageUnit,SQUEEZE_RIGHT,1)
         CALL PRINT_ERROR( msgBuf , 1)
        else if (nerrcode .eq. 2) then
         WRITE(msgBuf,'(A)')
     &    '  cal_Set: The time step specified is not valid.'
         CALL PRINT_MESSAGE(msgBuf,standardMessageUnit,SQUEEZE_RIGHT,1)
         CALL PRINT_ERROR( msgBuf , 1)
        else if (nerrcode .eq. 3) then
         WRITE(msgBuf,'(A)')
     &    '  cal_Set: The time step is less than a second.'
         CALL PRINT_MESSAGE(msgBuf,standardMessageUnit,SQUEEZE_RIGHT,1)
         CALL PRINT_ERROR( msgBuf , 1)
        else if (nerrcode .eq. 4) then
         WRITE(msgBuf,'(A)')
     &    '  cal_Set: The time step contains fractions of a second.'
         CALL PRINT_MESSAGE(msgBuf,standardMessageUnit,SQUEEZE_RIGHT,1)
         CALL PRINT_ERROR( msgBuf , 1)
c       else if (nerrcode .eq. 5) then
c        WRITE(msgBuf,'(A)')
c    &    '  cal_Set: Less than one time step per calendar day.'
c        CALL PRINT_MESSAGE(msgBuf,standardMessageUnit,SQUEEZE_RIGHT,1)
c        CALL PRINT_ERROR( msgBuf , 1)
c       else if (nerrcode .eq. 6) then
c        WRITE(msgBuf,'(A)')
c    &    '  cal_Set: The specifications are incomplete. Please'
c        CALL PRINT_MESSAGE(msgBuf,standardMessageUnit,SQUEEZE_RIGHT,1)
c        CALL PRINT_ERROR( msgBuf , 1)
c        WRITE(msgBuf,'(A)')
c    &    '                refer to the documentation.'
c        CALL PRINT_MESSAGE(msgBuf,standardMessageUnit,SQUEEZE_RIGHT,1)
c        CALL PRINT_ERROR( msgBuf , 1)
c       else if (nerrcode .eq. 7) then
c        WRITE(msgBuf,'(A)')
c    &    '  cal_Set: The final date of integration is before its'
c        CALL PRINT_MESSAGE(msgBuf,standardMessageUnit,SQUEEZE_RIGHT,1)
c        CALL PRINT_ERROR( msgBuf , 1)
c        WRITE(msgBuf,'(A)')
c    &    '                start date.'
c        CALL PRINT_MESSAGE(msgBuf,standardMessageUnit,SQUEEZE_RIGHT,1)
c        CALL PRINT_ERROR( msgBuf , 1)
c       else if (nerrcode .eq. 10) then
c        WRITE(msgBuf,'(A)')
c    &    '  cal_Set: The Julian Calendar is not implemented yet.'
c        CALL PRINT_MESSAGE(msgBuf,standardMessageUnit,SQUEEZE_RIGHT,1)
c        CALL PRINT_ERROR( msgBuf , 1)
c       else if (nerrcode .eq. 11) then
c        WRITE(msgBuf,'(A)')
c    &    '  cal_Set: The No Calendar case is not implemented yet.'
c        CALL PRINT_MESSAGE(msgBuf,standardMessageUnit,SQUEEZE_RIGHT,1)
c        CALL PRINT_ERROR( msgBuf , 1)
c       else if ( nerrcode .eq. 12) then
c        WRITE(msgBuf,'(A)')
c    &    '  cal_Set: modelstart .ne. startTime ... please check.'
c        CALL PRINT_MESSAGE(msgBuf,standardMessageUnit,SQUEEZE_RIGHT,1)
c        CALL PRINT_ERROR( msgBuf , 1)
c       else if ( nerrcode .eq. 13 ) then
c        WRITE(msgBuf,'(A)')
c    &    '  cal_Set: modelend .ne. endTime ... please check.'
c        CALL PRINT_MESSAGE(msgBuf,standardMessageUnit,SQUEEZE_RIGHT,1)
c        CALL PRINT_ERROR( msgBuf , 1)
c       else if ( nerrcode .eq. 14 ) then
c        WRITE(msgBuf,'(A)')
c    &    '  cal_Set: modelstep .ne. deltaTclock ... please check.'
c        CALL PRINT_MESSAGE(msgBuf,standardMessageUnit,SQUEEZE_RIGHT,1)
c        CALL PRINT_ERROR( msgBuf , 1)
c       else if ( nerrcode .eq. 15 ) then
c        WRITE(msgBuf,'(A)')
c    &    '  cal_Set: modeliter0 .ne. nIter0 ... please check.'
c       else if ( nerrcode .eq. 16 ) then
c        WRITE(msgBuf,'(A)')
c    &    '  cal_Set: modeliterend .ne. nEndIter ... please check.'
c        CALL PRINT_MESSAGE(msgBuf,standardMessageUnit,SQUEEZE_RIGHT,1)
c        CALL PRINT_ERROR( msgBuf , 1)
c       else if ( nerrcode .eq. 17 ) then
c        WRITE(msgBuf,'(A)')
c    &    '  cal_Set: modelintsteps .ne. nTimeSteps'
c        CALL PRINT_MESSAGE(msgBuf,standardMessageUnit,SQUEEZE_RIGHT,1)
c        CALL PRINT_ERROR( msgBuf , 1)
        else
          missingerrcode = .true.
        endif

      else if (nroutine .eq. 2) then
C     Error in cal_GetDate

        missingerrcode = .true.

      else if (nroutine .eq. 3) then
C     Error in cal_FullDate

        missingerrcode = .true.

      else if (nroutine .eq. 4) then
C     Error in cal_IsLeap

        missingerrcode = .true.

      else if (nroutine .eq. 5) then
C     Error in cal_TimePassed

        if (nerrcode .eq. 1) then
         WRITE(msgBuf,'(A)')
     &    'cal_TimePassed: cal and timeinterval cannot be compared'
         CALL PRINT_MESSAGE(msgBuf,standardMessageUnit,SQUEEZE_RIGHT,1)
         CALL PRINT_ERROR( msgBuf , 1)
        else
          missingerrcode = .true.
        endif

      else if (nroutine .eq. 6) then
C     Error in cal_AddTime

        if (nerrcode .eq. 1) then
         WRITE(msgBuf,'(A)')
     &    '  cal_AddTime: not a valid time interval.'
         CALL PRINT_MESSAGE(msgBuf,standardMessageUnit,SQUEEZE_RIGHT,1)
         CALL PRINT_ERROR( msgBuf , 1)
        else
          missingerrcode = .true.
        endif

      else if (nroutine .eq. 7) then
C     Error in cal_TimeInterval

        if (nerrcode .eq. 1) then
         WRITE(msgBuf,'(A)')
     &    '  cal_TimeInterval: not a valid time unit.'
         CALL PRINT_MESSAGE(msgBuf,standardMessageUnit,SQUEEZE_RIGHT,1)
         CALL PRINT_ERROR( msgBuf , 1)
        else
          missingerrcode = .true.
        endif

      else if (nroutine .eq. 8) then
C     Error in cal_SubDates

        if (nerrcode .eq. 1) then
         WRITE(msgBuf,'(A)')
     &    '  cal_SubDates: Not a valid combination of calendar dates'
         CALL PRINT_MESSAGE(msgBuf,standardMessageUnit,SQUEEZE_RIGHT,1)
         CALL PRINT_ERROR( msgBuf , 1)
         WRITE(msgBuf,'(A)')
     &    '             or time intervals.'
         CALL PRINT_MESSAGE(msgBuf,standardMessageUnit,SQUEEZE_RIGHT,1)
         CALL PRINT_ERROR( msgBuf , 1)
        else
          missingerrcode = .true.
        endif

      else if (nroutine .eq. 9) then
C     Error in cal_ConvDate

        if (nerrcode .eq. 1) then
         WRITE(msgBuf,'(A)')
     &    '  cal_ConvDate: date specification has mixed signs.'
         CALL PRINT_MESSAGE(msgBuf,standardMessageUnit,SQUEEZE_RIGHT,1)
         CALL PRINT_ERROR( msgBuf , 1)
        else
          missingerrcode = .true.
        endif

      else if (nroutine .eq. 10) then
C     Error in cal_ToSeconds

        if (nerrcode .eq. 1) then
         WRITE(msgBuf,'(A)')
     &    '  cal_ToSeconds: input not a time interval array.'
         CALL PRINT_MESSAGE(msgBuf,standardMessageUnit,SQUEEZE_RIGHT,1)
         CALL PRINT_ERROR( msgBuf , 1)
        else
          missingerrcode = .true.
        endif

      else if (nroutine .eq. 11) then
C     Error in cal_StepsPerDay

        if (nerrcode .eq. 1) then
         WRITE(msgBuf,'(A)')
     &    '  cal_StepsPerDay: nothing else to do.'
         CALL PRINT_MESSAGE(msgBuf,standardMessageUnit,SQUEEZE_RIGHT,1)
         CALL PRINT_ERROR( msgBuf , 1)
        else
          missingerrcode = .true.
        endif

      else if (nroutine .eq. 12) then
C     Error in cal_DaysPerMonth

        if (nerrcode .eq. 1) then
         WRITE(msgBuf,'(A)')
     &    '  cal_DaysPerMonth: current year after final year.'
         CALL PRINT_MESSAGE(msgBuf,standardMessageUnit,SQUEEZE_RIGHT,1)
         CALL PRINT_ERROR( msgBuf , 1)
        else
          missingerrcode = .true.
        endif

      else if (nroutine .eq. 13) then
C     Error in cal_MonthsPerYear

        missingerrcode = .true.

      else if (nroutine .eq. 14) then
C     Error in cal_IntYears

        missingerrcode = .true.

      else if (nroutine .eq. 15) then
C     Error in cal_IntMonths

        missingerrcode = .true.

      else if (nroutine .eq. 16) then
C     Error in cal_IntDays

        missingerrcode = .true.

      else if (nroutine .eq. 17) then
C     Error in cal_nStepDay

        missingerrcode = .true.

      else if (nroutine .eq. 18) then
C     Error in cal_CheckDate

        if (nerrcode .eq. 0) then
         WRITE(msgBuf,'(A)')
     &    '   cal_CheckDate: A valid date specification!'
         CALL PRINT_MESSAGE(msgBuf,standardMessageUnit,SQUEEZE_RIGHT,1)
         CALL PRINT_ERROR( msgBuf , 1)
         WRITE(msgBuf,'(A)')
     &    '   This only means that the format is ok'
         CALL PRINT_MESSAGE(msgBuf,standardMessageUnit,SQUEEZE_RIGHT,1)
         CALL PRINT_ERROR( msgBuf , 1)
        else if (nerrcode .eq. 1) then
         WRITE(msgBuf,'(A)')
     &    '   cal_CheckDate: Last component of array not valid!'
         CALL PRINT_MESSAGE(msgBuf,standardMessageUnit,SQUEEZE_RIGHT,1)
         CALL PRINT_ERROR( msgBuf , 1)
        else if (nerrcode .eq. 2) then
         WRITE(msgBuf,'(A)')
     &    '   cal_CheckDate: Third component of interval array not 0'
         CALL PRINT_MESSAGE(msgBuf,standardMessageUnit,SQUEEZE_RIGHT,1)
         CALL PRINT_ERROR( msgBuf , 1)
        else if (nerrcode .eq. 3) then
         WRITE(msgBuf,'(A)')
     &    '   cal_CheckDate: Signs of first two components unequal!'
         CALL PRINT_MESSAGE(msgBuf,standardMessageUnit,SQUEEZE_RIGHT,1)
         CALL PRINT_ERROR( msgBuf , 1)
        else if (nerrcode .eq. 4) then
         WRITE(msgBuf,'(A)')
     &    '   cal_CheckDate: Second component not in hhmmss format!'
         CALL PRINT_MESSAGE(msgBuf,standardMessageUnit,SQUEEZE_RIGHT,1)
         CALL PRINT_ERROR( msgBuf , 1)
        else if (nerrcode .eq. 5) then
         WRITE(msgBuf,'(A)')
     &    '   cal_CheckDate: Weekday indentifier not correct!'
         CALL PRINT_MESSAGE(msgBuf,standardMessageUnit,SQUEEZE_RIGHT,1)
         CALL PRINT_ERROR( msgBuf , 1)
        else if (nerrcode .eq. 6) then
         WRITE(msgBuf,'(A)')
     &    '   cal_CheckDate: Leap year identifier not correct!'
         CALL PRINT_MESSAGE(msgBuf,standardMessageUnit,SQUEEZE_RIGHT,1)
         CALL PRINT_ERROR( msgBuf , 1)
        else if (nerrcode .eq. 7) then
         WRITE(msgBuf,'(A)')
     &    'cal_CheckDate: Calendar date before predef. reference date'
         CALL PRINT_MESSAGE(msgBuf,standardMessageUnit,SQUEEZE_RIGHT,1)
         CALL PRINT_ERROR( msgBuf , 1)
        else if (nerrcode .eq. 8) then
         WRITE(msgBuf,'(A)')
     &    '   cal_CheckDate: First component not in yymmdd format!'
         CALL PRINT_MESSAGE(msgBuf,standardMessageUnit,SQUEEZE_RIGHT,1)
         CALL PRINT_ERROR( msgBuf , 1)
        else
          missingerrcode = .true.
        endif

      else if (nroutine .eq. 19) then
C     Error in cal_PrintError

        missingerrcode = .true.

      else if (nroutine .eq. 20) then
C     Error in cal_PrintDate

        if (nerrcode .eq. 1) then
         WRITE(msgBuf,'(A)')
     &    '  cal_PrintDate: date not a legal calendar array.'
         CALL PRINT_MESSAGE(msgBuf,standardMessageUnit,SQUEEZE_RIGHT,1)
         CALL PRINT_ERROR( msgBuf , 1)
        else
          missingerrcode = .true.
        endif

      else if (nroutine .eq. 21) then
C     Error in cal_PrintError

        missingerrcode = .true.

      else if (nroutine .eq. 25) then
C     Error in cal_NumInts

        if (nerrcode .eq. 1) then
         WRITE(msgBuf,'(A)')
     &    '  cal_NumInts: Expected a time interval as third argument.'
         CALL PRINT_MESSAGE(msgBuf,standardMessageUnit,SQUEEZE_RIGHT,1)
         CALL PRINT_ERROR( msgBuf , 1)
        else
          missingerrcode = .true.
        endif

      else
        missingerrcode = .true.
      endif

      if (missingerrcode) then
        print*,'  cal_PrintError: routine called by an undefined'
        print*,'                  error code.'
        print*,'  cal_PrintError: error code = ',calerr
        stop   '  stopped in cal_PrintError.'
      endif

      return
      end

#include "ctrparam.h"
#include "ATM2D_OPTIONS.h"

C     !INTERFACE:
      SUBROUTINE MONTH_END_DIAGS(  monid, myTime, myIter, myThid )
C     *==========================================================*
C     | Prints out rolling month-end quantities, and sums these  |
c     | into the tave monthly diagnostic variables.              |
C     *==========================================================*
        IMPLICIT NONE

C     === Global Atmosphere Variables ===
#include "ATMSIZE.h"
#include "SIZE.h"
#include "EEPARAMS.h"
#include "ATM2D_VARS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
C     monid  - current month of the year
C     myTime - current simulation time (ocean model time)
C     myIter - iteration number (ocean model)
C     myThid - Thread no. that called this routine.
      INTEGER monid
      _RL     myTime
      INTEGER myIter
      INTEGER myThid

C     LOCAL VARIABLES:
      CHARACTER*(MAX_LEN_MBUF) suff
      INTEGER ndmonth(12)
      DATA ndmonth/31,28,31,30,31,30,31,31,30,31,30,31/
      INTEGER i,j
      _RS norm_factor

      norm_factor = ndmonth(monid)*86400.0

      DO j=1,sNy
        DO i=1,sNx

          qnet_atm_ta(i,j,monid)= qnet_atm_ta(i,j,monid) +
     &                            qnet_atm(i,j)
          evap_atm_ta(i,j,monid)= evap_atm_ta(i,j,monid) +
     &                            evap_atm(i,j)
          precip_atm_ta(i,j,monid)= precip_atm_ta(i,j,monid) +
     &                              precip_atm(i,j)
          runoff_atm_ta(i,j,monid)=  runoff_atm_ta(i,j,monid) +
     &                               runoff_atm(i,j)
          sum_qrel_ta(i,j,monid)= sum_qrel_ta(i,j,monid) +
     &                            sum_qrel(i,j)
          sum_frel_ta(i,j,monid)= sum_frel_ta(i,j,monid) +
     &                            sum_frel(i,j)
          sum_iceMask_ta(i,j,monid)= sum_iceMask_ta(i,j,monid) +
     &                               sum_iceMask(i,j)
          sum_iceHeight_ta(i,j,monid)= sum_iceHeight_ta(i,j,monid) +
     &                                 sum_iceHeight(i,j)
          sum_iceTime_ta(i,j,monid)= sum_iceTime_ta(i,j,monid) +
     &                               sum_iceTime(i,j)
          sum_oceMxLT_ta(i,j,monid)= sum_oceMxLT_ta(i,j,monid) +
     &                               sum_oceMxLT(i,j)
          sum_oceMxLS_ta(i,j,monid)= sum_oceMxLS_ta(i,j,monid) +
     &                               sum_oceMxLS(i,j)

          qnet_atm(i,j)=qnet_atm(i,j)/ norm_factor
          evap_atm(i,j)=evap_atm(i,j)/ norm_factor
          precip_atm(i,j)= precip_atm(i,j)/ norm_factor
          runoff_atm(i,j)=  runoff_atm(i,j)/ norm_factor
          sum_qrel(i,j)= sum_qrel(i,j)/ norm_factor
          sum_frel(i,j)= sum_frel(i,j)/ norm_factor
          sum_iceMask(i,j)= sum_iceMask(i,j)/ norm_factor
          sum_iceHeight(i,j)= sum_iceHeight(i,j)/ norm_factor
          sum_iceTime(i,j)= sum_iceTime(i,j)/ norm_factor
          sum_oceMxLT(i,j)= sum_oceMxLT(i,j)/ norm_factor
          sum_oceMxLS(i,j)= sum_oceMxLS(i,j)/ norm_factor

        ENDDO
      ENDDO

      WRITE(suff,'(I2.2)') monid
      CALL WRITE_FLD_XY_RL('mQnetAtmtave.', suff, qnet_atm,
     &                     myIter, myThid)
      CALL WRITE_FLD_XY_RL('mEvapAtmtave.', suff, evap_atm,
     &                     myIter, myThid)
      CALL WRITE_FLD_XY_RL('mPrecipAtmtave.', suff, precip_atm,
     &                     myIter, myThid)
      CALL WRITE_FLD_XY_RL('mRunoffAtmtave.', suff, runoff_atm,
     &                     myIter, myThid)
      CALL WRITE_FLD_XY_RL('mQrelfluxtave.', suff, sum_qrel,
     &                     myIter, myThid)
      CALL WRITE_FLD_XY_RL('mFrelfluxtave.', suff, sum_frel,
     &                     myIter, myThid)
      CALL WRITE_FLD_XY_RL('mIceMasktave.', suff, sum_iceMask,
     &                     myIter, myThid)
      CALL WRITE_FLD_XY_RL('mIceHeighttave.', suff, sum_iceHeight,
     &                     myIter, myThid)
      CALL WRITE_FLD_XY_RL('mIceTimetave.', suff, sum_iceTime,
     &                     myIter, myThid)
      CALL WRITE_FLD_XY_RL('mOceMxLTtave.', suff, sum_oceMxLT,
     &                     myIter, myThid)
      CALL WRITE_FLD_XY_RL('mOceMxLStave.', suff, sum_oceMxLS,
     &                     myIter, myThid)

      DO j=1,sNy
        DO i=1,sNx

          qnet_atm(i,j)= 0. _d 0
          evap_atm(i,j)= 0. _d 0
          precip_atm(i,j)= 0. _d 0
          runoff_atm(i,j)= 0. _d 0
          sum_qrel(i,j)= 0. _d 0
          sum_frel(i,j)= 0. _d 0
          sum_iceMask(i,j)= 0. _d 0
          sum_iceHeight(i,j)= 0. _d 0
          sum_iceTime(i,j)= 0. _d 0
          sum_oceMxLT(i,j)= 0. _d 0
          sum_oceMxLS(i,j)= 0. _d 0

        ENDDO
      ENDDO

      RETURN
      END

!#########################################################
! This file is part of OpenAD released under the LGPL.   #
! The full COPYRIGHT notice can be found in the top      #
! level directory of the OpenAD distribution             #
!#########################################################
        module OAD_active
        use w2f__types
        implicit none
        private :: runTimeErrorStop, shapeChange
        public :: active
#ifndef TRACE
        public :: saxpy, sax, zero_deriv, setderiv
        public :: set_neg_deriv, inc_deriv, dec_deriv
#endif
        public :: oad_convert
        public :: oad_allocateMatching, oad_allocateShape, oad_shapeTest
#ifndef TRACE
        integer :: count_mult = 0
        integer :: count_add = 0
#endif
        integer, parameter :: shapeChange=0
#ifdef VECTOR
        integer :: max_deriv_vec_len
        parameter ( max_deriv_vec_len = 100 )
        integer :: oad_ctmp_i1, oad_ctmp_i2, oad_ctmp_i3, & 
        oad_ctmp_i4, oad_ctmp_i5, oad_ctmp_i6, oad_ctmp_i7
# define VECTOR_DIM , dimension(max_deriv_vec_len)
# define VECTOR_LOOP_VAR integer :: i
# define VECTOR_LOOP_BEGIN do i=1,max_deriv_vec_len
# define VECTOR_LOOP_END end do
# define DELEM d(i)
#else 
# define VECTOR_DIM 
# define VECTOR_LOOP_VAR
# define VECTOR_LOOP_BEGIN
# define VECTOR_LOOP_END
# define DELEM d
#endif
#ifdef SCALARNDI
# define DINIT
#else
# define DINIT =0.0d0
#endif

        !
        ! active needs to be a sequence type
        !  with no initialization
        !
        type active
          sequence
          real(w2f__8) :: v 
#ifndef TRACE
          ! initialization does not work for active variables
          ! inside of common block, such as in boxmodel
          ! initialization is required for correct adjoint
          real(w2f__8) VECTOR_DIM :: d DINIT
#endif
        end type
#ifndef TRACE
        interface saxpy
          module procedure saxpy_d0_a0_a0
          module procedure saxpy_l0_a0_a0
          module procedure saxpy_i0_a0_a0
          module procedure saxpy_d0_a0_a1
          module procedure saxpy_d0_a1_a1
          module procedure saxpy_d0_a2_a2
          module procedure saxpy_d1_a0_a1
          module procedure saxpy_d1_a1_a1 
          module procedure saxpy_l1_a1_a1 
          module procedure saxpy_i1_a1_a1
          module procedure saxpy_a1_a1_a1
          module procedure saxpy_d2_a0_a2
          module procedure saxpy_d2_a2_a2
# ifndef DEFAULT_R8
          module procedure saxpy_r0_a0_a0
          module procedure saxpy_r0_a1_a1
          module procedure saxpy_r1_a0_a1
          module procedure saxpy_r1_a1_a1
# endif
        end interface
        
        interface setderiv
          module procedure setderiv_a0_a0
          module procedure setderiv_a1_a0
          module procedure setderiv_a1_a1
          module procedure setderiv_a2_a0
          module procedure setderiv_a2_a2
          module procedure setderiv_a3_a3
        end interface

        interface set_neg_deriv
          module procedure set_neg_deriv_a0_a0
          module procedure set_neg_deriv_a1_a1
        end interface set_neg_deriv

        interface inc_deriv
          module procedure inc_deriv_a0_a0
          module procedure inc_deriv_a1_a1
          module procedure inc_deriv_a2_a2
        end interface inc_deriv

        interface dec_deriv
          module procedure dec_deriv_a0_a0
          module procedure dec_deriv_a1_a1
          module procedure dec_deriv_a2_a2
        end interface dec_deriv

        interface zero_deriv
          module procedure zero_deriv_a0
          module procedure zero_deriv_a1
          module procedure zero_deriv_a2
          module procedure zero_deriv_a3
          module procedure zero_deriv_a4
        end interface

        interface sax
          module procedure sax_d0_a0_a0 
          module procedure sax_l0_a0_a0
          module procedure sax_i0_a0_a0
          module procedure sax_d0_a0_a1
          module procedure sax_d0_a0_a2
          module procedure sax_d0_a1_a1
          module procedure sax_d0_a2_a2
          module procedure sax_d0_a3_a3
          module procedure sax_d1_a0_a1
          module procedure sax_d1_a1_a1 
          module procedure sax_l1_a1_a1 
          module procedure sax_i1_a1_a1
          module procedure sax_d2_a0_a2
          module procedure sax_d2_a2_a2
# ifndef DEFAULT_R8
          module procedure sax_r0_a0_a0
# endif
        end interface

#endif
        interface oad_convert
          module procedure convert_d0_a0
          module procedure convert_d1_a1
          module procedure convert_d2_a2
          module procedure convert_d3_a3
          module procedure convert_d4_a4
          module procedure convert_d5_a5
          module procedure convert_d6_a6
          module procedure convert_d7_a7
          module procedure convert_a0_d0
          module procedure convert_a1_d1
          module procedure convert_a2_d2
          module procedure convert_a3_d3
          module procedure convert_a4_d4
          module procedure convert_a5_d5
          module procedure convert_a6_d6
          module procedure convert_a7_d7
#ifndef DEFAULT_R8
          module procedure convert_r0_a0
          module procedure convert_r1_a1
          module procedure convert_r2_a2
          module procedure convert_r3_a3
          module procedure convert_r4_a4
          module procedure convert_r5_a5
          module procedure convert_r6_a6
          module procedure convert_r7_a7
          module procedure convert_a0_r0
          module procedure convert_a1_r1
          module procedure convert_a2_r2
          module procedure convert_a3_r3
          module procedure convert_a4_r4
          module procedure convert_a5_r5
          module procedure convert_a6_r6
          module procedure convert_a7_r7
#endif
        end interface

        interface oad_allocateMatching
          module procedure allocateMatching_d1_d1
          module procedure allocateMatching_a1_d1
          module procedure allocateMatching_d1_a1
          module procedure allocateMatching_a1_a1
          module procedure allocateMatching_d2_d2
          module procedure allocateMatching_a2_d2
          module procedure allocateMatching_d2_a2
          module procedure allocateMatching_a2_a2
          module procedure allocateMatching_d3_d3
          module procedure allocateMatching_a3_d3
          module procedure allocateMatching_d3_a3
          module procedure allocateMatching_a3_a3
          module procedure allocateMatching_a4_a4
          module procedure allocateMatching_d4_a4
          module procedure allocateMatching_d5_d5
          module procedure allocateMatching_a5_d5
          module procedure allocateMatching_d5_a5
          module procedure allocateMatching_a5_a5
          module procedure allocateMatching_d6_d6
          module procedure allocateMatching_a6_d6
          module procedure allocateMatching_d6_a6
          module procedure allocateMatching_a6_a6
#ifndef DEFAULT_R8
          module procedure allocateMatching_r1_r1
          module procedure allocateMatching_d1_r1
          module procedure allocateMatching_r1_d1
          module procedure allocateMatching_a1_r1
          module procedure allocateMatching_r1_a1
          module procedure allocateMatching_a2_r2
          module procedure allocateMatching_r2_a2
#endif
        end interface 

        interface oad_allocateShape
          module procedure allocateShape_d1
          module procedure allocateShape_d2
        end interface 

        interface oad_shapeTest
          module procedure shapeTest_a1_d1
          module procedure shapeTest_a1_a1
          module procedure shapeTest_d1_a1
          module procedure shapeTest_a2_d2
          module procedure shapeTest_a2_a2
          module procedure shapeTest_d2_a2
          module procedure shapeTest_a3_a3
          module procedure shapeTest_d3_a3
          module procedure shapeTest_a4_a4
          module procedure shapeTest_d4_a4
          module procedure shapeTest_a5_a5
          module procedure shapeTest_d5_a5
          module procedure shapeTest_a5_d5
          module procedure shapeTest_a6_a6
          module procedure shapeTest_d6_a6
          module procedure shapeTest_a6_d6
#ifndef DEFAULT_R8
          module procedure shapeTest_r1_a1
          module procedure shapeTest_r2_a2
          module procedure shapeTest_a1_r1
          module procedure shapeTest_a2_r2
#endif
        end interface 

        interface runTimeErrorStop
          module procedure runTimeErrorStopI
        end interface 

        contains
#ifndef TRACE
        !
        ! chain rule saxpy to be used in forward and reverse modes
        !
        subroutine saxpy_d0_a0_a0(a,x,y)
          real(w2f__8), intent(in) :: a
          type(active), intent(in) :: x
          type(active), intent(inout) :: y
          VECTOR_LOOP_VAR
          VECTOR_LOOP_BEGIN
            y%DELEM=y%DELEM + x%DELEM*a
          VECTOR_LOOP_END
        end subroutine
        subroutine saxpy_l0_a0_a0(a,x,y)
          integer(kind=w2f__i8), intent(in) :: a
          type(active), intent(in) :: x
          type(active), intent(inout) :: y
          VECTOR_LOOP_VAR
          VECTOR_LOOP_BEGIN
            y%DELEM=y%DELEM + x%DELEM*a
          VECTOR_LOOP_END
        end subroutine
        subroutine saxpy_i0_a0_a0(a,x,y)
          integer(kind=w2f__i4), intent(in) :: a
          type(active), intent(in) :: x
          type(active), intent(inout) :: y
          VECTOR_LOOP_VAR
          VECTOR_LOOP_BEGIN
            y%DELEM=y%DELEM + x%DELEM*a
          VECTOR_LOOP_END
        end subroutine
        subroutine saxpy_d0_a0_a1(a,x,y)
          real(w2f__8), intent(in) :: a
          type(active), intent(in) :: x
          type(active), dimension(:), intent(inout) :: y
          VECTOR_LOOP_VAR
          VECTOR_LOOP_BEGIN
            y%DELEM=y%DELEM + x%DELEM*a
          VECTOR_LOOP_END
        end subroutine
        subroutine saxpy_d0_a1_a1(a,x,y)
          real(w2f__8), intent(in) :: a
          type(active), dimension(:), intent(in) :: x
          type(active), dimension(:), intent(inout) :: y
          VECTOR_LOOP_VAR
          VECTOR_LOOP_BEGIN
            y%DELEM=y%DELEM + x%DELEM*a
          VECTOR_LOOP_END
        end subroutine
        subroutine saxpy_d0_a2_a2(a,x,y)
          real(w2f__8), intent(in) :: a
          type(active), dimension(:,:), intent(in) :: x
          type(active), dimension(:,:), intent(inout) :: y
          VECTOR_LOOP_VAR
          VECTOR_LOOP_BEGIN
            y%DELEM=y%DELEM + x%DELEM*a
          VECTOR_LOOP_END
        end subroutine
        subroutine saxpy_d1_a0_a1(a,x,y)
          real(w2f__8), dimension(:), intent(in) :: a
          type(active), intent(in) :: x
          type(active), dimension(:), intent(inout) :: y
          VECTOR_LOOP_VAR
          VECTOR_LOOP_BEGIN
            y%DELEM=y%DELEM+x%DELEM*a
          VECTOR_LOOP_END
        end subroutine
        subroutine saxpy_d1_a1_a1(a,x,y)
          real(w2f__8), dimension(:), intent(in) :: a
          type(active), dimension(:), intent(in) :: x
          type(active), dimension(:), intent(inout) :: y
          VECTOR_LOOP_VAR
          VECTOR_LOOP_BEGIN
            y%DELEM=y%DELEM+x%DELEM*a
          VECTOR_LOOP_END
        end subroutine
        subroutine saxpy_l1_a1_a1(a,x,y)
          integer(kind=w2f__i8), dimension(:), intent(in) :: a
          type(active), dimension(:), intent(in) :: x
          type(active), dimension(:), intent(inout) :: y
          VECTOR_LOOP_VAR
          VECTOR_LOOP_BEGIN
            y%DELEM=y%DELEM+x%DELEM*a
          VECTOR_LOOP_END
        end subroutine
        subroutine saxpy_i1_a1_a1(a,x,y)
          integer(kind=w2f__i4), dimension(:), intent(in) :: a
          type(active), dimension(:), intent(in) :: x
          type(active), dimension(:), intent(inout) :: y
          VECTOR_LOOP_VAR
          VECTOR_LOOP_BEGIN
            y%DELEM=y%DELEM+x%DELEM*a
          VECTOR_LOOP_END
        end subroutine
        subroutine saxpy_a1_a1_a1(a,x,y)
          type(active), dimension(:), intent(in) :: a
          type(active), dimension(:), intent(in) :: x
          type(active), dimension(:), intent(inout) :: y
          VECTOR_LOOP_VAR
          VECTOR_LOOP_BEGIN
            y%DELEM=y%DELEM+x%DELEM*a%v
          VECTOR_LOOP_END
        end subroutine
        subroutine saxpy_d2_a0_a2(a,x,y)
          real(w2f__8), dimension(:,:), intent(in) :: a
          type(active), intent(in) :: x
          type(active), dimension(:,:), intent(inout) :: y
          VECTOR_LOOP_VAR
          VECTOR_LOOP_BEGIN
            y%DELEM=y%DELEM + x%DELEM*a
          VECTOR_LOOP_END
        end subroutine
        subroutine saxpy_d2_a2_a2(a,x,y)
          real(w2f__8), dimension(:,:), intent(in) :: a
          type(active), dimension(:,:), intent(in) :: x
          type(active), dimension(:,:), intent(inout) :: y
          VECTOR_LOOP_VAR
          VECTOR_LOOP_BEGIN
            y%DELEM=y%DELEM + x%DELEM*a
          VECTOR_LOOP_END
        end subroutine
# ifndef DEFAULT_R8
        subroutine saxpy_r0_a0_a0(a,x,y)
          real(w2f__4), intent(in) :: a
          type(active), intent(in) :: x
          type(active), intent(inout) :: y
          VECTOR_LOOP_VAR
          VECTOR_LOOP_BEGIN
            y%DELEM=y%DELEM + x%DELEM*a
          VECTOR_LOOP_END
        end subroutine
        subroutine saxpy_r0_a1_a1(a,x,y)
          real(w2f__4), intent(in) :: a
          type(active), dimension(:), intent(in) :: x
          type(active), dimension(:), intent(inout) :: y
          VECTOR_LOOP_VAR
          VECTOR_LOOP_BEGIN
            y%DELEM=y%DELEM + x%DELEM*a
          VECTOR_LOOP_END
        end subroutine
        subroutine saxpy_r1_a0_a1(a,x,y)
          real(w2f__4), dimension(:), intent(in) :: a
          type(active), intent(in) :: x
          type(active), dimension(:), intent(inout) :: y
          VECTOR_LOOP_VAR
          VECTOR_LOOP_BEGIN
            y%DELEM=y%DELEM + x%DELEM*a
          VECTOR_LOOP_END
        end subroutine
        subroutine saxpy_r1_a1_a1(a,x,y)
          real(w2f__4), dimension(:), intent(in) :: a
          type(active), dimension(:), intent(in) :: x
          type(active), dimension(:), intent(inout) :: y
          VECTOR_LOOP_VAR
          VECTOR_LOOP_BEGIN
            y%DELEM=y%DELEM+x%DELEM*a
          VECTOR_LOOP_END
        end subroutine
# endif
        !
        ! chain rule saxpy to be used in forward and reverse modes
        ! derivative component of y is equal to zero initially
        ! note: y needs to be inout as otherwise value component gets
        ! zeroed out
        !
        subroutine sax_d0_a0_a0(a,x,y)
          real(w2f__8), intent(in) :: a
          type(active), intent(in) :: x
          type(active), intent(inout) :: y
          VECTOR_LOOP_VAR
          VECTOR_LOOP_BEGIN
            y%DELEM=x%DELEM*a
          VECTOR_LOOP_END
        end subroutine
        subroutine sax_l0_a0_a0(a,x,y)
          integer(kind=w2f__i8), intent(in) :: a
          type(active), intent(in) :: x
          type(active), intent(inout) :: y
          VECTOR_LOOP_VAR
          VECTOR_LOOP_BEGIN
            y%DELEM=x%DELEM*a
          VECTOR_LOOP_END
        end subroutine
        subroutine sax_i0_a0_a0(a,x,y)
          integer(kind=w2f__i4), intent(in) :: a
          type(active), intent(in) :: x
          type(active), intent(inout) :: y
          VECTOR_LOOP_VAR
          VECTOR_LOOP_BEGIN
            y%DELEM=x%DELEM*a
          VECTOR_LOOP_END
        end subroutine
        subroutine sax_d0_a0_a1(a,x,y)
          real(w2f__8), intent(in) :: a
          type(active), intent(in) :: x
          type(active), dimension(:), intent(inout) :: y
          VECTOR_LOOP_VAR
          VECTOR_LOOP_BEGIN
            y%DELEM=x%DELEM*a
          VECTOR_LOOP_END
        end subroutine
        subroutine sax_d0_a0_a2(a,x,y)
          real(w2f__8), intent(in) :: a
          type(active), intent(in) :: x
          type(active), dimension(:,:), intent(inout) :: y
          VECTOR_LOOP_VAR
          VECTOR_LOOP_BEGIN
            y%DELEM = x%DELEM*a
          VECTOR_LOOP_END
        end subroutine
        subroutine sax_d0_a1_a1(a,x,y)
          real(w2f__8), intent(in) :: a
          type(active), dimension(:), intent(in) :: x
          type(active), dimension(:), intent(inout) :: y
          VECTOR_LOOP_VAR
          VECTOR_LOOP_BEGIN
            y%DELEM=x%DELEM*a
          VECTOR_LOOP_END
        end subroutine
        subroutine sax_d0_a2_a2(a,x,y)
          real(w2f__8), intent(in) :: a
          type(active), dimension(:,:), intent(in) :: x
          type(active), dimension(:,:), intent(inout) :: y
          VECTOR_LOOP_VAR
          VECTOR_LOOP_BEGIN
            y%DELEM=x%DELEM*a
          VECTOR_LOOP_END
        end subroutine
        subroutine sax_d0_a3_a3(a,x,y)
          real(w2f__8), intent(in) :: a
          type(active), dimension(:,:,:), intent(in) :: x
          type(active), dimension(:,:,:), intent(inout) :: y
          VECTOR_LOOP_VAR
          VECTOR_LOOP_BEGIN
            y%DELEM=x%DELEM*a
          VECTOR_LOOP_END
        end subroutine
        subroutine sax_d1_a0_a1(a,x,y)
          real(w2f__8), dimension(:), intent(in) :: a
          type(active), intent(in) :: x
          type(active), dimension(:), intent(inout) :: y
          VECTOR_LOOP_VAR
          VECTOR_LOOP_BEGIN
            y%DELEM=x%DELEM*a
          VECTOR_LOOP_END
        end subroutine
        subroutine sax_d1_a1_a1(a,x,y)
          real(w2f__8), dimension(:), intent(in) :: a
          type(active), dimension(:), intent(in) :: x
          type(active), dimension(:), intent(inout) :: y
          VECTOR_LOOP_VAR
          VECTOR_LOOP_BEGIN
            y%DELEM=x%DELEM*a
          VECTOR_LOOP_END
        end subroutine
        subroutine sax_l1_a1_a1(a,x,y)
          integer(kind=w2f__i8), dimension(:), intent(in) :: a
          type(active), dimension(:), intent(in) :: x
          type(active), dimension(:), intent(inout) :: y
          VECTOR_LOOP_VAR
          VECTOR_LOOP_BEGIN
            y%DELEM=x%DELEM*a
          VECTOR_LOOP_END
        end subroutine
        subroutine sax_i1_a1_a1(a,x,y)
          integer(kind=w2f__i4), dimension(:), intent(in) :: a
          type(active), dimension(:), intent(in) :: x
          type(active), dimension(:), intent(inout) :: y
          VECTOR_LOOP_VAR
          VECTOR_LOOP_BEGIN
            y%DELEM=x%DELEM*a
          VECTOR_LOOP_END
        end subroutine
        subroutine sax_d2_a0_a2(a,x,y)
          real(w2f__8), dimension(:,:), intent(in) :: a
          type(active), intent(in) :: x
          type(active), dimension(:,:), intent(inout) :: y
          VECTOR_LOOP_VAR
          VECTOR_LOOP_BEGIN
            y%DELEM=x%DELEM*a
          VECTOR_LOOP_END
        end subroutine
        subroutine sax_d2_a2_a2(a,x,y)
          real(w2f__8), dimension(:,:), intent(in) :: a
          type(active), dimension(:,:), intent(in) :: x
          type(active), dimension(:,:), intent(inout) :: y
          VECTOR_LOOP_VAR
          VECTOR_LOOP_BEGIN
            y%DELEM=x%DELEM*a
          VECTOR_LOOP_END
        end subroutine
# ifndef DEFAULT_R8
        subroutine sax_r0_a0_a0(a,x,y)
          real(w2f__4), intent(in) :: a
          type(active), intent(in) :: x
          type(active), intent(inout) :: y
          VECTOR_LOOP_VAR
          VECTOR_LOOP_BEGIN
            y%DELEM=x%DELEM*a
          VECTOR_LOOP_END
        end subroutine
# endif
        !
        ! set derivative of y to be equal to derivative of x
        ! note: making y inout allows for already existing active
        ! variables to become the target of a derivative assignment
        !
        subroutine setderiv_a0_a0(y,x)
          type(active), intent(inout) :: y
          type(active), intent(in) :: x
          VECTOR_LOOP_VAR
          VECTOR_LOOP_BEGIN
            y%DELEM = x%DELEM
          VECTOR_LOOP_END
        end subroutine
        subroutine setderiv_a1_a0(y,x)
          type(active), intent(inout), dimension(:) :: y
          type(active), intent(in) :: x
          VECTOR_LOOP_VAR
          VECTOR_LOOP_BEGIN
            y%DELEM = x%DELEM
          VECTOR_LOOP_END
        end subroutine
        subroutine setderiv_a1_a1(y,x)
          type(active), intent(inout), dimension(:) :: y
          type(active), intent(in), dimension(:) :: x
          VECTOR_LOOP_VAR
          VECTOR_LOOP_BEGIN
            y%DELEM = x%DELEM
          VECTOR_LOOP_END
        end subroutine
        subroutine setderiv_a2_a0(y,x)
          type(active), intent(inout), dimension(:,:) :: y
          type(active), intent(in) :: x
          VECTOR_LOOP_VAR
          VECTOR_LOOP_BEGIN
            y%DELEM = x%DELEM
          VECTOR_LOOP_END
        end subroutine
        subroutine setderiv_a2_a2(y,x)
          type(active), intent(inout), dimension(:,:) :: y
          type(active), intent(in), dimension(:,:) :: x
          VECTOR_LOOP_VAR
          VECTOR_LOOP_BEGIN
            y%DELEM = x%DELEM
          VECTOR_LOOP_END
        end subroutine
        subroutine setderiv_a3_a3(y,x)
          type(active), intent(inout), dimension(:,:,:) :: y
          type(active), intent(in), dimension(:,:,:) :: x
          VECTOR_LOOP_VAR
          VECTOR_LOOP_BEGIN
            y%DELEM = x%DELEM
          VECTOR_LOOP_END
        end subroutine
        !
        ! set the derivative of y to be the negated derivative of x
        ! note: making y inout allows for already existing active
        ! variables to become the target of a derivative assignment
        !
        
        subroutine set_neg_deriv_a0_a0(y,x)
          type(active), intent(inout) :: y
          type(active), intent(in) :: x
          VECTOR_LOOP_VAR
          VECTOR_LOOP_BEGIN
            y%DELEM = -x%DELEM
          VECTOR_LOOP_END
        end subroutine

        subroutine set_neg_deriv_a1_a1(y,x)
          type(active), intent(inout), dimension(:) :: y
          type(active), intent(in), dimension(:) :: x
          VECTOR_LOOP_VAR
          VECTOR_LOOP_BEGIN
            y%DELEM = -x%DELEM
          VECTOR_LOOP_END
        end subroutine

        !
        ! increment the derivative of y by the derivative of x
        ! note: making y inout allows for already existing active
        ! variables to become the target of a derivative assignment
        !
        
        subroutine inc_deriv_a0_a0(y,x)
          type(active), intent(inout) :: y
          type(active), intent(in) :: x
          VECTOR_LOOP_VAR
          VECTOR_LOOP_BEGIN
            y%DELEM=y%DELEM + x%DELEM
          VECTOR_LOOP_END
        end subroutine

        subroutine inc_deriv_a1_a1(y,x)
          type(active), intent(inout), dimension(:) :: y
          type(active), intent(in), dimension(:) :: x
          VECTOR_LOOP_VAR
          VECTOR_LOOP_BEGIN
            y%DELEM=y%DELEM + x%DELEM
          VECTOR_LOOP_END
        end subroutine

        subroutine inc_deriv_a2_a2(y,x)
          type(active), intent(inout), dimension(:,:) :: y
          type(active), intent(in), dimension(:,:) :: x
          VECTOR_LOOP_VAR
          VECTOR_LOOP_BEGIN
            y%DELEM=y%DELEM + x%DELEM
          VECTOR_LOOP_END
        end subroutine

        !
        ! decrement the derivative of y by the derivative of x
        ! note: making y inout allows for already existing active
        ! variables to become the target of a derivative assignment
        !
        
        subroutine dec_deriv_a0_a0(y,x)
          type(active), intent(inout) :: y
          type(active), intent(in) :: x
          VECTOR_LOOP_VAR
          VECTOR_LOOP_BEGIN
            y%DELEM=y%DELEM - x%DELEM
          VECTOR_LOOP_END
        end subroutine

        subroutine dec_deriv_a1_a1(y,x)
          type(active), intent(inout), dimension(:) :: y
          type(active), intent(in), dimension(:) :: x
          VECTOR_LOOP_VAR
          VECTOR_LOOP_BEGIN
            y%DELEM=y%DELEM - x%DELEM
          VECTOR_LOOP_END
        end subroutine
        
        subroutine dec_deriv_a2_a2(y,x)
          type(active), intent(inout), dimension(:,:) :: y
          type(active), intent(in), dimension(:,:) :: x
          VECTOR_LOOP_VAR
          VECTOR_LOOP_BEGIN
            y%DELEM=y%DELEM - x%DELEM
          VECTOR_LOOP_END
        end subroutine
        
        !
        ! set derivative components to 0.0
        !
        subroutine zero_deriv_a0(x)
          type(active), intent(inout) :: x
          VECTOR_LOOP_VAR
          VECTOR_LOOP_BEGIN
             x%DELEM=0.0d0
          VECTOR_LOOP_END 
        end subroutine

        subroutine zero_deriv_a1(x)
          type(active), dimension(:), intent(inout) :: x
          VECTOR_LOOP_VAR
          VECTOR_LOOP_BEGIN
             x%DELEM=0.0d0
          VECTOR_LOOP_END 
        end subroutine

        subroutine zero_deriv_a2(x)
          type(active), dimension(:,:), intent(inout) :: x
          VECTOR_LOOP_VAR
          VECTOR_LOOP_BEGIN
             x%DELEM=0.0d0
          VECTOR_LOOP_END 
        end subroutine

        subroutine zero_deriv_a3(x)
          type(active), dimension(:,:,:), intent(inout) :: x
          VECTOR_LOOP_VAR
          VECTOR_LOOP_BEGIN
             x%DELEM=0.0d0
          VECTOR_LOOP_END 
        end subroutine

        subroutine zero_deriv_a4(x)
          type(active), dimension(:,:,:,:), intent(inout) :: x
          VECTOR_LOOP_VAR
          VECTOR_LOOP_BEGIN
             x%DELEM=0.0d0
          VECTOR_LOOP_END 
        end subroutine

#endif
        !
        ! conversions
        !
        subroutine convert_d0_a0(convertTo, convertFrom)
          real(w2f__8), intent(out) :: convertTo
          type(active), intent(in) :: convertFrom
          convertTo=convertFrom%v
        end subroutine
        subroutine convert_d1_a1(convertTo, convertFrom)
          real(w2f__8), dimension(:), intent(out) :: convertTo
          type(active), dimension(:), intent(in) :: convertFrom
          convertTo=convertFrom%v
        end subroutine
        subroutine convert_d2_a2(convertTo, convertFrom)
          real(w2f__8), dimension(:,:), intent(out) :: convertTo
          type(active), dimension(:,:), intent(in) :: convertFrom
          convertTo=convertFrom%v
        end subroutine
        subroutine convert_d3_a3(convertTo, convertFrom)
          real(w2f__8), dimension(:,:,:), intent(out) :: convertTo
          type(active), dimension(:,:,:), intent(in) :: convertFrom
          convertTo=convertFrom%v
        end subroutine
        subroutine convert_d4_a4(convertTo, convertFrom)
          real(w2f__8), dimension(:,:,:,:), intent(out) :: convertTo
          type(active), dimension(:,:,:,:), intent(in) :: convertFrom
          convertTo=convertFrom%v
        end subroutine
        subroutine convert_d5_a5(convertTo, convertFrom)
          real(w2f__8), dimension(:,:,:,:,:), intent(out) :: convertTo
          type(active), dimension(:,:,:,:,:), intent(in) :: convertFrom
          convertTo=convertFrom%v
        end subroutine
        subroutine convert_d6_a6(convertTo, convertFrom)
          real(w2f__8), dimension(:,:,:,:,:,:), intent(out) :: convertTo
          type(active), dimension(:,:,:,:,:,:), intent(in) :: convertFrom
          convertTo=convertFrom%v
        end subroutine
        subroutine convert_d7_a7(convertTo, convertFrom)
          real(w2f__8), dimension(:,:,:,:,:,:,:), intent(out) :: convertTo
          type(active), dimension(:,:,:,:,:,:,:), intent(in) :: convertFrom
          convertTo=convertFrom%v
        end subroutine

        subroutine convert_a0_d0(convertTo, convertFrom)
          type(active), intent(inout) :: convertTo
          real(w2f__8), intent(in) :: convertFrom
          convertTo%v=convertFrom
        end subroutine
        subroutine convert_a1_d1(convertTo, convertFrom)
          type(active), dimension(:), intent(inout) :: convertTo
          real(w2f__8), dimension(:), intent(in) :: convertFrom
          convertTo%v=convertFrom
        end subroutine
        subroutine convert_a2_d2(convertTo, convertFrom)
          type(active), dimension(:,:), intent(inout) :: convertTo
          real(w2f__8), dimension(:,:), intent(in) :: convertFrom
          convertTo%v=convertFrom
        end subroutine
        subroutine convert_a3_d3(convertTo, convertFrom)
          type(active), dimension(:,:,:), intent(inout) :: convertTo
          real(w2f__8), dimension(:,:,:), intent(in) :: convertFrom
          convertTo%v=convertFrom
        end subroutine
        subroutine convert_a4_d4(convertTo, convertFrom)
          type(active), dimension(:,:,:,:), intent(inout) :: convertTo
          real(w2f__8), dimension(:,:,:,:), intent(in) :: convertFrom
          convertTo%v=convertFrom
        end subroutine
        subroutine convert_a5_d5(convertTo, convertFrom)
          type(active), dimension(:,:,:,:,:), intent(inout) :: convertTo
          real(w2f__8), dimension(:,:,:,:,:), intent(in) :: convertFrom
          convertTo%v=convertFrom
        end subroutine
        subroutine convert_a6_d6(convertTo, convertFrom)
          type(active), dimension(:,:,:,:,:,:), intent(inout) :: convertTo
          real(w2f__8), dimension(:,:,:,:,:,:), intent(in) :: convertFrom
          convertTo%v=convertFrom
        end subroutine
        subroutine convert_a7_d7(convertTo, convertFrom)
          type(active), dimension(:,:,:,:,:,:,:), intent(inout) :: convertTo
          real(w2f__8), dimension(:,:,:,:,:,:,:), intent(in) :: convertFrom
          convertTo%v=convertFrom
        end subroutine
#ifndef DEFAULT_R8
        subroutine convert_r0_a0(convertTo, convertFrom)
          real(w2f__4), intent(out) :: convertTo
          type(active), intent(in) :: convertFrom
          convertTo=convertFrom%v
        end subroutine
        subroutine convert_r1_a1(convertTo, convertFrom)
          real(w2f__4), dimension(:), intent(out) :: convertTo
          type(active), dimension(:), intent(in) :: convertFrom
          convertTo=convertFrom%v
        end subroutine
        subroutine convert_r2_a2(convertTo, convertFrom)
          real(w2f__4), dimension(:,:), intent(out) :: convertTo
          type(active), dimension(:,:), intent(in) :: convertFrom
          convertTo=convertFrom%v
        end subroutine
        subroutine convert_r3_a3(convertTo, convertFrom)
          real(w2f__4), dimension(:,:,:), intent(out) :: convertTo
          type(active), dimension(:,:,:), intent(in) :: convertFrom
          convertTo=convertFrom%v
        end subroutine
        subroutine convert_r4_a4(convertTo, convertFrom)
          real(w2f__4), dimension(:,:,:,:), intent(out) :: convertTo
          type(active), dimension(:,:,:,:), intent(in) :: convertFrom
          convertTo=convertFrom%v
        end subroutine
        subroutine convert_r5_a5(convertTo, convertFrom)
          real(w2f__4), dimension(:,:,:,:,:), intent(out) :: convertTo
          type(active), dimension(:,:,:,:,:), intent(in) :: convertFrom
          convertTo=convertFrom%v
        end subroutine
        subroutine convert_r6_a6(convertTo, convertFrom)
          real(w2f__4), dimension(:,:,:,:,:,:), intent(out) :: convertTo
          type(active), dimension(:,:,:,:,:,:), intent(in) :: convertFrom
          convertTo=convertFrom%v
        end subroutine
        subroutine convert_r7_a7(convertTo, convertFrom)
          real(w2f__4), dimension(:,:,:,:,:,:,:), intent(out) :: convertTo
          type(active), dimension(:,:,:,:,:,:,:), intent(in) :: convertFrom
          convertTo=convertFrom%v
        end subroutine

        subroutine convert_a0_r0(convertTo, convertFrom)
          type(active), intent(inout) :: convertTo
          real(w2f__4), intent(in) :: convertFrom
          convertTo%v=convertFrom
        end subroutine
        subroutine convert_a1_r1(convertTo, convertFrom)
          type(active), dimension(:), intent(inout) :: convertTo
          real(w2f__4), dimension(:), intent(in) :: convertFrom
          convertTo%v=convertFrom
        end subroutine
        subroutine convert_a2_r2(convertTo, convertFrom)
          type(active), dimension(:,:), intent(inout) :: convertTo
          real(w2f__4), dimension(:,:), intent(in) :: convertFrom
          convertTo%v=convertFrom
        end subroutine
        subroutine convert_a3_r3(convertTo, convertFrom)
          type(active), dimension(:,:,:), intent(inout) :: convertTo
          real(w2f__4), dimension(:,:,:), intent(in) :: convertFrom
          convertTo%v=convertFrom
        end subroutine
        subroutine convert_a4_r4(convertTo, convertFrom)
          type(active), dimension(:,:,:,:), intent(inout) :: convertTo
          real(w2f__4), dimension(:,:,:,:), intent(in) :: convertFrom
          convertTo%v=convertFrom
        end subroutine
        subroutine convert_a5_r5(convertTo, convertFrom)
          type(active), dimension(:,:,:,:,:), intent(inout) :: convertTo
          real(w2f__4), dimension(:,:,:,:,:), intent(in) :: convertFrom
          convertTo%v=convertFrom
        end subroutine
        subroutine convert_a6_r6(convertTo, convertFrom)
          type(active), dimension(:,:,:,:,:,:), intent(inout) :: convertTo
          real(w2f__4), dimension(:,:,:,:,:,:), intent(in) :: convertFrom
          convertTo%v=convertFrom
        end subroutine
        subroutine convert_a7_r7(convertTo, convertFrom)
          type(active), dimension(:,:,:,:,:,:,:), intent(inout) :: convertTo
          real(w2f__4), dimension(:,:,:,:,:,:,:), intent(in) :: convertFrom
          convertTo%v=convertFrom
        end subroutine
#endif
        !
        ! allocations
        !
        subroutine allocateMatching_d1_d1(toBeAllocated,allocateMatching)
          implicit none
          real(w2f__8), dimension(:), allocatable :: toBeAllocated
          real(w2f__8), dimension(:) :: allocateMatching
          if (allocated(toBeAllocated)) deallocate(toBeAllocated)
          allocate(toBeAllocated(size(allocateMatching)))
        end subroutine
        subroutine allocateMatching_a1_d1(toBeAllocated,allocateMatching)
          implicit none
          type(active), dimension(:), allocatable :: toBeAllocated
          real(w2f__8), dimension(:) :: allocateMatching
          if (allocated(toBeAllocated)) deallocate(toBeAllocated)
          allocate(toBeAllocated(size(allocateMatching)))
        end subroutine
        subroutine allocateMatching_d1_a1(toBeAllocated,allocateMatching)
          implicit none
          real(w2f__8), dimension(:), allocatable :: toBeAllocated
          type(active), dimension(:) :: allocateMatching
          if (allocated(toBeAllocated)) deallocate(toBeAllocated)
          allocate(toBeAllocated(size(allocateMatching)))
        end subroutine
        subroutine allocateMatching_a1_a1(toBeAllocated,allocateMatching)
          implicit none
          type(active), dimension(:), allocatable :: toBeAllocated
          type(active), dimension(:) :: allocateMatching
          if (allocated(toBeAllocated)) deallocate(toBeAllocated)
          allocate(toBeAllocated(size(allocateMatching)))
        end subroutine
        subroutine allocateMatching_d2_d2(toBeAllocated,allocateMatching)
          implicit none
          real(w2f__8), dimension(:,:), allocatable :: toBeAllocated
          real(w2f__8), dimension(:,:) :: allocateMatching
          if (allocated(toBeAllocated)) deallocate(toBeAllocated)
          allocate(toBeAllocated(size(allocateMatching,1), &
               size(allocateMatching,2)))
        end subroutine
        subroutine allocateMatching_a2_d2(toBeAllocated,allocateMatching)
          implicit none
          type(active), dimension(:,:), allocatable :: toBeAllocated
          real(w2f__8), dimension(:,:) :: allocateMatching
          if (allocated(toBeAllocated)) deallocate(toBeAllocated)
          allocate(toBeAllocated(size(allocateMatching,1), &
               size(allocateMatching,2)))
        end subroutine
        subroutine allocateMatching_d2_a2(toBeAllocated,allocateMatching)
          implicit none
          real(w2f__8), dimension(:,:), allocatable :: toBeAllocated
          type(active), dimension(:,:) :: allocateMatching
          if (allocated(toBeAllocated)) deallocate(toBeAllocated)
          allocate(toBeAllocated(size(allocateMatching,1), &
               size(allocateMatching,2)))
        end subroutine
        subroutine allocateMatching_a2_a2(toBeAllocated,allocateMatching)
          implicit none
          type(active), dimension(:,:), allocatable :: toBeAllocated
          type(active), dimension(:,:) :: allocateMatching
          if (allocated(toBeAllocated)) deallocate(toBeAllocated)
          allocate(toBeAllocated(size(allocateMatching,1), &
               size(allocateMatching,2)))
        end subroutine
        subroutine allocateMatching_d3_d3(toBeAllocated,allocateMatching)
          implicit none
          real(w2f__8), dimension(:,:,:), allocatable :: toBeAllocated
          real(w2f__8), dimension(:,:,:) :: allocateMatching
          if (allocated(toBeAllocated)) deallocate(toBeAllocated)
          allocate(toBeAllocated(size(allocateMatching,1), &
               size(allocateMatching,2),&
               size(allocateMatching,3)))
        end subroutine
        subroutine allocateMatching_a3_d3(toBeAllocated,allocateMatching)
          implicit none
          type(active), dimension(:,:,:), allocatable :: toBeAllocated
          real(w2f__8), dimension(:,:,:) :: allocateMatching
          if (allocated(toBeAllocated)) deallocate(toBeAllocated)
          allocate(toBeAllocated(size(allocateMatching,1), &
               size(allocateMatching,2),&
               size(allocateMatching,3)))
        end subroutine
        subroutine allocateMatching_d3_a3(toBeAllocated,allocateMatching)
          implicit none
          real(w2f__8), dimension(:,:,:), allocatable :: toBeAllocated
          type(active), dimension(:,:,:) :: allocateMatching
          if (allocated(toBeAllocated)) deallocate(toBeAllocated)
          allocate(toBeAllocated(size(allocateMatching,1), &
               size(allocateMatching,2),&
               size(allocateMatching,3)))
        end subroutine
        subroutine allocateMatching_a3_a3(toBeAllocated,allocateMatching)
          implicit none
          type(active), dimension(:,:,:), allocatable :: toBeAllocated
          type(active), dimension(:,:,:) :: allocateMatching
          if (allocated(toBeAllocated)) deallocate(toBeAllocated)
          allocate(toBeAllocated(size(allocateMatching,1), &
               size(allocateMatching,2),&
               size(allocateMatching,3)))
        end subroutine
        subroutine allocateMatching_a4_a4(toBeAllocated,allocateMatching)
          implicit none
          type(active), dimension(:,:,:,:), allocatable :: toBeAllocated
          type(active), dimension(:,:,:,:) :: allocateMatching
          if (allocated(toBeAllocated)) deallocate(toBeAllocated)
          allocate(toBeAllocated(size(allocateMatching,1), &
               size(allocateMatching,2),&
               size(allocateMatching,3),&
               size(allocateMatching,4)))
        end subroutine
        subroutine allocateMatching_d4_a4(toBeAllocated,allocateMatching)
          implicit none
          real(w2f__8), dimension(:,:,:,:), allocatable :: toBeAllocated
          type(active), dimension(:,:,:,:) :: allocateMatching
          if (allocated(toBeAllocated)) deallocate(toBeAllocated)
          allocate(toBeAllocated(size(allocateMatching,1), &
               size(allocateMatching,2),&
               size(allocateMatching,3),&
               size(allocateMatching,4)))
        end subroutine
        subroutine allocateMatching_d5_d5(toBeAllocated,allocateMatching)
          implicit none
          real(w2f__8), dimension(:,:,:,:,:), allocatable :: toBeAllocated
          real(w2f__8), dimension(:,:,:,:,:) :: allocateMatching
          if (allocated(toBeAllocated)) deallocate(toBeAllocated)
          allocate(toBeAllocated(size(allocateMatching,1), &
               size(allocateMatching,2),&
               size(allocateMatching,3),&
               size(allocateMatching,4),&
               size(allocateMatching,5)))
        end subroutine
        subroutine allocateMatching_a5_d5(toBeAllocated,allocateMatching)
          implicit none
          type(active), dimension(:,:,:,:,:), allocatable :: toBeAllocated
          real(w2f__8), dimension(:,:,:,:,:) :: allocateMatching
          if (allocated(toBeAllocated)) deallocate(toBeAllocated)
          allocate(toBeAllocated(size(allocateMatching,1), &
               size(allocateMatching,2),&
               size(allocateMatching,3),&
               size(allocateMatching,4),&
               size(allocateMatching,5)))
        end subroutine
        subroutine allocateMatching_d5_a5(toBeAllocated,allocateMatching)
          implicit none
          real(w2f__8), dimension(:,:,:,:,:), allocatable :: toBeAllocated
          type(active), dimension(:,:,:,:,:) :: allocateMatching
          if (allocated(toBeAllocated)) deallocate(toBeAllocated)
          allocate(toBeAllocated(size(allocateMatching,1), &
               size(allocateMatching,2),&
               size(allocateMatching,3),&
               size(allocateMatching,4),&
               size(allocateMatching,5)))
        end subroutine
        subroutine allocateMatching_a5_a5(toBeAllocated,allocateMatching)
          implicit none
          type(active), dimension(:,:,:,:,:), allocatable :: toBeAllocated
          type(active), dimension(:,:,:,:,:) :: allocateMatching
          if (allocated(toBeAllocated)) deallocate(toBeAllocated)
          allocate(toBeAllocated(size(allocateMatching,1), &
               size(allocateMatching,2),&
               size(allocateMatching,3),&
               size(allocateMatching,4),&
               size(allocateMatching,5)))
        end subroutine
        subroutine allocateMatching_d6_d6(toBeAllocated,allocateMatching)
          implicit none
          real(w2f__8), dimension(:,:,:,:,:,:), allocatable :: toBeAllocated
          real(w2f__8), dimension(:,:,:,:,:,:) :: allocateMatching
          if (allocated(toBeAllocated)) deallocate(toBeAllocated)
          allocate(toBeAllocated(size(allocateMatching,1), &
               size(allocateMatching,2),&
               size(allocateMatching,3),&
               size(allocateMatching,4),&
               size(allocateMatching,5),&
               size(allocateMatching,6)))
        end subroutine
        subroutine allocateMatching_a6_d6(toBeAllocated,allocateMatching)
          implicit none
          type(active), dimension(:,:,:,:,:,:), allocatable :: toBeAllocated
          real(w2f__8), dimension(:,:,:,:,:,:) :: allocateMatching
          if (allocated(toBeAllocated)) deallocate(toBeAllocated)
          allocate(toBeAllocated(size(allocateMatching,1), &
               size(allocateMatching,2),&
               size(allocateMatching,3),&
               size(allocateMatching,4),&
               size(allocateMatching,5),&
               size(allocateMatching,6)))
        end subroutine
        subroutine allocateMatching_d6_a6(toBeAllocated,allocateMatching)
          implicit none
          real(w2f__8), dimension(:,:,:,:,:,:), allocatable :: toBeAllocated
          type(active), dimension(:,:,:,:,:,:) :: allocateMatching
          if (allocated(toBeAllocated)) deallocate(toBeAllocated)
          allocate(toBeAllocated(size(allocateMatching,1), &
               size(allocateMatching,2),&
               size(allocateMatching,3),&
               size(allocateMatching,4),&
               size(allocateMatching,5),&
               size(allocateMatching,6)))
        end subroutine
        subroutine allocateMatching_a6_a6(toBeAllocated,allocateMatching)
          implicit none
          type(active), dimension(:,:,:,:,:,:), allocatable :: toBeAllocated
          type(active), dimension(:,:,:,:,:,:) :: allocateMatching
          if (allocated(toBeAllocated)) deallocate(toBeAllocated)
          allocate(toBeAllocated(size(allocateMatching,1), &
               size(allocateMatching,2),&
               size(allocateMatching,3),&
               size(allocateMatching,4),&
               size(allocateMatching,5),&
               size(allocateMatching,6)))
        end subroutine
#ifndef DEFAULT_R8
        subroutine allocateMatching_r1_r1(toBeAllocated,allocateMatching)
          implicit none
          real(w2f__4), dimension(:), allocatable :: toBeAllocated
          real(w2f__4), dimension(:) :: allocateMatching
          if (allocated(toBeAllocated)) deallocate(toBeAllocated)
          allocate(toBeAllocated(size(allocateMatching)))
        end subroutine
        subroutine allocateMatching_d1_r1(toBeAllocated,allocateMatching)
          implicit none
          real(w2f__8), dimension(:), allocatable :: toBeAllocated
          real(w2f__4), dimension(:) :: allocateMatching
          if (allocated(toBeAllocated)) deallocate(toBeAllocated)
          allocate(toBeAllocated(size(allocateMatching)))
        end subroutine
        subroutine allocateMatching_r1_d1(toBeAllocated,allocateMatching)
          implicit none
          real(w2f__4), dimension(:), allocatable :: toBeAllocated
          real(w2f__8), dimension(:) :: allocateMatching
          if (allocated(toBeAllocated)) deallocate(toBeAllocated)
          allocate(toBeAllocated(size(allocateMatching)))
        end subroutine
        subroutine allocateMatching_a1_r1(toBeAllocated,allocateMatching)
          implicit none
          type(active), dimension(:), allocatable :: toBeAllocated
          real(w2f__4), dimension(:) :: allocateMatching
          if (allocated(toBeAllocated)) deallocate(toBeAllocated)
          allocate(toBeAllocated(size(allocateMatching)))
        end subroutine
        subroutine allocateMatching_r1_a1(toBeAllocated,allocateMatching)
          implicit none
          real(w2f__4), dimension(:), allocatable :: toBeAllocated
          type(active), dimension(:) :: allocateMatching
          if (allocated(toBeAllocated)) deallocate(toBeAllocated)
          allocate(toBeAllocated(size(allocateMatching)))
        end subroutine
        subroutine allocateMatching_a2_r2(toBeAllocated,allocateMatching)
          implicit none
          type(active), dimension(:,:), allocatable :: toBeAllocated
          real(w2f__4), dimension(:,:) :: allocateMatching
          if (allocated(toBeAllocated)) deallocate(toBeAllocated)
          allocate(toBeAllocated(size(allocateMatching,1), &
               size(allocateMatching,2)))
        end subroutine
        subroutine allocateMatching_r2_a2(toBeAllocated,allocateMatching)
          implicit none
          real(w2f__4), dimension(:,:), allocatable :: toBeAllocated
          type(active), dimension(:,:) :: allocateMatching
          if (allocated(toBeAllocated)) deallocate(toBeAllocated)
          allocate(toBeAllocated(size(allocateMatching,1), &
               size(allocateMatching,2)))
        end subroutine
#endif
        !
        ! allocate shape
        !
        subroutine allocateShape_d1(toBeAllocated,s1)
          implicit none
          real(w2f__8), dimension(:), allocatable :: toBeAllocated
          integer(w2f__i8) :: s1
          if (allocated(toBeAllocated)) deallocate(toBeAllocated)
          allocate(toBeAllocated(s1))
        end subroutine
        subroutine allocateShape_d2(toBeAllocated,s1,s2)
          implicit none
          real(w2f__8), dimension(:,:), allocatable :: toBeAllocated
          integer(w2f__i8) :: s1,s2
          if (allocated(toBeAllocated)) deallocate(toBeAllocated)
          allocate(toBeAllocated(s1,s2))
        end subroutine
        !
        ! shape tests
        !
        subroutine shapeTest_a1_d1(allocatedVar,origVar)
          implicit none
          type(active), dimension(:), allocatable :: allocatedVar
          real(w2f__8), dimension(:) :: origVar
          if (.not. all(shape(allocatedVar)==shape(origVar))) call runTimeErrorStop(shapeChange)
        end subroutine
        subroutine shapeTest_a1_a1(allocatedVar,origVar)
          implicit none
          type(active), dimension(:), allocatable :: allocatedVar
          type(active), dimension(:) :: origVar
          if (.not. all(shape(allocatedVar)==shape(origVar))) call runTimeErrorStop(shapeChange)
        end subroutine
        subroutine shapeTest_d1_a1(allocatedVar,origVar)
          implicit none
          real(w2f__8), dimension(:), allocatable :: allocatedVar
          type(active), dimension(:) :: origVar
          if (.not. all(shape(allocatedVar)==shape(origVar))) call runTimeErrorStop(shapeChange)
        end subroutine
        subroutine shapeTest_a2_d2(allocatedVar,origVar)
          implicit none
          type(active), dimension(:,:), allocatable :: allocatedVar
          real(w2f__8), dimension(:,:) :: origVar
          if (.not. all(shape(allocatedVar)==shape(origVar))) call runTimeErrorStop(shapeChange)
        end subroutine
        subroutine shapeTest_a2_a2(allocatedVar,origVar)
          implicit none
          type(active), dimension(:,:), allocatable :: allocatedVar
          type(active), dimension(:,:) :: origVar
          if (.not. all(shape(allocatedVar)==shape(origVar))) call runTimeErrorStop(shapeChange)
        end subroutine
        subroutine shapeTest_d2_a2(allocatedVar,origVar)
          implicit none
          real(w2f__8), dimension(:,:), allocatable :: allocatedVar
          type(active), dimension(:,:) :: origVar
          if (.not. all(shape(allocatedVar)==shape(origVar))) call runTimeErrorStop(shapeChange)
        end subroutine
        subroutine shapeTest_a3_a3(allocatedVar,origVar)
          implicit none
          type(active), dimension(:,:,:), allocatable :: allocatedVar
          type(active), dimension(:,:,:) :: origVar
          if (.not. all(shape(allocatedVar)==shape(origVar))) call runTimeErrorStop(shapeChange)
        end subroutine
        subroutine shapeTest_d3_a3(allocatedVar,origVar)
          implicit none
          real(w2f__8), dimension(:,:,:), allocatable :: allocatedVar
          type(active), dimension(:,:,:) :: origVar
          if (.not. all(shape(allocatedVar)==shape(origVar))) call runTimeErrorStop(shapeChange)
        end subroutine
        subroutine shapeTest_a4_a4(allocatedVar,origVar)
          implicit none
          type(active), dimension(:,:,:,:), allocatable :: allocatedVar
          type(active), dimension(:,:,:,:) :: origVar
          if (.not. all(shape(allocatedVar)==shape(origVar))) call runTimeErrorStop(shapeChange)
        end subroutine
        subroutine shapeTest_d4_a4(allocatedVar,origVar)
          implicit none
          real(w2f__8), dimension(:,:,:,:), allocatable :: allocatedVar
          type(active), dimension(:,:,:,:) :: origVar
          if (.not. all(shape(allocatedVar)==shape(origVar))) call runTimeErrorStop(shapeChange)
        end subroutine
        subroutine shapeTest_a5_a5(allocatedVar,origVar)
          implicit none
          type(active), dimension(:,:,:,:,:), allocatable :: allocatedVar
          type(active), dimension(:,:,:,:,:) :: origVar
          if (.not. all(shape(allocatedVar)==shape(origVar))) call runTimeErrorStop(shapeChange)
        end subroutine
        subroutine shapeTest_d5_a5(allocatedVar,origVar)
          implicit none
          real(w2f__8), dimension(:,:,:,:,:), allocatable :: allocatedVar
          type(active), dimension(:,:,:,:,:) :: origVar
          if (.not. all(shape(allocatedVar)==shape(origVar))) call runTimeErrorStop(shapeChange) 
        end subroutine
        subroutine shapeTest_a5_d5(allocatedVar,origVar)
          implicit none
          type(active), dimension(:,:,:,:,:), allocatable :: allocatedVar
          real(w2f__8), dimension(:,:,:,:,:) :: origVar
          if (.not. all(shape(allocatedVar)==shape(origVar))) call runTimeErrorStop(shapeChange) 
        end subroutine
        subroutine shapeTest_a6_a6(allocatedVar,origVar)
          implicit none
          type(active), dimension(:,:,:,:,:,:), allocatable :: allocatedVar
          type(active), dimension(:,:,:,:,:,:) :: origVar
          if (.not. all(shape(allocatedVar)==shape(origVar))) call runTimeErrorStop(shapeChange)
        end subroutine
        subroutine shapeTest_d6_a6(allocatedVar,origVar)
          implicit none
          real(w2f__8), dimension(:,:,:,:,:,:), allocatable :: allocatedVar
          type(active), dimension(:,:,:,:,:,:) :: origVar
          if (.not. all(shape(allocatedVar)==shape(origVar))) call runTimeErrorStop(shapeChange) 
        end subroutine
        subroutine shapeTest_a6_d6(allocatedVar,origVar)
          implicit none
          type(active), dimension(:,:,:,:,:,:), allocatable :: allocatedVar
          real(w2f__8), dimension(:,:,:,:,:,:) :: origVar
          if (.not. all(shape(allocatedVar)==shape(origVar))) call runTimeErrorStop(shapeChange) 
        end subroutine
#ifndef DEFAULT_R8
        subroutine shapeTest_r1_a1(allocatedVar,origVar)
          implicit none
          real(w2f__4), dimension(:), allocatable :: allocatedVar
          type(active), dimension(:) :: origVar
          if (.not. all(shape(allocatedVar)==shape(origVar))) call runTimeErrorStop(shapeChange)
        end subroutine
        subroutine shapeTest_r2_a2(allocatedVar,origVar)
          implicit none
          real(w2f__4), dimension(:,:), allocatable :: allocatedVar
          type(active), dimension(:,:) :: origVar
          if (.not. all(shape(allocatedVar)==shape(origVar))) call runTimeErrorStop(shapeChange)
        end subroutine
        subroutine shapeTest_a1_r1(allocatedVar,origVar)
          implicit none
          type(active), dimension(:), allocatable :: allocatedVar
          real(w2f__4), dimension(:) :: origVar
          if (.not. all(shape(allocatedVar)==shape(origVar))) call runTimeErrorStop(shapeChange)
        end subroutine
        subroutine shapeTest_a2_r2(allocatedVar,origVar)
          implicit none
          type(active), dimension(:,:), allocatable :: allocatedVar
          real(w2f__4), dimension(:,:) :: origVar
          if (.not. all(shape(allocatedVar)==shape(origVar))) call runTimeErrorStop(shapeChange)
        end subroutine
#endif
        subroutine runTimeErrorStopI(mesgId)
          implicit none
          integer mesgId
          select case (mesgId) 
          case (shapeChange)
             stop "ERROR: OAD run time library: detected shape change"
             end select 
        end subroutine

        end module

#include "OBSFIT_OPTIONS.h"
#ifdef ALLOW_CTRL
# include "CTRL_OPTIONS.h"
#endif

CBOP
C     !ROUTINE: OBSFIT_INLOOP

C     !INTERFACE:
      SUBROUTINE OBSFIT_INLOOP( myTime, myIter, myThid )

C     !DESCRIPTION:
C     ==================================================================
C     | Computes and writes model counterparts for ObsFit data
C     ==================================================================

C     !USES:
      IMPLICIT NONE
C     == Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "GRID.h"
#include "DYNVARS.h"
#include "PARAMS.h"
#ifdef ALLOW_CAL
# include "cal.h"
#endif
#ifdef ALLOW_CTRL
# include "OPTIMCYCLE.h"
#endif
#ifdef ALLOW_OBSFIT
# include "OBSFIT_SIZE.h"
# include "OBSFIT.h"
# include "netcdf.inc"
#endif

C     !INPUT PARAMETERS:
C     myTime :: Current time in simulation
C     myIter :: Current iteration number in simulation
C     myThid :: my thread ID number
      _RL     myTime
      INTEGER myIter
      INTEGER myThid
CEOP

#ifdef ALLOW_OBSFIT
C     !LOCAL VARIABLES:
      INTEGER sample_num, num_file, iq
      INTEGER bi, bj
      INTEGER sample_i(NUM_INTERP_PTS_OBS)
      INTEGER sample_j(NUM_INTERP_PTS_OBS)
      INTEGER sample_k(NUM_INTERP_PTS_OBS)
      _RL     sample_frac(NUM_INTERP_PTS_OBS)
      _RL     sample_modval, saved_modval
# ifndef ALLOW_CTRL
      INTEGER optimcycle
# endif
# ifndef ALLOW_ECCO
      INTEGER i,j,k
# endif

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

# ifndef ALLOW_CTRL
      optimcycle = 0
# endif

# ifndef ALLOW_ECCO
      DO bj = myByLo(myThid), myByHi(myThid)
        DO bi = myBxLo(myThid), myBxHi(myThid)
          DO k = 1, Nr
            DO j = 1, sNy
              DO i =  1, sNx
                m_UE(i,j,k,bi,bj) = 0. _d 0
                m_VN(i,j,k,bi,bj) = 0. _d 0
              ENDDO
            ENDDO
          ENDDO
        ENDDO
      ENDDO

      CALL ROTATE_UV2EN_RL(
     U     uVel, vVel, m_UE, m_VN,
     I     .TRUE., .TRUE., .FALSE., Nr, myThid )
# endif /* not ALLOW_ECCO */

      _BEGIN_MASTER( myThid )

      DO bj = 1, nSy
        DO bi = 1, nSx
          DO num_file = 1, NFILESMAX_OBS
            DO sample_num = 1, NSAMP_PER_TILE_MAX
              IF ( sample_num.LE.sampleNo(num_file,bi,bj) ) THEN
                IF ( (sample_timeE(num_file,sample_num,bi,bj).GE.
     &           myTime).AND.
     &           (sample_timeS(num_file,sample_num,bi,bj).LT.
     &           (myTime+deltaTClock)) ) THEN
                  DO iq = 1, NUM_INTERP_PTS_OBS
                    sample_i(iq) =
     &               sample_interp_i(num_file,sample_num,iq,bi,bj)
                    sample_j(iq) =
     &               sample_interp_j(num_file,sample_num,iq,bi,bj)
                    sample_k(iq) =
     &               sample_interp_k(num_file,sample_num,iq,bi,bj)
                    sample_frac(iq) = sample_interp_frac
     &               (num_file,sample_num,iq,bi,bj)
                  ENDDO

                  sample_modval = 0
                  saved_modval = 0

C If averaging or integrating in time, read previously
C recorded value and add to it
                  IF ( obsfitOperation(num_file).GT.0 ) THEN
                    CALL ACTIVE_READ_OBS_TILE(
     I                   num_file,
     O                   saved_modval,
     I                   sample_num,.FALSE.,optimcycle,bi,bj,myThid,
     I                   obsfit_dummy(num_file,bi,bj) )
                  ENDIF

                  CALL OBSFIT_SAMPLING(
     O                 sample_modval,
     I                 sample_i, sample_j, sample_k, sample_frac,
     I                 sample_type(num_file,sample_num,bi,bj),
     I                 num_file, bi, bj, myTime, myIter, myThid )

                  sample_modval = sample_modval*
     &             obsfit_facmod(num_file)

                  IF ( obsfitOperation(num_file).GT.0 ) THEN
                    sample_modval = saved_modval
     &               +sample_modval*deltaTClock
                  ENDIF

                  sample_modmask(bi,bj) = sample_modmask(bi,bj)*
     &             sample_weight(num_file,sample_num,bi,bj)

                  CALL ACTIVE_WRITE_OBS_TILE(
     I                 num_file,sample_modval,
     I                 sample_num,optimcycle,bi,bj,myThid,
     I                 obsfit_dummy(num_file,bi,bj) )

                ENDIF !IF ((sample_time
              ENDIF !IF (sampleNo(num_file,bi,bj).NE.0)
            ENDDO !DO sample_num
          ENDDO !DO num_file

        ENDDO
      ENDDO

      _END_MASTER( myThid )

#endif /* ALLOW_OBSFIT */

      RETURN
      END

#include "SEAICE_OPTIONS.h"

CBOP
C     !ROUTINE: SEAICE_WRITE_PICKUP
C     !INTERFACE:
      SUBROUTINE SEAICE_WRITE_PICKUP ( permPickup, suff,
     I                                 myTime, myIter, myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE SEAICE_WRITE_PICKUP
C     | o Write sea ice pickup file for restarting.
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     == Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "SEAICE_SIZE.h"
#include "SEAICE_PARAMS.h"
#include "SEAICE.h"
#include "SEAICE_TRACER.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     permPickup :: write a permanent pickup
C     suff    :: suffix for pickup file (eg. ckptA or 0000000010)
C     myTime  :: Current time in simulation
C     myIter  :: Current iteration number in simulation
C     myThid  :: My Thread Id number
      LOGICAL permPickup
      CHARACTER*(*) suff
      _RL     myTime
      INTEGER myIter
      INTEGER myThid

C     !LOCAL VARIABLES:
C     == Local variables ==
C     fp          :: pickup-file precision ( precFloat64 )
C     glf         :: local flag for "globalFiles"
C     fn          :: Temp. for building file name.
C     nWrFlds     :: number of fields being written
C     listDim     :: dimension of "wrFldList" local array
C     wrFldList   :: list of written fields
C     j           :: loop index / field number
C     nj          :: record number
C     msgBuf      :: Informational/error message buffer
      INTEGER fp
      LOGICAL  glf
      _RL     timList(1)
      CHARACTER*(MAX_LEN_FNAM) fn
      INTEGER listDim, nWrFlds
      PARAMETER( listDim = 20 )
      CHARACTER*(8) wrFldList(listDim)
      INTEGER j, nj
      CHARACTER*(MAX_LEN_MBUF) msgBuf
#ifdef ALLOW_SITRACER
      CHARACTER*(8) fldName
      INTEGER iTrac
#endif
CEOP

C--   Write model fields
      WRITE(fn,'(A,A)') 'pickup_seaice.',suff

c     IF ( seaice_pickup_write_mdsio ) THEN

       fp = precFloat64
       j = 0
       nj = 0
C     record number < 0 : a hack not to write meta files now:

C--   write Sea-Ice Thermodynamics State variables, starting with 3-D fields:
       IF ( .NOT.useThSIce ) THEN

#ifdef SEAICE_ITD

        j = j + 1
        CALL WRITE_REC_3D_RL( fn,fp, nITD, TICES,   -j, myIter,myThid )
        IF (j.LE.listDim) wrFldList(j) = 'siTICES '
        j = j + 1
        CALL WRITE_REC_3D_RL( fn,fp, nITD, AREAITD, -j, myIter,myThid )
        IF (j.LE.listDim) wrFldList(j) = 'siAREAn '
        j = j + 1
        CALL WRITE_REC_3D_RL( fn,fp, nITD, HEFFITD, -j, myIter,myThid )
        IF (j.LE.listDim) wrFldList(j) = 'siHEFFn '
        j = j + 1
        CALL WRITE_REC_3D_RL( fn,fp, nITD, HSNOWITD,-j, myIter,myThid )
        IF (j.LE.listDim) wrFldList(j) = 'siHSNOWn'
C-    switch to 2-D fields:
        nj = -j*nITD

#else /* SEAICE_ITD */

        j = j + 1
        nj = nj-1
        IF (SEAICE_multDim.GT.1) THEN
         CALL WRITE_REC_3D_RL(fn,fp,nITD,TICES, nj, myIter, myThid )
         IF (j.LE.listDim) wrFldList(j) = 'siTICES '
C-    switch to 2-D fields:
c         nj = nj*nITD
         nj = nj-nITD+1
        ELSE
         CALL WRITE_REC_LEV_RL( fn, fp, nITD, 1, 1, TICES,
     I                          nj, myIter, myThid )
         IF (j.LE.listDim) wrFldList(j) = 'siTICE  '
        ENDIF

C---  continue to write 2-D fields:
        j = j + 1
        nj = nj-1
        CALL WRITE_REC_3D_RL( fn, fp,  1, AREA , nj, myIter, myThid )
        IF (j.LE.listDim) wrFldList(j) = 'siAREA  '
        j = j + 1
        nj = nj-1
        CALL WRITE_REC_3D_RL( fn, fp,  1, HEFF , nj, myIter, myThid )
        IF (j.LE.listDim) wrFldList(j) = 'siHEFF  '
        j = j + 1
        nj = nj-1
        CALL WRITE_REC_3D_RL( fn, fp,  1, HSNOW , nj, myIter, myThid )
        IF (j.LE.listDim) wrFldList(j) = 'siHSNOW '

#endif /* SEAICE_ITD */

#ifdef SEAICE_VARIABLE_SALINITY
        j = j + 1
        nj = nj-1
        CALL WRITE_REC_3D_RL( fn, fp,  1, HSALT , nj, myIter, myThid )
        IF (j.LE.listDim) wrFldList(j) = 'siHSALT '
#endif
#ifdef ALLOW_SITRACER
         DO iTrac = 1, SItrNumInUse
          WRITE(fldName,'(A6,I2.2)') 'siTrac', iTrac
          j = j + 1
          nj = nj-1
          CALL WRITE_REC_3D_RL( fn, fp,  1,
     &         SItracer(1-OLx,1-OLy,1,1,iTrac),
     &         nj, myIter, myThid )
          IF (j.LE.listDim) wrFldList(j) = fldName
         ENDDO
#endif
       ENDIF

C--    write Sea-Ice Dynamics variables (all 2-D fields):
       j = j + 1
       nj = nj-1
       CALL WRITE_REC_3D_RL( fn, fp,  1, UICE , nj, myIter, myThid )
       IF (j.LE.listDim)  wrFldList(j) = 'siUICE  '

       j = j + 1
       nj = nj-1
       CALL WRITE_REC_3D_RL( fn, fp,  1, VICE , nj, myIter, myThid )
       IF (j.LE.listDim)  wrFldList(j) = 'siVICE  '

       IF ( SEAICEuseBDF2 ) THEN
        j = j + 1
        nj = nj-1
        CALL WRITE_REC_3D_RL( fn, fp,  1, uIceNm1 , nj, myIter, myThid )
        IF (j.LE.listDim)  wrFldList(j) = 'siUicNm1'

        j = j + 1
        nj = nj-1
        CALL WRITE_REC_3D_RL( fn, fp,  1, vIceNm1 , nj, myIter, myThid )
        IF (j.LE.listDim)  wrFldList(j) = 'siVicNm1'
       ENDIF
#if (defined(SEAICE_CGRID) && defined(SEAICE_ALLOW_EVP))
       IF ( SEAICEuseEVP ) THEN
        j = j + 1
        nj = nj-1
        CALL WRITE_REC_3D_RL( fn, fp,  1, seaice_sigma1,
     &                                            nj, myIter, myThid )
        IF (j.LE.listDim) wrFldList(j) = 'siSigm1 '

        j = j + 1
        nj = nj-1
        CALL WRITE_REC_3D_RL( fn, fp,  1, seaice_sigma2,
     &                                            nj, myIter, myThid )
        IF (j.LE.listDim) wrFldList(j) = 'siSigm2 '

        j = j + 1
        nj = nj-1
        CALL WRITE_REC_3D_RL( fn, fp,  1, seaice_sigma12,
     &                                            nj, myIter, myThid )
        IF (j.LE.listDim) wrFldList(j) = 'siSigm12'
       ENDIF
#endif /* SEAICE_ALLOW_EVP */

       nWrFlds = j
       IF ( nWrFlds.GT.listDim ) THEN
         WRITE(msgBuf,'(2A,I5,A)') 'WRITE_SEAICE_PICKUP: ',
     &     'trying to write ',nWrFlds,' fields'
         CALL PRINT_ERROR( msgBuf, myThid )
         WRITE(msgBuf,'(2A,I5,A)') 'WRITE_SEAICE_PICKUP: ',
     &     'field-list dimension (listDim=',listDim,') too small'
         CALL PRINT_ERROR( msgBuf, myThid )
         STOP 'ABNORMAL END: S/R WRITE_SEAICE_PICKUP (list-size Pb)'
       ENDIF

#ifdef ALLOW_MDSIO
C     uses this specific S/R to write (with more informations) only meta files
       nj = ABS(nj)
       glf  = globalFiles
       timList(1) = myTime
       CALL MDS_WR_METAFILES( fn, fp, glf, .FALSE.,
     &                         0, 0, 1, ' ',
     &                         nWrFlds, wrFldList,
     &                         1, timList, oneRL,
     &                         nj, myIter, myThid )
C
#endif /* ALLOW_MDSIO */
C--------------------------
c     ENDIF

      RETURN
      END

#include "OBCS_OPTIONS.h"
#ifdef ALLOW_AUTODIFF
# include "AUTODIFF_OPTIONS.h"
#endif

CBOP
C     !ROUTINE: OBCS_INIT_VARIABLES
C     !INTERFACE:
      SUBROUTINE OBCS_INIT_VARIABLES( myThid )

C     !DESCRIPTION:
C     *==========================================================*
C     | SUBROUTINE OBCS_INIT_VARIABLES
C     | o Initialise OBCs variable data
C     *==========================================================*
C     *==========================================================*

C     !USES:
      IMPLICIT NONE
C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "DYNVARS.h"
#include "OBCS_PARAMS.h"
c#include "OBCS_GRID.h"
#include "OBCS_FIELDS.h"
#include "OBCS_SEAICE.h"
#ifdef ALLOW_PTRACERS
#include "PTRACERS_SIZE.h"
#include "PTRACERS_PARAMS.h"
#include "PTRACERS_FIELDS.h"
#include "OBCS_PTRACERS.h"
#endif /* ALLOW_PTRACERS */

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     myThid :: my Thread Id Number
      INTEGER myThid
CEOP

#ifdef ALLOW_OBCS

C     !LOCAL VARIABLES:
C     == Local variables ==
      INTEGER bi, bj
      INTEGER i, j, k
#ifdef ALLOW_PTRACERS
      INTEGER iTracer
#endif /* ALLOW_PTRACERS */

#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_ENTER('OBCS_INIT_VARIABLES',myThid)
#endif

      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)

#ifdef ALLOW_OBCS_PRESCRIBE
        OBCS_ldRec(bi,bj) = 0
#endif
        DO k=1,Nr
         DO i=1-OLx,sNx+OLx
#ifdef ALLOW_OBCS_NORTH
          OBNu(i,k,bi,bj)=0. _d 0
          OBNv(i,k,bi,bj)=0. _d 0
          OBNt(i,k,bi,bj)=0. _d 0
          OBNs(i,k,bi,bj)=0. _d 0
# ifdef ALLOW_OBCS_PRESCRIBE
          OBNu0(i,k,bi,bj)=0. _d 0
          OBNv0(i,k,bi,bj)=0. _d 0
          OBNt0(i,k,bi,bj)=0. _d 0
          OBNs0(i,k,bi,bj)=0. _d 0
          OBNu1(i,k,bi,bj)=0. _d 0
          OBNv1(i,k,bi,bj)=0. _d 0
          OBNt1(i,k,bi,bj)=0. _d 0
          OBNs1(i,k,bi,bj)=0. _d 0
# endif
# ifdef ALLOW_OBCS_STEVENS
          OBNvStevens(i,k,bi,bj)=0. _d 0
          OBNtStevens(i,k,bi,bj)=0. _d 0
          OBNsStevens(i,k,bi,bj)=0. _d 0
# endif /* ALLOW_OBCS_STEVENS */
#endif /* ALLOW_OBCS_NORTH */

#ifdef ALLOW_OBCS_SOUTH
          OBSu(i,k,bi,bj)=0. _d 0
          OBSv(i,k,bi,bj)=0. _d 0
          OBSt(i,k,bi,bj)=0. _d 0
          OBSs(i,k,bi,bj)=0. _d 0
# ifdef ALLOW_OBCS_PRESCRIBE
          OBSu0(i,k,bi,bj)=0. _d 0
          OBSv0(i,k,bi,bj)=0. _d 0
          OBSt0(i,k,bi,bj)=0. _d 0
          OBSs0(i,k,bi,bj)=0. _d 0
          OBSu1(i,k,bi,bj)=0. _d 0
          OBSv1(i,k,bi,bj)=0. _d 0
          OBSt1(i,k,bi,bj)=0. _d 0
          OBSs1(i,k,bi,bj)=0. _d 0
# endif
# ifdef ALLOW_OBCS_STEVENS
          OBSvStevens(i,k,bi,bj)=0. _d 0
          OBStStevens(i,k,bi,bj)=0. _d 0
          OBSsStevens(i,k,bi,bj)=0. _d 0
# endif /* ALLOW_OBCS_STEVENS */
#endif /* ALLOW_OBCS_SOUTH */
         ENDDO

         DO j=1-OLy,sNy+OLy
#ifdef ALLOW_OBCS_EAST
          OBEu(j,k,bi,bj)=0. _d 0
          OBEv(j,k,bi,bj)=0. _d 0
          OBEt(j,k,bi,bj)=0. _d 0
          OBEs(j,k,bi,bj)=0. _d 0
# ifdef ALLOW_OBCS_PRESCRIBE
          OBEu0(j,k,bi,bj)=0. _d 0
          OBEv0(j,k,bi,bj)=0. _d 0
          OBEt0(j,k,bi,bj)=0. _d 0
          OBEs0(j,k,bi,bj)=0. _d 0
          OBEu1(j,k,bi,bj)=0. _d 0
          OBEv1(j,k,bi,bj)=0. _d 0
          OBEt1(j,k,bi,bj)=0. _d 0
          OBEs1(j,k,bi,bj)=0. _d 0
# endif
# ifdef ALLOW_OBCS_STEVENS
          OBEuStevens(j,k,bi,bj)=0. _d 0
          OBEtStevens(j,k,bi,bj)=0. _d 0
          OBEsStevens(j,k,bi,bj)=0. _d 0
# endif /* ALLOW_OBCS_STEVENS */
#endif /* ALLOW_OBCS_EAST */

#ifdef ALLOW_OBCS_WEST
          OBWu(j,k,bi,bj)=0. _d 0
          OBWv(j,k,bi,bj)=0. _d 0
          OBWt(j,k,bi,bj)=0. _d 0
          OBWs(j,k,bi,bj)=0. _d 0
# ifdef ALLOW_OBCS_PRESCRIBE
          OBWu0(j,k,bi,bj)=0. _d 0
          OBWv0(j,k,bi,bj)=0. _d 0
          OBWt0(j,k,bi,bj)=0. _d 0
          OBWs0(j,k,bi,bj)=0. _d 0
          OBWu1(j,k,bi,bj)=0. _d 0
          OBWv1(j,k,bi,bj)=0. _d 0
          OBWt1(j,k,bi,bj)=0. _d 0
          OBWs1(j,k,bi,bj)=0. _d 0
# endif
# ifdef ALLOW_OBCS_STEVENS
          OBWuStevens(j,k,bi,bj)=0. _d 0
          OBWtStevens(j,k,bi,bj)=0. _d 0
          OBWsStevens(j,k,bi,bj)=0. _d 0
# endif /* ALLOW_OBCS_STEVENS */
#endif /* ALLOW_OBCS_WEST */
         ENDDO
        ENDDO

#ifdef ALLOW_NONHYDROSTATIC
        DO k=1,Nr
         DO i=1-OLx,sNx+OLx
          OBNw (i,k,bi,bj) = 0. _d 0
          OBSw (i,k,bi,bj) = 0. _d 0
# ifdef ALLOW_OBCS_PRESCRIBE
          OBNw0(i,k,bi,bj) = 0. _d 0
          OBSw0(i,k,bi,bj) = 0. _d 0
          OBNw1(i,k,bi,bj) = 0. _d 0
          OBSw1(i,k,bi,bj) = 0. _d 0
# endif
         ENDDO
         DO j=1-OLy,sNy+OLy
          OBEw (j,k,bi,bj) = 0. _d 0
          OBWw (j,k,bi,bj) = 0. _d 0
# ifdef ALLOW_OBCS_PRESCRIBE
          OBEw0(j,k,bi,bj) = 0. _d 0
          OBWw0(j,k,bi,bj) = 0. _d 0
          OBEw1(j,k,bi,bj) = 0. _d 0
          OBWw1(j,k,bi,bj) = 0. _d 0
# endif
         ENDDO
        ENDDO
#endif /* ALLOW_NONHYDROSTATIC */

#ifdef NONLIN_FRSURF
        DO i=1-OLx,sNx+OLx
          OBNeta (i,bi,bj) = 0. _d 0
          OBSeta (i,bi,bj) = 0. _d 0
# ifdef ALLOW_OBCS_PRESCRIBE
          OBNeta0(i,bi,bj) = 0. _d 0
          OBSeta0(i,bi,bj) = 0. _d 0
          OBNeta1(i,bi,bj) = 0. _d 0
          OBSeta1(i,bi,bj) = 0. _d 0
# endif
        ENDDO
        DO j=1-OLy,sNy+OLy
          OBEeta (j,bi,bj) = 0. _d 0
          OBWeta (j,bi,bj) = 0. _d 0
# ifdef ALLOW_OBCS_PRESCRIBE
          OBEeta0(j,bi,bj) = 0. _d 0
          OBWeta0(j,bi,bj) = 0. _d 0
          OBEeta1(j,bi,bj) = 0. _d 0
          OBWeta1(j,bi,bj) = 0. _d 0
# endif
        ENDDO
#endif /* NONLIN_FRSURF */

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#ifdef ALLOW_SEAICE
        DO i=1-OLx,sNx+OLx
#ifdef ALLOW_OBCS_NORTH
         OBNa (i,bi,bj)=0. _d 0
         OBNh (i,bi,bj)=0. _d 0
         OBNa0(i,bi,bj)=0. _d 0
         OBNh0(i,bi,bj)=0. _d 0
         OBNa1(i,bi,bj)=0. _d 0
         OBNh1(i,bi,bj)=0. _d 0
         OBNsl (i,bi,bj)=0. _d 0
         OBNsn (i,bi,bj)=0. _d 0
         OBNsl0(i,bi,bj)=0. _d 0
         OBNsn0(i,bi,bj)=0. _d 0
         OBNsl1(i,bi,bj)=0. _d 0
         OBNsn1(i,bi,bj)=0. _d 0
         OBNuice (i,bi,bj)=0. _d 0
         OBNvice (i,bi,bj)=0. _d 0
         OBNuice0(i,bi,bj)=0. _d 0
         OBNvice0(i,bi,bj)=0. _d 0
         OBNuice1(i,bi,bj)=0. _d 0
         OBNvice1(i,bi,bj)=0. _d 0
#endif /* ALLOW_OBCS_NORTH */
#ifdef ALLOW_OBCS_SOUTH
         OBSa (i,bi,bj)=0. _d 0
         OBSh (i,bi,bj)=0. _d 0
         OBSa0(i,bi,bj)=0. _d 0
         OBSh0(i,bi,bj)=0. _d 0
         OBSa1(i,bi,bj)=0. _d 0
         OBSh1(i,bi,bj)=0. _d 0
         OBSsl (i,bi,bj)=0. _d 0
         OBSsn (i,bi,bj)=0. _d 0
         OBSsl0(i,bi,bj)=0. _d 0
         OBSsn0(i,bi,bj)=0. _d 0
         OBSsl1(i,bi,bj)=0. _d 0
         OBSsn1(i,bi,bj)=0. _d 0
         OBSuice (i,bi,bj)=0. _d 0
         OBSvice (i,bi,bj)=0. _d 0
         OBSuice0(i,bi,bj)=0. _d 0
         OBSvice0(i,bi,bj)=0. _d 0
         OBSuice1(i,bi,bj)=0. _d 0
         OBSvice1(i,bi,bj)=0. _d 0
#endif /* ALLOW_OBCS_SOUTH */
        ENDDO
        DO j=1-OLy,sNy+OLy
#ifdef ALLOW_OBCS_EAST
         OBEa (j,bi,bj)=0. _d 0
         OBEh (j,bi,bj)=0. _d 0
         OBEa0(j,bi,bj)=0. _d 0
         OBEh0(j,bi,bj)=0. _d 0
         OBEa1(j,bi,bj)=0. _d 0
         OBEh1(j,bi,bj)=0. _d 0
         OBEsl (j,bi,bj)=0. _d 0
         OBEsn (j,bi,bj)=0. _d 0
         OBEsl0(j,bi,bj)=0. _d 0
         OBEsn0(j,bi,bj)=0. _d 0
         OBEsl1(j,bi,bj)=0. _d 0
         OBEsn1(j,bi,bj)=0. _d 0
         OBEuice (j,bi,bj)=0. _d 0
         OBEvice (j,bi,bj)=0. _d 0
         OBEuice0(j,bi,bj)=0. _d 0
         OBEvice0(j,bi,bj)=0. _d 0
         OBEuice1(j,bi,bj)=0. _d 0
         OBEvice1(j,bi,bj)=0. _d 0
#endif /* ALLOW_OBCS_EAST */
#ifdef ALLOW_OBCS_WEST
         OBWa (j,bi,bj)=0. _d 0
         OBWh (j,bi,bj)=0. _d 0
         OBWa0(j,bi,bj)=0. _d 0
         OBWh0(j,bi,bj)=0. _d 0
         OBWa1(j,bi,bj)=0. _d 0
         OBWh1(j,bi,bj)=0. _d 0
         OBWsl (j,bi,bj)=0. _d 0
         OBWsn (j,bi,bj)=0. _d 0
         OBWsl0(j,bi,bj)=0. _d 0
         OBWsn0(j,bi,bj)=0. _d 0
         OBWsl1(j,bi,bj)=0. _d 0
         OBWsn1(j,bi,bj)=0. _d 0
         OBWuice (j,bi,bj)=0. _d 0
         OBWvice (j,bi,bj)=0. _d 0
         OBWuice0(j,bi,bj)=0. _d 0
         OBWvice0(j,bi,bj)=0. _d 0
         OBWuice1(j,bi,bj)=0. _d 0
         OBWvice1(j,bi,bj)=0. _d 0
#endif /* ALLOW_OBCS_WEST */
        ENDDO
#endif /* ALLOW_SEAICE */

#ifdef ALLOW_PTRACERS
#ifndef ALLOW_AUTODIFF_TAMC
        IF ( usePTRACERS ) THEN
#endif
         DO iTracer=1,PTRACERS_numInUse
          DO k=1,Nr
           DO i=1-OLx,sNx+OLx
#ifdef ALLOW_OBCS_NORTH
            OBNptr (i,k,bi,bj,iTracer)=0. _d 0
# ifdef ALLOW_OBCS_PRESCRIBE
            OBNptr0(i,k,bi,bj,iTracer)=0. _d 0
            OBNptr1(i,k,bi,bj,iTracer)=0. _d 0
# endif
#endif /* ALLOW_OBCS_NORTH */

#ifdef ALLOW_OBCS_SOUTH
            OBSptr (i,k,bi,bj,iTracer)=0. _d 0
# ifdef ALLOW_OBCS_PRESCRIBE
            OBSptr0(i,k,bi,bj,iTracer)=0. _d 0
            OBSptr1(i,k,bi,bj,iTracer)=0. _d 0
# endif
#endif /* ALLOW_OBCS_SOUTH */
           ENDDO

           DO j=1-OLy,sNy+OLy
#ifdef ALLOW_OBCS_EAST
            OBEptr (j,k,bi,bj,iTracer)=0. _d 0
# ifdef ALLOW_OBCS_PRESCRIBE
            OBEptr0(j,k,bi,bj,iTracer)=0. _d 0
            OBEptr1(j,k,bi,bj,iTracer)=0. _d 0
# endif
#endif /* ALLOW_OBCS_EAST */

#ifdef ALLOW_OBCS_WEST
            OBWptr (j,k,bi,bj,iTracer)=0. _d 0
# ifdef ALLOW_OBCS_PRESCRIBE
            OBWptr0(j,k,bi,bj,iTracer)=0. _d 0
            OBWptr1(j,k,bi,bj,iTracer)=0. _d 0
# endif
#endif /* ALLOW_OBCS_WEST */
           ENDDO
          ENDDO
         ENDDO
#ifndef ALLOW_AUTODIFF_TAMC
        ENDIF
#endif
#endif /* ALLOW_PTRACERS */

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#ifdef ALLOW_ORLANSKI
        IF (useOrlanskiNorth.OR.useOrlanskiSouth.OR.
     &      useOrlanskiEast.OR.useOrlanskiWest) THEN
#ifdef ALLOW_DEBUG
          IF (debugMode) CALL DEBUG_CALL('ORLANSKI_INIT',myThid)
#endif
          CALL ORLANSKI_INIT(bi, bj, myThid)
        ENDIF
#endif /* ALLOW_ORLANSKI */

       ENDDO
      ENDDO

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C     Only needed for Orlanski or Stevens OB:
      IF ( nIter0.NE.0 .OR. pickupSuff.NE.' ' ) THEN
        CALL OBCS_READ_PICKUP( nIter0, myThid )
      ENDIF
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C--   Load/compute OBCS values (initial conditions only)
      IF ( nIter0.EQ.0 .AND. pickupSuff.EQ.' ' ) THEN
#ifdef ALLOW_DEBUG
       IF (debugMode) CALL DEBUG_CALL('OBCS_CALC',myThid)
#endif
#if ( defined ALLOW_AUTODIFF_TAMC && defined ALLOW_OBCS_STEVENS )
# ifdef ALLOW_OBCS_EAST
CADJ STORE OBEsStevens = tapelev_init, key = 1
CADJ STORE OBEtStevens = tapelev_init, key = 1
# endif
# ifdef ALLOW_OBCS_WEST
CADJ STORE OBWsStevens = tapelev_init, key = 1
CADJ STORE OBWtStevens = tapelev_init, key = 1
# endif
# ifdef ALLOW_OBCS_SOUTH
CADJ STORE OBSsStevens = tapelev_init, key = 1
CADJ STORE OBStStevens = tapelev_init, key = 1
# endif
# ifdef ALLOW_OBCS_NORTH
CADJ STORE OBNsStevens = tapelev_init, key = 1
CADJ STORE OBNtStevens = tapelev_init, key = 1
# endif
#endif
       CALL OBCS_CALC( startTime, nIter0,
     &              uVel, vVel, wVel, theta, salt, myThid )
C     S/R OBCS_CALC is split between computing the boundary conditions
C     and adjusting them to balance the flow (and apply tides)
       CALL OBCS_ADJUST( startTime, nIter0, myThid )

C--   Apply OBCS values to initial conditions for consistency
C      (but initial conditions only)
#ifdef ALLOW_DEBUG
       IF (debugMode)
     &    CALL DEBUG_CALL('OBCS_APPLY_UV + OBCS_APPLY_TS',myThid)
#endif
       DO bj = myByLo(myThid), myByHi(myThid)
        DO bi = myBxLo(myThid), myBxHi(myThid)
          CALL OBCS_APPLY_UV( bi, bj, 0, uVel, vVel, myThid )
          CALL OBCS_APPLY_TS( bi, bj, 0, theta, salt, myThid )
        ENDDO
       ENDDO
       IF (useOBCSprescribe) THEN
C     After applying the boundary conditions exchange the 3D-fields.
C     This is only necessary of the boundary values have been read
C     from a file.
#ifdef ALLOW_DEBUG
        IF (debugMode)
     &    CALL DEBUG_CALL('EXCHANGES in OBCS_INIT_VARIABLES',myThid)
#endif
        CALL EXCH_UV_XYZ_RL(uVel,vVel,.TRUE.,myThid)
        _EXCH_XYZ_RL( theta, myThid )
        _EXCH_XYZ_RL( salt , myThid )
       ENDIF
C     endif start from rest
#ifdef ALLOW_OBCS_PRESCRIBE
      ELSEIF ( useOBCSprescribe ) THEN
C-- Need this call (although loading U,V,T,S OB values is not really necessary)
C    a) OB values needed for etaH (NonLinFreeSurf) and for wVel (nonHydrostatic)
C    b) OB values needed for ptracers (in case nIter0 = PTRACERS_Iter0 <> 0)
C    c) with present implementation, only do initialisation when called
C       with myTime=startTime (S/R EXF_GETFFIELDREC, setting "first")
C       or with myIter=nIter0 (S/R OBCS_FIELDS_LOAD). And this cannot be changed
C       because of above call to OBCS_CALC(startTime,nIter0).
        CALL OBCS_PRESCRIBE_READ( startTime, nIter0, myThid )
#endif
      ENDIF
C--   calls to S/R OBCS_COPY_TRACER on theta & salt are no longer needed
C     with maskInC,W,S in pkg/generic_advdiff: removed

#ifdef ALLOW_PTRACERS
C     repeat everything for passive tracers
      IF ( usePTRACERS ) THEN
C     catch the case when we do start from a pickup for dynamics variables
C     but initialise ptracers differently
       IF ( nIter0.EQ.PTRACERS_Iter0 ) THEN
#ifdef ALLOW_DEBUG
        IF (debugMode) CALL DEBUG_CALL('OBCS_APPLY_PTRACER',myThid)
#endif
        DO iTracer=1,PTRACERS_numInUse
         DO bj = myByLo(myThid), myByHi(myThid)
          DO bi = myBxLo(myThid), myBxHi(myThid)
            CALL OBCS_APPLY_PTRACER(
     I           bi, bj, 0, iTracer,
     U           pTracer(1-OLx,1-OLy,1,bi,bj,iTracer),
     I           myThid )
          ENDDO
         ENDDO
        ENDDO
C     endif start from rest
       ENDIF
       IF ( nIter0.EQ.PTRACERS_Iter0 .AND. useOBCSprescribe ) THEN
C     After applying the boundary conditions exchange the 3D-fields.
C     This is only necessary of the boundary values have been read
C     from a file.
#ifdef ALLOW_DEBUG
         IF (debugMode) CALL DEBUG_CALL(
     &        'PTRACERS EXCHANGES in OBCS_INIT_VARIABLES',myThid)
#endif
         CALL PTRACERS_FIELDS_BLOCKING_EXCH( myThid )
c      ELSE
C--   Calls to S/R OBCS_COPY_TRACER on pTracers are no longer needed
C     with maskInC,W,S in pkg/generic_advdiff: removed
C-    This call was part of ptracers exchange S/R but was needed in all cases
       ENDIF
C     endif usePTRACERS
      ENDIF
#endif /* ALLOW_PTRACERS */

#endif /* ALLOW_OBCS */

#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_LEAVE('OBCS_INIT_VARIABLES',myThid)
#endif
      RETURN
      END

#include "BLING_OPTIONS.h"
#ifdef ALLOW_AUTODIFF
# include "AUTODIFF_OPTIONS.h"
#endif

CBOP
C !ROUTINE: BLING_LIGHT

C !INTERFACE: ==========================================================
      SUBROUTINE BLING_LIGHT(
     I           mld,
     U           irr_inst, irr_eff,
     I           bi, bj, iMin, iMax, jMin, jMax,
     I           myTime, myIter, myThid)

C !DESCRIPTION:
C     o calculate effective light for phytoplankton growth
C       There are multiple types of light.
C     - irr_inst is the instantaneous irradiance field.
C     - irr_mix is the same, but with the irr_inst averaged throughout
C       the mixed layer. This quantity is intended to represent the
C       light to which phytoplankton subject to turbulent transport in
C       the mixed-layer would be exposed.
C     - irr_eff is the effective irradiance for photosynthesis,
C       given either by irr_inst or irr_mix, depending on model
C       options and location.
C     o instantaneous light is calculated either from
C     - date and latitude, then exponentially attenuated down the
C       water column, or
C     - short-wave radiation read from external forcing file,
C       attenuated down the water column, or
C     - short-wave radiation distributed through the water column
C       according to SWFRAC routine

C !USES: ===============================================================
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "BLING_VARS.h"
#ifdef USE_QSW
# include "FFIELDS.h"
#endif
#ifdef ALLOW_AUTODIFF_TAMC
# include "tamc.h"
#endif

C !INPUT PARAMETERS: ===================================================
C     bi,bj         :: tile indices
C     iMin,iMax     :: computation domain: 1rst index range
C     jMin,jMax     :: computation domain: 2nd  index range
C     myTime        :: current time
C     myIter        :: current timestep
C     myThid        :: thread Id. number
      INTEGER bi, bj, iMin, iMax, jMin, jMax
      INTEGER myThid
      INTEGER myIter
      _RL     myTime
      _RL mld       (1-OLx:sNx+OLx,1-OLy:sNy+OLy)

C !OUTPUT PARAMETERS: ==================================================
C     irr_inst      :: instantaneous light
C     irr_eff       :: effective light for photosynthesis
      _RL irr_inst  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL irr_eff   (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)

C !LOCAL VARIABLES: ====================================================
      INTEGER i,j,k
      LOGICAL QSW_underice
#ifdef ALLOW_CAL
      INTEGER mydate(4)
#endif
      _RL localTime
      _RL utcTime, diffutc
      _RL sat_atten
      _RL sat_atten_sum(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL chl_sat_sum  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL atten
      _RL irr_surf  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
#ifdef ML_MEAN_LIGHT
      _RL irr_mix   (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL SumMLIrr  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL tmp_ML    (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
#endif
#ifndef USE_QSW
      _RL sfac      (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
#endif
#ifdef PHYTO_SELF_SHADING
      _RL k0_rd, chi_rd, e_rd
      _RL k0_bg, chi_bg, e_bg
      _RL kChl_rd   (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL kChl_bg   (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL atten_rd
      _RL atten_bg
      _RL irr_rd    (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL irr_bg    (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
#endif /* PHYTO_SELF_SHADING */
#ifdef ALLOW_AUTODIFF_TAMC
C     tkey :: tape key (tile dependent)
C     kkey :: tape key (tile and level dependent)
      INTEGER tkey, kkey
#endif
CEOP

C  Remove light under ice
C  If using Qsw and seaice/thsice, then ice fraction is already
C  taken into account
      QSW_underice = .FALSE.
#ifdef USE_QSW
      IF ( useSEAICE ) QSW_underice = .TRUE.
      IF ( useThSIce ) QSW_underice = .TRUE.
#endif

      DO j=1-OLy,sNy+OLy
       DO i=1-OLx,sNx+OLx
        chl_sat_sum(i,j)   = 0. _d 0
        sat_atten_sum(i,j) = 0. _d 0
#ifdef ML_MEAN_LIGHT
        SumMLIrr(i,j) = 0. _d 0
        tmp_ML(i,j)   = 0. _d 0
#endif
#ifndef USE_QSW
        sfac(i,j)     = 0. _d 0
#endif
       ENDDO
      ENDDO
      DO k=1,Nr
       DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
         irr_eff(i,j,k) = 0. _d 0
#ifdef PHYTO_SELF_SHADING
         irr_rd(i,j,k)        = 0. _d 0
         irr_bg(i,j,k)        = 0. _d 0
#endif
        ENDDO
       ENDDO
      ENDDO

#ifdef PHYTO_SELF_SHADING
C  Specify co-efficients for bio-optical model {kChl = k0 +chi[chl]^e}
C  in red and blue-green fractions (Morel 1988; Foujols et al. 2000)
      k0_rd  = 0.225 _d 0
      k0_bg  = 0.0232 _d 0
      chi_rd = 0.037 _d 0
      chi_bg = 0.074 _d 0
      e_rd   = 0.629 _d 0
      e_bg   = 0.674 _d 0
#endif

C ---------------------------------------------------------------------
C  instantaneous light, mixed layer averaged light

#ifdef USE_QSW
C  Convert insolation to photosynthetically-available radiations (PAR)
      DO j=jMin,jMax
       DO i=iMin,iMax
        irr_surf(i,j) = MAX( epsln,
     &                  -parfrac*Qsw(i,j,bi,bj)*maskInC(i,j,bi,bj))
       ENDDO
      ENDDO
#else
C  Find surface insolation (light) as function of date and latitude
      CALL GCHEM_INSOLATION(
     O     sfac,
     I     iMin, iMax, jMin, jMax, bi, bj,
     I     myTime, myIter, myThid)

C Photosynthetically active solar radiation (PAR) just below surface
      DO j=jMin,jMax
       DO i=iMin,iMax
        irr_surf(i,j) = MAX(1. _d -5,sfac(i,j)*parfrac)
       ENDDO
      ENDDO
#endif /* USE_QSW */

C  Remove light under ice
      IF ( .NOT. QSW_underice ) THEN
       DO j=jMin,jMax
        DO i=iMin,iMax
         irr_surf(i,j) = irr_surf(i,j)*(1. _d 0 - FIce(i,j,bi,bj))
        ENDDO
       ENDDO
      ENDIF

#ifdef ALLOW_AUTODIFF_TAMC
      tkey = bi + (bj - 1)*nSx + (ikey_dynamics - 1)*nSx*nSy
CADJ STORE irr_surf = comlev1_bibj, key=tkey, kind=isbyte
#endif /* ALLOW_AUTODIFF_TAMC */

      DO k=1,Nr

#ifdef ALLOW_AUTODIFF_TAMC
       kkey = k + (tkey-1)*Nr
# ifdef ML_MEAN_LIGHT
CADJ STORE tmp_ML = comlev1_bibj_k, key=kkey, kind=isbyte
# endif /* ML_MEAN_LIGHT */
#endif

C Top layer
       IF ( k.EQ.1) THEN

        DO j=jMin,jMax
         DO i=iMin,iMax

          IF ( maskC(i,j,k,bi,bj).EQ.oneRS ) THEN

#ifdef PHYTO_SELF_SHADING
C  Use bio-optical model of Manizza et al. (2005) to account for
C  effect of self-shading on ligt available for phytoplankton
C  growth. As written this DOES NOT feedback onto the absorption
C  of shortwave radiation calculated in the physical model, which
C  is instead calculated in the subroutine swfrac

C  Attenuation coefficient adjusted to chlorophyll in top layer
#ifdef ALLOW_AUTODIFF
           IF ( chl(i,j,1,bi,bj) .GT. 0. _d 0 ) THEN
#endif
            kChl_rd(i,j,1) = k0_rd + chi_rd*(chl(i,j,1,bi,bj)**e_rd)
            kChl_bg(i,j,1) = k0_bg + chi_bg*(chl(i,j,1,bi,bj)**e_bg)
#ifdef ALLOW_AUTODIFF
           ELSE
            kChl_rd(i,j,1) = k0_rd
            kChl_bg(i,j,1) = k0_bg
           ENDIF
#endif
C  Light attenuation in middle of top layer
           atten_rd = kChl_rd(i,j,1)*drF(1)/2. _d 0*hFacC(i,j,1,bi,bj)
           atten_bg = kChl_bg(i,j,1)*drF(1)/2. _d 0*hFacC(i,j,1,bi,bj)
C  Irradiance in middle of top layer
           irr_rd(i,j,1) = irr_surf(i,j) * exp(-atten_rd) * 0.5 _d 0
           irr_bg(i,j,1) = irr_surf(i,j) * exp(-atten_bg) * 0.5 _d 0
           irr_inst(i,j,1) = irr_rd(i,j,1) + irr_bg(i,j,1)
#else /* PHYTO_SELF_SHADING */
C SW radiation attenuated exponentially
C  Light attenuation in middle of top layer
           atten = k0_2d(i,j,bi,bj)*halfRL*drF(1)*hFacC(i,j,1,bi,bj)
           irr_inst(i,j,1) = irr_surf(i,j)*exp(-atten)

#endif /* PHYTO_SELF_SHADING */

          ENDIF
         ENDDO
        ENDDO

C k>1: below surface layer
       ELSE

#ifdef ALLOW_AUTODIFF_TAMC
# ifdef PHYTO_SELF_SHADING
CADJ STORE irr_bg(:,:,k-1) = comlev1_bibj_k, key=kkey, kind=isbyte
CADJ STORE irr_rd(:,:,k-1) = comlev1_bibj_k, key=kkey, kind=isbyte
# endif
#endif

        DO j=jMin,jMax
         DO i=iMin,iMax

          IF ( maskC(i,j,k,bi,bj).EQ.oneRS ) THEN

#ifdef PHYTO_SELF_SHADING
C  Attenuation coefficient adjusted to chlorophyll in kth layer
#ifdef ALLOW_AUTODIFF
           IF ( chl(i,j,k,bi,bj) .GT. 0. _d 0 ) THEN
#endif
            kChl_rd(i,j,k) = k0_rd + chi_rd*(chl(i,j,k,bi,bj)**e_rd)
            kChl_bg(i,j,k) = k0_bg + chi_bg*(chl(i,j,k,bi,bj)**e_bg)
#ifdef ALLOW_AUTODIFF
           ELSE
            kChl_rd(i,j,k) = k0_rd
            kChl_bg(i,j,k) = k0_bg
           ENDIF
#endif
C  Light attenuation from one more layer
           atten_rd = kChl_rd(i,j,k)*drF(k)/2. _d 0*hFacC(i,j,k,bi,bj)
     &        + kChl_rd(i,j,k-1)*drF(k-1)/2. _d 0*hFacC(i,j,k-1,bi,bj)
           atten_bg = kChl_bg(i,j,k)*drF(k)/2. _d 0*hFacC(i,j,k,bi,bj)
     &        + kChl_bg(i,j,k-1)*drF(k-1)/2. _d 0*hFacC(i,j,k-1,bi,bj)
C  Irradiance in middle of layer k
           irr_rd(i,j,k) = irr_rd(i,j,k-1)*exp(-atten_rd)
           irr_bg(i,j,k) = irr_bg(i,j,k-1)*exp(-atten_bg)
           irr_inst(i,j,k) = irr_rd(i,j,k) + irr_bg(i,j,k)

#else /* PHYTO_SELF_SHADING */
C SW radiation attenuated exponentially
C  Attenuation from one more layer
           atten = k0_2d(i,j,bi,bj)*halfRL*( drF(k)*hFacC(i,j,k,bi,bj)
     &                                 + drF(k-1)*hFacC(i,j,k-1,bi,bj) )
           irr_inst(i,j,k) = irr_inst(i,j,k-1)*exp(-atten)

#endif /* PHYTO_SELF_SHADING */

          ENDIF
         ENDDO
        ENDDO

       ENDIF /* if k=1 then, else */

C Satellite chl
       DO j=jMin,jMax
        DO i=iMin,iMax
         IF ( maskC(i,j,k,bi,bj).EQ.oneRS ) THEN

          IF ( irr_surf(i,j).GT.zeroRL ) THEN
c           sat_atten = irr_inst(i,j,k)/irr_surf(i,j)
#ifdef PHYTO_SELF_SHADING
           sat_atten = exp(-2. _d 0 * k0_bg * (-rC(k)))
#else
           sat_atten = exp(-2. _d 0 * k0_2d(i,j,bi,bj) * (-rC(k)))
#endif
           chl_sat_sum(i,j) = chl_sat_sum(i,j)
     &                 + chl(i,j,k,bi,bj)*sat_atten
           sat_atten_sum(i,j) = sat_atten_sum(i,j) + sat_atten
          ENDIF

#ifdef ML_MEAN_LIGHT
C  Mean irradiance in the mixed layer
          IF ( (-rF(k+1).LE. mld(i,j)) .AND.
     &         (-rF(k+1).LT.MLmix_max) ) THEN
           SumMLIrr(i,j) = SumMLIrr(i,j)+drF(k)*irr_inst(i,j,k)
           tmp_ML(i,j) = tmp_ML(i,j) + drF(k)
           irr_mix(i,j) = SumMLIrr(i,j)/tmp_ML(i,j)
          ENDIF
#endif

         ENDIF
        ENDDO
       ENDDO

C     end first k loop
      ENDDO

C Satellite chlorophyll

C get time (in h) within the day:
      utcTime = MOD( myTime/3600. _d 0, 24. _d 0 )
#ifdef ALLOW_CAL
C mydate is utc time
      IF ( useCAL ) THEN
       CALL CAL_GETDATE( myIter, myTime, mydate, myThid )
       i = mydate(2)/10000
       j = mydate(2)/100
       j = MOD(j,100)
       k = MOD(mydate(2),100)
       utcTime = i + j/60. _d 0 + k/3600. _d 0
      ENDIF
#endif
C Update diagnostic only if ~13:30 local time, when satellite observes
      DO j=jMin,jMax
       DO i=iMin,iMax
        IF ( usingSphericalPolarGrid .OR. usingCurvilinearGrid ) THEN
C       local-time difference (in h) from UTC time (note: 15 = 360/24)
         diffutc = XC(i,j,bi,bj)/15. _d 0
        ELSE
C       for other grid (e.g., cartesian), assumes no difference in time
         diffutc = 0. _d 0
        ENDIF
        localTime = utcTime + diffutc + 24. _d 0
        localTime = MOD( localTime, 24. _d 0 )
        IF ( localTime.GT.chlsat_locTimWindow(1) .AND.
     &       localTime.LT.chlsat_locTimWindow(2) ) THEN
         chl_sat(i,j,bi,bj) = chl_sat_sum(i,j)
     &                      / (sat_atten_sum(i,j) + epsln)
        ENDIF
       ENDDO
      ENDDO

      DO k=1,Nr
       DO j=jMin,jMax
        DO i=iMin,iMax
         IF ( maskC(i,j,k,bi,bj).EQ.oneRS ) THEN

          irr_eff(i,j,k) = irr_inst(i,j,k)
#ifdef ML_MEAN_LIGHT
C  Inside mixed layer, effective light is set to mean mixed layer light
          IF ( (-rF(k+1).LE. mld(i,j)) .AND.
     &         (-rF(k+1).LT.MLmix_max) ) THEN
           irr_eff(i,j,k) = irr_mix(i,j)
          ENDIF
#endif

         ENDIF
        ENDDO
       ENDDO
      ENDDO

#ifdef ALLOW_DIAGNOSTICS
      IF ( useDiagnostics ) THEN
       CALL DIAGNOSTICS_FILL(chl_sat,'BLGCHLSA',0,1,1,bi,bj,myThid)
      ENDIF
#endif /* ALLOW_DIAGNOSTICS */

      RETURN
      END

#include "SALT_PLUME_OPTIONS.h"

CBOP
C     !ROUTINE: SALT_PLUME_APPLY
C     !INTERFACE:
      SUBROUTINE SALT_PLUME_APPLY(
     I            trIdentity, bi, bj,
     I            recip_hFac_arg,
     I            tracer,trApplyFlag,
     I            myTime, myIter, myThid )

C     U            trStar,

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE SALT_PLUME_APPLY
C     | o Apply the salt_pume-transport to tracer field
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "GRID.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "DYNVARS.h"
#include "SALT_PLUME.h"
#ifdef ALLOW_GENERIC_ADVDIFF
# include "GAD.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
C     trIdentity :: tracer identification number
C     bi,bj      :: Tile indices
C     recip_drF  :: Reciprol of cell thickness
C     recip_hFac_arg :: Reciprol of cell open-depth factor
C     tracer     :: tracer field at current time (input)
C     trApplyFlag:: [0]=update saltplume forcing T/S terms
C                :: [1]=update gTr tendency
C     trStar     :: future tracer field (modified)
C     myTime     :: Current time in simulation
C     myIter     :: Current time-step number
C     myThid     :: my Thread Id. number

      INTEGER trIdentity, trApplyFlag
      INTEGER bi, bj
      _RS recip_hFac_arg(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL tracer        (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
C      _RL trStar        (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)

      _RL     myTime
      INTEGER myIter, myThid

#ifdef ALLOW_SALT_PLUME
#ifdef SALT_PLUME_VOLUME

C     !LOCAL VARIABLES:
C     === Local variables ===
C     msgBuf     :: Informational/error message buffer
C     plumetend  :: forcing terms [W/m2 or g/m2/s]
C     work       :: working array
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      INTEGER i, j, k
      INTEGER upward
      LOGICAL onOffFlag
      _RL gTr_Surf2kLev, gTr_Below2kLev, gTr_kLev2Above,
     &    dSPvolBelow2kLev, gTr_totSurf2Below,
     &    SurfVal, SEAICE_Tfrz, ConvertFac, recip_ConvertFac
      integer kp1, Nrp1
      _RL         plumetend(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL         work(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr+1)

#ifdef ALLOW_DIAGNOSTICS
      CHARACTER*8 diagName
      CHARACTER*4 diagSufx
      LOGICAL     doDiagSPtend
C-    Functions:
      LOGICAL  DIAGNOSTICS_IS_ON
      EXTERNAL DIAGNOSTICS_IS_ON
#ifdef ALLOW_GENERIC_ADVDIFF
      CHARACTER*5 GAD_DIAG_SUFX
      EXTERNAL    GAD_DIAG_SUFX
#endif /* ALLOW_GENERIC_ADVDIFF */
#endif /* ALLOW_DIAGNOSTICS */

CEOP

C      WRITE(msgBuf,'(A,2i4)') 'trApplyFlag,trIdentity: ',
C     & trApplyFlag,trIdentity
C         CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
C     &                      SQUEEZE_RIGHT, myThid )

      IF ( trApplyFlag.LT.0 .OR. trApplyFlag.GT.1) THEN
       STOP 'S/R SALT_PLUME_APPLY: incorrect setting of trApplyFlag!'
      ELSE

       SEAICE_Tfrz = -1.96 _d 0

       onOffFlag = .FALSE.
#ifdef ALLOW_GENERIC_ADVDIFF
       IF ( trIdentity.EQ.GAD_TEMPERATURE ) onOffFlag = .TRUE.
       IF ( trIdentity.EQ.GAD_SALINITY    ) onOffFlag = .TRUE.
#endif
       IF ( onOffFlag ) THEN
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

c       upward = rkSign*NINT(-gravitySign)
        upward = 1
        IF (usingZCoords) upward = -1

        IF ( trIdentity.EQ.GAD_TEMPERATURE ) THEN
         SurfVal          = SEAICE_Tfrz
         ConvertFac       = HeatCapacity_Cp*rhoConst
         recip_ConvertFac = mass2rUnit/HeatCapacity_Cp
#ifdef ALLOW_DIAGNOSTICS
         IF ( useDiagnostics ) diagSufx = '_TH '
#endif /* ALLOW_DIAGNOSTICS */
        ENDIF
        IF ( trIdentity.EQ.GAD_SALINITY ) THEN
         SurfVal          = SPbrineSconst
         ConvertFac       = rhoConst
         recip_ConvertFac = mass2rUnit
#ifdef ALLOW_DIAGNOSTICS
         IF ( useDiagnostics ) diagSufx = '_SLT'
#endif /* ALLOW_DIAGNOSTICS */
        ENDIF

#ifdef ALLOW_DIAGNOSTICS
        doDiagSPtend = .FALSE.
        diagName = 'SPtd'
        IF ( useDiagnostics ) THEN
C--   Set diagnostic suffix for the current tracer
#ifdef ALLOW_GENERIC_ADVDIFF
         diagSufx = GAD_DIAG_SUFX( trIdentity, myThid )
#endif /* ALLOW_GENERIC_ADVDIFF */
         diagName = 'SPtd'//diagSufx
         doDiagSPtend = DIAGNOSTICS_IS_ON(diagName,myThid)
        ENDIF
#endif /* ALLOW_DIAGNOSTICS */

C-- initializing:
        Nrp1=Nr+1
        DO k=1,Nr
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           plumetend(i,j,k) = 0. _d 0
           work(i,j,k) = tracer(i,j,k,bi,bj)
          ENDDO
         ENDDO
        ENDDO
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
           work(i,j,Nrp1) = 0. _d 0
         ENDDO
        ENDDO
C-----------------

Catn: After discussion with JM, it is cleaner to remove the negative
c     buoyancy associated with saltplumeflux from the surface lev
c     here instead of inside salt_plume_forcing_surf.F and
c     kpp_forcing_surf.F:

        IF(trApplyFlag.LT.1) THEN
C ======= if trApplyFlag==0: calc SPforcing[T,S] =================
         IF(trIdentity.EQ.GAD_TEMPERATURE) THEN
          DO k=1,Nr
           DO j=1-OLy,sNy+OLy
            DO i=1-OLx,sNx+OLx
             SPforcingT(i,j,k,bi,bj)=0. _d 0
            ENDDO
           ENDDO
          ENDDO
         ENDIF
         IF(trIdentity.EQ.GAD_SALINITY) THEN
          DO k=1,Nr
           DO j=1-OLy,sNy+OLy
            DO i=1-OLx,sNx+OLx
             SPforcingS(i,j,k,bi,bj)=0. _d 0
            ENDDO
           ENDDO
          ENDDO
         ENDIF

         DO k=Nr,1,-1
          kp1=k+1
          DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
C           IF(trIdentity.EQ.GAD_SALINITY) SurfVal=SPbrineSalt(i,j,bi,bj)
           IF(trIdentity.EQ.GAD_TEMPERATURE) SurfVal=tracer(i,j,1,bi,bj)
Catn: m/s*[degC,g/kg]
            gTr_totSurf2Below = SPbrineVolFlux(i,j,bi,bj)*SurfVal
            gTr_Surf2kLev = dSPvolSurf2kLev(i,j,k,bi,bj) * SurfVal
            dSPvolBelow2kLev = -dSPvolkLev2Above(i,j,kp1,bi,bj)
            gTr_Below2kLev= dSPvolBelow2kLev * work(i,j,kp1)
Catn: gTr_kLev2Above works even for kLev=1 because this is how much
C volume of original [salinity,heat] associated with [SSS,SST]
C was replaced by same volume of brine [salt,heat(from SEAICE_Tfrz)].
C Note: by design, dSPvolkLev2Above already is negative
            gTr_kLev2Above= dSPvolkLev2Above(i,j,k,bi,bj) * work(i,j,k)

C salt: [m/s * g/m3] = [g/s/m2] = unit of saltPlumeFlux
C theta:[m/s * kg/m3 * J/kg/degC * degC] = [W/m2]
            plumetend(i,j,k) = ConvertFac *
     &          ( gTr_Surf2kLev + gTr_Below2kLev + gTr_kLev2Above )
            IF(k.eq.1) plumetend(i,j,k) = ConvertFac *
     &          ( gTr_Surf2kLev + gTr_Below2kLev)
C remove negative buoyancy from surface,
C used to be in salt_plume_forcing_surf.F
C           IF(k.EQ.1) THEN
C            plumetend(i,j,k) = plumetend(i,j,k)
C     &                         - ConvertFac*gTr_totSurf2Below
C           ENDIF

Catn: report T/S SPforcing[T,S] related to saltplumeflux for kpp
C     and return zero to do_oceanic_phys.F; unit: [g/m2/s or W/m2]
C            trStar(i,j,k,bi,bj) = 0. _d 0
            IF (trIdentity.EQ.GAD_SALINITY) THEN
             SPforcingS(i,j,k,bi,bj)=plumetend(i,j,k)
            ENDIF
            IF (trIdentity.EQ.GAD_TEMPERATURE) THEN
             SPforcingT(i,j,k,bi,bj)=plumetend(i,j,k)
            ENDIF
           ENDDO
          ENDDO
         ENDDO
#ifdef ALLOW_DIAGNOSTICS
        IF ( doDiagSPtend )
     &   CALL DIAGNOSTICS_FILL(plumetend, diagName, 0,Nr,2,bi,bj,myThid)
#endif /* ALLOW_DIAGNOSTICS */

        ELSE
C ============ updating gTr =====================================
Catn: updating tendency gTr (gS,gT); unit: [g/kg/s or degC/s]
C         WRITE(msgBuf,'(a,2e24.17)') 'b4SPap: [Tr,gTr](1,1,1,bi,bj):',
C     &     tracer(1,1,1,bi,bj),trStar(1,1,1,bi,bj)
C         CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
C     &                      SQUEEZE_RIGHT, myThid )
         DO k=Nr,1,-1
          kp1=k+1
          DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
            IF (trIdentity.EQ.GAD_TEMPERATURE)
     &       plumetend(i,j,k)=SPforcingT(i,j,k,bi,bj)
            IF (trIdentity.EQ.GAD_SALINITY) THEN
             plumetend(i,j,k)=SPforcingS(i,j,k,bi,bj)
            ENDIF

C            trStar(i,j,k,bi,bj)=trStar(i,j,k,bi,bj)+plumetend(i,j,k)
C     &      *recip_drF(k)*recip_hFac_arg(i,j,k)
C     &      *recip_ConvertFac
           ENDDO
          ENDDO
         ENDDO

        ENDIF

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C--    end if on-off-flag
       ENDIF
C--   end trApplyFlag
      ENDIF

#endif /* SALT_PLUME_VOLUME */
#endif /* ALLOW_SALT_PLUME */

      RETURN
      END

#include "GRIDALT_OPTIONS.h"

      subroutine phys2dyn(qphy,pephy,im1,im2,jm1,jm2,lmphy,Nsx,Nsy,
     .     idim1,idim2,jdim1,jdim2,bi,bj,pedyn,Lbot,lmdyn,nlperdyn,qdyn)
C***********************************************************************
C Purpose:
C   To interpolate an arbitrary quantity from the 'dynamics' eta (pstar)
C               grid to the higher resolution physics grid
C Algorithm:
C   Routine works one layer (edge to edge pressure) at a time.
C   Physics -> Dynamics computes the physics layer mean value,
C   weighted by dp**kappa (interp1) or by dp.
C
C Input:
C   qphy..... [im,jm,lmphy] Arbitrary Quantity on Input Grid
C   pephy.... [im,jm,lmphy+1] Pressures at bottom edges of input levels
C   im1,2 ... Limits for Longitude Dimension of Input
C   jm1,2 ... Limits for Latitude  Dimension of Input
C   lmphy.... Vertical  Dimension of Input
C   Nsx...... Number of processes in x-direction
C   Nsy...... Number of processes in y-direction
C   idim1,2.. Beginning and ending i-values to calculate
C   jdim1,2.. Beginning and ending j-values to calculate
C   bi....... Index of process number in x-direction
C   bj....... Index of process number in x-direction
C   pedyn.... [im,jm,lmdyn+1] Pressures at bottom edges of output levels
C   lmdyn.... Vertical  Dimension of Output
C   nlperdyn. Mapping Array-Highest Physics level in each dynmics level
C
C Output:
C   qdyn..... [im,jm,lmdyn] Quantity at output grid (physics grid)
C
C Notes:
C   1) This algorithm assumes that the output (physics) grid levels
C      fit exactly into the input (dynamics) grid levels
C***********************************************************************
      implicit none

      integer  im1, im2, jm1, jm2, lmdyn, lmphy, Nsx, Nsy
      integer idim1, idim2, jdim1, jdim2, bi, bj
      _RL qphy(im1:im2,jm1:jm2,lmphy,Nsx,Nsy)
      _RL pedyn(im1:im2,jm1:jm2,lmdyn+1,Nsx,Nsy)
      _RL pephy(im1:im2,jm1:jm2,lmphy+1,Nsx,Nsy)
      integer nlperdyn(im1:im2,jm1:jm2,lmdyn,Nsx,Nsy)
      _RL qdyn(im1:im2,jm1:jm2,lmdyn,Nsx,Nsy)
      integer Lbot(im1:im2,jm1:jm2,Nsx,Nsy)

      integer  i,j,L,Lout1,Lout1p1,Lout2,Lphy
      _RL dpkephy, dpkedyn, sum

cinterp1  _RL kappa
#ifdef ALLOW_FIZHI
cinterp1  _RL getcon
#else
cinterp1 #include 'SIZE.h'
cinterp1 #include 'EEPARAMS.h'
cinterp1 #include 'PARAMS.h'
#endif

#ifdef ALLOW_FIZHI
cinterp1  kappa = getcon('KAPPA')
#else
cinterp1  kappa = atm_kappa
#endif

c do loop for all dynamics (output) levels
      do L = 1,lmdyn
c do loop for all grid points
       do j = jdim1,jdim2
        do i = idim1,idim2
         qdyn(i,j,L,bi,bj) = 0.
c Check to make sure we are above ground - otherwise do nothing
         if(L.ge.Lbot(i,j,bi,bj))then
          if(L.eq.Lbot(i,j,bi,bj)) then
           Lout1 = 0
          else
           Lout1 = nlperdyn(i,j,L-1,bi,bj)
          endif
          Lout2 = nlperdyn(i,j,L,bi,bj)
c do loop for all physics levels contained in this dynamics level
cinterp1  dpkedyn = (pedyn(i,j,L,bi,bj)**kappa)-
cinterp1                                   (pedyn(i,j,L+1,bi,bj)**kappa)
          dpkedyn = pedyn(i,j,L,bi,bj)-pedyn(i,j,L+1,bi,bj)
          sum = 0.
          Lout1p1 = Lout1+1
          do Lphy = Lout1p1,Lout2
cinterp1   dpkephy = (pephy(i,j,Lphy,bi,bj)**kappa)-
cinterp1                                (pephy(i,j,Lphy+1,bi,bj)**kappa)
           dpkephy = pephy(i,j,Lphy,bi,bj)-pephy(i,j,Lphy+1,bi,bj)
           sum=sum+qphy(i,j,Lphy,bi,bj)*(dpkephy/dpkedyn)
          enddo
          qdyn(i,j,L,bi,bj) = sum
         endif
        enddo
       enddo
      enddo

      return
      end

#include "GAD_OPTIONS.h"

CBOP
C !ROUTINE: GAD_DST2U1_ADV_X

C !INTERFACE: ==========================================================
      SUBROUTINE GAD_DST2U1_ADV_X(
     I           bi,bj,k, advectionScheme, calcCFL,
     I           deltaTloc, uTrans, uFld,
     I           tracer,
     O           uT,
     I           myThid )

C !DESCRIPTION:
C  Calculates the area integrated zonal flux due to advection
C  of a tracer using second-order Direct Space and Time (DST-2)
C  interpolation (=Lax-Wendroff) or simple 1rst order upwind scheme.

C !USES: ===============================================================
      IMPLICIT NONE
#include "SIZE.h"
#include "GRID.h"
#include "GAD.h"

C !INPUT PARAMETERS: ===================================================
C  bi,bj             :: tile indices
C  k                 :: vertical level
C  advectionScheme   :: advection scheme to use: either 2nd Order DST
C                                                or 1rst Order Upwind
C  calcCFL           :: =T: calculate CFL number ; =F: take uFld as CFL
C  deltaTloc         :: local time-step (s)
C  uTrans            :: zonal volume transport
C  uFld              :: zonal flow / CFL number
C  tracer            :: tracer field
C  myThid            :: thread number
      INTEGER bi,bj,k
      INTEGER advectionScheme
      LOGICAL calcCFL
      _RL deltaTloc
      _RL uTrans(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL uFld  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL tracer(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER myThid

C !OUTPUT PARAMETERS: ==================================================
C  uT                :: zonal advective flux
      _RL uT    (1-OLx:sNx+OLx,1-OLy:sNy+OLy)

C !LOCAL VARIABLES: ====================================================
C  i,j               :: loop indices
C  rLimit            :: centered (vs upwind) fraction
C  uCFL              :: Courant-Friedrich-Levy number
      INTEGER i,j
      _RL uCFL, xLimit, uAbs
CEOP

      xLimit = 0. _d 0
      IF ( advectionScheme.EQ.ENUM_DST2 ) xLimit = 1. _d 0

      DO j=1-Oly,sNy+Oly
       uT(1-Olx,j)=0.
      ENDDO
      DO j=1-Oly,sNy+Oly
       DO i=1-Olx+1,sNx+Olx

        uCFL = uFld(i,j)
        IF ( calcCFL ) uCFL = ABS( uFld(i,j)*deltaTloc
     &                  *recip_dxC(i,j,bi,bj)*recip_deepFacC(k) )

c       uT(i,j) =
c    &     uTrans(i,j)*(tracer(i-1,j)+tracer(i,j))*0.5 _d 0
c    &   + ( 1. _d 0 - xLimit*(1. _d 0 - uCFL) )*ABS(uTrans(i,j))
c    &                *(tracer(i-1,j)-tracer(i,j))*0.5 _d 0
C-- above formulation produces large truncation error when:
C    1rst.O upWind and   u > 0 & |tracer(i-1,j)| << |tracer(i,j)|
C                   or   u < 0 & |tracer(i-1,j)| >> |tracer(i,j)|
C-- change to a more robust expression:
        uAbs = ABS(uTrans(i,j))
     &       *( 1. _d 0 - xLimit*(1. _d 0 - uCFL) )
        uT(i,j) = ( uTrans(i,j)+uAbs )* 0.5 _d 0 * tracer(i-1,j)
     &          + ( uTrans(i,j)-uAbs )* 0.5 _d 0 * tracer(i,j)
       ENDDO
      ENDDO

      RETURN
      END

#include "PACKAGES_CONFIG.h"
#include "CPP_OPTIONS.h"

CBOP
C     !ROUTINE: INI_PRESSURE
C     !INTERFACE:
      SUBROUTINE INI_PRESSURE( myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE INI_PRESSURE
C     | o initialise the pressure field consistently with
C     |   temperature and salinity
C     |   - needs to be called after ini_theta, ini_salt, and
C     |     ini_psurf
C     |   - does not include surface pressure loading, because
C     |     that is only available until after
C     |     CALL packages_init_variables
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "EOS.h"
#include "GRID.h"
#include "DYNVARS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     myThid     :: my Thread Id number
      INTEGER myThid

C     !LOCAL VARIABLES:
C     dPhiHydX,Y :: Gradient (X & Y directions) of Hyd. Potential
C     bi,bj      :: tile indices
C     i,j,k      :: Loop counters
      INTEGER bi, bj
      INTEGER  i,  j, k
#ifndef ALLOW_AUTODIFF
      INTEGER  iMin, iMax, jMin, jMax, npiter
      _RL PhiHydF (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL PhiHydC (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL dPhiHydX(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL dPhiHydY(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL oldPhi  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL count, rmspp, rmsppold
      _RL sumTile, rmsTile
#endif

      CHARACTER*(MAX_LEN_MBUF) msgBuf
CEOP

      _BEGIN_MASTER( myThid )
      WRITE(msgBuf,'(a)')
     &     'Start initial hydrostatic pressure computation'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      _END_MASTER( myThid )

      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
        DO k = 1,Nr
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           totPhiHyd(i,j,k,bi,bj) = 0. _d 0
          ENDDO
         ENDDO
        ENDDO
       ENDDO
      ENDDO

      IF ( storePhiHyd4Phys ) THEN

#ifndef ALLOW_AUTODIFF
cph-- deal with this iterative loop for AD once it will
cph-- really be needed;
cph-- would need storing of totPhiHyd for each npiter

       iMin = 1-OLx
       iMax = sNx+OLx
       jMin = 1-OLy
       jMax = sNy+OLy

       rmspp    = 1. _d 0
       rmsppold = 0. _d 0
       npiter = 0

C     iterate pressure p = integral of (g*rho(p)*dz)
       DO npiter= 1, 15
        IF ( rmspp.GT.zeroRL ) THEN
         rmsppold = rmspp
         rmspp    = 0. _d 0
         count    = 0. _d 0
         DO bj = myByLo(myThid), myByHi(myThid)
          DO bi = myBxLo(myThid), myBxHi(myThid)
           rmsTile = 0. _d 0
           sumTile = 0. _d 0
           DO j=1-OLy,sNy+OLy
            DO i=1-OLx,sNx+OLx
              phiHydF(i,j) = 0. _d 0
            ENDDO
           ENDDO
           DO k = 1, Nr
C     for each level save old pressure and compute new pressure
            DO j=jMin,jMax
             DO i=iMin,iMax
              oldPhi(i,j) = totPhiHyd(i,j,k,bi,bj)
             ENDDO
            ENDDO
            CALL CALC_PHI_HYD(
     I           bi, bj, iMin, iMax, jMin, jMax, k,
     U           phiHydF,
     O           phiHydC, dPhiHydX, dPhiHydY,
     I           startTime, -1, myThid )
C     compute convergence criterion
            DO j=1,sNy
             DO i=1,sNx
              rmsTile = rmsTile
     &            + (totPhiHyd(i,j,k,bi,bj)-oldPhi(i,j))**2
     &             * maskC(i,j,k,bi,bj)
              sumTile = sumTile + maskC(i,j,k,bi,bj)
             ENDDO
            ENDDO
C --      end k loop
           ENDDO
           rmspp = rmspp + rmsTile
           count = count + sumTile
          ENDDO
         ENDDO
Cml        WRITE(msgBuf,'(I10.10)') npiter
Cml        CALL WRITE_FLD_XYZ_RL( 'POLD.',msgBuf,pold,npiter,myThid)
Cml        CALL WRITE_FLD_XYZ_RL( 'PINI.',msgBuf,pressure,npiter,myThid)
         _GLOBAL_SUM_RL( rmspp, myThid )
         _GLOBAL_SUM_RL( count, myThid )
         IF ( count .EQ. 0. ) THEN
           rmspp = 0. _d 0
         ELSE
           rmspp = SQRT(rmspp/count)
         ENDIF
         _BEGIN_MASTER( myThid )
         WRITE(msgBuf,'(A,I4,A,1PE20.12)')
     &        'Iteration', npiter, ', RMS-difference =', rmspp
         CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                       SQUEEZE_RIGHT, myThid )
         _END_MASTER( myThid )

        ENDIF
C --   end npiter loop
       ENDDO

C     print some diagnostics
       _BEGIN_MASTER( myThid )
       IF ( rmspp .NE. 0. ) THEN
        IF ( rmspp .EQ. rmsppold ) THEN
         WRITE(msgBuf,'(A)')
     &      'Initial hydrostatic pressure did not converge perfectly,'
         CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                       SQUEEZE_RIGHT, myThid )
         WRITE(msgBuf,'(A)')
     &      'but the RMS-difference is constant, indicating that the'
         CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                       SQUEEZE_RIGHT, myThid )
         WRITE(msgBuf,'(A)')
     &      'algorithm converged within machine precision.'
         CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                       SQUEEZE_RIGHT, myThid )
        ELSE
         WRITE(msgBuf,'(A,I2,A)')
     &       'Initial hydrostatic pressure did not converge after ',
     &          npiter-1, ' steps'
         CALL PRINT_ERROR( msgBuf, myThid )
         STOP 'ABNORMAL END: S/R INI_PRESSURE'
        ENDIF
       ENDIF
       WRITE(msgBuf,'(A)')
     &     'Initial hydrostatic pressure converged.'
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                     SQUEEZE_RIGHT, myThid )
       _END_MASTER( myThid )

#endif /* ALLOW_AUTODIFF */

c-- else of if storePhiHyd4Phys
      ELSE
C     print a message and DO nothing
       _BEGIN_MASTER( myThid )
       WRITE(msgBuf,'(A,A)')
     &        'Pressure is predetermined for buoyancyRelation ',
     &        buoyancyRelation(1:11)
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                     SQUEEZE_RIGHT, myThid )
       _END_MASTER( myThid )

      ENDIF

      _BEGIN_MASTER( myThid )
      WRITE(msgBuf,'(A)') ' '
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      _END_MASTER( myThid )

      RETURN
      END

#include "CPP_EEOPTIONS.h"

C--  File exch2_rs_rl_12_d.F: Tapenade Tangent Linear EXCH2 routines
C--   Contents
C--   o  EXCH2_RS1_CUBE_D(
C--   o  EXCH2_RL1_CUBE_D(
C--   o  EXCH2_RS2_CUBE_D(
C--   o  EXCH2_RL2_CUBE_D(

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      SUBROUTINE EXCH2_RS1_CUBE_D(
     U            array, arrayd,
     I            signOption, fieldCode,
     I            myOLw, myOLe, myOLs, myOLn, myNz,
     I            exchWidthX, exchWidthY,
     I            cornerMode, myThid )
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "EESUPPORT.h"
#include "W2_EXCH2_SIZE.h"
#include "W2_EXCH2_TOPOLOGY.h"
#include "W2_EXCH2_BUFFER.h"

      INTEGER myOLw, myOLe, myOLs, myOLn, myNz
      _RS array(1-myOLw:sNx+myOLe,
     &           1-myOLs:sNy+myOLn,
     &           myNz, nSx, nSy)
      _RS arrayd(1-myOLw:sNx+myOLe,
     &           1-myOLs:sNy+myOLn,
     &           myNz, nSx, nSy)
      LOGICAL signOption
      CHARACTER*2 fieldCode
      INTEGER exchWidthX
      INTEGER exchWidthY
      INTEGER cornerMode
      INTEGER myThid

      CALL EXCH2_RS1_CUBE(
     U            array,
     I            signOption, fieldCode,
     I            myOLw, myOLe, myOLs, myOLn, myNz,
     I            exchWidthX, exchWidthY,
     I            cornerMode, myThid )
      CALL EXCH2_RS1_CUBE(
     U            arrayd,
     I            signOption, fieldCode,
     I            myOLw, myOLe, myOLs, myOLn, myNz,
     I            exchWidthX, exchWidthY,
     I            cornerMode, myThid )
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      SUBROUTINE EXCH2_RL1_CUBE_D(
     U            array, arrayd,
     I            signOption, fieldCode,
     I            myOLw, myOLe, myOLs, myOLn, myNz,
     I            exchWidthX, exchWidthY,
     I            cornerMode, myThid )
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "EESUPPORT.h"
#include "W2_EXCH2_SIZE.h"
#include "W2_EXCH2_TOPOLOGY.h"
#include "W2_EXCH2_BUFFER.h"

      INTEGER myOLw, myOLe, myOLs, myOLn, myNz
      _RL array(1-myOLw:sNx+myOLe,
     &           1-myOLs:sNy+myOLn,
     &           myNz, nSx, nSy)
      _RL arrayd(1-myOLw:sNx+myOLe,
     &           1-myOLs:sNy+myOLn,
     &           myNz, nSx, nSy)
      LOGICAL signOption
      CHARACTER*2 fieldCode
      INTEGER exchWidthX
      INTEGER exchWidthY
      INTEGER cornerMode
      INTEGER myThid

      CALL EXCH2_RL1_CUBE(
     U            array,
     I            signOption, fieldCode,
     I            myOLw, myOLe, myOLs, myOLn, myNz,
     I            exchWidthX, exchWidthY,
     I            cornerMode, myThid )
      CALL EXCH2_RL1_CUBE(
     U            arrayd,
     I            signOption, fieldCode,
     I            myOLw, myOLe, myOLs, myOLn, myNz,
     I            exchWidthX, exchWidthY,
     I            cornerMode, myThid )

      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      SUBROUTINE EXCH2_RS2_CUBE_D(
     U            array1, array1d,
     U            array2, array2d,
     I            signOption, fieldCode,
     I            myOLw, myOLe, myOLs, myOLn, myNz,
     I            exchWidthX, exchWidthY,
     I            cornerMode, myThid )
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "EESUPPORT.h"
#include "W2_EXCH2_SIZE.h"
#include "W2_EXCH2_TOPOLOGY.h"
#include "W2_EXCH2_BUFFER.h"
      INTEGER myOLw, myOLe, myOLs, myOLn, myNz
      _RS array1(1-myOLw:sNx+myOLe,
     &           1-myOLs:sNy+myOLn,
     &           myNz, nSx, nSy)
      _RS array1d(1-myOLw:sNx+myOLe,
     &           1-myOLs:sNy+myOLn,
     &           myNz, nSx, nSy)
      _RS array2(1-myOLw:sNx+myOLe,
     &           1-myOLs:sNy+myOLn,
     &           myNz, nSx, nSy)
      _RS array2d(1-myOLw:sNx+myOLe,
     &           1-myOLs:sNy+myOLn,
     &           myNz, nSx, nSy)

      LOGICAL signOption
      CHARACTER*2 fieldCode
      INTEGER exchWidthX
      INTEGER exchWidthY
      INTEGER cornerMode
      INTEGER myThid

      CALL EXCH2_RS2_CUBE(
     U            array1, array2,
     I            signOption, fieldCode,
     I            myOLw, myOLe, myOLs, myOLn, myNz,
     I            exchWidthX, exchWidthY,
     I            cornerMode, myThid )

      CALL EXCH2_RS2_CUBE(
     U            array1d, array2d,
     I            signOption, fieldCode,
     I            myOLw, myOLe, myOLs, myOLn, myNz,
     I            exchWidthX, exchWidthY,
     I            cornerMode, myThid )

      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      SUBROUTINE EXCH2_RL2_CUBE_D(
     U            array1, array1d,
     U            array2, array2d,
     I            signOption, fieldCode,
     I            myOLw, myOLe, myOLs, myOLn, myNz,
     I            exchWidthX, exchWidthY,
     I            cornerMode, myThid )
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "EESUPPORT.h"
#include "W2_EXCH2_SIZE.h"
#include "W2_EXCH2_TOPOLOGY.h"
#include "W2_EXCH2_BUFFER.h"

      INTEGER myOLw, myOLe, myOLs, myOLn, myNz
      _RL array1(1-myOLw:sNx+myOLe,
     &           1-myOLs:sNy+myOLn,
     &           myNz, nSx, nSy)
      _RL array1d(1-myOLw:sNx+myOLe,
     &           1-myOLs:sNy+myOLn,
     &           myNz, nSx, nSy)
      _RL array2(1-myOLw:sNx+myOLe,
     &           1-myOLs:sNy+myOLn,
     &           myNz, nSx, nSy)
      _RL array2d(1-myOLw:sNx+myOLe,
     &           1-myOLs:sNy+myOLn,
     &           myNz, nSx, nSy)

      LOGICAL signOption
      CHARACTER*2 fieldCode
      INTEGER exchWidthX
      INTEGER exchWidthY
      INTEGER cornerMode
      INTEGER myThid

      CALL EXCH2_RL2_CUBE(
     U            array1, array2,
     I            signOption, fieldCode,
     I            myOLw, myOLe, myOLs, myOLn, myNz,
     I            exchWidthX, exchWidthY,
     I            cornerMode, myThid )

      CALL EXCH2_RL2_CUBE(
     U            array1d, array2d,
     I            signOption, fieldCode,
     I            myOLw, myOLe, myOLs, myOLn, myNz,
     I            exchWidthX, exchWidthY,
     I            cornerMode, myThid )

      END

#include "FIZHI_OPTIONS.h"

CBOP
C     !ROUTINE: FIZHI_READ_PICKUP
C     !INTERFACE:
      SUBROUTINE FIZHI_READ_PICKUP( myIter, myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R FIZHI_READ_PICKUP
C     | o Reads current fizhi state from a pickup file
C     *==========================================================*
C     \ev

C     !USES:
CEOP
      IMPLICIT NONE

C     == Global variables ===
#include "SIZE.h"
#include "fizhi_SIZE.h"
#include "fizhi_land_SIZE.h"
#include "fizhi_coms.h"
#include "fizhi_land_coms.h"
#include "fizhi_io_comms.h"
#include "EEPARAMS.h"
#include "PARAMS.h"

C     == Routine Arguments ==
C     myIter  :: time-step number
C     myThid  :: Number of this instance
      INTEGER myIter
      INTEGER myThid

C     !LOCAL VARIABLES:
C     fn      :: character buffer for creating filename
C     prec    :: precision of pickup files
C     k       :: loop index
      INTEGER i, prec
      CHARACTER*(MAX_LEN_FNAM) fn
      _RL temp(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nrphys,Nsx,Nsy)
      integer j,bi,bj

      DO i = 1,MAX_LEN_FNAM
        fn(i:i) = ' '
      ENDDO
      WRITE(fn,'(A,I10.10)') 'pickup_fizhi.',myIter
      prec = precFloat64

      IF ( fizhi_mdsio_read_pickup ) THEN

C     Read fields as consecutive records
       CALL READ_REC_3D_RL( fn,prec,Nrphys,uphy,      1,myIter,myThid )
       CALL READ_REC_3D_RL( fn,prec,Nrphys,vphy,      2,myIter,myThid )
       CALL READ_REC_3D_RL( fn,prec,Nrphys,thphy,     3,myIter,myThid )
       CALL READ_REC_3D_RL( fn,prec,Nrphys,sphy,      4,myIter,myThid )
       CALL READ_REC_3D_RL( fn,prec,Nrphys,cldtot_lw, 5,myIter,myThid )
       CALL READ_REC_3D_RL( fn,prec,Nrphys,cldras_lw, 6,myIter,myThid )
       CALL READ_REC_3D_RL( fn,prec,Nrphys,cldlsp_lw, 7,myIter,myThid )
       CALL READ_REC_3D_RL( fn,prec,Nrphys,lwlz,      8,myIter,myThid )
       CALL READ_REC_3D_RL( fn,prec,Nrphys,cldtot_sw, 9,myIter,myThid )
       CALL READ_REC_3D_RL( fn,prec,Nrphys,cldras_sw,10,myIter,myThid )
       CALL READ_REC_3D_RL( fn,prec,Nrphys,cldlsp_sw,11,myIter,myThid )
       CALL READ_REC_3D_RL( fn,prec,Nrphys,swlz,     12,myIter,myThid )
       CALL READ_REC_3D_RL( fn,prec,Nrphys,qliqavelw,13,myIter,myThid )
       CALL READ_REC_3D_RL( fn,prec,Nrphys,qliqavesw,14,myIter,myThid )
       CALL READ_REC_3D_RL( fn,prec,Nrphys,fccavelw, 15,myIter,myThid )
       CALL READ_REC_3D_RL( fn,prec,Nrphys,fccavesw, 16,myIter,myThid )
       CALL READ_REC_3D_RL( fn,prec,Nrphys,temp,     17,myIter,myThid )

       do bj = 1,myByLo(myThid), myByHi(myThid)
       do bi = 1,myBxLo(myThid), myBxHi(myThid)
       do j = 1-OLy,sNy+OLy
       do i = 1-OLx,sNx+OLx
        raincon(i,j,bi,bj) = temp(i,j,1,bi,bj)
        rainlsp(i,j,bi,bj) = temp(i,j,2,bi,bj)
        snowfall(i,j,bi,bj) = temp(i,j,3,bi,bj)
       enddo
       enddo

       iras(bi,bj)       = NINT(temp(1,1,4,bi,bj))
       nlwcld(bi,bj)     = NINT(temp(2,1,4,bi,bj))
       nlwlz(bi,bj)      = NINT(temp(3,1,4,bi,bj))
       nswcld(bi,bj)     = NINT(temp(4,1,4,bi,bj))
       nswlz(bi,bj)      = NINT(temp(5,1,4,bi,bj))
       imstturbsw(bi,bj) = NINT(temp(6,1,4,bi,bj))
       imstturblw(bi,bj) = NINT(temp(7,1,4,bi,bj))

       enddo
       enddo

      ENDIF

#ifdef ALLOW_MNC
      IF ( useMNC .and. fizhi_mnc_read_pickup ) THEN

        _BEGIN_MASTER(myThid)

        WRITE(fn,'(A,I10.10)') 'pickup_fizhi.',myIter

        CALL MNC_CW_RL_R('D',fn,0,0,'uphy',uphy,myThid)
        CALL MNC_CW_RL_R('D',fn,0,0,'vphy',vphy,myThid)
        CALL MNC_CW_RL_R('D',fn,0,0,'thphy',thphy,myThid)
        CALL MNC_CW_RL_R('D',fn,0,0,'sphy',sphy,myThid)
        CALL MNC_CW_RL_R('D',fn,0,0,'sphy',sphy,myThid)


        _END_MASTER(myThid)

      ENDIF
#endif

      RETURN
      END

#include "MONITOR_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: MON_INIT

C     !INTERFACE:
      SUBROUTINE MON_INIT( myThid )

C     !DESCRIPTION:
C     Set default monitor internal setup.

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "MONITOR.h"

C     !INPUT PARAMETERS:
      INTEGER myThid
CEOP

C     !LOCAL VARIABLES:
c     CHARACTER*(MAX_LEN_MBUF) msgbuf

C     Since monitor does not have a "data" file of its own, all its
C     output flags are set in "model/src/ini_parms.F".  Please see the
C     IO section of that file for the monitor flags.

C     Set monitor I/O to standard output by default
C     and prefix monitor "variables" with mon by default.
      CALL MON_SET_IOUNIT( standardMessageUnit, myThid )
      CALL MON_SET_PREF  ( mon_string_none    , myThid )

      _BEGIN_MASTER(myThid)

C     Internal parameter for continuing when monitor_solution would
C     otherwise decide to stop the code.
c     mon_overrideStop=.FALSE.
      monSolutionMaxRange = 1. _d +4
      IF ( fluidIsWater ) monSolutionMaxRange = 1. _d +3

      mon_output_AM = fluidIsAir .AND. useCoriolis
     &                           .AND. selectCoriMap.GE.2
      mon_trAdvCFL(1) = 0.
      mon_trAdvCFL(2) = 0.
      mon_trAdvCFL(3) = 0.

      _END_MASTER(myThid)

      _BARRIER

      RETURN
      END

#include "MOM_COMMON_OPTIONS.h"

CBOP
C !ROUTINE: MOM_CALC_KE

C !INTERFACE: ==========================================================
      SUBROUTINE MOM_CALC_KE(
     I        bi,bj,k,KEscheme,
     I        uFld, vFld,
     O        KE,
     I        myThid)

C !DESCRIPTION:
C Calculates the Kinetic energy of horizontal flow
C \begin{equation*}
C KE = \frac{1}{2} \left( h_w \overline{u^2}^i + h_s \overline{v^2}^j \right)
C \end{equation*}

C !USES: ===============================================================
      IMPLICIT NONE
#include "SIZE.h"
#include "GRID.h"

C !INPUT PARAMETERS: ===================================================
C  bi,bj                :: tile indices
C  k                    :: vertical level
C  KEscheme             :: spacial discretisation scheme for KE
C  uFld                 :: zonal flow
C  vFld                 :: meridional flow
C  KE                   :: Kinetic Energy
C  myThid               :: thread number
      INTEGER bi,bj,k
      _RL uFld(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL vFld(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER KEscheme
      INTEGER myThid

C !OUTPUT PARAMETERS: ==================================================
C  KE                   :: Kinetic energy
      _RL KE(1-OLx:sNx+OLx,1-OLy:sNy+OLy)

C !LOCAL VARIABLES: ====================================================
C  i,j                  :: loop indices
      INTEGER i,j
CEOP

C       This defn of KE should not ever be used. Just to let you know.
C                            2       2
C                 1  /  ___I    ___J   \
C           KE = --- |   U    +  V     |
C                 2  \                 /
C
#ifdef ALLOW_AUTODIFF
      DO j=1-OLy,sNy+OLy
       DO i=1-OLx,sNx+OLx
         KE(i,j) = 0.
       ENDDO
      ENDDO
#endif

      IF (KEscheme.EQ.-1) THEN
       DO j=1-OLy,sNy+OLy-1
        DO i=1-OLx,sNx+OLx-1
         KE(i,j) = 0.125*(
     &             ( uFld(i,j)+uFld(i+1, j ) )**2
     &            +( vFld(i,j)+vFld( i ,j+1) )**2 )
        ENDDO
       ENDDO

      ELSEIF (KEscheme.EQ.0) THEN
C       This defn of KE should be used for the vector invariant equations.
C                       _____I  _____J
C                 1  /     2       2   \
C           KE = --- |   U    +  V     |
C                 2  \                 /
C
       DO j=1-OLy,sNy+OLy-1
        DO i=1-OLx,sNx+OLx-1
         KE(i,j) = 0.25*(
     &           ( uFld( i , j )*uFld( i , j )
     &            +uFld(i+1, j )*uFld(i+1, j ) )
     &         + ( vFld( i , j )*vFld( i , j )
     &            +vFld( i ,j+1)*vFld( i ,j+1) )
     &                  )
        ENDDO
       ENDDO

      ELSEIF (KEscheme.EQ.1) THEN
C       As above but including the area
       DO j=1-OLy,sNy+OLy-1
        DO i=1-OLx,sNx+OLx-1
         KE(i,j) = 0.25*(
     &           ( uFld(i, j )*uFld(i, j )*rAw(i ,j, bi,bj)
     &            +uFld(i+1,j)*uFld(i+1,j)*rAw(i+1,j,bi,bj) )
     &         + ( vFld(i, j )*vFld(i, j )*rAs(i ,j, bi,bj)
     &            +vFld(i,j+1)*vFld(i,j+1)*rAs(i,j+1,bi,bj) )
     &                  )*recip_rA(i,j,bi,bj)
        ENDDO
       ENDDO

      ELSEIF (KEscheme.EQ.2) THEN
C       As KEscheme=0 but including the lopping factors and should be used
C       for the conservative form of the momentum equations.
       DO j=1-OLy,sNy+OLy-1
        DO i=1-OLx,sNx+OLx-1
         KE(i,j) = 0.25*(
     &           ( uFld( i , j )*uFld( i , j )*_hFacW(i,j,k,bi,bj)
     &            +uFld(i+1, j )*uFld(i+1, j )*_hFacW(i+1,j,k,bi,bj) )
     &         + ( vFld( i , j )*vFld( i , j )*_hFacS(i,j,k,bi,bj)
     &            +vFld( i ,j+1)*vFld( i ,j+1)*_hFacS(i,j+1,k,bi,bj) )
     &            )*_recip_hFacC(i,j,k,bi,bj)
        ENDDO
       ENDDO

      ELSEIF (KEscheme.EQ.3) THEN
C       As above but including the area
       DO j=1-OLy,sNy+OLy-1
        DO i=1-OLx,sNx+OLx-1
         KE(i,j) = 0.25*(
     &           (
     &    uFld(i, j )*uFld(i, j )
     &        *_hFacW(i ,j, k,bi,bj)*rAw(i ,j, bi,bj)
     &   +uFld(i+1,j)*uFld(i+1,j)
     &        *_hFacW(i+1,j,k,bi,bj)*rAw(i+1,j,bi,bj)
     &           )
     &         + (
     &    vFld(i, j )*vFld(i, j )
     &        *_hFacS(i, j, k,bi,bj)*rAs(i ,j, bi,bj)
     &   +vFld(i,j+1)*vFld(i,j+1)
     &        *_hFacS(i,j+1,k,bi,bj)*rAs(i,j+1,bi,bj)
     &           )      )*_recip_hFacC(i,j,k,bi,bj)
     &                   * recip_rA(i,j,bi,bj)
        ENDDO
       ENDDO

      ELSE
       STOP 'S/R MOM_CALC_KE: We should never reach this point!'
      ENDIF

      RETURN
      END

#include "DIC_OPTIONS.h"

C--  File dic_solvesaphe.F:
C--   Contents:
C--   o AHINI_FOR_AT
C--   o ANW_INFSUP
C--   o EQUATION_AT
C--   o CALC_PCO2_SOLVESAPHE
C--   o DIC_COEFFS_SURF
C--   o DIC_COEFFS_DEEP
C--   o SOLVE_AT_FAST
C--   o SOLVE_AT_GENERAL
C--   o SOLVE_AT_GENERAL_SEC

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C    SolveSAPHE is free software: you can redistribute it and/or modify
C    it under the terms of the GNU Lesser General Public License as published by
C    the Free Software Foundation, either version 3 of the License, or
C    (at your option) any later version.
C
C    SolveSAPHE is distributed in the hope that it will be useful,
C    but WITHOUT ANY WARRANTY; without even the implied warranty of
C    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C    GNU Lesser General Public License for more details.
C
C    You should have received a copy of the GNU Lesser General Public License
C    along with SolveSAPHE.  If not, see <http://www.gnu.org/licenses/>.
C
C    Copyright 2013 Guy Munhoven
C
C    From the paper: Munhoven, G (2013),
C        Mathematics of the total alkalinity–pH equation – pathway to robust
C        and universal solution algorithms: the SolveSAPHE package v1.0.1.
C      Geosci. Model Dev., 6, 1367–1388,  doi:10.5194/gmd-6-1367-2013
C
C    JMLauderdale Summer 2018:
C    - Modified for MITGCM style, just keeping the "general" equations from
C        MOD_PHSOLVERS SOLVE_AT_GENERAL SOLVE_AT_GENERAL_SEC and SOLVE_AT_FAST.
C        Use runtime flags in data.dic to use GENERAL (selectPHsolver=1,
C        default), SEC (selectPHsolver=2) or FAST (selectPHsolver=3).
C
C    - MOD_CHEMCONST is included here as DIC_COEFFS_SURF, with the
C        style brought in line with S/R CARBON_COEFF (i.e all ak values are
C        filled in one call, rather than all as separate functions).
C
C    - MOD_CHEMCONST pressure corrections have been split off into the new
C        S/R DIC_COEFFS_DEEP, call both to get pressure
C        adjusted dissociation constants
C
C    - Different coefficients can be accessed using runtime flags in data.dic:
C
C    Borate concentration from salinity:
C     selectBTconst=1 for the default formulation of Uppström (1974)
C                     i.e. the same as S/R CARBON_COEFFS
C     selectBTconst=2 for the new formulation from Lee et al (2010)
C
C    Fluoride concentration from salinity:
C     selectFTconst=1 for the default formulation of Riley (1965)
C                     i.e. the same as S/R CARBON_COEFFS
C     selectFTconst=2 for the new formulation from Culkin (1965)
C
C    First dissociation constant for hydrogen fluoride:
C     selectHFconst=1 for the default  Dickson and Riley (1979)
C                     i.e. the same as S/R CARBON_COEFFS
C     selectHFconst=2 for the formulation of Perez and Fraga (1987)
C
C    First and second dissociation constants of carbonic acid:
C     selectK1K2const=1 for the default formulation of Millero (1995) with data
C              from Mehrbach et al. (1973),  i.e. the same as S/R CARBON_COEFFS
C     selectK1K2const=2 for the formulation of Roy et al. (1993)
C     selectK1K2const=3 for the "combination" formulation of Millero (1995)
C     selectK1K2const=4 for the formulation of Luecker et al. (2000)
C     selectK1K2const=5 for the formulation of Millero
C                                              (2010, Mar. Fresh Wat. Res.)
C     selectK1K2const=6 for the formulation of Waters, Millero, Woosley
C                                              (2014, Mar. Chem.)
C      =========================================================================
      SUBROUTINE AHINI_FOR_AT(p_alkcb, p_dictot, p_bortot, p_hini,
     &                    i, j, k, bi, bj, myIter, myThid )

C      Subroutine returns the root for the 2nd order approximation of the
C      DIC -- B_T -- A_CB equation for [H+] (reformulated as a cubic polynomial)
C      around the local minimum, if it exists.

C      Returns * 1E-03 if p_alkcb <= 0
C              * 1E-10 if p_alkcb >= 2*p_dictot + p_bortot
C              * 1E-07 if 0 < p_alkcb < 2*p_dictot + p_bortot
C                       and the 2nd order approximation does not have a solution

      IMPLICIT NONE

C     MITgcm GLobal variables
#include "SIZE.h"
#include "EEPARAMS.h"
#include "DIC_VARS.h"

C -----------------------------------------------------------------------
C     Argument variables
C -----------------------------------------------------------------------

      _RL p_alkcb
      _RL p_dictot
      _RL p_bortot
      _RL p_hini
      INTEGER i,j,k,bi,bj,myIter,myThid

#ifdef CARBONCHEM_SOLVESAPHE
C -----------------------------------------------------------------------
C     Local variables
C -----------------------------------------------------------------------

      _RL zcar, zbor
      _RL zd, zsqrtd, zhmin
      _RL za2, za1, za0

      IF (p_alkcb .LE. 0. _d 0) THEN
       p_hini = 1. _d -3
      ELSEIF (p_alkcb .GE. (2. _d 0*p_dictot + p_bortot)) THEN
       p_hini = 1. _d -10
      ELSE
       zcar = p_dictot/p_alkcb
       zbor = p_bortot/p_alkcb

C      Coefficients of the cubic polynomial
       za2 = akb(i,j,bi,bj)*(1. _d 0 - zbor) + ak1(i,j,bi,bj)
     &       *(1. _d 0-zcar)
       za1 = ak1(i,j,bi,bj)*akb(i,j,bi,bj)*(1. _d 0 - zbor - zcar)
     &     + ak1(i,j,bi,bj)*ak2(i,j,bi,bj)*(1. _d 0 - (zcar+zcar))
       za0 = ak1(i,j,bi,bj)*ak2(i,j,bi,bj)*akb(i,j,bi,bj)
     &       *(1. _d 0 - zbor - (zcar+zcar))

C      Taylor expansion around the minimum
       zd = za2*za2 - 3. _d 0*za1
C            Discriminant of the quadratic equation
C                 for the minimum close to the root

       IF(zd .GT. 0. _d 0) THEN
C      If the discriminant is positive
         zsqrtd = SQRT(zd)
         IF(za2 .LT. 0) THEN
           zhmin = (-za2 + zsqrtd)/3. _d 0
         ELSE
           zhmin = -za1/(za2 + zsqrtd)
        ENDIF
        p_hini = zhmin + SQRT(-(za0 + zhmin*(za1 + zhmin*(za2 + zhmin)))
     &            /zsqrtd)
       ELSE
         p_hini = 1. _d -7
       ENDIF
      ENDIF

#endif /* CARBONCHEM_SOLVESAPHE */
      RETURN
      END
C      END SUBROUTINE AHINI_FOR_AT
C      =========================================================================

C      =========================================================================
      SUBROUTINE ANW_INFSUP(p_dictot, p_bortot,
     &                      p_po4tot, p_siltot,
     &                      p_nh4tot, p_h2stot,
     &                      p_so4tot, p_flutot,
     &                      p_alknw_inf, p_alknw_sup,
     &                      i, j, k, bi, bj, myIter,
     &                      myThid )

C      Subroutine returns the lower and upper bounds of "non-water-selfionization"
C      Contributions to total alkalinity (the infimum and the supremum), i.e
C      inf(TA - [OH-] + [H+]) and sup(TA - [OH-] + [H+])

      IMPLICIT NONE

C     MITgcm GLobal variables
#include "SIZE.h"
#include "EEPARAMS.h"
#include "DIC_VARS.h"

C      --------------------
C      Argument variables
C      --------------------

      _RL p_dictot
      _RL p_bortot
      _RL p_po4tot
      _RL p_siltot
      _RL p_nh4tot
      _RL p_h2stot
      _RL p_so4tot
      _RL p_flutot
      _RL p_alknw_inf
      _RL p_alknw_sup
      INTEGER i,j,k,bi,bj,myIter,myThid

#ifdef CARBONCHEM_SOLVESAPHE
C      p_alknw_inf = -\Sum_i m_i Xtot_i
C
C      p_alknw_inf =-p_dictot*0. _d 0 & ! n = 2, m = 0
C                  -p_bortot*0. _d 0 &  ! n = 1, m = 0
C                  -p_po4tot*1. _d 0 &  ! n = 3, m = 1
C                  -p_siltot*0. _d 0 &  ! n = 1, m = 0
C                  -p_nh4tot*0. _d 0 &  ! n = 1, m = 0
C                  -p_h2stot*0. _d 0 &  ! n = 1, m = 0
C                  -p_so4tot*1. _d 0 &  ! n = 1, m = 1
C                  -p_flutot*1. _d 0    ! n = 1, m = 1

      p_alknw_inf =    -p_po4tot - p_so4tot - p_flutot

C      p_alknw_sup = \Sum_i (n_i - m_i) Xtot_i
C
C      p_alknw_sup = p_dictot*(2. _d 0-0. _d 0) &  ! n = 2, m = 0
C                  p_bortot*(1. _d 0-0. _d 0) &    ! n = 1, m = 0
C                  p_po4tot*(3. _d 0-1. _d 0) &    ! n = 3, m = 1
C                  p_siltot*(1. _d 0-0. _d 0) &    ! n = 1, m = 0
C                  p_nh4tot*(1. _d 0-0. _d 0) &    ! n = 1, m = 0
C                  p_h2stot*(1. _d 0-0. _d 0) &    ! n = 1, m = 0
C                  p_so4tot*(1. _d 0-1. _d 0) &    ! n = 1, m = 1
C                  p_flutot*(1. _d 0-1. _d 0)      ! n = 1, m = 1

      p_alknw_sup =  p_dictot + p_dictot + p_bortot
     &             + p_po4tot + p_po4tot + p_siltot
     &             + p_nh4tot + p_h2stot

#endif /* CARBONCHEM_SOLVESAPHE */
      RETURN
      END
C      END SUBROUTINE ANW_INFSUP
C      =========================================================================

C      =========================================================================
      SUBROUTINE CALC_PCO2_SOLVESAPHE(
     I                    t,s,z_dictot,z_po4tot,z_siltot,z_alktot,
     U                    pHlocal,z_pco2,z_co3,
     I                    i,j,k,bi,bj,debugPrt,myIter,myThid )

      IMPLICIT NONE

C     MITgcm GLobal variables
#include "SIZE.h"
#include "EEPARAMS.h"
#include "DIC_VARS.h"

C -----------------------------------------------------------------------
C General parameters
C -----------------------------------------------------------------------
C       diclocal = total inorganic carbon (mol/m^3)
C             where 1 T = 1 metric ton = 1000 kg
C       ta  = total alkalinity (eq/m^3)
C       pt  = inorganic phosphate (mol/^3)
C       sit = inorganic silicate (mol/^3)
C       t   = temperature (degrees C)
C       s   = salinity (g/kg)
      _RL  t, s, z_po4tot, z_siltot, z_alktot
      _RL  z_pco2, z_dictot, pHlocal
      _RL  z_co3
      INTEGER i,j,k,bi,bj
      LOGICAL debugPrt
      INTEGER myIter,myThid

#ifdef CARBONCHEM_SOLVESAPHE

C     == Local variables ==
      _RL  z_h
      _RL  z_hini
      _RL  z_bortot
      _RL  z_nh4tot
      _RL  z_h2stot
      _RL  z_so4tot
      _RL  z_flutot
      _RL  z_val
      _RL  z_co2s
      _RL  z_fco2
      _RL  z_hco3
      _RL  z_co2aq
      CHARACTER*(MAX_LEN_MBUF) msgBuf
C -----------------------------------------------------------------------
C Change units from the input of mol/m^3 -> mol/kg:
c (1 mol/m^3)  x (1 m^3/1024.5 kg)
c where the ocean mean surface density is 1024.5 kg/m^3
c Note: mol/kg are actually what the body of this routine uses
c for calculations.  Units are reconverted back to mol/m^3 at the
c end of this routine.
c To convert input in mol/m^3 -> mol/kg
      z_po4tot=z_po4tot*permil
      z_siltot=z_siltot*permil
      z_alktot=z_alktot*permil
      z_dictot=z_dictot*permil

C Load from the carbon_chem common block
      z_so4tot = st(i,j,bi,bj)
      z_flutot = ft(i,j,bi,bj)
      z_bortot = bt(i,j,bi,bj)

      z_nh4tot = 0. _d 0
      z_h2stot = 0. _d 0

      z_hini = 10. _d 0**(-1. _d 0 * pHlocal)

      at_maxniter  = 50

      IF ( selectPHsolver.EQ.1 ) THEN
#ifdef ALLOW_DEBUG
        IF (debugPrt) CALL DEBUG_CALL('SOLVE_AT_GENERAL',myThid)
#endif
        CALL SOLVE_AT_GENERAL(z_alktot, z_dictot, z_bortot,
     &                z_po4tot, z_siltot, z_nh4tot, z_h2stot,
     &                z_so4tot, z_flutot, z_hini,   z_val,
     &                z_h,
     &                i, j, k, bi, bj, debugPrt, myIter, myThid )
      ELSEIF ( selectPHsolver.EQ.2 ) THEN
#ifdef ALLOW_DEBUG
        IF (debugPrt) CALL DEBUG_CALL('SOLVE_AT_GENERAL_SEC',myThid)
#endif
        CALL SOLVE_AT_GENERAL_SEC(z_alktot, z_dictot, z_bortot,
     &                z_po4tot, z_siltot, z_nh4tot, z_h2stot,
     &                z_so4tot, z_flutot, z_hini,   z_val,
     &                z_h,
     &                i, j, k, bi, bj, debugPrt, myIter, myThid )
      ELSEIF ( selectPHsolver.EQ.3 ) THEN
#ifdef ALLOW_DEBUG
        IF (debugPrt) CALL DEBUG_CALL('SOLVE_AT_FAST',myThid)
#endif
        CALL SOLVE_AT_FAST(z_alktot, z_dictot, z_bortot,
     &                z_po4tot, z_siltot, z_nh4tot, z_h2stot,
     &                z_so4tot, z_flutot, z_hini,   z_val,
     &                z_h,
     &                i, j, k, bi, bj, debugPrt, myIter, myThid )
      ENDIF

C Unlikely, but it might happen...
      IF ( z_h .LT. 0. _d 0 ) THEN
        WRITE(msgBuf,'(A,A,A)')
     &    'S/R CALC_PCO2_SOLVESAPHE:',
     &    ' H+ ion concentration less than 0',
     &    ' Divergence or too many iterations'
        CALL PRINT_ERROR( msgBuf, myThid )
        STOP 'ABNORMAL END: S/R CALC_PCO2_SOLVESAPHE'
      ENDIF

C Return update pH to main routine
      phlocal = -log10(z_h)

C now determine [CO2*]
      z_co2s  = z_dictot/
     &   (1.0 _d 0 + (ak1(i,j,bi,bj)/z_h)
     & + (ak1(i,j,bi,bj)*ak2(i,j,bi,bj)/(z_h*z_h)))
C Evaluate HCO3- and CO32- , carbonate ion concentration
C used in determination of calcite compensation depth
      z_hco3 = ak1(i,j,bi,bj)*z_dictot /
     &         (z_h*z_h + ak1(i,j,bi,bj)*z_h
     &        + ak1(i,j,bi,bj)*ak2(i,j,bi,bj))
      z_co3 = ak1(i,j,bi,bj)*ak2(i,j,bi,bj)*z_dictot /
     &         (z_h*z_h + ak1(i,j,bi,bj)*z_h
     &        + ak1(i,j,bi,bj)*ak2(i,j,bi,bj))

c ---------------------------------------------------------------
c surface pCO2 (following Dickson and Goyet, DOE...)
#ifdef WATERVAP_BUG
      z_pco2 = z_co2s/ff(i,j,bi,bj)
#else
c bug fix by Bennington
      z_fco2 = z_co2s/ak0(i,j,bi,bj)
      z_pco2 = z_fco2/fugf(i,j,bi,bj)
#endif

C ----------------------------------------------------------------
C Reconvert from mol/kg -> mol/m^3
      z_po4tot = z_po4tot/permil
      z_siltot = z_siltot/permil
      z_alktot = z_alktot/permil
      z_dictot = z_dictot/permil
      z_hco3   = z_hco3/permil
      z_co3    = z_co3/permil
      z_co2aq  = z_co2s/permil

#endif /* CARBONCHEM_SOLVESAPHE */
      RETURN
      END
C      END SUBROUTINE CALC_PCO2_SOLVESAPHE
C      =========================================================================

C      =========================================================================
      SUBROUTINE DIC_COEFFS_SURF(
     &                   ttemp,stemp,
     &                   bi,bj,iMin,iMax,jMin,jMax,myThid)

C     Determine coefficients for surface carbon chemistry,
C     loaded into common block

      IMPLICIT NONE

C     MITgcm GLobal variables
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "DIC_VARS.h"

      _RL  ttemp(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL  stemp(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER bi,bj,iMin,iMax,jMin,jMax,myThid

#ifdef CARBONCHEM_SOLVESAPHE

C LOCAL VARIABLES
      INTEGER i, j
      _RL t
      _RL s
      _RL t_k
      _RL t_k_o_100
      _RL t_k_o_100_2
      _RL dlog_t_k
      _RL dlog10_t_k
      _RL inv_t_k
      _RL ion_st, is_2, sqrtis
      _RL s_2, sqrts, s_15, scl, s35
      _RL log_fw2sw
      _RL B, B1
      _RL delta
      _RL P1atm
      _RL RT
      _RL Rgas
C conversions for different pH scales
      _RL total2free
      _RL free2total
      _RL free2sw
      _RL sw2free
      _RL total2sw
      _RL sw2total

        do i=imin,imax
         do j=jmin,jmax
          if (hFacC(i,j,1,bi,bj).gt.0. _d 0) then
           t = ttemp(i,j)
           s = stemp(i,j)
C terms used more than once for:
C temperature
           t_k         = 273.15 _d 0 + t
           t_k_o_100   = t_k/100. _d 0
           t_k_o_100_2 = t_k_o_100*t_k_o_100
           inv_t_k=1.0 _d 0/t_k
           dlog_t_k    = LOG(t_k)
           dlog10_t_k  = LOG10(t_k)
C ionic strength (converted to kgsw)
           ion_st=19.924 _d 0*s/(1000. _d 0-1.005 _d 0*s)
           is_2=ion_st*ion_st
           sqrtis=sqrt(ion_st)
C salinity
           s_2  = s*s
           sqrts=sqrt(s)
           s_15 = s*sqrts
           scl  = s/1.80655 _d 0
           s35  = s/35. _d 0

           log_fw2sw = LOG( 1. _d 0 - 0.001005 _d 0*s )

      IF ( selectBTconst.EQ.1 ) THEN
C -----------------------------------------------------------------------
C       Calculate the total borate concentration in mol/kg-SW
C       given the salinity of a sample
C       Ref: Uppström (1974), cited by  Dickson et al. (2007, chapter 5, p 10)
C            Millero (1982) cited in Millero (1995)
C       pH scale  : N/A
           bt(i,j,bi,bj) = 0.000232 _d 0* scl/10.811 _d 0
      ELSEIF ( selectBTconst.EQ.2 ) THEN
C -----------------------------------------------------------------------
C       Calculate the total borate concentration in mol/kg-SW
C       given the salinity of a sample
C       References: New formulation from Lee et al (2010)
C       pH scale  : N/A
           bt(i,j,bi,bj) = 0.0002414 _d 0* scl/10.811 _d 0
      ENDIF

      IF ( selectFTconst.EQ.1 ) THEN
C -----------------------------------------------------------------------
C       Calculate the total fluoride concentration in mol/kg-SW
C       given the salinity of a sample
C       References: Riley (1965)
C       pH scale  : N/A
           ft(i,j,bi,bj) = 0.000067 _d 0 * scl/18.9984 _d 0
      ELSEIF ( selectFTconst.EQ.2 ) THEN
C -----------------------------------------------------------------------
C       Calculate the total fluoride concentration in mol/kg-SW
C       given the salinity of a sample
C       References: Culkin (1965) (???)
C       pH scale  : N/A
           ft(i,j,bi,bj) = 0.000068 _d 0*(s35)
      ENDIF

C -----------------------------------------------------------------------
C       Calculate the total sulfate concentration in mol/kg-SW
C       given the salinity of a sample
C       References: Morris & Riley (1966) quoted in Handbook (2007)
C       pH scale  : N/A
           st(i,j,bi,bj) = 0.14 _d 0 * scl/96.062 _d 0

C -----------------------------------------------------------------------
C       Calculate the total calcium concentration in mol/kg-SW
C       given the salinity of a sample
C       References: Culkin (1965) (???)
C       pH scale  : N/A
           cat(i,j,bi,bj) = 0.010282 _d 0*(s35)

C -----------------------------------------------------------------------
C       Calculate K0 in (mol/kg-SW)/atmosphere
C       References: Weiss (1979) [(mol/kg-SW)/atm]
C       pH scale  : N/A
C       Note      : currently no pressure correction
           ak0(i,j,bi,bj)  = EXP( 93.4517 _d 0/t_k_o_100 - 60.2409 _d 0
     &                 + 23.3585 _d 0*LOG(t_k_o_100)
     &                 + s * (0.023517 _d 0 - 0.023656 _d 0*t_k_o_100
     &                 + 0.0047036 _d 0*t_k_o_100_2))

C------------------------------------------------------------------------
C       Calculate f = k0(1-pH2O)*correction term for non-ideality
C       References: Weiss & Price (1980, Mar. Chem., 8, 347-359
C                   Eq 13 with table 6 values)
C       pH scale  : N/A
           ff(i,j,bi,bj) = exp(-162.8301 _d 0 + 218.2968 _d 0/t_k_o_100
     &          + 90.9241 _d 0*log(t_k_o_100) - 1.47696 _d 0*t_k_o_100_2
     &          + s * (.025695 _d 0 - .025225 _d 0*t_k_o_100
     &          + 0.0049867 _d 0*t_k_o_100_2))

C------------------------------------------------------------------------
C       Calculate Fugacity Factor needed for non-ideality in ocean
C       References: Weiss (1974) Marine Chemistry
C       pH scale  : N/A
           P1atm = 1.01325 _d 0 ! bars
           Rgas = 83.1451 _d 0  ! bar*cm3/(mol*K)
           RT = Rgas*t_k
           delta = (57.7 _d 0 - 0.118 _d 0*t_k)
           B1 = -1636.75 _d 0 + 12.0408 _d 0*t_k
     &                  - 0.0327957 _d 0*t_k*t_k
           B  = B1 + 3.16528 _d 0*t_k*t_k*t_k*(0.00001 _d 0)

C   "x2" term often neglected (assumed=1) in applications of Weiss's (1974) eq.9
C    x2 = 1 - x1 = 1 - xCO2 (it is very close to 1, but not quite)
           fugf(i,j,bi,bj) = exp( (B+2. _d 0*delta) * P1atm / RT)

      IF ( selectK1K2const.EQ.1 ) THEN
C -----------------------------------------------------------------------
C       Calculate first dissociation constant of carbonic acid
C       in mol/kg-SW on the Seawater pH-scale.
C       References: Millero (1995, eq 35 -- pK1(MEHR));
C                   Mehrbach et al. (1973) data
C       pH scale:   Seawater
           ak1(i,j,bi,bj)=10.**(-1. _d 0*(3670.7 _d 0*inv_t_k
     &          - 62.008 _d 0 + 9.7944 _d 0*dlog_t_k
     &          - 0.0118 _d 0 * s + 0.000116 _d 0*s_2))

C       Calculate second dissociation constant of carbonic acid
C       in mol/kg-SW on the Seawater pH-scale.
C       References: Millero (1995, eq 36 -- pK2(MEHR))
C                   Mehrbach et al. (1973) data
C       pH scale:   Seawater
           ak2(i,j,bi,bj)=10.**(-1. _d 0*(1394.7 _d 0*inv_t_k
     &           + 4.777 _d 0 - 0.0184 _d 0*s + 0.000118 _d 0*s_2))

      ELSEIF ( selectK1K2const.EQ.2 ) THEN
C -----------------------------------------------------------------------
C       Calculate first dissociation constant of carbonic acid
C       in mol/kg-SW on the Total pH-scale.
C       References: Roy et al. (1993) -- also Handbook (1994)
C       pH scale  : Total
C       Note      : converted here from mol/kg-H2O to mol/kg-SW
           ak1(i,j,bi,bj)  =  EXP(-2307.1255 _d 0*inv_t_k + 2.83655 _d 0
     &              - 1.5529413 _d 0*dlog_t_k
     &              + (-4.0484 _d 0*inv_t_k - 0.20760841)*sqrts
     &              + 0.08468345*s
     &              - 0.00654208*s_15
     &              + log_fw2sw )

C       Calculate second dissociation constant of carbonic acid
C       in mol/kg-SW on the Total pH-scale.
C       References: Roy et al. (1993) -- also Handbook (1994)
C       pH scale  : Total
C       Note      : converted here from mol/kg-H2O to mol/kg-SW
           ak2(i,j,bi,bj) = EXP(-3351.6106 _d 0*inv_t_k - 9.226508 _d 0
     &              - 0.2005743 _d 0*dlog_t_k
     &              + ( -23.9722 _d 0*inv_t_k - 0.106901773 _d 0)*sqrts
     &              + 0.1130822*s - 0.00846934 _d 0*s_15
     &              + log_fw2sw )

      ELSEIF ( selectK1K2const.EQ.3 ) THEN
C -----------------------------------------------------------------------
C       Calculate first dissociation constant of carbonic acid
C       in mol/kg-SW on the Seawater pH-scale.
C       References: Millero (1995, eq 50 -- ln K1(COM))
C       pH scale:   Seawater
           ak1(i,j,bi,bj)  = EXP(2.18867 _d 0 - 2275.0360 _d 0*inv_t_k
     &              - 1.468591 _d 0*dlog_t_k
     &              + ( -0.138681 _d 0 - 9.33291 _d 0*inv_t_k)*sqrts
     &              + 0.0726483 _d 0*s - 0.00574938 _d 0*s_15)

C       Calculate second dissociation constant of carbonic acid
C       in mol/kg-SW on the Seawater pH-scale.
C       References: Millero (1995, eq 51 -- ln K2(COM))
C       pH scale:   Seawater
           ak2(i,j,bi,bj)  = EXP(-0.84226 _d 0 - 3741.1288 _d 0*inv_t_k
     &              -  1.437139 _d 0*dlog_t_k
     &              + (-0.128417 _d 0 - 24.41239 _d 0*inv_t_k)*sqrts
     &              +  0.1195308 _d 0*s - 0.00912840 _d 0*s_15)

      ELSEIF ( selectK1K2const.EQ.4 ) THEN
C -----------------------------------------------------------------------
C       Calculate first dissociation constant of carbonic acid
C       in mol/kg-SW on the Total pH-scale.
C       Suitable when 2 < T < 35 and 19 < S < 43
C       References: Luecker et al. (2000) -- also Handbook (2007)
C       pH scale:   Total
           ak1(i,j,bi,bj)  = 10. _d 0**( 61.2172 _d 0
     &                 - 3633.86 _d 0*inv_t_k - 9.67770 _d 0*dlog_t_k
     &                 + s*(0.011555 - s*0.0001152 _d 0))

C       Calculate second dissociation constant of carbonic acid
C       in mol/kg-SW on the Total pH-scale.
C       Suitable when 2 < T < 35 and 19 < S < 43
C       References: Luecker et al. (2000) -- also Handbook (2007)
C       pH scale:   Total
           ak2(i,j,bi,bj)  = 10. _d 0**(-25.9290 _d 0
     &                 - 471.78 _d 0*inv_t_k + 3.16967 _d 0*dlog_t_k
     &                 + s*(0.01781 _d 0 - s*0.0001122 _d 0))

      ELSEIF ( selectK1K2const.EQ.5 ) THEN
C -----------------------------------------------------------------------
C       Calculate first dissociation constant of carbonic acid
C       in mol/kg-SW on the Seawater pH-scale.
C       Suitable when 0 < T < 50 and 1 < S < 50
C       References: Millero (2010, Mar. Fresh Wat. Res.)
C                   Millero (1979) pressure correction
C       pH scale:   Seawater
           ak1(i,j,bi,bj) = 10.0 _d 0**(-1*(6320.813 _d 0*inv_t_k
     &      + 19.568224 _d 0*dlog_t_k -126.34048 _d 0
     &      + 13.4038 _d 0*sqrts + 0.03206 _d 0*s - (5.242 _d -5)*s_2
     &      + (-530.659 _d 0*sqrts - 5.8210 _d 0*s)*inv_t_k
     &      -2.0664 _d 0*sqrts*dlog_t_k))

C       Calculate second dissociation constant of carbonic acid
C       in mol/kg-SW on the Seawater pH-scale.
C       Suitable when 0 < T < 50 and 1 < S < 50
C       References: Millero (2010, Mar. Fresh Wat. Res.)
C                   Millero (1979) pressure correction
C       pH scale:   Seawater
           ak2(i,j,bi,bj) = 10.0 _d 0**(-1*(5143.692 _d 0*inv_t_k
     &     + 14.613358 _d 0*dlog_t_k -90.18333 _d 0
     &     + 21.3728 _d 0*sqrts + 0.1218 _d 0*s - (3.688 _d -4)*s_2
     &     + (-788.289 _d 0*sqrts - 19.189 _d 0*s)*inv_t_k
     &     -3.374 _d 0*sqrts*dlog_t_k))

      ELSEIF ( selectK1K2const.EQ.6 ) THEN
C -----------------------------------------------------------------------
C       Calculate first dissociation constant of carbonic acid
C       in mol/kg-SW on the Seawater pH-scale.
C       Suitable when 0 < T < 50 and 1 < S < 50
C       References: Waters, Millero, Woosley (Mar. Chem., 165, 66-67, 2014)
C                   Millero (1979) pressure correction
C       pH scale:   Seawater
           ak1(i,j,bi,bj) = 10.0 _d 0**(-1.*(6320.813 _d 0*inv_t_k
     &     + 19.568224 _d 0*dlog_t_k -126.34048 _d 0
     &     + 13.409160 _d 0*sqrts + 0.031646 _d 0*s - (5.1895 _d -5)*s_2
     &     + (-531.3642 _d 0*sqrts - 5.713 _d 0*s)*inv_t_k
     &     -2.0669166 _d 0*sqrts*dlog_t_k))

C       Calculate second dissociation constant of carbonic acid
C       in mol/kg-SW on the Seawater pH-scale.
C       Suitable when 0 < T < 50 and 1 < S < 50
C       References: Waters, Millero, Woosley (Mar. Chem., 165, 66-67, 2014)
C                   Millero (1979) pressure correction
C       pH scale:   Seawater
           ak2(i,j,bi,bj) = 10.0 _d 0**(-1.*
     &     ( 5143.692 _d 0*inv_t_k + 14.613358 _d 0*dlog_t_k
     &      - 90.18333 _d 0 + 21.225890 _d 0*sqrts + 0.12450870 _d 0*s
     &      - (3.7243 _d -4)*s_2
     &      + (-779.3444 _d 0*sqrts - 19.91739 _d 0*s)*inv_t_k
     &      - 3.3534679 _d 0*sqrts*dlog_t_k ) )

      ENDIF /* selectK1K2const */

C -----------------------------------------------------------------------
C       Calculate boric acid dissociation constant KB
C       in mol/kg-SW on the total pH-scale.
C       References: Dickson (1990, eq. 23) -- also Handbook (2007, eq. 37)
C       pH scale  : total
           akb(i,j,bi,bj)  = EXP(( -8966.90 _d 0 - 2890.53 _d 0*sqrts
     &      -77.942 _d 0*s + 1.728 _d 0*s_15 - 0.0996 _d 0*s_2 )*inv_t_k
     &      + (148.0248 _d 0 + 137.1942 _d 0*sqrts + 1.62142 _d 0*s)
     &      + (-24.4344 _d 0 - 25.085 _d 0*sqrts - 0.2474 _d 0*s)*
     &      dlog_t_k + 0.053105 _d 0*sqrts*t_k )

C -----------------------------------------------------------------------
C       Calculate the first dissociation constant
C       of phosphoric acid (H3PO4) in seawater
C       References: Yao and Millero (1995)
C       pH scale  : Seawater
           ak1p(i,j,bi,bj) = EXP(115.54 _d 0
     &              - 4576.752 _d 0*inv_t_k - 18.453 _d 0*dlog_t_k
     &              + ( 0.69171 _d 0 -  106.736 _d 0*inv_t_k)*sqrts
     &              + (-0.01844 _d 0 -  0.65643 _d 0*inv_t_k)*s)

C -----------------------------------------------------------------------
C       Calculate the second dissociation constant
C       of phosphoric acid (H3PO4) in seawater
C       References: Yao and Millero (1995)
C       pH scale  : Seawater
           ak2p(i,j,bi,bj) = EXP( 172.1033 _d 0
     &              - 8814.715 _d 0*inv_t_k
     &              -   27.927 _d 0*dlog_t_k
     &              + (  1.3566 _d 0 -  160.340 _d 0*inv_t_k)*sqrts
     &              + (-0.05778 _d 0 +  0.37335 _d 0*inv_t_k)*s)

C -----------------------------------------------------------------------
C       Calculate the third dissociation constant
C       of phosphoric acid (H3PO4) in seawater
C       References: Yao and Millero (1995)
C       pH scale  : Seawater
           ak3p(i,j,bi,bj) = EXP(-18.126 _d 0  -  3070.75 _d 0*inv_t_k
     &                + ( 2.81197 _d 0 + 17.27039 _d 0*inv_t_k)*sqrts
     &                + (-0.09984 _d 0 - 44.99486 _d 0*inv_t_k)*s)

C -----------------------------------------------------------------------
C       Calculate the first dissociation constant
C       of silicic acid (H4SiO4) in seawater
C       References: Yao and Millero (1995) cited by Millero (1995)
C       pH scale  : Seawater (according to Dickson et al, 2007)
C       Note      : converted here from mol/kg-H2O to mol/kg-sw
           aksi(i,j,bi,bj) = EXP(
     &           117.40 _d 0 - 8904.2 _d 0*inv_t_k
     &         - 19.334 _d 0 * dlog_t_k
     &         + ( 3.5913 _d 0 -  458.79 _d 0*inv_t_k) * sqrtis
     &         + (-1.5998 _d 0 +  188.74 _d 0*inv_t_k) * ion_st
     &         + (0.07871 _d 0 - 12.1652 _d 0*inv_t_k) * ion_st*ion_st
     &         + log_fw2sw )

C -----------------------------------------------------------------------
C       Calculate the dissociation constant
C       of ammonium in sea-water [mol/kg-SW]
C       References: Yao and Millero (1995)
C       pH scale  : Seawater
           akn(i,j,bi,bj)  = EXP(-0.25444 _d 0 -  6285.33 _d 0*inv_t_k
     &                + 0.0001635 _d 0 * t_k
     &                + ( 0.46532 _d 0 - 123.7184 _d 0*inv_t_k)*sqrts
     &                + (-0.01992 _d 0 +  3.17556 _d 0*inv_t_k)*s)

C -----------------------------------------------------------------------
C       Calculate the dissociation constant of hydrogen sulfide in sea-water
C       References: Millero et al. (1988) (cited by Millero (1995)
C       pH scale  : - Seawater (according to Yao and Millero, 1995,
C                               p. 82: "refitted if necessary")
C                   - Total (according to Lewis and Wallace, 1998)
C       Note      : we stick to Seawater here for the time being
C       Note      : the fits from Millero (1995) and Yao and Millero (1995)
C                   derive from Millero et al. (1998), with all the coefficients
C                   multiplied by -ln(10)
           akhs(i,j,bi,bj) = EXP( 225.838 _d 0 - 13275.3 _d 0*inv_t_k
     &               - 34.6435 _d 0 * dlog_t_k
     &               +  0.3449 _d 0*sqrts -  0.0274 _d 0*s)

C -----------------------------------------------------------------------
C       Calculate the dissociation constant of hydrogen sulfate (bisulfate)
C       References: Dickson (1990) -- also Handbook (2007)
C       pH scale  : free
C       Note      : converted here from mol/kg-H2O to mol/kg-SW
           aks(i,j,bi,bj) = EXP(141.328 _d 0
     &                -   4276.1 _d 0*inv_t_k -  23.093 _d 0*dlog_t_k
     &                + ( 324.57 _d 0 - 13856. _d 0*inv_t_k
     &                -   47.986 _d 0*dlog_t_k) * sqrtis
     &                + (-771.54 _d 0 + 35474. _d 0*inv_t_k
     &                +  114.723 _d 0*dlog_t_k) * ion_st
     &                - 2698. _d 0*inv_t_k*ion_st**1.5 _d 0
     &                + 1776. _d 0*inv_t_k*ion_st*ion_st
     &                + log_fw2sw )

      IF ( selectHFconst.EQ.1 ) THEN
C -----------------------------------------------------------------------
C       Calculate the dissociation constant \beta_{HF} [(mol/kg-SW)^{-1}]
C       in (mol/kg-SW)^{-1}, where
C         \beta_{HF} = \frac{ [HF] }{ [H^{+}] [F^{-}] }
C       References: Dickson and Riley (1979)
C       pH scale  : free
C       Note      : converted here from mol/kg-H2O to mol/kg-SW
           akf(i,j,bi,bj) = EXP(1590.2 _d 0*inv_t_k - 12.641 _d 0
     &                 + 1.525 _d 0*sqrtis
     &                 + log_fw2sw )
      ELSEIF ( selectHFconst.EQ.2 ) THEN
C -----------------------------------------------------------------------
C       Calculate the dissociation constant for hydrogen fluoride
C       in mol/kg-SW
C       References: Perez and Fraga (1987)
C       pH scale  : Total (according to Handbook, 2007)
           akf(i,j,bi,bj) = EXP( 874. _d 0*inv_t_k - 9.68 _d 0
     &                           + 0.111 _d 0*sqrts )
      ENDIF

C -----------------------------------------------------------------------
C       Calculate the water dissociation constant Kw in (mol/kg-SW)^2
C       References: Millero (1995) for value at pressc = 0
C       pH scale  : Seawater
           akw(i,j,bi,bj) =  EXP(148.9802 _d 0 - 13847.26 _d 0*inv_t_k
     &              -   23.6521 _d 0*dlog_t_k
     &              + (-5.977 _d 0 + 118.67 _d 0*inv_t_k
     &              + 1.0495 _d 0*dlog_t_k)*sqrts
     &              -   0.01615 _d 0*s )

C -----------------------------------------------------------------------
C pH scale conversion factors and conversions. Everything on total pH scale
           total2free = 1. _d 0/
     &                 (1. _d 0 + st(i,j,bi,bj)/aks(i,j,bi,bj))

           free2total = (1. _d 0 + st(i,j,bi,bj)/aks(i,j,bi,bj))

           free2sw = 1. _d 0
     &                 + (st(i,j,bi,bj)/ aks(i,j,bi,bj))
     &                 + (ft(i,j,bi,bj)/(akf(i,j,bi,bj)*total2free))

           sw2free = 1. _d 0 / free2sw

           total2sw = total2free * free2sw

           sw2total = 1. _d 0 / total2sw

           aphscale(i,j,bi,bj) = 1. _d 0 + st(i,j,bi,bj)/aks(i,j,bi,bj)

      IF ( selectK1K2const.NE.2 .AND. selectK1K2const.NE.4 ) THEN
C Convert to the total pH scale
           ak1(i,j,bi,bj)  = ak1(i,j,bi,bj)*sw2total
           ak2(i,j,bi,bj)  = ak2(i,j,bi,bj)*sw2total
      ENDIF
           ak1p(i,j,bi,bj) = ak1p(i,j,bi,bj)*sw2total
           ak2p(i,j,bi,bj) = ak2p(i,j,bi,bj)*sw2total
           ak3p(i,j,bi,bj) = ak3p(i,j,bi,bj)*sw2total
           aksi(i,j,bi,bj) = aksi(i,j,bi,bj)*sw2total
           akn (i,j,bi,bj) = akn (i,j,bi,bj)*sw2total
           akhs(i,j,bi,bj) = akhs(i,j,bi,bj)*sw2total
           aks (i,j,bi,bj) = aks (i,j,bi,bj)*free2total
      IF ( selectHFconst.EQ.1 ) THEN
           akf (i,j,bi,bj) = akf (i,j,bi,bj)*free2total
      ENDIF
           akw (i,j,bi,bj) = akw (i,j,bi,bj)*sw2total

C -----------------------------------------------------------------------
C       Calculate the stoichiometric solubility product
C       of calcite in seawater
C       References: Mucci (1983)
C       pH scale  : N/A
C       Units     : (mol/kg-SW)^2

           Ksp_TP_Calc(i,j,bi,bj) = 10. _d 0**(-171.9065 _d 0
     &             - 0.077993 _d 0*t_k
     &             + 2839.319 _d 0*inv_t_k + 71.595 _d 0*dlog10_t_k
     &             + ( -0.77712 _d 0 + 0.0028426 _d 0*t_k
     &             + 178.34 _d 0*inv_t_k)*sqrts
     &             - 0.07711 _d 0*s + 0.0041249 _d 0*s_15)

C -----------------------------------------------------------------------
C       Calculate the stoichiometric solubility product
C       of aragonite in seawater
C       References: Mucci (1983)
C       pH scale  : N/A
C       Units     : (mol/kg-SW)^2

           Ksp_TP_Arag(i,j,bi,bj) = 10. _d 0**(-171.945 _d 0
     &             - 0.077993 _d 0*t_k
     &             + 2903.293 _d 0*inv_t_k + 71.595 _d 0*dlog10_t_k
     &             + ( -0.068393 _d 0 + 0.0017276 _d 0*t_k
     &             + 88.135 _d 0*inv_t_k)*sqrts
     &             - 0.10018 _d 0*s + 0.0059415 _d 0*s_15)
         else
           bt(i,j,bi,bj)  = 0. _d 0
           st(i,j,bi,bj)  = 0. _d 0
           ft(i,j,bi,bj)  = 0. _d 0
           cat(i,j,bi,bj) = 0. _d 0
           fugf(i,j,bi,bj)= 0. _d 0
           ff(i,j,bi,bj)  = 0. _d 0
           ak0(i,j,bi,bj) = 0. _d 0
           ak1(i,j,bi,bj) = 0. _d 0
           ak2(i,j,bi,bj) = 0. _d 0
           akb(i,j,bi,bj) = 0. _d 0
           ak1p(i,j,bi,bj)= 0. _d 0
           ak2p(i,j,bi,bj)= 0. _d 0
           ak3p(i,j,bi,bj)= 0. _d 0
           aksi(i,j,bi,bj)= 0. _d 0
           akw(i,j,bi,bj) = 0. _d 0
           aks(i,j,bi,bj) = 0. _d 0
           akf(i,j,bi,bj) = 0. _d 0
           akn(i,j,bi,bj) = 0. _d 0
           akhs(i,j,bi,bj)= 0. _d 0
           Ksp_TP_Calc(i,j,bi,bj) = 0. _d 0
           Ksp_TP_Arag(i,j,bi,bj) = 0. _d 0
           aphscale(i,j,bi,bj)    = 0. _d 0
         endif
         end do
        end do
#endif /* CARBONCHEM_SOLVESAPHE */
      RETURN
      END
C     END SUBROUTINE DIC_COEFFS_SURF
C -----------------------------------------------------------------------

C -----------------------------------------------------------------------
      SUBROUTINE DIC_COEFFS_DEEP(
     &                   ttemp,stemp,
     &                   bi,bj,iMin,iMax,jMin,jMax,
     &                   Klevel,myThid)

C     Add depth dependence to carbon chemistry coefficients loaded into
C     common block. Corrections occur on the Seawater pH scale and are
C     converted back to the total scale
      IMPLICIT NONE

C     MITgcm GLobal variables
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "DIC_VARS.h"

      _RL  ttemp(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL  stemp(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER bi,bj,iMin,iMax,jMin,jMax,Klevel,myThid

#ifdef CARBONCHEM_SOLVESAPHE
C LOCAL VARIABLES
      INTEGER i, j, k
      _RL  bdepth
      _RL  cdepth
      _RL  pressc
      _RL t
      _RL s
      _RL zds
      _RL t_k
      _RL t_k_o_100
      _RL t_k_o_100_2
      _RL dlog_t_k
      _RL sqrtis
      _RL sqrts
      _RL s_2
      _RL s_15
      _RL inv_t_k
      _RL ion_st
      _RL is_2
      _RL scl
      _RL zrt
      _RL B1
      _RL B
      _RL delta
      _RL Pzatm
      _RL zdvi
      _RL zdki
      _RL pfac
C pH scale converstions
      _RL total2free_surf
      _RL free2sw_surf
      _RL total2sw_surf
      _RL total2free
      _RL free2total
      _RL free2sw
      _RL sw2free
      _RL total2sw
      _RL sw2total

c determine pressure (bar) from depth
c 1 BAR at z=0m (atmos pressure)
c use UPPER surface of cell so top layer pressure = 0 bar
c for surface exchange coeffs

cmick..............................
c        write(6,*)'Klevel ',klevel

        bdepth = 0. _d 0
        cdepth = 0. _d 0
        pressc = 1. _d 0
        do k = 1,Klevel
            cdepth = bdepth + 0.5 _d 0*drF(k)
            bdepth = bdepth + drF(k)
            pressc = 1. _d 0 + 0.1 _d 0*cdepth
        end do
cmick...................................................
c        write(6,*)'depth,pressc ',cdepth,pressc
cmick....................................................

        do i=imin,imax
         do j=jmin,jmax
          if (hFacC(i,j,Klevel,bi,bj).gt.0. _d 0) then
           t = ttemp(i,j)
           s = stemp(i,j)
C terms used more than once for:
C temperature
           t_k = 273.15 _d 0 + t
           zrt= 83.14472 _d 0 * t_k
           t_k_o_100 = t_k/100. _d 0
           t_k_o_100_2=t_k_o_100*t_k_o_100
           inv_t_k=1.0 _d 0/t_k
           dlog_t_k=log(t_k)
C ionic strength
           ion_st=19.924 _d 0*s/(1000. _d 0-1.005 _d 0*s)
           is_2=ion_st*ion_st
           sqrtis=sqrt(ion_st)
C salinity
           s_2=s*s
           sqrts=sqrt(s)
           s_15=s**1.5 _d 0
           scl=s/1.80655 _d 0
           zds = s - 34.8 _d 0

           total2free_surf = 1. _d 0/
     &                 (1. _d 0 + st(i,j,bi,bj)/aks(i,j,bi,bj))

           free2sw_surf = 1. _d 0
     &                 + st(i,j,bi,bj)/ aks(i,j,bi,bj)
     &                 + ft(i,j,bi,bj)/(akf(i,j,bi,bj)*total2free_surf)

           total2sw_surf = total2free_surf * free2sw_surf

C------------------------------------------------------------------------
C       Recalculate Fugacity Factor needed for non-ideality in ocean
C       with pressure dependence.
C       Reference : Weiss (1974) Marine Chemistry
C       pH scale  : N/A
           Pzatm = 1.01325 _d 0+pressc ! bars
           delta = (57.7 _d 0 - 0.118 _d 0*t_k)
           B1 = -1636.75 _d 0 + 12.0408 _d 0*t_k -0.0327957 _d 0*t_k*t_k
           B  = B1 + 3.16528 _d 0*t_k*t_k*t_k*(0.00001 _d 0)
C   "x2" term often neglected (assumed=1) in applications of Weiss's (1974) eq.9
C    x2 = 1 - x1 = 1 - xCO2 (it is very close to 1, but not quite)
           fugf(i,j,bi,bj) = exp( (B+2. _d 0*delta) * Pzatm / zrt)

C -----------------------------------------------------------------------
C       Apply pressure dependence to the dissociation constant of hydrogen
C       sulfate (bisulfate).  Ref: Millero (1995) for pressure correction
           zdvi         =  -18.03 _d 0 + t*(0.0466 _d 0 + t*0.316 _d -3)
           zdki         = ( -4.53 _d 0 + t*0.0900 _d 0)*1. _d -3
           pfac = (-zdvi + zdki*pressc/2. _d 0)*pressc/zrt
           aks(i,j,bi,bj) = total2free_surf*aks(i,j,bi,bj) * exp(pfac)

           total2free = 1. _d 0/
     &                 (1. _d 0 + st(i,j,bi,bj)/aks(i,j,bi,bj))

           free2total = (1. _d 0 + st(i,j,bi,bj)/aks(i,j,bi,bj))

C free2sw has an additional component from fluoride
           free2sw    = 1. _d 0
     &                 + st(i,j,bi,bj)/ aks(i,j,bi,bj)

           aks(i,j,bi,bj) = aks(i,j,bi,bj)*free2total

C -----------------------------------------------------------------------
C       Apply pressure dependence to dissociation constant for hydrogen fluoride
C       References: Millero (1995) for pressure correction
           zdvi   =   -9.78 _d 0 + t*(-0.0090 _d 0 - t*0.942 _d -3)
           zdki   = ( -3.91 _d 0 + t*0.054 _d 0)*1. _d -3
           pfac   = (-zdvi + zdki*pressc/2. _d 0)*pressc/zrt
           akf(i,j,bi,bj) = total2free_surf*akf(i,j,bi,bj) * exp(pfac)

C free2sw has an additional component from fluoride add it here
           free2sw = free2sw
     &               + ft(i,j,bi,bj)/akf(i,j,bi,bj)

           sw2free = 1. _d 0 / free2sw

           total2sw = total2free * free2sw

           sw2total = 1. _d 0 / total2sw

           akf(i,j,bi,bj) = akf(i,j,bi,bj)*free2total

C -----------------------------------------------------------------------
C       Apply pressure dependence to 1rst dissociation constant of carbonic acid
C       References: Millero (1982) pressure correction
           zdvi =  -25.50 _d 0 -0.151 _d 0*zds + 0.1271 _d 0*t
           zdki = ( -3.08 _d 0 -0.578 _d 0*zds + 0.0877 _d 0*t)*1. _d -3
           pfac = (-zdvi + zdki*pressc/2. _d 0)*pressc/zrt
           ak1(i,j,bi,bj) = (total2sw_surf*ak1(i,j,bi,bj)
     &                      * exp(pfac))*sw2total

C -----------------------------------------------------------------------
C       Apply pressure dependence to 2nd dissociation constant of carbonic acid
C       References: Millero (1979) pressure correction
           zdvi = -15.82 _d 0 + 0.321 _d 0*zds - 0.0219 _d 0*t
           zdki = ( 1.13 _d 0 - 0.314 _d 0*zds - 0.1475 _d 0*t)*1. _d -3
           pfac = (-zdvi + zdki*pressc/2. _d 0)*pressc/zrt
           ak2(i,j,bi,bj) = (total2sw_surf*ak2(i,j,bi,bj)
     &                      * exp(pfac))*sw2total

C -----------------------------------------------------------------------
C       Apply pressure dependence to the boric acid dissociation constant KB
C       References: Millero (1979) pressure correction
           zdvi      = -29.48 _d 0 + 0.295 _d 0*zds + 0.1622 _d 0*t
     &                 - 0.002608 _d 0*t*t
           zdki      = (-2.84 _d 0 + 0.354 _d 0*zds)*1. _d -3
           pfac =  (-zdvi + zdki*pressc/2. _d 0)*pressc/zrt
           akb(i,j,bi,bj) = (total2sw_surf*akb(i,j,bi,bj)
     &                      * exp(pfac))*sw2total

C -----------------------------------------------------------------------
C       Apply pressure dependence to water dissociation constant Kw in
C       (mol/kg-SW)^2. Ref.: Millero (pers. comm. 1996) for pressure correction
           zdvi    =  -20.02 _d 0 + 0.1119 _d 0*t - 0.1409 _d -2*t*t
           zdki    = ( -5.13 _d 0 + 0.0794 _d 0*t)*1. _d -3
           pfac = (-zdvi + zdki*pressc/2. _d 0)*pressc/zrt
           akw(i,j,bi,bj) = (total2sw_surf*akw(i,j,bi,bj)
     &                      * exp(pfac))*sw2total

C -----------------------------------------------------------------------
C       Apply pressure dependence to the first dissociation constant
C       of phosphoric acid (H3PO4) in seawater
C       References: Millero (1995) for pressure correction
           zdvi      =  -14.51 _d 0 + 0.1211 _d 0*t - 0.321 _d -3*t*t
           zdki      = ( -2.67 _d 0 + 0.0427 _d 0*t)*1. _d -3
           pfac = (-zdvi + zdki*pressc/2. _d 0)*pressc/zrt
           ak1p(i,j,bi,bj) = (total2sw_surf*ak1p(i,j,bi,bj)
     &                       * exp(pfac))*sw2total

C -----------------------------------------------------------------------
C       Apply pressure dependence to the second dissociation constant
C       of phosphoric acid (H3PO4) in seawater
C       References: Millero (1995) for pressure correction
           zdvi       =  -23.12 _d 0 + 0.1758 _d 0*t -2.647 _d -3*t*t
           zdki       = ( -5.15 _d 0 +   0.09 _d 0*t)*1. _d -3
           pfac = (-zdvi + zdki*pressc/2. _d 0)*pressc/zrt
           ak2p(i,j,bi,bj) = (total2sw_surf*ak2p(i,j,bi,bj)
     &                       * exp(pfac))*sw2total

C -----------------------------------------------------------------------
C       Apply pressure dependence to the third dissociation constant
C       of phosphoric acid (H3PO4) in seawater
C       References: Millero (1995) for pressure correction
           zdvi      =  -26.57 _d 0 + 0.2020 _d 0*t -3.042 _d -3*t*t
           zdki      = ( -4.08 _d 0 + 0.0714 _d 0*t)*1. _d -3
           pfac = (-zdvi + zdki*pressc/2. _d 0)*pressc/zrt
           ak3p(i,j,bi,bj) = (total2sw_surf*ak3p(i,j,bi,bj)
     &                       * exp(pfac))*sw2total

C -----------------------------------------------------------------------
C       Apply pressure dependence to the first dissociation constant
C       of silicic acid (H4SiO4) in seawater
C       References: Millero (1979) pressure correction. Note: Pressure
C        correction estimated to be the same as borate (Millero, 1995)
           zdvi      = -29.48 _d 0 + 0.295 _d 0*zds + 0.1622 _d 0*t
     &                 - 0.002608 _d 0*t*t
           zdki      = (-2.84 _d 0 + 0.354 _d 0*zds)*1. _d -3
           pfac =  (-zdvi + zdki*pressc/2. _d 0)*pressc/zrt
           aksi(i,j,bi,bj) = (total2sw_surf*aksi(i,j,bi,bj)
     &                       * exp(pfac))*sw2total

C -----------------------------------------------------------------------
C       Apply pressure dependence to the dissociation constant of hydrogen
C       sulfide in sea-water
C       References: Millero (1995) for pressure correction
           zdvi         =  -14.80 _d 0 + t*(0.0020 _d 0 - t*0.400 _d -3)
           zdki         = (  2.89 _d 0 + t*0.054 _d 0)*1. _d -3
           pfac  = (-zdvi + zdki*pressc/2. _d 0)*pressc/zrt
           akhs(i,j,bi,bj) = (total2sw_surf*akhs(i,j,bi,bj)
     &                       * exp(pfac))*sw2total

C -----------------------------------------------------------------------
C       Apply pressure dependence to the dissociation constant
C       of ammonium in sea-water [mol/kg-SW]
C       References: Millero (1995) for pressure correction
           zdvi         =  -26.43 _d 0 + t*(0.0889 _d 0 - t*0.905 _d -3)
           zdki         = ( -5.03 _d 0 + t*0.0814 _d 0)*1. _d -3
           pfac  = (-zdvi + zdki*pressc/2. _d 0)*pressc/zrt
           akn(i,j,bi,bj) = (total2sw_surf*akn(i,j,bi,bj)
     &                      * exp(pfac))*sw2total

C -----------------------------------------------------------------------
C       Apply pressure dependence to the stoichiometric solubility product
C       of calcite in seawater
C       References: Millero (1995) for pressure correction
           zdvi      =  -48.76 _d 0 + 0.5304 _d 0*t
           zdki      = (-11.76 _d 0 + 0.3692 _d 0*t)*1. _d -3
           pfac = (-zdvi + zdki*pressc/2. _d 0)*pressc/zrt
           Ksp_TP_Calc(i,j,bi,bj) = Ksp_TP_Calc(i,j,bi,bj) * exp(pfac)

C -----------------------------------------------------------------------
C       Apply pressure dependence to the stoichiometric solubility product
C       of aragonite in seawater
C       References: Millero (1979) for pressure correction
           zdvi      =  -48.76 _d 0 + 0.5304 _d 0*t  + 2.8 _d 0
           zdki      = (-11.76 _d 0 + 0.3692 _d 0*t)*1. _d -3
           pfac = (-zdvi + zdki*pressc/2. _d 0)*pressc/zrt
           Ksp_TP_Arag(i,j,bi,bj) = Ksp_TP_Arag(i,j,bi,bj) * exp(pfac)
         else
           bt(i,j,bi,bj)  = 0. _d 0
           st(i,j,bi,bj)  = 0. _d 0
           ft(i,j,bi,bj)  = 0. _d 0
           cat(i,j,bi,bj) = 0. _d 0
           fugf(i,j,bi,bj)= 0. _d 0
           ff(i,j,bi,bj)  = 0. _d 0
           ak0(i,j,bi,bj) = 0. _d 0
           ak1(i,j,bi,bj) = 0. _d 0
           ak2(i,j,bi,bj) = 0. _d 0
           akb(i,j,bi,bj) = 0. _d 0
           ak1p(i,j,bi,bj)= 0. _d 0
           ak2p(i,j,bi,bj)= 0. _d 0
           ak3p(i,j,bi,bj)= 0. _d 0
           aksi(i,j,bi,bj)= 0. _d 0
           akw(i,j,bi,bj) = 0. _d 0
           aks(i,j,bi,bj) = 0. _d 0
           akf(i,j,bi,bj) = 0. _d 0
           akn(i,j,bi,bj) = 0. _d 0
           akhs(i,j,bi,bj)= 0. _d 0
           Ksp_TP_Calc(i,j,bi,bj) = 0. _d 0
           Ksp_TP_Arag(i,j,bi,bj) = 0. _d 0
           aphscale(i,j,bi,bj)    = 0. _d 0
         endif
       enddo
      enddo
#endif /* CARBONCHEM_SOLVESAPHE */

      RETURN
      END
C     END SUBROUTINE DIC_COEFFS_DEEP
C      =========================================================================

C      =========================================================================
      SUBROUTINE EQUATION_AT(p_alktot, p_h,      p_dictot,
     &                       p_bortot, p_po4tot, p_siltot,
     &                       p_nh4tot, p_h2stot, p_so4tot,
     &                       p_flutot, p_eqn   , p_deriveqn,
     &                       i, j, k, bi, bj, myIter,
     &                       myThid )

      IMPLICIT NONE

C     MITgcm GLobal variables
#include "SIZE.h"
#include "EEPARAMS.h"
#include "DIC_VARS.h"

C      --------------------
C      Argument variables
C      --------------------

      _RL p_alktot
      _RL p_h
      _RL p_dictot
      _RL p_bortot
      _RL p_po4tot
      _RL p_siltot
      _RL p_nh4tot
      _RL p_h2stot
      _RL p_so4tot
      _RL p_flutot
      _RL p_deriveqn
      _RL p_eqn
      INTEGER i,j,k,bi,bj,myIter,myThid

#ifdef CARBONCHEM_SOLVESAPHE

C      -----------------
C      Local variables
C      -----------------

      _RL znumer_dic, zdnumer_dic, zdenom_dic, zalk_dic, zdalk_dic
      _RL znumer_bor, zdnumer_bor, zdenom_bor, zalk_bor, zdalk_bor
      _RL znumer_po4, zdnumer_po4, zdenom_po4, zalk_po4, zdalk_po4
      _RL znumer_sil, zdnumer_sil, zdenom_sil, zalk_sil, zdalk_sil
      _RL znumer_nh4, zdnumer_nh4, zdenom_nh4, zalk_nh4, zdalk_nh4
      _RL znumer_h2s, zdnumer_h2s, zdenom_h2s, zalk_h2s, zdalk_h2s
      _RL znumer_so4, zdnumer_so4, zdenom_so4, zalk_so4, zdalk_so4
      _RL znumer_flu, zdnumer_flu, zdenom_flu, zalk_flu, zdalk_flu
      _RL                                      zalk_wat

C      H2CO3 - HCO3 - CO3 : n=2, m=0
      znumer_dic = 2. _d 0*ak1(i,j,bi,bj)*ak2(i,j,bi,bj)
     &             + p_h*  ak1(i,j,bi,bj)
      zdenom_dic =      ak1(i,j,bi,bj)*ak2(i,j,bi,bj)
     &             + p_h*(ak1(i,j,bi,bj) + p_h)
      zalk_dic   = p_dictot * (znumer_dic/zdenom_dic)

C      B(OH)3 - B(OH)4 : n=1, m=0
      znumer_bor =      akb(i,j,bi,bj)
      zdenom_bor =      akb(i,j,bi,bj) + p_h
      zalk_bor   = p_bortot * (znumer_bor/zdenom_bor)

C      H3PO4 - H2PO4 - HPO4 - PO4 : n=3, m=1
      znumer_po4 =
     &        3. _d 0*ak1p(i,j,bi,bj)*ak2p(i,j,bi,bj)*ak3p(i,j,bi,bj)
     &      + p_h*(2. _d 0*ak1p(i,j,bi,bj)*ak2p(i,j,bi,bj)
     &               + p_h*ak1p(i,j,bi,bj))
      zdenom_po4 =    ak1p(i,j,bi,bj)*ak2p(i,j,bi,bj)*ak3p(i,j,bi,bj)
     &           + p_h*(ak1p(i,j,bi,bj)*ak2p(i,j,bi,bj)
     &           + p_h*(ak1p(i,j,bi,bj) + p_h))
      zalk_po4   = p_po4tot * (znumer_po4/zdenom_po4 - 1. _d 0)
C       Zero level of H3PO4 = 1

C      H4SiO4 - H3SiO4 : n=1, m=0
      znumer_sil =      aksi(i,j,bi,bj)
      zdenom_sil =      aksi(i,j,bi,bj) + p_h
      zalk_sil   = p_siltot * (znumer_sil/zdenom_sil)

C      NH4 - NH3 : n=1, m=0
      znumer_nh4 =      akn(i,j,bi,bj)
      zdenom_nh4 =      akn(i,j,bi,bj) + p_h
      zalk_nh4   = p_nh4tot * (znumer_nh4/zdenom_nh4)

C      H2S - HS : n=1, m=0
      znumer_h2s =      akhs(i,j,bi,bj)
      zdenom_h2s =      akhs(i,j,bi,bj) + p_h
      zalk_h2s   = p_h2stot * (znumer_h2s/zdenom_h2s)

C      HSO4 - SO4 : n=1, m=1
      znumer_so4 =      aks(i,j,bi,bj)
      zdenom_so4 =      aks(i,j,bi,bj) + p_h
      zalk_so4   = p_so4tot * (znumer_so4/zdenom_so4 - 1. _d 0)

C      HF - F : n=1, m=1
      znumer_flu =      akf(i,j,bi,bj)
      zdenom_flu =      akf(i,j,bi,bj) + p_h
      zalk_flu   = p_flutot * (znumer_flu/zdenom_flu - 1. _d 0)

C      H2O - OH
      zalk_wat   = akw(i,j,bi,bj)/p_h - p_h/aphscale(i,j,bi,bj)

C      EQUATION_AT =    zalk_dic + zalk_bor + zalk_po4 + zalk_sil &
C              + zalk_nh4 + zalk_h2s + zalk_so4 + zalk_flu &
C                  + zalk_wat - p_alktot
      p_eqn =   zalk_dic + zalk_bor + zalk_po4 + zalk_sil
     &         + zalk_nh4 + zalk_h2s + zalk_so4 + zalk_flu
     &         + zalk_wat - p_alktot

C      IF(PRESENT(p_deriveqn)) THEN

C      H2CO3 - HCO3 - CO3 : n=2
        zdnumer_dic = ak1(i,j,bi,bj)*ak1(i,j,bi,bj)*ak2(i,j,bi,bj)
     &                + p_h*(4. _d 0*ak1(i,j,bi,bj)*ak2(i,j,bi,bj)
     &                               + p_h*      ak1(i,j,bi,bj))
        zdalk_dic   = -p_dictot*(zdnumer_dic/zdenom_dic**2)

C      B(OH)3 - B(OH)4 : n=1
        zdnumer_bor = akb(i,j,bi,bj)
        zdalk_bor   = -p_bortot*(zdnumer_bor/zdenom_bor**2)

C      H3PO4 - H2PO4 - HPO4 - PO4 : n=3
        zdnumer_po4 = ak1p(i,j,bi,bj)*ak2p(i,j,bi,bj)
     &               *ak1p(i,j,bi,bj)*ak2p(i,j,bi,bj)
     &               *ak3p(i,j,bi,bj)
     & + p_h*(4. _d 0*ak1p(i,j,bi,bj)*ak1p(i,j,bi,bj)*ak2p(i,j,bi,bj)
     &               *ak3p(i,j,bi,bj)
     & + p_h*(9. _d 0*ak1p(i,j,bi,bj)*ak2p(i,j,bi,bj)*ak3p(i,j,bi,bj)
     &              + ak1p(i,j,bi,bj)*ak1p(i,j,bi,bj)*ak2p(i,j,bi,bj)
     & + p_h*(4. _d 0*ak1p(i,j,bi,bj)*ak2p(i,j,bi,bj)
     & + p_h*         ak1p(i,j,bi,bj))))
        zdalk_po4   = -p_po4tot * (zdnumer_po4/zdenom_po4**2)

C      H4SiO4 - H3SiO4 : n=1
        zdnumer_sil = aksi(i,j,bi,bj)
        zdalk_sil   = -p_siltot * (zdnumer_sil/zdenom_sil**2)

C      NH4 - NH3 : n=1
        zdnumer_nh4 = akn(i,j,bi,bj)
        zdalk_nh4   = -p_nh4tot * (zdnumer_nh4/zdenom_nh4**2)

C      H2S - HS : n=1
        zdnumer_h2s = akhs(i,j,bi,bj)
        zdalk_h2s   = -p_h2stot * (zdnumer_h2s/zdenom_h2s**2)

C      HSO4 - SO4 : n=1
        zdnumer_so4 = aks(i,j,bi,bj)
        zdalk_so4   = -p_so4tot * (zdnumer_so4/zdenom_so4**2)

C      HF - F : n=1
        zdnumer_flu = akf(i,j,bi,bj)
        zdalk_flu   = -p_flutot * (zdnumer_flu/zdenom_flu**2)

        p_deriveqn = zdalk_dic + zdalk_bor + zdalk_po4 + zdalk_sil
     &             + zdalk_nh4 + zdalk_h2s + zdalk_so4 + zdalk_flu
     &             - akw(i,j,bi,bj)/p_h**2 - 1. _d 0/aphscale(i,j,bi,bj)
C      ENDIF

#endif /* CARBONCHEM_SOLVESAPHE */
      RETURN
      END
C     END SUBROUTINE EQUATION_AT
C      =========================================================================

C      =========================================================================
      SUBROUTINE SOLVE_AT_FAST(p_alktot, p_dictot, p_bortot,
     &                         p_po4tot, p_siltot, p_nh4tot,
     &                         p_h2stot, p_so4tot, p_flutot,
     &                         p_hini,   p_val,    p_hnew,
     &                         i, j, k, bi, bj,
     &                         debugPrt, myIter, myThid )
C      =========================================================================
C      Fast version of SOLVE_AT_GENERAL, without any bounds checking.

      IMPLICIT NONE

C     MITgcm GLobal variables
#include "SIZE.h"
#include "EEPARAMS.h"
#include "DIC_VARS.h"

C     _RL SOLVE_AT_FAST

C     --------------------
C     Argument variables
C     --------------------

      _RL p_alktot
      _RL p_dictot
      _RL p_bortot
      _RL p_po4tot
      _RL p_siltot
      _RL p_nh4tot
      _RL p_h2stot
      _RL p_so4tot
      _RL p_flutot
      _RL p_hini
      _RL p_val
      _RL p_hnew
      INTEGER i, j, k, bi, bj
      LOGICAL debugPrt
      INTEGER myIter, myThid

#ifdef CARBONCHEM_SOLVESAPHE

C     --------------------
C     Local variables
C     --------------------

      _RL zh_ini, zh, zh_prev, zh_lnfactor
      _RL zhdelta
      _RL zeqn, zdeqndh

C     LOGICAL l_exitnow
      LOGICAL iterate4pH
      _RL pz_exp_threshold
      _RL pp_rdel_ah_target
      INTEGER niter_atfast

      pp_rdel_ah_target = 1. _d -8
      pz_exp_threshold = 1.0 _d 0
C      =========================================================================

C     IF(PRESENT(p_hini)) THEN
      zh_ini = p_hini
C     ELSE
C     #if defined(DEBUG_PHSOLVERS)
C        PRINT*, '[SOLVE_AT_FAST] Calling AHINI_FOR_AT for h_ini'
C     #endif
C
C        CALL AHINI_FOR_AT(p_alktot, p_dictot, p_bortot, zh_ini)
C
C     #if defined(DEBUG_PHSOLVERS)
C        PRINT*, '[SOLVE_AT_FAST] h_ini :', zh_ini
C     #endif
C     ENDIF

      zh = zh_ini
C Reset counters of iterations
      niter_atfast    = 0

      iterate4pH = .TRUE.
      DO WHILE ( iterate4pH )

       niter_atfast = niter_atfast + 1
       IF ( niter_atfast .GT. at_maxniter ) THEN
         zh = -1. _d 0
         iterate4pH = .FALSE.
       ELSE

         zh_prev = zh

C        zeqn = EQUATION_AT(p_alktot, zh,       p_dictot, p_bortot,
C     &                      p_po4tot, p_siltot, p_nh4tot, p_h2stot,
C     &                      p_so4tot, p_flutot, P_DERIVEQN = zdeqndh)

        CALL EQUATION_AT( p_alktot, zh      , p_dictot, p_bortot,
     &                    p_po4tot, p_siltot, p_nh4tot, p_h2stot,
     &                    p_so4tot, p_flutot,
     &                    zeqn    , zdeqndh,
     &                    i, j, k, bi, bj, myIter, myThid )
C zh is the root
        iterate4pH = ( zeqn .NE. 0. _d 0 )
       ENDIF

       IF ( iterate4pH ) THEN
        zh_lnfactor = -zeqn/(zdeqndh*zh_prev)
        IF(ABS(zh_lnfactor) .GT. pz_exp_threshold) THEN
           zh          = zh_prev*EXP(zh_lnfactor)
        ELSE
           zhdelta     = zh_lnfactor*zh_prev
           zh          = zh_prev + zhdelta
        ENDIF

C     #if defined(DEBUG_PHSOLVERS)
C        PRINT*, '[SOLVE_AT_FAST] testing zh :', zh, zeqn, zh_lnfactor
C     #endif
C
C      ! Stop iterations once |\delta{[H]}/[H]| < rdel
C      ! <=> |(zh - zh_prev)/zh_prev| = |EXP(-zeqn/(zdeqndh*zh_prev)) -1| < rdel
C      ! |EXP(-zeqn/(zdeqndh*zh_prev)) -1| ~ |zeqn/(zdeqndh*zh_prev)|
C
C      ! Alternatively:
C      ! |\Delta pH| = |zeqn/(zdeqndh*zh_prev*LOG(10))|
C      !             ~ 1/LOG(10) * |\Delta [H]|/[H]
C      !             < 1/LOG(10) * rdel
C
C      ! Hence |zeqn/(zdeqndh*zh)| < rdel
C
C      ! rdel <- pp_rdel_ah_target

C        l_exitnow = (ABS(zh_lnfactor) < pp_rdel_ah_target)
C        IF(l_exitnow) EXIT
        iterate4pH = ( ABS(zh_lnfactor) .GE. pp_rdel_ah_target )

       ENDIF
      ENDDO

C     SOLVE_AT_FAST = zh
      p_hnew = zh

C     IF(PRESENT(p_val)) THEN
        IF(zh .GT. 0. _d 0) THEN
C           p_val = EQUATION_AT(p_alktot, zh,       p_dictot, p_bortot,
C     &                          p_po4tot, p_siltot, p_nh4tot, p_h2stot,
C     &                          p_so4tot, p_flutot)
           CALL EQUATION_AT( p_alktot, zh,       p_dictot, p_bortot,
     &                       p_po4tot, p_siltot, p_nh4tot, p_h2stot,
     &                       p_so4tot, p_flutot,
     &                       p_val   , zdeqndh,
     &                       i, j, k, bi, bj, myIter, myThid )
        ELSE
c          p_val = HUGE(1. _d 0)
           p_val = 1. _d +65
        ENDIF
C     ENDIF

#endif /* CARBONCHEM_SOLVESAPHE */
      RETURN
      END
C END FUNCTION SOLVE_AT_FAST
C      =========================================================================

C      =========================================================================
      SUBROUTINE SOLVE_AT_GENERAL(p_alktot, p_dictot, p_bortot,
     &                         p_po4tot, p_siltot, p_nh4tot,
     &                         p_h2stot, p_so4tot, p_flutot,
     &                         p_hini,   p_val,    p_hnew,
     &                         i, j, k, bi, bj,
     &                         debugPrt, myIter, myThid )
C      Universal pH solver that converges from any given initial value,
C      determines upper an lower bounds for the solution if required

      IMPLICIT NONE

C     MITgcm GLobal variables
#include "SIZE.h"
#include "EEPARAMS.h"
#include "DIC_VARS.h"

C      _RL SOLVE_AT_GENERAL

C     --------------------
C     Argument variables
C     --------------------

       _RL p_alktot
       _RL p_dictot
       _RL p_bortot
       _RL p_po4tot
       _RL p_siltot
       _RL p_nh4tot
       _RL p_h2stot
       _RL p_so4tot
       _RL p_flutot
       _RL p_hini
       _RL p_hnew
       _RL p_val
      INTEGER i, j, k, bi, bj
      LOGICAL debugPrt
      INTEGER myIter, myThid

#ifdef CARBONCHEM_SOLVESAPHE

C     -----------------
C     Local variables
C     -----------------

      _RL zh_ini, zh, zh_prev, zh_lnfactor
      _RL p_alknw_inf, p_alknw_sup
      _RL zh_min, zh_max
      _RL zdelta, zh_delta
      _RL zeqn, zdeqndh, zeqn_absmin
      INTEGER niter_atgen

C      LOGICAL       :: l_exitnow
      LOGICAL iterate4pH
      _RL pz_exp_threshold
      _RL pp_rdel_ah_target

      pp_rdel_ah_target = 1. _d -8
      pz_exp_threshold = 1. _d 0

C      IF(PRESENT(p_hini)) THEN
        zh_ini = p_hini
C      ELSE
C#if defined(DEBUG_PHSOLVERS)
C        PRINT*, '[SOLVE_AT_GENERAL] Calling AHINI_FOR_AT for h_ini'
C#endif
C        CALL AHINI_FOR_AT(p_alktot, p_dictot, p_bortot, zh_ini)
C#if defined(DEBUG_PHSOLVERS)
C        PRINT*, '[SOLVE_AT_GENERAL] h_ini :', zh_ini
C#endif
C      ENDIF
#ifdef ALLOW_DEBUG
      IF (debugPrt) CALL DEBUG_CALL('ANW_INFSUP',myThid)
#endif
      CALL ANW_INFSUP(p_dictot, p_bortot,
     &                p_po4tot, p_siltot,  p_nh4tot, p_h2stot,
     &                p_so4tot, p_flutot,
     &                p_alknw_inf, p_alknw_sup,
     &                i, j, k, bi, bj, myIter, myThid )

      zdelta = (p_alktot-p_alknw_inf)**2 + 4. _d 0*akw(i,j,bi,bj)
     &         /aphscale(i,j,bi,bj)

      IF(p_alktot .GE. p_alknw_inf) THEN
        zh_min = 2. _d 0*akw(i,j,bi,bj) /( p_alktot-p_alknw_inf
     &           + SQRT(zdelta) )
      ELSE
        zh_min = aphscale(i,j,bi,bj)*(-(p_alktot-p_alknw_inf)
     &           + SQRT(zdelta) ) / 2. _d 0
      ENDIF

      zdelta = (p_alktot-p_alknw_sup)**2 + 4. _d 0*akw(i,j,bi,bj)
     &         /aphscale(i,j,bi,bj)

      IF(p_alktot .LE. p_alknw_sup) THEN
        zh_max = aphscale(i,j,bi,bj)*(-(p_alktot-p_alknw_sup)
     &           + SQRT(zdelta) ) / 2. _d 0
      ELSE
        zh_max = 2. _d 0*akw(i,j,bi,bj) /( p_alktot-p_alknw_sup
     &           + SQRT(zdelta) )
      ENDIF

C#if defined(DEBUG_PHSOLVERS)
C           PRINT*, '[SOLVE_AT_GENERAL] h_min :', zh_min
C           PRINT*, '[SOLVE_AT_GENERAL] h_max :', zh_max
C#endif

      zh = MAX(MIN(zh_max, zh_ini), zh_min)
C     Uncomment this line for the "safe" initialisation test
C      zh = SQRT(zh_max*zh_min)

C     Reset counters of iterations
      niter_atgen       = 0
c     zeqn_absmin       = HUGE(1. _d 0)
      zeqn_absmin       = 1. _d +65

      iterate4pH = .TRUE.
      DO WHILE ( iterate4pH )

       IF ( niter_atgen .GE. at_maxniter ) THEN
           zh = -1. _d 0
           iterate4pH = .FALSE.
       ELSE

        zh_prev = zh
#ifdef ALLOW_DEBUG
        IF (debugPrt) CALL DEBUG_CALL('EQUATION_AT',myThid)
#endif
C        zeqn = EQUATION_AT(p_alktot, zh,      p_dictot, p_bortot,
C     &                   p_po4tot, p_siltot, p_nh4tot, p_h2stot,
C     &                   p_so4tot, p_flutot, P_DERIVEQN = zdeqndh)
        CALL EQUATION_AT( p_alktot, zh,       p_dictot, p_bortot,
     &                    p_po4tot, p_siltot, p_nh4tot, p_h2stot,
     &                    p_so4tot, p_flutot,
     &                    zeqn   , zdeqndh,
     &                    i, j, k, bi, bj, myIter, myThid )

C         Adapt bracketing interval
        IF(zeqn .GT. 0. _d 0) THEN
           zh_min = zh_prev
        ELSEIF(zeqn .LT. 0. _d 0) THEN
           zh_max = zh_prev
        ELSE
C          zh is the root; unlikely but, one never knows
           iterate4pH = .FALSE.
        ENDIF
       ENDIF

       IF ( iterate4pH ) THEN
C         Now determine the next iterate zh
        niter_atgen = niter_atgen + 1

        IF(ABS(zeqn) .GE. 0.5 _d 0*zeqn_absmin) THEN
C          if the function evaluation at the current point is
C          not decreasing faster than with a bisection step (at least linearly)
C          in absolute value take one bisection step on [ph_min, ph_max]
C          ph_new = (ph_min + ph_max)/2 _d 0
C          In terms of [H]_new:
C            [H]_new = 10**(-ph_new)
C                   = 10**(-(ph_min + ph_max)/2 _d 0)
C                   = SQRT(10**(-(ph_min + phmax)))
C                   = SQRT(zh_max * zh_min)
           zh          = SQRT(zh_max * zh_min)
C Required to test convergence below
           zh_lnfactor = (zh - zh_prev)/zh_prev
        ELSE
C          dzeqn/dpH = dzeqn/d[H] * d[H]/dpH
C                   = -zdeqndh * LOG(10) * [H]
C          \Delta pH = -zeqn/(zdeqndh*d[H]/dpH) = zeqn/(zdeqndh*[H]*LOG(10))

C          pH_new = pH_old + \deltapH

C          [H]_new = 10**(-pH_new)
C                 = 10**(-pH_old - \Delta pH)
C                 = [H]_old * 10**(-zeqn/(zdeqndh*[H]_old*LOG(10)))
C                 = [H]_old * EXP(-LOG(10)*zeqn/(zdeqndh*[H]_old*LOG(10)))
C                 = [H]_old * EXP(-zeqn/(zdeqndh*[H]_old))
           zh_lnfactor = -zeqn/(zdeqndh*zh_prev)

           IF(ABS(zh_lnfactor) .GT. pz_exp_threshold) THEN
             zh          = zh_prev*EXP(zh_lnfactor)
           ELSE
             zh_delta    = zh_lnfactor*zh_prev
             zh          = zh_prev + zh_delta
           ENDIF

C#if defined(DEBUG_PHSOLVERS)
C           PRINT*, '[SOLVE_AT_GENERAL] testing zh :', zh, zeqn, zh_lnfactor
C#endif

           IF( zh .LT. zh_min ) THEN
C              if [H]_new < [H]_min
C              i.e., if ph_new > ph_max then
C              take one bisection step on [ph_prev, ph_max]
C              ph_new = (ph_prev + ph_max)/2 _d 0
C              In terms of [H]_new:
C              [H]_new = 10**(-ph_new)
C                     = 10**(-(ph_prev + ph_max)/2 _d 0)
C                     = SQRT(10**(-(ph_prev + phmax)))
C                     = SQRT([H]_old*10**(-ph_max))
C                     = SQRT([H]_old * zh_min)
             zh               = SQRT(zh_prev * zh_min)
C Required to test convergence below
             zh_lnfactor      = (zh - zh_prev)/zh_prev
           ENDIF

           IF( zh .GT. zh_max ) THEN
C              if [H]_new > [H]_max
C              i.e., if ph_new < ph_min, then
C              take one bisection step on [ph_min, ph_prev]
C              ph_new = (ph_prev + ph_min)/2 _d 0
C              In terms of [H]_new:
C              [H]_new = 10**(-ph_new)
C                     = 10**(-(ph_prev + ph_min)/2 _d 0)
C                     = SQRT(10**(-(ph_prev + ph_min)))
C                     = SQRT([H]_old*10**(-ph_min))
C                     = SQRT([H]_old * zhmax)
             zh               = SQRT(zh_prev * zh_max)
C Required to test convergence below
             zh_lnfactor      = (zh - zh_prev)/zh_prev

           ENDIF
        ENDIF

        zeqn_absmin = MIN( ABS(zeqn), zeqn_absmin)
C        Stop iterations once |\delta{[H]}/[H]| < rdel
C        <=> |(zh - zh_prev)/zh_prev| = |EXP(-zeqn/(zdeqndh*zh_prev)) -1| < rdel
C        |EXP(-zeqn/(zdeqndh*zh_prev)) -1| ~ |zeqn/(zdeqndh*zh_prev)|
C
C        Alternatively:
C        |\Delta pH| = |zeqn/(zdeqndh*zh_prev*LOG(10))|
C                    ~ 1/LOG(10) * |\Delta [H]|/[H]
C                    < 1/LOG(10) * rdel
C
C        Hence |zeqn/(zdeqndh*zh)| < rdel
C
C        rdel <-- pp_rdel_ah_target
C        l_exitnow = (ABS(zh_lnfactor) < pp_rdel_ah_target)
C        IF(l_exitnow) EXIT
         iterate4pH = ( ABS(zh_lnfactor) .GE. pp_rdel_ah_target )

       ENDIF
      ENDDO

C      SOLVE_AT_GENERAL = zh
      p_hnew = zh

C      IF(PRESENT(p_val)) THEN
C           p_val = EQUATION_AT(p_alktot, zh,      p_dictot, p_bortot,
C     &                       p_po4tot, p_siltot, p_nh4tot, p_h2stot,
C     &                       p_so4tot, p_flutot)
C        ELSE
C           p_val = HUGE(1. _d 0)
C       ENDIF
C      ENDIF
#ifdef ALLOW_DEBUG
      IF (debugPrt) CALL DEBUG_LEAVE('SOLVE_AT_GENERAL',myThid)
#endif
#endif /* CARBONCHEM_SOLVESAPHE */
      RETURN
      END
C      END FUNCTION SOLVE_AT_GENERAL
C      =========================================================================

C      =========================================================================
      SUBROUTINE SOLVE_AT_GENERAL_SEC(p_alktot, p_dictot,
     &                           p_bortot, p_po4tot,
     &                           p_siltot, p_nh4tot,
     &                           p_h2stot, p_so4tot,
     &                           p_flutot, p_hini,
     &                           p_val,    p_hnew,
     &                           i, j, k, bi, bj,
     &                           debugPrt, myIter, myThid )

C      Universal pH solver that converges from any given initial value,
C      determines upper an lower bounds for the solution if required
      IMPLICIT NONE

C     MITgcm GLobal variables
#include "SIZE.h"
#include "EEPARAMS.h"
#include "DIC_VARS.h"

C     --------------------
C     Argument variables
C     --------------------

      _RL p_alktot
      _RL p_dictot
      _RL p_bortot
      _RL p_po4tot
      _RL p_siltot
      _RL p_nh4tot
      _RL p_h2stot
      _RL p_so4tot
      _RL p_flutot
      _RL p_hini
      _RL p_hnew
      _RL p_val
      INTEGER i, j, k, bi, bj
      LOGICAL debugPrt
      INTEGER myIter, myThid

#ifdef CARBONCHEM_SOLVESAPHE

C     -----------------
C     Local variables
C     -----------------

      _RL  zh_ini, zh, zh_1, zh_2, zh_delta
      _RL  p_alknw_inf, p_alknw_sup
      _RL  zh_min, zh_max
      _RL  zeqn, zeqn_1, zeqn_2, zeqn_absmin
      _RL  zdelta, zdeqndh
      _RL pp_rdel_ah_target
      INTEGER niter_atsec
C      LOGICAL       ::  l_exitnow
      LOGICAL iterate4pH

      pp_rdel_ah_target = 1. _d -8

C      IF(PRESENT(p_hini)) THEN
        zh_ini = p_hini
C      ELSE
C#if defined(DEBUG_PHSOLVERS)
C        PRINT*, '[SOLVE_AT_GENERAL_SEC] Calling AHINI_FOR_AT for h_ini'
C#endif
C       CALL AHINI_FOR_AT(p_alktot, p_dictot, p_bortot, zh_ini)
C#if defined(DEBUG_PHSOLVERS)
C        PRINT*, '[SOLVE_AT_GENERAL_SEC] h_ini :', zh_ini
C#endif
C      ENDIF

      CALL ANW_INFSUP(p_dictot, p_bortot,
     &               p_po4tot, p_siltot,  p_nh4tot, p_h2stot,
     &               p_so4tot, p_flutot,
     &               p_alknw_inf, p_alknw_sup,
     &               i, j, k, bi, bj, myIter, myThid )

      zdelta = (p_alktot-p_alknw_inf)**2 + 4. _d 0*akw(i,j,bi,bj)
     &         /aphscale(i,j,bi,bj)

      IF(p_alktot .GE. p_alknw_inf) THEN
        zh_min = 2. _d 0*akw(i,j,bi,bj) /( p_alktot-p_alknw_inf
     &           + SQRT(zdelta) )
      ELSE
        zh_min = aphscale(i,j,bi,bj)*(-(p_alktot-p_alknw_inf)
     &           + SQRT(zdelta) ) / 2. _d 0
      ENDIF

      zdelta = (p_alktot-p_alknw_sup)**2 + 4. _d 0*akw(i,j,bi,bj)
     &         /aphscale(i,j,bi,bj)

      IF(p_alktot .LE. p_alknw_sup) THEN
        zh_max = aphscale(i,j,bi,bj)*(-(p_alktot-p_alknw_sup)
     &           + SQRT(zdelta) ) / 2. _d 0
      ELSE
        zh_max = 2. _d 0*akw(i,j,bi,bj) /( p_alktot-p_alknw_sup
     &           + SQRT(zdelta) )
      ENDIF

C#if defined(DEBUG_PHSOLVERS)
C           PRINT*, '[SOLVE_AT_GENERAL_SEC] h_min :', zh_min
C           PRINT*, '[SOLVE_AT_GENERAL_SEC] h_max :', zh_max
C#endif

C     Uncomment this line for the "safe" initialisation test
      zh = MAX(MIN(zh_max, zh_ini), zh_min)
C      zh = SQRT(zh_max*zh_min)

C      Reset counters of iterations
      niter_atsec       = 0

C      Prepare the secant iterations: two initial (zh, zeqn) pairs are required
C      We have the starting value, that needs to be completed by the evaluation
C      of the equation value it produces.
C      Complete the initial value with its equation evaluation
C      (will take the role of the $n-2$ iterate at the first secant evaluation)

C     zh_2 is the initial value
      zh_2   = zh
C      zeqn_2 = EQUATION_AT(p_alktot, zh_2,     p_dictot, p_bortot,
C     &                   p_po4tot, p_siltot, p_nh4tot, p_h2stot,
C     &                   p_so4tot, p_flutot)
      CALL EQUATION_AT( p_alktot, zh_2,    p_dictot, p_bortot,
     &                  p_po4tot, p_siltot, p_nh4tot, p_h2stot,
     &                  p_so4tot, p_flutot,
     &                  zeqn_2  , zdeqndh,
     &                  i, j, k, bi, bj, myIter, myThid )

      zeqn_absmin       = ABS(zeqn_2)

C      Adapt bracketing interval and heuristically set zh_1

      IF(zeqn_2 .LT. 0. _d 0) THEN
C                 If zeqn_2 < 0, then we adjust zh_max:
C                 we can be sure that zh_min < zh_2 < zh_max.
        zh_max = zh_2
C                 for zh_1, try 25% (0.1 pH units) below the current zh_max,
C                 but stay above SQRT(zh_min*zh_max), which would be equivalent
C                 to a bisection step on [pH@zh_min, pH@zh_max]
        zh_1   = MAX(zh_max/1.25 _d 0, SQRT(zh_min*zh_max))

      ELSEIF(zeqn_2 .GT. 0. _d 0) THEN
C                 If zeqn_2 < 0, then we adjust zh_min:
C                 we can be sure that zh_min < zh_2 < zh_max.
        zh_min = zh_2
C                 for zh_1, try 25% (0.1 pH units) above the current zh_min,
C                 but stay below SQRT(zh_min*zh_max) which would be equivalent
C                 to a bisection step on [pH@zh_min, pH@zh_max]
        zh_1   = MIN(zh_min*1.25 _d 0, SQRT(zh_min*zh_max))

      ELSE
C       we have got the root; unlikely, but one never knows
C        SOLVE_AT_GENERAL_SEC = zh_2
         p_hnew = zh_2
C        IF(PRESENT(p_val)) p_val = zeqn_2
         p_val = zeqn_2
        RETURN
      ENDIF

C      We now have the first pair completed (zh_2, zeqn_2).
C      Define the second one (zh_1, zeqn_1), which is also the first iterate.
C      zh_1 has already been set above

C     Update counter of iterations
      niter_atsec = 1

C      zeqn_1 = EQUATION_AT(p_alktot, zh_1,      p_dictot, p_bortot,
C     &                   p_po4tot, p_siltot, p_nh4tot, p_h2stot,
C     &                   p_so4tot, p_flutot)
      CALL EQUATION_AT( p_alktot, zh_1,     p_dictot, p_bortot,
     &                  p_po4tot, p_siltot, p_nh4tot, p_h2stot,
     &                  p_so4tot, p_flutot,
     &                  zeqn_1  , zdeqndh,
     &                  i, j, k, bi, bj, myIter, myThid )

C      Adapt bracketing interval: we know that zh_1 <= zh <= zh_max (if zeqn_1>0)
C      or zh_min <= zh <= zh_1 (if zeqn_1 < 0), so this can always be done

      IF(zeqn_1 .GT. 0. _d 0) THEN
        zh_min = zh_1
      ELSEIF(zeqn_1 .LT. 0. _d 0) THEN
        zh_max = zh_1
      ELSE
C      zh_1 is the root
C        SOLVE_AT_GENERAL_SEC = zh_1
        p_hnew = zh_1
C        IF(PRESENT(p_val)) p_val = zeqn_1
        p_val = zeqn_1
      ENDIF

      IF(ABS(zeqn_1) .GT. zeqn_absmin) THEN
C     Swap zh_2 and zh_1 if ABS(zeqn_2) < ABS(zeqn_1)
C                 so that zh_2 and zh_1 lead to decreasing equation
C                 values (in absolute value)
        zh     = zh_1
        zeqn   = zeqn_1
        zh_1   = zh_2
        zeqn_1 = zeqn_2
        zh_2   = zh
        zeqn_2 = zeqn
      ELSE
        zeqn_absmin = ABS(zeqn_1)
      ENDIF

C     Pre-calculate the first secant iterate (this is the second iterate)
      niter_atsec = 2

      zh_delta = -zeqn_1/((zeqn_2-zeqn_1)/(zh_2 - zh_1))
      zh = zh_1 + zh_delta

C      Make sure that zh_min < zh < zh_max (if not,
C      bisect around zh_1 which is the best estimate)

      IF (zh .GT. zh_max) THEN
C       This can only happen if zh_2 < zh_1
C                 and zeqn_2 > zeqn_1 > 0
        zh = SQRT(zh_1*zh_max)
      ENDIF

      IF (zh .LT. zh_min) THEN
C       This can only happen if zh_2 > zh_1
C                and zeqn_2 < zeqn_1 < 0
        zh = SQRT(zh_1*zh_min)
      ENDIF

      iterate4pH = .TRUE.
      DO WHILE ( iterate4pH )

       IF ( niter_atsec .GE. at_maxniter ) THEN
           zh = -1. _d 0
           iterate4pH = .FALSE.
       ELSE

C        zeqn = EQUATION_AT(p_alktot, zh, p_dictot, p_bortot,
C      &                  p_po4tot, p_siltot, p_nh4tot, p_h2stot,
C      &                  p_so4tot, p_flutot)
        CALL EQUATION_AT( p_alktot, zh,       p_dictot, p_bortot,
     &                    p_po4tot, p_siltot, p_nh4tot, p_h2stot,
     &                    p_so4tot, p_flutot,
     &                    zeqn    , zdeqndh,
     &                    i, j, k, bi, bj, myIter, myThid )

C       Adapt bracketing interval: since initially, zh_min <= zh <= zh_max
C       we are sure that zh will improve either bracket, depending on the sign
C       of zeqn
        IF(zeqn .GT. 0. _d 0) THEN
          zh_min = zh
        ELSEIF(zeqn .LT. 0. _d 0) THEN
          zh_max = zh
        ELSE
C         zh is the root
          iterate4pH = .FALSE.
        ENDIF
       ENDIF

       IF ( iterate4pH ) THEN
C      Start calculation of next iterate
        niter_atsec = niter_atsec + 1

        zh_2   = zh_1
        zeqn_2 = zeqn_1
        zh_1   = zh
        zeqn_1 = zeqn

        IF(ABS(zeqn) .GE. 0.5 _d 0*zeqn_absmin) THEN
C            if the function evaluation at the current point
C            is not decreasing faster in absolute value than
C            we may expect for a bisection step, then take
C            one bisection step on [ph_min, ph_max]
C            ph_new = (ph_min + ph_max)/2 _d 0
C            In terms of [H]_new:
C            [H]_new = 10**(-ph_new)
C                   = 10**(-(ph_min + ph_max)/2 _d 0)
C                   = SQRT(10**(-(ph_min + phmax)))
C                   = SQRT(zh_max * zh_min)
           zh              = SQRT(zh_max * zh_min)
           zh_delta          = zh - zh_1
        ELSE
C            \Delta H = -zeqn_1*(h_2 - h_1)/(zeqn_2 - zeqn_1)
C            H_new = H_1 + \Delta H
           zh_delta = -zeqn_1/((zeqn_2-zeqn_1)/(zh_2 - zh_1))
           zh      = zh_1 + zh_delta

C#if defined(DEBUG_PHSOLVERS)
C           PRINT*, '[SOLVE_AT_GENERAL_SEC] testing zh :', zh, zeqn, zh_delta
C#endif
           IF( zh .LT. zh_min ) THEN
C              if [H]_new < [H]_min
C              i.e., if ph_new > ph_max then
C              take one bisection step on [ph_prev, ph_max]
C              ph_new = (ph_prev + ph_max)/2 _d 0
C              In terms of [H]_new:
C              [H]_new = 10**(-ph_new)
C                     = 10**(-(ph_prev + ph_max)/2 _d 0)
C                     = SQRT(10**(-(ph_prev + phmax)))
C                     = SQRT([H]_old*10**(-ph_max))
C                     = SQRT([H]_old * zh_min)
             zh              = SQRT(zh_1 * zh_min)
             zh_delta         = zh - zh_1
           ENDIF

           IF( zh .GT. zh_max ) THEN
C              if [H]_new > [H]_max
C              i.e., if ph_new < ph_min, then
C              take one bisection step on [ph_min, ph_prev]
C              ph_new = (ph_prev + ph_min)/2 _d 0
C              In terms of [H]_new:
C              [H]_new = 10**(-ph_new)
C                     = 10**(-(ph_prev + ph_min)/2 _d 0)
C                     = SQRT(10**(-(ph_prev + ph_min)))
C                     = SQRT([H]_old*10**(-ph_min))
C                     = SQRT([H]_old * zhmax)
             zh               = SQRT(zh_1 * zh_max)
             zh_delta          = zh - zh_1
           ENDIF
        ENDIF

        zeqn_absmin = MIN(ABS(zeqn), zeqn_absmin)

C       Stop iterations once |([H]-[H_1])/[H_1]| < rdel
C        l_exitnow = (ABS(zh_delta) < pp_rdel_ah_target*zh_1)
C        IF(l_exitnow) EXIT
        iterate4pH = ( ABS(zh_delta) .GE. pp_rdel_ah_target*zh_1 )

       ENDIF
      ENDDO

C      SOLVE_AT_GENERAL_SEC = zh
      p_hnew = zh

C      IF(PRESENT(p_val)) THEN
       IF(zh .GT. 0. _d 0) THEN
C           p_val = EQUATION_AT(p_alktot, zh,      p_dictot, p_bortot,
C     &                       p_po4tot, p_siltot, p_nh4tot, p_h2stot,
C     &                       p_so4tot, p_flutot)
          CALL EQUATION_AT( p_alktot, zh,       p_dictot, p_bortot,
     &                      p_po4tot, p_siltot, p_nh4tot, p_h2stot,
     &                      p_so4tot, p_flutot,
     &                      p_val   , zdeqndh,
     &                      i, j, k, bi, bj, myIter, myThid )
       ELSE
c         p_val = HUGE(1. _d 0)
          p_val = 1. _d +65
       ENDIF
C      ENDIF

#endif /* CARBONCHEM_SOLVESAPHE */
      RETURN
      END
C      END FUNCTION SOLVE_AT_GENERAL_SEC
C      =========================================================================

#include "ECCO_OPTIONS.h"

      subroutine cost_averagesinit( mythid )

c     ==================================================================
c     SUBROUTINE cost_averagesinit
c     ==================================================================
c
c     o Set average fields for temperature, salinity, surface pressure,
c       and averaging counters to zero. The average fields are declared
c       in the header file ecco_cost.h.
c
c     started: Christian Eckert eckert@mit.edu 30-Jun-1999
c
c     changed: Christian Eckert eckert@mit.edu 11-Feb-2000
c
c              - Restructured the code in order to create a package
c                for the MITgcmUV.
c
c     ==================================================================
c     SUBROUTINE cost_averagesinit
c     ==================================================================

      implicit none

c     == global variables ==

#include "EEPARAMS.h"
#include "SIZE.h"
#include "ECCO_SIZE.h"
#include "ECCO.h"

c     == routine arguments ==

      integer mythid

c     == local variables ==

      integer bi,bj
      integer jmin,jmax
      integer imin,imax
#ifdef ALLOW_GENCOST_CONTRIBUTION
      integer i,j,k,kk
#endif

c     == end of interface ==

c--   Set the loop ranges.
      jmin = 1
      jmax = sny
      imin = 1
      imax = snx

      do bj = mybylo(mythid), mybyhi(mythid)
        do bi = mybxlo(mythid), mybxhi(mythid)

#ifdef ALLOW_GENCOST_CONTRIBUTION
          do  k=1,NGENCOST
            do j = jmin,jmax
              do i = imin,imax
                gencost_barfld(i,j,bi,bj,k) = 0. _d 0
                gencost_modfld(i,j,bi,bj,k) = 0. _d 0
              enddo
            enddo
            gencost_dummy(k) = 0. _d 0
          enddo
#ifdef ALLOW_GENCOST3D
          do  kk=1,NGENCOST3D
            do j = jmin,jmax
              do i = imin,imax
                do k = 1,nr
                gencost_bar3d(i,j,k,bi,bj,kk) = 0. _d 0
                gencost_mod3d(i,j,k,bi,bj,kk) = 0. _d 0
                enddo
              enddo
            enddo
          enddo
#endif /* ALLOW_GENCOST3D */
#endif /* ALLOW_GENCOST_CONTRIBUTION */

        enddo
      enddo

      return
      end

#undef USE_OBSOLETE_MDS_RW_SLICE
#include "MDSIO_OPTIONS.h"

C--  File mdsio_rw_slice.F: old version of MDS_READ/WRITE_SEC_XZ/YZ S/R with
C    fewer arguments (kept for backward compatibility): call new MDSIO S/R
C    with fixed additional arguments
C--   Contents
C--   o MDSREADFIELDXZ
C--   o MDSREADFIELDYZ
C--   o MDSREADFIELDXZ_LOC
C--   o MDSREADFIELDYZ_LOC
C--   o MDSWRITEFIELDXZ
C--   o MDSWRITEFIELDYZ
C--   o MDSWRITEFIELDXZ_LOC
C--   o MDSWRITEFIELDYZ_LOC

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      SUBROUTINE MDSREADFIELDXZ(
     I   fName,
     I   filePrec,
     I   arrType,
     I   nNz,
     |   arr,
     I   irecord,
     I   myThid )

C Arguments:
C
C fName      string  :: base name for file to written
C filePrec   integer :: number of bits per word in file (32 or 64)
C arrType    char(2) :: declaration of "arr": either "RS" or "RL"
C nNz        integer :: size of third dimension: normally either 1 or Nr
C arr         RS/RL  :: array to write, arr(:,:,nNz,:,:)
C irecord    integer :: record number to read
C myThid     integer :: thread identifier
C
C Routine now calls MDS_READ_SEC_XZ, just a way to add extra arguments
C to the argument list.
C The 1rst new argument (useCurrentDir=.FALSE.) allows to read files from
C the "mdsioLocalDir" directory (if it is set).
C The 2nd new argument avoid argument array of undefined type (RL/RS).

      IMPLICIT NONE
C Global variables / COMMON blocks
#include "SIZE.h"
c #include "EEPARAMS.h"

C Routine arguments
      CHARACTER*(*) fName
      INTEGER filePrec
      CHARACTER*(2) arrType
      INTEGER nNz
      _RL     arr(*)
      INTEGER irecord
      INTEGER myThid

#ifdef USE_OBSOLETE_MDS_RW_SLICE
C Local variables
      _RL dummyRL(1)
      _RS dummyRS(1)

      IF ( arrType.EQ.'RL' ) THEN
        CALL MDS_READ_SEC_XZ(
     I                fName, filePrec, .FALSE., arrType, nNz, 1, nNz,
     O                arr, dummyRS,
     I                irecord, myThid )
      ELSE
        CALL MDS_READ_SEC_XZ(
     I                fName, filePrec, .FALSE., arrType, nNz, 1, nNz,
     O                dummyRL, arr,
     I                irecord, myThid )
      ENDIF

#else /* USE_OBSOLETE_MDS_RW_SLICE */
      STOP 'ABNORMAL END: S/R MDSREADFIELDXZ is retired'
#endif /* USE_OBSOLETE_MDS_RW_SLICE */

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      SUBROUTINE MDSREADFIELDYZ(
     I   fName,
     I   filePrec,
     I   arrType,
     I   nNz,
     |   arr,
     I   irecord,
     I   myThid )

C Arguments:
C
C fName      string  :: base name for file to written
C filePrec   integer :: number of bits per word in file (32 or 64)
C arrType    char(2) :: declaration of "arr": either "RS" or "RL"
C nNz        integer :: size of third dimension: normally either 1 or Nr
C arr         RS/RL  :: array to write, arr(:,:,nNz,:,:)
C irecord    integer :: record number to read
C myThid     integer :: thread identifier
C
C Routine now calls MDS_READ_SEC_YZ, just a way to add extra arguments
C to the argument list.
C The 1rst new argument (useCurrentDir=.FALSE.) allows to read files from
C the "mdsioLocalDir" directory (if it is set).
C The 2nd new argument avoid argument array of undefined type (RL/RS).

      IMPLICIT NONE
C Global variables / COMMON blocks
#include "SIZE.h"
c #include "EEPARAMS.h"

C Routine arguments
      CHARACTER*(*) fName
      INTEGER filePrec
      CHARACTER*(2) arrType
      INTEGER nNz
      _RL     arr(*)
      INTEGER irecord
      INTEGER myThid

#ifdef USE_OBSOLETE_MDS_RW_SLICE
C Local variables
      _RL dummyRL(1)
      _RS dummyRS(1)

      IF ( arrType.EQ.'RL' ) THEN
        CALL MDS_READ_SEC_YZ(
     I                fName, filePrec, .FALSE., arrType, nNz, 1, nNz,
     O                arr, dummyRS,
     I                irecord, myThid )
      ELSE
        CALL MDS_READ_SEC_YZ(
     I                fName, filePrec, .FALSE., arrType, nNz, 1, nNz,
     O                dummyRL, arr,
     I                irecord, myThid )
      ENDIF

#else /* USE_OBSOLETE_MDS_RW_SLICE */
      STOP 'ABNORMAL END: S/R MDSREADFIELDYZ is retired'
#endif /* USE_OBSOLETE_MDS_RW_SLICE */

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      SUBROUTINE MDSREADFIELDXZ_LOC(
     I   fName,
     I   filePrec,
     I   arrType,
     I   nNz,
     |   arr,
     I   irecord,
     I   myThid )

C Arguments:
C
C fName      string  :: base name for file to written
C filePrec   integer :: number of bits per word in file (32 or 64)
C arrType    char(2) :: declaration of "arr": either "RS" or "RL"
C nNz        integer :: size of third dimension: normally either 1 or Nr
C arr         RS/RL  :: array to write, arr(:,:,nNz,:,:)
C irecord    integer :: record number to read
C myThid     integer :: thread identifier
C
C Routine now calls MDS_READ_SEC_XZ, just a way to add extra arguments
C to the argument list.
C The 1rst new argument (useCurrentDir=.TRUE.) forces to ignore the
C "mdsioLocalDir" parameter and to always write to the current directory.
C The 2nd new argument avoid argument array of undefined type (RL/RS).

      IMPLICIT NONE
C Global variables / COMMON blocks
#include "SIZE.h"
c #include "EEPARAMS.h"

C Routine arguments
      CHARACTER*(*) fName
      INTEGER filePrec
      CHARACTER*(2) arrType
      INTEGER nNz
      _RL     arr(*)
      INTEGER irecord
      INTEGER myThid

#ifdef USE_OBSOLETE_MDS_RW_SLICE
C Local variables
      _RL dummyRL(1)
      _RS dummyRS(1)

      IF ( arrType.EQ.'RL' ) THEN
        CALL MDS_READ_SEC_XZ(
     I                fName, filePrec, .TRUE., arrType, nNz, 1, nNz,
     O                arr, dummyRS,
     I                irecord, myThid )
      ELSE
        CALL MDS_READ_SEC_XZ(
     I                fName, filePrec, .TRUE., arrType, nNz, 1, nNz,
     O                dummyRL, arr,
     I                irecord, myThid )
      ENDIF

#else /* USE_OBSOLETE_MDS_RW_SLICE */
      STOP 'ABNORMAL END: S/R MDSREADFIELDXZ_LOC is empty'
#endif /* USE_OBSOLETE_MDS_RW_SLICE */

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      SUBROUTINE MDSREADFIELDYZ_LOC(
     I   fName,
     I   filePrec,
     I   arrType,
     I   nNz,
     |   arr,
     I   irecord,
     I   myThid )

C Arguments:
C
C fName      string  :: base name for file to written
C filePrec   integer :: number of bits per word in file (32 or 64)
C arrType    char(2) :: declaration of "arr": either "RS" or "RL"
C nNz        integer :: size of third dimension: normally either 1 or Nr
C arr         RS/RL  :: array to write, arr(:,:,nNz,:,:)
C irecord    integer :: record number to read
C myThid     integer :: thread identifier
C
C Routine now calls MDS_READ_SEC_YZ, just a way to add extra arguments
C to the argument list.
C The 1rst new argument (useCurrentDir=.TRUE.) forces to ignore the
C "mdsioLocalDir" parameter and to always write to the current directory.
C The 2nd new argument avoid argument array of undefined type (RL/RS).

      IMPLICIT NONE
C Global variables / COMMON blocks
#include "SIZE.h"
c #include "EEPARAMS.h"

C Routine arguments
      CHARACTER*(*) fName
      INTEGER filePrec
      CHARACTER*(2) arrType
      INTEGER nNz
      _RL     arr(*)
      INTEGER irecord
      INTEGER myThid

#ifdef USE_OBSOLETE_MDS_RW_SLICE
C Local variables
      _RL dummyRL(1)
      _RS dummyRS(1)

      IF ( arrType.EQ.'RL' ) THEN
        CALL MDS_READ_SEC_YZ(
     I                fName, filePrec, .TRUE., arrType, nNz, 1, nNz,
     O                arr, dummyRS,
     I                irecord, myThid )
      ELSE
        CALL MDS_READ_SEC_YZ(
     I                fName, filePrec, .TRUE., arrType, nNz, 1, nNz,
     O                dummyRL, arr,
     I                irecord, myThid )
      ENDIF

#else /* USE_OBSOLETE_MDS_RW_SLICE */
      STOP 'ABNORMAL END: S/R MDSREADFIELDYZ_LOC is empty'
#endif /* USE_OBSOLETE_MDS_RW_SLICE */

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      SUBROUTINE MDSWRITEFIELDXZ(
     I   fName,
     I   filePrec,
     I   globalFile,
     I   arrType,
     I   nNz,
     I   arr,
     I   irecord,
     I   myIter,
     I   myThid )

C Arguments:
C
C fName      string  :: base name for file to write
C filePrec   integer :: number of bits per word in file (32 or 64)
C globalFile logical :: selects between writing a global or tiled file
C arrType    char(2) :: declaration of "arr": either "RS" or "RL"
C nNz        integer :: size of third dimension: normally either 1 or Nr
C arr         RS/RL  :: array to write, arr(:,:,nNzdim,:,:)
C irecord    integer :: record number to write
C myIter     integer :: time step number
C myThid     integer :: thread identifier
C
C Routine now calls MDS_WRITE_REC_XZ, just a way to add extra arguments
C to the argument list.
C The 1rst new argument (useCurrentDir=.FALSE.) allows to write files to
C the "mdsioLocalDir" directory (if it is set).
C The 2nd new argument avoid argument array of undefined type (RL/RS).

      IMPLICIT NONE
C Global variables / common blocks
#include "SIZE.h"
c #include "EEPARAMS.h"

C Routine arguments
      CHARACTER*(*) fName
      INTEGER filePrec
      LOGICAL globalFile
      CHARACTER*(2) arrType
      INTEGER nNz
      _RL     arr(*)
      INTEGER irecord
      INTEGER myIter
      INTEGER myThid

#ifdef USE_OBSOLETE_MDS_RW_SLICE
C Local variables
      _RL dummyRL(1)
      _RS dummyRS(1)

      IF ( arrType.EQ.'RL' ) THEN
        CALL MDS_WRITE_SEC_XZ(
     I                 fName, filePrec, globalFile, .FALSE.,
     I                 arrType, nNz, 1, nNz, arr, dummyRS,
     I                 irecord, myIter, myThid )
      ELSE
        CALL MDS_WRITE_SEC_XZ(
     I                 fName, filePrec, globalFile, .FALSE.,
     I                 arrType, nNz, 1, nNz, dummyRL, arr,
     I                 irecord, myIter, myThid )
      ENDIF

#else /* USE_OBSOLETE_MDS_RW_SLICE */
      STOP 'ABNORMAL END: S/R MDSWRITEFIELDXZ is retired'
#endif /* USE_OBSOLETE_MDS_RW_SLICE */

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      SUBROUTINE MDSWRITEFIELDYZ(
     I   fName,
     I   filePrec,
     I   globalFile,
     I   arrType,
     I   nNz,
     I   arr,
     I   irecord,
     I   myIter,
     I   myThid )

C Arguments:
C
C fName      string  :: base name for file to write
C filePrec   integer :: number of bits per word in file (32 or 64)
C globalFile logical :: selects between writing a global or tiled file
C arrType    char(2) :: declaration of "arr": either "RS" or "RL"
C nNz        integer :: size of third dimension: normally either 1 or Nr
C arr         RS/RL  :: array to write, arr(:,:,nNzdim,:,:)
C irecord    integer :: record number to write
C myIter     integer :: time step number
C myThid     integer :: thread identifier
C
C Routine now calls MDS_WRITE_REC_YZ, just a way to add extra arguments
C to the argument list.
C The 1rst new argument (useCurrentDir=.FALSE.) allows to write files to
C the "mdsioLocalDir" directory (if it is set).
C The 2nd new argument avoid argument array of undefined type (RL/RS).

      IMPLICIT NONE
C Global variables / common blocks
#include "SIZE.h"
c #include "EEPARAMS.h"

C Routine arguments
      CHARACTER*(*) fName
      INTEGER filePrec
      LOGICAL globalFile
      CHARACTER*(2) arrType
      INTEGER nNz
      _RL     arr(*)
      INTEGER irecord
      INTEGER myIter
      INTEGER myThid

#ifdef USE_OBSOLETE_MDS_RW_SLICE
C Local variables
      _RL dummyRL(1)
      _RS dummyRS(1)

      IF ( arrType.EQ.'RL' ) THEN
        CALL MDS_WRITE_SEC_YZ(
     I                 fName, filePrec, globalFile, .FALSE.,
     I                 arrType, nNz, 1, nNz, arr, dummyRS,
     I                 irecord, myIter, myThid )
      ELSE
        CALL MDS_WRITE_SEC_YZ(
     I                 fName, filePrec, globalFile, .FALSE.,
     I                 arrType, nNz, 1, nNz, dummyRL, arr,
     I                 irecord, myIter, myThid )
      ENDIF

#else /* USE_OBSOLETE_MDS_RW_SLICE */
      STOP 'ABNORMAL END: S/R MDSWRITEFIELDYZ is retired'
#endif /* USE_OBSOLETE_MDS_RW_SLICE */

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      SUBROUTINE MDSWRITEFIELDXZ_LOC(
     I   fName,
     I   filePrec,
     I   globalFile,
     I   arrType,
     I   nNz,
     I   arr,
     I   irecord,
     I   myIter,
     I   myThid )

C Arguments:
C
C fName      string  :: base name for file to write
C filePrec   integer :: number of bits per word in file (32 or 64)
C globalFile logical :: selects between writing a global or tiled file
C arrType    char(2) :: declaration of "arr": either "RS" or "RL"
C nNz        integer :: size of third dimension: normally either 1 or Nr
C arr         RS/RL  :: array to write, arr(:,:,nNzdim,:,:)
C irecord    integer :: record number to write
C myIter     integer :: time step number
C myThid     integer :: thread identifier
C
C Routine now calls MDS_WRITE_REC_XZ, just a way to add extra arguments
C to the argument list.
C The 1rst new argument (useCurrentDir=.TRUE.) forces to ignore the
C "mdsioLocalDir" parameter and to always write to the current directory.
C The 2nd new argument avoid argument array of undefined type (RL/RS).

      IMPLICIT NONE
C Global variables / common blocks
#include "SIZE.h"
c #include "EEPARAMS.h"

C Routine arguments
      CHARACTER*(*) fName
      INTEGER filePrec
      LOGICAL globalFile
      CHARACTER*(2) arrType
      INTEGER nNz
      _RL     arr(*)
      INTEGER irecord
      INTEGER myIter
      INTEGER myThid

#ifdef USE_OBSOLETE_MDS_RW_SLICE
C Local variables
      _RL dummyRL(1)
      _RS dummyRS(1)

      IF ( arrType.EQ.'RL' ) THEN
        CALL MDS_WRITE_SEC_XZ(
     I                 fName, filePrec, globalFile, .TRUE.,
     I                 arrType, nNz, 1, nNz, arr, dummyRS,
     I                 irecord, myIter, myThid )
      ELSE
        CALL MDS_WRITE_SEC_XZ(
     I                 fName, filePrec, globalFile, .TRUE.,
     I                 arrType, nNz, 1, nNz, dummyRL, arr,
     I                 irecord, myIter, myThid )
      ENDIF

#else /* USE_OBSOLETE_MDS_RW_SLICE */
      STOP 'ABNORMAL END: S/R MDSWRITEFIELDXZ_LOC is empty'
#endif /* USE_OBSOLETE_MDS_RW_SLICE */

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      SUBROUTINE MDSWRITEFIELDYZ_LOC(
     I   fName,
     I   filePrec,
     I   globalFile,
     I   arrType,
     I   nNz,
     I   arr,
     I   irecord,
     I   myIter,
     I   myThid )

C Arguments:
C
C fName      string  :: base name for file to write
C filePrec   integer :: number of bits per word in file (32 or 64)
C globalFile logical :: selects between writing a global or tiled file
C arrType    char(2) :: declaration of "arr": either "RS" or "RL"
C nNz        integer :: size of third dimension: normally either 1 or Nr
C arr         RS/RL  :: array to write, arr(:,:,nNzdim,:,:)
C irecord    integer :: record number to write
C myIter     integer :: time step number
C myThid     integer :: thread identifier
C
C Routine now calls MDS_WRITE_REC_YZ, just a way to add extra arguments
C to the argument list.
C The 1rst new argument (useCurrentDir=.TRUE.) forces to ignore the
C "mdsioLocalDir" parameter and to always write to the current directory.
C The 2nd new argument avoid argument array of undefined type (RL/RS).

      IMPLICIT NONE
C Global variables / common blocks
#include "SIZE.h"
c #include "EEPARAMS.h"

C Routine arguments
      CHARACTER*(*) fName
      INTEGER filePrec
      LOGICAL globalFile
      CHARACTER*(2) arrType
      INTEGER nNz
      _RL     arr(*)
      INTEGER irecord
      INTEGER myIter
      INTEGER myThid

#ifdef USE_OBSOLETE_MDS_RW_SLICE
C Local variables
      _RL dummyRL(1)
      _RS dummyRS(1)

      IF ( arrType.EQ.'RL' ) THEN
        CALL MDS_WRITE_SEC_YZ(
     I                 fName, filePrec, globalFile, .TRUE.,
     I                 arrType, nNz, 1, nNz, arr, dummyRS,
     I                 irecord, myIter, myThid )
      ELSE
        CALL MDS_WRITE_SEC_YZ(
     I                 fName, filePrec, globalFile, .TRUE.,
     I                 arrType, nNz, 1, nNz, dummyRL, arr,
     I                 irecord, myIter, myThid )
      ENDIF

#else /* USE_OBSOLETE_MDS_RW_SLICE */
      STOP 'ABNORMAL END: S/R MDSWRITEFIELDYZ_LOC is empty'
#endif /* USE_OBSOLETE_MDS_RW_SLICE */

      RETURN
      END

#include "PACKAGES_CONFIG.h"
#include "CPP_OPTIONS.h"

CBOP
C     !ROUTINE: INI_PSURF
C     !INTERFACE:
      SUBROUTINE INI_PSURF( myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE INI_PSURF                                     |
C     | o Set model initial free-surface height/pressure.        |
C     *==========================================================*
C     | There are several options for setting the initial        |
C     | surface displacement (r unit) field.                     |
C     |  1. Inline code                                          |
C     |  2. Two-dimensional data from a file.                    |
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "DYNVARS.h"
#include "SURFACE.h"
#ifdef ALLOW_CD_CODE
# include "CD_CODE_VARS.h"
#endif
#ifdef ALLOW_SHELFICE
# include "SHELFICE.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     myThid :: my Thread Id number
      INTEGER myThid

C     !LOCAL VARIABLES:
C     bi,bj  :: tiles indices
C     i, j   :: Loop counters
      INTEGER bi, bj
      INTEGER i, j
      _RL omegaPrime, snFac, psFac
CEOP

C--   Initialise surface position anomaly to zero
      omegaPrime = 80. _d 0 / rSphere
c     psFac = -(rSphere**2)*omegaPrime*(Omega+omegaPrime)
C     previous expression above was missing one "half" factor:
      psfac = -(rSphere*rSphere)*omegaPrime
     &                          *( Omega + omegaPrime*0.5 _d 0 )
      snFac = 1. _d 0 / (4. _d 0*Omega*Omega)
C     recip_Bo is constant here, Z-coord: =1/gBaro
C                                P-coord: if uniformLin_PhiSurf=T, =rhoConst
      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          etaN(i,j,bi,bj) = 0. _d 0
     &     + psFac*( snFac*fCori(i,j,bi,bj)*fCori(i,j,bi,bj)
     &             - 1. _d 0 / 3. _d 0 )*recip_Bo(i,j,bi,bj)
         ENDDO
        ENDDO
       ENDDO
      ENDDO
C     Read an initial state
      IF ( pSurfInitFile .NE. ' ' ) THEN
       CALL READ_FLD_XY_RL( pSurfInitFile, ' ', etaN, 0, myThid )
C      fill the overlap (+ BARRIER)
       _EXCH_XY_RL(etaN, myThid)
      ENDIF

#ifdef ALLOW_CD_CODE
C--   By default, initialize etaNm1 with etaN :
      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          etaNm1(i,j,bi,bj) = etaN(i,j,bi,bj)
         ENDDO
        ENDDO
       ENDDO
      ENDDO
#endif

C--   By default, initialize etaH with etaN :
      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          etaH(i,j,bi,bj) = etaN(i,j,bi,bj)
          etaHnm1(i,j,bi,bj) = etaN(i,j,bi,bj)
          dEtaHdt(i,j,bi,bj) = 0. _d 0
         ENDDO
        ENDDO
       ENDDO
      ENDDO

#ifdef ALLOW_SHELFICE
      IF ( useShelfIce .AND. usingZCoords ) THEN
        DO bj=myByLo(myThid),myByHi(myThid)
         DO bi=myBxLo(myThid),myBxHi(myThid)
           DO j=1-OLy,sNy+OLy
            DO i=1-OLx,sNx+OLx
              phi0surf(i,j,bi,bj) = phi0surf(i,j,bi,bj)
     &          + shelficeLoadAnomaly(i,j,bi,bj)*recip_rhoConst
            ENDDO
           ENDDO
         ENDDO
        ENDDO
      ENDIF
#endif /* ALLOW_SHELFICE */

      RETURN
      END

#include "OCN_CPL_OPTIONS.h"

CBOP
C     !ROUTINE: CPL_INI_VARS
C     !INTERFACE:
      SUBROUTINE CPL_INI_VARS( myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R CPL_INI_VARS
C     | o Initialisation routine for arrays that are used to
C     |   buffer data that interfaces to the coupling layer.
C     | - Oceanic version -
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "CPL_PARAMS.h"
#include "OCNCPL.h"

C     !INPUT/OUTPUT PARAMETERS:
C     myThid :: my Thread Id Number
      INTEGER myThid

#ifdef COMPONENT_MODULE
C     !LOCAL VARIABLES:
C     i,j,bi,bj :: Loop counters
      INTEGER i,j,bi,bj
CEOP

      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
C.        Export fields
          ocMxlD2cpl(i,j,bi,bj) = 0.
          SSTocn2cpl(i,j,bi,bj) = 0.
          SSSocn2cpl(i,j,bi,bj) = 0.
          vSqocn2cpl(i,j,bi,bj) = 0.
#ifdef ALLOW_DIC
          fluxCO2cpl(i,j,bi,bj) = 0.
#endif
C-        Import and/or export fields
#if (defined ALLOW_DIC) || (defined ALLOW_THSICE)
          sIceFrac_cpl  (i,j,bi,bj) = 0.
#endif
#ifdef ALLOW_THSICE
          sIceThick_cpl (i,j,bi,bj) = 0.
          sIceSnowH_cpl (i,j,bi,bj) = 0.
          sIceQ1_cpl    (i,j,bi,bj) = 0.
          sIceQ2_cpl    (i,j,bi,bj) = 0.
#endif
C-        Import fields
          atmSLPr   (i,j,bi,bj) = 0.
          HeatFlux  (i,j,bi,bj) = 0.
          qShortWave(i,j,bi,bj) = 0.
          tauX      (i,j,bi,bj) = 0.
          tauY      (i,j,bi,bj) = 0.
          FWflux    (i,j,bi,bj) = 0.
          iceSaltFlx(i,j,bi,bj) = 0.
          seaIceMass(i,j,bi,bj) = 0.
#ifdef ALLOW_SALT_PLUME
          saltPlmFlx_cpl(i,j,bi,bj) = 0.
#endif
#ifdef ALLOW_DIC
          RunOff_cpl(i,j,bi,bj) = 0.
          airCO2    (i,j,bi,bj) = 0.
          surfWSpeed(i,j,bi,bj) = 0.
#endif
         ENDDO
        ENDDO
       ENDDO
      ENDDO

      IF ( startTime.NE.baseTime .OR. nIter0.NE.0
     &                   .OR. pickupSuff .NE. ' ' ) THEN
       CALL OCN_CPL_READ_PICKUP( nIter0, myThid )
      ENDIF

#endif /* COMPONENT_MODULE */

      RETURN
      END

#include "GRDCHK_OPTIONS.h"
#ifdef ALLOW_CTRL
# include "CTRL_OPTIONS.h"
#endif

      SUBROUTINE GRDCHK_GETXX(
     I                       icvrec,
     I                       theSimulationMode,
     I                       iGrdC, jGrdC, layer,
     I                       bi_gc, bj_gc, procId_gc,
     I                       varIndex_gc,
     O                       xx_comp_ref,
     O                       xx_comp_pert,
     I                       localEps,
     I                       myThid )

C     ==================================================================
C     SUBROUTINE grdchk_getxx
C     ==================================================================
C
C     o Set component a component of the control vector; xx(loc)
C
C     started: Christian Eckert eckert@mit.edu 08-Mar-2000
C     continued: heimbach@mit.edu: 13-Jun-2001
C
C     ==================================================================
C     SUBROUTINE grdchk_getxx
C     ==================================================================

      IMPLICIT NONE

C     == global variables ==
#include "EEPARAMS.h"
#include "SIZE.h"
#include "CTRL_SIZE.h"
#include "CTRL.h"
#include "OPTIMCYCLE.h"

C     == routine arguments ==
      INTEGER icvrec
      INTEGER theSimulationMode
      INTEGER iGrdC, jGrdC, layer
      INTEGER bi_gc, bj_gc
      INTEGER procId_gc
      INTEGER varIndex_gc
      _RL     xx_comp_ref
      _RL     xx_comp_pert
      _RL     localEps
      INTEGER myThid

#ifdef ALLOW_GRDCHK
C--   == external ==
      INTEGER  ILNBLNK
      EXTERNAL ILNBLNK

C     == local variables ==
      INTEGER iL, ilDir
      _RL     dummy
      LOGICAL doglobalread
      LOGICAL ladinit
      CHARACTER*(MAX_LEN_FNAM) ctrl_name
      CHARACTER*(MAX_LEN_FNAM) fName
      _RL loctmp2d (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
#ifdef ALLOW_GENARR3D_CONTROL
      _RL loctmp3d (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
#endif
#if (defined ALLOW_OBCSN_CONTROL || defined ALLOW_OBCSS_CONTROL)
      _RL tmpfldxz (1-OLx:sNx+OLx,Nr,nSx,nSy)
#endif
#if (defined ALLOW_OBCSE_CONTROL || defined ALLOW_OBCSW_CONTROL)
      _RL tmpfldyz (1-OLy:sNy+OLy,Nr,nSx,nSy)
#endif
C--   == end of interface ==

      xx_comp_ref  = 0. _d 0
      xx_comp_pert = 0. _d 0

      doglobalread = .FALSE.
      ladinit      = .FALSE.
C     Find ctrlDir (w/o trailing blanks) length
      ilDir = ILNBLNK(ctrlDir)

      ctrl_name = ncvarfname(varIndex_gc)
      iL = ILNBLNK( ctrl_name )

      IF ( theSimulationMode .EQ. TANGENT_SIMULATION ) THEN
        WRITE(fName,'(3A,I10.10)') ctrlDir(1:ilDir)//yadmark,
     &           ctrl_name(1:iL), '.', optimcycle
      ELSEIF ( theSimulationMode .EQ. FORWARD_SIMULATION ) THEN
        WRITE(fName,'(3A,I10.10)') ctrlDir(1:ilDir),
     &           ctrl_name(1:iL), '.', optimcycle
      ELSE
        WRITE(fName,'(A)') ' '
      ENDIF

#ifdef ALLOW_GENARR3D_CONTROL
      IF ( ncvartype(varIndex_gc) .EQ. 'Arr3D' ) THEN
         CALL active_read_xyz( fName, loctmp3d, 1,
     &                         doglobalread, ladinit, optimcycle,
     &                         myThid, dummy )
         IF ( myProcId .EQ. procId_gc )
     &   xx_comp_ref = loctmp3d( iGrdC,jGrdC,layer,bi_gc,bj_gc )
         IF ( myProcId .EQ. procId_gc )
     &   xx_comp_pert = xx_comp_ref + localEps
         IF ( myProcId .EQ. procId_gc )
     &   loctmp3d( iGrdC,jGrdC,layer,bi_gc,bj_gc ) = xx_comp_pert
         CALL active_write_xyz( fName, loctmp3d, 1,
     &                          optimcycle,
     &                          myThid, dummy )
#else
      IF ( .FALSE. ) THEN
#endif

#if (defined ALLOW_OBCSN_CONTROL || defined ALLOW_OBCSS_CONTROL)
      ELSEIF ( ncvartype(varIndex_gc) .EQ. 'SecXZ' ) THEN
         CALL active_read_xz( fName, tmpfldxz, icvrec,
     &                        doglobalread, ladinit, optimcycle,
     &                        myThid, dummy )
         IF ( myProcId .EQ. procId_gc )
     &   xx_comp_ref = tmpfldxz( iGrdC,layer,bi_gc,bj_gc )
         IF ( myProcId .EQ. procId_gc )
     &   xx_comp_pert = xx_comp_ref + localEps
         IF ( myProcId .EQ. procId_gc )
     &   tmpfldxz( iGrdC,layer,bi_gc,bj_gc ) = xx_comp_pert
         CALL active_write_xz( fName, tmpfldxz, icvrec,
     &                         optimcycle,
     &                         myThid, dummy )
#endif

#if (defined ALLOW_OBCSE_CONTROL || defined ALLOW_OBCSW_CONTROL)
      ELSEIF ( ncvartype(varIndex_gc) .EQ. 'SecYZ' ) THEN
         CALL active_read_yz( fName, tmpfldyz, icvrec,
     &                        doglobalread, ladinit, optimcycle,
     &                        myThid, dummy )
         IF ( myProcId .EQ. procId_gc )
     &   xx_comp_ref = tmpfldyz( jGrdC,layer,bi_gc,bj_gc )
         IF ( myProcId .EQ. procId_gc )
     &   xx_comp_pert = xx_comp_ref + localEps
         IF ( myProcId .EQ. procId_gc )
     &   tmpfldyz( jGrdC,layer,bi_gc,bj_gc ) = xx_comp_pert
         CALL active_write_yz( fName, tmpfldyz, icvrec,
     &                         optimcycle,
     &                         myThid, dummy )
#endif

      ELSE
         CALL active_read_xy( fName, loctmp2d, icvrec,
     &                        doglobalread, ladinit, optimcycle,
     &                        myThid, dummy )
         IF ( myProcId .EQ. procId_gc )
     &   xx_comp_ref = loctmp2d( iGrdC,jGrdC,bi_gc,bj_gc )
         IF ( myProcId .EQ. procId_gc )
     &   xx_comp_pert = xx_comp_ref + localEps
         IF ( myProcId .EQ. procId_gc )
     &   loctmp2d( iGrdC,jGrdC,bi_gc,bj_gc ) = xx_comp_pert
         CALL active_write_xy( fName, loctmp2d, icvrec,
     &                         optimcycle,
     &                         myThid, dummy )

      ENDIF

#endif /* ALLOW_GRDCHK */

      RETURN
      END

#include "OBCS_OPTIONS.h"

CBOP
C     !ROUTINE: OBCS_APPLY_PTRACER
C     !INTERFACE:
      SUBROUTINE OBCS_APPLY_PTRACER(
     I                               bi, bj, kArg, iTracer,
     U                               pFld,
     I                               myThid )

C     !DESCRIPTION:
C     *==========================================================*
C     | S/R OBCS_APPLY_PTRACER
C     | In this routine the open boundary values are applied
C     | that have been calculated in OBCS_CALC.
C     *==========================================================*

C     !USES:
      IMPLICIT NONE
C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "OBCS_GRID.h"
#ifdef ALLOW_PTRACERS
#include "PTRACERS_SIZE.h"
#include "OBCS_PTRACERS.h"
#endif /* ALLOW_PTRACERS */

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine Arguments ==
C    bi, bj   :: indices of current tile
C    kArg     :: index of current level which OBC apply to
C                or, if zero, apply to all levels
C    iTracer  :: index of current passive tracer
C    pFld     :: passive tracer field
C    myThid   :: my Thread Id number
      INTEGER bi, bj
      INTEGER kArg
      INTEGER iTracer
      _RL pFld(1-OLx:sNx+OLx,1-OLy:sNy+OLy,*)
      INTEGER myThid
CEOP

#ifdef ALLOW_PTRACERS

C     !LOCAL VARIABLES:
C     == Local variables ==
      INTEGER k, kLo, kHi
      INTEGER kl, kMx
      INTEGER i, j
      INTEGER Iobc, Jobc

      IF ( kArg.EQ.0 ) THEN
        kLo = 1
        kHi = Nr
        kMx = Nr
      ELSE
        kLo = kArg
        kHi = kArg
        kMx = 1
      ENDIF

C     Set model variables to OB values on North/South Boundaries
#ifdef ALLOW_OBCS_NORTH
      IF ( tileHasOBN(bi,bj) ) THEN
C Northern boundary
       DO i=1-OLx,sNx+OLx
        Jobc = OB_Jn(i,bi,bj)
        IF ( Jobc.NE.OB_indexNone ) THEN
         DO k = kLo,kHi
          kl = MIN(k,kMx)
          pFld(i,Jobc,kl) = OBNptr(i,k,bi,bj,iTracer)
         ENDDO
        ENDIF
       ENDDO
      ENDIF
#endif /* ALLOW_OBCS_NORTH */

#ifdef ALLOW_OBCS_SOUTH
      IF ( tileHasOBS(bi,bj) ) THEN
C Southern boundary
       DO i=1-OLx,sNx+OLx
        Jobc = OB_Js(i,bi,bj)
        IF ( Jobc.NE.OB_indexNone ) THEN
         DO k = kLo,kHi
          kl = MIN(k,kMx)
          pFld(i,Jobc,kl) = OBSptr(i,k,bi,bj,iTracer)
         ENDDO
        ENDIF
       ENDDO
      ENDIF
#endif /* ALLOW_OBCS_SOUTH */

C     Set model variables to OB values on East/West Boundaries
#ifdef ALLOW_OBCS_EAST
      IF ( tileHasOBE(bi,bj) ) THEN
C Eastern boundary
       DO j=1-OLy,sNy+OLy
        Iobc = OB_Ie(j,bi,bj)
        IF ( Iobc.NE.OB_indexNone ) THEN
         DO k = kLo,kHi
          kl = MIN(k,kMx)
          pFld(Iobc,j,kl) = OBEptr(j,k,bi,bj,iTracer)
         ENDDO
        ENDIF
       ENDDO
      ENDIF
#endif /* ALLOW_OBCS_EAST */

#ifdef ALLOW_OBCS_WEST
      IF ( tileHasOBW(bi,bj) ) THEN
C Western boundary
       DO j=1-OLy,sNy+OLy
        Iobc = OB_Iw(j,bi,bj)
        IF ( Iobc.NE.OB_indexNone ) THEN
         DO k = kLo,kHi
          kl = MIN(k,kMx)
          pFld(Iobc,j,kl) = OBWptr(j,k,bi,bj,iTracer)
         ENDDO
        ENDIF
       ENDDO
      ENDIF
#endif /* ALLOW_OBCS_WEST */

#endif /* ALLOW_PTRACERS */

      RETURN
      END

#include "GRDCHK_OPTIONS.h"
#ifdef ALLOW_CTRL
# include "CTRL_OPTIONS.h"
#endif

CBOP
C     !ROUTINE: GRDCHK_GET_POSITION
C     !INTERFACE:
      SUBROUTINE GRDCHK_GET_POSITION( myThid )

C     !DESCRIPTION:
C     o Get the location of a given component of the control vector for
C       the current process.
C
C     started: Christian Eckert eckert@mit.edu 04-Apr-2000
C     continued: heimbach@mit.edu: 13-Jun-2001

C     !USES:
      IMPLICIT NONE

#include "EEPARAMS.h"
#include "SIZE.h"
#include "GRID.h"
#ifdef ALLOW_SHELFICE
# include "SHELFICE.h"
#endif
#ifdef ALLOW_OBCS
# include "OBCS_GRID.h"
#endif
#include "CTRL_SIZE.h"
#include "CTRL.h"
#ifdef ALLOW_OBCS_CONTROL
C     CTRL_OBCS.h must be included before GRDCHK.h
# include "CTRL_OBCS.h"
#endif
#include "GRDCHK.h"

C     !INPUT/OUTPUT PARAMETERS:
      INTEGER myThid

#ifdef ALLOW_GRDCHK
C     !LOCAL VARIABLES:
      INTEGER icvrec
      INTEGER jtile
      INTEGER itile
      INTEGER layer
      INTEGER obcspos
      INTEGER itilepos
      INTEGER jtilepos
      INTEGER itest
      INTEGER ierr
      INTEGER bi,bj
      INTEGER i,j,k
      INTEGER iobcs
      INTEGER iwrk, jwrk, kwrk
      INTEGER irec, irecwrk
      INTEGER icomptest
      INTEGER nobcsmax
      INTEGER pastit
      _RL wetlocal
CEOP

C     local copies of COMMON block variable (GRDCHK.h)
      itile    = iLocTile
      jtile    = jLocTile
      itilepos = iGloPos
      jtilepos = jGloPos
      layer    = kGloPos
      obcspos  = obcsglo
      icvrec   = recglo

      _BEGIN_MASTER( myThid )

C--   determine proc. number from following assumptions <= done in
C     grdchk_readparms

      IF ( myProcId .EQ. grdchkwhichproc ) THEN

C     initialise parameters
       ierr      = -5
       pastit    = -1
       wetlocal  = 0

       itest     = 0
       icomptest = 0
       irecwrk   = 1
       kwrk      = 1
       jwrk      = 1
       iwrk      = 1

C--   set max loop index for obcs multiplicities
       IF ( ncvargrd(grdchkvarindex) .EQ. 'm' ) THEN
#ifdef ALLOW_OBCS_CONTROL
        nobcsmax = nobcs
#else
        PRINT *, 'S/R grdchk_get_position: Ooops!'
#endif
       ELSE
        nobcsmax = 1
       ENDIF

C--   Start to loop over records.
       DO irec = irecwrk, ncvarrecs(grdchkvarindex)
        iobcs = MOD((irec-1),nobcsmax) + 1
        bi = itile
        bj = jtile
        DO k = kwrk, ncvarnrmax(grdchkvarindex)
cph(
cph-print               PRINT *, 'ph-grd get_pos irec, bj, bi, k ',
cph-print     &              irec, bj, bi, k
cph)
         IF ( ierr .ne. 0 ) THEN
          DO j = jwrk, ncvarymax(grdchkvarindex)
           DO i = iwrk, ncvarxmax(grdchkvarindex)
            IF (ierr .NE. 0) THEN
             IF ( ncvargrd(grdchkvarindex) .EQ. 'c' ) THEN
              IF ( maskC(i,j,k,bi,bj) .GT. 0.) THEN
               icomptest = icomptest + 1
              ENDIF
              wetlocal = maskC(i,j,k,bi,bj)
             ELSEIF ( ncvargrd(grdchkvarindex) .EQ. 's' ) THEN
              IF ( _maskS(i,j,k,bi,bj) .GT. 0.) THEN
               icomptest = icomptest + 1
              ENDIF
              wetlocal = _maskS(i,j,k,bi,bj)
             ELSEIF ( ncvargrd(grdchkvarindex) .EQ. 'w' ) THEN
              IF ( _maskW(i,j,k,bi,bj) .GT. 0.) THEN
               icomptest = icomptest + 1
              ENDIF
              wetlocal = _maskW(i,j,k,bi,bj)
#ifdef ALLOW_SHELFICE
C--   Ice shelf mask.
             ELSEIF ( ncvargrd(grdchkvarindex) .EQ. 'i' ) THEN
              IF ( maskSHI(i,j,k,bi,bj) .GT. 0.) THEN
               icomptest = icomptest + 1
              ENDIF
              wetlocal = maskSHI(i,j,k,bi,bj)
#endif /* ALLOW_SHELFICE */
#ifdef ALLOW_OBCS_CONTROL
             ELSEIF ( ncvargrd(grdchkvarindex) .EQ. 'm' ) THEN
              IF ( ncvarfname(grdchkvarindex)
     &             .EQ. xx_obcsn_file ) THEN
#ifdef ALLOW_OBCSN_CONTROL
               IF (grdchk_maskxz(i,k,bi,bj,iobcs) .GT. 0.
     &              .AND. j .EQ. OB_Jn(i,bi,bj) ) THEN
                icomptest = icomptest + 1
               ENDIF
               wetlocal = grdchk_maskxz(i,k,bi,bj,iobcs)
#endif
              ELSEIF ( ncvarfname(grdchkvarindex)
     &                    .EQ. xx_obcss_file ) THEN
#ifdef ALLOW_OBCSS_CONTROL
               IF (grdchk_maskxz(i,k,bi,bj,iobcs) .GT. 0.
     &              .AND. j .EQ. OB_Js(i,bi,bj) ) THEN
                icomptest = icomptest + 1
               ENDIF
               wetlocal = grdchk_maskxz(i,k,bi,bj,iobcs)
#endif
              ELSEIF ( ncvarfname(grdchkvarindex)
     &              .EQ. xx_obcse_file ) THEN
#ifdef ALLOW_OBCSE_CONTROL
               IF (grdchk_maskyz(j,k,bi,bj,iobcs) .GT. 0.
     &              .AND. i .EQ. OB_Ie(j,bi,bj) ) THEN
                icomptest = icomptest + 1
               ENDIF
               wetlocal = grdchk_maskyz(j,k,bi,bj,iobcs)
#endif
              ELSEIF ( ncvarfname(grdchkvarindex)
     &              .EQ. xx_obcsw_file ) THEN
#ifdef ALLOW_OBCSW_CONTROL
               IF ( grdchk_maskyz(j,k,bi,bj,iobcs) .GT. 0.
     &              .AND. i .EQ. OB_Iw(j,bi,bj) ) THEN
                icomptest = icomptest + 1
               ENDIF
               wetlocal = grdchk_maskyz(j,k,bi,bj,iobcs)
#endif
              ENDIF
#endif /* ALLOW_OBCS_CONTROL */
             ENDIF

             IF ( i     .EQ. itilepos .AND.
     &            j     .EQ. jtilepos .AND.
     &            k     .EQ. layer .AND.
     &            bi    .EQ. itile .AND.
     &            bj    .EQ. jtile .AND.
     &            iobcs .EQ. obcspos .AND.
     &            irec  .EQ. icvrec ) THEN
              pastit = 0
              IF ( wetlocal .NE.0 ) THEN
               nbeg = icomptest
               nend = nbeg + nend
               ierr     = 0
               WRITE(standardMessageUnit,'(a,6I5)')
     &              ' grad-res exact position met: '
               WRITE(standardMessageUnit,'(a,7I5)')
     &              ' grad-res ', grdchkwhichproc,
     &              nbeg, itilepos, jtilepos, layer,
     &              itile, jtile
               GOTO 1234
              ENDIF
             ELSEIF ( pastit .EQ. 0 .AND. wetlocal .NE.0 ) THEN
              nbeg = icomptest
              nend = nbeg + nend
              ierr     = 0
              WRITE(standardMessageUnit,'(a,6I5)')
     &             ' grad-res closest next position: '
              WRITE(standardMessageUnit,'(a,7I5)')
     &             ' grad-res ', grdchkwhichproc,
     &             nbeg, itilepos, jtilepos, layer,
     &             itile, jtile
              GOTO 1234
             ENDIF

            ENDIF
           ENDDO
           iwrk = 1
          ENDDO
          jwrk = 1
         ELSEIF (ierr .NE. 0) THEN
          itest     = itest + nwettile(bi,bj,k,iobcs)
          iwrk      = 1
          jwrk      = 1
         ENDIF

C--   End of loop over k
        ENDDO

C--   End of loop over irec records.
       ENDDO

C--   End of if myProcId statement
      ENDIF

 1234 CONTINUE

      _END_MASTER( myThid )

      _BARRIER

#endif /* ALLOW_GRDCHK */

      RETURN
      END

#include "EXF_OPTIONS.h"

CBOP
C     !ROUTINE: EXF_INIT_FIXED
C     !INTERFACE:
      SUBROUTINE EXF_INIT_FIXED( myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE EXF_INIT_FIXED
C     | o Routine to initialize EXF variables
C     |   that are kept fixed during the run.
C     *==========================================================*
C     \ev
C     !USES:
      IMPLICIT NONE

C     === Global variables ===
#include "EEPARAMS.h"
#include "SIZE.h"
#include "PARAMS.h"
#include "EXF_PARAM.h"
#include "EXF_CONSTANTS.h"
#include "EXF_INTERP_SIZE.h"
#include "EXF_INTERP_PARAM.h"

C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
C     myThid    ::  my Thread Id number
      INTEGER myThid
CEOP

C     !LOCAL VARIABLES:
C     === Local variables ===
C     msgBuf    :: Informational/error message buffer
C     errCount  :: error counter
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      INTEGER errCount
#ifdef USE_EXF_INTERPOLATION
      INTEGER j
#endif

#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_ENTER('EXF_INIT_FIXED',myThid)
#endif

      _BEGIN_MASTER( myThid )
      errCount = 0

C--   Set mask for each input field
C     ' ' = no masking; 'c' = centered mask; 'w' = western mask; 's' = southern
      hfluxmask    = 'c'
      sfluxmask    = 'c'
      atempmask    = 'c'
      aqhmask      = 'c'
      hs_mask      = 'c'
      hl_mask      = 'c'
      evapmask     = 'c'
      precipmask   = 'c'
      snowprecipmask='c'
      runoffmask   = 'c'
      saltflxmask  = 'c'
      IF ( stressIsOnCgrid ) THEN
       ustressmask = 'w'
       vstressmask = 's'
      ELSE
       ustressmask = 'c'
       vstressmask = 'c'
      ENDIF
      uwindmask    = 'c'
      vwindmask    = 'c'
      wspeedmask   = 'c'
      swfluxmask   = 'c'
      lwfluxmask   = 'c'
      swdownmask   = 'c'
      lwdownmask   = 'c'
      apressuremask= 'c'
      tidePotmask  = 'c'
      areamaskmask = 'c'
      climsstmask  = 'c'
      climsssmask  = 'c'
      climustrmask = 'w'
      climvstrmask = 's'

      IF ( useSEAICE ) THEN
C     Avoid masking of vector fields with pkg/seaice (for B/C-grid interp.)
C     but keep it for fields that might involve calculation using SST on land
       hfluxmask    = ' '
       sfluxmask    = ' '
c      atempmask    = ' '
c      aqhmask      = ' '
c      hs_mask      = ' '
c      hl_mask      = ' '
c      evapmask     = ' '
c      precipmask   = ' '
c      snowprecipmask=' '
c      runoffmask   = ' '
c      saltflxmask  = ' '
       ustressmask  = ' '
       vstressmask  = ' '
       uwindmask    = ' '
       vwindmask    = ' '
       wspeedmask   = ' '
       swfluxmask   = ' '
       swdownmask   = ' '
c      lwfluxmask   = ' '
c      lwdownmask   = ' '
       apressuremask= ' '
c      tidePotmask  = ' '
c      areamaskmask = ' '
c      climsstmask  = ' '
c      climsssmask  = ' '
       climustrmask = ' '
       climvstrmask = ' '
      ENDIF

C--   Complete the start date specifications for the forcing
C     fields to get a complete calendar date array.
C     FLDStartTime, for FLD = { uwind, vwind, wspeed, etc. },
C     returns time in seconds of first FLD record from the
C     beginning of the model integration or, if useYearlyFields,
C     from the beginning of the year.

      IF ( useAtmWind ) THEN
       IF ( uwindfile .NE. ' ' ) THEN
# ifdef ALLOW_DEBUG
        IF (debugMode) CALL DEBUG_CALL('GETFFIELD_START uwind',myThid)
# endif
        CALL EXF_GETFFIELD_START( useExfYearlyFields,
     I                     'exf', 'uwind', uwindperiod,
     I                     uwindstartdate1, uwindstartdate2,
     U                     uwindStartTime, errCount,
     I                     myThid )
       ENDIF
       IF ( vwindfile .NE. ' ' ) THEN
# ifdef ALLOW_DEBUG
        IF (debugMode) CALL DEBUG_CALL('GETFFIELD_START vwind',myThid)
# endif
        CALL EXF_GETFFIELD_START( useExfYearlyFields,
     I                     'exf', 'vwind', vwindperiod,
     I                     vwindstartdate1, vwindstartdate2,
     U                     vwindStartTime, errCount,
     I                     myThid )
       ENDIF
      ENDIF

      IF ( wspeedfile .NE. ' ' ) THEN
# ifdef ALLOW_DEBUG
       IF (debugMode) CALL DEBUG_CALL('GETFFIELD_START wspeed',myThid)
# endif
       CALL EXF_GETFFIELD_START( useExfYearlyFields,
     I                    'exf', 'wspeed', wspeedperiod,
     I                    wspeedstartdate1, wspeedstartdate2,
     U                    wspeedStartTime, errCount,
     I                    myThid )
      ENDIF

      IF ( .NOT.useAtmWind ) THEN
       IF ( ustressfile .NE. ' ' ) THEN
# ifdef ALLOW_DEBUG
        IF (debugMode)
     &     CALL DEBUG_CALL('GETFFIELD_START ustress',myThid)
# endif
        CALL EXF_GETFFIELD_START( useExfYearlyFields,
     I                     'exf', 'ustress', ustressperiod,
     I                     ustressstartdate1, ustressstartdate2,
     U                     ustressStartTime, errCount,
     I                     myThid )
       ENDIF
       IF ( vstressfile .NE. ' ' ) THEN
# ifdef ALLOW_DEBUG
        IF (debugMode)
     &     CALL DEBUG_CALL('GETFFIELD_START vstress',myThid)
# endif
        CALL EXF_GETFFIELD_START( useExfYearlyFields,
     I                     'exf', 'vstress', vstressperiod,
     I                     vstressstartdate1, vstressstartdate2,
     U                     vstressStartTime, errCount,
     I                     myThid )
       ENDIF
      ENDIF

      IF ( hfluxfile .NE. ' ' ) THEN
# ifdef ALLOW_DEBUG
       IF (debugMode) CALL DEBUG_CALL('GETFFIELD_START hflux',myThid)
# endif
       CALL EXF_GETFFIELD_START( useExfYearlyFields,
     I                    'exf', 'hflux', hfluxperiod,
     I                    hfluxstartdate1, hfluxstartdate2,
     U                    hfluxStartTime, errCount,
     I                    myThid )
      ENDIF
      IF ( sfluxfile .NE. ' ' ) THEN
# ifdef ALLOW_DEBUG
       IF (debugMode) CALL DEBUG_CALL('GETFFIELD_START sflux',myThid)
# endif
       CALL EXF_GETFFIELD_START( useExfYearlyFields,
     I                    'exf', 'sflux', sfluxperiod,
     I                    sfluxstartdate1, sfluxstartdate2,
     U                    sfluxStartTime, errCount,
     I                    myThid )
      ENDIF

#if defined(ALLOW_ATM_TEMP) || defined(SHORTWAVE_HEATING)
      IF ( swfluxfile .NE. ' '  ) THEN
# ifdef ALLOW_DEBUG
       IF (debugMode) CALL DEBUG_CALL('GETFFIELD_START swflux',myThid)
# endif
       CALL EXF_GETFFIELD_START( useExfYearlyFields,
     I                    'exf', 'swflux', swfluxperiod,
     I                    swfluxstartdate1, swfluxstartdate2,
     U                    swfluxStartTime, errCount,
     I                    myThid )
      ENDIF
#endif /* defined(ALLOW_ATM_TEMP) || defined(SHORTWAVE_HEATING) */

#ifdef ALLOW_ATM_TEMP
      IF ( atempfile .NE. ' ' ) THEN
# ifdef ALLOW_DEBUG
       IF (debugMode) CALL DEBUG_CALL('GETFFIELD_START atemp',myThid)
# endif
       CALL EXF_GETFFIELD_START( useExfYearlyFields,
     I                    'exf', 'atemp', atempperiod,
     I                    atempstartdate1, atempstartdate2,
     U                    atempStartTime, errCount,
     I                    myThid )
      ENDIF
      IF ( aqhfile .NE. ' ' ) THEN
# ifdef ALLOW_DEBUG
       IF (debugMode) CALL DEBUG_CALL('GETFFIELD_START aqh',myThid)
# endif
       CALL EXF_GETFFIELD_START( useExfYearlyFields,
     I                    'exf', 'aqh', aqhperiod,
     I                    aqhstartdate1, aqhstartdate2,
     U                    aqhStartTime, errCount,
     I                    myThid )
      ENDIF
# ifdef ALLOW_READ_TURBFLUXES
      IF ( hs_file .NE. ' ' ) THEN
#  ifdef ALLOW_DEBUG
       IF (debugMode) CALL DEBUG_CALL('GETFFIELD_START hs ',myThid)
#  endif
       CALL EXF_GETFFIELD_START( useExfYearlyFields,
     I                    'exf', 'hs_', hs_period,
     I                    hs_startdate1, hs_startdate2,
     U                    hs_StartTime, errCount,
     I                    myThid )
      ENDIF
      IF ( hl_file .NE. ' ' ) THEN
#  ifdef ALLOW_DEBUG
       IF (debugMode) CALL DEBUG_CALL('GETFFIELD_START hl ',myThid)
#  endif
       CALL EXF_GETFFIELD_START( useExfYearlyFields,
     I                    'exf', 'hl_', hl_period,
     I                    hl_startdate1, hl_startdate2,
     U                    hl_StartTime, errCount,
     I                    myThid )
      ENDIF
# endif /* ALLOW_READ_TURBFLUXES */
      IF ( lwfluxfile .NE. ' ' ) THEN
# ifdef ALLOW_DEBUG
       IF (debugMode) CALL DEBUG_CALL('GETFFIELD_START lwflux',myThid)
# endif
       CALL EXF_GETFFIELD_START( useExfYearlyFields,
     I                    'exf', 'lwflux', lwfluxperiod,
     I                    lwfluxstartdate1, lwfluxstartdate2,
     U                    lwfluxStartTime, errCount,
     I                    myThid )
      ENDIF
      IF ( precipfile .NE. ' ' ) THEN
# ifdef ALLOW_DEBUG
       IF (debugMode) CALL DEBUG_CALL('GETFFIELD_START precip',myThid)
# endif
       CALL EXF_GETFFIELD_START( useExfYearlyFields,
     I                    'exf', 'precip', precipperiod,
     I                    precipstartdate1, precipstartdate2,
     U                    precipStartTime, errCount,
     I                    myThid )
      ENDIF
      IF ( snowprecipfile .NE. ' ' ) THEN
# ifdef ALLOW_DEBUG
       IF (debugMode)
     &    CALL DEBUG_CALL('GETFFIELD_START snowprecip',myThid)
# endif
       CALL EXF_GETFFIELD_START( useExfYearlyFields,
     I                    'exf', 'snowprecip', snowprecipperiod,
     I                    snowprecipstartdate1, snowprecipstartdate2,
     U                    snowprecipStartTime, errCount,
     I                    myThid )
      ENDIF
#endif /* ALLOW_ATM_TEMP */

#ifdef EXF_READ_EVAP
      IF ( evapfile .NE. ' ' ) THEN
# ifdef ALLOW_DEBUG
       IF (debugMode) CALL DEBUG_CALL('GETFFIELD_START evap',myThid)
# endif
       CALL EXF_GETFFIELD_START( useExfYearlyFields,
     I                    'exf', 'evap', evapperiod,
     I                    evapstartdate1, evapstartdate2,
     U                    evapStartTime, errCount,
     I                    myThid )
      ENDIF
#endif /* EXF_READ_EVAP */

#ifdef ALLOW_RUNOFF
      IF ( runofffile .NE. ' ' ) THEN
# ifdef ALLOW_DEBUG
       IF (debugMode) CALL DEBUG_CALL('GETFFIELD_START runoff',myThid)
# endif
       CALL EXF_GETFFIELD_START( useExfYearlyFields,
     I                    'exf', 'runoff', runoffperiod,
     I                    runoffstartdate1, runoffstartdate2,
     U                    runoffStartTime, errCount,
     I                    myThid )
      ENDIF
#endif /* ALLOW_RUNOFF */

#ifdef ALLOW_SALTFLX
      IF ( saltflxfile .NE. ' ' ) THEN
# ifdef ALLOW_DEBUG
       IF (debugMode)
     &    CALL DEBUG_CALL('GETFFIELD_START saltflx',myThid)
# endif
       CALL EXF_GETFFIELD_START( useExfYearlyFields,
     I                    'exf', 'saltflx', saltflxperiod,
     I                    saltflxstartdate1, saltflxstartdate2,
     U                    saltflxStartTime, errCount,
     I                    myThid )
      ENDIF
#endif /* ALLOW_SALTFLX */

#ifdef ALLOW_DOWNWARD_RADIATION
      IF ( swdownfile .NE. ' ' ) THEN
# ifdef ALLOW_DEBUG
       IF (debugMode) CALL DEBUG_CALL('GETFFIELD_START swdown',myThid)
# endif
       CALL EXF_GETFFIELD_START( useExfYearlyFields,
     I                    'exf', 'swdown', swdownperiod,
     I                    swdownstartdate1, swdownstartdate2,
     U                    swdownStartTime, errCount,
     I                    myThid )
      ENDIF
      IF ( lwdownfile .NE. ' ' ) THEN
# ifdef ALLOW_DEBUG
       IF (debugMode) CALL DEBUG_CALL('GETFFIELD_START lwdown',myThid)
# endif
       CALL EXF_GETFFIELD_START( useExfYearlyFields,
     I                    'exf', 'lwdown', lwdownperiod,
     I                    lwdownstartdate1, lwdownstartdate2,
     U                    lwdownStartTime, errCount,
     I                    myThid )
      ENDIF
#endif /* ALLOW_DOWNWARD_RADIATION */

#ifdef ATMOSPHERIC_LOADING
      IF ( apressurefile .NE. ' ' ) THEN
# ifdef ALLOW_DEBUG
       IF (debugMode)
     &    CALL DEBUG_CALL('GETFFIELD_START apressure',myThid)
# endif
       CALL EXF_GETFFIELD_START( useExfYearlyFields,
     I                    'exf', 'apressure', apressureperiod,
     I                    apressurestartdate1, apressurestartdate2,
     U                    apressureStartTime, errCount,
     I                    myThid )
      ENDIF
#endif /* ATMOSPHERIC_LOADING */

#ifdef EXF_ALLOW_TIDES
      IF ( tidePotFile .NE. ' ' ) THEN
# ifdef ALLOW_DEBUG
       IF (debugMode)
     &    CALL DEBUG_CALL('GETFFIELD_START tidePot',myThid)
# endif
       CALL EXF_GETFFIELD_START( useExfYearlyFields,
     I                    'exf', 'tidePot', tidePotPeriod,
     I                    tidePotStartdate1, tidePotStartdate2,
     U                    tidePotStartTime, errCount,
     I                    myThid )
      ENDIF
#endif /* EXF_ALLOW_TIDES */

#ifdef EXF_SEAICE_FRACTION
      IF ( areamaskfile .NE. ' ' ) THEN
# ifdef ALLOW_DEBUG
       IF (debugMode)
     &    CALL DEBUG_CALL('GETFFIELD_START areamask',myThid)
# endif
       CALL EXF_GETFFIELD_START( useExfYearlyFields,
     I                    'exf', 'areamask', areamaskperiod,
     I                    areamaskstartdate1, areamaskstartdate2,
     U                    areamaskStartTime, errCount,
     I                    myThid )
      ENDIF
#endif /* EXF_SEAICE_FRACTION */

#ifdef ALLOW_OBCS
      IF ( useOBCS ) THEN
# ifdef ALLOW_DEBUG
       IF (debugMode) CALL DEBUG_CALL('GETFFIELD_START obcsN',myThid)
# endif
       CALL EXF_GETFFIELD_START( useOBCSYearlyFields,
     I                    'exf', 'obcsN', obcsNperiod,
     I                    obcsNstartdate1, obcsNstartdate2,
     U                    obcsNstartTime, errCount,
     I                    myThid )
# ifdef ALLOW_DEBUG
       IF (debugMode) CALL DEBUG_CALL('GETFFIELD_START obcsS',myThid)
# endif
       CALL EXF_GETFFIELD_START( useOBCSYearlyFields,
     I                    'exf', 'obcsS', obcsSperiod,
     I                    obcsSstartdate1, obcsSstartdate2,
     U                    obcsSstartTime, errCount,
     I                    myThid )
# ifdef ALLOW_DEBUG
       IF (debugMode) CALL DEBUG_CALL('GETFFIELD_START obcsE',myThid)
# endif
       CALL EXF_GETFFIELD_START( useOBCSYearlyFields,
     I                    'exf', 'obcsE', obcsEperiod,
     I                    obcsEstartdate1, obcsEstartdate2,
     U                    obcsEstartTime, errCount,
     I                    myThid )
# ifdef ALLOW_DEBUG
       IF (debugMode) CALL DEBUG_CALL('GETFFIELD_START obcsW',myThid)
# endif
       CALL EXF_GETFFIELD_START( useOBCSYearlyFields,
     I                    'exf', 'obcsW', obcsWperiod,
     I                    obcsWstartdate1, obcsWstartdate2,
     U                    obcsWstartTime, errCount,
     I                    myThid )
      ENDIF
# ifdef ALLOW_SEAICE
      IF ( useOBCS .AND. useSEAICE ) THEN
# ifdef ALLOW_DEBUG
       IF (debugMode) CALL DEBUG_CALL('GETFFIELD_START siobN',myThid)
# endif
       CALL EXF_GETFFIELD_START( useOBCSYearlyFields,
     I                    'exf', 'siobN', siobNperiod,
     I                    siobNstartdate1, siobNstartdate2,
     U                    siobNstartTime, errCount,
     I                    myThid )
# ifdef ALLOW_DEBUG
       IF (debugMode) CALL DEBUG_CALL('GETFFIELD_START siobS',myThid)
# endif
       CALL EXF_GETFFIELD_START( useOBCSYearlyFields,
     I                    'exf', 'siobS', siobSperiod,
     I                    siobSstartdate1, siobSstartdate2,
     U                    siobSstartTime, errCount,
     I                    myThid )
# ifdef ALLOW_DEBUG
       IF (debugMode) CALL DEBUG_CALL('GETFFIELD_START siobE',myThid)
# endif
       CALL EXF_GETFFIELD_START( useOBCSYearlyFields,
     I                    'exf', 'siobE', siobEperiod,
     I                    siobEstartdate1, siobEstartdate2,
     U                    siobEstartTime, errCount,
     I                    myThid )
# ifdef ALLOW_DEBUG
       IF (debugMode) CALL DEBUG_CALL('GETFFIELD_START siobW',myThid)
# endif
       CALL EXF_GETFFIELD_START( useOBCSYearlyFields,
     I                    'exf', 'siobW', siobWperiod,
     I                    siobWstartdate1, siobWstartdate2,
     U                    siobWstartTime, errCount,
     I                    myThid )
      ENDIF
# endif /* ALLOW_SEAICE */
#endif /* ALLOW_OBCS */

#ifdef ALLOW_CLIMSST_RELAXATION
      IF ( climsstfile .NE. ' ' ) THEN
# ifdef ALLOW_DEBUG
       IF (debugMode)
     &    CALL DEBUG_CALL('GETFFIELD_START climsst',myThid)
# endif
       CALL EXF_GETFFIELD_START( useExfYearlyFields,
     I                    'exf', 'climsst', climsstperiod,
     I                    climsststartdate1, climsststartdate2,
     U                    climsstStartTime, errCount,
     I                    myThid )
      ENDIF
#endif /* ALLOW_CLIMSST_RELAXATION */

#ifdef ALLOW_CLIMSSS_RELAXATION
      IF ( climsssfile .NE. ' ' ) THEN
# ifdef ALLOW_DEBUG
       IF (debugMode)
     &    CALL DEBUG_CALL('GETFFIELD_START climsss',myThid)
# endif
       CALL EXF_GETFFIELD_START( useExfYearlyFields,
     I                    'exf', 'climsss', climsssperiod,
     I                    climsssstartdate1, climsssstartdate2,
     U                    climsssStartTime, errCount,
     I                    myThid )
      ENDIF
#endif /* ALLOW_CLIMSSS_RELAXATION */

#ifdef ALLOW_CLIMSTRESS_RELAXATION
      IF ( climustrfile .NE. ' ' ) THEN
# ifdef ALLOW_DEBUG
       IF (debugMode)
     &    CALL DEBUG_CALL('GETFFIELD_START climustr',myThid)
# endif
       CALL EXF_GETFFIELD_START( useExfYearlyFields,
     I                    'exf', 'climustr', climustrperiod,
     I                    climustrstartdate1, climustrstartdate2,
     U                    climustrStartTime, errCount,
     I                    myThid )
      ENDIF

      IF ( climvstrfile .NE. ' ' ) THEN
# ifdef ALLOW_DEBUG
       IF (debugMode)
     &    CALL DEBUG_CALL('GETFFIELD_START climvstr',myThid)
# endif
       CALL EXF_GETFFIELD_START( useExfYearlyFields,
     I                    'exf', 'climvstr', climvstrperiod,
     I                    climvstrstartdate1, climvstrstartdate2,
     U                    climvstrStartTime, errCount,
     I                    myThid )
      ENDIF
#endif /* ALLOW_CLIMSTRESS_RELAXATION */

#ifdef USE_EXF_INTERPOLATION
C--   For vector fields, set flag to interpolate the 2 components together
C-    wind-stress:
      uvInterp_stress = ustressfile.NE.' ' .AND. vstressfile.NE.' '
     &  .AND. ustress_interpMethod.GE.1 .AND. vstress_interpMethod.GE.1
      uvInterp_stress = uvInterp_stress
     &  .AND. ustressStartTime .EQ. vstressStartTime
     &  .AND. ustressperiod    .EQ. vstressperiod
      uvInterp_stress = uvInterp_stress
     &  .AND. ustress_nlon .EQ. vstress_nlon
     &  .AND. ustress_nlat .EQ. vstress_nlat
     &  .AND. ustress_lon0 .EQ. vstress_lon0
     &  .AND. ustress_lat0 .EQ. vstress_lat0
     &  .AND. ustress_lon_inc .EQ. vstress_lon_inc
      IF ( uvInterp_stress ) THEN
        DO j=1,MIN(ustress_nlat-1,MAX_LAT_INC)
          uvInterp_stress = uvInterp_stress
     &     .AND. ustress_lat_inc(j) .EQ. vstress_lat_inc(j)
        ENDDO
      ENDIF
C-    wind:
      uvInterp_wind = uwindfile.NE.' ' .AND. vwindfile.NE.' '
     &  .AND. uwind_interpMethod.GE.1 .AND. vwind_interpMethod.GE.1
      uvInterp_wind = uvInterp_wind
     &  .AND. uwindStartTime .EQ. vwindStartTime
     &  .AND. uwindperiod    .EQ. vwindperiod
      uvInterp_wind = uvInterp_wind
     &  .AND. uwind_nlon .EQ. vwind_nlon
     &  .AND. uwind_nlat .EQ. vwind_nlat
     &  .AND. uwind_lon0 .EQ. vwind_lon0
     &  .AND. uwind_lat0 .EQ. vwind_lat0
     &  .AND. uwind_lon_inc .EQ. vwind_lon_inc
      IF ( uvInterp_wind ) THEN
        DO j=1,MIN(uwind_nlat-1,MAX_LAT_INC)
          uvInterp_wind = uvInterp_wind
     &     .AND. uwind_lat_inc(j) .EQ. vwind_lat_inc(j)
        ENDDO
      ENDIF
C-    clim wind-stress:
      uvInterp_climstr = climustrfile.NE.' ' .AND. climvstrfile.NE.' '
     &  .AND.climustr_interpMethod.GE.1 .AND.climvstr_interpMethod.GE.1
      uvInterp_climstr = uvInterp_climstr
     &  .AND. climustrStartTime .EQ. climvstrStartTime
     &  .AND. climustrperiod    .EQ. climvstrperiod
      uvInterp_climstr = uvInterp_climstr
     &  .AND. climustr_nlon .EQ. climvstr_nlon
     &  .AND. climustr_nlat .EQ. climvstr_nlat
     &  .AND. climustr_lon0 .EQ. climvstr_lon0
     &  .AND. climustr_lat0 .EQ. climvstr_lat0
     &  .AND. climustr_lon_inc .EQ. climvstr_lon_inc
      IF ( uvInterp_climstr ) THEN
        DO j=1,MIN(climustr_nlat-1,MAX_LAT_INC)
          uvInterp_climstr = uvInterp_climstr
     &     .AND. climustr_lat_inc(j) .EQ. climvstr_lat_inc(j)
        ENDDO
      ENDIF
# ifdef EXF_USE_OLD_INTERP_POLE
      uvInterp_stress = .FALSE.
      uvInterp_wind   = .FALSE.
      uvInterp_climstr= .FALSE.
# endif
#endif  /* USE_EXF_INTERPOLATION */

      IF ( errCount.GE.1 ) THEN
        WRITE(msgBuf,'(A,I3,A)')
     &       'EXF_INIT_FIXED: detected', errCount,' fatal error(s)'
        CALL PRINT_ERROR( msgBuf, myThid )
        CALL ALL_PROC_DIE( 0 )
        STOP 'ABNORMAL END: S/R EXF_INIT_FIXED'
      ENDIF

      _END_MASTER( myThid )
      _BARRIER

#ifdef ALLOW_ZENITHANGLE
      IF ( useExfZenAlbedo .OR. useExfZenIncoming ) THEN
# ifdef ALLOW_DEBUG
       IF (debugMode) CALL DEBUG_CALL('EXF_ZENITHANGLE_TABLE',myThid)
# endif
       CALL EXF_ZENITHANGLE_TABLE(myThid)
      ENDIF
#endif /* ALLOW_ZENITHANGLE */

C--   Summarize the External forcing setup.
# ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_CALL('EXF_SUMMARY',myThid)
# endif
      CALL EXF_SUMMARY( myThid )

#ifdef ALLOW_DIAGNOSTICS
      IF ( useDiagnostics ) THEN
# ifdef ALLOW_DEBUG
        IF (debugMode) CALL DEBUG_CALL('EXF_DIAGNOSTICS_INIT',myThid)
# endif
        CALL EXF_DIAGNOSTICS_INIT( myThid )
      ENDIF
#endif

#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_LEAVE('EXF_INIT_FIXED',myThid)
#endif

      RETURN
      END

#include "AUTODIFF_OPTIONS.h"
#ifdef ALLOW_CTRL
# include "CTRL_OPTIONS.h"
#endif

CBOP
C     !ROUTINE: AUTODIFF_INIT_VARIA
C     !INTERFACE:
      SUBROUTINE AUTODIFF_INIT_VARIA( myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE AUTODIFF_INIT_VARIA
C     | o Initialise to zero some active arrays
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "FFIELDS.h"
#include "SURFACE.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     myThid :: My Thread Id number
      INTEGER myThid

#ifdef ALLOW_AUTODIFF
C     !LOCAL VARIABLES:
C     == Local variables ==
C     bi,bj  :: tile indices
C     i,j,k  :: Loop counters
      INTEGER bi, bj
#ifdef ALLOW_EP_FLUX
      INTEGER i, j, k
#endif
CEOP

C--   Scalar fields
      TsurfCor = 0. _d 0
      SsurfCor = 0. _d 0

C--   Over all tiles
      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)

C-      3D arrays
#ifdef ALLOW_EP_FLUX
        DO k=1,Nr
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           EfluxY(i,j,k,bi,bj) = 0.
           EfluxP(i,j,k,bi,bj) = 0.
          ENDDO
         ENDDO
        ENDDO
#endif

       ENDDO
      ENDDO

#endif /* ALLOW_AUTODIFF */
      RETURN
      END

#include "CTRL_OPTIONS.h"
#ifdef ALLOW_STREAMICE
# include "STREAMICE_OPTIONS.h"
#endif

CBOP
C     !ROUTINE: CTRL_MAP_FORCING
C     !INTERFACE:
      SUBROUTINE CTRL_MAP_FORCING( myTime, myIter, myThid )

C     !DESCRIPTION: \bv
c     *=================================================================
c     | SUBROUTINE CTRL_MAP_FORCING
c     | Add the surface flux anomalies of the control vector
c     | to the model flux fields and update the tile halos.
c     | The control vector is defined in the header file "CTRL.h".
c     *=================================================================
C     \ev

C     !USES:
      IMPLICIT NONE

C     == Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "FFIELDS.h"
#include "CTRL_SIZE.h"
#include "CTRL.h"
#include "CTRL_GENARR.h"
#include "CTRL_DUMMY.h"
#ifdef ALLOW_STREAMICE
# include "STREAMICE.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     myTime :: time counter for this thread
C     myIter :: iteration counter for this thread
C     myThid :: thread number for this instance of the routine.
      _RL     myTime
      INTEGER myIter
      INTEGER myThid

C     !FUNCTIONS:

C     !LOCAL VARIABLES:
C     == Local variables ==
#ifdef ALLOW_GENTIM2D_CONTROL
      INTEGER bi,bj
      INTEGER i,j
      INTEGER iarr
      _RL     tmpUE(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL     tmpVN(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL     tmpUX(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL     tmpVY(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      CHARACTER*(MAX_LEN_FNAM) temp_genarr_fnam

c     == end of interface ==
CEOP

      DO bj = myByLo(myThid),myByHi(myThid)
       DO bi = myBxLo(myThid),myBxHi(myThid)
        DO j = 1-OLy,sNy+OLy
         DO i = 1-OLx,sNx+OLx
          tmpUE(i,j,bi,bj) = 0. _d 0
          tmpVN(i,j,bi,bj) = 0. _d 0
          tmpUX(i,j,bi,bj) = 0. _d 0
          tmpVY(i,j,bi,bj) = 0. _d 0
         ENDDO
        ENDDO
       ENDDO
      ENDDO

      DO bj = myByLo(myThid),myByHi(myThid)
       DO bi = myBxLo(myThid),myBxHi(myThid)
        DO j = 1,sNy
         DO i = 1,sNx
          DO iarr = 1, maxCtrlTim2D
           temp_genarr_fnam=xx_gentim2d_file(iarr)
           IF (temp_genarr_fnam(1:5).EQ.'xx_fe') tmpUE
     &       (i,j,bi,bj)=tmpUE(i,j,bi,bj)+xx_gentim2d(i,j,bi,bj,iarr)
           IF (temp_genarr_fnam(1:5).EQ.'xx_fn') tmpVN
     &        (i,j,bi,bj)=tmpVN(i,j,bi,bj)+xx_gentim2d(i,j,bi,bj,iarr)
          ENDDO
         ENDDO
        ENDDO
       ENDDO
      ENDDO

      _EXCH_XY_RL(tmpUE,myThid)
      _EXCH_XY_RL(tmpVN,myThid)
      CALL ROTATE_UV2EN_RL(tmpUX,tmpVY,tmpUE,tmpVN,
     &     .FALSE.,.TRUE.,.TRUE.,1,myThid)

      DO bj = myByLo(myThid),myByHi(myThid)
       DO bi = myBxLo(myThid),myBxHi(myThid)
        DO j = 1,sNy
         DO i = 1,sNx
          fu(i,j,bi,bj)=fu(i,j,bi,bj)+tmpUX(i,j,bi,bj)
          fv(i,j,bi,bj)=fv(i,j,bi,bj)+tmpVY(i,j,bi,bj)
          DO iarr = 1, maxCtrlTim2D
           temp_genarr_fnam=xx_gentim2d_file(iarr)
           IF (temp_genarr_fnam(1:7).EQ.'xx_qnet') Qnet(i,j,bi,bj)
     &          = Qnet(i,j,bi,bj) + xx_gentim2d(i,j,bi,bj,iarr)
           IF (temp_genarr_fnam(1:8).EQ.'xx_empmr') EmPmR(i,j,bi,bj)
     &          = EmPmR(i,j,bi,bj) + xx_gentim2d(i,j,bi,bj,iarr)
           IF (temp_genarr_fnam(1:6).EQ.'xx_qsw') Qsw(i,j,bi,bj)
     &          = Qsw(i,j,bi,bj) + xx_gentim2d(i,j,bi,bj,iarr)
           IF (temp_genarr_fnam(1:6).EQ.'xx_sst') SST(i,j,bi,bj)
     &          = SST(i,j,bi,bj) + xx_gentim2d(i,j,bi,bj,iarr)
           IF (temp_genarr_fnam(1:6).EQ.'xx_sss') SSS(i,j,bi,bj)
     &          = SSS(i,j,bi,bj) + xx_gentim2d(i,j,bi,bj,iarr)
           IF (temp_genarr_fnam(1:8).EQ.'xx_pload') pLoad(i,j,bi,bj)
     &          = pLoad(i,j,bi,bj) + xx_gentim2d(i,j,bi,bj,iarr)
           IF (temp_genarr_fnam(1:11).EQ.'xx_saltflux')
     &          saltFlux(i,j,bi,bj) = saltFlux(i,j,bi,bj)
     &                             + xx_gentim2d(i,j,bi,bj,iarr)
           IF (temp_genarr_fnam(1:5).EQ.'xx_fu') fu(i,j,bi,bj)
     &          = fu(i,j,bi,bj) + xx_gentim2d(i,j,bi,bj,iarr)
           IF (temp_genarr_fnam(1:5).EQ.'xx_fv') fv(i,j,bi,bj)
     &          = fv(i,j,bi,bj) + xx_gentim2d(i,j,bi,bj,iarr)
          ENDDO
          ENDDO
         ENDDO
        ENDDO
       ENDDO

# ifdef ALLOW_STREAMICE
       IF ( useStreamIce ) THEN
        DO bj = myByLo(myThid), myByHi(myThid)
         DO bi = myBxLo(myThid), myBxHi(myThid)
          DO j = 1-OLy,sNy+OLy
           DO i = 1-OLx,sNx+OLx
            DO iarr = 1, maxCtrlTim2D
             temp_genarr_fnam=xx_gentim2d_file(iarr)
             IF (temp_genarr_fnam(1:8).EQ.'xx_bglen')
     &        B_glen(i,j,bi,bj) =
     &         xx_gentim2d(i,j,bi,bj,iarr)+
     &         B_glen_init(i,j,bi,bj)
             IF (temp_genarr_fnam(1:7).EQ.'xx_beta')
     &        C_basal_friction(i,j,bi,bj) =
     &         xx_gentim2d(i,j,bi,bj,iarr)+
     &         C_basal_fric_init(i,j,bi,bj)
             IF (temp_genarr_fnam(1:17).EQ.'xx_bdot_streamice')
     &        Bdot_streamice(i,j,bi,bj) =
     &         xx_gentim2d(i,j,bi,bj,iarr)
             IF (temp_genarr_fnam(1:11).EQ.'xx_bdot_max') THEN
               streamice_bdot_maxmelt_v(i,j,bi,bj) =
     &          xx_gentim2d(i,j,bi,bj,iarr)
             ENDIF
            ENDDO
           ENDDO
          ENDDO
         ENDDO
        ENDDO
       ENDIF
# endif /* ALLOW_STREAMICE */

       CALL EXCH_XY_RS( Qnet , myThid )
       CALL EXCH_XY_RS( EmPmR , myThid )
       CALL EXCH_XY_RS( Qsw , myThid )
       CALL EXCH_XY_RS( SST , myThid )
       CALL EXCH_XY_RS( SSS , myThid )
       CALL EXCH_XY_RS( pLoad , myThid )
       CALL EXCH_XY_RS( saltFlux , myThid )
       CALL EXCH_UV_XY_RS( fu, fv, .TRUE., myThid )

# ifdef ALLOW_STREAMICE
       IF ( useStreamIce ) THEN
        CALL EXCH_XY_RL( streamice_bdot_maxmelt_v, myThid )
        CALL EXCH_XY_RL( C_basal_friction, myThid )
        CALL EXCH_XY_RL( B_glen, myThid )
        CALL EXCH_XY_RL( bdot_streamice, myThid )
       ENDIF
# endif /* ALLOW_STREAMICE */

#endif /* ALLOW_GENTIM2D_CONTROL */

      RETURN
      END

#include "CTRL_OPTIONS.h"

C--  File ctrl_toolbox.F: Routines to handle basic operations common in pkg/ctrl
C--  Note: basically same as ecco_toolbox routines, but copied here for package
C--  independence (pkg/ecco doesn't work with openad)
C--   Contents
C--   o CTRL_ASSIGN
C--   o CTRL_CPRLRL
C--   o CTRL_CPRSRL
C--   o CTRL_CPRSRS

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: CTRL_ASSIGN
C     !INTERFACE:
      SUBROUTINE CTRL_ASSIGN( fld, nnzloc, fill_value, myThid )
C     !DESCRIPTION: \bv
C     fill a field with fill_value
C     \ev

C     !USES:
      IMPLICIT NONE
C     == global variables ==
#include "EEPARAMS.h"
#include "SIZE.h"

C     !INPUT/OUTPUT PARAMETERS:
      INTEGER nnzloc
      _RL fld   (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nnzloc,nSx,nSy)
      _RL fill_value
      INTEGER myThid

#ifdef ALLOW_CTRL
C     !LOCAL VARIABLES:
      INTEGER bi,bj
      INTEGER i,j,k
CEOP

      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
        DO k = 1,nnzloc
         DO j = 1-OLy,sNy+OLy
          DO i = 1-OLx,sNx+OLx
            fld(i,j,k,bi,bj) = fill_value
          ENDDO
         ENDDO
        ENDDO
       ENDDO
      ENDDO

#endif /* ALLOW_CTRL */

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: CTRL_CPRLRL
C     !INTERFACE:
      SUBROUTINE CTRL_CPRLRL(
     I                   fldIn, nzIn, fldOut, nzOut,
     I                   myThid )

C     !DESCRIPTION: \bv
C     copy a field (RL) to another array (RL)
C     \ev

C     !USES:
      IMPLICIT NONE
C     == global variables ==
#include "EEPARAMS.h"
#include "SIZE.h"

C     !INPUT/OUTPUT PARAMETERS:
      INTEGER nzIn, nzOut
      _RL fldIn (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nzIn,nSx,nSy)
      _RL fldOut(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nzOut,nSx,nSy)
      INTEGER myThid

#ifdef ALLOW_CTRL
C     !LOCAL VARIABLES:
      INTEGER bi,bj
      INTEGER i,j,k
CEOP

      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
        DO k = 1,nzOut
         DO j = 1-OLy,sNy+OLy
          DO i = 1-OLx,sNx+OLx
            fldOut(i,j,k,bi,bj) = fldIn(i,j,k,bi,bj)
          ENDDO
         ENDDO
        ENDDO
       ENDDO
      ENDDO

#endif /* ALLOW_CTRL */

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: CTRL_CPRSRL
C     !INTERFACE:
      SUBROUTINE CTRL_CPRSRL(
     I                   fldIn, nzIn, fldOut, nzOut,
     I                   myThid )

C     !DESCRIPTION: \bv
C     copy a field to another array, switching from _RS to _RL
C     \ev

C     !USES:
      IMPLICIT NONE
C     == global variables ==
#include "EEPARAMS.h"
#include "SIZE.h"

C     !INPUT/OUTPUT PARAMETERS:
      INTEGER nzIn, nzOut
      _RS fldIn (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nzIn,nSx,nSy)
      _RL fldOut(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nzOut,nSx,nSy)
      INTEGER myThid

#ifdef ALLOW_CTRL
C     !LOCAL VARIABLES:
      INTEGER bi,bj
      INTEGER i,j,k
CEOP

      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
        DO k = 1,nzOut
         DO j = 1-OLy,sNy+OLy
          DO i = 1-OLx,sNx+OLx
            fldOut(i,j,k,bi,bj) = fldIn(i,j,k,bi,bj)
          ENDDO
         ENDDO
        ENDDO
       ENDDO
      ENDDO

#endif /* ALLOW_CTRL */

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: CTRL_CPRSRS
C     !INTERFACE:
      SUBROUTINE CTRL_CPRSRS(
     I                   fldIn, nzIn, fldOut, nzOut,
     I                   myThid )

C     !DESCRIPTION: \bv
C     copy a field (RS) to another array (RS)
C     \ev

C     !USES:
      IMPLICIT NONE
C     == global variables ==
#include "EEPARAMS.h"
#include "SIZE.h"

C     !INPUT/OUTPUT PARAMETERS:
      INTEGER nzIn, nzOut
      _RS fldIn (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nzIn,nSx,nSy)
      _RS fldOut(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nzOut,nSx,nSy)
      INTEGER myThid

#ifdef ALLOW_CTRL
C     !LOCAL VARIABLES:
      INTEGER bi,bj
      INTEGER i,j,k
CEOP

      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
        DO k = 1,nzOut
         DO j = 1-OLy,sNy+OLy
          DO i = 1-OLx,sNx+OLx
            fldOut(i,j,k,bi,bj) = fldIn(i,j,k,bi,bj)
          ENDDO
         ENDDO
        ENDDO
       ENDDO
      ENDDO

#endif /* ALLOW_CTRL */

      RETURN
      END

C The following to set the AMPI_FORTRANCOMPATIBLE
C  if it was placed in the configure command.
#include "ampi/userIF/libConfig.h"

#ifdef AMPI_FORTRANCOMPATIBLE
      subroutine ADTOOL_AMPI_fortranSetupTypes(adouble, areal)
#include "ampi/ampif.h"
        INTEGER adouble
        INTEGER areal
C for now just set this to be scalars of the matching type 
        AMPI_ADOUBLE_PRECISION=MPI_DOUBLE_PRECISION
        adouble=AMPI_ADOUBLE_PRECISION
        AMPI_AREAL=MPI_REAL
        areal=AMPI_AREAL
      end subroutine

      subroutine ADTOOL_AMPI_fortranCleanupTypes(adouble, areal)
#include "ampi/ampif.h"
        INTEGER adouble
        INTEGER areal
C for now do nothing
      end subroutine

      subroutine ADTOOL_AMPI_fortranSetupBindings()
#include "ampi/ampif.h"
      call ADTOOL_AMPI_sendfortranbindings(
     +     MPI_BOTTOM, MPI_IN_PLACE,
     +     MPI_STATUS_IGNORE, MPI_STATUSES_IGNORE,
     +     MPI_ERRCODES_IGNORE, MPI_ARGV_NULL, MPI_ARGVS_NULL)
      end subroutine
#endif

#include "GGL90_OPTIONS.h"

CBOP
C     !ROUTINE: GGL90_INIT_VARIA
C     !INTERFACE:
      SUBROUTINE GGL90_INIT_VARIA( myThid )

C     !DESCRIPTION: \bv
C     *================================================================*
C     | SUBROUTINE GGL90_INIT_VARIA
C     | o initialize variables
C     *================================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "GGL90.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     myThid -  Number of this instance of GGL90_INIT
      INTEGER myThid

#ifdef ALLOW_GGL90
C     !LOCAL VARIABLES:
C     == Local variables ==
C     bi,bj,I,J,K - Loop counters
      INTEGER bi, bj
      INTEGER i, j, k
CEOP

C--   Over all tiles
      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)

C-      3D arrays
        DO k=1,Nr
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           GGL90viscArU(i,j,k,bi,bj) = 0. _d 0
           GGL90viscArV(i,j,k,bi,bj) = 0. _d 0
           GGL90diffKr(i,j,k,bi,bj)  = 0. _d 0
           IF ( useIDEMIX) THEN
            GGL90TKE(i,j,k,bi,bj)=GGL90eps*maskC(i,j,k,bi,bj)
           ELSE
CML           GGL90TKE(I,J,K,bi,bj)=0. _d 0
            GGL90TKE(i,j,k,bi,bj)=GGL90TKEmin*maskC(i,j,k,bi,bj)
           ENDIF
          ENDDO
         ENDDO
        ENDDO

C-      2D arrays

       ENDDO
      ENDDO

#ifdef ALLOW_GGL90_IDEMIX
c-----------------------------------------------------------------------
c  IDEMIX
c-----------------------------------------------------------------------
C--   Over all tiles
      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)

        DO k=1,Nr
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           IDEMIX_E(i,j,k,bi,bj) = 0. _d 0
          ENDDO
         ENDDO
        ENDDO

        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          IDEMIX_F_B(i,j,bi,bj) = 0. _d 0
          IDEMIX_F_S(i,j,bi,bj) = 0. _d 0
         ENDDO
        ENDDO

       ENDDO
      ENDDO
c-----------------------------------------------------------------------
c      read in forcing fields for IDEMIX
c-----------------------------------------------------------------------
      IF ( useIDEMIX .AND. IDEMIX_tidal_file .NE. ' ' ) THEN
       CALL READ_REC_XY_RL( IDEMIX_tidal_file,IDEMIX_F_b,1,0,myThid )
       _EXCH_XY_RL(IDEMIX_F_b,myThid)

       DO bj = myByLo(myThid), myByHi(myThid)
        DO bi = myBxLo(myThid), myBxHi(myThid)
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           IDEMIX_F_b(i,j,bi,bj) = -MAX(0. _d 0,
     &          MIN(1. _d 0,IDEMIX_F_b(i,j,bi,bj)))
C     fraction that enters IW field
           IDEMIX_F_b(i,j,bi,bj) = IDEMIX_frac_F_b*
CML     &          IDEMIX_F_b(i,j,bi,bj)*recip_rhoConst
     &          IDEMIX_F_b(i,j,bi,bj)/1024. _d 0
          ENDDO
         ENDDO
        ENDDO
       ENDDO
      ENDIF

      IF ( useIDEMIX .AND. IDEMIX_wind_file .NE. ' ' ) THEN
       CALL READ_REC_XY_RL( IDEMIX_wind_file ,IDEMIX_F_s,1,0,myThid )
       _EXCH_XY_RL(IDEMIX_F_s,myThid)
       DO bj = myByLo(myThid), myByHi(myThid)
        DO bi = myBxLo(myThid), myBxHi(myThid)
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           IDEMIX_F_s(i,j,bi,bj) = MAX(0. _d 0,
     &          MIN(1. _d 0,IDEMIX_F_s(i,j,bi,bj)))
C     fraction that leaves mixed layer
           IDEMIX_F_s(i,j,bi,bj) = IDEMIX_frac_F_s*
CML     &          IDEMIX_F_s(i,j,bi,bj)*recip_rhoConst
     &          IDEMIX_F_s(i,j,bi,bj)/1024.
          ENDDO
         ENDDO
        ENDDO
       ENDDO
      ENDIF
#endif /* ALLOW_GGL90_IDEMIX */

      IF ( nIter0.NE.0 .OR. pickupSuff.NE.' ' ) THEN
       CALL GGL90_READ_PICKUP( nIter0, myThid )
      ELSE
C--   Read initial turbulent kinetic energy thickness from file if available.
       IF ( GGL90TKEFile .NE. ' ' ) THEN
        CALL READ_FLD_XYZ_RL( GGL90TKEFile, ' ', GGL90TKE, 0, myThid )
        _EXCH_XYZ_RL(GGL90TKE,myThid)
        DO bj=myByLo(myThid),myByHi(myThid)
         DO bi=myBxLo(myThid),myBxHi(myThid)
          DO k=1,Nr
           DO j=1-OLy,sNy+OLy
            DO i=1-OLx,sNx+OLx
             GGL90TKE(i,j,k,bi,bj) = MAX(GGL90TKE(i,j,k,bi,bj),
     &            GGL90TKEmin)*maskC(i,j,k,bi,bj)
            ENDDO
           ENDDO
          ENDDO
         ENDDO
        ENDDO
       ENDIF
      ENDIF

#endif /*  ALLOW_GGL90  */

      RETURN
      END

#include "GAD_OPTIONS.h"

CBOP
C !ROUTINE: GAD_DST3FL_ADV_R

C !INTERFACE: ==========================================================
      SUBROUTINE GAD_DST3FL_ADV_R(
     I           bi,bj,k,dTarg,
     I           rTrans, wFld,
     I           tracer,
     O           wT,
     I           myThid )

C !DESCRIPTION:
C  Calculates the area integrated vertical flux due to advection of a tracer
C  using 3rd Order DST Scheme with flux limiting

C !USES: ===============================================================
      IMPLICIT NONE

C     == GLobal variables ==
#include "SIZE.h"
#include "GRID.h"
#include "GAD.h"

C     == Routine arguments ==
C !INPUT PARAMETERS: ===================================================
C  bi,bj             :: tile indices
C  k                 :: vertical level
C  deltaTloc         :: local time-step (s)
C  rTrans            :: vertical volume transport
C  wFld              :: vertical flow
C  tracer            :: tracer field
C  myThid            :: thread number
      INTEGER bi,bj,k
      _RL dTarg
      _RL rTrans(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL wFld  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL tracer(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      INTEGER myThid

C !OUTPUT PARAMETERS: ==================================================
C  wT                :: vertical advective flux
      _RL wT    (1-OLx:sNx+OLx,1-OLy:sNy+OLy)

C     == Local variables ==
C !LOCAL VARIABLES: ====================================================
C  i,j               :: loop indices
C  km1               :: =max( k-1 , 1 )
C  wLoc              :: velocity, vertical component
C  wCFL              :: Courant-Friedrich-Levy number
      INTEGER i,j,kp1,km1,km2
      _RL Rjm,Rj,Rjp,wCFL,d0,d1
      _RL psiP,psiM,thetaP,thetaM
      _RL wLoc
      _RL thetaMax
      PARAMETER( thetaMax = 1.D+20 )

      km2=MAX(1,k-2)
      km1=MAX(1,k-1)
      kp1=MIN(Nr,k+1)

      DO j=1-OLy,sNy+OLy
       DO i=1-OLx,sNx+OLx
#if (defined ALLOW_AUTODIFF && defined TARGET_NEC_SX)
C     These lines make TAF create vectorizable code
        thetaP = 0. _d 0
        thetaM = 0. _d 0
#endif
        Rjp=(tracer(i,j,k)-tracer(i,j,kp1))
     &         *maskC(i,j,kp1,bi,bj)
        Rj =(tracer(i,j,km1)-tracer(i,j,k))
     &         *maskC(i,j,k,bi,bj)*maskC(i,j,km1,bi,bj)
        Rjm=(tracer(i,j,km2)-tracer(i,j,km1))
     &         *maskC(i,j,km1,bi,bj)

        wLoc = wFld(i,j)
        wCFL = ABS(wLoc*dTarg*recip_drC(k))
        d0=(2. _d 0 -wCFL)*(1. _d 0 -wCFL)*oneSixth
        d1=(1. _d 0 -wCFL*wCFL)*oneSixth

C-      the old version: can produce overflow, division by zero,
C       and is wrong for tracer with low concentration:
c       thetaP=Rjm/(1.D-20+Rj)
c       thetaM=Rjp/(1.D-20+Rj)
C-      the right expression, but not bounded:
c       thetaP=0.D0
c       thetaM=0.D0
c       IF (Rj.NE.0.D0) thetaP=Rjm/Rj
c       IF (Rj.NE.0.D0) thetaM=Rjp/Rj
C-      prevent |thetaP,M| to reach too big value:
        IF ( ABS(Rj)*thetaMax .LE. ABS(Rjm) ) THEN
          thetaP=SIGN(thetaMax,Rjm*Rj)
        ELSE
          thetaP=Rjm/Rj
        ENDIF
        IF ( ABS(Rj)*thetaMax .LE. ABS(Rjp) ) THEN
          thetaM=SIGN(thetaMax,Rjp*Rj)
        ELSE
          thetaM=Rjp/Rj
        ENDIF

        psiP=d0+d1*thetaP
        psiP=MAX(0. _d 0,MIN(MIN(1. _d 0,psiP),
     &                       thetaP*(1. _d 0 -wCFL)/(wCFL+1. _d -20) ))
        psiM=d0+d1*thetaM
        psiM=MAX(0. _d 0,MIN(MIN(1. _d 0,psiM),
     &                       thetaM*(1. _d 0 -wCFL)/(wCFL+1. _d -20) ))

        wT(i,j)=
     &   0.5*(rTrans(i,j)+ABS(rTrans(i,j)))
     &      *( tracer(i,j, k ) + psiM*Rj )
     &  +0.5*(rTrans(i,j)-ABS(rTrans(i,j)))
     &      *( tracer(i,j,km1) - psiP*Rj )

       ENDDO
      ENDDO

      RETURN
      END

#include "GAD_OPTIONS.h"

CBOP
C     !ROUTINE: GAD_U3C4_IMPL_R
C     !INTERFACE:
      SUBROUTINE GAD_U3C4_IMPL_R(
     I           bi,bj,k, iMin,iMax,jMin,jMax,
     I           advectionScheme, deltaTarg, rTrans, recip_hFac,
     O           a5d, b5d, c5d, d5d, e5d,
     I           myThid )

C     !DESCRIPTION:
C     Compute matrix element to solve vertical advection implicitly
C      using 3rd order upwind advection scheme,
C         or 3rd order Direct Space and Time advection scheme,
C         or 4th order Centered advection scheme.
C     Method:
C      contribution of vertical transport at interface k is added
C      to matrix lines k and k-1

C     !USES:
      IMPLICIT NONE

C     == Global variables ===
#include "SIZE.h"
#include "GRID.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GAD.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine Arguments ==
C     bi,bj        :: tile indices
C     k            :: vertical level
C     iMin,iMax    :: computation domain
C     jMin,jMax    :: computation domain
C  advectionScheme :: advection scheme to use
C     deltaTarg    :: time step
C     rTrans       :: vertical volume transport
C     recip_hFac   :: inverse of cell open-depth factor
C     a5d          :: 2nd  lower diag of pentadiagonal matrix
C     b5d          :: 1rst lower diag of pentadiagonal matrix
C     c5d          :: main diag       of pentadiagonal matrix
C     d5d          :: 1rst upper diag of pentadiagonal matrix
C     e5d          :: 2nd  upper diag of pentadiagonal matrix
C     myThid       :: thread number
      INTEGER bi,bj,k
      INTEGER iMin,iMax,jMin,jMax
      INTEGER advectionScheme
      _RL     deltaTarg(Nr)
      _RL     rTrans(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RS recip_hFac(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL     a5d   (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL     b5d   (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL     c5d   (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL     d5d   (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL     e5d   (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      INTEGER myThid

C     == Local Variables ==
C     i,j          :: loop indices
C     kp1          :: =min( k+1 , Nr )
C     km2          :: =max( k-2 , 1 )
C     rCenter      :: centered contribution
C     rUpwind      :: upwind   contribution
C     rC4km, rC4kp :: high order contribution
C     rHigh        :: high order term factor
      LOGICAL flagC4
      INTEGER i,j,kp1,km2
#if (defined ALLOW_AUTODIFF && defined TARGET_NEC_SX)
      _RL rC4km2D  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL rC4kp2D  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL rCenter2D(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL rUpwind2D(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
#endif
      _RL wCFL, rCenter, rUpwind
      _RL rC4km, rC4kp, rHigh
      _RL mskM, mskP, maskM2, maskP1
      _RL deltaTcfl
CEOP

C--   process interior interface only:
      IF ( k.GT.1 .AND. k.LE.Nr ) THEN

      km2=MAX(1,k-2)
      kp1=MIN(Nr,k+1)
      maskP1 = 1. _d 0
      maskM2 = 1. _d 0
      IF ( k.LE.2 ) maskM2 = 0. _d 0
      IF ( k.GE.Nr) maskP1 = 0. _d 0
      flagC4 = advectionScheme.EQ.ENUM_CENTERED_4TH
     &         .AND. k.GT.2 .AND. k.LT.Nr

C--    Add centered, upwind and high-order contributions
       deltaTcfl = deltaTarg(k)
#if (defined ALLOW_AUTODIFF && defined TARGET_NEC_SX)
       DO j=jMin,jMax
        DO i=iMin,iMax
         rCenter2D(i,j) =
     &        0.5 _d 0 *rTrans(i,j)*recip_rA(i,j,bi,bj)*rkSign
         mskM   = maskC(i,j,km2,bi,bj)*maskM2
         mskP   = maskC(i,j,kp1,bi,bj)*maskP1
         IF ( flagC4 .AND. mskM*mskP.GT.0. _d 0 ) THEN
          rUpwind2D(i,j) = 0. _d 0
          rC4km2D  (i,j) = oneSixth*rCenter*mskM
          rC4kp2D  (i,j) = oneSixth*rCenter*mskP
         ELSEIF ( advectionScheme.EQ.ENUM_DST3 ) THEN
          wCFL = deltaTcfl*ABS(rTrans(i,j))
     &            *recip_rA(i,j,bi,bj)*recip_drC(k)
     &            *recip_deepFac2F(k)*recip_rhoFacF(k)
          rHigh  = (1. _d 0 -wCFL*wCFL)*oneSixth
c         rUpwind2D(i,j) = (2. _d 0*rHigh - wCFL)*ABS(rCenter)
          rUpwind2D(i,j) = (2. _d 0*rHigh )*ABS(rCenter)
          rC4km2D  (i,j) =  rHigh * (rCenter+ABS(rCenter))*mskM
          rC4kp2D  (i,j) =  rHigh * (rCenter-ABS(rCenter))*mskP
         ELSE
          rUpwind2D(i,j) =  2. _d 0*oneSixth*ABS(rCenter)
          rC4km2D  (i,j) = oneSixth*(rCenter+ABS(rCenter))*mskM
          rC4kp2D  (i,j) = oneSixth*(rCenter-ABS(rCenter))*mskP
         ENDIF
        ENDDO
       ENDDO
#endif /* ALLOW_AUTODIFF and TARGET_NEC_SX */
       DO j=jMin,jMax
         DO i=iMin,iMax
#if (defined ALLOW_AUTODIFF && defined TARGET_NEC_SX)
           rC4km   = rC4km2D  (i,j)
           rC4kp   = rC4kp2D  (i,j)
           rCenter = rCenter2D(i,j)
           rUpwind = rUpwind2D(i,j)
#else
           rCenter= 0.5 _d 0 *rTrans(i,j)*recip_rA(i,j,bi,bj)*rkSign
           mskM   = maskC(i,j,km2,bi,bj)*maskM2
           mskP   = maskC(i,j,kp1,bi,bj)*maskP1
           IF ( flagC4 .AND. mskM*mskP.GT.0. _d 0 ) THEN
            rUpwind= 0. _d 0
            rC4km  = oneSixth*rCenter*mskM
            rC4kp  = oneSixth*rCenter*mskP
           ELSEIF ( advectionScheme.EQ.ENUM_DST3 ) THEN
            wCFL = deltaTcfl*ABS(rTrans(i,j))
     &            *recip_rA(i,j,bi,bj)*recip_drC(k)
     &            *recip_deepFac2F(k)*recip_rhoFacF(k)
            rHigh  = (1. _d 0 -wCFL*wCFL)*oneSixth
c           rUpwind= (2. _d 0*rHigh - wCFL)*ABS(rCenter)
            rUpwind= (2. _d 0*rHigh )*ABS(rCenter)
            rC4km  =  rHigh * (rCenter+ABS(rCenter))*mskM
            rC4kp  =  rHigh * (rCenter-ABS(rCenter))*mskP
           ELSE
            rUpwind=  2. _d 0*oneSixth*ABS(rCenter)
            rC4km  = oneSixth*(rCenter+ABS(rCenter))*mskM
            rC4kp  = oneSixth*(rCenter-ABS(rCenter))*mskP
           ENDIF
#endif /* ALLOW_AUTODIFF and TARGET_NEC_SX */
           a5d(i,j,k)   = a5d(i,j,k)
     &                  + rC4km
     &                   *deltaTarg(k)
     &                   *recip_hFac(i,j,k)*recip_drF(k)
     &                   *recip_deepFac2C(k)*recip_rhoFacC(k)
           b5d(i,j,k)   = b5d(i,j,k)
     &                  - ( (rCenter+rUpwind) + rC4km )
     &                   *deltaTarg(k)
     &                   *recip_hFac(i,j,k)*recip_drF(k)
     &                   *recip_deepFac2C(k)*recip_rhoFacC(k)
           c5d(i,j,k)   = c5d(i,j,k)
     &                  - ( (rCenter-rUpwind) + rC4kp )
     &                   *deltaTarg(k)
     &                   *recip_hFac(i,j,k)*recip_drF(k)
     &                   *recip_deepFac2C(k)*recip_rhoFacC(k)
           d5d(i,j,k)   = d5d(i,j,k)
     &                  + rC4kp
     &                   *deltaTarg(k)
     &                   *recip_hFac(i,j,k)*recip_drF(k)
     &                   *recip_deepFac2C(k)*recip_rhoFacC(k)
           b5d(i,j,k-1) = b5d(i,j,k-1)
     &                  - rC4km
     &                   *deltaTarg(k-1)
     &                   *recip_hFac(i,j,k-1)*recip_drF(k-1)
     &                   *recip_deepFac2C(k-1)*recip_rhoFacC(k-1)
           c5d(i,j,k-1) = c5d(i,j,k-1)
     &                  + ( (rCenter+rUpwind) + rC4km )
     &                   *deltaTarg(k-1)
     &                   *recip_hFac(i,j,k-1)*recip_drF(k-1)
     &                   *recip_deepFac2C(k-1)*recip_rhoFacC(k-1)
           d5d(i,j,k-1) = d5d(i,j,k-1)
     &                  + ( (rCenter-rUpwind) + rC4kp )
     &                   *deltaTarg(k-1)
     &                   *recip_hFac(i,j,k-1)*recip_drF(k-1)
     &                   *recip_deepFac2C(k-1)*recip_rhoFacC(k-1)
           e5d(i,j,k-1) = e5d(i,j,k-1)
     &                  - rC4kp
     &                   *deltaTarg(k-1)
     &                   *recip_hFac(i,j,k-1)*recip_drF(k-1)
     &                   *recip_deepFac2C(k-1)*recip_rhoFacC(k-1)
         ENDDO
       ENDDO

C--   process interior interface only: end
      ENDIF

      RETURN
      END

C taping --------------------------------------------


      subroutine push_s0(x)
C $OpenAD$ INLINE DECLS
      use OAD_tape
      implicit none
      double precision :: x
C $OpenAD$ END DECLS
      if(oad_dt_sz .lt. oad_dt_ptr) call oad_dt_grow()
      oad_dt(oad_dt_ptr)=x; oad_dt_ptr=oad_dt_ptr+1
      end subroutine 

      subroutine pop_s0(x)
C $OpenAD$ INLINE DECLS
      use OAD_tape
      implicit none
      double precision :: x
C $OpenAD$ END DECLS
      oad_dt_ptr=oad_dt_ptr-1
      x=oad_dt(oad_dt_ptr)
      end subroutine

      subroutine push_s1(x)
C $OpenAD$ INLINE DECLS
      use OAD_tape
      implicit none
      double precision :: x(:)
C $OpenAD$ END DECLS
      oad_chunk_size=size(x,1)
      if(oad_dt_sz .lt. oad_dt_ptr+oad_chunk_size)
     + call oad_dt_grow()
      oad_dt(oad_dt_ptr:oad_dt_ptr+oad_chunk_size-1)=
     +x
      oad_dt_ptr=oad_dt_ptr+oad_chunk_size
      end subroutine 

      subroutine pop_s1(x)
C $OpenAD$ INLINE DECLS
      use OAD_tape
      implicit none
      double precision :: x(:)
C $OpenAD$ END DECLS
      oad_chunk_size=size(x,1)
      oad_dt_ptr=oad_dt_ptr-oad_chunk_size
      x=oad_dt(oad_dt_ptr:oad_dt_ptr+oad_chunk_size-1)
      end subroutine

      subroutine push_s2(x)
C $OpenAD$ INLINE DECLS
      use OAD_tape
      implicit none
      double precision :: x(:,:)
C $OpenAD$ END DECLS
      oad_chunk_size=size(x,1)*size(x,2)
      if(oad_dt_sz .lt. oad_dt_ptr+oad_chunk_size) 
     + call oad_dt_grow()
      oad_dt(oad_dt_ptr:oad_dt_ptr+oad_chunk_size-1)=
     +reshape(x,(/oad_chunk_size/))
      oad_dt_ptr=oad_dt_ptr+oad_chunk_size
      end subroutine 

      subroutine pop_s2(x)
C $OpenAD$ INLINE DECLS
      use OAD_tape
      implicit none
      double precision :: x(:,:)
C $OpenAD$ END DECLS
      oad_chunk_size=size(x,1)*size(x,2)
      oad_dt_ptr=oad_dt_ptr-oad_chunk_size
        x=reshape(oad_dt(oad_dt_ptr:oad_dt_ptr+oad_chunk_size-1),
     +shape(x))
      end subroutine

      subroutine apush(x)
C $OpenAD$ INLINE DECLS
      use OAD_tape
      use OAD_active
      implicit none
      type(active) :: x
C $OpenAD$ END DECLS
      if(oad_dt_sz .lt. oad_dt_ptr) call oad_dt_grow()
      oad_dt(oad_dt_ptr)=x%v; oad_dt_ptr=oad_dt_ptr+1
      end subroutine 

      subroutine apop(x)
C $OpenAD$ INLINE DECLS
      use OAD_tape
      use OAD_active
      implicit none
      type(active) :: x
C $OpenAD$ END DECLS
      oad_dt_ptr=oad_dt_ptr-1
      x%v=oad_dt(oad_dt_ptr)
      end subroutine

      subroutine push_i_s0(x)
C $OpenAD$ INLINE DECLS
      use OAD_tape
      implicit none
      integer :: x
C $OpenAD$ END DECLS
      if(oad_it_sz .lt. oad_it_ptr) call oad_it_grow()
      oad_it(oad_it_ptr)=x; oad_it_ptr=oad_it_ptr+1
      end subroutine 

      subroutine pop_i_s0(x)
C $OpenAD$ INLINE DECLS
      use OAD_tape
      implicit none
      integer :: x
C $OpenAD$ END DECLS
      oad_it_ptr=oad_it_ptr-1
      x=oad_it(oad_it_ptr)
      end subroutine

      subroutine push_i_s1(x)
C $OpenAD$ INLINE DECLS
      use OAD_tape
      implicit none
      integer :: x(:)
C $OpenAD$ END DECLS
      oad_chunk_size=size(x,1)
      if(oad_it_sz .lt. oad_it_ptr+oad_chunk_size) 
     +call oad_it_grow()
      oad_it(oad_it_ptr:oad_it_ptr+oad_chunk_size-1)=
     +x 
      oad_it_ptr=oad_it_ptr+oad_chunk_size
      end subroutine 

      subroutine pop_i_s1(x)
C $OpenAD$ INLINE DECLS
      use OAD_tape
      implicit none
      integer :: x(:)
C $OpenAD$ END DECLS
      oad_chunk_size=size(x,1)
      oad_it_ptr=oad_it_ptr-oad_chunk_size
      x=oad_it(oad_it_ptr:oad_it_ptr+oad_chunk_size-1)
      end subroutine

      subroutine push_i_s2(x)
C $OpenAD$ INLINE DECLS
      use OAD_tape
      implicit none
      integer :: x(:,:)
C $OpenAD$ END DECLS
      oad_chunk_size=size(x,1)*size(x,2)
      if(oad_it_sz .lt. oad_it_ptr+oad_chunk_size) 
     + call oad_it_grow()
      oad_it(oad_it_ptr:oad_it_ptr+oad_chunk_size-1)=
     +reshape(x,(/oad_chunk_size/))
      oad_it_ptr=oad_it_ptr+oad_chunk_size
      end subroutine 

      subroutine pop_i_s2(x)
C $OpenAD$ INLINE DECLS
      use OAD_tape
      implicit none
      integer :: x(:,:)
C $OpenAD$ END DECLS
      oad_chunk_size=size(x,1)*size(x,2)
      oad_it_ptr=oad_it_ptr-oad_chunk_size
        x=reshape(oad_it(oad_it_ptr:oad_it_ptr+oad_chunk_size-1),
     +shape(x))
      end subroutine

      subroutine push_b(x)
C $OpenAD$ INLINE DECLS
      use OAD_tape
      implicit none
      logical :: x
C $OpenAD$ END DECLS
      if(oad_lt_sz .lt. oad_lt_ptr) call oad_lt_grow()
      oad_lt(oad_lt_ptr)=x; oad_lt_ptr=oad_lt_ptr+1
      end subroutine 

      subroutine pop_b(x)
C $OpenAD$ INLINE DECLS
      use OAD_tape
      implicit none
      logical :: x
C $OpenAD$ END DECLS
      oad_lt_ptr=oad_lt_ptr-1
      x=oad_lt(oad_lt_ptr)
      end subroutine

      subroutine push_s(s)
C $OpenAD$ INLINE DECLS
      use OAD_tape
      implicit none
      character*(80) :: s
C $OpenAD$ END DECLS
      if(oad_st_sz .lt. oad_st_ptr) call oad_st_grow()
      oad_st(oad_st_ptr)=s; oad_st_ptr=oad_st_ptr+1
      end subroutine 

      subroutine pop_s(s)
C $OpenAD$ INLINE DECLS
      use OAD_tape
      implicit none
      character*(80) :: s
C $OpenAD$ END DECLS
      oad_st_ptr=oad_st_ptr-1
      s=oad_st(oad_st_ptr)
      end subroutine

C ----------------------- Propagation -----------------------

      subroutine saxpy(a,x,y)
C $OpenAD$ INLINE DECLS
      use OAD_active
      implicit none
      double precision, intent(in) :: a
      type(active), intent(in) :: x
      type(active), intent(inout) :: y
C $OpenAD$ END DECLS
      y%d=y%d+x%d*(a)
      end subroutine

      subroutine zeroderiv(x)
C $OpenAD$ INLINE DECLS
      use OAD_active
      implicit none
      type(active), intent(out) :: x
C $OpenAD$ END DECLS
      x%d=0.0d0
      end subroutine

      subroutine setderiv(y,x)
C $OpenAD$ INLINE DECLS
      use OAD_active
      implicit none
      type(active), intent(out) :: x
      type(active), intent(in) :: y
C $OpenAD$ END DECLS
      x%d=y%d
      end subroutine

      subroutine incderiv(y,x)
C $OpenAD$ INLINE DECLS
      use OAD_active
      implicit none
      type(active), intent(out) :: x
      type(active), intent(in) :: y
C $OpenAD$ END DECLS
      x%d=x%d+y%d
      end subroutine

      subroutine decderiv(y,x)
C $OpenAD$ INLINE DECLS
      use OAD_active
      implicit none
      type(active), intent(out) :: x
      type(active), intent(in) :: y
C $OpenAD$ END DECLS
      x%d = x%d - y%d
      end subroutine decderiv

C Checkpointing stuff ---------------------------------------

C reals -----------------------------------------------------
      subroutine cp_arg_store_real_scalar(x)
C $OpenAD$ INLINE DECLS
        use OAD_cp
        implicit none
        double precision :: x
C $OpenAD$ END DECLS
#ifdef OAD_DEBUG_CP
        !write(standardmessageunit,*)'OAD: cp write x ', x
#endif
	write(unit=cp_io_unit) x
      end subroutine 

      subroutine cp_arg_restore_real_scalar(x)
C $OpenAD$ INLINE DECLS
        use OAD_cp
        implicit none
        double precision :: x
C $OpenAD$ END DECLS
	read(unit=cp_io_unit) x
#ifdef OAD_DEBUG_CP
        !write(standardmessageunit,*)'OAD: cp read x ', x
#endif
      end subroutine 

      subroutine cp_arg_store_real_scalar_a(x)
C $OpenAD$ INLINE DECLS
        use OAD_active
        use OAD_cp
        implicit none
        type(active) :: x
C $OpenAD$ END DECLS
#ifdef OAD_DEBUG_CP
        !write(standardmessageunit,*)'OAD: cp write x ', x%v
#endif
	write(unit=cp_io_unit) x%v
      end subroutine 

      subroutine cp_arg_restore_real_scalar_a(x)
C $OpenAD$ INLINE DECLS
        use OAD_active
        use OAD_cp
        implicit none
        type(active) :: x
C $OpenAD$ END DECLS
      	read(unit=cp_io_unit) x%v
#ifdef OAD_DEBUG_CP
        !write(standardmessageunit,*)'OAD: cp read x ', x%v
#endif
      end subroutine 

      subroutine cp_arg_store_real_vector(x)
C $OpenAD$ INLINE DECLS
        use OAD_cp
        implicit none
        double precision, dimension(:) :: x
C $OpenAD$ END DECLS
#ifdef OAD_DEBUG_CP
        !write(standardmessageunit,*)'OAD: cp write x ', x(1)
#endif
	write(unit=cp_io_unit) x
      end subroutine 

      subroutine cp_arg_restore_real_vector(x)
C $OpenAD$ INLINE DECLS
        use OAD_cp
        implicit none
        double precision, dimension(:) :: x
C $OpenAD$ END DECLS
      	read(unit=cp_io_unit) x
#ifdef OAD_DEBUG_CP
        !write(standardmessageunit,*)'OAD: cp read x ', x(1)
#endif
      end subroutine 

      subroutine cp_arg_store_real_vector_a(x)
C $OpenAD$ INLINE DECLS
        use OAD_active
        use OAD_cp
        implicit none
        type(active), dimension(:) :: x
C $OpenAD$ END DECLS
#ifdef OAD_DEBUG_CP
        !write(standardmessageunit,*)'OAD: cp write x ', x(1)%v
#endif
	write(unit=cp_io_unit) x%v
      end subroutine 

      subroutine cp_arg_restore_real_vector_a(x)
C $OpenAD$ INLINE DECLS
        use OAD_active
        use OAD_cp
        implicit none
        type(active), dimension(:) :: x
C $OpenAD$ END DECLS
      	read(unit=cp_io_unit) x%v
#ifdef OAD_DEBUG_CP
        !write(standardmessageunit,*)'OAD: cp read x ', x(1)%v
#endif
      end subroutine 

      subroutine cp_arg_store_real_matrix(x)
C $OpenAD$ INLINE DECLS
        use OAD_cp
        implicit none
        double precision, dimension(:,:) :: x
C $OpenAD$ END DECLS
#ifdef OAD_DEBUG_CP
        !write(standardmessageunit,*)'OAD: cp write x ', x(1,1)
#endif
	write(unit=cp_io_unit) x
      end subroutine 

      subroutine cp_arg_restore_real_matrix(x)
C $OpenAD$ INLINE DECLS
        use OAD_cp
        implicit none
        double precision, dimension(:,:) :: x
C $OpenAD$ END DECLS
        read(unit=cp_io_unit) x
#ifdef OAD_DEBUG_CP
        !write(standardmessageunit,*)'OAD: cp read x ', x(1,1)
#endif
      end subroutine 

      subroutine cp_arg_store_real_matrix_a(x)
C $OpenAD$ INLINE DECLS
        use OAD_active
        use OAD_cp
        implicit none
        type(active), dimension(:,:) :: x
C $OpenAD$ END DECLS
#ifdef OAD_DEBUG_CP
        !write(standardmessageunit,*)'OAD: cp write x ', x(1,1)%v
#endif
	write(unit=cp_io_unit) x%v
      end subroutine 

      subroutine cp_arg_restore_real_matrix_a(x)
C $OpenAD$ INLINE DECLS
        use OAD_active
        use OAD_cp
        implicit none
        type(active), dimension(:,:) :: x
C $OpenAD$ END DECLS
      	read(unit=cp_io_unit) x%v
#ifdef OAD_DEBUG_CP
        !write(standardmessageunit,*)'OAD: cp read x ', x(1,1)%v
#endif
      end subroutine 

      subroutine cp_arg_store_real_three_tensor(x)
C $OpenAD$ INLINE DECLS
        use OAD_cp
        implicit none
        double precision, dimension(:,:,:) :: x
C $OpenAD$ END DECLS
#ifdef OAD_DEBUG_CP
        !write(standardmessageunit,*)'OAD: cp write x ', x(1,1,1)
#endif
	write(unit=cp_io_unit) x
      end subroutine 

      subroutine cp_arg_restore_real_three_tensor(x)
C $OpenAD$ INLINE DECLS
        use OAD_cp
        implicit none
        double precision, dimension(:,:,:) :: x
C $OpenAD$ END DECLS
      	read(unit=cp_io_unit) x
#ifdef OAD_DEBUG_CP
        !write(standardmessageunit,*)'OAD: cp read x ', x(1,1,1)
#endif
      end subroutine 

      subroutine cp_arg_store_real_three_tensor_a(x)
C $OpenAD$ INLINE DECLS
        use OAD_active
        use OAD_cp
        implicit none
        type(active), dimension(:,:,:) :: x
C $OpenAD$ END DECLS
#ifdef OAD_DEBUG_CP
        !write(standardmessageunit,*)'OAD: cp write x ', x(1,1,1)%v
#endif
	write(unit=cp_io_unit) x%v
      end subroutine 

      subroutine cp_arg_restore_real_three_tensor_a(x)
C $OpenAD$ INLINE DECLS
        use OAD_active
        use OAD_cp
        implicit none
        type(active), dimension(:,:,:) :: x
C $OpenAD$ END DECLS
      	read(unit=cp_io_unit) x%v
#ifdef OAD_DEBUG_CP
        !write(standardmessageunit,*)'OAD: cp read x ', x(1,1,1)%v
#endif
      end subroutine 

      subroutine cp_arg_store_real_four_tensor(x)
C $OpenAD$ INLINE DECLS
        use OAD_cp
        implicit none
        double precision, dimension(:,:,:,:) :: x
C $OpenAD$ END DECLS
#ifdef OAD_DEBUG_CP
        !write(standardmessageunit,*)'OAD: cp write x ', x(1,1,1,1)
#endif
	write(unit=cp_io_unit) x
      end subroutine 

      subroutine cp_arg_restore_real_four_tensor(x)
C $OpenAD$ INLINE DECLS
        use OAD_cp
        implicit none
        double precision, dimension(:,:,:,:) :: x
C $OpenAD$ END DECLS
	read(unit=cp_io_unit) x
#ifdef OAD_DEBUG_CP
        !write(standardmessageunit,*)'OAD: cp read x ', x(1,1,1,1)
#endif
      end subroutine 

      subroutine cp_arg_store_real_four_tensor_a(x)
C $OpenAD$ INLINE DECLS
        use OAD_active
        use OAD_cp
        implicit none
        type(active), dimension(:,:,:,:) :: x
C $OpenAD$ END DECLS
#ifdef OAD_DEBUG_CP
        !write(standardmessageunit,*)'OAD: cp write x ', x(1,1,1,1)%v
#endif
	write(unit=cp_io_unit) x%v
      end subroutine 

      subroutine cp_arg_restore_real_four_tensor_a(x)
C $OpenAD$ INLINE DECLS
        use OAD_active
        use OAD_cp
        implicit none
        type(active), dimension(:,:,:,:) :: x
C $OpenAD$ END DECLS
	read(unit=cp_io_unit) x%v
#ifdef OAD_DEBUG_CP
        !write(standardmessageunit,*)'OAD: cp read x ', x(1,1,1,1)%v
#endif 
      end subroutine

      subroutine cp_arg_store_real_five_tensor(x)
C $OpenAD$ INLINE DECLS
        use OAD_cp
        implicit none
        double precision, dimension(:,:,:,:,:) :: x
C $OpenAD$ END DECLS
#ifdef OAD_DEBUG_CP
        !write(standardmessageunit,*)'OAD: cp write x ', x(1,1,1,1,1)
#endif
	write(unit=cp_io_unit) x
      end subroutine 

      subroutine cp_arg_restore_real_five_tensor(x)
C $OpenAD$ INLINE DECLS
        use OAD_cp
        implicit none
        double precision, dimension(:,:,:,:,:) :: x
C $OpenAD$ END DECLS
	read(unit=cp_io_unit) x
#ifdef OAD_DEBUG_CP
        !write(standardmessageunit,*)'OAD: cp read x ', x(1,1,1,1,1)
#endif
      end subroutine 

      subroutine cp_arg_store_real_five_tensor_a(x)
C $OpenAD$ INLINE DECLS
        use OAD_active
        use OAD_cp
        implicit none
        type(active), dimension(:,:,:,:,:) :: x
C $OpenAD$ END DECLS
#ifdef OAD_DEBUG_CP
        !write(standardmessageunit,*)'OAD: cp write x ', x(1,1,1,1,1)%v
#endif
	write(unit=cp_io_unit) x%v
      end subroutine 

      subroutine cp_arg_restore_real_five_tensor_a(x)
C $OpenAD$ INLINE DECLS
        use OAD_active
        use OAD_cp
        implicit none
        type(active), dimension(:,:,:,:,:) :: x
C $OpenAD$ END DECLS
	read(unit=cp_io_unit) x%v
#ifdef OAD_DEBUG_CP
        !write(standardmessageunit,*)'OAD: cp read x ', x(1,1,1,1,1)%v
#endif
      end subroutine 

      subroutine cp_arg_store_real_six_tensor(x)
C $OpenAD$ INLINE DECLS
        use OAD_cp
        implicit none
        double precision, dimension(:,:,:,:,:,:) :: x
C $OpenAD$ END DECLS
#ifdef OAD_DEBUG_CP
        !write(standardmessageunit,*)'OAD: cp write x ', x(1,1,1,1,1,1)
#endif
	write(unit=cp_io_unit) x
      end subroutine 

      subroutine cp_arg_restore_real_six_tensor(x)
C $OpenAD$ INLINE DECLS
        use OAD_cp
        implicit none
        double precision, dimension(:,:,:,:,:,:) :: x
C $OpenAD$ END DECLS
	read(unit=cp_io_unit) x
#ifdef OAD_DEBUG_CP
        !write(standardmessageunit,*)'OAD: cp read x ', x(1,1,1,1,1,1)
#endif
      end subroutine 

      subroutine cp_arg_store_real_six_tensor_a(x)
C $OpenAD$ INLINE DECLS
        use OAD_active
        use OAD_cp
        implicit none
        type(active), dimension(:,:,:,:,:,:) :: x
C $OpenAD$ END DECLS
#ifdef OAD_DEBUG_CP
        !write(standardmessageunit,*)'OAD: cp write x ', x(1,1,1,1,1,1)%v
#endif
	write(unit=cp_io_unit) x%v
      end subroutine 

      subroutine cp_arg_restore_real_six_tensor_a(x)
C $OpenAD$ INLINE DECLS
        use OAD_active
        use OAD_cp
        implicit none
        type(active), dimension(:,:,:,:,:,:) :: x
C $OpenAD$ END DECLS
	read(unit=cp_io_unit) x%v
#ifdef OAD_DEBUG_CP
        !write(standardmessageunit,*)'OAD: cp read x ', x(1,1,1,1,1,1)%v
#endif
      end subroutine 

C integers -----------------------------------------------------
      subroutine cp_arg_store_integer_scalar(i)
C $OpenAD$ INLINE DECLS
        use OAD_cp
        implicit none
        integer :: i
C $OpenAD$ END DECLS
#ifdef OAD_DEBUG_CP
        !write(standardmessageunit,*)'OAD: cp write i ', i
#endif
	write(unit=cp_io_unit) i
      end subroutine 

      subroutine cp_arg_restore_integer_scalar(i)
C $OpenAD$ INLINE DECLS
        use OAD_cp
        implicit none
        integer :: i
C $OpenAD$ END DECLS
	read(unit=cp_io_unit) i
#ifdef OAD_DEBUG_CP
        !write(standardmessageunit,*)'OAD: cp read i ', i
#endif
      end subroutine 

      subroutine cp_arg_store_integer_vector(i)
C $OpenAD$ INLINE DECLS
        use OAD_cp
        implicit none
        integer, dimension(:) :: i
C $OpenAD$ END DECLS
#ifdef OAD_DEBUG_CP
        !write(standardmessageunit,*)'OAD: cp write i ', i(1)
#endif
	write(unit=cp_io_unit) i
      end subroutine 

      subroutine cp_arg_restore_integer_vector(i)
C $OpenAD$ INLINE DECLS
        use OAD_cp
        implicit none
        integer, dimension(:) :: i
C $OpenAD$ END DECLS
	read(unit=cp_io_unit) i
#ifdef OAD_DEBUG_CP
        !write(standardmessageunit,*)'OAD: cp read i ', i(1)
#endif
      end subroutine 

      subroutine cp_arg_store_integer_matrix(i)
C $OpenAD$ INLINE DECLS
        use OAD_cp
        implicit none
        integer, dimension(:,:) :: i
C $OpenAD$ END DECLS
#ifdef OAD_DEBUG_CP
        !write(standardmessageunit,*)'OAD: cp write i ', i(1,1)
#endif
	write(unit=cp_io_unit) i
      end subroutine 

      subroutine cp_arg_restore_integer_matrix(i)
C $OpenAD$ INLINE DECLS
        use OAD_cp
        implicit none
        integer, dimension(:,:) :: i
C $OpenAD$ END DECLS
	read(unit=cp_io_unit) i
#ifdef OAD_DEBUG_CP
        !write(standardmessageunit,*)'OAD: cp read i ', i(1,1)
#endif
      end subroutine 

      subroutine cp_arg_store_integer_three_tensor(i)
C $OpenAD$ INLINE DECLS
        use OAD_cp
        implicit none
        integer, dimension(:,:,:) :: i
C $OpenAD$ END DECLS
#ifdef OAD_DEBUG_CP
        !write(standardmessageunit,*)'OAD: cp write i ', i(1,1,1)
#endif
	write(unit=cp_io_unit) i
      end subroutine 

      subroutine cp_arg_restore_integer_three_tensor(i)
C $OpenAD$ INLINE DECLS
        use OAD_cp
        implicit none
        integer, dimension(:,:,:) :: i
C $OpenAD$ END DECLS
        read(unit=cp_io_unit) i
#ifdef OAD_DEBUG_CP
        !write(standardmessageunit,*)'OAD: cp read i ', i(1,1,1)
#endif
      end subroutine 

      subroutine cp_arg_store_integer_four_tensor(i)
C $OpenAD$ INLINE DECLS
        use OAD_cp
        implicit none
        integer, dimension(:,:,:,:) :: i
C $OpenAD$ END DECLS
#ifdef OAD_DEBUG_CP
        !write(standardmessageunit,*)'OAD: cp write i ', i(1,1,1,1)
#endif
        write(unit=cp_io_unit) i
      end subroutine 

      subroutine cp_arg_restore_integer_four_tensor(i)
C $OpenAD$ INLINE DECLS
        use OAD_cp
        implicit none
        integer, dimension(:,:,:,:) :: i
C $OpenAD$ END DECLS
        read(unit=cp_io_unit) i
#ifdef OAD_DEBUG_CP
        !write(standardmessageunit,*)'OAD: cp read i ', i(1,1,1,1)
#endif
      end subroutine 

      subroutine cp_arg_store_integer_five_tensor(i)
C $OpenAD$ INLINE DECLS
        use OAD_cp
        implicit none
        integer, dimension(:,:,:,:,:) :: i
C $OpenAD$ END DECLS
#ifdef OAD_DEBUG_CP
        !write(standardmessageunit,*)'OAD: cp write i ', i(1,1,1,1,1)
#endif
        write(unit=cp_io_unit) i
      end subroutine 

      subroutine cp_arg_restore_integer_five_tensor(i)
C $OpenAD$ INLINE DECLS
        use OAD_cp
        implicit none
        integer, dimension(:,:,:,:,:) :: i
C $OpenAD$ END DECLS
        read (unit=cp_io_unit) i
#ifdef OAD_DEBUG_CP
        !write(standardmessageunit,*)'OAD: cp read i ', i(1,1,1,1,1)
#endif
      end subroutine 

C strings  -----------------------------------------------------
      subroutine cp_arg_store_string_scalar(s)
C $OpenAD$ INLINE DECLS
      use OAD_cp
      implicit none
      character*(80) :: s
C $OpenAD$ END DECLS 
#ifdef OAD_DEBUG_CP
        !write(standardmessageunit,*)'OAD: cp write s ', s
#endif
        write(unit=cp_io_unit) s
      end subroutine 
      
      subroutine cp_arg_restore_string_scalar(s)
C $OpenAD$ INLINE DECLS
      use OAD_cp
      implicit none
      character*(80) :: s
C $OpenAD$ END DECLS
        read (unit=cp_io_unit) s
#ifdef OAD_DEBUG_CP
        !write(standardmessageunit,*)'OAD: cp read s ', s
#endif
      end subroutine 

C bools  -----------------------------------------------------
      subroutine cp_arg_store_bool_scalar(b)
C $OpenAD$ INLINE DECLS
        use OAD_cp
        implicit none
        logical :: b
C $OpenAD$ END DECLS
#ifdef OAD_DEBUG_CP
        !write(standardmessageunit,*)'OAD: cp write b ', b
#endif
        write(unit=cp_io_unit) b
      end subroutine 

      subroutine cp_arg_restore_bool_scalar(b)
C $OpenAD$ INLINE DECLS
        use OAD_cp
        implicit none
        logical :: b
C $OpenAD$ END DECLS
        read (unit=cp_io_unit) b
#ifdef OAD_DEBUG_CP
        !write(standardmessageunit,*)'OAD: cp read b ', b
#endif
      end subroutine 

      subroutine cp_arg_store_bool_matrix(b)
C $OpenAD$ INLINE DECLS
        use OAD_cp
        implicit none
        logical, dimension(:,:) :: b
C $OpenAD$ END DECLS
#ifdef OAD_DEBUG_CP
        !write(standardmessageunit,*)'OAD: cp write b ', b(1,1)
#endif
	write(unit=cp_io_unit) b
      end subroutine 

      subroutine cp_arg_restore_bool_matrix(b)
C $OpenAD$ INLINE DECLS
        use OAD_cp
        implicit none
        logical, dimension(:,:) :: b
C $OpenAD$ END DECLS
	read(unit=cp_io_unit) b
#ifdef OAD_DEBUG_CP
        !write(standardmessageunit,*)'OAD: cp read b ', b(1,1)
#endif
      end subroutine

C adjoints of active reals ----------------------------------
      subroutine cp_arg_store_real_scalar_a_d(x)
C $OpenAD$ INLINE DECLS
        use OAD_active
        use OAD_cp
        implicit none
        type(active) :: x
C $OpenAD$ END DECLS
#ifdef OAD_DEBUG_CP
        !write(standardmessageunit,*)'OAD: cp write x%d ', x%d
#endif
	write(unit=cp_io_unit) x%d
      end subroutine 

      subroutine cp_arg_restore_real_scalar_a_d(x)
C $OpenAD$ INLINE DECLS
        use OAD_active
        use OAD_cp
        implicit none
        type(active) :: x
C $OpenAD$ END DECLS
      	read(unit=cp_io_unit) x%d
#ifdef OAD_DEBUG_CP
        !write(standardmessageunit,*)'OAD: cp read x%d ', x%d
#endif
      end subroutine 

      subroutine cp_arg_store_real_vector_a_d(x)
C $OpenAD$ INLINE DECLS
        use OAD_active
        use OAD_cp
        implicit none
        type(active), dimension(:) :: x
C $OpenAD$ END DECLS
#ifdef OAD_DEBUG_CP
        !write(standardmessageunit,*)'OAD: cp write x%d ', x(1)%d
#endif
	write(unit=cp_io_unit) x%d
      end subroutine 

      subroutine cp_arg_restore_real_vector_a_d(x)
C $OpenAD$ INLINE DECLS
        use OAD_active
        use OAD_cp
        implicit none
        type(active), dimension(:) :: x
C $OpenAD$ END DECLS
      	read(unit=cp_io_unit) x%d
#ifdef OAD_DEBUG_CP
        !write(standardmessageunit,*)'OAD: cp read x%d ', x(1)%d
#endif
      end subroutine  

      subroutine cp_arg_store_real_matrix_a_d(x)
C $OpenAD$ INLINE DECLS
        use OAD_active
        use OAD_cp
        implicit none
        type(active), dimension(:,:) :: x
C $OpenAD$ END DECLS
#ifdef OAD_DEBUG_CP
        !write(standardmessageunit,*)'OAD: cp write x%d ', x(1,1)%d
#endif
	write(unit=cp_io_unit) x%d
      end subroutine 

      subroutine cp_arg_restore_real_matrix_a_d(x)
C $OpenAD$ INLINE DECLS
        use OAD_active
        use OAD_cp
        implicit none
        type(active), dimension(:,:) :: x
C $OpenAD$ END DECLS
      	read(unit=cp_io_unit) x%d
#ifdef OAD_DEBUG_CP
        !write(standardmessageunit,*)'OAD: cp read x%d ', x(1,1)%d
#endif
      end subroutine 

      subroutine cp_arg_store_real_three_tensor_a_d(x)
C $OpenAD$ INLINE DECLS
        use OAD_active
        use OAD_cp
        implicit none
        type(active), dimension(:,:,:) :: x
C $OpenAD$ END DECLS
#ifdef OAD_DEBUG_CP
        !write(standardmessageunit,*)'OAD: cp write x%d ', x(1,1,1)%d
#endif
	write(unit=cp_io_unit) x%d
      end subroutine 

      subroutine cp_arg_restore_real_three_tensor_a_d(x)
C $OpenAD$ INLINE DECLS
        use OAD_active
        use OAD_cp
        implicit none
        type(active), dimension(:,:,:) :: x
C $OpenAD$ END DECLS
      	read(unit=cp_io_unit) x%d
#ifdef OAD_DEBUG_CP
        !write(standardmessageunit,*)'OAD: cp read x%d ', x(1,1,1)%d
#endif
      end subroutine 

      subroutine cp_arg_store_real_four_tensor_a_d(x)
C $OpenAD$ INLINE DECLS
        use OAD_active
        use OAD_cp
        implicit none
        type(active), dimension(:,:,:,:) :: x
C $OpenAD$ END DECLS
#ifdef OAD_DEBUG_CP
        !write(standardmessageunit,*)'OAD: cp write x%d ', x(1,1,1,1)%d
#endif
	write(unit=cp_io_unit) x%d
      end subroutine 

      subroutine cp_arg_restore_real_four_tensor_a_d(x)
C $OpenAD$ INLINE DECLS
        use OAD_active
        use OAD_cp
        implicit none
        type(active), dimension(:,:,:,:) :: x
C $OpenAD$ END DECLS
	read(unit=cp_io_unit) x%d
#ifdef OAD_DEBUG_CP
        !write(standardmessageunit,*)'OAD: cp read x%d ', x(1,1,1,1)%d
#endif 
      end subroutine

      subroutine cp_arg_store_real_five_tensor_a_d(x)
C $OpenAD$ INLINE DECLS
        use OAD_active
        use OAD_cp
        implicit none
        type(active), dimension(:,:,:,:,:) :: x
C $OpenAD$ END DECLS
#ifdef OAD_DEBUG_CP
        !write(standardmessageunit,*)'OAD: cp write x%d ', x(1,1,1,1,1)%d
#endif
	write(unit=cp_io_unit) x%d
      end subroutine 

      subroutine cp_arg_restore_real_five_tensor_a_d(x)
C $OpenAD$ INLINE DECLS
        use OAD_active
        use OAD_cp
        implicit none
        type(active), dimension(:,:,:,:,:) :: x
C $OpenAD$ END DECLS
	read(unit=cp_io_unit) x%d
#ifdef OAD_DEBUG_CP
        !write(standardmessageunit,*)'OAD: cp read x%d ', x(1,1,1,1,1)%d
#endif
      end subroutine 

      subroutine cp_arg_store_real_six_tensor_a_d(x)
C $OpenAD$ INLINE DECLS
        use OAD_active
        use OAD_cp
        implicit none
        type(active), dimension(:,:,:,:,:,:) :: x
C $OpenAD$ END DECLS
#ifdef OAD_DEBUG_CP
        !write(standardmessageunit,*)'OAD: cp write x%d ', x(1,1,1,1,1,1)%d
#endif
	write(unit=cp_io_unit) x%d
      end subroutine 

      subroutine cp_arg_restore_real_six_tensor_a_d(x)
C $OpenAD$ INLINE DECLS
        use OAD_active
        use OAD_cp
        implicit none
        type(active), dimension(:,:,:,:,:,:) :: x
C $OpenAD$ END DECLS
	read(unit=cp_io_unit) x%d
#ifdef OAD_DEBUG_CP
        !write(standardmessageunit,*)'OAD: cp read x%d ', x(1,1,1,1,1,1)%d
#endif
      end subroutine   

#include "MONITOR_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: MON_STATS_LATBND_RL

C     !INTERFACE:
      SUBROUTINE MON_STATS_LATBND_RL(
     I     myNr, mskNr, kLoc, nSepBnd, ySepBnd,
     I     arr, arrMask, arrhFac, arrArea, arrY, arrDr,
     O     theMin,theMax,theMean,theVar,theVol,
     I     myThid )

C     !DESCRIPTION:
C     Calculate bare statistics of global array "\_RL arr" on each
C     Latitude band (given by \texttt{ySepBnd}).

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
      INTEGER  NLATBND
      EXTERNAL NLATBND

C     !INPUT PARAMETERS:
C     nSepBnd :: Number of latitude bands
C     ySepBnd :: Southern latitude egde (from 2 to nSepBnd, 1 is not used)
      INTEGER myNr, mskNr, kLoc
      INTEGER nSepBnd
      _RS ySepBnd(nSepBnd)
      _RL arr(1-OLx:sNx+OLx,1-OLy:sNy+OLy,myNr,nSx,nSy)
      _RS arrMask(1-OLx:sNx+OLx,1-OLy:sNy+OLy,mskNr,nSx,nSy)
      _RS arrhFac(1-OLx:sNx+OLx,1-OLy:sNy+OLy,mskNr,nSx,nSy)
      _RS arrArea(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RS arrY(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RS arrDr(myNr)
      _RL theMin(nSepBnd)
      _RL theMax(nSepBnd)
      _RL theMean(nSepBnd)
      _RL theVar(nSepBnd)
      _RL theVol(nSepBnd)
      INTEGER myThid
CEOP

C     !LOCAL VARIABLES:
C     msgBuf :: Informational/error meesage buffer
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      INTEGER bi,bj,i,j,k,n
      INTEGER km, k1, k2
      _RL tmpVal
      _RL tmpVol
      INTEGER nSepDim
      PARAMETER ( nSepDim = 200 )
      _RL tileVol (nSx,nSy,nSepDim)
      _RL tileMean(nSx,nSy,nSepDim)
      _RL tileVar (nSx,nSy,nSepDim)
      LOGICAL noPnts(nSepDim)

C-    Check local Dim
      IF ( nSepBnd .GT. nSepDim ) THEN
        WRITE(msgBuf,'(A,I6,A)')
     &  'MON_STATS_LATBND_RL: local array Dim (nSepDim=',nSepDim,
     &  ' ) too small'
        CALL PRINT_ERROR( msgBuf , myThid)
        WRITE(msgBuf,'(A,I6)')
     &  'MON_STATS_LATBND_RL: Need nSepDim to be at least =', nSepBnd
        CALL PRINT_ERROR( msgBuf , myThid)
        STOP 'ABNORMAL END: S/R MON_STATS_LATBND_RL'
      ENDIF

      IF ( kLoc.EQ.0 ) THEN
        k1 = 1
        k2 = myNr
      ELSE
        k1 = kLoc
        k2 = kLoc
      ENDIF

      DO n=1,nSepBnd
       noPnts(n)=.TRUE.
       theMin(n)=0.
       theMax(n)=0.
       theMean(n)=0.
       theVar(n)=0.
       theVol(n)=0.
      ENDDO

      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        DO n=1,nSepBnd
         tileVol (bi,bj,n) = 0.
         tileMean(bi,bj,n) = 0.
         tileVar (bi,bj,n) = 0.
        ENDDO
        DO k=k1,k2
         km = MIN(k,mskNr)
         DO j=1,sNy
          DO i=1,sNx
           n = NLATBND(nSepBnd, ySepBnd, arrY(i,j,bi,bj) )
           tmpVal=arr(i,j,k,bi,bj)
           IF (arrMask(i,j,km,bi,bj).NE.0. .AND. noPnts(n)) THEN
            theMin(n)=tmpVal
            theMax(n)=tmpVal
            noPnts(n)=.FALSE.
           ENDIF
           IF (arrMask(i,j,km,bi,bj).NE.0.) THEN
            theMin(n)=MIN(theMin(n),tmpVal)
            theMax(n)=MAX(theMax(n),tmpVal)
            tmpVol = arrArea(i,j,bi,bj)*arrhFac(i,j,km,bi,bj)*arrDr(k)
     &                                 *arrMask(i,j,km,bi,bj)
            tileVol (bi,bj,n) = tileVol (bi,bj,n) + tmpVol
            tileMean(bi,bj,n) = tileMean(bi,bj,n) + tmpVol*tmpVal
            tileVar (bi,bj,n) = tileVar (bi,bj,n) + tmpVol*tmpVal*tmpVal
           ENDIF
          ENDDO
         ENDDO
        ENDDO
       ENDDO
      ENDDO

      DO n=1,nSepBnd
       CALL GLOBAL_SUM_TILE_RL( tileVol(1,1,n) , theVol(n) , myThid )
       CALL GLOBAL_SUM_TILE_RL( tileMean(1,1,n), theMean(n), myThid )
       CALL GLOBAL_SUM_TILE_RL( tileVar(1,1,n) , theVar(n) , myThid )
      ENDDO

      DO n=1,nSepBnd
       IF (theVol(n).GT.0.) THEN
        theMean(n)= theMean(n)/theVol(n)
        theVar(n) = theVar(n) /theVol(n)
        theVar(n) = theVar(n) -theMean(n)*theMean(n)
        IF ( noPnts(n) ) theMin(n) = theMean(n)
        theMin(n) = -theMin(n)
        _GLOBAL_MAX_RL(theMin(n), myThid)
        theMin(n)=-theMin(n)
        IF ( noPnts(n) ) theMax(n) = theMin(n)
        _GLOBAL_MAX_RL(theMax(n), myThid)
       ENDIF
      ENDDO

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: NLATBND

C     !INTERFACE:
      INTEGER FUNCTION NLATBND( nBnd, yBnd, yLoc )
      IMPLICIT NONE

C     !DESCRIPTION:
C     Find the latidude band of yLoc in nSep strip

C     !INPUT PARAMETERS:
C     nBnd :: Number of latitude bands
C     yBnd :: latitude of southern boundary (for each lat. band)
C     yLoc :: current latitude
      INTEGER nBnd
      _RS yBnd(nBnd)
      _RS yLoc
CEOP

C     !LOCAL VARIABLES:
      INTEGER n

      NLATBND = 1
      DO n=2,nBnd
       IF (yLoc .GT. yBnd(n)) NLATBND = n
      ENDDO

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#include "THSICE_OPTIONS.h"
#ifdef ALLOW_GENERIC_ADVDIFF
# include "GAD_OPTIONS.h"
#endif
#ifdef ALLOW_AUTODIFF
# include "AUTODIFF_OPTIONS.h"
#endif

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C !ROUTINE: THSICE_ADVECTION

C !INTERFACE: ==========================================================
      SUBROUTINE THSICE_ADVECTION(
     I     tracerIdentity,
     I     advectionScheme,
     I     useGridArea,
     I     uTrans, vTrans, maskOc, deltaTadvect, iceEps,
     U     iceVol, iceFld,
     O     afx, afy,
     I     bi, bj, myTime, myIter, myThid)

C !DESCRIPTION:
C Calculates the tendency of a sea-ice field due to advection.
C It uses the multi-dimensional method given in \ref{sect:multiDimAdvection}
C and can only be used for the non-linear advection schemes such as the
C direct-space-time method and flux-limiters.
C
C This routine is an adaption of the GAD_ADVECTION for 2D-fields.
C for Area, effective thickness or other sea-ice field,
C  the contribution iceFld*div(u) (that is present in gad_advection)
C  is not included here.
C
C The algorithm is as follows:
C \begin{itemize}
C \item{$\theta^{(n+1/2)} = \theta^{(n)}
C      - \Delta t \partial_x (u\theta^{(n)}) + \theta^{(n)} \partial_x u$}
C \item{$\theta^{(n+2/2)} = \theta^{(n+1/2)}
C      - \Delta t \partial_y (v\theta^{(n+1/2)}) + \theta^{(n)} \partial_y v$}
C \item{$G_\theta = ( \theta^{(n+2/2)} - \theta^{(n)} )/\Delta t$}
C \end{itemize}
C
C The tendency (output) is over-written by this routine.

C !USES: ===============================================================
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#if ( defined ALLOW_DBUG_THSICE || defined ALLOW_AUTODIFF_TAMC )
# include "THSICE_SIZE.h"
#endif
#ifdef ALLOW_GENERIC_ADVDIFF
# include "GAD.h"
#endif
#ifdef ALLOW_EXCH2
#include "W2_EXCH2_SIZE.h"
#include "W2_EXCH2_TOPOLOGY.h"
#endif /* ALLOW_EXCH2 */
#ifdef ALLOW_AUTODIFF_TAMC
# include "tamc.h"
#endif

C !INPUT PARAMETERS: ===================================================
C  tracerIdentity  :: tracer identifier (required only for OBCS)
C  advectionScheme :: advection scheme to use (Horizontal plane)
C  useGridArea     :: use grid-cell Area (instead of "iceVol" field)
C  uTrans,vTrans   :: volume transports at U,V points
C  maskOc          :: oceanic mask
C  iceVol          :: sea-ice volume
C  iceFld          :: sea-ice field
C  deltaTadvect    :: time-step used for advection [s]
C  iceEps          :: small volume (to avoid division by zero if iceVol==0)
C  bi,bj           :: tile indices
C  myTime          :: current time in simulation [s]
C  myIter          :: current iteration number
C  myThid          :: my thread Id. number
      INTEGER tracerIdentity
      INTEGER advectionScheme
      LOGICAL useGridArea
      _RL uTrans(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL vTrans(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RS maskOc(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL iceFld(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL iceVol(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL deltaTadvect, iceEps
      INTEGER bi,bj
      _RL myTime
      INTEGER myIter
      INTEGER myThid

C !OUTPUT PARAMETERS: ==================================================
C  iceVol (Updated):: sea-ice volume
C  iceFld (Updated):: sea-ice field
C  afx             :: horizontal advective flux, x direction
C  afy             :: horizontal advective flux, y direction
      _RL afx   (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL afy   (1-OLx:sNx+OLx,1-OLy:sNy+OLy)

#ifdef ALLOW_GENERIC_ADVDIFF
C !LOCAL VARIABLES: ====================================================
C  maskLocC      :: 2-D array mask at grid-cell center
C  maskLocW      :: 2-D array for mask at West points
C  maskLocS      :: 2-D array for mask at South points
C [iMin,iMax]Upd :: loop range to update sea-ice field
C [jMin,jMax]Upd :: loop range to update sea-ice field
C  i,j           :: loop indices
C  uCfl          :: CFL number, zonal direction
C  vCfl          :: CFL number, meridional direction
C  af            :: 2-D array for horizontal advective flux
C  calc_fluxes_X :: logical to indicate to calculate fluxes in X dir
C  calc_fluxes_Y :: logical to indicate to calculate fluxes in Y dir
C  interiorOnly  :: only update the interior of myTile, but not the edges
C  overlapOnly   :: only update the edges of myTile, but not the interior
C  nipass        :: number of passes in multi-dimensional method
C  ipass         :: number of the current pass being made
C  myTile        :: variables used to determine which cube face
C  nCFace        :: owns a tile for cube grid runs using
C                :: multi-dim advection.
C [N,S,E,W]_edge :: true if N,S,E,W edge of myTile is an Edge of the cube
      _RS maskLocC(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RS maskLocW(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RS maskLocS(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER iMinUpd,iMaxUpd,jMinUpd,jMaxUpd
      INTEGER i,j,k
      _RL uCfl    (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL vCfl    (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL af      (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL tmpVol
      LOGICAL calc_fluxes_X, calc_fluxes_Y, withSigns
      LOGICAL interiorOnly, overlapOnly
      INTEGER nipass,ipass
      INTEGER nCFace
      LOGICAL N_edge, S_edge, E_edge, W_edge
#ifdef ALLOW_EXCH2
      INTEGER myTile
#endif
#ifdef ALLOW_AUTODIFF_TAMC
C     trNumber :: thsice tracer number
C     tkey     :: tape key (depends on tile indices and tracer index)
C     dkey     :: tape key (depends on direction and tkey)
      INTEGER trNumber, tkey, dkey
      CHARACTER*(MAX_LEN_MBUF) msgBuf
#endif
#ifdef ALLOW_DBUG_THSICE
      LOGICAL dBugFlag
      INTEGER idb,jdb,biDb
      _RL tmpFac
#endif /* ALLOW_DBUG_THSICE */
CEOP

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      k = 1
#ifdef ALLOW_AUTODIFF_TAMC
C     tracerIdentity has negative values from GAD_SI_FRAC=-5 to GAD_SI_QICE2=-9
      trNumber = GAD_SI_FRAC - tracerIdentity
      tkey = bi + (bj-1)*nSx + (ikey_dynamics-1)*nSx*nSy
      tkey = trNumber + 1 + (tkey-1)*thSIce_nAdv
      IF ( trNumber .LT. 0 .OR. trNumber+1 .GT. thSIce_nAdv) THEN
       WRITE(msgBuf,'(A,2(I3,A))')
     &      'THSICE_ADVECTION: tracerIdentity =', tracerIdentity,
     &      ' not consistent with thSIce_nAdv =', thSIce_nAdv,
     &      ', ==> check "THSICE_SIZE.h"'
       CALL PRINT_ERROR( msgBuf, myThid )
       STOP 'ABNORMAL END: S/R THSICE_ADVECTION'
      ENDIF
#endif /* ALLOW_AUTODIFF_TAMC */

#ifdef ALLOW_DBUG_THSICE
      dBugFlag = debugLevel.GE.debLevC
     &     .AND. myIter.EQ.nIter0
     &     .AND. ( tracerIdentity.EQ.GAD_SI_HICE .OR.
     &             tracerIdentity.EQ.GAD_SI_QICE2 )
c    &     .AND. tracerIdentity.EQ.GAD_SI_FRAC
      idb  = MIN(13,sNx)
      jdb  = MOD(17,sNy)
      biDb = nSx/2
#endif /* ALLOW_DBUG_THSICE */

C--   Set up work arrays with valid (i.e. not NaN) values
C     These inital values do not alter the numerical results. They
C     just ensure that all memory references are to valid floating
C     point numbers. This prevents spurious hardware signals due to
C     uninitialised but inert locations.

C--   Set tile-specific parameters for horizontal fluxes
      IF (useCubedSphereExchange) THEN
       nipass=3
#ifdef ALLOW_EXCH2
       myTile = W2_myTileList(bi,bj)
       nCFace = exch2_myFace(myTile)
       N_edge = exch2_isNedge(myTile).EQ.1
       S_edge = exch2_isSedge(myTile).EQ.1
       E_edge = exch2_isEedge(myTile).EQ.1
       W_edge = exch2_isWedge(myTile).EQ.1
#else
       nCFace = bi
       N_edge = .TRUE.
       S_edge = .TRUE.
       E_edge = .TRUE.
       W_edge = .TRUE.
#endif
      ELSE
       nipass=2
       nCFace = bi
       N_edge = .FALSE.
       S_edge = .FALSE.
       E_edge = .FALSE.
       W_edge = .FALSE.
      ENDIF

#ifdef ALLOW_AUTODIFF_TAMC
      IF (nipass .GT. maxcube) THEN
       WRITE(msgBuf,'(A,2(I3,A))') 'S/R THSICE_ADVECTION: nipass =',
     &      nipass, ' >', maxcube, ' = maxcube, ==> check "tamc.h"'
       CALL PRINT_ERROR( msgBuf, myThid )
       STOP 'ABNORMAL END: S/R THSICE_ADVECTION'
      ENDIF
#endif

C--   Start horizontal fluxes

C--   set mask West & South (and local Centered mask)
      DO j=1-OLy,sNy+OLy
       maskLocW(1-OLx,j) = 0.
       DO i=2-OLx,sNx+OLx
        maskLocW(i,j) = MIN( maskOc(i-1,j), maskOc(i,j) )
#ifdef ALLOW_OBCS
     &                * maskInW(i,j,bi,bj)
#endif /* ALLOW_OBCS */
       ENDDO
      ENDDO
      DO i=1-OLx,sNx+OLx
       maskLocS(i,1-OLy) = 0.
      ENDDO
      DO j=2-OLy,sNy+OLy
       DO i=1-OLx,sNx+OLx
        maskLocS(i,j) = MIN( maskOc(i,j-1), maskOc(i,j) )
#ifdef ALLOW_OBCS
     &                * maskInS(i,j,bi,bj)
#endif /* ALLOW_OBCS */
       ENDDO
      ENDDO
C     maskLocC is just a local copy of Ocean mask (maskOc) except if using OBCS:
C     use "maksInC" to prevent updating tracer field in OB regions
      DO j=1-OLy,sNy+OLy
       DO i=1-OLx,sNx+OLx
        maskLocC(i,j) = maskOc(i,j)
#ifdef ALLOW_OBCS
     &                * maskInC(i,j,bi,bj)
#endif /* ALLOW_OBCS */
       ENDDO
      ENDDO

      IF (useCubedSphereExchange) THEN
       withSigns = .FALSE.
       CALL FILL_CS_CORNER_UV_RS(
     &      withSigns, maskLocW,maskLocS, bi,bj, myThid )
      ENDIF

C--   Multiple passes for different directions on different tiles
C--   For cube need one pass for each of red, green and blue axes.
      DO ipass=1,nipass
#ifdef ALLOW_AUTODIFF_TAMC
       dkey = ipass + (tkey-1) * maxcube
#endif

       interiorOnly = .FALSE.
       overlapOnly  = .FALSE.
       IF (useCubedSphereExchange) THEN
C--   CubedSphere : pass 3 times, with partial update of local seaice field
        IF (ipass.EQ.1) THEN
         overlapOnly  = MOD(nCFace,3).EQ.0
         interiorOnly = MOD(nCFace,3).NE.0
         calc_fluxes_X = nCFace.EQ.6 .OR. nCFace.EQ.1 .OR. nCFace.EQ.2
         calc_fluxes_Y = nCFace.EQ.3 .OR. nCFace.EQ.4 .OR. nCFace.EQ.5
        ELSEIF (ipass.EQ.2) THEN
         overlapOnly  = MOD(nCFace,3).EQ.2
         interiorOnly = MOD(nCFace,3).EQ.1
         calc_fluxes_X = nCFace.EQ.2 .OR. nCFace.EQ.3 .OR. nCFace.EQ.4
         calc_fluxes_Y = nCFace.EQ.5 .OR. nCFace.EQ.6 .OR. nCFace.EQ.1
        ELSE
         interiorOnly = .TRUE.
         calc_fluxes_X = nCFace.EQ.5 .OR. nCFace.EQ.6
         calc_fluxes_Y = nCFace.EQ.2 .OR. nCFace.EQ.3
        ENDIF
       ELSE
C--   not CubedSphere
        calc_fluxes_X = MOD(ipass,2).EQ.1
        calc_fluxes_Y = .NOT.calc_fluxes_X
       ENDIF
#ifdef ALLOW_DBUG_THSICE
       IF (dBugFlag.AND.bi.EQ.biDb ) WRITE(6,'(A,3I4,2I5,4L5)')
     &   'ICE_adv:', tracerIdentity, ipass, bi, idb, jdb,
     &   calc_fluxes_X, calc_fluxes_Y, overlapOnly, interiorOnly
#endif /* ALLOW_DBUG_THSICE */

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C--   X direction

       IF (calc_fluxes_X) THEN

C-     Do not compute fluxes if
C       a) needed in overlap only
C   and b) the overlap of myTile are not cube-face Edges
#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE iceFld = comlev1_thsice_adv, key=dkey, byte=isbyte
CADJ STORE iceVol = comlev1_thsice_adv, key=dkey, byte=isbyte
#endif
        IF ( .NOT.overlapOnly .OR. N_edge .OR. S_edge ) THEN

C-     Advective flux in X
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
            af(i,j) = 0.
          ENDDO
         ENDDO

C-     Internal exchange for calculations in X
         IF ( overlapOnly ) THEN
          CALL FILL_CS_CORNER_TR_RL( 1, .FALSE.,
     &                               iceFld, bi,bj, myThid )
          IF ( .NOT.useGridArea )
     &    CALL FILL_CS_CORNER_TR_RL( 1, .FALSE.,
     &                               iceVol, bi,bj, myThid )
         ENDIF

C-     Compute CFL number
         IF ( useGridArea ) THEN
          DO j=1-OLy,sNy+OLy
           DO i=2-OLx,sNx+OLx
            uCfl(i,j) = deltaTadvect*(
     &          MAX( uTrans(i,j), 0. _d 0 )*recip_rA(i-1,j,bi,bj)
     &         +MAX(-uTrans(i,j), 0. _d 0 )*recip_rA( i ,j,bi,bj)
     &                               )
           ENDDO
          ENDDO
         ELSE
          DO j=1-OLy,sNy+OLy
           DO i=2-OLx,sNx+OLx
            uCfl(i,j) = deltaTadvect*(
     &        MAX( uTrans(i,j), 0. _d 0 )/MAX( iceVol(i-1,j), iceEps )
     &       +MAX(-uTrans(i,j), 0. _d 0 )/MAX( iceVol( i ,j), iceEps )
     &                               )
           ENDDO
          ENDDO
         ENDIF

         IF ( advectionScheme.EQ.ENUM_UPWIND_1RST
     &        .OR. advectionScheme.EQ.ENUM_DST2 ) THEN
          CALL GAD_DST2U1_ADV_X( bi,bj,k, advectionScheme, .FALSE.,
     I             deltaTadvect, uTrans, uCfl, iceFld,
     O             af, myThid )
#ifdef ALLOW_DBUG_THSICE
          IF (dBugFlag.AND.bi.EQ.biDb ) WRITE(6,'(A,1P4E14.6)')
     &      'ICE_adv: xFx=', af(idb,jdb), iceFld(idb,jdb),
     &       uTrans(idb,jdb), af(idb,jdb)/uTrans(idb,jdb)
#endif /* ALLOW_DBUG_THSICE */
         ELSEIF (advectionScheme.EQ.ENUM_FLUX_LIMIT) THEN
          CALL GAD_FLUXLIMIT_ADV_X( bi,bj,k, .FALSE., deltaTadvect,
     I             uTrans, uCfl, maskLocW, iceFld,
     O             af, myThid )
         ELSEIF (advectionScheme.EQ.ENUM_DST3 ) THEN
          CALL GAD_DST3_ADV_X(      bi,bj,k, .FALSE., deltaTadvect,
     I             uTrans, uCfl, maskLocW, iceFld,
     O             af, myThid )
         ELSEIF (advectionScheme.EQ.ENUM_DST3_FLUX_LIMIT ) THEN
          CALL GAD_DST3FL_ADV_X(    bi,bj,k, .FALSE., deltaTadvect,
     I             uTrans, uCfl, maskLocW, iceFld,
     O             af, myThid )
         ELSE
          STOP
     & 'THSICE_ADVECTION: adv. scheme incompatibale with multi-dim'
         ENDIF

C--   Internal exchange for next calculations in Y
         IF ( overlapOnly .AND. ipass.EQ.1 ) THEN
          CALL FILL_CS_CORNER_TR_RL( 2, .FALSE.,
     &                               iceFld, bi,bj, myThid )
          IF ( .NOT.useGridArea )
     &    CALL FILL_CS_CORNER_TR_RL( 2, .FALSE.,
     &                               iceVol, bi,bj, myThid )
         ENDIF

C--   Advective flux in X : done
        ENDIF

C-     Update the local seaice field where needed:

C     update in overlap-Only
        IF ( overlapOnly ) THEN
         iMinUpd = 1-OLx+1
         iMaxUpd = sNx+OLx-1
C--   notes: these 2 lines below have no real effect (because recip_hFac=0
C            in corner region) but safer to keep them.
         IF ( W_edge ) iMinUpd = 1
         IF ( E_edge ) iMaxUpd = sNx

#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE iceFld = comlev1_thsice_adv, key=dkey, byte=isbyte
CADJ STORE iceVol = comlev1_thsice_adv, key=dkey, byte=isbyte
CADJ STORE af     = comlev1_thsice_adv, key=dkey, byte=isbyte
#endif
         IF ( S_edge ) THEN
          IF ( useGridArea ) THEN
           DO j=1-OLy,0
            DO i=iMinUpd,iMaxUpd
             iceFld(i,j) = iceFld(i,j)
     &                    -deltaTadvect*maskLocC(i,j)
     &                                 *recip_rA(i,j,bi,bj)
     &                                 *( af(i+1,j)-af(i,j) )
            ENDDO
           ENDDO
          ELSE
           DO j=1-OLy,0
            DO i=iMinUpd,iMaxUpd
             tmpVol = iceVol(i,j)
             iceVol(i,j) = iceVol(i,j)
     &                    -deltaTadvect*maskLocC(i,j)
     &                           *( uTrans(i+1,j)-uTrans(i,j) )
             IF ( iceVol(i,j).GT.iceEps )
     &       iceFld(i,j) = ( iceFld(i,j)*tmpVol
     &                      -deltaTadvect*maskLocC(i,j)
     &                                  *( af(i+1,j)-af(i,j) )
     &                     )/iceVol(i,j)
            ENDDO
           ENDDO
          ENDIF
C-    keep advective flux (for diagnostics)
          DO j=1-OLy,0
           DO i=1-OLx+1,sNx+OLx
             afx(i,j) = af(i,j)
           ENDDO
          ENDDO
C-    end if South Edge
         ENDIF
         IF ( N_edge ) THEN
          IF ( useGridArea ) THEN
           DO j=sNy+1,sNy+OLy
            DO i=iMinUpd,iMaxUpd
             iceFld(i,j) = iceFld(i,j)
     &                    -deltaTadvect*maskLocC(i,j)
     &                                 *recip_rA(i,j,bi,bj)
     &                                 *( af(i+1,j)-af(i,j) )
            ENDDO
           ENDDO
          ELSE
           DO j=sNy+1,sNy+OLy
            DO i=iMinUpd,iMaxUpd
             tmpVol = iceVol(i,j)
             iceVol(i,j) = iceVol(i,j)
     &                    -deltaTadvect*maskLocC(i,j)
     &                           *( uTrans(i+1,j)-uTrans(i,j) )
             IF ( iceVol(i,j).GT.iceEps )
     &       iceFld(i,j) = ( iceFld(i,j)*tmpVol
     &                      -deltaTadvect*maskLocC(i,j)
     &                                   *( af(i+1,j)-af(i,j) )
     &                     )/iceVol(i,j)
            ENDDO
           ENDDO
          ENDIF
C-    keep advective flux (for diagnostics)
          DO j=sNy+1,sNy+OLy
           DO i=1-OLx+1,sNx+OLx
             afx(i,j) = af(i,j)
           ENDDO
          ENDDO
C-    end if North Edge
         ENDIF

        ELSE
#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE iceFld = comlev1_thsice_adv, key=dkey, byte=isbyte
CADJ STORE iceVol = comlev1_thsice_adv, key=dkey, byte=isbyte
CADJ STORE af     = comlev1_thsice_adv, key=dkey, byte=isbyte
#endif
C     do not only update the overlap
          jMinUpd = 1-OLy
          jMaxUpd = sNy+OLy
          IF ( interiorOnly .AND. S_edge ) jMinUpd = 1
          IF ( interiorOnly .AND. N_edge ) jMaxUpd = sNy
          IF ( useGridArea ) THEN
           DO j=jMinUpd,jMaxUpd
            DO i=1-OLx+1,sNx+OLx-1
             iceFld(i,j) = iceFld(i,j)
     &                    -deltaTadvect*maskLocC(i,j)
     &                                 *recip_rA(i,j,bi,bj)
     &                                 *( af(i+1,j)-af(i,j) )
            ENDDO
           ENDDO
          ELSE
           DO j=jMinUpd,jMaxUpd
            DO i=1-OLx+1,sNx+OLx-1
             tmpVol = iceVol(i,j)
             iceVol(i,j) = iceVol(i,j)
     &                    -deltaTadvect*maskLocC(i,j)
     &                           *( uTrans(i+1,j)-uTrans(i,j) )
             IF ( iceVol(i,j).GT.iceEps )
     &       iceFld(i,j) = ( iceFld(i,j)*tmpVol
     &                      -deltaTadvect*maskLocC(i,j)
     &                                   *( af(i+1,j)-af(i,j) )
     &                     )/iceVol(i,j)
            ENDDO
           ENDDO
          ENDIF
C-    keep advective flux (for diagnostics)
          DO j=jMinUpd,jMaxUpd
           DO i=1-OLx+1,sNx+OLx
             afx(i,j) = af(i,j)
           ENDDO
          ENDDO

C-     end if/else update overlap-Only
        ENDIF

C--   End of X direction
       ENDIF

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C--   Y direction

       IF (calc_fluxes_Y) THEN

C-     Do not compute fluxes if
C       a) needed in overlap only
C   and b) the overlap of myTile are not cube-face edges
#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE iceFld = comlev1_thsice_adv, key=dkey, byte=isbyte
CADJ STORE iceVol = comlev1_thsice_adv, key=dkey, byte=isbyte
#endif
        IF ( .NOT.overlapOnly .OR. E_edge .OR. W_edge ) THEN

C-     Advective flux in Y
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
            af(i,j) = 0.
          ENDDO
         ENDDO

C-     Internal exchange for calculations in Y
         IF ( overlapOnly ) THEN
          CALL FILL_CS_CORNER_TR_RL( 2, .FALSE.,
     &                               iceFld, bi,bj, myThid )
          IF ( .NOT.useGridArea )
     &    CALL FILL_CS_CORNER_TR_RL( 2, .FALSE.,
     &                               iceVol, bi,bj, myThid )
         ENDIF

C-     Compute CFL number
         IF ( useGridArea ) THEN
          DO j=2-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
            vCfl(i,j) = deltaTadvect*(
     &          MAX( vTrans(i,j), 0. _d 0 )*recip_rA(i,j-1,bi,bj)
     &         +MAX(-vTrans(i,j), 0. _d 0 )*recip_rA(i, j ,bi,bj)
     &                               )
           ENDDO
          ENDDO
         ELSE
          DO j=2-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
            vCfl(i,j) = deltaTadvect*(
     &        MAX( vTrans(i,j), 0. _d 0 )/MAX( iceVol(i,j-1), iceEps )
     &       +MAX(-vTrans(i,j), 0. _d 0 )/MAX( iceVol(i, j ), iceEps )
     &                               )
           ENDDO
          ENDDO
         ENDIF

         IF ( advectionScheme.EQ.ENUM_UPWIND_1RST
     &        .OR. advectionScheme.EQ.ENUM_DST2 ) THEN
          CALL GAD_DST2U1_ADV_Y( bi,bj,k, advectionScheme, .FALSE.,
     I             deltaTadvect, vTrans, vCfl, iceFld,
     O             af, myThid )
#ifdef ALLOW_DBUG_THSICE
          IF (dBugFlag.AND.bi.EQ.biDb ) WRITE(6,'(A,1P4E14.6)')
     &      'ICE_adv: yFx=', af(idb,jdb), iceFld(idb,jdb),
     &       vTrans(idb,jdb), af(idb,jdb)/vTrans(idb,jdb)
#endif /* ALLOW_DBUG_THSICE */
         ELSEIF (advectionScheme.EQ.ENUM_FLUX_LIMIT) THEN
          CALL GAD_FLUXLIMIT_ADV_Y( bi,bj,k, .FALSE., deltaTadvect,
     I             vTrans, vCfl, maskLocS, iceFld,
     O             af, myThid )
         ELSEIF (advectionScheme.EQ.ENUM_DST3 ) THEN
          CALL GAD_DST3_ADV_Y(      bi,bj,k, .FALSE., deltaTadvect,
     I             vTrans, vCfl, maskLocS, iceFld,
     O             af, myThid )
         ELSEIF (advectionScheme.EQ.ENUM_DST3_FLUX_LIMIT ) THEN
          CALL GAD_DST3FL_ADV_Y(    bi,bj,k, .FALSE., deltaTadvect,
     I             vTrans, vCfl, maskLocS, iceFld,
     O             af, myThid )
         ELSE
          STOP
     &  'THSICE_ADVECTION: adv. scheme incompatibale with mutli-dim'
         ENDIF

         IF ( overlapOnly .AND. ipass.EQ.1 ) THEN
          CALL FILL_CS_CORNER_TR_RL( 1, .FALSE.,
     &                               iceFld, bi,bj, myThid )
          IF ( .NOT.useGridArea )
     &    CALL FILL_CS_CORNER_TR_RL( 1, .FALSE.,
     &                               iceVol, bi,bj, myThid )
         ENDIF

C-     Advective flux in Y : done
        ENDIF

C-     Update the local seaice field where needed:

C      update in overlap-Only
        IF ( overlapOnly ) THEN
         jMinUpd = 1-OLy+1
         jMaxUpd = sNy+OLy-1
C- notes: these 2 lines below have no real effect (because recip_hFac=0
C         in corner region) but safer to keep them.
         IF ( S_edge ) jMinUpd = 1
         IF ( N_edge ) jMaxUpd = sNy

#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE iceFld = comlev1_thsice_adv, key=dkey, byte=isbyte
CADJ STORE iceVol = comlev1_thsice_adv, key=dkey, byte=isbyte
CADJ STORE af     = comlev1_thsice_adv, key=dkey, byte=isbyte
#endif
         IF ( W_edge ) THEN
          IF ( useGridArea ) THEN
           DO j=jMinUpd,jMaxUpd
            DO i=1-OLx,0
             iceFld(i,j) = iceFld(i,j)
     &                    -deltaTadvect*maskLocC(i,j)
     &                                 *recip_rA(i,j,bi,bj)
     &                                 *( af(i,j+1)-af(i,j) )
            ENDDO
           ENDDO
          ELSE
           DO j=jMinUpd,jMaxUpd
            DO i=1-OLx,0
             tmpVol = iceVol(i,j)
             iceVol(i,j) = iceVol(i,j)
     &                    -deltaTadvect*maskLocC(i,j)
     &                           *( vTrans(i,j+1)-vTrans(i,j) )
             IF ( iceVol(i,j).GT.iceEps )
     &       iceFld(i,j) = ( iceFld(i,j)*tmpVol
     &                      -deltaTadvect*maskLocC(i,j)
     &                                   *( af(i,j+1)-af(i,j) )
     &                     )/iceVol(i,j)
            ENDDO
           ENDDO
          ENDIF
C-    keep advective flux (for diagnostics)
          DO j=1-OLy+1,sNy+OLy
           DO i=1-OLx,0
             afy(i,j) = af(i,j)
           ENDDO
          ENDDO
C-    end if West Edge
         ENDIF
         IF ( E_edge ) THEN
          IF ( useGridArea ) THEN
           DO j=jMinUpd,jMaxUpd
            DO i=sNx+1,sNx+OLx
             iceFld(i,j) = iceFld(i,j)
     &                    -deltaTadvect*maskLocC(i,j)
     &                                 *recip_rA(i,j,bi,bj)
     &                                 *( af(i,j+1)-af(i,j) )
            ENDDO
           ENDDO
          ELSE
           DO j=jMinUpd,jMaxUpd
            DO i=sNx+1,sNx+OLx
             tmpVol = iceVol(i,j)
             iceVol(i,j) = iceVol(i,j)
     &                    -deltaTadvect*maskLocC(i,j)
     &                           *( vTrans(i,j+1)-vTrans(i,j) )
             IF ( iceVol(i,j).GT.iceEps )
     &       iceFld(i,j) = ( iceFld(i,j)*tmpVol
     &                      -deltaTadvect*maskLocC(i,j)
     &                                   *( af(i,j+1)-af(i,j) )
     &                     )/iceVol(i,j)
            ENDDO
           ENDDO
          ENDIF
C-    keep advective flux (for diagnostics)
          DO j=1-OLy+1,sNy+OLy
           DO i=sNx+1,sNx+OLx
             afy(i,j) = af(i,j)
           ENDDO
          ENDDO
C-    end if East Edge
         ENDIF

        ELSE
#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE iceFld = comlev1_thsice_adv, key=dkey, byte=isbyte
CADJ STORE iceVol = comlev1_thsice_adv, key=dkey, byte=isbyte
CADJ STORE af     = comlev1_thsice_adv, key=dkey, byte=isbyte
#endif
C     do not only update the overlap
          iMinUpd = 1-OLx
          iMaxUpd = sNx+OLx
          IF ( interiorOnly .AND. W_edge ) iMinUpd = 1
          IF ( interiorOnly .AND. E_edge ) iMaxUpd = sNx
          IF ( useGridArea ) THEN
           DO j=1-OLy+1,sNy+OLy-1
            DO i=iMinUpd,iMaxUpd
             iceFld(i,j) = iceFld(i,j)
     &                    -deltaTadvect*maskLocC(i,j)
     &                                 *recip_rA(i,j,bi,bj)
     &                                 *( af(i,j+1)-af(i,j) )
            ENDDO
           ENDDO
          ELSE
           DO j=1-OLy+1,sNy+OLy-1
            DO i=iMinUpd,iMaxUpd
             tmpVol = iceVol(i,j)
             iceVol(i,j) = iceVol(i,j)
     &                    -deltaTadvect*maskLocC(i,j)
     &                           *( vTrans(i,j+1)-vTrans(i,j) )
             IF ( iceVol(i,j).GT.iceEps )
     &       iceFld(i,j) = ( iceFld(i,j)*tmpVol
     &                      -deltaTadvect*maskLocC(i,j)
     &                                   *( af(i,j+1)-af(i,j) )
     &                     )/iceVol(i,j)
            ENDDO
           ENDDO
          ENDIF
C-    keep advective flux (for diagnostics)
          DO j=1-OLy+1,sNy+OLy
           DO i=iMinUpd,iMaxUpd
             afy(i,j) = af(i,j)
           ENDDO
          ENDDO

C      end if/else update overlap-Only
        ENDIF

C--   End of Y direction
       ENDIF

C--   End of ipass loop
      ENDDO

C-    explicit advection is done ; add some debugging print
#ifdef ALLOW_DBUG_THSICE
      IF ( dBugFlag ) THEN
       DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
         IF ( i.EQ.idb .AND. j.EQ.jdb .AND. bi.EQ.biDb ) THEN
          tmpFac= deltaTadvect*recip_rA(i,j,bi,bj)
          WRITE(6,'(A,1P4E14.6)') 'ICE_adv:',
     &     afx(i,j)*tmpFac,afx(i+1,j)*tmpFac,
     &     afy(i,j)*tmpFac,afy(i,j+1)*tmpFac
         ENDIF
        ENDDO
       ENDDO
      ENDIF

#ifdef ALLOW_DEBUG
      IF ( debugLevel .GE. debLevC
     &     .AND. tracerIdentity.EQ.GAD_SI_HICE
     &     .AND. k.LE.3 .AND. myIter.EQ.1+nIter0
     &     .AND. nPx.EQ.1 .AND. nPy.EQ.1
     &     .AND. useCubedSphereExchange ) THEN
       CALL DEBUG_CS_CORNER_UV( ' afx,afy from THSICE_ADVECTION',
     &      afx,afy, k, standardMessageUnit,bi,bj,myThid )
      ENDIF
#endif /* ALLOW_DEBUG */
#endif /* ALLOW_DBUG_THSICE */

#endif /* ALLOW_GENERIC_ADVDIFF */

      RETURN
      END

#include "GGL90_OPTIONS.h"

CBOP
C     !ROUTINE: GGL90_READPARMS
C     !INTERFACE:
      SUBROUTINE GGL90_READPARMS( myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE GGL90_READPARMS                               |
C     | o Routine to read in file data.ggl90                     |
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "GGL90.h"

C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
C     myThid -  Number of this instance of GGL90_READPARMS
      INTEGER myThid

#ifdef ALLOW_GGL90

C     !FUNCTIONS:
C     === Functions ===
      INTEGER  ILNBLNK
      EXTERNAL ILNBLNK

C     !LOCAL VARIABLES:
C     === Local variables ===
C     msgBuf      - Informational/error message buffer
C     errIO       - IO error flag
C     iUnit       - Work variable for IO unit number
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      INTEGER errIO, iUnit, iL
C     retired variables
      INTEGER nRetired
      _RL GGL90taveFreq

C--   GGL90 vertical mixing parameters
      NAMELIST /GGL90_PARM01/
     &     GGL90dumpFreq, GGL90taveFreq,
     &     GGL90diffTKEh,
     &     GGL90mixingMaps, GGL90writeState,
     &     GGL90ck, GGL90ceps, GGL90alpha, GGL90m2,
     &     GGL90TKEmin, GGL90TKEsurfMin, GGL90TKEbottom,
     &     GGL90mixingLengthMin, mxlMaxFlag, adMxlMaxFlag, mxlSurfFlag,
     &     GGL90viscMax, GGL90diffMax, GGL90TKEFile,
     &     GGL90_dirichlet, calcMeanVertShear, useIDEMIX,
     &     useLANGMUIR

#ifdef ALLOW_GGL90_IDEMIX
C-----------------------------------------------------------------------
C  IDEMIX
C-----------------------------------------------------------------------
      NAMELIST /GGL90_PARM02/
     & IDEMIX_tau_v, IDEMIX_tau_h, IDEMIX_gamma, IDEMIX_jstar,
     & IDEMIX_mu0,IDEMIX_tidal_file,IDEMIX_wind_file,
     & IDEMIX_mixing_efficiency, IDEMIX_diff_max,
     & IDEMIX_diff_min, IDEMIX_frac_F_b, IDEMIX_frac_F_s,
     & IDEMIX_include_GM,IDEMIX_include_GM_bottom
#endif /* ALLOW_GGL90_IDEMIX */

#ifdef ALLOW_GGL90_LANGMUIR
C-----------------------------------------------------------------------
C  Langmuir circulation
C-----------------------------------------------------------------------
      NAMELIST /GGL90_PARM03/
     & LC_Gamma, LC_num, LC_lambda
#endif /* ALLOW_GGL90_LANGMUIR*/

CEOP
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      IF ( .NOT.useGGL90 ) THEN
C-    pkg GGL90 is not used
        _BEGIN_MASTER(myThid)
C-    Track pkg activation status:
C     print a (weak) warning if data.ggl90 is found
         CALL PACKAGES_UNUSED_MSG( 'useGGL90', ' ', ' ' )
        _END_MASTER(myThid)
        RETURN
      ENDIF

      _BEGIN_MASTER(myThid)

      WRITE(msgBuf,'(A)') ' GGL90_READPARMS: opening data.ggl90'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      errIO = 0
      CALL OPEN_COPY_DATA_FILE(
     I                          'data.ggl90', 'GGL90_READPARMS',
     O                          iUnit,
     I                          myThid )

C--   set default TKE vertical mixing parameters
      GGL90dumpFreq        = dumpFreq
      GGL90taveFreq        = UNSET_RL
      GGL90mixingMaps      = .FALSE.
      GGL90writeState      = .FALSE.
      GGL90ck              = 0.1 _d 0
      GGL90ceps            = 0.7 _d 0
      GGL90alpha           = 1.0 _d 0
C     Blanke and Delecluse (1993, JPO) use
      GGL90m2              = 3.75 _d 0
      GGL90TKEmin          = 1.0 _d -11
C     Blanke and Delecluse (1993, JPO) use
      GGL90TKEsurfMin      = 1.0 _d -04
      GGL90TKEbottom       = UNSET_RL
      GGL90viscMax         = 1. _d 2
      GGL90diffMax         = 1. _d 2
      GGL90diffTKEh        = 0.0 _d 0
      GGL90mixingLengthMin = 1.0 _d -08
      mxlMaxFlag           = 0
      adMxlMaxFlag         = UNSET_I
      mxlSurfFlag          = .FALSE.
      GGL90TKEFile         = ' '
      GGL90_dirichlet      = .TRUE.
      calcMeanVertShear    = .FALSE.
      useIDEMIX            = .FALSE.
      useLANGMUIR          = .FALSE.

#ifdef ALLOW_GGL90_IDEMIX
C-----------------------------------------------------------------------
C     set default parameter for IDEMIX
C-----------------------------------------------------------------------
C     New (and different from Olbers and Eden, 20130) parameter default
C     values for tau_v, jstar, mu0 according to Pollmann et al. (2017):
      IDEMIX_tau_v      =  2.0*86400.0 _d 0
      IDEMIX_tau_h      = 10.0*86400.0 _d 0
      IDEMIX_gamma      = 1.57 _d 0
      IDEMIX_jstar      = 5.0 _d 0
      IDEMIX_mu0        = 1.0 _d 0/3.0 _d 0
      IDEMIX_mixing_efficiency = 0.1666 _d 0
      IDEMIX_diff_max   = 1.0 _d 0
      IDEMIX_diff_min   = 1.0 _d -9
      IDEMIX_frac_F_b   = 1.0 _d 0
C     only approx. 20% of near inertial wind power input reaches IDEMIX
      IDEMIX_frac_F_s   = 0.2 _d 0
C     IDEMIX_tidal_file = 'tidal_energy.bin'
C     IDEMIX_wind_file  = 'wind_energy.bin'
      IDEMIX_tidal_file = ' '
      IDEMIX_wind_file  = ' '
      IDEMIX_include_GM = .FALSE.
      IDEMIX_include_GM_bottom = .FALSE.
#endif /* ALLOW_GGL90_IDEMIX */

#ifdef ALLOW_GGL90_LANGMUIR
C-----------------------------------------------------------------------
C     set default parameter for LANGMUIR
C-----------------------------------------------------------------------
      LC_Gamma      =  1.0 _d 1
      LC_num        =  3.2 _d -1
      LC_lambda     =  4.0 _d 1
#endif /* ALLOW_GGL90_LANGMUIR */

C-----------------------------------------------------------------------
C define some non-dimensional constants and
C the vertical mixing coefficients in m-k-s units
C-----------------------------------------------------------------------

C--   Read settings from model parameter file "data.ggl90".
      WRITE(msgBuf,'(A)')
     &  ' GGL90_READPARMS ; starts to read GGL90_PARM01'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      READ( UNIT=iUnit, NML=GGL90_PARM01 )
c     READ( UNIT=iUnit, NML=GGL90_PARM01, IOSTAT=errIO )
      IF ( errIO .LT. 0 ) THEN
        WRITE(msgBuf,'(A)')
     &   'S/R GGL90_READPARMS, Problem reading NML GGL90_PARM01'
        CALL PRINT_ERROR( msgBuf, myThid )
        STOP 'ABNORMAL END: S/R GGL90_READPARMS'
      ENDIF
      WRITE(msgBuf,'(A)')
     &     ' GGL90_READPARMS: read GGL90_PARM01 : OK'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )

#ifdef ALLOW_GGL90_IDEMIX
      IF (useIDEMIX) THEN
       WRITE(msgBuf,'(A)')
     &  ' GGL90_READPARMS ; starts to read GGL90_PARM02'
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                     SQUEEZE_RIGHT, myThid )
       READ( UNIT=iUnit, NML=GGL90_PARM02 )
c      READ( UNIT=iUnit, NML=GGL90_PARM02, IOSTAT=errIO )
       IF ( errIO .LT. 0 ) THEN
        WRITE(msgBuf,'(A)')
     &   'S/R GGL90_READPARMS, Problem reading NML GGL90_PARM02'
        CALL PRINT_ERROR( msgBuf, myThid )
        STOP 'ABNORMAL END: S/R GGL90_READPARMS'
       ENDIF
       WRITE(msgBuf,'(A)')
     &     ' GGL90_READPARMS: read GGL90_PARM02 : OK'
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                     SQUEEZE_RIGHT, myThid )
      ENDIF
#endif /* ALLOW_GGL90_IDEMIX */

#ifdef ALLOW_GGL90_LANGMUIR
      IF (useLANGMUIR) THEN
       WRITE(msgBuf,'(A)')
     &  ' GGL90_READPARMS ; starts to read GGL90_PARM03'
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                     SQUEEZE_RIGHT, myThid )
       READ( UNIT=iUnit, NML=GGL90_PARM03 )
c      READ( UNIT=iUnit, NML=GGL90_PARM03, IOSTAT=errIO )
       IF ( errIO .LT. 0 ) THEN
        WRITE(msgBuf,'(A)')
     &   'S/R GGL90_READPARMS, Problem reading NML GGL90_PARM03'
        CALL PRINT_ERROR( msgBuf, myThid )
        STOP 'ABNORMAL END: S/R GGL90_READPARMS'
       ENDIF
       WRITE(msgBuf,'(A)')
     &     ' GGL90_READPARMS: read GGL90_PARM03 : OK'
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                     SQUEEZE_RIGHT, myThid )
      ENDIF
#endif /* ALLOW_GGL90_LANGMUIR */

#ifdef SINGLE_DISK_IO
      CLOSE(iUnit)
#else
      CLOSE(iUnit,STATUS='DELETE')
#endif /* SINGLE_DISK_IO */

      WRITE(msgBuf,'(A)')
     &     ' GGL90_READPARMS: finished reading data.ggl90'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )

#ifdef ALLOW_GGL90_IDEMIX
      IF ( useIDEMIX ) THEN
       IF ( OLx .LT. 3 .or. OLy .lt. 3) THEN
        WRITE(msgBuf,'(A)') 'OLx/OLy must be greater than 2'
        CALL PRINT_ERROR( msgBuf , 1)
        STOP 'ABNORMAL END: S/R GGL90_READPARMS'
       ENDIF
      ENDIF
#endif /* ALLOW_GGL90_IDEMIX */

C Now set-up any remaining parameters that result from the input parameters
      IF ( GGL90TKEbottom .EQ. UNSET_RL ) THEN
       GGL90TKEbottom = GGL90TKEmin
      ENDIF
      IF ( adMxlMaxFlag .EQ. UNSET_I ) THEN
       adMxlMaxFlag = mxlMaxFlag
      ENDIF
#ifdef ALLOW_GGL90_IDEMIX
      IF ( GGL90TKEmin .LT. 0. ) THEN   ! CE: changed le to lt  !!!
#else
      IF ( GGL90TKEmin .LE. 0. ) THEN
#endif
       WRITE(msgBuf,'(A)')
     &      'GGL90TKEmin must be greater than zero'
       CALL PRINT_ERROR( msgBuf , 1)
       STOP 'ABNORMAL END: S/R GGL90_READPARMS'
      ENDIF
      IF ( GGL90TKEbottom .LT. 0. ) THEN
       WRITE(msgBuf,'(A)')
     &      'GGL90TKEbottom must not be less than zero'
       CALL PRINT_ERROR( msgBuf , 1)
       STOP 'ABNORMAL END: S/R GGL90_READPARMS'
      ENDIF
      IF ( GGL90mixingLengthMin .LE. 0. ) THEN
       WRITE(msgBuf,'(A)')
     &      'GGL90mixingLengthMin must be greater than zero'
       CALL PRINT_ERROR( msgBuf , 1)
       STOP 'ABNORMAL END: S/R GGL90_READPARMS'
      ENDIF
      IF ( GGL90viscMax .LE. 0. ) THEN
       WRITE(msgBuf,'(A)') 'GGL90viscMax must be greater than zero'
       CALL PRINT_ERROR( msgBuf , 1)
       STOP 'ABNORMAL END: S/R GGL90_READPARMS'
      ENDIF
      IF ( GGL90diffMax .LE. 0. ) THEN
       WRITE(msgBuf,'(A)') 'GGL90diffMax must be greater than zero'
       CALL PRINT_ERROR( msgBuf , 1)
       STOP 'ABNORMAL END: S/R GGL90_READPARMS'
      ENDIF

C-    Retired parameters
      nRetired = 0
      IF ( GGL90taveFreq .NE. UNSET_RL ) THEN
       nRetired = nRetired + 1
       WRITE(msgBuf,'(A,A)')
     &  'S/R GGL90_READPARMS: "GGL90taveFreq" ',
     &  'is no longer allowed in file "data.ggl90"'
       CALL PRINT_ERROR( msgBuf, myThid )
       WRITE(msgBuf,'(A)')
     &  'S/R GGL90_READPARMS: use diagnostics variables instead'
       CALL PRINT_ERROR( msgBuf, myThid )
      ENDIF
      IF ( nRetired .GT. 0 ) THEN
       WRITE(msgBuf,'(2A)') 'S/R GGL90_READPARMS: ',
     &  'Error reading parameter file "data.ggl90"'
       CALL PRINT_ERROR( msgBuf, myThid )
       WRITE(msgBuf,'(A)')
     &  'some out of date parameters were found in the namelist'
       CALL PRINT_ERROR( msgBuf, myThid )
       STOP 'ABNORMAL END: S/R GGL90_READPARMS'
      ENDIF

C--   print TKE vertical mixing parameters to stdout for better debugging
      WRITE(msgBuf,'(A)')
     &'// ======================================================='
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)') '// GGL90 configuration'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)')
     &'// ======================================================='
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )

      CALL WRITE_0D_RL( GGL90dumpFreq, INDEX_NONE,'GGL90dumpFreq =',
     &'   /* GGL90 state write out interval ( s ). */')
      CALL WRITE_0D_L(GGL90mixingMaps,INDEX_NONE,
     &     'GGL90mixingMAPS =', '   /* GGL90 IO flag */')
      CALL WRITE_0D_L(GGL90writeState,INDEX_NONE,
     &     'GGL90writeState =', '   /* GGL90 IO flag */')
      CALL WRITE_0D_RL( GGL90ck, INDEX_NONE,'GGL90ck =',
     &'   /* GGL90 viscosity parameter */')
      CALL WRITE_0D_RL( GGL90ceps, INDEX_NONE,'GGL90ceps =',
     &'   /* GGL90 dissipation parameter */')
      CALL WRITE_0D_RL( GGL90alpha, INDEX_NONE,'GGL90alpha =',
     &'   /* GGL90 TKE diffusivity parameter */')
      CALL WRITE_0D_RL( GGL90m2, INDEX_NONE,'GGL90m2 =',
     &'   /* GGL90 wind stress to vertical stress ratio */')
      CALL WRITE_0D_RL( GGL90TKEmin, INDEX_NONE,'GGL90TKEmin =',
     &'   /* GGL90 minimum kinetic energy ( m^2/s^2 ) */')
      CALL WRITE_0D_RL( GGL90TKEsurfMin, INDEX_NONE,
     &     'GGL90TKEsurfMin =',
     &'   /* GGL90 minimum surface kinetic energy ( m^2/s^2 ) */')
      CALL WRITE_0D_RL( GGL90TKEbottom, INDEX_NONE,
     &     'GGL90TKEbottom =',
     &     '   /* GGL90 bottom kinetic energy ( m^2/s^2 ) */')
      CALL WRITE_0D_RL( GGL90viscMax, INDEX_NONE,'GGL90viscMax =',
     &     '   /* GGL90 upper limit for viscosity (m^2/s ) */')
      CALL WRITE_0D_RL( GGL90diffMax, INDEX_NONE,'GGL90diffMax =',
     &     '   /* GGL90 upper limit for diffusivity (m^2/s ) */')
      CALL WRITE_0D_RL( GGL90diffTKEh, INDEX_NONE,'GGL90diffTKEh =',
     &     '   /* GGL90 horizontal diffusivity for TKE ( m^2/s ) */')
      CALL WRITE_0D_RL( GGL90mixingLengthMin, INDEX_NONE,
     &     'GGL90mixingLengthMin =',
     &     '   /* GGL90 minimum mixing length (m) */')
      CALL WRITE_0D_I(mxlMaxFlag, INDEX_NONE, 'mxlMaxFlag =',
     &     '   /* Flag for limiting mixing-length method */')
#ifdef ALLOW_AUTODIFF
      CALL WRITE_0D_I(adMxlMaxFlag, INDEX_NONE, 'adMxlMaxFlag =',
     &     '   /* Flag for limiting mixing-length method in AD-mode */')
#endif
      CALL WRITE_0D_L(mxlSurfFlag,INDEX_NONE,
     &     'mxlSurfFlag =',
     &     '   /* GGL90 flag for near surface mixing */')
      CALL WRITE_0D_L( calcMeanVertShear, INDEX_NONE,
     &     'calcMeanVertShear =',
     &     ' /* calc Mean of Vert.Shear (vs shear of Mean flow) */')
      iL = MAX_LEN_MBUF - 22
      iL = MIN( iL, MAX(ILNBLNK(GGL90TKEFile),1) )
      WRITE(msgBuf,'(A,A)')'GGL90: GGL90TKEFile = ',GGL90TKEFile(1:iL)
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      CALL WRITE_0D_L(GGL90_dirichlet,INDEX_NONE,
     & 'GGL90_dirichlet =', '   /* GGL90 Boundary condition flag */')

#ifdef ALLOW_GGL90_IDEMIX
      CALL WRITE_0D_L(useIDEMIX,INDEX_NONE, 'useIDEMIX =',
     &     '   /* turn on IDEMIX contribution. */')

      IF ( useIDEMIX ) THEN
       CALL WRITE_0D_RL( IDEMIX_tau_v, INDEX_NONE,'IDEMIX_tau_v =',
     &     '   /* IDEMIX vertical group speed parameter. */')
       CALL WRITE_0D_RL( IDEMIX_tau_h, INDEX_NONE,'IDEMIX_tau_h =',
     &     '   /* IDEMIX horizontal group speed parameter. */')
       CALL WRITE_0D_RL( IDEMIX_gamma, INDEX_NONE,'IDEMIX_gamma =',
     &     '   /* IDEMIX group speed parameter. */')
       CALL WRITE_0D_RL( IDEMIX_jstar, INDEX_NONE,'IDEMIX_jstar =',
     &     '   /* IDEMIX baroclinic mode bandwidth. */')
       CALL WRITE_0D_RL( IDEMIX_mu0, INDEX_NONE,'IDEMIX_mu0 =',
     &     '   /* IDEMIX dissipation parameter. */')
       CALL WRITE_0D_RL( IDEMIX_mixing_efficiency,INDEX_NONE,
     &     'IDEMIX_mixing_efficiency =',
     &     '   /* IDEMIX mixing efficiency. */')
       CALL WRITE_0D_RL( IDEMIX_diff_max,INDEX_NONE,'IDEMIX_diff_max =',
     &     '   /* IDEMIX maximal diffusivity. */')
       CALL WRITE_0D_RL( IDEMIX_diff_min,INDEX_NONE,'IDEMIX_diff_min =',
     &     '   /* IDEMIX minimal diffusivity. */')
       CALL WRITE_0D_RL( IDEMIX_frac_F_b,INDEX_NONE,'IDEMIX_frac_F_b =',
     &     '   /* Fraction of F_b which enters IW field. */')
       CALL WRITE_0D_RL( IDEMIX_frac_F_s,INDEX_NONE,'IDEMIX_frac_F_s =',
     &     '   /* Fraction of F_s which enters IW field. */')
       CALL WRITE_0D_L(IDEMIX_include_GM,INDEX_NONE,
     & 'IDEMIX_include_GM =', '   /* IDEMIX GM flag */')
       CALL WRITE_0D_L(IDEMIX_include_GM_bottom,INDEX_NONE,
     & 'IDEMIX_include_GM_bottom =', '   /* IDEMIX GM flag */')
C
       CALL WRITE_0D_C( IDEMIX_tidal_file, -1, INDEX_NONE,
     &  'IDEMIX_tidal_file =', ' /* file name of tidal energy field */')
       CALL WRITE_0D_C( IDEMIX_wind_file, -1, INDEX_NONE,
     &  'IDEMIX_wind_file  =', ' /* file name of wind energy field */')
      ENDIF
#endif /* ALLOW_GGL90_IDEMIX */

#ifdef ALLOW_GGL90_LANGMUIR
      CALL WRITE_0D_L(useLANGMUIR,INDEX_NONE, 'useLANGMUIR =',
     &     '   /* turn on Langmuir circulation effect. */')

      IF ( useLANGMUIR ) THEN
       CALL WRITE_0D_RL( LC_Gamma, INDEX_NONE,'LC_Gamma  =',
     & ' /* Mix-Length Amplification fac. from Langmuir Circ. (>=1) */')
       CALL WRITE_0D_RL( LC_num, INDEX_NONE,'LC_num    =',
     &     ' /* Value for the Langmuir number (no units) */')
       CALL WRITE_0D_RL( LC_lambda, INDEX_NONE,'LC_lambda =',
     &     ' /* Vertical scale for Stokes velocity ( m ) */')
      ENDIF
#endif /* ALLOW_GGL90_LANGMUIR */

      WRITE(msgBuf,'(A)')
     &'// ======================================================='
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)') '// End of GGL90 config. summary'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)')
     &'// ======================================================='
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)') ' '
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )

      _END_MASTER(myThid)

C--   Everyone else must wait for the parameters to be loaded
      _BARRIER

#endif /* ALLOW_GGL90 */

      RETURN
      END

#include "CPP_EEOPTIONS.h"

CBOP
C     !ROUTINE: NML_SET_TERMINATOR

C     !INTERFACE:
      SUBROUTINE NML_SET_TERMINATOR(
     U                               record )

C     !DESCRIPTION:
C     *=================================================================*
C     | SUBROUTINE NML\_SET\_TERMINATOR
C     | o Set namelist terminator character
C     *=================================================================*
C     | Change trailing \& to trailing / when needed
C     *=================================================================*

C     !USES:
      IMPLICIT NONE
C     == Global variables ==
#include "EEPARAMS.h"

C     !FUNCTIONS:
      INTEGER  ILNBLNK
      EXTERNAL ILNBLNK

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
      CHARACTER*(MAX_LEN_PREC) record

C     !LOCAL VARIABLES:
C     == Local variables ==
      INTEGER iL
      CHARACTER*(2) nmlEnd
#ifdef NML_TERMINATOR
      PARAMETER( nmlEnd = ' /' )
#else
      PARAMETER( nmlEnd = ' &' )
#endif
CEOP

      iL = MAX(ILNBLNK(record),1)
      IF ( iL .EQ. 2 ) THEN
       IF ( record(1:2) .EQ. ' &' ) THEN
        record(1:2) = nmlEnd
       ENDIF
      ENDIF

      RETURN
      END

#include "CD_CODE_OPTIONS.h"

      SUBROUTINE CD_CODE_INI_VARS( myThid )

      IMPLICIT NONE
C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "CD_CODE_VARS.h"

C     == Routine arguments ==
C     myThid :: my Thread Id number
      INTEGER myThid

C     !LOCAL VARIABLES:
C     == Local variables ==
C     bi,bj  - Loop counters
C     I,J,K
      INTEGER bi, bj
      INTEGER I, J, K
CEOP

#ifdef ALLOW_CD_CODE

C--   Over all tiles
      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)

C-      3D arrays
        DO K=1,Nr
         DO J=1-Oly,sNy+Oly
          DO I=1-Olx,sNx+Olx
           uNM1(I,J,K,bi,bj)=0. _d 0
           vNM1(I,J,K,bi,bj)=0. _d 0
           uVeld(I,J,K,bi,bj)=0. _d 0
           vVeld(I,J,K,bi,bj)=0. _d 0
          ENDDO
         ENDDO
        ENDDO

C-      2D arrays
        DO J=1-Oly,sNy+Oly
         DO I=1-Olx,sNx+Olx
          etaNm1(I,J,bi,bj)=0. _d 0
         ENDDO
        ENDDO

       ENDDO
      ENDDO

      IF ( nIter0.NE.0 .OR. pickupSuff.NE.' ' ) THEN
        CALL CD_CODE_READ_PICKUP( nIter0, myThid )
      ENDIF

#endif /*  ALLOW_CD_CODE  */

      RETURN
      END

#include "SEAICE_OPTIONS.h"

CStartOfInterface
      SUBROUTINE ostres( COR_ICE, myThid )
C     *==========================================================*
C     | SUBROUTINE ostres                                        |
C     | o Calculate ocean surface stress                         |
C     *==========================================================*
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "FFIELDS.h"
#include "SEAICE_SIZE.h"
#include "SEAICE_PARAMS.h"
#include "SEAICE.h"

C     === Routine arguments ===
C     myThid - Thread no. that called this routine.
      _RL COR_ICE        (1-OLx:sNx+OLx,1-OLy:sNy+OLy,  nSx,nSy)
      INTEGER myThid
CEndOfInterface

#ifdef SEAICE_BGRID_DYNAMICS
C     === Local variables ===
C     i,j,bi,bj - Loop counters

      INTEGER i, j, bi, bj
      _RL  SINWIN, COSWIN, SINWAT, COSWAT
# ifdef SEAICE_BICE_STRESS
      _RL  fuIce, fvIce
# endif

c     introduce turning angle (default is zero)
      SINWIN=SIN(SEAICE_airTurnAngle*deg2rad)
      COSWIN=COS(SEAICE_airTurnAngle*deg2rad)
      SINWAT=SIN(SEAICE_waterTurnAngle*deg2rad)
      COSWAT=COS(SEAICE_waterTurnAngle*deg2rad)

C--   Update overlap regions
      CALL EXCH_UV_XY_RL(WINDX, WINDY, .TRUE., myThid)

# ifndef SEAICE_EXTERNAL_FLUXES
C--   Interpolate wind stress (N/m^2) from South-West B-grid
C     to South-West C-grid for forcing ocean model.
      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        DO j=1,sNy
         DO i=1,sNx
            fu(I,J,bi,bj)=HALF
     &           *(WINDX(I,J+1,bi,bj)+WINDX(I,J,bi,bj))
            fv(I,J,bi,bj)=HALF
     &           *(WINDY(I+1,J,bi,bj)+WINDY(I,J,bi,bj))
         ENDDO
        ENDDO
       ENDDO
      ENDDO
      CALL EXCH_UV_XY_RS(fu, fv, .TRUE., myThid)
# endif /* ifndef SEAICE_EXTERNAL_FLUXES */

# ifdef SEAICE_BICE_STRESS
C--   Compute ice-affected wind stress
      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        DO j=1,sNy
         DO i=1,sNx
          fuIce=QUART*( DWATN(I,J,bi,bj)+DWATN(I,J+1,bi,bj) )*(
     &         COSWAT *
     &         ( UICE(I,J,  bi,bj)-GWATX(I,J,  bi,bj)
     &         + UICE(I,J+1,bi,bj)-GWATX(I,J+1,bi,bj) )
     &         -SIGN(SINWAT,COR_ICE(I,J,bi,bj)) *
     &         ( VICE(I,J,  bi,bj)-GWATY(I,J,  bi,bj)
     &         + VICE(I,J+1,bi,bj)-GWATY(I,J+1,bi,bj) )
     &         )
          fvIce=QUART*( DWATN(I,J,bi,bj)+DWATN(I+1,J,bi,bj) )*(
     &         SIGN(SINWAT,COR_ICE(I,J,bi,bj)) *
     &         ( UICE(I,  J,bi,bj)-GWATX(I,  J,bi,bj)
     &         + UICE(I+1,J,bi,bj)-GWATX(I+1,J,bi,bj) )
     &         + COSWAT *
     &         ( VICE(I,  J,bi,bj)-GWATY(I,  J,bi,bj)
     &         + VICE(I+1,J,bi,bj)-GWATY(I+1,J,bi,bj) )
     &         )
          fu(I,J,bi,bj)=(ONE-AREA(I,J,bi,bj))*fu(I,J,bi,bj)+
     &         AREA(I,J,bi,bj)*fuIce
          fv(I,J,bi,bj)=(ONE-AREA(I,J,bi,bj))*fv(I,J,bi,bj)+
     &         AREA(I,J,bi,bj)*fvIce
         ENDDO
        ENDDO
       ENDDO
      ENDDO
      CALL EXCH_UV_XY_RS(fu, fv, .TRUE., myThid)
# endif /* SEAICE_BICE_STRESS */
#endif /* SEAICE_BCGRID_DYNAMICS */

      RETURN
      END

#include "DIC_OPTIONS.h"

CBOP
C !ROUTINE: ALK_SURFFORCING

C !INTERFACE: ==========================================================
      SUBROUTINE ALK_SURFFORCING( PTR_ALK , GALK,
     I           bi,bj,imin,imax,jmin,jmax,
     I           myTime, myIter, myThid )

C !DESCRIPTION:
C Calculate the alkalinity change due to freshwater flux
C Update alkalinity tendency term

C !USES: ===============================================================
      IMPLICIT NONE
#include "SIZE.h"
#include "DYNVARS.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "FFIELDS.h"
#include "DIC_VARS.h"

C !INPUT PARAMETERS: ===================================================
C  PTR_ALK              :: alkalinity field
C  bi,bj                :: tile indices
C  myTime               :: current time
C  myIter               :: current timestep
C  myThid               :: thread number
      _RL  PTR_ALK(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      INTEGER iMin,iMax,jMin,jMax, bi, bj
      _RL myTime
      INTEGER myIter, myThid

C !OUTPUT PARAMETERS: ==================================================
C  GALK                 :: tendency term of alkalinity
      _RL  GALK(1-OLx:sNx+OLx,1-OLy:sNy+OLy)

#ifdef ALLOW_PTRACERS
#ifdef DIC_BIOTIC

#ifdef ALLOW_OLD_VIRTUALFLUX
C !LOCAL VARIABLES: ====================================================
C  i,j                  :: loop indices
      INTEGER i,j
CEOP

        DO j=jmin,jmax
          DO i=imin,imax
            IF (maskC(i,j,1,bi,bj).NE.0. _d 0) THEN
c calculate virtual flux
c EminusPforV = dS/dt*(1/Sglob)
C NOTE: Be very careful with signs here!
C Positive EminusPforV => loss of water to atmos and increase
C in salinity. Thus, also increase in other surface tracers
C (i.e. positive virtual flux into surface layer)
              GALK(i,j)=gsm_ALK*surfaceForcingS(i,j,bi,bj)*
     &                  recip_drF(1)/gsm_S
c OR
c let virtual flux be zero
c             GALK(i,j)=0.d0
c
            ELSE
              GALK(i,j)=0. _d 0
            ENDIF
          ENDDO
         ENDDO
#endif /* ALLOW_OLD_VIRTUALFLUX */

#endif
#endif
        RETURN
        END

#     include "GAD_OPTIONS.h"

      SUBROUTINE GAD_PQM_HAT_R(bi,bj,ix,iy,
     &           method,mask,fbar,edge,
     &           ohat,fhat,myThid)
C     |================================================================|
C     | PQM_HAT_R: reconstruct grid-cell PQM polynomials.              |
C     |================================================================|

          implicit none

C     =============================================== global variables
#         include "SIZE.h"
#         include "GRID.h"
#         include "GAD.h"

C     ====================================================== arguments
C       bi,bj     :: tile indexing.
C       ix,iy     :: x-,y-indexing.
C       method    :: advection scheme.
C       mask      :: col. of cell-wise mask values.
C       fbar      :: col. of cell-wise values.
C       edge      :: col. of edge-wise values/slopes.
C                    - EDGE(1,:) = VALUE.
C                    - EDGE(2,:) = DF/DR.
C       ohat      :: col. of oscl. coeff.
C                    - OHAT(1,:) = D^1F/DS^1.
C                    - OHAT(2,:) = D^2F/DS^2.
C       fhat      :: col. of poly. coeff.
C                    - FHAT(:,I) = PQM coeff.
C       myThid    :: thread number.
C     ================================================================
          integer bi,bj
          integer ix,iy
          integer method
          _RL mask(1-3:Nr+3)
          _RL fbar(1-3:Nr+3)
          _RL edge(1:2,
     &             1-0:Nr+1)
          _RL ohat(1:2,
     &             1-3:Nr+3)
          _RL fhat(1:5,
     &             1-0:Nr+0)
          integer myThid

C     ====================================================== variables
C       ii,ir     :: local r-indexing.
C       ff00      :: centre-biased cell value.
C       ffll,ffrr :: left-, and right-biased cell values.
C       xhat      :: local coord. scaling.
C       fell,ferr :: left-, and right-biased edge values.
C       dell,derr :: left-, and right-biased edge slopes.
C       dfds      :: linear slope estimates.
C       uhat      :: "NULL" limited poly. coeff.
C       lhat      :: "MONO" limited poly. coeff.
C       scal      :: "WENO" weights.
C       fmag,fdel :: local perturbation indicators.
C     ================================================================
          integer ii,ir
          _RL ff00
          _RL ffll,ffrr
          _RL rhat
          _RL fell,ferr
          _RL dell,derr
          _RL dfds(-1:+1)
          _RL uhat(+1:+5)
          _RL lhat(+1:+5)
          _RL scal(+1:+2)
          _RL fmag,fdel
          integer  mono

          do  ir = +1, Nr

C     =============================== scale to local grid-cell co-ords
              rhat = drF(ir)  * .5 _d 0

C     =============================== assemble cell mean + edge values
              ff00 = fbar(ir+0)
              ffll = ff00
     &             + mask(ir-1)*(fbar(ir-1)-ff00)
              ffrr = ff00
     &             + mask(ir+1)*(fbar(ir+1)-ff00)

              fell = edge(+1,ir-0)
              ferr = edge(+1,ir+1)

              dell = edge(+2,ir-0)
              derr = edge(+2,ir+1)

              dell = dell * rhat
              derr = derr * rhat

c             select case(method)
c             case(ENUM_PQM_NULL_LIMIT)
              if ( method.eq.ENUM_PQM_NULL_LIMIT ) then
C     =============================== "NULL" limited grid-cell profile
              CALL GAD_PQM_FUN_NULL ( ff00,
     &             fell,ferr,dell,derr,lhat,mono)

c             case(ENUM_PQM_MONO_LIMIT)
              elseif ( method.eq.ENUM_PQM_MONO_LIMIT ) then
C     =============================== "MONO" limited grid-cell profile
              CALL GAD_PLM_FUN_U(ffll,ff00,ffrr,dfds)

              CALL GAD_PQM_FUN_MONO ( ff00,ffll,ffrr,
     &             fell,ferr,dell,derr,dfds,lhat,
     &             mono)

c             case(ENUM_PQM_WENO_LIMIT)
              elseif ( method.eq.ENUM_PQM_WENO_LIMIT ) then
C     =============================== "WENO" limited grid-cell profile
              CALL GAD_PLM_FUN_U(ffll,ff00,ffrr,dfds)

              CALL GAD_PQM_FUN_NULL ( ff00,
     &             fell,ferr,dell,derr,uhat,mono)

              CALL GAD_PQM_FUN_MONO ( ff00,ffll,ffrr,
     &             fell,ferr,dell,derr,dfds,lhat,
     &             mono)

              if ( mono .gt. 0) then

C     =============================== only apply WENO if it is worth it
              fdel = abs(ffrr-ff00)+abs(ff00-ffll)
              fmag = abs(ffll)+abs(ff00)+abs(ffrr)

              if (fdel .gt. 1. _d -6 * fmag) then

C     =============================== calc. WENO oscillation weighting
                  CALL GAD_OSC_MUL_R(ir,+2,mask,
     &                 ohat,scal)

                  do  ii = +1, +5
C     =============================== blend limited/un-limited profile
                  lhat(ii) = scal(1) * uhat(ii)
     &                     + scal(2) * lhat(ii)
                  end do

              end if

              end if

c             end select
              endif

              do  ii = +1, +5
C     =============================== copy polynomial onto output data
                  fhat(ii,ir) = lhat(ii)
              end do

          end do

          return

c     end subroutine GAD_PQM_HAT_R
      end

#include "DIAG_OPTIONS.h"

CBOP
C     !ROUTINE: DIAG_CALC_PSIVEL
C     !INTERFACE:
      SUBROUTINE DIAG_CALC_PSIVEL(
     I                k, iPsi0, jPsi0, uTrans, vTrans,
     O                psiVel, psiLoc,
     I                prtMsg, myTime, myIter, myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE DIAG_CALC_PSIVEL
C     | o Calculate horizontal transport stream-function
C     |   from non-divergent horizontal transport.
C     *==========================================================*
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     === Global data ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#ifdef ALLOW_OBCS
# include "GRID.h"
# include "OBCS_GRID.h"
#endif /* ALLOW_OBCS */

C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
C     k       :: current level
C     i,jPsi0 :: indices of grid-point location where Psi == 0
C     uTrans  :: horizontal transport, u-component
C     vTrans  :: horizontal transport, u-component
C     psiVel  :: horizontal stream-function
C     psiLoc  :: horizontal stream-function at special location
C     prtMsg  :: do print message to standard-output
C     myTime  :: current time of simulation (s)
C     myIter  :: current iteration number
C     myThid  :: my Thread Id number
      INTEGER k
      INTEGER iPsi0(nSx,nSy)
      INTEGER jPsi0(nSx,nSy)
      _RL  uTrans(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL  vTrans(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL  psiVel(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL  psiLoc(2)
      LOGICAL prtMsg
      _RL  myTime
      INTEGER myIter
      INTEGER myThid

C     !LOCAL VARIABLES:
C     === Local variables ====
C     bi, bj  :: tile indices
C     i, j    :: loop indices
C     dPsiX   :: tile stream-function increment along X-dir
C     dPsiY   :: tile stream-function increment along Y-dir
C     psiOri  :: stream-function value at tile origin
      INTEGER bi, bj
      INTEGER i, j
      _RL    dPsiX (nSx,nSy)
      _RL    dPsiY (nSx,nSy)
      _RL    psiOri(nSx,nSy)
      _RL    offSet
      LOGICAL zeroPsi
c     CHARACTER*(MAX_LEN_MBUF) msgBuf
#ifdef ALLOW_OBCS
      INTEGER is, js, ix, jx, iy, jy, ijCnt
      INTEGER npass, nPts, prev_nPts
      LOGICAL kPsi(1:sNx+1,1:sNy+1)
#endif /* ALLOW_OBCS */
CEOP

#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_ENTER('DIAG_CALC_PSIVEL',myThid)
#endif

C--   Initialise
      zeroPsi = iPsi0(1,1).GE.0
      psiLoc(1) = 0.
      psiLoc(2) = 0.

C--   step.1 : compute Psi over each tile separately
      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        dPsiX (bi,bj) = 0.
        dPsiY (bi,bj) = 0.
        psiOri(bi,bj) = 0.
        IF ( useOBCS ) THEN
C-    Case with OBC:
#ifdef ALLOW_OBCS
C- Note: OB may introduce discontinuity in domain & tile stream-function map;
C     within a tile: define a local "is-set" mask (=kPsi) and
C                    propagate stream-function value without assumption.
C     between tiles: present code is not "general", likely to work with
C                    simple OB setting and/or simple tile connection (no exch2).
C     A truly general algorithm requires to change CUMULSUM_Z_TILE (adding 1
C     more input dPsi/tile) and to account for disabled tile-connection due
C     to OB when setting cumsum tile-mapping (W2_SET_MAP_CUMSUM).
         DO j=1,sNy+1
          DO i=1,sNx+1
            kPsi(i,j) = .FALSE.
            psiVel(i,j,bi,bj) = 0.
          ENDDO
         ENDDO
C-    select starting point
         ijCnt = sNx+sNy+1
         is = 0
         js = 0
         DO j=1,sNy
          DO i=1,sNx
           IF ( OBCS_insideMask(i,j,bi,bj).EQ.1.
     &                      .AND. (i+j).LE.ijCnt ) THEN
             is = i
             js = j
             ijCnt = i+j
           ENDIF
          ENDDO
         ENDDO
         IF ( is.EQ.0 ) THEN
           nPts = 0
         ELSE
           kPsi(is,js) = .TRUE.
           nPts = 1
         ENDIF
         npass = 0
         prev_nPts = 0
         DO WHILE ( nPts.GT.prev_nPts )
           prev_nPts = nPts
           npass = npass + 1
           DO j=1,sNy+1
            DO i=1,sNx
             IF ( OBCS_insideMask(i,j-1,bi,bj).EQ.1. .OR.
     &            OBCS_insideMask(i, j ,bi,bj).EQ.1. ) THEN
               IF ( kPsi(i,j) .AND. .NOT.kPsi(i+1,j) ) THEN
                 nPts = nPts + 1
                 kPsi(i+1,j) = .TRUE.
                 psiVel(i+1,j,bi,bj) = psiVel(i,j,bi,bj)
     &                               + vTrans(i,j,bi,bj)
               ENDIF
               IF ( .NOT.kPsi(i,j) .AND. kPsi(i+1,j) ) THEN
                 nPts = nPts + 1
                 kPsi(i,j) = .TRUE.
                 psiVel(i,j,bi,bj) = psiVel(i+1,j,bi,bj)
     &                               - vTrans(i,j,bi,bj)
               ENDIF
             ENDIF
            ENDDO
           ENDDO
           DO j=1,sNy
            DO i=1,sNx+1
             IF ( OBCS_insideMask(i-1,j,bi,bj).EQ.1. .OR.
     &            OBCS_insideMask( i ,j,bi,bj).EQ.1. ) THEN
               IF ( kPsi(i,j) .AND. .NOT.kPsi(i,j+1) ) THEN
                 nPts = nPts + 1
                 kPsi(i,j+1) = .TRUE.
                 psiVel(i,j+1,bi,bj) = psiVel(i,j,bi,bj)
     &                               - uTrans(i,j,bi,bj)
               ENDIF
               IF ( .NOT.kPsi(i,j) .AND. kPsi(i,j+1) ) THEN
                 nPts = nPts + 1
                 kPsi(i,j) = .TRUE.
                 psiVel(i,j,bi,bj) = psiVel(i,j+1,bi,bj)
     &                               + uTrans(i,j,bi,bj)
               ENDIF
             ENDIF
            ENDDO
           ENDDO
           IF ( prtMsg .AND. nPts.GT.prev_nPts ) THEN
             _BEGIN_MASTER( myThid )
             WRITE(standardMessageUnit,'(A,2I4,A,I6,I8)')
     &          ' diag_calc_psivel: bi,bj=', bi, bj,
     &          ' : npass,nPts=', npass, nPts
             _END_MASTER( myThid )
           ENDIF
C-    end do while (npass count)
         ENDDO
C-    set tile increments
         ix = 0
         jx = 0
         DO i=sNx+1,1,-1
          DO j=1,sNy
           IF ( kPsi(i,j) .AND. jx.EQ.0 ) THEN
             ix = i
             jx = j
           ENDIF
          ENDDO
         ENDDO
         IF ( jx.NE.0 ) dPsiX (bi,bj) = psiVel(ix,jx,bi,bj)
         iy = 0
         jy = 0
         DO j=sNy+1,1,-1
          DO i=1,sNx
           IF ( kPsi(i,j) .AND. iy.EQ.0 ) THEN
             iy = i
             jy = j
           ENDIF
          ENDDO
         ENDDO
         IF ( iy.NE.0 ) dPsiY (bi,bj) = psiVel(iy,jy,bi,bj)
         IF ( prtMsg ) THEN
           _BEGIN_MASTER( myThid )
           WRITE(standardMessageUnit,'(3(A,2I4))')
     &          ' diag_calc_psivel:            is,js=', is,js,
     &                 ' ; ix,jx=', ix,jx, ' ; iy,jy=', iy,jy
c          IF ( iPsi0(bi,bj)*jPsi0(bi,bj).GT.0 )
c    &     WRITE(standardMessageUnit,'(A,L5))')
c    &          ' diag_calc_psivel:          kPsi @ i,jPsi0 =',
c    &                          kPsi(iPsi0(bi,bj),jPsi0(bi,bj))
           _END_MASTER( myThid )
         ENDIF
#endif /* ALLOW_OBCS */
        ELSE
C-    Case without OBC:
         psiVel(1,1,bi,bj) = psiOri(bi,bj)
         j = 1
         DO i=1,sNx
           psiVel(i+1,j,bi,bj) = psiVel(i,j,bi,bj)
     &                         + vTrans(i,j,bi,bj)
         ENDDO
C-     note: can vectorise inner loop
         DO j=1,sNy
          DO i=1,sNx+1
           psiVel(i,j+1,bi,bj) = psiVel(i,j,bi,bj)
     &                         - uTrans(i,j,bi,bj)
          ENDDO
         ENDDO
         dPsiX (bi,bj) = psiVel(1+sNx,1,bi,bj)
         dPsiY (bi,bj) = psiVel(1,1+sNy,bi,bj)
C-    end with/without OBC cases
        ENDIF
       ENDDO
      ENDDO

      CALL CUMULSUM_Z_TILE_RL(
     O                  psiOri, psiLoc,
     I                  dPsiX, dPsiY, myThid )

C--   step.2 : account for Psi @ tile origin
      offSet = 0.
      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        DO j=1,sNy+1
         DO i=1,sNx+1
           psiVel(i,j,bi,bj) = psiVel(i,j,bi,bj) + psiOri(bi,bj)
         ENDDO
        ENDDO
        IF ( iPsi0(bi,bj)*jPsi0(bi,bj).GT.0 )
     &   offSet = -psiVel(iPsi0(bi,bj),jPsi0(bi,bj),bi,bj)
       ENDDO
      ENDDO

      IF ( zeroPsi ) THEN
C--   step.3 : shift stream-function to satisfy Psi == 0 @ a particular location
        _GLOBAL_SUM_RL( offSet, myThid )
        psiLoc(1) = psiLoc(1) + offSet
        psiLoc(2) = psiLoc(2) + offSet
        DO bj=myByLo(myThid),myByHi(myThid)
         DO bi=myBxLo(myThid),myBxHi(myThid)
          DO j=1,sNy+1
           DO i=1,sNx+1
             psiVel(i,j,bi,bj) = psiVel(i,j,bi,bj) + offSet
           ENDDO
          ENDDO
         ENDDO
        ENDDO
      ENDIF

#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_LEAVE('DIAG_CALC_PSIVEL',myThid)
#endif

      RETURN
      END

#include "MDSIO_OPTIONS.h"

C--  File mdsio_read_section.F: Routines to handle mid-level I/O interface.
C--   Contents
C--   o MDS_WRITE_SEC_XZ
C--   o MDS_WRITE_SEC_YZ

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

CBOP
C !ROUTINE: MDS_WRITE_SEC_XZ
C !INTERFACE:
      SUBROUTINE MDS_WRITE_SEC_XZ(
     I   fName,
     I   filePrec,
     I   globalFile,
     I   useCurrentDir,
     I   arrType,
     I   kSize, kLo, kHi,
     I   fldRL, fldRS,
     I   irecord,
     I   myIter,
     I   myThid )

C !DESCRIPTION
C Arguments:
C
C fName       string  :: base name for file to read
C filePrec    integer :: number of bits per word in file (32 or 64)
C globalFile  logical :: selects between writing a global or tiled file
C useCurrentDir logic :: always write to the current directory (even if
C                        "mdsioLocalDir" is set)
C arrType     char(2) :: which array (fldRL/RS) to write, either "RL" or "RS"
C kSize       integer :: size of second dimension: normally either 1 or Nr
C kLo         integer :: 1rst vertical level (of array fldRL/RS) to write
C kHi         integer :: last vertical level (of array fldRL/RS) to write
C fldRL         RL    :: array to write if arrType="RL", fldRL(:,kSize,:,:)
C fldRS         RS    :: array to write if arrType="RS", fldRS(:,kSize,:,:)
C irecord     integer :: record number to read
C myIter      integer :: time step number
C myThid      integer :: thread identifier
C
C MDS_WRITE_SEC_XZ creates either a file of the form "fName.data"
C if the logical flag "globalFile" is set true. Otherwise
C it creates MDS tiled files of the form "fName.xxx.yyy.data".
C The precision of the file is decsribed by filePrec, set either
C  to floatPrec32 or floatPrec64. The char*(2) string arrType, either "RL"
C  or "RS", selects which array is written, either fldRL or fldRS.
C This routine writes vertical slices (X-Z) including overlap regions.
C irecord is the record number to be read and must be >= 1.
C NOTE: It is currently assumed that
C the highest record number in the file was the last record written.
C
C Modified: 06/02/00 spk@ocean.mit.edu
CEOP

C !USES:
      IMPLICIT NONE
C Global variables / common blocks
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#ifdef ALLOW_EXCH2
#include "W2_EXCH2_SIZE.h"
#include "W2_EXCH2_TOPOLOGY.h"
#include "W2_EXCH2_PARAMS.h"
#endif /* ALLOW_EXCH2 */

C !INPUT PARAMETERS:
      CHARACTER*(*) fName
      INTEGER filePrec
      LOGICAL globalFile
      LOGICAL useCurrentDir
      CHARACTER*(2) arrType
      INTEGER kSize, kLo, kHi
      _RL  fldRL(*)
      _RS  fldRS(*)
      INTEGER irecord
      INTEGER myIter
      INTEGER myThid
C !OUTPUT PARAMETERS:

C !FUNCTIONS:
      INTEGER ILNBLNK
      INTEGER MDS_RECLEN
      EXTERNAL ILNBLNK, MDS_RECLEN

C !LOCAL VARIABLES:
      CHARACTER*(MAX_LEN_FNAM) dataFName, pfName
      INTEGER IL, pIL, dUnit, nLev, irec
      INTEGER iG, jG, bi, bj, k, kL
      Real*4 r4seg(sNx)
      Real*8 r8seg(sNx)
      INTEGER length_of_rec
      LOGICAL fileIsOpen
      CHARACTER*(MAX_LEN_MBUF) msgBuf
#ifdef ALLOW_EXCH2
      INTEGER tGx, tNx, tN
#endif /* ALLOW_EXCH2 */

C     ------------------------------------------------------------------

C Only do I/O if I am the master thread
      _BEGIN_MASTER( myThid )

C Record number must be >= 1
      IF (irecord .LT. 1) THEN
       WRITE(msgBuf,'(A,I9.8)')
     &   ' MDS_WRITE_SEC_XZ: argument irecord = ',irecord
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                     SQUEEZE_RIGHT, myThid )
       WRITE(msgBuf,'(A)')
     &   ' MDS_WRITE_SEC_XZ: invalid value for irecord'
       CALL PRINT_ERROR( msgBuf, myThid )
       STOP 'ABNORMAL END: S/R MDS_WRITE_SEC_XZ'
      ENDIF

C Assume nothing
      fileIsOpen=.FALSE.
      IL  = ILNBLNK( fName )
      pIL = ILNBLNK( mdsioLocalDir )

C Assign special directory
      IF ( useCurrentDir .OR. pIL.EQ.0 ) THEN
       pfName= fName
      ELSE
       WRITE(pfName,'(2A)') mdsioLocalDir(1:pIL), fName(1:IL)
      ENDIF
      pIL=ILNBLNK( pfName )

C Set number of levels to write:
      nLev = kHi - kLo + 1

C Assign a free unit number as the I/O channel for this routine
      CALL MDSFINDUNIT( dUnit, myThid )

C If we are writing to a global file then we open it here
      IF (globalFile) THEN
       WRITE(dataFName,'(2A)') fName(1:IL),'.data'
       IF (irecord .EQ. 1) THEN
        length_of_rec = MDS_RECLEN( filePrec, sNx, myThid )
        OPEN( dUnit, file=dataFName, status=_NEW_STATUS,
     &        access='direct', recl=length_of_rec )
        fileIsOpen=.TRUE.
       ELSE
        length_of_rec = MDS_RECLEN( filePrec, sNx, myThid )
        OPEN( dUnit, file=dataFName, status='old',
     &        access='direct', recl=length_of_rec )
        fileIsOpen=.TRUE.
       ENDIF
      ENDIF

C Loop over all tiles
      DO bj=1,nSy
       DO bi=1,nSx
C If we are writing to a tiled MDS file then we open each one here
        IF (.NOT. globalFile) THEN
         iG=bi+(myXGlobalLo-1)/sNx
         jG=bj+(myYGlobalLo-1)/sNy
         WRITE(dataFName,'(2A,I3.3,A,I3.3,A)')
     &              pfName(1:pIL),'.',iG,'.',jG,'.data'
         IF (irecord .EQ. 1) THEN
          length_of_rec = MDS_RECLEN( filePrec, sNx, myThid )
          OPEN( dUnit, file=dataFName, status=_NEW_STATUS,
     &          access='direct', recl=length_of_rec )
          fileIsOpen=.TRUE.
         ELSE
          length_of_rec = MDS_RECLEN( filePrec, sNx, myThid )
          OPEN( dUnit, file=dataFName, status='old',
     &          access='direct', recl=length_of_rec )
          fileIsOpen=.TRUE.
         ENDIF
        ENDIF
        IF (fileIsOpen) THEN
#ifdef ALLOW_EXCH2
C layout of global x-z section files is "xStack"
         tN = W2_myTileList(bi,bj)
         tGx = exch2_txXStackLo(tN)
         tNx = exch2_tNx(tN)
#endif /* ALLOW_EXCH2 */
         DO k=1,nLev
           kL = k + kLo - 1
           IF (globalFile) THEN
#ifdef ALLOW_EXCH2
C record length is sNx==tNx
            irec = 1 + ( tGx-1
     &                   + ( k-1 + (irecord-1)*nLev )*exch2_xStack_Nx
     &                 )/tNx
#else /* ALLOW_EXCH2 */
            iG = myXGlobalLo-1 + (bi-1)*sNx
            jG = (myYGlobalLo-1)/sNy + (bj-1)
            irec = 1 + INT(iG/sNx) + nSx*nPx*(k-1)
     &           + nSx*nPx*nLev*(irecord-1)
#endif /* ALLOW_EXCH2 */
           ELSE
            iG = 0
            jG = 0
            irec = k + nLev*(irecord-1)
           ENDIF
           IF (filePrec .EQ. precFloat32) THEN
            IF (arrType .EQ. 'RS') THEN
             CALL MDS_SEG4toRS_2D( sNx,OLx,kSize,bi,bj,kL,.FALSE.,
     &                             r4seg,fldRS )
            ELSEIF (arrType .EQ. 'RL') THEN
             CALL MDS_SEG4toRL_2D( sNx,OLx,kSize,bi,bj,kL,.FALSE.,
     &                             r4seg,fldRL )
            ELSE
             WRITE(msgBuf,'(A)')
     &         ' MDS_WRITE_SEC_XZ: illegal value for arrType'
             CALL PRINT_ERROR( msgBuf, myThid )
             STOP 'ABNORMAL END: S/R MDS_WRITE_SEC_XZ'
            ENDIF
#ifdef _BYTESWAPIO
            CALL MDS_BYTESWAPR4(sNx,r4seg)
#endif
            WRITE(dUnit,rec=irec) r4seg
           ELSEIF (filePrec .EQ. precFloat64) THEN
            IF (arrType .EQ. 'RS') THEN
             CALL MDS_SEG8toRS_2D( sNx,OLx,kSize,bi,bj,kL,.FALSE.,
     &                             r8seg,fldRS )
            ELSEIF (arrType .EQ. 'RL') THEN
             CALL MDS_SEG8toRL_2D( sNx,OLx,kSize,bi,bj,kL,.FALSE.,
     &                             r8seg,fldRL )
            ELSE
             WRITE(msgBuf,'(A)')
     &         ' MDS_WRITE_SEC_XZ: illegal value for arrType'
             CALL PRINT_ERROR( msgBuf, myThid )
             STOP 'ABNORMAL END: S/R MDS_WRITE_SEC_XZ'
            ENDIF
#ifdef _BYTESWAPIO
            CALL MDS_BYTESWAPR8( sNx, r8seg )
#endif
            WRITE(dUnit,rec=irec) r8seg
           ELSE
            WRITE(msgBuf,'(A)')
     &        ' MDS_WRITE_SEC_XZ: illegal value for filePrec'
            CALL PRINT_ERROR( msgBuf, myThid )
            STOP 'ABNORMAL END: S/R MDS_WRITE_SEC_XZ'
           ENDIF
C End of k loop
         ENDDO
        ELSE
         WRITE(msgBuf,'(A)')
     &     ' MDS_WRITE_SEC_XZ: I should never get to this point'
         CALL PRINT_ERROR( msgBuf, myThid )
         STOP 'ABNORMAL END: S/R MDS_WRITE_SEC_XZ'
        ENDIF
C If we were writing to a tiled MDS file then we close it here
        IF (fileIsOpen .AND. (.NOT. globalFile)) THEN
         CLOSE( dUnit )
         fileIsOpen = .FALSE.
        ENDIF
C End of bi,bj loops
       ENDDO
      ENDDO

C If global file was opened then close it
      IF (fileIsOpen .AND. globalFile) THEN
       CLOSE( dUnit )
       fileIsOpen = .FALSE.
      ENDIF

      _END_MASTER( myThid )

C     ------------------------------------------------------------------
      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

CBOP
C !ROUTINE: MDS_WRITE_SEC_YZ
C !INTERFACE:
      SUBROUTINE MDS_WRITE_SEC_YZ(
     I   fName,
     I   filePrec,
     I   globalFile,
     I   useCurrentDir,
     I   arrType,
     I   kSize, kLo, kHi,
     I   fldRL, fldRS,
     I   irecord,
     I   myIter,
     I   myThid )

C !DESCRIPTION
C Arguments:
C
C fName       string  :: base name for file to read
C filePrec    integer :: number of bits per word in file (32 or 64)
C globalFile  logical :: selects between writing a global or tiled file
C useCurrentDir logic :: always write to the current directory (even if
C                        "mdsioLocalDir" is set)
C arrType     char(2) :: which array (fldRL/RS) to write, either "RL" or "RS"
C kSize       integer :: size of second dimension: normally either 1 or Nr
C kLo         integer :: 1rst vertical level (of array fldRL/RS) to write
C kHi         integer :: last vertical level (of array fldRL/RS) to write
C fldRL         RL    :: array to write if arrType="RL", fldRL(:,kSize,:,:)
C fldRS         RS    :: array to write if arrType="RS", fldRS(:,kSize,:,:)
C irecord     integer :: record number to read
C myIter      integer :: time step number
C myThid      integer :: thread identifier
C
C MDS_WRITE_SEC_YZ creates either a file of the form "fName.data"
C if the logical flag "globalFile" is set true. Otherwise
C it creates MDS tiled files of the form "fName.xxx.yyy.data".
C The precision of the file is decsribed by filePrec, set either
C  to floatPrec32 or floatPrec64. The char*(2) string arrType, either "RL"
C  or "RS", selects which array is written, either fldRL or fldRS.
C This routine writes vertical slices (Y-Z) including overlap regions.
C irecord is the record number to be read and must be >= 1.
C NOTE: It is currently assumed that
C the highest record number in the file was the last record written.
C
C Modified: 06/02/00 spk@ocean.mit.edu
CEOP

C !USES:
      IMPLICIT NONE
C Global variables / common blocks
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#ifdef ALLOW_EXCH2
#include "W2_EXCH2_SIZE.h"
#include "W2_EXCH2_TOPOLOGY.h"
#include "W2_EXCH2_PARAMS.h"
#endif /* ALLOW_EXCH2 */

C !INPUT PARAMETERS:
      CHARACTER*(*) fName
      INTEGER filePrec
      LOGICAL globalFile
      LOGICAL useCurrentDir
      CHARACTER*(2) arrType
      INTEGER kSize, kLo, kHi
      _RL  fldRL(*)
      _RS  fldRS(*)
      INTEGER irecord
      INTEGER myIter
      INTEGER myThid
C !OUTPUT PARAMETERS:

C !FUNCTIONS:
      INTEGER ILNBLNK
      INTEGER MDS_RECLEN
      EXTERNAL ILNBLNK, MDS_RECLEN

C !LOCAL VARIABLES:
      CHARACTER*(MAX_LEN_FNAM) dataFName, pfName
      INTEGER IL, pIL, dUnit, nLev, irec
      INTEGER iG, jG, bi, bj, k, kL
      Real*4 r4seg(sNy)
      Real*8 r8seg(sNy)
      INTEGER length_of_rec
      LOGICAL fileIsOpen
      CHARACTER*(MAX_LEN_MBUF) msgBuf
#ifdef ALLOW_EXCH2
      INTEGER tGy, tNy, tN
#endif /* ALLOW_EXCH2 */
C     ------------------------------------------------------------------

C Only do I/O if I am the master thread
      _BEGIN_MASTER( myThid )

C Record number must be >= 1
      IF (irecord .LT. 1) THEN
       WRITE(msgBuf,'(A,I9.8)')
     &   ' MDS_WRITE_SEC_YZ: argument irecord = ',irecord
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                     SQUEEZE_RIGHT , myThid)
       WRITE(msgBuf,'(A)')
     &   ' MDS_WRITE_SEC_YZ: invalid value for irecord'
       CALL PRINT_ERROR( msgBuf, myThid )
       STOP 'ABNORMAL END: S/R MDS_WRITE_SEC_YZ'
      ENDIF

C Assume nothing
      fileIsOpen=.FALSE.
      IL  = ILNBLNK( fName )
      pIL = ILNBLNK( mdsioLocalDir )

C Assign special directory
      IF ( useCurrentDir .OR. pIL.EQ.0 ) THEN
       pfName= fName
      ELSE
       WRITE(pfName,'(2a)') mdsioLocalDir(1:pIL), fName(1:IL)
      ENDIF
      pIL=ILNBLNK( pfName )

C Set number of levels to write:
      nLev = kHi - kLo + 1

C Assign a free unit number as the I/O channel for this routine
      CALL MDSFINDUNIT( dUnit, myThid )

C If we are writing to a global file then we open it here
      IF (globalFile) THEN
       WRITE(dataFName,'(2A)') fName(1:IL),'.data'
       IF (irecord .EQ. 1) THEN
        length_of_rec = MDS_RECLEN( filePrec, sNy, myThid )
        OPEN( dUnit, file=dataFName, status=_NEW_STATUS,
     &        access='direct', recl=length_of_rec )
        fileIsOpen=.TRUE.
       ELSE
        length_of_rec = MDS_RECLEN( filePrec, sNy, myThid )
        OPEN( dUnit, file=dataFName, status='old',
     &        access='direct', recl=length_of_rec )
        fileIsOpen=.TRUE.
       ENDIF
      ENDIF

C Loop over all tiles
      DO bj=1,nSy
       DO bi=1,nSx
C If we are writing to a tiled MDS file then we open each one here
        IF (.NOT. globalFile) THEN
         iG=bi+(myXGlobalLo-1)/sNx
         jG=bj+(myYGlobalLo-1)/sNy
         WRITE(dataFName,'(2A,I3.3,A,I3.3,A)')
     &              pfName(1:pIL),'.',iG,'.',jG,'.data'
         IF (irecord .EQ. 1) THEN
          length_of_rec = MDS_RECLEN( filePrec, sNy, myThid )
          OPEN( dUnit, file=dataFName, status=_NEW_STATUS,
     &          access='direct', recl=length_of_rec )
          fileIsOpen=.TRUE.
         ELSE
          length_of_rec = MDS_RECLEN( filePrec, sNy, myThid )
          OPEN( dUnit, file=dataFName, status='old',
     &          access='direct', recl=length_of_rec )
          fileIsOpen=.TRUE.
         ENDIF
        ENDIF
        IF (fileIsOpen) THEN
#ifdef ALLOW_EXCH2
C layout of global y-z section files is "yStack"
         tN = W2_myTileList(bi,bj)
         tGy = exch2_tyYStackLo(tN)
         tNy = exch2_tNy(tN)
#endif /* ALLOW_EXCH2 */
         DO k=1,nLev
           kL = k + kLo - 1
           IF (globalFile) THEN
#ifdef ALLOW_EXCH2
C record length is sNy==tNy
            irec = 1 + ( tGy-1
     &                   + ( k-1 + (irecord-1)*nLev )*exch2_yStack_Ny
     &                 )/tNy
#else /* ALLOW_EXCH2 */
            iG = (myXGlobalLo-1)/sNx + (bi-1)
            jG = myYGlobalLo-1 + (bj-1)*sNy
            irec = 1 + INT(jG/sNy) + nSy*nPy*(k-1)
     &           + nSy*nPy*nLev*(irecord-1)
#endif /* ALLOW_EXCH2 */
           ELSE
            iG = 0
            jG = 0
            irec = k + nLev*(irecord-1)
           ENDIF
           IF (filePrec .EQ. precFloat32) THEN
            IF (arrType .EQ. 'RS') THEN
             CALL MDS_SEG4toRS_2D( sNy,OLy,kSize,bi,bj,kL,.FALSE.,
     &                             r4seg,fldRS )
            ELSEIF (arrType .EQ. 'RL') THEN
             CALL MDS_SEG4toRL_2D( sNy,OLy,kSize,bi,bj,kL,.FALSE.,
     &                             r4seg,fldRL )
            ELSE
             WRITE(msgBuf,'(A)')
     &         ' MDS_WRITE_SEC_YZ: illegal value for arrType'
             CALL PRINT_ERROR( msgBuf, myThid )
             STOP 'ABNORMAL END: S/R MDS_WRITE_SEC_YZ'
            ENDIF
#ifdef _BYTESWAPIO
            CALL MDS_BYTESWAPR4(sNy,r4seg)
#endif
            WRITE(dUnit,rec=irec) r4seg
           ELSEIF (filePrec .EQ. precFloat64) THEN
            IF (arrType .EQ. 'RS') THEN
             CALL MDS_SEG8toRS_2D( sNy,OLy,kSize,bi,bj,kL,.FALSE.,
     &                             r8seg,fldRS )
            ELSEIF (arrType .EQ. 'RL') THEN
             CALL MDS_SEG8toRL_2D( sNy,OLy,kSize,bi,bj,kL,.FALSE.,
     &                             r8seg,fldRL )
            ELSE
             WRITE(msgBuf,'(A)')
     &         ' MDS_WRITE_SEC_YZ: illegal value for arrType'
             CALL PRINT_ERROR( msgBuf, myThid )
             STOP 'ABNORMAL END: S/R MDS_WRITE_SEC_YZ'
            ENDIF
#ifdef _BYTESWAPIO
            CALL MDS_BYTESWAPR8( sNy, r8seg )
#endif
            WRITE(dUnit,rec=irec) r8seg
           ELSE
            WRITE(msgBuf,'(A)')
     &        ' MDS_WRITE_SEC_YZ: illegal value for filePrec'
            CALL PRINT_ERROR( msgBuf, myThid )
            STOP 'ABNORMAL END: S/R MDS_WRITE_SEC_YZ'
           ENDIF
C End of k loop
         ENDDO
        ELSE
         WRITE(msgBuf,'(A)')
     &     ' MDS_WRITE_SEC_YZ: I should never get to this point'
         CALL PRINT_ERROR( msgBuf, myThid )
         STOP 'ABNORMAL END: S/R MDS_WRITE_SEC_YZ'
        ENDIF
C If we were writing to a tiled MDS file then we close it here
        IF (fileIsOpen .AND. (.NOT. globalFile)) THEN
         CLOSE( dUnit )
         fileIsOpen = .FALSE.
        ENDIF
C End of bi,bj loops
       ENDDO
      ENDDO

C If global file was opened then close it
      IF (fileIsOpen .AND. globalFile) THEN
       CLOSE( dUnit )
       fileIsOpen = .FALSE.
      ENDIF

      _END_MASTER( myThid )

C     ------------------------------------------------------------------
      RETURN
      END

#include "OCN_CPL_OPTIONS.h"

CBOP 0
C !ROUTINE: OCN_CHECK_CPLCONFIG

C !INTERFACE:
      SUBROUTINE OCN_CHECK_CPLCONFIG(
     U                        errFlag, errMsg,
     I                        myThid )

C !DESCRIPTION:
C     *==========================================================*
C     | SUBROUTINE OCN_CHECK_CPLCONFIG
C     | o Check for inconsistency in coupling set-up config
C     *==========================================================*
C     | The routine checks on consistent coupler-exchange config
C     |  and performs some basic checking on consistency between
C     |  components (e.g., land-sea mask);
C     | Also summarises coupling set-up config and output fields
C     |  that were imported
C     *==========================================================*

C !USES:
      IMPLICIT NONE
C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "CPL_PARAMS.h"
#include "OCNCPL.h"

C !INPUT/OUTPUT PARAMETERS:
C     errFlag  :: logical flag to report an error
C     errMsg   :: error message to print to clog file
C     myThid   :: Thread number for this instance of the routine
      LOGICAL errFlag
      CHARACTER*(*) errMsg
      INTEGER myThid

C !LOCAL VARIABLES:
      INTEGER i, j, bi, bj
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      _RL atm_waterOnly, atm_landOnly, depth_noWater
CEOP

C--   Summarise fields that were imported.
C     o Plot atmosphere land-mask
      IF ( debugLevel.GE.debLevB ) THEN
        CALL WRITE_FLD_XY_RL( 'Atm_Land', ' ', landMask, 0, myThid )
      ENDIF
      IF ( plotLevel.GE.debLevC ) THEN
        CALL PLOT_FIELD_XYRL( landMask,
     &                  'Atmosphere land/sea mask on ocean grid',
     &                  1, myThid )
      ENDIF

C--   Report previously found errors
      _BEGIN_MASTER( myThid )

      IF ( cplErrorCount.NE.0 ) THEN
        errFlag = .TRUE.
        WRITE(msgBuf,'(2A,I4,A)') 'OCN_CHECK_CPLCONFIG: ',
     &    ' cplErrorCount=', cplErrorCount, ' (from previous error)'
        CALL PRINT_ERROR( msgBuf, myThid )
      ENDIF

C--   Do consistency checks on imported fields.
C     o Check that:
C      a) where land/sea mask is "water-only", this should be a wet ocean pts
C      b) where land/sea mask has "no water",  this should be a dry ocean pts
      atm_waterOnly = 0. _d 0
      atm_landOnly  = 1. _d 0
      depth_noWater = 0. _d 0
      DO bj=1,nSy
       DO bi=1,nSx
        DO j=1,sNy
         DO i=1,sNx
          IF ( ( landMask(i,j,bi,bj) .EQ. atm_waterOnly
     &        .AND. R_low(i,j,bi,bj) .EQ. depth_noWater )
     &    .OR. ( landMask(i,j,bi,bj) .EQ. atm_landOnly
     &        .AND. R_low(i,j,bi,bj) .NE. depth_noWater ) ) THEN
           errFlag = .TRUE.
           WRITE(msgBuf,'(2(A,I6),2(A,I4),A)')
     &     'Inconsistent land/sea mask @ (i=', i, ',j=', j,
     &                              ',bi=', bi, ',bj=', bj, ')'
           CALL PRINT_ERROR( msgBuf, myThid )
           WRITE(msgBuf,'(A,E30.15)')
     &     'Land (atmosphere) ==', landMask(i,j,bi,bj)
           CALL PRINT_ERROR( msgBuf, myThid )
           WRITE(msgBuf,'(A,E30.15)')
     &     'Depth (ocean)     ==', R_low(i,j,bi,bj)
           CALL PRINT_ERROR( msgBuf, myThid )
          ENDIF
         ENDDO
        ENDDO
       ENDDO
      ENDDO

      IF ( errFlag ) WRITE(errMsg,'(A)')
     &   'OCN_CHECK_CPLCONFIG: inconsistent OCN/CPL/ATM config'

      _END_MASTER( myThid )

      RETURN
      END

#include "OBCS_OPTIONS.h"

CBOP
C     !ROUTINE: OBCS_ADJUST

C     !INTERFACE:
      SUBROUTINE OBCS_ADJUST(
     &     futureTime, futureIter, myThid )

C     !DESCRIPTION:
C     *==========================================================*
C     | SUBROUTINE OBCS_ADJUST
C     | o adjust boundary fluxes to balance flow
C     | o this code used to be part of S/R OBCS_CALC, but with
C     |   surface balancing, we need all forcing terms so this
C     |   part needs be called after S/R EXTERNAL_FORCING_SURF
C     | o tidal forcing needs to be applied at the very end after
C     |   balancing the flow because it introduces new
C     |   (purposefully) unbalanced flow
C     *==========================================================*

C     !USES:
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "OBCS_PARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
      INTEGER futureIter
      _RL futureTime
      INTEGER myThid

#ifdef ALLOW_OBCS

#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_ENTER('OBCS_ADJUST',myThid)
#endif

#ifdef ALLOW_OBCS_BALANCE
      IF ( useOBCSbalance ) THEN
        CALL OBCS_BALANCE_FLOW( futureTime, futureIter, myThid )
      ENDIF
#endif /* ALLOW_OBCS_BALANCE */

#ifdef ALLOW_OBCS_TIDES
      IF ( useOBCStides ) THEN
        CALL OBCS_ADD_TIDES( futureTime, futureIter, myThid )
      ENDIF
#endif /* ALLOW_OBCS_TIDES */

#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_LEAVE('OBCS_ADJUST',myThid)
#endif
#endif /* ALLOW_OBCS */

      RETURN
      END

#include "KPP_OPTIONS.h"

CBOP
C     !ROUTINE: KPP_INIT_FIXED
C     !INTERFACE:
      SUBROUTINE KPP_INIT_FIXED( myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE KPP_INIT_FIXED
C     | o Routine to initialize GM/Redi variables
C     |   that are kept fixed during the run.
C     *==========================================================*
C     \ev
C     !USES:
      IMPLICIT NONE

C     === Global variables ===
#include "EEPARAMS.h"
#include "SIZE.h"
#include "PARAMS.h"
#include "GRID.h"
#include "KPP_PARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
C     myThid ::  my Thread Id number
      INTEGER myThid
CEOP

C     !LOCAL VARIABLES:
C     === Local variables ===
C     i,j,k,bi,bj - Loop counters
C     zehat       - zeta * ustar**3
C     zeta        - Stability parameter d/l
      INTEGER i, j, k
      _RL zehat
      _RL zeta
      _RL usta
      _RL p25, p33

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C-- Note: this should go in a separated S/R: KPP_MNC_INIT
#ifdef ALLOW_MNC
      IF (useMNC) THEN
C       Define grid types for KPP variables
        CALL MNC_CW_ADD_VNAME('KPPviscAz', 'Cen_xy_Hn__C__t',
     &       4,5, myThid)
        CALL MNC_CW_ADD_VATTR_TEXT('KPPviscAz','units','m^2/s',
     &       myThid)
        CALL MNC_CW_ADD_VATTR_TEXT('KPPviscAz','long_name',
     &       'KPP_vertical_eddy_viscosity_coefficient', myThid)
        CALL MNC_CW_ADD_VATTR_TEXT('KPPviscAz',
     &       'coordinates','XC YC RC iter', myThid)

        CALL MNC_CW_ADD_VNAME('KPPdiffKzS', 'Cen_xy_Hn__C__t',
     &       4,5, myThid)
        CALL MNC_CW_ADD_VATTR_TEXT('KPPdiffKzS','units','m^2/s',
     &       myThid)
        CALL MNC_CW_ADD_VATTR_TEXT('KPPdiffKzS','long_name',
     &       'KPP_salt-tracer_vertical_diffusion_coefficient',
     &       myThid)
        CALL MNC_CW_ADD_VATTR_TEXT('KPPdiffKzS',
     &       'coordinates','XC YC RC iter', myThid)

        CALL MNC_CW_ADD_VNAME('KPPdiffKzT', 'Cen_xy_Hn__C__t',
     &       4,5, myThid)
        CALL MNC_CW_ADD_VATTR_TEXT('KPPdiffKzT','units','m^2/s',
     &       myThid)
        CALL MNC_CW_ADD_VATTR_TEXT('KPPdiffKzT','long_name',
     &       'KPP_vertical_heat_diffusion_coefficient', myThid)
        CALL MNC_CW_ADD_VATTR_TEXT('KPPdiffKzT',
     &       'coordinates','XC YC RC iter', myThid)

        CALL MNC_CW_ADD_VNAME('KPPGHAT', 'Cen_xy_Hn__C__t',
     &       4,5, myThid)
        CALL MNC_CW_ADD_VATTR_TEXT('KPPGHAT','units','s/m^2',
     &       myThid)
        CALL MNC_CW_ADD_VATTR_TEXT('KPPGHAT','long_name',
     &       'KPP_nonlocal_transport_coefficient', myThid)
        CALL MNC_CW_ADD_VATTR_TEXT('KPPGHAT',
     &       'coordinates','XC YC RC iter', myThid)

        CALL MNC_CW_ADD_VNAME('KPPghatKS', 'Cen_xy_Hn__L__t',
     &       4,5, myThid)
        CALL MNC_CW_ADD_VATTR_TEXT('KPPghatKS','units','0-1',
     &       myThid)
        CALL MNC_CW_ADD_VATTR_TEXT('KPPghatKS','long_name',
     &  'ratio of KPP non-local (salt) flux relative to surface-flux',
     &       myThid)
        CALL MNC_CW_ADD_VATTR_TEXT('KPPghatKS','coordinates',
     &       'XC YC RF iter', myThid)

        CALL MNC_CW_ADD_VNAME('KPPHBL', 'Cen_xy_Hn__-__t',
     &       3,4, myThid)
        CALL MNC_CW_ADD_VATTR_TEXT('KPPHBL','units','m',
     &       myThid)
        CALL MNC_CW_ADD_VATTR_TEXT('KPPHBL','long_name',
     &       'KPP_boundary_layer_depth', myThid)
        CALL MNC_CW_ADD_VATTR_TEXT('KPPHBL',
     &       'coordinates','XC YC iter', myThid)

        CALL MNC_CW_ADD_VNAME('KPPFRAC', 'Cen_xy_Hn__-__t',
     &       3,4, myThid)
        CALL MNC_CW_ADD_VATTR_TEXT('KPPFRAC','units','dimless',
     &       myThid)
        CALL MNC_CW_ADD_VATTR_TEXT('KPPFRAC','long_name',
     &       'KPP_short-wave_fraction_heating_the_mixing_layer',
     &       myThid)
        CALL MNC_CW_ADD_VATTR_TEXT('KPPFRAC',
     &       'coordinates','XC YC iter', myThid)
      ENDIF
#endif /* ALLOW_MNC */
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      _BEGIN_MASTER(myThid)

      p25 = 0.25 _d 0
      p33 = 1. _d 0 / 3. _d 0

C-----------------------------------------------------------------------
C Initialize constants that depend on parameters in data.kpp
C-----------------------------------------------------------------------

      Vtc     = concv * SQRT(0.2 _d 0 /concs/epsilon) / vonk**2 / Ricr
      cg      = cstar * vonk * (concs * vonk * epsilon)**p33

c-----------------------------------------------------------------------
c construct the wm and ws lookup tables
c-----------------------------------------------------------------------

      deltaz = (zmax - zmin)/(nni + 1)
      deltau = (umax - umin)/(nnj + 1)

      DO i = 0, nni + 1
         zehat = deltaz*i + zmin
         DO j = 0, nnj + 1
            usta = deltau*j + umin
            zeta = zehat / max(phepsi,usta**3)
            IF (zehat .GE. 0.) THEN
               wmt(i,j) = vonk*usta/(1. + conc1*zeta)
               wst(i,j) = wmt(i,j)
            ELSE
               IF (zeta .GT. zetam) THEN
                  wmt(i,j) = vonk*usta*(1. - conc2*zeta)**p25
               ELSE
                  wmt(i,j) = vonk*(conam*usta**3 - concm*zehat)**p33
               ENDIF
               IF (zeta .GT. zetas) THEN
                  wst(i,j) = vonk*usta*SQRT(1. _d 0 - conc3*zeta)
               ELSE
                  wst(i,j) = vonk*(conas*usta**3 - concs*zehat)**p33
               ENDIF
            ENDIF
         ENDDO
      ENDDO

C-----------------------------------------------------------------------
C     vertical grid
C-----------------------------------------------------------------------

      IF (minKPPhbl .EQ. UNSET_RL) THEN
         minKPPhbl = -rC(1)
      ENDIF
      zgrid(0)  =  phepsi
      hwide(0)  =  phepsi
c     zgrid(1)  = -drF(1)*0.5
c     hwide(1)  =  drF(1)
c     DO k = 2, Nr
c        zgrid(k) = zgrid(k-1) - (drF(k-1)+drF(k))*0.5
c        hwide(k) = drF(k)
c     ENDDO
C- jmc : use the model vertical grid :
      DO k = 1, Nr
         zgrid(k) = rC(k)
         hwide(k) = drF(k)
      ENDDO

      zgrid(Nrp1) = zgrid(Nr) * 100.

      hwide(Nrp1) = phepsi

      _END_MASTER(myThid)
      _BARRIER

#ifdef ALLOW_DIAGNOSTICS
      IF ( useDiagnostics ) THEN
        CALL KPP_DIAGNOSTICS_INIT( myThid )
      ENDIF
#endif

      RETURN
      END

      subroutine template()
      use OAD_cp
      use OAD_tape
      use OAD_rev

!$TEMPLATE_PRAGMA_DECLARATIONS

      integer :: cp_loop_variable_1,cp_loop_variable_2,
     +     cp_loop_variable_3,cp_loop_variable_4

      integer iaddr
      external iaddr

#ifdef OAD_DEBUG_SPLIT1
      character*(80):: indentation='                                        
     +                                         '
      our_indent=our_indent+1

      write(standardmessageunit, '(A,A,A)', ADVANCE='NO') 
     +'OAD:',indentation(1:our_indent), 'enter __SRNAME__:'
      call oad_dump_revmod(); call oad_dump_tapestats()
      write(standardmessageunit,*) 
#endif

      if (our_rev_mode%plain) then
#ifdef OAD_DEBUG_SPLIT1
        write(standardmessageunit,'(A,A,A)') 
     +'OAD:',indentation(1:our_indent), 
     +' __SRNAME__: entering plain'
#endif
!$PLACEHOLDER_PRAGMA$ id=1
      end if
      if (our_rev_mode%tape) then
#ifdef OAD_DEBUG_SPLIT1
        write(standardmessageunit,'(A,A,A)') 
     +'OAD:',indentation(1:our_indent), 
     +' __SRNAME__: entering tape'
#endif
!$PLACEHOLDER_PRAGMA$ id=2
      end if 
      if (our_rev_mode%adjoint) then
#ifdef OAD_DEBUG_SPLIT1
         write(standardmessageunit,'(A,A,A)') 
     +'OAD:',indentation(1:our_indent), 
     +' __SRNAME__: entering adjoint'
#endif
!$PLACEHOLDER_PRAGMA$ id=3
      end if 

#ifdef OAD_DEBUG_SPLIT1
      write(standardmessageunit,'(A,A,A)', ADVANCE='NO') 
     +'OAD:',indentation(1:our_indent), 'leave __SRNAME__:'
      call oad_dump_revmod(); call oad_dump_tapestats()
      write(standardmessageunit,*) 

      our_indent=our_indent-1
#endif

      end subroutine template

#include "ctrparam.h"
#include "ATM2D_OPTIONS.h"

C     !INTERFACE:
      SUBROUTINE SUBTRACT_MEANS( wght0, wght1,
     &                           intime0, intime1, myThid )
C     *==========================================================*
C     | Subtract out (1D) mean values of wind variables          |
c     | (anomaly coupling)                                       |
C     *==========================================================*
      IMPLICIT NONE

#include "ATMSIZE.h"
#include "SIZE.h"
#include "EEPARAMS.h"
#include "ATM2D_VARS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
C     myThid - Thread no. that called this routine.
      _RL  wght0
      _RL  wght1
      INTEGER intime0
      INTEGER intime1
      INTEGER myThid

C     LOCAL VARIABLES:
      INTEGER j_atm

C     Interpolate and subtract 1D mean wind files

      DO j_atm=2,jm0-1
        atm_tauu(j_atm)= atm_tauu(j_atm) -
     &       (wght0*atau(j_atm,intime0) + wght1*atau(j_atm,intime1))
        atm_tauv(j_atm)= atm_tauv(j_atm) -
     &       (wght0*atav(j_atm,intime0) + wght1*atav(j_atm,intime1))
        atm_windspeed(j_atm)= atm_windspeed(j_atm) -
     &       (wght0*awind(j_atm,intime0) + wght1*awind(j_atm,intime1))
      ENDDO

      RETURN
      END

#include "PACKAGES_CONFIG.h"
#include "CPP_OPTIONS.h"
      subroutine set_alarm (tag,date,time,freq)
C***********************************************************************        
C  Purpose                                                                      
C  -------                                                                      
C     Utility to Set Internal Alarms
C
C  Argument Description                                                         
C  --------------------                                                          
C     tag ....... Character String Tagging Alarm Process
C     date ...... Begining Date for Alarm
C     time ...... Begining Time for Alarm
C     freq ...... Repeating Frequency Interval for Alarm
C
C***********************************************************************        

      implicit none
      character*(*) tag
      integer       freq,date,time

#ifdef ALLOW_USE_MPI
#include "SIZE.h"
#include "EEPARAMS.h"
#include "EESUPPORT.h"
#endif

#include "chronos.h"

#ifdef ALLOW_USE_MPI
c MPI Utilities
c -------------
#include "mpif.h"
      integer  mpi_comm_model,ierror
#endif

      integer myid
      logical first,set
      data          first /.true./

      integer n
#ifdef ALLOW_USE_MPI
      call mpi_comm_rank ( mpi_comm_model,myid,ierror )
#else
      myid = 1
#endif

      if(first) then
         ntags    = 1
          tags(1) = tag
         freqs(1) = freq
         dates(1) = date
         times(1) = time
         if( myid.eq.1 ) write(6,100) date,time,freq,tags(1)
      else

      set = .false.
      do n=1,ntags
       if(tag.eq.tags(n)) then
        if( myid.eq.1 ) then
         print *, 'Warning!  Alarm has already been set for Tag: ',tag
         print *, 'Changing  Alarm Information:'
         print *, 'Frequency: ',freqs(n),' (Old) ',freq,' (New)'
         print *, '    Date0: ',dates(n),' (Old) ',date,' (New)'
         print *, '    Time0: ',times(n),' (Old) ',time,' (New)'
        endif
        freqs(n) = freq
        dates(n) = date
        times(n) = time
        set = .true.
       endif
      enddo
      if(.not.set) then
            ntags = ntags+1
         if(ntags.gt.maxtag ) then
            if( myid.eq.1 ) then
            print *, 'Too many Alarms are Set!!'
            print *, 'Maximum Number of Alarms = ',maxtag
            endif
         call my_finalize
         call my_exit (101)
         endif
          tags(ntags) = tag
         freqs(ntags) = freq
         dates(ntags) = date
         times(ntags) = time
         if( myid.eq.1 ) write(6,100) date,time,freq,tags(ntags)
      endif
      endif

      first = .false.
  100 format(1x,'Setting Alarm for: ',i8,2x,i6.6,',  with frequency: ',
     .       i8,', and Tag: ',a80)
      return
      end

      subroutine get_alarm (tag,date,time,freq,tleft)
C***********************************************************************        
C  Purpose                                                                      
C  -------                                                                      
C     Utility to Get Internal Alarm Information
C
C  Input
C  -----
C     tag ....... Character String Tagging Alarm Process
C
C  Output
C  ------
C     date ...... Begining  Date for Alarm
C     time ...... Begining  Time for Alarm
C     freq ...... Frequency Interval for Alarm
C     tleft ..... Time Remaining (seconds) before Alarm is TRUE
C
C***********************************************************************        

      implicit none
      character*(*) tag
      integer freq,date,time,tleft

#ifdef ALLOW_USE_MPI
#include "SIZE.h"
#include "EEPARAMS.h"
#include "EESUPPORT.h"
#endif

#include "chronos.h"

#ifdef ALLOW_USE_MPI
c MPI Utilities
c -------------
#include "mpif.h"
      integer  mpi_comm_model,ierror
#endif

      logical set,alarm
      external alarm
      integer myid,n,nalarm,nsecf

#ifdef ALLOW_USE_MPI
      call mpi_comm_rank ( mpi_comm_model,myid,ierror )
#else
      myid = 1
#endif

      set = .false.
      do n=1,ntags
      if(tag.eq.tags(n)) then
       freq  = freqs(n)
       date  = dates(n)
       time  = times(n)

       if( alarm(tag) ) then
       tleft = 0
       else
       call get_time (nymd,nhms)
       tleft = nsecf(freq) - nalarm(freq,nymd,nhms,date,time )
       endif

       set = .true.
      endif
      enddo

      if(.not.set) then
      if( myid.eq.1 ) print *, 'Alarm has not been set for Tag: ',tag
      freq  = 0
      date  = 0
      time  = 0
      tleft = 0
      endif

      return
      end

      function alarm (tag)
      implicit none
      character*(*) tag
      integer date,time
      logical alarm
#include "chronos.h"

      integer n,modalarm,nalarm,freq,date0,time0
      modalarm(freq,date0,time0) = nalarm (freq,date,time,date0,time0 )

      call get_time (date,time)

      alarm = .false.
      do n=1,ntags
      if( tags(n).eq.tag  ) then
          if( freqs(n).eq.0 ) then
          alarm = (dates(n).eq.date) .and. (times(n).eq.time)
          else
          alarm = ( date.gt.dates(n) .or.
     .             (date.eq.dates(n) .and. time.ge.times(n)) ) .and.
     .              modalarm( freqs(n),dates(n),times(n) ).eq.0
          endif
      endif
      enddo

      return
      end

      subroutine set_time (date,time)
      implicit none
      integer  date,time

#ifdef ALLOW_USE_MPI
#include "SIZE.h"
#include "EEPARAMS.h"
#include "EESUPPORT.h"
#endif

#include "chronos.h"

#ifdef ALLOW_USE_MPI
c MPI Utilities
c -------------
#include "mpif.h"
      integer  mpi_comm_model,ierror
#endif
      integer myid

#ifdef ALLOW_USE_MPI
      call mpi_comm_rank ( mpi_comm_model,myid,ierror )
#else
      myid = 1
#endif
      if(  myid.eq.1 ) then
      print *, 'Setting Clock'
      print *, 'Date: ',date
      print *, 'Time: ',time
      endif

      nymd = date
      nhms = time
      return
      end

      subroutine get_time (date,time)
      implicit none
      integer date,time

#include "chronos.h"

      date = nymd
      time = nhms
      return
      end

      function nsecf (nhms)
C***********************************************************************
C  Purpose
C     Converts NHMS format to Total Seconds
C
C***********************************************************************
      implicit none
      integer  nhms, nsecf
      nsecf =  nhms/10000*3600 + mod(nhms,10000)/100*60 + mod(nhms,100)
      return
      end

      function nhmsf (nsec)
C***********************************************************************
C  Purpose
C     Converts Total Seconds to NHMS format
C
C***********************************************************************
      implicit none
      integer  nhmsf, nsec
      nhmsf =  nsec/3600*10000 + mod(nsec,3600)/60*100 + mod(nsec,60)
      return
      end

      function nsecf2 (nhhmmss,nmmdd,nymd)
C***********************************************************************
C  Purpose
C     Computes the Total Number of seconds from NYMD using NHHMMSS & NMMDD
C
C  Arguments   Description
C     NHHMMSS  IntervaL Frequency (HHMMSS)
C     NMMDD    Interval Frequency (MMDD)
C     NYMD     Current  Date      (YYMMDD)
C
C  NOTE:
C     IF (NMMDD.ne.0), THEN HOUR FREQUENCY HH MUST BE < 24
C
C***********************************************************************
      implicit none

      integer nsecf2,nhhmmss,nmmdd,nymd

      INTEGER NSDAY, NCYCLE
      PARAMETER ( NSDAY  = 86400 )
      PARAMETER ( NCYCLE = 1461*24*3600 )

      INTEGER YEAR, MONTH, DAY

      INTEGER  MNDY(12,4)
      DATA MNDY /0,31,60,91,121,152,182,213,244,274,305,335,366,
     .           397,34*0 /

      integer nsecf,i,nsegm,nsegd,iday,iday2,nday

C***********************************************************************
C*                 COMPUTE # OF SECONDS FROM NHHMMSS                   *
C***********************************************************************

      nsecf2 = nsecf( nhhmmss )

      if( nmmdd.eq.0 ) return

C***********************************************************************
C*                 COMPUTE # OF DAYS IN A 4-YEAR CYCLE                 *
C***********************************************************************

      DO I=15,48
      MNDY(I,1) = MNDY(I-12,1) + 365
      ENDDO

C***********************************************************************
C*                 COMPUTE # OF SECONDS FROM NMMDD                     *
C***********************************************************************

      nsegm =     nmmdd/100
      nsegd = mod(nmmdd,100)

      YEAR   = NYMD / 10000
      MONTH  = MOD(NYMD,10000) / 100
      DAY    = MOD(NYMD,100)

      IDAY   = MNDY( MONTH ,MOD(YEAR ,4)+1 )
      month = month + nsegm
      If( month.gt.12 ) then
      month = month - 12
      year = year + 1
      endif
      IDAY2  = MNDY( MONTH ,MOD(YEAR ,4)+1 )

                    nday = iday2-iday
      if(nday.lt.0) nday = nday + 1461
                    nday = nday + nsegd

      nsecf2 = nsecf2 + nday*nsday

      return
      end

      subroutine fixdate (nymd)
      implicit none
      integer nymd

c Modify 6-digit YYMMDD for dates between 1950-2050
c -------------------------------------------------
      if (nymd .lt. 500101) then
        nymd = 20000000 + nymd
      else if (nymd .le. 991231) then
        nymd = 19000000 + nymd
      endif

      return
      end

      subroutine interp_time ( nymd ,nhms , 
     .                         nymd1,nhms1, nymd2,nhms2, fac1,fac2 )
C***********************************************************************        
C                                                                               
C  PURPOSE:
C  ========
C    Compute interpolation factors, fac1 & fac2, to be used in the
C    calculation of the instantanious boundary conditions, ie:
C
C               q(i,j) = fac1*q1(i,j) + fac2*q2(i,j)
C    where:
C               q(i,j) => Boundary Data valid    at (nymd  , nhms )
C              q1(i,j) => Boundary Data centered at (nymd1 , nhms1)
C              q2(i,j) => Boundary Data centered at (nymd2 , nhms2)
C                                                                               
C  INPUT:                                                                       
C  ======                                                                       
C    nymd     : Date (yymmdd) of Current Timestep
C    nhms     : Time (hhmmss) of Current Timestep
C    nymd1    : Date (yymmdd) of Boundary Data 1
C    nhms1    : Time (hhmmss) of Boundary Data 1
C    nymd2    : Date (yymmdd) of Boundary Data 2
C    nhms2    : Time (hhmmss) of Boundary Data 2
C                                                                               
C  OUTPUT:                                                                      
C  =======                                                                      
C    fac1     : Interpolation factor for Boundary Data 1
C    fac2     : Interpolation factor for Boundary Data 2
C                                                                               
C                                                                               
C***********************************************************************        
      implicit none

      integer nhms,nymd,nhms1,nymd1,nhms2,nymd2
      _RL fac1,fac2
                                                                                
      INTEGER  YEAR , MONTH , DAY , SEC
      INTEGER  YEAR1, MONTH1, DAY1, SEC1
      INTEGER  YEAR2, MONTH2, DAY2, SEC2

      _RL time, time1, time2
                                                                                
      INTEGER    DAYSCY                                                         
      PARAMETER (DAYSCY = 365*4+1)                                   

      INTEGER MNDY(12,4)              
                                                                                
      LOGICAL FIRST                                                             
      DATA    FIRST/.TRUE./                                                     
                                                                                
      DATA MNDY /0,31,60,91,121,152,182,213,244,274,305,335,366,                
     .           397,34*0 /

      integer i,nsecf
                                                                                
C***********************************************************************        
C*                         SET TIME BOUNDARIES                         *        
C***********************************************************************        
                                                                                
      YEAR   = NYMD / 10000
      MONTH  = MOD(NYMD,10000) / 100
      DAY    = MOD(NYMD,100)
      SEC    = NSECF(NHMS)
                                                                                
      YEAR1  = NYMD1 / 10000
      MONTH1 = MOD(NYMD1,10000) / 100
      DAY1   = MOD(NYMD1,100)
      SEC1   = NSECF(NHMS1)
                                                                                
      YEAR2  = NYMD2 / 10000
      MONTH2 = MOD(NYMD2,10000) / 100
      DAY2   = MOD(NYMD2,100)
      SEC2   = NSECF(NHMS2)
                                                                                
C***********************************************************************        
C*                    COMPUTE DAYS IN 4-YEAR CYCLE                     *        
C***********************************************************************        
                                                                                
      IF(FIRST) THEN
      DO I=15,48
      MNDY(I,1) = MNDY(I-12,1) + 365
      ENDDO
      FIRST=.FALSE.
      ENDIF
                                                                                
C***********************************************************************        
C*                     COMPUTE INTERPOLATION FACTORS                   *        
C***********************************************************************        
                                                                                
      time  = DAY  + MNDY(MONTH ,MOD(YEAR ,4)+1) + float(sec )/86400.
      time1 = DAY1 + MNDY(MONTH1,MOD(YEAR1,4)+1) + float(sec1)/86400.
      time2 = DAY2 + MNDY(MONTH2,MOD(YEAR2,4)+1) + float(sec2)/86400.

      if( time .lt.time1 ) time  = time  + dayscy
      if( time2.lt.time1 ) time2 = time2 + dayscy

      fac1  = (time2-time)/(time2-time1)
      fac2  = (time-time1)/(time2-time1)

      RETURN
      END

      subroutine tick (nymd,nhms,ndt)
C***********************************************************************
C  Purpose
C     Tick the Date (nymd) and Time (nhms) by NDT (seconds)
C
C***********************************************************************
      implicit none

      integer nymd,nhms,ndt

      integer nsec,nsecf,incymd,nhmsf

      IF(NDT.NE.0) THEN
      NSEC = NSECF(NHMS) + NDT

      IF (NSEC.GT.86400)  THEN
      DO WHILE (NSEC.GT.86400)
      NSEC = NSEC - 86400
      NYMD = INCYMD (NYMD,1)
      ENDDO
      ENDIF   
               
      IF (NSEC.EQ.86400)  THEN
      NSEC = 0
      NYMD = INCYMD (NYMD,1)
      ENDIF   
               
      IF (NSEC.LT.00000)  THEN
      DO WHILE (NSEC.LT.0)
      NSEC = 86400 + NSEC
      NYMD = INCYMD (NYMD,-1)
      ENDDO
      ENDIF   
               
      NHMS = NHMSF (NSEC)
      ENDIF   

      RETURN  
      END    

      subroutine tic_time (mymd,mhms,ndt)
C***********************************************************************
C  PURPOSE
C     Tick the Clock by NDT (seconds)
C
C***********************************************************************
      implicit none
#include "chronos.h"

      integer mymd,mhms,ndt

      integer nsec,nsecf,incymd,nhmsf

      IF(NDT.NE.0) THEN
      NSEC = NSECF(NHMS) + NDT

      IF (NSEC.GT.86400)  THEN
      DO WHILE (NSEC.GT.86400)
      NSEC = NSEC - 86400
      NYMD = INCYMD (NYMD,1)
      ENDDO
      ENDIF   
               
      IF (NSEC.EQ.86400)  THEN
      NSEC = 0
      NYMD = INCYMD (NYMD,1)
      ENDIF   
               
      IF (NSEC.LT.00000)  THEN
      DO WHILE (NSEC.LT.0)
      NSEC = 86400 + NSEC
      NYMD = INCYMD (NYMD,-1)
      ENDDO
      ENDIF   
               
      NHMS = NHMSF (NSEC)
      ENDIF   

c Pass Back Current Updated Time
c ------------------------------
      mymd = nymd
      mhms = nhms

      RETURN  
      END    

      FUNCTION NALARM (MHMS,NYMD,NHMS,NYMD0,NHMS0)                              
C***********************************************************************        
C  PURPOSE                                                                      
C     COMPUTES MODULO-FRACTION BETWEEN MHHS AND TOTAL TIME                      
C  USAGE                                                                        
C  ARGUMENTS   DESCRIPTION                                                      
C     MHMS     INTERVAL FREQUENCY (HHMMSS)                                      
C     NYMD     CURRENT   YYMMDD                                                 
C     NHMS     CURRENT   HHMMSS                                                 
C     NYMD0    BEGINNING YYMMDD                                                 
C     NHMS0    BEGINNING HHMMSS                                                 
C                                                                               
C***********************************************************************        
      implicit none

      integer nalarm,MHMS,NYMD,NHMS,NYMD0,NHMS0

      integer nsday, ncycle
      PARAMETER ( NSDAY  = 86400 )
      PARAMETER ( NCYCLE = 1461*24*3600 )

      INTEGER YEAR, MONTH, DAY, SEC, YEAR0, MONTH0, DAY0, SEC0

      integer MNDY(12,4)
      DATA MNDY /0,31,60,91,121,152,182,213,244,274,305,335,366,
     .           397,34*0 /

      integer i,nsecf,iday,iday0,nsec,nsec0,ntime

C***********************************************************************        
C*                 COMPUTE # OF DAYS IN A 4-YEAR CYCLE                 *        
C***********************************************************************        

      DO I=15,48
      MNDY(I,1) = MNDY(I-12,1) + 365
      ENDDO

C***********************************************************************        
C*                   SET CURRENT AND BEGINNING TIMES                   *        
C***********************************************************************        

      YEAR   = NYMD / 10000
      MONTH  = MOD(NYMD,10000) / 100
      DAY    = MOD(NYMD,100)
      SEC    = NSECF(NHMS)

      YEAR0  = NYMD0 / 10000
      MONTH0 = MOD(NYMD0,10000) / 100
      DAY0   = MOD(NYMD0,100)
      SEC0   = NSECF(NHMS0)

C***********************************************************************        
C*      COMPUTE POSITIONS IN CYCLE FOR CURRENT AND BEGINNING TIMES     *        
C***********************************************************************        
                                                                                
      IDAY   = (DAY -1) + MNDY( MONTH ,MOD(YEAR ,4)+1 )                         
      IDAY0  = (DAY0-1) + MNDY( MONTH0,MOD(YEAR0,4)+1 )                         
                                                                                
      NSEC   = IDAY *NSDAY + SEC                                                
      NSEC0  = IDAY0*NSDAY + SEC0                                               
                                                                                
                       NTIME  = NSEC-NSEC0                                      
      IF (NTIME.LT.0 ) NTIME  = NTIME + NCYCLE                                  
                       NALARM = NTIME                                           
      IF ( MHMS.NE.0 ) NALARM = MOD( NALARM,NSECF(MHMS) )                       
                                                                                
      RETURN                                                                    
      END                                                                       

      FUNCTION INCYMD (NYMD,M)                                                  
C***********************************************************************        
C  PURPOSE                                                                      
C     INCYMD:  NYMD CHANGED BY ONE DAY                                          
C     MODYMD:  NYMD CONVERTED TO JULIAN DATE                                    
C  DESCRIPTION OF PARAMETERS                                                    
C     NYMD     CURRENT DATE IN YYMMDD FORMAT                                    
C     M        +/- 1 (DAY ADJUSTMENT)                                           
C                                                                               
C***********************************************************************        
      implicit none
      integer incymd,nymd,m
                                                                                
      integer ny,nm,nd,ny00,modymd

      INTEGER NDPM(12)
      DATA NDPM /31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31/
      LOGICAL LEAP
      DATA NY00 /1900 /
      LEAP(NY) = MOD(NY,4).EQ.0 .AND. (NY.NE.0 .OR. MOD(NY00,400).EQ.0)
                                                                                
C***********************************************************************        
C                                                                               
      NY = NYMD / 10000
      NM = MOD(NYMD,10000) / 100
      ND = MOD(NYMD,100) + M
                                                                                
      IF (ND.EQ.0) THEN
      NM = NM - 1
      IF (NM.EQ.0) THEN
          NM = 12
          NY = NY - 1
      ENDIF
      ND = NDPM(NM)
      IF (NM.EQ.2 .AND. LEAP(NY))  ND = 29
      ENDIF
                                                                                
      IF (ND.EQ.29 .AND. NM.EQ.2 .AND. LEAP(NY))  GO TO 20

      IF (ND.GT.NDPM(NM)) THEN
      ND = 1
      NM = NM + 1
      IF (NM.GT.12) THEN
          NM = 1
          NY = NY + 1
      ENDIF
      ENDIF
                                                                                
   20 CONTINUE
      INCYMD = NY*10000 + NM*100 + ND

      RETURN
                                                                                
C***********************************************************************        
C                      E N T R Y    M O D Y M D                                 
C***********************************************************************        
                                                                                
      ENTRY MODYMD (NYMD)

      NY = NYMD / 10000
      NM = MOD(NYMD,10000) / 100
      ND = MOD(NYMD,100)
                                                                                
   40 CONTINUE
      IF (NM.LE.1)  GO TO 60
      NM = NM - 1
      ND = ND + NDPM(NM)
      IF (NM.EQ.2 .AND. LEAP(NY))  ND = ND + 1
      GO TO 40
                                                                                
   60 CONTINUE
      MODYMD = ND

      RETURN
      END

      SUBROUTINE ASTRO ( NYMD,NHMS,ALAT,ALON,IRUN,COSZ,RA )
C***********************************************************************
C
C  INPUT:
C  ======
C    NYMD      : CURRENT YYMMDD
C    NHMS      : CURRENT HHMMSS
C    ALAT(IRUN):LATITUDES  IN DEGREES.
C    ALON(IRUN):LONGITUDES IN DEGREES. (0 = GREENWICH, + = EAST).
C    IRUN      : # OF POINTS TO CALCULATE
C
C  OUTPUT:
C  =======
C    COSZ(IRUN)  : COSINE OF ZENITH ANGLE.
C    RA          : EARTH-SUN DISTANCE IN UNITS OF
C                  THE ORBITS SEMI-MAJOR AXIS.
C
C  NOTE:
C  =====
C  THE INSOLATION AT THE TOP OF THE ATMOSPHERE IS:
C
C  S(I) = (SOLAR CONSTANT)*(1/RA**2)*COSZ(I),
C
C  WHERE:
C  RA AND COSZ(I) ARE THE TWO OUTPUTS OF THIS SUBROUTINE.
C
C***********************************************************************

      implicit none

c Input Variables
c ---------------
      integer nymd, nhms, irun
      _RL    cosz(irun), alat(irun), alon(irun), ra

c Local Variables
c ---------------
      integer year, day, sec, month, iday, idayp1
      integer dayscy
      integer i,nsecf,k,km,kp

      _RL hc
      _RL pi, zero, one, two, six, dg2rd, yrlen, eqnx, ob, ecc, per
      _RL daylen, fac, thm, thp, thnow, zs, zc, sj, cj

      parameter ( pi    = 3.1415926535898)
      parameter ( zero  = 0.0 )
      parameter ( one   = 1.0 )
      parameter ( two   = 2.0 )
      parameter ( six   = 6.0 )
      parameter ( dg2rd = pi/180. )

      parameter ( yrlen  = 365.25  )
      parameter ( dayscy = 365*4+1 )
      parameter ( eqnx   =  80.9028)
      parameter ( ob     =  23.45*dg2rd )
      parameter ( ecc    =   0.0167 )
      parameter ( per    = 102.0*dg2rd)
      parameter ( daylen = 86400.)

      _RL      TH(DAYSCY),T0,T1,T2,T3,T4,FUN,Y,MNDY(12,4)

      LOGICAL FIRST
      DATA    FIRST/.TRUE./
      SAVE

      DATA MNDY /0,31,60,91,121,152,182,213,244,274,305,335,366,
     .           397,34*0 /

      FUN(Y) = (TWO*PI/((ONE-ECC**2)**1.5))*(ONE/YRLEN)
     .       * (ONE - ECC*COS(Y-PER)) ** 2

C***********************************************************************
C*                          SET CURRENT TIME                           *
C***********************************************************************

      YEAR  = NYMD / 10000
      MONTH = MOD(NYMD,10000) / 100
      DAY   = MOD(NYMD,100)
      SEC   = NSECF(NHMS)

C***********************************************************************
C*                 COMPUTE DAY-ANGLES FOR 4-YEAR CYCLE                 *
C***********************************************************************

      IF(FIRST) THEN
           DO 100 I=15,48
           MNDY(I,1) = MNDY(I-12,1) + 365
100        CONTINUE

           KM  = INT(EQNX) + 1
           FAC = KM-EQNX
           T0 = ZERO
           T1 = FUN(T0         )*FAC
           T2 = FUN(ZERO+T1/TWO)*FAC
           T3 = FUN(ZERO+T2/TWO)*FAC
           T4 = FUN(ZERO+T3    )*FAC
           TH(KM) = (T1 + TWO*(T2 + T3) + T4) / SIX

           DO 200 K=2,DAYSCY
           T1 = FUN(TH(KM)       )
           T2 = FUN(TH(KM)+T1/TWO)
           T3 = FUN(TH(KM)+T2/TWO)
           T4 = FUN(TH(KM)+T3    )
           KP = MOD(KM,DAYSCY) + 1
           TH(KP) = TH(KM) + (T1 + TWO*(T2 + T3) + T4) / SIX
           KM = KP
 200       CONTINUE

           FIRST=.FALSE.
      ENDIF

C***********************************************************************
C*            COMPUTE EARTH-SUN DISTANCE TO CURRENT SECOND             *
C***********************************************************************

      IDAY   = DAY + MNDY(MONTH,MOD(YEAR,4)+1)
      IDAYP1 = MOD( IDAY,DAYSCY) + 1
      THM    = MOD( TH(IDAY)  ,TWO*PI)
      THP    = MOD( TH(IDAYP1),TWO*PI)

      IF(THP.LT.THM) THP = THP + TWO*PI
      FAC   = FLOAT(SEC)/DAYLEN
      THNOW = THM*(ONE-FAC) + THP*FAC

      ZS = SIN(THNOW) * SIN(OB)
      ZC = SQRT(ONE-ZS*ZS)
      RA = (1.-ECC*ECC) / ( ONE-ECC*COS(THNOW-PER) )

C***********************************************************************
C*                 COMPUTE COSINE OF THE ZENITH ANGLE                  *
C***********************************************************************

      FAC  = FAC*TWO*PI + PI
      DO I = 1,IRUN

      HC = COS( FAC+ALON(I)*DG2RD )
      SJ = SIN(ALAT(I)*DG2RD)
      CJ = SQRT(ONE-SJ*SJ)

          COSZ(I) = SJ*ZS + CJ*ZC*HC
      IF( COSZ(I).LT.ZERO ) COSZ(I) = ZERO
      ENDDO

      RETURN
      END

      subroutine time_bound(nymd,nhms,nymd1,nhms1,nymd2,nhms2,imnm,imnp)
C***********************************************************************
C  PURPOSE
C     Compute Date and Time boundaries.
C
C  ARGUMENTS   DESCRIPTION
C     nymd .... Current    Date
C     nhms .... Current    Time
C     nymd1 ... Previous   Date Boundary
C     nhms1 ... Previous   Time Boundary
C     nymd2 ... Subsequent Date Boundary
C     nhms2 ... Subsequent Time Boundary
C
C     imnm .... Previous   Time Index for Interpolation
C     imnp .... Subsequent Time Index for Interpolation
C
C***********************************************************************

      implicit none
      integer  nymd,nhms, nymd1,nhms1, nymd2,nhms2

c Local Variables
c ---------------
      integer  month,day,nyear,midmon1,midmon,midmon2
      integer  imnm,imnp
      INTEGER  DAYS(14), daysm, days0, daysp
      DATA     DAYS /31,31,28,31,30,31,30,31,31,30,31,30,31,31/

      integer nmonf,ndayf,n
      NMONF(N) = MOD(N,10000)/100
      NDAYF(N) = MOD(N,100)

C*********************************************************************
C**** Find Proper Month and Time Boundaries for Climatological Data **
C*********************************************************************

      MONTH  = NMONF(NYMD)
      DAY    = NDAYF(NYMD)

      daysm  = days(month  )
      days0  = days(month+1)
      daysp  = days(month+2)

c Check for Leap Year
c -------------------
      nyear = nymd/10000
      if( 4*(nyear/4).eq.nyear ) then
      if( month.eq.3 ) daysm = daysm+1
      if( month.eq.2 ) days0 = days0+1
      if( month.eq.1 ) daysp = daysp+1
      endif

      MIDMON1 = daysm/2 + 1
      MIDMON  = days0/2 + 1
      MIDMON2 = daysp/2 + 1


      IF(DAY.LT.MIDMON) THEN
         imnm = month
         imnp = month + 1
         nymd2 = (nymd/10000)*10000 + month*100 + midmon
         nhms2 = 000000
         nymd1 = nymd2
         nhms1 = nhms2
         call tick ( nymd1,nhms1,       -midmon  *86400 )
         call tick ( nymd1,nhms1,-(daysm-midmon1)*86400 )
      ELSE
         IMNM = MONTH + 1
         IMNP = MONTH + 2
         nymd1 = (nymd/10000)*10000 + month*100 + midmon
         nhms1 = 000000
         nymd2 = nymd1
         nhms2 = nhms1
         call tick ( nymd2,nhms2,(days0-midmon)*86400 )
         call tick ( nymd2,nhms2,       midmon2*86400 )
      ENDIF

c -------------------------------------------------------------
c Note:  At this point, imnm & imnp range between 01-14, where
c        01    -> Previous years December
c        02-13 -> Current  years January-December
c        14    -> Next     years January
c -------------------------------------------------------------

      imnm = imnm-1
      imnp = imnp-1

      if( imnm.eq.0  ) imnm = 12
      if( imnp.eq.0  ) imnp = 12
      if( imnm.eq.13 ) imnm = 1
      if( imnp.eq.13 ) imnp = 1

      return
      end

#include "MNC_OPTIONS.h"

C--  File mnc_var.F: Handle NetCDF variables (definition,description & writing)
C--   Contents
C--   o MNC_VAR_INIT_DBL
C--   o MNC_VAR_INIT_REAL
C--   o MNC_VAR_INIT_INT
C--   o MNC_VAR_INIT_ANY
C--   o MNC_VAR_ADD_ATTR_STR
C--   o MNC_VAR_ADD_ATTR_DBL
C--   o MNC_VAR_ADD_ATTR_REAL
C--   o MNC_VAR_ADD_ATTR_INT
C--   o MNC_VAR_ADD_ATTR_ANY
C--   o MNC_VAR_WRITE_DBL
C--   o MNC_VAR_WRITE_REAL
C--   o MNC_VAR_WRITE_INT
C--   o MNC_VAR_APPEND_DBL
C--   o MNC_VAR_APPEND_REAL
C--   o MNC_VAR_APPEND_INT
C--   o MNC_VAR_WRITE_ANY

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 1
C     !ROUTINE: MNC_VAR_INIT_DBL

C     !INTERFACE:
      SUBROUTINE MNC_VAR_INIT_DBL(
     I     fname,
     I     gname,
     I     vname,
     I     irv,
     I     myThid )

C     !DESCRIPTION:
C     Create a double-precision real variable within a NetCDF file context.

C     !USES:
      IMPLICIT NONE
#include "netcdf.inc"

C     !INPUT PARAMETERS:
      CHARACTER*(*) fname,gname,vname
      INTEGER irv,myThid
CEOP

      CALL MNC_VAR_INIT_ANY( fname,gname,vname, NF_DOUBLE, irv,myThid )

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 1
C     !ROUTINE: MNC_VAR_INIT_REAL

C     !INTERFACE:
      SUBROUTINE MNC_VAR_INIT_REAL(
     I     fname,
     I     gname,
     I     vname,
     I     irv,
     I     myThid )

C     !DESCRIPTION:
C     Create a single-precision real variable within a NetCDF file context.

C     !USES:
      IMPLICIT NONE
#include "netcdf.inc"

C     !INPUT PARAMETERS:
      CHARACTER*(*) fname,gname,vname
      INTEGER irv,myThid
CEOP

      CALL MNC_VAR_INIT_ANY( fname,gname,vname, NF_FLOAT, irv,myThid )

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 1
C     !ROUTINE: MNC_VAR_INIT_INT

C     !INTERFACE:
      SUBROUTINE MNC_VAR_INIT_INT(
     I     fname,
     I     gname,
     I     vname,
     I     irv,
     I     myThid )

C     !DESCRIPTION:
C     Create an integer variable within a NetCDF file context.

C     !USES:
      IMPLICIT NONE
#include "netcdf.inc"

C     !INPUT PARAMETERS:
      CHARACTER*(*) fname,gname,vname
      INTEGER irv,myThid
CEOP

      CALL MNC_VAR_INIT_ANY( fname,gname,vname, NF_INT, irv,myThid )

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 1
C     !ROUTINE: MNC_VAR_INIT_ANY

C     !INTERFACE:
      SUBROUTINE MNC_VAR_INIT_ANY(
     I     fname,
     I     gname,
     I     vname,
     I     vtype,
     I     irv,
     I     myThid )

C     !DESCRIPTION:
C     General function for creating variables within a NetCDF file context.

C     !USES:
      IMPLICIT NONE
#include "MNC_COMMON.h"
#include "EEPARAMS.h"
#include "netcdf.inc"

C     !INPUT PARAMETERS:
      CHARACTER*(*) fname,gname,vname
      INTEGER vtype
      INTEGER irv,myThid
CEOP

C     Functions
      INTEGER  ILNBLNK
      EXTERNAL ILNBLNK

C     !LOCAL VARIABLES:
      INTEGER i,j,k, n, nf, indf,indv, fid, nd, ngrid, is,ie, err
      INTEGER vid, nv, ind_g_finfo, needed, nvar
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      INTEGER ids(20)
      INTEGER lenf,leng,lenv

C     Strip trailing spaces
      lenf = ILNBLNK(fname)
      leng = ILNBLNK(gname)
      lenv = ILNBLNK(vname)

C     Check that the file is open
      CALL MNC_GET_IND(MNC_MAX_FID, fname, mnc_f_names, indf, myThid)
      IF (indf .LT. 1) THEN
        nf = ILNBLNK( fname )
        WRITE(msgBuf,'(3A)') 'MNC ERROR: file ''', fname(1:nf),
     &       ''' must be opened first'
        CALL print_error(msgBuf, myThid)
        STOP 'ABNORMAL END: S/R MNC_VAR_INIT_ANY'
      ENDIF
      fid = mnc_f_info(indf,2)

C     Check for sufficient storage space in mnc_fv_ids
      needed = 1 + 3*(mnc_fv_ids(indf,1) + 1)
      IF (needed .GE. MNC_MAX_INFO) THEN
        WRITE(msgBuf,'(2A,I7,A)') 'MNC ERROR: MNC_MAX_INFO exceeded',
     &       ': please increase it to ', 2*MNC_MAX_INFO,
     &       ' in the file ''pkg/mnc/MNC_SIZE.h'''
        CALL print_error(msgBuf, myThid)
        STOP 'ABNORMAL END: S/R MNC_VAR_INIT_ANY'
      ENDIF

C     Get the grid information
      ngrid = mnc_f_info(indf,3)
      IF (ngrid .LT. 1) THEN
        WRITE(msgBuf,'(3A)') 'MNC ERROR: file ''', fname(1:lenf),
     &       ''' contains NO grids'
        CALL print_error(msgBuf, myThid)
        STOP 'ABNORMAL END: S/R MNC_VAR_INIT_ANY'
      ENDIF
      DO i = 1,ngrid
        j = 4 + (i-1)*3
        k = mnc_f_info(indf,j)
        n = ILNBLNK(mnc_g_names(k))
        IF ((leng .EQ. n)
     &       .AND. (mnc_g_names(k)(1:n) .EQ. gname(1:n))) THEN
          ind_g_finfo = j
          is = mnc_f_info(indf,(j+1))
          ie = mnc_f_info(indf,(j+2))
          nd = 0
          DO k = is,ie
            nd = nd + 1
            ids(nd) = mnc_d_ids(mnc_fd_ind(indf,k))
          ENDDO
          GOTO 10
        ENDIF
      ENDDO
      WRITE(msgBuf,'(5A)') 'MNC ERROR: file ''', fname(1:lenf),
     &     ''' does not contain grid ''', gname(1:leng), ''''
      CALL print_error(msgBuf, myThid)
      STOP 'ABNORMAL END: S/R MNC_VAR_INIT_ANY'
 10   CONTINUE

C     Check if the variable is already defined
      nvar = mnc_fv_ids(indf,1)
      DO i = 1,nvar
        j = 2 + 3*(i-1)
        IF (mnc_v_names(mnc_fv_ids(indf,j)) .EQ. vname) THEN
          k = mnc_f_info(indf,mnc_fv_ids(indf,j+2))
          IF (mnc_g_names(k) .NE. gname) THEN
            WRITE(msgBuf,'(5A)') 'MNC ERROR: variable ''',
     &           vname(1:lenv), ''' is already defined in file ''',
     &           fname(1:lenf), ''' but using a different grid shape'
            CALL print_error(msgBuf, myThid)
            STOP 'ABNORMAL END: S/R MNC_VAR_INIT_ANY'
          ELSE
C           Its OK, the variable and grid names are the same
            irv = 0
            RETURN
          ENDIF
        ENDIF
      ENDDO

      irv = 1

C     Add the variable definition
      CALL MNC_FILE_REDEF(fname, myThid)
      err = NF_DEF_VAR(fid, vname, vtype, nd, ids, vid)
      IF ( err .NE. NF_NOERR ) THEN
        WRITE(msgBuf,'(2A)') 'ERROR:  MNC will not ',
     &       'overwrite variables in existing NetCDF'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(2A)') '        files.  Please',
     &       ' make sure that you are not trying to'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(2A)') '        overwrite output',
     &       'files from a previous model run!'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(5A)') 'defining variable ''', vname(1:lenv),
     &     ''' in file ''', fname(1:lenf), ''''
        CALL MNC_HANDLE_ERR(err, msgBuf, myThid)
      ENDIF

C     Success, so save the variable info
      CALL MNC_GET_NEXT_EMPTY_IND(MNC_MAX_ID,mnc_v_names,'mnc_v_names',
     &     indv, myThid)
      mnc_v_names(indv)(1:lenv) = vname(1:lenv)
      nv = mnc_fv_ids(indf,1)
      i = 2 + nv*3
      mnc_fv_ids(indf,i)   = indv
      mnc_fv_ids(indf,i+1) = vid
      mnc_fv_ids(indf,i+2) = ind_g_finfo
      mnc_fv_ids(indf,1) = nv + 1

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 1
C     !ROUTINE: MNC_VAR_ADD_ATTR_STR

C     !INTERFACE:
      SUBROUTINE MNC_VAR_ADD_ATTR_STR(
     I     fname,
     I     vname,
     I     atname,
     I     sval,
     I     myThid )

C     !DESCRIPTION:
C     Subroutine for adding a character string attribute to a NetCDF file.

C     !USES:
      IMPLICIT NONE

C     !INPUT PARAMETERS:
      CHARACTER*(*) fname,vname,atname,sval
      INTEGER myThid
CEOP
      real*8 dZero(1)
      real*4 sZero(1)
      INTEGER iZero(1)
      dZero(1) = 0.0D0
      sZero(1) = 0.0
      iZero(1) = 0

      CALL MNC_VAR_ADD_ATTR_ANY( fname,vname,atname,
     &     1, sval, 0, dZero, sZero, iZero, myThid )

      RETURN
      END
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 1
C     !ROUTINE: MNC_VAR_ADD_ATTR_DBL

C     !INTERFACE:
      SUBROUTINE MNC_VAR_ADD_ATTR_DBL(
     I     fname,
     I     vname,
     I     atname,
     I     nv,
     I     dval,
     I     myThid )

C     !DESCRIPTION:
C     Subroutine for adding a double-precision real attribute to a NetCDF file.

C     !USES:
      IMPLICIT NONE

C     !INPUT PARAMETERS:
      CHARACTER*(*) fname,vname,atname
      INTEGER nv
      Real*8 dval(*)
      INTEGER myThid
CEOP
      real*4 sZero(1)
      INTEGER iZero(1)
      sZero(1) = 0.0
      iZero(1) = 0

      CALL MNC_VAR_ADD_ATTR_ANY( fname,vname,atname,
     &     2, ' ', nv, dval, sZero, iZero, myThid )

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 1
C     !ROUTINE: MNC_VAR_ADD_ATTR_REAL

C     !INTERFACE:
      SUBROUTINE MNC_VAR_ADD_ATTR_REAL(
     I     fname,
     I     vname,
     I     atname,
     I     nv,
     I     rval,
     I     myThid )

C     !DESCRIPTION:
C     Subroutine for adding a single-precision real attribute to a NetCDF file.

C     !USES:
      IMPLICIT NONE

C     !INPUT PARAMETERS:
      CHARACTER*(*) fname,vname,atname
      INTEGER nv
      Real*4 rval(*)
      INTEGER myThid
CEOP
      real*8 dZero(1)
      INTEGER iZero(1)
      dZero(1) = 0.0D0
      iZero(1) = 0

      CALL MNC_VAR_ADD_ATTR_ANY( fname,vname,atname,
     &     3, ' ', nv, dZero, rval, iZero, myThid )
      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 1
C     !ROUTINE: MNC_VAR_ADD_ATTR_INT

C     !INTERFACE:
      SUBROUTINE MNC_VAR_ADD_ATTR_INT(
     I     fname,
     I     vname,
     I     atname,
     I     nv,
     I     ival,
     I     myThid )

C     !DESCRIPTION:
C     Subroutine for adding an integer attribute to a NetCDF file.

C     !USES:
      IMPLICIT NONE

C     !INPUT PARAMETERS:
      CHARACTER*(*) fname,vname,atname
      INTEGER nv
      INTEGER ival(*)
      INTEGER myThid
CEOP
      real*8 dZero(1)
      real*4 sZero(1)
      dZero(1) = 0.0D0
      sZero(1) = 0.0

      CALL MNC_VAR_ADD_ATTR_ANY( fname,vname,atname,
     &     4, ' ', nv, dZero, sZero, ival, myThid )

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 1
C     !ROUTINE: MNC_VAR_ADD_ATTR_ANY

C     !INTERFACE:
      SUBROUTINE MNC_VAR_ADD_ATTR_ANY(
     I     fname,
     I     vname,
     I     atname,
     I     atype, cs,len,dv,rv,iv,
     I     myThid )

C     !DESCRIPTION:
C     General SUBROUTINE for adding attributes to a NetCDF file.

C     !USES:
      IMPLICIT NONE
#include "MNC_COMMON.h"
#include "EEPARAMS.h"
#include "netcdf.inc"

C     !INPUT PARAMETERS:
      CHARACTER*(*) fname,vname,atname
      INTEGER atype
      CHARACTER*(*) cs
      INTEGER len
      Real*8 dv(*)
      Real*4 rv(*)
      INTEGER iv(*)
      INTEGER myThid
CEOP

C     Functions
      INTEGER  ILNBLNK
      EXTERNAL ILNBLNK

C     !LOCAL VARIABLES:
      INTEGER n, indf,ind_fv_ids, fid,vid, err
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      INTEGER lenf,lenv,lenat,lens

C     Strip trailing spaces
      lenf = ILNBLNK(fname)
      lenv = ILNBLNK(vname)
      lenat = ILNBLNK(atname)
      lens = ILNBLNK(cs)

      CALL MNC_GET_FVINDS(fname, vname, indf, ind_fv_ids, myThid)
      IF ((indf .LT. 1).OR.(ind_fv_ids .LT. 1)) THEN
        WRITE(msgBuf,'(5A)') 'MNC ERROR: file ''', fname(1:lenf),
     &       ''' is not open or does not contain variable ''',
     &       vname(1:lenv), ''''
        CALL print_error(msgBuf, myThid)
        STOP 'ABNORMAL END: S/R MNC_VAR_ADD_ATTR_STR'
      ENDIF
      fid = mnc_f_info(indf,2)
      vid = mnc_fv_ids(indf,(ind_fv_ids+1))

C     Set the attribute
      CALL MNC_FILE_REDEF(fname, myThid)
      IF (atype .EQ. 1) THEN
        err = NF_PUT_ATT_TEXT(fid, vid, atname, lens, cs)
      ELSEIF (atype .EQ. 2) THEN
        err = NF_PUT_ATT_DOUBLE(fid, vid, atname, NF_DOUBLE, len, dv)
      ELSEIF (atype .EQ. 3) THEN
        err = NF_PUT_ATT_REAL(fid, vid, atname, NF_FLOAT, len, rv)
      ELSEIF (atype .EQ. 4) THEN
        err = NF_PUT_ATT_INT(fid, vid, atname, NF_INT, len, iv)
      ELSE
        WRITE(msgBuf,'(A,I10,A)') 'MNC ERROR: atype = ''', atype,
     &       ''' is invalid--must be: [1-4]'
        n = ILNBLNK(msgBuf)
        CALL print_error(msgBuf(1:n), myThid)
        STOP 'ABNORMAL END: S/R MNC_VAR_ADD_ATTR_ANY'
      ENDIF
      WRITE(msgBuf,'(5A)') 'adding attribute ''', atname(1:lenat),
     &     ''' to file ''', fname(1:lenf), ''''
      CALL MNC_HANDLE_ERR(err, msgBuf, myThid)

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      SUBROUTINE MNC_VAR_WRITE_DBL(
     I     fname,
     I     vname,
     I     var,
     I     myThid )

      IMPLICIT NONE
C     Arguments
      CHARACTER*(*) fname, vname
      Real*8 var(*)
      INTEGER myThid

C     Local Variables
      Real*4  dummyR4(1)
      INTEGER dummyI (1)

      DATA dummyR4 / 0. /
      DATA dummyI  / 0 /

      CALL MNC_VAR_WRITE_ANY( fname, vname, 1, 0,
     &                        var, dummyR4, dummyI, myThid )

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      SUBROUTINE MNC_VAR_WRITE_REAL(
     I     fname,
     I     vname,
     I     var,
     I     myThid )

      IMPLICIT NONE
C     Arguments
      CHARACTER*(*) fname, vname
      Real*4 var(*)
      INTEGER myThid

C     Local Variables
      Real*8  dummyR8(1)
      INTEGER dummyI (1)

      DATA dummyR8 / 0. _d 0 /
      DATA dummyI  / 0 /

      CALL MNC_VAR_WRITE_ANY( fname, vname, 2, 0,
     &                        dummyR8, var, dummyI, myThid )

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      SUBROUTINE MNC_VAR_WRITE_INT(
     I     fname,
     I     vname,
     I     var,
     I     myThid )

      IMPLICIT NONE
C     Arguments
      CHARACTER*(*) fname, vname
      INTEGER var(*)
      INTEGER myThid

C     Local Variables
      Real*8  dummyR8(1)
      Real*4  dummyR4(1)

      DATA dummyR8 / 0. _d 0 /
      DATA dummyR4 / 0. /

      CALL MNC_VAR_WRITE_ANY( fname, vname, 3, 0,
     &                        dummyR8, dummyR4, var, myThid )

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      SUBROUTINE MNC_VAR_APPEND_DBL(
     I     fname,
     I     vname,
     I     var,
     I     append,
     I     myThid )

      IMPLICIT NONE
C     Arguments
      CHARACTER*(*) fname, vname
      Real*8 var(*)
      INTEGER append, myThid

C     Local Variables
      Real*4  dummyR4(1)
      INTEGER dummyI (1)

      DATA dummyR4 / 0. /
      DATA dummyI  / 0 /

      CALL MNC_VAR_WRITE_ANY( fname, vname, 1, append,
     &                        var, dummyR4, dummyI, myThid )

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      SUBROUTINE MNC_VAR_APPEND_REAL(
     I     fname,
     I     vname,
     I     var,
     I     append,
     I     myThid )

      IMPLICIT NONE
C     Arguments
      CHARACTER*(*) fname, vname
      Real*4 var(*)
      INTEGER append, myThid

C     Local Variables
      Real*8  dummyR8(1)
      INTEGER dummyI (1)

      DATA dummyR8 / 0. _d 0 /
      DATA dummyI  / 0 /

      CALL MNC_VAR_WRITE_ANY( fname, vname, 2, append,
     &                        dummyR8, var, dummyI, myThid )

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      SUBROUTINE MNC_VAR_APPEND_INT(
     I     fname,
     I     vname,
     I     var,
     I     append,
     I     myThid )

      IMPLICIT NONE
C     Arguments
      CHARACTER*(*) fname, vname
      INTEGER var(*)
      INTEGER append, myThid

C     Local Variables
      Real*8  dummyR8(1)
      Real*4  dummyR4(1)

      DATA dummyR8 / 0. _d 0 /
      DATA dummyR4 / 0. /

      CALL MNC_VAR_WRITE_ANY( fname, vname, 3, append,
     &                        dummyR8, dummyR4, var, myThid )

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      SUBROUTINE MNC_VAR_WRITE_ANY(
     I     fname,
     I     vname,
     I     vtype,
     I     append,
     I     dv,
     I     rv,
     I     iv,
     I     myThid )

      IMPLICIT NONE
#include "MNC_COMMON.h"
#include "EEPARAMS.h"
#include "netcdf.inc"

C     Arguments
      CHARACTER*(*) fname, vname
      INTEGER vtype
      INTEGER append
      Real*8 dv(*)
      Real*4 rv(*)
      INTEGER iv(*)
      INTEGER myThid

C     Functions
      INTEGER ILNBLNK

C     Local Variables
      INTEGER i,j,k, n, indf,ind_fv_ids, fid,vid,did, ig, err, ds,de
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      INTEGER lenf,lenv, lend
      INTEGER vstart(100), vcount(100)

C     Strip trailing spaces
      lenf = ILNBLNK(fname)
      lenv = ILNBLNK(vname)

      CALL MNC_GET_FVINDS(fname, vname, indf, ind_fv_ids, myThid)
      IF ((indf .LT. 1).OR.(ind_fv_ids .LT. 1)) THEN
        WRITE(msgBuf,'(5A)') 'MNC ERROR: file ''', fname(1:lenf),
     &       ''' is not open or does not contain variable ''',
     &       vname(1:lenv), ''''
        CALL print_error(msgBuf, myThid)
        STOP 'ABNORMAL END: S/R MNC_VAR_ADD_ATTR_STR'
      ENDIF
      fid = mnc_f_info(indf,2)
      vid = mnc_fv_ids(indf,(ind_fv_ids+1))

C     Get the lengths from the dim IDs
      ig = mnc_fv_ids(indf,(ind_fv_ids+2))
      ds = mnc_f_info(indf,ig+1)
      de = mnc_f_info(indf,ig+2)
      k = 0
      DO i = ds,de
        k = k + 1
        vstart(k) = 1
        vcount(k) = mnc_d_size( mnc_fd_ind(indf,i) )
      ENDDO

C     Check for the unlimited dimension
      j = mnc_d_size( mnc_fd_ind(indf,de) )
      IF (j .LT. 1) THEN
        did = mnc_d_ids( mnc_fd_ind(indf,de) )
        err = NF_INQ_DIMLEN(fid, did, lend)
        WRITE(msgBuf,'(A)') 'reading current length of unlimited dim'
        CALL MNC_HANDLE_ERR(err, msgBuf, myThid)
        IF (append .GT. 0) THEN
          lend = lend + append
        ENDIF
        IF (lend .LT. 1) lend = 1
        vstart(k) = lend
        vcount(k) = 1
      ENDIF

      CALL MNC_FILE_ENDDEF(fname, myThid)
      IF (vtype .EQ. 1) THEN
        err = NF_PUT_VARA_DOUBLE(fid, vid, vstart, vcount, dv)
      ELSEIF (vtype .EQ. 2) THEN
        err = NF_PUT_VARA_REAL(fid, vid, vstart, vcount, rv)
      ELSEIF (vtype .EQ. 3) THEN
        err = NF_PUT_VARA_INT(fid, vid, vstart, vcount, iv)
      ELSE
        WRITE(msgBuf,'(A,I10,A)') 'MNC ERROR: vtype = ''', vtype,
     &       ''' is invalid--must be: [1|2|3]'
        n = ILNBLNK(msgBuf)
        CALL print_error(msgBuf(1:n), myThid)
        STOP 'ABNORMAL END: S/R MNC_VAR_WRITE_ALL'
      ENDIF
      WRITE(msgBuf,'(5A)') 'writing variable ''', vname(1:lenv),
     &     ''' to file ''', fname(1:lenf), ''''
      CALL MNC_HANDLE_ERR(err, msgBuf, myThid)

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#include "CPP_OPTIONS.h"

CBOP
C     !ROUTINE: INTEGRATE_FOR_W
C     !INTERFACE:
      SUBROUTINE INTEGRATE_FOR_W(
     I                     bi, bj, k, uFld, vFld, mFld, rStarDhDt,
     O                     wFld,
     I                     myIter, myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE INTEGRATE_FOR_W
C     | o Integrate for vertical velocity.
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     == GLobal variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "SURFACE.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     uFld, vFld :: Zonal and meridional flow
C     mFld       :: added mass
C     rStarDhDt  :: relative time derivative of column thickness = d.eta/dt / H
C     wFld       :: Vertical flow
C     myIter     :: Current iteration number in simulation
C     myThid     :: my Thread Id. number
      INTEGER bi,bj,k
      _RL  uFld (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      _RL  vFld (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
#ifdef ALLOW_ADDFLUID
      _RL  mFld (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
#else
      _RL  mFld (1)
#endif
#if (defined NONLIN_FRSURF) && !(defined DISABLE_RSTAR_CODE)
      _RL rStarDhDt(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
#else
      _RL rStarDhDt(1)
#endif
      _RL  wFld (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      INTEGER myIter
      INTEGER myThid

C     !LOCAL VARIABLES:
C     == Local variables ==
C     uTrans, vTrans :: Temps. for volume transports
C     conv2d         :: horizontal transport convergence [m^3/s]
      INTEGER i,j
      _RL uTrans(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL vTrans(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL conv2d(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
CEOP

C--   Calculate velocity field "volume transports" through
C     tracer cell faces (anelastic: scaled as a mass transport).
      DO j=1,sNy+1
        DO i=1,sNx+1
          uTrans(i,j) = uFld(i,j,k,bi,bj)
     &                *_dyG(i,j,bi,bj)*deepFacC(k)*rhoFacC(k)
     &                *drF(k)*_hFacW(i,j,k,bi,bj)
          vTrans(i,j) = vFld(i,j,k,bi,bj)
     &                *_dxG(i,j,bi,bj)*deepFacC(k)*rhoFacC(k)
     &                *drF(k)*_hFacS(i,j,k,bi,bj)
        ENDDO
      ENDDO
      DO j=1,sNy
        DO i=1,sNx
          conv2d(i,j) = -( uTrans(i+1,j)-uTrans(i,j)
     &                    +vTrans(i,j+1)-vTrans(i,j) )
        ENDDO
      ENDDO
#ifdef ALLOW_ADDFLUID
      IF ( selectAddFluid.GE.1 .AND. myIter.NE.0 ) THEN
       DO j=1,sNy
        DO i=1,sNx
          conv2d(i,j) = conv2d(i,j)
     &                + mFld(i,j,k,bi,bj)*mass2rUnit
        ENDDO
       ENDDO
      ENDIF
#endif /* ALLOW_ADDFLUID */

C--   Calculate vertical "volume transport" through face k
C     between tracer cell k-1 & k
      IF (rigidLid) THEN
C-  o Rigid-Lid case: zero at lower and upper boundaries
        IF (k.EQ.1) THEN
          DO j=1,sNy
           DO i=1,sNx
             wFld(i,j,k,bi,bj) = 0.
           ENDDO
          ENDDO
        ELSEIF (k.EQ.Nr) THEN
          DO j=1,sNy
           DO i=1,sNx
             wFld(i,j,k,bi,bj) =
     &          conv2d(i,j)*recip_rA(i,j,bi,bj)
     &         *maskC(i,j,k,bi,bj)*maskC(i,j,k-1,bi,bj)
     &         *recip_deepFac2F(k)*recip_rhoFacF(k)
           ENDDO
          ENDDO
        ELSE
          DO j=1,sNy
           DO i=1,sNx
             wFld(i,j,k,bi,bj) =
     &        ( wFld(i,j,k+1,bi,bj)*deepFac2F(k+1)*rhoFacF(k+1)
     &         +conv2d(i,j)*recip_rA(i,j,bi,bj)
     &        )*maskC(i,j,k,bi,bj)*maskC(i,j,k-1,bi,bj)
     &         *recip_deepFac2F(k)*recip_rhoFacF(k)
           ENDDO
          ENDDO
        ENDIF
#ifdef NONLIN_FRSURF
# ifndef DISABLE_RSTAR_CODE
      ELSEIF ( select_rStar.NE.0 ) THEN
C-  o rStar case: zero under-ground and at r_lower boundary
C     can be non-zero at surface (useRealFreshWaterFlux).
        IF (k.EQ.Nr) THEN
          DO j=1,sNy
           DO i=1,sNx
             wFld(i,j,k,bi,bj) =
     &        ( conv2d(i,j)*recip_rA(i,j,bi,bj)
     &         -rStarDhDt(i,j)*drF(k)*h0FacC(i,j,k,bi,bj)
     &        )*maskC(i,j,k,bi,bj)
     &         *recip_deepFac2F(k)*recip_rhoFacF(k)
           ENDDO
          ENDDO
        ELSE
          DO j=1,sNy
           DO i=1,sNx
             wFld(i,j,k,bi,bj) =
     &        ( wFld(i,j,k+1,bi,bj)*deepFac2F(k+1)*rhoFacF(k+1)
     &         +conv2d(i,j)*recip_rA(i,j,bi,bj)
     &         -rStarDhDt(i,j)*drF(k)*h0FacC(i,j,k,bi,bj)
     &        )*maskC(i,j,k,bi,bj)
     &         *recip_deepFac2F(k)*recip_rhoFacF(k)
           ENDDO
          ENDDO
        ENDIF
# endif /* DISABLE_RSTAR_CODE */
# ifndef DISABLE_SIGMA_CODE
      ELSEIF ( selectSigmaCoord.NE.0 ) THEN
C-  o Hybrid Sigma coordinate:
        IF (k.EQ.Nr) THEN
          DO j=1,sNy
           DO i=1,sNx
             wFld(i,j,k,bi,bj) =
     &        ( conv2d(i,j)*recip_rA(i,j,bi,bj)
     &         -dEtaHdt(i,j,bi,bj)*dBHybSigF(k)
     &        )*maskC(i,j,k,bi,bj)
           ENDDO
          ENDDO
        ELSE
          DO j=1,sNy
           DO i=1,sNx
             wFld(i,j,k,bi,bj) =
     &        ( wFld(i,j,k+1,bi,bj)
     &         +conv2d(i,j)*recip_rA(i,j,bi,bj)
     &         -dEtaHdt(i,j,bi,bj)*dBHybSigF(k)
     &        )*maskC(i,j,k,bi,bj)
           ENDDO
          ENDDO
        ENDIF
# endif /* DISABLE_SIGMA_CODE */
#endif /* NONLIN_FRSURF */
      ELSE
C-  o Free Surface case (r-Coordinate):
C      non zero at surface ; zero under-ground and at r_lower boundary
        IF (k.EQ.Nr) THEN
          DO j=1,sNy
           DO i=1,sNx
             wFld(i,j,k,bi,bj) =
     &          conv2d(i,j)*recip_rA(i,j,bi,bj)
     &         *maskC(i,j,k,bi,bj)
     &         *recip_deepFac2F(k)*recip_rhoFacF(k)
           ENDDO
          ENDDO
        ELSE
          DO j=1,sNy
           DO i=1,sNx
             wFld(i,j,k,bi,bj) =
     &        ( wFld(i,j,k+1,bi,bj)*deepFac2F(k+1)*rhoFacF(k+1)
     &         +conv2d(i,j)*recip_rA(i,j,bi,bj)
     &        )*maskC(i,j,k,bi,bj)
     &         *recip_deepFac2F(k)*recip_rhoFacF(k)
           ENDDO
          ENDDO
        ENDIF
C-  endif - rigid-lid / Free-Surf.
      ENDIF

      RETURN
      END

#include "GGL90_OPTIONS.h"
#ifdef ALLOW_AUTODIFF
# include "AUTODIFF_OPTIONS.h"
#endif

CBOP
C !ROUTINE: GGL90_MIXINGLENGTH

C !INTERFACE: ======================================================
      SUBROUTINE GGL90_MIXINGLENGTH(
     U     GGL90mixingLength,
#ifdef ALLOW_GGL90_LANGMUIR
     O     LCmixingLength,
#endif
     O     rMixingLength,
     I     iMin ,iMax ,jMin ,jMax,
     I     bi, bj, myTime, myIter, myThid )

C !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE GGL90_MIXINGLENGTH                            |
C     | o Compute GGL90mixingLength (and LCmixingLength)         |
C     *==========================================================*
C     | Equation numbers refer to                                |
C     |  Gaspar et al. (1990), JGR 95 (C9), pp 16,179            |
C     | Some parts of the implementation follow Blanke and       |
C     |  Delecuse (1993), JPO, and OPA code, in particular the   |
C     |  computation of the                                      |
C     |  mixing length = max(min(lk,depth),lkmin)                |
C     | Note: Only call this S/R if Nr > 1 (no use if Nr=1)      |
C     *==========================================================*

C \ev

C !USES: ============================================================
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "GGL90.h"
#ifdef ALLOW_SHELFICE
# include "SHELFICE.h"
#endif
#ifdef ALLOW_AUTODIFF
# include "AUTODIFF_PARAMS.h"
#endif
#ifdef ALLOW_AUTODIFF_TAMC
# include "tamc.h"
#endif

C !INPUT PARAMETERS: ===================================================
C Routine arguments
C     GGL90mixingLength :: mixing length (m) following Banke+Delecuse
C     rMixingLength     :: inverse of mixing length
C     iMin,iMax,jMin,jMax :: index boundaries of computation domain
C     bi, bj :: Current tile indices
C     myTime :: Current time in simulation
C     myIter :: Current time-step number
C     myThid :: My Thread Id number
      _RL     GGL90mixingLength(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
#ifdef ALLOW_GGL90_LANGMUIR
      _RL     LCmixingLength   (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
#endif
      _RL     rMixingLength    (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      INTEGER iMin ,iMax ,jMin ,jMax
      INTEGER bi, bj
      _RL     myTime
      INTEGER myIter
      INTEGER myThid

#ifdef ALLOW_GGL90
C !LOCAL VARIABLES: ====================================================
C     i, j, k          :: array computation indices
C     kSrf             :: vertical index of surface level
C     kTop             :: index of top interface (just below surf. level)
C
C     In general, all 3D variables are defined at W-points (i.e.,
C     between k and k-1), all 2D variables are also defined at W-points
C     or at the very surface level (like uStarSquare)
      INTEGER i, j, k
      INTEGER kSrf, kTop
      _RL MaxLength
      _RL mxLength_Dn(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL MLtmp
C     This mixed layer model is not invariant under coordinate
C     transformation to pressure coordinates, so we need these
C     factors to scale the vertical (pressure) coordinates
      _RL coordFac, recip_coordFac
      INTEGER locMxlMaxFlag
      CHARACTER*(MAX_LEN_MBUF) msgBuf
#ifdef ALLOW_AUTODIFF_TAMC
C     tkey :: tape key (depends on tiles)
C     kkey :: tape key (depends on levels and tiles)
      INTEGER tkey, kkey
#endif
CEOP

      IF ( usingPCoords ) THEN
       kSrf = Nr
       kTop = Nr
      ELSE
       kSrf =  1
       kTop =  2
      ENDIF

      coordFac = 1. _d 0
      IF ( usingPCoords) coordFac = gravity * rhoConst
      recip_coordFac = 1./coordFac

      locMxlMaxFlag = mxlMaxFlag
#ifdef ALLOW_AUTODIFF
      IF ( inAdMode ) locMxlMaxFlag = adMxlMaxFlag
#endif
#ifdef ALLOW_AUTODIFF_TAMC
      tkey = bi + (bj-1)*nSx + (ikey_dynamics-1)*nSx*nSy
#endif /* ALLOW_AUTODIFF_TAMC */

C--   Initialize local fields
      DO k=1,Nr
       DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
         rMixingLength(i,j,k) = 0. _d 0
         mxLength_Dn  (i,j,k) = 0. _d 0
        ENDDO
       ENDDO
      ENDDO
      DO j=1-OLy,sNy+OLy
       DO i=1-OLx,sNx+OLx
c       rMixingLength(i,j,1)  = 0. _d 0
        mxLength_Dn(i,j,1) = GGL90mixingLengthMin
       ENDDO
      ENDDO

#ifdef ALLOW_GGL90_LANGMUIR
      IF (useLANGMUIR) THEN
       DO k=1,Nr
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          LCmixingLength(i,j,k) = GGL90mixingLengthMin
         ENDDO
        ENDDO
       ENDDO
      ENDIF
#endif

C-    Ensure mixing between first and second level
      IF (mxlSurfFlag) THEN
       DO j=jMin,jMax
        DO i=iMin,iMax
#ifdef ALLOW_SHELFICE
         IF ( useShelfIce ) THEN
          kSrf = MAX(1,kTopC(i,j,bi,bj))
          kTop = MIN(kSrf+1,Nr)
         ENDIF
#endif
         GGL90mixingLength(i,j,kTop)=drF(kSrf)*recip_coordFac
        ENDDO
       ENDDO
      ENDIF

C--   Impose upper and lower bound for mixing length
#ifdef ALLOW_AUTODIFF
CADJ STORE GGL90mixingLength = comlev1_bibj, key=tkey, kind=isbyte
#endif
      IF ( locMxlMaxFlag .EQ. 0 ) THEN

       DO k=2,Nr
        DO j=jMin,jMax
         DO i=iMin,iMax
C     Use thickness of water column (inverse of recip_Rcol) as the
C     maximum length.
          MaxLength =
     &         ( Ro_surf(i,j,bi,bj) - R_low(i,j,bi,bj) )*recip_coordFac
          GGL90mixingLength(i,j,k) = MIN(GGL90mixingLength(i,j,k),
     &                                   MaxLength)
         ENDDO
        ENDDO
       ENDDO

      ELSEIF ( locMxlMaxFlag .EQ. 1 ) THEN

       DO k=2,Nr
        DO j=jMin,jMax
         DO i=iMin,iMax
          MaxLength=MIN(Ro_surf(i,j,bi,bj)-rF(k),rF(k)-R_low(i,j,bi,bj))
     &         * recip_coordFac
c         MaxLength=MAX(MaxLength,20. _d 0)
          GGL90mixingLength(i,j,k) = MIN(GGL90mixingLength(i,j,k),
     &                                   MaxLength)
         ENDDO
        ENDDO
       ENDDO

      ELSEIF ( locMxlMaxFlag .EQ. 2 .OR. locMxlMaxFlag .EQ. 3 ) THEN

       IF ( usingPcoords ) THEN
#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE GGL90mixingLength = comlev1_bibj, key = tkey, kind=isbyte
#endif /* ALLOW_AUTODIFF_TAMC */
C     Downward sweep, extra treatment of k=Nr for p-coordinates
C     because level Nr+1 is not available
        DO j=jMin,jMax
         DO i=iMin,iMax
          mxLength_Dn(i,j,Nr) = MIN(GGL90mixingLength(i,j,Nr),
     &         GGL90mixingLengthMin+drF(Nr)*recip_coordFac)
         ENDDO
        ENDDO
        DO k=Nr-1,2,-1
#ifdef ALLOW_AUTODIFF_TAMC
         kkey = k + (tkey-1)*Nr
CADJ STORE mxLength_Dn(:,:,k+1)
CADJ &     = comlev1_bibj_k, key = kkey, kind=isbyte
#endif /* ALLOW_AUTODIFF_TAMC */
         DO j=jMin,jMax
          DO i=iMin,iMax
           mxLength_Dn(i,j,k) = MIN(GGL90mixingLength(i,j,k),
     &          mxLength_Dn(i,j,k+1)+drF(k)*recip_coordFac)
          ENDDO
         ENDDO
        ENDDO
C     Upward sweep
        DO k=2,Nr
#ifdef ALLOW_AUTODIFF_TAMC
         kkey = k + (tkey-1)*Nr
C     It is important that the two k-levels of these fields are stored
C     in one statement because otherwise taf will only store one, which
C     is wrong (i.e. was wrong in previous versions).
CADJ STORE GGL90mixingLength(:,:,k-1), GGL90mixingLength(:,:,k)
CADJ &     = comlev1_bibj_k, key = kkey, kind=isbyte
#endif /* ALLOW_AUTODIFF_TAMC */
         DO j=jMin,jMax
          DO i=iMin,iMax
           GGL90mixingLength(i,j,k) = MIN(GGL90mixingLength(i,j,k),
     &          GGL90mixingLength(i,j,k-1)+drF(k-1)*recip_coordFac)
          ENDDO
         ENDDO
        ENDDO

       ELSE
C-    Z-coordinate case
#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE GGL90mixingLength = comlev1_bibj, key = tkey, kind=isbyte
#endif /* ALLOW_AUTODIFF_TAMC */
C     Downward sweep
        DO k=2,Nr
#ifdef ALLOW_AUTODIFF_TAMC
         kkey = k + (tkey-1)*Nr
CADJ STORE mxLength_Dn(:,:,k-1)
CADJ &     = comlev1_bibj_k, key = kkey, kind=isbyte
#endif /* ALLOW_AUTODIFF_TAMC */
         DO j=jMin,jMax
          DO i=iMin,iMax
           mxLength_Dn(i,j,k) = MIN(GGL90mixingLength(i,j,k),
     &          mxLength_Dn(i,j,k-1)+drF(k-1)*recip_coordFac)
          ENDDO
         ENDDO
        ENDDO

C     Upward sweep, extra treatment of k=Nr for z-coordinates
C     because level Nr+1 is not available
        DO j=jMin,jMax
         DO i=iMin,iMax
          GGL90mixingLength(i,j,Nr) = MIN(GGL90mixingLength(i,j,Nr),
     &         GGL90mixingLengthMin+drF(Nr)*recip_coordFac)
         ENDDO
        ENDDO
        DO k=Nr-1,2,-1
#ifdef ALLOW_AUTODIFF_TAMC
         kkey = k + (tkey-1)*Nr
C     It is important that the two k-levels of these fields are stored
C     in one statement because otherwise taf will only store one, which
C     is wrong (i.e. was wrong in previous versions).
CADJ STORE GGL90mixingLength(:,:,k+1), GGL90mixingLength(:,:,k)
CADJ &     = comlev1_bibj_k, key = kkey, kind=isbyte
#endif /* ALLOW_AUTODIFF_TAMC */
         DO j=jMin,jMax
          DO i=iMin,iMax
           GGL90mixingLength(i,j,k) = MIN(GGL90mixingLength(i,j,k),
     &          GGL90mixingLength(i,j,k+1)+drF(k)*recip_coordFac)
          ENDDO
         ENDDO
        ENDDO
C-    end if P/Z-coordinate
       ENDIF

#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE mxLength_Dn       = comlev1_bibj, key = tkey, kind=isbyte
CADJ STORE GGL90mixingLength = comlev1_bibj, key = tkey, kind=isbyte
#endif
C     Impose minimum from downward sweep
       DO k=2,Nr
        DO j=jMin,jMax
         DO i=iMin,iMax
          GGL90mixingLength(i,j,k) = MIN(GGL90mixingLength(i,j,k),
     &                                  mxLength_Dn(i,j,k))
         ENDDO
        ENDDO
       ENDDO

      ELSE
       WRITE(msgBuf,'(A,I5,A)')
     &   'GGL90_MIXINGLENGTH: mxlMaxFlag=',
     &   locMxlMaxFlag,' not implemented'
       CALL PRINT_ERROR( msgBuf, myThid )
       STOP 'ABNORMAL END: S/R GGL90_MIXINGLENGTH'
      ENDIF

#ifdef ALLOW_GGL90_LANGMUIR
C----------------------------------
C--   Langmuir circulation effect :
C----------------------------------
      IF (useLANGMUIR) THEN
# ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE GGL90mixingLength = comlev1_bibj, key = tkey, kind=isbyte
# endif
       IF ( locMxlMaxFlag .EQ. 1 ) THEN
        DO k=2,Nr
         DO j=jMin,jMax
          DO i=iMin,iMax
           IF ( usingPcoords ) THEN
            MaxLength=(rF(k)-R_low(i,j,bi,bj))*recip_coordFac
           ELSE
            MaxLength=(Ro_surf(i,j,bi,bj)-rF(k)) * recip_coordFac
           ENDIF
           IF (GGL90mixingLength(i,j,k) .EQ. MaxLength) THEN
            LCmixingLength(i,j,k) = LC_Gamma * GGL90mixingLength(i,j,k)
           ELSE
            LCmixingLength(i,j,k) = GGL90mixingLength(i,j,k)
           ENDIF
          ENDDO
         ENDDO
        ENDDO

       ELSEIF ( locMxlMaxFlag .EQ. 2 .OR. locMxlMaxFlag .EQ. 3 ) THEN

# ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE mxLength_Dn       = comlev1_bibj, key = tkey, kind=isbyte
# endif
        DO k=2,Nr
         DO j=jMin,jMax
          DO i=iMin,iMax
           IF (GGL90mixingLength(i,j,k) .EQ. mxLength_Dn(i,j,k)) THEN
            LCmixingLength(i,j,k) = LC_Gamma * GGL90mixingLength(i,j,k)
           ELSE
            LCmixingLength(i,j,k) = GGL90mixingLength(i,j,k)
           ENDIF
          ENDDO
         ENDDO
        ENDDO

       ELSE
        WRITE(msgBuf,'(2A,I5,A)')
     &       'GGL90_MIXINGLENGTH: ',
     &       'Langmuir Circ. Parameterization with mxlMaxFlag=',
     &   locMxlMaxFlag,' not implemented'
        CALL PRINT_ERROR( msgBuf, myThid )
        STOP 'ABNORMAL END: S/R GGL90_MIXINGLENGTH'
       ENDIF

C--   Impose minimum LC-mixing length to avoid division by zero
       IF ( locMxlMaxFlag .EQ. 1 .OR. locMxlMaxFlag .EQ. 2 ) THEN
# ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE LCmixingLength    = comlev1_bibj, key = tkey, kind=isbyte
# endif
        DO k=2,Nr
         DO j=jMin,jMax
          DO i=iMin,iMax
           MLtmp = MAX(LCmixingLength(i,j,k),GGL90mixingLengthMin)
           LCmixingLength(i,j,k) = MLtmp
          ENDDO
         ENDDO
        ENDDO
       ENDIF
      ENDIF
#endif /* ALLOW_GGL90_LANGMUIR */

#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE GGL90mixingLength = comlev1_bibj, key = tkey, kind=isbyte
#endif
C--   Impose minimum mixing length to avoid division by zero
C     and compute inverse
      IF ( locMxlMaxFlag.EQ.3 ) THEN
#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE mxLength_Dn       = comlev1_bibj, key = tkey, kind=isbyte
#endif
       DO k=2,Nr
        DO j=jMin,jMax
         DO i=iMin,iMax
#ifdef GGL90_REGULARIZE_MIXINGLENGTH
          MLtmp = SQRT( GGL90mixingLength(i,j,k)*mxLength_Dn(i,j,k)
     &         + GGL90mixingLengthMin**2 )
#else
          MLtmp = SQRT( GGL90mixingLength(i,j,k)*mxLength_Dn(i,j,k) )
          MLtmp = MAX( MLtmp, GGL90mixingLengthMin )
#endif
          rMixingLength(i,j,k) = 1. _d 0 / MLtmp
         ENDDO
        ENDDO
       ENDDO
      ELSE
       DO k=2,Nr
        DO j=jMin,jMax
         DO i=iMin,iMax
#ifdef GGL90_REGULARIZE_MIXINGLENGTH
          MLtmp = SQRT( GGL90mixingLength(i,j,k)**2
     &         + GGL90mixingLengthMin**2 )
#else
          MLtmp = MAX(GGL90mixingLength(i,j,k),GGL90mixingLengthMin)
#endif
          GGL90mixingLength(i,j,k) = MLtmp
          rMixingLength(i,j,k) = 1. _d 0 / MLtmp
         ENDDO
        ENDDO
       ENDDO
      ENDIF

#endif /* ALLOW_GGL90 */

      RETURN
      END

#include "SHELFICE_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: SHELFICE_FORCING_SURF
C     !INTERFACE:
      SUBROUTINE SHELFICE_FORCING_SURF(
     I           bi, bj, iMin, iMax, jMin, jMax,
     I           myTime, myIter, myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R SHELFICE_FORCING_SURF
C     | o Contains problem specific surface forcing
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     == Global data ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
c#include "DYNVARS.h"
#include "SURFACE.h"
#include "FFIELDS.h"
#include "SHELFICE.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     bi,bj     :: Current tile indices
C     iMin,iMax :: Working range of x-index for applying forcing.
C     jMin,jMax :: Working range of y-index for applying forcing.
C     myTime    :: Current time in simulation
C     myIter    :: Current iteration number in simulation
C     myThid    :: Thread Id number
      INTEGER bi, bj
      INTEGER iMin, iMax, jMin, jMax
      _RL myTime
      INTEGER myIter
      INTEGER myThid

#ifdef ALLOW_SHELFICE
C     !LOCAL VARIABLES:
C     == Local variables ==
C     i,j   :: Loop counters
      INTEGER i, j
      LOGICAL SHI_useRealFWflux
CEOP

      SHI_useRealFWflux = useRealFreshWaterFlux .AND.
     &  ( .NOT.SHELFICEboundaryLayer .OR. SHI_withBL_realFWflux )

c     DO bj=myByLo(myThid),myByHi(myThid)
c      DO bi=myBxLo(myThid),myBxHi(myThid)

C--   Zero out surface forcing terms below ice-shelf
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          IF ( kTopC(i,j,bi,bj).NE.0 ) THEN
            surfaceForcingT(i,j,bi,bj) = 0.
            surfaceForcingS(i,j,bi,bj) = 0.
            EmPmR(i,j,bi,bj) = 0.
            Qsw  (i,j,bi,bj) = 0.
C-    just for consistent diagnostics, also reset Qnet:
            Qnet (i,j,bi,bj) = 0.
          ENDIF
         ENDDO
        ENDDO
        DO j=1-OLy,sNy+OLy
         DO i=2-OLx,sNx+OLx
          IF ( MAX( kTopC(i-1,j,bi,bj), kTopC(i,j,bi,bj) ).NE.0 ) THEN
            surfaceForcingU(i,j,bi,bj) = 0.
          ENDIF
         ENDDO
        ENDDO
        DO j=2-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          IF ( MAX( kTopC(i,j-1,bi,bj), kTopC(i,j,bi,bj) ).NE.0 ) THEN
            surfaceForcingV(i,j,bi,bj) = 0.
          ENDIF
         ENDDO
        ENDDO

        IF ( .NOT. useSTIC ) THEN
C--   Forcing term

         IF ( .NOT.SHELFICEboundaryLayer ) THEN
C-    for now, forcing using SHELFICEboundaryLayer is done separately
C     (calling SHELFICE_FORCING_T & _S from APPLY_FORCING_T & _S)
          DO j=1,sNy
           DO i=1,sNx
            IF ( kTopC(i,j,bi,bj).NE.0 ) THEN
             surfaceForcingT(i,j,bi,bj) = shelficeForcingT(i,j,bi,bj)
             surfaceForcingS(i,j,bi,bj) = shelficeForcingS(i,j,bi,bj)
            ENDIF
           ENDDO
          ENDDO
         ENDIF

         IF ( SHI_useRealFWflux ) THEN
C-    Allows PmE to be used even if boundary layer is being used,
C     as long as SHI_withBL_realFWflux is set to account for advective flux
          DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
c           IF ( kTopC(i,j,bi,bj).NE.0 ) THEN
             EmPmR(i,j,bi,bj) = EmPmR(i,j,bi,bj)
     &         + shelfIceFreshWaterFlux(i,j,bi,bj)
c           ENDIF
           ENDDO
          ENDDO
         ENDIF

C-      end-if not useSTIC
        ENDIF

        IF ( staggerTimeStep ) THEN
          DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
             PmEpR(i,j,bi,bj) = -EmPmR(i,j,bi,bj)
           ENDDO
          ENDDO
        ENDIF

        IF ( usingZCoords ) THEN
          DO j = jMin, jMax
           DO i = iMin, iMax
             phi0surf(i,j,bi,bj) = phi0surf(i,j,bi,bj)
     &         + shelficeLoadAnomaly(i,j,bi,bj)*recip_rhoConst
           ENDDO
          ENDDO
        ENDIF

#ifdef ALLOW_DIAGNOSTICS
        IF ( useDiagnostics ) THEN
          DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
             shelficeDragU(i,j,bi,bj) = 0.
             shelficeDragV(i,j,bi,bj) = 0.
           ENDDO
          ENDDO
        ENDIF
#endif /* ALLOW_DIAGNOSTICS */

c      ENDDO
c     ENDDO

#endif /* ALLOW_SHELFICE */
      RETURN
      END

#include "MOM_VECINV_OPTIONS.h"

      SUBROUTINE MOM_VI_DEL2UV(
     I        bi,bj,k,
     I        hDiv,vort3,hFacZ,
     O        del2u,del2v,
     I        myThid)
      IMPLICIT NONE
C
C     Calculate del^2 of (u,v) in terms of hDiv and vort3
C

C     == Global variables ==
#include "SIZE.h"
#include "GRID.h"
#include "EEPARAMS.h"

C     == Routine arguments ==
      INTEGER bi,bj,k
      _RL hDiv(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL vort3(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RS hFacZ(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL del2u(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL del2v(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER myThid

C     == Local variables ==
      INTEGER i,j
c     _RL Zip,Zij,Zpj,Dim,Dij,Dmj,uDij

C     - bi-harmonic viscosity :

c     DO j=2-OLy,sNy+OLy-1
c      DO i=2-OLx,sNx+OLx-1

c       Dim=dyF( i ,j-1,bi,bj)*hFacC( i ,j-1,k,bi,bj)*hDiv( i ,j-1)
c       Dij=dyF( i , j ,bi,bj)*hFacC( i , j ,k,bi,bj)*hDiv( i , j )
c       Dmj=dyF(i-1, j ,bi,bj)*hFacC(i-1, j ,k,bi,bj)*hDiv(i-1, j )
c       Dim=dyF( i ,j-1,bi,bj)*                       hDiv( i ,j-1)
c       Dij=dyF( i , j ,bi,bj)*                       hDiv( i , j )
c       Dmj=dyF(i-1, j ,bi,bj)*                       hDiv(i-1, j )
c       Dim=                                          hDiv( i ,j-1)
c       Dij=                                          hDiv( i , j )
c       Dmj=                                          hDiv(i-1, j )

c       Zip=dxV( i ,j+1,bi,bj)*hFacZ( i ,j+1)*vort3( i ,j+1)
c       Zij=dxV( i , j ,bi,bj)*hFacZ( i , j )*vort3( i , j )
c       Zpj=dxV(i+1, j ,bi,bj)*hFacZ(i+1, j )*vort3(i+1, j )
c       Zip=                   hFacZ( i ,j+1)*vort3( i ,j+1)
c       Zij=                   hFacZ( i , j )*vort3( i , j )
c       Zpj=                   hFacZ(i+1, j )*vort3(i+1, j )

c       del2u(i,j) = recip_rAw(i,j,bi,bj)*(
c    &   +recip_hFacW(i,j,k,bi,bj)*( Dij-Dmj )
c    &   -recip_hFacW(i,j,k,bi,bj)*( Zip-Zij ) )
c       del2u(i,j) = recip_rAw(i,j,bi,bj)*(
c    &   +                         ( Dij-Dmj )
c    &   -recip_hFacW(i,j,k,bi,bj)*( Zip-Zij ) )
c       del2u(i,j) =
c    &   +                         ( Dij-Dmj )*recip_DXC(i,j,bi,bj)
c    &   -recip_hFacW(i,j,k,bi,bj)*( Zip-Zij )*recip_DYG(i,j,bi,bj)

c       del2v(i,j) = recip_rAs(i,j,bi,bj)*(
c    &    recip_hFacS(i,j,k,bi,bj)*( Zpj-Zij )
c    &   +recip_hFacS(i,j,k,bi,bj)*( Dij-Dim ) )
c       del2v(i,j) = recip_rAs(i,j,bi,bj)*(
c    &    recip_hFacS(i,j,k,bi,bj)*( Zpj-Zij )
c    &   +                         ( Dij-Dim ) )
c       del2v(i,j) =
c    &    recip_hFacS(i,j,k,bi,bj)*( Zpj-Zij )*recip_DXG(i,j,bi,bj)
c    &   +                         ( Dij-Dim )*recip_DYC(i,j,bi,bj)

c      ENDDO
c     ENDDO

C     - bi-harmonic viscosity : del^2(U_component)

cph-exch2#ifndef ALLOW_AUTODIFF_TAMC
      IF (useCubedSphereExchange) THEN
C     to compute d/dx(hDiv), fill corners with appropriate values:
        CALL FILL_CS_CORNER_TR_RL( 1, .FALSE.,
     &                             hDiv, bi,bj, myThid )
      ENDIF
cph-exch2#endif
c     DO j=1,sNy
c      DO i=1,sNx+1
      DO j=2-OLy,sNy+OLy-1
       DO i=2-OLx,sNx+OLx-1
        del2u(i,j) =
     &      (  ( hDiv(i,j) - hDiv(i-1,j) )*recip_dxC(i,j,bi,bj)
     &        -_recip_hFacW(i,j,k,bi,bj)*
     &         ( hFacZ(i,j+1)*vort3(i,j+1) - hFacZ(i,j)*vort3(i,j) )
     &                                    *recip_dyG(i,j,bi,bj)
     &      )*maskW(i,j,k,bi,bj)*recip_deepFacC(k)
#ifdef ALLOW_OBCS
     &       *maskInW(i,j,bi,bj)
#endif
       ENDDO
      ENDDO

C     - bi-harmonic viscosity : del^2(V_component)

cph-exch2#ifndef ALLOW_AUTODIFF_TAMC
      IF (useCubedSphereExchange) THEN
C     to compute d/dy(hDiv), fill corners with appropriate values:
        CALL FILL_CS_CORNER_TR_RL( 2, .FALSE.,
     &                             hDiv, bi,bj, myThid )
      ENDIF
cph-exch2#endif
c     DO j=1,sNy+1
c      DO i=1,sNx
      DO j=2-OLy,sNy+OLy-1
       DO i=2-OLx,sNx+OLx-1
        del2v(i,j) =
     &      (  ( hDiv(i,j) - hDiv(i,j-1) )*recip_dyC(i,j,bi,bj)
     &        +_recip_hFacS(i,j,k,bi,bj)*
     &         ( hFacZ(i+1,j)*vort3(i+1,j) - hFacZ(i,j)*vort3(i,j) )
     &                                    *recip_dxG(i,j,bi,bj)
     &      )*maskS(i,j,k,bi,bj)*recip_deepFacC(k)
#ifdef ALLOW_OBCS
     &       *maskInS(i,j,bi,bj)
#endif
       ENDDO
      ENDDO

      RETURN
      END

#include "OBCS_OPTIONS.h"
#ifdef ALLOW_CTRL
# include "CTRL_OPTIONS.h"
#endif /* ALLOW_CTRL */

CBOP
C     !ROUTINE: OBCS_CALC

C     !INTERFACE:
      SUBROUTINE OBCS_CALC( futureTime, futureIter,
     &                      uVel, vVel, wVel, theta, salt,
     &                      myThid )

C     !DESCRIPTION:
C     *==========================================================*
C     | SUBROUTINE OBCS_CALC
C     | o Calculate future boundary data at open boundaries
C     |   at time = futureTime
C     *==========================================================*

C     !USES:
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "OBCS_PARAMS.h"
#include "OBCS_GRID.h"
#include "OBCS_FIELDS.h"
#ifdef ALLOW_PTRACERS
# include "PTRACERS_SIZE.h"
# include "PTRACERS_PARAMS.h"
# include "PTRACERS_FIELDS.h"
# include "OBCS_PTRACERS.h"
#endif /* ALLOW_PTRACERS */
#ifdef ALLOW_NEST_CHILD
# include "NEST_CHILD.h"
#endif /* ALLOW_NEST_CHILD */

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
      INTEGER futureIter
      _RL futureTime
      _RL uVel (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      _RL vVel (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      _RL wVel (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      _RL theta(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      _RL salt (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      INTEGER myThid

#ifdef ALLOW_OBCS

C     !LOCAL VARIABLES:
C     bi, bj       :: tile indices
C     i,j,k        :: loop indices
C     I_obc, J_obc :: local index of open boundary
C     msgBuf       :: Informational/error message buffer
      INTEGER bi, bj, k
#if (defined ALLOW_OBCS_EAST ) || (defined ALLOW_OBCS_WEST )
      INTEGER j
#endif
#if (defined ALLOW_OBCS_NORTH) || (defined ALLOW_OBCS_SOUTH)
      INTEGER i
#endif
#ifdef ALLOW_PTRACERS
      INTEGER I_obc, J_obc
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      INTEGER iTracer
#endif /* ALLOW_PTRACERS */

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_ENTER('OBCS_CALC',myThid)
#endif

      DO bj=myByLo(myThid),myByHi(myThid)
      DO bi=myBxLo(myThid),myBxHi(myThid)

#ifdef ALLOW_NEST_CHILD
      IF ( useNEST_CHILD ) THEN
        IF ( PASSI.LT.2 ) THEN
         CALL NEST_CHILD_RECV ( myThid )
        ENDIF
      ENDIF
#endif /* ALLOW_NEST_CHILD */

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#ifdef ALLOW_OBCS_EAST
C     Eastern OB
#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_MSG('OBCS_CALC: East',myThid)
#endif
      IF (useOrlanskiEast) THEN
#ifdef ALLOW_ORLANSKI
        CALL ORLANSKI_EAST(
     &          bi, bj, futureTime,
     &          uVel, vVel, wVel, theta, salt,
     &          myThid )
#endif
#ifdef ALLOW_NEST_CHILD
      ELSEIF ( useNEST_CHILD ) THEN
        DO k=1,Nr
          DO j=1-OLy,sNy+OLy
            IF ( OB_Ie(j,bi,bj).NE.OB_indexNone ) THEN
              OBEu(j,k,bi,bj)= U_F1(j,k,2)
              OBEv(j,k,bi,bj)= V_F1(j,k,2)
              OBEt(j,k,bi,bj)= T_F1(j,k,2)
              OBEs(j,k,bi,bj)= S_F1(j,k,2)
#ifdef NONLIN_FRSURF
              OBEeta(j,bi,bj)= ETA_F1(j,1,2)
#endif
            ENDIF
          ENDDO
        ENDDO
#endif /* ALLOW_NEST_CHILD */
      ELSE
        DO k=1,Nr
          DO j=1-OLy,sNy+OLy
            IF ( OB_Ie(j,bi,bj).NE.OB_indexNone ) THEN
              OBEu(j,k,bi,bj)=0.
              OBEv(j,k,bi,bj)=0.
              OBEt(j,k,bi,bj)=tRef(k)
              OBEs(j,k,bi,bj)=sRef(k)
#ifdef ALLOW_NONHYDROSTATIC
              OBEw(j,k,bi,bj)=0.
#endif
#ifdef NONLIN_FRSURF
              OBEeta(j,bi,bj)=0.
#endif
            ENDIF
          ENDDO
        ENDDO
      ENDIF
#endif /* ALLOW_OBCS_EAST */

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#ifdef ALLOW_OBCS_WEST
C     Western OB
#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_MSG('OBCS_CALC: West',myThid)
#endif
      IF (useOrlanskiWest) THEN
#ifdef ALLOW_ORLANSKI
        CALL ORLANSKI_WEST(
     &          bi, bj, futureTime,
     &          uVel, vVel, wVel, theta, salt,
     &          myThid )
#endif
#ifdef ALLOW_NEST_CHILD
      ELSEIF ( useNEST_CHILD ) THEN
        DO k=1,Nr
          DO j=1-OLy,sNy+OLy
            IF ( OB_Iw(j,bi,bj).NE.OB_indexNone ) THEN
              OBWu(j,k,bi,bj)= U_F1(j,k,1)
              OBWv(j,k,bi,bj)= V_F1(j,k,1)
              OBWt(j,k,bi,bj)= T_F1(j,k,1)
              OBWs(j,k,bi,bj)= S_F1(j,k,1)
#ifdef NONLIN_FRSURF
              OBWeta(j,bi,bj)= ETA_F1(j,1,1)
#endif
           ENDIF
          ENDDO
        ENDDO
#endif /* ALLOW_NEST_CHILD */
      ELSE
        DO k=1,Nr
          DO j=1-OLy,sNy+OLy
            IF ( OB_Iw(j,bi,bj).NE.OB_indexNone ) THEN
              OBWu(j,k,bi,bj)=0.
              OBWv(j,k,bi,bj)=0.
              OBWt(j,k,bi,bj)=tRef(k)
              OBWs(j,k,bi,bj)=sRef(k)
#ifdef ALLOW_NONHYDROSTATIC
              OBWw(j,k,bi,bj)=0.
#endif
#ifdef NONLIN_FRSURF
              OBWeta(j,bi,bj)=0.
#endif
           ENDIF
          ENDDO
        ENDDO
      ENDIF
#endif /* ALLOW_OBCS_WEST */

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#ifdef ALLOW_OBCS_NORTH
C         Northern OB
#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_MSG('OBCS_CALC: North',myThid)
#endif
      IF (useOrlanskiNorth) THEN
#ifdef ALLOW_ORLANSKI
        CALL ORLANSKI_NORTH(
     &          bi, bj, futureTime,
     &          uVel, vVel, wVel, theta, salt,
     &          myThid )
#endif
      ELSE
        DO k=1,Nr
          DO i=1-OLx,sNx+OLx
            IF ( OB_Jn(i,bi,bj).NE.OB_indexNone ) THEN
              OBNv(i,k,bi,bj)=0.
              OBNu(i,k,bi,bj)=0.
              OBNt(i,k,bi,bj)=tRef(k)
              OBNs(i,k,bi,bj)=sRef(k)
#ifdef ALLOW_NONHYDROSTATIC
              OBNw(i,k,bi,bj)=0.
#endif
#ifdef NONLIN_FRSURF
              OBNeta(i,bi,bj)=0.
#endif
            ENDIF
          ENDDO
        ENDDO
      ENDIF
#endif /* ALLOW_OBCS_NORTH */

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#ifdef ALLOW_OBCS_SOUTH
C         Southern OB
#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_MSG('OBCS_CALC: South',myThid)
#endif
      IF (useOrlanskiSouth) THEN
#ifdef ALLOW_ORLANSKI
        CALL ORLANSKI_SOUTH(
     &          bi, bj, futureTime,
     &          uVel, vVel, wVel, theta, salt,
     &          myThid )
#endif
      ELSE
        DO k=1,Nr
          DO i=1-OLx,sNx+OLx
            IF ( OB_Js(i,bi,bj).NE.OB_indexNone ) THEN
              OBSu(i,k,bi,bj)=0.
              OBSv(i,k,bi,bj)=0.
              OBSt(i,k,bi,bj)=tRef(k)
              OBSs(i,k,bi,bj)=sRef(k)
#ifdef ALLOW_NONHYDROSTATIC
              OBSw(i,k,bi,bj)=0.
#endif
#ifdef NONLIN_FRSURF
              OBSeta(i,bi,bj)=0.
#endif
            ENDIF
          ENDDO
        ENDDO
      ENDIF
#endif /* ALLOW_OBCS_SOUTH */

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#ifdef ALLOW_PTRACERS
      IF ( usePTRACERS ) THEN
C
C     Calculate some default open boundary conditions for passive tracers:
C     The default is a homogeneous v.Neumann conditions, that is, the
C     tracer gradient across the open boundary is nearly zero;
C     only nearly, because the boundary conditions are applied throughout
C     the time step during which the interior field does change; therefore
C     we have to use the values from the previous time step here. If you
C     really want exact v.Neumann conditions, you have to modify
C     obcs_apply_ptracer directly.
C
# ifdef ALLOW_OBCS_EAST
C     Eastern OB
#  ifdef ALLOW_DEBUG
       IF (debugMode)
     &      CALL DEBUG_MSG('OBCS_CALC: East, pTracers',myThid)
#  endif
       IF (useOrlanskiEast) THEN
        WRITE(msgBuf,'(A)')
     &       'OBCS_CALC: ERROR: useOrlanskiEast Rad OBC with'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(A)')
     &       'OBCS_CALC: ERROR: pTracers not yet implemented'
        CALL PRINT_ERROR( msgBuf, myThid )
        STOP 'ABNORMAL END: S/R OBCS_CALC'
       ELSE
        DO iTracer=1,PTRACERS_numInUse
         DO k=1,Nr
          DO j=1-OLy,sNy+OLy
           IF ( OB_Ie(j,bi,bj).NE.OB_indexNone ) THEN
            I_obc = OB_Ie(j,bi,bj)
            OBEptr(j,k,bi,bj,iTracer) =
     &           pTracer(I_obc-1,j,k,bi,bj,iTracer)
     &           *_maskW(I_obc,j,k,bi,bj)
           ENDIF
          ENDDO
         ENDDO
        ENDDO
       ENDIF
# endif /* ALLOW_OBCS_EAST */

C ------------------------------------------------------------------------------

# ifdef ALLOW_OBCS_WEST
C     Western OB
#  ifdef ALLOW_DEBUG
       IF (debugMode)
     &      CALL DEBUG_MSG('OBCS_CALC: West, pTracers',myThid)
#  endif
       IF (useOrlanskiWest) THEN
        WRITE(msgBuf,'(A)')
     &       'OBCS_CALC: ERROR: useOrlanskiWest Rad OBC with'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(A)')
     &       'OBCS_CALC: ERROR: pTracers not yet implemented'
        CALL PRINT_ERROR( msgBuf, myThid )
        STOP 'ABNORMAL END: S/R OBCS_CALC'
       ELSE
        DO iTracer=1,PTRACERS_numInUse
         DO k=1,Nr
          DO j=1-OLy,sNy+OLy
           IF ( OB_Iw(j,bi,bj).NE.OB_indexNone ) THEN
            I_obc = OB_Iw(j,bi,bj)
            OBWptr(j,k,bi,bj,iTracer) =
     &           pTracer(I_obc+1,j,k,bi,bj,iTracer)
     &           *_maskW(I_obc+1,j,k,bi,bj)
           ENDIF
          ENDDO
         ENDDO
        ENDDO
       ENDIF
# endif /* ALLOW_OBCS_WEST */

C ------------------------------------------------------------------------------

# ifdef ALLOW_OBCS_NORTH
C         Northern OB
#  ifdef ALLOW_DEBUG
       IF (debugMode)
     &     CALL DEBUG_MSG('OBCS_CALC: North, pTracers',myThid)
#  endif
       IF (useOrlanskiNorth) THEN
        WRITE(msgBuf,'(A)')
     &       'OBCS_CALC: ERROR: useOrlanskiNorth Rad OBC with'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(A)')
     &       'OBCS_CALC: ERROR: pTracers not yet implemented'
        CALL PRINT_ERROR( msgBuf, myThid )
        STOP 'ABNORMAL END: S/R OBCS_CALC'
       ELSE
        DO iTracer=1,PTRACERS_numInUse
         DO k=1,Nr
          DO i=1-OLx,sNx+OLx
           IF ( OB_Jn(i,bi,bj).NE.OB_indexNone ) THEN
            J_obc = OB_Jn(i,bi,bj)
            OBNptr(i,k,bi,bj,iTracer) =
     &           pTracer(i,J_obc-1,k,bi,bj,iTracer)
     &           *_maskS(i,J_obc,k,bi,bj)
           ENDIF
          ENDDO
         ENDDO
        ENDDO
       ENDIF
# endif /* ALLOW_OBCS_NORTH */

C ------------------------------------------------------------------------------

# ifdef ALLOW_OBCS_SOUTH
C         Southern OB
# ifdef ALLOW_DEBUG
       IF (debugMode)
     &      CALL DEBUG_MSG('OBCS_CALC: South, pTracers',myThid)
#endif
       IF (useOrlanskiSouth) THEN
        WRITE(msgBuf,'(A)')
     &       'OBCS_CALC: ERROR: useOrlanskiSouth Rad OBC with'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(A)')
     &       'OBCS_CALC: ERROR: pTracers not yet implemented'
        CALL PRINT_ERROR( msgBuf, myThid )
        STOP 'ABNORMAL END: S/R OBCS_CALC'
       ELSE
        DO iTracer=1,PTRACERS_numInUse
         DO k=1,Nr
          DO i=1-OLx,sNx+OLx
           IF ( OB_Js(i,bi,bj).NE.OB_indexNone ) THEN
            J_obc = OB_Js(i,bi,bj)
            OBSptr(i,k,bi,bj,iTracer) =
     &           pTracer(i,J_obc+1,k,bi,bj,iTracer)
     &           *_maskS(i,J_obc+1,k,bi,bj)
           ENDIF
          ENDDO
         ENDDO
        ENDDO
       ENDIF
# endif /* ALLOW_OBCS_SOUTH */
C     end if (usePTracers)
      ENDIF
#endif /* ALLOW_PTRACERS */

C--   end bi,bj loops.
      ENDDO
      ENDDO

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#ifdef ALLOW_OBCS_PRESCRIBE
      IF (useOBCSprescribe) THEN
C--     Calculate future values on open boundaries
#ifdef ALLOW_DEBUG
        IF (debugMode) CALL DEBUG_CALL('OBCS_PRESCRIBE_READ',myThid)
#endif
        CALL OBCS_PRESCRIBE_READ( futureTime, futureIter, myThid )
      ENDIF
#endif /* ALLOW_OBCS_PRESCRIBE */

C ------------------------------------------------------------------------------
C     read control parameter contributions here to be independent of flags
C     ALLOW_OBCS_PRESCRIBE and useOBCSprescribe
#ifdef ALLOW_CTRL
      IF ( useCTRL ) THEN
# ifdef ALLOW_OBCSN_CONTROL
       CALL CTRL_GETOBCSN ( futureTime, futureIter, myThid )
# endif
# ifdef ALLOW_OBCSS_CONTROL
       CALL CTRL_GETOBCSS ( futureTime, futureIter, myThid )
# endif
# ifdef ALLOW_OBCSW_CONTROL
       CALL CTRL_GETOBCSW ( futureTime, futureIter, myThid )
# endif
# ifdef ALLOW_OBCSE_CONTROL
       CALL CTRL_GETOBCSE ( futureTime, futureIter, myThid )
# endif
      ENDIF
#endif /* ALLOW_CTRL */

C ------------------------------------------------------------------------------

#ifdef ALLOW_OBCS_STEVENS
C     The Stevens (1990) boundary conditions come after reading data from
C     files, because they use the data to compute a mix of simplified
C     Orlanski and prescribed boundary conditions
      IF (useStevensNorth.OR.useStevensSouth.OR.
     &     useStevensEast.OR.useStevensWest) THEN
#ifdef ALLOW_DEBUG
       IF (debugMode) CALL DEBUG_CALL('OBCS_CALC_STEVENS',myThid)
#endif
       CALL OBCS_CALC_STEVENS( futureTime, futureIter, myThid )
      ENDIF
#endif /* ALLOW_OBCS_STEVENS */

#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_LEAVE('OBCS_CALC',myThid)
#endif
#endif /* ALLOW_OBCS */

      RETURN
      END

#include "STREAMICE_OPTIONS.h"
#ifdef ALLOW_AUTODIFF
# include "AUTODIFF_OPTIONS.h"
#endif


      SUBROUTINE ADSTRMICE_H_INV (
#ifdef ALLOW_OPENAD
     &            H,
     &            Hd,
     &            S,
     &            R,
     &            Rd,
     &            delta,
#endif
     &            mythid)

!      This S/R finds a thickness (H) that gives surf elev S with bed R

#include "SIZE.h"
#include "GRID.h"
#include "SET_GRID.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "STREAMICE.h"
!#include "CTRL_GENARR.h"

      INTEGER myThid

#ifdef ALLOW_STREAMICE
#ifdef ALLOW_AUTODIFF

      _RL fp, hf
      _RL rhoi, rhow, i_r, delta
      INTEGER i, j, bi, bj
      _RL ETA_GL_STREAMICE
      EXTERNAL ETA_GL_STREAMICE
      _RL ETA_GL_PRIME_STREAMICE
!      EXTERNAL PHI_GL_STREAMICE_PRIME

      _RL H(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
!      _RL Rtmp(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)a
#ifdef ALLOW_AUTODIFF_TAMC
      _RL r_low_si_ad(1-olx:snx+olx,1-oly:sny+oly,nsx,nsy)
      common /streamice_rlow_ad/ r_low_si_ad
      _RL h_streamice_ad(1-olx:snx+olx,1-oly:sny+oly,nsx,nsy)
      common /streamice_fields_rl_ad/ h_streamice_ad
#else
      _RL R(1-olx:snx+olx,1-oly:sny+oly,nsx,nsy)
      _RL S(1-olx:snx+olx,1-oly:sny+oly,nsx,nsy)
      _RL Rd(1-olx:snx+olx,1-oly:sny+oly,nsx,nsy)
      _RL Hd(1-olx:snx+olx,1-oly:sny+oly,nsx,nsy)
#endif

!       il=ILNBLNK( xx_genarr2d_file(iarr) )
!       write(fnamegeneric(1:80),'(2a,i10.10)')
!     &     xx_genarr2d_file(iarr)(1:il),'.',optimcycle
!       CALL ACTIVE_READ_XY ( fnamegeneric, tmpfld2d, 1,
!     &                      doglobalread, ladinit, optimcycle,
!     &                      myThid, xx_genarr2d_dummy(iarr) )



!      CALL ACTIVE_READ_XY ( 'H_adjust.data', H, 1,
!     &     doglobalread, ladinit, optimcycle,
!     &     myThid,

!      CALL READ_FLD_XY_RL( 'R_low_adjust.data', ' ', Rtmp,
!     &     0, myThid )

!      call write_fld_xy_rl ("R_invert_pre","",R,0,mythid)

      CALL STREAMICE_INVERT_SURF_FORTHICK (
     O            H,
#ifdef ALLOW_AUTODIFF_TAMC
     I            surf_el_streamice,
     I            R_low_si,
#else
     I            S,
     I            R,
#endif
     I            delta,
     I            myThid)

      rhoi = streamice_density
      rhow = streamice_density_ocean_avg
      i_r = rhow/rhoi
      delta=1-rhoi/rhow

      DO bj=myByLo(myThid), myByHi(myThid)
        DO bi=myBxLo(myThid), myBxHi(myThid)
          do j = 1,sNy
            do i = 1,sNx


#ifdef ALLOW_AUTODIFF_TAMC
              hf = -1.0 * i_r * R_low_si (i,j,bi,bj)
#else
              hf = -1.0 * i_r * R (i,j,bi,bj)
#endif

              fp = ETA_GL_PRIME_STREAMICE (
     &             H (i,j,bi,bj)-hf,
     &             delta,
     &             1. _d 0,
     &             delta*hf,
     &             streamice_smooth_gl_width)


#ifdef ALLOW_AUTODIFF_TAMC
              r_low_si_ad (i,j,bi,bj) =
     &          r_low_si_ad (i,j,bi,bj) -
     &          i_r * (fp-delta)/fp *
     &          h_streamice_ad(i,j,bi,bj)
#else
              rd (i,j,bi,bj) =
     &          rd (i,j,bi,bj) -
     &          i_r * (fp-delta)/fp *
     &          hd(i,j,bi,bj)
#endif

            enddo
          enddo
        enddo
      enddo

#endif
#endif
      RETURN
      END

#include "FLT_OPTIONS.h"
#undef DBUG_EXCH_VEC

      SUBROUTINE FLT_EXCHG (
     I                       myTime, myIter, myThid )

C     ==================================================================
C     SUBROUTINE FLT_EXCHG
C     ==================================================================
C     o Exchange particles between tiles.
C     started: Arne Biastoch
C     changed: Antti Westerlund antti.westerlund@helsinki.fi 2004.06.10
C     ==================================================================

C     !USES:
      IMPLICIT NONE

C     == global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "FLT_SIZE.h"
#include "FLT.h"

C     == routine arguments ==
      _RL myTime
      INTEGER myIter, myThid

C     == shared variables ==
C-    buffer for sending/receiving variables (E/W are also used for S/N)
C     (needs to be in common block for multi-threaded)
      INTEGER imax, imax2
      PARAMETER(imax=9)
      PARAMETER(imax2=imax*max_npart_exch)
      _RL fltbuf_sendE(imax2,nSx,nSy)
      _RL fltbuf_sendW(imax2,nSx,nSy)
      _RL fltbuf_recvE(imax2,nSx,nSy)
      _RL fltbuf_recvW(imax2,nSx,nSy)
      COMMON / FLT_EXCHG_BUFF /
     &   fltbuf_sendE, fltbuf_sendW, fltbuf_recvE, fltbuf_recvW

C     == local variables ==
      INTEGER bi, bj, ic
      INTEGER ip, jp, jl, m, npNew
      INTEGER icountE, icountW, icountN, icountS
      INTEGER deleteList(max_npart_exch*2)
      _RL ilo, ihi, jlo, jhi, iNew, jNew
      CHARACTER*(MAX_LEN_MBUF) msgBuf
#ifdef FLT_WITHOUT_X_PERIODICITY
      LOGICAL wSide, eSide
#endif /* FLT_WITHOUT_X_PERIODICITY */
#ifdef FLT_WITHOUT_Y_PERIODICITY
      LOGICAL sSide, nSide
#endif /* FLT_WITHOUT_Y_PERIODICITY */
      _RL     flt_stopped

C     == end of interface ==

C--   set the "end-time" of a stopped float
      flt_stopped = -2.
      flt_stopped = MIN( baseTime, flt_stopped )

Caw Check if there are eastern/western tiles
c     IF ( Nx.NE.sNx ) THEN
C--   for periodic domain, condition above is wrong ; needs a better test
      IF ( .TRUE. ) THEN

C--   Choose floats that have to exchanged with eastern and western tiles
C     and pack to arrays

        DO bj=myByLo(myThid),myByHi(myThid)
         DO bi=myBxLo(myThid),myBxHi(myThid)

C initialize buffers
           DO m=1,imax2
             fltbuf_sendE(m,bi,bj) = 0.
             fltbuf_sendW(m,bi,bj) = 0.
             fltbuf_recvE(m,bi,bj) = 0.
             fltbuf_recvW(m,bi,bj) = 0.
           ENDDO

           icountE=0
           icountW=0
           jl = 0

           ilo = 0.5 _d 0
           ihi = 0.5 _d 0 + DFLOAT(sNx)
#ifdef FLT_WITHOUT_X_PERIODICITY
           wSide = myXGlobalLo+bi .LE.2
           eSide = myXGlobalLo+bi*sNx.GT.Nx
#endif /* FLT_WITHOUT_X_PERIODICITY */

           DO ip=1,npart_tile(bi,bj)

#ifdef FLT_WITHOUT_X_PERIODICITY
             IF ( eSide .AND.
     &           (myTime.LE.tend(ip,bi,bj) .OR. tend(ip,bi,bj).EQ.-1.)
     &           .AND. ipart(ip,bi,bj).GE.ihi ) THEN
C          stop the float:
              tend(ip,bi,bj) = flt_stopped
             ELSEIF ( ipart(ip,bi,bj).GE.ihi ) THEN
#else /* FLT_WITHOUT_X_PERIODICITY */
             IF ( ipart(ip,bi,bj).GE.ihi ) THEN
#endif /* FLT_WITHOUT_X_PERIODICITY */
              icountE=icountE+1
              IF ( icountE.LE.max_npart_exch ) THEN

               ic = (icountE-1)*imax
               iNew = ipart(ip,bi,bj) - DFLOAT(sNx)
               fltbuf_sendE(ic+1,bi,bj) =   npart(ip,bi,bj)
               fltbuf_sendE(ic+2,bi,bj) =  tstart(ip,bi,bj)
               fltbuf_sendE(ic+3,bi,bj) =   iNew
               fltbuf_sendE(ic+4,bi,bj) =   jpart(ip,bi,bj)
               fltbuf_sendE(ic+5,bi,bj) =   kpart(ip,bi,bj)
               fltbuf_sendE(ic+6,bi,bj) =  kfloat(ip,bi,bj)
               fltbuf_sendE(ic+7,bi,bj) =     iup(ip,bi,bj)
               fltbuf_sendE(ic+8,bi,bj) =    itop(ip,bi,bj)
               fltbuf_sendE(ic+9,bi,bj) =    tend(ip,bi,bj)

C tag this float to be removed:
               jl = jl + 1
               deleteList(jl) = ip
               npart(ip,bi,bj) = 0.

              ENDIF
             ENDIF

#ifdef FLT_WITHOUT_X_PERIODICITY
             IF ( wSide .AND.
     &           (myTime.LE.tend(ip,bi,bj) .OR. tend(ip,bi,bj).EQ.-1.)
     &           .AND. ipart(ip,bi,bj).LT.ilo ) THEN
C          stop the float:
              tend(ip,bi,bj) = flt_stopped
             ELSEIF ( ipart(ip,bi,bj).LT.ilo ) THEN
#else /* FLT_WITHOUT_X_PERIODICITY */
             IF ( ipart(ip,bi,bj).LT.ilo ) THEN
#endif /* FLT_WITHOUT_X_PERIODICITY */
              icountW=icountW+1
              IF ( icountW.LE.max_npart_exch ) THEN

               ic = (icountW-1)*imax
               iNew = ipart(ip,bi,bj) + DFLOAT(sNx)
               fltbuf_sendW(ic+1,bi,bj) =   npart(ip,bi,bj)
               fltbuf_sendW(ic+2,bi,bj) =  tstart(ip,bi,bj)
               fltbuf_sendW(ic+3,bi,bj) =   iNew
               fltbuf_sendW(ic+4,bi,bj) =   jpart(ip,bi,bj)
               fltbuf_sendW(ic+5,bi,bj) =   kpart(ip,bi,bj)
               fltbuf_sendW(ic+6,bi,bj) =  kfloat(ip,bi,bj)
               fltbuf_sendW(ic+7,bi,bj) =     iup(ip,bi,bj)
               fltbuf_sendW(ic+8,bi,bj) =    itop(ip,bi,bj)
               fltbuf_sendW(ic+9,bi,bj) =    tend(ip,bi,bj)

C tag this float to be removed:
               jl = jl + 1
               deleteList(jl) = ip
               npart(ip,bi,bj) = 0.

              ENDIF
             ENDIF

           ENDDO
           IF ( icountE.GT.max_npart_exch ) THEN
             WRITE(msgBuf,'(2A,2I4,2(A,I8))') ' FLT_EXCHG:',
     &         ' bi,bj=', bi, bj,
     &         ' icountE=', icountE,
     &         ' > max_npart_exch=', max_npart_exch
             CALL PRINT_ERROR( msgBuf, myThid )
           ENDIF
           IF ( icountW.GT.max_npart_exch ) THEN
             WRITE(msgBuf,'(2A,2I4,2(A,I8))') ' FLT_EXCHG:',
     &         ' bi,bj=', bi, bj,
     &         ' icountW=', icountW,
     &         ' > max_npart_exch=', max_npart_exch
             CALL PRINT_ERROR( msgBuf, myThid )
           ENDIF
           IF ( icountE.GT.max_npart_exch
     &     .OR. icountW.GT.max_npart_exch ) THEN
             STOP 'ABNORMAL END: S/R FLT_EXCHG'
           ENDIF
           IF ( (icountE+icountW).GT.0 ) THEN
C Remove from this tile-list, floats which have been sent to an other tile
             npNew = npart_tile(bi,bj) - (icountE+icountW)
             jl = 0
             DO jp = npNew+1,npart_tile(bi,bj)
              IF ( npart(jp,bi,bj).NE.0. _d 0 ) THEN
                jl = jl + 1
                ip = deleteList(jl)
C        copy: ip <-- jp
                npart (ip,bi,bj) =  npart (jp,bi,bj)
                tstart(ip,bi,bj) =  tstart(jp,bi,bj)
                ipart (ip,bi,bj) =  ipart (jp,bi,bj)
                jpart (ip,bi,bj) =  jpart (jp,bi,bj)
                kpart (ip,bi,bj) =  kpart (jp,bi,bj)
                kfloat(ip,bi,bj) =  kfloat(jp,bi,bj)
                iup   (ip,bi,bj) =  iup   (jp,bi,bj)
                itop  (ip,bi,bj) =  itop  (jp,bi,bj)
                tend  (ip,bi,bj) =  tend  (jp,bi,bj)
              ENDIF
             ENDDO
             npart_tile(bi,bj) = npNew
           ENDIF

         ENDDO
        ENDDO

C--   Send or Put east and west edges.

#ifdef DBUG_EXCH_VEC
        WRITE(errorMessageUnit,'(A,I8)') 'FLT_EXCH: 0x', myIter
#endif
        CALL EXCH_SEND_PUT_VEC_X_RL(
     I                               fltbuf_sendE, fltbuf_sendW,
     O                               fltbuf_recvE, fltbuf_recvW,
     I                               imax2, myThid )
#ifdef DBUG_EXCH_VEC
        WRITE(errorMessageUnit,'(A,I8)') 'FLT_EXCH: 1x', myIter
#endif
C--   Receive east/west arrays
        CALL EXCH_RECV_GET_VEC_X_RL(
     U                               fltbuf_recvE, fltbuf_recvW,
     I                               imax2, myThid )
#ifdef DBUG_EXCH_VEC
        WRITE(errorMessageUnit,'(A,I8)') 'FLT_EXCH: 2x', myIter
#endif

C--   Unpack arrays on new tiles

        DO bj=myByLo(myThid),myByHi(myThid)
         DO bi=myBxLo(myThid),myBxHi(myThid)

           DO ip=1,max_npart_exch

            ic=(ip-1)*imax
            IF ( fltbuf_recvE(ic+1,bi,bj).NE.0. ) THEN
             npart_tile(bi,bj) = npart_tile(bi,bj) + 1
             IF ( npart_tile(bi,bj).LE.max_npart_tile ) THEN
               jp = npart_tile(bi,bj)
               npart( jp,bi,bj) = fltbuf_recvE(ic+1,bi,bj)
               tstart(jp,bi,bj) = fltbuf_recvE(ic+2,bi,bj)
               ipart( jp,bi,bj) = fltbuf_recvE(ic+3,bi,bj)
               jpart( jp,bi,bj) = fltbuf_recvE(ic+4,bi,bj)
               kpart( jp,bi,bj) = fltbuf_recvE(ic+5,bi,bj)
               kfloat(jp,bi,bj) = fltbuf_recvE(ic+6,bi,bj)
               iup(   jp,bi,bj) = fltbuf_recvE(ic+7,bi,bj)
               itop(  jp,bi,bj) = fltbuf_recvE(ic+8,bi,bj)
               tend(  jp,bi,bj) = fltbuf_recvE(ic+9,bi,bj)
             ENDIF
            ENDIF

           ENDDO
           IF ( npart_tile(bi,bj).GT.max_npart_tile ) THEN
             WRITE(msgBuf,'(2A,2I4,2(A,I8))') 'FLT_EXCHG:+E',
     &         ' bi,bj=', bi, bj,
     &         ' npart_tile=', npart_tile(bi,bj),
     &         ' > max_npart_tile=', max_npart_tile
              CALL PRINT_ERROR( msgBuf, myThid )
              STOP 'ABNORMAL END: S/R FLT_EXCHG'
           ENDIF

           DO ip=1,max_npart_exch

            ic=(ip-1)*imax
            IF ( fltbuf_recvW(ic+1,bi,bj).NE.0. ) THEN
             npart_tile(bi,bj) = npart_tile(bi,bj) + 1
             IF ( npart_tile(bi,bj).LE.max_npart_tile ) THEN
               jp = npart_tile(bi,bj)
               npart( jp,bi,bj) = fltbuf_recvW(ic+1,bi,bj)
               tstart(jp,bi,bj) = fltbuf_recvW(ic+2,bi,bj)
               ipart( jp,bi,bj) = fltbuf_recvW(ic+3,bi,bj)
               jpart( jp,bi,bj) = fltbuf_recvW(ic+4,bi,bj)
               kpart( jp,bi,bj) = fltbuf_recvW(ic+5,bi,bj)
               kfloat(jp,bi,bj) = fltbuf_recvW(ic+6,bi,bj)
               iup(   jp,bi,bj) = fltbuf_recvW(ic+7,bi,bj)
               itop(  jp,bi,bj) = fltbuf_recvW(ic+8,bi,bj)
               tend(  jp,bi,bj) = fltbuf_recvW(ic+9,bi,bj)
             ENDIF
            ENDIF

           ENDDO
           IF ( npart_tile(bi,bj).GT.max_npart_tile ) THEN
             WRITE(msgBuf,'(2A,2I4,2(A,I8))') 'FLT_EXCHG:+W',
     &         ' bi,bj=', bi, bj,
     &         ' npart_tile=', npart_tile(bi,bj),
     &         ' > max_npart_tile=', max_npart_tile
              CALL PRINT_ERROR( msgBuf, myThid )
              STOP 'ABNORMAL END: S/R FLT_EXCHG'
           ENDIF

         ENDDO
        ENDDO

Caw end tile check
      ENDIF

C--   Choose floats that have to exchanged with northern and southern tiles
C     and pack to arrays

Caw Check if there are northern/southern tiles
c     IF ( Ny.NE.sNy ) THEN
C--   for periodic domain, condition above is wrong ; needs a better test
      IF ( .TRUE. ) THEN

        DO bj=myByLo(myThid),myByHi(myThid)
         DO bi=myBxLo(myThid),myBxHi(myThid)

C initialize buffers

           DO m=1,imax2
             fltbuf_sendE(m,bi,bj) = 0.
             fltbuf_sendW(m,bi,bj) = 0.
             fltbuf_recvE(m,bi,bj) = 0.
             fltbuf_recvW(m,bi,bj) = 0.
           ENDDO

           icountN=0
           icountS=0
           jl = 0

           jlo = 0.5 _d 0
           jhi = 0.5 _d 0 + DFLOAT(sNy)
#ifdef FLT_WITHOUT_Y_PERIODICITY
           sSide = myYGlobalLo+bj .LE.2
           nSide = myYGlobalLo+bj*sNy.GT.Ny
#endif /* FLT_WITHOUT_Y_PERIODICITY */

           DO ip=1,npart_tile(bi,bj)

#ifdef FLT_WITHOUT_Y_PERIODICITY
             IF ( nSide .AND.
     &           (myTime.LE.tend(ip,bi,bj) .OR. tend(ip,bi,bj).EQ.-1.)
     &           .AND. jpart(ip,bi,bj).GE.jhi ) THEN
C          stop the float:
              tend(ip,bi,bj) = flt_stopped
             ELSEIF ( jpart(ip,bi,bj).GE.jhi ) THEN
#else /* FLT_WITHOUT_Y_PERIODICITY */
             IF ( jpart(ip,bi,bj).GE.jhi ) THEN
#endif /* FLT_WITHOUT_Y_PERIODICITY */
              icountN=icountN+1
              IF ( icountN.LE.max_npart_exch ) THEN

               ic = (icountN-1)*imax
               jNew = jpart(ip,bi,bj) - DFLOAT(sNy)
               fltbuf_sendE(ic+1,bi,bj) =   npart(ip,bi,bj)
               fltbuf_sendE(ic+2,bi,bj) =  tstart(ip,bi,bj)
               fltbuf_sendE(ic+3,bi,bj) =   ipart(ip,bi,bj)
               fltbuf_sendE(ic+4,bi,bj) =   jNew
               fltbuf_sendE(ic+5,bi,bj) =   kpart(ip,bi,bj)
               fltbuf_sendE(ic+6,bi,bj) =  kfloat(ip,bi,bj)
               fltbuf_sendE(ic+7,bi,bj) =     iup(ip,bi,bj)
               fltbuf_sendE(ic+8,bi,bj) =    itop(ip,bi,bj)
               fltbuf_sendE(ic+9,bi,bj) =    tend(ip,bi,bj)

C tag this float to be removed:
               jl = jl + 1
               deleteList(jl) = ip
               npart(ip,bi,bj) = 0.

c             ELSE
c              WRITE(msgBuf,'(2A,2I4,I6,A,2F17.6))') ' FLT_EXCHG,N:',
c    &         ' bi,bj,ip=', bi, bj, ip,
c    &         ' yp,yHi=', jpart(ip,bi,bj), jhi
c              CALL PRINT_ERROR( msgBuf, myThid )
              ENDIF
             ENDIF

#ifdef FLT_WITHOUT_Y_PERIODICITY
             IF ( sSide .AND.
     &           (myTime.LE.tend(ip,bi,bj) .OR. tend(ip,bi,bj).EQ.-1.)
     &           .AND. jpart(ip,bi,bj).LT.jlo ) THEN
C          stop the float:
              tend(ip,bi,bj) = flt_stopped
             ELSEIF ( jpart(ip,bi,bj).LT.jlo ) THEN
#else /* FLT_WITHOUT_Y_PERIODICITY */
             IF ( jpart(ip,bi,bj).LT.jlo ) THEN
#endif /* FLT_WITHOUT_Y_PERIODICITY */
              icountS=icountS+1
              IF ( icountS.LE.max_npart_exch ) THEN

               ic = (icountS-1)*imax
               jNew = jpart(ip,bi,bj) + DFLOAT(sNy)
               fltbuf_sendW(ic+1,bi,bj) =   npart(ip,bi,bj)
               fltbuf_sendW(ic+2,bi,bj) =  tstart(ip,bi,bj)
               fltbuf_sendW(ic+3,bi,bj) =   ipart(ip,bi,bj)
               fltbuf_sendW(ic+4,bi,bj) =   jNew
               fltbuf_sendW(ic+5,bi,bj) =   kpart(ip,bi,bj)
               fltbuf_sendW(ic+6,bi,bj) =  kfloat(ip,bi,bj)
               fltbuf_sendW(ic+7,bi,bj) =     iup(ip,bi,bj)
               fltbuf_sendW(ic+8,bi,bj) =    itop(ip,bi,bj)
               fltbuf_sendW(ic+9,bi,bj) =    tend(ip,bi,bj)

C tag this float to be removed:
               jl = jl + 1
               deleteList(jl) = ip
               npart(ip,bi,bj) = 0.

c             ELSE
c              WRITE(msgBuf,'(2A,2I4,I6,A,2F17.6))') ' FLT_EXCHG,S:',
c    &         ' bi,bj,ip=', bi, bj, ip,
c    &         ' yp,yLo=', jpart(ip,bi,bj), jlo
c              CALL PRINT_ERROR( msgBuf, myThid )
              ENDIF
             ENDIF

           ENDDO
           IF ( icountN.GT.max_npart_exch ) THEN
             WRITE(msgBuf,'(2A,2I4,2(A,I8))') ' FLT_EXCHG:',
     &         ' bi,bj=', bi, bj,
     &         ' icountN=', icountN,
     &         ' > max_npart_exch=', max_npart_exch
             CALL PRINT_ERROR( msgBuf, myThid )
           ENDIF
           IF ( icountS.GT.max_npart_exch ) THEN
             WRITE(msgBuf,'(2A,2I4,2(A,I8))') ' FLT_EXCHG:',
     &         ' bi,bj=', bi, bj,
     &         ' icountS=', icountS,
     &         ' > max_npart_exch=', max_npart_exch
             CALL PRINT_ERROR( msgBuf, myThid )
           ENDIF
           IF ( icountN.GT.max_npart_exch
     &     .OR. icountS.GT.max_npart_exch ) THEN
             STOP 'ABNORMAL END: S/R FLT_EXCHG'
           ENDIF
           IF ( (icountN+icountS).GT.0 ) THEN
C Remove from this tile-list, floats which have been sent to an other tile
             npNew = npart_tile(bi,bj) - (icountN+icountS)
             jl = 0
             DO jp = npNew+1,npart_tile(bi,bj)
              IF ( npart(jp,bi,bj).NE.0. _d 0 ) THEN
                jl = jl + 1
                ip = deleteList(jl)
C        copy: ip <-- jp
                npart (ip,bi,bj) =  npart (jp,bi,bj)
                tstart(ip,bi,bj) =  tstart(jp,bi,bj)
                ipart (ip,bi,bj) =  ipart (jp,bi,bj)
                jpart (ip,bi,bj) =  jpart (jp,bi,bj)
                kpart (ip,bi,bj) =  kpart (jp,bi,bj)
                kfloat(ip,bi,bj) =  kfloat(jp,bi,bj)
                iup   (ip,bi,bj) =  iup   (jp,bi,bj)
                itop  (ip,bi,bj) =  itop  (jp,bi,bj)
                tend  (ip,bi,bj) =  tend  (jp,bi,bj)
              ENDIF
             ENDDO
             npart_tile(bi,bj) = npNew
           ENDIF

         ENDDO
        ENDDO

C     Send or Put north and south arrays.
#ifdef DBUG_EXCH_VEC
        WRITE(errorMessageUnit,'(A,I8)') 'FLT_EXCH: 0y', myIter
#endif
        CALL EXCH_SEND_PUT_VEC_Y_RL(
     I                               fltbuf_sendE, fltbuf_sendW,
     O                               fltbuf_recvE, fltbuf_recvW,
     I                               imax2, myThid )
#ifdef DBUG_EXCH_VEC
        WRITE(errorMessageUnit,'(A,I8)') 'FLT_EXCH: 1y', myIter
#endif
C     Receive north and south arrays
        CALL EXCH_RECV_GET_VEC_Y_RL(
     U                               fltbuf_recvE, fltbuf_recvW,
     I                               imax2, myThid )
#ifdef DBUG_EXCH_VEC
        WRITE(errorMessageUnit,'(A,I8)') 'FLT_EXCH: 2y', myIter
c       STOP 'FLT_EXCHG: Normal End'
#endif

C--   Unpack arrays on new tiles

        DO bj=myByLo(myThid),myByHi(myThid)
         DO bi=myBxLo(myThid),myBxHi(myThid)

           DO ip=1,max_npart_exch

            ic=(ip-1)*imax
            IF ( fltbuf_recvE(ic+1,bi,bj).NE.0. ) THEN
             npart_tile(bi,bj) = npart_tile(bi,bj) + 1
             IF ( npart_tile(bi,bj).LE.max_npart_tile ) THEN
               jp = npart_tile(bi,bj)
               npart( jp,bi,bj) = fltbuf_recvE(ic+1,bi,bj)
               tstart(jp,bi,bj) = fltbuf_recvE(ic+2,bi,bj)
               ipart( jp,bi,bj) = fltbuf_recvE(ic+3,bi,bj)
               jpart( jp,bi,bj) = fltbuf_recvE(ic+4,bi,bj)
               kpart( jp,bi,bj) = fltbuf_recvE(ic+5,bi,bj)
               kfloat(jp,bi,bj) = fltbuf_recvE(ic+6,bi,bj)
               iup(   jp,bi,bj) = fltbuf_recvE(ic+7,bi,bj)
               itop(  jp,bi,bj) = fltbuf_recvE(ic+8,bi,bj)
               tend(  jp,bi,bj) = fltbuf_recvE(ic+9,bi,bj)
             ENDIF
            ENDIF

           ENDDO
           IF ( npart_tile(bi,bj).GT.max_npart_tile ) THEN
             WRITE(msgBuf,'(2A,2I4,2(A,I8))') 'FLT_EXCHG:+N',
     &         ' bi,bj=', bi, bj,
     &         ' npart_tile=', npart_tile(bi,bj),
     &         ' > max_npart_tile=', max_npart_tile
              CALL PRINT_ERROR( msgBuf, myThid )
              STOP 'ABNORMAL END: S/R FLT_EXCHG'
           ENDIF

           DO ip=1,max_npart_exch

            ic=(ip-1)*imax
            IF ( fltbuf_recvW(ic+1,bi,bj).NE.0. ) THEN
             npart_tile(bi,bj) = npart_tile(bi,bj) + 1
             IF ( npart_tile(bi,bj).LE.max_npart_tile ) THEN
               jp = npart_tile(bi,bj)
               npart( jp,bi,bj) = fltbuf_recvW(ic+1,bi,bj)
               tstart(jp,bi,bj) = fltbuf_recvW(ic+2,bi,bj)
               ipart( jp,bi,bj) = fltbuf_recvW(ic+3,bi,bj)
               jpart( jp,bi,bj) = fltbuf_recvW(ic+4,bi,bj)
               kpart( jp,bi,bj) = fltbuf_recvW(ic+5,bi,bj)
               kfloat(jp,bi,bj) = fltbuf_recvW(ic+6,bi,bj)
               iup(   jp,bi,bj) = fltbuf_recvW(ic+7,bi,bj)
               itop(  jp,bi,bj) = fltbuf_recvW(ic+8,bi,bj)
               tend(  jp,bi,bj) = fltbuf_recvW(ic+9,bi,bj)
             ENDIF
            ENDIF

           ENDDO
           IF ( npart_tile(bi,bj).GT.max_npart_tile ) THEN
             WRITE(msgBuf,'(2A,2I4,2(A,I8))') 'FLT_EXCHG:+S',
     &         ' bi,bj=', bi, bj,
     &         ' npart_tile=', npart_tile(bi,bj),
     &         ' > max_npart_tile=', max_npart_tile
              CALL PRINT_ERROR( msgBuf, myThid )
              STOP 'ABNORMAL END: S/R FLT_EXCHG'
           ENDIF

         ENDDO
        ENDDO

Caw end tile check
      ENDIF

      RETURN
      END

#include "MDSIO_OPTIONS.h"

CBOP
C !ROUTINE: MDS_READVEC_LOC
C !INTERFACE:
      SUBROUTINE MDS_READVEC_LOC(
     I   fName,
     I   filePrec,
     U   ioUnit,
     I   arrType,
     I   nSize,
     I   fldRL, fldRS,
     I   bi, bj,
     I   iRec,
     I   myThid )

C !DESCRIPTION:
C Arguments:
C
C fName    string  :: base name for file to read
C filePrec integer :: number of bits per word in file (32 or 64)
C ioUnit   integer :: fortran file IO unit
C nSize    integer :: number of elements of input array "fldRL/RS" to read
C arrType  char(2) :: which array (fldRL/RS) to read, either "RL" or "RS"
C fldRL    ( RL )  :: array to read if arrType="RL", fldRL(nSize)
C fldRS    ( RS )  :: array to read if arrType="RS", fldRS(nSize)
C bi,bj    integer :: tile indices (if tiled array) or 0,0 if not a tiled array
C iRec     integer :: record number to read
C myThid   integer :: my Thread Id number
C
C MDS_READVEC_LOC : reads a vector (local to tile bi,bj) from binary file:
C according to ioUnit:
C  ioUnit > 0 : assume file "ioUnit" is open, and read from it.
C  ioUnit = 0 : open file, read and close the file (return ioUnit=0).
C  ioUnit =-1 : open file, read and leave it open (return IO unit in ioUnit)
C  ioUnit =-2 : same as -1 except keep ioUnit=-2 (no stop) if missing file
C if bi=bj=0, MDS_READVEC_LOC first check if the file "fName" exists,
C  then if the file "fName.data" exists, and read from the 1rst found.
C if bi,bj >0, read from MDS tiled files of the form "fName.xxx.yyy.data"
C The precision of the file is described by filePrec, set either
C  to floatPrec32 or floatPrec64.
C iRec is the record number to read and must be >=1.

C !USES:
      IMPLICIT NONE

C Global variables / common blocks
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#ifdef ALLOW_FIZHI
# include "fizhi_SIZE.h"
#endif /* ALLOW_FIZHI */
#include "MDSIO_BUFF_3D.h"

C !INPUT/OUTPUT PARAMETERS:
      CHARACTER*(*) fName
      INTEGER ioUnit
      INTEGER filePrec
      CHARACTER*(2) arrType
      INTEGER nSize
      _RL     fldRL(*)
      _RS     fldRS(*)
      INTEGER bi,bj
      INTEGER iRec
      INTEGER myThid

C !FUNCTIONS:
      INTEGER ILNBLNK
      INTEGER MDS_RECLEN
      EXTERNAL ILNBLNK
      EXTERNAL MDS_RECLEN

C !LOCAL VARIABLES:
      CHARACTER*(MAX_LEN_FNAM) dataFname, pfName
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      LOGICAL exst
      LOGICAL fileIsOpen
      INTEGER iG,jG,dUnit,IL,pIL,iLfn
      INTEGER length_of_rec
      INTEGER buffSize
CEOP

C---  Only DO I/O IF I am the master thread
      _BEGIN_MASTER( myThid )

C--   Assume nothing
      fileIsOpen = .FALSE.
      IL  = ILNBLNK( fName )

C--   Record number must be >= 1
      IF ( iRec.LT.1 ) THEN
         WRITE(msgBuf,'(A,I9)')
     &     ' MDS_READVEC_LOC: argument iRec = ',iRec
         CALL PRINT_ERROR( msgBuf, myThid )
         WRITE(msgBuf,'(A)')
     &    ' MDS_READVEC_LOC: invalid value for iRec'
         CALL PRINT_ERROR( msgBuf, myThid )
         STOP 'ABNORMAL END: S/R MDS_READVEC_LOC'
      ENDIF

C--   Check buffer size
      buffSize = sNx*sNy*size3dBuf*nSx*nSy
      IF ( nSize.GT.buffSize ) THEN
         WRITE(msgBuf,'(3A)')
     &    ' MDS_READVEC_LOC: reading from file "', fName(1:IL), '":'
         CALL PRINT_ERROR( msgBuf, myThid )
         WRITE(msgBuf,'(A,I9)')
     &     ' MDS_READVEC_LOC: dim of array to read=', nSize
         CALL PRINT_ERROR( msgBuf, myThid )
         WRITE(msgBuf,'(A,I9)')
     &     ' MDS_READVEC_LOC: exceeds buffer size=', buffSize
         CALL PRINT_ERROR( msgBuf, myThid )
         WRITE(msgBuf,'(A)')
     &    ' increase "size3dBuf" in "MDSIO_BUFF_3D.h" and recompile'
         CALL PRINT_ERROR( msgBuf, myThid )
         STOP 'ABNORMAL END: S/R MDS_READVEC_LOC'
      ENDIF

      IF ( ioUnit.GT.0 ) THEN
C--   Assume file Unit is already open with correct Rec-Length & Precision
         fileIsOpen = .TRUE.
         dUnit = ioUnit
      ELSEIF ( ioUnit.GE.-2 ) THEN
C--   Need to open file IO unit with File-name, Rec-Length & Precision

C-    Assign special directory
        IF ( mdsioLocalDir .NE. ' ' ) THEN
          pIL = ILNBLNK( mdsioLocalDir )
          WRITE(pFname,'(2A)') mdsioLocalDir(1:pIL), fName(1:IL)
          pIL = IL + pIL
        ELSE
          WRITE(pFname,'(A)') fName(1:IL)
          pIL = IL
        ENDIF

C-    Assign a free unit number as the I/O channel for this routine
        CALL MDSFINDUNIT( dUnit, myThid )

C--   Set the file Name:
        IF ( bi.EQ.0 .AND. bj.EQ.0 ) THEN
C-    Check first for global file with simple name (ie. fName)
          WRITE(dataFname,'(2A)') fName(1:IL)
          iLfn = IL
          INQUIRE( file=dataFname, exist=exst )
c         IF (exst) THEN
c           write(0,*) 'found file: ',dataFname(1:iLfn)
c         ENDIF
          IF ( .NOT.exst ) THEN
C-    Check for global file with ".data" suffix
            WRITE(dataFname,'(2A)') fName(1:IL),'.data'
            iLfn = IL+5
            INQUIRE( file=dataFname, exist=exst )
c           IF (exst) THEN
c            write(0,*) 'found file: ',dataFname(1:iLfn)
c           ENDIF
          ENDIF
        ELSE
C-    We are reading a tiled array (bi>0,bj>0):
          iG=bi+(myXGlobalLo-1)/sNx
          jG=bj+(myYGlobalLo-1)/sNy
          WRITE(dataFname,'(2A,I3.3,A,I3.3,A)')
     &          pfName(1:pIL),'.',iG,'.',jG,'.data'
          iLfn= pIL+8+5
          INQUIRE( file=dataFname, exist=exst )
c         IF (exst) THEN
c          write(0,*) 'found file: ',dataFname(1:iLfn)
c         ENDIF
        ENDIF
C--   Open the file:
        IF ( exst ) THEN
          IF ( debugLevel.GE.debLevB ) THEN
            WRITE(msgBuf,'(2A)')
     &      ' MDS_READVEC_LOC: open file: ',dataFname(1:iLfn)
            CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                          SQUEEZE_RIGHT, myThid )
          ENDIF
          length_of_rec = MDS_RECLEN( filePrec, nSize, myThid )
          OPEN( dUnit, file=dataFname, status=_OLD_STATUS,
     &          _READONLY_ACTION access='direct', recl=length_of_rec )
          fileIsOpen=.TRUE.
        ELSE
          fileIsOpen=.FALSE.
          WRITE(msgBuf,'(3A)')
     &     'S/R MDS_READVEC_LOC: file=',dataFname(1:iLfn),' not found'
          IF ( ioUnit.GE.-1 ) THEN
           CALL PRINT_ERROR( msgBuf, myThid )
           STOP 'ABNORMAL END: S/R MDS_READVEC_LOC'
          ELSEIF ( debugLevel.GE.debLevA ) THEN
           CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                         SQUEEZE_RIGHT, myThid )
          ENDIF
        ENDIF
      ELSE
         WRITE(msgBuf,'(A,I9,A)')  ' MDS_READVEC_LOC:',
     &         ioUnit, ' = invalid value for ioUnit argument'
         CALL PRINT_ERROR( msgBuf, myThid )
         STOP 'ABNORMAL END: S/R MDS_READVEC_LOC'
C--   End if block: File Unit is already open / Need to open it
      ENDIF

C--   Read from file
      IF ( fileIsOpen ) THEN
         IF ( arrType.EQ.'RS' ) THEN
            CALL MDS_RD_REC_RS( fldRS, shared3dBuf_r4, shared3dBuf_r8,
     I                          filePrec, dUnit, iRec, nSize, myThid )
         ELSEIF ( arrType.EQ.'RL' ) THEN
            CALL MDS_RD_REC_RL( fldRL, shared3dBuf_r4, shared3dBuf_r8,
     I                          filePrec, dUnit, iRec, nSize, myThid )
         ELSE
            WRITE(msgBuf,'(A)')
     &          ' MDS_READVEC_LOC: illegal value for arrType'
            CALL PRINT_ERROR( msgBuf, myThid )
            STOP 'ABNORMAL END: S/R MDS_READVEC_LOC'
         ENDIF
      ENDIF

C--   Close file
      IF ( fileIsOpen ) THEN
        IF ( ioUnit.EQ.-2 .OR. ioUnit.EQ.-1 ) THEN
          ioUnit = dUnit
        ELSEIF ( ioUnit.EQ.0 ) THEN
          CLOSE( dUnit )
          fileIsOpen = .FALSE.
        ENDIF
      ENDIF

      _END_MASTER( myThid )

      RETURN
      END

#include "FIZHI_OPTIONS.h"
      subroutine fizhi_init_chem(mythid,nozlats,nozlevs,ntimesoz,
     . ozlats,ozlevs,o3,
     . nwatlats,nwatlevs,ntimesq,watlats,watlevs,water,
     . Nrphys,pressure,n2o,methane,co2,cfc11,cfc12,cfc22)
C***********************************************************************
C Subroutine fizhi_init_chem - routine to read in the ozone and upper
C      atmosphere water vapor, and set the methane, n2o and cfc values
C
C INPUT:
C 
C mythid   - thread number (processor number)
C
C OUTPUT:
C
C***********************************************************************
      implicit none
      integer mythid,nozlevs,nozlats,nwatlevs,nwatlats,Nrphys
      integer ntimesoz,ntimesq
      _RL o3(nozlats,nozlevs,ntimesoz)
      _RL water(nwatlats,nwatlevs,ntimesq)
      _RL ozlats(nozlats), ozlevs(nozlevs)
      _RL watlats(nwatlats), watlevs(nwatlevs)
      _RL pressure(Nrphys),methane(Nrphys),n2o(Nrphys)
      _RL co2,cfc11,cfc12,cfc22

      _RL getcon
      integer kqz,koz
      call mdsfindunit( kqz, myThid )
      call mdsfindunit( koz, myThid )

      call read_qz (kqz,water,watlats,watlevs,nwatlats,nwatlevs,ntimesq)
      call read_oz (koz,o3,ozlats,ozlevs,nozlats,nozlevs,ntimesoz)

      call get_methane_n2o (pressure,Nrphys,n2o,methane)

      co2   = getcon('CO2'  )*1.e-6
      cfc11 = getcon('CFC11')*1.e-9
      cfc12 = getcon('CFC12')*1.e-9
      cfc22 = getcon('CFC22')*1.e-9

      RETURN
      END

      subroutine read_qz (ku,qz,lats,levs,nlat,nlev,ntime)
C***********************************************************************
C  PURPOSE
C     To Read Stratospheric Moisture Data
C
C  ARGUMENTS   DESCRIPTION
C     ku ...... Unit to Read  Moisture Data
C     qz ...... Stratospheric Moisture Data
C     lats .... Stratospheric Moisture Data Latitudes (degrees)
C     levs .... Stratospheric Moisture Data Levels    (mb)
C     nlat .... Number of ozone latitudes
C     nlev .... Number of ozone levels
C     ntime ... Number of ozone time values
C
C***********************************************************************

      implicit none
      integer  ku,nlat,nlev,ntime

      _RL qz(nlat,nlev,ntime)
      _RL lats(nlat)
      _RL levs(nlev)

      integer time0
      integer lat
      integer lev

      _RL voltomas
      parameter ( voltomas = 0.622e-6 )

      open(ku,file='data.sage',form='formatted')
      rewind ku

c Set Moisture Data Latitudes
c ---------------------------
      do   lat = 1,nlat
      lats(lat) = -85. + (lat-1)*10.
      enddo

c Read Moisture Pressure Levels
c -----------------------------
      read(ku,1000) (levs(lev),lev=1,nlev)

c Read Moisture Amounts by Month and Level
c ----------------------------------------
      do time0=1,ntime
      read (ku,1001)
      do  lat=1,nlat
      read(ku,1000) (qz(lat,lev,time0),lev=1,nlev)
      enddo
      enddo

c Convert from Volume Mixing Ratio to Mass Mixing Ratio
c -----------------------------------------------------
      do time0 = 1,ntime
      do  lev = 1,nlev
      do  lat = 1,nlat
      qz(lat,lev,time0) = qz(lat,lev,time0)*voltomas
      enddo
      enddo
      enddo

 1000 format (3(5x,7(2x,f6.1)/))
 1001 format (1x)
      return
      end

      subroutine read_oz (ku,oz,lats,levs,nlat,nlev,ntime)
C***********************************************************************
C  PURPOSE
C     To Read Ozone Value
C
C  ARGUMENTS   DESCRIPTION
C     ku ...... Unit to Read Ozone Data
C     oz ...... Ozone Data
C     lats .... Ozone Data Latitudes (degrees)
C     levs .... Ozone Data Levels    (mb)
C     nlat .... Number of ozone latitudes
C     nlev .... Number of ozone levels
C     ntime ... Number of ozone time values
C
C***********************************************************************

      implicit none
      integer  ku,nlat,nlev,ntime

      _RL   oz(nlat,nlev,ntime)
      real*4 o3(nlat)
      _RL lats(nlat)
      _RL levs(nlev)

      integer time0
      integer lat
      integer lev
      integer nrec

      _RL plevs(34)
      data plevs/ 0.003, 0.005, 0.007, 0.01, 0.015, 0.02, 0.03, 0.05,
     .            0.07, 0.1, 0.15, 0.2, 0.3, 0.5, 0.7, 1.0, 1.5, 2.0,
     .            3.0, 5.0, 7.0, 10.0, 15.0, 20.0, 30.0, 50.0, 70.0,
     .            100.0, 150.0, 200.0, 300.0, 500.0, 700.0, 1000.0 /

c Set Ozone Data Latitudes
c ------------------------
      do   lat = 1,nlat
      lats(lat) = -90. + (lat-1)*5.
      enddo

c Set Ozone Data Levels
c ------------------------
      do   lev = 1,nlev
      levs(lev) = plevs(lev)
      enddo

c Read Ozone Amounts by Month and Level
c -------------------------------------
      close (ku)
      open(ku,file='data.gcmo3',form='unformatted',access='direct',
     .                                                 recl=nlat*4)

      do time0=1,ntime
      do lev=1,nlev
C Note: 2 quantities in Ozone Dataset
      nrec = lev+(time0-1)*nlev*2   
      read(ku,rec=nrec) o3
#if defined( _BYTESWAPIO )
      call mds_byteswapr4(nlat,o3)
#endif
           do lat=1,nlat
           oz(lat,nlev-lev+1,time0) = o3(lat)
           enddo
      enddo
      enddo

      close (ku)
      return
      end

      subroutine get_methane_n2o (pres,Nrphys,n2o,methane)
C***********************************************************************
C  PURPOSE
C     Compute methane and n2o
C
C  ARGUMENTS   DESCRIPTION
C
C***********************************************************************
C*         Climatological Annual and Global Mean Height Data           *
C***********************************************************************

      implicit none

      integer Nrphys
      _RL n2o(Nrphys),methane(Nrphys)
      _RL pres(Nrphys)
      _RL hght(Nrphys), slope,pr1,pr2,hpr1,hpr2
      integer L,L1,L2,lup,ldn

      _RL plevc (46), plevz(46)
      _RL hghtc (46), hghtz(46)

      data plevc /1000.00, 975.00, 950.00, 925.00, 900.00,
     .             875.00, 850.00, 825.00, 800.00, 750.00,
     .             700.00, 650.00, 600.00, 550.00, 500.00,
     .             450.00, 400.00, 350.00, 300.00, 250.00,
     .             200.00, 150.00, 100.00,  70.00,  50.00,
     .              40.00,  30.00,  20.00,  10.00,   7.00,
     .               5.00,   4.00,   3.00,   2.00,   1.00,
     .               0.70,   0.50,   0.40,   0.30,   0.20,
     .               0.10,   0.07,   0.05,   0.04,   0.03,
     .               0.02 /

      data hghtc/ 0.128733 , 0.316985 , 0.528275 , 0.749515 , 0.976471 ,
     .            1.208910 , 1.446800 , 1.690980 , 1.941630 , 2.463530 ,
     .            3.016200 , 3.603490 , 4.229410 , 4.899870 , 5.622320 ,
     .            6.405940 , 7.263450 , 8.211920 , 9.275540 , 10.49150 ,
     .            11.92420 , 13.70200 , 16.12980 , 18.24120 , 20.26480 ,
     .            21.63100 , 23.41250 , 25.96570 , 30.45890 , 32.85240 ,
     .            35.17360 , 36.75040 , 38.82900 , 41.84600 , 47.15580 ,
     .            49.90100 , 52.46230 , 54.13890 , 56.26340 , 59.17640 ,
     .            63.89980 , 66.20240 , 68.29210 , 69.63550 , 71.32330 ,
     .            73.62110 /

      do L=1,46
      plevz(L) = plevc(47-L)
      hghtz(L) = hghtc(47-L)
      enddo

C **********************************************************************
C                     Interpolate Heights to Model Pressures        ****
C **********************************************************************

      do L2 = 1,Nrphys

         do L1 = 1,46
            if( plevz(L1).gt.pres(L2) ) then
                if( L1.eq.1 ) then
                    lup = 1
                    ldn = 2
                else
                    lup = L1-1
                    ldn = L1
                endif
                goto 10
            endif
         enddo
         lup = 45
         ldn = 46

   10 continue
       pr1 = plevz(lup)
       pr2 = plevz(ldn)
      hpr1 = hghtz(lup)
      hpr2 = hghtz(ldn)

      slope = ( hpr1-hpr2 )/( pr1-pr2 )
      hght(L2) = hpr2 + ( pres(L2)-pr2 )*slope

      enddo

C **********************************************************************
C  Set the profiles of N2O and CH4 based on Bresser and Pawson 1996 ****
C **********************************************************************

      do L = 1,Nrphys
       if( hght(L).gt.26. ) then
        n2o(L) = 120.* exp( (26.- hght(L)) / 5.69 ) * 1.e-9
       else if( hght(L).gt.16. ) then
        n2o(L) = 307.* exp( (16.- hght(L)) /10.47 ) * 1.e-9
       else
        n2o(L) = 307.e-9
       endif
      enddo

      do L = 1,Nrphys
       if( hght(L).gt.55. ) then
        methane(L) = 0.2e-6
       else if( hght(L).gt.14. ) then
        methane(L) = 1.7* exp( (14.- hght(L)) /19.16 ) * 1.e-6
       else
        methane(L) = 1.7e-6
       endif
      enddo

      return
      end

#include "GAD_OPTIONS.h"

CBOP
C !ROUTINE: GAD_C2_ADV_X

C !INTERFACE: ==========================================================
      SUBROUTINE GAD_C2_ADV_X( 
     I           bi,bj,k,
     I           uTrans,
     I           tracer,
     O           uT,
     I           myThid )

C !DESCRIPTION:
C Calculates the area integrated zonal flux due to advection of a tracer using
C centered second-order interpolation:
C \begin{equation*}
C F^x_{adv} = U \overline{\theta}^i
C \end{equation*}

C !USES: ===============================================================
      IMPLICIT NONE
#include "SIZE.h"
#include "GRID.h"

C !INPUT PARAMETERS: ===================================================
C  bi,bj                :: tile indices
C  k                    :: vertical level
C  uTrans               :: zonal volume transport
C  tracer               :: tracer field
C  myThid               :: thread number
      INTEGER bi,bj,k
      _RL uTrans(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL tracer(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER myThid

C !OUTPUT PARAMETERS: ==================================================
C  uT                   :: zonal advective flux
      _RL uT    (1-OLx:sNx+OLx,1-OLy:sNy+OLy)

C !LOCAL VARIABLES: ====================================================
C  i,j                  :: loop indices
      INTEGER i,j
CEOP

      DO j=1-Oly,sNy+Oly
       uT(1-Olx,j)=0.
      ENDDO
      DO j=1-Oly,sNy+Oly
       DO i=1-Olx+1,sNx+Olx
        uT(i,j) = 
     &   uTrans(i,j)*(Tracer(i,j)+Tracer(i-1,j))*0.5 _d 0
       ENDDO
      ENDDO

      RETURN
      END

#include "BBL_OPTIONS.h"
C--  File bbl_tendency_apply.F: Routines to apply BBL tendencies
C--   Contents
C--   o BBL_TENDENCY_APPLY_T
C--   o BBL_TENDENCY_APPLY_S

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 0
C !ROUTINE: BBL_TENDENCY_APPLY_T

C !INTERFACE:
      SUBROUTINE BBL_TENDENCY_APPLY_T(
     U                     gT_arr,
     I                     iMin,iMax,jMin,jMax, k, bi, bj,
     I                     myTime, myIter, myThid )

C     !DESCRIPTION:
C     Add bbl tendency terms to T (theta) tendency.  Routine works
C     for one level at a time

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "GRID.h"
c#include "DYNVARS.h"
#include "BBL.h"

C     !INPUT/OUTPUT PARAMETERS:
C     gT_arr    :: the tendency array
C     iMin,iMax :: Working range of x-index for applying forcing.
C     jMin,jMax :: Working range of y-index for applying forcing.
C     k         :: Current vertical level index
C     bi,bj     :: Current tile indices
C     myTime    :: Current time in simulation
C     myIter    :: Current iteration number
C     myThid    :: my Thread Id number
      _RL     gT_arr(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER iMin, iMax, jMin, jMax
      INTEGER k, bi, bj
      _RL     myTime
      INTEGER myIter
      INTEGER myThid
CEOP

C     !LOCAL VARIABLES:
      INTEGER i, j

      DO j=jMin,jMax
       DO i=iMin,iMax
         IF ( k .EQ. kLowC(i,j,bi,bj) )
     &     gT_arr(i,j) = gT_arr(i,j)
     &       + maskC(i,j,k,bi,bj) * bbl_TendTheta(i,j,bi,bj)
       ENDDO
      ENDDO

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 0
C !ROUTINE: BBL_TENDENCY_APPLY_S

C !INTERFACE:
      SUBROUTINE BBL_TENDENCY_APPLY_S(
     U                     gS_arr,
     I                     iMin,iMax,jMin,jMax, k, bi, bj,
     I                     myTime, myIter, myThid )

C     !DESCRIPTION:
C     Add bbl tendency terms to S tendency.  Routine works for one
C     level at a time

C     !INPUT PARAMETERS:
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "GRID.h"
c#include "DYNVARS.h"
#include "BBL.h"

C     !INPUT/OUTPUT PARAMETERS:
C     gS_arr    :: the tendency array
C     iMin,iMax :: Working range of x-index for applying forcing.
C     jMin,jMax :: Working range of y-index for applying forcing.
C     k         :: Current vertical level index
C     bi,bj     :: Current tile indices
C     myTime    :: Current time in simulation
C     myIter    :: Current iteration number
C     myThid    :: my Thread Id number
      _RL     gS_arr(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER iMin, iMax, jMin, jMax
      INTEGER k, bi, bj
      _RL     myTime
      INTEGER myIter
      INTEGER myThid
CEOP

C     !LOCAL VARIABLES:
      INTEGER i, j

      DO j=jMin,jMax
       DO i=iMin,iMax
        IF ( k .EQ. kLowC(i,j,bi,bj) )
     &     gS_arr(i,j) = gS_arr(i,j)
     &       + maskC(i,j,k,bi,bj) * bbl_TendSalt(i,j,bi,bj)
       ENDDO
      ENDDO

      RETURN
      END

#include "OFFLINE_OPTIONS.h"
#ifdef ALLOW_AUTODIFF
# include "AUTODIFF_OPTIONS.h"
#endif

CBOP
C     !ROUTINE: OFFLINE_FIELDS_LOAD
C     !INTERFACE:
      SUBROUTINE OFFLINE_FIELDS_LOAD( myTime, myIter, myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE OFFLINE_FIELDS_LOAD
C     | o Control reading of fields from external source.
C     *==========================================================*
C     | Offline External source field loading routine.
C     | This routine is called every time we want to
C     | load a a set of external fields. The routine decides
C     | which fields to load and then reads them in.
C     | This routine needs to be customised for particular
C     | experiments.
C     | Notes
C     | =====
C     | currently the file names need to be specific lengths
C     | would like to make this more flexible QQ
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
c#include "GRID.h"
#include "SURFACE.h"
#include "DYNVARS.h"
#include "FFIELDS.h"
#ifdef ALLOW_GMREDI
#include "GMREDI.h"
#endif
#ifdef ALLOW_KPP
#include "KPP.h"
#endif
#ifdef ALLOW_OFFLINE
#include "OFFLINE.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
C     myTime  :: Simulation time
C     myIter  :: Simulation timestep number
C     myThid  :: Thread no. that called this routine.
      _RL     myTime
      INTEGER myIter
      INTEGER myThid
CEOP

#ifdef ALLOW_OFFLINE
C     !FUNCTIONS:
      INTEGER  IFNBLNK, ILNBLNK
      EXTERNAL IFNBLNK, ILNBLNK

C     !LOCAL VARIABLES:
C     fn      :: Temp. for building file name.
C     msgBuf  :: Informational/error message buffer
      CHARACTER*(MAX_LEN_FNAM) fn
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      INTEGER prec

      INTEGER bi,bj,i,j,k
      INTEGER intimeP, intime0, intime1
      _RL aWght, bWght, locTime
      INTEGER Ifprd
      INTEGER I1, I2

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      prec = offlineLoadPrec

c      IF ( offlinePeriodicExternalLoad ) THEN
      IF ( .TRUE. ) THEN

C--   First call requires that we initialize everything to zero for safety
C      <= already done in OFFLINE_INIT_VARIA

C--   Now calculate whether it is time to update the forcing arrays
      locTime = myTime - offlineTimeOffset
      CALL GET_PERIODIC_INTERVAL(
     O                  intimeP, intime0, intime1, bWght, aWght,
     I                  offlineForcingCycle, offlineForcingPeriod,
     I                  deltaToffline, locTime, myThid )

      bi = myBxLo(myThid)
      bj = myByLo(myThid)
#ifdef ALLOW_DEBUG
      IF ( debugLevel.GE.debLevB ) THEN
        _BEGIN_MASTER(myThid)
        WRITE(standardMessageUnit,'(A,I10,A,4I5,A,2F14.10)')
     &   ' OFFLINE_FIELDS_LOAD,', myIter,
     &   ' : iP,iLd,i0,i1=', intimeP, offlineLdRec(bi,bj),
     &    intime0,intime1, ' ; Wght=', bWght, aWght
        _END_MASTER(myThid)
      ENDIF
#endif /* ALLOW_DEBUG */

#ifdef ALLOW_AUTODIFF_TAMC
C-    assuming that we call S/R OFFLINE_FIELDS_LOAD at each time-step and
C     with increasing time, this will catch when we need to load new records;
C     But with Adjoint run, this is not always the case => might end-up using
C     the wrong time-records
      IF ( intime0.NE.intimeP .OR. myIter.EQ.nIter0 ) THEN
#else /* ALLOW_AUTODIFF_TAMC */
C-    Make no assumption on sequence of calls to OFFLINE_FIELDS_LOAD ;
C     This is the correct formulation (works in Adjoint run).
C     Unfortunatly, produces many recomputations <== not used until it is fixed
      IF ( intime1.NE.offlineLdRec(bi,bj) ) THEN
#endif /* ALLOW_AUTODIFF_TAMC */

       Ifprd = NINT(offlineForcingPeriod/deltaToffline)
       IF ( Ifprd*deltaToffline .NE. offlineForcingPeriod ) THEN
        WRITE(msgBuf,'(2A,I5,A)') 'OFFLINE_FIELDS_LOAD: ',
     &     'offlineForcingPeriod not multiple of deltaToffline'
        CALL PRINT_ERROR( msgBuf, myThid )
        STOP 'ABNORMAL END: S/R OFFLINE_FIELDS_LOAD'
       ENDIF

C--   If the above condition is met then we need to read in
C     data for the period ahead and the period behind myTime.
       IF ( debugLevel.GE.debLevZero ) THEN
        _BEGIN_MASTER(myThid)
        WRITE(standardMessageUnit,'(A,I10,A,2(2I5,A))')
     &   ' OFFLINE_FIELDS_LOAD, it=', myIter,
     &   ' : Reading new data, i0,i1=', intime0, intime1,
     &    ' (prev=', intimeP, offlineLdRec(bi,bj), ' )'
        _END_MASTER(myThid)
       ENDIF

       _BARRIER

#ifdef NOT_MODEL_FILES
C if reading own files setup reading here
#else

C--   Read in 3-D fields and apply EXCH

       IF ( Uvelfile .NE. ' '  ) THEN
        I1=IFNBLNK(Uvelfile)
        I2=ILNBLNK(Uvelfile)
        WRITE(fn,'(A,A,I10.10)') Uvelfile(I1:I2),'.',
     &        intime0*Ifprd +offlineIter0
c       print*,'OFFLINE READ', fn
        CALL READ_REC_3D_RS( fn, prec, Nr, uvel0, 1, myIter, myThid )
        WRITE(fn,'(A,A,I10.10)') Uvelfile(I1:I2),'.',
     &        intime1*Ifprd +offlineIter0
c       print*,'OFFLINE READ', fn
        CALL READ_REC_3D_RS( fn, prec, Nr, uvel1, 1, myIter, myThid )
       ENDIF
       IF ( Vvelfile .NE. ' '  ) THEN
        I1=IFNBLNK(Vvelfile)
        I2=ILNBLNK(Vvelfile)
        WRITE(fn,'(A,A,I10.10)') Vvelfile(I1:I2),'.',
     &        intime0*Ifprd +offlineIter0
        CALL READ_REC_3D_RS( fn, prec, Nr, vvel0, 1, myIter, myThid )
        WRITE(fn,'(A,A,I10.10)') Vvelfile(I1:I2),'.',
     &        intime1*Ifprd +offlineIter0
        CALL READ_REC_3D_RS( fn, prec, Nr, vvel1, 1, myIter, myThid )
       ENDIF
       IF ( Uvelfile .NE. ' ' .OR. Vvelfile .NE. ' '  ) THEN
        CALL EXCH_UV_XYZ_RS( uvel0, vvel0, .TRUE., myThid )
        CALL EXCH_UV_XYZ_RS( uvel1, vvel1, .TRUE., myThid )
       ENDIF

       IF ( Wvelfile .NE. ' '  ) THEN
        I1=IFNBLNK(Wvelfile)
        I2=ILNBLNK(Wvelfile)
        WRITE(fn,'(A,A,I10.10)') Wvelfile(I1:I2),'.',
     &        intime0*Ifprd +offlineIter0
        CALL READ_REC_3D_RS( fn, prec, Nr, wvel0, 1, myIter, myThid )
        WRITE(fn,'(A,A,I10.10)') Wvelfile(I1:I2),'.',
     &        intime1*Ifprd +offlineIter0
        CALL READ_REC_3D_RS( fn, prec, Nr, wvel1, 1, myIter, myThid )
        _EXCH_XYZ_RS(wvel0, myThid )
        _EXCH_XYZ_RS(wvel1, myThid )
       ENDIF

       IF ( Thetfile .NE. ' '  ) THEN
        I1=IFNBLNK(Thetfile)
        I2=ILNBLNK(Thetfile)
        WRITE(fn,'(A,A,I10.10)') Thetfile(I1:I2),'.',
     &        intime0*Ifprd +offlineIter0
        CALL READ_REC_3D_RS( fn, prec, Nr, tave0, 1, myIter, myThid )
        WRITE(fn,'(A,A,I10.10)') Thetfile(I1:I2),'.',
     &        intime1*Ifprd +offlineIter0
        CALL READ_REC_3D_RS( fn, prec, Nr, tave1, 1, myIter, myThid )
        _EXCH_XYZ_RS(tave0 , myThid )
        _EXCH_XYZ_RS(tave1 , myThid )
       ENDIF

       IF ( Saltfile .NE. ' ' ) THEN
        I1=IFNBLNK(Saltfile)
        I2=ILNBLNK(Saltfile)
        WRITE(fn,'(A,A,I10.10)') Saltfile(I1:I2),'.',
     &        intime0*Ifprd +offlineIter0
        CALL READ_REC_3D_RS( fn, prec, Nr, save0, 1, myIter, myThid )
        WRITE(fn,'(A,A,I10.10)') Saltfile(I1:I2),'.',
     &        intime1*Ifprd +offlineIter0
        CALL READ_REC_3D_RS( fn, prec, Nr, save1, 1, myIter, myThid )
        _EXCH_XYZ_RS(save0, myThid )
        _EXCH_XYZ_RS(save1, myThid )
       ENDIF

#ifdef ALLOW_GMREDI
       IF ( GMwxFile .NE. ' ' ) THEN
        I1=IFNBLNK(GMwxFile)
        I2=ILNBLNK(GMwxFile)
        WRITE(fn,'(A,A,I10.10)') GMwxFile(I1:I2),'.',
     &        intime0*Ifprd +offlineIter0
        CALL READ_REC_3D_RS( fn, prec, Nr, gmkx0, 1, myIter, myThid )
        WRITE(fn,'(A,A,I10.10)') GMwxFile(I1:I2),'.',
     &        intime1*Ifprd +offlineIter0
        CALL READ_REC_3D_RS( fn, prec, Nr, gmkx1, 1, myIter, myThid )
       ENDIF
       IF ( GMwyFile .NE. ' ' ) THEN
        I1=IFNBLNK(GMwyFile)
        I2=ILNBLNK(GMwyFile)
        WRITE(fn,'(A,A,I10.10)') GMwyFile(I1:I2),'.',
     &        intime0*Ifprd +offlineIter0
        CALL READ_REC_3D_RS( fn, prec, Nr, gmky0, 1, myIter, myThid )
        WRITE(fn,'(A,A,I10.10)') GMwyFile(I1:I2),'.',
     &        intime1*Ifprd +offlineIter0
        CALL READ_REC_3D_RS( fn, prec, Nr, gmky1, 1, myIter, myThid )
       ENDIF
       IF ( GMwxFile .NE. ' ' .OR. GMwyFile .NE. ' ' ) THEN
        CALL EXCH_UV_AGRID_3D_RS( gmkx0, gmky0, .FALSE., Nr, myThid )
        CALL EXCH_UV_AGRID_3D_RS( gmkx1, gmky1, .FALSE., Nr, myThid )
       ENDIF

       IF ( GMwzFile       .NE. ' ') THEN
        I1=IFNBLNK(GMwzFile)
        I2=ILNBLNK(GMwzFile)
        WRITE(fn,'(A,A,I10.10)') GMwzFile(I1:I2),'.',
     &        intime0*Ifprd +offlineIter0
        CALL READ_REC_3D_RS( fn, prec, Nr, gmkz0, 1, myIter, myThid )
        WRITE(fn,'(A,A,I10.10)') GMwzFile(I1:I2),'.',
     &        intime1*Ifprd +offlineIter0
        CALL READ_REC_3D_RS( fn, prec, Nr, gmkz1, 1, myIter, myThid )
        _EXCH_XYZ_RS(gmkz0, myThid )
        _EXCH_XYZ_RS(gmkz1, myThid )
       ENDIF
#endif /* ALLOW_GMREDI */

       IF ( ConvFile .NE. ' ' ) THEN
        I1=IFNBLNK(ConvFile)
        I2=ILNBLNK(ConvFile)
        WRITE(fn,'(A,A,I10.10)') ConvFile(I1:I2),'.',
     &        intime0*Ifprd +offlineIter0
        CALL READ_REC_3D_RS( fn, prec, Nr, conv0, 1, myIter, myThid )
        WRITE(fn,'(A,A,I10.10)') ConvFile(I1:I2),'.',
     &        intime1*Ifprd +offlineIter0
        CALL READ_REC_3D_RS( fn, prec, Nr, conv1, 1, myIter, myThid )
        _EXCH_XYZ_RS(conv0, myThid )
        _EXCH_XYZ_RS(conv1, myThid )
       ENDIF

#ifdef ALLOW_KPP
       IF ( KPP_DiffSFile .NE. ' ' ) THEN
        I1=IFNBLNK(KPP_DiffSFile)
        I2=ILNBLNK(KPP_DiffSFile)
        WRITE(fn,'(A,A,I10.10)') KPP_DiffSFile(I1:I2),'.',
     &        intime0*Ifprd +offlineIter0
        CALL READ_REC_3D_RS( fn, prec, Nr, kdfs0, 1, myIter, myThid )
        WRITE(fn,'(A,A,I10.10)') KPP_DiffSFile(I1:I2),'.',
     &        intime1*Ifprd +offlineIter0
        CALL READ_REC_3D_RS( fn, prec, Nr, kdfs1, 1, myIter, myThid )
        _EXCH_XYZ_RS(kdfs0 , myThid )
        _EXCH_XYZ_RS(kdfs1 , myThid )
       ENDIF

       IF ( KPP_ghatKFile .NE. ' ' ) THEN
C-- Note: assume that KPP_ghatKFile contains the product ghat*diffKzS
C         even if, for convienience, it will be loaded into array KPPghat
        I1=IFNBLNK(KPP_ghatKFile)
        I2=ILNBLNK(KPP_ghatKFile)
        WRITE(fn,'(A,A,I10.10)') KPP_ghatKFile(I1:I2),'.',
     &        intime0*Ifprd +offlineIter0
        CALL READ_REC_3D_RS( fn, prec, Nr, kght0, 1, myIter, myThid )
        WRITE(fn,'(A,A,I10.10)') KPP_ghatKFile(I1:I2),'.',
     &        intime1*Ifprd +offlineIter0
        CALL READ_REC_3D_RS( fn, prec, Nr, kght1, 1, myIter, myThid )
        _EXCH_XYZ_RS(kght0, myThid )
        _EXCH_XYZ_RS(kght1, myThid )
       ENDIF
#endif /* ALLOW_KPP */

C--   Read in 2-D fields and apply EXCH

c      IF ( HFluxFile .NE. ' ' ) THEN
c       I1=IFNBLNK(HFluxFile)
c       I2=ILNBLNK(HFluxFile)
c       WRITE(fn,'(A,A,I10.10)') HFluxFile(I1:I2),'.',
c    &        intime0*Ifprd +offlineIter0
c       CALL READ_REC_3D_RS( fn, prec,  1, hflx0, 1, myIter, myThid )
c       WRITE(fn,'(A,A,I10.10)') HFluxFile(I1:I2),'.',
c    &        intime1*Ifprd +offlineIter0
c       CALL READ_REC_3D_RS( fn, prec,  1, hflx1, 1, myIter, myThid )
c       _EXCH_XY_RS(hflx0 , myThid )
c       _EXCH_XY_RS(hflx1 , myThid )
c      ENDIF

       IF ( SFluxFile .NE. ' ' ) THEN
        I1=IFNBLNK(SFluxFile)
        I2=ILNBLNK(SFluxFile)
        WRITE(fn,'(A,A,I10.10)') SFluxFile(I1:I2),'.',
     &        intime0*Ifprd +offlineIter0
        CALL READ_REC_3D_RS( fn, prec,  1, sflx0, 1, myIter, myThid )
        WRITE(fn,'(A,A,I10.10)') SFluxFile(I1:I2),'.',
     &        intime1*Ifprd +offlineIter0
        CALL READ_REC_3D_RS( fn, prec,  1, sflx1, 1, myIter, myThid )
        _EXCH_XY_RS(sflx0, myThid )
        _EXCH_XY_RS(sflx1, myThid )
       ENDIF

c      IF ( IceFile .NE. ' ' ) THEN
c       I1=IFNBLNK(IceFile)
c       I2=ILNBLNK(IceFile)
c       WRITE(fn,'(A,A,I10.10)') IceFile(I1:I2),'.',
c    &        intime0*Ifprd +offlineIter0
c       CALL READ_REC_3D_RS( fn, prec,  1, icem0, 1, myIter, myThid )
c       WRITE(fn,'(A,A,I10.10)') IceFile(I1:I2),'.',
c    &        intime1*Ifprd +offlineIter0
c       CALL READ_REC_3D_RS( fn, prec,  1, icem1, 1, myIter, myThid )
c       _EXCH_XY_RS(icem0, myThid )
c       _EXCH_XY_RS(icem1, myThid )
c      ENDIF

#endif /* else NOT_MODEL_FILES */

C-    save newly loaded time-record
       DO bj = myByLo(myThid), myByHi(myThid)
         DO bi = myBxLo(myThid), myBxHi(myThid)
           offlineLdRec(bi,bj) = intime1
         ENDDO
       ENDDO

C--   end if-block for loading new time-records
      ENDIF

C--   Save time-interpolation weights
      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
         offline_Wght(1,bi,bj) = bWght
         offline_Wght(2,bi,bj) = aWght
       ENDDO
      ENDDO

C--   Interpolate State Variables: uvel, vvel, wvel
      IF ( myIter.NE.nIter0 .OR. nonlinFreeSurf.LE.0 ) THEN
C     Skip initial (nIter0) setting of state vars if loaded from pickup-files
C     (as it is the case when using Non-Lin Free-Surf)
       DO bj = myByLo(myThid), myByHi(myThid)
        DO bi = myBxLo(myThid), myBxHi(myThid)

         DO k=1,Nr
          DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
             uVel(i,j,k,bi,bj) = bWght*uvel0(i,j,k,bi,bj)
     &                         + aWght*uvel1(i,j,k,bi,bj)
             vVel(i,j,k,bi,bj) = bWght*vvel0(i,j,k,bi,bj)
     &                         + aWght*vvel1(i,j,k,bi,bj)
             wVel(i,j,k,bi,bj) = bWght*wvel0(i,j,k,bi,bj)
     &                         + aWght*wvel1(i,j,k,bi,bj)
             theta(i,j,k,bi,bj)= bWght*tave0(i,j,k,bi,bj)
     &                         + aWght*tave1(i,j,k,bi,bj)
             salt(i,j,k,bi,bj) = bWght*save0(i,j,k,bi,bj)
     &                         + aWght*save1(i,j,k,bi,bj)
           ENDDO
          ENDDO
         ENDDO
#ifdef NONLIN_FRSURF
         IF ( select_rStar.GT.0 ) THEN
          DO k=1,Nr
           DO j=1-OLy,sNy+OLy
            DO i=1-OLx,sNx+OLx
              uVel(i,j,k,bi,bj) = uVel(i,j,k,bi,bj)
     &                          / rStarFacW(i,j,bi,bj)
              vVel(i,j,k,bi,bj) = vVel(i,j,k,bi,bj)
     &                          / rStarFacS(i,j,bi,bj)
            ENDDO
           ENDDO
          ENDDO
         ELSEIF ( nonlinFreeSurf.GT.0 ) THEN
          STOP 'OFFLINE_FIELDS_LOAD: r-Coord NLFS code missing'
         ENDIF
#endif /* NONLIN_FRSURF */

C--   end bi,bj loops
        ENDDO
       ENDDO
      ENDIF

C-- Diagnostics
C      IF (myThid.EQ.1 .AND. myTime.LT.62208000.) THEN
C        write(*,'(a,1p5e12.4,3i6,2e12.4)')
C     &   'time,U,V,W,i0,i1,a,b = ',
C     &   myTime,
C     &   Uvel(1,sNy,1,1,1),Vvel(1,sNy,1,1,1),
C     &   Wvel(1,sNy,1,1,1),
C     &   intime0,intime1,aWght,bWght
C        write(*,'(a,1p4e12.4,2e12.4)')
C     &   'time,uvel0,uvel1,U = ',
C     &   myTime,
C     &   uvel0(1,sNy,1,1,1),uvel1(1,sNy,1,1,1),Uvel(1,sNy,1,1,1),
C     &   aWght,bWght
C      ENDIF

C endif for periodicForcing
      ENDIF

#endif /* ALLOW_OFFLINE */

      RETURN
      END

#include "SEAICE_OPTIONS.h"

CBOP
C     !ROUTINE: SEAICE_TURNOFF_IO
C     !INTERFACE:
      SUBROUTINE SEAICE_TURNOFF_IO( seqFlag, myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE SEAICE_TURNOFF_IO
C     | o Turn off some of the seaice output flags
C     *==========================================================*
C     | Used in adjoint simulation (and called after the first
C     |  forward sweep) to avoid writing output multiple times (if
C     |  recomputations and/or grdchk) with the same iter number.
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
c#include "PARAMS.h"
#include "SEAICE_SIZE.h"
#include "SEAICE_PARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     seqFlag :: flag that indicates where this S/R is called from:
C             :: =0 called at the end of S/R COST_FINAL
C             :: =1 called at initialisation when using DIVA
C     myThid  :: My Thread Id number
      INTEGER seqFlag
      INTEGER myThid

C     !LOCAL VARIABLES:
C     == Local variables ==
c     CHARACTER*(MAX_LEN_MBUF) msgBuf
CEOP

C--   only master-thread resets shared flags (in common block)
      _BEGIN_MASTER( myThid )

C--   Set output freq. to zero to avoid re-write of
C     averaged fields in reverse checkpointing loops
      SEAICE_monFreq  = 0.
      SEAICE_dumpFreq = 0.

      _END_MASTER( myThid )

      RETURN
      END

#include "PACKAGES_CONFIG.h"
#include "CPP_OPTIONS.h"
#ifdef ALLOW_AUTODIFF
# include "AUTODIFF_OPTIONS.h"
#endif

CBOP
C     !ROUTINE: CALC_VISCOSITY
C     !INTERFACE:
      SUBROUTINE CALC_VISCOSITY(
     I           bi,bj, iMin,iMax,jMin,jMax,
     O           kappaRU, kappaRV,
     I           myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE CALC_VISCOSITY
C     | o Calculate net vertical viscosity
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     == GLobal variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "DYNVARS.h"
#include "GRID.h"
#ifndef EXCLUDE_PCELL_MIX_CODE
# ifdef ALLOW_AUTODIFF
#  include "tamc.h"
# endif
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     iMin,iMax,jMin,jMax :: Range of points for which calculation
C     bi,bj   :: current tile indices
C     kappaRU :: Total vertical viscosity for zonal flow.
C     kappaRV :: Total vertical viscosity for meridional flow.
C     myThid  :: my Thread Id number
      INTEGER iMin,iMax,jMin,jMax
      INTEGER bi,bj
      _RL kappaRU(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr+1)
      _RL kappaRV(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr+1)
      INTEGER myThid

C     !LOCAL VARIABLES:
C     == Local variables ==
C     i, j, k :: Loop counters
      INTEGER i,j,k
      INTEGER ki
#ifndef EXCLUDE_PCELL_MIX_CODE
      INTEGER km, mixSurf, mixBott
      _RL pC_kFac
      _RL tmpFac(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
# ifdef ALLOW_AUTODIFF_TAMC
C     tkey :: tape key (tile dependent)
C     kkey :: tape key (level and tile dependent)
      INTEGER tkey, kkey
# endif
#endif
CEOP

      DO k = 1,Nr+1
       ki = MIN(k,Nr)

       DO j = 1-OLy, sNy+OLy
        DO i = 1-OLx, sNx+OLx
         kappaRU(i,j,k) = viscArNr(ki)
         kappaRV(i,j,k) = viscArNr(ki)
        ENDDO
       ENDDO

#ifdef ALLOW_KPP
       IF ( useKPP .AND. k.LE.Nr ) THEN
         CALL KPP_CALC_VISC(
     I        bi,bj, iMin,iMax,jMin,jMax, k,
     O        kappaRU, kappaRV,
     I        myThid)
       ENDIF
#endif

#ifdef ALLOW_PP81
       IF ( usePP81 .AND. k.LE.Nr ) THEN
         CALL PP81_CALC_VISC(
     I        bi,bj, iMin,iMax,jMin,jMax, k,
     O        kappaRU, kappaRV,
     I        myThid)
       ENDIF
#endif

#ifdef ALLOW_KL10
       IF ( useKL10 .AND. k.LE.Nr ) THEN
         CALL KL10_CALC_VISC(
     I        bi,bj, iMin,iMax,jMin,jMax, k,
     O        kappaRU, kappaRV,
     I        myThid)
       ENDIF
#endif

#ifdef ALLOW_MY82
       IF ( useMY82 .AND. k.LE.Nr ) THEN
         CALL MY82_CALC_VISC(
     I        bi,bj, iMin,iMax,jMin,jMax, k,
     O        kappaRU, kappaRV,
     I        myThid)
       ENDIF
#endif

#ifdef ALLOW_GGL90
       IF ( useGGL90 .AND. k.LE.Nr ) THEN
         CALL GGL90_CALC_VISC(
     I        bi,bj, iMin,iMax,jMin,jMax, k,
     O        kappaRU, kappaRV,
     I        myThid)
       ENDIF
#endif

       IF ( k.EQ.Nr+1 .AND.
     &     ( usePP81 .OR. useKL10 .OR. useMY82 .OR. useGGL90 )
     &    ) THEN
        DO j = 1-OLy, sNy+OLy
         DO i = 1-OLx, sNx+OLx
          kappaRU(i,j,k) = kappaRU(i,j,ki)
          kappaRV(i,j,k) = kappaRV(i,j,ki)
         ENDDO
        ENDDO
       ENDIF

C--   end of k loop
      ENDDO

#ifndef EXCLUDE_PCELL_MIX_CODE
# ifdef ALLOW_AUTODIFF_TAMC
      tkey = bi + (bj-1)*nSx + (ikey_dynamics-1)*nSx*nSy
CADJ STORE kappaRU = comlev1_bibj, key = tkey, kind = isbyte
CADJ STORE kappaRV = comlev1_bibj, key = tkey, kind = isbyte
# endif
      IF ( interViscAr_pCell ) THEN
C--   This is a hack: alter vertical viscosity (instead of changing many S/R)
C     in order to account for missing hFac in viscous term
       DO k = 2,Nr
         km = k - 1
C-    account for true distance (including hFac) in vertical gradient
         DO j = 2-OLy, sNy+OLy
          DO i = 2-OLx, sNx+OLx
           IF ( k.GT.kSurfW(i,j,bi,bj) .AND.
     &          k.LE.MIN( kLowC(i,j,bi,bj), kLowC(i-1,j,bi,bj) )
     &        ) THEN
             kappaRU(i,j,k) = kappaRU(i,j,k)
     &                *twoRL/(hFacW(i,j,km,bi,bj)+hFacW(i,j,k,bi,bj))
           ENDIF
          ENDDO
         ENDDO
         DO j = 2-OLy, sNy+OLy
          DO i = 2-OLx, sNx+OLx
           IF ( k.GT.kSurfS(i,j,bi,bj) .AND.
     &          k.LE.MIN( kLowC(i,j,bi,bj), kLowC(i,j-1,bi,bj) )
     &        ) THEN
             kappaRV(i,j,k) = kappaRV(i,j,k)
     &                *twoRL/(hFacS(i,j,km,bi,bj)+hFacS(i,j,k,bi,bj))
           ENDIF
          ENDDO
         ENDDO
       ENDDO
      ENDIF

      IF ( pCellMix_select.GT.0 ) THEN
C--   This is a hack: alter vertical viscosity (instead of changing many S/R)
C     in order to to increase mixing for too thin surface/bottom partial cell
       mixSurf = pCellMix_select/10
       mixBott = MOD(pCellMix_select,10)
       DO k = 2,Nr
# ifdef ALLOW_AUTODIFF_TAMC
         kkey = k + (tkey-1)*Nr
# endif
         km = k - 1
         pC_kFac = 1.
         IF ( pCellMix_delR.LT.drF(k) )
     &     pC_kFac = pCellMix_delR*recip_drF(k)

C-    Increase KappaRU above bottom level:
         IF ( mixBott.GE.1 ) THEN
          DO j = 2-OLy, sNy+OLy
           DO i = 2-OLx, sNx+OLx
             tmpFac(i,j) = 0. _d 0
             IF ( k.EQ.MIN( kLowC(i,j,bi,bj), kLowC(i-1,j,bi,bj) )
     &        .AND. k.GT.kSurfW(i,j,bi,bj) ) THEN
               tmpFac(i,j) = pC_kFac*_recip_hFacW(i,j,k,bi,bj)
             ENDIF
           ENDDO
          ENDDO
          IF ( mixBott.EQ.2 ) THEN
           DO j = 2-OLy, sNy+OLy
            DO i = 2-OLx, sNx+OLx
             tmpFac(i,j) = tmpFac(i,j)*tmpFac(i,j)
            ENDDO
           ENDDO
          ELSEIF ( mixBott.EQ.3 ) THEN
           DO j = 2-OLy, sNy+OLy
            DO i = 2-OLx, sNx+OLx
             tmpFac(i,j) = tmpFac(i,j)*tmpFac(i,j)*tmpFac(i,j)
            ENDDO
           ENDDO
          ELSEIF ( mixBott.EQ.4 ) THEN
           DO j = 2-OLy, sNy+OLy
            DO i = 2-OLx, sNx+OLx
             tmpFac(i,j) = tmpFac(i,j)*tmpFac(i,j)
     &                    *tmpFac(i,j)*tmpFac(i,j)
            ENDDO
           ENDDO
          ENDIF
C-    increase mixing above bottom (by ~(1/hFac)^mixBott) if too thin p-cell
          DO j = 2-OLy, sNy+OLy
           DO i = 2-OLx, sNx+OLx
             tmpFac(i,j) = MIN( tmpFac(i,j), pCellMix_maxFac )
# ifdef ALLOW_AUTODIFF_TAMC
           ENDDO
          ENDDO
CADJ STORE tmpFac         = comlev1_bibj_k, key = kkey, kind = isbyte
CADJ STORE kappaRU(:,:,k) = comlev1_bibj_k, key = kkey, kind = isbyte
          DO j = 2-OLy, sNy+OLy
           DO i = 2-OLx, sNx+OLx
# endif
             kappaRU(i,j,k) = MAX( kappaRU(i,j,k),
     &                             pCellMix_viscAr(k)*tmpFac(i,j) )
           ENDDO
          ENDDO
         ENDIF

C-    Increase KappaRV above bottom level:
         IF ( mixBott.GE.1 ) THEN
          DO j = 2-OLy, sNy+OLy
           DO i = 2-OLx, sNx+OLx
             tmpFac(i,j) = 0. _d 0
             IF ( k.EQ.MIN( kLowC(i,j,bi,bj), kLowC(i,j-1,bi,bj) )
     &        .AND. k.GT.kSurfS(i,j,bi,bj) ) THEN
               tmpFac(i,j) = pC_kFac*_recip_hFacS(i,j,k,bi,bj)
             ENDIF
           ENDDO
          ENDDO
          IF ( mixBott.EQ.2 ) THEN
           DO j = 2-OLy, sNy+OLy
            DO i = 2-OLx, sNx+OLx
             tmpFac(i,j) = tmpFac(i,j)*tmpFac(i,j)
            ENDDO
           ENDDO
          ELSEIF ( mixBott.EQ.3 ) THEN
           DO j = 2-OLy, sNy+OLy
            DO i = 2-OLx, sNx+OLx
             tmpFac(i,j) = tmpFac(i,j)*tmpFac(i,j)*tmpFac(i,j)
            ENDDO
           ENDDO
          ELSEIF ( mixBott.EQ.4 ) THEN
           DO j = 2-OLy, sNy+OLy
            DO i = 2-OLx, sNx+OLx
             tmpFac(i,j) = tmpFac(i,j)*tmpFac(i,j)
     &                    *tmpFac(i,j)*tmpFac(i,j)
            ENDDO
           ENDDO
          ENDIF
C-    increase mixing above bottom (by ~(1/hFac)^mixBott) if too thin p-cell
          DO j = 2-OLy, sNy+OLy
           DO i = 2-OLx, sNx+OLx
             tmpFac(i,j) = MIN( tmpFac(i,j), pCellMix_maxFac )
# ifdef ALLOW_AUTODIFF_TAMC
           ENDDO
          ENDDO
CADJ STORE tmpFac         = comlev1_bibj_k, key = kkey, kind = isbyte
CADJ STORE kappaRV(:,:,k) = comlev1_bibj_k, key = kkey, kind = isbyte
          DO j = 2-OLy, sNy+OLy
           DO i = 2-OLx, sNx+OLx
# endif
             kappaRV(i,j,k) = MAX( kappaRV(i,j,k),
     &                             pCellMix_viscAr(k)*tmpFac(i,j) )
           ENDDO
          ENDDO
         ENDIF

         pC_kFac = 1.
         IF ( pCellMix_delR.LT.drF(km) )
     &     pC_kFac = pCellMix_delR*recip_drF(km)

C-    Increase KappaRU below surface level:
         IF ( mixSurf.GE.1 ) THEN
          DO j = 2-OLy, sNy+OLy
           DO i = 2-OLx, sNx+OLx
             tmpFac(i,j) = 0. _d 0
             IF ( km.EQ.kSurfW(i,j,bi,bj) .AND.
     &            km.LT.MIN( kLowC(i,j,bi,bj), kLowC(i-1,j,bi,bj) )
     &          ) THEN
               tmpFac(i,j) = pC_kFac*_recip_hFacW(i,j,km,bi,bj)
             ENDIF
           ENDDO
          ENDDO
          IF ( mixSurf.EQ.2 ) THEN
           DO j = 2-OLy, sNy+OLy
            DO i = 2-OLx, sNx+OLx
             tmpFac(i,j) = tmpFac(i,j)*tmpFac(i,j)
            ENDDO
           ENDDO
          ELSEIF ( mixSurf.EQ.3 ) THEN
           DO j = 2-OLy, sNy+OLy
            DO i = 2-OLx, sNx+OLx
             tmpFac(i,j) = tmpFac(i,j)*tmpFac(i,j)*tmpFac(i,j)
            ENDDO
           ENDDO
          ELSEIF ( mixSurf.EQ.4 ) THEN
           DO j = 2-OLy, sNy+OLy
            DO i = 2-OLx, sNx+OLx
             tmpFac(i,j) = tmpFac(i,j)*tmpFac(i,j)
     &                    *tmpFac(i,j)*tmpFac(i,j)
            ENDDO
           ENDDO
          ENDIF
C-    increase mixing below surface (by ~(1/hFac)^mixSurf) if too thin p-cell
# ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE tmpFac = comlev1_bibj_k, key = kkey, kind = isbyte
# endif
          DO j = 2-OLy, sNy+OLy
           DO i = 2-OLx, sNx+OLx
             tmpFac(i,j) = MIN( tmpFac(i,j), pCellMix_maxFac )
# ifdef ALLOW_AUTODIFF_TAMC
           ENDDO
          ENDDO
CADJ STORE tmpFac         = comlev1_bibj_k, key = kkey, kind = isbyte
CADJ STORE kappaRU(:,:,k) = comlev1_bibj_k, key = kkey, kind = isbyte
          DO j = 2-OLy, sNy+OLy
           DO i = 2-OLx, sNx+OLx
# endif
             kappaRU(i,j,k) = MAX( kappaRU(i,j,k),
     &                             pCellMix_viscAr(k)*tmpFac(i,j) )
           ENDDO
          ENDDO
         ENDIF

C-    Increase KappaRV below surface level:
         IF ( mixSurf.GE.1 ) THEN
          DO j = 2-OLy, sNy+OLy
           DO i = 2-OLx, sNx+OLx
             tmpFac(i,j) = 0. _d 0
             IF ( km.EQ.kSurfS(i,j,bi,bj) .AND.
     &            km.LT.MIN( kLowC(i,j,bi,bj), kLowC(i,j-1,bi,bj) )
     &          ) THEN
               tmpFac(i,j) = pC_kFac*_recip_hFacS(i,j,km,bi,bj)
             ENDIF
           ENDDO
          ENDDO
          IF ( mixSurf.EQ.2 ) THEN
           DO j = 2-OLy, sNy+OLy
            DO i = 2-OLx, sNx+OLx
             tmpFac(i,j) = tmpFac(i,j)*tmpFac(i,j)
            ENDDO
           ENDDO
          ELSEIF ( mixSurf.EQ.3 ) THEN
           DO j = 2-OLy, sNy+OLy
            DO i = 2-OLx, sNx+OLx
             tmpFac(i,j) = tmpFac(i,j)*tmpFac(i,j)*tmpFac(i,j)
            ENDDO
           ENDDO
          ELSEIF ( mixSurf.EQ.4 ) THEN
           DO j = 2-OLy, sNy+OLy
            DO i = 2-OLx, sNx+OLx
             tmpFac(i,j) = tmpFac(i,j)*tmpFac(i,j)
     &                    *tmpFac(i,j)*tmpFac(i,j)
            ENDDO
           ENDDO
          ENDIF
C-    increase mixing below surface (by ~(1/hFac)^mixSurf) if too thin p-cell
# ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE tmpFac = comlev1_bibj_k, key = kkey, kind = isbyte
# endif
          DO j = 2-OLy, sNy+OLy
           DO i = 2-OLx, sNx+OLx
             tmpFac(i,j) = MIN( tmpFac(i,j), pCellMix_maxFac )
# ifdef ALLOW_AUTODIFF_TAMC
           ENDDO
          ENDDO
CADJ STORE tmpFac         = comlev1_bibj_k, key = kkey, kind = isbyte
CADJ STORE kappaRV(:,:,k) = comlev1_bibj_k, key = kkey, kind = isbyte
          DO j = 2-OLy, sNy+OLy
           DO i = 2-OLx, sNx+OLx
# endif
             kappaRV(i,j,k) = MAX( kappaRV(i,j,k),
     &                             pCellMix_viscAr(k)*tmpFac(i,j) )
           ENDDO
          ENDDO
         ENDIF

C--   end of k loop
       ENDDO
      ENDIF
#endif /* ndef EXCLUDE_PCELL_MIX_CODE */

      RETURN
      END

#include "SEAICE_OPTIONS.h"
#ifdef ALLOW_AUTODIFF
# include "AUTODIFF_OPTIONS.h"
#endif

CBOP
C     !ROUTINE: SEAICE_DYNSOLVER
C     !INTERFACE:
      SUBROUTINE SEAICE_DYNSOLVER( myTime, myIter, myThid )

C     !DESCRIPTION:
C     *=============================================================*
C     | SUBROUTINE SEAICE_DYNSOLVER                                 |
C     | C-grid version of ice dynamics using either                 |
C     | o free drift                                                |
C     | o LSR solver, Zhang and Hibler, JGR, 102, 8691-8702, 1997   |
C     | o Krylov solver, after Lemieux and Tremblay, JGR, 114, 2009 |
C     | o JFNK solver, Losch et al., JCP, 257 901-911, 2014         |
C     | o EVP solver, Hunke and Dukowicz, JPO 27, 1849-1867 1997    |
C     *=============================================================*

C     !USES:
      IMPLICIT NONE
C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "SURFACE.h"
#include "DYNVARS.h"
#include "FFIELDS.h"
#include "SEAICE_SIZE.h"
#include "SEAICE_PARAMS.h"
#include "SEAICE_GRID.h"
#include "SEAICE.h"

#ifdef ALLOW_AUTODIFF_TAMC
# include "tamc.h"
#endif

C     !INPUT PARAMETERS:
C     === Routine arguments ===
C     myTime     :: Simulation time
C     myIter     :: Simulation timestep number
C     myThid     :: my Thread Id. number
      _RL     myTime
      INTEGER myIter
      INTEGER myThid

C     !FUNCTIONS:
      LOGICAL  DIFFERENT_MULTIPLE
      EXTERNAL DIFFERENT_MULTIPLE
#if ( defined ALLOW_DIAGNOSTICS && defined SEAICE_CGRID )
      LOGICAL  DIAGNOSTICS_IS_ON
      EXTERNAL DIAGNOSTICS_IS_ON
#endif

C     !LOCAL VARIABLES:
C     === Local variables ===
C     i,j    :: Loop counters
C     bi,bj  :: tile counters
      INTEGER i, j, bi, bj
#ifdef SEAICE_CGRID
# ifndef ALLOW_AUTODIFF
      _RL mask_uice, mask_vice
# endif
C     phiSurf :: geopotential height at sea surface (including pressure load)
      _RL phiSurf(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
#endif
C     TAUX    :: zonal      wind stress over seaice at U point
C     TAUY    :: meridional wind stress over seaice at V point
      _RL TAUX   (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL TAUY   (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
#if ( defined ALLOW_DIAGNOSTICS && defined SEAICE_CGRID )
# ifdef ALLOW_AUTODIFF
      _RL strDivX(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL strDivY(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
# endif /* ALLOW_AUTODIFF */
      _RL sig1   (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL sig2   (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL sig12  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL sigp, sigm, sigTmp, recip_prs
      _RL areaW, areaS, COSWAT
      _RS SINWAT
      INTEGER kSrf
      LOGICAL diag_SIsigma_isOn, diag_SIshear_isOn
      LOGICAL diag_SIenpi_isOn, diag_SIenpot_isOn
      LOGICAL diag_SIpRfric_isOn, diag_SIpSfric_isOn
#endif
CEOP

      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
#if ( defined ALLOW_AUTODIFF && defined SEAICE_CGRID )
C Following re-initialisation breaks some "artificial" AD dependencies
C incured by IF (DIFFERENT_MULTIPLE ... statement
          PRESS0     (i,j,bi,bj) = SEAICE_strength*HEFF(i,j,bi,bj)
     &         *EXP(-SEAICE_cStar*(ONE-AREA(i,j,bi,bj)))
          SEAICE_zMax(i,j,bi,bj) = SEAICE_zetaMaxFac*PRESS0(i,j,bi,bj)
          SEAICE_zMin(i,j,bi,bj) = SEAICE_zetaMin
          PRESS0     (i,j,bi,bj) = PRESS0(i,j,bi,bj)*HEFFM(i,j,bi,bj)
# ifdef SEAICE_ALLOW_FREEDRIFT
          uice_fd(i,j,bi,bj)= 0. _d 0
          vice_fd(i,j,bi,bj)= 0. _d 0
# endif
#if ( defined ALLOW_DIAGNOSTICS && defined SEAICE_CGRID )
          strDivX(i,j,bi,bj)= 0. _d 0
          strDivY(i,j,bi,bj)= 0. _d 0
# endif
#endif /* ALLOW_AUTODIFF and SEAICE_CGRID */
C     Always initialise these local variables, needed for TAF, but also
C     because they are not completely filled in S/R seaice_get_dynforcing
          TAUX(i,j,bi,bj) = 0. _d 0
          TAUY(i,j,bi,bj) = 0. _d 0
         ENDDO
        ENDDO
       ENDDO
      ENDDO
#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE uice    = comlev1, key=ikey_dynamics, kind=isbyte
CADJ STORE vice    = comlev1, key=ikey_dynamics, kind=isbyte
CADJ STORE uicenm1 = comlev1, key=ikey_dynamics, kind=isbyte
CADJ STORE vicenm1 = comlev1, key=ikey_dynamics, kind=isbyte
#endif /* ALLOW_AUTODIFF_TAMC */
C--   interface of dynamics with atmopheric forcing fields (wind/stress)
C     Call this in each time step so that we can use the surface stress
C     in S/R seaice_ocean_stress
      CALL SEAICE_GET_DYNFORCING (
     I     uIce, vIce, AREA, SIMaskU, SIMaskV,
     O     TAUX, TAUY,
     I     myTime, myIter, myThid )

#ifdef SEAICE_CGRID
      IF ( SEAICEuseDYNAMICS .AND.
     &  DIFFERENT_MULTIPLE(SEAICE_deltaTdyn,myTime,SEAICE_deltaTtherm)
     &   ) THEN

#if (defined ALLOW_AUTODIFF_TAMC && defined SEAICE_ALLOW_EVP)
CADJ STORE press0      = comlev1, key=ikey_dynamics, kind=isbyte
CADJ STORE SEAICE_zMax = comlev1, key=ikey_dynamics, kind=isbyte
#endif /* ALLOW_AUTODIFF_TAMC and SEAICE_ALLOW_EVP */

C--   NOW SET UP MASS PER UNIT AREA AND CORIOLIS TERM
       DO bj=myByLo(myThid),myByHi(myThid)
        DO bi=myBxLo(myThid),myBxHi(myThid)
         DO j=1-OLy+1,sNy+OLy
          DO i=1-OLx+1,sNx+OLx
           seaiceMassC(i,j,bi,bj)=SEAICE_rhoIce*HEFF(i,j,bi,bj)
           seaiceMassU(i,j,bi,bj)=SEAICE_rhoIce*HALF*(
     &          HEFF(i,j,bi,bj) + HEFF(i-1,j  ,bi,bj) )
           seaiceMassV(i,j,bi,bj)=SEAICE_rhoIce*HALF*(
     &          HEFF(i,j,bi,bj) + HEFF(i  ,j-1,bi,bj) )
          ENDDO
         ENDDO
         IF ( SEAICEaddSnowMass ) THEN
          DO j=1-OLy+1,sNy+OLy
           DO i=1-OLx+1,sNx+OLx
            seaiceMassC(i,j,bi,bj)=seaiceMassC(i,j,bi,bj)
     &           +                 SEAICE_rhoSnow*HSNOW(i,j,bi,bj)
            seaiceMassU(i,j,bi,bj)=seaiceMassU(i,j,bi,bj)
     &           +                  SEAICE_rhoSnow*HALF*(
     &           HSNOW(i,j,bi,bj) + HSNOW(i-1,j  ,bi,bj) )

            seaiceMassV(i,j,bi,bj)=seaiceMassV(i,j,bi,bj)
     &           +                  SEAICE_rhoSnow*HALF*(
     &           HSNOW(i,j,bi,bj) + HSNOW(i  ,j-1,bi,bj) )
           ENDDO
          ENDDO
         ENDIF
        ENDDO
       ENDDO

# ifndef ALLOW_AUTODIFF
       IF ( SEAICE_maskRHS ) THEN
C     dynamic masking of areas with no ice, not recommended
C     and only kept for testing purposes
        DO bj=myByLo(myThid),myByHi(myThid)
         DO bi=myBxLo(myThid),myBxHi(myThid)
          DO j=1-OLy+1,sNy+OLy
           DO i=1-OLx+1,sNx+OLx
            seaiceMaskU(i,j,bi,bj)=AREA(i,j,bi,bj)+AREA(i-1,j,bi,bj)
            mask_uice=HEFFM(i,j,bi,bj)+HEFFM(i-1,j  ,bi,bj)
            IF ( (seaiceMaskU(i,j,bi,bj) .GT. 0. _d 0) .AND.
     &           (mask_uice .GT. 1.5 _d 0) ) THEN
             seaiceMaskU(i,j,bi,bj) = 1. _d 0
            ELSE
             seaiceMaskU(i,j,bi,bj) = 0. _d 0
            ENDIF
            seaiceMaskV(i,j,bi,bj)=AREA(i,j,bi,bj)+AREA(i,j-1,bi,bj)
            mask_vice=HEFFM(i,j,bi,bj)+HEFFM(i  ,j-1,bi,bj)
            IF ( (seaiceMaskV(i,j,bi,bj) .GT. 0. _d 0) .AND.
     &           (mask_vice .GT. 1.5 _d 0) ) THEN
             seaiceMaskV(i,j,bi,bj) = 1. _d 0
            ELSE
             seaiceMaskV(i,j,bi,bj) = 0. _d 0
            ENDIF
           ENDDO
          ENDDO
         ENDDO
        ENDDO
        CALL EXCH_UV_XY_RL( seaiceMaskU, seaiceMaskV, .FALSE., myThid )
       ENDIF
# endif /* ndef ALLOW_AUTODIFF */

C--   NOW SET UP FORCING FIELDS

C     initialise fields
# if (defined ALLOW_AUTODIFF && defined SEAICE_ALLOW_EVP)
       DO bj=myByLo(myThid),myByHi(myThid)
        DO bi=myBxLo(myThid),myBxHi(myThid)
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           stressDivergenceX(i,j,bi,bj) = 0. _d 0
           stressDivergenceY(i,j,bi,bj) = 0. _d 0
          ENDDO
         ENDDO
        ENDDO
       ENDDO
# endif

       DO bj=myByLo(myThid),myByHi(myThid)
        DO bi=myBxLo(myThid),myBxHi(myThid)
C--   Compute surface pressure at z==0:
C-    use actual sea surface height for tilt computations
         IF ( usingPCoords ) THEN
          DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
            phiSurf(i,j) = phiHydLow(i,j,bi,bj)
           ENDDO
          ENDDO
         ELSE
          DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
            phiSurf(i,j) = Bo_surf(i,j,bi,bj)*etaN(i,j,bi,bj)
           ENDDO
          ENDDO
         ENDIF
# ifdef ATMOSPHERIC_LOADING
C--   add atmospheric loading and Sea-Ice loading as it is done for phi0surf
C--   in S/R external_forcing_surf
         IF ( usingZCoords ) THEN
          IF ( useRealFreshWaterFlux ) THEN
           DO j=1-OLy,sNy+OLy
            DO i=1-OLx,sNx+OLx
             phiSurf(i,j) = phiSurf(i,j)
     &                    + ( pload(i,j,bi,bj)
     &                       +sIceLoad(i,j,bi,bj)*gravity*sIceLoadFac
     &                      )*recip_rhoConst
            ENDDO
           ENDDO
          ELSE
           DO j=1-OLy,sNy+OLy
            DO i=1-OLx,sNx+OLx
             phiSurf(i,j) = phiSurf(i,j)
     &                    + pload(i,j,bi,bj)*recip_rhoConst
            ENDDO
           ENDDO
          ENDIF
C        ELSEIF ( usingPCoords ) THEN
C     The true atmospheric P-loading is not yet implemented for P-coord
C     (requires time varying dP(Nr) like dP(k-bottom) with NonLin FS).
         ENDIF
# endif /* ATMOSPHERIC_LOADING */
C--   basic forcing by wind stress
         IF ( SEAICEscaleSurfStress ) THEN
          DO j=1-OLy+1,sNy+OLy
           DO i=1-OLx+1,sNx+OLx
            FORCEX0(i,j,bi,bj)=TAUX(i,j,bi,bj)
     &           * 0.5 _d 0*(AREA(i,j,bi,bj)+AREA(i-1,j,bi,bj))
            FORCEY0(i,j,bi,bj)=TAUY(i,j,bi,bj)
     &           * 0.5 _d 0*(AREA(i,j,bi,bj)+AREA(i,j-1,bi,bj))
           ENDDO
          ENDDO
         ELSE
          DO j=1-OLy+1,sNy+OLy
           DO i=1-OLx+1,sNx+OLx
            FORCEX0(i,j,bi,bj)=TAUX(i,j,bi,bj)
            FORCEY0(i,j,bi,bj)=TAUY(i,j,bi,bj)
           ENDDO
          ENDDO
         ENDIF

         IF ( SEAICEuseTILT ) THEN
          DO j=1-OLy+1,sNy+OLy
           DO i=1-OLx+1,sNx+OLx
C--   now add in tilt
            FORCEX0(i,j,bi,bj)=FORCEX0(i,j,bi,bj)
     &           -seaiceMassU(i,j,bi,bj)*_recip_dxC(i,j,bi,bj)
     &           *( phiSurf(i,j)-phiSurf(i-1,j) )
            FORCEY0(i,j,bi,bj)=FORCEY0(i,j,bi,bj)
     &           -seaiceMassV(i,j,bi,bj)* _recip_dyC(i,j,bi,bj)
     &           *( phiSurf(i,j)-phiSurf(i,j-1) )
           ENDDO
          ENDDO
         ENDIF

         CALL SEAICE_CALC_ICE_STRENGTH( bi, bj, myTime, myIter, myThid )

        ENDDO
       ENDDO

# ifdef SEAICE_ALLOW_FREEDRIFT
       IF ( SEAICEuseFREEDRIFT .OR. SEAICEuseEVP
     &                         .OR. LSR_mixIniGuess.EQ.0 ) THEN
        CALL SEAICE_FREEDRIFT( myTime, myIter, myThid )
       ENDIF
       IF ( SEAICEuseFREEDRIFT ) THEN
        DO bj=myByLo(myThid),myByHi(myThid)
         DO bi=myBxLo(myThid),myBxHi(myThid)
          DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
            uIce(i,j,bi,bj) = uIce_fd(i,j,bi,bj)
            vIce(i,j,bi,bj) = vIce_fd(i,j,bi,bj)
            stressDivergenceX(i,j,bi,bj) = 0. _d 0
            stressDivergenceY(i,j,bi,bj) = 0. _d 0
           ENDDO
          ENDDO
         ENDDO
        ENDDO
       ENDIF
# endif /* SEAICE_ALLOW_FREEDRIFT */

# ifdef ALLOW_OBCS
       IF ( useOBCS ) THEN
         CALL OBCS_APPLY_UVICE( uIce, vIce, myThid )
       ENDIF
# endif

# ifdef SEAICE_ALLOW_EVP
#  ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE uice    = comlev1, key=ikey_dynamics, kind=isbyte
CADJ STORE vice    = comlev1, key=ikey_dynamics, kind=isbyte
CADJ STORE uicenm1 = comlev1, key=ikey_dynamics, kind=isbyte
CADJ STORE vicenm1 = comlev1, key=ikey_dynamics, kind=isbyte
#  endif /* ALLOW_AUTODIFF_TAMC */
       IF ( SEAICEuseEVP ) THEN
C     Elastic-Viscous-Plastic solver, following Hunke (2001)
        CALL SEAICE_EVP( myTime, myIter, myThid )
       ENDIF
# endif /* SEAICE_ALLOW_EVP */

       IF ( SEAICEuseLSR ) THEN
C     Picard solver with LSR scheme (Zhang-J/Hibler 1997), ported to a C-grid
        CALL SEAICE_LSR( myTime, myIter, myThid )
       ENDIF

# ifdef SEAICE_ALLOW_KRYLOV
#  ifdef ALLOW_AUTODIFF
       STOP 'Adjoint does not work with Picard-Krylov solver.'
#  else
       IF ( SEAICEuseKrylov ) THEN
C     Picard solver with Matrix-free Krylov solver (Lemieux et al. 2008)
        CALL SEAICE_KRYLOV( myTime, myIter, myThid )
       ENDIF
#  endif /*  ALLOW_AUTODIFF */
# endif /* SEAICE_ALLOW_KRYLOV */

# ifdef SEAICE_ALLOW_JFNK
#  ifdef ALLOW_AUTODIFF
       STOP 'Adjoint does not work with JFNK solver.'
#  else
       IF ( SEAICEuseJFNK ) THEN
C     Jacobian-free Newton Krylov solver (Lemieux et al. 2010, 2012)
        CALL SEAICE_JFNK( myTime, myIter, myThid )
       ENDIF
#  endif /*  ALLOW_AUTODIFF */
# endif /* SEAICE_ALLOW_JFNK */

C End of IF (SEAICEuseDYNAMICS and DIFFERENT_MULTIPLE ...
      ENDIF
#endif /* SEAICE_CGRID */

C Update ocean surface stress
      IF ( SEAICEupdateOceanStress ) THEN
#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE uice, vice, DWATN = comlev1, key=ikey_dynamics, kind=isbyte
# ifdef SEAICE_CGRID
CADJ STORE stressDivergenceX = comlev1, key=ikey_dynamics, kind=isbyte
CADJ STORE stressDivergenceY = comlev1, key=ikey_dynamics, kind=isbyte
# endif
#endif /* ALLOW_AUTODIFF_TAMC */
        CALL SEAICE_OCEAN_STRESS (
     I              TAUX, TAUY, myTime, myIter, myThid )
      ENDIF

#ifdef SEAICE_ALLOW_CLIPVELS
      IF ( SEAICEuseDYNAMICS .AND. SEAICE_clipVelocities) THEN
# ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE uice = comlev1, key=ikey_dynamics, kind=isbyte
CADJ STORE vice = comlev1, key=ikey_dynamics, kind=isbyte
# endif /* ALLOW_AUTODIFF_TAMC */
c Put a cap on ice velocity
c limit velocity to 0.40 m s-1 to avoid potential CFL violations
c in open water areas (drift of zero thickness ice)
       DO bj=myByLo(myThid),myByHi(myThid)
        DO bi=myBxLo(myThid),myBxHi(myThid)
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           uIce(i,j,bi,bj)=
     &          MAX(MIN(uIce(i,j,bi,bj),0.40 _d +00),-0.40 _d +00)
           vIce(i,j,bi,bj)=
     &          MAX(MIN(vIce(i,j,bi,bj),0.40 _d +00),-0.40 _d +00)
          ENDDO
         ENDDO
        ENDDO
       ENDDO
      ENDIF
#endif /* SEAICE_ALLOW_CLIPVELS */

#if ( defined ALLOW_DIAGNOSTICS && defined SEAICE_CGRID )
C     diagnostics related to mechanics/dynamics/momentum equations
      IF ( useDiagnostics .AND. SEAICEuseDYNAMICS ) THEN
       CALL DIAGNOSTICS_FILL(zeta   ,'SIzeta  ',0,1,0,1,1,myThid)
       CALL DIAGNOSTICS_FILL(eta    ,'SIeta   ',0,1,0,1,1,myThid)
       CALL DIAGNOSTICS_FILL(press  ,'SIpress ',0,1,0,1,1,myThid)
       CALL DIAGNOSTICS_FILL(deltaC ,'SIdelta ',0,1,0,1,1,myThid)
# ifdef SEAICE_ALLOW_SIDEDRAG
C     recompute lateral coast drag terms
       IF ( DIAGNOSTICS_IS_ON('SIlatDgU',myThid) ) THEN
        DO bj = myByLo(myThid), myByHi(myThid)
         DO bi = myBxLo(myThid), myBxHi(myThid)
C     use sig1 as a temporary field
          DO j=1,sNy
           DO i=1,sNx+1
            sig1(i,j) = sideDragU(i,j,bi,bj)*uIce(i,j,bi,bj)
           ENDDO
          ENDDO
          CALL DIAGNOSTICS_FILL(sig1,'SIlatDgU',0,1,2,bi,bj,myThid)
         ENDDO
        ENDDO
       ENDIF
       IF ( DIAGNOSTICS_IS_ON('SIlatDgV',myThid) ) THEN
        DO bj = myByLo(myThid), myByHi(myThid)
         DO bi = myBxLo(myThid), myBxHi(myThid)
C     use sig1 as a temporary field
          DO j=1,sNy+1
           DO i=1,sNx
            sig1(i,j) = sideDragV(i,j,bi,bj)*vIce(i,j,bi,bj)
           ENDDO
          ENDDO
          CALL DIAGNOSTICS_FILL(sig1,'SIlatDgV',0,1,2,bi,bj,myThid)
         ENDDO
        ENDDO
       ENDIF
# endif /* SEAICE_ALLOW_SIDEDRAG */

       IF ( DIAGNOSTICS_IS_ON('SItensil',myThid) ) THEN
        DO bj = myByLo(myThid), myByHi(myThid)
         DO bi = myBxLo(myThid), myBxHi(myThid)
C     use sig1 as a temporary field
          DO j=1,sNy
           DO i=1,sNx
            IF ( tensileStrFac(i,j,bi,bj) .EQ. oneRL ) THEN
C     This special case of tensile strength equal to compressive strength
C     is not very physical and should actually not happen but you never know;
C     in this case, press = P-T = P*(1-k) = 0. and we have to use press0 to
C     get something
             sig1(i,j) = press0(i,j,bi,bj)
            ELSE
C     This is more complicated than you think because press = P-T = P*(1-k),
C     but we are looking for T = k*P = k*press/(1-k)
             sig1(i,j) = tensileStrFac(i,j,bi,bj)
     &            *press(i,j,bi,bj)/(1. _d 0 - tensileStrFac(i,j,bi,bj))
            ENDIF
           ENDDO
          ENDDO
          CALL DIAGNOSTICS_FILL(sig1,'SItensil',0,1,2,bi,bj,myThid)
         ENDDO
        ENDDO
       ENDIF
C     If any of the stress or energy diagnostics are required,
C     first recompute strainrates from up-to-date velocities
       diag_SIsigma_isOn  = DIAGNOSTICS_IS_ON('SIsig1  ',myThid)
     &                 .OR. DIAGNOSTICS_IS_ON('SIsig2  ',myThid)
       diag_SIshear_isOn  = DIAGNOSTICS_IS_ON('SIshear ',myThid)
       diag_SIenpi_isOn   = DIAGNOSTICS_IS_ON('SIenpi  ',myThid)
       diag_SIenpot_isOn  = DIAGNOSTICS_IS_ON('SIenpot ',myThid)
       diag_SIpRfric_isOn = DIAGNOSTICS_IS_ON('SIpRfric',myThid)
       diag_SIpSfric_isOn = DIAGNOSTICS_IS_ON('SIpSfric',myThid)
       IF ( diag_SIsigma_isOn  .OR. diag_SIshear_isOn .OR.
     &      diag_SIenpi_isOn   .OR. diag_SIenpot_isOn .OR.
     &      diag_SIpRfric_isOn .OR. diag_SIpSfric_isOn ) THEN
        CALL SEAICE_CALC_STRAINRATES(
     I       uIce, vIce,
     O       e11, e22, e12,
     I       0, myTime, myIter, myThid )
C     but use old viscosities and pressure for the
C     principle stress components
CML     CALL SEAICE_CALC_VISCOSITIES(
CML  I     e11, e22, e12, SEAICE_zMin, SEAICE_zMax, HEFFM, press0,
CML  I     tensileStrFac,
CML  O     eta, etaZ, zeta, zetaZ, press, deltaC,
CML  I     0, myTime, myIter, myThid )
       ENDIF
C
       DO bj = myByLo(myThid), myByHi(myThid)
        DO bi = myBxLo(myThid), myBxHi(myThid)
C
C     stress diagnostics
C
         IF ( diag_SIsigma_isOn ) THEN
# ifdef SEAICE_ALLOW_EVP
C     This could go directly into EVP, but to keep a better eye on it,
C     I would like to keep it here.
          IF ( SEAICEuseEVP ) THEN
C     for EVP compute principle stress components from recent
C     stress state and normalize with latest
C     PRESS = PRESS(n-1), n = number of sub-cycling steps
           DO j=1,sNy
            DO i=1,sNx
             sigp = seaice_sigma1(i,j,bi,bj)
             sigm = seaice_sigma2(i,j,bi,bj)
             sig12(i,j) = 0.25 _d 0 *
     &            ( seaice_sigma12(i  ,j  ,bi,bj)
     &            + seaice_sigma12(i+1,j  ,bi,bj)
     &            + seaice_sigma12(i+1,j+1,bi,bj)
     &            + seaice_sigma12(i  ,j+1,bi,bj) )
             sigTmp = SQRT( sigm*sigm + 4. _d 0*sig12(i,j)*sig12(i,j) )
             recip_prs = 0. _d 0
             IF ( press0(i,j,bi,bj) .GT. 1. _d -13 )
     &            recip_prs = 1. _d 0 / press0(i,j,bi,bj)
             sig1(i,j) = 0.5 _d 0*(sigp + sigTmp)*recip_prs
             sig2(i,j) = 0.5 _d 0*(sigp - sigTmp)*recip_prs
            ENDDO
           ENDDO
          ELSE
# else
          IF ( .TRUE. ) THEN
# endif /* SEAICE_ALLOW_EVP */
           CALL SEAICE_CALC_STRESS(
     I          e11, e22, e12, press, zeta, eta, etaZ,
     O          sig1, sig2, sig12,
     I          bi, bj, myTime, myIter, myThid )
           DO j=1,sNy
            DO i=1,sNx
             sigp   = sig1(i,j) + sig2(i,j)
             sigm   = sig1(i,j) - sig2(i,j)
C     This should be the way of computing sig12 at C-points,
C            sigTmp = 0.25 _d 0 *
C    &            ( sig12(i  ,j  ) + sig12(i+1,j  )
C    &            + sig12(i  ,j+1) + sig12(i+1,j+1) )
C     but sig12 = 2*etaZ*e12, and because of strong gradients in eta,
C     etaZ can be very large for a cell with small eta and the straightforward
C     way of averaging mixes large etaZ with small press0, so we have to do it
C     in different way to get meaningfull sig12C (=sigTmp):
             sigTmp = 2. _d 0 * eta(i,j,bi,bj) * 0.25 _d 0 *
     &            (e12(i,j,bi,bj) + e12(i+1,j,bi,bj)
     &            +e12(i,j+1,bi,bj)+e12(i+1,j+1,bi,bj))
             sigTmp = SQRT( sigm*sigm + 4. _d 0*sigTmp*sigTmp )
             recip_prs = 0. _d 0
             IF ( press0(i,j,bi,bj) .GT. 1. _d -13 )
     &            recip_prs = 1. _d 0 / press0(i,j,bi,bj)
             sig1(i,j) = 0.5 _d 0*(sigp + sigTmp)*recip_prs
             sig2(i,j) = 0.5 _d 0*(sigp - sigTmp)*recip_prs
            ENDDO
           ENDDO
          ENDIF
          CALL DIAGNOSTICS_FILL(sig1,'SIsig1  ',0,1,2,bi,bj,myThid)
          CALL DIAGNOSTICS_FILL(sig2,'SIsig2  ',0,1,2,bi,bj,myThid)
         ENDIF
C
         IF ( diag_SIshear_isOn  ) THEN
          DO j=1,sNy
           DO i=1,sNx
            sigm = e11(i,j,bi,bj) - e22(i,j,bi,bj)
            sigTmp =
     &           ( e12(i  ,j  ,bi,bj)**2 + e12(i+1,j  ,bi,bj)**2
     &           + e12(i+1,j+1,bi,bj)**2 + e12(i  ,j+1,bi,bj)**2 )
C     shear deformation as sqrt((e11-e22)**2 + 4*e12**2); the 4 pulled into
C     the average
            sig1(i,j) = SQRT(sigm*sigm + sigTmp)
           ENDDO
          ENDDO
          CALL DIAGNOSTICS_FILL(sig1,'SIshear ',0,1,2,bi,bj,myThid)
         ENDIF
C
C     most of the energy diagnostics, re-use sig1, sig2, sig12 as tmp-arrays
C
         IF ( diag_SIenpi_isOn ) THEN
C     compute internal stresses with updated ice velocities
C     TAF gets confused when we use stressDivergenceX/Y as temporary arrays
C     therefore we need to use new arrays
          IF ( .NOT. SEAICEuseFREEDRIFT )
     &         CALL SEAICE_CALC_STRESSDIV(
     I         e11, e22, e12, press, zeta, eta, etaZ,
# ifdef ALLOW_AUTODIFF
     O         strDivX, strDivY,
# else /* not ALLOW_AUTODIFF */
     O         stressDivergenceX, stressDivergenceY,
# endif /* ALLOW_AUTODIFF */
     I         bi, bj, myTime, myIter, myThid )
          DO j=1,sNy+1
           DO i=1,sNx+1
# ifdef ALLOW_AUTODIFF
            sig1(i,j) = uIce(i,j,bi,bj)*strDivX(i,j,bi,bj)
            sig2(i,j) = vIce(i,j,bi,bj)*strDivY(i,j,bi,bj)
# else /* not ALLOW_AUTODIFF */
            sig1(i,j) = uIce(i,j,bi,bj)*stressDivergenceX(i,j,bi,bj)
            sig2(i,j) = vIce(i,j,bi,bj)*stressDivergenceY(i,j,bi,bj)
# endif /* ALLOW_AUTODIFF */
           ENDDO
          ENDDO
C     average from velocity points to pressure points
          DO j=1,sNy
           DO i=1,sNx
            sig12(i,j)= 0.5 _d 0 * ( sig1(i,j) + sig1(i+1,j)
     &                             + sig2(i,j) + sig2(i,j+1) )
           ENDDO
          ENDDO
          CALL DIAGNOSTICS_FILL(sig12,'SIenpi  ',0,1,2,bi,bj,myThid)
         ENDIF
         IF ( diag_SIenpot_isOn ) THEN
          DO j=1,sNy
           DO i=1,sNx
            sig1(i,j) = 0.5 _d 0 * press0(i,j,bi,bj) *
     &           ( e11(i,j,bi,bj) + e22(i,j,bi,bj) )
           ENDDO
          ENDDO
          CALL DIAGNOSTICS_FILL(sig1,'SIenpot ',0,1,2,bi,bj,myThid)
         ENDIF
         IF ( diag_SIpRfric_isOn ) THEN
          DO j=1,sNy
           DO i=1,sNx
            sig1(i,j) = - zeta(i,j,bi,bj)
     &           * ( e11(i,j,bi,bj) + e22(i,j,bi,bj) )
     &           * ( e11(i,j,bi,bj) + e22(i,j,bi,bj) )
           ENDDO
          ENDDO
          CALL DIAGNOSTICS_FILL(sig1,'SIpRfric',0,1,2,bi,bj,myThid)
         ENDIF
         IF ( diag_SIpSfric_isOn ) THEN
          DO j=1,sNy
           DO i=1,sNx
            sig1(i,j) = - eta(i,j,bi,bj)
     &        * ( (e11(i,j,bi,bj) - e22(i,j,bi,bj))**2 +
     &            ( e12(i  ,j  ,bi,bj)**2 + e12(i+1,j  ,bi,bj)**2
     &            + e12(i+1,j+1,bi,bj)**2 + e12(i  ,j+1,bi,bj)**2 )
     &          )
           ENDDO
          ENDDO
          CALL DIAGNOSTICS_FILL(sig1,'SIpSfric',0,1,2,bi,bj,myThid)
         ENDIF
         IF ( DIAGNOSTICS_IS_ON('SIenpa  ',myThid) ) THEN
          DO j=1,sNy+1
           DO i=1,sNx+1
            areaW = 0.5 _d 0 * (AREA(i,j,bi,bj) + AREA(i-1,j,bi,bj))
     &           * SEAICEstressFactor
            areaS = 0.5 _d 0 * (AREA(i,j,bi,bj) + AREA(i,j-1,bi,bj))
     &           * SEAICEstressFactor
            sig1(i,j) = TAUX(i,j,bi,bj)*areaW * uIce(i,j,bi,bj)
            sig2(i,j) = TAUY(i,j,bi,bj)*areaS * vIce(i,j,bi,bj)
           ENDDO
          ENDDO
C     average from velocity points to pressure points
          DO j=1,sNy
           DO i=1,sNx
            sig12(i,j)= 0.5 _d 0 * ( sig1(i,j) + sig1(i+1,j)
     &                             + sig2(i,j) + sig2(i,j+1) )
           ENDDO
          ENDDO
          CALL DIAGNOSTICS_FILL(sig12,'SIenpa  ',0,1,2,bi,bj,myThid)
         ENDIF
         IF ( DIAGNOSTICS_IS_ON('SIenpw  ',myThid) ) THEN
C     surface level
          kSrf = 1
C     introduce turning angle (default is zero)
          SINWAT=SIN(SEAICE_waterTurnAngle*deg2rad)
          COSWAT=COS(SEAICE_waterTurnAngle*deg2rad)
          DO j=1,sNy+1
           DO i=1,sNx+1
            areaW = 0.5 _d 0 * (AREA(i,j,bi,bj) + AREA(i-1,j,bi,bj))
     &         * SEAICEstressFactor
            areaS = 0.5 _d 0 * (AREA(i,j,bi,bj) + AREA(i,j-1,bi,bj))
     &         * SEAICEstressFactor
            sig1(i,j) = areaW *
     &           HALF*( DWATN(i,j,bi,bj)+DWATN(i-1,j,bi,bj) )*
     &         COSWAT *
     &         ( uIce(i,j,bi,bj)-uVel(i,j,kSrf,bi,bj) )
     &         - SIGN(SINWAT, _fCori(i,j,bi,bj)) * 0.5 _d 0 *
     &         ( DWATN(i  ,j,bi,bj) *
     &         0.5 _d 0*(vIce(i  ,j  ,bi,bj)-vVel(i  ,j  ,kSrf,bi,bj)
     &                  +vIce(i  ,j+1,bi,bj)-vVel(i  ,j+1,kSrf,bi,bj))
     &         + DWATN(i-1,j,bi,bj) *
     &         0.5 _d 0*(vIce(i-1,j  ,bi,bj)-vVel(i-1,j  ,kSrf,bi,bj)
     &                  +vIce(i-1,j+1,bi,bj)-vVel(i-1,j+1,kSrf,bi,bj))
     &         )
            sig1(i,j) = sig1(i,j) * uIce(i,j,bi,bj)
            sig2(i,j) = areaS *
     &           HALF*( DWATN(i,j,bi,bj)+DWATN(i,j-1,bi,bj) )*
     &         COSWAT *
     &         ( vIce(i,j,bi,bj)-vVel(i,j,kSrf,bi,bj) )
     &         + SIGN(SINWAT,  _fCori(i,j,bi,bj)) * 0.5 _d 0 *
     &         ( DWATN(i,j  ,bi,bj) *
     &         0.5 _d 0*(uIce(i  ,j  ,bi,bj)-uVel(i  ,j  ,kSrf,bi,bj)
     &                  +uIce(i+1,j  ,bi,bj)-uVel(i+1,j  ,kSrf,bi,bj))
     &         + DWATN(i,j-1,bi,bj) *
     &         0.5 _d 0*(uIce(i  ,j-1,bi,bj)-uVel(i  ,j-1,kSrf,bi,bj)
     &                  +uIce(i+1,j-1,bi,bj)-uVel(i+1,j-1,kSrf,bi,bj))
     &         )
            sig2(i,j) = sig2(i,j) * vIce(i,j,bi,bj)
           ENDDO
          ENDDO
C     average from velocity points to pressure points
          DO j=1,sNy
           DO i=1,sNx
            sig12(i,j)= - 0.5 _d 0 * ( sig1(i,j) + sig1(i+1,j)
     &                               + sig2(i,j) + sig2(i,j+1) )
           ENDDO
          ENDDO
          CALL DIAGNOSTICS_FILL(sig12,'SIenpw  ',0,1,2,bi,bj,myThid)
         ENDIF
         IF ( SEAICEuseTilt
     &        .AND. DIAGNOSTICS_IS_ON('SIenpg  ',myThid) ) THEN
          DO j=1-OLy+1,sNy+OLy
           DO i=1-OLx+1,sNx+OLx
            sig1(i,j)=
     &           - seaiceMassU(i,j,bi,bj)*_recip_dxC(i,j,bi,bj)
     &           *( phiSurf(i,j)-phiSurf(i-1,j) ) * uIce(i,j,bi,bj)
            sig2(i,j)=
     &           - seaiceMassV(i,j,bi,bj)* _recip_dyC(i,j,bi,bj)
     &           *( phiSurf(i,j)-phiSurf(i,j-1) ) * vIce(i,j,bi,bj)
           ENDDO
          ENDDO
C     average from velocity points to pressure points
          DO j=1,sNy
           DO i=1,sNx
            sig12(i,j) = 0.5 _d 0 * ( sig1(i,j) + sig1(i+1,j)
     &                              + sig2(i,j) + sig2(i,j+1) )
           ENDDO
          ENDDO
          CALL DIAGNOSTICS_FILL(sig12,'SIenpg  ',0,1,2,bi,bj,myThid)
         ENDIF
C     bi/bj-loop
        ENDDO
       ENDDO
C     useDiagnostics & SEAICEuseDYNAMICS
      ENDIF
#endif /* ALLOW_DIAGNOSTICS and SEAICE_CGRID */

      RETURN
      END

#include "LAND_OPTIONS.h"

CBOP
C     !ROUTINE: LAND_WRITE_PICKUP
C     !INTERFACE:
      SUBROUTINE LAND_WRITE_PICKUP( isperm, suff,
     I                              myTime, myIter, myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R LAND_WRITE_PICKUP
C     | o Writes current state of land package to a pickup file
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     == Global variables ===
#include "LAND_SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "LAND_PARAMS.h"
#include "LAND_VARS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine Arguments ==
C     isperm  :: flag for permanent or rolling checkpoint
C     suff    :: suffix for pickup file (eg. ckptA or 0000000010)
C     myTime  :: current time
C     myIter  :: time-step number
C     myThid  :: Number of this instance
      LOGICAL isperm
      CHARACTER*(*) suff
      _RL myTime
      INTEGER myIter
      INTEGER myThid

#ifdef ALLOW_LAND

C     !FUNCTIONS:
      INTEGER  ILNBLNK
      EXTERNAL ILNBLNK

C     !LOCAL VARIABLES:
C     fn      :: character buffer for creating filename
C     prec    :: precision of pickup files
c     INTEGER prec, iChar, lChar, k
      INTEGER prec, lChar, k
      CHARACTER*(MAX_LEN_FNAM) fn
CEOP

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      lChar = ILNBLNK(suff)

      IF ( land_pickup_write_mdsio ) THEN

C--   Write fields as consecutive records
        WRITE(fn,'(A,A)') 'pickup_land.',suff(1:lChar)
        prec = precFloat64

        CALL WRITE_REC_3D_RL( fn, prec, land_nLev,
     &                        land_enthalp,  1, myIter, myThid )
        CALL WRITE_REC_3D_RL( fn, prec, land_nLev,
     &                        land_groundW,  2, myIter, myThid )
        k=2*land_nLev
        CALL WRITE_REC_3D_RL( fn, prec, 1,
     &                        land_skinT,  k+1, myIter, myThid )
        CALL WRITE_REC_3D_RL( fn, prec, 1,
     &                        land_hSnow,  k+2, myIter, myThid )
        CALL WRITE_REC_3D_RL( fn, prec, 1,
     &                        land_snowAge,k+3, myIter, myThid )

      ENDIF

#ifdef ALLOW_MNC
      IF ( land_pickup_write_mnc ) THEN

        DO k = 1,MAX_LEN_FNAM
          fn(k:k) = ' '
        ENDDO
        IF ( isperm ) THEN
          WRITE(fn,'(A)') 'pickup_land'
        ELSE
          WRITE(fn,'(A,A)') 'pickup_land.',suff(1:lChar)
        ENDIF
        CALL MNC_FILE_CLOSE_ALL_MATCHING(fn, myThid)
        CALL MNC_CW_SET_UDIM(fn, 1, myThid)
        IF ( isperm ) THEN
          CALL MNC_CW_SET_CITER(fn, 3, 3, myIter, 0, myThid)
        ELSE
          CALL MNC_CW_SET_CITER(fn, 2, -1, -1, -1, myThid)
        ENDIF
        CALL MNC_CW_SET_UDIM(fn, 1, myThid)

        CALL MNC_CW_RL_W_S('D',fn,0,0,'T', myTime, myThid)
        CALL MNC_CW_I_W_S('I',fn,0,0,'iter', myIter, myThid)

        CALL MNC_CW_RL_W('D',fn,0,0,
     &       'land_enthalp', land_enthalp, myThid)
        CALL MNC_CW_RL_W('D',fn,0,0,
     &       'land_groundW', land_groundW, myThid)

        CALL MNC_CW_RL_W('D',fn,0,0,
     &       'land_skinT', land_skinT, myThid)
        CALL MNC_CW_RL_W('D',fn,0,0,
     &       'land_hSnow', land_hSnow, myThid)
        CALL MNC_CW_RL_W('D',fn,0,0,
     &       'land_snAge', land_snowAge, myThid)

      ENDIF
#endif /*  ALLOW_MNC  */

#endif /* ALLOW_LAND */

      RETURN
      END

#include "EBM_OPTIONS.h"

CBOP 0
C !ROUTINE: EBM_READPARMS

C !INTERFACE:
      SUBROUTINE EBM_READPARMS( myThid )

C     !DESCRIPTION:
C     *==========================================================*
C     | SUBROUTINE EBM_READPARMS
C     | o Routine to read in parameters from file data.ebm
C     *==========================================================*

C     !USES:
      IMPLICIT NONE
C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#ifdef ALLOW_EBM
#include "EBM.h"
#endif

C     !INPUT PARAMETERS:
C     myThid     :: my Thread Id number
      INTEGER myThid
CEOP

#ifdef ALLOW_EBM
C     !LOCAL VARIABLES:
C     msgBuf     :: Informational/error message buffer
C     errIO      :: IO error flag
C     iUnit      :: Work variable for IO unit number
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      INTEGER errIO, iUnit

C--   Namelist
      NAMELIST /EBM_PARM01/
     & tauThetaZonRelax,
     & scale_runoff,
     & RunoffFile

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      IF ( .NOT.useEBM ) THEN
C-    PKG ebm is not used
        _BEGIN_MASTER(myThid)
C-    Track pkg activation status:
C     print a (weak) warning if data.ebm is found
         CALL PACKAGES_UNUSED_MSG( 'useEBM', ' ', ' ' )
        _END_MASTER(myThid)
        RETURN
      ENDIF

      _BEGIN_MASTER(myThid)

      WRITE(msgBuf,'(A)') ' EBM_READPARMS: opening data.ebm'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      errIO = 0
      CALL OPEN_COPY_DATA_FILE(
     I                          'data.ebm', 'EBM_READPARMS',
     O                          iUnit,
     I                          myThid )

C--   set default
      tauThetaZonRelax = 0.
      scale_runoff = 1.
      RunoffFile = ' '

C-----------------------------------------------------------------------

C--   Read settings from model parameter file "data.ebm".
      READ( UNIT=iUnit, NML=EBM_PARM01 )
c     READ( UNIT=iUnit, NML=EBM_PARM01, IOSTAT=errIO )
      IF ( errIO .LT. 0 ) THEN
       WRITE(msgBuf,'(A)') 'S/R EBM_READPARMS'
       CALL PRINT_ERROR( msgBuf, myThid )
       WRITE(msgBuf,'(A)') 'Error reading numerical model '
       CALL PRINT_ERROR( msgBuf, myThid )
       WRITE(msgBuf,'(A)') 'parameter file "data.ebm"'
       CALL PRINT_ERROR( msgBuf, myThid )
       WRITE(msgBuf,'(A)') 'Problem in namelist EBM_PARM01'
       CALL PRINT_ERROR( msgBuf, myThid )
       STOP 'ABNORMAL END: S/R EBM_READPARMS'
      ENDIF
C     Close the open data file
#ifdef SINGLE_DISK_IO
      CLOSE(iUnit)
#else
      CLOSE(iUnit,STATUS='DELETE')
#endif /* SINGLE_DISK_IO */

      WRITE(msgBuf,'(A)') ' EBM_READPARMS: finished reading data.ebm'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )

C--   Set other parameters
      IF ( tauThetaZonRelax .NE. 0. _d 0 ) THEN
        IF ( tauThetaClimRelax.NE.0. _d 0 ) THEN
          WRITE(msgBuf,'(2A)') 'EBM_READPARMS: ',
     &     'tauThetaClimRelax > 0 AND tauThetaZonRelax > 0'
          CALL PRINT_ERROR( msgBuf, myThid )
          WRITE(msgBuf,'(2A)') 'EBM_READPARMS: ',
     &     'cannot relax Temp. to 2-d map AND ZonAver SST'
          CALL PRINT_ERROR( msgBuf, myThid )
          STOP 'ABNORMAL END: S/R EBM_READPARMS'
        ELSE
          WRITE(msgBuf,'(2A)') ' EBM_READPARMS: ',
     &     'set tauThetaClimRelax to tauThetaZonRelax value'
          CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                        SQUEEZE_RIGHT, myThid )
          tauThetaClimRelax = tauThetaZonRelax
        ENDIF
      ENDIF
C-   Set latitude boundaries used in EBM
      latBnd(1) =  0. _d 0
      latBnd(2) = 35. _d 0
      latBnd(3) = 85. _d 0

      _END_MASTER(myThid)

C--   Everyone else must wait for the parameters to be loaded
      _BARRIER

#endif /* ALLOW_EBM */

      RETURN
      END

#include "MOM_COMMON_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: MOM_CALC_SMAG_3D

C     !INTERFACE:
      SUBROUTINE MOM_CALC_SMAG_3D(
     I        str11, str22, str33, str12, str13, str23,
     O        viscAh3d_00, viscAh3d_12,
     O        viscAh3d_13, viscAh3d_23,
     I        smag3D_hLsC, smag3D_hLsW, smag3D_hLsS, smag3D_hLsZ,
     I        k, bi, bj, myThid )

C     !DESCRIPTION:
C     Calculate Smagorinsky 3-D (harmonic) viscosities
C      at current level k (for viscAh3d_00 & viscAh3d_12)
C      and at level k+1   (for viscAh3d_13 & viscAh3d_23)

C     !USES:
      IMPLICIT NONE

C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#ifdef ALLOW_SMAG_3D_DIFFUSIVITY
# include "DYNVARS.h"
#endif
c#include "MOM_VISC.h"

C     !INPUT PARAMETERS:
C     str11       :: strain component Vxx @ grid-cell center
C     str22       :: strain component Vyy @ grid-cell center
C     str33       :: strain component Vzz @ grid-cell center
C     str12       :: strain component Vxy @ grid-cell corner
C     str13       :: strain component Vxz @ above uVel
C     str23       :: strain component Vyz @ above vVel
C     smag3D_hLsC :: horiz. grid length scale (power 2/3) at grid cell center
C     smag3D_hLsW :: horiz. grid length scale (power 2/3) at western  edge
C     smag3D_hLsS :: horiz. grid length scale (power 2/3) at southern egde
C     smag3D_hLsZ :: horiz. grid length scale (power 2/3) at grid cell corner
C     k           :: current level index
C     bi, bj      :: tile indices
C     myThid      :: my Thread Id number
      _RL str11(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL str22(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL str33(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL str12(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL str13(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr+1)
      _RL str23(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr+1)
      _RS smag3D_hLsC(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RS smag3D_hLsW(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RS smag3D_hLsS(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RS smag3D_hLsZ(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      INTEGER k, bi, bj
      INTEGER myThid

C     !OUTPUT PARAMETERS:
C     viscAh3d_00 :: Smagorinsky viscosity @ grid-cell center
C     viscAh3d_12 :: Smagorinsky viscosity @ grid-cell corner
C     viscAh3d_13 :: Smagorinsky viscosity @ above uVel
C     viscAh3d_23 :: Smagorinsky viscosity @ above vVel
      _RL viscAh3d_00(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL viscAh3d_12(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL viscAh3d_13(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr+1)
      _RL viscAh3d_23(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr+1)
CEOP

#ifdef ALLOW_SMAG_3D
C     !LOCAL VARIABLES:
C     S66   :: Sum of squared of the 3 strain component @ grid-cell center
C     S12   :: Squared of strain component Vxy @ grid-cell corner
C     S13   :: Squared of strain component Vxz @ above uVel
C     S23   :: Squared of strain component Vyz @ above vVel
      INTEGER i, j
      INTEGER kl, n
      _RL twoThird, tmpFac, locVisc
      _RL S66(1-OLx:sNx+OLx,1-OLy:sNy+OLy,2)
      _RL S12(1-OLx:sNx+OLx,1-OLy:sNy+OLy,2)
      _RL S13(1-OLx:sNx+OLx,1-OLy:sNy+OLy,2)
      _RL S23(1-OLx:sNx+OLx,1-OLy:sNy+OLy,2)

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      twoThird = 2. _d 0 / 3. _d 0

      DO n=1,2
        kl = k + n - 1
        IF ( kl.LE.Nr ) THEN
          DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
             S66(i,j,n) = str11(i,j,kl)**2
     &                  + str22(i,j,kl)**2
     &                  + str33(i,j,kl)**2
             S12(i,j,n) = str12(i,j,kl)**2
           ENDDO
          ENDDO
        ELSE
          DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
             S66(i,j,n) = 0. _d 0
             S12(i,j,n) = 0. _d 0
           ENDDO
          ENDDO
        ENDIF
          DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
             S13(i,j,n) = str13(i,j,kl)**2
             S23(i,j,n) = str23(i,j,kl)**2
           ENDDO
          ENDDO
      ENDDO

C--  ------------------------------------------------------------------
C--  calculate current level Smag viscosity coeff
C--  ------------------------------------------------------------------

C     Current level k --> n=1
      kl = k
      n = 1
      tmpFac = twoRL*SQRT(twoRL)*drF(kl)**twoThird

C     viscAh3d_00 = sqrt( S11+S22+S33+2*(S12+S13+S23) ) @ grid-cell center

      DO j=1-OLy,sNy+OLy-1
       DO i=1-OLx,sNx+OLx-1
         locVisc =
     &    smag3D_hLsC(i,j,bi,bj)*tmpFac*SQRT(
     &            S66( i , j , n )
     &   +  0.5*( S12( i ,j+1, n )+S12(i+1,j+1, n )
     &           +S12( i , j , n )+S12(i+1, j , n ) )
     &   +  0.5*( S13( i , j , n )+S13(i+1, j , n )
     &           +S13( i , j ,n+1)+S13(i+1, j ,n+1) )
     &   +  0.5*( S23( i , j , n )+S23( i ,j+1, n )
     &           +S23( i , j ,n+1)+S23( i ,j+1,n+1) )
     &                                      )
         viscAh3d_00(i,j,kl) = locVisc*smag3D_coeff
#ifdef ALLOW_SMAG_3D_DIFFUSIVITY
         smag3D_diffK(i,j,kl,bi,bj) = locVisc*smag3D_diffCoeff
#endif
       ENDDO
      ENDDO

C     viscAh3d_12 = sqrt( S11+S22+S33+2*(S12+S13+S23) ) @ grid-cell corner

      tmpFac = smag3D_coeff*tmpFac
      DO j=2-OLy,sNy+OLy
       DO i=2-OLx,sNx+OLx
         viscAh3d_12(i,j,kl) =
     &    smag3D_hLsZ(i,j,bi,bj)*tmpFac*SQRT(
     &     0.25*( S66(i-1, j , n )+S66( i , j , n )
     &           +S66(i-1,j-1, n )+S66( i ,j-1, n ) )
     &   + 2.0 *  S12( i , j , n )
     &   + 0.5 *( S13( i ,j-1, n )+S13( i , j , n )
     &           +S13( i ,j-1,n+1)+S13( i , j ,n+1) )
     &   + 0.5 *( S23(i-1, j , n )+S23( i , j , n )
     &           +S23(i-1, j ,n+1)+S23( i , j ,n+1) )
     &                                      )
       ENDDO
      ENDDO

C--  ------------------------------------------------------------------
C--  calculate  next level (k+1) viscosity coeff (uz,vz)
C--  ------------------------------------------------------------------

      IF ( k.EQ.1 ) THEN
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
           viscAh3d_13(i,j,k) = 0. _d 0
           viscAh3d_23(i,j,k) = 0. _d 0
         ENDDO
        ENDDO
      ENDIF

C     Next level k+1 --> n=2
      kl = k+1
      n = 2
      tmpFac = smag3D_coeff*twoRL*SQRT(twoRL)*drC(kl)**twoThird

C     viscAh3d_13 = sqrt( S11+S22+S33+2*(S12+S13+S23) ) @ above uVel

      DO j=1-OLy,sNy+OLy-1
       DO i=2-OLx,sNx+OLx
         viscAh3d_13(i,j,kl) =
     &    smag3D_hLsW(i,j,bi,bj)*tmpFac*SQRT(
     &     0.25*( S66(i-1, j ,n-1)+S66( i , j ,n-1)
     &           +S66(i-1, j , n )+S66( i , j , n ) )
     &   + 0.5 *( S12( i , j ,n-1)+S12( i ,j+1,n-1)
     &           +S12( i , j , n )+S12( i ,j+1, n ) )
     &   + 2.0 *  S13( i , j , n )
     &   + 0.5 *( S23(i-1,j+1, n )+S23( i ,j+1, n )
     &           +S23(i-1, j , n )+S23( i , j , n ) )
     &                                      )
       ENDDO
      ENDDO

C     viscAh3d_23 = sqrt( S11+S22+S33+2*(S12+S13+S23) ) @ above vVel

      DO j=2-OLy,sNy+OLy
       DO i=1-OLx,sNx+OLx-1
         viscAh3d_23(i,j,kl) =
     &    smag3D_hLsS(i,j,bi,bj)*tmpFac*SQRT(
     &     0.25*( S66( i ,j-1,n-1)+S66( i , j ,n-1)
     &           +S66( i ,j-1, n )+S66( i , j , n ) )
     &   + 0.5 *( S12( i , j ,n-1)+S12(i+1, j ,n-1)
     &           +S12( i , j , n )+S12(i+1, j , n ) )
     &   + 0.5 *( S13( i , j , n )+S13(i+1, j , n )
     &           +S13( i ,j-1, n )+S13(i+1,j-1, n ) )
     &   + 2.0 *  S23( i , j , n )
     &                                      )
       ENDDO
      ENDDO

#ifdef ALLOW_DIAGNOSTICS
c     IF ( useDiagnostics.AND. k.EQ.Nr ) THEN
c       CALL DIAGNOSTICS_FILL( viscAh3d_00, 'Smag3D_C',
c    &                         0, Nr, 2, bi, bj, myThid )
c     ENDIF
#endif

#endif /* ALLOW_SMAG_3D */
      RETURN
      END

#include "PACKAGES_CONFIG.h"
#include "CPP_OPTIONS.h"

CBOP
C     !ROUTINE: INI_CURVILINEAR_GRID
C     !INTERFACE:
      SUBROUTINE INI_CURVILINEAR_GRID( myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE INI_CURVILINEAR_GRID
C     | o Initialise curvilinear coordinate system
C     *==========================================================*
C     | Curvilinear grid settings are read from a file rather
C     | than coded in-line as for cartesian and spherical polar.
C     | This is more general but you have to create the grid
C     | yourself.
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#ifdef ALLOW_EXCH2
#include "W2_EXCH2_SIZE.h"
#include "W2_EXCH2_TOPOLOGY.h"
#endif
#ifdef ALLOW_MNC
#include "MNC_PARAMS.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     myThid -  Number of this instance of INI_CURVILINEAR_GRID
      INTEGER myThid

C     !LOCAL VARIABLES:
C     == Shared Local variables ==
      LOGICAL anglesAreSet
      COMMON /LOCAL_INI_CURVILINEAR_GRID/ anglesAreSet
C     == Local variables ==
      INTEGER bi,bj
      INTEGER i,j
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      INTEGER fp
      _RL tmpFac, tmpFac2
#ifdef ALLOW_MNC
      CHARACTER*(MAX_LEN_FNAM) mncFn
#endif
#ifndef OLD_GRID_IO
      INTEGER iG, jG, iL, iLen
      CHARACTER*(MAX_LEN_FNAM) fName
      CHARACTER*(MAX_LEN_MBUF) tmpBuf
      INTEGER  ILNBLNK
      EXTERNAL ILNBLNK
#endif
#ifdef ALLOW_EXCH2
      CHARACTER*(6) fmtStr
      INTEGER iTmp
#endif
CEOP

C--   Set everything to zero everywhere
C     Note: this is now done earlier in main S/R INI_GRID

C     Here we make no assumptions about grid symmetry and simply
C     read the raw grid data from files

#ifdef OLD_GRID_IO
C--   File Precision is different from "new grid IO" (always 64-bits precision)
C     which should probably be changed to the standard file-prec (= readBinaryPrec)
      fp = readBinaryPrec

# ifdef ALLOW_MDSIO
C-    Cell centered quantities
      CALL READ_REC_3D_RS( 'LONC.bin', fp, 1, xC, 1, 0, myThid )
      CALL READ_REC_3D_RS( 'LATC.bin', fp, 1, yC, 1, 0, myThid )
      _EXCH_XY_RS(xC,myThid)
      _EXCH_XY_RS(yC,myThid)

      CALL READ_REC_3D_RS( 'DXF.bin', fp, 1, dxF, 1, 0, myThid )
      CALL READ_REC_3D_RS( 'DYF.bin', fp, 1, dyF, 1, 0, myThid )
      CALL EXCH_UV_AGRID_3D_RS( dxF, dyF, .FALSE., 1, myThid )

      CALL READ_REC_3D_RS( 'RA.bin' , fp, 1, rA,  1, 0, myThid )
      _EXCH_XY_RS(rA,myThid )

      _BEGIN_MASTER(myThid)
      anglesAreSet = .FALSE.
      _END_MASTER(myThid)

C-    Corner quantities
      CALL READ_REC_3D_RS( 'LONG.bin', fp, 1, xG, 1, 0, myThid )
      CALL READ_REC_3D_RS( 'LATG.bin', fp, 1, yG, 1, 0, myThid )
      IF (useCubedSphereExchange) THEN
cs-   this block needed by cubed sphere until we write more useful I/O routines
       IF ( nPx*nPy*nSy.EQ.1 .AND. nSx.EQ.6 ) THEN
        _BARRIER
        _BEGIN_MASTER(myThid)
         bi=3
         bj=1
         yG(1,sNy+1,bj,1)=yG(1,1,bi,1)
         bj=bj+2
         yG(1,sNy+1,bj,1)=yG(1,1,bi,1)
         bj=bj+2
         yG(1,sNy+1,bj,1)=yG(1,1,bi,1)
         bi=6
         bj=2
         yG(sNx+1,1,bj,1)=yG(1,1,bi,1)
         bj=bj+2
         yG(sNx+1,1,bj,1)=yG(1,1,bi,1)
         bj=bj+2
         yG(sNx+1,1,bj,1)=yG(1,1,bi,1)
        _END_MASTER(myThid)
        _BARRIER
       ELSE
        WRITE(msgBuf,'(2A)') 'INI_CURVILINEAR_GRID:',
     &        ' OLD_GRID_IO only works for 6 tiles on 1 proc'
        CALL PRINT_ERROR( msgBuf, myThid )
        STOP 'ABNORMAL END: S/R INI_CURVILINEAR_GRID'
       ENDIF
cs-   end block
      ENDIF
      CALL EXCH_Z_3D_RS( xG, 1, myThid )
      CALL EXCH_Z_3D_RS( yG, 1, myThid )

      CALL READ_REC_3D_RS( 'DXV.bin', fp, 1, dxV, 1, 0, myThid )
      CALL READ_REC_3D_RS( 'DYU.bin', fp, 1, dyU, 1, 0, myThid )
cs-   this block needed by cubed sphere until we write more useful I/O routines
      IF ( useCubedSphereExchange ) THEN
       IF ( nPx*nPy*nSx*nSy.EQ.6 .AND. sNx.EQ.sNy ) THEN
        DO bj = myByLo(myThid), myByHi(myThid)
         DO bi = myBxLo(myThid), myBxHi(myThid)
          dxV(sNx+1,1,bi,bj)=dxV(1,1,bi,bj)
          dxV(1,sNy+1,bi,bj)=dxV(1,1,bi,bj)
          dyU(sNx+1,1,bi,bj)=dyU(1,1,bi,bj)
          dyU(1,sNy+1,bi,bj)=dyU(1,1,bi,bj)
         ENDDO
        ENDDO
       ELSE
        WRITE(msgBuf,'(2A)') 'INI_CURVILINEAR_GRID:',
     &        ' OLD_GRID_IO only works with 1 tile per face'
        CALL PRINT_ERROR( msgBuf, myThid )
        STOP 'ABNORMAL END: S/R INI_CURVILINEAR_GRID'
       ENDIF
cs-   end block
      ENDIF
      CALL EXCH_UV_BGRID_3D_RS( dxV, dyU, .FALSE., 1, myThid )

      CALL READ_REC_3D_RS( 'RAZ.bin', fp, 1, rAz, 1, 0, myThid )
      IF (useCubedSphereExchange) THEN
cs-   this block needed by cubed sphere until we write more useful I/O routines
       DO bj = myByLo(myThid), myByHi(myThid)
        DO bi = myBxLo(myThid), myBxHi(myThid)
         rAz(sNx+1,1,bi,bj)=rAz(1,1,bi,bj)
         rAz(1,sNy+1,bi,bj)=rAz(1,1,bi,bj)
        ENDDO
       ENDDO
cs-   end block
      ENDIF
      CALL EXCH_Z_3D_RS( rAz, 1, myThid )

C-    Staggered (u,v pairs) quantities
      CALL READ_REC_3D_RS( 'DXC.bin', fp, 1, dxC, 1, 0, myThid )
      CALL READ_REC_3D_RS( 'DYC.bin', fp, 1, dyC, 1, 0, myThid )
      CALL EXCH_UV_XY_RS(dxC,dyC,.FALSE.,myThid)

      CALL READ_REC_3D_RS( 'RAW.bin', fp, 1, rAw, 1, 0, myThid )
      CALL READ_REC_3D_RS( 'RAS.bin', fp, 1, rAs, 1, 0, myThid )
      CALL EXCH_UV_XY_RS(rAw,rAs,.FALSE.,myThid)

      CALL READ_REC_3D_RS( 'DXG.bin', fp, 1, dxG, 1, 0, myThid )
      CALL READ_REC_3D_RS( 'DYG.bin', fp, 1, dyG, 1, 0, myThid )
      CALL EXCH_UV_XY_RS(dyG,dxG,.FALSE.,myThid)
# else /* ALLOW_MDSIO */
      WRITE(msgBuf,'(2A)')
     &  'INI_CURVILINEAR_GRID: In order to use OLD_GRID_IO code,'
      CALL PRINT_ERROR( msgBuf, myThid )
      WRITE(msgBuf,'(2A)')
     &  'INI_CURVILINEAR_GRID: needs to compile MDSIO pkg'
      CALL PRINT_ERROR( msgBuf, myThid )
      STOP 'ABNORMAL END: S/R INI_CURVILINEAR_GRID'
# endif /* ALLOW_MDSIO */

c     write(10) xC
c     write(10) yC
c     write(10) dxF
c     write(10) dyF
c     write(10) rA
c     write(10) xG
c     write(10) yG
c     write(10) dxV
c     write(10) dyU
c     write(10) rAz
c     write(10) dxC
c     write(10) dyC
c     write(10) rAw
c     write(10) rAs
c     write(10) dxG
c     write(10) dyG

#else /* ifndef OLD_GRID_IO */

#ifdef ALLOW_MNC
      IF (useMNC .AND. readgrid_mnc) THEN
C--   read NetCDF files:

        DO i = 1,80
          mncFn(i:i) = ' '
        ENDDO
        write(mncFn,'(a)') 'mitgrid'
        DO i = 1,MAX_LEN_MBUF
          msgBuf(i:i) = ' '
        ENDDO
        WRITE(msgBuf,'(2A)') msgBuf,' ; Reading grid info using MNC'
        CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &       SQUEEZE_RIGHT , myThid)
        CALL MNC_FILE_CLOSE_ALL_MATCHING(mncFn, myThid)
        CALL MNC_CW_SET_UDIM(mncFn, 1, myThid)
        CALL MNC_CW_SET_CITER(mncFn, 2, -1, -1, -1, myThid)
        CALL MNC_CW_SET_UDIM(mncFn, 1, myThid)
        CALL MNC_CW_RS_R('D',mncFn,0,0,'XC', xC,  myThid)
        CALL MNC_CW_RS_R('D',mncFn,0,0,'XG', xG,  myThid)
        CALL MNC_CW_RS_R('D',mncFn,0,0,'YC', yC,  myThid)
        CALL MNC_CW_RS_R('D',mncFn,0,0,'YG', yG,  myThid)
        CALL MNC_CW_RS_R('D',mncFn,0,0,'dxC',dxC, myThid)
        CALL MNC_CW_RS_R('D',mncFn,0,0,'dyC',dyC, myThid)
        CALL MNC_CW_RS_R('D',mncFn,0,0,'dxF',dxF, myThid)
        CALL MNC_CW_RS_R('D',mncFn,0,0,'dyF',dyF, myThid)
        CALL MNC_CW_RS_R('D',mncFn,0,0,'dxG',dxG, myThid)
        CALL MNC_CW_RS_R('D',mncFn,0,0,'dyG',dyG, myThid)
        CALL MNC_CW_RS_R('D',mncFn,0,0,'dxV',dxV, myThid)
        CALL MNC_CW_RS_R('D',mncFn,0,0,'dyU',dyU, myThid)
        CALL MNC_CW_RS_R('D',mncFn,0,0,'rA', rA,  myThid)
        CALL MNC_CW_RS_R('D',mncFn,0,0,'rAz',rAz, myThid)
        CALL MNC_CW_RS_R('D',mncFn,0,0,'rAw',rAw, myThid)
        CALL MNC_CW_RS_R('D',mncFn,0,0,'rAs',rAs, myThid)
        CALL MNC_CW_RS_R('D',mncFn,0,0,'AngleCS',angleCosC,myThid)
        CALL MNC_CW_RS_R('D',mncFn,0,0,'AngleSN',angleSinC,myThid)
        anglesAreSet = .TRUE.

      ELSE
C--   read Binary files:
#endif /* ALLOW_MNC */

C--   File Precision: keep 64-bits precision (as it used to be)
C     but should probably change it to the standard file-prec (= readBinaryPrec)
      fp = precFloat64
c     fp = readBinaryPrec

C--   Everyone must wait for the initialisation to be done
      _BARRIER

C--   Only do I/O if I am the master thread
      _BEGIN_MASTER(myThid)

      DO bj = 1,nSy
       DO bi = 1,nSx
#ifdef ALLOW_EXCH2
C-    Use face number:
        jG = W2_myTileList(bi,bj)
        iG = exch2_myface(jG)
        iTmp = MAX(4,1 + INT(LOG10(DFLOAT(W2_maxNbTiles))))
        WRITE(fmtStr,'(A,I1,A)') '(A,I',iTmp,')'
        WRITE(tmpBuf,fmtStr) 'tile:',jG
#else
C-    Tile Id number = Bi + (Bj-1)*(nSx*nPx)  with tile global-indices Bi,Bj
        iG = bi+(myXGlobalLo-1)/sNx
        jG = bj+(myYGlobalLo-1)/sNy
        WRITE(tmpBuf,'(2(A,I3))') 'tile:',iG,' ,',jG
        iG = iG + (jG-1)*(nSx*nPx)
#endif

        iLen = ILNBLNK(horizGridFile)
        IF ( iLen .EQ. 0 ) THEN
          WRITE(fName,'("tile",I3.3,".mitgrid")') iG
        ELSE
          WRITE(fName,'(2A,I3.3,A)') horizGridFile(1:iLen),
     &                              '.face',iG,'.bin'
        ENDIF
        iLen = ILNBLNK(fName)
        iL = ILNBLNK(tmpBuf)
        WRITE(msgBuf,'(3A)') tmpBuf(1:iL),
     &                   ' ; Read from file ',fName(1:iLen)
        CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                      SQUEEZE_RIGHT , myThid)
        WRITE(msgBuf,'(A)') '  =>'

#ifdef ALLOW_MDSIO
        CALL MDS_FACEF_READ_RS( fName, fp, 1,  xC, bi, bj, myThid )
        iL = ILNBLNK(msgBuf)
        WRITE(tmpBuf,'(A,1X,A)') msgBuf(1:iL),'xC'
        CALL MDS_FACEF_READ_RS( fName, fp, 2,  yC, bi, bj, myThid )
        iL = ILNBLNK(tmpBuf)
        WRITE(msgBuf,'(A,1X,A)') tmpBuf(1:iL),'yC'
        CALL MDS_FACEF_READ_RS( fName, fp, 3, dxF, bi, bj, myThid )
        iL = ILNBLNK(msgBuf)
        WRITE(tmpBuf,'(A,1X,A)') msgBuf(1:iL),'dxF'
        CALL MDS_FACEF_READ_RS( fName, fp, 4, dyF, bi, bj, myThid )
        iL = ILNBLNK(tmpBuf)
        WRITE(msgBuf,'(A,1X,A)') tmpBuf(1:iL),'dyF'
        CALL MDS_FACEF_READ_RS( fName, fp, 5,  rA, bi, bj, myThid )
        iL = ILNBLNK(msgBuf)
        WRITE(tmpBuf,'(A,1X,A)') msgBuf(1:iL),'rA'
        CALL MDS_FACEF_READ_RS( fName, fp, 6,  xG, bi, bj, myThid )
        iL = ILNBLNK(tmpBuf)
        WRITE(msgBuf,'(A,1X,A)') tmpBuf(1:iL),'xG'
        CALL MDS_FACEF_READ_RS( fName, fp, 7,  yG, bi, bj, myThid )
        iL = ILNBLNK(msgBuf)
        WRITE(tmpBuf,'(A,1X,A)') msgBuf(1:iL),'yG'
        CALL MDS_FACEF_READ_RS( fName, fp, 8, dxV, bi, bj, myThid )
        iL = ILNBLNK(tmpBuf)
        WRITE(msgBuf,'(A,1X,A)') tmpBuf(1:iL),'dxV'
        CALL MDS_FACEF_READ_RS( fName, fp, 9, dyU, bi, bj, myThid )
        iL = ILNBLNK(msgBuf)
        WRITE(tmpBuf,'(A,1X,A)') msgBuf(1:iL),'dyU'
        CALL MDS_FACEF_READ_RS( fName, fp,10, rAz, bi, bj, myThid )
        iL = ILNBLNK(tmpBuf)
        WRITE(msgBuf,'(A,1X,A)') tmpBuf(1:iL),'rAz'
        CALL MDS_FACEF_READ_RS( fName, fp,11, dxC, bi, bj, myThid )
        iL = ILNBLNK(msgBuf)
        WRITE(tmpBuf,'(A,1X,A)') msgBuf(1:iL),'dxC'
        CALL MDS_FACEF_READ_RS( fName, fp,12, dyC, bi, bj, myThid )
        iL = ILNBLNK(tmpBuf)
        WRITE(msgBuf,'(A,1X,A)') tmpBuf(1:iL),'dyC'
        CALL MDS_FACEF_READ_RS( fName, fp,13, rAw, bi, bj, myThid )
        iL = ILNBLNK(msgBuf)
        WRITE(tmpBuf,'(A,1X,A)') msgBuf(1:iL),'rAw'
        CALL MDS_FACEF_READ_RS( fName, fp,14, rAs, bi, bj, myThid )
        iL = ILNBLNK(tmpBuf)
        WRITE(msgBuf,'(A,1X,A)') tmpBuf(1:iL),'rAs'
        CALL MDS_FACEF_READ_RS( fName, fp,15, dxG, bi, bj, myThid )
        iL = ILNBLNK(msgBuf)
        WRITE(tmpBuf,'(A,1X,A)') msgBuf(1:iL),'dxG'
        CALL MDS_FACEF_READ_RS( fName, fp,16, dyG, bi, bj, myThid )
        iL = ILNBLNK(tmpBuf)
        WRITE(msgBuf,'(A,1X,A)') tmpBuf(1:iL),'dyG'

        iLen = ILNBLNK(horizGridFile)
        IF ( iLen.GT.0 ) THEN
         CALL MDS_FACEF_READ_RS(fName,fp,17,angleCosC,bi,bj,myThid)
         iL = ILNBLNK(msgBuf)
         WRITE(tmpBuf,'(A,1X,A)') msgBuf(1:iL),'AngleCS'
         CALL MDS_FACEF_READ_RS(fName,fp,18,angleSinC,bi,bj,myThid)
         iL = ILNBLNK(tmpBuf)
         WRITE(msgBuf,'(A,1X,A)') tmpBuf(1:iL),'AngleSN'
         anglesAreSet = .TRUE.
        ELSE
         anglesAreSet = .FALSE.
        ENDIF
#else /* ALLOW_MDSIO */
        WRITE(msgBuf,'(2A)')
     &   'INI_CURVILINEAR_GRID: Needs to compile MDSIO pkg'
        CALL PRINT_ERROR( msgBuf, myThid )
        STOP 'ABNORMAL END: S/R INI_CURVILINEAR_GRID'
#endif /* ALLOW_MDSIO */

        CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                      SQUEEZE_RIGHT , myThid)

       ENDDO
      ENDDO

      _END_MASTER(myThid)

#ifdef ALLOW_MNC
      ENDIF
#endif /* ALLOW_MNC */

      CALL EXCH_XY_RS(xC,myThid)
      CALL EXCH_XY_RS(yC,myThid)
      CALL EXCH_UV_AGRID_3D_RS( dxF, dyF, .FALSE., 1, myThid )
      CALL EXCH_XY_RS(rA,myThid )
      CALL EXCH_Z_3D_RS( xG, 1, myThid )
      CALL EXCH_Z_3D_RS( yG, 1, myThid )
      CALL EXCH_UV_BGRID_3D_RS( dxV, dyU, .FALSE., 1, myThid)
      CALL EXCH_Z_3D_RS( rAz, 1, myThid )
      CALL EXCH_UV_XY_RS(dxC,dyC,.FALSE.,myThid)
      CALL EXCH_UV_XY_RS(rAw,rAs,.FALSE.,myThid)
      CALL EXCH_UV_XY_RS(dyG,dxG,.FALSE.,myThid)

#endif /* OLD_GRID_IO */

C--   Scale all grid-factor when original grid-file corresponds to
C     a different planet radius (radius_fromHorizGrid <> rSphere)
      IF ( rSphere.NE.radius_fromHorizGrid ) THEN
        tmpFac = rSphere / radius_fromHorizGrid
        tmpFac2 = tmpFac*tmpFac
        DO bj = myByLo(myThid), myByHi(myThid)
         DO bi = myBxLo(myThid), myBxHi(myThid)
          DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
            dxC(i,j,bi,bj) = dxC(i,j,bi,bj)*tmpFac
            dyC(i,j,bi,bj) = dyC(i,j,bi,bj)*tmpFac
            dxG(i,j,bi,bj) = dxG(i,j,bi,bj)*tmpFac
            dyG(i,j,bi,bj) = dyG(i,j,bi,bj)*tmpFac
            dxF(i,j,bi,bj) = dxF(i,j,bi,bj)*tmpFac
            dyF(i,j,bi,bj) = dyF(i,j,bi,bj)*tmpFac
            dxV(i,j,bi,bj) = dxV(i,j,bi,bj)*tmpFac
            dyU(i,j,bi,bj) = dyU(i,j,bi,bj)*tmpFac
            rA (i,j,bi,bj) = rA (i,j,bi,bj)*tmpFac2
            rAz(i,j,bi,bj) = rAz(i,j,bi,bj)*tmpFac2
            rAw(i,j,bi,bj) = rAw(i,j,bi,bj)*tmpFac2
            rAs(i,j,bi,bj) = rAs(i,j,bi,bj)*tmpFac2
           ENDDO
          ENDDO
         ENDDO
        ENDDO
      ENDIF

C--   Calculate (sines and cosines of) angles of grid north with
C     geographical north when they have not been read from a file
      CALL CALC_GRID_ANGLES( anglesAreSet, myThid )

C--   Exchange Angle (either loaded from file or computed)
      CALL EXCH_UV_AGRID_3D_RS(angleSinC,angleCosC,.TRUE., 1, myThid)

c     CALL WRITE_FULLARRAY_RS('dxV',dxV,1,0,0,1,0,myThid)
c     CALL WRITE_FULLARRAY_RS('dyU',dyU,1,0,0,1,0,myThid)
c     CALL WRITE_FULLARRAY_RS('rAz',rAz,1,0,0,1,0,myThid)
c     CALL WRITE_FULLARRAY_RS('xG' ,xG ,1,0,0,1,0,myThid)
c     CALL WRITE_FULLARRAY_RS('yG' ,yG ,1,0,0,1,0,myThid)

C--   Now let us look at all these beasts
      IF ( plotLevel.GE.debLevC ) THEN
        CALL PLOT_FIELD_XYRS( xC      , 'Current xC      ', 0, myThid )
        CALL PLOT_FIELD_XYRS( yC      , 'Current yC      ', 0, myThid )
        CALL PLOT_FIELD_XYRS( dxF     , 'Current dxF     ', 0, myThid )
        CALL PLOT_FIELD_XYRS( dyF     , 'Current dyF     ', 0, myThid )
        CALL PLOT_FIELD_XYRS( rA      , 'Current rA      ', 0, myThid )
        CALL PLOT_FIELD_XYRS( xG      , 'Current xG      ', 0, myThid )
        CALL PLOT_FIELD_XYRS( yG      , 'Current yG      ', 0, myThid )
        CALL PLOT_FIELD_XYRS( dxV     , 'Current dxV     ', 0, myThid )
        CALL PLOT_FIELD_XYRS( dyU     , 'Current dyU     ', 0, myThid )
        CALL PLOT_FIELD_XYRS( rAz     , 'Current rAz     ', 0, myThid )
        CALL PLOT_FIELD_XYRS( dxC     , 'Current dxC     ', 0, myThid )
        CALL PLOT_FIELD_XYRS( dyC     , 'Current dyC     ', 0, myThid )
        CALL PLOT_FIELD_XYRS( rAw     , 'Current rAw     ', 0, myThid )
        CALL PLOT_FIELD_XYRS( rAs     , 'Current rAs     ', 0, myThid )
        CALL PLOT_FIELD_XYRS( dxG     , 'Current dxG     ', 0, myThid )
        CALL PLOT_FIELD_XYRS( dyG     , 'Current dyG     ', 0, myThid )
        CALL PLOT_FIELD_XYRS(angleCosC, 'Current AngleCS ', 0, myThid )
        CALL PLOT_FIELD_XYRS(angleSinC, 'Current AngleSN ', 0, myThid )
      ENDIF

      RETURN
      END

#include "CPP_EEOPTIONS.h"

CBOP
C     !ROUTINE: BAR_CHECK

C     !INTERFACE:
      SUBROUTINE BAR_CHECK( barrierId, myThid )

C     !DESCRIPTION:
C     *=====================================================================*
C     | SUBROUTINE BAR\_CHECK
C     | o Check threads synchronization in the barrier calling sequence
C     *=====================================================================*
C     | o Apply double BARRIER and check that all threads get the same
C     |   barrierId.
C     *=====================================================================*

C     !USES:
      IMPLICIT NONE
C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
C     == Local common block ==
      INTEGER barStatus(nSx,nSy)
      COMMON / BAR_CHECH_SYNCHRO / barStatus

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     barrierId :: barrier identificator of this instance of BAR_CHECK
C     myThid    :: Thread number of this instance of BAR_CHECK
      INTEGER barrierId
      INTEGER myThid

C     !LOCAL VARIABLES:
C     == Local variables ==
C     bi,bj  :: tile indices
C     msgBuf :: Informational/error meesage buffer
      INTEGER bi,bj
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      LOGICAL flag
CEOP

      IF ( barrierId .NE. 0 ) THEN
C-    Only do checking when barrierId is non-zero

C-    Set barStatus to barrierId :
       DO bj = myByLo(myThid), myByHi(myThid)
        DO bi = myBxLo(myThid), myBxHi(myThid)
          barStatus(bi,bj) = barrierId
        ENDDO
       ENDDO
C-    Synchro
       _BARRIER
C-    Check that all threads have the same barStatus
       flag = .FALSE.
       DO bj = 1,nSy
        DO bi = 1,nSx
          flag = flag .OR. (barStatus(bi,bj).NE.barrierId)
        ENDDO
       ENDDO
       IF ( flag ) THEN
         WRITE(msgBuf,'(A,I4,A,I8)') 'BAR_CHECK: thread', myThid,
     &        ' out of Sync when reaching barrierId=', barrierId
         CALL PRINT_ERROR( msgBuf, myThid )
#ifndef DISABLE_WRITE_TO_UNIT_ZERO
         WRITE(0,*) myThid, barrierId, 'barStatus=', barStatus
#endif
         STOP 'ABNORMAL END: S/R BAR_CHECK: OUT OF SYNC'
       ENDIF

      ENDIF
      
C-    Synchro
      _BARRIER

      RETURN
      END

#include "MOM_FLUXFORM_OPTIONS.h"
#ifdef ALLOW_MOM_COMMON
# include "MOM_COMMON_OPTIONS.h"
#endif

CBOP
C !ROUTINE: MOM_V_YVISCFLUX

C !INTERFACE: ==========================================================
      SUBROUTINE MOM_V_YVISCFLUX(
     I        bi,bj,k,
     I        vFld, del2v,
     O        yViscFluxV,
     I        viscAh_D,viscA4_D,
     I        myThid )

C !DESCRIPTION:
C Calculates the area integrated meridional viscous fluxes of V:
C \begin{equation*}
C F^y = - \frac{ \Delta x_f \Delta r_f h_c }{\Delta y_f}
C  ( A_h \delta_j v - A_4 \delta_j \nabla^2 v )
C \end{equation*}

C !USES: ===============================================================
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"

C !INPUT PARAMETERS: ===================================================
C  bi,bj                :: tile indices
C  k                    :: vertical level
C  vFld                 :: meridional flow
C  del2v                :: Laplacian of meridional flow
C  myThid               :: thread number
      INTEGER bi,bj,k
      _RL vFld(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL del2v(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL viscAh_D(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL viscA4_D(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER myThid

C !OUTPUT PARAMETERS: ==================================================
C  yViscFluxV           :: viscous fluxes
      _RL yViscFluxV(1-OLx:sNx+OLx,1-OLy:sNy+OLy)

C !LOCAL VARIABLES: ====================================================
C  i,j                  :: loop indices
      INTEGER i,j
CEOP

C     - Laplacian  and bi-harmonic terms
      DO j=1-OLy,sNy+OLy-1
       DO i=1-OLx,sNx+OLx-1
        yViscFluxV(i,j) =
     &    _dxF(i,j,bi,bj)*drF(k)*_hFacC(i,j,k,bi,bj)
     &     *(
     &       -viscAh_D(i,j)*( vFld(i,j+1)-vFld(i,j) )
#ifdef ISOTROPIC_COS_SCALING
     &       *cosFacU(j,bi,bj)
#endif
     &       +viscA4_D(i,j)*(del2v(i,j+1)-del2v(i,j))
#ifdef ISOTROPIC_COS_SCALING
#ifdef COSINEMETH_III
     &       *sqCosFacU(j,bi,bj)
#else
     &       *cosFacU(j,bi,bj)
#endif
#endif
     &      )*_recip_dyF(i,j,bi,bj)
c    &       *deepFacC(k)        ! dxF scaling factor
c    &       *recip_deepFacC(k)  ! recip_dyF scaling factor

       ENDDO
      ENDDO

      RETURN
      END

#include "OBCS_OPTIONS.h"

      SUBROUTINE ORLANSKI_INIT(bi, bj, myThid )
C     /==========================================================\
C     | SUBROUTINE ORLANSKI_INIT                                 |
C     | o Initialise storage and phase speed arrays              |
C     |   for Orlanski radiation condition                       |
C     |==========================================================|
C     |                                                          |
C     \==========================================================/
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#ifdef ALLOW_ORLANSKI
#include "ORLANSKI.h"
#endif /* ALLOW_ORLANSKI */

C     == Routine arguments ==
      INTEGER bi, bj, myThid

#ifdef ALLOW_ORLANSKI

C     == Local variables ==
      INTEGER I, J, K

      DO K=1,Nr
        DO I=1-Olx,sNx+Olx
          UN_STORE_1(I,K,bi,bj)=0.
          VN_STORE_1(I,K,bi,bj)=0.
          TN_STORE_1(I,K,bi,bj)=0.
          SN_STORE_1(I,K,bi,bj)=0.
          UN_STORE_2(I,K,bi,bj)=0.
          VN_STORE_2(I,K,bi,bj)=0.
          TN_STORE_2(I,K,bi,bj)=0.
          SN_STORE_2(I,K,bi,bj)=0.
          UN_STORE_3(I,K,bi,bj)=0.
          VN_STORE_3(I,K,bi,bj)=0.
          TN_STORE_3(I,K,bi,bj)=0.
          SN_STORE_3(I,K,bi,bj)=0.
          UN_STORE_4(I,K,bi,bj)=0.
          VN_STORE_4(I,K,bi,bj)=0.
          TN_STORE_4(I,K,bi,bj)=0.
          SN_STORE_4(I,K,bi,bj)=0.
          US_STORE_1(I,K,bi,bj)=0.
          VS_STORE_1(I,K,bi,bj)=0.
          TS_STORE_1(I,K,bi,bj)=0.
          SS_STORE_1(I,K,bi,bj)=0.
          US_STORE_2(I,K,bi,bj)=0.
          VS_STORE_2(I,K,bi,bj)=0.
          TS_STORE_2(I,K,bi,bj)=0.
          SS_STORE_2(I,K,bi,bj)=0.
          US_STORE_3(I,K,bi,bj)=0.
          VS_STORE_3(I,K,bi,bj)=0.
          TS_STORE_3(I,K,bi,bj)=0.
          SS_STORE_3(I,K,bi,bj)=0.
          US_STORE_4(I,K,bi,bj)=0.
          VS_STORE_4(I,K,bi,bj)=0.
          TS_STORE_4(I,K,bi,bj)=0.
          SS_STORE_4(I,K,bi,bj)=0.
          CVEL_UN(I,K,bi,bj)=0.
          CVEL_VN(I,K,bi,bj)=0.
          CVEL_TN(I,K,bi,bj)=0.
          CVEL_SN(I,K,bi,bj)=0.
          CVEL_US(I,K,bi,bj)=0.
          CVEL_VS(I,K,bi,bj)=0.
          CVEL_TS(I,K,bi,bj)=0.
          CVEL_SS(I,K,bi,bj)=0.
#ifdef ALLOW_NONHYDROSTATIC
          WN_STORE_1(I,K,bi,bj)=0.
          WN_STORE_2(I,K,bi,bj)=0.
          WN_STORE_3(I,K,bi,bj)=0.
          WN_STORE_4(I,K,bi,bj)=0.
          WS_STORE_1(I,K,bi,bj)=0.
          WS_STORE_2(I,K,bi,bj)=0.
          WS_STORE_3(I,K,bi,bj)=0.
          WS_STORE_4(I,K,bi,bj)=0.
          CVEL_WN(I,K,bi,bj)=0.
          CVEL_WS(I,K,bi,bj)=0.
#endif
        ENDDO
        DO J=1-Oly,sNy+Oly
          UE_STORE_1(J,K,bi,bj)=0.
          VE_STORE_1(J,K,bi,bj)=0.
          TE_STORE_1(J,K,bi,bj)=0.
          SE_STORE_1(J,K,bi,bj)=0.
          UE_STORE_2(J,K,bi,bj)=0.
          VE_STORE_2(J,K,bi,bj)=0.
          TE_STORE_2(J,K,bi,bj)=0.
          SE_STORE_2(J,K,bi,bj)=0.
          UE_STORE_3(J,K,bi,bj)=0.
          VE_STORE_3(J,K,bi,bj)=0.
          TE_STORE_3(J,K,bi,bj)=0.
          SE_STORE_3(J,K,bi,bj)=0.
          UE_STORE_4(J,K,bi,bj)=0.
          VE_STORE_4(J,K,bi,bj)=0.
          TE_STORE_4(J,K,bi,bj)=0.
          SE_STORE_4(J,K,bi,bj)=0.
          UW_STORE_1(J,K,bi,bj)=0.
          VW_STORE_1(J,K,bi,bj)=0.
          TW_STORE_1(J,K,bi,bj)=0.
          SW_STORE_1(J,K,bi,bj)=0.
          UW_STORE_2(J,K,bi,bj)=0.
          VW_STORE_2(J,K,bi,bj)=0.
          TW_STORE_2(J,K,bi,bj)=0.
          SW_STORE_2(J,K,bi,bj)=0.
          UW_STORE_3(J,K,bi,bj)=0.
          VW_STORE_3(J,K,bi,bj)=0.
          TW_STORE_3(J,K,bi,bj)=0.
          SW_STORE_3(J,K,bi,bj)=0.
          UW_STORE_4(J,K,bi,bj)=0.
          VW_STORE_4(J,K,bi,bj)=0.
          TW_STORE_4(J,K,bi,bj)=0.
          SW_STORE_4(J,K,bi,bj)=0.
          CVEL_UE(J,K,bi,bj)=0.
          CVEL_VE(J,K,bi,bj)=0.
          CVEL_TE(J,K,bi,bj)=0.
          CVEL_SE(J,K,bi,bj)=0.
          CVEL_UW(J,K,bi,bj)=0.
          CVEL_VW(J,K,bi,bj)=0.
          CVEL_TW(J,K,bi,bj)=0.
          CVEL_SW(J,K,bi,bj)=0.
#ifdef ALLOW_NONHYDROSTATIC
          WE_STORE_1(J,K,bi,bj)=0.
          WE_STORE_2(J,K,bi,bj)=0.
          WE_STORE_3(J,K,bi,bj)=0.
          WE_STORE_4(J,K,bi,bj)=0.
          WW_STORE_1(J,K,bi,bj)=0.
          WW_STORE_2(J,K,bi,bj)=0.
          WW_STORE_3(J,K,bi,bj)=0.
          WW_STORE_4(J,K,bi,bj)=0.
          CVEL_WE(J,K,bi,bj)=0.
          CVEL_WW(J,K,bi,bj)=0.
#endif
        ENDDO
      ENDDO

#endif /* ALLOW_ORLANSKI */
      RETURN
      END

#include "PTRACERS_OPTIONS.h"

CBOP 0
C     !ROUTINE: PTRACERS_ZONAL_FILT_APPLY

C     !INTERFACE:
      SUBROUTINE PTRACERS_ZONAL_FILT_APPLY(
     I                                      myThid )

C     !DESCRIPTION:
C     *==========================================================*
C     | S/R PTRACERS_ZONAL_FILT_APPLY
C     | o Apply FFT filter to all passive tracers
C     *==========================================================*

C     !USES:
      IMPLICIT NONE
C     == Global data ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "PTRACERS_SIZE.h"
#include "PTRACERS_PARAMS.h"
#include "PTRACERS_START.h"
#include "PTRACERS_FIELDS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     myThid  :: my Thread Id number
      INTEGER myThid
CEOP

#ifdef ALLOW_ZONAL_FILT

C     !LOCAL VARIABLES:
      INTEGER iTr
      INTEGER bi,bj

      DO iTr = 1,PTRACERS_numInUse
       IF ( PTRACERS_StepFwd(iTr) ) THEN

        DO bj=myByLo(myThid),myByHi(myThid)
         DO bi=myBxLo(myThid),myBxHi(myThid)
          CALL ZONAL_FILTER(
     U                       pTracer(1-OLx,1-OLy,1,bi,bj,iTr),
     I                       hFacC(1-OLx,1-OLy,1,bi,bj),
     I                       1, sNy, Nr, bi, bj, 1, myThid )
         ENDDO
        ENDDO

       ENDIF
      ENDDO

#endif /* ALLOW_ZONAL_FILT */

      RETURN
      END

C modified for external_forcing_DIC.F  August 1999
C
C modified swd Oct 01 and Feb 02, for use as package for c40_patch1
C modified to use with c44 and ptracers: swd May 2002
C modified to have carbonate and biological influences: swd June 2002
C modified for cfc: swd Sep 2003

#include "GCHEM_OPTIONS.h"
#define OCMIP_GRAD
#undef STEPH_GRAD

CBOP
C     !ROUTINE: CFC11_FORCING
C     !INTERFACE:
      SUBROUTINE CFC11_FORCING(
     I                          pTr_CFC11,
     U                          gCFC11,
     I                          bi, bj, iMin, iMax, jMin, jMax,
     I                          myTime, myIter, myThid )

C     !DESCRIPTION:
C     *==========================================================*
C     | SUBROUTINE CFC11_FORCING
C     | o Calculate the changes to CFC11 through air-sea  fluxes
C     *==========================================================*

C     !USES:
      IMPLICIT NONE
C     == GLobal variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "CFC.h"
#include "CFC_ATMOS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     pTr_CFC11  :: ocean CFC11 concentration
C     gCFC11     :: CFC11 tendency
C     bi, bj     :: current tile indices
C     iMin,iMax  :: computation domain, 1rst index bounds
C     jMin,jMax  :: computation domain, 2nd  index bounds
C     myTime     :: current time in simulation
C     myIter     :: current iteration number
C     myThid     :: my Thread Id number
      _RL  pTr_CFC11(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL  gCFC11(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      INTEGER bi, bj
      INTEGER iMin, iMax, jMin, jMax
      _RL  myTime
      INTEGER myIter
      INTEGER myThid
CEOP

#ifdef ALLOW_PTRACERS
#ifdef ALLOW_CFC
C     !FUNCTIONS:
      LOGICAL  DIFFERENT_MULTIPLE
      EXTERNAL DIFFERENT_MULTIPLE

C     !LOCAL VARIABLES:
C     AtmosCFC11 :: atmospheric CFC11 field
C     fluxCFC11  :: air-sea CFC11 fluxes
C     msgBuf     :: message buffer
      _RL  fluxCFC11(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL  AtmosCFC11(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER i, j
      INTEGER intimeP, intime0, intime1, iRec0, iRec1
      _RL cfcTime, aWght, bWght
      _RL ACFC11north, ACFC11south
      _RL recip_dLat, weight
      CHARACTER*(MAX_LEN_MBUF) msgBuf
#ifdef STEPH_GRAD
       _RL a1, a2
#endif

C--   Find atmospheric CFC :
C     assume that cfcTime=0 corresponds to the beginning of the 1rst record
C     time-period. This is consistent with 1rst record value = time-averaged
C     atmos-CFC over time period: cfcTime= 0 to cfcTime= 1 x atmCFC_recSepTime
C---------------------------
       cfcTime = myTime + atmCFC_timeOffset
       CALL GET_PERIODIC_INTERVAL(
     O                   intimeP, intime0, intime1, bWght, aWght,
     I                   zeroRL, atmCFC_recSepTime,
     I                   deltaTclock, cfcTime, myThid )
       iRec0 = MAX( 1, MIN( ACFCnRec, intime0 ) )
       iRec1 = MAX( 1, MIN( ACFCnRec, intime1 ) )
       ACFC11north = ACFC11( iRec0, 1 )*bWght
     &             + ACFC11( iRec1, 1 )*aWght
       ACFC11south = ACFC11( iRec0, 2 )*bWght
     &             + ACFC11( iRec1, 2 )*aWght

C-    Print to check:
       IF ( DIFFERENT_MULTIPLE( CFC_monFreq, myTime, deltaTClock )
     &      .AND. bi*bj.EQ.1 ) THEN
         WRITE(msgBuf,'(A,6X,I10,I6,F9.4,F7.1)')
     &    'CFC11_FORCING: iter,rec0,w0,yr0 =', myIter,
     &        intime0, bWght, ACFCyear(iRec0)
         CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                       SQUEEZE_RIGHT, myThid )
         WRITE(msgBuf,'(A,1PE16.7,I6,0PF9.4,F7.1)')
     &    'CFC11_FORCING: cfcT,rec1,w1,yr1 =', cfcTime,
     &        intime1, aWght, ACFCyear(iRec1)
         CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                       SQUEEZE_RIGHT, myThid )
         WRITE(msgBuf,'(2(A,F14.6))')
     &    'CFC11_FORCING: aCFC11_N =', ACFC11north,
     &                ' , aCFC11_S =', ACFC11south
         CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                       SQUEEZE_RIGHT, myThid )
       ENDIF

C--   Provide gradient between N and S values
#ifdef STEPH_GRAD
C STEPH S INITIAL VERSION
       DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
          if ((j.gt.int(sNy/2)+3.and.j.le.sNy).or.j.lt.1) then
             AtmosCFC11(i,j)=ACFC11north
          endif
          if (j.ge.int(sNy/2)-3.and.j.le.int(sNy/2)+3) then
             a1=(float(j-int(sNy/2)+3)+.5)/7
             a2=1.d0-a1
             AtmosCFC11(i,j)=a1*ACFC11south +
     &                       a2*ACFC11north
          endif
          if ((j.lt.int(sNy/2)-3.and.j.gt.0).or.j.gt.sNy) then
             AtmosCFC11(i,j)=ACFC11south
          endif
        ENDDO
       ENDDO
#endif
#ifdef OCMIP_GRAD
C-    OCMIP VERSION
C     between N & S lat boundaries, do linear interpolation ; and
C     beyond N or S lat boundaries, just take the hemispheric value
       recip_dLat = 1. _d 0 / ( atmCFC_yNorthBnd - atmCFC_ySouthBnd )
       DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
          weight = ( yC(i,j,bi,bj) - atmCFC_ySouthBnd )*recip_dLat
          weight = MAX( zeroRL, MIN( oneRL, weight ) )
          AtmosCFC11(i,j)= weight * ACFC11north
     &         + ( oneRL - weight )*ACFC11south

        ENDDO
c         print*,'QQ cfc11', j, ATMOSCFC11(1,j,bi,bj)
       ENDDO
#endif
C--   cfc11 air-sea fluxes
       CALL CFC11_SURFFORCING(
     I                    pTr_CFC11, AtmosCFC11,
     O                    fluxCFC11,
     I                    bi, bj, iMin, iMax, jMin, jMax,
     I                    myTime, myIter, myThid )

C--   update surface tendencies
       DO j=jMin,jMax
        DO i=iMin,iMax
          gCFC11(i,j,1) = gCFC11(i,j,1)
c    &     + fluxCFC11(i,j)*recip_drF(1)*maskC(i,j,1,bi,bj)
     &     + fluxCFC11(i,j)*recip_drF(1)*recip_hFacC(i,j,1,bi,bj)
        ENDDO
       ENDDO

#endif /* ALLOW_CFC */
#endif /* ALLOW_PTRACERS */

       RETURN
       END

#include "BBL_OPTIONS.h"

CBOP
C     !ROUTINE: BBL_CALC_RHS

C     !INTERFACE:
      SUBROUTINE BBL_CALC_RHS(
     I        myTime, myIter, myThid )

C     !DESCRIPTION:
C     Calculate tendency of tracers due to bottom boundary layer.

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "DYNVARS.h"
#include "BBL.h"

C     !INPUT PARAMETERS:
C     myTime    :: Current time in simulation
C     myIter    :: Current time-step number
C     myThid    :: my Thread Id number
      _RL     myTime
      INTEGER myIter, myThid

C     !OUTPUT PARAMETERS:

C     !LOCAL VARIABLES:
C     bi,bj     :: Tile indices
C     i,j       :: Loop indices
C     d,r       :: Donnor/Receiver indices
C     kBot      :: k index of bottommost wet grid box
C     kLowC1    :: k index of bottommost (i,j) cell
C     kLowC2    :: k index of bottommost (i+1,j) or (i,j+1) cell
C     kl        :: k index at which to compare 2 cells
C     thk_d     :: thickness of donnor bottommost wet grid cell
C     thk_r     :: thickness of receiver bottommost wet grid cell
C     bblEta_d  :: bbl_eta of donnor cell
C     bblEta_r  :: bbl_eta of receiver cell
C     resThk_r  :: thk_r - bblEta_r
C     Theta_r   :: Theta of receiver cell
C     bblTheta_d:: Theta of donnor bbl
C     bblTheta_r:: Theta of receiver bbl
C     resTheta_r:: Theta of resThk_r
C     Salt_r    :: Salt of receiver cell
C     bblSalt_d :: Salt of donnor bbl
C     bblSalt_r :: Salt of receiver bbl
C     resSalt_r :: Salt of resThk_r
C     deltaRho  :: density change
C     deltaDpt  :: depth change
C     dVol      :: horizontal volume transport
C     bbl_tend  :: temporary variable for tendency terms
C     sloc      :: salinity of bottommost wet grid box
C     tloc      :: temperature of bottommost wet grid box
C     rholoc    :: in situ density of bottommost wet grid box
C     rhoBBL    :: in situ density of bottom boundary layer
C     bbl_rho1  :: local (i,j) density
C     bbl_rho2  :: local (i+1, j) or (i,j+1) density
      INTEGER bi, bj
      INTEGER i, j, d, r, kBot, kLowC1, kLowC2, kl
      _RL     thk_d, thk_r, bblEta_d, bblEta_r, resThk_r
      _RL     Theta_r, bblTheta_d, bblTheta_r, resTheta_r
      _RL     Salt_r,  bblSalt_d,  bblSalt_r,  resSalt_r
      _RL     deltaRho, deltaDpt, dVol, bbl_tend
      _RL     sloc   ( 0:sNx+1, 0:sNy+1 )
      _RL     tloc   ( 0:sNx+1, 0:sNy+1 )
      _RL     rholoc ( 0:sNx+1, 0:sNy+1 )
      _RL     rhoBBL ( 0:sNx+1, 0:sNy+1 )
      _RL     bbl_rho1, bbl_rho2
CEOP

C--   Loops on tile indices bi,bj
      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)

C     Initialize tendency terms, make local copy of
C     bottomost temperature, salinity, in-situ density
C     and in-situ BBL density.
        DO j=0,sNy+1
         DO i=0,sNx+1
          bbl_TendTheta(i,j,bi,bj) = 0. _d 0
          bbl_TendSalt (i,j,bi,bj) = 0. _d 0
          kBot        = max(1,kLowC(i,j,bi,bj))
          tLoc(i,j)   = theta(i,j,kBot,bi,bj)
          sLoc(i,j)   = salt (i,j,kBot,bi,bj)
          rholoc(i,j) = rhoInSitu(i,j,kBot,bi,bj)
          IF ( kBot .EQ. Nr ) THEN
           rhoBBL(i,j) = bbl_rho_nr(i,j,bi,bj)
          ELSE
           rhoBBL(i,j) = rhoInSitu(i,j,kBot+1,bi,bj)
          ENDIF
         ENDDO
        ENDDO
 
C==== Compute and apply vertical exchange between BBL and
C     residual volume of botommost wet grid box.
C     This operation does not change total tracer quantity
C     in botommost wet grid box.

        DO j=0,sNy+1
         DO i=0,sNx+1
c        DO j=-oly,sNy+oly
c         DO i=-olx,sNx+olx
          kBot = kLowC(i,j,bi,bj)
          IF ( kBot .GT. 0 ) THEN
C     If model density is lower than BBL, slowly diffuse upward.
           IF ( rhoLoc(i,j) .LT. rhoBBL(i,j) )
     &            bbl_eta(i,j,bi,bj) = max ( 0. _d 0 ,
     &            bbl_eta(i,j,bi,bj) - bbl_wvel * dTtracerLev(kBot) )
C     If model density is higher than BBL then mix instantly.
           IF ( rhoLoc(i,j) .GE. rhoBBL(i,j) .OR.
     &          bbl_eta(i,j,bi,bj) .EQ. 0. _d 0 ) THEN
            bbl_theta(i,j,bi,bj) = tLoc(i,j)
            bbl_salt (i,j,bi,bj) = sLoc(i,j)
            bbl_eta  (i,j,bi,bj) = 0. _d 0
           ENDIF
          ENDIF
         ENDDO
        ENDDO

C==== Compute meridional bbl exchange at northern edge.
        j=sNy
        DO i=0,sNx+1
         kLowC1 = kLowC(i,j  ,bi,bj)
         kLowC2 = kLowC(i,j+1,bi,bj)
         IF ((kLowC1.GT.0).AND.(kLowC2.GT.0)) THEN

C     Compare the bbl densities at the higher pressure
C     (highest possible density of given t,s)
C     bbl in situ density is stored in k > kLowC indices
          kl = MAX(kLowC1,kLowC2) + 1
          deltaDpt = R_low(i,j,bi,bj)   + bbl_eta(i,j,bi,bj) -
     &               R_low(i,j+1,bi,bj) - bbl_eta(i,j+1,bi,bj)
          IF ( deltaDpt .GT. 0. ) THEN
           IF ( kl .GT. Nr ) THEN
            bbl_rho1 = bbl_rho_nr(i,j,bi,bj)
           ELSE
            bbl_rho1 = rhoInSitu(i,j,kl,bi,bj)
           ENDIF
           bbl_rho2 = rhoInSitu(i,j+1,kLowC2,bi,bj)
          ELSE
           bbl_rho1 = rhoInSitu(i,j,kLowC1,bi,bj)
           IF ( kl .GT. Nr ) THEN
            bbl_rho2 = bbl_rho_nr(i,j+1,bi,bj)
           ELSE
            bbl_rho2 = rhoInSitu(i,j+1,kl,bi,bj)
           ENDIF
          ENDIF
          deltaRho = bbl_rho2 - bbl_rho1
          IF ( (deltaRho*deltaDpt) .LT. 0. ) THEN
C     If heavy BBL water is higher than light BBL water,
C     exchange properties laterally.

C     Determine donnor and receiver cells.
           IF ( bbl_rho1 .GT. bbl_rho2 ) THEN
            d = j
            r = j + 1
           ELSE
            d = j + 1
            r = j
           ENDIF

C     Replenish thickness of donor cell, if needed.
           thk_d = drF(kLowC(i,d,bi,bj)) *
     &          hFacC(i,d,kLowC(i,d,bi,bj),bi,bj)
           IF ( ( bbl_theta(i,d,bi,bj) .EQ. tloc(i,d) ) .AND.
     &          ( bbl_salt (i,d,bi,bj) .EQ. sloc(i,d) ) .AND.
     &          ( bbl_eta  (i,d,bi,bj) .LT. bbl_initEta ) )
     &          bbl_eta(i,d,bi,bj) = min ( bbl_initEta, thk_d )

C     Compute some donnor and receiver cell properties.
           thk_r      = drF(kLowC(i,r,bi,bj)) *
     &                  hFacC(i,r,kLowC(i,r,bi,bj),bi,bj)
           Theta_r    = tLoc(i,r)
           Salt_r     = sLoc(i,r)
           bblTheta_d = bbl_theta(i,d,bi,bj)
           bblTheta_r = bbl_theta(i,r,bi,bj)
           bblSalt_d  = bbl_salt (i,d,bi,bj)
           bblSalt_r  = bbl_salt (i,r,bi,bj)
           bblEta_d   = bbl_eta  (i,d,bi,bj)
           bblEta_r   = bbl_eta  (i,r,bi,bj)
           resThk_r   = thk_r - bblEta_r
           resTheta_r = (Theta_r*thk_r-bblTheta_r*bblEta_r)/resThk_r
           resSalt_r  = (Salt_r *thk_r-bblSalt_r *bblEta_r)/resThk_r

C     Compute volume transport from donnor to receiver.
           dVol = min ( bblEta_d * rA(i,d,bi,bj) / 2. _d 0,
     &          resThk_r * rA(i,r,bi,bj) / 2. _d 0,
     &          dxG(i,j+1,bi,bj) * bblEta_d * bbl_hvel * deltaT )

C     Compute temperature tracer tendencies for donor and receiver cell.
           bbl_tend = dVol * (bblTheta_d - resTheta_r) / deltaT
           bbl_TendTheta(i,d,bi,bj) = bbl_TendTheta(i,d,bi,bj) -
     &                                bbl_tend / rA(i,d,bi,bj) / thk_d
           bbl_TendTheta(i,r,bi,bj) = bbl_TendTheta(i,r,bi,bj) +
     &                                bbl_tend / rA(i,r,bi,bj) / thk_r

C     Compute salinity tracer tendencies for donor and receiver cell.
           bbl_tend = dVol * (bblSalt_d - resSalt_r) / deltaT
           bbl_TendSalt(i,d,bi,bj) = bbl_TendSalt(i,d,bi,bj) -
     &                               bbl_tend / rA(i,d,bi,bj) / thk_d
           bbl_TendSalt(i,r,bi,bj) = bbl_TendSalt(i,r,bi,bj) +
     &                               bbl_tend / rA(i,r,bi,bj) / thk_r

C     Adjust pbl thickness and tracer properties.
           bbl_eta(i,d,bi,bj) = bblEta_d - dVol / rA(i,d,bi,bj)
           IF ( bbl_eta(i,d,bi,bj) .LT. 0.0001 ) THEN
            bbl_eta(i,d,bi,bj) = 0. _d 0
            bbl_theta(i,d,bi,bj) = tLoc(i,d)
            bbl_salt (i,d,bi,bj) = sLoc(i,d)
           ENDIF
           bbl_eta(i,r,bi,bj) = bblEta_r + dVol / rA(i,r,bi,bj)
           bbl_theta(i,r,bi,bj) = ( dVol * bblTheta_d +
     &          bblEta_r * rA(i,r,bi,bj) * bblTheta_r ) /
     &          ( bbl_eta(i,r,bi,bj) * rA(i,r,bi,bj) )
           bbl_salt(i,r,bi,bj)  = ( dVol * bblSalt_d  +
     &          bblEta_r * rA(i,r,bi,bj) * bblSalt_r  ) /
     &          ( bbl_eta(i,r,bi,bj) * rA(i,r,bi,bj) )
          ENDIF
         ENDIF
        ENDDO

C==== Compute meridional bbl exchange inside tile.
        DO j=0,sNy-1
         DO i=0,sNx+1
          kLowC1 = kLowC(i,j  ,bi,bj)
          kLowC2 = kLowC(i,j+1,bi,bj)
          IF ((kLowC1.GT.0).AND.(kLowC2.GT.0)) THEN

C     Compare the bbl densities at the higher pressure
C     (highest possible density of given t,s)
C     bbl in situ density is stored in k > kLowC indices
           kl = MAX(kLowC1,kLowC2) + 1
           deltaDpt = R_low(i,j,bi,bj)   + bbl_eta(i,j,bi,bj) -
     &                R_low(i,j+1,bi,bj) - bbl_eta(i,j+1,bi,bj)
           IF ( deltaDpt .GT. 0. ) THEN
            IF ( kl .GT. Nr ) THEN
             bbl_rho1 = bbl_rho_nr(i,j,bi,bj)
            ELSE
             bbl_rho1 = rhoInSitu(i,j,kl,bi,bj)
            ENDIF
            bbl_rho2 = rhoInSitu(i,j+1,kLowC2,bi,bj)
           ELSE
            bbl_rho1 = rhoInSitu(i,j,kLowC1,bi,bj)
            IF ( kl .GT. Nr ) THEN
             bbl_rho2 = bbl_rho_nr(i,j+1,bi,bj)
            ELSE
             bbl_rho2 = rhoInSitu(i,j+1,kl,bi,bj)
            ENDIF
           ENDIF
           deltaRho = bbl_rho2 - bbl_rho1
           IF ( (deltaRho*deltaDpt) .LT. 0. ) THEN
C     If heavy BBL water is higher than light BBL water,
C     exchange properties laterally.

C     Determine donnor and receiver cells.
            IF ( bbl_rho1 .GT. bbl_rho2 ) THEN
             d = j
             r = j + 1
            ELSE
             d = j + 1
             r = j
            ENDIF

C     Replenish thickness of donor cell, if needed.
            thk_d = drF(kLowC(i,d,bi,bj)) *
     &              hFacC(i,d,kLowC(i,d,bi,bj),bi,bj)
            IF ( ( bbl_theta(i,d,bi,bj) .EQ. tloc(i,d) ) .AND.
     &           ( bbl_salt (i,d,bi,bj) .EQ. sloc(i,d) ) .AND.
     &           ( bbl_eta  (i,d,bi,bj) .LT. bbl_initEta ) )
     &           bbl_eta(i,d,bi,bj) = min ( bbl_initEta, thk_d )

C     Compute some donnor and receiver cell properties.
            thk_r      = drF(kLowC(i,r,bi,bj)) *
     &                   hFacC(i,r,kLowC(i,r,bi,bj),bi,bj)
            Theta_r    = tLoc(i,r)
            Salt_r     = sLoc(i,r)
            bblTheta_d = bbl_theta(i,d,bi,bj)
            bblTheta_r = bbl_theta(i,r,bi,bj)
            bblSalt_d  = bbl_salt (i,d,bi,bj)
            bblSalt_r  = bbl_salt (i,r,bi,bj)
            bblEta_d   = bbl_eta  (i,d,bi,bj)
            bblEta_r   = bbl_eta  (i,r,bi,bj)
            resThk_r   = thk_r - bblEta_r
            resTheta_r = (Theta_r*thk_r-bblTheta_r*bblEta_r)/resThk_r
            resSalt_r  = (Salt_r *thk_r-bblSalt_r *bblEta_r)/resThk_r

C     Compute volume transport from donnor to receiver.
            dVol = min ( bblEta_d * rA(i,d,bi,bj) / 2. _d 0,
     &           resThk_r * rA(i,r,bi,bj) / 2. _d 0,
     &           dxG(i,j+1,bi,bj) * bblEta_d * bbl_hvel * deltaT )

C     Compute temperature tracer tendencies for donor and receiver cell.
            bbl_tend = dVol * (bblTheta_d - resTheta_r) / deltaT
            bbl_TendTheta(i,d,bi,bj) = bbl_TendTheta(i,d,bi,bj) -
     &                                 bbl_tend / rA(i,d,bi,bj) / thk_d
            bbl_TendTheta(i,r,bi,bj) = bbl_TendTheta(i,r,bi,bj) +
     &                                 bbl_tend / rA(i,r,bi,bj) / thk_r

C     Compute salinity tracer tendencies for donor and receiver cell.
            bbl_tend = dVol * (bblSalt_d - resSalt_r) / deltaT
            bbl_TendSalt(i,d,bi,bj) = bbl_TendSalt(i,d,bi,bj) -
     &                                bbl_tend / rA(i,d,bi,bj) / thk_d
            bbl_TendSalt(i,r,bi,bj) = bbl_TendSalt(i,r,bi,bj) +
     &                                bbl_tend / rA(i,r,bi,bj) / thk_r

C     Adjust pbl thickness and tracer properties.
            bbl_eta(i,d,bi,bj) = bblEta_d - dVol / rA(i,d,bi,bj)
            IF ( bbl_eta(i,d,bi,bj) .LT. 0.0001 ) THEN
             bbl_eta(i,d,bi,bj) = 0. _d 0
             bbl_theta(i,d,bi,bj) = tLoc(i,d)
             bbl_salt (i,d,bi,bj) = sLoc(i,d)
            ENDIF
            bbl_eta(i,r,bi,bj) = bblEta_r + dVol / rA(i,r,bi,bj)
            bbl_theta(i,r,bi,bj) = ( dVol * bblTheta_d +
     &           bblEta_r * rA(i,r,bi,bj) * bblTheta_r ) /
     &           ( bbl_eta(i,r,bi,bj) * rA(i,r,bi,bj) )
            bbl_salt(i,r,bi,bj)  = ( dVol * bblSalt_d  +
     &           bblEta_r * rA(i,r,bi,bj) * bblSalt_r  ) /
     &           ( bbl_eta(i,r,bi,bj) * rA(i,r,bi,bj) )
           ENDIF
          ENDIF
         ENDDO
        ENDDO

C==== Compute zonal bbl exchange at Eastern edge.
        i=sNx
        DO j=1,sNy
         kLowC1 = kLowC(i  ,j,bi,bj)
         kLowC2 = kLowC(i+1,j,bi,bj)
         IF ((kLowC1.GT.0).AND.(kLowC2.GT.0)) THEN

C     Compare the bbl densities at the higher pressure
C     (highest possible density of given t,s)
C     bbl in situ density is stored in k > kLowC indices
          kl = MAX(kLowC1,kLowC2) + 1
          deltaDpt = R_low(i,j,bi,bj)   + bbl_eta(i,j,bi,bj) -
     &               R_low(i+1,j,bi,bj) - bbl_eta(i+1,j,bi,bj)
          IF ( deltaDpt .GT. 0. ) THEN
           IF ( kl .GT. Nr ) THEN
            bbl_rho1 = bbl_rho_nr(i,j,bi,bj)
           ELSE
            bbl_rho1 = rhoInSitu(i,j,kl,bi,bj)
           ENDIF
           bbl_rho2 = rhoInSitu(i+1,j,kLowC2,bi,bj)
          ELSE
           bbl_rho1 = rhoInSitu(i,j,kLowC1,bi,bj)
           IF ( kl .GT. Nr ) THEN
            bbl_rho2 = bbl_rho_nr(i+1,j,bi,bj)
           ELSE
            bbl_rho2 = rhoInSitu(i+1,j,kl,bi,bj)
           ENDIF
          ENDIF
          deltaRho = bbl_rho2 - bbl_rho1
          IF ( (deltaRho*deltaDpt) .LT. 0. ) THEN
C     If heavy BBL water is higher than light BBL water,
C     exchange properties laterally.

C     Determine donnor and receiver cells.
           IF ( bbl_rho1 .GT. bbl_rho2 ) THEN
            d = i
            r = i + 1
           ELSE
            d = i + 1
            r = i
           ENDIF

C     Replenish thickness of donor cell, if needed.
           thk_d = drF(kLowC(d,j,bi,bj)) *
     &             hFacC(d,j,kLowC(d,j,bi,bj),bi,bj)
           IF ( ( bbl_theta(d,j,bi,bj) .EQ. tloc(d,j) ) .AND.
     &          ( bbl_salt (d,j,bi,bj) .EQ. sloc(d,j) ) .AND.
     &          ( bbl_eta  (d,j,bi,bj) .LT. bbl_initEta ) )
     &          bbl_eta(d,j,bi,bj) = min ( bbl_initEta, thk_d )

C     Compute some donnor and receiver cell properties.
           thk_r      = drF(kLowC(r,j,bi,bj)) *
     &                  hFacC(r,j,kLowC(r,j,bi,bj),bi,bj)
           Theta_r    = tLoc(r,j)
           Salt_r     = sLoc(r,j)
           bblTheta_d = bbl_theta(d,j,bi,bj)
           bblTheta_r = bbl_theta(r,j,bi,bj)
           bblSalt_d  = bbl_salt (d,j,bi,bj)
           bblSalt_r  = bbl_salt (r,j,bi,bj)
           bblEta_d   = bbl_eta  (d,j,bi,bj)
           bblEta_r   = bbl_eta  (r,j,bi,bj)
           resThk_r   = thk_r - bblEta_r
           resTheta_r = (Theta_r*thk_r-bblTheta_r*bblEta_r)/resThk_r
           resSalt_r  = (Salt_r *thk_r-bblSalt_r *bblEta_r)/resThk_r

C     Compute volume transport from donnor to receiver.
           dVol = min ( bblEta_d * rA(d,j,bi,bj) / 2. _d 0,
     &          resThk_r * rA(r,j,bi,bj) / 2. _d 0,
     &          dxG(i+1,j,bi,bj) * bblEta_d * bbl_hvel * deltaT )

C     Compute temperature tracer tendencies for donor and receiver cell.
           bbl_tend = dVol * (bblTheta_d - resTheta_r) / deltaT
           bbl_TendTheta(d,j,bi,bj) = bbl_TendTheta(d,j,bi,bj) -
     &                                bbl_tend / rA(d,j,bi,bj) / thk_d
           bbl_TendTheta(r,j,bi,bj) = bbl_TendTheta(r,j,bi,bj) +
     &                                bbl_tend / rA(r,j,bi,bj) / thk_r

C     Compute salinity tracer tendencies for donor and receiver cell.
           bbl_tend = dVol * (bblSalt_d - resSalt_r) / deltaT
           bbl_TendSalt(d,j,bi,bj) = bbl_TendSalt(d,j,bi,bj) -
     &                               bbl_tend / rA(d,j,bi,bj) / thk_d
           bbl_TendSalt(r,j,bi,bj) = bbl_TendSalt(r,j,bi,bj) +
     &                               bbl_tend / rA(r,j,bi,bj) / thk_r

C     Adjust pbl thickness and tracer properties.
           bbl_eta(d,j,bi,bj) = bblEta_d - dVol / rA(d,j,bi,bj)
           IF ( bbl_eta(d,j,bi,bj) .LT. 0.0001 ) THEN
            bbl_eta(d,j,bi,bj) = 0. _d 0
            bbl_theta(d,j,bi,bj) = tLoc(d,j)
            bbl_salt (d,j,bi,bj) = sLoc(d,j)
           ENDIF
           bbl_eta(r,j,bi,bj) = bblEta_r + dVol / rA(r,j,bi,bj)
           bbl_theta(r,j,bi,bj) = ( dVol * bblTheta_d +
     &          bblEta_r * rA(r,j,bi,bj) * bblTheta_r ) /
     &          ( bbl_eta(r,j,bi,bj) * rA(r,j,bi,bj) )
           bbl_salt(r,j,bi,bj)  = ( dVol * bblSalt_d  +
     &          bblEta_r * rA(r,j,bi,bj) * bblSalt_r  ) /
     &          ( bbl_eta(r,j,bi,bj) * rA(r,j,bi,bj) )
          ENDIF
         ENDIF
        ENDDO

C==== Compute zonal bbl exchange inside tile.
        DO j=1,sNy
         DO i=0,sNx-1
          kLowC1 = kLowC(i  ,j,bi,bj)
          kLowC2 = kLowC(i+1,j,bi,bj)
          IF ((kLowC1.GT.0).AND.(kLowC2.GT.0)) THEN

C     Compare the bbl densities at the higher pressure
C     (highest possible density of given t,s)
C     bbl in situ density is stored in k > kLowC indices
           kl = MAX(kLowC1,kLowC2) + 1
           deltaDpt = R_low(i,j,bi,bj)   + bbl_eta(i,j,bi,bj) -
     &                R_low(i+1,j,bi,bj) - bbl_eta(i+1,j,bi,bj)
           IF ( deltaDpt .GT. 0. ) THEN
            IF ( kl .GT. Nr ) THEN
             bbl_rho1 = bbl_rho_nr(i,j,bi,bj)
            ELSE
             bbl_rho1 = rhoInSitu(i,j,kl,bi,bj)
            ENDIF
            bbl_rho2 = rhoInSitu(i+1,j,kLowC2,bi,bj)
           ELSE
            bbl_rho1 = rhoInSitu(i,j,kLowC1,bi,bj)
            IF ( kl .GT. Nr ) THEN
             bbl_rho2 = bbl_rho_nr(i+1,j,bi,bj)
            ELSE
             bbl_rho2 = rhoInSitu(i+1,j,kl,bi,bj)
            ENDIF
           ENDIF
           deltaRho = bbl_rho2 - bbl_rho1
           IF ( (deltaRho*deltaDpt) .LT. 0. ) THEN
C     If heavy BBL water is higher than light BBL water,
C     exchange properties laterally.

C     Determine donnor and receiver cells.
            IF ( bbl_rho1 .GT. bbl_rho2 ) THEN
             d = i
             r = i + 1
            ELSE
             d = i + 1
             r = i
            ENDIF

C     Replenish thickness of donor cell, if needed.
            thk_d = drF(kLowC(d,j,bi,bj)) *
     &              hFacC(d,j,kLowC(d,j,bi,bj),bi,bj)
            IF ( ( bbl_theta(d,j,bi,bj) .EQ. tloc(d,j) ) .AND.
     &           ( bbl_salt (d,j,bi,bj) .EQ. sloc(d,j) ) .AND.
     &           ( bbl_eta  (d,j,bi,bj) .LT. bbl_initEta ) )
     &           bbl_eta(d,j,bi,bj) = min ( bbl_initEta, thk_d )

C     Compute some donnor and receiver cell properties.
            thk_r      = drF(kLowC(r,j,bi,bj)) *
     &                   hFacC(r,j,kLowC(r,j,bi,bj),bi,bj)
            Theta_r    = tLoc(r,j)
            Salt_r     = sLoc(r,j)
            bblTheta_d = bbl_theta(d,j,bi,bj)
            bblTheta_r = bbl_theta(r,j,bi,bj)
            bblSalt_d  = bbl_salt (d,j,bi,bj)
            bblSalt_r  = bbl_salt (r,j,bi,bj)
            bblEta_d   = bbl_eta  (d,j,bi,bj)
            bblEta_r   = bbl_eta  (r,j,bi,bj)
            resThk_r   = thk_r - bblEta_r
            resTheta_r = (Theta_r*thk_r-bblTheta_r*bblEta_r)/resThk_r
            resSalt_r  = (Salt_r *thk_r-bblSalt_r *bblEta_r)/resThk_r

C     Compute volume transport from donnor to receiver.
            dVol = min ( bblEta_d * rA(d,j,bi,bj) / 2. _d 0,
     &           resThk_r * rA(r,j,bi,bj) / 2. _d 0,
     &           dxG(i+1,j,bi,bj) * bblEta_d * bbl_hvel * deltaT )

C     Compute temperature tracer tendencies for donor and receiver cell.
            bbl_tend = dVol * (bblTheta_d - resTheta_r) / deltaT
            bbl_TendTheta(d,j,bi,bj) = bbl_TendTheta(d,j,bi,bj) -
     &                                 bbl_tend / rA(d,j,bi,bj) / thk_d
            bbl_TendTheta(r,j,bi,bj) = bbl_TendTheta(r,j,bi,bj) +
     &                                 bbl_tend / rA(r,j,bi,bj) / thk_r

C     Compute salinity tracer tendencies for donor and receiver cell.
            bbl_tend = dVol * (bblSalt_d - resSalt_r) / deltaT
            bbl_TendSalt(d,j,bi,bj) = bbl_TendSalt(d,j,bi,bj) -
     &                                bbl_tend / rA(d,j,bi,bj) / thk_d
            bbl_TendSalt(r,j,bi,bj) = bbl_TendSalt(r,j,bi,bj) +
     &                                bbl_tend / rA(r,j,bi,bj) / thk_r

C     Adjust pbl thickness and tracer properties.
            bbl_eta(d,j,bi,bj) = bblEta_d - dVol / rA(d,j,bi,bj)
            IF ( bbl_eta(d,j,bi,bj) .LT. 0.0001 ) THEN
             bbl_eta(d,j,bi,bj) = 0. _d 0
             bbl_theta(d,j,bi,bj) = tLoc(d,j)
             bbl_salt (d,j,bi,bj) = sLoc(d,j)
            ENDIF
            bbl_eta(r,j,bi,bj) = bblEta_r + dVol / rA(r,j,bi,bj)
            bbl_theta(r,j,bi,bj) = ( dVol * bblTheta_d +
     &           bblEta_r * rA(r,j,bi,bj) * bblTheta_r ) /
     &           ( bbl_eta(r,j,bi,bj) * rA(r,j,bi,bj) )
            bbl_salt(r,j,bi,bj)  = ( dVol * bblSalt_d  +
     &           bblEta_r * rA(r,j,bi,bj) * bblSalt_r  ) /
     &           ( bbl_eta(r,j,bi,bj) * rA(r,j,bi,bj) )
           ENDIF
          ENDIF
         ENDDO
        ENDDO

C--   end bi,bj loops.
       ENDDO
      ENDDO

      CALL EXCH_XY_RL( bbl_eta      , myThid )
      CALL EXCH_XY_RL( bbl_theta    , myThid )
      CALL EXCH_XY_RL( bbl_salt     , myThid )
      CALL EXCH_XY_RL( bbl_TendTheta, myThid )
      CALL EXCH_XY_RL( bbl_TendSalt , myThid )

      RETURN
      END

#include "CTRL_OPTIONS.h"

CBOP
C     !ROUTINE: CTRL_DEPTH_INI

C     !INTERFACE:
      SUBROUTINE CTRL_DEPTH_INI( mythid )

C     !DESCRIPTION: \bv
c     *=================================================================
c     | SUBROUTINE ctrl_depth_ini
c     | Add the depth part of the control vector to the model state
c     *=================================================================
C     \ev

C     !USES:
      IMPLICIT NONE
#include "EEPARAMS.h"
#include "SIZE.h"
#include "GRID.h"
#include "CTRL_SIZE.h"
#ifdef ALLOW_GENARR2D_CONTROL
# include "CTRL_GENARR.h"
#endif

C     !INPUT PARAMETERS:
      integer mythid

C     !OUTPUT PARAMETERS:

#ifdef ALLOW_DEPTH_CONTROL
C     !FUNCTIONS:

C     !LOCAL VARIABLES:

      INTEGER bi,bj
      INTEGER i,j
#ifdef ALLOW_GENARR2D_CONTROL
      INTEGER iarr
      INTEGER igen
#endif
      CHARACTER*(MAX_LEN_MBUF) msgbuf
CEOP

      WRITE(msgBuf,'(A,A)') 'CTRL_DEPTH_INI: ctrl update R_low, ',
     &     'adding the control vector.'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &     SQUEEZE_RIGHT, myThid )

C     In contrast to other control variable starting with xx_, this
C     variable not an increment, but a full replacement of R_low, see
C     also GRID.h. This is necessary because TAF gets confused if we do
C     not do it like this.
      DO bj=myByLo(mythid),myByHi(mythid)
       DO bi=myBxLo(mythid),myBxHi(mythid)
        DO j = 1-OLy,sNy+OLy
         DO i = 1-OLx,sNx+OLx
          xx_r_low(i,j,bi,bj) = R_low(i,j,bi,bj)
         ENDDO
        ENDDO
       ENDDO
      ENDDO
#ifdef ALLOW_GENARR2D_CONTROL
C--   use generic 2D control variable infrastructure to set xx_r_low
      igen = 0
      DO iarr = 1, maxCtrlArr2D
       IF ( xx_genarr2d_weight(iarr).NE.' ' .AND.
     &      xx_genarr2d_file(iarr)(1:8).EQ.'xx_depth') igen = iarr
      ENDDO
      IF ( igen .GT. 0 ) THEN
       CALL CTRL_MAP_GENARR2D( xx_r_low, igen, myThid )
      ENDIF
#else
      STOP 'ALLOW_DEPTH_CONTROL only works with ALLOW_GENARR2D_CONTROL'
#endif /* ALLOW_GENARR2D_CONTROL */
#endif /* ALLOW_DEPTH_CONTROL */

      return
      end

#include "LONGSTEP_OPTIONS.h"

CBOP
C     !ROUTINE: LONGSTEP_FILL_3D
C     !INTERFACE:
      SUBROUTINE LONGSTEP_FILL_3D(
     U      lsCnt, lsFld,
     I      fld, myNr, myThid)

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE LONGSTEP_FILL_3D
C     | o update longstep average for one field (incl. overlap)
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     == Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C      lsCnt :: Counter to update
C      lsFld :: average to update
C        fld :: field to accumulate
C       myNr :: number of levels to update
C     myThid :: my Thread Id number
      INTEGER myNr
      _RL lsFld(1-OLx:sNx+OLx,1-OLy:sNy+OLy,myNr,nSx,nSy)
      _RL Fld(1-OLx:sNx+OLx,1-OLy:sNy+OLy,myNr,nSx,nSy)
      INTEGER lsCnt(nSx,nSy)
      INTEGER myThid

#ifdef ALLOW_LONGSTEP
C     !LOCAL VARIABLES:
C     == Local variables ==
      INTEGER i,j,k,bi,bj
CEOP

      DO bj=myByLo(myThid), myByHi(myThid)
       DO bi=myBxLo(myThid), myBxHi(myThid)
        lsCnt(bi,bj) = lsCnt(bi,bj) + 1
        DO k = 1,myNr
         DO j = 1-OLy,sNy+OLy
          DO i = 1-OLx,sNx+OLx
           lsFld(i,j,k,bi,bj) = lsFld(i,j,k,bi,bj) + fld(i,j,k,bi,bj)
          ENDDO
         ENDDO
        ENDDO
       ENDDO
      ENDDO
#endif /* ALLOW_LONGSTEP */

      RETURN
      END

#include "OCN_CPL_OPTIONS.h"

CBOP 0
C !ROUTINE: OCN_EXPORT_FIELDS

C !INTERFACE:
      SUBROUTINE OCN_EXPORT_FIELDS( myIter, myThid )

C !DESCRIPTION:
C     *==========================================================*
C     | SUBROUTINE OCN_EXPORT_FIELDS
C     | o Routine for exporting oceanic fields
C     |   to the coupling layer.
C     *==========================================================*
C     | This version talks to the MIT Coupler. It uses the MIT
C     | Coupler "checkpoint1" library calls.
C     *==========================================================*

C !USES:
      IMPLICIT NONE
C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "CPL_PARAMS.h"
#include "OCNIDS.h"
#include "OCNCPL.h"

C !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     myIter  :: Current timestep number.
C     myThid  :: Thread number for this instance of the routine
      INTEGER myIter
      INTEGER myThid
CEOP

#ifdef COMPONENT_MODULE
C !LOCAL VARIABLES:
C     == Local variables ==

C-    Send Oceanic fields to coupling layer
C  Note: 1) Information is sent on the ocean model grid.
C        2) MIT Coupler checkpoint1 does not allow asynchronous posting of
C          data, so ordering has to be consistent with coupling layer ordering

      _BARRIER
      _BEGIN_MASTER( myThid )

C-    Send Ocean mixed-layer depth to coupling layer
      CALL COMPSEND_R8TILES( ocnMxlDName,
     I     sNx, OLx, sNy, OLy, 1, nSx, nSy, ocMxlD2cpl )

C-    Send sea-surface temperature to coupling layer
      CALL COMPSEND_R8TILES( ocnSSTName,
     I     sNx, OLx, sNy, OLy, 1, nSx, nSy, SSTocn2cpl )

C-    Send sea-surface salinity to coupling layer
      CALL COMPSEND_R8TILES( ocnSSSName,
     I     sNx, OLx, sNy, OLy, 1, nSx, nSy, SSSocn2cpl )

C-    Send ocean surface velocity square to coupling layer
      CALL COMPSEND_R8TILES( ocnSSVsqName,
     I     sNx, OLx, sNy, OLy, 1, nSx, nSy, vSqocn2cpl )

#ifdef ALLOW_DIC
      IF ( ocn_cplExch_DIC ) THEN
C-    Send ocean CO2 flux to coupling layer
        CALL COMPSEND_R8TILES( ocnCO2FluxName,
     I     sNx, OLx, sNy, OLy, 1, nSx, nSy, fluxCO2cpl )
      ENDIF
#endif /* ALLOW_DIC */
#ifdef ALLOW_THSICE
      IF ( ocn_cplExch2W_sIce ) THEN
C-    Send thSIce state-vars to coupling layer
        CALL COMPSEND_R8TILES( ocnSIceFracName,
     I     sNx, OLx, sNy, OLy, 1, nSx, nSy, sIceFrac_cpl )
        CALL COMPSEND_R8TILES( ocnSIceThickName,
     I     sNx, OLx, sNy, OLy, 1, nSx, nSy, sIceThick_cpl )
        CALL COMPSEND_R8TILES( ocnSIceSnowName,
     I     sNx, OLx, sNy, OLy, 1, nSx, nSy, sIceSnowH_cpl )
        CALL COMPSEND_R8TILES( ocnSIceQ1Name,
     I     sNx, OLx, sNy, OLy, 1, nSx, nSy, sIceQ1_cpl )
        CALL COMPSEND_R8TILES( ocnSIceQ2Name,
     I     sNx, OLx, sNy, OLy, 1, nSx, nSy, sIceQ2_cpl )
      ENDIF
#endif /* ALLOW_THSICE */

      _END_MASTER( myThid )
      _BARRIER

#endif /* COMPONENT_MODULE */

      RETURN
      END

#include "MOM_FLUXFORM_OPTIONS.h"
#ifdef ALLOW_MOM_COMMON
# include "MOM_COMMON_OPTIONS.h"
#endif

CBOP
C !ROUTINE: MOM_U_DEL2U

C !INTERFACE: ==========================================================
      SUBROUTINE MOM_U_DEL2U(
     I        bi, bj, k,
     I        uFld, hFacZ, h0FacZ,
     O        del2u,
     I        myThid )

C !DESCRIPTION:
C Calculates the Laplacian of zonal flow

C !USES: ===============================================================
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "SURFACE.h"

C !INPUT PARAMETERS: ===================================================
C  bi,bj                :: tile indices
C  k                    :: vertical level
C  uFld                 :: zonal flow
C  hFacZ                :: fractional thickness at vorticity points
C  h0FacZ               :: fixed fractional thickness at vorticity points
C  myThid               :: my Thread Id number
      INTEGER bi, bj, k
      _RL uFld  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RS hFacZ (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RS h0FacZ(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER myThid

C !OUTPUT PARAMETERS: ==================================================
C  del2u                :: Laplacian
      _RL del2u(1-OLx:sNx+OLx,1-OLy:sNy+OLy)

C !LOCAL VARIABLES: ====================================================
C  i,j                  :: loop indices
      INTEGER i,j
      _RL fZon(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL fMer(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RS hFacZClosedS, hFacZClosedN
CEOP

C     Zonal flux d/dx U
      DO j=1-OLy+1,sNy+OLy-1
       DO i=1-OLx,sNx+OLx-1
        fZon(i,j) = drF(k)*_hFacC(i,j,k,bi,bj)
     &   *_dyF(i,j,bi,bj)
     &   *_recip_dxF(i,j,bi,bj)
     &   *(uFld(i+1,j)-uFld(i,j))
#ifdef COSINEMETH_III
     &   *sqCosFacU(j,bi,bj)
#endif
#ifdef ALLOW_OBCS
     &   *maskInC(i,j,bi,bj)
#endif
c    &   *deepFacC(k)        ! dyF scaling factor
c    &   *recip_deepFacC(k)  ! recip_dxF scaling factor
       ENDDO
      ENDDO

C     Meridional flux d/dy U
      DO j=1-OLy+1,sNy+OLy
       DO i=1-OLx+1,sNx+OLx-1
        fMer(i,j) = drF(k)*hFacZ(i,j)
     &   *_dxV(i,j,bi,bj)
     &   *_recip_dyU(i,j,bi,bj)
     &   *(uFld(i,j)-uFld(i,j-1))
#if (defined (ISOTROPIC_COS_SCALING) && defined (COSINEMETH_III))
     &   *sqCosFacV(j,bi,bj)
#endif
c    &   *deepFacC(k)        ! dxV scaling factor
c    &   *recip_deepFacC(k)  ! recip_dyU scaling factor
       ENDDO
      ENDDO

C     del^2 U
      DO j=1-OLy+1,sNy+OLy-1
       DO i=1-OLx+1,sNx+OLx-1
        del2u(i,j) =
     &   recip_drF(k)*_recip_hFacW(i,j,k,bi,bj)
     &  *recip_rAw(i,j,bi,bj)*recip_deepFac2C(k)
     &  *( fZon(i,j  )    - fZon(i-1,j)
     &    +fMer(i,j+1)    - fMer(i  ,j)
     &   )*_maskW(i,j,k,bi,bj)
#ifdef ALLOW_OBCS
     &    *maskInW(i,j,bi,bj)
#endif
       ENDDO
      ENDDO

      IF (no_slip_sides) THEN
C-- No-slip BCs impose a drag at walls...
       DO j=1-OLy+1,sNy+OLy-1
        DO i=1-OLx+1,sNx+OLx-1
#ifdef NONLIN_FRSURF
         hFacZClosedS = h0FacW(i,j,k,bi,bj) - h0FacZ(i,j)
         hFacZClosedN = h0FacW(i,j,k,bi,bj) - h0FacZ(i,j+1)
#else
         hFacZClosedS = _hFacW(i,j,k,bi,bj) - h0FacZ(i,j)
         hFacZClosedN = _hFacW(i,j,k,bi,bj) - h0FacZ(i,j+1)
#endif
         del2u(i,j) = del2u(i,j)
     &    -_recip_hFacW(i,j,k,bi,bj)
     &       *recip_rAw(i,j,bi,bj)*recip_deepFac2C(k)
     &       *( hFacZClosedS*dxV(i, j ,bi,bj)
     &                      *_recip_dyU(i, j ,bi,bj)
     &         +hFacZClosedN*dxV(i,j+1,bi,bj)
     &                      *_recip_dyU(i,j+1,bi,bj)
     &        )*uFld(i,j)*sideDragFactor
     &         *_maskW(i,j,k,bi,bj)
        ENDDO
       ENDDO
      ENDIF

      RETURN
      END

#include "GRDCHK_OPTIONS.h"
#include "AD_CONFIG.h"

      SUBROUTINE grdchk_print(
     I                         ichknum,
     I                         ierr_grdchk,
     I                         myThid )

C     ==================================================================
C     SUBROUTINE grdchk_print
C     ==================================================================
C
C     o Print the results of the gradient check.
C
C     started: Christian Eckert eckert@mit.edu 08-Mar-2000
C     continued: heimbach@mit.edu: 13-Jun-2001
C
C     ==================================================================
C     SUBROUTINE grdchk_print
C     ==================================================================

      IMPLICIT NONE

C     == global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "GRDCHK.h"

C     == routine arguments ==
      INTEGER ichknum
      INTEGER ierr_grdchk
      INTEGER myThid

#ifdef ALLOW_GRDCHK
C     !FUNCTIONS:
      INTEGER  ILNBLNK
      EXTERNAL ILNBLNK

C     !LOCAL VARIABLES:
      _RL fcref
      _RL fcpertplus, fcpertminus
      _RL xxmemo_ref
      _RL xxmemo_pert
      _RL gfd
      _RL adxxmemo
      _RL ftlxxmemo
      _RL ratio_ad
      _RL ratio_ftl
      _RL ratio_RMS
      INTEGER i
      INTEGER itile
      INTEGER jtile
      INTEGER itilepos
      INTEGER jtilepos
      INTEGER layer
      INTEGER icomp
      INTEGER ierr
      INTEGER numchecks
      INTEGER iL
      CHARACTER*(MAX_LEN_MBUF) msgBuf
CEOP

      iL = ILNBLNK( grdchkvarname )

C--   Print header.
      WRITE(msgBuf,'(A)') ' '
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)')
     & '// ======================================================='
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)')
     & '// Gradient check results  >>> START <<<'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid)
      WRITE(msgBuf,'(A)')
     & '// ======================================================='
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT , myThid )
      WRITE(msgBuf,'(A)') ' '
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )

c     WRITE(msgBuf,'(A,1PE14.6)')
c    & ' EPS = ',grdchk_eps
      WRITE(msgBuf,'(A,1PE13.6,3A)')
     & ' EPS =', grdchk_eps,
     & ' ; grdchk CTRL var/file name: "',grdchkvarname(1:iL),'"'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)') ' '
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )

      WRITE(msgBuf,'(A,2X,4A,3(3X,A),11X,A)')
     & 'grdchk output h.p:', 'Id', ' Itile', ' Jtile',
     & ' LAYER', 'bi', 'bj', 'X(Id)', 'X(Id)+/-EPS'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT , myThid )
      WRITE(msgBuf,'(A,2X,A,A4,1X,2A21)')
     &     'grdchk output h.c:', 'Id', 'FC', 'FC1', 'FC2'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
#ifdef ALLOW_TANGENTLINEAR_RUN
      WRITE(msgBuf,'(A,2X,A,2X,2A18,4X,A18)')
     &     'grdchk output h.g:', 'Id',
     &     'FC1-FC2/(2*EPS)', 'TLM GRAD(FC)', '1-FDGRD/TLMGRD'
#else
      WRITE(msgBuf,'(A,2X,A,2X,2A18,4X,A18)')
     &     'grdchk output h.g:', 'Id',
     &     'FC1-FC2/(2*EPS)', 'ADJ GRAD(FC)', '1-FDGRD/ADGRD'
#endif
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )

C--   Individual checks.
      IF ( ierr_grdchk .EQ. 0 ) THEN
         numchecks = ichknum
      ELSE
         numchecks = maxgrdchecks
      ENDIF

      ratio_RMS = 0.
      DO i = 1, numchecks
        xxmemo_ref   = xxmemref  (i)
        xxmemo_pert  = xxmempert (i)
        adxxmemo     = adxxmem   (i)
        ftlxxmemo    = ftlxxmem  (i)
        fcref        = fcrmem    (i)
        fcpertplus   = fcppmem   (i)
        fcpertminus  = fcpmmem   (i)
        gfd          = gfdmem    (i)
        ratio_ad     = ratioadmem(i)
        ratio_ftl    = ratioftlmem(i)
        itile        = bimem   (i)
        jtile        = bjmem   (i)
        itilepos     = ilocmem (i)
        jtilepos     = jlocmem (i)
        layer        = klocmem (i)
        icomp        = icompmem(i)
        ierr         = ierrmem (i)

        WRITE(msgBuf,'(A)') ' '
        CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
        WRITE(msgBuf,'(A,I4,3I6,2I5,1x,1P2E17.9)')
     &       'grdchk output (p):',
     &       i, itilepos, jtilepos, layer, itile, jtile,
     &       xxmemo_ref, xxmemo_pert
        CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
        IF ( ierr .EQ. 0 ) THEN
          WRITE(msgBuf,'(A,I4,1P3E21.13)')
     &          'grdchk output (c):',
     &          i, fcref, fcpertplus, fcpertminus
          CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                        SQUEEZE_RIGHT, myThid )
#ifdef ALLOW_TANGENTLINEAR_RUN
          ratio_RMS  = ratio_RMS + ratio_ftl*ratio_ftl
          WRITE(msgBuf,'(A,I4,3x,1P3E21.13)')
     &          'grdchk output (g):',
     &         i, gfd, ftlxxmemo, ratio_ftl
#else
          ratio_RMS  = ratio_RMS + ratio_ad*ratio_ad
          WRITE(msgBuf,'(A,I4,3x,1P3E21.13)')
     &          'grdchk output (g):',
     &          i, gfd, adxxmemo, ratio_ad
#endif
          CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                        SQUEEZE_RIGHT, myThid )
        ELSE
          IF ( ierr .EQ. -1 ) THEN
           WRITE(msgBuf,'(A)') ' Component does not exist (zero)'
          ELSEIF ( ierr .EQ. -2 ) THEN
           WRITE(msgBuf,'(A)') ' Component does not exist (negative)'
          ELSEIF ( ierr .EQ. -3 ) THEN
           WRITE(msgBuf,'(A)') ' Component does not exist (too large)'
          ELSEIF ( ierr .EQ. -4 ) THEN
           WRITE(msgBuf,'(A)') ' Component does not exist (land point)'
          ELSE
           WRITE(msgBuf,'(A,I6,A)') ' Unknown error (ierr=', ierr, ' )'
          ENDIF
          CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                        SQUEEZE_RIGHT, myThid )
        ENDIF
      ENDDO

C--   Print final lines.
      IF ( ichknum.GT.1 ) ratio_RMS = ratio_RMS / ichknum
      IF ( ratio_RMS.GT.0. ) ratio_RMS = SQRT( ratio_RMS )
      WRITE(msgBuf,'(A)') ' '
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A,I4,A,1P1E21.13)')
     &  'grdchk  summary  :  RMS of ',ichknum,' ratios =',ratio_RMS
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)') ' '
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)')
     & '// ======================================================='
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)')
     & '// Gradient check results  >>> END <<<'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)')
     & '// ======================================================='
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)') ' '
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )

#endif /* ALLOW_GRDCHK */

      RETURN
      END

#include "STREAMICE_OPTIONS.h"
#ifdef ALLOW_AUTODIFF
# include "AUTODIFF_OPTIONS.h"
#endif
#include "AD_CONFIG.h"

CBOP
C     !ROUTINE: streamice_dump
C     !INTERFACE:
      subroutine streamice_dump( mytime, myiter, myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE streamice_dump                          |
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     == Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "STREAMICE.h"
#include "GRID.h"

      LOGICAL  DIFFERENT_MULTIPLE
      EXTERNAL DIFFERENT_MULTIPLE
      INTEGER  IO_ERRCOUNT
      EXTERNAL IO_ERRCOUNT

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     myIter - iteration counter for this thread
C     myTime - time counter for this thread
C     myThid - Thread number for this instance of the routine.
      integer myThid
      integer myiter
      _RL     mytime

#if (defined (ALLOW_ADJOINT_RUN) || defined (ALLOW_ADMTLM))

C     !LOCAL VARIABLES:
c     == local variables ==
C     suff - Hold suffix part of a filename
C     beginIOErrCount - Begin and end IO error counts
C     endIOErrCount
C     msgBuf - Error message buffer
      CHARACTER*(MAX_LEN_FNAM) suff
      INTEGER beginIOErrCount
      INTEGER endIOErrCount
      CHARACTER*(MAX_LEN_MBUF) msgBuf

c     == end of interface ==
CEOP


#endif /* ALLOW_ADJOINT_RUN */

      RETURN
      END

      SUBROUTINE openad_checkpointinit(uCheckLev1,
     +     uCheckLev2,
     +     uCheckLev3,
     +     uCheckLev4 )

      IMPLICIT NONE

#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"

      integer iloop
      logical haveRemainder, allStepsCovered
      integer  uCheckLev1, uCheckLev2, uCheckLev3,uCheckLev4
      integer  nCheckLev1, nCheckLev2, nCheckLev3,nCheckLev4

      uCheckLev1=0
      uCheckLev2=0
      uCheckLev3=0
      uCheckLev4=0

      open(2,action='read',file='ncheckLev.conf')
      read(2,'(I5,/,I5,/I5,/I5)') nCheckLev1, nCheckLev2, nCheckLev3,
     +nCheckLev4
      close(2)

      write(standardmessageunit,'(A,I4,A,I4,A,I4,A,I8)')
     +'OAD: the_main_loop checkpoints allowed 1st:' ,nCheckLev1,
     +', 2nd:', nCheckLev2,
     +', 3rd:', nCheckLev3,
     +', 4th:', nCheckLev4

cju in this current scheme
cju there is no point in  specifying 1 as the number of checkpoints
cju because for now don't avoid the incidental store of
cju the same checkpoint across multiple levels.
      if (nCheckLev4 .eq. 1 ) then
         uCheckLev4=0
         write(standardmessageunit,'(A)')
     +'OAD: NOTE: resetting level 4 to 0'
      else
         uCheckLev4=nCheckLev4
      end if
      if (nCheckLev3 .eq. 1 ) then
         uCheckLev3=0
         write(standardmessageunit,'(A)')
     +'OAD: NOTE: resetting level 3 to 0'
      else
         uCheckLev3=nCheckLev3
      end if
      if (nCheckLev2 .eq. 1 ) then
         uCheckLev2=0
         write(standardmessageunit,'(A)')
     +'OAD: NOTE: resetting level 2 to 0'
      else
         uCheckLev2=nCheckLev2
      end if
      if (nCheckLev1 .eq. 1 ) then
         uCheckLev1=0
         write(standardmessageunit,'(A)')
     +'OAD: NOTE: resetting level 1 to 0'
      else
         uCheckLev1=nCheckLev1
      end if
cju check sanity
      if (uCheckLev4 .gt. 0 ) then
        if ( uCheckLev3*uCheckLev2*uCheckLev1 .eq. 0) then
           write(errormessageunit,'(A)')
     +'OAD: ERROR: uCheckLev4 > 0 implies ',
     +'all lower levels must be nonzero too.'
        end if
      end if
      if (uCheckLev3 .gt. 0 ) then
        if ( uCheckLev2*uCheckLev1 .eq. 0) then
           write(errormessageunit,'(A)')
     +'OAD: ERROR: uCheckLev3 > 0 implies ',
     +'all lower levels must be nonzero too.'
        end if
      end if
      if (uCheckLev2 .gt. 0 ) then
        if ( uCheckLev1 .eq. 0) then
           write(errormessageunit,'(A)')
     +'OAD: ERROR: uCheckLev2 > 0 implies ',
     +'all lower levels must be nonzero too.'
        end if
      end if
      if (uCheckLev1 .eq. 0 ) then
         write(errormessageunit,'(A)')
     +'OAD: ERROR: uCheckLev1 must be nonzero '
      end if

cju uCheckLev1
      allStepsCovered = .false.
      if (nTimeSteps .lt. uCheckLev1 ) then
         uCheckLev1=nTimeSteps
         allStepsCovered =.true.
      end if

cju uCheckLev2
      if (.NOT. allStepsCovered )  then
         if (MOD(nTimeSteps,uCheckLev1).gt.0)  then
            if((nTimeSteps/uCheckLev1)+1 .le. uCheckLev2 ) then
               uCheckLev2=(nTimeSteps/uCheckLev1)+1
               allStepsCovered =.true.
            end if
         else
            if((nTimeSteps/uCheckLev1) .le. uCheckLev2 ) then
               uCheckLev2=(nTimeSteps/uCheckLev1)
               allStepsCovered =.true.
            end if
         end if
      else
         uCheckLev2 = 0
      end if

cju uCheckLev3
      if (.NOT. allStepsCovered )  then
         if (MOD(nTimeSteps,uCheckLev1*uCheckLev2).gt.0)  then
            if((nTimeSteps/(uCheckLev1*uCheckLev2))+1
     +           .le. uCheckLev3 ) then
               uCheckLev3=(nTimeSteps/(uCheckLev1*uCheckLev2))+1
               allStepsCovered =.true.
            end if
         else
           if((nTimeSteps/(uCheckLev1*uCheckLev2)) .le. uCheckLev3 )then
               uCheckLev3=(nTimeSteps/(uCheckLev1*uCheckLev2))
               allStepsCovered =.true.
            end if
         end if
      else
         uCheckLev3 = 0
      end if

cju uCheckLev4
      if (.NOT. allStepsCovered )  then
         if (MOD(nTimeSteps,uCheckLev1*uCheckLev2*uCheckLev3)
     +        .gt.0)  then
            if((nTimeSteps/(uCheckLev1*uCheckLev2*uCheckLev3))+1
     +           .le. uCheckLev4 ) then
               uCheckLev4=
     +              (nTimeSteps/(uCheckLev1*uCheckLev2*uCheckLev3))+1
               allStepsCovered =.true.
            end if
         else
            if((nTimeSteps/(uCheckLev1*uCheckLev2*uCheckLev3))
     +           .le. uCheckLev4 ) then
               uCheckLev4=
     +              (nTimeSteps/(uCheckLev1*uCheckLev2*uCheckLev3))
               allStepsCovered =.true.
            end if
         end if
      else
         uCheckLev4 = 0
      end if

      if (.NOT. allStepsCovered) then
         write(errormessageunit,'(A)')
     +'OAD: ERROR: not enough checkpoints allowed'
      end if

      write(standardmessageunit,'(A,I6)')
     +'OAD: timesteps required:',ntimesteps
      write(standardmessageunit,'(4(A,I4))')
     +'OAD: the_main_loop checkpoints used    1st:',uCheckLev1,
     +', 2nd:', uCheckLev2,
     +', 3rd:', uCheckLev3,
     +', 4th:', uCheckLev4

      END

#include "OBCS_OPTIONS.h"

C--   File obcs_seaice_sponge.F:
C--    Contents:
C--    o OBCS_SEAICE_SPONGE_A
C--    o OBCS_SEAICE_SPONGE_H
C--    o OBCS_SEAICE_SPONGE_SL
C--    o OBCS_SEAICE_SPONGE_SN

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

CStartOfInterface
      SUBROUTINE OBCS_SEAICE_SPONGE_A( myThid )
C     *==========================================================*
C     | S/R OBCS_SEAICE_SPONGE_A
C     | Adds a relaxation term to AREA near Open-Boundaries
C     *==========================================================*
      IMPLICIT NONE

C     == Global data ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "DYNVARS.h"
#include "OBCS_PARAMS.h"
#include "OBCS_GRID.h"
#include "OBCS_FIELDS.h"
#include "OBCS_SEAICE.h"
#ifdef ALLOW_SEAICE
# include "SEAICE_SIZE.h"
# include "SEAICE_PARAMS.h"
# include "SEAICE.h"
#endif

C     == Routine arguments ==
      INTEGER myThid
CEndOfInterface

#if (defined(ALLOW_OBCS) && defined(ALLOW_SEAICE) && defined(ALLOW_OBCS_SEAICE_SPONGE))
C     == Local variables ==
C     Loop counters
      INTEGER bi, bj, i, j, isl, jsl
      _RL lambda_obcs

      IF ( useSeaiceSponge .AND. seaiceSpongeThickness.NE.0 ) THEN
       DO bj=myByLo(myThid),myByHi(myThid)
        DO bi=myBxLo(myThid),myBxHi(myThid)

C Northern Open Boundary
# ifdef ALLOW_OBCS_NORTH
         IF ( tileHasOBN(bi,bj) ) THEN
          DO i=1,sNx
           IF ( OB_Jn(i,bi,bj).NE.OB_indexNone ) THEN
            DO jsl= 1,seaiceSpongeThickness
             j=OB_Jn(i,bi,bj)-jsl
             IF ((j.ge.1).and.(j.le.sNy)) THEN
              lambda_obcs = (
     &           float(seaiceSpongeThickness-jsl)*Arelaxobcsbound
     &           + float(jsl-1)*Arelaxobcsinner)
     &           / float(seaiceSpongeThickness-1)
              IF (lambda_obcs.ne.0.) THEN
               lambda_obcs = SEAICE_deltaTtherm / lambda_obcs
              ELSE
               lambda_obcs = 0. _d 0
              ENDIF
              AREA(i,j,bi,bj) = AREA(i,j,bi,bj)
     &           - maskC(i,j,1,bi,bj) * lambda_obcs
     &           * ( AREA(i,j,bi,bj) - OBNa(i,bi,bj) )
             ENDIF
            ENDDO
           ENDIF
          ENDDO
         ENDIF
# endif

C Southern Open Boundary
# ifdef ALLOW_OBCS_SOUTH
         IF ( tileHasOBS(bi,bj) ) THEN
          DO i=1,sNx
           IF ( OB_Js(i,bi,bj).NE.OB_indexNone ) THEN
            DO jsl= 1,seaiceSpongeThickness
             j=OB_Js(i,bi,bj)+jsl
             IF ((j.ge.1).and.(j.le.sNy)) THEN
              lambda_obcs = (
     &           float(seaiceSpongeThickness-jsl)*Arelaxobcsbound
     &           + float(jsl-1)*Arelaxobcsinner)
     &           / float(seaiceSpongeThickness-1)
              if (lambda_obcs.ne.0.) then
               lambda_obcs = SEAICE_deltaTtherm / lambda_obcs
              else
               lambda_obcs = 0. _d 0
              endif
              AREA(i,j,bi,bj) = AREA(i,j,bi,bj)
     &           - maskC(i,j,1,bi,bj) * lambda_obcs
     &           * ( AREA(i,j,bi,bj) - OBSa(i,bi,bj) )
             ENDIF
            ENDDO
           ENDIF
          ENDDO
         ENDIF
# endif

C Eastern Open Boundary
# ifdef ALLOW_OBCS_EAST
         IF ( tileHasOBE(bi,bj) ) THEN
          DO j=1,sNy
           IF ( OB_Ie(j,bi,bj).NE.OB_indexNone ) THEN
            DO isl= 1,seaiceSpongeThickness
             i=OB_Ie(j,bi,bj)-isl
             IF ((i.ge.1).and.(i.le.sNx)) THEN
              lambda_obcs = (
     &           float(seaiceSpongeThickness-isl)*Arelaxobcsbound
     &           + float(isl-1)*Arelaxobcsinner)
     &           / float(seaiceSpongeThickness-1)
              if (lambda_obcs.ne.0.) then
               lambda_obcs = SEAICE_deltaTtherm / lambda_obcs
              else
               lambda_obcs = 0. _d 0
              endif
              AREA(i,j,bi,bj) = AREA(i,j,bi,bj)
     &           - maskC(i,j,1,bi,bj) * lambda_obcs
     &           * ( AREA(i,j,bi,bj) - OBEa(j,bi,bj) )
             ENDIF
            ENDDO
           ENDIF
          ENDDO
         ENDIF
# endif

C Western Open Boundary
# ifdef ALLOW_OBCS_WEST
         IF ( tileHasOBW(bi,bj) ) THEN
          DO j=1,sNy
           IF ( OB_Iw(j,bi,bj).NE.OB_indexNone ) THEN
            DO isl= 1,seaiceSpongeThickness
             i=OB_Iw(j,bi,bj)+isl
             IF ((i.ge.1).and.(i.le.sNx)) THEN
              lambda_obcs= (
     &           float(seaiceSpongeThickness-isl)*Arelaxobcsbound
     &           + float(isl-1)*Arelaxobcsinner)
     &           / float(seaiceSpongeThickness-1)
              if (lambda_obcs.ne.0.) then
               lambda_obcs = SEAICE_deltaTtherm / lambda_obcs
              else
               lambda_obcs = 0. _d 0
              endif
              AREA(i,j,bi,bj) = AREA(i,j,bi,bj)
     &           - maskC(i,j,1,bi,bj) * lambda_obcs
     &           * ( AREA(i,j,bi,bj) - OBWa(j,bi,bj) )
             ENDIF
            ENDDO
           ENDIF
          ENDDO
         ENDIF
# endif

        ENDDO
       ENDDO
      ENDIF

#endif /* ALLOW_OBCS & ALLOW_SEAICE & ALLOW_OBCS_SEAICE_SPONGE */

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

CStartOfInterface
      SUBROUTINE OBCS_SEAICE_SPONGE_H( myThid )
C     *==========================================================*
C     | S/R OBCS_SEAICE_SPONGE_H
C     | Adds a relaxation term to HEFF near Open-Boundaries
C     *==========================================================*
      IMPLICIT NONE

C     == Global data ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "DYNVARS.h"
#include "OBCS_PARAMS.h"
#include "OBCS_GRID.h"
#include "OBCS_FIELDS.h"
#include "OBCS_SEAICE.h"
#ifdef ALLOW_SEAICE
# include "SEAICE_SIZE.h"
# include "SEAICE_PARAMS.h"
# include "SEAICE.h"
#endif

C     == Routine arguments ==
      INTEGER myThid
CEndOfInterface

#if (defined(ALLOW_OBCS) && defined(ALLOW_SEAICE) && defined(ALLOW_OBCS_SEAICE_SPONGE))
C     == Local variables ==
C     Loop counters
      INTEGER bi, bj, i, j, isl, jsl
      _RL lambda_obcs

      IF ( useSeaiceSponge .AND. seaiceSpongeThickness.NE.0 ) THEN
       DO bj=myByLo(myThid),myByHi(myThid)
        DO bi=myBxLo(myThid),myBxHi(myThid)

C Northern Open Boundary
# ifdef ALLOW_OBCS_NORTH
         IF ( tileHasOBN(bi,bj) ) THEN
          DO i=1,sNx
           IF ( OB_Jn(i,bi,bj).NE.OB_indexNone ) THEN
            DO jsl= 1,seaiceSpongeThickness
             j=OB_Jn(i,bi,bj)-jsl
             IF ((j.ge.1).and.(j.le.sNy)) THEN
              lambda_obcs = (
     &           float(seaiceSpongeThickness-jsl)*Hrelaxobcsbound
     &           + float(jsl-1)*Hrelaxobcsinner)
     &           / float(seaiceSpongeThickness-1)
              IF (lambda_obcs.ne.0.) THEN
               lambda_obcs = SEAICE_deltaTtherm / lambda_obcs
              ELSE
               lambda_obcs = 0. _d 0
              ENDIF
              HEFF(i,j,bi,bj) = HEFF(i,j,bi,bj)
     &           - maskC(i,j,1,bi,bj) * lambda_obcs
     &           * ( HEFF(i,j,bi,bj) - OBNh(i,bi,bj) )
             ENDIF
            ENDDO
           ENDIF
          ENDDO
         ENDIF
# endif

C Southern Open Boundary
# ifdef ALLOW_OBCS_SOUTH
         IF ( tileHasOBS(bi,bj) ) THEN
          DO i=1,sNx
           IF ( OB_Js(i,bi,bj).NE.OB_indexNone ) THEN
            DO jsl= 1,seaiceSpongeThickness
             j=OB_Js(i,bi,bj)+jsl
             IF ((j.ge.1).and.(j.le.sNy)) THEN
              lambda_obcs = (
     &           float(seaiceSpongeThickness-jsl)*Hrelaxobcsbound
     &           + float(jsl-1)*Hrelaxobcsinner)
     &           / float(seaiceSpongeThickness-1)
              if (lambda_obcs.ne.0.) then
               lambda_obcs = SEAICE_deltaTtherm / lambda_obcs
              else
               lambda_obcs = 0. _d 0
              endif
              HEFF(i,j,bi,bj) = HEFF(i,j,bi,bj)
     &           - maskC(i,j,1,bi,bj) * lambda_obcs
     &           * ( HEFF(i,j,bi,bj) - OBSh(i,bi,bj) )
             ENDIF
            ENDDO
           ENDIF
          ENDDO
         ENDIF
# endif

C Eastern Open Boundary
# ifdef ALLOW_OBCS_EAST
         IF ( tileHasOBE(bi,bj) ) THEN
          DO j=1,sNy
           IF ( OB_Ie(j,bi,bj).NE.OB_indexNone ) THEN
            DO isl= 1,seaiceSpongeThickness
             i=OB_Ie(j,bi,bj)-isl
             IF ((i.ge.1).and.(i.le.sNx)) THEN
              lambda_obcs = (
     &           float(seaiceSpongeThickness-isl)*Hrelaxobcsbound
     &           + float(isl-1)*Hrelaxobcsinner)
     &           / float(seaiceSpongeThickness-1)
              if (lambda_obcs.ne.0.) then
               lambda_obcs = SEAICE_deltaTtherm / lambda_obcs
              else
               lambda_obcs = 0. _d 0
              endif
              HEFF(i,j,bi,bj) = HEFF(i,j,bi,bj)
     &           - maskC(i,j,1,bi,bj) * lambda_obcs
     &           * ( HEFF(i,j,bi,bj) - OBEh(j,bi,bj) )
             ENDIF
            ENDDO
           ENDIF
          ENDDO
         ENDIF
# endif

C Western Open Boundary
# ifdef ALLOW_OBCS_WEST
         IF ( tileHasOBW(bi,bj) ) THEN
          DO j=1,sNy
           IF ( OB_Iw(j,bi,bj).NE.OB_indexNone ) THEN
            DO isl= 1,seaiceSpongeThickness
             i=OB_Iw(j,bi,bj)+isl
             IF ((i.ge.1).and.(i.le.sNx)) THEN
              lambda_obcs= (
     &           float(seaiceSpongeThickness-isl)*Hrelaxobcsbound
     &           + float(isl-1)*Hrelaxobcsinner)
     &           / float(seaiceSpongeThickness-1)
              if (lambda_obcs.ne.0.) then
               lambda_obcs = SEAICE_deltaTtherm / lambda_obcs
              else
               lambda_obcs = 0. _d 0
              endif
              HEFF(i,j,bi,bj) = HEFF(i,j,bi,bj)
     &           - maskC(i,j,1,bi,bj) * lambda_obcs
     &           * ( HEFF(i,j,bi,bj) - OBWh(j,bi,bj) )
             ENDIF
            ENDDO
           ENDIF
          ENDDO
         ENDIF
# endif

        ENDDO
       ENDDO
      ENDIF

#endif /* ALLOW_OBCS & ALLOW_SEAICE & ALLOW_OBCS_SEAICE_SPONGE */

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

CStartOfInterface
      SUBROUTINE OBCS_SEAICE_SPONGE_SL( myThid )
C     *==========================================================*
C     | S/R OBCS_SEAICE_SPONGE_SL
C     | Adds a relaxation term to HSALT near Open-Boundaries
C     *==========================================================*
      IMPLICIT NONE

C     == Global data ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "DYNVARS.h"
#include "OBCS_PARAMS.h"
#include "OBCS_GRID.h"
#include "OBCS_FIELDS.h"
#include "OBCS_SEAICE.h"
#ifdef ALLOW_SEAICE
# include "SEAICE_SIZE.h"
# include "SEAICE_PARAMS.h"
# include "SEAICE.h"
#endif

C     == Routine arguments ==
      INTEGER myThid
CEndOfInterface

#if (defined(ALLOW_OBCS) && defined(ALLOW_SEAICE) && defined(ALLOW_OBCS_SEAICE_SPONGE) && defined(SEAICE_VARIABLE_SALINITY))
C     == Local variables ==
C     Loop counters
      INTEGER bi, bj, i, j, isl, jsl
      _RL lambda_obcs

      IF ( useSeaiceSponge .AND. seaiceSpongeThickness.NE.0 ) THEN
       DO bj=myByLo(myThid),myByHi(myThid)
        DO bi=myBxLo(myThid),myBxHi(myThid)

C Northern Open Boundary
# ifdef ALLOW_OBCS_NORTH
         IF ( tileHasOBN(bi,bj) ) THEN
          DO i=1,sNx
           IF ( OB_Jn(i,bi,bj).NE.OB_indexNone ) THEN
            DO jsl= 1,seaiceSpongeThickness
             j=OB_Jn(i,bi,bj)-jsl
             IF ((j.ge.1).and.(j.le.sNy)) THEN
              lambda_obcs = (
     &           float(seaiceSpongeThickness-jsl)*SLrelaxobcsbound
     &           + float(jsl-1)*SLrelaxobcsinner)
     &           / float(seaiceSpongeThickness-1)
              IF (lambda_obcs.ne.0.) THEN
               lambda_obcs = SEAICE_deltaTtherm / lambda_obcs
              ELSE
               lambda_obcs = 0. _d 0
              ENDIF
              HSALT(i,j,bi,bj) = HSALT(i,j,bi,bj)
     &           - maskC(i,j,1,bi,bj) * lambda_obcs
     &           * ( HSALT(i,j,bi,bj) - OBNsl(i,bi,bj) )
             ENDIF
            ENDDO
           ENDIF
          ENDDO
         ENDIF
# endif

C Southern Open Boundary
# ifdef ALLOW_OBCS_SOUTH
         IF ( tileHasOBS(bi,bj) ) THEN
          DO i=1,sNx
           IF ( OB_Js(i,bi,bj).NE.OB_indexNone ) THEN
            DO jsl= 1,seaiceSpongeThickness
             j=OB_Js(i,bi,bj)+jsl
             IF ((j.ge.1).and.(j.le.sNy)) THEN
              lambda_obcs = (
     &           float(seaiceSpongeThickness-jsl)*SLrelaxobcsbound
     &           + float(jsl-1)*SLrelaxobcsinner)
     &           / float(seaiceSpongeThickness-1)
              if (lambda_obcs.ne.0.) then
               lambda_obcs = SEAICE_deltaTtherm / lambda_obcs
              else
               lambda_obcs = 0. _d 0
              endif
              HSALT(i,j,bi,bj) = HSALT(i,j,bi,bj)
     &           - maskC(i,j,1,bi,bj) * lambda_obcs
     &           * ( HSALT(i,j,bi,bj) - OBSsl(i,bi,bj) )
             ENDIF
            ENDDO
           ENDIF
          ENDDO
         ENDIF
# endif

C Eastern Open Boundary
# ifdef ALLOW_OBCS_EAST
         IF ( tileHasOBE(bi,bj) ) THEN
          DO j=1,sNy
           IF ( OB_Ie(j,bi,bj).NE.OB_indexNone ) THEN
            DO isl= 1,seaiceSpongeThickness
             i=OB_Ie(j,bi,bj)-isl
             IF ((i.ge.1).and.(i.le.sNx)) THEN
              lambda_obcs = (
     &           float(seaiceSpongeThickness-isl)*SLrelaxobcsbound
     &           + float(isl-1)*SLrelaxobcsinner)
     &           / float(seaiceSpongeThickness-1)
              if (lambda_obcs.ne.0.) then
               lambda_obcs = SEAICE_deltaTtherm / lambda_obcs
              else
               lambda_obcs = 0. _d 0
              endif
              HSALT(i,j,bi,bj) = HSALT(i,j,bi,bj)
     &           - maskC(i,j,1,bi,bj) * lambda_obcs
     &           * ( HSALT(i,j,bi,bj) - OBEsl(j,bi,bj) )
             ENDIF
            ENDDO
           ENDIF
          ENDDO
         ENDIF
# endif

C Western Open Boundary
# ifdef ALLOW_OBCS_WEST
         IF ( tileHasOBW(bi,bj) ) THEN
          DO j=1,sNy
           IF ( OB_Iw(j,bi,bj).NE.OB_indexNone ) THEN
            DO isl= 1,seaiceSpongeThickness
             i=OB_Iw(j,bi,bj)+isl
             IF ((i.ge.1).and.(i.le.sNx)) THEN
              lambda_obcs= (
     &           float(seaiceSpongeThickness-isl)*SLrelaxobcsbound
     &           + float(isl-1)*SLrelaxobcsinner)
     &           / float(seaiceSpongeThickness-1)
              if (lambda_obcs.ne.0.) then
               lambda_obcs = SEAICE_deltaTtherm / lambda_obcs
              else
               lambda_obcs = 0. _d 0
              endif
              HSALT(i,j,bi,bj) = HSALT(i,j,bi,bj)
     &           - maskC(i,j,1,bi,bj) * lambda_obcs
     &           * ( HSALT(i,j,bi,bj) - OBWsl(j,bi,bj) )
             ENDIF
            ENDDO
           ENDIF
          ENDDO
         ENDIF
# endif

        ENDDO
       ENDDO
      ENDIF

#endif /* ALLOW_OBCS & ALLOW_SEAICE & ALLOW_OBCS_SEAICE_SPONGE & SEAICE_VARIABLE_SALINITY */

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

CStartOfInterface
      SUBROUTINE OBCS_SEAICE_SPONGE_SN( myThid )
C     *==========================================================*
C     | S/R OBCS_SEAICE_SPONGE_SN
C     | Adds a relaxation term to HSNOW near Open-Boundaries
C     *==========================================================*
      IMPLICIT NONE

C     == Global data ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "DYNVARS.h"
#include "OBCS_PARAMS.h"
#include "OBCS_GRID.h"
#include "OBCS_FIELDS.h"
#include "OBCS_SEAICE.h"
#ifdef ALLOW_SEAICE
# include "SEAICE_SIZE.h"
# include "SEAICE_PARAMS.h"
# include "SEAICE.h"
#endif

C     == Routine arguments ==
      INTEGER myThid
CEndOfInterface

#if (defined(ALLOW_OBCS) && defined(ALLOW_SEAICE) && defined(ALLOW_OBCS_SEAICE_SPONGE))
C     == Local variables ==
C     Loop counters
      INTEGER bi, bj, i, j, isl, jsl
      _RL lambda_obcs

      IF ( useSeaiceSponge .AND. seaiceSpongeThickness.NE.0 ) THEN
       DO bj=myByLo(myThid),myByHi(myThid)
        DO bi=myBxLo(myThid),myBxHi(myThid)

C Northern Open Boundary
# ifdef ALLOW_OBCS_NORTH
         IF ( tileHasOBN(bi,bj) ) THEN
          DO i=1,sNx
           IF ( OB_Jn(i,bi,bj).NE.OB_indexNone ) THEN
            DO jsl= 1,seaiceSpongeThickness
             j=OB_Jn(i,bi,bj)-jsl
             IF ((j.ge.1).and.(j.le.sNy)) THEN
              lambda_obcs = (
     &           float(seaiceSpongeThickness-jsl)*SNrelaxobcsbound
     &           + float(jsl-1)*SNrelaxobcsinner)
     &           / float(seaiceSpongeThickness-1)
              IF (lambda_obcs.ne.0.) THEN
               lambda_obcs = SEAICE_deltaTtherm / lambda_obcs
              ELSE
               lambda_obcs = 0. _d 0
              ENDIF
              HSNOW(i,j,bi,bj) = HSNOW(i,j,bi,bj)
     &           - maskC(i,j,1,bi,bj) * lambda_obcs
     &           * ( HSNOW(i,j,bi,bj) - OBNsn(i,bi,bj) )
             ENDIF
            ENDDO
           ENDIF
          ENDDO
         ENDIF
# endif

C Southern Open Boundary
# ifdef ALLOW_OBCS_SOUTH
         IF ( tileHasOBS(bi,bj) ) THEN
          DO i=1,sNx
           IF ( OB_Js(i,bi,bj).NE.OB_indexNone ) THEN
            DO jsl= 1,seaiceSpongeThickness
             j=OB_Js(i,bi,bj)+jsl
             IF ((j.ge.1).and.(j.le.sNy)) THEN
              lambda_obcs = (
     &           float(seaiceSpongeThickness-jsl)*SNrelaxobcsbound
     &           + float(jsl-1)*SNrelaxobcsinner)
     &           / float(seaiceSpongeThickness-1)
              if (lambda_obcs.ne.0.) then
               lambda_obcs = SEAICE_deltaTtherm / lambda_obcs
              else
               lambda_obcs = 0. _d 0
              endif
              HSNOW(i,j,bi,bj) = HSNOW(i,j,bi,bj)
     &           - maskC(i,j,1,bi,bj) * lambda_obcs
     &           * ( HSNOW(i,j,bi,bj) - OBSsn(i,bi,bj) )
             ENDIF
            ENDDO
           ENDIF
          ENDDO
         ENDIF
# endif

C Eastern Open Boundary
# ifdef ALLOW_OBCS_EAST
         IF ( tileHasOBE(bi,bj) ) THEN
          DO j=1,sNy
           IF ( OB_Ie(j,bi,bj).NE.OB_indexNone ) THEN
            DO isl= 1,seaiceSpongeThickness
             i=OB_Ie(j,bi,bj)-isl
             IF ((i.ge.1).and.(i.le.sNx)) THEN
              lambda_obcs = (
     &           float(seaiceSpongeThickness-isl)*SNrelaxobcsbound
     &           + float(isl-1)*SNrelaxobcsinner)
     &           / float(seaiceSpongeThickness-1)
              if (lambda_obcs.ne.0.) then
               lambda_obcs = SEAICE_deltaTtherm / lambda_obcs
              else
               lambda_obcs = 0. _d 0
              endif
              HSNOW(i,j,bi,bj) = HSNOW(i,j,bi,bj)
     &           - maskC(i,j,1,bi,bj) * lambda_obcs
     &           * ( HSNOW(i,j,bi,bj) - OBEsn(j,bi,bj) )
             ENDIF
            ENDDO
           ENDIF
          ENDDO
         ENDIF
# endif

C Western Open Boundary
# ifdef ALLOW_OBCS_WEST
         IF ( tileHasOBW(bi,bj) ) THEN
          DO j=1,sNy
           IF ( OB_Iw(j,bi,bj).NE.OB_indexNone ) THEN
            DO isl= 1,seaiceSpongeThickness
             i=OB_Iw(j,bi,bj)+isl
             IF ((i.ge.1).and.(i.le.sNx)) THEN
              lambda_obcs= (
     &           float(seaiceSpongeThickness-isl)*SNrelaxobcsbound
     &           + float(isl-1)*SNrelaxobcsinner)
     &           / float(seaiceSpongeThickness-1)
              if (lambda_obcs.ne.0.) then
               lambda_obcs = SEAICE_deltaTtherm / lambda_obcs
              else
               lambda_obcs = 0. _d 0
              endif
              HSNOW(i,j,bi,bj) = HSNOW(i,j,bi,bj)
     &           - maskC(i,j,1,bi,bj) * lambda_obcs
     &           * ( HSNOW(i,j,bi,bj) - OBWsn(j,bi,bj) )
             ENDIF
            ENDDO
           ENDIF
          ENDDO
         ENDIF
# endif

        ENDDO
       ENDDO
      ENDIF

#endif /* ALLOW_OBCS & ALLOW_SEAICE & ALLOW_OBCS_SEAICE_SPONGE */

      RETURN
      END

#include "ECCO_OPTIONS.h"

C--  File ecco_check.F:
C--   Contents
C--   o ECCO_CHECK
C--   o ECCO_CHECK_FILES

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      SUBROUTINE ECCO_CHECK( myThid )
C     *==========================================================*
C     | SUBROUTINE ECCO_CHECK                                    |
C     | o Check runtime activated packages have been built in.   |
C     *==========================================================*
C     | All packages can be selected/deselected at build time    |
C     | ( when code is compiled ) and activated/deactivated at   |
C     | runtime. This routine does a quick check to trap packages|
C     | that were activated at runtime but that were not compiled|
C     | in at build time.                                        |
C     *==========================================================*
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "ECCO_SIZE.h"
#include "ECCO.h"

C     === Routine arguments ===
C     myThid -  Number of this instances
      INTEGER myThid

c     == external functions ==
      INTEGER  ILNBLNK
      EXTERNAL ILNBLNK

C     === Local variables ===
C     msgBuf      - Informational/error message buffer
      CHARACTER*(MAX_LEN_MBUF) msgBuf
#ifdef ALLOW_GENCOST_CONTRIBUTION
      INTEGER igen_etagcm, il
      INTEGER igen_tp, igen_ers, igen_gfo, use_mon_int, use_day_int
      LOGICAL exst
      CHARACTER*(128) tempfile
      INTEGER icount_transp
      INTEGER k
#endif
      INTEGER nRetired

      _BEGIN_MASTER(myThid)

      WRITE(msgBuf,'(2A)') 'ECCO_CHECK: ',
     &                     ' --> Starts to check ECCO set-up'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )

c ============ retired compile option checks
      nRetired = 0

#ifdef ALLOW_MEAN_HFLUX_COST_CONTRIBUTION
           WRITE(msgBuf,'(3A)') '** WARNING ** ECCO_CHECK:',
     &      'ALLOW_MEAN_HFLUX_COST_CONTRIBUTION has no',
     &      'effect since cost_mean_heatflux has been retired'
           CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                     SQUEEZE_RIGHT , myThid )
       nRetired = nRetired + 1
#endif
#ifdef ALLOW_MEAN_SFLUX_COST_CONTRIBUTION
           WRITE(msgBuf,'(3A)') '** WARNING ** ECCO_CHECK:',
     &      'ALLOW_MEAN_SFLUX_COST_CONTRIBUTION has no',
     &      'effect since cost_mean_saltflux has been retired'
           CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                     SQUEEZE_RIGHT , myThid )
       nRetired = nRetired + 1
#endif
#ifdef ALLOW_SSH_GLOBMEAN_COST_CONTRIBUTION
           WRITE(msgBuf,'(3A)') '** WARNING ** ECCO_CHECK:',
     &      'ALLOW_SSH_GLOBMEAN_COST_CONTRIBUTION has no',
     &      'effect since cost_ssh_globmean has been retired'
           CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                     SQUEEZE_RIGHT , myThid )
       nRetired = nRetired + 1
#endif
#ifdef ALLOW_NEW_SSH_COST
           WRITE(msgBuf,'(3A)') '** WARNING ** ECCO_CHECK:',
     &      'ALLOW_NEW_SSH_COST has no',
     &      'effect since cost_ssh_new has been retired'
           CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                     SQUEEZE_RIGHT , myThid )
       nRetired = nRetired + 1
#endif
#ifdef ALLOW_CURMTR_COST_CONTRIBUTION
           WRITE(msgBuf,'(3A)') '** WARNING ** ECCO_CHECK:',
     &      'ALLOW_CURMTR_COST_CONTRIBUTION has no',
     &      'effect since cost_curmtr has been retired'
           CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                     SQUEEZE_RIGHT , myThid )
       nRetired = nRetired + 1
#endif
#ifdef ALLOW_DRIFTER_COST_CONTRIBUTION
           WRITE(msgBuf,'(3A)') '** WARNING ** ECCO_CHECK:',
     &      'ALLOW_DRIFTER_COST_CONTRIBUTION has no',
     &      'effect since cost_drifter has been retired'
           CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                     SQUEEZE_RIGHT , myThid )
       nRetired = nRetired + 1
#endif
#ifdef ALLOW_BP_COST_CONTRIBUTION
        WRITE(msgBuf,'(3A)') 'ECCO_CHECK:',
     &      ' "ALLOW_BP_COST_CONTRIBUTION" has been removed',
     &      ' since cost_bp has been retired'
        CALL PRINT_ERROR( msgBuf, myThid )
        nRetired = nRetired + 1
#endif
#ifdef ALLOW_SCAT_COST_CONTRIBUTION
           WRITE(msgBuf,'(3A)') '** WARNING ** ECCO_CHECK:',
     &      'ALLOW_SCAT_COST_CONTRIBUTION has no',
     &      'effect since cost_scat etc has been retired'
           CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                     SQUEEZE_RIGHT , myThid )
       nRetired = nRetired + 1
#endif
#ifdef ALLOW_DAILYSCAT_COST_CONTRIBUTION
           WRITE(msgBuf,'(3A)') '** WARNING ** ECCO_CHECK:',
     &      'ALLOW_DAILYSCAT_COST_CONTRIBUTION has no',
     &      'effect since cost_scat etc has been retired'
           CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                     SQUEEZE_RIGHT , myThid )
       nRetired = nRetired + 1
#endif
#ifdef ALLOW_DRIFT_COST_CONTRIBUTION
           WRITE(msgBuf,'(3A)') '** WARNING ** ECCO_CHECK:',
     &      'ALLOW_DRIFT_COST_CONTRIBUTION has no',
     &      'effect since cost_drift has been retired'
           CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                     SQUEEZE_RIGHT , myThid )
       nRetired = nRetired + 1
#endif
#ifdef ALLOW_DRIFTW_COST_CONTRIBUTION
           WRITE(msgBuf,'(3A)') '** WARNING ** ECCO_CHECK:',
     &      'ALLOW_DRIFTW_COST_CONTRIBUTION has no',
     &      'effect since cost_driftw has been retired'
           CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                     SQUEEZE_RIGHT , myThid )
       nRetired = nRetired + 1
#endif
#ifdef ALLOW_COST_INI_FIN
           WRITE(msgBuf,'(3A)') '** WARNING ** ECCO_CHECK:',
     &      'ALLOW_COST_INI_FIN has no',
     &      'effect since cost_theta_ini_fin etc has been retired'
           CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                     SQUEEZE_RIGHT , myThid )
       nRetired = nRetired + 1
#endif
#ifdef ALLOW_COST_TRANSPORT
           WRITE(msgBuf,'(3A)') '** WARNING ** ECCO_CHECK:',
     &      'ALLOW_COST_TRANSPORT has no',
     &      'effect since cost_trans_merid etc has been retired'
           CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                     SQUEEZE_RIGHT , myThid )
       nRetired = nRetired + 1
#endif
#ifdef ALLOW_COST_ATLANTIC
           WRITE(msgBuf,'(3A)') '** WARNING ** ECCO_CHECK:',
     &      'ALLOW_COST_ATLANTIC has no',
     &      'effect since cost_atlantic has been retired'
           CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                     SQUEEZE_RIGHT , myThid )
       nRetired = nRetired + 1
#endif
#ifdef ALLOW_TRANSPORT_COST_CONTRIBUTION
           WRITE(msgBuf,'(3A)') '** WARNING ** ECCO_CHECK:',
     &      'ALLOW_TRANSPORT_COST_CONTRIBUTION has no',
     &      'effect since cost_gen_transport has been retired'
           CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                     SQUEEZE_RIGHT , myThid )
       nRetired = nRetired + 1
#endif
#ifdef ALLOW_EGM96_ERROR_COV
           WRITE(msgBuf,'(3A)') '** WARNING ** ECCO_CHECK:',
     &      'ALLOW_EGM96_ERROR_COV has no',
     &      'effect since cost_geoid etc has been retired'
           CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                     SQUEEZE_RIGHT , myThid )
       nRetired = nRetired + 1
#endif
#ifdef ALLOW_IESTAU_COST_CONTRIBUTION
           WRITE(msgBuf,'(3A)') '** WARNING ** ECCO_CHECK:',
     &      'ALLOW_IESTAU_COST_CONTRIBUTION has no',
     &      'effect since cost_ies etc has been retired'
           CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                     SQUEEZE_RIGHT , myThid )
       nRetired = nRetired + 1
#endif
#ifdef ALLOW_SIGMAR_COST_CONTRIBUTION
           WRITE(msgBuf,'(3A)') '** WARNING ** ECCO_CHECK:',
     &      'ALLOW_SIGMAR_COST_CONTRIBUTION has no',
     &      'effect since cost_sigmar has been retired'
           CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                     SQUEEZE_RIGHT , myThid )
       nRetired = nRetired + 1
#endif
#ifdef ALLOW_EDDYPSI_COST_CONTRIBUTION
           WRITE(msgBuf,'(3A)') '** WARNING ** ECCO_CHECK:',
     &      'ALLOW_EDDYPSI_COST_CONTRIBUTION has no',
     &      'effect since cost_tau_eddy has been retired'
           CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                     SQUEEZE_RIGHT , myThid )
       nRetired = nRetired + 1
#endif
#ifdef ALLOW_OBCS_COST_CONTRIBUTION
       WRITE(msgBuf,'(2A)') '** WARNING ** ECCO_CHECK:',
     &      'ALLOW_OBCS_COST_CONTRIBUTION has been retired'
       CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                     SQUEEZE_RIGHT , myThid )
       nRetired = nRetired + 1
#endif
#ifdef ALLOW_OBCSN_COST_CONTRIBUTION
       WRITE(msgBuf,'(2A)') '** WARNING ** ECCO_CHECK:',
     &      'ALLOW_OBCSN_COST_CONTRIBUTION has been retired'
       CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                     SQUEEZE_RIGHT , myThid )
       nRetired = nRetired + 1
#endif
#ifdef ALLOW_OBCSS_COST_CONTRIBUTION
       WRITE(msgBuf,'(2A)') '** WARNING ** ECCO_CHECK:',
     &      'ALLOW_OBCSS_COST_CONTRIBUTION has been retired'
       CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                     SQUEEZE_RIGHT , myThid )
       nRetired = nRetired + 1
#endif
#ifdef ALLOW_OBCSW_COST_CONTRIBUTION
       WRITE(msgBuf,'(2A)') '** WARNING ** ECCO_CHECK:',
     &      'ALLOW_OBCSW_COST_CONTRIBUTION has been retired'
       CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                     SQUEEZE_RIGHT , myThid )
       nRetired = nRetired + 1
#endif
#ifdef ALLOW_OBCSE_COST_CONTRIBUTION
       WRITE(msgBuf,'(2A)') '** WARNING ** ECCO_CHECK:',
     &      'ALLOW_OBCSE_COST_CONTRIBUTION has been retired'
       CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                     SQUEEZE_RIGHT , myThid )
       nRetired = nRetired + 1
#endif

      IF ( nRetired .GT. 0 ) THEN
       WRITE(msgBuf,'(2A)') 'S/R ECCO_CHECK: ',
     &  '  retired compile-time options need to be removed'
       CALL PRINT_ERROR( msgBuf, myThid )
       CALL ALL_PROC_DIE( 0 )
       STOP 'ABNORMAL END: S/R ECCO_CHECK'
      ENDIF

c ============ retired run-time parameter checks
      nRetired = 0

#ifdef ALLOW_GENCOST_CONTRIBUTION
      DO k=1,NGENCOST
       IF (gencost_scalefile(k).NE.' ') THEN
           WRITE(msgBuf,'(3A)') '** WARNING ** ECCO_CHECK:',
     &      'gencost_scalefile has been retired; ',
     &      'gencost_posproc_c should now be used instead'
           CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                     SQUEEZE_RIGHT , myThid )
           nRetired = nRetired + 1
       ENDIF
       IF (gencost_smooth2Ddiffnbt(k).NE.0) THEN
           WRITE(msgBuf,'(3A)') '** WARNING ** ECCO_CHECK:',
     &      'gencost_smooth2Ddiffnbt has been retired; ',
     &      'gencost_posproc_i should now be used instead'
           CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                     SQUEEZE_RIGHT , myThid )
           nRetired = nRetired + 1
       ENDIF
       IF (gencost_timevaryweight(k)) THEN
           WRITE(msgBuf,'(3A)') '** WARNING ** ECCO_CHECK:',
     &      'gencost_timevaryweight has been retired; ',
     &      'gencost_posproc should now be used instead'
           CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                     SQUEEZE_RIGHT , myThid )
           nRetired = nRetired + 1
       ENDIF
       IF (gencost_nrecperiod(k).NE.0) THEN
           WRITE(msgBuf,'(3A)') '** WARNING ** ECCO_CHECK:',
     &      'gencost_nrecperiod has been retired; ',
     &      'gencost_posproc clim should now be used instead'
           CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                     SQUEEZE_RIGHT , myThid )
           nRetired = nRetired + 1
       ENDIF

      ENDDO
#endif

      IF ( nRetired .GT. 0 ) THEN
       WRITE(msgBuf,'(2A)') 'S/R ECCO_CHECK: ',
     &  '  retired run-time options were found in data.ecco'
       CALL PRINT_ERROR( msgBuf, myThid )
       CALL ALL_PROC_DIE( 0 )
       STOP 'ABNORMAL END: S/R ECCO_CHECK'
      ENDIF

c ============ backward compatibility checks
      IF ( (using_topex).AND.(.NOT.using_tpj) ) using_tpj=.TRUE.

      _END_MASTER(myThid)

c ============ generic cost function related checks

#ifdef ALLOW_GENCOST_CONTRIBUTION
      icount_transp=0
      igen_tp = 0
      igen_ers = 0
      igen_gfo = 0
      DO k=1,NGENCOST

         IF (gencost_pointer3d(k).GT.NGENCOST3D) THEN
           WRITE(msgBuf,'(2A)')
     &      'ECCO_CHECK: too many 3D cost terms; please',
     &      'increase NGENCOST3D and recompile.'
           CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                     SQUEEZE_RIGHT , myThid )
           CALL PRINT_ERROR( msgBuf , myThid )
           STOP 'ABNORMAL END: S/R ECCO_CHECK'
         ENDIF

         IF (gencost_msk_pointer3d(k).GT.NGENCOST3D) THEN
           WRITE(msgBuf,'(2A)')
     &      'ECCO_CHECK: too many 3D msk terms; please',
     &      'increase NGENCOST3D and recompile.'
           CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                     SQUEEZE_RIGHT , myThid )
           CALL PRINT_ERROR( msgBuf , myThid )
           STOP 'ABNORMAL END: S/R ECCO_CHECK'
         ENDIF

         IF ( gencost_datafile(k) .NE. ' ' ) THEN

           CALL ECCO_CHECK_FILES( using_gencost(k), 'gencost',
     &       gencost_datafile(k), gencost_startdate1(k), myThid )

c--
           IF ( (gencost_preproc(1,k).EQ.'variaweight').AND.
     &          ( gencost_errfile(k) .NE. ' ' ) ) THEN
             CALL ECCO_CHECK_FILES( using_gencost(k), 'gencost',
     &         gencost_errfile(k), gencost_startdate1(k), myThid )
           ELSEIF ( gencost_errfile(k) .NE. ' ' ) THEN
             il = ILNBLNK(gencost_errfile(k))
             inquire( file=gencost_errfile(k)(1:il), exist=exst )
             IF (.NOT.exst) THEN
               using_gencost(k)=.FALSE.
               il = ILNBLNK(gencost_name(k))
               WRITE(msgBuf,'(4A)')
     &           '** WARNING ** ECCO_CHECK: missing error file',
     &           ' so ',gencost_name(k)(1:il),' gets switched off'
               CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                    SQUEEZE_RIGHT , myThid)
             ENDIF
           ENDIF

c altimetry related checks

         IF (gencost_name(k).EQ.'sshv4-tp') THEN
           igen_tp = k
           using_tpj = using_gencost(k)
         ENDIF
         IF (gencost_name(k).EQ.'sshv4-ers') THEN
           igen_ers = k
           using_ers = using_gencost(k)
         ENDIF
         IF (gencost_name(k).EQ.'sshv4-gfo') THEN
           igen_gfo = k
           using_gfo = using_gencost(k)
         ENDIF
         IF (gencost_name(k).EQ.'sshv4-mdt') using_mdt=using_gencost(k)

c seaice related checks
         IF (gencost_name(k).EQ.'siv4-conc')
     &       using_cost_seaice=using_gencost(k)
         IF (gencost_name(k).EQ.'siv4-deconc')
     &       using_cost_seaice=using_gencost(k)
         IF (gencost_name(k).EQ.'siv4-exconc')
     &       using_cost_seaice=using_gencost(k)
catn-- put STOP statement if use old siv4 names:
         IF (gencost_name(k).EQ.'siv4-sst') THEN
           WRITE(msgBuf,'(2A)')
     &      'ECCO_CHECK: OLD seaice gencost_name siv4-sst is retired,',
     &      ' NEW name is siv4-deconc'
           CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                     SQUEEZE_RIGHT , myThid )
           CALL PRINT_ERROR( msgBuf , myThid )
           STOP 'ABNORMAL END: S/R ECCO_CHECK'
         ENDIF
         IF (gencost_name(k).EQ.'siv4-vol') THEN
           WRITE(msgBuf,'(2A)')
     &      'ECCO_CHECK: OLD seaice gencost_name siv4-vol is retired,',
     &      ' NEW name is siv4-exconc'
           CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                     SQUEEZE_RIGHT , myThid )
           CALL PRINT_ERROR( msgBuf , myThid )
           STOP 'ABNORMAL END: S/R ECCO_CHECK'
         ENDIF

c-atn add another block for cost that do not need datafile but
c should have checks for other things:
c here, separate into different gencost_flag block
         ELSE  !if ( gencost_datafile(k) .NE. ' ' ) THEN
c---------------- block -1 ----------------------------
c block -1: cost ssh-[mdt,lsc,amsre-lsc] do not need datafile
c but need errfile. at the moment do not accomodate variaweight.
          IF (gencost_flag(k).EQ. -1) THEN
            IF (gencost_errfile(k) .NE. ' ') THEN
             il = ILNBLNK(gencost_errfile(k))
             inquire( file=gencost_errfile(k)(1:il), exist=exst )
             IF (.NOT.exst) THEN
              using_gencost(k)=.FALSE.
              il = ILNBLNK(gencost_name(k))
              WRITE(msgBuf,'(4A)')
     &          '** WARNING ** ECCO_CHECK: missing error file',
     &          ' so ',gencost_name(k)(1:il),' gets switched off'
              CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                   SQUEEZE_RIGHT , myThid)
             ENDIF
            ELSEIF(.NOT.(gencost_name(k).EQ.'sshv4-gmsl')) THEN
             using_gencost(k)=.FALSE.
             il = ILNBLNK(gencost_name(k))
             WRITE(msgBuf,'(4A)')
     &        '** WARNING ** ECCO_CHECK: error file not defined',
     &        ' so ',gencost_name(k)(1:il),' gets switched off'
             CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                  SQUEEZE_RIGHT , myThid)
            ENDIF

c---------------- block -3 ----------------------------
c-- boxmean: require [err,bar]file, can have datafile, not checked here
c-- also not checked for variwei at the moment
          ELSEIF(gencost_flag(k) .EQ. -3 ) THEN
           WRITE(msgBuf,'(A,i3,L5)')
     &     'entering boxmean/horflux check,k,using_gencost(k): ,',
     &     k,using_gencost(k)
           CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                        SQUEEZE_RIGHT , myThid)

            IF (gencost_errfile(k) .NE. ' ') THEN
              WRITE(msgBuf,'(3A)') 'S/R ECCO_CHECK: boxmean now ',
     &          ' uses gencost_mask instead of gencost_errfile --',
     &          ' please update data.ecco accordingly'
              CALL PRINT_ERROR( msgBuf, myThid )
              STOP 'ABNORMAL END: S/R ECCO_CHECK'
            ENDIF

            IF (gencost_mask(k) .EQ. ' ') THEN
              using_gencost(k)=.FALSE.
              il = ILNBLNK(gencost_name(k))
              WRITE(msgBuf,'(4A)')
     &          '** WARNING ** ECCO_CHECK: gencost_mask is',
     &          ' undefined so ',gencost_name(k)(1:il),
     &          ' gets switched off'
              CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                   SQUEEZE_RIGHT , myThid)
            ENDIF

            IF ((gencost_mask(k) .NE. ' ').AND.
     &          (gencost_barfile(k)(1:9).EQ.'m_boxmean')) THEN
             il = ILNBLNK(gencost_mask(k))
             WRITE(tempfile(1:128),'(2A)') gencost_mask(k)(1:il),'C'
             inquire( file=tempfile(1:il+1), exist=exst )
             IF (.NOT.exst) THEN
               using_gencost(k)=.FALSE.
               il = ILNBLNK(gencost_name(k))
               WRITE(msgBuf,'(4A)')
     &           '** WARNING ** ECCO_CHECK: missing mask C file',
     &           ' so ',gencost_name(k)(1:il),' gets switched off'
               CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                    SQUEEZE_RIGHT , myThid)
             ENDIF
            ENDIF

            IF ((gencost_mask(k) .NE. ' ').AND.
     &          (gencost_barfile(k)(1:9).EQ.'m_horflux')) THEN
             il = ILNBLNK(gencost_mask(k))
             WRITE(tempfile(1:128),'(2A)') gencost_mask(k)(1:il),'W'
             inquire( file=tempfile(1:il+1), exist=exst )
             IF (.NOT.exst) THEN
               using_gencost(k)=.FALSE.
               il = ILNBLNK(gencost_name(k))
               WRITE(msgBuf,'(4A)')
     &           '** WARNING ** ECCO_CHECK: missing mask W file',
     &           ' so ',gencost_name(k)(1:il),' gets switched off'
               CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                    SQUEEZE_RIGHT , myThid)
             ENDIF
c
             il = ILNBLNK(gencost_mask(k))
             WRITE(tempfile(1:128),'(2A)') gencost_mask(k)(1:il),'S'
             inquire( file=tempfile(1:il+1), exist=exst )
             IF (.NOT.exst) THEN
               using_gencost(k)=.FALSE.
               il = ILNBLNK(gencost_name(k))
               WRITE(msgBuf,'(4A)')
     &           '** WARNING ** ECCO_CHECK: missing mask S file',
     &           ' so ',gencost_name(k)(1:il),' gets switched off'
               CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                    SQUEEZE_RIGHT , myThid)
             ENDIF
            ENDIF

c-- check barfile, make sure character m_[theta,salt] match exactly
c-- (upper/lower-case matters) in cost_gencost_customize
           IF (.NOT.(
     &          (gencost_barfile(k)(1:15).EQ.'m_boxmean_theta').OR.
     &          (gencost_barfile(k)(1:13).EQ.'m_boxmean_eta').OR.
     &          (gencost_barfile(k)(1:14).EQ.'m_boxmean_salt').OR.
     &          (gencost_barfile(k)(1:17).EQ.'m_boxmean_ptracer').OR.
     &          (gencost_barfile(k)(1:13).EQ.'m_boxmean_vol').OR.
     &          (gencost_barfile(k)(1:16).EQ.'m_boxmean_shifwf').OR.
     &          (gencost_barfile(k)(1:16).EQ.'m_boxmean_shihtf').OR.
     &          (gencost_barfile(k)(1:13).EQ.'m_horflux_vol')
     &        )) THEN
            using_gencost(k)=.FALSE.
            il=ILNBLNK(gencost_barfile(k))
            WRITE(msgBuf,'(3A)')
     &      '** WARNING ** S/R ECCO_CHECK: barfile ',
     &      gencost_barfile(k)(1:il),': has no matched model var.'
            CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                          SQUEEZE_RIGHT, myThid )
            WRITE(msgBuf,'(A)') 'Edit cost_gencost_customize to fix. '
            CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                          SQUEEZE_RIGHT, myThid )
            il = ILNBLNK(gencost_name(k))
          WRITE(msgBuf,'(2A)') gencost_name(k)(1:il),' is switched off'
            CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                          SQUEEZE_RIGHT, myThid )
           ENDIF !barfile

c---------------- block -4 ----------------------------
c-- transs: require [mask,bar][W,S]file, can have datafile, but
c-- not checked here. also not checked for variwei at the moment
         ELSEIF ( (gencost_flag(k).EQ. -4) .OR.
     &            (gencost_flag(k).EQ. -5) ) THEN
          WRITE(msgBuf,'(A,i3,L5)')
     &     'ecco_check for gencost transp & moc; k,using_gencost(k): ,',
     &     k,using_gencost(k)
          CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                        SQUEEZE_RIGHT , myThid)

C ---
C Warn the user that this is a less tested objective function
C TBD: Write a more consistent transport objective function
C ---

          IF ((gencost_barfile(k)(1:7).EQ.'m_trVol').AND.
     &        (gencost_flag(k).EQ.-4)) THEN
           WRITE(msgBuf,'(A)')
     &  '** WARNING ** ECCO_CHECK: cost_gencost_transp.F not tested'
           CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                         SQUEEZE_RIGHT, myThid )
           WRITE(msgBuf,'(A)')
     &   ' See m_horflux_vol via cost_gencost_boxmean.F.'
           CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                         SQUEEZE_RIGHT, myThid )
          ELSEIF( (gencost_barfile(k)(1:8).EQ.'m_trHeat').OR.
     &            (gencost_barfile(k)(1:8).EQ.'m_trSalt') ) THEN
           WRITE(msgBuf,'(2A)')
     &   '** WARNING ** ECCO_CHECK: m_tr[Heat,Salt] to be used with',
     &   ' caution because:'
           CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                         SQUEEZE_RIGHT, myThid )
           WRITE(msgBuf,'(A)')
     &  '  (1) advection inconsistent unless ENUM_CENTERED_2ND is used'
           CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                         SQUEEZE_RIGHT, myThid )
           WRITE(msgBuf,'(A)')
     &  '  (2) bolus velocities not included'
           CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                         SQUEEZE_RIGHT, myThid )
           WRITE(msgBuf,'(A)')
     &  '  (3) diffusion components not included'
           CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                         SQUEEZE_RIGHT, myThid )
         ENDIF

C ---
C Note to user: use gencost_mask not errfile
C ---
          IF (gencost_errfile(k) .NE. ' ') THEN
            WRITE(msgBuf,'(3A)') 'S/R ECCO_CHECK: transp & moc now ',
     &        ' use gencost_mask instead of gencost_errfile --',
     &        ' please update data.ecco accordingly'
            CALL PRINT_ERROR( msgBuf, myThid )
            STOP 'ABNORMAL END: S/R ECCO_CHECK'
          ENDIF

          IF (gencost_mask(k) .EQ. ' ') THEN
            using_gencost(k)=.FALSE.
            il = ILNBLNK(gencost_name(k))
            WRITE(msgBuf,'(4A)')
     &        '** WARNING ** ECCO_CHECK: gencost_mask is',
     &        ' undefined so ',gencost_name(k)(1:il),
     &        ' gets switched off'
            CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                 SQUEEZE_RIGHT , myThid)

          ELSE
c-- West ----------------------
           il = ILNBLNK(gencost_mask(k))
           WRITE(tempfile(1:128),'(2A)') gencost_mask(k)(1:il),'W'
           inquire( file=tempfile(1:il+1), exist=exst )
           WRITE(msgBuf,'(2A,L5)') 'ecco_check file, exst: ',
     &       tempfile(1:il+1),exst
           CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                  SQUEEZE_RIGHT , myThid)
           IF (.NOT.exst) THEN
             using_gencost(k)=.FALSE.
             WRITE(msgBuf,'(2A)')
     &         '** WARNING ** ECCO_CHECK: missing mask file: ',
     &         tempfile(1:il+1)
             CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                  SQUEEZE_RIGHT , myThid)
             il = ILNBLNK(gencost_name(k))
             WRITE(msgBuf,'(3A)')
     &         ' so ',gencost_name(k)(1:il),' gets switched off'
             CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                  SQUEEZE_RIGHT , myThid)
           ENDIF
c-- South --------------------
           il = ILNBLNK(gencost_mask(k))
           WRITE(tempfile(1:128),'(2A)') gencost_mask(k)(1:il),'S'
           inquire( file=tempfile(1:il+1), exist=exst )
           WRITE(msgBuf,'(2A,L5)') 'ecco_check file, exst: ',
     &       tempfile(1:il+1),exst
           CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                  SQUEEZE_RIGHT , myThid)
           IF (.NOT.exst) THEN
             using_gencost(k)=.FALSE.
             WRITE(msgBuf,'(2A)')
     &         '** WARNING ** ECCO_CHECK: missing mask file: ',
     &         tempfile(1:il+1)
             CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                  SQUEEZE_RIGHT , myThid)
             il = ILNBLNK(gencost_name(k))
             WRITE(msgBuf,'(3A)')
     &         ' so ',gencost_name(k)(1:il),' gets switched off'
             CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                  SQUEEZE_RIGHT , myThid)
           ENDIF
         ENDIF ! gencost_mask.EQ.' '

c-- check barfile, make sure character m_tr[Vol,Heat,Salt] match exactly
c-- (upper/lower-case matters) in cost_gencost_customize
          IF(.NOT.( (gencost_barfile(k)(1:7).EQ.'m_trVol') .OR.
     &              (gencost_barfile(k)(1:8).EQ.'m_trHeat').OR.
     &              (gencost_barfile(k)(1:8).EQ.'m_trSalt') )) THEN
           using_gencost(k)=.FALSE.
           il=ILNBLNK(gencost_barfile(k))
           WRITE(msgBuf,'(3A)')
     &     '** WARNING ** S/R ECCO_CHECK: barfile ',
     &     gencost_barfile(k)(1:il),': has no matched model var.'
           CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                         SQUEEZE_RIGHT, myThid )
           WRITE(msgBuf,'(A)') 'Edit cost_gencost_customize to fix. '
           CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                         SQUEEZE_RIGHT, myThid )
           il = ILNBLNK(gencost_name(k))
           WRITE(msgBuf,'(2A)') gencost_name(k)(1:il),' is switched off'
           CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                         SQUEEZE_RIGHT, myThid )
          ENDIF !barfile
c-- set using_cost_transp
          IF ((using_gencost(k)).AND.(gencost_flag(k).EQ.-4))
     &      icount_transp=icount_transp+1
          IF (icount_transp.GT.0) using_cost_transp = .TRUE.
c-- final report to make sure using_cost_transp is set correctly
          WRITE(msgBuf,'(2A,i3,L5)')
     &     'ecco_check: gencost transp; icount_transp,',
     &     'using_cost_transp: ',icount_transp,using_cost_transp
          CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                        SQUEEZE_RIGHT , myThid)

         ENDIF  !gencost_flag

         ENDIF !if ( gencost_datafile(k) .NE. ' ' ) THEN
      ENDDO

c check that one of the used gencost term defines etagcm (needed in sshv4)
      IF ( (using_tpj ).OR.(using_ers).OR.(using_gfo)
     &     .OR.(using_mdt) ) using_cost_altim = .TRUE.

      igen_etagcm=0
      DO k=1,NGENCOST
        IF ( (gencost_barfile(k)(1:5).EQ.'m_eta').AND.
     &       (using_gencost(k)) )  igen_etagcm=k
      ENDDO

      IF ((igen_etagcm.EQ.0).AND.(using_cost_altim)) THEN
c warn user as we override using_cost_altim
        using_cost_altim = .FALSE.
        WRITE(msgBuf,'(2A)')
     &    '** WARNING ** S/R ECCO_CHECK: missing file: ',
     &    'for altimeter data so cost gets switched off'
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
      ELSE
c print result to screen
        WRITE(msgBuf,'(A,I3)')
     &  'etagcm defined by gencost =',igen_etagcm
        CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
      ENDIF

C If more than one within the data set [tp,ers,gfo] are present, they must have
C the same avgperiod, e.g., day or month. Here we check for inconsistency:
      IF (using_cost_altim) THEN
       use_mon_int = 0
       use_day_int = 0
       IF ( using_tpj ) THEN
        IF (gencost_avgperiod(igen_tp) .EQ.'month' .OR.
     &      gencost_avgperiod(igen_tp) .EQ.'MONTH') THEN
          use_mon_int = use_mon_int + 1
        ELSE
          use_day_int = use_day_int + 1
        ENDIF
       ENDIF
       IF ( using_ers ) THEN
        IF (gencost_avgperiod(igen_ers) .EQ.'month' .OR.
     &      gencost_avgperiod(igen_ers) .EQ.'MONTH') THEN
          use_mon_int = use_mon_int + 1
        ELSE
          use_day_int = use_day_int + 1
        ENDIF
       ENDIF
       IF ( using_gfo ) THEN
        IF (gencost_avgperiod(igen_gfo).EQ.'month' .OR.
     &      gencost_avgperiod(igen_gfo).EQ.'MONTH' ) THEN
          use_mon_int = use_mon_int + 1
        ELSE
          use_day_int = use_day_int + 1
        ENDIF
       ENDIF
       IF ( use_mon_int .GT. 0 .AND. use_day_int .GT. 0 ) THEN
         WRITE(msgBuf,'(2A)')
     &    'ECCO_CHECK: cost sshv4: data set TP/ERS/GFO must be all ',
     &    'daily or monthly, but cannot be mixed.'
         CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                       SQUEEZE_RIGHT, myThid )
         CALL PRINT_ERROR( msgBuf, myThid )
         STOP 'ABNORMAL END: S/R ECCO_CHECK'
       ENDIF
      ENDIF

#endif /* ALLOW_GENCOST_CONTRIBUTION */

C ============ other pkg/ecco related checks
      _BEGIN_MASTER(myThid)

#ifndef ALLOW_PSBAR_STERIC
      IF (ecco_output_sterGloH) THEN
         WRITE(msgBuf,'(3A)') 'ECCO_CHECK:',
     &         ' Cannot set ecco_output_sterGloH to TRUE',
     &         ' with #undef ALLOW_PSBAR_STERIC'
         CALL PRINT_ERROR( msgBuf, myThid )
         STOP 'ABNORMAL END: S/R ECCO_CHECK'
      ENDIF
#endif

C--   Summarize the ECCO cost function setup.
      CALL ECCO_SUMMARY( myThid )

      WRITE(msgBuf,'(2A)') 'ECCO_CHECK: ',
     &                     ' <-- Ends Normally'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)') ' '
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )

      _END_MASTER(myThid)

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      SUBROUTINE ECCO_CHECK_FILES(
     O using_cost_local,
     I localname, localobsfile, localstartdate1,
     I myThid )

C     *==========================================================*
C     | SUBROUTINE ECCO_CHECK_FILES                              |
C     | o Check that obs files are present for specified years.  |
C     |   If not then set using_cost_local to false.             |
C     *==========================================================*
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "ECCO_SIZE.h"
#include "ECCO.h"
#ifdef ALLOW_CAL
# include "cal.h"
#endif

C     === Routine arguments ===
C     myThid -  Number of this instances
      INTEGER myThid
      LOGICAL using_cost_local
      CHARACTER*(*) localname
      CHARACTER*(MAX_LEN_FNAM) localobsfile
      INTEGER localstartdate1

c     == external functions ==
      INTEGER  ILNBLNK
      EXTERNAL ILNBLNK

C     === Local variables ===
C     msgBuf      - Informational/error message buffer
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      INTEGER irec, mody, modm, yday, locy, il
      LOGICAL exst, singleFileTest, yearlyFileTest
      CHARACTER*(128) fname

c     == end of interface ==

c left for later : refine test accounting for localstartdate1

#ifdef ALLOW_CAL

      _BEGIN_MASTER(myThid)

      IF ( (using_cost_local).AND.(localobsfile.EQ.' ') ) THEN
c warn user as we override using_cost_local
             WRITE(msgBuf,'(4A)')
     &       '** WARNING ** ECCO_CHECK_FILES: missing file',
     &       ' definition so ',localname,' gets switched off'
             CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                    SQUEEZE_RIGHT , myThid)
c switch off cost function term
             using_cost_local = .FALSE.
      ENDIF

      singleFileTest = .FALSE.
      IF (using_cost_local) THEN
           inquire( file=localobsfile, exist=exst )
           IF ( exst ) singleFileTest=.TRUE.
      ENDIF

      yearlyFileTest = .FALSE.
      IF ( (using_cost_local).AND.(.NOT.singleFileTest) ) THEN
        DO irec = 1, nmonsrec
           mody   = modelstartdate(1)/10000
           modm   = modelstartdate(1)/100 - mody*100
           yday   = mody + INT((modm-1+irec-1)/12)

           locy   = localstartdate1/10000

           il=ilnblnk(localobsfile)
           WRITE(fname(1:128),'(2a,i4)')
     &       localobsfile(1:il), '_', yday
           inquire( file=fname, exist=exst )

           IF ( (.NOT.exst).AND.(yday.GE.locy) ) THEN
c warn user as we override using_cost_local
             WRITE(msgBuf,'(5A)')
     &       '** WARNING ** ECCO_CHECK_FILES: missing ',fname,
     &       ' so ',localname,' gets switched off'
             CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                    SQUEEZE_RIGHT , myThid)
c switch off cost function term
             using_cost_local = .FALSE.
           ELSEIF ( (exst).AND.(yday.GE.locy) ) THEN
             yearlyFileTest = .TRUE.
           ENDIF
        ENDDO
      ENDIF

      IF (using_cost_local) THEN
      IF ( (.NOT.yearlyFileTest).AND.(.NOT.singleFileTest) ) THEN
c warn user as we override using_cost_local
             WRITE(msgBuf,'(4A)')
     &       '** WARNING ** ECCO_CHECK_FILES: no data ',
     &       ' so ',localname,' gets switched off'
             CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                    SQUEEZE_RIGHT , myThid)
c switch off cost function term
             using_cost_local = .FALSE.
      ENDIF
      ENDIF

      _END_MASTER(myThid)

#endif /* ALLOW_CAL */

      RETURN
      END

#include "ADMTLM_OPTIONS.h"

      subroutine admtlm_dsvd ( mythid )
c
c     This example program is intended to illustrate the
c     the use of ARPACK to compute the Singular Value Decomposition.
c
c     This code shows how to use ARPACK to find a few of the
c     largest singular values(sigma) and corresponding right singular
c     vectors (v) for the the matrix A by solving the symmetric problem:
c
c                        (A'*A)*v = sigma*v
c
c     where A is an m by n real matrix.
c
c     This code may be easily modified to estimate the 2-norm
c     condition number  largest(sigma)/smallest(sigma) by setting
c     which = 'BE' below.  This will ask for a few of the smallest
c     and a few of the largest singular values simultaneously.
c     The condition number could then be estimated by taking
c     the ratio of the largest and smallest singular values.
c
c     This formulation is appropriate when  m  .ge.  n.
c     Reverse the roles of A and A' in the case that  m .le. n.
c
c     The main points illustrated here are
c
c        1) How to declare sufficient memory to find NEV
c           largest singular values of A .
c
c        2) Illustration of the reverse communication interface
c           needed to utilize the top level ARPACK routine DSAUPD
c           that computes the quantities needed to construct
c           the desired singular values and vectors(if requested).
c
c        3) How to extract the desired singular values and vectors
c           using the ARPACK routine DSEUPD.
c
c        4) How to construct the left singular vectors U from the
c           right singular vectors V to obtain the decomposition
c
c                        A*V = U*S
c
c           where S = diag(sigma_1, sigma_2, ..., sigma_k).
c
c     The only thing that must be supplied in order to use this
c     routine on your problem is to change the array dimensions
c     appropriately, to specify WHICH singular values you want to
c     compute and to supply a the matrix-vector products
c
c                         w <-  Ax
c                         y <-  A'w
c
c     in place of the calls  to AV( ) and ATV( ) respectively below.
c
c     Further documentation is available in the header of DSAUPD
c     which may be found in the SRC directory.
c
c     This codes implements
c
c\Example-1
c     ... Suppose we want to solve A'A*v = sigma*v in regular mode,
c         where A is derived from the simplest finite difference
c         discretization of the 2-dimensional kernel  K(s,t)dt  where
c
c                 K(s,t) =  s(t-1)   if 0 .le. s .le. t .le. 1,
c                           t(s-1)   if 0 .le. t .lt. s .le. 1.
c
c         See subroutines AV  and ATV for details.
c     ... OP = A'*A  and  B = I.
c     ... Assume "call av (n,x,y)" computes y = A*x
c     ... Assume "call atv (n,y,w)" computes w = A'*y
c     ... Assume exact shifts are used
c     ...
c
c\BeginLib
c
c\Routines called:
c     dsaupd  ARPACK reverse communication interface routine.
c     dseupd  ARPACK routine that returns Ritz values and (optionally)
c             Ritz vectors.
c     dnrm2   Level 1 BLAS that computes the norm of a vector.
c     daxpy   Level 1 BLAS that computes y <- alpha*x+y.
c     dscal   Level 1 BLAS thst computes x <- x*alpha.
c     dcopy   Level 1 BLAS thst computes y <- x.
c
c\Author
c     Richard Lehoucq
c     Danny Sorensen
c     Chao Yang
c     Dept. of Computational &
c     Applied Mathematics
c     Rice University
c     Houston, Texas
c
c\SCCS Information: @(#)
c FILE: svd.F   SID: 2.4   DATE OF SID: 10/17/00   RELEASE: 2
c
c\Remarks
c     1. None
c
c\EndLib
c
c-----------------------------------------------------------------------
c
c     %------------------------------------------------------%
c     | Storage Declarations:                                |
c     |                                                      |
c     | It is assumed that A is M by N with M .ge. N.        |
c     |                                                      |
c     | The maximum dimensions for all arrays are            |
c     | set here to accommodate a problem size of            |
c     | M .le. MAXM  and  N .le. MAXN                        |
c     |                                                      |
c     | The NEV right singular vectors will be computed in   |
c     | the N by NCV array V.                                |
c     |                                                      |
c     | The NEV left singular vectors will be computed in    |
c     | the M by NEV array U.                                |
c     |                                                      |
c     | NEV is the number of singular values requested.      |
c     |     See specifications for ARPACK usage below.       |
c     |                                                      |
c     | NCV is the largest number of basis vectors that will |
c     |     be used in the Implicitly Restarted Arnoldi      |
c     |     Process.  Work per major iteration is            |
c     |     proportional to N*NCV*NCV.                       |
c     |                                                      |
c     | You must set:                                        |
c     |                                                      |
c     | MAXM:   Maximum number of rows of the A allowed.     |
c     | MAXN:   Maximum number of columns of the A allowed.  |
c     | MAXNEV: Maximum NEV allowed                          |
c     | MAXNCV: Maximum NCV allowed                          |
c     %------------------------------------------------------%
c
C     !USES:
C     == Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#ifdef ALLOW_ADMTLM
# ifdef ALLOW_AUTODIFF_TAMC
#  include "tamc.h"
# endif
# include "CTRL.h"
# include "OPTIMCYCLE.h"
# include "cost.h"
# include "adcost.h"
# include "g_cost.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
      INTEGER mythid

C     == PARAMETERS ==
      integer          maxnev, maxncv, ldv, ldu
cph(
      parameter       ( maxnev=15, maxncv=30, ldu = maxm, ldv=maxn )
      character*(80)   fnameGlobal
cph)
c
c     %--------------%
c     | Local Arrays |
c     %--------------%
c
      Double precision
     &                 v(ldv,maxncv), u(ldu, maxnev),
     &                 workl(maxncv*(maxncv+8)), workd(3*maxn),
     &                 s(maxncv,2), resid(maxn), ax(maxm)
      logical          select(maxncv)
      integer          iparam(11), ipntr(11)
c
c     %---------------%
c     | Local Scalars |
c     %---------------%
c
      character        bmat*1, which*2
      integer          ido, m, n, nev, ncv, lworkl, info, ierr,
     &                 j, ishfts, maxitr, mode, nconv
      logical          rvec
      Double precision
     &                 tol, sigma, temp
c
c     %------------%
c     | Parameters |
c     %------------%
c
      Double precision
     &                 one, zero
      parameter        (one = 1.0D+0, zero = 0.0D+0)
c
c     %-----------------------------%
c     | BLAS & LAPACK routines used |
c     %-----------------------------%
c
      Double precision
     &                 dnrm2
      external         dnrm2, daxpy, dcopy, dscal

cph(
      integer l, ilinsysinfo, ii, jj
      integer ipiv(maxn)
      integer phiwork(maxn)

      double precision ferr, berr
      double precision phtmpin(maxn), phtmpout(maxn)
      double precision phxout(maxn)
      double precision tmpvec1(maxn), tmpvec2(maxn)
      double precision phrwork(3*maxn)
cph      double precision metricLoc(maxn,maxn)
cph      double precision metricTriag(maxn,maxn)
cph      double precision metricInv(maxn,maxn)

cph      DATA (metricInv(ii,1),ii=1,maxn)
cph     &     / 9.9896D+07, 0.0519D+07, -0.0415D+07,
cph     &     0.0486D+07, -0.2432D+07, 0.1945D+07 /
cph      DATA (metricInv(ii,2),ii=1,maxn)
cph     &     / 0.0519D+07, 9.7403D+07, 0.2077D+07,
cph     &     -0.2432D+07, 1.2158D+07, -0.9726D+07 /
cph      DATA (metricInv(ii,3),ii=1,maxn)
cph     &     / -0.0415D+07, 0.2077D+07, 9.8338D+07,
cph     &     0.1945D+07, -0.9726D+07, 0.7781D+07 /
cph      DATA (metricInv(ii,4),ii=1,maxn)
cph     &     / 0.0486D+07, -0.2432D+07, 0.1945D+07,
cph     &     9.7723D+07, 1.1385D+07, -0.9108D+07 /
cph      DATA (metricInv(ii,5),ii=1,maxn)
cph     &     / -0.2432D+07, 1.2158D+07, -0.9726D+07,
cph     &     1.1385D+07, 4.3073D+07, 4.5542D+07 /
cph      DATA (metricInv(ii,6),ii=1,maxn)
cph     &     / 0.1945D+07, -0.9726D+07, 0.7781D+07,
cph     &     -0.9108D+07, 4.5542D+07, 6.3567D+07 /
cph)
c
c     %-----------------------%
c     | Executable Statements |
c     %-----------------------%
c
c     %-------------------------------------------------%
c     | The following include statement and assignments |
c     | initiate trace output from the internal         |
c     | actions of ARPACK.  See debug.doc in the        |
c     | DOCUMENTS directory for usage.  Initially, the  |
c     | most useful information will be a breakdown of  |
c     | time spent in the various stages of computation |
c     | given by setting msaupd = 1.                    |
c     %-------------------------------------------------%
c
      include 'arpack_debug.h'
      ndigit = -3
      logfil = 6
      msgets = 0
      msaitr = 0
      msapps = 0
      msaupd = 1
      msaup2 = 0
      mseigt = 0
      mseupd = 0
c
c     %-------------------------------------------------%
c     | The following sets dimensions for this problem. |
c     %-------------------------------------------------%
c
cph(
      m = admtlmrec
      n = admtlmrec
cph)
c
c     %------------------------------------------------%
c     | Specifications for ARPACK usage are set        |
c     | below:                                         |
c     |                                                |
c     |    1) NEV = 4 asks for 4 singular values to be |
c     |       computed.                                |
c     |                                                |
c     |    2) NCV = 20 sets the length of the Arnoldi  |
c     |       factorization                            |
c     |                                                |
c     |    3) This is a standard problem               |
c     |         (indicated by bmat  = 'I')             |
c     |                                                |
c     |    4) Ask for the NEV singular values of       |
c     |       largest magnitude                        |
c     |         (indicated by which = 'LM')            |
c     |       See documentation in DSAUPD for the      |
c     |       other options SM, BE.                    |
c     |                                                |
c     | Note: NEV and NCV must satisfy the following   |
c     |       conditions:                              |
c     |                 NEV <= MAXNEV,                 |
c     |             NEV + 1 <= NCV <= MAXNCV           |
c     %------------------------------------------------%
c
cph(
      nev   = 15
      ncv   = 30
      bmat  = 'I'
cph)
      which = 'LM'
c
      if ( n .gt. maxn ) then
         print *, ' ERROR with _SVD: N is greater than MAXN '
         go to 9000
      else if ( m .gt. maxm ) then
         print *, ' ERROR with _SVD: M is greater than MAXM '
         go to 9000
      else if ( nev .gt. maxnev ) then
         print *, ' ERROR with _SVD: NEV is greater than MAXNEV '
         go to 9000
      else if ( ncv .gt. maxncv ) then
         print *, ' ERROR with _SVD: NCV is greater than MAXNCV '
         go to 9000
      end if
c
c     %-----------------------------------------------------%
c     | Specification of stopping rules and initial         |
c     | conditions before calling DSAUPD                    |
c     |                                                     |
c     |           abs(sigmaC - sigmaT) < TOL*abs(sigmaC)    |
c     |               computed   true                       |
c     |                                                     |
c     |      If TOL .le. 0,  then TOL <- macheps            |
c     |              (machine precision) is used.           |
c     |                                                     |
c     | IDO  is the REVERSE COMMUNICATION parameter         |
c     |      used to specify actions to be taken on return  |
c     |      from DSAUPD. (See usage below.)                |
c     |                                                     |
c     |      It MUST initially be set to 0 before the first |
c     |      call to DSAUPD.                                |
c     |                                                     |
c     | INFO on entry specifies starting vector information |
c     |      and on return indicates error codes            |
c     |                                                     |
c     |      Initially, setting INFO=0 indicates that a     |
c     |      random starting vector is requested to         |
c     |      start the ARNOLDI iteration.  Setting INFO to  |
c     |      a nonzero value on the initial call is used    |
c     |      if you want to specify your own starting       |
c     |      vector (This vector must be placed in RESID.)  |
c     |                                                     |
c     | The work array WORKL is used in DSAUPD as           |
c     | workspace.  Its dimension LWORKL is set as          |
c     | illustrated below.                                  |
c     %-----------------------------------------------------%
c
      lworkl = ncv*(ncv+8)
cph(
      tol = zero
cph      tol = 1.D-10
cph)
      info = 0
      ido = 0
c
c     %---------------------------------------------------%
c     | Specification of Algorithm Mode:                  |
c     |                                                   |
c     | This program uses the exact shift strategy        |
c     | (indicated by setting IPARAM(1) = 1.)             |
c     | IPARAM(3) specifies the maximum number of Arnoldi |
c     | iterations allowed.  Mode 1 of DSAUPD is used     |
c     | (IPARAM(7) = 1). All these options can be changed |
c     | by the user. For details see the documentation in |
c     | DSAUPD.                                           |
c     %---------------------------------------------------%
c
      ishfts = 1
cph(
      maxitr = 10
c      maxitr = 5
c
      mode = 1
cph)
      iparam(1) = ishfts
c
      iparam(3) = maxitr
c
      iparam(7) = mode
c
c     %------------------------------------------------%
c     | M A I N   L O O P (Reverse communication loop) |
c     %------------------------------------------------%
c
C--   Set model configuration (fixed arrays)
      CALL INITIALISE_FIXED( myThid )
c
 10   continue
c
      print *, 'ph----------------------------------------------------'
      print *, 'ph----------------------------------------------------'
      print *, 'ph----------------------------------------------------'
c
c        %---------------------------------------------%
c        | Repeatedly call the routine DSAUPD and take |
c        | actions indicated by parameter IDO until    |
c        | either convergence is indicated or maxitr   |
c        | has been exceeded.                          |
c        %---------------------------------------------%
c
ctest(
         CALL DSAUPD ( ido, bmat, n, which, nev, tol, resid,
     &                 ncv, v, ldv, iparam, ipntr, workd, workl,
     &                 lworkl, info )
ctest         ido = -1
ctest)
c
cph(
         print *, 'ph-count: optimcycle, ido, info, ipntr(1) ',
     &        optimcycle, ido, info, ipntr(1)
cph)

         if (ido .eq. -1 .or. ido .eq. 1) then
c
c           %---------------------------------------%
c           | Perform matrix vector multiplications |
c           |              w <--- A*x       (av())  |
c           |              y <--- A'*w      (atv()) |
c           | The user should supply his/her own    |
c           | matrix vector multiplication routines |
c           | here that takes workd(ipntr(1)) as    |
c           | the input, and returns the result in  |
c           | workd(ipntr(2)).                      |
c           %---------------------------------------%
c
c           call  av (m, n, workd(ipntr(1)), ax)
c           call atv (m, n, ax, workd(ipntr(2)))
c
cph(
c            do l = 1, n
c               print *, 'ph-test A ', l,
c     &              workd(ipntr(1)+l), workd(ipntr(2)+l), workd(l)
c            enddo
cph)
            do l = 1, n
               phtmpadmtlm(l) = workd(ipntr(1)+l-1)
            enddo

            IF (optimcycle .GT. 0 ) THEN
               _BEGIN_MASTER( mythid )
               IF ( myProcId .eq. 0 ) THEN
                  call admtlm_dsvd2model( .FALSE., mythid )
               ENDIF
               _END_MASTER( mythid )
cph               CALL ADMTLM_UPXX( mythid )
            ENDIF

c--         MWMWMWMWMWMWMW
            CALL ADMTLM_DRIVER( mythid )
c--         MWMWMWMWMWMWMW

            _BEGIN_MASTER( mythid )
            IF ( myProcId .eq. 0 ) THEN
               call admtlm_model2dsvd( .FALSE., mythid )
            ENDIF
            _END_MASTER( mythid )

            do l = 1, n
               workd(ipntr(2)+l-1) = phtmpadmtlm(l)
            enddo
c

            if (optimcycle .EQ. 4)
     &           STOP 'in ADMTLM_DSVD after the_model_main'

cph(
cph   Since we solve for a generalized EV problem, we have to solve
cph   M*y=A*x for y with known matrix M and vector A*x
c            do ii = 1, n
c               phxout(ii) = 0.
c               do jj = 1, n
c                  phxout(ii) = phxout(ii) +
c     &                 metricInv(ii,jj)*phtmpout(jj)
c               enddo
c               print *, 'ph-test C ', ii, phxout(ii)
c            enddo
c
c            call dposvx (
c     &           'E', 'U', maxn, 1, metricLoc, 6, metricTriag, 6,
c     &           'N', tmpvec1, phtmpout, 6, phxout, 6, tmpvec2,
c     &           ferr, berr, phrwork, phiwork, ilinsysinfo)
cph
c            call dgesv ( maxn, 1, metricLoc, maxn,
c     &                 ipiv, phtmpout, maxn, ilinsysinfo )
cph
c
cph    Finally schift result y -> workd(ipntr(2))
cph            call dcopy ( maxn, tmpvec1, 1, workd(ipntr(2)), 1 )
cph    We have restored orig. standard EV problem
cph    OP*x = lambda*x for OP = INV(M)*A
cph)
c
c           %-----------------------------------------%
c           | L O O P   B A C K to call DSAUPD again. |
c           %-----------------------------------------%
c
            optimcycle = optimcycle + 1

            go to 10
c
         end if
c
cph(
 1001    continue
         print *, 'ph-continue ', info, ierr
cph)
c
c     %----------------------------------------%
c     | Either we have convergence or there is |
c     | an error.                              |
c     %----------------------------------------%
c
      if ( info .lt. 0 ) then
c
c        %--------------------------%
c        | Error message. Check the |
c        | documentation in DSAUPD. |
c        %--------------------------%
c
         print *, ' '
         print *, ' Error with _saupd, info = ', info
         print *, ' Check documentation in _saupd '
         print *, ' '
c
      else
c
c        %--------------------------------------------%
c        | No fatal errors occurred.                  |
c        | Post-Process using DSEUPD.                 |
c        |                                            |
c        | Computed singular values may be extracted. |
c        |                                            |
c        | Singular vectors may also be computed now  |
c        | if desired.  (indicated by rvec = .true.)  |
c        |                                            |
c        | The routine DSEUPD now called to do this   |
c        | post processing                            |
c        %--------------------------------------------%
c
         rvec = .true.
c
         call dseupd ( rvec, 'All', select, s, v, ldv, sigma,
     &        bmat, n, which, nev, tol, resid, ncv, v, ldv,
     &        iparam, ipntr, workd, workl, lworkl, ierr )
c
c        %-----------------------------------------------%
c        | Singular values are returned in the first     |
c        | column of the two dimensional array S         |
c        | and the corresponding right singular vectors  |
c        | are returned in the first NEV columns of the  |
c        | two dimensional array V as requested here.    |
c        %-----------------------------------------------%
c
         if ( ierr .ne. 0) then
c
c           %------------------------------------%
c           | Error condition:                   |
c           | Check the documentation of DSEUPD. |
c           %------------------------------------%
c
            print *, ' '
            print *, ' Error with _seupd, info = ', ierr
            print *, ' Check the documentation of _seupd. '
            print *, ' '
c
         else
c
            nconv =  iparam(5)
cph(
            do j=1, nconv
               print *, 'ph-ev ', j, s(j,1), s(j,2)
            enddo

            STOP 'TEST AFTER dneupd'
cph)
            do 20 j=1, nconv
c
               s(j,1) = sqrt(s(j,1))
c
c              %-----------------------------%
c              | Compute the left singular   |
c              | vectors from the formula    |
c              |                             |
c              |     u = Av/sigma            |
c              |                             |
c              | u should have norm 1 so     |
c              | divide by norm(Av) instead. |
c              %-----------------------------%
c
               do l = 1, n
                  tmpvec1(l) = v(l,j)
               enddo

c
c--              MWMWMWMWMWMWMW
cph               call box_main( tmpvec1, tmpvec2, metricLoc, ldoadjoint )
c--              MWMWMWMWMWMWMW
c
               call dcopy( m, tmpvec2, 1, u(l,j), 1 )
               temp = one / dnrm2( m, u(l,j), 1 )
cph(
               print *, 'ph-print ', j, dnrm2( m, u(l,j), 1 )
cph)
               call dscal(m , temp, u(l,j), 1 )

cph               do l = 1, n
cph                  u(l,j) = tmpvec2(l)
cph               enddo
cph               temp = one/dnrm2(m, tmpvec2, 1)
cph               call dscal(m, temp, tmpvec2, 1)
c
c              %---------------------------%
c              |                           |
c              | Compute the residual norm |
c              |                           |
c              |   ||  A*v - sigma*u ||    |
c              |                           |
c              | for the NCONV accurately  |
c              | computed singular values  |
c              | and vectors.  (iparam(5)  |
c              | indicates how many are    |
c              | accurate to the requested |
c              | tolerance).               |
c              | Store the result in 2nd   |
c              | column of array S.        |
c              %---------------------------%
c
               call daxpy(m, -s(j,1), u(1,j), 1, tmpvec2, 1)
               s(j,2) = dnrm2(m, tmpvec2, 1)
c
 20         continue
c
c           %-------------------------------%
c           | Display computed residuals    |
c           %-------------------------------%
c
            call dmout(6, nconv, 2, s, maxncv, -6,
     &                'Singular values and direct residuals')
         end if
c
c        %------------------------------------------%
c        | Print additional convergence information |
c        %------------------------------------------%
c
         if ( info .eq. 1) then
            print *, ' '
            print *, ' Maximum number of iterations reached.'
            print *, ' '
         else if ( info .eq. 3) then
            print *, ' '
            print *, ' No shifts could be applied during implicit',
     &               ' Arnoldi update, try increasing NCV.'
            print *, ' '
         end if
c
         print *, ' '
         print *, ' _SVD '
         print *, ' ==== '
         print *, ' '
         print *, ' Size of the matrix is ', n
         print *, ' The number of Ritz values requested is ', nev
         print *, ' The number of Arnoldi vectors generated',
     &            ' (NCV) is ', ncv
         print *, ' What portion of the spectrum: ', which
         print *, ' The number of converged Ritz values is ',
     &              nconv
         print *, ' The number of Implicit Arnoldi update',
     &            ' iterations taken is ', iparam(3)
         print *, ' The number of OP*x is ', iparam(9)
         print *, ' The convergence criterion is ', tol
         print *, ' '
c
      end if
c
c     %-------------------------%
c     | Done with program dsvd. |
c     %-------------------------%
c
 9000 continue
c
      end

#include "LAND_OPTIONS.h"

CBOP
C     !ROUTINE: LAND_OUTPUT
C     !INTERFACE:
      SUBROUTINE LAND_OUTPUT( myTime, myIter, myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R LAND_OUTPUT
C     | o general routine for Land output
C     *==========================================================*
C     | - write snap-shot & time-average output
C     | - call monitor to write global quantities
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     === Global variables ===
#include "LAND_SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "LAND_PARAMS.h"
#include "LAND_VARS.h"
#ifdef ALLOW_AIM
#include "AIM_FFIELDS.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     myTime :: Current time of simulation ( s )
C     myIter :: Current iteration number in simulation
C     myThid :: my Thread Id number
      _RL     myTime
      INTEGER myIter
      INTEGER myThid

#ifdef ALLOW_LAND
C     !FUNCTIONS:
      LOGICAL  DIFFERENT_MULTIPLE
      EXTERNAL DIFFERENT_MULTIPLE

C     !LOCAL VARIABLES:
      CHARACTER*(10) suff
#ifdef ALLOW_MNC
      CHARACTER*(MAX_LEN_FNAM) fn
      CHARACTER*(1) pf
#endif
CEOP

#ifdef ALLOW_AIM
      IF ( land_monFreq.NE.0. ) THEN
        CALL LAND_MONITOR( aim_landFr, myTime, myIter, myThid )
      ENDIF
#endif

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      IF (
     &     DIFFERENT_MULTIPLE( land_diagFreq, myTime, land_deltaT )
     &  .OR. dumpInitAndLast.AND.( myTime.EQ.endTime .OR.
     &                             myTime.EQ.startTime  )
     &   ) THEN

C--   Write snap-shot
C jmc: previously done from LAND_DO_DIAGS, but much better here.

        IF ( land_snapshot_mdsio ) THEN

          IF ( rwSuffixType.EQ.0 ) THEN
            WRITE(suff,'(I10.10)') myIter
          ELSE
            CALL RW_GET_SUFFIX( suff, myTime, myIter, myThid )
          ENDIF

C--   Write ground Temp and soil moisture :
          CALL WRITE_FLD_3D_RL( 'land_groundT.', suff, land_nLev,
     &                           land_groundT, myIter, myThid )
          CALL WRITE_FLD_3D_RL( 'land_enthalp.', suff, land_nLev,
     &                           land_enthalp, myIter, myThid )
          CALL WRITE_FLD_3D_RL( 'land_groundW.', suff, land_nLev,
     &                           land_groundW, myIter, myThid )
C--   other (2-D) state variables:
          CALL WRITE_FLD_XY_RL(
     &         'land_skinT.', suff, land_skinT, myIter, myThid )
          CALL WRITE_FLD_XY_RL(
     &         'land_hSnow.', suff, land_hSnow, myIter, myThid )
          CALL WRITE_FLD_XY_RL(
     &         'land_snAge.', suff, land_snowAge, myIter, myThid )

          IF ( myIter.NE.nIter0 ) THEN
C--   fluxes (2-D map):
          CALL WRITE_FLD_XY_RL(
     &         'land_RunOff.', suff, land_runOff, myIter, myThid )
          CALL WRITE_FLD_XY_RL(
     &         'land_enRnOf.', suff, land_enRnOf, myIter, myThid )
          CALL WRITE_FLD_XY_RL(
     &         'land_HeatFx.', suff, land_HeatFlx, myIter, myThid )
          CALL WRITE_FLD_XY_RL(
     &         'land_frWaFx.', suff, land_Pr_m_Ev, myIter, myThid )
          CALL WRITE_FLD_XY_RL(
     &         'land_EnWaFx.', suff, land_EnWFlux, myIter, myThid )
          ENDIF

        ENDIF

#ifdef ALLOW_MNC
        IF ( land_snapshot_mnc ) THEN
          _BARRIER

          IF ( writeBinaryPrec .EQ. precFloat64 ) THEN
            pf(1:1) = 'D'
          ELSE
            pf(1:1) = 'R'
          ENDIF
          WRITE(fn,'(A)') 'land_snapshot'
          CALL MNC_CW_SET_UDIM(fn, -1, myThid)
          CALL MNC_CW_RL_W_S('D',fn,0,0,'T', myTime, myThid)
          CALL MNC_CW_SET_UDIM(fn, 0, myThid)
          CALL MNC_CW_I_W_S('I',fn,0,0,'iter', myIter, myThid)

          CALL MNC_CW_RL_W(pf,fn,0,0,
     &         'land_groundT', land_groundT, myThid)
          CALL MNC_CW_RL_W(pf,fn,0,0,
     &         'land_enthalp', land_enthalp, myThid)
          CALL MNC_CW_RL_W(pf,fn,0,0,
     &         'land_groundW', land_groundW, myThid)

          CALL MNC_CW_RL_W(pf,fn,0,0,
     &         'land_skinT', land_skinT, myThid)
          CALL MNC_CW_RL_W(pf,fn,0,0,
     &         'land_hSnow', land_hSnow, myThid)
          CALL MNC_CW_RL_W(pf,fn,0,0,
     &         'land_snAge', land_snowAge, myThid)
          CALL MNC_CW_RL_W(pf,fn,0,0,
     &         'land_RunOff', land_runOff, myThid)
          CALL MNC_CW_RL_W(pf,fn,0,0,
     &         'land_enRnOf', land_enRnOf, myThid)

          CALL MNC_CW_RL_W(pf,fn,0,0,
     &         'land_HeatFx', land_HeatFlx, myThid)
          CALL MNC_CW_RL_W(pf,fn,0,0,
     &         'land_frWaFx', land_Pr_m_Ev, myThid)
          CALL MNC_CW_RL_W(pf,fn,0,0,
     &         'land_EnWaFx', land_EnWFlux, myThid)

          _BARRIER
        ENDIF
#endif

      ENDIF

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#endif /* ALLOW_LAND */

      RETURN
      END

#include "CPP_OPTIONS.h"

CBOP
C     !ROUTINE: INI_CARTESIAN_GRID
C     !INTERFACE:
      SUBROUTINE INI_CARTESIAN_GRID( myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE INI_CARTESIAN_GRID
C     | o Initialise model coordinate system
C     *==========================================================*
C     | The grid arrays, initialised here, are used throughout
C     | the code in evaluating gradients, integrals and spatial
C     | avarages. This routine is called separately by each
C     | thread and initialises only the region of the domain
C     | it is "responsible" for.
C     | Under the cartesian grid mode primitive distances
C     | in X and Y are in metres. Distance in Z are in m or Pa
C     | depending on the vertical gridding mode.
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     myThid  :: my Thread Id Number
      INTEGER myThid

C     !LOCAL VARIABLES:
C     == Local variables ==
C     bi,bj   :: tile indices
C     i, j    :: loop counters
C     delXloc :: mesh spacing in X direction
C     delYloc :: mesh spacing in Y direction
C     xGloc   :: mesh corner-point location (local "Long" real array type)
C     yGloc   :: mesh corner-point location (local "Long" real array type)
      INTEGER bi, bj
      INTEGER i,  j
      INTEGER gridNx, gridNy
C NOTICE the extended range of indices!!
      _RL delXloc(0-OLx:sNx+OLx)
      _RL delYloc(0-OLy:sNy+OLy)
C NOTICE the extended range of indices!!
      _RL xGloc(1-OLx:sNx+OLx+1,1-OLy:sNy+OLy+1)
      _RL yGloc(1-OLx:sNx+OLx+1,1-OLy:sNy+OLy+1)
CEOP

C--   For each tile ...
      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)

C--     set tile local mesh (same units as delX,deY)
C       corresponding to coordinates of cell corners for N+1 grid-lines

        CALL INI_LOCAL_GRID(
     O                       xGloc, yGloc,
     O                       delXloc, delYloc,
     O                       gridNx, gridNy,
     I                       bi, bj, myThid )

C--     Make a permanent copy of [xGloc,yGloc] in [xG,yG]
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          xG(i,j,bi,bj) = xGloc(i,j)
          yG(i,j,bi,bj) = yGloc(i,j)
         ENDDO
        ENDDO

C--     Calculate [xC,yC], coordinates of cell centers
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
C         by averaging
          xC(i,j,bi,bj) = 0.25 _d 0*(
     &     xGloc(i,j)+xGloc(i+1,j)+xGloc(i,j+1)+xGloc(i+1,j+1) )
          yC(i,j,bi,bj) = 0.25 _d 0*(
     &     yGloc(i,j)+yGloc(i+1,j)+yGloc(i,j+1)+yGloc(i+1,j+1) )
         ENDDO
        ENDDO

C--     Calculate [dxF,dyF], lengths between cell faces (through center)
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          dxF(i,j,bi,bj) = delXloc(i)
          dyF(i,j,bi,bj) = delYloc(j)
         ENDDO
        ENDDO

C--     Calculate [dxG,dyG], lengths along cell boundaries
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          dxG(i,j,bi,bj) = delXloc(i)
          dyG(i,j,bi,bj) = delYloc(j)
         ENDDO
        ENDDO

C--     The following arrays are not defined in some parts of the halo
C       region. We set them to zero here for safety.
C       Note: this is now done earlier in main S/R INI_GRID

C--     Calculate [dxC], zonal length between cell centers
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx+1,sNx+OLx ! NOTE range
          dxC(i,j,bi,bj) = 0.5 _d 0*(dxF(i,j,bi,bj)+dxF(i-1,j,bi,bj))
         ENDDO
        ENDDO

C--     Calculate [dyC], meridional length between cell centers
        DO j=1-OLy+1,sNy+OLy ! NOTE range
         DO i=1-OLx,sNx+OLx
          dyC(i,j,bi,bj) = 0.5 _d 0*(dyF(i,j,bi,bj)+dyF(i,j-1,bi,bj))
         ENDDO
        ENDDO

C--     Calculate [dxV,dyU], length between velocity points (through corners)
        DO j=1-OLy+1,sNy+OLy ! NOTE range
         DO i=1-OLx+1,sNx+OLx ! NOTE range
C         by averaging (method I)
          dxV(i,j,bi,bj) = 0.5 _d 0*(dxG(i,j,bi,bj)+dxG(i-1,j,bi,bj))
          dyU(i,j,bi,bj) = 0.5 _d 0*(dyG(i,j,bi,bj)+dyG(i,j-1,bi,bj))
C         by averaging (method II)
c         dxV(i,j,bi,bj) = 0.5*(dxG(i,j,bi,bj)+dxG(i-1,j,bi,bj))
c         dyU(i,j,bi,bj) = 0.5*(dyC(i,j,bi,bj)+dyC(i-1,j,bi,bj))
         ENDDO
        ENDDO

C--     Calculate vertical face area
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          rA (i,j,bi,bj) = dxF(i,j,bi,bj)*dyF(i,j,bi,bj)
          rAw(i,j,bi,bj) = dxC(i,j,bi,bj)*dyG(i,j,bi,bj)
          rAs(i,j,bi,bj) = dxG(i,j,bi,bj)*dyC(i,j,bi,bj)
          rAz(i,j,bi,bj) = dxV(i,j,bi,bj)*dyU(i,j,bi,bj)
C--     Set trigonometric terms & grid orientation:
C       Note: this is now done earlier in main S/R INI_GRID
c         tanPhiAtU(i,j,bi,bj) = 0.
c         tanPhiAtV(i,j,bi,bj) = 0.
c         angleCosC(i,j,bi,bj) = 1.
c         angleSinC(i,j,bi,bj) = 0.
         ENDDO
        ENDDO

C--   end bi,bj loops
       ENDDO
      ENDDO

      RETURN
      END

#include "MDSIO_OPTIONS.h"

CBOP
C !ROUTINE: MDS_READ_FIELD
C !INTERFACE:
      SUBROUTINE MDS_READ_FIELD(
     I   fName,
     I   filePrec,
     I   useCurrentDir,
     I   arrType,
     I   kSize,kLo,kHi,
     O   fldRL, fldRS,
     I   irecord,
     I   myThid )

C !DESCRIPTION:
C Arguments:
C
C fName     (string)  :: base name for file to read
C filePrec  (integer) :: number of bits per word in file (32 or 64)
C useCurrentDir(logic):: always read from the current directory (even if
C                        "mdsioLocalDir" is set)
C arrType   (char(2)) :: which array (fldRL/RS) to read into, either "RL" or "RS"
C kSize     (integer) :: size of third dimension: normally either 1 or Nr
C kLo       (integer) :: 1rst vertical level (of array fldRL/RS) to read-in
C kHi       (integer) :: last vertical level (of array fldRL/RS) to read-in
C fldRL       ( RL )  :: array to read into if arrType="RL", fldRL(:,:,kSize,:,:)
C fldRS       ( RS )  :: array to read into if arrType="RS", fldRS(:,:,kSize,:,:)
C irecord   (integer) :: record number to read
C myIter    (integer) :: time step number
C myThid    (integer) :: thread identifier
C
C MDS_READ_FIELD first checks to see IF the file "fName" exists, then
C  IF the file "fName.data" exists and finally the tiled files of the
C  form "fName.xxx.yyy.data" exist. Currently, the meta-files are not
C  read because it is difficult to parse files in fortran.
C The precision of the file is decsribed by filePrec, set either
C  to floatPrec32 or floatPrec64. The char*(2) string arrType, either "RL"
C  or "RS", selects which array is filled in, either fldRL or fldRS.
C (kSize,kLo,kHi) allows for both 2-D and 3-D arrays to be handled, with
C  the option to only read and fill-in a sub-set of consecutive vertical
C  levels (from kLo to kHi) ; (kSize,kLo,kHi)=(1,1,1) implies a 2-D model
C  field and (kSize,kLo,kHi)=(Nr,1,Nr) implies a 3-D model field.
C irecord is the record number to be read and must be >= 1.
C The file data is stored in fldRL/RS *but* the overlaps are *not* updated,
C  i.e., an exchange must be called.
C
C- Multi-threaded: Only Master thread does IO (and MPI calls) and put data
C   to a shared buffer that any thread can get access to.
C- Convention regarding thread synchronisation (BARRIER):
C  A per-thread (or per tile) partition of the 2-D shared-buffer (sharedLocBuf_r4/r8)
C   is readily available => any access (e.g., by master-thread) to a portion
C   owned by an other thread is put between BARRIER (protected).
C  No thread partition exist for the 3-D shared buffer (shared3dBuf_r4/r8).
C   Therefore, the 3-D buffer is considered to be owned by master-thread and
C   any access by other than master thread is put between BARRIER (protected).
C
C Created: 03/16/99 adcroft@mit.edu
CEOP

C !USES:
      IMPLICIT NONE
C Global variables / common blocks
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#ifdef ALLOW_EXCH2
#include "W2_EXCH2_SIZE.h"
#include "W2_EXCH2_TOPOLOGY.h"
#include "W2_EXCH2_PARAMS.h"
#endif /* ALLOW_EXCH2 */
#include "EEBUFF_SCPU.h"
#ifdef ALLOW_FIZHI
# include "fizhi_SIZE.h"
#endif /* ALLOW_FIZHI */
#include "MDSIO_BUFF_3D.h"

C !INPUT PARAMETERS:
      CHARACTER*(*) fName
      INTEGER filePrec
      LOGICAL useCurrentDir
      CHARACTER*(2) arrType
      INTEGER kSize, kLo, kHi
      INTEGER irecord
      INTEGER myThid
C !OUTPUT PARAMETERS:
      _RL  fldRL(*)
      _RS  fldRS(*)

C !FUNCTIONS
      INTEGER  ILNBLNK
      INTEGER  MDS_RECLEN
      LOGICAL  MASTER_CPU_IO
      EXTERNAL ILNBLNK
      EXTERNAL MDS_RECLEN
      EXTERNAL MASTER_CPU_IO

C !LOCAL VARIABLES:
C     bBij  :: base shift in Buffer index for tile bi,bj
      CHARACTER*(MAX_LEN_FNAM) dataFName,pfName
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      LOGICAL exst
      LOGICAL globalFile, fileIsOpen
      LOGICAL iAmDoingIO
      LOGICAL useExch2ioLayOut
      INTEGER xSize, ySize
      INTEGER iG,jG,bi,bj
      INTEGER i1,i2,i,j,k,nNz
      INTEGER irec,dUnit,IL,pIL
      INTEGER length_of_rec
      INTEGER bBij
      INTEGER tNx, tNy, global_nTx
      INTEGER tBx, tBy, iGjLoc, jGjLoc
#ifdef ALLOW_EXCH2
      INTEGER tN
#endif /* ALLOW_EXCH2 */

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C Set dimensions:
      xSize = Nx
      ySize = Ny
      useExch2ioLayOut = .FALSE.
#ifdef ALLOW_EXCH2
      IF ( W2_useE2ioLayOut ) THEN
        xSize = exch2_global_Nx
        ySize = exch2_global_Ny
        useExch2ioLayOut = .TRUE.
      ENDIF
#endif /* ALLOW_EXCH2 */

C Assume nothing
      globalFile = .FALSE.
      fileIsOpen = .FALSE.
      IL  = ILNBLNK( fName )
      pIL = ILNBLNK( mdsioLocalDir )
      nNz = 1 + kHi - kLo

C Only do I/O if I am the master thread (and mpi process 0 IF useSingleCpuIO):
      iAmDoingIO = MASTER_CPU_IO(myThid)

C File name should not be too long:
C    IL(+pIL if not useCurrentDir)(+5: '.data')(+8: bi,bj) =< MAX_LEN_FNAM
C    and shorter enough to be written to msgBuf with other informations
      IF ( useCurrentDir .AND. (90+IL).GT.MAX_LEN_MBUF ) THEN
        WRITE(msgBuf,'(2A,2(I4,A))') 'MDS_READ_FIELD: ',
     &   'Too long (IL=',IL,') file name:'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(errorMessageUnit,'(3A)')'file: >',fName(1:IL),'<'
        CALL ALL_PROC_DIE( myThid )
        STOP 'ABNORMAL END: S/R MDS_READ_FIELD'
      ELSEIF ( (90+IL+pIL).GT.MAX_LEN_MBUF ) THEN
        WRITE(msgBuf,'(2A,2(I4,A))') 'MDS_READ_FIELD: ',
     &   'Too long (pIL=',pIL,', IL=',IL,') pfix + file name:'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(errorMessageUnit,'(3A)')'pfix: >',mdsioLocalDir(1:pIL),'<'
        WRITE(errorMessageUnit,'(3A)')'file: >',fName(1:IL),'<'
        CALL ALL_PROC_DIE( myThid )
        STOP 'ABNORMAL END: S/R MDS_READ_FIELD'
      ENDIF
C Record number must be >= 1
      IF (irecord .LT. 1) THEN
        WRITE(msgBuf,'(3A,I10)')
     &    ' MDS_READ_FIELD: file="', fName(1:IL), '"'
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
        WRITE(msgBuf,'(A,I9.8)')
     &    ' MDS_READ_FIELD: argument irecord = ',irecord
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
        WRITE(msgBuf,'(A)')
     &    ' MDS_READ_FIELD: Invalid value for irecord'
        CALL PRINT_ERROR( msgBuf, myThid )
        CALL ALL_PROC_DIE( myThid )
        STOP 'ABNORMAL END: S/R MDS_READ_FIELD'
      ENDIF
C check for valid sub-set of levels:
      IF ( kLo.LT.1 .OR. kHi.GT.kSize ) THEN
        WRITE(msgBuf,'(3A,I10)')
     &    ' MDS_READ_FIELD: file="', fName(1:IL), '"'
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
        WRITE(msgBuf,'(3(A,I6))')
     &    ' MDS_READ_FIELD: arguments kSize=', kSize,
     &    ' , kLo=', kLo, ' , kHi=', kHi
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
        WRITE(msgBuf,'(A)')
     &    ' MDS_READ_FIELD: invalid sub-set of levels'
        CALL PRINT_ERROR( msgBuf, myThid )
        CALL ALL_PROC_DIE( myThid )
        STOP 'ABNORMAL END: S/R MDS_READ_FIELD'
      ENDIF
C check for 3-D Buffer size:
      IF ( .NOT.useSingleCpuIO .AND. nNz.GT.size3dBuf ) THEN
        WRITE(msgBuf,'(3A,I10)')
     &    ' MDS_READ_FIELD: file="', fName(1:IL), '"'
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
        WRITE(msgBuf,'(3(A,I6))')
     &    ' MDS_READ_FIELD: Nb Lev to read =', nNz,
     &    ' >', size3dBuf, ' = buffer 3rd Dim'
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
        WRITE(msgBuf,'(A)')
     &    ' MDS_READ_FIELD: buffer 3rd Dim. too small'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(A)')
     &    ' increase "size3dBuf" in "MDSIO_BUFF_3D.h" and recompile'
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
        CALL ALL_PROC_DIE( myThid )
        STOP 'ABNORMAL END: S/R MDS_READ_FIELD'
      ENDIF

C Only do I/O if I am the master thread
      IF ( iAmDoingIO ) THEN

C Assign special directory
        IF ( useCurrentDir .OR. pIL.EQ.0 ) THEN
         pfName= fName
        ELSE
         WRITE(pfName,'(2a)') mdsioLocalDir(1:pIL), fName(1:IL)
        ENDIF
        pIL=ILNBLNK( pfName )

C Assign a free unit number as the I/O channel for this routine
        CALL MDSFINDUNIT( dUnit, myThid )

C Check first for global file with simple name (ie. fName)
        dataFName = fName
        INQUIRE( file=dataFName, exist=exst )
        IF (exst) THEN
          IF ( debugLevel .GE. debLevB ) THEN
            WRITE(msgBuf,'(A,A)')
     &      ' MDS_READ_FIELD: opening global file: ',dataFName(1:IL)
            CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                          SQUEEZE_RIGHT, myThid)
          ENDIF
          globalFile = .TRUE.
        ENDIF

C If negative check for global file with MDS name (ie. fName.data)
        IF (.NOT. globalFile) THEN
          WRITE(dataFName,'(2a)') fName(1:IL),'.data'
          INQUIRE( file=dataFName, exist=exst )
          IF (exst) THEN
           IF ( debugLevel .GE. debLevB ) THEN
            WRITE(msgBuf,'(A,A)')
     &      ' MDS_READ_FIELD: opening global file: ',dataFName(1:IL+5)
            CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                          SQUEEZE_RIGHT, myThid)
           ENDIF
           globalFile = .TRUE.
          ENDIF
        ENDIF

C- endif iAmDoingIO
      ENDIF

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      IF ( useSingleCPUIO ) THEN

C master thread of process 0, only, opens a global file
       IF ( iAmDoingIO ) THEN
C If global file is visible to process 0, then open it here.
C Otherwise stop program.
         IF ( globalFile) THEN
          length_of_rec = MDS_RECLEN( filePrec, xSize*ySize, myThid )
          OPEN( dUnit, file=dataFName, status='old', _READONLY_ACTION
     &         access='direct', recl=length_of_rec )
         ELSE
          WRITE(msgBuf,'(2A)')
     &      ' MDS_READ_FIELD: filename: ', dataFName(1:IL+5)
          CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                        SQUEEZE_RIGHT, myThid)
          CALL PRINT_ERROR( msgBuf, myThid )
          WRITE(msgBuf,'(A)')
     &      ' MDS_READ_FIELD: File does not exist'
          CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                        SQUEEZE_RIGHT, myThid)
          CALL PRINT_ERROR( msgBuf, myThid )
          STOP 'ABNORMAL END: S/R MDS_READ_FIELD'
         ENDIF
C- endif iAmDoingIO
       ENDIF

       DO k=kLo,kHi

C master thread of process 0, only, read from file
        IF ( iAmDoingIO ) THEN
          irec = 1 + k-kLo + (irecord-1)*nNz
          IF (filePrec .EQ. precFloat32) THEN
           READ(dUnit,rec=irec) ( xy_buffer_r4(i),i=1,xSize*ySize )
#ifdef _BYTESWAPIO
           CALL MDS_BYTESWAPR4( xSize*ySize, xy_buffer_r4 )
#endif
          ELSE
           READ(dUnit,rec=irec) ( xy_buffer_r8(i),i=1,xSize*ySize )
#ifdef _BYTESWAPIO
           CALL MDS_BYTESWAPR8( xSize*ySize, xy_buffer_r8 )
#endif
          ENDIF
C- endif iAmDoingIO
        ENDIF

C Wait for all thread to finish. This prevents other threads to continue
C  to acces shared buffer while master thread is loading data into
        CALL BAR2( myThid )

        IF ( filePrec.EQ.precFloat32 ) THEN
          CALL SCATTER_2D_R4(
     U                        xy_buffer_r4,
     O                        sharedLocBuf_r4,
     I                        xSize, ySize,
     I                        useExch2ioLayOut, .FALSE., myThid )
C All threads wait for Master to finish loading into shared buffer
          CALL BAR2( myThid )
          IF ( arrType.EQ.'RS' ) THEN
            CALL MDS_PASS_R4toRS( sharedLocBuf_r4, fldRS,
     I                  0, 0, 1, k, kSize, 0, 0, .TRUE., myThid )
          ELSEIF ( arrType.EQ.'RL' ) THEN
            CALL MDS_PASS_R4toRL( sharedLocBuf_r4, fldRL,
     I                  0, 0, 1, k, kSize, 0, 0, .TRUE., myThid )
          ELSE
            WRITE(msgBuf,'(A)')
     &          ' MDS_READ_FIELD: illegal value for arrType'
            CALL PRINT_ERROR( msgBuf, myThid )
            CALL ALL_PROC_DIE( myThid )
            STOP 'ABNORMAL END: S/R MDS_READ_FIELD'
          ENDIF
        ELSEIF ( filePrec.EQ.precFloat64 ) THEN
          CALL SCATTER_2D_R8(
     U                        xy_buffer_r8,
     O                        sharedLocBuf_r8,
     I                        xSize, ySize,
     I                        useExch2ioLayOut, .FALSE., myThid )
C All threads wait for Master to finish loading into shared buffer
          CALL BAR2( myThid )
          IF ( arrType.EQ.'RS' ) THEN
            CALL MDS_PASS_R8toRS( sharedLocBuf_r8, fldRS,
     I                  0, 0, 1, k, kSize, 0, 0, .TRUE., myThid )
          ELSEIF ( arrType.EQ.'RL' ) THEN
            CALL MDS_PASS_R8toRL( sharedLocBuf_r8, fldRL,
     I                  0, 0, 1, k, kSize, 0, 0, .TRUE., myThid )
          ELSE
            WRITE(msgBuf,'(A)')
     &          ' MDS_READ_FIELD: illegal value for arrType'
            CALL PRINT_ERROR( msgBuf, myThid )
            CALL ALL_PROC_DIE( myThid )
            STOP 'ABNORMAL END: S/R MDS_READ_FIELD'
          ENDIF
        ELSE
          WRITE(msgBuf,'(A)')
     &            ' MDS_READ_FIELD: illegal value for filePrec'
          CALL PRINT_ERROR( msgBuf, myThid )
          CALL ALL_PROC_DIE( myThid )
          STOP 'ABNORMAL END: S/R MDS_READ_FIELD'
        ENDIF

       ENDDO
c      ENDDO k=kLo,kHi

       IF ( iAmDoingIO ) THEN
         CLOSE( dUnit )
       ENDIF

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C---  else .NOT.useSingleCpuIO
      ELSE

C Wait for all thread to finish. This prevents other threads to continue
C  to acces 3-D buffer while master thread is reading
c      CALL BAR2( myThid )

C Only do I/O if I am the master thread
       IF ( iAmDoingIO ) THEN

C If we are reading from a global file then we open it here
        IF (globalFile) THEN
         length_of_rec = MDS_RECLEN( filePrec, sNx, myThid )
         OPEN( dUnit, file=dataFName, status='old', _READONLY_ACTION
     &        access='direct', recl=length_of_rec )
         fileIsOpen=.TRUE.
        ENDIF

C Loop over all tiles
        DO bj=1,nSy
         DO bi=1,nSx
          bBij = sNx*sNy*nNz*( bi-1 + (bj-1)*nSx )

          IF (globalFile) THEN
C--- Case of 1 Global file:

c         IF (fileIsOpen) THEN
           tNx = sNx
           tNy = sNy
           global_nTx = xSize/sNx
           tBx = myXGlobalLo-1 + (bi-1)*sNx
           tBy = myYGlobalLo-1 + (bj-1)*sNy
           iGjLoc = 0
           jGjLoc = 1
#ifdef ALLOW_EXCH2
           IF ( useExch2ioLayOut ) THEN
             tN = W2_myTileList(bi,bj)
c            tNx = exch2_tNx(tN)
c            tNy = exch2_tNy(tN)
c            global_nTx = exch2_global_Nx/tNx
             tBx = exch2_txGlobalo(tN) - 1
             tBy = exch2_tyGlobalo(tN) - 1
             IF   ( exch2_mydNx(tN) .GT. xSize ) THEN
C-           face x-size larger than glob-size : fold it
               iGjLoc = 0
               jGjLoc = exch2_mydNx(tN) / xSize
             ELSEIF ( exch2_tNy(tN) .GT. ySize ) THEN
C-           tile y-size larger than glob-size : make a long line
               iGjLoc = exch2_mydNx(tN)
               jGjLoc = 0
             ELSE
C-           default (face fit into global-IO-array)
               iGjLoc = 0
               jGjLoc = 1
             ENDIF
           ENDIF
#endif /* ALLOW_EXCH2 */

           DO k=kLo,kHi
            DO j=1,tNy
             irec = 1 + ( tBx + (j-1)*iGjLoc )/sNx
     &                + ( tBy + (j-1)*jGjLoc )*global_nTx
     &            +( k-kLo + (irecord-1)*nNz )*global_nTx*ySize
             i1 = bBij + 1 + (j-1)*sNx + (k-kLo)*sNx*sNy
             i2 = bBij +         j*sNx + (k-kLo)*sNx*sNy
             IF ( filePrec.EQ.precFloat32 ) THEN
              READ(dUnit,rec=irec) (shared3dBuf_r4(i),i=i1,i2)
             ELSE
              READ(dUnit,rec=irec) (shared3dBuf_r8(i),i=i1,i2)
             ENDIF
C End of j,k loops
            ENDDO
           ENDDO

C end if fileIsOpen
c         ENDIF

          ELSE
C--- Case of 1 file per tile (globalFile=F):

C If we are reading from a tiled MDS file then we open each one here
           iG=bi+(myXGlobalLo-1)/sNx
           jG=bj+(myYGlobalLo-1)/sNy
           WRITE(dataFName,'(2A,I3.3,A,I3.3,A)')
     &            pfName(1:pIL),'.',iG,'.',jG,'.data'
           INQUIRE( file=dataFName, exist=exst )
C Of course, we only open the file if the tile is "active"
C (This is a place-holder for the active/passive mechanism
           IF (exst) THEN
            IF ( debugLevel .GE. debLevB ) THEN
             WRITE(msgBuf,'(A,A)')
     &       ' MDS_READ_FIELD: opening file: ',dataFName(1:pIL+13)
             CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                        SQUEEZE_RIGHT, myThid)
            ENDIF
            length_of_rec = MDS_RECLEN( filePrec, sNx*sNy*nNz, myThid )
            OPEN( dUnit, file=dataFName, status='old', _READONLY_ACTION
     &            access='direct', recl=length_of_rec )
            fileIsOpen=.TRUE.
           ELSE
            fileIsOpen=.FALSE.
            WRITE(msgBuf,'(4A)') ' MDS_READ_FIELD: filename: ',
     &             fName(1:IL),' , ', dataFName(1:pIL+13)
            CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                          SQUEEZE_RIGHT, myThid)
            CALL PRINT_ERROR( msgBuf, myThid )
            WRITE(msgBuf,'(A)')
     &      ' MDS_READ_FIELD: Files DO not exist'
            CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                          SQUEEZE_RIGHT, myThid)
            CALL PRINT_ERROR( msgBuf, myThid )
            STOP 'ABNORMAL END: S/R MDS_READ_FIELD'
           ENDIF

           irec = irecord
           i1 = bBij + 1
           i2 = bBij + sNx*sNy*nNz
           IF ( filePrec.EQ.precFloat32 ) THEN
             READ(dUnit,rec=irec) (shared3dBuf_r4(i),i=i1,i2)
           ELSE
             READ(dUnit,rec=irec) (shared3dBuf_r8(i),i=i1,i2)
           ENDIF

C here We close the tiled MDS file
           IF ( fileIsOpen ) THEN
             CLOSE( dUnit )
             fileIsOpen = .FALSE.
           ENDIF

C--- End Global File / tile-file cases
          ENDIF

C End of bi,bj loops
         ENDDO
        ENDDO

C If global file was opened then close it
        IF (fileIsOpen .AND. globalFile) THEN
          CLOSE( dUnit )
          fileIsOpen = .FALSE.
        ENDIF

#ifdef _BYTESWAPIO
        IF ( filePrec.EQ.precFloat32 ) THEN
          CALL MDS_BYTESWAPR4( sNx*sNy*nNz*nSx*nSy, shared3dBuf_r4 )
        ELSE
          CALL MDS_BYTESWAPR8( sNx*sNy*nNz*nSx*nSy, shared3dBuf_r8 )
        ENDIF
#endif

C- endif iAmDoingIO
       ENDIF

C All threads wait for Master to finish reading into shared buffer
       CALL BAR2( myThid )

C---    Copy from 3-D buffer to fldRL/RS (multi-threads):
        IF ( filePrec.EQ.precFloat32 ) THEN
          IF ( arrType.EQ.'RS' ) THEN
            CALL MDS_PASS_R4toRS( shared3dBuf_r4, fldRS,
     I              0, 0, nNz, kLo, kSize, 0, 0, .TRUE., myThid )
          ELSEIF ( arrType.EQ.'RL' ) THEN
            CALL MDS_PASS_R4toRL( shared3dBuf_r4, fldRL,
     I              0, 0, nNz, kLo, kSize, 0, 0, .TRUE., myThid )
          ELSE
            WRITE(msgBuf,'(A)')
     &         ' MDS_READ_FIELD: illegal value for arrType'
            CALL PRINT_ERROR( msgBuf, myThid )
            CALL ALL_PROC_DIE( myThid )
            STOP 'ABNORMAL END: S/R MDS_READ_FIELD'
          ENDIF
        ELSEIF ( filePrec.EQ.precFloat64 ) THEN
          IF ( arrType.EQ.'RS' ) THEN
            CALL MDS_PASS_R8toRS( shared3dBuf_r8, fldRS,
     I              0, 0, nNz, kLo, kSize, 0, 0, .TRUE., myThid )
          ELSEIF ( arrType.EQ.'RL' ) THEN
            CALL MDS_PASS_R8toRL( shared3dBuf_r8, fldRL,
     I              0, 0, nNz, kLo, kSize, 0, 0, .TRUE., myThid )
          ELSE
            WRITE(msgBuf,'(A)')
     &         ' MDS_READ_FIELD: illegal value for arrType'
            CALL PRINT_ERROR( msgBuf, myThid )
            CALL ALL_PROC_DIE( myThid )
            STOP 'ABNORMAL END: S/R MDS_READ_FIELD'
          ENDIF
        ELSE
          WRITE(msgBuf,'(A)')
     &         ' MDS_READ_FIELD: illegal value for filePrec'
          CALL PRINT_ERROR( msgBuf, myThid )
          CALL ALL_PROC_DIE( myThid )
          STOP 'ABNORMAL END: S/R MDS_READ_FIELD'
        ENDIF

C Wait for all threads to finish getting data from 3-D shared buffer.
C  This prevents the master-thread to change the buffer content before
C  every one got his data.
       CALL BAR2( myThid )

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C     if useSingleCpuIO / else / end
      ENDIF

      RETURN
      END

#include "ctrparam.h"
#include "ATM2D_OPTIONS.h"

C     !INTERFACE:
      SUBROUTINE FIXED_FLUX_ADD( inMonth, wght0, wght1,
     &                   intime0, intime1, iftime, myIter, myThid)
C     *==========================================================*
C     | Add fixed flux files to the surface forcing fields. These|
c     | can be OBS fields or derived fields for anomaly coupling.|
C     *==========================================================*
        IMPLICIT NONE

C     === Global Atmos/Ocean/Seaice Interface Variables ===
#include "ATMSIZE.h"
#include "SIZE.h"
#include "GRID.h"
#include "EEPARAMS.h"
#include "THSICE_VARS.h"
#include "ATM2D_VARS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
C     inMonth - current month
C     wght0, wght1   - weight of first and second month, respectively
C     intime0,intime1- month id # for first and second months
C     iftime - true -> prompts a reloading of data from disk
C     myIter - Ocean iteration number
C     myThid - Thread no. that called this routine.
      INTEGER inMonth
      _RL  wght0
      _RL  wght1
      INTEGER intime0
      INTEGER intime1
      LOGICAL iftime
      INTEGER myIter
      INTEGER myThid

C     LOCAL VARIABLES:
      _RL qfadj     ! temp variable for qflux adjustment
      INTEGER i,j   ! loop counters
C     save below in common block so continual reloading isn't necessary
      COMMON /OCEANMEAN/
     &                 tau0, tau1, tav0, tav1,
     &                 wind0, wind1, qnet0, qnet1,
     &                 evap0, precip0, runoff0
C     &                 evap0, evap1,
C     &                 precip0, precip1,
C     &                 runoff0, runoff1

      _RS  tau0(1-Olx:sNx+Olx,1-Oly:sNy+Oly,1,1)
      _RS  tau1(1-Olx:sNx+Olx,1-Oly:sNy+Oly,1,1)
      _RS  tav0(1-Olx:sNx+Olx,1-Oly:sNy+Oly,1,1)
      _RS  tav1(1-Olx:sNx+Olx,1-Oly:sNy+Oly,1,1)
      _RS  wind0(1-Olx:sNx+Olx,1-Oly:sNy+Oly,1,1)
      _RS  wind1(1-Olx:sNx+Olx,1-Oly:sNy+Oly,1,1)
      _RS  qnet0(1-Olx:sNx+Olx,1-Oly:sNy+Oly,1,1)
      _RS  qnet1(1-Olx:sNx+Olx,1-Oly:sNy+Oly,1,1)
      _RS  evap0(1-Olx:sNx+Olx,1-Oly:sNy+Oly,1,1)
C      _RS  evap1(1-Olx:sNx+Olx,1-Oly:sNy+Oly,1,1)
      _RS  precip0(1-Olx:sNx+Olx,1-Oly:sNy+Oly,1,1)
C      _RS  precip1(1-Olx:sNx+Olx,1-Oly:sNy+Oly,1,1)
      _RS  runoff0(1-Olx:sNx+Olx,1-Oly:sNy+Oly,1,1)
C      _RS  runoff1(1-Olx:sNx+Olx,1-Oly:sNy+Oly,1,1)

      IF (ifTime) THEN

C      If the above condition is met then we need to read in
C      data for the period ahead and the period behind current time.

        WRITE(*,*) 'S/R FIXED_FLUX_ADD: Reading new data'
        IF ( tauuFile .NE. ' '  ) THEN
          CALL READ_REC_XY_RS( tauuFile,tau0,intime0,
     &                      myIter,myThid )
          CALL READ_REC_XY_RS( tauuFile,tau1,intime1,
     &                      myIter,myThid )
        ENDIF
        IF ( tauvFile .NE. ' '  ) THEN
          CALL READ_REC_XY_RS( tauvFile,tav0,intime0,
     &                      myIter,myThid )
          CALL READ_REC_XY_RS( tauvFile,tav1,intime1,
     &                      myIter,myThid )
        ENDIF
        IF ( windFile .NE. ' '  ) THEN
          CALL READ_REC_XY_RS( windFile,wind0,intime0,
     &                      myIter,myThid )
          CALL READ_REC_XY_RS( windFile,wind1,intime1,
     &                      myIter,myThid )
        ENDIF
        IF ( qnetFile .NE. ' '  ) THEN
          CALL READ_REC_XY_RS( qnetFile,qnet0,intime0,
     &                      myIter,myThid )
          CALL READ_REC_XY_RS( qnetFile,qnet1,intime1,
     &                      myIter,myThid )
        ENDIF
      ENDIF
      
      IF (new_mon) THEN
        WRITE(*,*) 'S/R FIXED_FLUX_ADD: Reading new EmPmR files'
        IF ( evapFile .NE. ' '  ) THEN
          CALL READ_REC_XY_RS( evapFile,evap0,inMonth,
     &                      myIter,myThid )
C          CALL READ_REC_XY_RS( evapFile,evap1,intime1,
C     &                      myIter,myThid )
        ENDIF
        IF ( precipFile .NE. ' '  ) THEN
          CALL READ_REC_XY_RS( precipFile,precip0,inMonth,
     &                      myIter,myThid )
C          CALL READ_REC_XY_RS( precipFile,precip1,intime1,
C     &                      myIter,myThid )
        ENDIF
        IF ( runoffFile .NE. ' '  ) THEN
          CALL READ_REC_XY_RS( runoffFile,runoff0,inMonth,
     &                      myIter,myThid )
C          CALL READ_REC_XY_RS( runoffFile,runoff1,intime1,
C     &                      myIter,myThid )
        ENDIF
        new_mon = .FALSE.
      ENDIF


C--   Interpolate and add to anomaly
      DO j=1,sNy
        DO i=1,sNx
         IF (maskC(i,j,1,1,1).EQ.1.) THEN

          fu_2D(i,j)= fu_2D(i,j) +
     &                (wght0*tau0(i,j,1,1) + wght1*tau1(i,j,1,1))
          fv_2D(i,j)= fv_2D(i,j) +
     &                (wght0*tav0(i,j,1,1) + wght1*tav1(i,j,1,1))
          wspeed_2D(i,j)= wspeed_2D(i,j) +
     &                (wght0*wind0(i,j,1,1) + wght1*wind1(i,j,1,1))

          qfadj = (wght0*qnet0(i,j,1,1) + wght1*qnet1(i,j,1,1))
          IF ( (qfadj .NE. 0. _d 0) .AND. 
     &       (iceMask(i,j,1,1) .LT. 0.999 _d 0)) THEN
               qneto_2D(i,j)= qneto_2D(i,j) + qfadj
     &                / (1. _d 0 - iceMask(i,j,1,1))
          ENDIF

C 9/08/06 assume evap is + in file, thus subtract
          IF (useObsEmP) THEN
            evapo_2D(i,j)= -evap0(i,j,1,1) 
            precipo_2D(i,j)= precip0(i,j,1,1)
            IF (iceMask(i,j,1,1) .NE. 0. _d 0) THEN
              evapi_2D(i,j)= -evap0(i,j,1,1)
              precipi_2D(i,j)= precip0(i,j,1,1) 
            ENDIF
          ELSE
            evapo_2D(i,j)= evapo_2D(i,j) -
     &                evap0(i,j,1,1) 
            precipo_2D(i,j)= precipo_2D(i,j) +
     &                precip0(i,j,1,1) 
            IF (iceMask(i,j,1,1) .NE. 0. _d 0) THEN
              evapi_2D(i,j)= evapi_2D(i,j) -
     &                evap0(i,j,1,1) 
              precipi_2D(i,j)= precipi_2D(i,j) +
     &                precip0(i,j,1,1) 
            ENDIF
          ENDIF

          IF (useObsRunoff) THEN
              runoff_2D(i,j)= runoff0(i,j,1,1) 
          ELSE
              runoff_2D(i,j)= runoff_2D(i,j) +
     &                runoff0(i,j,1,1)
          ENDIF
         ENDIF
        ENDDO
      ENDDO

      RETURN
      END

#include "MDSIO_OPTIONS.h"

CBOP
C !ROUTINE: MDS_READ_TAPE
C !INTERFACE:
      SUBROUTINE MDS_READ_TAPE(
     I   fName,
     I   filePrec,
     I   arrType,
     I   nSize,
     O   fldR8, fldR4,
     I   singleCpuIO,
     I   iRec,
     I   myThid )

C !DESCRIPTION:
C MDS_READ_TAPE: load an array (treated as vector) for a tape-file
C  (renamed from MDSREADVECTOR with 2 explicit output array typest)
C
C Arguments:
C fName      string  :: base name for file to read
C filePrec   integer :: number of bits per word in file (32 or 64)
C arrType    char(2) :: which array (fldR8/R4) to read, either "R8" or "R4"
C nSize      integer :: number of elements of input array "fldR8/R4" to read
C fldR8      ( R8 )  :: array to read if arrType="R8", fldR8(nSize)
C fldR4      ( R4 )  :: array to read if arrType="R4", fldR4(nSize)
C singleCpuIO ( L )  :: only proc 0 do IO and send data to other procs
C iRec       integer :: record number to read
C myThid     integer :: my Thread Id number

C !USES:
      IMPLICIT NONE

C-- Global variables --
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"

C !INPUT/OUTPUT PARAMETERS:
      CHARACTER*(*) fName
      INTEGER filePrec
      CHARACTER*(2) arrType
      INTEGER nSize
      _R8     fldR8(*)
      _R4     fldR4(*)
      LOGICAL singleCpuIO
      INTEGER iRec
      INTEGER myThid

#ifdef ALLOW_AUTODIFF

C !FUNCTIONS:
      INTEGER ILNBLNK
      INTEGER MDS_RECLEN
      EXTERNAL ILNBLNK
      EXTERNAL MDS_RECLEN

C !LOCAL VARIABLES:
      CHARACTER*(MAX_LEN_FNAM) dataFName, pfName
      INTEGER iG, jG, jRec, dUnit, IL, pIL
      LOGICAL exst
      LOGICAL globalFile, fileIsOpen
      INTEGER length_of_rec
      CHARACTER*(MAX_LEN_MBUF) msgBuf

C simple implementation of singleCpuIO without any specific EXCH2
C feature (should work as long as reading and writing match)
      INTEGER j
      INTEGER vec_size
C Note: would be better to use explicit (allocate/delocate) dynamical
C       allocation instead of this implicit form:
      _R8    gl_buffer_r8(nSize*nPx*nPy)
      _R4    gl_buffer_r4(nSize*nPx*nPy)
      _R8    local_r8    (nSize)
      _R4    local_r4    (nSize)
CEOP

      vec_size = nSize*nPx*nPy

C--   Only do I/O if I am the master thread
      _BEGIN_MASTER( myThid )

C-    Record number must be >= 1
      IF ( iRec.LT.1 ) THEN
       WRITE(msgBuf,'(A,I10)')
     &   ' MDS_READ_TAPE: argument iRec =',iRec
       CALL PRINT_ERROR( msgBuf, myThid )
       WRITE(msgBuf,'(A)')
     &   ' MDS_READ_TAPE: invalid value for iRec'
       CALL PRINT_ERROR( msgBuf, myThid )
       STOP 'ABNORMAL END: S/R MDS_READ_TAPE'
      ENDIF

C-    Assume nothing
      globalFile = .FALSE.
      fileIsOpen = .FALSE.
      IL  = ILNBLNK( fName )
      pIL = ILNBLNK( mdsioLocalDir )

C-    Assign special directory
      IF ( mdsioLocalDir .NE. ' ' ) THEN
       WRITE(pfName,'(2A)') mdsioLocalDir(1:pIL), fName(1:IL)
      ELSE
       pfName = fName
      ENDIF
      pIL = ILNBLNK( pfName )

C-    Assign a free unit number as the I/O channel for this routine
      CALL MDSFINDUNIT( dUnit, myThid )

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
      IF ( singleCpuIO ) THEN

        IF ( myProcId .EQ. 0 ) THEN
C--   Master thread of process 0, only, opens a global file

C-    Check first for global file with with MDS name (ie. fName.data)
         WRITE(dataFName,'(2A)') fName(1:IL),'.data'
         INQUIRE( file=dataFName, exist=exst )
         IF (exst) globalFile = .TRUE.

C-    If global file is visible to process 0, then open it here.
         IF ( globalFile ) THEN
          IF ( debugLevel .GE. debLevB ) THEN
           WRITE(msgBuf,'(A,A)')
     &     ' MDS_READ_TAPE: opening global file: ',dataFName(1:IL+5)
           CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                         SQUEEZE_RIGHT, myThid )
          ENDIF
          length_of_rec = MDS_RECLEN( filePrec, vec_size, myThid )
          OPEN( dUnit, file=dataFName, status='old', _READONLY_ACTION
     &          access='direct', recl=length_of_rec )
         ELSE
C     Otherwise stop program.
          WRITE(msgBuf,'(2A)')
     &      ' MDS_READ_TAPE: filename: ',dataFName(1:IL)
C-jmc: why double print (stdout + stderr) ?
          CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                        SQUEEZE_RIGHT, myThid )
          CALL PRINT_ERROR( msgBuf, myThid )
          WRITE(msgBuf,'(A)')
     &      ' MDS_READ_TAPE: File does not exist'
          CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                        SQUEEZE_RIGHT, myThid )
          CALL PRINT_ERROR( msgBuf, myThid )
          STOP 'ABNORMAL END: S/R MDS_READ_TAPE'
         ENDIF

C-    Read into global buffer:
         IF ( filePrec.EQ.precFloat32 ) THEN
           READ(dUnit,rec=iRec) gl_buffer_r4
#ifdef _BYTESWAPIO
           CALL MDS_BYTESWAPR4( vec_size, gl_buffer_r4 )
#endif
         ELSEIF ( filePrec.EQ.precFloat64 ) THEN
           READ(dUnit,rec=iRec) gl_buffer_r8
#ifdef _BYTESWAPIO
           CALL MDS_BYTESWAPR8( vec_size, gl_buffer_r8 )
#endif
         ENDIF

C-    Close data-file
         CLOSE( dUnit )

C--   end if myProcId=0
        ENDIF

        IF ( filePrec.EQ.precFloat32 ) THEN
          CALL SCATTER_VEC_R4( gl_buffer_r4, local_r4, nSize, myThid )
        ELSEIF ( filePrec.EQ.precFloat64 ) THEN
          CALL SCATTER_VEC_R8( gl_buffer_r8, local_r8, nSize, myThid )
        ELSE
          WRITE(msgBuf,'(A)')
     &            ' MDS_READ_TAPE: illegal value for filePrec'
          CALL PRINT_ERROR( msgBuf, myThid )
          STOP 'ABNORMAL END: S/R MDS_READ_TAPE'
        ENDIF

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C     if ( singleCpuIO ), else
      ELSEIF ( .NOT. singleCpuIO ) THEN

C-    Check first for global file with with MDS name (ie. fName.data)
        WRITE(dataFName,'(2A)') fName(1:IL),'.data'
        INQUIRE( file=dataFName, exist=exst )
        IF (exst) THEN
          IF ( debugLevel .GE. debLevB ) THEN
           WRITE(msgBuf,'(A,A)')
     &     ' MDS_READ_TAPE: opening global file: ',dataFName(1:IL+5)
           CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                         SQUEEZE_RIGHT, myThid )
          ENDIF
          globalFile = .TRUE.
C-    And open it here
          length_of_rec = MDS_RECLEN( filePrec, nSize, myThid )
          OPEN( dUnit, file=dataFName, status='old',_READONLY_ACTION 
     &          access='direct', recl=length_of_rec )
          fileIsOpen=.TRUE.
        ENDIF

C-    If we are reading from a tiled MDS file then we open each one here
        IF ( .NOT.globalFile ) THEN
         iG = 1 + (myXGlobalLo-1)/sNx
         jG = 1 + (myYGlobalLo-1)/sNy
         WRITE(dataFName,'(2A,I3.3,A,I3.3,A)')
     &              pfName(1:pIL),'.',iG,'.',jG,'.data'
         INQUIRE( file=dataFName, exist=exst )
         IF (exst) THEN
          IF ( debugLevel .GE. debLevB ) THEN
           WRITE(msgBuf,'(A,A)')
     &      ' MDS_READ_TAPE: opening file: ',dataFName(1:pIL+13)
           CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                         SQUEEZE_RIGHT, myThid )
          ENDIF
          length_of_rec = MDS_RECLEN( filePrec, nSize, myThid )
          OPEN( dUnit, file=dataFName, status='old',_READONLY_ACTION 
     &          access='direct', recl=length_of_rec )
          fileIsOpen=.TRUE.
         ELSE
          fileIsOpen=.FALSE.
          WRITE(msgBuf,'(4A)')
     &      ' MDS_READ_TAPE: missing file: ',fName(1:IL),
     &                                 ' , ',dataFName(1:pIL+13)
          CALL PRINT_ERROR( msgBuf, myThid )
          STOP 'ABNORMAL END: S/R MDS_READ_TAPE'
         ENDIF
        ENDIF

        IF ( fileIsOpen ) THEN
          IF ( globalFile ) THEN
C-    read the same way it was written:
            jRec = 1 + myProcId + (iRec-1)*nPx*nPy
          ELSE
            jRec = iRec
          ENDIF
          IF ( filePrec.EQ.precFloat32 ) THEN
           READ(dUnit,rec=jRec) local_r4
#ifdef _BYTESWAPIO
           CALL MDS_BYTESWAPR4( nSize, local_r4 )
#endif
          ELSEIF ( filePrec.EQ.precFloat64 ) THEN
           READ(dUnit,rec=jRec) local_r8
#ifdef _BYTESWAPIO
           CALL MDS_BYTESWAPR8( nSize, local_r8 )
#endif
          ELSE
           WRITE(msgBuf,'(A)')
     &            ' MDS_READ_TAPE: illegal value for filePrec'
           CALL PRINT_ERROR( msgBuf, myThid )
           STOP 'ABNORMAL END: S/R MDS_READ_TAPE'
          ENDIF
C--   If file was opened then close it
          CLOSE( dUnit )
          fileIsOpen = .FALSE.
        ENDIF

C     end-if ( .not. singleCpuIO )
      ENDIF

      _END_MASTER( myThid )

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C--   Copy local buffer into output array
        IF ( arrType.EQ.'R4' ) THEN
          IF ( filePrec.EQ.precFloat32 ) THEN
            DO j=1,nSize
              fldR4(j) = local_r4(j)
            ENDDO
          ELSE
            DO j=1,nSize
              fldR4(j) = local_r8(j)
            ENDDO
          ENDIF
        ELSEIF ( arrType.EQ.'R8' ) THEN
          IF ( filePrec.EQ.precFloat32 ) THEN
            DO j=1,nSize
              fldR8(j) = local_r4(j)
            ENDDO
          ELSE
            DO j=1,nSize
              fldR8(j) = local_r8(j)
            ENDDO
          ENDIF
        ELSE
          WRITE(msgBuf,'(A)')
     &          ' MDS_READ_TAPE: illegal value for arrType'
          CALL PRINT_ERROR( msgBuf, myThid )
          STOP 'ABNORMAL END: S/R MDS_READ_TAPE'
        ENDIF

#else /* ALLOW_AUTODIFF */
      STOP 'ABNORMAL END: S/R MDS_READ_TAPE is empty'
#endif /* ALLOW_AUTODIFF */

      RETURN
      END

#include "CPP_OPTIONS.h"

CBOP
C     !ROUTINE: TAUEDDY_INIT_VARIA
C     !INTERFACE:
      SUBROUTINE TAUEDDY_INIT_VARIA( myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE TAUEDDY_INIT_VARIA
C     | o Initialise to zero some active arrays
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "FFIELDS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     myThid :: my Thread Id number
      INTEGER myThid

#ifdef ALLOW_EDDYPSI

C     !LOCAL VARIABLES:
C     == Local variables ==
C     bi,bj  - Loop counters
C     i,j,k
      INTEGER bi, bj
      INTEGER i, j, k
CEOP

C--   Over all tiles
      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
        DO k=1,Nr
         DO j=1-Oly,sNy+Oly
          DO i=1-Olx,sNx+Olx
           eddyPsiX(i,j,k,bi,bj)=0.
           eddyPsiY(i,j,k,bi,bj)=0.
          ENDDO
         ENDDO
        ENDDO
       ENDDO
      ENDDO

      IF ( eddyPsiXFile .NE. ' ' ) THEN
       CALL READ_FLD_XYZ_RS( eddyPsiXFile, ' ',
     &                       eddyPsiX, nIter0, myThid )
      ENDIF
      IF ( eddyPsiYFile .NE. ' ' ) THEN
       CALL READ_FLD_XYZ_RS( eddyPsiYFile, ' ',
     &                       eddyPsiY, nIter0, myThid )
      ENDIF

      CALL EXCH_UV_XYZ_RS(eddyPsiX,eddyPsiY,.TRUE.,myThid)

#endif /* ALLOW_EDDYPSI */

      RETURN
      END

#include "STREAMICE_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

CBOP
      SUBROUTINE STREAMICE_FINALIZE_PETSC
C     *============================================================*
C     | SUBROUTINE                                                 |
C     | o                                                          |
C     *============================================================*

C     === Global variables ===
#ifdef ALLOW_PETSC
#ifdef STREAMICE_PETSC_3_8

C     THE FOLLOWING MODULES ARE PART OF THE PETSC
C     LIBRARY, USED BY STREAMICE WHEN AVAILABLE TO ACCELERATE
C     SOLVES OF LINEAR SYSTEMS

C     assumes paths
C     {petsc_dir}/include/petsc/finclude/
C     {petsc_dir}/include
C     in the include statement
#include "petsc/finclude/petsc.h"
#include "petsc/finclude/petscvec.h"
      use petscvec
#include "petsc/finclude/petscmat.h"
      use petscmat
#include "petsc/finclude/petscksp.h"
      use petscksp
#include "petsc/finclude/petscpc.h"
      use petscpc
#include "STREAMICE_PETSC_MOD.h"
      IMPLICIT NONE
# else
      IMPLICIT NONE
#include "finclude/petsc.h"
#include "STREAMICE_PETSC_MOD.h"

#endif
#endif

#include "SIZE.h"
#include "GRID.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "STREAMICE.h"

C     !INPUT/OUTPUT ARGUMENTS
c     INTEGER myThid

#ifdef ALLOW_STREAMICE

#ifdef ALLOW_PETSC

      PetscErrorCode ierr

      if (streamice_use_petsc) then
      call PetscFinalize(ierr)
      endif

#endif

#endif
      RETURN
      END

#include "CHEAPAML_OPTIONS.h"

CBOP
C     !ROUTINE: CHEAPAML_INIT_VARIA
C     !INTERFACE:
      SUBROUTINE CHEAPAML_INIT_VARIA( myThid )

C     !DESCRIPTION:
C     *==========================================================*
C     | SUBROUTINE CHEAPAML_INIT_VARIA
C     | o Set cheapaml initial temp field
C     *==========================================================*

C     !USES:
      IMPLICIT NONE
C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "FFIELDS.h"
#include "CHEAPAML.h"

C     !INPUT PARAMETERS:
C     myThid :: my Thread Id number
      INTEGER myThid
CEOP

C     !FUNCTIONS
      INTEGER  ILNBLNK
      EXTERNAL ILNBLNK

C     !LOCAL VARIABLES:
C     bi,bj  :: tile indices
C     i,j    :: grid-point indices
C     msgBuf :: Informational/error message buffer
      INTEGER bi, bj
      INTEGER i, j
      INTEGER iG,jG
      _RL local, localt
      _RL ssqa
      _RL recipNym1
      INTEGER iL, ioUnit
      CHARACTER*(MAX_LEN_MBUF) msgBuf
C     INTEGER prec
C     CHARACTER*(MAX_LEN_FNAM) fn

      ioUnit = standardMessageUnit
      recipNym1 = Ny - 1
      IF ( Ny.GT.1 ) recipNym1 = 1. _d 0 / recipNym1

C--   Initialise CheapAML variables in common block:
      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          Tr            (i,j,bi,bj) = 0. _d 0
          qr            (i,j,bi,bj) = 0. _d 0
          Tair          (i,j,bi,bj) = 0. _d 0
          gTairm        (i,j,bi,bj) = 0. _d 0
          qair          (i,j,bi,bj) = 0. _d 0
          gqairm        (i,j,bi,bj) = 0. _d 0
          uWind         (i,j,bi,bj) = 0. _d 0
          vWind         (i,j,bi,bj) = 0. _d 0
          wWind         (i,j,bi,bj) = 0. _d 0
          solar         (i,j,bi,bj) = 0. _d 0
          ustress       (i,j,bi,bj) = 0. _d 0
          vstress       (i,j,bi,bj) = 0. _d 0
          wavesh        (i,j,bi,bj) = 0. _d 0
          wavesp        (i,j,bi,bj) = 0. _d 0
          cheapPrecip   (i,j,bi,bj) = 0. _d 0
          CheapHgrid    (i,j,bi,bj) = 0. _d 0
c         cheapPrGrid   (i,j,bi,bj) = 0. _d 0
          Cheapclouds   (i,j,bi,bj) = 0. _d 0
          Cheapdlongwave(i,j,bi,bj) = 0. _d 0
          Cheaptracer   (i,j,bi,bj) = 0. _d 0
          CheaptracerR  (i,j,bi,bj) = 0. _d 0
          gCheaptracerm (i,j,bi,bj) = 0. _d 0
         ENDDO
        ENDDO
       ENDDO
      ENDDO

      IF ( startTime.EQ.baseTime .AND. nIter0.EQ.0
     &                           .AND. pickupSuff.EQ.' ' ) THEN

       IF ( AirTempFile .NE. ' ' ) THEN
         iL = ILNBLNK(AirTempFile)
         WRITE(msgBuf,'(4A)') 'CHEAPAML_INIT_VARIA: ',
     &      'Tair initialized from ->', AirTempFile(1:iL), '<-'
         CALL PRINT_MESSAGE(msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
         CALL READ_FLD_XY_RL( AirTempFile,' ',Tair,0,myThid )
       ELSE
         WRITE(msgBuf,'(4A)') 'CHEAPAML_INIT_VARIA: ',
     &      'Tair initialized using standard profile'
         CALL PRINT_MESSAGE(msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
         DO bj = myByLo(myThid), myByHi(myThid)
          DO bi = myBxLo(myThid), myBxHi(myThid)
           DO j=1,sNy
            DO i=1,sNx
             jG = myYGlobalLo-1+(bj-1)*sNy+j
             iG = myXGlobalLo-1+(bi-1)*sNx+i
             localt = 25. _d 0 - (jG-1)*recipNym1*10. _d 0
             localt = 20. _d 0
     &         + 10. _d 0*EXP( -( (jG-30)**2+(iG-30)**2 )/100. _d 0 )
             Tair(i,j,bi,bj) = localt
            ENDDO
           ENDDO
          ENDDO
         ENDDO
       ENDIF
       _EXCH_XY_RL( Tair, myThid )

C do specific humidity
       IF ( AirQFile .NE. ' ') THEN
         iL = ILNBLNK(AirQFile)
         WRITE(msgBuf,'(4A)') 'CHEAPAML_INIT_VARIA: ',
     &      'Qair initialized from ->', AirQFile(1:iL), '<-'
         CALL PRINT_MESSAGE(msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
         CALL READ_FLD_XY_RL( AirQFile,' ',qair,0,myThid )
       ELSE
C     default to 80% relative humidity
         WRITE(msgBuf,'(4A)') 'CHEAPAML_INIT_VARIA: ',
     &      'Qair initialized using standard profile'
         CALL PRINT_MESSAGE(msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
         DO bj = myByLo(myThid), myByHi(myThid)
          DO bi = myBxLo(myThid), myBxHi(myThid)
           DO j=1,sNy
            DO i=1,sNx
             local= Tair(i,j,bi,bj)+celsius2K
             ssqa = ssq0*EXP( lath*(ssq1-ssq2/local) ) / p0
             qair(i,j,bi,bj)=0.8 _d 0*ssqa
            ENDDO
           ENDDO
          ENDDO
         ENDDO
       ENDIF
       _EXCH_XY_RL( qair, myThid )

C do passive tracer
       IF ( TracerFile .NE. ' ') THEN
         iL = ILNBLNK(TracerFile)
         WRITE(msgBuf,'(4A)') 'CHEAPAML_INIT_VARIA: ',
     &      'Tracer initialized from ->', TracerFile(1:iL), '<-'
         CALL PRINT_MESSAGE(msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
         CALL READ_FLD_XY_RL( TracerFile,' ',Cheaptracer,0,myThid )
       ELSE
C default value at 290 (!)
         WRITE(msgBuf,'(4A)') 'CHEAPAML_INIT_VARIA: ',
     &      'Tracer initialized using standard profile'
         CALL PRINT_MESSAGE(msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
         DO bj = myByLo(myThid), myByHi(myThid)
          DO bi = myBxLo(myThid), myBxHi(myThid)
           DO j=1,sNy
            DO i=1,sNx
             Cheaptracer(i,j,bi,bj)=290.0 _d 0
            ENDDO
           ENDDO
          ENDDO
         ENDDO
       ENDIF
       _EXCH_XY_RL( Cheaptracer, myThid )

      ELSE
C Restart from cheapaml_pickups
       CALL CHEAPAML_READ_PICKUP( nIter0, myThid )
C End start-from-iter-zero if/else block
      ENDIF

C     construct cheaplayer thickness
       IF ( cheap_hFile .NE. ' ') THEN
         iL = ILNBLNK(cheap_hFile)
         WRITE(msgBuf,'(4A)') 'CHEAPAML_INIT_VARIA: ',
     &      'BL thickness taken from ->', cheap_hFile(1:iL), '<-'
         CALL PRINT_MESSAGE(msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
         CALL READ_FLD_XY_RL( cheap_hFile,' ',cheapHgrid,0,myThid )
       ELSE
         DO bj = myByLo(myThid), myByHi(myThid)
          DO bi = myBxLo(myThid), myBxHi(myThid)
            DO j=1-OLy,sNy+OLy
             DO i=1-OLx,sNx+OLx
               cheapHgrid(i,j,bi,bj) = cheapaml_h
             ENDDO
            ENDDO
          ENDDO
         ENDDO
       ENDIF
       _EXCH_XY_RL( CheapHgrid, myThid )

c!BD       IF ( cheap_prFile .NE. ' ') THEN
c!BD        write(*,*)'Conv precip taken from  ->',cheap_prFile
c!BD        CALL READ_FLD_XY_RL( cheap_prFile,' ',cheapPrGrid,0,myThid )
c!BD       ELSE
c!BD         DO bj = myByLo(myThid), myByHi(myThid)
c!BD           DO bi = myBxLo(myThid), myBxHi(myThid)
c!BD             DO j=1-OLy,sNy+OLy
c!BD               DO i=1-OLx,sNx+OLx
c!BD               cheapPrGrid(i,j,bi,bj) = 0.0 _d 0
c!BD               ENDDO
c!BD             ENDDO
c!BD           ENDDO
c!BD         ENDDO
c!BD       ENDIF
c!BD        _EXCH_XY_RL( cheapPrGrid, myThid )

C fill in outer edges
       DO bj = myByLo(myThid), myByHi(myThid)
        DO bi = myBxLo(myThid), myBxHi(myThid)
          DO j=1-OLy,sNy+OLy
           jG = myYGlobalLo-1+(bj-1)*sNy+j
           DO i=1-OLx,sNx+OLx
             iG=myXGlobalLo-1+(bi-1)*sNx+i
             IF ( .NOT.cheapamlXperiodic .AND. iG.LT.1 ) THEN
                 Tair(i,j,bi,bj)=Tair(1,j,bi,bj)
                 qair(i,j,bi,bj)=qair(1,j,bi,bj)
                 Cheaptracer(i,j,bi,bj)=Cheaptracer(1,j,bi,bj)
                 CheapHgrid(i,j,bi,bj)=CheapHgrid(1,j,bi,bj)
             ELSEIF ( .NOT.cheapamlXperiodic .AND. iG.GT.Nx ) THEN
                 Tair(i,j,bi,bj)=Tair(sNx,j,bi,bj)
                 qair(i,j,bi,bj)=qair(sNx,j,bi,bj)
                 Cheaptracer(i,j,bi,bj)=Cheaptracer(sNx,j,bi,bj)
                 CheapHgrid(i,j,bi,bj)=CheapHgrid(sNx,j,bi,bj)
             ELSEIF ( .NOT.cheapamlYperiodic .AND.  jG.LT.1 ) THEN
                 Tair(i,j,bi,bj)=Tair(i,1,bi,bj)
                 qair(i,j,bi,bj)=qair(i,1,bi,bj)
                 Cheaptracer(i,j,bi,bj)=Cheaptracer(i,1,bi,bj)
                 CheapHgrid(i,j,bi,bj)=CheapHgrid(i,1,bi,bj)
             ELSEIF ( .NOT.cheapamlYperiodic .AND.  jG.GT.Ny ) THEN
                 Tair(i,j,bi,bj)=Tair(i,sNy,bi,bj)
                 qair(i,j,bi,bj)=qair(i,sNy,bi,bj)
                 Cheaptracer(i,j,bi,bj)=Cheaptracer(i,sNy,bi,bj)
                 CheapHgrid(i,j,bi,bj)=CheapHgrid(i,sNy,bi,bj)
             ENDIF
           ENDDO
          ENDDO
        ENDDO
       ENDDO

      IF ( debugLevel.GE.debLevB .AND. nIter0.EQ.0 ) THEN
        CALL WRITE_FLD_XY_RL('CheapHgrid', ' ', CheapHgrid, 0, myThid )
      ENDIF

      RETURN
      END

#include "OBCS_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: OBCS_BALANCE_FLOW

C     !INTERFACE:
      SUBROUTINE OBCS_BALANCE_FLOW( myTime, myIter, myThid )

C     !DESCRIPTION:
C     *==========================================================*
C     | SUBROUTINE OBCS_BALANCE_FLOW
C     | o Modify OB normal flow to ensure no net inflow
C     *==========================================================*

C     !USES:
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "OBCS_PARAMS.h"
#include "OBCS_GRID.h"
#include "OBCS_FIELDS.h"
#include "FFIELDS.h"

C     !INPUT/OUTPUT PARAMETERS:
      _RL myTime
      INTEGER myIter
      INTEGER myThid
CEOP

#if ( defined ALLOW_OBCS && defined ALLOW_OBCS_BALANCE )

C     !FUNCTIONS:

C     !LOCAL VARIABLES:
C     bi, bj       :: tile indices
C     i,j,k        :: loop indices
C     iB, jB       :: local index of open boundary
C     msgBuf       :: Informational/error message buffer
      INTEGER bi, bj
      INTEGER i, j, k
#if (defined ALLOW_OBCS_EAST ) || (defined ALLOW_OBCS_WEST )
      INTEGER iB
#endif
#if (defined ALLOW_OBCS_NORTH) || (defined ALLOW_OBCS_SOUTH)
      INTEGER jB
#endif
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      _RL areaOB, tmpA
      _RL inFlow, flowE, flowW, flowN, flowS
      _RL tileArea(nSx,nSy)
      _RL tileFlow(nSx,nSy)
      _RL tileAreaOB(nSx,nSy)
      _RL tileInFlow(nSx,nSy)
      LOGICAL flag
      _RL netFreshWaterFlux
      _RL shelfIceNetMassFlux
#ifdef ALLOW_OBCS_EAST
      _RL areaE
#endif
#ifdef ALLOW_OBCS_WEST
      _RL areaW
#endif
#ifdef ALLOW_OBCS_NORTH
      _RL areaN
#endif
#ifdef ALLOW_OBCS_SOUTH
      _RL areaS
#endif

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C-- Old method (OBCS_balanceFac < 0): balance each OB separately
C-- New method applies to all OB with BCS_balanceFac >=0 :
C      ensure that the net inflow through all OB is balanced by correcting
C      each OB normal flow with a uniform velocity, using the corresponding
C      weight factor OBCS_balanceFac.
C  e.g., OBCS_balanceFacE,W,N,S= 1, -1, 2, 0 :
C      => correct Western OBWu (by substracting a uniform velocity) to ensure
C         zero net transport through Western OB
C      => correct Eastern and Northern normal flow (twice larger Northern
C         velocity correction than Eastern correction) to ensure that
C         the total inflow through E+N+S OB is balanced

#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_ENTER('OBCS_BALANCE_FLOW',myThid)
#endif

C--   Integrate the transport through each OB
      flag = .FALSE.
      areaOB = 0. _d 0
      inFlow = 0. _d 0
      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        tileAreaOB(bi,bj) = 0.
        tileInFlow(bi,bj) = 0.
       ENDDO
      ENDDO

#ifdef ALLOW_OBCS_EAST
      areaE = 0. _d 0
      flowE = 0. _d 0
      flag = flag .OR. ( OBCS_balanceFacE.GT.0. )
      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        tileArea(bi,bj) = 0.
        tileFlow(bi,bj) = 0.
        IF ( tileHasOBE(bi,bj) ) THEN
         DO k=1,Nr
          DO j=1,sNy
           iB = OB_Ie(j,bi,bj)
C-    If 1 OB location is on 2 tiles (@ edge of 2 tiles), select the one which
C     communicates with tile interior (sNx+1) rather than with halo region (i=1)
           IF ( iB.NE.OB_indexNone .AND. iB.GT.1 ) THEN
            tmpA = drF(k)*hFacW(iB,j,k,bi,bj)*dyG(iB,j,bi,bj)
     &                   *maskInW(iB,j,bi,bj)
            tileArea(bi,bj) = tileArea(bi,bj) + tmpA
            tileFlow(bi,bj) = tileFlow(bi,bj) + tmpA*OBEu(j,k,bi,bj)
           ENDIF
          ENDDO
         ENDDO
         IF ( OBCS_balanceFacE.GE.0. ) THEN
           tileInFlow(bi,bj) = tileInFlow(bi,bj) - tileFlow(bi,bj)
           tileAreaOB(bi,bj) = tileAreaOB(bi,bj)
     &                       + tileArea(bi,bj)*OBCS_balanceFacE
         ENDIF
         areaE = areaE + tileArea(bi,bj)
         flowE = flowE + tileFlow(bi,bj)
        ENDIF
       ENDDO
      ENDDO
c     WRITE(standardMessageUnit,'(A,I9,1P2E16.8)')
c    &   'OBCS_balance it,areaE,flowE=', myIter, areaE, flowE
      IF ( OBCS_balanceFacE.LT.0. ) THEN
        CALL GLOBAL_SUM_TILE_RL( tileArea, areaE, myThid )
        IF ( areaE.GT.0. ) THEN
          CALL GLOBAL_SUM_TILE_RL( tileFlow, flowE, myThid )
          IF ( debugLevel.GE.debLevC ) THEN
            WRITE(msgBuf,'(A,I9,A,1P2E16.8)') 'OBCS_balance (it=',
     &            myIter, ' ) correct OBEu:', flowE, -flowE/areaE
            CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                          SQUEEZE_RIGHT, myThid )
          ENDIF
          flowE = -flowE/areaE
        ENDIF
      ENDIF
#endif /* ALLOW_OBCS_EAST */

#ifdef ALLOW_OBCS_WEST
      areaW = 0. _d 0
      flowW = 0. _d 0
      flag = flag .OR. ( OBCS_balanceFacW.GT.0. )
      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        tileArea(bi,bj) = 0.
        tileFlow(bi,bj) = 0.
        IF ( tileHasOBW(bi,bj) ) THEN
         DO k=1,Nr
          DO j=1,sNy
           iB = OB_Iw(j,bi,bj)
C-    If 1 OB location is on 2 tiles (@ edge of 2 tiles), select the one which
C     communicates with tile interior (i=0) rather than with halo region (i=sNx)
           IF ( iB.NE.OB_indexNone .AND. iB.LT.sNx ) THEN
            tmpA = drF(k)*hFacW(1+iB,j,k,bi,bj)*dyG(1+iB,j,bi,bj)
     &                   *maskInW(1+iB,j,bi,bj)
            tileArea(bi,bj) = tileArea(bi,bj) + tmpA
            tileFlow(bi,bj) = tileFlow(bi,bj) + tmpA*OBWu(j,k,bi,bj)
           ENDIF
          ENDDO
         ENDDO
         IF ( OBCS_balanceFacW.GE.0. ) THEN
           tileInFlow(bi,bj) = tileInFlow(bi,bj) + tileFlow(bi,bj)
           tileAreaOB(bi,bj) = tileAreaOB(bi,bj)
     &                       + tileArea(bi,bj)*OBCS_balanceFacW
         ENDIF
         areaW = areaW + tileArea(bi,bj)
         flowW = flowW + tileFlow(bi,bj)
        ENDIF
       ENDDO
      ENDDO
c     WRITE(standardMessageUnit,'(A,I9,1P2E16.8)')
c    &   'OBCS_balance it,areaW,flowW=', myIter, areaW, flowW
      IF ( OBCS_balanceFacW.LT.0. ) THEN
        CALL GLOBAL_SUM_TILE_RL( tileArea, areaW, myThid )
        IF ( areaW.GT.0. ) THEN
          CALL GLOBAL_SUM_TILE_RL( tileFlow, flowW, myThid )
          IF ( debugLevel.GE.debLevC ) THEN
            WRITE(msgBuf,'(A,I9,A,1P2E16.8)') 'OBCS_balance (it=',
     &            myIter, ' ) correct OBWu:', flowW, -flowW/areaW
            CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                          SQUEEZE_RIGHT, myThid )
          ENDIF
          flowW = -flowW/areaW
        ENDIF
      ENDIF
#endif /* ALLOW_OBCS_WEST */

#ifdef ALLOW_OBCS_NORTH
      areaN = 0. _d 0
      flowN = 0. _d 0
      flag = flag .OR. ( OBCS_balanceFacN.GT.0. )
      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        tileArea(bi,bj) = 0.
        tileFlow(bi,bj) = 0.
        IF ( tileHasOBN(bi,bj) ) THEN
         DO k=1,Nr
          DO i=1,sNx
           jB = OB_Jn(i,bi,bj)
C-    If 1 OB location is on 2 tiles (@ edge of 2 tiles), select the one which
C     communicates with tile interior (sNy+1) rather than with halo region (j=1)
           IF ( jB.NE.OB_indexNone .AND. jB.GT.1 ) THEN
            tmpA = drF(k)*hFacS(i,jB,k,bi,bj)*dxG(i,jB,bi,bj)
     &                   *maskInS(i,jB,bi,bj)
            tileArea(bi,bj) = tileArea(bi,bj) + tmpA
            tileFlow(bi,bj) = tileFlow(bi,bj) + tmpA*OBNv(i,k,bi,bj)
           ENDIF
          ENDDO
         ENDDO
         IF ( OBCS_balanceFacN.GE.0. ) THEN
           tileInFlow(bi,bj) = tileInFlow(bi,bj) - tileFlow(bi,bj)
           tileAreaOB(bi,bj) = tileAreaOB(bi,bj)
     &                       + tileArea(bi,bj)*OBCS_balanceFacN
         ENDIF
         areaN = areaN + tileArea(bi,bj)
         flowN = flowN + tileFlow(bi,bj)
        ENDIF
       ENDDO
      ENDDO
c     WRITE(standardMessageUnit,'(A,I9,1P2E16.8)')
c    &   'OBCS_balance it,areaN,flowN=', myIter, areaN, flowN
      IF ( OBCS_balanceFacN.LT.0. ) THEN
        CALL GLOBAL_SUM_TILE_RL( tileArea, areaN, myThid )
        IF ( areaN.GT.0. ) THEN
          CALL GLOBAL_SUM_TILE_RL( tileFlow, flowN, myThid )
          IF ( debugLevel.GE.debLevC ) THEN
            WRITE(msgBuf,'(A,I9,A,1P2E16.8)') 'OBCS_balance (it=',
     &            myIter, ' ) correct OBNv:', flowN, -flowN/areaN
            CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                          SQUEEZE_RIGHT, myThid )
          ENDIF
          flowN = -flowN/areaN
        ENDIF
      ENDIF
#endif /* ALLOW_OBCS_NORTH */

#ifdef ALLOW_OBCS_SOUTH
      areaS = 0. _d 0
      flowS = 0. _d 0
      flag = flag .OR. ( OBCS_balanceFacS.GT.0. )
      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        tileArea(bi,bj) = 0.
        tileFlow(bi,bj) = 0.
        IF ( tileHasOBS(bi,bj) ) THEN
         DO k=1,Nr
          DO i=1,sNx
           jB = OB_Js(i,bi,bj)
C-    If 1 OB location is on 2 tiles (@ edge of 2 tiles), select the one which
C     communicates with tile interior (j=0) rather than with halo region (j=sNy)
           IF ( jB.NE.OB_indexNone .AND. jB.LT.sNy ) THEN
            tmpA = drF(k)*hFacS(i,1+jB,k,bi,bj)*dxG(i,1+jB,bi,bj)
     &                   *maskInS(i,1+jB,bi,bj)
            tileArea(bi,bj) = tileArea(bi,bj) + tmpA
            tileFlow(bi,bj) = tileFlow(bi,bj) + tmpA*OBSv(i,k,bi,bj)
           ENDIF
          ENDDO
         ENDDO
         IF ( OBCS_balanceFacS.GE.0. ) THEN
           tileInFlow(bi,bj) = tileInFlow(bi,bj) + tileFlow(bi,bj)
           tileAreaOB(bi,bj) = tileAreaOB(bi,bj)
     &                       + tileArea(bi,bj)*OBCS_balanceFacS
         ENDIF
         areaS = areaS + tileArea(bi,bj)
         flowS = flowS + tileFlow(bi,bj)
        ENDIF
       ENDDO
      ENDDO
c     WRITE(standardMessageUnit,'(A,I9,1P2E16.8)')
c    &   'OBCS_balance it,areaS,flowS=', myIter, areaS, flowS
      IF ( OBCS_balanceFacS.LT.0. ) THEN
        CALL GLOBAL_SUM_TILE_RL( tileArea, areaS, myThid )
        IF ( areaS.GT.0. ) THEN
          CALL GLOBAL_SUM_TILE_RL( tileFlow, flowS, myThid )
          IF ( debugLevel.GE.debLevC ) THEN
            WRITE(msgBuf,'(A,I9,A,1P2E16.8)') 'OBCS_balance (it=',
     &            myIter, ' ) correct OBSv:', flowS, -flowS/areaS
            CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                          SQUEEZE_RIGHT, myThid )
          ENDIF
          flowS = -flowS/areaS
        ENDIF
      ENDIF
#endif /* ALLOW_OBCS_SOUTH */

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C--   Calculate a flux throught the surface from the global change of etaH
C     to take into account both freshwater fluxes like precipitation and
C     displacement fluxes from advancing ice sheets or imported sea ice

      netFreshWaterFlux = 0. _d 0
      shelfIceNetMassFlux = 0. _d 0
      IF ( OBCSbalanceSurf ) THEN
       DO bj=myByLo(myThid),myByHi(myThid)
        DO bi=myBxLo(myThid),myBxHi(myThid)
         tileFlow(bi,bj) = 0.
         DO j=1,sNy
          DO i=1,sNx
           tileFlow(bi,bj) = tileFlow(bi,bj)
     &          - EmPmR(i,j,bi,bj)
     &          * _rA(i,j,bi,bj) * maskInC(i,j,bi,bj)
          ENDDO
         ENDDO
        ENDDO
       ENDDO
       CALL GLOBAL_SUM_TILE_RL( tileFlow, netFreshWaterFlux, myThid )
       IF ( debugLevel.GE.debLevC ) THEN
        WRITE(msgBuf,'(A,I9,A,1P1E16.8)') 'OBCS_balance (it=',
     &       myIter, ' ) correct for netFreshWaterFlux:',
     &       netFreshWaterFlux
        CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &       SQUEEZE_RIGHT, myThid )
       ENDIF
#ifdef ALLOW_SHELFICE
       IF ( useShelfIce ) THEN
        CALL SHELFICE_NETMASSFLUX_SURF(
     O                        shelfIceNetMassFlux,
     I                        myTime, myIter, myThid )
        IF ( debugLevel.GE.debLevC ) THEN
         WRITE(msgBuf,'(A,I9,A,1P1E16.8)') 'OBCS_balance (it=',
     &        myIter, ' ) correct for shelfIceNetMassFlux:',
     &        shelfIceNetMassFlux
         CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &        SQUEEZE_RIGHT, myThid )
        ENDIF
       ENDIF
#endif /* ALLOW_SHELFICE */
      ENDIF

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C--   Calculate a unique velocity correction for all (OBCS_balanceFac>0) OB
C     and correct each OB using corresponding weight factor OBCS_balanceFac

      IF ( flag ) CALL GLOBAL_SUM_TILE_RL( tileAreaOB, areaOB, myThid )
      IF ( areaOB.GT.0. ) THEN
        CALL GLOBAL_SUM_TILE_RL( tileInFlow, inFlow, myThid )
        IF ( debugLevel.GE.debLevC ) THEN
          WRITE(msgBuf,'(A,I9,A,1P2E16.8)') 'OBCS_balance (it=',
     &       myIter, ' ) correct for inFlow:', inFlow, inFlow/areaOB
          CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                        SQUEEZE_RIGHT, myThid )
        ENDIF
        IF ( OBCSbalanceSurf ) THEN
         inFlow = inFlow + netFreshWaterFlux*mass2rUnit
#ifdef ALLOW_SHELFICE
         IF ( useShelfIce )
     &        inFlow = inFlow + shelfIceNetMassFlux*mass2rUnit
#endif
        ENDIF
        inFlow = inFlow / areaOB
      ENDIF
      IF ( OBCS_balanceFacE.GE.0. ) flowE =  inFlow*OBCS_balanceFacE
      IF ( OBCS_balanceFacW.GE.0. ) flowW = -inFlow*OBCS_balanceFacW
      IF ( OBCS_balanceFacN.GE.0. ) flowN =  inFlow*OBCS_balanceFacN
      IF ( OBCS_balanceFacS.GE.0. ) flowS = -inFlow*OBCS_balanceFacS

      IF ( debugLevel.GE.debLevC  .AND. areaOB.GT.0. ) THEN
          WRITE(msgBuf,'(A,1P2E16.8)')
     &     'OBCS_balance correction to OBEu,OBWu:', flowE, flowW
          CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                        SQUEEZE_RIGHT, myThid )
          WRITE(msgBuf,'(A,1P2E16.8)')
     &     'OBCS_balance correction to OBNv,OBSv:', flowN, flowS
          CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                        SQUEEZE_RIGHT, myThid )
      ENDIF

c     IF ( .NOT.useOBCSbalance ) RETURN

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C--   Add correction:

#ifdef ALLOW_OBCS_EAST
      IF ( OBCS_balanceFacE.NE.0. ) THEN
       DO bj=myByLo(myThid),myByHi(myThid)
        DO bi=myBxLo(myThid),myBxHi(myThid)
         IF ( tileHasOBE(bi,bj) ) THEN
          DO k=1,Nr
           DO j=1-OLy,sNy+OLy
            iB = OB_Ie(j,bi,bj)
            IF ( iB.NE.OB_indexNone ) THEN
             OBEu(j,k,bi,bj) = OBEu(j,k,bi,bj)
     &                       + flowE*maskW(iB,j,k,bi,bj)
            ENDIF
           ENDDO
          ENDDO
         ENDIF
        ENDDO
       ENDDO
      ENDIF
#endif /* ALLOW_OBCS_EAST */

#ifdef ALLOW_OBCS_WEST
      IF ( OBCS_balanceFacW.NE.0. ) THEN
       DO bj=myByLo(myThid),myByHi(myThid)
        DO bi=myBxLo(myThid),myBxHi(myThid)
         IF ( tileHasOBW(bi,bj) ) THEN
          DO k=1,Nr
           DO j=1-OLy,sNy+OLy
            iB = OB_Iw(j,bi,bj)
            IF ( iB.NE.OB_indexNone ) THEN
             OBWu(j,k,bi,bj) = OBWu(j,k,bi,bj)
     &                       + flowW*maskW(1+iB,j,k,bi,bj)
            ENDIF
           ENDDO
          ENDDO
         ENDIF
        ENDDO
       ENDDO
      ENDIF
#endif /* ALLOW_OBCS_WEST */

#ifdef ALLOW_OBCS_NORTH
      IF ( OBCS_balanceFacN.NE.0. ) THEN
       DO bj=myByLo(myThid),myByHi(myThid)
        DO bi=myBxLo(myThid),myBxHi(myThid)
         IF ( tileHasOBN(bi,bj) ) THEN
          DO k=1,Nr
           DO i=1-OLx,sNx+OLx
            jB = OB_Jn(i,bi,bj)
            IF ( jB.NE.OB_indexNone ) THEN
             OBNv(i,k,bi,bj) = OBNv(i,k,bi,bj)
     &                       + flowN*maskS(i,jB,k,bi,bj)
            ENDIF
           ENDDO
          ENDDO
         ENDIF
        ENDDO
       ENDDO
      ENDIF
#endif /* ALLOW_OBCS_NORTH */

#ifdef ALLOW_OBCS_SOUTH
      IF ( OBCS_balanceFacS.NE.0. ) THEN
       DO bj=myByLo(myThid),myByHi(myThid)
        DO bi=myBxLo(myThid),myBxHi(myThid)
         IF ( tileHasOBS(bi,bj) ) THEN
          DO k=1,Nr
           DO i=1-OLx,sNx+OLx
            jB = OB_Js(i,bi,bj)
            IF ( jB.NE.OB_indexNone ) THEN
             OBSv(i,k,bi,bj) = OBSv(i,k,bi,bj)
     &                       + flowS*maskS(i,1+jB,k,bi,bj)
            ENDIF
           ENDDO
          ENDDO
         ENDIF
        ENDDO
       ENDDO
      ENDIF
#endif /* ALLOW_OBCS_SOUTH */

#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_LEAVE('OBCS_BALANCE_FLOW',myThid)
#endif

#endif /* ALLOW_OBCS and ALLOW_OBCS_BALANCE */

      RETURN
      END

#include "KL10_OPTIONS.h"

CBOP
C     !ROUTINE: KL10_INIT_FIXED
C     !INTERFACE:
      SUBROUTINE KL10_INIT_FIXED( myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE KL10_INIT_FIXED
C     | o Routine to initialize KL10 variables
C     |   that are kept fixed during the run.
C     *==========================================================*
C     \ev
C     !USES:
      IMPLICIT NONE

C     === Global variables ===
#include "EEPARAMS.h"
#include "SIZE.h"
#include "PARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
C     myThid ::  my Thread Id number
      INTEGER myThid
CEOP

C     !LOCAL VARIABLES :
C     === Local variables ===
C
C JMK: not sure what this is.
CML#ifdef ALLOW_MNC
CML      IF (useMNC) THEN
CMLC       Define grid types for Mellor-Yamada (MY) variables
CML        CALL MNC_CW_ADD_VNAME('KLviscAr', 'Cen_xy_Hn__C__t',
CML     &       4,5, myThid)
CML        CALL MNC_CW_ADD_VATTR_TEXT('KLviscAr','units','m^2/s',
CML     &       myThid)
CML        CALL MNC_CW_ADD_VATTR_TEXT('KLviscAr','long_name',
CML     &       'MY_vertical_eddy_viscosity_coefficient', myThid)
CML        CALL MNC_CW_ADD_VATTR_TEXT('KLviscAr',
CML     &       'coordinates','XC YC RC iter', myThid)
CML
CML        CALL MNC_CW_ADD_VNAME('KLdiffKr', 'Cen_xy_Hn__C__t',
CML     &       4,5, myThid)
CML        CALL MNC_CW_ADD_VATTR_TEXT('KLdiffKr','units','m^2/s',
CML     &       myThid)
CML        CALL MNC_CW_ADD_VATTR_TEXT('KLdiffKr','long_name',
CML     &       'MY_tracer_vertical_diffusion_coefficient',
CML     &       myThid)
CML        CALL MNC_CW_ADD_VATTR_TEXT('KLdiffKr',
CML     &       'coordinates','XC YC RC iter', myThid)
CML#endif /* ALLOW_MNC */

#ifdef ALLOW_DIAGNOSTICS
      IF ( useDiagnostics ) THEN
        CALL KL10_DIAGNOSTICS_INIT( myThid )
      ENDIF
#endif

      RETURN
      END

#include "PROFILES_OPTIONS.h"

C     ==================================================================
C
C     active_files_ad.F: Routines to handle the I/O of the active file
C                        for the adjoint calculations. All files are
C                        direct access files.
C
C     Routines
C
C     o  adactive_read_profile      - Adjoint of active_read_profile
C     o  adactive_write_profile     - Adjoint of active_write_profile
C
C        changed: gforget@ocean.mit.edu 23-Mar-2006
C
C     ==================================================================

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C !ROUTINE: ADACTIVE_READ_PROFILE

C !INTERFACE:
      SUBROUTINE ADACTIVE_READ_PROFILE(
     I                              active_num_file,
     I                              nadactive_var,
     I                              adactive_var,
     I                              active_varnum,
     I                              irec,
     I                              lAdInit,
     I                              myIter,
     I                              bi,
     I                              bj,
     I                              myThid
     &                            )

C     !DESCRIPTION:
C     Adjoint of active_read_profile.

C     !USES:
      IMPLICIT NONE
C     == Global variables ===
#include "EEPARAMS.h"
#include "SIZE.h"
#ifdef ALLOW_PROFILES
# include "PROFILES_SIZE.h"
# include "profiles.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     active_var_file: filename
C     nadactive_var:   integer size of adactive_var
C     adactive_var:    array
C     irec:            record number
C     myIter:          number of optimization iteration (default: 0)
C     myThid:          my thread ID number
C     doglobalread:    flag for global or local read/write
C                      (default: .false.)
C     lAdInit:         initialisation of corresponding adjoint
C                      variable and write to active file
      INTEGER nadactive_var,active_num_file
      _RL     adactive_var(nadactive_var)
      INTEGER irec,active_varnum
      INTEGER myIter
      INTEGER bi,bj,myThid
      LOGICAL lAdInit
CEOP

#ifdef ALLOW_PROFILES

      CALL ACTIVE_READ_PROFILE_RL( fidadjoint(active_num_file,bi,bj),
     &     active_num_file,
     &     nadactive_var, adactive_var, active_varnum, lAdInit,
     &     irec, prof_ind_glob(active_num_file,irec,bi,bj),
     &     REVERSE_SIMULATION, myIter,bi,bj, myThid)

#endif

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C !ROUTINE: ADACTIVE_WRITE_PROFILE

C !INTERFACE:
      SUBROUTINE ADACTIVE_WRITE_PROFILE(
     I                              active_num_file,
     I                              nadactive_var,
     I                              adactive_var,
     I                              active_varnum,
     I                              irec,
     I                              myIter,
     I                              bi,
     I                              bj,
     I                              myThid,
     I                              dummy
     &                            )

C     !DESCRIPTION:
C     Adjoint of active_write_profile.

C     !USES:
      IMPLICIT NONE
C     == Global variables ===
#include "EEPARAMS.h"
#include "SIZE.h"
#ifdef ALLOW_PROFILES
# include "PROFILES_SIZE.h"
# include "profiles.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     active_var_file: filename
C     nadactive_var:   integer size of adactive_var
C     adactive_var:    array
C     irec:            record number
C     myIter:          number of optimization iteration (default: 0)
C     myThid:          my thread ID number
C     doglobalread:    flag for global or local read/write
C                      (default: .false.)
C     lAdInit:         initialisation of corresponding adjoint
C                      variable and write to active file
      INTEGER nadactive_var,active_num_file
      _RL     adactive_var(nadactive_var)
      INTEGER irec,active_varnum
      INTEGER myIter
      INTEGER bi,bj,myThid
      _RL     dummy
CEOP

#ifdef ALLOW_PROFILES

      CALL ACTIVE_WRITE_PROFILE_RL( fidadjoint(active_num_file,bi,bj),
     &     active_num_file,
     &     nadactive_var, adactive_var, active_varnum,
     &     irec, prof_ind_glob(active_num_file,irec,bi,bj),
     &     REVERSE_SIMULATION, myIter,bi,bj, myThid)

#endif

      RETURN
      END

#include "SEAICE_OPTIONS.h"

CBOP
C !ROUTINE: SEAICE_PREPARE_RIDGING
C !INTERFACE: ==========================================================
      SUBROUTINE SEAICE_PREPARE_RIDGING(
#ifdef SEAICE_ITD
     O     hActual,
     O     hrMin, hrMax, hrExp, ridgeRatio, ridgingModeNorm, partFunc,
#endif /* SEAICE_ITD */
     I     iMin, iMax, jMin, jMax, bi, bj, myTime, myIter, myThid )

C !DESCRIPTION: \bv
C     *===========================================================*
C     | SUBROUTINE SEAICE_PREPARE_RIDGING
C     | o compute ridging parameters according to Thorndyke et al
C     |   (1975), Hibler (1980), Bitz et al (2001) or
C     |   Lipscomb et al (2007)
C     | o this routine is called from s/r seaice_do_ridging and
C     |   from s/r seaice_calc_ice_strength
C     |
C     | Martin Losch, Apr. 2014, Martin.Losch@awi.de
C     *===========================================================*
C \ev

C !USES: ===============================================================
      IMPLICIT NONE

#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "SEAICE_SIZE.h"
#include "SEAICE_PARAMS.h"
#include "SEAICE_GRID.h"
#include "SEAICE.h"

C !INPUT PARAMETERS: ===================================================
C     === Routine arguments ===
C     bi, bj    :: outer loop counters
C     myTime    :: current time
C     myIter    :: iteration number
C     myThid    :: Thread no. that called this routine.
C     i/jMin/Max:: loop boundaries
      _RL myTime
      INTEGER bi,bj
      INTEGER myIter
      INTEGER myThid
      INTEGER iMin, iMax, jMin, jMax
#ifdef SEAICE_ITD
C     ridgingModeNorm :: norm to ensure convervation (N in Lipscomb et al 2007)
C     partFunc   :: participation function (a_n in Lipscomb et al 2007)
C     ridgeRatio :: mean ridge thickness/ thickness of ridging ice
C     hrMin      :: min ridge thickness
C     hrMax      :: max ridge thickness   (SEAICEredistFunc = 0)
C     hrExp      :: ridge e-folding scale (SEAICEredistFunc = 1)
C     hActual    :: HEFFITD/AREAITD, regularized
      _RL ridgingModeNorm (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL partFunc        (1-OLx:sNx+OLx,1-OLy:sNy+OLy,0:nITD)
      _RL hrMin           (1-OLx:sNx+OLx,1-OLy:sNy+OLy,1:nITD)
      _RL hrMax           (1-OLx:sNx+OLx,1-OLy:sNy+OLy,1:nITD)
      _RL hrExp           (1-OLx:sNx+OLx,1-OLy:sNy+OLy,1:nITD)
      _RL ridgeRatio      (1-OLx:sNx+OLx,1-OLy:sNy+OLy,1:nITD)
      _RL hActual         (1-OLx:sNx+OLx,1-OLy:sNy+OLy,1:nITD)
CEndOfInterface

C !LOCAL VARIABLES: ====================================================
C     === Local variables ===
C     i,j,k       :: inner loop counters
C
      INTEGER i, j
      INTEGER k
C     variables related to ridging schemes
C     gSum        :: cumulative distribution function G
      _RL gSum            (1-OLx:sNx+OLx,1-OLy:sNy+OLy,-1:nITD)
      _RL recip_gStar, recip_aStar, tmp
C     Regularization values squared
      _RL area_reg_sq, hice_reg_sq
CEOP

C---+-|--1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C     regularization constants
      area_reg_sq = SEAICE_area_reg * SEAICE_area_reg
      hice_reg_sq = SEAICE_hice_reg * SEAICE_hice_reg
      DO k=1,nITD
       DO j=jMin,jMax
        DO i=iMin,iMax
         hActual(i,j,k) = 0. _d 0
CML         IF ( AREAITD(i,j,k,bi,bj) .GT. SEAICE_area_reg ) THEN
CML          hActual(i,j,k) = HEFFITD(i,j,k,bi,bj)/AREAITD(i,j,k,bi,bj)
CML         ENDIF
         IF ( HEFFITD(i,j,k,bi,bj) .GT. 0. _d 0 ) THEN
C     regularize as in seaice_growth: compute hActual with regularized
C     AREA and regularize from below with a minimum thickness
          tmp = HEFFITD(i,j,k,bi,bj)
     &         /SQRT( AREAITD(i,j,k,bi,bj)**2 + area_reg_sq )
          hActual(i,j,k) = SQRT(tmp * tmp + hice_reg_sq)
         ENDIF
        ENDDO
       ENDDO
      ENDDO

C---+-|--1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C     compute the cumulative thickness distribution function gSum
      DO j=jMin,jMax
       DO i=iMin,iMax
        gSum(i,j,-1) = 0. _d 0
        gSum(i,j,0)  = 0. _d 0
        IF ( opnWtrFrac(i,j,bi,bj) .GT. SEAICE_area_floor )
     &       gSum(i,j,0) = opnWtrFrac(i,j,bi,bj)
       ENDDO
      ENDDO
      DO k = 1, nITD
       DO j=jMin,jMax
        DO i=iMin,iMax
         gSum(i,j,k) = gSum(i,j,k-1)
         IF ( AREAITD(i,j,k,bi,bj) .GT. SEAICE_area_floor )
     &        gSum(i,j,k) = gSum(i,j,k) + AREAITD(i,j,k,bi,bj)
        ENDDO
       ENDDO
      ENDDO
C     normalize
      DO k = 0, nITD
       DO j=jMin,jMax
        DO i=iMin,iMax
         IF ( gSum(i,j,nITD).NE.0. _d 0 )
     &        gSum(i,j,k) = gSum(i,j,k) / gSum(i,j,nITD)
        ENDDO
       ENDDO
      ENDDO

C     Compute the participation function
C                    area lost from category n due to ridging/closing
C     partFunc(n) = --------------------------------------------------
C                       total area lost due to ridging/closing

      IF ( SEAICEpartFunc .EQ. 0 ) THEN
C     Thorndike et al. (1975) discretize b(h) = (2/Gstar) * (1 - G(h)/Gstar)
C     The expressions for the partition function partFunc are found by
C     integrating b(h)g(h) between the category boundaries.
       recip_gStar = 1. _d 0 / SEAICEgStar
       DO k = 0, nITD
        DO j=jMin,jMax
         DO i=iMin,iMax
          partFunc(i,j,k) = 0. _d 0
          IF ( gSum(i,j,k) .LT. SEAICEgStar ) THEN
           partFunc(i,j,k) =
     &          (gSum(i,j,k)-gSum(i,j,k-1)) * recip_gStar
     &          *( 2. _d 0 - (gSum(i,j,k-1)+gSum(i,j,k))*recip_gStar)
          ELSEIF (  gSum(i,j,k-1) .LT. SEAICEgStar
     &          .AND. gSum(i,j,k) .GE. SEAICEgStar ) THEN
           partFunc(i,j,k) =
     &          (SEAICEgStar-gSum(i,j,k-1)) * recip_gStar
     &          *( 2. _d 0 - (gSum(i,j,k-1)+SEAICEgStar)*recip_gStar)
          ENDIF
         ENDDO
        ENDDO
       ENDDO
      ELSEIF  ( SEAICEpartFunc .EQ. 1 ) THEN
C     Lipscomb et al. (2007) discretize b(h) = exp(-G(h)/astar) into
C     partFunc(n) = [exp(-G(n-1)/astar - exp(-G(n)/astar] / [1-exp(-1/astar)].
C     The expression is found by integrating b(h)g(h) between the category
C     boundaries.
       recip_astar = 1. _d 0 / SEAICEaStar
       tmp = 1. _d 0 / ( 1. _d 0 - EXP( -recip_astar ) )
C     abuse gSum as a work array
       k = -1
       DO j=jMin,jMax
        DO i=iMin,iMax
         gSum(i,j,k)     = EXP(-gSum(i,j,k)*recip_astar) * tmp
        ENDDO
       ENDDO
       DO k = 0, nITD
        DO j=jMin,jMax
         DO i=iMin,iMax
          gSum(i,j,k)     = EXP(-gSum(i,j,k)*recip_astar) * tmp
          partFunc(i,j,k) = gSum(i,j,k-1) - gSum(i,j,k)
         ENDDO
        ENDDO
       ENDDO
      ELSE
       STOP 'Ooops: SEAICEpartFunc > 1 not implemented'
      ENDIF

C     Compute variables of ITD of ridged ice
C     ridgeRatio :: mean ridge thickness/ thickness of ridging ice
C     hrMin      :: min ridge thickness
C     hrMax      :: max ridge thickness   (SEAICEredistFunc = 0)
C     hrExp      :: ridge e-folding scale (SEAICEredistFunc = 1)
      DO k = 1, nITD
       DO j=jMin,jMax
        DO i=iMin,iMax
         hrMin(i,j,k)      = 0. _d 0
         hrMax(i,j,k)      = 0. _d 0
         hrExp(i,j,k)      = 0. _d 0
C     avoid divisions by zero
         ridgeRatio(i,j,k) = 1. _d 0
        ENDDO
       ENDDO
      ENDDO
      IF ( SEAICEredistFunc .EQ. 0 ) THEN
C     Assume ridged ice is uniformly distributed between hrmin and hrmax.
C     (Hibler, 1980)
       DO k = 1, nITD
        DO j=jMin,jMax
         DO i=iMin,iMax
          IF ( hActual(i,j,k) .GT. 0. _d 0 ) THEN
C     This is the original Hibler (1980) scheme:
           hrMin(i,j,k) = 2. _d 0 * hActual(i,j,k)
           hrMax(i,j,k) = 2. _d 0 * SQRT(hActual(i,j,k)*SEAICEhStar)
C     CICE does this in addition, so that thick ridging ice is not required
C     to raft:
           hrMin(i,j,k) = MIN(hrMin(i,j,k),hActual(i,j,k)+SEAICEmaxRaft)
           hrMax(i,j,k) = MAX(hrMax(i,j,k),hrMin(i,j,k)+SEAICE_hice_reg)
C
           ridgeRatio(i,j,k) =
     &          0.5 _d 0 * (hrMax(i,j,k)+hrMin(i,j,k))/hActual(i,j,k)
          ENDIF
         ENDDO
        ENDDO
       ENDDO
      ELSEIF ( SEAICEredistFunc .EQ. 1 ) THEN
C     Follow Lipscomb et al. (2007) and model ridge ITD as an exponentially
C     decaying function
       DO k = 1, nITD
        DO j=jMin,jMax
         DO i=iMin,iMax
          IF ( hActual(i,j,k) .GT. 0. _d 0 ) THEN
C     regularization is only required in this case but already done above
CML           tmp = MAX(hActual(i,j,k), SEAICE_hice_reg)
           tmp = hActual(i,j,k)
           hrMin(i,j,k) = MIN(2.D0 * tmp, tmp+SEAICEmaxRaft)
           hrExp(i,j,k) = SEAICEmuRidging*SQRT(tmp)
C     arent we missing a factor 0.5 here?
           ridgeRatio(i,j,k)=(hrMin(i,j,k)+hrExp(i,j,k))/tmp
          ENDIF
         ENDDO
        ENDDO
       ENDDO
      ELSE
       STOP 'Ooops: SEAICEredistFunc > 1 not implemented'
      ENDIF

C     Compute the norm of the ridging mode N (in Lipscomp et al 2007)
C     or omega (in Bitz et al 2001):
C     rigdingModeNorm = net ice area removed / total area participating.
C     For instance, if a unit area of ice with thickness = 1 participates in
C     ridging to form a ridge with a = 1/3 and thickness = 3, then
C     rigdingModeNorm = 1 - 1/3 = 2/3.
      DO j=jMin,jMax
       DO i=iMin,iMax
        ridgingModeNorm(i,j) = partFunc(i,j,0)
       ENDDO
      ENDDO
      DO k = 1, nITD
       DO j=jMin,jMax
        DO i=iMin,iMax
         partFunc(i,j,k) = partFunc(i,j,k) * heffM(i,j,bi,bj)
         ridgingModeNorm(i,j) = ridgingModeNorm(i,j)
     &        + partFunc(i,j,k)*( 1. _d 0 - 1. _d 0/ridgeRatio(i,j,k) )
        ENDDO
       ENDDO
      ENDDO
C     avoid division by zero
      DO j=jMin,jMax
       DO i=iMin,iMax
        IF ( ridgingModeNorm(i,j) .LE. 0. _d 0 )
     &       ridgingModeNorm(i,j) = 1. _d 0
       ENDDO
      ENDDO

#endif /* SEAICE_ITD */

      RETURN
      END

#include "OBCS_OPTIONS.h"
#ifdef ALLOW_CTRL
# include "CTRL_OPTIONS.h"
#endif
c#ifdef ALLOW_COST
c# include "COST_OPTIONS.h"
c#endif

CBOP
C !ROUTINE: OBCS_COST_FINAL

C !INTERFACE: ==========================================================
      SUBROUTINE OBCS_COST_FINAL( ifc, optimcycle, myThid )

C !DESCRIPTION:
C     Compute cost function contribution (Tikhonov regularisation)
C     of pkg/obcs and print to STDOUT and costfunction_obcs-file.

C !USES: ===============================================================
      IMPLICIT NONE
C     == Global variables ==
#include "EEPARAMS.h"
#include "SIZE.h"
#ifdef ALLOW_COST
# include "cost.h"
#endif
#ifdef ALLOW_CTRL
# include "CTRL_OBCS.h"
#endif

C !INPUT PARAMETERS: ===================================================
C     ifc        :: file unit for costfunction_obcs.XXXX
C     optimcycle :: cycle number of the off-line optimization.
C     myThid     :: my Thread Id number
      INTEGER ifc
      INTEGER optimcycle
      INTEGER myThid

#if defined ALLOW_COST && defined ALLOW_CTRL
C    defined ALLOW_OBCS_CONTROL
C    defined ALLOW_OBCS_COST_CONTRIBUTION

C !LOCAL VARIABLES: ====================================================
      INTEGER bi, bj
      _RL f_obcsN, f_obcsS, f_obcsE, f_obcsW, f_ageos
      _RL no_obcsN, no_obcsS, no_obcsE, no_obcsW, no_ageos

      CHARACTER*23 cfname
      CHARACTER*(MAX_LEN_MBUF) msgBuf
CEOP

      IF ( useObcsCostContribution ) THEN
       f_obcsN  = 0. _d 0
       f_obcsS  = 0. _d 0
       f_obcsE  = 0. _d 0
       f_obcsW  = 0. _d 0
       f_ageos  = 0. _d 0
       no_obcsN = 0. _d 0
       no_obcsS = 0. _d 0
       no_obcsE = 0. _d 0
       no_obcsW = 0. _d 0
       no_ageos = 0. _d 0

c--   Sum up all contributions.
       DO bj = myByLo(myThid), myByHi(myThid)
        DO bi = myBxLo(myThid), myBxHi(myThid)

         tile_fc(bi,bj) = tile_fc(bi,bj)
     &        + mult_obcsN   * objf_obcsN(bi,bj)
     &        + mult_obcsS   * objf_obcsS(bi,bj)
     &        + mult_obcsE   * objf_obcsE(bi,bj)
     &        + mult_obcsW   * objf_obcsW(bi,bj)
# ifdef OBCS_AGEOS_COST_CONTRIBUTION
     &        + mult_ageos   * objf_ageos(bi,bj)
# endif
         f_obcsN  = f_obcsN + objf_obcsN(bi,bj)
         f_obcsS  = f_obcsS + objf_obcsS(bi,bj)
         f_obcsE  = f_obcsE + objf_obcsE(bi,bj)
         f_obcsW  = f_obcsW + objf_obcsW(bi,bj)
         no_obcsN = no_obcsN + num_obcsN(bi,bj)
         no_obcsS = no_obcsS + num_obcsS(bi,bj)
         no_obcsE = no_obcsE + num_obcsE(bi,bj)
         no_obcsW = no_obcsW + num_obcsW(bi,bj)
# ifdef OBCS_AGEOS_COST_CONTRIBUTION
         f_ageos  = f_ageos + objf_ageos(bi,bj)
         no_ageos = no_ageos + num_ageos(bi,bj)
# endif
        ENDDO
       ENDDO

       _GLOBAL_SUM_RL( f_obcsN , myThid )
       _GLOBAL_SUM_RL( f_obcsS , myThid )
       _GLOBAL_SUM_RL( f_obcsE , myThid )
       _GLOBAL_SUM_RL( f_obcsW , myThid )
       _GLOBAL_SUM_RL( no_obcsN, myThid )
       _GLOBAL_SUM_RL( no_obcsS, myThid )
       _GLOBAL_SUM_RL( no_obcsE, myThid )
       _GLOBAL_SUM_RL( no_obcsW, myThid )
# ifdef OBCS_AGEOS_COST_CONTRIBUTION
       _GLOBAL_SUM_RL( f_ageos , myThid )
       _GLOBAL_SUM_RL( no_ageos, myThid )
# endif

C     start printing to STDOUT
       WRITE(msgBuf,'(A,1PE22.14,1X,1PE9.2)')
     &      ' --> f_obcsN    =', f_obcsN, mult_obcsN
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                     SQUEEZE_RIGHT, myThid )
       WRITE(msgBuf,'(A,1PE22.14,1X,1PE9.2)')
     &      ' --> f_obcsS    =', f_obcsS, mult_obcsS
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                     SQUEEZE_RIGHT, myThid )
       WRITE(msgBuf,'(A,1PE22.14,1X,1PE9.2)')
     &      ' --> f_obcsE    =', f_obcsE, mult_obcsE
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                     SQUEEZE_RIGHT, myThid )
       WRITE(msgBuf,'(A,1PE22.14,1X,1PE9.2)')
     &      ' --> f_obcsW    =', f_obcsW, mult_obcsW
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                     SQUEEZE_RIGHT, myThid )
# ifdef OBCS_AGEOS_COST_CONTRIBUTION
       WRITE(msgBuf,'(A,1PE22.14,1X,1PE9.2)')
     &      ' --> f_ageos    =', f_ageos, mult_ageos
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                     SQUEEZE_RIGHT, myThid )
# endif

C     write contributions to costfunction file

C--   Each process has calculated the global part for itself.
       IF ( ifc .NE. -1 ) THEN
        WRITE(cfname,'(A,I4.4)') 'costfunction_obcs.',optimcycle
        OPEN(unit=ifc,file=cfname)
        WRITE(msgBuf,'(A,A)')
     &       'Writing obcs ctrl cost function info to ', cfname
        CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )

        WRITE(ifc,'(A,1PE22.14,1PE22.14,1X,1PE9.2)')
     &       'f_obcsN =', f_obcsN, no_obcsN, mult_obcsN
        WRITE(ifc,'(A,1PE22.14,1PE22.14,1X,1PE9.2)')
     &       'f_obcsS =', f_obcsS, no_obcsS, mult_obcsS
        WRITE(ifc,'(A,1PE22.14,1PE22.14,1X,1PE9.2)')
     &       'f_obcsE =', f_obcsE, no_obcsE, mult_obcsE
        WRITE(ifc,'(A,1PE22.14,1PE22.14,1X,1PE9.2)')
     &       'f_obcsW =', f_obcsW, no_obcsW, mult_obcsW
# ifdef OBCS_AGEOS_COST_CONTRIBUTION
        WRITE(ifc,'(A,1PE22.14,1PE22.14,1X,1PE9.2)')
     &       'f_ageos =', f_ageos, no_ageos, mult_ageos
# endif
        CLOSE(ifc)
       ENDIF

C     useObcsCostContribution
      ENDIF
#endif /* ALLOW_COST etc */

      RETURN
      END

#include "KPP_OPTIONS.h"
#ifdef ALLOW_SALT_PLUME
#include "SALT_PLUME_OPTIONS.h"
#endif

CBOP
C     !ROUTINE: KPP_DIAGNOSTICS_INIT
C     !INTERFACE:
      SUBROUTINE KPP_DIAGNOSTICS_INIT( myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE KPP_DIAGNOSTICS_INIT
C     | o Routine to initialize list of all available diagnostics
C     |   for KPP package
C     *==========================================================*
C     \ev
C     !USES:
      IMPLICIT NONE

C     === Global variables ===
#include "EEPARAMS.h"
#include "SIZE.h"
#ifdef ALLOW_GENERIC_ADVDIFF
# include "GAD.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
C     myThid ::  my Thread Id number
      INTEGER myThid
CEOP

#ifdef ALLOW_DIAGNOSTICS
C     !LOCAL VARIABLES:
C     === Local variables ===
C     diagNum   :: diagnostics number in the (long) list of available diag.
C     diagMate  :: diag. mate number in the (long) list of available diag.
C     diagName  :: local short name (8c) of a diagnostics
C     diagCode  :: local parser field with characteristics of the diagnostics
C              cf head of S/R DIAGNOSTICS_INIT_EARLY or DIAGNOSTICS_MAIN_INIT
C     diagUnits :: local string (16c): physical units of a diagnostic field
C     diagTitle :: local string (80c): description of field in diagnostic
      INTEGER       diagNum
c     INTEGER       diagMate
      CHARACTER*4   diagSufx
      CHARACTER*8   diagName
      CHARACTER*16  diagCode
      CHARACTER*16  diagUnits
      CHARACTER*(80) diagTitle
#ifdef ALLOW_GENERIC_ADVDIFF
      CHARACTER*4 GAD_DIAG_SUFX
      EXTERNAL    GAD_DIAG_SUFX
#endif

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

        diagName  = 'KPPviscA'
        diagTitle = 'KPP vertical eddy viscosity coefficient'
        diagUnits = 'm^2/s           '
        diagCode  = 'SM P    LR      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

        diagName  = 'KPPdiffS'
        diagTitle = 'Vertical diffusion coefficient for salt & tracers'
        diagUnits = 'm^2/s           '
        diagCode  = 'SM P    LR      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

        diagName  = 'KPPdiffT'
        diagTitle = 'Vertical diffusion coefficient for heat'
        diagUnits = 'm^2/s           '
        diagCode  = 'SM P    LR      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

        diagName  = 'KPPghatK'
        diagTitle = 'ratio of KPP non-local (salt) flux'
     &            //' relative to surface-flux'
        diagUnits = '0-1             '
        diagCode  = 'SM P    LR      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

        diagName  = 'KPPhbl  '
        diagTitle = 'KPP boundary layer depth, bulk Ri criterion'
        diagUnits = 'm               '
        diagCode  = 'SM P     1      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

        diagName  = 'KPPfrac '
        diagTitle = 'Short-wave flux fraction heating the mixing layer'
        diagUnits = '                '
        diagCode  = 'SM P     1      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

        diagName  = 'KPPdbsfc'
        diagTitle = 'Buoyancy difference with respect to surface'
        diagUnits = 'm/s^2           '
        diagCode  = 'SM P    UR      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

        diagName  = 'KPPbfsfc'
        diagTitle = 'Bo+radiation absorbed to d=hbf*hbl + plume'
        diagUnits = 'm^2/s^3         '
        diagCode  = 'SM P    UR      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

        diagName  = 'KPPRi   '
        diagTitle = 'Bulk Richardson number'
        diagUnits = 'non-dimensional '
        diagCode  = 'SM P    UR      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

        diagName  = 'KPPbo   '
        diagTitle = 'Surface turbulent buoyancy forcing'
        diagUnits = 'm^2/s^3         '
        diagCode  = 'SM P     1      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

        diagName  = 'KPPbosol'
        diagTitle = 'surface radiative buoyancy forcing'
        diagUnits = 'm^2/s^3         '
        diagCode  = 'SM P     1      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

        diagName  = 'KPPdbloc'
        diagTitle = 'Local delta buoyancy across interfaces'
        diagUnits = 'm/s^2           '
        diagCode  = 'SM P    UR      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

        diagName  = 'KPPshsq '
        diagTitle = 'Local shear (V(k-1)-V(k))^2'
        diagUnits = 'm^2/s^2         '
        diagCode  = 'SM P    UR      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

        diagName  = 'KPPdVsq '
        diagTitle = 'Shear relative to surface (V(ksrf)-V(k))**2'
        diagUnits = 'm^2/s^2         '
        diagCode  = 'SM P    UR      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

#ifndef EXCLUDE_KPP_DOUBLEDIFF
        diagName  = 'KPPnuddt'
        diagTitle = 'Vertical double diffusion coefficient for heat'
        diagUnits = 'm^2/s           '
        diagCode  = 'SM P    UR      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

        diagName  = 'KPPnudds'
        diagTitle = 'Vertical double diffusion coefficient for salt'
        diagUnits = 'm^2/s           '
        diagCode  = 'SM P    UR      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )
#endif /* ndef EXCLUDE_KPP_DOUBLEDIFF */

        diagSufx  = 'aaaa'
#ifdef ALLOW_GENERIC_ADVDIFF
        diagSufx  = GAD_DIAG_SUFX( GAD_TEMPERATURE, myThid )
#endif
        diagName  = 'KPPg'//diagSufx
        diagTitle = 'KPP non-local Flux of Pot.Temperature'
        diagUnits = 'degC.m^3/s      '
        diagCode  = 'WM      LR      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

#ifdef ALLOW_GENERIC_ADVDIFF
        diagSufx  = GAD_DIAG_SUFX( GAD_SALINITY, myThid )
#endif
        diagName  = 'KPPg'//diagSufx
        diagTitle = 'KPP non-local Flux of Salinity'
        diagUnits = 'g/kg.m^3/s      '
        diagCode  = 'WM      LR      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

#ifdef ALLOW_SALT_PLUME
        diagName  = 'KPPpfrac'
        diagTitle = 'Salt plume flux fraction penetrating mixing layer'
        diagUnits = '                '
        diagCode  = 'SM P     1      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )

        diagName  = 'KPPboplm'
        diagTitle = 'Surface haline buoyancy forcing'
        diagUnits = 'm^2/s^3         '
#ifdef SALT_PLUME_VOLUME
        diagCode  = 'SM P    UR      '
#else /* SALT_PLUME_VOLUME */
        diagCode  = 'SM P     1      '
#endif /* SALT_PLUME_VOLUME */
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I       diagName, diagCode, diagUnits, diagTitle, 0, myThid )
#endif /* ALLOW_SALT_PLUME */

#endif /* ALLOW_DIAGNOSTICS */

      RETURN
      END

#include "PACKAGES_CONFIG.h"
#include "CPP_OPTIONS.h"

CBOP
C     !ROUTINE: INI_NLFS_VARS
C     !INTERFACE:
      SUBROUTINE INI_NLFS_VARS( myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE INI_NLFS_VARS
C     | o Initialise variables for Non-Linear Free-Surface
C     |   formulations (formerly INI_SURF_DR & INI_R_STAR)
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     == Global variables
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "SURFACE.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     myThid :: my Thread Id. number
      INTEGER myThid

C     !LOCAL VARIABLES:
C     Local variables
C     i,j,k,bi,bj  :: loop counter
      INTEGER i, j
      INTEGER bi, bj
#ifdef NONLIN_FRSURF
      INTEGER ks
# ifdef ALLOW_AUTODIFF
      INTEGER k
# endif
      _RL hFacInfMOM, Rmin_tmp
#endif /* NONLIN_FRSURF */
CEOP

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_ENTER('INI_NLFS_VARS',myThid)
#endif

      DO bj=myByLo(myThid), myByHi(myThid)
       DO bi=myBxLo(myThid), myBxHi(myThid)
C-    1rst bi,bj loop :

C-- Initialise arrays:
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
            etaHnm1(i,j,bi,bj) = 0.
            dEtaHdt(i,j,bi,bj) = 0.
            PmEpR  (i,j,bi,bj) = 0.
          ENDDO
         ENDDO

#ifdef NONLIN_FRSURF
C-- Initialise arrays (NLFS using r-coordinate):
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           hFac_surfC(i,j,bi,bj) = 0.
           hFac_surfW(i,j,bi,bj) = 0.
           hFac_surfS(i,j,bi,bj) = 0.
           hFac_surfNm1C(i,j,bi,bj) = 0.
           hFac_surfNm1W(i,j,bi,bj) = 0.
           hFac_surfNm1S(i,j,bi,bj) = 0.
           Rmin_surf(i,j,bi,bj) = Ro_surf(i,j,bi,bj)
          ENDDO
         ENDDO

C-- Initialise arrays (NLFS using r* coordinate):
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
            rStarFacC(i,j,bi,bj) = 1.
            rStarFacW(i,j,bi,bj) = 1.
            rStarFacS(i,j,bi,bj) = 1.
            pStarFacK(i,j,bi,bj) = 1.
            rStarFacNm1C(i,j,bi,bj) = 1.
            rStarFacNm1W(i,j,bi,bj) = 1.
            rStarFacNm1S(i,j,bi,bj) = 1.
            rStarExpC(i,j,bi,bj) = 1.
            rStarExpW(i,j,bi,bj) = 1.
            rStarExpS(i,j,bi,bj) = 1.
            rStarDhCDt(i,j,bi,bj) = 0.
            rStarDhWDt(i,j,bi,bj) = 0.
            rStarDhSDt(i,j,bi,bj) = 0.
          ENDDO
         ENDDO

C-- Initialise arrays (NLFS using hybrid sigma-coordinate):
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
            etaHw  (i,j,bi,bj) = 0.
            etaHs  (i,j,bi,bj) = 0.
            dEtaWdt(i,j,bi,bj) = 0.
            dEtaSdt(i,j,bi,bj) = 0.
          ENDDO
         ENDDO

# ifdef ALLOW_AUTODIFF
C--  to make TAF happy: reset hFac to h0Fac (copied from hFac in ini_linear_phisurf)
         DO k=1,Nr
          DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
            hFacC(i,j,k,bi,bj) = h0FacC(i,j,k,bi,bj)
            hFacW(i,j,k,bi,bj) = h0FacW(i,j,k,bi,bj)
            hFacS(i,j,k,bi,bj) = h0FacS(i,j,k,bi,bj)
           ENDDO
          ENDDO
         ENDDO
         DO k=1,Nr
          DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
#  ifdef USE_MASK_AND_NO_IF
            recip_hFacC(i,j,k,bi,bj) = maskC(i,j,k,bi,bj) /
     &        ( _hFacC(i,j,k,bi,bj) + (oneRS - maskC(i,j,k,bi,bj)) )
            recip_hFacW(i,j,k,bi,bj) = maskW(i,j,k,bi,bj) /
     &        ( _hFacW(i,j,k,bi,bj) + (oneRS - maskW(i,j,k,bi,bj)) )
            recip_hFacS(i,j,k,bi,bj) = maskS(i,j,k,bi,bj) /
     &        ( _hFacS(i,j,k,bi,bj) + (oneRS - maskS(i,j,k,bi,bj)) )
#  else
            IF ( maskC(i,j,k,bi,bj).NE.zeroRS )
     &        recip_hFacC(i,j,k,bi,bj) = oneRS / _hFacC(i,j,k,bi,bj)
            IF ( maskW(i,j,k,bi,bj).NE.zeroRS )
     &        recip_hFacW(i,j,k,bi,bj) = oneRS / _hFacW(i,j,k,bi,bj)
            IF ( maskS(i,j,k,bi,bj).NE.zeroRS )
     &        recip_hFacS(i,j,k,bi,bj) = oneRS / _hFacS(i,j,k,bi,bj)
#  endif
           ENDDO
          ENDDO
         ENDDO
# endif /* ALLOW_AUTODIFF */
#endif /* NONLIN_FRSURF */

C-    end 1rst bi,bj loop.
       ENDDO
      ENDDO

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
#ifdef NONLIN_FRSURF

      hFacInfMOM = hFacInf

      DO bj=myByLo(myThid), myByHi(myThid)
       DO bi=myBxLo(myThid), myBxHi(myThid)

C-- Compute the mimimum value of r_surf (used for computing hFac_surfC)
         DO j=1,sNy
          DO i=1,sNx
           ks = kSurfC(i,j,bi,bj)
           IF (ks.LE.Nr) THEN
             Rmin_tmp = rF(ks+1)
             IF ( ks.EQ.kSurfW(i,j,bi,bj))
     &          Rmin_tmp = MAX(Rmin_tmp, R_low(i-1,j,bi,bj))
             IF ( ks.EQ.kSurfW(i+1,j,bi,bj))
     &          Rmin_tmp = MAX(Rmin_tmp, R_low(i+1,j,bi,bj))
             IF ( ks.EQ.kSurfS(i,j,bi,bj))
     &          Rmin_tmp = MAX(Rmin_tmp, R_low(i,j-1,bi,bj))
             IF ( ks.EQ.kSurfS(i,j+1,bi,bj))
     &          Rmin_tmp = MAX(Rmin_tmp, R_low(i,j+1,bi,bj))

             Rmin_surf(i,j,bi,bj) =
     &        MAX( MAX(rF(ks+1),R_low(i,j,bi,bj)) + hFacInf*drF(ks),
     &                                Rmin_tmp + hFacInfMOM*drF(ks)
     &           )
           ENDIF
          ENDDO
         ENDDO

C-    end bi,bj loop.
       ENDDO
      ENDDO

      CALL EXCH_XY_RL( Rmin_surf, myThid )

#endif /* NONLIN_FRSURF */
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_LEAVE('INI_NLFS_VARS',myThid)
#endif

      RETURN
      END

#include "PACKAGES_CONFIG.h"
#include "CPP_OPTIONS.h"

CBOP
C     !ROUTINE: CALC_OCE_MXLAYER
C     !INTERFACE:
      SUBROUTINE CALC_OCE_MXLAYER(
     I                       rhoSurf, sigmaR,
     I                       bi, bj, myTime, myIter, myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R CALC_OCE_MXLAYER
C     | o Diagnose the Oceanic surface Mixed-Layer
C     | Note: output "hMixLayer" is in "r" unit, i.e., in Pa
C     |       when using P-coordinate.
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "DYNVARS.h"
#ifdef ALLOW_GMREDI
# include "GMREDI.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine Arguments ==
C     rhoSurf   :: Surface density anomaly
C     sigmaR    :: Vertical gradient of potential density
C     bi,bj     :: tile indices
C     myTime    :: Current time in simulation
C     myIter    :: Current iteration number in simulation
C     myThid    :: my Thread Id number
      _RL     rhoSurf(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL     sigmaR (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      INTEGER bi, bj
      _RL     myTime
      INTEGER myIter
      INTEGER myThid

C     === Functions ====
#ifdef ALLOW_DIAGNOSTICS
      LOGICAL  DIAGNOSTICS_IS_ON
      EXTERNAL DIAGNOSTICS_IS_ON
#endif /* ALLOW_DIAGNOSTICS */

C     !LOCAL VARIABLES:
C     == Local variables ==
C     i, j, k   :: Loop counters
C     kSrf      :: surface center-level index
C     kTop      :: surface interface level index
C     kDir      :: downward k increment
C     kU, kL    :: loop ranges, Up and Low
C     kup, klw  :: interface level index above & below current level k
      INTEGER i, j, k
      INTEGER kSrf, kTop, kDir, deltaK
      INTEGER kU, kL, klw, kup
      LOGICAL calcMixLayerDepth, kIn
      INTEGER method
      _RL     rhoBigNb
      _RL     rhoMxL(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL     rhoKm1(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL     rhoLoc(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL     tmpFac, sigmAv
CEOP

      calcMixLayerDepth = .FALSE.
#ifdef ALLOW_GMREDI
      IF ( useGMRedi .AND. .NOT.useKPP ) THEN
       calcMixLayerDepth = GM_useSubMeso .OR. GM_taper_scheme.EQ.'fm07'
     &       .OR. GM_useBatesK3d
      ENDIF
#endif
#ifdef ALLOW_DIAGNOSTICS
      IF ( useDiagnostics.AND. .NOT.calcMixLayerDepth ) THEN
        calcMixLayerDepth = DIAGNOSTICS_IS_ON('MXLDEPTH',myThid)
      ENDIF
#endif
      IF ( calcMixLayerDepth ) THEN

        IF ( usingPCoords ) THEN
         kTop    = Nr+1
         kSrf    = Nr
         kDir    = -1
         deltaK  =  1
        ELSE
         kTop    =  1
         kSrf    =  1
         kDir    =  1
         deltaK  =  0
        ENDIF
C--   Select which "method" to use:
       method = 0
       IF ( hMixCriteria.LT.0. ) method = 1
       IF ( hMixCriteria.GT.1. ) method = 2

       IF ( method.EQ.1 ) THEN

C--   First method :
C     where the potential density (ref.lev=surface) is larger than
C       surface density plus Delta_Rho = hMixCriteria * Alpha(surf)
C     = density of water which is -hMixCriteria colder than surface water
C     (see Kara, Rochford, and Hurlburt JGR 2000 for default criterion)

c       hMixCriteria  = -0.8 _d 0
c       dRhoSmall = 1. _d -6
        rhoBigNb  = rhoConst*1. _d 10
        CALL FIND_ALPHA(
     I            bi, bj, 1-OLx, sNx+OLx, 1-OLy, sNy+OLy, kSrf, kSrf,
     O            rhoMxL, myThid )

        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
           rhoKm1(i,j) = rhoSurf(i,j)
           rhoMxL(i,j) = rhoSurf(i,j)
     &                 + MAX( rhoMxL(i,j)*hMixCriteria, dRhoSmall )
           hMixLayer(i,j,bi,bj) = Ro_surf(i,j,bi,bj) - R_low(i,j,bi,bj)
         ENDDO
        ENDDO
C-    Z-coord: (kU,kL,kDir) = (2,Nr,1) ; P-coord: (kU,kL,kDir)= (Nr-1,1,-1)
        kU = 2 + deltaK*(Nr-3)
        kL = Nr - deltaK*(Nr-1)
        DO k = kU,kL,kDir
C-    potential density (reference level = surface level)
         CALL FIND_RHO_2D(
     I        1-OLx, sNx+OLx, 1-OLy, sNy+OLy, kSrf,
     I        theta(1-OLx,1-OLy,k,bi,bj), salt(1-OLx,1-OLy,k,bi,bj),
     O        rhoLoc,
     I        k, bi, bj, myThid )

         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
c          kIn = k.LT.klowC(i,j,bi,bj).AND.k.GE.kSurfC(i,j,bi,bj)
           kIn = k.LE.klowC(i,j,bi,bj).AND.k.GE.kSurfC(i,j,bi,bj)
           IF ( kIn .AND. rhoLoc(i,j).GE.rhoMxL(i,j) ) THEN
             IF ( rhoLoc(i,j).GT.rhoKm1(i,j) ) THEN
              tmpFac = ( rhoMxL(i,j) - rhoKm1(i,j) )
     &               / ( rhoLoc(i,j) - rhoKm1(i,j) )
             ELSE
              tmpFac = 0.
             ENDIF
C-    Note: sign is more related to kDir than it is to gravity orientation
c            hMixLayer(i,j,bi,bj) = ( rF(kTop)-rC(k-kDir) )*kDir
             hMixLayer(i,j,bi,bj) = -gravitySign*( rF(kTop)-rC(k-kDir) )
     &                            + tmpFac*drC(k+deltaK)
             rhoMxL(i,j) = rhoBigNb
           ELSE
             rhoKm1(i,j) = rhoLoc(i,j)
           ENDIF
          ENDDO
         ENDDO
        ENDDO

       ELSEIF ( method.EQ.2 ) THEN

C--   Second method :
C     where the local stratification exceed the mean stratification above
C     (from surface down to here) by factor hMixCriteria

c       hMixCriteria  = 1.5 _d 0
c       dRhoSmall = 1. _d -2
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          IF ( klowC(i,j,bi,bj) .GT. 0 ) THEN
           hMixLayer(i,j,bi,bj) = drF(kSrf)
           rhoMxL(i,j) = 1.
          ELSE
           hMixLayer(i,j,bi,bj) = rF(kTop)
           rhoMxL(i,j) = -1.
          ENDIF
         ENDDO
        ENDDO
C-    Z-coord: (kU,kL,kDir) = (2,Nr-1,1) ; P-coord: (kU,kL,kDir)= (Nr-1,2,-1)
        kU = 2 + deltaK*(Nr-3)
        kL = Nr-1 - deltaK*(Nr-3)
        DO k = kU,kL,kDir
C-    potential density (reference level = surface level)
         CALL FIND_RHO_2D(
     I        1-OLx, sNx+OLx, 1-OLy, sNy+OLy, kSrf,
     I        theta(1-OLx,1-OLy,k,bi,bj), salt(1-OLx,1-OLy,k,bi,bj),
     O        rhoLoc,
     I        k, bi, bj, myThid )

         kup = k+deltaK
         klw = kup+kDir
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           kIn = k.LT.klowC(i,j,bi,bj).AND.k.GT.kSurfC(i,j,bi,bj)
           IF ( kIn .AND. rhoMxL(i,j).GE.0. ) THEN
             sigmAv = ( rhoLoc(i,j)-rhoSurf(i,j)+dRhoSmall )
     &              / ( rC(k)-rC(kSrf) ) * gravitySign
             IF ( gravitySign * sigmaR(i,j,klw)
     &            .GT.sigmAv*hMixCriteria ) THEN
               tmpFac = 0. _d 0
               IF ( sigmAv.GT.0. _d 0 ) THEN
                 tmpFac = hMixCriteria*sigmaR(i,j,kup)/sigmaR(i,j,klw)
                 IF ( tmpFac .GT. 1. _d 0 ) THEN
                   tmpFac = 1. _d 0
     &             + ( tmpFac - 1. _d 0 )/( hMixCriteria - 1. _d 0 )
                 ENDIF
                 tmpFac = MAX( 0. _d 0, MIN( tmpFac, 2. _d 0 ) )
               ENDIF
C-    Note: sign is more related to kDir than it is to gravity orientation
               hMixLayer(i,j,bi,bj) = -gravitySign *
     &                               ( rF(kTop)-rF(klw) )
     &                               - drF(k)*tmpFac*0.5 _d 0
               rhoMxL(i,j) = -1.
             ENDIF
           ENDIF
          ENDDO
         ENDDO
        ENDDO

       ELSE
        STOP 'S/R CALC_OCE_MXLAYER: invalid method'
       ENDIF

       IF ( hMixSmooth .GT. 0. _d 0 ) THEN
        tmpFac = (1. _d 0 - hMixSmooth ) / 4. _d 0
        DO j=1-OLy+1,sNy+OLy-1
         DO i=1-OLx+1,sNx+OLx-1
            rhoLoc(i,j)=(hMixSmooth *   hMixLayer(i,j,bi,bj)   +
     &                       tmpFac * ( hMixLayer(i-1,j,bi,bj) +
     &                                  hMixLayer(i+1,j,bi,bj) +
     &                                  hMixLayer(i,j-1,bi,bj) +
     &                                  hMixLayer(i,j+1,bi,bj) )
     &                  )
     &                 /(hMixSmooth +
     &                       tmpFac * ( maskC(i-1,j,kSrf,bi,bj) +
     &                                  maskC(i+1,j,kSrf,bi,bj) +
     &                                  maskC(i,j-1,kSrf,bi,bj) +
     &                                  maskC(i,j+1,kSrf,bi,bj) )
     &                  ) * maskC(i,j,kSrf,bi,bj)
         ENDDO
        ENDDO
        DO j=1-OLy+1,sNy+OLy-1
         DO i=1-OLx+1,sNx+OLx-1
            hMixLayer(i,j,bi,bj) = rhoLoc(i,j)
         ENDDO
        ENDDO
       ENDIF

#ifdef ALLOW_DIAGNOSTICS
       IF ( useDiagnostics ) THEN
        CALL DIAGNOSTICS_FILL( hMixLayer, 'MXLDEPTH',
     &                         0, 1, 1, bi, bj, myThid )
       ENDIF
#endif /* ALLOW_DIAGNOSTICS */

C--   end if calcMixLayerDepth
      ENDIF

      RETURN
      END

#include "LONGSTEP_OPTIONS.h"

CBOP
C     !ROUTINE: LONGSTEP_INIT_VARIA
C     !INTERFACE:
      SUBROUTINE LONGSTEP_INIT_VARIA( myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE LONGSTEP_INIT_VARIA
C     | o Initialize LONGSTEP data structures
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     == Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "DYNVARS.h"
#include "LONGSTEP.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     myThid     :: my Thread Id number
      INTEGER myThid

#ifdef ALLOW_LONGSTEP
C     !LOCAL VARIABLES:
C     == Local variables ==
CEOP

C     Initialise LS_doTimeStep
      _BARRIER
      _BEGIN_MASTER(myThid)
      LS_doTimeStep = .FALSE.
      _END_MASTER(myThid)
      _BARRIER

C     initialize longstep averages to zero

      CALL LONGSTEP_RESET_3D(LS_uVelCount, LS_uVel, Nr, myThid)
      CALL LONGSTEP_RESET_3D(LS_vVelCount, LS_vVel, Nr, myThid)
      CALL LONGSTEP_RESET_3D(LS_wVelCount, LS_wVel, Nr, myThid)
      CALL LONGSTEP_RESET_3D(LS_thetaCount,LS_theta,Nr, myThid)
      CALL LONGSTEP_RESET_3D(LS_saltCount, LS_salt, Nr, myThid)
      IF ( ivdc_kappa .NE. 0. _d 0 )
     & CALL LONGSTEP_RESET_3D(LS_IVDConvCountCount,
     &                       LS_IVDConvCount, Nr, myThid)
#ifdef SHORTWAVE_HEATING
      CALL LONGSTEP_RESET_3D(LS_QswCount, LS_Qsw, 1, myThid)
#endif
      CALL LONGSTEP_RESET_3D(LS_fwFluxCount,LS_fwFlux,1,myThid)
#ifdef ALLOW_GMREDI
      IF ( useGMRedi ) THEN
       CALL LONGSTEP_RESET_3D(LS_KwxCount, LS_Kwx, Nr, myThid)
       CALL LONGSTEP_RESET_3D(LS_KwyCount, LS_Kwy, Nr, myThid)
       CALL LONGSTEP_RESET_3D(LS_KwzCount, LS_Kwz, Nr, myThid)
       CALL LONGSTEP_RESET_3D(LS_KuxCount, LS_Kux, Nr, myThid)
       CALL LONGSTEP_RESET_3D(LS_KvyCount, LS_Kvy, Nr, myThid)
       CALL LONGSTEP_RESET_3D(LS_KuzCount, LS_Kuz, Nr, myThid)
       CALL LONGSTEP_RESET_3D(LS_KvzCount, LS_Kvz, Nr, myThid)
       CALL LONGSTEP_RESET_3D(LS_PsiXCount, LS_PsiX, Nr, myThid)
       CALL LONGSTEP_RESET_3D(LS_PsiYCount, LS_PsiY, Nr, myThid)
      ENDIF
#endif
#ifdef ALLOW_KPP
      IF ( useKPP ) THEN
       CALL LONGSTEP_RESET_3D(LS_KPPdiffKzSCount,
     &                        LS_KPPdiffKzS, Nr, myThid)
       CALL LONGSTEP_RESET_3D(LS_KPPghatCount,
     &                        LS_KPPghat, Nr, myThid)
      ENDIF
#endif

#endif /* ALLOW_LONGSTEP */

      RETURN
      END

#include "CPP_OPTIONS.h"

CBOP
C     !ROUTINE: RESET_NLFS_VARS
C     !INTERFACE:
      SUBROUTINE RESET_NLFS_VARS( myTime, myIter, myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE RESET_NLFS_VARS
C     | o Re-set some Non-Linear Free-Surface variables
C     |   in order to facilitate the AD tool task of solving
C     |   dependency rules.
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     == Global variables
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "SURFACE.h"

C     !INPUT/OUTPUT PARAMETERS:
C     myTime    :: Current time in simulation
C     myIter    :: Current iteration number in simulation
C     myThid    :: my Thread Id number
      _RL myTime
      INTEGER myIter
      INTEGER myThid

C     !LOCAL VARIABLES:
#ifdef NONLIN_FRSURF
#ifndef DISABLE_RSTAR_CODE
C     i, j,     :: loop counter
C     bi, bj    :: tile indices
      INTEGER i, j, bi, bj
CEOP

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      DO bj=myByLo(myThid), myByHi(myThid)
       DO bi=myBxLo(myThid), myBxHi(myThid)

        IF ( fluidIsAir .AND. select_rStar.GE.1 ) THEN
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           pStarFacK(i,j,bi,bj) = rStarFacC(i,j,bi,bj)**atm_kappa
          ENDDO
         ENDDO
        ELSE
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           pStarFacK(i,j,bi,bj) = 1. _d 0
          ENDDO
         ENDDO
        ENDIF

C- end bi,bj loop
       ENDDO
      ENDDO

#endif /* DISABLE_RSTAR_CODE */
#endif /* NONLIN_FRSURF */

      RETURN
      END

#include "PACKAGES_CONFIG.h"
#include "CPP_OPTIONS.h"
#ifdef ALLOW_EXCH2
# include "W2_OPTIONS.h"
#endif /* ALLOW_EXCH2 */

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C !ROUTINE: INI_PARMS
C !INTERFACE:
      SUBROUTINE INI_PARMS( myThid )

C !DESCRIPTION:
C     Routine to load model "parameters" from parameter file "data"

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#ifdef ALLOW_EXCH2
# include "W2_EXCH2_SIZE.h"
# include "W2_EXCH2_TOPOLOGY.h"
#endif /* ALLOW_EXCH2 */
#include "EOS.h"
C- need GRID.h to save, in rF(1), half retired param Ro_SeaLevel value:
#include "GRID.h"
#include "SET_GRID.h"

C !INPUT/OUTPUT PARAMETERS:
C   myThid :: Number of this instance of INI_PARMS
      INTEGER myThid

C !LOCAL VARIABLES:
C   dxSpacing, dySpacing :: Default spacing in X and Y.
C                        :: Units are that of coordinate system
C                        :: i.e. cartesian => metres ; s. polar => degrees
C   deltaTtracer  :: Timestep for tracer equations ( s )
C   forcing_In_AB :: flag to put all forcings (Temp,Salt,Tracers,Momentum)
C                 :: contribution in (or out of) Adams-Bashforth time stepping.
C   goptCount  :: Used to count the nuber of grid options (only one is allowed!)
C   msgBuf     :: Informational/error message buffer
C   errIO      :: IO error flag
C   errCount   :: error counter (inconsitent params and other errors)
C   iUnit      :: Work variable for IO unit number
C   k, i, j    :: Loop counters
C   xxxDefault :: Default value for variable xxx
      _RL  dxSpacing
      _RL  dySpacing
      _RL deltaTtracer
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      LOGICAL forcing_In_AB
      INTEGER goptCount
      INTEGER gridNx, gridNy
      INTEGER k, i, j, iUnit
      INTEGER errIO, errCount
C   Default values for variables which have vertical coordinate system
C   dependency.
      _RL viscArDefault
      _RL diffKrTDefault
      _RL diffKrSDefault
      _RL hFacMinDrDefault
      _RL delRDefault(Nr)
C-- Variables used to select between different coordinate systems:
C   zCoordInputData :: The vertical coordinate system in the rest of the  model
C   pCoordInputData :: is written in terms of r. In the model "data" file,
C   rCoordInputData :: input params can be in terms of z, p or r.
C   coordsSet       :: e.g. delZ or delP or delR for the vertical grid spacing.
C                   :: The following rules apply:
C                   :: All parameters must use the same vertical coordinate
C                   :: system.  e.g. delZ and viscAz is legal
C                   ::           but delZ and viscAr is an error.
C                   :: Similarly specifying delZ and delP is an error.
C                   :: zCoord..., pCoord..., rCoord... are used to flag when
C                   :: z, p or r are used.
C                   :: coordsSet counts how many vertical coordinates have been
C                   :: used to specify variables. coordsSet > 1 is an error.
C   vertSetCount    :: to count number of vertical array elements which are set.
C   specifiedDiffKrT :: internal flag, true if any diffK[r,z,p,Nr]T is specified
C   specifiedDiffKrS :: internal flag, true if any diffK[r,z,p,Nr]S is specified

      LOGICAL zCoordInputData
      LOGICAL pCoordInputData
      LOGICAL rCoordInputData
      INTEGER coordsSet
      INTEGER vertSetCount
      LOGICAL specifiedDiffKrT, specifiedDiffKrS

C-- Variables which have vertical coordinate system dependency.
C   delZ    :: Vertical grid spacing ( m  ).
C   delP    :: Vertical grid spacing ( Pa ).
C   viscAz  :: Eddy viscosity coeff. for mixing of momentum vertically (m^2/s)
C   viscAp  :: Eddy viscosity coeff. for mixing of momentum vertically (Pa^2/s)
C   diffKzT :: Laplacian diffusion coeff. for mixing of heat vertically (m^2/s)
C   diffKpT :: Laplacian diffusion coeff. for mixing of heat vertically (Pa^2/s)
C   diffKzS :: Laplacian diffusion coeff. for mixing of salt vertically (m^2/s)
C   diffKpS :: Laplacian diffusion coeff. for mixing of salt vertically (Pa^2/s)
      _RL delZ(Nr)
      _RL delP(Nr)
      _RL viscAz
      _RL viscAp
      _RL viscAr
      _RL diffKzT
      _RL diffKpT
      _RL diffKrT
      _RL diffKzS
      _RL diffKpS
      _RL diffKrS

C-- Retired main data file parameters. Kept here to trap use of old data files.
C   nRetired :: Counter used to trap gracefully namelists containing "retired"
C            :: parameters. These are parameters that are either no-longer used
C            :: or that have moved to a different input file and/or namelist.
C Namelist PARM01:
C   useConstantF  :: Coriolis coeff set to f0     (replaced by selectCoriMap=0)
C   useBetaPlaneF :: Coriolis coeff = f0 + beta.y (replaced by selectCoriMap=1)
C   useSphereF    :: Coriolis = 2.omega.sin(phi)  (replaced by selectCoriMap=2)
C   useJamartWetPoints :: for backward compat. (replaced by selectCoriScheme=1)
C                      :: Use wet-point method for Coriolis (Jamart & Ozer 1986)
C   SadournyCoriolis :: for backward compat. (replaced by selectVortScheme=2)
C   use3dCoriolis :: for backward compat. (=F,T same as select3dCoriScheme=0,1)
C   metricTerms   :: for backward compat. (=F,T same as selectMetricTerms=0,1)
C   tracerAdvScheme :: tracer advection scheme (old passive tracer code)
C   trac_EvPrRn :: tracer conc. in Rain & Evap (old passive tracer code)
C   saltDiffusion :: diffusion of salinity    on/off (flag not used)
C   tempDiffusion :: diffusion of temperature on/off (flag not used)
C   zonal_filt_lat :: Moved to package "zonal_filt"
C   gravitySign  :: direction of gravity relative to R direction
C                :: (removed from namelist and set according to z/p coordinate)
C   viscAstrain  :: replaced by standard viscosity coeff & useStrainTensionVisc
C   viscAtension :: replaced by standard viscosity coeff & useStrainTensionVisc
C   useAnisotropicViscAgridMax :: Changed to be default behavior.  Can
C                   use old method by setting useAreaViscLength=.true.
C   usePickupBeforeC35 :: to restart from old-pickup files (generated with code
C                 from before checkpoint-35, Feb 08, 2001): disabled (Jan 2007)
C   debugMode    :: to print debug msg. now read from parameter file eedata
C   allowInteriorFreezing :: Allow water at depth to freeze
C                            and rise to the surface (replaced by pkg/frazil)
C   useOldFreezing :: use the old version (before checkpoint52a_pre, 2003-11-12)
C   balanceEmPmR   :: for backward compat. (replaced by selectBalanceEmPmR=1),
C                  :: substract global mean of EmPmR at every time step
C   writeStatePrec :: Precision used for writing model state (not used)
C Namelist PARM02:
C   cg2dChkResFreq :: Frequency with which to check 2-D con. grad solver
C                       residual (was never coded)
C   cg3dChkResFreq :: Frequency with which to check 3-D con. grad solver
C                       residual (was never coded)
C Namelist PARM03:
C   tauThetaClimRelax3Dim :: replaced by pkg/rbcs (3.D Relaxation B.Cs)
C   tauSaltClimRelax3Dim  :: replaced by pkg/rbcs (3.D Relaxation B.Cs)
C   taveFreq       :: Frequency output for time-averaged state vars ;
C                     disabled as pkg/timeave has been removed
C   tave_lastIter  :: last (within taveFreq period) time-step fraction in time-
C                     averaded output ; disabled as pkg/timeave has been removed
C   calendarDumps  :: moved to package "cal" (calendar)
C Namelist PARM04:
C   Ro_SeaLevel :: origin of the vertical R-coords axis ;
C               :: replaced by top_Pres or seaLev_Z setting
C   groundAtK1 :: put the surface(k=1) at the ground (replaced by usingPCoords)
C   rkFac      :: removed from namelist ; replaced by -rkSign
C   thetaMin   :: unfortunate variable name ; replaced by xgOrigin
C   phiMin     :: unfortunate variable name ; replaced by ygOrigin
C Namelist PARM05:
C   shelfIceFile :: File containing the topography of the shelfice draught
C                   (replaced by SHELFICEtopoFile in SHELFICE.h)
C   dQdTfile     :: File containing thermal relaxation coefficient
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      INTEGER nRetired
      LOGICAL useConstantF, useBetaPlaneF, useSphereF
      LOGICAL useJamartWetPoints, useEnergyConservingCoriolis
      LOGICAL SadournyCoriolis
      LOGICAL use3dCoriolis, metricTerms
      LOGICAL tempDiffusion, saltDiffusion
      INTEGER tracerAdvScheme
      _RL trac_EvPrRn
      _RL zonal_filt_lat
c     _RL gravitySign
      _RL viscAstrain, viscAtension
      LOGICAL useAnisotropicViscAgridMax
      LOGICAL usePickupBeforeC35
      LOGICAL saveDebugMode
      LOGICAL allowInteriorFreezing, useOldFreezing
      LOGICAL balanceEmPmR
      INTEGER writeStatePrec
C-
      INTEGER cg2dChkResFreq, cg3dChkResFreq
C-
      _RL tauThetaClimRelax3Dim, tauSaltClimRelax3Dim
      _RL taveFreq, tave_lastIter
      LOGICAL calendarDumps
C-
      LOGICAL groundAtK1
      _RL Ro_SeaLevel
      _RL rkFac
      _RL thetaMin, phiMin
C-
      CHARACTER*(MAX_LEN_FNAM) shelfIceFile
      CHARACTER*(MAX_LEN_FNAM) dQdTfile

C--   Continuous equation parameters
      NAMELIST /PARM01/
     & gravitySign, nh_Am2,
     & gravity, gBaro, gravityFile, rhonil, tAlpha, sBeta,
     & selectCoriMap, f0, beta, fPrime, omega, rotationPeriod,
     & viscAh, viscAhW, viscAhMax,
     & viscAhGrid, viscAhGridMax, viscAhGridMin,
     & viscC2leith, viscC4leith, smag3D_coeff, useSmag3D,
     & useFullLeith, useAnisotropicViscAgridMax, useStrainTensionVisc,
     & useAreaViscLength, viscC2leithD, viscC4leithD, viscC2LeithQG,
     & viscC2smag, viscC4smag, viscAhD, viscAhZ, viscA4D, viscA4Z,
     & viscA4, viscA4W,
     & viscA4Max, viscA4Grid, viscA4GridMax, viscA4GridMin,
     & viscA4ReMax, viscAhReMax,
     & cosPower, viscAstrain, viscAtension,
     & viscAz, diffKzT, diffKzS, viscAp, diffKpT, diffKpS,
     & viscAr, diffKrT, diffKrS, viscArNr, diffKrNrT, diffKrNrS,
     & diffKhT, diffK4T, diffKhS, diffK4S, smag3D_diffCoeff,
     & diffKr4T, diffKr4S, BL79LatVary,
     & diffKrBL79surf, diffKrBL79deep, diffKrBL79scl, diffKrBL79Ho,
     & diffKrBLEQsurf, diffKrBLEQdeep, diffKrBLEQscl, diffKrBLEQHo,
     & surf_pRef, tRef, sRef, tRefFile, sRefFile, rhoRefFile,
     & eosType, selectP_inEOS_Zc, integr_GeoPot, selectFindRoSurf,
     & HeatCapacity_Cp, celsius2K, atm_Cp, atm_Rd, atm_Rq, atm_Po,
     & no_slip_sides, sideDragFactor, no_slip_bottom, bottomVisc_pCell,
     & bottomDragLinear, bottomDragQuadratic,  zRoughBot,
     & selectBotDragQuadr,
     & momPressureForcing, momForcing, momTidalForcing,
     & momViscosity, momAdvection, vectorInvariantMomentum,
     & useConstantF, useBetaPlaneF, useSphereF, useCoriolis,
     & use3dCoriolis, select3dCoriScheme, selectCoriScheme,
     & useCDscheme, useJamartWetPoints, useEnergyConservingCoriolis,
     & useAbsVorticity, selectVortScheme, SadournyCoriolis,
     & useJamartMomAdv, upwindVorticity, highOrderVorticity,
     & upwindShear, selectKEscheme,
     & selectMetricTerms, metricTerms, useNHMTerms, addFrictionHeating,
     & tempDiffusion, tempAdvection, tempForcing, temp_stayPositive,
     & saltDiffusion, saltAdvection, saltForcing, salt_stayPositive,
     & implicSurfPress, implicDiv2DFlow, implicitNHPress,
     & implicitFreeSurface, rigidLid, freeSurfFac,
     & hFacMin, hFacMinDz, hFacMinDp, hFacMinDr,
     & exactConserv, linFSConserveTr, uniformLin_PhiSurf,
     & nonlinFreeSurf, hFacInf, hFacSup, select_rStar,
     & nonHydrostatic, selectNHfreeSurf, quasiHydrostatic,
     & implicitIntGravWave, staggerTimeStep, doResetHFactors,
     & tempStepping, saltStepping, momStepping,
     & implicitDiffusion, implicitViscosity, selectImplicitDrag,
     & tempImplVertAdv, saltImplVertAdv, momImplVertAdv,
     & rhoConst, thetaConst, rhoConstFresh, buoyancyRelation,
     & allowFreezing, allowInteriorFreezing, useOldFreezing, ivdc_kappa,
     & hMixCriteria, dRhoSmall, hMixSmooth,
     & tempAdvScheme, tempVertAdvScheme, tracerAdvScheme,
     & saltAdvScheme, saltVertAdvScheme, multiDimAdvection,
     & selectAddFluid, useRealFreshWaterFlux, convertFW2Salt,
     & temp_EvPrRn, salt_EvPrRn, trac_EvPrRn,
     & temp_addMass, salt_addMass, zonal_filt_lat,
     & smoothAbsFuncRange, sIceLoadFac, selectPenetratingSW,
     & selectBalanceEmPmR, balanceEmPmR, balanceQnet, balancePrintMean,
     & balanceThetaClimRelax, balanceSaltClimRelax,
     & readBinaryPrec, writeBinaryPrec, writeStatePrec, globalFiles,
     & useSingleCpuIO, useSingleCpuInput, usePickupBeforeC54,
     & usePickupBeforeC35, debugMode, debugLevel, plotLevel

C--   Elliptic solver parameters
      NAMELIST /PARM02/
     & cg2dMaxIters, cg2dMinItersNSA, cg2dChkResFreq, cg2dUseMinResSol,
     & cg2dTargetResidual, cg2dTargetResWunit,
     & cg2dpcOffDFac, cg2dPreCondFreq,
     & cg3dMaxIters, cg3dChkResFreq,
     & cg3dTargetResidual, cg3dTargetResWunit,
     & useNSACGSolver, useSRCGSolver, printResidualFreq

C--   Time stepping parammeters
      NAMELIST /PARM03/
     & nIter0, nTimeSteps, nTimeSteps_l2, nEndIter,
     & baseTime, startTime, endTime,
     & deltaT, deltaTClock, deltaTMom,
     & deltaTtracer, dTtracerLev, deltaTFreeSurf,
     & forcing_In_AB, momForcingOutAB, tracForcingOutAB,
     & momDissip_In_AB, doAB_onGtGs,
     & abEps, alph_AB, beta_AB, startFromPickupAB2, applyExchUV_early,
     & tauCD, rCD, epsAB_CD, cAdjFreq,
     & chkPtFreq, pChkPtFreq, pickupSuff, pickupStrictlyMatch,
     & writePickupAtEnd,
     & dumpFreq, dumpInitAndLast, adjDumpFreq, taveFreq, tave_lastIter,
     & diagFreq, monitorFreq, adjMonitorFreq, monitorSelect,
     & outputTypesInclusive, rwSuffixType,
     & tauThetaClimRelax, tauSaltClimRelax, latBandClimRelax,
     & tauThetaClimRelax3Dim, tauSaltClimRelax3Dim,
     & periodicExternalForcing, externForcingPeriod, externForcingCycle,
     & calendarDumps

C--   Gridding parameters
      NAMELIST /PARM04/
     & usingCartesianGrid, usingCylindricalGrid,
     & usingSphericalPolarGrid, usingCurvilinearGrid,
     & xgOrigin, ygOrigin, dxSpacing, dySpacing,
     & delX, delY, delXFile, delYFile, horizGridFile,
     & phiEuler, thetaEuler, psiEuler,
     & rSphere, radius_fromHorizGrid, deepAtmosphere, seaLev_Z,
     & top_Pres, delZ, delP, delR, delRc, delRFile, delRcFile,
     & useMin4hFacEdges, interViscAr_pCell, interDiffKr_pCell,
     & pCellMix_select, pCellMix_maxFac, pCellMix_delR,
     & pCellMix_viscAr, pCellMix_diffKr,
     & selectSigmaCoord, rSigmaBnd, hybSigmFile,
     & Ro_SeaLevel, rkFac, groundAtK1, thetaMin, phiMin

C--   Input files
      NAMELIST /PARM05/
     & bathyFile, topoFile, addWwallFile, addSwallFile, shelfIceFile,
     & diffKrFile, viscAhDfile, viscAhZfile, viscA4Dfile, viscA4Zfile,
     & hydrogThetaFile, hydrogSaltFile,
     & maskIniTemp, maskIniSalt, checkIniTemp, checkIniSalt,
     & zonalWindFile, meridWindFile,
     & thetaClimFile, saltClimFile,
     & surfQfile, surfQnetFile, surfQswFile, EmPmRfile, saltFluxFile,
     & uVelInitFile, vVelInitFile, pSurfInitFile,
     & dQdTFile, ploadFile, geoPotAnomFile, addMassFile,
     & tCylIn, tCylOut,
     & eddyPsiXFile, eddyPsiYFile, geothermalFile,
     & lambdaThetaFile, lambdaSaltFile, wghtBalanceFile,
     & mdsioLocalDir, adTapeDir,
     & the_run_name
CEOP

#ifdef ALLOW_EXCH2
      gridNx = exch2_mydNx(1)
      gridNy = exch2_mydNy(1)
#else /* ALLOW_EXCH2 */
      gridNx = Nx
      gridNy = Ny
#endif /* ALLOW_EXCH2 */

      _BEGIN_MASTER(myThid)

C     Defaults values for input parameters
      CALL SET_DEFAULTS(
     O   viscArDefault, diffKrTDefault, diffKrSDefault,
     O   hFacMinDrDefault, delRDefault,
     I   myThid )

      useJamartWetPoints = .FALSE.
      useEnergyConservingCoriolis = .FALSE.
      SadournyCoriolis = .FALSE.
      use3dCoriolis   = .TRUE.
      metricTerms     = .TRUE.
      balanceEmPmR    = .FALSE.

C--   Initialise "which vertical coordinate system used" flags.
      zCoordInputData = .FALSE.
      pCoordInputData = .FALSE.
      rCoordInputData = .FALSE.
      coordsSet       = 0

C--   Initialise retired parameters to unlikely value
      nRetired = 0
      useConstantF    = .FALSE.
      useBetaPlaneF   = .FALSE.
      useSphereF      = .TRUE.
      tempDiffusion   = .TRUE.
      saltDiffusion   = .TRUE.
      tracerAdvScheme = UNSET_I
      trac_EvPrRn     = UNSET_RL
      zonal_filt_lat  = UNSET_RL
      gravitySign     = UNSET_RL
      viscAstrain     = UNSET_RL
      viscAtension    = UNSET_RL
      useAnisotropicViscAgridMax=.TRUE.
      usePickupBeforeC35    = .FALSE.
      saveDebugMode   = debugMode
      allowInteriorFreezing = .FALSE.
      useOldFreezing  = .FALSE.
      writeStatePrec  = UNSET_I
      cg2dChkResFreq  = UNSET_I
      cg3dChkResFreq  = UNSET_I
      tauThetaClimRelax3Dim = UNSET_RL
      tauSaltClimRelax3Dim  = UNSET_RL
      taveFreq        = UNSET_RL
      tave_lastIter   = UNSET_RL
      calendarDumps   = .FALSE.
      Ro_SeaLevel     = UNSET_RL
      rkFac           = UNSET_RL
      groundAtK1      = .FALSE.
      thetaMin        = UNSET_RL
      phiMin          = UNSET_RL
      shelfIceFile    = ' '
      dQdTFile        = ' '

C--   Open the parameter file
      WRITE(msgBuf,'(A)')
     &     ' INI_PARMS: opening model parameter file "data"'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )

      CALL OPEN_COPY_DATA_FILE( 'data', 'INI_PARMS',
     O                          iUnit, myThid )

C--   Read settings from iUnit (= a copy of model parameter file "data").
      errIO = 0
      errCount = 0

C--   Set default "physical" parameters
      viscAhW  = UNSET_RL
      viscA4W  = UNSET_RL
      viscAhD  = UNSET_RL
      viscAhZ  = UNSET_RL
      viscA4D  = UNSET_RL
      viscA4Z  = UNSET_RL
      viscAz   = UNSET_RL
      viscAp   = UNSET_RL
      viscAr   = UNSET_RL
      diffKzT  = UNSET_RL
      diffKpT  = UNSET_RL
      diffKrT  = UNSET_RL
      diffKzS  = UNSET_RL
      diffKpS  = UNSET_RL
      diffKrS  = UNSET_RL
      hFacMinDr         = UNSET_RL
      hFacMinDz         = UNSET_RL
      hFacMinDp         = UNSET_RL
      tAlpha            = UNSET_RL
      sBeta             = UNSET_RL
      implicitNHPress   = UNSET_RL
      tempVertAdvScheme = 0
      saltVertAdvScheme = 0
      plotLevel         = UNSET_I
C--   z,p,r coord input switching.
      WRITE(msgBuf,'(A)') ' INI_PARMS ; starts to read PARM01'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      READ(UNIT=iUnit,NML=PARM01) !,IOSTAT=errIO)
      IF ( errIO .LT. 0 ) THEN
       WRITE(msgBuf,'(A)')
     &  'S/R INI_PARMS: Error reading model parameter file "data"'
       CALL PRINT_ERROR( msgBuf, myThid )
       WRITE(msgBuf,'(A)') 'S/R INI_PARMS: Problem in namelist PARM01'
       CALL PRINT_ERROR( msgBuf, myThid )
       STOP 'ABNORMAL END: S/R INI_PARMS'
      ELSE
       WRITE(msgBuf,'(A)') ' INI_PARMS ; read PARM01 : OK'
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                     SQUEEZE_RIGHT, myThid )
      ENDIF

C-    set the type of vertical coordinate and type of fluid
C     according to buoyancyRelation
      usingPCoords    = .FALSE.
      usingZCoords    = .FALSE.
      fluidIsAir      = .FALSE.
      fluidIsWater    = .FALSE.
      IF ( buoyancyRelation.EQ.'ATMOSPHERIC' ) THEN
        usingPCoords = .TRUE.
        fluidIsAir   = .TRUE.
      ELSEIF ( buoyancyRelation.EQ.'OCEANICP') THEN
        usingPCoords  = .TRUE.
        fluidIsWater  = .TRUE.
      ELSEIF ( buoyancyRelation.EQ.'OCEANIC' ) THEN
        usingZCoords  = .TRUE.
        fluidIsWater  = .TRUE.
      ELSE
        WRITE(msgBuf,'(2A)') 'S/R INI_PARMS:',
     &      ' Bad value of buoyancyRelation '
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF

      IF ( .NOT.rigidLid .AND.
     &     .NOT.implicitFreeSurface ) THEN
C-     No barotropic solver selected => use implicitFreeSurface as default
       WRITE(msgBuf,'(A)')
     &  'S/R INI_PARMS: No request for barotropic solver'
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                     SQUEEZE_RIGHT, myThid )
       WRITE(msgBuf,'(A)')
     &  'S/R INI_PARMS: => Use implicitFreeSurface as default'
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                     SQUEEZE_RIGHT, myThid )
        implicitFreeSurface = .TRUE.
      ENDIF
      IF ( implicitFreeSurface ) freeSurfFac = 1. _d 0
      IF ( rigidLid            ) freeSurfFac = 0. _d 0
      IF ( gBaro .EQ. UNSET_RL ) gBaro=gravity
      IF ( rhoConst .EQ. UNSET_RL ) rhoConst=rhoNil
      IF ( rhoConstFresh .EQ. UNSET_RL ) rhoConstFresh=rhoConst
      IF ( implicitNHPress.EQ.UNSET_RL )
     &     implicitNHPress = implicSurfPress
      IF ( omega .EQ. UNSET_RL ) THEN
        omega = 0. _d 0
        IF ( rotationPeriod .NE. 0. _d 0 )
     &  omega = 2. _d 0 * PI / rotationPeriod
      ELSEIF ( omega .EQ. 0. _d 0 ) THEN
        rotationPeriod = 0. _d 0
      ELSE
        rotationPeriod = 2. _d 0 * PI / omega
      ENDIF
      IF ( atm_Rd .EQ. UNSET_RL ) THEN
        atm_Rd = atm_Cp * atm_kappa
      ELSE
        atm_kappa = atm_Rd / atm_Cp
      ENDIF
C--   Non-hydrostatic/quasi-hydrostatic
      IF (nonHydrostatic.AND.quasiHydrostatic) THEN
       WRITE(msgBuf,'(A)')
     &   'Illegal: both nonHydrostatic = quasiHydrostatic = TRUE'
       CALL PRINT_ERROR( msgBuf, myThid )
       errCount = errCount + 1
      ENDIF
C--  Advection and Forcing for Temp and salt
      IF (tempVertAdvScheme.EQ.0) tempVertAdvScheme = tempAdvScheme
      IF (saltVertAdvScheme.EQ.0) saltVertAdvScheme = saltAdvScheme
C--  horizontal viscosity (acting on Divergence or Vorticity)
      IF ( viscAhD .EQ. UNSET_RL ) viscAhD = viscAh
      IF ( viscAhZ .EQ. UNSET_RL ) viscAhZ = viscAh
      IF ( viscA4D .EQ. UNSET_RL ) viscA4D = viscA4
      IF ( viscA4Z .EQ. UNSET_RL ) viscA4Z = viscA4
C--  horizontal viscosity for vertical momentum
      IF ( viscAhW .EQ. UNSET_RL ) viscAhW = viscAhD
      IF ( viscA4W .EQ. UNSET_RL ) viscA4W = viscA4D
C--   z,p,r coord input switching.
      IF ( viscAz .NE. UNSET_RL ) zCoordInputData = .TRUE.
      IF ( viscAp .NE. UNSET_RL ) pCoordInputData = .TRUE.
      IF ( viscAr .NE. UNSET_RL ) rCoordInputData = .TRUE.
      IF ( viscAr .EQ. UNSET_RL )          viscAr = viscAz
      IF ( viscAr .EQ. UNSET_RL )          viscAr = viscAp
      vertSetCount = 0
      DO k=1,Nr
        IF ( viscArNr(k).NE.UNSET_RL ) vertSetCount = vertSetCount + 1
      ENDDO
      IF ( vertSetCount.GT.0 .AND. vertSetCount.LT.Nr ) THEN
        WRITE(msgBuf,'(A,2(I5,A))') 'S/R INI_PARMS: Partial setting (',
     &        vertSetCount, ' /', Nr, ') of viscArNr is not allowed'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF
      IF ( viscAr .EQ. UNSET_RL ) THEN
        viscAr = viscArDefault
      ELSEIF ( vertSetCount.GT.0 ) THEN
        WRITE(msgBuf,'(2A)') 'S/R INI_PARMS: Cannot set both ',
     &     'viscArNr and viscAr (or Ap,Az) in param file data'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF
      IF ( vertSetCount.EQ.0 ) THEN
        DO k=1,Nr
          viscArNr(k) = viscAr
        ENDDO
      ENDIF
#ifdef ALLOW_MOM_COMMON
C-    set default scheme for quadratic bottom-drag
      IF ( selectBotDragQuadr.EQ.-1 .AND. bottomDragQuadratic.NE.0. )
     &  selectBotDragQuadr = 0
      IF ( selectBotDragQuadr.EQ.-1 .AND. zRoughBot.NE.0. )
     &  selectBotDragQuadr = 0
#endif /* ALLOW_MOM_COMMON */

      IF ( smag3D_diffCoeff.NE.zeroRL .AND. .NOT.useSmag3D ) THEN
        WRITE(msgBuf,'(2A)') '** WARNING ** INI_PARMS: ',
     &    'will not use "smag3D_diffCoeff" without useSmag3D'
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
        WRITE(msgBuf,'(2A)') '** WARNING ** INI_PARMS: ',
     &    '==> reset "smag3D_diffCoeff" to zero'
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
       smag3D_diffCoeff = zeroRL
      ENDIF
      IF ( diffKzT .NE. UNSET_RL ) zCoordInputData  = .TRUE.
      IF ( diffKpT .NE. UNSET_RL ) pCoordInputData  = .TRUE.
      IF ( diffKrT .NE. UNSET_RL ) rCoordInputData  = .TRUE.
      IF ( diffKrT .EQ. UNSET_RL )          diffKrT = diffKzT
      IF ( diffKrT .EQ. UNSET_RL )          diffKrT = diffKpT
      vertSetCount = 0
      DO k=1,Nr
        IF ( diffKrNrT(k).NE.UNSET_RL ) vertSetCount = vertSetCount + 1
      ENDDO
      IF ( vertSetCount.GT.0 .AND. vertSetCount.LT.Nr ) THEN
        WRITE(msgBuf,'(A,2(I5,A))') 'S/R INI_PARMS: Partial setting (',
     &        vertSetCount, ' /', Nr, ') of diffKrNrT is not allowed'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF
      specifiedDiffKrT = vertSetCount.EQ.Nr
      IF ( diffKrT .EQ. UNSET_RL ) THEN
        diffKrT = diffKrTDefault
      ELSEIF ( vertSetCount.GT.0 ) THEN
        WRITE(msgBuf,'(2A)') 'S/R INI_PARMS: Cannot set both ',
     &     'diffKrNrT and diffKrT (or Kp,Kz) in param file data'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ELSE
        specifiedDiffKrT = .TRUE.
      ENDIF
      IF ( vertSetCount.EQ.0 ) THEN
        DO k=1,Nr
          diffKrNrT(k) = diffKrT
        ENDDO
      ENDIF

      IF ( diffKzS .NE. UNSET_RL ) zCoordInputData  = .TRUE.
      IF ( diffKpS .NE. UNSET_RL ) pCoordInputData  = .TRUE.
      IF ( diffKrS .NE. UNSET_RL ) rCoordInputData  = .TRUE.
      IF ( diffKrS .EQ. UNSET_RL )          diffKrS = diffKzS
      IF ( diffKrS .EQ. UNSET_RL )          diffKrS = diffKpS
      vertSetCount = 0
      DO k=1,Nr
        IF ( diffKrNrS(k).NE.UNSET_RL ) vertSetCount = vertSetCount + 1
      ENDDO
      IF ( vertSetCount.GT.0 .AND. vertSetCount.LT.Nr ) THEN
        WRITE(msgBuf,'(A,2(I5,A))') 'S/R INI_PARMS: Partial setting (',
     &        vertSetCount, ' /', Nr, ') of diffKrNrS is not allowed'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF
      IF ( vertSetCount.EQ.Nr ) THEN
        specifiedDiffKrS = .TRUE.
        IF ( diffKrS.NE.UNSET_RL ) THEN
         WRITE(msgBuf,'(2A)') 'S/R INI_PARMS: Cannot set both ',
     &     'diffKrNrS and diffKrS (or Kp,Kz) in param file data'
         CALL PRINT_ERROR( msgBuf, myThid )
         errCount = errCount + 1
        ENDIF
      ELSEIF ( diffKrS.NE.UNSET_RL ) THEN
        specifiedDiffKrS = .TRUE.
        DO k=1,Nr
          diffKrNrS(k) = diffKrS
        ENDDO
      ELSE
        specifiedDiffKrS = .FALSE.
        diffKrS = diffKrSDefault
C-    use temp diffusivity as default salt diffusivity:
        DO k=1,Nr
          diffKrNrS(k) = diffKrNrT(k)
        ENDDO
      ENDIF

      IF (diffKrBLEQsurf .EQ. UNSET_RL) diffKrBLEQsurf = diffKrBL79surf
      IF (diffKrBLEQdeep .EQ. UNSET_RL) diffKrBLEQdeep = diffKrBL79deep
      IF (diffKrBLEQscl  .EQ. UNSET_RL) diffKrBLEQscl  = diffKrBL79scl
      IF (diffKrBLEQHo   .EQ. UNSET_RL) diffKrBLEQHo   = diffKrBL79Ho

      IF ( hFacMinDz .NE. UNSET_RL ) zCoordInputData = .TRUE.
      IF ( hFacMinDp .NE. UNSET_RL ) pCoordInputData = .TRUE.
      IF ( hFacMinDr .NE. UNSET_RL ) rCoordInputData = .TRUE.
      IF ( hFacMinDr .EQ. UNSET_RL ) hFacMinDr       = hFacMinDz
      IF ( hFacMinDr .EQ. UNSET_RL ) hFacMinDr       = hFacMinDp
      IF ( hFacMinDr .EQ. UNSET_RL ) hFacMinDr       = hFacMinDrDefault

      IF (convertFW2Salt.EQ.UNSET_RL) THEN
        convertFW2Salt = 35.
        IF (useRealFreshWaterFlux) convertFW2Salt=-1
        IF ( selectAddFluid.GE.1 ) convertFW2Salt=-1
      ENDIF
      IF ( selectPenetratingSW.EQ.UNSET_I ) THEN
        selectPenetratingSW = 0
#ifdef SHORTWAVE_HEATING
        IF ( fluidIsWater ) selectPenetratingSW = 1
#endif
      ENDIF

C--   for backward compatibility :
      IF ( selectCoriScheme.EQ.UNSET_I ) THEN
        selectCoriScheme = 0
        IF ( useJamartWetPoints ) selectCoriScheme = 1
        IF ( useEnergyConservingCoriolis .AND.
     &       .NOT.vectorInvariantMomentum )
     &    selectCoriScheme = selectCoriScheme + 2
      ENDIF
      IF ( vectorInvariantMomentum ) THEN
        IF ( useJamartWetPoints .AND. selectCoriScheme.NE.1 ) THEN
          WRITE(msgBuf,'(A,I5,A)')
     &     'S/R INI_PARMS: selectCoriScheme=', selectCoriScheme,
     &     ' conflicts with "useJamartWetPoints"'
          CALL PRINT_ERROR( msgBuf, myThid )
          errCount = errCount + 1
        ENDIF
      ELSE
        IF ( useEnergyConservingCoriolis
     &       .AND. selectCoriScheme.LT.2 ) THEN
          WRITE(msgBuf,'(A,I5,A)')
     &     'S/R INI_PARMS: selectCoriScheme=', selectCoriScheme,
     &     ' conflicts with "useEnergyConservingCoriolis"'
          CALL PRINT_ERROR( msgBuf, myThid )
          errCount = errCount + 1
        ENDIF
        IF ( useJamartWetPoints .AND. selectCoriScheme.NE.1
     &                          .AND. selectCoriScheme.NE.3 ) THEN
          WRITE(msgBuf,'(A,I5,A)')
     &     'S/R INI_PARMS: selectCoriScheme=', selectCoriScheme,
     &     ' conflicts with "useJamartWetPoints"'
          CALL PRINT_ERROR( msgBuf, myThid )
          errCount = errCount + 1
        ENDIF
      ENDIF
      IF ( SadournyCoriolis ) THEN
C--   for backward compatibility :
        IF ( selectVortScheme.EQ.UNSET_I ) selectVortScheme = 2
        IF ( selectVortScheme.NE.2 ) THEN
          WRITE(msgBuf,'(A,I5,A)')
     &     'S/R INI_PARMS: selectVortScheme=', selectVortScheme,
     &     ' conflicts with "SadournyCoriolis"'
          CALL PRINT_ERROR( msgBuf, myThid )
          errCount = errCount + 1
        ENDIF
      ENDIF
      IF ( select3dCoriScheme.EQ.UNSET_I ) THEN
C--   for backward compatibility :
        select3dCoriScheme = 0
        IF ( use3dCoriolis ) select3dCoriScheme = 1
      ELSEIF ( select3dCoriScheme.NE.0 .AND. .NOT.use3dCoriolis ) THEN
        WRITE(msgBuf,'(A,I5,A)')
     &     'S/R INI_PARMS: select3dCoriScheme=', select3dCoriScheme,
     &     ' conflicts with "use3dCoriolis=F"'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF
      IF ( selectMetricTerms.EQ.UNSET_I ) THEN
C--   for backward compatibility :
        selectMetricTerms = 0
        IF ( metricTerms ) selectMetricTerms = 1
      ELSEIF ( selectMetricTerms.NE.0 .AND. .NOT.metricTerms ) THEN
        WRITE(msgBuf,'(A,I5,A)')
     &     'S/R INI_PARMS: selectMetricTerms=', selectMetricTerms,
     &     ' conflicts with "metricTerms=F"'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF
      IF ( selectBalanceEmPmR.EQ.UNSET_I ) THEN
        selectBalanceEmPmR = 0
        IF ( balanceEmPmR ) selectBalanceEmPmR = 1
      ELSEIF ( selectBalanceEmPmR.NE.1 .AND. balanceEmPmR ) THEN
        WRITE(msgBuf,'(A,I5,A)')
     &     'S/R INI_PARMS: selectBalanceEmPmR=', selectBalanceEmPmR,
     &     ' conflicts with "balanceEmPmR"'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF

      IF ( ivdc_kappa.NE.zeroRL .AND. .NOT.implicitDiffusion ) THEN
        WRITE(msgBuf,'(A,A)')
     &  'S/R INI_PARMS: To use ivdc_kappa you must enable implicit',
     &  ' vertical diffusion.'
       CALL PRINT_ERROR( msgBuf, myThid )
       errCount = errCount + 1
      ENDIF

      coordsSet = 0
      IF ( zCoordInputData ) coordsSet = coordsSet + 1
      IF ( pCoordInputData ) coordsSet = coordsSet + 1
      IF ( rCoordInputData ) coordsSet = coordsSet + 1
      IF ( coordsSet .GT. 1 ) THEN
       WRITE(msgBuf,'(A)')
     &  'S/R INI_PARMS: Cannot mix z, p and r in the input data.'
       CALL PRINT_ERROR( msgBuf, myThid )
       errCount = errCount + 1
      ENDIF
      IF ( rhoConst .LE. 0. ) THEN
       WRITE(msgBuf,'(A)')
     &  'S/R INI_PARMS: rhoConst must be greater than 0.'
       CALL PRINT_ERROR( msgBuf, myThid )
       errCount = errCount + 1
       recip_rhoConst = 1. _d 0
      ELSE
       recip_rhoConst = 1. _d 0 / rhoConst
      ENDIF
      IF ( eosType.EQ.'LINEAR' .AND. rhoNil.LE.0. ) THEN
       WRITE(msgBuf,'(A)')
     &  'S/R INI_PARMS: rhoNil must be greater than 0.'
       CALL PRINT_ERROR( msgBuf, myThid )
       errCount = errCount + 1
      ENDIF
      IF ( HeatCapacity_Cp .LE. 0. ) THEN
       WRITE(msgBuf,'(A)')
     &  'S/R INI_PARMS: HeatCapacity_Cp must be greater than 0.'
       CALL PRINT_ERROR( msgBuf, myThid )
       errCount = errCount + 1
      ENDIF
      IF ( gravity .LE. 0. ) THEN
       WRITE(msgBuf,'(A)')
     &  'S/R INI_PARMS: gravity must be greater than 0.'
       CALL PRINT_ERROR( msgBuf, myThid )
       errCount = errCount + 1
       recip_gravity = 1. _d 0
      ELSE
       recip_gravity = 1. _d 0 / gravity
      ENDIF

C-    set default printResidualFreq according to debugLevel
      printResidualFreq = -1
      IF ( debugLevel.GE.debLevE ) printResidualFreq = 1
      IF ( plotLevel.EQ.UNSET_I ) plotLevel = debugLevel

C-    set useSingleCpuInput=.TRUE. if useSingleCpuIO==.TRUE.
      IF ( useSingleCpuIO ) useSingleCpuInput=.TRUE.

C     Check for retired parameters still being used
      nRetired = 0
      IF ( useConstantF ) THEN
       nRetired = nRetired+1
       WRITE(msgBuf,'(A,A)') 'S/R INI_PARMS: "useConstantF" ',
     &  'is no longer allowed in file "data"'
       CALL PRINT_ERROR( msgBuf, myThid )
       WRITE(msgBuf,'(A,A)') 'S/R INI_PARMS: set "selectCoriMap"',
     &  ' [0,1,2,3] to impose a setting over grid default'
       CALL PRINT_ERROR( msgBuf, myThid )
      ENDIF
      IF ( useBetaPlaneF ) THEN
       nRetired = nRetired+1
       WRITE(msgBuf,'(A,A)') 'S/R INI_PARMS: "useBetaPlaneF" ',
     &  'is no longer allowed in file "data"'
       CALL PRINT_ERROR( msgBuf, myThid )
       WRITE(msgBuf,'(A,A)') 'S/R INI_PARMS: set "selectCoriMap"',
     &  ' [0,1,2,3] to impose a setting over grid default'
       CALL PRINT_ERROR( msgBuf, myThid )
      ENDIF
      IF ( .NOT. useSphereF ) THEN
       nRetired = nRetired+1
       WRITE(msgBuf,'(A,A)') 'S/R INI_PARMS: "useSphereF" ',
     &  'is no longer allowed in file "data"'
       CALL PRINT_ERROR( msgBuf, myThid )
       WRITE(msgBuf,'(A,A)') 'S/R INI_PARMS: set "selectCoriMap"',
     &  ' [0,1,2,3] to impose a setting over grid default'
       CALL PRINT_ERROR( msgBuf, myThid )
      ENDIF
      IF ( zonal_filt_lat .NE. UNSET_RL ) THEN
       nRetired = nRetired+1
       WRITE(msgBuf,'(A,A)')
     &  'S/R INI_PARMS: Paramater "zonal_filt_lat" is',
     &  ' no longer allowed in file "data".'
       CALL PRINT_ERROR( msgBuf, myThid )
       WRITE(msgBuf,'(A,A)')
     &  'S/R INI_PARMS: Paramater "zonal_filt_lat" is',
     &  ' now read from file "data.zonfilt".'
       CALL PRINT_ERROR( msgBuf, myThid )
      ENDIF
      IF ( gravitySign .NE. UNSET_RL ) THEN
       nRetired = nRetired+1
       WRITE(msgBuf,'(A,A)')
     &  'S/R INI_PARMS: "gravitySign" is set according to vertical ',
     &  ' coordinate and is no longer allowed in file "data".'
       CALL PRINT_ERROR( msgBuf, myThid )
      ENDIF
      IF ( tracerAdvScheme .NE. UNSET_I ) THEN
       nRetired = nRetired+1
       WRITE(msgBuf,'(A,A)') 'S/R INI_PARMS: "tracerAdvScheme" ',
     &  '(old passive tracer code) is no longer allowed in file "data"'
       CALL PRINT_ERROR( msgBuf, myThid )
      ENDIF
      IF ( trac_EvPrRn .NE. UNSET_RL ) THEN
       nRetired = nRetired+1
       WRITE(msgBuf,'(A,A)') 'S/R INI_PARMS: "trac_EvPrRn" ',
     &  '(old passive tracer code) is no longer allowed in file "data"'
       CALL PRINT_ERROR( msgBuf, myThid )
      ENDIF
      IF ( .NOT. tempDiffusion ) THEN
       nRetired = nRetired+1
       WRITE(msgBuf,'(A,A)') 'S/R INI_PARMS: "tempDiffusion" ',
     &  'is no longer allowed in file "data"'
       CALL PRINT_ERROR( msgBuf, myThid )
       WRITE(msgBuf,'(A,A)') 'S/R INI_PARMS: to turn off diffusion',
     &  ' => set diffusivity to zero'
       CALL PRINT_ERROR( msgBuf, myThid )
      ENDIF
      IF ( .NOT. saltDiffusion ) THEN
       nRetired = nRetired+1
       WRITE(msgBuf,'(A,A)') 'S/R INI_PARMS: "saltDiffusion" ',
     &  'is no longer allowed in file "data"'
       CALL PRINT_ERROR( msgBuf, myThid )
       WRITE(msgBuf,'(A,A)') 'S/R INI_PARMS: to turn off diffusion',
     &  ' => set diffusivity to zero'
       CALL PRINT_ERROR( msgBuf, myThid )
      ENDIF
      IF ( viscAstrain .NE. UNSET_RL ) THEN
       nRetired = nRetired+1
       WRITE(msgBuf,'(A,A)')
     &  'S/R INI_PARMS: "viscAstrain" ',
     &  'is no longer allowed in file "data"'
       CALL PRINT_ERROR( msgBuf, myThid )
       WRITE(msgBuf,'(A,A)') 'S/R INI_PARMS: to use Strain & Tension',
     &  ' formulation => set useStrainTensionVisc to TRUE'
       CALL PRINT_ERROR( msgBuf, myThid )
      ENDIF
      IF ( viscAtension .NE. UNSET_RL ) THEN
       nRetired = nRetired+1
       WRITE(msgBuf,'(A,A)')
     &  'S/R INI_PARMS: "viscAtension" ',
     &  'is no longer allowed in file "data"'
       CALL PRINT_ERROR( msgBuf, myThid )
       WRITE(msgBuf,'(A,A)') 'S/R INI_PARMS: to use Strain & Tension',
     &  ' formulation => set useStrainTensionVisc to TRUE'
       CALL PRINT_ERROR( msgBuf, myThid )
      ENDIF
      IF ( .NOT.useAnisotropicViscAgridMax ) THEN
       nRetired = nRetired+1
       WRITE(msgBuf,'(A,A)')
     &  'S/R INI_PARMS: "useAnisotropicViscAgridMax" ',
     &  'is not allowed in "data" substitute useAreaViscLength=true'
       CALL PRINT_ERROR( msgBuf, myThid )
      ENDIF
      IF ( usePickupBeforeC35 ) THEN
       nRetired = nRetired+1
       WRITE(msgBuf,'(A,A)')
     &  'S/R INI_PARMS: "usePickupBeforeC35" ',
     &  'is no longer supported & not longer allowed in file "data"'
       CALL PRINT_ERROR( msgBuf, myThid )
      ENDIF
      IF ( debugMode.NEQV.saveDebugMode ) THEN
       nRetired = nRetired+1
       WRITE(msgBuf,'(A,A)')
     &  'S/R INI_PARMS: "debugMode" has been moved to "eedata"',
     &  ' and is no longer allowed in file "data"'
       CALL PRINT_ERROR( msgBuf, myThid )
      ENDIF
      IF ( allowInteriorFreezing ) THEN
       nRetired = nRetired+1
       WRITE(msgBuf,'(A,A)')
     &  'S/R INI_PARMS: "allowInteriorFreezing" has been replaced',
     &  ' by pkg/frazil and is no longer allowed in file "data"'
       CALL PRINT_ERROR( msgBuf, myThid )
      ENDIF
      IF ( useOldFreezing ) THEN
       nRetired = nRetired+1
       WRITE(msgBuf,'(A,A)') 'S/R INI_PARMS: "useOldFreezing" ',
     &  'is no longer supported & not longer allowed in file "data"'
       CALL PRINT_ERROR( msgBuf, myThid )
      ENDIF
      IF ( writeStatePrec .NE. UNSET_I ) THEN
       nRetired = nRetired+1
       WRITE(msgBuf,'(A,A)') 'S/R INI_PARMS: "writeStatePrec" ',
     &  '(un-used) is no longer allowed in file "data"'
       CALL PRINT_ERROR( msgBuf, myThid )
      ENDIF

C--   Elliptic solver parameters
      WRITE(msgBuf,'(A)') ' INI_PARMS ; starts to read PARM02'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      READ(UNIT=iUnit,NML=PARM02) !,IOSTAT=errIO)
      IF ( errIO .LT. 0 ) THEN
       WRITE(msgBuf,'(A)')
     &  'S/R INI_PARMS: Error reading model parameter file "data"'
       CALL PRINT_ERROR( msgBuf, myThid )
       WRITE(msgBuf,'(A)') 'S/R INI_PARMS: Problem in namelist PARM02'
       CALL PRINT_ERROR( msgBuf, myThid )
       STOP 'ABNORMAL END: S/R INI_PARMS'
      ELSE
       WRITE(msgBuf,'(A)') ' INI_PARMS ; read PARM02 : OK'
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                     SQUEEZE_RIGHT, myThid )
      ENDIF
C     Check for retired parameters still being used
      IF ( cg2dChkResFreq .NE. UNSET_I ) THEN
       nRetired = nRetired+1
       WRITE(msgBuf,'(A,A)') 'S/R INI_PARMS: unused "cg2dChkResFreq"',
     &  ' is no longer allowed in file "data"'
       CALL PRINT_ERROR( msgBuf, myThid )
      ENDIF
      IF ( cg3dChkResFreq .NE. UNSET_I ) THEN
       nRetired = nRetired+1
       WRITE(msgBuf,'(A,A)') 'S/R INI_PARMS: unused "cg3dChkResFreq"',
     &  ' is no longer allowed in file "data"'
       CALL PRINT_ERROR( msgBuf, myThid )
      ENDIF

C--   Time stepping parameters
      rCD               = -1. _d 0
      epsAB_CD          = UNSET_RL
      latBandClimRelax  = UNSET_RL
      deltaTtracer      = 0. _d 0
      forcing_In_AB     = .TRUE.
      WRITE(msgBuf,'(A)') ' INI_PARMS ; starts to read PARM03'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      READ(UNIT=iUnit,NML=PARM03) !,IOSTAT=errIO)
      IF ( errIO .LT. 0 ) THEN
       WRITE(msgBuf,'(A)')
     &  'S/R INI_PARMS: Error reading model parameter file "data"'
       CALL PRINT_ERROR( msgBuf, myThid )
       WRITE(msgBuf,'(A)') 'S/R INI_PARMS: Problem in namelist PARM03'
       CALL PRINT_ERROR( msgBuf, myThid )
       STOP 'ABNORMAL END: S/R INI_PARMS'
      ELSE
       WRITE(msgBuf,'(A)') ' INI_PARMS ; read PARM03 : OK'
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                     SQUEEZE_RIGHT, myThid )
      ENDIF
C     Check for retired parameters still being used
      IF ( tauThetaClimRelax3Dim .NE. UNSET_RL ) THEN
       nRetired = nRetired+1
       WRITE(msgBuf,'(A,A)') 'S/R INI_PARMS: "tauThetaClimRelax3Dim" ',
     &  'is no longer allowed in file "data"'
       CALL PRINT_ERROR( msgBuf, myThid )
       WRITE(msgBuf,'(A,A)') 'S/R INI_PARMS: 3-dim. relaxation code',
     & ' has moved to separate pkg/rbcs.'
       CALL PRINT_ERROR( msgBuf, myThid )
      ENDIF
      IF ( tauSaltClimRelax3Dim .NE. UNSET_RL ) THEN
       nRetired = nRetired+1
       WRITE(msgBuf,'(A,A)') 'S/R INI_PARMS: "tauSaltClimRelax3Dim" ',
     &  'is no longer allowed in file "data"'
       CALL PRINT_ERROR( msgBuf, myThid )
       WRITE(msgBuf,'(A,A)') 'S/R INI_PARMS: 3-dim. relaxation code',
     & ' has moved to separate pkg/rbcs.'
       CALL PRINT_ERROR( msgBuf, myThid )
      ENDIF
      IF ( taveFreq .NE. UNSET_RL ) THEN
       nRetired = nRetired+1
       WRITE(msgBuf,'(A,A)') 'S/R INI_PARMS: "taveFreq" ',
     &  'is no longer allowed in file "data"'
       CALL PRINT_ERROR( msgBuf, myThid )
      ENDIF
      IF ( tave_lastIter .NE. UNSET_RL ) THEN
       nRetired = nRetired+1
       WRITE(msgBuf,'(A,A)') 'S/R INI_PARMS: "tave_lastIter" ',
     &  'is no longer allowed in file "data"'
       CALL PRINT_ERROR( msgBuf, myThid )
      ENDIF
      IF ( taveFreq.NE.UNSET_RL .OR. tave_lastIter.NE.UNSET_RL ) THEN
       WRITE(msgBuf,'(A,A)') 'S/R INI_PARMS: ',
     & ' since "pkg/timeave" has been removed.'
       CALL PRINT_ERROR( msgBuf, myThid )
      ENDIF
      IF ( calendarDumps ) THEN
       nRetired = nRetired+1
       WRITE(msgBuf,'(A,A)') 'S/R INI_PARMS: "calendarDumps" ',
     &  'is no longer allowed in file "data"'
       CALL PRINT_ERROR( msgBuf, myThid )
       WRITE(msgBuf,'(A,A)') 'S/R INI_PARMS: calendarDumps',
     & ' has moved to "data.cal"'
       CALL PRINT_ERROR( msgBuf, myThid )
      ENDIF

C     Process "timestepping" params
C     o Time step size
      IF ( deltaTtracer .NE. dTtracerLev(1) .AND.
     &     deltaTtracer .NE. 0. .AND. dTtracerLev(1) .NE. 0. ) THEN
        WRITE(msgBuf,'(A)')
     &   'S/R INI_PARMS: deltaTtracer & dTtracerLev(1) not equal'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ELSEIF ( dTtracerLev(1) .NE. 0. ) THEN
        deltaTtracer = dTtracerLev(1)
      ENDIF
      IF ( deltaT       .EQ. 0. ) deltaT       = deltaTClock
      IF ( deltaT       .EQ. 0. ) deltaT       = deltaTtracer
      IF ( deltaT       .EQ. 0. ) deltaT       = deltaTMom
      IF ( deltaT       .EQ. 0. ) deltaT       = deltaTFreeSurf
      IF ( deltaT       .EQ. 0. ) THEN
        WRITE(msgBuf,'(2A)') 'S/R INI_PARMS: ',
     &   'need to specify in file "data", namelist "PARM03"'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(2A)') 'S/R INI_PARMS: ',
     &   ' a model timestep (in s) deltaT or deltaTClock= ?'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
        deltaT = 1.
      ENDIF
      IF ( deltaTMom    .EQ. 0. ) deltaTMom    = deltaT
      IF ( deltaTtracer .EQ. 0. ) deltaTtracer = deltaT
      IF ( deltaTClock  .EQ. 0. ) deltaTClock  = deltaT
      DO k=1,Nr
       IF (dTtracerLev(k).EQ.0.) dTtracerLev(k)= deltaTtracer
      ENDDO
C Note that this line should set deltaFreesurf=deltaTtracer
C but this would change a lot of existing set-ups so we are
C obliged to set the default inappropriately.
C Be advised that when using asynchronous time stepping
C it is better to set deltaTreesurf=deltaTtracer
      IF ( deltaTFreeSurf .EQ. 0. ) deltaTFreeSurf  = deltaTMom
      IF ( periodicExternalForcing ) THEN
       IF ( externForcingCycle*externForcingPeriod .EQ. 0. ) THEN
        WRITE(msgBuf,'(A)')
     &   'S/R INI_PARMS: externForcingCycle,externForcingPeriod =0'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
       ELSEIF ( INT(externForcingCycle/externForcingPeriod) .NE.
     &              externForcingCycle/externForcingPeriod ) THEN
        WRITE(msgBuf,'(A)')
     &   'S/R INI_PARMS: externForcingCycle <> N*externForcingPeriod'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
       ELSEIF ( externForcingCycle.LT.externForcingPeriod ) THEN
        WRITE(msgBuf,'(A)')
     &   'S/R INI_PARMS: externForcingCycle < externForcingPeriod'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
       ENDIF
       IF ( externForcingPeriod.LT.deltaTClock ) THEN
        WRITE(msgBuf,'(A)')
     &   'S/R INI_PARMS: externForcingPeriod < deltaTClock'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
       ENDIF
      ENDIF
C     o Adams-Bashforth time stepping:
      IF ( momForcingOutAB  .EQ. UNSET_I ) THEN
        momForcingOutAB  = 1
        IF ( forcing_In_AB ) momForcingOutAB  = 0
      ENDIF
      IF ( tracForcingOutAB .EQ. UNSET_I ) THEN
        tracForcingOutAB = 1
        IF ( forcing_In_AB ) tracForcingOutAB = 0
      ENDIF
C     o Convection frequency
      IF ( cAdjFreq .LT. 0. ) THEN
       cAdjFreq = deltaTClock
      ENDIF
      IF ( ivdc_kappa .NE. 0. .AND. cAdjFreq .NE. 0. ) THEN
       WRITE(msgBuf,'(A,A)')
     &  'S/R INI_PARMS: You have enabled both ivdc_kappa and',
     &  ' convective adjustment.'
       CALL PRINT_ERROR( msgBuf, myThid )
       errCount = errCount + 1
      ENDIF
      IF (useCDscheme) THEN
C     o CD coupling (CD scheme):
        IF ( tauCD .EQ. 0. _d 0 ) tauCD = deltaTMom
        IF ( rCD .LT. 0. ) rCD = 1. _d 0 - deltaTMom/tauCD
        IF ( epsAB_CD .EQ. UNSET_RL ) epsAB_CD = abEps
      ENDIF

      IF ( startTime.EQ.UNSET_RL .AND. nIter0.EQ.-1 ) THEN
C     o set default value for start time & nIter0
        startTime = baseTime
        nIter0 = 0
      ELSEIF ( startTime.EQ.UNSET_RL ) THEN
C     o set start time from nIter0
         startTime = baseTime + deltaTClock*DFLOAT(nIter0)
      ELSEIF ( nIter0.EQ.-1 ) THEN
C     o set nIter0 from start time
         nIter0 = NINT( (startTime-baseTime)/deltaTClock )
      ELSEIF ( baseTime.EQ.0. ) THEN
C     o set base time from the 2 others
         baseTime = startTime - deltaTClock*DFLOAT(nIter0)
      ENDIF

      nTimeSteps_l2 = 4
C     o nTimeSteps 1
      IF ( nTimeSteps .EQ. 0 .AND. nEndIter .NE. 0 )
     &     nTimeSteps = nEndIter-nIter0
C     o nTimeSteps 2
      IF ( nTimeSteps .EQ. 0 .AND. endTime .NE. 0. )
     &     nTimeSteps = NINT((endTime-startTime)/deltaTClock)
C     o nEndIter 1
      IF ( nEndIter .EQ. 0 .AND. nTimeSteps .NE. 0 )
     &     nEndIter = nIter0+nTimeSteps
C     o nEndIter 2
      IF ( nEndIter .EQ. 0 .AND. endTime .NE. 0. )
     &     nEndIter = NINT((endTime-baseTime)/deltaTClock)
C     o End Time 1
      IF ( endTime .EQ. 0. .AND. nTimeSteps .NE. 0 )
     &     endTime = startTime + deltaTClock*DFLOAT(nTimeSteps)
C     o End Time 2
      IF ( endTime .EQ. 0. .AND. nEndIter .NE. 0 )
     &     endTime = baseTime + deltaTClock*DFLOAT(nEndIter)

C     o Consistent?
      IF ( startTime .NE. baseTime+deltaTClock*DFLOAT(nIter0) ) THEN
       WRITE(msgBuf,'(A)')
     & 'S/R INI_PARMS: startTime, baseTime and nIter0 are inconsistent'
       CALL PRINT_ERROR( msgBuf, myThid )
       WRITE(msgBuf,'(A)')
     & 'S/R INI_PARMS: Perhaps more than two were set at once'
       CALL PRINT_ERROR( msgBuf, myThid )
       errCount = errCount + 1
      ENDIF
      IF ( nEndIter .NE. nIter0+nTimeSteps ) THEN
       WRITE(msgBuf,'(A)')
     & 'S/R INI_PARMS: nIter0, nTimeSteps and nEndIter are inconsistent'
       CALL PRINT_ERROR( msgBuf, myThid )
       WRITE(msgBuf,'(A)')
     & 'S/R INI_PARMS: Perhaps more than two were set at once'
       CALL PRINT_ERROR( msgBuf, myThid )
       errCount = errCount + 1
      ENDIF
      IF ( nTimeSteps .NE. NINT((endTime-startTime)/deltaTClock)
     &   ) THEN
       WRITE(msgBuf,'(A)')
     & 'S/R INI_PARMS: both endTime and nTimeSteps have been set'
       CALL PRINT_ERROR( msgBuf, myThid )
       WRITE(msgBuf,'(A)')
     & 'S/R INI_PARMS: but are inconsistent'
       CALL PRINT_ERROR( msgBuf, myThid )
       errCount = errCount + 1
      ENDIF

C     o Monitor (should also add CPP flag for monitor?)
      IF (monitorFreq.LT.0.) THEN
       monitorFreq=0.
       IF (dumpFreq.NE.0.) monitorFreq=dumpFreq
       IF (diagFreq.NE.0..AND.diagFreq.LT.monitorFreq)
     &         monitorFreq=diagFreq
       IF (chkPtFreq.NE.0..AND.chkPtFreq.LT.monitorFreq)
     &         monitorFreq=chkPtFreq
       IF (pChkPtFreq.NE.0..AND.pChkPtFreq.LT.monitorFreq)
     &         monitorFreq=pChkPtFreq
       IF (monitorFreq.EQ.0.) monitorFreq=deltaTClock
      ENDIF
      IF ( monitorSelect.EQ.UNSET_I ) THEN
        monitorSelect = 2
        IF ( fluidIsWater ) monitorSelect = 3
      ENDIF

C--   Grid parameters
C     In cartesian coords distances are in metres
      DO k =1,Nr
       delZ(k) = UNSET_RL
       delP(k) = UNSET_RL
       delR(k) = UNSET_RL
      ENDDO
C     In spherical polar distances are in degrees
      dxSpacing = UNSET_RL
      dySpacing = UNSET_RL
C-    pCell-Mix  parameters:
      interViscAr_pCell = .FALSE.
      interDiffKr_pCell = .FALSE.
      pCellMix_select = 0
      pCellMix_maxFac = 1. _d 4
      pCellMix_delR = 0.
      DO k=1,Nr
        pCellMix_viscAr(k) = viscArNr(k)
        pCellMix_diffKr(k) = diffKrNrT(k)
      ENDDO

      WRITE(msgBuf,'(A)') ' INI_PARMS ; starts to read PARM04'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      READ(UNIT=iUnit,NML=PARM04) !,IOSTAT=errIO)
      IF ( errIO .LT. 0 ) THEN
       WRITE(msgBuf,'(A)')
     &  'S/R INI_PARMS: Error reading model parameter file "data"'
       CALL PRINT_ERROR( msgBuf, myThid )
       WRITE(msgBuf,'(A)') 'S/R INI_PARMS: Problem in namelist PARM04'
       CALL PRINT_ERROR( msgBuf, myThid )
       STOP 'ABNORMAL END: S/R INI_PARMS'
      ELSE
       WRITE(msgBuf,'(A)') ' INI_PARMS ; read PARM04 : OK'
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                     SQUEEZE_RIGHT, myThid )
      ENDIF

C     Check for retired parameters still being used
      IF ( Ro_SeaLevel .NE. UNSET_RL ) THEN
c      nRetired = nRetired+1
       IF ( usingPCoords ) THEN
        WRITE(msgBuf,'(2A)') '** WARNING ** INI_PARMS: ',
     &   '"Ro_SeaLevel" (P @ bottom) depreciated (backward compat'
       ELSEIF ( usingZCoords ) THEN
        WRITE(msgBuf,'(2A)') '** WARNING ** INI_PARMS: ',
     &   '"Ro_SeaLevel" (Z @ top) depreciated (backward compat'
       ENDIF
       CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                     SQUEEZE_RIGHT, myThid )
       IF ( usingPCoords ) THEN
        WRITE(msgBuf,'(2A)') '** WARNING ** INI_PARMS: ',
     &   ' only). To set vert. axis, use instead "top_Pres".'
       ELSEIF ( usingZCoords ) THEN
        WRITE(msgBuf,'(2A)') '** WARNING ** INI_PARMS: ',
     &   ' only). To set vert. axis, use instead "seaLev_Z".'
       ENDIF
       CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                     SQUEEZE_RIGHT, myThid )
      ENDIF
      IF ( rkFac .NE. UNSET_RL ) THEN
       nRetired = nRetired+1
       WRITE(msgBuf,'(A,A)')
     &  'S/R INI_PARMS: "rkFac" has been replaced by -rkSign ',
     &  ' and is no longer allowed in file "data".'
       CALL PRINT_ERROR( msgBuf, myThid )
      ENDIF
      IF ( groundAtK1 ) THEN
c      nRetired = nRetired+1
       WRITE(msgBuf,'(A,A)')
     &  'S/R INI_PARMS: "groundAtK1" is set according to vertical ',
     &  ' coordinate and is no longer allowed in file "data".'
       CALL PRINT_ERROR( msgBuf, myThid )
      ENDIF
      IF ( thetaMin .NE. UNSET_RL ) THEN
       nRetired = nRetired+1
       WRITE(msgBuf,'(A,A)')
     &  'S/R INI_PARMS: "thetaMin" no longer allowed,',
     &  ' has been replaced by "xgOrigin"'
       CALL PRINT_ERROR( msgBuf, myThid )
      ENDIF
      IF ( phiMin .NE. UNSET_RL ) THEN
       nRetired = nRetired+1
       WRITE(msgBuf,'(A,A)')
     &  'S/R INI_PARMS: "phiMin" no longer allowed,',
     &  ' has been replaced by "ygOrigin"'
       CALL PRINT_ERROR( msgBuf, myThid )
      ENDIF

C     X coordinate : Check for multiple definitions
      goptCount = 0
      IF ( delX(1)   .NE. UNSET_RL ) goptCount = goptCount + 1
      IF ( dxSpacing .NE. UNSET_RL ) goptCount = goptCount + 1
      IF ( delXFile  .NE. ' ' )      goptCount = goptCount + 1
      IF ( goptCount.GT.1 ) THEN
       WRITE(msgBuf,'(A,A)') 'Too many specifications for delX:',
     &   'Specify only one of delX, dxSpacing or delXfile'
       CALL PRINT_ERROR( msgBuf, myThid )
       errCount = errCount + 1
      ENDIF
      IF ( dxSpacing .NE. UNSET_RL ) THEN
       DO i=1,gridNx
        delX(i) = dxSpacing
       ENDDO
      ENDIF
C     Y coordinate : Check for multiple definitions
      goptCount = 0
      IF ( delY(1)   .NE. UNSET_RL ) goptCount = goptCount + 1
      IF ( dySpacing .NE. UNSET_RL ) goptCount = goptCount + 1
      IF ( delYFile  .NE. ' ' )      goptCount = goptCount + 1
      IF ( goptCount.GT.1 ) THEN
       WRITE(msgBuf,'(A,A)') 'Too many specifications for delY:',
     &   'Specify only one of delY, dySpacing or delYfile'
       CALL PRINT_ERROR( msgBuf, myThid )
       errCount = errCount + 1
      ENDIF
      IF ( dySpacing .NE. UNSET_RL ) THEN
       DO j=1,gridNy
        delY(j) = dySpacing
       ENDDO
      ENDIF

C--   Check for conflicting grid definitions.
      goptCount = 0
      IF ( usingCartesianGrid )      goptCount = goptCount+1
      IF ( usingSphericalPolarGrid ) goptCount = goptCount+1
      IF ( usingCurvilinearGrid )    goptCount = goptCount+1
      IF ( usingCylindricalGrid )    goptCount = goptCount+1
      IF ( goptCount .GT. 1 ) THEN
       WRITE(msgBuf,'(A)')
     &  'S/R INI_PARMS: More than one coordinate system requested'
       CALL PRINT_ERROR( msgBuf, myThid )
       errCount = errCount + 1
      ENDIF
      IF ( goptCount .LT. 1 ) THEN
C-     No horizontal grid is specified => use Cartesian grid as default:
       WRITE(msgBuf,'(A)')
     &  'S/R INI_PARMS: No horizontal grid requested'
       CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                     SQUEEZE_RIGHT, myThid )
       WRITE(msgBuf,'(A)')
     &  'S/R INI_PARMS: => Use Cartesian Grid as default'
       CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                     SQUEEZE_RIGHT, myThid )
       usingCartesianGrid = .TRUE.
      ENDIF
C-    Radius of the Planet:
      IF ( rSphere.EQ.UNSET_RL ) THEN
        IF ( usingCurvilinearGrid .AND.
     &       radius_fromHorizGrid.NE.UNSET_RL ) THEN
           rSphere = radius_fromHorizGrid
        ELSE
           rSphere = 6370. _d 3
        ENDIF
      ENDIF
      IF ( radius_fromHorizGrid.EQ.UNSET_RL ) THEN
           radius_fromHorizGrid = rSphere
      ENDIF
      IF ( rSphere .NE. 0. ) THEN
       recip_rSphere = 1. _d 0/rSphere
      ELSE
       recip_rSphere = 0.
      ENDIF
C--   Grid rotation
      IF ( phiEuler .NE. 0. _d 0 .OR. thetaEuler .NE. 0. _d 0
     &     .OR. psiEuler .NE. 0. _d 0 ) rotateGrid = .TRUE.

C--   Default vertical axis origin
      IF ( Ro_SeaLevel .NE. UNSET_RL ) THEN
       IF ( usingPCoords .AND. top_Pres.NE.UNSET_RL ) THEN
        WRITE(msgBuf,'(2A)') 'S/R INI_PARMS: ',
     &       'Cannot set both "Ro_SeaLevel" and "top_Pres"'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
       ENDIF
       IF ( usingZCoords .AND. seaLev_Z.NE.UNSET_RL ) THEN
        WRITE(msgBuf,'(2A)') 'S/R INI_PARMS: ',
     &       'Cannot set both "Ro_SeaLevel" and "seaLev_Z"'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
       ENDIF
       rF(1) = Ro_SeaLevel
      ELSE
       rF(1) = UNSET_RS
      ENDIF
      IF ( top_Pres.EQ.UNSET_RL ) top_Pres = 0.
      IF ( seaLev_Z.EQ.UNSET_RL ) seaLev_Z = 0.
C--   Default origin for  X & Y axis (longitude & latitude origin):
      IF ( xgOrigin .EQ. UNSET_RL ) xgOrigin = 0.
      IF ( ygOrigin .EQ. UNSET_RL ) THEN
        IF ( usingSphericalPolarGrid )  THEN
          ygOrigin = 0.
        ELSEIF ( usingCartesianGrid )   THEN
          ygOrigin = 0.
        ELSEIF ( usingCylindricalGrid ) THEN
          ygOrigin = 0.
        ELSEIF ( usingCurvilinearGrid ) THEN
          ygOrigin = 0.
        ELSE
          WRITE(msgBuf,'(A)')
     &    'S/R INI_PARMS: found no coordinate system to set ygOrigin'
          CALL PRINT_ERROR( msgBuf, myThid )
          errCount = errCount + 1
        ENDIF
      ENDIF

C--   set cell Center depth and put Interface at the middle between 2 C
      setCenterDr = .FALSE.
      DO k=1,Nr+1
       IF ( delRc(k).EQ.UNSET_RL ) THEN
        IF ( setCenterDr ) THEN
         WRITE(msgBuf,'(A,I4)')
     &        'S/R INI_PARMS: No value for delRc at k =', k
         CALL PRINT_ERROR( msgBuf, myThid )
         errCount = errCount + 1
        ENDIF
       ELSE
        IF ( k.EQ.1 ) setCenterDr = .TRUE.
        IF ( .NOT.setCenterDr ) THEN
         WRITE(msgBuf,'(A,I4)')
     &        'S/R INI_PARMS: No value for delRc at k <', k
         CALL PRINT_ERROR( msgBuf, myThid )
         errCount = errCount + 1
        ENDIF
       ENDIF
      ENDDO
      IF ( setCenterDr ) rCoordInputData = .TRUE.
C--   p, z, r coord parameters
      setInterFDr = .FALSE.
      DO k = 1, Nr
       IF ( delZ(k) .NE. UNSET_RL ) zCoordInputData = .TRUE.
       IF ( delP(k) .NE. UNSET_RL ) pCoordInputData = .TRUE.
       IF ( delR(k) .NE. UNSET_RL ) rCoordInputData = .TRUE.
       IF ( delR(k) .EQ. UNSET_RL ) delR(k) = delZ(k)
       IF ( delR(k) .EQ. UNSET_RL ) delR(k) = delP(k)
       IF ( delR(k) .EQ. UNSET_RL ) THEN
        IF ( setInterFDr ) THEN
         WRITE(msgBuf,'(A,I4)')
     &        'S/R INI_PARMS: No value for delZ/delP/delR at k =', k
         CALL PRINT_ERROR( msgBuf, myThid )
         errCount = errCount + 1
        ENDIF
       ELSE
        IF ( k.EQ.1 ) setInterFDr = .TRUE.
        IF ( .NOT.setInterFDr ) THEN
         WRITE(msgBuf,'(A,I4)')
     &        'S/R INI_PARMS: No value for delZ/delP/delR at k <', k
         CALL PRINT_ERROR( msgBuf, myThid )
         errCount = errCount + 1
        ENDIF
       ENDIF
      ENDDO
C     Check for multiple coordinate systems
      coordsSet = 0
      IF ( zCoordInputData ) coordsSet = coordsSet + 1
      IF ( pCoordInputData ) coordsSet = coordsSet + 1
      IF ( rCoordInputData ) coordsSet = coordsSet + 1
      IF ( coordsSet .GT. 1 ) THEN
       WRITE(msgBuf,'(A)')
     &  'S/R INI_PARMS: Cannot mix z, p and r in the input data.'
       CALL PRINT_ERROR( msgBuf, myThid )
       errCount = errCount + 1
      ENDIF
C-    Check for double definition (file & namelist)
      IF ( delRcFile.NE.' ' ) THEN
        IF ( setCenterDr ) THEN
          WRITE(msgBuf,'(A)')
     &         'S/R INI_PARMS: Cannot set both delRc and delRcFile'
          CALL PRINT_ERROR( msgBuf, myThid )
          errCount = errCount + 1
        ENDIF
        setCenterDr = .TRUE.
      ENDIF
      IF ( delRFile.NE.' ' ) THEN
        IF ( setInterFDr ) THEN
          WRITE(msgBuf,'(A)')
     &         'S/R INI_PARMS: Cannot set both delR and delRFile'
          CALL PRINT_ERROR( msgBuf, myThid )
          errCount = errCount + 1
        ENDIF
        setInterFDr = .TRUE.
      ENDIF

C--   Input files
      WRITE(msgBuf,'(A)') ' INI_PARMS ; starts to read PARM05'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      READ(UNIT=iUnit,NML=PARM05) !,IOSTAT=errIO)
      IF ( errIO .LT. 0 ) THEN
       WRITE(msgBuf,'(A)')
     &  'S/R INI_PARMS: Error reading model parameter file "data"'
       CALL PRINT_ERROR( msgBuf, myThid )
       WRITE(msgBuf,'(A)') 'S/R INI_PARMS: Problem in namelist PARM05'
       CALL PRINT_ERROR( msgBuf, myThid )
       STOP 'ABNORMAL END: S/R INI_PARMS'
      ELSE
       WRITE(msgBuf,'(A)') ' INI_PARMS ; read PARM05 : OK'
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                     SQUEEZE_RIGHT, myThid )
      ENDIF
C     Check for retired parameters still being used
      IF ( shelfIceFile .NE. ' ' ) THEN
       nRetired = nRetired+1
       WRITE(msgBuf,'(A,A)')
     &  'S/R INI_PARMS: "shelfIceFile" is not allowed in "data", ',
     &  'substitute "SHELFICEtopoFile" in data.shelfice'
       CALL PRINT_ERROR( msgBuf, myThid )
      ENDIF
      IF ( dQdTFile .NE. ' ' ) THEN
       nRetired = nRetired+1
       WRITE(msgBuf,'(A,A)')
     &  'S/R INI_PARMS: "dQdTFile" has been retired from file "data"'
       CALL PRINT_ERROR( msgBuf, myThid )
      ENDIF
C     Check if two conflicting I/O directories have been specified
      IF (mdsioLocalDir .NE. ' ' .AND. adTapeDir .NE. ' ') THEN
         WRITE(msgBuf,'(A)')
     &   'S/R INI_PARMS: mdsioLocalDir and adTapeDir cannot be'
         CALL PRINT_ERROR( msgBuf, myThid )
         WRITE(msgBuf,'(A)')
     &   'S/R INI_PARMS: specified at the same time'
         CALL PRINT_ERROR( msgBuf, myThid )
         errCount = errCount + 1
      ENDIF

C     Check for relaxation term:
       IF ( (tauThetaClimRelax.GT.0.).AND.
     &      (thetaClimFile.EQ.' ') ) THEN
         WRITE(msgBuf,'(A)')
     &   'S/R INI_PARMS: tauThetaClimRelax > 0 but'
         CALL PRINT_ERROR( msgBuf, myThid )
         WRITE(msgBuf,'(A)')
     &   'S/R INI_PARMS: thetaClimFile is undefined'
         CALL PRINT_ERROR( msgBuf, myThid )
         errCount = errCount + 1
       ENDIF
       IF ( (tauSaltClimRelax.GT.0.).AND.
     &      (saltClimFile.EQ.' ') ) THEN
         WRITE(msgBuf,'(A)')
     &   'S/R INI_PARMS: tauSaltClimRelax > 0 but'
         CALL PRINT_ERROR( msgBuf, myThid )
         WRITE(msgBuf,'(A)')
     &   'S/R INI_PARMS: saltClimFile is undefined'
         CALL PRINT_ERROR( msgBuf, myThid )
         errCount = errCount + 1
       ENDIF
C     Check vertical diffusivity setting:
#ifdef ALLOW_3D_DIFFKR
       IF ( specifiedDiffKrT ) THEN
         WRITE(msgBuf,'(2A)') '** WARNING ** INI_PARMS: Ignores diffKr',
     &   'T (or Kp,Kz) setting in file "data" with ALLOW_3D_DIFFKR'
         CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                       SQUEEZE_RIGHT, myThid )
       ENDIF
       IF ( specifiedDiffKrS .AND. diffKrFile.NE.' ' ) THEN
         WRITE(msgBuf,'(2A)') '** WARNING ** INI_PARMS: Ignores diffKr',
     &   'S (or Kp,Kz) setting in file "data" and uses diffKrFile'
         CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                       SQUEEZE_RIGHT, myThid )
       ENDIF
#endif

C--   Set Units conversion factor required to incorporate
C     surface forcing into z-p isomorphic equations:
C     mass2rUnit: from mass per unit area [kg/m2] to r-coordinate
C     rUnit2mass: from r-coordinate to mass per unit area [kg/m2]
      IF ( usingPCoords ) THEN
         mass2rUnit = gravity
         rUnit2mass = recip_gravity
      ELSE
         mass2rUnit = recip_rhoConst
         rUnit2mass = rhoConst
      ENDIF

C--   For backward compatibility, set temp_addMass and salt_addMass
C     to temp_EvPrRn and salt_EvPrRn if not set in parameter file "data"
      IF (temp_addMass .EQ. UNSET_RL) temp_addMass = temp_EvPrRn
      IF (salt_addMass .EQ. UNSET_RL) salt_addMass = salt_EvPrRn

C--   Make a choice (if unset) regarding using CG2D solver min.-residual sol.
C      for simple set-up (cartesian grid + flat bottom), default is to
C      use the solver minimum residual solution (cg2dUseMinResSol=1).
      IF ( cg2dUseMinResSol.EQ.UNSET_I ) THEN
        cg2dUseMinResSol = 0
        IF ( topoFile.EQ.' ' .AND. bathyFile.EQ.' '
     &       .AND. usingCartesianGrid ) cg2dUseMinResSol = 1
      ENDIF

C--   Close the open data file
#ifdef SINGLE_DISK_IO
      CLOSE(iUnit)
#else
      CLOSE(iUnit,STATUS='DELETE')
#endif /* SINGLE_DISK_IO */

      WRITE(msgBuf,'(A)') ' INI_PARMS: finished reading file "data"'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT , myThid )

C--   Check whether any retired parameters were found.
      IF ( nRetired .GT. 0 ) THEN
       WRITE(msgBuf,'(A)')
     &  'S/R INI_PARMS: Error reading parameter file "data":'
       CALL PRINT_ERROR( msgBuf, myThid )
       WRITE(msgBuf,'(I4,A)') nRetired,
     &      ' out of date parameters were found in the namelist'
       CALL PRINT_ERROR( msgBuf, myThid )
       errCount = errCount + 1
      ENDIF
C--   Stop if any error was found (including retired params):
      IF ( errCount .GE. 1 ) THEN
        WRITE(msgBuf,'(A,I3,A)')
     &       'S/R INI_PARMS: detected', errCount,' fatal error(s)'
        CALL PRINT_ERROR( msgBuf, myThid )
        CALL ALL_PROC_DIE( 0 )
        STOP 'ABNORMAL END: S/R INI_PARMS'
      ENDIF

      _END_MASTER(myThid)

C--   Everyone else must wait for the parameters to be loaded
      _BARRIER

      RETURN
      END

#include "GAD_OPTIONS.h"

CBOP
C !ROUTINE: GAD_DEL2

C !INTERFACE: ==========================================================
      SUBROUTINE GAD_DEL2(
     I           bi,bj,k,
     I           dTdx,dTdy,
     O           del2,
     I           myThid )

C !DESCRIPTION:
C Calculates the horizontal Laplacian of a tracer:
C \begin{equation*}
C \nabla^2 \theta = \partial_{xx} \theta + \partial_{yy} \theta
C \end{equation*}

C !USES: ===============================================================
      IMPLICIT NONE
#include "SIZE.h"
#include "GRID.h"

C !INPUT PARAMETERS: ===================================================
C  bi,bj                :: tile indices
C  k                    :: vertical level
C  dTx                  :: zonal tracer gradient
C  dTy                  :: meridional tracer gradient
C  myThid               :: thread number
      INTEGER bi,bj,k
      _RL dTdx(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL dTdy(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER myThid

C !OUTPUT PARAMETERS: ==================================================
C  del2                 :: Laplacian of tracer
      _RL del2(1-OLx:sNx+OLx,1-OLy:sNy+OLy)

C !LOCAL VARIABLES: ====================================================
C  i,j                  :: loop indices
      INTEGER i,j
CEOP

C--   Initialise to zero.
      DO j=1-Oly,sNy+Oly
       DO i=1-Olx,sNx+Olx
        del2(i,j)= 0. _d 0
       ENDDO
      ENDDO

C     Difference of zonal fluxes & meridional fluxes
C      and divide by grid-cell volume
      DO j=1-Oly,sNy+Oly-1
       DO i=1-Olx,sNx+Olx-1
        del2(i,j)=recip_rA(i,j,bi,bj)*recip_deepFac2C(k)
     &           *recip_drF(k)*_recip_hFacC(i,j,k,bi,bj)
     &           *( ( dTdx(i+1,j)-dTdx(i,j) )
     &             +( dTdy(i,j+1)-dTdy(i,j) )
     &            )
       ENDDO
      ENDDO

      RETURN
      END

#include "SHELFICE_OPTIONS.h"

CBOP
C     !ROUTINE: SHELFICE_REMESH_CALC_W
C     !INTERFACE:
      SUBROUTINE SHELFICE_REMESH_CALC_W(
     I                             uFld, vFld,
     O                             wFld,
     I                             myIter, myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE SHELFICE_REMESH_CALC_W
C     | o Integrate the continuity Eq : compute vertical velocity
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     == Global variables
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
c#include "DYNVARS.h"
#include "GRID.h"
c#include "SURFACE.h"
#include "FFIELDS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     uFld     :: Zonal velocity ( m/s )
C     vFld     :: Meridional velocity ( m/s )
C     wFld     :: Vertical velocity ( m/s )
C     myIter   :: Current iteration number
C     myThid   :: my Thread Id. number
      _RL uFld(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      _RL vFld(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      _RL wFld(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      INTEGER myIter
      INTEGER myThid

#ifdef ALLOW_SHELFICE_REMESHING

C     !LOCAL VARIABLES:
C     bi,bj    :: tile index
C     i,j,k    :: Loop counters
      INTEGER k,bi,bj
#ifdef ALLOW_OBCS
      INTEGER i, j
#endif
#ifndef ALLOW_ADDFLUID
      _RL addMass(1)
#endif /* ndef ALLOW_ADDFLUID */
#if (defined NONLIN_FRSURF) && !(defined DISABLE_RSTAR_CODE)
      _RL rStarDhDt(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
#else
      _RL rStarDhDt(1)
#endif
CEOP

C--   Start bi,bj loops
      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

        DO k=Nr,1,-1
C--   Integrate continuity vertically for vertical velocity

         CALL INTEGRATE_FOR_W(
     I                         bi, bj, k, uFld, vFld,
     I                         addMass, rStarDhDt,
     O                         wFld,
     I                         myIter, myThid )

#ifdef ALLOW_OBCS
C--   reset W to zero outside the OB interior region
         IF ( useOBCS ) THEN
          DO j=1,sNy
           DO i=1,sNx
             wFld(i,j,k,bi,bj) = wFld(i,j,k,bi,bj)*maskInC(i,j,bi,bj)
           ENDDO
          ENDDO
         ENDIF
#endif /* ALLOW_OBCS */

C-    End k look
        ENDDO

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C--   End bi,bj loops
       ENDDO
      ENDDO

      _EXCH_XYZ_RL( wFld, myThid )

#endif /* ALLOW_SHELFICE_REMESHING */

      RETURN
      END

#include "MOM_COMMON_OPTIONS.h"

CBOP
C !ROUTINE: MOM_W_CORIOLIS_NH

C !INTERFACE: ==========================================================
      SUBROUTINE MOM_W_CORIOLIS_NH(
     I               bi, bj, k,
     I               uFld, vFld, recip_rThickC,
     U               wCoriolisTerm,
     I               myThid )

C !DESCRIPTION:
C Calculates the Coriolis term in the vertical momentum equation:
C \begin{equation*}
C + f_prime \overline{u}^{ik}
C \end{equation*}

C !USES: ===============================================================
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"

C !INPUT PARAMETERS: ===================================================
C  bi, bj               :: tile indices
C  k                    :: vertical level
C  uFld                 :: horizontal flow, u component
C  vFld                 :: horizontal flow, v component
C  recip_rThickC        :: reciprocal of W-cell thickness
C  myThid               :: my Thread Id number
      INTEGER bi, bj, k
      _RL uFld(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      _RL vFld(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      _RL recip_rThickC(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER myThid

C !OUTPUT PARAMETERS: ==================================================
C  uCoriolisTerm        :: Coriolis term
      _RL wCoriolisTerm(1-OLx:sNx+OLx,1-OLy:sNy+OLy)

#ifdef ALLOW_NONHYDROSTATIC
C !LOCAL VARIABLES: ====================================================
C  i, j                 :: loop indices
      INTEGER i,j
CEOP

      IF ( k.GT.1 .AND. k.LE.Nr ) THEN

       IF ( select3dCoriScheme.EQ.1 ) THEN
C-    Original discretization of 2*Omega*cos(phi)*u_eastward
C     documented as Energy conserving
        DO j=1-OLy,sNy+OLy-1
         DO i=1-OLx,sNx+OLx-1
           wCoriolisTerm(i,j) =
     &      -gravitySign*fCoriCos(i,j,bi,bj)*
     &       ( angleCosC(i,j,bi,bj)*(
     &                (uFld(i,j,k-1,bi,bj)+uFld(i+1,j,k-1,bi,bj))
     &              + (uFld(i,j, k ,bi,bj)+uFld(i+1,j, k ,bi,bj))
     &                              )*0.25 _d 0
     &        -angleSinC(i,j,bi,bj)*(
     &                (vFld(i,j,k-1,bi,bj)+vFld(i,j+1,k-1,bi,bj))
     &              + (vFld(i,j, k ,bi,bj)+vFld(i,j+1, k ,bi,bj))
     &                              )*0.25 _d 0
     &       )*wUnit2rVel(k)
         ENDDO
        ENDDO
       ELSEIF ( select3dCoriScheme.EQ.2 ) THEN
C-    Using thickness-averaged transport (but without hFac):
        DO j=1-OLy,sNy+OLy-1
         DO i=1-OLx,sNx+OLx-1
           wCoriolisTerm(i,j) = -gravitySign
     &      *fCoriCos(i,j,bi,bj)
     &      *( angleCosC(i,j,bi,bj)
     &         *( ( uFld(i,j,k-1,bi,bj) + uFld(i+1,j,k-1,bi,bj) )
     &            *drF(k-1)
     &          + ( uFld(i,j, k ,bi,bj) + uFld(i+1,j, k ,bi,bj) )
     &            *drF( k )
     &          )*0.25 _d 0
     &        -angleSinC(i,j,bi,bj)
     &         *( ( vFld(i,j,k-1,bi,bj) + vFld(i,j+1,k-1,bi,bj) )
     &            *drF(k-1)
     &          + ( vFld(i,j, k ,bi,bj) + vFld(i,j+1, k ,bi,bj) )
     &            *drF( k )
     &          )*0.25 _d 0
     &       )*recip_drC(k)*wUnit2rVel(k)
         ENDDO
        ENDDO
       ELSE
C-    Using thickness-averaged transport:
C     for now, without dyG*deepFacC weight and without recip_hFacI factor:
        DO j=1-OLy,sNy+OLy-1
         DO i=1-OLx,sNx+OLx-1
           wCoriolisTerm(i,j) = -gravitySign
     &      *fCoriCos(i,j,bi,bj)
     &      *( angleCosC(i,j,bi,bj)
     &        *( ( uFld( i ,j,k-1,bi,bj)*hFacW( i ,j,k-1,bi,bj)
     &           + uFld(i+1,j,k-1,bi,bj)*hFacW(i+1,j,k-1,bi,bj)
     &           )*drF(k-1)
c    &            *deepFacC(k-1)
     &         + ( uFld( i ,j, k ,bi,bj)*hFacW( i ,j, k ,bi,bj)
     &           + uFld(i+1,j, k ,bi,bj)*hFacW(i+1,j, k ,bi,bj)
     &           )*drF( k )
c    &            *deepFacC( k )
     &         )*0.25 _d 0
     &        -angleSinC(i,j,bi,bj)
     &        *( ( vFld(i, j ,k-1,bi,bj)*hFacS(i, j ,k-1,bi,bj)
     &           + vFld(i,j+1,k-1,bi,bj)*hFacS(i,j+1,k-1,bi,bj)
     &           )*drF(k-1)
c    &            *deepFacC(k-1)
     &         + ( vFld(i, j , k ,bi,bj)*hFacS(i, j , k ,bi,bj)
     &           + vFld(i,j+1, k ,bi,bj)*hFacS(i,j+1, k ,bi,bj)
     &           )*drF( k )
c    &            *deepFacC( k )
     &         )*0.25 _d 0
     &       )*recip_rThickC(i,j)*wUnit2rVel(k)
c    &       )*recip_rThickC(i,j)*recip_deepFacF(k)*wUnit2rVel(k)
         ENDDO
        ENDDO
       ENDIF

      ELSE
        DO j=1-OLy,sNy+OLy-1
         DO i=1-OLx,sNx+OLx-1
           wCoriolisTerm(i,j) = 0. _d 0
         ENDDO
        ENDDO
      ENDIF

#endif /* ALLOW_NONHYDROSTATIC */

      RETURN
      END

#include "ctrparam.h"
#include "ATM2D_OPTIONS.h"
      SUBROUTINE ATM2D_WRITE_PICKUP(
     I     modelEnd,
     I     myTime,
     I     myIter,
     I     myThid )

C     *==========================================================*
C     | Write pickup files for atm2d package which needs it to   |
C     |restart. It writes both "rolling-checkpoint" files (ckptA,|
C     |ckptB) and permanent checkpoint files. NOT called from    |
C     |the usual MITGCM WRITE_PICKUP routine in forward step, as |
C     |NORM_OCN_FLUXES must be done before these fluxes are ready|
C     *==========================================================*

C     Note this routine was pilfered from the MITGCM code prior to
C     JMC's changes in 8/06.

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "RESTART.h"

      LOGICAL  DIFFERENT_MULTIPLE
      EXTERNAL DIFFERENT_MULTIPLE
      INTEGER  IO_ERRCOUNT
      EXTERNAL IO_ERRCOUNT

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     modelEnd    :: Checkpoint call at end of model run.
C     myThid :: Thread number for this instance of the routine.
C     myIter :: Iteration number
C     myTime :: Current time of simulation ( s )
      LOGICAL modelEnd
      INTEGER myThid
      INTEGER myIter
      _RL     myTime

C     !LOCAL VARIABLES:
C     == Local variables ==
C     permCheckPoint :: Flag indicating whether a permanent checkpoint will
C                       be written.
C     tempCheckPoint :: Flag indicating if it is time to write a non-permanent
C                       checkpoint (that will be permanent if permCheckPoint=T)
      LOGICAL permCheckPoint, tempCheckPoint
CEOP

      permCheckPoint = .FALSE.
      tempCheckPoint = .FALSE.
      permCheckPoint=
     &     DIFFERENT_MULTIPLE(pChkPtFreq,myTime,deltaTClock)
      tempCheckPoint=
     &     DIFFERENT_MULTIPLE( chkPtFreq,myTime,deltaTClock)

#ifdef ALLOW_CAL
      IF ( useCAL ) THEN
         CALL CAL_TIME2DUMP( zeroRL, pChkPtFreq, deltaTClock,
     U                       permCheckPoint,
     I                       myTime, myIter, myThid )
         CALL CAL_TIME2DUMP( zeroRL, chkPtFreq,  deltaTClock,
     U                       tempCheckPoint,
     I                       myTime, myIter, myThid )
      ENDIF
#endif /* ALLOW_CAL */

      IF (
     &     ( .NOT.modelEnd .AND. (permCheckPoint.OR.tempCheckPoint) )
     &     .OR.
     &     ( modelEnd .AND. .NOT.(permCheckPoint.OR.tempCheckPoint) )
     &     ) THEN

        IF (tempCheckPoint)   !toggle was done prematurely...
     &       nCheckLev = MOD(nCheckLev, maxNoChkptLev)+1

        CALL ATM2D_WRITE_PICKUP_NOW(
     &       permCheckPoint, myTime, myIter, myThid )

        IF (tempCheckPoint)   !note this works for A/B chpt only
     &       nCheckLev = MOD(nCheckLev, maxNoChkptLev)+1

      ENDIF

      RETURN
      END


C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
#include "ctrparam.h"
#include "ATM2D_OPTIONS.h"
CBOP
C     !ROUTINE: ATM2D_WRITE_PICKUP_NOW

C     !INTERFACE:
      SUBROUTINE ATM2D_WRITE_PICKUP_NOW(
     I     permCheckPoint,
     I     myTime,
     I     myIter,
     I     myThid )

C     !DESCRIPTION:
C     Write pickup files for atm2d package which needs it to restart and
C     do it NOW.

C     !USES:
      IMPLICIT NONE
#include "ATMSIZE.h"
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "RESTART.h"
#include "THSICE_VARS.h"
#include "ATM2D_VARS.h"


C     !INPUT/OUTPUT PARAMETERS:
C     permCheckPoint  :: Checkpoint is permanent
C     myThid :: Thread number for this instance of the routine.
C     myIter :: Iteration number
C     myTime :: Current time of simulation ( s )
      LOGICAL permCheckPoint
      INTEGER myThid
      INTEGER myIter
      _RL     myTime

C     == Common blocks ==
      COMMON /PCKP_GBLFLS/ globalFile
      LOGICAL globalFile

C     !LOCAL VARIABLES:
C     == Local variables ==
C     oldPrc :: Temp. for holding I/O precision
C     fn     :: Temp. for building file name string.
      CHARACTER*(MAX_LEN_FNAM) fn
      INTEGER prec, i,j
CEOP

      prec = precFloat64

C     Create suffix to pass on to package pickup routines
      IF ( permCheckPoint ) THEN
       WRITE(fn,'(A,I10.10)') 'pickup_atm2d.',myIter
      ELSE
       WRITE(fn,'(A,A)') 'pickup_atm2d.',checkPtSuff(nCheckLev)
      ENDIF

      CALL WRITE_REC_3D_RL( fn,prec,1,pass_slp,      1,myIter,myThid )
      CALL WRITE_REC_3D_RL( fn,prec,1,pass_qnet,     2,myIter,myThid )
      CALL WRITE_REC_3D_RL( fn,prec,1,pass_solarnet, 3,myIter,myThid )
      CALL WRITE_REC_3D_RL( fn,prec,1,pass_fu,       4,myIter,myThid )
      CALL WRITE_REC_3D_RL( fn,prec,1,pass_fv,       5,myIter,myThid )
      CALL WRITE_REC_3D_RL( fn,prec,1,pass_precip,   6,myIter,myThid )
      CALL WRITE_REC_3D_RL( fn,prec,1,pass_evap,     7,myIter,myThid )
      CALL WRITE_REC_3D_RL( fn,prec,1,pass_runoff,   8,myIter,myThid )
      CALL WRITE_REC_3D_RL( fn,prec,1,pass_wspeed,   9,myIter,myThid )
      CALL WRITE_REC_3D_RL( fn,prec,1,pass_pCO2,    10,myIter,myThid )
      CALL WRITE_REC_3D_RL( fn,prec,1,pass_sIceLoad,11,myIter,myThid )

      CALL WRITE_REC_3D_RL( fn,prec,1,sHeating,     12,myIter,myThid )
      CALL WRITE_REC_3D_RL( fn,prec,1,flxCndBt,     13,myIter,myThid )
      CALL WRITE_REC_3D_RL( fn,prec,1,pass_prcAtm,  14,myIter,myThid )
      CALL WRITE_REC_3D_RL( fn,prec,1,snowPrc,      15,myIter,myThid )
      CALL WRITE_REC_3D_RL( fn,prec,1,icFrwAtm,     16,myIter,myThid )
      CALL WRITE_REC_3D_RL( fn,prec,1,icFlxSw,      17,myIter,myThid )
      CALL WRITE_REC_3D_RL( fn,prec,1,siceAlb,      18,myIter,myThid )

      RETURN
      END

#include "BLING_OPTIONS.h"
#ifdef ALLOW_AUTODIFF
# include "AUTODIFF_OPTIONS.h"
#endif

CBOP
      SUBROUTINE BLING_BIO_NITROGEN(
     I           PTR_O2, PTR_FE, PTR_PO4, PTR_DOP,
     I           PTR_NO3, PTR_DON,
#ifdef USE_SIBLING
     I           PTR_SI,
#endif
#ifdef ADVECT_PHYTO
     I           PTR_PHY,
#endif
     O           G_DIC, G_ALK, G_O2, G_FE,
     O           G_PO4, G_DOP, G_NO3, G_DON,
#ifdef USE_SIBLING
     O           G_SI,
#endif
     I           bi, bj, imin, imax, jmin, jmax,
     I           myTime, myIter, myThid)

C     =================================================================
C     | subroutine bling_bio_nitrogen
C     | o Nutrient uptake and partitioning between organic pools.
C     | - Phytoplankton specific growth rate is calculated
C     |   as a function of light, nutrient limitation, and
C     |   temperature.
C     | - Population growth is calculated as a function of the local
C     |   phytoplankton biomass.
C     | o Organic matter export and remineralization.
C     | - Sinking particulate flux and diel migration contribute to
C     |   export.
C     | - Benthic denitrification
C     | - Iron source from sediments
C     | - Iron scavenging
C     | o Diel Vertical Migration
C     =================================================================

      IMPLICIT NONE

C     === Global variables ===
C     phyto_sm     :: small phytoplankton biomass
C     phyto_lg     :: large phytoplankton biomass
C     phyto_diaz   :: diazotroph phytoplankton biomass
C *** if ADVECT_PHYTO, these are fraction of total biomass instead ***

#include "SIZE.h"
#include "DYNVARS.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "BLING_VARS.h"
#include "PTRACERS_SIZE.h"
#include "PTRACERS_PARAMS.h"
#ifdef ALLOW_AUTODIFF_TAMC
# include "tamc.h"
#endif

C     === Routine arguments ===
C     bi,bj         :: tile indices
C     iMin,iMax     :: computation domain: 1rst index range
C     jMin,jMax     :: computation domain: 2nd  index range
C     myTime        :: current time
C     myIter        :: current timestep
C     myThid        :: thread Id. number
      INTEGER bi, bj, imin, imax, jmin, jmax
      _RL     myTime
      INTEGER myIter
      INTEGER myThid
C     === Input ===
C     PTR_O2        :: oxygen concentration
C     PTR_FE        :: iron concentration
C     PTR_PO4       :: phosphate concentration
C     PTR_DOP       :: dissolved organic phosphorus concentration
C     PTR_NO3       :: nitrate concentration
C     PTR_DON       :: dissolved organic nitrogen concentration
C     PTR_SI        :: silica concentration
C     PTR_PHY       :: total phytoplankton biomass
      _RL     PTR_O2 (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL     PTR_FE (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL     PTR_PO4(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL     PTR_DOP(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL     PTR_NO3(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL     PTR_DON(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
#ifdef USE_SIBLING
      _RL     PTR_SI (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
#endif
#ifdef ADVECT_PHYTO
      _RL     PTR_PHY(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
#endif

C     === Output ===
C     G_xxx         :: tendency term for tracer xxx
      _RL     G_DIC     (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL     G_ALK     (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL     G_O2      (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL     G_FE      (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL     G_PO4     (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL     G_DOP     (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL     G_NO3     (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL     G_DON     (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
#ifdef USE_SIBLING
      _RL     G_SI      (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
#endif

#ifdef ALLOW_BLING
# ifndef USE_BLING_V1
C     === Local variables ===
C     i,j,k         :: loop indices
C     Phy_lg_local  :: biomass in large phytoplankton
C     Phy_sm_local  :: biomass in small phytoplankton
C     Phy_diaz_local:: biomass in diazotroph phytoplankton
C     NO3_lim       :: nitrate limitation
C     PO4_lim       :: phosphate limitation
C     Fe_lim        :: iron limitation for phytoplankton
C     Fe_lim_diaz   :: iron limitation for diazotrophs
C     light_lim     :: light limitation
C     expkT         :: temperature function
C     Pc_m          :: light-saturated max photosynthesis rate for phyto
C     Pc_m_diaz     :: light-saturated max photosynthesis rate for diaz
C     theta_Fe      :: Chl:C ratio
C     theta_Fe_inv  :: C:Chl ratio
C     theta_Fe_max  :: Fe-replete maximum Chl:C ratio
C     irrk          :: nut-limited efficiency of algal photosystems
C     irr_inst      :: instantaneous light
C     irr_eff       :: effective irradiance
C     mld           :: mixed layer depth
C     mu            :: net carbon-specific growth rate for phyt
C     mu_diaz       :: net carbon-specific growth rate for diaz
C     PtoN          :: variable ratio of phosphorus to nitrogen
C     FetoN         :: variable ratio of iron to nitrogen
C     N_uptake      :: NO3 utilization by phytoplankton
C     N_fix         :: Nitrogen fixation by diazotrophs
C     N_den_pelag   :: Pelagic denitrification
C     N_den_benthic :: Benthic denitrification
C     P_uptake      :: PO4 utilization by phytoplankton
C     Fe_uptake     :: dissolved Fe utilization by phytoplankton
C     CaCO3_uptake  :: Calcium carbonate uptake for shell formation
C     CaCO3_diss    :: Calcium carbonate dissolution
C     G_CaCO3       :: tendency of calcium carbonate
C     DON_prod      :: production of dissolved organic nitrogen
C     DOP_prod      :: production of dissolved organic phosphorus
C     DON_remin     :: remineralization of dissolved organic nitrogen
C     DOP_remin     :: remineralization of dissolved organic phosphorus
C     O2_prod       :: production of oxygen
C     frac_exp      :: fraction of sinking particulate organic matter
C     N_spm         :: particulate sinking of nitrogen
C     P_spm         :: particulate sinking of phosphorus
C     Fe_spm        :: particulate sinking of iron
C     N_dvm         :: vertical transport of nitrogen by DVM
C     P_dvm         :: vertical transport of phosphorus by DVM
C     Fe_dvm        :: vertical transport of iron by DVM
C     N_recycle     :: recycling of newly-produced organic nitrogen
C     P_recycle     :: recycling of newly-produced organic phosphorus
C     Fe_recycle    :: recycling of newly-produced organic iron
C     N_reminp      :: remineralization of particulate organic nitrogen
C     P_reminp      :: remineralization of particulate organic nitrogen
C     Fe_reminp     :: remineralization of particulate organic iron
C     Fe_reminsum   :: iron remineralization and adsorption
C     N_remindvm    :: nitrogen remineralization due to diel vertical migration
C     P_remindvm    :: phosphorus remineralization due to diel vertical migration
C     Fe_remindvm   :: iron remineralization due to diel vertical migration
C     POC_flux      :: particulate organic carbon flux
C     NPP           :: net primary production
C     NCP           :: net community production
C     depth_l       :: depth of lower interface
C     *flux_u       :: "*" flux through upper interface
C     *flux_l       :: "*" flux through lower interface
C     zremin        :: remineralization lengthscale for nutrients
C     zremin_caco3  :: remineralization lengthscale for CaCO3
C     wsink         :: speed of sinking particles
C     POC_sed       :: flux of particulate organic carbon to sediment
C     Fe_sed        :: sediment iron efflux
C     kFe_eq_lig    :: iron ligand stability constant
C     FreeFe        :: free (unbound) iron concentration
C     Fe_ads_inorg  :: iron adsorption
C     Fe_ads_org    :: iron adsorption  (2nd order)
C     NO3_btmflx    :: bottom flux of nitrate
C     PO4_btmflx    :: bottom flux of phosphate
C     O2_btmflx     :: bottom flux of oxygen
C     Fe_burial     :: flux of iron to sediment as particulate
C
      INTEGER i,j,k
      _RL Phy_lg_local(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL Phy_sm_local(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL Phy_diaz_local(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL NO3_lim(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL PO4_lim(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL Fe_lim(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL Fe_lim_diaz(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL light_lim(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL expkT(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL Pc_m
      _RL Pc_m_diaz
      _RL theta_Fe_max
      _RL theta_Fe(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL theta_Fe_inv(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL irrk(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL irr_eff(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL irr_inst(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL mld(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL mu(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL mu_diaz(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL PtoN(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL FetoN(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL N_uptake(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL N_fix(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL N_den_pelag(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL N_den_benthic(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL P_uptake(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL Fe_uptake(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL CaCO3_uptake(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL CaCO3_diss(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL G_CACO3(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL DON_prod(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL DOP_prod(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL DON_remin(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL DOP_remin(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL O2_prod(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL frac_exp
      _RL N_spm(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL P_spm(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL Fe_spm(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL N_dvm(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL P_dvm(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL Fe_dvm(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL N_recycle(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL P_recycle(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL Fe_recycle(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL N_reminp(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL P_reminp(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL Fe_reminp(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL Fe_reminsum(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL N_remindvm(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL P_remindvm(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL Fe_remindvm(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL POC_flux(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL NPP(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL NCP(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL depth_l
      _RL PONflux_u
      _RL PONflux_l
      _RL POPflux_u
      _RL POPflux_l
      _RL PFEflux_u
      _RL PFEflux_l
      _RL CaCO3flux_u
      _RL CaCO3flux_l
      _RL zremin
      _RL zremin_caco3
      _RL wsink
      _RL POC_sed
      _RL Fe_sed(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL kFe_eq_lig
      _RL FreeFe
      _RL Fe_ads_inorg(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL Fe_ads_org(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL log_btm_flx
      _RL NO3_btmflx(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL PO4_btmflx(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL O2_btmflx(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL Fe_burial(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL no3_adj(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL po4_adj(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL fe_adj(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL o2_adj(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL don_adj(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL dop_adj(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
#ifdef ML_MEAN_PHYTO
      _RL tmp_p_sm_ML
      _RL tmp_p_lg_ML
      _RL tmp_p_diaz_ML
      _RL tmp_ML
#endif
#ifdef USE_BLING_DVM
      INTEGER tmp_dvm
      _RL o2_upper
      _RL o2_lower
      _RL dz_upper
      _RL dz_lower
      _RL temp_upper
      _RL temp_lower
      _RL z_dvm_regr
      _RL frac_migr
      _RL fdvm_migr
      _RL fdvm_stat
      _RL fdvmn_vint
      _RL fdvmp_vint
      _RL fdvmfe_vint
      _RL z_dvm
      _RL dvm(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL x_erfcc,z_erfcc,t_erfcc,erfcc
#endif
#ifdef USE_SIBLING
      _RL Si_lim(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL Si_uptake(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL Si_spm(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL Si_recycle(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL Si_reminp(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL SitoN_uptake(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL Phy_diatom_local(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL frac_diss_Si(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL Pc_m_diatom
      _RL mu_diatom(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL zremin_Si
      _RL Siflux_u
      _RL Siflux_l
      _RL si_adj(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
#endif
#ifdef ADVECT_PHYTO
      _RL phy_adj(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
#endif
#ifdef SIZE_DEP_LIM
      _RL light_lim_sm(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL light_lim_lg(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL NO3_lim_sm(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL NO3_lim_lg(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL PO4_lim_sm(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL PO4_lim_lg(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL Fe_lim_sm(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL Fe_lim_lg(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL Pc_m_sm
      _RL Pc_m_lg
      _RL mu_sm(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL mu_lg(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
#endif
#ifdef ALLOW_AUTODIFF_TAMC
C     tkey   :: tape key (tile dependent)
C     ijkkey :: tape key (depends on i,j,k indices and tiles)
      INTEGER tkey, ijkkey
#endif
CEOP

#ifdef ALLOW_AUTODIFF_TAMC
      tkey = bi + (bj - 1)*nSx + (ikey_dynamics - 1)*nSx*nSy
#endif

C  Initialize output and diagnostics
       DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
            mld(i,j)             = 0. _d 0
            NO3_btmflx(i,j)      = 0. _d 0
            PO4_btmflx(i,j)      = 0. _d 0
            O2_btmflx(i,j)       = 0. _d 0
            Fe_burial(i,j)       = 0. _d 0
         ENDDO
       ENDDO
       DO k=1,Nr
         DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
              G_DIC(i,j,k)          = 0. _d 0
              G_ALK(i,j,k)          = 0. _d 0
              G_O2(i,j,k)           = 0. _d 0
              G_Fe(i,j,k)           = 0. _d 0
              G_PO4(i,j,k)          = 0. _d 0
              G_DOP(i,j,k)          = 0. _d 0
              G_NO3(i,j,k)          = 0. _d 0
              G_DON(i,j,k)          = 0. _d 0
              G_CaCO3(i,j,k)        = 0. _d 0
              Phy_lg_local(i,j,k)   = 0. _d 0
              Phy_sm_local(i,j,k)   = 0. _d 0
              Phy_diaz_local(i,j,k) = 0. _d 0
              NO3_lim(i,j,k)        = 0. _d 0
              PO4_lim(i,j,k)        = 0. _d 0
              Fe_lim(i,j,k)         = 0. _d 0
              Fe_lim_diaz(i,j,k)    = 0. _d 0
              light_lim(i,j,k)      = 0. _d 0
              expkT(i,j,k)          = 0. _d 0
              theta_Fe(i,j,k)       = 0. _d 0
              irrk(i,j,k)           = 0. _d 0
              irr_inst(i,j,k)       = 0. _d 0
              irr_eff(i,j,k)        = 0. _d 0
              mu(i,j,k)             = 0. _d 0
              mu_diaz(i,j,k)        = 0. _d 0
              PtoN(i,j,k)           = 0. _d 0
              FetoN(i,j,k)          = 0. _d 0
              N_uptake(i,j,k)       = 0. _d 0
              N_fix(i,j,k)          = 0. _d 0
              N_den_pelag(i,j,k)    = 0. _d 0
              N_den_benthic(i,j,k)  = 0. _d 0
              P_uptake(i,j,k)       = 0. _d 0
              Fe_uptake(i,j,k)      = 0. _d 0
              CaCO3_uptake(i,j,k)   = 0. _d 0
              CaCO3_diss(i,j,k)     = 0. _d 0
              DON_prod(i,j,k)       = 0. _d 0
              DOP_prod(i,j,k)       = 0. _d 0
              DON_remin(i,j,k)      = 0. _d 0
              DOP_remin(i,j,k)      = 0. _d 0
              O2_prod(i,j,k)        = 0. _d 0
              N_spm(i,j,k)          = 0. _d 0
              P_spm(i,j,k)          = 0. _d 0
              Fe_spm(i,j,k)         = 0. _d 0
              N_dvm(i,j,k)          = 0. _d 0
              P_dvm(i,j,k)          = 0. _d 0
              Fe_dvm(i,j,k)         = 0. _d 0
              N_recycle(i,j,k)      = 0. _d 0
              P_recycle(i,j,k)      = 0. _d 0
              Fe_recycle(i,j,k)     = 0. _d 0
              N_reminp(i,j,k)       = 0. _d 0
              P_reminp(i,j,k)       = 0. _d 0
              Fe_reminp(i,j,k)      = 0. _d 0
              Fe_reminsum(i,j,k)    = 0. _d 0
              N_remindvm(i,j,k)     = 0. _d 0
              P_remindvm(i,j,k)     = 0. _d 0
              Fe_remindvm(i,j,k)    = 0. _d 0
              NCP(i,j,k)            = 0. _d 0
              Fe_sed(i,j,k)         = 0. _d 0
              Fe_ads_org(i,j,k)     = 0. _d 0
              Fe_ads_inorg(i,j,k)   = 0. _d 0
#ifdef USE_BLING_DVM
              dvm(i,j,k)            = 0. _d 0
#endif
#ifdef USE_SIBLING
              G_SI(i,j,k)             = 0. _d 0
              Si_lim(i,j,k)           = 0. _d 0
              Si_spm(i,j,k)           = 0. _d 0
              Si_uptake(i,j,k)        = 0. _d 0
              Si_recycle(i,j,k)       = 0. _d 0
              Si_reminp(i,j,k)        = 0. _d 0
              SitoN_uptake(i,j,k)     = 0. _d 0
              Phy_diatom_local(i,j,k) = 0. _d 0
              frac_diss_Si(i,j,k)     = 0. _d 0
              mu_diatom(i,j,k)        = 0. _d 0
#endif
           ENDDO
         ENDDO
       ENDDO

C-----------------------------------------------------------
C  avoid negative nutrient concentrations that can result from
C  advection when low concentrations

#ifdef BLING_NO_NEG
# ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE PTR_O2, PTR_FE, PTR_PO4, PTR_DOP, PTR_NO3, PTR_DON
#  ifdef USE_SIBLING
CADJ &   , PTR_SI
#  endif
#  ifdef ADVECT_PHYTO
CADJ &   , PTR_PHY
#  endif
CADJ &     = comlev1_bibj, key=tkey, kind=isbyte
# endif /* ALLOW_AUTODIFF_TAMC */
      CALL BLING_MIN_VAL(PTR_O2,  1. _d -11, o2_adj, bi, bj)
      CALL BLING_MIN_VAL(PTR_FE,  1. _d -11, fe_adj, bi, bj)
      CALL BLING_MIN_VAL(PTR_PO4, 1. _d -8, po4_adj, bi, bj)
      CALL BLING_MIN_VAL(PTR_DOP, 1. _d -11, dop_adj, bi, bj)
      CALL BLING_MIN_VAL(PTR_NO3, 1. _d -7, no3_adj, bi, bj)
      CALL BLING_MIN_VAL(PTR_DON, 1. _d -11, don_adj, bi, bj)
# ifdef USE_SIBLING
      CALL BLING_MIN_VAL(PTR_SI , 1. _d -7, si_adj, bi, bj)
# endif
# ifdef ADVECT_PHYTO
      CALL BLING_MIN_VAL(PTR_PHY, 1. _d -11, phy_adj, bi, bj)
# endif
#endif

C-----------------------------------------------------------
C  Phytoplankton size classes

      DO k=1,Nr
       DO j=jmin,jmax
        DO i=imin,imax
#ifdef ADVECT_PHYTO
          Phy_lg_local(i,j,k)   = PTR_PHY(i,j,k)*phyto_lg(i,j,k,bi,bj)
          Phy_sm_local(i,j,k)   = PTR_PHY(i,j,k)*phyto_sm(i,j,k,bi,bj)
          Phy_diaz_local(i,j,k) = PTR_PHY(i,j,k)*phyto_diaz(i,j,k,bi,bj)
#else
          Phy_lg_local(i,j,k)   = phyto_lg(i,j,k,bi,bj)
          Phy_sm_local(i,j,k)   = phyto_sm(i,j,k,bi,bj)
          Phy_diaz_local(i,j,k) = phyto_diaz(i,j,k,bi,bj)
#endif
        ENDDO
       ENDDO
      ENDDO

C-----------------------------------------------------------
C  Mixed layer depth calculation for light, phytoplankton and dvm.
C  Do not need to calculate if not using ML_MEAN_LIGHT, ML_MEAN_PHYTO,
C  and USE_BLING_DVM
C  (with BLING_ADJOINT_SAFE flag, USE_BLING_DVM is undefined)

#if ( defined (ML_MEAN_LIGHT) || \
      defined (ML_MEAN_PHYTO) || \
      defined (USE_BLING_DVM) )
      CALL BLING_MIXEDLAYER(
     U                         mld,
     I                         bi, bj, imin, imax, jmin, jmax,
     I                         myTime, myIter, myThid)
# ifdef ALLOW_AUTODIFF_TAMC
C     save result of s/r bling_mixedlayer to avoid calling it in AD-code
CADJ STORE mld = comlev1_bibj, key=tkey, kind=isbyte
# endif
#endif

C  Phytoplankton mixing
C  The mixed layer is assumed to homogenize vertical gradients of phytoplankton.
C  This allows for basic Sverdrup dynamics in a qualitative sense.
C  This has not been thoroughly tested, and care should be
C  taken with its interpretation.

#ifdef ML_MEAN_PHYTO
# ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE Phy_sm_local   = comlev1_bibj, key=tkey, kind=isbyte
CADJ STORE Phy_lg_local   = comlev1_bibj, key=tkey, kind=isbyte
CADJ STORE Phy_diaz_local = comlev1_bibj, key=tkey, kind=isbyte
# endif
      DO j=jmin,jmax
       DO i=imin,imax

        tmp_p_sm_ML = 0. _d 0
        tmp_p_lg_ML = 0. _d 0
        tmp_p_diaz_ML = 0. _d 0
        tmp_ML  = 0. _d 0

        DO k=1,Nr

         IF ( maskC(i,j,k,bi,bj).EQ.oneRS ) THEN
          IF ((-rf(k+1) .le. mld(i,j)).and.
     &               (-rf(k+1).lt.MLmix_max)) THEN
           tmp_p_sm_ML = tmp_p_sm_ML+Phy_sm_local(i,j,k)*drF(k)
     &                  *hFacC(i,j,k,bi,bj)
           tmp_p_lg_ML = tmp_p_lg_ML+Phy_lg_local(i,j,k)*drF(k)
     &                  *hFacC(i,j,k,bi,bj)
           tmp_p_diaz_ML = tmp_p_diaz_ML+Phy_diaz_local(i,j,k)*drF(k)
     &                  *hFacC(i,j,k,bi,bj)
           tmp_ML = tmp_ML + drF(k)
          ENDIF
         ENDIF

        ENDDO

        DO k=1,Nr

         IF ( maskC(i,j,k,bi,bj).EQ.oneRS ) THEN
          IF ((-rf(k+1) .le. mld(i,j)).and.
     &               (-rf(k+1).lt.MLmix_max)) THEN

           Phy_lg_local(i,j,k)   = max(1. _d -8,tmp_p_lg_ML/tmp_ML)
           Phy_sm_local(i,j,k)   = max(1. _d -8,tmp_p_sm_ML/tmp_ML)
           Phy_diaz_local(i,j,k) = max(1. _d -8,tmp_p_diaz_ML/tmp_ML)

          ENDIF
         ENDIF

        ENDDO
       ENDDO
      ENDDO
# ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE Phy_sm_local   = comlev1_bibj, key=tkey, kind=isbyte
CADJ STORE Phy_lg_local   = comlev1_bibj, key=tkey, kind=isbyte
CADJ STORE Phy_diaz_local = comlev1_bibj, key=tkey, kind=isbyte
# endif
#endif

#ifdef USE_SIBLING
      DO k=1,Nr
       DO j=jmin,jmax
        DO i=imin,imax
         Phy_diatom_local(i,j,k) = Phy_lg_local(i,j,k)
        ENDDO
       ENDDO
      ENDDO
#endif

C-----------------------------------------------------------
C  light availability for biological production

      CALL BLING_LIGHT(
     I                    mld,
     U                    irr_inst, irr_eff,
     I                    bi, bj, imin, imax, jmin, jmax,
     I                    myTime, myIter, myThid )
#ifdef ALLOW_AUTODIFF_TAMC
C     save results of s/r bling_light to avoid calling it in AD-code
CADJ STORE irr_inst = comlev1_bibj, key=tkey, kind=isbyte
CADJ STORE irr_eff  = comlev1_bibj, key=tkey, kind=isbyte
#endif

C  phytoplankton photoadaptation to local light level
C  This represents the fact that phytoplankton cells are adapted
C  to the averaged light field to which they've been exposed over
C  their lifetimes, rather than the instantaneous light. The
C  timescale is set by gamma_irr_mem.

      DO k=1,Nr
       DO j=jmin,jmax
        DO i=imin,imax

          irr_mem(i,j,k,bi,bj) = irr_mem(i,j,k,bi,bj) +
     &           (irr_eff(i,j,k) - irr_mem(i,j,k,bi,bj))*
     &           min( 1. _d 0, gamma_irr_mem*PTRACERS_dTLev(k) )

        ENDDO
       ENDDO
      ENDDO

C  Nutrient uptake and partitioning between organic pools

      DO k=1,Nr
       DO j=jmin,jmax
        DO i=imin,imax
         IF ( maskC(i,j,k,bi,bj).EQ.oneRS ) THEN

C--   Compute 3d fields that used more than once.
C ---------------------------------------------------------------------
C  First, calculate the limitation terms for NUT and Fe, and the
C  Fe-limited Chl:C maximum. The light-saturated maximal photosynthesis
C  rate term (Pc_m) is simply the product of a prescribed maximal
C  photosynthesis rate (Pc_0), the Eppley temperature dependence, and a
C  resource limitation term. The iron limitation term has a lower limit
C  of Fe_lim_min and is scaled by (k_Fe2P + Fe2P_max) / Fe2P_max so that
C  it approaches 1 as Fe approaches infinity. Thus, it is of comparable
C  magnitude to the macro-nutrient limitation term.

C  Macro-nutrient limitation

          NO3_lim(i,j,k) = PTR_NO3(i,j,k)/(PTR_NO3(i,j,k)+k_NO3)

          PO4_lim(i,j,k) = PTR_PO4(i,j,k)/(PTR_PO4(i,j,k)+k_PO4)

C  Iron limitation

          Fe_lim(i,j,k) = PTR_FE(i,j,k)
     &                    / (PTR_FE(i,j,k)+k_Fe_2d(i,j,bi,bj))

          Fe_lim_diaz(i,j,k) = PTR_FE(i,j,k)
     &                         / (PTR_FE(i,j,k)+k_Fe_diaz_2d(i,j,bi,bj))

#ifdef USE_SIBLING
          Si_lim(i,j,k) = PTR_Si(i,j,k)/(PTR_Si(i,j,k)+k_Si)
#endif

#ifdef SIZE_DEP_LIM
          NO3_lim_sm(i,j,k) = PTR_NO3(i,j,k)/(PTR_NO3(i,j,k)+k_NO3_sm)

          PO4_lim_sm(i,j,k) = PTR_PO4(i,j,k)/(PTR_PO4(i,j,k)+k_PO4_sm)

          Fe_lim_sm(i,j,k) = PTR_FE(i,j,k)/(PTR_FE(i,j,k)+k_Fe_sm)

          NO3_lim_lg(i,j,k) = PTR_NO3(i,j,k)/(PTR_NO3(i,j,k)+k_NO3_lg)

          PO4_lim_lg(i,j,k) = PTR_PO4(i,j,k)/(PTR_PO4(i,j,k)+k_PO4_lg)

          Fe_lim_lg(i,j,k) = PTR_FE(i,j,k)/(PTR_FE(i,j,k)+k_Fe_lg)
#endif
C  NB The temperature function of Eppley (1972) is used to represent the
C  effects of temperature on uptake, synthesis and ecosystem function.
C  The reference value is 0 C. Note that this differs slightly from the
C  more common Arrhenius form of the equation, but by a tiny amount (less
C  than 4% difference over the range -2 to 32 C for an Arrhenius constant
C  (Ae) of 5150).

C ---------------------------------------------------------------------
C  Temperature functionality of growth and grazing

C  NB The temperature function of Eppley (1972) is used to represent the
C  effects of temperature on uptake, synthesis and ecosystem function.
C  The reference value is 0 C. Note that this differs slightly from the
C  more common Arrhenius form of the equation, but by a tiny amount (less
C  than 4% difference over the range -2 to 32 C for an Arrhenius constant
C  (Ae) of 5150).

          expkT(i,j,k) = exp(kappa_eppley * theta(i,j,k,bi,bj))

C  The light-saturated maximal photosynthesis rate term (pc_m) is
C  the product of a prescribed maximal photosynthesis rate (pc_0), the
C  Eppley temperature dependence, and a co-limitation term (the product
C  of Michaelis-Menten no3-limitation, po4-limitation, or iron-limitation).
C  Note this was altered from the Liebig limitation of BLINGv0, following
C  the arguments of Danger (Oikos, 2008) and Harpole (Ecol. Letters 2011).
C  Taking the cube root, to provide the geometric mean.

C  Geometric mean is causing instability in b-SOSE. Returning to Liebig

#ifdef MIN_NUT_LIM
          Pc_m = Pc_0_2d(i,j,bi,bj) * expkT(i,j,k)
     &           * min(NO3_lim(i,j,k), PO4_lim(i,j,k), Fe_lim(i,j,k))
     &           * maskC(i,j,k,bi,bj)
#else
          Pc_m = Pc_0_2d(i,j,bi,bj) * expkT(i,j,k)
     &           * (NO3_lim(i,j,k) * PO4_lim(i,j,k) * Fe_lim(i,j,k))
     &           **(1./3.) * maskC(i,j,k,bi,bj)
#endif

C  Diazotrophs are assumed to be more strongly temperature sensitive,
C  given their observed restriction to relatively warm waters. Presumably
C  this is because of the difficulty of achieving N2 fixation in an oxic
C  environment. Thus, they have lower pc_0 and higher kappa_eppley.
C  Taking the square root, to provide the geometric mean.

#ifdef MIN_NUT_LIM
          Pc_m_diaz = Pc_0_diaz_2d(i,j,bi,bj)
     &           * exp(kappa_eppley_diaz * theta(i,j,k,bi,bj))
     &           * min(PO4_lim(i,j,k), Fe_lim_diaz(i,j,k))
     &           * maskC(i,j,k,bi,bj)
#else
          Pc_m_diaz = Pc_0_diaz_2d(i,j,bi,bj)
     &           * exp(kappa_eppley_diaz * theta(i,j,k,bi,bj))
     &           * (PO4_lim(i,j,k) * Fe_lim_diaz(i,j,k))**(1./2.)
     &           * maskC(i,j,k,bi,bj)
#endif

C  Diatoms are limited by the abundance of silica
C  Note: this is not in original SiBLING code

#ifdef USE_SIBLING
# ifdef MIN_NUT_LIM
          Pc_m_diatom = Pc_0_2d(i,j,bi,bj) * expkT(i,j,k)
     &           * min(NO3_lim(i,j,k), PO4_lim(i,j,k), Fe_lim(i,j,k),
     &           Si_lim(i,j,k)) * maskC(i,j,k,bi,bj)
# else
          Pc_m_diatom = Pc_0_2d(i,j,bi,bj) * expkT(i,j,k)
     &           * (NO3_lim(i,j,k) * PO4_lim(i,j,k) * Fe_lim(i,j,k)
     &           * Si_lim(i,j,k)) **(1./4.) * maskC(i,j,k,bi,bj)
# endif
#endif

C  (Pc_m and Pc_m_diaz crash adjoint if get too small)
#ifdef BLING_ADJOINT_SAFE
          Pc_m        = max(Pc_m       ,maskC(i,j,k,bi,bj)*1. _d -15)
          Pc_m_diaz   = max(Pc_m_diaz  ,maskC(i,j,k,bi,bj)*1. _d -15)
# ifdef USE_SIBLING
          Pc_m_diatom = max(Pc_m_diatom,maskC(i,j,k,bi,bj)*1. _d -15)
# endif
#endif

C ---------------------------------------------------------------------
C  Fe limitation reduces the maximum achievable Chl:C ratio (theta_Fe)
C  below a prescribed, Fe-replete maximum value (theta_Fe_max),
C  to approach a prescribed minimum Chl:C (theta_Fe_min) under extreme
C  Fe-limitation.

          theta_Fe_max = theta_Fe_max_lo+
     &                  (theta_Fe_max_hi-theta_Fe_max_lo)*Fe_lim(i,j,k)

          theta_Fe(i,j,k) = theta_Fe_max
     &                  / (1. _d 0 + alpha_photo_2d(i,j,bi,bj)
     &                  *theta_Fe_max
     &                  *irr_mem(i,j,k,bi,bj)/(epsln + 2. _d 0*Pc_m))

C ---------------------------------------------------------------------
C  Nutrient-limited efficiency of algal photosystems, irrk, is calculated
C  with the iron limitation term included as a multiplier of the
C  theta_Fe_max to represent the importance of Fe in forming chlorophyll
C  accessory antennae, which do not affect the Chl:C but still affect the
C  phytoplankton ability to use light (eg Stzrepek & Harrison, Nature 2004).
C  Use same thetamax for diazotrophs, since their extra Fe requirement
C  is for nitrogenase, not for the photosystem.

          irrk(i,j,k) = Pc_m
     &             /(epsln + alpha_photo_2d(i,j,bi,bj)*theta_Fe_max)
     &             + irr_mem(i,j,k,bi,bj)/2. _d 0

          light_lim(i,j,k) = ( 1. _d 0 - exp(-irr_eff(i,j,k)
     &               /(epsln + irrk(i,j,k))))

C  Carbon-specific photosynthesis rate

          mu(i,j,k) = Pc_m * light_lim(i,j,k)

#ifdef USE_SIBLING
          mu_diatom(i,j,k) = Pc_m_diatom * light_lim(i,j,k)
#endif

C  Temperature threshold for diazotrophs

          IF (theta(i,j,k,bi,bj) .gt. 14) THEN
           mu_diaz(i,j,k) = Pc_m_diaz * light_lim(i,j,k)
          ELSE
           mu_diaz(i,j,k) = 0. _d 0
          ENDIF

C  Stoichiometry

          PtoN(i,j,k) = PtoN_min + (PtoN_max - PtoN_min) *
     &                  PTR_PO4(i,j,k) / (k_PtoN + PTR_PO4(i,j,k))

          FetoN(i,j,k) = FetoN_min + (FetoN_max - FetoN_min) *
     &                   PTR_FE(i,j,k) / (k_FetoN + PTR_FE(i,j,k))

#ifdef USE_SIBLING
C  Si uptake by diatoms varies with both Si-limitation and growth-rate
C  limitation by other factors: increasing Si limitation decreases Si
C  uptake, but growth limitation by other factors under high Si conditions
C  results in increase Si:P of uptake.

          SitoN_uptake(i,j,k) = min(SitoN_uptake_max,
     &                   Si_lim(i,j,k) * max(SitoN_uptake_min,
     &                   (1. / epsln + SitoN_uptake_scale + min(
     &                   PO4_lim(i,j,k), Fe_lim(i,j,k) ) * (1. -
     &              exp(-irr_eff(i,j,k)/(epsln + irrk(i,j,k) )) ))
     &                   **SitoN_uptake_exp))
#endif

C  Nutrient uptake

          N_uptake(i,j,k) = mu(i,j,k) * (Phy_sm_local(i,j,k)
     &                      + Phy_lg_local(i,j,k))

#ifdef SIZE_DEP_LIM
          Pc_m_sm = Pc_0_2d(i,j,bi,bj) * expkT(i,j,k)
     &           * min(NO3_lim_sm(i,j,k), PO4_lim_sm(i,j,k),
     &           Fe_lim_sm(i,j,k)) * maskC(i,j,k,bi,bj)

          Pc_m_lg = Pc_0_2d(i,j,bi,bj) * expkT(i,j,k)
     &           * min(NO3_lim_lg(i,j,k), PO4_lim_lg(i,j,k),
     &           Fe_lim_lg(i,j,k)) * maskC(i,j,k,bi,bj)

          light_lim_sm(i,j,k) = light_lim(i,j,k)

          light_lim_lg(i,j,k) = light_lim(i,j,k)

          mu_sm(i,j,k) = Pc_m_sm * light_lim_sm(i,j,k)
          mu_lg(i,j,k) = Pc_m_lg * light_lim_lg(i,j,k)

          N_uptake(i,j,k) = mu_sm(i,j,k) * Phy_sm_local(i,j,k)
     &                      + mu_lg(i,j,k) * Phy_lg_local(i,j,k)
#endif /* SIZE_DEP_LIM */

          N_fix(i,j,k) = mu_diaz(i,j,k) * Phy_diaz_local(i,j,k)

          P_uptake(i,j,k) = (N_uptake(i,j,k) +
     &                      N_fix(i,j,k)) * PtoN(i,j,k)

          Fe_uptake(i,j,k) = (N_uptake(i,j,k) +
     &                       N_fix(i,j,k)) * FetoN(i,j,k)

#ifdef USE_SIBLING
          Si_uptake(i,j,k) = mu(i,j,k) * Phy_diatom_local(i,j,k)
     &                       * SitoN_uptake(i,j,k)
#endif

C  Calcium carbonate production

C  Alkalinity is consumed through the production of CaCO3. Here, this is
C  simply a linear function of the implied growth rate of small
C  phytoplankton, which gave a reasonably good fit to the global
C  observational synthesis of Dunne (2009). This is consistent
C  with the findings of Jin et al. (GBC,2006).

#ifdef SIZE_DEP_LIM
          CaCO3_uptake(i,j,k) = mu_sm(i,j,k) * Phy_sm_local(i,j,k)
     &                          * phi_sm_2d(i,j,bi,bj) * CatoN
#else
          CaCO3_uptake(i,j,k) = mu(i,j,k) * Phy_sm_local(i,j,k)
     &                          * phi_sm_2d(i,j,bi,bj) * CatoN
#endif

         ENDIF
        ENDDO
       ENDDO
      ENDDO

C ---------------------------------------------------------------------
C  Grazing is treated using the size-dependent grazing laws of
C  Dunne et al. (GBC, 2005), with alpha=1/3 (eq. 5b):
C   lambda_small = lambda0 * e^kT * (small/pivotal)
C   lambda_large = lambda0 * e^hT * (large/pivotal)^alpha
C  where small/large are the biomasses of small and large phytoplankton,
C  and lambda is mortality. The constants were determined empirically
C  from a global dataset.
C  Basically, small phytoplankton have a linear increase in mortality
C  with biomass, reflecting the rapid increase of small zooplankton as
C  growth rates increase, while large zooplankton respond weakly to
C  increases in the growth rates of large phytoplankton. This produces
C  a simple bloom dynamic.
C  Because diazotrophs have specialized grazers (O'Neil and Roman, 1992;
C  Mulholland, Biogeosciences 2007), they are treated independently from
C  other phytoplankton. This has an important impact, reducing direct
C  competition between diazotrophs and other phytoplankton.
C  Note that the phytoplankton concentrations here are not part of the
C  conserved nutrient pools: they are only used to keep track of the
C  biomass, which is required to calculate the uptake fluxes.

      DO k=1,Nr
       DO j=jmin,jmax
        DO i=imin,imax
         IF ( maskC(i,j,k,bi,bj).EQ.oneRS ) THEN

          Phy_lg_local(i,j,k) = Phy_lg_local(i,j,k) +
     &                Phy_lg_local(i,j,k)*(mu(i,j,k) - lambda_0
     &                * expkT(i,j,k) *
     &                (Phy_lg_local(i,j,k)/pivotal)**(1. / 3.))
     &                * PTRACERS_dTLev(k)

          Phy_sm_local(i,j,k) = Phy_sm_local(i,j,k) +
     &                Phy_sm_local(i,j,k)*(mu(i,j,k) - lambda_0
     &                * expkT(i,j,k) * (Phy_sm_local(i,j,k)/pivotal))
     &                * PTRACERS_dTLev(k)

          Phy_diaz_local(i,j,k) = Phy_diaz_local(i,j,k) +
     &                Phy_diaz_local(i,j,k)*(mu_diaz(i,j,k)-20*lambda_0
     &                * expkT(i,j,k) * (Phy_diaz_local(i,j,k)/pivotal))
     &                * PTRACERS_dTLev(k)

#ifdef ALLOW_AUTODIFF
C     avoid recomputation warnings
         ENDIF
        ENDDO
       ENDDO
      ENDDO
#ifdef ALLOW_AUTODIFF_TAMC
C     These stores avoid some recomputations, but may not be worth it.
cCADJ STORE Phy_sm_local   = comlev1_bibj, key=tkey, kind=isbyte
cCADJ STORE Phy_lg_local   = comlev1_bibj, key=tkey, kind=isbyte
cCADJ STORE Phy_diaz_local = comlev1_bibj, key=tkey, kind=isbyte
#endif
      DO k=1,Nr
       DO j=jmin,jmax
        DO i=imin,imax
         IF ( maskC(i,j,k,bi,bj).EQ.oneRS ) THEN
#endif
           Phy_lg_local(i,j,k) =  max( epsln, Phy_lg_local(i,j,k) )
           Phy_sm_local(i,j,k) =  max( epsln, Phy_sm_local(i,j,k) )
           Phy_diaz_local(i,j,k) =  max( epsln, Phy_diaz_local(i,j,k) )
         ENDIF
        ENDDO
       ENDDO
      ENDDO

#if ( defined SIZE_DEP_LIM || defined USE_SIBLING )
# ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE Phy_sm_local   = comlev1_bibj, key=tkey, kind=isbyte
CADJ STORE Phy_lg_local   = comlev1_bibj, key=tkey, kind=isbyte
CADJ STORE Phy_diaz_local = comlev1_bibj, key=tkey, kind=isbyte
# endif
      DO k=1,Nr
       DO j=jmin,jmax
        DO i=imin,imax
         IF ( maskC(i,j,k,bi,bj).EQ.oneRS ) THEN
# ifdef SIZE_DEP_LIM

          Phy_lg_local(i,j,k) = Phy_lg_local(i,j,k) +
     &                Phy_lg_local(i,j,k)*(mu_lg(i,j,k) - lambda_0
     &                * expkT(i,j,k) *
     &                (Phy_lg_local(i,j,k)/pivotal)**(1. / 3.))
     &                * PTRACERS_dTLev(k)

          Phy_sm_local(i,j,k) = Phy_sm_local(i,j,k) +
     &                Phy_sm_local(i,j,k)*(mu_sm(i,j,k) - lambda_0
     &                * expkT(i,j,k) * (Phy_sm_local(i,j,k)/pivotal))
     &                * PTRACERS_dTLev(k)

# endif

# ifdef USE_SIBLING
C  For now: assuming that all large phyto are diatoms
C  Another option would be to have a separate diatom population and give
C  them a higher growth rate to be competitive. Would also need to add
C  a global variable "phyto_diatom"
          Phy_diatom_local(i,j,k) = Phy_lg_local(i,j,k)

c          Phy_diatom_local(i,j,k) = Phy_diatom_local(i,j,k) +
c     &                Phy_diatom_local(i,j,k)*(mu_diatom(i,j,k)-lambda_0
c     &                * expkT(i,j,k) * (Phy_diatom_local(i,j,k)/pivotal))
c     &                * PTRACERS_dTLev(k)
# endif

         ENDIF
        ENDDO
       ENDDO
      ENDDO
#endif /* SIZE_DEP_LIM or USE_SIBLING */

C  Separate loop for adjoint stores
#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE Phy_sm_local   = comlev1_bibj, key=tkey, kind=isbyte
CADJ STORE Phy_lg_local   = comlev1_bibj, key=tkey, kind=isbyte
CADJ STORE Phy_diaz_local = comlev1_bibj, key=tkey, kind=isbyte
#endif

      DO k=1,Nr
       DO j=jmin,jmax
        DO i=imin,imax

         IF ( maskC(i,j,k,bi,bj).EQ.oneRS ) THEN

#ifdef ADVECT_PHYTO
C  update tracer here
          PTR_PHY(i,j,k) = Phy_lg_local(i,j,k) + Phy_sm_local(i,j,k)
     &                     + Phy_diaz_local(i,j,k)
C  update fractional abundance
          phyto_lg(i,j,k,bi,bj) = Phy_lg_local(i,j,k)/PTR_PHY(i,j,k)
          phyto_sm(i,j,k,bi,bj) = Phy_sm_local(i,j,k)/PTR_PHY(i,j,k)
          phyto_diaz(i,j,k,bi,bj) = Phy_diaz_local(i,j,k)/PTR_PHY(i,j,k)
#else
C  update biomass
          phyto_lg(i,j,k,bi,bj) = Phy_lg_local(i,j,k)
          phyto_sm(i,j,k,bi,bj) = Phy_sm_local(i,j,k)
          phyto_diaz(i,j,k,bi,bj) = Phy_diaz_local(i,j,k)
#endif

C  use the diagnostic biomass to calculate the chl concentration
C  in mg/m3 (carbon = 12.01 g/mol)

          chl(i,j,k,bi,bj) = max(chl_min, CtoN * 12.01 * 1. _d 3 *
     &           theta_Fe(i,j,k) *
     &           (Phy_lg_local(i,j,k) + Phy_sm_local(i,j,k)
     &           + Phy_diaz_local(i,j,k)))

         ENDIF
        ENDDO
       ENDDO
      ENDDO
#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE phyto_sm(:,:,:,bi,bj)   = comlev1_bibj, key=tkey, kind=isbyte
CADJ STORE phyto_lg(:,:,:,bi,bj)   = comlev1_bibj, key=tkey, kind=isbyte
CADJ STORE phyto_diaz(:,:,:,bi,bj) = comlev1_bibj, key=tkey, kind=isbyte
#endif

C ---------------------------------------------------------------------
C  Partitioning between organic pools

C  The uptake of nutrients is assumed to contribute to the growth of
C  phytoplankton, which subsequently die and are consumed by heterotrophs.
C  This can involve the transfer of nutrient elements between many
C  organic pools, both particulate and dissolved, with complex histories.
C  We take a simple approach here, partitioning the total uptake into two
C  fractions - sinking and non-sinking - as a function of temperature,
C  following Dunne et al. (2005).
C  Then, the non-sinking fraction is further subdivided, such that the
C  majority is recycled instantaneously to the inorganic nutrient pool,
C  representing the fast turnover of labile dissolved organic matter via
C  the microbial loop, and the remainder is converted to semi-labile
C  dissolved organic matter. Iron and macro-nutrient are treated
C  identically for the first step, but all iron is recycled
C  instantaneously in the second step (i.e. there is no dissolved organic
C  iron pool).
C  Assume that the fraction of uptake that produces sinking particulate
C  organic matter is the same for diazotrophic and non-diazotrophic
C  phytoplankton.

      DO k=1,Nr
       DO j=jmin,jmax
        DO i=imin,imax

         IF ( maskC(i,j,k,bi,bj).EQ.oneRS ) THEN

C  sinking fraction: particulate organic matter

#ifdef NEW_FRAC_EXP
C  Fraction that does into POM is
C  (assume diaz has same export frac as small phyto)
C  e^kT * [phi_lg * B_lg/Btot + phi_sm * B_sm/Btot + phi_sm * Bdiaz/Bto]

          frac_exp = (phi_sm_2d(i,j,bi,bj) * (phyto_sm(i,j,k,bi,bj) +
     &      phyto_diaz(i,j,k,bi,bj)) + phi_lg_2d(i,j,bi,bj) *
     &      phyto_lg(i,j,k,bi,bj)) /
     &      (phyto_sm(i,j,k,bi,bj) + phyto_diaz(i,j,k,bi,bj) +
     &      phyto_lg(i,j,k,bi,bj)) *
     &      exp(kappa_remin * theta(i,j,k,bi,bj))

#else

C  This is from blingv1, where B_sm and B_lg are diagnosed from
C  the value of mu...
          frac_exp = (phi_sm_2d(i,j,bi,bj) + phi_lg_2d(i,j,bi,bj) *
     &           (mu(i,j,k)/(epsln + lambda_0*expkT(i,j,k)))**2)/
     &           (1. + (mu(i,j,k)/
     &           (epsln + lambda_0*expkT(i,j,k)))**2)*
     &           exp(kappa_remin * theta(i,j,k,bi,bj))

#endif

#ifdef USE_BLING_DVM
          N_dvm(i,j,k) = phi_dvm * frac_exp *
     &             (N_uptake(i,j,k) + N_fix(i,j,k))

          P_dvm(i,j,k) = phi_dvm * frac_exp * P_uptake(i,j,k)

          Fe_dvm(i,j,k) = phi_dvm * frac_exp * Fe_uptake(i,j,k)

          N_spm(i,j,k) = frac_exp * (1.0 - phi_dvm) *
     &                 (N_uptake(i,j,k) + N_fix(i,j,k))

          P_spm(i,j,k) = frac_exp * (1.0 - phi_dvm) *
     &                 P_uptake(i,j,k)

          Fe_spm(i,j,k) = frac_exp * (1.0 - phi_dvm) *
     &                  Fe_uptake(i,j,k)
#else
          N_spm(i,j,k) = frac_exp * (N_uptake(i,j,k) + N_fix(i,j,k))
          P_spm(i,j,k) = frac_exp * P_uptake(i,j,k)
          Fe_spm(i,j,k) = frac_exp * Fe_uptake(i,j,k)

          N_dvm(i,j,k) = 0
          P_dvm(i,j,k) = 0
          Fe_dvm(i,j,k) = 0
#endif

C  the remainder is divided between instantaneously recycled and
C  long-lived dissolved organic matter.

          DON_prod(i,j,k) = phi_DOM_2d(i,j,bi,bj)*(N_uptake(i,j,k)
     &                      + N_fix(i,j,k) - N_spm(i,j,k)
     &                      - N_dvm(i,j,k))

          DOP_prod(i,j,k) = phi_DOM_2d(i,j,bi,bj)*(P_uptake(i,j,k)
     &                      - P_spm(i,j,k) - P_dvm(i,j,k))

          N_recycle(i,j,k) = N_uptake(i,j,k) + N_fix(i,j,k)
     &                       - N_spm(i,j,k) - DON_prod(i,j,k)
     &                       - N_dvm(i,j,k)

          P_recycle(i,j,k) = P_uptake(i,j,k)
     &                       - P_spm(i,j,k) - DOP_prod(i,j,k)
     &                       - P_dvm(i,j,k)

          Fe_recycle(i,j,k) = Fe_uptake(i,j,k)
     &                        - Fe_spm(i,j,k) - Fe_dvm(i,j,k)

#ifdef USE_SIBLING
          frac_diss_Si(i,j,k) = exp(-SitoN_uptake(i,j,k) /
     &                        (q_SitoN_diss *
     &                        exp(kappa_remin_Si * theta(i,j,k,bi,bj))))

          Si_recycle(i,j,k) = Si_uptake(i,j,k) * frac_diss_Si(i,j,k)

          Si_spm(i,j,k) = Si_uptake(i,j,k) - Si_recycle(i,j,k)
#endif

         ENDIF

        ENDDO
       ENDDO
      ENDDO

CML#ifdef ALLOW_AUTODIFF_TAMC
CMLC     these stores avoid recomputing the previous loop, but avoiding
CMLC     that may not be necessary
CMLCADJ STORE N_spm     = comlev1_bibj, key = tkey, kind = isbyte
CMLCADJ STORE P_spm     = comlev1_bibj, key = tkey, kind = isbyte
CMLCADJ STORE Fe_spm    = comlev1_bibj, key = tkey, kind = isbyte
CMLCADJ STORE don_prod  = comlev1_bibj, key = tkey, kind = isbyte
CMLCADJ STORE n_recycle = comlev1_bibj, key = tkey, kind = isbyte
CML#endif

C ---------------------------------------------------------------------
C  Remineralization
C  In general, the flux at the bottom of a grid cell should equal
C  Fb = (Ft + Prod*dz) / (1 + zremin*dz)
C  where Ft is the flux at the top, and prod*dz is the integrated
C  production of new sinking particles within the layer.
C  This is also multiplied by the fraction of the grid cell that is
C  not intercepted by the bottom at this level, according to the
C  subgridscale sediment interception fraction.
C  Since Ft=0 in the first layer,

C$TAF LOOP = parallel
      DO j=jmin,jmax
C$TAF LOOP = parallel
       DO i=imin,imax

C  Initialize upper flux

        PONflux_u            = 0. _d 0
        POPflux_u            = 0. _d 0
        PFEflux_u            = 0. _d 0
        CaCO3flux_u          = 0. _d 0
#ifdef USE_SIBLING
        Siflux_u             = 0. _d 0
#endif

        DO k=1,Nr
#ifdef ALLOW_AUTODIFF_TAMC
         ijkkey = k + ( (i-1) + (j-1) * (2*OLx+sNx) ) * Nr
     &          + (tkey - 1) * (2*OLx+sNx) * (2*OLy+sNy) * Nr
CADJ STORE PONflux_u   = comlev1_bibj_ijk, key = ijkkey, kind = isbyte
CADJ STORE POPflux_u   = comlev1_bibj_ijk, key = ijkkey, kind = isbyte
CADJ STORE PFEflux_u   = comlev1_bibj_ijk, key = ijkkey, kind = isbyte
CADJ STORE CaCO3flux_u = comlev1_bibj_ijk, key = ijkkey, kind = isbyte
# ifdef USE_SIBLING
CADJ STORE Siflux_u    = comlev1_bibj_ijk, key = ijkkey, kind = isbyte
# endif
#endif

C  Initialization here helps taf

         Fe_ads_org(i,j,k)    = 0. _d 0

         IF ( maskC(i,j,k,bi,bj).EQ.oneRS ) THEN

C  Calculate the remineralization lengthscale matrix, zremin, a function
C  of z. Sinking rate (wsink) is constant over the upper wsink0_z metres,
C  then  increases linearly with depth.
C  The remineralization rate is a function of oxygen concentrations,
C  following a Holling type 2 dependence, decreasing to a minimum value
C  of remin_min. This is ad hoc, following work by Bianchi, Sarmiento,
C  Galbraith and Kwon (unpublished).
C  Sinking speed is evaluated at the bottom of the cell

          depth_l=-rF(k+1)
          IF (depth_l .LE. wsink0z)  THEN
           wsink = wsink0_2d(i,j,bi,bj)
          ELSE
           wsink = wsinkacc * (depth_l - wsink0z) + wsink0_2d(i,j,bi,bj)
          ENDIF

          zremin = gamma_POM_2d(i,j,bi,bj) * ( PTR_O2(i,j,k)**2 /
     &               (k_O2**2 + PTR_O2(i,j,k)**2) * (1-remin_min)
     &               + remin_min )/(wsink + epsln)

C  Calcium remineralization relaxed toward the inverse of the
C  ca_remin_depth constant value as the calcite saturation approaches 0.

          zremin_caco3 = 1. _d 0/ca_remin_depth*(1. _d 0 - min(1. _d 0,
     &               omegaC(i,j,k,bi,bj) + epsln ))

#ifdef USE_SIBLING
          zremin_Si = gamma_Si_0 / wsink_Si
#endif

C  POM flux leaving the cell

          PONflux_l = (PONflux_u+N_spm(i,j,k)*drF(k)
     &           *hFacC(i,j,k,bi,bj))/(1+zremin*drF(k)
     &           *hFacC(i,j,k,bi,bj))

          POPflux_l = (POPflux_u+P_spm(i,j,k)*drF(k)
     &           *hFacC(i,j,k,bi,bj))/(1+zremin*drF(k)
     &           *hFacC(i,j,k,bi,bj))

C  CaCO3 flux leaving the cell

          CaCO3flux_l = (caco3flux_u+CaCO3_uptake(i,j,k)*drF(k)
     &           *hFacC(i,j,k,bi,bj))/(1+zremin_caco3*drF(k)
     &           *hFacC(i,j,k,bi,bj))

#ifdef USE_SIBLING
          Siflux_l = (Siflux_u+Si_spm(i,j,k)*drF(k)
     &           *hFacC(i,j,k,bi,bj))/(1+zremin_Si*drF(k)
     &           *hFacC(i,j,k,bi,bj))
#endif

C  Check if we are not a bottom cell

          IF ( k.NE.kLowC(i,j,bi,bj) ) THEN
C  Start with cells that are not the deepest cells

C  Nutrient accumulation in a cell is given by the biological production
C  (and instant remineralization) of particulate organic matter
C  plus flux thought upper interface minus flux through lower interface.
C  (Since not deepest cell: hFacC=1)

           N_reminp(i,j,k) = (PONflux_u + N_spm(i,j,k)*drF(k)
     &                    - PONflux_l)*recip_drF(k)

           P_reminp(i,j,k) = (POPflux_u + P_spm(i,j,k)*drF(k)
     &                    - POPflux_l)*recip_drF(k)

           CaCO3_diss(i,j,k) = (CaCO3flux_u + CaCO3_uptake(i,j,k)
     &                    *drF(k) - CaCO3flux_l)*recip_drF(k)

#ifdef USE_SIBLING
           Si_reminp(i,j,k) = (Siflux_u + Si_spm(i,j,k)*drF(k)
     &                     - Siflux_l)*recip_drF(k)
#endif

           Fe_sed(i,j,k) = 0. _d 0

          ELSE
C  Now do bottom layer

C  If this layer is adjacent to bottom topography or it is the deepest
C  cell of the domain, then remineralize/dissolve in this grid cell
C  i.e. do not subtract off lower boundary fluxes when calculating remin

           N_reminp(i,j,k) = PONflux_u*recip_drF(k)
     &                    *recip_hFacC(i,j,k,bi,bj) + N_spm(i,j,k)

           P_reminp(i,j,k) = POPflux_u*recip_drF(k)
     &                    *recip_hFacC(i,j,k,bi,bj) + P_spm(i,j,k)

           CaCO3_diss(i,j,k) = CaCO3flux_u*recip_drF(k)
     &                  *recip_hFacC(i,j,k,bi,bj) + CaCO3_uptake(i,j,k)

#ifdef USE_SIBLING
           Si_reminp(i,j,k) = Siflux_u*recip_drF(k)
     &                  *recip_hFacC(i,j,k,bi,bj) + Si_spm(i,j,k)
#endif

C  Efflux Fed out of sediments
C  The phosphate flux hitting the bottom boundary
C  is used to scale the return of iron to the water column.
C  Maximum value added for numerical stability.

           POC_sed = PONflux_l * CtoN

           Fe_sed(i,j,k) = max(epsln, FetoC_sed * POC_sed * recip_drF(k)
     &            *recip_hFacC(i,j,k,bi,bj))

           log_btm_flx = 1. _d -20

CMM: this is causing instability in the adjoint. Needs debugging
#ifndef BLING_ADJOINT_SAFE
           IF (POC_sed .gt. 0. _d 0) THEN

C  Convert from mol N m-2 s-1 to umol C cm-2 d-1 and take the log

            log_btm_flx = log10(min(43.0 _d 0, POC_sed *
     &           86400. _d 0 * 100.0 _d 0))

C  Metamodel gives units of umol C cm-2 d-1, convert to mol N m-2 s-1 and
C  multiply by no3_2_n to give NO3 consumption rate

            N_den_benthic(i,j,k) = min (POC_sed * NO3toN / CtoN,
     &         (10 _d 0)**(-0.9543 _d 0 + 0.7662 _d 0 *
     &         log_btm_flx - 0.235 _d 0 * log_btm_flx * log_btm_flx)
     &         / (CtoN * 86400. _d 0 * 100.0 _d 0) * NO3toN *
     &         PTR_NO3(i,j,k) / (k_no3 + PTR_NO3(i,j,k)) ) *
     &         recip_drF(k)

           ENDIF
#endif

C  ---------------------------------------------------------------------
C  Calculate external bottom fluxes. Positive fluxes
C  are into the water column from the seafloor. For P, the bottom flux puts
C  the sinking flux reaching the bottom cell into the water column through
C  diffusion. For iron, the sinking flux disappears into the sediments if
C  bottom waters are oxic (assumed adsorbed as oxides). If bottom waters are
C  anoxic, the sinking flux of Fe is returned to the water column.
C
C  For oxygen, the consumption of oxidant required to respire the settling flux
C  of organic matter (in support of the no3 bottom flux) diffuses from the
C  bottom water into the sediment.

C  Assume all NO3 for benthic denitrification is supplied from the bottom water,
C  and that all organic N is also consumed under denitrification (Complete
C  Denitrification, sensu Paulmier, Biogeosciences 2009). Therefore, no NO3 is
C  regenerated from organic matter respired by benthic denitrification
C  (necessitating the second term in b_no3).

           NO3_btmflx(i,j) = PONflux_l*drF(k)*hFacC(i,j,k,bi,bj)
     &                   - N_den_benthic(i,j,k) / NO3toN

           PO4_btmflx(i,j) = POPflux_l*drF(k)*hFacC(i,j,k,bi,bj)

C  Oxygen flux into sediments is that required to support non-denitrification
C  respiration, assuming a 4/5 oxidant ratio of O2 to NO3. Oxygen consumption
C  is allowed to continue at negative oxygen concentrations, representing
C  sulphate reduction.

           O2_btmflx(i,j) = -( O2toN*PONflux_l*drF(k)*hFacC(i,j,k,bi,bj)
     &                  - N_den_benthic(i,j,k)* 1.25)

          ENDIF

C  Calculate free and inorganically associated iron concentration for
C  scavenging. We assume that there is a spectrum of iron ligands present
C  in seawater, with  varying binding strengths and whose composition
C  varies with light and iron concentrations. For example,
C  photodissocation of ligand complexes occurs under bright light,
C  weakening the binding strength (e.g. Barbeau et al., Nature 2001),
C  while at very low iron concentrations (order kfe_eq_lig_femin),
C  siderophores are thought to be produced as a response to extreme iron
C  stress. In anoxic waters, iron should be reduced, and therefore mostly
C  immune to scavenging; therefore, the feprime calculation is not made
C  if oxygen is less than 0.

          kFe_eq_lig = kFe_eq_lig_max-(kFe_eq_lig_max-kFe_eq_lig_min)
     &             *(irr_inst(i,j,k)**2
     &             /(kFe_eq_lig_irr**2+irr_inst(i,j,k)**2))
     &             *max(epsln,min(1. _d 0,(PTR_FE(i,j,k)
     &             -kFe_eq_lig_Femin)/
     &             (PTR_FE(i,j,k)+epsln)*1.2 _d 0))

          FreeFe = (-(1+kFe_eq_lig*(ligand-PTR_FE(i,j,k)))
     &            +((1+kFe_eq_lig*(ligand-PTR_FE(i,j,k)))**2+4*
     &            kFe_eq_lig*PTR_FE(i,j,k))**(0.5))/(2*
     &            kFe_eq_lig)

          IF (PTR_O2(i,j,k) .LT. oxic_min)  THEN
           FreeFe = 0. _d 0
          ENDIF

          Fe_ads_inorg(i,j,k) =
     &       kFe_inorg*(max(1. _d -8,FreeFe))**(1.5)

C  Calculate the Fe adsorption using this PONflux_l:
C  The absolute first order rate constant is calculated from the
C  concentration of organic particles, after Parekh et al. (2005).
C  (Galbraith's code limits the value to 1/2dt for numerical stability).

          IF ( PONflux_l .GT. 0. _d 0 ) THEN
            Fe_ads_org(i,j,k) =
     &           kFE_org*(PONflux_l/(epsln + wsink)
     &             * MasstoN)**(0.58)*FreeFe
          ENDIF

          PFEflux_l = (PFEflux_u+(Fe_spm(i,j,k)+Fe_ads_inorg(i,j,k)
     &            +Fe_ads_org(i,j,k))*drF(k)
     &            *hFacC(i,j,k,bi,bj))/(1+zremin*drF(k)
     &            *hFacC(i,j,k,bi,bj))

C  Added the burial flux of sinking particulate iron here as a
C  diagnostic, needed to calculate mass balance of iron.
C  this is calculated last for the deepest cell

          Fe_burial(i,j) = PFEflux_l

          IF ( PTR_O2(i,j,k) .LT. oxic_min ) THEN
            PFEflux_l = 0. _d 0
          ENDIF

          Fe_reminp(i,j,k) = (PFEflux_u+(Fe_spm(i,j,k)
     &            +Fe_ads_inorg(i,j,k)
     &            +Fe_ads_org(i,j,k))*drF(k)
     &            *hFacC(i,j,k,bi,bj)-PFEflux_l)*recip_drF(k)
     &            *recip_hFacC(i,j,k,bi,bj)

          Fe_reminsum(i,j,k) = Fe_reminp(i,j,k) + Fe_sed(i,j,k)
     &                 - Fe_ads_org(i,j,k) - Fe_ads_inorg(i,j,k)

C  Prepare the tracers for the next layer down

          PONflux_u   = PONflux_l
          POPflux_u   = POPflux_l
          PFEflux_u   = PFEflux_l
          CaCO3flux_u = CaCO3flux_l
#ifdef USE_SIBLING
          Siflux_u    = Siflux_l
#endif

         ENDIF

        ENDDO
       ENDDO
      ENDDO
#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE N_reminp = comlev1_bibj, key=tkey, kind=isbyte
#endif
C-----------------------------------------------------------
C  remineralization from diel vertical migration
#ifdef USE_BLING_DVM

C  DIEL VERTICAL MIGRATOR EXPORT
C  The effect of vertically-migrating animals on the export flux of organic
C  matter from the ocean surface is treated similarly to the scheme of
C  Bianchi et al., Nature Geoscience 2013.
C  This involves calculating the stationary depth of vertical migrators, using
C  an empirical multivariate regression, and ensuring that this remains
C  above the bottom as well as any suboxic waters.
C  The total DVM export flux is partitioned between a swimming migratory
C  component and the stationary component, and these are summed.

C$TAF LOOP = parallel
      DO j=jmin,jmax
C$TAF LOOP = parallel
       DO i=imin,imax

C  Initialize
        o2_upper = 0.
        o2_lower = 0.
        dz_upper = 0.
        dz_lower = 0.
        temp_upper = 0.
        temp_lower = 0.
        z_dvm_regr = 0.
        z_dvm     = 0.
        frac_migr = 0.
        fdvm_migr = 0.
        fdvm_stat = 0.
        fdvmn_vint = 0.
        fdvmp_vint = 0.
        fdvmfe_vint = 0.

        DO k=1,Nr

         IF ( maskC(i,j,k,bi,bj).EQ.oneRS ) THEN

C  Calculate the depth of migration based on linear regression.

          depth_l=-rF(k+1)

C  Average temperature and oxygen over upper 35 m, and 140-515m.
C  Also convert O2 to mmol m-3.

          if ( abs(depth_l) .lt. 35.) then
            dz_upper = dz_upper + drf(k)
            temp_upper = temp_upper + theta(i,j,k,bi,bj)*drf(k)
            o2_upper = o2_upper + PTR_O2(i,j,k) * drf(k)*1.0 _d 3
          endif
          if ( (abs(depth_l) .gt. 140.0 _d 0) .and.
     &          (abs(depth_l) .lt. 515. _d 0)) then
            dz_lower = dz_lower + drf(k)
            temp_lower = temp_lower + theta(i,j,k,bi,bj)*drf(k)
            o2_lower = o2_lower + PTR_O2(i,j,k) * drf(k)*1.0 _d 3
          endif

         ENDIF
        ENDDO

        o2_upper = o2_upper / (epsln + dz_upper)
        temp_upper = temp_upper / (epsln + dz_upper)
        o2_lower = o2_lower / (epsln + dz_lower)
        temp_lower = temp_lower / (epsln + dz_lower)

C  Calculate the regression, using the constants given in Bianchi et al. (2013).
C  The variable values are bounded to lie within reasonable ranges:
C         O2 gradient   : [-10,300] mmol/m3
C         Log10 Chl     : [-1.8,0.85] log10(mg/m3)
C         mld           : [0,500] m
C         T gradient    : [-3,20] C

        z_dvm_regr = 398. _d 0
     &   - 0.56 _d 0*min(300. _d 0,max(-10. _d 0,(o2_upper - o2_lower)))
     &   - 115. _d 0*min(0.85 _d 0,max(-1.80 _d 0,
     &   log10(max(chl(i,j,1,bi,bj),chl_min))))
     &   + 0.36 _d 0*min(500. _d 0,max(epsln,mld(i,j)))
     &   - 2.40 _d 0*min(20. _d 0,max(-3. _d 0,(temp_upper-temp_lower)))

C  Limit the depth of migration in polar winter.
C  Use irr_mem since this is averaged over multiple days, dampening the
C  diurnal cycle.
C  Tapers Z_DVM to the minimum when surface irradince is below a given
C  threshold (here 10 W/m2).

        if ( irr_mem(i,j,1,bi,bj) .lt. 10. ) then
          z_dvm_regr = 150. _d 0 + (z_dvm_regr - 150. _d 0) *
     &       irr_mem(i,j,1,bi,bj) / 10. _d 0
        endif

C  Check for suboxic water within the column. If found, set dvm
C  stationary depth to 2 layers above it. This is not meant to
C  represent a cessation of downward migration, but rather the
C  requirement for aerobic DVM respiration to occur above the suboxic
C  water, where O2 is available.

        tmp_dvm = 0
        DO k=1,Nr-2

         IF ( maskC(i,j,k,bi,bj).EQ.oneRS .AND. tmp_dvm.EQ.0 ) THEN

          z_dvm = -rf(k+1)
          if (PTR_O2(i,j,k+2) .lt. (5. _d 0*oxic_min)) tmp_dvm = 1

         ENDIF

        ENDDO

C  The stationary depth is constrained between 150 and 700, above any
C  anoxic waters found, and above the bottom.

        z_dvm = min(700. _d 0,max(150. _d 0,z_dvm_regr),z_dvm,-rf(k+1))

C  Calculate the fraction of migratory respiration that occurs
C  during upwards and downwards swimming. The remainder is
C  respired near the stationary depth.
C  Constants for swimming speed and resting time are hard-coded
C  after Bianchi et al, Nature Geoscience 2013.

        frac_migr = max( 0.0 _d 0, min( 1.0 _d 0, (2.0 _d 0 * z_dvm) /
     &        (epsln + 0.05 _d 0 * 0.5 _d 0 * 86400. _d 0)))

C  Calculate the vertical profile shapes of DVM fluxes.
C  These are given as the downward organic flux due to migratory
C  DVM remineralization, defined at the bottom of each layer k.

        tmp_dvm = 0
        DO k=1,Nr

         IF ( maskC(i,j,k,bi,bj).EQ.oneRS .AND. tmp_dvm.EQ.0 ) THEN

C  First, calculate the part due to active migration above
C  the stationary depth.
          if (-rf(k+1) .lt. z_dvm) then
            fdvm_migr = frac_migr / (epsln + z_dvm - (-rf(2))) *
     &            (z_dvm - (-rf(k+1)) )
          else
            fdvm_migr  = 0.0
          endif

C  Then, calculate the part at the stationary depth.

C  Approximation of the complementary error function
C  From Numerical Recipes (F90, Ch. 6, p. 216)
C  Returns the complementary error function erfc(x)
C  with fractional error everywhere less than 1.2e-7

          x_erfcc = (-rf(k) - z_dvm) /
     &        ( (epsln + 2. _d 0 * sigma_dvm**2. _d 0)**0.5)

          z_erfcc = abs(x_erfcc)

          t_erfcc = 1. _d 0/(1. _d 0+0.5 _d 0*z_erfcc)

          erfcc = t_erfcc*exp(-z_erfcc*z_erfcc-1.26551223+t_erfcc*
     &       (1.00002368+t_erfcc*(0.37409196+t_erfcc*
     &       (.09678418+t_erfcc*(-.18628806+t_erfcc*(.27886807+
     &       t_erfcc*(-1.13520398+t_erfcc*(1.48851587+
     &       t_erfcc*(-0.82215223+t_erfcc*0.17087277)))))))))

          if (x_erfcc .lt. 0.0) then
            erfcc = 2.0 - erfcc
          endif

          fdvm_stat = (1. _d 0 - frac_migr) / 2. _d 0 * erfcc

C  Add the shapes, resulting in the 3-d DVM flux operator. If the
C  current layer is the bottom layer, or the layer beneath the
C  underlying layer is suboxic, all fluxes at and below the current
C  layer remain at the initialized value of zero. This will cause all
C  remaining DVM remineralization to occur in this layer.

          IF (k.LT.Nr-1) THEN
            if (PTR_O2(i,j,k+2) .lt. (5. _d 0*oxic_min)) tmp_dvm = 1
          ENDIF
c!!          if (k .eq. grid_kmt(i,j)) exit
          dvm(i,j,k)  = fdvm_migr + fdvm_stat

         ENDIF

        ENDDO

C  Sum up the total organic flux to be transported by DVM

        do k = 1, Nr
          fdvmn_vint  = fdvmn_vint  + N_dvm(i,j,k)  * drf(k)
          fdvmp_vint  = fdvmp_vint  + P_dvm(i,j,k)  * drf(k)
          fdvmfe_vint = fdvmfe_vint + Fe_dvm(i,j,k) * drf(k)
        enddo

C  Calculate the remineralization terms as the divergence of the flux

        N_remindvm(i,j,1)  = fdvmn_vint *  (1 - dvm(i,j,1)) /
     &     (epsln + drf(1))
        P_remindvm(i,j,1)  = fdvmp_vint *  (1 - dvm(i,j,1)) /
     &     (epsln + drf(1))
        Fe_remindvm(i,j,1) = fdvmfe_vint * (1 - dvm(i,j,1)) /
     &     (epsln + drf(1))

        do k = 2, Nr
          N_remindvm(i,j,k)  = fdvmn_vint  *
     &       (dvm(i,j,k-1) - dvm(i,j,k)) / (epsln + drf(k))
          P_remindvm(i,j,k)  = fdvmp_vint  *
     &       (dvm(i,j,k-1) - dvm(i,j,k)) / (epsln + drf(k))
          Fe_remindvm(i,j,k) = fdvmfe_vint *
     &       (dvm(i,j,k-1) - dvm(i,j,k)) / (epsln + drf(k))
        enddo

       enddo
      enddo

#endif

C-----------------------------------------------------------

      DO k=1,Nr
       DO j=jmin,jmax
        DO i=imin,imax

         IF ( maskC(i,j,k,bi,bj).EQ.oneRS ) THEN

C  Dissolved organic matter slow remineralization

#ifdef BLING_NO_NEG
          DON_remin(i,j,k) = MAX(maskC(i,j,k,bi,bj)*gamma_DON
     &                       *PTR_DON(i,j,k),0. _d 0)

          DOP_remin(i,j,k) = MAX(maskC(i,j,k,bi,bj)*gamma_DOP
     &                       *PTR_DOP(i,j,k),0. _d 0)
#else
          DON_remin(i,j,k) = maskC(i,j,k,bi,bj)*gamma_DON
     &                       *PTR_DON(i,j,k)

          DOP_remin(i,j,k) = maskC(i,j,k,bi,bj)*gamma_DOP
     &                       *PTR_DOP(i,j,k)
#endif

C  Pelagic denitrification
C  If anoxic

          IF (PTR_O2(i,j,k) .lt. oxic_min) THEN
           IF (PTR_NO3(i,j,k) .gt. oxic_min) THEN
            N_den_pelag(i,j,k) = max(epsln, (NO3toN *
     &                    ((1. _d 0 - phi_DOM_2d(i,j,bi,bj))
     &                    * (N_reminp(i,j,k)
     &                    + N_remindvm(i,j,k)) + DON_remin(i,j,k) +
     &                    N_recycle(i,j,k))) - N_den_benthic(i,j,k))
           ENDIF
          ENDIF

C  oxygen production through photosynthesis

          O2_prod(i,j,k) = O2toN * N_uptake(i,j,k)
     &                     + (O2toN - 1.25 _d 0) * N_fix(i,j,k)

C-----------------------------------------------------------
C  ADD TERMS

C  Nutrients
C  Sum of fast recycling, decay of sinking POM, and decay of DOM,
C  less uptake, (less denitrification).

          G_PO4(i,j,k) = -P_uptake(i,j,k) + P_recycle(i,j,k)
     &                   + (1. _d 0 - phi_DOM_2d(i,j,bi,bj))
     &                   * (P_reminp(i,j,k)
     &                   + P_remindvm(i,j,k)) + DOP_remin(i,j,k)

          G_NO3(i,j,k) = -N_uptake(i,j,k)
          IF (PTR_O2(i,j,k) .lt. oxic_min) THEN
C  Anoxic
           G_NO3(i,j,k) = G_NO3(i,j,k)
     &                    - N_den_pelag(i,j,k) - N_den_benthic(i,j,k)
          ELSE
C  Oxic
           G_NO3(i,j,k) = G_NO3(i,j,k)
     &                   + N_recycle(i,j,k)
     &                   + (1. _d 0 - phi_DOM_2d(i,j,bi,bj))
     &                   * (N_reminp(i,j,k) + N_remindvm(i,j,k))
     &                   + DON_remin(i,j,k)
     &                   - N_den_benthic(i,j,k)
          ENDIF

C  Iron
C  remineralization, sediments and adsorption are all bundled into
C  Fe_reminsum

          G_FE(i,j,k) = -Fe_uptake(i,j,k) + Fe_reminsum(i,j,k)
     &                  + Fe_remindvm(i,j,k) + Fe_recycle(i,j,k)

C  Dissolved Organic Matter
C  A fraction of POM remineralization goes into dissolved pools.

          G_DON(i,j,k) = DON_prod(i,j,k) + phi_DOM_2d(i,j,bi,bj)
     &                   * (N_reminp(i,j,k) + N_remindvm(i,j,k))
     &                   - DON_remin(i,j,k)

          G_DOP(i,j,k) = DOP_prod(i,j,k) + phi_DOM_2d(i,j,bi,bj)
     &                   * (P_reminp(i,j,k) + P_remindvm(i,j,k))
     &                   - DOP_remin(i,j,k)

C  Oxygen:
C  Assuming constant O2:N ratio in terms of oxidant required per mol of
C  organic N. This implies a constant stoichiometry of C:N and H:N (where H is
C  reduced, organic H). Because the N provided by N2 fixation is reduced from
C  N2, rather than NO3-, the o2_2_n_fix is slightly less than the NO3- based
C  ratio (by 1.25 mol O2/ mol N). Account for the organic matter respired
C  through benthic denitrification by subtracting 5/4 times the benthic
C  denitrification NO3 utilization rate from the overall oxygen consumption.

          G_O2(i,j,k) = O2_prod(i,j,k)
C  If oxic
          IF (PTR_O2(i,j,k) .gt. oxic_min) THEN
           G_O2(i,j,k) = G_O2(i,j,k)
     &                  -O2toN * ((1. _d 0 - phi_DOM_2d(i,j,bi,bj))
     &                  * (N_reminp(i,j,k) + N_remindvm(i,j,k))
     &                  + DON_remin(i,j,k) +  N_recycle(i,j,k))
     &                  + N_den_benthic(i,j,k) * 1.25 _d 0
C  If anoxic but NO3 concentration is very low
C  (generate negative O2; proxy for HS-).
          ELSEIF (PTR_NO3(i,j,k) .lt. oxic_min) THEN
           G_O2(i,j,k) = G_O2(i,j,k)
     &                  -O2toN * ((1. _d 0 - phi_DOM_2d(i,j,bi,bj))
     &                  * (N_reminp(i,j,k) + N_remindvm(i,j,k))
     &                  + DON_remin(i,j,k) +  N_recycle(i,j,k))
          ENDIF

#ifdef USE_SIBLING
          G_Si(i,j,k) = -Si_uptake(i,j,k) + Si_recycle(i,j,k)
     &                  + Si_reminp(i,j,k)
#endif

C  Carbon flux diagnostic

          NCP(i,j,k) = (N_uptake(i,j,k) + N_fix(i,j,k)
     &                   - N_recycle(i,j,k)
     &                   - (1. _d 0 - phi_DOM_2d(i,j,bi,bj))
     &                   * (N_reminp(i,j,k) + N_remindvm(i,j,k))
     &                   - DON_remin(i,j,k) ) * CtoN

          G_CaCO3(i,j,k) = CaCO3_diss(i,j,k) - CaCO3_uptake(i,j,k)

          G_ALK(i,j,k) = - G_NO3(i,j,k)
     &              + 2. _d 0*G_CaCO3(i,j,k)

          G_DIC(i,j,k) = -NCP(i,j,k) + G_CaCO3(i,j,k)

C  for diagnostics: convert to mol C/m3

          Phy_lg_local(i,j,k) = Phy_lg_local(i,j,k) * CtoN
          Phy_sm_local(i,j,k) = Phy_sm_local(i,j,k) * CtoN
          Phy_diaz_local(i,j,k) = Phy_diaz_local(i,j,k) * CtoN

C  for constraints determine POC, assuming that phytoplankton carbon
C  is 30% of POC

          poc(i,j,k,bi,bj) = (Phy_lg_local(i,j,k) + Phy_sm_local(i,j,k)
     &                 + Phy_diaz_local(i,j,k) ) * CtoN * 3.33333 _d 0

         ENDIF

        ENDDO
       ENDDO
      ENDDO

C ---------------------------------------------------------------------

#ifdef ALLOW_DIAGNOSTICS
      IF ( useDiagnostics ) THEN

      DO k=1,Nr
       DO j=jmin,jmax
        DO i=imin,imax

         IF ( maskC(i,j,k,bi,bj).EQ.oneRS ) THEN

          NPP(i,j,k) = (N_uptake(i,j,k) + N_fix(i,j,k)) * CtoN

c  for diagnostics: convert biomass to mol C/m3

          Phy_lg_local(i,j,k) = Phy_lg_local(i,j,k) * CtoN
          Phy_sm_local(i,j,k) = Phy_sm_local(i,j,k) * CtoN
          Phy_diaz_local(i,j,k) = Phy_diaz_local(i,j,k) * CtoN

c  Carbon flux diagnostic

          POC_flux(i,j,k) = CtoN * N_spm(i,j,k)

c  C:Chl ratio in g C / g Chl

          IF ( theta_Fe(i,j,k).EQ.zeroRL ) THEN
             theta_Fe_inv(i,j,k) = 0. _d 0
          ELSE
             theta_Fe_inv(i,j,k) = oneRL/theta_Fe(i,j,k)
          ENDIF

         ELSE
             NPP(i,j,k) = 0. _d 0
             Phy_lg_local(i,j,k) = 0. _d 0
             Phy_sm_local(i,j,k) = 0. _d 0
             Phy_diaz_local(i,j,k) = 0. _d 0
             POC_flux(i,j,k) = 0. _d 0
             theta_Fe_inv(i,j,k) = 0. _d 0
         ENDIF

        ENDDO
       ENDDO
      ENDDO

C 3d global variables
        CALL DIAGNOSTICS_FILL(chl,    'BLGCHL  ',0,Nr,1,bi,bj,myThid)
        CALL DIAGNOSTICS_FILL(poc,    'BLGPOC  ',0,Nr,1,bi,bj,myThid)
        CALL DIAGNOSTICS_FILL(irr_mem,'BLGIMEM ',0,Nr,1,bi,bj,myThid)
C 3d local variables
        CALL DIAGNOSTICS_FILL(G_DIC   ,'BLGBIOC ',0,Nr,2,bi,bj,myThid)
        CALL DIAGNOSTICS_FILL(G_ALK   ,'BLGBIOAL',0,Nr,2,bi,bj,myThid)
        CALL DIAGNOSTICS_FILL(G_O2    ,'BLGBIOO2',0,Nr,2,bi,bj,myThid)
        CALL DIAGNOSTICS_FILL(G_Fe    ,'BLGBIOFE',0,Nr,2,bi,bj,myThid)
        CALL DIAGNOSTICS_FILL(G_PO4   ,'BLGBIOP ',0,Nr,2,bi,bj,myThid)
        CALL DIAGNOSTICS_FILL(G_NO3   ,'BLGBION ',0,Nr,2,bi,bj,myThid)
        CALL DIAGNOSTICS_FILL(Phy_sm_local,'BLGPSM  ',0,Nr,2,bi,bj,
     &       myThid)
        CALL DIAGNOSTICS_FILL(Phy_lg_local,'BLGPLG  ',0,Nr,2,bi,bj,
     &       myThid)
        CALL DIAGNOSTICS_FILL(Phy_diaz_local,'BLGPDIA ',0,Nr,2,bi,bj,
     &       myThid)
        CALL DIAGNOSTICS_FILL(irrk,    'BLGIRRK ',0,Nr,2,bi,bj,myThid)
        CALL DIAGNOSTICS_FILL(irr_eff, 'BLGIEFF ',0,Nr,2,bi,bj,myThid)
        CALL DIAGNOSTICS_FILL(irr_inst,'BLGIRRIS',0,Nr,2,bi,bj,myThid)
        CALL DIAGNOSTICS_FILL(theta_Fe,'BLGCHL2C',0,Nr,2,bi,bj,myThid)
        CALL DIAGNOSTICS_FILL(theta_Fe_inv,'BLGC2CHL',0,Nr,2,bi,bj,
     &       myThid)
        CALL DIAGNOSTICS_FILL(Fe_lim,  'BLGFELIM',0,Nr,2,bi,bj,myThid)
        CALL DIAGNOSTICS_FILL(NO3_lim, 'BLGNLIM ',0,Nr,2,bi,bj,myThid)
        CALL DIAGNOSTICS_FILL(PO4_lim, 'BLGPLIM ',0,Nr,2,bi,bj,myThid)
#ifdef USE_SIBLING
        CALL DIAGNOSTICS_FILL(G_SI    ,'BLGBIOSI',0,Nr,2,bi,bj,myThid)
        CALL DIAGNOSTICS_FILL(Si_lim,  'BLGSILIM',0,Nr,2,bi,bj,myThid)
        CALL DIAGNOSTICS_FILL(Si_uptake,'BLGSIUP ',0,Nr,2,bi,bj,myThid)
        CALL DIAGNOSTICS_FILL(Si_recycle,'BLGSIREC',0,Nr,2,bi,bj,myThid)
        CALL DIAGNOSTICS_FILL(Si_reminp,'BLGSIREM',0,Nr,2,bi,bj,myThid)
        CALL DIAGNOSTICS_FILL(SitoN_uptake,'BLGSI2N ',0,Nr,2,bi,bj,
     &       myThid)
        CALL DIAGNOSTICS_FILL(frac_diss_Si,'BLGSIDIS',0,Nr,2,bi,bj,
     &       myThid)
#endif
        CALL DIAGNOSTICS_FILL(light_lim,'BLGLLIM ',0,Nr,2,bi,bj,myThid)
        CALL DIAGNOSTICS_FILL(POC_flux,'BLGPOCF ',0,Nr,2,bi,bj,myThid)
        CALL DIAGNOSTICS_FILL(PtoN,    'BLGP2N  ',0,Nr,2,bi,bj,myThid)
        CALL DIAGNOSTICS_FILL(FetoN,   'BLGFE2N ',0,Nr,2,bi,bj,myThid)
        CALL DIAGNOSTICS_FILL(NPP,     'BLGNPP  ',0,Nr,2,bi,bj,myThid)
        CALL DIAGNOSTICS_FILL(NCP,     'BLGNCP  ',0,Nr,2,bi,bj,myThid)
        CALL DIAGNOSTICS_FILL(Fe_dvm,  'BLGFEDVM',0,Nr,2,bi,bj,myThid)
        CALL DIAGNOSTICS_FILL(Fe_spm,  'BLGFESPM',0,Nr,2,bi,bj,myThid)
        CALL DIAGNOSTICS_FILL(Fe_recycle,  'BLGFEREC',0,Nr,2,bi,bj,
     &       myThid)
        CALL DIAGNOSTICS_FILL(Fe_remindvm, 'BLGFERD ',0,Nr,2,bi,bj,
     &       myThid)
        CALL DIAGNOSTICS_FILL(Fe_uptake,'BLGFEUP ',0,Nr,2,bi,bj,myThid)
        CALL DIAGNOSTICS_FILL(N_den_benthic,'BLGNDENB',0,Nr,2,bi,bj,
     &       myThid)
        CALL DIAGNOSTICS_FILL(N_den_pelag, 'BLGNDENP',0,Nr,2,bi,bj,
     &       myThid)
        CALL DIAGNOSTICS_FILL(N_dvm,    'BLGNDVM ',0,Nr,2,bi,bj,myThid)
        CALL DIAGNOSTICS_FILL(N_fix,    'BLGNFIX ',0,Nr,2,bi,bj,myThid)
        CALL DIAGNOSTICS_FILL(DON_prod, 'BLGDONP ',0,Nr,2,bi,bj,myThid)
        CALL DIAGNOSTICS_FILL(DON_remin,'BLGDONR ',0,Nr,2,bi,bj,myThid)
        CALL DIAGNOSTICS_FILL(N_spm,    'BLGNSPM ',0,Nr,2,bi,bj,myThid)
        CALL DIAGNOSTICS_FILL(N_recycle,'BLGNREC ',0,Nr,2,bi,bj,myThid)
        CALL DIAGNOSTICS_FILL(N_remindvm,'BLGNRD  ',0,Nr,2,bi,bj,myThid)
        CALL DIAGNOSTICS_FILL(N_reminp, 'BLGNREM ',0,Nr,2,bi,bj,myThid)
        CALL DIAGNOSTICS_FILL(N_uptake, 'BLGNUP  ',0,Nr,2,bi,bj,myThid)
        CALL DIAGNOSTICS_FILL(P_dvm,    'BLGPDVM ',0,Nr,2,bi,bj,myThid)
        CALL DIAGNOSTICS_FILL(DOP_prod, 'BLGDOPP ',0,Nr,2,bi,bj,myThid)
        CALL DIAGNOSTICS_FILL(DOP_remin,'BLGDOPR ',0,Nr,2,bi,bj,myThid)
        CALL DIAGNOSTICS_FILL(P_spm,    'BLGPSPM ',0,Nr,2,bi,bj,myThid)
        CALL DIAGNOSTICS_FILL(P_recycle,'BLGPREC ',0,Nr,2,bi,bj,myThid)
        CALL DIAGNOSTICS_FILL(P_remindvm,'BLGPRD  ',0,Nr,2,bi,bj,myThid)
        CALL DIAGNOSTICS_FILL(P_reminp, 'BLGPREM ',0,Nr,2,bi,bj,myThid)
        CALL DIAGNOSTICS_FILL(P_uptake, 'BLGPUP  ',0,Nr,2,bi,bj,myThid)
        CALL DIAGNOSTICS_FILL(mu,       'BLGMU   ',0,Nr,2,bi,bj,myThid)
        CALL DIAGNOSTICS_FILL(mu_diaz,  'BLGMUDIA',0,Nr,2,bi,bj,myThid)
        CALL DIAGNOSTICS_FILL(CaCO3_diss,  'BLGCCdis',0,Nr,2,bi,bj,
     &       myThid)
        CALL DIAGNOSTICS_FILL(CaCO3_uptake,'BLGCCpro',0,Nr,2,bi,bj,
     &       myThid)
        CALL DIAGNOSTICS_FILL(Fe_ads_org,  'BLGFEADO',0,Nr,2,bi,bj,
     &       myThid)
        CALL DIAGNOSTICS_FILL(Fe_ads_inorg,'BLGFEADI',0,Nr,2,bi,bj,
     &       myThid)
        CALL DIAGNOSTICS_FILL(Fe_sed,    'BLGFESED',0,Nr,2,bi,bj,myThid)
        CALL DIAGNOSTICS_FILL(Fe_reminp, 'BLGFEREM',0,Nr,2,bi,bj,myThid)
        CALL DIAGNOSTICS_FILL(N_reminp,  'BLGNREM ',0,Nr,2,bi,bj,myThid)
        CALL DIAGNOSTICS_FILL(P_reminp,  'BLGPREM ',0,Nr,2,bi,bj,myThid)
        CALL DIAGNOSTICS_FILL(no3_adj,   'BLGNONEN',0,Nr,2,bi,bj,myThid)
C 2d local variables
        CALL DIAGNOSTICS_FILL(mld,       'BLGMLD  ',0,1,2,bi,bj,myThid)
        CALL DIAGNOSTICS_FILL(Fe_burial, 'BLGFEBUR',0,1,2,bi,bj,myThid)
        CALL DIAGNOSTICS_FILL(NO3_btmflx,'BLGNSED ',0,1,2,bi,bj,myThid)
        CALL DIAGNOSTICS_FILL(PO4_btmflx,'BLGPSED ',0,1,2,bi,bj,myThid)
        CALL DIAGNOSTICS_FILL(O2_btmflx, 'BLGO2SED',0,1,2,bi,bj,myThid)
      ENDIF
#endif /* ALLOW_DIAGNOSTICS */

#endif /* USE_BLING_V1 */

#endif /* ALLOW_BLING */

      RETURN
      END

#include "GAD_OPTIONS.h"

CBOP
C !ROUTINE: GAD_FLUXLIMIT_ADV_R

C !INTERFACE: ==========================================================
      SUBROUTINE GAD_FLUXLIMIT_ADV_R(
     I           bi, bj, k, dTarg,
     I           rTrans, wFld,
     I           tracer,
     O           wT,
     I           myThid )

C !DESCRIPTION:
C Calculates the area integrated vertical flux due to advection of a tracer
C using second-order interpolation with a flux limiter:
C \begin{equation*}
C F^x_{adv} = W \overline{ \theta }^k
C - \frac{1}{2} \left(
C     [ 1 - \psi(C_r) ] |W|
C    + W \frac{w \Delta t}{\Delta r_c} \psi(C_r)
C              \right) \delta_k \theta
C \end{equation*}
C where the $\psi(C_r)$ is the limiter function and $C_r$ is
C the slope ratio.

C !USES: ===============================================================
      IMPLICIT NONE
#include "SIZE.h"
#include "GRID.h"
#include "EEPARAMS.h"
#include "PARAMS.h"

C !INPUT PARAMETERS: ===================================================
C  bi, bj             :: tile indices
C  k                  :: vertical level
C  rTrans             :: vertical volume transport
C  wFld               :: vertical flow
C  tracer             :: tracer field
C  myThid             :: thread number
      INTEGER bi, bj, k
      _RL dTarg
      _RL rTrans(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL wFld  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL tracer(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      INTEGER myThid

C !OUTPUT PARAMETERS: ==================================================
C  wT                 :: vertical advective flux
      _RL wT    (1-OLx:sNx+OLx,1-OLy:sNy+OLy)

C !LOCAL VARIABLES: ====================================================
C  i, j               :: loop indices
C  kp1                :: =min( k+1 , Nr )
C  km1                :: =max( k-1 , 1 )
C  km2                :: =max( k-2 , 1 )
C  bi, bj             :: tile indices or (1,1) depending on use
C  Cr                 :: slope ratio
C  Rjm, Rj, Rjp       :: differences at k-1,k,k+1
C  wLoc               :: velocity, vertical component
      INTEGER i, j, kp1, km1, km2
      _RL Cr, Rjm, Rj, Rjp
      _RL wLoc, wCFL
      _RL CrMax
      PARAMETER( CrMax = 1.D+6 )

C Statement function provides Limiter(Cr)
#include "GAD_FLUX_LIMITER.h"
CEOP

      km2 = MAX(1,k-2)
      km1 = MAX(1,k-1)
      kp1 = MIN(Nr,k+1)

      IF ( k.GT.Nr) THEN
       DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
         wT(i,j) = 0.
        ENDDO
       ENDDO
      ELSE
       DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx

         wLoc = wFld(i,j)
         wCFL = ABS( wLoc*dTarg*recip_drC(k) )
         Rjp = (tracer(i,j,kp1)-tracer(i,j,k))
     &          *maskC(i,j,kp1,bi,bj)
         Rj  = (tracer(i,j,k)  -tracer(i,j,km1))
         Rjm = (tracer(i,j,km1)-tracer(i,j,km2))
     &          *maskC(i,j,km2,bi,bj)

         IF ( rTrans(i,j).LT.zeroRL ) THEN
           Cr = Rjm
         ELSE
           Cr = Rjp
         ENDIF
         IF ( ABS(Rj)*CrMax .LE. ABS(Cr) ) THEN
           Cr = SIGN( CrMax, Cr )*SIGN( oneRL, Rj )
         ELSE
           Cr = Cr/Rj
         ENDIF

C        calculate Limiter Function:
         Cr = Limiter(Cr)

         wT(i,j) = maskC(i,j,km1,bi,bj)*(
     &      rTrans(i,j)*
     &        (tracer(i,j,k)+tracer(i,j,km1))*0.5 _d 0
     &    + ABS(rTrans(i,j))*( (oneRL-Cr) + wCFL*Cr )
     &                      *Rj*0.5 _d 0 )
        ENDDO
       ENDDO
      ENDIF

      RETURN
      END

#include "MONITOR_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: MONITOR

C     !INTERFACE:
      SUBROUTINE MONITOR(
     I                    myTime, myIter, myThid )

C     !DESCRIPTION:
C     Monitor key dynamical variables: calculate over the full domain
C      some simple statistics (e.g., min,max,average) and write them.

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "DYNVARS.h"
#include "FFIELDS.h"
#include "MONITOR.h"
#ifdef ALLOW_MNC
# include "MNC_PARAMS.h"
#endif

C     !INPUT PARAMETERS:
      _RL myTime
      INTEGER myIter
      INTEGER myThid
CEOP

C     === Functions ====
      LOGICAL  DIFFERENT_MULTIPLE
      EXTERNAL DIFFERENT_MULTIPLE
      LOGICAL  MASTER_CPU_IO
      EXTERNAL MASTER_CPU_IO

C     !LOCAL VARIABLES:
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      _RL dT
      _RL statsTemp(6)
      _RL dummyRL(6)
      _RS thickFacC(Nr), thickFacF(Nr)
      INTEGER k

      IF ( DIFFERENT_MULTIPLE(monitorFreq,myTime,deltaTClock) ) THEN

        IF ( MASTER_CPU_IO(myThid) ) THEN
C--   only the master thread is allowed to switch On/Off mon_write_stdout
C     & mon_write_mnc (since it is the only thread that uses those flags):

          IF (monitor_stdio) THEN
            mon_write_stdout = .TRUE.
          ELSE
            mon_write_stdout = .FALSE.
          ENDIF
          mon_write_mnc = .FALSE.
#ifdef ALLOW_MNC
          IF (useMNC .AND. monitor_mnc) THEN
            DO k = 1,MAX_LEN_MBUF
              mon_fname(k:k) = ' '
            ENDDO
            mon_fname(1:7) = 'monitor'
            CALL MNC_CW_APPEND_VNAME(
     &           'T', '-_-_--__-__t', 0,0, myThid)
            CALL MNC_CW_SET_UDIM(mon_fname, -1, myThid)
            CALL MNC_CW_RL_W_S(
     &          'D',mon_fname,1,1,'T', myTime, myThid)
            CALL MNC_CW_SET_UDIM(mon_fname, 0, myThid)
            mon_write_mnc = .TRUE.
          ENDIF
#endif /* ALLOW_MNC */

C       Dynamics field monitor start
          IF ( mon_write_stdout ) THEN
            WRITE(msgBuf,'(2A)') '// ==========================',
     &             '============================='
            CALL PRINT_MESSAGE( msgBuf, mon_ioUnit, SQUEEZE_RIGHT , 1)
            WRITE(msgBuf,'(A)')
     &             '// Begin MONITOR dynamic field statistics'
            CALL PRINT_MESSAGE( msgBuf, mon_ioUnit, SQUEEZE_RIGHT , 1)
            WRITE(msgBuf,'(2A)') '// ==========================',
     &             '============================='
            CALL PRINT_MESSAGE( msgBuf, mon_ioUnit, SQUEEZE_RIGHT , 1)
          ENDIF

C--   endif master cpu io
        ENDIF

C-      Set mass weighted thickness factor
        DO k=1,Nr
          thickFacC(k) = drF(k)*deepFac2C(k)*rhoFacC(k)
          thickFacF(k) = drC(k)*deepFac2F(k)*rhoFacF(k)
        ENDDO

C       Print the time to make grepping the stdout easier
        CALL MON_SET_PREF( 'time', myThid )
        CALL MON_OUT_I( '_tsnumber', myIter,mon_string_none,myThid )
        CALL MON_OUT_RL('_secondsf', myTime,mon_string_none,myThid )

        IF ( monitorSelect.GE.1 ) THEN
C       Print the basic statistics of model state variables
         CALL MON_SET_PREF( 'dynstat', myThid )
         CALL MON_WRITESTATS_RL(  1, etaN, '_eta',
     &            maskInC, maskInC, rA , drF, dummyRL, myThid )
         CALL MON_WRITESTATS_RL( Nr, uVel, '_uvel',
     &            hFacW, maskInW, rAw, thickFacC, dummyRL, myThid )
         CALL MON_WRITESTATS_RL( Nr, vVel, '_vvel',
     &            hFacS, maskInS, rAs, thickFacC, dummyRL, myThid )
         CALL MON_WRITESTATS_RL( Nr, wVel, '_wvel',
     &            maskC, maskInC, rA , thickFacF, dummyRL, myThid )
         CALL MON_WRITESTATS_RL( Nr, theta,'_theta',
     &            hFacC, maskInC, rA , thickFacC, statsTemp, myThid )
         CALL MON_WRITESTATS_RL( Nr, salt, '_salt',
     &            hFacC, maskInC, rA , thickFacC, dummyRL, myThid )
        ELSE
         statsTemp(1) = 1.
         statsTemp(2) = 0.
        ENDIF
        IF ( monitorSelect.GE.3 .AND.
     &       nSx.EQ.1 .AND. nSy.EQ.1 ) THEN
C-      print stats only if nSx=nSy=1 since otherwise stats are wrong
         k = 1
         IF ( usingPCoords ) k = Nr
         CALL MON_WRITESTATS_RL( 1, theta(1-OLx,1-OLy,k,1,1), '_sst',
     &            maskInC, maskInC, rA , drF, dummyRL, myThid )
         CALL MON_WRITESTATS_RL( 1,  salt(1-OLx,1-OLy,k,1,1), '_sss',
     &            maskInC, maskInC, rA , drF, dummyRL, myThid )
        ENDIF

C       Print the basic statistics of external forcing
        IF ( monitorSelect.GE.3 ) THEN
         CALL MON_SET_PREF( 'forcing', myThid )
         CALL MON_WRITESTATS_RS( 1, Qnet, '_qnet',
     &            maskInC, maskInC, rA , drF, dummyRL, myThid )
         CALL MON_WRITESTATS_RS( 1, Qsw , '_qsw',
     &            maskInC, maskInC, rA , drF, dummyRL, myThid )
         CALL MON_WRITESTATS_RS( 1, EmPmR,'_empmr',
     &            maskInC, maskInC, rA , drF, dummyRL, myThid )
         CALL MON_WRITESTATS_RS( 1, fu ,  '_fu',
     &            maskInW, maskInW, rAw, drF, dummyRL, myThid )
         CALL MON_WRITESTATS_RS( 1, fv ,  '_fv',
     &            maskInS, maskInS, rAs, drF, dummyRL, myThid )
        ENDIF

C       Print numerical stablility parameters for lastest tracer advection
        IF ( monitorSelect.GE.2 ) THEN
         CALL MON_SET_PREF( 'trAdv_CFL', myThid )
         CALL MON_OUT_RL( '_u', mon_trAdvCFL(1), mon_foot_max,myThid )
         CALL MON_OUT_RL( '_v', mon_trAdvCFL(2), mon_foot_max,myThid )
         CALL MON_OUT_RL( '_w', mon_trAdvCFL(3), mon_foot_max,myThid )
        ENDIF

C       Print the numerical stablility parameters for current state
        CALL MON_SET_PREF( 'advcfl', myThid )
        dT = MAX(dTtracerLev(1),deltaTmom)
        CALL MON_ADVCFL(  '_uvel', uVel, recip_dxC, dT, myThid )
        CALL MON_ADVCFL(  '_vvel', vVel, recip_dyC, dT, myThid )
        CALL MON_ADVCFLW( '_wvel', wVel, recip_drC, dT, myThid )
        CALL MON_ADVCFLW2('_W_hf', wVel, recip_hFacC,
     &                                   recip_drF, dT, myThid )

C       Print stats for KE
        CALL MON_KE(myIter, myThid)

C       Print stats for (relative,absolute) Vorticity AND Pot.Vort.
        IF ( monitorSelect.GE.2 ) CALL MON_VORT3( myIter, myThid )

C       Print stats for surface correction terms (Linear Free-Surf)
        IF ( monitorSelect.GE.2 ) CALL MON_SURFCOR( myThid )

C       Check that solution is within reasonable bounds
        CALL MON_SOLUTION( statsTemp, myTime, myIter, myThid )

C       Dynamics field monitor finish
        IF ( MASTER_CPU_IO(myThid) ) THEN
C--   only the master thread is allowed to switch On/Off mon_write_stdout
C     & mon_write_mnc (since it is the only thread that uses those flags):

          IF ( mon_write_stdout ) THEN
            WRITE(msgBuf,'(2A)') '// ==========================',
     &             '============================='
            CALL PRINT_MESSAGE( msgBuf, mon_ioUnit, SQUEEZE_RIGHT , 1)
            WRITE(msgBuf,'(A)')
     &             '// End MONITOR dynamic field statistics'
            CALL PRINT_MESSAGE( msgBuf, mon_ioUnit, SQUEEZE_RIGHT , 1)
            WRITE(msgBuf,'(2A)') '// ==========================',
     &             '============================='
            CALL PRINT_MESSAGE( msgBuf, mon_ioUnit, SQUEEZE_RIGHT , 1)
          ENDIF

          mon_write_stdout = .FALSE.
          mon_write_mnc    = .FALSE.

C--   endif master cpu io
        ENDIF

C     endif different multiple
      ENDIF

      RETURN
      END

#include "CPP_EEOPTIONS.h"

CBOP
C     !ROUTINE: EXCH_CYCLE_EBL

C     !INTERFACE:
      SUBROUTINE EXCH_CYCLE_EBL( myThid )
      IMPLICIT NONE

C     !DESCRIPTION:
C     *==========================================================*
C     | SUBROUTINE EXCH\_CYCLE\_EBL                                 
C     | o Cycle exchange buffer level.                            
C     *==========================================================*
C     | Step the "exchange buffer level" to next value.           
C     | The buffer level is used to prevent consecutive messages  
C     | overwriting one another. Because we know that every tile  
C     | will participate in an exchange we can be sure that every 
C     | tile will cycle through the buffers with the same         
C     | sequence. Also we know that a tile cannot start a new     
C     | exchange before it has completed its end of the previous  
C     | exchange. Thus by cycling through three buffer levels we  
C     | can be sure that the buffer we write to will be free.     
C     |  That is by the time we are participating in the third    
C     | exchange transaction we know that both ends of the first  
C     | transaction must have completed.                          
C     | Note --                                                   
C     | 1. We allow more than three levels below although this    
C     | is not necessary.                                         
C     *==========================================================*

C     !USES:
C     == Global data ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "EESUPPORT.h"
#include "EXCH.h"

C     !INPUT PARAMETERS:
C     == Routine arguments ==
C     myThid :: Thread number of this instance of the routine
      INTEGER myThid

C     !LOCAL VARIABLES:
C     == Local variables ==
C     bi, bj :: Loop counters
      INTEGER bi, bj
CEOP

      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
C--     Use next level exchange buffer in cycle.
        exchangeBufLevel(1,bi,bj) = exchangeBufLevel(1,bi,bj)+1
        IF ( exchangeBufLevel(1,bi,bj) .GT. NUMBER_OF_BUFFER_LEVELS )
     &   exchangeBufLevel(1,bi,bj) = 1
       ENDDO
      ENDDO

      RETURN
      END

c#include "PACKAGES_CONFIG.h"
#include "ATM_CPL_OPTIONS.h"

CBOP 0
C !ROUTINE: ATM_CHECK_CPLCONFIG

C !INTERFACE:
      SUBROUTINE ATM_CHECK_CPLCONFIG(
     U                        errFlag, errMsg,
     I                        landMask, myThid )

C !DESCRIPTION:
C     *==========================================================*
C     | SUBROUTINE ATM_CHECK_CPLCONFIG
C     | o Check for inconsistency in coupling set-up config
C     *==========================================================*
C     | The routine checks on consistent coupler-exchange config
C     |  and performs some basic checking on consistency between
C     |  components (e.g., land-sea mask);
C     | Also summarises coupling set-up config and output fields
C     |  that were imported
C     *==========================================================*

C !USES:
      IMPLICIT NONE
C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
c#include "GRID.h"
#include "CPL_PARAMS.h"
#include "ATMCPL.h"

C !INPUT/OUTPUT PARAMETERS:
C     errFlag  :: logical flag to report an error
C     errMsg   :: error message to print to clog file
C     landMask :: land / sea mask (=1 : full land; =0 : full ocean grid cell)
C     myThid   :: Thread number for this instance of the routine
      LOGICAL errFlag
      CHARACTER*(*) errMsg
      _RL landMask(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      INTEGER myThid

C !LOCAL VARIABLES:
      INTEGER i, j, bi, bj
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      _RL atm_waterOnly, atm_landOnly, mxlD_noWater
CEOP

C--   Summarise fields that were imported.
C     o Plot ocean depths
      IF ( debugLevel.GE.debLevB ) THEN
        CALL WRITE_FLD_XY_RL( 'Ocn_MxlD', ' ', ocMxlD, 0, myThid )
      ENDIF
      IF ( plotLevel.GE.debLevC ) THEN
        CALL PLOT_FIELD_XYRL( ocMxlD,
     &                  'Ocean mixed-layer depth on atmos grid',
     &                  1, myThid )
      ENDIF

C--   Report previously found errors
      _BEGIN_MASTER( myThid )

      IF ( cplErrorCount.NE.0 ) THEN
        errFlag = .TRUE.
        WRITE(msgBuf,'(2A,I4,A)') 'ATM_CHECK_CPLCONFIG: ',
     &    ' cplErrorCount=', cplErrorCount, ' (from previous error)'
        CALL PRINT_ERROR( msgBuf, myThid )
      ENDIF

C--   Do consistency checks on imported fields.
C     o Check that:
C      a) where land/sea mask is "water-only", this should be a wet ocean pts
C      b) where land/sea mask has "no water",  this should be a dry ocean pts
      atm_waterOnly = 0. _d 0
      atm_landOnly  = 1. _d 0
      mxlD_noWater  = 0. _d 0
      DO bj=1,nSy
       DO bi=1,nSx
        DO j=1,sNy
         DO i=1,sNx
          IF ( ( landMask(i,j,bi,bj) .EQ. atm_waterOnly
     &       .AND. ocMxlD(i,j,bi,bj) .EQ. mxlD_noWater )
     &    .OR. ( landMask(i,j,bi,bj) .EQ. atm_landOnly
     &       .AND. ocMxlD(i,j,bi,bj) .NE. mxlD_noWater ) ) THEN
           errFlag = .TRUE.
           WRITE(msgBuf,'(2(A,I6),2(A,I4),A)')
     &     'Inconsistent land/sea mask @ (i=', i, ',j=', j,
     &                              ',bi=', bi, ',bj=', bj, ')'
           CALL PRINT_ERROR( msgBuf, myThid )
           WRITE(msgBuf,'(A,E30.15)')
     &     'Land (atmosphere) ==', landMask(i,j,bi,bj)
           CALL PRINT_ERROR( msgBuf, myThid )
           WRITE(msgBuf,'(A,E30.15)')
     &     'Mxl-Depth (ocean) ==', ocMxlD(i,j,bi,bj)
           CALL PRINT_ERROR( msgBuf, myThid )
          ENDIF
         ENDDO
        ENDDO
       ENDDO
      ENDDO

      IF ( errFlag ) WRITE(errMsg,'(A)')
     &   'ATM_CHECK_CPLCONFIG: inconsistent ATM/CPL/OCN config'

      _END_MASTER( myThid )

      RETURN
      END

#include "MDSIO_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C- modification: no need to edit the 4 scr files mdsio_pass_r{4,8}tor{l,s}.F :
C        from the 1rst src file (mdsio_pass_r4torl.F), can update the 3 others
C        using the script "derive_other_types".
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

CBOP
C !ROUTINE: MDS_PASS_R4toRL
C !INTERFACE:
      SUBROUTINE MDS_PASS_R4toRL(
     U                            buffer, arrFld,
     I                            oLi, oLj, nNz, kLo, kSize,
     I                            biArg, bjArg, copyTo, myThid )

C !DESCRIPTION:
C     Transfer 3-D real*4 buffer to 3-D RL model array, or the reverse,
C      depending on "copyTo" value. Apply transfer to tile biArg,bjArg
C      only or to all myThid tiles if called with biArg=bjArg=0.

C     !USES:
      IMPLICIT NONE

C Global variables / common blocks
#include "EEPARAMS.h"
#include "SIZE.h"

C     !INPUT/OUTPUT PARAMETERS:
C Routine arguments
C buffer  (real*4) :: buffer 3-D array (Input/Output if copyTo=T/F)
C arrFld   ( RL )  :: model 3-D tiled array (Output/Input if copyTo=T/F)
C oLi     (integer):: Overlap size (dim-1) of buffer to copy - to/from - arrFld
C oLj     (integer):: Overlap size (dim-2) of buffer to copy - to/from - arrFld
C nNz     (integer):: Number of levels to - fill in / extract from - arrFld
C kLo     (integer):: 1rst level to - fill in / extract from - arrFld
C kSize   (integer):: third dimension of 3-D array "arrFld"
C biArg   (integer):: tile X-index to - fill in / extract from - tiled buffer
C bjArg   (integer):: tile Y-index to - fill in / extract from - tiled buffer
C copyTo  (logical):: if =T, copy 2-D -> 3-D ; if =F: copy 2-D <- 3-D
C myThid  (integer):: my Thread Id number
      INTEGER oLi, oLj
      INTEGER nNz, kSize
      Real*4 buffer(1-oLi:sNx+oLi,1-oLj:sNy+oLj,nNz,nSx,nSy)
      _RL    arrFld(1-OLx:sNx+OLx,1-OLy:sNy+OLy,kSize,nSx,nSy)
      INTEGER kLo
      INTEGER biArg
      INTEGER bjArg
      LOGICAL copyTo
      INTEGER myThid

C !LOCAL VARIABLES:
C   i,j,k :: loop indices
C   bi,bj :: tile indices
      INTEGER i,j,k,bi,bj
      INTEGER kLev
CEOP
      IF ( oLi.LT.0 .OR. oLi.GT.OLx .OR.
     &     oLj.LT.0 .OR. oLj.GT.OLy ) THEN
        STOP 'ABNORMAL END: MDS_PASS_R4toRL invalid oLi,oLj Arg'
      ENDIF

      IF ( biArg.EQ.0 .AND. bjArg.EQ.0 ) THEN
        IF ( copyTo ) THEN
          DO bj = myByLo(myThid), myByHi(myThid)
           DO bi = myBxLo(myThid), myBxHi(myThid)
            DO k=1,nNz
             kLev = kLo+k-1
             DO j=1-oLj,sNy+oLj
              DO i=1-oLi,sNx+oLi
                arrFld(i,j,kLev,bi,bj) = buffer(i,j,k,bi,bj)
              ENDDO
             ENDDO
            ENDDO
           ENDDO
          ENDDO
        ELSE
          DO bj = myByLo(myThid), myByHi(myThid)
           DO bi = myBxLo(myThid), myBxHi(myThid)
            DO k=1,nNz
             kLev = kLo+k-1
             DO j=1-oLj,sNy+oLj
              DO i=1-oLi,sNx+oLi
                buffer(i,j,k,bi,bj) = arrFld(i,j,kLev,bi,bj)
              ENDDO
             ENDDO
            ENDDO
           ENDDO
          ENDDO
        ENDIF
      ELSEIF ( biArg.GE.1 .AND. biArg.LE.nSx
     &   .AND. bjArg.GE.1 .AND. bjArg.LE.nSy ) THEN
        bi = biArg
        bj = bjArg
        IF ( copyTo ) THEN
          DO k=1,nNz
            kLev = kLo+k-1
            DO j=1-oLj,sNy+oLj
              DO i=1-oLi,sNx+oLi
                arrFld(i,j,kLev,1,1) = buffer(i,j,k,bi,bj)
              ENDDO
            ENDDO
          ENDDO
        ELSE
          DO k=1,nNz
            kLev = kLo+k-1
            DO j=1-oLj,sNy+oLj
              DO i=1-oLi,sNx+oLi
                buffer(i,j,k,bi,bj) = arrFld(i,j,kLev,1,1)
              ENDDO
            ENDDO
          ENDDO
        ENDIF
      ELSE
        STOP 'ABNORMAL END: MDS_PASS_R4toRL invalid bi,bj Arg'
      ENDIF

      RETURN
      END

#include "CPP_OPTIONS.h"

CBOP
C     !ROUTINE: INI_NH_FIELDS
C     !INTERFACE:
      SUBROUTINE INI_NH_FIELDS( myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE INI_NH_FIELDS
C     | o Set model initial non-hydrostatic fields.
C     *==========================================================*
C     | Note: If using NH form,
C     |  call this S/R whether starting or restarting simulation.
C     | This is different from other "true" ini_fields type S/R
C     |  (e.g., INI_VEL) which are called only when starting.
C     | Reason: no real physical field to initialise (since wVel
C     |  is diagnose from continuity) but needs to set few arrays
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "RESTART.h"
#include "NH_VARS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     myThid  :: My Thread Id number
      INTEGER myThid

#ifdef ALLOW_NONHYDROSTATIC
C     !LOCAL VARIABLES:
C     == Local variables ==
      INTEGER bi,bj
      INTEGER i,j
      INTEGER ks
      CHARACTER*(MAX_LEN_MBUF) msgBuf
#ifdef NONLIN_FRSURF
      INTEGER k
#endif
CEOP

      IF ( startTime .EQ. baseTime .AND.  nIter0 .EQ. 0
     &     .AND. pickupSuff .EQ. ' ' ) THEN
C--   Case where starting from initial conditions

C--   Read an initial non-hydrostatic pressure field
c       IF (phiNHinitFile .NE. ' ') THEN
c        CALL READ_FLD_XYZ_RL( phiNHinitFile, ' ', phi_nh, 0, myThid )
c        _EXCH_XYZ_RL(phi_nh, myThid)
c       ENDIF

      ELSE
C--   Case where restarting from a pickup

       _BEGIN_MASTER(myThid)
       WRITE(msgBuf,'(A,I4)')
     &   'INI_NH_FIELDS: dPhiNHstatus=', dPhiNHstatus
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                     SQUEEZE_RIGHT, myThid )
       _END_MASTER(myThid)
       IF ( exactConserv .AND. dPhiNHstatus.EQ.0 ) THEN
c      IF ( exactConserv ) THEN
C--   Separate the Hydrostatic Surface Pressure adjusment (=> put it in dPhiNH)
C     from the Non-hydrostatic pressure (since cg3d_x contains both contribution)
        DO bj=myByLo(myThid),myByHi(myThid)
         DO bi=myBxLo(myThid),myBxHi(myThid)
          IF ( select_rStar.EQ.0 .AND. uniformFreeSurfLev ) THEN
C-       Z coordinate: assume surface @ level k=1
           DO j=1-OLy,sNy+OLy
            DO i=1-OLx,sNx+OLx
              dPhiNH(i,j,bi,bj) = phi_nh(i,j,1,bi,bj)
c             dPhiNH(i,j,bi,bj) = 0.
            ENDDO
           ENDDO
          ELSEIF ( select_rStar.EQ.0 ) THEN
C-       Other than Z coordinate: no assumption on surface level index
           DO j=1-OLy,sNy+OLy
            DO i=1-OLx,sNx+OLx
             ks = kSurfC(i,j,bi,bj)
             IF ( ks.LE.Nr ) THEN
              dPhiNH(i,j,bi,bj) = phi_nh(i,j,ks,bi,bj)
             ELSE
              dPhiNH(i,j,bi,bj) = 0.
             ENDIF
            ENDDO
           ENDDO
#ifdef NONLIN_FRSURF
          ELSE
C        rStar : take vertical average of P_NH as Hyd.Surf.Press adjustment
           DO j=1-OLy,sNy+OLy
            DO i=1-OLx,sNx+OLx
              dPhiNH(i,j,bi,bj) = 0.
            ENDDO
           ENDDO
           DO k=1,Nr
            DO j=1-OLy,sNy+OLy
             DO i=1-OLx,sNx+OLx
              dPhiNH(i,j,bi,bj) = dPhiNH(i,j,bi,bj)
     &          + phi_nh(i,j,k,bi,bj)*drF(k)*hFacC(i,j,k,bi,bj)
             ENDDO
            ENDDO
           ENDDO
           DO j=1-OLy,sNy+OLy
            DO i=1-OLx,sNx+OLx
              dPhiNH(i,j,bi,bj) = dPhiNH(i,j,bi,bj)
     &                           *recip_Rcol(i,j,bi,bj)
            ENDDO
           ENDDO
#endif /* NONLIN_FRSURF */
          ENDIF
         ENDDO
        ENDDO
C-     end of if-block: dPhiNH_status
       ENDIF

      ENDIF

#endif /* ALLOW_NONHYDROSTATIC */
      RETURN
      END

#include "GRDCHK_OPTIONS.h"
#ifdef ALLOW_CTRL
# include "CTRL_OPTIONS.h"
#endif

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C !ROUTINE: GRDCHK_CTRL_FNAME

C !INTERFACE:
      SUBROUTINE GRDCHK_CTRL_FNAME(
     U                              fName,
     U                              grdchk_index,
     I                              myThid )

C     !DESCRIPTION:
C     associate control file-name with the grdchk_index,
C     depending on which one is set

C     !USES:
      IMPLICIT NONE
C     == Global variables ===
#include "EEPARAMS.h"
#include "SIZE.h"
#include "CTRL_SIZE.h"
#include "CTRL.h"
#include "CTRL_GENARR.h"
#ifdef ALLOW_OBCS_CONTROL
# include "CTRL_OBCS.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     fName        :: name of the CTRL var/file matching grdchk_index
C     grdchk_index :: grdchk index of CTRL variable to perturb
C     myThid       :: my Thread Id number
      CHARACTER*(MAX_LEN_FNAM) fName
      INTEGER grdchk_index
      INTEGER myThid

C     !FUNCTIONS:
      INTEGER  ILNBLNK
      EXTERNAL ILNBLNK

C     !LOCAL VARIABLES:
C     msgBuf     :: Informational/error message buffer
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      INTEGER il, jl, ivar
CEOP

      IF ( grdchk_index .EQ. UNSET_I ) THEN
C--   If not set, determine grdchk_index from fName (= grdchkvarname)
       IF ( fName .NE. ' ' ) THEN
        jl = ILNBLNK(fName)
        DO ivar = 1, maxcvars
         IF ( grdchk_index .EQ. UNSET_I ) THEN
          il = ILNBLNK(ncvarfname(ivar))
          IF ( il.EQ.jl .AND. ncvarfname(ivar)(1:il).EQ.fName(1:il) )
     &      grdchk_index = ivar
         ENDIF
        ENDDO
       ENDIF

       IF ( grdchk_index .EQ. UNSET_I ) THEN
        WRITE(msgBuf,'(3A)') 'S/R GRDCHK_CTRL_FNAME: ',
     &       'grdchkvarindex is not set and could not be determined ',
     &       'from grdchkvarname'
        CALL PRINT_ERROR( msgBuf, myThid )
        STOP 'ABNORMAL END: S/R GRDCHK_CTRL_FNAME'
       ENDIF

      ELSEIF ( grdchk_index.LE.0 .OR. grdchk_index.GT.maxcvars ) THEN
C--   check for valid index value

        WRITE(msgBuf,'(2A,I8)') 'GRDCHK_CTRL_FNAME: ',
     &        'Invalid grdchk_index=', grdchk_index
        CALL PRINT_ERROR( msgBuf, myThid )
        STOP 'ABNORMAL END: S/R GRDCHK_CTRL_FNAME'

      ELSEIF ( fName .NE. ' ' ) THEN
C--   IF both grdchk_index and fName are set, check for consistency
       jl = ILNBLNK(fName)
       il = ILNBLNK(ncvarfname(grdchk_index))
       IF ( il.NE.jl .OR.
     &      fName(1:il) .NE. ncvarfname(grdchk_index)(1:il) ) THEN
        WRITE(msgBuf,'(5A)') 'S/R GRDCHK_CTRL_FNAME: ',
     &       'fName(grdchkvarindex) = ', fName(1:jl),
     &       ' .NE. ncvarfname = ', ncvarfname(grdchk_index)(1:il)
        CALL PRINT_ERROR( msgBuf, myThid )
        STOP 'ABNORMAL END: S/R GRDCHK_CTRL_FNAME'
       ENDIF

      ELSE
C--   set fName from grdchk_index:
        fName = ncvarfname( grdchk_index )
      ENDIF

      RETURN
      END

#include "STREAMICE_OPTIONS.h"

      SUBROUTINE template()
      use OAD_cp
      use OAD_tape
      use OAD_rev

!$TEMPLATE_PRAGMA_DECLARATIONS

      integer testTape
      !logical isTape
      !type(modeType) :: our_orig_mode

#if (defined(ALLOW_STREAMICE_FP_ADJ) && defined(ALLOW_OPENAD))

      if (our_rev_mode%plain .or. our_rev_mode%tape) then
!      if (our_rev_mode%plain) then

       if (our_rev_mode%tape) then
        testTape=1
        our_rev_mode%plain=.true.
        our_rev_mode%tape=.false.
        our_rev_mode%adjoint=.false.
       else
        testTape=0
       endif

       err_max = 0. _d 0
       err_sum = 0. _d 0

       DO bj = myByLo(myThid), myByHi(myThid)
        DO bi = myBxLo(myThid), myBxHi(myThid)
         err_sum_tile(bi,bj) = 0. _d 0
        ENDDO
       ENDDO

        DO bj = myByLo(myThid), myByHi(myThid)
         DO bi = myBxLo(myThid), myBxHi(myThid)
          DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
            Au_SI (i,j,bi,bj) = 0. _d 0
            Av_SI (i,j,bi,bj) = 0. _d 0
            u_dummy (i,j,bi,bj) = u_streamice(i,j,bi,bj)%v
            v_dummy (i,j,bi,bj) = v_streamice(i,j,bi,bj)%v
            ubd_SI (i,j,bi,bj)%v = 0. _d 0
            vbd_SI (i,j,bi,bj)%v = 0. _d 0
           ENDDO
          ENDDO
         ENDDO
        ENDDO

        CALL openad_STREAMICE_CG_BOUND_VALS( myThid,
     O    ubd_SI,
     O    vbd_SI)

        CALL openad_STREAMICE_CG_ACTION( myThid,
     O    Au_SI,
     O    Av_SI,
     I    U_dummy,
     I    V_dummy,
     I    0, sNx+1, 0, sNy+1 )

       IF (streamice_err_norm .LT. 1.0) then

        DO bj = myByLo(myThid), myByHi(myThid)
         DO bi = myBxLo(myThid), myBxHi(myThid)
          DO j=1,sNy
           DO i=1,sNx
            err_tempu = 0. _d 0
            err_tempv = 0. _d 0
            IF (STREAMICE_umask(i,j,bi,bj).eq.1) THEN
             err_tempu =
     &        ABS (Au_SI(i,j,bi,bj)+0*ubd_SI(i,j,bi,bj)%v -
     &            taudx_SI(i,j,bi,bj)%v)
            ENDIF
            IF (STREAMICE_vmask(i,j,bi,bj).eq.1) THEN
             err_tempv = MAX( err_tempu,
     &        ABS (Av_SI(i,j,bi,bj)+0*vbd_SI(i,j,bi,bj)%v -
     &            taudy_SI(i,j,bi,bj)%v))
            ENDIF
            IF (err_tempv .ge. err_max) THEN
             err_max = err_tempv
            ENDIF
           ENDDO
          ENDDO
         ENDDO
        ENDDO

        CALL GLOBAL_MAX_R8 (err_max, myThid)

       ELSE

        DO bj = myByLo(myThid), myByHi(myThid)
         DO bi = myBxLo(myThid), myBxHi(myThid)
          DO j=1,sNy
           DO i=1,sNx

            IF (STREAMICE_umask(i,j,bi,bj).eq.1) THEN
             err_sum_tile(bi,bj) = err_sum_tile(bi,bj) +
     &        (ABS (Au_SI(i,j,bi,bj)+0*ubd_SI(i,j,bi,bj)%v -
     &            taudx_SI(i,j,bi,bj)%v)) ** streamice_err_norm
            ENDIF
            IF (STREAMICE_vmask(i,j,bi,bj).eq.1) THEN
             err_sum_tile(bi,bj) = err_sum_tile(bi,bj) +
     &        (ABS (Av_SI(i,j,bi,bj)+0*vbd_SI(i,j,bi,bj)%v -
     &            taudy_SI(i,j,bi,bj)%v)) ** streamice_err_norm
            ENDIF

           ENDDO
          ENDDO
         ENDDO
        ENDDO

        CALL GLOBAL_SUM_TILE_RL( err_sum_tile, err_sum, myThid )

        err_max = err_sum ** (1./streamice_err_norm)

       ENDIF

       if (testTape.eq.1) then
        our_rev_mode%plain=.false.
        our_rev_mode%tape=.true.
        our_rev_mode%adjoint=.false.
       endif

      end if

#endif
      end subroutine template

#include "PACKAGES_CONFIG.h"
#include "CPP_OPTIONS.h"

CBOP
C     !ROUTINE: MOMENTUM_CORRECTION_STEP
C     !INTERFACE:
      SUBROUTINE MOMENTUM_CORRECTION_STEP( myTime, myIter, myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE MOMENTUM_CORRECTION_STEP
C     *==========================================================*
C     |1rst Part : Update U,V.
C     |
C     | The arrays used for time stepping are cycled.
C     | Momentum:
C     |           V(n) = Gv(n) - dt * grad Eta
C     |
C     |part1: update U,V
C     |  U*,V* (contained in gU,gV) have the surface
C     |     pressure gradient term added and the result stored
C     |     in U,V (contained in uVel, vVel)
C     |
C     |part2: Adjustments
C     |   o Filter  U,V (Shapiro Filter, Zonal_Filter)
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     == Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "DYNVARS.h"

#ifdef ALLOW_SHAP_FILT
#include "SHAP_FILT.h"
#endif
#ifdef ALLOW_ZONAL_FILT
#include "ZONAL_FILT.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     myTime :: Current time in simulation
C     myIter :: Current iteration number in simulation
C     myThid :: my Thread Id. number
      _RL myTime
      INTEGER myIter
      INTEGER myThid

C     !LOCAL VARIABLES:
      _RL phiSurfX(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL phiSurfY(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER iMin, iMax
      INTEGER jMin, jMax
      INTEGER bi, bj
      INTEGER i, j
CEOP

      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)

        IF ( momStepping ) THEN
C--     Set up work arrays that need valid initial values
          DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
            phiSurfX(i,j) = 0.
            phiSurfY(i,j) = 0.
           ENDDO
          ENDDO

C       Loop range: Gradients of Eta are evaluated so valid
C       range is all but first row and column in overlaps.
          iMin = 1-OLx+1
          iMax = sNx+OLx
          jMin = 1-OLy+1
          jMax = sNy+OLy

C-      Calculate gradient of surface Potentiel
          CALL CALC_GRAD_PHI_SURF(
     I         bi, bj, iMin, iMax, jMin, jMax,
     I         etaN,
     O         phiSurfX, phiSurfY,
     I         myThid )

C-      Update velocity fields:  V(n) = V** - dt * grad Eta
          CALL CORRECTION_STEP(
     I         bi, bj, iMin, iMax, jMin, jMax,
     I         phiSurfX, phiSurfY,
     I         myTime, myIter, myThid )
        ENDIF

#ifdef ALLOW_OBCS
        IF ( useOBCS ) THEN
          CALL OBCS_APPLY_UV( bi, bj, 0, uVel, vVel, myThid )
        ENDIF
#endif /* ALLOW_OBCS */

C--    End of 1rst bi,bj loop
       ENDDO
      ENDDO

C--- 2nd Part : Adjustment.

C--   Filter (and exchange)
#ifdef ALLOW_SHAP_FILT
      IF ( useSHAP_FILT ) THEN
       IF ( .NOT.shap_filt_uvStar ) THEN
        CALL TIMER_START('SHAP_FILT_UV       [MOM_CORR_STEP]',myThid)
        CALL SHAP_FILT_APPLY_UV( uVel, vVel, myTime, myIter, myThid )
        CALL TIMER_STOP ('SHAP_FILT_UV       [MOM_CORR_STEP]',myThid)
       ENDIF
      ENDIF
#endif
#ifdef ALLOW_ZONAL_FILT
      IF ( useZONAL_FILT ) THEN
       IF ( .NOT.zonal_filt_uvStar ) THEN
        CALL TIMER_START('ZONAL_FILT_UV      [MOM_CORR_STEP]',myThid)
        CALL ZONAL_FILT_APPLY_UV( uVel, vVel, myThid )
        CALL TIMER_STOP ('ZONAL_FILT_UV      [MOM_CORR_STEP]',myThid)
       ENDIF
      ENDIF
#endif

C--   Try to fix restart (Pb at machine trucation level accumulating in wVel):
C     Apply EXCH to horiz velocity before integrating continuity (-> wVel)
      IF ( applyExchUV_early )
     &  CALL EXCH_UV_3D_RL( uVel, vVel, .TRUE., Nr, myThid )

      RETURN
      END

#include "GRDCHK_OPTIONS.h"
#ifdef ALLOW_CTRL
# include "CTRL_OPTIONS.h"
#endif

      SUBROUTINE GRDCHK_GET_MASK( myThid )

C     ==================================================================
C     SUBROUTINE grdchk_get_mask
C     ==================================================================
C
C     o Get the location of a given component of the control vector for
C       the current process.
C
C     started: Christian Eckert eckert@mit.edu 04-Apr-2000
C     continued: heimbach@mit.edu: 13-Jun-2001
C
C     ==================================================================
C     SUBROUTINE grdchk_get_mask
C     ==================================================================

      IMPLICIT NONE

C     == global variables ==
#include "EEPARAMS.h"
#include "SIZE.h"
#include "CTRL_SIZE.h"
#include "CTRL.h"
#ifdef ALLOW_OBCS_CONTROL
C     CTRL_OBCS.h must be included before GRDCHK.h
# include "CTRL_OBCS.h"
#endif
#include "GRDCHK.h"

C     == routine arguments ==
      INTEGER myThid

#ifdef ALLOW_GRDCHK
C     == local variables ==
      INTEGER bi, bj
      INTEGER k, iobcs
      INTEGER itlo, ithi
      INTEGER jtlo, jthi
      INTEGER nobcsmax
C     == end of interface ==

      jtlo = 1
      jthi = nSy
      itlo = 1
      ithi = nSx

      _BEGIN_MASTER( myThid )

#ifdef ALLOW_OBCS_CONTROL
      nobcsmax = nobcs
#else
      nobcsmax = 1
#endif

C--   initialise
      DO bj = jtlo,jthi
       DO bi = itlo,ithi
        DO k = 1,ncvarnrmax(grdchkvarindex)
         DO iobcs = 1, nobcsmax
           nwettile(bi,bj,k,iobcs) = 0
         ENDDO
        ENDDO
       ENDDO
      ENDDO

C--   Determine the number of components of the given
C--   control variable on the current tile.
      IF ( ncvargrd(grdchkvarindex) .EQ. 'c' ) THEN
        DO bj = jtlo,jthi
         DO bi = itlo,ithi
          DO k = 1,ncvarnrmax(grdchkvarindex)
            nwettile(bi,bj,k,1) = nwetctile(bi,bj,k)
          ENDDO
         ENDDO
        ENDDO
      ELSEIF ( ncvargrd(grdchkvarindex) .EQ. 's' ) THEN
        DO bj = jtlo,jthi
         DO bi = itlo,ithi
          DO k = 1,ncvarnrmax(grdchkvarindex)
            nwettile(bi,bj,k,1) = nwetstile(bi,bj,k)
          ENDDO
         ENDDO
        ENDDO
      ELSEIF ( ncvargrd(grdchkvarindex) .EQ. 'w' ) THEN
        DO bj = jtlo,jthi
         DO bi = itlo,ithi
          DO k = 1,ncvarnrmax(grdchkvarindex)
            nwettile(bi,bj,k,1) = nwetwtile(bi,bj,k)
          ENDDO
         ENDDO
        ENDDO
c     ELSEIF ( ncvargrd(grdchkvarindex) .EQ. 'v' ) THEN
c       DO bj = jtlo,jthi
c        DO bi = itlo,ithi
c         DO k = 1,ncvarnrmax(grdchkvarindex)
c           nwettile(bi,bj,k,1) = nwetvtile(bi,bj,k)
c         ENDDO
c        ENDDO
c       ENDDO
#ifdef ALLOW_SHELFICE
      ELSEIF ( ncvargrd(grdchkvarindex) .EQ. 'i' ) THEN
        DO bj = jtlo,jthi
         DO bi = itlo,ithi
          DO k = 1,ncvarnrmax(grdchkvarindex)
            nwettile(bi,bj,k,1) = nwetitile(bi,bj,k)
          ENDDO
         ENDDO
        ENDDO
#endif /* ALLOW_SHELFICE */
#ifdef ALLOW_OBCS_CONTROL
      ELSEIF ( ncvargrd(grdchkvarindex) .EQ. 'm' ) THEN
       DO bj = jtlo,jthi
         DO bi = itlo,ithi
          DO k = 1,ncvarnrmax(grdchkvarindex)
           DO iobcs = 1, nobcsmax
             IF ( ncvarindex(grdchkvarindex).EQ.1 ) THEN
#ifdef ALLOW_OBCSN_CONTROL
               nwettile(bi,bj,k,iobcs) = nwetobcsn(bi,bj,k,iobcs)
#endif
             ELSEIF ( ncvarindex(grdchkvarindex).EQ.2 ) THEN
#ifdef ALLOW_OBCSS_CONTROL
               nwettile(bi,bj,k,iobcs) = nwetobcss(bi,bj,k,iobcs)
#endif
             ELSEIF ( ncvarindex(grdchkvarindex).EQ.3 ) THEN
#ifdef ALLOW_OBCSE_CONTROL
               nwettile(bi,bj,k,iobcs) = nwetobcse(bi,bj,k,iobcs)
#endif
             ELSEIF ( ncvarindex(grdchkvarindex).EQ.4 ) THEN
#ifdef ALLOW_OBCSW_CONTROL
               nwettile(bi,bj,k,iobcs) = nwetobcsw(bi,bj,k,iobcs)
#endif
             ENDIF
           ENDDO
          ENDDO
         ENDDO
        ENDDO
#endif /* ALLOW_OBCS_CONTROL */
      ELSE
Ce        --> wrong grid specification for the control variable.
      ENDIF

C--   get mask file for obcs
#ifdef ALLOW_OBCS_CONTROL
      CALL GRDCHK_GET_OBCS_MASK( myThid )
#endif

C     ----------------------------------------------------------------

C--   Determine the actual and the maximum possible number of
C--   components of the given control variable.
      ncvarcomp     = 0
      maxncvarcomps = 0
      DO bj = jtlo,jthi
       DO bi = itlo,ithi
        DO k = 1,ncvarnrmax(grdchkvarindex)
         DO iobcs = 1, nobcsmax
           ncvarcomp     = ncvarcomp + nwettile(bi,bj,k,iobcs)
           maxncvarcomps = maxncvarcomps
     &      + ncvarxmax(grdchkvarindex)*ncvarymax(grdchkvarindex)
         ENDDO
        ENDDO
       ENDDO
      ENDDO
      ncvarcomp     = ncvarcomp*ncvarrecs(grdchkvarindex)
      maxncvarcomps = maxncvarcomps*ncvarrecs(grdchkvarindex)

      DO bj = jtlo,jthi
       DO bi = itlo,ithi
         iwetsum(bi,bj,0)    = 0
         DO k = 1,ncvarnrmax(grdchkvarindex)
           iwetsum(bi,bj,k) = iwetsum(bi,bj,k-1) + nwettile(bi,bj,k,1)
         ENDDO
       ENDDO
      ENDDO

      _END_MASTER( myThid )

      _BARRIER

#endif /* ALLOW_GRDCHK */

      RETURN
      END

#include "CTRL_OPTIONS.h"

CBOP
C     !ROUTINE: CTRL_MAP_INI_GENARR
C     !INTERFACE:
      SUBROUTINE CTRL_MAP_INI_GENARR( myThid )

C     !DESCRIPTION: \bv
C     *=================================================================
C     | SUBROUTINE CTRL_MAP_INI_GENARR
C     | Add the generic arrays of the
C     | control vector to the model state and update the tile halos.
C     | The control vector is defined in the header file "CTRL.h".
C     *=================================================================
C     | local version for OpenAD exp. tutorial_global_oce_optim
C     *=================================================================
C     \ev

C     !USES:
      IMPLICIT NONE

C     == global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
CML#include "DYNVARS.h"
#include "FFIELDS.h"
#include "CTRL_SIZE.h"
#include "CTRL.h"
#include "CTRL_GENARR.h"
#include "CTRL_DUMMY.h"
#include "OPTIMCYCLE.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == routine arguments ==
      INTEGER myThid

C     !FUNCTIONS:
      INTEGER  ILNBLNk
      EXTERNAL ILNBLNK

C     !LOCAL VARIABLES:
C     == local variables ==
      INTEGER bi,bj
      INTEGER i,j
      INTEGER il
      INTEGER iarr

      LOGICAL doglobalread
      LOGICAL ladinit
      CHARACTER*(MAX_LEN_FNAM) fnamebase
      CHARACTER*(MAX_LEN_FNAM) fnamegeneric
      _RL     fac
#ifdef ALLOW_GENARR2D_CONTROL
      _RL     tmpfld2d(1-OLx:sNx+OLx,1-OLy:sNy+OLy,   nSx,nSy)
#endif
#ifdef ALLOW_GENARR3D_CONTROL
      INTEGER k
      _RL     tmpfld3d(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
#endif
CEOP

      doglobalread = .FALSE.
      ladinit      = .FALSE.
      fac = 1. _d 0

#ifdef ALLOW_GENARR2D_CONTROL
C--   An example of connecting specific fields
C--   to 3 generic 2D control arrays
cc--->>>
cc--->>> COMPILE FAILURE IS DELIBERATE
cc--->>> BE SURE WHAT YOU ARE DOING AND CUSTOMIZE <<<---
cc--->>>
C--   generic - user-defined control vars
      DO iarr = 1, maxCtrlArr2D

C     The control variables in this experiment is the mean heat flux. As
C     is it constant in time , we can specify it here and add it to qnet
C     at the beginning of the integration.
       DO bj=myByLo(myThid), myByHi(myThid)
        DO bi=myBxLo(myThid), myBxHi(myThid)
         DO j = 1,sNy
          DO i = 1,sNx
           tmpfld2d(i,j,bi,bj) = 0. _d 0
          ENDDO
         ENDDO
        ENDDO
       ENDDO
       fnamebase = xx_genarr2d_file(iarr)
       il=ILNBLNK( fnamebase )
       WRITE(fnamegeneric,'(2A,I10.10)')
     &     fnamebase(1:il),'.',optimcycle
       CALL ACTIVE_READ_XY ( fnamegeneric, tmpfld2d, 1,
     &                      doglobalread, ladinit, optimcycle,
     &                      myThid, xx_genarr2d_dummy(iarr) )
       IF ( iarr .EQ. 1 ) THEN
        DO bj=myByLo(myThid), myByHi(myThid)
         DO bi=myBxLo(myThid), myBxHi(myThid)
          DO j = 1,sNy
           DO i = 1,sNx
            Qnetm(i,j,bi,bj) = Qnetm(i,j,bi,bj)
     &           + fac*tmpfld2d(i,j,bi,bj)
           ENDDO
          ENDDO
         ENDDO
        ENDDO
       ENDIF
C--   end iarr loop
      ENDDO
      _EXCH_XY_RS( Qnetm, myThid )

#endif /* ALLOW_GENARR2D_CONTROL */

#ifdef ALLOW_GENARR3D_CONTROL
C--   An example of connecting specific fields
C--   to 3 generic 3D control arrays
cc--->>>
cc--->>> COMPILE FAILURE IS DELIBERATE
cc--->>> BE SURE WHAT YOU ARE DOING AND CUSTOMIZE <<<---
cc--->>>
cc

C--   generic - user-defined control vars
      DO iarr = 1, maxCtrlArr3D

       DO bj=myByLo(myThid), myByHi(myThid)
        DO bi=myBxLo(myThid), myBxHi(myThid)
         DO k = 1,Nr
          DO j = 1,sNy
           DO i = 1,sNx
            tmpfld3d(i,j,k,bi,bj) = 0. _d 0
           ENDDO
          ENDDO
         ENDDO
        ENDDO
       ENDDO
       fnamebase = xx_genarr3d_file(iarr)
       il=ILNBLNK( fnamebase )
       WRITE(fnamegeneric,'(2A,I10.10)')
     &     fnamebase(1:il),'.',optimcycle
       CALL ACTIVE_READ_XYZ( fnamegeneric, tmpfld3d, 1,
     &                       doglobalread, ladinit, optimcycle,
     &                       myThid, xx_genarr3d_dummy(iarr) )
       IF ( iarr .EQ. 1 ) THEN
CML        DO bj=myByLo(myThid), myByHi(myThid)
CML         DO bi=myBxLo(myThid), myBxHi(myThid)
CML          DO k = 1,Nr
CML           DO j = 1,sNy
CML            DO i = 1,sNx
CML             theta(i,j,k,bi,bj) = theta(i,j,k,bi,bj)
CML     &         + fac*tmpfld3d(i,j,k,bi,bj)
CML            ENDDO
CML           ENDDO
CML          ENDDO
CML         ENDDO
CML        ENDDO
CML        CALL EXCH_3D_RL( theta, Nr, myThid )
      ENDIF

C--   end iarr loop
      ENDDO

#endif /* ALLOW_GENARR3D_CONTROL */

      RETURN
      END

#include "GMREDI_OPTIONS.h"
#ifdef ALLOW_AUTODIFF
# include "AUTODIFF_OPTIONS.h"
#endif

CBOP
C     !ROUTINE: GMREDI_SLOPE_PSI
C     !INTERFACE:
      SUBROUTINE GMREDI_SLOPE_PSI(
     O             taperX, taperY,
     U             SlopeX, SlopeY,
     U             dSigmaDrW, dSigmaDrS,
     I             LrhoW, LrhoS, rDepth, k,
     I             bi, bj, myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE GMREDI_SLOPE_PSI                              |
C     | o Calculate slopes for use in GM advective form          |
C     *==========================================================*
C     | On entry:                                                |
C     |     dSigmaDrW,S  contains the -d/dz Sigma if Z-coords    |
C     |                           but  d/dp Sigma if P-coords    |
C     |     SlopeX/Y     contains X/Y gradients of sigma         |
C     |     rDepth       depth (> 0) in r-Unit from the surface  |
C     | On exit:                                                 |
C     |     dSigmaDrW,S  contains the effective dSig/dz          |
C     |     SlopeX/Y     contains X/Y slopes                     |
C     |     taperFct     contains tapering funct. value ;        |
C     |                  = 1 when using no tapering              |
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "GMREDI.h"
#include "PARAMS.h"
#ifdef ALLOW_AUTODIFF_TAMC
# include "tamc.h"
#endif /* ALLOW_AUTODIFF_TAMC */

C     !INPUT/OUTPUT PARAMETERS:
      _RL taperX(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL taperY(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL SlopeX(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL SlopeY(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL dSigmaDrW(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL dSigmaDrS(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL LrhoW(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL LrhoS(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL rDepth
      INTEGER k,bi,bj,myThid

#ifdef ALLOW_GMREDI
#ifdef GM_BOLUS_ADVEC

C     !LOCAL VARIABLES:
      _RL dSigmaDrLtd(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL f1, Smod, f2, Rnondim
      _RL maxSlopeSqr
      _RL slopeCutoff
      _RL loc_maxSlope, loc_rMaxSlope
      _RL fpi
      PARAMETER( fpi = PI )
      INTEGER i, j
#ifdef GMREDI_WITH_STABLE_ADJOINT
      _RL slopeMaxSpec
#endif
#ifdef ALLOW_AUTODIFF_TAMC
C     kkey :: tape key (depends on levels and tiles)
      INTEGER kkey
#endif
CEOP

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      slopeCutoff = SQRT( GM_slopeSqCutoff )
C-    Note regarding slopeCutoff: current code by-passes the reduction of taper
C     fct when slope is larger than "slopeCutoff", and this is not very safe !
C     However, with default GM_Small_Number (=1.E-20) and default value of
C     GM_slopeSqCutoff (=1.E+48), this is unlikely to occur as it would require
C     |sigmaX/Y| > 1.e+4

      loc_maxSlope  = GM_maxSlope*wUnit2rVel(k)
      loc_rMaxSlope = GM_rMaxSlope*rVel2wUnit(k)

#ifdef ALLOW_AUTODIFF_TAMC
      kkey = bi + (bj-1)*nSx + (ikey_dynamics-1)*nSx*nSy
      kkey = k + (kkey-1)*Nr
#endif /* ALLOW_AUTODIFF_TAMC */

      IF (GM_taper_scheme.EQ.'orig' .OR.
     &    GM_taper_scheme.EQ.'clipping') THEN

#ifdef GM_EXCLUDE_CLIPPING

        STOP 'Need to compile without "#define GM_EXCLUDE_CLIPPING"'

#else  /* GM_EXCLUDE_CLIPPING */

C-      Original implementation in mitgcmuv
C       (this turns out to be the same as Cox slope clipping)

C-- X-comp

#ifdef ALLOW_AUTODIFF
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx+1,sNx+OLx
          dSigmaDrLtd(i,j) = 0. _d 0
         ENDDO
        ENDDO
#endif /* ALLOW_AUTODIFF */

C-      Cox 1987 "Slope clipping"
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx+1,sNx+OLx
          dSigmaDrLtd(i,j) = GM_Small_Number
     &     + ABS(SlopeX(i,j))*loc_rMaxSlope
         ENDDO
        ENDDO
#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE dSigmaDrLtd(:,:)  = comlev1_bibj_k, key=kkey, byte=isbyte
CADJ STORE dSigmaDrW(:,:)    = comlev1_bibj_k, key=kkey, byte=isbyte
#endif
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx+1,sNx+OLx
          IF (dSigmaDrW(i,j).LE.dSigmaDrLtd(i,j))
     &        dSigmaDrW(i,j) = dSigmaDrLtd(i,j)
         ENDDO
        ENDDO
#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE dSigmaDrW(:,:)    = comlev1_bibj_k, key=kkey, byte=isbyte
#endif
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx+1,sNx+OLx
          SlopeX(i,j) = SlopeX(i,j)/dSigmaDrW(i,j)
          taperX(i,j) = 1. _d 0
         ENDDO
        ENDDO

C-- Y-comp

#ifdef ALLOW_AUTODIFF
        DO j=1-OLy+1,sNy+OLy
         DO i=1-OLx,sNx+OLx
          dSigmaDrLtd(i,j) = 0. _d 0
         ENDDO
        ENDDO
#endif /* ALLOW_AUTODIFF */
        DO j=1-OLy+1,sNy+OLy
         DO i=1-OLx,sNx+OLx
          dSigmaDrLtd(i,j) = GM_Small_Number
     &     + ABS(SlopeY(i,j))*loc_rMaxSlope
         ENDDO
        ENDDO
#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE dSigmaDrLtd(:,:)  = comlev1_bibj_k, key=kkey, byte=isbyte
CADJ STORE dSigmaDrS(:,:)    = comlev1_bibj_k, key=kkey, byte=isbyte
#endif
        DO j=1-OLy+1,sNy+OLy
         DO i=1-OLx,sNx+OLx
          IF (dSigmaDrS(i,j).LE.dSigmaDrLtd(i,j))
     &        dSigmaDrS(i,j) = dSigmaDrLtd(i,j)
         ENDDO
        ENDDO
#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE dSigmaDrS(:,:)    = comlev1_bibj_k, key=kkey, byte=isbyte
#endif
        DO j=1-OLy+1,sNy+OLy
         DO i=1-OLx,sNx+OLx
          SlopeY(i,j) = SlopeY(i,j)/dSigmaDrS(i,j)
          taperY(i,j) = 1. _d 0
         ENDDO
        ENDDO

#endif /* GM_EXCLUDE_CLIPPING */

      ELSEIF (GM_taper_scheme.EQ.'fm07') THEN

        STOP 'GMREDI_SLOPE_PSI: AdvForm not yet implemented for fm07'

      ELSE

#ifdef GM_EXCLUDE_TAPERING

        STOP 'Need to compile without "#define GM_EXCLUDE_TAPERING"'

#else  /* GM_EXCLUDE_TAPERING */

#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE slopeX(:,:)       = comlev1_bibj_k, key=kkey, byte=isbyte
CADJ STORE dSigmaDrW(:,:)    = comlev1_bibj_k, key=kkey, byte=isbyte
#endif

C- Compute the slope, no clipping, but avoid reverse slope in negatively
C                                  stratified (dSigmaDr < 0) region :
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx+1,sNx+OLx
          IF (dSigmaDrW(i,j).LE.GM_Small_Number)
     &        dSigmaDrW(i,j) = GM_Small_Number
         ENDDO
        ENDDO
#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE dsigmaDrW(:,:)    = comlev1_bibj_k, key=kkey, byte=isbyte
#endif
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx+1,sNx+OLx
          SlopeX(i,j) = SlopeX(i,j)/dSigmaDrW(i,j)
          taperX(i,j) = 1. _d 0
         ENDDO
        ENDDO
#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE slopeX(:,:)    = comlev1_bibj_k, key=kkey, byte=isbyte
#endif
        IF (GM_taper_scheme.NE.'stableGmAdjTap') THEN
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx+1,sNx+OLx
           IF ( ABS(SlopeX(i,j)) .GE. slopeCutoff ) THEN
             SlopeX(i,j) = SIGN(slopeCutoff,SlopeX(i,j))
             taperX(i,j) = 0. _d 0
           ENDIF
          ENDDO
         ENDDO
        ENDIF

#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE slopeY(:,:)       = comlev1_bibj_k, key=kkey, byte=isbyte
CADJ STORE dSigmaDrS(:,:)    = comlev1_bibj_k, key=kkey, byte=isbyte
#endif

        DO j=1-OLy+1,sNy+OLy
         DO i=1-OLx,sNx+OLx
          IF (dSigmaDrS(i,j).LE.GM_Small_Number)
     &        dSigmaDrS(i,j) = GM_Small_Number
         ENDDO
        ENDDO
#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE dsigmaDrS(:,:)    = comlev1_bibj_k, key=kkey, byte=isbyte
#endif
        DO j=1-OLy+1,sNy+OLy
         DO i=1-OLx,sNx+OLx
          SlopeY(i,j) = SlopeY(i,j)/dSigmaDrS(i,j)
          taperY(i,j) = 1. _d 0
         ENDDO
        ENDDO
#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE slopeY(:,:)    = comlev1_bibj_k, key=kkey, byte=isbyte
#endif
        IF (GM_taper_scheme.NE.'stableGmAdjTap') THEN
         DO j=1-OLy+1,sNy+OLy
          DO i=1-OLx,sNx+OLx
           IF ( ABS(SlopeY(i,j)) .GE. slopeCutoff ) THEN
             SlopeY(i,j) = SIGN(slopeCutoff,SlopeY(i,j))
             taperY(i,j) = 0. _d 0
           ENDIF
          ENDDO
         ENDDO
        ENDIF

C- Compute the tapering function for the GM+Redi tensor :

#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE slopeX(:,:)       = comlev1_bibj_k, key=kkey, byte=isbyte
CADJ STORE slopeY(:,:)       = comlev1_bibj_k, key=kkey, byte=isbyte
#endif

       IF (GM_taper_scheme.EQ.'linear') THEN

C-      Simplest adiabatic tapering = Smax/Slope (linear)
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx+1,sNx+OLx
          Smod = ABS(SlopeX(i,j))
          IF ( Smod .GT. loc_maxSlope .AND.
     &         Smod .LT. slopeCutoff )
     &      taperX(i,j) = loc_maxSlope/(Smod+GM_Small_Number)
         ENDDO
        ENDDO
        DO j=1-OLy+1,sNy+OLy
         DO i=1-OLx,sNx+OLx
          Smod = ABS(SlopeY(i,j))
          IF ( Smod .GT. loc_maxSlope .AND.
     &         Smod .LT. slopeCutoff )
     &      taperY(i,j) = loc_maxSlope/(Smod+GM_Small_Number)
         ENDDO
        ENDDO

       ELSEIF ( GM_taper_scheme.EQ.'gkw91' .OR.
     &          GM_taper_scheme.EQ.'ac02' ) THEN

C-      Gerdes, Koberle and Willebrand, Clim. Dyn. 1991
        maxSlopeSqr = loc_maxSlope*loc_maxSlope
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx+1,sNx+OLx
          Smod = ABS(SlopeX(i,j))
          IF ( Smod .GT. loc_maxSlope .AND.
     &         Smod .LT. slopeCutoff )
     &      taperX(i,j) = maxSlopeSqr/
     &           ( SlopeX(i,j)*SlopeX(i,j) + GM_Small_Number )
         ENDDO
        ENDDO
        DO j=1-OLy+1,sNy+OLy
         DO i=1-OLx,sNx+OLx
          Smod = ABS(SlopeY(i,j))
          IF ( Smod .GT. loc_maxSlope .AND.
     &         Smod .LT. slopeCutoff )
     &      taperY(i,j) = maxSlopeSqr/
     &           ( SlopeY(i,j)*SlopeY(i,j) + GM_Small_Number )
         ENDDO
        ENDDO

       ELSEIF (GM_taper_scheme.EQ.'dm95') THEN

C-      Danabasoglu and McWilliams, J. Clim. 1995
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx+1,sNx+OLx
          Smod = ABS(SlopeX(i,j))*rVel2wUnit(k)
          taperX(i,j) = op5*( oneRL + TANH( (GM_Scrit-Smod)/GM_Sd ))
         ENDDO
        ENDDO
        DO j=1-OLy+1,sNy+OLy
         DO i=1-OLx,sNx+OLx
          Smod = ABS(SlopeY(i,j))*rVel2wUnit(k)
          taperY(i,j) = op5*( oneRL + TANH( (GM_Scrit-Smod)/GM_Sd ))
         ENDDO
        ENDDO

       ELSEIF (GM_taper_scheme.EQ.'ldd97') THEN

C-      Large, Danabasoglu and Doney, JPO 1997

        DO j=1-OLy,sNy+OLy
         DO i=1-OLx+1,sNx+OLx
          Smod = ABS(SlopeX(i,j))
          IF ( Smod .LT. slopeCutoff ) THEN
            f1 = op5*( oneRL
     &               + TANH( (GM_Scrit-Smod*rVel2wUnit(k))/GM_Sd ) )
            IF ( Smod.NE.zeroRL ) THEN
              Rnondim = rDepth/( LrhoW(i,j)*Smod )
            ELSE
              Rnondim = 1. _d 0
            ENDIF
            IF ( Rnondim.GE.oneRL ) THEN
              f2 = 1. _d 0
            ELSE
              f2 = op5*( oneRL + SIN( fpi*(Rnondim-op5) ))
            ENDIF
            taperX(i,j) = f1*f2
          ENDIF
         ENDDO
        ENDDO

        DO j=1-OLy+1,sNy+OLy
         DO i=1-OLx,sNx+OLx
          Smod = ABS(SlopeY(i,j))
          IF ( Smod .LT. slopeCutoff ) THEN
            f1 = op5*( oneRL
     &               + TANH( (GM_Scrit-Smod*rVel2wUnit(k))/GM_Sd ) )
            IF ( Smod.NE.zeroRL ) THEN
              Rnondim = rDepth/( LrhoS(i,j)*Smod )
            ELSE
              Rnondim = 1. _d 0
            ENDIF
            IF ( Rnondim.GE.oneRL ) THEN
              f2 = 1. _d 0
            ELSE
              f2 = op5*( oneRL + SIN( fpi*(Rnondim-op5) ))
            ENDIF
            taperY(i,j) = f1*f2
          ENDIF
         ENDDO
        ENDDO

       ELSEIF (GM_taper_scheme.EQ.'stableGmAdjTap') THEN

#ifndef GMREDI_WITH_STABLE_ADJOINT

        STOP 'Need to compile wth "#define GMREDI_WITH_STABLE_ADJOINT"'

#else  /* GMREDI_WITH_STABLE_ADJOINT */

c special choice for adjoint/optimization of parameters
c (~ strong clipping, reducing non linearity of psi=f(K))

        slopeMaxSpec=1. _d -4

#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE slopeX(:,:)       = comlev1_bibj_k, key=kkey, byte=isbyte
CADJ STORE slopeY(:,:)       = comlev1_bibj_k, key=kkey, byte=isbyte
#endif
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx+1,sNx+OLx
          Smod = ABS(SlopeX(i,j))
          IF ( Smod .GT. slopeMaxSpec ) THEN
           SlopeX(i,j) = 5.*SlopeX(i,j)*slopeMaxSpec/Smod
          ELSE
           SlopeX(i,j) = 5.*SlopeX(i,j)
          ENDIF
          taperX(i,j) = 1.
         ENDDO
        ENDDO
        DO j=1-OLy+1,sNy+OLy
         DO i=1-OLx,sNx+OLx
          Smod = ABS(SlopeY(i,j))
          IF ( Smod .GT. slopeMaxSpec ) THEN
           SlopeY(i,j) = 5.*SlopeY(i,j)*slopeMaxSpec/Smod
          ELSE
           SlopeY(i,j) = 5.*SlopeY(i,j)
          ENDIF
          taperY(i,j) = 1.
         ENDDO
        ENDDO
#endif /* GMREDI_WITH_STABLE_ADJOINT */

       ELSEIF (GM_taper_scheme.NE.' ') THEN
        STOP 'GMREDI_SLOPE_PSI: Bad GM_taper_scheme'
       ENDIF

#endif /* GM_EXCLUDE_TAPERING */

      ENDIF

#endif /* BOLUS_ADVEC */
#endif /* ALLOW_GMREDI */

      RETURN
      END

#include "OBCS_OPTIONS.h"

CBOP
C     !ROUTINE: OBCS_COPY_TRACER
C     !INTERFACE:

      SUBROUTINE OBCS_COPY_TRACER(
     U                             trFld,
     I                             kSiz, bi, bj, myThid )

C     !DESCRIPTION:
C     *==========================================================*
C     | S/R OBCS_COPY_TRACER
C     | Copy tracer value from the OB location to narrow band
C     |   region (width = same as overlap) beyond the OB.
C     *==========================================================*
C     | Note: need this copy after an EXCH when:
C     |  1) a several grid-point stencil scheme (e.g., high order
C     |     advection scheme) is used for tracer.
C     |  2) OB is so close to tile edge (e.g., OB_Iw=1) that, to
C     |     compute fluxes at the OB, a high-order scheme will
C     |     use grid points from the overlap region.
C     *==========================================================*

C     !USES:
      IMPLICIT NONE
C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "OBCS_GRID.h"

C     !INPUT/OUTPUT PARAMETERS:
C    trFld    :: tracer-field array which OBC applies to.
C    kSiz     :: 3rd dim of tracer-field array "trFld"
C    bi, bj   :: indices of current tile
C    myThid   :: my Thread Id number
      INTEGER kSiz
      _RL     trFld(1-OLx:sNx+OLx,1-OLy:sNy+OLy,kSiz)
      INTEGER bi, bj
      INTEGER myThid
CEOP

#ifdef ALLOW_OBCS

C     !LOCAL VARIABLES:
      INTEGER i, j, k
#if (defined ALLOW_OBCS_EAST ) || (defined ALLOW_OBCS_WEST )
      INTEGER Iobc
#endif
#if (defined ALLOW_OBCS_NORTH) || (defined ALLOW_OBCS_SOUTH)
      INTEGER Jobc
#endif

C     Set model variables to OB values on North/South Boundaries
#ifdef ALLOW_OBCS_NORTH
      IF ( tileHasOBN(bi,bj) ) THEN
C Northern boundary
         DO i=1-OLx,sNx+OLx
          Jobc = OB_Jn(i,bi,bj)
          IF ( Jobc.NE.OB_indexNone ) THEN
           DO k = 1,kSiz
            DO j = Jobc+1, Jobc+OLy
             trFld(i,j,k) = trFld(i,Jobc,k)
            ENDDO
           ENDDO
          ENDIF
         ENDDO
      ENDIF
#endif /* ALLOW_OBCS_NORTH */

#ifdef ALLOW_OBCS_SOUTH
      IF ( tileHasOBS(bi,bj) ) THEN
C Southern boundary
         DO i=1-OLx,sNx+OLx
          Jobc = OB_Js(i,bi,bj)
          IF ( Jobc.NE.OB_indexNone ) THEN
           DO k = 1,kSiz
            DO j = Jobc-OLy, Jobc-1
             trFld(i,j,k) = trFld(i,Jobc,k)
            ENDDO
           ENDDO
          ENDIF
         ENDDO
      ENDIF
#endif /* ALLOW_OBCS_SOUTH */

C     Set model variables to OB values on East/West Boundaries
#ifdef ALLOW_OBCS_EAST
      IF ( tileHasOBE(bi,bj) ) THEN
C Eastern boundary
         DO j=1-OLy,sNy+OLy
          Iobc = OB_Ie(j,bi,bj)
          IF ( Iobc.NE.OB_indexNone ) THEN
           DO k = 1,kSiz
            DO i = Iobc+1, Iobc+OLx
             trFld(i,j,k) = trFld(Iobc,j,k)
            ENDDO
           ENDDO
          ENDIF
         ENDDO
      ENDIF
#endif /* ALLOW_OBCS_EAST */

#ifdef ALLOW_OBCS_WEST
      IF ( tileHasOBW(bi,bj) ) THEN
C Western boundary
         DO j=1-OLy,sNy+OLy
          Iobc = OB_Iw(j,bi,bj)
          IF ( Iobc.NE.OB_indexNone ) THEN
           DO k = 1,kSiz
            DO i = Iobc-OLx, Iobc-1
             trFld(i,j,k) = trFld(Iobc,j,k)
            ENDDO
           ENDDO
          ENDIF
         ENDDO
      ENDIF
#endif /* ALLOW_OBCS_WEST */

#endif /* ALLOW_OBCS */

      RETURN
      END

#include "GAD_OPTIONS.h"

CBOP
C !ROUTINE: CHEAPAML_CALC_RHS

C !INTERFACE: ==========================================================
      SUBROUTINE CHEAPAML_CALC_RHS(
     I           bi,bj, iMin,iMax,jMin,jMax,
     I           uTrans, vTrans,
     I           uVel, vVel,
     I           diffKh, Tracer,
     I           deltaTtracer, zu,
     I           useFluxLimit, cheapamlXperiodic, cheapamlYperiodic,
     O           wVel,
     U           gTracer,
     I           myTime, myIter, myThid )

C !DESCRIPTION:
C Calculates the tendency of a tracer due to advection and diffusion.
C Because horizontal velocity field is potential divergent, it is
C necessary to compute the vertical velocity and to compute the
C vertical flux divergence.
C The fluxes in each direction are computed independently and then
C the tendency is set to the divergence of these fluxes.
C In Cheapaml, it is always assumed the boundaries are open, and
C a simple open boundary implementation is used, whereby if the
C transport is outward directed, upwind weighting is used
C for the advective flux and the diffusive flux is shut off.
C If the transport is inward directed, the advective flux is computed
C using the Tr file, as is the diffusive flux.
C
C The tendency is the divergence of the fluxes:
C \begin{equation*}
C G_\theta = G_\theta + \nabla \cdot {\bf F}
C \end{equation*}
C
C The tendency is assumed to contain data on entry.

C !USES: ===============================================================
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "GAD.h"

C !INPUT PARAMETERS: ===================================================
C bi,bj            :: tile indices
C iMin,iMax        :: loop range for called routines
C jMin,jMax        :: loop range for called routines
C uTrans,vTrans    :: 2-D arrays of volume transports at U,V points
C uVel,vVel,       :: 2 components of the velcity field (2-D array)
C diffKh           :: horizontal diffusion coefficient
C Tracer           :: tracer field
C deltaTtracer     :: atmospheric tracer time step
C zu               ::
C useFluxLimit     ::
C cheapamlXperiodic :: cheapaml domain is periodic in X dir
C cheapamlYperiodic :: cheapaml domain is periodic in Y dir
C myTime           :: current time
C myIter           :: iteration number
C myThid           :: thread number
      INTEGER bi,bj,iMin,iMax,jMin,jMax
      _RL uTrans(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL vTrans(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL uVel  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL vVel  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL diffKh
      _RL Tracer(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL deltaTtracer, zu
      LOGICAL useFluxLimit
      LOGICAL cheapamlXperiodic, cheapamlYperiodic
      _RL     myTime
      INTEGER myIter, myThid

C !OUTPUT PARAMETERS: ==================================================
C wVel             ::
C gTracer          :: tendency array
      _RL wVel   (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL gTracer(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)

C !LOCAL VARIABLES: ====================================================
C i,j              :: loop indices
C fZon             :: zonal fluxes
C fMer             :: meridional fluxes
C fVer             :: vertical fluxes
C af               :: advective fluxes
C df               :: diffusive flux
C localT           :: local copy of tracer field
C horizDiv         :: divergence of the horizontal wind
C maskLocW         :: local copy of West Face Land Mask
C maskLocS         :: local copy of South Face Land Mask

      INTEGER i,j, iG,jG, ii, jj
      _RL fZon  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL fMer  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL df    (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL localT(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL horizDiv(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RS maskLocW(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RS maskLocS(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
CEOP

C--   Initialize fluxes
      DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
          df(i,j)   = 0. _d 0
          fZon(i,j) = 0. _d 0
          fMer(i,j) = 0. _d 0
        ENDDO
      ENDDO

C--   Make local copy of tracer array
C--   and compute w
      DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
          localT(i,j)=tracer(i,j,bi,bj)
        ENDDO
      ENDDO
      DO j=1-OLy,sNy+OLy-1
        DO i=1-OLx,sNx+OLx-1
          horizDiv(i,j) = (
     &       ( uTrans(i+1,j) - uTrans(i,j) )
     &     + ( vTrans(i,j+1) - vTrans(i,j) )
     &                    )*recip_rA(i,j,bi,bj)
          wVel(i,j,bi,bj) = -horizDiv(i,j)
        ENDDO
      ENDDO

C     prepare boundary tracer values
      IF(.NOT.cheapamlXperiodic)THEN
       DO j=1,sNy
        DO i=1,sNx
         iG=myXGlobalLo-1+(bi-1)*sNx+i
         IF (iG.EQ.2) THEN
           IF (uVel(i,j,bi,bj).LT.0. _d 0) THEN
             DO ii=1-OLx,1
              localT(ii,j)=localT(i,j)
             ENDDO
           ENDIF
         ELSEIF (iG.EQ.Nx-1) THEN
           IF (uVel(i+1,j,bi,bj).GT.0. _d 0) THEN
             DO ii=sNx,sNx+OLx
              localT(ii,j)=localT(i,j)
             ENDDO
           ENDIF
         ENDIF
        ENDDO
       ENDDO
      ENDIF
C     -    Advective flux in X
      IF (useFluxLimit) THEN
C     make local copy of west land mask
        DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
c            maskLocW(i,j)=maskW(i,j,1,bi,bj)
C     change to allow advection on land
             maskLocW(i,j)=1. _d 0
          ENDDO
        ENDDO
        CALL GAD_DST3FL_ADV_X(
     I     bi,bj,1,.TRUE., deltaTtracer,
     I     uTrans, uVel(1-OLx,1-OLy,bi,bj),
     I     maskLocW, localT,
     O     fZon,
     I     myThid )
      ELSE
        CALL GAD_C2_ADV_X( bi,bj,1,uTrans,localT,fZon,myThid )
      ENDIF

C     -    Diffusive flux in X
      IF ( diffKh.NE.zeroRL ) THEN
        CALL GAD_DIFF_X( bi,bj,1, dyG(1-OLx,1-OLy,bi,bj),
     I                   diffKh, localT,
     O                   df, myThid )
        DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
            fZon(i,j) = fZon(i,j) + df(i,j)
          ENDDO
        ENDDO
      ENDIF

C     repair boundary tracer values
      IF(.NOT.cheapamlXperiodic)THEN
       DO j=1,sNy
        DO i=1,sNx
         iG=myXGlobalLo-1+(bi-1)*sNx+i
         IF (iG.EQ.2) THEN
           IF (uVel(i,j,bi,bj).LT.0. _d 0) THEN
             DO ii=1-OLx,1
              localT(ii,j)=tracer(ii,j,bi,bj)
             ENDDO
           ENDIF
          ELSEIF (iG.EQ.Nx-1) THEN
           IF (uVel(i+1,j,bi,bj).GT.0. _d 0) THEN
             DO ii=sNx,sNx+OLx
              localT(ii,j)=tracer(ii,j,bi,bj)
             ENDDO
           ENDIF
         ENDIF
        ENDDO
       ENDDO
      ENDIF

C     -    Advective flux in Y

C     prepare boundary tracer values
      IF(.NOT.cheapamlYperiodic)THEN
       DO j=1,sNy
        jG = myYGlobalLo-1+(bj-1)*sNy+j
        DO i=1,sNx
         IF (jG.EQ.2) THEN
           IF (vVel(i,j,bi,bj).LT.0. _d 0) THEN
             DO jj=1-OLy,1
              localT(i,jj)=localT(i,j)
             ENDDO
           ENDIF
         ELSEIF (jG.EQ.Ny-1) THEN
           IF (vVel(i,j+1,bi,bj).GT.0. _d 0) THEN
             DO jj=sNy,sNy+OLy
              localT(i,jj)=localT(i,j)
             ENDDO
           ENDIF
         ENDIF
        ENDDO
       ENDDO
      ENDIF

      IF (useFluxLimit) THEN
C     make local copy of south land mask
        DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
c            maskLocS(i,j)=maskS(i,j,1,bi,bj)
C Change to allow advection on land
            maskLocS(i,j)= 1. _d 0
          ENDDO
        ENDDO
        CALL GAD_DST3FL_ADV_Y(
     I     bi,bj,1,.TRUE., deltaTtracer,
     I     vTrans, vVel(1-OLx,1-OLy,bi,bj),
     I     maskLocS, localT,
     O     fMer,
     I     myThid )
      ELSE
        CALL GAD_C2_ADV_Y( bi,bj,1,vTrans,localT,fMer,myThid )
      ENDIF

C     -    Diffusive flux in Y
      IF ( diffKh.NE.zeroRL ) THEN
        CALL GAD_DIFF_Y( bi,bj,1, dxG(1-OLx,1-OLy,bi,bj),
     I                   diffKh, localT,
     O                   df, myThid )
        IF ( .NOT.cheapamlYperiodic ) THEN
         DO j=1,sNy+1
          jG = myYGlobalLo-1+(bj-1)*sNy+j
          IF ( jG.EQ.1 .OR. jG.EQ.Ny ) THEN
C- Note: conditions above ire strange. Instead, should it be:
c         IF ( jG.EQ.1 .OR. jG.EQ.Ny+1 ) THEN
           DO i=1-OLx,sNx+OLx
            df(i,j) = 0. _d 0
           ENDDO
          ENDIF
         ENDDO
        ENDIF
        DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
            fMer(i,j) = fMer(i,j) + df(i,j)
          ENDDO
        ENDDO
      ENDIF

C--   Divergence of fluxes
      DO j=1-OLy,sNy+OLy-1
        DO i=1-OLx,sNx+OLx-1
          gTracer(i,j,bi,bj) =
     &       -( ( fZon(i+1,j) - fZon(i,j) )
     &        + ( fMer(i,j+1) - fMer(i,j) )
     &        )*recip_rA(i,j,bi,bj)
     &       + horizDiv(i,j)*localT(i,j)
        ENDDO
      ENDDO

      RETURN
      END

#include "SEAICE_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: SEAICE_MONITOR

C     !INTERFACE:
      SUBROUTINE SEAICE_MONITOR(
     I                  myTime, myIter, myThid )

C     !DESCRIPTION:
C     Print some statistics about input forcing fields.

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "SEAICE_SIZE.h"
#include "SEAICE_PARAMS.h"
#ifdef SEAICE_BGRID_DYNAMICS
# include "SEAICE_GRID.h"
#endif
#include "SEAICE.h"
#include "SEAICE_TRACER.h"
#ifdef ALLOW_MONITOR
# include "MONITOR.h"
#endif

C     !INPUT PARAMETERS:
      INTEGER myIter
      _RL myTime
      INTEGER myThid
CEOP

#ifdef ALLOW_MONITOR
C     === Functions ====
      LOGICAL  DIFFERENT_MULTIPLE
      EXTERNAL DIFFERENT_MULTIPLE
      LOGICAL  MASTER_CPU_IO
      EXTERNAL MASTER_CPU_IO

C     == Local variables ==
      CHARACTER*(MAX_LEN_MBUF) msgBuf
#ifdef ALLOW_SITRACER
      INTEGER iTracer
      CHARACTER*(MAX_LEN_MBUF) suff
#endif
#ifdef ALLOW_MNC
      INTEGER i
#endif /* ALLOW_MNC */
      _RL dummyRL(6)

      IF ( DIFFERENT_MULTIPLE(SEAICE_monFreq,myTime,deltaTClock)
     &   ) THEN

        IF ( MASTER_CPU_IO(myThid) ) THEN
C--   only the master thread is allowed to switch On/Off mon_write_stdout
C     & mon_write_mnc (since it is the only thread that uses those flags):

          IF (SEAICE_mon_stdio) THEN
            mon_write_stdout = .TRUE.
          ELSE
            mon_write_stdout = .FALSE.
          ENDIF
          mon_write_mnc = .FALSE.
#ifdef ALLOW_MNC
          IF (useMNC .AND. SEAICE_mon_mnc) THEN
            DO i = 1,MAX_LEN_MBUF
              mon_fname(i:i) = ' '
            ENDDO
            mon_fname(1:14) = 'monitor_seaice'
            CALL MNC_CW_APPEND_VNAME(
     &           'T', '-_-_--__-__t', 0,0, myThid)
            CALL MNC_CW_SET_UDIM(mon_fname, -1, myThid)
            CALL MNC_CW_RL_W_S(
     &          'D',mon_fname,1,1,'T', myTime, myThid)
            CALL MNC_CW_SET_UDIM(mon_fname, 0, myThid)
            mon_write_mnc = .TRUE.
          ENDIF
#endif /* ALLOW_MNC */

          IF ( mon_write_stdout ) THEN
            WRITE(msgBuf,'(2A)') '// ===========================',
     &             '============================'
            CALL PRINT_MESSAGE(msgBuf, mon_ioUnit, SQUEEZE_RIGHT, 1)
            WRITE(msgBuf,'(A)') '// Begin MONITOR SEAICE statistics'
            CALL PRINT_MESSAGE(msgBuf, mon_ioUnit, SQUEEZE_RIGHT, 1)
            WRITE(msgBuf,'(2A)') '// ===========================',
     &             '============================'
            CALL PRINT_MESSAGE(msgBuf, mon_ioUnit, SQUEEZE_RIGHT, 1)
          ENDIF

C--   endif master cpu io
        ENDIF

        CALL MON_SET_PREF('seaice',myThid)
        CALL MON_OUT_I ('_tsnumber', myIter,mon_string_none,myThid)
        CALL MON_OUT_RL('_time_sec', myTime,mon_string_none,myThid)

C       Print some statistics about input forcing fields
#ifdef SEAICE_CGRID
        CALL MON_WRITESTATS_RL( 1, UICE, '_uice',
     &           maskInW, maskInW, rAw, drF, dummyRL, myThid )
        CALL MON_WRITESTATS_RL( 1, VICE, '_vice',
     &           maskInS, maskInS, rAs, drF, dummyRL, myThid )
#endif
#ifdef SEAICE_BGRID_DYNAMICS
        CALL MON_WRITESTATS_RL( 1, UICE, '_uice',
     &                   UVM, UVM, rAz, drF, dummyRL, myThid )
        CALL MON_WRITESTATS_RL( 1, VICE, '_vice',
     &                   UVM, UVM, rAz, drF, dummyRL, myThid )
#endif
        IF ( .NOT.useThSIce ) THEN
         CALL MON_WRITESTATS_RL( 1, AREA, '_area',
     &           maskInC, maskInC, rA , drF, dummyRL, myThid )
         CALL MON_WRITESTATS_RL( 1, HEFF, '_heff',
     &           maskInC, maskInC, rA , drF, dummyRL, myThid )
         CALL MON_WRITESTATS_RL( 1, HSNOW,'_hsnow',
     &           maskInC, maskInC, rA , drF, dummyRL, myThid )
#ifdef SEAICE_VARIABLE_SALINITY
         CALL MON_WRITESTATS_RL( 1, HSALT,'_hsalt',
     &           maskInC, maskInC, rA , drF, dummyRL, myThid )
#endif /* SEAICE_VARIABLE_SALINITY */
        ENDIF
#ifdef ALLOW_SITRACER
        DO iTracer = 1, SItrNumInUse
         WRITE(suff,'(A9,I2.2)') '_sitracer', iTracer
         CALL MON_WRITESTATS_RL(
     &          1,SItracer(1-OLx,1-OLy,1,1,iTracer),suff,
     &          maskInC, maskInC, rA , drF, dummyRL, myThid )
        ENDDO
#endif /* ALLOW_SITRACER */

        IF ( MASTER_CPU_IO(myThid) ) THEN
C--   only the master thread is allowed to switch On/Off mon_write_stdout
C     & mon_write_mnc (since it is the only thread that uses those flags):

          IF ( mon_write_stdout ) THEN
            WRITE(msgBuf,'(2A)') '// ===========================',
     &           '============================'
            CALL PRINT_MESSAGE(msgBuf, mon_ioUnit, SQUEEZE_RIGHT, 1)
            WRITE(msgBuf,'(A)') '// End MONITOR SEAICE statistics'
            CALL PRINT_MESSAGE(msgBuf, mon_ioUnit, SQUEEZE_RIGHT, 1)
            WRITE(msgBuf,'(2A)') '// ===========================',
     &           '============================'
            CALL PRINT_MESSAGE(msgBuf, mon_ioUnit, SQUEEZE_RIGHT, 1)
          ENDIF

          mon_write_stdout = .FALSE.
          mon_write_mnc    = .FALSE.

C--   endif master cpu io
        ENDIF

C     endif different multiple
      ENDIF

#endif /* ALLOW_MONITOR */

      RETURN
      END

#include "BBL_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 0
C !ROUTINE: BBL_CHECK

C !INTERFACE:
      SUBROUTINE BBL_CHECK( myThid )

C     !DESCRIPTION:
C     Check dependances with other packages

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "BBL.h"

C     !INPUT PARAMETERS:
C     myThid   :: my Thread Id number
      INTEGER myThid
CEOP

#ifdef ALLOW_BBL
C     !LOCAL VARIABLES:
C     msgBuf   :: Informational/error message buffer
      CHARACTER*(MAX_LEN_MBUF) msgBuf

      _BEGIN_MASTER(myThid)

       WRITE(msgBuf,'(A)') 'BBL_CHECK: #define BBL'
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                     SQUEEZE_RIGHT , 1)

C--  Print out some key parameters :
       CALL WRITE_0D_RL( bbl_wvel, INDEX_NONE,
     &  'bbl_wvel =', ' /* vertical entrainment (m/s) */')
       CALL WRITE_0D_RL( bbl_hvel, INDEX_NONE,
     &  'bbl_hvel =', ' /* horizontal velocity (m/s) */')
       CALL WRITE_0D_RL( bbl_initEta, INDEX_NONE,
     &  'bbl_initEta =', ' /* default thickness (m) */')

C--  Check parameters:

      _END_MASTER(myThid)

#endif /* ALLOW_BBL */

      RETURN
      END

#include "SHELFICE_OPTIONS.h"
#ifdef ALLOW_AUTODIFF
# include "AUTODIFF_OPTIONS.h"
#endif
#ifdef ALLOW_CTRL
# include "CTRL_OPTIONS.h"
#endif

CBOP
C     !ROUTINE: SHELFICE_THERMODYNAMICS
C     !INTERFACE:
      SUBROUTINE SHELFICE_THERMODYNAMICS(
     I                        myTime, myIter, myThid )
C     !DESCRIPTION: \bv
C     *=============================================================*
C     | S/R  SHELFICE_THERMODYNAMICS
C     | o shelf-ice main routine.
C     |   compute temperature and (virtual) salt flux at the
C     |   shelf-ice ocean interface
C     |
C     | stresses at the ice/water interface are computed in separate
C     | routines that are called from mom_fluxform/mom_vecinv
C     *=============================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "EOS.h"
#include "GRID.h"
#include "DYNVARS.h"
#include "FFIELDS.h"
#include "SHELFICE.h"
#ifdef ALLOW_CTRL
# include "CTRL_SIZE.h"
# include "CTRL.h"
# include "CTRL_DUMMY.h"
# ifdef ALLOW_GENTIM2D_CONTROL
#  include "CTRL_GENARR.h"
# endif
#endif /* ALLOW_CTRL */
#ifdef ALLOW_AUTODIFF_TAMC
# include "tamc.h"
#endif /* ALLOW_AUTODIFF_TAMC */

C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
C     myIter :: iteration counter for this thread
C     myTime :: time counter for this thread
C     myThid :: thread number for this instance of the routine.
      _RL  myTime
      INTEGER myIter
      INTEGER myThid

#ifdef ALLOW_SHELFICE
C     !LOCAL VARIABLES :
C     === Local variables ===
C     i,j,k,kp1,bi,bj  :: loop counters
C     tLoc, sLoc, pLoc :: local in-situ temperature, salinity, pressure
C     theta/saltFreeze :: temperature and salinity of water at the
C                         ice-ocean interface (at the freezing point)
C     freshWaterFlux   :: local variable for fresh water melt flux due
C                         to melting in kg/m^2/s
C                         (negative density x melt rate)
C     convertFW2SaltLoc:: local copy of convertFW2Salt
C     cFac             :: 1 for conservative form, 0, otherwise
C     rFac             :: realFreshWaterFlux factor
C     dFac             :: 0 for diffusive heat flux (Holland and Jenkins, 1999,
C                           eq21)
C                         1 for advective and diffusive heat flux (eq22, 26, 31)
C     fwflxFac         :: only effective for dFac=1, 1 if we expect a melting
C                         fresh water flux, 0 otherwise
C     rFWinBL          :: = 1 when realFreshWaterFlux is used with BoundaryLayer
C     auxiliary variables and abbreviations:
C     a0, a1, a2, b0, c0
C     eps1, eps2, eps3, eps3a, eps4, eps6, eps7, eps8, epsq
C     aqe, bqe, cqe, discrim, recip_aqe
C     drKp1, recip_drLoc
      INTEGER i,j,k,kp1
      INTEGER bi,bj
      _RL tLoc(1:sNx,1:sNy)
      _RL sLoc(1:sNx,1:sNy)
      _RL pLoc(1:sNx,1:sNy)
      _RL uLoc(1:sNx+1,1:sNy+1)
      _RL vLoc(1:sNx+1,1:sNy+1)
      _RL velSq(1:sNx,1:sNy)
      _RL tTMP, sTMP, uTMP, vTMP, vSqTmp
      _RL thetaFreeze, saltFreeze, recip_Cp
      _RL freshWaterFlux
#ifdef ALLOW_ISOMIP_TD
      _RL convertFW2SaltLoc
#endif
      _RL a0, a1, a2, b0, c0
      _RL eps1, eps2, eps3, eps3a, eps4, eps6, eps7, eps8, epsq
      _RL cFac, rFac, dFac, fwflxFac, rFWinBL
      _RL aqe, bqe, cqe, discrim, recip_aqe
      _RL drKp1, recip_drLoc
      _RL recip_latentHeat
      _RL tmpFac

#ifdef SHI_ALLOW_GAMMAFRICT
      _RL shiPr, shiSc, shiLo, recip_shiKarman, shiTwoThirds
      _RL gammaTmoleT, gammaTmoleS, gammaTurb, gammaTurbConst
      _RL ustar, ustarSq, etastar
      _RL u_tmp, v_tmp
      PARAMETER ( shiTwoThirds = 0.66666666666666666666666666667D0 )
#ifdef ALLOW_DIAGNOSTICS
      _RL uStarDiag(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
#endif /* ALLOW_DIAGNOSTICS */
#endif /*SHI_ALLOW_GAMMAFRICT */

#ifndef ALLOW_OPENAD
      _RL SW_TEMP
      EXTERNAL SW_TEMP
#endif

#ifdef ALLOW_GENTIM2D_CONTROL
      INTEGER iarr
      _RL xx_shifwflx_loc(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
#endif
#ifdef ALLOW_AUTODIFF_TAMC
# ifdef SHI_ALLOW_GAMMAFRICT
      INTEGER ikey
# endif
#endif
CEOP
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#ifdef SHI_ALLOW_GAMMAFRICT
#ifdef ALLOW_AUTODIFF
C     re-initialize here again, curtesy to TAF
      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
        DO j = 1-OLy,sNy+OLy
         DO i = 1-OLx,sNx+OLx
          shiTransCoeffT(i,j,bi,bj) = SHELFICEheatTransCoeff
          shiTransCoeffS(i,j,bi,bj) = SHELFICEsaltTransCoeff
         ENDDO
        ENDDO
       ENDDO
      ENDDO
#endif /* ALLOW_AUTODIFF */
      IF ( SHELFICEuseGammaFrict ) THEN
C     Implement friction velocity-dependent transfer coefficient
C     of Holland and Jenkins, JPO, 1999
       recip_shiKarman= 1. _d 0 / 0.4 _d 0
       shiLo = 0. _d 0
       shiPr = shiPrandtl**shiTwoThirds
       shiSc = shiSchmidt**shiTwoThirds
cph      shiPr = (viscArNr(1)/diffKrNrT(1))**shiTwoThirds
cph      shiSc = (viscArNr(1)/diffKrNrS(1))**shiTwoThirds
       gammaTmoleT = 12.5 _d 0 * shiPr - 6. _d 0
       gammaTmoleS = 12.5 _d 0 * shiSc - 6. _d 0
C     instead of etastar = sqrt(1+zetaN*ustar./(f*Lo*Rc))
       etastar = 1. _d 0
       gammaTurbConst  = 1. _d 0 / (2. _d 0 * shiZetaN*etastar)
     &      - recip_shiKarman
      ENDIF
#endif /* SHI_ALLOW_GAMMAFRICT */

      recip_latentHeat = 0. _d 0
      IF ( SHELFICElatentHeat .NE. 0. _d 0 )
     &     recip_latentHeat = 1. _d 0/SHELFICElatentHeat
C     are we doing the conservative form of Jenkins et al. (2001)?
      recip_Cp = 1. _d 0 / HeatCapacity_Cp
      cFac = 0. _d 0
      IF ( SHELFICEconserve ) cFac = 1. _d 0
C     with "real fresh water flux" (affecting ETAN), there is more to modify
      rFac = 1. _d 0
      IF ( SHELFICEconserve .AND. useRealFreshWaterFlux ) rFac = 0. _d 0
      rFWinBL = 0. _d 0
      IF ( SHI_withBL_realFWflux ) rFWinBL = 1. _d 0
C     heat flux into the ice shelf, default is diffusive flux
C     (Holland and Jenkins, 1999, eq.21)
      dFac = 0. _d 0
      IF ( SHELFICEadvDiffHeatFlux ) dFac = 1. _d 0
      fwflxFac = 0. _d 0
C     linear dependence of freezing point on salinity
      a0 = -0.0575   _d  0
      a1 =  0.0      _d -0
      a2 =  0.0      _d -0
      c0 =  0.0901   _d  0
      b0 =  -7.61    _d -4
#ifdef ALLOW_ISOMIP_TD
      IF ( useISOMIPTD ) THEN
C     non-linear dependence of freezing point on salinity
       a0 = -0.0575   _d  0
       a1 = 1.710523  _d -3
       a2 = -2.154996 _d -4
       b0 = -7.53     _d -4
       c0 = 0. _d 0
      ENDIF
      convertFW2SaltLoc = convertFW2Salt
C     hardcoding this value here is OK because it only applies to ISOMIP
C     where this value is part of the protocol
      IF ( convertFW2SaltLoc .EQ. -1. ) convertFW2SaltLoc = 33.4 _d 0
#endif /* ALLOW_ISOMIP_TD */

      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
        DO j = 1-OLy,sNy+OLy
         DO i = 1-OLx,sNx+OLx
          shelfIceHeatFlux      (i,j,bi,bj) = 0. _d 0
          shelfIceFreshWaterFlux(i,j,bi,bj) = 0. _d 0
          shelficeForcingT      (i,j,bi,bj) = 0. _d 0
          shelficeForcingS      (i,j,bi,bj) = 0. _d 0
#if (defined SHI_ALLOW_GAMMAFRICT && defined ALLOW_DIAGNOSTICS)
          uStarDiag             (i,j,bi,bj) = 0. _d 0
#endif /* SHI_ALLOW_GAMMAFRICT and ALLOW_DIAGNOSTICS */
#ifdef ALLOW_GENTIM2D_CONTROL
          xx_shifwflx_loc       (i,j,bi,bj) = 0. _d 0
#endif /* ALLOW_GENTIM2D_CONTROL */
         ENDDO
        ENDDO
       ENDDO
      ENDDO
#if (defined ALLOW_CTRL && defined ALLOW_GENTIM2D_CONTROL)
      IF ( useCTRL ) THEN
       DO iarr = 1, maxCtrlTim2D
        IF (xx_gentim2d_file(iarr)(1:11).EQ.'xx_shifwflx') THEN
         DO bj = myByLo(myThid),myByHi(myThid)
          DO bi = myBxLo(myThid),myBxHi(myThid)
           DO j = 1,sNy
            DO i = 1,sNx
             xx_shifwflx_loc(i,j,bi,bj)=xx_gentim2d(i,j,bi,bj,iarr)
            ENDDO
           ENDDO
          ENDDO
         ENDDO
        ENDIF
       ENDDO
      ENDIF
#endif

#ifdef ALLOW_SHELFICE_REMESHING
      IF ( SHI_update_kTopC ) THEN
C--   Deal with ice-shelf edge advance or retreat when allowing ice-shelf
C     mass to change. Since current ice-shelf representation is missing
C     a fractional ice-shelf cover representation, this turns into making
C     or removing a "thin ice-shelf" grid-cell. Here we update "kTopC"
C     as ice-shelf mass appears or vanishes in any surface grid-cell.
        DO bj = myByLo(myThid), myByHi(myThid)
         DO bi = myBxLo(myThid), myBxHi(myThid)
          DO j = 1-OLy,sNy+OLy
           DO i = 1-OLx,sNx+OLx
             IF ( kSurfC(i,j,bi,bj).LE.Nr .AND.
     &            shelficeMass(i,j,bi,bj).GT.zeroRL ) THEN
               kTopC(i,j,bi,bj) = kSurfC(i,j,bi,bj)
             ELSE
               kTopC(i,j,bi,bj) = 0
             ENDIF
           ENDDO
          ENDDO
         ENDDO
        ENDDO
      ENDIF
# ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE kTopC        = comlev1, key=ikey_dynamics
# endif
#endif /* ALLOW_SHELFICE_REMESHING */
#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE shelficeMass = comlev1, key=ikey_dynamics, kind=isbyte
#endif

      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)

#ifdef ALLOW_AUTODIFF_TAMC
# ifdef SHI_ALLOW_GAMMAFRICT
        ikey = bi + (bj-1)*nSx + (ikey_dynamics-1)*nSx*nSy
# endif /* SHI_ALLOW_GAMMAFRICT */
#endif /* ALLOW_AUTODIFF_TAMC */

C--   make local copies of temperature, salinity and depth (pressure in deci-bar)
C--   underneath the ice
        DO j = 1, sNy
         DO i = 1, sNx
          k         = MAX(1,kTopC(i,j,bi,bj))
C-    original (inaccurate) pLoc expression below:
C     assumes rhoConst*gravity*SItodBar=1 + missing both "shelficeLoadAnomaly"
C      static contribution and etaN dynamical contribution:
c         pLoc(i,j) = ABS(R_shelfIce(i,j,bi,bj))
C-    new and accurate pLoc expression (just the weight of the ice):
          pLoc(i,j) = shelficeMass(i,j,bi,bj)*gravity*SItodBar
          tLoc(i,j) = theta(i,j,k,bi,bj)
          sLoc(i,j) = MAX(salt(i,j,k,bi,bj), zeroRL)
          velSq(i,j)= 0.
         ENDDO
        ENDDO
        DO j = 1, sNy+1
         DO i = 1, sNx+1
          uLoc(i,j) = 0.
          vLoc(i,j) = 0.
         ENDDO
        ENDDO
#ifdef SHI_ALLOW_GAMMAFRICT
        IF ( SHELFICEuseGammaFrict .AND. SHELFICE_oldCalcUStar ) THEN
C-    Original averaging expression for uStar:
         DO j = 1, sNy
          DO i = 1, sNx
           k = MAX(1,kTopC(i,j,bi,bj))
           uLoc(i,j) = recip_hFacC(i,j,k,bi,bj) * halfRL *
     &         ( uVel(i,  j,k,bi,bj) * _hFacW(i,  j,k,bi,bj)
     &         + uVel(i+1,j,k,bi,bj) * _hFacW(i+1,j,k,bi,bj) )
           vLoc(i,j) = recip_hFacC(i,j,k,bi,bj) * halfRL *
     &         ( vVel(i,j,  k,bi,bj) * _hFacS(i,j,  k,bi,bj)
     &         + vVel(i,j+1,k,bi,bj) * _hFacS(i,j+1,k,bi,bj) )
           velSq(i,j) = uLoc(i,j)*uLoc(i,j)+vLoc(i,j)*vLoc(i,j)
          ENDDO
         ENDDO
        ELSEIF ( SHELFICEuseGammaFrict ) THEN
C-    New (more accurate) averaging expression for uStar:
         DO j = 1, sNy
          DO i = 1, sNx
           uLoc(i,j) = 0.
           vLoc(i,j) = 0.
           velSq(i,j) = 0.
           k = MAX(1,kTopC(i,j,bi,bj))
           tmpFac = _hFacW(i,  j,k,bi,bj) + _hFacW(i+1,j,k,bi,bj)
           IF ( tmpFac.GT.0. _d 0 )
     &     velSq(i,j) = (
     &     uVel( i, j,k,bi,bj)*uVel( i, j,k,bi,bj)*_hFacW( i, j,k,bi,bj)
     &   + uVel(i+1,j,k,bi,bj)*uVel(i+1,j,k,bi,bj)*_hFacW(i+1,j,k,bi,bj)
     &                  )/tmpFac
           tmpFac = _hFacS(i,j,  k,bi,bj) + _hFacS(i,j+1,k,bi,bj)
           IF ( tmpFac.GT.0. _d 0 )
     &     velSq(i,j) = velSq(i,j) + (
     &     vVel(i, j, k,bi,bj)*vVel(i, j, k,bi,bj)*_hFacS(i, j, k,bi,bj)
     &   + vVel(i,j+1,k,bi,bj)*vVel(i,j+1,k,bi,bj)*_hFacS(i,j+1,k,bi,bj)
     &                               )/tmpFac
          ENDDO
         ENDDO
        ENDIF
#endif /* SHI_ALLOW_GAMMAFRICT */

        IF ( SHELFICEBoundaryLayer ) THEN
C--   average over boundary layer width
         DO j = 1, sNy
          DO i = 1, sNx
           k   = kTopC(i,j,bi,bj)
           IF ( k .NE. 0 .AND. k .LT. Nr ) THEN
C           This local variable assignment/reassignment is simply to
C           avoid TAF recomputations... Oh the games we play...
            tTMP   = tLoc (i,j)
            sTMP   = sLoc (i,j)
            uTMP   = uLoc (i,j)
            vTMP   = vLoc (i,j)
            vSqTMP = velSq(i,j)

            kp1 = MIN(Nr,k+1)
C--   overlap into lower cell
            drKp1 = drF(k)*( 1. _d 0 - _hFacC(i,j,k,bi,bj) )
C--   lower cell may not be as thick as required
            drKp1 = MIN( drKp1, drF(kp1) * _hFacC(i,j,kp1,bi,bj) )
            drKp1 = MAX( drKp1, 0. _d 0 )
            recip_drLoc = 1. _d 0 /
     &           ( drF(k)*_hFacC(i,j,k,bi,bj) + drKp1 )
            tTMP = ( tTMP * drF(k)*_hFacC(i,j,k,bi,bj)
     &           + theta(i,j,kp1,bi,bj) *drKp1 )
     &           * recip_drLoc
            sTMP = ( sTMP * drF(k)*_hFacC(i,j,k,bi,bj)
     &           + MAX(salt(i,j,kp1,bi,bj), zeroRL) * drKp1 )
     &           * recip_drLoc
            uTMP = ( uTMP * drF(k)*_hFacC(i,j,k,bi,bj)
     &           + drKp1 * recip_hFacC(i,j,kp1,bi,bj) * halfRL *
     &           ( uVel(i,  j,kp1,bi,bj) * _hFacW(i,  j,kp1,bi,bj)
     &           + uVel(i+1,j,kp1,bi,bj) * _hFacW(i+1,j,kp1,bi,bj) )
     &           ) * recip_drLoc
            vTMP = ( vTMP * drF(k)*_hFacC(i,j,k,bi,bj)
     &           + drKp1 * recip_hFacC(i,j,kp1,bi,bj) * halfRL *
     &           ( vVel(i,j,  kp1,bi,bj) * _hFacS(i,j,  kp1,bi,bj)
     &           + vVel(i,j+1,kp1,bi,bj) * _hFacS(i,j+1,kp1,bi,bj) )
     &           ) * recip_drLoc
            vSqTMP = uTMP*uTMP + vTMP*vTMP

            tLoc (i,j) = tTMP
            sLoc (i,j) = sTMP
            uLoc (i,j) = uTMP
            vLoc (i,j) = vTMP
            velSq(i,j) = vSqTMP
           ENDIF
          ENDDO
         ENDDO
        ENDIF

#ifdef SHI_ALLOW_GAMMAFRICT
        IF ( SHI_withBL_uStarTopDz ) THEN
C--  TOPDR averages U/V over boundary layer at U/V points, then averages
C    (as opposed to averaging horizontally then vertically)
C    Average at u- and v- points over deltaR. use later to override uLoc/vLoc
         DO j = 1, sNy+1
          DO i = 1, sNx+1
           k = kSurfW(i,j,bi,bj)
           IF (k.LT.Nr) THEN
            kp1 = k+1
            drKp1 = drF(k)*( 1. _d 0 - _hFacW(i,j,k,bi,bj) )
            drKp1 = MIN( drKp1, drF(kp1) * _hFacW(i,j,kp1,bi,bj) )
            drKp1 = MAX( drKp1, 0. _d 0 )
            recip_drLoc = 1. _d 0
     &                  / ( drF(k)*_hFacW(i,j,k,bi,bj) + drKp1 )
            uLoc(i,j) = ( drF(k)*_hFacW(i,j,k,bi,bj)*uVel(i,j,k,bi,bj)
     &                  + drKp1*uVel(i,j,kp1,bi,bj)
     &                  )*recip_drLoc
c           u_topDr(i,j) =
c    &           ( uVel(i,j,k,bi,bj)*drF(k)*_hFacW(i,j,k,bi,bj)
c    &           + uVel(i,j,kp1,bi,bj)*drKp1
c    &           )*recip_drLoc
           ELSEIF (k.EQ.Nr) THEN
            uLoc(i,j) = uVel(i,j,k,bi,bj)
           ELSE
            uLoc(i,j) = 0. _d 0
           ENDIF

           k = kSurfS(i,j,bi,bj)
           IF (k.LT.Nr) THEN
            kp1 = k+1
            drKp1 = drF(k)*( 1. _d 0 - _hFacS(i,j,k,bi,bj) )
            drKp1 = MIN( drKp1, drF(kp1) * _hFacS(i,j,kp1,bi,bj) )
            drKp1 = MAX( drKp1, 0. _d 0 )
            recip_drLoc = 1. _d 0
     &                  / ( drF(k)*_hFacS(i,j,k,bi,bj) + drKp1 )
            vLoc(i,j) = ( drF(k)*_hFacS(i,j,k,bi,bj)*vVel(i,j,k,bi,bj)
     &                  + drKp1*vVel(i,j,kp1,bi,bj)
     &                  )*recip_drLoc
c           v_topDr(i,j) =
c    &           ( vVel(i,j,k,bi,bj)*drF(k)*_hFacS(i,j,k,bi,bj)
c    &           + vVel(i,j,kp1,bi,bj)*drKp1
c    &           )*recip_drLoc
           ELSEIF (k.EQ.Nr) THEN
            vLoc(i,j) = vVel(i,j,k,bi,bj)
           ELSE
            vLoc(i,j) = 0. _d 0
           ENDIF

          ENDDO
         ENDDO
         DO j = 1, sNy
          DO i = 1, sNx
           u_tmp = halfRL*( uLoc(i,j) + uLoc(i+1,j) )
           v_tmp = halfRL*( vLoc(i,j) + vLoc(i,j+1) )
           velSq(i,j) = u_tmp*u_tmp + v_tmp*v_tmp
          ENDDO
         ENDDO
        ENDIF
#endif /* SHI_ALLOW_GAMMAFRICT */

C--   turn potential temperature into in-situ temperature relative
C--   to the surface
        DO j = 1, sNy
         DO i = 1, sNx
#ifdef ALLOW_OPENAD
          CALL SW_TEMP(sLoc(i,j),tLoc(i,j),pLoc(i,j),zeroRL,tLoc(i,j))
#else
          tLoc(i,j) = SW_TEMP(sLoc(i,j),tLoc(i,j),pLoc(i,j),zeroRL)
#endif
         ENDDO
        ENDDO

#ifdef SHI_ALLOW_GAMMAFRICT
        IF ( SHELFICEuseGammaFrict ) THEN
         DO j = 1, sNy
          DO i = 1, sNx
           k = kTopC(i,j,bi,bj)
           IF ( k .NE. 0 .AND. pLoc(i,j) .GT. 0. _d 0 ) THEN
            ustarSq = shiCdragfld(i,j,bi,bj) * MAX( 1.D-6, velSq(i,j) )
            ustar   = SQRT(ustarSq)
#ifdef ALLOW_DIAGNOSTICS
            uStarDiag(i,j,bi,bj) = ustar
#endif /* ALLOW_DIAGNOSTICS */
C     instead of etastar = sqrt(1+zetaN*ustar./(f*Lo*Rc))
C           etastar = 1. _d 0
C           gammaTurbConst  = 1. _d 0 / (2. _d 0 * shiZetaN*etastar)
C    &           - recip_shiKarman
            IF ( fCori(i,j,bi,bj) .NE. 0. _d 0 ) THEN
             gammaTurb = LOG( ustarSq * shiZetaN * etastar**2
     &            / ABS(fCori(i,j,bi,bj) * 5.0 _d 0 * shiKinVisc))
     &            * recip_shiKarman
     &            + gammaTurbConst
C     Do we need to catch the unlikely case of very small ustar
C     that can lead to negative gammaTurb?
C            gammaTurb = MAX(0.D0, gammaTurb)
            ELSE
             gammaTurb = gammaTurbConst
            ENDIF
            shiTransCoeffT(i,j,bi,bj) = MAX( zeroRL,
     &           ustar/(gammaTurb + gammaTmoleT) )
            shiTransCoeffS(i,j,bi,bj) = MAX( zeroRL,
     &           ustar/(gammaTurb + gammaTmoleS) )
           ENDIF
          ENDDO
         ENDDO
        ENDIF
#endif /* SHI_ALLOW_GAMMAFRICT */

#ifdef ALLOW_AUTODIFF_TAMC
# ifdef SHI_ALLOW_GAMMAFRICT
CADJ STORE shiTransCoeffS(:,:,bi,bj) = comlev1_bibj,
CADJ &     key=ikey, byte=isbyte
CADJ STORE shiTransCoeffT(:,:,bi,bj) = comlev1_bibj,
CADJ &     key=ikey, byte=isbyte
# endif /* SHI_ALLOW_GAMMAFRICT */
#endif /* ALLOW_AUTODIFF_TAMC */
#ifdef ALLOW_ISOMIP_TD
        IF ( useISOMIPTD ) THEN
         DO j = 1, sNy
          DO i = 1, sNx
           k = kTopC(i,j,bi,bj)
           IF ( k .NE. 0 .AND. pLoc(i,j) .GT. 0. _d 0 ) THEN
C--   Calculate freezing temperature as a function of salinity and pressure
            thetaFreeze =
     &           sLoc(i,j) * ( a0 + a1*sqrt(sLoc(i,j)) + a2*sLoc(i,j) )
     &           + b0*pLoc(i,j) + c0
C--   Calculate the upward heat and  fresh water fluxes
            shelfIceHeatFlux(i,j,bi,bj) = maskC(i,j,k,bi,bj)
     &           * shiTransCoeffT(i,j,bi,bj)
     &           * ( tLoc(i,j) - thetaFreeze )
     &           * HeatCapacity_Cp*rUnit2mass
#ifdef ALLOW_GENTIM2D_CONTROL
     &           - xx_shifwflx_loc(i,j,bi,bj)*SHELFICElatentHeat
#endif /*  ALLOW_GENTIM2D_CONTROL */
C     upward heat flux into the shelf-ice implies basal melting,
C     thus a downward (negative upward) fresh water flux (as a mass flux),
C     and vice versa
            shelfIceFreshWaterFlux(i,j,bi,bj) =
     &           - shelfIceHeatFlux(i,j,bi,bj)
     &           *recip_latentHeat
C--   compute surface tendencies
            shelficeForcingT(i,j,bi,bj) =
     &           - shelfIceHeatFlux(i,j,bi,bj)
     &           *recip_Cp*mass2rUnit
     &           - cFac * shelfIceFreshWaterFlux(i,j,bi,bj)*mass2rUnit
     &           * ( thetaFreeze - tLoc(i,j) )
            shelficeForcingS(i,j,bi,bj) =
     &           shelfIceFreshWaterFlux(i,j,bi,bj) * mass2rUnit
     &           * ( cFac*sLoc(i,j) + (1. _d 0-cFac)*convertFW2SaltLoc )
C--   stress at the ice/water interface is computed in separate
C     routines that are called from mom_fluxform/mom_vecinv
           ELSE
            shelfIceHeatFlux      (i,j,bi,bj) = 0. _d 0
            shelfIceFreshWaterFlux(i,j,bi,bj) = 0. _d 0
            shelficeForcingT      (i,j,bi,bj) = 0. _d 0
            shelficeForcingS      (i,j,bi,bj) = 0. _d 0
           ENDIF
          ENDDO
         ENDDO
        ELSE
#else
        IF ( .TRUE. ) THEN
#endif /* ALLOW_ISOMIP_TD */
C     use BRIOS thermodynamics, following Hellmers PhD thesis:
C     Hellmer, H., 1989, A two-dimensional model for the thermohaline
C     circulation under an ice shelf, Reports on Polar Research, No. 60
C     (in German).

         DO j = 1, sNy
          DO i = 1, sNx
           k    = kTopC(i,j,bi,bj)
           IF ( k .NE. 0 .AND. pLoc(i,j) .GT. 0. _d 0 ) THEN
C     heat flux into the ice shelf, default is diffusive flux
C     (Holland and Jenkins, 1999, eq.21)
            thetaFreeze = a0*sLoc(i,j)+c0+b0*pLoc(i,j)
            fwflxFac    = 0. _d 0
            IF ( tLoc(i,j) .GT. thetaFreeze ) fwflxFac = dFac
C     a few abbreviations
            eps1 = rUnit2mass*HeatCapacity_Cp
     &           *shiTransCoeffT(i,j,bi,bj)
            eps2 = rUnit2mass*SHELFICElatentHeat
     &           *shiTransCoeffS(i,j,bi,bj)

C     solve quadratic equation for salinity at shelfice-ocean interface
C     note: this part of the code is not very intuitive as it involves
C     many arbitrary abbreviations that were introduced to derive the
C     correct form of the quadratic equation for salinity. The abbreviations
C     are explained in the documentation.
C
C     eps3a was introduced as a constant variant of eps3 to avoid AD of
C     code of type (pLoc-const)/pLoc
            eps3a = rhoShelfIce*SHELFICEheatCapacity_Cp
     &           * SHELFICEkappa *  ( 1. _d 0 - dFac )
            eps3 = eps3a/pLoc(i,j)
            eps4 = b0*pLoc(i,j) + c0
            eps6 = eps4 - tLoc(i,j)
            eps7 = eps4 - SHELFICEthetaSurface
            eps8 = rUnit2mass*SHELFICEheatCapacity_Cp
     &           *shiTransCoeffS(i,j,bi,bj) * fwflxFac
            epsq = eps1*eps6 + eps3*eps7
C     coefficients of the quadratic equations for saltFreeze
            aqe = a0*(eps1+eps3-eps8)
            recip_aqe = 0. _d 0
            IF ( aqe .NE. 0. _d 0 ) recip_aqe = 0.5 _d 0/aqe
            bqe = epsq - eps2 + eps8*( a0*sLoc(i,j) - eps7 )
     &           - a0*(eps1+eps3)*SHELFICEsalinity
            cqe = ( eps2 + eps8*eps7 )*sLoc(i,j) - epsq*SHELFICEsalinity
            discrim = bqe*bqe - 4. _d 0*aqe*cqe
#undef ALLOW_SHELFICE_DEBUG
#ifdef ALLOW_SHELFICE_DEBUG
            IF ( discrim .LT. 0. _d 0 ) THEN
             print *, 'ml-shelfice: discrim = ', discrim,aqe,bqe,cqe
             print *, 'ml-shelfice: pLoc    = ', pLoc(i,j)
             print *, 'ml-shelfice: tLoc    = ', tLoc(i,j)
             print *, 'ml-shelfice: sLoc    = ', sLoc(i,j)
             print *, 'ml-shelfice: tsurface= ',
     &            SHELFICEthetaSurface
             print *, 'ml-shelfice: eps1    = ', eps1
             print *, 'ml-shelfice: eps2    = ', eps2
             print *, 'ml-shelfice: eps3    = ', eps3
             print *, 'ml-shelfice: eps4    = ', eps4
             print *, 'ml-shelfice: eps6    = ', eps6
             print *, 'ml-shelfice: eps7    = ', eps7
             print *, 'ml-shelfice: eps8    = ', eps8
             print *, 'ml-shelfice: rU2mass = ', rUnit2mass
             print *, 'ml-shelfice: rhoIce  = ', rhoShelfIce
             print *, 'ml-shelfice: cFac    = ', cFac
             print *, 'ml-shelfice: Cp_W    = ', HeatCapacity_Cp
             print *, 'ml-shelfice: Cp_I    = ',
     &            SHELFICEHeatCapacity_Cp
             print *, 'ml-shelfice: gammaT  = ',
     &            SHELFICEheatTransCoeff
             print *, 'ml-shelfice: gammaS  = ',
     &            SHELFICEsaltTransCoeff
             print *, 'ml-shelfice: lat.heat= ',
     &            SHELFICElatentHeat
             STOP 'ABNORMAL END in S/R SHELFICE_THERMODYNAMICS'
            ENDIF
#endif /* ALLOW_SHELFICE_DEBUG */
            saltFreeze = (- bqe - SQRT(discrim))*recip_aqe
            IF ( saltFreeze .LT. 0. _d 0 )
     &           saltFreeze = (- bqe + SQRT(discrim))*recip_aqe
            thetaFreeze = a0*saltFreeze + eps4
#ifdef SHI_SALTBAL_FWFLX
C--   upward fresh water flux due to melting (in kg/m^2/s)
cph change to identical form
cph            freshWaterFlux = rUnit2mass
cph     &           * shiTransCoeffS(i,j,bi,bj)
cph     &           * ( saltFreeze - sLoc(i,j) ) / saltFreeze
            freshWaterFlux = rUnit2mass * shiTransCoeffS(i,j,bi,bj)
C     Catch unlikely case of saltFreeze = 0 (often when sLoc=0)
            IF ( saltFreeze .NE. 0. _d 0 )
     &           freshWaterFlux = freshWaterFlux
     &           * ( 1. _d 0 - sLoc(i,j) / saltFreeze )
#else /* ndef SHI_SALTBAL_FWFLX */
C     This formulation of fwflux, derived from the heat balance equation
C     instead of the salt balance equation, can handle the case when the
C     salinity of the ocean, boundary layer, and ice are identical.
C     Default thermodynamics specify a linear temperature gradient
C     through the ice (Holland and Jenkins, 1999, Section 2).
C     Here, via eps3=0 and fwflxFac, we also cover the case of a nonlinear
C     temperature gradient through the ice (Holland and Jenkins, 1999,
C     Section 3), but only for melting (Eq. 31 of Holland and Jenkins,
C     1999). fwflxFac = 0 for freezing and 1 for melting conditions.
            freshWaterFlux = (
     &             eps1*( thetaFreeze - tLoc(i,j) )
     &           + eps3*( thetaFreeze - SHELFICEthetaSurface )
     &           ) / ( SHELFICElatentHeat
     &                + fwflxFac * SHELFICEheatCapacity_Cp*
     &                  (thetaFreeze - SHELFICEthetaSurface) )
#endif /* ndef SHI_SALTBAL_FWFLX */

#ifdef ALLOW_GENTIM2D_CONTROL
            freshWaterFlux = freshWaterFlux + xx_shifwflx_loc(i,j,bi,bj)
#endif /* ALLOW_GENTIM2D_CONTROL */
C--   Calculate the upward heat and fresh water fluxes;
C--   MITgcm sign conventions: downward (negative) fresh water flux
C--   implies melting and due to upward (positive) heat flux
            shelfIceHeatFlux(i,j,bi,bj) =
     &           ( eps3
     &           - freshWaterFlux*SHELFICEheatCapacity_Cp*fwflxFac )
     &           * ( thetaFreeze - SHELFICEthetaSurface )
     &           -  cFac*freshWaterFlux*( SHELFICElatentHeat
     &             - HeatCapacity_Cp*( thetaFreeze - rFac*tLoc(i,j) ) )
            shelfIceFreshWaterFlux(i,j,bi,bj) = freshWaterFlux
C--   compute surface tendencies
C--   DNG: correction to use cell value for flux rather than BL values
C--        in order to conserve salt and temp even with real FW Flux
            shelficeForcingT(i,j,bi,bj) =
     &           ( shiTransCoeffT(i,j,bi,bj)
     &           - cFac*freshWaterFlux*mass2rUnit
     &           )*( thetaFreeze - tLoc(i,j) )
     &           - rFWinBL*freshWaterFlux*mass2rUnit
     &            *( tLoc(i,j) - theta(i,j,k,bi,bj) )
            shelficeForcingS(i,j,bi,bj) =
     &           ( shiTransCoeffS(i,j,bi,bj)
     &           - cFac*freshWaterFlux*mass2rUnit
     &           )*( saltFreeze - sLoc(i,j) )
     &           - rFWinBL*freshWaterFlux*mass2rUnit
     &            *( sLoc(i,j) - salt(i,j,k,bi,bj) )
           ELSE
            shelfIceHeatFlux      (i,j,bi,bj) = 0. _d 0
            shelfIceFreshWaterFlux(i,j,bi,bj) = 0. _d 0
            shelficeForcingT      (i,j,bi,bj) = 0. _d 0
            shelficeForcingS      (i,j,bi,bj) = 0. _d 0
           ENDIF
          ENDDO
         ENDDO
C     endif (not) useISOMIPTD
        ENDIF
C     end bi,bj loops
       ENDDO
      ENDDO
#ifdef ALLOW_AUTODIFF_TAMC
C     Avoid recomputing most of the routine body in the AD-code
CADJ STORE shelfIceFreshWaterFlux
CADJ &     = comlev1, key=ikey_dynamics, kind=isbyte
#endif

      IF (SHELFICEMassStepping) THEN
       CALL SHELFICE_STEP_ICEMASS( myTime, myIter, myThid )
      ENDIF

#ifdef ALLOW_DIAGNOSTICS
      IF ( useDiagnostics ) THEN
       CALL DIAGNOSTICS_FILL_RS(shelfIceFreshWaterFlux,'SHIfwFlx',
     &      0,1,0,1,1,myThid)
       CALL DIAGNOSTICS_FILL_RS(shelfIceHeatFlux,      'SHIhtFlx',
     &      0,1,0,1,1,myThid)
C     SHIForcT (Ice shelf forcing for theta [W/m2], >0 increases theta)
       tmpFac = HeatCapacity_Cp*rUnit2mass
       CALL DIAGNOSTICS_SCALE_FILL(shelficeForcingT,tmpFac,1,
     &      'SHIForcT',0,1,0,1,1,myThid)
C     SHIForcS (Ice shelf forcing for salt [g/m2/s], >0 increases salt)
       tmpFac = rUnit2mass
       CALL DIAGNOSTICS_SCALE_FILL(shelficeForcingS,tmpFac,1,
     &      'SHIForcS',0,1,0,1,1,myThid)
C     Transfer coefficients
       CALL DIAGNOSTICS_FILL(shiTransCoeffT,'SHIgammT',
     &      0,1,0,1,1,myThid)
       CALL DIAGNOSTICS_FILL(shiTransCoeffS,'SHIgammS',
     &      0,1,0,1,1,myThid)

C     Friction velocity
#ifdef SHI_ALLOW_GAMMAFRICT
       IF ( SHELFICEuseGammaFrict ) THEN
        CALL DIAGNOSTICS_FILL(uStarDiag,'SHIuStar',0,1,0,1,1,myThid)
        CALL DIAGNOSTICS_FILL(shiCDragFld,'SHICDrag',
     &      0,1,0,1,1,myThid)
       ENDIF
#endif /* SHI_ALLOW_GAMMAFRICT */
#ifdef ALLOW_SHELFICE_REMESHING
       CALL DIAGNOSTICS_FILL_RS( R_shelfIce, 'SHIRshel',
     &                           0, 1, 0, 1, 1, myThid )
#endif
      ENDIF
#endif /* ALLOW_DIAGNOSTICS */

#endif /* ALLOW_SHELFICE */
      RETURN
      END

#include "GMREDI_OPTIONS.h"

      SUBROUTINE GMREDI_CALC_DIFF( 
     I        bi,bj,iMin,iMax,jMin,jMax,kArg,kSize,
     U        KappaRx,
     I        tracerIdentity,myThid)

C     /==========================================================\
C     | SUBROUTINE GMREDI_CALC_DIFF                              |
C     | o Add contribution to net diffusivity from GM/Redi       |
C     \==========================================================/
      IMPLICIT NONE

C     == GLobal variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "GAD.h"
#ifdef ALLOW_LONGSTEP
#include "LONGSTEP.h"
#endif
#ifdef ALLOW_GMREDI
#include "GMREDI.h"
#endif

C     == Routine arguments ==
C     bi, bj,   :: tile indices
C     iMin,iMax :: Range of points for which calculation is done
C     jMin,jMax :: Range of points for which calculation is done
C     kArg      :: = 0 -> do the k-loop here and treat all levels
C                  > 0 -> k-loop is done outside and treat only level k=kArg
C     kSize     :: 3rd Dimension of the vertical diffusivity array KappaRx
C     KappaRx   :: vertical diffusivity array 
C     myThid    :: Instance number for this innvocation of GMREDI_CALC_DIFF
C
      INTEGER bi,bj,iMin,iMax,jMin,jMax,kArg,kSize
      _RL KappaRx(1-Olx:sNx+Olx,1-Oly:sNy+Oly,kSize)
      INTEGER tracerIdentity
      INTEGER myThid

#ifdef ALLOW_GMREDI

C     == Local variables ==
C     i,j,k     :: Loop counters
      INTEGER i,j,k

C--   Add Vertical diffusivity contribution from GM/Redi
      IF ( kArg .EQ. 0 ) THEN
C-    do all levels :
        DO k=1,MIN(Nr,kSize)
         DO j=jMin,jMax
          DO i=iMin,iMax
           IF (tracerIdentity .LT. GAD_TR1) THEN
            KappaRx(i,j,k) = KappaRx(i,j,k)+Kwz(i,j,k,bi,bj)
     &           *maskInC(i,j,bi,bj)
           ELSE
#ifdef ALLOW_LONGSTEP
            KappaRx(i,j,k) = KappaRx(i,j,k)+LS_Kwz(i,j,k,bi,bj)
#else
            KappaRx(i,j,k) = KappaRx(i,j,k)+Kwz(i,j,k,bi,bj)
#endif
     &           *maskInC(i,j,bi,bj)
           ENDIF
          ENDDO
         ENDDO
        ENDDO
      ELSE
C-    do level k=kArg only :
         k = MIN(kArg,kSize)
         DO j=jMin,jMax
          DO i=iMin,iMax
           IF (tracerIdentity .LT. GAD_TR1) THEN
            KappaRx(i,j,k) = KappaRx(i,j,k)+Kwz(i,j,kArg,bi,bj)
     &           *maskInC(i,j,bi,bj)
           ELSE
#ifdef ALLOW_LONGSTEP
            KappaRx(i,j,k) = KappaRx(i,j,k)+LS_Kwz(i,j,kArg,bi,bj)
#else
            KappaRx(i,j,k) = KappaRx(i,j,k)+Kwz(i,j,kArg,bi,bj)
#endif
     &           *maskInC(i,j,bi,bj)
           ENDIF
          ENDDO
         ENDDO
      ENDIF

#endif /* ALLOW_GMREDI */

      RETURN
      END

#include "ECCO_OPTIONS.h"

      subroutine cost_gencost_all( myiter, mytime, mythid )

c     ==================================================================
c     SUBROUTINE cost_gencost_all
c     ==================================================================
c
c     o Evaluate user defined penalty terms
c
c     ==================================================================
c     SUBROUTINE cost_gencost_all
c     ==================================================================

      implicit none

c     == global variables ==

#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#ifdef ALLOW_ECCO
# include "ECCO_SIZE.h"
# include "ECCO.h"
#endif

c     == routine arguments ==

      integer mythid
      integer myiter
      _RL     mytime

#ifdef ALLOW_GENCOST_CONTRIBUTION
c     == local variables ==

      character*(max_len_mbuf) msgbuf
      integer nnzbar
      integer nnzobs
      integer k
      integer nrecloc, nrecperiodloc

c     == external functions ==

c     == end of interface ==

      do k = 1, NGENCOST

         if ( (using_gencost(k)).AND.( gencost_flag(k).EQ.1 )
     &   .AND.( .NOT.gencost_is1d(k) ) ) then

#ifdef ALLOW_DEBUG
         IF ( debugLevel .GE. debLevD ) THEN
           write(msgbuf,'(a,x,i2.2)') 'gencost #', k
           call print_message( msgbuf, standardmessageunit,
     &        SQUEEZE_RIGHT , mythid)
         ENDIF
#endif

         if ( .NOT.gencost_is3d(k) ) then
           nnzbar = 1
           nnzobs = 1
         else
           nnzbar = nr
           nnzobs = nr
         endif

         nrecloc= gencost_nrec(k)
         nrecperiodloc= gencost_nrec(k)

         call cost_generic(
     &     nnzbar, gencost_barfile(k), gencost_dummy(k),
     &     nnzobs, gencost_datafile(k), gencost_errfile(k),
     &     mult_gencost(k), nrecloc, nrecperiodloc,
     &     gencost_startdate(1,k), gencost_period(k), 'c',
     &     gencost_spmin(k), gencost_spmax(k), gencost_spzero(k),
     &     gencost_preproc(1,k), gencost_preproc_c(1,k),
     &     gencost_preproc_i(1,k), gencost_preproc_r(1,k),
     &     gencost_posproc(1,k), gencost_posproc_c(1,k),
     &     gencost_posproc_i(1,k), gencost_posproc_r(1,k),
     &     gencost_outputlevel(k), gencost_name(k),
     &     objf_gencost(1,1,k), num_gencost(1,1,k),
     &     myiter, mytime, mythid )

         endif ! if ( (using_gencost(k)).AND.( gencost_flag(k).EQ.1 ) ) then

      end do

      call cost_gencost_glbmean( mythid )
      call cost_gencost_boxmean( mythid )
      call cost_gencost_bpv4( mythid )
      call cost_gencost_moc( mythid )
      IF (using_cost_transp) call cost_gencost_transp( mythid )
      IF (using_cost_altim) call cost_gencost_sshv4( mythid )
      IF (using_cost_sst) call cost_gencost_sstv4( mythid )
      IF (using_cost_seaice) call cost_gencost_seaicev4( mythid )

#endif /* ALLOW_GENCOST_CONTRIBUTION */

      return
      end

#include "ATM_CPL_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 0
C !ROUTINE: CPL_DIAGNOSTICS_INIT

C !INTERFACE:
      SUBROUTINE CPL_DIAGNOSTICS_INIT( myThid )

C     !DESCRIPTION:
C     Initialize list of available diagnostics
C     for Coupled Atmospheric Component

C     !USES:
      IMPLICIT NONE
#include "EEPARAMS.h"
#include "SIZE.h"
#include "CPL_PARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     myThid ::  my Thread Id number
      INTEGER myThid
CEOP

#ifdef ALLOW_DIAGNOSTICS
C     !LOCAL VARIABLES:
C     === Local variables ===
C     diagNum   :: diagnostics number in the (long) list of available diag.
C     diagMate  :: diag. mate number in the (long) list of available diag.
C     diagName  :: local short name (8c) of a diagnostics
C     diagCode  :: local parser field with characteristics of the diagnostics
C              cf head of S/R DIAGNOSTICS_INIT_EARLY or DIAGNOSTICS_MAIN_INIT
C     diagUnits :: local string (16c): physical units of a diagnostic field
C     diagTitle :: local string (80c): description of field in diagnostic
      INTEGER       diagNum
c     INTEGER       diagMate
      CHARACTER*8   diagName
      CHARACTER*16  diagCode
      CHARACTER*16  diagUnits
      CHARACTER*(80) diagTitle
#ifdef ALLOW_THSICE
      INTEGER       numFract, numThick
#endif /* ALLOW_THSICE */

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

c     IF ( useDiagnotics ) THEN

        diagName  = 'CPL_MxlD'
        diagTitle = 'Ocean mixed-layer depth [m] (recv from Coupler)'
        diagUnits = 'm               '
        diagCode  = 'SM      M1      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I           diagName, diagCode, diagUnits, diagTitle, 0, myThid )

        diagName  = 'CPL_SST '
        diagTitle = 'Ocean surface temperature (recv from Coupler)'
        diagUnits = 'degC            '
        diagCode  = 'SM      M1      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I           diagName, diagCode, diagUnits, diagTitle, 0, myThid )

        diagName  = 'CPL_SSS '
        diagTitle = 'Ocean surface salinity    (recv from Coupler)'
        diagUnits = 'g/kg            '
        diagCode  = 'SM      M1      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I           diagName, diagCode, diagUnits, diagTitle, 0, myThid )

        diagName  = 'CPL_vSq '
        diagName  = 'CPL_Vel2'
        diagTitle = 'Ocean surface velocity square (recv from Coupler)'
        diagUnits = 'm^2/s^2         '
        diagCode  = 'SM      M1      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I           diagName, diagCode, diagUnits, diagTitle, 0, myThid )

#ifdef ALLOW_AIM
        diagName  = 'CPL_fCO2'
        diagTitle ='Ocean air-sea flux of CO2 (+=down)(recv fr Coupler)'
        diagUnits = 'mol/m^2/s       '
        diagCode  = 'SM      M1      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I           diagName, diagCode, diagUnits, diagTitle, 0, myThid )
#endif /* ALLOW_AIM */

#ifdef ALLOW_THSICE
        diagName  = 'CPL_icFr'
        diagTitle = 'Seaice fraction (Ocean, recv from Coupler)'
        diagUnits = '0-1             '
        diagCode  = 'SM P    M1      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I           diagName, diagCode, diagUnits, diagTitle, 0, myThid )
        numFract  = diagNum

        diagName  = 'CPL_iceH'
        diagTitle = 'Seaice thickness (Ocean, recv from Coupler)'
        diagUnits = 'm               '
        diagCode  = 'SM PC   M1      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I    diagName, diagCode, diagUnits, diagTitle, numFract, myThid )
        numThick  = diagNum

        diagName  = 'CPL_snwH'
        diagTitle = 'Snow thickness over seaice (OCN, recv fr Coupler)'
        diagUnits = 'm               '
        diagCode  = 'SM PC   M1      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I    diagName, diagCode, diagUnits, diagTitle, numFract, myThid )

        diagName  = 'CPL_Qic1'
        diagTitle ='Enthalpy of seaice layer 1 (Ocean, recv fr Coupler)'
        diagUnits = 'J/kg            '
        diagCode  = 'SM  C   M1      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I    diagName, diagCode, diagUnits, diagTitle, numThick, myThid )

        diagName  = 'CPL_Qic2'
        diagTitle ='Enthalpy of seaice layer 2 (Ocean, recv fr Coupler)'
        diagUnits = 'J/kg            '
        diagCode  = 'SM  C   M1      '
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I    diagName, diagCode, diagUnits, diagTitle, numThick, myThid )
#endif /* ALLOW_THSICE */

c     ENDIF

#endif /* ALLOW_DIAGNOSTICS */

      RETURN
      END

#include "AIM_OPTIONS.h"

      SUBROUTINE CONVMF (PSA,dpFac,SE,QA,QSAT,
     O                   IDEPTH,CBMF,PRECNV,DFSE,DFQA,
     I                   kGrd,bi,bj,myThid)
C--
C--   SUBROUTINE CONVMF (PSA,SE,QA,QSAT,
C--  *                   IDEPTH,CBMF,PRECNV,DFSE,DFQA)
C--
C--   Purpose: Compute convective fluxes of dry static energy and moisture
C--            using a simplified mass-flux scheme
C--   Input:   PSA    = norm. surface pressure [p/p0]            (2-dim)
C              dpFac  = cell delta_P fraction                    (3-dim)
C--            SE     = dry static energy                        (3-dim)
C--            QA     = specific humidity [g/kg]                 (3-dim)
C--            QSAT   = saturation spec. hum. [g/kg]             (3-dim)
C--   Output:  IDEPTH = convection depth in layers               (2-dim)
C--            CBMF   = cloud-base mass flux                     (2-dim)
C--            PRECNV = convective precipitation [g/(m^2 s)]     (2-dim)
C--            DFSE   = net flux of d.s.en. into each atm. layer (3-dim)
C--            DFQA   = net flux of sp.hum. into each atm. layer (3-dim)
C    Input:    kGrd   = Ground level index                       (2-dim)
C              bi,bj  = tile index
C              myThid = Thread number for this instance of the routine
C-------
C  Note: dry static energy has been replaced by Pot.Temp.
C-------

      IMPLICIT NONE

C     Resolution parameters

C-- size for MITgcm & Physics package :
#include "AIM_SIZE.h" 

#include "EEPARAMS.h"

C     Physical constants + functions of sigma and latitude

#include "com_physcon.h"

C     Convection constants

#include "com_cnvcon.h"

C-- Routine arguments:
      _RL PSA(NGP), SE(NGP,NLEV), QA(NGP,NLEV), QSAT(NGP,NLEV)
      _RL dpFac(NGP,NLEV)
      INTEGER IDEPTH(NGP)
      _RL CBMF(NGP), PRECNV(NGP), DFSE(NGP,NLEV), DFQA(NGP,NLEV)
      INTEGER  kGrd(NGP)
      INTEGER  bi,bj,myThid

#ifdef ALLOW_AIM

C-- Local variables:
      INTEGER ITOP(NGP)
c_FM  REAL SM(NGP,NLEV), QATHR(NGP), ENTR(2:NLEV-1)
      _RL  QATHR(NGP), ENTR(2:NLEV-1) 
      _RL  ENTR_PS(NGP,2:NLEV-1), FM0(NGP) 

      INTEGER J, K, K1, Ktmp
      _RL  dSEdp(NGP,NLEV), factP, PSA_1
      _RL  dSEdpTot, stab_crit, FDMUS
C- jmc: declare all local variables:
      _RL  QMAX, DELQ, QB, QSATB, FMASS, ENMASS, SENTR 
      _RL  FPSA, FQMAX, RDPS, FUQ, FDQ, FSQ
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C--   1. Initialization of output and workspace arrays

      PSA_1 = 1.
      FQMAX=  5.

      RDPS = 2. _d 0 /(1. _d 0 - PSMIN)
c_FM  FM0=P0*DSIG(NLEV)/(GG*TRCNV*3600)
c_FM    FPSA=PSA(J)*MIN(1.,(PSA(J)-PSMIN)*RDPS)
C-    compute FM0(J) = FM0*FPSA
      DO J=1,NGP
       FM0(J)=0.
       Ktmp = kGrd(J)
       IF ( Ktmp .NE. 0 ) THEN
        FPSA = MIN(1. _d 0 ,(PSA(J)-PSMIN)*RDPS)
        FM0(J)=P0*DSIG(Ktmp)*dpFac(J,Ktmp)/(GG*TRCNV*3600. _d 0)
       ENDIF
      ENDDO

      DO K=1,NLEV
        DO J=1,NGP
          DFSE(J,K)=0.0
          DFQA(J,K)=0.0
        ENDDO
      ENDDO
      DO K=2,NLEV-1
        DO J=1,NGP
          ENTR_PS(J,K)=0.
        ENDDO
      ENDDO

      DO J=1,NGP
        ITOP(J)  =kGrd(J)
        CBMF(J)  =0.0
        PRECNV(J)=0.0
      ENDDO

C     Saturation moist static energy
c_FM  DO K=1,NLEV
c_FM    DO J=1,NGP
c_FM      SM(J,K)=SE(J,K)+ALHC*QSAT(J,K)
c_FM    ENDDO
c_FM  ENDDO

C ---------------------------------------------
C    Write Conditional stability based on Pot.Temp :
C    dSEdp(K) = Delta[Static-Energy] between 2 Plevels(k,k+1)
C    and corresponds to SE(K+1)-SE(K) in the original code
C -------
      DO K=1,NLEV-1
       factP = CP*SIGH(K)**(RD/CP)
       DO J=1,NGP
         dSEdp(J,K)=(SE(J,K+1)-SE(J,K))*factP
       ENDDO
      ENDDO

C     Entrainment profile (up to sigma = 0.5)

c_FM  SENTR=0.
c_FM  DO K=2,NLEV-1
c_FM    ENTR(K)=( MAX( 0. _d 0, SIG(K)-0.5 _d 0) )**2
c_FM    SENTR=SENTR+ENTR(K)
c_FM  ENDDO

c_FM  SENTR=ENTMAX/SENTR
c_FM  DO K=2,NLEV-1
c_FM    ENTR(K)=ENTR(K)*SENTR
c_FM  ENDDO 

      DO J=1,NGP
       DO K=2,NLEV-1
        ENTR_PS(J,K)=0.
       ENDDO
       Ktmp = kGrd(J)
       IF (Ktmp.GT.2) THEN
         SENTR=0.
         DO K=2,Ktmp-1
           ENTR(K)= ( MAX( 0. _d 0, SIG(K)/PSA(J) - 0.5 _d 0) )**2
           SENTR=SENTR+ENTR(K)
         ENDDO
         IF (SENTR.GT.0.) THEN
          SENTR=ENTMAX/SENTR
          DO K=2,Ktmp-1
           ENTR_PS(J,K) = ENTR(K)*SENTR*PSA(J)
          ENDDO
         ENDIF
       ENDIF
      ENDDO

C--   2. Check of conditions for convection

C     2.1 Conditional instability

c_FM  DO K=NLEV-2,2,-1
c_FM    DO J=1,NGP
c_FM      SMB=SM(J,K)+WVI(K,2)*(SM(J,K+1)-SM(J,K))
c_FM      IF (SM(J,NLEV).GT.SMB) ITOP(J)=K
c_FM    ENDDO
c_FM  ENDDO   

      DO J=1,NGP
       Ktmp = kGrd(J)
       IF ( Ktmp .GE. 2 ) THEN
        dSEdpTot = dSEdp(J,Ktmp-1)
        DO k=Ktmp-2,2,-1
          dSEdpTot = dSEdpTot + dSEdp(J,K)
          stab_crit = dSEdpTot + ALHC*(QSAT(J,Ktmp)-QSAT(J,K))
     &     -WVI(K,2)*(dSEdp(J,K) + ALHC*(QSAT(J,K+1)-QSAT(J,K)) )
          IF (stab_crit.GT.0.) ITOP(J) = K
        ENDDO
       ENDIF
      ENDDO


C     2.2 Humidity exceeding prescribed threshold

      DO J=1,NGP
       Ktmp = kGrd(J)
       IF ( Ktmp .NE. 0 ) THEN
        QATHR(J)=MIN(QBL,RHBL*QSAT(J,Ktmp))
        IF (QA(J,Ktmp).LT.QATHR(J).OR.PSA(J).LT.PSMIN)
     &      ITOP(J)=Ktmp
       ENDIF
        IDEPTH(J)=Ktmp-ITOP(J)
      ENDDO 

C--   3. Convection over selected grid-points

      DO 300 J=1,NGP
       Ktmp = kGrd(J)
      IF (ITOP(J).EQ.Ktmp) GO TO 300

C-      3.1 Boundary layer (cloud base)

        K = Ktmp
        K1=K-1

C       Maximum specific humidity in the PBL
        QMAX=MAX(1.01 _d 0 *QA(J,K),QSAT(J,K))

C       Dry static energy and moisture at upper boundary
c_FM    SB=SE(J,K1)+WVI(K1,2)*(SE(J,K)-SE(J,K1))
        QB=QA(J,K1)+WVI(K1,2)*(QA(J,K)-QA(J,K1))
        QB=MIN(QB,QA(J,K))

C       Cloud-base mass flux, computed to satisfy:
C       fmass*(qmax-qb)*(g/dp)=(q-qthr)/trcnv

c_FM    FPSA=PSA(J)*MIN(1.,(PSA(J)-PSMIN)*RDPS)
c_FM    FMASS=FM0*FPSA*MIN(FQMAX,(QA(J,K)-QATHR(J))/(QMAX-QB))
        FMASS = FM0(J)*MIN(FQMAX,(QA(J,K)-QATHR(J))/(QMAX-QB))
        CBMF(J)=FMASS

C       Upward fluxes at upper boundary
c_FM    FUS=FMASS*SE(J,K)
        FUQ=FMASS*QMAX

C       Downward fluxes at upper boundary
c_FM    FDS=FMASS*SB
        FDQ=FMASS*QB

C       Net flux of dry static energy and moisture
        FDMUS = FMASS*dSEdp(J,K1)*(WVI(K1,2)-1.)
        DFSE(J,K)=FDMUS
c_FM    DFSE(J,K)=FDS-FUS
        DFQA(J,K)=FDQ-FUQ

C-      3.2 Intermediate layers (entrainment)

        DO K=Ktmp-1,ITOP(J)+1,-1
        K1=K-1

C         Fluxes at lower boundary
c_FM      DFSE(J,K)=FUS-FDS
          DFQA(J,K)=FUQ-FDQ

C         Mass entrainment
c_FM      ENMASS=ENTR(K)*PSA(J)*CBMF(J)
          ENMASS=ENTR_PS(J,K) * CBMF(J)
          FMASS=FMASS+ENMASS

C         Upward fluxes at upper boundary
c_FM      FUS=FUS+ENMASS*SE(J,K)
          FUQ=FUQ+ENMASS*QA(J,K)

C         Downward fluxes at upper boundary
c_FM      SB=SE(J,K1)+WVI(K1,2)*(SE(J,K)-SE(J,K1))
          QB=QA(J,K1)+WVI(K1,2)*(QA(J,K)-QA(J,K1))
c_FM      FDS=FMASS*SB
          FDQ=FMASS*QB

C         Net flux of dry static energy and moisture
          DFSE(J,K) = FMASS*(WVI(K1,2)-1.)*dSEdp(J,K1)
     &             -(FMASS-ENMASS)*WVI(K,2)*dSEdp(J,K)
          FDMUS = FDMUS + DFSE(J,K)
c_FM      DFSE(J,K)=DFSE(J,K)+FDS-FUS
          DFQA(J,K)=DFQA(J,K)+FDQ-FUQ

C         Secondary moisture flux
          DELQ=RHIL*QSAT(J,K)-QA(J,K)
          IF (DELQ.GT.0.0) THEN
            FSQ=SMF*CBMF(J)*DELQ
            DFQA(J,K)   =DFQA(J,K)   +FSQ
            DFQA(J,Ktmp)=DFQA(J,Ktmp)-FSQ
          ENDIF

        ENDDO

C-      3.3 Top layer (condensation and detrainment)

        K=ITOP(J)

C       Flux of convective precipitation
        QSATB=QSAT(J,K)+WVI(K,2)*(QSAT(J,K+1)-QSAT(J,K))
        PRECNV(J)=MAX(FUQ-FMASS*QSATB, 0. _d 0)

C       Net flux of dry static energy and moisture
        DFSE(J,K)= -FDMUS+ALHC*PRECNV(J)
c_FM    DFSE(J,K)=FUS-FDS+ALHC*PRECNV(J)
        DFQA(J,K)=FUQ-FDQ-PRECNV(J)

 300  CONTINUE

#endif /* ALLOW_AIM */ 

      RETURN
      END

#include "PACKAGES_CONFIG.h"
#include "CPP_OPTIONS.h"

CBOP
C     !ROUTINE: INI_SALT
C     !INTERFACE:
      SUBROUTINE INI_SALT( myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE INI_SALT
C     | o Set model initial salinity field.
C     *==========================================================*
C     | There are several options for setting the initial
C     | temperature file
C     |  1. Inline code
C     |  2. Vertical profile ( uniform S in X and Y )
C     |  3. Three-dimensional data from a file. For example from
C     |     Levitus or from a checkpoint file from a previous
C     |     integration.
C     | In addition to setting the salinity field we also
C     | set the initial salinity tendency term here.
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "DYNVARS.h"
#ifdef ALLOW_MNC
#include "MNC_PARAMS.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     myThid :: Number of this instance of INI_SALT
      INTEGER myThid

C     !LOCAL VARIABLES:
C     == Local variables ==
C     bi,bj  :: Tile indices
C     i,j,k  :: Loop counters
      INTEGER bi, bj
      INTEGER i, j, k, localWarnings
      CHARACTER*(MAX_LEN_MBUF) msgBuf
CEOP

C--   Initialise salinity field to the vertical reference profile
      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
        DO k=1,Nr
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           salt(i,j,k,bi,bj) = sRef(k)
          ENDDO
         ENDDO
        ENDDO
       ENDDO
      ENDDO

      IF ( hydrogSaltFile .NE. ' ' ) THEN
#ifdef ALLOW_MNC
        IF ( useMNC.AND.mnc_read_salt ) THEN
          CALL MNC_FILE_CLOSE_ALL_MATCHING(hydrogSaltFile, myThid)
          CALL MNC_CW_SET_UDIM(hydrogSaltFile, 1, myThid)
          CALL MNC_CW_SET_CITER(hydrogSaltFile, 2, -1, -1, -1, myThid)
          CALL MNC_CW_SET_UDIM(hydrogSaltFile, 1, myThid)
          CALL MNC_CW_RL_R('D',hydrogSaltFile,0,0,'S',salt, myThid)
          CALL MNC_FILE_CLOSE_ALL_MATCHING(hydrogSaltFile, myThid)
        ELSE
#endif /*  ALLOW_MNC  */
          CALL READ_FLD_XYZ_RL( hydrogSaltFile, ' ', salt, 0, myThid )
#ifdef ALLOW_MNC
        ENDIF
#endif /*  ALLOW_MNC  */
        _EXCH_XYZ_RL( salt, myThid )
      ENDIF

C--   Apply mask and test consistency
      localWarnings=0
      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
        DO k=1,Nr
         IF ( maskIniSalt ) THEN
          DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
            IF (maskC(i,j,k,bi,bj).EQ.0.) salt(i,j,k,bi,bj) = 0.
           ENDDO
          ENDDO
         ENDIF
         IF ( sRef(k).NE.0. ) THEN
          DO j=1,sNy
           DO i=1,sNx
            IF ( maskC(i,j,k,bi,bj).NE.0.
     &      .AND. salt(i,j,k,bi,bj).EQ.0. ) THEN
              localWarnings=localWarnings+1
            ENDIF
           ENDDO
          ENDDO
         ENDIF
        ENDDO
       ENDDO
      ENDDO
      IF ( localWarnings.NE.0 ) THEN
       IF ( checkIniSalt ) THEN
        WRITE(msgBuf,'(A,I10,A)')
     &   ' INI_SALT: found', localWarnings,
     &   ' wet grid-pts with salt=0 identically.'
        CALL PRINT_ERROR( msgBuf , myThid)
        WRITE(msgBuf,'(A,A)')
     &  ' If this is intentional, you need to',
     &  ' set checkIniSalt=.false. in "data", namelist PARM05'
        CALL PRINT_ERROR( msgBuf , myThid)
        STOP 'ABNORMAL END: S/R INI_SALT'
       ELSE
        WRITE(msgBuf,'(A,I10,A)')
     &   '** WARNINGS ** INI_SALT: found', localWarnings,
     &   ' wet grid-pts with salt=0 identically.'
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
       ENDIF
      ENDIF

      IF ( plotLevel.GE.debLevC ) THEN
        CALL PLOT_FIELD_XYZRL( salt, 'Initial Salinity',
     &                         Nr, 1, myThid )
      ENDIF

      RETURN
      END

#include "MOM_VECINV_OPTIONS.h"

CBOP
C     !ROUTINE: MOM_VI_U_CORIOLIS
C     !INTERFACE:
      SUBROUTINE MOM_VI_U_CORIOLIS(
     I                     bi, bj, k,
     I                     selectVortScheme, useJamartMomAdv,
     I                     vFld, omega3, hFacZ, r_hFacZ,
     O                     uCoriolisTerm,
     I                     myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R MOM_VI_U_CORIOLIS
C     |==========================================================*
C     | o Calculate flux (in Y-dir.) of vorticity at U point
C     |   using 2nd order interpolation
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "GRID.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
      INTEGER bi, bj, k
      _RL     vFld     (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL     omega3   (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RS     hFacZ    (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RS     r_hFacZ  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL uCoriolisTerm(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER selectVortScheme
      LOGICAL useJamartMomAdv
      INTEGER myThid
CEOP

C     == Local variables ==
C     msgBuf :: Informational/error message buffer
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      INTEGER i, j
      _RL     vBarXY, vBarXm, vBarXp
      _RL     vort3u
      _RL     vort3mj, vort3ij, vort3mp, vort3ip
      _RL     oneThird, tmpFac
      _RS     epsil

      epsil = 1. _d -9
      tmpFac = 1. _d 0
c     oneThird = 1. _d 0 / ( 1. _d 0 + 2.*tmpFac )
      oneThird = 1. _d 0 / 3. _d 0

      IF ( selectVortScheme.EQ.0 ) THEN
C--   using enstrophy conserving scheme (Shallow-Water Eq.) by Sadourny, JAS 75

       DO j=1-OLy,sNy+OLy-1
        DO i=2-OLx,sNx+OLx
         vBarXY = 0.25 _d 0*(
     &      ( vFld( i , j )*dxG( i , j ,bi,bj)*_hFacS( i , j ,k,bi,bj)
     &      + vFld(i-1, j )*dxG(i-1, j ,bi,bj)*_hFacS(i-1, j ,k,bi,bj) )
     &     +( vFld( i ,j+1)*dxG( i ,j+1,bi,bj)*_hFacS( i ,j+1,k,bi,bj)
     &      + vFld(i-1,j+1)*dxG(i-1,j+1,bi,bj)*_hFacS(i-1,j+1,k,bi,bj) )
     &                      )
         vort3u = halfRL*( omega3(i,j)*r_hFacZ(i,j)
     &                   + omega3(i,j+1)*r_hFacZ(i,j+1) )
         uCoriolisTerm(i,j) = +vort3u*vBarXY*recip_dxC(i,j,bi,bj)
     &                               * _maskW(i,j,k,bi,bj)
        ENDDO
       ENDDO

      ELSEIF ( selectVortScheme.EQ.1 ) THEN
C--   same as above, with different formulation (relatively to hFac)

       DO j=1-OLy,sNy+OLy-1
        DO i=2-OLx,sNx+OLx
         vBarXY = halfRL*(
     &      ( vFld( i , j )*dxG( i , j ,bi,bj)*hFacZ(i, j )
     &      + vFld(i-1, j )*dxG(i-1, j ,bi,bj)*hFacZ(i, j ) )
     &     +( vFld( i ,j+1)*dxG( i ,j+1,bi,bj)*hFacZ(i,j+1)
     &      + vFld(i-1,j+1)*dxG(i-1,j+1,bi,bj)*hFacZ(i,j+1) )
     &                     )/MAX( epsil, hFacZ(i,j)+hFacZ(i,j+1) )
         vort3u = halfRL*( omega3(i,j) + omega3(i,j+1) )
         uCoriolisTerm(i,j) = +vort3u*vBarXY*recip_dxC(i,j,bi,bj)
     &                               * _maskW(i,j,k,bi,bj)
        ENDDO
       ENDDO

      ELSEIF ( selectVortScheme.EQ.2 ) THEN
C--   using energy conserving scheme (used by Sadourny in JAS 75 paper)

       DO j=1-OLy,sNy+OLy-1
        DO i=2-OLx,sNx+OLx
         vBarXm = halfRL*(
     &       vFld( i , j )*dxG( i , j ,bi,bj)*_hFacS( i , j ,k,bi,bj)
     &     + vFld(i-1, j )*dxG(i-1, j ,bi,bj)*_hFacS(i-1, j ,k,bi,bj) )
         vBarXp = halfRL*(
     &       vFld( i ,j+1)*dxG( i ,j+1,bi,bj)*_hFacS( i ,j+1,k,bi,bj)
     &     + vFld(i-1,j+1)*dxG(i-1,j+1,bi,bj)*_hFacS(i-1,j+1,k,bi,bj) )
         vort3u = ( vBarXm*r_hFacZ(i, j )*omega3(i, j )
     &            + vBarXp*r_hFacZ(i,j+1)*omega3(i,j+1)
     &            )*halfRL
         uCoriolisTerm(i,j) = +vort3u*recip_dxC(i,j,bi,bj)
     &                               * _maskW(i,j,k,bi,bj)
        ENDDO
       ENDDO

      ELSEIF ( selectVortScheme.EQ.3 ) THEN
C--   using energy & enstrophy conserving scheme
C     (from Sadourny, described by Burridge & Haseler, ECMWF Rep.4, 1977)

C     domain where uCoriolisTerm is valid :
C     [ 3-Olx : sNx+Olx-1 ] x [ 2-Oly : sNy+Oly-1 ]
C     (=> might need overlap of 3 if using CD-scheme)
       DO j=1-OLy,sNy+OLy-1
        DO i=2-OLx,sNx+OLx-1
         vort3mj = ( r_hFacZ(i, j )*omega3(i, j )
     &             +(r_hFacZ(i,j+1)*omega3(i,j+1)
     &              +r_hFacZ(i-1,j)*omega3(i-1,j)
     &             ))*oneThird
c    &             )*tmpFac)*oneThird
     &      *vFld(i-1, j )*dxG(i-1, j ,bi,bj)*_hFacS(i-1, j ,k,bi,bj)
         vort3ij = ( r_hFacZ(i, j )*omega3(i, j )
     &             +(r_hFacZ(i,j+1)*omega3(i,j+1)
     &              +r_hFacZ(i+1,j)*omega3(i+1,j)
     &             ))*oneThird
c    &             )*tmpFac)*oneThird
     &      *vFld( i , j )*dxG( i , j ,bi,bj)*_hFacS( i , j ,k,bi,bj)
         vort3mp = ( r_hFacZ(i,j+1)*omega3(i,j+1)
     &             +(r_hFacZ(i, j )*omega3(i, j )
     &              +r_hFacZ(i-1,j+1)*omega3(i-1,j+1)
     &             ))*oneThird
c    &             )*tmpFac)*oneThird
     &      *vFld(i-1,j+1)*dxG(i-1,j+1,bi,bj)*_hFacS(i-1,j+1,k,bi,bj)
         vort3ip = ( r_hFacZ(i,j+1)*omega3(i,j+1)
     &             +(r_hFacZ(i, j )*omega3(i, j )
     &              +r_hFacZ(i+1,j+1)*omega3(i+1,j+1)
     &             ))*oneThird
c    &             )*tmpFac)*oneThird
     &      *vFld( i ,j+1)*dxG( i ,j+1,bi,bj)*_hFacS( i ,j+1,k,bi,bj)
C---
         uCoriolisTerm(i,j) = +( (vort3mj+vort3ij)+(vort3mp+vort3ip) )
     &                      *0.25 _d 0 *recip_dxC(i,j,bi,bj)
     &                                 * _maskW(i,j,k,bi,bj)
        ENDDO
       ENDDO

      ELSEIF ( selectVortScheme.EQ.4 ) THEN
C--   using energy conserving scheme without r_hFacZ factor

       DO j=1-OLy,sNy+OLy-1
        DO i=2-OLx,sNx+OLx
         vBarXm = halfRL*(
     &       vFld( i , j )*dxG( i , j ,bi,bj)*_hFacS( i , j ,k,bi,bj)
     &     + vFld(i-1, j )*dxG(i-1, j ,bi,bj)*_hFacS(i-1, j ,k,bi,bj) )
         vBarXp = halfRL*(
     &       vFld( i ,j+1)*dxG( i ,j+1,bi,bj)*_hFacS( i ,j+1,k,bi,bj)
     &     + vFld(i-1,j+1)*dxG(i-1,j+1,bi,bj)*_hFacS(i-1,j+1,k,bi,bj) )
         vort3u = ( vBarXm*omega3(i, j )
     &            + vBarXp*omega3(i,j+1)
     &            )*halfRL
         uCoriolisTerm(i,j) = +vort3u*recip_dxC(i,j,bi,bj)
     &                               *recip_hFacW(i,j,k,bi,bj)
        ENDDO
       ENDDO

      ELSE
        WRITE(msgBuf,'(A,I5,A)')
     &   'MOM_VI_U_CORIOLIS: selectVortScheme=', selectVortScheme,
     &   ' not implemented'
        CALL PRINT_ERROR( msgBuf, myThid )
        STOP 'ABNORMAL END: S/R MOM_VI_U_CORIOLIS'

      ENDIF

      IF ( useJamartMomAdv ) THEN
       DO j=1-OLy,sNy+OLy-1
        DO i=2-OLx,sNx+OLx-1
         uCoriolisTerm(i,j) = uCoriolisTerm(i,j)
     &           * 4. _d 0 * _hFacW(i,j,k,bi,bj)
     &           / MAX( epsil,
     &                  (_hFacS(i, j ,k,bi,bj)+_hFacS(i-1, j ,k,bi,bj))
     &                 +(_hFacS(i,j+1,k,bi,bj)+_hFacS(i-1,j+1,k,bi,bj))
     &                )
        ENDDO
       ENDDO
      ENDIF

      RETURN
      END

#include "CPP_OPTIONS.h"
#undef INCLUDE_EOS_CHECK

C--  File ini_eos.F: Routines to initialise Equation of State
C--   Contents
C--   o INI_EOS
C--   o EOS_CHECK

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: INI_EOS
C     !INTERFACE:
      SUBROUTINE INI_EOS( myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE INI_EOS
C     | o Initialise coefficients of equation of state.
C     *==========================================================*
C     \ev

C     !USES:

      IMPLICIT NONE
C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "EOS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     myThid -  Number of this instance of INI_CORI
      INTEGER myThid

C     !FUNCTIONS
      INTEGER  ILNBLNK
      EXTERNAL ILNBLNK

C     !LOCAL VARIABLES:
C     == Local variables ==
C     i,k    :: Loop counters
      INTEGER  i, k, iLen
      CHARACTER*(MAX_LEN_MBUF) msgBuf

      IF ( .NOT.fluidIsWater ) RETURN

      _BARRIER
      _BEGIN_MASTER(myThid)

      equationOfState = eosType
      iLen = ILNBLNK(equationOfState)
      iLen = MAX(iLen,1)

      DO k = 1,6
         eosJMDCFw(k) = 0. _d 0
      ENDDO
      DO k = 1,9
         eosJMDCSw(k) = 0. _d 0
      ENDDO
      DO k = 1,5
         eosJMDCKFw(k) = 0. _d 0
      ENDDO
      DO k = 1,7
         eosJMDCKSw(k) = 0. _d 0
      ENDDO
      DO k = 1,14
         eosJMDCKP(k) = 0. _d 0
      ENDDO
      DO k = 0,11
         eosMDJWFnum(k) = 0. _d 0
      ENDDO
      DO k = 0,12
         eosMDJWFden(k) = 0. _d 0
      ENDDO
      DO k = 1,48
         teos(k)        = 0. _d 0
      ENDDO

C     For all current EOS that explicitly depend on pressure ('UNESCO',
C     'JMD95','MDJWF' & 'TEOS10' ), the input pressure is assumed to be
C     relative to reference atmospheric pressure of 1.atm = 101325 Pa
      eosRefP0 = 101325. _d 0

      IF ( equationOfState .EQ. 'LINEAR' ) THEN
         IF ( tAlpha .EQ. UNSET_RL ) tAlpha = 2.  _d -4
         IF ( sBeta  .EQ. UNSET_RL ) sBeta  = 7.4 _d -4
      ELSEIF ( equationOfState .EQ. 'POLY3' ) THEN
         OPEN(37,FILE='POLY3.COEFFS',STATUS='OLD',FORM='FORMATTED')
         READ(37,*) k
         IF (k.NE.Nr) THEN
            WRITE(msgBuf,'(A)')
     &           'ini_eos: attempt to read POLY3.COEFFS failed'
            CALL PRINT_ERROR( msgBuf, myThid )
            WRITE(msgBuf,'(A)')
     &           '           because bad # of levels in data'
            CALL PRINT_ERROR( msgBuf, myThid )
            STOP 'Bad data in POLY3.COEFFS'
         ENDIF
         READ(37,*) (eosRefT(k),eosRefS(k),eosSig0(k),k=1,Nr)
         DO k=1,Nr
            READ(37,*) (eosC(i,k),i=1,9)
         ENDDO
         CLOSE(37)

      ELSEIF ( equationOfState .EQ. 'JMD95Z'
     &    .OR. equationOfState .EQ. 'JMD95P'
     &    .OR. equationOfState .EQ. 'UNESCO' ) THEN

C     Jackett & McDougall (1995, JAOT) equation of state
C     rho = R(salinity, potential temperature, pressure)
C     pressure needs to be available (from the previous
C     time step to linearize the problem)

         IF ( equationOfState .EQ. 'JMD95Z' .AND. usingPCoords ) THEN
            WRITE(msgBuf,'(A)')
     &      'ini_eos: equation of state ''JMD95Z'' should not'
            CALL PRINT_ERROR( msgBuf, myThid )
            WRITE(msgBuf,'(A)')
     &      '         be used together with pressure coordinates.'
            CALL PRINT_ERROR( msgBuf, myThid )
            WRITE(msgBuf,'(A)')
     &      '         Use only ''JMD95P'' with ''OCEANICP''.'
            CALL PRINT_ERROR( msgBuf, myThid )
            STOP 'ABNORMAL END: S/R INI_EOS'
         ENDIF

C     coefficients nonlinear equation of state in pressure coordinates for
C     1. density of fresh water at p = 0
         eosJMDCFw(1) =  999.842594 _d +00
         eosJMDCFw(2) =    6.793952 _d -02
         eosJMDCFw(3) = -  9.095290 _d -03
         eosJMDCFw(4) =    1.001685 _d -04
         eosJMDCFw(5) = -  1.120083 _d -06
         eosJMDCFw(6) =    6.536332 _d -09
C     2. density of sea water at p = 0
         eosJMDCSw(1) =    8.24493  _d -01
         eosJMDCSw(2) = -  4.0899   _d -03
         eosJMDCSw(3) =    7.6438   _d -05
         eosJMDCSw(4) = -  8.2467   _d -07
         eosJMDCSw(5) =    5.3875   _d -09
         eosJMDCSw(6) = -  5.72466  _d -03
         eosJMDCSw(7) =    1.0227   _d -04
         eosJMDCSw(8) = -  1.6546   _d -06
         eosJMDCSw(9) =    4.8314   _d -04
         IF ( equationOfState(1:5) .EQ. 'JMD95' ) THEN
C     3. secant bulk modulus K of fresh water at p = 0
            eosJMDCKFw(1) =   1.965933 _d +04
            eosJMDCKFw(2) =   1.444304 _d +02
            eosJMDCKFw(3) = - 1.706103 _d +00
            eosJMDCKFw(4) =   9.648704 _d -03
            eosJMDCKFw(5) = - 4.190253 _d -05
C     4. secant bulk modulus K of sea water at p = 0
            eosJMDCKSw(1) =   5.284855 _d +01
            eosJMDCKSw(2) = - 3.101089 _d -01
            eosJMDCKSw(3) =   6.283263 _d -03
            eosJMDCKSw(4) = - 5.084188 _d -05
            eosJMDCKSw(5) =   3.886640 _d -01
            eosJMDCKSw(6) =   9.085835 _d -03
            eosJMDCKSw(7) = - 4.619924 _d -04
C     5. secant bulk modulus K of sea water at p
            eosJMDCKP( 1) =   3.186519 _d +00
            eosJMDCKP( 2) =   2.212276 _d -02
            eosJMDCKP( 3) = - 2.984642 _d -04
            eosJMDCKP( 4) =   1.956415 _d -06
            eosJMDCKP( 5) =   6.704388 _d -03
            eosJMDCKP( 6) = - 1.847318 _d -04
            eosJMDCKP( 7) =   2.059331 _d -07
            eosJMDCKP( 8) =   1.480266 _d -04
            eosJMDCKP( 9) =   2.102898 _d -04
            eosJMDCKP(10) = - 1.202016 _d -05
            eosJMDCKP(11) =   1.394680 _d -07
            eosJMDCKP(12) = - 2.040237 _d -06
            eosJMDCKP(13) =   6.128773 _d -08
            eosJMDCKP(14) =   6.207323 _d -10

         ELSEIF ( equationOfState .EQ. 'UNESCO' ) THEN

            WRITE(msgBuf,'(a)')
     &           'WARNING WARNING WARNING WARNING WARNING WARNING '
            CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                          SQUEEZE_RIGHT, myThid )
            WRITE(msgBuf,'(a,a)')
     &           'WARNING: using the UNESCO formula with potential ',
     &           'temperature'
            CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                          SQUEEZE_RIGHT, myThid )
            WRITE(msgBuf,'(a)')
     &           'WARNING: can result in density errors of up to 5%'
            CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                          SQUEEZE_RIGHT, myThid )
            WRITE(msgBuf,'(a)')
     &           'WARNING: (see Jackett and McDougall 1995, JAOT)'
            CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                          SQUEEZE_RIGHT, myThid )
            WRITE(msgBuf,'(a)')
     &           'WARNING WARNING WARNING WARNING WARNING WARNING '
            CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                          SQUEEZE_RIGHT, myThid )

C     3. secant bulk modulus K of fresh water at p = 0
            eosJMDCKFw(1) =   1.965221 _d +04
            eosJMDCKFw(2) =   1.484206 _d +02
            eosJMDCKFw(3) = - 2.327105 _d +00
            eosJMDCKFw(4) =   1.360477 _d -02
            eosJMDCKFw(5) = - 5.155288 _d -05
C     4. secant bulk modulus K of sea water at p = 0
            eosJMDCKSw(1) =   5.46746  _d +01
            eosJMDCKSw(2) = - 0.603459 _d +00
            eosJMDCKSw(3) =   1.09987  _d -02
            eosJMDCKSw(4) = - 6.1670   _d -05
            eosJMDCKSw(5) =   7.944    _d -02
            eosJMDCKSw(6) =   1.6483   _d -02
            eosJMDCKSw(7) = - 5.3009   _d -04
C     5. secant bulk modulus K of sea water at p
            eosJMDCKP( 1) =   3.239908 _d +00
            eosJMDCKP( 2) =   1.43713  _d -03
            eosJMDCKP( 3) =   1.16092  _d -04
            eosJMDCKP( 4) = - 5.77905  _d -07
            eosJMDCKP( 5) =   2.2838   _d -03
            eosJMDCKP( 6) = - 1.0981   _d -05
            eosJMDCKP( 7) = - 1.6078   _d -06
            eosJMDCKP( 8) =   1.91075  _d -04
            eosJMDCKP( 9) =   8.50935  _d -05
            eosJMDCKP(10) = - 6.12293  _d -06
            eosJMDCKP(11) =   5.2787   _d -08
            eosJMDCKP(12) = - 9.9348   _d -07
            eosJMDCKP(13) =   2.0816   _d -08
            eosJMDCKP(14) =   9.1697   _d -10
         ELSE
            STOP 'INI_EOS: We should never reach this point!'
         ENDIF

      ELSEIF ( equationOfState .EQ. 'MDJWF' ) THEN

         eosMDJWFnum( 0) =  9.99843699 _d +02
         eosMDJWFnum( 1) =  7.35212840 _d +00
         eosMDJWFnum( 2) = -5.45928211 _d -02
         eosMDJWFnum( 3) =  3.98476704 _d -04
         eosMDJWFnum( 4) =  2.96938239 _d +00
         eosMDJWFnum( 5) = -7.23268813 _d -03
         eosMDJWFnum( 6) =  2.12382341 _d -03
         eosMDJWFnum( 7) =  1.04004591 _d -02
         eosMDJWFnum( 8) =  1.03970529 _d -07
         eosMDJWFnum( 9) =  5.18761880 _d -06
         eosMDJWFnum(10) = -3.24041825 _d -08
         eosMDJWFnum(11) = -1.23869360 _d -11

         eosMDJWFden( 0) =  1.00000000 _d +00
         eosMDJWFden( 1) =  7.28606739 _d -03
         eosMDJWFden( 2) = -4.60835542 _d -05
         eosMDJWFden( 3) =  3.68390573 _d -07
         eosMDJWFden( 4) =  1.80809186 _d -10
         eosMDJWFden( 5) =  2.14691708 _d -03
         eosMDJWFden( 6) = -9.27062484 _d -06
         eosMDJWFden( 7) = -1.78343643 _d -10
         eosMDJWFden( 8) =  4.76534122 _d -06
         eosMDJWFden( 9) =  1.63410736 _d -09
         eosMDJWFden(10) =  5.30848875 _d -06
         eosMDJWFden(11) = -3.03175128 _d -16
         eosMDJWFden(12) = -1.27934137 _d -17

      ELSEIF ( equationOfState .EQ. 'TEOS10' ) THEN

       teos(01) =  9.998420897506056 _d +02
       teos(02) =  2.839940833161907 _d  00
       teos(03) = -3.147759265588511 _d -02
       teos(04) =  1.181805545074306 _d -03
       teos(05) = -6.698001071123802 _d  00
       teos(06) = -2.986498947203215 _d -02
       teos(07) =  2.327859407479162 _d -04
       teos(08) = -3.988822378968490 _d -02
       teos(09) =  5.095422573880500 _d -04
       teos(10) = -1.426984671633621 _d -05
       teos(11) =  1.645039373682922 _d -07
       teos(12) = -2.233269627352527 _d -02
       teos(13) = -3.436090079851880 _d -04
       teos(14) =  3.726050720345733 _d -06
       teos(15) = -1.806789763745328 _d -04
       teos(16) =  6.876837219536232 _d -07
       teos(17) = -3.087032500374211 _d -07
       teos(18) = -1.988366587925593 _d -08
       teos(19) = -1.061519070296458 _d -11
       teos(20) =  1.550932729220080 _d -10
       teos(21) =  1.000000000000000 _d  00
       teos(22) =  2.775927747785646 _d -03
       teos(23) = -2.349607444135925 _d -05
       teos(24) =  1.119513357486743 _d -06
       teos(25) =  6.743689325042773 _d -10
       teos(26) = -7.521448093615448 _d -03
       teos(27) = -2.764306979894411 _d -05
       teos(28) =  1.262937315098546 _d -07
       teos(29) =  9.527875081696435 _d -10
       teos(30) = -1.811147201949891 _d -11
       teos(31) = -3.303308871386421 _d -05
       teos(32) =  3.801564588876298 _d -07
       teos(33) = -7.672876869259043 _d -09
       teos(34) = -4.634182341116144 _d -11
       teos(35) =  2.681097235569143 _d -12
       teos(36) =  5.419326551148740 _d -06
       teos(37) = -2.742185394906099 _d -05
       teos(38) = -3.212746477974189 _d -07
       teos(39) =  3.191413910561627 _d -09
       teos(40) = -1.931012931541776 _d -12
       teos(41) = -1.105097577149576 _d -07
       teos(42) =  6.211426728363857 _d -10
       teos(43) = -1.119011592875110 _d -10
       teos(44) = -1.941660213148725 _d -11
       teos(45) = -1.864826425365600 _d -14
       teos(46) =  1.119522344879478 _d -14
       teos(47) = -1.200507748551599 _d -15
       teos(48) =  6.057902487546866 _d -17

       Sprac_Sref = 35.0 _d 0 / 35.16504 _d 0
       I_S0       = 0.025 _d 0 *Sprac_Sref
       I_Ts       = 0.025 _d 0
       I_cp0      = 1.0 _d 0 / 3991.86795711963 _d 0

       H00 = 61.01362420681071 _d 0   *  I_cp0
       H01 = 168776.46138048015 _d 0  * (I_cp0*I_Ts)
       H02 = -2735.2785605119625 _d 0 * (I_cp0*I_Ts**2)
       H03 = 2574.2164453821433 _d 0  * (I_cp0*I_Ts**3)
       H04 = -1536.6644434977543 _d 0 * (I_cp0*I_Ts**4)
       H05 = 545.7340497931629 _d 0   * (I_cp0*I_Ts**5)
       H06 = -50.91091728474331 _d 0  * (I_cp0*I_Ts**6)
       H07 = -18.30489878927802 _d 0  * (I_cp0*I_Ts**7)
       H20 = 268.5520265845071 _d 0   *  I_cp0
       H21 = -12019.028203559312 _d 0 * (I_cp0*I_Ts)
       H22 = 3734.858026725145 _d 0   * (I_cp0*I_Ts**2)
       H23 = -2046.7671145057618 _d 0 * (I_cp0*I_Ts**3)
       H24 = 465.28655623826234 _d 0  * (I_cp0*I_Ts**4)
       H25 = -0.6370820302376359 _d 0 * (I_cp0*I_Ts**5)
       H26 = -10.650848542359153 _d 0 * (I_cp0*I_Ts**6)
       H30 = 937.2099110620707 _d 0   *  I_cp0
       H31 = 588.1802812170108 _d 0   * (I_cp0*I_Ts)
       H32 = 248.39476522971285 _d 0  * (I_cp0*I_Ts**2)
       H33 = -3.871557904936333 _d 0  * (I_cp0*I_Ts**3)
       H34 = -2.6268019854268356 _d 0 * (I_cp0*I_Ts**4)
       H40 = -1687.914374187449 _d 0  *  I_cp0
       H41 = 936.3206544460336 _d 0   * (I_cp0*I_Ts)
       H42 = -942.7827304544439 _d 0  * (I_cp0*I_Ts**2)
       H43 = 369.4389437509002 _d 0   * (I_cp0*I_Ts**3)
       H44 = -33.83664947895248 _d 0  * (I_cp0*I_Ts**4)
       H45 = -9.987880382780322 _d 0  * (I_cp0*I_Ts**5)
       H50 = 246.9598888781377 _d 0   *  I_cp0
       H60 = 123.59576582457964 _d 0  *  I_cp0
       H70 = -48.5891069025409 _d 0   *  I_cp0

       TPN00 = -1.446013646344788 _d -2
       TPN10 = -3.305308995852924 _d -3 * Sprac_Sref
       TPN20 =  1.062415929128982 _d -4 * Sprac_Sref**2
       TPN01 =  9.477566673794488 _d -1
       TPN11 =  2.166591947736613 _d -3 * Sprac_Sref
       TPN02 =  3.828842955039902 _d -3
       TPD10 =  6.506097115635800 _d -4 * Sprac_Sref
       TPD01 =  3.830289486850898 _d -3
       TPD02 =  1.247811760368034 _d -6

      ELSEIF( equationOfState .EQ. 'IDEALG' ) THEN

      ELSE

         WRITE(msgBuf,'(3A)') 'INI_EOS: eosType= "',
     &                     equationOfState(1:iLen), '" not valid'
         CALL PRINT_ERROR( msgbuf, myThid )
         STOP 'ABNORMAL END: S/R INI_EOS'

      ENDIF

C--   Check EOS initialisation:

      CALL EOS_CHECK( myThid )

      _END_MASTER( myThid )
      _BARRIER

      RETURN
      END

CBOP
C     !ROUTINE: EOS_CHECK
C     !INTERFACE:
      SUBROUTINE EOS_CHECK( myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE EOS_CHECK
C     | o check the equation of state.
C     *==========================================================*
C     \ev

C     !USES:

      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "EOS.h"
#include "GRID.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     myThid ::  Number of this instance of EOS_CHECK
      INTEGER myThid

#ifdef INCLUDE_EOS_CHECK
C     !LOCAL VARIABLES:
C     == Local variables ==
C     bi,bj  - Loop counters
C     i,j,k
      INTEGER bi, bj
      INTEGER iMin, iMax, jMin, jMax
      INTEGER  i, j, k
      _RL tFld   (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL sFld   (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL pFld   (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL rhoLoc (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL bulkMod(1-OLx:sNx+OLx,1-OLy:sNy+OLy)

      INTEGER ncheck, kcheck, k1c, k2c, iLen
      PARAMETER ( ncheck = 20 )
      _RL tLoc(ncheck), ptLoc(ncheck), sLoc(ncheck), pLoc(ncheck)
      _RL rLoc(ncheck), bLoc(ncheck)
      _RL surf_pRef_save, rhoDif

      CHARACTER*(MAX_LEN_MBUF) msgBuf
      CHARACTER*(13) blkWrd

      DATA tLoc
     &     /3.25905152915860 _d 0, 20.38687090048638 _d 0,
     &     25.44820830309568 _d 0, 20.17368557065936 _d 0,
     &     13.43397459640398 _d 0,
     &      5.               _d 0, 25.               _d 0,
     &      5.               _d 0, 25.               _d 0,
     &      5.               _d 0, 25.               _d 0,
     &      5.               _d 0, 25.               _d 0,
     &      5.               _d 0, 25.               _d 0,
     &      5.               _d 0, 25.               _d 0,
     &      5.               _d 0, 25.               _d 0,
     &      5.               _d 0/
     &     ptLoc
     &     /3.               _d 0, 20.               _d 0,
     &     25.               _d 0, 20.               _d 0,
     &     12.               _d 0,
     &      5.               _d 0, 25.               _d 0,
     &      5.               _d 0, 25.               _d 0,
     &      4.03692566635316 _d 0, 22.84661726775120 _d 0,
     &      3.62720389416752 _d 0, 22.62420229124846 _d 0,
     &     19.5130           _d 0,  3.5588           _d 0,
     &      1.8157           _d 0,  1.3434           _d 0,
     &      1.1583           _d 0,  1.0518           _d 0,
     &      1.0073           _d 0/
     &     sLoc
     &     /35.5 _d 0, 35. _d 0,
     &      35.0 _d 0, 20. _d 0,
     &      40.0 _d 0,
     &       0.  _d 0,  0. _d 0,
     &      35.  _d 0, 35. _d 0,
     &       0.  _d 0,  0. _d 0,
     &      35.  _d 0, 35. _d 0,
     &      34.7392 _d 0, 34.4652 _d 0,
     &      34.7738 _d 0, 34.8435 _d 0,
     &      34.8637 _d 0, 34.8739 _d 0, 34.8776 _d 0/
     &     pLoc
     &     /300. _d 5,  200. _d 5,
     &      200. _d 5,  100. _d 5,
     &      800. _d 5,
     &        0. _d 0,    0. _d 0,
     &        0. _d 0,    0. _d 0,
     &     1000. _d 5, 1000. _d 5,
     &     1000. _d 5, 1000. _d 5,
     &        0. _d 0, 1010. _d 4,
     &     2025. _d 4, 3045. _d 4,
     &     4069. _d 4, 5098. _d 4,
     &     6131. _d 4/
      DATA rLoc
     &     /1041.83267  _d 0, 1033.213387 _d 0,
     &      1031.654229 _d 0, 1017.726743 _d 0,
     &      1062.928258 _d 0,
     &       999.96675  _d 0,  997.04796  _d 0,
     &      1027.67547  _d 0, 1023.34306  _d 0,
     &      1044.12802  _d 0, 1037.90204  _d 0,
     &      1069.48914  _d 0, 1062.53817  _d 0,
     &      1024.571477039354932 _d 0, 1031.937207908966911 _d 0,
     &      1037.002326523349893 _d 0, 1041.668901630106348 _d 0,
     &      1046.179673478751511 _d 0, 1050.591667083023594 _d 0,
     &      1054.901835905235885 _d 0/
     &     bLoc
     &     /   -1.00000 _d 0,    -1.00000 _d 0,
     &         -1.00000 _d 0,    -1.00000 _d 0,
     &         -1.00000 _d 0,
     &      20337.80375 _d 0, 22100.72106 _d 0,
     &      22185.93358 _d 0, 23726.34949 _d 0,
     &      23643.52599 _d 0, 25405.09717 _d 0,
     &      25577.49819 _d 0, 27108.94504 _d 0,
     &         -1.00000 _d 0,    -1.00000 _d 0,
     &         -1.00000 _d 0,    -1.00000 _d 0,
     &         -1.00000 _d 0,    -1.00000 _d 0,
     &         -1.00000 _d 0/

      blkWrd = '             '
      bi   = 1
      bj   = 1
      k    = 1
      iMin = 1
      iMax = 1
      jMin = 1
      jMax = 1
      i    = 1
      j    = 1
      IF (       equationOfState.NE.'LINEAR'
     &     .AND. equationOfState.NE.'POLY3'
     &     .AND. equationOfState.NE.'IDEALG' ) THEN
C     check nonlinear EOS
        WRITE(msgBuf,'(A,A)')
     &        'EOS_CHECK: Check the equation of state: Type ',
     &        equationOfState
        CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
        IF ( equationOfState.EQ.'JMD95Z' .OR.
     &       equationOfState.EQ.'JMD95P' ) THEN
          WRITE(msgBuf,'(A)')
     &         'EOS_CHECK: check Rho values for eosType=JMD95:'
          k1c = 1
          k2c = 1
        ELSEIF ( equationOfState.EQ.'MDJWF' ) THEN
          WRITE(msgBuf,'(A)')
     &         'EOS_CHECK: check Rho values for eosType=MDJWF:'
          k1c = 2
          k2c = 5
        ELSEIF ( equationOfState.EQ.'UNESCO' ) THEN
          WRITE(msgBuf,'(A)')
     &         'EOS_CHECK: check Rho & K values for eosType=UNESCO:'
          k1c = 6
          k2c = 13
        ELSEIF ( equationOfState.EQ.'TEOS10' ) THEN
          WRITE(msgBuf,'(A)')
     &         'EOS_CHECK: check Rho values for eosType=TEOS10:'
          k1c = 14
          k2c = ncheck
        ELSE
          WRITE(msgBuf,'(3A)') 'EOS_CHECK: Invalid eosType= ',
     &          equationOfState
          CALL PRINT_ERROR( msgBuf, myThid )
          STOP 'ABNORMAL END: S/R EOS_CHECK'
        ENDIF
        CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
C-    Will use "surf_pRef" to get the right pressure out of S/R PRESSURE_FOR_EOS
C     --> save current value into "surf_pRef_save"
        surf_pRef_save = surf_pRef
        DO kcheck = k1c, k2c

          surf_pRef = eosRefP0 + pLoc(kcheck)
          IF ( usingPCoords ) THEN
            surf_pRef = surf_pRef - rC(k)
          ENDIF
          IF ( equationOfState.NE.'UNESCO' ) THEN
             tFld(i,j) = ptLoc(kcheck)
          ELSE
             tFld(i,j) = tLoc(kcheck)
          ENDIF
          sFld(i,j)    = sLoc(kcheck)
          pFld(i,j)    = pLoc(kcheck)
          rhoLoc(i,j)  =  0. _d 0

          CALL FIND_RHO_2D(
     I           iMin, iMax, jMin, jMax, k,
     I           tFld, sFld,
     O           rhoLoc,
     I           k, bi, bj, myThid )
          rhoDif = rhoLoc(i,j) + rhoConst - rLoc(kcheck)

          IF ( equationOfState.EQ.'UNESCO' ) THEN
            CALL FIND_BULKMOD(
     I           iMin, iMax, jMin, jMax,
     I           pFld, tFld, sFld,
     O           bulkMod,
     I           myThid )
C-    Reference value
            WRITE(msgBuf,'(2(A,F4.1),A,F5.0,2A,F10.5,A,F11.5)')
     &           'rho(', sFld(i,j), ' g/kg,',
     &           tFld(i,j), ' degC,',
     &           pLoc(kcheck)*SItoBar, ' bar)',
     &           ' = ', rLoc(kcheck), ' ', bLoc(kcheck)
            CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                          SQUEEZE_RIGHT, myThid )
            WRITE(msgBuf,'(A,F10.5,A,F11.5,A,1PE10.3)')
     &           ' rho(find_rho_2d)                 = ',
     &           rhoLoc(i,j)+rhoConst, ' ', bulkMod(i,j), ' ', rhoDif
            iLen = LEN( blkWrd )
          ELSE
C-    Reference value
            WRITE(msgBuf,'(2(A,F4.1),A,F5.0,2A,F10.5,A,F11.5)')
     &           'rho(', sFld(i,j), ' g/kg,',
     &           tFld(i,j), ' degC,',
     &           pLoc(kcheck)*SItoBar, ' bar)',
     &           ' = ', rLoc(kcheck)
            CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                          SQUEEZE_RIGHT, myThid )
            WRITE(msgBuf,'(A,F10.5,A,1PE10.3)')
     &         ' rho(find_rho_2d)                 = ',
     &         rhoLoc(i,j)+rhoConst, ' ', rhoDif
            iLen = 1
          ENDIF
          CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                        SQUEEZE_RIGHT, myThid )

          surf_pRef = eosRefP0
          CALL FIND_RHO_SCALAR( tFld(i,j), sLoc(kcheck),
     &         pLoc(kcheck), rhoLoc(i,j), myThid )
          rhoDif = rhoLoc(i,j) - rLoc(kcheck)
          WRITE(msgBuf,'(A,F10.5,A,1PE10.3)')
     &         ' rho(find_rho_scalar)             = ',
     &         rhoLoc(i,j), blkWrd(1:iLen), rhoDif
          CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                        SQUEEZE_RIGHT, myThid )

        ENDDO
C     end check nonlinear EOS ; restore surf_pRef value
        surf_pRef = surf_pRef_save

        WRITE(msgBuf,'(A)') 'EOS_CHECK: Done'
        CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )

      ENDIF
#endif /* INCLUDE_EOS_CHECK */

      RETURN
      END

#include "MONITOR_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: MON_SET_PREF

C     !INTERFACE:
      SUBROUTINE MON_SET_PREF( prefString, myThid )

C     !DESCRIPTION:
C     Set default monitor prefix string.

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "MONITOR.h"
      EXTERNAL IFNBLNK, ILNBLNK
      INTEGER  IFNBLNK, ILNBLNK

C     !INPUT PARAMETERS:
C     prefString - String to use for prefixing monitor output
C     myThid     - Instance number of this call to monitor
      CHARACTER*(*) prefString
      INTEGER myThid
CEOP

C     !LOCAL VARIABLES:
C     I0, I1 - String first and last indices
C     IL     - String length
      INTEGER I0, I1
      INTEGER IL

C     Dont change before everyone is ready
      CALL BAR2( myThid )

C     Set monitor I/O unit
      _BEGIN_MASTER(myThid)
      I0 = IFNBLNK( prefString )
      I1 = ILNBLNK( prefString )
      IL = I1-I0+1
      IF ( IL .LE. MAX_LEN_MBUF ) THEN
       mon_pref = ' '
       mon_prefL = IL
       mon_pref(1:IL) = prefString(I0:I1)
      ENDIF
      _END_MASTER(myThid)

C     Make sure everyone sees the change
      CALL BAR2( myThid )

      RETURN
      END

#include "ctrparam.h"
#include "ATM2D_OPTIONS.h"

C     !INTERFACE:
      SUBROUTINE GET_OCNVARS( myTime, myIter, myThid )
C     *==========================================================*
C     | Gets the ocean data from either the ocean common block,  |
C     | or, in MPI mode, from the passed common block. This data |
C     | is used by the atmosphere and sea ice models.            |
C     *==========================================================*
        IMPLICIT NONE

C     === Global Atmosphere Variables ===
#include "ATMSIZE.h"
#include "SIZE.h"
#include "EEPARAMS.h"
#include "THSICE_VARS.h"
#include "ATM2D_VARS.h"

#ifdef ATM2D_MPI_ON
#  include "OCNSIZE.h"
#  include "OCNVARS.h"
#  include "OCNIDS.h"
#else
#  include "PARAMS.h"
#  include "GRID.h"
#  include "SURFACE.h"
#  include "DYNVARS.h"
#  ifdef ALLOW_DIC
#    include "DIC_VARS.h"
#  endif
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
C     myTime - current simulation time (ocean model time)
C     myIter - iteration number (ocean model)
C     myThid - Thread no. that called this routine.
      _RL     myTime
      INTEGER myIter
      INTEGER myThid

C     LOCAL VARIABLES:
      INTEGER i,j


#ifdef ATM2D_MPI_ON
C presuming ocnsize.h same as size.h
      DO j=1,sNy
        DO i=1,sNx
          sstFromOcn(i,j)= SST_ocn(i,j)
          sssFromOcn(i,j)= SSS_ocn(i,j)
          mlDepth(i,j) = OcMxlD_ocn(i,j)
          IF ( ocnCpl_exchange_DIC ) oFluxCO2(i,j) = fluxCO2_ocn(i,j)
C          IF ( ocnCpl_exchange_DIC )
C     &       print *,'ofluxCO2:',i,j,fluxCO2_ocn(i,j)

C Put in seaice common block
          tOceMxl(i,j,1,1)= SST_ocn(i,j)
          sOceMxl(i,j,1,1)= SSS_ocn(i,j)
          hOceMxl(i,j,1,1) = OcMxlD_ocn(i,j)
          v2ocMxL(i,j,1,1) =  vSq_ocn(i,j)
        ENDDO
      ENDDO

#else
       DO j=1,sNy
        DO i=1,sNx
          sstFromOcn(i,j) = theta(i,j,1,1,1)
          sssFromOcn(i,j) = salt (i,j,1,1,1)
        ENDDO
       ENDDO

#  ifdef NONLIN_FRSURF
Cjrs ask J-M about next lines
      IF ( nonlinFreeSurf.GT.0 .AND. staggerTimeStep ) THEN
       IF ( select_rStar.GT.0 ) THEN
        DO j=1,sNy
         DO i=1,sNx
           mlDepth(i,j) =
     &          h0FacC(i,j,1,1,1)*rStarFacC(i,j,1,1)*drF(1)
         ENDDO
        ENDDO
       ELSE
        DO j=1,sNy
         DO i=1,sNx
           mlDepth(i,j) = hFac_surfC(i,j,1,1)*drF(1)
         ENDDO
        ENDDO
       ENDIF
      ELSE
#  else /* NONLIN_FRSURF */
      IF (.TRUE.) THEN
#  endif /* NONLIN_FRSURF */
       DO j=1,sNy
        DO i=1,sNx
           mlDepth(i,j) = hFacC(i,j,1,1,1)*drF(1)
        ENDDO
       ENDDO
      ENDIF

      DO j=1,sNy
        DO i=1,sNx
          v2ocMxL(i,j,1,1) =
     &              ( uVel(i , j,1,1,1)*uVel(i , j,1,1,1)
     &              + uVel(i+1,j,1,1,1)*uVel(i+1,j,1,1,1)
     &              + vVel(i,j+1,1,1,1)*vVel(i,j+1,1,1,1)
     &              + vVel(i,j , 1,1,1)*vVel(i,j , 1,1,1)
     &              )*0.5 _d 0
        ENDDO
      ENDDO

      DO j=1,sNy
        DO i=1,sNx

#  ifdef ALLOW_DIC
          oFluxCO2(i,j) = fluxCO2(i,j,1,1)
#  endif

C Put in seaice common block
          tOceMxl(i,j,1,1)= sstFromOcn(i,j)
          sOceMxl(i,j,1,1)= sssFromOcn(i,j)
          hOceMxl(i,j,1,1) = mlDepth(i,j)
        ENDDO
      ENDDO

#endif

      RETURN
      END

#include "FLT_OPTIONS.h"
#undef DBUG_EXCH_VEC

      SUBROUTINE FLT_EXCH2 (
     I                       myTime, myIter, myThid )

C     ==================================================================
C     SUBROUTINE FLT_EXCH2
C     ==================================================================
C     o Exchange particles between tiles.
C     started: Arne Biastoch
C     changed: Antti Westerlund antti.westerlund@helsinki.fi 2004.06.10
C     adapted to exch2: Oliver Jahn 2010.09
C     ==================================================================

C     !USES:
      IMPLICIT NONE

C     == global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "EESUPPORT.h"
#include "PARAMS.h"
#include "FLT_SIZE.h"
#include "FLT.h"
#ifdef ALLOW_EXCH2
#include "W2_EXCH2_SIZE.h"
#include "W2_EXCH2_PARAMS.h"
#include "W2_EXCH2_TOPOLOGY.h"
#endif

C     == routine arguments ==
      _RL myTime
      INTEGER myIter, myThid

#ifdef ALLOW_EXCH2

C     == local variables ==
      INTEGER bi, bj, ic
      INTEGER ip, jp, jl, npNew
      INTEGER icountE, icountW, icountN, icountS
      INTEGER deleteList(max_npart_exch*2)
      INTEGER imax, imax2, m
      INTEGER N, nT, ipass, myFace
      INTEGER e2_msgHandles( 2, W2_maxNeighbours, nSx, nSy )
      _RL ilo, ihi, jlo, jhi
      PARAMETER(imax=9)
      PARAMETER(imax2=imax*max_npart_exch)
      CHARACTER*(MAX_LEN_MBUF) msgBuf

C     buffer for sending/receiving variables (4 levels <-> N,S,E,W)
      COMMON/FLTBUF/fltbuf_send,fltbuf_recv
      _RL fltbuf_send(imax2,nSx,nSy,4)
      _RL fltbuf_recv(imax2,nSx,nSy,4)
      LOGICAL wSide, eSide, sSide, nSide
      _RL     flt_stopped

C     == end of interface ==

C have to do 2 passes to get into tiles diagonally across
      DO ipass=1,2

C     Prevent anyone to access shared buffer while an other thread modifies it
C--   not needed here since send buffer is different fron recv buffer
C     (which is not the case for usual 3-D field exch in EXCH2)
c       CALL BAR2( myThid )

C--   Choose floats that have to exchanged with eastern and western tiles
C     and pack to arrays

        DO bj=myByLo(myThid),myByHi(myThid)
         DO bi=myBxLo(myThid),myBxHi(myThid)
           nT = W2_myTileList(bi,bj)
           myFace = exch2_myFace(nT)

C initialize buffers
           DO N=1,4
            DO m=1,imax2
             fltbuf_send(m,bi,bj,N) = 0.
             fltbuf_recv(m,bi,bj,N) = 0.
            ENDDO
           ENDDO

           icountE=0
           icountW=0
           jl = 0

           ilo = 0.5 _d 0
           ihi = 0.5 _d 0 + DFLOAT(sNx)
           wSide = exch2_isWedge(nT).EQ.1
     &       .AND. facet_link(W2_WEST,myFace).EQ.0.
           eSide = exch2_isEedge(nT).EQ.1
     &       .AND. facet_link(W2_EAST,myFace).EQ.0.
           flt_stopped = -2.
           flt_stopped = MIN( baseTime, flt_stopped )

           DO ip=1,npart_tile(bi,bj)

             IF ( eSide .AND.
     &           (myTime.LE.tend(ip,bi,bj) .OR. tend(ip,bi,bj).EQ.-1.)
     &           .AND. ipart(ip,bi,bj).GE.ihi ) THEN
C          stop the float:
              tend(ip,bi,bj) = flt_stopped
             ELSEIF ( ipart(ip,bi,bj).GE.ihi ) THEN
              icountE=icountE+1
              IF ( icountE.LE.max_npart_exch ) THEN

               ic = (icountE-1)*imax
               fltbuf_send(ic+1,bi,bj,W2_EAST) =   npart(ip,bi,bj)
               fltbuf_send(ic+2,bi,bj,W2_EAST) =  tstart(ip,bi,bj)
               fltbuf_send(ic+3,bi,bj,W2_EAST) =   ipart(ip,bi,bj)
               fltbuf_send(ic+4,bi,bj,W2_EAST) =   jpart(ip,bi,bj)
               fltbuf_send(ic+5,bi,bj,W2_EAST) =   kpart(ip,bi,bj)
               fltbuf_send(ic+6,bi,bj,W2_EAST) =  kfloat(ip,bi,bj)
               fltbuf_send(ic+7,bi,bj,W2_EAST) =     iup(ip,bi,bj)
               fltbuf_send(ic+8,bi,bj,W2_EAST) =    itop(ip,bi,bj)
               fltbuf_send(ic+9,bi,bj,W2_EAST) =    tend(ip,bi,bj)

C tag this float to be removed:
               jl = jl + 1
               deleteList(jl) = ip
               npart(ip,bi,bj) = 0.

              ENDIF
             ENDIF

             IF ( wSide .AND.
     &           (myTime.LE.tend(ip,bi,bj) .OR. tend(ip,bi,bj).EQ.-1.)
     &           .AND. ipart(ip,bi,bj).LT.ilo ) THEN
C          stop the float:
              tend(ip,bi,bj) = flt_stopped
             ELSEIF ( ipart(ip,bi,bj).LT.ilo ) THEN
              icountW=icountW+1
              IF ( icountW.LE.max_npart_exch ) THEN

               ic = (icountW-1)*imax
               fltbuf_send(ic+1,bi,bj,W2_WEST) =   npart(ip,bi,bj)
               fltbuf_send(ic+2,bi,bj,W2_WEST) =  tstart(ip,bi,bj)
               fltbuf_send(ic+3,bi,bj,W2_WEST) =   ipart(ip,bi,bj)
               fltbuf_send(ic+4,bi,bj,W2_WEST) =   jpart(ip,bi,bj)
               fltbuf_send(ic+5,bi,bj,W2_WEST) =   kpart(ip,bi,bj)
               fltbuf_send(ic+6,bi,bj,W2_WEST) =  kfloat(ip,bi,bj)
               fltbuf_send(ic+7,bi,bj,W2_WEST) =     iup(ip,bi,bj)
               fltbuf_send(ic+8,bi,bj,W2_WEST) =    itop(ip,bi,bj)
               fltbuf_send(ic+9,bi,bj,W2_WEST) =    tend(ip,bi,bj)

C tag this float to be removed:
               jl = jl + 1
               deleteList(jl) = ip
               npart(ip,bi,bj) = 0.

              ENDIF
             ENDIF

           ENDDO
           IF ( icountE.GT.max_npart_exch ) THEN
             WRITE(msgBuf,'(2A,2I4,2(A,I8))') ' FLT_EXCH2:',
     &         ' bi,bj=', bi, bj,
     &         ' icountE=', icountE,
     &         ' > max_npart_exch=', max_npart_exch
             CALL PRINT_ERROR( msgBuf, myThid )
           ENDIF
           IF ( icountW.GT.max_npart_exch ) THEN
             WRITE(msgBuf,'(2A,2I4,2(A,I8))') ' FLT_EXCH2:',
     &         ' bi,bj=', bi, bj,
     &         ' icountW=', icountW,
     &         ' > max_npart_exch=', max_npart_exch
             CALL PRINT_ERROR( msgBuf, myThid )
           ENDIF
           IF ( icountE.GT.max_npart_exch
     &     .OR. icountW.GT.max_npart_exch ) THEN
             STOP 'ABNORMAL END: S/R FLT_EXCH2'
           ENDIF
           IF ( (icountE+icountW).GT.0 ) THEN
C Remove from this tile-list, floats which have been sent to an other tile
             npNew = npart_tile(bi,bj) - (icountE+icountW)
             jl = 0
             DO jp = npNew+1,npart_tile(bi,bj)
              IF ( npart(jp,bi,bj).NE.0. _d 0 ) THEN
                jl = jl + 1
                ip = deleteList(jl)
C        copy: ip <-- jp
                npart (ip,bi,bj) =  npart (jp,bi,bj)
                tstart(ip,bi,bj) =  tstart(jp,bi,bj)
                ipart (ip,bi,bj) =  ipart (jp,bi,bj)
                jpart (ip,bi,bj) =  jpart (jp,bi,bj)
                kpart (ip,bi,bj) =  kpart (jp,bi,bj)
                kfloat(ip,bi,bj) =  kfloat(jp,bi,bj)
                iup   (ip,bi,bj) =  iup   (jp,bi,bj)
                itop  (ip,bi,bj) =  itop  (jp,bi,bj)
                tend  (ip,bi,bj) =  tend  (jp,bi,bj)
              ENDIF
             ENDDO
             npart_tile(bi,bj) = npNew
           ENDIF

           icountN=0
           icountS=0
           jl = 0

           jlo = 0.5 _d 0
           jhi = 0.5 _d 0 + DFLOAT(sNy)
           sSide = exch2_isSedge(nT).EQ.1
     &       .AND. facet_link(W2_SOUTH,myFace).EQ.0.
           nSide = exch2_isNedge(nT).EQ.1
     &       .AND. facet_link(W2_NORTH,myFace).EQ.0.
           flt_stopped = -2.
           flt_stopped = MIN( baseTime, flt_stopped )

           DO ip=1,npart_tile(bi,bj)

            IF ( npart(ip,bi,bj).NE.0 ) THEN

             IF ( nSide .AND.
     &           (myTime.LE.tend(ip,bi,bj) .OR. tend(ip,bi,bj).EQ.-1.)
     &           .AND. jpart(ip,bi,bj).GE.jhi ) THEN
C          stop the float:
              tend(ip,bi,bj) = flt_stopped
             ELSEIF ( jpart(ip,bi,bj).GE.jhi ) THEN
              icountN=icountN+1
              IF ( icountN.LE.max_npart_exch ) THEN

               ic = (icountN-1)*imax
               fltbuf_send(ic+1,bi,bj,W2_NORTH) =   npart(ip,bi,bj)
               fltbuf_send(ic+2,bi,bj,W2_NORTH) =  tstart(ip,bi,bj)
               fltbuf_send(ic+3,bi,bj,W2_NORTH) =   ipart(ip,bi,bj)
               fltbuf_send(ic+4,bi,bj,W2_NORTH) =   jpart(ip,bi,bj)
               fltbuf_send(ic+5,bi,bj,W2_NORTH) =   kpart(ip,bi,bj)
               fltbuf_send(ic+6,bi,bj,W2_NORTH) =  kfloat(ip,bi,bj)
               fltbuf_send(ic+7,bi,bj,W2_NORTH) =     iup(ip,bi,bj)
               fltbuf_send(ic+8,bi,bj,W2_NORTH) =    itop(ip,bi,bj)
               fltbuf_send(ic+9,bi,bj,W2_NORTH) =    tend(ip,bi,bj)

C tag this float to be removed:
               jl = jl + 1
               deleteList(jl) = ip
               npart(ip,bi,bj) = 0.

c             ELSE
c              WRITE(msgBuf,'(2A,2I4,I6,A,2F17.6))') ' FLT_EXCH2,N:',
c    &         ' bi,bj,ip=', bi, bj, ip,
c    &         ' yp,yHi=', jpart(ip,bi,bj), jhi
c              CALL PRINT_ERROR( msgBuf, myThid )
              ENDIF
             ENDIF

             IF ( sSide .AND.
     &           (myTime.LE.tend(ip,bi,bj) .OR. tend(ip,bi,bj).EQ.-1.)
     &           .AND. jpart(ip,bi,bj).LT.jlo ) THEN
C          stop the float:
              tend(ip,bi,bj) = flt_stopped
             ELSEIF ( jpart(ip,bi,bj).LT.jlo ) THEN
              icountS=icountS+1
              IF ( icountS.LE.max_npart_exch ) THEN

               ic = (icountS-1)*imax
               fltbuf_send(ic+1,bi,bj,W2_SOUTH) =   npart(ip,bi,bj)
               fltbuf_send(ic+2,bi,bj,W2_SOUTH) =  tstart(ip,bi,bj)
               fltbuf_send(ic+3,bi,bj,W2_SOUTH) =   ipart(ip,bi,bj)
               fltbuf_send(ic+4,bi,bj,W2_SOUTH) =   jpart(ip,bi,bj)
               fltbuf_send(ic+5,bi,bj,W2_SOUTH) =   kpart(ip,bi,bj)
               fltbuf_send(ic+6,bi,bj,W2_SOUTH) =  kfloat(ip,bi,bj)
               fltbuf_send(ic+7,bi,bj,W2_SOUTH) =     iup(ip,bi,bj)
               fltbuf_send(ic+8,bi,bj,W2_SOUTH) =    itop(ip,bi,bj)
               fltbuf_send(ic+9,bi,bj,W2_SOUTH) =    tend(ip,bi,bj)

C tag this float to be removed:
               jl = jl + 1
               deleteList(jl) = ip
               npart(ip,bi,bj) = 0.

c             ELSE
c              WRITE(msgBuf,'(2A,2I4,I6,A,2F17.6))') ' FLT_EXCH2,S:',
c    &         ' bi,bj,ip=', bi, bj, ip,
c    &         ' yp,yLo=', jpart(ip,bi,bj), jlo
c              CALL PRINT_ERROR( msgBuf, myThid )
              ENDIF
             ENDIF

            ENDIF

           ENDDO
           IF ( icountN.GT.max_npart_exch ) THEN
             WRITE(msgBuf,'(2A,2I4,2(A,I8))') ' FLT_EXCH2:',
     &         ' bi,bj=', bi, bj,
     &         ' icountN=', icountN,
     &         ' > max_npart_exch=', max_npart_exch
             CALL PRINT_ERROR( msgBuf, myThid )
           ENDIF
           IF ( icountS.GT.max_npart_exch ) THEN
             WRITE(msgBuf,'(2A,2I4,2(A,I8))') ' FLT_EXCH2:',
     &         ' bi,bj=', bi, bj,
     &         ' icountS=', icountS,
     &         ' > max_npart_exch=', max_npart_exch
             CALL PRINT_ERROR( msgBuf, myThid )
           ENDIF
           IF ( icountN.GT.max_npart_exch
     &     .OR. icountS.GT.max_npart_exch ) THEN
             STOP 'ABNORMAL END: S/R FLT_EXCH2'
           ENDIF
           IF ( (icountN+icountS).GT.0 ) THEN
C Remove from this tile-list, floats which have been sent to an other tile
             npNew = npart_tile(bi,bj) - (icountN+icountS)
             jl = 0
             DO jp = npNew+1,npart_tile(bi,bj)
              IF ( npart(jp,bi,bj).NE.0. _d 0 ) THEN
                jl = jl + 1
                ip = deleteList(jl)
C        copy: ip <-- jp
                npart (ip,bi,bj) =  npart (jp,bi,bj)
                tstart(ip,bi,bj) =  tstart(jp,bi,bj)
                ipart (ip,bi,bj) =  ipart (jp,bi,bj)
                jpart (ip,bi,bj) =  jpart (jp,bi,bj)
                kpart (ip,bi,bj) =  kpart (jp,bi,bj)
                kfloat(ip,bi,bj) =  kfloat(jp,bi,bj)
                iup   (ip,bi,bj) =  iup   (jp,bi,bj)
                itop  (ip,bi,bj) =  itop  (jp,bi,bj)
                tend  (ip,bi,bj) =  tend  (jp,bi,bj)
              ENDIF
             ENDDO
             npart_tile(bi,bj) = npNew
           ENDIF

         ENDDO
        ENDDO

C     Prevent anyone to access shared buffer while an other thread modifies it
        _BARRIER

C--   Send or Put east and west edges.

#ifdef DBUG_EXCH_VEC
        WRITE(errorMessageUnit,'(A,I8)') 'FLT_EXCH: 0x', myIter
#endif
        CALL EXCH2_SEND_PUT_VEC_RL(
     I                               fltbuf_send,
     O                               fltbuf_recv,
     O                               e2_msgHandles(1,1,1,1),
     I                               imax2, myThid )
#ifdef DBUG_EXCH_VEC
        WRITE(errorMessageUnit,'(A,I8)') 'FLT_EXCH2: 1x', myIter
#endif

#ifdef ALLOW_USE_MPI
        IF ( usingMPI ) THEN
C--   Receive east/west arrays
         CALL EXCH2_RECV_GET_VEC_RL(
     U                               fltbuf_recv,
     I                               e2_msgHandles(1,1,1,1),
     I                               imax2, myThid )
#ifdef DBUG_EXCH_VEC
         WRITE(errorMessageUnit,'(A,I8)') 'FLT_EXCH2: 2x', myIter
#endif
        ENDIF
#endif /* ALLOW_USE_MPI */

C--   need to sync threads after master has received data ;
C     (done after mpi waitall in case waitall is really needed)
        _BARRIER

C--   Unpack arrays on new tiles

        DO bj=myByLo(myThid),myByHi(myThid)
         DO bi=myBxLo(myThid),myBxHi(myThid)

           DO ip=1,max_npart_exch

            ic=(ip-1)*imax
            IF ( fltbuf_recv(ic+1,bi,bj,W2_EAST).NE.0. ) THEN
             npart_tile(bi,bj) = npart_tile(bi,bj) + 1
             IF ( npart_tile(bi,bj).LE.max_npart_tile ) THEN
               jp = npart_tile(bi,bj)
               npart( jp,bi,bj) = fltbuf_recv(ic+1,bi,bj,W2_EAST)
               tstart(jp,bi,bj) = fltbuf_recv(ic+2,bi,bj,W2_EAST)
               ipart( jp,bi,bj) = fltbuf_recv(ic+3,bi,bj,W2_EAST)
               jpart( jp,bi,bj) = fltbuf_recv(ic+4,bi,bj,W2_EAST)
               kpart( jp,bi,bj) = fltbuf_recv(ic+5,bi,bj,W2_EAST)
               kfloat(jp,bi,bj) = fltbuf_recv(ic+6,bi,bj,W2_EAST)
               iup(   jp,bi,bj) = fltbuf_recv(ic+7,bi,bj,W2_EAST)
               itop(  jp,bi,bj) = fltbuf_recv(ic+8,bi,bj,W2_EAST)
               tend(  jp,bi,bj) = fltbuf_recv(ic+9,bi,bj,W2_EAST)
             ENDIF
            ENDIF

           ENDDO
           IF ( npart_tile(bi,bj).GT.max_npart_tile ) THEN
             WRITE(msgBuf,'(2A,2I4,2(A,I8))') 'FLT_EXCH2:+E',
     &         ' bi,bj=', bi, bj,
     &         ' npart_tile=', npart_tile(bi,bj),
     &         ' > max_npart_tile=', max_npart_tile
              CALL PRINT_ERROR( msgBuf, myThid )
              STOP 'ABNORMAL END: S/R FLT_EXCH2'
           ENDIF

           DO ip=1,max_npart_exch

            ic=(ip-1)*imax
            IF ( fltbuf_recv(ic+1,bi,bj,W2_WEST).NE.0. ) THEN
             npart_tile(bi,bj) = npart_tile(bi,bj) + 1
             IF ( npart_tile(bi,bj).LE.max_npart_tile ) THEN
               jp = npart_tile(bi,bj)
               npart( jp,bi,bj) = fltbuf_recv(ic+1,bi,bj,W2_WEST)
               tstart(jp,bi,bj) = fltbuf_recv(ic+2,bi,bj,W2_WEST)
               ipart( jp,bi,bj) = fltbuf_recv(ic+3,bi,bj,W2_WEST)
               jpart( jp,bi,bj) = fltbuf_recv(ic+4,bi,bj,W2_WEST)
               kpart( jp,bi,bj) = fltbuf_recv(ic+5,bi,bj,W2_WEST)
               kfloat(jp,bi,bj) = fltbuf_recv(ic+6,bi,bj,W2_WEST)
               iup(   jp,bi,bj) = fltbuf_recv(ic+7,bi,bj,W2_WEST)
               itop(  jp,bi,bj) = fltbuf_recv(ic+8,bi,bj,W2_WEST)
               tend(  jp,bi,bj) = fltbuf_recv(ic+9,bi,bj,W2_WEST)
             ENDIF
            ENDIF

           ENDDO
           IF ( npart_tile(bi,bj).GT.max_npart_tile ) THEN
             WRITE(msgBuf,'(2A,2I4,2(A,I8))') 'FLT_EXCH2:+W',
     &         ' bi,bj=', bi, bj,
     &         ' npart_tile=', npart_tile(bi,bj),
     &         ' > max_npart_tile=', max_npart_tile
              CALL PRINT_ERROR( msgBuf, myThid )
              STOP 'ABNORMAL END: S/R FLT_EXCH2'
           ENDIF

           DO ip=1,max_npart_exch

            ic=(ip-1)*imax
            IF ( fltbuf_recv(ic+1,bi,bj,W2_NORTH).NE.0. ) THEN
             npart_tile(bi,bj) = npart_tile(bi,bj) + 1
             IF ( npart_tile(bi,bj).LE.max_npart_tile ) THEN
               jp = npart_tile(bi,bj)
               npart( jp,bi,bj) = fltbuf_recv(ic+1,bi,bj,W2_NORTH)
               tstart(jp,bi,bj) = fltbuf_recv(ic+2,bi,bj,W2_NORTH)
               ipart( jp,bi,bj) = fltbuf_recv(ic+3,bi,bj,W2_NORTH)
               jpart( jp,bi,bj) = fltbuf_recv(ic+4,bi,bj,W2_NORTH)
               kpart( jp,bi,bj) = fltbuf_recv(ic+5,bi,bj,W2_NORTH)
               kfloat(jp,bi,bj) = fltbuf_recv(ic+6,bi,bj,W2_NORTH)
               iup(   jp,bi,bj) = fltbuf_recv(ic+7,bi,bj,W2_NORTH)
               itop(  jp,bi,bj) = fltbuf_recv(ic+8,bi,bj,W2_NORTH)
               tend(  jp,bi,bj) = fltbuf_recv(ic+9,bi,bj,W2_NORTH)
             ENDIF
            ENDIF

           ENDDO
           IF ( npart_tile(bi,bj).GT.max_npart_tile ) THEN
             WRITE(msgBuf,'(2A,2I4,2(A,I8))') 'FLT_EXCH2:+N',
     &         ' bi,bj=', bi, bj,
     &         ' npart_tile=', npart_tile(bi,bj),
     &         ' > max_npart_tile=', max_npart_tile
              CALL PRINT_ERROR( msgBuf, myThid )
              STOP 'ABNORMAL END: S/R FLT_EXCH2'
           ENDIF

           DO ip=1,max_npart_exch

            ic=(ip-1)*imax
            IF ( fltbuf_recv(ic+1,bi,bj,W2_SOUTH).NE.0. ) THEN
             npart_tile(bi,bj) = npart_tile(bi,bj) + 1
             IF ( npart_tile(bi,bj).LE.max_npart_tile ) THEN
               jp = npart_tile(bi,bj)
               npart( jp,bi,bj) = fltbuf_recv(ic+1,bi,bj,W2_SOUTH)
               tstart(jp,bi,bj) = fltbuf_recv(ic+2,bi,bj,W2_SOUTH)
               ipart( jp,bi,bj) = fltbuf_recv(ic+3,bi,bj,W2_SOUTH)
               jpart( jp,bi,bj) = fltbuf_recv(ic+4,bi,bj,W2_SOUTH)
               kpart( jp,bi,bj) = fltbuf_recv(ic+5,bi,bj,W2_SOUTH)
               kfloat(jp,bi,bj) = fltbuf_recv(ic+6,bi,bj,W2_SOUTH)
               iup(   jp,bi,bj) = fltbuf_recv(ic+7,bi,bj,W2_SOUTH)
               itop(  jp,bi,bj) = fltbuf_recv(ic+8,bi,bj,W2_SOUTH)
               tend(  jp,bi,bj) = fltbuf_recv(ic+9,bi,bj,W2_SOUTH)
             ENDIF
            ENDIF

           ENDDO
           IF ( npart_tile(bi,bj).GT.max_npart_tile ) THEN
             WRITE(msgBuf,'(2A,2I4,2(A,I8))') 'FLT_EXCH2:+S',
     &         ' bi,bj=', bi, bj,
     &         ' npart_tile=', npart_tile(bi,bj),
     &         ' > max_npart_tile=', max_npart_tile
              CALL PRINT_ERROR( msgBuf, myThid )
              STOP 'ABNORMAL END: S/R FLT_EXCH2'
           ENDIF

         ENDDO
        ENDDO

C ipass
      ENDDO

#endif /* ALLOW_EXCH2 */

      RETURN
      END

#include "THSICE_OPTIONS.h"
#ifdef ALLOW_AUTODIFF
# include "AUTODIFF_OPTIONS.h"
#endif

CBOP
C     !ROUTINE: THSICE_STEP_TEMP
C     !INTERFACE:
      SUBROUTINE THSICE_STEP_TEMP(
     I             bi, bj, iMin, iMax, jMin, jMax,
     I             myTime, myIter, myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R  THSICE_STEP_TEMP
C     | o Step Forward Surface and SeaIce Temperature.
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "FFIELDS.h"
#include "THSICE_SIZE.h"
#include "THSICE_PARAMS.h"
#include "THSICE_VARS.h"
#ifdef ALLOW_AUTODIFF_TAMC
# include "tamc.h"
#endif

      INTEGER siLo, siHi, sjLo, sjHi
      PARAMETER ( siLo = 1-OLx , siHi = sNx+OLx )
      PARAMETER ( sjLo = 1-OLy , sjHi = sNy+OLy )

C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
C- input:
C     bi,bj   :: tile indices
C   iMin,iMax :: computation domain: 1rst index range
C   jMin,jMax :: computation domain: 2nd  index range
C     myTime  :: Current time in simulation
C     myIter  :: Current iteration number
C     myThid  :: my Thread Id number
C-- Modify fluxes hold in commom blocks
C- input:
C     icFlxSW :: (Inp) short-wave heat flux (+=down): downward comp. only
C- output
C     icFlxSW :: (Out) net SW flux into ocean (+=down)
C     icFlxAtm:: net flux of energy from the atmosphere [W/m2] (+=down)
C     icFrwAtm:: evaporation to the atmosphere (kg/m2/s) (>0 if evaporate)
C--
      INTEGER bi,bj
      INTEGER iMin, iMax
      INTEGER jMin, jMax
      _RL  myTime
      INTEGER myIter
      INTEGER myThid
CEOP

#ifdef ALLOW_THSICE
C     !LOCAL VARIABLES:
C     === Local variables ===
C     tFrzOce   :: sea-water freezing temperature [oC] (function of S)
C     dTsrf     :: surf. temp adjusment: Ts^n+1 - Ts^n
C     tmpFlx    :: dummy array for surface fluxes and derivative vs Tsurf
C Note: dTsrf & tmpFlx are not used here; just allocate enough space for dTsrf.
      INTEGER i,j
      _RL tFrzOce(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL dTsrf  (1:sNx,1:sNy)
C     some compilers complain about the wrong dimensions of this field
C     so it has to be defined with overlaps
      _RL tmpFlx (1:sNx,1:sNy,0:2)
      _RL opFrac, icFrac
      LOGICAL dBugFlag

#ifdef ALLOW_AUTODIFF_TAMC
C     tkey  :: tape key (depends on tiles)
      INTEGER tkey
#endif
C-    define grid-point location where to print debugging values
#include "THSICE_DEBUG.h"

 1010 FORMAT(A,1P4E14.6)

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#ifdef ALLOW_AUTODIFF_TAMC
      tkey = bi + (bj-1)*nSx + (ikey_dynamics-1)*nSx*nSy
#endif /* ALLOW_AUTODIFF_TAMC */

C     Initialise some local arrays
      DO j = 1-OLy, sNy+OLy
       DO i = 1-OLx, sNx+OLx
        tFrzOce(i,j)  = 0. _d 0
       ENDDO
      ENDDO
      DO j = 1, sNy
       DO i = 1, sNx
        dTsrf(i,j)    = 0. _d 0
        tmpFlx(i,j,0) = 0. _d 0
        tmpFlx(i,j,1) = 0. _d 0
        tmpFlx(i,j,2) = 0. _d 0
       ENDDO
      ENDDO

      dBugFlag = debugLevel.GE.debLevC
C-    Initialise flxAtm,evpAtm
      DO j = 1-OLy, sNy+OLy
       DO i = 1-OLx, sNx+OLx
        icFlxAtm(i,j,bi,bj) = 0.
        icFrwAtm(i,j,bi,bj) = 0.
       ENDDO
      ENDDO

#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE tsrf(:,:,bi,bj) = comlev1_bibj, key=tkey, kind=isbyte
#endif
c     IF ( fluidIsWater ) THEN
       CALL THSICE_ALBEDO(
     I          bi, bj, siLo, siHi, sjLo, sjHi,
     I          iMin,iMax, jMin,jMax,
     I          iceMask(siLo,sjLo,bi,bj), iceHeight(siLo,sjLo,bi,bj),
     I          snowHeight(siLo,sjLo,bi,bj), Tsrf(siLo,sjLo,bi,bj),
     I          snowAge(siLo,sjLo,bi,bj),
     O          siceAlb(siLo,sjLo,bi,bj), icAlbNIR(siLo,sjLo,bi,bj),
     I          myTime, myIter, myThid )

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C    part.1 : ice-covered fraction ;
C     Solve for surface and ice temperature (implicitly) ; compute surf. fluxes
C-------

#ifdef ALLOW_AUTODIFF_TAMC
C     avoid calling s/r thsice_albedosolve4temp in adjoint routine again
CADJ STORE siceAlb (:,:,bi,bj) = comlev1_bibj, key=tkey, kind=isbyte
CADJ STORE icAlbNIR(:,:,bi,bj) = comlev1_bibj, key=tkey, kind=isbyte
CADJ STORE icFlxSW (:,:,bi,bj) = comlev1_bibj, key=tkey, kind=isbyte
#endif

#ifdef ALLOW_DBUG_THSICE
       DO j = jMin, jMax
        DO i = iMin, iMax
         IF (iceMask(i,j,bi,bj).GT.0. _d 0) THEN
          IF ( dBug(i,j,bi,bj) ) THEN
           WRITE(6,'(A,2I4,2I2)') 'ThSI_STEP_T: i,j=',i,j,bi,bj
           WRITE(6,1010) 'ThSI_STEP_T: iceMask, hIc, hSn, Tsf  =',
     &                   iceMask(i,j,bi,bj), iceHeight(i,j,bi,bj),
     &                   snowHeight(i,j,bi,bj), Tsrf(i,j,bi,bj)
          ENDIF
         ENDIF
        ENDDO
       ENDDO
#endif
       DO j = jMin, jMax
        DO i = iMin, iMax
         IF (iceMask(i,j,bi,bj).GT.0. _d 0) THEN
C-      surface net SW flux:
          icFlxSW(i,j,bi,bj) = icFlxSW(i,j,bi,bj)
     &                       *(1. _d 0 - siceAlb(i,j,bi,bj))
          tFrzOce(i,j) = -mu_Tf*sOceMxL(i,j,bi,bj)
         ELSE
          tFrzOce(i,j) = 0. _d 0
         ENDIF
        ENDDO
       ENDDO

#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE Qice1   (:,:,bi,bj) = comlev1_bibj, key=tkey, kind=isbyte
CADJ STORE Qice2   (:,:,bi,bj) = comlev1_bibj, key=tkey, kind=isbyte
CADJ STORE sHeating(:,:,bi,bj) = comlev1_bibj, key=tkey, kind=isbyte
CADJ STORE Tsrf    (:,:,bi,bj) = comlev1_bibj, key=tkey, kind=isbyte
#endif
       CALL THSICE_SOLVE4TEMP(
     I          bi, bj,
     I          iMin,iMax, jMin,jMax, dBugFlag,
     I          useBulkForce, useEXF,
     I          iceMask(siLo,sjLo,bi,bj), iceHeight(siLo,sjLo,bi,bj),
     I          snowHeight(siLo,sjLo,bi,bj), tFrzOce, tmpFlx,
     U          icFlxSW(siLo,sjLo,bi,bj), Tsrf(siLo,sjLo,bi,bj),
     U          Qice1(siLo,sjLo,bi,bj), Qice2(siLo,sjLo,bi,bj),
     O          Tice1(siLo,sjLo,bi,bj), Tice2(siLo,sjLo,bi,bj), dTsrf,
     O          sHeating(siLo,sjLo,bi,bj), flxCndBt(siLo,sjLo,bi,bj),
     O          icFlxAtm(siLo,sjLo,bi,bj), icFrwAtm(siLo,sjLo,bi,bj),
     I          myTime, myIter, myThid )

#ifdef ALLOW_AUTODIFF_TAMC
C     avoid calling s/r thsice_solve4temp in adjoint routine again
CADJ STORE icFlxSW(:,:,bi,bj) = comlev1_bibj, key=tkey, kind=isbyte
#endif
       DO j = jMin, jMax
        DO i = iMin, iMax
         IF (iceMask(i,j,bi,bj).GT.0. _d 0) THEN
          icFrac  = iceMask(i,j,bi,bj)
          opFrac = 1. _d 0 - icFrac
C--    Update Fluxes :
          Qsw(i,j,bi,bj) = opFrac*Qsw(i,j,bi,bj)
     &                   - icFrac*icFlxSW(i,j,bi,bj)
         ENDIF
        ENDDO
       ENDDO
c     ENDIF

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
#endif /* ALLOW_THSICE */

      RETURN
      END

#include "MONITOR_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: MON_KE

C     !INTERFACE:
      SUBROUTINE MON_KE(
     I     myIter, myThid )

C     !DESCRIPTION:
C     Calculates stats for Kinetic Energy, (barotropic) Potential Energy
C                      and total Angular Momentum

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "DYNVARS.h"
#include "MONITOR.h"
#include "GRID.h"
#include "SURFACE.h"

C     !INPUT PARAMETERS:
      INTEGER myIter, myThid
CEOP

C     !LOCAL VARIABLES:
      INTEGER bi, bj
      INTEGER i,j,k
      INTEGER ks, kp1
      _RL numPnts,theVol,tmpVal, mskp1, msk_1
      _RL abFac1, abFac2, R_drK, cosLat
      _RL theMax,theMean,theVolMean,potEnMean
      _RL totAMu, totAMs
      _RL tileMean(nSx,nSy)
      _RL tileVlAv(nSx,nSy)
      _RL tilePEav(nSx,nSy)
      _RL tileVol (nSx,nSy)
      _RL tileAMu (nSx,nSy)
      _RL tileAMs (nSx,nSy)
      _RL tmpFld(1:sNx,1:sNy)
      _RS cos2LatG(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
#ifdef ALLOW_NONHYDROSTATIC
      _RL tmpWke
#endif
#ifdef ALLOW_ADAMSBASHFORTH_3
      INTEGER m1, m2
#endif

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      numPnts=0.
      theVol=0.
      theMax=0.
      theMean=0.
      theVolMean=0.
      potEnMean =0.

      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        tileVol(bi,bj)  = 0. _d 0
        tileMean(bi,bj) = 0. _d 0
        tileVlAv(bi,bj) = 0. _d 0
        tilePEav(bi,bj) = 0. _d 0
        DO k=1,Nr
         kp1 = MIN(k+1,Nr)
         mskp1 = 1.
         IF ( k.GE.Nr ) mskp1 = 0.
C- Note: Present NH implementation does not account for D.w/dt at k=1.
C        Consequently, wVel(k=1) does not contribute to NH KE (msk_1=0).
         msk_1 = 1.
         IF ( k.EQ.1 .AND. selectNHfreeSurf.LE.0 ) msk_1 = 0.
         DO j=1,sNy
          DO i=1,sNx
           tileVol(bi,bj) = tileVol(bi,bj)
     &                    + rA(i,j,bi,bj)*deepFac2C(k)
     &                     *rhoFacC(k)*drF(k)*_hFacC(i,j,k,bi,bj)
     &                     *maskInC(i,j,bi,bj)

C- Vector Invariant form (like in pkg/mom_vecinv/mom_vi_calc_ke.F)
c          tmpVal=0.25*( uVel( i , j ,k,bi,bj)*uVel( i , j ,k,bi,bj)
c    &                  +uVel(i+1, j ,k,bi,bj)*uVel(i+1, j ,k,bi,bj)
c    &                  +vVel( i , j ,k,bi,bj)*vVel( i , j ,k,bi,bj)
c    &                  +vVel( i ,j+1,k,bi,bj)*vVel( i ,j+1,k,bi,bj) )
c          tileVlAv(bi,bj) = tileVlAv(bi,bj)
c    &              +tmpVal*rA(i,j,bi,bj)*drF(k)*hFacC(i,j,k,bi,bj)

C- Energy conservative form (like in pkg/mom_fluxform/mom_calc_ke.F)
C    this is the safe way to check the energy conservation
C    with no assumption on how grid spacing & area are defined.
           tmpVal=0.25*(
     &       uVel( i ,j,k,bi,bj)*uVel( i ,j,k,bi,bj)
     &         *dyG( i ,j,bi,bj)*dxC( i ,j,bi,bj)*_hFacW( i ,j,k,bi,bj)
     &      +uVel(i+1,j,k,bi,bj)*uVel(i+1,j,k,bi,bj)
     &         *dyG(i+1,j,bi,bj)*dxC(i+1,j,bi,bj)*_hFacW(i+1,j,k,bi,bj)
     &      +vVel(i, j ,k,bi,bj)*vVel(i, j ,k,bi,bj)
     &         *dxG(i, j ,bi,bj)*dyC(i, j ,bi,bj)*_hFacS(i, j ,k,bi,bj)
     &      +vVel(i,j+1,k,bi,bj)*vVel(i,j+1,k,bi,bj)
     &         *dxG(i,j+1,bi,bj)*dyC(i,j+1,bi,bj)*_hFacS(i,j+1,k,bi,bj)
     &        )*maskInC(i,j,bi,bj)
           tileVlAv(bi,bj) = tileVlAv(bi,bj)
     &                     + tmpVal*deepFac2C(k)*rhoFacC(k)*drF(k)
           tmpVal= tmpVal*_recip_hFacC(i,j,k,bi,bj)*recip_rA(i,j,bi,bj)

#ifdef ALLOW_NONHYDROSTATIC
           IF ( nonHydrostatic ) THEN
            tmpWke = 0.25*
     &        ( wVel(i,j, k, bi,bj)*wVel(i,j, k, bi,bj)*msk_1
     &                             *deepFac2F( k )*rhoFacF( k )
     &         +wVel(i,j,kp1,bi,bj)*wVel(i,j,kp1,bi,bj)*mskp1
     &                             *deepFac2F(kp1)*rhoFacF(kp1)
     &        )*maskC(i,j,k,bi,bj)*maskInC(i,j,bi,bj)
            tileVlAv(bi,bj) = tileVlAv(bi,bj)
     &             + tmpWke*rA(i,j,bi,bj)*drF(k)*_hFacC(i,j,k,bi,bj)
            tmpVal = tmpVal
     &             + tmpWke*recip_deepFac2C(k)*recip_rhoFacC(k)
           ENDIF
#endif

           theMax=MAX(theMax,tmpVal)
           IF (tmpVal.NE.0.) THEN
            tileMean(bi,bj)=tileMean(bi,bj)+tmpVal
            numPnts=numPnts+1.
           ENDIF

          ENDDO
         ENDDO
        ENDDO
C- Potential Energy (external mode):
         DO j=1,sNy
          DO i=1,sNx
           tmpVal = 0.5 _d 0*Bo_surf(i,j,bi,bj)
     &                      *etaN(i,j,bi,bj)*etaN(i,j,bi,bj)
C- jmc: if geoid not flat (phi0surf), needs to add this term.
C       not sure for atmos/ocean in P ; or atmos. loading in ocean-Z
           tmpVal = tmpVal
     &            + phi0surf(i,j,bi,bj)*etaN(i,j,bi,bj)
           tilePEav(bi,bj) = tilePEav(bi,bj)
     &            + tmpVal*rA(i,j,bi,bj)*deepFac2F(1)
     &                    *maskInC(i,j,bi,bj)
c          tmpVal = etaN(i,j,bi,bj)
c    &            + phi0surf(i,j,bi,bj)*recip_Bo(i,j,bi,bj)
c          tilePEav(bi,bj) = tilePEav(bi,bj)
c    &        + 0.5 _d 0*Bo_surf(i,j,bi,bj)*tmpVal*tmpVal
c    &                  *rA(i,j,bi,bj)*maskInC(i,j,bi,bj)
          ENDDO
         ENDDO
C- end bi,bj loops
       ENDDO
      ENDDO
      _GLOBAL_SUM_RL(numPnts,myThid)
      _GLOBAL_MAX_RL(theMax,myThid)
      CALL GLOBAL_SUM_TILE_RL( tileMean, theMean   , myThid )
      CALL GLOBAL_SUM_TILE_RL( tileVol , theVol    , myThid )
      CALL GLOBAL_SUM_TILE_RL( tileVlAv, theVolMean, myThid )
      CALL GLOBAL_SUM_TILE_RL( tilePEav, potEnMean , myThid )
      IF (numPnts.NE.0.) theMean=theMean/numPnts
      IF (theVol.NE.0.) THEN
        theVolMean=theVolMean/theVol
        potEnMean = potEnMean/theVol
      ENDIF

C--   Compute total angular momentum
      IF ( mon_output_AM ) THEN
       DO bj=myByLo(myThid),myByHi(myThid)
        DO bi=myBxLo(myThid),myBxHi(myThid)
C-    Calculate contribution from zonal velocity
         abFac1 = 0. _d 0
         abFac2 = 0. _d 0
#ifdef ALLOW_ADAMSBASHFORTH_3
          m1 = 1 + mod(myIter+1,2)
          m2 = 1 + mod( myIter ,2)
          IF ( myIter.GE.2 ) abFac2 = beta_AB
          IF ( myIter.GE.1 ) abFac1 = -( alph_AB + abFac2 )
#else
          IF ( myIter.GE.1 ) abFac1 = -( 0.5 _d 0 + abEps )
#endif
C-    contribution from uVel component: 1rst integrate vertically
         DO j=1,sNy
          DO i=1,sNx
            tmpFld(i,j) = 0. _d 0
          ENDDO
         ENDDO
         DO k=1,Nr
          R_drK = rSphere*deepFacC(k)*deepFac2C(k)
     &                   *rhoFacC(k)*drF(k)
          DO j=1,sNy
           DO i=1,sNx
#ifdef ALLOW_ADAMSBASHFORTH_3
            tmpVal = abFac1*guNm(i,j,k,bi,bj,m1)
     &             + abFac2*guNm(i,j,k,bi,bj,m2)
#else
            tmpVal = abFac1*guNm1(i,j,k,bi,bj)
#endif
            tmpVal = tmpVal*deltaTMom + uVel(i,j,k,bi,bj)
            tmpFld(i,j) = tmpFld(i,j)
     &             + R_drK*tmpVal*_hFacW(i,j,k,bi,bj)
           ENDDO
          ENDDO
         ENDDO
C-    and then integrate horizontally over this tile
         DO j=1,sNy
          DO i=1,sNx
            cosLat = COS( deg2rad*
     &             ( yG(i,j,bi,bj) + yG(i,j+1,bi,bj) )*halfRL )
            tmpFld(i,j) = tmpFld(i,j)*u2zonDir(i,j,bi,bj)
     &                   *cosLat*rAw(i,j,bi,bj)
     &                   *maskInW(i,j,bi,bj)
          ENDDO
         ENDDO
         tileAMu(bi,bj) = 0. _d 0
         DO j=1,sNy
          DO i=1,sNx
            tileAMu(bi,bj) = tileAMu(bi,bj) + tmpFld(i,j)
          ENDDO
         ENDDO
C-    contribution from vVel component: 1rst integrate vertically
         DO j=1,sNy
          DO i=1,sNx
            tmpFld(i,j) = 0. _d 0
          ENDDO
         ENDDO
         DO k=1,Nr
          R_drK = rSphere*deepFacC(k)*deepFac2C(k)
     &                   *rhoFacC(k)*drF(k)
          DO j=1,sNy
           DO i=1,sNx
#ifdef ALLOW_ADAMSBASHFORTH_3
            tmpVal = abFac1*gvNm(i,j,k,bi,bj,m1)
     &             + abFac2*gvNm(i,j,k,bi,bj,m2)
#else
            tmpVal = abFac1*gvNm1(i,j,k,bi,bj)
#endif
            tmpVal = tmpVal*deltaTMom + vVel(i,j,k,bi,bj)
            tmpFld(i,j) = tmpFld(i,j)
     &             + R_drK*tmpVal*_hFacS(i,j,k,bi,bj)
           ENDDO
          ENDDO
         ENDDO
C-    and then integrate horizontally over this tile
         DO j=1,sNy
          DO i=1,sNx
            cosLat = COS( deg2rad*
     &             ( yG(i,j,bi,bj) + yG(i+1,j,bi,bj) )*halfRL )
            tmpFld(i,j) = tmpFld(i,j)*v2zonDir(i,j,bi,bj)
     &                   *cosLat*rAs(i,j,bi,bj)
     &                   *maskInS(i,j,bi,bj)
          ENDDO
         ENDDO
         DO j=1,sNy
          DO i=1,sNx
            tileAMu(bi,bj) = tileAMu(bi,bj) + tmpFld(i,j)
          ENDDO
         ENDDO
C-    Calculate contribution from mass distribution anomaly (i.e., free-surface)
         IF ( exactConserv ) THEN
          DO j=1,sNy
           DO i=1,sNx
            tmpFld(i,j) = etaHnm1(i,j,bi,bj)
           ENDDO
          ENDDO
         ELSE
          DO j=1,sNy
           DO i=1,sNx
            tmpFld(i,j) = etaN(i,j,bi,bj)
           ENDDO
          ENDDO
         ENDIF
C-    calculate angular momentum from mass-distribution anomaly
C     using square of radial distance (averaged @ center point)
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
            cosLat = COS( deg2rad*yG(i,j,bi,bj) )
            cos2LatG(i,j) = cosLat*cosLat
          ENDDO
         ENDDO
         DO j=1,sNy
          DO i=1,sNx
            tmpFld(i,j) = tmpFld(i,j)
     &        *omega*rSphere*rSphere
     &        *( ( cos2LatG(i,j) + cos2LatG(i+1,j+1) )
     &         + ( cos2LatG(i+1,j) + cos2LatG(i,j+1) )
     &         )*0.25 _d 0
          ENDDO
         ENDDO
         DO j=1,sNy
          DO i=1,sNx
            ks = kSurfC(i,j,bi,bj)
            tmpFld(i,j) = tmpFld(i,j)
     &             *maskInC(i,j,bi,bj)*deepFac2F(ks)
     &             *rA(i,j,bi,bj)*deepFac2F(ks)*rhoFacF(ks)
          ENDDO
         ENDDO
         tileAMs(bi,bj) = 0. _d 0
         DO j=1,sNy
          DO i=1,sNx
            tileAMs(bi,bj) = tileAMs(bi,bj) + tmpFld(i,j)
          ENDDO
         ENDDO
C- end bi,bj loops
        ENDDO
       ENDDO
       CALL GLOBAL_SUM_TILE_RL( tileAMu , totAMu, myThid )
       CALL GLOBAL_SUM_TILE_RL( tileAMs , totAMs, myThid )

C--   Print stats for total Angular Momentum (per unit area, in kg/s):
       CALL MON_SET_PREF('am',myThid)
       totAMu = totAMu*rUnit2mass
       totAMs = totAMs*rUnit2mass
       IF ( globalArea.GT.0. ) totAMu = totAMu/globalArea
       IF ( globalArea.GT.0. ) totAMs = totAMs/globalArea
       CALL MON_OUT_RL( mon_string_none, totAMs,
     &         '_eta_mean', myThid )
       CALL MON_OUT_RL( mon_string_none, totAMu,
     &         '_uZo_mean', myThid )
       totAMu = totAMu + freeSurfFac*totAMs
       CALL MON_OUT_RL( mon_string_none, totAMu,
     &         '_tot_mean', myThid )

      ENDIF

C--   Print stats for (barotropic) Potential Energy:
      CALL MON_SET_PREF('pe_b',myThid)
      CALL MON_OUT_RL(mon_string_none,potEnMean,
     &         mon_foot_mean,myThid)

C--   Print stats for KE
      CALL MON_SET_PREF('ke',myThid)
      CALL MON_OUT_RL(mon_string_none,theMax,mon_foot_max,myThid)
c     CALL MON_OUT_RL(mon_string_none,theMean,mon_foot_mean,myThid)
      CALL MON_OUT_RL(mon_string_none,theVolMean,
     &         mon_foot_mean,myThid)
      CALL MON_OUT_RL(mon_string_none,theVol,
     &         mon_foot_vol,myThid)

      RETURN
      END

#include "GAD_OPTIONS.h"

CBOP
C     !ROUTINE: GAD_C2_IMPL_R
C     !INTERFACE:
      SUBROUTINE GAD_C2_IMPL_R(
     I           bi,bj,k, iMin,iMax,jMin,jMax,
     I           deltaTarg, rTrans, recip_hFac,
     O           a3d, b3d, c3d,
     I           myThid )

C     !DESCRIPTION:
C     Compute matrix element to solve vertical advection implicitly
C     using centered second-order scheme The contribution of vertical
C     transport at interface k is added to matrix lines k and k-1.

C     !USES:
      IMPLICIT NONE

C     == Global variables ===
#include "SIZE.h"
#include "GRID.h"
#include "EEPARAMS.h"
#include "PARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine Arguments ==
C     bi,bj        :: tile indices
C     k            :: vertical level
C     iMin,iMax    :: computation domain
C     jMin,jMax    :: computation domain
C     deltaTarg    :: time step
C     rTrans       :: vertical volume transport
C     recip_hFac   :: inverse of cell open-depth factor
C     a3d          :: lower diagonal of the tridiagonal matrix
C     b3d          :: main  diagonal of the tridiagonal matrix
C     c3d          :: upper diagonal of the tridiagonal matrix
C     myThid       :: thread number
      INTEGER bi,bj,k
      INTEGER iMin,iMax,jMin,jMax
      _RL     deltaTarg(Nr)
      _RL     rTrans(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RS recip_hFac(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL     a3d   (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL     b3d   (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL     c3d   (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      INTEGER myThid

C     == Local Variables ==
C     i,j          :: loop indices
C     rCenter      :: centered contribution
      INTEGER i,j
      _RL rCenter
CEOP

C--   process interior interface only:
      IF ( k.GT.1 .AND. k.LE.Nr ) THEN

C--    Add centered contribution
       DO j=jMin,jMax
         DO i=iMin,iMax
           rCenter = 0.5 _d 0 *rTrans(i,j)*recip_rA(i,j,bi,bj)*rkSign
           a3d(i,j,k)   = a3d(i,j,k)
     &                  - rCenter*deltaTarg(k)
     &                   *recip_hFac(i,j,k)*recip_drF(k)
     &                   *recip_deepFac2C(k)*recip_rhoFacC(k)
           b3d(i,j,k)   = b3d(i,j,k)
     &                  - rCenter*deltaTarg(k)
     &                   *recip_hFac(i,j,k)*recip_drF(k)
     &                   *recip_deepFac2C(k)*recip_rhoFacC(k)
           b3d(i,j,k-1) = b3d(i,j,k-1)
     &                  + rCenter*deltaTarg(k-1)
     &                   *recip_hFac(i,j,k-1)*recip_drF(k-1)
     &                   *recip_deepFac2C(k-1)*recip_rhoFacC(k-1)
           c3d(i,j,k-1) = c3d(i,j,k-1)
     &                  + rCenter*deltaTarg(k-1)
     &                   *recip_hFac(i,j,k-1)*recip_drF(k-1)
     &                   *recip_deepFac2C(k-1)*recip_rhoFacC(k-1)
         ENDDO
       ENDDO

C--   process interior interface only: end
      ENDIF

      RETURN
      END

#include "FIZHI_OPTIONS.h"
       SUBROUTINE FIZHI_DRIVER (myid,im,jm,lm,bi,bj,ptracer,ntracer,
     & turbStart, xlats,xlons,
     & p,u,v,t,q,pl,ple,dpres,pkht,pkl,surfz,fracland,landtype,radswt,
     & phis_var,tgz,sea_ice,
     & nchp,chlat,chlon,igrd,nchptot,nchpland,chfr,ityp,
     & tcanopy,tdeep,ecanopy,swetshal,swetroot,swetdeep,capac,snodep,
     & ctmt,xxmt,yymt,zetamt,xlmt,khmt,tke,
     & albvisdr,albvisdf,albnirdr,albnirdf,emiss,alai,agrn,
     & chemq,chemo3,co2,cfc11,cfc12,cfc22,methane,n2o,
     & lwdt,lwdtclr,swdt,swdtclr,turbu,turbv,turbt,turbq,
     & moistu,moistv,moistt,moistq,
     & radswg,swgclr,fdirpar,fdifpar,osr,osrclr,tg0,radlwg,lwgclr,
     & st4,dst4,dlwdtg,rainlsp,raincon,snowfall,iras,nlwcld,
     & cldtot_lw,cldras_lw,cldlsp_lw,nlwlz,lwlz,nswcld,cldtot_sw,
     & cldras_sw,cldlsp_sw,nswlz,swlz,imstturbsw,imstturblw,qliqavesw,
     & qliqavelw,fccavesw,fccavelw,qq)
C***********************************************************************
C  Purpose
C  -------
C     Driver for the FIZHI high-end Atmospheric Physics
C
C  Arguments  Description
C  ----------------------
C     nymd ..... Current YYMMDD
C     nhms ..... Current HHMMSS
C     fracland.. Land Fractions
C     landtype.. Land Vegetation Types
C     radswt ... Incident Solar Radiation
C
C***********************************************************************
      IMPLICIT NONE

c Diagnostic Common
c -----------------

c Timers Common
c -------------
#include "chronos.h"

c Input Parameters
c ----------------
      INTEGER myid,im,jm,lm,bi,bj,ptracer,ntracer
      LOGICAL turbStart
      INTEGER nchp,igrd(nchp),nchptot,nchpland,ityp(nchp)
      INTEGER iras,nlwcld,nlwlz,nswcld,nswlz
      INTEGER imstturbsw,imstturblw

      _RL xlats(im,jm), xlons(im,jm)
      _RL p(im,jm)
      _RL u(im,jm,lm),v(im,jm,lm),t(im,jm,lm)
      _RL q(im,jm,lm,ntracer)
      _RL pl(im,jm,lm),ple(im,jm,lm+1),dpres(im,jm,lm)
      _RL pkht(im,jm,lm+1)
      _RL pkl(im,jm,lm)
      _RL surfz(im,jm)
      _RL radswt(im,jm), fracland(im,jm)
      INTEGER landtype(im,jm)
      _RL phis_var(im,jm), sea_ice(im,jm)
      _RL chlat(nchp),chlon(nchp),chfr(nchp)
      _RL tcanopy(nchp),tdeep(nchp),ecanopy(nchp),swetshal(nchp)
      _RL swetroot(nchp),swetdeep(nchp),capac(nchp),snodep(nchp)
      _RL ctmt(nchp),xxmt(nchp),yymt(nchp),zetamt(nchp)
      _RL xlmt(nchp,lm),khmt(nchp,lm),tke(nchp,lm)
      _RL co2,cfc11,cfc12,cfc22,methane(lm),n2o(lm)
      _RL lwdt(im,jm,lm),lwdtclr(im,jm,lm)
      _RL swdt(im,jm,lm),swdtclr(im,jm,lm)
      _RL turbu(im,jm,lm),turbv(im,jm,lm),turbt(im,jm,lm)
      _RL turbq(im,jm,lm,ntracer)
      _RL moistu(im,jm,lm),moistv(im,jm,lm),moistt(im,jm,lm)
      _RL moistq(im,jm,lm,ntracer)
      _RL chemo3(im,jm,lm),chemq(im,jm,lm)
      _RL albvisdr(im,jm),albvisdf(im,jm),albnirdr(im,jm)
      _RL albnirdf(im,jm),emiss(im,jm,10)
      _RL alai(nchp),agrn(nchp)
      _RL radswg(im,jm),swgclr(im,jm)
      _RL fdirpar(im,jm),fdifpar(im,jm),osr(im,jm),osrclr(im,jm)
      _RL tg0(im,jm),radlwg(im,jm),lwgclr(im,jm),st4(im,jm)
      _RL dst4(im,jm)
      _RL dlwdtg(im,jm,lm)
      _RL rainlsp(im,jm),raincon(im,jm),snowfall(im,jm)
      _RL cldtot_lw(im,jm,lm),cldras_lw(im,jm,lm)
      _RL cldlsp_lw(im,jm,lm)
      _RL lwlz(im,jm,lm)
      _RL cldtot_sw(im,jm,lm),cldras_sw(im,jm,lm)
      _RL cldlsp_sw(im,jm,lm)
      _RL swlz(im,jm,lm)
      _RL qliqavesw(im,jm,lm),qliqavelw(im,jm,lm)
      _RL fccavesw(im,jm,lm),fccavelw(im,jm,lm)
      _RL qq(im,jm,lm)
      _RL tgz(im,jm)

c Local Variables
c ---------------
      _RL rfu(im,jm,lm),rfv(im,jm,lm),rft(im,jm,lm)
      LOGICAL     alarm
      EXTERNAL    alarm
      INTEGER numpcheck
      PARAMETER (numpcheck = 5)
      INTEGER pchecklevs(numpcheck)
      _RL pcheckpress(numpcheck)
C     data pcheckpress/950.,750.,700.,400.,10./
      data pcheckpress/950.,850.,700.,400.,10./

      INTEGER low_level,mid_level,nltop,nsubmin,nsubmax,Lup
      INTEGER ndmoist,ndturb,ndlw,ndsw
      INTEGER istrip,npcs
      INTEGER i,j
      INTEGER ndpnt
      INTEGER ndum0, ndum1, ndum2
      _RL akap,getcon
      _RL ptop
      LOGICAL lpnt,cumfric
      INTEGER imglobal

      istrip = im*jm
      npcs   = 1

      ptop   =  0.
      akap = getcon('KAPPA')

C **********************************************************************
C ****                         Initialization                       ****
C **********************************************************************
      call get_alarm ( 'radlw',ndum0,ndum1, ndlw   ,ndum2 )
      call get_alarm ( 'radsw',ndum0,ndum1, ndsw   ,ndum2 )
      call get_alarm ( 'turb' ,ndum0,ndum1, ndturb ,ndum2 )
      call get_alarm ( 'moist',ndum0,ndum1, ndmoist,ndum2 )

      call get_alarm ( 'pnt'  ,ndum0,ndum1, ndpnt  ,ndum2 )
      lpnt = ndpnt.ne.0

C Fill array of model levels closest to a given pressure value

      call getpwhere(myid,numpcheck,pcheckpress,pchecklevs)

      low_level = pchecklevs(3)
      mid_level = pchecklevs(4)
      nltop = pchecklevs(5)
      nsubmin = pchecklevs(1)
      nsubmax = pchecklevs(2)
      Lup = pchecklevs(3)

CCC   cumfric = .true.
      cumfric = .false.

C **********************************************************************
C ****                  Call Physics Mini-Drivers                   ****
C **********************************************************************

C SHORT WAVE RADIATION
C ====================
      IF ( alarm('radsw') ) THEN

      call swrio ( nymd,nhms,bi,bj,ndsw,myid,istrip,npcs,
     &   low_level,mid_level,im,jm,lm,
     &   p,pl,ple,dpres,pkht,pkl,t,chemq,chemo3,co2,
     &   albvisdr,albvisdf,albnirdr,albnirdf,swdt,swdtclr,
     &   radswg,swgclr,fdifpar,fdirpar,osr,osrclr,
     &   ptop,nswcld,cldtot_sw,cldras_sw,nswlz,swlz,
     &   .false.,imstturbsw,qliqavesw,
     &   fccavesw,landtype,xlats,xlons )

      ENDIF

C LONG WAVE RADIATION
C ===================
      IF ( alarm('radlw') ) THEN

c Set Reference Ground Temperature
c --------------------------------
      do j=1,jm
      do i=1,im
      tg0(i,j) = tgz(i,j)
      enddo
      enddo

      call lwrio ( nymd,nhms,bi,bj,myid,istrip,npcs,
     &   low_level,mid_level,im,jm,lm,
     &   p,pl,ple,dpres,pkht,pkl,t,chemq,chemo3,co2,
     &   cfc11,cfc12,cfc22,methane,n2o,emiss,tgz,radlwg,st4,dst4,
     &   lwdt,dlwdtg,lwdtclr,lwgclr,
     &   nlwcld,cldtot_lw,cldras_lw,nlwlz,lwlz,
     &   .false.,imstturblw,qliqavelw,
     &   fccavelw,landtype )

      ENDIF

C TURBULENCE
C ==========
      IF ( alarm('turb') ) THEN

      call turbio (im,jm,lm,istrip,nymd,nhms,bi,bj,
     &  turbStart, ndturb,nltop,
     &  ptop,p,u,v,t,q,ntracer,ptracer,pl,ple,dpres,pkht,pkl,
     &  ctmt,xxmt,yymt,zetamt,xlmt,khmt,tke,
     &  tgz,fracland,landtype,
     &  tcanopy,ecanopy,tdeep,swetshal,swetroot,swetdeep,snodep,capac,
     &  nchp,nchptot,nchpland,chfr,chlat,chlon,igrd,ityp,
     &  alai,agrn,sea_ice,lpnt,
     &  turbu,turbv,turbt,turbq,radlwg,st4,dst4,radswg,radswt,
     &  fdifpar,fdirpar,rainlsp,raincon,snowfall,tg0,
     &  imstturblw,imstturbsw,qliqavelw,qliqavesw,fccavelw,fccavesw,qq,
     &  myid)

c Add Gravity-Wave Drag Tendency
c ------------------------------
C Comment this out for now

      imglobal = 128
      call gwdrag (myid,p,pl,ple,dpres,pkl,u,v,t,q,phis_var,
     &   turbu,turbv,turbt,im,jm,lm,bi,bj,istrip,npcs,imglobal)

c Add Rayleigh Friction Damping Above 70 Km
c -----------------------------------------

      call rayleigh(myid,pl,pkl,pkht,surfz,u,v,t,q,im,jm,lm,
     &                                                bi,bj,rfu,rfv,rft)
C Now Add Rayleigh Friction Tendencies to Turb Tendency

C     do L=1,lm
C     do j=1,jm
C     do i=1,im
C      turbu(i,j,L) = turbu(i,j,L) + rfu(i,j,L)
C      turbv(i,j,L) = turbv(i,j,L) + rfv(i,j,L)
C      turbt(i,j,L) = turbt(i,j,L) + rft(i,j,L)
C     enddo
C     enddo
C     enddo

      endif

C MOIST PROCESSES
C ===============
      if ( alarm('moist') ) then
      call moistio (ndmoist,istrip,npcs,
     &    low_level,mid_level,nltop,nsubmin,nsubmax,Lup,
     &    p,pl,ple,dpres,pkht,pkl,u,v,t,q,bi,bj,ntracer,ptracer,qq,
     &    moistu,moistv,moistt,moistq,cumfric,im,jm,lm,ptop,iras,
     &    rainlsp,raincon,snowfall,
     &    nswcld,cldtot_sw,cldras_sw,cldlsp_sw,nswlz,swlz,
     &    nlwcld,cldtot_lw,cldras_lw,cldlsp_lw,nlwlz,lwlz,
     &              .false.,myid)
      endif

      return
      end

#include "CTRL_OPTIONS.h"

      SUBROUTINE CTRL_SET_GLOBFLD_XY(
     I                fname, nRecArg, filePrec, myThid )

C     ==================================================================
C     SUBROUTINE ctrl_set_globfld_xy
C     ==================================================================
C
C     o initialise field
C
C     started: heimbach@mit.edu, 16-Aug-2001
C
C     changed: heimbach@mit.edu 17-Jun-2003
C              merged changes from Armin to replace write of
C              nr * globfld2d by 1 * globfld3d
C              (ad hoc fix to speed up global I/O)
C
C     ==================================================================

      IMPLICIT NONE

C     == global variables ==
#include "EEPARAMS.h"
#include "SIZE.h"
c#include "PARAMS.h"
c#include "CTRL_SIZE.h"
c#include "CTRL.h"
#include "OPTIMCYCLE.h"

C     == routine arguments ==
      CHARACTER*(MAX_LEN_FNAM)   fname
      INTEGER nRecArg
      INTEGER filePrec
      INTEGER myThid

C     == local variables ==
      INTEGER bi, bj
      INTEGER i, j, k
      INTEGER irec, nrec_nl
      _RL globfld2d(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL globfld3d(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)

C     == end of interface ==

C     Initialise temporary file
      DO bj = myByLo(myThid), myByHi(myThid)
        DO bi = myBxLo(myThid), myBxHi(myThid)
          DO j = 1-OLy,sNy+OLy
             DO i = 1-OLx,sNx+OLx
                globfld2d(i,j,bi,bj) = 0. _d 0
             ENDDO
          ENDDO
          DO k = 1,Nr
            DO j = 1-OLy,sNy+OLy
              DO i = 1-OLx,sNx+OLx
                globfld3d(i,j,k,bi,bj) = 0. _d 0
              ENDDO
            ENDDO
          ENDDO
        ENDDO
      ENDDO

      nrec_nl = INT(nRecArg/Nr)
      DO irec = 1,  nrec_nl
        CALL WRITE_REC_3D_RL( fname, filePrec, Nr,
     &                        globfld3d,
     &                        irec, optimcycle, myThid )
      ENDDO

      DO irec = nrec_nl*Nr+1, nRecArg
        CALL WRITE_REC_3D_RL( fname, filePrec, 1,
     &                        globfld2d,
     &                        irec, optimcycle, myThid )
      ENDDO

      RETURN
      END

#include "THSICE_OPTIONS.h"
#ifdef ALLOW_AIM
# include "AIM_OPTIONS.h"
#endif

CBOP
C     !ROUTINE: THSICE_INI_VARS
C     !INTERFACE:
      SUBROUTINE THSICE_INI_VARS( myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R THSICE_INI_VARS
C     | o initialize THermo_SeaICE variables
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "FFIELDS.h"
#include "THSICE_PARAMS.h"
#include "THSICE_VARS.h"
#ifdef ALLOW_AIM
# include "AIM_FFIELDS.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     myThid :: My Thread Id. number
      INTEGER myThid
CEOP

#ifdef ALLOW_THSICE
C     == Local variables ==
C     bi,bj  :: Loop counters
C     i,j    :: Loop counters
      INTEGER bi, bj
      INTEGER i, j
c     CHARACTER*(MAX_LEN_FNAM) fn
      _RL v2Loc
      _RL Tf

c     set up ice arrays to zero if starting ice
      DO bj = myByLo(myThid), myByHi(myThid)
        DO bi = myBxLo(myThid), myBxHi(myThid)
C-        state variables :
          DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
            iceMask(i,j,bi,bj)  = 0. _d 0
            iceHeight(i,j,bi,bj)= 0. _d 0
            snowHeight(i,j,bi,bj)=0. _d 0
            Tsrf(i,j,bi,bj)     = 0. _d 0
            Tice1(i,j,bi,bj)    = 0. _d 0
            Tice2(i,j,bi,bj)    = 0. _d 0
            Qice1(i,j,bi,bj)    = 0. _d 0
            Qice2(i,j,bi,bj)    = 0. _d 0
            snowAge(i,j,bi,bj)  = 0. _d 0
           ENDDO
          ENDDO
C-        fluxes :
          DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
            sHeating(i,j,bi,bj) = 0. _d 0
            flxCndBt(i,j,bi,bj) = 0. _d 0
            siceAlb(i,j,bi,bj)  = 0. _d 0
            icFlxSW (i,j,bi,bj) = 0. _d 0
            icFlxAtm(i,j,bi,bj) = 0. _d 0
            icFrwAtm(i,j,bi,bj) = 0. _d 0
C-        needed when using advection/diffusion:
            oceFWfx(i,j,bi,bj)  = 0. _d 0
            oceSflx(i,j,bi,bj)  = 0. _d 0
            oceQnet(i,j,bi,bj)  = 0. _d 0
           ENDDO
          ENDDO
C-        oceanic mixed layer state :
          v2Loc = vMxL_default*vMxL_default
          DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
             hOceMxL(i,j,bi,bj) = hMxL_default
             tOceMxL(i,j,bi,bj) = 0. _d 0
             sOceMxL(i,j,bi,bj) = sMxL_default
             v2ocMxL(i,j,bi,bj) = v2Loc
           ENDDO
          ENDDO
#ifdef ALLOW_AIM
          IF ( useAIM ) THEN
C-        Mask mixed layer depth : depth is used in thsice slab_ocean
C         and this mask is used in thsice_advdiff and if coupled
           DO j=1-OLy,sNy+OLy
            DO i=1-OLx,sNx+OLx
             IF ( aim_landFr(i,j,bi,bj).EQ.1. _d 0 )
     &       hOceMxL(i,j,bi,bj) = 0.
            ENDDO
           ENDDO
          ENDIF
#endif /* ALLOW_AIM */
        ENDDO
      ENDDO
      adjustFrW = 0. _d 0

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#ifdef ALLOW_OCN_COMPON_INTERF
      IF ( useCoupler .AND. thSIce_skipThermo ) RETURN
#endif /* ALLOW_OCN_COMPON_INTERF */

      IF ( startIceModel.LE.0 .AND.
     &     ( nIter0.NE.0  .OR. pickupSuff.NE.' ' )
     &   ) THEN
C--     Read ice pickup fields
        CALL THSICE_READ_PICKUP( nIter0, myThid )

      ELSE
C--     Read initial conditions:
        IF ( thSIceFract_InitFile .NE. ' ' ) THEN
         CALL READ_REC_XY_RL(thSIceFract_InitFile,iceMask,1,0,myThid)
        ENDIF
        IF ( thSIceThick_InitFile .NE. ' ' ) THEN
         CALL READ_REC_XY_RL(thSIceThick_InitFile,iceHeight,1,0,myThid)
        ENDIF
        IF ( thSIceSnowH_InitFile .NE. ' ' ) THEN
         CALL READ_REC_XY_RL(thSIceSnowH_InitFile,snowHeight,1,0,myThid)
        ENDIF
        IF ( thSIceSnowA_InitFile .NE. ' ' ) THEN
         CALL READ_REC_XY_RL(thSIceSnowA_InitFile,snowAge,1,0,myThid)
        ENDIF
        IF ( thSIceEnthp_InitFile .NE. ' ' ) THEN
         CALL READ_REC_XY_RL(thSIceEnthp_InitFile,Qice1,1,0,myThid)
         CALL READ_REC_XY_RL(thSIceEnthp_InitFile,Qice2,2,0,myThid)
        ENDIF
        IF ( thSIceTsurf_InitFile .NE. ' ' ) THEN
         CALL READ_REC_XY_RL(thSIceTsurf_InitFile,Tsrf,1,0,myThid)
        ENDIF
        IF ( thSIceEnthp_InitFile .EQ. ' ' ) THEN
C-    enthalpy of new ice in J/kg, taken from thsice_extend.F with Tf beeing
C     the freezing Temp of seawater computed from a fixed salinity (31.5 g/kg)
C     Tf = -mu_Tf*salinity = -1.70 deg C;  Qice1 ~ 3.2e5;  Qice2 ~ 3.4e5
         Tf = -1.70 _d 0
         DO bj = myByLo(myThid), myByHi(myThid)
          DO bi = myBxLo(myThid), myBxHi(myThid)
           DO j=1-OLy,sNy+OLy
            DO i=1-OLx,sNx+OLx
             IF (iceMask(i,j,bi,bj) .NE. 0. _d 0) THEN
              Qice1(i,j,bi,bj) = -cpWater*Tmlt1
     &             + cpIce *(Tmlt1-Tf) + Lfresh*(1. _d 0-Tmlt1/Tf)
              Qice2(i,j,bi,bj) = -cpIce *Tf + Lfresh
             ENDIF
            ENDDO
           ENDDO
          ENDDO
         ENDDO
        ENDIF
      ENDIF

      _EXCH_XY_RL(iceMask,myThid)
      _EXCH_XY_RL(iceHeight, myThid)
      _EXCH_XY_RL(snowHeight,myThid)
      _EXCH_XY_RL(Tsrf,   myThid)
      _EXCH_XY_RL(Tice1,  myThid)
      _EXCH_XY_RL(Tice2,  myThid)
      _EXCH_XY_RL(Qice1,  myThid)
      _EXCH_XY_RL(Qice2,  myThid)
      _EXCH_XY_RL(snowAge,myThid)

C--     Initialise Sea-Ice Loading for SeaIce-Dynamics :
      IF ( useSEAICE ) THEN
       DO bj = myByLo(myThid), myByHi(myThid)
        DO bi = myBxLo(myThid), myBxHi(myThid)
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           sIceLoad(i,j,bi,bj) = ( snowHeight(i,j,bi,bj)*rhos
     &          + iceHeight(i,j,bi,bj)*rhoi
     &          )*iceMask(i,j,bi,bj)
          ENDDO
         ENDDO
        ENDDO
       ENDDO
      ENDIF

#endif /* ALLOW_THSICE */

      RETURN
      END

#include "GMREDI_OPTIONS.h"

CBOP
C     !ROUTINE: GMREDI_DO_EXCH
C     !INTERFACE:
      SUBROUTINE GMREDI_DO_EXCH(
     I                           myTime, myIter, myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE GMREDI_DO_EXCH
C     | o Apply Exchanges to GM-Redi variables when necessary
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GMREDI.h"

C     !INPUT/OUTPUT PARAMETERS:
C     myTime :: Current time in simulation
C     myIter :: Current iteration number in simulation
C     myThid :: my Thread Id. number
      _RL     myTime
      INTEGER myIter
      INTEGER myThid
CEOP

C     !LOCAL VARIABLES:

#ifdef GM_BOLUS_ADVEC
#ifdef ALLOW_EDDYPSI
      IF ( GM_InMomAsStress ) THEN
#else
C     For multi-dim advection, need valid bolus velocity in halo regions
C     near CS-corners: Because of sigmaR averaging @ U & V points, that
C     would require calling FILL_CS_CORNER_TR before each averaging (similar
C     to what is done in grad_sigma.F), near CS-corner values are not right.
C     This exchange fixes this Pb. Fix also a similar Pb with VisbeckK or
C     with GM-bolus 2-D mapping factor (GM_bolFac2d).
      IF ( useCubedSphereExchange
     &     .AND. GM_AdvForm
     &     .AND. .NOT.GM_AdvSeparate
     &     .AND. useMultiDimAdvec ) THEN
#endif
#ifdef ALLOW_DEBUG
        IF (debugMode) CALL DEBUG_CALL('EXCH_UV(GM_PsiX,Y)',myThid)
#endif
        CALL EXCH_UV_XYZ_RL( GM_PsiX, GM_PsiY, .TRUE., myThid )
      ENDIF
#endif /* GM_BOLUS_ADVEC */

#ifdef GM_GEOM_VARIABLE_K
      IF ( GM_useGEOM ) THEN
       _EXCH_XY_RL( GEOM_EKE , myThid )
       _BEGIN_MASTER( myThid )
C     moved here, outside bi,bj loop:
       IF ( GEOM_startAB .EQ. 0 ) GEOM_startAB = 1
       _END_MASTER( myThid )
      ENDIF
#endif

      RETURN
      END

#include "SEAICE_OPTIONS.h"

CBOP
C !ROUTINE: SEAICE_ITD_REDIST

C !INTERFACE: ==========================================================
      SUBROUTINE SEAICE_ITD_REDIST(
     I     bi, bj, myTime, myIter, myThid )

C !DESCRIPTION: \bv
C     *===========================================================*
C     | SUBROUTINE SEAICE_ITD_REDIST
C     | o checks if absolute ice thickness in any category
C     |   exceeds its category limits
C     | o redistributes sea ice area and volume
C     |   and associated ice properties in thickness space
C     |
C     | Torge Martin, Feb. 2012, torge@mit.edu
C     *===========================================================*
C \ev

C !USES: ===============================================================
      IMPLICIT NONE

C     === Global variables to be checked and redistributed ===
C     AREAITD   :: sea ice area      by category
C     HEFFITD   :: sea ice thickness by category
C
C     === Global variables to be redistributed ===
C     HSNOWITD  :: snow thickness    by category
C     enthalpy ?
C     temperature ?
C     salinity ?
C     age ?
C
#include "SIZE.h"
#include "EEPARAMS.h"
c#include "PARAMS.h"
#include "SEAICE_SIZE.h"
#include "SEAICE_PARAMS.h"
#include "SEAICE.h"

C !INPUT PARAMETERS: ===================================================
C     === Routine arguments ===
C     bi, bj    :: outer loop counters
C     myTime    :: current time
C     myIter    :: iteration number
C     myThid    :: Thread no. that called this routine.
      _RL myTime
      INTEGER bi,bj
      INTEGER myIter
      INTEGER myThid

#ifdef SEAICE_ITD

C !LOCAL VARIABLES: ====================================================
C     === Local variables ===
C     i,j,k       :: inner loop counters
C     nITD        :: number of sea ice thickness categories
C     openwater   :: open water area fraction
C
      INTEGER i, j, k
      _RL openWater  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
CEOP
C---+-|--1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

c      DO bj=myByLo(myThid),myByHi(myThid)
c       DO bi=myBxLo(myThid),myBxHi(myThid)
C must now be called within bi,bj loop

C       calculate area of open water
      DO j=1-OLy,sNy+OLy
       DO i=1-OLx,sNx+OLx
        openWater(i,j) = ONE
       ENDDO
      ENDDO
      DO k=1,nITD
       DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
         openWater(i,j) = openWater(i,j) - AREAITD(i,j,k,bi,bj)
        ENDDO
       ENDDO
      ENDDO

C     ----------------------------------------------------
C     | redistribute/"advect" sea ice in thickness space |
C     | as described in Bitz et al. (2001)               |
C     ----------------------------------------------------

C---+-|--1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C--   Hibler-type "ridging", i.e. cut back excessive ice area fraction ---
C     in case ice concentration exceeds 100% assume that
C     convergence of floe field has eliminated all open water
C     and eventual rafting occured in thinnest category:
      DO j=1-OLy,sNy+OLy
       DO i=1-OLx,sNx+OLx
        IF (openWater(i,j) .lt. 0.0)
     &     AREAITD(i,j,1,bi,bj) = openWater(i,j) + AREAITD(i,j,1,bi,bj)
       ENDDO
      ENDDO
C
C     the following steps only make sense if there are actually
C     multi-categories
      IF (nITD .gt. 1) THEN
C
C--   check if more thicker ice needs to be rafted to accomodate area excess:
       DO k=1,nITD-1
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          IF (AREAITD(i,j,k,bi,bj) .lt. 0.0) THEN
C--   pass concentration deficit up to next thicker category
C--   since all quantities are extensive, we add instead of average
           AREAITD (i,j,k+1,bi,bj) = AREAITD (i,j,k+1,bi,bj)
     &                             + AREAITD (i,j,k,bi,bj)
           AREAITD (i,j,k  ,bi,bj) = ZERO
           HEFFITD (i,j,k+1,bi,bj) = HEFFITD (i,j,k+1,bi,bj)
     &                             + HEFFITD (i,j,k,bi,bj)
           HEFFITD (i,j,k  ,bi,bj) = ZERO
           HSNOWITD(i,j,k+1,bi,bj) = HSNOWITD(i,j,k+1,bi,bj)
     &                             + HSNOWITD(i,j,k,bi,bj)
           HSNOWITD(i,j,k  ,bi,bj) = ZERO
C            t1(k+1) = t1(k+1)+t1(k); t1(k) = ZERO
C            t2(k+1) = t2(k+1)+t2(k); t2(k) = ZERO
C            age(k+1)=age(k+1)+age(k);age(k)= ZERO
C this is for ridged sea ice volume fraction
C            IF (PRESENT(rdg)) THEN
C             rdg(k+1)=rdg(k+1)+rdg(k); rdg(k)= ZERO
C            ENDIF
          ENDIF
         ENDDO
        ENDDO
       ENDDO

C     --- ice thickness redistribution ---
C         now check that ice thickness stays within category limits
       DO k=1,nITD-1
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          IF (HEFFITD(i,j,k,bi,bj) .gt.
     &         Hlimit(k)*AREAITD(i,j,k,bi,bj)) THEN
C--   the upper thickness limit is exceeded: move ice up to next
C     thicker category
           AREAITD (i,j,k+1,bi,bj) = AREAITD (i,j,k+1,bi,bj)
     &                             + AREAITD (i,j,k,bi,bj)
           AREAITD (i,j,k  ,bi,bj) = ZERO
           HEFFITD (i,j,k+1,bi,bj) = HEFFITD (i,j,k+1,bi,bj)
     &                             + HEFFITD (i,j,k,bi,bj)
           HEFFITD (i,j,k  ,bi,bj) = ZERO
           HSNOWITD(i,j,k+1,bi,bj) = HSNOWITD(i,j,k+1,bi,bj)
     &                             + HSNOWITD(i,j,k,bi,bj)
           HSNOWITD(i,j,k  ,bi,bj) = ZERO
C            t1(k+1) = t1(k+1)+t1(k); t1(k) = ZERO
C            t2(k+1) = t2(k+1)+t2(k); t2(k) = ZERO
C            age(k+1)=age(k+1)+age(k);age(k)= ZERO
C            IF (PRESENT(rdg)) THEN
C             rdg(k+1)=rdg(k+1)+rdg(k);rdg(k)= ZERO
C            ENDIF
          ENDIF
         ENDDO
        ENDDO
       ENDDO
C
       DO k=nITD,2,-1
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          IF (HEFFITD(i,j,k,bi,bj) .lt.
     &         Hlimit(k-1)*AREAITD(i,j,k,bi,bj)) THEN
C--   the lower thickness limit is exceeded: move ice down to next thinner
C     category
           AREAITD (i,j,k-1,bi,bj) = AREAITD (i,j,k-1,bi,bj)
     &                             + AREAITD (i,j,k,bi,bj)
           AREAITD (i,j,k  ,bi,bj) = ZERO
           HEFFITD (i,j,k-1,bi,bj) = HEFFITD (i,j,k-1,bi,bj)
     &                             + HEFFITD (i,j,k,bi,bj)
           HEFFITD (i,j,k  ,bi,bj) = ZERO
           HSNOWITD(i,j,k-1,bi,bj) = HSNOWITD(i,j,k-1,bi,bj)
     &                             + HSNOWITD(i,j,k,bi,bj)
           HSNOWITD(i,j,k  ,bi,bj) = ZERO
c            snow(k-1) = snow(k-1)+snow(k); snow(k) = ZERO
C            t1(k-1) = t1(k-1)+t1(k); t1(k) = ZERO
C            t2(k-1) = t2(k-1)+t2(k); t2(k) = ZERO
C            age(k-1)=age(k-1)+age(k);age(k)= ZERO
C            IF (PRESENT(rdg)) THEN
C            rdg(k-1)=rdg(k-1)+rdg(k);rdg(k)= ZERO
C            ENDIF
          ENDIF
         ENDDO
        ENDDO
       ENDDO
C
C     end nITD>1 constraint
      ENDIF

C     end bi,bj loop
c       ENDDO
c      ENDDO

C---+-|--1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
#endif /* SEAICE_ITD */
      RETURN
      END

#include "PTRACERS_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE:

C     !INTERFACE:
      SUBROUTINE PTRACERS_MNC_INIT( myThid )

C     !DESCRIPTION:
C     Initialize PTRACERS parameters, read in data.ptracers

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PTRACERS_SIZE.h"
#include "PTRACERS_PARAMS.h"
#include "PARAMS.h"

C     !INPUT PARAMETERS:
      INTEGER myThid
CEOP

#ifdef ALLOW_PTRACERS
#ifdef ALLOW_MNC

C     !LOCAL VARIABLES:
      INTEGER ii, jj, ilnb
      character*(80) name
      character*(MAX_LEN_MBUF) msgbuf

C     Functions
      integer ILNBLNK

      IF (useMNC) THEN
        DO ii = 1,PTRACERS_numInUse

          DO jj = 1,80
            name(jj:jj) = ' '
          ENDDO

C         Create the tracer
          ilnb = ILNBLNK(PTRACERS_names(ii))
          IF (ilnb .LT. 1) THEN
            write(msgbuf,'(2a,i3,2a)') 'PTRACERS_MNC_INIT ERROR: ',
     &           'PTRACERS_names(',ii,') is blank--please name it in',
     &           ' ''data.ptracers'''
            CALL print_error(msgbuf, mythid)
            stop 'ABNORMAL END: S/R PTRACERS_MNC_INIT'
          ENDIF
          CALL MNC_CW_ADD_VNAME(
     &         PTRACERS_names(ii),'Cen_xy_Hn__C__t',4,5,myThid)
          WRITE(name,'(a,a)') 'surf_',PTRACERS_names(ii)(1:ilnb)
          CALL MNC_CW_ADD_VNAME(name,'Cen_xy_Hn__-__t',3,4,myThid)

C         Add the long_name attribute if its defined
          ilnb = ILNBLNK(PTRACERS_long_names(ii))
          IF (ilnb .GT. 0) THEN
            CALL MNC_CW_ADD_VATTR_TEXT(PTRACERS_names(ii),
     &           'long_name',PTRACERS_long_names(ii),myThid)
          ENDIF

C         Add the units attribute if its defined
          ilnb = ILNBLNK(PTRACERS_units(ii))
          IF (ilnb .GT. 0) THEN
            CALL MNC_CW_ADD_VATTR_TEXT(PTRACERS_names(ii),'units',
     &           PTRACERS_units(ii),myThid)
          ENDIF

        ENDDO

      ENDIF
#endif /*  ALLOW_MNC  */
#endif /* ALLOW_PTRACERS */

      RETURN
      END

#include "GMREDI_OPTIONS.h"
#ifdef ALLOW_GENERIC_ADVDIFF
# include "GAD_OPTIONS.h"
#endif

CBOP
C !ROUTINE: GMREDI_CALC_GEOM

C !INTERFACE: ==========================================================
      SUBROUTINE GMREDI_CALC_GEOM(
     I             sigmaX, sigmaY, sigmaR,
     I             bi, bj, myTime, myIter, myThid )

C     !DESCRIPTION:
C     *==========================================================*
C     | SUBROUTINE GMREDI_CALC_GEOM
C     | Calculate GM coefficient with the GEOMETRIC prescription
C     | GEOM_K3d is located at the grid-cell vertical interface.
C     *==========================================================*

C !USES: ===============================================================
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "DYNVARS.h"
#include "GMREDI.h"

C !INPUT PARAMETERS: ===================================================
C     sigmaXYR  :: density gradient variables
C     bi, bj    :: tile indices
C     myTime    :: Current time in simulation
C     myIter    :: Current iteration number in simulation
C     myThid    :: My Thread Id. number
      _RL sigmaX(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL sigmaY(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL sigmaR(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      INTEGER bi, bj
      _RL     myTime
      INTEGER myIter
      INTEGER myThid

#ifdef GM_GEOM_VARIABLE_K
C !INOUT PARAMETERS: ===================================================
C  GEOM_K3d     :: GEOMETRIC K-GM (GEOMETRIC in horizontal,
C                             structure function in vertical)
C  GEOM_EKE     :: GEOMETRIC parameterised energy
C              not really an output, passed around as common block

C !LOCAL VARIABLES: ====================================================
C     i,j,k           :: Loop counters
C     Slope(XY)       :: isopycnal slopes
C     dSigmaD(xyr)    :: derivative of density variables
C     dSigma(HR)      :: variables to compute isopycnal slopes
C     (MN)2loc        :: local M^2 and N^2
C     S(N)loc         :: local M^2/N^2 and M^2/N
C     (S)Nloc_zint    :: depth integrated M^2/N and N
C                       (for calculating trd_ene_gen and trd_ene_wav)
C     trd_ene_*       :: trends for energy
C                        gen, adv, lap, dis
C     ene_*           :: intermediate variables for computing trends
C     depth*          :: various depth variables for computation purposes
C     c1, c_ros[XYEN] :: long Rossby wave phase speeds for trd_ene_wav
C     UV_depth_avg    :: depth-avg flow for                trd_ene_adv
C     ab0, ab1        :: Adams-Bashforth weights

      INTEGER i,j,k
      INTEGER kSurf
      _RL dSigmaDx
      _RL dSigmaDy
      _RL dSigmaDr(1-OLx:sNx+OLx,1-OLy:sNy+OLy)

      _RL dSigmaH, dSigmaR
      _RL N2loc, SNloc, Sloc
      _RL SNloc3D(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL N2loc3D(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)

      _RL recipMaxSlope
      _RL c_dum, fp_im, fm_ip
      _RL ab0, ab1, fCoriFac

C     metric variables
      _RL recip_depthW(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL recip_depthS(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
C     depth at C-points in meters
      _RL depthC      (1-OLx:sNx+OLx,1-OLy:sNy+OLy)

C     hFac of the W-control volumes
      _RL hFac

C     general variables
      _RL deltaTloc

C     local version of current rhs of eddy energy equation
      _RL ene_rhs_now(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL vert_struc_func(1-OLx:sNx+OLx,1-OLy:sNy+OLy, Nr)

      _RL SNloc_zint (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL  Nloc_zint (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL trd_ene_gen(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL trd_ene_dis(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL trd_ene_adv(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL trd_ene_wav(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL trd_ene_lap(1-OLx:sNx+OLx,1-OLy:sNy+OLy)

      _RL U_depth_avg(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL V_depth_avg(1-OLx:sNx+OLx,1-OLy:sNy+OLy)

      _RL c1    (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL c_rosX(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL c_rosY(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL c_rosE

      _RL ene_adv_x(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL ene_adv_y(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL ene_wav_x(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL ene_wav_y(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL ene_lap_x(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL ene_lap_y(1-OLx:sNx+OLx,1-OLy:sNy+OLy)

CEOP

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      kSurf = 1
      IF ( usingPCoords ) kSurf = Nr
      deltaTloc = dtTracerLev(kSurf)
      recipMaxSlope = 0. _d 0
      IF ( GM_maxSlope.GT.0. _d 0 ) THEN
        recipMaxSlope = 1. _d 0 / GM_maxSlope
      ENDIF

C--   initialise some variables for calculations

C     depths for doing depth-averaging
      DO j=1-OLy,sNy+OLy
       DO i=1-OLx,sNx+OLx
        recip_depthW(i,j) = 0.0 _d 0
        recip_depthS(i,j) = 0.0 _d 0
        c_dum = rSurfW(i,j,bi,bj) - rLowW(i,j,bi,bj)
        IF ( c_dum .GT. zeroRL ) recip_depthW(i,j) = 1. _d 0 / c_dum
        c_dum = rSurfS(i,j,bi,bj) - rLowS(i,j,bi,bj)
        IF ( c_dum .GT. zeroRL ) recip_depthS(i,j) = 1. _d 0 / c_dum
C     convert to meters in the case of p-coordinates
        depthC(i,j) = ( Ro_surf(i,j,bi,bj) - R_low(i,j,bi,bj) )
     &              * rUnit2mass*recip_rhoConst
       ENDDO
      ENDDO

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C   TODO: should the calculations be based on the tapered slopes?
C         here it is just the raw stuff
C         if being moved then this routine might want to be after
C         the SLOPE_LIMIT routine

C     initialisations, put this in a loop if need be
      DO j=1-OLy,sNy+OLy
       DO i=1-OLx,sNx+OLx
        SNloc_zint(i,j) = 0.0 _d 0
        Nloc_zint(i,j)  = 0.0 _d 0
       ENDDO
      ENDDO
      DO k=1,Nr
       DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
         vert_struc_func(i,j,k) = 1.0 _d 0
         N2loc3D(i,j,k)         = 0.0 _d 0
         SNloc3D(i,j,k)         = 0.0 _d 0
        ENDDO
       ENDDO
      ENDDO
C-- 1st k loop : compute vertical structure to be used later
      DO k=Nr,2,-1

C     For stable conditions sigmaR<0 for z-coordinates, but >0 for p-coords
C     => change sign of vertical Sigma gradient (always downward)
C     to match stratification sign (i.e., positive if stratified)
C     For p-coordinates: convert r-units to z
       DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
         dSigmaDr(i,j) = MAX( gravitySign*sigmaR(i,j,k), zeroRL )
     &        * mass2rUnit * rhoConst
        ENDDO
       ENDDO

C      NOTE: Ignores boundary cells (convenient with the 5-point filter used)
       DO j=2-OLy,sNy+OLy-1
        DO i=2-OLx,sNx+OLx-1
         IF ( maskC(i,j,k,bi,bj) .GT. 0. _d 0 ) THEN

C      Compute -N^2 rho_0 / g via averaging, on vertical interfaces
          dSigmaR = (dSigmaDr(i,j) * 4.0 _d 0
     &                + maskC(i-1,j,k,bi,bj)*dSigmaDr(i-1,j)
     &                + maskC(i+1,j,k,bi,bj)*dSigmaDr(i+1,j)
     &                + maskC(i,j-1,k,bi,bj)*dSigmaDr(i,j-1)
     &                + maskC(i,j+1,k,bi,bj)*dSigmaDr(i,j+1)
     &                 ) / (4.0 _d 0
     &                    + maskC(i-1,j,k,bi,bj)
     &                    + maskC(i+1,j,k,bi,bj)
     &                    + maskC(i,j-1,k,bi,bj)
     &                    + maskC(i,j+1,k,bi,bj)
     &                     )
C      Compute M^2 rho_0 / g on vertical interfaces
          dSigmaDx = op25 * (sigmaX(i+1,j,k-1) + sigmaX(i,j,k-1)
     &                    +  sigmaX(i+1,j,k  ) + sigmaX(i,j,k  )
     &                       ) *  maskC(i,j,k,bi,bj)
          dSigmaDy = op25 * (sigmaY(i,j+1,k-1) + sigmaY(i,j,k-1)
     &                    +  sigmaY(i,j+1,k  ) + sigmaY(i,j,k  )
     &                       ) *  maskC(i,j,k,bi,bj)
          dSigmaH = SQRT(dSigmaDx * dSigmaDx
     &                 + dSigmaDy * dSigmaDy)
          IF ( dSigmaH .GT. 0. _d 0 ) THEN
           IF ( dSigmaR .GT. dSigmaH*recipMaxSlope ) THEN
            Sloc = dSigmaH / dSigmaR
           ELSE
            Sloc = GM_maxSlope
           ENDIF
           N2loc3D(i,j,k) = gravity * recip_rhoConst * dSigmaR
           SNloc3D(i,j,k) = Sloc * SQRT(N2loc3D(i,j,k))
          ENDIF
         ENDIF
        ENDDO
       ENDDO
      ENDDO
      IF ( GEOM_vert_struc ) THEN
       k=2
C      avoid division by zero
       DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
         vert_struc_func(i,j,k) = MAX(N2loc3D(i,j,k),
     &                                GEOM_vert_struc_min)
        ENDDO
       ENDDO
C      Cap the (N^2 / N^2_surf) between something (1 and 0.1 default)
       DO k=Nr,2,-1
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          vert_struc_func(i,j,k) =
     &         MAX(MIN(GEOM_vert_struc_max,
     &                 N2loc3D(i,j,k)/vert_struc_func(i,j,2)),
     &             GEOM_vert_struc_min)
         ENDDO
        ENDDO
       ENDDO
      ENDIF

C-- 2nd k loop : compute the rest of the GEOMETRIC stuff
      DO k=Nr,2,-1

C      NOTE: Ignores boundary cells (convenient with the 5-point filter used)
       DO j=2-OLy,sNy+OLy-1
        DO i=2-OLx,sNx+OLx-1
         IF ( maskC(i,j,k,bi,bj) .GT. 0. _d 0 ) THEN
          N2loc = N2loc3D(i,j,k)
          SNloc = SNloc3D(i,j,k)
C     hFac now contains the coordinate factor rUnit2mass*recip_rhoConst
C     ( = 1 for z-coordinates and 1/(gravity*rhoConst for p-coordinates)
          hFac = MIN( halfRS, _hFacC(i,j,k-1,bi,bj) )
     &         + MIN( halfRS, _hFacC(i,j,k  ,bi,bj) )
     &                    * rUnit2mass*recip_rhoConst
          SNloc_zint(i,j) = SNloc_zint(i,j)
     &                    + SNloc * drC(k) * hFac
     &                    * vert_struc_func(i,j,k)
          Nloc_zint(i,j)  = Nloc_zint(i,j) + SQRT(N2loc)
     &                    * drC(k) * hFac
         ENDIF
        ENDDO
       ENDDO
      ENDDO

C     work out the implied long Rossby phase speeds at T pts
C     average it onto UV points later

      fCoriFac = 0.0 _d 0
      IF ( usingCartesianGrid .AND. f0 .NE. 0.0 _d 0 )
     &     fCoriFac = beta / (f0 * f0)

      DO j=1-OLy,sNy+OLy
       DO i=1-OLx,sNx+OLx
C       only compute the Rossby phase speed if deep enough
        IF (depthC(i,j) .GT. 300.0 _d 0) THEN
         c1(i,j) = MIN(10.0 _d 0, Nloc_zint(i,j) / PI)
     &              * maskC(i,j,kSurf,bi,bj)

C       bound the f factors away from zero (inside Eq +/- 5degN/S),
C       compute the Rossby phase speed, and bound above by
C       1st baroclinic equatorial Rossby wave phase speed
         IF ( .NOT.usingCartesianGrid ) THEN
          fCoriFac = MAX( ABS(fCori(i,j,bi,bj)), 1.2676 _d -05 )
          fCoriFac = fCoriCos(i,j,bi,bj) / ( rSphere * fCoriFac ** 2 )
         ENDIF
         c_rosE = - MIN( c1(i,j)/3.0 _d 0, c1(i,j)*c1(i,j)*fCoriFac )
C     rotating EW Rossby velocity to XY for the grid, c_rosN=0 by definition
C     (trivial rotation for Cartesian plane)
         c_rosX(i,j) =  angleCosC(i,j,bi,bj)*c_rosE
c    &                + angleSinC(i,j,bi,bj)*c_rosN
         c_rosY(i,j) = -angleSinC(i,j,bi,bj)*c_rosE
c    &                 +angleCosC(i,j,bi,bj)*c_rosN
        ELSE
         c_rosX(i,j) = 0.0 _d 0
         c_rosY(i,j) = 0.0 _d 0
         c1    (i,j) = 0.0 _d 0
        ENDIF
       ENDDO
      ENDDO

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C-- compute kgm as per GEOMETRIC in horizontal, then extend
C-- vertically by structure function if required
C-- do other tapering things here

C     1. compute the 2d k_GEOM first
C        bound the denominator from below (choice following NEMO)

      DO j=1-OLy,sNy+OLy
       DO i=1-OLx,sNx+OLx
C     for cubed sphere setups, depthC can be zero in the halo, so we
C     include it in the masking
        IF ( maskC(i,j,kSurf,bi,bj)*depthC(i,j) .GT. 0. _d 0 ) THEN
         GEOM_K3d(i,j,kSurf,bi,bj) = GEOM_alpha * GEOM_EKE(i,j,bi,bj)
     &        / MAX( SNloc_zint(i,j), 1. _d -7 * depthC(i,j) )
        ENDIF
       ENDDO
      ENDDO

C     2. cap k_GEOM from above! (stop it being too big)

      IF ( GEOM_alpha .NE. 0.0 _d 0 ) THEN
       DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
         GEOM_K3d(i,j,kSurf,bi,bj) =
     &        MIN( GEOM_K3d(i,j,kSurf,bi,bj), GEOM_maxVal_K )
        ENDDO
       ENDDO
      ENDIF

C     3. taper it according to depth to kill k_GEOM in shallow regions

      DO j=1-OLy,sNy+OLy
       DO i=1-OLx,sNx+OLx
        GEOM_K3d(i,j,kSurf,bi,bj) = GEOM_K3d(i,j,kSurf,bi,bj)
     &       * GEOM_taper(i,j,bi,bj) * maskC(i,j,kSurf,bi,bj)
       ENDDO
      ENDDO

C     4. extend the (tapered) k_GEOM in depth

      DO k=Nr,2,-1
       DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
         GEOM_K3d(i,j,k,bi,bj) = vert_struc_func(i,j,k)
     &                      * GEOM_K3d(i,j,kSurf,bi,bj)
     &                      * maskC(i,j,k,bi,bj)
        ENDDO
       ENDDO
      ENDDO

C     5. cap k_GEOM from below (do not strictly need this)

      IF ( GEOM_alpha .NE. 0.0 _d 0 ) THEN
       DO k=1,Nr
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          GEOM_K3d(i,j,k,bi,bj) =
     &         MAX( GEOM_K3d(i,j,k,bi,bj), GEOM_minVal_K )
         ENDDO
        ENDDO
       ENDDO
      ENDIF

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C--   time step the energy
C     allocate and initialise
      DO j=1-OLy,sNy+OLy
       DO i=1-OLx,sNx+OLx
        trd_ene_gen(i,j) = 0.0 _d 0
       ENDDO
      ENDDO

C     loop over k
      DO k=Nr,2,-1

C      NOTE: Ignores boundary cells (convenient with the 5-point filter used)
       DO j=2-OLy,sNy+OLy-1
        DO i=2-OLx,sNx+OLx-1
         IF ( maskC(i,j,k,bi,bj) .GT. 0. _d 0 ) THEN
          hFac = MIN( halfRS, _hFacC(i,j,k-1,bi,bj) )
     &         + MIN( halfRS, _hFacC(i,j,k  ,bi,bj) )
          SNloc = SNloc3D(i,j,k)
          trd_ene_gen(i,j) = trd_ene_gen(i,j)
     &                     + GEOM_K3d(i,j,k,bi,bj)
     &                     * SNloc * SNloc
     &                     * drC(k) * hFac
     &                     * rUnit2mass*recip_rhoConst
         ENDIF
        ENDDO
       ENDDO
      ENDDO
C ----------------------------------------------
C ---- start advection of energy ---------------
C ----------------------------------------------

      DO j=1-OLy,sNy+OLy
       DO i=1-OLx,sNx+OLx
        trd_ene_dis(i,j) = 0.0 _d 0
        trd_ene_adv(i,j) = 0.0 _d 0
        trd_ene_wav(i,j) = 0.0 _d 0
        trd_ene_lap(i,j) = 0.0 _d 0

        U_depth_avg(i,j) = 0.0 _d 0
        V_depth_avg(i,j) = 0.0 _d 0

        ene_adv_x(i,j)   = 0.0 _d 0
        ene_adv_y(i,j)   = 0.0 _d 0
        ene_wav_x(i,j)   = 0.0 _d 0
        ene_wav_y(i,j)   = 0.0 _d 0
        ene_lap_x(i,j)   = 0.0 _d 0
        ene_lap_y(i,j)   = 0.0 _d 0
        ene_rhs_now(i,j) = 0.0 _d 0
       ENDDO
      ENDDO

C ----  form the energy fluxes

C     1. form the depth-AVG velocity
      DO k= 1,Nr
       DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
         U_depth_avg(i,j) = U_depth_avg(i,j)
     &                    + uVel(i,j,k,bi,bj) * drF(k)
     &                    * hFacW(i,j,k,bi,bj) * recip_depthW(i,j)
         V_depth_avg(i,j) = V_depth_avg(i,j)
     &                    + vVel(i,j,k,bi,bj) * drF(k)
     &                    * hFacS(i,j,k,bi,bj) * recip_depthS(i,j)
        ENDDO
       ENDDO
      ENDDO

C     2. form the advective tendency in each direction
      DO j=2-OLy,sNy+OLy-1
       DO i=2-OLx,sNx+OLx-1
C-    X direction:
C ---- second ordered centred difference
c       ene_adv_x(i,j) = -halfRL
c    &    *( U_depth_avg(i,j) * dyG(i,j,bi,bj)
c    &       *( GEOM_EKE( i ,j,bi,bj) - GEOM_EKE(i-1,j,bi,bj) )
c    &     + U_depth_avg(i+1,j) * dyG(i+1,j,bi,bj)
c    &       *( GEOM_EKE(i+1,j,bi,bj) - GEOM_EKE( i ,j,bi,bj) )
c    &     )
C ---- 1st order upwinding
        fp_im = U_depth_avg( i ,j) + ABS( U_depth_avg( i ,j) )
        fm_ip = U_depth_avg(i+1,j) - ABS( U_depth_avg(i+1,j) )
        ene_adv_x(i,j) = -halfRL
     &    *( fp_im * dyG(i,j,bi,bj)
     &       *( GEOM_EKE( i ,j,bi,bj) - GEOM_EKE(i-1,j,bi,bj) )
     &     + fm_ip * dyG(i+1,j,bi,bj)
     &       *( GEOM_EKE(i+1,j,bi,bj) - GEOM_EKE( i ,j,bi,bj) )
     &     )
C ---- 1st order upwinding wave stuff
        c_dum = ( c_rosX(i-1,j) + c_rosX(i,j) )*halfRL
        fp_im = ( c_dum + ABS( c_dum ) )*maskW( i ,j,kSurf,bi,bj)
        c_dum = ( c_rosX(i,j) + c_rosX(i+1,j) )
        fm_ip = ( c_dum - ABS( c_dum ) )*maskW(i+1,j,kSurf,bi,bj)
        ene_wav_x(i,j) = -halfRL
     &    *( fp_im * dyG(i,j,bi,bj)
     &       *( GEOM_EKE( i ,j,bi,bj) - GEOM_EKE(i-1,j,bi,bj) )
     &     + fm_ip * dyG(i+1,j,bi,bj)
     &       *( GEOM_EKE(i+1,j,bi,bj) - GEOM_EKE( i ,j,bi,bj) )
     &     )
C-    Y direction:
C ---- second ordered centred difference
c       ene_adv_y(i,j) = -halfRL
c    &    *( V_depth_avg(i,j) * dxG(i,j,bi,bj)
c    &       *( GEOM_EKE(i, j ,bi,bj) - GEOM_EKE(i,j-1,bi,bj) )
c    &     + V_depth_avg(i,j+1) * dxG(i,j+1,bi,bj)
c    &       *( GEOM_EKE(i,j+1,bi,bj) - GEOM_EKE(i, j ,bi,bj) )
c    &     )
C ---- 1st order upwinding
        fp_im = V_depth_avg(i, j ) + ABS( V_depth_avg(i, j ) )
        fm_ip = V_depth_avg(i,j+1) - ABS( V_depth_avg(i,j+1) )
        ene_adv_y(i,j) = -halfRL
     &    *( fp_im * dxG(i,j,bi,bj)
     &       *( GEOM_EKE(i, j ,bi,bj) - GEOM_EKE(i,j-1,bi,bj) )
     &     + fm_ip * dxG(i,j+1,bi,bj)
     &       *( GEOM_EKE(i,j+1,bi,bj) - GEOM_EKE(i, j ,bi,bj) )
     &     )
C ---- 1st order upwinding wave stuff
        c_dum = ( c_rosY(i-1,j) + c_rosY(i,j) )*halfRL
        fp_im = ( c_dum + ABS( c_dum ) )*maskS(i, j ,kSurf,bi,bj)
        c_dum = ( c_rosY(i,j) + c_rosY(i,j+1) )
        fm_ip = ( c_dum - ABS( c_dum ) )*maskS(i,j+1,kSurf,bi,bj)
        ene_wav_y(i,j) = -halfRL
     &    *( fp_im * dxG(i,j,bi,bj)
     &       *( GEOM_EKE(i, j ,bi,bj) - GEOM_EKE(i,j-1,bi,bj) )
     &     + fm_ip * dxG(i,j+1,bi,bj)
     &       *( GEOM_EKE(i,j+1,bi,bj) - GEOM_EKE(i, j ,bi,bj) )
     &     )
       ENDDO
      ENDDO

C     3. form the diffusive fluxes in each direction
      DO j=1-OLy,sNy+OLy
       DO i=2-OLx,sNx+OLx
        ene_lap_x(i,j) = -GEOM_diffKh_EKE * dyG(i,j,bi,bj)
     &       * ( GEOM_EKE(i,j,bi,bj) - GEOM_EKE(i-1,j,bi,bj) )
     &       * recip_dxC(i,j,bi,bj)*maskW(i,j,kSurf,bi,bj)
     &       * cosFacU(j,bi,bj)
       ENDDO
      ENDDO
      DO j=2-OLy,sNy+OLy
       DO i=1-OLx,sNx+OLx
        ene_lap_y(i,j) = -GEOM_diffKh_EKE * dxG(i,j,bi,bj)
     &       * ( GEOM_EKE(i,j,bi,bj) - GEOM_EKE(i,j-1,bi,bj) )
     &       * recip_dyC(i,j,bi,bj)*maskS(i,j,kSurf,bi,bj)
#ifdef ISOTROPIC_COS_SCALING
     &       *cosFacV(j,bi,bj)
#endif
       ENDDO
      ENDDO

C     4. sum or form tendencies on cell
      DO j=2-OLy,sNy+OLy-1
       DO i=2-OLx,sNx+OLx-1
        trd_ene_dis(i,j) = - GEOM_lmbda * GEOM_EKE(i,j,bi,bj)
     &                                          *maskInC(i,j,bi,bj)
C     Add advective contribution and divide by grid cell area
        trd_ene_adv(i,j) = ( ene_adv_x(i,j) + ene_adv_y(i,j) )
     &                     * recip_rA(i,j,bi,bj)*maskInC(i,j,bi,bj)
        trd_ene_wav(i,j) = ( ene_wav_x(i,j) + ene_wav_y(i,j) )
     &                     * recip_rA(i,j,bi,bj)*maskInC(i,j,bi,bj)
C     Form diffusive tendency from (minus) flux divergence
        trd_ene_lap(i,j) = -( ene_lap_x(i+1,j) - ene_lap_x(i,j)
     &                      + ene_lap_y(i,j+1) - ene_lap_y(i,j) )
     &                      *recip_rA(i,j,bi,bj)*maskInC(i,j,bi,bj)
C       form the RHS
        ene_rhs_now(i,j) = trd_ene_gen(i,j)
     &                   + trd_ene_dis(i,j)
     &                   + trd_ene_adv(i,j)
     &                   + trd_ene_wav(i,j)
     &                   + trd_ene_lap(i,j)
       ENDDO
      ENDDO

C     At this point, the new ene_rhs_now is defined and correctly
C     computed for all i,j except for 1-OLx/y and sNx/y+Olx/y, and we do
C     not need any exchange. We do need to exchange the solution GEOM_EKE
C     in S/R GMREDI_DO_EXCH.

C     third: time stepping
      IF ( GEOM_startAB .EQ. 0 ) THEN
       ab0 =  1.0 _d 0
       ab1 =  0.0 _d 0
C-    moved to gmredi_do_exch.F (outside bi,bj loop):
c       GEOM_startAB = 1
      ELSE
       ab0 =  1.5 _d 0 + abEps
       ab1 = -0.5 _d 0 - abEps
      ENDIF
      DO j=2-OLy,sNy+OLy-1
       DO i=2-OLx,sNx+OLx-1
        GEOM_EKE(i,j,bi,bj) = GEOM_EKE(i,j,bi,bj)
     &            + deltaTloc * (
     &            + ab0 * ene_rhs_now(i,j)
     &            + ab1 * GEOM_gEKE_Nm1(i,j,bi,bj)
     &                        )
       ENDDO
      ENDDO
C ----------------------------------------------
C ---- end advection of energy -----------------
C ----------------------------------------------

C     update rhs fields for the next time step
      DO j=1-OLy,sNy+OLy
       DO i=1-OLx,sNx+OLx
        GEOM_gEKE_Nm1(i,j,bi,bj) = ene_rhs_now(i,j)
       ENDDO
      ENDDO

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C--   diagnostics and restarts

#ifdef ALLOW_DIAGNOSTICS
      IF ( useDiagnostics ) THEN
       CALL DIAGNOSTICS_FILL(vert_struc_func,
     &                       'GEOMstru', 0,Nr,2,bi,bj,myThid)
       CALL DIAGNOSTICS_FILL(trd_ene_gen,
     &                       'GEOMEgen', 0,1,2,bi,bj,myThid)
       CALL DIAGNOSTICS_FILL(trd_ene_dis,
     &                       'GEOMEdis', 0,1,2,bi,bj,myThid)
C        advective trends are dE/dt + -(u - c) dot grad E
       CALL DIAGNOSTICS_FILL(trd_ene_adv,
     &                       'GEOMEadv', 0,1,2,bi,bj,myThid)
       CALL DIAGNOSTICS_FILL(trd_ene_wav,
     &                       'GEOMEwav', 0,1,2,bi,bj,myThid)
       CALL DIAGNOSTICS_FILL(trd_ene_lap,
     &                       'GEOMElap', 0,1,2,bi,bj,myThid)
       CALL DIAGNOSTICS_FILL(c1,
     &                       'GEOM_c1 ', 0,1,2,bi,bj,myThid)
      ENDIF
#endif /* ALLOW_DIAGNOSTICS */

#endif /* GM_GEOM_VARIABLE_K */

      RETURN
      END

#include "DWNSLP_OPTIONS.h"

CBOP
C     !ROUTINE: DWNSLP_APPLY
C     !INTERFACE:
      SUBROUTINE DWNSLP_APPLY(
     I            trIdentity, bi, bj, kBottom,
     I            tracer,
     U            gTracer,
     I            recip_hFac, recip_rA_arg, recip_drF,
     I            deltaTLev, myTime, myIter, myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE DWNSLP_APPLY
C     | o Apply the dowsloping-transport to tracer field
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "DWNSLP_SIZE.h"
#include "DWNSLP_PARAMS.h"
#include "DWNSLP_VARS.h"
#ifdef ALLOW_GENERIC_ADVDIFF
# include "GAD.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
C     trIdentity :: tracer identification number
C     bi,bj      :: Tile indices
C     kBottom    :: bottom level
C     tracer     :: tracer field at current time (input)
C     gTracer    :: tracer tendency to update
C     recip_hFac :: Reciprocal of cell open-depth factor
C     recip_rA_arg :: Reciprocal of cell Area
C     recip_drF  :: Reciprocal of cell thickness
C     deltaTLev  :: tracer time step
C     myTime     :: Current time in simulation
C     myIter     :: Current time-step number
C     myThid     :: my Thread Id. number
      INTEGER trIdentity
      INTEGER bi, bj
      INTEGER kBottom ( xySize, nSx, nSy )
      _RL tracer      ( xySize, Nr )
      _RL gTracer     ( xySize, Nr )
      _RS recip_hFac  ( xySize, Nr )
      _RS recip_rA_arg( xySize, nSx, nSy )
      _RS recip_drF(Nr)
      _RL deltaTLev(Nr)
      _RL     myTime
      INTEGER myIter, myThid

#ifdef ALLOW_DOWN_SLOPE
#ifdef ALLOW_DIAGNOSTICS
C-    !FUNCTIONS:
      LOGICAL  DIAGNOSTICS_IS_ON
      EXTERNAL DIAGNOSTICS_IS_ON
#endif /* ALLOW_DIAGNOSTICS */

C     !LOCAL VARIABLES:
C     === Local variables ===
C     msgBuf     :: Informational/error message buffer
      INTEGER k
      INTEGER n,ijd,ijs,kshelf,kDeep
      _RL     gTrLoc(0:Nr)
      _RL     dTrac(1:Nr)
      INTEGER upward
      LOGICAL onOffFlag

#ifdef ALLOW_DIAGNOSTICS
      CHARACTER*8 diagName
      CHARACTER*4 diagSufx
      LOGICAL     doDiagDwnSlpTend
      _RL         tmpFac
#ifdef ALLOW_GENERIC_ADVDIFF
      CHARACTER*4 GAD_DIAG_SUFX
      EXTERNAL    GAD_DIAG_SUFX
#endif
#endif /* ALLOW_DIAGNOSTICS */

CEOP

      onOffFlag = .TRUE.
#ifdef ALLOW_GENERIC_ADVDIFF
      IF ( trIdentity.EQ.GAD_TEMPERATURE ) onOffFlag = temp_useDWNSLP
      IF ( trIdentity.EQ.GAD_SALINITY    ) onOffFlag = salt_useDWNSLP
#endif
      IF ( onOffFlag ) THEN
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

c      upward = rkSign*NINT(-gravitySign)
       upward = 1
       IF (usingZCoords) upward = -1

#ifdef ALLOW_DIAGNOSTICS
       IF ( useDiagnostics ) THEN
        IF ( trIdentity.GE.1 ) THEN
C--   Set diagnostic suffix for the current tracer
#ifdef ALLOW_GENERIC_ADVDIFF
          diagSufx = GAD_DIAG_SUFX( trIdentity, myThid )
#else
          diagSufx = 'aaaa'
#endif
          diagName = 'DSLP'//diagSufx
        ELSE
          STOP 'S/R DWNSLP_APPLY: should never reach this point !'
        ENDIF
        doDiagDwnSlpTend = DIAGNOSTICS_IS_ON(diagName,myThid)
       ELSE
        doDiagDwnSlpTend = .FALSE.
       ENDIF
       IF ( doDiagDwnSlpTend ) THEN
         tmpFac = -1. _d 0
         CALL DIAGNOSTICS_SCALE_FILL( gTracer, tmpFac, 1, diagName,
     &                                0, Nr, -2, bi, bj, myThid )
       ENDIF
#endif /* ALLOW_DIAGNOSTICS */

#ifndef TARGET_NEC_SX
       IF ( DWNSLP_ioUnit.GT.0 ) THEN
        _BEGIN_MASTER(myThid)
        WRITE(DWNSLP_ioUnit,'(A,I8,3I4)')
     &   ' DWNSLP_APPLY: iter, iTr, bi,bj=', myIter,trIdentity, bi,bj
        WRITE(DWNSLP_ioUnit,'(2A)') '  bi  bj     n    ijDp    ijSh',
     &   ' kDp   Tr_Dp         Gt_Dp         Tr_Sh         Gt_Sh'
        _END_MASTER(myThid)
       ENDIF
#endif

       DO n=1,DWNSLP_NbSite(bi,bj)
        IF (DWNSLP_deepK(n,bi,bj).NE.0) THEN

C- detect density gradient along the slope => Downsloping flow
         ijd = DWNSLP_ijDeep(n,bi,bj)
         ijs = ijd + DWNSLP_shVsD(n,bi,bj)

         kshelf = kBottom(ijs,bi,bj)
         kDeep = DWNSLP_deepK(n,bi,bj)
C- precomute vertical tracer differences to help TAF
         DO k=kshelf,kDeep+upward,-upward
          dTrac(k) = tracer(ijd,k-upward)-tracer(ijd,k)
         ENDDO
         dTrac(kDeep) = tracer(ijs,kshelf)-tracer(ijd,kDeep)
C- downsloping flow (in) & upward return flow :
         DO k=kshelf,kDeep,-upward
          gTrLoc(k) = DWNSLP_Transp(n,bi,bj)
     &       * dTrac(k)
     &       *recip_drF(k)*recip_hFac(ijd,k)
     &       *recip_rA_arg(ijd,bi,bj)
          gTracer(ijd,k) = gTracer(ijd,k) + gTrLoc(k)
         ENDDO
C- downsloping flow (out) & return flow to the shelf
         k = kshelf
         gTrLoc(0) = DWNSLP_Transp(n,bi,bj)
     &       * ( tracer(ijd,k)-tracer(ijs,k) )
     &       *recip_drF(k)*recip_hFac(ijs,k)
     &       *recip_rA_arg(ijs,bi,bj)
         gTracer(ijs,k) = gTracer(ijs,k) + gTrLoc(0)

#ifndef TARGET_NEC_SX
C-    skip within do-loop write statement when compiling on a vector computer
         IF ( DWNSLP_ioUnit.GT.0 ) THEN
          _BEGIN_MASTER(myThid)
          k = kDeep
          WRITE(DWNSLP_ioUnit,'(2I4,I6,2I8,I4,1P4E14.6)')
     &      bi,bj,n,ijd,ijs,k,
     &      tracer(ijd,k), deltaTLev(k)*gTrLoc(k),
     &      tracer(ijs,kshelf), deltaTLev(k)*gTrLoc(0)
          _END_MASTER(myThid)
         ENDIF
#endif
        ENDIF
       ENDDO
#ifndef TARGET_NEC_SX
       IF ( DWNSLP_ioUnit.GT.0 ) THEN
         _BEGIN_MASTER(myThid)
         WRITE(DWNSLP_ioUnit,*)
         _END_MASTER(myThid)
       ENDIF
#endif

#ifdef ALLOW_DIAGNOSTICS
       IF ( doDiagDwnSlpTend )
     &  CALL DIAGNOSTICS_FILL( gTracer, diagName, 0,Nr,2,bi,bj,myThid )
#endif /* ALLOW_DIAGNOSTICS */

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C--   end if on-off-flag
      ENDIF

#endif /* ALLOW_DOWN_SLOPE */

      RETURN
      END

#include "SMOOTH_OPTIONS.h"

      SUBROUTINE SMOOTH_DIFF3D( fld_in, nbt_in, myThid )

C     *==========================================================*
C     | SUBROUTINE smooth_diff3D
C     | o Routine that smoothes a 3D field, using diffusion
C     *==========================================================*

      IMPLICIT NONE
#include "EEPARAMS.h"
#include "SIZE.h"
#include "PARAMS.h"
#include "GRID.h"
#include "SMOOTH.h"

      _RL fld_in(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      INTEGER nbt_in
      INTEGER myThid

      INTEGER i, j, k, bi, bj
      INTEGER myIter(nSx,nSy), iloop
      _RL gT_in  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      _RL gTm1_in(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      _RL gt_AB  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)

      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        DO k=1,Nr
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           gT_in(i,j,k,bi,bj)   = 0. _d 0
           gTm1_in(i,j,k,bi,bj) = 0. _d 0
          ENDDO
         ENDDO
        ENDDO
       ENDDO
      ENDDO

      CALL EXCH_XYZ_RL( fld_in,  myThid )
      CALL EXCH_XYZ_RL( gt_in,   myThid )
      CALL EXCH_XYZ_RL( gtm1_in, myThid )

      DO iloop=1,nbt_in

       DO bj=myByLo(myThid),myByHi(myThid)
        DO bi=myBxLo(myThid),myBxHi(myThid)
         DO k=1,Nr
          DO j=1,sNy
           DO i=1,sNx
            gT_in(i,j,k,bi,bj) = 0. _d 0
           ENDDO
          ENDDO
         ENDDO
        ENDDO
       ENDDO

       CALL EXCH_XYZ_RL( gt_in, myThid )

c compute gT_in:
       CALL SMOOTH_RHS( fld_in, gT_in, myThid )

       DO bj=myByLo(myThid),myByHi(myThid)
        DO bi=myBxLo(myThid),myBxHi(myThid)
c adams bashfort on gT_in:
         myIter(bi,bj) = iloop-1
         DO k=1,Nr
          CALL ADAMS_BASHFORTH2(
     I                        bi, bj, k, Nr,
     U                        gT_in(1-OLx,1-OLy,1,bi,bj),
     U                        gTm1_in(1-OLx,1-OLy,1,bi,bj), gt_AB,
     I                        0, myIter(bi,bj), myThid )
         ENDDO
c time stepping:
         DO k=1,Nr
          DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
            IF (maskC(i,j,k,bi,bj).NE.0.) THEN
             fld_in(i,j,k,bi,bj) = fld_in(i,j,k,bi,bj)
     &            + smooth3DdelTime*gT_in(i,j,k,bi,bj)
             gT_in(i,j,k,bi,bj) = 0
            ENDIF
           ENDDO
          ENDDO
         ENDDO

         IF ( smooth3DdoImpldiff ) THEN
          CALL SMOOTH_IMPLDIFF(
     I         bi, bj, 1, sNx, 1, sNy ,
     I         smooth3DdelTime, smooth3D_kappaR(1-OLx,1-OLy,1,bi,bj),
     I         recip_hFacC,
     U         fld_in,
     I         myThid )
         ENDIF

        ENDDO
       ENDDO

       CALL EXCH_XYZ_RL ( fld_in , myThid )
       CALL EXCH_XYZ_RL ( gt_in , myThid )
       CALL EXCH_XYZ_RL ( gtm1_in , myThid )

      ENDDO

      RETURN
      END

#include "OBCS_OPTIONS.h"

CBOP
C     !ROUTINE: OBCS_COPY_UV_N
C     !INTERFACE:

      SUBROUTINE OBCS_COPY_UV_N(
     U                             uFld, vFld,
     I                             kSiz, bi, bj, myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R OBCS_COPY_UV_N
C     | Copy normal value from the OB location to narrow band
C     |   region (width = same as overlap) beyond the OB.
C     *==========================================================*
C     | Note: need to copy at the beginning of the dynamics loop
C     | only when Stevens boundary conditions are used
C     *==========================================================*
C     \ev
C     !USES:
      IMPLICIT NONE
C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "OBCS_PARAMS.h"
#include "OBCS_GRID.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine Arguments ==
C     u/vFld  :: u and v-components which OBC applies to.
C     kSiz    :: 3rd dim of tracer-field array "trFld"
C     bi, bj  :: indices of current tile
C     myThid  :: my Thread Id number
      INTEGER kSiz
      _RL     uFld(1-OLx:sNx+OLx,1-OLy:sNy+OLy,kSiz)
      _RL     vFld(1-OLx:sNx+OLx,1-OLy:sNy+OLy,kSiz)
      INTEGER bi, bj
      INTEGER myThid
CEOP

#ifdef ALLOW_OBCS_STEVENS

C     !LOCAL VARIABLES:
C     == Local variables ==
      INTEGER i, j, k
      INTEGER Iobc, Jobc

C     Set model variables to OB values on North/South Boundaries
#ifdef ALLOW_OBCS_NORTH
      IF ( tileHasOBN(bi,bj) .AND. useStevensNorth ) THEN
C     Northern boundary
       DO i=1-OLx,sNx+OLx
        Jobc = OB_Jn(i,bi,bj)
        IF ( Jobc.NE.OB_indexNone ) THEN
         DO k = 1, kSiz
          DO j = Jobc+1, Jobc+OLy
           vFld(i,j,k) = vFld(i,Jobc,k)
          ENDDO
         ENDDO
        ENDIF
       ENDDO
      ENDIF
#endif /* ALLOW_OBCS_NORTH */

#ifdef ALLOW_OBCS_SOUTH
      IF ( tileHasOBS(bi,bj) .AND. useStevensSouth ) THEN
C     Southern boundary
       DO i=1-OLx,sNx+OLx
        Jobc = OB_Js(i,bi,bj)
        IF ( Jobc.NE.OB_indexNone ) THEN
         DO k = 1, kSiz
          DO j = Jobc-OLy, Jobc
           vFld(i,j,k) = vFld(i,Jobc+1,k)
          ENDDO
         ENDDO
        ENDIF
       ENDDO
      ENDIF
#endif /* ALLOW_OBCS_SOUTH */

C     Set model variables to OB values on East/West Boundaries
#ifdef ALLOW_OBCS_EAST
      IF ( tileHasOBE(bi,bj) .AND. useStevensEast ) THEN
C     Eastern boundary
       DO j=1-OLy,sNy+OLy
        Iobc = OB_Ie(j,bi,bj)
        IF ( Iobc.NE.OB_indexNone ) THEN
         DO k = 1, kSiz
          DO i = Iobc+1, Iobc+OLx
           uFld(i,j,k) = uFld(Iobc,j,k)
          ENDDO
         ENDDO
        ENDIF
       ENDDO
      ENDIF
#endif /* ALLOW_OBCS_EAST */

#ifdef ALLOW_OBCS_WEST
      IF ( tileHasOBW(bi,bj) .AND. useStevensWest ) THEN
C     Western boundary
       DO j=1-OLy,sNy+OLy
        Iobc = OB_Iw(j,bi,bj)
        IF ( Iobc.NE.OB_indexNone ) THEN
         DO k = 1, kSiz
          DO i = Iobc-OLx, Iobc
           uFld(i,j,k) = uFld(Iobc+1,j,k)
          ENDDO
         ENDDO
        ENDIF
       ENDDO
      ENDIF
#endif /* ALLOW_OBCS_WEST */

#endif /* ALLOW_OBCS_STEVENS */

      RETURN
      END

#include "PACKAGES_CONFIG.h"
#include "CPP_OPTIONS.h"
#ifdef ALLOW_EXCH2
# include "W2_OPTIONS.h"
#endif /* ALLOW_EXCH2 */

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: LOAD_GRID_SPACING
C     !INTERFACE:
      SUBROUTINE LOAD_GRID_SPACING( myThid )

C     !DESCRIPTION:
C     load grid-spacing (vector array) delX, delY, delR or delRc from file.

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#ifdef ALLOW_EXCH2
# include "W2_EXCH2_SIZE.h"
# include "W2_EXCH2_TOPOLOGY.h"
#endif /* ALLOW_EXCH2 */
#include "GRID.h"
#include "SET_GRID.h"

C     !INPUT/OUTPUT PARAMETERS:
C     myThid    :: my Thread Id. number
      INTEGER myThid
CEOP

C     !FUNCTIONS:
      INTEGER  ILNBLNK
      EXTERNAL ILNBLNK

C     !LOCAL VARIABLES:
C     msgBuf    :: Informational/error message buffer
C     delYsum   :: delY full-domain sum
      INTEGER iLen
      INTEGER i, j, n
      INTEGER gridNx, gridNy
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      _RL delYsum

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#ifdef ALLOW_EXCH2
      gridNx = exch2_mydNx(1)
      gridNy = exch2_mydNy(1)
#else /* ALLOW_EXCH2 */
      gridNx = Nx
      gridNy = Ny
#endif /* ALLOW_EXCH2 */

      _BEGIN_MASTER( myThid )

C--   X coordinate
      IF ( delXFile .NE. ' ' ) THEN
        iLen = ILNBLNK(delXFile)
        CALL READ_GLVEC_RL( delXFile, ' ', delX, gridNx, 1, myThid )
        WRITE(msgBuf,'(3A)') 'S/R LOAD_GRID_SPACING:',
     &    ' delX loaded from file: ', delXFile(1:iLen)
        CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                      SQUEEZE_RIGHT , myThid )
      ENDIF

C--   Y coordinate
      IF ( delYFile .NE. ' ' ) THEN
        iLen = ILNBLNK(delYFile)
        CALL READ_GLVEC_RL( delYFile, ' ', delY, gridNy, 1, myThid )
        WRITE(msgBuf,'(3A)') 'S/R LOAD_GRID_SPACING:',
     &    ' delY loaded from file: ', delYFile(1:iLen)
        CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                      SQUEEZE_RIGHT , myThid )
      ENDIF

C--   vertical coordinate "R"
      IF ( delRFile .NE. ' ' ) THEN
        iLen = ILNBLNK(delRFile)
        CALL READ_GLVEC_RL( delRFile, ' ', delR, Nr, 1, myThid )
        WRITE(msgBuf,'(3A)') 'S/R LOAD_GRID_SPACING:',
     &    ' delR loaded from file: ', delRFile(1:iLen)
        CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                      SQUEEZE_RIGHT , myThid )
      ENDIF

      IF ( delRcFile .NE. ' ' ) THEN
        iLen = ILNBLNK(delRcFile)
        CALL READ_GLVEC_RL( delRcFile, ' ', delRc, Nr+1, 1, myThid )
        WRITE(msgBuf,'(3A)') 'S/R LOAD_GRID_SPACING:',
     &    ' delRc loaded from file: ', delRcFile(1:iLen)
        CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                      SQUEEZE_RIGHT , myThid )
      ENDIF

C--   hybrid sigma vertical coordinate coefficient
      IF ( hybSigmFile .NE. ' ' ) THEN
        iLen = ILNBLNK(hybSigmFile)
        CALL READ_GLVEC_RS( hybSigmFile,' ',aHybSigmF,Nr+1, 1,myThid )
        CALL READ_GLVEC_RS( hybSigmFile,' ',bHybSigmF,Nr+1, 2,myThid )
        WRITE(msgBuf,'(3A)') 'S/R LOAD_GRID_SPACING:',
     &    ' a&b_HybSigmF loaded from file: ', hybSigmFile(1:iLen)
        CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                      SQUEEZE_RIGHT , myThid )
      ENDIF

C--   Check horizontal grid-spacing
      IF ( .NOT.usingCurvilinearGrid ) THEN
C Note: To avoid multiple copies of the same code in several horiz.grid
C       initialisation S/R, check horiz.grid spacing here, after
C       loading delX,delY (and before calling any of these S/R).

C--   Check delX grid-spacing:
       n = 0
       DO i=1,gridNx
C-    check that delX has been set
        IF ( delX(i).EQ.UNSET_RL ) THEN
         n = n+1
         WRITE(msgBuf,'(2A,I5)') 'S/R LOAD_GRID_SPACING:',
     &       ' No value for delX at i =', i
         CALL PRINT_ERROR( msgBuf, myThid )
        ENDIF
C-    check that delX is > 0
        IF ( delX(i).LE.0. ) THEN
         n = n+1
         WRITE(msgBuf,'(2A,I5,A,1PE16.8,A)') 'S/R LOAD_GRID_SPACING:',
     &       ' delX(i=', i, ')=', delX(i), ' : MUST BE >0'
         CALL PRINT_ERROR( msgBuf, myThid )
        ENDIF
       ENDDO
       IF ( n.GE.1 ) THEN
         WRITE(msgBuf,'(2A,I5,A)') 'S/R LOAD_GRID_SPACING:',
     &       ' found', n, ' invalid delX values'
         CALL PRINT_ERROR( msgBuf, myThid )
         STOP 'ABNORMAL END: S/R LOAD_GRID_SPACING'
       ENDIF

C--   Check delY grid-spacing:
       n = 0
       DO j=1,gridNy
C-    check that delY has been set
        IF ( delY(j).EQ.UNSET_RL ) THEN
         n = n+1
         WRITE(msgBuf,'(2A,I5)') 'S/R LOAD_GRID_SPACING:',
     &       ' No value for delY at j =', j
         CALL PRINT_ERROR( msgBuf, myThid )
        ENDIF
C-    check that delY is > 0
        IF ( delY(j).LE.0. ) THEN
         n = n+1
         WRITE(msgBuf,'(2A,I5,A,1PE16.8,A)') 'S/R LOAD_GRID_SPACING:',
     &       ' delY(j=', j, ')=', delY(j), ' : MUST BE >0'
         CALL PRINT_ERROR( msgBuf, myThid )
        ENDIF
       ENDDO
       IF ( n.GE.1 ) THEN
         WRITE(msgBuf,'(2A,I5,A)') 'S/R LOAD_GRID_SPACING:',
     &       ' found', n, ' invalid delY values'
         CALL PRINT_ERROR( msgBuf, myThid )
         STOP 'ABNORMAL END: S/R LOAD_GRID_SPACING'
       ENDIF
C--   end of grid-spacing check (not usingCurvilinearGrid)
      ENDIF

C--   Set default (=whole domain) for where relaxation to climatology applies
      IF ( usingCartesianGrid .OR. usingSphericalPolarGrid ) THEN
        delYsum = 0.
        DO j=1,gridNy
          delYsum = delYsum + delY(j)
        ENDDO
        IF ( latBandClimRelax.EQ.UNSET_RL ) THEN
          latBandClimRelax = delYsum*3. _d 0
        ENDIF
      ENDIF

      _END_MASTER(myThid)
C--   Everyone else must wait for the parameters to be loaded
      _BARRIER

      RETURN
      END

#include "EXF_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

CBOP
C     !ROUTINE: EXF_INIT_VARIA
C     !INTERFACE:
      SUBROUTINE EXF_INIT_VARIA( myThid )

C !DESCRIPTION: \bv
C  *=================================================================*
C  | SUBROUTINE EXF_INIT_VARIA
C  | o This routine initialises the forcing
C  *=================================================================*
C  |  started: Ralf.Giering@FastOpt.de 25-Mai-20000
C  |  mods for pkg/seaice: menemenlis@jpl.nasa.gov 20-Dec-2002
C  *=================================================================*
C \ev

C !USES:
      IMPLICIT NONE
C     == global variables ==
#include "EEPARAMS.h"
#include "SIZE.h"
#include "GRID.h"
#include "EXF_PARAM.h"
#include "EXF_INTERP_SIZE.h"
#include "EXF_INTERP_PARAM.h"
#include "EXF_FIELDS.h"
#include "PARAMS.h"
#ifdef ALLOW_BULK_OFFLINE
# include "DYNVARS.h"
#endif

C !INPUT/OUTPUT PARAMETERS:
C     myThid         :: My Thread Id number
      INTEGER myThid

C !LOCAL VARIABLES:
      INTEGER i,j,ks,bi,bj
CEOP

      ks = 1
      IF ( usingPCoords ) ks = Nr

C--   Initialise to zero intermediate fields (in common block)
      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          wStress(i,j,bi,bj) = 0.
          cw(i,j,bi,bj) = 0.
          sw(i,j,bi,bj) = 0.
          sh(i,j,bi,bj) = 0.
#ifdef ALLOW_ATM_TEMP
          hs(i,j,bi,bj) = 0.
          hl(i,j,bi,bj) = 0.
#endif
         ENDDO
        ENDDO
       ENDDO
      ENDDO

      IF ( .NOT.useAtmWind ) THEN
C- Note: In case of constant-in-time wind-stress ( u,v stressperiod = 0 &
C      u,v stressfile.NE.' ' ) interpolated from 2-component wind-stress field
C      with ( usingCurvilinearGrid .OR. rotateGrid .OR. uvInterp_stress )
C      this initial setting of ustress & vstress (+ ustress0,1 & vstress0,1)
C      will be over-written at first time-step when calling EXF_SET_UV.
       CALL EXF_INIT_FLD(
     I     'ustress', ustressfile, ustressmask,
     I     ustressperiod, exf_inscal_ustress, ustressconst,
     O     ustress, ustress0, ustress1,
#ifdef USE_EXF_INTERPOLATION
     I     ustress_lon0, ustress_lon_inc,
     I     ustress_lat0, ustress_lat_inc,
     I     ustress_nlon, ustress_nlat, xC, yC, ustress_interpMethod,
#endif
     I     myThid )

       CALL EXF_INIT_FLD(
     I     'vstress', vstressfile, vstressmask,
     I     vstressperiod, exf_inscal_vstress, vstressconst,
     O     vstress, vstress0, vstress1,
#ifdef USE_EXF_INTERPOLATION
     I     vstress_lon0, vstress_lon_inc,
     I     vstress_lat0, vstress_lat_inc,
     I     vstress_nlon, vstress_nlat, xC, yC, vstress_interpMethod,
#endif
     I     myThid )

      ELSE
       DO bj = myByLo(myThid), myByHi(myThid)
        DO bi = myBxLo(myThid), myBxHi(myThid)
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           uwind(i,j,bi,bj) = 0.
           vwind(i,j,bi,bj) = 0.
          ENDDO
         ENDDO
        ENDDO
       ENDDO
      ENDIF

      IF ( useAtmWind ) THEN
C- Note: In case of constant-in-time winds ( u,v windperiod = 0 &
C      u,v windfile.NE.' ' ) interpolated from 2-component wind field
C      with ( usingCurvilinearGrid .OR. rotateGrid .OR. uvInterp_wind )
C      this initial setting of uwind & vwind (+ uwind0,1 & vwind0,1)
C      will be over-written at first time-step when calling EXF_SET_UV.
       CALL EXF_INIT_FLD(
     I     'uwind', uwindfile, uwindmask,
     I     uwindperiod, exf_inscal_uwind, uwindconst,
     O     uwind, uwind0, uwind1,
#ifdef USE_EXF_INTERPOLATION
     I     uwind_lon0, uwind_lon_inc,
     I     uwind_lat0, uwind_lat_inc,
     I     uwind_nlon, uwind_nlat, xC, yC, uwind_interpMethod,
#endif
     I     myThid )

       CALL EXF_INIT_FLD(
     I     'vwind', vwindfile, vwindmask,
     I     vwindperiod, exf_inscal_vwind, vwindconst,
     O     vwind, vwind0, vwind1,
#ifdef USE_EXF_INTERPOLATION
     I     vwind_lon0, vwind_lon_inc,
     I     vwind_lat0, vwind_lat_inc,
     I     vwind_nlon, vwind_nlat, xC, yC, vwind_interpMethod,
#endif
     I     myThid )

      ELSE
       DO bj = myByLo(myThid), myByHi(myThid)
        DO bi = myBxLo(myThid), myBxHi(myThid)
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           uwind(i,j,bi,bj) = 0.
           vwind(i,j,bi,bj) = 0.
          ENDDO
         ENDDO
        ENDDO
       ENDDO
      ENDIF

      CALL EXF_INIT_FLD(
     I     'wspeed', wspeedfile, wspeedmask,
     I     wspeedperiod, exf_inscal_wspeed, wspeedconst,
     O     wspeed, wspeed0, wspeed1,
#ifdef USE_EXF_INTERPOLATION
     I     wspeed_lon0, wspeed_lon_inc,
     I     wspeed_lat0, wspeed_lat_inc,
     I     wspeed_nlon, wspeed_nlat, xC, yC, wspeed_interpMethod,
#endif
     I     myThid )

      CALL EXF_INIT_FLD(
     I     'hflux', hfluxfile, hfluxmask,
     I     hfluxperiod, exf_inscal_hflux, hfluxconst,
     O     hflux, hflux0, hflux1,
#ifdef USE_EXF_INTERPOLATION
     I     hflux_lon0, hflux_lon_inc,
     I     hflux_lat0, hflux_lat_inc,
     I     hflux_nlon, hflux_nlat, xC, yC, hflux_interpMethod,
#endif
     I     myThid )

      CALL EXF_INIT_FLD(
     I     'sflux', sfluxfile, sfluxmask,
     I     sfluxperiod, exf_inscal_sflux, sfluxconst,
     O     sflux, sflux0, sflux1,
#ifdef USE_EXF_INTERPOLATION
     I     sflux_lon0, sflux_lon_inc,
     I     sflux_lat0, sflux_lat_inc,
     I     sflux_nlon, sflux_nlat, xC, yC, sflux_interpMethod,
#endif
     I     myThid )

#ifdef ALLOW_ATM_TEMP

      CALL EXF_INIT_FLD(
     I     'atemp', atempfile, atempmask,
     I     atempperiod, exf_inscal_atemp, atempconst,
     O     atemp, atemp0, atemp1,
#ifdef USE_EXF_INTERPOLATION
     I     atemp_lon0, atemp_lon_inc,
     I     atemp_lat0, atemp_lat_inc,
     I     atemp_nlon, atemp_nlat, xC, yC, atemp_interpMethod,
#endif
     I     myThid )

      CALL EXF_INIT_FLD(
     I     'aqh', aqhfile, aqhmask,
     I     aqhperiod, exf_inscal_aqh, aqhconst,
     O     aqh, aqh0, aqh1,
#ifdef USE_EXF_INTERPOLATION
     I     aqh_lon0, aqh_lon_inc,
     I     aqh_lat0, aqh_lat_inc,
     I     aqh_nlon, aqh_nlat, xC, yC, aqh_interpMethod,
#endif
     I     myThid )

# ifdef ALLOW_READ_TURBFLUXES

      CALL EXF_INIT_FLD(
     I     'hs', hs_file, hs_mask,
     I     hs_period, exf_inscal_hs, hs_const,
     O     hs, hs0, hs1,
#  ifdef USE_EXF_INTERPOLATION
     I     hs_lon0, hs_lon_inc,
     I     hs_lat0, hs_lat_inc,
     I     hs_nlon, hs_nlat, xC, yC, hs_interpMethod,
#  endif
     I     myThid )

      CALL EXF_INIT_FLD(
     I     'hl', hl_file, hl_mask,
     I     hl_period, exf_inscal_hl, hl_const,
     O     hl, hl0, hl1,
#  ifdef USE_EXF_INTERPOLATION
     I     hl_lon0, hl_lon_inc,
     I     hl_lat0, hl_lat_inc,
     I     hl_nlon, hl_nlat, xC, yC, hl_interpMethod,
#  endif
     I     myThid )

# endif /* ALLOW_READ_TURBFLUXES */

      CALL EXF_INIT_FLD(
     I     'lwflux', lwfluxfile, lwfluxmask,
     I     lwfluxperiod, exf_inscal_lwflux, lwfluxconst,
     O     lwflux, lwflux0, lwflux1,
#ifdef USE_EXF_INTERPOLATION
     I     lwflux_lon0, lwflux_lon_inc,
     I     lwflux_lat0, lwflux_lat_inc,
     I     lwflux_nlon, lwflux_nlat, xC, yC, lwflux_interpMethod,
#endif
     I     myThid )

#ifdef EXF_READ_EVAP
      CALL EXF_INIT_FLD(
     I     'evap', evapfile, evapmask,
     I     evapperiod, exf_inscal_evap, evapconst,
     O     evap, evap0, evap1,
#ifdef USE_EXF_INTERPOLATION
     I     evap_lon0, evap_lon_inc,
     I     evap_lat0, evap_lat_inc,
     I     evap_nlon, evap_nlat, xC, yC, evap_interpMethod,
#endif
     I     myThid )
#endif /* EXF_READ_EVAP */

      CALL EXF_INIT_FLD(
     I     'precip', precipfile, precipmask,
     I     precipperiod, exf_inscal_precip, precipconst,
     O     precip, precip0, precip1,
#ifdef USE_EXF_INTERPOLATION
     I     precip_lon0, precip_lon_inc,
     I     precip_lat0, precip_lat_inc,
     I     precip_nlon, precip_nlat, xC, yC, precip_interpMethod,
#endif
     I     myThid )

      CALL EXF_INIT_FLD(
     I     'snowprecip', snowprecipfile, snowprecipmask,
     I     snowprecipperiod, exf_inscal_snowprecip, snowprecipconst,
     O     snowprecip, snowprecip0, snowprecip1,
#ifdef USE_EXF_INTERPOLATION
     I     snowprecip_lon0, snowprecip_lon_inc,
     I     snowprecip_lat0, snowprecip_lat_inc,
     I     snowprecip_nlon, snowprecip_nlat, xC, yC,
     I     snowprecip_interpMethod,
#endif
     I     myThid )

#endif /* ALLOW_ATM_TEMP */

#if defined(ALLOW_ATM_TEMP) || defined(SHORTWAVE_HEATING)
      CALL EXF_INIT_FLD(
     I     'swflux', swfluxfile, swfluxmask,
     I     swfluxperiod,  exf_inscal_swflux, swfluxconst,
     O     swflux, swflux0, swflux1,
#ifdef USE_EXF_INTERPOLATION
     I     swflux_lon0, swflux_lon_inc,
     I     swflux_lat0, swflux_lat_inc,
     I     swflux_nlon, swflux_nlat, xC, yC, swflux_interpMethod,
#endif
     I     myThid )
#endif /* defined(ALLOW_ATM_TEMP) || defined(SHORTWAVE_HEATING) */

#ifdef ALLOW_DOWNWARD_RADIATION

      CALL EXF_INIT_FLD(
     I     'swdown', swdownfile, swdownmask,
     I     swdownperiod, exf_inscal_swdown, swdownconst,
     O     swdown, swdown0, swdown1,
#ifdef USE_EXF_INTERPOLATION
     I     swdown_lon0, swdown_lon_inc,
     I     swdown_lat0, swdown_lat_inc,
     I     swdown_nlon, swdown_nlat, xC, yC, swdown_interpMethod,
#endif
     I     myThid )

      CALL EXF_INIT_FLD(
     I     'lwdown', lwdownfile, lwdownmask,
     I     lwdownperiod, exf_inscal_lwdown, lwdownconst,
     O     lwdown, lwdown0, lwdown1,
#ifdef USE_EXF_INTERPOLATION
     I     lwdown_lon0, lwdown_lon_inc,
     I     lwdown_lat0, lwdown_lat_inc,
     I     lwdown_nlon, lwdown_nlat, xC, yC, lwdown_interpMethod,
#endif
     I     myThid )

#endif /* ALLOW_DOWNWARD_RADIATION */

#ifdef ATMOSPHERIC_LOADING
      CALL EXF_INIT_FLD(
     I     'apressure', apressurefile, apressuremask,
     I     apressureperiod, exf_inscal_apressure, apressureconst,
     O     apressure, apressure0, apressure1,
#ifdef USE_EXF_INTERPOLATION
     I     apressure_lon0, apressure_lon_inc,
     I     apressure_lat0, apressure_lat_inc,
     I     apressure_nlon, apressure_nlat, xC, yC,
     I     apressure_interpMethod,
#endif
     I     myThid )
#endif /* ATMOSPHERIC_LOADING */

#ifdef EXF_ALLOW_TIDES
      CALL EXF_INIT_FLD(
     I     'tidePot', tidePotFile, tidePotMask,
     I     tidePotPeriod, exf_inscal_tidePot, tidePotconst,
     O     tidePot, tidePot0, tidePot1,
#ifdef USE_EXF_INTERPOLATION
     I     tidePot_lon0, tidePot_lon_inc,
     I     tidePot_lat0, tidePot_lat_inc,
     I     tidePot_nlon, tidePot_nlat, xC, yC, tidePot_interpMethod,
#endif
     I     myThid )
#endif /* EXF_ALLOW_TIDES */

#ifdef EXF_SEAICE_FRACTION
      CALL EXF_INIT_FLD(
     I     'areamask', areamaskfile, areamaskmask,
     I     areamaskperiod, exf_inscal_areamask, areamaskconst,
     O     areamask, areamask0, areamask1,
#ifdef USE_EXF_INTERPOLATION
     I     areamask_lon0, areamask_lon_inc,
     I     areamask_lat0, areamask_lat_inc,
     I     areamask_nlon, areamask_nlat, xC, yC, areamask_interpMethod,
#endif
     I     myThid )
#endif /* EXF_SEAICE_FRACTION */

#ifdef ALLOW_RUNOFF
      CALL EXF_INIT_FLD(
     I     'runoff', runofffile, runoffmask,
     I     runoffperiod, exf_inscal_runoff, runoffconst,
     O     runoff, runoff0, runoff1,
# ifdef USE_EXF_INTERPOLATION
     I     runoff_lon0, runoff_lon_inc,
     I     runoff_lat0, runoff_lat_inc,
     I     runoff_nlon, runoff_nlat, xC, yC, runoff_interpMethod,
# endif
     I     myThid )
# ifdef ALLOW_RUNOFTEMP
      CALL EXF_INIT_FLD(
     I     'runoftemp', runoftempfile, runoffmask,
     I     runoffperiod, exf_inscal_runoftemp, runoftempconst,
     O     runoftemp, runoftemp0, runoftemp1,
#  ifdef USE_EXF_INTERPOLATION
     I     runoff_lon0, runoff_lon_inc,
     I     runoff_lat0, runoff_lat_inc,
     I     runoff_nlon, runoff_nlat, xC, yC, runoff_interpMethod,
#  endif
     I     myThid )
# endif /* ALLOW_RUNOFTEMP */
#endif /* ALLOW_RUNOFF */

#ifdef ALLOW_SALTFLX
      CALL EXF_INIT_FLD(
     I     'saltflx', saltflxfile, saltflxmask,
     I     saltflxperiod, exf_inscal_saltflx, saltflxconst,
     O     saltflx, saltflx0, saltflx1,
#ifdef USE_EXF_INTERPOLATION
     I     saltflx_lon0, saltflx_lon_inc,
     I     saltflx_lat0, saltflx_lat_inc,
     I     saltflx_nlon, saltflx_nlat, xC, yC, saltflx_interpMethod,
#endif
     I     myThid )
#endif /* ALLOW_SALTFLX */

#ifdef ALLOW_CLIMSST_RELAXATION
      CALL EXF_INIT_FLD(
     I     'climsst', climsstfile, climsstmask,
     I     climsstperiod, exf_inscal_climsst, climsstconst,
     O     climsst, climsst0, climsst1,
#ifdef USE_EXF_INTERPOLATION
     I     climsst_lon0, climsst_lon_inc,
     I     climsst_lat0, climsst_lat_inc,
     I     climsst_nlon, climsst_nlat, xC, yC, climsst_interpMethod,
#endif
     I     myThid )
#endif

#ifdef ALLOW_CLIMSSS_RELAXATION
      CALL EXF_INIT_FLD(
     I     'climsss', climsssfile, climsssmask,
     I     climsssperiod, exf_inscal_climsss, climsssconst,
     O     climsss, climsss0, climsss1,
#ifdef USE_EXF_INTERPOLATION
     I     climsss_lon0, climsss_lon_inc,
     I     climsss_lat0, climsss_lat_inc,
     I     climsss_nlon, climsss_nlat, xC, yC, climsss_interpMethod,
#endif
     I     myThid )
#endif

#ifdef ALLOW_CLIMSTRESS_RELAXATION
      CALL EXF_INIT_FLD(
     I     'climustr', climustrfile, climustrmask,
     I     climustrperiod, exf_inscal_climustr, climustrconst,
     O     climustr, climustr0, climustr1,
#ifdef USE_EXF_INTERPOLATION
     I     climustr_lon0, climustr_lon_inc,
     I     climustr_lat0, climustr_lat_inc,
     I     climustr_nlon, climustr_nlat, xC, yC, climustr_interpMethod,
#endif
     I     myThid )

      CALL EXF_INIT_FLD(
     I     'climvstr', climvstrfile, climvstrmask,
     I     climvstrperiod, exf_inscal_climvstr, climvstrconst,
     O     climvstr, climvstr0, climvstr1,
#ifdef USE_EXF_INTERPOLATION
     I     climvstr_lon0, climvstr_lon_inc,
     I     climvstr_lat0, climvstr_lat_inc,
     I     climvstr_nlon, climvstr_nlat, xC, yC, climvstr_interpMethod,
#endif
     I     myThid )
#endif /* CLIMSTRESS_RELAXATION */

#ifdef ALLOW_BULK_OFFLINE
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

# ifdef ALLOW_CLIMSST_RELAXATION
      _EXCH_XY_RL(climsst, myThid)
# endif
# ifdef ALLOW_CLIMSSS_RELAXATION
      _EXCH_XY_RL(climsss, myThid)
# endif
# ifdef ALLOW_CLIMSTRESS_RELAXATION
      CALL EXCH_UV_XY_RL( climustr, climvstr, .TRUE., myThid )
# endif
      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
# ifdef ALLOW_CLIMSST_RELAXATION
           IF ( climsstfile .NE. ' ' .AND.
     &          climsstperiod .EQ. 0. )
     &          theta(i,j,ks,bi,bj) = climsst(i,j,bi,bj)
# endif
# ifdef ALLOW_CLIMSSS_RELAXATION
           IF ( climsssfile .NE. ' ' .AND.
     &          climsssperiod .EQ. 0. )
     &          salt(i,j,ks,bi,bj) = climsss(i,j,bi,bj)
# endif
# ifdef ALLOW_CLIMSTRESS_RELAXATION
           IF ( climustrfile .NE. ' ' .AND.
     &          climustrperiod .EQ. 0. )
     &          uVel(i,j,ks,bi,bj) = climustr(i,j,bi,bj)
           IF ( climvstrfile .NE. ' ' .AND.
     &          climvstrperiod .EQ. 0. )
     &          vVel(i,j,ks,bi,bj) = climvstr(i,j,bi,bj)
# endif
           IF ( maskC(i,j,ks,bi,bj) .NE. 0. .AND.
     &             theta(i,j,ks,bi,bj) .EQ. 0. ) THEN
                PRINT *, 'ph-warn-exf-init ', i, j, theta(i,j,ks,bi,bj)
cph                STOP 'in exf_init'
           ENDIF
          ENDDO
         ENDDO
       ENDDO
      ENDDO

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
#endif /* ALLOW_BULK_OFFLINE */

      RETURN
      END

#include "PACKAGES_CONFIG.h"
#include "CPP_OPTIONS.h"

CBOP
C     !ROUTINE: CORRECTION_STEP
C     !INTERFACE:
      SUBROUTINE CORRECTION_STEP( bi, bj, iMin, iMax, jMin, jMax,
     I                      phiSurfX, phiSurfY,
     I                      myTime, myIter, myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R CORRECTION_STEP
C     | o Corrects the horizontal flow fields with the surface
C     |   pressure (and Non-Hydrostatic pressure).
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "DYNVARS.h"
#ifdef ALLOW_NONHYDROSTATIC
# include "NH_VARS.h"
#endif
#ifdef ALLOW_DIAGNOSTICS
# include "FFIELDS.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine Arguments ==
C     bi, bj              :: Tile indices
C     iMin,iMax,jMin,jMax :: Loop counters range
C     phiSurfX, phiSurfY  :: Surface Potential gradient
C     myTime              :: Current time in simulation
C     myIter              :: Current iteration number in simulation
C     myThid              :: my Thread Id number
      _RL     phiSurfX(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL     phiSurfY(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER bi, bj
      INTEGER iMin, iMax, jMin, jMax
      _RL     myTime
      INTEGER myIter
      INTEGER myThid

C     !FUNCTIONS:
#ifdef ALLOW_DIAGNOSTICS
      LOGICAL  DIAGNOSTICS_IS_ON
      EXTERNAL DIAGNOSTICS_IS_ON
#endif

C     !LOCAL VARIABLES:
C     == Local variables ==
C     i, j         :: Loop counters
C     k            :: Level index
C     psFac, nhFac :: Scaling parameters for supressing gradients
C     gU_dpx       :: implicit part of pressure gradient tendency
C     gV_dpy       :: implicit part of pressure gradient tendency
      INTEGER i,j
      INTEGER k
      _RL     psFac, nhFac
      _RL     gU_dpx(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL     gV_dpy(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
#ifdef ALLOW_DIAGNOSTICS
      LOGICAL dPhiDiagIsOn, implDisDiagIsOn
# ifdef ALLOW_SOLVE4_PS_AND_DRAG
      _RL tmpFac
# endif
#endif /* ALLOW_DIAGNOSTICS */
CEOP

#ifdef ALLOW_DIAGNOSTICS
      dPhiDiagIsOn = .FALSE.
      IF ( useDiagnostics )
     &  dPhiDiagIsOn = DIAGNOSTICS_IS_ON( 'Um_dPhiX', myThid )
     &            .OR. DIAGNOSTICS_IS_ON( 'Vm_dPhiY', myThid )
      implDisDiagIsOn = .FALSE.
      IF ( useDiagnostics )
     &  implDisDiagIsOn = DIAGNOSTICS_IS_ON( 'Um_ImplD', myThid )
     &               .OR. DIAGNOSTICS_IS_ON( 'Vm_ImplD', myThid )
#endif

C--   Loop over all layers, top to bottom
      DO k=1,Nr

#ifdef ALLOW_SOLVE4_PS_AND_DRAG
       IF ( selectImplicitDrag.EQ.2 ) THEN

#ifdef ALLOW_DIAGNOSTICS
C--    Momentum update: separate contribution from surf.pressure
C      and contribution from implicit viscosity with bottom drag
        IF ( dPhiDiagIsOn ) THEN
         psFac = pfFacMom*implicSurfPress
     &          *recip_deepFacC(k)*recip_rhoFacC(k)
         DO j=jMin,jMax
          DO i=iMin,iMax
           gU_dpx(i,j) = -psFac*phiSurfX(i,j)*_maskW(i,j,k,bi,bj)
           gV_dpy(i,j) = -psFac*phiSurfY(i,j)*_maskS(i,j,k,bi,bj)
          ENDDO
         ENDDO
         CALL DIAGNOSTICS_FILL( gU_dpx,
     &                         'Um_dPhiX', k, 1, -2, bi, bj, myThid )
         CALL DIAGNOSTICS_FILL( gV_dpy,
     &                         'Vm_dPhiY', k, 1, -2, bi, bj, myThid )
        ENDIF
        IF ( implDisDiagIsOn ) THEN
         psFac = pfFacMom*implicSurfPress
         tmpFac = recip_deepFacC(k)*recip_rhoFacC(k)
         DO j=jMin,jMax
          DO i=iMin,iMax
           gU_dpx(i,j) = -psFac*( dU_psFacX(i,j,k,bi,bj) - tmpFac )
     &                   *phiSurfX(i,j)*_maskW(i,j,k,bi,bj)
           gV_dpy(i,j) = -psFac*( dV_psFacY(i,j,k,bi,bj) - tmpFac )
     &                   *phiSurfY(i,j)*_maskS(i,j,k,bi,bj)
          ENDDO
         ENDDO
         CALL DIAGNOSTICS_FILL( gU_dpx,
     &                         'Um_ImplD', k, 1, -2, bi, bj, myThid )
         CALL DIAGNOSTICS_FILL( gV_dpy,
     &                         'Vm_ImplD', k, 1, -2, bi, bj, myThid )
        ENDIF
#endif /* ALLOW_DIAGNOSTICS */

C     On/off scaling parameter
        psFac = pfFacMom*implicSurfPress

C     Pressure gradient tendency (zonal mom): Implicit part
        DO j=jMin,jMax
         DO i=iMin,iMax
          gU_dpx(i,j) =
     &         -psFac*dU_psFacX(i,j,k,bi,bj)*phiSurfX(i,j)
c    &                  *_maskW(i,j,k,bi,bj)
         ENDDO
        ENDDO

C     Pressure gradient tendency (merid mom): Implicit part
        DO j=jMin,jMax
         DO i=iMin,iMax
          gV_dpy(i,j) =
     &         -psFac*dV_psFacY(i,j,k,bi,bj)*phiSurfY(i,j)
c    &                  *_maskS(i,j,k,bi,bj)
         ENDDO
        ENDDO

       ELSE
#endif /* ALLOW_SOLVE4_PS_AND_DRAG */

C     On/off scaling parameters (including anelastic & deep-model factors)
        psFac = pfFacMom*implicSurfPress
     &         *recip_deepFacC(k)*recip_rhoFacC(k)

C     Pressure gradient tendency (zonal mom): Implicit part
        IF ( use3Dsolver ) THEN
         nhFac = pfFacMom*implicitNHPress
     &          *recip_deepFacC(k)*recip_rhoFacC(k)
         DO j=jMin,jMax
          DO i=iMin,iMax
           gU_dpx(i,j) = -(
     &          psFac*phiSurfX(i,j)
#ifdef ALLOW_NONHYDROSTATIC
     &        + nhFac*_recip_dxC(i,j,bi,bj)
     &           *(phi_nh(i,j,k,bi,bj)-phi_nh(i-1,j,k,bi,bj))
#endif
     &                   )*_maskW(i,j,k,bi,bj)
          ENDDO
         ENDDO
        ELSE
         DO j=jMin,jMax
          DO i=iMin,iMax
           gU_dpx(i,j) = -psFac*phiSurfX(i,j)*_maskW(i,j,k,bi,bj)
          ENDDO
         ENDDO
        ENDIF

C     Pressure gradient tendency (merid mom): Implicit part
        IF ( use3Dsolver ) THEN
         DO j=jMin,jMax
          DO i=iMin,iMax
           gV_dpy(i,j) = -(
     &          psFac*phiSurfY(i,j)
#ifdef ALLOW_NONHYDROSTATIC
     &        + nhFac*_recip_dyC(i,j,bi,bj)
     &           *(phi_nh(i,j,k,bi,bj)-phi_nh(i,j-1,k,bi,bj))
#endif
     &                   )*_maskS(i,j,k,bi,bj)
          ENDDO
         ENDDO
        ELSE
         DO j=jMin,jMax
          DO i=iMin,iMax
           gV_dpy(i,j) = -psFac*phiSurfY(i,j)*_maskS(i,j,k,bi,bj)
          ENDDO
         ENDDO
        ENDIF

#ifdef ALLOW_DIAGNOSTICS
        IF ( dPhiDiagIsOn ) THEN
         CALL DIAGNOSTICS_FILL( gU_dpx,
     &                         'Um_dPhiX', k, 1, -2, bi, bj, myThid )
         CALL DIAGNOSTICS_FILL( gV_dpy,
     &                         'Vm_dPhiY', k, 1, -2, bi, bj, myThid )
        ENDIF
#endif /* ALLOW_DIAGNOSTICS */

#ifdef ALLOW_SOLVE4_PS_AND_DRAG
       ENDIF
#endif /* ALLOW_SOLVE4_PS_AND_DRAG */

C     Update zonal velocity: add implicit pressure gradient tendency
       DO j=jMin,jMax
        DO i=iMin,iMax
          uVel(i,j,k,bi,bj)=( gU(i,j,k,bi,bj)
     &                      + deltaTMom*gU_dpx(i,j)
     &                      )*_maskW(i,j,k,bi,bj)
#ifdef ALLOW_OBCS
     &                       *maskInW(i,j,bi,bj)
#endif
        ENDDO
       ENDDO

C     Update merid. velocity: add implicit pressure gradient tendency
       DO j=jMin,jMax
        DO i=iMin,iMax
          vVel(i,j,k,bi,bj)=( gV(i,j,k,bi,bj)
     &                      + deltaTMom*gV_dpy(i,j)
     &                      )*_maskS(i,j,k,bi,bj)
#ifdef ALLOW_OBCS
     &                       *maskInS(i,j,bi,bj)
#endif
        ENDDO
       ENDDO

C-    end of k loop
      ENDDO

#ifdef ALLOW_DIAGNOSTICS
      IF ( useDiagnostics .AND. selectImplicitDrag.EQ.2 ) THEN
       IF ( DIAGNOSTICS_IS_ON( 'botTauX ', myThid ) ) THEN
         IF ( usingZCoords ) THEN
C         kLowC = 0 if dry column
          DO j=jMin,jMax
           DO i=iMin,iMax
            k = MAX( 1, MIN( kLowC(i-1,j,bi,bj), kLowC(i,j,bi,bj) ) )
            botDragU(i,j,bi,bj) = -botDragU(i,j,bi,bj)
     &                          * uVel(i,j,k,bi,bj)
           ENDDO
          ENDDO
         ELSE
C         kSurfW = Nr+1 if dry column
          DO j=jMin,jMax
           DO i=iMin,iMax
            k = MIN( Nr, kSurfW(i,j,bi,bj) )
            botDragU(i,j,bi,bj) = -botDragU(i,j,bi,bj)
     &                          * uVel(i,j,k,bi,bj)
           ENDDO
          ENDDO
         ENDIF
         CALL DIAGNOSTICS_FILL_RS( botDragU, 'botTauX ',
     &                             0, 1, 1, bi, bj, myThid )
       ENDIF
       IF ( DIAGNOSTICS_IS_ON( 'botTauY ', myThid ) ) THEN
         IF ( usingZCoords ) THEN
C         kLowC = 0 if dry column
          DO j=jMin,jMax
           DO i=iMin,iMax
            k = MAX( 1, MIN( kLowC(i,j-1,bi,bj), kLowC(i,j,bi,bj) ) )
            botDragV(i,j,bi,bj) = -botDragV(i,j,bi,bj)
     &                          * vVel(i,j,k,bi,bj)
           ENDDO
          ENDDO
         ELSE
C         kSurfS = Nr+1 if dry column
          DO j=jMin,jMax
           DO i=iMin,iMax
            k = MIN( Nr, kSurfS(i,j,bi,bj) )
            botDragV(i,j,bi,bj) = -botDragV(i,j,bi,bj)
     &                          * vVel(i,j,k,bi,bj)
           ENDDO
          ENDDO
         ENDIF
         CALL DIAGNOSTICS_FILL_RS( botDragV, 'botTauY ',
     &                             0, 1, 1, bi, bj, myThid )
       ENDIF
      ENDIF

# ifdef ALLOW_SHELFICE
      IF ( useShelfIce .AND. useDiagnostics ) THEN
        CALL SHELFICE_DIAGNOSTICS_DRAG(
     I                uVel(1-OLx,1-OLy,1,bi,bj),
     I                vVel(1-OLx,1-OLy,1,bi,bj),
     I                bi, bj, myIter, myThid )
      ENDIF
# endif /* ALLOW_SHELFICE */
#endif /* ALLOW_DIAGNOSTICS */

      RETURN
      END

#include "PACKAGES_CONFIG.h"
#include "CPP_EEOPTIONS.h"

CBOP
C     !ROUTINE: INI_COMMUNICATION_PATTERNS

C     !INTERFACE:
      SUBROUTINE INI_COMMUNICATION_PATTERNS( myThid )
C     !DESCRIPTION:
C     *==========================================================*
C     | SUBROUTINE INI\_COMMUNICATION\_PATTERNS
C     | o Initialise between tile communication data structures.
C     *==========================================================*
C     | This routine assigns identifiers to each tile and then
C     | defines a map of neighbors for each tile.
C     | For each neighbor a communication method is defined.
C     *==========================================================*

C     !USES:
      IMPLICIT NONE
C     === Global data ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "EESUPPORT.h"
#include "EXCH.h"

C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
C     myThid :: Thread number we are dealing with in this call
      INTEGER myThid

C     !LOCAL VARIABLES:
C     === Local variables ===
C     pxW   :: Process X coord of process to west.
C     pxE   :: Process X coord of process to west.
C     pyN   :: Process Y coord of process to north.
C     pyS   :: Process Y coord of process to south.
C     procW :: Process Id of process to west.
C     procE :: Process Id of process to east.
C     procN :: Process Id of process to north.
C     procS :: Process Id of process to south.
C     totalTileCount :: Total number of tiles
C     tagW0, tagE0, tagS0, tagN0, theTag :: Working variables for
C                                           calculating message tags.
C     biW, biE, bjN, bjS :: Tile x and y indices to west, east,
C                           south and north.
C     bi, bj   :: Tile loop counter
C     picnt, pjcnt   :: Process loop counter
C     bi0, bj0 :: Base global index coordinate ( on CS there is no global
C                 coord).
      INTEGER bi0(nPx)
      INTEGER bj0(nPy)
      INTEGER bi, bj, picnt, pjcnt
      INTEGER pxW, pxE, pyN, pyS
      INTEGER procW, procE, procN, procS
      INTEGER totalTileCount
      INTEGER tagW0, tagE0, tagS0, tagN0, theTag
      INTEGER biE, biW, bjN, bjS
      INTEGER thePx, thePy, theBj, theBi
CEOP

C--   Define a globally unique tile numbers for each tile.
C--   We aslo define the tile numbers for our east, west, south
C--   and north neighbor tiles here. As coded below this is done from
C--   a simple cartesian formula. To handle irregular tile distributions
C--   the code below would be changed. For instance we could read
C--   the neighbor tile information from a file rather than deriving
C--   it in-line. This allows general tile distributions and connectivity
C--   both within a thread, between threads and between processors.
C     Notes --
C     1. The cartesian based formula coded below works as follows:
C       i. Each tile has one west neighbor, one east neighbor
C          one north neignbor and one south neighbor.
C      ii. For each of my neighbors store the following
C          - neighbor tile id
C          - neighbor process id
C     2. The information that is stored is then used to determine
C        the between tile communication method. The method used
C        depends on whether the tile is part of the same process,
C        on the same machine etc...
C     3. To initialise a tile distribution with holes in it
C        i.e. tiles that are not computed on. Set tile number to
C        the value NULL_TILE. This must also be done for tileNoW,
C        tileNoE, tileNoS, tileNoN.
C     4. The default formula below assigns tile numbers sequentially
C        in X on the **global** grid. Within a process the tile numbers
C        will not necessairily be sequential. This means that the tile
C        numbering label does not change when nTx, nTy, nPx or nPy change.
C        It will only change if the tile size changes or the global
C        grid changes.
C     bi0 and bj0 are the base global tile grid coordinate for the first
C     tile in this process.
      DO picnt = 1, nPx
       bi0(picnt) = picnt
      ENDDO
      DO pjcnt = 1, nPy
       bj0(pjcnt) = pjcnt
      ENDDO
      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
C       o My tile identifier
Crg     tileNo(bi,bj) = (bj0(myPy)-1+bj-1)*nSx*nPx+bi0(myPx)+bi-1
        thePx = myPx
        thePy = myPy
        theBj = bj
        theBi = bi
        tileNo(bi,bj) =
     &    ((thePy-1)*nSy+theBj-1)*nSx*nPx
     &   + (thePx-1)*nSx
     &   + theBi
C       o My west neighbor tile and process identifier
        biW   = bi-1
        pxW   = myPx
        procW = myPid
        IF ( biW .LT. 1 ) THEN
         biW   = nSx
         pxW   = myPx-1
         procW = pidW
         IF ( pxW .LT. 1 ) pxW   = nPx
        ENDIF
Crg     tileNoW (bi,bj) = (bj0(myPy)-1+bj-1)*nSx*nPx+bi0(pxW)+biW-1
        thePx = pxW
        thePy = myPy
        theBj = bj
        theBi = biW
        tileNoW (bi,bj) =
     &    ((thePy-1)*nSy+theBj-1)*nSx*nPx
     &   + (thePx-1)*nSx
     &   + theBi
#ifdef ALLOW_NEST_CHILD
#ifndef ALLOW_USE_MPI
        tileNoW (bi,bj) = NULL_TILE
#endif
#endif
        tilePidW(bi,bj) = procW
        tileBiW (bi,bj) = biW
        tileBjW (bi,bj) = bj
C       o My east neighbor tile and process identifier
        biE   = bi+1
        pxE   = myPx
        procE = myPid
        IF ( biE .GT. nSx ) THEN
         biE = 1
         pxE = myPx+1
         procE = pidE
         IF ( pxE .GT. nPx ) pxE   = 1
        ENDIF
Crg     tileNoE(bi,bj)  = (bj0(myPy)-1+bj-1)*nSx*nPx+bi0(pxE)+biE-1
        thePx = pxE
        thePy = myPy
        theBi = biE
        theBj = bj
        tileNoE(bi,bj) =
     &    ((thePy-1)*nSy+theBj-1)*nSx*nPx
     &   + (thePx-1)*nSx
     &   + theBi
#ifdef ALLOW_NEST_CHILD
#ifndef ALLOW_USE_MPI
        tileNoE (bi,bj) = NULL_TILE
#endif
#endif
        tilePidE(bi,bj) = procE
        tileBiE (bi,bj) = biE
        tileBjE (bi,bj) = bj
C       o My north neighbor tile and process identifier
        bjN   = bj+1
        pyN   = myPy
        procN = myPid
        IF ( bjN .GT. nSy ) THEN
         bjN = 1
         pyN = myPy+1
         procN = pidN
         IF ( pyN .GT. nPy ) pyN   = 1
        ENDIF
Crg     tileNoN(bi,bj) = (bj0(pyN)-1+bjN-1)*nSx*nPx+bi0(myPx)+bi-1
        thePx = myPx
        thePy = pyN
        theBi = bi
        theBj = bjN
        tileNoN(bi,bj) =
     &    ((thePy-1)*nSy+theBj-1)*nSx*nPx
     &   + (thePx-1)*nSx
     &   + theBi
        tilePidN(bi,bj) = procN
         tileBiN(bi,bj) = bi
         tileBjN(bi,bj) = bjN
C       o My south neighbor tile and process identifier
        bjS   = bj-1
        pyS   = myPy
        procS = myPid
        IF ( bjS .LT. 1 ) THEN
         bjS = nSy
         pyS = pyS-1
         procS = pidS
         IF ( pyS .LT. 1 ) pyS = nPy
        ENDIF
Crg     tileNoS(bi,bj) = (bj0(pyS+1)-1+bjS-1)*nSx*nPx+bi0(myPx+1)+bi-1
        thePx = myPx
        thePy = pyS
        theBi = bi
        theBj = bjS
        tileNoS(bi,bj) =
     &    ((thePy-1)*nSy+theBj-1)*nSx*nPx
     &   + (thePx-1)*nSx
     &   + theBi
        tilePidS(bi,bj) = procS
         tileBiS(bi,bj) = bi
         tileBjS(bi,bj) = bjS
       ENDDO
      ENDDO

C--   Define the total count of tiles.
      totalTileCount = nSx*nSy*nPx*nPy

C--   Set tags for each tile face.
C     Tags are used to distinguish exchanges from particular
C     faces of particular tiles.
C     Tag numbers are based on
C      i - The tile number
C     ii - The direction (N,S,W,E) of the message
C     We dont check for the NULL_TILE tile number here as it
C     should not actually be used.
      TagW0=1
      TagE0=2
      TagN0=3
      TagS0=4
      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
C       Send tags
C       o Tag I use for messages I send to west
        theTag = TagW0*totalTileCount+tileNo(bi,bj)-1
        tileTagSendW(bi,bj) = theTag
C       o Tag I use for messages I send to east
        theTag = TagE0*totalTileCount+tileNo(bi,bj)-1
        tileTagSendE(bi,bj) = theTag
C       o Tag I use for messages I send to north
        theTag = TagN0*totalTileCount+tileNo(bi,bj)-1
        tileTagSendN(bi,bj) = theTag
C       o Tag I use for messages I send to south
        theTag = TagS0*totalTileCount+tileNo(bi,bj)-1
        tileTagSendS(bi,bj) = theTag
C       Receive tags
C       o Tag on messages I receive from my east
        theTag = TagW0*totalTileCount+tileNoE(bi,bj)-1
        tileTagRecvE(bi,bj) = theTag
C       o Tag on messages I receive from my west
        theTag = TagE0*totalTileCount+tileNoW(bi,bj)-1
        tileTagRecvW(bi,bj) = theTag
C       o Tag on messages I receive from my north
        theTag = TagS0*totalTileCount+tileNoN(bi,bj)-1
        tileTagRecvN(bi,bj) = theTag
C       o Tag on messages I receive from my north
        theTag = TagN0*totalTileCount+tileNoS(bi,bj)-1
        tileTagRecvS(bi,bj) = theTag
       ENDDO
      ENDDO

C--   Set the form of excahnge to use between neighboring tiles.
C     For now use either shared memory, messages or nothing. Further
C     rules can be added later to allow shm regions and ump regions etc...
C     Notes -
C     1. We require symmetry here. If one face of a tile uses
C        communication method A then the matching face on its neighbor
C        tile must also use communication method A.
      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
C      o West face communication
       IF ( tileNoW(bi,bj) .EQ. NULL_TILE ) THEN
        tileCommModeW(bi,bj) = COMM_NONE
       ELSE
        IF ( myPid .EQ. tilePidW(bi,bj) ) THEN
         tileCommModeW(bi,bj) = COMM_PUT
        ELSE
         tileCommModeW(bi,bj) = COMM_MSG
        ENDIF
       ENDIF
C      o East face communication
       IF ( tileNoE(bi,bj) .EQ. NULL_TILE ) THEN
        tileCommModeE(bi,bj) = COMM_NONE
       ELSE
        IF ( myPid .EQ. tilePidE(bi,bj) ) THEN
         tileCommModeE(bi,bj) = COMM_PUT
        ELSE
         tileCommModeE(bi,bj) = COMM_MSG
        ENDIF
       ENDIF
C      o South face communication
       IF ( tileNoS(bi,bj) .EQ. NULL_TILE ) THEN
        tileCommModeS(bi,bj) = COMM_NONE
       ELSE
        IF ( myPid .EQ. tilePidS(bi,bj) ) THEN
         tileCommModeS(bi,bj) = COMM_PUT
        ELSE
         tileCommModeS(bi,bj) = COMM_MSG
        ENDIF
       ENDIF
C      o North face communication
       IF ( tileNoN(bi,bj) .EQ. NULL_TILE ) THEN
        tileCommModeN(bi,bj) = COMM_NONE
       ELSE
        IF ( myPid .EQ. tilePidN(bi,bj) ) THEN
         tileCommModeN(bi,bj) = COMM_PUT
        ELSE
         tileCommModeN(bi,bj) = COMM_MSG
        ENDIF
       ENDIF

       ENDDO
      ENDDO

C     Initialise outstanding exchange request counter
      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        exchNReqsX(1,bi,bj) = 0
        exchNReqsY(1,bi,bj) = 0
       ENDDO
      ENDDO

      RETURN
      END

#include "GAD_OPTIONS.h"

CBOP
C     !ROUTINE: GAD_SOM_FILL_CS_CORNER
C     !INTERFACE:
      SUBROUTINE GAD_SOM_FILL_CS_CORNER(
     I           fill4dirX,
     U           sm_v,  sm_o,  sm_x,  sm_y,  sm_z,
     U           sm_xx, sm_yy, sm_zz, sm_xy, sm_xz, sm_yz,
     I           bi, bj, myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE GAD_SOM_FILL_CS_CORNER
C     | o Wraper S/R to fill the corner-halo region of CS-grid,
C     |   for all moments of a 1 tracer field
C     *==========================================================*
C     | o the corner halo region is filled with valid values
C     |   in order to compute (later on) gradient in X or Y
C     |   direction, on a wide stencil.
C     *==========================================================*
C     \ev
C     !USES:
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GAD.h"

C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
C     fill4dirX :: True = prepare for X direction calculations
C                  otherwise, prepare for Y direction
C     sm_v      :: volume of grid cell
C     sm_o      :: tracer content of grid cell (zero order moment)
C     sm_x,y,z  :: 1rst order moment of tracer distribution, in x,y,z direction
C   sm_xx,yy,zz ::  2nd order moment of tracer distribution, in x,y,z direction
C   sm_xy,xz,yz ::  2nd order moment of tracer distr., in cross direction xy,xz,yz
C     bi,bj     :: tile indices
C     myThid    :: my Thread Id. number
      LOGICAL fill4dirX
      _RL sm_v  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL sm_o  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL sm_x  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL sm_y  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL sm_z  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL sm_xx (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL sm_yy (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL sm_zz (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL sm_xy (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL sm_xz (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL sm_yz (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER bi,bj
      INTEGER myThid

C     !LOCAL VARIABLES:
C     == Local variables ==
      INTEGER selectDir
CEOP

      IF (useCubedSphereExchange) THEN
          IF ( fill4dirX ) THEN
            selectDir = 1
          ELSE
            selectDir = 2
          ENDIF
          CALL FILL_CS_CORNER_TR_RL( selectDir, .FALSE.,
     &                               sm_v , bi,bj, myThid )
          CALL FILL_CS_CORNER_TR_RL( selectDir, .FALSE.,
     &                               sm_o , bi,bj, myThid )
          CALL FILL_CS_CORNER_AG_RL( fill4dirX, .TRUE.,
     &                               sm_x , sm_y , bi,bj, myThid )
          CALL FILL_CS_CORNER_TR_RL( selectDir, .FALSE.,
     &                               sm_z , bi,bj, myThid )
          CALL FILL_CS_CORNER_AG_RL( fill4dirX, .FALSE.,
     &                               sm_xx, sm_yy, bi,bj, myThid )
          CALL FILL_CS_CORNER_TR_RL( selectDir, .FALSE.,
     &                               sm_zz, bi,bj, myThid )
          CALL FILL_CS_CORNER_TR_RL( selectDir, .TRUE.,
     &                               sm_xy, bi,bj, myThid )
          CALL FILL_CS_CORNER_AG_RL( fill4dirX, .TRUE.,
     &                               sm_xz, sm_yz, bi,bj, myThid )
      ENDIF

      RETURN
      END

module vert_diff_mod

!=======================================================================
!
!                         VERTICAL DIFFUSION MODULE
!
!      Routines for computing the tendencies due to vertical diffusion
!
!=======================================================================

use   constants_mod, only:  GRAV, RDGAS, RVGAS, CP_air

!use         fms_mod, only:  error_mesg, FATAL, uppercase, &
!                            write_version_number, stdlog, &
!                            mpp_pe, mpp_root_pe

!use   field_manager_mod, only: MODEL_ATMOS
!use  tracer_manager_mod, only: query_method, get_tracer_index

implicit none
private


! public interfaces
!=======================================================================
public :: gcm_vert_diff_init,          &
          gcm_vert_diff_end,           &
          gcm_vert_diff,               &
          gcm_vert_diff_down,          &
          gcm_vert_diff_up,            &
          vert_diff,                   &
          surf_diff_type

!=======================================================================

! form of interfaces
!=======================================================================

type surf_diff_type

  real, pointer, dimension(:,:) :: dtmass,    &
                                   dflux_t,   &
                                   dflux_q,   &
                                   delta_t,   &
                                   delta_q

end type surf_diff_type

!real,    allocatable, dimension(:,:,:) :: e_global, f_t_global, f_q_global

logical :: do_init = .true.
logical :: do_conserve_energy = .true.
logical :: use_virtual_temp_vert_diff, do_mcm_plev
integer :: sphum

!--------------------- version number ---------------------------------

character(len=128) :: version = '$Id: vert_diff_mod.F90,v 1.1 2013/05/08 22:14:15 jmc Exp $'
character(len=128) :: tag = '$Name:  $'

real, parameter :: d608 = (RVGAS-RDGAS)/RDGAS

contains

!#######################################################################

subroutine gcm_vert_diff_init (idim, jdim, kdim,              &
                               do_conserve_energy_in, myThid, &
                               use_virtual_temp_vert_diff_in, &
                               do_mcm_plev_in )

!type(surf_diff_type), intent(inout) :: Tri_surf
 integer,              intent(in)    :: idim, jdim, kdim
 logical,              intent(in)    :: do_conserve_energy_in
 integer, intent(in)                 :: myThid
 logical, optional,    intent(in)    :: use_virtual_temp_vert_diff_in
 logical, optional,    intent(in)    :: do_mcm_plev_in

!    _BARRIER
!    _BEGIN_MASTER(myThid)
     CALL BARRIER(myThid)
     IF ( myThid.EQ.1 ) THEN

!   call write_version_number ( version, tag )

! get the tracer number for specific humidity
! jmc: --- need to do something ---
    sphum = 2
!   sphum = get_tracer_index( MODEL_ATMOS, 'sphum')
!   if (mpp_pe() == mpp_root_pe()) &
!   write (stdlog(),'(a,i4)') 'Tracer number for specific humidity =',sphum

    if(present(use_virtual_temp_vert_diff_in)) then
      use_virtual_temp_vert_diff = use_virtual_temp_vert_diff_in
    else
      use_virtual_temp_vert_diff = .false.
    endif
    if(present(do_mcm_plev_in)) then
      do_mcm_plev = do_mcm_plev_in
    else
      do_mcm_plev = .false.
    endif

 if (do_init) then

!   if (allocated(  e_global ))    deallocate (  e_global )
!   if (allocated(f_t_global ))    deallocate (f_t_global )
!   if (allocated(f_q_global ))    deallocate (f_q_global )

!   allocate(  e_global (idim, jdim, kdim-1))
!   allocate(f_t_global (idim, jdim, kdim-1))
!   allocate(f_q_global (idim, jdim, kdim-1))

    do_init = .false.

 endif

!call alloc_surf_diff_type ( Tri_surf, idim, jdim, myThid )

 do_conserve_energy = do_conserve_energy_in

     ENDIF
     CALL BARRIER(myThid)

end subroutine gcm_vert_diff_init

!#######################################################################

subroutine alloc_surf_diff_type ( Tri_surf, idim, jdim, myThid )

type(surf_diff_type), intent(inout) :: Tri_surf
integer,              intent(in)    :: idim, jdim
integer,              intent(in)    :: myThid

    allocate( Tri_surf%dtmass    (idim, jdim) )
    allocate( Tri_surf%dflux_t   (idim, jdim) )
    allocate( Tri_surf%dflux_q   (idim, jdim) )
    allocate( Tri_surf%delta_t   (idim, jdim) )
    allocate( Tri_surf%delta_q   (idim, jdim) )

end subroutine alloc_surf_diff_type

!#######################################################################

subroutine dealloc_surf_diff_type ( Tri_surf, myThid )

type(surf_diff_type), intent(inout) :: Tri_surf
integer,intent(in)                  :: myThid

      deallocate( Tri_surf%dtmass    )
      deallocate( Tri_surf%dflux_t   )
      deallocate( Tri_surf%dflux_q   )
      deallocate( Tri_surf%delta_t   )
      deallocate( Tri_surf%delta_q   )

end subroutine dealloc_surf_diff_type

!#######################################################################

subroutine gcm_vert_diff_end (myThid)

integer, intent(in)  ::myThid

  if (.not.do_init) then

!   if (allocated(   e_global ))    deallocate (   e_global)
!   if (allocated( f_t_global ))    deallocate ( f_t_global)
!   if (allocated( f_q_global ))    deallocate ( f_q_global)

  endif

end subroutine gcm_vert_diff_end

!#######################################################################

subroutine gcm_vert_diff_down (is, js, delt,                 &
                         u, v, t, q,                         &
!                        tr,                                 &
                         diff_m, diff_t, p_half, p_full,     &
                         z_full, tau_u, tau_v, dtau_datmos,  &
!                        flux_tr,                            &
                         dt_u, dt_v, dt_t, dt_q,             &
!                        dt_tr,                              &
                         dissipative_heat, tri_surf_dtmass,  &
                         tri_surf_dflux_t, tri_surf_dflux_q, &
                         tri_surf_delta_t, tri_surf_delta_q, &
                         e_global, f_t_global, f_q_global,   &
                         myThid, kbot )

integer, intent(in)                        :: is, js
real,    intent(in)                        :: delt
real,    intent(in)   , dimension(:,:,:)   :: u, v, t, q,     &
                                              diff_m, diff_t, &
                                              p_half, p_full, &
                                              z_full
!real,    intent(in)   , dimension(:,:,:,:) :: tr
real,    intent(in)   , dimension(:,:)     :: dtau_datmos
real,    intent(inout), dimension(:,:)     :: tau_u, tau_v
!real,    intent(inout), dimension(:,:,:)   :: flux_tr
real,    intent(inout), dimension(:,:,:)   :: dt_u, dt_v, dt_t
real,    intent(in),    dimension(:,:,:)   :: dt_q
!real,    intent(inout), dimension(:,:,:,:) :: dt_tr
real,    intent(out)  , dimension(:,:,:)   :: dissipative_heat
!type(surf_diff_type), intent(inout)        :: Tri_surf
real,    intent(inout), dimension(:,:)     :: tri_surf_dtmass
real,    intent(inout), dimension(:,:)     :: tri_surf_dflux_t, tri_surf_dflux_q
real,    intent(inout), dimension(:,:)     :: tri_surf_delta_t, tri_surf_delta_q
real,    intent(out),   dimension(:,:,:)   :: e_global, f_t_global, f_q_global
integer, intent(in)                        :: myThid

integer, intent(in)   , dimension(:,:), optional :: kbot

real, dimension(size(u,1),size(u,2),size(u,3)) :: tt, mu, nu

real, dimension(size(u,1),size(u,2)) :: f_t_delt_n1, f_q_delt_n1, &
            mu_delt_n, nu_n, e_n1, delta_t_n, delta_q_n

real    :: gcp
integer :: i, j, kb, ie, je

!-----------------------------------------------------------------------

  if(do_init) call PRINT_ERROR ( &
       'gcm_vert_diff_down in vert_diff_mod'//  &
      'the initialization routine gcm_vert_diff_init has not been called', &
       myThid )
! if(do_init) call error_mesg ('gcm_vert_diff_down in vert_diff_mod',  &
!     'the initialization routine gcm_vert_diff_init has not been called', &
!      FATAL)

 ie = is + size(t,1) -1
 je = js + size(t,2) -1

 gcp       = GRAV/CP_air
 tt  = t + z_full*gcp   ! the vertical gradient of tt determines the
                        ! diffusive flux of temperature

 call compute_mu (p_half, mu, myThid)
 call compute_nu (diff_m, p_half, p_full, z_full, t, q, nu, myThid)

!  diffuse u-momentum and v_momentum

 call uv_vert_diff (delt, mu, nu, u, v, dtau_datmos, tau_u, tau_v,  &
                    dt_u, dt_v, dt_t, dissipative_heat, myThid, kbot)

!  recompute nu for a different diffusivity
 call compute_nu   (diff_t, p_half, p_full, z_full, t, q, nu, myThid)

!  diffuse tracers
!call tr_vert_diff (delt, mu, nu, tr, flux_tr, dt_tr, myThid, kbot )

!  downward sweep of tridiagonal solver for temperature and specific humidity
 call vert_diff_down_2                            &
         (delt, mu, nu, tt, q, dt_t, dt_q,        &
         e_global             (is:ie,js:je,:),    &
         f_t_global           (is:ie,js:je,:),    &
         f_q_global           (is:ie,js:je,:),    &
         mu_delt_n, nu_n, e_n1, f_t_delt_n1, f_q_delt_n1, &
         delta_t_n, delta_q_n, myThid, kbot)

! store information needed by flux_exchange module

    tri_surf_delta_t (is:ie,js:je) = delta_t_n + mu_delt_n*nu_n*f_t_delt_n1
    tri_surf_delta_q (is:ie,js:je) = delta_q_n + mu_delt_n*nu_n*f_q_delt_n1
    tri_surf_dflux_t (is:ie,js:je) = -nu_n*(1.0 - e_n1)
    tri_surf_dflux_q (is:ie,js:je) = -nu_n*(1.0 - e_n1)
    tri_surf_dtmass  (is:ie,js:je) = mu_delt_n

!-----------------------------------------------------------------------

end subroutine gcm_vert_diff_down

!#######################################################################

subroutine gcm_vert_diff_up (is, js, delt,                   &
                         tri_surf_delta_t, tri_surf_delta_q, &
                         e_global, f_t_global, f_q_global,   &
                         dt_t, dt_q, myThid, kbot)

integer, intent(in)                      :: is, js
real,    intent(in)                      :: delt
integer, intent(in)                      :: myThid
!type(surf_diff_type), intent(in)         :: Tri_surf
real,    intent(in),    dimension(:,:)   :: tri_surf_delta_t, tri_surf_delta_q
real,    intent(in),    dimension(:,:,:) :: e_global, f_t_global, f_q_global
real,    intent(out),   dimension(:,:,:) :: dt_t, dt_q
integer, intent(in),    dimension(:,:), optional :: kbot

integer :: ie, je

 ie = is + size(dt_t,1) -1
 je = js + size(dt_t,2) -1


 call vert_diff_up (delt ,                              &
                    e_global          (is:ie,js:je,:) , &
                    f_t_global        (is:ie,js:je,:) , &
                    tri_surf_delta_t  (is:ie,js:je) ,   &
                    dt_t, myThid, kbot )

 call vert_diff_up (delt ,                              &
                    e_global          (is:ie,js:je,:) , &
                    f_q_global        (is:ie,js:je,:) , &
                    tri_surf_delta_q  (is:ie,js:je) ,   &
                    dt_q, myThid, kbot )


end subroutine gcm_vert_diff_up

!#######################################################################

subroutine gcm_vert_diff (delt, u, v, t, q, tr,                    &
                          diff_m, diff_t, p_half, p_full, z_full,  &
                          dtau_datmos, dsens_datmos, devap_datmos, &
                          sens, evap, tau_u, tau_v, flux_tr,       &
                          dt_u, dt_v, dt_t, dt_q, dt_tr,           &
                          dissipative_heat, myThid, kbot      )

!  one-step diffusion call for gcm in which there is no implicit dependence of
!    surface fluxes on surface temperature

real,    intent(in)                          :: delt
real,    intent(in)   , dimension(:,:,:)     :: u, v, t, q, p_half, p_full, &
                                                z_full, diff_m, diff_t
real,    intent(in)   , dimension(:,:,:,:)   :: tr
real,    intent(in)   , dimension(:,:)       :: dtau_datmos, dsens_datmos, &
                                                devap_datmos
real,    intent(inout), dimension(:,:,:)     :: flux_tr
real,    intent(inout), dimension(:,:)       :: tau_u, tau_v, sens, evap
real,    intent(inout), dimension(:,:,:)     :: dt_u, dt_v, dt_t, dt_q
real,    intent(inout), dimension(:,:,:,:)   :: dt_tr
real,    intent(out)  , dimension(:,:,:)     :: dissipative_heat
integer, intent(in)                          :: myThid

integer, intent(in)   , dimension(:,:), optional :: kbot

real, dimension(size(u,1),size(u,2),size(u,3)) :: mu, nu


!-----------------------------------------------------------------------

 call compute_mu (p_half, mu, myThid)

 call compute_nu (diff_m, p_half, p_full, z_full, t, q, nu, myThid)

 call uv_vert_diff (delt, mu, nu, u, v, dtau_datmos, tau_u, tau_v, &
                    dt_u, dt_v, dt_t, dissipative_heat, myThid, kbot )

 call compute_nu   (diff_t, p_half, p_full, z_full, t, q, nu, myThid)

 call tq_vert_diff (delt, mu, nu, t, q, z_full,  &
                    dsens_datmos, devap_datmos,  &
                    sens, evap, dt_t, dt_q, myThid, kbot )

 call tr_vert_diff (delt, mu, nu, tr, flux_tr, dt_tr, myThid, kbot )

end subroutine gcm_vert_diff

!#######################################################################

subroutine vert_diff (delt, xi, t, q, diff, p_half, p_full, z_full, &
                      flux, dflux_datmos, factor, dt_xi, myThid, kbot)

! one-step diffusion of a single field

real,    intent(in)                          :: delt
real,    intent(in)   , dimension(:,:,:)     :: xi, t, q, diff, p_half, p_full, z_full
real,    intent(inout), dimension(:,:)       :: flux
real,    intent(in)   , dimension(:,:)       :: dflux_datmos
real,    intent(in)                          :: factor
real,    intent(inout), dimension(:,:,:)     :: dt_xi
integer, intent(in)                          :: myThid

integer, intent(in)   , dimension(:,:), optional :: kbot

real, dimension(size(xi,1),size(xi,2),size(xi,3)  ) :: mu, nu
real, dimension(size(xi,1),size(xi,2),size(xi,3)-1) :: e, f

real, dimension(size(xi,1),size(xi,2))  :: mu_delt_n, nu_n, e_n1,  &
                                           f_delt_n1, delta_xi_n

!-----------------------------------------------------------------------

 call compute_mu    (p_half, mu, myThid)

 call compute_nu    (diff, p_half, p_full, z_full, t, q, nu, myThid)

 call vert_diff_down &
     (delt, mu, nu, xi, dt_xi, e, f, mu_delt_n, nu_n, e_n1,  &
      f_delt_n1, delta_xi_n, myThid, kbot)

 call diff_surface (mu_delt_n, nu_n, e_n1, f_delt_n1,     &
                    dflux_datmos, flux, factor, delta_xi_n, myThid)

 call vert_diff_up (delt, e, f, delta_xi_n, dt_xi, myThid, kbot)

end subroutine vert_diff


!#######################################################################

subroutine uv_vert_diff (delt, mu, nu, u, v,  &
                         dtau_datmos, tau_u, tau_v, dt_u, dt_v, dt_t, &
                         dissipative_heat, myThid, kbot )

real,    intent(in)                        :: delt
real,    intent(in)   , dimension(:,:,:)   :: u, v, mu, nu
real,    intent(in)   , dimension(:,:)     :: dtau_datmos
real,    intent(inout), dimension(:,:)     :: tau_u, tau_v
real,    intent(inout), dimension(:,:,:)   :: dt_u, dt_v, dt_t
real,    intent(out)  , dimension(:,:,:)   :: dissipative_heat
integer, intent(in)                        :: myThid

integer, intent(in)   , dimension(:,:), optional :: kbot

real, dimension(size(u,1),size(u,2)) :: mu_delt_n, nu_n, e_n1,    &
                                        f_u_delt_n1, f_v_delt_n1, &
                                        delta_u_n, delta_v_n

real, dimension(size(u,1),size(u,2),size(u,3)) :: dt_u_temp, dt_v_temp

real, dimension(size(u,1),size(u,2),size(u,3)-1) :: e, f_u, f_v
integer :: i, j, kb

real    :: half_delt, cp_inv


!-----------------------------------------------------------------------

 half_delt = 0.5*delt
 cp_inv    = 1.0/CP_air

 if (do_conserve_energy) then
   dt_u_temp = dt_u
   dt_v_temp = dt_v
 endif

 call vert_diff_down_2 &
     (delt, mu, nu, u, v, dt_u, dt_v, e, f_u, f_v, &
      mu_delt_n, nu_n, e_n1, f_u_delt_n1, f_v_delt_n1,  &
      delta_u_n, delta_v_n, myThid, kbot)

 call diff_surface (mu_delt_n, nu_n, e_n1, f_u_delt_n1, &
                    dtau_datmos, tau_u, 1.0, delta_u_n, myThid)
 call diff_surface (mu_delt_n, nu_n, e_n1, f_v_delt_n1, &
                    dtau_datmos, tau_v, 1.0, delta_v_n, myThid)

 call vert_diff_up (delt, e, f_u, delta_u_n, dt_u, myThid, kbot)
 call vert_diff_up (delt, e, f_v, delta_v_n, dt_v, myThid, kbot)

 if (do_conserve_energy) then
    dt_u_temp = dt_u - dt_u_temp
    dt_v_temp = dt_v - dt_v_temp
    dissipative_heat = - cp_inv*( (u + half_delt*dt_u_temp)*dt_u_temp &
                                 +(v + half_delt*dt_v_temp)*dt_v_temp )
    dt_t = dt_t + dissipative_heat
 else
    dissipative_heat = 0.0
 endif

!-----------------------------------------------------------------------

end subroutine uv_vert_diff

!#######################################################################

subroutine tq_vert_diff (delt, mu, nu, t, q,  z_full, &
                         dsens_datmos, devap_datmos, sens, evap, &
                         dt_t, dt_q, myThid,  kbot)


real,    intent(in)                        :: delt
real,    intent(in)   , dimension(:,:,:)   :: t, q, z_full, mu, nu
real,    intent(in)   , dimension(:,:)     :: dsens_datmos, devap_datmos
real,    intent(inout), dimension(:,:)     :: sens, evap
real,    intent(inout), dimension(:,:,:)   :: dt_t, dt_q
integer, intent(in)                        :: myThid

integer, intent(in)   , dimension(:,:), optional :: kbot

real, dimension(size(t,1),size(t,2)) :: mu_delt_n, nu_n,          &
                                        e_n1, f_t_delt_n1, f_q_delt_n1, &
                                        delta_t_n, delta_q_n,      &
                                        flux1, dflux1_dsurf

real, dimension(size(t,1),size(t,2),size(t,3)-1) :: e, f_t, f_q
real, dimension(size(t,1),size(t,2),size(t,3)  ) :: tt

integer :: i, j, kb
real    :: gcp
!-----------------------------------------------------------------------

 gcp = GRAV/CP_air
 tt  = t + z_full*gcp

 call vert_diff_down_2 &
     (delt, mu, nu, tt, q, dt_t, dt_q, e, f_t, f_q,    &
      mu_delt_n, nu_n, e_n1, f_t_delt_n1, f_q_delt_n1, &
      delta_t_n, delta_q_n, myThid, kbot)


 call diff_surface (mu_delt_n, nu_n, e_n1, f_t_delt_n1,  &
                    dsens_datmos, sens, CP_air, delta_t_n, myThid)

 call diff_surface (mu_delt_n, nu_n, e_n1, f_q_delt_n1,  &
                    devap_datmos, evap, 1.0, delta_q_n, myThid)

 call vert_diff_up (delt, e, f_t, delta_t_n, dt_t, myThid, kbot)
 call vert_diff_up (delt, e, f_q, delta_q_n, dt_q, myThid, kbot)


!-----------------------------------------------------------------------

end subroutine tq_vert_diff

!#######################################################################

subroutine tr_vert_diff (delt, mu, nu, tr, flux, dt_tr, myThid, kbot )

real,    intent(in)                        :: delt
real,    intent(in)   , dimension(:,:,:)   :: mu, nu
real,    intent(in)   , dimension(:,:,:,:) :: tr
real,    intent(inout), dimension(:,:,:)   :: flux
real,    intent(inout), dimension(:,:,:,:) :: dt_tr
integer, intent(in)                        :: myThid

integer, intent(in)   , dimension(:,:), optional :: kbot

real, dimension(size(tr,1),size(tr,2)) :: mu_delt_n, nu_n, e_n1

real, dimension(size(tr,1),size(tr,2),size(tr,4)) :: f_delt_n1, delta_tr_n
real, dimension(size(tr,1),size(tr,2)) :: dflux_dtr

real, dimension(size(tr,1),size(tr,2),size(tr,3)-1,size(tr,4)) :: f

real, dimension(size(tr,1),size(tr,2),size(tr,3)-1) :: e
integer :: i, j, n, kb, ntr
character(len=128) :: scheme
logical, dimension(size(dt_tr,4)) :: skip_tracer_diff
!-----------------------------------------------------------------------

 ntr  = size(tr,4) ! number of prognostic tracers


 ! setup flags for tracer diffusion
 ! this could be moved to the initialization
 skip_tracer_diff(1:ntr) = .true.
 do n=1,ntr
   ! skip specific humidity (done separately)
     if ( n == sphum ) cycle
   ! skip tracers if diffusion scheme truned off
! jmc: --- need to do something ---
!    if (query_method('diff_vert',MODEL_ATMOS,n,scheme)) then
!        if(uppercase(trim(scheme)) == 'NONE') cycle
!    endif
     skip_tracer_diff(n) = .false.
 enddo


 dflux_dtr = 0.0

 call vert_diff_down_n &
     (delt, mu, nu, tr, dt_tr, e, f, mu_delt_n, nu_n,  &
      e_n1, f_delt_n1, delta_tr_n, myThid, skip_tracer_diff, kbot)

 do n = 1, ntr
   if (skip_tracer_diff(n)) cycle
   call diff_surface (mu_delt_n, nu_n, e_n1, f_delt_n1(:,:,n),  &
                      dflux_dtr, flux(:,:,n), 1.0, delta_tr_n(:,:,n), myThid)

   call vert_diff_up (delt, e, f(:,:,:,n), delta_tr_n(:,:,n),  &
                      dt_tr(:,:,:,n), myThid, kbot)
 end do

!-----------------------------------------------------------------------

end subroutine tr_vert_diff

!#######################################################################

subroutine vert_diff_down &
      (delt, mu, nu, tr, dt_tr, e, f, mu_delt_n, nu_n,  &
       e_n1, f_delt_n1, delta_tr_n, myThid, kbot)

!-----------------------------------------------------------------------

real,    intent(in)                         :: delt
real,    intent(in)    , dimension(:,:,:)   :: mu, nu
real,    intent(in)    , dimension(:,:,:)   :: tr
real,    intent(inout) , dimension(:,:,:)   :: dt_tr
real,    intent(out)   , dimension(:,:,:)   :: e
real,    intent(out)   , dimension(:,:,:)   :: f
real,    intent(out)   , dimension(:,:)     :: mu_delt_n, nu_n, e_n1
real,    intent(out)   , dimension(:,:)     :: f_delt_n1, delta_tr_n
integer, intent(in)                         :: myThid

integer, intent(in),    dimension(:,:), optional :: kbot

real, dimension(size(tr,1),size(tr,2),size(tr,3)) :: a, b, c, g

integer :: i, j, k, kb, nlev

!-----------------------------------------------------------------------

 call explicit_tend (mu, nu, tr, dt_tr, myThid)

 call compute_e  (delt, mu, nu, e, a, b, c, g, myThid)

 call compute_f (dt_tr, b, c, g, f, myThid)


 if (present(kbot)) then
    do j=1,size(tr,2)
    do i=1,size(tr,1)
        kb = kbot(i,j)
        mu_delt_n(i,j) =  mu(i,j,kb  )*delt
             nu_n(i,j) =  nu(i,j,kb  )
             e_n1(i,j) =   e(i,j,kb-1)
    enddo
    enddo
    do j=1,size(tr,2)
    do i=1,size(tr,1)
        kb = kbot(i,j)
         f_delt_n1(i,j) =     f(i,j,kb-1)*delt
        delta_tr_n(i,j) = dt_tr(i,j,kb  )*delt
    enddo
    enddo
 else
        nlev = size(mu,3)
        mu_delt_n(:,:) =       mu(:,:,nlev  )*delt
             nu_n(:,:) =       nu(:,:,nlev  )
             e_n1(:,:) =        e(:,:,nlev-1)
        f_delt_n1(:,:) =        f(:,:,nlev-1)*delt
       delta_tr_n(:,:) =    dt_tr(:,:,nlev  )*delt
 endif



!-----------------------------------------------------------------------

end subroutine vert_diff_down

!#######################################################################

subroutine vert_diff_down_2 &
      (delt, mu, nu, xi_1, xi_2, dt_xi_1, dt_xi_2, e, f_1, f_2, &
       mu_delt_n, nu_n, e_n1, f_1_delt_n1, f_2_delt_n1,         &
       delta_1_n, delta_2_n, myThid, kbot)

!-----------------------------------------------------------------------

real,    intent(in)                       :: delt
real,    intent(in)    , dimension(:,:,:) :: mu, nu, xi_1, xi_2
real,    intent(in)    , dimension(:,:,:) :: dt_xi_1, dt_xi_2
real,    intent(out)   , dimension(:,:,:) :: e, f_1, f_2
real,    intent(out)   , dimension(:,:)   :: mu_delt_n, nu_n, e_n1,    &
                                             f_1_delt_n1, f_2_delt_n1, &
                                             delta_1_n, delta_2_n
integer, intent(in)                       :: myThid

integer, intent(in),    dimension(:,:), optional :: kbot

real, dimension(size(xi_1,1),size(xi_1,2),size(xi_1,3)) :: a, b, c, g, &
                                                      dt_xi_11, dt_xi_22

integer :: i, j, k, kb, nlev

!-----------------------------------------------------------------------

! local copy of input
  dt_xi_11 = dt_xi_1
  dt_xi_22 = dt_xi_2

 call explicit_tend (mu, nu, xi_1, dt_xi_11, myThid)
 call explicit_tend (mu, nu, xi_2, dt_xi_22, myThid)

 call compute_e (delt, mu, nu, e, a, b, c, g, myThid)

 call compute_f (dt_xi_11, b, c, g, f_1, myThid)
 call compute_f (dt_xi_22, b, c, g, f_2, myThid)

 if (present(kbot)) then
    do j=1,size(xi_1,2)
    do i=1,size(xi_1,1)
        kb = kbot(i,j)
        mu_delt_n(i,j)  =      mu(i,j,kb  )*delt
             nu_n(i,j)  =      nu(i,j,kb  )
            e_n1(i,j)  =       e(i,j,kb-1)
     f_1_delt_n1(i,j)  =     f_1(i,j,kb-1)*delt
     f_2_delt_n1(i,j)  =     f_2(i,j,kb-1)*delt
        delta_1_n(i,j)  = dt_xi_11(i,j,kb  )*delt
        delta_2_n(i,j)  = dt_xi_22(i,j,kb  )*delt
    enddo
    enddo
 else
        nlev = size(mu,3)
        mu_delt_n(:,:)  =      mu(:,:,nlev  )*delt
             nu_n(:,:)  =      nu(:,:,nlev  )
            e_n1(:,:)  =       e(:,:,nlev-1)
     f_1_delt_n1(:,:)  =     f_1(:,:,nlev-1)*delt
     f_2_delt_n1(:,:)  =     f_2(:,:,nlev-1)*delt
        delta_1_n(:,:)  = dt_xi_11(:,:,nlev  )*delt
        delta_2_n(:,:)  = dt_xi_22(:,:,nlev  )*delt
 endif



!-----------------------------------------------------------------------

end subroutine vert_diff_down_2

!#######################################################################

subroutine vert_diff_down_n &
      (delt, mu, nu, tr, dt_tr, e, f, mu_delt_n, nu_n,  &
       e_n1, f_delt_n1, delta_tr_n, myThid, skip, kbot)

!-----------------------------------------------------------------------

real,    intent(in)                         :: delt
real,    intent(in)    , dimension(:,:,:)   :: mu, nu
real,    intent(in)    , dimension(:,:,:,:) :: tr
real,    intent(inout) , dimension(:,:,:,:) :: dt_tr
real,    intent(out)   , dimension(:,:,:)   :: e
real,    intent(out)   , dimension(:,:,:,:) :: f
real,    intent(out)   , dimension(:,:)     :: mu_delt_n, nu_n, e_n1
real,    intent(out)   , dimension(:,:,:)   :: f_delt_n1, delta_tr_n
integer, intent(in)                         :: myThid

logical, intent(in),    dimension(:),   optional :: skip
integer, intent(in),    dimension(:,:), optional :: kbot

real, dimension(size(tr,1),size(tr,2),size(tr,3)) :: a, b, c, g

integer :: i, j, k, n, kb, nlev, ntr

!-----------------------------------------------------------------------

  ntr = size(tr,4)

 call compute_e  (delt, mu, nu, e, a, b, c, g, myThid)

 do n = 1, ntr
   if (present(skip)) then
       if(skip(n)) cycle
   endif
   call explicit_tend (mu, nu, tr(:,:,:,n), dt_tr(:,:,:,n), myThid)
   call compute_f (dt_tr(:,:,:,n), b, c, g, f(:,:,:,n), myThid)
 end do


 if (present(kbot)) then
    do j=1,size(tr,2)
    do i=1,size(tr,1)
        kb = kbot(i,j)
        mu_delt_n(i,j) =  mu(i,j,kb  )*delt
             nu_n(i,j) =  nu(i,j,kb  )
            e_n1(i,j) =   e(i,j,kb-1)
    enddo
    enddo
    do n=1,size(tr,4)
    if (present(skip)) then
       if(skip(n)) cycle
    endif
    do j=1,size(tr,2)
    do i=1,size(tr,1)
        kb = kbot(i,j)
       f_delt_n1(i,j,n)  =     f(i,j,kb-1,n)*delt
       delta_tr_n(i,j,n) = dt_tr(i,j,kb  ,n)*delt
    enddo
    enddo
    enddo
 else
    nlev = size(mu,3)
    mu_delt_n(:,:)  =  mu(:,:,nlev  )*delt
         nu_n(:,:)  =  nu(:,:,nlev  )
         e_n1(:,:)  =   e(:,:,nlev-1)
    do n=1,size(tr,4)
      if (present(skip)) then
          if(skip(n)) cycle
      endif
       f_delt_n1(:,:,n) =     f(:,:,nlev-1,n)*delt
      delta_tr_n(:,:,n) = dt_tr(:,:,nlev  ,n)*delt
    enddo
 endif



!-----------------------------------------------------------------------

end subroutine vert_diff_down_n

!#######################################################################

subroutine diff_surface (mu_delt, nu, e_n1, f_delt_n1,  &
                         dflux_datmos, flux, factor, delta_xi, myThid)

!-----------------------------------------------------------------------

real, intent(in)   , dimension(:,:) :: mu_delt, nu, e_n1, f_delt_n1,  &
                                       dflux_datmos
real, intent(inout), dimension(:,:) :: flux, delta_xi
real, intent(in) :: factor
integer, intent(in)                 :: myThid

!-----------------------------------------------------------------------

 real, dimension(size(flux,1),size(flux,2)) :: dflux
 real :: fff

 fff = 1.0/factor

 dflux    = - nu*(1.0 - e_n1)
 delta_xi = delta_xi + mu_delt*nu*f_delt_n1

 delta_xi = (delta_xi + mu_delt*flux*fff)/&
                      (1.0 - mu_delt*(dflux + dflux_datmos*fff))

 flux     = flux + dflux_datmos*delta_xi


!-----------------------------------------------------------------------

end subroutine diff_surface

!#######################################################################

subroutine vert_diff_up (delt, e, f, delta_xi_n, dt_xi, myThid, kbot)

!-----------------------------------------------------------------------

real,    intent(in)                      :: delt
real,    intent(in),    dimension(:,:,:) :: e, f
real,    intent(in) ,   dimension(:,:)   :: delta_xi_n
real,    intent(out),   dimension(:,:,:) :: dt_xi
integer, intent(in)                      :: myThid
integer, intent(in),    dimension(:,:), optional :: kbot

integer :: i, j, k, kb, nlev
!-----------------------------------------------------------------------

 if (present(kbot)) then
     do j = 1, size(dt_xi,2)
     do i = 1, size(dt_xi,1)
         kb = kbot(i,j)
         dt_xi(i,j,kb) = delta_xi_n(i,j)/delt
         do k = kb -1, 1, -1
           dt_xi(i,j,k) = e(i,j,k)*dt_xi(i,j,k+1) + f(i,j,k)
         end do
     end do
     end do
 else
    nlev = size(dt_xi,3)
    dt_xi(:,:,nlev) = delta_xi_n/delt
    do k = size(dt_xi,3)-1, 1, -1
      dt_xi(:,:,k) = e(:,:,k)*dt_xi(:,:,k+1) + f(:,:,k)
    end do
 endif

!-----------------------------------------------------------------------

end subroutine vert_diff_up

!#######################################################################

subroutine compute_e (delt, mu, nu, e, a, b, c, g, myThid)

!-----------------------------------------------------------------------

real,    intent(in)                       :: delt
real,    intent(in)    , dimension(:,:,:) :: mu, nu
real,    intent(out)   , dimension(:,:,:) :: e, a, b, c, g
integer, intent(in)                       :: myThid

integer :: k, nlev

!-----------------------------------------------------------------------

 nlev = size(mu,3)

 a(:,:,1:nlev-1) = - mu(:,:,1:nlev-1)*nu(:,:,2:nlev)*delt
 a(:,:,nlev    ) =   0.0
 c(:,:,2:nlev  ) = - mu(:,:,2:nlev  )*nu(:,:,2:nlev)*delt
 c(:,:,1       ) =   0.0

 b = 1.0 - a - c

 e(:,:,1)   =   - a(:,:,1)/b(:,:,1)
 do  k= 2, nlev - 1
    g(:,:,k) = 1.0/(b(:,:,k) + c(:,:,k)*e(:,:,k-1))
    e(:,:,k) = - a(:,:,k)*g(:,:,k)
 enddo

!-----------------------------------------------------------------------

end subroutine compute_e

!#######################################################################

subroutine compute_f (dt_xi, b, c, g, f, myThid)

!-----------------------------------------------------------------------
real,    intent(in)    , dimension(:,:,:) :: dt_xi, b, c, g
real,    intent(out)   , dimension(:,:,:) :: f
integer, intent(in)                       :: myThid

integer :: k
!-----------------------------------------------------------------------

 f(:,:,1) =   dt_xi(:,:,1)/b(:,:,1)

 do  k = 2, size(b,3)-1
    f(:,:,k) = (dt_xi(:,:,k) - c(:,:,k)*f(:,:,k-1))*g(:,:,k)
 enddo

!-----------------------------------------------------------------------

end subroutine compute_f

!#######################################################################

subroutine explicit_tend (mu, nu, xi, dt_xi, myThid)

!-----------------------------------------------------------------------

real,    intent(in)    , dimension(:,:,:) :: mu, nu, xi
real,    intent(inout) , dimension(:,:,:) :: dt_xi
integer, intent(in)                       :: myThid

real, dimension(size(xi,1),size(xi,2),size(xi,3)) :: fluxx

integer :: k, nlev

!-----------------------------------------------------------------------

 nlev = size(mu,3)

 fluxx(:,:,1)      = 0.0
 fluxx(:,:,2:nlev) = nu(:,:,2:nlev)*(xi(:,:,2:nlev) - xi(:,:,1:nlev-1))

 dt_xi(:,:,1:nlev-1) = dt_xi(:,:,1:nlev-1) +  &
    mu(:,:,1:nlev-1)*(fluxx(:,:,2:nlev) - fluxx(:,:,1:nlev-1))
 dt_xi(:,:,nlev)     = dt_xi(:,:,nlev) - mu(:,:,nlev)*fluxx(:,:,nlev)

!-----------------------------------------------------------------------

end subroutine explicit_tend

!#######################################################################

subroutine compute_mu (p_half, mu, myThid)

!-----------------------------------------------------------------------
real,    intent(in)    , dimension(:,:,:) :: p_half
real,    intent(out)   , dimension(:,:,:) :: mu
integer, intent(in)                       :: myThid

integer :: nlev
!-----------------------------------------------------------------------

nlev = size(mu,3)

mu(:,:,1:nlev) = GRAV / (p_half(:,:,2:nlev+1) -p_half(:,:,1:nlev))

!-----------------------------------------------------------------------

end subroutine compute_mu


!#######################################################################

subroutine compute_nu (diff, p_half, p_full, z_full, t, q, nu, myThid)

!-----------------------------------------------------------------------
real,    intent(in)    , dimension(:,:,:) :: diff, p_half, p_full, &
                                             z_full, t, q
real,    intent(out)   , dimension(:,:,:) :: nu
integer, intent(in)                       :: myThid

real, dimension(size(t,1),size(t,2),size(t,3)) :: rho_half, tt
integer :: nlev
!-----------------------------------------------------------------------

nlev = size(nu,3)

if ( use_virtual_temp_vert_diff ) then
  tt = t * (1.0 + d608*q)           ! virtual temperature
else
  tt = t ! Take out virtual temperature effect here to mimic supersource
endif

rho_half(:,:,2:nlev) =  &         ! density at half levels
      2.0*p_half(:,:,2:nlev)/(RDGAS*(tt(:,:,2:nlev)+tt(:,:,1:nlev-1)))

if(do_mcm_plev) then
  nu(:,:,2:nlev) = GRAV*rho_half(:,:,2:nlev)*rho_half(:,:,2:nlev)*diff(:,:,2:nlev)/ &
                    (p_full(:,:,2:nlev)-p_full(:,:,1:nlev-1))
else
  nu(:,:,2:nlev) = rho_half(:,:,2:nlev)*diff(:,:,2:nlev) /  &
                    (z_full(:,:,1:nlev-1)-z_full(:,:,2:nlev))
endif
!-----------------------------------------------------------------------

end subroutine compute_nu

!#######################################################################

end module vert_diff_mod

#define EXACT_CONSERV
#include "PACKAGES_CONFIG.h"
#include "CPP_OPTIONS.h"
#ifdef ALLOW_MOM_COMMON
# include "MOM_COMMON_OPTIONS.h"
#endif
#ifdef ALLOW_CTRL
# include "CTRL_OPTIONS.h"
#endif

CBOP
C     !ROUTINE: CONFIG_CHECK
C     !INTERFACE:
      SUBROUTINE CONFIG_CHECK( myThid )
C     !DESCRIPTION: \bv
C     *=========================================================*
C     | SUBROUTINE CONFIG_CHECK
C     | o Check model parameter settings.
C     *=========================================================*
C     | This routine help to prevent the use of parameters
C     | that are not compatible with the model configuration.
C     *=========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#ifdef ALLOW_MOM_COMMON
# include "MOM_VISC.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     myThid   ::  my Thread Id number
      INTEGER myThid

C     !LOCAL VARIABLES:
C     msgBuf   :: Informational/error message buffer
C     errCount :: error counter (inconsitent params and other errors)
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      INTEGER errCount
CEOP

      _BEGIN_MASTER(myThid)
      WRITE(msgBuf,'(A)')
     &'// ======================================================='
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)') '// Check Model config. (CONFIG_CHECK):'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      _END_MASTER(myThid)

C--   MPI + multi-threads: seems to be OK to let master-thread check & stop
C      (as long as all procs finish cleanly by calling ALL_PROC_DIE)
      _BEGIN_MASTER(myThid)
      errCount = 0

C-  check that CPP option is "defined" when running-flag parameter is on:

#ifndef INCLUDE_CONVECT_CALL
C     o Check that Convective-adjustment code is compiled If cAdjFreq <> 0
      IF ( cAdjFreq .NE. 0. ) THEN
#ifdef INCLUDE_CONVECT_INI_CALL
        WRITE(msgBuf,'(2A)') '** Warning ** CONFIG_CHECK: ',
     &  'Convective-Adjustment (cAdjFreq) turned off (except INI)'
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
        WRITE(msgBuf,'(2A)') '** Warning ** CONFIG_CHECK: ',
     &  ' without "#define INCLUDE_CONVECT_CALL" in CPP_OPTIONS.h'
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
#else
        WRITE(msgBuf,'(2A)') 'CONFIG_CHECK: ',
     &  'Cannot use Convective-Adjustment (cAdjFreq) without'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(2A)') 'CONFIG_CHECK: ',
     &  ' defining INCLUDE_CONVECT_(CALL/INI_CALL) in CPP_OPTIONS.h'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
#endif
      ENDIF
#endif /* ndef INCLUDE_CONVECT_CALL */

C     o If diffKrFile is set, then we should make sure the corresponing
C       code is being compiled
#ifndef ALLOW_3D_DIFFKR
      IF (diffKrFile.NE.' ') THEN
        WRITE(msgBuf,'(A)')
     &  'CONFIG_CHECK: diffKrFile is set but never used.'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(2A)') 'CONFIG_CHECK: ',
     &  'Re-compile with: "#define ALLOW_3D_DIFFKR"'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF
#endif

#ifdef EXCLUDE_PCELL_MIX_CODE
      IF ( interDiffKr_pCell .OR. interViscAr_pCell
     &                       .OR. pCellMix_select.NE.0 ) THEN
        IF ( interDiffKr_pCell ) THEN
          WRITE(msgBuf,'(2A)') 'CONFIG_CHECK: ',
     &    'Cannot use interDiffKr_pCell=.TRUE.'
          CALL PRINT_ERROR( msgBuf, myThid )
        ENDIF
        IF ( interViscAr_pCell ) THEN
          WRITE(msgBuf,'(2A)') 'CONFIG_CHECK: ',
     &    'Cannot use interViscAr_pCell=.TRUE.'
          CALL PRINT_ERROR( msgBuf, myThid )
        ENDIF
        IF ( pCellMix_select.NE.0 ) THEN
          WRITE(msgBuf,'(2A,I6)') 'CONFIG_CHECK: ',
     &    'Cannot use pCellMix_select=', pCellMix_select
          CALL PRINT_ERROR( msgBuf, myThid )
        ENDIF
        WRITE(msgBuf,'(2A)') 'CONFIG_CHECK: when compiled ',
     &  'with "#define EXCLUDE_PCELL_MIX_CODE" in CPP_OPTIONS.h'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF
#endif

#ifndef ALLOW_LEITH_QG
C     Check that Leith QG viscosity coefficeint is zero if the
C     QGLeith code has not been compiled.
      IF ( viscC2LeithQG.NE.zeroRL )  THEN
        WRITE(msgBuf,'(2A)') 'CONFIG_CHECK: ',
     &  'must #define ALLOW_LEITH_QG in MOM_COMMON_OPTIONS.h'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(2A)') 'CONFIG_CHECK: ',
     &  ' in order to use QG-Leith (viscC2LeithQG > 0)'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF
#endif /* ALLOW_LEITH_QG */

#ifndef ALLOW_SMAG_3D
      IF ( useSmag3D ) THEN
        WRITE(msgBuf,'(2A)') 'CONFIG_CHECK: ',
     &  'Cannot set useSmag3D=TRUE when compiled with'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(2A)') 'CONFIG_CHECK: ',
     &  '"#undef ALLOW_SMAG_3D" in MOM_COMMON_OPTIONS.h'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF
#endif
#ifndef ALLOW_SMAG_3D_DIFFUSIVITY
      IF ( smag3D_diffCoeff.NE.zeroRL ) THEN
        WRITE(msgBuf,'(2A)') 'CONFIG_CHECK: ',
     &  'Cannot use smag3D_diffCoeff > 0 when compiled with'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(2A)') 'CONFIG_CHECK: ',
     &  '"#undef ALLOW_SMAG_3D_DIFFUSIVITY" in CPP_OPTIONS.h'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF
#endif

#ifndef ALLOW_NONHYDROSTATIC
      IF (use3Dsolver) THEN
        WRITE(msgBuf,'(A)')
     &   'CONFIG_CHECK: #undef ALLOW_NONHYDROSTATIC and'
        CALL PRINT_ERROR( msgBuf, myThid )
       IF ( implicitIntGravWave ) WRITE(msgBuf,'(A)')
     &   'CONFIG_CHECK: implicitIntGravWave is TRUE'
       IF ( nonHydrostatic ) WRITE(msgBuf,'(A)')
     &   'CONFIG_CHECK: nonHydrostatic is TRUE'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF
#endif

#ifndef ALLOW_QHYD_STAGGER_TS
      IF ( quasiHydrostatic .AND. staggerTimeStep ) THEN
        WRITE(msgBuf,'(2A)') 'CONFIG_CHECK: ',
     &    'Cannot use quasiHydrostatic with staggerTimeStep'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(2A)') 'CONFIG_CHECK: when compiled ',
     &  'with "#undef ALLOW_QHYD_STAGGER_TS" in CPP_OPTIONS.h'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF
#endif

#ifndef ALLOW_ADAMSBASHFORTH_3
      IF ( alph_AB.NE.UNSET_RL .OR. beta_AB.NE.UNSET_RL ) THEN
        WRITE(msgBuf,'(2A)') 'CONFIG_CHECK: ',
     &   '#undef ALLOW_ADAMSBASHFORTH_3 but alph_AB,beta_AB'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(A,1P2E20.7)')
     &   'CONFIG_CHECK: are set to:',alph_AB,beta_AB
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF
#endif

#ifndef INCLUDE_IMPLVERTADV_CODE
      IF ( momImplVertAdv ) THEN
        WRITE(msgBuf,'(A)')
     &   'CONFIG_CHECK: #undef INCLUDE_IMPLVERTADV_CODE'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(A)')
     &   'CONFIG_CHECK: but momImplVertAdv is TRUE'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF
      IF ( tempImplVertAdv ) THEN
        WRITE(msgBuf,'(A)')
     &   'CONFIG_CHECK: #undef INCLUDE_IMPLVERTADV_CODE'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(A)')
     &   'CONFIG_CHECK: but tempImplVertAdv is TRUE'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF
      IF ( saltImplVertAdv ) THEN
        WRITE(msgBuf,'(A)')
     &   'CONFIG_CHECK: #undef INCLUDE_IMPLVERTADV_CODE'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(A)')
     &   'CONFIG_CHECK: but saltImplVertAdv is TRUE'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF
      IF ( dTtracerLev(1).NE.dTtracerLev(Nr) .AND. implicitDiffusion
     &     .AND. ( saltStepping .OR. tempStepping .OR. usePTRACERS )
     &   ) THEN
        WRITE(msgBuf,'(A)')
     &   'CONFIG_CHECK: #undef INCLUDE_IMPLVERTADV_CODE'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(2A)') 'CONFIG_CHECK: ',
     &   'but implicitDiffusion=T with non-uniform dTtracerLev'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF
      IF ( selectImplicitDrag.GT.0 ) THEN
        WRITE(msgBuf,'(2A)') 'CONFIG_CHECK: ',
     &   'Needs to compile with #define INCLUDE_IMPLVERTADV_CODE'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(A)')
     &   'CONFIG_CHECK:  to use selectImplicitDrag > 0 ==> STOP here'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF
#endif

#ifndef ALLOW_SOLVE4_PS_AND_DRAG
      IF ( selectImplicitDrag.EQ.2 ) THEN
        WRITE(msgBuf,'(2A)') 'CONFIG_CHECK: ',
     &   'Needs to compile with #define ALLOW_SOLVE4_PS_AND_DRAG'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(A)')
     &   'CONFIG_CHECK:  to use selectImplicitDrag = 2 ==> STOP here'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF
#endif

#ifdef ALLOW_AUTODIFF
      IF ( momImplVertAdv ) THEN
        WRITE(msgBuf,'(A)')
     &   'CONFIG_CHECK: momImplVertAdv is not yet'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(A)')
     &   'CONFIG_CHECK: supported in adjoint mode'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF
      IF ( selectImplicitDrag.GT.0 ) THEN
        WRITE(msgBuf,'(A)')
     &   'CONFIG_CHECK: selectImplicitDrag is not yet'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(A)')
     &   'CONFIG_CHECK: supported in adjoint mode'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF
#endif

#ifdef ALLOW_DEPTH_CONTROL
      IF ( useOBCS ) THEN
        WRITE(msgBuf,'(A)')
     &   'CONFIG_CHECK: DEPTH_CONTROL code not compatible with OBCS'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF
#endif

#ifndef EXACT_CONSERV
c     IF ( exactConserv ) THEN
        WRITE(msgBuf,'(2A)') 'CONFIG_CHECK: ',
     &   '#undef EXACT_CONSERV not allowed in CPP_OPTIONS.h'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(2A)') 'CONFIG_CHECK: ',
     &   ' since CPP option EXACT_CONSERV has been retired'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
c     ENDIF
#endif

#ifndef NONLIN_FRSURF
      IF (nonlinFreeSurf.NE.0) THEN
        WRITE(msgBuf,'(A)')
     &   'CONFIG_CHECK: #undef NONLIN_FRSURF and'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(A)')
     &   'CONFIG_CHECK: nonlinFreeSurf is non-zero'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF
#endif

#ifndef NONLIN_FRSURF
      IF (select_rStar .NE. 0) THEN
        WRITE(msgBuf,'(A)')
     &   'CONFIG_CHECK: rStar is part of NonLin-FS '
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(A)')
     &   'CONFIG_CHECK: ==> set #define NONLIN_FRSURF to use it'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF
#endif /* NONLIN_FRSURF */

#ifdef DISABLE_RSTAR_CODE
      IF ( select_rStar.NE.0 ) THEN
        WRITE(msgBuf,'(A)')
     &   'CONFIG_CHECK: rStar code disable (DISABLE_RSTAR_CODE defined)'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(A)')
     &   'CONFIG_CHECK: ==> set #undef DISABLE_RSTAR_CODE to use it'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF
#endif /* DISABLE_RSTAR_CODE */

#ifdef DISABLE_SIGMA_CODE
      IF ( selectSigmaCoord.NE.0 ) THEN
        WRITE(msgBuf,'(A)')
     &   'CONFIG_CHECK: Sigma code disable (DISABLE_SIGMA_CODE defined)'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(A)')
     &   'CONFIG_CHECK: ==> set #undef DISABLE_SIGMA_CODE to use it'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF
#endif /* DISABLE_SIGMA_CODE */

#ifdef USE_NATURAL_BCS
        WRITE(msgBuf,'(A)')
     &   'CONFIG_CHECK: USE_NATURAL_BCS option has been replaced'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(A)')
     &   'CONFIG_CHECK: by useRealFreshWaterFlux=TRUE in data file'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
#endif

#ifndef ALLOW_ADDFLUID
      IF ( selectAddFluid.NE.0 ) THEN
        WRITE(msgBuf,'(A)')
     &   'CONFIG_CHECK: #undef ALLOW_ADDFLUID (CPP_OPTIONS.h) and'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(A,I4,A)') 'CONFIG_CHECK: selectAddFluid=',
     &                           selectAddFluid, ' is not zero'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF
#endif /* ALLOW_ADDFLUID */

C     o If pLoadFile is set, then we should make sure the corresponing
C       code is being compiled
#ifndef ATMOSPHERIC_LOADING
      IF (pLoadFile.NE.' ') THEN
        WRITE(msgBuf,'(A)')
     &  'CONFIG_CHECK: pLoadFile is set but you have not'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(A)')
     &  ' compiled the model with the pressure loading code.'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(A)')
     &  ' Re-compile with: "#define ATMOSPHERIC_LOADING"'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF
      IF ( useRealFreshWaterFlux .AND. useThSIce ) THEN
        WRITE(msgBuf,'(A)')
     &  'CONFIG_CHECK: sIceLoad is computed but'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(A)')
     &  ' pressure loading code is not compiled.'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(A)')
     &  ' Re-compile with: "#define ATMOSPHERIC_LOADING"'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF
#endif

      IF ( geothermalFile.NE.' ' ) THEN
C     o Need to use S/R APPLY_FORCING_T to get Geothermal forcing
#ifdef USE_OLD_EXTERNAL_FORCING
        WRITE(msgBuf,'(2A)') 'CONFIG_CHECK: ',
     &  'geothermalFile is set but Geothermal-Flux code'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(2A)')' is missing.',
     &  ' Re-compile with "#undef USE_OLD_EXTERNAL_FORCING"'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
#endif /* USE_OLD_EXTERNAL_FORCING */
C     o Need to define ALLOW_GEOTHERMAL_FLUX to use geothermalFile forcing
#ifndef ALLOW_GEOTHERMAL_FLUX
        WRITE(msgBuf,'(2A)') 'CONFIG_CHECK: ',
     &  'geothermalFile is set but Geothermal-Flux code'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(2A)')' is not compiled.',
     &  ' Re-compile with "#define ALLOW_GEOTHERMAL_FLUX"'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
#endif /* ALLOW_GEOTHERMAL_FLUX */
      ENDIF

C     o Need to use S/R APPLY_FORCING_U,V to get Tidal forcing
#ifdef USE_OLD_EXTERNAL_FORCING
      IF ( momTidalForcing ) THEN
        WRITE(msgBuf,'(2A)') 'CONFIG_CHECK: ',
     &  'momTidalForcing is set but Tidal forcing code'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(2A)')' is missing.',
     &  ' Re-compile with "#undef USE_OLD_EXTERNAL_FORCING"'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF
#endif /* USE_OLD_EXTERNAL_FORCING */

#ifndef ALLOW_FRICTION_HEATING
      IF ( addFrictionHeating ) THEN
        WRITE(msgBuf,'(2A)') 'CONFIG_CHECK: addFrictionHeating=T',
     &   ' but FRICTIONAL_HEATING code is not compiled.'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(2A)') 'CONFIG_CHECK: Re-compile with:',
     &   ' "#define ALLOW_FRICTION_HEATING" (CPP_OPTIONS.h)'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF
#endif

#ifdef SHORTWAVE_HEATING
      IF ( fluidIsAir .AND. selectPenetratingSW.GT.0 ) THEN
        WRITE(msgBuf,'(2A)') 'CONFIG_CHECK:',
     &   ' Water column short wave heating (selectPenetratingSW>0)'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(2A)') 'CONFIG_CHECK:',
     &   '  cannot be used in Atmospheric setup (fluidIsAir=T)'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF
#else /* SHORTWAVE_HEATING */
      IF ( selectPenetratingSW.GT.0 ) THEN
        WRITE(msgBuf,'(2A)') 'CONFIG_CHECK: selectPenetratingSW>0',
     &   ' but SHORTWAVE_HEATING code is not compiled.'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(2A)') 'CONFIG_CHECK: Re-compile with:',
     &   ' "#define SHORTWAVE_HEATING" (CPP_OPTIONS.h)'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF
#endif /* SHORTWAVE_HEATING */

#ifdef ALLOW_BALANCE_FLUXES
      IF ( selectBalanceEmPmR.LT.0 .OR. selectBalanceEmPmR.GT.2 ) THEN
        WRITE(msgBuf,'(2A,I6,A)') 'CONFIG_CHECK: ',
     &   'selectBalanceEmPmR=', selectBalanceEmPmR,' : invalid value'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF
#else /* ALLOW_BALANCE_FLUXES */
      IF ( selectBalanceEmPmR.NE.0 .OR. balanceQnet ) THEN
        WRITE(msgBuf,'(A,A)')
     &  'CONFIG_CHECK: balanceEmPmR/Qnet is set but balance code ',
     &  'is not compiled.'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(2A)') 'CONFIG_CHECK: ',
     &  'Re-compile with:  ALLOW_BALANCE_FLUXES defined'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF
#endif /* ALLOW_BALANCE_FLUXES */

#ifndef ALLOW_BALANCE_RELAX
      IF (balanceThetaClimRelax .OR. balanceSaltClimRelax) THEN
        WRITE(msgBuf,'(A,A)')
     &  'CONFIG_CHECK: balanceTheta/SaltClimRelax is set ',
     &  'but balance code is not compiled.'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(2A)') 'CONFIG_CHECK: ',
     &  'Re-compile with  ALLOW_BALANCE_RELAX defined'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF
#endif

#ifndef ALLOW_CG2D_NSA
      IF (useNSACGSolver) THEN
        WRITE(msgBuf,'(A,A)')
     &  'CONFIG_CHECK: useNSACGSolver = .TRUE., but CG2D_NSA ',
     &  'code is not compiled.'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(A)')
     &  'CONFIG_CHECK: Re-compile with ALLOW_CG2D_NSA defined'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF
#endif /* ALLOW_CG2D_NSA */

#ifndef ALLOW_SRCG
      IF (useSRCGSolver) THEN
        WRITE(msgBuf,'(A,A)')
     &  'CONFIG_CHECK: useSRCGSolver = .TRUE., but single reduction ',
     &  'code is not compiled.'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(A)')
     &  'CONFIG_CHECK: Re-compile with ALLOW_SRCG defined'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF
#endif /* ALLOW_SRCG */

#ifndef ALLOW_BOTTOMDRAG_ROUGHNESS
      IF (zRoughBot .GT. 0.) THEN
        WRITE(msgBuf,'(A,A)') 'CONFIG_CHECK: zRoughBot > 0.',
     &  ' but bottom drag code for roughness length is not compiled'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(2A)') 'CONFIG_CHECK: Re-compile with',
     &  ' #define ALLOW_BOTTOMDRAG_ROUGHNESS (MOM_COMMON_OPTIONS.h)'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF
#endif /* ALLOW_BOTTOMDRAG_ROUGHNESS */

      IF ( useNSACGSolver .AND. useSRCGSolver ) THEN
        WRITE(msgBuf,'(A,A)')
     &      'CONFIG_CHECK: both useNSACGSolver and ',
     &      'useSRCGSolver = .TRUE., this is not allowed.'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C--   Check parameter consistency :

      IF ( ( OLx.LT.2 .OR. OLy.LT.2 ) .AND. momStepping ) THEN
C-    Current algorithm (solve_for_pressure, RHS) prevents to use
C     momAdvection or viscAh > 0 with OLx,y=1 ; it should still allow us
C     to use OLx,y=1 when momAdvection=F and viscAh=0 but some loop range
C     in few momentum S/R are not carefully set to support this.
        WRITE(msgBuf,'(A,A)') 'CONFIG_CHECK: Cannot use momStepping',
     &  ' with overlap (OLx,OLy) smaller than 2'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF
      IF ( ( OLx.LT.3 .OR. OLy.LT.3 ) .AND.
     &     ( viscC4leithD.NE.0.  .OR. viscC4leith.NE.0.
     &     .OR. viscC4smag.NE.0. .OR. viscA4Grid.NE.0.
     &     .OR. viscA4D.NE.0.    .OR. viscA4Z.NE.0. ) ) THEN
        WRITE(msgBuf,'(A,A)')
     &  'CONFIG_CHECK: cannot use Biharmonic Visc. (viscA4) with',
     &  ' overlap (OLx,OLy) smaller than 3'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF
      IF ( ( OLx.LT.3 .OR. OLy.LT.3 ) .AND.
     &     ( viscC2leithD.NE.0. .OR. viscC4leithD.NE.0. .OR.
     &       viscC2LeithQG.NE.0.)
     &   ) THEN
        WRITE(msgBuf,'(A,A)')
     &  'CONFIG_CHECK: cannot use Leith Visc.(div.part or QG) with',
     &  ' overlap (OLx,OLy) smaller than 3'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF
      IF ( ( OLx.LT.3 .OR. OLy.LT.3 ) .AND.
     &     useSmag3D .AND. useCDscheme ) THEN
        WRITE(msgBuf,'(A,A)')
     &  'CONFIG_CHECK: cannot use Smag-3D + CD-scheme with',
     &  ' overlap (OLx,OLy) smaller than 3'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF

      IF ( ( viscC4leithD.NE.0. .OR. viscC4leith.NE.0. .OR.
     &       viscC2leithD.NE.0. .OR. viscC2leith.NE.0.)
     &     .AND. (viscC2LeithQG.NE.0) ) THEN
        WRITE(msgBuf,'(A,A)')
     &  'CONFIG_CHECK: cannot use LeithQG in conjunction with',
     &  ' either standard Leith or LeithD'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF

#ifndef DISCONNECTED_TILES
C     Overlaps cannot be larger than interior tile except for special cases
      IF ( sNx.LT.OLx ) THEN
#ifdef ALLOW_EXCH2
       WRITE(msgBuf,'(A)')
     &  'CONFIG_CHECK: sNx<OLx not allowed with ALLOW_EXCH2 defined'
       CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
#endif /* ALLOW_EXCH2 */
       IF ( Nx.NE.1 ) THEN
        WRITE(msgBuf,'(A)')
     &  'CONFIG_CHECK: sNx<OLx not allowed unless Nx=1'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
       ENDIF
      ENDIF
      IF ( sNy.LT.OLy ) THEN
#ifdef ALLOW_EXCH2
       WRITE(msgBuf,'(A)')
     &  'CONFIG_CHECK: sNy<OLy not allowed with ALLOW_EXCH2 defined'
       CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
#endif /* ALLOW_EXCH2 */
       IF ( Ny.NE.1 ) THEN
        WRITE(msgBuf,'(A)')
     &  'CONFIG_CHECK: sNy<OLy not allowed unless Ny=1'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
       ENDIF
      ENDIF
#endif /* ndef DISCONNECTED_TILES */

C--   Gravity vertical profile limitations:
      IF ( usingPCoords .AND. gravityFile .NE. ' ' ) THEN
        WRITE(msgBuf,'(A,A)') 'CONFIG_CHECK: Variable gravity',
     &  ' not yet implemented for P-coordinate'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF
      IF ( select_rStar.NE.0 .AND. gravityFile .NE. ' ' ) THEN
        WRITE(msgBuf,'(A,A)') 'CONFIG_CHECK: Variable gravity',
     &  ' not yet implemented with rStar'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF

C--   Deep-Atmosphere & Anelastic limitations:
      IF ( deepAtmosphere .AND.
     &     useRealFreshWaterFlux .AND. usingPCoords ) THEN
        WRITE(msgBuf,'(A,A)')
     &  'CONFIG_CHECK: Deep-Atmosphere not yet implemented with',
     &  ' real-Fresh-Water option in P-coordinate'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF
      IF ( select_rStar.NE.0 .AND.
     &        ( deepAtmosphere .OR.
     &          usingZCoords.AND.rhoRefFile .NE. ' ' ) ) THEN
        WRITE(msgBuf,'(A,A)')
     &  'CONFIG_CHECK: Deep-Atmosphere or Anelastic',
     &  ' not yet implemented with rStar'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF

C--   Free-surface related limitations:
      IF ( cg2dUseMinResSol.LT.0 .OR. cg2dUseMinResSol.GT.1 ) THEN
        WRITE(msgBuf,'(A,I10,A)')
     &   'CONFIG_CHECK: cg2dUseMinResSol set to unvalid value(=',
     &                  cg2dUseMinResSol, ')'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF

      IF ( rigidLid .AND. implicitFreeSurface ) THEN
        WRITE(msgBuf,'(A,A)')
     &  'CONFIG_CHECK: Cannot select both implicitFreeSurface',
     &  ' and rigidLid.'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF

      IF ( rigidLid .AND. exactConserv ) THEN
        WRITE(msgBuf,'(A)')
     &   'CONFIG_CHECK: exactConserv not compatible with'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(A)')
     &   'CONFIG_CHECK: rigidLid (meaningless in that case)'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF

      IF ( linFSConserveTr .AND. nonlinFreeSurf.NE.0 ) THEN
        WRITE(msgBuf,'(A)')
     &   'CONFIG_CHECK: Cannot select both a Nonlinear Free Surf.'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(A)')
     &   'CONFIG_CHECK: and Tracer Correction of Lin. Free Surf.'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF

      IF ( rigidLid .AND. useRealFreshWaterFlux ) THEN
        WRITE(msgBuf,'(A)')
     &   'CONFIG_CHECK: useRealFreshWaterFlux not compatible with'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(A)')
     &   'CONFIG_CHECK: rigidLid (meaningless in that case)'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF

      IF ( implicDiv2DFlow.NE.oneRL .AND. .NOT.exactConserv ) THEN
        WRITE(msgBuf,'(2A)') 'CONFIG_CHECK: implicDiv2DFlow < 1 ',
     &   'requires exactConserv= T'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF

      IF ( nonlinFreeSurf.NE.0 .AND. .NOT.exactConserv ) THEN
        WRITE(msgBuf,'(A)')
     &   'CONFIG_CHECK: nonlinFreeSurf cannot be used'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(A)')
     &   'CONFIG_CHECK: without exactConserv'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF

      IF ( select_rStar.NE.0 .AND. .NOT.exactConserv ) THEN
        WRITE(msgBuf,'(A)')
     &   'CONFIG_CHECK: r* Coordinate cannot be used'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(A)')
     &   'CONFIG_CHECK: without exactConserv'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF

      IF ( select_rStar.GE.1 .AND. nonlinFreeSurf.LE.0 ) THEN
        WRITE(msgBuf,'(2A,I3,A)') 'CONFIG_CHECK: r* Coordinate',
     &   ' (select_rStar=', select_rStar, ' ) cannot be used'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(2A,I3,A)') 'CONFIG_CHECK: ',
     &   ' with Linear FreeSurf (nonlinFreeSurf=', nonlinFreeSurf,' )'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF
      IF ( select_rStar.EQ.2 .AND. nonlinFreeSurf.NE.4 ) THEN
C-    not consistent to account for the slope of the coordinate when
C     ignoring the variations of level-thickness in PhiHyd calculation;
C     for now, issue a warning (but might change the code later on):
        WRITE(msgBuf,'(2A,I3)') '** WARNING ** CONFIG_CHECK: ',
     &   'select_rStar=2 not right with nonlinFreeSurf=', nonlinFreeSurf
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
      ENDIF

      IF ( selectSigmaCoord.NE.0 ) THEN
       IF ( fluidIsWater ) THEN
        WRITE(msgBuf,'(A)')
     &   'CONFIG_CHECK: Sigma-Coords not yet coded for Oceanic set-up'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
       ENDIF
       IF ( nonlinFreeSurf.LE.0 ) THEN
        WRITE(msgBuf,'(A)')
     &   'CONFIG_CHECK: Sigma-Coords not coded for Lin-FreeSurf'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
       ENDIF
       IF (select_rStar.NE.0 ) THEN
        WRITE(msgBuf,'(A)')
     &   'CONFIG_CHECK: Sigma-Coords and rStar are not compatible'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
       ENDIF
        WRITE(msgBuf,'(A)')
     &   'CONFIG_CHECK: Sigma-Coords code neither complete nor tested'
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
      ENDIF

C- note : not implemented in checkpoint48b but it is done now (since 01-28-03)
c     IF (select_rStar.GT.0 .AND. useOBCS ) THEN
c       STOP 'ABNORMAL END: S/R CONFIG_CHECK'
c     ENDIF

      IF ( nonlinFreeSurf.NE.0 .AND.
     &     deltaTFreeSurf.NE.dTtracerLev(1) ) THEN
        WRITE(msgBuf,'(2A)') '** WARNING ** CONFIG_CHECK: ',
     &                       'nonlinFreeSurf might cause problems'
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
        WRITE(msgBuf,'(2A)') '** WARNING ** ',
     &               'with different FreeSurf & Tracer time-steps'
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
      ENDIF

      IF ( useRealFreshWaterFlux .AND. implicDiv2DFlow.EQ.zeroRL
     &     .AND. startTime.NE.baseTime .AND. usePickupBeforeC54 ) THEN
        WRITE(msgBuf,'(A)')
     &   'CONFIG_CHECK: usePickupBeforeC54 restart does not work with'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(A)')
     &   'CONFIG_CHECK:  implicDiv2DFlow=0 + useRealFreshWaterFlux'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF

      IF ( useRealFreshWaterFlux .AND. .NOT.exactConserv
     &            .AND. buoyancyRelation.EQ.'OCEANICP' ) THEN
        WRITE(msgBuf,'(A)')
     &   'CONFIG_CHECK: RealFreshWaterFlux with OCEANICP'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(A)')
     &   'CONFIG_CHECK: requires exactConserv=T'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF

      IF ( selectAddFluid.LT.-1 .OR. selectAddFluid.GT.2 ) THEN
        WRITE(msgBuf,'(A,I10,A)') 'CONFIG_CHECK: selectAddFluid=',
     &                             selectAddFluid, ' not allowed'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(2A)') 'CONFIG_CHECK: ',
     &       'should be =0 (Off), 1,2 (Add Mass) or -1 (Virtual Flux)'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF
      IF ( selectAddFluid.GE.1 .AND. rigidLid ) THEN
        WRITE(msgBuf,'(A)')
     &   'CONFIG_CHECK: selectAddFluid > 0 not compatible with'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(A)')
     &   'CONFIG_CHECK: rigidLid (meaningless in that case)'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF
      IF ( selectAddFluid.GE.1 .AND. .NOT.staggerTimeStep ) THEN
        WRITE(msgBuf,'(2A)') '** WARNING ** CONFIG_CHECK: ',
     &   'synchronous time-stepping =>'
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
        WRITE(msgBuf,'(2A)') '** WARNING ** ',
     &   '1 time-step mismatch in AddFluid effects on T & S'
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
      ENDIF

C--   Pressure calculation and pressure gradient:
#ifndef INCLUDE_PHIHYD_CALCULATION_CODE
      IF ( momPressureForcing .OR. storePhiHyd4Phys ) THEN
        WRITE(msgBuf,'(2A)') 'CONFIG_CHECK: ',
     &   'missing code to calculate pressure (totPhiHyd)'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF
#endif /* INCLUDE_PHIHYD_CALCULATION_CODE */
      IF ( storePhiHyd4Phys .AND. .NOT.momStepping ) THEN
        WRITE(msgBuf,'(2A)') 'CONFIG_CHECK: ',
     &   'storePhiHyd4Phys = TRUE but pressure is not computed'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF

C--   Non-hydrostatic and 3-D solver related limitations:
      IF (nonlinFreeSurf.NE.0 .AND. use3Dsolver) THEN
        WRITE(msgBuf,'(A)')
     &   'CONFIG_CHECK: nonlinFreeSurf not yet implemented'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(A)')
     &   'CONFIG_CHECK: in nonHydrostatic code'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF

      IF ( implicitNHPress*implicSurfPress*implicDiv2DFlow.NE.1.
     &     .AND. implicitIntGravWave ) THEN
        WRITE(msgBuf,'(2A)') 'CONFIG_CHECK: implicitIntGravWave',
     &    ' NOT SAFE with non-fully implicit solver'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(2A)') 'CONFIG_CHECK: To by-pass this',
     &    'STOP, comment this test and re-compile config_check'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF
      IF ( implicitNHPress*implicSurfPress*implicDiv2DFlow.EQ.0.
     &     .AND. nonHydrostatic ) THEN
        WRITE(msgBuf,'(2A)') 'CONFIG_CHECK: ',
     &   'Needs non-zero implicit factors (i.e., implicitNHPress,'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(2A)') 'CONFIG_CHECK: ',
     &   ' implicSurfPress & implicDiv2DFlow) to run nonHydrostatic'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF
      IF ( nonHydrostatic .AND.
     &     implicitNHPress.NE.implicSurfPress ) THEN
        WRITE(msgBuf,'(2A)') '** WARNING ** CONFIG_CHECK: ',
     &               'nonHydrostatic might cause problems with'
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
        WRITE(msgBuf,'(2A)') '** WARNING ** CONFIG_CHECK: ',
     &               'different implicitNHPress & implicSurfPress'
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
      ENDIF

      IF ( selectImplicitDrag.EQ.2 .AND. use3Dsolver ) THEN
        WRITE(msgBuf,'(2A)') 'CONFIG_CHECK: selectImplicitDrag=2',
     &               ' not compatible with 3-D Press. solver'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF

      IF ( implicitViscosity .AND. use3Dsolver ) THEN
        WRITE(msgBuf,'(2A)') '** WARNING ** CONFIG_CHECK: ',
     &    'Implicit viscosity applies to provisional u,vVel'
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
        WRITE(msgBuf,'(2A)') '** WARNING ** => not consistent with',
     &    ' final vertical shear (after appling 3-D solver solution'
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
      ENDIF
      IF ( implicitViscosity .AND. nonHydrostatic ) THEN
        WRITE(msgBuf,'(2A)') '** WARNING ** CONFIG_CHECK: ',
     &    'Implicit viscosity not implemented in CALC_GW'
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
        WRITE(msgBuf,'(2A)') '** WARNING ** CONFIG_CHECK: ',
     &    'Explicit viscosity might become unstable if too large'
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
      ENDIF

C--   Momentum related limitations:
      IF ( vectorInvariantMomentum.AND.momStepping ) THEN
       IF ( highOrderVorticity.AND.upwindVorticity ) THEN
        WRITE(msgBuf,'(2A)') 'CONFIG_CHECK: ',
     &   '"highOrderVorticity" conflicts with "upwindVorticity"'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
       ENDIF
      ENDIF
#ifdef ALLOW_MOM_COMMON
      IF ( vectorInvariantMomentum .AND. momViscosity .AND.
     &     usingSphericalPolarGrid .AND. cosPower.NE.zeroRL ) THEN
#ifdef ISOTROPIC_COS_SCALING
       IF ( no_slip_sides ) THEN
        WRITE(msgBuf,'(2A)') 'CONFIG_CHECK: inconsistent ',
     &    'no_slip_sides & ISOTROPIC_COS_SCALING in mom_vecinv'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
       ELSE
        WRITE(msgBuf,'(2A)') '** WARNING ** CONFIG_CHECK: ',
     &    'ISOTROPIC_COS_SCALING not implemented in mom_vecinv'
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
       ENDIF
#endif /* ISOTROPIC_COS_SCALING */
#ifdef COSINEMETH_III
       IF ( useBiharmonicVisc .AND. no_slip_sides ) THEN
        WRITE(msgBuf,'(2A)') 'CONFIG_CHECK: inconsistent ',
     &    'no_slip_sides & COSINEMETH_III in mom_vecinv'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
       ELSEIF ( useBiharmonicVisc ) THEN
        WRITE(msgBuf,'(2A)') '** WARNING ** CONFIG_CHECK: ',
     &    'COSINEMETH_III not implemented in mom_vecinv'
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
       ENDIF
#endif /* COSINEMETH_III */
      ENDIF
#endif /* ALLOW_MOM_COMMON */
      IF ( .NOT.vectorInvariantMomentum .AND. momAdvection ) THEN
       IF ( usingCurvilinearGrid ) THEN
        WRITE(msgBuf,'(2A)') '** WARNING ** CONFIG_CHECK: ',
     &       'missing metric-terms for CurvilinearGrid'
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
       ENDIF
       IF ( hasWetCSCorners ) THEN
        WRITE(msgBuf,'(2A)') 'CONFIG_CHECK: momAdvection ',
     &   'in flux-form is wrong on CubedSphere grid (corners)'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
       ENDIF
      ENDIF
      IF ( selectCoriMap.LT.0 .OR. selectCoriMap.GT.3 ) THEN
        WRITE(msgBuf,'(2A,I4)') 'CONFIG_CHECK: ',
     &       'Invalid option: selectCoriMap=', selectCoriMap
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF
      IF ( selectBotDragQuadr.LT.-1 .OR. selectBotDragQuadr.GT.2 ) THEN
        WRITE(msgBuf,'(2A,I8,A)') 'CONFIG_CHECK: ',
     &       'selectBotDragQuadr=', selectBotDragQuadr,
     &       ' not valid (-1,0,1,2)'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF
      IF ( useSmag3D .AND.
     &    ( usingPCoords .OR. deepAtmosphere .OR. selectSigmaCoord.NE.0
     &                   .OR. rhoRefFile.NE.' ' .OR. hasWetCSCorners )
     &   ) THEN
        WRITE(msgBuf,'(2A)') 'CONFIG_CHECK: ',
     &       'Smag-3D not yet implemented for this set-up'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF

      IF ( momStepping .AND. .NOT.useCDscheme
     &                 .AND. (tauCD.NE.0. .OR. rCD.NE.-1.) ) THEN
C- jmc: since useCDscheme is a new [04-13-03] flag (default=F),
C       put this WARNING to stress that even if CD-scheme parameters
C       (tauCD,rCD) are set, CD-scheme is not used without useCDscheme=T
C-    and STOP if using mom_fluxform (following Chris advise).
C- jmc: but ultimately, this block can/will be removed.
       IF ( vectorInvariantMomentum ) THEN
        WRITE(msgBuf,'(2A)') '** WARNING ** CONFIG_CHECK: ',
     &   'CD-scheme is OFF but params(tauCD,rCD) are set'
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
        WRITE(msgBuf,'(3A)') '** WARNING ** to turn ON CD-scheme:',
     &   ' => "useCDscheme=.TRUE." in "data", namelist PARM01'
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
       ELSE
        WRITE(msgBuf,'(A)')
     &   'CONFIG_CHECK: CD-scheme is OFF but params(tauCD,rCD) are set'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(2A)')
     &   'CONFIG_CHECK: to turn ON CD-scheme: => "useCDscheme=.TRUE."',
     &   ' in "data", namelist PARM01'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
       ENDIF
      ENDIF

      IF ( useCDscheme .AND. hasWetCSCorners ) THEN
        WRITE(msgBuf,'(2A)')
     &   'CONFIG_CHECK: CD-scheme not implemented on CubedSphere grid'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF
      IF ( useCDscheme .AND. momImplVertAdv ) THEN
        WRITE(msgBuf,'(2A)')'CONFIG_CHECK: ',
     &   'Implicit Vert. Advect. not coded for CD-scheme velocity'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF
      IF ( useCDscheme .AND. selectImplicitDrag.GT.0 ) THEN
        WRITE(msgBuf,'(2A)')'CONFIG_CHECK: ',
     &   'Implicit (bottom) drag not coded for CD-scheme velocity'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF

C--   Time-stepping limitations
      IF ( implicitIntGravWave .AND. staggerTimeStep ) THEN
        WRITE(msgBuf,'(2A)') 'CONFIG_CHECK: staggerTimeStep',
     &    ' incompatible with implicitIntGravWave'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF
      IF ( momForcingOutAB.NE.0 .AND. momForcingOutAB.NE.1 ) THEN
        WRITE(msgBuf,'(A,I10,A)') 'CONFIG_CHECK: momForcingOutAB=',
     &                             momForcingOutAB, ' not allowed'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(2A)') 'CONFIG_CHECK: momForcingOutAB ',
     &                       'should be =1 (Out of AB) or =0 (In AB)'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF
      IF ( tracForcingOutAB.NE.0 .AND. tracForcingOutAB.NE.1 ) THEN
        WRITE(msgBuf,'(A,I10,A)') 'CONFIG_CHECK: tracForcingOutAB=',
     &                             tracForcingOutAB, ' not allowed'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(2A)') 'CONFIG_CHECK: tracForcingOutAB ',
     &                       'should be =1 (Out of AB) or =0 (In AB)'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF
      IF ( selectImplicitDrag.LT.0 .OR. selectImplicitDrag.GT.2 ) THEN
        WRITE(msgBuf,'(2A,I4)') 'CONFIG_CHECK: ',
     &    'Invalid option: selectImplicitDrag=',  selectImplicitDrag
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF
      IF ( selectImplicitDrag.EQ.1 ) THEN
        WRITE(msgBuf,'(2A)') 'CONFIG_CHECK: selectImplicitDrag=1',
     &  ' not yet available'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF

C--   Grid limitations:
      IF ( rotateGrid ) THEN
       IF ( .NOT. usingSphericalPolarGrid ) THEN
        WRITE(msgBuf,'(2A)')
     &       'CONFIG_CHECK: specifying Euler angles makes only ',
     &       'sense with usingSphericalGrid=.TRUE.'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
       ENDIF
       IF ( useFLT .OR. useECCO ) THEN
        WRITE(msgBuf,'(2A)') '** WARNING ** CONFIG_CHECK: specifying',
     &       ' Euler angles may not work with pkgs FLT, ECCO'
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
       ENDIF
      ENDIF

C--   Packages conflict
      IF ( useMATRIX .AND. useGCHEM ) THEN
        WRITE(msgBuf,'(2A)')
     &   'CONFIG_CHECK: cannot set both: useMATRIX & useGCHEM'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF

      IF ( useMATRIX .AND. .NOT.usePTRACERS ) THEN
        WRITE(msgBuf,'(2A)')
     &       'CONFIG_CHECK: cannot set useMATRIX without ',
     &       'setting usePTRACERS'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF

      IF ( (useSEAICE .OR. useThSIce) .AND. allowFreezing ) THEN
        WRITE(msgBuf,'(2A)')
     &       'CONFIG_CHECK: cannot set allowFreezing',
     &       ' with pkgs SEAICE or THSICE'
        CALL PRINT_ERROR( msgBuf, myThid )
        errCount = errCount + 1
      ENDIF

      IF ( errCount.GE.1 ) THEN
        WRITE(msgBuf,'(A,I3,A)')
     &       'CONFIG_CHECK: detected', errCount,' fatal error(s)'
        CALL PRINT_ERROR( msgBuf, myThid )
        CALL ALL_PROC_DIE( 0 )
        STOP 'ABNORMAL END: S/R CONFIG_CHECK'
      ENDIF
      _END_MASTER(myThid)

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      _BEGIN_MASTER(myThid)
      WRITE(msgBuf,'(A)') '// CONFIG_CHECK : Normal End'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)')
     &'// ======================================================='
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)') ' '
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      _END_MASTER(myThid)

      RETURN
      END

#include "MOM_FLUXFORM_OPTIONS.h"

CBOP
C !ROUTINE: MOM_V_METRIC_CYLINDER

C !INTERFACE: ==========================================================
      SUBROUTINE MOM_V_METRIC_CYLINDER(
     I        bi,bj,k,
     I        uFld, vFld,
     O        vMetricTerms,
     I        myThid )

C !DESCRIPTION:
C Calculates the meridional metric term due to cylinder curvature:
C \begin{equation}
C -\frac{u^2}{r}
C \end{equation}

C !USES: ===============================================================
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"

C !INPUT PARAMETERS: ===================================================
C  bi,bj                :: tile indices
C  k                    :: vertical level
C  uFld                 :: zonal flow
C  vFld                 :: meridional flow
C  myThid               :: thread number
      INTEGER bi,bj,k
      _RL uFld(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL vFld(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER myThid

C !OUTPUT PARAMETERS: ==================================================
C  vMetricTerms         :: metric term
      _RL vMetricTerms(1-OLx:sNx+OLx,1-OLy:sNy+OLy)

C !LOCAL VARIABLES: ====================================================
C  i,j                  :: loop indices
      INTEGER i,j
      _RL radius
CEOP

      DO j=1-OLy+1,sNy+OLy
       DO i=1-OLx,sNx+OLx-1
          radius = (yG(i,j,bi,bj)+yG(i+1,j,bi,bj))*0.5 _d 0
C-   to get the same results as before:
c         radius = yC(i,j,bi,bj)
          IF ( radius.GT.0. ) THEN
             vMetricTerms(i,j) =
     &           -0.25*(uFld(i,j) + uFld(i+1,j) +
     &                  uFld(i,j-1)+uFld(i+1,j-1))
     &           *0.25*(uFld(i,j) + uFld(i+1,j) +
     &                  uFld(i,j-1)+uFld(i+1,j-1))/radius
          ELSE
             vMetricTerms(i,j) = 0.
          ENDIF
       ENDDO
      ENDDO

      RETURN
      END

#include "STIC_OPTIONS.h"
#ifdef ALLOW_SHELFICE
# include "SHELFICE_OPTIONS.h"
#endif

CBOP
C     !ROUTINE: STIC_SOLVE4FLUXES
C     !INTERFACE:
      SUBROUTINE STIC_SOLVE4FLUXES(
     I   tLoc, sLoc, pLoc,
     I   gammaT, gammaS,
     I   iceConductionDistance, thetaIceConduction,
     O   heatFlux, fwFlux,
     O   forcingT, forcingS,
     O   insitutLoc,
     I   bi, bj, myTime, myIter, myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE SOLVE4FLUXES
C     | o Calculate
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#ifdef ALLOW_SHELFICE
# include "SHELFICE.h"
#endif

C     !INPUT PARAMETERS:
C     tLoc         ::
C     sLoc         ::
C     pLoc         ::
C     gammaT ::
C     gammaS ::
C     bi,bj      :: tile indices
C     myTime     :: current time in simulation
C     myIter     :: iteration number in simulation
C     myThid     :: my Thread Id number

C     !OUTPUT PARAMETERS:
C     heatFlux       ::
C     fwFlux ::
C     forcingT       ::
C     forcingS       ::
C     insitutLoc   ::
C----------

      _RL tLoc, sLoc, pLoc
      _RL gammaT, gammaS
      _RL iceConductionDistance, thetaIceConduction
      _RL heatFlux, fwFlux, forcingT, forcingS, insitutLoc
      INTEGER bi, bj
      _RL     myTime
      INTEGER myIter, myThid
CEOP

#ifndef ALLOW_OPENAD
      _RL SW_TEMP
      EXTERNAL SW_TEMP
#endif

C     !LOCAL VARIABLES:
C     === Local variables ===
      _RL thetaFreeze, saltFreeze
      _RL eps1, eps2, eps3, eps4, eps6, eps7, eps8
      _RL aqe, bqe, cqe, discrim, recip_aqe
      _RL a0, b0, c0
      _RL w_B
      CHARACTER*(MAX_LEN_MBUF) msgBuf

C     === Useful Units ===
C--   gammaT, m s^-1
C--   gammaS, m s^-1
C--   rUnit2mass (rhoConst), kg m^-3
C--   mass2rUnit (recip_rhoConst), m^3 kg^-1
C--   eps3, W K^-1 m^-2
C--   fwFlux, kg m^-2 s^-1
C--   heatFlux, kg m^-2 s^-1
C--   forcing T, K m/s
C--   forcing S, psu m/s
C--   SHELFICEkappa, m^2/s
C--   w_B,  m/s

C--   eps1, W K^-1 m^-2 : kg/m^3 * J/kg/K * m/s
C--   eps2, W m^-2 : kg/m^3 * J/kg * m/s
C--   eps3, W K^-1 m^-2 : kg m^-3 * J kg^-1 K^-1 * m^2 s^-1 * m^-1

C--   fwFlux : fresh water flux due to melting (kg m^-2 s^-1)

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C     linear dependence of freezing point on salinity
      a0 = -0.0575   _d  0
      c0 =  0.0901   _d  0
      b0 =  -7.61    _d -4

C--   convert potential T into in-situ T relative to surface
      insitutLoc = SW_TEMP(sLoc,tLoc,pLoc, zeroRL)

C--   DEFINE SOME CONSTANTS
      eps1 = rUnit2mass*HeatCapacity_Cp * gammaT
      eps2 = rUnit2mass*SHELFICElatentHeat * gammaS
      eps3 = rhoSHELFICE*SHELFICEheatCapacity_Cp * SHELFICEkappa
     &       /iceConductionDistance;
      eps4 = b0*pLoc + c0
      eps6 = eps4 - insitutLoc
      eps7 = eps4 - thetaIceConduction

      IF ( debugLevel.GE.debLevE ) THEN
         WRITE(msgBuf,'(A,9E16.8)')
     &   'r2mass, Cp, gmaT,SIlh,gmaS, rhoSI, SI_Cp, Kap, ICondDis ',
     &   rUnit2mass,HeatCapacity_Cp,gammaT, SHELFICElatentHeat,gammaS,
     &   rhoSHELFICE, SHELFICEheatCapacity_Cp, SHELFICEkappa,
     &   iceConductionDistance

         CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                       SQUEEZE_RIGHT , 1)
      ENDIF

C--   Default thermodynamics specify a linear T gradient
C--   through the ice (Holland and Jenkins, 1999, Section 2).
      IF (SHELFICEadvDiffHeatFlux .EQV. .FALSE.) THEN
          aqe = a0*(eps1 + eps3)
          bqe = eps1*eps6 + eps3*eps7 - eps2 - SHELFICEsalinity*aqe
          cqe = eps2 * sLoc - SHELFICEsalinity*(eps1*eps6 + eps3*eps7)

C--   Alterantively, we can have a nonlinear  T gradient
C--   through the ice (Holland and Jenkins, 1999, Section 3).
C--   This demands a different set of constants
      ELSE
          eps8 = rUnit2mass * gammaS * SHELFICEheatCapacity_Cp
          aqe = a0 *(eps1 - eps8)
          bqe = eps1*eps6 + sLoc*eps8*a0 - eps8*eps7 - eps2 -
     &        SHELFICEsalinity*eps1*a0
          cqe = sLoc*(eps8*eps7 + eps2) - SHELFICEsalinity*eps1
      ENDIF

C     solve quadratic equation for salinity at shelfice-ocean interface
      recip_aqe = 0. _d 0
      IF ( aqe .NE. 0. _d 0 ) recip_aqe = 0.5 _d 0/aqe

C--   Sb = \frac{-bqe \pm \sqrt(bqe^2 - 4 aqc cqe)}{2 aqe}
      discrim = bqe*bqe - 4. _d 0*aqe*cqe

C--   Try the negative root (- SQRT(discrim))  of the quadratic eq.
      saltFreeze = (- bqe - SQRT(discrim))*recip_aqe

C---  If the negative root yields a negative salinity, then use the
C--   positive root (+ SQRT(discrim))
      IF ( saltFreeze .LT. 0. _d 0 ) THEN
          saltFreeze = (- bqe + SQRT(discrim))*recip_aqe
      ENDIF

C--   in situ seawater freezing point using linearization
      thetaFreeze = a0*saltFreeze + eps4

C--   Calculate the upward heat and fresh water fluxes;
C--   MITgcm sign conventions: downward (negative) fresh water flux
C--   implies melting and due to upward (positive) heat flux

C--   Default thermodynamics specify a linear T gradient
C--   through the ice (Holland and Jenkins, 1999, Section 2).
      IF (SHELFICEadvDiffHeatFlux .EQV. .FALSE.) THEN
C--   This formulation of fwflux, derived from the heat balance equation
C--   instead of the salt balance equation, can handle the case when the
C--   salinity of the ocean, boundary layer, and ice are identical.
          fwFlux = 1/SHELFICElatentHeat*(
     &        eps3*(thetaFreeze - thetaIceConduction) -
     &        eps1*(insitutLoc - thetaFreeze) )
C--   Alterantively, we can have a nonlinear  T gradient
C--   through the ice (Holland and Jenkins, 1999, Section 3).
C--   This is only for melting case (Eq. 31 of Holland and Jenkins, 1999)
      ELSE
          fwFlux =
     &        eps1 * ( thetaFreeze - insitutLoc ) /
     &        (SHELFICElatentHeat + SHELFICEheatCapacity_Cp*
     &        (thetaFreeze - thetaIceConduction))
      ENDIF

C--   If a nonlinear local ice T gradient near the ice-ocean interface
C--   is allowed and fwflux is positive (ice growth) then
C--   we must solve the quadratic equation using a different set of
C--   coeffs (Holland Jenkins, 1999).
C--   Since we first need to know fwFlux, the solving of the
C--   quadratic equation for this case cannot be combined
C--   with the other two cases (linear T, nonlinear T and melting).
      IF ((SHELFICEadvDiffHeatFlux .EQV. .TRUE.) .AND.
     &    (fwFlux .GT. zeroRL)) THEN
          aqe = a0 *(eps1)
          bqe = eps1*eps6 - eps2 - SHELFICEsalinity*eps1*a0
          cqe = sLoc*(eps2) - SHELFICEsalinity*eps1

          recip_aqe = 0. _d 0
          IF ( aqe .NE. 0. _d 0 ) recip_aqe = 0.5 _d 0/aqe

          discrim = bqe*bqe - 4. _d 0*aqe*cqe
          saltFreeze = (- bqe - SQRT(discrim))*recip_aqe
          IF ( saltFreeze .LT. 0. _d 0 ) THEN
              saltFreeze = (- bqe + SQRT(discrim))*recip_aqe
          ENDIF

          thetaFreeze = a0*saltFreeze + eps4

          fwFlux =
     &        eps1 * ( thetaFreeze - insitutLoc ) /
     &        SHELFICElatentHeat
      ENDIF

C     velocity of meltwater flux at ice-ocean interface (m/s)
C     * negative corresponds to downward flux of meltwater (melting)
      w_B = fwFlux * mass2rUnit

C--   Calculate the upward heat fluxes:
C--   melting requires upward (positive) heat flux from ocean to ice.

C--   The heatFlux variable corresponds with the change of energy in the
C--   ocean grid cell volume.  In the conservative case (J2001),
C--   advective heat fluxes change the energy of the volume whereas in
C--   the non-conservative case there are no advective heat fluxes
C--   melting or freezing have no associated advective heat fluxes.
      IF (SHELFICEconserve) THEN

C--   In the conservative case (J2001) there are two cases, fixed and
C--   non-fixed ocean volume.

          IF (useRealFreshWaterFlux ) THEN

C--   If the ocean volume can change (realFWFlux=true) then advection of
C--   meltwater does not displace water at T=insitutLoc in the cell and the
C--   heat flux correpsonding to the total energy flux of the volume
C--   consists of only two terms: turbulent fluxes (positive out)
C--   and advective meltwater fluxes (negative in).
             heatFlux = rUnit2mass*HeatCapacity_Cp * (
     &           gammaT * (insitutLoc - thetaFreeze)
     &           + w_B * (thetaFreeze - insitutLoc + tLoc) )
          ELSE

C--   If the volume is fixed (realFWFlux=false) then the advection of
C--   meltwater does displace ambient water at T=insitutLoc in the cell.
C--   Displacement reduction volume energy by w_B * insitutLoc (positive)
             heatFlux = rUnit2mass*HeatCapacity_Cp * (
     &           gammaT * (insitutLoc - thetaFreeze)
     &           + w_B * (thetaFreeze - insitutLoc)        )
          ENDIF

      ELSE

C--   In the non-conservative form, only fluxes are turbulent fluxes
          heatFlux = rUnit2mass*HeatCapacity_Cp *
     &           gammaT * (insitutLoc - thetaFreeze)
      ENDIF

C--   Calculate the T and S tendency terms.  T tendency term is
C--   not necessarily proportional to the heat flux term above because
C--   the heat flux term corresponds to total energy change in the grid
C--   cell and not the change of energy per unit volume.

      IF (SHELFICEconserve) THEN
C--   In the conservative case, meltwater advection contributes (J2001)
C--   to T and S tendencies
C--   * forcing T (K m/s)
          forcingT =
     &      (gammaT - w_B)*(thetaFreeze - insitutLoc)

C--   * forcing S (psu m/s)
          forcingS =
     &      (gammaS - w_B)*(saltFreeze  - sLoc)
      ELSE
C--   Otherwise, the only fluxes out of the ocean that change T and S
C--   are the turbulent fluxes.
          forcingT = gammaT * ( thetaFreeze - insitutLoc )
          forcingS = gammaS * ( saltFreeze  - sLoc )
      ENDIF

      IF ( debugLevel.GE.debLevE ) THEN
         WRITE(msgBuf,'(A,7E16.8)')
     &   'aqe, bqe, ceq ',
     &   aqe,bqe,cqe

         CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT , 1)

         WRITE(msgBuf,'(A,7E16.8)')
     &   'T,S,P,t,TFrz,SFrz,w_B ',
     &   tLoc,sLoc,pLoc, insitutLoc, thetaFreeze, saltFreeze, w_B

         CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                       SQUEEZE_RIGHT , 1)
      ENDIF

      RETURN
      END

#include "GRIDALT_OPTIONS.h"

       subroutine gridalt_update(myThid)
c***********************************************************************
c subroutine gridalt_update
c
c Purpose: Update the pressure thicknesses of the layers of the
c          alternative vertical grid (used now for atmospheric physics).
c
c Calculate: dpphys    - new delta r (p*) edge-to-edge of physics grid
c                        using dpphys0 (initial value) and rstarfacC
c
c***********************************************************************
       implicit none

#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "fizhi_SIZE.h"
#include "gridalt_mapping.h"
#include "SURFACE.h"

       integer myThid

       integer im1,im2,jm1,jm2
       integer i1,i2,j1,j2,bi,bj
       integer i,j,L
       logical  diagnostics_is_on
       external diagnostics_is_on
       _RL temparr(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nrphys,nSx,nSy)

       im1 = 1-OLx
       im2 = sNx+OLx
       jm1 = 1-OLy
       jm2 = sNy+OLy
       i1 = 1
       i2 = sNx
       j1 = 1
       j2 = sNy

#ifdef ALLOW_FIZHI
#ifdef NONLIN_FRSURF

       if(usefizhi .and. (select_rStar.GT.0) )then
        do bj = myByLo(myThid), myByHi(myThid)
        do bi = myBxLo(myThid), myBxHi(myThid)
c
         do L = 1,Nrphys
          do j = j1,j2
          do i = i1,i2
           dpphys(i,j,L,bi,bj) = dpphys0(i,j,L,bi,bj) *
     .                     rstarfacC(i,j,bi,bj)
          enddo
          enddo
         enddo
c
        enddo
        enddo

       endif

#endif

#ifdef ALLOW_DIAGNOSTICS
       if(useDiagnostics) then
       IF ( DIAGNOSTICS_IS_ON('DPPHYS  ',myThid) ) THEN
        do bj = myByLo(myThid), myByHi(myThid)
        do bi = myBxLo(myThid), myBxHi(myThid)
         do L = 1,Nrphys
          do j = j1,j2
          do i = i1,i2
           temparr(i,j,L,bi,bj) = dpphys(i,j,L,bi,bj) * 1. _d -2
          enddo
          enddo
         enddo
        enddo
        enddo
        CALL DIAGNOSTICS_FILL(temparr,'DPPHYS  ',-1,Nrphys,0,1,1,myThid)
       ENDIF
       endif
#endif

#endif
       return
       end

#include "MDSIO_OPTIONS.h"

C--  File mdsio_read_facefile.F:
C--   Contents
C--   o MDS_FACEF_READ_RS
C--   o MDS_FACEF_READ_RL  <- not yet coded

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

CBOP
C     !ROUTINE:  MDS_FACEF_READ_RS
C     !INTERFACE:
      SUBROUTINE MDS_FACEF_READ_RS(
     I                    fName, fPrec, irec,
     U                    array,
     I                    bi,bj, myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE MDS_FACEF_READ_RS
C     *==========================================================*
C     | Read 1 field from a file which contains all the data from
C     |  1 "face" (= piece of domain with rectangular topology)
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#ifdef ALLOW_EXCH2
#include "W2_EXCH2_SIZE.h"
#include "W2_EXCH2_TOPOLOGY.h"
#endif /* ALLOW_EXCH2 */

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
      CHARACTER*(*) fName
      INTEGER fPrec
      INTEGER irec
      _RS array(1-Olx:sNx+Olx,1-Oly:sNy+Oly,nSx,nSy)
      INTEGER bi,bj, myThid
CEOP

C     !FUNCTIONS:
      INTEGER  MDS_RECLEN
      EXTERNAL MDS_RECLEN
      INTEGER  ILNBLNK
      EXTERNAL ILNBLNK

C     !LOCAL VARIABLES:
C     == Local variables ==
      INTEGER i,j, dUnit, iLen
      INTEGER length_of_rec
      CHARACTER*(MAX_LEN_MBUF) msgBuf
#ifdef ALLOW_EXCH2
      INTEGER tN, dNx, dNy, tBx, tBy, tNx, tNY, jj, jBase
      Real*4 ioBuf4(1:sNx*nSx*nPx+1)
      Real*8 ioBuf8(1:sNx*nSx*nPx+1)
#else
      Real*4 ioBuf4(1:sNx+1,1:sNy+1)
      Real*8 ioBuf8(1:sNx+1,1:sNy+1)
#endif /* ALLOW_EXCH2 */

      iLen = ILNBLNK(fName)
#ifdef ALLOW_EXCH2
C     Figure out offset of tile within face
      tN  = W2_myTileList(bi,bj)
      dNx = exch2_mydnx(tN)
      dNy = exch2_mydny(tN)
      tBx = exch2_tbasex(tN)
      tBy = exch2_tbasey(tN)
      tNx = exch2_tnx(tN)
      tNy = exch2_tny(tN)

      CALL MDSFINDUNIT( dUnit, myThid )
      length_of_rec = MDS_RECLEN( fPrec, (dNx+1), myThid )
      OPEN( dUnit, file=fName(1:iLen), status='old', _READONLY_ACTION
     &             access='direct', recl=length_of_rec )
      j = 0
      jBase=(irec-1)*(dNy+1)
      IF ( fPrec.EQ.precFloat32 ) THEN
        DO jj=1+tBy,sNy+1+tBy
         READ(dUnit,rec=jj+jBase) (ioBuf4(i),i=1,dNx+1)
#ifdef _BYTESWAPIO
         CALL MDS_BYTESWAPR4( (dNx+1), ioBuf4 )
#endif
         j = j+1
         DO i=1,sNx+1
          array(i,j,bi,bj) = ioBuf4(i+tBx)
         ENDDO
        ENDDO
      ELSEIF ( fPrec.EQ.precFloat64 ) THEN
        DO jj=1+tBy,sNy+1+tBy
         READ(dUnit,rec=jj+jBase) (ioBuf8(i),i=1,dNx+1)
#ifdef _BYTESWAPIO
         CALL MDS_BYTESWAPR8( (dNx+1), ioBuf8 )
#endif
         j = j+1
         DO i=1,sNx+1
          array(i,j,bi,bj) = ioBuf8(i+tBx)
         ENDDO
        ENDDO
      ELSE
        WRITE(msgBuf,'(A,I8,A)')  ' MDS_FACEF_READ_RS:',
     &             fPrec, ' = illegal value for fPrec'
        CALL PRINT_ERROR( msgBuf, myThid )
        STOP 'ABNORMAL END: S/R MDS_FACEF_READ_RS'
      ENDIF
      CLOSE( dUnit )

#else /* ALLOW_EXCH2 */

      CALL MDSFINDUNIT( dUnit, myThid )
      length_of_rec = MDS_RECLEN( fPrec, (sNx+1)*(sNy+1), myThid )
      OPEN( dUnit, file=fName(1:iLen), status='old', _READONLY_ACTION
     &             access='direct', recl=length_of_rec )
      IF ( fPrec.EQ.precFloat32 ) THEN
        READ(dUnit, rec=irec) ioBuf4
#ifdef _BYTESWAPIO
        CALL MDS_BYTESWAPR4( (sNx+1)*(sNy+1), ioBuf4 )
#endif
        DO j=1,sNy+1
         DO i=1,sNx+1
          array(i,j,bi,bj) = ioBuf4(i,j)
         ENDDO
        ENDDO
      ELSEIF ( fPrec.EQ.precFloat64 ) THEN
        READ(dUnit, rec=irec) ioBuf8
#ifdef _BYTESWAPIO
        CALL MDS_BYTESWAPR8( (sNx+1)*(sNy+1), ioBuf8 )
#endif
        DO j=1,sNy+1
         DO i=1,sNx+1
          array(i,j,bi,bj) = ioBuf8(i,j)
         ENDDO
        ENDDO
      ELSE
        WRITE(msgBuf,'(A,I8,A)')  ' MDS_FACEF_READ_RS:',
     &             fPrec, ' = illegal value for fPrec'
        CALL PRINT_ERROR( msgBuf, myThid )
        STOP 'ABNORMAL END: S/R MDS_FACEF_READ_RS'
      ENDIF
      CLOSE( dUnit )

#endif /* ALLOW_EXCH2 */

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      RETURN
      END

#include "FIZHI_OPTIONS.h"
      subroutine moistio (ndmoist,istrip,npcs,
     .   lowlevel,midlevel,nltop,nsubmin,nsubmax,Lup,
     .   pz,plz,plze,dpres,pkht,pkl,uz,vz,tz,qz,bi,bj,ntracerin,ptracer,
     .   qqz,dumoist,dvmoist,dtmoist,dqmoist,cumfric,
     .   im,jm,lm,ptop,
     .   iras,rainlsp,rainconv,snowfall,
     .   nswcld,cldtot_sw,cldras_sw,cldlsp_sw,nswlz,swlz,
     .   nlwcld,cldtot_lw,cldras_lw,cldlsp_lw,nlwlz,lwlz,
     .   lpnt,myid)

       implicit none

C Input Variables
C ---------------
      integer im,jm,lm
      integer ndmoist,istrip,npcs
      integer bi,bj,ntracerin,ptracer
      integer lowlevel,midlevel,nltop,nsubmin,nsubmax,Lup
      _RL pz(im,jm),plz(im,jm,lm),plze(im,jm,lm+1),dpres(im,jm,lm)
      _RL pkht(im,jm,lm+1),pkl(im,jm,lm)
      _RL tz(im,jm,lm),qz(im,jm,lm,ntracerin)
      _RL uz(im,jm,lm),vz(im,jm,lm)
      _RL qqz(im,jm,lm)
      _RL dumoist(im,jm,lm),dvmoist(im,jm,lm)
      _RL dtmoist(im,jm,lm),dqmoist(im,jm,lm,ntracerin)
      logical cumfric
      _RL ptop
      integer iras
      _RL rainlsp(im,jm),rainconv(im,jm),snowfall(im,jm)
      integer nswcld,nswlz
      _RL cldlsp_sw(im,jm,lm),cldras_sw(im,jm,lm)
      _RL cldtot_sw(im,jm,lm),swlz(im,jm,lm)
      integer nlwcld,nlwlz
      _RL  cldlsp_lw(im,jm,lm),cldras_lw(im,jm,lm)
      _RL  cldtot_lw(im,jm,lm),lwlz(im,jm,lm)
      logical lpnt
      integer myid

C Local Variables
C ---------------
      integer    ncrnd,nsecf

      _RL       fracqq, rh, dum
      integer    snowcrit
      parameter (fracqq = 0.1)
      _RL one
      parameter (one=1.)

      _RL   cldsr(im,jm,lm)
      _RL   srcld(istrip,lm)

      _RL plev
      _RL cldnow,cldlsp_mem,cldlsp,cldras_mem,cldras
      _RL watnow,watmin,cldmin
      _RL cldprs(im,jm),cldtmp(im,jm)
      _RL cldhi (im,jm),cldlow(im,jm)
      _RL cldmid(im,jm),totcld(im,jm)

      _RL   CLDLS(im,jm,lm)  , CPEN(im,jm,lm)
      _RL    tmpimjm(im,jm)
      _RL    lsp_new(im,jm)
      _RL   conv_new(im,jm)
      _RL   snow_new(im,jm)

      _RL  qqcolmin(im,jm)
      _RL  qqcolmax(im,jm)
      integer levpbl(im,jm)

C Gathered Arrays for Variable Cloud Base
C ---------------------------------------
      _RL    raincgath(im*jm)
      _RL     pigather(im*jm)
      _RL     thgather(im*jm,lm)
      _RL     shgather(im*jm,lm)
      _RL    pkzgather(im*jm,lm)
      _RL    pkegather(im*jm,lm+1)
      _RL    plzgather(im*jm,lm)
      _RL    plegather(im*jm,lm+1)
      _RL     dpgather(im*jm,lm)
      _RL    tmpgather(im*jm,lm)
      _RL   deltgather(im*jm,lm)
      _RL   delqgather(im*jm,lm)
      _RL      ugather(im*jm,lm,ntracerin+2-ptracer)
      _RL   delugather(im*jm,lm,ntracerin+2-ptracer)
      _RL     deltrnev(im*jm,lm)
      _RL     delqrnev(im*jm,lm)

      integer  nindeces(lm)
      integer  pblindex(im*jm)
      integer levgather(im*jm)

C Stripped Arrays
C ---------------
      _RL saveth (istrip,lm)
      _RL saveq  (istrip,lm)
      _RL saveu  (istrip,lm,ntracerin+2-ptracer)
      _RL usubcl (istrip,   ntracerin+2-ptracer)

      _RL     ple(istrip,lm+1)
      _RL      dp(istrip,lm)
      _RL      TL(ISTRIP,lm)  , SHL(ISTRIP,lm)
      _RL      PL(ISTRIP,lm)  , PLK(ISTRIP,lm)
      _RL    PLKE(ISTRIP,lm+1)
      _RL      TH(ISTRIP,lm)  ,CVTH(ISTRIP,lm)
      _RL   CVQ(ISTRIP,lm)
      _RL      UL(ISTRIP,lm,ntracerin+2-ptracer)
      _RL     cvu(istrip,lm,ntracerin+2-ptracer)
      _RL  CLMAXO(ISTRIP,lm),CLBOTH(ISTRIP,lm)
      _RL  CLSBTH(ISTRIP,lm)
      _RL    TMP1(ISTRIP,lm),  TMP2(ISTRIP,lm)
      _RL    TMP3(ISTRIP,lm),  TMP4(ISTRIP,lm+1)
      _RL    TMP5(ISTRIP,lm+1)
      integer   ITMP1(ISTRIP,lm), ITMP2(ISTRIP,lm)

      _RL   PRECIP(ISTRIP), PCNET(ISTRIP)
      _RL   SP(ISTRIP),  PREP(ISTRIP)
      _RL   PCPEN (ISTRIP,lm)
      integer pbl(istrip),depths(lm)

      _RL   cldlz(istrip,lm), cldwater(im,jm,lm)
      _RL   rhfrac(istrip), rhmin, pup, ppbl, rhcrit(istrip,lm)
      _RL   offset, alpha, rasmax

      logical first
      logical lras
      _RL    clfrac (istrip,lm)
      _RL    cldmas (istrip,lm)
      _RL    detrain(istrip,lm)
      _RL    psubcld    (istrip), psubcldg (im,jm)
      _RL    psubcld_cnt(istrip), psubcldgc(im,jm)
      _RL rnd(lm/2)
      DATA      FIRST /.TRUE./

      integer imstp,nsubcl,nlras
      integer i,j,iloop,indx,indgath,l,nn,num,numdeps,nt
      _RL tmstp,tminv,sday,grav,alhl,cp,elocp,gamfac
      _RL rkappa,p0kappa,p0kinv,ptopkap,pcheck
      _RL tice,getcon,pi
      integer ntracer,ntracedim, ntracex

#ifdef ALLOW_DIAGNOSTICS
      logical  diagnostics_is_on
      external diagnostics_is_on
      _RL tmpdiag(im,jm),tmpdiag2(im,jm)
#endif

C **********************************************************************
C ****                     INITIALIZATION                           ****
C **********************************************************************

C Add U and V components to tracer array for cumulus friction

      if(cumfric) then
       ntracer = ntracerin + 2
      else
       ntracer = ntracerin
      endif
      ntracedim= max(ntracer-ptracer,1)
      ntracex= ntracer-ptracer
      IMSTP  = nsecf(NDMOIST)
      TMSTP  = FLOAT(IMSTP)
      TMINV  = 1. /  TMSTP

C Minimum Large-Scale Cloud Fraction at rhcrit
      alpha  = 0.80
C Difference in fraction between SR and LS Threshold
      offset = 0.10
C Large-Scale Relative Humidity Threshold above 600 mb
      rhmin  = 0.95
C Maximum Cloud Fraction associated with RAS
      rasmax = 1.00

cc        nn = 3*3600.0/tmstp + 1
          nn = 3*1800.0/tmstp + 1
C Threshold for Cloud Fraction Memory
cc    cldmin = rasmax*(1.0-tmstp/3600.)**nn
      cldmin = rasmax*(1.0-tmstp/1800.)**nn
C Threshold for Cloud Liquid Water Memory
      watmin = 1.0e-8

      SDAY   = GETCON('SDAY')
      GRAV   = GETCON('GRAVITY')
      ALHL   = GETCON('LATENT HEAT COND')
      CP     = GETCON('CP')
      ELOCP  = GETCON('LATENT HEAT COND') / GETCON('CP')
      GAMFAC = GETCON('LATENT HEAT COND') * GETCON('EPS') * ELOCP
     .       / GETCON('RGAS')
      RKAPPA = GETCON('KAPPA')
      P0KAPPA  =  1000.0**RKAPPA
      P0KINV   =  1. / P0KAPPA
      PTOPKAP  =  PTOP**RKAPPA
      tice     = getcon('FREEZING-POINT')
      PI       = 4.*atan(1.)

C Determine Total number of Random Clouds to Check
C ---------------------------------------------
      ncrnd = (lm-nltop+1)/2

      if(first .and. myid.eq.1 .and. bi.eq.1 ) then
       print *
       print *,'Top Level Allowed for Convection : ',nltop
       print *,'          Highest Sub-Cloud Level: ',nsubmax
       print *,'          Lowest  Sub-Cloud Level: ',nsubmin
       print *,'    Total Number of Random Clouds: ',ncrnd
       print *
       first = .false.
      endif

C And now find PBL depth - the level where qq = fracqq * qq at surface
C --------------------------------------------------------------------
      do j = 1,jm
      do i = 1,im
       qqcolmin(i,j) = qqz(i,j,lm)*fracqq
       qqcolmax(i,j) = qqz(i,j,lm)
         levpbl(i,j) = lm+1
      enddo
      enddo

      DO L = lm-1,1,-1
       DO j = 1,jm
       DO i = 1,im
        IF((qqz(i,j,l).gt.qqcolmax(i,j))
     1                   .and.(levpbl(i,j).eq.lm+1))then
         qqcolmax(i,j) = qqz(i,j,l)
         qqcolmin(i,j) = fracqq*qqcolmax(i,j)
        endif
        if((qqz(i,j,l).lt.qqcolmin(i,j))
     1                   .and.(levpbl(i,j).eq.lm+1))levpbl(i,j)=L+1
       enddo
       enddo
      enddo

      do j = 1,jm
      do i = 1,im
        if(levpbl(i,j).gt.nsubmin) levpbl(i,j) = nsubmin
        if(levpbl(i,j).lt.nsubmax) levpbl(i,j) = nsubmax
      enddo
      enddo

C Set up the array of indeces of subcloud levels for the gathering
C ----------------------------------------------------------------
      indx = 0
      do L = nsubmin,nltop,-1
       do j = 1,jm
       do i = 1,im
        if(levpbl(i,j).eq.L) then
         indx = indx + 1
         pblindex(indx) = (j-1)*im + i
        endif
       enddo
       enddo
      enddo

      do indx = 1,im*jm
c      levgather(indx) = levpbl(pblindex(indx),1)
c       pigather(indx) =     pz(pblindex(indx),1)
c       pkegather(indx,lm+1) = pkht(pblindex(indx),1,lm+1)
c       plegather(indx,lm+1) = plze(pblindex(indx),1,lm+1)
        j = 1+INT((pblindex(indx)-1)/im)
        i = 1+MOD((pblindex(indx)-1),im)
       levgather(indx) = levpbl(i,j)
        pigather(indx) =     pz(i,j)
        pkegather(indx,lm+1) = pkht(i,j,lm+1)
        plegather(indx,lm+1) = plze(i,j,lm+1)
      enddo

      do L = 1,lm
       do indx = 1,im*jm
c        thgather(indx,L) = tz(pblindex(indx),1,L)
c        shgather(indx,L) = qz(pblindex(indx),1,L,1)
c       pkegather(indx,L) = pkht(pblindex(indx),1,L)
c       pkzgather(indx,L) = pkl(pblindex(indx),1,L)
c       plegather(indx,L) = plze(pblindex(indx),1,L)
c       plzgather(indx,L) = plz(pblindex(indx),1,L)
c        dpgather(indx,L) = dpres(pblindex(indx),1,L)
        j = 1+INT((pblindex(indx)-1)/im)
        i = 1+MOD((pblindex(indx)-1),im)
         thgather(indx,L) = tz(i,j,L)
         shgather(indx,L) = qz(i,j,L,1)
        pkegather(indx,L) = pkht(i,j,L)
        pkzgather(indx,L) = pkl(i,j,L)
        plegather(indx,L) = plze(i,j,L)
        plzgather(indx,L) = plz(i,j,L)
         dpgather(indx,L) = dpres(i,j,L)
       enddo
      enddo
C General Tracers
C----------------
      do nt = 1,ntracerin-ptracer
      do L = 1,lm
       do indx = 1,im*jm
c       ugather(indx,L,nt) = qz(pblindex(indx),1,L,nt+ptracer)
        j = 1+INT((pblindex(indx)-1)/im)
        i = 1+MOD((pblindex(indx)-1),im)
        ugather(indx,L,nt) = qz(i,j,L,nt+ptracer)
       enddo
      enddo
      enddo

      if(cumfric) then
C Cumulus Friction - load u and v wind components into tracer array
C------------------------------------------------------------------
      do L = 1,lm
       do indx = 1,im*jm
c       ugather(indx,L,ntracerin-ptracer+1) = uz(pblindex(indx),1,L)
c       ugather(indx,L,ntracerin-ptracer+2) = vz(pblindex(indx),1,L)
        j = 1+INT((pblindex(indx)-1)/im)
        i = 1+MOD((pblindex(indx)-1),im)
        ugather(indx,L,ntracerin-ptracer+1) = uz(i,j,L)
        ugather(indx,L,ntracerin-ptracer+2) = vz(i,j,L)
       enddo
      enddo

      endif

C bump the counter for number of calls to convection
C --------------------------------------------------
                        iras = iras + 1
      if( iras.ge.1e9 ) iras = 1

C select the 'random' cloud detrainment levels for RAS
C ----------------------------------------------------
      call rndcloud(iras,ncrnd,rnd,myid)

      do l=1,lm
      do j=1,jm
      do i=1,im
      dumoist(i,j,l) = 0.
      dvmoist(i,j,l) = 0.
      dtmoist(i,j,l) = 0.
        do nt = 1,ntracerin
        dqmoist(i,j,l,nt) = 0.
        enddo
      enddo
      enddo
      enddo

C***********************************************************************
C ****                     LOOP OVER NPCS PEICES                    ****
C **********************************************************************

      DO 1000 NN = 1,NPCS

C **********************************************************************
C ****                   VARIABLE INITIALIZATION                    ****
C **********************************************************************

       CALL STRIP (  pigather, SP      ,im*jm,ISTRIP,1 ,NN )
       CALL STRIP ( pkzgather, PLK     ,im*jm,ISTRIP,lm,NN )
       CALL STRIP ( pkegather, PLKE    ,im*jm,ISTRIP,lm+1,NN )
       CALL STRIP ( plzgather, PL      ,im*jm,ISTRIP,lm,NN )
       CALL STRIP ( plegather, PLE     ,im*jm,ISTRIP,lm+1,NN )
       CALL STRIP (  dpgather, dp      ,im*jm,ISTRIP,lm,NN )
       CALL STRIP (  thgather, TH      ,im*jm,ISTRIP,lm,NN )
       CALL STRIP (  shgather, SHL     ,im*jm,ISTRIP,lm,NN )
       CALL STRINT( levgather, pbl     ,im*jm,ISTRIP,1 ,NN )

       do nt = 1,ntracer-ptracer
        call strip ( ugather(1,1,nt), ul(1,1,nt),im*jm,istrip,lm,nn )
       enddo

C **********************************************************************
C ****        SETUP FOR RAS CUMULUS PARAMETERIZATION                ****
C **********************************************************************
C RAS works with real theta - convert from model theta
      DO L = 1,lm
      DO I = 1,ISTRIP
             TH(I,L) = TH(I,L) * P0KAPPA
         CLMAXO(I,L) = 0.
         CLBOTH(I,L) = 0.
         cldmas(I,L) = 0.
        detrain(I,L) = 0.
      ENDDO
      ENDDO

      do L = 1,lm
      depths(L) = 0
      enddo

      numdeps = 0
      do L = nsubmin,nltop,-1
                       nindeces(L) = 0
       do i = 1,istrip
       if(pbl(i).eq.L) nindeces(L) = nindeces(L) + 1
       enddo
       if(nindeces(L).gt.0) then
       numdeps = numdeps + 1
       depths(numdeps) = L
       endif
      enddo

C Initiate a do-loop around RAS for the number of different
C    sub-cloud layer depths in this strip
C --If all subcloud depths are the same, execute loop once
C   Otherwise loop over different subcloud layer depths

      num = 1
      DO iloop = 1,numdeps

       nsubcl = depths(iloop)

C Compute sub-cloud values for Temperature and Spec.Hum.
C ------------------------------------------------------
       DO 600 I=num,num+nindeces(nsubcl)-1
        TMP1(I,2) = 0.
        TMP1(I,3) = 0.
 600   CONTINUE

       NLRAS = NSUBCL - NLTOP + 1
       DO 601 L=NSUBCL,lm
       DO 602 I=num,num+nindeces(nsubcl)-1
        TMP1(I,2) = TMP1(I,2) + (PLE(I,L+1)-PLE(I,L))*TH (I,L)/sp(i)
        TMP1(I,3) = TMP1(I,3) + (PLE(I,L+1)-PLE(I,L))*SHL(I,L)/sp(i)
 602   CONTINUE
 601   CONTINUE
       DO 603 I=num,num+nindeces(nsubcl)-1
        TMP1(I,4) = 1. / ( (PLE(I,lm+1)-PLE(I,NSUBCL))/sp(I) )
         TH(I,NSUBCL) = TMP1(I,2)*TMP1(I,4)
        SHL(I,NSUBCL) = TMP1(I,3)*TMP1(I,4)
 603   CONTINUE

C Save initial value of tracers and compute sub-cloud value
C ---------------------------------------------------------
       DO NT = 1,ntracer-ptracer
          do  L = 1,lm
          do  i = num,num+nindeces(nsubcl)-1
          saveu(i,L,nt) = ul(i,L,nt)
          enddo
          enddo
          DO I=num,num+nindeces(nsubcl)-1
          TMP1(I,2) = 0.
          ENDDO
          DO L=NSUBCL,lm
          DO I=num,num+nindeces(nsubcl)-1
           TMP1(I,2) = TMP1(I,2)+(PLE(I,L+1)-PLE(I,L))*UL(I,L,NT)/sp(i)
          ENDDO
          ENDDO
          DO I=num,num+nindeces(nsubcl)-1
          UL(I,NSUBCL,NT) = TMP1(I,2)*TMP1(I,4)
             usubcl(i,nt) = ul(i,nsubcl,nt)
          ENDDO
       ENDDO

C Compute Pressure Arrays for RAS
C -------------------------------
       DO 111 L=1,lm
       DO 112 I=num,num+nindeces(nsubcl)-1
        TMP4(I,L) = PLE(I,L)
 112   CONTINUE
 111   CONTINUE
       DO I=num,num+nindeces(nsubcl)-1
        TMP5(I,1) = PTOPKAP / P0KAPPA
       ENDDO
       DO L=2,lm
       DO I=num,num+nindeces(nsubcl)-1
        TMP5(I,L) = PLKE(I,L)*P0KINV
       ENDDO
       ENDDO
       DO  I=num,num+nindeces(nsubcl)-1
        TMP4(I,lm+1) = PLE (I,lm+1)
        TMP5(I,lm+1) = PLKE(I,lm+1)*P0KINV
       ENDDO
       DO 113 I=num,num+nindeces(nsubcl)-1
        TMP4(I,NSUBCL+1) = PLE (I,lm+1)
        TMP5(I,NSUBCL+1) = PLKE(I,lm+1)*P0KINV
 113   CONTINUE

      do i=num,num+nindeces(nsubcl)-1
C Temperature at top of sub-cloud layer
      tmp2(i,1) = TH(i,NSUBCL) * PLKE(i,NSUBCL)/P0KAPPA
C Pressure    at top of sub-cloud layer
      tmp2(i,2) = tmp4(i,nsubcl)
      enddo

      do i=num,num+nindeces(nsubcl)-1
       call qsat (tmp2(i,1),tmp2(i,2),tmp2(i,3),dum,.false.)
       rh =  SHL(I,NSUBCL) / tmp2(i,3)
       if (rh .le. 0.85) then
         rhfrac(i) = 0.
       else if (rh .ge. 0.95) then
         rhfrac(i) = 1.
       else
         rhfrac(i) = (rh-0.85)*10.
       endif
      enddo
CC  Uncomment out the previous code, comment out this to
CC          activate the RH threshold for convection (trigger)
CC    do i=num,num+nindeces(nsubcl)-1
CC      rhfrac(i) = 1.
CC    enddo

C  Compute RH threshold for Large-scale condensation
C  Used in Slingo-Ritter clouds as well - define offset between SR and LS

C Top level of atan func above this rh_threshold = rhmin
      pup = 600.
      do i=num,num+nindeces(nsubcl)-1
       do L = nsubcl, lm
         rhcrit(i,L) = 1.
       enddo
       do L = 1, nsubcl-1
        pcheck = pl(i,L)
        if (pcheck .le. pup) then
         rhcrit(i,L) = rhmin
        else
         ppbl = pl(i,nsubcl)
         rhcrit(i,L) = rhmin + (1.-rhmin)/(19.) *
     .      ((atan( (2.*(pcheck-pup)/(ppbl-pup)-1.) *
     .       tan(20.*pi/21.-0.5*pi) )
     .        + 0.5*pi) * 21./pi - 1.)
        endif
       enddo
      enddo

C Save Initial Values of Temperature and Specific Humidity
C --------------------------------------------------------
      do L = 1,lm
      do i = num,num+nindeces(nsubcl)-1
        saveth(i,L) = th (i,L)
        saveq (i,L) = shl(i,L)
        PCPEN (i,L) = 0.
        CLFRAC(i,L) = 0.
      enddo
      enddo

      CALL RAS ( NN,istrip,nindeces(nsubcl),NLRAS,NLTOP,lm,TMSTP
     1, UL(num,1,1),ntracedim,ntracex,TH(num,NLTOP),SHL(num,NLTOP)
     2, TMP4(num,NLTOP), TMP5(num,NLTOP),rnd, ncrnd, PCPEN(num,NLTOP)
     3, CLBOTH(num,NLTOP), CLFRAC(num,NLTOP)
     4, cldmas(num,nltop), detrain(num,nltop)
     8, cp,grav,rkappa,alhl,rhfrac(num),rasmax )

C Compute Diagnostic CLDMAS in RAS Subcloud Layers
C ------------------------------------------------
       do L=nsubcl,lm
       do I=num,num+nindeces(nsubcl)-1
        dum = dp(i,L)/(ple(i,lm+1)-ple(i,nsubcl))
        cldmas(i,L) = cldmas(i,L-1) - dum*cldmas(i,nsubcl-1)
       enddo
       enddo

C Update Theta and Moisture due to RAS
C ------------------------------------
       DO L=1,nsubcl
       DO I=num,num+nindeces(nsubcl)-1
        CVTH(I,L) =  (TH (I,L) - saveth(i,l))
        CVQ (I,L) =  (SHL(I,L) - saveq (i,l))
       ENDDO
       ENDDO
       DO L=nsubcl+1,lm
       DO I=num,num+nindeces(nsubcl)-1
        CVTH(I,L) = cvth(i,nsubcl)
        CVQ (I,L) = cvq (i,nsubcl)
       ENDDO
       ENDDO

       DO L=nsubcl+1,lm
       DO I=num,num+nindeces(nsubcl)-1
        TH (I,L) = saveth(i,l) + cvth(i,l)
        SHL(I,L) = saveq (i,l) + cvq (i,l)
       ENDDO
       ENDDO
       DO L=1,lm
       DO I=num,num+nindeces(nsubcl)-1
        CVTH(I,L) =  CVTH(I,L) *P0KINV*SP(I)*tminv
        CVQ (I,L) =  CVQ (I,L) *SP(I)*tminv
       ENDDO
       ENDDO

C Compute Tracer Tendency due to RAS
C ----------------------------------
       do nt = 1,ntracer-ptracer
        DO L=1,nsubcl-1
        DO I=num,num+nindeces(nsubcl)-1
         CVU(I,L,nt) = ( UL(I,L,nt)-saveu(i,l,nt) )*sp(i)*tminv
        ENDDO
        ENDDO
        DO L=nsubcl,lm
        DO I=num,num+nindeces(nsubcl)-1
         if( usubcl(i,nt).ne.0.0 ) then
          cvu(i,L,nt) = ( ul(i,nsubcl,nt)-usubcl(i,nt) ) *
     .                     ( saveu(i,L,nt)/usubcl(i,nt) )*sp(i)*tminv
         else
          cvu(i,L,nt) = 0.0
         endif
        ENDDO
        ENDDO
       enddo

C Compute Diagnostic PSUBCLD (Subcloud Layer Pressure)
C ----------------------------------------------------
       do i=num,num+nindeces(nsubcl)-1
                             lras = .false.
       do L=nltop,nsubcl
       if( cvq(i,L).ne.0.0 ) lras = .true.
       enddo
       psubcld    (i) = 0.0
       psubcld_cnt(i) = 0.0
       if( lras ) then
       psubcld    (i) = sp(i)+ptop-ple(i,nsubcl)
       psubcld_cnt(i) = 1.0
       endif
       enddo

C End of subcloud layer depth loop (iloop)

       num = num+nindeces(nsubcl)

      ENDDO

C **********************************************************************
C ****                     TENDENCY UPDATES                         ****
C ****    (Keep 'Gathered' tendencies in 'gather' arrays now)       ****
C **********************************************************************

      call paste( CVTH,deltgather,istrip,im*jm,lm,NN )
      call paste(  CVQ,delqgather,istrip,im*jm,lm,NN )
      do nt = 1,ntracer-ptracer
      call paste( CVU(1,1,nt),delugather(1,1,nt),istrip,im*jm,lm,NN )
      enddo

C **********************************************************************
C     And now paste some arrays for filling diagnostics
C (use pkegather to hold detrainment and tmpgather for cloud mass flux)
C **********************************************************************

      call paste( cldmas,tmpgather,istrip,im*jm,lm,NN)
      call paste(detrain,pkegather,istrip,im*jm,lm,NN)
      call paste(psubcld    ,psubcldg ,istrip,im*jm,1,NN)
      call paste(psubcld_cnt,psubcldgc,istrip,im*jm,1,NN)

C *********************************************************************
C ****         RE-EVAPORATION OF PENETRATING CONVECTIVE RAIN       ****
C *********************************************************************

      CALL STRIP ( thgather,TH ,im*jm,ISTRIP,lm,NN)
      CALL STRIP ( shgather,SHL,im*jm,ISTRIP,lm,NN)
      DO L=1,lm
      DO I=1,ISTRIP
           TH(I,L) =  TH(I,L) + CVTH(I,L)*tmstp/SP(I)
          SHL(I,L) = SHL(I,L) +  CVQ(I,L)*tmstp/SP(I)
           TL(I,L) =  TH(I,L)*PLK(I,L)
       saveth(I,L) =  th(I,L)
       saveq (I,L) = SHL(I,L)
      ENDDO
      ENDDO

       CALL RNEVP (NN,ISTRIP,lm,TL,SHL,PCPEN,PL,CLFRAC,SP,DP,PLKE,
     .  PLK,TH,TMP1,TMP2,TMP3,ITMP1,ITMP2,PCNET,PRECIP,
     .  CLSBTH,TMSTP,one,cp,grav,alhl,gamfac,cldlz,rhcrit,offset,alpha)

C **********************************************************************
C ****                     TENDENCY UPDATES                         ****
C **********************************************************************

      DO L=1,lm

       DO I =1,ISTRIP
       TMP1(I,L) = sp(i) * (SHL(I,L)-saveq(I,L)) * tminv
       ENDDO
       CALL PSTBMP(TMP1(1,L),delqgather(1,L),ISTRIP,im*jm,1,NN)

       DO I =1,ISTRIP
       TMP1(I,L) = sp(i) * ((TL(I,L)/PLK(I,L))-saveth(i,l)) * tminv
       ENDDO
       CALL PSTBMP(TMP1(1,L),deltgather(1,L),ISTRIP,im*jm,1,NN)

C Paste rain evap tendencies into arrays for diagnostic output
C ------------------------------------------------------------
       DO I =1,ISTRIP
        TMP1(I,L) = ((TL(I,L)/PLK(I,L))-saveth(i,l))*plk(i,l)*sday*tminv
       ENDDO
       call paste(tmp1(1,L),deltrnev(1,L),istrip,im*jm,1,NN)

       DO I =1,ISTRIP
        TMP1(I,L) = (SHL(I,L)-saveq(I,L)) * 1000. * sday * tminv
       ENDDO
       call paste(tmp1(1,L),delqrnev(1,L),istrip,im*jm,1,NN)

      ENDDO

C *********************************************************************
C          Add Non-Precipitating Clouds where the relative
C                     humidity is less than 100%
C               Apply Cloud Top Entrainment Instability
C *********************************************************************

      do L=1,lm
      do i=1,istrip
      srcld(i,L) = -clsbth(i,L)
      enddo
      enddo

      call srclouds (saveth,saveq,plk,pl,plke,clsbth,cldlz,istrip,lm,
     .                                              rhcrit,offset,alpha)

      do L=1,lm
      do i=1,istrip
      srcld(i,L) = srcld(i,L)+clsbth(i,L)
      enddo
      enddo

C *********************************************************************
C ****                PASTE CLOUD AMOUNTS                          ****
C *********************************************************************

      call paste (  srcld,   cldsr,istrip,im*jm,lm,nn )
      call paste (  cldlz,cldwater,istrip,im*jm,lm,nn )
      call paste ( clsbth,   cldls,istrip,im*jm,lm,nn )
      call paste ( clboth,   cpen ,istrip,im*jm,lm,nn )

C compute Total Accumulated Precip for Landsurface Model
C ------------------------------------------------------
      do i = 1,istrip
C  Initialize Rainlsp, Rainconv and Snowfall
      tmp1(i,1) = 0.0
      tmp1(i,2) = 0.0
      tmp1(i,3) = 0.0
      enddo

      do i = 1,istrip
      prep(i)   = PRECIP(I) + PCNET(I)
      tmp1(i,1) = PRECIP(I)
      tmp1(i,2) = pcnet(i)
      enddo
C
C  check whether there is snow
C-------------------------------------------------------
C  snow algorthm:
C  if temperature profile from the surface level to 700 mb
C  uniformaly c  below zero, then precipitation (total) is
C  snowfall.  Else there is no snow.
C-------------------------------------------------------

        do i = 1,istrip
          snowcrit=0
          do l=lup,lm
            if (saveth(i,l)*plk(i,l).le. tice ) then
             snowcrit=snowcrit+1
            endif
          enddo
          if (snowcrit .eq. (lm-lup+1)) then
            tmp1(i,3) = prep(i)
            tmp1(i,1)=0.0
            tmp1(i,2)=0.0
          endif
        enddo

      CALL paste (tmp1(1,1), lsp_new,ISTRIP,im*jm,1,NN)
      CALL paste (tmp1(1,2),conv_new,ISTRIP,im*jm,1,NN)
      CALL paste (tmp1(1,3),snow_new,ISTRIP,im*jm,1,NN)
      CALL paste (pcnet,raincgath,ISTRIP,im*jm,1,NN)

C *********************************************************************
C ****               End Major Stripped Region                     ****
C *********************************************************************

 1000 CONTINUE

C Large Scale Rainfall, Conv rain, and snowfall
C ---------------------------------------------
      call back2grd ( lsp_new,pblindex, lsp_new,im*jm)
      call back2grd (conv_new,pblindex,conv_new,im*jm)
      call back2grd (snow_new,pblindex,snow_new,im*jm)
      call back2grd (raincgath,pblindex,raincgath,im*jm)

C Subcloud Layer Pressure
C -----------------------
      call back2grd (psubcldg ,pblindex,psubcldg ,im*jm)
      call back2grd (psubcldgc,pblindex,psubcldgc,im*jm)

      do L = 1,lm
C Delta theta,q, convective, max and ls clouds
C --------------------------------------------
       call back2grd (deltgather(1,L),pblindex, dtmoist(1,1,L)  ,im*jm)
       call back2grd (delqgather(1,L),pblindex, dqmoist(1,1,L,1),im*jm)
       call back2grd (    cpen(1,1,L),pblindex,    cpen(1,1,L)  ,im*jm)
       call back2grd (   cldls(1,1,L),pblindex,   cldls(1,1,L)  ,im*jm)
       call back2grd (cldwater(1,1,L),pblindex,cldwater(1,1,L)  ,im*jm)
       call back2grd ( pkzgather(1,L),pblindex, pkzgather(1,L)  ,im*jm)

C Diagnostics:
C ------------
       call back2grd(tmpgather(1,L),pblindex,
     .                                            tmpgather(1,L),im*jm)
       call back2grd(pkegather(1,L),pblindex,
     .                                            pkegather(1,L),im*jm)
       call back2grd(deltrnev(1,L),pblindex,
     .                                             deltrnev(1,L),im*jm)
       call back2grd(delqrnev(1,L),pblindex,
     .                                             delqrnev(1,L),im*jm)
       call back2grd(cldsr(1,1,L),pblindex,
     .                                              cldsr(1,1,L),im*jm)
      enddo

C General Tracers
C ---------------
      do nt = 1,ntracerin-ptracer
       do L = 1,lm
       call back2grd (delugather(1,L,nt),pblindex,
     .                                 dqmoist(1,1,L,ptracer+nt),im*jm)
       enddo
      enddo

      if(cumfric) then

C U and V for cumulus friction
C ----------------------------
      do L = 1,lm
       call back2grd (delugather(1,L,ntracerin-ptracer+1),pblindex,
     .                                 dumoist(1,1,L),im*jm)
       call back2grd (delugather(1,L,ntracerin-ptracer+2),pblindex,
     .                                 dvmoist(1,1,L),im*jm)
      enddo

C Remove pi-weighting for u and v tendencies
      do j = 1,jm
      do i = 1,im
       tmpimjm(i,j) = 1./pz(i,j)
      enddo
      enddo
      do L = 1,lm
      do j = 1,jm
      do i = 1,im
       dumoist(i,j,L) = dumoist(i,j,L) * tmpimjm(i,j)
       dvmoist(i,j,L) = dvmoist(i,j,L) * tmpimjm(i,j)
      enddo
      enddo
      enddo

      endif

C **********************************************************************
C                          BUMP DIAGNOSTICS
C **********************************************************************

#ifdef ALLOW_DIAGNOSTICS

C Sub-Cloud Layer
C -------------------------
      if(diagnostics_is_on('PSUBCLD ',myid) .and.
     .                 diagnostics_is_on('PSUBCLDC',myid) ) then
       call diagnostics_fill(psubcldg,'PSUBCLD ',0,1,3,bi,bj,myid)
       call diagnostics_fill(psubcldgc,'PSUBCLDC',0,1,3,bi,bj,myid)
      endif

C Non-Precipitating Cloud Fraction
C --------------------------------
      if(diagnostics_is_on('CLDNP   ',myid) ) then
       do L=1,lm
       do j=1,jm
       do i=1,im
        tmpdiag(i,j) = cldsr(i,j,L)
       enddo
       enddo
       call diagnostics_fill(tmpdiag,'CLDNP   ',L,1,3,bi,bj,myid)
      enddo
      endif

C Moist Processes Heating Rate
C ----------------------------
      if(diagnostics_is_on('MOISTT  ',myid) ) then
       do L=1,lm
       do j=1,jm
       do i=1,im
        indgath = (j-1)*im + i
        tmpdiag(i,j)=(dtmoist(i,j,L)*sday*pkzgather(indgath,L)/pz(i,j))
       enddo
       enddo
       call diagnostics_fill(tmpdiag,'MOISTT  ',L,1,3,bi,bj,myid)
      enddo
      endif

C Moist Processes Moistening Rate
C -------------------------------
      if(diagnostics_is_on('MOISTQ  ',myid) ) then
       do L=1,lm
       do j=1,jm
       do i=1,im
        tmpdiag(i,j)=(dqmoist(i,j,L,1)*sday*1000./pz(i,j))
       enddo
       enddo
       call diagnostics_fill(tmpdiag,'MOISTQ  ',L,1,3,bi,bj,myid)
      enddo
      endif

C Moist Processes U-tendency
C ----------------------------
      if(diagnostics_is_on('MOISTU  ',myid) ) then
       do L=1,lm
       do j=1,jm
       do i=1,im
        tmpdiag(i,j)=dumoist(i,j,L)*sday
       enddo
       enddo
       call diagnostics_fill(tmpdiag,'MOISTU  ',L,1,3,bi,bj,myid)
      enddo
      endif

C Moist Processes V-tendency
C ----------------------------
      if(diagnostics_is_on('MOISTV  ',myid) ) then
       do L=1,lm
       do j=1,jm
       do i=1,im
        tmpdiag(i,j)=dvmoist(i,j,L)*sday
       enddo
       enddo
       call diagnostics_fill(tmpdiag,'MOISTV  ',L,1,3,bi,bj,myid)
      enddo
      endif

C Cloud Mass Flux
C ---------------
      if(diagnostics_is_on('CLDMAS  ',myid) ) then
       do L=1,lm
       do j=1,jm
       do i=1,im
        indgath = (j-1)*im + i
        tmpdiag(i,j)=tmpgather(indgath,L)
       enddo
       enddo
       call diagnostics_fill(tmpdiag,'CLDMAS  ',L,1,3,bi,bj,myid)
       enddo
      endif

C Detrained Cloud Mass Flux
C -------------------------
      if(diagnostics_is_on('DTRAIN  ',myid) ) then
       do L=1,lm
       do j=1,jm
       do i=1,im
        indgath = (j-1)*im + i
        tmpdiag(i,j)=pkegather(indgath,L)
       enddo
       enddo
       call diagnostics_fill(tmpdiag,'DTRAIN  ',L,1,3,bi,bj,myid)
       enddo
      endif

C Grid-Scale Condensational Heating Rate
C --------------------------------------
      if(diagnostics_is_on('DTLS    ',myid) ) then
       do L=1,lm
       do j=1,jm
       do i=1,im
        indgath = (j-1)*im + i
        tmpdiag(i,j)=deltrnev(indgath,L)
       enddo
       enddo
       call diagnostics_fill(tmpdiag,'DTLS    ',L,1,3,bi,bj,myid)
       enddo
      endif

C Grid-Scale Condensational Moistening Rate
C -----------------------------------------
      if(diagnostics_is_on('DQLS    ',myid) ) then
       do L=1,lm
       do j=1,jm
       do i=1,im
        indgath = (j-1)*im + i
        tmpdiag(i,j)=delqrnev(indgath,L)
       enddo
       enddo
       call diagnostics_fill(tmpdiag,'DQLS    ',L,1,3,bi,bj,myid)
       enddo
      endif

C Total Precipitation
C -------------------
      if(diagnostics_is_on('PREACC  ',myid) ) then
       do j=1,jm
       do i=1,im
        tmpdiag(i,j) = (lsp_new(I,j) + snow_new(I,j) + conv_new(i,j))
     .                                                    *sday*tminv
       enddo
       enddo
       call diagnostics_fill(tmpdiag,'PREACC  ',0,1,3,bi,bj,myid)
      endif

C Convective Precipitation
C ------------------------
      if(diagnostics_is_on('PRECON  ',myid) ) then
       do j=1,jm
       do i=1,im
        indgath = (j-1)*im + i
        tmpdiag(i,j) = raincgath(indgath)*sday*tminv
       enddo
       enddo
       call diagnostics_fill(tmpdiag,'PRECON  ',0,1,3,bi,bj,myid)
      endif

#endif

C **********************************************************************
C ****   Fill Rainfall and Snowfall Arrays for Land Surface Model   ****
C ****        Note:  Precip Rates work when DT(turb)<DT(moist)      ****
C **********************************************************************

      do j = 1,jm
      do i = 1,im
       rainlsp (i,j) = rainlsp (i,j) +  lsp_new(i,j)*tminv
       rainconv(i,j) = rainconv(i,j) + conv_new(i,j)*tminv
       snowfall(i,j) = snowfall(i,j) + snow_new(i,j)*tminv
      enddo
      enddo

C **********************************************************************
C ***        Compute Time-averaged Quantities for Radiation          ***
C ***               CPEN  => Cloud Fraction from RAS                 ***
C ***               CLDLS => Cloud Fraction from RNEVP               ***
C **********************************************************************

      do j = 1,jm
      do i = 1,im
          cldhi (i,j) = 0.
          cldmid(i,j) = 0.
          cldlow(i,j) = 0.
          cldtmp(i,j) = 0.
          cldprs(i,j) = 0.
         tmpimjm(i,j) = 0.
      enddo
      enddo

C Set Moist-Process Memory Coefficient
C ------------------------------------
      cldras_mem = 1.0-tmstp/ 3600.0
      cldras_mem = 1.0-tmstp/ 1800.0
      cldlsp_mem = 1.0-tmstp/(3600.0*3)
      cldlsp_mem = 1.0-tmstp/(1800.0)

      do L = 1,lm
      do j = 1,jm
      do i = 1,im
C- to recover old code, replace the 2 lines above by the 2 commented below:
c     do j = 1,1
c     do i = 1,im*jm
       indx = (j-1)*im + i
       plev = pl(indx,L)

C Compute Time-averaged Cloud and Water Amounts for Longwave Radiation
C --------------------------------------------------------------------
       watnow = cldwater(i,j,L)
       if( plev.le.500.0 ) then
          cldras = min( max( cldras_lw(i,j,L)*cldras_mem,cpen(i,j,L)),
     $         1.0 _d 0)
       else
        cldras = 0.0
       endif
       cldlsp = min( max( cldlsp_lw(i,j,L)*cldlsp_mem,cldls(i,j,L)),
     $      1.0 _d 0)

       if( cldras.lt.cldmin ) cldras = 0.0
       if( cldlsp.lt.cldmin ) cldlsp = 0.0

       cldnow = max( cldlsp,cldras )

       lwlz(i,j,L) = ( nlwlz*lwlz(i,j,L) + watnow)/(nlwlz +1)
       cldtot_lw(i,j,L) = (nlwcld*cldtot_lw(i,j,L) + cldnow)/(nlwcld+1)
       cldlsp_lw(i,j,L) = (nlwcld*cldlsp_lw(i,j,L) + cldlsp)/(nlwcld+1)
       cldras_lw(i,j,L) = (nlwcld*cldras_lw(i,j,L) + cldras)/(nlwcld+1)

C Compute Time-averaged Cloud and Water Amounts for Shortwave Radiation
C ---------------------------------------------------------------------
       watnow = cldwater(i,j,L)
       if( plev.le.500.0 ) then
          cldras = min( max(cldras_sw(i,j,L)*cldras_mem, cpen(i,j,L)),
     $         1.0 _d 0)
       else
        cldras = 0.0
       endif
       cldlsp = min( max(cldlsp_sw(i,j,L)*cldlsp_mem,cldls(i,j,L)),
     $      1.0 _d 0)

       if( cldras.lt.cldmin ) cldras = 0.0
       if( cldlsp.lt.cldmin ) cldlsp = 0.0

       cldnow = max( cldlsp,cldras )

       swlz(i,j,L) = ( nswlz*swlz(i,j,L) + watnow)/(nswlz +1)
       cldtot_sw(i,j,L) = (nswcld*cldtot_sw(i,j,L) + cldnow)/(nswcld+1)
       cldlsp_sw(i,j,L) = (nswcld*cldlsp_sw(i,j,L) + cldlsp)/(nswcld+1)
       cldras_sw(i,j,L) = (nswcld*cldras_sw(i,j,L) + cldras)/(nswcld+1)

C Compute Instantaneous Low-Mid-High Maximum Overlap Cloud Fractions
C ----------------------------------------------------------------------

       if( L.lt.midlevel ) cldhi (i,j) = max( cldnow,cldhi (i,j) )
       if( L.ge.midlevel  .and.
     .      L.lt.lowlevel ) cldmid(i,j) = max( cldnow,cldmid(i,j) )
       if( L.ge.lowlevel ) cldlow(i,j) = max( cldnow,cldlow(i,j) )

C Compute Cloud-Top Temperature and Pressure
C ------------------------------------------
       cldtmp(i,j) =  cldtmp(i,j) + cldnow*pkzgather(i,L)
     .             *  ( tz(i,j,L) + dtmoist(i,j,L)*tmstp/pz(i,j) )
       cldprs(i,j) =  cldprs(i,j) + cldnow*plev
       tmpimjm(i,j) = tmpimjm(i,j) + cldnow

      enddo
      enddo
      enddo

C Compute Instantaneous Total 2-D Cloud Fraction
C ----------------------------------------------
      do j = 1,jm
      do i = 1,im
      totcld(i,j) = 1.0 - (1.-cldhi (i,j))
     .                  * (1.-cldmid(i,j))
     .                  * (1.-cldlow(i,j))
      enddo
      enddo

C **********************************************************************
C ***       Fill Cloud Top Pressure and Temperature Diagnostic       ***
C **********************************************************************

#ifdef ALLOW_DIAGNOSTICS
      if(diagnostics_is_on('CLDTMP  ',myid) .and.
     .                 diagnostics_is_on('CTTCNT  ',myid) ) then
       do j=1,jm
       do i=1,im
        if( cldtmp(i,j).gt.0. ) then
         tmpdiag(i,j) = cldtmp(i,j)*totcld(i,j)/tmpimjm(i,j)
         tmpdiag2(i,j) = totcld(i,j)
        else
         tmpdiag(i,j) = 0.
         tmpdiag2(i,j) = 0.
        endif
       enddo
       enddo
       call diagnostics_fill(tmpdiag,'CLDTMP  ',0,1,3,bi,bj,myid)
       call diagnostics_fill(tmpdiag2,'CTTCNT  ',0,1,3,bi,bj,myid)
      endif

      if(diagnostics_is_on('CLDPRS  ',myid) .and.
     .                 diagnostics_is_on('CTPCNTC ',myid) ) then
       do j=1,jm
       do i=1,im
        if( cldprs(i,j).gt.0. ) then
         tmpdiag(i,j) = cldprs(i,j)*totcld(i,j)/tmpimjm(i,j)
         tmpdiag2(i,j) = totcld(i,j)
        else
         tmpdiag(i,j) = 0.
         tmpdiag2(i,j) = 0.
        endif
       enddo
       enddo
       call diagnostics_fill(tmpdiag,'CLDPRS  ',0,1,3,bi,bj,myid)
       call diagnostics_fill(tmpdiag2,'CTPCNT  ',0,1,3,bi,bj,myid)
      endif

#endif

C **********************************************************************
C ****                      INCREMENT COUNTERS                      ****
C **********************************************************************

       nlwlz    = nlwlz    + 1
       nswlz    = nswlz    + 1

       nlwcld   = nlwcld   + 1
       nswcld   = nswcld   + 1

      RETURN
      END
      SUBROUTINE RAS( NN, LNG, LENC, K, NLTOP, nlayr, DT
     *,      UOI, ntracedim, ntracer, POI, QOI, PRS, PRJ, rnd, ncrnd
     *,      RAINS, CLN, CLF, cldmas, detrain
     *,      cp,grav,rkappa,alhl,rhfrac,rasmax )
C
C*********************************************************************
C********************* SUBROUTINE  RAS   *****************************
C********************** 16 MARCH   1988 ******************************
C*********************************************************************
C
      implicit none

C Argument List
      integer nn,lng,lenc,k,nltop,nlayr
      integer ntracedim, ntracer
      integer ncrnd
      _RL dt
      _RL UOI(lng,nlayr,ntracedim),   POI(lng,K)
      _RL QOI(lng,K), PRS(lng,K+1), PRJ(lng,K+1)
      _RL rnd(ncrnd)
      _RL RAINS(lng,K), CLN(lng,K), CLF(lng,K)
      _RL cldmas(lng,K), detrain(lng,K)
      _RL cp,grav,rkappa,alhl,rhfrac(lng),rasmax

C Local Variables
      _RL TCU(lng,K), QCU(lng,K)
      _RL ucu(lng,K,ntracedim)
      _RL ALF(lng,K), BET(lng,K), GAM(lng,K)
     *,         ETA(lng,K), HOI(lng,K)
     *,         PRH(lng,K), PRI(lng,K)
      _RL HST(lng,K), QOL(lng,K), GMH(lng,K)

      _RL TX1(lng), TX2(lng), TX3(lng), TX4(lng), TX5(lng)
     *,         TX6(lng), TX7(lng), TX8(lng), TX9(lng)
     *,         TX11(lng), TX12(lng), TX13(lng), TX14(lng,ntracedim)
     *,         TX15(lng)
     *,         WFN(lng)
      integer IA1(lng), IA2(lng), IA3(lng)
      _RL cloudn(lng), pcu(lng)

      integer krmin,icm
      _RL rknob, cmb2pa
      PARAMETER (KRMIN=01)
      PARAMETER (ICM=1000)
      PARAMETER (CMB2PA=100.0)
      PARAMETER (rknob = 10.)

      integer IC(ICM),   IRND(icm)
      _RL cmass(lng,K)
      LOGICAL SETRAS
      integer ifound
      _RL temp
      _RL thbef(lng,K)

      integer i,L,nc,ib,nt
      integer km1,kp1,kprv,kcr,kfx,ncmx
      _RL p00, crtmsf, frac, rasblf

      do L = 1,k
      do I = 1,LENC
       rains(i,l) = 0.
      enddo
      enddo

      p00 = 1000.
      crtmsf = 0.

C The numerator here is the fraction of the subcloud layer mass flux
C      allowed to entrain into the cloud

CCC   FRAC = 1./dt
CCC   FRAC = 0.5/dt
      FRAC = 0.5/dt

      KM1    = K  - 1
      KP1    = K  + 1
C we want the ras adjustment time scale to be one hour (indep of dt)
C     RASBLF = 1./3600.
C we want the ras adjustment time scale to be one half hour (indep of dt)
      RASBLF = 1./1800.
C
       KPRV  = KM1
C Removed KRMAX parameter
       KCR   = MIN(KM1,nlayr-2)
       KFX   = KM1 - KCR
       NCMX  = KFX + NCRND
C
       IF (KFX .GT. 0) THEN
        DO NC=1,KFX
         IC(NC) = K - NC
        ENDDO
       ENDIF
C
      IF (NCRND .GT. 0) THEN
       DO I=1,ncrnd
        IRND(I) = (RND(I)-0.0005)*(KCR-KRMIN+1)
        IRND(I) = IRND(I) + KRMIN
       ENDDO
C
       DO NC=1,NCRND
        IC(KFX+NC) = IRND(NC)
       ENDDO
      ENDIF
C
      DO 100 NC=1,NCMX
C
       IF (NC .EQ. 1 ) THEN
        SETRAS = .TRUE.
       ELSE
        SETRAS = .FALSE.
       ENDIF
       IB = IC(NC)

C Initialize Cloud Fraction Array
C -------------------------------
      do i = 1,lenc
      cloudn(i) = 0.0
      enddo

       CALL CLOUD(nn,lng, LENC, K, NLTOP, nlayr, IB, RASBLF,SETRAS,FRAC
     *,           CP,  ALHL, RKAPPA, GRAV, P00, CRTMSF
     *,           POI, QOI, UOI, ntracedim, Ntracer, PRS, PRJ
     *,           PCU, CLOUDN, TCU, QCU, UCU, CMASS
     *,           ALF, BET, GAM, PRH, PRI, HOI, ETA
     *,           HST, QOL, GMH
     *,           TX1, TX2, TX3, TX4, TX5, TX6, TX7, TX8, TX9
     *,           WFN, TX11, TX12, TX13, TX14, TX15
     *,           IA1,IA2,IA3,rhfrac)

C Compute fraction of grid box into which rain re-evap occurs (clf)
C -----------------------------------------------------------------
      do i = 1,lenc

C mass in detrainment layer
C -------------------------
       tx1(i) = cmb2pa *  (prs(i,ib+1) - prs(i,ib))/(grav*dt)

C ratio of detraining cloud mass to mass in detrainment layer
C -----------------------------------------------------------
       tx1(i) = rhfrac(i)*rknob * cmass(i,ib) / tx1(i)
       if(cmass(i,K).gt.0.) clf(i,ib) = clf(i,ib) + tx1(i)
       if( clf(i,ib).gt.1.) clf(i,ib) = 1.
      enddo

C Compute Total Cloud Mass Flux
C *****************************
      do L=ib,k
      do i=1,lenc
       cmass(i,L) = rhfrac(i)*cmass(i,L) * dt
      enddo
      enddo

      do L=ib,k
      do i=1,lenc
       cldmas(i,L) = cldmas(i,L) + cmass(i,L)
      enddo
      enddo

      do i=1,lenc
      detrain(i,ib) = detrain(i,ib) + cmass(i,ib)
      enddo

      DO L=IB,K
       DO I=1,LENC
        thbef(I,L) = POI(I,L)
        POI(I,L) = POI(I,L) + TCU(I,L) * DT * rhfrac(i)
        QOI(I,L) = QOI(I,L) + QCU(I,L) * DT * rhfrac(i)
       ENDDO
      ENDDO
      DO NT=1,Ntracer
      DO L=IB,K
       DO I=1,LENC
        UOI(I,L+nltop-1,NT)=UOI(I,L+nltop-1,NT)+UCU(I,L,NT)*DT*rhfrac(i)
       ENDDO
      ENDDO
      ENDDO
      DO I=1,LENC
       rains(I,ib) = rains(I,ib) + PCU(I)*dt * rhfrac(i)
      ENDDO

      do i = 1,lenc
       ifound = 0
       do L = 1,k
        if(tcu(i,L).ne.0.)ifound = ifound + 1
       enddo
       if(ifound.ne.0) then
c       print *,i,' made a cloud detraining at ',ib
        do L = 1,k
         temp = TCU(I,L) * DT * rhfrac(i)
c        write(6,122)L,thbef(i,L),poi(i,L),temp
        enddo
       endif
      enddo

  100 CONTINUE

 122  format(' ',i3,' TH B ',e10.3,' TH A ',e10.3,' DTH ',e10.3)

C Fill Convective Cloud Fractions based on 3-D Rain Amounts
C ---------------------------------------------------------
      do L=k-1,1,-1
      do i=1,lenc
         tx1(i)   = 100*(prs(i,L+1)-prs(i,L))/grav
         cln(i,L) = min(1600*rains(i,L)/tx1(i),rasmax )
      enddo
      enddo

      RETURN
      END
      subroutine rndcloud (iras,nrnd,rnd,myid)
      implicit none
      integer n,iras,nrnd,myid
      _RL random_numbx
c     _RL rnd(nrnd)
      _RL rnd(*)
      integer irm
      parameter (irm = 1000)
      _RL random(irm)
      integer i,mcheck,iseed,indx
      logical first
      data    first /.true./
      integer iras0
      data    iras0 /0/
      save random, iras0

      if(nrnd.eq.0)then
       do i = 1,nrnd
        rnd(i) = 0
       enddo
       if(first .and. myid.eq.1) print *,' NO RANDOM CLOUDS IN RAS '
       go to 100
      endif

      mcheck = mod(iras-1,irm/nrnd)

c     print *,' RNDCLOUD: first ',first,' iras ',iras,' iras0 ',iras0
c     print *,' RNDCLOUD: irm,nrnd,mcheck=',irm,nrnd,mcheck

      if ( iras.eq.iras0 ) then
C-    Not the 1rst tile: we are all set (already done for the 1rst tile):
C -----------------------------------------------------------------------
          indx = (iras-1)*nrnd

C First Time In From a Continuing RESTART (IRAS.GT.1) or Reading a New RESTART
C   -- or --
C Multiple Time In But have Used Up all 1000 numbers (MCHECK.EQ.0)
C ----------------------------------------------------------------------------
      elseif ( first.and.(iras.gt.1) .or. mcheck.eq.0 ) then
       iseed = (iras-1-mcheck)*nrnd
       call random_seedx(iseed)
       do i = 1,irm
        random(i) = random_numbx(iseed)
       enddo
       indx = (iras-1)*nrnd

       if( myid.eq.1 ) print *, 'Creating Rand Numb Array in RNDCLOUD'
     &                        ,', iseed=', iseed
       if( myid.eq.1 ) print *, 'IRAS: ',iras,'  IRAS0: ',iras0,
     &    ' indx: ', mod(indx,irm)

C Multiple Time In But have NOT Used Up all 1000 numbers (MCHECK.NE.0)
C --------------------------------------------------------------------
      else
          indx = (iras-1)*nrnd
      endif

          indx = mod(indx,irm)
      if( indx+nrnd.gt.irm ) then
c       if( myid.eq.1 .AND. iras.ne.iras0 ) print *,
c    &   'reach end of Rand Numb Array in RNDCLOUD',indx,irm-nrnd
        indx=irm-nrnd
      endif

      do n = 1,nrnd
       rnd(n) = random(indx+n)
      enddo

 100  continue
      first = .false.
      iras0 = iras

      return
      end
      function random_numbx(iseed)
      implicit none
      integer iseed
      real *8 seed,port_rand
      _RL random_numbx
#ifdef FIZHI_CRAY
      _RL ranf
      random_numbx = ranf()
#else
#ifdef FIZHI_SGI
      _RL rand
      random_numbx = rand()
#else
      seed = -1.d0
      random_numbx = port_rand(seed)
#endif
#endif
      return
      end
      subroutine random_seedx (iseed)
      implicit none
      integer  iseed
      real *8 port_rand
#ifdef FIZHI_CRAY
      call ranset (iseed)
#else
#ifdef FIZHI_SGI
      integer*4   seed
                  seed = iseed
      call srand (seed)
#else
      real*8 tmpRdN
      real*8 seed
      seed = iseed
      tmpRdN = port_rand(seed)
#endif
#endif
      return
      end
      SUBROUTINE CLOUD(nn,lng, LENC, K, NLTOP, nlayr, IC, RASALF
     *,                 SETRAS, FRAC
     *,                 CP,  ALHL, RKAP, GRAV, P00, CRTMSF
     *,                 POI, QOI, UOI, ntracedim, Ntracer, PRS,  PRJ
     *,                 PCU, CLN, TCU, QCU, UCU, CMASS
     *,                 ALF, BET, GAM, PRH, PRI, HOL, ETA
     *,                 HST, QOL, GMH
     *,                 TX1, TX2, TX3, TX4, TX5, TX6, TX7, TX8, ALM
     *,                 WFN, AKM, QS1, CLF, UHT, WLQ
     *,                 IA, I1, I2,rhfrac)
C
C*********************************************************************
C******************** Relaxed Arakawa-Schubert ***********************
C********************* Plug Compatible Version  **********************
C************************ SUBROUTINE CLOUD ***************************
C************************* 23 JULY    1992 ***************************
C*********************************************************************
C*********************************************************************
C*********************************************************************
C************************** Developed By *****************************
C**************************              *****************************
C************************ Shrinivas Moorthi **************************
C************************       and         **************************
C************************  Max J. Suarez *****************************
C************************                *****************************
C******************** Laboratory for Atmospheres *********************
C****************** NASA/GSFC, Greenbelt, MD 20771 *******************
C*********************************************************************
C*********************************************************************
C
C   The calculations of Moorthi and Suarez (1992, MWR) are
C   contained in the CLOUD routine.
C   It is probably advisable, at least initially, to treat CLOUD
C   as a black box that computes the single cloud adjustments. RAS,
C   on the other hand, can be tailored to each GCMs configuration
C   (ie, number and placement of levels, nature of boundary layer,
C    time step and frequency with which RAS is called).
C
C
C  Input:
C  ------
C
C     lng     : The inner dimension of update and input arrays.
C
C     LENC    : The run: the number of soundings processes in a single call.
C               RAS works on the first LENC of the lng soundings
C               passed. This allows working on pieces of the world
C               say for multitasking, without declaring temporary arrays
C               and copying the data to and from them. This is a F77
C               version. An F90 version would have to allow more
C               flexibility in the argument declarations.  Obviously
C               (LENC<=lng).
C
C     K       : Number of vertical layers (increasing downwards).
C               Need not be the same as the number of layers in the
C               GCM, since it is the outer dimension. The bottom layer
C               (K) is the subcloud layer.
C
C     IC      : Detrainment level to check for presence of convection
C
C     RASALF  : Relaxation parameter (< 1.) for present cloud-type
C
C     SETRAS  : Logical parameter to control re-calculation of
C               saturation specific humidity and mid level P**kappa
C
C     FRAC    : Fraction of the PBL (layer K) mass allowed to be used
C               by a cloud-type in time DT
C
C     CP      : Specific heat at constant pressure
C
C     ALHL    : Latent Heat of condensation
C
C     RKAP    : R/Cp, where R is the gas constant
C
C     GRAV    : Acceleration due to gravity
C
C     P00     : A reference pressure in hPa, useually 1000 hPa
C
C     CRTMSF  : Critical value of mass flux above which cloudiness at
C               the detrainment layer of that cloud-type is assumed.
C               Affects only cloudiness calculation.
C
C     POI     : 2D array of dimension (lng,K) containing potential
C               temperature. Updated but not initialized by RAS.
C
C     QOI     : 2D array of dimension (lng,K) containing specific
C               humidity. Updated but not initialized by RAS.
C
C     UOI     : 3D array of dimension (lng,K,NTRACER) containing tracers
C               Updated but not initialized by RAS.
C
C     PRS     : 2D array of dimension (lng,K+1) containing pressure
C               in hPa at the interfaces of K-layers from top of the
C               atmosphere to the bottom. Not modified.
C
C     PRJ     : 2D array of dimension (lng,K+1) containing (PRS/P00) **
C               RKAP.  i.e. Exner function at layer edges. Not modified.
C
C     rhfrac  : 1D array of dimension (lng) containing a rel.hum. scaling
C               fraction. Not modified.
C
C  Output:
C  -------
C
C     PCU     : 1D array of length lng containing accumulated
C               precipitation in mm/sec.
C
C     CLN     : 2D array of dimension (lng,K) containing cloudiness
C               Note:  CLN is bumped but NOT initialized
C
C     TCU     : 2D array of dimension (lng,K) containing accumulated
C               convective heating (K/sec).
C
C     QCU     : 2D array of dimension (lng,K) containing accumulated
C               convective drying (kg/kg/sec).
C
C     CMASS   : 2D array of dimension (lng,K) containing the
C               cloud mass flux (kg/sec). Filled from cloud top
C               to base.
C
C  Temporaries:
C
C      ALF, BET, GAM, ETA, PRH, PRI, HOI, HST, QOL, GMH are temporary
C               2D real arrays of dimension of at least (LENC,K) where LENC is
C               the horizontal dimension over which convection is invoked.
C
C
C    TX1, TX2, TX3, TX4, TX5, TX6, TX7, TX8, TX9, AKM, QS1, CLF, UHT
C    VHT, WLQ  WFN are temporary real arrays of length at least LENC
C
C    IA, I1, and I2 are temporary integer arrays of length LENC
C
C
C************************************************************************
      implicit none
C Argument List declarations
      integer nn,lng,LENC,K,NLTOP,nlayr,ic,ntracedim, ntracer
      _RL rasalf
      LOGICAL SETRAS
      _RL frac, cp,  alhl, rkap, grav, p00, crtmsf
      _RL POI(lng,K),QOI(lng,K),PRS(lng,K+1),PRJ(lng,K+1)
      _RL uoi(lng,nlayr,ntracedim)
      _RL PCU(LENC), CLN(lng)
      _RL TCU(lng,K),QCU(lng,K),ucu(lng,k,ntracedim),CMASS(lng,K)
      _RL ALF(lng,K), BET(lng,K),  GAM(lng,K), PRH(lng,K), PRI(lng,K)
      _RL HOL(LENC,K), ETA(LENC,K), HST(LENC,K), QOL(LENC,K)
      _RL GMH(LENC,K)
      _RL TX1(LENC), TX2(LENC), TX3(LENC), TX4(LENC)
      _RL TX5(LENC), TX6(LENC), TX7(LENC), TX8(LENC)
      _RL ALM(LENC), WFN(LENC), AKM(LENC), QS1(LENC)
      _RL WLQ(LENC), CLF(LENC)
      _RL uht(lng,ntracedim)
      integer IA(LENC), I1(LENC),I2(LENC)
      _RL      rhfrac(lng)

C Local Variables
      _RL daylen,half,one,zero,cmb2pa,rhmax
      PARAMETER (DAYLEN=86400.0,  HALF=0.5,  ONE=1.0, ZERO=0.0)
      PARAMETER (CMB2PA=100.0)
      PARAMETER (RHMAX=0.9999)
      _RL rkapp1,onebcp,albcp,onebg,cpbg,twobal
C
      integer nt,km1,ic1,i,L,len1,len2,isav,len11,ii
      integer lena,lena1,lenb
      _RL tem,tem1

C Explicit Inline Directives
C --------------------------
#ifdef FIZHI_CRAY
#ifdef FIZHI_F77_COMPIL
cfpp$ expand (qsat)
#endif
#endif

      RKAPP1 = 1.0  + RKAP
      ONEBCP = 1.0  / CP
      ALBCP  = ALHL * ONEBCP
      ONEBG  = 1.0  / GRAV
      CPBG   = CP   * ONEBG
      TWOBAL = 2.0 / ALHL

C
      KM1 = K  - 1
      IC1 = IC + 1
C
C      SETTING ALF, BET, GAM, PRH, AND PRI : DONE ONLY WHEN SETRAS=.T.
C

      IF (SETRAS) THEN

         DO 2050 L=1,K
         DO 2030 I=1,LENC
          PRH(I,L) = (PRJ(I,L+1)*PRS(I,L+1) - PRJ(I,L)*PRS(I,L))
     *                            / ((PRS(I,L+1)-PRS(I,L)) * RKAPP1)
 2030    CONTINUE
 2050    CONTINUE

         DO 2070 L=1,K
         DO 2060 I=1,LENC
          TX5(I) = POI(I,L) * PRH(I,L)
          TX1(I) = (PRS(I,L) + PRS(I,L+1)) * 0.5
          TX3(I) = TX5(I)
          CALL QSAT(TX3(I), TX1(I), TX2(I), TX4(I), .TRUE.)
          ALF(I,L) = TX2(I) - TX4(I) * TX5(I)
          BET(I,L) = TX4(I) * PRH(I,L)
          GAM(I,L) = 1.0 / ((1.0 + TX4(I)*ALBCP) * PRH(I,L))
          PRI(I,L) = (CP/CMB2PA) / (PRS(I,L+1) - PRS(I,L))
 2060    CONTINUE
 2070    CONTINUE

      ENDIF
C
C
      DO 10 L=1,K
      DO 10 I=1,lng
      TCU(I,L) = 0.0
      QCU(I,L) = 0.0
      CMASS(I,L) = 0.0
   10 CONTINUE

      do nt = 1,ntracer
      do L=1,K
      do I=1,LENC
      ucu(I,L,nt) = 0.0
      enddo
      enddo
      enddo
C
      DO 30 I=1,LENC
      TX1(I)   = PRJ(I,K+1) * POI(I,K)
      QS1(I)   = ALF(I,K) + BET(I,K)*POI(I,K)
      QOL(I,K) = MIN(QS1(I)*RHMAX,QOI(I,K))

      HOL(I,K) = TX1(I)*CP + QOL(I,K)*ALHL
      ETA(I,K) = ZERO
      TX2(I)   = (PRJ(I,K+1) - PRJ(I,K)) * POI(I,K) * CP
   30 CONTINUE
C
      IF (IC .LT. KM1) THEN
         DO 3703 L=KM1,IC1,-1
         DO 50 I=1,LENC
         QS1(I)   = ALF(I,L) + BET(I,L)*POI(I,L)
         QOL(I,L) = MIN(QS1(I)*RHMAX,QOI(I,L))
C
         TEM1 = TX2(I) + PRJ(I,L+1) * POI(I,L) * CP
         HOL(I,L) = TEM1 + QOL(I,L )* ALHL
         HST(I,L) = TEM1 + QS1(I)   * ALHL

         TX1(I)   = (PRJ(I,L+1) - PRJ(I,L)) * POI(I,L)
         ETA(I,L) = ETA(I,L+1) + TX1(I)*CPBG
         TX2(I)   = TX2(I)     + TX1(I)*CP
   50    CONTINUE
C
 3703    CONTINUE
      ENDIF

      DO 70 I=1,LENC
      HOL(I,IC) = TX2(I)
      QS1(I)    = ALF(I,IC) + BET(I,IC)*POI(I,IC)
      QOL(I,IC) = MIN(QS1(I)*RHMAX,QOI(I,IC))
C
      TEM1      = TX2(I) + PRJ(I,IC1) * POI(I,IC) * CP
      HOL(I,IC) = TEM1 + QOL(I,IC) * ALHL
      HST(I,IC) = TEM1 + QS1(I)    * ALHL
C
      TX3(I   ) = (PRJ(I,IC1) - PRH(I,IC)) * POI(I,IC)
      ETA(I,IC) = ETA(I,IC1) + CPBG * TX3(I)
   70 CONTINUE
C
      DO 130 I=1,LENC
      TX2(I) = HOL(I,K)  - HST(I,IC)
      TX1(I) = ZERO

  130 CONTINUE
C
C     ENTRAINMENT PARAMETER
C
      DO 160 L=IC,KM1
      DO 160 I=1,LENC
      TX1(I) = TX1(I) + (HST(I,IC) - HOL(I,L)) * (ETA(I,L) - ETA(I,L+1))
  160 CONTINUE
C
      LEN1 = 0
      LEN2 = 0
      ISAV = 0
      DO 195 I=1,LENC
      IF (TX1(I) .GT. ZERO .AND. TX2(I) .GT. ZERO
     .                     .AND. rhfrac(i).ne.0.0 ) THEN
         LEN1      = LEN1 + 1
         IA(LEN1)  = I
         ALM(LEN1) = TX2(I) / TX1(I)
      ENDIF
  195 CONTINUE
C
      LEN2 = LEN1
      if (IC1 .lt. K) then
         DO 196 I=1,LENC
         IF (TX2(I) .LE. 0.0 .AND. (HOL(I,K) .GT. HST(I,IC1))
     .                       .AND. rhfrac(i).ne.0.0 ) THEN
            LEN2      = LEN2 + 1
            IA(LEN2)  = I
            ALM(LEN2) = 0.0
         ENDIF
  196    CONTINUE
      endif
C
      IF (LEN2 .EQ. 0) THEN
c        DO 5010 I=1,LENC*K
c        HST(I,1) = 0.0
c        QOL(I,1) = 0.0
c5010    CONTINUE
         DO L = 1,K
          DO I = 1,LENC
           HST(I,L) = 0.0
           QOL(I,L) = 0.0
          ENDDO
         ENDDO
         DO 5020 I=1,LENC
         PCU(I) = 0.0
 5020    CONTINUE
         RETURN
      ENDIF
      LEN11 = LEN1 + 1
C
C     NORMALIZED MASSFLUX
C
      DO 250 I=1,LEN2
      ETA(I,K) = 1.0
      II       = IA(I)
      TX2(I)   = 0.5 * (PRS(II,IC) + PRS(II,IC1))
      TX4(I)   = PRS(II,K)
  250 CONTINUE
C
      DO 252 I=LEN11,LEN2
      WFN(I)   = 0.0
      II       = IA(I)
      IF (HST(II,IC1) .LT. HST(II,IC)) THEN
         TX6(I) = (HST(II,IC1)-HOL(II,K))/(HST(II,IC1)-HST(II,IC))
      ELSE
         TX6(I) = 0.0
      ENDIF
      TX2(I) = 0.5 * (PRS(II,IC1)+PRS(II,IC1+1)) * (1.0-TX6(I))
     *                             + TX2(I)      * TX6(I)
  252 CONTINUE
C
      CALL ACRITN(LEN2, TX2, TX4, TX3)
C
      DO 260 L=KM1,IC,-1
      DO 255 I=1,LEN2
      TX1(I) = ETA(IA(I),L)
  255 CONTINUE
      DO 260 I=1,LEN2
      ETA(I,L) = 1.0 + ALM(I) * TX1(I)
  260 CONTINUE
C
C     CLOUD WORKFUNCTION
C
      IF (LEN1 .GT. 0) THEN
         DO 270 I=1,LEN1
         II = IA(I)
         WFN(I) = - GAM(II,IC) * (PRJ(II,IC1) - PRH(II,IC))
     *                         *  HST(II,IC) * ETA(I,IC1)
  270    CONTINUE
      ENDIF
C
      DO 290 I=1,LEN2
      II = IA(I)
      TX1(I) = HOL(II,K)
  290 CONTINUE
C
      IF (IC1 .LE. KM1) THEN

         DO 380 L=KM1,IC1,-1
         DO 380 I=1,LEN2
         II = IA(I)
         TEM = TX1(I) + (ETA(I,L) - ETA(I,L+1)) * HOL(II,L)
C
         PCU(I) = PRJ(II,L+1) - PRH(II,L)
         TEM1   = ETA(I,L+1) * PCU(I)
         TX1(I) = TX1(I)*PCU(I)
C
         PCU(I) = PRH(II,L) - PRJ(II,L)
         TEM1   = (TEM1 + ETA(I,L) * PCU(I)) * HST(II,L)
         TX1(I) = TX1(I) + TEM*PCU(I)
C
         WFN(I) = WFN(I) + (TX1(I) - TEM1) * GAM(II,L)
         TX1(I) = TEM
  380    CONTINUE
      ENDIF
C
      LENA = 0
      IF (LEN1 .GT. 0) THEN
         DO 512 I=1,LEN1
         II = IA(I)
         WFN(I) = WFN(I) + TX1(I) * GAM(II,IC)*(PRJ(II,IC1)-PRH(II,IC))
     *                   - TX3(I)
         IF (WFN(I) .GT. 0.0) THEN
            LENA = LENA + 1
            I1(LENA) = IA(I)
            I2(LENA) = I
            TX1(LENA) = WFN(I)
            TX2(LENA) = QS1(IA(I))
            TX6(LENA) = 1.0
         ENDIF
  512    CONTINUE
      ENDIF
      LENB = LENA
      DO 515 I=LEN11,LEN2
      WFN(I) = WFN(I) - TX3(I)
      IF (WFN(I) .GT. 0.0 .AND. TX6(I) .GT. 0.0) THEN
         LENB = LENB + 1
         I1(LENB)  = IA(I)
         I2(LENB)  = I
         TX1(LENB) = WFN(I)
         TX2(LENB) = QS1(IA(I))
         TX4(LENB) = TX6(I)
      ENDIF
  515 CONTINUE
C
      IF (LENB .LE. 0) THEN
c        DO 5030 I=1,LENC*K
c        HST(I,1) = 0.0
c        QOL(I,1) = 0.0
c5030    CONTINUE
         DO L = 1,K
          DO I = 1,LENC
           HST(I,L) = 0.0
           QOL(I,L) = 0.0
          ENDDO
         ENDDO
         DO 5040 I=1,LENC
         PCU(I) = 0.0
 5040    CONTINUE
         RETURN
      ENDIF

C
      DO 516 I=1,LENB
      WFN(I) = TX1(I)
      QS1(I) = TX2(I)
  516 CONTINUE
C
      DO 520 L=IC,K
      DO 517 I=1,LENB
      TX1(I) = ETA(I2(I),L)
  517 CONTINUE
      DO 520 I=1,LENB
      ETA(I,L) = TX1(I)
  520 CONTINUE
C
      LENA1 = LENA + 1
C
      DO 510 I=1,LENA
      II = I1(I)
      TX8(I) = HST(II,IC) - HOL(II,IC)
  510 CONTINUE
      DO 530 I=LENA1,LENB
      II = I1(I)
      TX6(I) = TX4(I)
      TEM    = TX6(I) * (HOL(II,IC)-HOL(II,IC1)) + HOL(II,IC1)
      TX8(I) = HOL(II,K) - TEM

      TEM1   = TX6(I) * (QOL(II,IC)-QOL(II,IC1)) + QOL(II,IC1)
      TX5(I) = TEM    - TEM1 * ALHL
      QS1(I) = TEM1   + TX8(I)*(ONE/ALHL)
      TX3(I) = HOL(II,IC)
  530 CONTINUE
C
C
      DO 620 I=1,LENB
      II = I1(I)
      WLQ(I) = QOL(II,K) - QS1(I)     * ETA(I,IC)
      TX7(I) = HOL(II,K)
  620 CONTINUE
      DO NT=1,Ntracer
      DO 621 I=1,LENB
      II = I1(I)
      UHT(I,NT) = UOI(II,K+nltop-1,NT)-UOI(II,IC+nltop-1,NT) * ETA(I,IC)
  621 CONTINUE
      ENDDO
C
      DO 635 L=KM1,IC,-1
      DO 630 I=1,LENB
      II = I1(I)
      TEM    = ETA(I,L) - ETA(I,L+1)
      WLQ(I) = WLQ(I) + TEM * QOL(II,L)
  630 CONTINUE
  635 CONTINUE
      DO NT=1,Ntracer
      DO L=KM1,IC,-1
      DO I=1,LENB
      II = I1(I)
      TEM    = ETA(I,L) - ETA(I,L+1)
      UHT(I,NT) = UHT(I,NT) + TEM *  UOI(II,L+nltop-1,NT)
      ENDDO
      ENDDO
      ENDDO
C
C     CALCULATE GS AND PART OF AKM (THAT REQUIRES ETA)
C
      DO 690 I=1,LENB
      II = I1(I)
c     TX7(I)     = HOL(II,K)
      TEM        = (POI(II,KM1) - POI(II,K)) / (PRH(II,K) - PRH(II,KM1))
      HOL(I,K)   = TEM * (PRJ(II,K)-PRH(II,KM1))*PRH(II,K)*PRI(II,K)
      HOL(I,KM1) = TEM * (PRH(II,K)-PRJ(II,K))*PRH(II,KM1)*PRI(II,KM1)
      AKM(I)     = ZERO
      TX2(I)     = 0.5 * (PRS(II,IC) + PRS(II,IC1))
  690 CONTINUE

      IF (IC1 .LE. KM1) THEN
         DO 750 L=KM1,IC1,-1
         DO 750 I=1,LENB
         II = I1(I)
         TEM      = (POI(II,L-1) - POI(II,L)) * ETA(I,L)
     *                            / (PRH(II,L) - PRH(II,L-1))
C
         HOL(I,L)   = TEM * (PRJ(II,L)-PRH(II,L-1)) * PRH(II,L)
     *                    *  PRI(II,L)  + HOL(I,L)
         HOL(I,L-1) = TEM * (PRH(II,L)-PRJ(II,L)) * PRH(II,L-1)
     *                                              * PRI(II,L-1)
C
         AKM(I)   = AKM(I) - HOL(I,L)
     *            * (ETA(I,L)   * (PRH(II,L)-PRJ(II,L)) +
     *               ETA(I,L+1) * (PRJ(II,L+1)-PRH(II,L))) / PRH(II,L)
  750    CONTINUE
      ENDIF
C
C
      CALL RNCL(LENB, TX2, TX1, CLF)

      DO 770 I=1,LENB
      TX2(I) = (ONE - TX1(I)) * WLQ(I)
      WLQ(I) = TX1(I) * WLQ(I)
C
      TX1(I) = HOL(I,IC)
  770 CONTINUE
      DO 790 I=LENA1, LENB
      II = I1(I)
      TX1(I) = TX1(I) + (TX5(I)-TX3(I)+QOL(II,IC)*ALHL)*(PRI(II,IC)/CP)
  790 CONTINUE

      DO 800 I=1,LENB
      HOL(I,IC) = TX1(I) - TX2(I) * ALBCP * PRI(I1(I),IC)
  800 CONTINUE

      IF (LENA .GT. 0) THEN
         DO 810 I=1,LENA
         II = I1(I)
         AKM(I) = AKM(I) - ETA(I,IC1) * (PRJ(II,IC1) - PRH(II,IC))
     *                                * TX1(I) / PRH(II,IC)
  810    CONTINUE
      ENDIF
C
C     CALCULATE GH
C
      DO 830 I=1,LENB
      II = I1(I)
      TX3(I)   =  QOL(II,KM1) - QOL(II,K)
      GMH(I,K) = HOL(I,K) + TX3(I) * PRI(II,K) * (ALBCP)

      AKM(I)   = AKM(I) + GAM(II,KM1)*(PRJ(II,K)-PRH(II,KM1))
     *                               * GMH(I,K)
      TX3(I)   =  zero
  830 CONTINUE
C
      IF (IC1 .LE. KM1) THEN
         DO 840 L=KM1,IC1,-1
         DO 840 I=1,LENB
         II = I1(I)
         TX2(I) = TX3(I)
         TX3(I) = (QOL(II,L-1) - QOL(II,L)) * ETA(I,L)
         TX2(I) = TX2(I) + TX3(I)
C
         GMH(I,L) = HOL(I,L) + TX2(I)   * PRI(II,L) * (ALBCP*HALF)
  840    CONTINUE
C
C
      ENDIF
      DO 850 I=LENA1,LENB
      TX3(I) = TX3(I) + TWOBAL
     *       * (TX7(I) - TX8(I) - TX5(I) - QOL(I1(I),IC)*ALHL)
  850 CONTINUE
      DO 860 I=1,LENB
      GMH(I,IC) = TX1(I) + PRI(I1(I),IC) * ONEBCP
     *          * (TX3(I)*(ALHL*HALF) + ETA(I,IC) * TX8(I))
  860 CONTINUE
C
C     CALCULATE HC PART OF AKM
C
      IF (IC1 .LE. KM1) THEN
         DO 870 I=1,LENB
         TX1(I) = GMH(I,K)
  870    CONTINUE
         DO 3725 L=KM1,IC1,-1
         DO 880 I=1,LENB
         II = I1(I)
         TX1(I) = TX1(I) + (ETA(I,L) - ETA(I,L+1)) * GMH(I,L)
         TX2(I) = GAM(II,L-1) * (PRJ(II,L) - PRH(II,L-1))
  880    CONTINUE
C
         IF (L .EQ. IC1) THEN
            DO 890 I=LENA1,LENB
            TX2(I) = ZERO
  890       CONTINUE
         ENDIF
         DO 900 I=1,LENB
         II = I1(I)
         AKM(I) = AKM(I) + TX1(I) *
     *          (TX2(I) + GAM(II,L)*(PRH(II,L)-PRJ(II,L)))
  900    CONTINUE
 3725    CONTINUE
      ENDIF
C
      DO 920 I=LENA1,LENB
      II = I1(I)
      TX2(I) = 0.5 * (PRS(II,IC) + PRS(II,IC1))
     *       + 0.5*(PRS(II,IC+2) - PRS(II,IC)) * (ONE-TX6(I))
C
      TX1(I) = PRS(II,IC1)
      TX5(I) = 0.5 * (PRS(II,IC1) + PRS(II,IC+2))
C
      IF ((TX2(I) .GE. TX1(I)) .AND. (TX2(I) .LT. TX5(I))) THEN
         TX6(I)     = ONE - (TX2(I) - TX1(I)) / (TX5(I) - TX1(I))
C
         TEM        = PRI(II,IC1) / PRI(II,IC)
         HOL(I,IC1) = HOL(I,IC1) + HOL(I,IC) * TEM
         HOL(I,IC)  = ZERO
C
         GMH(I,IC1) = GMH(I,IC1) + GMH(I,IC) * TEM
         GMH(I,IC)  = ZERO
      ELSEIF (TX2(I) .LT. TX1(I)) THEN
         TX6(I) = 1.0
      ELSE
         TX6(I) = 0.0
      ENDIF
  920 CONTINUE
C
C
      DO I=1,LENC
      PCU(I) = 0.0
      ENDDO

      DO 970 I=1,LENB
      II = I1(I)
      IF (AKM(I) .LT. ZERO .AND. WLQ(I) .GE. 0.0) THEN
         WFN(I) = - TX6(I) * WFN(I) * RASALF / AKM(I)
      ELSE
         WFN(I) = ZERO
      ENDIF
      TEM       = (PRS(II,K+1)-PRS(II,K))*(CMB2PA*FRAC)
      WFN(I)    = MIN(WFN(I), TEM)
C
C     compute cloud amount
C
CC    TX1(I) = CLN(II)
CC    IF (WFN(I) .GT. CRTMSF)  TX1(I) = TX1(I) + CLF(I)
CC    IF (TX1(I) .GT. ONE)  TX1(I) = ONE
C
C     PRECIPITATION
C
      PCU(II) =  WLQ(I) * WFN(I) * ONEBG
C
C     CUMULUS FRICTION AT THE BOTTOM LAYER
C
      TX4(I)   = WFN(I) * (1.0/ALHL)
      TX5(I)   = WFN(I) * ONEBCP
  970 CONTINUE
C
C     compute cloud mass flux for diagnostic output
C
      DO L = IC,K
      DO I=1,LENB
       II = I1(I)
       if(L.lt.K)then
       CMASS(II,L) =  ETA(I,L+1) * WFN(I) * ONEBG
       else
       CMASS(II,L) =  WFN(I) * ONEBG
       endif
      ENDDO
      ENDDO
C
CC    DO 975 I=1,LENB
CC    II = I1(I)
CC    CLN(II) = TX1(I)
CC975 CONTINUE
C
C     THETA AND Q CHANGE DUE TO CLOUD TYPE IC
C

c     TEMA = 0.0
c     TEMB = 0.0
      DO 990 L=IC,K
      DO 980 I=1,LENB
      II = I1(I)
      TEM      = (GMH(I,L) - HOL(I,L)) * TX4(I)
      TEM1     =  HOL(I,L) * TX5(I)
C
      TCU(II,L) = TEM1 / PRH(II,L)
      QCU(II,L) = TEM
  980 CONTINUE

c     I = I1(IP1)
c
c     TEM  = (PRS(I,L+1)-PRS(I,L)) * (ONEBG*100.0)
c     TEMA = TEMA +  TCU(I,L) * PRH(I,L) * TEM * (CP/ALHL)
c     TEMB = TEMB +  QCU(I,L)            * TEM
C
  990 CONTINUE
C
C Compute Tracer Tendencies
C -------------------------
      do nt = 1,ntracer
C
C Tracer Tendency at the Bottom Layer
C -----------------------------------
      DO 995 I=1,LENB
      II = I1(I)
      TEM    = half*TX5(I) * PRI(II,K)
      TX1(I) = ( UOI(II,KM1+nltop-1,nt) - UOI(II,K+nltop-1,nt))
      ucu(II,K,nt) = TEM * TX1(I)
  995 CONTINUE
C
C Tracer Tendency at all other Levels
C -----------------------------------
      DO 1020 L=KM1,IC1,-1
      DO 1010 I=1,LENB
      II = I1(I)
      TEM = half*TX5(I) * PRI(II,L)
      TEM1   = TX1(I)
      TX1(I) = (UOI(II,L-1+nltop-1,nt)-UOI(II,L+nltop-1,nt)) * ETA(I,L)
      TX3(I) = (TX1(I) + TEM1) * TEM
 1010 CONTINUE
      DO 1020 I=1,LENB
      II = I1(I)
      ucu(II,L,nt) = TX3(I)
 1020 CONTINUE

      DO 1030 I=1,LENB
      II = I1(I)
      IF (TX6(I) .GE. 1.0) THEN
         TEM    = half*TX5(I) * PRI(II,IC)
      ELSE
         TEM = 0.0
      ENDIF
      TX1(I) = (TX1(I) + UHT(I,nt) + UHT(I,nt)) * TEM
 1030 CONTINUE
      DO 1040 I=1,LENB
      II = I1(I)
      ucu(II,IC,nt) = TX1(I)
 1040 CONTINUE

      enddo
C
C     PENETRATIVE CONVECTION CALCULATION OVER
C

      RETURN
      END
      SUBROUTINE RNCL(lng, PL, RNO, CLF)
C
C*********************************************************************
C********************** Relaxed Arakawa-Schubert *********************
C************************   SUBROUTINE  RNCL  ************************
C**************************** 23 July 1992 ***************************
C*********************************************************************
      implicit none
C Argument List declarations
      integer lng
      _RL PL(lng),  RNO(lng), CLF(lng)

C Local Variables
      _RL p5,p8,pt8,pt2,pfac,p4,p6,p7,p9,cucld,cfac
      PARAMETER (P5=500.0,  P8=800.0, PT8=0.8, PT2=0.2)
      PARAMETER (PFAC=PT2/(P8-P5))
      PARAMETER (P4=400.0,    P6=401.0)
      PARAMETER (P7=700.0,    P9=900.0)
      PARAMETER (CUCLD=0.5,CFAC=CUCLD/(P6-P4))

      integer i
C
      DO 10 I=1,lng
                           rno(i) = 1.0
ccc   if( pl(i).le.400.0 ) rno(i) = max( 0.75 _d 0, 1.0-0.0025*
ccc  &                                 (400.0-pl(i)) )

ccc   IF ( PL(I).GE.P7 .AND. PL(I).LE.P9 ) THEN
ccc     RNO(I) = ((P9-PL(I))/(P9-P7)) **2
ccc   ELSE IF (PL(I).GT.P9) THEN
ccc     RNO(I) = 0.
ccc   ENDIF

      CLF(I) = CUCLD
C
CARIESIF (PL(I) .GE. P5 .AND. PL(I) .LE. P8) THEN
CARIES    RNO(I) = (P8-PL(I))*PFAC + PT8
CARIESELSEIF (PL(I) .GT. P8 ) THEN
CARIES    RNO(I) = PT8
CARIESENDIF
CARIES
      IF (PL(I) .GE. P4 .AND. PL(I) .LE. P6) THEN
         CLF(I) = (P6-PL(I))*CFAC
      ELSEIF (PL(I) .GT. P6 ) THEN
         CLF(I) = 0.0
      ENDIF
   10 CONTINUE
C
      RETURN
      END
      SUBROUTINE ACRITN ( lng,PL,PLB,ACR )

C*********************************************************************
C********************** Relaxed Arakawa-Schubert *********************
C************************** SUBROUTINE  ACRIT    *********************
C******************  modified August 28, 1996   L.Takacs  ************
C****                                                            *****
C****  Note:  Data obtained from January Mean After-Analysis     *****
C****         from 4x5 46-layer GEOS Assimilation                *****
C****                                                            *****
C*********************************************************************
      implicit none
C Argument List declarations
      integer lng
      _RL PL(lng), PLB(lng), ACR(lng)

C Local variables
      integer lma
      parameter  (lma=18)
      _RL p(lma)
      _RL a(lma)
      integer i,L
      _RL temp

      data p  / 93.81, 111.65, 133.46, 157.80, 186.51,
     .         219.88, 257.40, 301.21, 352.49, 409.76,
     .         471.59, 535.04, 603.33, 672.79, 741.12,
     .         812.52, 875.31, 930.20/

      data a  / 3.35848, 3.13645, 2.48072, 2.08277, 1.53364,
     .          1.01971,  .65846,  .45867,  .38687,  .31002,
     .           .25574,  .20347,  .17254,  .15260,  .16756,
     .           .09916,  .10360,  .05880/

      do L=1,lma-1
      do i=1,lng
         if( pl(i).ge.p(L)   .and.
     .       pl(i).le.p(L+1)) then
         temp = ( pl(i)-p(L) )/( p(L+1)-p(L) )
         acr(i) = a(L+1)*temp + a(L)*(1-temp)
         endif
      enddo
      enddo

      do i=1,lng
      if( pl(i).lt.p(1)   ) acr(i) = a(1)
      if( pl(i).gt.p(lma) ) acr(i) = a(lma)
      enddo

      do i=1,lng
      acr(i) = acr(i) * (plb(i)-pl(i))
      enddo

      RETURN
      END
       SUBROUTINE RNEVP(NN,IRUN,NLAY,TL,QL,RAIN,PL,CLFRAC,SP,DP,PLKE,
     1   PLK,TH,TEMP1,TEMP2,TEMP3,ITMP1,ITMP2,RCON,RLAR,CLSBTH,tmscl,
     2   tmfrc,cp,gravity,alhl,gamfac,cldlz,RHCRIT,offset,alpha)

      implicit none
C Argument List declarations
      integer nn,irun,nlay
      _RL TL(IRUN,NLAY),QL(IRUN,NLAY),RAIN(IRUN,NLAY),
     . PL(IRUN,NLAY),CLFRAC(IRUN,NLAY),SP(IRUN),TEMP1(IRUN,NLAY),
     . TEMP2(IRUN,NLAY),PLKE(IRUN,NLAY+1),
     . RCON(IRUN),RLAR(IRUN),DP(IRUN,NLAY),PLK(IRUN,NLAY),TH(IRUN,NLAY),
     . TEMP3(IRUN,NLAY)
      integer ITMP1(IRUN,NLAY),ITMP2(IRUN,NLAY)
      _RL CLSBTH(IRUN,NLAY)
      _RL tmscl,tmfrc,cp,gravity,alhl,gamfac,offset,alpha
      _RL cldlz(irun,nlay)
      _RL rhcrit(irun,nlay)
C
C Local Variables
      _RL zm1p04,zero,two89,zp44,zp01,half,zp578,one,z3600,z1800
      _RL zp1,zp001
      PARAMETER (ZM1P04 = -1.04E-4 )
      PARAMETER (ZERO = 0.)
      PARAMETER (TWO89= 2.89E-5)
      PARAMETER ( ZP44= 0.44)
      PARAMETER ( ZP01= 0.01)
      PARAMETER ( ZP1 = 0.1 )
      PARAMETER ( ZP001= 0.001)
      PARAMETER ( HALF= 0.5)
      PARAMETER ( ZP578 = 0.578 )
      PARAMETER ( ONE = 1.)
      PARAMETER ( Z3600 = 3600.)
      PARAMETER ( Z1800 = 1800.)
C
      _RL EVP9(IRUN,NLAY)
      _RL water(irun),crystal(irun)
      _RL watevap(irun),iceevap(irun)
      _RL fracwat,fracice, tice,rh,fact,dum
      _RL rainmax(irun)
      _RL getcon,rphf,elocp,cpog,relax
      _RL exparg,arearat,rpow

      integer i,L,n,nlaym1,irnlay,irnlm1

C Explicit Inline Directives
C --------------------------
#ifdef FIZHI_CRAY
#ifdef FIZHI_F77_COMPIL
cfpp$ expand (qsat)
#endif
#endif

       tice = getcon('FREEZING-POINT')

       fracwat = 0.70
       fracice = 0.01

       NLAYM1 = NLAY - 1
       IRNLAY = IRUN*NLAY
       IRNLM1 = IRUN*(NLAY-1)

C      RPHF = Z3600/tmscl
       RPHF = Z1800/tmscl

       ELOCP   = alhl/cp
       CPOG    = cp/gravity

       DO I = 1,IRUN
          RLAR(I) = 0.
         water(i) = 0.
       crystal(i) = 0.
       ENDDO

       do L = 1,nlay
       do i = 1,irun
          EVP9(i,L) = 0.
         TEMP1(i,L) = 0.
         TEMP2(i,L) = 0.
         TEMP3(i,L) = 0.
        CLSBTH(i,L) = 0.
         cldlz(i,L) = 0.
       enddo
       enddo

C RHO(ZERO) / RHO FOR TERMINAL VELOCITY APPROX.
C ---------------------------------------------
      DO L = 1,NLAY
      DO I = 1,IRUN
        TEMP2(I,L) = PL(I,L)*ZP001
        TEMP2(I,L) = SQRT(TEMP2(I,L))
      ENDDO
      ENDDO

C INVERSE OF MASS IN EACH LAYER
C -----------------------------
      DO L = 1,NLAY
      DO I = 1,IRUN
      TEMP3(I,L) = GRAVITY*ZP01 / DP(I,L)
      ENDDO
      ENDDO

C DO LOOP FOR MOISTURE EVAPORATION ABILITY AND CONVEC EVAPORATION.
C ----------------------------------------------------------------
      DO 100 L=1,NLAY

      DO I = 1,IRUN
        TEMP1(I,3) = TL(I,L)
        TEMP1(I,4) = QL(I,L)
      ENDDO

      DO 50 N=1,2
       IF(N.EQ.1)RELAX=HALF
       IF(N.GT.1)RELAX=ONE

      DO I = 1,IRUN
       call qsat ( temp1(i,3),pl(i,L),temp1(i,2),temp1(i,6),.true. )
       TEMP1(I,5)=TEMP1(I,2)-TEMP1(I,4)
       TEMP1(I,6)=TEMP1(I,6)*ELOCP
       TEMP1(I,5)=TEMP1(I,5)/(ONE+TEMP1(I,6))
       TEMP1(I,4)=TEMP1(I,4)+TEMP1(I,5)*RELAX
       TEMP1(I,3)=TEMP1(I,3)-TEMP1(I,5)*ELOCP*RELAX
      ENDDO
  50  CONTINUE

      DO I = 1,IRUN
          EVP9(I,L) = (TEMP1(I,4) -  QL(I,L))/TEMP3(I,L)
C convective detrained water
         cldlz(i,L) = rain(i,L)*temp3(i,L)
       if(  tl(i,L).gt.tice-20.) then
           water(i) =   water(i) + rain(i,L)
       else
         crystal(i) = crystal(i) + rain(i,L)
       endif
      ENDDO

C**********************************************************************
C  FOR CONVECTIVE PRECIP, FIND THE "EVAPORATION EFFICIENCY" USING     *
C                   KESSLERS PARAMETERIZATION                         *
C**********************************************************************

      DO 20 I=1,IRUN

        iceevap(i) = 0.
        watevap(i) = 0.

       if( (evp9(i,L).gt.0.) .and. (crystal(i).gt.0.) ) then
       iceevap(I) = EVP9(I,L)*fracice
       IF(iceevap(i).GE.crystal(i)) iceevap(i) = crystal(i)
       EVP9(I,L)=EVP9(I,L)-iceevap(I)
       crystal(i) = crystal(i) - iceevap(i)
       endif

C and now warm precipitate
       if( (evp9(i,L).gt.0.) .and. (water(i).gt.0.) ) then
       exparg    = ZM1P04*tmscl*((water(i)*RPHF*TEMP2(I,L))**ZP578)
       AREARAT = ONE-(EXP(EXPARG))
       watevap(I) = EVP9(I,L)*AREARAT*fracwat
       IF(watevap(I).GE.water(i)) watevap(I) = water(i)
       EVP9(I,L)=EVP9(I,L)-watevap(I)
       water(i) = water(i) - watevap(i)
       endif

       QL(I,L) = QL(I,L)+(iceevap(i)+watevap(i))*TEMP3(I,L)
       TL(I,L) = TL(I,L)-(iceevap(i)+watevap(i))*TEMP3(I,L)*ELOCP

  20  CONTINUE

  100 CONTINUE

      do i = 1,irun
      rcon(i) = water(i) + crystal(i)
      enddo

C**********************************************************************
C Large Scale Precip
C**********************************************************************

      DO 200 L=1,NLAY
      DO I = 1,IRUN
        rainmax(i) = rhcrit(i,L)*evp9(i,L) +
     .               ql(i,L)*(rhcrit(i,L)-1.)/temp3(i,L)

         if (rainmax(i).LE.0.0) then
           call qsat( tl(i,L),pl(i,L),rh,dum,.false.)
           rh = ql(i,L)/rh

           if( rhcrit(i,L).eq.1.0 ) then
           fact = 1.0
           else
           fact = min( 1.0 _d 0, alpha + (1.0-alpha)*( rh-rhcrit(i,L)) /
     1                                          (1.0-rhcrit(i,L)) )
           endif

C Do not allow clouds above 10 mb
           if( pl(i,L).ge.10.0 ) CLSBTH(I,L) = fact
           RLAR(I) = RLAR(I)-rainmax(I)
           QL(I,L) = QL(I,L)+rainmax(I)*TEMP3(I,L)
           TL(I,L) = TL(I,L)-rainmax(I)*TEMP3(I,L)*ELOCP
C Large-scale water
        cldlz(i,L) = cldlz(i,L) - rainmax(i)*temp3(i,L)
         ENDIF
      ENDDO

      DO I=1,IRUN
         IF((RLAR(I).GT.0.0).AND.(rainmax(I).GT.0.0))THEN
          RPOW=(RLAR(I)*RPHF*TEMP2(I,L))**ZP578
          EXPARG  = ZM1P04*tmscl*RPOW
          AREARAT = ONE-(EXP(EXPARG))
          TEMP1(I,7) = rainmax(I)*AREARAT
          IF(TEMP1(I,7).GE.RLAR(I)) TEMP1(I,7) = RLAR(I)
          RLAR(I) =    RLAR(I)-TEMP1(I,7)
          QL(I,L) =    QL(I,L)+TEMP1(I,7)*TEMP3(I,L)
          TL(I,L) =    TL(I,L)-TEMP1(I,7)*TEMP3(I,L)*ELOCP
         ENDIF
      ENDDO

  200 CONTINUE

      RETURN
      END
      subroutine srclouds (th,q,plk,pl,plke,cloud,cldwat,irun,irise,
     1                                                rhc,offset,alpha)
C***********************************************************************
C
C  PURPOSE:
C  ========
C    Compute non-precipitating cloud fractions
C    based on Slingo and Ritter (1985).
C    Remove cloudiness where conditionally unstable.
C
C  INPUT:
C  ======
C    th ......... Potential Temperature (irun,irise)
C    q .......... Specific  Humidity    (irun,irise)
C    plk ........ P**Kappa at mid-layer (irun,irise)
C    pl ......... Pressure at mid-layer (irun,irise)
C    plke ....... P**Kappa at edge      (irun,irise+1)
C    irun ....... Horizontal   dimension
C    irise ...... Vertical     dimension
C
C  OUTPUT:
C  =======
C    cloud ...... Cloud Fraction        (irun,irise)
C
C***********************************************************************

      implicit none
      integer  irun,irise

      _RL   th(irun,irise)
      _RL    q(irun,irise)
      _RL  plk(irun,irise)
      _RL   pl(irun,irise)
      _RL plke(irun,irise+1)

      _RL  cloud(irun,irise)
      _RL cldwat(irun,irise)
      _RL     qs(irun,irise)

      _RL cp, alhl, getcon, akap
      _RL ratio, temp, elocp
      _RL rhcrit,rh,dum
      integer i,L

      _RL rhc(irun,irise)
      _RL offset,alpha

C Explicit Inline Directives
C --------------------------
#ifdef FIZHI_CRAY
#ifdef FIZHI_F77_COMPIL
cfpp$ expand (qsat)
#endif
#endif

      cp     = getcon('CP')
      alhl   = getcon('LATENT HEAT COND')
      elocp  = alhl/cp
      akap   = getcon('KAPPA')

      do L = 1,irise
      do i = 1,irun
                  temp = th(i,L)*plk(i,L)
      call qsat ( temp,pl(i,L),qs(i,L),dum,.false. )
      enddo
      enddo

      do L  = 2,irise
      do i  = 1,irun
      rh    = q(i,L)/qs(i,L)

      rhcrit = rhc(i,L) - offset
      ratio  = alpha*(rh-rhcrit)/offset

      if(cloud(i,L).eq.  0.0 .and. ratio.gt.0.0 ) then
         cloud(i,L) = min( ratio,1.0 _d 0)
      endif

      enddo
      enddo

C Reduce clouds from conditionally unstable layer
C -----------------------------------------------
      call ctei ( th,q,cloud,cldwat,pl,plk,plke,irun,irise )

      return
      end

      subroutine ctei ( th,q,cldfrc,cldwat,pl,plk,plke,im,lm )
      implicit none
      integer im,lm
      _RL  th(im,lm),q(im,lm),plke(im,lm+1),cldwat(im,lm)
      _RL plk(im,lm),pl(im,lm),cldfrc(im,lm)
      integer i,L
      _RL    getcon,cp,alhl,elocp,cpoel,t,p,s,qs,dqsdt,dq
      _RL    k,krd,kmm,f

      cp     = getcon('CP')
      alhl   = getcon('LATENT HEAT COND')
      cpoel  = cp/alhl
      elocp  = alhl/cp

      do L=lm,2,-1
      do i=1,im
          dq = q(i,L)+cldwat(i,L)-q(i,L-1)-cldwat(i,L-1)
      if( dq.eq.0.0 ) dq = 1.0e-20
      k = 1.0 + cpoel*plke(i,L)*( th(i,L)-th(i,L-1) ) / dq

      t = th(i,L)*plk(i,L)
      p = pl(i,L)
      call qsat ( t,p,qs,dqsdt,.true. )

      krd = ( cpoel*t*(1+elocp*dqsdt) )/( 1 + 1.608*dqsdt*t )

      kmm = ( 1+elocp*dqsdt )*( 1 + 0.392*cpoel*t )
     .    / ( 2+(1+1.608*cpoel*t)*elocp*dqsdt )

      s = ( (k-krd)/(kmm-krd) )
c     f = 1.0 - min( 1.0 _d 0, max(0.0 _d 0,1.0-exp(-s)) )
C- to avoid floating overflow in exp(-s):
      f = 1.
      if (s.GT.0. ) f = max( 0.0 _d 0, min( 1.0 _d 0, exp(-s)) )

      cldfrc(i,L) = cldfrc(i,L)*f
      cldwat(i,L) = cldwat(i,L)*f

      enddo
      enddo

      return
      end

      subroutine back2grd(gathered,indeces,scattered,irun)
      implicit none
      integer i,irun,indeces(irun)
      _RL gathered(irun),scattered(irun)
      _RL temp(irun)
      do i = 1,irun
       temp(indeces(i)) = gathered(i)
      enddo
      do i = 1,irun
       scattered(i) = temp(i)
      enddo
      return
      end

#include "MDSIO_OPTIONS.h"

CBOP
C !ROUTINE: MDS_WRITELOCAL
C !INTERFACE:
      SUBROUTINE MDS_WRITELOCAL(
     I   fName,
     I   filePrec,
     I   globFile,
     I   arrType,
     I   nNz,
     I   fldRL, fldRS,
     I   biArg, bjArg,
     I   irecord,
     I   myIter,
     I   myThArg )

C !DESCRIPTION:
C Arguments:
C
C fName     (string)  :: base name for file to write
C filePrec  (integer) :: number of bits per word in file (32 or 64)
C globalFile (logical):: selects between writing a global or tiled file
C arrType   (char(2)) :: which array (fldRL/RS) to write, either "RL" or "RS"
C nNz       (integer) :: size of third dimension: normally either 1 or Nr
C fldRL       ( RL )  :: array to write if arrType="RL", fldRL(:,:,nNz)
C fldRS       ( RS )  :: array to write if arrType="RS", fldRS(:,:,nNz)
C biArg     (integer) :: tile X-index argument
C bjArg     (integer) :: tile Y-index argument
C irecord   (integer) :: record number to write
C myIter    (integer) :: time step number
C myThArg   (integer) :: thread argument (= my Thread Id or = 0 to simply
C                        write 1 tile without thread synchronisation)
C
C MDS_WRITELOCAL write a local-tile array corresponding to tile biArg,bjArg
C  of this Process. Threading: with myThArg=0 or when LOCBIN_IO_THREAD_SAFE
C  is defined, go for a strait writing of this tile ; otherwise, use the
C  shared buffer IO to store data from all threads, then synchronise and
C  let the master thread write nThreads tiles. If multiple tiles per thread,
C  will repeat this sequence each time this S/R is called by the master thread
C  with a different biArg,biArg. IMPORTANT: 2nd case requires that all threads
C  call this S/R and assumes symmetry in tiles per thread treatment.
C Convention regarding thread synchronisation (BARRIER): see mdsio_write_field.F
C MDS_WRITELOCAL creates either a file of the form "fName.data" and
C  "fName.meta" if the logical flag "globalFile" is set true. Otherwise
C  it creates MDS tiled files of the form "fName.xxx.yyy.data" and
C  "fName.xxx.yyy.meta". A meta-file is always created.
C Currently, the meta-files are not read because it is difficult
C  to parse files in fortran. We should read meta information before
C  adding records to an existing multi-record file.
C The precision of the file is decsribed by filePrec, set either
C  to floatPrec32 or floatPrec64. The char*(2) string arrType, either
C  "RL" or "RS", selects which array is written, either fldRL or fldRS.
C nNz allows for both 2-D and 3-D arrays to be handled. nNz=1 implies
C  a 2-D model field and nNz=Nr implies a 3-D model field.
C irecord is the record number to be written and must be >= 1.
C NOTE: It is currently assumed that the highest record number in the file
C  was the last record written. Nor is there a consistency check between the
C  routine arguments and file, i.e., if you write record 2 after record 4
C  the meta information will record the number of records to be 2. This,
C  again, is because we have read the meta information. To be fixed.
C
C Created: 03/16/99 adcroft@mit.edu
C Changed: 05/31/00 heimbach@mit.edu
C          open(dUnit, ..., status='old', ... -> status='unknown'
CEOP

C !USES:
      IMPLICIT NONE
C Global variables / common blocks
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#ifdef ALLOW_EXCH2
#include "W2_EXCH2_SIZE.h"
#include "W2_EXCH2_TOPOLOGY.h"
#include "W2_EXCH2_PARAMS.h"
#endif /* ALLOW_EXCH2 */
#ifdef ALLOW_FIZHI
# include "fizhi_SIZE.h"
#endif /* ALLOW_FIZHI */
#include "MDSIO_BUFF_3D.h"

C !INPUT PARAMETERS:
      CHARACTER*(*) fName
      INTEGER filePrec
      LOGICAL globFile
      CHARACTER*(2) arrType
      INTEGER nNz
      _RL fldRL(*)
      _RS fldRS(*)
      INTEGER biArg, bjArg
      INTEGER irecord
      INTEGER myIter
      INTEGER myThArg
C !OUTPUT PARAMETERS:

C !FUNCTIONS
      INTEGER ILNBLNK
      INTEGER MDS_RECLEN
      EXTERNAL ILNBLNK, MDS_RECLEN

C !LOCAL VARIABLES:
C     bBij  :: base shift in Buffer index for tile bi,bj
      CHARACTER*(MAX_LEN_FNAM) dataFName,metaFName
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      LOGICAL fileIsOpen
      LOGICAL globalFile
      LOGICAL iAmDoingIO
      INTEGER xSize, ySize
      INTEGER iG,jG
      INTEGER i1,i2,i,j,k
      INTEGER irec,dUnit,IL
      INTEGER dimList(3,3),nDims, map2gl(2)
      INTEGER length_of_rec
      INTEGER bBij
      INTEGER bi, bj
      INTEGER myThid, ith, nthLoop
      INTEGER tNx, tNy, global_nTx
      INTEGER tBx, tBy, iGjLoc, jGjLoc
#ifdef ALLOW_EXCH2
      INTEGER tN
#endif /* ALLOW_EXCH2 */
      _RL dummyRL(1)
      CHARACTER*8 blank8c

      DATA dummyRL(1) / 0. _d 0 /
      DATA blank8c / '        ' /

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C Set dimensions:
      xSize = Nx
      ySize = Ny
#ifdef ALLOW_EXCH2
      IF ( W2_useE2ioLayOut ) THEN
        xSize = exch2_global_Nx
        ySize = exch2_global_Ny
      ENDIF
#endif /* ALLOW_EXCH2 */

C-    default:
      iGjLoc = 0
      jGjLoc = 1

      IL = ILNBLNK( fName )
      globalFile = globFile
      myThid = MAX(myThArg,1)
#ifdef LOCBIN_IO_THREAD_SAFE
      nthLoop = 1
      iAmDoingIO = .TRUE.
#else /* LOCBIN_IO_THREAD_SAFE */
      nthLoop = nThreads
      IF ( myThArg.EQ.0 ) nthLoop = 1
      iAmDoingIO = .FALSE.
      IF ( myThid.EQ.1 ) iAmDoingIO = .TRUE.
#endif /* LOCBIN_IO_THREAD_SAFE */

      IF ( nThreads.GT.1 .AND. globFile ) THEN
C-    do not assume safe Muti-Threaded Binary IO to a single global file
C      => switch to tiled file
        globalFile = .FALSE.
        IF ( debugLevel.GE.debLevA .AND. IL.GT.0 ) THEN
         WRITE(msgBuf,'(A,I10,A,2I5,A)')
     &    'MDS_WRITELOCAL (it=', myIter, ' ; bi,bj=', biArg,bjArg,
     &    ' ): No global-file multi-threaded IO'
         CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                       SQUEEZE_RIGHT , myThid )
         WRITE(msgBuf,'(2A)')
     &    'MDS_WRITELOCAL: => write tiled file: ', fName(1:IL)
         CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                       SQUEEZE_RIGHT , myThid )
        ENDIF
      ENDIF

C Record number must be >= 1
      IF (irecord .LT. 1) THEN
        WRITE(msgBuf,'(3A,I10)')
     &    ' MDS_WRITELOCAL: file="', fName(1:IL), '" , iter=', myIter
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                      SQUEEZE_RIGHT , myThid )
        WRITE(msgBuf,'(A,I9.8)')
     &    ' MDS_WRITELOCAL: argument irecord = ',irecord
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                      SQUEEZE_RIGHT , myThid )
        WRITE(msgBuf,'(A)')
     &    ' MDS_WRITELOCAL: invalid value for irecord'
        CALL PRINT_ERROR( msgBuf, myThid )
        CALL ALL_PROC_DIE( myThArg )
        STOP 'ABNORMAL END: S/R MDS_WRITELOCAL'
      ENDIF
C check for 3-D Buffer size:
      IF ( .NOT.useSingleCpuIO .AND. nNz.GT.size3dBuf ) THEN
        WRITE(msgBuf,'(3A,I10)')
     &    ' MDS_WRITELOCAL: file="', fName(1:IL), '" , iter=', myIter
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                      SQUEEZE_RIGHT , myThid )
        WRITE(msgBuf,'(3(A,I6))')
     &    ' MDS_WRITELOCAL: Nb Lev to write =', nNz,
     &    ' >', size3dBuf, ' = buffer 3rd Dim'
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                      SQUEEZE_RIGHT , myThid )
        WRITE(msgBuf,'(A)')
     &    ' MDS_WRITELOCAL: buffer 3rd Dim. too small'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(A)')
     &    ' increase "size3dBuf" in "MDSIO_BUFF_3D.h" and recompile'
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                      SQUEEZE_RIGHT , myThid )
        CALL ALL_PROC_DIE( myThArg )
        STOP 'ABNORMAL END: S/R MDS_WRITELOCAL'
      ENDIF

C Wait for all thread to finish. This prevents other threads (e.g., master)
C  to continue to acces 3-D buffer while this thread is filling it.
      IF ( nthLoop.GT.1 ) CALL BAR2( myThid )

C-------------------------------------------------
C---    Copy from fldRL/RS to 3-D buffer (multi-threads):
      IF ( filePrec.EQ.precFloat32 ) THEN
          IF ( arrType.EQ.'RS' ) THEN
            CALL MDS_PASS_R4toRS( shared3dBuf_r4, fldRS,
     I           0, 0, nNz, 1, nNz, biArg, bjArg, .FALSE., myThid )
          ELSEIF ( arrType.EQ.'RL' ) THEN
            CALL MDS_PASS_R4toRL( shared3dBuf_r4, fldRL,
     I           0, 0, nNz, 1, nNz, biArg, bjArg, .FALSE., myThid )
          ELSE
            WRITE(msgBuf,'(A)')
     &         ' MDS_WRITELOCAL: illegal value for arrType'
            CALL PRINT_ERROR( msgBuf, myThid )
            CALL ALL_PROC_DIE( myThArg )
            STOP 'ABNORMAL END: S/R MDS_WRITELOCAL'
          ENDIF
      ELSEIF ( filePrec.EQ.precFloat64 ) THEN
          IF ( arrType.EQ.'RS' ) THEN
            CALL MDS_PASS_R8toRS( shared3dBuf_r8, fldRS,
     I           0, 0, nNz, 1, nNz, biArg, bjArg, .FALSE., myThid )
          ELSEIF ( arrType.EQ.'RL' ) THEN
            CALL MDS_PASS_R8toRL( shared3dBuf_r8, fldRL,
     I           0, 0, nNz, 1, nNz, biArg, bjArg, .FALSE., myThid )
          ELSE
            WRITE(msgBuf,'(A)')
     &         ' MDS_WRITELOCAL: illegal value for arrType'
            CALL PRINT_ERROR( msgBuf, myThid )
            CALL ALL_PROC_DIE( myThArg )
            STOP 'ABNORMAL END: S/R MDS_WRITELOCAL'
          ENDIF
      ELSE
          WRITE(msgBuf,'(A)')
     &         ' MDS_WRITELOCAL: illegal value for filePrec'
          CALL PRINT_ERROR( msgBuf, myThid )
          CALL ALL_PROC_DIE( myThArg )
          STOP 'ABNORMAL END: S/R MDS_WRITELOCAL'
      ENDIF
C-------------------------------------------------

C Wait for all threads to finish filling shared buffer
      IF ( nthLoop.GT.1 ) CALL BAR2( myThid )

C Only do I/O if I am the master thread
      IF ( iAmDoingIO ) THEN

C Assume nothing
        fileIsOpen=.FALSE.

C Assign a free unit number as the I/O channel for this routine
        CALL MDSFINDUNIT( dUnit, myThid )

C If we are writing to a global file then we open it here
        IF (globalFile) THEN
          WRITE(dataFName,'(2A)') fName(1:IL),'.data'
          length_of_rec = MDS_RECLEN( filePrec, sNx, myThid )
          IF (irecord .EQ. 1) THEN
           OPEN( dUnit, file=dataFName, status='unknown',
     &           access='direct', recl=length_of_rec )
          ELSE
           OPEN( dUnit, file=dataFName, status=_OLD_STATUS,
     &           access='direct', recl=length_of_rec )
          ENDIF
          fileIsOpen=.TRUE.
        ENDIF

C Loop over tiles
        DO ith=1,nthLoop
          bi = biArg + myBxLo(ith) - 1
          bj = bjArg + myByLo(ith) - 1

          bBij = sNx*sNy*nNz*( bi-1 + (bj-1)*nSx )
          i1 = bBij + 1
#ifdef _BYTESWAPIO
          IF ( filePrec.EQ.precFloat32 ) THEN
            CALL MDS_BYTESWAPR4( sNx*sNy*nNz, shared3dBuf_r4(i1) )
          ELSE
            CALL MDS_BYTESWAPR8( sNx*sNy*nNz, shared3dBuf_r8(i1) )
          ENDIF
#endif

          tNx = sNx
          tNy = sNy
          global_nTx = xSize/sNx
          tBx = myXGlobalLo-1 + (bi-1)*sNx
          tBy = myYGlobalLo-1 + (bj-1)*sNy
#ifdef ALLOW_EXCH2
          IF ( W2_useE2ioLayOut ) THEN
            tN = W2_myTileList(bi,bj)
c           global_nTx = exch2_global_Nx/sNx
            tBx = exch2_txGlobalo(tN) - 1
            tBy = exch2_tyGlobalo(tN) - 1
            IF   ( exch2_mydNx(tN) .GT. xSize ) THEN
C-          face x-size larger than glob-size : fold it
              iGjLoc = 0
              jGjLoc = exch2_mydNx(tN) / xSize
            ELSEIF ( exch2_tNy(tN) .GT. ySize ) THEN
C-          tile y-size larger than glob-size : make a long line
              iGjLoc = exch2_mydNx(tN)
              jGjLoc = 0
            ELSE
C-          default (face fit into global-IO-array)
              iGjLoc = 0
              jGjLoc = 1
            ENDIF
          ENDIF
#endif /* ALLOW_EXCH2 */

          IF (globalFile) THEN
C--- Case of 1 Global file:

           DO k=1,nNz
            DO j=1,sNy
C-       compute record number:
             irec = 1 + ( tBx + (j-1)*iGjLoc )/tNx
     &                + ( tBy + (j-1)*jGjLoc )*global_nTx
     &            +  ( k-1 + (irecord-1)*nNz )*global_nTx*ySize
             i1 = bBij + 1 + (j-1)*sNx + (k-1)*sNx*sNy
             i2 = bBij +         j*sNx + (k-1)*sNx*sNy
             IF ( filePrec.EQ.precFloat32 ) THEN
               WRITE(dUnit,rec=irec) (shared3dBuf_r4(i),i=i1,i2)
             ELSE
               WRITE(dUnit,rec=irec) (shared3dBuf_r8(i),i=i1,i2)
             ENDIF
C End of j,k loops
            ENDDO
           ENDDO

          ELSE
C--- Case of 1 file per tile (globalFile=F):

C If we are writing to a tiled MDS file then we open each one here
            iG=bi+(myXGlobalLo-1)/sNx
            jG=bj+(myYGlobalLo-1)/sNy
            WRITE(dataFName,'(2A,I3.3,A,I3.3,A)')
     &               fName(1:IL),'.',iG,'.',jG,'.data'
            length_of_rec = MDS_RECLEN( filePrec, sNx*sNy*nNz, myThid )
            IF (irecord .EQ. 1) THEN
             OPEN( dUnit, file=dataFName, status=_NEW_STATUS,
     &             access='direct', recl=length_of_rec )
            ELSE
             OPEN( dUnit, file=dataFName, status=_OLD_STATUS,
     &             access='direct', recl=length_of_rec )
            ENDIF
            fileIsOpen=.TRUE.

            irec = irecord
            i1 = bBij + 1
            i2 = bBij + sNx*sNy*nNz
            IF ( filePrec.EQ.precFloat32 ) THEN
              WRITE(dUnit,rec=irec) (shared3dBuf_r4(i),i=i1,i2)
            ELSE
              WRITE(dUnit,rec=irec) (shared3dBuf_r8(i),i=i1,i2)
            ENDIF

C If we were writing to a tiled MDS file then we close it here
            IF ( fileIsOpen ) THEN
              CLOSE( dUnit )
              fileIsOpen = .FALSE.
            ENDIF

C--- End Global File / tile-file cases
          ENDIF

C Create meta-file for each tile if we are tiling
          IF ( .NOT.globalFile ) THEN
           iG=bi+(myXGlobalLo-1)/sNx
           jG=bj+(myYGlobalLo-1)/sNy
           WRITE(metaFname,'(2A,I3.3,A,I3.3,A)')
     &                fName(1:IL),'.',iG,'.',jG,'.meta'
           dimList(1,1) = xSize
           dimList(2,1) = tBx + 1
           dimList(3,1) = tBx + tNx
           dimList(1,2) = ySize
           dimList(2,2) = tBy + 1
           dimList(3,2) = tBy + tNy
           dimList(1,3) = Nr
           dimList(2,3) = 1
           dimList(3,3) = Nr
           nDims = 3
           IF ( nNz.EQ.1 ) nDims = 2
           map2gl(1) = iGjLoc
           map2gl(2) = jGjLoc
           CALL MDS_WRITE_META(
     I              metaFName, dataFName, the_run_name, ' ',
     I              filePrec, nDims, dimList, map2gl, 0, blank8c,
     I              0, dummyRL, oneRL, irecord, myIter, myThid )
          ENDIF

C End of ith loop
        ENDDO

C If global file was opened then close it
        IF (fileIsOpen .AND. globalFile) THEN
          CLOSE( dUnit )
          fileIsOpen = .FALSE.
        ENDIF

C Create meta-file for the global-file
        IF (globalFile) THEN
         WRITE(metaFName,'(2A)') fName(1:IL),'.meta'
         dimList(1,1) = xSize
         dimList(2,1) = 1
         dimList(3,1) = xSize
         dimList(1,2) = ySize
         dimList(2,2) = 1
         dimList(3,2) = ySize
         dimList(1,3) = Nr
         dimList(2,3) = 1
         dimList(3,3) = Nr
         nDims = 3
         IF ( nNz.EQ.1 ) nDims = 2
         map2gl(1) = 0
         map2gl(2) = 1
         CALL MDS_WRITE_META(
     I              metaFName, dataFName, the_run_name, ' ',
     I              filePrec, nDims, dimList, map2gl, 0, blank8c,
     I              0, dummyRL, oneRL, irecord, myIter, myThid )
        ENDIF

C-    end if iAmDoingIO
      ENDIF

C Make other threads wait for I/O completion so that after this,
C  3-D buffer can again be modified by any thread
c     IF ( nthLoop.GT.1 ) CALL BAR2( myThid )

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
      RETURN
      END

#include "REGRID_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 0
C     !ROUTINE: REGRID_INIT_VARIA

C     !INTERFACE:
      SUBROUTINE REGRID_INIT_VARIA( myThid )

C     !DESCRIPTION:
C     Initialize REGRID variables

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "REGRID_SIZE.h"
#include "REGRID.h"
#ifdef ALLOW_EXCH2
# include "W2_EXCH2_SIZE.h"
# include "W2_EXCH2_TOPOLOGY.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     myThid ::  my Thread Id number
      INTEGER myThid

C     !FUNCTIONS:
      INTEGER  ILNBLNK
      EXTERNAL ILNBLNK

C     !LOCAL VARIABLES:
      INTEGER i,k, iface, uniq_tnum, bi,bj
      INTEGER irx, isrc, idst, nFx,nFy, init_nlpts,nlpts
      INTEGER iUnit, errIO, nnb
      INTEGER iminx,iminy, imaxx,imaxy
      _RL wt
      CHARACTER*(MAX_LEN_FNAM) fname
      CHARACTER*(MAX_LEN_MBUF) msgbuf
      LOGICAL  exst
#ifndef ALLOW_EXCH2
      INTEGER iG, jG
#endif
CEOP

C     Regrid files contain information on a per-face basis.  This is
C     convenient in two respects: (1) the domain can be re-tiled without
C     changing any of the files [since the ordering with respect to
C     tiles is performed here in the model] and (2) when faces are
C     removed or added only the corresponding per-face files will need
C     to be removed or added [and all the other per-face files remain
C     unchanged provided the face numbers do not change].
C
C     The convention is: "points cycle most quickly in X and then Y"
C
C        +-------------------+
C        |  Face             |
C        |                   |
C        |       +-----+     |
C      Y |       |Tile |     |
C        |       +-----+     |
C        |                   |
C        |123...             |
C        +-------------------+
C                X

      _BEGIN_MASTER( myThid )

      WRITE(msgBuf,'(a)')
     &     '// ======================================================='
      CALL PRINT_MESSAGE(msgBuf,standardMessageUnit,
     &     SQUEEZE_RIGHT,myThid)
      WRITE(msgBuf,'(a)')
     &     '// Begin reading the per-face REGRID information'
      CALL PRINT_MESSAGE(msgBuf,standardMessageUnit,
     &     SQUEEZE_RIGHT,myThid)
      WRITE(msgBuf,'(a)')
     &     '// ======================================================='
      CALL PRINT_MESSAGE(msgBuf,standardMessageUnit,
     &     SQUEEZE_RIGHT,myThid)

      nlpts = 0

      CALL MDSFINDUNIT(iUnit, myThid)

      DO bj = myByLo(myThid), myByHi(myThid)
        DO bi = myBxLo(myThid), myBxHi(myThid)

#ifdef ALLOW_EXCH2
C         EXCH2 domains
          uniq_tnum = W2_myTileList(bi,bj)
          iface = exch2_myFace(uniq_tnum)
          nFx = exch2_mydnx(uniq_tnum)
          nFy = exch2_mydny(uniq_tnum)
          iminx = exch2_tbasex(uniq_tnum) + 1
          imaxx = iminx + exch2_tnx(uniq_tnum) - 1
          iminy = exch2_tbasey(uniq_tnum) + 1
          imaxy = iminy + exch2_tny(uniq_tnum) - 1
#else
C         Global tile number for simple single-face "EXCH1" domains
          iG = bi + (myXGlobalLo-1)/sNx
          jG = bj + (myYGlobalLo-1)/sNy
          uniq_tnum = (jG - 1)*(nPx*nSx) + iG
          iface = 1
          nFx = nSx * sNx
          nFy = nSy * sNy
          iminx = myXGlobalLo
          imaxx = myXGlobalLo + sNx - 1
          iminy = myYGlobalLo
          imaxy = myYGlobalLo + sNy - 1
#endif

C         WRITE(*,*) 'iminx, imaxx, nFx, nFy = ',
C         &         iminx, imaxx, nFx, nFy

C         Read through all the weights files for this tile (face) and
C         locate the points that belong to this tile
          DO i = 1,regrid_ngrids

            IF (i .EQ. 1) THEN
              nlpts = 0
            ELSE
              nlpts = REGRID_iend(i,bi,bj)
            ENDIF
            init_nlpts = nlpts

            DO k = 1,MAX_LEN_FNAM
              fname(k:k) = ' '
            ENDDO
            nnb = ILNBLNK(REGRID_fbname_in(i))
            write(fname,'(a,i3.3,a)')
     &           REGRID_fbname_in(i)(1:nnb),iface,'.regrid.ascii'
            nnb = ILNBLNK(fname)
            INQUIRE( FILE=fname, EXIST=exst )
            IF (.NOT. exst) THEN
              WRITE(msgBuf,'(A)')  'S/R REGRID_INIT_VARIA()'
              CALL PRINT_ERROR( msgBuf , 1)
              WRITE(msgBuf,'(3A)')  ' File "',
     &             fname(1:nnb), '" does not exist'
              CALL PRINT_ERROR( msgBuf , 1)
              CLOSE(iUnit)
              STOP ' stopped in REGRID_INIT_VARIA()'
            ENDIF

            open(unit=iUnit, file=fname, status='old', iostat=errIO)

            IF (errIO .LT. 0) THEN
              WRITE(msgBuf,'(A)')  'S/R REGRID_INIT_VARIA()'
              CALL PRINT_ERROR( msgBuf , 1)
              WRITE(msgBuf,'(3A)')  'Unable to open file="',
     &             fname(1:nnb), '"'
              CALL PRINT_ERROR( msgBuf , 1)
              CLOSE(iUnit)
              STOP ' stopped in REGRID_INIT_VARIA()'
            ELSE
              WRITE(msgBuf,'(3a)') 'Reading file "', fname(1:nnb),'"'
              call PRINT_MESSAGE(msgBuf,standardMessageUnit,
     &             SQUEEZE_RIGHT,myThid)
            ENDIF

            DO WHILE ( .TRUE. )
C             READ(iUnit,fmt='(2(I10,1X),1P1E23.13E3)',iostat=errIO)
              READ(iUnit,fmt='(2(1X,I10),1X,E28.22)',iostat=errIO)
     &             isrc, idst, wt
              IF ( errIO .NE. 0 ) THEN
                GOTO 100
              ENDIF
              irx = MOD(isrc,nFx)
              IF (irx .EQ. 0)  irx = nFx
              IF ((iminx .LE. irx) .AND. (irx .LE. imaxx)) THEN
                nlpts = nlpts + 1
                REGRID_i_loc(nlpts,bi,bj) = irx
                REGRID_j_loc(nlpts,bi,bj) = isrc/nFx + 1
                REGRID_i_out(nlpts,bi,bj) = idst
                REGRID_amat(nlpts,bi,bj)  = wt
              ENDIF

            ENDDO
 100        CONTINUE
            close(iUnit)
            WRITE(msgBuf,'(a,i10)') '  num weights read = ',
     &           (nlpts - init_nlpts)
            call PRINT_MESSAGE(msgBuf,standardMessageUnit,
     &           SQUEEZE_RIGHT,myThid)

            REGRID_ibeg(i,bi,bj) = init_nlpts + 1
            REGRID_iend(i,bi,bj) = nlpts
          ENDDO

        ENDDO
      ENDDO

      WRITE(msgBuf,'(a)') ' '
      CALL PRINT_MESSAGE(msgBuf,standardMessageUnit,
     &     SQUEEZE_RIGHT,myThid)

      _END_MASTER( myThid )

      RETURN
      END

#include "AIM_OPTIONS.h"

CBOP
C     !ROUTINE: AIM_SURF_BC
C     !INTERFACE:
      SUBROUTINE AIM_SURF_BC(
     U                        tYear,
     O                        aim_sWght0, aim_sWght1,
     I                        bi, bj, myTime, myIter, myThid )

C     !DESCRIPTION: \bv
C     *================================================================*
C     | S/R AIM_SURF_BC
C     | Set surface Boundary Conditions
C     |  for the atmospheric physics package
C     *================================================================*
c     | was part of S/R FORDATE in Franco Molteni SPEEDY code (ver23).
C     | For now, surface BC are loaded from files (S/R AIM_FIELDS_LOAD)
C     |  and imposed (= surf. forcing).
C     | In the future, will add
C     |  a land model and a coupling interface with an ocean GCM
C     *================================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     -------------- Global variables --------------
C-- size for MITgcm & Physics package :
#include "AIM_SIZE.h"

C-- MITgcm
#include "EEPARAMS.h"
#include "PARAMS.h"
C_EqCh: start
#ifdef ALLOW_EXCH2
# include "W2_EXCH2_SIZE.h"
#endif /* ALLOW_EXCH2 */
#include "SET_GRID.h"
C_EqCh: end
#include "GRID.h"
c #include "DYNVARS.h"
c #include "SURFACE.h"

C-- Physics package
#include "AIM_PARAMS.h"
#include "AIM_FFIELDS.h"
c #include "AIM_GRID.h"
#include "com_forcon.h"
#include "com_forcing.h"
c #include "com_physvar.h"
#include "AIM_CO2.h"

C-- Coupled to the Ocean :
#ifdef COMPONENT_MODULE
#include "CPL_PARAMS.h"
#include "ATMCPL.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     tYear      :: Fraction into year
C     aim_sWght0 :: weight for time interpolation of surface BC
C     aim_sWght1 :: 0/1 = time period before/after the current time
C     bi,bj      :: Tile indices
C     myTime     :: Current time of simulation ( s )
C     myIter     :: Current iteration number in simulation
C     myThid     :: my Thread number Id.
      _RL     tYear
      _RL     aim_sWght0, aim_sWght1
      INTEGER bi, bj
      _RL     myTime
      INTEGER myIter, myThid
CEOP

#ifdef ALLOW_AIM
C     !FUNCTIONS:
C     !LOCAL VARIABLES:
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C--   Local Variables originally (Speedy) in common bloc (com_forcing.h):
C--   COMMON /FORDAY/ Daily forcing fields (updated in FORDATE)
C     oice1      :: sea ice fraction
C     snow1      :: snow depth (mm water)
      _RL     oice1(NGP)
      _RL     snow1(NGP)
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C     == Local variables ==
C     i,j,k,I2,k   :: Loop counters
      INTEGER i,j,I2,k, nm0
      _RL t0prd, tNcyc, tmprd, dTprd
      _RL SDEP1, IDEP2, SDEP2, SWWIL2, RSW, soilw_0, soilw_1
      _RL RSD, alb_land, oceTfreez, ALBSEA1, ALPHA, CZEN, CZEN2
      _RL RZEN, ZS, ZC, SJ, CJ, TMPA, TMPB, TMPL, hlim
c     _RL DALB, alb_sea
#ifdef ALLOW_AIM_CO2
#ifdef ALLOW_DIAGNOSTICS
      _RL pCO2scl
#endif
#endif /* ALLOW_AIM_CO2 */

C_EqCh: start
      CHARACTER*(MAX_LEN_MBUF) suff
      _RL xBump, yBump, dxBump, dyBump
      xBump = xgOrigin + delX(1)*64.
      yBump = ygOrigin   + delY(1)*11.5
      dxBump=  delX(1)*12.
      dyBump=  delY(1)*6.
C_EqCh: Fix solar insolation with Sun directly overhead on Equator
      tYear = 0.25 _d 0 - 10. _d 0/365. _d 0
C_EqCh: end

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C-    Set Land-sea mask (in [0,1]) from aim_landFr to fMask1:
      DO j=1,sNy
        DO i=1,sNx
          I2 = i+(j-1)*sNx
          fMask1(I2,1,myThid) = aim_landFr(i,j,bi,bj)
        ENDDO
      ENDDO

      IF (aim_useFMsurfBC) THEN
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C     aim_surfForc_TimePeriod :: Length of forcing time period (e.g. 1 month)
C     aim_surfForc_NppCycle   :: Number of time period per Cycle (e.g. 12)
C     aim_surfForc_TransRatio ::
C-     define how fast the (linear) transition is from one month to the next
C       = 1                 -> linear between 2 midle month
C       > TimePeriod/deltaT -> jump from one month to the next one

C--   Calculate weight for linear interpolation between 2 month centers
        t0prd = myTime / aim_surfForc_TimePeriod
        tNcyc = aim_surfForc_NppCycle
        tmprd = t0prd - 0.5 _d 0 + tNcyc
        tmprd = MOD(tmprd,tNcyc)
C-     indices of previous month (nm0) and next month (nm1):
        nm0 = 1 + INT(tmprd)
c       nm1 = 1 + MOD(nm0,aim_surfForc_NppCycle)
C-     interpolation weight:
        dTprd = tmprd - (nm0 - 1)
        aim_sWght1 = 0.5 _d 0+(dTprd-0.5 _d 0)*aim_surfForc_TransRatio
        aim_sWght1 = MAX( 0. _d 0, MIN(1. _d 0, aim_sWght1) )
        aim_sWght0 = 1. _d 0 - aim_sWght1

C--   Compute surface forcing at present time (linear Interp in time)
C     using F.Molteni surface BC form ; fields needed are:
C     1. Sea  Surface temperatures  (in situ Temp. [K])
C     2. Land Surface temperatures  (in situ Temp. [K])
C     3. Soil moisture         (between 0-1)
C     4. Snow depth, Sea Ice : used to compute albedo (=> local arrays)
C     5. Albedo                (between 0-1)

C-    Surface Temperature:
        DO j=1,sNy
         DO i=1,sNx
          I2 = i+(j-1)*sNx
          sst1(I2,myThid) = aim_sWght0*aim_sst0(i,j,bi,bj)
     &                    + aim_sWght1*aim_sst1(i,j,bi,bj)
          stl1(I2,myThid) = aim_sWght0*aim_lst0(i,j,bi,bj)
     &                    + aim_sWght1*aim_lst1(i,j,bi,bj)
         ENDDO
        ENDDO

C-    Soil Water availability : (from F.M. INFORC S/R)
        SDEP1 = 70. _d 0
        IDEP2 =  3. _d 0
        SDEP2 = IDEP2*SDEP1

        SWWIL2= SDEP2*SWWIL
        RSW   = 1. _d 0/(SDEP1*SWCAP+SDEP2*(SWCAP-SWWIL))

        DO j=1,sNy
         DO i=1,sNx
          I2 = i+(j-1)*sNx
          soilw_0 = ( aim_sw10(i,j,bi,bj)
     &     +aim_veget(i,j,bi,bj)*
     &      MAX(IDEP2*aim_sw20(i,j,bi,bj)-SWWIL2, 0. _d 0)
     &              )*RSW
          soilw_1 = ( aim_sw11(i,j,bi,bj)
     &     +aim_veget(i,j,bi,bj)*
     &      MAX(IDEP2*aim_sw21(i,j,bi,bj)-SWWIL2, 0. _d 0)
     &              )*RSW
          soilw1(I2,myThid) = aim_sWght0*soilw_0
     &                      + aim_sWght1*soilw_1
          soilw1(I2,myThid) = MIN(1. _d 0, soilw1(I2,myThid) )
         ENDDO
        ENDDO

C-    Set snow depth & sea-ice fraction :
        DO j=1,sNy
         DO i=1,sNx
          I2 = i+(j-1)*sNx
          snow1(I2) = aim_sWght0*aim_snw0(i,j,bi,bj)
     &              + aim_sWght1*aim_snw1(i,j,bi,bj)
          oice1(I2) = aim_sWght0*aim_oic0(i,j,bi,bj)
     &              + aim_sWght1*aim_oic1(i,j,bi,bj)
         ENDDO
        ENDDO

        IF (aim_splitSIOsFx) THEN
C-    Split Ocean and Sea-Ice surf. temp. ; remove ice-fraction < 1 %
c        oceTfreez = tFreeze - 1.9 _d 0
         oceTfreez = celsius2K - 1.9 _d 0
         DO J=1,NGP
          sti1(J,myThid) = sst1(J,myThid)
          IF ( oice1(J) .GT. 1. _d -2 ) THEN
            sst1(J,myThid) = MAX(sst1(J,myThid),oceTfreez)
            sti1(J,myThid) = sst1(J,myThid)
     &                     +(sti1(J,myThid)-sst1(J,myThid))/oice1(J)
          ELSE
            oice1(J) = 0. _d 0
          ENDIF
         ENDDO
        ELSE
         DO J=1,NGP
          sti1(J,myThid) = sst1(J,myThid)
         ENDDO
        ENDIF

C-    Surface Albedo : (from F.M. FORDATE S/R)
c_FM    DALB=ALBICE-ALBSEA
        RSD=1. _d 0/SDALB
        ALPHA= 2. _d 0*PI*(TYEAR+10. _d 0/365. _d 0)
#ifdef ALLOW_INSOLATION
        ZS = - SIN(OBLIQ * deg2rad) * COS(ALPHA)
        ZC =   ASIN( ZS )
        ZC =   COS(ZC)
#else /* ALLOW_INSOLATION */
        RZEN = COS(ALPHA) * ( -23.45 _d 0 * deg2rad)
        ZC = COS(RZEN)
        ZS = SIN(RZEN)
#endif /* ALLOW_INSOLATION */
        DO j=1,sNy
         DO i=1,sNx
c_FM      SNOWC=MIN(1.,RSD*SNOW1(I,J))
c_FM      ALBL=ALB0(I,J)+MAX(ALBSN-ALB0(I,J),0.0)*SNOWC
c_FM      ALBS=ALBSEA+DALB*OICE1(I,J)
c_FM      ALB1(I,J)=FMASK1(I,J)*ALBL+FMASK0(I,J)*ALBS
          I2 = i+(j-1)*sNx
          alb_land = aim_albedo(i,j,bi,bj)
     &       + MAX( 0. _d 0, ALBSN-aim_albedo(i,j,bi,bj) )
     &        *MIN( 1. _d 0, RSD*snow1(I2))
c         alb_sea  = ALBSEA + DALB*oice1(I2)
c         alb1(I2,0,myThid) = alb_sea
c    &        + (alb_land - alb_sea)*fMask1(I2,1,myThid)
          ALBSEA1 = ALBSEA
          IF ( aim_selectOceAlbedo .EQ. 1) THEN
           SJ = SIN(yC(i,j,bi,bj) * deg2rad)
           CJ = COS(yC(i,j,bi,bj) * deg2rad)
           TMPA = SJ*ZS
           TMPB = CJ*ZC
           TMPL = -TMPA/TMPB
           IF (TMPL .GE. 1.0 _d 0) THEN
            CZEN = 0.0 _d 0
           ELSEIF (TMPL .LE. -1.0 _d 0) THEN
            CZEN = (2.0 _d 0)*TMPA*PI
            CZEN2= PI*((2.0 _d 0)*TMPA*TMPA + TMPB*TMPB)
            CZEN = CZEN2/CZEN
           ELSE
            hlim = ACOS(TMPL)
            CZEN = 2.0 _d 0*(TMPA*hlim + TMPB*SIN(hlim))
            CZEN2= 2.0 _d 0*TMPA*TMPA*hlim
     &          + 4.0 _d 0*TMPA*TMPB*SIN(hlim)
     &          + TMPB*TMPB*( hlim + 0.5 _d 0*SIN(2.0 _d 0*hlim) )
            CZEN = CZEN2/CZEN
           ENDIF
           ALBSEA1 = ( ( 2.6 _d 0 / (CZEN**(1.7 _d 0) + 0.065 _d 0) )
     &          + ( 15. _d 0 * (CZEN-0.1 _d 0) * (CZEN-0.5 _d 0)
     &          * (CZEN-1.0 _d 0) ) ) / 100.0 _d 0
          ENDIF
          alb1(I2,1,myThid) = alb_land
C_DE      alb1(I2,2,myThid) = ALBSEA
          alb1(I2,2,myThid) = 0.5 _d 0 * ALBSEA
     &        + 0.5 _d 0 * ALBSEA1
          alb1(I2,3,myThid) = ALBICE
         ENDDO
        ENDDO

C-- else aim_useFMsurfBC
      ELSE
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C-    safer to initialise output argument aim_sWght0,1
C     even if they are not used when aim_useFMsurfBC=F
        aim_sWght1 = 0. _d 0
        aim_sWght0 = 1. _d 0

C-    Set surface forcing fields needed by atmos. physics package
C     1. Albedo                (between 0-1)
C     2. Sea  Surface temperatures  (in situ Temp. [K])
C     3. Land Surface temperatures  (in situ Temp. [K])
C     4. Soil moisture         (between 0-1)
C        Snow depth, Sea Ice (<- no need for now)

C      Set surface albedo data (in [0,1]) from aim_albedo to alb1 :
       IF (aim_useMMsurfFc) THEN
        DO j=1,sNy
         DO i=1,sNx
          I2 = i+(j-1)*sNx
          alb1(I2,1,myThid) = aim_albedo(i,j,bi,bj)
          alb1(I2,2,myThid) = aim_albedo(i,j,bi,bj)
          alb1(I2,3,myThid) = aim_albedo(i,j,bi,bj)
         ENDDO
        ENDDO
       ELSE
        DO j=1,sNy
         DO i=1,sNx
          I2 = i+(j-1)*sNx
          alb1(I2,1,myThid) = 0.
          alb1(I2,2,myThid) = 0.
          alb1(I2,3,myThid) = 0.
         ENDDO
        ENDDO
       ENDIF
C      Set surface temperature data from aim_S/LSurfTemp to sst1 & stl1 :
       IF (aim_useMMsurfFc) THEN
        DO j=1,sNy
         DO i=1,sNx
          I2 = i+(j-1)*sNx
          sst1(I2,myThid) = aim_sst0(i,j,bi,bj)
          stl1(I2,myThid) = aim_sst0(i,j,bi,bj)
          sti1(I2,myThid) = aim_sst0(i,j,bi,bj)
         ENDDO
        ENDDO
       ELSE
        DO j=1,sNy
         DO i=1,sNx
          I2 = i+(j-1)*sNx
          sst1(I2,myThid) = 300.
          stl1(I2,myThid) = 300.
          sti1(I2,myThid) = 300.
C_EqCh: start
          sst1(I2,myThid) = 280.
     &     +20. _d 0 *exp( -((xC(i,j,bi,bj)-xBump)/dxBump)**2
     &                     -((yC(i,j,bi,bj)-yBump)/dyBump)**2 )
          stl1(I2,myThid) = sst1(I2,myThid)
          sti1(I2,myThid) = sst1(I2,myThid)
C_EqCh: end
         ENDDO
        ENDDO
C_EqCh: start
        IF (myIter.EQ.nIter0) THEN
         WRITE(suff,'(I10.10)') myIter
         CALL AIM_WRITE_PHYS( 'aim_SST.', suff, 1,sst1,
     &                        1, bi, bj, 1, myIter, myThid )
        ENDIF
C_EqCh: end
       ENDIF

C-     Set soil water availability (in [0,1]) from aim_sw10 to soilw1 :
       IF (aim_useMMsurfFc) THEN
        DO j=1,sNy
         DO i=1,sNx
          I2 = i+(j-1)*sNx
          soilw1(I2,myThid) = aim_sw10(i,j,bi,bj)
         ENDDO
        ENDDO
       ELSE
        DO j=1,sNy
         DO i=1,sNx
          I2 = i+(j-1)*sNx
          soilw1(I2,myThid) = 0.
         ENDDO
        ENDDO
       ENDIF

C-     Set Snow depth and Sea Ice
C      (not needed here since albedo is loaded from file)
        DO j=1,sNy
         DO i=1,sNx
          I2 = i+(j-1)*sNx
          oice1(I2) = 0.
          snow1(I2) = 0.
         ENDDO
        ENDDO

C-- endif/else aim_useFMsurfBC
      ENDIF

#ifdef COMPONENT_MODULE
      IF ( useCoupler ) THEN
C--   take surface data from the ocean component
C     to replace MxL fields (if use sea-ice) or directly AIM SST
        CALL ATM_APPLY_IMPORT(
     I           aim_landFr,
     U           sst1(1,myThid), oice1,
     I           myTime, myIter, bi, bj, myThid )
      ENDIF
#endif /* COMPONENT_MODULE */

#ifdef ALLOW_AIM_CO2
      DO j=1,sNy
        DO i=1,sNx
           I2 = i+(j-1)*sNx
           aim_CO2(I2,myThid)= atm_pCO2
        ENDDO
      ENDDO
#ifdef ALLOW_DIAGNOSTICS
      IF ( useDiagnostics ) THEN
         pCO2scl = 1. _d 6
         CALL DIAGNOSTICS_SCALE_FILL( aim_CO2(1,myThid), pCO2scl, 1,
     &                  'aim_pCO2', 1, 1, 3, bi, bj, myThid )
      ENDIF
#endif /* ALLOW_DIAGNOSTICS */
#endif /* ALLOW_AIM_CO2 */

#ifdef ALLOW_LAND
      IF (useLand) THEN
C-    Use land model output instead of prescribed Temp & moisture
        CALL AIM_LAND2AIM(
     I           aim_landFr, aim_veget, aim_albedo, snow1,
     U           stl1(1,myThid), soilw1(1,myThid), alb1(1,1,myThid),
     I           myTime, myIter, bi, bj, myThid )
      ENDIF
#endif /* ALLOW_LAND */

#ifdef ALLOW_THSICE
      IF (useThSIce) THEN
C-    Use thermo. sea-ice model output instead of prescribed Temp & albedo
        CALL AIM_SICE2AIM(
     I           aim_landFr,
     U           sst1(1,myThid), oice1,
     O           sti1(1,myThid), alb1(1,3,myThid),
     I           myTime, myIter, bi, bj, myThid )
      ENDIF
#endif /* ALLOW_THSICE */

C-- set the sea-ice & open ocean fraction :
        DO J=1,NGP
          fMask1(J,3,myThid) =(1. _d 0 - fMask1(J,1,myThid))
     &                        *oice1(J)
          fMask1(J,2,myThid) = 1. _d 0 - fMask1(J,1,myThid)
     &                                 - fMask1(J,3,myThid)
        ENDDO

C-- set the mean albedo :
        DO J=1,NGP
          alb1(J,0,myThid) = fMask1(J,1,myThid)*alb1(J,1,myThid)
     &                     + fMask1(J,2,myThid)*alb1(J,2,myThid)
     &                     + fMask1(J,3,myThid)*alb1(J,3,myThid)
        ENDDO

C-- initialize surf. temp. change to zero:
        DO k=1,3
         DO J=1,NGP
          dTsurf(J,k,myThid) = 0.
         ENDDO
        ENDDO

        IF (.NOT.aim_splitSIOsFx) THEN
         DO J=1,NGP
          fMask1(J,3,myThid) = 0. _d 0
          fMask1(J,2,myThid) = 1. _d 0 - fMask1(J,1,myThid)
         ENDDO
        ENDIF

#endif /* ALLOW_AIM */

      RETURN
      END

#include "OBCS_OPTIONS.h"

CBOP
C     !ROUTINE: OBCS_CALC

C     !INTERFACE:
      SUBROUTINE OBCS_CALC( futureTime, futureIter,
     &                      uVel, vVel, wVel, theta, salt,
     &                      myThid )

C     !DESCRIPTION:
C     *==========================================================*
C     | SUBROUTINE OBCS_CALC
C     | o Calculate future boundary data at open boundaries
C     |   at time = futureTime
C     *==========================================================*

C     !USES:
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "OBCS_PARAMS.h"
#include "OBCS_GRID.h"
#include "OBCS_FIELDS.h"
#include "EOS.h"
#ifdef ALLOW_PTRACERS
# include "PTRACERS_SIZE.h"
# include "PTRACERS_PARAMS.h"
# include "PTRACERS_FIELDS.h"
# include "OBCS_PTRACERS.h"
#endif /* ALLOW_PTRACERS */
#ifdef ALLOW_NEST_CHILD
# include "NEST_CHILD.h"
#endif /* ALLOW_NEST_CHILD */

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
      INTEGER futureIter
      _RL futureTime
      _RL uVel (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      _RL vVel (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      _RL wVel (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      _RL theta(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      _RL salt (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      INTEGER myThid

#ifdef ALLOW_OBCS

C     !LOCAL VARIABLES:
C     bi, bj       :: tile indices
C     i,j,k        :: loop indices
C     I_obc, J_obc :: local index of open boundary
C     msgBuf       :: Informational/error message buffer
      INTEGER bi, bj
      INTEGER i, j, k
      _RL rampTime2
      _RL rexpt
      _RL hinit, delh
      _RL z(nr)
      _RL Dmax,Dinf,dTemp,gp_inflow,Lrho
      _RL Width,x,Xcenter,Fz,zt,Rit
#ifdef ALLOW_PTRACERS
      INTEGER I_obc, J_obc
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      INTEGER iTracer
#endif /* ALLOW_PTRACERS */

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_ENTER('OBCS_CALC',myThid)
#endif

c     Total depth
      Dmax = 600. _d 0
c     width of flow transition
      delh=5. _d 0
c     total depth of active layer
      Dinf=300. _d 0
c     g_prime of inflow
      dTemp=(2. _d 0/rhonil)/(2. _d -4)
      gp_inflow=tAlpha*gravity*dTemp
c     Deformation radius
      Lrho=sqrt(gp_inflow*Dinf)/f0
c     dimensional width
      Width=100. _d 3
c     nondimensional width
      Width=Width/Lrho
c      print *,'Width=',Width
c     coordinate of center of embayment
      Xcenter = 1700. _d 3
c     Critical Richardson number
      Rit = 1. _d 0/3. _d 0
c      Ttarget=-5.0e6
c      areaCh=Width*Lrho*Dmax
c      relaxtime=180000.0
c      relaxConst=1.0/(areaCh*relaxtime)


      z(1) = -delR(1)/2. _d 0
      do j=2,nr
Caja NOTE: This gives the depths of W points, not U,V,T,S,p points
C          USe instead drC but requires different indexing. See documentation
C          in AJAs head
      z(j) = z(j-1) - delR(j)
      enddo

c     ramptime for velocity
      rampTime2 = 4. _d 0*44567. _d 0
      rexpt=1. _d 0/exp(futureTime/rampTime2)

      DO bj=myByLo(myThid),myByHi(myThid)
      DO bi=myBxLo(myThid),myBxHi(myThid)

#ifdef ALLOW_NEST_CHILD
      IF ( useNEST_CHILD ) THEN
        IF ( PASSI.LT.2 ) THEN
         CALL NEST_CHILD_RECV ( myThid )
        ENDIF
      ENDIF
#endif /* ALLOW_NEST_CHILD */

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#ifdef ALLOW_OBCS_EAST
C     Eastern OB
#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_MSG('OBCS_CALC: East',myThid)
#endif
      IF (useOrlanskiEast) THEN
#ifdef ALLOW_ORLANSKI
        CALL ORLANSKI_EAST(
     &          bi, bj, futureTime,
     &          uVel, vVel, wVel, theta, salt,
     &          myThid )
#endif
#ifdef ALLOW_NEST_CHILD
      ELSEIF ( useNEST_CHILD ) THEN
        DO k=1,Nr
          DO j=1-OLy,sNy+OLy
            IF ( OB_Ie(j,bi,bj).NE.OB_indexNone ) THEN
              OBEu(j,k,bi,bj)= U_F1(j,k,2)
              OBEv(j,k,bi,bj)= V_F1(j,k,2)
              OBEt(j,k,bi,bj)= T_F1(j,k,2)
              OBEs(j,k,bi,bj)= S_F1(j,k,2)
#ifdef NONLIN_FRSURF
              OBEeta(j,bi,bj)= ETA_F1(j,1,2)
#endif
            ENDIF
          ENDDO
        ENDDO
#endif /* ALLOW_NEST_CHILD */
      ELSE
        DO k=1,Nr
          DO j=1-OLy,sNy+OLy
            IF ( OB_Ie(j,bi,bj).NE.OB_indexNone ) THEN
             OBEu(j,k,bi,bj)=0.
c     &       +Uinflow
c     & *0.5*(1.0 - (exp((z(k)-hinit)/delh)
c     &   - exp(-(z(k)-hinit)/delh))
c     &   /(exp((z(k)-hinit)/delh)
c     &  + exp(-(z(k)-hinit)/delh)))
c     &*(1.0 - rexpt*rexpt)/(1.0 + rexpt*rexpt)
             OBEv(j,k,bi,bj)=0.
             OBEt(j,k,bi,bj)=tRef(k)
c     &  +Tinflow
c     & *0.5*(1.0 - (exp((z(k)-hinit)/delh)
c     &   - exp(-(z(k)-hinit)/delh))
c     &   /(exp((z(k)-hinit)/delh)
c     &  + exp(-(z(k)-hinit)/delh)))
c     &*(1.0 - rexpt*rexpt)/(1.0 + rexpt*rexpt)
              OBEs(j,k,bi,bj)=sRef(k)
#ifdef ALLOW_NONHYDROSTATIC
              OBEw(j,k,bi,bj)=0.
#endif
#ifdef NONLIN_FRSURF
              OBEeta(j,bi,bj)=0.
#endif
            ENDIF
          ENDDO
        ENDDO
      ENDIF
#endif /* ALLOW_OBCS_EAST */

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#ifdef ALLOW_OBCS_WEST
C     Western OB
#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_MSG('OBCS_CALC: West',myThid)
#endif
      IF (useOrlanskiWest) THEN
#ifdef ALLOW_ORLANSKI
        CALL ORLANSKI_WEST(
     &          bi, bj, futureTime,
     &          uVel, vVel, wVel, theta, salt,
     &          myThid )
#endif
#ifdef ALLOW_NEST_CHILD
      ELSEIF ( useNEST_CHILD ) THEN
        DO k=1,Nr
          DO j=1-OLy,sNy+OLy
            IF ( OB_Iw(j,bi,bj).NE.OB_indexNone ) THEN
              OBWu(j,k,bi,bj)= U_F1(j,k,1)
              OBWv(j,k,bi,bj)= V_F1(j,k,1)
              OBWt(j,k,bi,bj)= T_F1(j,k,1)
              OBWs(j,k,bi,bj)= S_F1(j,k,1)
#ifdef NONLIN_FRSURF
              OBWeta(j,bi,bj)= ETA_F1(j,1,1)
#endif
           ENDIF
          ENDDO
        ENDDO
#endif /* ALLOW_NEST_CHILD */
      ELSE
        DO k=1,Nr
          DO j=1-OLy,sNy+OLy
            IF ( OB_Iw(j,bi,bj).NE.OB_indexNone ) THEN
              OBWu(j,k,bi,bj)=0.
              OBWv(j,k,bi,bj)=0.
              OBWt(j,k,bi,bj)=tRef(k)
              OBWs(j,k,bi,bj)=sRef(k)
#ifdef ALLOW_NONHYDROSTATIC
              OBWw(j,k,bi,bj)=0.
#endif
#ifdef NONLIN_FRSURF
              OBWeta(j,bi,bj)=0.
#endif
           ENDIF
          ENDDO
        ENDDO
      ENDIF
#endif /* ALLOW_OBCS_WEST */

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#ifdef ALLOW_OBCS_NORTH
C         Northern OB, template for forcing
#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_MSG('OBCS_CALC: North',myThid)
#endif
      IF (useOrlanskiNorth) THEN
#ifdef ALLOW_ORLANSKI
        CALL ORLANSKI_NORTH(
     &          bi, bj, futureTime,
     &          uVel, vVel, wVel, theta, salt,
     &          myThid )
#endif
      ELSE
        DO k=1,Nr
          DO i=1-OLx,sNx+OLx
            IF ( OB_Jn(i,bi,bj).NE.OB_indexNone ) THEN
c Make center of embayment x=0
              x=(xC(I,1,bi,bj)-Xcenter)/Lrho +Width/2. _d 0
              IF ((x.GE.0.).AND.(x.LE.Width)) THEN
               hinit=Dinf*(exp(-x)) - Dmax
c      if (k.eq.5) then
c      print *,'x=',x,'  xC',xC(I,1,bi,bj),'  I=',I
c      print *,'hinit=',hinit
c      endif
               zt=(z(k) + Dmax - (hinit + Dmax))/(hinit+Dmax)
               IF (zt.GE.(Rit/(2. _d 0 -Rit))) THEN
                Fz=1.
               ELSE
                IF (zt.GE.(-Rit/(2.+Rit))) THEN
                 Fz=1. _d 0/Rit*zt/(zt+1. _d 0) + 0.5 _d 0
                ELSE
                 Fz=0.
                ENDIF
               ENDIF
              ELSE
               Fz=1.
              ENDIF
c       if ((x.ge.0).and.(x.le.Width)) then
c        print *,'z(k)',z(k),'zt',zt,'Fz',Fz
c       endif
              OBNv(i,k,bi,bj)=0.
     &     -  sqrt(gp_inflow*Dinf)*exp(-x)
     &                            *(1. _d 0 - Fz)
c           if ((x.ge.0).and.(x.le.Width)) then
c           if (k.eq.5) then
c       print *,'V=',OBNv(I,K,bi,bj)
c           endif
c           endif
              OBNu(i,k,bi,bj)=0.
              IF (tRef(K).LE. (-dTemp*(1. _d 0 - Fz))) THEN
               OBNt(I,K,bi,bj) = tRef(K)
              ELSE
               OBNt(i,k,bi,bj) = -dTemp*(1. _d 0 - Fz)
              ENDIF
c           if ((x.ge.0).and.(x.le.Width)) then
c       print *,'T=',OBNt(i,k,bi,bj)
c           endif
c            OBNt(i,k,bi,bj)=tRef(k)
c     & - dTemp
c     & *(1.0 - Fz)
              OBNs(i,k,bi,bj)=sRef(k) + 1. _d 0*(1. _d 0 - Fz)
#ifdef ALLOW_NONHYDROSTATIC
              OBNw(i,k,bi,bj)=0.
#endif
#ifdef NONLIN_FRSURF
              OBNeta(i,bi,bj)=0.
#endif
            ENDIF
          ENDDO
        ENDDO
      ENDIF
#endif /* ALLOW_OBCS_NORTH */

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#ifdef ALLOW_OBCS_SOUTH
C         Southern OBC, template for forcing
#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_MSG('OBCS_CALC: South',myThid)
#endif
      IF (useOrlanskiSouth) THEN
#ifdef ALLOW_ORLANSKI
        CALL ORLANSKI_SOUTH(
     &          bi, bj, futureTime,
     &          uVel, vVel, wVel, theta, salt,
     &          myThid )
#endif
      ELSE
        DO k=1,Nr
          DO i=1-OLx,sNx+OLx
            IF ( OB_Js(i,bi,bj).NE.OB_indexNone ) THEN
              OBSu(i,k,bi,bj)=0.
              OBSv(i,k,bi,bj)=0.
              OBSt(i,k,bi,bj)=tRef(k)
              OBSs(i,k,bi,bj)=sRef(k)
#ifdef ALLOW_NONHYDROSTATIC
              OBSw(i,k,bi,bj)=0.
#endif
#ifdef NONLIN_FRSURF
              OBSeta(i,bi,bj)=0.
#endif
            ENDIF
          ENDDO
        ENDDO
      ENDIF
#endif /* ALLOW_OBCS_SOUTH */

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#ifdef ALLOW_PTRACERS
      IF ( usePTRACERS ) THEN
C
C     Calculate some default open boundary conditions for passive tracers:
C     The default is a homogeneous v.Neumann conditions, that is, the
C     tracer gradient across the open boundary is nearly zero;
C     only nearly, because the boundary conditions are applied throughout
C     the time step during which the interior field does change; therefore
C     we have to use the values from the previous time step here. If you
C     really want exact v.Neumann conditions, you have to modify
C     obcs_apply_ptracer directly.
C
# ifdef ALLOW_OBCS_EAST
C     Eastern OB
#  ifdef ALLOW_DEBUG
       IF (debugMode)
     &      CALL DEBUG_MSG('OBCS_CALC: East, pTracers',myThid)
#  endif
       IF (useOrlanskiEast) THEN
        WRITE(msgBuf,'(A)')
     &       'OBCS_CALC: ERROR: useOrlanskiEast Rad OBC with'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(A)')
     &       'OBCS_CALC: ERROR: pTracers not yet implemented'
        CALL PRINT_ERROR( msgBuf, myThid )
        STOP 'ABNORMAL END: S/R OBCS_CALC'
       ELSE
        DO iTracer=1,PTRACERS_numInUse
         DO k=1,Nr
          DO j=1-OLy,sNy+OLy
           IF ( OB_Ie(j,bi,bj).NE.OB_indexNone ) THEN
            I_obc = OB_Ie(j,bi,bj)
            OBEptr(j,k,bi,bj,iTracer) =
     &           pTracer(I_obc-1,j,k,bi,bj,iTracer)
     &           *_maskW(I_obc,j,k,bi,bj)
           ENDIF
          ENDDO
         ENDDO
        ENDDO
       ENDIF
# endif /* ALLOW_OBCS_EAST */

C ------------------------------------------------------------------------------

# ifdef ALLOW_OBCS_WEST
C     Western OB
#  ifdef ALLOW_DEBUG
       IF (debugMode)
     &      CALL DEBUG_MSG('OBCS_CALC: West, pTracers',myThid)
#  endif
       IF (useOrlanskiWest) THEN
        WRITE(msgBuf,'(A)')
     &       'OBCS_CALC: ERROR: useOrlanskiWest Rad OBC with'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(A)')
     &       'OBCS_CALC: ERROR: pTracers not yet implemented'
        CALL PRINT_ERROR( msgBuf, myThid )
        STOP 'ABNORMAL END: S/R OBCS_CALC'
       ELSE
        DO iTracer=1,PTRACERS_numInUse
         DO k=1,Nr
          DO j=1-OLy,sNy+OLy
           IF ( OB_Iw(j,bi,bj).NE.OB_indexNone ) THEN
            I_obc = OB_Iw(j,bi,bj)
            OBWptr(j,k,bi,bj,iTracer) =
     &           pTracer(I_obc+1,j,k,bi,bj,iTracer)
     &           *_maskW(I_obc+1,j,k,bi,bj)
           ENDIF
          ENDDO
         ENDDO
        ENDDO
       ENDIF
# endif /* ALLOW_OBCS_WEST */

C ------------------------------------------------------------------------------

# ifdef ALLOW_OBCS_NORTH
C         Northern OB
#  ifdef ALLOW_DEBUG
       IF (debugMode)
     &     CALL DEBUG_MSG('OBCS_CALC: North, pTracers',myThid)
#  endif
       IF (useOrlanskiNorth) THEN
        WRITE(msgBuf,'(A)')
     &       'OBCS_CALC: ERROR: useOrlanskiNorth Rad OBC with'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(A)')
     &       'OBCS_CALC: ERROR: pTracers not yet implemented'
        CALL PRINT_ERROR( msgBuf, myThid )
        STOP 'ABNORMAL END: S/R OBCS_CALC'
       ELSE
        DO iTracer=1,PTRACERS_numInUse
         DO k=1,Nr
          DO i=1-OLx,sNx+OLx
           IF ( OB_Jn(i,bi,bj).NE.OB_indexNone ) THEN
            J_obc = OB_Jn(i,bi,bj)
            OBNptr(i,k,bi,bj,iTracer) =
     &           pTracer(i,J_obc-1,k,bi,bj,iTracer)
     &           *_maskS(i,J_obc,k,bi,bj)
           ENDIF
          ENDDO
         ENDDO
        ENDDO
       ENDIF
# endif /* ALLOW_OBCS_NORTH */

C ------------------------------------------------------------------------------

# ifdef ALLOW_OBCS_SOUTH
C         Southern OB
# ifdef ALLOW_DEBUG
       IF (debugMode)
     &      CALL DEBUG_MSG('OBCS_CALC: South, pTracers',myThid)
#endif
       IF (useOrlanskiSouth) THEN
        WRITE(msgBuf,'(A)')
     &       'OBCS_CALC: ERROR: useOrlanskiSouth Rad OBC with'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(A)')
     &       'OBCS_CALC: ERROR: pTracers not yet implemented'
        CALL PRINT_ERROR( msgBuf, myThid )
        STOP 'ABNORMAL END: S/R OBCS_CALC'
       ELSE
        DO iTracer=1,PTRACERS_numInUse
         DO k=1,Nr
          DO i=1-OLx,sNx+OLx
           IF ( OB_Js(i,bi,bj).NE.OB_indexNone ) THEN
            J_obc = OB_Js(i,bi,bj)
            OBSptr(i,k,bi,bj,iTracer) =
     &           pTracer(i,J_obc+1,k,bi,bj,iTracer)
     &           *_maskS(i,J_obc+1,k,bi,bj)
           ENDIF
          ENDDO
         ENDDO
        ENDDO
       ENDIF
# endif /* ALLOW_OBCS_SOUTH */
C     end if (usePTracers)
      ENDIF
#endif /* ALLOW_PTRACERS */

C--   end bi,bj loops.
      ENDDO
      ENDDO

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#ifdef ALLOW_OBCS_PRESCRIBE
      IF (useOBCSprescribe) THEN
C--     Calculate future values on open boundaries
#ifdef ALLOW_DEBUG
        IF (debugMode) CALL DEBUG_CALL('OBCS_PRESCRIBE_READ',myThid)
#endif
        CALL OBCS_PRESCRIBE_READ( futureTime, futureIter, myThid )
      ENDIF
#endif /* ALLOW_OBCS_PRESCRIBE */

C ------------------------------------------------------------------------------

#ifdef ALLOW_OBCS_STEVENS
C     The Stevens (1990) boundary conditions come after reading data from
C     files, because they use the data to compute a mix of simplified
C     Orlanski and prescribed boundary conditions
      IF (useStevensNorth.OR.useStevensSouth.OR.
     &     useStevensEast.OR.useStevensWest) THEN
#ifdef ALLOW_DEBUG
       IF (debugMode) CALL DEBUG_CALL('OBCS_CALC_STEVENS',myThid)
#endif
       CALL OBCS_CALC_STEVENS( futureTime, futureIter, myThid )
      ENDIF
#endif /* ALLOW_OBCS_STEVENS */

#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_LEAVE('OBCS_CALC',myThid)
#endif
#endif /* ALLOW_OBCS */

      RETURN
      END

#include "CPP_EEOPTIONS.h"

      INTEGER FUNCTION MDS_RECLEN( filePrec, nnn, myThid )
C IN:
C   filePrec    integer :: precision of file in bits
C   nnn         integer :: number of elements in record
C   myThid      integer :: my thread id number
C OUT:
C   MDS_RECLEN  integer :: appropriate length of record in bytes or words
C
C Created: 03/29/99 eckert@mit.edu + adcroft@mit.edu

      IMPLICIT NONE

C Global variables
#include "SIZE.h"
#include "EEPARAMS.h"
C
C Arguments
      INTEGER filePrec
      INTEGER nnn
      INTEGER myThid
C
C Local
      CHARACTER*(MAX_LEN_MBUF) msgBuf
C     ------------------------------------------------------------------

      IF (filePrec .EQ. precFloat32) THEN
       MDS_RECLEN = nnn*WORDLENGTH
      ELSEIF (filePrec .EQ. precFloat64) THEN
       MDS_RECLEN = nnn*WORDLENGTH*2
      ELSE
       WRITE(msgBuf,'(A,I2.2)')
     &   ' MDS_RECLEN: filePrec = ',filePrec
       CALL PRINT_ERROR( msgBuf, myThid )
       WRITE(msgBuf,'(A)')
     &   ' MDS_RECLEN: illegal value for filePrec'
       CALL PRINT_ERROR( msgBuf, myThid )
       STOP 'ABNORMAL END: S/R MDS_RECLEN'
      ENDIF

C     ------------------------------------------------------------------
      RETURN
      END

#include "PTRACERS_OPTIONS.h"
#include "GAD_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: PTRACERS_RESET

C     !INTERFACE:
      SUBROUTINE PTRACERS_RESET( myTime, myIter, myThid )

C     !DESCRIPTION:
C     Re-initialize PTRACERS if it is the correct time to do so

C     !USES:
#include "PTRACERS_MOD.h"
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "PTRACERS_SIZE.h"
#include "PTRACERS_PARAMS.h"
#include "PTRACERS_FIELDS.h"
#include "GAD.h"

C     !INPUT PARAMETERS:
C     myThid               :: thread number
      INTEGER myIter
      _RL myTime
      INTEGER myThid

#ifdef ALLOW_PTRACERS

      LOGICAL  DIFFERENT_MULTIPLE
      EXTERNAL DIFFERENT_MULTIPLE

C     !LOCAL VARIABLES:
C     i,j,k,bi,bj,iTracer  :: loop indices
C     msgBuf      :: Informational/error message buffer
      INTEGER i,j,k,bi,bj,iTracer
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      CHARACTER*(MAX_LEN_FNAM) tmpInitialFile

#ifdef PTRACERS_ALLOW_DYN_STATE
      INTEGER n
#endif
CEOP

C     Loop over tracers
      DO iTracer = 1, PTRACERS_num

C     Check if it is time to reset this tracer
       IF ( PTRACERS_resetFreq(iTracer).GT.0. .AND. myIter.GT.0 .AND.
     &  DIFFERENT_MULTIPLE( PTRACERS_resetFreq(iTracer),
     &  myTime + PTRACERS_resetPhase(iTracer), deltaTClock ) ) THEN

C     message
        _BEGIN_MASTER( myThid )
        WRITE(msgBuf,'(A,I2,I10)')
     &           '// PTRACER Resetting, (iTracer,t-step) = ',
     &            iTracer, myIter
        CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
        _END_MASTER( myThid )

C     Initialise again this tracer arrays
        DO bj = myByLo(myThid), myByHi(myThid)
         DO bi = myBxLo(myThid), myBxHi(myThid)
          DO k=1,Nr
           DO j=1-OLy,sNy+OLy
            DO i=1-OLx,sNx+OLx
             pTracer(i,j,k,bi,bj,iTracer) = PTRACERS_ref(k,iTracer)
             gpTrNm1(i,j,k,bi,bj,iTracer) = 0. _d 0
            ENDDO
           ENDDO
          ENDDO
         ENDDO
        ENDDO

C     Read initial conditions and exchange
        tmpInitialFile = ' '
        tmpInitialFile = PTRACERS_initialFile(iTracer)
        IF ( tmpInitialFile .NE. ' ' ) THEN
         CALL READ_FLD_XYZ_RL(tmpInitialFile,' ',
     &        pTracer(1-OLx,1-OLy,1,1,1,iTracer),0,myThid)
         _EXCH_XYZ_RL(pTracer(1-OLx,1-OLy,1,1,1,iTracer),myThid)
        ENDIF

C     Apply mask and reset tendencies
        DO bj = myByLo(myThid), myByHi(myThid)
         DO bi = myBxLo(myThid), myBxHi(myThid)
          DO k=1,Nr
           DO j=1-OLy,sNy+OLy
            DO i=1-OLx,sNx+OLx
             IF (maskC(i,j,k,bi,bj).EQ.0.)
     &           pTracer(i,j,k,bi,bj,iTracer)=0. _d 0
            ENDDO
           ENDDO
          ENDDO
         ENDDO
        ENDDO

#ifdef PTRACERS_ALLOW_DYN_STATE
C     Initialize SOM array :
        IF ( PTRACERS_SOM_Advection(iTracer) ) THEN
        _BEGIN_MASTER( myThid )
         WRITE(msgBuf,'(A,I3,A)')'PTRACERS_RESET: iTracer = ',
     &               iTracer, ' : resetting 2nd-order moments '
         CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                       SQUEEZE_RIGHT, myThid )
        _END_MASTER( myThid )
         DO bj = myByLo(myThid), myByHi(myThid)
          DO bi = myBxLo(myThid), myBxHi(myThid)
           DO n = 1,nSOM
            DO k=1,Nr
             DO j=1-OLy,sNy+OLy
              DO i=1-OLx,sNx+OLx
               _Ptracers_som(i,j,k,bi,bj,n,iTracer) = 0. _d 0
              ENDDO
             ENDDO
            ENDDO
           ENDDO
          ENDDO
         ENDDO
c        CALL GAD_EXCH_SOM( _Ptracers_som(:,:,:,:,:,:,iTracer),
c    &                       Nr, myThid )
        ENDIF
#endif /* PTRACERS_ALLOW_DYN_STATE */

        _BEGIN_MASTER( myThid )
        WRITE(msgBuf,'(A)')  ' '
        CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
        _END_MASTER( myThid )

C     end of reset if block
       ENDIF
C     end of Tracer loop
      ENDDO

#endif /* ALLOW_PTRACERS */

      RETURN
      END

#include "PACKAGES_CONFIG.h"
#include "CPP_OPTIONS.h"
#ifdef ALLOW_AUTODIFF
# include "AUTODIFF_OPTIONS.h"
#endif
#ifdef ALLOW_COST
# include "COST_OPTIONS.h"
#endif
#ifdef ALLOW_CTRL
# include "CTRL_OPTIONS.h"
#endif
#ifdef ALLOW_EXF
# include "EXF_OPTIONS.h"
#endif

CBOP
C     !ROUTINE: LOAD_FIELDS_DRIVER
C     !INTERFACE:
      SUBROUTINE LOAD_FIELDS_DRIVER( myTime, myIter, myThid )

C     !DESCRIPTION: \bv
C     *==================================================================
C     | SUBROUTINE LOAD_FIELDS_DRIVER
C     | o Load external forcing fields from file
C     *==================================================================
C     *==================================================================
C     \ev

C     !CALLING SEQUENCE:
C     LOAD_FIELDS_DRIVER
C       |
C       |-- CONVERT_CT2PT  (TEOS10 case)
C       |
C       |-- CTRL_MAP_GENTIM2D
C       |
C       |-- BULKF_FIELDS_LOAD
C       |
C       |-- EXF_GETFORCING
C       |
C       |-- CHEAPAML_FIELDS_LOAD
C       |
C       |-- EXTERNAL_FIELDS_LOAD
C       |
C       |-- GCHEM_FIELDS_LOAD
C       |
C       |-- RBCS_FIELDS_LOAD
C       |
C       |-- AIM_FIELDS_LOAD

C     !USES:
      IMPLICIT NONE
C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "FFIELDS.h"
#include "DYNVARS.h"

#ifdef ALLOW_AUTODIFF
# ifdef ALLOW_AUTODIFF_TAMC
#  include "tamc.h"
# endif
# ifdef ALLOW_CTRL
#  include "CTRL_SIZE.h"
#  include "CTRL.h"
#  include "CTRL_GENARR.h"
#  include "CTRL_DUMMY.h"
# endif
# ifdef ALLOW_COST
#  include "cost.h"
# endif
# include "EOS.h"
# ifdef ALLOW_EXF
#  include "EXF_FIELDS.h"
#  include "EXF_CONSTANTS.h"
#  ifdef ALLOW_TAPENADE
#   include "EXF_PARAM.h"
#   include "EXF_INTERP_SIZE.h"
#   include "EXF_INTERP_PARAM.h"
#  endif
# endif
#endif /* ALLOW_AUTODIFF */

C     !INPUT/OUTPUT PARAMETERS:
C     myTime :: time counter for this thread
C     myIter :: iteration counter for this thread
C     myThid :: thread number for this instance of the routine.
      _RL     myTime
      INTEGER myIter
      INTEGER myThid

      _RL consTemp_to_poTemp
      EXTERNAL consTemp_to_poTemp

C     !LOCAL VARIABLES:
#if (defined ALLOW_ADDFLUID) || (defined ALLOW_FRICTION_HEATING)
      INTEGER k
#endif
      INTEGER ks
      INTEGER i,j,bi,bj
CEOP

#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_ENTER( 'LOAD_FIELDS_DRIVER', myThid )
#endif

C--   Initialise forcing arrays that may receive multiple contributions
#ifdef ALLOW_ADDFLUID
C-- 3 cases: a) prescribe constant 3-D field "addMass" (loaded from addMassFile)
C            b) prescribe time-variable 3-D field "addMass" (not yet coded)
C            c) compute "addMass" at each time-step (sum of contrib from pkgs)
C-  Note: Condition below might need an update once (b) is made available
      IF ( selectAddFluid.NE.0 .AND. addMassFile.EQ.' ' ) THEN
        DO bj=myByLo(myThid),myByHi(myThid)
         DO bi=myBxLo(myThid),myBxHi(myThid)
          DO k=1,Nr
           DO j=1-OLy,sNy+OLy
            DO i=1-OLx,sNx+OLx
             addMass(i,j,k,bi,bj) =  0. _d 0
            ENDDO
           ENDDO
          ENDDO
         ENDDO
        ENDDO
      ENDIF
#endif /* ALLOW_ADDFLUID */

#ifdef ALLOW_FRICTION_HEATING
      IF ( addFrictionHeating .AND. staggerTimeStep ) THEN
        DO bj=myByLo(myThid),myByHi(myThid)
         DO bi=myBxLo(myThid),myBxHi(myThid)
          DO k=1,Nr
           DO j=1-OLy,sNy+OLy
            DO i=1-OLx,sNx+OLx
             frictionHeating(i,j,k,bi,bj) = 0. _d 0
            ENDDO
           ENDDO
          ENDDO
         ENDDO
        ENDDO
      ENDIF
#endif /* ALLOW_FRICTION_HEATING */

C--   Determine surface temperature, usually just a copy of the surface
C--   level of theta, but for eosType='TEOS10', we need to convert from
C--   conservative temperature to in-situ surface temperature
      IF ( usingPCoords ) THEN
       ks = Nr
      ELSE
       ks = 1
      ENDIF
      IF ( fluidIsWater .AND. eosType .EQ. 'TEOS10' ) THEN
        DO bj=myByLo(myThid),myByHi(myThid)
         DO bi=myBxLo(myThid),myBxHi(myThid)
          CALL CONVERT_CT2PT(
     I         theta(1-OLx,1-OLy,ks,bi,bj),
     I         salt(1-OLx,1-OLy,ks,bi,bj),
     O         gcmSST(1-OLx,1-OLy,bi,bj),
     I         myTime, myIter, myThid )
C     apply mask (because theta=0 will lead to gcmSST<0)
          DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
            gcmSST(i,j,bi,bj) = gcmSST(i,j,bi,bj)*maskC(i,j,ks,bi,bj)
           ENDDO
          ENDDO
         ENDDO
        ENDDO
#ifdef ALLOW_AUTODIFF
      ELSE
#else
      ELSEIF ( fluidIsWater ) THEN
#endif
        DO bj=myByLo(myThid),myByHi(myThid)
         DO bi=myBxLo(myThid),myBxHi(myThid)
          DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
            gcmSST(i,j,bi,bj) = theta(i,j,ks,bi,bj)
           ENDDO
          ENDDO
         ENDDO
        ENDDO
      ENDIF

C--   Map generic time varying controls to xx_gentim2d
#ifdef ALLOW_CTRL
      IF ( useCTRL ) THEN
#ifdef ALLOW_DEBUG
        IF (debugMode) CALL DEBUG_CALL('CTRL_MAP_GENTIM2D',myThid)
#endif
        CALL CTRL_MAP_GENTIM2D( myTime, myIter, myThid )
      ENDIF
#endif /* ALLOW_CTRL */

#ifdef ALLOW_BULK_FORCE
      IF ( useBulkForce ) THEN
C--   Bulk-Formulae pkg: load all forcing fields at current time
#ifdef ALLOW_DEBUG
        IF (debugMode) CALL DEBUG_CALL('BULKF_FIELDS_LOAD',myThid)
#endif
        CALL TIMER_START('BULKF_FIELDS_LOAD  [LOAD_FLDS_DRIVER]',myThid)
        CALL BULKF_FIELDS_LOAD( myTime, myIter, myThid )
        CALL TIMER_STOP ('BULKF_FIELDS_LOAD  [LOAD_FLDS_DRIVER]',myThid)
      ENDIF
#endif /* ALLOW_BULK_FORCE */

C--   Call external forcing package
#ifdef ALLOW_EXF
      IF (useEXF) THEN
# ifdef ALLOW_DEBUG
        IF (debugMode) CALL DEBUG_CALL('EXF_GETFORCING',myThid)
# endif
        CALL TIMER_START('EXF_GETFORCING     [LOAD_FLDS_DRIVER]',myThid)
        CALL EXF_GETFORCING( myTime, myIter, myThid )
        CALL TIMER_STOP ('EXF_GETFORCING     [LOAD_FLDS_DRIVER]',myThid)
      ENDIF
#endif /* ALLOW_EXF */

C--   Call external CheapAML forcing package
#ifdef ALLOW_CHEAPAML
      IF ( useCheapAML  ) THEN
#ifdef ALLOW_DEBUG
        IF (debugMode) CALL DEBUG_CALL('CHEAPAML_FIELDS_LOAD',myThid)
#endif
        CALL CHEAPAML_FIELDS_LOAD( myTime, myIter, myThid )
      ENDIF
#endif /*ALLOW_CHEAPAML */

      IF ( fluidIsWater ) THEN
#ifdef ALLOW_DEBUG
        IF (debugMode) CALL DEBUG_CALL('EXTERNAL_FIELDS_LOAD',myThid)
#endif
        CALL TIMER_START('EXTERNAL_FLDS_LOAD [LOAD_FLDS_DRIVER]',myThid)
        CALL EXTERNAL_FIELDS_LOAD( myTime, myIter, myThid )
        CALL TIMER_STOP ('EXTERNAL_FLDS_LOAD [LOAD_FLDS_DRIVER]',myThid)
      ENDIF

#ifdef ALLOW_GCHEM
      IF ( useGCHEM ) THEN
#ifdef ALLOW_DEBUG
        IF (debugMode) CALL DEBUG_CALL('GCHEM_FIELDS_LOAD',myThid)
#endif /* ALLOW_DEBUG */
        CALL GCHEM_FIELDS_LOAD( myTime, myIter, myThid )
      ENDIF
#endif /* ALLOW_GCHEM */

#ifdef ALLOW_RBCS
      IF ( useRBCS ) THEN
        CALL RBCS_FIELDS_LOAD( myTime, myIter, myThid )
      ENDIF
#endif

#ifdef ALLOW_AIM
      IF ( useAIM ) THEN
C-     Update AIM bottom boundary data
        CALL AIM_FIELDS_LOAD( myTime, myIter, myThid )
      ENDIF
#endif

#ifdef ALLOW_DIAGNOSTICS
      IF ( fluidIsWater .AND. useDiagnostics ) THEN
        CALL DIAGNOSTICS_FILL( gcmSST, 'GCM_SST ',
     &                               0, 1, 0, 1, 1, myThid )
      ENDIF
#endif /* ALLOW_DIAGNOSTICS */

#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_LEAVE( 'LOAD_FIELDS_DRIVER', myThid )
#endif

      RETURN
      END

#include "CPP_EEOPTIONS.h"
C--   File active_write_tap.F: Active write with Tapenade.
C--    Contents:
C--    o ACTIVE_WRITE_XY_D
C--    o ACTIVE_WRITE_XYZ_D
C--    o ACTIVE_WRITE_XY_B
C--    o ACTIVE_WRITE_XYZ_B
C--    o ACTIVE_WRITE_XY_BWD (for use without checkpointing)
C--    o ACTIVE_WRITE_XY_FWD (for use without checkpointing)

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

CBOP
C     !ROUTINE: ACTIVE_WRITE_XY_D
C     !INTERFACE:
      SUBROUTINE ACTIVE_WRITE_XY_D(
     I                            active_var_file,
     I                            active_var,
     I                            active_vard,
     I                            iRec,
     I                            myOptimIter,
     I                            myThid,
     I                            dummy,
     I                            dummyd
     &                          )

C     *==========================================================*
C     | SUBROUTINE ACTIVE_WRITE_XY_D
C     | o Forward differentiation of ACTIVE_WRITE_XY.
C     *==========================================================*
C     | written by Shreyas Gaikwad, Laurent Hascoet in Nov 2022
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     == global variables ==
#include "SIZE.h"

C     !INPUT/OUTPUT PARAMETERS:
C     active_var_file:: filename
C     active_var     :: array
C     active_vard    :: forward derivative of active_var
C     iRec           :: record number
C     myOptimIter    :: number of optimization iteration (default: 0)
C     myThid         :: thread number for this instance
      CHARACTER*(*) active_var_file
      Real*8     active_var(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      Real*8     active_vard(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      INTEGER iRec
      INTEGER myOptimIter
      INTEGER myThid
      Real*8     dummy
      Real*8     dummyd

C     !LOCAL VARIABLES:
      CHARACTER*(2) pref
      CHARACTER*(80) fname
      INTEGER myNr
      LOGICAL globalFile
      LOGICAL useCurrentDir
CEOP

      pref = 'g_'
      CALL ADD_PREFIX( pref, active_var_file, fname )
      myNr = 1
      globalFile = .FALSE.
      useCurrentDir = .FALSE.

      CALL ACTIVE_WRITE_3D_RL(
     &                 active_var_file, active_var, globalFile,
     &                 useCurrentDir, iRec, myNr,
     &                 0, myOptimIter, myThid )

      CALL ACTIVE_WRITE_3D_RL(
     &                 fname, active_vard, globalFile,
     &                 useCurrentDir, iRec, myNr,
     &                 2, myOptimIter, myThid )

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

CBOP
C     !ROUTINE: ACTIVE_WRITE_XYZ_D
C     !INTERFACE:
      SUBROUTINE ACTIVE_WRITE_XYZ_D(
     I                            active_var_file,
     I                            active_var,
     I                            active_vard,
     I                            iRec,
     I                            myOptimIter,
     I                            myThid,
     I                            dummy,
     I                            dummyd
     &                          )

C     *==========================================================*
C     | SUBROUTINE ACTIVE_WRITE_XYZ_D
C     | o Forward differentiation of ACTIVE_WRITE_XYZ.
C     *==========================================================*
C     | written by Shreyas Gaikwad, Laurent Hascoet in Nov 2022
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     == global variables ==
#include "SIZE.h"

C     !INPUT/OUTPUT PARAMETERS:
C     active_var_file:: filename
C     active_var     :: array
C     active_vard    :: forward derivative of active_var
C     iRec           :: record number
C     myOptimIter    :: number of optimization iteration (default: 0)
C     myThid         :: thread number for this instance
      CHARACTER*(*) active_var_file
      Real*8     active_var(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      Real*8     active_vard(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      INTEGER iRec
      INTEGER myOptimIter
      INTEGER myThid
      Real*8     dummy
      Real*8     dummyd

C     !LOCAL VARIABLES:
      CHARACTER*(2) pref
      CHARACTER*(80) fname
      INTEGER myNr
      LOGICAL globalFile
      LOGICAL useCurrentDir
CEOP

      pref = 'g_'
      CALL ADD_PREFIX( pref, active_var_file, fname )
      myNr = Nr
      globalFile = .FALSE.
      useCurrentDir = .FALSE.

      CALL ACTIVE_WRITE_3D_RL(
     &                 active_var_file, active_var, globalFile,
     &                 useCurrentDir, iRec, myNr,
     &                 0, myOptimIter, myThid )

      CALL ACTIVE_WRITE_3D_RL(
     &                 fname, active_vard, globalFile,
     &                 useCurrentDir, iRec, myNr,
     &                 2, myOptimIter, myThid )

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

CBOP
C     !ROUTINE: ACTIVE_WRITE_XY_B
C     !INTERFACE:
      SUBROUTINE ACTIVE_WRITE_XY_B(
     I                              active_var_file,
     I                              active_var,
     U                              active_varb,
     I                              iRec,
     I                              myOptimIter,
     I                              myThid,
     I                              dummy,
     O                              dummyb
     &                            )

C     *==========================================================*
C     | SUBROUTINE ACTIVE_WRITE_XY_B
C     | o Reverse differentiation of ACTIVE_WRITE_XY.
C     *==========================================================*
C     | written by Shreyas Gaikwad, Laurent Hascoet in Nov 2022
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     == global variables ==
#include "EEPARAMS.h"
#include "SIZE.h"

C     !INPUT/OUTPUT PARAMETERS:
C     active_var_file:: filename
C     active_var     :: array
C     active_varb    :: reverse derivative of active_var
C     iRec           :: record number
C     myOptimIter    :: number of optimization iteration (default: 0)
C     myThid         :: thread number for this instance
      CHARACTER*(80) active_var_file
      Real*8     active_var(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      Real*8     active_varb(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      INTEGER iRec
      INTEGER myOptimIter
      INTEGER myThid
      Real*8     dummy
      Real*8     dummyb

C     !LOCAL VARIABLES:
      CHARACTER*(2) adpref
      CHARACTER*(80) fname
      INTEGER myNr
      LOGICAL globalFile
      LOGICAL useCurrentDir
CEOP
      adpref = 'ad'
      CALL ADD_PREFIX( adpref, active_var_file, fname )
      myNr = 1
      globalFile = .FALSE.
      useCurrentDir = .FALSE.
      CALL ACTIVE_WRITE_3D_RL(
     &                 fname, active_varb, globalFile,
     &                 useCurrentDir, iRec, myNr,
     &                 REVERSE_SIMULATION, myOptimIter, myThid )

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

CBOP
C     !ROUTINE: ACTIVE_WRITE_XYZ_B
C     !INTERFACE:
      SUBROUTINE ACTIVE_WRITE_XYZ_B(
     I                              active_var_file,
     I                              active_var,
     U                              active_varb,
     I                              iRec,
     I                              myOptimIter,
     I                              myThid,
     I                              dummy,
     O                              dummyb
     &                            )

C     *==========================================================*
C     | SUBROUTINE ACTIVE_WRITE_XYZ_B
C     | o Reverse differentiation of ACTIVE_WRITE_XYZ.
C     *==========================================================*
C     | written by Shreyas Gaikwad, Laurent Hascoet in Nov 2022
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     == global variables ==
#include "EEPARAMS.h"
#include "SIZE.h"

C     !INPUT/OUTPUT PARAMETERS:
C     active_var_file:: filename
C     active_var     :: array
C     active_varb    :: reverse derivative of active_var
C     iRec           :: record number
C     myOptimIter    :: number of optimization iteration (default: 0)
C     myThid         :: thread number for this instance
      CHARACTER*(80) active_var_file
      Real*8     active_var(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      Real*8     active_varb(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      INTEGER iRec
      INTEGER myOptimIter
      INTEGER myThid
      Real*8     dummy
      Real*8     dummyb

C     !FUNCTIONS:
      INTEGER  ILNBLNK
      EXTERNAL ILNBLNK

C     !LOCAL VARIABLES:
      CHARACTER*(2) adpref
      CHARACTER*(80) fname
      INTEGER il
      INTEGER myNr
      LOGICAL globalFile
      LOGICAL useCurrentDir
CEOP
      adpref = 'ad'
      CALL ADD_PREFIX( adpref, active_var_file, fname )
      myNr = Nr
      globalFile = .FALSE.
      useCurrentDir = .FALSE.
      CALL ACTIVE_WRITE_3D_RL(
     &                 fname, active_varb, globalFile,
     &                 useCurrentDir, iRec, myNr,
     &                 REVERSE_SIMULATION, myOptimIter, myThid )

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

CBOP
C     !ROUTINE: ACTIVE_WRITE_XY_FWD
C     !INTERFACE:
      SUBROUTINE ACTIVE_WRITE_XY_FWD(
     I                              active_var_file,
     I                              active_var,
     I                              iRec,
     I                              myOptimIter,
     I                              myThid,
     I                              dummy
     &                            )

C     *==========================================================*
C     | SUBROUTINE ACTIVE_WRITE_XY_FWD
C     | o Reverse differentiation of ACTIVE_WRITE_XY.
C     *==========================================================*
C     | written by Shreyas Gaikwad, Laurent Hascoet in Nov 2022
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     == global variables ==
#include "SIZE.h"

C     !INPUT/OUTPUT PARAMETERS:
C     active_var_file:: filename
C     active_var     :: array
C     iRec           :: record number
C     myOptimIter    :: number of optimization iteration (default: 0)
C     myThid         :: thread number for this instance
      CHARACTER*(80) active_var_file
      Real*8     active_var(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      INTEGER iRec
      INTEGER myOptimIter
      INTEGER myThid
      Real*8     dummy

      CALL ACTIVE_WRITE_XY(
     I                 active_var_file,
     I                 active_var,
     I                 iRec,
     I                 myOptimIter,
     I                 myThid,
     I                 dummy
     &                    )

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

CBOP
C     !ROUTINE: ACTIVE_WRITE_XY_BWD
C     !INTERFACE:
      SUBROUTINE ACTIVE_WRITE_XY_BWD(
     I                              active_var_file,
     I                              active_var,
     U                              active_varb,
     I                              iRec,
     I                              myOptimIter,
     I                              myThid,
     I                              dummy,
     O                              dummyb
     &                            )

C     *==========================================================*
C     | SUBROUTINE ACTIVE_WRITE_XY_BWD
C     | o Reverse differentiation of ACTIVE_WRITE_XY.
C     *==========================================================*
C     | written by Shreyas Gaikwad, Laurent Hascoet in Nov 2022
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     == global variables ==
#include "SIZE.h"

C     !INPUT/OUTPUT PARAMETERS:
C     active_var_file:: filename
C     active_var     :: array
C     active_varb    :: reverse derivative of active_var
C     iRec           :: record number
C     myOptimIter    :: number of optimization iteration (default: 0)
C     myThid         :: thread number for this instance
      CHARACTER*(80) active_var_file
      Real*8     active_var(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      Real*8     active_varb(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      INTEGER iRec
      INTEGER myOptimIter
      INTEGER myThid
      Real*8     dummy
      Real*8     dummyb

      CALL ACTIVE_WRITE_XY_B(
     I                 active_var_file,
     I                 active_var,
     U                 active_varb,
     I                 iRec,
     I                 myOptimIter,
     I                 myThid,
     I                 dummy,
     O                 dummyb )

      RETURN
      END

#include "GAD_OPTIONS.h"

CBOP
C !ROUTINE: GAD_WRITE_PICKUP

C !INTERFACE: ==========================================================
      SUBROUTINE GAD_WRITE_PICKUP( suff,
     I                             myTime, myIter, myThid )

C !DESCRIPTION:
C     Writes current state of 2nd.Order moments to a pickup file

C !USES: ===============================================================
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GAD.h"
#include "GAD_SOM_VARS.h"
#ifdef ALLOW_MNC
#include "MNC_PARAMS.h"
#endif

C !INPUT PARAMETERS: ===================================================
C     suff    :: suffix for pickup file (eg. ckptA or 0000000010)
C     myTime  :: model time
C     myIter  :: time-step number
C     myThid  :: thread number
      CHARACTER*(*) suff
      _RL     myTime
      INTEGER myIter
      INTEGER myThid

C !OUTPUT PARAMETERS: ==================================================
C  none

#ifdef GAD_ALLOW_TS_SOM_ADV
C     === Functions ====
      INTEGER  ILNBLNK
      EXTERNAL ILNBLNK

C !LOCAL VARIABLES: ====================================================
C     n       :: 2nd.O. moment loop index
C     iRec    :: record number
C     fn      :: character buffer for creating filename
C     prec    :: precision of pickup files
C     msgBuf  :: Informational/error meesage buffer
      INTEGER n,prec,iRec,lChar
      CHARACTER*(MAX_LEN_FNAM) fn
#ifdef ALLOW_MNC
      CHARACTER*(MAX_LEN_MBUF) msgBuf
#endif
CEOP

#ifdef ALLOW_MNC
      IF ( useMNC .AND. pickup_write_mnc ) THEN
       IF ( tempSOM_Advection .OR. saltSOM_Advection ) THEN
        WRITE(msgBuf,'(A)') 'GAD_WRITE_PICKUP: MNC not yet coded',
     &                      ' => write bin file instead'
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                      SQUEEZE_RIGHT, myThid)
       ENDIF
      ENDIF
#endif /*  ALLOW_MNC  */

c     IF ( pickup_write_mdsio ) THEN
      IF ( .TRUE. ) THEN
       lChar = ILNBLNK(suff)

       IF ( tempSOM_Advection ) THEN
C--   Pot. Temp. 2nd.Order moments
        IF ( lChar.EQ.0 ) THEN
          WRITE(fn,'(2A)') 'pickup_somT'
        ELSE
          WRITE(fn,'(2A)') 'pickup_somT.',suff(1:lChar)
        ENDIF
        prec = precFloat64
C       Write 2nd Order moments as consecutive records
        DO n=1,nSOM
          iRec = n
          CALL WRITE_REC_3D_RL( fn, prec, Nr,
     I               som_T(1-Olx,1-Oly,1,1,1,n),
     I               iRec, myIter, myThid )
        ENDDO
       ENDIF

       IF ( saltSOM_Advection ) THEN
C--   Salinity 2nd.Order moments
        IF ( lChar.EQ.0 ) THEN
          WRITE(fn,'(2A)') 'pickup_somS'
        ELSE
          WRITE(fn,'(2A)') 'pickup_somS.',suff(1:lChar)
        ENDIF
        prec = precFloat64
C       Write 2nd Order moments as consecutive records
        DO n=1,nSOM
          iRec = n
          CALL WRITE_REC_3D_RL( fn, prec, Nr,
     I               som_S(1-Olx,1-Oly,1,1,1,n),
     I               iRec, myIter, myThid )
        ENDDO
       ENDIF

      ENDIF

#endif /* GAD_ALLOW_TS_SOM_ADV */

      RETURN
      END

#include "PACKAGES_CONFIG.h"
#include "CPP_OPTIONS.h"

CBOP
C     !ROUTINE: INI_DEPTHS
C     !INTERFACE:
      SUBROUTINE INI_DEPTHS( myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE INI_DEPTHS
C     | o define R_position of Lower and Surface Boundaries
C     *==========================================================*
C     |atmosphere orography:
C     | define either in term of P_topo or converted from Z_topo
C     |ocean bathymetry:
C     | The depths of the bottom of the model is specified in
C     | terms of an XY map with one depth for each column of
C     | grid cells. Depths do not have to coincide with the
C     | model levels. The model lopping algorithm makes it
C     | possible to represent arbitrary depths.
C     | The mode depths map also influences the models topology
C     | By default the model domain wraps around in X and Y.
C     | This default doubly periodic topology is "supressed"
C     | if a depth map is defined which closes off all wrap
C     | around flow.
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "SURFACE.h"
#ifdef ALLOW_MNC
# include "MNC_PARAMS.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     myThid  ::  my Thread Id number
      INTEGER myThid

C     !LOCAL VARIABLES:
C     == Local variables ==
C     iG, jG  :: Global coordinate index
C     bi, bj  :: Tile indices
C     i, j    :: Loop counters
C     oldPrec :: Temporary used in controlling binary input dataset precision
C     msgBuf  :: Informational/error message buffer
      INTEGER iG, jG
      INTEGER bi, bj
      INTEGER  i, j
      CHARACTER*(MAX_LEN_MBUF) msgBuf
CEOP

      IF (usingPCoords .AND. bathyFile .NE. ' '
     &                 .AND. topoFile  .NE. ' ' ) THEN
       WRITE(msgBuf,'(A,A)')
     &  'S/R INI_DEPTHS: both bathyFile & topoFile are specified:',
     &  ' select the right one !'
       CALL PRINT_ERROR( msgBuf , myThid)
       STOP 'ABNORMAL END: S/R INI_DEPTHS'
      ENDIF

C------
C   0) Initialize R_low and Ro_surf (define an empty domain)
C------
      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          R_low(i,j,bi,bj)   = 0. _d 0
          Ro_surf(i,j,bi,bj) = 0. _d 0
          topoZ(i,j,bi,bj)   = 0. _d 0
         ENDDO
        ENDDO
       ENDDO
      ENDDO

C-    Need to synchronize here before doing master-thread IO
C     this is done within IO routines => no longer needed
c     _BARRIER

C------
C   1) Set R_low = the Lower (in r sense) boundary of the fluid column :
C------
      IF (usingPCoords .OR. bathyFile .EQ. ' ') THEN
C- e.g., atmosphere : R_low = Top of atmosphere
C-            ocean : R_low = Bottom
       DO bj = myByLo(myThid), myByHi(myThid)
        DO bi = myBxLo(myThid), myBxHi(myThid)
         DO j=1,sNy
          DO i=1,sNx
           R_low(i,j,bi,bj) = rF(Nr+1)
          ENDDO
         ENDDO
        ENDDO
       ENDDO
      ELSE

#ifdef ALLOW_MNC
        IF (useMNC .AND. mnc_read_bathy) THEN
          CALL MNC_CW_ADD_VNAME('bathy', 'Cen_xy_Hn__-__-', 3,4, myThid)
          CALL MNC_FILE_CLOSE_ALL_MATCHING(bathyFile, myThid)
          CALL MNC_CW_SET_UDIM(bathyFile, 1, myThid)
          CALL MNC_CW_SET_CITER(bathyFile, 2, -1, -1, -1, myThid)
          CALL MNC_CW_SET_UDIM(bathyFile, 1, myThid)
          CALL MNC_CW_RS_R('D',bathyFile,0,0,'bathy',R_low, myThid)
          CALL MNC_FILE_CLOSE_ALL_MATCHING(bathyFile, myThid)
          CALL MNC_CW_DEL_VNAME('bathy', myThid)
        ELSE
#endif /*  ALLOW_MNC  */
C Read the bathymetry using the mid-level I/O package read_write_rec
C The 0 is the "iteration" argument. The 1 is the record number.
          CALL READ_REC_XY_RS( bathyFile, R_low, 1, 0, myThid )
C Read the bathymetry using the mid-level I/O package read_write_fld
C The 0 is the "iteration" argument. The ' ' is an empty suffix
c       CALL READ_FLD_XY_RS( bathyFile, ' ', R_low, 0, myThid )
C Read the bathymetry using the low-level I/O package
c       CALL MDSREADFIELD( bathyFile, readBinaryPrec,
c    &                     'RS', 1, R_low, 1, myThid )

#ifdef ALLOW_MNC
        ENDIF
#endif /*  ALLOW_MNC  */

      ENDIF
C- end setup R_low in the interior

C- fill in the overlap (+ BARRIER):
      _EXCH_XY_RS(R_low, myThid )

      IF ( plotLevel.GE.debLevC ) THEN
c      PRINT *, ' Calling plot field', myThid
       CALL PLOT_FIELD_XYRS( R_low, 'Bottom depths (ini_depths)',
     &                       -1, myThid )
      ENDIF
c     CALL WRITE_FLD_XY_RS( 'R_low' ,' ', R_low, 0,myThid)

c---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C------
C   2) Set R_surf = Surface boundary: ocean surface / ground for the atmosphere
C------

      IF ( usingPCoords .AND. bathyFile.NE.' ' ) THEN
C------ read directly Po_surf from bathyFile (only for backward compatibility)

        CALL READ_REC_XY_RS( bathyFile, Ro_surf, 1, 0, myThid )

      ELSEIF ( topoFile.EQ.' ' ) THEN
C------ set default value:

        DO bj = myByLo(myThid), myByHi(myThid)
         DO bi = myBxLo(myThid), myBxHi(myThid)
          DO j=1,sNy
           DO i=1,sNx
            Ro_surf(i,j,bi,bj) = rF(1)
           ENDDO
          ENDDO
         ENDDO
        ENDDO

      ELSE
C------ read from file:

C- read surface topography (in m) from topoFile (case topoFile.NE.' '):

        CALL READ_REC_XY_RS( topoFile, topoZ, 1, 0, myThid )
        _EXCH_XY_RS( topoZ, myThid )

        IF (buoyancyRelation .EQ. 'ATMOSPHERIC') THEN
C----
C   Convert Surface Geopotential to (reference) Surface Pressure
C   according to Tref profile, using same discretisation as in calc_phi_hyd
C----
c         CALL WRITE_FLD_XY_RS( 'topo_Z',' ',topoZ,0,myThid)

          CALL INI_P_GROUND( 2, topoZ,
     O                       Ro_surf,
     I                       myThid )

C         This I/O is now done in write_grid.F
c         CALL WRITE_FLD_XY_RS( 'topo_P',' ',Ro_surf,0,myThid)

        ELSEIF ( buoyancyRelation.EQ.'OCEANICP' ) THEN

          WRITE(msgBuf,'(A,A)') 'S/R INI_DEPTHS: ',
     &     'from topoFile (in m) to ref.bottom pressure: Not yet coded'
          CALL PRINT_ERROR( msgBuf , myThid)
          STOP 'ABNORMAL END: S/R INI_DEPTHS'

        ELSE
C----
C   Direct Transfer to Ro_surf (e.g., to specify upper ocean boundary
C    below an ice-shelf - NOTE - actually not yet implemented )
          DO bj = myByLo(myThid), myByHi(myThid)
           DO bi = myBxLo(myThid), myBxHi(myThid)
            DO j=1,sNy
             DO i=1,sNx
              Ro_surf(i,j,bi,bj) = topoZ(i,j,bi,bj)
             ENDDO
            ENDDO
           ENDDO
          ENDDO

        ENDIF

C------ end case "read topoFile"
      ENDIF

C----- fill in the overlap (+ BARRIER):
      _EXCH_XY_RS(Ro_surf, myThid )

c---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C------
C   3) Close the Domain (special configuration).
C------
      IF (usingPCoords) THEN
       DO bj = myByLo(myThid), myByHi(myThid)
        DO bi = myBxLo(myThid), myBxHi(myThid)
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           iG = myXGlobalLo-1+(bi-1)*sNx+i
           jG = myYGlobalLo-1+(bj-1)*sNy+j
C          Test for eastern edge
c          IF ( iG .EQ. Nx )  Ro_surf(i,j,bi,bj) = 0.
C          Test for northern edge
c          IF ( jG .EQ. Ny )  Ro_surf(i,j,bi,bj) = 0.
C- Domain : Symetric % Eq. & closed at N & S boundaries:
c          IF ( usingSphericalPolarGrid .AND.
c    &          ABS(yC(i,j,bi,bj)).GE.ABS(ygOrigin) )
c    &       Ro_surf(i,j,bi,bj) = rF(Nr+1)
           IF ( usingSphericalPolarGrid .AND.
     &          ABS(yC(i,j,bi,bj)).GE.90. )
     &       Ro_surf(i,j,bi,bj) = rF(Nr+1)
          ENDDO
         ENDDO
        ENDDO
       ENDDO
      ELSE
       DO bj = myByLo(myThid), myByHi(myThid)
        DO bi = myBxLo(myThid), myBxHi(myThid)
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           iG = myXGlobalLo-1+(bi-1)*sNx+i
           jG = myYGlobalLo-1+(bj-1)*sNy+j
C          Test for eastern edge
c          IF ( iG .EQ. Nx )  R_low(i,j,bi,bj) = 0.
C          Test for northern edge
c          IF ( jG .EQ. Ny )  R_low(i,j,bi,bj) = 0.
C- Domain : Symetric % Eq. & closed at N & S boundaries:
c          IF ( usingSphericalPolarGrid .AND.
c    &          ABS(yC(i,j,bi,bj)).GE.ABS(ygOrigin) )
c    &       R_low(i,j,bi,bj) = rF(1)
           IF ( usingSphericalPolarGrid .AND.
     &          ABS(yC(i,j,bi,bj)).GE.90. )
     &       R_low(i,j,bi,bj) = rF(1)
          ENDDO
         ENDDO
        ENDDO
       ENDDO
      ENDIF

      IF ( plotLevel.GE.debLevC ) THEN
       _BARRIER
       CALL PLOT_FIELD_XYRS( Ro_surf,
     &           'Surface reference r-position (ini_depths)',
     &           -1, myThid )
      ENDIF
c     CALL WRITE_FLD_XY_RS('Ro_surf',' ',Ro_surf,0,myThid)

C--   Everyone else must wait for the depth to be loaded
C-    note: not necessary since all single-thread IO above are followed
C           by an EXCH (with BARRIER) + BARRIER within IO routine
c     _BARRIER

#ifdef ALLOW_OBCS
      IF ( useOBCS ) THEN
C     check for inconsistent topography along boundaries and fix it
       CALL OBCS_CHECK_DEPTHS( myThid )
C     update the overlaps
       _EXCH_XY_RS( R_low, myThid )
      ENDIF
#endif /* ALLOW_OBCS */

#ifdef ALLOW_EXCH2
C     Check domain boundary (e.g., in case of missing tiles)
      CALL EXCH2_CHECK_DEPTHS( R_low, Ro_surf, myThid )
#endif

      RETURN
      END

#include "SHELFICE_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: SHELFICE_MNC_INIT

C     !INTERFACE:
      SUBROUTINE SHELFICE_MNC_INIT( myThid )

C     !DESCRIPTION:
C     Initialize SHELFICE variables within MNC

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"

C     !INPUT PARAMETERS:
      INTEGER myThid
CEOP

#ifdef ALLOW_SHELFICE
#ifdef ALLOW_MNC
      IF (useMNC) THEN

        CALL MNC_CW_ADD_VNAME('fwFlux','Cen_xy_Hn__-__t',3,4,myThid)
        CALL MNC_CW_ADD_VATTR_TEXT('fwFlux','units','kg/m^2/s', myThid)
        CALL MNC_CW_ADD_VATTR_TEXT('fwFlux','description',
     &       'Net fresh water flux into shelfice',myThid)

        CALL MNC_CW_ADD_VNAME('heatFlux','Cen_xy_Hn__-__t',3,4,myThid)
        CALL MNC_CW_ADD_VATTR_TEXT('heatFlux','units','W/m^2',myThid)
        CALL MNC_CW_ADD_VATTR_TEXT('heatFlux','description',
     &       'Net heat flux into shelfice',myThid)

      ENDIF
#endif /*  ALLOW_MNC     */
#endif /*  ALLOW_SHELFICE  */

      RETURN
      END

#include "FIZHI_OPTIONS.h"
CBOP
C     !ROUTINE: FIZHI_WRITE_STATE
C     !INTERFACE:
      SUBROUTINE FIZHI_WRITE_STATE( myTime, myIter, myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R FIZHI_WRITE_STATE
C     | o Writes current state of fizhi package to an output file
C     | o     Called from do_the_model_io
C     *==========================================================*
C     \ev

C     !USES:
CEOP
      IMPLICIT NONE

C     == Global variables ===
#include "SIZE.h"
#include "fizhi_SIZE.h"
#include "fizhi_land_SIZE.h"
#include "fizhi_coms.h"
#include "fizhi_land_coms.h"
#include "EEPARAMS.h"
#include "PARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine Arguments ==
C     myTime  :: current time
C     myIter  :: time-step number
C     myThid  :: Number of this instance
      _RL myTime
      INTEGER myIter
      INTEGER myThid

C     !FUNCTIONS:
      LOGICAL  DIFFERENT_MULTIPLE
      EXTERNAL DIFFERENT_MULTIPLE

C     !LOCAL VARIABLES:
C     fn      :: character buffer for creating filename
      CHARACTER*(MAX_LEN_FNAM) fn
      INTEGER prec

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      IF (
     &     DIFFERENT_MULTIPLE(dumpFreq,myTime,deltaTClock)
     &  .OR. dumpInitAndLast.AND.( myTime.EQ.endTime .OR.
     &                             myTime.EQ.startTime  )
     &   ) THEN

C--   Write fields:
       prec = writeBinaryPrec
       WRITE( fn, '(A,I10.10)' ) 'fizhi_U.', myIter
       CALL WRITE_REC_3D_RL( fn,prec, Nrphys, uphy, 1, myIter,myThid )
       WRITE( fn, '(A,I10.10)' ) 'fizhi_V.', myIter
       CALL WRITE_REC_3D_RL( fn,prec, Nrphys, vphy, 1, myIter,myThid )
       WRITE( fn, '(A,I10.10)' ) 'fizhi_T.', myIter
       CALL WRITE_REC_3D_RL( fn,prec, Nrphys, thphy, 1, myIter,myThid )
       WRITE( fn, '(A,I10.10)' ) 'fizhi_S.', myIter
       CALL WRITE_REC_3D_RL( fn,prec, Nrphys, sphy, 1, myIter,myThid )

      ENDIF

      RETURN
      END

#include "FIZHI_OPTIONS.h"
       subroutine CtoA(myThid,fieldin1,fieldin2,mask1,mask2,idim1,idim2,
     .  jdim1,jdim2,numlevs,Nsx,Nsy,im1,im2,jm1,jm2,fieldout1,fieldout2)
c----------------------------------------------------------------------
c  Subroutine CtoA - Routine to map a velocity component quantity
c         from the C-Grid to the A-Grid. 
c         This includes doing an exchange to fill the halo region, and 
c         then a linear average with the appropriate topography mask.
c         Also: Set up "bi, bj loop" here.
c
c  Input: myThid
c         fieldin1    Field on c-grid to move to a-grid (1st component)
c         fieldin2    Field on c-grid to move to a-grid (2nd component)
c         mask1       Topography [0,1] mask - 1 to indicate above ground
c         mask2       Topography [0,1] mask - 1 to indicate above ground
c         idim1,idim2,jdim1,jdim2   Indeces in x and y for computations
c         numlevs     Number of vertical levels
c         Nsx, Nsy    
c         im1,im2,jm1,jm2   Span of fields in x and y
c
c Output: fieldout1   Field mapped to A-Grid (1st component)
c         fieldout2   Field mapped to A-Grid (2nd component)
c
c Call: exchange on c-grid
c-----------------------------------------------------------------------
       implicit none
#include "EEPARAMS.h"

       integer myThid, numlevs
       integer idim1, idim2, jdim1, jdim2, im1, im2, jm1, jm2
       integer Nsx, Nsy
       _RS mask1(idim1:idim2,jdim1:jdim2,numlevs,Nsx,Nsy)
       _RS mask2(idim1:idim2,jdim1:jdim2,numlevs,Nsx,Nsy)
       _RL fieldin1(idim1:idim2,jdim1:jdim2,numlevs,Nsx,Nsy)
       _RL fieldin2(idim1:idim2,jdim1:jdim2,numlevs,Nsx,Nsy)
       _RL fieldout1(idim1:idim2,jdim1:jdim2,numlevs,Nsx,Nsy)
       _RL fieldout2(idim1:idim2,jdim1:jdim2,numlevs,Nsx,Nsy)

       integer i, j, L, bi, bj
       logical withSigns
       data withSigns/.TRUE./
       _RL tmpfld1(idim1:idim2,jdim1:jdim2)
       _RL tmpfld2(idim1:idim2,jdim1:jdim2)

c Call the c-grid exchange routine to fill in the halo regions
       call exch_uv_xyz_RL(fieldin1,fieldin2,withSigns,myThid)

c Now take average
       do bj = myByLo(myThid), myByHi(myThid)
       do bi = myBxLo(myThid), myBxHi(myThid)

        do L = 1,numlevs
         do j = jdim1,jdim2
          do i = idim1,idim2
           tmpfld1(i,j) = fieldin1(i,j,L,bi,bj)*mask1(i,j,L,bi,bj)
           tmpfld2(i,j) = fieldin2(i,j,L,bi,bj)*mask2(i,j,L,bi,bj)
          enddo
         enddo
         do j = jm1,jm2
         do i = im1,im2
          if( (mask1(i,j,L,bi,bj).ne.0.) .or. 
     .                               (mask1(i+1,j,L,bi,bj).ne.0.) ) then
c          fieldout1(i,j,L,bi,bj) = 
c    .        ( fieldin1(i,j,L,bi,bj)*mask1(i,j,L,bi,bj) + 
c    .          fieldin1(i+1,j,L,bi,bj)*mask1(i+1,j,L,bi,bj) ) /
c    .            ( mask1(i,j,L,bi,bj) + mask1(i+1,j,L,bi,bj) )
           fieldout1(i,j,L,bi,bj) = 
     .            ( tmpfld1(i,j) + tmpfld1(i+1,j) ) /
     .            ( mask1(i,j,L,bi,bj) + mask1(i+1,j,L,bi,bj) )
          else
           fieldout1(i,j,L,bi,bj) = 0.
          endif
          if( (mask2(i,j,L,bi,bj).ne.0.) .or. 
     .                               (mask2(i,j+1,L,bi,bj).ne.0.) ) then
c          fieldout2(i,j,L,bi,bj) = 
c    .        ( fieldin2(i,j,L,bi,bj)*mask2(i,j,L,bi,bj) + 
c    .          fieldin2(i,j+1,L,bi,bj)*mask2(i,j+1,L,bi,bj) ) /
c    .            ( mask2(i,j,L,bi,bj) + mask2(i,j+1,L,bi,bj) )
           fieldout2(i,j,L,bi,bj) = 
     .            ( tmpfld2(i,j) + tmpfld2(i,j+1) ) /
     .            ( mask2(i,j,L,bi,bj) + mask2(i,j+1,L,bi,bj) )
          else
           fieldout2(i,j,L,bi,bj) = 0.
          endif
         enddo
         enddo
        enddo

       enddo
       enddo

       return
       end

#include "PTRACERS_OPTIONS.h"
#include "GAD_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: PTRACERS_INIT_VARIA

C     !INTERFACE:
      SUBROUTINE PTRACERS_INIT_VARIA( myThid )

C     !DESCRIPTION:
C     Initialize PTRACERS data structures

C     !USES:
#include "PTRACERS_MOD.h"
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "GAD.h"
#include "PTRACERS_SIZE.h"
#include "PTRACERS_PARAMS.h"
#include "PTRACERS_START.h"
#include "PTRACERS_FIELDS.h"

C     !INPUT PARAMETERS:
C     myThid               :: thread number
      INTEGER myThid

#ifdef ALLOW_PTRACERS

C     !LOCAL VARIABLES:
C     i,j,k,bi,bj,iTracer  :: loop indices
      INTEGER i,j,k,bi,bj,iTracer
#ifdef PTRACERS_ALLOW_DYN_STATE
      INTEGER n
#endif
      CHARACTER*(MAX_LEN_FNAM) tmpInitialFile
CEOP

C     Initialise internal parameter in common block:
      _BEGIN_MASTER( myThid )
      DO iTracer = 1, PTRACERS_num
        PTRACERS_StepFwd(iTracer) = .TRUE.
        PTRACERS_startAB(iTracer) = nIter0 - PTRACERS_Iter0
      ENDDO
      _END_MASTER( myThid )
      _BARRIER

C     Loop over tracers
      DO iTracer = 1, PTRACERS_num

C     Loop over tiles
       DO bj = myByLo(myThid), myByHi(myThid)
        DO bi = myBxLo(myThid), myBxHi(myThid)

C     Initialize arrays in common blocks :
         DO k=1,Nr
          DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
            pTracer(i,j,k,bi,bj,iTracer) = PTRACERS_ref(k,iTracer)
            gpTrNm1(i,j,k,bi,bj,iTracer) = 0. _d 0
           ENDDO
          ENDDO
         ENDDO
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           surfaceForcingPTr(i,j,bi,bj,iTracer) = 0. _d 0
          ENDDO
         ENDDO

#ifdef PTRACERS_ALLOW_DYN_STATE
C     Initialize SOM array :
         IF ( PTRACERS_SOM_Advection(iTracer) ) THEN
           DO n = 1,nSOM
            DO k=1,Nr
             DO j=1-OLy,sNy+OLy
              DO i=1-OLx,sNx+OLx
               _Ptracers_som(i,j,k,bi,bj,n,iTracer) = 0. _d 0
              ENDDO
             ENDDO
            ENDDO
           ENDDO
         ENDIF
#endif /* PTRACERS_ALLOW_DYN_STATE */

C     end bi,bj loops
        ENDDO
       ENDDO

C     end of Tracer loop
      ENDDO

C     Now read initial conditions and always exchange
      IF (nIter0.EQ.PTRACERS_Iter0) THEN
       DO iTracer = 1, PTRACERS_numInUse
        tmpInitialFile = PTRACERS_initialFile(iTracer)
        IF ( tmpInitialFile .NE. ' ' ) THEN
         CALL READ_FLD_XYZ_RL(tmpInitialFile,' ',
     &        pTracer(1-OLx,1-OLy,1,1,1,iTracer),0,myThid)
         _EXCH_XYZ_RL(pTracer(1-OLx,1-OLy,1,1,1,iTracer),myThid)
        ENDIF
       ENDDO
      ENDIF

C     Apply mask
      DO iTracer = 1, PTRACERS_numInUse
       DO bj = myByLo(myThid), myByHi(myThid)
        DO bi = myBxLo(myThid), myBxHi(myThid)
         DO k=1,Nr
          DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
            IF (maskC(i,j,k,bi,bj).EQ.0.)
     &           pTracer(i,j,k,bi,bj,iTracer)=0. _d 0
           ENDDO
          ENDDO
         ENDDO
        ENDDO
       ENDDO
      ENDDO

C Read from a pickup file if needed
      IF ( nIter0.GT.PTRACERS_Iter0 .OR.
     &    (nIter0.EQ.PTRACERS_Iter0 .AND. pickupSuff.NE.' ')
     &   ) THEN

       CALL PTRACERS_READ_PICKUP( nIter0, myThid )
      ENDIF

#endif /* ALLOW_PTRACERS */

      RETURN
      END

#include "PACKAGES_CONFIG.h"
#include "CPP_OPTIONS.h"

C--  File apply_forcing.F:
C--   Contents
C--   o APPLY_FORCING_U
C--   o APPLY_FORCING_V
C--   o APPLY_FORCING_T
C--   o APPLY_FORCING_S

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: APPLY_FORCING_U
C     !INTERFACE:
      SUBROUTINE APPLY_FORCING_U(
     U                     gU_arr,
     I                     iMin,iMax,jMin,jMax, k, bi, bj,
     I                     myTime, myIter, myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R APPLY_FORCING_U
C     | o Contains problem specific forcing for zonal velocity.
C     *==========================================================*
C     | Adds terms to gU for forcing by external sources
C     | e.g. wind stress, bottom friction etc ...
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     == Global data ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "DYNVARS.h"
#include "FFIELDS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     gU_arr    :: the tendency array
C     iMin,iMax :: Working range of x-index for applying forcing.
C     jMin,jMax :: Working range of y-index for applying forcing.
C     k         :: Current vertical level index
C     bi,bj     :: Current tile indices
C     myTime    :: Current time in simulation
C     myIter    :: Current iteration number
C     myThid    :: my Thread Id number
      _RL     gU_arr(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER iMin, iMax, jMin, jMax
      INTEGER k, bi, bj
      _RL     myTime
      INTEGER myIter
      INTEGER myThid

C     !LOCAL VARIABLES:
C     i,j       :: Loop counters
C     kSurface  :: index of surface level
      INTEGER i, j
#ifdef USE_OLD_EXTERNAL_FORCING
      _RL     locVar(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL     tmpVar(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
#else
      INTEGER kSurface
#endif /* USE_OLD_EXTERNAL_FORCING */
CEOP

#ifdef USE_OLD_EXTERNAL_FORCING

      DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
          locVar(i,j) = gU(i,j,k,bi,bj)
        ENDDO
      ENDDO
      CALL EXTERNAL_FORCING_U(
     I              iMin, iMax, jMin, jMax, bi, bj, k,
     I              myTime, myThid )
C-    Use 2-d local array tmpVar and split loop in 2 parts to avoid compiler
C     to mess-up this part by re-arranging the order of instructions (wrong
C     when gU and gU_arr are the same array, i.e., called with argument gU).
      DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
          tmpVar(i,j) = gU(i,j,k,bi,bj) - locVar(i,j)
          gU(i,j,k,bi,bj) = locVar(i,j)
        ENDDO
      ENDDO
C-    not needed since APPLY_FORCING_U is no longer called with argument gU
c     CALL FOOL_THE_COMPILER_RL( tmpVar(1,1) )
      DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
          gU_arr(i,j) = gU_arr(i,j) + tmpVar(i,j)
        ENDDO
      ENDDO

#else  /* USE_OLD_EXTERNAL_FORCING */

      IF ( fluidIsAir ) THEN
       kSurface = 0
      ELSEIF ( usingPCoords ) THEN
       kSurface = Nr
      ELSE
       kSurface = 1
      ENDIF

C--   Forcing term
#ifdef ALLOW_AIM
      IF ( useAIM ) CALL AIM_TENDENCY_APPLY_U(
     U                       gU_arr,
     I                       iMin,iMax,jMin,jMax, k, bi,bj,
     I                       myTime, myIter, myThid )
#endif /* ALLOW_AIM */

#ifdef ALLOW_ATM_PHYS
      IF ( useAtm_Phys ) CALL ATM_PHYS_TENDENCY_APPLY_U(
     U                       gU_arr,
     I                       iMin,iMax,jMin,jMax, k, bi,bj,
     I                       myTime, myIter, myThid )
#endif /* ALLOW_ATM_PHYS */

#ifdef ALLOW_FIZHI
      IF ( useFIZHI ) CALL FIZHI_TENDENCY_APPLY_U(
     U                       gU_arr,
     I                       iMin,iMax,jMin,jMax, k, bi,bj,
     I                       myTime, myIter, myThid )
#endif /* ALLOW_FIZHI */

C     Add Tidal momentum forcing from 2-d geopotential anomaly
      IF ( momTidalForcing ) THEN
       DO j=0,sNy+1
        DO i=1,sNx+1
          gU_arr(i,j) = gU_arr(i,j)
     &      - recip_dxC(i,j,bi,bj)*recip_deepFacC(k)
     &      * ( phiTide2d(i,j,bi,bj) - phiTide2d(i-1,j,bi,bj) )
     &      *_maskW(i,j,k,bi,bj)
        ENDDO
       ENDDO
      ENDIF

C     Ocean: Add momentum surface forcing (e.g., wind-stress) in surface level
      IF ( k .EQ. kSurface ) THEN
c      DO j=1,sNy
C-jmc: Without CD-scheme, this is OK ; but with CD-scheme, needs to cover [0:sNy+1]
       DO j=0,sNy+1
        DO i=1,sNx+1
          gU_arr(i,j) = gU_arr(i,j)
     &      +foFacMom*surfaceForcingU(i,j,bi,bj)
     &      *recip_drF(k)*_recip_hFacW(i,j,k,bi,bj)
        ENDDO
       ENDDO
      ELSEIF ( kSurface.EQ.-1 ) THEN
       DO j=0,sNy+1
        DO i=1,sNx+1
         IF ( kSurfW(i,j,bi,bj).EQ.k ) THEN
          gU_arr(i,j) = gU_arr(i,j)
     &      +foFacMom*surfaceForcingU(i,j,bi,bj)
     &      *recip_drF(k)*_recip_hFacW(i,j,k,bi,bj)
         ENDIF
        ENDDO
       ENDDO
      ENDIF

#ifdef ALLOW_EDDYPSI
         CALL TAUEDDY_TENDENCY_APPLY_U(
     U                 gU_arr,
     I                 iMin,iMax,jMin,jMax, k, bi,bj,
     I                 myTime, myIter, myThid )
#endif

#ifdef ALLOW_RBCS
      IF (useRBCS) THEN
        CALL RBCS_ADD_TENDENCY(
     U                 gU_arr,
     I                 k, bi, bj, -1,
     I                 myTime, myIter, myThid )

      ENDIF
#endif /* ALLOW_RBCS */

#ifdef ALLOW_OBCS
      IF (useOBCS) THEN
        CALL OBCS_SPONGE_U(
     U                   gU_arr,
     I                   iMin,iMax,jMin,jMax, k, bi,bj,
     I                   myTime, myIter, myThid )
      ENDIF
#endif /* ALLOW_OBCS */

#ifdef ALLOW_MYPACKAGE
      IF ( useMYPACKAGE ) THEN
        CALL MYPACKAGE_TENDENCY_APPLY_U(
     U                 gU_arr,
     I                 iMin,iMax,jMin,jMax, k, bi,bj,
     I                 myTime, myIter, myThid )
      ENDIF
#endif /* ALLOW_MYPACKAGE */

#endif /* USE_OLD_EXTERNAL_FORCING */

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: APPLY_FORCING_V
C     !INTERFACE:
      SUBROUTINE APPLY_FORCING_V(
     U                     gV_arr,
     I                     iMin,iMax,jMin,jMax, k, bi, bj,
     I                     myTime, myIter, myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R APPLY_FORCING_V
C     | o Contains problem specific forcing for merid velocity.
C     *==========================================================*
C     | Adds terms to gV for forcing by external sources
C     | e.g. wind stress, bottom friction etc ...
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     == Global data ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "DYNVARS.h"
#include "FFIELDS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     gV_arr    :: the tendency array
C     iMin,iMax :: Working range of x-index for applying forcing.
C     jMin,jMax :: Working range of y-index for applying forcing.
C     k         :: Current vertical level index
C     bi,bj     :: Current tile indices
C     myTime    :: Current time in simulation
C     myIter    :: Current iteration number
C     myThid    :: my Thread Id number
      _RL     gV_arr(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER iMin, iMax, jMin, jMax
      INTEGER k, bi, bj
      _RL     myTime
      INTEGER myIter
      INTEGER myThid

C     !LOCAL VARIABLES:
C     i,j       :: Loop counters
C     kSurface  :: index of surface level
      INTEGER i, j
#ifdef USE_OLD_EXTERNAL_FORCING
      _RL     locVar(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL     tmpVar(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
#else
      INTEGER kSurface
#endif /* USE_OLD_EXTERNAL_FORCING */
CEOP

#ifdef USE_OLD_EXTERNAL_FORCING

      DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
          locVar(i,j) = gV(i,j,k,bi,bj)
        ENDDO
      ENDDO
      CALL EXTERNAL_FORCING_V(
     I              iMin, iMax, jMin, jMax, bi, bj, k,
     I              myTime, myThid )
C-    Use 2-d local array tmpVar and split loop in 2 parts to avoid compiler
C     to mess-up this part by re-arranging the order of instructions (wrong
C     when gV and gV_arr are the same array, i.e., called with argument gV).
      DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
          tmpVar(i,j) = gV(i,j,k,bi,bj) - locVar(i,j)
          gV(i,j,k,bi,bj) = locVar(i,j)
        ENDDO
      ENDDO
C-    not needed since APPLY_FORCING_V is no longer called with argument gV
c     CALL FOOL_THE_COMPILER_RL( tmpVar(1,1) )
      DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
          gV_arr(i,j) = gV_arr(i,j) + tmpVar(i,j)
        ENDDO
      ENDDO

#else  /* USE_OLD_EXTERNAL_FORCING */

      IF ( fluidIsAir ) THEN
       kSurface = 0
      ELSEIF ( usingPCoords ) THEN
       kSurface = Nr
      ELSE
       kSurface = 1
      ENDIF

C--   Forcing term
#ifdef ALLOW_AIM
      IF ( useAIM ) CALL AIM_TENDENCY_APPLY_V(
     U                       gV_arr,
     I                       iMin,iMax,jMin,jMax, k, bi,bj,
     I                       myTime, myIter, myThid )
#endif /* ALLOW_AIM */

#ifdef ALLOW_ATM_PHYS
      IF ( useAtm_Phys ) CALL ATM_PHYS_TENDENCY_APPLY_V(
     U                       gV_arr,
     I                       iMin,iMax,jMin,jMax, k, bi,bj,
     I                       myTime, myIter, myThid )
#endif /* ALLOW_ATM_PHYS */

#ifdef ALLOW_FIZHI
      IF ( useFIZHI ) CALL FIZHI_TENDENCY_APPLY_V(
     U                       gV_arr,
     I                       iMin,iMax,jMin,jMax, k, bi,bj,
     I                       myTime, myIter, myThid )
#endif /* ALLOW_FIZHI */

C     Add Tidal momentum forcing from 2-d geopotential anomaly
      IF ( momTidalForcing ) THEN
       DO j=1,sNy+1
        DO i=0,sNx+1
          gV_arr(i,j) = gV_arr(i,j)
     &      - recip_dyC(i,j,bi,bj)*recip_deepFacC(k)
     &      *( phiTide2d(i,j,bi,bj) - phiTide2d(i,j-1,bi,bj) )
     &      *_maskS(i,j,k,bi,bj)
        ENDDO
       ENDDO
      ENDIF

C     Ocean: Add momentum surface forcing (e.g., wind-stress) in surface level
      IF ( k .EQ. kSurface ) THEN
       DO j=1,sNy+1
c       DO i=1,sNx
C-jmc: Without CD-scheme, this is OK ; but with CD-scheme, needs to cover [0:sNx+1]
        DO i=0,sNx+1
          gV_arr(i,j) = gV_arr(i,j)
     &      +foFacMom*surfaceForcingV(i,j,bi,bj)
     &      *recip_drF(k)*_recip_hFacS(i,j,k,bi,bj)
        ENDDO
       ENDDO
      ELSEIF ( kSurface.EQ.-1 ) THEN
       DO j=1,sNy+1
        DO i=0,sNx+1
         IF ( kSurfS(i,j,bi,bj).EQ.k ) THEN
          gV_arr(i,j) = gV_arr(i,j)
     &      +foFacMom*surfaceForcingV(i,j,bi,bj)
     &      *recip_drF(k)*_recip_hFacS(i,j,k,bi,bj)
         ENDIF
        ENDDO
       ENDDO
      ENDIF

#ifdef ALLOW_EDDYPSI
         CALL TAUEDDY_TENDENCY_APPLY_V(
     U                 gV_arr,
     I                 iMin,iMax,jMin,jMax, k, bi,bj,
     I                 myTime, myIter, myThid )
#endif

#ifdef ALLOW_RBCS
      IF (useRBCS) THEN
        CALL RBCS_ADD_TENDENCY(
     U                 gV_arr,
     I                 k, bi, bj, -2,
     I                 myTime, myIter, myThid )
      ENDIF
#endif /* ALLOW_RBCS */

#ifdef ALLOW_OBCS
      IF (useOBCS) THEN
        CALL OBCS_SPONGE_V(
     U                   gV_arr,
     I                   iMin,iMax,jMin,jMax, k, bi,bj,
     I                   myTime, myIter, myThid )
      ENDIF
#endif /* ALLOW_OBCS */

#ifdef ALLOW_MYPACKAGE
      IF ( useMYPACKAGE ) THEN
        CALL MYPACKAGE_TENDENCY_APPLY_V(
     U                 gV_arr,
     I                 iMin,iMax,jMin,jMax, k, bi,bj,
     I                 myTime, myIter, myThid )
      ENDIF
#endif /* ALLOW_MYPACKAGE */

#endif /* USE_OLD_EXTERNAL_FORCING */

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: APPLY_FORCING_T
C     !INTERFACE:
      SUBROUTINE APPLY_FORCING_T(
     U                     gT_arr,
     I                     iMin,iMax,jMin,jMax, k, bi, bj,
     I                     myTime, myIter, myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R APPLY_FORCING_T
C     | o Contains problem specific forcing for temperature.
C     *==========================================================*
C     | Adds terms to gT for forcing by external sources
C     | e.g. heat flux, climatalogical relaxation, etc ...
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     == Global data ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "DYNVARS.h"
#include "FFIELDS.h"
#include "SURFACE.h"

C     !INPUT/OUTPUT PARAMETERS:
C     gT_arr    :: the tendency array
C     iMin,iMax :: Working range of x-index for applying forcing.
C     jMin,jMax :: Working range of y-index for applying forcing.
C     k         :: Current vertical level index
C     bi,bj     :: Current tile indices
C     myTime    :: Current time in simulation
C     myIter    :: Current iteration number
C     myThid    :: my Thread Id number
      _RL     gT_arr(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER iMin, iMax, jMin, jMax
      INTEGER k, bi, bj
      _RL     myTime
      INTEGER myIter
      INTEGER myThid

C     !LOCAL VARIABLES:
C     i,j       :: Loop counters
C     kSurface  :: index of surface level
      INTEGER i, j
#ifndef USE_OLD_EXTERNAL_FORCING
      INTEGER kSurface
      INTEGER km, kc, kp
      _RL     tmpVar(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL tmpFac, delPI
      _RL recip_Cp
#endif /* USE_OLD_EXTERNAL_FORCING */
CEOP

#ifdef USE_OLD_EXTERNAL_FORCING

      DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
          gT(i,j,k,bi,bj) = 0. _d 0
        ENDDO
      ENDDO
      CALL EXTERNAL_FORCING_T(
     I              iMin, iMax, jMin, jMax, bi, bj, k,
     I              myTime, myThid )
      DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
          gT_arr(i,j) = gT_arr(i,j) + gT(i,j,k,bi,bj)
        ENDDO
      ENDDO

#else  /* USE_OLD_EXTERNAL_FORCING */

      IF ( fluidIsAir ) THEN
       kSurface = 0
      ELSEIF ( usingZCoords .AND. useShelfIce ) THEN
       kSurface = -1
      ELSEIF ( usingPCoords ) THEN
       kSurface = Nr
      ELSE
       kSurface = 1
      ENDIF
      recip_Cp = 1. _d 0 / HeatCapacity_Cp

C--   Note on loop range: For model dynamics, only needs to get correct
C     forcing (update gT_arr) in tile interior (1:sNx,1:sNy);
C     However, for some diagnostics, we may want to get valid forcing
C     extended over 1 point in tile halo region (0:sNx+1,0:sNy=1).

C--   Forcing term
#ifdef ALLOW_AIM
      IF ( useAIM ) CALL AIM_TENDENCY_APPLY_T(
     U                       gT_arr,
     I                       iMin,iMax,jMin,jMax, k, bi,bj,
     I                       myTime, myIter, myThid )
#endif /* ALLOW_AIM */

#ifdef ALLOW_ATM_PHYS
      IF ( useAtm_Phys ) CALL ATM_PHYS_TENDENCY_APPLY_T(
     U                       gT_arr,
     I                       iMin,iMax,jMin,jMax, k, bi,bj,
     I                       myTime, myIter, myThid )
#endif /* ALLOW_ATM_PHYS */

#ifdef ALLOW_FIZHI
      IF ( useFIZHI ) CALL FIZHI_TENDENCY_APPLY_T(
     U                       gT_arr,
     I                       iMin,iMax,jMin,jMax, k, bi,bj,
     I                       myTime, myIter, myThid )
#endif /* ALLOW_FIZHI */

#ifdef ALLOW_ADDFLUID
      IF ( selectAddFluid.NE.0 .AND. temp_addMass.NE.UNSET_RL ) THEN
       IF ( ( selectAddFluid.GE.1 .AND. nonlinFreeSurf.GT.0 )
     &      .OR. convertFW2Salt.EQ.-1. _d 0 ) THEN
         DO j=0,sNy+1
          DO i=0,sNx+1
            gT_arr(i,j) = gT_arr(i,j)
     &        + addMass(i,j,k,bi,bj)*mass2rUnit
     &          *( temp_addMass - theta(i,j,k,bi,bj) )
     &          *recip_rA(i,j,bi,bj)
     &          *recip_drF(k)*_recip_hFacC(i,j,k,bi,bj)
C    &          *recip_deepFac2C(k)*recip_rhoFacC(k)
          ENDDO
         ENDDO
       ELSE
         DO j=0,sNy+1
          DO i=0,sNx+1
            gT_arr(i,j) = gT_arr(i,j)
     &        + addMass(i,j,k,bi,bj)*mass2rUnit
     &          *( temp_addMass - tRef(k) )
     &          *recip_rA(i,j,bi,bj)
     &          *recip_drF(k)*_recip_hFacC(i,j,k,bi,bj)
C    &          *recip_deepFac2C(k)*recip_rhoFacC(k)
          ENDDO
         ENDDO
       ENDIF
      ENDIF
#endif /* ALLOW_ADDFLUID */

#ifdef ALLOW_FRICTION_HEATING
      IF ( addFrictionHeating ) THEN
        IF ( fluidIsAir ) THEN
C         conversion from in-situ Temp to Pot.Temp
          tmpFac = (atm_Po/rC(k))**atm_kappa
C         conversion from W/m^2/r_unit to K/s
          tmpFac = (tmpFac/atm_Cp) * mass2rUnit
        ELSE
C         conversion from W/m^2/r_unit to K/s
          tmpFac = recip_Cp * mass2rUnit
        ENDIF
        DO j=0,sNy+1
          DO i=0,sNx+1
            gT_arr(i,j) = gT_arr(i,j)
     &         + frictionHeating(i,j,k,bi,bj)*tmpFac
     &          *recip_drF(k)*_recip_hFacC(i,j,k,bi,bj)
          ENDDO
        ENDDO
      ENDIF
#endif /* ALLOW_FRICTION_HEATING */

      IF ( fluidIsAir .AND. atm_Rq.NE.zeroRL .AND. Nr.NE.1 ) THEN
C--   Compressible fluid: account for difference between moist and dry air
C     specific volume in Enthalpy equation (+ V.dP term), since only the
C     dry air part is accounted for in the (dry) Pot.Temp formulation.
C     Used centered averaging from interface to center (consistent with
C     conversion term in KE eq) and same discretisation ( [T*Q]_bar_k )
C     as for Theta_v in CALC_PHI_HYD

C     conversion from in-situ Temp to Pot.Temp
        tmpFac = (atm_Po/rC(k))**atm_kappa
C     conversion from W/kg to K/s
        tmpFac = tmpFac/atm_Cp
        km = k-1
        kc = k
        kp = k+1
        IF ( k.EQ.1 ) THEN
          DO j=0,sNy+1
           DO i=0,sNx+1
            tmpVar(i,j) = 0.
           ENDDO
          ENDDO
        ELSE
          delPI = atm_Cp*( (rC(km)/atm_Po)**atm_kappa
     &                   - (rC(kc)/atm_Po)**atm_kappa )
          DO j=0,sNy+1
           DO i=0,sNx+1
            tmpVar(i,j) = wVel(i,j,kc,bi,bj)*delPI*atm_Rq
     &                  *( theta(i,j,km,bi,bj)*salt(i,j,km,bi,bj)
     &                   + theta(i,j,kc,bi,bj)*salt(i,j,kc,bi,bj)
     &                   )*maskC(i,j,km,bi,bj)*0.25 _d 0
           ENDDO
          ENDDO
        ENDIF
        IF ( k.LT.Nr ) THEN
          delPI = atm_Cp*( (rC(kc)/atm_Po)**atm_kappa
     &                   - (rC(kp)/atm_Po)**atm_kappa )
          DO j=0,sNy+1
           DO i=0,sNx+1
            tmpVar(i,j) = tmpVar(i,j)
     &                  + wVel(i,j,kp,bi,bj)*delPI*atm_Rq
     &                  *( theta(i,j,kc,bi,bj)*salt(i,j,kc,bi,bj)
     &                   + theta(i,j,kp,bi,bj)*salt(i,j,kp,bi,bj)
     &                   )*maskC(i,j,kp,bi,bj)*0.25 _d 0
           ENDDO
          ENDDO
        ENDIF
        DO j=0,sNy+1
          DO i=0,sNx+1
            gT_arr(i,j) = gT_arr(i,j)
     &         + tmpVar(i,j)*tmpFac
     &          *recip_drF(k)*_recip_hFacC(i,j,k,bi,bj)
          ENDDO
        ENDDO
#ifdef ALLOW_DIAGNOSTICS
        IF ( useDiagnostics ) THEN
C     conversion to W/m^2
          tmpFac = rUnit2mass
          CALL DIAGNOSTICS_SCALE_FILL( tmpVar, tmpFac, 1,
     &                     'MoistCor', kc, 1, 2, bi,bj,myThid )
        ENDIF
#endif /* ALLOW_DIAGNOSTICS */
      ENDIF

C     Ocean: Add temperature surface forcing (e.g., heat-flux) in surface level
      IF ( k .EQ. kSurface ) THEN
       DO j=0,sNy+1
        DO i=0,sNx+1
          gT_arr(i,j) = gT_arr(i,j)
     &      +surfaceForcingT(i,j,bi,bj)
     &      *recip_drF(k)*_recip_hFacC(i,j,k,bi,bj)
        ENDDO
       ENDDO
      ELSEIF ( kSurface.EQ.-1 ) THEN
       DO j=0,sNy+1
        DO i=0,sNx+1
         IF ( kSurfC(i,j,bi,bj).EQ.k ) THEN
          gT_arr(i,j) = gT_arr(i,j)
     &      +surfaceForcingT(i,j,bi,bj)
     &      *recip_drF(k)*_recip_hFacC(i,j,k,bi,bj)
         ENDIF
        ENDDO
       ENDDO
      ENDIF

      IF (linFSConserveTr) THEN
       DO j=0,sNy+1
        DO i=0,sNx+1
         IF (k .EQ. kSurfC(i,j,bi,bj)) THEN
          gT_arr(i,j) = gT_arr(i,j)
     &        +TsurfCor*recip_drF(k)*_recip_hFacC(i,j,k,bi,bj)
         ENDIF
        ENDDO
       ENDDO
      ENDIF

#ifdef ALLOW_GEOTHERMAL_FLUX
      IF ( usingZCoords ) THEN
       DO j=0,sNy+1
        DO i=0,sNx+1
         IF ( k.EQ.kLowC(i,j,bi,bj) ) THEN
          gT_arr(i,j)=gT_arr(i,j)
     &      + geothermalFlux(i,j,bi,bj)
     &        *recip_Cp*mass2rUnit
     &        *recip_drF(k)*_recip_hFacC(i,j,k,bi,bj)
         ENDIF
        ENDDO
       ENDDO
      ELSEIF ( kSurface .EQ. Nr ) THEN
C     this is oceanic pressure coordinate case
C     where the flux at the bottom is applied as kSurfC
       DO j=0,sNy+1
        DO i=0,sNx+1
         IF ( k.EQ.kSurfC(i,j,bi,bj) ) THEN
          gT_arr(i,j)=gT_arr(i,j)
     &      + geothermalFlux(i,j,bi,bj)
     &        *recip_Cp*mass2rUnit
     &        *recip_drF(k)*_recip_hFacC(i,j,k,bi,bj)
         ENDIF
        ENDDO
       ENDDO
      ELSE
C-    Neither Z-Coords nor kSurface=Nr : not implemented
       STOP 'ABNORMAL END: S/R APPLY_FORCING_T (geothermal-flux)'
      ENDIF
#endif /* ALLOW_GEOTHERMAL_FLUX */

#ifdef SHORTWAVE_HEATING
C Penetrating SW radiation
      IF ( selectPenetratingSW .GT. 0 ) THEN
       DO j=0,sNy+1
        DO i=0,sNx+1
         gT_arr(i,j) = gT_arr(i,j)
     &        + Qsw(i,j,bi,bj)*gravitySign
     &        *( SWFrac3D(i,j,k,bi,bj) - SWFrac3D(i,j,k+1,bi,bj) )
     &        *recip_Cp*mass2rUnit
     &        *recip_drF(k)*_recip_hFacC(i,j,k,bi,bj)
        ENDDO
       ENDDO
      ENDIF
#endif /* SHORTWAVE_HEATING */

#ifdef ALLOW_FRAZIL
      IF ( useFRAZIL )
     &     CALL FRAZIL_TENDENCY_APPLY_T(
     U                 gT_arr,
     I                 iMin,iMax,jMin,jMax, k, bi,bj,
     I                 myTime, myIter, myThid )
#endif /* ALLOW_FRAZIL */

#ifdef ALLOW_SHELFICE
      IF ( useShelfIce )
     &     CALL SHELFICE_FORCING_T(
     U                   gT_arr,
     I                   iMin,iMax,jMin,jMax, k, bi,bj,
     I                   myTime, myIter, myThid )
#endif /* ALLOW_SHELFICE */

#ifdef ALLOW_ICEFRONT
      IF ( useICEFRONT )
     &     CALL ICEFRONT_TENDENCY_APPLY_T(
     U                   gT_arr,
     I                   k, bi, bj, myTime, myIter, myThid )
#endif /* ALLOW_ICEFRONT */

#ifdef ALLOW_SALT_PLUME
      IF ( useSALT_PLUME )
     &     CALL SALT_PLUME_TENDENCY_APPLY_T(
     U                     gT_arr,
     I                     iMin,iMax,jMin,jMax, k, bi,bj,
     I                     myTime, myIter, myThid )
#endif /* ALLOW_SALT_PLUME */

#ifdef ALLOW_RBCS
      IF (useRBCS) THEN
        CALL RBCS_ADD_TENDENCY(
     U                 gT_arr,
     I                 k, bi, bj, 1,
     I                 myTime, myIter, myThid )
      ENDIF
#endif /* ALLOW_RBCS */

#ifdef ALLOW_OBCS
      IF (useOBCS) THEN
        CALL OBCS_SPONGE_T(
     U                   gT_arr,
     I                   iMin,iMax,jMin,jMax, k, bi,bj,
     I                   myTime, myIter, myThid )
      ENDIF
#endif /* ALLOW_OBCS */

#ifdef ALLOW_BBL
      IF ( useBBL ) CALL BBL_TENDENCY_APPLY_T(
     U                       gT_arr,
     I                       iMin,iMax,jMin,jMax, k, bi,bj,
     I                       myTime, myIter, myThid )
#endif /* ALLOW_BBL */

#ifdef ALLOW_MYPACKAGE
      IF ( useMYPACKAGE ) THEN
        CALL MYPACKAGE_TENDENCY_APPLY_T(
     U                 gT_arr,
     I                 iMin,iMax,jMin,jMax, k, bi,bj,
     I                 myTime, myIter, myThid )
      ENDIF
#endif /* ALLOW_MYPACKAGE */

#endif /* USE_OLD_EXTERNAL_FORCING */

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: APPLY_FORCING_S
C     !INTERFACE:
      SUBROUTINE APPLY_FORCING_S(
     U                     gS_arr,
     I                     iMin,iMax,jMin,jMax, k, bi, bj,
     I                     myTime, myIter, myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R APPLY_FORCING_S
C     | o Contains problem specific forcing for merid velocity.
C     *==========================================================*
C     | Adds terms to gS for forcing by external sources
C     | e.g. fresh-water flux, climatalogical relaxation, etc ...
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     == Global data ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "DYNVARS.h"
#include "FFIELDS.h"
#include "SURFACE.h"

C     !INPUT/OUTPUT PARAMETERS:
C     gS_arr    :: the tendency array
C     iMin,iMax :: Working range of x-index for applying forcing.
C     jMin,jMax :: Working range of y-index for applying forcing.
C     k         :: Current vertical level index
C     bi,bj     :: Current tile indices
C     myTime    :: Current time in simulation
C     myIter    :: Current iteration number
C     myThid    :: my Thread Id number
      _RL     gS_arr(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER iMin, iMax, jMin, jMax
      INTEGER k, bi, bj
      _RL     myTime
      INTEGER myIter
      INTEGER myThid

C     !LOCAL VARIABLES:
C     i,j       :: Loop counters
C     kSurface  :: index of surface level
      INTEGER i, j
#ifndef USE_OLD_EXTERNAL_FORCING
      INTEGER kSurface
#endif /* USE_OLD_EXTERNAL_FORCING */
CEOP

#ifdef USE_OLD_EXTERNAL_FORCING

      DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
          gS(i,j,k,bi,bj) = 0. _d 0
        ENDDO
      ENDDO
      CALL EXTERNAL_FORCING_S(
     I              iMin, iMax, jMin, jMax, bi, bj, k,
     I              myTime, myThid )
      DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
          gS_arr(i,j) = gS_arr(i,j) + gS(i,j,k,bi,bj)
        ENDDO
      ENDDO

#else  /* USE_OLD_EXTERNAL_FORCING */

      IF ( fluidIsAir ) THEN
       kSurface = 0
      ELSEIF ( usingZCoords .AND. useShelfIce ) THEN
       kSurface = -1
      ELSEIF ( usingPCoords ) THEN
       kSurface = Nr
      ELSE
       kSurface = 1
      ENDIF

C--   Note on loop range: For model dynamics, only needs to get correct
C     forcing (update gS_arr) in tile interior (1:sNx,1:sNy);
C     However, for some diagnostics, we may want to get valid forcing
C     extended over 1 point in tile halo region (0:sNx+1,0:sNy=1).

C--   Forcing term
#ifdef ALLOW_AIM
      IF ( useAIM ) CALL AIM_TENDENCY_APPLY_S(
     U                       gS_arr,
     I                       iMin,iMax,jMin,jMax, k, bi,bj,
     I                       myTime, myIter, myThid )
#endif /* ALLOW_AIM */

#ifdef ALLOW_ATM_PHYS
      IF ( useAtm_Phys ) CALL ATM_PHYS_TENDENCY_APPLY_S(
     U                       gS_arr,
     I                       iMin,iMax,jMin,jMax, k, bi,bj,
     I                       myTime, myIter, myThid )
#endif /* ALLOW_ATM_PHYS */

#ifdef ALLOW_FIZHI
      IF ( useFIZHI ) CALL FIZHI_TENDENCY_APPLY_S(
     U                       gS_arr,
     I                       iMin,iMax,jMin,jMax, k, bi,bj,
     I                       myTime, myIter, myThid )
#endif /* ALLOW_FIZHI */

#ifdef ALLOW_ADDFLUID
      IF ( selectAddFluid.NE.0 .AND. salt_addMass.NE.UNSET_RL ) THEN
       IF ( ( selectAddFluid.GE.1 .AND. nonlinFreeSurf.GT.0 )
     &      .OR. convertFW2Salt.EQ.-1. _d 0 ) THEN
         DO j=0,sNy+1
          DO i=0,sNx+1
            gS_arr(i,j) = gS_arr(i,j)
     &        + addMass(i,j,k,bi,bj)*mass2rUnit
     &          *( salt_addMass - salt(i,j,k,bi,bj) )
     &          *recip_rA(i,j,bi,bj)
     &          *recip_drF(k)*_recip_hFacC(i,j,k,bi,bj)
C    &          *recip_deepFac2C(k)*recip_rhoFacC(k)
          ENDDO
         ENDDO
       ELSE
         DO j=0,sNy+1
          DO i=0,sNx+1
            gS_arr(i,j) = gS_arr(i,j)
     &        + addMass(i,j,k,bi,bj)*mass2rUnit
     &          *( salt_addMass - sRef(k) )
     &          *recip_rA(i,j,bi,bj)
     &          *recip_drF(k)*_recip_hFacC(i,j,k,bi,bj)
C    &          *recip_deepFac2C(k)*recip_rhoFacC(k)
          ENDDO
         ENDDO
       ENDIF
      ENDIF
#endif /* ALLOW_ADDFLUID */

C     Ocean: Add salinity surface forcing (e.g., fresh-water) in surface level
      IF ( k .EQ. kSurface ) THEN
       DO j=0,sNy+1
        DO i=0,sNx+1
          gS_arr(i,j) = gS_arr(i,j)
     &      +surfaceForcingS(i,j,bi,bj)
     &      *recip_drF(k)*_recip_hFacC(i,j,k,bi,bj)
        ENDDO
       ENDDO
      ELSEIF ( kSurface.EQ.-1 ) THEN
       DO j=0,sNy+1
        DO i=0,sNx+1
         IF ( kSurfC(i,j,bi,bj).EQ.k ) THEN
          gS_arr(i,j) = gS_arr(i,j)
     &      +surfaceForcingS(i,j,bi,bj)
     &      *recip_drF(k)*_recip_hFacC(i,j,k,bi,bj)
         ENDIF
        ENDDO
       ENDDO
      ENDIF

      IF (linFSConserveTr) THEN
       DO j=0,sNy+1
        DO i=0,sNx+1
         IF (k .EQ. kSurfC(i,j,bi,bj)) THEN
          gS_arr(i,j) = gS_arr(i,j)
     &        +SsurfCor*recip_drF(k)*_recip_hFacC(i,j,k,bi,bj)
         ENDIF
        ENDDO
       ENDDO
      ENDIF

#ifdef ALLOW_SHELFICE
      IF ( useShelfIce )
     &     CALL SHELFICE_FORCING_S(
     U                   gS_arr,
     I                   iMin,iMax,jMin,jMax, k, bi,bj,
     I                   myTime, myIter, myThid )
#endif /* ALLOW_SHELFICE */

#ifdef ALLOW_ICEFRONT
      IF ( useICEFRONT )
     &     CALL ICEFRONT_TENDENCY_APPLY_S(
     U                   gS_arr,
     I                   k, bi, bj, myTime, myIter, myThid )
#endif /* ALLOW_ICEFRONT */

#ifdef ALLOW_SALT_PLUME
      IF ( useSALT_PLUME )
     &     CALL SALT_PLUME_TENDENCY_APPLY_S(
     U                     gS_arr,
     I                     iMin,iMax,jMin,jMax, k, bi,bj,
     I                     myTime, myIter, myThid )
#endif /* ALLOW_SALT_PLUME */

#ifdef ALLOW_RBCS
      IF (useRBCS) THEN
        CALL RBCS_ADD_TENDENCY(
     U                 gS_arr,
     I                 k, bi, bj, 2,
     I                 myTime, myIter, myThid )
      ENDIF
#endif /* ALLOW_RBCS */

#ifdef ALLOW_OBCS
      IF (useOBCS) THEN
        CALL OBCS_SPONGE_S(
     U                   gS_arr,
     I                   iMin,iMax,jMin,jMax, k, bi,bj,
     I                   myTime, myIter, myThid )
      ENDIF
#endif /* ALLOW_OBCS */

#ifdef ALLOW_BBL
      IF ( useBBL ) CALL BBL_TENDENCY_APPLY_S(
     U                       gS_arr,
     I                       iMin,iMax,jMin,jMax, k, bi,bj,
     I                       myTime, myIter, myThid )
#endif /* ALLOW_BBL */

#ifdef ALLOW_MYPACKAGE
      IF ( useMYPACKAGE ) THEN
        CALL MYPACKAGE_TENDENCY_APPLY_S(
     U                 gS_arr,
     I                 iMin,iMax,jMin,jMax, k, bi,bj,
     I                 myTime, myIter, myThid )
      ENDIF
#endif /* ALLOW_MYPACKAGE */

#endif /* USE_OLD_EXTERNAL_FORCING */

      RETURN
      END

#include "ATM_CPL_OPTIONS.h"
#ifdef ALLOW_AIM
# include "AIM_OPTIONS.h"
#endif

CBOP
C     !ROUTINE: ATM_STORE_AIM_FIELDS
C     !INTERFACE:
      SUBROUTINE ATM_STORE_AIM_FIELDS(
     I                     bi, bj,
     I                     myTime, myIter, myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE ATM_STORE_AIM_FIELDS
C     | o Routine for saving AIM fields (e.g., surface wind
C     |   speed) for export to coupling layer.
C     *==========================================================*
C     | This version interfaces to the AIM package.
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     == Global variables ==
#ifdef ALLOW_AIM
# include "AIM_SIZE.h"
#else
# include "SIZE.h"
#endif

#include "EEPARAMS.h"
#include "PARAMS.h"
c#include "ATMIDS.h"
#include "CPL_PARAMS.h"
#ifdef ALLOW_AIM
# include "AIM2DYN.h"
# include "AIM_CO2.h"
#endif
C     == Global variables for coupling interface ==
#include "ATMCPL.h"

C     !INPUT/OUTPUT PARAMETERS:
C     bi, bj    :: Tile indices
C     myTime    :: Current time in simulation (s)
C     myIter    :: Current iteration number
C     myThid    :: My Thread Id. number
      INTEGER bi, bj
      _RL     myTime
      INTEGER myIter
      INTEGER myThid
CEOP

#ifdef ALLOW_AIM
C     !LOCAL VARIABLES:
C     i, j      :: Loop counters
      INTEGER i,j
      _RL cplTimeFraction

      cplTimeFraction = 1. _d 0 / DFLOAT(cplSendFrq_iter)

C     o Accumulate atmospheric surface wind speed (m/s) from AIM pkg
C       that will be exported to the coupling layer.
       sWSpeedTime(bi,bj) = sWSpeedTime(bi,bj) + cplTimeFraction
       DO j=1,sNy
        DO i=1,sNx
          sWSpeed(i,j,bi,bj) = sWSpeed(i,j,bi,bj)
     &                       + aim_surfWind(i,j,bi,bj)*cplTimeFraction
        ENDDO
       ENDDO

#ifdef ALLOW_AIM_CO2
c     IF ( atm_cplExch_DIC ) THEN
C     o Accumulate atmospheric CO2 from Aim pkg that will be exported
C       to the coupling layer.
       airCO2Time(bi,bj) = airCO2Time(bi,bj) + cplTimeFraction
       DO j=1,sNy
        DO i=1,sNx
          airCO2(i,j,bi,bj) = airCO2(i,j,bi,bj)
     &                      + aim_CO2(i,j,bi,bj)*cplTimeFraction
        ENDDO
       ENDDO
c     ENDIF
#endif /* ALLOW_AIM_CO2 */

#endif /* ALLOW_AIM */

      RETURN
      END

#include "BULK_FORCE_OPTIONS.h"

      SUBROUTINE BULKF_READPARMS( myThid )
C     *==========================================================*
C     | SUBROUTINE BULKF_READPARMS                               |
C     | o Routine to initialize BULKF variables and constants.   |
C     *==========================================================*
C     | Initialize BULKF    parameters, read in data.blk         |
C     *==========================================================*
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "BULKF_PARAMS.h"
#include "BULKF.h"
#ifdef CONSERV_BULKF
#include "BULKF_CONSERV.h"
#endif

C     === Routine arguments ===
      INTEGER myThid

#ifdef ALLOW_BULK_FORCE
C     === Local variables ===
C     msgBuf     :: Informational/error message buffer
C     iUnit      :: Work variable for IO unit number
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      INTEGER iUnit
C--   retired parameters:
      _RL blk_taveFreq

C--   Bulk Formula parameter
      NAMELIST /BULKF_CONST/
     &  rhoA, rhoFW,
     &  cpAir, Lvap, Lfresh,
     &  Tf0kel, Rgas, xkar, stefan,
     &  zref, zwd, zth,
     &  cDrag_1, cDrag_2, cDrag_3,
     &  cStantonS, cStantonU, cDalton,
     &  umin, humid_fac, saltQsFac, gamma_blk,
     &  atm_emissivity, ocean_emissivity,
     &  snow_emissivity, ice_emissivity,
#ifdef ALLOW_FORMULA_AIM
     &  FWIND0, CHS, VGUST, DTHETA, dTstab, FSTAB,
#endif
     &  ocean_albedo

      NAMELIST /BULKF_PARM01/
     &         useFluxFormula_AIM, blk_nIter, calcWindStress,
     &         blk_taveFreq,
     &         AirTempFile, AirHumidityFile, RainFile,
     &         SolarFile, LongwaveFile, UWindFile,
     &         VWindFile,  RunoffFile, WSpeedFile, QnetFile,
     &         EmPFile, CloudFile, airPotTempFile

#ifdef CONSERV_BULKF
c-    conserving qnet, empmr
      NAMELIST /BULKF_PARM02/
     &         qnet_off, empmr_off, conservcycle
#endif

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      IF ( .NOT.useBulkForce ) THEN
C-    pkg BULK_FORCE is not used
        _BEGIN_MASTER(myThid)
C-    Track pkg activation status:
C     print a (weak) warning if data.blk is found
         CALL PACKAGES_UNUSED_MSG(
     I                'useBulkForce', 'BULKF_READPARMS', 'blk' )
        _END_MASTER(myThid)
        RETURN
      ENDIF

      _BEGIN_MASTER(myThid)

C--   Default values
C-    Physical constant :
c     slp0   = atm_Po / 100.  ! reference sea-level atmospheric pressure [mb]
      rhoA   = 1.3 _d 0
      rhoFW  = rhoConstFresh
      cpAir  = atm_Cp
c     cpwv   = 1.81 _d 3
      Lvap   = 2.5 _d 6
      Lfresh = 3.34 _d 5
c     Lvap_ice = 2.83 _d 6
      Tf0kel = celsius2K
      Rgas   = atm_Rd
c     Rvap   = 461. _d 0
      xkar   = 0.4  _d 0
      stefan = 5.67 _d -8
      zref   = 10.0 _d 0
      zwd    = zref
      zth    = zref
      cDrag_1 = 2.70   _d -3
      cDrag_2 = 0.142  _d -3
      cDrag_3 = 0.0764 _d -3
      cStantonS = 18.0 _d -3
      cStantonU = 32.7 _d -3
      cDalton   = 34.6 _d -3
      umin      =  1.0 _d 0
      humid_fac =  0.606 _d 0
      saltQsFac =  0.980 _d 0
      gamma_blk =  0.010 _d 0
      atm_emissivity  = .90 _d 0
      ocean_emissivity= .985 _d 0
      snow_emissivity = .98 _d 0
      ice_emissivity  = .98 _d 0
      ocean_albedo    = .10 _d 0
#ifdef ALLOW_FORMULA_AIM
      FWIND0 = 0.6 _d 0
      CHS = 0.8 _d -3
      VGUST  = 5. _d 0
      DTHETA = 3. _d 0
      dTstab = 1. _d 0
      FSTAB  = 0.67 _d 0
#endif

C-    bulk-forcing parameters:
      useFluxFormula_AIM = .FALSE.
      blk_nIter = 5
      calcWindStress = zonalWindFile .EQ. ' '
     &           .AND. meridWindFile .EQ. ' '

C-    Input data files names :
      AirTempFile=' '
      AirHumidityFile=' '
      RainFile=' '
      SolarFile=' '
      LongwaveFile=' '
      UWindFile=' '
      VWindFile=' '
      WspeedFile=' '
      RunoffFile=' '
      QnetFile=' '
      EmPFile=' '
      CloudFile=' '
      SnowFile=' '
      airPotTempFile=' '

C-    retired params default:
      blk_taveFreq = UNSET_RL

      CALL OPEN_COPY_DATA_FILE(
     I                          'data.blk', 'BULKF_READPARMS',
     O                          iUnit,
     I                          myThid )

C--   Read parameters from open data file
      WRITE(msgBuf,'(A)')' BULKF_READPARMS: starts to read BULKF_CONST'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT , myThid)
      READ(UNIT=iUnit,NML=BULKF_CONST)
      WRITE(msgBuf,'(A)') ' BULKF_READPARMS: read BULKF_CONST : OK'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT , myThid)

      WRITE(msgBuf,'(A)')' BULKF_READPARMS: starts to read BULKF_PARM01'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT , myThid)
      READ(UNIT=iUnit,NML=BULKF_PARM01)
      WRITE(msgBuf,'(A)') ' BULKF_READPARMS: read BULKF_PARM01 : OK'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT , myThid)

#ifdef CONSERV_BULKF
c -- default
      qnet_off=0.d0
      empmr_off=0.d0
      WRITE(msgBuf,'(A)')' BULKF_READPARMS: starts reading BULKF_PARM02'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT , myThid)
      READ(UNIT=iUnit,NML=BULKF_PARM02)
      WRITE(msgBuf,'(A)') ' BULKF_READPARMS: read BULKF_PARM02 : OK'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT , myThid)

#endif /* CONSERV_BULKF */

C--   Close the open data file
#ifdef SINGLE_DISK_IO
      CLOSE(iUnit)
#else
      CLOSE(iUnit,STATUS='DELETE')
#endif /* SINGLE_DISK_IO */

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C--   Check for retired parameters:
      IF ( blk_taveFreq .NE. UNSET_RL ) THEN
        WRITE(msgBuf,'(2A)') 'BULKF_READPARMS: "blk_taveFreq"',
     &    ' is no longer allowed in file "data.blk"'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(2A)') 'BULKF_READPARMS: ',
     &    ' since "pkg/timeave" has been removed.'
        CALL PRINT_ERROR( msgBuf, myThid )
c       errCount = errCount + 1
        STOP 'ABNORMAL END: S/R BULKF_READPARMS'
      ENDIF

C-  check that CPP option is "defined" when running-flag parameter is on:
#ifndef ALLOW_FORMULA_AIM
      IF ( useFluxFormula_AIM ) THEN
        WRITE(msgBuf,'(2A)') ' BULKF_READPARMS: ',
     &   'useFluxFormula_AIM is TRUE and #undef ALLOW_FORMULA_AIM'
        CALL PRINT_ERROR( msgBuf , myThid)
        WRITE(msgBuf,'(2A)') ' BULKF_READPARMS: => recompile with',
     &   ' #define ALLOW_FORMULA_AIM in BULK_FORCE_OPTIONS.h'
        CALL PRINT_ERROR( msgBuf , myThid)
        STOP 'ABNORMAL END: S/R BULKF_READPARMS'
      ENDIF
#endif

C-    Define other constants (from previous ones):
c     Qcoef  = 6.11 _d 0 * 0.622 _d 0 / p0
c     Sha    = Rgas / .286 _d 0

      useQnetch = QnetFile .NE. ' '
      useEmPch  = EmPFile  .NE. ' '

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
      iUnit = standardMessageUnit
c     iUnit=88
c     OPEN(iUnit,file='bulkf_check_params',status='unknown')
c     WRITE(iUnit,*) 'BlkF: slp0     =',slp0
      WRITE(iUnit,*) 'BlkF: rhoA     =',rhoA
      WRITE(iUnit,*) 'BlkF: rhoFW    =',rhoFW
      WRITE(iUnit,*) 'BlkF: cpAir    =',cpAir
c     WRITE(iUnit,*) 'BlkF: cpwv     =',cpwv
      WRITE(iUnit,*) 'BlkF: Lvap     =',Lvap
      WRITE(iUnit,*) 'BlkF: Lfresh   =',Lfresh
c     WRITE(iUnit,*) 'BlkF: Lvap_ice =',Lvap_ice
c     WRITE(iUnit,*) 'BlkF: Sha      =',Sha
      WRITE(iUnit,*) 'BlkF: Tf0kel   =',Tf0kel
      WRITE(iUnit,*) 'BlkF: Rgas     =',Rgas
c     WRITE(iUnit,*) 'BlkF: Rvap     =',Rvap
      WRITE(iUnit,*) 'BlkF: xkar     =',xkar
      WRITE(iUnit,*) 'BlkF: stefan   =',stefan
      WRITE(iUnit,*) 'BlkF: zref     =',zref
      WRITE(iUnit,*) 'BlkF: zwd      =',zwd
      WRITE(iUnit,*) 'BlkF: zth      =',zth
      WRITE(iUnit,*) 'BlkF: cDrag_1  =',cDrag_1
      WRITE(iUnit,*) 'BlkF: cDrag_2  =',cDrag_2
      WRITE(iUnit,*) 'BlkF: cDrag_3  =',cDrag_3
      WRITE(iUnit,*) 'BlkF: cStantonS=',cStantonS
      WRITE(iUnit,*) 'BlkF: cStantonU=',cStantonU
      WRITE(iUnit,*) 'BlkF: cDalton  =',cDalton
      WRITE(iUnit,*) 'BlkF: umin     =',umin
      WRITE(iUnit,*) 'BlkF: humid_fac=',humid_fac
      WRITE(iUnit,*) 'BlkF: saltQsFac=',saltQsFac
      WRITE(iUnit,*) 'BlkF: gamma_blk=',gamma_blk
      WRITE(iUnit,*) 'BlkF: atm_emissivity  =',atm_emissivity
      WRITE(iUnit,*) 'BlkF: ocean_emissivity=',ocean_emissivity
      WRITE(iUnit,*) 'BlkF: snow_emissivity =',snow_emissivity
      WRITE(iUnit,*) 'BlkF: ice_emissivity  =',ice_emissivity
      WRITE(iUnit,*) 'BlkF: ocean_albedo    =',ocean_albedo
#ifdef ALLOW_FORMULA_AIM
      WRITE(iUnit,*) 'BlkF: FWIND0   =', FWIND0
      WRITE(iUnit,*) 'BlkF: CHS      =', CHS
      WRITE(iUnit,*) 'BlkF: VGUST    =', VGUST
      WRITE(iUnit,*) 'BlkF: DTHETA   =', DTHETA
      WRITE(iUnit,*) 'BlkF: dTstab   =', dTstab
      WRITE(iUnit,*) 'BlkF: FSTAB    =', FSTAB
#endif
      WRITE(iUnit,*) 'BlkF: useFluxFormula_AIM=',useFluxFormula_AIM
      WRITE(iUnit,*) 'BlkF: calcWindStress  =', calcWindStress
      WRITE(iUnit,*) 'BlkF: useQnetch       =', useQnetch
      WRITE(iUnit,*) 'BlkF: useEmPch        =', useEmPch
      WRITE(iUnit,*) 'BlkF: blk_nIter   =',blk_nIter
      IF (iUnit.EQ.88) CLOSE(iUnit)
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      _END_MASTER(myThid)

C--   Everyone else must wait for the parameters to be loaded
      _BARRIER

#endif /* ALLOW_BULK_FORCE */

      RETURN
      END

#include "PACKAGES_CONFIG.h"
#include "CPP_OPTIONS.h"
#include "AD_CONFIG.h"
#ifdef ALLOW_AUTODIFF
# include "AUTODIFF_OPTIONS.h"
#endif

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: WRITE_GRID
C     !INTERFACE:
      SUBROUTINE WRITE_GRID(
     I                 myThid )

C     !DESCRIPTION:
C     Writes the model geometry and grid arrays to file(s) using which
C     ever I/O package is available/active.  This includes horizontal
C     and vertical grid and finite volume modulating factors (hFacs).
C     Essentailly, it dumps the contents of GRID.h to disk.

C     !CALLING SEQUENCE:
C     INITIALIZE_FIXED
C       |
C       |-- WRITE_GRID

C     !USES:
      IMPLICIT NONE

#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#ifdef ALLOW_MNC
#include "MNC_PARAMS.h"
#endif
#include "GRID.h"

C     !INPUT/OUTPUT PARAMETERS:
C     myThid -  Number of this instances
      INTEGER myThid

C     !LOCAL VARIABLES:
C     tmpfld :: Temporary array used to compute & write Total Depth ;
C               loaded in multi-threaded way but written by single (master)
C               thread => needs to be in common to be shared by all threads
C     no longer needed since MDSIO now allows (2009/06/07) to write local arrays
c     COMMON / LOCAL_WRITE_GRID / tmpfld
      _RS tmpfld(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RS tmpVar(Nr+1)
      INTEGER i,j,k,bi,bj
      LOGICAL writegrid_mdsio
#ifdef ALLOW_MNC
      CHARACTER*(4) bfname
#endif
CEOP

C     Calculate the fluid thickness in R coordinates as seen by the
C     model.  This may differ from what the user specified due to
C     partial cells, etc.
      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
C     Total fluid column thickness (r_unit) :
            tmpfld(i,j,bi,bj) = Ro_surf(i,j,bi,bj) - R_low(i,j,bi,bj)
          ENDDO
         ENDDO
       ENDDO
      ENDDO
c     _BARRIER

      writegrid_mdsio = .TRUE.
#ifdef ALLOW_MNC
      IF ( useMNC ) THEN
        writegrid_mdsio = outputTypesInclusive .OR. .NOT.writegrid_mnc
      ENDIF
#endif /* ALLOW_MNC */

      IF ( writegrid_mdsio ) THEN

C     Write horizontal grid arrays
        CALL WRITE_FLD_XY_RS( 'XC',' ',xC,-1,myThid)
        CALL WRITE_FLD_XY_RS( 'YC',' ',yC,-1,myThid)
        CALL WRITE_FLD_XY_RS( 'XG',' ',xG,-1,myThid)
        CALL WRITE_FLD_XY_RS( 'YG',' ',yG,-1,myThid)
        CALL WRITE_FLD_XY_RS( 'RAC',' ',rA,-1,myThid)
        CALL WRITE_FLD_XY_RS( 'RAW',' ',rAw,-1,myThid)
        CALL WRITE_FLD_XY_RS( 'RAS',' ',rAs,-1,myThid)
        CALL WRITE_FLD_XY_RS( 'RAZ',' ',rAz,-1,myThid)
        CALL WRITE_FLD_XY_RS( 'DXG',' ',dxG,-1,myThid)
        CALL WRITE_FLD_XY_RS( 'DYG',' ',dyG,-1,myThid)
        CALL WRITE_FLD_XY_RS( 'DXC',' ',dxC,-1,myThid)
        CALL WRITE_FLD_XY_RS( 'DYC',' ',dyC,-1,myThid)
        CALL WRITE_FLD_XY_RS( 'DXF',' ',dxF,-1,myThid)
        CALL WRITE_FLD_XY_RS( 'DYF',' ',dyF,-1,myThid)
        CALL WRITE_FLD_XY_RS( 'DXV',' ',dxV,-1,myThid)
        CALL WRITE_FLD_XY_RS( 'DYU',' ',dyU,-1,myThid)
        IF ( usingCurvilinearGrid .OR. rotateGrid ) THEN
          CALL WRITE_FLD_XY_RS( 'AngleCS',' ',angleCosC,-1,myThid)
          CALL WRITE_FLD_XY_RS( 'AngleSN',' ',angleSinC,-1,myThid)
          CALL WRITE_FLD_XY_RS( 'U2zonDir',' ',u2zonDir,-1,myThid)
          CALL WRITE_FLD_XY_RS( 'V2zonDir',' ',v2zonDir,-1,myThid)
        ENDIF
C     Write 3D geometry arrays
        CALL WRITE_FLD_XY_RS( 'Depth',' ',tmpfld,-1,myThid)
        IF ( debugLevel.GE.debLevC ) THEN
         CALL WRITE_FLD_XY_RS( 'rLowC', ' ', R_low, -1,myThid)
         CALL WRITE_FLD_XY_RS( 'rLowW', ' ', rLowW, -1,myThid)
         CALL WRITE_FLD_XY_RS( 'rLowS', ' ', rLowS, -1,myThid)
         CALL WRITE_FLD_XY_RS( 'rSurfC',' ',Ro_surf,-1,myThid)
         CALL WRITE_FLD_XY_RS( 'rSurfW',' ',rSurfW, -1,myThid)
         CALL WRITE_FLD_XY_RS( 'rSurfS',' ',rSurfS, -1,myThid)
        ENDIF
        CALL WRITE_FLD_XYZ_RS( 'hFacC',' ',hFacC, -1, myThid )
        CALL WRITE_FLD_XYZ_RS( 'hFacW',' ',hFacW, -1, myThid )
        CALL WRITE_FLD_XYZ_RS( 'hFacS',' ',hFacS, -1, myThid )
        IF ( fluidIsAir )
     &    CALL WRITE_FLD_XY_RS( 'topo_P',' ',Ro_surf,-1,myThid)
        IF ( useOBCS ) THEN
          CALL WRITE_FLD_XY_RS( 'maskInC',' ', maskInC, -1, myThid )
          CALL WRITE_FLD_XY_RS( 'maskInW',' ', maskInW, -1, myThid )
          CALL WRITE_FLD_XY_RS( 'maskInS',' ', maskInS, -1, myThid )
c         CALL WRITE_FULLARRAY_RS('maskInC',maskInC,1,0,0,1,-1,myThid)
c         CALL WRITE_FULLARRAY_RS('maskInW',maskInW,1,0,0,1,-1,myThid)
c         CALL WRITE_FULLARRAY_RS('maskInS',maskInS,1,0,0,1,-1,myThid)
        ENDIF

C     Write vertical grid arrays
        CALL WRITE_GLVEC_RS( 'RC', ' ', rC,  Nr, -1, myThid )
        CALL WRITE_GLVEC_RS( 'RF', ' ', rF, 1+Nr,-1, myThid )
        CALL WRITE_GLVEC_RS( 'DRC',' ', drC,1+Nr,-1, myThid )
        CALL WRITE_GLVEC_RS( 'DRF',' ', drF, Nr, -1, myThid )
        IF ( selectSigmaCoord.NE.0 ) THEN
         CALL WRITE_GLVEC_RS( 'AHybSigF',' ',aHybSigmF,1+Nr,-1,myThid )
         CALL WRITE_GLVEC_RS( 'BHybSigF',' ',bHybSigmF,1+Nr,-1,myThid )
         CALL WRITE_GLVEC_RS( 'AHybSigC',' ',aHybSigmC, Nr, -1,myThid )
         CALL WRITE_GLVEC_RS( 'BHybSigC',' ',bHybSigmC, Nr, -1,myThid )
         CALL WRITE_GLVEC_RS('DAHybSigF',' ',dAHybSigF, Nr, -1,myThid )
         CALL WRITE_GLVEC_RS('DBHybSigF',' ',dBHybSigF, Nr, -1,myThid )
         CALL WRITE_GLVEC_RS('DAHybSigC',' ',dAHybSigC,1+Nr,-1,myThid )
         CALL WRITE_GLVEC_RS('DBHybSigC',' ',dBHybSigC,1+Nr,-1,myThid )
        ENDIF

      ENDIF

C--  Comment out the "if": also useful for the Ocean (to get the full
C    Pressure) and write also these MDS file when writegrid_mdsio=F
C    (since missing from MNC grid-file)
c      IF (buoyancyRelation .EQ. 'ATMOSPHERIC') THEN
        DO k=1,Nr+1
          tmpVar(k) = phiRef(2*k-1)
        ENDDO
        CALL WRITE_GLVEC_RS( 'PHrefF',' ',tmpVar,1+Nr,-1, myThid )
        DO k=1,Nr
          tmpVar(k) = phiRef(2*k)
        ENDDO
        CALL WRITE_GLVEC_RS( 'PHrefC',' ',tmpVar, Nr, -1, myThid )
c      ENDIF

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#ifdef ALLOW_MNC
      IF ( useMNC .AND. writegrid_mnc ) THEN

        _BEGIN_MASTER( myThid )
        bfname='grid'

C       Write the GRID.h variables to a file
        CALL MNC_CW_SET_UDIM(bfname, 0, myThid)
        CALL MNC_CW_SET_CITER(bfname, 2, -1, -1, -1, myThid)
        CALL MNC_CW_SET_UDIM(bfname, 1, myThid)
        CALL MNC_CW_RS_W('D',bfname,0,0,'rC',rC,myThid)
        CALL MNC_CW_RS_W('D',bfname,0,0,'rF',rF,myThid)
        CALL MNC_CW_RS_W('D',bfname,0,0,'rU',rF(2),myThid)
        CALL MNC_CW_RS_W('D',bfname,0,0,'rL',rF,myThid)
        CALL MNC_CW_RS_W('D',bfname,0,0,'drC',drC,myThid)
        CALL MNC_CW_RS_W('D',bfname,0,0,'drF',drF,myThid)
        CALL MNC_CW_RS_W('D',bfname,0,0,'xC',xC,myThid)
        CALL MNC_CW_RS_W('D',bfname,0,0,'yC',yC,myThid)
c       CALL MNC_CW_RS_W('D',bfname,0,0,'xU',xG,myThid)
c       CALL MNC_CW_RS_W('D',bfname,0,0,'yU',yC,myThid)
c       CALL MNC_CW_RS_W('D',bfname,0,0,'xV',xC,myThid)
c       CALL MNC_CW_RS_W('D',bfname,0,0,'yV',yG,myThid)
        CALL MNC_CW_RS_W('D',bfname,0,0,'xG',xG,myThid)
        CALL MNC_CW_RS_W('D',bfname,0,0,'yG',yG,myThid)
        CALL MNC_CW_RS_W('D',bfname,0,0,'dxC',dxC,myThid)
        CALL MNC_CW_RS_W('D',bfname,0,0,'dyC',dyC,myThid)
        CALL MNC_CW_RS_W('D',bfname,0,0,'dxF',dxF,myThid)
        CALL MNC_CW_RS_W('D',bfname,0,0,'dyF',dyF,myThid)
        CALL MNC_CW_RS_W('D',bfname,0,0,'dxG',dxG,myThid)
        CALL MNC_CW_RS_W('D',bfname,0,0,'dyG',dyG,myThid)
        CALL MNC_CW_RS_W('D',bfname,0,0,'dxV',dxV,myThid)
        CALL MNC_CW_RS_W('D',bfname,0,0,'dyU',dyU,myThid)
        CALL MNC_CW_RS_W('D',bfname,0,0,'rAc',rA,myThid)
        CALL MNC_CW_RS_W('D',bfname,0,0,'rAw',rAw,myThid)
        CALL MNC_CW_RS_W('D',bfname,0,0,'rAs',rAs,myThid)
        CALL MNC_CW_RS_W('D',bfname,0,0,'rAz',rAz,myThid)
        IF ( usingCurvilinearGrid .OR. rotateGrid ) THEN
          CALL MNC_CW_RS_W('D',bfname,0,0,'angleCS',angleCosC,myThid)
          CALL MNC_CW_RS_W('D',bfname,0,0,'angleSN',angleSinC,myThid)
        ENDIF
        CALL MNC_CW_RS_W('D',bfname,0,0,'fCori',fCori,myThid)
        CALL MNC_CW_RS_W('D',bfname,0,0,'fCoriG',fCoriG,myThid)
        CALL MNC_CW_RS_W('D',bfname,0,0,'rLowC',R_low,myThid)
        CALL MNC_CW_RS_W('D',bfname,0,0,'rSurfC',Ro_surf,myThid)
        CALL MNC_CW_RS_W('D',bfname,0,0,'Depth',tmpfld,myThid)
        CALL MNC_CW_RS_W('D',bfname,0,0,'hFacC',hFacC,myThid)
        CALL MNC_CW_RS_W('D',bfname,0,0,'hFacW',hFacW,myThid)
        CALL MNC_CW_RS_W('D',bfname,0,0,'hFacS',hFacS,myThid)

        _END_MASTER(myThid)

      ENDIF

      IF ( useMNC .AND. (usingCurvilinearGrid .OR. rotateGrid) ) THEN
C     If the grid is not simply cartesian, cylindrical or spherical,
C     include additional coordinate information to the following files
       IF ( snapshot_mnc .AND.
     &      ( dumpFreq .GT. 0. .OR. dumpInitAndLast ) )
     &      CALL MNC_CW_WRITE_GRID_COORD('state', myThid)
#if (defined ALLOW_AUTODIFF) && \
    (defined (ALLOW_ADJOINT_RUN) || defined (ALLOW_ADMTLM)) && \
    (defined ALLOW_AUTODIFF_MONITOR)
       IF ( autodiff_mnc .AND. adjDumpFreq .GT. 0. ) THEN
        CALL MNC_CW_WRITE_GRID_COORD('adstate', myThid)
#ifdef ALLOW_EXF
        IF (useEXF) CALL MNC_CW_WRITE_GRID_COORD('adexf',myThid)
#endif /* ALLOW_EXF */
#ifdef ALLOW_SEAICE
        IF (useSEAICE) CALL MNC_CW_WRITE_GRID_COORD('adseaice',myThid)
#endif /* ALLOW_SEAICE */
       ENDIF
#endif /* ALLOW_AUTODIFF */
      ENDIF

#endif /* ALLOW_MNC */

      RETURN
      END

#include "AUTODIFF_OPTIONS.h"
#ifdef ALLOW_CTRL
# include "CTRL_OPTIONS.h"
#endif

C     ==================================================================
C     active_file_control_slice.F: Routines to handle the I/O of active
C                                  variables for the adjoint calculations.
C                                  All files are diRect access files.
C     Routines:
C     o  ACTIVE_READ_XZ_RL  : Basic routine to handle active XZ read operations
C     o  ACTIVE_READ_XZ_RS  : Basic routine to handle active XZ read operations
C     o  ACTIVE_READ_YZ_RL  : Basic routine to handle active YZ read operations
C     o  ACTIVE_READ_YZ_RS  : Basic routine to handle active YZ read operations

C     o  ACTIVE_WRITE_XZ_RL : Basic routine to handle active XZ write operations
C     o  ACTIVE_WRITE_XZ_RS : Basic routine to handle active XZ write operations
C     o  ACTIVE_WRITE_YZ_RL : Basic routine to handle active YZ write operations
C     o  ACTIVE_WRITE_YZ_RS : Basic routine to handle active YZ write operations

C     ==================================================================

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: ACTIVE_READ_XZ_RL
C     !INTERFACE:
      SUBROUTINE ACTIVE_READ_XZ_RL(
     I                          activeVar_file,
     O                          active_var,
     I                          globalFile,
     I                          useCurrentDir,
     I                          lAdInit,
     I                          iRec,
     I                          myNr,
     I                          theSimulationMode,
     I                          myOptimIter,
     I                          myThid )
C     !DESCRIPTION: \bv
C     ==================================================================
C     SUBROUTINE ACTIVE_READ_XZ_RL
C     ==================================================================
C     o Read an active XZ _RL variable from file.
C     The variable *globalfile* can be used as a switch, which allows
C     to read from a global file. The adjoint files are, however, always
C     treated as tiled files.
C     started: heimbach@mit.edu 05-Mar-2001
C     ==================================================================
C     SUBROUTINE ACTIVE_READ_XZ_RL
C     ==================================================================
C     \ev

C     !USES:
      IMPLICIT NONE

C     == global variables ==
#include "EEPARAMS.h"
#include "SIZE.h"
#include "PARAMS.h"
#include "CTRL_SIZE.h"
#include "CTRL.h"

C     !INPUT/OUTPUT PARAMETERS:
C     activeVar_file :: filename
C     active_var     :: array
C     globalFile     ::
C     useCurrentDir  :: always read from the current directory
C                        (even if "mdsioLocalDir" is set)
C     lAdInit        :: initialisation of corresponding adjoint variable
C                        and write to active file
C     iRec           :: record number
C     myNr           :: vertical array dimension
C     theSimulationMode :: forward mode or reverse mode simulation
C     myOptimIter    :: number of optimization iteration (default: 0)
C     myThid         :: thread number for this instance
      CHARACTER*(*) activeVar_file
      INTEGER  myNr
      _RL      active_var(1-OLx:sNx+OLx,myNr,nSx,nSy)
      LOGICAL  globalFile
      LOGICAL  useCurrentDir
      LOGICAL  lAdInit
      INTEGER  iRec
      INTEGER  theSimulationMode
      INTEGER  myOptimIter
      INTEGER  myThid

C     !LOCAL VARIABLES:
      CHARACTER*(2)  adpref
      CHARACTER*(MAX_LEN_FNAM) adfname
      INTEGER bi,bj
      INTEGER i,k
      INTEGER prec
      LOGICAL w_globFile
      _RS  dummyRS(1)
      _RL  active_data_t(1-OLx:sNx+OLx,myNr,nSx,nSy)
CEOP

C     force 64-bit io
      prec = ctrlprec

C     >>>>>>>>>>>>>>>>>>> FORWARD RUN <<<<<<<<<<<<<<<<<<<
      IF (theSimulationMode .EQ. FORWARD_SIMULATION) THEN

C     Read the active variable from file.
        CALL MDS_READ_SEC_XZ(
     I                activeVar_file, prec, useCurrentDir,
     I                'RL', myNr, 1, myNr,
     O                active_var, dummyRS,
     I                iRec, myThid )

        IF ( lAdInit ) THEN
C     Initialise the corresponding adjoint variable on the
C     adjoint variable file. These files are tiled.

          DO bj = myByLo(myThid), myByHi(myThid)
           DO bi = myBxLo(myThid), myBxHi(myThid)
            DO k = 1, myNr
              DO i=1,sNx
                active_data_t(i,k,bi,bj) = 0. _d 0
              ENDDO
            ENDDO
           ENDDO
          ENDDO

          adpref = 'ad'
          CALL ADD_PREFIX( adpref, activeVar_file, adfname )
          CALL MDS_WRITE_SEC_XZ(
     I                adfname, prec, globalFile, useCurrentDir,
     I                'RL', myNr, 1, myNr,
     I                active_data_t, dummyRS,
     I                iRec, myOptimIter, myThid )

        ENDIF

      ENDIF

C     >>>>>>>>>>>>>>>>>>> ADJOINT RUN <<<<<<<<<<<<<<<<<<<
      IF (theSimulationMode .EQ. REVERSE_SIMULATION) THEN

        CALL MDS_READ_SEC_XZ(
     I                activeVar_file, prec, useCurrentDir,
     I                'RL', myNr, 1, myNr,
     O                active_data_t, dummyRS,
     I                iRec, myThid )

C     Add active_var from appropriate location to data.
        DO bj = myByLo(myThid), myByHi(myThid)
         DO bi = myBxLo(myThid), myBxHi(myThid)
          DO k = 1, myNr
            DO i=1,sNx
              active_data_t(i,k,bi,bj) = active_data_t(i,k,bi,bj)
     &                                 + active_var(i,k,bi,bj)
            ENDDO
          ENDDO
         ENDDO
        ENDDO

C     Store the result on disk.
        w_globFile = .FALSE.
        CALL MDS_WRITE_SEC_XZ(
     I                activeVar_file, prec, w_globFile, useCurrentDir,
     I                'RL', myNr, 1, myNr,
     I                active_data_t, dummyRS,
     I                iRec, myOptimIter, myThid )

C     Set active_var to zero.
        DO bj = myByLo(myThid), myByHi(myThid)
         DO bi = myBxLo(myThid), myBxHi(myThid)
          DO k = 1, myNr
            DO i=1,sNx
              active_var(i,k,bi,bj) = 0 _d 0
            ENDDO
          ENDDO
         ENDDO
        ENDDO

      ENDIF

C     >>>>>>>>>>>>>>>>>>> TANGENT RUN <<<<<<<<<<<<<<<<<<<
      IF (theSimulationMode .EQ. TANGENT_SIMULATION) THEN
C     Read the active variable from file.
        CALL MDS_READ_SEC_XZ(
     I                activeVar_file, prec, useCurrentDir,
     I                'RL', myNr, 1, myNr,
     O                active_var, dummyRS,
     I                iRec, myThid )
      ENDIF

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: ACTIVE_READ_XZ_RS
C     !INTERFACE:
      SUBROUTINE ACTIVE_READ_XZ_RS(
     I                          activeVar_file,
     O                          active_var,
     I                          globalFile,
     I                          useCurrentDir,
     I                          lAdInit,
     I                          iRec,
     I                          myNr,
     I                          theSimulationMode,
     I                          myOptimIter,
     I                          myThid )

C     !DESCRIPTION: \bv
C     ==================================================================
C     SUBROUTINE ACTIVE_READ_XZ_RS
C     ==================================================================
C     o Read an active XZ _RS variable from file.
C     The variable *globalfile* can be used as a switch, which allows
C     to read from a global file. The adjoint files are, however, always
C     treated as tiled files.
C     started: heimbach@mit.edu 05-Mar-2001
C     ==================================================================
C     SUBROUTINE ACTIVE_READ_XZ_RS
C     ==================================================================
C     \ev

C     !USES:
      IMPLICIT NONE

C     == global variables ==
#include "EEPARAMS.h"
#include "SIZE.h"
#include "PARAMS.h"
#include "CTRL_SIZE.h"
#include "CTRL.h"

C     !INPUT/OUTPUT PARAMETERS:
C     activeVar_file :: filename
C     active_var     :: array
C     globalFile     ::
C     useCurrentDir  :: always read from the current directory
C                        (even if "mdsioLocalDir" is set)
C     lAdInit        :: initialisation of corresponding adjoint variable
C                        and write to active file
C     iRec           :: record number
C     myNr           :: vertical array dimension
C     theSimulationMode :: forward mode or reverse mode simulation
C     myOptimIter    :: number of optimization iteration (default: 0)
C     myThid         :: thread number for this instance
      CHARACTER*(*) activeVar_file
      INTEGER  myNr
      _RS      active_var(1-OLx:sNx+OLx,myNr,nSx,nSy)
      LOGICAL  globalFile
      LOGICAL  useCurrentDir
      LOGICAL  lAdInit
      INTEGER  iRec
      INTEGER  theSimulationMode
      INTEGER  myOptimIter
      INTEGER  myThid

C     !LOCAL VARIABLES:
      CHARACTER*(2)  adpref
      CHARACTER*(MAX_LEN_FNAM) adfname
      INTEGER bi,bj
      INTEGER i,k
      INTEGER prec
      LOGICAL w_globFile
      _RS  active_data_t(1-OLx:sNx+OLx,myNr,nSx,nSy)
      _RL  dummyRL(1)
CEOP

C     force 64-bit io
      prec = ctrlprec

C     >>>>>>>>>>>>>>>>>>> FORWARD RUN <<<<<<<<<<<<<<<<<<<
      IF (theSimulationMode .EQ. FORWARD_SIMULATION) THEN

C     Read the active variable from file.
        CALL MDS_READ_SEC_XZ(
     I                activeVar_file, prec, useCurrentDir,
     I                'RS', myNr, 1, myNr,
     O                dummyRL, active_var,
     I                iRec, myThid )

        IF ( lAdInit ) THEN
C     Initialise the corresponding adjoint variable on the
C     adjoint variable file. These files are tiled.

          DO bj = myByLo(myThid), myByHi(myThid)
           DO bi = myBxLo(myThid), myBxHi(myThid)
            DO k = 1, myNr
              DO i=1,sNx
                active_data_t(i,k,bi,bj) = 0. _d 0
              ENDDO
            ENDDO
           ENDDO
          ENDDO

          adpref = 'ad'
          CALL ADD_PREFIX( adpref, activeVar_file, adfname )
          CALL MDS_WRITE_SEC_XZ(
     I                adfname, prec, globalFile, useCurrentDir,
     I                'RS', myNr, 1, myNr,
     I                dummyRL, active_data_t,
     I                iRec, myOptimIter, myThid )

        ENDIF

      ENDIF

C     >>>>>>>>>>>>>>>>>>> ADJOINT RUN <<<<<<<<<<<<<<<<<<<
      IF (theSimulationMode .EQ. REVERSE_SIMULATION) THEN

        CALL MDS_READ_SEC_XZ(
     I                activeVar_file, prec, useCurrentDir,
     I                'RS', myNr, 1, myNr,
     O                dummyRL, active_data_t,
     I                iRec, myThid )

C     Add active_var from appropriate location to data.
        DO bj = myByLo(myThid), myByHi(myThid)
         DO bi = myBxLo(myThid), myBxHi(myThid)
          DO k = 1, myNr
            DO i=1,sNx
              active_data_t(i,k,bi,bj) = active_data_t(i,k,bi,bj)
     &                                 + active_var(i,k,bi,bj)
            ENDDO
          ENDDO
         ENDDO
        ENDDO

C     Store the result on disk.
        w_globFile = .FALSE.
        CALL MDS_WRITE_SEC_XZ(
     I                activeVar_file, prec, w_globFile, useCurrentDir,
     I                'RS', myNr, 1, myNr,
     I                dummyRL, active_data_t,
     I                iRec, myOptimIter, myThid )

C     Set active_var to zero.
        DO bj = myByLo(myThid), myByHi(myThid)
         DO bi = myBxLo(myThid), myBxHi(myThid)
          DO k = 1, myNr
            DO i=1,sNx
              active_var(i,k,bi,bj) = 0 _d 0
            ENDDO
          ENDDO
         ENDDO
        ENDDO

      ENDIF

C     >>>>>>>>>>>>>>>>>>> TANGENT RUN <<<<<<<<<<<<<<<<<<<
      IF (theSimulationMode .EQ. TANGENT_SIMULATION) THEN
C     Read the active variable from file.
        CALL MDS_READ_SEC_XZ(
     I                activeVar_file, prec, useCurrentDir,
     I                'RS', myNr, 1, myNr,
     O                dummyRL, active_var,
     I                iRec, myThid )
      ENDIF

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: ACTIVE_READ_YZ_RL
C     !INTERFACE:
      SUBROUTINE ACTIVE_READ_YZ_RL(
     I                          activeVar_file,
     O                          active_var,
     I                          globalFile,
     I                          useCurrentDir,
     I                          lAdInit,
     I                          iRec,
     I                          myNr,
     I                          theSimulationMode,
     I                          myOptimIter,
     I                          myThid )
C     !DESCRIPTION: \bv
C     ==================================================================
C     SUBROUTINE ACTIVE_READ_YZ_RL
C     ==================================================================
C     o Read an active YZ _RL variable from file.
C     The variable *globalfile* can be used as a switch, which allows
C     to read from a global file. The adjoint files are, however, always
C     treated as tiled files.
C     started: heimbach@mit.edu 05-Mar-2001
C     ==================================================================
C     SUBROUTINE ACTIVE_READ_YZ_RL
C     ==================================================================
C     \ev

C     !USES:
      IMPLICIT NONE

C     == global variables ==
#include "EEPARAMS.h"
#include "SIZE.h"
#include "PARAMS.h"
#include "CTRL_SIZE.h"
#include "CTRL.h"

C     !INPUT/OUTPUT PARAMETERS:
C     activeVar_file :: filename
C     active_var     :: array
C     globalFile     ::
C     useCurrentDir  :: always read from the current directory
C                        (even if "mdsioLocalDir" is set)
C     lAdInit        :: initialisation of corresponding adjoint variable
C                        and write to active file
C     iRec           :: record number
C     myNr           :: vertical array dimension
C     theSimulationMode :: forward mode or reverse mode simulation
C     myOptimIter    :: number of optimization iteration (default: 0)
C     myThid         :: thread number for this instance
      CHARACTER*(*) activeVar_file
      INTEGER  myNr
      _RL      active_var(1-OLy:sNy+OLy,myNr,nSx,nSy)
      LOGICAL  globalFile
      LOGICAL  useCurrentDir
      LOGICAL  lAdInit
      INTEGER  iRec
      INTEGER  theSimulationMode
      INTEGER  myOptimIter
      INTEGER  myThid

C     !LOCAL VARIABLES:
      CHARACTER*(2)  adpref
      CHARACTER*(MAX_LEN_FNAM) adfname
      INTEGER bi,bj
      INTEGER j,k
      INTEGER prec
      LOGICAL w_globFile
      _RS  dummyRS(1)
      _RL  active_data_t(1-OLy:sNy+OLy,myNr,nSx,nSy)
CEOP

C     force 64-bit io
      prec = ctrlprec

C     >>>>>>>>>>>>>>>>>>> FORWARD RUN <<<<<<<<<<<<<<<<<<<
      IF (theSimulationMode .EQ. FORWARD_SIMULATION) THEN

C     Read the active variable from file.
        CALL MDS_READ_SEC_YZ(
     I                activeVar_file, prec, useCurrentDir,
     I                'RL', myNr, 1, myNr,
     O                active_var, dummyRS,
     I                iRec, myThid )

        IF ( lAdInit ) THEN
C     Initialise the corresponding adjoint variable on the
C     adjoint variable file. These files are tiled.

          DO bj = myByLo(myThid), myByHi(myThid)
           DO bi = myBxLo(myThid), myBxHi(myThid)
            DO k = 1, myNr
             DO j=1,sNy
                active_data_t(j,k,bi,bj) = 0. _d 0
             ENDDO
            ENDDO
           ENDDO
          ENDDO

          adpref = 'ad'
          CALL ADD_PREFIX( adpref, activeVar_file, adfname )
          CALL MDS_WRITE_SEC_YZ(
     I                adfname, prec, globalFile, useCurrentDir,
     I                'RL', myNr, 1, myNr,
     I                active_data_t, dummyRS,
     I                iRec, myOptimIter, myThid )

        ENDIF

      ENDIF

C     >>>>>>>>>>>>>>>>>>> ADJOINT RUN <<<<<<<<<<<<<<<<<<<
      IF (theSimulationMode .EQ. REVERSE_SIMULATION) THEN

        CALL MDS_READ_SEC_YZ(
     I                activeVar_file, prec, useCurrentDir,
     I                'RL', myNr, 1, myNr,
     O                active_data_t, dummyRS,
     I                iRec, myThid )

C     Add active_var from appropriate location to data.
        DO bj = myByLo(myThid), myByHi(myThid)
         DO bi = myBxLo(myThid), myBxHi(myThid)
          DO k = 1, myNr
           DO j=1,sNy
              active_data_t(j,k,bi,bj) = active_data_t(j,k,bi,bj)
     &                                 + active_var(j,k,bi,bj)
           ENDDO
          ENDDO
         ENDDO
        ENDDO

C     Store the result on disk.
        w_globFile = .FALSE.
        CALL MDS_WRITE_SEC_YZ(
     I                activeVar_file, prec, w_globFile, useCurrentDir,
     I                'RL', myNr, 1, myNr,
     I                active_data_t, dummyRS,
     I                iRec, myOptimIter, myThid )

C     Set active_var to zero.
        DO bj = myByLo(myThid), myByHi(myThid)
         DO bi = myBxLo(myThid), myBxHi(myThid)
          DO k = 1, myNr
           DO j=1,sNy
              active_var(j,k,bi,bj) = 0 _d 0
           ENDDO
          ENDDO
         ENDDO
        ENDDO

      ENDIF

C     >>>>>>>>>>>>>>>>>>> TANGENT RUN <<<<<<<<<<<<<<<<<<<
      IF (theSimulationMode .EQ. TANGENT_SIMULATION) THEN
C     Read the active variable from file.
        CALL MDS_READ_SEC_YZ(
     I                activeVar_file, prec, useCurrentDir,
     I                'RL', myNr, 1, myNr,
     O                active_var, dummyRS,
     I                iRec, myThid )
      ENDIF

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: ACTIVE_READ_YZ_RS
C     !INTERFACE:
      SUBROUTINE ACTIVE_READ_YZ_RS(
     I                          activeVar_file,
     O                          active_var,
     I                          globalFile,
     I                          useCurrentDir,
     I                          lAdInit,
     I                          iRec,
     I                          myNr,
     I                          theSimulationMode,
     I                          myOptimIter,
     I                          myThid )

C     !DESCRIPTION: \bv
C     ==================================================================
C     SUBROUTINE ACTIVE_READ_YZ_RS
C     ==================================================================
C     o Read an active YZ _RS variable from file.
C     The variable *globalfile* can be used as a switch, which allows
C     to read from a global file. The adjoint files are, however, always
C     treated as tiled files.
C     started: heimbach@mit.edu 05-Mar-2001
C     ==================================================================
C     SUBROUTINE ACTIVE_READ_YZ_RS
C     ==================================================================
C     \ev

C     !USES:
      IMPLICIT NONE

C     == global variables ==
#include "EEPARAMS.h"
#include "SIZE.h"
#include "PARAMS.h"
#include "CTRL_SIZE.h"
#include "CTRL.h"

C     !INPUT/OUTPUT PARAMETERS:
C     activeVar_file :: filename
C     active_var     :: array
C     globalFile     ::
C     useCurrentDir  :: always read from the current directory
C                        (even if "mdsioLocalDir" is set)
C     lAdInit        :: initialisation of corresponding adjoint variable
C                        and write to active file
C     iRec           :: record number
C     myNr           :: vertical array dimension
C     theSimulationMode :: forward mode or reverse mode simulation
C     myOptimIter    :: number of optimization iteration (default: 0)
C     myThid         :: thread number for this instance
      CHARACTER*(*) activeVar_file
      INTEGER  myNr
      _RS      active_var(1-OLy:sNy+OLy,myNr,nSx,nSy)
      LOGICAL  globalFile
      LOGICAL  useCurrentDir
      LOGICAL  lAdInit
      INTEGER  iRec
      INTEGER  theSimulationMode
      INTEGER  myOptimIter
      INTEGER  myThid

C     !LOCAL VARIABLES:
      CHARACTER*(2)  adpref
      CHARACTER*(MAX_LEN_FNAM) adfname
      INTEGER bi,bj
      INTEGER j,k
      INTEGER prec
      LOGICAL w_globFile
      _RS  active_data_t(1-OLy:sNy+OLy,myNr,nSx,nSy)
      _RL  dummyRL(1)
CEOP

C     force 64-bit io
      prec = ctrlprec

C     >>>>>>>>>>>>>>>>>>> FORWARD RUN <<<<<<<<<<<<<<<<<<<
      IF (theSimulationMode .EQ. FORWARD_SIMULATION) THEN

C     Read the active variable from file.
        CALL MDS_READ_SEC_YZ(
     I                activeVar_file, prec, useCurrentDir,
     I                'RS', myNr, 1, myNr,
     O                dummyRL, active_var,
     I                iRec, myThid )

        IF ( lAdInit ) THEN
C     Initialise the corresponding adjoint variable on the
C     adjoint variable file. These files are tiled.

          DO bj = myByLo(myThid), myByHi(myThid)
           DO bi = myBxLo(myThid), myBxHi(myThid)
            DO k = 1, myNr
             DO j=1,sNy
                active_data_t(j,k,bi,bj) = 0. _d 0
             ENDDO
            ENDDO
           ENDDO
          ENDDO

          adpref = 'ad'
          CALL ADD_PREFIX( adpref, activeVar_file, adfname )
          CALL MDS_WRITE_SEC_YZ(
     I                adfname, prec, globalFile, useCurrentDir,
     I                'RS', myNr, 1, myNr,
     I                dummyRL, active_data_t,
     I                iRec, myOptimIter, myThid )

        ENDIF

      ENDIF

C     >>>>>>>>>>>>>>>>>>> ADJOINT RUN <<<<<<<<<<<<<<<<<<<
      IF (theSimulationMode .EQ. REVERSE_SIMULATION) THEN

        CALL MDS_READ_SEC_YZ(
     I                activeVar_file, prec, useCurrentDir,
     I                'RS', myNr, 1, myNr,
     O                dummyRL, active_data_t,
     I                iRec, myThid )

C     Add active_var from appropriate location to data.
        DO bj = myByLo(myThid), myByHi(myThid)
         DO bi = myBxLo(myThid), myBxHi(myThid)
          DO k = 1, myNr
           DO j=1,sNy
              active_data_t(j,k,bi,bj) = active_data_t(j,k,bi,bj)
     &                                 + active_var(j,k,bi,bj)
           ENDDO
          ENDDO
         ENDDO
        ENDDO

C     Store the result on disk.
        w_globFile = .FALSE.
        CALL MDS_WRITE_SEC_YZ(
     I                activeVar_file, prec, w_globFile, useCurrentDir,
     I                'RS', myNr, 1, myNr,
     I                dummyRL, active_data_t,
     I                iRec, myOptimIter, myThid )

C     Set active_var to zero.
        DO bj = myByLo(myThid), myByHi(myThid)
         DO bi = myBxLo(myThid), myBxHi(myThid)
          DO k = 1, myNr
           DO j=1,sNy
              active_var(j,k,bi,bj) = 0 _d 0
           ENDDO
          ENDDO
         ENDDO
        ENDDO

      ENDIF

C     >>>>>>>>>>>>>>>>>>> TANGENT RUN <<<<<<<<<<<<<<<<<<<
      IF (theSimulationMode .EQ. TANGENT_SIMULATION) THEN
C     Read the active variable from file.
        CALL MDS_READ_SEC_YZ(
     I                activeVar_file, prec, useCurrentDir,
     I                'RS', myNr, 1, myNr,
     O                dummyRL, active_var,
     I                iRec, myThid )
      ENDIF

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: ACTIVE_WRITE_XZ_RL
C     !INTERFACE:
      SUBROUTINE ACTIVE_WRITE_XZ_RL(
     I                          activeVar_file,
     I                          active_var,
     I                          globalFile,
     I                          useCurrentDir,
     I                          iRec,
     I                          myNr,
     I                          theSimulationMode,
     I                          myOptimIter,
     I                          myThid )

C     !DESCRIPTION: \bv
C     ==================================================================
C     SUBROUTINE ACTIVE_WRITE_XZ_RL
C     ==================================================================
C     o Write an active XZ _RL variable to a file.
C     started: heimbach@mit.edu 05-Mar-2001
C     ==================================================================
C     SUBROUTINE ACTIVE_WRITE_XZ_RL
C     ==================================================================
C     \ev

C     !USES:
      IMPLICIT NONE

C     == global variables ==
#include "EEPARAMS.h"
#include "SIZE.h"
#include "PARAMS.h"
#include "CTRL_SIZE.h"
#include "CTRL.h"

C     !INPUT/OUTPUT PARAMETERS:
C     activeVar_file :: filename
C     active_var     :: array
C     globalFile     ::
C     useCurrentDir  :: always write to the current directory
C                        (even if "mdsioLocalDir" is set)
C     iRec           :: record number
C     myNr           :: vertical array dimension
C     theSimulationMode :: forward mode or reverse mode simulation
C     myOptimIter    :: number of optimization iteration (default: 0)
C     myThid         :: thread number for this instance
      CHARACTER*(*) activeVar_file
      INTEGER  myNr
      _RL      active_var(1-OLx:sNx+OLx,myNr,nSx,nSy)
      LOGICAL  globalFile
      LOGICAL  useCurrentDir
      INTEGER  iRec
      INTEGER  theSimulationMode
      INTEGER  myOptimIter
      INTEGER  myThid

C     !LOCAL VARIABLES:
      INTEGER  i,k
      INTEGER  bi,bj
      INTEGER  prec
      _RS  dummyRS(1)
      _RL  active_data_t(1-OLx:sNx+OLx,myNr,nSx,nSy)
CEOP

C     force 64-bit io
      prec = ctrlprec

C     >>>>>>>>>>>>>>>>>>> FORWARD RUN <<<<<<<<<<<<<<<<<<<
      IF (theSimulationMode .EQ. FORWARD_SIMULATION) THEN
        CALL MDS_WRITE_SEC_XZ(
     I                activeVar_file, prec, globalFile, useCurrentDir,
     I                'RL', myNr, 1, myNr,
     I                active_var, dummyRS,
     I                iRec, myOptimIter, myThid )
      ENDIF

C     >>>>>>>>>>>>>>>>>>> ADJOINT RUN <<<<<<<<<<<<<<<<<<<
      IF (theSimulationMode .EQ. REVERSE_SIMULATION) THEN

        CALL MDS_READ_SEC_XZ(
     I                activeVar_file, prec, useCurrentDir,
     I                'RL', myNr, 1, myNr,
     O                active_data_t, dummyRS,
     I                iRec, myThid )

C     Add active_var from appropriate location to data.
        DO bj = myByLo(myThid), myByHi(myThid)
         DO bi = myBxLo(myThid), myBxHi(myThid)
          DO k = 1, myNr
            DO i=1,sNx
              active_var(i,k,bi,bj) = active_var(i,k,bi,bj)
     &                              + active_data_t(i,k,bi,bj)
              active_data_t(i,k,bi,bj) = 0. _d 0
            ENDDO
          ENDDO
         ENDDO
        ENDDO
        CALL MDS_WRITE_SEC_XZ(
     I                activeVar_file, prec, globalFile, useCurrentDir,
     I                'RL', myNr, 1, myNr,
     I                active_data_t, dummyRS,
     I                iRec, myOptimIter, myThid )

      ENDIF

C     >>>>>>>>>>>>>>>>>>> TANGENT RUN <<<<<<<<<<<<<<<<<<<
      IF (theSimulationMode .EQ. TANGENT_SIMULATION) THEN
        CALL MDS_WRITE_SEC_XZ(
     I                activeVar_file, prec, globalFile, useCurrentDir,
     I                'RL', myNr, 1, myNr,
     I                active_var, dummyRS,
     I                iRec, myOptimIter, myThid )
      ENDIF

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: ACTIVE_WRITE_XZ_RS
C     !INTERFACE:
      SUBROUTINE ACTIVE_WRITE_XZ_RS(
     I                          activeVar_file,
     I                          active_var,
     I                          globalFile,
     I                          useCurrentDir,
     I                          iRec,
     I                          myNr,
     I                          theSimulationMode,
     I                          myOptimIter,
     I                          myThid )

C     !DESCRIPTION: \bv
C     ==================================================================
C     SUBROUTINE ACTIVE_WRITE_XZ_RS
C     ==================================================================
C     o Write an active XZ _RS variable to a file.
C     started: heimbach@mit.edu 05-Mar-2001
C     ==================================================================
C     SUBROUTINE ACTIVE_WRITE_XZ_RS
C     ==================================================================
C     \ev

C     !USES:
      IMPLICIT NONE

C     == global variables ==
#include "EEPARAMS.h"
#include "SIZE.h"
#include "PARAMS.h"
#include "CTRL_SIZE.h"
#include "CTRL.h"

C     !INPUT/OUTPUT PARAMETERS:
C     activeVar_file :: filename
C     active_var     :: array
C     globalFile     ::
C     useCurrentDir  :: always write to the current directory
C                        (even if "mdsioLocalDir" is set)
C     iRec           :: record number
C     myNr           :: vertical array dimension
C     theSimulationMode :: forward mode or reverse mode simulation
C     myOptimIter    :: number of optimization iteration (default: 0)
C     myThid         :: thread number for this instance
      CHARACTER*(*) activeVar_file
      INTEGER  myNr
      _RS      active_var(1-OLx:sNx+OLx,myNr,nSx,nSy)
      LOGICAL  globalFile
      LOGICAL  useCurrentDir
      INTEGER  iRec
      INTEGER  theSimulationMode
      INTEGER  myOptimIter
      INTEGER  myThid

C     !LOCAL VARIABLES:
      INTEGER  i,k
      INTEGER  bi,bj
      INTEGER  prec
      _RS  active_data_t(1-OLx:sNx+OLx,myNr,nSx,nSy)
      _RL  dummyRL(1)
CEOP

C     force 64-bit io
      prec = ctrlprec

C     >>>>>>>>>>>>>>>>>>> FORWARD RUN <<<<<<<<<<<<<<<<<<<
      IF (theSimulationMode .EQ. FORWARD_SIMULATION) THEN
        CALL MDS_WRITE_SEC_XZ(
     I                activeVar_file, prec, globalFile, useCurrentDir,
     I                'RS', myNr, 1, myNr,
     I                dummyRL, active_var,
     I                iRec, myOptimIter, myThid )
      ENDIF

C     >>>>>>>>>>>>>>>>>>> ADJOINT RUN <<<<<<<<<<<<<<<<<<<
      IF (theSimulationMode .EQ. REVERSE_SIMULATION) THEN

        CALL MDS_READ_SEC_XZ(
     I                activeVar_file, prec, useCurrentDir,
     I                'RS', myNr, 1, myNr,
     O                dummyRL, active_data_t,
     I                iRec, myThid )

C     Add active_var from appropriate location to data.
        DO bj = myByLo(myThid), myByHi(myThid)
         DO bi = myBxLo(myThid), myBxHi(myThid)
          DO k = 1, myNr
            DO i=1,sNx
              active_var(i,k,bi,bj) = active_var(i,k,bi,bj)
     &                              + active_data_t(i,k,bi,bj)
              active_data_t(i,k,bi,bj) = 0. _d 0
            ENDDO
          ENDDO
         ENDDO
        ENDDO
        CALL MDS_WRITE_SEC_XZ(
     I                activeVar_file, prec, globalFile, useCurrentDir,
     I                'RS', myNr, 1, myNr,
     I                dummyRL, active_data_t,
     I                iRec, myOptimIter, myThid )

      ENDIF

C     >>>>>>>>>>>>>>>>>>> TANGENT RUN <<<<<<<<<<<<<<<<<<<
      IF (theSimulationMode .EQ. TANGENT_SIMULATION) THEN
        CALL MDS_WRITE_SEC_XZ(
     I                activeVar_file, prec, globalFile, useCurrentDir,
     I                'RS', myNr, 1, myNr,
     I                dummyRL, active_var,
     I                iRec, myOptimIter, myThid )
      ENDIF

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: ACTIVE_WRITE_YZ_RL
C     !INTERFACE:
      SUBROUTINE ACTIVE_WRITE_YZ_RL(
     I                          activeVar_file,
     I                          active_var,
     I                          globalFile,
     I                          useCurrentDir,
     I                          iRec,
     I                          myNr,
     I                          theSimulationMode,
     I                          myOptimIter,
     I                          myThid )

C     !DESCRIPTION: \bv
C     ==================================================================
C     SUBROUTINE ACTIVE_WRITE_YZ_RL
C     ==================================================================
C     o Write an active YZ _RL variable to a file.
C     started: heimbach@mit.edu 05-Mar-2001
C     ==================================================================
C     SUBROUTINE ACTIVE_WRITE_YZ_RL
C     ==================================================================
C     \ev

C     !USES:
      IMPLICIT NONE

C     == global variables ==
#include "EEPARAMS.h"
#include "SIZE.h"
#include "PARAMS.h"
#include "CTRL_SIZE.h"
#include "CTRL.h"

C     !INPUT/OUTPUT PARAMETERS:
C     activeVar_file :: filename
C     active_var     :: array
C     globalFile     ::
C     useCurrentDir  :: always write to the current directory
C                        (even if "mdsioLocalDir" is set)
C     iRec           :: record number
C     myNr           :: vertical array dimension
C     theSimulationMode :: forward mode or reverse mode simulation
C     myOptimIter    :: number of optimization iteration (default: 0)
C     myThid         :: thread number for this instance
      CHARACTER*(*) activeVar_file
      INTEGER  myNr
      _RL      active_var(1-OLy:sNy+OLy,myNr,nSx,nSy)
      LOGICAL  globalFile
      LOGICAL  useCurrentDir
      INTEGER  iRec
      INTEGER  theSimulationMode
      INTEGER  myOptimIter
      INTEGER  myThid

C     !LOCAL VARIABLES:
      INTEGER  j,k
      INTEGER  bi,bj
      INTEGER  prec
      _RS  dummyRS(1)
      _RL  active_data_t(1-OLy:sNy+OLy,myNr,nSx,nSy)
CEOP

C     force 64-bit io
      prec = ctrlprec

C     >>>>>>>>>>>>>>>>>>> FORWARD RUN <<<<<<<<<<<<<<<<<<<
      IF (theSimulationMode .EQ. FORWARD_SIMULATION) THEN
        CALL MDS_WRITE_SEC_YZ(
     I                activeVar_file, prec, globalFile, useCurrentDir,
     I                'RL', myNr, 1, myNr,
     I                active_var, dummyRS,
     I                iRec, myOptimIter, myThid )
      ENDIF

C     >>>>>>>>>>>>>>>>>>> ADJOINT RUN <<<<<<<<<<<<<<<<<<<
      IF (theSimulationMode .EQ. REVERSE_SIMULATION) THEN

        CALL MDS_READ_SEC_YZ(
     I                activeVar_file, prec, useCurrentDir,
     I                'RL', myNr, 1, myNr,
     O                active_data_t, dummyRS,
     I                iRec, myThid )

C     Add active_var from appropriate location to data.
        DO bj = myByLo(myThid), myByHi(myThid)
         DO bi = myBxLo(myThid), myBxHi(myThid)
          DO k = 1, myNr
           DO j=1,sNy
              active_var(j,k,bi,bj) = active_var(j,k,bi,bj)
     &                              + active_data_t(j,k,bi,bj)
              active_data_t(j,k,bi,bj) = 0. _d 0
           ENDDO
          ENDDO
         ENDDO
        ENDDO
        CALL MDS_WRITE_SEC_YZ(
     I                activeVar_file, prec, globalFile, useCurrentDir,
     I                'RL', myNr, 1, myNr,
     I                active_data_t, dummyRS,
     I                iRec, myOptimIter, myThid )

      ENDIF

C     >>>>>>>>>>>>>>>>>>> TANGENT RUN <<<<<<<<<<<<<<<<<<<
      IF (theSimulationMode .EQ. TANGENT_SIMULATION) THEN
        CALL MDS_WRITE_SEC_YZ(
     I                activeVar_file, prec, globalFile, useCurrentDir,
     I                'RL', myNr, 1, myNr,
     I                active_var, dummyRS,
     I                iRec, myOptimIter, myThid )
      ENDIF

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: ACTIVE_WRITE_YZ_RS
C     !INTERFACE:
      SUBROUTINE ACTIVE_WRITE_YZ_RS(
     I                          activeVar_file,
     I                          active_var,
     I                          globalFile,
     I                          useCurrentDir,
     I                          iRec,
     I                          myNr,
     I                          theSimulationMode,
     I                          myOptimIter,
     I                          myThid )

C     !DESCRIPTION: \bv
C     ==================================================================
C     SUBROUTINE ACTIVE_WRITE_YZ_RS
C     ==================================================================
C     o Write an active YZ _RS variable to a file.
C     started: heimbach@mit.edu 05-Mar-2001
C     ==================================================================
C     SUBROUTINE ACTIVE_WRITE_YZ_RS
C     ==================================================================
C     \ev

C     !USES:
      IMPLICIT NONE

C     == global variables ==
#include "EEPARAMS.h"
#include "SIZE.h"
#include "PARAMS.h"
#include "CTRL_SIZE.h"
#include "CTRL.h"

C     !INPUT/OUTPUT PARAMETERS:
C     activeVar_file :: filename
C     active_var     :: array
C     globalFile     ::
C     useCurrentDir  :: always write to the current directory
C                        (even if "mdsioLocalDir" is set)
C     iRec           :: record number
C     myNr           :: vertical array dimension
C     theSimulationMode :: forward mode or reverse mode simulation
C     myOptimIter    :: number of optimization iteration (default: 0)
C     myThid         :: thread number for this instance
      CHARACTER*(*) activeVar_file
      INTEGER  myNr
      _RS      active_var(1-OLy:sNy+OLy,myNr,nSx,nSy)
      LOGICAL  globalFile
      LOGICAL  useCurrentDir
      INTEGER  iRec
      INTEGER  theSimulationMode
      INTEGER  myOptimIter
      INTEGER  myThid

C     !LOCAL VARIABLES:
      INTEGER  j,k
      INTEGER  bi,bj
      INTEGER  prec
      _RS  active_data_t(1-OLy:sNy+OLy,myNr,nSx,nSy)
      _RL  dummyRL(1)
CEOP

C     force 64-bit io
      prec = ctrlprec

C     >>>>>>>>>>>>>>>>>>> FORWARD RUN <<<<<<<<<<<<<<<<<<<
      IF (theSimulationMode .EQ. FORWARD_SIMULATION) THEN
        CALL MDS_WRITE_SEC_YZ(
     I                activeVar_file, prec, globalFile, useCurrentDir,
     I                'RS', myNr, 1, myNr,
     I                dummyRL, active_var,
     I                iRec, myOptimIter, myThid )
      ENDIF

C     >>>>>>>>>>>>>>>>>>> ADJOINT RUN <<<<<<<<<<<<<<<<<<<
      IF (theSimulationMode .EQ. REVERSE_SIMULATION) THEN

        CALL MDS_READ_SEC_YZ(
     I                activeVar_file, prec, useCurrentDir,
     I                'RS', myNr, 1, myNr,
     O                dummyRL, active_data_t,
     I                iRec, myThid )

C     Add active_var from appropriate location to data.
        DO bj = myByLo(myThid), myByHi(myThid)
         DO bi = myBxLo(myThid), myBxHi(myThid)
          DO k = 1, myNr
           DO j=1,sNy
              active_var(j,k,bi,bj) = active_var(j,k,bi,bj)
     &                              + active_data_t(j,k,bi,bj)
              active_data_t(j,k,bi,bj) = 0. _d 0
           ENDDO
          ENDDO
         ENDDO
        ENDDO
        CALL MDS_WRITE_SEC_YZ(
     I                activeVar_file, prec, globalFile, useCurrentDir,
     I                'RS', myNr, 1, myNr,
     I                dummyRL, active_data_t,
     I                iRec, myOptimIter, myThid )

      ENDIF

C     >>>>>>>>>>>>>>>>>>> TANGENT RUN <<<<<<<<<<<<<<<<<<<
      IF (theSimulationMode .EQ. TANGENT_SIMULATION) THEN
        CALL MDS_WRITE_SEC_YZ(
     I                activeVar_file, prec, globalFile, useCurrentDir,
     I                'RS', myNr, 1, myNr,
     I                dummyRL, active_var,
     I                iRec, myOptimIter, myThid )
      ENDIF

      RETURN
      END

#include "CAL_OPTIONS.h"

      integer function cal_IntMonths(
     I                                mythid
     &                              )

c     ==================================================================
c     FUNCTION cal_IntMonths
c     ==================================================================
c
c     o Return the number of calendar months that are affected by the 
c       current model integration.
c
c              
c     started: Christian Eckert eckert@mit.edu  30-Jun-1999
c
c     changed: Christian Eckert eckert@mit.edu  29-Dec-1999
c
c              - restructured the original version in order to have a
c                better interface to the MITgcmUV.
c
c              Christian Eckert eckert@mit.edu  03-Feb-2000
c
c              - Introduced new routine and function names, cal_<NAME>,
c                for verion 0.1.3.
c
c     ==================================================================
c     FUNCTION cal_IntMonths
c     ==================================================================

      implicit none

c     == global variables ==

#include "cal.h"

c     == routine arguments ==

      integer mythid

c     == local variables ==

      integer endmonth
      integer startmonth
      integer endyear
      integer startyear

c     == end of interface ==

      startmonth = mod(modelstartdate(1)/100,100)
      endmonth   = mod(  modelenddate(1)/100,100)
      startyear  = modelstartdate(1)/10000
      endyear    = modelenddate(1)/10000

ce    --> allow for previous iterations: niter0 !
ce        in this case one would need some more information about the 
ce        integration of the model, e.g. the global start and end dates.

      if ( startyear .ne. endyear ) then
        cal_IntMonths = (nmonthyear - startmonth + 1) +
     &               nmonthyear*(endyear - startyear - 1) +
     &               endmonth
      else
        cal_IntMonths = endmonth - startmonth + 1
      endif

      if ( ( modelenddate(2) .eq. 0) .and.
     &     ( mod(modelenddate(1),100) .eq. 1) ) then
        cal_IntMonths = cal_IntMonths - 1
      endif

      return
      end

#include "EXF_OPTIONS.h"

C--  File exf_set_gen.F: General routines to load-in an input field
C--   Contents
C--   o EXF_SET_GEN
C--   o EXF_INIT_GEN

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      SUBROUTINE EXF_SET_GEN(
     &     genfile, genStartTime, genperiod,
     &     exf_inscal_gen, genremove_intercept, genremove_slope,
     &     genfld, gen0, gen1, genmask,
#ifdef USE_EXF_INTERPOLATION
     &     gen_lon0, gen_lon_inc, gen_lat0, gen_lat_inc,
     &     gen_nlon, gen_nlat, gen_xout, gen_yout, interp_method,
#endif
     &     myTime, myIter, myThid )

C  *=================================================================*
C  | SUBROUTINE EXF_SET_GEN
C  *=================================================================*
C  | o old version of current S/R EXF_SET_FLD, with fewer arguments
C  | o kept to allow to compile and use old piece of code
C  *=================================================================*

      IMPLICIT NONE

C     == global variables ==
#include "EEPARAMS.h"
#include "SIZE.h"
#include "EXF_PARAM.h"
#include "EXF_INTERP_SIZE.h"

C     == routine arguments ==
      _RL genStartTime, genperiod
      _RL exf_inscal_gen
      _RL genremove_intercept, genremove_slope
      _RL genfld(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL gen0  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL gen1  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      CHARACTER*1 genmask
      CHARACTER*(128) genfile
      _RL     myTime
      INTEGER myIter
      INTEGER myThid

#ifdef USE_EXF_INTERPOLATION
C     gen_lon_0 ,gen_lat_0 :: longitude and latitude of SouthWest
C                             corner of global input grid
C     gen_nlon, gen_nlat   :: input x-grid and y-grid size
C     gen_lon_inc          :: scalar x-grid increment
C     gen_lat_inc          :: vector y-grid increments
C     gen_xout, gen_yout   :: coordinates for output grid
      _RL gen_lon0, gen_lon_inc
      _RL gen_lat0, gen_lat_inc(MAX_LAT_INC)
      INTEGER gen_nlon, gen_nlat
      _RS gen_xout  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RS gen_yout  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      INTEGER interp_method
#endif /* USE_EXF_INTERPOLATION */

C     == local variables ==
C     msgBuf     :: Informational/error message buffer
c     CHARACTER*(MAX_LEN_MBUF) msgBuf
      CHARACTER*(7) gen_name
C     == end of interface ==

      gen_name   = 'exf_gen'
      CALL EXF_SET_FLD(
     I     gen_name, genfile, genmask,
     I     genStartTime, genperiod, repeatPeriod,
     I     exf_inscal_gen, genremove_intercept, genremove_slope,
     U     genfld, gen0, gen1,
#ifdef USE_EXF_INTERPOLATION
     I     gen_lon0, gen_lon_inc, gen_lat0, gen_lat_inc,
     I     gen_nlon, gen_nlat, gen_xout, gen_yout, interp_method,
#endif
     I     myTime, myIter, myThid )

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      SUBROUTINE EXF_INIT_GEN (
     &     genfile, genperiod, exf_inscal_gen, genmask,
     &     genconst, genfld, gen0, gen1,
#ifdef USE_EXF_INTERPOLATION
     &     gen_lon0, gen_lon_inc, gen_lat0, gen_lat_inc,
     &     gen_nlon, gen_nlat, gen_xout, gen_yout, interp_method,
#endif
     &     myThid )

C  *=================================================================*
C  | SUBROUTINE EXF_INIT_GEN
C  *=================================================================*
C  | o old version of current S/R EXF_INIT_FLD, with fewer arguments
C  | o kept to allow to compile and use old piece of code
C  *=================================================================*

      IMPLICIT NONE

C     == global variables ==
#include "EEPARAMS.h"
#include "SIZE.h"
#include "EXF_INTERP_SIZE.h"

C     == routine arguments ==
      _RL genperiod, exf_inscal_gen, genconst
      _RL genfld(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL gen0  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL gen1  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      CHARACTER*1 genmask
      CHARACTER*(128) genfile
      INTEGER myThid

#ifdef USE_EXF_INTERPOLATION
C     gen_lon_0 ,gen_lat_0 :: longitude and latitude of SouthWest
C                             corner of global input grid
C     gen_nlon, gen_nlat   :: input x-grid and y-grid size
C     gen_lon_inc          :: scalar x-grid increment
C     gen_lat_inc          :: vector y-grid increments
C     gen_xout, gen_yout   :: coordinates for output grid
      _RL gen_lon0, gen_lon_inc
      _RL gen_lat0, gen_lat_inc(MAX_LAT_INC)
      INTEGER gen_nlon, gen_nlat
      _RS gen_xout  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RS gen_yout  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      INTEGER interp_method
#endif /* USE_EXF_INTERPOLATION */

C     == local variables ==
C     msgBuf     :: Informational/error message buffer
c     CHARACTER*(MAX_LEN_MBUF) msgBuf
      CHARACTER*(7) gen_name
C     == end of interface ==

      gen_name   = 'exf_gen'
      CALL EXF_INIT_FLD (
     I     gen_name, genfile, genmask,
     I     genperiod, exf_inscal_gen, genconst,
     U     genfld, gen0, gen1,
#ifdef USE_EXF_INTERPOLATION
     I     gen_lon0, gen_lon_inc, gen_lat0, gen_lat_inc,
     I     gen_nlon, gen_nlat, gen_xout, gen_yout, interp_method,
#endif
     I     myThid )

      RETURN
      END

#include "STREAMICE_OPTIONS.h"
#ifdef ALLOW_AUTODIFF
# include "AUTODIFF_OPTIONS.h"
#endif

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

CBOP
      SUBROUTINE STREAMICE_VEL_SOLVE( myThid, maxNLIter, maxCGiter,
     &                                myIter )
C     /============================================================\
C     | SUBROUTINE                                                 |
C     | o                                                          |
C     |============================================================|
C     |                                                            |
C     \============================================================/
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "STREAMICE.h"
#include "STREAMICE_CG.h"

#ifdef ALLOW_AUTODIFF_TAMC
# include "tamc.h"
#endif

C     !INPUT/OUTPUT ARGUMENTS
      INTEGER myThid
      INTEGER maxNLIter
      INTEGER maxCGIter
      INTEGER myIter

#ifdef ALLOW_STREAMICE

C     LOCAL VARIABLES

c   real, dimension(:,:), pointer :: TAUDX, TAUDY, u_prev_iterate, v_prev_iterate, &
c                         u_bdry_cont, v_bdry_cont, Au, Av, err_u, err_v, &
c                         geolonq, geolatq, u_last, v_last, float_cond, H_node
c   type(ocean_grid_type), pointer      :: G
c   integer                 :: conv_flag, i, j, k,l, iter, isym, &
c                         isdq, iedq, jsdq, jedq, isd, ied, jsd, jed, isumstart, jsumstart, nodefloat, nsub
c   real                     :: err_max, err_tempu, err_tempv, err_init, area, max_vel, tempu, tempv, rhoi, rhow

      INTEGER i, j, iter, cg_iters, bi, bj
      INTEGER iter_numconv
      _RL err_max, err_init, err_max_fp
      _RL err_lastchange, cgtol
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      LOGICAL CONVERGED
#ifdef ALLOW_AUTODIFF_TAMC
      INTEGER ikey_nl
#endif
c       _RL taudx (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
c       _RL taudy (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)

      IF (STREAMICE_alt_driving_stress) THEN
       CALL STREAMICE_DRIVING_STRESS_FD (myThid)
      ELSEIF (STREAMICE_ppm_driving_stress) THEN
       CALL STREAMICE_DRIVING_STRESS_PPM (myThid)
      ELSE
       CALL STREAMICE_DRIVING_STRESS (myThid)
      ENDIF

#ifdef ALLOW_AUTODIFF_TAMC
#ifdef STREAMICE_STRESS_BOUNDARY_CONTROL
c$TAF STORE taudx_SI = comlev1, key=ikey_dynamics
c$TAF STORE taudy_SI = comlev1, key=ikey_dynamics
#endif
#endif

#ifdef STREAMICE_STRESS_BOUNDARY_CONTROL
      _EXCH_XY_RL( taudx_SI , myThid )
      _EXCH_XY_RL( taudy_SI , myThid )
      CALL STREAMICE_FORCED_BUTTRESS (myThid)
#endif

      CALL TIMER_START ('STREAMICE_VEL_SOLVE',myThid)

      cgtol = streamice_cg_tol
      CONVERGED = .false.
      err_max = 0.
      err_max_fp = 0.

      _EXCH_XY_RL( taudx_SI , myThid )
      _EXCH_XY_RL( taudy_SI , myThid )

      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          u_old_SI (i,j,bi,bj) = U_streamice (i,j,bi,bj)
          v_old_SI (i,j,bi,bj) = V_streamice (i,j,bi,bj)
         ENDDO
        ENDDO
       ENDDO
      ENDDO

#ifdef ALLOW_AUTODIFF_TAMC
c$TAF STORE U_streamice = comlev1, key=ikey_dynamics
c$TAF STORE V_streamice = comlev1, key=ikey_dynamics
#ifdef STREAMICE_HYBRID_STRESS
c$TAF STORE streamice_taubx = comlev1, key=ikey_dynamics
c$TAF STORE streamice_tauby = comlev1, key=ikey_dynamics
c$TAF STORE visc_streamice_full = comlev1, key=ikey_dynamics
#endif
#endif

#ifdef STREAMICE_HYBRID_STRESS
       CALL STREAMICE_VISC_BETA_HYBRID ( myThid )
#else
       CALL STREAMICE_VISC_BETA ( myThid )
#endif

#ifdef STREAMICE_HYBRID_STRESS
c$TAF STORE visc_streamice_full = comlev1, key=ikey_dynamics
#endif

      _EXCH_XY_RL( tau_beta_eff_streamice , myThid )
      _EXCH_XY_RL( visc_streamice , myThid )

c to stop ifort complaining
        err_init = 0. _d 0

      if (STREAMICE_chkresidconvergence .or.
     &    (streamice_maxnliter_cpl.eq.0 .and. myIter.eq.0)) then

       CALL STREAMICE_GET_VEL_RESID_ERR ( err_init,
#ifdef ALLOW_AUTODIFF_TAMC
     I      ikey_dynamics,
#endif
     I      myThid )

#ifdef ALLOW_AUTODIFF_TAMC
c$TAF STORE err_init = comlev1, key=ikey_dynamics
#endif

       WRITE(msgBuf,'(A,E15.7)') 'initial nonlinear resid (error): ',
     &                       err_init
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT , 1)

      endif !STREAMICE_chkresidconvergence

      iter_numconv = 0
      err_max = err_init
      err_max_fp = streamice_nonlin_tol_fp * 10.
      err_lastchange = err_init

C START NL ITER. LOOP
C-------------------------------------------------------------------
#ifdef ALLOW_TAPENADE
C      Tapenade Pragma for fixed point iters
C$NOAD FP-LOOP
#endif
      DO iter=1,maxNLIter

C     To avoid using "exit", loop goes through all iterations
C       but after convergence loop does nothing

#ifdef ALLOW_AUTODIFF_TAMC
         ikey_nl = (ikey_dynamics-1)*streamice_max_nl + iter
#endif
#ifdef ALLOW_AUTODIFF_TAMC
c$TAF STORE cgtol = comlev1_stream_nl, key=ikey_nl
c$TAF STORE err_max = comlev1_stream_nl, key=ikey_nl
c$TAF STORE err_max_fp = comlev1_stream_nl, key=ikey_nl
c$TAF STORE err_lastchange = comlev1_stream_nl, key=ikey_nl
c$TAF STORE ru_old_si = comlev1_stream_nl, key=ikey_nl
c$TAF STORE rv_old_si = comlev1_stream_nl, key=ikey_nl
c$TAF STORE u_old_si = comlev1_stream_nl, key=ikey_nl
c$TAF STORE v_old_si = comlev1_stream_nl, key=ikey_nl
c$TAF STORE streamice_cg_a1 = comlev1_stream_nl, key=ikey_nl
c$TAF STORE streamice_cg_a2 = comlev1_stream_nl, key=ikey_nl
c$TAF STORE streamice_cg_a3 = comlev1_stream_nl, key=ikey_nl
c$TAF STORE streamice_cg_a4 = comlev1_stream_nl, key=ikey_nl
c$TAF STORE U_streamice = comlev1_stream_nl, key=ikey_nl
c$TAF STORE V_streamice = comlev1_stream_nl, key=ikey_nl
c$TAF STORE tau_beta_eff_streamice = comlev1_stream_nl, key=ikey_nl
c$TAF STORE visc_streamice = comlev1_stream_nl, key=ikey_nl
c$TAF STORE zu_old_si = comlev1_stream_nl, key=ikey_nl
c$TAF STORE zv_old_si = comlev1_stream_nl, key=ikey_nl
#endif

c        IF ((err_max .GT. streamice_nonlin_tol * err_init) .and.
c      &     (err_max_fp .GT. streamice_nonlin_tol_fp)) THEN

#ifdef ALLOW_AUTODIFF_TAMC
c$TAF STORE CONVERGED = comlev1_stream_nl, key=ikey_nl
#endif

       IF (.not.CONVERGED) THEN

       iter_numconv = iter_numconv + 1

#ifdef ALLOW_AUTODIFF_TAMC
c$TAF STORE cgtol = comlev1_stream_nl, key=ikey_nl
c$TAF STORE err_max = comlev1_stream_nl, key=ikey_nl
c$TAF STORE err_lastchange = comlev1_stream_nl, key=ikey_nl
c$TAF STORE ru_old_si = comlev1_stream_nl, key=ikey_nl
c$TAF STORE rv_old_si = comlev1_stream_nl, key=ikey_nl
c$TAF STORE streamice_cg_a1 = comlev1_stream_nl, key=ikey_nl
c$TAF STORE streamice_cg_a2 = comlev1_stream_nl, key=ikey_nl
c$TAF STORE streamice_cg_a3 = comlev1_stream_nl, key=ikey_nl
c$TAF STORE streamice_cg_a4 = comlev1_stream_nl, key=ikey_nl
c$TAF STORE U_streamice = comlev1_stream_nl, key=ikey_nl
c$TAF STORE V_streamice = comlev1_stream_nl, key=ikey_nl
c$TAF STORE tau_beta_eff_streamice = comlev1_stream_nl, key=ikey_nl
c$TAF STORE visc_streamice = comlev1_stream_nl, key=ikey_nl
c$TAF STORE zu_old_si = comlev1_stream_nl, key=ikey_nl
c$TAF STORE zv_old_si = comlev1_stream_nl, key=ikey_nl
#endif

      petscFlag = 0
#ifdef ALLOW_PETSC
      if (streamice_use_petsc) then
        if (iter .le. streamice_maxnliter_petsc) then
          petscFlag = 1
        endif
      endif
#endif

       CALL STREAMICE_CG_WRAPPER(
     &       U_streamice,
     &       V_streamice,
     &       taudx_SI,
     &       taudy_SI,
     &       cgtol,
     &       cg_iters,
     &       maxCGIter,
     &       myThid )

#ifdef STREAMICE_HYBRID_STRESS
#ifdef ALLOW_AUTODIFF_TAMC
c$TAF STORE U_streamice = comlev1_stream_nl, key=ikey_nl
c$TAF STORE V_streamice = comlev1_stream_nl, key=ikey_nl
#endif
#endif

#ifdef STREAMICE_HYBRID_STRESS
        CALL STREAMICE_TAUB (myThid)
#endif

c-----------------------------------------------------------------------------
       WRITE(msgBuf,'(A,I5,A,I4,A)') 'streamice linear solve number',
     &                       iter, " ",
     &                       cg_iters,
     &                       ' iterations '
        CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT , 1)
c-----------------------------------------------------------------------------

#ifdef ALLOW_AUTODIFF_TAMC
c$TAF STORE U_streamice = comlev1_stream_nl, key=ikey_nl
c$TAF STORE V_streamice = comlev1_stream_nl, key=ikey_nl
#ifdef STREAMICE_HYBRID_STRESS
c$TAF STORE streamice_taubx = comlev1_stream_nl, key=ikey_nl
c$TAF STORE streamice_tauby = comlev1_stream_nl, key=ikey_nl
c$TAF STORE visc_streamice_full = comlev1_stream_nl, key=ikey_nl
#endif
#endif

#ifdef STREAMICE_HYBRID_STRESS
       CALL STREAMICE_VISC_BETA_HYBRID ( myThid )
#else
       CALL STREAMICE_VISC_BETA ( myThid )
#endif

      _EXCH_XY_RL( tau_beta_eff_streamice , myThid )
      _EXCH_XY_RL( visc_streamice , myThid )

c----------------------CONVERGENCE TESTS-------------------------------

      if (STREAMICE_chkresidconvergence .or.
     &    (streamice_maxnliter_cpl.eq.0 .and. myIter.eq.0)) then

        CALL STREAMICE_GET_VEL_RESID_ERR ( err_max,
#ifdef ALLOW_AUTODIFF_TAMC
     I     ikey_nl,
#endif
     I     myThid )

       WRITE(msgBuf,'(A,E15.7)') 'err/err_init',
     &                       err_max/err_init
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT , 1)

       IF (err_max .LE. streamice_nonlin_tol * err_init) THEN
        CONVERGED = .true.
       ENDIF

      endif

      if (STREAMICE_chkfixedptconvergence .or.
     &    (streamice_maxnliter_cpl.eq.0 .and. myIter.eq.0)) then

        CALL STREAMICE_GET_VEL_FP_ERR ( err_max_fp,
#ifdef ALLOW_AUTODIFF_TAMC
     I     ikey_nl,
#endif
     I     myThid )

       DO bj = myByLo(myThid), myByHi(myThid)
        DO bi = myBxLo(myThid), myBxHi(myThid)
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           u_old_SI (i,j,bi,bj) = U_streamice (i,j,bi,bj)
           v_old_SI (i,j,bi,bj) = V_streamice (i,j,bi,bj)
          ENDDO
         ENDDO
        ENDDO
       ENDDO

       WRITE(msgBuf,'(A,1PE22.14)') 'STREAMICE_FP_ERROR =',
     &                       err_max_fp
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT , 1)

       IF (err_max_fp .LE. streamice_nonlin_tol_fp) THEN
        CONVERGED = .true.
       ENDIF

      endif

c----------------------END CONVERGENCE TESTS-------------------------------

       IF (err_max<err_lastchange*1.e-2 .and.
     &   STREAMICE_lower_cg_tol) THEN
         cgtol = cgtol * 5.e-2
         err_lastchange = err_max
         WRITE(msgBuf,'(A,E15.7)') 'new cg tol: ',
     &                       cgtol
         CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT , 1)
       ENDIF

       ENDIF ! (err_max .GT. streamice_nonlin_tol * err_init)
      ENDDO

C END NL ITER. LOOP
C-------------------------------------------------------------------

      if (iter_numconv .lt. maxnliter) then
       WRITE(msgBuf,'(A,I5,A)') 'VELOCITY SOLVE CONVERGED, ',
     &         iter_numconv, ' iterations'
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                     SQUEEZE_RIGHT , 1)
      else
       WRITE(msgBuf,'(A,I5,A)') 'VELOCITY SOLVE NOT CONVERGED IN ',
     &         iter_numconv, ' iterations'
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                     SQUEEZE_RIGHT , 1)
      endif

      _EXCH_XY_RL(U_streamice, myThid)
      _EXCH_XY_RL(V_streamice, myThid)

      CALL TIMER_STOP ('STREAMICE_VEL_SOLVE',myThid)

#endif
      RETURN
      END

#include "BLING_OPTIONS.h"

CBOP
      subroutine BLING_INIT_VARIA( myThid )

C     ==========================================================
C     | subroutine bling_init_varia
C     | o Initialize variable parameters
C     ==========================================================

      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "PTRACERS_SIZE.h"
#include "PTRACERS_PARAMS.h"
#include "BLING_VARS.h"

C     !INPUT PARAMETERS:
C     myThid               :: thread number
      INTEGER myThid
CEOP

#ifdef ALLOW_BLING
      INTEGER i,j, bi,bj
      INTEGER k
c     CHARACTER*(MAX_LEN_MBUF) msgBuf

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C--   Initialise global variables
      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          DO k = 1, Nr
            omegaC(i,j,k,bi,bj)     = 0. _d 0
            omegaAr(i,j,k,bi,bj)    = 0. _d 0
            irr_mem(i,j,k,bi,bj)    = 1. _d 0
            chl(i,j,k,bi,bj)        = 0. _d 0
            poc(i,j,k,bi,bj)        = 0. _d 0
            phyto_sm(i,j,k,bi,bj)   = 4. _d -7 / permil
            phyto_lg(i,j,k,bi,bj)   = 4. _d -7 / permil
#ifndef USE_BLING_V1
            phyto_diaz(i,j,k,bi,bj) = 4. _d -7 / permil
#endif
          ENDDO
          chl_sat(i,j,bi,bj)        = 0. _d 0
          gamma_POM_2d(i,j,bi,bj)   = gamma_POM
          wsink0_2d(i,j,bi,bj)      = wsink0
          phi_DOM_2d(i,j,bi,bj)     = phi_DOM
          phi_sm_2d(i,j,bi,bj)      = phi_sm
          phi_lg_2d(i,j,bi,bj)      = phi_lg
          k0_2d(i,j,bi,bj)          = k0
          Pc_0_2d(i,j,bi,bj)        = Pc_0
          k_Fe_2d(i,j,bi,bj)        = k_Fe
#ifndef USE_BLING_V1
          k_Fe_diaz_2d(i,j,bi,bj)   = k_Fe_diaz
          Pc_0_diaz_2d(i,j,bi,bj)   = Pc_0_diaz
          alpha_photo_2d(i,j,bi,bj) = alpha_photo
#endif
         ENDDO
        ENDDO
       ENDDO
      ENDDO

C Read in 2d bio related variables
        IF ( bling_k0_2dFile .NE. ' ' ) THEN
           CALL READ_FLD_XY_RL( bling_k0_2dFile, ' ',
     &                          k0_2d, 0, myThid )
           _EXCH_XY_RL(k0_2d,myThid)
        ENDIF
        IF ( bling_Pc_2dFile .NE. ' ' ) THEN
           CALL READ_FLD_XY_RL( bling_Pc_2dFile, ' ',
     &                          Pc_0_2d, 0, myThid )
        _EXCH_XY_RL(Pc_0_2d,myThid)
        ENDIF
        IF ( bling_k_Fe2dFile .NE. ' ' ) THEN
           CALL READ_FLD_XY_RL( bling_k_Fe2dFile, ' ',
     &                          k_Fe_2d, 0, myThid )
        _EXCH_XY_RL(k_Fe_2d,myThid)
        ENDIF
        IF ( bling_gamma_POM2dFile .NE. ' ' ) THEN
           CALL READ_FLD_XY_RL( bling_gamma_POM2dFile, ' ',
     &                          gamma_POM_2d, 0, myThid )
        _EXCH_XY_RL(gamma_POM_2d,myThid)
        ENDIF
        IF ( bling_wsink0_2dFile .NE. ' ' ) THEN
           CALL READ_FLD_XY_RL( bling_wsink0_2dFile, ' ',
     &                          wsink0_2d, 0, myThid )
        _EXCH_XY_RL(wsink0_2d,myThid)
        ENDIF
        IF ( bling_phi_DOM2dFile .NE. ' ' ) THEN
           CALL READ_FLD_XY_RL( bling_phi_DOM2dFile, ' ',
     &                          phi_DOM_2d, 0, myThid )
        _EXCH_XY_RL(phi_DOM_2d,myThid)
        ENDIF
        IF ( bling_phi_sm2dFile .NE. ' ' ) THEN
           CALL READ_FLD_XY_RL( bling_phi_sm2dFile, ' ',
     &                          phi_sm_2d, 0, myThid )
        _EXCH_XY_RL(phi_sm_2d,myThid)
        ENDIF
        IF ( bling_phi_lg2dFile .NE. ' ' ) THEN
           CALL READ_FLD_XY_RL( bling_phi_lg2dFile, ' ',
     &                          phi_lg_2d, 0, myThid )
        _EXCH_XY_RL(phi_lg_2d,myThid)
        ENDIF
#ifndef USE_BLING_V1
        IF ( bling_Pc_2d_diazFile .NE. ' ' ) THEN
           CALL READ_FLD_XY_RL( bling_Pc_2d_diazFile,' ',
     &                          Pc_0_diaz_2d, 0, myThid)
        _EXCH_XY_RL(Pc_0_diaz_2d,myThid)
        ENDIF
        IF (   bling_alpha_photo2dFile .NE. ' ' ) THEN
           CALL READ_FLD_XY_RL( bling_alpha_photo2dFile, ' ',
     &                          alpha_photo_2d, 0, myThid )
        _EXCH_XY_RL(alpha_photo_2d,myThid)
        ENDIF
        IF ( bling_k_Fe_diaz2dFile .NE. ' ' ) THEN
           CALL READ_FLD_XY_RL( bling_k_Fe_diaz2dFile, ' ',
     &                          k_Fe_diaz_2d, 0, myThid )
        _EXCH_XY_RL(k_Fe_diaz_2d,myThid)
        ENDIF
#endif

#ifdef ADVECT_PHYTO
       DO bj = myByLo(myThid), myByHi(myThid)
        DO bi = myBxLo(myThid), myBxHi(myThid)
         DO k=1,Nr
          DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
            phyto_sm(i,j,k,bi,bj)   = 0.5 _d 0
            phyto_lg(i,j,k,bi,bj)   = 0.5 _d 0
            phyto_diaz(i,j,k,bi,bj) = 0. _d 0
           ENDDO
          ENDDO
         ENDDO
        ENDDO
       ENDDO
#else
C     Read phyto plankton abundance ICs and exchange
      IF (nIter0.EQ.PTRACERS_Iter0) THEN
        IF ( bling_psmFile .NE. ' ' ) THEN
         CALL READ_FLD_XYZ_RL(bling_psmFile,' ',
     &        phyto_sm(1-OLx,1-OLy,1,1,1),0,myThid)
         _EXCH_XYZ_RL(phyto_sm(1-OLx,1-OLy,1,1,1),myThid)
        ENDIF
        IF (bling_plgFile .NE. ' ' ) THEN
         CALL READ_FLD_XYZ_RL(bling_plgFile,' ',
     &        phyto_lg(1-OLx,1-OLy,1,1,1),0,myThid)
         _EXCH_XYZ_RL(phyto_lg(1-OLx,1-OLy,1,1,1),myThid)
        ENDIF
#ifndef USE_BLING_V1
        IF ( bling_PdiazFile .NE. ' ' ) THEN
         CALL READ_FLD_XYZ_RL(bling_pdiazFile,' ',
     &        phyto_diaz(1-OLx,1-OLy,1,1,1),0,myThid)
         _EXCH_XYZ_RL(phyto_diaz(1-OLx,1-OLy,1,1,1),myThid)
        ENDIF
#endif
      ENDIF
#endif /* ifdef ADVECT_PHYTO */
C     Apply mask
       DO bj = myByLo(myThid), myByHi(myThid)
        DO bi = myBxLo(myThid), myBxHi(myThid)
         DO k=1,Nr
          DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
            IF (maskC(i,j,k,bi,bj).EQ.0.) THEN
             phyto_sm(i,j,k,bi,bj)   = 0. _d 0
             phyto_lg(i,j,k,bi,bj)   = 0. _d 0
#ifndef USE_BLING_V1
             phyto_diaz(i,j,k,bi,bj) = 0. _d 0
#endif
            ENDIF
           ENDDO
          ENDDO
         ENDDO
        ENDDO
       ENDDO

C      IF ( nIter0.GT.PTRACERS_Iter0 .OR.
C     &    (nIter0.EQ.PTRACERS_Iter0 .AND. pickupSuff.NE.' ')
C IF ABOVE TRUE phyto READ FROM PICKUP AND OVERWRITES IC READ
C PICKUP CALLED FROM bling_carbonate_init.F
C

#endif /* ALLOW_BLING */

      RETURN
      END

#include "PACKAGES_CONFIG.h"
#include "CPP_OPTIONS.h"
#ifdef ALLOW_AUTODIFF
# include "AUTODIFF_OPTIONS.h"
#endif

CBOP
C     !ROUTINE: CALC_PHI_HYD
C     !INTERFACE:
      SUBROUTINE CALC_PHI_HYD(
     I                         bi, bj, iMin, iMax, jMin, jMax, k,
     U                         phiHydF,
     O                         phiHydC, dPhiHydX, dPhiHydY,
     I                         myTime, myIter, myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE CALC_PHI_HYD                                  |
C     | o Integrate the hydrostatic relation to find the Hydros. |
C     *==========================================================*
C     |    Potential (ocean: Pressure/rho ; atmos = geopotential)
C     | On entry:
C     |   phiHydF(i,j) is the hydrostatic Potential anomaly
C     |                at middle between tracer points k-1,k
C     | On exit:
C     |   phiHydC(i,j) is the hydrostatic Potential anomaly
C     |                at cell centers (tracer points), level k
C     |   phiHydF(i,j) is the hydrostatic Potential anomaly
C     |                at middle between tracer points k,k+1
C     |   dPhiHydX,Y   hydrostatic Potential gradient (X&Y dir)
C     |                at cell centers (tracer points), level k
C     | integr_GeoPot allows to select one integration method
C     |    1= Finite volume form ; else= Finite difference form
C     *==========================================================*
C     \ev
C     !USES:
      IMPLICIT NONE
C     == Global variables ==
#include "SIZE.h"
#include "GRID.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#ifdef ALLOW_AUTODIFF_TAMC
#include "tamc.h"
#endif /* ALLOW_AUTODIFF_TAMC */
#include "SURFACE.h"
#include "DYNVARS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     bi, bj, k  :: tile and level indices
C     iMin,iMax,jMin,jMax :: computational domain
C     phiHydF    :: hydrostatic potential anomaly at middle between
C                   2 centers (entry: Interf_k ; output: Interf_k+1)
C     phiHydC    :: hydrostatic potential anomaly at cell center
C     dPhiHydX,Y :: gradient (X & Y dir.) of hydrostatic potential anom.
C     myTime     :: current time
C     myIter     :: current iteration number
C     myThid     :: thread number for this instance of the routine.
      INTEGER bi,bj,iMin,iMax,jMin,jMax,k
      _RL phiHydF(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL phiHydC(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL dPhiHydX(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL dPhiHydY(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL myTime
      INTEGER myIter, myThid

#ifdef INCLUDE_PHIHYD_CALCULATION_CODE

C     !LOCAL VARIABLES:
C     == Local variables ==
C     phiHydU    :: hydrostatic potential anomaly at interface k+1 (Upper k)
C     pKappaF    :: (p/Po)^kappa at interface k
C     pKappaU    :: (p/Po)^kappa at interface k+1 (Upper k)
C     pKappaC    :: (p/Po)^kappa at cell center k
      INTEGER i,j
      _RL alphaRho(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
#ifndef DISABLE_SIGMA_CODE
      _RL phiHydU (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL pKappaF (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL pKappaU (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL pKappaC, locDepth, fullDepth
#endif /* DISABLE_SIGMA_CODE */
      _RL thetaRef, locBuoy
      _RL dRlocM,dRlocP, ddRloc
      _RL ddPIm, ddPIp, rec_dRm, rec_dRp
      _RL surfPhiFac
      LOGICAL useDiagPhiRlow, addSurfPhiAnom
      LOGICAL useFVgradPhi
#ifdef ALLOW_AUTODIFF_TAMC
C     tkey :: tape key (tile dependent)
C     kkey :: tape key (level and tile dependent)
      INTEGER tkey, kkey
#endif
CEOP
      useDiagPhiRlow = .TRUE.
      addSurfPhiAnom = select_rStar.EQ.0 .AND. nonlinFreeSurf.GE.4
      useFVgradPhi   = selectSigmaCoord.NE.0

      surfPhiFac = 0.
      IF (addSurfPhiAnom) surfPhiFac = 1.

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C  Atmosphere:
C integr_GeoPot => select one option for the integration of the Geopotential:
C   = 0 : Energy Conserving Form, accurate with Topo full cell;
C   = 1 : Finite Volume Form, with Part-Cell, linear in P by Half level;
C   =2,3: Finite Difference Form, with Part-Cell,
C         linear in P between 2 Tracer levels.
C       can handle both cases: Tracer lev at the middle of InterFace_W
C                          and InterFace_W at the middle of Tracer lev;
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#ifdef ALLOW_AUTODIFF_TAMC
      tkey = bi + (bj-1)*nSx + (ikey_dynamics-1)*nSx*nSy
      kkey = k + (tkey-1)*Nr
#endif /* ALLOW_AUTODIFF_TAMC */

C--   Initialize phiHydF to zero :
C     note: atmospheric_loading or Phi_topo anomaly are incorporated
C           later in S/R calc_grad_phi_hyd
      IF (k.EQ.1) THEN
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
           phiHydF(i,j) = 0.
         ENDDO
        ENDDO
      ENDIF

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
      IF ( buoyancyRelation .EQ. 'OCEANIC' ) THEN
C       This is the hydrostatic pressure calculation for the Ocean
C       which uses the FIND_RHO() routine to calculate density
C       before integrating g*rho over the current layer/interface
#ifdef ALLOW_AUTODIFF_TAMC
CADJ GENERAL
#endif /* ALLOW_AUTODIFF_TAMC */

        IF ( implicitIntGravWave .OR. myIter.LT.0 ) THEN
C---    Calculate density
#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE theta(:,:,k,bi,bj) = comlev1_bibj_k, key=kkey, kind = isbyte
CADJ STORE salt (:,:,k,bi,bj) = comlev1_bibj_k, key=kkey, kind = isbyte
#endif /* ALLOW_AUTODIFF_TAMC */
          CALL FIND_RHO_2D(
     I              iMin, iMax, jMin, jMax, k,
     I              theta(1-OLx,1-OLy,k,bi,bj),
     I              salt(1-OLx,1-OLy,k,bi,bj),
     O              alphaRho,
     I              k, bi, bj, myThid )
        ELSE
          DO j=jMin,jMax
           DO i=iMin,iMax
             alphaRho(i,j) = rhoInSitu(i,j,k,bi,bj)
           ENDDO
          ENDDO
        ENDIF

#ifdef ALLOW_SHELFICE
C     mask rho, so that there is no contribution of phiHyd from
C     overlying shelfice (whose density we do not know)
        IF ( useShelfIce .AND. useDOWN_SLOPE ) THEN
C- note: does not work for down_slope pkg which needs rho below the bottom.
C    setting rho=0 above the ice-shelf base is enough (and works in both cases)
C    but might be slower (--> keep original masking if not using down_slope pkg)
         DO j=jMin,jMax
          DO i=iMin,iMax
           IF ( k.LT.kSurfC(i,j,bi,bj) ) alphaRho(i,j) = 0. _d 0
          ENDDO
         ENDDO
        ELSEIF ( useShelfIce ) THEN
         DO j=jMin,jMax
          DO i=iMin,iMax
           alphaRho(i,j) = alphaRho(i,j)*maskC(i,j,k,bi,bj)
          ENDDO
         ENDDO
        ENDIF
#endif /* ALLOW_SHELFICE */

#ifdef ALLOW_MOM_COMMON
C--     Quasi-hydrostatic terms are added in as if they modify the buoyancy
        IF ( quasiHydrostatic ) THEN
         CALL MOM_QUASIHYDROSTATIC( bi, bj, k, uVel, vVel,
     U                              alphaRho,
     I                              myTime, myIter, myThid )
        ENDIF
#endif /* ALLOW_MOM_COMMON */
#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE alphaRho = comlev1_bibj_k, key = kkey, kind = isbyte
#endif

#ifdef NONLIN_FRSURF
        IF ( addSurfPhiAnom .AND.
     &       uniformFreeSurfLev .AND. k.EQ.1 ) THEN
          DO j=jMin,jMax
            DO i=iMin,iMax
              phiHydF(i,j) = surfPhiFac*etaH(i,j,bi,bj)
     &                      *gravity*alphaRho(i,j)*recip_rhoConst
            ENDDO
          ENDDO
        ENDIF
#endif /* NONLIN_FRSURF */

C----  Hydrostatic pressure at cell centers

       IF (integr_GeoPot.EQ.1) THEN
C  --  Finite Volume Form

C---------- This discretization is the "finite volume" form
C           which has not been used to date since it does not
C           conserve KE+PE exactly even though it is more natural

        IF ( uniformFreeSurfLev ) THEN
         DO j=jMin,jMax
          DO i=iMin,iMax
            phiHydC(i,j) = phiHydF(i,j)
     &              + halfRL*drF(k)*gravFacC(k)*gravity
     &                             *alphaRho(i,j)*recip_rhoConst
            phiHydF(i,j) = phiHydF(i,j)
     &                     + drF(k)*gravFacC(k)*gravity
     &                             *alphaRho(i,j)*recip_rhoConst
          ENDDO
         ENDDO
        ELSE
         DO j=jMin,jMax
          DO i=iMin,iMax
           IF (k.EQ.kSurfC(i,j,bi,bj)) THEN
            ddRloc = Ro_surf(i,j,bi,bj)-rC(k)
#ifdef NONLIN_FRSURF
            ddRloc = ddRloc + surfPhiFac*etaH(i,j,bi,bj)
#endif
            phiHydC(i,j) = ddRloc*gravFacC(k)*gravity
     &                           *alphaRho(i,j)*recip_rhoConst
           ELSE
            phiHydC(i,j) = phiHydF(i,j)
     &              + halfRL*drF(k)*gravFacC(k)*gravity
     &                             *alphaRho(i,j)*recip_rhoConst
           ENDIF
           phiHydF(i,j) = phiHydC(i,j)
     &              + halfRL*drF(k)*gravFacC(k)*gravity
     &                             *alphaRho(i,j)*recip_rhoConst
          ENDDO
         ENDDO
        ENDIF

       ELSE
C  --  Finite Difference Form

C---------- This discretization is the "energy conserving" form
C           which has been used since at least Adcroft et al., MWR 1997

        dRlocM = halfRL*drC(k)*gravFacF(k)
        IF (k.EQ.1) dRlocM = (rF(k)-rC(k))*gravFacF(k)
        IF (k.EQ.Nr) THEN
          dRlocP = (rC(k)-rF(k+1))*gravFacF(k+1)
        ELSE
          dRlocP = halfRL*drC(k+1)*gravFacF(k+1)
        ENDIF
        IF ( uniformFreeSurfLev ) THEN
         DO j=jMin,jMax
          DO i=iMin,iMax
            phiHydC(i,j) = phiHydF(i,j)
     &             + dRlocM*gravity*alphaRho(i,j)*recip_rhoConst
            phiHydF(i,j) = phiHydC(i,j)
     &             + dRlocP*gravity*alphaRho(i,j)*recip_rhoConst
          ENDDO
         ENDDO
        ELSE
         rec_dRm = oneRL/(rF(k)-rC(k))
         rec_dRp = oneRL/(rC(k)-rF(k+1))
         DO j=jMin,jMax
          DO i=iMin,iMax
           IF (k.EQ.kSurfC(i,j,bi,bj)) THEN
            ddRloc = Ro_surf(i,j,bi,bj)-rC(k)
#ifdef NONLIN_FRSURF
            ddRloc = ddRloc + surfPhiFac*etaH(i,j,bi,bj)
#endif
            phiHydC(i,j) =( MAX(zeroRL,ddRloc)*rec_dRm*dRlocM
     &                     +MIN(zeroRL,ddRloc)*rec_dRp*dRlocP
     &                    )*gravity*alphaRho(i,j)*recip_rhoConst
           ELSE
            phiHydC(i,j) = phiHydF(i,j)
     &             + dRlocM*gravity*alphaRho(i,j)*recip_rhoConst
           ENDIF
           phiHydF(i,j) = phiHydC(i,j)
     &             + dRlocP*gravity*alphaRho(i,j)*recip_rhoConst
          ENDDO
         ENDDO
        ENDIF

C  --  end if integr_GeoPot = ...
       ENDIF

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
      ELSEIF ( buoyancyRelation .EQ. 'OCEANICP' ) THEN
C       This is the hydrostatic pressure calculation for the Ocean
C       which uses the FIND_RHO() routine to calculate density before
C       integrating (1/rho)_prime*dp over the current layer/interface
#ifdef      ALLOW_AUTODIFF_TAMC
CADJ GENERAL
#endif      /* ALLOW_AUTODIFF_TAMC */

        IF ( implicitIntGravWave .OR. myIter.LT.0 ) THEN
C--     Calculate density
#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE theta(:,:,k,bi,bj) = comlev1_bibj_k, key=kkey, kind = isbyte
CADJ STORE salt (:,:,k,bi,bj) = comlev1_bibj_k, key=kkey, kind = isbyte
#endif /* ALLOW_AUTODIFF_TAMC */
          CALL FIND_RHO_2D(
     I              iMin, iMax, jMin, jMax, k,
     I              theta(1-OLx,1-OLy,k,bi,bj),
     I              salt(1-OLx,1-OLy,k,bi,bj),
     O              alphaRho,
     I              k, bi, bj, myThid )
        ELSE
          DO j=jMin,jMax
           DO i=iMin,iMax
             alphaRho(i,j) = rhoInSitu(i,j,k,bi,bj)
           ENDDO
          ENDDO
        ENDIF

#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE alphaRho = comlev1_bibj_k, key = kkey, kind = isbyte
#endif
C--     Calculate specific volume anomaly "alpha_prime":
C       = 1/(rho_prime + rho_Cst) - 1/rho_Cst
C       = - (rho_prime/rho_Cst) / ( 1 + rho_prime/rho_Cst ) / rho_Cst
        DO j=jMin,jMax
          DO i=iMin,iMax
            locBuoy = alphaRho(i,j)*recip_rhoConst
            alphaRho(i,j) = -maskC(i,j,k,bi,bj)*recip_rhoConst
     &                    * locBuoy/( oneRL + locBuoy )
          ENDDO
        ENDDO

#ifdef ALLOW_MOM_COMMON
C--     Quasi-hydrostatic terms are added as if they modify the specific-volume
        IF ( quasiHydrostatic ) THEN
         CALL MOM_QUASIHYDROSTATIC( bi, bj, k, uVel, vVel,
     U                              alphaRho,
     I                              myTime, myIter, myThid )
        ENDIF
#endif /* ALLOW_MOM_COMMON */
#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE alphaRho = comlev1_bibj_k, key = kkey, kind = isbyte
#endif

C----  Hydrostatic pressure at cell centers

       IF (integr_GeoPot.EQ.1) THEN
C  --  Finite Volume Form

         DO j=jMin,jMax
          DO i=iMin,iMax

C---------- This discretization is the "finite volume" form
C           which has not been used to date since it does not
C           conserve KE+PE exactly even though it is more natural

           IF (k.EQ.kSurfC(i,j,bi,bj)) THEN
             ddRloc = Ro_surf(i,j,bi,bj)-rC(k)
#ifdef NONLIN_FRSURF
             ddRloc = ddRloc + surfPhiFac*etaH(i,j,bi,bj)
#endif
             phiHydC(i,j) = ddRloc*alphaRho(i,j)
c--to reproduce results of c48d_post: uncomment those 4+1 lines
c            phiHydC(i,j)=phiHydF(i,j)
c    &          +(hFacC(i,j,k,bi,bj)-halfRL)*drF(k)*alphaRho(i,j)
c            phiHydF(i,j)=phiHydF(i,j)
c    &          + hFacC(i,j,k,bi,bj)*drF(k)*alphaRho(i,j)
           ELSE
             phiHydC(i,j) = phiHydF(i,j) + halfRL*drF(k)*alphaRho(i,j)
c            phiHydF(i,j) = phiHydF(i,j) +        drF(k)*alphaRho(i,j)
           ENDIF
c-- and comment this last one:
             phiHydF(i,j) = phiHydC(i,j) + halfRL*drF(k)*alphaRho(i,j)
c-----
          ENDDO
         ENDDO

       ELSE
C  --  Finite Difference Form, with Part-Cell Bathy

         dRlocM = halfRL*drC(k)
         IF (k.EQ.1) dRlocM=rF(k)-rC(k)
         IF (k.EQ.Nr) THEN
           dRlocP=rC(k)-rF(k+1)
         ELSE
           dRlocP=halfRL*drC(k+1)
         ENDIF
         rec_dRm = oneRL/(rF(k)-rC(k))
         rec_dRp = oneRL/(rC(k)-rF(k+1))

         DO j=jMin,jMax
          DO i=iMin,iMax

C---------- This discretization is the "energy conserving" form

           IF (k.EQ.kSurfC(i,j,bi,bj)) THEN
             ddRloc = Ro_surf(i,j,bi,bj)-rC(k)
#ifdef NONLIN_FRSURF
             ddRloc = ddRloc + surfPhiFac*etaH(i,j,bi,bj)
#endif
             phiHydC(i,j) =( MAX(zeroRL,ddRloc)*rec_dRm*dRlocM
     &                      +MIN(zeroRL,ddRloc)*rec_dRp*dRlocP
     &                     )*alphaRho(i,j)
           ELSE
             phiHydC(i,j) = phiHydF(i,j) + dRlocM*alphaRho(i,j)
           ENDIF
             phiHydF(i,j) = phiHydC(i,j) + dRlocP*alphaRho(i,j)
          ENDDO
         ENDDO

C  --  end if integr_GeoPot = ...
       ENDIF

      ELSEIF ( buoyancyRelation .EQ. 'ATMOSPHERIC' ) THEN
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C       This is the hydrostatic geopotential calculation for the Atmosphere
C       The ideal gas law is used implicitly here rather than calculating
C       the specific volume, analogous to the oceanic case.

        IF ( implicitIntGravWave .OR. myIter.LT.0 ) THEN
C--     virtual potential temperature anomaly (including water vapour effect)
          IF ( select_rStar.GE.1 .OR. selectSigmaCoord.GE.1 ) THEN
C-      isothermal (theta=const) reference state
            thetaRef = thetaConst
          ELSE
C-      horizontally uniform (tRef) reference state
            thetaRef = tRef(k)
          ENDIF
          DO j=jMin,jMax
           DO i=iMin,iMax
            alphaRho(i,j) = ( theta(i,j,k,bi,bj)
     &                        *( salt(i,j,k,bi,bj)*atm_Rq + oneRL )
     &                      - thetaRef )*maskC(i,j,k,bi,bj)
           ENDDO
          ENDDO
        ELSE
          DO j=jMin,jMax
           DO i=iMin,iMax
             alphaRho(i,j) = rhoInSitu(i,j,k,bi,bj)
           ENDDO
          ENDDO
        ENDIF

#ifdef ALLOW_MOM_COMMON
C--     Quasi-hydrostatic terms are added in as if they modify the Pot.Temp
        IF ( quasiHydrostatic ) THEN
         CALL MOM_QUASIHYDROSTATIC( bi, bj, k, uVel, vVel,
     U                              alphaRho,
     I                              myTime, myIter, myThid )
        ENDIF
#endif /* ALLOW_MOM_COMMON */
#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE alphaRho = comlev1_bibj_k, key = kkey, kind = isbyte
#endif

C---    Integrate d Phi / d pi

#ifndef DISABLE_SIGMA_CODE
C  --  Finite Volume Form, integrated to r-level (cell center & upper interface)
       IF ( useFVgradPhi ) THEN

         fullDepth = rF(1)-rF(Nr+1)
         DO j=jMin,jMax
          DO i=iMin,iMax
           locDepth = Ro_surf(i,j,bi,bj) - R_low(i,j,bi,bj)
#ifdef NONLIN_FRSURF
           locDepth = locDepth + surfPhiFac*etaH(i,j,bi,bj)
#endif
           pKappaF(i,j) = (
     &           ( R_low(i,j,bi,bj) + aHybSigmF( k )*fullDepth
     &                              + bHybSigmF( k )*locDepth
     &           )/atm_Po )**atm_kappa
           pKappaC      = (
     &           ( R_low(i,j,bi,bj) + aHybSigmC( k )*fullDepth
     &                              + bHybSigmC( k )*locDepth
     &           )/atm_Po )**atm_kappa
           pKappaU(i,j) = (
     &           ( R_low(i,j,bi,bj)+ aHybSigmF(k+1)*fullDepth
     &                             + bHybSigmF(k+1)*locDepth
     &           )/atm_Po )**atm_kappa
           phiHydC(i,j) = phiHydF(i,j)
     &        + atm_Cp*( pKappaF(i,j) - pKappaC      )*alphaRho(i,j)
           phiHydU(i,j) = phiHydF(i,j)
     &        + atm_Cp*( pKappaF(i,j) - pKappaU(i,j) )*alphaRho(i,j)
          ENDDO
         ENDDO
C end: Finite Volume Form, integrated to r-level.

       ELSEIF (integr_GeoPot.EQ.0) THEN
#else /* DISABLE_SIGMA_CODE */
       IF (integr_GeoPot.EQ.0) THEN
#endif /* DISABLE_SIGMA_CODE */
C  --  Energy Conserving Form, accurate with Full cell topo  --
C------------ The integration for the first level phi(k=1) is the same
C             for both the "finite volume" and energy conserving methods.
C    *NOTE* o Working with geopotential Anomaly, the geopotential boundary
C             condition is simply Phi-prime(Ro_surf)=0.
C           o convention ddPI > 0 (same as drF & drC)
C-----------------------------------------------------------------------
         IF (k.EQ.1) THEN
           ddPIm=atm_Cp*( ((rF( k )/atm_Po)**atm_kappa)
     &                   -((rC( k )/atm_Po)**atm_kappa) )
         ELSE
           ddPIm=atm_Cp*( ((rC(k-1)/atm_Po)**atm_kappa)
     &                   -((rC( k )/atm_Po)**atm_kappa) )*halfRL
         ENDIF
         IF (k.EQ.Nr) THEN
           ddPIp=atm_Cp*( ((rC( k )/atm_Po)**atm_kappa)
     &                   -((rF(k+1)/atm_Po)**atm_kappa) )
         ELSE
           ddPIp=atm_Cp*( ((rC( k )/atm_Po)**atm_kappa)
     &                   -((rC(k+1)/atm_Po)**atm_kappa) )*halfRL
         ENDIF
C-------- This discretization is the energy conserving form
         DO j=jMin,jMax
          DO i=iMin,iMax
             phiHydC(i,j) = phiHydF(i,j) +ddPIm*alphaRho(i,j)
             phiHydF(i,j) = phiHydC(i,j) +ddPIp*alphaRho(i,j)
          ENDDO
         ENDDO
C end: Energy Conserving Form, No hFac  --
C-----------------------------------------------------------------------

       ELSEIF (integr_GeoPot.EQ.1) THEN
C  --  Finite Volume Form, with Part-Cell Topo, linear in P by Half level
C---------
C  Finite Volume formulation consistent with Partial Cell, linear in p by piece
C   Note: a true Finite Volume form should be linear between 2 Interf_W :
C     phi_C = (phi_W_k+ phi_W_k+1)/2 ; but not accurate in Stratosphere (low p)
C   also: if Interface_W at the middle between tracer levels, this form
C     is close to the Energy Cons. form in the Interior, except for the
C     non-linearity in PI(p)
C---------
           ddPIm=atm_Cp*( ((rF( k )/atm_Po)**atm_kappa)
     &                   -((rC( k )/atm_Po)**atm_kappa) )
           ddPIp=atm_Cp*( ((rC( k )/atm_Po)**atm_kappa)
     &                   -((rF(k+1)/atm_Po)**atm_kappa) )
         DO j=jMin,jMax
          DO i=iMin,iMax
           IF (k.EQ.kSurfC(i,j,bi,bj)) THEN
             ddRloc = Ro_surf(i,j,bi,bj)-rC(k)
#ifdef NONLIN_FRSURF
             ddRloc = ddRloc + surfPhiFac*etaH(i,j,bi,bj)
#endif
             phiHydC(i,j) = ddRloc*recip_drF(k)*2. _d 0
     &          *ddPIm*alphaRho(i,j)
           ELSE
             phiHydC(i,j) = phiHydF(i,j) +ddPIm*alphaRho(i,j)
           ENDIF
             phiHydF(i,j) = phiHydC(i,j) +ddPIp*alphaRho(i,j)
          ENDDO
         ENDDO
C end: Finite Volume Form, with Part-Cell Topo, linear in P by Half level
C-----------------------------------------------------------------------

       ELSEIF ( integr_GeoPot.EQ.2
     &     .OR. integr_GeoPot.EQ.3 ) THEN
C  --  Finite Difference Form, with Part-Cell Topo,
C       works with Interface_W  at the middle between 2.Tracer_Level
C        and  with Tracer_Level at the middle between 2.Interface_W.
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C  Finite Difference formulation consistent with Partial Cell,
C   Valid & accurate if Interface_W at middle between tracer levels
C   linear in p between 2 Tracer levels ; conserve energy in the Interior
C---------
         IF (k.EQ.1) THEN
           ddPIm=atm_Cp*( ((rF( k )/atm_Po)**atm_kappa)
     &                   -((rC( k )/atm_Po)**atm_kappa) )
         ELSE
           ddPIm=atm_Cp*( ((rC(k-1)/atm_Po)**atm_kappa)
     &                   -((rC( k )/atm_Po)**atm_kappa) )*halfRL
         ENDIF
         IF (k.EQ.Nr) THEN
           ddPIp=atm_Cp*( ((rC( k )/atm_Po)**atm_kappa)
     &                   -((rF(k+1)/atm_Po)**atm_kappa) )
         ELSE
           ddPIp=atm_Cp*( ((rC( k )/atm_Po)**atm_kappa)
     &                   -((rC(k+1)/atm_Po)**atm_kappa) )*halfRL
         ENDIF
         rec_dRm = oneRL/(rF(k)-rC(k))
         rec_dRp = oneRL/(rC(k)-rF(k+1))
         DO j=jMin,jMax
          DO i=iMin,iMax
           IF (k.EQ.kSurfC(i,j,bi,bj)) THEN
             ddRloc = Ro_surf(i,j,bi,bj)-rC(k)
#ifdef NONLIN_FRSURF
             ddRloc = ddRloc + surfPhiFac*etaH(i,j,bi,bj)
#endif
             phiHydC(i,j) =( MAX(zeroRL,ddRloc)*rec_dRm*ddPIm
     &                      +MIN(zeroRL,ddRloc)*rec_dRp*ddPIp
     &                     )*alphaRho(i,j)
           ELSE
             phiHydC(i,j) = phiHydF(i,j) +ddPIm*alphaRho(i,j)
           ENDIF
             phiHydF(i,j) = phiHydC(i,j) +ddPIp*alphaRho(i,j)
          ENDDO
         ENDDO
C end: Finite Difference Form, with Part-Cell Topo
C-----------------------------------------------------------------------

       ELSE
         STOP 'CALC_PHI_HYD: Bad integr_GeoPot option !'
       ENDIF

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
      ELSE
        STOP 'CALC_PHI_HYD: Bad value of buoyancyRelation !'
      ENDIF

#ifdef ALLOW_AUTODIFF_TAMC
# ifdef NONLIN_FRSURF
CADJ STORE alphaRho = comlev1_bibj_k, key = kkey, kind = isbyte
CADJ STORE phiHydC  = comlev1_bibj_k, key = kkey, kind = isbyte
CADJ STORE phiHydF  = comlev1_bibj_k, key = kkey, kind = isbyte
# endif
#endif

      IF ( .NOT. useFVgradPhi ) THEN
C--   r-coordinate and r*-coordinate cases:

       IF ( momPressureForcing ) THEN
        CALL CALC_GRAD_PHI_HYD(
     I                         k, bi, bj, iMin,iMax, jMin,jMax,
     I                         phiHydC, alphaRho,
     O                         dPhiHydX, dPhiHydY,
     I                         myTime, myIter, myThid)
       ENDIF

#ifndef DISABLE_SIGMA_CODE
      ELSE
C--   else (SigmaCoords part)

       IF ( fluidIsWater ) THEN
        STOP 'CALC_PHI_HYD: missing code for SigmaCoord'
       ENDIF
       IF ( momPressureForcing ) THEN
        CALL CALC_GRAD_PHI_FV(
     I                         k, bi, bj, iMin,iMax, jMin,jMax,
     I                         phiHydF, phiHydU, pKappaF, pKappaU,
     O                         dPhiHydX, dPhiHydY,
     I                         myTime, myIter, myThid)
       ENDIF
       DO j=jMin,jMax
         DO i=iMin,iMax
           phiHydF(i,j) = phiHydU(i,j)
         ENDDO
       ENDDO

#endif /* DISABLE_SIGMA_CODE */
C--   end if-not/else useFVgradPhi
      ENDIF

C---   Diagnose Phi at boundary r=R_low :
C       = Ocean bottom pressure (Ocean, Z-coord.)
C       = Sea-surface height    (Ocean, P-coord.)
C       = Top atmosphere height (Atmos, P-coord.)
      IF (useDiagPhiRlow) THEN
        CALL DIAGS_PHI_RLOW(
     I                      k, bi, bj, iMin,iMax, jMin,jMax,
     I                      phiHydF, phiHydC, alphaRho,
     I                      myTime, myIter, myThid)
      ENDIF

C---   Diagnose Full Hydrostatic Potential at cell center level
        CALL DIAGS_PHI_HYD(
     I                      k, bi, bj, iMin,iMax, jMin,jMax,
     I                      phiHydC,
     I                      myTime, myIter, myThid)

#endif /* INCLUDE_PHIHYD_CALCULATION_CODE */

      RETURN
      END

#include "ATM_CPL_OPTIONS.h"

CBOP
C     !ROUTINE: CPL_READPARMS
C     !INTERFACE:
      SUBROUTINE CPL_READPARMS( myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R CPL_READPARMS
C     | o Read Coupling parameters that control import/export
C     |   from/to the coupler layer
C     *==========================================================*
C     |   this version is specific to 1 component (atmos)
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     == Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "CPL_PARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine Arguments ==
C     myThid     :: my Thread Id. number
      INTEGER myThid
CEOP

#ifdef COMPONENT_MODULE

C     !FUNCTIONS:
c     INTEGER ILNBLNK

C     !LOCAL VARIABLES:
C     == Local Variables ==
C     msgBuf     :: Informational/error message buffer
C     iUnit      :: Work variable for IO unit number
C     k          :: loop counter
C     iL         :: Work variable for length of file-name
C     cpl_earlyExpImpCall :: retired; always call coupler early in call sequence

      CHARACTER*(MAX_LEN_MBUF) msgBuf
      INTEGER iUnit
c     INTEGER k, iL
      _RL  cpl_atmSendFrq, tmpLoc
      LOGICAL cpl_earlyExpImpCall

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C--   Coupling parameters:
C     cpl_oldPickup  :: restart from an old pickup (= until checkpoint 59h)
C     useImportMxlD  :: True => use Imported Mix.Layer Detph from coupler
C     useImportSST   :: True => use the Imported SST from coupler
C     useImportSSS   :: True => use the Imported SSS from coupler
C     useImportVsq   :: True => use the Imported Surf. velocity^2
C     useImportThSIce :: True => use the Imported thSIce state vars from coupler
C     useImportFlxCO2 :: True => use the Imported air-sea CO2 flux from coupler
C     cpl_atmSendFrq :: Frequency^-1 for sending data to coupler (s)
      NAMELIST /CPL_ATM_PARAM/
     &    cpl_earlyExpImpCall,
     &    cpl_oldPickup,
     &    useImportMxlD, useImportSST, useImportSSS,
     &    useImportVsq, useImportThSIce, useImportFlxCO2,
     &    cpl_atmSendFrq,
     &    maxNumberPrint

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      _BEGIN_MASTER(myThid)

C--   Open the data file
      WRITE(msgBuf,'(A)') ' CPL_READPARMS: opening data.cpl'
      CALL PRINT_MESSAGE( msgBuf,standardMessageUnit,SQUEEZE_RIGHT,1 )

      CALL OPEN_COPY_DATA_FILE( 'data.cpl', 'CPL_READPARMS',
     O                          iUnit, myThid )

C-    Set default value:
      cpl_earlyExpImpCall = .TRUE.
      cpl_oldPickup = .FALSE.
      useImportMxlD = .TRUE.
      useImportSST  = .TRUE.
      useImportSSS  = .TRUE.
      useImportVsq  = .TRUE.
      useImportThSIce = cpl_exchange2W_sIce.EQ.3
      useImportFlxCO2 =  cpl_exchange_DIC .EQ. 3
      cpl_atmSendFrq= deltaTClock
      maxNumberPrint= 100
      countPrtExp   = 0
      countPrtImp   = 0

C--   Read parameters from open data file:

C-    Parameters for coupling interface:
      READ(UNIT=iUnit,NML=CPL_ATM_PARAM)

      WRITE(msgBuf,'(A)')
     &   ' CPL_READPARMS: finished reading data.cpl'
      CALL PRINT_MESSAGE( msgBuf,standardMessageUnit,SQUEEZE_RIGHT,1 )

C--   Close the open data file
#ifdef SINGLE_DISK_IO
      CLOSE(iUnit)
#else
      CLOSE(iUnit,STATUS='DELETE')
#endif /* SINGLE_DISK_IO */

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C--   Check for retired parameters:
      IF ( .NOT.cpl_earlyExpImpCall ) THEN
        WRITE(msgBuf,'(2A)') 'CPL_READPARMS: ',
     &   'Parameter "cpl_earlyExpImpCall" has been retired;'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(2A)') 'CPL_READPARMS: ',
     &   '=> always call coupler early in sequence of calls'
        CALL PRINT_ERROR( msgBuf, myThid )
        cplErrorCount = cplErrorCount + 1
      ENDIF

C--   Check parameters and model configuration

#ifndef ALLOW_LAND
      IF ( atm_cplExch_RunOff ) THEN
        WRITE(msgBuf,'(2A)') 'CPL_READPARMS: needs',
     &    ' to compile pkg/land to use: atm_cplExch_RunOff=T'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(2A)') 'CPL_READPARMS: ',
     &    ' (set from Coupler "data.cpl": cpl_exchange_RunOff > 1)'
        CALL PRINT_ERROR( msgBuf, myThid )
        cplErrorCount = cplErrorCount + 1
      ENDIF
#endif /* ndef ALLOW_LAND */
#ifndef ALLOW_THSICE
      IF ( atm_cplExch1W_sIce ) THEN
        WRITE(msgBuf,'(2A)') 'CPL_READPARMS: needs',
     &    ' to compile pkg/thsice to use: atm_cplExch1W_sIce=T'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(2A)') 'CPL_READPARMS: ',
     &    ' (set from Coupler "data.cpl": cpl_exchange1W_sIce > 1)'
        CALL PRINT_ERROR( msgBuf, myThid )
        cplErrorCount = cplErrorCount + 1
      ENDIF
      IF ( atm_cplExch2W_sIce ) THEN
        WRITE(msgBuf,'(2A)') 'CPL_READPARMS: needs',
     &    ' to compile pkg/thsice to use: atm_cplExch2W_sIce=T'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(2A)') 'CPL_READPARMS: ',
     &    ' (set from Coupler "data.cpl": cpl_exchange2W_sIce > 1)'
        CALL PRINT_ERROR( msgBuf, myThid )
        cplErrorCount = cplErrorCount + 1
      ENDIF
      IF ( atm_cplExch_SaltPl ) THEN
        WRITE(msgBuf,'(2A)') 'CPL_READPARMS: needs',
     &    ' to compile pkg/thsice to use: atm_cplExch_SaltPl=T'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(2A)') 'CPL_READPARMS: ',
     &    ' (set from Coupler "data.cpl": cpl_exchange_SaltPl > 1)'
        CALL PRINT_ERROR( msgBuf, myThid )
        cplErrorCount = cplErrorCount + 1
      ENDIF
#endif /* ndef ALLOW_THSICE */
#ifndef ALLOW_AIM
      IF ( atm_cplExch_DIC ) THEN
        WRITE(msgBuf,'(2A)') 'CPL_READPARMS: needs',
     &    ' to compile pkg/aim_v23 to use: atm_cplExch_DIC = T'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(2A)') 'CPL_READPARMS: ',
     &    ' (set from Coupler "data.cpl": cpl_exchange_DIC > 1)'
        CALL PRINT_ERROR( msgBuf, myThid )
        cplErrorCount = cplErrorCount + 1
      ENDIF
#endif /* ndef ALLOW_AIM */

      IF ( useImportThSIce .AND. .NOT.atm_cplExch2W_sIce ) THEN
        WRITE(msgBuf,'(2A)') 'CPL_READPARMS: useImportThSIce',
     &    ' requires setting'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(2A)') 'CPL_READPARMS: ',
     &    ' cpl_exchange2W_sIce > 1 (in Coupler "data.cpl")'
        CALL PRINT_ERROR( msgBuf, myThid )
        cplErrorCount = cplErrorCount + 1
      ELSEIF ( useImportThSIce .AND. cpl_exchange2W_sIce.NE.3 ) THEN
        WRITE(msgBuf,'(2A)') '** WARNING ** CPL_READPARMS: ',
     &    'useImportThSIce useless without'
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
        WRITE(msgBuf,'(2A)') '** WARNING ** CPL_READPARMS: ',
     &    ' cpl_exchange2W_sIce = 3 (in Coupler "data.cpl")'
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
      ENDIF
      IF ( useImportFlxCO2 .AND. cpl_exchange_DIC.NE.3  ) THEN
        WRITE(msgBuf,'(2A)') 'CPL_READPARMS: useImportFlxCO2',
     &    ' requires setting'
        CALL PRINT_ERROR( msgBuf, myThid )
        WRITE(msgBuf,'(2A)') 'CPL_READPARMS: ',
     &    ' cpl_exchange_DIC = 3 (in Coupler "data.cpl")'
        CALL PRINT_ERROR( msgBuf, myThid )
        cplErrorCount = cplErrorCount + 1
      ENDIF
      tmpLoc = NINT( cpl_atmSendFrq / deltaTClock )
      tmpLoc = ABS( tmpLoc - ( cpl_atmSendFrq / deltaTClock ) )
      IF ( tmpLoc.GT.1. _d -12 .OR. cpl_atmSendFrq.EQ.zeroRL ) THEN
        WRITE(msgBuf,'(2A)') 'CPL_READPARMS: cpl_atmSendFrq',
     &    ' is not a multiple of deltaT'
        CALL PRINT_ERROR( msgBuf, myThid )
        cplErrorCount = cplErrorCount + 1
      ENDIF

C-    Derive other parameters:
      cplSendFrq_iter = NINT( cpl_atmSendFrq / deltaTClock )
      IF ( cplSendFrq_iter.LT.1 ) cplSendFrq_iter = 1

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C--   Print out set-up summary

      iUnit = standardMessageUnit
      WRITE(msgBuf,'(A)') ' '
      CALL PRINT_MESSAGE( msgBuf, iUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)') '// ==================================='
      CALL PRINT_MESSAGE( msgBuf, iUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)') '// Coupling set-up summary :'
      CALL PRINT_MESSAGE( msgBuf, iUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)') '// ==================================='
      CALL PRINT_MESSAGE( msgBuf, iUnit, SQUEEZE_RIGHT, myThid )

C-    o Print Coupler-Exchange config (set from params in coupler 'data.cpl')
       WRITE(msgBuf,'(A)') '// -------'
       CALL PRINT_MESSAGE( msgBuf, iUnit, SQUEEZE_RIGHT, myThid )
       WRITE(msgBuf,'(A)')
     &        '// Coupler-exchange switch (received from coupler):'
       CALL PRINT_MESSAGE( msgBuf, iUnit, SQUEEZE_RIGHT, myThid )

       CALL WRITE_0D_L( atm_cplSequential, INDEX_NONE,
     &                 'atm_cplSequential =',
     &   ' /* use Sequential Coupling Exchange on/off flag */')
       CALL WRITE_0D_L( atm_cplExch_RunOff, INDEX_NONE,
     &                 'atm_cplExch_RunOff =',
     &     ' /* exchange RunOff fields with coupler on/off */')
       CALL WRITE_0D_L( atm_cplExch1W_sIce, INDEX_NONE,
     &                 'atm_cplExch1W_sIce =',
     &     ' /* 1-way exchange of seaice vars with coupler */')
       CALL WRITE_0D_L( atm_cplExch2W_sIce, INDEX_NONE,
     &                 'atm_cplExch2W_sIce =',
     &     ' /* 2-way exchange of ThSIce vars with coupler */')
       CALL WRITE_0D_L( atm_cplExch_SaltPl, INDEX_NONE,
     &                 'atm_cplExch_SaltPl =',
     &     ' /* exchange Salt-Plume fields with coupler */')
       CALL WRITE_0D_L( atm_cplExch_DIC, INDEX_NONE,
     &                 'atm_cplExch_DIC    =',
     &     ' /* exchange DIC    fields with coupler on/off */')

C-    print namelist parameter value:
       WRITE(msgBuf,'(A)') '// -------'
       CALL PRINT_MESSAGE( msgBuf, iUnit, SQUEEZE_RIGHT, myThid )
       WRITE(msgBuf,'(A)')
     &        '// Coupler parameters (from local param file):'
       CALL PRINT_MESSAGE( msgBuf, iUnit, SQUEEZE_RIGHT, myThid )

       CALL WRITE_0D_L( cpl_oldPickup , INDEX_NONE,
     &                 'cpl_oldPickup =',
     &   ' /* restart from old pickup on/off flag */')
       CALL WRITE_0D_L( useImportMxlD , INDEX_NONE,
     &                 'useImportMxlD =',
     &   ' /* use Imported MxL. Depth from Coupler flag */')
       CALL WRITE_0D_L( useImportSST  , INDEX_NONE,
     &                 'useImportSST  =',
     &   ' /* use Imported SST from Coupler on/off flag */')
       CALL WRITE_0D_L( useImportSSS  , INDEX_NONE,
     &                 'useImportSSS  =',
     &   ' /* use Imported SSS from Coupler on/off flag */')
       CALL WRITE_0D_L( useImportVsq  , INDEX_NONE,
     &                 'useImportVsq  =',
     &   ' /* use Imported surf.Vel^2 from Coupler flag */')
       CALL WRITE_0D_L( useImportThSIce, INDEX_NONE,
     &                 'useImportThSIce=',
     &   ' /* use Imported thSIce state-var fr Cpl. flag */')
       CALL WRITE_0D_L( useImportFlxCO2, INDEX_NONE,
     &                 'useImportFlxCO2=',
     &   ' /* use Imported air-sea CO2 flux fr Cpl.  flag */')
       CALL WRITE_0D_RL( cpl_atmSendFrq, INDEX_NONE, 'cpl_atmSendFrq =',
     &   ' /* Frequency^o-1 for sending data to Coupler (s) */')
C     cpl_atmSendFrq  :: Frequency^-1 for sending data to coupler (s)
       CALL WRITE_0D_I( cplSendFrq_iter, INDEX_NONE,'cplSendFrq_iter =',
     &  ' /* send data to coupler every "cplSendFrq" iter */')
       CALL WRITE_0D_I( maxNumberPrint, INDEX_NONE, 'maxNumberPrint =',
     &  ' /* max number of printed Exp/Imp messages */')

      WRITE(msgBuf,'(A)') '// ==================================='
      CALL PRINT_MESSAGE( msgBuf, iUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)') '// End of Coupling set-up summary'
      CALL PRINT_MESSAGE( msgBuf, iUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)') '// ==================================='
      CALL PRINT_MESSAGE( msgBuf, iUnit, SQUEEZE_RIGHT, myThid )

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      _END_MASTER(myThid)

C--   Everyone else must wait for the parameters to be loaded
      _BARRIER

#endif /* COMPONENT_MODULE */

      RETURN
      END

#include "PACKAGES_CONFIG.h"
#include "CPP_OPTIONS.h"

CBOP
C     !ROUTINE: IMPLDIFF
C     !INTERFACE:
      SUBROUTINE IMPLDIFF( bi, bj, iMin, iMax, jMin, jMax,
     I                     tracerId, KappaRX, recip_hFac,
     U                     gTracer,
     I                     myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R IMPLDIFF
C     | o Solve implicit diffusion equation for vertical
C     |   diffusivity.
C     *==========================================================*
C     | o Recoded from 2d intermediate fields to 3d to reduce
C     |   TAF storage
C     | o Fixed missing masks for fields a(), c()
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     == Global data ==
#include "SIZE.h"
#include "DYNVARS.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#ifdef ALLOW_GENERIC_ADVDIFF
# include "GAD.h"
#endif
#ifdef ALLOW_LONGSTEP
# include "LONGSTEP_PARAMS.h"
#endif
#ifdef ALLOW_PTRACERS
# include "PTRACERS_SIZE.h"
# include "PTRACERS_PARAMS.h"
#endif
#ifdef ALLOW_LAYERS
# include "LAYERS_P2SHARE.h"
#endif
c#ifdef ALLOW_AUTODIFF_TAMC
c#endif

C     !INPUT/OUTPUT PARAMETERS:
C     tracerId   :: tracer Identificator (if > 0) ; = -1 or -2 when
C                   solving vertical viscosity implicitly for U or V
C     KappaRk    :: vertical diffusion coefficient
C     recip_hFac :: Inverse of cell open-depth factor
C     gTracer    :: future tracer field
      INTEGER bi,bj,iMin,iMax,jMin,jMax
      INTEGER tracerId
      _RL KappaRX(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RS recip_hFac(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL gTracer(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      INTEGER myThid

C     !LOCAL VARIABLES:
      INTEGER i,j,k
      _RL deltaTX(Nr), locUpdate
      _RL locTr(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL a(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL b(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL c(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL bet(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL gam(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
#ifdef ALLOW_DIAGNOSTICS
      CHARACTER*8 diagName
      CHARACTER*4 diagSufx
#ifdef ALLOW_GENERIC_ADVDIFF
      CHARACTER*4 GAD_DIAG_SUFX
      EXTERNAL    GAD_DIAG_SUFX
#endif
      LOGICAL     DIAGNOSTICS_IS_ON
      EXTERNAL    DIAGNOSTICS_IS_ON
      _RL recip_dT
      _RL df (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
#endif /* ALLOW_DIAGNOSTICS */
CEOP

cph(
cph Not good for TAF: may create irreducible control flow graph
cph      IF (Nr.LE.1) RETURN
cph)

#ifdef ALLOW_PTRACERS
      IF ( tracerId.GE.GAD_TR1) THEN
        DO k=1,Nr
         deltaTX(k) = PTRACERS_dTLev(k)
        ENDDO
      ELSEIF ( tracerId.GE.1 ) THEN
#else
      IF ( tracerId.GE.1 ) THEN
#endif
        DO k=1,Nr
         deltaTX(k) = dTtracerLev(k)
        ENDDO
      ELSE
        DO k=1,Nr
         deltaTX(k) = deltaTMom
        ENDDO
      ENDIF

C--   Initialise
      DO k=1,Nr
       DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
         locTr(i,j,k) = 0. _d 0
        ENDDO
       ENDDO
      ENDDO

C--   Old aLower
      DO j=1-OLy,sNy+OLy
       DO i=1-OLx,sNx+OLx
         a(i,j,1) = 0. _d 0
       ENDDO
      ENDDO
      DO k=2,Nr
#ifdef TARGET_NEC_SX
       DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
#else
       DO j=jMin,jMax
        DO i=iMin,iMax
#endif
          a(i,j,k) = -deltaTX(k)*recip_hFac(i,j,k)*recip_drF(k)
     &               *recip_deepFac2C(k)*recip_rhoFacC(k)
     &               *KappaRX(i,j, k )*recip_drC( k )
     &               *deepFac2F(k)*rhoFacF(k)
          IF (recip_hFac(i,j,k-1).EQ.0.) a(i,j,k)=0.
        ENDDO
       ENDDO
      ENDDO

C--   Old aUpper
      DO k=1,Nr-1
#ifdef TARGET_NEC_SX
       DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
#else
       DO j=jMin,jMax
        DO i=iMin,iMax
#endif
          c(i,j,k) = -deltaTX(k)*recip_hFac(i,j,k)*recip_drF(k)
     &               *recip_deepFac2C(k)*recip_rhoFacC(k)
     &               *KappaRX(i,j,k+1)*recip_drC(k+1)
     &               *deepFac2F(k+1)*rhoFacF(k+1)
          IF (recip_hFac(i,j,k+1).EQ.0.) c(i,j,k)=0.
        ENDDO
       ENDDO
      ENDDO
      DO j=1-OLy,sNy+OLy
       DO i=1-OLx,sNx+OLx
         c(i,j,Nr) = 0. _d 0
       ENDDO
      ENDDO

C--   Old aCenter
      DO k=1,Nr
#ifdef TARGET_NEC_SX
       DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
#else
       DO j=jMin,jMax
        DO i=iMin,iMax
#endif
          b(i,j,k) = 1. _d 0 - ( a(i,j,k) + c(i,j,k) )
C-    to recover older (prior to 2016-10-05) results:
c         b(i,j,k) = 1. _d 0 - c(i,j,k) - a(i,j,k)
        ENDDO
       ENDDO
      ENDDO

C--   Old and new gam, bet are the same
      DO k=1,Nr
       DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
          bet(i,j,k) = 1. _d 0
          gam(i,j,k) = 0. _d 0
        ENDDO
       ENDDO
      ENDDO

C--   Only need do anything if Nr>1
      IF (Nr.GT.1) THEN

       k = 1
C--    Beginning of forward sweep (top level)
#ifdef TARGET_NEC_SX
       DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
#else
       DO j=jMin,jMax
        DO i=iMin,iMax
#endif
         IF (b(i,j,1).NE.0.) bet(i,j,1) = 1. _d 0 / b(i,j,1)
        ENDDO
       ENDDO

      ENDIF

C--   Middle of forward sweep
      IF (Nr.GE.2) THEN

CADJ loop = sequential
       DO k=2,Nr

#ifdef TARGET_NEC_SX
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
#else
        DO j=jMin,jMax
         DO i=iMin,iMax
#endif
          gam(i,j,k) = c(i,j,k-1)*bet(i,j,k-1)
          IF ( ( b(i,j,k) - a(i,j,k)*gam(i,j,k) ) .NE. 0.)
     &        bet(i,j,k) = 1. _d 0 / ( b(i,j,k) - a(i,j,k)*gam(i,j,k) )
         ENDDO
        ENDDO

       ENDDO

      ENDIF

#ifdef TARGET_NEC_SX
      DO j=1-OLy,sNy+OLy
       DO i=1-OLx,sNx+OLx
#else
      DO j=jMin,jMax
       DO i=iMin,iMax
#endif
        locTr(i,j,1) = gTracer(i,j,1)*bet(i,j,1)
       ENDDO
      ENDDO
      DO k=2,Nr
#ifdef TARGET_NEC_SX
       DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
#else
       DO j=jMin,jMax
        DO i=iMin,iMax
#endif
         locTr(i,j,k) = bet(i,j,k)*
     &        (gTracer(i,j,k) - a(i,j,k)*locTr(i,j,k-1))
        ENDDO
       ENDDO
      ENDDO

C--    Backward sweep
CADJ loop = sequential
       DO k=Nr-1,1,-1
#ifdef TARGET_NEC_SX
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
#else
        DO j=jMin,jMax
         DO i=iMin,iMax
#endif
          locTr(i,j,k) = locTr(i,j,k) - gam(i,j,k+1)*locTr(i,j,k+1)
         ENDDO
        ENDDO
       ENDDO

       DO k=1,Nr
#ifdef TARGET_NEC_SX
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
#else
        DO j=jMin,jMax
         DO i=iMin,iMax
#endif
          locUpdate =  locTr(i,j,k) - gTracer(i,j,k)
          gTracer(i,j,k) = locTr(i,j,k)
          locTr(i,j,k) = locUpdate
         ENDDO
        ENDDO
       ENDDO

#ifdef ALLOW_DIAGNOSTICS
C--   Diagnostics of momentum dissipation/viscous tendency, implicit part:
      IF ( useDiagnostics .AND.
     &     ( tracerId.EQ. -1 .OR. tracerId.EQ. -2 ) ) THEN
        IF ( tracerId.EQ. -1 ) diagName = 'Um_ImplD'
        IF ( tracerId.EQ. -2 ) diagName = 'Vm_ImplD'
        IF ( DIAGNOSTICS_IS_ON(diagName,myThid) ) THEN
          recip_dT = 0. _d 0
          IF ( deltaTMom.GT.zeroRL ) recip_dT = oneRL / deltaTMom
          DO k=1,Nr
           DO j=1-OLy,sNy+OLy
            DO i=1-OLx,sNx+OLx
              locTr(i,j,k) = locTr(i,j,k)*recip_dT
            ENDDO
           ENDDO
          ENDDO
          CALL DIAGNOSTICS_FILL( locTr,diagName, 0,Nr,2,bi,bj, myThid )
        ENDIF
      ENDIF

C--   Diagnostics of vertical diffusion flux (or vertical viscous flux):
      IF ( useDiagnostics .AND.tracerId.NE.0 ) THEN
        IF ( tracerId.GE. 1 ) THEN
C--   Set diagnostic suffix for the current tracer
#ifdef ALLOW_GENERIC_ADVDIFF
          diagSufx = GAD_DIAG_SUFX( tracerId, myThid )
#else
          diagSufx = 'aaaa'
#endif
          diagName = 'DFrI'//diagSufx
        ELSEIF ( tracerId.EQ. -1 ) THEN
          diagName = 'VISrI_Um'
        ELSEIF ( tracerId.EQ. -2 ) THEN
          diagName = 'VISrI_Vm'
        ELSE
          STOP 'IMPLIDIFF: should never reach this point !'
        ENDIF
        IF ( DIAGNOSTICS_IS_ON(diagName,myThid)
#ifdef ALLOW_LAYERS
     &       .OR. layers_useThermo
#endif
     &       ) THEN
         DO k= 1,Nr
          IF ( k.EQ.1 ) THEN
C-  Note: Needs to call DIAGNOSTICS_FILL at level k=1 even if array == 0
C         otherwise counter is not incremented !!
            DO j=1-OLy,sNy+OLy
             DO i=1-OLx,sNx+OLx
               df(i,j) = 0. _d 0
             ENDDO
            ENDDO
          ELSEIF ( tracerId.GE.1 ) THEN
#ifdef TARGET_NEC_SX
            DO j=1-OLy,sNy+OLy
             DO i=1-OLx,sNx+OLx
#else
            DO j=1,sNy
             DO i=1,sNx
#endif
               df(i,j) =
     &             -rA(i,j,bi,bj)*deepFac2F(k)*rhoFacF(k)
     &            * KappaRX(i,j,k)*recip_drC(k)*rkSign
     &            * (gTracer(i,j,k) - gTracer(i,j,k-1))
     &            * maskC(i,j,k,bi,bj)
     &            * maskC(i,j,k-1,bi,bj)
             ENDDO
            ENDDO
          ELSEIF ( tracerId.EQ.-1 ) THEN
#ifdef TARGET_NEC_SX
            DO j=1-OLy,sNy+OLy
             DO i=1-OLx,sNx+OLx
#else
            DO j=1,sNy
             DO i=1,sNx+1
#endif
               df(i,j) =
     &             -rAw(i,j,bi,bj)*deepFac2F(k)*rhoFacF(k)
     &            * KappaRX(i,j,k)*recip_drC(k)*rkSign
     &            * (gTracer(i,j,k) - gTracer(i,j,k-1))
     &            * _maskW(i,j,k,bi,bj)
     &            * _maskW(i,j,k-1,bi,bj)
             ENDDO
            ENDDO
          ELSEIF ( tracerId.EQ.-2 ) THEN
#ifdef TARGET_NEC_SX
            DO j=1-OLy,sNy+OLy
             DO i=1-OLx,sNx+OLx
#else
            DO j=1,sNy+1
             DO i=1,sNx
#endif
               df(i,j) =
     &             -rAs(i,j,bi,bj)*deepFac2F(k)*rhoFacF(k)
     &            * KappaRX(i,j,k)*recip_drC(k)*rkSign
     &            * (gTracer(i,j,k) - gTracer(i,j,k-1))
     &            * _maskS(i,j,k,bi,bj)
     &            * _maskS(i,j,k-1,bi,bj)
             ENDDO
            ENDDO
          ENDIF
          CALL DIAGNOSTICS_FILL(df,diagName, k,1, 2,bi,bj, myThid)
#ifdef ALLOW_LAYERS
          IF ( layers_useThermo ) THEN
           CALL LAYERS_FILL( df, tracerId, 'DFR',
     &                           k, 1, 2,bi,bj, myThid )
          ENDIF
#endif /* ALLOW_LAYERS */
         ENDDO
        ENDIF
      ENDIF
#endif /* ALLOW_DIAGNOSTICS */

      RETURN
      END

#include "CPP_OPTIONS.h"
#undef OLD_PSTAR_SLOPE_TERM

CBOP
C     !ROUTINE: CALC_GRAD_PHI_HYD
C     !INTERFACE:
      SUBROUTINE CALC_GRAD_PHI_HYD(
     I                       k, bi, bj, iMin,iMax, jMin,jMax,
     I                       phiHydC, alphRho,
     O                       dPhiHydX, dPhiHydY,
     I                       myTime, myIter, myThid)
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R CALC_GRAD_PHI_HYD
C     | o Calculate the gradient of Hydrostatic potential anomaly
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "SURFACE.h"
#include "DYNVARS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine Arguments ==
C     bi,bj      :: tile index
C     iMin,iMax,jMin,jMax :: Loop counters
C     phiHydC    :: Hydrostatic Potential anomaly
C                  (atmos: =Geopotential ; ocean-z: =Pressure/rho)
C     alphRho    :: Density (z-coord) or specific volume (p-coord)
C     dPhiHydX,Y :: Gradient (X & Y directions) of Hyd. Potential
C     myTime :: Current time
C     myIter :: Current iteration number
C     myThid :: Instance number for this call of the routine.
      INTEGER k, bi,bj, iMin,iMax, jMin,jMax
      _RL phiHydC(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL alphRho(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL dPhiHydX(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL dPhiHydY(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL myTime
      INTEGER myIter, myThid

#ifdef INCLUDE_PHIHYD_CALCULATION_CODE

C     !LOCAL VARIABLES:
C     == Local variables ==
C     i,j :: Loop counters
      INTEGER i,j
      _RL varLoc(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
#ifdef NONLIN_FRSURF
      LOGICAL generalForm
      _RL factorP, factPI
      CHARACTER*(MAX_LEN_MBUF) msgBuf
#endif
CEOP

#ifdef NONLIN_FRSURF
      IF (select_rStar.GE.2 .AND. nonlinFreeSurf.GE.4 ) THEN
# ifndef DISABLE_RSTAR_CODE
C-    Integral of b.dr = rStarFac * Integral of b.dr* :
C      and will add later (select_rStar=2) the contribution of
C      the slope of the r* coordinate.
       IF ( fluidIsAir ) THEN
C-     Consistent with Phi'= Integr[ theta'.dPI ] :
        DO j=jMin,jMax
         DO i=iMin,iMax
          varLoc(i,j) = phiHydC(i,j)*pStarFacK(i,j,bi,bj)
     &                + phi0surf(i,j,bi,bj)
         ENDDO
        ENDDO
       ELSE
        DO j=jMin,jMax
         DO i=iMin,iMax
          varLoc(i,j) = phiHydC(i,j)*rStarFacC(i,j,bi,bj)
     &                + phi0surf(i,j,bi,bj)
         ENDDO
        ENDDO
       ENDIF
      ELSEIF (select_rStar.GE.1 .AND. nonlinFreeSurf.GE.4 ) THEN
C-    Integral of b.dr but scaled to correspond to a fixed r-level (=r*)
C      no contribution of the slope of the r* coordinate (select_rStar=1)
       IF ( fluidIsAir ) THEN
C-     Consistent with Phi'= Integr[ theta'.dPI ] :
        DO j=jMin,jMax
         DO i=iMin,iMax
          IF (Ro_surf(i,j,bi,bj).EQ.rC(k)) THEN
           factPI=atm_Cp*( ((etaH(i,j,bi,bj)+rC(k))/atm_Po)**atm_kappa
     &                    -(                 rC(k) /atm_Po)**atm_kappa
     &                  )
           varLoc(i,j) = factPI*alphRho(i,j)
     &                 + phi0surf(i,j,bi,bj)
          ELSEIF (Ro_surf(i,j,bi,bj).NE.0. _d 0) THEN
           factPI = (rC(k)/Ro_surf(i,j,bi,bj))**atm_kappa
           varLoc(i,j) = phiHydC(i,j)
     &                  *(pStarFacK(i,j,bi,bj) - factPI)
     &                  /(1. _d 0 -factPI)
     &                 + phi0surf(i,j,bi,bj)
          ENDIF
         ENDDO
        ENDDO
       ELSE
        DO j=jMin,jMax
         DO i=iMin,iMax
          IF (Ro_surf(i,j,bi,bj).EQ.rC(k)) THEN
           WRITE(msgBuf,'(3A)') 'CALC_GRAD_PHI_HYD: ',
     &      'Problem when Ro_surf=rC',
     &      ' with select_rStar,nonlinFreeSurf=1,4'
           CALL PRINT_ERROR( msgBuf , myThid)
           STOP 'CALC_GRAD_PHI_HYD: Pb in r* options implementation'
          ELSE
           varLoc(i,j) = phiHydC(i,j)
     &                  *(etaH(i,j,bi,bj)+Ro_surf(i,j,bi,bj)-rC(k))
     &                  /                (Ro_surf(i,j,bi,bj)-rC(k))
     &                 + phi0surf(i,j,bi,bj)
          ENDIF
         ENDDO
        ENDDO
       ENDIF
# endif /* DISABLE_RSTAR_CODE */
      ELSE
#else /* NONLIN_FRSURF */
      IF (.TRUE.) THEN
#endif /* NONLIN_FRSURF */
       DO j=jMin,jMax
        DO i=iMin,iMax
         varLoc(i,j) = phiHydC(i,j)+phi0surf(i,j,bi,bj)
        ENDDO
       ENDDO
      ENDIF

C--   Zonal & Meridional gradient of potential anomaly
      DO j=1-OLy,sNy+OLy
       DO i=1-OLx,sNx+OLx
        dPhiHydX(i,j)  = 0. _d 0
        dPhiHydY(i,j)  = 0. _d 0
       ENDDO
      ENDDO
      DO j=jMin,jMax
       DO i=iMin+1,iMax
        dPhiHydX(i,j) = _recip_dxC(i,j,bi,bj)*recip_deepFacC(k)
     &                *( varLoc(i,j)-varLoc(i-1,j) )*recip_rhoFacC(k)
       ENDDO
      ENDDO
      DO j=jMin+1,jMax
       DO i=iMin,iMax
        dPhiHydY(i,j) = _recip_dyC(i,j,bi,bj)*recip_deepFacC(k)
     &                *( varLoc(i,j)-varLoc(i,j-1) )*recip_rhoFacC(k)
       ENDDO
      ENDDO

#ifdef NONLIN_FRSURF
# ifndef DISABLE_RSTAR_CODE
      IF (select_rStar.GE.2 .AND. nonlinFreeSurf.GE.1 ) THEN
C-     need to use general form anytime r* @ Top is not uniformly zero:
       generalForm = useShelfIce .OR.
     &  ( usingPCoords .AND. ( rF(Nr+1).NE.zeroRS ) ) .OR.
     &  ( usingZCoords .AND. ( topoFile.NE.' ' .OR. rF(1).NE.zeroRS ) )
c      generalForm = .TRUE.
       IF ( fluidIsWater .AND. ( usingZCoords .OR. generalForm ) ) THEN
        IF ( usingZCoords ) THEN
C--    z* coordinate slope term: rho_prime/rho0 * Grad_r(g.z)
         factorP = gravity*recip_rhoConst*recip_rhoFacC(k)*0.5 _d 0
        ELSE
C--    p* coordinate slope term: alpha_prime * Grad_r( p )
         factorP = 0.5 _d 0
        ENDIF
        IF ( generalForm ) THEN
C-     general case, works for both P & Z coordinates:
         DO j=jMin,jMax
          DO i=iMin,iMax
           varLoc(i,j) = etaH(i,j,bi,bj)*recip_Rcol(i,j,bi,bj)
     &                 *( rC(k) - R_low(i,j,bi,bj) )
          ENDDO
         ENDDO
        ELSE
C-     Z-coordinate with flat top at z = 0:
         DO j=jMin,jMax
          DO i=iMin,iMax
           varLoc(i,j) = etaH(i,j,bi,bj)
     &                 *(1. _d 0 + rC(k)*recip_Rcol(i,j,bi,bj))
          ENDDO
         ENDDO
        ENDIF
        DO j=jMin,jMax
         DO i=iMin+1,iMax
          dPhiHydX(i,j) = dPhiHydX(i,j)
     &     +factorP*(alphRho(i-1,j)+alphRho(i,j))
     &             *(varLoc(i,j)-varLoc(i-1,j))
     &             *recip_dxC(i,j,bi,bj)*recip_deepFacC(k)
         ENDDO
        ENDDO
        DO j=jMin+1,jMax
         DO i=iMin,iMax
          dPhiHydY(i,j) = dPhiHydY(i,j)
     &     +factorP*(alphRho(i,j-1)+alphRho(i,j))
     &             *(varLoc(i,j)-varLoc(i,j-1))
     &             *recip_dyC(i,j,bi,bj)*recip_deepFacC(k)
         ENDDO
        ENDDO
       ELSEIF ( fluidIsWater ) THEN
C--    p* coordinate slope term: alpha_prime * Grad_r( p )
C-     requires top to be at p = 0:
        factorP = 0.5 _d 0
        DO j=jMin,jMax
         DO i=iMin+1,iMax
          dPhiHydX(i,j) = dPhiHydX(i,j)
     &     +factorP*(alphRho(i-1,j)+alphRho(i,j))
     &             *(rStarFacC(i,j,bi,bj)-rStarFacC(i-1,j,bi,bj))
     &             *rC(k)*recip_dxC(i,j,bi,bj)*recip_deepFacC(k)
         ENDDO
        ENDDO
        DO j=jMin+1,jMax
         DO i=iMin,iMax
          dPhiHydY(i,j) = dPhiHydY(i,j)
     &     +factorP*(alphRho(i,j-1)+alphRho(i,j))
     &             *(rStarFacC(i,j,bi,bj)-rStarFacC(i,j-1,bi,bj))
     &             *rC(k)*recip_dyC(i,j,bi,bj)*recip_deepFacC(k)
         ENDDO
        ENDDO
       ELSEIF ( fluidIsAir ) THEN
#ifdef OLD_PSTAR_SLOPE_TERM
C--    p* coordinate slope term: alpha_prime * Grad_r( p ):
C      PI_star * (Theta_eq^prime)_bar_i * kappa * delta^i( rStarFacC )
C- Note: factor: ( p_s / p_s^o )^(kappa - 1) = rStarFacC^(kappa -1)
C        is missing here.
        factorP = (rC(k)/atm_Po)**atm_kappa
        factorP = (atm_Rd/rC(k))*factorP*0.5 _d 0
#else
C--    p* coordinate slope term: theta_prime * Grad_r( PI ):
C      PI_star * (Theta_eq^prime)_bar_i * delta^i( rStarFacC^kappa )
C      This is also consitent with geopotential factor: rStarFacC^kappa
        factorP = halfRL*atm_Cp*(rC(k)/atm_Po)**atm_kappa
#endif
        DO j=jMin,jMax
         DO i=iMin+1,iMax
          dPhiHydX(i,j) = dPhiHydX(i,j)
     &     +factorP*(alphRho(i-1,j)+alphRho(i,j))
#ifdef OLD_PSTAR_SLOPE_TERM
     &             *(rStarFacC(i,j,bi,bj)-rStarFacC(i-1,j,bi,bj))
     &             *rC(k)*recip_dxC(i,j,bi,bj)*recip_deepFacC(k)
#else
     &             *(pStarFacK(i,j,bi,bj)-pStarFacK(i-1,j,bi,bj))
     &             *recip_dxC(i,j,bi,bj)*recip_deepFacC(k)
#endif
         ENDDO
        ENDDO
        DO j=jMin+1,jMax
         DO i=iMin,iMax
          dPhiHydY(i,j) = dPhiHydY(i,j)
     &     +factorP*(alphRho(i,j-1)+alphRho(i,j))
#ifdef OLD_PSTAR_SLOPE_TERM
     &             *(rStarFacC(i,j,bi,bj)-rStarFacC(i,j-1,bi,bj))
     &             *rC(k)*recip_dyC(i,j,bi,bj)*recip_deepFacC(k)
#else
     &             *(pStarFacK(i,j,bi,bj)-pStarFacK(i,j-1,bi,bj))
     &             *recip_dyC(i,j,bi,bj)*recip_deepFacC(k)
#endif
         ENDDO
        ENDDO
       ENDIF
      ENDIF
# endif /* DISABLE_RSTAR_CODE */
#endif /* NONLIN_FRSURF */

C--   Apply mask:
      DO j=1-OLy,sNy+OLy
       DO i=1-OLx,sNx+OLx
         dPhiHydX(i,j) = dPhiHydX(i,j)*_maskW(i,j,k,bi,bj)
         dPhiHydY(i,j) = dPhiHydY(i,j)*_maskS(i,j,k,bi,bj)
       ENDDO
      ENDDO

#endif /* INCLUDE_PHIHYD_CALCULATION_CODE */

      RETURN
      END

#include "ATM_CPL_OPTIONS.h"

CBOP 0
C !ROUTINE: ATM_EXPORT_ATMCONFIG

C !INTERFACE:
      SUBROUTINE ATM_EXPORT_ATMCONFIG(
     U                      errFlag,
     I                      landMask, myThid )

C !DESCRIPTION:
C     *==========================================================*
C     | SUBROUTINE ATM_EXPORT_ATMCONFIG
C     | o Routine for exporting atmos. config to coupling level.
C     *==========================================================*
C     | This version talks to the MIT Coupler. It uses the MIT
C     | Coupler "checkpoint1" library calls.
C     *==========================================================*

C !USES:
      IMPLICIT NONE
C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "ATMIDS.h"
c#include "ATMCPL.h"
#include "CPL_PARAMS.h"

C !INPUT/OUTPUT PARAMETERS:
C     errFlag  :: logical flag to report an error
C     landMask :: land / sea mask (=1 : full land; =0 : full ocean grid cell)
C     myThid   :: Thread number for this instance of the routine
      LOGICAL errFlag
      _RL landMask(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      INTEGER myThid

C !LOCAL VARIABLES:
C     msgBuf     :: Informational/error message buffer
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      INTEGER tmpFld(1)
CEOP

C     Send my configuration information to the coupler
      _BARRIER
      _BEGIN_MASTER( myThid )

C     o Send number of coupler time-steps to do for this run
      IF ( MOD( nTimeSteps, cplSendFrq_iter ).NE.0 ) THEN
        errFlag = .TRUE.
        WRITE(msgBuf,'(2A)') 'ATM_EXPORT_ATMCONFIG: ',
     &   '=> Length of run not a multiple of cpl_atmSendFrq'
        CALL PRINT_ERROR( msgBuf, myThid )
      ENDIF
      tmpFld(1) = nTimeSteps/cplSendFrq_iter
      CALL COMPSEND_I4VEC( 'nCouplingSteps', 1, tmpFld )

C     o Send atmos. land/sea mask
      CALL COMPSEND_R8TILES(
     I              atmLandName, sNx, OLx, sNy, OLy, 1, nSx, nSy,
     I              landMask )

      _END_MASTER( myThid )
      _BARRIER

      RETURN
      END

#include "EXF_OPTIONS.h"

      SUBROUTINE EXF_ZENITHANGLE_TABLE( myThid )

C     ==================================================================
C     SUBROUTINE exf_zenithangle_table
C     ==================================================================
C
C     o compute table of daily mean albedo that will be used in exf_zenithangle.F
C
C     ==================================================================
C     SUBROUTINE exf_zenithangle_table
C     ==================================================================

      IMPLICIT NONE

C     == global variables ==
#include "EEPARAMS.h"
#include "SIZE.h"
#include "PARAMS.h"
#include "GRID.h"
#include "EXF_PARAM.h"
#include "EXF_FIELDS.h"
#include "EXF_CONSTANTS.h"

C     == routine arguments ==
      INTEGER myThid

#ifdef ALLOW_DOWNWARD_RADIATION
#ifdef ALLOW_ZENITHANGLE
C     == local variables ==
      INTEGER bi,bj
      INTEGER i,j
      _RL FSOL, dD0dDsq, SOLC, tmpINT1, tmpINT2
      _RL LLLAT, TYEAR, TDAY, ALPHA, CZEN, ALBSEA1
      _RL DECLI, ZS, ZC, SJ, CJ, TMPA, TMPB
      INTEGER iLat,iTyear,iTday
C     == end of interface ==

      _BEGIN_MASTER( myThid )

C solar constant
C --------------
      SOLC   = 1368. _d 0

         DO iLat=1,181
          DO iTyear=1,366

        LLLAT=(iLat-91. _d 0)
        TYEAR=(iTyear-1. _d 0)/365. _d 0

C determine solar declination
C ---------------------------
C       (formula from Hartmann textbook, after Spencer 1971)
        ALPHA= 2. _d 0*PI*TYEAR
        DECLI = 0.006918 _d 0
     &       - 0.399912 _d 0 * cos ( 1. _d 0 * ALPHA )
     &       + 0.070257 _d 0 * sin ( 1. _d 0 * ALPHA )
     &       - 0.006758 _d 0 * cos ( 2. _d 0 * ALPHA )
     &       + 0.000907 _d 0 * sin ( 2. _d 0 * ALPHA )
     &       - 0.002697 _d 0 * cos ( 3. _d 0 * ALPHA )
     &       + 0.001480 _d 0 * sin ( 3. _d 0 * ALPHA )

        ZC = COS(DECLI)
        ZS = SIN(DECLI)
        SJ = SIN(LLLAT * deg2rad)
        CJ = COS(LLLAT * deg2rad)
        TMPA = SJ*ZS
        TMPB = CJ*ZC

C compute squared earth-sun distance ratio
C ----------------------------------------
C       (formula from Hartmann textbook, after Spencer 1971)
        dD0dDsq = 1.000110 _d 0
     &         + 0.034221 _d 0 * cos ( 1. _d 0 * ALPHA )
     &         + 0.001280 _d 0 * sin ( 1. _d 0 * ALPHA )
     &         + 0.000719 _d 0 * cos ( 2. _d 0 * ALPHA )
     &         + 0.000077 _d 0 * sin ( 2. _d 0 * ALPHA )

        tmpINT1=0. _d 0
        tmpINT2=0. _d 0
        DO iTday=1,100
            TDAY=iTday/100. _d 0
C determine DAILY VARYING cos of solar zenith angle CZEN
C ------------------------------------------------------
            CZEN = TMPA + TMPB *
     &         cos( 2. _d 0 *PI* TDAY + 0. _d 0 * deg2rad )
            IF ( CZEN .LE.0 ) CZEN = 0. _d 0
C compute incoming flux at the top of the atm.:
C ---------------------------------------------
            FSOL = SOLC * dD0dDsq * MAX( 0. _d 0, CZEN )
C determine direct ocean albedo
C -----------------------------
C       (formula from Briegleb, Minnis, et al 1986)
            ALBSEA1 = ( ( 2.6 _d 0 / (CZEN**(1.7 _d 0) + 0.065 _d 0) )
     &          + ( 15. _d 0 * (CZEN-0.1 _d 0) * (CZEN-0.5 _d 0)
     &          * (CZEN-1.0 _d 0) ) ) / 100.0 _d 0
C accumulate averages
C -------------------
            tmpINT1=tmpINT1+FSOL*ALBSEA1/100. _d 0
            tmpINT2=tmpINT2+FSOL/100. _d 0
         ENDDO
C compute weighted average of albedo
C ----------------------------------
         IF ( 0.5 _d 0 * tmpINT2 .GT. tmpINT1) THEN
            zen_albedo_table(iTyear,iLat)=tmpINT1/tmpINT2
         ELSE
            zen_albedo_table(iTyear,iLat)=0.5 _d 0
         ENDIF

          ENDDO
         ENDDO

      _END_MASTER( myThid )
      _BARRIER


C determine interpolation coefficient for each grid point
       DO bj = myByLo(myThid),myByHi(myThid)
        DO bi = myBxLo(myThid),myBxHi(myThid)
         DO j = 1,sNy
          DO i = 1,sNx
           LLLAT=yC(i,j,bi,bj)+91. _d 0
C ensure that it is in valid range
           LLLAT=max(LLLAT, 1. _d 0)
           LLLAT=min(LLLAT, 181. _d 0)
C store
           zen_albedo_pointer(i,j,bi,bj)=LLLAT
          ENDDO
         ENDDO
        ENDDO
       ENDDO

#endif /* ALLOW_ZENITHANGLE */
#endif /* ALLOW_DOWNWARD_RADIATION */

      RETURN
      END

#include "MOM_COMMON_OPTIONS.h"
#ifdef ALLOW_AUTODIFF
# include "AUTODIFF_OPTIONS.h"
#endif
#ifdef ALLOW_CTRL
# include "CTRL_OPTIONS.h"
#endif

CBOP
C !ROUTINE: MOM_CALC_HFACZ

C !INTERFACE: ==========================================================
      SUBROUTINE MOM_CALC_HFACZ(
     I        bi, bj, k,
     O        hFacZ, r_hFacZ,
     I        myThid )

C !DESCRIPTION:
C Calculates the fractional thickness at vorticity points

C !USES: ===============================================================
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#ifdef ALLOW_DEPTH_CONTROL
# ifdef ALLOW_AUTODIFF_TAMC
#  include "tamc.h"
# endif
#else /* ALLOW_DEPTH_CONTROL */
# ifdef ALLOW_EXCH2
#  include "W2_EXCH2_SIZE.h"
#  include "W2_EXCH2_TOPOLOGY.h"
# endif
#endif /* ALLOW_DEPTH_CONTROL */

C !INPUT PARAMETERS: ===================================================
C  bi,bj      :: tile indices
C  k          :: vertical level
C  myThid     :: my Thread Id number
      INTEGER bi, bj, k
      INTEGER myThid

C !OUTPUT PARAMETERS: ==================================================
C  hFacZ      :: fractional thickness at vorticity points
C  r_hFacZ    :: reciprocal
      _RS hFacZ(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RS r_hFacZ(1-OLx:sNx+OLx,1-OLy:sNy+OLy)

C !LOCAL VARIABLES: ====================================================
C  i,j        :: loop indices
C  hZoption   :: forward mode option to select the way hFacZ is computed:
C                0 : = minimum of 4 hFacW,hFacS arround (consistent with
C                    definition of partial cell & mask near topography)
C                1 : = minimum of 2 average (hFacW)_j,(hFacS)_i
C                2 : = average of 4 hFacW,hFacS arround (consistent with
C                    how free surface affects hFacW,hFacS it using r* and
C                    without topography)
      INTEGER i,j
#ifdef ALLOW_DEPTH_CONTROL
      _RS hFacZOpenI(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RS hFacZOpenJ(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
# ifdef USE_SMOOTH_MIN
      _RS      SMOOTHMIN_RS
      EXTERNAL SMOOTHMIN_RS
# endif /* USE_SMOOTH_MIN */
# ifdef ALLOW_AUTODIFF_TAMC
      INTEGER kkey
# endif
#else /* ALLOW_DEPTH_CONTROL */
      _RS     hFacZOpen
      INTEGER hZoption
      LOGICAL northWestCorner, northEastCorner,
     &        southWestCorner, southEastCorner
      INTEGER myFace
# ifdef ALLOW_EXCH2
      INTEGER myTile
# endif /* ALLOW_EXCH2 */
      PARAMETER ( hZoption = 0 )
#endif /* ALLOW_DEPTH_CONTROL */
CEOP

C--   Calculate open water fraction at vorticity points

#ifdef ALLOW_DEPTH_CONTROL

#ifdef ALLOW_AUTODIFF_TAMC
      kkey = bi + (bj-1)*nSx + (ikey_dynamics-1)*nSx*nSy
      kkey = k + (kkey-1)*Nr
#endif /* ALLOW_AUTODIFF_TAMC */

      DO j=1-OLy,sNy+OLy
       DO i=1-OLx,sNx+OLx
        hFacZ(i,j)     =0.
        r_hFacZ(i,j)   =0.
        hFacZOpenI(i,j)=0.
        hFacZOpenJ(i,j)=0.
       ENDDO
      ENDDO

#ifdef    ALLOW_AUTODIFF_TAMC
CADJ STORE      hFacZ(:,:) = comlev1_bibj_k , key=kkey, byte=isbyte
CADJ STORE    r_hFacZ(:,:) = comlev1_bibj_k , key=kkey, byte=isbyte
#endif    /* ALLOW_AUTODIFF_TAMC */
      DO j=2-OLy,sNy+OLy
       DO i=2-OLx,sNx+OLx
        hFacZOpenJ(i,j)=
#ifdef USE_SMOOTH_MIN
     &       SMOOTHMIN_RS(_hFacW(i  ,j  ,k,bi,bj),
#else
     &                MIN(_hFacW(i  ,j  ,k,bi,bj),
#endif /* USE_SMOOTH_MIN */
     &                    _hFacW(i  ,j-1,k,bi,bj))
     &       *maskW(i,j,k,bi,bj)*maskW(i,j-1,k,bi,bj)
        hFacZOpenI(i,j)=
#ifdef USE_SMOOTH_MIN
     &       SMOOTHMIN_RS(_hFacS(i  ,j  ,k,bi,bj),
#else
     &                MIN(_hFacS(i  ,j  ,k,bi,bj),
#endif /* USE_SMOOTH_MIN */
     &                    _hFacS(i-1,j  ,k,bi,bj))
     &         *maskS(i,j,k,bi,bj)*maskS(i-1,j,k,bi,bj)
       ENDDO
      ENDDO
#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE hFacZOpenI(:,:) = comlev1_bibj_k , key=kkey, byte=isbyte
CADJ STORE hFacZOpenJ(:,:) = comlev1_bibj_k , key=kkey, byte=isbyte
#endif /* ALLOW_AUTODIFF_TAMC */
      DO j=2-OLy,sNy+OLy
       DO i=2-OLx,sNx+OLx
        hFacZ(i,j) =
#ifdef USE_SMOOTH_MIN
     &       SMOOTHMIN_RS(hFacZOpenI(i,j),hFacZOpenJ(i,j))
#else
     &                MIN(hFacZOpenI(i,j),hFacZOpenJ(i,j))
#endif /* USE_SMOOTH_MIN */
     &         *maskW(i,j,k,bi,bj)*maskW(i,j-1,k,bi,bj)
     &         *maskS(i,j,k,bi,bj)*maskS(i-1,j,k,bi,bj)
       ENDDO
      ENDDO
#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE hFacZ(:,:) = comlev1_bibj_k , key=kkey, byte=isbyte
#endif /* ALLOW_AUTODIFF_TAMC */
      DO j=2-OLy,sNy+OLy
       DO i=2-OLx,sNx+OLx
        IF (hFacZ(i,j).EQ.0.) THEN
         r_hFacZ(i,j) = 0. _d 0
        ELSE
         r_hFacZ(i,j) = 1. _d 0/hFacZ(i,j)
        ENDIF
       ENDDO
      ENDDO
#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE    r_hFacZ(:,:) = comlev1_bibj_k , key=kkey, byte=isbyte
#endif /* ALLOW_AUTODIFF_TAMC */

#else /* not ALLOW_DEPTH_CONTROL */

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C-    Initialize hFacZ:
c     DO j=1-OLy,sNy+OLy
c      DO i=1-OLx,sNx+OLx
c        hFacZ(i,j)=0.
c      ENDDO
c     ENDDO

C--   1rst row & column are not computed: fill with zero
      DO i=1-OLx,sNx+OLx
        hFacZ(i,1-OLy)=0.
      ENDDO
      DO j=2-OLy,sNy+OLy
        hFacZ(1-OLx,j)=0.
      ENDDO

C--   Calculate open water fraction at vorticity points

      IF ( hZoption.EQ.2 ) THEN
        DO j=2-OLy,sNy+OLy
         DO i=2-OLx,sNx+OLx
c         hFacZOpen=
c    &               ( _hFacW(i, j ,k,bi,bj)*rAw(i, j ,bi,bj)
c    &                +_hFacW(i,j-1,k,bi,bj)*rAw(i,j-1,bi,bj) )
c    &             + ( _hFacS( i ,j,k,bi,bj)*rAs( i ,j,bi,bj)
c    &                +_hFacS(i-1,j,k,bi,bj)*rAs(i-1,j,bi,bj) )
c         hFacZ(i,j) = 0.25 _d 0 * hFacZOpen*recip_rAz(i,j,bi,bj)
          hFacZOpen=
     &               ( _hFacW(i, j ,k,bi,bj)
     &                +_hFacW(i,j-1,k,bi,bj) )
     &             + ( _hFacS( i ,j,k,bi,bj)
     &                +_hFacS(i-1,j,k,bi,bj) )
          hFacZ(i,j) = 0.25 _d 0 * hFacZOpen
         ENDDO
        ENDDO
      ELSEIF ( hZoption.EQ.1 ) THEN
        DO j=2-OLy,sNy+OLy
         DO i=2-OLx,sNx+OLx
c         hFacZOpen=MIN(
c    &                  _hFacW(i, j ,k,bi,bj)*rAw(i, j ,bi,bj)
c    &                + _hFacW(i,j-1,k,bi,bj)*rAw(i,j-1,bi,bj)
c    &                , _hFacS( i ,j,k,bi,bj)*rAs( i ,j,bi,bj)
c    &                + _hFacS(i-1,j,k,bi,bj)*rAs(i-1,j,bi,bj)
c    &                 )
c         hFacZ(i,j) = 0.5 _d 0 * hFacZOpen*recip_rAz(i,j,bi,bj)
          hFacZOpen=MIN(
     &                  _hFacW(i, j ,k,bi,bj)
     &                + _hFacW(i,j-1,k,bi,bj)
     &                , _hFacS( i ,j,k,bi,bj)
     &                + _hFacS(i-1,j,k,bi,bj)
     &                 )
          hFacZ(i,j) = 0.5 _d 0 * hFacZOpen
         ENDDO
        ENDDO
      ELSE
        DO j=2-OLy,sNy+OLy
         DO i=2-OLx,sNx+OLx
          hFacZOpen=MIN(_hFacW(i,j,k,bi,bj),
     &                  _hFacW(i,j-1,k,bi,bj))
          hFacZOpen=MIN(_hFacS(i,j,k,bi,bj),hFacZOpen)
          hFacZOpen=MIN(_hFacS(i-1,j,k,bi,bj),hFacZOpen)
          hFacZ(i,j)=hFacZOpen
         ENDDO
        ENDDO
      ENDIF

C-----------------------------------------
C     Special stuff for Cubed Sphere
      IF ( useCubedSphereExchange .AND. hZoption.GE.1 ) THEN

#ifdef ALLOW_EXCH2
        myTile = W2_myTileList(bi,bj)
        myFace = exch2_myFace(myTile)
        southWestCorner = exch2_isWedge(myTile).EQ.1
     &              .AND. exch2_isSedge(myTile).EQ.1
        southEastCorner = exch2_isEedge(myTile).EQ.1
     &              .AND. exch2_isSedge(myTile).EQ.1
        northEastCorner = exch2_isEedge(myTile).EQ.1
     &              .AND. exch2_isNedge(myTile).EQ.1
        northWestCorner = exch2_isWedge(myTile).EQ.1
     &              .AND. exch2_isNedge(myTile).EQ.1
#else
        myFace = bi
        southWestCorner = .TRUE.
        southEastCorner = .TRUE.
        northWestCorner = .TRUE.
        northEastCorner = .TRUE.
#endif /* ALLOW_EXCH2 */

        IF ( southWestCorner ) THEN
         i=1
         j=1
         IF ( hZoption.EQ.1 ) THEN
          hFacZOpen=MIN(_hFacW(i,j,k,bi,bj),
     &                  _hFacW(i,j-1,k,bi,bj))
          hFacZOpen=MIN(_hFacS(i,j,k,bi,bj),hFacZOpen)
          hFacZ(i,j)=hFacZOpen
         ELSE
          IF ( MOD(myFace,2).EQ.1 ) THEN
            hFacZOpen=
     &               ( _hFacW(i,j-1,k,bi,bj)
     &                +_hFacS( i ,j,k,bi,bj) )
     &               + _hFacW(i, j ,k,bi,bj)
          ELSE
            hFacZOpen=
     &               ( _hFacW(i, j ,k,bi,bj)
     &                +_hFacW(i,j-1,k,bi,bj) )
     &               + _hFacS( i ,j,k,bi,bj)
          ENDIF
          hFacZ(i,j) = hFacZOpen / 3. _d 0
         ENDIF
        ENDIF

        IF ( southEastCorner ) THEN
         i=sNx+1
         j=1
C-    to get the same truncation, independent from the face Nb:
         IF ( hZoption.EQ.1 ) THEN
          hFacZOpen=MIN(_hFacW(i,j,k,bi,bj),
     &                  _hFacW(i,j-1,k,bi,bj))
          hFacZOpen=MIN(_hFacS(i-1,j,k,bi,bj),hFacZOpen)
          hFacZ(i,j)=hFacZOpen
         ELSE
          IF ( myFace.EQ.4 ) THEN
            hFacZOpen=
     &               ( _hFacS(i-1,j,k,bi,bj)
     &                +_hFacW(i,j-1,k,bi,bj) )
     &               + _hFacW(i, j ,k,bi,bj)
          ELSEIF ( myFace.EQ.6 ) THEN
            hFacZOpen=
     &               ( _hFacW(i,j-1,k,bi,bj)
     &                +_hFacW(i, j ,k,bi,bj) )
     &               + _hFacS(i-1,j,k,bi,bj)
          ELSE
            hFacZOpen=
     &               ( _hFacW(i, j ,k,bi,bj)
     &                +_hFacS(i-1,j,k,bi,bj) )
     &               + _hFacW(i,j-1,k,bi,bj)
          ENDIF
          hFacZ(i,j) = hFacZOpen / 3. _d 0
         ENDIF
        ENDIF

        IF ( northWestCorner ) THEN
         i=1
         j=sNy+1
C-    to get the same truncation, independent from the face Nb:
         IF ( hZoption.EQ.1 ) THEN
          hFacZOpen=MIN(_hFacW(i,j,k,bi,bj),
     &                  _hFacW(i,j-1,k,bi,bj))
          hFacZOpen=MIN(_hFacS(i,j,k,bi,bj),hFacZOpen)
          hFacZ(i,j)=hFacZOpen
         ELSE
          IF ( myFace.EQ.1 ) THEN
            hFacZOpen=
     &               ( _hFacS( i ,j,k,bi,bj)
     &                +_hFacW(i, j ,k,bi,bj) )
     &               + _hFacW(i,j-1,k,bi,bj)
          ELSEIF ( myFace.EQ.5 ) THEN
            hFacZOpen=
     &               ( _hFacW(i, j ,k,bi,bj)
     &                +_hFacW(i,j-1,k,bi,bj) )
     &               + _hFacS( i ,j,k,bi,bj)
          ELSE
            hFacZOpen=
     &               ( _hFacW(i,j-1,k,bi,bj)
     &                +_hFacS( i ,j,k,bi,bj) )
     &               + _hFacW(i, j ,k,bi,bj)
          ENDIF
          hFacZ(i,j) = hFacZOpen / 3. _d 0
         ENDIF
        ENDIF

        IF ( northEastCorner ) THEN
         i=sNx+1
         j=sNy+1
         IF ( hZoption.EQ.1 ) THEN
          hFacZOpen=MIN(_hFacW(i,j,k,bi,bj),
     &                  _hFacW(i,j-1,k,bi,bj))
          hFacZOpen=MIN(_hFacS(i-1,j,k,bi,bj),hFacZOpen)
          hFacZ(i,j)=hFacZOpen
         ELSE
          IF ( MOD(myFace,2).EQ.1 ) THEN
            hFacZOpen=
     &               ( _hFacW(i,j-1,k,bi,bj)
     &                +_hFacW(i, j ,k,bi,bj) )
     &               + _hFacS(i-1,j,k,bi,bj)
          ELSE
            hFacZOpen=
     &               ( _hFacW(i, j ,k,bi,bj)
     &                +_hFacS(i-1,j,k,bi,bj) )
     &               + _hFacW(i,j-1,k,bi,bj)
          ENDIF
          hFacZ(i,j) = hFacZOpen / 3. _d 0
         ENDIF
        ENDIF

      ENDIF
C     Special Cubed Sphere block ends here
C-----------------------------------------

C--   Calculate reciprocal:
      DO j=1-OLy,sNy+OLy
       DO i=1-OLx,sNx+OLx
        IF (hFacZ(i,j).EQ.0.) THEN
         r_hFacZ(i,j) = 0.
        ELSE
         r_hFacZ(i,j) = 1. _d 0/hFacZ(i,j)
        ENDIF
       ENDDO
      ENDDO

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
#endif /* ALLOW_DEPTH_CONTROL */

      RETURN
      END

#include "GMREDI_OPTIONS.h"
#ifdef ALLOW_AUTODIFF
# include "AUTODIFF_OPTIONS.h"
#endif

CBOP
C     !ROUTINE: GMREDI_XTRANSPORT
C     !INTERFACE:
      SUBROUTINE GMREDI_XTRANSPORT(
     I     trIdentity, bi, bj, k,
     I     iMin, iMax, jMin, jMax,
     I     xA, maskFk, Tracer,
     U     df,
     I     myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | o SUBROUTINE GMREDI_XTRANSPORT
C     |   Add horizontal x transport terms from GM/Redi
C     |   parameterization.
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     == GLobal variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "GMREDI.h"
#include "GAD.h"
#ifdef ALLOW_LONGSTEP
#include "LONGSTEP.h"
#endif

#ifdef ALLOW_AUTODIFF_TAMC
# include "tamc.h"
# ifdef ALLOW_PTRACERS
#  include "PTRACERS_SIZE.h"
# endif
#endif /* ALLOW_AUTODIFF_TAMC */

C     !INPUT/OUTPUT PARAMETERS:
C     trIdentity :: tracer Id number
C     bi, bj     :: current tile indices
C     k          :: current level index
C     iMin,iMax  :: Range of 1rst index where results will be set
C     jMin,jMax  :: Range of 2nd  index where results will be set
C     xA         :: Area of X face
C     maskFk     :: 2-D mask for vertical interface k (between level k-1 & k)
C     Tracer     :: 3D Tracer field
C     df         :: Diffusive flux component work array.
C     myThid     :: my Thread Id number
      INTEGER trIdentity
      INTEGER bi, bj, k
      INTEGER iMin, iMax, jMin, jMax
      _RS xA    (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RS maskFk(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL Tracer(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL df    (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER myThid
CEOP

#ifdef ALLOW_GMREDI
C     !LOCAL VARIABLES:
C     i, j       :: Loop counters
      INTEGER i, j
#if ( defined (GM_EXTRA_DIAGONAL) || defined (GM_BOLUS_ADVEC) )
      INTEGER kp1
      _RL maskp1
#endif
#ifdef GM_EXTRA_DIAGONAL
      INTEGER km1
      _RL dTdz  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
#endif
#ifdef GM_BOLUS_ADVEC
      _RL uTrans(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
#ifdef ALLOW_DIAGNOSTICS
      LOGICAL  DIAGNOSTICS_IS_ON
      EXTERNAL DIAGNOSTICS_IS_ON
      _RL tmp1k(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
#endif
#endif /* GM_BOLUS_ADVEC */
#ifdef ALLOW_AUTODIFF_TAMC
C     kkey :: tape key (depends on levels and tiles)
      INTEGER kkey
      CHARACTER*(MAX_LEN_MBUF) msgBuf
#endif

#ifdef ALLOW_AUTODIFF_TAMC
      kkey = bi + (bj-1)*nSx + (ikey_dynamics-1)*nSx*nSy
      kkey = trIdentity + (kkey-1)*maxpass
      kkey = k + (kkey-1)*Nr
      IF (trIdentity.GT.maxpass) THEN
       WRITE(msgBuf,'(A,2I5)')
     &      'GMREDI_XTRANSPORT: trIdentity > maxpass ',
     &      trIdentity, maxpass
       CALL PRINT_ERROR( msgBuf, myThid )
       STOP 'ABNORMAL END: S/R GMREDI_XTRANSPORT'
      ENDIF
#endif /* ALLOW_AUTODIFF_TAMC */

      IF (useGMRedi) THEN

#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE Kux(:,:,k,bi,bj) =
CADJ &     comlev1_gmredi_k_gad, key=kkey, byte=isbyte
# ifdef GM_EXTRA_DIAGONAL
CADJ STORE Kuz(:,:,k,bi,bj) =
CADJ &     comlev1_gmredi_k_gad, key=kkey, byte=isbyte
# endif
#endif /* ALLOW_AUTODIFF_TAMC */

C--   Area integrated zonal flux
#ifdef ALLOW_LONGSTEP
      IF ( trIdentity .GE. GAD_TR1 ) THEN
       DO j=jMin,jMax
        DO i=iMin,iMax
         df(i,j) = df(i,j)
     &    -xA(i,j)
     &     *LS_Kux(i,j,k,bi,bj)
     &     *_recip_dxC(i,j,bi,bj)*recip_deepFacC(k)
     &     *( Tracer(i,j,k) - Tracer(i-1,j,k) )
        ENDDO
       ENDDO
      ELSE
#endif /* ALLOW_LONGSTEP */
       DO j=jMin,jMax
        DO i=iMin,iMax
         df(i,j) = df(i,j)
     &    -xA(i,j)
     &     *Kux(i,j,k,bi,bj)
     &     *_recip_dxC(i,j,bi,bj)*recip_deepFacC(k)
     &     *( Tracer(i,j,k) - Tracer(i-1,j,k) )
        ENDDO
       ENDDO
#ifdef ALLOW_LONGSTEP
      ENDIF
#endif /* ALLOW_LONGSTEP */

#ifdef GM_EXTRA_DIAGONAL
      IF ( GM_ExtraDiag ) THEN
       km1 = MAX(k-1,1)
       kp1 = MIN(k+1,Nr)
C-    Vertical gradients interpolated to U points
C     Note: no real needs for masking out with maskp1 when k=Nr since the Tracer
C           difference is already zero (k=kp1 in this case); but cleaner for
C           AD-code to ensure exactly zero contribution to Tracer AD var.
       maskp1 = 1. _d 0
       IF (k.GE.Nr) maskp1 = 0. _d 0
       DO j=jMin,jMax
        DO i=iMin,iMax
         dTdz(i,j) = op5*(
     &    +op5*recip_drC(k)*
     &        ( maskFk(i-1,j)*
     &            ( Tracer(i-1,j,km1)-Tracer(i-1,j,k) )
     &         +maskFk( i ,j)*
     &            ( Tracer( i ,j,km1)-Tracer( i ,j,k) )
     &        )
     &    +op5*recip_drC(kp1)*
     &        ( maskC(i-1,j,k,bi,bj)*maskC(i-1,j,kp1,bi,bj)*maskp1*
     &            ( Tracer(i-1,j,k)-Tracer(i-1,j,kp1) )
     &         +maskC( i ,j,k,bi,bj)*maskC( i ,j,kp1,bi,bj)*maskp1*
     &            ( Tracer( i ,j,k)-Tracer( i ,j,kp1) )
     &        )          )
        ENDDO
       ENDDO
#ifdef GM_AUTODIFF_EXCESSIVE_STORE
CADJ STORE dTdz(:,:) =
CADJ &     comlev1_gmredi_k_gad, key=kkey, byte=isbyte
#endif
C-    Off-diagonal components of horizontal flux
#ifdef ALLOW_LONGSTEP
       IF ( trIdentity .GE. GAD_TR1 ) THEN
        DO j=jMin,jMax
         DO i=iMin,iMax
          df(i,j) = df(i,j) - xA(i,j)*LS_Kuz(i,j,k,bi,bj)*dTdz(i,j)
         ENDDO
        ENDDO
       ELSE
#endif /* ALLOW_LONGSTEP */
        DO j=jMin,jMax
         DO i=iMin,iMax
          df(i,j) = df(i,j) - xA(i,j)*Kuz(i,j,k,bi,bj)*dTdz(i,j)
         ENDDO
        ENDDO
#ifdef ALLOW_LONGSTEP
       ENDIF
#endif /* ALLOW_LONGSTEP */
      ENDIF
#endif /* GM_EXTRA_DIAGONAL */

#ifdef GM_BOLUS_ADVEC
      IF ( GM_AdvForm .AND. GM_AdvSeparate
     &                .AND. .NOT.GM_InMomAsStress ) THEN
C      Since bolus transport is computed as curl of stream-function, needs to
C      flip sign when using Left-Handed Coordinate system such as P-coordinate
c      flipSign4LHCoord = -gravitySign
       kp1 = MIN(k+1,Nr)
       maskp1 = 1. _d 0
       IF (k.GE.Nr) maskp1 = 0. _d 0
#ifdef ALLOW_LONGSTEP
       IF ( trIdentity .GE. GAD_TR1 ) THEN
        DO j=jMin,jMax
         DO i=iMin,iMax
          uTrans(i,j) = -gravitySign*dyG(i,j,bi,bj)
     &       *( LS_PsiX(i,j,kp1,bi,bj)*deepFacF(kp1)*maskp1
     &        - LS_PsiX(i,j, k ,bi,bj)*deepFacF(k)
     &        )*maskW(i,j,k,bi,bj)
         ENDDO
        ENDDO
       ELSE
#endif /* ALLOW_LONGSTEP */
        DO j=jMin,jMax
         DO i=iMin,iMax
          uTrans(i,j) = -gravitySign*dyG(i,j,bi,bj)
     &       *( GM_PsiX(i,j,kp1,bi,bj)*deepFacF(kp1)*maskp1
     &        - GM_PsiX(i,j, k ,bi,bj)*deepFacF(k)
     &        )*maskW(i,j,k,bi,bj)
         ENDDO
        ENDDO
#ifdef ALLOW_LONGSTEP
       ENDIF
#endif /* ALLOW_LONGSTEP */
#ifdef GM_AUTODIFF_EXCESSIVE_STORE
CADJ STORE uTrans(:,:) =
CADJ &     comlev1_gmredi_k_gad, key=kkey, byte=isbyte
#endif
       DO j=jMin,jMax
        DO i=iMin,iMax
         df(i,j) = df(i,j)
     &    + uTrans(i,j)*op5*( Tracer(i,j,k) + Tracer(i-1,j,k) )
        ENDDO
       ENDDO
      ENDIF

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#ifdef ALLOW_DIAGNOSTICS
      IF ( useDiagnostics .AND. trIdentity.EQ.1 .AND.
     &     DIAGNOSTICS_IS_ON( 'GM_ubT  ', myThid ) ) THEN
       kp1 = MIN(k+1,Nr)
       maskp1 = 1. _d 0
       IF (k.GE.Nr) maskp1 = 0. _d 0
       DO j=jMin,jMax
        DO i=iMin,iMax
         tmp1k(i,j) = -gravitySign*dyG(i,j,bi,bj)
     &      *( GM_PsiX(i,j,kp1,bi,bj)*deepFacF(kp1)*maskp1
     &       - GM_PsiX(i,j, k ,bi,bj)*deepFacF(k)
     &       )*maskW(i,j,k,bi,bj)
     &        *op5*( Tracer(i,j,k) + Tracer(i-1,j,k) )
        ENDDO
       ENDDO
       CALL DIAGNOSTICS_FILL(tmp1k,'GM_ubT  ', k,1,2,bi,bj,myThid)
      ENDIF
#endif /* ALLOW_DIAGNOSTICS */

#endif /* GM_BOLUS_ADVEC */

      ENDIF
#endif /* ALLOW_GMREDI */

      RETURN
      END

#include "SEAICE_OPTIONS.h"

C--  File seaice_diagnostics_init.F: Routines initialize SEAICE diagnostics
C--   Contents
C--   o SEAICE_DIAGNOSTICS_INIT
C--   o SEAICE_DIAG_SUFX

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: SEAICE_DIAGNOSTICS_INIT
C     !INTERFACE:
      SUBROUTINE SEAICE_DIAGNOSTICS_INIT( myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE SEAICE_DIAGNOSTICS_INIT
C     | o Routine to initialize list of all available diagnostics
C     |   for SEAICE package
C     *==========================================================*
C     \ev
C     !USES:
      IMPLICIT NONE

C     === Global variables ===
#include "EEPARAMS.h"
#include "SIZE.h"
#include "SEAICE_SIZE.h"
#include "SEAICE_PARAMS.h"
#include "SEAICE_TRACER.h"

C     !INPUT/OUTPUT PARAMETERS:
C     myThid ::  my Thread Id number
      INTEGER myThid

#ifdef ALLOW_DIAGNOSTICS
C     !fUNCTIONS:
      INTEGER     ILNBLNK
      EXTERNAL    ILNBLNK
      CHARACTER*4 SEAICE_DIAG_SUFX
      EXTERNAL    SEAICE_DIAG_SUFX

C     !LOCAL VARIABLES:
C     diagNum   :: diagnostics number in the (long) list of available diag.
C     diagMate  :: diag. mate number in the (long) list of available diag.
C     diagName  :: local short name (8c) of a diagnostics
C     diagCode  :: local parser field with characteristics of the diagnostics
C                   see head of S/R DIAGNOSTICS_INIT_EARLY or DIAGNOSTICS_MAIN_INIT
C                   for a list of options
C     diagUnits :: local string (16c): physical units of a diagnostic field
C     diagTitle :: local string (80c): description of field in diagnostic
      INTEGER       diagNum
      INTEGER       diagMate
      CHARACTER*8   diagName
      CHARACTER*16  diagCode
      CHARACTER*16  diagUnits
      CHARACTER*(80) diagTitle

#ifdef ALLOW_SITRACER
      INTEGER       iTr, ilnb, numMateTr, numMateTrPreTh
      CHARACTER*8   locUnitTr
      CHARACTER*30  locNameTr
#endif
      INTEGER       numArea, numAreaPreTh, numHeff, numHeffPreTh
      CHARACTER*9   flxUnits
      CHARACTER*15  locName
      CHARACTER*4   diagSufx
CEOP

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C=============== state variables ============

      diagName  = 'SIarea  '
      diagTitle = 'SEAICE fractional ice-covered area [0 to 1]'
      diagUnits = 'm^2/m^2         '
      diagCode  = 'SM      M1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )
      numArea  = diagNum

      diagName  = 'SIareaPR'
      diagTitle = 'SIarea preceeding ridging process'
      diagUnits = 'm^2/m^2         '
      diagCode  = 'SM      M1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'SIareaPT'
      diagTitle = 'SIarea preceeding thermodynamic growth/melt'
      diagUnits = 'm^2/m^2         '
      diagCode  = 'SM      M1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )
      numAreaPreTh  = diagNum

      diagName  = 'SIheff  '
      diagTitle = 'SEAICE effective ice thickness'
      diagUnits = 'm               '
      diagCode  = 'SM      M1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )
      numHeff  = diagNum

      diagName  = 'SIheffPT'
      diagTitle = 'SIheff preceeeding thermodynamic growth/melt'
      diagUnits = 'm               '
      diagCode  = 'SM      M1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )
      numHeffPreTh  = diagNum

      diagName  = 'SIhsnow '
      diagTitle = 'SEAICE effective snow thickness'
      diagUnits = 'm               '
      diagCode  = 'SM      M1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'SIhsnoPT'
      diagTitle = 'SIhsnow preceeeding thermodynamic growth/melt'
      diagUnits = 'm               '
      diagCode  = 'SM      M1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'SIhsalt '
      diagTitle = 'SEAICE effective salinity'
      diagUnits = 'g/m^2           '
      diagCode  = 'SM      M1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'SIenpa  '
      diagTitle = 'SEAICE power input by surface wind stresses'
      diagUnits = 'W/m^2           '
      diagCode  = 'SM      M1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'SIenpw  '
      diagTitle = 'SEAICE work done by ocean drag'
      diagUnits = 'W/m^2           '
      diagCode  = 'SM      M1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'SIenph  '
      diagTitle = 'SEAICE power due to change in inertia'
      diagUnits = 'W/m^2           '
      diagCode  = 'SM      M1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'SIenpg  '
      diagTitle = 'SEAICE work generated by gravity'
      diagUnits = 'W/m^2           '
      diagCode  = 'SM      M1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'SIenpi  '
      diagTitle = 'SEAICE work done by internal stress'
      diagUnits = 'W/m^2           '
      diagCode  = 'SM      M1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'SIenpot '
      diagTitle = 'SEAICE work done to change potential energy'
      diagUnits = 'W/m^2           '
      diagCode  = 'SM      M1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'SIpRfric'
      diagTitle = 'SEAICE dissipation in ridging by internal stresses'
      diagUnits = 'W/m^2           '
      diagCode  = 'SM      M1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'SIpSfric'
      diagTitle = 'SEAICE dissipation in shearing by internal stresses'
      diagUnits = 'W/m^2           '
      diagCode  = 'SM      M1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

#ifdef ALLOW_SITRACER
      DO iTr = 1, SItrNumInUse

C--    Set default name & tracer Units:
       WRITE(locNameTr,'(A,I4.4,A)') 'sea ice tracer no. ',iTr
       if (SItrMate(iTr).EQ.'HEFF') then
         locUnitTr  = '(kg/kg) '
         numMateTr  = numHeff
         numMateTrPreTh = numHeffPreTh
       else
         locUnitTr  = '(kg/m^2)'
         numMateTr  = numArea
         numMateTrPreTh = numAreaPreTh
       endif
C-     use name & units from data.seaice :
       ilnb = ILNBLNK(SItrUnit(iTr))
       IF ( ilnb.GE.1 ) THEN
         ilnb = LEN(locUnitTr)
         locUnitTr = SItrUnit(iTr)(1:ilnb)
       ENDIF
       ilnb = ILNBLNK(SItrNameLong(iTr))
       IF ( ilnb.GE.1 ) THEN
         ilnb = MIN(LEN(locNameTr),ilnb)
         WRITE(locNameTr,'(A)') SItrNameLong(iTr)(1:ilnb)
       ELSE
         ilnb = ILNBLNK(SItrName(iTr))
         IF ( ilnb.GE.1 ) THEN
           ilnb = MIN(LEN(locNameTr),ilnb)
           WRITE(locNameTr,'(2A)') SItrName(iTr)(1:ilnb),' tracer'
         ENDIF
       ENDIF
       ilnb = MAX(ILNBLNK(locNameTr),1)

       WRITE(diagName,'(A4,I2.2,A2)') 'SItr',iTr,'  '
       WRITE(diagTitle,'(4A)') locNameTr(1:ilnb),
     &       ' (associated with ',SItrMate(iTr),')'
       diagUnits = locUnitTr//'        '
       diagCode  = 'SM  C   M1      '
       CALL DIAGNOSTICS_ADDTOLIST( diagNum, diagName,
     I      diagCode, diagUnits, diagTitle, numMateTr, myThid )

       WRITE(diagName,'(A4,I2.2,A2)') 'SItr',iTr,'PT'
       WRITE(diagTitle,'(A4,I2.2,2A)') 'SItr',iTr,
     &     ' preceeeding thermodynamic growth/melt'
       diagUnits = locUnitTr//'        '
       diagCode  = 'SM  C   M1      '
       CALL DIAGNOSTICS_ADDTOLIST( diagNum, diagName,
     I      diagCode, diagUnits, diagTitle, numMateTrPreTh, myThid )

      ENDDO
#endif

      diagName  = 'SItices '
      diagTitle = 'Surface Temperature over Sea-Ice (area weighted)'
      diagUnits = 'K               '
      diagCode  = 'SM  C   M1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, numArea, myThid )

      diagName  = 'SIuice  '
      diagTitle = 'SEAICE zonal ice velocity, >0 from West to East'
      diagUnits = 'm/s             '
#ifdef SEAICE_CGRID
      diagCode  = 'UU      M1      '
#else
      diagCode  = 'UZ      M1      '
#endif
      diagMate  = diagNum + 2
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

      diagName  = 'SIvice  '
      diagTitle = 'SEAICE merid. ice velocity, >0 from South to North'
      diagUnits = 'm/s             '
#ifdef SEAICE_CGRID
      diagCode  = 'VV      M1      '
#else
      diagCode  = 'VZ      M1      '
#endif
      diagMate  = diagNum
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

C=============== momentum, heat and fresh water forcing ============

C     pkg/diagnostics SIfu and oceTAUX, and dumpfreq FU
C     are identical but they differ from pkg/diagnostics EXFtaux, which
C     is stress before impact of ice.  Also when using exf bulk
C     formulae, EXFtaux is defined on tracer rather than uvel points.
c     diagName  = 'SIfu    '
c     diagTitle = 'SEAICE zonal surface wind stress, >0 increases uVel '
c     diagUnits = 'N/m^2           '
c     diagCode  = 'UU      U1      '
c     diagMate  = diagNum + 2
c     CALL DIAGNOSTICS_ADDTOLIST( diagNum,
c    I     diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

C     pkg/diagnostics SIfv and oceTAUY, and dumpfreq FV
C     are identical but they differ from pkg/diagnostics EXFtauy, which
C     is stress before impact of ice.  Also when using exf bulk
C     formulae, EXFtauy is defined on tracer rather than vvel points.
c     diagName  = 'SIfv    '
c     diagTitle = 'SEAICE merid. surface wind stress, >0 increases vVel'
c     diagUnits = 'N/m^2           '
c     diagCode  = 'VV      U1      '
c     diagMate  = diagNum
c     CALL DIAGNOSTICS_ADDTOLIST( diagNum,
c    I     diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

      diagName  = 'SItaux  '
      diagTitle = 'SEAICE zonal surface wind stress, >0 increases uIce'
      diagUnits = 'N/m^2           '
      diagCode  = 'UU      U1      '
      diagMate  = diagNum + 2
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

      diagName  = 'SItauy  '
      diagTitle = 'SEAICE merid surface wind stress, >0 increases vIce'
      diagUnits = 'N/m^2           '
      diagCode  = 'VV      U1      '
      diagMate  = diagNum
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

      diagName  = 'SIatmTx '
      diagTitle = 'Zonal surface wind stress over Ocean+SeaIce'
      diagUnits = 'N/m^2           '
      diagCode  = 'UU      U1      '
      diagMate  = diagNum + 2
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

      diagName  = 'SIatmTy '
      diagTitle = 'Merid surface wind stress over Ocean+SeaIce'
      diagUnits = 'N/m^2           '
      diagCode  = 'VV      U1      '
      diagMate  = diagNum
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

c     diagName  = 'SIuwind '
c     diagTitle = 'SEAICE zonal 10-m wind speed, >0 increases uVel'
c     diagUnits = 'm/s             '
c     diagCode  = 'UM      U1      '
c     diagMate  = diagNum + 2
c     CALL DIAGNOSTICS_ADDTOLIST( diagNum,
c    I     diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

c     diagName  = 'SIvwind '
c     diagTitle = 'SEAICE meridional 10-m wind speed, >0 increases uVel'
c     diagUnits = 'm/s             '
c     diagCode  = 'VM      U1      '
c     diagMate  = diagNum
c     CALL DIAGNOSTICS_ADDTOLIST( diagNum,
c    I     diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

# ifdef SEAICE_ALLOW_SIDEDRAG
      diagName  = 'SIlatDgU'
      diagTitle = 'SEAICE lateral coastal drag on U momentum'
      diagUnits = 'N/m^2           '
      diagCode  = 'UU      M1      '
      diagMate  = diagNum + 2
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'SIlatDgV'
      diagTitle = 'SEAICE lateral coastal drag on V momentum'
      diagUnits = 'N/m^2           '
      diagCode  = 'VV      M1      '
      diagMate  = diagNum
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )
#endif

C     SIqnet and Qnet are identical.
C     With #undef NONLIN_FRSURF SIqnet is identical to -(TFLUX-TRELAX).
C     Except over land and under sea ice, SIqnet is also identical to
C     EXFlwnet+EXFswnet-EXFhl-EXFhs.
      diagName  = 'SIqnet  '
      diagTitle = 'Ocean surface heatflux, turb+rad, >0 decreases theta'
      diagUnits = 'W/m^2           '
      diagCode  = 'SM      U1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

C     SIqsw and Qsw are identical.
C     Except under sea ice, SIqsw is also identical to EXFswnet.
      diagName  = 'SIqsw   '
      diagTitle = 'Ocean surface shortwave radiat., >0 decreases theta'
      diagUnits = 'W/m^2           '
      diagCode  = 'SM      U1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'SIatmQnt'
      diagTitle = 'Net atmospheric heat flux, >0 decreases theta'
      diagUnits = 'W/m^2           '
      diagCode  = 'SM      U1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'SItflux '
      diagTitle = 'Same as TFLUX but incl seaice (>0 incr T decr H)'
      diagUnits = 'W/m^2           '
      diagCode  = 'SM      U1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )
#ifdef SEAICE_USE_GROWTH_ADX
      diagName  = 'SIeprflx'
      diagTitle = 'heat flux adjustment associated with EmPmR'
      diagUnits = 'W/m^2           '
      diagCode  = 'SM      U1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )
#else
#ifndef SEAICE_DISABLE_HEATCONSFIX
      diagName  = 'SIaaflux'
      diagTitle = 'conservative ocn<->seaice adv. heat flux adjust.'
      diagUnits = 'W/m^2           '
      diagCode  = 'SM      U1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )
#endif
#endif

      diagName  = 'SIhl    '
      diagTitle = 'Latent heat flux into ocean, >0 increases theta'
      diagUnits = 'W/m^2           '
      diagCode  = 'SM      U1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'SIqneto '
      diagTitle = 'Open Ocean Part of SIqnet, turb+rad, >0 decr theta'
      diagUnits = 'W/m^2           '
      diagCode  = 'SM      U1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'SIqneti '
      diagTitle = 'Ice Covered Part of SIqnet, turb+rad, >0 decr theta'
      diagUnits = 'W/m^2           '
      diagCode  = 'SM      U1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

C     pkg/diagnostics SIempmr and dumpfreq EmPmR
C     are identical but they differ from pkg/diagnostics EXFempmr, which
C     is EmPmR before impact of ice.
      diagName  = 'SIempmr '
      diagTitle = 'Ocean surface freshwater flux, > 0 increases salt'
      diagUnits = 'kg/m^2/s        '
      diagCode  = 'SM      U1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'SIatmFW '
      diagTitle = 'Net freshwater flux from atmosphere & land (+=down)'
      diagUnits = 'kg/m^2/s        '
      diagCode  = 'SM      U1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'SIsnPrcp'
      diagTitle = 'Snow precip. (+=dw) over Sea-Ice (area weighted)'
      diagUnits = 'kg/m^2/s        '
      diagCode  = 'SM      U1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'SIfwSubl'
      diagTitle ='Potential sublimation freshwater flux, >0 decr. ice'
      diagUnits = 'kg/m^2/s        '
      diagCode  = 'SM      U1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'SIacSubl'
      diagTitle = 'Actual sublimation freshwater flux, >0 decr. ice'
      diagUnits = 'kg/m^2/s        '
      diagCode  = 'SM      U1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'SIrsSubl'
      diagTitle = 'Residual subl. freshwater flux, >0 taken from ocn'
      diagUnits = 'kg/m^2/s        '
      diagCode  = 'SM      U1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'SIactLHF'
      diagTitle = 'Actual latent heat flux over ice'
      diagUnits = 'W/m^2           '
      diagCode  = 'SM      U1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'SImaxLHF'
      diagTitle = 'Maximum latent heat flux over ice'
      diagUnits = 'W/m^2           '
      diagCode  = 'SM      U1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

#ifdef ALLOW_SITRACER
      DO iTr = 1, SItrNumInUse
       IF (SItrMate(iTr).EQ.'HEFF') then
C--    Set default name & tracer Units:
       WRITE(diagUnits,'(A)') 'kg/m^2/s'
C--     use units from data.seaice :
       ilnb = ILNBLNK(SItrUnit(iTr))
       IF ( ilnb.GE.1 ) THEN
         WRITE(diagUnits,'(2A)') SItrUnit(iTr)(1:ilnb),'.kg/m^2/s'
       ENDIF
C--
       WRITE(diagName,'(A4,I2.2,A2)') 'SItr',iTr,'Fx'
       WRITE(diagTitle,'(A4,I2.2,A)') 'SItr',iTr,
     I      ' flux out of ice pack (that may enter ocean)'
       diagCode  = 'SM      M1      '
       CALL DIAGNOSTICS_ADDTOLIST( diagNum, diagName,
     I      diagCode, diagUnits, diagTitle, 0, myThid )

      ENDIF
      ENDDO
#endif

C============== ice growth/melt ==============

      diagName  = 'SIaQbOCN'
      diagTitle = 'Potential HEFF rate of change by ocean ice flux'
      diagUnits = 'm/s             '
      diagCode  = 'SM      M1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'SIaQbATC'
      diagTitle = 'Potential HEFF rate of change by atm flux over ice'
      diagUnits = 'm/s             '
      diagCode  = 'SM      M1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'SIaQbATO'
      diagTitle = 'Potential HEFF rate of change by open ocn atm flux'
      diagUnits = 'm/s             '
      diagCode  = 'SM      M1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'SIdHbOCN'
      diagTitle = 'HEFF rate of change by ocean ice flux'
      diagUnits = 'm/s             '
      diagCode  = 'SM      M1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'SIdSbATC'
      diagTitle = 'HSNOW rate of change by atm flux over sea ice'
      diagUnits = 'm/s             '
      diagCode  = 'SM      M1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'SIdSbOCN'
      diagTitle = 'HSNOW rate of change by ocean ice flux'
      diagUnits = 'm/s             '
      diagCode  = 'SM      M1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'SIdHbATC'
      diagTitle = 'HEFF rate of change by atm flux over sea ice'
      diagUnits = 'm/s             '
      diagCode  = 'SM      M1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'SIdHbATO'
      diagTitle = 'HEFF rate of change by open ocn atm flux'
      diagUnits = 'm/s             '
      diagCode  = 'SM      M1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'SIdHbFLO'
      diagTitle = 'HEFF rate of change by flooding snow'
      diagUnits = 'm/s             '
      diagCode  = 'SM      M1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )
#ifdef SEAICE_GREASE

      diagName  = 'SIgrsLT '
      diagTitle = 'actual grease ice layer thickness'
      diagUnits = 'm               '
      diagCode  = 'SM      M1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )
#endif

C=============== expansion/contraction ============

      diagName  = 'SIdAbATO'
      diagTitle = 'Potential AREA rate of change by open ocn atm flux'
      diagUnits = 'm^2/m^2/s       '
      diagCode  = 'SM      M1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'SIdAbATC'
      diagTitle = 'Potential AREA rate of change by atm flux over ice'
      diagUnits = 'm^2/m^2/s       '
      diagCode  = 'SM      M1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'SIdAbOCN'
      diagTitle = 'Potential AREA rate of change by ocean ice flux'
      diagUnits = 'm^2/m^2/s       '
      diagCode  = 'SM      M1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'SIdA'
      diagTitle = 'AREA rate of change (net)'
      diagUnits = 'm^2/m^2/s       '
      diagCode  = 'SM      M1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

C============== advection/diffusion ============

C     effective thickness
      flxUnits = '.m^2/s   '
      locName = 'eff ice thickn '
      WRITE(diagUnits,'(2A)') 'm',flxUnits
      diagSufx = SEAICE_DIAG_SUFX( GAD_HEFF, myThid )

C--   advective flux
      diagName  = 'ADVx'//diagSufx
      diagTitle = 'Zonal      Advective Flux of '//locName
      diagCode  = 'UU      M1      '
      diagMate  = diagNum + 2
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

      diagName  = 'ADVy'//diagSufx
      diagTitle = 'Meridional Advective Flux of '//locName
      diagCode  = 'VV      M1      '
      diagMate  = diagNum
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

C--   Diffusive flux:
      diagName  = 'DFxE'//diagSufx
      diagTitle = 'Zonal      Diffusive Flux of '//locName
      diagCode  = 'UU      M1      '
      diagMate  = diagNum + 2
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

      diagName  = 'DFyE'//diagSufx
      diagTitle = 'Meridional Diffusive Flux of '//locName
      diagCode  = 'VV      M1      '
      diagMate  = diagNum
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

C     fractional ice covered area (ice concentration)
      locName = 'fract area     '
      WRITE(diagUnits,'(2A)') 'm^2/m^2',flxUnits
      diagSufx = SEAICE_DIAG_SUFX( GAD_AREA, myThid )

C--   advective flux
      diagName  = 'ADVx'//diagSufx
      diagTitle = 'Zonal      Advective Flux of '//locName
      diagCode  = 'UU      M1      '
      diagMate  = diagNum + 2
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

      diagName  = 'ADVy'//diagSufx
      diagTitle = 'Meridional Advective Flux of '//locName
      diagCode  = 'VV      M1      '
      diagMate  = diagNum
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

C--   Diffusive flux:
      diagName  = 'DFxE'//diagSufx
      diagTitle = 'Zonal      Diffusive Flux of '//locName
      diagCode  = 'UU      M1      '
      diagMate  = diagNum + 2
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

      diagName  = 'DFyE'//diagSufx
      diagTitle = 'Meridional Diffusive Flux of '//locName
      diagCode  = 'VV      M1      '
      diagMate  = diagNum
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

C     effective snow thickness
      locName = 'eff snow thickn'
      WRITE(diagUnits,'(2A)') 'm',flxUnits
      diagSufx = SEAICE_DIAG_SUFX( GAD_SNOW, myThid )

C--   advective flux
      diagName  = 'ADVx'//diagSufx
      diagTitle = 'Zonal      Advective Flux of '//locName
      diagCode  = 'UU      M1      '
      diagMate  = diagNum + 2
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

      diagName  = 'ADVy'//diagSufx
      diagTitle = 'Meridional Advective Flux of '//locName
      diagCode  = 'VV      M1      '
      diagMate  = diagNum
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

C--   Diffusive flux:
      diagName  = 'DFxE'//diagSufx
      diagTitle = 'Zonal      Diffusive Flux of '//locName
      diagCode  = 'UU      M1      '
      diagMate  = diagNum + 2
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

      diagName  = 'DFyE'//diagSufx
      diagTitle = 'Meridional Diffusive Flux of '//locName
      diagCode  = 'VV      M1      '
      diagMate  = diagNum
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

C     sea ice salinity
      locName = 'seaice salinity'
      WRITE(diagUnits,'(2A)') 'g/kg',flxUnits
      diagSufx = SEAICE_DIAG_SUFX( GAD_SALT, myThid )

C--   advective flux
      diagName  = 'ADVx'//diagSufx
      diagTitle = 'Zonal      Advective Flux of '//locName
      diagCode  = 'UU      M1      '
      diagMate  = diagNum + 2
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

      diagName  = 'ADVy'//diagSufx
      diagTitle = 'Meridional Advective Flux of '//locName
      diagCode  = 'VV      M1      '
      diagMate  = diagNum
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

C--   Diffusive flux:
      diagName  = 'DFxE'//diagSufx
      diagTitle = 'Zonal      Diffusive Flux of '//locName
      diagCode  = 'UU      M1      '
      diagMate  = diagNum + 2
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

      diagName  = 'DFyE'//diagSufx
      diagTitle = 'Meridional Diffusive Flux of '//locName
      diagCode  = 'VV      M1      '
      diagMate  = diagNum
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

C--   effective thickness transport (centered in space, 1 time-step lag)
      diagName  = 'SIuheff '
      diagTitle = 'Zonal      Transport of eff ice thickn (centered)'
      diagUnits = 'm^2/s           '
      diagCode  = 'UU      M1      '
      diagMate  = diagNum + 2
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

      diagName  = 'SIvheff '
      diagTitle = 'Meridional Transport of eff ice thickn (centered)'
      diagUnits = 'm^2/s           '
      diagCode  = 'VV      M1      '
      diagMate  = diagNum
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

C=============== dynamics ============

      diagName  = 'SIpress '
      diagTitle = 'SEAICE strength (with upper and lower limit)'
      diagUnits = 'N/m             '
      diagCode  = 'SM      M1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I    diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'SIzeta  '
      diagTitle = 'SEAICE nonlinear bulk viscosity'
      diagUnits = 'kg/s            '
      diagCode  = 'SM      M1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I    diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'SIeta   '
      diagTitle = 'SEAICE nonlinear shear viscosity'
      diagUnits = 'kg/s            '
      diagCode  = 'SM      M1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'SIsig1  '
      diagTitle = 'SEAICE normalized principle stress, component one'
      diagUnits = 'no units        '
      diagCode  = 'SM      M1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'SIsig2  '
      diagTitle = 'SEAICE normalized principle stress, component two'
      diagUnits = 'no units        '
      diagCode  = 'SM      M1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'SIshear '
      diagTitle = 'SEAICE shear deformation rate'
      diagUnits = '1/s             '
      diagCode  = 'SM      M1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'SIdelta '
      diagTitle = 'SEAICE Delta deformation rate'
      diagUnits = '1/s             '
      diagCode  = 'SM      M1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'SItensil'
      diagTitle = 'SEAICE maximal tensile strength'
      diagUnits = 'N/m             '
      diagCode  = 'SM      M1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I    diagName, diagCode, diagUnits, diagTitle, 0, myThid )

C=============== numerics ============

      diagName  = 'SIlsrRe '
      diagTitle = 'SEAICE LSR residual norm'
      diagUnits = 'N/m             '
      diagCode  = 'SM      M1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I    diagName, diagCode, diagUnits, diagTitle, 0, myThid )

#ifdef SEAICE_ITD
C=============== ice thickness categories ============

      diagName  = 'SIheffN '
      diagTitle = 'SEAICE effective ice thickness per category'
      diagUnits = 'm               '
      diagCode  = 'SM      MX      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )
      CALL DIAGNOSTICS_SETKLEV( diagName, nITD, myThid )

      diagName  = 'SIareaN '
      diagTitle =
     I 'SEAICE fractional ice-covered area per category [0 to 1]'
      diagUnits = 'm^2/m^2         '
      diagCode  = 'SM      MX      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )
      CALL DIAGNOSTICS_SETKLEV( diagName, nITD, myThid )

      diagName  = 'SIhsnowN'
      diagTitle = 'SEAICE effective snow thickness per category'
      diagUnits = 'm               '
      diagCode  = 'SM      MX      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )
      CALL DIAGNOSTICS_SETKLEV( diagName, nITD, myThid )
#endif

#ifdef ALLOW_AUTODIFF
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C     Adjoint state variables
      diagName  = 'ADJarea '
      diagTitle = 'dJ/darea: Sensitivity to seaice fractional ice-cover'
      diagUnits = 'dJ/(m^2/m^2)    '
      diagCode  = 'SM A    M1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'ADJheff '
      diagTitle = 'dJ/dheff: Sensitvity to seaice ice thickness'
      diagUnits = 'dJ/dm           '
      diagCode  = 'SM A    M1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'ADJhsnow'
      diagTitle = 'dJ/dhsnow: Sensitivity to seaice snow thickness'
      diagUnits = 'dJ/dm           '
      diagCode  = 'SM A    M1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'ADJuice '
      diagTitle = 'dJ/duice: sensitivity to zonal ice velocity'
      diagUnits = 'dJ/(m/s)        '
#ifdef SEAICE_CGRID
      diagCode  = 'UU A    M1      '
#else
      diagCode  = 'UZ A    M1      '
#endif
      diagMate  = diagNum + 2
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I   diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

      diagName  = 'ADJvice '
      diagTitle = 'dJ/dvice: sensitivity to meridional ice velocity'
      diagUnits = 'dJ/(m/s)        '
#ifdef SEAICE_CGRID
      diagCode  = 'VV A    M1      '
#else
      diagCode  = 'VZ A    M1      '
#endif
      diagMate  = diagNum
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I   diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )
#endif /* ALLOW_AUTODIFF */
#endif /* ALLOW_DIAGNOSTICS */

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 0
C     !ROUTINE: SEAICE_DIAG_SUFX

C     !INTERFACE:
      CHARACTER*4 FUNCTION SEAICE_DIAG_SUFX( tracerId, myThid )

C     !DESCRIPTION:
C     *==========================================================*
C     | FUNCTION SEAICE_DIAG_SUFX
C     | o Return diagnostic suffix (4 character long) for the
C     |   "tracerId" tracer (used to build diagnostic names).
C     *==========================================================*

C     !USES:
      IMPLICIT NONE
#include "EEPARAMS.h"
#include "SEAICE_SIZE.h"
#include "SEAICE_PARAMS.h"

C     !INPUT PARAMETERS:
C     tracerId   ::  tracer identifier
C     myThid     ::  my thread Id number
      INTEGER      tracerId
      INTEGER      myThid
CEOP

C     !LOCAL VARIABLES:

C--   Set diagnostic suffix (4 character long) for the "tracerId" tracer
      IF ( tracerId.EQ.GAD_HEFF ) THEN
        SEAICE_DIAG_SUFX = 'HEFF'
      ELSEIF( tracerId.EQ.GAD_AREA ) THEN
        SEAICE_DIAG_SUFX = 'AREA'
      ELSEIF( tracerId.EQ.GAD_SNOW ) THEN
        SEAICE_DIAG_SUFX = 'SNOW'
      ELSEIF( tracerId.EQ.GAD_SALT ) THEN
        SEAICE_DIAG_SUFX = 'SSLT'
      ELSE
        SEAICE_DIAG_SUFX = 'aaaa'
      ENDIF

      RETURN
      END

#include "AIM_OPTIONS.h"

CBOP
C     !ROUTINE: SUFLUX_OCEAN
C     !INTERFACE:
      SUBROUTINE SUFLUX_OCEAN(
     I                   PSA, FMASK,
     I                   Tsurf, SSR, SLRD,
     I                   T1, T0, Q0, DENVV,
     O                   SHF, EVAP, SLRU,
     I                   bi,bj,myThid)

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R SUFLUX_OCEAN
C     | o compute surface flux over ocean
C     *==========================================================*
C     | o contains part of original S/R SUFLUX (Speedy code)
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     Resolution parameters

C-- size for MITgcm & Physics package :
#include "AIM_SIZE.h"
#include "EEPARAMS.h"

C     Physical constants + functions of sigma and latitude
#include "com_physcon.h"

C     Surface flux constants
#include "com_sflcon.h"

C     == Routine Arguments ==
C--   Input:
C    FMASK  :: fractional land-sea mask        (2-dim)
C    Tsurf  :: surface temperature        (2-dim)
C    SSR    :: sfc sw radiation (net flux)     (2-dim)
C    SLRD   :: sfc lw radiation (downward flux)(2-dim)
C    T1     :: near-surface air temperature (from Pot.temp)
C    T0     :: near-surface air temperature    (2-dim)
C    Q0     :: near-surface sp. humidity [g/kg](2-dim)
C    DENVV  :: surface flux (sens,lat.) coeff. (=Rho*|V|) [kg/m2/s]
C--   Output:
C    SHF    :: sensible heat flux              (2-dim)
C    EVAP   :: evaporation [g/(m^2 s)]         (2-dim)
C    SLRU   :: sfc lw radiation (upward flux)  (2-dim)
C--   Input:
C    bi,bj  :: tile index
C    myThid :: Thread number for this instance of the routine
C--
      _RL  PSA(NGP)
      _RL  FMASK(NGP), Tsurf(NGP)
      _RL  SSR(NGP), SLRD(NGP) 
      _RL  T1(NGP), T0(NGP), Q0(NGP), DENVV(NGP)

      _RL  SHF(NGP), EVAP(NGP), SLRU(NGP)

      INTEGER bi,bj,myThid
CEOP

#ifdef ALLOW_AIM

C-- Local variables:
C    CDENVV :: surf. heat flux (sens.,lat.) coeff including stability effect
      _RL CDENVV(NGP), RDTH, FSSEA
      _RL QSAT0(NGP)
      _RL QDUMMY(1), RDUMMY(1), TS4
      INTEGER J

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C--   2. Computation of fluxes over land and sea

C     2.1 Wind stress

C     2.2 Sensible heat flux (from clim. TS over land)

C     Stability correction

      RDTH = FSTAB/DTHETA

      DO J=1,NGP
        FSSEA =1.+MIN(DTHETA,MAX(-DTHETA, Tsurf(J)-T1(J)))*RDTH
        CDENVV(J)=CHS*DENVV(J)*FSSEA
      ENDDO

      DO J=1,NGP
        SHF(J) = CDENVV(J)*CP*(Tsurf(J)-T0(J))
      ENDDO

C     2.3 Evaporation

      CALL SHTORH (0, NGP, Tsurf, PSA, 1. _d 0, QDUMMY, RDUMMY,
     &                QSAT0, myThid)

      DO J=1,NGP
        EVAP(J) = CDENVV(J)*(QSAT0(J)-Q0(J))
      ENDDO

C     2.4 Emission of lw radiation from the surface

      DO J=1,NGP
        TS4     = Tsurf(J)**4
        SLRU(J) = SBC*TS4
      ENDDO

C--   3. Adjustment of skin temperature and fluxes over land
C--      based on energy balance (to be implemented)
C        <= done separately for each surface type (land,sea,se-ice)

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
#endif /* ALLOW_AIM */

      RETURN
      END

#include "LONGSTEP_OPTIONS.h"

CBOP
C     !ROUTINE: LONGSTEP_THERMODYNAMICS
C     !INTERFACE:
      SUBROUTINE LONGSTEP_THERMODYNAMICS( myTime, myIter, myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE LONGSTEP_THERMODYNAMICS
C     | o Controlling routine for the prognostics of passive tracers
C     |   with longer time step.
C     *===========================================================
C     | This is a copy of THERMODYNAMICS, but only with the
C     | parts relevant to ptracers, and dynamics fields replaced
C     | by their longstep averages.
C     | When THERMODYNAMICS is changed, this routine probably has
C     | to be changed too :(
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     == Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "RESTART.h"
#include "DYNVARS.h"
#include "GRID.h"
#include "SURFACE.h"
#ifdef ALLOW_GENERIC_ADVDIFF
# include "GAD.h"
#endif
#include "LONGSTEP_PARAMS.h"
#include "LONGSTEP.h"
#ifdef ALLOW_PTRACERS
# include "PTRACERS_SIZE.h"
# include "PTRACERS_PARAMS.h"
# include "PTRACERS_FIELDS.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     myTime :: Current time in simulation
C     myIter :: Current iteration number in simulation
C     myThid :: Thread number for this instance of the routine.
      _RL myTime
      INTEGER myIter
      INTEGER myThid

#ifdef ALLOW_LONGSTEP
C     !LOCAL VARIABLES:
C     == Local variables
C     uFld,vFld,wFld :: Local copy of velocity field (3 components)
C     kappaRk        :: Total diffusion in vertical, all levels, 1 tracer
C     useVariableK   :: T when vertical diffusion is not constant
C     iMin, iMax     :: Ranges and sub-block indices on which calculations
C     jMin, jMax        are applied.
C     bi, bj         :: Tile indices
C     i, j, k        :: loop indices
      _RL uFld    (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL vFld    (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL wFld    (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL kappaRk (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RS recip_hFacNew(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      INTEGER iMin, iMax
      INTEGER jMin, jMax
      INTEGER bi, bj
      INTEGER i, j, k
CEOP

#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_ENTER('LONGSTEP_THERMODYNAMICS',myThid)
#endif

C     time for a ptracer time step?
      IF ( LS_doTimeStep ) THEN

      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)

C--   Set up work arrays with valid (i.e. not NaN) values
C     These inital values do not alter the numerical results. They
C     just ensure that all memory references are to valid floating
C     point numbers. This prevents spurious hardware signals due to
C     uninitialised but inert locations.

        DO k=1,Nr
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
C This is currently also used by IVDC and Diagnostics
           kappaRk(i,j,k)    = 0. _d 0
          ENDDO
         ENDDO
        ENDDO

C--     Compute new reciprocal hFac for implicit calculation
#ifdef NONLIN_FRSURF
        IF ( nonlinFreeSurf.GT.0 ) THEN
         IF ( select_rStar.GT.0 ) THEN
# ifndef DISABLE_RSTAR_CODE
          DO k=1,Nr
           DO j=1-OLy,sNy+OLy
            DO i=1-OLx,sNx+OLx
             recip_hFacNew(i,j,k) = recip_hFacC(i,j,k,bi,bj)
     &                            / rStarExpC(i,j,bi,bj)
            ENDDO
           ENDDO
          ENDDO
# endif /* DISABLE_RSTAR_CODE */
         ELSEIF ( selectSigmaCoord.NE.0 ) THEN
# ifndef DISABLE_SIGMA_CODE
          DO k=1,Nr
           DO j=1-OLy,sNy+OLy
            DO i=1-OLx,sNx+OLx
             recip_hFacNew(i,j,k) = recip_hFacC(i,j,k,bi,bj)
     &        /( 1. _d 0 + dEtaHdt(i,j,bi,bj)*deltaTFreeSurf
     &                    *dBHybSigF(k)*recip_drF(k)
     &                    *recip_hFacC(i,j,k,bi,bj)
     &         )
            ENDDO
           ENDDO
          ENDDO
# endif /* DISABLE_RSTAR_CODE */
         ELSE
          DO k=1,Nr
           DO j=1-OLy,sNy+OLy
            DO i=1-OLx,sNx+OLx
             IF ( k.EQ.kSurfC(i,j,bi,bj) ) THEN
              recip_hFacNew(i,j,k) = 1. _d 0 / hFac_surfC(i,j,bi,bj)
             ELSE
              recip_hFacNew(i,j,k) = recip_hFacC(i,j,k,bi,bj)
             ENDIF
            ENDDO
           ENDDO
          ENDDO
         ENDIF
        ELSE
#endif /* NONLIN_FRSURF */
          DO k=1,Nr
           DO j=1-OLy,sNy+OLy
            DO i=1-OLx,sNx+OLx
             recip_hFacNew(i,j,k) = _recip_hFacC(i,j,k,bi,bj)
            ENDDO
           ENDDO
          ENDDO
#ifdef NONLIN_FRSURF
        ENDIF
#endif /* NONLIN_FRSURF */

        iMin = 1-OLx
        iMax = sNx+OLx
        jMin = 1-OLy
        jMax = sNy+OLy

C     need to recompute surfaceForcingPtr using LS_fwFlux
        CALL LONGSTEP_FORCING_SURF(
     I        bi, bj, iMin, iMax, jMin, jMax,
     I        myTime,myIter,myThid )

C--   Set up 3-D velocity field that we use to advect tracers:
C-    just do a local copy:
        DO k=1,Nr
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           uFld(i,j,k) = LS_uVel(i,j,k,bi,bj)
           vFld(i,j,k) = LS_vVel(i,j,k,bi,bj)
           wFld(i,j,k) = LS_wVel(i,j,k,bi,bj)
          ENDDO
         ENDDO
        ENDDO
#ifdef ALLOW_GMREDI
C-    add Bolus velocity to Eulerian-mean velocity:
        IF (useGMRedi) THEN
          CALL  LONGSTEP_RESIDUAL_FLOW(
     U                  uFld, vFld, wFld,
     I                  bi, bj, myIter, myThid )
        ENDIF
#endif /* ALLOW_GMREDI */

#ifdef ALLOW_PTRACERS
C--     Calculate passive tracer tendencies
C       and step forward, storing result in gPtr
C       Also apply open boundary conditions for each passive tracer
        IF ( usePTRACERS ) THEN
#ifdef ALLOW_DEBUG
           IF (debugMode) CALL DEBUG_CALL('PTRACERS_INTEGRATE',myThid)
#endif
           CALL PTRACERS_INTEGRATE(
     I          bi, bj, recip_hFacNew,
     I          uFld, vFld, wFld,
     U          kappaRk,
     I          myTime, myIter, myThid )
        ENDIF
#endif /* ALLOW_PTRACERS */

C--   end bi,bj loops.
       ENDDO
      ENDDO

#ifdef ALLOW_DEBUG
      IF ( debugLevel.GE.debLevD ) THEN
       CALL DEBUG_STATS_RL(Nr,LS_uVel,'LS_Uvel (THERMODYNAMICS)',myThid)
       CALL DEBUG_STATS_RL(Nr,LS_vVel,'LS_Vvel (THERMODYNAMICS)',myThid)
       CALL DEBUG_STATS_RL(Nr,LS_wVel,'LS_Wvel (THERMODYNAMICS)',myThid)
       CALL DEBUG_STATS_RL(Nr,LS_theta,'LS_Theta (THERMODYNAMICS)',
     &                     myThid)
       CALL DEBUG_STATS_RL(Nr,LS_salt,'LS_Salt (THERMODYNAMICS)',myThid)
#ifdef ALLOW_PTRACERS
       IF ( usePTRACERS ) THEN
         CALL PTRACERS_DEBUG(myThid)
       ENDIF
#endif /* ALLOW_PTRACERS */
      ENDIF
#endif /* ALLOW_DEBUG */

C     LS_doTimeStep
      ENDIF

#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_LEAVE('LONGSTEP_THERMODYNAMICS',myThid)
#endif

#endif /* ALLOW_LONGSTEP */

      RETURN
      END

#include "MOM_COMMON_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: MOM_CALC_3D_STRAIN

C     !INTERFACE:
      SUBROUTINE MOM_CALC_3D_STRAIN(
     O        str11, str22, str33, str12, str13, str23,
     I        bi, bj, myThid )

C     !DESCRIPTION:
C     Calculates the strain tensor of the 3-D flow field

C     !USES:
      IMPLICIT NONE

C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "DYNVARS.h"

C     !INPUT PARAMETERS:
C     bi, bj      :: tile indices
C     myThid      :: my Thread Id number
      INTEGER bi, bj
      INTEGER myThid

C     !OUTPUT PARAMETERS:
C     str11       :: strain component Vxx @ grid-cell center
C     str22       :: strain component Vyy @ grid-cell center
C     str33       :: strain component Vzz @ grid-cell center
C     str12       :: strain component Vxy @ grid-cell corner
C     str13       :: strain component Vxz @ above uVel
C     str23       :: strain component Vyz @ above vVel
      _RL str11(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL str22(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL str33(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL str12(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL str13(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr+1)
      _RL str23(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr+1)

#ifdef ALLOW_SMAG_3D
C     !LOCAL VARIABLES:
C      i, j, k    :: loop indices
      INTEGER i, j, k
      INTEGER kp1
      _RL maskp1
      LOGICAL freeSlip3d
CEOP
      freeSlip3d = .NOT.( no_slip_sides .AND. no_slip_bottom )

      DO k=1,Nr
       kp1 = MIN(k+1,Nr)
       maskp1 = oneRL
       IF ( k.EQ.Nr ) maskp1 = zeroRL

C-    Fills up array edges:
       i = sNx+OLx
       DO j=1-OLy,sNy+OLy
         str11(i,j,k) = 0. _d 0
       ENDDO
       j = sNy+OLy
       DO i=1-OLx,sNx+OLx
         str22(i,j,k) = 0. _d 0
       ENDDO
       i = 1-OLx
       DO j=1-OLy,sNy+OLy
         str12(i,j,k) = 0. _d 0
         str13(i,j,k) = 0. _d 0
       ENDDO
       j = 1-OLy
       DO i=1-OLx,sNx+OLx
         str12(i,j,k) = 0. _d 0
         str23(i,j,k) = 0. _d 0
       ENDDO

C     str11 = u_x
       DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx-1
          str11(i,j,k) = recip_dxF(i,j,bi,bj)
     &           *( uVel(i+1, j , k ,bi,bj)-uVel( i , j , k ,bi,bj) )
        ENDDO
       ENDDO

C     str22 = v_y
       DO j=1-OLy,sNy+OLy-1
        DO i=1-OLx,sNx+OLx
          str22(i,j,k) = recip_dyF(i,j,bi,bj)
     &           *( vVel( i ,j+1, k ,bi,bj)-vVel( i , j , k ,bi,bj) )
        ENDDO
       ENDDO

C     str33 = w_z
       DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
          str33(i,j,k) = recip_drF(k)*rkSign
     &    *( maskp1*wVel( i , j ,kp1,bi,bj)-wVel( i , j , k ,bi,bj) )
        ENDDO
       ENDDO

C     str12 = ( u_y + v_x )/2
       DO j=2-OLy,sNy+OLy
        DO i=2-OLx,sNx+OLx
          str12(i,j,k) = halfRL*(
     &      recip_dyU(i,j,bi,bj)
     &           *( uVel( i , j , k ,bi,bj)-uVel( i ,j-1, k ,bi,bj) )
     &     +recip_dxV(i,j,bi,bj)
     &           *( vVel( i , j , k ,bi,bj)-vVel(i-1, j , k ,bi,bj) )
     &                          )
        ENDDO
       ENDDO

C     str13 & str23 special case: k=1
       IF ( k.EQ.1 .AND. freeSlip3d ) THEN
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          str13(i,j,k) = 0. _d 0
          str23(i,j,k) = 0. _d 0
         ENDDO
        ENDDO
       ELSEIF ( k.EQ.1 ) THEN
C--    should put surface wind-stress if z-coords; but right in p-coords:
        DO j=1-OLy,sNy+OLy
         DO i=2-OLx,sNx+OLx
          str13(i,j,k) = halfRL*(
     &      recip_drC(k)*rkSign
     &           *( uVel( i , j , k ,bi,bj)*twoRL )
     &     +recip_dxC(i,j,bi,bj)
     &           *( wVel( i , j , k ,bi,bj)-wVel(i-1, j , k ,bi,bj) )
     &                          )
         ENDDO
        ENDDO
        DO j=2-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          str23(i,j,k) = halfRL*(
     &      recip_drC(k)*rkSign
     &           *( vVel( i , j , k ,bi,bj)*twoRL )
     &     +recip_dyC(i,j,bi,bj)
     &           *( wVel( i , j , k ,bi,bj)-wVel( i ,j-1, k ,bi,bj) )
     &                          )
         ENDDO
        ENDDO
       ELSE
C     str13 = ( u_z + w_x )/2
        DO j=1-OLy,sNy+OLy
         DO i=2-OLx,sNx+OLx
          str13(i,j,k) = halfRL*(
     &      recip_drC(k)*rkSign
     &           *( uVel( i , j , k ,bi,bj)-uVel( i , j ,k-1 ,bi,bj) )
     &     +recip_dxC(i,j,bi,bj)
     &           *( wVel( i , j , k ,bi,bj)-wVel(i-1, j , k ,bi,bj) )
     &                          )
         ENDDO
        ENDDO
C     str23 = ( v_z + w_y )/2
        DO j=2-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          str23(i,j,k) = halfRL*(
     &      recip_drC(k)*rkSign
     &           *( vVel( i , j , k ,bi,bj)-vVel( i , j ,k-1,bi,bj) )
     &     +recip_dyC(i,j,bi,bj)
     &           *( wVel( i , j , k ,bi,bj)-wVel( i ,j-1, k ,bi,bj) )
     &                          )
         ENDDO
        ENDDO
       ENDIF

       IF ( freeSlip3d ) THEN
        DO j=2-OLy,sNy+OLy
         DO i=2-OLx,sNx+OLx
           str12(i,j,k) = str12(i,j,k)
     &                  *maskW(i,j-1,k,bi,bj)*maskW(i,j,k,bi,bj)
         ENDDO
        ENDDO
        IF ( k.GE.2 ) THEN
         DO j=1-OLy,sNy+OLy
          DO i=2-OLx,sNx+OLx
           str13(i,j,k) = str13(i,j,k)
     &                  *maskW(i,j,k-1,bi,bj)*maskW(i,j,k,bi,bj)
          ENDDO
         ENDDO
         DO j=2-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           str23(i,j,k) = str23(i,j,k)
     &                  *maskS(i,j,k-1,bi,bj)*maskS(i,j,k,bi,bj)
          ENDDO
         ENDDO
        ENDIF
       ENDIF

C--   end k loop
      ENDDO

C--   fill-up strain tensor component at the very bottom (k=Nr+1)
      k = Nr+1

      DO j=1-OLy,sNy+OLy
       DO i=1-OLx,sNx+OLx
         str13(i,j,k) = 0. _d 0
         str23(i,j,k) = 0. _d 0
       ENDDO
      ENDDO

      IF ( .NOT.freeSlip3d ) THEN

C     str13 = ( u_z + w_x )/2
       DO j=1-OLy,sNy+OLy
        DO i=2-OLx,sNx+OLx
          str13(i,j,k) =
     &         recip_drF(Nr)*rkSign
c    &      recip_drC(k)*rkSign
     &            *( 0. _d 0 - uVel( i , j ,k-1 ,bi,bj) )
        ENDDO
       ENDDO

C     str23 = ( v_z + w_y )/2
       DO j=2-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
        str23(i,j,k) =
     &         recip_drF(Nr)*rkSign
c    &      recip_drC(k)*rkSign
     &            *( 0. _d 0 - vVel( i , j ,k-1,bi,bj) )
        ENDDO
       ENDDO

      ENDIF

C     Special stuff for Cubed Sphere
c     IF (useCubedSphereExchange) THEN
c      STOP 'S/R MOM_CALC_3D_STRAIN: should not be used on the cube!'
c     ENDIF

#endif /* ALLOW_SMAG_3D */
      RETURN
      END

#include "CHEAPAML_OPTIONS.h"
CBOP
C     !ROUTINE: CHEAPAML_DIAGNOSTICS_INIT
C     !INTERFACE:
      SUBROUTINE CHEAPAML_DIAGNOSTICS_INIT( myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE CHEAPAML_DIAGNOSTICS_INIT
C     | o Routine to initialize list of all available diagnostics
C     |   for CHEAPAML package
C     *==========================================================*
C     \ev
C     !USES:
      IMPLICIT NONE

C     === Global variables ===
#include "EEPARAMS.h"
#include "SIZE.h"
#include "PARAMS.h"
#include "CHEAPAML.h"

C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
C     myThid ::  my Thread Id number
      INTEGER myThid
CEOP

#ifdef ALLOW_DIAGNOSTICS
C     !LOCAL VARIABLES:
C     === Local variables ===
C     diagNum   :: diagnostics number in the (long) list of available diag.
C     diagMate  :: diag. mate number in the (long) list of available diag.
C     diagName  :: local short name (8c) of a diagnostics
C     diagCode  :: local parser field with characteristics of the diagnostics
C              cf head of S/R DIAGNOSTICS_INIT_EARLY or DIAGNOSTICS_MAIN_INIT
C     diagUnits :: local string (16c): physical units of a diagnostic field
C     diagTitle :: local string (80c): description of field in diagnostic
      INTEGER       diagNum
      INTEGER       diagMate
      CHARACTER*8   diagName
      CHARACTER*16  diagCode
      CHARACTER*16  diagUnits
      CHARACTER*(80) diagTitle

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      diagName  = 'CH_TAIR '
      diagTitle = 'cheapAML Surface Air Temp'
      diagUnits = 'degres C        '
      diagCode  = 'SM      L1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I            diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'CH_QNET '
      diagTitle = 'cheapAML Surface heating '
      diagUnits = 'W/m2            '
      diagCode  = 'SM      L1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I            diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'CH_QAIR '
      diagTitle = 'cheapAML Specific Humidity'
      diagUnits = 'kg/kg           '
      diagCode  = 'SM      L1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I            diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'CH_EmP  '
      diagTitle = 'cheapAML Evap-Precip     '
      diagUnits = 'kg/m2/s         '
      diagCode  = 'SM      L1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I            diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'CH_Trace'
      diagTitle = 'cheapAML Passive Tracer  '
      diagUnits = 'Depend on Tracer'
      diagCode  = 'SM      L1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I            diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'CH_Uwind'
      diagTitle = 'cheapAML Zonal Wind      '
      diagUnits = 'm/s           '
      diagCode  = 'UU      L1      '
      diagmate  = diagNum + 2
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I      diagName, diagCode, diagUnits, diagTitle, diagmate, myThid )

      diagName  = 'CH_Vwind'
      diagTitle = 'cheapAML Meridional Wind '
      diagUnits = 'm/s             '
      diagCode  = 'VV      L1      '
      diagmate  = diagNum
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I      diagName, diagCode, diagUnits, diagTitle, diagmate, myThid )

      diagName  = 'CH_LH   '
      diagTitle = 'cheapAML latent heat     '
      diagUnits = 'W/m2            '
      diagCode  = 'SM      L1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I            diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'CH_SH   '
      diagTitle = 'cheapAML sensible heat   '
      diagUnits = 'W/m2            '
      diagCode  = 'SM      L1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I            diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'CH_Prec '
      diagTitle = 'cheapAML precipitation   '
      diagUnits = 'kg/m2/s         '
      diagCode  = 'SM      L1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I            diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'CH_q100 '
      diagTitle = 'cheapAML upper Specific Humidity'
      diagUnits = 'kg/kg           '
      diagCode  = 'SM      L1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I            diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'CH_ssqt '
      diagTitle = 'cheapAML surf sat Specific Humid.'
      diagUnits = 'kg/kg           '
      diagCode  = 'SM      L1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I            diagName, diagCode, diagUnits, diagTitle, 0, myThid )

#endif /* ALLOW_DIAGNOSTICS */

      RETURN
      END

#include "SHAP_FILT_OPTIONS.h"

CBOP
C     !ROUTINE: SHAP_FILT_TRACER_S2
C     !INTERFACE:
      SUBROUTINE SHAP_FILT_TRACER_S2(
     U           field, tmpFld,
     I           nShapTr, exchInOut, kSize,
     I           myTime, myIter, myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R SHAP_FILT_TRACER_S2
C     | o Applies Shapiro filter to 2D field (cell center).
C     | o use filtering function "S2" = [1 - (d_xx+d_yy)^n]
C     | o Options for computational filter (no grid spacing)
C     |   or physical space filter (with grid spacing) or both.
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     == Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "SHAP_FILT.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments
C     field     :: cell-centered 2D field on which filter applies
C     tmpFld    :: working temporary array
C     nShapTr   :: (total) power of the filter for this tracer
C     exchInOut :: apply Exchanges to fill overlap region:
C            = 0 : do not apply Exch on neither input nor output field
C            = 1 : apply Exch on input field
C                  (needed if input field has invalid overlap)
C            = 2 : apply Exch on output field (after the filter)
C            = 3 : apply Exch on both input & output field
C     kSize     :: length of 3rd Dim : either =1 (2D field) or =Nr (3D field)
C     myTime    :: Current time in simulation
C     myIter    :: Current iteration number in simulation
C     myThid    :: Thread number for this instance of SHAP_FILT_TRACER_S2
      INTEGER kSize
      _RL field(1-OLx:sNx+OLx,1-OLy:sNy+OLy,kSize,nSx,nSy)
      _RL tmpFld(1-OLx:sNx+OLx,1-OLy:sNy+OLy,kSize,nSx,nSy)
      INTEGER nShapTr, exchInOut
      _RL     myTime
      INTEGER myIter
      INTEGER myThid

#ifdef ALLOW_SHAP_FILT

C     !LOCAL VARIABLES:
C     == Local variables ==
      INTEGER nShapComput
      INTEGER bi,bj,k,i,j,n
      _RL tmpGrd(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL tmpFdx(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL tmpFdy(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
CEOP

      IF ( exchInOut.LT.0 .OR. exchInOut.GT.3 ) THEN
         STOP 'S/R SHAP_FILT_TRACER_S2: exchInOut is wrong'
      ENDIF

      IF (nShapTr.GT.0) THEN
C-------
C  Apply computational filter ^(nShap-nShapPhys) without grid factor
C  then apply Physical filter ^nShapPhys  with grid factors
C-------
        nShapComput = nShapTr - nShapTrPhys

        DO bj=myByLo(myThid),myByHi(myThid)
         DO bi=myBxLo(myThid),myBxHi(myThid)
          DO k=1,kSize
           DO j=1-OLy,sNy+OLy
            DO i=1-OLx,sNx+OLx
             tmpFld(i,j,k,bi,bj)=field(i,j,k,bi,bj)
            ENDDO
           ENDDO
          ENDDO
         ENDDO
        ENDDO

C      ( d_xx +d_yy )^n tmpFld

       DO n=1,nShapTr

        IF ( ( MOD(n,2).EQ.1 .OR. Shap_alwaysExchTr ) .AND.
     &       ( n.GE.2 .OR. MOD(exchInOut,2).EQ.1 )  ) THEN
         IF (kSize.EQ.Nr) THEN
          _EXCH_XYZ_RL( tmpFld, myThid )
         ELSEIF (kSize.EQ.1) THEN
          _EXCH_XY_RL( tmpFld, myThid )
         ELSE
          STOP 'S/R SHAP_FILT_TRACER_S2: kSize is wrong'
         ENDIF
        ENDIF

        DO bj=myByLo(myThid),myByHi(myThid)
         DO bi=myBxLo(myThid),myBxHi(myThid)
          DO k=1,kSize

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C--        Calculate gradient in X direction:
#ifndef ALLOW_AUTODIFF
           IF ( .NOT.Shap_alwaysExchTr
     &          .AND. useCubedSphereExchange ) THEN
C          to compute d/dx(tmpFld), fill corners with appropriate values:
             CALL FILL_CS_CORNER_TR_RL( 1, .FALSE.,
     &                                 tmpFld(1-OLx,1-OLy,k,bi,bj),
     &                                 bi,bj, myThid )
           ENDIF
#endif
           IF ( n.LE.nShapComput ) THEN
C-         Computational space: del_i
             DO j=0,sNy+1
              DO i=0,sNx+2
               tmpFdx(i,j) =
     &            ( tmpFld(i,j,k,bi,bj)-tmpFld(i-1,j,k,bi,bj) )
     &                     *_maskW(i,j,k,bi,bj)
              ENDDO
             ENDDO
           ELSE
C-         Physical space: grad_x
             DO j=0,sNy+1
              DO i=0,sNx+2
               tmpFdx(i,j) =
     &            ( tmpFld(i,j,k,bi,bj)-tmpFld(i-1,j,k,bi,bj) )
     &                     *_hFacW(i,j,k,bi,bj)
     &                     *dyG(i,j,bi,bj)*recip_dxC(i,j,bi,bj)
              ENDDO
             ENDDO
           ENDIF

C--        Calculate gradient in Y direction:
#ifndef ALLOW_AUTODIFF
           IF ( .NOT.Shap_alwaysExchTr
     &          .AND. useCubedSphereExchange ) THEN
C          to compute d/dy(tmpFld), fill corners with appropriate values:
             CALL FILL_CS_CORNER_TR_RL( 2, .FALSE.,
     &                                 tmpFld(1-OLx,1-OLy,k,bi,bj),
     &                                 bi,bj, myThid )
           ENDIF
#endif
           IF ( n.LE.nShapComput ) THEN
C-         Computational space: del_j
             DO j=0,sNy+2
              DO i=0,sNx+1
               tmpFdy(i,j) =
     &            ( tmpFld(i,j,k,bi,bj)-tmpFld(i,j-1,k,bi,bj) )
     &                     *_maskS(i,j,k,bi,bj)
              ENDDO
             ENDDO
           ELSE
C-         Physical space: grad_y
             DO j=0,sNy+2
              DO i=0,sNx+1
               tmpFdy(i,j) =
     &            ( tmpFld(i,j,k,bi,bj)-tmpFld(i,j-1,k,bi,bj) )
     &                     *_hFacS(i,j,k,bi,bj)
     &                     *dxG(i,j,bi,bj)*recip_dyC(i,j,bi,bj)
              ENDDO
             ENDDO
           ENDIF

C--        Calculate (d_xx + d_yy) tmpFld :
           DO j=0,sNy+1
             DO i=0,sNx+1
               tmpGrd(i,j) = ( tmpFdx(i+1,j) - tmpFdx(i,j) )
     &                     + ( tmpFdy(i,j+1) - tmpFdy(i,j) )
             ENDDO
           ENDDO

C--        Computational space Filter
           IF ( n.LE.nShapComput ) THEN
             DO j=0,sNy+1
              DO i=0,sNx+1
               tmpFld(i,j,k,bi,bj) = -0.125*tmpGrd(i,j)
              ENDDO
             ENDDO
C--        Physical space Filter
           ELSEIF (Shap_TrLength.LE.0.) THEN
             DO j=0,sNy+1
              DO i=0,sNx+1
               tmpFld(i,j,k,bi,bj) = -0.125*tmpGrd(i,j)
     &             *recip_hFacC(i,j,k,bi,bj)
              ENDDO
             ENDDO
           ELSE
             DO j=0,sNy+1
              DO i=0,sNx+1
               tmpFld(i,j,k,bi,bj) = -0.125*tmpGrd(i,j)
     &             *recip_hFacC(i,j,k,bi,bj)*recip_rA(i,j,bi,bj)
     &             *Shap_TrLength*Shap_TrLength
              ENDDO
             ENDDO
           ENDIF
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C      end k,bi,bj loop:
          ENDDO
         ENDDO
        ENDDO
C      end loop n=1,nShapTr
       ENDDO

C      F <-  [1 - (d_xx+d_yy)^n *deltaT/tau].F
       DO bj=myByLo(myThid),myByHi(myThid)
        DO bi=myBxLo(myThid),myBxHi(myThid)
         DO k=1,kSize
          DO j=1,sNy
           DO i=1,sNx
            field(i,j,k,bi,bj)=field(i,j,k,bi,bj)
     &            -tmpFld(i,j,k,bi,bj)*dTtracerLev(1)/Shap_Trtau
            tmpFld(i,j,k,bi,bj)= -tmpFld(i,j,k,bi,bj)/Shap_Trtau
           ENDDO
          ENDDO
         ENDDO
        ENDDO
       ENDDO

       IF ( exchInOut.GE.2 ) THEN
        IF (kSize.EQ.Nr) THEN
          _EXCH_XYZ_RL( field, myThid )
        ELSEIF (kSize.EQ.1) THEN
          _EXCH_XY_RL( field, myThid )
        ELSE
          STOP 'S/R SHAP_FILT_TRACER_S2: kSize is wrong'
        ENDIF
       ENDIF

      ENDIF
#endif /* ALLOW_SHAP_FILT */

      RETURN
      END

      PROGRAM KNUDSEN2
      implicit none
C
C     COEFFICIENTS FOR DENSITY COMPUTATION
C
C     THIS PROGRAM CALCULATES THE COEFFICIENTS OF THE POLYNOMIAL
C     APPROXIMATION TO THE KNUDSEN FORMULA.  THE PROGRAM IS SET UP
C     TO YIELD COEFFICIENTS THAT WILL COMPUTE DENSITY AS A FUNCTION
C     OF POTENTIAL TEMPERATURE, SALINITY, AND DEPTH.
C
C     Number of levels
      integer NumLevels
      PARAMETER (NumLevels=15)

C     Number of Temperature and Salinity callocation points
      integer NumTempPt,NumSalPt,NumCallocPt
      PARAMETER (NumTempPt = 10, NumSalPt = 5 )
      PARAMETER (NumCallocPt =NumSalPt*NumTempPt )

C     Number of terms in fit polynomial
      integer NTerms
      PARAMETER (NTerms = 9 )

C     Functions (Density and Potential temperature)
      DOUBLE PRECISION DN
      DOUBLE PRECISION DUNESCO
      real POTEM
C
C     Arrays for least squares routine
      real A(NumCallocPt,NumCallocPt),
     &    B(NumCallocPt),
     &    X(NTerms),
     &    AB(13,NumLevels),
     &    C(NumCallocPt,NTerms),
     &    H(NTerms,NTerms),
     &    R(NumCallocPt*2),SB(NumCallocPt*4)

      real 
     &    Z(NumLevels),
     &    DZ(NumLevels)
      integer
     &    IDX(NumLevels)

      real 
     &    Theta(NumCallocPt),
     &    SPick(NumCallocPt),TPick(NumCallocPt),DenPick(NumCallocPt)

C     ENTER BOUNDS FOR POLYNOMIAL FIT:
C           TMin(K) = LOWER BND OF T AT Level K  (Insitu Temperature)
C           TMax(K) = UPPER BND OF T          "  (Insitu Temperature)
C           SMin(K) = LOWER BND OF S          "
C           SMax(K) = UPPER BND OF S          "

      real TMin(25), TMax(25)
     &    ,SMin(25), SMax(25)


      DATA TMin / 4*-2., 15*-1., 6*0.     /
      DATA TMax / 29., 19., 14., 11., 9., 7., 5., 3*4., 5*3., 10*2. /
      DATA SMin / 28.5, 33.7, 34., 34.1, 34.2, 34.4, 2*34.5,
     &    15*34.6, 2*34.7 /
      DATA SMax / 36.7, 36.6, 35.8, 35.7, 35.3, 2*35.1, 7*35.,
     &    9*34.9, 2*34.8 /

! Local
      integer I,J,K,IT,IEQ,IRANK,NDIM,NHDIM,N,M,IN,ITMAX,MP,L,NN
      real T,S,D,EPS,DeltaT,DeltaS,ENORM,DeltaDen,DensityRef
      real Tbar,Sbar,Tsum,SSum,TempInc,SalnInc
      real DensitySum,ThetaSum
      real DensityBar,thetabar,TempRef,SAlRef


C  ENTER LEVEL THICKNESSES IN CENTIMETERS  
C     DATA dz/ 4*50.E2, 2*100.E2, 200.E2, 400.E2, 7*500.E2, 6*10.E2 /
       DATA dz/   5.00e+03,7.00e+03,1.00e+04,1.40e+04,
     &1.90e+04,2.40e+04,2.90e+04,3.40e+04,3.90e+04,
     &4.40e+04,4.90e+04,5.40e+04,5.90e+04,6.40e+04,
     &6.90e+04/ ! ,6.90e+04/

C     CALC DEPTHS OF LEVELS FROM DZ (IN METERS)
C     THE MAXIMUM ALLOWABLE DEPTH IS 8000 METERS
      Z(1) = 0.             ! for level at box edges
      Z(1)=.5*DZ(1)/100.    ! for level at box center
      DO K=2,NumLevels
        Z(K)=Z(K-1)+.5*(DZ(K)+DZ(K-1))/100.
      ENDDO


C     Break the levels up into 250m bands
      DO  I=1,NumLevels
        IDX( I ) = I 
C       Comment out the next line to use input bands as polynomial levels
        IDX( I ) = IFIX(Z(I)/250.)+1  
      ENDDO


C     Write some diagnostics 
      PRINT 419
      PRINT 422,(Z(I),
     &    Tmin( IDX(I)),Tmax( IDX(I)),
     &    SMin(IDX(I)),Smax( IDX(I)),
CCC     &    TMin(I),TMax(I),SMin(I),SMax(I),
     &    (   IDX(I) ),I=1,NumLevels )


C     Loop over each level and calculate the polynomial coefficients

      DO MP=1,NumLevels

C     Choose callocation points
        TempInc =(Tmax( IDX(MP))-TMin(IDX(MP)))/(2.*FLOAT(NumSalPt)-1.0)
        SalnInc =(Smax( IDX(MP))-SMin(IDX(MP)))/(FLOAT(NumSalPt)-1.0)
        DO I=1,NumTempPt
          DO J=1,NumSalPt
            K=NumSalPt*I+J-NumSalPt
            TPick(K)=TMin(IDX(MP))+(FLOAT(I)-1.0)*TempInc
            SPick(K)=SMin(IDX(MP))+(FLOAT(J)-1.0)*SalnInc
          ENDDO
        ENDDO


C  For each callocation point, convert insitu temperature to
C  potential temperature and calculate the corresponding density.
        Tsum=0.0
        Ssum=0.0
        DensitySum=0.0
        ThetaSum=0.0
        DO K=1,NumCallocPt
          D=Z(MP)
          S=SPick(K)
          T=TPick(K)
C          DenPick(K)=DN(T,S,D)
          DenPick(K)=DUNESCO(T,S,D)
          Theta(K)=POTEM(T,S,D)
          Tsum=Tsum+TPick(K)
          Ssum=Ssum+SPick(K)
          DensitySum = DensitySum+DenPick(K)
          ThetaSum   = ThetaSum+Theta(K)
        ENDDO

C     Let (Tbar,Sbar) = the average of (T,S) used in the set of calloc pts
C     NOTE:  Tbar is still an insitu temperature
C     Also, calculate the average density of the set of callocation points

        Tbar=Tsum / FLOAT( NumCallocPt )
        Sbar=Ssum / FLOAT( NumCallocPt )
        DensityBar=DensitySum / FLOAT( NumCallocPt )

C     Calculate the average potential temperature of the callocation points
        ThetaBar=ThetaSum/ FLOAT( NumCallocPt )

C     Set the reference temperature, salinity and density
C        DensityRef=DN(Tbar,Sbar,D)
        DensityRef=DUNESCO(Tbar,Sbar,D)

        SalRef = Sbar

        TempRef=TBar
        TempRef=ThetaBar   ! DELETE THIS LINE IF USING IN SITU TEMPERATURES

C$$$        TempRef=POTEM(TBar,Sbar,D)


        AB(1,MP)=Z(MP)
        AB(2,MP)=DensityRef
        AB(3,MP)=TempRef
        AB(4,MP)=SalRef
        DO K=1,NumCallocPt
          TPick(K)=Theta(K)   ! DELETE THIS LINE IF USING IN SITU TEMPERATURES
          DeltaT   = TPick(K)   - TempRef
          DeltaS   = SPick(K)   - SalRef
          DeltaDen = DenPick(K) - DensityRef
          B(K)= DeltaDen
          A(K,1)=DeltaT
          A(K,2)=DeltaS
          A(K,3)=DeltaT*DeltaT
          A(K,4)=DeltaT*DeltaS
          A(K,5)=DeltaS*DeltaS
          A(K,6)=A(K,3)*DeltaT
          A(K,7)=A(K,4)*DeltaT
          A(K,8)=A(K,4)*DeltaS
          A(K,9)=A(K,5)*DeltaS
        ENDDO
C     SET THE ARGUMENTS IN CALL TO LSQSL2
C     FIRST DIMENSION OF ARRAY A
        NDIM=NumCallocPt
C     
C     NUMBER OF ROWS OF A
        M=NumCallocPt
C     
C     NUMBER OF COLUMNS OF A
        N=NTerms
C     OPTION NUMBER OF LSQSL2
        IN=1
C     
C     ITMAX=NUMBER OF ITERATIONS
        ITMAX=100
C     
        IT=0
        IEQ=2
        IRANK=0
        EPS=1.0E-7
        EPS=1.0E-11
        NHDIM=NTerms
        CALL LSQSL2(NDIM,A,M,N,B,X,IRANK,IN,ITMAX,IT,IEQ,ENORM,EPS,
     &      NHDIM,H,C,R,SB)

CCC   PRINT 411
        DO I=1,N
          AB(I+4,MP)=X(I)
        ENDDO
      ENDDO
      PRINT 430
  430 FORMAT(1X,'  Z    SIG0    T    S       X1          X2
     1    X3          X4          X5          X6          X7          X8
     2    X9     ',/)
      NN=N+4
ccc C************************************************************************
ccc C     WRITE TO UNIT 50
ccc C************************************************************************
ccc       OPEN(UNIT=50,FILE='KNUDSEN_COEFS.mit.h',STATUS='UNKNOWN')
ccc 
ccc C***      WRITE(50,613)
ccc 613   FORMAT('      REAL SIGREF(KM)')
ccc       ISEQ=114399990
ccc       DO  J=1,NumLevels
ccc         ISEQ=ISEQ+10
ccc C$$$        WRITE(50,615)J,.01*DZ(J)
ccc       ENDDO
ccc   615 FORMAT('      DZ(',I3,')=',F7.2,'E2')
ccc C$$$      WRITE(50,601)
ccc 601   FORMAT('C  REFERENCE DENSITIES AT T-POINTS'                )
ccc       ISEQ=114500030
ccc       DO J=1,NumLevels
ccc         ISEQ=ISEQ+10
ccc C$$$        WRITE(50,501)J,AB(2,J)
ccc       ENDDO
ccc 501   FORMAT('      SIGREF(',I3,')=',F8.4)
ccc 
ccc 
ccc       WRITE(50,'("      DATA SIGREF/")')
ccc 
ccc       N0 = 1
ccc c      DO ILINE = 1,NumLevels/5 -1
ccc 222   CONTINUE      
ccc         N1 = N0 + 4
ccc         N1 = MIN(N1, NumLevels)
ccc         WRITE(50,1280) (AB(2,I),I=N0,N1)
ccc         N0 = N1 + 1
ccc       IF ( N1 .LT. NumLevels ) GOTO 222
ccc C     N1 = N0 + 4
ccc C     IF( N1 .GT. NumLevels ) N1 = NumLevels
ccc       WRITE(50,1286) 
ccc 

C**********************************************************************

C MITgcmUV

      open(99,file='POLY3.COEFFS',form='formatted',status='unknown')
      write(99,*) NumLevels
      write(99,'(3(G20.13))') (ab(3,J),ab(4,J),ab(2,J),J=1 , NumLevels)
      do J=1,NumLevels
         write(99,'(3(G20.13))')(AB(I,J),I=5,13)
      enddo    
      close(99)

C**********************************************************************

c     PRINT 412,((AB(I,J),I=1,NN),J=1,NumLevels)

C     WRITE DATA STATEMENTS TO UNIT 50
caja  DO  L=1,NumLevels
caja    AB(2,L)=1.E-3*AB(2,L)
caja    AB(4,L)=1.E-3*AB(4,L)-.035
caja    AB(5,L)=1.E-3*AB(5,L)
caja    AB(7,L)=1.E-3*AB(7,L)
caja    AB(10,L)=1.E-3*AB(10,L)
caja    AB( 9,L)=1.E+3*AB( 9,L)
caja    AB(11,L)=1.E+3*AB(11,L)
caja    AB(13,L)=1.E+6*AB(13,L)
caja  ENDDO

C**********************************************************************

C MITgcm (compare01)

      open(99,file='polyeos.coeffs',form='formatted',status='unknown')
      do J=1,NumLevels
       write(99,*) ab(3,J)  ! ref temperature
      enddo    
      do J=1,NumLevels
       write(99,*) ab(4,J)  ! ref sal
      enddo    
      do J=1,NumLevels
       do I=5,13
        write(99,*) AB(I,J)
       enddo    
      enddo    
      do J=1,NumLevels
       write(99,*) ab(2,J)  ! ref sig0
      enddo    
CEK      write(99,200)(ab(3,J),J=11,15)  ! ref temperature
CEK      write(99,200)(ab(4,J),J= 1, 5)  ! ref sal
CEK      write(99,200)(ab(4,J),J= 6,10)  ! ref sal
CEK      write(99,200)(ab(4,J),J= 11,15) ! ref sal
CEK      do I=5,NN
CEK         write(99,200)(AB(I,J),J= 1, 5)
CEK         write(99,200)(AB(I,J),J= 6,10)
CEK         write(99,200)(AB(I,J),J=11,15)
CEK      enddo    
CEK      write(99,200)(AB(2,J),J= 1, 5)  ! ref sig0
CEK      write(99,200)(AB(2,J),J= 6,10)  ! ref sig0
CEK      write(99,200)(AB(2,J),J=11,15)  ! ref sig0
CEK  200 format(5(E14.7,1X))

C**********************************************************************



ccc       NSEQ=603800000
ccc       WRITE(50,1298)
ccc       N=0
ccc  1260 IS=N+1
ccc       IE=N+5
ccc       NSEQ=NSEQ+10
ccc       IF(IE.LT.NumLevels) THEN
ccc         WRITE(50,1280) (AB(3,I),I=IS,IE)
ccc         N=IE
ccc         GO TO 1260
ccc       ELSE
ccc         IE=NumLevels
ccc         N=IE-IS+1
ccc         GO TO (1261,1262,1263,1264,1265),N
ccc  1261     WRITE(50,1281) (AB(3,I),I=IS,IE)
ccc           GO TO 1268
ccc  1262     WRITE(50,1282) (AB(3,I),I=IS,IE)
ccc           GO TO 1268
ccc  1263     WRITE(50,1283) (AB(3,I),I=IS,IE)
ccc           GO TO 1268
ccc  1264     WRITE(50,1284) (AB(3,I),I=IS,IE)
ccc           GO TO 1268
ccc  1265     WRITE(50,1285) (AB(3,I),I=IS,IE)
ccc       ENDIF
ccc  1268 CONTINUE
ccc       NSEQ=603900000
ccc       WRITE(50,1297)
ccc       N=0
ccc  1270 IS=N+1
ccc       IE=N+5
ccc       NSEQ=NSEQ+10
ccc       IF(IE.LT.NumLevels) THEN
ccc         WRITE(50,1280) (AB(4,I),I=IS,IE)
ccc         N=IE
ccc         GO TO 1270
ccc       ELSE
ccc         IE=NumLevels
ccc         N=IE-IS+1
ccc         GO TO (1271,1272,1273,1274,1275),N
ccc  1271     WRITE(50,1281) (AB(4,I),I=IS,IE)
ccc           GO TO 1278
ccc  1272     WRITE(50,1282) (AB(4,I),I=IS,IE)
ccc           GO TO 1278
ccc  1273     WRITE(50,1283) (AB(4,I),I=IS,IE)
ccc           GO TO 1278
ccc  1274     WRITE(50,1284) (AB(4,I),I=IS,IE)
ccc           GO TO 1278
ccc  1275     WRITE(50,1285) (AB(4,I),I=IS,IE)
ccc       ENDIF
ccc  1278 CONTINUE
ccc       DO 1200 L=1,NumLevels
ccc       IF(L.EQ.1) NSEQ=604000000
ccc       WRITE(50,1296) L
ccc       NSEQ=NSEQ+10
ccc       WRITE(50,1295) (AB(I,L),I=5,8)
ccc       NSEQ=NSEQ+10
ccc       WRITE(50,1295) (AB(I,L),I=9,12)
ccc       NSEQ=NSEQ+10
ccc       WRITE(50,1294) AB(13,L)
ccc       NSEQ=NSEQ+10
ccc  1200 CONTINUE
ccc  1288 CONTINUE
 1298 FORMAT(18H      DATA TRef  /,67X,I9)
 1297 FORMAT(18H      DATA SRef  /,67X,I9)
C 419  FORMAT(5X,'LEVEL   TMIN      TMAX      SMIN      SMAX   ',
C     &          ' TMIN()  Tmax()   Smin()    Smax()  D/250')
C  422 FORMAT (5X,F6.1,4F10.3,4F10.3,I3)
  419 FORMAT(5X,'LEVEL   TMIN      TMAX      SMIN      SMAX  D/250')
  422 FORMAT (5X,F6.1,4F10.3,I3)
  412 FORMAT(1X,F6.1,F8.4,F7.3,F6.2,9E12.5)
 1296 FORMAT(6X,'DATA (C(',I2,',N),N=1,9)/',54X,I9)
 1295 FORMAT(5X,1H*,9X,4(E13.7,1H,),10X,I9)
 1294 FORMAT(5X,1H*,9X,E13.7,1H/,52X,I9)
 1280 FORMAT(5X,1H*,8X,5(F10.7,1H,),12X,I9)
 1281 FORMAT(5X,1H*,8X,F10.7,1H/,56X,I9)
 1282 FORMAT(5X,1H*,8X,F10.7,1H,,F10.7,1H/,45X,I9)
 1283 FORMAT(5X,1H*,8X,2(F10.7,1H,),F10.7,1H/,34X,I9)
 1284 FORMAT(5X,1H*,8X,3(F10.7,1H,),F10.7,1H/,23X,I9)
 1285 FORMAT(5X,1H*,8X,4(F10.7,1H,),F10.7,1H/,12X,I9)
 1286 FORMAT(5X,1H*,1H/)
  350 FORMAT(1X,E14.7)
  351 FORMAT(1H+,T86,E14.7/)
  400 FORMAT(1X,9E14.7)
  410 FORMAT(1X,5E14.7)
  411 FORMAT(///)
      STOP
      END
C****************************************************************************
*DECK LSQSL2
      SUBROUTINE LSQSL2 (NDIM,A,D,W,B,X,IRANK,IN,ITMAX,IT,IEQ,ENORM,EPS1
     1,NHDIM,H,AA,R,S)
      implicit none
C     THIS ROUTINE IS A MODIFICATION OF LSQSOL. MARCH,1968. R. HANSON.
C     LINEAR LEAST SQUARES SOLUTION
C
C     THIS ROUTINE FINDS X SUCH THAT THE EUCLIDEAN LENGTH OF
C     (*) AX-B IS A MINIMUM.
C
C     HERE A HAS K ROWS AND N COLUMNS, WHILE B IS A COLUMN VECTOR WITH
C     K COMPONENTS.
C
C     AN ORTHOGONAL MATRIX Q IS FOUND SO THAT QA IS ZERO BELOW
C     THE MAIN DIAGONAL.
C     SUPPOSE THAT RANK (A)=R
C     AN ORTHOGONAL MATRIX S IS FOUND SUCH THAT
C     QAS=T IS AN R X N UPPER TRIANGULAR MATRIX WHOSE LAST N-R COLUMNS
C     ARE ZERO.
C     THE SYSTEM TZ=C (C THE FIRST R COMPONENTS OF QB) IS THEN
C     SOLVED. WITH W=SZ, THE SOLUTION MAY BE EXPRESSED
C     AS X = W + SY, WHERE W IS THE SOLUTION OF (*) OF MINIMUM EUCLID-
C     EAN LENGTH AND Y IS ANY SOLUTION TO (QAS)Y=TY=0.
C
C     ITERATIVE IMPROVEMENTS ARE CALCULATED USING RESIDUALS AND
C     THE ABOVE PROCEDURES WITH B REPLACED BY B-AX, WHERE X IS AN
C     APPROXIMATE SOLUTION.
C
      integer ndim,nhdim
      DOUBLE PRECISION SJ,DP,DP1,UP,BP,AJ
      LOGICAL ERM
      INTEGER D,W
C
C     IN=1 FOR FIRST ENTRY.
C                   A IS DECOMPOSED AND SAVED. AX-B IS SOLVED.
C     IN = 2 FOR SUBSEQUENT ENTRIES WITH A NEW VECTOR B.
C     IN=3 TO RESTORE A FROM THE PREVIOUS ENTRY.
C     IN=4 TO CONTINUE THE ITERATIVE IMPROVEMENT FOR THIS SYSTEM.
C     IN = 5 TO CALCULATE SOLUTIONS TO AX=0, THEN STORE IN THE ARRAY H.
C     IN  =  6   DO NOT STORE A  IN AA.  OBTAIN  T = QAS, WHERE T IS
C     MIN(K,N) X MIN(K,N) AND UPPER TRIANGULAR. NOW RETURN.DO NOT OBTAIN
C     A SOLUTION.
C     NO SCALING OR COLUMN INTERCHANGES ARE PERFORMED.
C     IN  =  7   SAME AS WITH  IN = 6  EXCEPT THAT SOLN. OF MIN. LENGTH
C                IS PLACED INTO X. NO ITERATIVE REFINEMENT.  NOW RETURN.
C     COLUMN INTERCHANGES ARE PERFORMED. NO SCALING IS PERFORMED.
C     IN  = 8    SET ADDRESSES. NOW RETURN.
C
C     OPTIONS FOR COMPUTING  A MATRIX PRODUCT   Y*H  OR  H*Y ARE
C     AVAILABLE WITH THE USE OF THE ENTRY POINTS  MYH AND MHY.
C     USE OF THESE OPTIONS IN THESE ENTRY POINTS ALLOW A GREAT SAVING IN
C     STORAGE REQUIRED.
C
C
      real A(NDIM,NDIM),B(1),AA(D,W),S(1), X(1),H(NHDIM,NHDIM),R(1)
C     D = DEPTH OF MATRIX.
C     W = WIDTH OF MATRIX.
C----
      integer K,N,IT,ISW,L,M,IRANK,IEQ,IN,K1
      integer J1,J2,J3,J4,J5,J6,J7,J8,J9
      integer N1,N2,N3,N4,N5,N6,N7,N8,NS
      integer I,ITMAX,IPM1,II,LM,J,IP,KM,IPP1,IRP1,IRM1
      real SP,ENORM,TOP,TOP1,ENM1,TOP2,EPS1,EPS2,A1,A2,AM
C----
      K=D
      N=W
      ERM=.TRUE.
C
C     IF IT=0 ON ENTRY, THE POSSIBLE ERROR MESSAGE WILL BE SUPPRESSED.
C
      IF (IT.EQ.0) ERM=.FALSE.
C
C     IEQ = 2      IF COLUMN SCALING BY LEAST MAX. COLUMN LENGTH IS
C     TO BE PERFORMED.
C
C     IEQ = 1       IF SCALING OF ALL COMPONENTS IS TO BE DONE WITH
C     THE SCALAR MAX(ABS(AIJ))/K*N.
C
C     IEQ = 3 IF COLUMN SCALING AS WITH IN =2 WILL BE RETAINED IN
C     RANK DEFICIENT CASES.
C
C     THE ARRAY S MUST CONTAIN AT LEAST MAX(K,N) + 4N + 4MIN(K,N) CELLS
C        THE   ARRAY R MUST CONTAIN K+4N S.P. CELLS.
C
      DATA EPS2/1.E-16/
C     THE LAST CARD CONTROLS DESIRED RELATIVE ACCURACY.
C     EPS1  CONTROLS  (EPS) RANK.
C
      ISW=1
      L=MIN0(K,N)
      M=MAX0(K,N)
      J1=M
      J2=N+J1
      J3=J2+N
      J4=J3+L
      J5=J4+L
      J6=J5+L
      J7=J6+L
      J8=J7+N
      J9=J8+N
      LM=L
      IF (IRANK.GE.1.AND.IRANK.LE.L) LM=IRANK
      IF (IN.EQ.6) LM=L
      IF (IN.EQ.8) RETURN
C
C     RETURN AFTER SETTING ADDRESSES WHEN IN=8.
C
      GO TO (10,360,810,390,830,10,10), IN
C
C     EQUILIBRATE COLUMNS OF A (1)-(2).
C
C     (1)
C
   10 CONTINUE
C
C     SAVE DATA WHEN IN = 1.
C
      IF (IN.GT.5) GO TO 30
      DO 20 J=1,N
      DO 20 I=1,K
   20 AA(I,J)=A(I,J)
   30 CONTINUE
      IF (IEQ.EQ.1) GO TO 60
      DO 50 J=1,N
      AM=0.E0
      DO 40 I=1,K
   40 AM=AMAX1(AM,ABS(A(I,J)))
C
C      S(M+N+1)-S(M+2N) CONTAINS SCALING FOR OUTPUT VARIABLES.
C
      N2=J2+J
      IF (IN.EQ.6) AM=1.E0
      S(N2)=1.E0/AM
      DO 50 I=1,K
   50 A(I,J)=A(I,J)*S(N2)
      GO TO 100
   60 AM=0.E0
      DO 70 J=1,N
      DO 70 I=1,K
   70 AM=AMAX1(AM,ABS(A(I,J)))
      AM=AM/FLOAT(K*N)
      IF (IN.EQ.6) AM=1.E0
      DO 80 J=1,N
      N2=J2+J
   80 S(N2)=1.E0/AM
      DO 90 J=1,N
      N2=J2+J
      DO 90 I=1,K
   90 A(I,J)=A(I,J)*S(N2)
C     COMPUTE COLUMN LENGTHS WITH D.P. SUMS FINALLY ROUNDED TO S.P.
C
C     (2)
C
  100 DO 110 J=1,N
      N7=J7+J
      N2=J2+J
  110 S(N7)=S(N2)
C
C      S(M+1)-S(M+ N) CONTAINS VARIABLE PERMUTATIONS.
C
C     SET PERMUTATION TO IDENTITY.
C
      DO 120 J=1,N
      N1=J1+J
  120 S(N1)=J
C
C     BEGIN ELIMINATION ON THE MATRIX A WITH ORTHOGONAL MATRICES .
C
C     IP=PIVOT ROW
C
      DO 250 IP=1,LM
C
C
      DP=0.D0
      KM=IP
      DO 140 J=IP,N
      SJ=0.D0
      DO 130 I=IP,K
      SJ=SJ+A(I,J)**2
  130 CONTINUE
      IF (DP.GT.SJ) GO TO 140
      DP=SJ
      KM=J
      IF (IN.EQ.6) GO TO 160
  140 CONTINUE
C
C     MAXIMIZE (SIGMA)**2 BY COLUMN INTERCHANGE.
C
C      SUPRESS COLUMN INTERCHANGES WHEN IN=6.
C
C
C     EXCHANGE COLUMNS IF NECESSARY.
C
      IF (KM.EQ.IP) GO TO 160
      DO 150 I=1,K
      A1=A(I,IP)
      A(I,IP)=A(I,KM)
  150 A(I,KM)=A1
C
C     RECORD PERMUTATION AND EXCHANGE SQUARES OF COLUMN LENGTHS.
C
      N1=J1+KM
      A1=S(N1)
      N2=J1+IP
      S(N1)=S(N2)
      S(N2)=A1
      N7=J7+KM
      N8=J7+IP
      A1=S(N7)
      S(N7)=S(N8)
      S(N8)=A1
  160 IF (IP.EQ.1) GO TO 180
      A1=0.E0
      IPM1=IP-1
      DO 170 I=1,IPM1
      A1=A1+A(I,IP)**2
  170 CONTINUE
      IF (A1.GT.0.E0) GO TO 190
  180 IF (DP.GT.0.D0) GO TO 200
C
C     TEST FOR RANK DEFICIENCY.
C
  190 IF (DSQRT(DP/A1).GT.EPS1) GO TO 200
      IF (IN.EQ.6) GO TO 200
      II=IP-1
      IF (ERM) WRITE (6,1140) IRANK,EPS1,II,II
      IRANK=IP-1
      ERM=.FALSE.
      GO TO 260
C
C     (EPS1) RANK IS DEFICIENT.
C
  200 SP=DSQRT(DP)
C
C     BEGIN FRONT ELIMINATION ON COLUMN IP.
C
C     SP=SQROOT(SIGMA**2).
C
      BP=1.D0/(DP+SP*ABS(A(IP,IP)))
C
C     STORE BETA IN S(3N+1)-S(3N+L).
C
      IF (IP.EQ.K) BP=0.D0
      N3=K+2*N+IP
      R(N3)=BP
      UP=DSIGN(DBLE(SP)+ABS(A(IP,IP)),DBLE(A(IP,IP)))
      IF (IP.GE.K) GO TO 250
      IPP1=IP+1
      IF (IP.GE.N) GO TO 240
      DO 230 J=IPP1,N
      SJ=0.D0
      DO 210 I=IPP1,K
  210 SJ=SJ+A(I,J)*A(I,IP)
      SJ=SJ+UP*A(IP,J)
      SJ=BP*SJ
C
C     SJ=YJ NOW
C
      DO 220 I=IPP1,K
  220 A(I,J)=A(I,J)-A(I,IP)*SJ
  230 A(IP,J)=A(IP,J)-SJ*UP
  240 A(IP,IP)=-SIGN(SP,A(IP,IP))
C
      N4=K+3*N+IP
      R(N4)=UP
  250 CONTINUE
      IRANK=LM
  260 IRP1=IRANK+1
      IRM1=IRANK-1
      IF (IRANK.EQ.0.OR.IRANK.EQ.N) GO TO 360
      IF (IEQ.EQ.3) GO TO 290
C
C     BEGIN BACK PROCESSING FOR RANK DEFICIENCY CASE
C      IF IRANK IS LESS THAN N.
C
      DO 280 J=1,N
      N2=J2+J
      N7=J7+J
      L=MIN0(J,IRANK)
C
C     UNSCALE COLUMNS FOR RANK DEFICIENT MATRICES WHEN IEQ.NE.3.
C
      DO 270 I=1,L
  270 A(I,J)=A(I,J)/S(N7)
      S(N7)=1.E0
  280 S(N2)=1.E0
  290 IP=IRANK
  300 SJ=0.D0
      DO 310 J=IRP1,N
      SJ=SJ+A(IP,J)**2
  310 CONTINUE
      SJ=SJ+A(IP,IP)**2
      AJ=DSQRT(SJ)
      UP=DSIGN(AJ+ABS(A(IP,IP)),DBLE(A(IP,IP)))
C
C     IP TH ELEMENT OF U VECTOR CALCULATED.
C
      BP=1.D0/(SJ+ABS(A(IP,IP))*AJ)
C
C     BP = 2/LENGTH OF U SQUARED.
C
      IPM1=IP-1
      IF (IPM1.LE.0) GO TO 340
      DO 330 I=1,IPM1
      DP=A(I,IP)*UP
      DO 320 J=IRP1,N
      DP=DP+A(I,J)*A(IP,J)
  320 CONTINUE
      DP=DP/(SJ+ABS(A(IP,IP))*AJ)
C
C     CALC. (AJ,U), WHERE AJ=JTH ROW OF A
C
      A(I,IP)=A(I,IP)-UP*DP
C
C     MODIFY ARRAY A.
C
      DO 330 J=IRP1,N
  330 A(I,J)=A(I,J)-A(IP,J)*DP
  340 A(IP,IP)=-DSIGN(AJ,DBLE(A(IP,IP)))
C
C     CALC. MODIFIED PIVOT.
C
C
C     SAVE BETA AND IP TH ELEMENT OF U VECTOR IN R ARRAY.
C
      N6=K+IP
      N7=K+N+IP
      R(N6)=BP
      R(N7)=UP
C
C     TEST FOR END OF BACK PROCESSING.
C
      IF (IP-1) 360,360,350
  350 IP=IP-1
      GO TO 300
  360 IF (IN.EQ.6) RETURN
      DO 370 J=1,K
  370 R(J)=B(J)
      IT=0
C
C     SET INITIAL X VECTOR TO ZERO.
C
      DO 380 J=1,N
  380 X(J)=0.D0
      IF (IRANK.EQ.0) GO TO 690
C
C     APPLY Q TO RT. HAND SIDE.
C
  390 DO 430 IP=1,IRANK
      N4=K+3*N+IP
      SJ=R(N4)*R(IP)
      IPP1=IP+1
      IF (IPP1.GT.K) GO TO 410
      DO 400 I=IPP1,K
  400 SJ=SJ+A(I,IP)*R(I)
  410 N3=K+2*N+IP
      BP=R(N3)
      IF (IPP1.GT.K) GO TO 430
      DO 420 I=IPP1,K
  420 R(I)=R(I)-BP*A(I,IP)*SJ
  430 R(IP)=R(IP)-BP*R(N4)*SJ
      DO 440 J=1,IRANK
  440 S(J)=R(J)
      ENORM=0.E0
      IF (IRP1.GT.K) GO TO 510
      DO 450 J=IRP1,K
  450 ENORM=ENORM+R(J)**2
      ENORM=SQRT(ENORM)
      GO TO 510
  460 DO 480 J=1,N
      SJ=0.D0
      N1=J1+J
      IP=S(N1)
      DO 470 I=1,K
  470 SJ=SJ+R(I)*AA(I,IP)
C
C     APPLY AT TO RT. HAND SIDE.
C     APPLY SCALING.
C
      N7=J2+IP
      N1=K+N+J
  480 R(N1)=SJ*S(N7)
      N1=K+N
      S(1)=R(N1+1)/A(1,1)
      IF (N.EQ.1) GO TO 510
      DO 500 J=2,N
      N1=J-1
      SJ=0.D0
      DO 490 I=1,N1
  490 SJ=SJ+A(I,J)*S(I)
      N2=K+J+N
  500 S(J)=(R(N2)-SJ)/A(J,J)
C
C     ENTRY TO CONTINUE ITERATING.  SOLVES TZ = C = 1ST IRANK
C     COMPONENTS OF QB .
C
  510 S(IRANK)=S(IRANK)/A(IRANK,IRANK)
      IF (IRM1.EQ.0) GO TO 540
      DO 530 J=1,IRM1
      N1=IRANK-J
      N2=N1+1
      SJ=0.
      DO 520 I=N2,IRANK
  520 SJ=SJ+A(N1,I)*S(I)
  530 S(N1)=(S(N1)-SJ)/A(N1,N1)
C
C     Z CALCULATED.  COMPUTE X = SZ.
C
  540 IF (IRANK.EQ.N) GO TO 590
      DO 550 J=IRP1,N
  550 S(J)=0.E0
      DO 580 I=1,IRANK
      N7=K+N+I
      SJ=R(N7)*S(I)
      DO 560 J=IRP1,N
      SJ=SJ+A(I,J)*S(J)
  560 CONTINUE
      N6=K+I
      DO 570 J=IRP1,N
  570 S(J)=S(J)-A(I,J)*R(N6)*SJ
  580 S(I)=S(I)-R(N6)*R(N7)*SJ
C
C     INCREMENT FOR X OF MINIMAL LENGTH CALCULATED.
C
  590 DO 600 I=1,N
  600 X(I)=X(I)+S(I)
      IF (IN.EQ.7) GO TO 750
C
C     CALC. SUP NORM OF INCREMENT AND RESIDUALS
C
      TOP1=0.E0
      DO 610 J=1,N
      N2=J7+J
  610 TOP1=AMAX1(TOP1,ABS(S(J))*S(N2))
      DO 630 I=1,K
      SJ=0.D0
      DO 620 J=1,N
      N1=J1+J
      IP=S(N1)
      N7=J2+IP
  620 SJ=SJ+AA(I,IP)*X(J)*S(N7)
  630 R(I)=B(I)-SJ
      IF (ITMAX.LE.0) GO TO 750
C
C     CALC. SUP NORM OF X.
C
      TOP=0.E0
      DO 640 J=1,N
      N2=J7+J
  640 TOP=AMAX1(TOP,ABS(X(J))*S(N2))
C
C     COMPARE RELATIVE CHANGE IN X WITH TOLERANCE EPS .
C
      IF (TOP1-TOP*EPS2) 690,650,650
  650 IF (IT-ITMAX) 660,680,680
  660 IT=IT+1
      IF (IT.EQ.1) GO TO 670
      IF (TOP1.GT..25*TOP2) GO TO 690
  670 TOP2=TOP1
      GO TO (390,460), ISW
  680 IT=0
  690 SJ=0.D0
      DO 700 J=1,K
      SJ=SJ+R(J)**2
  700 CONTINUE
      ENORM=DSQRT(SJ)
      IF (IRANK.EQ.N.AND.ISW.EQ.1) GO TO 710
      GO TO 730
  710 ENM1=ENORM
C
C     SAVE X ARRAY.
C
      DO 720 J=1,N
      N1=K+J
  720 R(N1)=X(J)
      ISW=2
      IT=0
      GO TO 460
C
C     CHOOSE BEST SOLUTION
C
  730 IF (IRANK.LT.N) GO TO 750
      IF (ENORM.LE.ENM1) GO TO 750
      DO 740 J=1,N
      N1=K+J
  740 X(J)=R(N1)
      ENORM=ENM1
C
C     NORM OF AX - B LOCATED IN THE CELL ENORM .
C
C
C     REARRANGE VARIABLES.
C
  750 DO 760 J=1,N
      N1=J1+J
  760 S(J)=S(N1)
      DO 790 J=1,N
      DO 770 I=J,N
      IP=S(I)
      IF (J.EQ.IP) GO TO 780
  770 CONTINUE
  780 S(I)=S(J)
      S(J)=J
      SJ=X(J)
      X(J)=X(I)
  790 X(I)=SJ
C
C     SCALE VARIABLES.
C
      DO 800 J=1,N
      N2=J2+J
  800 X(J)=X(J)*S(N2)
      RETURN
C
C     RESTORE A.
C
  810 DO 820 J=1,N
      N2=J2+J
      DO 820 I=1,K
  820 A(I,J)=AA(I,J)
      RETURN
C
C     GENERATE SOLUTIONS TO THE HOMOGENEOUS EQUATION AX = 0.
C
  830 IF (IRANK.EQ.N) RETURN
      NS=N-IRANK
      DO 840 I=1,N
      DO 840 J=1,NS
  840 H(I,J)=0.E0
      DO 850 J=1,NS
      N2=IRANK+J
  850 H(N2,J)=1.E0
      IF (IRANK.EQ.0) RETURN
      DO 870 J=1,IRANK
      DO 870 I=1,NS
      N7=K+N+J
      SJ=R(N7)*H(J,I)
      DO 860 K1=IRP1,N
  860 SJ=SJ+H(K1,I)*A(J,K1)
      N6=K+J
      BP=R(N6)
      DP=BP*R(N7)*SJ
      A1=DP
      A2=DP-A1
      H(J,I)=H(J,I)-(A1+2.*A2)
      DO 870 K1=IRP1,N
      DP=BP*A(J,K1)*SJ
      A1=DP
      A2=DP-A1
  870 H(K1,I)=H(K1,I)-(A1+2.*A2)
C
C     REARRANGE ROWS OF SOLUTION MATRIX.
C
      DO 880 J=1,N
      N1=J1+J
  880 S(J)=S(N1)
      DO 910 J=1,N
      DO 890 I=J,N
      IP=S(I)
      IF (J.EQ.IP) GO TO 900
  890 CONTINUE
  900 S(I)=S(J)
      S(J)=J
      DO 910 K1=1,NS
      A1=H(J,K1)
      H(J,K1)=H(I,K1)
  910 H(I,K1)=A1
      RETURN
C
 1140 FORMAT (31H0WARNING. IRANK HAS BEEN SET TO,I4,6H  BUT(,1PE10.3,9H)
     1 RANK IS,I4,25H.  IRANK IS NOW TAKEN AS ,I4,1H.)
      END
      FUNCTION POTEM(T,S,P)
      implicit none
C     POTENTIAL TEMPERATURE FUNCTION
C     BASED ON FOFONOFF AND FROESE (1958) AS SHOWN IN "THE SEA" VOL. 1,
C     PAGE 17, TABLE IV
C     INPUT IS TEMPERATURE, SALINITY, PRESSURE (OR DEPTH)
C     UNITS ARE DEG.C., PPT, DBARS (OR METERS)
      real POTEM,T,S,P
      real B1,B2,B3,B4,B5,B6,B7,B8,B9,B10,B11
      real T2,T3,S2,P2
      B1=-1.60E-5*P
      B2=1.014E-5*P*T
      T2=T*T
      T3=T2*T
      B3=-1.27E-7*P*T2
      B4=2.7E-9*P*T3
      B5=1.322E-6*P*S
      B6=-2.62E-8*P*S*T
      S2=S*S
      P2=P*P
      B7=4.1E-9*P*S2
      B8=9.14E-9*P2
      B9=-2.77E-10*P2*T
      B10=9.5E-13*P2*T2
      B11=-1.557E-13*P2*P
      POTEM=B1+B2+B3+B4+B5+B6+B7+B8+B9+B10+B11
      POTEM=T-POTEM
      RETURN
      END
      FUNCTION DN(T,S,D)
      implicit none
      real T,S,D
      DOUBLE PRECISION DN,T3,S2,T2,S3,F1,F2,F3,FS,SIGMA,A,B1,B2,B,CO,
     1ALPHA,ALPSTD
      T2 = T*T
      T3= T2* T
      S2 = S*S
      S3 = S2 * S
      F1 = -(T-3.98)**2 * (T+283.)/(503.57*(T+67.26))
      F2 = T3*1.0843E-6 - T2*9.8185E-5 + T*4.786E-3
      F3 = T3*1.667E-8 - T2*8.164E-7 + T*1.803E-5
      FS= S3*6.76786136D-6 - S2*4.8249614D-4 + S*8.14876577D-1
      SIGMA= F1 + (FS+3.895414D-2)*(1.-F2+F3*(FS-.22584586D0))
      A= D*1.0E-4*(105.5+ T*9.50 - T2*0.158 - D*T*1.5E-4)  -
     1(227. + T*28.33 - T2*0.551 + T3* 0.004)
      B1 = (FS-28.1324)/10.0
      B2 = B1 * B1
      B= -B1* (147.3-T*2.72 + T2*0.04 - D*1.0E-4*(32.4- 0.87*T+.02*T2))
      B= B+ B2*(4.5-0.1*T - D*1.0E-4*(1.8-0.06*T))
      CO = 4886./(1. + 1.83E-5*D)
      ALPHA=     D*1.0E-6* (CO+A+B)
      DN=(SIGMA+ALPHA)/(1.-1.E-3*ALPHA)
      RETURN
      END

      double precision function dunesco(t,s,d)

      implicit none
      real t,s,d
      double precision t2,t3,t4,s2,s3o2,p,p2,r,comp

c     convert from meters to bars
      p = d*0.1D0
      
      t2 = t*t
      t3 = t2*t
      t4 = t3*t
      
      s2 = s*s
      if (s .lt. 0.) then
         write(*,*) '****************************'
         write(*,*) '* subroutine density_field *'
         write(*,*) '****************************'
         write(*,*) '             WARNING: salinity takes on'
         write(*,*)
     &        '             negative values '
         write(*,*) '             S = ', s
         write(*,*) '             This is not supposed to ',
     &        'happen. Have a look!'
         stop
      end if
      s3o2 = sqrt(s2*s)
      
      
***   density at one standard atmosphere pressure (p=0) in si-units
      
      r =    999.842594                 + 6.793952e-02 * t 
     &     -          9.095290e-3  * t2 + 1.001685e-04 * t3  
     &     -          1.120083e-06 * t4 + 6.536332e-9  * t4*t
     &     + s    * ( 8.24493e-01       - 4.0899e-3    * t 
     &              + 7.6438e-05   * t2 - 8.2467e-07   * t3 
     &              + 5.3875e-09   * t4 ) 
     &     + s3o2 * (                   - 5.72466e-03 
     &              + 1.0227e-04   * t  - 1.6546e-06   * t2 ) 
     &     +          4.8314e-04   * s2 

***   density at depth d[m] = p[bar] :
***   include depth effect of secant bulk modulus k(s,t,p) if desired
              
      p2   = p*p
      
      comp = 19652.21 
     &     +        148.4206       * t  -   2.327105     * t2 
     &     +          1.360477e-02 * t3 -   5.155288e-05 * t4  
     &     + p    * ( 3.239908          +   1.43713e-03  * t 
     &              + 1.16092e-04  * t2 -   5.77905e-07  * t3 )  
     &     + p2   * ( 8.50935e-05       -   6.12293e-06  * t 
     &              + 5.2787e-08   * t2 ) 
     &     + s    * (54.6746            -   0.603459     * t 
     &              + 1.09987e-02  * t2 -   6.1670e-5    * t3 ) 
     &     + s3o2 * ( 7.944e-02         +   1.6483e-02   * t 
     &              - 5.3009e-04*t2)        
     &     + p*s  * ( 2.2838e-03 
     &              - 1.0981e-05   * t  -   1.6078e-06   * t2 ) 
     &              + 1.91075e-04  * p*s3o2  
     &     + p2*s * (                   -  9.9348e-07 
     &              + 2.0816e-08   * t  +   9.1697e-10   * t2 )

      dunesco = r/(1.D0-(p/comp))-1000.D0

      return
      end

#include "SEAICE_OPTIONS.h"

      subroutine seaice_cost_test( mytime, myiter, mythid )

c     ==================================================================
c     SUBROUTINE seaice_cost_test
c     ==================================================================
c
c     o Compute sea-ice cost function.  The following options can be
c       selected with data.seaice (SEAICE_PARM02) variable cost_ice_flag
c
c     cost_ice_flag = 1
c     - compute mean sea-ice volume
c       costIceStart < mytime < costIceEnd
c
c     cost_ice_flag = 2
c     - compute mean sea-ice area
c       costIceStart < mytime < costIceEnd
c
c     cost_ice_flag = 3
c     - heat content of top level plus latent heat of sea-ice
c       costIceStart < mytime < costIceEnd
c
c     cost_ice_flag = 4
c     - heat content of top level
c       costIceStart < mytime < costIceEnd
c
c     cost_ice_flag = 5
c     - heat content of top level plus sea-ice plus latent heat of snow
c       costIceStart < mytime < costIceEnd
c
c     cost_ice_flag = 6
c     - quadratic cost function measuring difference between pkg/seaice
c       AREA variable and simulated sea-ice measurements at every time
c       step.
c
c     ==================================================================
c
c     started: menemenlis@jpl.nasa.gov 26-Feb-2003
c
c     ==================================================================
c     SUBROUTINE seaice_cost_test
c     ==================================================================

      IMPLICIT NONE

#if (defined ALLOW_COST && defined ALLOW_COST_ICE)
c     == global variables ==
#include "EEPARAMS.h"
#include "SIZE.h"
#include "GRID.h"
#include "PARAMS.h"
#include "SEAICE_SIZE.h"
#include "SEAICE_COST.h"
#include "SEAICE.h"
#include "DYNVARS.h"
#include "cost.h"
#endif /* ALLOW_COST & ALLOW_COST_ICE */

c     == routine arguments ==
      _RL     mytime
      integer myiter
      integer mythid

#if (defined ALLOW_COST && defined ALLOW_COST_ICE)
c     == external functions ==
      integer  ilnblnk
      external ilnblnk

c     == local variables ==
c     msgBuf      - Informational/error message buffer
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      integer bi,bj,i,j,kSrf
      _RL tempVar

c     == end of interface ==

      if ( usingPCoords ) then
       kSrf = Nr
      else
       kSrf = 1
      endif
      if ( myTime .GT. (endTime - lastinterval) ) then
         tempVar = 1. _d 0/
     &             ( ( 1. _d 0 + min(endTime-startTime,lastinterval) )
     &             / deltaTClock )

cph(
      write(standardMessageUnit,*) 'ph-ice B ', myiter,
     &        theta(4,4,kSrf,1,1), area(4,4,1,1), heff(4,4,1,1)
cph)
         if ( cost_ice_flag .eq. 1 ) then
c     sea-ice volume
            do bj=myByLo(myThid),myByHi(myThid)
               do bi=myBxLo(myThid),myBxHi(myThid)
                  do j = 1,sny
                     do i =  1,snx
                        objf_ice(bi,bj) = objf_ice(bi,bj) +
     &                       tempVar * rA(i,j,bi,bj) * HEFF(i,j,bi,bj)
                     enddo
                  enddo
               enddo
            enddo

         elseif ( cost_ice_flag .eq. 2 ) then
c     sea-ice area
            do bj=myByLo(myThid),myByHi(myThid)
               do bi=myBxLo(myThid),myBxHi(myThid)
                  do j = 1,sny
                     do i =  1,snx
                        objf_ice(bi,bj) = objf_ice(bi,bj) +
     &                       tempVar * rA(i,j,bi,bj) * AREA(i,j,bi,bj)
                     enddo
                  enddo
               enddo
            enddo

c     heat content of top level:
c     theta * delZ * (sea water heat capacity = 3996 J/kg/K)
c                  * (density of sea-water = 1026 kg/m^3)
c
c     heat content of sea-ice:
c     tice * heff * (sea ice heat capacity = 2090 J/kg/K)
c                 * (density of sea-ice = 910 kg/m^3)
c
c     note: to remove mass contribution to heat content,
c     which is not properly accounted for by volume converving
c     ocean model, theta and tice are referenced to freezing
c     temperature of sea-ice, here -1.96 deg C
c
c     latent heat content of sea-ice:
c     - heff * (latent heat of fusion = 334000 J/kg)
c            * (density of sea-ice = 910 kg/m^3)
c
c     latent heat content of snow:
c     - hsnow * (latent heat of fusion = 334000 J/kg)
c             * (density of snow = 330 kg/m^3)

         elseif ( cost_ice_flag .eq. 3 ) then
c     heat content of top level plus latent heat of sea-ice
            do bj=myByLo(myThid),myByHi(myThid)
             do bi=myBxLo(myThid),myBxHi(myThid)
              do j = 1,sny
               do i =  1,snx
                objf_ice(bi,bj) = objf_ice(bi,bj) +
     &                 tempVar * rA(i,j,bi,bj) * (
     &                 (THETA(i,j,kSrf,bi,bj) + 1.96 _d 0 ) *
     &                 drF(kSrf) * 3996. _d 0 * 1026. _d 0 -
     &                 HEFF(i,j,bi,bj) * 334000. _d 0 * 910. _d 0 )
               enddo
              enddo
             enddo
            enddo

         elseif ( cost_ice_flag .eq. 4 ) then
c     heat content of top level
            do bj=myByLo(myThid),myByHi(myThid)
             do bi=myBxLo(myThid),myBxHi(myThid)
              do j = 1,sny
               do i =  1,snx
                objf_ice(bi,bj) = objf_ice(bi,bj) +
     &                 tempVar * rA(i,j,bi,bj) * (
     &                 (THETA(i,j,kSrf,bi,bj) + 1.96 _d 0 ) *
     &                 drF(kSrf) * 3996. _d 0 * 1026. _d 0 )
               enddo
              enddo
             enddo
            enddo

         elseif ( cost_ice_flag .eq. 5 ) then
c     heat content of top level plus sea-ice plus latent heat of snow
            do bj=myByLo(myThid),myByHi(myThid)
             do bi=myBxLo(myThid),myBxHi(myThid)
              do j = 1,sny
               do i =  1,snx
                objf_ice(bi,bj) = objf_ice(bi,bj) +
     &                 tempVar * rA(i,j,bi,bj) * (
     &                 (THETA(i,j,kSrf,bi,bj) + 1.96 _d 0 ) *
     &                 drF(kSrf) * 3996. _d 0 * 1026. _d 0 +
     &                 (TICES(i,j,1,bi,bj) - 273.15 _d 0 + 1.96 _d 0 ) *
     &                 HEFF(i,j,bi,bj) * 2090. _d 0 * 910. _d 0 -
     &                 HEFF(i,j,bi,bj) * 334000. _d 0 * 910. _d 0 -
     &                 HSNOW(i,j,bi,bj) * 334000. _d 0 * 330. _d 0 )
               enddo
              enddo
             enddo
            enddo

         elseif ( cost_ice_flag .eq. 6 ) then
c     Qadratic cost function measuring difference between pkg/seaice
c     AREA variable and simulated sea-ice measurements at every time
c     step.  For time being no measurements are read-in.  It is
c     assumed that measurements are AREA=0.5 at all times everywhere.
            do bj=myByLo(myThid),myByHi(myThid)
               do bi=myBxLo(myThid),myBxHi(myThid)
                  do j = 1,sny
                     do i =  1,snx
                        objf_ice(bi,bj) = objf_ice(bi,bj) +
     &                       ( AREA(i,j,bi,bj) - 0.5 _d 0 ) *
     &                       ( AREA(i,j,bi,bj) - 0.5 _d 0 )
                     enddo
                  enddo
               enddo
            enddo

         elseif ( cost_ice_flag .eq. 7 ) then

            do bj=myByLo(myThid),myByHi(myThid)
               do bi=myBxLo(myThid),myBxHi(myThid)
                  do j = 1,sny
                     do i =  1,snx
                        objf_ice(bi,bj) = objf_ice(bi,bj) +
     &                       UICE(i,j,bi,bj) * UICE(i,j,bi,bj) +
     &                       VICE(i,j,bi,bj) * VICE(i,j,bi,bj)

                     enddo
                  enddo
               enddo
            enddo

         else
            WRITE(msgBuf,'(A)')
     &           'COST_ICE: invalid cost_ice_flag'
            CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &           SQUEEZE_RIGHT , myThid )
            STOP 'ABNORMAL END: S/R COST_ICE'
         endif
      endif

cph(
      write(standardMessageUnit,*) 'ph-ice C ', myiter, objf_ice(1,1)
cph)

#endif /* ALLOW_COST & ALLOW_COST_ICE */

      RETURN
      END

#include "DIAG_OPTIONS.h"

CBOP 0
C     !ROUTINE: DIAGNOSTICS_CLEAR
C     !INTERFACE:
      SUBROUTINE DIAGNOSTICS_CLEAR (listId, myThid)

C     !DESCRIPTION:
C***********************************************************************
C     Driver to clear diagnostics specified in diagnostic index list
C***********************************************************************

C     !USES:
      IMPLICIT NONE

C     == Global variables ===
#include "EEPARAMS.h"
#include "SIZE.h"
#include "DIAGNOSTICS_SIZE.h"
#include "DIAGNOSTICS.h"

C     !INPUT PARAMETERS:
C     listId   ::  diagnostics list number
C     myThid :: my Thread Id number
      INTEGER listId, myThid
CEOP

C     !LOCAL VARIABLES:
      INTEGER m, ndId, ipt, nLev

      DO m=1,nActive(listId)
       IF ( idiag(m,listId).GT.0 ) THEN
         ndId  = ABS(jdiag(m,listId))
         ipt   = idiag(m,listId)
         nLev  = kdiag(ndId)*averageCycle(listId)
c        WRITE(0,'(2(A,I3),2A,2(A,I5))') 'CLRDIAG (listId=',listId,
c    &     ' )',nLev,' levs, diag: ',cdiag(ndId),
c    &     ' ipt=',ipt,' , ndiag=',ndiag(ipt,1,1)
         CALL DIAGNOSTICS_CLRDIAG( ipt, nLev, myThid )
       ENDIF
      ENDDO

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

CBOP 0
C     !ROUTINE: DIAGNOSTICS_CLRDIAG
C     !INTERFACE:
      SUBROUTINE DIAGNOSTICS_CLRDIAG ( ipt, nLev, myThid )

C     !DESCRIPTION:
C***********************************************************************
C     Zero out model diagnostic array elements
C***********************************************************************

C     !USES:
      IMPLICIT NONE

C     == Global variables ===
#include "EEPARAMS.h"
#include "SIZE.h"
#include "DIAGNOSTICS_SIZE.h"
#include "DIAGNOSTICS.h"

C     !INPUT PARAMETERS:
C     ipt    :: diagnostic pointer to storage array
C     nLev   :: number of levels (in storage array) to reset
C     myThid :: my Thread Id number
      INTEGER ipt, nLev
      INTEGER myThid
CEOP

C     !LOCAL VARIABLES:
      INTEGER bi,bj
      INTEGER i,j,k
      INTEGER kl

C **********************************************************************
C ****              SET DIAGNOSTIC AND COUNTER TO ZERO              ****
C **********************************************************************

      DO bj=myByLo(myThid), myByHi(myThid)
       DO bi=myBxLo(myThid), myBxHi(myThid)
        DO k = 1,nLev
         kl = ipt+k-1
         ndiag(kl,bi,bj) = 0
         DO j = 1-OLy,sNy+OLy
          DO i = 1-OLx,sNx+OLx
           qdiag(i,j,kl,bi,bj) = 0.0
          ENDDO
         ENDDO
        ENDDO
       ENDDO
      ENDDO

      RETURN
      END

#include "MOM_COMMON_OPTIONS.h"

      SUBROUTINE MOM_CALC_ABSVORT3( 
     I        bi,bj,k,
     I        vort3,
     O        omega3,
     I        myThid)
      IMPLICIT NONE
C     /==========================================================\
C     | S/R MOM_CALC_ABSVORT3                                    |
C     |==========================================================|
C     \==========================================================/

C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
C     == Routine arguments ==
C     myThid - Instance number for this innvocation of CALC_MOM_RHS
      INTEGER bi,bj,k
      _RL vort3(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL omega3(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER myThid

C     == Local variables ==
      INTEGER i,j
      _RL nonLinFac,useCoriolisFac

      IF (momAdvection) THEN
        nonLinFac=1.
      ELSE
        nonLinFac=0.
      ENDIF
      IF (useCoriolis) THEN
        useCoriolisFac=1.
      ELSE
        useCoriolisFac=0.
      ENDIF

      DO j=1-Oly,sNy+Oly
       DO i=1-Olx,sNx+Olx
        omega3(I,J)=
     &      fCoriG(i,j,bi,bj)*useCoriolisFac
     &     +vort3(i,j)*nonLinFac
       ENDDO
      ENDDO
        
      RETURN
      END

#include "PACKAGES_CONFIG.h"
#include "CPP_OPTIONS.h"

C--  File apply_forcing.F:
C--   Contents
C--   o APPLY_FORCING_U
C--   o APPLY_FORCING_V
C--   o APPLY_FORCING_T
C--   o APPLY_FORCING_S

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: APPLY_FORCING_U
C     !INTERFACE:
      SUBROUTINE APPLY_FORCING_U(
     U                     gU_arr,
     I                     iMin,iMax,jMin,jMax, k, bi, bj,
     I                     myTime, myIter, myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R APPLY_FORCING_U
C     | o Contains problem specific forcing for zonal velocity.
C     *==========================================================*
C     | Adds terms to gU for forcing by external sources
C     | e.g. wind stress, bottom friction etc ...
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     == Global data ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "DYNVARS.h"
#include "FFIELDS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     gU_arr    :: the tendency array
C     iMin,iMax :: Working range of x-index for applying forcing.
C     jMin,jMax :: Working range of y-index for applying forcing.
C     k         :: Current vertical level index
C     bi,bj     :: Current tile indices
C     myTime    :: Current time in simulation
C     myIter    :: Current iteration number
C     myThid    :: my Thread Id number
      _RL     gU_arr(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER iMin, iMax, jMin, jMax
      INTEGER k, bi, bj
      _RL     myTime
      INTEGER myIter
      INTEGER myThid

C     !LOCAL VARIABLES:
C     i,j       :: Loop counters
C     kSurface  :: index of surface level
      INTEGER i, j
#ifdef USE_OLD_EXTERNAL_FORCING
      _RL     locVar(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL     tmpVar
#else
      INTEGER kSurface
#endif
CEOP

#ifdef USE_OLD_EXTERNAL_FORCING

      DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
          locVar(i,j) = gU(i,j,k,bi,bj)
        ENDDO
      ENDDO
      CALL EXTERNAL_FORCING_U(
     I              iMin, iMax, jMin, jMax, bi, bj, k,
     I              myTime, myThid )
      DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
          tmpVar = gU(i,j,k,bi,bj) - locVar(i,j)
          gU(i,j,k,bi,bj) = locVar(i,j)
          gU_arr(i,j) = gU_arr(i,j) + tmpVar
        ENDDO
      ENDDO

#else  /* USE_OLD_EXTERNAL_FORCING */

      IF ( fluidIsAir ) THEN
       kSurface = 0
      ELSEIF ( usingPCoords ) THEN
       kSurface = Nr
      ELSE
       kSurface = 1
      ENDIF

C--   Forcing term
#ifdef ALLOW_AIM
      IF ( useAIM ) CALL AIM_TENDENCY_APPLY_U(
     U                       gU_arr,
     I                       iMin,iMax,jMin,jMax, k, bi,bj,
     I                       myTime, 0, myThid )
#endif /* ALLOW_AIM */

#ifdef ALLOW_ATM_PHYS
      IF ( useAtm_Phys ) CALL ATM_PHYS_TENDENCY_APPLY_U(
     U                       gU_arr,
     I                       iMin,iMax,jMin,jMax, k, bi,bj,
     I                       myTime, 0, myThid )
#endif /* ALLOW_ATM_PHYS */

#ifdef ALLOW_FIZHI
      IF ( useFIZHI ) CALL FIZHI_TENDENCY_APPLY_U(
     U                       gU_arr,
     I                       iMin,iMax,jMin,jMax, k, bi,bj,
     I                       myTime, 0, myThid )
#endif /* ALLOW_FIZHI */

C     Ocean: Add momentum surface forcing (e.g., wind-stress) in surface level
      IF ( k .EQ. kSurface ) THEN
c      DO j=1,sNy
C-jmc: Without CD-scheme, this is OK ; but with CD-scheme, needs to cover [0:sNy+1]
       DO j=0,sNy+1
        DO i=1,sNx+1
          gU_arr(i,j) = gU_arr(i,j)
     &      +foFacMom*surfaceForcingU(i,j,bi,bj)
     &      *recip_drF(k)*_recip_hFacW(i,j,k,bi,bj)
        ENDDO
       ENDDO
      ELSEIF ( kSurface.EQ.-1 ) THEN
       DO j=0,sNy+1
        DO i=1,sNx+1
         IF ( kSurfW(i,j,bi,bj).EQ.k ) THEN
          gU_arr(i,j) = gU_arr(i,j)
     &      +foFacMom*surfaceForcingU(i,j,bi,bj)
     &      *recip_drF(k)*_recip_hFacW(i,j,k,bi,bj)
         ENDIF
        ENDDO
       ENDDO
      ENDIF

#ifdef ALLOW_EDDYPSI
         CALL TAUEDDY_TENDENCY_APPLY_U(
     U                 gU_arr,
     I                 iMin,iMax,jMin,jMax, k, bi,bj,
     I                 myTime, 0, myThid )
#endif

#ifdef ALLOW_RBCS
      IF (useRBCS) THEN
        CALL RBCS_ADD_TENDENCY(
     U                 gU_arr,
     I                 k, bi, bj, -1,
     I                 myTime, 0, myThid )

      ENDIF
#endif /* ALLOW_RBCS */

#ifdef ALLOW_OBCS
      IF (useOBCS) THEN
        CALL OBCS_SPONGE_U(
     U                   gU_arr,
     I                   iMin,iMax,jMin,jMax, k, bi,bj,
     I                   myTime, 0, myThid )
      ENDIF
#endif /* ALLOW_OBCS */

#ifdef ALLOW_MYPACKAGE
      IF ( useMYPACKAGE ) THEN
        CALL MYPACKAGE_TENDENCY_APPLY_U(
     U                 gU_arr,
     I                 iMin,iMax,jMin,jMax, k, bi,bj,
     I                 myTime, 0, myThid )
      ENDIF
#endif /* ALLOW_MYPACKAGE */

#endif /* USE_OLD_EXTERNAL_FORCING */

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: APPLY_FORCING_V
C     !INTERFACE:
      SUBROUTINE APPLY_FORCING_V(
     U                     gV_arr,
     I                     iMin,iMax,jMin,jMax, k, bi, bj,
     I                     myTime, myIter, myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R APPLY_FORCING_V
C     | o Contains problem specific forcing for merid velocity.
C     *==========================================================*
C     | Adds terms to gV for forcing by external sources
C     | e.g. wind stress, bottom friction etc ...
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     == Global data ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "DYNVARS.h"
#include "FFIELDS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     gV_arr    :: the tendency array
C     iMin,iMax :: Working range of x-index for applying forcing.
C     jMin,jMax :: Working range of y-index for applying forcing.
C     k         :: Current vertical level index
C     bi,bj     :: Current tile indices
C     myTime    :: Current time in simulation
C     myIter    :: Current iteration number
C     myThid    :: my Thread Id number
      _RL     gV_arr(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER iMin, iMax, jMin, jMax
      INTEGER k, bi, bj
      _RL     myTime
      INTEGER myIter
      INTEGER myThid

C     !LOCAL VARIABLES:
C     i,j       :: Loop counters
C     kSurface  :: index of surface level
      INTEGER i, j
#ifdef USE_OLD_EXTERNAL_FORCING
      _RL     locVar(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL     tmpVar
#else
      INTEGER kSurface
#endif
CEOP

#ifdef USE_OLD_EXTERNAL_FORCING

      DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
          locVar(i,j) = gV(i,j,k,bi,bj)
        ENDDO
      ENDDO
      CALL EXTERNAL_FORCING_V(
     I              iMin, iMax, jMin, jMax, bi, bj, k,
     I              myTime, myThid )
      DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
          tmpVar = gV(i,j,k,bi,bj) - locVar(i,j)
          gV(i,j,k,bi,bj) = locVar(i,j)
          gV_arr(i,j) = gV_arr(i,j) + tmpVar
        ENDDO
      ENDDO

#else  /* USE_OLD_EXTERNAL_FORCING */

      IF ( fluidIsAir ) THEN
       kSurface = 0
      ELSEIF ( usingPCoords ) THEN
       kSurface = Nr
      ELSE
       kSurface = 1
      ENDIF

C--   Forcing term
#ifdef ALLOW_AIM
      IF ( useAIM ) CALL AIM_TENDENCY_APPLY_V(
     U                       gV_arr,
     I                       iMin,iMax,jMin,jMax, k, bi,bj,
     I                       myTime, 0, myThid )
#endif /* ALLOW_AIM */

#ifdef ALLOW_ATM_PHYS
      IF ( useAtm_Phys ) CALL ATM_PHYS_TENDENCY_APPLY_V(
     U                       gV_arr,
     I                       iMin,iMax,jMin,jMax, k, bi,bj,
     I                       myTime, 0, myThid )
#endif /* ALLOW_ATM_PHYS */

#ifdef ALLOW_FIZHI
      IF ( useFIZHI ) CALL FIZHI_TENDENCY_APPLY_V(
     U                       gV_arr,
     I                       iMin,iMax,jMin,jMax, k, bi,bj,
     I                       myTime, 0, myThid )
#endif /* ALLOW_FIZHI */

C     Ocean: Add momentum surface forcing (e.g., wind-stress) in surface level
      IF ( k .EQ. kSurface ) THEN
       DO j=1,sNy+1
c       DO i=1,sNx
C-jmc: Without CD-scheme, this is OK ; but with CD-scheme, needs to cover [0:sNx+1]
        DO i=0,sNx+1
          gV_arr(i,j) = gV_arr(i,j)
     &      +foFacMom*surfaceForcingV(i,j,bi,bj)
     &      *recip_drF(k)*_recip_hFacS(i,j,k,bi,bj)
        ENDDO
       ENDDO
      ELSEIF ( kSurface.EQ.-1 ) THEN
       DO j=1,sNy+1
        DO i=0,sNx+1
         IF ( kSurfS(i,j,bi,bj).EQ.k ) THEN
          gV_arr(i,j) = gV_arr(i,j)
     &      +foFacMom*surfaceForcingV(i,j,bi,bj)
     &      *recip_drF(k)*_recip_hFacS(i,j,k,bi,bj)
         ENDIF
        ENDDO
       ENDDO
      ENDIF

#ifdef ALLOW_EDDYPSI
         CALL TAUEDDY_TENDENCY_APPLY_V(
     U                 gV_arr,
     I                 iMin,iMax,jMin,jMax, k, bi,bj,
     I                 myTime, 0, myThid )
#endif

#ifdef ALLOW_RBCS
      IF (useRBCS) THEN
        CALL RBCS_ADD_TENDENCY(
     U                 gV_arr,
     I                 k, bi, bj, -2,
     I                 myTime, 0, myThid )
      ENDIF
#endif /* ALLOW_RBCS */

#ifdef ALLOW_OBCS
      IF (useOBCS) THEN
        CALL OBCS_SPONGE_V(
     U                   gV_arr,
     I                   iMin,iMax,jMin,jMax, k, bi,bj,
     I                   myTime, 0, myThid )
      ENDIF
#endif /* ALLOW_OBCS */

#ifdef ALLOW_MYPACKAGE
      IF ( useMYPACKAGE ) THEN
        CALL MYPACKAGE_TENDENCY_APPLY_V(
     U                 gV_arr,
     I                 iMin,iMax,jMin,jMax, k, bi,bj,
     I                 myTime, 0, myThid )
      ENDIF
#endif /* ALLOW_MYPACKAGE */

#endif /* USE_OLD_EXTERNAL_FORCING */

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: APPLY_FORCING_T
C     !INTERFACE:
      SUBROUTINE APPLY_FORCING_T(
     U                     gT_arr,
     I                     iMin,iMax,jMin,jMax, k, bi, bj,
     I                     myTime, myIter, myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R APPLY_FORCING_T
C     | o Contains problem specific forcing for temperature.
C     *==========================================================*
C     | Adds terms to gT for forcing by external sources
C     | e.g. heat flux, climatalogical relaxation, etc ...
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     == Global data ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "DYNVARS.h"
#include "FFIELDS.h"
#include "SURFACE.h"

C     !INPUT/OUTPUT PARAMETERS:
C     gT_arr    :: the tendency array
C     iMin,iMax :: Working range of x-index for applying forcing.
C     jMin,jMax :: Working range of y-index for applying forcing.
C     k         :: Current vertical level index
C     bi,bj     :: Current tile indices
C     myTime    :: Current time in simulation
C     myIter    :: Current iteration number
C     myThid    :: my Thread Id number
      _RL     gT_arr(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER iMin, iMax, jMin, jMax
      INTEGER k, bi, bj
      _RL     myTime
      INTEGER myIter
      INTEGER myThid

C     !LOCAL VARIABLES:
C     i,j       :: Loop counters
C     kSurface  :: index of surface level
      INTEGER i, j
#ifdef USE_OLD_EXTERNAL_FORCING
      _RL     locVar(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL     tmpVar
#else
      INTEGER kSurface
      INTEGER km, kc, kp
      _RL tmpVar(1:sNx,1:sNy)
      _RL tmpFac, delPI
      _RL recip_Cp
CEOP
#ifdef SHORTWAVE_HEATING
      _RL minusone
      PARAMETER (minusOne=-1.)
      _RL swfracb(2)
      INTEGER kp1
#endif
C---- Experiment specific declaration: starts here -------------------
C     iG, jG             :: Global index temps.
C     hC, hW, hE, hN, hS :: Fractional vertical distance open to fluid temps.
C     dFlux[WENS]        :: Diffusive flux normal to each cell face.
C     faceArea           :: Temp. for holding area normal to tempurature gradient.
      INTEGER iG, jG
      _RL hC, hW, hE, hN, hS
      _RL dFluxW, dFluxE, dFluxN, dFluxS
      _RL faceArea

C--   Forcing term
C     Add term which represents the diffusive flux from a circular cylinder of temperature tCylIm in the
C     interior of the simulation domain. Result is a tendency which is determined from the finite
C     volume formulated divergence of the diffusive heat flux due to the local cylinder
C     temperature, fluid temperature difference.
C     kDiffCyl :: Diffusion coefficient
C     tCylIn     :: Temperature of the inner boundary of the cylinder
C     tCylOut     :: Temperature of the outer boundary cylinder
C     iGSource :: Index space I (global) coordinate for source center.
C     jGSource :: Index space J (global) coordinate for source center.
C     rSource  :: Extent of the source term region. Loop will skip checking points outside
C              :: this region. Within this region the source heating will be added
C              :: to any points that are at a land - fluid boundary. rSource is in grid
C              :: points, so that points checked are ophi(iGlobal,jGlobal) such that
C              :: iGlobal=iGsource +/- rSource, jGlobal = jGsource +/- rSource.
C              :: rSource, iGSource and jGSource only need to define a quadrilateral that
C              :: includes the cylinder and no other land, they do not need to be exact.
C afe:
C  the below appears to be an attempt to make the heat flux somewhat general in regards
C  to bathymetry, but jmc pointed out some ways it could be better.  this is not
C  an issue at this point (July 04) since all experiments are being done with straight-
C  sided tank and cyclinder walls.
C  some todo items:
C  * add terms to top and bottom -- probably critical!!!
C  * make tCyl more flexible -- maybe have as separate inner and outer variables
C       or, eventually, a forcing field
C  * think about possible problems with differing heat diffusion rates in wall materials
C    (plexiglass, air, water in the compound tank case)
      _RL kDiffCyl
      _RL tCyl
      INTEGER rSource
      INTEGER iGSource
      INTEGER jGSource
C---- Experiment specific declaration:  ends  here -------------------
#endif

#ifdef USE_OLD_EXTERNAL_FORCING

      DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
          locVar(i,j) = gT(i,j,k,bi,bj)
        ENDDO
      ENDDO
      CALL EXTERNAL_FORCING_T(
     I              iMin, iMax, jMin, jMax, bi, bj, k,
     I              myTime, myThid )
      DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
          tmpVar = gT(i,j,k,bi,bj) - locVar(i,j)
          gT(i,j,k,bi,bj) = locVar(i,j)
          gT_arr(i,j) = gT_arr(i,j) + tmpVar
        ENDDO
      ENDDO

#else  /* USE_OLD_EXTERNAL_FORCING */

      IF ( fluidIsAir ) THEN
       kSurface = 0
      ELSEIF ( usingZCoords .AND. useShelfIce ) THEN
       kSurface = -1
      ELSEIF ( usingPCoords ) THEN
       kSurface = Nr
      ELSE
       kSurface = 1
      ENDIF
      recip_Cp = 1. _d 0 / HeatCapacity_Cp

C--   Forcing term
#ifdef ALLOW_AIM
      IF ( useAIM ) CALL AIM_TENDENCY_APPLY_T(
     U                       gT_arr,
     I                       iMin,iMax,jMin,jMax, k, bi,bj,
     I                       myTime, 0, myThid )
#endif /* ALLOW_AIM */

#ifdef ALLOW_ATM_PHYS
      IF ( useAtm_Phys ) CALL ATM_PHYS_TENDENCY_APPLY_T(
     U                       gT_arr,
     I                       iMin,iMax,jMin,jMax, k, bi,bj,
     I                       myTime, 0, myThid )
#endif /* ALLOW_ATM_PHYS */

#ifdef ALLOW_FIZHI
      IF ( useFIZHI ) CALL FIZHI_TENDENCY_APPLY_T(
     U                       gT_arr,
     I                       iMin,iMax,jMin,jMax, k, bi,bj,
     I                       myTime, 0, myThid )
#endif /* ALLOW_FIZHI */

#ifdef ALLOW_ADDFLUID
      IF ( selectAddFluid.NE.0 .AND. temp_addMass.NE.UNSET_RL ) THEN
       IF ( ( selectAddFluid.GE.1 .AND. nonlinFreeSurf.GT.0 )
     &      .OR. convertFW2Salt.EQ.-1. _d 0 ) THEN
         DO j=1,sNy
          DO i=1,sNx
            gT_arr(i,j) = gT_arr(i,j)
     &        + addMass(i,j,k,bi,bj)*mass2rUnit
     &          *( temp_addMass - theta(i,j,k,bi,bj) )
     &          *recip_rA(i,j,bi,bj)
     &          *recip_drF(k)*_recip_hFacC(i,j,k,bi,bj)
C    &          *recip_deepFac2C(k)*recip_rhoFacC(k)
          ENDDO
         ENDDO
       ELSE
         DO j=1,sNy
          DO i=1,sNx
            gT_arr(i,j) = gT_arr(i,j)
     &        + addMass(i,j,k,bi,bj)*mass2rUnit
     &          *( temp_addMass - tRef(k) )
     &          *recip_rA(i,j,bi,bj)
     &          *recip_drF(k)*_recip_hFacC(i,j,k,bi,bj)
C    &          *recip_deepFac2C(k)*recip_rhoFacC(k)
          ENDDO
         ENDDO
       ENDIF
      ENDIF
#endif /* ALLOW_ADDFLUID */

#ifdef ALLOW_FRICTION_HEATING
      IF ( addFrictionHeating ) THEN
        IF ( fluidIsAir ) THEN
C         conversion from in-situ Temp to Pot.Temp
          tmpFac = (atm_Po/rC(k))**atm_kappa
C         conversion from W/m^2/r_unit to K/s
          tmpFac = (tmpFac/atm_Cp) * mass2rUnit
        ELSE
C         conversion from W/m^2/r_unit to K/s
          tmpFac = recip_Cp * mass2rUnit
        ENDIF
        DO j=1,sNy
          DO i=1,sNx
            gT_arr(i,j) = gT_arr(i,j)
     &         + frictionHeating(i,j,k,bi,bj)
     &          *tmpFac*recip_rA(i,j,bi,bj)
     &          *recip_drF(k)*_recip_hFacC(i,j,k,bi,bj)
          ENDDO
        ENDDO
      ENDIF
#endif /* ALLOW_FRICTION_HEATING */

      IF ( fluidIsAir .AND. atm_Rq.NE.zeroRL .AND. Nr.NE.1 ) THEN
C--   Compressible fluid: account for difference between moist and dry air
C     specific volume in Enthalpy equation (+ V.dP term), since only the
C     dry air part is accounted for in the (dry) Pot.Temp formulation.
C     Used centered averaging from interface to center (consistent with
C     conversion term in KE eq) and same discretisation ( [T*Q]_bar_k )
C     as for Theta_v in CALC_PHI_HYD

C     conversion from in-situ Temp to Pot.Temp
        tmpFac = (atm_Po/rC(k))**atm_kappa
C     conversion from W/kg to K/s
        tmpFac = tmpFac/atm_Cp
        km = k-1
        kc = k
        kp = k+1
        IF ( k.EQ.1 ) THEN
          DO j=1,sNy
           DO i=1,sNx
            tmpVar(i,j) = 0.
           ENDDO
          ENDDO
        ELSE
          delPI = atm_Cp*( (rC(km)/atm_Po)**atm_kappa
     &                   - (rC(kc)/atm_Po)**atm_kappa )
          DO j=1,sNy
           DO i=1,sNx
            tmpVar(i,j) = wVel(i,j,kc,bi,bj)*delPI*atm_Rq
     &                  *( theta(i,j,km,bi,bj)*salt(i,j,km,bi,bj)
     &                   + theta(i,j,kc,bi,bj)*salt(i,j,kc,bi,bj)
     &                   )*maskC(i,j,km,bi,bj)*0.25 _d 0
           ENDDO
          ENDDO
        ENDIF
        IF ( k.LT.Nr ) THEN
          delPI = atm_Cp*( (rC(kc)/atm_Po)**atm_kappa
     &                   - (rC(kp)/atm_Po)**atm_kappa )
          DO j=1,sNy
           DO i=1,sNx
            tmpVar(i,j) = tmpVar(i,j)
     &                  + wVel(i,j,kp,bi,bj)*delPI*atm_Rq
     &                  *( theta(i,j,kc,bi,bj)*salt(i,j,kc,bi,bj)
     &                   + theta(i,j,kp,bi,bj)*salt(i,j,kp,bi,bj)
     &                   )*maskC(i,j,kp,bi,bj)*0.25 _d 0
           ENDDO
          ENDDO
        ENDIF
        DO j=1,sNy
          DO i=1,sNx
            gT_arr(i,j) = gT_arr(i,j)
     &         + tmpVar(i,j)*tmpFac
     &          *recip_drF(k)*_recip_hFacC(i,j,k,bi,bj)
          ENDDO
        ENDDO
#ifdef ALLOW_DIAGNOSTICS
        IF ( useDiagnostics ) THEN
C     conversion to W/m^2
          tmpFac = rUnit2mass
          CALL DIAGNOSTICS_SCALE_FILL( tmpVar, tmpFac, 1,
     &                     'MoistCor', kc, 1, 3, bi,bj,myThid )
        ENDIF
#endif /* ALLOW_DIAGNOSTICS */
      ENDIF

C     Ocean: Add temperature surface forcing (e.g., heat-flux) in surface level
      IF ( k .EQ. kSurface ) THEN
       DO j=1,sNy
        DO i=1,sNx
          gT_arr(i,j) = gT_arr(i,j)
     &      +surfaceForcingT(i,j,bi,bj)
     &      *recip_drF(k)*_recip_hFacC(i,j,k,bi,bj)
        ENDDO
       ENDDO
      ELSEIF ( kSurface.EQ.-1 ) THEN
       DO j=1,sNy
        DO i=1,sNx
         IF ( kSurfC(i,j,bi,bj).EQ.k ) THEN
          gT_arr(i,j) = gT_arr(i,j)
     &      +surfaceForcingT(i,j,bi,bj)
     &      *recip_drF(k)*_recip_hFacC(i,j,k,bi,bj)
         ENDIF
        ENDDO
       ENDDO
      ENDIF

      IF (linFSConserveTr) THEN
       DO j=1,sNy
        DO i=1,sNx
          IF (k .EQ. kSurfC(i,j,bi,bj)) THEN
            gT_arr(i,j) = gT_arr(i,j)
     &        +TsurfCor*recip_drF(k)*_recip_hFacC(i,j,k,bi,bj)
          ENDIF
        ENDDO
       ENDDO
      ENDIF

#ifdef SHORTWAVE_HEATING
C Penetrating SW radiation
c     IF ( usePenetratingSW ) THEN
       swfracb(1)=abs(rF(k))
       swfracb(2)=abs(rF(k+1))
       CALL SWFRAC(
     I             2, minusOne,
     U             swfracb,
     I             myTime, 1, myThid )
       kp1 = k+1
       IF (k.EQ.Nr) THEN
        kp1 = k
        swfracb(2)=0. _d 0
       ENDIF
       DO j=1,sNy
        DO i=1,sNx
         gT_arr(i,j) = gT_arr(i,j)
     &   -Qsw(i,j,bi,bj)*(swfracb(1)*maskC(i,j,k,bi,bj)
     &                   -swfracb(2)*maskC(i,j,kp1, bi,bj))
     &    *recip_Cp*mass2rUnit
     &    *recip_drF(k)*_recip_hFacC(i,j,k,bi,bj)
        ENDDO
       ENDDO
c     ENDIF
#endif

C---- Experiment specific code: starts here --------------------------
      kDiffCyl = 3. _d -7
      rSource  = 3
      iGSource = 30
      jGSource = 8
      DO j=1,sNy
       DO i=1,sNx
        dFluxW = 0.
        dFluxE = 0.
        dFluxN = 0.
        dFluxS = 0.
        jG = myYGlobalLo-1+(bj-1)*sNy+J
        iG = myXGlobalLo-1+(bi-1)*sNx+I
c      IF(jG .GE. jGSource-rSource .AND. jG .LE. jGSource+rSource) THEN
c     the following bites the big one
      IF(jG .LE. 10) THEN
         tCyl = tCylIn
      ELSE
         tCyl = tCylOut
      ENDIF
c      IF(iG .GE. iGSource-rSource .AND. iG .LE. iGSource+rSource) THEN
          hC = hFacC(i  ,j  ,k,bi,bj)
          hW = hFacW(i  ,j  ,k,bi,bj)
          hE = hFacW(i+1,j  ,k,bi,bj)
          hN = hFacS(i  ,j+1,k,bi,bj)
          hS = hFacS(i  ,j  ,k,bi,bj)
          IF ( hC .NE. 0. .AND .hW .EQ. 0. ) THEN
C          Cylinder to west
           faceArea = drF(k)*dyG(i,j,bi,bj)
           dFluxW =
     &      -faceArea*kDiffCyl*(theta(i,j,k,bi,bj) - tCyl)
     &      *recip_dxC(i,j,bi,bj)
          ENDIF
          IF ( hC .NE. 0. .AND .hE .EQ. 0. ) THEN
C          Cylinder to east
           faceArea = drF(k)*dyG(i+1,j,bi,bj)
           dFluxE =
     &      -faceArea*kDiffCyl*(tCyl - theta(i,j,k,bi,bj))
     &      *recip_dxC(i,j,bi,bj)
          ENDIF
          IF ( hC .NE. 0. .AND .hN .EQ. 0. ) THEN
C          Cylinder to north
           faceArea = drF(k)*dxG(i,j+1,bi,bj)
           dFluxN =
     &      -faceArea*kDiffCyl*(tCyl-theta(i,j,k,bi,bj))
     &      *recip_dyC(i,j,bi,bj)
          ENDIF
          IF ( hC .NE. 0. .AND .hS .EQ. 0. ) THEN
C          Cylinder to south
           faceArea = drF(k)*dxG(i,j,bi,bj)
           dFluxS =
     &      -faceArea*kDiffCyl*(theta(i,j,k,bi,bj) - tCyl)
     &      *recip_dyC(i,j,bi,bj)
          ENDIF
c      ENDIF
c      ENDIF
C       Net tendency term is minus flux divergence divided by the volume.
        gT_arr(i,j) = gT_arr(i,j)
     &  -_recip_hFacC(i,j,k,bi,bj)*recip_drF(k)
     &  *recip_rA(i,j,bi,bj)
     &  *(
     &    dFluxE-dFluxW
     &   +dFluxN-dFluxS
     &   )

       ENDDO
      ENDDO
C---- Experiment specific code:  ends  here --------------------------

#ifdef ALLOW_FRAZIL
      IF ( useFRAZIL )
     &     CALL FRAZIL_TENDENCY_APPLY_T(
     U                 gT_arr,
     I                 iMin,iMax,jMin,jMax, k, bi,bj,
     I                 myTime, 0, myThid )
#endif /* ALLOW_FRAZIL */

#ifdef ALLOW_SHELFICE
      IF ( useShelfIce )
     &     CALL SHELFICE_FORCING_T(
     U                   gT_arr,
     I                   iMin,iMax,jMin,jMax, k, bi,bj,
     I                   myTime, 0, myThid )
#endif /* ALLOW_SHELFICE */

#ifdef ALLOW_ICEFRONT
      IF ( useICEFRONT )
     &     CALL ICEFRONT_TENDENCY_APPLY_T(
     U                   gT_arr,
     I                   k, bi, bj, myTime, 0, myThid )
#endif /* ALLOW_ICEFRONT */

#ifdef ALLOW_SALT_PLUME
      IF ( useSALT_PLUME )
     &     CALL SALT_PLUME_TENDENCY_APPLY_T(
     U                     gT_arr,
     I                     iMin,iMax,jMin,jMax, k, bi,bj,
     I                     myTime, 0, myThid )
#endif /* ALLOW_SALT_PLUME */

#ifdef ALLOW_RBCS
      IF (useRBCS) THEN
        CALL RBCS_ADD_TENDENCY(
     U                 gT_arr,
     I                 k, bi, bj, 1,
     I                 myTime, 0, myThid )
      ENDIF
#endif /* ALLOW_RBCS */

#ifdef ALLOW_OBCS
      IF (useOBCS) THEN
        CALL OBCS_SPONGE_T(
     U                   gT_arr,
     I                   iMin,iMax,jMin,jMax, k, bi,bj,
     I                   myTime, 0, myThid )
      ENDIF
#endif /* ALLOW_OBCS */

#ifdef ALLOW_BBL
      IF ( useBBL ) CALL BBL_TENDENCY_APPLY_T(
     U                       gT_arr,
     I                       iMin,iMax,jMin,jMax, k, bi,bj,
     I                       myTime, 0, myThid )
#endif /* ALLOW_BBL */

#ifdef ALLOW_MYPACKAGE
      IF ( useMYPACKAGE ) THEN
        CALL MYPACKAGE_TENDENCY_APPLY_T(
     U                 gT_arr,
     I                 iMin,iMax,jMin,jMax, k, bi,bj,
     I                 myTime, 0, myThid )
      ENDIF
#endif /* ALLOW_MYPACKAGE */

#endif /* USE_OLD_EXTERNAL_FORCING */

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: APPLY_FORCING_S
C     !INTERFACE:
      SUBROUTINE APPLY_FORCING_S(
     U                     gS_arr,
     I                     iMin,iMax,jMin,jMax, k, bi, bj,
     I                     myTime, myIter, myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R APPLY_FORCING_S
C     | o Contains problem specific forcing for merid velocity.
C     *==========================================================*
C     | Adds terms to gS for forcing by external sources
C     | e.g. fresh-water flux, climatalogical relaxation, etc ...
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     == Global data ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "DYNVARS.h"
#include "FFIELDS.h"
#include "SURFACE.h"

C     !INPUT/OUTPUT PARAMETERS:
C     gS_arr    :: the tendency array
C     iMin,iMax :: Working range of x-index for applying forcing.
C     jMin,jMax :: Working range of y-index for applying forcing.
C     k         :: Current vertical level index
C     bi,bj     :: Current tile indices
C     myTime    :: Current time in simulation
C     myIter    :: Current iteration number
C     myThid    :: my Thread Id number
      _RL     gS_arr(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER iMin, iMax, jMin, jMax
      INTEGER k, bi, bj
      _RL     myTime
      INTEGER myIter
      INTEGER myThid

C     !LOCAL VARIABLES:
C     i,j       :: Loop counters
C     kSurface  :: index of surface level
      INTEGER i, j
#ifdef USE_OLD_EXTERNAL_FORCING
      _RL     locVar(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL     tmpVar
#else
      INTEGER kSurface
#endif
CEOP

#ifdef USE_OLD_EXTERNAL_FORCING

      DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
          locVar(i,j) = gS(i,j,k,bi,bj)
        ENDDO
      ENDDO
      CALL EXTERNAL_FORCING_S(
     I              iMin, iMax, jMin, jMax, bi, bj, k,
     I              myTime, myThid )
      DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
          tmpVar = gS(i,j,k,bi,bj) - locVar(i,j)
          gS(i,j,k,bi,bj) = locVar(i,j)
          gS_arr(i,j) = gS_arr(i,j) + tmpVar
        ENDDO
      ENDDO

#else  /* USE_OLD_EXTERNAL_FORCING */

      IF ( fluidIsAir ) THEN
       kSurface = 0
      ELSEIF ( usingZCoords .AND. useShelfIce ) THEN
       kSurface = -1
      ELSEIF ( usingPCoords ) THEN
       kSurface = Nr
      ELSE
       kSurface = 1
      ENDIF

C--   Forcing term
#ifdef ALLOW_AIM
      IF ( useAIM ) CALL AIM_TENDENCY_APPLY_S(
     U                       gS_arr,
     I                       iMin,iMax,jMin,jMax, k, bi,bj,
     I                       myTime, 0, myThid )
#endif /* ALLOW_AIM */

#ifdef ALLOW_ATM_PHYS
      IF ( useAtm_Phys ) CALL ATM_PHYS_TENDENCY_APPLY_S(
     U                       gS_arr,
     I                       iMin,iMax,jMin,jMax, k, bi,bj,
     I                       myTime, 0, myThid )
#endif /* ALLOW_ATM_PHYS */

#ifdef ALLOW_FIZHI
      IF ( useFIZHI ) CALL FIZHI_TENDENCY_APPLY_S(
     U                       gS_arr,
     I                       iMin,iMax,jMin,jMax, k, bi,bj,
     I                       myTime, 0, myThid )
#endif /* ALLOW_FIZHI */

#ifdef ALLOW_ADDFLUID
      IF ( selectAddFluid.NE.0 .AND. salt_addMass.NE.UNSET_RL ) THEN
       IF ( ( selectAddFluid.GE.1 .AND. nonlinFreeSurf.GT.0 )
     &      .OR. convertFW2Salt.EQ.-1. _d 0 ) THEN
         DO j=1,sNy
          DO i=1,sNx
            gS_arr(i,j) = gS_arr(i,j)
     &        + addMass(i,j,k,bi,bj)*mass2rUnit
     &          *( salt_addMass - salt(i,j,k,bi,bj) )
     &          *recip_rA(i,j,bi,bj)
     &          *recip_drF(k)*_recip_hFacC(i,j,k,bi,bj)
C    &          *recip_deepFac2C(k)*recip_rhoFacC(k)
          ENDDO
         ENDDO
       ELSE
         DO j=1,sNy
          DO i=1,sNx
            gS_arr(i,j) = gS_arr(i,j)
     &        + addMass(i,j,k,bi,bj)*mass2rUnit
     &          *( salt_addMass - sRef(k) )
     &          *recip_rA(i,j,bi,bj)
     &          *recip_drF(k)*_recip_hFacC(i,j,k,bi,bj)
C    &          *recip_deepFac2C(k)*recip_rhoFacC(k)
          ENDDO
         ENDDO
       ENDIF
      ENDIF
#endif /* ALLOW_ADDFLUID */

C     Ocean: Add salinity surface forcing (e.g., fresh-water) in surface level
      IF ( k .EQ. kSurface ) THEN
       DO j=1,sNy
        DO i=1,sNx
          gS_arr(i,j) = gS_arr(i,j)
     &      +surfaceForcingS(i,j,bi,bj)
     &      *recip_drF(k)*_recip_hFacC(i,j,k,bi,bj)
        ENDDO
       ENDDO
      ELSEIF ( kSurface.EQ.-1 ) THEN
       DO j=1,sNy
        DO i=1,sNx
         IF ( kSurfC(i,j,bi,bj).EQ.k ) THEN
          gS_arr(i,j) = gS_arr(i,j)
     &      +surfaceForcingS(i,j,bi,bj)
     &      *recip_drF(k)*_recip_hFacC(i,j,k,bi,bj)
         ENDIF
        ENDDO
       ENDDO
      ENDIF

      IF (linFSConserveTr) THEN
       DO j=1,sNy
        DO i=1,sNx
          IF (k .EQ. kSurfC(i,j,bi,bj)) THEN
            gS_arr(i,j) = gS_arr(i,j)
     &        +SsurfCor*recip_drF(k)*_recip_hFacC(i,j,k,bi,bj)
          ENDIF
        ENDDO
       ENDDO
      ENDIF

#ifdef ALLOW_SHELFICE
      IF ( useShelfIce )
     &     CALL SHELFICE_FORCING_S(
     U                   gS_arr,
     I                   iMin,iMax,jMin,jMax, k, bi,bj,
     I                   myTime, 0, myThid )
#endif /* ALLOW_SHELFICE */

#ifdef ALLOW_ICEFRONT
      IF ( useICEFRONT )
     &     CALL ICEFRONT_TENDENCY_APPLY_S(
     U                   gS_arr,
     I                   k, bi, bj, myTime, 0, myThid )
#endif /* ALLOW_ICEFRONT */

#ifdef ALLOW_SALT_PLUME
      IF ( useSALT_PLUME )
     &     CALL SALT_PLUME_TENDENCY_APPLY_S(
     U                     gS_arr,
     I                     iMin,iMax,jMin,jMax, k, bi,bj,
     I                     myTime, 0, myThid )
#endif /* ALLOW_SALT_PLUME */

#ifdef ALLOW_RBCS
      IF (useRBCS) THEN
        CALL RBCS_ADD_TENDENCY(
     U                 gS_arr,
     I                 k, bi, bj, 2,
     I                 myTime, 0, myThid )
      ENDIF
#endif /* ALLOW_RBCS */

#ifdef ALLOW_OBCS
      IF (useOBCS) THEN
        CALL OBCS_SPONGE_S(
     U                   gS_arr,
     I                   iMin,iMax,jMin,jMax, k, bi,bj,
     I                   myTime, 0, myThid )
      ENDIF
#endif /* ALLOW_OBCS */

#ifdef ALLOW_BBL
      IF ( useBBL ) CALL BBL_TENDENCY_APPLY_S(
     U                       gS_arr,
     I                       iMin,iMax,jMin,jMax, k, bi,bj,
     I                       myTime, 0, myThid )
#endif /* ALLOW_BBL */

#ifdef ALLOW_MYPACKAGE
      IF ( useMYPACKAGE ) THEN
        CALL MYPACKAGE_TENDENCY_APPLY_S(
     U                 gS_arr,
     I                 iMin,iMax,jMin,jMax, k, bi,bj,
     I                 myTime, 0, myThid )
      ENDIF
#endif /* ALLOW_MYPACKAGE */

#endif /* USE_OLD_EXTERNAL_FORCING */

      RETURN
      END

!                TESTING TAPENADE PUSH/POP MECHANISM
!     ===========================================================
!
! Tests randomly chosen sequences of PUSH/POP, on randomly chosen
! scalars and arrays of random types. Tests PUSH/POP sequences that
! happen during checkpointing. Tests the "repeated access" mechanism
! that is necessary for snapshot-LOOK and for Fixed-point adjoints.
!
! Does not test pointer PUSH/POP. Anyway, here we are only concerned
! with sizes, so testing on int*8 and int*4 should test just as well.
!
! This test is random: generates PUSH/POP of random sequences of variables.
! The sequence of variables corresponding to a "*" or a "(" in the
! CODE structure string depends only on the SEED and on the position of the
! symbol in the CODE string.
! The test will be identical for identical CODE string and SEED.
!
! Syntax: $> testpushpop F "*(* 3[* (*) 5[* (*)]]*) * L(*) *" 49
!  -- 1st arg is F or C to test with adBuffer.f or adBuffer.c
!  -- 3rd arg is the SEED for random
!  -- 2nd arg is the CODE structure string
!    -- * is a plain code portion, causing PUSH and POP of a sequence of variables
!    -- (CODE) is a checkpointed CODE, implying a snapshot
!    -- L(CODE) is a checkpointed CODE with a bwd and a fwd snapshots
!      * fwd snapshot sequence depends on the position of the "("
!      * bwd snapshot sequence depends on the position of the "L"
!    -- n[CODE] tells that the bwd sweep of CODE will be accessed repeatedly n times,
!      thus reading n times each pushed value.
!
! Compiling: $> gfortran testpushpop.f90 adStack.c -o testpushpop
!
! Running (see testpushpop.sh): $> testpushpop.sh | grep Error

MODULE TESTPUSHPOPUTILS

  LOGICAL :: TRACEON = .false.

  INTEGER*4 :: ARRAYI4(5000), RECVARRAYI4(5000)
  INTEGER*8 :: ARRAYI8(5000), RECVARRAYI8(5000)
  REAL*4    :: ARRAYR4(5000), RECVARRAYR4(5000)
  REAL*8    :: ARRAYR8(5000), RECVARRAYR8(5000)
  COMPLEX*8    :: ARRAYC8(5000), RECVARRAYC8(5000)
  COMPLEX*16    :: ARRAYC16(5000), RECVARRAYC16(5000)
  CHARACTER(len=5000) :: ARRAYCHAR, RECVARRAYCHAR
  INTEGER*4 :: FLOWDIRECTION, RECVFLOWDIRECTION
  LOGICAL :: BOOLEAN, RECVBOOLEAN

  CHARACTER(len=500) :: givenCode
  INTEGER :: codeLength

  INTEGER*4 :: givenSeed, seed1, seed2

  ! proportions in % of int4,+int8,+real4,+real8,+complex8,+complex16,+characters,+bits
  ! the last one, being the total of all, must be 100:
  INTEGER :: trajtypes(8)=(/30,35,50,80,83,85,90,100/)
  INTEGER ::  snptypes(8)=(/30,35,55,90,93,95,100,100/)
  INTEGER :: snpatypes(8)=(/30,35,55,90,93,95,100,100/)
  INTEGER :: snpbtypes(8)=(/30,35,55,90,93,95,100,100/)

CONTAINS
  ! My pseudo-random generator. Can probably be improved!
  SUBROUTINE nextrandom(seed)
    INTEGER*4 :: seed
    seed = MOD(seed*(1+seed), 32768)
  END SUBROUTINE nextrandom

  ! Random integer between 0 and imax-1 using random seed1 :
  INTEGER*4 FUNCTION drawinteger(imax)
    INTEGER :: imax
    CALL nextrandom(seed1)
    drawinteger = MOD(seed1,imax)
  END FUNCTION drawinteger

  ! returns the value of random seed1 :
  INTEGER*4 FUNCTION getseed1()
    getseed1 = seed1
  END FUNCTION getseed1

  REAL*8 FUNCTION mkr8(seed,mult)
    INTEGER :: seed
    REAL*8 :: mult, tmp
    tmp = seed*mult
    if (tmp<0) tmp=-tmp
    mkr8 = SQRT(tmp)
  END FUNCTION mkr8

  REAL*4 FUNCTION mkr4(seed,mult)
    INTEGER :: seed
    REAL*4 :: mult, tmp
    tmp = seed*mult
    if (tmp<0) tmp=-tmp
    mkr4 = SQRT(tmp)
  END FUNCTION mkr4

  ! All "fill" functions: for each basic type,
  ! (in int4, int8, real4, real8, complex8, complex16, characters, bits)
  ! fills (a "length" first elements of) this type's corresponding
  ! global storage variable with some pseudo-random values
  ! computed with internal random var "seed2", initialized with "seed".
  ! The "random" quality of these values is not very critical.

  SUBROUTINE fillboolean(seed)
    INTEGER :: seed,tmp
    seed2 = 2+4*seed
    CALL nextrandom(seed2)
    if (seed2>=0) then
       tmp=seed2
    else
       tmp=-seed2
    endif
    BOOLEAN = (MOD(tmp,256).ge.128) !! Build a vaguely random boolean (i.e. LOGICAL)
  END SUBROUTINE fillboolean

  SUBROUTINE fillcontrolNb(length, seed)
    INTEGER :: length, seed, tmp
    seed2 = 2+4*seed
    CALL nextrandom(seed2)
    if (seed2>=0) then
       tmp=seed2
    else
       tmp=-seed2
    endif
    FLOWDIRECTION = MOD(tmp,2**length) !! Build a vaguely random INTEGER*4 coded with "length" bits
  END SUBROUTINE fillcontrolNb

  SUBROUTINE fillchararray(length, seed)
    INTEGER :: length, seed, i, tmp
    seed2 = 2+4*seed
    do i=1,length
       CALL nextrandom(seed2)
       if (seed2>=0) then
          tmp=seed2
       else
          tmp=-seed2
       endif
       ARRAYCHAR(i:i) = CHAR(33+MOD(tmp,94)) !! Build a vaguely random CHARACTER between ascii 33 and 126
    end do
  END SUBROUTINE fillchararray

  SUBROUTINE fillc8array(length, seed)
    INTEGER :: length, seed, i
    REAL*8 :: rpart, ipart
    seed2 = 2+4*seed
    do i=1,length
       CALL nextrandom(seed2)
       rpart = mkr4(seed2,1.2_4) !! Build a vaguely random REAL*4
       CALL nextrandom(seed2)
       ipart = mkr4(seed2,1.2_4) !! Build a vaguely random REAL*4
       ARRAYC8(i) = CMPLX(rpart,ipart,8)
    end do
  END SUBROUTINE fillc8array

  SUBROUTINE fillc16array(length, seed)
    INTEGER :: length, seed, i
    REAL*8 :: rpart, ipart
    seed2 = 2+4*seed
    do i=1,length
       CALL nextrandom(seed2)
       rpart = mkr8(seed2,1.2_8) !! Build a vaguely random REAL*8
       CALL nextrandom(seed2)
       ipart = mkr8(seed2,1.2_8) !! Build a vaguely random REAL*8
       ARRAYC16(i) = CMPLX(rpart,ipart,16)
    end do
  END SUBROUTINE fillc16array

  SUBROUTINE filli4array(length, seed)
    INTEGER :: length, seed, i
    seed2 = 2+4*seed
    do i=1,length
       CALL nextrandom(seed2)
       ARRAYI4(i) = seed2 !! Build a vaguely random INTEGER*4
    end do
  END SUBROUTINE filli4array

  SUBROUTINE filli8array(length, seed)
    INTEGER :: length, seed, tmo
    seed2 = 2+4*seed
    do i=1,length
       CALL nextrandom(seed2)
       if (seed2>=0) then
          tmp=seed2
       else
          tmp=-seed2
       endif
       ARRAYI8(i) = seed2*tmp !! Build a vaguely random INTEGER*8
    end do
  END SUBROUTINE filli8array

  SUBROUTINE fillr4array(length, seed)
    INTEGER :: length, seed, i
    seed2 = 2+4*seed
    do i=1,length
       CALL nextrandom(seed2)
       ARRAYR4(i) = mkr4(seed2,1.2_4) !! Build a vaguely random REAL*4
    end do
  END SUBROUTINE fillr4array

  SUBROUTINE fillr8array(length, seed)
    INTEGER :: length, seed, i
    seed2 = 2+4*seed
    do i=1,length
       CALL nextrandom(seed2)
       ARRAYR8(i) = mkr8(seed2,1.1_8) !! Build a vaguely random REAL*8
    end do
  END SUBROUTINE fillr8array

END MODULE TESTPUSHPOPUTILS

PROGRAM testpushpop
  USE TESTPUSHPOPUTILS
  IMPLICIT NONE
  INTEGER :: indexopen, indexclose
  CHARACTER(len=1) :: traceOnString
  CHARACTER(len=10) :: seedstring
  IF (iargc().ne.3) THEN
     print *,"Usage: testpushpop <T for trace> ""<CodeStructure>"" <seed>"
  ELSE
     CALL get_command_argument(1,traceOnString)
     CALL get_command_argument(2,givenCode,codeLength)
     CALL get_command_argument(3,seedstring)
     READ (seedstring,'(I10)') givenSeed
     TRACEON = (traceOnString.eq.'T').or.(traceOnString.eq.'t').or.(traceOnString.eq.'1')
     WRITE(6,991) givenSeed,givenCode(1:codeLength)
     CALL runsweep(givenCode(1:codeLength), 0, 1)
     !CALL EMITSHOWSTACK("middle"//CHAR(0)) !!Trace
     CALL runsweep(givenCode(1:codeLength), 0, -1)
  END IF
 991  FORMAT('seed=',i4,' code=',a)
END PROGRAM testpushpop

SUBROUTINE getparenthindices(code,indexopen,indexclose)
  USE TESTPUSHPOPUTILS
  IMPLICIT NONE
  CHARACTER(len=*) :: code
  INTEGER indexopen, indexclose
  INTEGER index, length, depth

  length = LEN(code)
  index = 1
! Advance to the open parenth or square bracket:
  do while(index.le.length.and.code(index:index).ne.'('.and.code(index:index).ne.'[')
     index = index+1
  enddo
  indexopen = index
  index = index+1
  depth = 1
! Find the corresponding closing parenth or square bracket or the end of string:
  do while(index.le.length.and.(depth.ne.1.or.(code(index:index).ne.')'.and.code(index:index).ne.']')))
     if (code(index:index).eq.'('.or.code(index:index).eq.'[') then
        depth = depth+1
     else if (code(index:index).eq.')'.or.code(index:index).eq.']') then
        depth = depth-1
     end if
     index = index+1
  enddo
  if (index.eq.length+1.and.depth.ne.0) then
     print *,'Missing closing in CodeStructure'
  end if
  indexclose = index
END SUBROUTINE getparenthindices

RECURSIVE SUBROUTINE runsweep(code, globaloffset, direction)
  USE TESTPUSHPOPUTILS
  IMPLICIT NONE
  CHARACTER(len=*) code
  INTEGER globaloffset, totaloffset, direction
  INTEGER index, length, repeat
  INTEGER indexopen, indexclose
  INTEGER ii
  !print *,'            runsweep on ',code,' offset:',globaloffset
  repeat = -1
  index = 1
  length = LEN(code)
! Skip white spaces:
  do while(index.le.length.and.(code(index:index).eq.' '.or.code(index:index).eq.'     '))
     index = index+1
  enddo
  totaloffset = globaloffset+index

! The next token is either '(' or 'endOfString' or [1..9] or '*' or 'L'
  if (index.gt.length) then
!   do nothing and return.

! CHECKPOINT WITH LOOK SNAPSHOT MECHANISM:
  else if (code(index:index).eq.'L') then
     CALL getparenthindices(code(index+1:),indexopen,indexclose)
     if (direction.eq.1) then
        CALL emitpushpopsequence(totaloffset, 10, snpatypes, 60, 1,'TAKE SNP A at',2)
        CALL emitpushpopsequence(totaloffset+indexopen, 10, snpbtypes, 70, 1,'TAKE SNP B at',2)
     end if
     CALL runsweep(code(index+indexclose+1:), totaloffset+indexclose, direction)
     if (direction.eq.-1) then
        CALL emitpushpopsequence(totaloffset+indexopen, 10, snpbtypes, 70, -1,' POP SNP B at',-2)
        CALL emitstartrepeat()
        CALL emitpushpopsequence(totaloffset, 10, snpatypes, 60, -1,'LOOK SNP A at',-3)
        CALL emitresetrepeat()
        CALL emitendrepeat()
        CALL runsweep(code(index+indexopen+1:index+indexclose-1), totaloffset+indexopen, 1)
        CALL runsweep(code(index+indexopen+1:index+indexclose-1), totaloffset+indexopen, -1)
        CALL emitpushpopsequence(totaloffset, 10, snpatypes, 60, -1,' POP SNP A at',-2)
     end if

! CHECKPOINT WITH PLAIN PUSH-POP SNAPSHOT:
  else if (code(index:index).eq.'(') then
     CALL getparenthindices(code(index:),indexopen,indexclose)
     if (direction.eq.1) then
        CALL emitpushpopsequence(totaloffset, 20, snptypes, 70, 1,'TAKE SNP at',2)
     end if
     CALL runsweep(code(index-1+indexclose+1:), totaloffset-1+indexclose, direction)
     if (direction.eq.-1) then
        CALL emitpushpopsequence(totaloffset, 20, snptypes, 70, -1,' POP SNP at',-2)
        CALL runsweep(code(index-1+indexopen+1:index-1+indexclose-1), totaloffset-1+indexopen, 1)
        CALL runsweep(code(index-1+indexopen+1:index-1+indexclose-1), totaloffset-1+indexopen, -1)
     end if

! PLAIN CODE:
  else if (code(index:index).eq.'*') then
     if (direction.eq.1) then
        CALL emitpushpopsequence(totaloffset, 80, trajtypes, 25, 1,'PUSHes part',1)
     end if
     CALL runsweep(code(index+1:), totaloffset, direction)
     if (direction.eq.-1) then
        CALL emitpushpopsequence(totaloffset, 80, trajtypes, 25, -1,'  POPs part',-1)
     end if

! CODE WITH ONE PUSH AND REPEATED POPS (e.g. FIXED-POINT ADJOINT):
  else if (code(index:index).gt.'0'.and.code(index:index).le.'9') then
     READ (code(index:index),'(I1)') repeat
     CALL getparenthindices(code(index+1:),indexopen,indexclose)
     if (direction.eq.1) then
        CALL runsweep(code(index-1+indexopen+2:index+indexclose-1), totaloffset+indexopen, 1)
     endif
     CALL runsweep(code(index+indexclose+1:), totaloffset+indexclose, direction)
     if (direction.eq.-1) then
        CALL emitstartrepeat()
        DO ii=1,repeat
           CALL runsweep(code(index-1+indexopen+2:index+indexclose-1), totaloffset+indexopen, -1)
           if (ii.ne.repeat) then
              CALL emitresetrepeat()
           else
              CALL emitendrepeat()
           endif
        ENDDO
     end if

  else
     print *,'Unexpected CodeStructure substring:',code(index:)
  end if
END SUBROUTINE runsweep

! index is the index in the code string of the "*" that stands
!  for this pushpop sequence. Index is used as the random seed.
! ppmax is the max number of push'es or pop's in sequence
! proportiontypes is the array of proportions in % of
! (int4,+int8,+real4,+real8,+complex8,+complex16,+characters,+bits)
! the last one, being the total of all, must be 100.
! action is 1 for PUSH and -1 for POP
SUBROUTINE emitpushpopsequence(index, ppmax, proportiontypes, proportionarrays, action, msg, op)
  USE TESTPUSHPOPUTILS
  IMPLICIT NONE
  INTEGER :: index, ppmax, proportiontypes(8), proportionarrays, action, op
  CHARACTER(*) :: msg
  INTEGER :: number, sort, isarray, arraylen, i
  INTEGER :: sorts(200), sizes(200), seeds(200)
  INTEGER :: iterfrom, iterto, iterstride
  ! initialize random seed1 using only index & givenSeed
  seed1 = 2+4*index*(givenSeed+index)
  number = drawinteger(ppmax)
  DO i=1,number
     sort = drawinteger(100)
     if (sort<proportiontypes(1)) then
        sorts(i) = 1
     else if (sort<proportiontypes(2)) then
        sorts(i) = 2
     else if (sort<proportiontypes(3)) then
        sorts(i) = 3
     else if (sort<proportiontypes(4)) then
        sorts(i) = 4
     else if (sort<proportiontypes(5)) then
        sorts(i) = 5
     else if (sort<proportiontypes(6)) then
        sorts(i) = 6
     else if (sort<proportiontypes(7)) then
        sorts(i) = 7
     else
        sorts(i) = 8
     endif
     isarray = drawinteger(100)
     if (isarray<proportionarrays) then
        if (sorts(i).eq.8) then
           !Case of push/pop control, limited to 6 bits:
           arraylen = drawinteger(6) !!Suggested 6
        else if (sorts(i).eq.7) then
           !Case of push/pop character arrays, limited to 80 bytes:
           arraylen = drawinteger(80) !!Suggested 80
        else
           arraylen = drawinteger(33) !!Suggested 33
           if (arraylen.ge.30) then
              arraylen = (arraylen-30)*1000 + drawinteger(999)
           else if (arraylen.ge.20) then
              arraylen = (arraylen-20)*100 + drawinteger(99)
           else if (arraylen.ge.10) then
              arraylen = (arraylen-10)*10 + drawinteger(9)
           end if
        endif
     else
        arraylen = -1 !Means scalar
     endif
     sizes(i) = arraylen
     seeds(i) = getseed1()+index
  END DO
  !CALL SHOWPUSHPOPSEQUENCE(op, index, number, sorts, sizes) !!Trace
  if (action.eq.1) then
     iterfrom=1
     iterto=number
     iterstride=1
  else
     iterfrom=number
     iterto=1
     iterstride=-1
  endif
  DO i=iterfrom,iterto,iterstride
     SELECT CASE (sorts(i))
     CASE (1) !int4
        if (sizes(i).eq.-1) then
           call filli4array(1, seeds(i))
           if (action.eq.1) then              ! PUSH
              call emitpushi4scalar()
           else                               ! POP
              CALL emitpopi4scalar()
           endif
        else
           call filli4array(sizes(i), seeds(i))
           if (action.eq.1) then              ! PUSH
              call emitpushi4array(sizes(i))
           else                               ! POP
              CALL emitpopi4array(sizes(i))
           endif
        endif
     CASE (2) !int8
        if (sizes(i).eq.-1) then
           call filli8array(1, seeds(i))
           if (action.eq.1) then              ! PUSH
              call emitpushi8scalar()
           else                               ! POP
              CALL emitpopi8scalar()
           endif
        else
           call filli8array(sizes(i), seeds(i))
           if (action.eq.1) then              ! PUSH
              call emitpushi8array(sizes(i))
           else                               ! POP
              CALL emitpopi8array(sizes(i))
           endif
        endif
     CASE (3) !real4
        if (sizes(i).eq.-1) then
           call fillr4array(1, seeds(i))
           if (action.eq.1) then              ! PUSH
              call emitpushr4scalar()
           else                               ! POP
              CALL emitpopr4scalar()
           endif
        else
           call fillr4array(sizes(i), seeds(i))
           if (action.eq.1) then              ! PUSH
              call emitpushr4array(sizes(i))
           else                               ! POP
              CALL emitpopr4array(sizes(i))
           endif
        endif
     CASE (4) !real8
        if (sizes(i).eq.-1) then
           call fillr8array(1, seeds(i))
           if (action.eq.1) then              ! PUSH
              call emitpushr8scalar()
           else                               ! POP
              CALL emitpopr8scalar()
           endif
        else
           call fillr8array(sizes(i), seeds(i))
           if (action.eq.1) then              ! PUSH
              call emitpushr8array(sizes(i))
           else                               ! POP
              CALL emitpopr8array(sizes(i))
           endif
        endif
     CASE (5) !complex8
        if (sizes(i).eq.-1) then
           call fillc8array(1, seeds(i))
           if (action.eq.1) then              ! PUSH
              call emitpushc8scalar()
           else                               ! POP
              CALL emitpopc8scalar()
           endif
        else
           call fillc8array(sizes(i), seeds(i))
           if (action.eq.1) then              ! PUSH
              call emitpushc8array(sizes(i))
           else                               ! POP
              CALL emitpopc8array(sizes(i))
           endif
        endif
     CASE (6) !complex16
        if (sizes(i).eq.-1) then
           call fillc16array(1, seeds(i))
           if (action.eq.1) then              ! PUSH
              call emitpushc16scalar()
           else                               ! POP
              CALL emitpopc16scalar()
           endif
        else
           call fillc16array(sizes(i), seeds(i))
           if (action.eq.1) then              ! PUSH
              call emitpushc16array(sizes(i))
           else                               ! POP
              CALL emitpopc16array(sizes(i))
           endif
        endif
     CASE (7) !characters
        if (sizes(i).eq.-1) then
           call fillchararray(1, seeds(i))
           if (action.eq.1) then              ! PUSH
              call emitpushcharacter()
           else                               ! POP
              CALL emitpopcharacter()
           endif
        else
           call fillchararray(sizes(i), seeds(i))
           if (action.eq.1) then              ! PUSH
              call emitpushcharacterarray(sizes(i))
           else                               ! POP
              CALL emitpopcharacterarray(sizes(i))
           endif
        endif
     CASE (8) !bits or control-flow directions
        if (sizes(i).le.0) then !bits
           call fillboolean(seeds(i))
           if (action.eq.1) then              ! PUSH
              call emitpushboolean()
           else                               ! POP
              CALL emitpopboolean()
           endif
        else  !control-flow directions
           call fillcontrolNb(sizes(i), seeds(i))
           if (action.eq.1) then              ! PUSH
              call emitpushcontrolNb(sizes(i))
           else                               ! POP
              CALL emitpopcontrolNb(sizes(i))
           endif
        endif
     END SELECT
  END DO
  !CALL EMITSHOWSTACKSIZE() ; !!Trace
END SUBROUTINE emitpushpopsequence

SUBROUTINE emitpushboolean()
  USE TESTPUSHPOPUTILS
  IMPLICIT NONE
  INTEGER*4 LOCSTRB,LOCSTRO
  IF (TRACEON) print *,'PUSHBOOLEAN(',BOOLEAN,') AT ',LOCSTRB(),LOCSTRO()
  CALL PUSHBOOLEAN(BOOLEAN)
END SUBROUTINE emitpushboolean

SUBROUTINE emitpopboolean()
  USE TESTPUSHPOPUTILS
  IMPLICIT NONE
  INTEGER*4 LOCSTRB,LOCSTRO
  CALL POPBOOLEAN(RECVBOOLEAN)
  IF (TRACEON) print *,'POPBOOLEAN(',RECVBOOLEAN,') AT ',LOCSTRB(),LOCSTRO()  
  if (RECVBOOLEAN.neqv.BOOLEAN) then
     print *,'Error boolean pushed ',BOOLEAN,' popped ',RECVBOOLEAN,   &
 &           ' seed:',givenSeed,' code:',givenCode(1:codeLength)
     stop
  end if
END SUBROUTINE emitpopboolean

SUBROUTINE emitpushcontrolNb(size)
  USE TESTPUSHPOPUTILS
  IMPLICIT NONE
  INTEGER size
  SELECT CASE (size)
  CASE (1)
     CALL PUSHCONTROL1B(FLOWDIRECTION)
  CASE (2)
     CALL PUSHCONTROL2B(FLOWDIRECTION)
  CASE (3)
     CALL PUSHCONTROL3B(FLOWDIRECTION)
  CASE (4)
     CALL PUSHCONTROL4B(FLOWDIRECTION)
  CASE (5)
     CALL PUSHCONTROL5B(FLOWDIRECTION)
  CASE (6)
     CALL PUSHCONTROL6B(FLOWDIRECTION)
  CASE (7)
     CALL PUSHCONTROL7B(FLOWDIRECTION)
  CASE (8)
     CALL PUSHCONTROL8B(FLOWDIRECTION)
  END SELECT
END SUBROUTINE emitpushcontrolNb

SUBROUTINE emitpopcontrolNb(size)
  USE TESTPUSHPOPUTILS
  IMPLICIT NONE
  INTEGER :: size
  SELECT CASE (size)
  CASE (1)
     CALL POPCONTROL1B(RECVFLOWDIRECTION)
  CASE (2)
     CALL POPCONTROL2B(RECVFLOWDIRECTION)
  CASE (3)
     CALL POPCONTROL3B(RECVFLOWDIRECTION)
  CASE (4)
     CALL POPCONTROL4B(RECVFLOWDIRECTION)
  CASE (5)
     CALL POPCONTROL5B(RECVFLOWDIRECTION)
  CASE (6)
     CALL POPCONTROL6B(RECVFLOWDIRECTION)
  CASE (7)
     CALL POPCONTROL7B(RECVFLOWDIRECTION)
  CASE (8)
     CALL POPCONTROL8B(RECVFLOWDIRECTION)
  END SELECT
  if (RECVFLOWDIRECTION.ne.FLOWDIRECTION) then
     print *,'Error flow direction pushed ',FLOWDIRECTION,' popped ',RECVFLOWDIRECTION,   &
 &           ' seed:',givenSeed,' code:',givenCode(1:codeLength)
     stop
  end if
END SUBROUTINE emitpopcontrolNb

SUBROUTINE emitpushcharacter()
  USE TESTPUSHPOPUTILS
  IMPLICIT NONE
  CALL PUSHCHARACTER(ARRAYCHAR(1:1))
END SUBROUTINE emitpushcharacter

SUBROUTINE emitpopcharacter()
  USE TESTPUSHPOPUTILS
  IMPLICIT NONE
     CALL POPCHARACTER(RECVARRAYCHAR(1:1))
  if (RECVARRAYCHAR(1:1).ne.ARRAYCHAR(1:1)) then
     print *,'Error character pushed ',ARRAYCHAR(1:1),' popped ',RECVARRAYCHAR(1:1),   &
 &           ' seed:',givenSeed,' code:',givenCode(1:codeLength)
     stop
  end if
END SUBROUTINE emitpopcharacter

SUBROUTINE emitpushcharacterarray(size)
  USE TESTPUSHPOPUTILS
  IMPLICIT NONE
  INTEGER size
  CALL PUSHCHARACTERARRAY(ARRAYCHAR, size)
END SUBROUTINE emitpushcharacterarray

SUBROUTINE emitpopcharacterarray(size)
  USE TESTPUSHPOPUTILS
  IMPLICIT NONE
  INTEGER :: size
  CALL POPCHARACTERARRAY(RECVARRAYCHAR, size)
  if (RECVARRAYCHAR(1:size).ne.ARRAYCHAR(1:size)) then
     print *,'Error character array pushed ',ARRAYCHAR(1:size),' popped ',RECVARRAYCHAR(1:size),   &
 &           ' seed:',givenSeed,' code:',givenCode(1:codeLength)
     stop
  end if
END SUBROUTINE emitpopcharacterarray

SUBROUTINE emitpushc8scalar()
  USE TESTPUSHPOPUTILS
  IMPLICIT NONE
  INTEGER*4 LOCSTRB,LOCSTRO
  IF (TRACEON) print *,'PUSHCOMPLEX8(',ARRAYC8(1),') AT ',LOCSTRB(),LOCSTRO()
  CALL PUSHCOMPLEX8(ARRAYC8(1))
END SUBROUTINE emitpushc8scalar

SUBROUTINE emitpopc8scalar()
  USE TESTPUSHPOPUTILS
  IMPLICIT NONE
  INTEGER*4 LOCSTRB,LOCSTRO
  CALL POPCOMPLEX8(RECVARRAYC8(1))
  IF (TRACEON) print *,'POPCOMPLEX8(',RECVARRAYC8(1),') AT ',LOCSTRB(),LOCSTRO()
  if (RECVARRAYC8(1).ne.ARRAYC8(1)) then
     print *,'Error complex8 scalar pushed ',ARRAYC8(1),' popped ',RECVARRAYC8(1),   &
 &           ' seed:',givenSeed,' code:',givenCode(1:codeLength)
     stop
  end if
END SUBROUTINE emitpopc8scalar

SUBROUTINE emitpushc8array(size)
  USE TESTPUSHPOPUTILS
  IMPLICIT NONE
  INTEGER size
  CALL PUSHCOMPLEX8ARRAY(ARRAYC8, size)
END SUBROUTINE emitpushc8array

SUBROUTINE emitpopc8array(size)
  USE TESTPUSHPOPUTILS
  IMPLICIT NONE
  INTEGER :: size, i
  CALL POPCOMPLEX8ARRAY(RECVARRAYC8, size)
  DO i=1,size
     if (RECVARRAYC8(i).ne.ARRAYC8(i)) then
        print *,'Error complex8 array elem ',i,' pushed ',ARRAYC8(i),' popped ',RECVARRAYC8(i),   &
 &           ' seed:',givenSeed,' code:',givenCode(1:codeLength)
        stop
     end if
  END DO
END SUBROUTINE emitpopc8array

SUBROUTINE emitpushc16scalar()
  USE TESTPUSHPOPUTILS
  IMPLICIT NONE
  CALL PUSHCOMPLEX16(ARRAYC16(1))
END SUBROUTINE emitpushc16scalar

SUBROUTINE emitpopc16scalar()
  USE TESTPUSHPOPUTILS
  IMPLICIT NONE
  CALL POPCOMPLEX16(RECVARRAYC16(1))
  if (RECVARRAYC16(1).ne.ARRAYC16(1)) then
     print *,'Error complex16 scalar pushed ',ARRAYC16(1),' popped ',RECVARRAYC16(1),   &
 &           ' seed:',givenSeed,' code:',givenCode(1:codeLength)
     stop
  end if
END SUBROUTINE emitpopc16scalar

SUBROUTINE emitpushc16array(size)
  USE TESTPUSHPOPUTILS
  IMPLICIT NONE
  INTEGER size
  CALL PUSHCOMPLEX16ARRAY(ARRAYC16, size)
END SUBROUTINE emitpushc16array

SUBROUTINE emitpopc16array(size)
  USE TESTPUSHPOPUTILS
  IMPLICIT NONE
  INTEGER :: size, i
  CALL POPCOMPLEX16ARRAY(RECVARRAYC16, size)
  DO i=1,size
     if (RECVARRAYC16(i).ne.ARRAYC16(i)) then
        print *,'Error complex16 array elem ',i,' pushed ',ARRAYC16(i),' popped ',RECVARRAYC16(i),   &
 &           ' seed:',givenSeed,' code:',givenCode(1:codeLength)
        stop
     end if
  END DO
END SUBROUTINE emitpopc16array

SUBROUTINE emitpushr4scalar()
  USE TESTPUSHPOPUTILS
  IMPLICIT NONE
  INTEGER*4 LOCSTRB,LOCSTRO
  IF (TRACEON) print *,'PUSHREAL4(',ARRAYR4(1),') AT ',LOCSTRB(),LOCSTRO()
  CALL PUSHREAL4(ARRAYR4(1))
END SUBROUTINE emitpushr4scalar

SUBROUTINE emitpopr4scalar()
  USE TESTPUSHPOPUTILS
  IMPLICIT NONE
  INTEGER*4 LOCSTRB,LOCSTRO
  CALL POPREAL4(RECVARRAYR4(1))
  IF (TRACEON) print *,'POPREAL4(',RECVARRAYR4(1),') AT ',LOCSTRB(),LOCSTRO()
  if (RECVARRAYR4(1).ne.ARRAYR4(1)) then
     print *,'Error real4 scalar pushed ',ARRAYR4(1),' popped ',RECVARRAYR4(1),   &
 &           ' seed:',givenSeed,' code:',givenCode(1:codeLength)
     stop
  end if
END SUBROUTINE emitpopr4scalar

SUBROUTINE emitpushr4array(size)
  USE TESTPUSHPOPUTILS
  IMPLICIT NONE
  INTEGER size
  INTEGER*4 LOCSTRB,LOCSTRO
  IF (TRACEON) print *,'PUSHREAL4ARRAY(',size,":",ARRAYR4(1),'...) AT ',LOCSTRB(),LOCSTRO()
  CALL PUSHREAL4ARRAY(ARRAYR4, size)
END SUBROUTINE emitpushr4array

SUBROUTINE emitpopr4array(size)
  USE TESTPUSHPOPUTILS
  IMPLICIT NONE
  INTEGER :: size, i
  INTEGER*4 LOCSTRB,LOCSTRO
  CALL POPREAL4ARRAY(RECVARRAYR4, size)
  IF (TRACEON) print *,'POPREAL4ARRAY(',size,":",RECVARRAYR4(1),'...) AT ',LOCSTRB(),LOCSTRO()
  DO i=1,size
     if (RECVARRAYR4(i).ne.ARRAYR4(i)) then
        print *,'Error real4 array elem ',i,' pushed ',ARRAYR4(i),' popped ',RECVARRAYR4(i),   &
 &           ' seed:',givenSeed,' code:',givenCode(1:codeLength)
        stop
     end if
  END DO
END SUBROUTINE emitpopr4array

SUBROUTINE emitpushr8scalar()
  USE TESTPUSHPOPUTILS
  IMPLICIT NONE
  INTEGER*4 LOCSTRB,LOCSTRO
  IF (TRACEON) print *,'PUSHREAL8(',ARRAYR8(1),') AT ',LOCSTRB(),LOCSTRO()
  CALL PUSHREAL8(ARRAYR8(1))
END SUBROUTINE emitpushr8scalar

SUBROUTINE emitpopr8scalar()
  USE TESTPUSHPOPUTILS
  IMPLICIT NONE
  INTEGER*4 LOCSTRB,LOCSTRO
  CALL POPREAL8(RECVARRAYR8(1))
  IF (TRACEON) print *,'POPREAL8(',RECVARRAYR8(1),') AT ',LOCSTRB(),LOCSTRO()
  if (RECVARRAYR8(1).ne.ARRAYR8(1)) then
     print *,'Error real8 scalar pushed ',ARRAYR8(1),' popped ',RECVARRAYR8(1),   &
 &           ' seed:',givenSeed,' code:',givenCode(1:codeLength)
     stop
  end if
END SUBROUTINE emitpopr8scalar

SUBROUTINE emitpushr8array(size)
  USE TESTPUSHPOPUTILS
  IMPLICIT NONE
  INTEGER size
  INTEGER*4 LOCSTRB,LOCSTRO
  IF (TRACEON) print *,'PUSHREAL8ARRAY(',size,":",ARRAYR8(1),'...) AT ',LOCSTRB(),LOCSTRO()
  CALL PUSHREAL8ARRAY(ARRAYR8, size)
END SUBROUTINE emitpushr8array

SUBROUTINE emitpopr8array(size)
  USE TESTPUSHPOPUTILS
  IMPLICIT NONE
  INTEGER :: size, i
  INTEGER*4 LOCSTRB,LOCSTRO
  CALL POPREAL8ARRAY(RECVARRAYR8, size)
  IF (TRACEON) print *,'POPREAL8ARRAY(',size,":",RECVARRAYR8(1),'...) AT ',LOCSTRB(),LOCSTRO()
  DO i=1,size
     if (RECVARRAYR8(i).ne.ARRAYR8(i)) then
        print *,'Error real8 array elem ',i,' pushed ',ARRAYR8(i),' popped ',RECVARRAYR8(i),   &
 &           ' seed:',givenSeed,' code:',givenCode(1:codeLength)
        stop
     end if
  END DO
END SUBROUTINE emitpopr8array

SUBROUTINE emitpushi4scalar()
  USE TESTPUSHPOPUTILS
  IMPLICIT NONE
  INTEGER*4 LOCSTRB,LOCSTRO
  IF (TRACEON) print *,'PUSHINTEGER4(',ARRAYI4(1),') AT ',LOCSTRB(),LOCSTRO()
  CALL PUSHINTEGER4(ARRAYI4(1))
END SUBROUTINE emitpushi4scalar

SUBROUTINE emitpopi4scalar()
  USE TESTPUSHPOPUTILS
  IMPLICIT NONE
  INTEGER*4 LOCSTRB,LOCSTRO
  CALL POPINTEGER4(RECVARRAYI4(1))
  IF (TRACEON) print *,'POPINTEGER4(',RECVARRAYI4(1),') AT ',LOCSTRB(),LOCSTRO()
  if (RECVARRAYI4(1).ne.ARRAYI4(1)) then
     print *,'Error integer4 scalar pushed ',ARRAYI4(1),' popped ',RECVARRAYI4(1),   &
 &           ' seed:',givenSeed,' code:',givenCode(1:codeLength)
     stop
  end if
END SUBROUTINE emitpopi4scalar

SUBROUTINE emitpushi4array(size)
  USE TESTPUSHPOPUTILS
  IMPLICIT NONE
  INTEGER size
  INTEGER*4 LOCSTRB,LOCSTRO
  IF (TRACEON) print *,'PUSHINTEGER4ARRAY(',size,":",ARRAYI4(1),'...) AT ',LOCSTRB(),LOCSTRO()
  CALL PUSHINTEGER4ARRAY(ARRAYI4, size)
END SUBROUTINE emitpushi4array

SUBROUTINE emitpopi4array(size)
  USE TESTPUSHPOPUTILS
  IMPLICIT NONE
  INTEGER :: size,i
  INTEGER*4 LOCSTRB,LOCSTRO
  CALL POPINTEGER4ARRAY(RECVARRAYI4, size)
  IF (TRACEON) print *,'POPINTEGER4ARRAY(',size,":",RECVARRAYI4(1),'...) AT ',LOCSTRB(),LOCSTRO()
  DO i=1,size
     if (RECVARRAYI4(i).ne.ARRAYI4(i)) then
        print *,'Error integer4 array elem ',i,' pushed ',ARRAYI4(i),' popped ',RECVARRAYI4(i),   &
 &           ' seed:',givenSeed,' code:',givenCode(1:codeLength)
        stop
     end if
  END DO
END SUBROUTINE emitpopi4array

SUBROUTINE emitpushi8scalar()
  USE TESTPUSHPOPUTILS
  IMPLICIT NONE
  INTEGER*4 LOCSTRB,LOCSTRO
  IF (TRACEON) print *,'PUSHINTEGER8(',ARRAYI8(1),') AT ',LOCSTRB(),LOCSTRO()
  CALL PUSHINTEGER8(ARRAYI8(1))
END SUBROUTINE emitpushi8scalar

SUBROUTINE emitpopi8scalar()
  USE TESTPUSHPOPUTILS
  IMPLICIT NONE
  INTEGER*4 LOCSTRB,LOCSTRO
  CALL POPINTEGER8(RECVARRAYI8(1))
  IF (TRACEON) print *,'POPINTEGER8(',RECVARRAYI8(1),') AT ',LOCSTRB(),LOCSTRO()
  if (RECVARRAYI8(1).ne.ARRAYI8(1)) then
     print *,'Error integer8 scalar pushed ',ARRAYI8(1),' popped ',RECVARRAYI8(1),   &
 &           ' seed:',givenSeed,' code:',givenCode(1:codeLength)
     stop
  end if
END SUBROUTINE emitpopi8scalar

SUBROUTINE emitpushi8array(size)
  USE TESTPUSHPOPUTILS
  IMPLICIT NONE
  INTEGER size
  CALL PUSHINTEGER8ARRAY(ARRAYI8, size)
END SUBROUTINE emitpushi8array

SUBROUTINE emitpopi8array(size)
  USE TESTPUSHPOPUTILS
  IMPLICIT NONE
  INTEGER :: size,i
  CALL POPINTEGER8ARRAY(RECVARRAYI8, size)
  DO i=1,size
     if (RECVARRAYI8(i).ne.ARRAYI8(i)) then
        print *,'Error integer8 array elem ',i,' pushed ',ARRAYI8(i),' popped ',RECVARRAYI8(i),   &
 &           ' seed:',givenSeed,' code:',givenCode(1:codeLength)
        stop
     end if
  END DO
END SUBROUTINE emitpopi8array

SUBROUTINE emitstartrepeat()
  USE TESTPUSHPOPUTILS
  INTEGER*4 LOCSTRB,LOCSTRO
  IF (TRACEON) print *,'adStack_startRepeat() AT ',LOCSTRB(),LOCSTRO()
  CALL ADSTACK_STARTREPEAT()
END SUBROUTINE emitstartrepeat

SUBROUTINE emitresetrepeat()
  USE TESTPUSHPOPUTILS
  INTEGER*4 LOCSTRB,LOCSTRO
  IF (TRACEON) print *,'adStack_resetRepeat() AT ',LOCSTRB(),LOCSTRO()
  CALL ADSTACK_RESETREPEAT()
  IF (TRACEON) print *,'-----------------------> ',LOCSTRB(),LOCSTRO()
END SUBROUTINE emitresetrepeat

SUBROUTINE emitendrepeat()
  USE TESTPUSHPOPUTILS
  INTEGER*4 LOCSTRB,LOCSTRO
  IF (TRACEON) print *,'adStack_endRepeat() AT ',LOCSTRB(),LOCSTRO()
  CALL ADSTACK_ENDREPEAT()
END SUBROUTINE emitendrepeat

!! Only for Trace:
SUBROUTINE emitshowstacksize()
  USE TESTPUSHPOPUTILS
  CALL ADSTACK_SHOWSTACKSIZE()
END SUBROUTINE emitshowstacksize

SUBROUTINE emitshowstack(locationName)
  USE TESTPUSHPOPUTILS
  CHARACTER(*) locationName
  CALL ADSTACK_SHOWSTACK(locationName)
END SUBROUTINE emitshowstack

#include "MOM_COMMON_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: MOM_W_SMAG_3D

C     !INTERFACE:
      SUBROUTINE MOM_W_SMAG_3D(
     I        str13, str23, str33,
     I        viscAh3d_00, viscAh3d_13, viscAh3d_23,
     I        rThickC_W, rThickC_S, rThickC_C, recip_rThickC,
     O        wDissip,
     I        iMin,iMax,jMin,jMax, k, bi, bj, myThid )

C     !DESCRIPTION:

C     !USES:
      IMPLICIT NONE

C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"

C     !INPUT PARAMETERS:
C     rThickC_W     :: thickness (in r-units) of W-Cell at Western Edge
C     rThickC_S     :: thickness (in r-units) of W-Cell at Southern Edge
C     rThickC_C     :: thickness (in r-units) of W-Cell (centered on W pt)
C     recip_rThickC :: reciprol thickness of W-Cell (centered on W-point)
C     iMin,iMax     :: 1rst index loop ranges
C     jMin,jMax     :: 2nd  index loop ranges
      _RL str13(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr+1)
      _RL str23(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr+1)
      _RL str33(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL viscAh3d_00(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL viscAh3d_13(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr+1)
      _RL viscAh3d_23(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr+1)
      _RL rThickC_W    (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL rThickC_S    (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL rThickC_C    (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL recip_rThickC(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER iMin,iMax, jMin,jMax
      INTEGER k, bi, bj
      INTEGER myThid

C     !OUTPUT PARAMETERS:
      _RL wDissip(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
CEOP

#ifdef ALLOW_SMAG_3D
C     !LOCAL VARIABLES:
      INTEGER i,j
      INTEGER km1
      _RL maskM1

      km1 = MAX(1,k-1)
      maskM1 = 1.
      IF ( k.LE.1 ) maskM1 = 0.

C     - Laplacian and bi-harmonic terms
c     IF (harmonic) THEN

C- note: free-slip @ bottom is commented out

C-    use simple (momentum conserving) scaling
C      (but not conserving angular momentum)

       DO j= jMin,jMax
        DO i= iMin,iMax
c        wDissip(i,j) = recip_rThickC(i,j)*
         wDissip(i,j) =
     &                  recip_rA(i,j,bi,bj)*(
     &     ( viscAh3d_13(i+1, j , k )*str13(i+1, j ,k)
c    &         *dyG(i+1, j ,bi,bj)*rThickC_W(i+1, j )
     &         *dyG(i+1, j ,bi,bj)
     &      -viscAh3d_13( i , j , k )*str13( i , j ,k)
c    &         *dyG( i , j ,bi,bj)*rThickC_W( i , j )
     &         *dyG( i , j ,bi,bj)
     &     )
     &    +( viscAh3d_23( i ,j+1, k )*str23( i ,j+1,k)
c    &         *dxG( i ,j+1,bi,bj)*rThickC_S( i ,j+1)
     &         *dxG( i ,j+1,bi,bj)
     &      -viscAh3d_23( i , j , k )*str23( i , j ,k)
c    &         *dxG( i , j ,bi,bj)*rThickC_S( i , j )
     &         *dxG( i , j ,bi,bj)
     &     )                                 )
     &                + recip_rThickC(i,j)
     &    *( viscAh3d_00( i , j , k )*str33( i , j , k )
     &      -viscAh3d_00( i , j ,km1)*str33( i , j ,km1)*maskM1
     &     )*rkSign
        ENDDO
       ENDDO

c     ENDIF

c     IF (biharmonic) THEN
c      STOP 'MOM_UV_SMAG_3D: BIHARMONIC NOT ALLOWED WITH SMAG_3D'
c     ENDIF

#endif /* ALLOW_SMAG_3D */
      RETURN
      END

#include "GAD_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C !ROUTINE: SALT_FILL
C !INTERFACE: ==========================================================
      SUBROUTINE SALT_FILL(
     I     uVel, vVel,
     U     salt,
     I     flag,myTime,myIter,myThid)

C !DESCRIPTION:
C Fills in negatives for the salt (specific humidity) field
C
C The algorithm is as follows:
C
C Simplest scheme (flag = 1) -> borrow from below and create
C                               salt if needed at bottom level
C 'Get it back'   (flag = 2) -> Fill negative of salt by getting it
C                               back from where it went
C     If no immediate surrounding value is large enough to fill negative,
C     the sum of immediate surrounding positive values is tried.
C     If sum is not large enough, salt is simply set to zero.
C  NOTE AS OF 6/2/06 -- DO NOT USE FLAG=2 OPTION - NOT WORKING

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"

C !INPUT PARAMETERS: ===================================================
C  uVel              :: zonal velocity component
C  vVel              :: meridional velocity component
C  salt              :: salt field
C  flag              :: integer flag telling scheme how to fill
C  myTime            :: current time
C  myIter            :: iteration number
C  myThid            :: thread number
C !OUTPUT PARAMETERS: ==================================================
C  salt             :: salt array is replaced
      _RL uVel (1-Olx:sNx+Olx,1-Oly:sNy+Oly,Nr,nSx,nSy)
      _RL vVel (1-Olx:sNx+Olx,1-Oly:sNy+Oly,Nr,nSx,nSy)
      _RL salt (1-Olx:sNx+Olx,1-Oly:sNy+Oly,Nr,nSx,nSy)
      INTEGER flag
      _RL myTime
      INTEGER myIter
      INTEGER myThid
CEOP

C     !FUNCTIONS:
c#ifdef ALLOW_DIAGNOSTICS
c     LOGICAL  DIAGNOSTICS_IS_ON
c     EXTERNAL DIAGNOSTICS_IS_ON
c#endif

C     !LOCAL VARIABLES:
      INTEGER bi,bj,i,j,L,LM1
      _RL dpratio
#ifdef ALLOW_DIAGNOSTICS
      _RL tmpFac
#endif

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
#ifdef ALLOW_DIAGNOSTICS
C Fill diagnostic for filling with negative of salt
        IF (useDiagnostics)THEN
          tmpFac = -1. _d 0
          CALL DIAGNOSTICS_SCALE_FILL(salt,tmpFac,1,'SALTFILL',
     &                                   0,Nr,-1,bi,bj,myThid)
        ENDIF
#endif

c Flag = 1:
c ---------------------------------
        if(flag.eq.1) then

        do L=Nr,2,-1
         LM1 = L-1
         dpratio= rC(L)/rC(LM1)
         do j=1,sNy
         do i=1,sNx
          if( salt(i,j,L,bi,bj).lt.0.0  _d 0) then
           salt(i,j,LM1,bi,bj) = salt(i,j,LM1,bi,bj) +
     .          salt(i,j,L,bi,bj)*dpratio
           salt(i,j,L,bi,bj) = 0.0 _d 0
          endif
         enddo
         enddo
        enddo

        do j=1,sNy
        do i=1,sNx
         if(salt(i,j,1,bi,bj).lt.0.0 _d 0)
     .                  salt(i,j,1,bi,bj) = 0.0 _d 0
        enddo
        enddo

        else
         print *,'Invalid Flag in salt_fill - nothing done '
        endif

#ifdef ALLOW_DIAGNOSTICS
C Fill diagnostic for filling with salt - get tendency
        IF ( useDiagnostics ) THEN
          CALL DIAGNOSTICS_FILL(salt,'SALTFILL',0,Nr,1,bi,bj,myThid)
        ENDIF
#endif
       ENDDO
      ENDDO

      RETURN
      END

#include "ECCO_OPTIONS.h"

      subroutine cost_gencost_boxmean( myThid )

c     ==================================================================
c     SUBROUTINE cost_gencost_boxmean
c     ==================================================================
c
c     o Evaluate cost function contributions of box mean THETA.
c
c     ==================================================================
c     SUBROUTINE cost_gencost_boxmean
c     ==================================================================

      implicit none

c     == global variables ==

#include "EEPARAMS.h"
#include "SIZE.h"
#include "PARAMS.h"
#include "GRID.h"
#ifdef ALLOW_CAL
# include "cal.h"
#endif
#ifdef ALLOW_ECCO
# include "ECCO_SIZE.h"
# include "ECCO.h"
#endif

c     == routine arguments ==
      integer myThid

#ifdef ALLOW_GENCOST_CONTRIBUTION
c     == local variables ==

      integer kgen
      _RL mybar(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)

      _RL mySumTile(nSx,nSy),myVolTile(nSx,nSy)
      _RL mySumGlo,myVolGlo

      _RL tmpSumTile(nSx,nSy)
      _RL tmpSumGlo

      integer bi,bj
      integer i,j
      integer nrecloc,irec,il,ioUnit
      character*(MAX_LEN_FNAM) myfname
      _RL mydummy
      logical doglobalread
      logical ladinit
      character*(MAX_LEN_MBUF) msgbuf

      LOGICAL exst
      CHARACTER*(128) tempfile
      _RS     dummyRS(1)
      _RL     gencost_mskTemporal
      _RL     tmpVar(1)

c     == external functions ==
      integer  ilnblnk
      external ilnblnk
      LOGICAL  MASTER_CPU_THREAD
      EXTERNAL MASTER_CPU_THREAD

c     == end of interface ==

c-- detect the relevant gencost indices
      do kgen=1,NGENCOST
        if ( (gencost_flag(kgen).EQ.-3).AND.(using_gencost(kgen)) ) then

c ========

c set bar field params
      doglobalread = .false.
      ladinit      = .false.
      mydummy=gencost_dummy(kgen)
      il = ilnblnk( gencost_barfile(kgen) )
      write(myfname,'(2a,i10.10)')
     &    gencost_barfile(kgen)(1:il),'.',eccoiter

c initialize various things to 0
      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
          mySumTile(bi,bj)=0. _d 0
          myVolTile(bi,bj)=0. _d 0
          mySumGlo=0. _d 0
          myVolGlo=0. _d 0
       ENDDO
      ENDDO

      nrecloc=gencost_nrec(kgen)

c ========

c main loop where cost is computed and time series is displayed
      do irec = 1,nrecloc

c read bar field
#ifdef ALLOW_AUTODIFF
        call active_read_xy( myfname, mybar, irec,
     &                        doglobalread, ladinit,
     &                        eccoiter, myThid,
     &                        mydummy )
#else
        CALL READ_REC_XY_RL( myfname, mybar,
     &                        iRec, 1, myThid )
#endif

      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
          tmpSumTile(bi,bj)=0. _d 0
          tmpSumGlo=0. _d 0
        enddo
      enddo

      il = ilnblnk(gencost_mask(kgen))
      write(tempfile(1:128),'(2A)') gencost_mask(kgen)(1:il),'T'
      inquire( file=tempfile(1:il+1), exist=exst )
      if ( (.NOT.exst).OR.(gencost_mask(kgen).EQ.' ') ) then
       gencost_mskTemporal=nrecloc
       gencost_mskTemporal=1. _d 0 / gencost_mskTemporal
      else
       ioUnit = 0
       call MDS_READVEC_LOC(tempfile,cost_iprec,ioUnit,'RL',
     &      1, tmpVar, dummyRS, 0, 0, iRec, myThid )
       gencost_mskTemporal = tmpVar(1)
      endif

c compute cost
      IF ( myProcId .EQ. 0 ) num_gencost(1,1,kgen)=
     &   num_gencost(1,1,kgen)+gencost_mskTemporal

      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
            do j = 1,sNy
              do i =  1,sNx
c sum that is actually be used in cost function
      objf_gencost(bi,bj,kgen)=objf_gencost(bi,bj,kgen)
     &   +gencost_mskTemporal*mybar(i,j,bi,bj)

c sum for display of time series
      tmpSumTile(bi,bj)=tmpSumTile(bi,bj)
     &   +gencost_mskTemporal*mybar(i,j,bi,bj)
              enddo
            enddo
        enddo
      enddo

c global sums for display of time series
      CALL GLOBAL_SUM_TILE_RL( tmpSumTile, tmpSumGlo, myThid )

      WRITE(msgBuf,'(A,I3,A,1PE21.14)')
     &    'boxmean/horflux :',irec,' ',tmpSumGlo
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &    SQUEEZE_RIGHT, myThid )

      enddo

c ========

c global sums for cost function
      CALL GLOBAL_SUM_TILE_RL( objf_gencost(1,1,kgen),
     &   mySumGlo, myThid )

      WRITE(msgBuf,'(A,1PE21.14)') 'boxmean/horflux fc :',mySumGlo
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &    SQUEEZE_RIGHT, myThid )

c ========

      endif !if ( (gencost_flag(kgen).EQ.-3).AND.
      enddo !do kgen=1,NGENCOST

#endif /* ALLOW_GENCOST_CONTRIBUTION */

      return
      end

#include "GAD_OPTIONS.h"
#ifdef ALLOW_AUTODIFF
# include "AUTODIFF_OPTIONS.h"
#endif

CBOP
C     !ROUTINE: GAD_DST3FL_IMPL_R
C     !INTERFACE:
      SUBROUTINE GAD_DST3FL_IMPL_R(
     I           bi,bj,k, iMin,iMax,jMin,jMax,
     I           deltaTarg, rTrans, recip_hFac, tFld,
     O           a5d, b5d, c5d, d5d, e5d,
     I           myThid )

C     !DESCRIPTION:

C     Compute matrix element to solve vertical advection implicitly
C     using 3rd order Direct Space and Time (DST) advection scheme
C           with Flux-Limiter.
C     Method:
C      contribution of vertical transport at interface k is added
C      to matrix lines k and k-1

C     !USES:
      IMPLICIT NONE

C     == Global variables ===
#include "SIZE.h"
#include "GRID.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GAD.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine Arguments ==
C     bi,bj        :: tile indices
C     k            :: vertical level
C     iMin,iMax    :: computation domain
C     jMin,jMax    :: computation domain
C     deltaTarg    :: time step
C     rTrans       :: vertical volume transport
C     recip_hFac   :: inverse of cell open-depth factor
C     tFld         :: tracer field
C     a5d          :: 2nd  lower diag of pentadiagonal matrix
C     b5d          :: 1rst lower diag of pentadiagonal matrix
C     c5d          :: main diag       of pentadiagonal matrix
C     d5d          :: 1rst upper diag of pentadiagonal matrix
C     e5d          :: 2nd  upper diag of pentadiagonal matrix
C     myThid       :: thread number
      INTEGER bi,bj,k
      INTEGER iMin,iMax,jMin,jMax
      _RL     deltaTarg(Nr)
      _RL     rTrans(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RS recip_hFac(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL     tFld  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL     a5d   (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL     b5d   (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL     c5d   (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL     d5d   (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL     e5d   (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      INTEGER myThid

C     == Local Variables ==
C     i,j          :: loop indices
C     kp1          :: =min( k+1 , Nr )
C     km2          :: =max( k-2 , 1 )
C     wCFL         :: Courant-Friedrich-Levy number
C     lowFac       :: low  order term factor
C     highFac      :: high order term factor
C     rCenter      :: centered contribution
C     rUpwind      :: upwind   contribution
C     rC4km, rC4kp :: high order contributions
      INTEGER i,j,kp1,km2
      _RL wCFL, rCenter, rUpwind
      _RL lowFac (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL highFac(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL rC4km, rC4kp
      _RL mskM, mskP, maskM2, maskP1
      _RL Rj, Rjh, cL1, cH3, cM2, th1, th2
      _RL deltaTcfl
#if ( defined ALLOW_AUTODIFF_TAMC && defined INCLUDE_IMPLVERTADV_CODE )
      INTEGER ikey
#endif
CEOP

#if ( defined ALLOW_AUTODIFF_TAMC && defined INCLUDE_IMPLVERTADV_CODE )
CADJ INIT loctape_gad = COMMON, (sNx+2*OLx)*(sNy+2*OLy)
#endif
C--   process interior interface only:
      IF ( k.GT.1 .AND. k.LE.Nr ) THEN

       km2=MAX(1,k-2)
       kp1=MIN(Nr,k+1)
       maskP1 = 1. _d 0
       maskM2 = 1. _d 0
       IF ( k.LE.2 ) maskM2 = 0. _d 0
       IF ( k.GE.Nr) maskP1 = 0. _d 0

C--   Compute the low-order term & high-order term fractions :
       deltaTcfl = deltaTarg(k)
C     DST-3 Flux-Limiter Advection Scheme:
C-    Limiter: Psi=max(0,min(1,cL1+theta*cH1,theta*(1-cfl)/cfl) )
C              with theta=Rjh/Rj ;
C       is linearize arround the current value of theta(tFld) & cfl:
C       lowFac & highFac are set such as Psi*Rj = lowFac*Rj + highFac*Rjh
       DO j=jMin,jMax
         DO i=iMin,iMax
#if ( defined ALLOW_AUTODIFF_TAMC && defined INCLUDE_IMPLVERTADV_CODE )
           ikey = i + (sNx+2*OLx)*(j-1)
#endif
           wCFL = deltaTcfl*ABS(rTrans(i,j))
     &           *recip_rA(i,j,bi,bj)*recip_drC(k)
     &           *recip_deepFac2F(k)*recip_rhoFacF(k)
           cL1 = (2. _d 0 -wCFL)*(1. _d 0 -wCFL)*oneSixth
           cH3 = (1. _d 0 -wCFL*wCFL)*oneSixth
c          cM2 = (1. _d 0 - wCFL)/( wCFL +1. _d -20)
           cM2 = (1. _d 0 + wCFL)/( wCFL +1. _d -20)

           Rj =(tFld(i,j,k)  -tFld(i,j,k-1))
           IF ( rTrans(i,j).GT.0. _d 0 ) THEN
             Rjh = (tFld(i,j,k-1)-tFld(i,j,km2))*maskC(i,j,km2,bi,bj)
           ELSE
             Rjh = (tFld(i,j,kp1)-tFld(i,j,k)  )*maskC(i,j,kp1,bi,bj)
           ENDIF
           IF ( Rj*Rjh.LE.0. _d 0 ) THEN
C-         1rst case: theta < 0 (Rj & Rjh opposite sign) => Psi = 0
             lowFac(i,j) = 0. _d 0
             highFac(i,j)= 0. _d 0
           ELSE
#if ( defined ALLOW_AUTODIFF_TAMC && defined INCLUDE_IMPLVERTADV_CODE )
C     These stores to local tape avoid recomputations and associated warnings
CADJ STORE Rjh, Rj = loctape_gad, key = ikey
#endif
             Rj  = ABS(Rj)
             Rjh = ABS(Rjh)
             th1 = cL1*Rj+cH3*Rjh
             th2 = cM2*Rjh
            IF     ( th1.LE.th2 .AND. th1.LE.Rj ) THEN
C-          2nd case: cL1+theta*cH3 = min of the three = Psi
             lowFac(i,j) = cL1
             highFac(i,j)= cH3
            ELSEIF ( th2.LT.th1 .AND. th2.LE.Rj ) THEN
C-          3rd case: theta*cM2 = min of the three = Psi
             lowFac(i,j) = 0. _d 0
             highFac(i,j)= cM2
            ELSE
C-          4th case (Rj < th1 & Rj < th2) : 1 = min of the three = Psi
             lowFac(i,j) = 1. _d 0
             highFac(i,j)= 0. _d 0
            ENDIF
           ENDIF
         ENDDO
       ENDDO

C--    Add centered & upwind contributions
       DO j=jMin,jMax
         DO i=iMin,iMax
           rCenter= 0.5 _d 0 *rTrans(i,j)*recip_rA(i,j,bi,bj)*rkSign
           mskM   = maskC(i,j,km2,bi,bj)*maskM2
           mskP   = maskC(i,j,kp1,bi,bj)*maskP1
           rUpwind= (0.5 _d 0 -lowFac(i,j))*ABS(rCenter)*2. _d 0
           rC4km  = highFac(i,j)*(rCenter+ABS(rCenter))*mskM
           rC4kp  = highFac(i,j)*(rCenter-ABS(rCenter))*mskP

           a5d(i,j,k)   = a5d(i,j,k)
     &                  + rC4km
     &                   *deltaTarg(k)
     &                   *recip_hFac(i,j,k)*recip_drF(k)
     &                   *recip_deepFac2C(k)*recip_rhoFacC(k)
           b5d(i,j,k)   = b5d(i,j,k)
     &                  - ( (rCenter+rUpwind) + rC4km )
     &                   *deltaTarg(k)
     &                   *recip_hFac(i,j,k)*recip_drF(k)
     &                   *recip_deepFac2C(k)*recip_rhoFacC(k)
           c5d(i,j,k)   = c5d(i,j,k)
     &                  - ( (rCenter-rUpwind) + rC4kp )
     &                   *deltaTarg(k)
     &                   *recip_hFac(i,j,k)*recip_drF(k)
     &                   *recip_deepFac2C(k)*recip_rhoFacC(k)
           d5d(i,j,k)   = d5d(i,j,k)
     &                  + rC4kp
     &                   *deltaTarg(k)
     &                   *recip_hFac(i,j,k)*recip_drF(k)
     &                   *recip_deepFac2C(k)*recip_rhoFacC(k)
           b5d(i,j,k-1) = b5d(i,j,k-1)
     &                  - rC4km
     &                   *deltaTarg(k-1)
     &                   *recip_hFac(i,j,k-1)*recip_drF(k-1)
     &                   *recip_deepFac2C(k-1)*recip_rhoFacC(k-1)
           c5d(i,j,k-1) = c5d(i,j,k-1)
     &                  + ( (rCenter+rUpwind) + rC4km )
     &                   *deltaTarg(k-1)
     &                   *recip_hFac(i,j,k-1)*recip_drF(k-1)
     &                   *recip_deepFac2C(k-1)*recip_rhoFacC(k-1)
           d5d(i,j,k-1) = d5d(i,j,k-1)
     &                  + ( (rCenter-rUpwind) + rC4kp )
     &                   *deltaTarg(k-1)
     &                   *recip_hFac(i,j,k-1)*recip_drF(k-1)
     &                   *recip_deepFac2C(k-1)*recip_rhoFacC(k-1)
           e5d(i,j,k-1) = e5d(i,j,k-1)
     &                  - rC4kp
     &                   *deltaTarg(k-1)
     &                   *recip_hFac(i,j,k-1)*recip_drF(k-1)
     &                   *recip_deepFac2C(k-1)*recip_rhoFacC(k-1)
         ENDDO
       ENDDO

C--   process interior interface only: end
      ENDIF

      RETURN
      END

#include "COST_OPTIONS.h"

      subroutine cost_atlantic_heat( myThid )
C     /==========================================================\
C     | subroutine cost_atlantic_heat                            |
C     | o This routine computes the meridional heat transport.   |
C     |   The current indices are for North Atlantic 29N         |
C     |   2x2 global setup.                                      |
C     \==========================================================/
       implicit none

C     == Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "DYNVARS.h"
#include "cost.h"

C     ======== Routine arguments ======================
C     myThid - Thread number for this instance of the routine.
      integer myThid

#ifdef ALLOW_COST_ATLANTIC_HEAT
C     ========= Local variables =========================
      integer    isecbeg      , isecend      , jsec
      integer    jsecbeg      , jsecend      , isec
      integer    kmaxdepth
      integer i, j, k
      integer ig, jg
      integer bi, bj
      _RL     locfc
      _RL     uVel_bar(Nr), vVel_bar(Nr), theta_bar(Nr)
      _RL     thetaUvel_bar(Nr), thetaVvel_bar(Nr)
      _RL     countU(Nr), countV(Nr), countT(Nr)
      _RL     countTU(Nr), countTV(Nr)
      _RL     petawatt
      _RL     sum
      parameter( petawatt = 1. _d +15 )

C     80W - 0W at 24N
      parameter( isecbeg = 69, isecend = 87, jsec = 28 )
cph      parameter( isecbeg = 70, isecend = 90, jsec = 30 )
      parameter( jsecbeg = 10, jsecend = 27, isec = 59 )
#ifdef ALLOW_COST_ATLANTIC_HEAT_DOMASS
      parameter ( kmaxdepth = 8 )
#else
      parameter ( kmaxdepth = 14 )
#endif

C------------------------------------------------------
C     Accumulate meridionally integrated transports
C     Note bar(V)*bar(T) not bar(VT)
C     Attention pYFaceA [m^2*gravity*rhoConst]
C------------------------------------------------------

      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)

        locfc = 0.0
        sum = 0.0

#define MERID_TRANSPORT

#ifdef MERID_TRANSPORT

#undef ENERGYNORM
#ifdef ENERGYNORM

        do i=1,sNx
         ig = myXGlobalLo-1+(bi-1)*sNx+i
         if ((ig .ge. isecbeg) .and. (ig .le. isecend)) then
          sum = 0.0
          do k = 1, kmaxdepth
           sum = sum
     &            + (vVel(i,j,k,bi,bj) * maskS(i,j,k,bi,bj)
     &            * drF(k))**2
          end do
          locfc = locfc + sum*dxG(i,j,bi,bj)
         end if
        end do

#else

        do j=1,sNy
         jg = myYGlobalLo-1+(bj-1)*sNy+j
         if (jg .eq. jsec) then

          do k = 1, Nr
           vVel_bar(k) = 0.0
           thetaVvel_bar(k) = 0.0
           countV(k) = 0.0
           countTV(k) = 0.0
           do i=1,sNx
            ig = myXGlobalLo-1+(bi-1)*sNx+i
c
            if ((ig .ge. isecbeg) .and. (ig .le. isecend)) then
               vVel_bar(k) = vVel_bar(k)
     &              + cMeanVVel(i,j,k,bi,bj)*dxG(i,j,bi,bj)
     &                 *maskS(i,j,k,bi,bj)

               thetaVvel_bar(k) = thetaVvel_bar(k)
     &            + cMeanThetaVVel(i,j,k,bi,bj)*dxG(i,j,bi,bj)
     &                 *maskS(i,j,k,bi,bj)*maskC(i,j,k,bi,bj)

             countTV(k) = countTV(k) +
     &            maskS(i,j,k,bi,bj)*maskC(i,j,k,bi,bj)
             countV(k) = countV(k) +
     &            maskS(i,j,k,bi,bj)
            end if

           enddo
          enddo
c
          do k = 1, Nr
#ifdef ALLOW_COST_ATLANTIC_HEAT_DOMASS
           if ( k .LE. kmaxdepth .AND. countV(k) .NE. 0) then
            sum = sum
     &            + vVel_bar(k)*drF(k)/countV(k)
           end if
#else
           if ( k .LE. kmaxdepth .AND. countTV(k) .NE. 0) then
            sum = sum
     &            + thetaVVel_bar(k)*drF(k)/countTV(k)
           end if
#endif
          end do

#endif /* ENERGYNORM */

#else

cph need to change this part to go from
cph \bar{u}*\bar{T} to \bar{u*T}
cph (required store dir. are now in place)

        do i=1,sNx
         ig = myXGlobalLo-1+(bi-1)*sNx+i
         if (ig .eq. isec) then

          do k = 1, Nr
           uVel_bar(k) = 0.0
           theta_bar(k) = 0.0
           countT(k) = 0.0
           countU(k) = 0.0
           do j=1,sNy
            jg = myYGlobalLo-1+(bj-1)*sNy+j
c
            if ((jg .ge. jsecbeg) .and. (jg .le. jsecend)) then
             uVel_bar(k) = uVel_bar(k)
     &                      + cMeanUVel(i,j,k,bi,bj)
     &                      *maskW(i,j,k,bi,bj)
     &                      *maskC(i,j,k,bi,bj)*maskC(i-1,j,k,bi,bj)
             theta_bar(k) = theta_bar(k) +
     &            0.5*( cMeanTheta(i,j,k,bi,bj)
     &                 +cMeanTheta(i-,j,k,bi,bj) )
     &                 *maskW(i,j,k,bi,bj)*dyG(i,j,bi,bj)
     &                 *maskC(i,j,k,bi,bj)*maskC(i-1,j,k,bi,bj)
             countT(k) = countT(k) + maskW(i,j,k,bi,bj)
     &                   *maskC(i,j,k,bi,bj)*maskC(i-1,j,k,bi,bj)
             countU(k) = countU(k) + maskW(i,j,k,bi,bj)
     &                   *maskC(i,j,k,bi,bj)*maskC(i-1,j,k,bi,bj)
            end if

           enddo
          enddo
c
          do k = 1, Nr
           if ( k .LE. kmaxdepth .AND.
     &          countT(k) .NE. 0 .AND. countU(k) .NE. 0) then
            sum = sum
     &            + uVel_bar(k) * theta_bar(k) * drF(k)
     &            / ( countT(k) * countU(k) )
           end if
          end do

#endif

         end if
        end do

#ifdef ALLOW_COST_ATLANTIC_HEAT_DOMASS
        objf_atl(bi,bj) =
     &     sum*1.E-6
#else
        objf_atl(bi,bj) =
     &     sum*HeatCapacity_Cp*rhoConst/petawatt
#endif

c--   end of bi,bj loop
       end do
      end do

#endif

      end

#include "SMOOTH_OPTIONS.h"

      SUBROUTINE SMOOTH_INIT_VARIA( myThid )

C     *==========================================================*
C     | SUBROUTINE SMOOTH_INIT_VARIA
C     | o Routine that initializes smoothing/correlation operators
C     |  (first version is empty => see smooth_init_fixed.F)
C     *==========================================================*

      IMPLICIT NONE
      INTEGER myThid

      RETURN
      END

#include "GMREDI_OPTIONS.h"

CBOP
C     !ROUTINE: GMREDI_OUTPUT

C     !INTERFACE:
      SUBROUTINE GMREDI_OUTPUT( myTime, myIter, myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE GMREDI_OUTPUT
C     | o general routine for GM/Redi output
C     *==========================================================*
C     |   write time-average & snap-shot output
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GMREDI.h"

C     !INPUT PARAMETERS:
C     myTime :: Current time of simulation ( s )
C     myIter :: Iteration number
C     myThid :: my Thread Id number
      _RL     myTime
      INTEGER myIter
      INTEGER myThid
CEOP

#ifdef ALLOW_GMREDI
C     !FUNCTIONS:
      LOGICAL  DIFFERENT_MULTIPLE
      EXTERNAL DIFFERENT_MULTIPLE

C     !LOCAL VARIABLES:
      CHARACTER*(10) suff
#ifdef ALLOW_MNC
      CHARACTER*(1) pf
#endif

      IF ( DIFFERENT_MULTIPLE(diagFreq,myTime,deltaTClock)
     &   ) THEN

        IF ( GM_MDSIO ) THEN
          IF ( rwSuffixType.EQ.0 ) THEN
            WRITE(suff,'(I10.10)') myIter
          ELSE
            CALL RW_GET_SUFFIX( suff, myTime, myIter, myThid )
          ENDIF
          CALL WRITE_FLD_XYZ_RL( 'GM_Kux.',suff,Kux,myIter,myThid)
          CALL WRITE_FLD_XYZ_RL( 'GM_Kvy.',suff,Kvy,myIter,myThid)
#ifdef GM_EXTRA_DIAGONAL
          IF (GM_ExtraDiag) THEN
            CALL WRITE_FLD_XYZ_RL( 'GM_Kuz.',suff,Kuz,myIter,myThid)
            CALL WRITE_FLD_XYZ_RL( 'GM_Kvz.',suff,Kvz,myIter,myThid)
          ENDIF
#endif
        ENDIF

#ifdef ALLOW_MNC
        IF ( GM_MNC ) THEN
          IF ( writeBinaryPrec .EQ. precFloat64 ) THEN
           pf(1:1) = 'D'
          ELSE
           pf(1:1) = 'R'
          ENDIF
          CALL MNC_CW_SET_UDIM('gm_inst', -1, myThid)
          CALL MNC_CW_RL_W_S('D','gm_inst',0,0,'T',myTime,myThid)
          CALL MNC_CW_SET_UDIM('gm_inst', 0, myThid)
          CALL MNC_CW_I_W_S('I','gm_inst',0,0,'iter',myIter,myThid)
          CALL MNC_CW_RL_W(pf,'gm_inst',0,0,'Kux',Kux,myThid)
          CALL MNC_CW_RL_W(pf,'gm_inst',0,0,'Kvy',Kvy,myThid)
#ifdef GM_EXTRA_DIAGONAL
          IF (GM_ExtraDiag) THEN
            CALL MNC_CW_RL_W(pf,'gm_inst',0,0,'Kuz',Kuz,myThid)
            CALL MNC_CW_RL_W(pf,'gm_inst',0,0,'Kvz',Kvz,myThid)
          ENDIF
#endif
        ENDIF
#endif /* ALLOW_MNC */

      ENDIF

#endif /* ALLOW_GMREDI */

      RETURN
      END

#include "ATM_CPL_OPTIONS.h"
#ifdef ALLOW_AIM
# include "AIM_OPTIONS.h"
#endif

CBOP 0
C !ROUTINE: ATM_GET_ATMCONFIG

C !INTERFACE:
      SUBROUTINE ATM_GET_ATMCONFIG(
     O                              landMask,
     I                              myThid )

C !DESCRIPTION:
C     *==========================================================*
C     | SUBROUTINE ATM_GET_ATMCONFIG
C     | o get atmos. config (land/sea mask) from other pkgs
C     *==========================================================*

C !USES:
      IMPLICIT NONE
C     == Global variables ==
#ifdef ALLOW_AIM
# include "AIM_SIZE.h"
#else
# include "SIZE.h"
#endif

#include "EEPARAMS.h"
#include "PARAMS.h"
c#include "GRID.h"
c#include "ATMIDS.h"
c#include "ATMCPL.h"
#ifdef ALLOW_AIM
# include "AIM_FFIELDS.h"
#endif /* ALLOW_AIM */

C !INPUT/OUTPUT PARAMETERS:
C     landMask :: land / sea mask (=1 : full land; =0 : full ocean grid cell)
C     myThid   :: Thread number for this instance of the routine
      _RL landMask(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      INTEGER myThid

C !LOCAL VARIABLES:
      INTEGER i,j,bi,bj
CEOP

      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)

C--   Initialise to zero (no land, full oceanic):
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
           landMask(i,j,bi,bj) = 0. _d 0
         ENDDO
        ENDDO

        IF ( useAtm_Phys ) THEN
C-    Since pkg/atm_phys does not currently handle land (but only swamp),
C     set landMask to an intermediate value (here half) to (by)pass the check
C     in ATM_CHECK_CPLCONFIG :
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           landMask(i,j,bi,bj) = 0.5 _d 0
          ENDDO
         ENDDO
        ENDIF

#ifdef ALLOW_AIM
        IF ( useAIM ) THEN
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           landMask(i,j,bi,bj) = aim_landFr(i,j,bi,bj)
          ENDDO
         ENDDO
        ENDIF
#endif /* ALLOW_AIM */

       ENDDO
      ENDDO

      RETURN
      END

!=======================================================================
      subroutine MITCOUPLER_tile_register( compName, nnx, nny )
      implicit none

! Arguments
      character*(*) compName
      integer nnx, nny

! MPI variables
#include "mpif.h"

! Predefined constants/arrays
#include "CPLR_SIG.h"

! Functions
      integer mitcplr_match_comp
      integer generate_tag
      external mitcplr_match_comp
      external generate_tag

! Local
      integer n,numprocs
      integer comm
      integer compind,count,dtype,tag,rank
      integer ierr
      integer stat(MPI_STATUS_SIZE)
      integer j, numtiles
      integer nx, ny, i0, j0
      integer ibuf(MAX_IBUF)

!     ------------------------------------------------------------------

      write(LogUnit,'(3A)')
     &    'MITCOUPLER_tile_register: do "', compName, '" :'

! Establish who I am communicating with
      compind=mitcplr_match_comp( compName )
      if (compind.le.0) STOP 'MITCOUPLER_tile_register: Bad component'
      comm=MPI_COMM_compcplr( compind )
      numprocs=num_component_procs(compind)

      write(LogUnit,'(2(A,I6))')
     &        ' compind=', compind, ' ; numprocs=', numprocs
      if (numprocs.lt.1) then
       STOP 'MITCOUPLER_tile_register: numprocs < 1'
      endif

! Foreach component process
      do n=1,numprocs

! Receive message
       count=MAX_IBUF
       dtype=MPI_INTEGER
       tag=generate_tag(112,n,'Register Tiles')
       rank=rank_component_procs(n,compind)

       call MPI_Recv(ibuf, count, dtype, rank, tag, comm, stat, ierr)

       if (ierr.ne.0) then
        write(LogUnit,*) 'MITCOUPLER_tile_register: rank(W,G)=',
     &            my_rank_in_world,my_rank_in_global,
     &            ' ierr=',ierr
        STOP 'MITCOUPLER_tile_register: MPI_Recv failed'
       endif

       numtiles=ibuf(1)
       if (numtiles.lt.1 .or. numtiles.gt.MAX_TILES) then
        write(LogUnit,*) 'MITCOUPLER_tile_register: #tiles = ',numtiles
        STOP 'MITCOUPLER_tile_register: invalid value for numtiles'
       endif
       component_num_tiles(n,compind)=numtiles

       write(LogUnit,'(3(A,I6),A)')   '- proc # =', n,
     &     ' ; rank=', rank, ' ; numtiles=', numtiles, '  -------'
       do j=1,numtiles

! Receive message
        count=MAX_IBUF
        dtype=MPI_INTEGER
        tag=generate_tag(113,j,'Register each tile')
        rank=rank_component_procs(n,compind)

        call MPI_Recv(ibuf, count, dtype, rank, tag, comm, stat, ierr)

        if (ierr.ne.0) then
         write(LogUnit,*) 'MITCOUPLER_tile_register: rank(W,G)=',
     &            my_rank_in_world,my_rank_in_global,
     &            ' ierr=',ierr
         STOP 'MITCOUPLER_tile_register: MPI_Recv failed'
        endif

! Extract data and store
        nx = ibuf(1)
        ny = ibuf(2)
        i0 = ibuf(3)
        j0 = ibuf(4)
        component_tile_nx(j,n,compind) = nx
        component_tile_ny(j,n,compind) = ny
        component_tile_i0(j,n,compind) = i0
        component_tile_j0(j,n,compind) = j0

! Print and check
        write(LogUnit,'(A,I5,A,2I5,A,2I8)') ' tile #:', j,
     &     ' ; Ni,Nj=', nx, ny, ' ; Io,Jo=', i0, j0

        if (nx.lt.1) then
         STOP 'MITCOUPLER_tile_register: invalid value for nx'
        endif
        if (ny.lt.1) then
         STOP 'MITCOUPLER_tile_register: invalid value for ny'
        endif
        if (i0.lt.1) then
         STOP 'MITCOUPLER_tile_register: invalid value for i0'
        endif
        if (j0.lt.1) then
         STOP 'MITCOUPLER_tile_register: invalid value for j0'
        endif
        if (i0+nx-1.gt.nnx) then
         STOP 'MITCOUPLER_tile_register: i0 + nx -1 > nnx'
        endif
        if (j0+ny-1.gt.nny) then
         STOP 'MITCOUPLER_tile_register: j0 + ny -1 > nny'
        endif

       enddo ! j
       write(LogUnit,'(A,2I8,2(A,I8))')
     &     ' rank(W,G)=', my_rank_in_world, my_rank_in_global,
     &     ' , rank = ',rank, ' , num_tiles = ', numtiles

      enddo ! n

      write(LogUnit,'(3A)') 'MITCOUPLER_tile_register: comp. "',
     &                         compName, '" done'

!     ------------------------------------------------------------------
      call flush(LogUnit)
      return
      end
!=======================================================================

#include "DIC_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: DIC_MNC_INIT

C     !INTERFACE:
      SUBROUTINE DIC_MNC_INIT( myThid )

C     !DESCRIPTION:
C     Initialize MNC for DIC

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "DIC_VARS.h"

C     !INPUT PARAMETERS:
C     myThid               :: thread number
      INTEGER myThid
CEOP

#ifdef ALLOW_DIC
#ifdef ALLOW_MNC

      IF ( useMNC ) THEN

      CALL MNC_CW_ADD_VNAME(
     &     'dic_BIO_ave', 'Cen_xy_Hn__C__t', 4,5, myThid)
      CALL MNC_CW_ADD_VATTR_TEXT(
     &     'dic_BIO_ave','units','--', myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('dic_BIO_ave','description',
     &     '', myThid)

      CALL MNC_CW_ADD_VNAME(
     &     'dic_CAR_ave', 'Cen_xy_Hn__C__t', 4,5, myThid)
      CALL MNC_CW_ADD_VATTR_TEXT(
     &     'dic_CAR_ave','units','--', myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('dic_CAR_ave','description',
     &     '', myThid)

      CALL MNC_CW_ADD_VNAME(
     &     'dic_SUR_ave', 'Cen_xy_Hn__-__t', 3,4, myThid)
      CALL MNC_CW_ADD_VATTR_TEXT(
     &     'dic_SUR_ave','units','--', myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('dic_SUR_ave','description',
     &     '', myThid)

      CALL MNC_CW_ADD_VNAME(
     &     'dic_SURO_ave', 'Cen_xy_Hn__-__t', 3,4, myThid)
      CALL MNC_CW_ADD_VATTR_TEXT(
     &     'dic_SURO_ave','units','--', myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('dic_SURO_ave','description',
     &     '', myThid)

      CALL MNC_CW_ADD_VNAME(
     &     'dic_pH_ave', 'Cen_xy_Hn__-__t', 3,4, myThid)
      CALL MNC_CW_ADD_VATTR_TEXT(
     &     'dic_pH_ave','units','--', myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('dic_pH_ave','description',
     &     '', myThid)

      CALL MNC_CW_ADD_VNAME(
     &     'dic_pCO2_ave', 'Cen_xy_Hn__-__t', 3,4, myThid)
      CALL MNC_CW_ADD_VATTR_TEXT(
     &     'dic_pCO2_ave','units','--', myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('dic_pCO2_ave','description',
     &     '', myThid)

      CALL MNC_CW_ADD_VNAME(
     &     'dic_fluxCO2_ave', 'Cen_xy_Hn__-__t', 3,4, myThid)
      CALL MNC_CW_ADD_VATTR_TEXT(
     &     'dic_fluxCO2_ave','units','--', myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('dic_fluxCO2_ave','description',
     &     '', myThid)

      CALL MNC_CW_ADD_VNAME(
     &     'dic_pflux_ave', 'Cen_xy_Hn__C__t', 4,5, myThid)
      CALL MNC_CW_ADD_VATTR_TEXT(
     &     'dic_pflux_ave','units','--', myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('dic_pflux_ave','description',
     &     '', myThid)

      CALL MNC_CW_ADD_VNAME(
     &     'dic_epflux_ave', 'Cen_xy_Hn__C__t', 4,5, myThid)
      CALL MNC_CW_ADD_VATTR_TEXT(
     &     'dic_epflux_ave','units','--', myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('dic_epflux_ave','description',
     &     '', myThid)

      CALL MNC_CW_ADD_VNAME(
     &     'dic_cflux_ave', 'Cen_xy_Hn__C__t', 4,5, myThid)
      CALL MNC_CW_ADD_VATTR_TEXT(
     &     'dic_cflux_ave','units','--', myThid)
      CALL MNC_CW_ADD_VATTR_TEXT('dic_cflux_ave','description',
     &     '', myThid)

      ENDIF

#endif /* ALLOW_MNC */
#endif /* ALLOW_DIC */

      RETURN
      END

#include "OBSFIT_OPTIONS.h"
C     obsfit_active_file_control.F:  Routines that handle the I/O of
C                                    active variables for adjoint
C                                    calculations
C
C     Routines
C     o  active_read_obs_tile_rl  - Read an active record from tiled file
C                                   fwd-mode only: including a mask
C     o  active_write_obs_tile_rl - Write an active record to tiled file
C                                   fwd-mode only: including a mask
C     o  active_read_obs_glob_rl  - Read an active record from global file
C                                   fwd-mode only: including a mask
C     o  active_write_obs_glob_rl - Write an active record to global file.
C                                   fwd-mode only: including a mask

CBOP
C     !ROUTINE: ACTIVE_READ_OBS_TILE_RL

C     !INTERFACE:
      SUBROUTINE ACTIVE_READ_OBS_TILE_RL(
     I                                    fid,
     I                                    active_num_file,
     O                                    active_var,
     I                                    lAdInit,
     I                                    irec,
     I                                    irecglob,
     I                                    theSimulationMode,
     I                                    myOptimIter,
     I                                    bi,
     I                                    bj,
     I                                    myThid )

C     !DESCRIPTION:
C     ==================================================================
C     | Read an active record from an ObsFit .equi. tiled file
C     | (can be netcdf or binary)
C     ==================================================================

C     !USES:
      IMPLICIT NONE
C     == Global variables ===
#include "EEPARAMS.h"
#include "SIZE.h"
#include "PARAMS.h"
#ifdef ALLOW_OBSFIT
# include "netcdf.inc"
# include "OBSFIT_SIZE.h"
# include "OBSFIT.h"
#endif

C     !INPUT PARAMETERS:
      INTEGER  fid
      INTEGER  active_num_file
      LOGICAL  lAdInit
      INTEGER  irec, irecglob, jrec
      INTEGER  theSimulationMode
      INTEGER  myOptimIter
      INTEGER  bi, bj, myThid
C     !IOUTPUT PARAMETERS:
      _RL      active_var
CEOP

#ifdef ALLOW_OBSFIT
C     !LOCAL VARIABLES:
      INTEGER  err, varID1, varID2
      INTEGER  vec_start, vec_count
      _RL      active_data_t
      _RL      vec_tmp(2)

       IF ( obsfitDoNcOutput ) THEN

        vec_start = irec
        vec_count = 1

        err = NF_INQ_VARID( fid, obsfit_nameequi, varID1 )
        CALL OBSFIT_NF_ERROR(
     &       'ACTIVE_READ: NF_INQ_VARID obsfit_nameequi',
     &       err,bi,bj,myThid )

       ELSE

        jrec = (irec-1)*2

       ENDIF

C     >>>>>>>>>>>>>>>>>>>             <<<<<<<<<<<<<<<<<<<
C     >>>>>>>>>>>>>>>>>>> FORWARD RUN <<<<<<<<<<<<<<<<<<<
C     >>>>>>>>>>>>>>>>>>>             <<<<<<<<<<<<<<<<<<<

      IF ( theSimulationMode .EQ. FORWARD_SIMULATION ) THEN

       _BEGIN_MASTER( myThid )

       IF ( obsfitDoNcOutput ) THEN

        err = NF_GET_VARA_DOUBLE( fid, varID1, vec_start, vec_count,
     &        active_var )
        CALL OBSFIT_NF_ERROR(
     &         'ACTIVE_READ: NF_GET_VARA_DOUBLE active_var',
     &         err,bi,bj,myThid )

        err = NF_INQ_VARID( fid, obsfit_namemask, varID2 )
        CALL OBSFIT_NF_ERROR(
     &         'ACTIVE_READ: NF_INQ_VARID obsfit_namemask',
     &         err,bi,bj,myThid )

        err = NF_GET_VARA_DOUBLE( fid, varID2, vec_start, vec_count,
     &        sample_modmask(bi,bj) )
        CALL OBSFIT_NF_ERROR(
     &         'ACTIVE_READ: NF_GET_VARA_DOUBLE sample_modmask',
     &         err,bi,bj,myThid )

       ELSE

        READ( fid, rec=jrec+1 ) vec_tmp
#ifdef _BYTESWAPIO
        CALL MDS_BYTESWAPR8( 2, vec_tmp )
#endif
        active_var = vec_tmp(1)
        READ( fid, rec=jrec+2 ) vec_tmp
#ifdef _BYTESWAPIO
        CALL MDS_BYTESWAPR8( 2, vec_tmp )
#endif
        sample_modmask(bi,bj) = vec_tmp(1)

       ENDIF

       _END_MASTER( myThid )

      ENDIF

C     >>>>>>>>>>>>>>>>>>>             <<<<<<<<<<<<<<<<<<<
C     >>>>>>>>>>>>>>>>>>> ADJOINT RUN <<<<<<<<<<<<<<<<<<<
C     >>>>>>>>>>>>>>>>>>>             <<<<<<<<<<<<<<<<<<<

      IF ( theSimulationMode .EQ. REVERSE_SIMULATION ) THEN

       _BEGIN_MASTER( myThid )

       IF ( obsfitDoNcOutput) THEN

        err = NF_GET_VARA_DOUBLE( fid, varID1, vec_start, vec_count,
     &        active_data_t )
        CALL OBSFIT_NF_ERROR(
     &         'ACTIVE_READ: NF_GET_VARA_DOUBLE AD active_data_t',
     &         err,bi,bj,myThid )

C Add active_var from appropriate location to data
        active_data_t = active_data_t + active_var

C Store the result on disk
        err = NF_PUT_VARA_DOUBLE( fid, varID1, vec_start, vec_count,
     &        active_data_t )
        CALL OBSFIT_NF_ERROR(
     &         'ACTIVE_READ: NF_PUT_VARA_DOUBLE AD active_data_t',
     &         err,bi,bj,myThid )

C Set active_var to zero
        active_var = 0. _d 0

       ELSE

        READ( fid, rec=jrec+1 ) vec_tmp
#ifdef _BYTESWAPIO
        CALL MDS_BYTESWAPR8( 2, vec_tmp )
#endif
        active_data_t = vec_tmp(1)

C Add active_var from appropriate location to data
        active_data_t = active_data_t + active_var

C Store the result on disk
        vec_tmp(1) = active_data_t
#ifdef _BYTESWAPIO
        CALL MDS_BYTESWAPR8( 2, vec_tmp )
#endif
        WRITE( fid, rec=jrec+1 ) vec_tmp

C Set active_var to zero
        active_var = 0. _d 0

       ENDIF

       _END_MASTER( myThid )

      ENDIF

C     >>>>>>>>>>>>>>>>>>>             <<<<<<<<<<<<<<<<<<<
C     >>>>>>>>>>>>>>>>>>> TANGENT RUN <<<<<<<<<<<<<<<<<<<
C     >>>>>>>>>>>>>>>>>>>             <<<<<<<<<<<<<<<<<<<

      IF ( theSimulationMode .EQ. TANGENT_SIMULATION ) THEN

       _BEGIN_MASTER( myThid )

       IF ( obsfitDoNcOutput ) THEN

        err = NF_GET_VARA_DOUBLE( fid, varID1, vec_start, vec_count,
     &        active_var )
        CALL OBSFIT_NF_ERROR(
     &         'ACTIVE_READ: NF_GET_VARA_DOUBLE TL active_var',
     &         err,bi,bj,myThid )
       ELSE

        READ( fid, rec=jrec+1 ) vec_tmp
#ifdef _BYTESWAPIO
        CALL MDS_BYTESWAPR8( 2, vec_tmp )
#endif
        active_var = vec_tmp(1)

       ENDIF

       _END_MASTER( myThid )

      ENDIF

#endif /* ALLOW_OBSFIT */

      RETURN
      END

C     =================================================================

CBOP
C     !ROUTINE: ACTIVE_WRITE_OBS_TILE_RL

C     !INTERFACE:
      SUBROUTINE ACTIVE_WRITE_OBS_TILE_RL(
     I                                 fid,
     I                                 active_num_file,
     I                                 active_var,
     I                                 irec,
     I                                 irecglob,
     I                                 theSimulationMode,
     I                                 myOptimIter,
     I                                 bi,
     I                                 bj,
     I                                 myThid )

C     !DESCRIPTION:
C     ==================================================================
C     | Write an active record to an ObsFit .equi. tiled file
C     | (can be netcdf or binary)
C     ==================================================================

C     !USES:
      IMPLICIT NONE
C     == Global variables ===
#include "EEPARAMS.h"
#include "SIZE.h"
#include "PARAMS.h"
#ifdef ALLOW_OBSFIT
# include "netcdf.inc"
# include "OBSFIT_SIZE.h"
# include "OBSFIT.h"
#endif

C     !INPUT PARAMETERS:
      INTEGER  fid
      INTEGER  active_num_file
      INTEGER  irec, irecglob, jrec
      INTEGER  theSimulationMode
      INTEGER  myOptimIter
      INTEGER  bi, bj, myThid
      _RL      active_var

#ifdef ALLOW_OBSFIT
C     !LOCAL VARIABLES:
      INTEGER  err, varID1, varID2, varID3
      INTEGER  vec_start, vec_count
      _RL      active_data_t
      _RL      vec_tmp(2)
CEOP

      IF ( obsfitDoNcOutput ) THEN

        vec_start = irec
        vec_count = 1

        err = NF_INQ_VARID( fid, obsfit_nameequi, varID1 )
        CALL OBSFIT_NF_ERROR(
     &       'ACTIVE_WRITE: NF_INQ_VARID obsfit_nameequi',
     &       err,bi,bj,myThid )
      ELSE

        jrec = (irec-1)*2

      ENDIF

C     >>>>>>>>>>>>>>>>>>>             <<<<<<<<<<<<<<<<<<<
C     >>>>>>>>>>>>>>>>>>> FORWARD RUN <<<<<<<<<<<<<<<<<<<
C     >>>>>>>>>>>>>>>>>>>             <<<<<<<<<<<<<<<<<<<

      IF ( theSimulationMode .EQ. FORWARD_SIMULATION ) THEN

       _BEGIN_MASTER( myThid )

       IF ( obsfitDoNcOutput ) THEN

        err = NF_PUT_VARA_DOUBLE( fid, varID1, vec_start, vec_count,
     &        active_var )
        CALL OBSFIT_NF_ERROR(
     &       'ACTIVE_WRITE: NF_PUT_VARA_DOUBLE active_var',
     &       err,bi,bj,myThid )

        err = NF_INQ_VARID( fid, obsfit_namemask, varID2 )
        CALL OBSFIT_NF_ERROR(
     &         'ACTIVE_WRITE: NF_INQ_VARID obsfit_namemask',
     &         err,bi,bj,myThid )
        err = NF_PUT_VARA_DOUBLE( fid, varID2, vec_start, vec_count,
     &        sample_modmask(bi,bj) )
        CALL OBSFIT_NF_ERROR(
     &         'ACTIVE_WRITE: NF_PUT_VARA_DOUBLE sample_modmask',
     &         err,bi,bj,myThid )

        err = NF_INQ_VARID( fid, 'sample_ind_glob', varID3 )
        CALL OBSFIT_NF_ERROR(
     &         'ACTIVE_WRITE: NF_INQ_VARID sample_ind_glob',
     &         err,bi,bj,myThid )
        err = NF_PUT_VAR1_INT( fid, varID3, vec_start, irecglob )
        CALL OBSFIT_NF_ERROR(
     &         'ACTIVE_WRITE: NF_PUT_VAR1_INT irecglob',
     &         err,bi,bj,myThid )

       ELSE

        vec_tmp(1) = active_var
        vec_tmp(2) = irecglob
#ifdef _BYTESWAPIO
        CALL MDS_BYTESWAPR8( 2, vec_tmp )
#endif
        WRITE( fid, rec= jrec+1 ) vec_tmp
        vec_tmp(1) = sample_modmask(bi,bj)
        vec_tmp(2) = irecglob
#ifdef _BYTESWAPIO
        CALL MDS_BYTESWAPR8( 2, vec_tmp )
#endif
        WRITE( fid, rec= jrec+2 ) vec_tmp

       ENDIF

       _END_MASTER( myThid )

      ENDIF

C     >>>>>>>>>>>>>>>>>>>             <<<<<<<<<<<<<<<<<<<
C     >>>>>>>>>>>>>>>>>>> ADJOINT RUN <<<<<<<<<<<<<<<<<<<
C     >>>>>>>>>>>>>>>>>>>             <<<<<<<<<<<<<<<<<<<

      IF ( theSimulationMode .EQ. REVERSE_SIMULATION ) THEN

       _BEGIN_MASTER( myThid )

       IF ( obsfitDoNcOutput ) THEN

        err = NF_GET_VARA_DOUBLE( fid, varID1, vec_start, vec_count,
     &        active_data_t )
        CALL OBSFIT_NF_ERROR(
     &       'ACTIVE_WRITE: NF_GET_VARA_DOUBLE active_data_t',
     &       err,bi,bj,myThid )

C     Add active_var to data.
        active_var = active_var + active_data_t
        active_data_t = 0. _d 0

        err = NF_PUT_VARA_DOUBLE(fid, varID1, vec_start, vec_count,
     &        active_data_t )
        CALL OBSFIT_NF_ERROR(
     &         'ACTIVE_WRITE: NF_PUT_VARA_DOUBLE active_data_t',
     &         err,bi,bj,myThid )

       ELSE

        READ( fid, rec=jrec+1 ) vec_tmp
#ifdef _BYTESWAPIO
        CALL MDS_BYTESWAPR8( 2, vec_tmp )
#endif
        active_data_t = vec_tmp(1)

C Add active_var from appropriate location to data.
        active_var = active_var + active_data_t
        active_data_t = 0. _d 0

C Store the result on disk.
        vec_tmp(1) = active_data_t
#ifdef _BYTESWAPIO
        CALL MDS_BYTESWAPR8( 2, vec_tmp )
#endif
        WRITE( fid, rec=jrec+1 ) vec_tmp

       ENDIF

       _END_MASTER( myThid )

      ENDIF

C     >>>>>>>>>>>>>>>>>>>             <<<<<<<<<<<<<<<<<<<
C     >>>>>>>>>>>>>>>>>>> TANGENT RUN <<<<<<<<<<<<<<<<<<<
C     >>>>>>>>>>>>>>>>>>>             <<<<<<<<<<<<<<<<<<<

      IF ( theSimulationMode .EQ. TANGENT_SIMULATION ) THEN

       _BEGIN_MASTER( myThid )

       IF ( obsfitDoNcOutput ) THEN

        err = NF_PUT_VARA_DOUBLE(fid, varID1, vec_start, vec_count,
     &        active_var )
          CALL OBSFIT_NF_ERROR(
     &         'ACTIVE_WRITE: NF_PUT_VARA_DOUBLE TL active_var',
     &         err,bi,bj,myThid )
       ELSE

        vec_tmp(1) = active_var
        vec_tmp(2) = irec
#ifdef _BYTESWAPIO
        CALL MDS_BYTESWAPR8( 2, vec_tmp )
#endif
        WRITE( fid, rec=jrec+1 ) vec_tmp

       ENDIF

       _END_MASTER( myThid )

      ENDIF

#endif /* ALLOW_OBSFIT */

      RETURN
      END

C     ==================================================================

CBOP
C     !ROUTINE: ACTIVE_READ_OBS_GLOB_RL

C     !INTERFACE:
      SUBROUTINE ACTIVE_READ_OBS_GLOB_RL(
     I                                  fid,
     I                                  active_num_file,
     O                                  active_var,
     O                                  active_mask,
     I                                  lAdInit,
     I                                  irec,
     I                                  irecglob,
     I                                  theSimulationMode,
     I                                  myOptimIter,
     I                                  myThid )

C     !DESCRIPTION:
C     ==================================================================
C     | Read an active record from an ObsFit .equi. global file
C     ==================================================================

C     !USES:
      IMPLICIT NONE
C     == Global variables ===
#include "EEPARAMS.h"
#include "SIZE.h"
#include "PARAMS.h"
#ifdef ALLOW_OBSFIT
# include "netcdf.inc"
# include "OBSFIT_SIZE.h"
# include "OBSFIT.h"
#endif

C     !INPUT PARAMETERS:
      INTEGER  fid
      INTEGER  active_num_file
      INTEGER  irec, irecglob
      INTEGER  theSimulationMode
      INTEGER  myOptimIter
      INTEGER  myThid
      _RL      active_var
      _RL      active_mask
      logical  lAdInit

#ifdef ALLOW_OBSFIT
C     !LOCAL VARIABLES:
      INTEGER  err, varID1, varID2
      INTEGER  vec_start, vec_count
      _RL      active_data_t
CEOP

      vec_start = irecglob
      vec_count = 1

C     >>>>>>>>>>>>>>>>>>>             <<<<<<<<<<<<<<<<<<<
C     >>>>>>>>>>>>>>>>>>> FORWARD RUN <<<<<<<<<<<<<<<<<<<
C     >>>>>>>>>>>>>>>>>>>             <<<<<<<<<<<<<<<<<<<

      IF ( theSimulationMode .EQ. FORWARD_SIMULATION ) THEN

       _BEGIN_MASTER( myThid )

        err = NF_INQ_VARID( fid, obsfit_nameequi, varID1 )
        err = NF_GET_VARA_DOUBLE( fid, varID1, vec_start, vec_count,
     &   active_var )

        err = NF_INQ_VARID( fid, obsfit_namemask, varID2 )
        err = NF_GET_VARA_DOUBLE( fid, varID2, vec_start, vec_count,
     &   active_mask )

        _END_MASTER( myThid )

      ENDIF

C     >>>>>>>>>>>>>>>>>>>             <<<<<<<<<<<<<<<<<<<
C     >>>>>>>>>>>>>>>>>>> ADJOINT RUN <<<<<<<<<<<<<<<<<<<
C     >>>>>>>>>>>>>>>>>>>             <<<<<<<<<<<<<<<<<<<

      IF ( theSimulationMode .EQ. REVERSE_SIMULATION ) THEN

       _BEGIN_MASTER( myThid )

       err = NF_INQ_VARID( fid, obsfit_nameequi, varID1 )
       err = NF_GET_VARA_DOUBLE( fid, varID1, vec_start, vec_count,
     &       active_data_t )

C Add active_var from appropriate location to data
       active_data_t = active_data_t + active_var
C Store the result on disk.
       err = NF_INQ_VARID( fid, obsfit_nameequi, varID1 )
       err = NF_PUT_VARA_DOUBLE( fid, varID1, vec_start, vec_count,
     &       active_data_t )

C Set active_var to zero
       active_var = 0. _d 0

       _END_MASTER( myThid )

      ENDIF

C     >>>>>>>>>>>>>>>>>>>             <<<<<<<<<<<<<<<<<<<
C     >>>>>>>>>>>>>>>>>>> TANGENT RUN <<<<<<<<<<<<<<<<<<<
C     >>>>>>>>>>>>>>>>>>>             <<<<<<<<<<<<<<<<<<<

      IF ( theSimulationMode .EQ. TANGENT_SIMULATION ) THEN

       _BEGIN_MASTER( myThid )

       err = NF_INQ_VARID( fid, obsfit_nameequi, varID1 )
       err = NF_GET_VARA_DOUBLE( fid, varID1, vec_start, vec_count,
     &       active_var )

       _END_MASTER( myThid )

      ENDIF

#endif /* ALLOW_OBSFIT */

      RETURN
      END

C     =================================================================

CBOP
C     !ROUTINE: ACTIVE_WRITE_OBS_GLOB_RL

C     !INTERFACE:
      SUBROUTINE ACTIVE_WRITE_OBS_GLOB_RL(
     I                                     fid,
     I                                     active_num_file,
     I                                     active_var,
     I                                     active_mask,
     I                                     irec,
     I                                     irecglob,
     I                                     theSimulationMode,
     I                                     myOptimIter,
     I                                     myThid )

C     !DESCRIPTION:
C     ==================================================================
C     | Write an active record to an ObsFit .equi. global file
C     ==================================================================

C     !USES:
      IMPLICIT NONE
C     == Global variables ===
#include "EEPARAMS.h"
#include "SIZE.h"
#include "PARAMS.h"
#ifdef ALLOW_OBSFIT
# include "netcdf.inc"
# include "OBSFIT_SIZE.h"
# include "OBSFIT.h"
#endif

C     !INPUT PARAMETERS:
      INTEGER  fid
      INTEGER  active_num_file
      INTEGER  irec, irecglob
      INTEGER  theSimulationMode
      INTEGER  myOptimIter
      INTEGER  myThid
      _RL      active_var
      _RL      active_mask

#ifdef ALLOW_OBSFIT
C     !LOCAL VARIABLES:
      INTEGER  err, varID1, varID2
      INTEGER  vec_start, vec_count
      _RL      active_data_t
CEOP

      vec_start = irecglob
      vec_count = 1

C     >>>>>>>>>>>>>>>>>>>             <<<<<<<<<<<<<<<<<<<
C     >>>>>>>>>>>>>>>>>>> FORWARD RUN <<<<<<<<<<<<<<<<<<<
C     >>>>>>>>>>>>>>>>>>>             <<<<<<<<<<<<<<<<<<<

      IF ( theSimulationMode .EQ. FORWARD_SIMULATION ) THEN

       _BEGIN_MASTER( myThid )

       err = NF_INQ_VARID( fid, obsfit_nameequi, varID1 )
       err = NF_PUT_VARA_DOUBLE( fid, varID1, vec_start, vec_count,
     &       active_var )

       err = NF_INQ_VARID( fid, obsfit_namemask, varID2 )
       err = NF_PUT_VARA_DOUBLE( fid, varID2, vec_start, vec_count,
     &       active_mask )

       _END_MASTER( myThid )

      ENDIF

c     >>>>>>>>>>>>>>>>>>>             <<<<<<<<<<<<<<<<<<<
C     >>>>>>>>>>>>>>>>>>> ADJOINT RUN <<<<<<<<<<<<<<<<<<<
C     >>>>>>>>>>>>>>>>>>>             <<<<<<<<<<<<<<<<<<<

      IF ( theSimulationMode .EQ. REVERSE_SIMULATION ) THEN

       _BEGIN_MASTER( myThid )

cav       vec_start = irec
cav       vec_count = 1
       err = NF_INQ_VARID( fid, obsfit_nameequi, varID1 )
       err = NF_GET_VARA_DOUBLE( fid, varID1, vec_start, vec_count,
     &       active_data_t )

C Add active_var to data.
       active_var = active_var + active_data_t
       active_data_t = 0. _d 0

cav       vec_start = irecglob
cav       vec_count = 1

       err = NF_INQ_VARID( fid, obsfit_nameequi, varID1 )
       err = NF_PUT_VARA_DOUBLE( fid, varID1, vec_start, vec_count,
     &       active_data_t )

       _END_MASTER( myThid )

      ENDIF

C     >>>>>>>>>>>>>>>>>>>             <<<<<<<<<<<<<<<<<<<
C     >>>>>>>>>>>>>>>>>>> TANGENT RUN <<<<<<<<<<<<<<<<<<<
C     >>>>>>>>>>>>>>>>>>>             <<<<<<<<<<<<<<<<<<<

      IF ( theSimulationMode .EQ. TANGENT_SIMULATION ) THEN

       _BEGIN_MASTER( myThid )

       err = NF_INQ_VARID( fid, obsfit_nameequi, varID1 )
       err = NF_PUT_VARA_DOUBLE( fid, varID1, vec_start, vec_count,
     &       active_var )

       _END_MASTER( myThid )

      ENDIF

#endif /* ALLOW_OBSFIT */

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#include "STREAMICE_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

CBOP
      SUBROUTINE STREAMICE_DIAGNOSTICS_STATE( myTime, myIter, myThid )

C     /============================================================\
C     | SUBROUTINE                                                 |
C     | o                                                          |
C     |============================================================|
C     |                                                            |
C     \============================================================/
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "STREAMICE.h"

      _RL myTime
      INTEGER myIter, myThid

#ifdef ALLOW_STREAMICE
#ifdef ALLOW_DIAGNOSTICS
      CHARACTER*(MAX_LEN_MBUF) msgBuf

#ifdef ALLOW_OPENAD
      INTEGER i, j, bi, bj

      _RL u_streamice_diag(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL v_streamice_diag(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL u_surf_diag(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL v_surf_diag(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL h_streamice_diag(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL area_diag(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL float_frac_diag(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL surf_diag(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL bdot_diag(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
#ifdef STREAMICE_HYBRID_STRESS
      _RL streamice_taubx_diag(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL streamice_tauby_diag(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
#endif
#ifdef ALLOW_STREAMICE_2DTRACER
       _RL trac2d_diag
#endif

      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
           u_streamice_diag(i,j,bi,bj) = u_streamice(i,j,bi,bj)%v
           v_streamice_diag(i,j,bi,bj) = v_streamice(i,j,bi,bj)%v
           h_streamice_diag(i,j,bi,bj) = H_streamice(i,j,bi,bj)%v
           area_diag(i,j,bi,bj) = area_shelf_streamice(i,j,bi,bj)%v
#if (defined(STREAMICE_SMOOTH_FLOATATION2) || defined(STREAMICE_SMOOTH_FLOATATION))
           float_frac_diag(i,j,bi,bj) =
     &         float_frac_streamice(i,j,bi,bj)%v
#endif
           surf_diag(i,j,bi,bj) =
     &         surf_el_streamice(i,j,bi,bj)%v
           bdot_diag(i,j,bi,bj) =
     &         bdot_streamice(i,j,bi,bj)%v
#ifdef STREAMICE_HYBRID_STRESS
           streamice_taubx_diag(i,j,bi,bj) =
     $         streamice_taubx(i,j,bi,bj)%v
           streamice_tauby_diag(i,j,bi,bj) =
     $         streamice_tauby(i,j,bi,bj)%v
           u_surf_diag(i,j,bi,bj) = streamice_u_surf(i,j,bi,bj)%v
           v_surf_diag(i,j,bi,bj) = streamice_v_surf(i,j,bi,bj)%v
#endif
#ifdef ALLOW_STREAMICE_2DTRACER
           trac2d_diag(i,j,bi,bj)=trac2d(i,j,bi,bj)%v
#endif

         ENDDO
        ENDDO
       ENDDO
      ENDDO

#endif /* ALLOW_OPENAD */

      IF ( useDiagnostics ) THEN
       WRITE(msgBuf,'(A)') 'CALLING FILL DIAGNOSTICS'
       CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                     SQUEEZE_RIGHT , 1)

#ifdef ALLOW_OPENAD

       CALL DIAGNOSTICS_FILL(U_streamice_diag,'SI_Uvel ',
     &      0,1,0,1,1,myThid)
       CALL DIAGNOSTICS_FILL(V_streamice_diag,'SI_Vvel ',
     &      0,1,0,1,1,myThid)
       CALL DIAGNOSTICS_FILL(H_streamice_diag,'SI_Thick',
     &      0,1,0,1,1,myThid)
       CALL DIAGNOSTICS_FILL(area_diag,'SI_area ',
     &      0,1,0,1,1,myThid)
       CALL DIAGNOSTICS_FILL(surf_diag,'SI_selev',
     &      0,1,0,1,1,myThid)
       CALL DIAGNOSTICS_FILL(bdot_diag,'BDOT_SI ',
     &      0,1,0,1,1,myThid)

#else

       CALL DIAGNOSTICS_FILL(U_streamice,'SI_Uvel ',
     &      0,1,0,1,1,myThid)
       CALL DIAGNOSTICS_FILL(V_streamice,'SI_Vvel ',
     &      0,1,0,1,1,myThid)
       CALL DIAGNOSTICS_FILL(H_streamice,'SI_Thick',
     &      0,1,0,1,1,myThid)
       CALL DIAGNOSTICS_FILL(area_shelf_streamice,'SI_area ',
     &      0,1,0,1,1,myThid)
       CALL DIAGNOSTICS_FILL(float_frac_streamice,'SI_float',
     &      0,1,0,1,1,myThid)
       CALL DIAGNOSTICS_FILL(surf_el_streamice,'SI_selev',
     &      0,1,0,1,1,myThid)
        CALL DIAGNOSTICS_FILL(bdot_streamice,'BDOT_SI ',
     &      0,1,0,1,1,myThid)

#endif

#ifdef ALLOW_OPENAD
#if (defined(STREAMICE_SMOOTH_FLOATATION2) || defined(STREAMICE_SMOOTH_FLOATATION))
       CALL DIAGNOSTICS_FILL(float_frac_diag,'SI_float',
     &      0,1,0,1,1,myThid)
#else
       CALL DIAGNOSTICS_FILL(float_frac_streamice,'SI_float',
     &      0,1,0,1,1,myThid)
#endif
#endif

       CALL DIAGNOSTICS_FILL_RS(STREAMICE_hmask,'SI_hmask',
     &      0,1,0,1,1,myThid)
#ifdef STREAMICE_HYBRID_STRESS
       CALL DIAGNOSTICS_FILL(streamice_u_bed,'SI_ubase',
     &      0,1,0,1,1,myThid)
       CALL DIAGNOSTICS_FILL(STREAMICE_v_bed,'SI_vbase',
     &      0,1,0,1,1,myThid)

#ifdef ALLOW_OPENAD
       CALL DIAGNOSTICS_FILL(streamice_taubx_diag,'SI_taubx',
     &      0,1,0,1,1,myThid)
       CALL DIAGNOSTICS_FILL(STREAMICE_tauby_diag,'SI_tauby',
     &      0,1,0,1,1,myThid)
       CALL DIAGNOSTICS_FILL(u_surf_diag,'SI_usurf',
     &      0,1,0,1,1,myThid)
       CALL DIAGNOSTICS_FILL(v_surf_diag,'SI_vsurf',
     &      0,1,0,1,1,myThid)
#else
       CALL DIAGNOSTICS_FILL(streamice_taubx,'SI_taubx',
     &      0,1,0,1,1,myThid)
       CALL DIAGNOSTICS_FILL(STREAMICE_tauby,'SI_tauby',
     &      0,1,0,1,1,myThid)
       CALL DIAGNOSTICS_FILL(streamice_u_surf,'SI_usurf',
     &      0,1,0,1,1,myThid)
       CALL DIAGNOSTICS_FILL(streamice_v_surf,'SI_vsurf',
     &      0,1,0,1,1,myThid)
#endif

#endif

#ifdef ALLOW_STREAMICE_2DTRACER
#ifdef ALLOW_OPENAD
       CALL DIAGNOSTICS_FILL(trac2d_diag,'SI2Dtrac',
     &      0,1,0,1,1,myThid)
#else
       CALL DIAGNOSTICS_FILL(trac2d,'SI2Dtrac',
     &      0,1,0,1,1,myThid)
#endif
#endif

      ENDIF

#endif /* ALLOW_DIAGNOSTICS */
#endif /* ALLOW_STREAMICE */
      RETURN
      END

#include "DIAG_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 0
C     !ROUTINE: DIAGSTATS_CLEAR

C     !INTERFACE:
      SUBROUTINE DIAGSTATS_CLEAR( listId, myThid)

C     !DESCRIPTION:
C     Clear statistics-diagnostics specified in 1 output stream list

C     !USES:
      IMPLICIT NONE
#include "EEPARAMS.h"
#include "SIZE.h"
#include "DIAGNOSTICS_SIZE.h"
#include "DIAGNOSTICS.h"

C     !INPUT PARAMETERS:
C     listId :: Diagnostics list number being written
C     myThid  :: my Thread Id number
      INTEGER  listId, myThid
CEOP

C     !LOCAL VARIABLES:
      INTEGER m, ndId, iSp

      DO m=1,diagSt_nbActv(listId)
       IF ( iSdiag(m,listId).GT.0 ) THEN
         ndId = jSdiag(m,listId)
         iSp  = iSdiag(m,listId)
         CALL DIAGSTATS_CLRDIAG( ndId, iSp, myThid )
       ENDIF
      ENDDO

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

CBOP 0
C     !ROUTINE: DIAGSTATS_CLEAR

C     !INTERFACE:
      SUBROUTINE DIAGSTATS_CLRDIAG( ndId, iSp, myThid )

C     !DESCRIPTION:
C     Zero out 1 statistics-diagnostic array

C     !USES:
      IMPLICIT NONE
#include "EEPARAMS.h"
#include "SIZE.h"
#include "DIAGNOSTICS_SIZE.h"
#include "DIAGNOSTICS.h"

C     !INPUT PARAMETERS:
C     ndId    :: Diagnostics Id Number (in available diag. list) to zero out
C     iSp     :: diagnostic pointer to storage array
C     myThid  :: my Thread Id number
      INTEGER ndId, iSp, myThid
CEOP

C     !LOCAL VARIABLES:
      INTEGER bi,bj
      INTEGER i,j,k

C **********************************************************************
C ****              SET DIAGNOSTIC AND COUNTER TO ZERO              ****
C **********************************************************************

      DO bj=myByLo(myThid), myByHi(myThid)
       DO bi=myBxLo(myThid), myBxHi(myThid)
        DO k = iSp,iSp+kdiag(ndId)-1
         DO j = 0,nRegions
          DO i = 0,nStats
           qSdiag(i,j,k,bi,bj) = 0.
          ENDDO
         ENDDO
        ENDDO
       ENDDO
      ENDDO

      RETURN
      END

#include "STREAMICE_OPTIONS.h"

      INTEGER FUNCTION ADFIXEDPOINT_NOTREDUCED(CUMUL, REDUCTION)
      IMPLICIT NONE

C     !DESCRIPTION:
C     *==========================================================*
C     | FUNCTION IO\_ERRCOUNT                                     |
C     | o Reads IO error counter.                                |
C     *==========================================================*

C     !USES:
C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "STREAMICE_FP.h"

C     !INPUT PARAMETERS:
C     == Routine arguments ==
      _RL CUMUL
      _RL REDUCTION
#ifdef ALLOW_TAPENADE
      _RL CUMUL_GLOB
      _RL CUMUL_TILE(1:nSx, 1:nSy)
      INTEGER iterate
      INTEGER growth
      INTEGER bi, bj, jtlo, jthi, itlo, ithi
CEOP

      IF (nTx.gt.1 .or. nTy.gt.1) THEN
       STOP 'ADFIXEDPOINT_NOTREDUCED: multithread not available'
      ENDIF

      DO bi=1,nSx
        DO bj=1,nSy
          CUMUL_TILE(bi,bj)=0.0
        ENDDO
      ENDDO
      CUMUL_TILE(1,1) = CUMUL

      CALL GLOBAL_SUM_TILE_RL
     &   ( CUMUL_TILE, CUMUL_GLOB, 1 )

      CUMUL = CUMUL_GLOB

      IF (cumul .LT. 0.0D0) THEN
C         Begin 1st iteration of a new adjoint FP loop
          IF (fpDepth .GE. 5) THEN
              adFixedPoint_notReduced = 0
              RETURN
          ENDIF
          fpDepth = fpDepth + 1
          refCumuls(fpDepth) = -1.0D0
          prevCumuls(fpDepth) = -1.0D0
          adjIters(fpDepth) = 1
          adFixedPoint_notReduced = 1
#ifdef ALLOW_PETSC
          if (STREAMICE_OAD_petsc_reuse) then
            streamice_need2createmat=.true.
            streamice_need2destroymat=.false.
          endif
#endif
          RETURN
      ELSE
C         2nd or later iteration
          IF (refCumuls(fpDepth) .LT. 0.0D0) THEN
C             Set reference value
              refCumuls(fpDepth) = cumul
              prevCumuls(fpDepth) = cumul
              IF (cumul .GT. 1.0D-10) THEN
                  iterate = 1
              ELSE
                  iterate = 0
              ENDIF
              growth = 0
          ELSE
C             Compare with reference value
              IF (cumul .GT. streamice_nonlin_tol_adjoint_rl *
     &                       refCumuls(fpDepth)) THEN
                  iterate = 1
              ELSE
                  iterate = 0
              ENDIF
              IF (adjIters(fpDepth) .GT. 5 .AND.
     &             cumul .GT. prevCumuls(fpDepth)) THEN
                  growth = 1
              ELSE
                  growth = 0
              ENDIF
              prevCumuls(fpDepth) = cumul
          ENDIF

          IF (iterate .EQ. 1 .AND. growth .EQ. 0) THEN
              adjIters(fpDepth) = adjIters(fpDepth) + 1
              WRITE(*,*) adjIters(fpDepth),
     &                 ' adjoint iterations (reduced ',
     &                 refCumuls(fpDepth), ' -> ', cumul, ')'
              adFixedPoint_notReduced = 1
#ifdef ALLOW_PETSC
              if (STREAMICE_OAD_petsc_reuse) then
                streamice_need2createmat=.false.
                streamice_need2destroymat=.false.
              endif
#endif
              RETURN
          ELSE
              IF (growth .EQ. 1) THEN
                  WRITE(*,*) adjIters(fpDepth),
     &                 ' adjoint iterations (reduced ',
     &                 refCumuls(fpDepth), ' -> ', cumul,
     &                 ', TERMINATED)'
#ifdef ALLOW_PETSC
                  if (STREAMICE_OAD_petsc_reuse) then
                    streamice_need2createmat=.false.
                    streamice_need2destroymat=.true.
                    !CALL streamice_petscmatdestroy()
                  endif
#endif
              ELSE
                  WRITE(*,*) adjIters(fpDepth),
     &                 ' adjoint iterations (reduced ',
     &                 refCumuls(fpDepth), ' -> ', cumul,
     &                 '), CONVERGED'
#ifdef ALLOW_PETSC
                  if (STREAMICE_OAD_petsc_reuse) then
                    streamice_need2createmat=.false.
                    streamice_need2destroymat=.true.
                    !CALL streamice_petscmatdestroy()
                  endif
#endif
              ENDIF

              IF (fpDepth .LT. 0) THEN
                  adFixedPoint_notReduced = 0
#ifdef ALLOW_PETSC
                  if (STREAMICE_OAD_petsc_reuse) then
                    streamice_need2createmat=.false.
                    streamice_need2destroymat=.true.
                    !CALL streamice_petscmatdestroy()
                  endif
#endif
                  RETURN
              ENDIF
              fpDepth = fpDepth - 1
              adFixedPoint_notReduced = 0
              RETURN
          ENDIF
      ENDIF
#endif /* ALLOW_TAPENADE */
      END

#include "PACKAGES_CONFIG.h"
#include "CPP_OPTIONS.h"


CBOP
C     !ROUTINE: DO_STATEVARS_DIAGS
C     !INTERFACE:
      SUBROUTINE DO_STATEVARS_DIAGS( myTime, seqFlag, myIter, myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE DO_STATEVARS_DIAGS
C     | o Controlling routine for state variables diagnostics
C     *==========================================================*
C     | Computing diagnostics of the model state (state-variables)
C     | is done at this level ;
C     | by contrast, other diagnostics (fluxes, tendencies)
C     | remain within the computation sequence.
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     == Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     myTime  :: Current time of simulation ( s )
C     seqFlag :: flag that indicate where this S/R is called from:
C             :: =0 called from the beginning of forward_step
C             :: =1 called from the middle of forward_step
C             :: =2 called from the end of forward_step
C     myIter  :: Iteration number
C     myThid  :: my Thread Id number
      _RL     myTime
      INTEGER seqFlag
      INTEGER myIter
      INTEGER myThid
CEOP

#ifdef ALLOW_DIAGNOSTICS
C     !LOCAL VARIABLES:
C     == Local variables ==
C     selectVars :: select which group of dianostics variables to fill-in
C            = 1 :: fill-in diagnostics for tracer   variables only
C            = 2 :: fill-in diagnostics for momentum variables only
C            = 3 :: fill-in diagnostics for momentum & tracer variables
C            = 4 :: fill-in state variable tendency diagnostics the second time
      INTEGER selectVars

C--   Fill-in Diagnostics pkg storage array (for state-variables)
      IF ( usediagnostics ) THEN

C-    select which group of state-var diagnostics to fill-in,
C      depending on: where this S/R is called from (seqFlag)
C                    and stagger/synchronous TimeStep
        selectVars = 0
        IF ( staggerTimeStep ) THEN
          IF ( seqFlag.EQ.0 ) selectVars = 2
          IF ( seqFlag.EQ.1 ) selectVars = 1
        ELSE
          IF ( seqFlag.EQ.0 ) selectVars = 3
        ENDIF
        IF ( seqFlag.EQ.2 ) selectVars = 4
        CALL DIAGNOSTICS_FILL_STATE( selectVars, myIter, myThid )

#ifdef ALLOW_GENERIC_ADVDIFF
        IF ( seqFlag.EQ.0 .AND. useGAD ) THEN
          CALL GAD_DIAGNOSTICS_STATE( myTime, myIter, myThid )
        ENDIF
#endif /* ALLOW_GENERIC_ADVDIFF */

#ifdef ALLOW_PTRACERS
        IF ( (selectVars.EQ.1 .OR. selectVars.EQ.3)
     &      .AND. usePTRACERS ) THEN
          CALL PTRACERS_DIAGNOSTICS_STATE( myTime, myIter, myThid )
        ENDIF
#endif /* ALLOW_PTRACERS */

#ifdef ALLOW_GMREDI
       IF ( seqFlag.EQ.2 .AND. useGMRedi ) THEN
         CALL GMREDI_DIAGNOSTICS_IMPL( myTime, myIter, myThid )
       ENDIF
#endif /* ALLOW_GMREDI */

#ifdef ALLOW_BBL
       IF ( seqFlag.EQ.0 .AND. useBBL ) THEN
         CALL BBL_DIAGNOSTICS_STATE( myTime, myIter, myThid )
       ENDIF
#endif /* ALLOW_BBL */

#ifdef ALLOW_SEAICE
       IF ( seqFlag.EQ.0 .AND. useSEAICE ) THEN
         CALL SEAICE_DIAGNOSTICS_STATE( myTime, myIter, myThid )
       ENDIF
#endif /* ALLOW_SEAICE */

#ifdef ALLOW_THSICE
       IF ( seqFlag.EQ.0 .AND. useThSIce ) THEN
         CALL THSICE_DIAGNOSTICS_STATE( myTime, myIter, myThid )
       ENDIF
#endif /* ALLOW_THSICE */

#ifdef ALLOW_STREAMICE
       IF ( seqFlag.EQ.2 .AND. useStreamIce ) THEN
         CALL STREAMICE_DIAGNOSTICS_STATE( myTime, myIter, myThid )
       ENDIF
#endif /* ALLOW_SEAICE */

#ifdef ALLOW_LAND
       IF ( seqFlag.EQ.0 .AND. useLand ) THEN
         CALL LAND_DIAGNOSTICS_STATE( myTime, myIter, myThid )
       ENDIF
#endif /* ALLOW_LAND */

#ifdef ALLOW_MYPACKAGE
       IF ( seqFlag.EQ.0 .AND. useMYPACKAGE ) THEN
         CALL MYPACKAGE_DIAGNOSTICS_STATE( myTime, myIter, myThid )
       ENDIF
#endif /* ALLOW_MYPACKAGE */

      ENDIf
#endif /* ALLOW_DIAGNOSTICS */

      RETURN
      END

#include "THSICE_OPTIONS.h"
#ifdef ALLOW_ATM2D
# include "ctrparam.h"
#endif
#ifdef ALLOW_AUTODIFF
# include "AUTODIFF_OPTIONS.h"
#endif

CBOP
C     !ROUTINE: THSICE_STEP_FWD
C     !INTERFACE:
      SUBROUTINE THSICE_STEP_FWD(
     I             bi, bj, iMin, iMax, jMin, jMax,
     I             prcAtm, snowPrc, qPrcRnO,
     I             myTime, myIter, myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R  THSICE_STEP_FWD
C     | o Step Forward Therm-SeaIce model.
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "FFIELDS.h"
#ifdef  ALLOW_ATM2D
# include "ATMSIZE.h"
# include "ATM2D_VARS.h"
#endif
#include "THSICE_SIZE.h"
#include "THSICE_PARAMS.h"
#include "THSICE_VARS.h"
#ifdef ALLOW_AUTODIFF_TAMC
# include "tamc.h"
#endif

      INTEGER siLo, siHi, sjLo, sjHi
      PARAMETER ( siLo = 1-OLx , siHi = sNx+OLx )
      PARAMETER ( sjLo = 1-OLy , sjHi = sNy+OLy )

C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
C- input:
C     bi,bj   :: tile indices
C   iMin,iMax :: computation domain: 1rst index range
C   jMin,jMax :: computation domain: 2nd  index range
C     prcAtm  :: total precip from the atmosphere [kg/m2/s]
C     snowPrc :: snow precipitation               [kg/m2/s]
C     qPrcRnO :: Energy content of Precip+RunOff (+=down) [W/m2]
C     myTime  :: current Time of simulation [s]
C     myIter  :: current Iteration number in simulation
C     myThid  :: my Thread Id number
C-- Use fluxes hold in commom blocks
C- input:
C     icFlxSW :: net short-wave heat flux (+=down) below sea-ice, into ocean
C     icFlxAtm  :: net Atmospheric surf. heat flux over sea-ice [W/m2], (+=down)
C     icFrwAtm  :: evaporation over sea-ice to the atmosphere   [kg/m2/s] (+=up)
C- output
C     icFlxAtm  :: net Atmospheric surf. heat flux over ice+ocean [W/m2], (+=down)
C     icFrwAtm  :: net fresh-water flux (E-P) from the atmosphere [kg/m2/s] (+=up)
      INTEGER bi,bj
      INTEGER iMin, iMax
      INTEGER jMin, jMax
      _RL prcAtm (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL snowPrc(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL qPrcRnO(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL  myTime
      INTEGER myIter
      INTEGER myThid
CEOP

#ifdef ALLOW_THSICE
C     !LOCAL VARIABLES:
C     === Local variables ===
C     iceFrac   :: fraction of grid area covered in ice
C     flx2oc    :: net heat flux from the ice to the ocean (+=down) [W/m2]
C     frw2oc    :: fresh-water flux from the ice to the ocean (+=down)
C     fsalt     :: mass salt flux to the ocean                (+=down)
C     frzSeaWat :: seawater freezing rate (expressed as mass flux) [kg/m^2/s]
C     frzmltMxL :: ocean mixed-layer freezing/melting potential [W/m2]
C     tFrzOce   :: sea-water freezing temperature [oC] (function of S)
C     isIceFree :: true for ice-free grid-cell that remains ice-free
C     ageFac    :: snow aging factor [1]
C     snowFac   :: snowing refreshing-age factor [units of 1/snowPr]
#ifdef ALLOW_BULK_FORCE
      LOGICAL isIceFree(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
#endif
      _RL     iceFrac  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL     flx2oc   (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL     frw2oc   (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL     fsalt    (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL     frzSeaWat(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL     tFrzOce  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL     frzmltMxL(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL ageFac
      _RL snowFac
      _RL cphm
      _RL opFrac, icFrac
      INTEGER i,j
      LOGICAL dBugFlag

#ifdef ALLOW_AUTODIFF_TAMC
C     tkey  :: tape key (depends on tiles)
      INTEGER tkey
#endif
C-    define grid-point location where to print debugging values
#include "THSICE_DEBUG.h"

 1010 FORMAT(A,1P4E14.6)

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#ifdef ALLOW_AUTODIFF_TAMC
      tkey = bi + (bj-1)*nSx + (ikey_dynamics-1)*nSx*nSy
#endif /* ALLOW_AUTODIFF_TAMC */

C-    Initialise
      dBugFlag = debugLevel.GE.debLevC
      DO j = 1-OLy, sNy+OLy
       DO i = 1-OLx, sNx+OLx
#ifdef ALLOW_BULK_FORCE
          isIceFree(i,j) = .FALSE.
#endif
#ifdef ALLOW_ATM2D
          sFluxFromIce(i,j) = 0. _d 0
#else
          saltFlux(i,j,bi,bj) = 0. _d 0
#endif
          frzSeaWat(i,j) = 0. _d 0
#ifdef ALLOW_AUTODIFF
          iceFrac(i,j) = 0.
C-   set these arrays everywhere: overlap are not set and not used,
C     but some arrays are stored and storage includes overlap.
          flx2oc(i,j) = 0. _d 0
          frw2oc(i,j) = 0. _d 0
          fsalt (i,j) = 0. _d 0
c         tFrzOce  (i,j) = 0. _d 0
c         frzmltMxL(i,j) = 0. _d 0
#endif
       ENDDO
      ENDDO

      ageFac = 1. _d 0 - thSIce_deltaT/snowAgTime
      snowFac = thSIce_deltaT/(rhos*hNewSnowAge)

#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE iceMask(:,:,bi,bj) = comlev1_bibj,key=tkey,kind=isbyte
#endif
      DO j = jMin, jMax
       DO i = iMin, iMax
        IF (iceMask(i,j,bi,bj).GT.0. _d 0) THEN
C--  Snow aging :
          snowAge(i,j,bi,bj) = thSIce_deltaT
     &                       + snowAge(i,j,bi,bj)*ageFac
          IF ( snowPrc(i,j).GT.0. _d 0 )
     &      snowAge(i,j,bi,bj) = snowAge(i,j,bi,bj)
     &          * EXP( - snowFac*snowPrc(i,j) )
C-------
C note: Any flux of mass (here fresh water) that enter or leave the system
C       with a non zero energy HAS TO be counted: add snow precip.
          icFlxAtm(i,j,bi,bj) = icFlxAtm(i,j,bi,bj)
     &                        - Lfresh*snowPrc(i,j)
     &                        + qPrcRnO(i,j)
C--
        ENDIF
       ENDDO
      ENDDO

#ifdef ALLOW_DIAGNOSTICS
      IF ( useDiagnostics ) THEN
        CALL DIAGNOSTICS_FRACT_FILL( snowPrc,
     I                       iceMask(1-OLx,1-OLy,bi,bj), oneRL, 1,
     I                              'SIsnwPrc', 0,1,2,bi,bj,myThid )
        CALL DIAGNOSTICS_FRACT_FILL( siceAlb, iceMask, oneRL, 1,
     I                              'SIalbedo', 0,1,1,bi,bj,myThid )
      ENDIF
#endif /* ALLOW_DIAGNOSTICS */
      DO j = jMin, jMax
       DO i = iMin, iMax
          siceAlb(i,j,bi,bj) = iceMask(i,j,bi,bj)*siceAlb(i,j,bi,bj)
       ENDDO
      ENDDO

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C    part.2 : ice-covered fraction ;
C     change in ice/snow thickness and ice-fraction
C     note: can only reduce the ice-fraction but not increase it.
C-------
      DO j = jMin, jMax
       DO i = iMin, iMax

        tFrzOce(i,j) = -mu_Tf*sOceMxL(i,j,bi,bj)
        cphm    = cpwater*rhosw*hOceMxL(i,j,bi,bj)
        frzmltMxL(i,j) = ( tFrzOce(i,j)-tOceMxL(i,j,bi,bj) )
     &                 * cphm/ocean_deltaT
        iceFrac(i,j) = iceMask(i,j,bi,bj)
        flx2oc(i,j)  = icFlxSW(i,j,bi,bj) + qPrcRnO(i,j)
C-------
#ifdef ALLOW_DBUG_THSICE
        IF ( dBug(i,j,bi,bj) ) THEN
         IF (frzmltMxL(i,j).GT.0. .OR. iceFrac(i,j).GT.0.) THEN
          WRITE(6,'(A,2I4,2I2)') 'ThSI_FWD: i,j=',i,j,bi,bj
          WRITE(6,1010) 'ThSI_FWD:-1- iceMask, hIc, hSn, Tsf  =',
     &                  iceFrac(i,j), iceHeight(i,j,bi,bj),
     &                  snowHeight(i,j,bi,bj), Tsrf(i,j,bi,bj)
          WRITE(6,1010) 'ThSI_FWD: ocTs,tFrzOce,frzmltMxL,Qnet=',
     &                     tOceMxL(i,j,bi,bj), tFrzOce(i,j),
     &                     frzmltMxL(i,j), Qnet(i,j,bi,bj)
         ENDIF
         IF (iceFrac(i,j).GT.0.)
     &    WRITE(6,1010) 'ThSI_FWD: icFrac,flxAtm,evpAtm,flxSnw=',
     &      iceFrac(i,j), icFlxAtm(i,j,bi,bj),
     &      icFrwAtm(i,j,bi,bj),-Lfresh*snowPrc(i,j)
        ENDIF
#endif
       ENDDO
      ENDDO

#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE iceHeight (:,:,bi,bj) = comlev1_bibj,key=tkey,kind=isbyte
CADJ STORE snowHeight(:,:,bi,bj) = comlev1_bibj,key=tkey,kind=isbyte
CADJ STORE iceMask   (:,:,bi,bj) = comlev1_bibj,key=tkey,kind=isbyte
CADJ STORE icFrwAtm  (:,:,bi,bj) = comlev1_bibj,key=tkey,kind=isbyte
CADJ STORE tFrzOce               = comlev1_bibj,key=tkey,kind=isbyte
CADJ STORE frzMltMxl             = comlev1_bibj,key=tkey,kind=isbyte
CADJ STORE iceFrac               = comlev1_bibj,key=tkey,kind=isbyte
#endif
      CALL THSICE_CALC_THICKN(
     I          bi, bj,
     I          iMin,iMax, jMin,jMax, dBugFlag,
     I          iceMask(siLo,sjLo,bi,bj), tFrzOce,
     I          tOceMxL(siLo,sjLo,bi,bj), v2ocMxL(siLo,sjLo,bi,bj),
     I          snowPrc(siLo,sjLo), prcAtm,
     I          sHeating(siLo,sjLo,bi,bj), flxCndBt(siLo,sjLo,bi,bj),
     U          iceFrac, iceHeight(siLo,sjLo,bi,bj),
     U          snowHeight(siLo,sjLo,bi,bj), Tsrf(siLo,sjLo,bi,bj),
     U          Qice1(siLo,sjLo,bi,bj), Qice2(siLo,sjLo,bi,bj),
     U          icFrwAtm(siLo,sjLo,bi,bj), frzmltMxL, flx2oc,
     O          frw2oc, fsalt, frzSeaWat,
     I          myTime, myIter, myThid )
#ifdef ALLOW_AUTODIFF_TAMC
C     these stores avoid recomputing s/r thsice_calc_thickn
CADJ STORE icFrwAtm(:,:,bi,bj)
CADJ &               = comlev1_bibj, key = tkey, kind = isbyte
CADJ STORE frzSeaWat = comlev1_bibj, key = tkey, kind = isbyte
CADJ STORE fsalt     = comlev1_bibj, key = tkey, kind = isbyte
CADJ STORE flx2oc    = comlev1_bibj, key = tkey, kind = isbyte
CADJ STORE frw2oc    = comlev1_bibj, key = tkey, kind = isbyte
CADJ STORE frzmltMxL = comlev1_bibj, key = tkey, kind = isbyte
#endif

C--   Net fluxes :
      DO j = jMin, jMax
       DO i = iMin, iMax
        IF (iceMask(i,j,bi,bj).GT.0. _d 0) THEN
C-     weighted average net fluxes:
          icFrac = iceMask(i,j,bi,bj)
          opFrac= 1. _d 0-icFrac
#ifdef ALLOW_ATM2D
          pass_qnet(i,j) = pass_qnet(i,j) - icFrac*flx2oc(i,j)
          pass_evap(i,j) = pass_evap(i,j) - icFrac*frw2oc(i,j)/rhofw
          sFluxFromIce(i,j) = -icFrac*fsalt(i,j)
#else
          icFlxAtm(i,j,bi,bj) = icFrac*icFlxAtm(i,j,bi,bj)
     &                        - opFrac*Qnet(i,j,bi,bj)
          icFrwAtm(i,j,bi,bj) = icFrac*icFrwAtm(i,j,bi,bj)
     &                        + opFrac*EmPmR(i,j,bi,bj)
          Qnet(i,j,bi,bj) = -icFrac*flx2oc(i,j) + opFrac*Qnet(i,j,bi,bj)
          EmPmR(i,j,bi,bj)= -icFrac*frw2oc(i,j)
     &                    +  opFrac*EmPmR(i,j,bi,bj)
          saltFlux(i,j,bi,bj) = -icFrac*fsalt(i,j)
#endif
#if defined(ALLOW_SALT_PLUME) || defined(ALLOW_ATM_COMPON_INTERF)
C-    All seawater freezing (no reduction by surf. melting) from CALC_THICKN
c         frzSeaWat(i,j) = icFrac*frzSeaWat(i,j)
C-    Net seawater freezing (underestimated if there is surf. melting or rain)
          frzSeaWat(i,j) = MAX( -icFrac*frw2oc(i,j), 0. _d 0 )
#endif

#ifdef ALLOW_DBUG_THSICE
          IF (dBug(i,j,bi,bj)) WRITE(6,1010)
     &          'ThSI_FWD:-3- iceFrac, hIc, hSn, Qnet =',
     &           iceFrac(i,j), iceHeight(i,j,bi,bj),
     &           snowHeight(i,j,bi,bj), Qnet(i,j,bi,bj)
#endif

        ELSEIF (hOceMxL(i,j,bi,bj).GT.0. _d 0) THEN
          icFlxAtm(i,j,bi,bj) = -Qnet(i,j,bi,bj)
          icFrwAtm(i,j,bi,bj) = EmPmR(i,j,bi,bj)
        ELSE
          icFlxAtm(i,j,bi,bj) = 0. _d 0
          icFrwAtm(i,j,bi,bj) = 0. _d 0
        ENDIF
       ENDDO
      ENDDO

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C    part.3 : freezing of sea-water
C     over ice-free fraction and what is left from ice-covered fraction
C-------
      DO j = 1-OLy, sNy+OLy
       DO i = 1-OLx, sNx+OLx
         flx2oc(i,j) = 0. _d 0
         frw2oc(i,j) = 0. _d 0
         fsalt (i,j) = 0. _d 0
       ENDDO
      ENDDO
      CALL THSICE_EXTEND(
     I          bi, bj,
     I          iMin,iMax, jMin,jMax, dBugFlag,
     I          frzmltMxL, tFrzOce,
     I          tOceMxL(siLo,sjLo,bi,bj),
     U          iceFrac, iceHeight(siLo,sjLo,bi,bj),
     U          snowHeight(siLo,sjLo,bi,bj), Tsrf(siLo,sjLo,bi,bj),
     U          Tice1(siLo,sjLo,bi,bj), Tice2(siLo,sjLo,bi,bj),
     U          Qice1(siLo,sjLo,bi,bj), Qice2(siLo,sjLo,bi,bj),
     O          flx2oc, frw2oc, fsalt,
     I          myTime, myIter, myThid )

#ifdef ALLOW_AUTODIFF_TAMC
C     these stores avoid recomputing s/r thsice_extend
CADJ STORE snowHeight(:,:,bi,bj) = comlev1_bibj,key=tkey,kind=isbyte
CADJ STORE iceHeight (:,:,bi,bj) = comlev1_bibj,key=tkey,kind=isbyte
CADJ STORE iceMask   (:,:,bi,bj) = comlev1_bibj,key=tkey,kind=isbyte
CADJ STORE iceFrac               = comlev1_bibj,key=tkey,kind=isbyte
#endif
      DO j = jMin, jMax
       DO i = iMin, iMax
C--    Net fluxes : (only non-zero contribution where frzmltMxL > 0 )
#ifdef ALLOW_ATM2D
          pass_qnet(i,j) = pass_qnet(i,j) - flx2oc(i,j)
          pass_evap(i,j) = pass_evap(i,j) - frw2oc(i,j)/rhofw
          sFluxFromIce(i,j)= sFluxFromIce(i,j) - fsalt(i,j)
#else
          Qnet(i,j,bi,bj) = Qnet(i,j,bi,bj) - flx2oc(i,j)
          EmPmR(i,j,bi,bj)= EmPmR(i,j,bi,bj)- frw2oc(i,j)
          saltFlux(i,j,bi,bj)=saltFlux(i,j,bi,bj) - fsalt(i,j)
#endif
#if defined(ALLOW_SALT_PLUME) || defined(ALLOW_ATM_COMPON_INTERF)
          frzSeaWat(i,j) = frzSeaWat(i,j) + MAX(-frw2oc(i,j), 0. _d 0 )
#endif

#ifdef ALLOW_DBUG_THSICE
        IF (dBug(i,j,bi,bj)) WRITE(6,1010)
     &         'ThSI_FWD:-4- iceFrac, hIc, hSn, Qnet =',
     &           iceFrac(i,j), iceHeight(i,j,bi,bj),
     &           snowHeight(i,j,bi,bj), Qnet(i,j,bi,bj)
#endif

#ifdef ALLOW_BULK_FORCE
        IF ( hOceMxL(i,j,bi,bj).GT.0. _d 0 )
     &    isIceFree(i,j) = iceMask(i,j,bi,bj).LE.0. _d 0
     &                  .AND.   iceFrac(i,j) .LE.0. _d 0
#endif
        IF ( iceFrac(i,j) .GT. 0. _d 0 ) THEN
          iceMask(i,j,bi,bj)=iceFrac(i,j)
          IF ( snowHeight(i,j,bi,bj).EQ.0. _d 0 )
     &     snowAge(i,j,bi,bj) = 0. _d 0
        ELSE
          iceMask(i,j,bi,bj)  = 0. _d 0
          iceHeight(i,j,bi,bj)= 0. _d 0
          snowHeight(i,j,bi,bj)=0. _d 0
          snowAge(i,j,bi,bj)  = 0. _d 0
          Tsrf(i,j,bi,bj)     = tOceMxL(i,j,bi,bj)
          Tice1(i,j,bi,bj)    = 0. _d 0
          Tice2(i,j,bi,bj)    = 0. _d 0
          Qice1(i,j,bi,bj)    = Lfresh
          Qice2(i,j,bi,bj)    = Lfresh
        ENDIF
       ENDDO
      ENDDO

#if defined(ALLOW_SALT_PLUME) || defined(ALLOW_ATM_COMPON_INTERF)
      IF ( useSALT_PLUME .OR. useCoupler ) THEN
        CALL THSICE_SALT_PLUME(
     I          sOceMxL(1-OLx,1-OLy,bi,bj),
     I          frzSeaWat,
     I          iMin,iMax, jMin,jMax, bi, bj,
     I          myTime, myIter, myThid )
      ENDIF
#endif /* ALLOW_SALT_PLUME or ALLOW_ATM_COMPON_INTERF */

      IF ( thSIceAdvScheme.LE.0 ) THEN
C- note: 1) regarding sIceLoad in ocean-dynamics, in case thSIceAdvScheme > 0,
C          compute sIceLoad in THSICE_DO_ADVECT after seaice advection is done.
C        2) regarding sIceLoad in seaice-dynamics, probably better not to update
C          sIceLoad here, to keep the balance between sIceLoad and adjusted Eta.
C        3) not sure in the case of no advection (thSIceAdvScheme=0) but using
C          seaice dynamics (unlikely senario anyway).
C--   Compute Sea-Ice Loading (= mass of sea-ice + snow / area unit)
       DO j = jMin, jMax
        DO i = iMin, iMax
          sIceLoad(i,j,bi,bj) = ( snowHeight(i,j,bi,bj)*rhos
     &                           + iceHeight(i,j,bi,bj)*rhoi
     &                          )*iceMask(i,j,bi,bj)
#ifdef ALLOW_ATM2D
          pass_sIceLoad(i,j)=sIceLoad(i,j,bi,bj)
#endif
        ENDDO
       ENDDO
      ENDIF

#ifdef ALLOW_BULK_FORCE
      IF ( useBulkForce ) THEN
        CALL BULKF_FLUX_ADJUST(
     I                          bi, bj, iMin, iMax, jMin, jMax,
     I                          isIceFree, myTime, myIter, myThid )
      ENDIF
#endif /* ALLOW_BULK_FORCE */

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
#endif /* ALLOW_THSICE */

      RETURN
      END

#include "DIAG_OPTIONS.h"

CBOP
C     !ROUTINE: DIAGNOSTICS_FILL
C     !INTERFACE:
      SUBROUTINE DIAGNOSTICS_FILL(
     I               inpFld, chardiag,
     I               kLev, nLevs, bibjFlg, biArg, bjArg, myThid )

C     !DESCRIPTION:
C***********************************************************************
C   Wrapper routine to increment the diagnostics arrays with a RL field
C***********************************************************************
C     !USES:
      IMPLICIT NONE

C     == Global variables ===
#include "EEPARAMS.h"
#include "SIZE.h"
#include "DIAGNOSTICS_SIZE.h"
#include "DIAGNOSTICS.h"

C     !INPUT PARAMETERS:
C***********************************************************************
C  Arguments Description
C  ----------------------
C     inpFld    :: Field to increment diagnostics array
C     chardiag  :: Character expression for diag to fill
C     kLev      :: Integer flag for vertical levels:
C                  > 0 (any integer): WHICH single level to increment in qdiag.
C                  0,-1 to increment "nLevs" levels in qdiag,
C                  0 : fill-in in the same order as the input array
C                  -1: fill-in in reverse order.
C     nLevs     :: indicates Number of levels of the input field array
C                  (whether to fill-in all the levels (kLev<1) or just one (kLev>0))
C     bibjFlg   :: Integer flag to indicate instructions for bi bj loop
C                  0 indicates that the bi-bj loop must be done here
C                  1 indicates that the bi-bj loop is done OUTSIDE
C                  2 indicates that the bi-bj loop is done OUTSIDE
C                     AND that we have been sent a local array (with overlap regions)
C                     (local array here means that it has no bi-bj dimensions)
C                  3 indicates that the bi-bj loop is done OUTSIDE
C                     AND that we have been sent a local array
C                     AND that the array has no overlap region (interior only)
C                  NOTE - bibjFlg can be NEGATIVE to indicate not to increment counter
C     biArg     :: X-direction tile number - used for bibjFlg=1-3
C     bjArg     :: Y-direction tile number - used for bibjFlg=1-3
C     myThid    ::  my thread Id number
C***********************************************************************
C                  NOTE: User beware! If a local (1 tile only) array
C                        is sent here, bibjFlg MUST NOT be set to 0
C                        or there will be out of bounds problems!
C***********************************************************************
      _RL     inpFld(*)
      CHARACTER*8 chardiag
      INTEGER kLev, nLevs, bibjFlg, biArg, bjArg
      INTEGER myThid
CEOP

C     !LOCAL VARIABLES:
C     ndId      :: diagnostic Id number (in available diagnostics list)
      INTEGER m, n, j, k, l, bi, bj
      INTEGER ndId, ipt, iSp
      INTEGER region2fill(0:nRegions)
      INTEGER arrType, wFac
      _RL     scaleFact
      _RL     dummyRL(1)
      _RS     dummyRS(1)
C ===============

C--   Check if this S/R is called from the right place ;
C     needs to be after DIAGNOSTICS_SWITCH_ONOFF and before DIAGNOSTICS_WRITE
      IF ( diag_pkgStatus.NE.ready2fillDiags ) THEN
        CALL DIAGNOSTICS_STATUS_ERROR( 'DIAGNOSTICS_FILL',
     &                   ' ', chardiag, ready2fillDiags, myThid )
      ENDIF

      arrType = 0
      scaleFact = 1. _d 0
      IF ( bibjFlg.EQ.0 ) THEN
        bi = myBxLo(myThid)
        bj = myByLo(myThid)
      ELSE
        bi = biArg
        bj = bjArg
      ENDIF
C--   2D/3D Diagnostics :
C Run through list of active diagnostics to make sure
C we are trying to fill a valid diagnostic
      DO n=1,nlists
       DO m=1,nActive(n)
        IF ( chardiag.EQ.flds(m,n) .AND. idiag(m,n).GT.0 ) THEN
         ipt = idiag(m,n)
         IF ( ndiag(ipt,bi,bj).GE.0 ) THEN
           ndId = ABS(jdiag(m,n))
           wFac = MIN( jdiag(m,n), 0 )
           ipt = ipt + pdiag(n,bi,bj)*kdiag(ndId)
C-    diagnostic is valid & active, do the filling:
           CALL DIAGNOSTICS_FILL_FIELD(
     I              inpFld, dummyRL, dummyRS, dummyRS,
     I              scaleFact, 1, arrType, wFac,
     I              ndId, ipt, kLev, nLevs,
     I              bibjFlg, biArg, bjArg, myThid )
         ENDIF
        ENDIF
       ENDDO
      ENDDO

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C--   Global/Regional Statistics :

C Run through list of active statistics-diagnostics to make sure
C we are trying to compute & fill a valid diagnostic

      DO n=1,diagSt_nbLists
       DO m=1,diagSt_nbActv(n)
        IF ( chardiag.EQ.diagSt_Flds(m,n) .AND. iSdiag(m,n).GT.0 ) THEN
         iSp = iSdiag(m,n)
         IF ( qSdiag(0,0,iSp,bi,bj).GE.0. ) THEN
           ndId = jSdiag(m,n)
C-    Find list of regions to fill:
           DO j=0,nRegions
            region2fill(j) = diagSt_region(j,n)
           ENDDO
C-    if this diagnostics appears in several lists (with same freq)
C     then add regions from other lists
           DO l=1,diagSt_nbLists
            DO k=1,diagSt_nbActv(l)
             IF ( iSdiag(k,l).EQ.-iSp ) THEN
              DO j=0,nRegions
               region2fill(j) = MAX(region2fill(j),diagSt_region(j,l))
              ENDDO
             ENDIF
            ENDDO
           ENDDO
C-    diagnostics is valid and Active: Now do the filling
           CALL DIAGSTATS_FILL(
     I              inpFld, dummyRL,
#ifndef REAL4_IS_SLOW
     I              dummyRS, dummyRS,
#endif
     I              scaleFact, 1, arrType, 0,
     I              ndId, iSp, region2fill, kLev, nLevs,
     I              bibjFlg, biArg, bjArg, myThid )
         ENDIF
        ENDIF
       ENDDO
      ENDDO

      RETURN
      END

#include "CAL_OPTIONS.h"

      subroutine cal_MonthsForYear(
     I                              iyear,
     O                              firstmonth,
     O                              lastmonth,
     O                              nmonths,
     I                              mythid
     &                            )

c     ==================================================================
c     SUBROUTINE cal_MonthsForYear
c     ==================================================================
c
c     o Given the current year of integration this routine returns
c       the number of months affected by the integration as well as the
c       first month and the last month in the sequence of the total
c       number of months that are to be integrated.
c
c       This routine also checks consistency of variables quite
c       extensively.
c
c     started: Christian Eckert eckert@mit.edu  06-Apr-2000
c
c     changed: 
c
c     ==================================================================
c     SUBROUTINE cal_MonthsForYear
c     ==================================================================

      implicit none

c     == global variables ==

#include "cal.h"

c     == routine arguments ==

      integer iyear
      integer firstmonth
      integer lastmonth
      integer nmonths
      integer mythid

c     == local variables ==

      integer ierr
      integer numyears
      integer firstyear
      integer firstmon
      integer lastyear
      integer lastmon
      integer lastday
      integer lastsecs

c     == external ==

      integer  cal_IntYears
      external cal_IntYears

c     == end of interface ==

      numyears = cal_IntYears( mythid )

      firstyear = modelstartdate(1)/10000
      firstmon  = mod(modelstartdate(1)/100,100)
      lastyear  = modelenddate(1)/10000
      lastmon   = mod(modelenddate(1)/100,100)
      lastday   = mod(modelenddate(1),100)
      lastsecs  = modelenddate(2)/10000*secondsperhour +
     &            mod(modelenddate(2)/100,100)*secondsperminute +
     &            mod(modelenddate(2),100)

      if ( numyears .eq. 1 ) then
c--     Only one calendar year affected by the integration.
        if ( iyear .eq. 1 ) then
          if ( firstyear .eq. lastyear ) then
            if ( (lastday .eq. 1) .and. (lastsecs .eq. 0) ) then
c--           Not really next month yet.
              lastmonth  = lastmon - firstmon
            else
c--           The most frequent case.
              lastmonth  = lastmon - firstmon + 1
            endif
            firstmonth = 1
          else if ( firstyear+1 .eq. lastyear ) then
c--         This is only the case if we end at midnight of 01-Jan
c--         of the next year.
            if ( ( modelenddate(2) .eq. 0) .and.
     &         ( mod(modelenddate(1),100) .eq. 1 ) .and.
     &           mod(modelenddate(1)/100,100) .eq. 1 ) then
              firstmonth = 1
              lastmonth  = nmonthyear - firstmon + 1
            else
c--           Inconsistent modelenddate; check cal_IntYears.
              ierr = 2804
              call cal_PrintError( ierr, mythid )
              stop ' stopped in cal_MonthsForYear.'
            endif
          else
c--         The specification of lastyear is wrong.
            ierr = 2803
            call cal_PrintError( ierr, mythid )
            stop ' stopped in cal_MonthsForYear.'
          endif
        else
c--       The variables numyears and iyear are inconsistent;
c--       ( iyear .gt. numyears ).
          ierr = 2802
          call cal_PrintError( ierr, mythid )
          stop ' stopped in cal_MonthsForYear.'
        endif

      else if ( numyears .gt. 1 ) then
c--     More than one year of integration.
        if ( iyear .eq. 1 ) then
          firstmonth = 1
          lastmonth  = nmonthyear - firstmon + 1
        else if ( ( iyear .gt. 1 )        .and.
     &            ( iyear .lt. numyears )       ) then
c--       Somewhere between first and last year.
          firstmonth = (nmonthyear - firstmon + 1) +
     &                 (iyear - 2)*nmonthyear + 1
          lastmonth  = (nmonthyear - firstmon + 1) +
     &                 (iyear - 2)*nmonthyear + nmonthyear
        else if ( iyear .eq. numyears ) then
c--       The last year of the integration.
          if ( lastyear .eq. (firstyear + numyears - 1) ) then
            if ( (lastday .eq. 1) .and. (lastsecs .eq. 0) ) then
c--           Not really next month yet.
              lastmonth  = (nmonthyear - firstmon + 1) +
     &                     (numyears - 2)*nmonthyear + lastmon - 1
            else
c--           The most frequent case.
              lastmonth  = (nmonthyear - firstmon + 1) +
     &                     (numyears - 2)*nmonthyear + lastmon
            endif
            firstmonth = (nmonthyear - firstmon + 1) +
     &                   (numyears - 2)*nmonthyear + 1
          else if ( lastyear .eq. (firstyear + numyears) ) then
c--         This is only the case if we end at midnight of 01-Jan.
            if ( ( modelenddate(2) .eq. 0) .and.
     &         ( mod(modelenddate(1),100) .eq. 1 ) .and.
     &           mod(modelenddate(1)/100,100) .eq. 1 ) then
              firstmonth = (nmonthyear - firstmon) +
     &                     (numyears - 2)*nmonthyear + 1
              lastmonth  = (nmonthyear - firstmon) +
     &                     (numyears - 2)*nmonthyear + nmonthyear
            else
c--           Inconsistent modelenddate; check cal_IntYears.
              ierr = 2807
              call cal_PrintError( ierr, mythid )
              stop ' stopped in cal_MonthsForYear.'
            endif
          else
c--         The variables lastyear and numyears are inconsistent.
            ierr = 2806
            call cal_PrintError( ierr, mythid )
            stop ' stopped in cal_MonthsForYear.'
          endif
        else
c--       The variables iyear and numyears are inconsistent.
          ierr = 2805
          call cal_PrintError( ierr, mythid )
          stop ' stopped in cal_MonthsForYear.'
        endif

      else
c--     The number of years to integrate is wrong; check cal_IntYears.
        ierr = 2801
        call cal_PrintError( ierr, mythid )
        stop ' stopped in cal_MonthsForYear.'
      endif

c--   The number of months to integrate in the given year.
      nmonths = lastmonth - firstmonth + 1

      return
      end

#include "FIZHI_OPTIONS.h"
      subroutine lwrio (nymd,nhms,bi,bj,myid,istrip,npcs,
     .                  low_level,mid_level,
     .                  im,jm,lm,
     .                  pz,plz,plze,dpres,pkht,pkz,tz,qz,oz,
     .                  co2,cfc11,cfc12,cfc22,methane,n2o,emissivity,
     .                  tgz,radlwg,st4,dst4,
     .                  dtradlw,dlwdtg,dtradlwc,lwgclr,
     .                  nlwcld,cldlw,clwmo,nlwlz,lwlz,
     .                  lpnt,imstturb,qliqave,fccave,landtype)

      implicit none

c Input Variables
c ---------------
      integer nymd,nhms,istrip,npcs,bi,bj,myid
      integer mid_level,low_level
      integer im,jm,lm        
      _RL pz(im,jm),plz(im,jm,lm),plze(im,jm,lm+1)
      _RL dpres(im,jm,lm),pkht(im,jm,lm+1),pkz(im,jm,lm)
      _RL tz(im,jm,lm),qz(im,jm,lm),oz(im,jm,lm)
      _RL co2,cfc11,cfc12,cfc22,methane(lm),n2o(lm)    
      _RL emissivity(im,jm,10)
      _RL tgz(im,jm),radlwg(im,jm),st4(im,jm),dst4(im,jm)     
      _RL dtradlw(im,jm,lm),dlwdtg (im,jm,lm) 
      _RL dtradlwc(im,jm,lm),lwgclr(im,jm)     
      integer nlwcld,nlwlz
      _RL cldlw(im,jm,lm),clwmo(im,jm,lm),lwlz(im,jm,lm)
      logical lpnt
      integer imstturb
      _RL qliqave(im,jm,lm),fccave(im,jm,lm)
      integer landtype(im,jm)

c Local Variables
c ---------------
      integer i,j,l,n,nn

      _RL cldtot (im,jm,lm)
      _RL cldmxo (im,jm,lm)

      _RL pl(istrip,lm)
      _RL pk(istrip,lm)
      _RL pke(istrip,lm)
      _RL ple(istrip,lm+1)

      _RL ADELPL(ISTRIP,lm)
      _RL dtrad(istrip,lm),dtradc(istrip,lm)
      _RL OZL(ISTRIP,lm),TZL(ISTRIP,lm)
      _RL SHZL(ISTRIP,lm),CLRO(ISTRIP,lm)
      _RL CLMO(ISTRIP,lm)
      _RL flx(ISTRIP,lm+1),flxclr(ISTRIP,lm+1)
      _RL cldlz(istrip,lm)
      _RL dfdts(istrip,lm+1),dtdtg(istrip,lm)

      _RL emiss(istrip,10)
      _RL taual(istrip,lm,10)
      _RL ssaal(istrip,lm,10)
      _RL asyal(istrip,lm,10)
      _RL cwc(istrip,lm,3)
      _RL reff(istrip,lm,3)
      _RL tauc(istrip,lm,3)

      _RL SGMT4(ISTRIP),TSURF(ISTRIP),dsgmt4(ISTRIP)
      integer lwi(istrip)

      _RL tmpstrip(istrip,lm)
      _RL tmpimjm(im,jm,lm)
      _RL tempor1(im,jm),tempor2(im,jm)

      _RL getcon,secday,convrt
#ifdef ALLOW_DIAGNOSTICS
      logical  diagnostics_is_on
      external diagnostics_is_on
      _RL tmpdiag(im,jm)
#endif

      logical high,  trace, cldwater
c     data high /.true./
c     data trace /.true./
      data high /.false./
      data trace /.false./
      data cldwater /.false./

C **********************************************************************
C ****                     INITIALIZATION                           ****
C **********************************************************************
 
      SECDAY = GETCON('SDAY')
      CONVRT = GETCON('GRAVITY') / ( 100.0 * GETCON('CP') )

c Adjust cloud fractions and cloud liquid water due to moist turbulence
c ---------------------------------------------------------------------
      if(imstturb.ne.0) then
        do L =1,lm
        do j =1,jm
        do i =1,im
           cldtot(i,j,L)=min(1.0 _d 0,max(cldlw(i,j,L),fccave(i,j,L)/
     $          imstturb))
           cldmxo(i,j,L) =  min( 1.0 _d 0,      clwmo(i,j,L) )
           lwlz(i,j,L) =  lwlz(i,j,L) + qliqave(i,j,L)/imstturb
        enddo
        enddo
        enddo
      else
        do L =1,lm
        do j =1,jm
        do i =1,im
         cldtot(i,j,L) =  min( 1.0 _d 0,cldlw(i,j,L) )
         cldmxo(i,j,L) =  min( 1.0 _d 0,clwmo(i,j,L) )
        enddo
        enddo
        enddo
      endif

C***********************************************************************
C ****                     LOOP OVER STRIPS                         ****
C **********************************************************************

      DO 1000 NN=1,NPCS

C **********************************************************************
C ****                   VARIABLE INITIALIZATION                    ****
C **********************************************************************

       CALL STRIP (OZ,OZL      ,im*jm,ISTRIP,lm   ,NN)
       CALL STRIP (PLZE,ple    ,im*jm,ISTRIP,lm+1 ,NN)
       CALL STRIP (PLZ ,pl     ,im*jm,ISTRIP,lm   ,NN)
       CALL STRIP (PKZ ,pk     ,im*jm,ISTRIP,lm   ,NN)
       CALL STRIP (PKHT,pke    ,im*jm,ISTRIP,lm   ,NN)
       CALL STRIP (TZ,TZL      ,im*jm,ISTRIP,lm   ,NN)
       CALL STRIP (qz,SHZL     ,im*jm,ISTRIP,lm   ,NN)
       CALL STRIP (cldtot,CLRO ,im*jm,ISTRIP,lm   ,NN)
       CALL STRIP (cldmxo,CLMO ,im*jm,ISTRIP,lm   ,NN)
       CALL STRIP (lwlz,cldlz  ,im*jm,ISTRIP,lm   ,NN)
       CALL STRIP (tgz,tsurf   ,im*jm,ISTRIP,1    ,NN)

       CALL STRIP (emissivity,emiss,im*jm,ISTRIP,10,NN)

       call stripitint (landtype,lwi,im*jm,im*jm,istrip,1,nn)

       DO L = 1,lm
       DO I = 1,ISTRIP
        ADELPL(I,L) = convrt / ( ple(I,L+1)-ple(I,L) )
       ENDDO
       ENDDO
 
C Compute Clouds
C --------------
       IF(NLWCLD.NE.0)THEN
       DO L = 1,lm
       DO I = 1,ISTRIP
        CLRO(I,L) = min( 1.0 _d 0,clro(i,L) )
        CLMO(I,L) = min( 1.0 _d 0,clmo(i,L) )
       ENDDO
       ENDDO
       ENDIF
 
C Convert to Temperature from Fizhi Theta
C ---------------------------------------
      DO L = 1,lm
      DO I = 1,ISTRIP
      TZL(I,L) = TZL(I,L)*pk(I,L)
      ENDDO
      ENDDO
      DO I = 1,ISTRIP
C To reduce longwave heating in lowest model layer
      TZL(I,lm) = ( 2*tzl(i,lm)+tsurf(i) )/3.0  
      ENDDO

C Compute Optical Thicknesses
C ---------------------------
      call opthk ( tzl,pl,ple,cldlz,clro,clmo,lwi,istrip,1,lm,tauc )
 
      do n = 1,3
      do L = 1,lm
      do i = 1,istrip
      tauc(i,L,n) = tauc(i,L,n)*0.75
      enddo
      enddo
      enddo

C Set the optical thickness, single scattering albedo and assymetry factor
C     for aerosols equal to zero to omit the contribution of aerosols
c-------------------------------------------------------------------------
      do n = 1,10
      do L = 1,lm
      do i = 1,istrip
      taual(i,L,n) = 0.
      ssaal(i,L,n) = 0.
      asyal(i,L,n) = 0.
      enddo
      enddo
      enddo

C Set cwc and reff to zero - when cldwater is .false.
c----------------------------------------------------
      do n = 1,3
      do L = 1,lm
      do i = 1,istrip
       cwc(i,L,n) = 0.
      reff(i,L,n) = 0.
      enddo
      enddo
      enddo

C **********************************************************************
C ****                CALL M-D Chou RADIATION                       ****
C **********************************************************************
 
      call irrad ( istrip,1,1,lm,ple,tzl,shzl,ozl,tsurf,co2,
     .             n2o,methane,cfc11,cfc12,cfc22,emiss,
     .             cldwater,cwc,tauc,reff,clro,mid_level,low_level,
     .             taual,ssaal,asyal,
     .             high,trace,flx,flxclr,dfdts,sgmt4 )
 
C **********************************************************************
C ****                   HEATING RATES                              ****
C **********************************************************************

       do L = 1,lm
       do i = 1,istrip
         dtrad(i,L) = (   flx(i,L)-   flx(i,L+1))*adelpl(i,L)
         tmpstrip(i,L) = flx(i,L)
         dtdtg(i,L) = ( dfdts(i,L)- dfdts(i,L+1))*adelpl(i,L)
        dtradc(i,L) = (flxclr(i,L)-flxclr(i,L+1))*adelpl(i,L)
       enddo
       enddo

C **********************************************************************
C ****              NET UPWARD LONGWAVE FLUX  (W/M**2)              ****
C **********************************************************************

       DO I = 1,ISTRIP
        flx   (i,1)    = -flx   (i,1)
        flxclr(i,1)    = -flxclr(i,1)
        flx   (i,lm+1) = -flx   (i,lm+1)
        flxclr(i,lm+1) = -flxclr(i,lm+1)
              sgmt4(i) = - sgmt4(i)
             dsgmt4(i) = - dfdts(i,lm+1)
       ENDDO

       CALL PASTE ( flx   (1,lm+1),RADLWG,ISTRIP,im*jm,1,NN )
       CALL PASTE ( flxclr(1,lm+1),LWGCLR,ISTRIP,im*jm,1,NN )

       CALL PASTE (  sgmt4, st4,ISTRIP,im*jm,1,NN )
       CALL PASTE ( dsgmt4,dst4,ISTRIP,im*jm,1,NN )

C **********************************************************************
C ****            PASTE AND BUMP SOME DIAGNOSTICS                   ****
C **********************************************************************

      CALL PASTE(flx(1,1),tempor1,ISTRIP,im*jm,1,NN)
      CALL PASTE(flxclr(1,1),tempor2,ISTRIP,im*jm,1,NN)

C **********************************************************************
C ****                 TENDENCY UPDATES                             ****
C **********************************************************************

      DO L = 1,lm
      DO I = 1,ISTRIP
      DTRAD (I,L) = ple(i,lm+1) * DTRAD (I,L)/pk(I,L)
      DTRADC(I,L) = ple(i,lm+1) * DTRADC(I,L)/pk(I,L)
       dtdtg(I,L) = ple(i,lm+1) * dtdtg (I,L)/pk(I,L)
      ENDDO
      ENDDO
      CALL PASTE ( tmpstrip ,tmpimjm ,ISTRIP,im*jm,lm,NN )
      CALL PASTE ( DTRAD ,DTRADLW ,ISTRIP,im*jm,lm,NN )
      CALL PASTE ( DTRADC,DTRADLWC,ISTRIP,im*jm,lm,NN )
      CALL PASTE ( dtdtg ,dlwdtg  ,ISTRIP,im*jm,lm,NN )

 1000 CONTINUE

C **********************************************************************
C ****                     BUMP DIAGNOSTICS                         ****
C **********************************************************************

#ifdef ALLOW_DIAGNOSTICS
      if(diagnostics_is_on('TGRLW   ',myid) ) then
       call diagnostics_fill(tgz,'TGRLW   ',0,1,3,bi,bj,myid)
      endif

      do L = 1,lm

       if(diagnostics_is_on('TLW     ',myid) ) then
        do j = 1,jm
        do i = 1,im
         tmpdiag(i,j) = tz(i,j,L)*pkz(i,j,L)
        enddo
        enddo
        call diagnostics_fill(tmpdiag,'TLW     ',L,1,3,bi,bj,myid)
       endif

       if(diagnostics_is_on('SHRAD   ',myid) ) then
        do j = 1,jm
        do i = 1,im
         tmpdiag(i,j) = qz(i,j,L)*1000.
        enddo
        enddo
        call diagnostics_fill(tmpdiag,'SHRAD   ',L,1,3,bi,bj,myid)
       endif

       if(diagnostics_is_on('OZLW    ',myid) ) then
        do j = 1,jm
        do i = 1,im
         tmpdiag(i,j) = oz(i,j,L)
        enddo
        enddo
        call diagnostics_fill(tmpdiag,'OZLW    ',L,1,3,bi,bj,myid)
       endif

      enddo

      if(diagnostics_is_on('OLR     ',myid) ) then
       call diagnostics_fill(tempor1,'OLR     ',0,1,3,bi,bj,myid)
      endif

      if(diagnostics_is_on('OLRCLR  ',myid) ) then
       call diagnostics_fill(tempor2,'OLRCLR  ',0,1,3,bi,bj,myid)
      endif
#endif

C **********************************************************************
C ****    Increment Diagnostics Counters and Zero-Out Cloud Info    ****
C **********************************************************************

      nlwlz    = 0
      nlwcld   = 0
      imstturb = 0

      do L = 1,lm
      do j = 1,jm
      do i = 1,im
         fccave(i,j,L) = 0.
        qliqave(i,j,L) = 0.
      enddo
      enddo
      enddo

      return
      end
c**********************   November 26, 1997   **************************

      subroutine irrad (m,n,ndim,np,pl,ta,wa,oa,ts,co2,
     *                  n2o,ch4,cfc11,cfc12,cfc22,emiss,
     *                  cldwater,cwc,taucl,reff,fcld,ict,icb,
     *                  taual,ssaal,asyal,
     *                  high,trace,flx,flc,dfdts,st4)

c***********************************************************************
c
c                        Version IR-5 (September, 1998)
c
c  New features of this version are:
c   (1) The effect of aerosol scattering on LW fluxes is included.
c   (2) Absorption and scattering of rain drops are included.
c
c***********************************************************************
c
c                        Version IR-4 (October, 1997)
c
c  New features of this version are:
c   (1) The surface is treated as non-black.  The surface
c         emissivity, emiss, is an input parameter
c   (2) The effect of cloud scattering on LW fluxes is included
c
c*********************************************************************
c
c This routine computes ir fluxes due to water vapor, co2, o3,
c   trace gases (n2o, ch4, cfc11, cfc12, cfc22, co2-minor),
c   clouds, and aerosols.
c  
c This is a vectorized code.  It computes fluxes simultaneously for
c   (m x n) soundings, which is a subset of (m x ndim) soundings.
c   In a global climate model, m and ndim correspond to the numbers of
c   grid boxes in the zonal and meridional directions, respectively.
c
c Some detailed descriptions of the radiation routine are given in
c   Chou and Suarez (1994).
c
c Ice and liquid cloud particles are allowed to co-exist in any of the
c  np layers. 
c
c If no information is available for the effective cloud particle size,
c  reff, default values of 10 micron for liquid water and 75 micron
c  for ice can be used.
c
c The maximum-random assumption is applied for cloud overlapping.
c  clouds are grouped into high, middle, and low clouds separated by the
c  level indices ict and icb.  Within each of the three groups, clouds
c  are assumed maximally overlapped, and the cloud cover of a group is
c  the maximum cloud cover of all the layers in the group.  clouds among
c  the three groups are assumed randomly overlapped. The indices ict and
c  icb correpond approximately to the 400 mb and 700 mb levels.
c
c Aerosols are allowed to be in any of the np layers. Aerosol optical
c  properties can be specified as functions of height and spectral band.
c
c There are options for computing fluxes:
c
c   If cldwater=.true., taucl is computed from cwc and reff as a
c   function of height and spectral band. 
c   If cldwater=.false., taucl must be given as input to the radiation
c   routine. It is independent of spectral band.
c
c   If high = .true., transmission functions in the co2, o3, and the
c   three water vapor bands with strong absorption are computed using
c   table look-up.  cooling rates are computed accurately from the
c   surface up to 0.01 mb.
c   If high = .false., transmission functions are computed using the
c   k-distribution method with linear pressure scaling for all spectral
c   bands and gases.  cooling rates are not calculated accurately for
c   pressures less than 20 mb. the computation is faster with
c   high=.false. than with high=.true.

c   If trace = .true., absorption due to n2o, ch4, cfcs, and the 
c   two minor co2 bands in the window region is included.
c   If trace = .false., absorption in minor bands is neglected.
c
c The IR spectrum is divided into nine bands:
c   
c   band     wavenumber (/cm)   absorber
c
c    1           0 - 340           h2o
c    2         340 - 540           h2o
c    3         540 - 800       h2o,cont,co2,n2o
c    4         800 - 980       h2o,cont
c                              co2,f11,f12,f22
c    5         980 - 1100      h2o,cont,o3
c                              co2,f11
c    6        1100 - 1215      h2o,cont
c                              n2o,ch4,f12,f22
c    7        1215 - 1380          h2o
c                              n2o,ch4
c    8        1380 - 1900          h2o
c    9        1900 - 3000          h2o
c
c In addition, a narrow band in the 15 micrometer region is added to
c    compute flux reduction due to n2o
c
c    10        540 - 620       h2o,cont,co2,n2o
c
c Band 3 (540-800/cm) is further divided into 3 sub-bands :
c
c   subband   wavenumber (/cm)
c
c    1          540 - 620
c    2          620 - 720
c    3          720 - 800
c
c---- Input parameters                               units    size
c
c   number of soundings in zonal direction (m)        n/d      1
c   number of soundings in meridional direction (n)   n/d      1
c   maximum number of soundings in
c                 meridional direction (ndim>=n)      n/d      1 
c   number of atmospheric layers (np)                 n/d      1
c   level pressure (pl)                               mb      m*ndim*(np+1)
c   layer temperature (ta)                            k       m*ndim*np
c   layer specific humidity (wa)                      g/g     m*ndim*np
c   layer ozone mixing ratio by mass (oa)             g/g     m*ndim*np
c   surface temperature (ts)                          k       m*ndim  
c   co2 mixing ratio by volumn (co2)                  pppv     1
c   n2o mixing ratio by volumn (n2o)                  pppv     np
c   ch4 mixing ratio by volumn (ch4)                  pppv     np
c   cfc11 mixing ratio by volumn (cfc11)              pppv     1
c   cfc12 mixing ratio by volumn (cfc12)              pppv     1
c   cfc22 mixing ratio by volumn (cfc22)              pppv     1
c   surface emissivity (emiss)                      fraction   m*ndim*10
c   input option for cloud optical thickness          n/d      1
c           cldwater="true" if cwc is provided
c           cldwater="false" if taucl is provided
c   cloud water mixing ratio (cwc)                   gm/gm   m*ndim*np*3
c           index 1 for ice particles
c           index 2 for liquid drops
c           index 3 for rain drops
c   cloud optical thickness (taucl)                   n/d    m*ndim*np*3
c           index 1 for ice particles
c           index 2 for liquid drops
c           index 3 for rain drops
c   effective cloud-particle size (reff)          micrometer m*ndim*np*3
c           index 1 for ice particles
c           index 2 for liquid drops
c           index 3 for rain drops
c   cloud amount (fcld)                             fraction  m*ndim*np
c   level index separating high and middle            n/d      1
c           clouds (ict)
c   level index separating middle and low             n/d      1
c           clouds (icb)
c   aerosol optical thickness (taual)                 n/d   m*ndim*np*10
c   aerosol single-scattering albedo (ssaal)          n/d   m*ndim*np*10
c   aerosol asymmetry factor (asyal)                  n/d   m*ndim*np*10
c   high (see explanation above)                               1
c   trace (see explanation above)                              1
c
c Data used in table look-up for transmittance calculations:
c
c   c1 , c2, c3: for co2 (band 3)
c   o1 , o2, o3: for  o3 (band 5)
c   h11,h12,h13: for h2o (band 1)
c   h21,h22,h23: for h2o (band 2)
c   h81,h82,h83: for h2o (band 8)
c
c---- output parameters
c
c   net downward flux, all-sky   (flx)             w/m**2  m*ndim*(np+1)
c   net downward flux, clear-sky (flc)             w/m**2  m*ndim*(np+1)
c   sensitivity of net downward flux  
c       to surface temperature (dfdts)            w/m**2/k m*ndim*(np+1)
c   emission by the surface (st4)                 w/m**2     m*ndim 
c 
c Notes: 
c
c   (1) Water vapor continuum absorption is included in 540-1380 /cm.
c   (2) Scattering is parameterized for clouds and aerosols.
c   (3) Diffuse cloud and aerosol transmissions are computed
c       from exp(-1.66*tau).
c   (4) If there are no clouds, flx=flc.
c   (5) plevel(1) is the pressure at the top of the model atmosphere,
c        and plevel(np+1) is the surface pressure.
c   (6) Downward flux is positive and upward flux is negative.
c   (7) dfdts is negative because upward flux is defined as negative.
c   (8) For questions and coding errors, contact with Ming-Dah Chou,
c       Code 913, NASA/Goddard Space Flight Center, Greenbelt, MD 20771.
c       Phone: 301-286-4012, Fax: 301-286-1759,
c       e-mail: chou@climate.gsfc.nasa.gov
c
c-----parameters defining the size of the pre-computed tables for transmittance
c     calculations using table look-up.
c
c     "nx" is the number of intervals in pressure
c     "no" is the number of intervals in o3 amount
c     "nc" is the number of intervals in co2 amount
c     "nh" is the number of intervals in h2o amount
c     "nt" is the number of copies to be made from the pre-computed
c          transmittance tables to reduce "memory-bank conflict"
c          in parallel machines and, hence, enhancing the speed of
c          computations using table look-up. 
c          If such advantage does not exist, "nt" can be set to 1.
c***************************************************************************

cfpp$ expand (h2oexps)
cfpp$ expand (conexps)
cfpp$ expand (co2exps)
cfpp$ expand (n2oexps)
cfpp$ expand (ch4exps)
cfpp$ expand (comexps)
cfpp$ expand (cfcexps)
cfpp$ expand (b10exps)
cfpp$ expand (tablup)
cfpp$ expand (h2okdis)
cfpp$ expand (co2kdis)
cfpp$ expand (n2okdis)
cfpp$ expand (ch4kdis)
cfpp$ expand (comkdis)
cfpp$ expand (cfckdis)
cfpp$ expand (b10kdis)

      implicit none
      integer nx,no,nc,nh,nt
      integer i,j,k,ip,iw,it,ib,ik,iq,isb,k1,k2
      parameter (nx=26,no=21,nc=24,nh=31,nt=7)

c---- input parameters ------

      integer m,n,ndim,np,ict,icb
      _RL pl(m,ndim,np+1),ta(m,ndim,np),wa(m,ndim,np),oa(m,ndim,np),
     *     ts(m,ndim)
      _RL co2,n2o(np),ch4(np),cfc11,cfc12,cfc22,emiss(m,ndim,10)
      _RL cwc(m,ndim,np,3),taucl(m,ndim,np,3),reff(m,ndim,np,3),
     *     fcld(m,ndim,np)
      _RL taual(m,ndim,np,10),ssaal(m,ndim,np,10),asyal(m,ndim,np,10)
      logical cldwater,high,trace

c---- output parameters ------

      _RL flx(m,ndim,np+1),flc(m,ndim,np+1),dfdts(m,ndim,np+1),
     *     st4(m,ndim)

c---- static data -----

      _RL cb(5,10)
      _RL xkw(9),aw(9),bw(9),pm(9),fkw(6,9),gkw(6,3),xke(9)
      _RL aib(3,10),awb(4,10),aiw(4,10),aww(4,10),aig(4,10),awg(4,10)
      integer ne(9),mw(9)

c---- temporary arrays -----

      _RL pa(m,n,np),dt(m,n,np)
      _RL sh2o(m,n,np+1),swpre(m,n,np+1),swtem(m,n,np+1)
      _RL sco3(m,n,np+1),scopre(m,n,np+1),scotem(m,n,np+1)
      _RL dh2o(m,n,np),dcont(m,n,np),dco2(m,n,np),do3(m,n,np)
      _RL dn2o(m,n,np),dch4(m,n,np)
      _RL df11(m,n,np),df12(m,n,np),df22(m,n,np)
      _RL th2o(m,n,6),tcon(m,n,3),tco2(m,n,6,2)
      _RL tn2o(m,n,4),tch4(m,n,4),tcom(m,n,2)
      _RL tf11(m,n),tf12(m,n),tf22(m,n)
      _RL h2oexp(m,n,np,6),conexp(m,n,np,3),co2exp(m,n,np,6,2)
      _RL n2oexp(m,n,np,4),ch4exp(m,n,np,4),comexp(m,n,np,2)
      _RL f11exp(m,n,np),  f12exp(m,n,np),  f22exp(m,n,np)
      _RL clr(m,n,0:np+1),fclr(m,n)
      _RL blayer(m,n,0:np+1),dlayer(m,n,np+1),dbs(m,n)
      _RL clrlw(m,n),clrmd(m,n),clrhi(m,n)
      _RL cwp(m,n,np,3)
      _RL trant(m,n),tranal(m,n),transfc(m,n,np+1),trantcr(m,n,np+1)
      _RL flxu(m,n,np+1),flxd(m,n,np+1),flcu(m,n,np+1),flcd(m,n,np+1)
      _RL rflx(m,n,np+1),rflc(m,n,np+1)

      logical oznbnd,co2bnd,h2otbl,conbnd,n2obnd
      logical ch4bnd,combnd,f11bnd,f12bnd,f22bnd,b10bnd

      _RL c1 (nx,nc,nt),c2 (nx,nc,nt),c3 (nx,nc,nt)
      _RL o1 (nx,no,nt),o2 (nx,no,nt),o3 (nx,no,nt)
      _RL h11(nx,nh,nt),h12(nx,nh,nt),h13(nx,nh,nt)
      _RL h21(nx,nh,nt),h22(nx,nh,nt),h23(nx,nh,nt)
      _RL h81(nx,nh,nt),h82(nx,nh,nt),h83(nx,nh,nt)

      _RL dp,xx,p1,dwe,dpe,a1,b1,fk1,a2,b2,fk2
      _RL w1,w2,w3,g1,g2,g3,ww,gg,ff,taux,reff1,reff2

c-----the following coefficients (equivalent to table 2 of
c     chou and suarez, 1995) are for computing spectrally 
c     integrated planck fluxes using eq. (22)

       data cb/
     1      -2.6844e-1,-8.8994e-2, 1.5676e-3,-2.9349e-6, 2.2233e-9,
     2       3.7315e+1,-7.4758e-1, 4.6151e-3,-6.3260e-6, 3.5647e-9,
     3       3.7187e+1,-3.9085e-1,-6.1072e-4, 1.4534e-5,-1.6863e-8,
     4      -4.1928e+1, 1.0027e+0,-8.5789e-3, 2.9199e-5,-2.5654e-8,
     5      -4.9163e+1, 9.8457e-1,-7.0968e-3, 2.0478e-5,-1.5514e-8,
     6      -4.7107e+1, 8.9130e-1,-5.9735e-3, 1.5596e-5,-9.5911e-9,
     7      -5.4041e+1, 9.5332e-1,-5.7784e-3, 1.2555e-5,-2.9377e-9,
     8      -6.9233e+0,-1.5878e-1, 3.9160e-3,-2.4496e-5, 4.9301e-8,
     9       1.1483e+2,-2.2376e+0, 1.6394e-2,-5.3672e-5, 6.6456e-8,
     *       1.9668e+1,-3.1161e-1, 1.2886e-3, 3.6835e-7,-1.6212e-9/

c-----xkw are the absorption coefficients for the first
c     k-distribution function due to water vapor line absorption
c     (tables 4 and 7).  units are cm**2/g    

      data xkw / 29.55  , 4.167e-1, 1.328e-2, 5.250e-4,
     *           5.25e-4, 9.369e-3, 4.719e-2, 1.320e-0, 5.250e-4/

c-----xke are the absorption coefficients for the first
c     k-distribution function due to water vapor continuum absorption
c     (table 6).  units are cm**2/g

      data xke /  0.00,   0.00,   27.40,   15.8,
     *            9.40,   7.75,     0.0,    0.0,    0.0/

c-----mw are the ratios between neighboring absorption coefficients
c     for water vapor line absorption (tables 4 and 7).

      data mw /6,6,8,6,6,8,9,6,16/

c-----aw and bw (table 3) are the coefficients for temperature scaling
c     in eq. (25).

      data aw/ 0.0021, 0.0140, 0.0167, 0.0302,
     *         0.0307, 0.0195, 0.0152, 0.0008, 0.0096/
      data bw/ -1.01e-5, 5.57e-5, 8.54e-5, 2.96e-4,
     *          2.86e-4, 1.108e-4, 7.608e-5, -3.52e-6, 1.64e-5/

      data pm/ 1.0, 1.0, 1.0, 1.0, 1.0, 0.77, 0.5, 1.0, 1.0/

c-----fkw is the planck-weighted k-distribution function due to h2o
c     line absorption given in table 4 of Chou and Suarez (1995).
c     the k-distribution function for the third band, fkw(*,3), is not used

      data fkw / 0.2747,0.2717,0.2752,0.1177,0.0352,0.0255,
     2           0.1521,0.3974,0.1778,0.1826,0.0374,0.0527,
     3           6*1.00,
     4           0.4654,0.2991,0.1343,0.0646,0.0226,0.0140,
     5           0.5543,0.2723,0.1131,0.0443,0.0160,0.0000,
     6           0.5955,0.2693,0.0953,0.0335,0.0064,0.0000,
     7           0.1958,0.3469,0.3147,0.1013,0.0365,0.0048,
     8           0.0740,0.1636,0.4174,0.1783,0.1101,0.0566,
     9           0.1437,0.2197,0.3185,0.2351,0.0647,0.0183/

c-----gkw is the planck-weighted k-distribution function due to h2o
c     line absorption in the 3 subbands (800-720,620-720,540-620 /cm)
c     of band 3 given in table 7.  Note that the order of the sub-bands
c     is reversed.

      data gkw/  0.1782,0.0593,0.0215,0.0068,0.0022,0.0000,
     2           0.0923,0.1675,0.0923,0.0187,0.0178,0.0000,
     3           0.0000,0.1083,0.1581,0.0455,0.0274,0.0041/

c-----ne is the number of terms used in each band to compute water vapor
c     continuum transmittance (table 6).

      data ne /0,0,3,1,1,1,0,0,0/
c
c-----coefficients for computing the extinction coefficient
c     for cloud ice particles
c     polynomial fit: y=a1+a2/x**a3; x is in m**2/gm
c
      data aib /  -0.44171,    0.62951,   0.06465,
     2            -0.13727,    0.61291,   0.28962,
     3            -0.01878,    1.67680,   0.79080,
     4            -0.01896,    1.06510,   0.69493,
     5            -0.04788,    0.88178,   0.54492,
     6            -0.02265,    1.57390,   0.76161,
     7            -0.01038,    2.15640,   0.89045, 
     8            -0.00450,    2.51370,   0.95989,
     9            -0.00044,    3.15050,   1.03750,
     *            -0.02956,    1.44680,   0.71283/
c
c-----coefficients for computing the extinction coefficient
c     for cloud liquid drops
c     polynomial fit: y=a1+a2*x+a3*x**2+a4*x**3; x is in m**2/gm
c
      data awb /   0.08641,    0.01769,    -1.5572e-3,   3.4896e-5,
     2             0.22027,    0.00997,    -1.8719e-3,   5.3112e-5,
     3             0.39252,   -0.02817,     7.2931e-4,  -3.8151e-6,
     4             0.39975,   -0.03426,     1.2884e-3,  -1.7930e-5,
     5             0.34021,   -0.02805,     1.0654e-3,  -1.5443e-5,
     6             0.15587,    0.00371,    -7.7705e-4,   2.0547e-5,
     7             0.05518,    0.04544,    -4.2067e-3,   1.0184e-4,
     8             0.12724,    0.04751,    -5.2037e-3,   1.3711e-4,
     9             0.30390,    0.01656,    -3.5271e-3,   1.0828e-4,
     *             0.63617,   -0.06287,     2.2350e-3,  -2.3177e-5/
c
c-----coefficients for computing the single-scattering albedo
c     for cloud ice particles
c     polynomial fit: y=a1+a2*x+a3*x**2+a4*x**3; x is in m**2/gm
c
      data aiw/    0.17201,    1.2229e-2,  -1.4837e-4,   5.8020e-7,
     2             0.81470,   -2.7293e-3,   9.7816e-8,   5.7650e-8,
     3             0.54859,   -4.8273e-4,   5.4353e-6,  -1.5679e-8,
     4             0.39218,    4.1717e-3, - 4.8869e-5,   1.9144e-7,
     5             0.71773,   -3.3640e-3,   1.9713e-5,  -3.3189e-8,
     6             0.77345,   -5.5228e-3,   4.8379e-5,  -1.5151e-7,
     7             0.74975,   -5.6604e-3,   5.6475e-5,  -1.9664e-7,
     8             0.69011,   -4.5348e-3,   4.9322e-5,  -1.8255e-7,
     9             0.83963,   -6.7253e-3,   6.1900e-5,  -2.0862e-7,
     *             0.64860,   -2.8692e-3,   2.7656e-5,  -8.9680e-8/
c
c-----coefficients for computing the single-scattering albedo
c     for cloud liquid drops
c     polynomial fit: y=a1+a2*x+a3*x**2+a4*x**3; x is in m**2/gm
c
      data aww/   -7.8566e-2,  8.0875e-2,  -4.3403e-3,   8.1341e-5,
     2            -1.3384e-2,  9.3134e-2,  -6.0491e-3,   1.3059e-4,
     3             3.7096e-2,  7.3211e-2,  -4.4211e-3,   9.2448e-5,
     4            -3.7600e-3,  9.3344e-2,  -5.6561e-3,   1.1387e-4,
     5             0.40212,    7.8083e-2,  -5.9583e-3,   1.2883e-4,
     6             0.57928,    5.9094e-2,  -5.4425e-3,   1.2725e-4,
     7             0.68974,    4.2334e-2,  -4.9469e-3,   1.2863e-4,
     8             0.80122,    9.4578e-3,  -2.8508e-3,   9.0078e-5,
     9             1.02340,   -2.6204e-2,   4.2552e-4,   3.2160e-6,
     *             0.05092,    7.5409e-2,  -4.7305e-3,   1.0121e-4/ 
c
c-----coefficients for computing the asymmetry factor for cloud ice particles
c     polynomial fit: y=a1+a2*x+a3*x**2+a4*x**3; x is in m**2/gm
c
      data aig /   0.57867,    1.0135e-2,  -1.1142e-4,   4.1537e-7,
     2             0.72259,    3.1149e-3,  -1.9927e-5,   5.6024e-8,
     3             0.76109,    4.5449e-3,  -4.6199e-5,   1.6446e-7,
     4             0.86934,    2.7474e-3,  -3.1301e-5,   1.1959e-7,
     5             0.89103,    1.8513e-3,  -1.6551e-5,   5.5193e-8,
     6             0.86325,    2.1408e-3,  -1.6846e-5,   4.9473e-8,
     7             0.85064,    2.5028e-3,  -2.0812e-5,   6.3427e-8,
     8             0.86945,    2.4615e-3,  -2.3882e-5,   8.2431e-8,
     9             0.80122,    3.1906e-3,  -2.4856e-5,   7.2411e-8,
     *             0.73290,    4.8034e-3,  -4.4425e-5,   1.4839e-7/
c
c-----coefficients for computing the asymmetry factor for cloud liquid drops
c     polynomial fit: y=a1+a2*x+a3*x**2+a4*x**3; x is in m**2/gm
c
      data awg /  -0.51930,    0.20290,    -1.1747e-2,   2.3868e-4,
     2            -0.22151,    0.19708,    -1.2462e-2,   2.6646e-4,
     3             0.14157,    0.14705,    -9.5802e-3,   2.0819e-4,
     4             0.41590,    0.10482,    -6.9118e-3,   1.5115e-4,
     5             0.55338,    7.7016e-2,  -5.2218e-3,   1.1587e-4,
     6             0.61384,    6.4402e-2,  -4.6241e-3,   1.0746e-4,
     7             0.67891,    4.8698e-2,  -3.7021e-3,   9.1966e-5,
     8             0.78169,    2.0803e-2,  -1.4749e-3,   3.9362e-5,
     9             0.93218,   -3.3425e-2,   2.9632e-3,  -6.9362e-5,
     *             0.01649,    0.16561,    -1.0723e-2,   2.3220e-4/ 
c
c-----include tables used in the table look-up for co2 (band 3), 
c     o3 (band 5), and h2o (bands 1, 2, and 7) transmission functions.

      logical first
      data first /.true./

#include "h2o-tran3.h"
#include "co2-tran3.h"
#include "o3-tran3.h"

c     save c1,c2,c3,o1,o2,o3
c     save h11,h12,h13,h21,h22,h23,h81,h82,h83

      if (first) then

c-----tables co2 and h2o are only used with 'high' option

       if (high) then

        do iw=1,nh
         do ip=1,nx
          h11(ip,iw,1)=1.0-h11(ip,iw,1)
          h21(ip,iw,1)=1.0-h21(ip,iw,1)
          h81(ip,iw,1)=1.0-h81(ip,iw,1)
         enddo
        enddo

        do iw=1,nc
         do ip=1,nx
          c1(ip,iw,1)=1.0-c1(ip,iw,1)
         enddo
        enddo

c-----copy tables to enhance the speed of co2 (band 3), o3 (band 5),
c     and h2o (bands 1, 2, and 8 only) transmission calculations
c     using table look-up.
c-----tables are replicated to avoid memory bank conflicts

        do it=2,nt
         do iw=1,nc
          do ip=1,nx
           c1 (ip,iw,it)= c1(ip,iw,1)
           c2 (ip,iw,it)= c2(ip,iw,1)
           c3 (ip,iw,it)= c3(ip,iw,1)
          enddo
         enddo
         do iw=1,nh
          do ip=1,nx
           h11(ip,iw,it)=h11(ip,iw,1)
           h12(ip,iw,it)=h12(ip,iw,1)
           h13(ip,iw,it)=h13(ip,iw,1)
           h21(ip,iw,it)=h21(ip,iw,1)
           h22(ip,iw,it)=h22(ip,iw,1)
           h23(ip,iw,it)=h23(ip,iw,1)
           h81(ip,iw,it)=h81(ip,iw,1)
           h82(ip,iw,it)=h82(ip,iw,1)
           h83(ip,iw,it)=h83(ip,iw,1)
          enddo
         enddo
        enddo

       endif

c-----always use table look-up for ozone transmittance

        do iw=1,no
         do ip=1,nx
          o1(ip,iw,1)=1.0-o1(ip,iw,1)
         enddo
        enddo

        do it=2,nt
         do iw=1,no
          do ip=1,nx
           o1 (ip,iw,it)= o1(ip,iw,1)
           o2 (ip,iw,it)= o2(ip,iw,1)
           o3 (ip,iw,it)= o3(ip,iw,1)
          enddo
         enddo
        enddo

       first=.false.

      endif

c-----set the pressure at the top of the model atmosphere
c     to 1.0e-4 if it is zero

      do j=1,n
       do i=1,m
          if (pl(i,j,1) .eq. 0.0) then
              pl(i,j,1)=1.0e-4
          endif
       enddo
      enddo

c-----compute layer pressure (pa) and layer temperature minus 250K (dt)

      do k=1,np
       do j=1,n
        do i=1,m
         pa(i,j,k)=0.5*(pl(i,j,k)+pl(i,j,k+1))
         dt(i,j,k)=ta(i,j,k)-250.0
        enddo
       enddo
      enddo

c-----compute layer absorber amount

c     dh2o : water vapor amount (g/cm**2)
c     dcont: scaled water vapor amount for continuum absorption
c            (g/cm**2)
c     dco2 : co2 amount (cm-atm)stp
c     do3  : o3 amount (cm-atm)stp
c     dn2o : n2o amount (cm-atm)stp
c     dch4 : ch4 amount (cm-atm)stp
c     df11 : cfc11 amount (cm-atm)stp
c     df12 : cfc12 amount (cm-atm)stp
c     df22 : cfc22 amount (cm-atm)stp
c     the factor 1.02 is equal to 1000/980
c     factors 789 and 476 are for unit conversion
c     the factor 0.001618 is equal to 1.02/(.622*1013.25) 
c     the factor 6.081 is equal to 1800/296


      do k=1,np
       do j=1,n
        do i=1,m

         dp           = pl(i,j,k+1)-pl(i,j,k)
         dh2o (i,j,k) = 1.02*wa(i,j,k)*dp+1.e-10
         do3  (i,j,k) = 476.*oa(i,j,k)*dp+1.e-10
         dco2 (i,j,k) = 789.*co2*dp+1.e-10
         dch4 (i,j,k) = 789.*ch4(k)*dp+1.e-10
         dn2o (i,j,k) = 789.*n2o(k)*dp+1.e-10
         df11 (i,j,k) = 789.*cfc11*dp+1.e-10
         df12 (i,j,k) = 789.*cfc12*dp+1.e-10
         df22 (i,j,k) = 789.*cfc22*dp+1.e-10

c-----compute scaled water vapor amount for h2o continuum absorption
c     following eq. (43).

         xx=pa(i,j,k)*0.001618*wa(i,j,k)*wa(i,j,k)*dp
         dcont(i,j,k) = xx*exp(1800./ta(i,j,k)-6.081)+1.e-10

        enddo
       enddo
      enddo

c-----compute column-integrated h2o amoumt, h2o-weighted pressure
c     and temperature.  it follows eqs. (37) and (38).

       if (high) then
        call column(m,n,np,pa,dt,dh2o,sh2o,swpre,swtem)
       endif

c-----compute layer cloud water amount (gm/m**2)
c     index is 1 for ice, 2 for waterdrops and 3 for raindrops.
c     Rain optical thickness is 0.00307 /(gm/m**2).
c     It is for a specific drop size distribution provided by Q. Fu.

       if (cldwater) then
        do k=1,np
         do j=1,n
          do i=1,m
             dp          =pl(i,j,k+1)-pl(i,j,k)
             cwp(i,j,k,1)=1.02*10000.0*cwc(i,j,k,1)*dp
             cwp(i,j,k,2)=1.02*10000.0*cwc(i,j,k,2)*dp
             cwp(i,j,k,3)=1.02*10000.0*cwc(i,j,k,3)*dp
             taucl(i,j,k,3)=0.00307*cwp(i,j,k,3)
          enddo
         enddo
        enddo
       endif

c-----the surface (np+1) is treated as a layer filled with black clouds.
c     clr is the equivalent clear fraction of a layer
c     transfc is the transmttance between the surface and a pressure level.
c     trantcr is the clear-sky transmttance between the surface and a
c     pressure level.
 
      do j=1,n
       do i=1,m
        clr(i,j,0)    = 1.0
        clr(i,j,np+1) = 0.0
        st4(i,j)      = 0.0
        transfc(i,j,np+1)=1.0
        trantcr(i,j,np+1)=1.0
       enddo
      enddo

c-----initialize fluxes

      do k=1,np+1
       do j=1,n
        do i=1,m
         flx(i,j,k)  = 0.0
         flc(i,j,k)  = 0.0
         dfdts(i,j,k)= 0.0
         rflx(i,j,k) = 0.0
         rflc(i,j,k) = 0.0
        enddo
       enddo
      enddo

c-----integration over spectral bands

      do 1000 ib=1,10

c-----if h2otbl, compute h2o (line) transmittance using table look-up.
c     if conbnd, compute h2o (continuum) transmittance in bands 3-6.
c     if co2bnd, compute co2 transmittance in band 3.
c     if oznbnd, compute  o3 transmittance in band 5.
c     if n2obnd, compute n2o transmittance in bands 6 and 7.
c     if ch4bnd, compute ch4 transmittance in bands 6 and 7.
c     if combnd, compute co2-minor transmittance in bands 4 and 5.
c     if f11bnd, compute cfc11 transmittance in bands 4 and 5.
c     if f12bnd, compute cfc12 transmittance in bands 4 and 6.
c     if f22bnd, compute cfc22 transmittance in bands 4 and 6.
c     if b10bnd, compute flux reduction due to n2o in band 10.

       h2otbl=high.and.(ib.eq.1.or.ib.eq.2.or.ib.eq.8)
       conbnd=ib.ge.3.and.ib.le.6
       co2bnd=ib.eq.3
       oznbnd=ib.eq.5
       n2obnd=ib.eq.6.or.ib.eq.7
       ch4bnd=ib.eq.6.or.ib.eq.7
       combnd=ib.eq.4.or.ib.eq.5
       f11bnd=ib.eq.4.or.ib.eq.5
       f12bnd=ib.eq.4.or.ib.eq.6
       f22bnd=ib.eq.4.or.ib.eq.6
       b10bnd=ib.eq.10

c-----blayer is the spectrally integrated planck flux of the mean layer
c     temperature derived from eq. (22)
c     the fitting for the planck flux is valid in the range 160-345 K.

       do k=1,np
        do j=1,n
         do i=1,m
          blayer(i,j,k)=ta(i,j,k)*(ta(i,j,k)*(ta(i,j,k)
     *                 *(ta(i,j,k)*cb(5,ib)+cb(4,ib))+cb(3,ib))
     *                 +cb(2,ib))+cb(1,ib)
         enddo
        enddo
       enddo

c-----the earth surface, with an index "np+1", is treated as a layer

       do j=1,n
        do i=1,m
         blayer(i,j,0)   = 0.0
         blayer(i,j,np+1)= ( ts(i,j)*(ts(i,j)*(ts(i,j)
     *                    *(ts(i,j)*cb(5,ib)+cb(4,ib))+cb(3,ib))
     *                    +cb(2,ib))+cb(1,ib) )*emiss(i,j,ib)

c-----dbs is the derivative of the surface emission with respect to
c     surface temperature (eq. 59).

         dbs(i,j)=(ts(i,j)*(ts(i,j)*(ts(i,j)*4.*cb(5,ib)
     *           +3.*cb(4,ib))+2.*cb(3,ib))+cb(2,ib))*emiss(i,j,ib)

        enddo
       enddo

       do k=1,np+1
        do j=1,n
         do i=1,m
           dlayer(i,j,k)=blayer(i,j,k-1)-blayer(i,j,k)
         enddo
        enddo
       enddo

c-----compute column-integrated absorber amoumt, absorber-weighted
c     pressure and temperature for co2 (band 3) and o3 (band 5).
c     it follows eqs. (37) and (38).

c-----this is in the band loop to save storage

      if (high .and. co2bnd) then
        call column(m,n,np,pa,dt,dco2,sco3,scopre,scotem)
      endif

      if (oznbnd) then
        call column(m,n,np,pa,dt,do3,sco3,scopre,scotem)
      endif

c-----compute cloud optical thickness

      if (cldwater) then
       do k= 1, np
        do j= 1, n
         do i= 1, m
          taucl(i,j,k,1)=cwp(i,j,k,1)*(aib(1,ib)+aib(2,ib)/
     *      reff(i,j,k,1)**aib(3,ib))
          taucl(i,j,k,2)=cwp(i,j,k,2)*(awb(1,ib)+(awb(2,ib)+(awb(3,ib)
     *      +awb(4,ib)*reff(i,j,k,2))*reff(i,j,k,2))*reff(i,j,k,2))
         enddo
        enddo
       enddo
      endif

c-----compute cloud single-scattering albedo and asymmetry factor for
c     a mixture of ice particles, liquid drops, and rain drops
c     single-scattering albedo and asymmetry factor of rain are set
c     to 0.54 and 0.95, respectively.

       do k= 1, np
        do j= 1, n
         do i= 1, m

           clr(i,j,k)    = 1.0
           taux=taucl(i,j,k,1)+taucl(i,j,k,2)+taucl(i,j,k,3)

          if (taux.gt.0.02 .and. fcld(i,j,k).gt.0.01) then

           reff1=min(reff(i,j,k,1),130. _d 0)
           reff2=min(reff(i,j,k,2),20.0 _d 0)

           w1=taucl(i,j,k,1)*(aiw(1,ib)+(aiw(2,ib)+(aiw(3,ib)
     *       +aiw(4,ib)*reff1)*reff1)*reff1)
           w2=taucl(i,j,k,2)*(aww(1,ib)+(aww(2,ib)+(aww(3,ib)
     *       +aww(4,ib)*reff2)*reff2)*reff2)
           w3=taucl(i,j,k,3)*0.54
           ww=(w1+w2+w3)/taux

           g1=w1*(aig(1,ib)+(aig(2,ib)+(aig(3,ib)
     *      +aig(4,ib)*reff1)*reff1)*reff1)
           g2=w2*(awg(1,ib)+(awg(2,ib)+(awg(3,ib)
     *      +awg(4,ib)*reff2)*reff2)*reff2)
           g3=w3*0.95

           gg=(g1+g2+g3)/(w1+w2+w3)

c-----parameterization of LW scattering
c     compute forward-scattered fraction and scale optical thickness

           ff=0.5+(0.3739+(0.0076+0.1185*gg)*gg)*gg
           taux=taux*(1.-ww*ff)

c-----compute equivalent cloud-free fraction, clr, for each layer
c     the cloud diffuse transmittance is approximated by using 
c     a diffusivity factor of 1.66.

           clr(i,j,k)=1.0-(fcld(i,j,k)*(1.0-exp(-1.66*taux)))

          endif

         enddo
        enddo
       enddo

c-----compute the exponential terms (eq. 32) at each layer due to
c     water vapor line absorption when k-distribution is used

      if (.not.h2otbl .and. .not.b10bnd) then
        call h2oexps(ib,m,n,np,dh2o,pa,dt,xkw,aw,bw,pm,mw,h2oexp)
      endif

c-----compute the exponential terms (eq. 46) at each layer due to
c     water vapor continuum absorption

      if (conbnd) then
        call conexps(ib,m,n,np,dcont,xke,conexp)
      endif

c-----compute the exponential terms (eq. 32) at each layer due to
c     co2 absorption

      if (.not.high .and. co2bnd) then
        call co2exps(m,n,np,dco2,pa,dt,co2exp)
      endif

c***** for trace gases *****

      if (trace) then

c-----compute the exponential terms at each layer due to n2o absorption

       if (n2obnd) then
        call n2oexps(ib,m,n,np,dn2o,pa,dt,n2oexp)
       endif

c-----compute the exponential terms at each layer due to ch4 absorption

       if (ch4bnd) then
        call ch4exps(ib,m,n,np,dch4,pa,dt,ch4exp)
       endif

c-----compute the exponential terms due to co2 minor absorption

       if (combnd) then
        call comexps(ib,m,n,np,dco2,dt,comexp)
       endif

c-----compute the exponential terms due to cfc11 absorption

       if (f11bnd) then
            a1  = 1.26610e-3
            b1  = 3.55940e-6
            fk1 = 1.89736e+1
            a2  = 8.19370e-4
            b2  = 4.67810e-6
            fk2 = 1.01487e+1
        call cfcexps(ib,m,n,np,a1,b1,fk1,a2,b2,fk2,df11,dt,f11exp)
       endif

c-----compute the exponential terms due to cfc12 absorption

       if (f12bnd) then
            a1  = 8.77370e-4
            b1  =-5.88440e-6
            fk1 = 1.58104e+1
            a2  = 8.62000e-4
            b2  =-4.22500e-6
            fk2 = 3.70107e+1
        call cfcexps(ib,m,n,np,a1,b1,fk1,a2,b2,fk2,df12,dt,f12exp)
       endif

c-----compute the exponential terms due to cfc22 absorption

       if (f22bnd) then
            a1  = 9.65130e-4
            b1  = 1.31280e-5
            fk1 = 6.18536e+0
            a2  =-3.00010e-5 
            b2  = 5.25010e-7
            fk2 = 3.27912e+1
        call cfcexps(ib,m,n,np,a1,b1,fk1,a2,b2,fk2,df22,dt,f22exp)
       endif

c-----compute the exponential terms at each layer in band 10 due to
c     h2o line and continuum, co2, and n2o absorption

       if (b10bnd) then
        call b10exps(m,n,np,dh2o,dcont,dco2,dn2o,pa,dt
     *              ,h2oexp,conexp,co2exp,n2oexp)
       endif

      endif

c-----compute transmittances for regions between levels k1 and k2
c     and update the fluxes at the two levels.


c-----initialize fluxes

      do k=1,np+1
       do j=1,n
        do i=1,m
         flxu(i,j,k) = 0.0
         flxd(i,j,k) = 0.0
         flcu(i,j,k) = 0.0
         flcd(i,j,k) = 0.0
        enddo
       enddo
      enddo

      do 2000 k1=1,np

c-----initialize fclr, th2o, tcon, tco2, and tranal
c     fclr is the clear fraction of the line-of-sight
c     clrlw, clrmd, and clrhi are the clear-sky fractions of the 
c      low, middle, and high troposphere, respectively
c     tranal is the aerosol transmission function

        do j=1,n
         do i=1,m
          fclr(i,j)  = 1.0
          clrlw(i,j) = 1.0
          clrmd(i,j) = 1.0
          clrhi(i,j) = 1.0
          tranal(i,j)= 1.0
         enddo
        enddo

c-----for h2o line transmission

      if (.not. h2otbl) then
        do ik=1,6
         do j=1,n
          do i=1,m
           th2o(i,j,ik)=1.0
          enddo
         enddo
        enddo
      endif

c-----for h2o continuum transmission

       if (conbnd) then
         do iq=1,3
          do j=1,n
           do i=1,m
            tcon(i,j,iq)=1.0
           enddo
          enddo
         enddo
       endif

c-----for co2 transmission using k-distribution method.
c     band 3 is divided into 3 sub-bands, but sub-bands 3a and 3c
c     are combined in computing the co2 transmittance.

       if (.not.high .and. co2bnd) then
         do isb=1,2
          do ik=1,6
           do j=1,n
            do i=1,m
             tco2(i,j,ik,isb)=1.0
            enddo
           enddo
          enddo
         enddo
       endif

c***** for trace gases *****

      if (trace) then

c-----for n2o transmission using k-distribution method.

       if (n2obnd) then
          do ik=1,4
           do j=1,n
            do i=1,m
             tn2o(i,j,ik)=1.0
            enddo
           enddo
          enddo
       endif

c-----for ch4 transmission using k-distribution method.

       if (ch4bnd) then
          do ik=1,4
           do j=1,n
            do i=1,m
             tch4(i,j,ik)=1.0
            enddo
           enddo
          enddo
       endif

c-----for co2-minor transmission using k-distribution method.

       if (combnd) then
          do ik=1,2
           do j=1,n
            do i=1,m
             tcom(i,j,ik)=1.0
            enddo
           enddo
          enddo
       endif

c-----for cfc-11 transmission using k-distribution method.

       if (f11bnd) then
           do j=1,n
            do i=1,m
             tf11(i,j)=1.0
            enddo
           enddo
       endif

c-----for cfc-12 transmission using k-distribution method.

       if (f12bnd) then
           do j=1,n
            do i=1,m
             tf12(i,j)=1.0
            enddo
           enddo
       endif

c-----for cfc-22 transmission when using k-distribution method.

       if (f22bnd) then
           do j=1,n
            do i=1,m
             tf22(i,j)=1.0
            enddo
           enddo
       endif

c-----for the transmission in band 10 using k-distribution method.

       if (b10bnd) then
          do ik=1,6
           do j=1,n
            do i=1,m
              th2o(i,j,ik)=1.0
              tco2(i,j,ik,1)=1.0
            enddo
           enddo
          enddo
          do iq=1,3
           do j=1,n
            do i=1,m
              tcon(i,j,iq)=1.0
            enddo
           enddo
          enddo
          do ik=1,4
           do j=1,n
            do i=1,m
              tn2o(i,j,ik)=1.0
            enddo
           enddo
          enddo
       endif

      endif

c-----loop over the bottom level of the region (k2)

      do 3000 k2=k1+1,np+1

c-----initialize total transmission function (trant)

          do j=1,n
           do i=1,m
            trant(i,j)=1.0
           enddo
          enddo

      if (h2otbl) then
          w1=-8.0
          p1=-2.0
          dwe=0.3
          dpe=0.2

c-----compute water vapor transmittance using table look-up

          if (ib.eq.1) then
           call tablup(k1,k2,m,n,np,nx,nh,nt,sh2o,swpre,swtem,
     *                 w1,p1,dwe,dpe,h11,h12,h13,trant)
          endif
          if (ib.eq.2) then
           call tablup(k1,k2,m,n,np,nx,nh,nt,sh2o,swpre,swtem,
     *                 w1,p1,dwe,dpe,h21,h22,h23,trant)

          endif
          if (ib.eq.8) then
           call tablup(k1,k2,m,n,np,nx,nh,nt,sh2o,swpre,swtem,
     *                 w1,p1,dwe,dpe,h81,h82,h83,trant)
          endif

      else

c-----compute water vapor transmittance using k-distribution

       if (.not.b10bnd) then
        call h2okdis(ib,m,n,np,k2-1,fkw,gkw,ne,h2oexp,conexp,
     *               th2o,tcon,trant)
       endif

      endif

      if (co2bnd) then

        if (high) then

c-----compute co2 transmittance using table look-up method

          w1=-4.0
          p1=-2.0
          dwe=0.3
          dpe=0.2
          call tablup(k1,k2,m,n,np,nx,nc,nt,sco3,scopre,scotem,
     *                w1,p1,dwe,dpe,c1,c2,c3,trant)

       else

c-----compute co2 transmittance using k-distribution method
          call co2kdis(m,n,np,k2-1,co2exp,tco2,trant)

        endif

      endif

c-----All use table look-up to compute o3 transmittance.

      if (oznbnd) then
          w1=-6.0
          p1=-2.0
          dwe=0.3
          dpe=0.2
          call tablup(k1,k2,m,n,np,nx,no,nt,sco3,scopre,scotem,
     *                w1,p1,dwe,dpe,o1,o2,o3,trant)

      endif

c***** for trace gases *****

      if (trace) then

c-----compute n2o transmittance using k-distribution method

       if (n2obnd) then
          call n2okdis(ib,m,n,np,k2-1,n2oexp,tn2o,trant)
       endif

c-----compute ch4 transmittance using k-distribution method

       if (ch4bnd) then
          call ch4kdis(ib,m,n,np,k2-1,ch4exp,tch4,trant)
       endif

c-----compute co2-minor transmittance using k-distribution method

       if (combnd) then
          call comkdis(ib,m,n,np,k2-1,comexp,tcom,trant)
       endif

c-----compute cfc11 transmittance using k-distribution method

       if (f11bnd) then
          call cfckdis(m,n,np,k2-1,f11exp,tf11,trant)
       endif

c-----compute cfc12 transmittance using k-distribution method

       if (f12bnd) then
          call cfckdis(m,n,np,k2-1,f12exp,tf12,trant)
       endif

c-----compute cfc22 transmittance using k-distribution method

       if (f22bnd) then
          call cfckdis(m,n,np,k2-1,f22exp,tf22,trant)
       endif

c-----compute transmittance in band 10 using k-distribution method
c     here, trant is the change in transmittance due to n2o absorption

       if (b10bnd) then
          call b10kdis(m,n,np,k2-1,h2oexp,conexp,co2exp,n2oexp
     *                ,th2o,tcon,tco2,tn2o,trant)
       endif

      endif
c
c-----include aerosol effect
c
      do j=1,n
       do i=1,m
         ff=0.5+(0.3739+(0.0076+0.1185*asyal(i,j,k2-1,ib))
     *      *asyal(i,j,k2-1,ib))*asyal(i,j,k2-1,ib)
         taux=taual(i,j,k2-1,ib)*(1.-ssaal(i,j,k2-1,ib)*ff)
         tranal(i,j)=tranal(i,j)*exp(-1.66*taux)
         trant (i,j)=trant(i,j) *tranal(i,j)
       enddo
      enddo

c-----Identify the clear-sky fractions clrhi, clrmd and clrlw, in the
c     high, middle and low cloud groups.
c     fclr is the clear-sky fraction between levels k1 and k2 assuming
c     the three cloud groups are randomly overlapped.

      do j=1,n
       do i=1,m
        if( k2 .le. ict ) then
            clrhi(i,j)=min(clr(i,j,k2-1),clrhi(i,j))
        elseif( k2 .gt. ict .and. k2 .le. icb ) then
            clrmd(i,j)=min(clr(i,j,k2-1),clrmd(i,j))
        elseif( k2 .gt. icb ) then
            clrlw(i,j)=min(clr(i,j,k2-1),clrlw(i,j))
        endif
            fclr(i,j)=clrlw(i,j)*clrmd(i,j)*clrhi(i,j)

       enddo
      enddo

c-----compute upward and downward fluxes (band 1-9).
c     add "boundary" terms to the net downward flux.
c     these are the first terms on the right-hand-side of
c     eqs. (56a) and (56b).  downward fluxes are positive.

      if (.not. b10bnd) then

       if (k2 .eq. k1+1) then

        do j=1,n
         do i=1,m

c-----compute upward and downward fluxes for clear-sky situation

          flcu(i,j,k1)=flcu(i,j,k1)-blayer(i,j,k1)
          flcd(i,j,k2)=flcd(i,j,k2)+blayer(i,j,k1)

c-----compute upward and downward fluxes for all-sky situation

          flxu(i,j,k1)=flxu(i,j,k1)-blayer(i,j,k1)
          flxd(i,j,k2)=flxd(i,j,k2)+blayer(i,j,k1)

         enddo
        enddo

       endif

c-----add flux components involving the four layers above and below
c     the levels k1 and k2.  it follows eqs. (56a) and (56b).

       do j=1,n
        do i=1,m
         xx=trant(i,j)*dlayer(i,j,k2)
         flcu(i,j,k1) =flcu(i,j,k1)+xx
         flxu(i,j,k1) =flxu(i,j,k1)+xx*fclr(i,j)
         xx=trant(i,j)*dlayer(i,j,k1)
         flcd(i,j,k2) =flcd(i,j,k2)+xx
         flxd(i,j,k2) =flxd(i,j,k2)+xx*fclr(i,j)
        enddo
       enddo

      else

c-----flux reduction due to n2o in band 10

       if (trace) then

        do j=1,n
         do i=1,m
           rflx(i,j,k1) = rflx(i,j,k1)+trant(i,j)*fclr(i,j)
     *                   *dlayer(i,j,k2)
           rflx(i,j,k2) = rflx(i,j,k2)+trant(i,j)*fclr(i,j)
     *                   *dlayer(i,j,k1)
           rflc(i,j,k1) = rflc(i,j,k1)+trant(i,j)
     *                   *dlayer(i,j,k2)
           rflc(i,j,k2) = rflc(i,j,k2)+trant(i,j)
     *                   *dlayer(i,j,k1)
         enddo
        enddo

       endif

      endif

 3000 continue


c-----transmission between level k1 and the surface

         do j=1,n
          do i=1,m
           trantcr(i,j,k1) =trant(i,j)
           transfc(i,j,k1) =trant(i,j)*fclr(i,j)
          enddo
         enddo

c-----compute the partial derivative of fluxes with respect to
c     surface temperature (eq. 59)

      if (trace .or. (.not. b10bnd) ) then

       do j=1,n
        do i=1,m
         dfdts(i,j,k1) =dfdts(i,j,k1)-dbs(i,j)*transfc(i,j,k1)
        enddo
       enddo

      endif

 2000 continue

      if (.not. b10bnd) then

c-----add contribution from the surface to the flux terms at the surface

        do j=1,n
         do i=1,m
          flcu(i,j,np+1)=flcu(i,j,np+1)-blayer(i,j,np+1)
          flxu(i,j,np+1)=flxu(i,j,np+1)-blayer(i,j,np+1)
          st4(i,j)=st4(i,j)-blayer(i,j,np+1)
          dfdts(i,j,np+1)=dfdts(i,j,np+1)-dbs(i,j)
         enddo
        enddo

c-----add the flux component reflected by the surface
c     note: upward flux is negative

        do k=1, np+1
         do j=1,n
          do i=1,m
           flcu(i,j,k)=flcu(i,j,k)-
     *           flcd(i,j,np+1)*trantcr(i,j,k)*(1.-emiss(i,j,ib))
           flxu(i,j,k)=flxu(i,j,k)-
     *           flxd(i,j,np+1)*transfc(i,j,k)*(1.-emiss(i,j,ib))
          enddo
         enddo
        enddo

      endif

c-----summation of fluxes over spectral bands

      do k=1,np+1
       do j=1,n
        do i=1,m
         flc(i,j,k)=flc(i,j,k)+flcd(i,j,k)+flcu(i,j,k)
         flx(i,j,k)=flx(i,j,k)+flxd(i,j,k)+flxu(i,j,k)
        enddo
       enddo
      enddo

 1000 continue

c-----adjust fluxes due to n2o absorption in band 10

      do k=1,np+1
       do j=1,n
        do i=1,m
         flc(i,j,k)=flc(i,j,k)+rflc(i,j,k)
         flx(i,j,k)=flx(i,j,k)+rflx(i,j,k)
        enddo
       enddo
      enddo

      return
      end
c***********************************************************************
      subroutine column (m,n,np,pa,dt,sabs0,sabs,spre,stem)
c***********************************************************************
c-----compute column-integrated (from top of the model atmosphere)
c     absorber amount (sabs), absorber-weighted pressure (spre) and
c     temperature (stem).
c     computations of spre and stem follows eqs. (37) and (38).
c
c--- input parameters
c   number of soundings in zonal direction (m)
c   number of soundings in meridional direction (n)
c   number of atmospheric layers (np)
c   layer pressure (pa)
c   layer temperature minus 250K (dt)
c   layer absorber amount (sabs0)
c
c--- output parameters
c   column-integrated absorber amount (sabs)
c   column absorber-weighted pressure (spre)
c   column absorber-weighted temperature (stem)
c
c--- units of pa and dt are mb and k, respectively.
c    units of sabs are g/cm**2 for water vapor and (cm-atm)stp
c    for co2 and o3
c***********************************************************************
      implicit none
      integer m,n,np,i,j,k

c---- input parameters -----

      _RL pa(m,n,np),dt(m,n,np),sabs0(m,n,np)

c---- output parameters -----

      _RL sabs(m,n,np+1),spre(m,n,np+1),stem(m,n,np+1)

c*********************************************************************
        do j=1,n
         do i=1,m
          sabs(i,j,1)=0.0
          spre(i,j,1)=0.0
          stem(i,j,1)=0.0
         enddo
        enddo

        do k=1,np
         do j=1,n
          do i=1,m
           sabs(i,j,k+1)=sabs(i,j,k)+sabs0(i,j,k)
           spre(i,j,k+1)=spre(i,j,k)+pa(i,j,k)*sabs0(i,j,k)
           stem(i,j,k+1)=stem(i,j,k)+dt(i,j,k)*sabs0(i,j,k)
          enddo
         enddo
        enddo

       return
       end
c**********************************************************************
      subroutine h2oexps(ib,m,n,np,dh2o,pa,dt,xkw,aw,bw,pm,mw,h2oexp)
c**********************************************************************
c   compute exponentials for water vapor line absorption
c   in individual layers.
c
c---- input parameters
c  spectral band (ib)
c  number of grid intervals in zonal direction (m)
c  number of grid intervals in meridional direction (n)
c  number of layers (np)
c  layer water vapor amount for line absorption (dh2o) 
c  layer pressure (pa)
c  layer temperature minus 250K (dt)
c  absorption coefficients for the first k-distribution
c     function due to h2o line absorption (xkw)
c  coefficients for the temperature and pressure scaling (aw,bw,pm)
c  ratios between neighboring absorption coefficients for
c     h2o line absorption (mw)
c
c---- output parameters
c  6 exponentials for each layer  (h2oexp)
c**********************************************************************
      implicit none
      integer ib,m,n,np,i,j,k,ik

c---- input parameters ------

      _RL dh2o(m,n,np),pa(m,n,np),dt(m,n,np)

c---- output parameters -----

      _RL h2oexp(m,n,np,6)

c---- static data -----

      integer mw(9)
      _RL xkw(9),aw(9),bw(9),pm(9)

c---- temporary arrays -----

      _RL xh,xh1

c**********************************************************************
c    note that the 3 sub-bands in band 3 use the same set of xkw, aw,
c    and bw,  therefore, h2oexp for these sub-bands are identical.
c**********************************************************************

        do k=1,np
         do j=1,n
          do i=1,m

c-----xh is the scaled water vapor amount for line absorption
c     computed from (27)

           xh = dh2o(i,j,k)*(pa(i,j,k)/500.)**pm(ib)
     1        * ( 1.+(aw(ib)+bw(ib)* dt(i,j,k))*dt(i,j,k) )

c-----h2oexp is the water vapor transmittance of the layer k
c     due to line absorption

           h2oexp(i,j,k,1) = exp(-xh*xkw(ib))

          enddo
         enddo
        enddo

        do ik=2,6

         if (mw(ib).eq.6) then

          do k=1,np
           do j=1,n
            do i=1,m
             xh = h2oexp(i,j,k,ik-1)*h2oexp(i,j,k,ik-1)
             h2oexp(i,j,k,ik) = xh*xh*xh
            enddo
           enddo
          enddo

        elseif (mw(ib).eq.8) then

          do k=1,np
           do j=1,n
            do i=1,m
             xh = h2oexp(i,j,k,ik-1)*h2oexp(i,j,k,ik-1)
             xh = xh*xh
             h2oexp(i,j,k,ik) = xh*xh
            enddo
           enddo
          enddo

        elseif (mw(ib).eq.9) then

          do k=1,np
           do j=1,n
            do i=1,m
             xh=h2oexp(i,j,k,ik-1)*h2oexp(i,j,k,ik-1)*h2oexp(i,j,k,ik-1)
             xh1 = xh*xh
             h2oexp(i,j,k,ik) = xh*xh1
            enddo
           enddo
          enddo

        else

          do k=1,np
           do j=1,n
            do i=1,m
             xh = h2oexp(i,j,k,ik-1)*h2oexp(i,j,k,ik-1)
             xh = xh*xh
             xh = xh*xh
             h2oexp(i,j,k,ik) = xh*xh
            enddo
           enddo
          enddo

        endif
       enddo

      return
      end
c**********************************************************************
      subroutine conexps(ib,m,n,np,dcont,xke,conexp)
c**********************************************************************
c   compute exponentials for continuum absorption in individual layers.
c
c---- input parameters
c  spectral band (ib)
c  number of grid intervals in zonal direction (m)
c  number of grid intervals in meridional direction (n)
c  number of layers (np)
c  layer scaled water vapor amount for continuum absorption (dcont) 
c  absorption coefficients for the first k-distribution function
c     due to water vapor continuum absorption (xke)
c
c---- output parameters
c  1 or 3 exponentials for each layer (conexp)
c**********************************************************************
      implicit none
      integer ib,m,n,np,i,j,k,iq

c---- input parameters ------

      _RL dcont(m,n,np)

c---- updated parameters -----

      _RL conexp(m,n,np,3)

c---- static data -----

      _RL xke(9)

c**********************************************************************

        do k=1,np
         do j=1,n
          do i=1,m
           conexp(i,j,k,1) = exp(-dcont(i,j,k)*xke(ib))
          enddo
         enddo
        enddo

       if (ib .eq. 3) then

c-----the absorption coefficients for sub-bands 3b (iq=2) and 3a (iq=3)
c     are, respectively, two and three times the absorption coefficient
c     for sub-band 3c (iq=1) (table 6).

        do iq=2,3
         do k=1,np
          do j=1,n
           do i=1,m
            conexp(i,j,k,iq) = conexp(i,j,k,iq-1) *conexp(i,j,k,iq-1)
           enddo
          enddo
         enddo
        enddo

       endif

      return
      end
c**********************************************************************
      subroutine co2exps(m,n,np,dco2,pa,dt,co2exp)
c**********************************************************************
c   compute co2 exponentials for individual layers.
c
c---- input parameters
c  number of grid intervals in zonal direction (m)
c  number of grid intervals in meridional direction (n)
c  number of layers (np)
c  layer co2 amount (dco2)
c  layer pressure (pa)
c  layer temperature minus 250K (dt)
c
c---- output parameters
c  6 exponentials for each layer (co2exp)
c**********************************************************************
      implicit none
      integer m,n,np,i,j,k

c---- input parameters -----

      _RL dco2(m,n,np),pa(m,n,np),dt(m,n,np)

c---- output parameters -----

      _RL co2exp(m,n,np,6,2)

c---- temporary arrays -----

      _RL xc

c**********************************************************************

        do k=1,np
         do j=1,n
          do i=1,m

c-----compute the scaled co2 amount from eq. (27) for band-wings
c     (sub-bands 3a and 3c).

           xc = dco2(i,j,k)*(pa(i,j,k)/300.0)**0.5
     1             *(1.+(0.0182+1.07e-4*dt(i,j,k))*dt(i,j,k))

c-----six exponentials by powers of 8 (table 7).

           co2exp(i,j,k,1,1)=exp(-xc*2.656e-5)

           xc=co2exp(i,j,k,1,1)*co2exp(i,j,k,1,1)
           xc=xc*xc
           co2exp(i,j,k,2,1)=xc*xc

           xc=co2exp(i,j,k,2,1)*co2exp(i,j,k,2,1)
           xc=xc*xc
           co2exp(i,j,k,3,1)=xc*xc

           xc=co2exp(i,j,k,3,1)*co2exp(i,j,k,3,1)
           xc=xc*xc
           co2exp(i,j,k,4,1)=xc*xc

           xc=co2exp(i,j,k,4,1)*co2exp(i,j,k,4,1)
           xc=xc*xc
           co2exp(i,j,k,5,1)=xc*xc

           xc=co2exp(i,j,k,5,1)*co2exp(i,j,k,5,1)
           xc=xc*xc
           co2exp(i,j,k,6,1)=xc*xc

c-----compute the scaled co2 amount from eq. (27) for band-center
c     region (sub-band 3b).

           xc = dco2(i,j,k)*(pa(i,j,k)/30.0)**0.85
     1             *(1.+(0.0042+2.00e-5*dt(i,j,k))*dt(i,j,k))

           co2exp(i,j,k,1,2)=exp(-xc*2.656e-3)

           xc=co2exp(i,j,k,1,2)*co2exp(i,j,k,1,2)
           xc=xc*xc
           co2exp(i,j,k,2,2)=xc*xc

           xc=co2exp(i,j,k,2,2)*co2exp(i,j,k,2,2)
           xc=xc*xc
           co2exp(i,j,k,3,2)=xc*xc

           xc=co2exp(i,j,k,3,2)*co2exp(i,j,k,3,2)
           xc=xc*xc
           co2exp(i,j,k,4,2)=xc*xc

           xc=co2exp(i,j,k,4,2)*co2exp(i,j,k,4,2)
           xc=xc*xc
           co2exp(i,j,k,5,2)=xc*xc

           xc=co2exp(i,j,k,5,2)*co2exp(i,j,k,5,2)
           xc=xc*xc
           co2exp(i,j,k,6,2)=xc*xc

          enddo
         enddo
        enddo

      return
      end
c**********************************************************************
      subroutine n2oexps(ib,m,n,np,dn2o,pa,dt,n2oexp)
c**********************************************************************
c   compute n2o exponentials for individual layers.
c
c---- input parameters
c  spectral band (ib)
c  number of grid intervals in zonal direction (m)
c  number of grid intervals in meridional direction (n)
c  number of layers (np)
c  layer n2o amount (dn2o)
c  layer pressure (pa)
c  layer temperature minus 250K (dt)
c
c---- output parameters
c  2 or 4 exponentials for each layer (n2oexp)
c**********************************************************************
      implicit none
      integer ib,m,n,np,i,j,k

c---- input parameters -----

      _RL dn2o(m,n,np),pa(m,n,np),dt(m,n,np)

c---- output parameters -----

      _RL n2oexp(m,n,np,4)

c---- temporary arrays -----

      _RL xc,xc1,xc2

c**********************************************************************

       do k=1,np
        do j=1,n
         do i=1,m

c-----four exponential by powers of 21 for band 6

          if (ib.eq.6) then

           xc=dn2o(i,j,k)*(1.+(1.9297e-3+4.3750e-6*dt(i,j,k))*dt(i,j,k))
           n2oexp(i,j,k,1)=exp(-xc*6.31582e-2)

           xc=n2oexp(i,j,k,1)*n2oexp(i,j,k,1)*n2oexp(i,j,k,1)
           xc1=xc*xc
           xc2=xc1*xc1
           n2oexp(i,j,k,2)=xc*xc1*xc2

c-----four exponential by powers of 8 for band 7

          else

           xc=dn2o(i,j,k)*(pa(i,j,k)/500.0)**0.48
     *        *(1.+(1.3804e-3+7.4838e-6*dt(i,j,k))*dt(i,j,k))
           n2oexp(i,j,k,1)=exp(-xc*5.35779e-2)

           xc=n2oexp(i,j,k,1)*n2oexp(i,j,k,1)
           xc=xc*xc
           n2oexp(i,j,k,2)=xc*xc
           xc=n2oexp(i,j,k,2)*n2oexp(i,j,k,2)
           xc=xc*xc
           n2oexp(i,j,k,3)=xc*xc
           xc=n2oexp(i,j,k,3)*n2oexp(i,j,k,3)
           xc=xc*xc
           n2oexp(i,j,k,4)=xc*xc

          endif

         enddo
        enddo
       enddo

      return
      end
c**********************************************************************
      subroutine ch4exps(ib,m,n,np,dch4,pa,dt,ch4exp)
c**********************************************************************
c   compute ch4 exponentials for individual layers.
c
c---- input parameters
c  spectral band (ib)
c  number of grid intervals in zonal direction (m)
c  number of grid intervals in meridional direction (n)
c  number of layers (np)
c  layer ch4 amount (dch4)
c  layer pressure (pa)
c  layer temperature minus 250K (dt)
c
c---- output parameters
c  1 or 4 exponentials for each layer (ch4exp)
c**********************************************************************
      implicit none
      integer ib,m,n,np,i,j,k

c---- input parameters -----

      _RL dch4(m,n,np),pa(m,n,np),dt(m,n,np)

c---- output parameters -----

      _RL ch4exp(m,n,np,4)

c---- temporary arrays -----

      _RL xc

c**********************************************************************

       do k=1,np
        do j=1,n
         do i=1,m

c-----four exponentials for band 6

          if (ib.eq.6) then

           xc=dch4(i,j,k)*(1.+(1.7007e-2+1.5826e-4*dt(i,j,k))*dt(i,j,k))
           ch4exp(i,j,k,1)=exp(-xc*5.80708e-3)

c-----four exponentials by powers of 12 for band 7

          else

           xc=dch4(i,j,k)*(pa(i,j,k)/500.0)**0.65
     *       *(1.+(5.9590e-4-2.2931e-6*dt(i,j,k))*dt(i,j,k))
           ch4exp(i,j,k,1)=exp(-xc*6.29247e-2)

           xc=ch4exp(i,j,k,1)*ch4exp(i,j,k,1)*ch4exp(i,j,k,1)
           xc=xc*xc
           ch4exp(i,j,k,2)=xc*xc

           xc=ch4exp(i,j,k,2)*ch4exp(i,j,k,2)*ch4exp(i,j,k,2)
           xc=xc*xc
           ch4exp(i,j,k,3)=xc*xc

           xc=ch4exp(i,j,k,3)*ch4exp(i,j,k,3)*ch4exp(i,j,k,3)
           xc=xc*xc
           ch4exp(i,j,k,4)=xc*xc

          endif

         enddo
        enddo
       enddo

      return
      end
c**********************************************************************
      subroutine comexps(ib,m,n,np,dcom,dt,comexp)
c**********************************************************************
c   compute co2-minor exponentials for individual layers.
c
c---- input parameters
c  spectral band (ib)
c  number of grid intervals in zonal direction (m)
c  number of grid intervals in meridional direction (n)
c  number of layers (np)
c  layer co2 amount (dcom)
c  layer temperature minus 250K (dt)
c
c---- output parameters
c  2 exponentials for each layer (comexp)
c**********************************************************************
      implicit none
      integer ib,m,n,np,i,j,k

c---- input parameters -----

      _RL dcom(m,n,np),dt(m,n,np)

c---- output parameters -----

      _RL comexp(m,n,np,2)

c---- temporary arrays -----

      _RL xc,xc1,xc2

c**********************************************************************

       do k=1,np
        do j=1,n
         do i=1,m

c-----two exponentials by powers of 60 for band 4

          if (ib.eq.4) then

           xc=dcom(i,j,k)*(1.+(3.5775e-2+4.0447e-4*dt(i,j,k))*dt(i,j,k))
           comexp(i,j,k,1)=exp(-xc*2.18947e-5)

           xc=comexp(i,j,k,1)*comexp(i,j,k,1)*comexp(i,j,k,1)
           xc=xc*xc
           xc1=xc*xc
           xc=xc1*xc1
           xc=xc*xc
           comexp(i,j,k,2)=xc*xc1

c-----two exponentials by powers of 44 for band 5

          else

           xc=dcom(i,j,k)*(1.+(3.4268e-2+3.7401e-4*dt(i,j,k))*dt(i,j,k))
           comexp(i,j,k,1)=exp(-xc*4.74570e-5)

           xc=comexp(i,j,k,1)*comexp(i,j,k,1)
           xc1=xc*xc
           xc2=xc1*xc1
           xc=xc2*xc2
           xc=xc*xc
           comexp(i,j,k,2)=xc1*xc2*xc

          endif

         enddo
        enddo
       enddo

      return
      end
c**********************************************************************
      subroutine cfcexps(ib,m,n,np,a1,b1,fk1,a2,b2,fk2,dcfc,dt,cfcexp)
c**********************************************************************
c   compute cfc(-11, -12, -22) exponentials for individual layers.
c
c---- input parameters
c  spectral band (ib)
c  number of grid intervals in zonal direction (m)
c  number of grid intervals in meridional direction (n)
c  number of layers (np)
c  parameters for computing the scaled cfc amounts
c             for temperature scaling (a1,b1,a2,b2)
c  the absorption coefficients for the
c     first k-distribution function due to cfcs (fk1,fk2)
c  layer cfc amounts (dcfc)
c  layer temperature minus 250K (dt)
c
c---- output parameters
c  1 exponential for each layer (cfcexp)
c**********************************************************************
      implicit none
      integer ib,m,n,np,i,j,k

c---- input parameters -----

      _RL dcfc(m,n,np),dt(m,n,np)

c---- output parameters -----

      _RL cfcexp(m,n,np)

c---- static data -----

      _RL a1,b1,fk1,a2,b2,fk2

c---- temporary arrays -----

      _RL xf

c**********************************************************************

       do k=1,np
        do j=1,n
         do i=1,m

c-----compute the scaled cfc amount (xf) and exponential (cfcexp)

          if (ib.eq.4) then
           xf=dcfc(i,j,k)*(1.+(a1+b1*dt(i,j,k))*dt(i,j,k))
           cfcexp(i,j,k)=exp(-xf*fk1)
          else
           xf=dcfc(i,j,k)*(1.+(a2+b2*dt(i,j,k))*dt(i,j,k))
           cfcexp(i,j,k)=exp(-xf*fk2)
          endif

         enddo
        enddo
       enddo

      return
      end
c**********************************************************************
      subroutine b10exps(m,n,np,dh2o,dcont,dco2,dn2o,pa,dt
     *          ,h2oexp,conexp,co2exp,n2oexp)
c**********************************************************************
c   compute band3a exponentials for individual layers.
c
c---- input parameters
c  number of grid intervals in zonal direction (m)
c  number of grid intervals in meridional direction (n)
c  number of layers (np)
c  layer h2o amount for line absorption (dh2o)
c  layer h2o amount for continuum absorption (dcont)
c  layer co2 amount (dco2)
c  layer n2o amount (dn2o)
c  layer pressure (pa)
c  layer temperature minus 250K (dt)
c
c---- output parameters
c
c  exponentials for each layer (h2oexp,conexp,co2exp,n2oexp)
c**********************************************************************
      implicit none
      integer m,n,np,i,j,k

c---- input parameters -----

      _RL dh2o(m,n,np),dcont(m,n,np),dn2o(m,n,np)
      _RL dco2(m,n,np),pa(m,n,np),dt(m,n,np)

c---- output parameters -----

      _RL h2oexp(m,n,np,6),conexp(m,n,np,3),co2exp(m,n,np,6,2)
     *    ,n2oexp(m,n,np,4)

c---- temporary arrays -----

      _RL xx,xx1,xx2,xx3

c**********************************************************************

        do k=1,np
         do j=1,n
          do i=1,m

c-----compute the scaled h2o-line amount for the sub-band 3a
c     table 3, Chou et al. (JAS, 1993)

           xx=dh2o(i,j,k)*(pa(i,j,k)/500.0)
     1           *(1.+(0.0149+6.20e-5*dt(i,j,k))*dt(i,j,k))

c-----six exponentials by powers of 8
c     the constant 0.10624 is equal to 1.66*0.064

           h2oexp(i,j,k,1)=exp(-xx*0.10624)

           xx=h2oexp(i,j,k,1)*h2oexp(i,j,k,1)
           xx=xx*xx
           h2oexp(i,j,k,2)=xx*xx

           xx=h2oexp(i,j,k,2)*h2oexp(i,j,k,2)
           xx=xx*xx
           h2oexp(i,j,k,3)=xx*xx

           xx=h2oexp(i,j,k,3)*h2oexp(i,j,k,3)
           xx=xx*xx
           h2oexp(i,j,k,4)=xx*xx

           xx=h2oexp(i,j,k,4)*h2oexp(i,j,k,4)
           xx=xx*xx
           h2oexp(i,j,k,5)=xx*xx

           xx=h2oexp(i,j,k,5)*h2oexp(i,j,k,5)
           xx=xx*xx
           h2oexp(i,j,k,6)=xx*xx

c-----compute the scaled co2 amount for the sub-band 3a
c     table 1, Chou et al. (JAS, 1993)

           xx=dco2(i,j,k)*(pa(i,j,k)/300.0)**0.5
     1           *(1.+(0.0179+1.02e-4*dt(i,j,k))*dt(i,j,k))

c-----six exponentials by powers of 8
c     the constant 2.656e-5 is equal to 1.66*1.60e-5

           co2exp(i,j,k,1,1)=exp(-xx*2.656e-5)

           xx=co2exp(i,j,k,1,1)*co2exp(i,j,k,1,1)
           xx=xx*xx
           co2exp(i,j,k,2,1)=xx*xx

           xx=co2exp(i,j,k,2,1)*co2exp(i,j,k,2,1)
           xx=xx*xx
           co2exp(i,j,k,3,1)=xx*xx

           xx=co2exp(i,j,k,3,1)*co2exp(i,j,k,3,1)
           xx=xx*xx
           co2exp(i,j,k,4,1)=xx*xx

           xx=co2exp(i,j,k,4,1)*co2exp(i,j,k,4,1)
           xx=xx*xx
           co2exp(i,j,k,5,1)=xx*xx

           xx=co2exp(i,j,k,5,1)*co2exp(i,j,k,5,1)
           xx=xx*xx
           co2exp(i,j,k,6,1)=xx*xx

c-----one exponential of h2o continuum for sub-band 3a
c     tabl 5 of Chou et. al. (JAS, 1993)
c     the constant 1.04995e+2 is equal to 1.66*63.25

           conexp(i,j,k,1)=exp(-dcont(i,j,k)*1.04995e+2)

c-----compute the scaled n2o amount for sub-band 3a

           xx=dn2o(i,j,k)*(1.+(1.4476e-3+3.6656e-6*dt(i,j,k))*dt(i,j,k))

c-----two exponential2 by powers of 58

           n2oexp(i,j,k,1)=exp(-xx*0.25238)

           xx=n2oexp(i,j,k,1)*n2oexp(i,j,k,1)
           xx1=xx*xx
           xx1=xx1*xx1
           xx2=xx1*xx1
           xx3=xx2*xx2
           n2oexp(i,j,k,2)=xx*xx1*xx2*xx3

          enddo
         enddo
        enddo

      return
      end
c**********************************************************************
      subroutine tablup(k1,k2,m,n,np,nx,nh,nt,sabs,spre,stem,w1,p1,
     *                  dwe,dpe,coef1,coef2,coef3,tran)
c**********************************************************************
c   compute water vapor, co2 and o3 transmittances between levels
c   k1 and k2 for m x n soundings, using table look-up.
c
c   calculations follow Eq. (40) of Chou and Suarez (1994)
c
c---- input ---------------------
c  indices for pressure levels (k1 and k2)
c  number of grid intervals in zonal direction (m)
c  number of grid intervals in meridional direction (n)
c  number of atmospheric layers (np)
c  number of pressure intervals in the table (nx)
c  number of absorber amount intervals in the table (nh)
c  number of tables copied (nt)
c  column-integrated absorber amount (sabs)
c  column absorber amount-weighted pressure (spre)
c  column absorber amount-weighted temperature (stem)
c  first value of absorber amount (log10) in the table (w1) 
c  first value of pressure (log10) in the table (p1) 
c  size of the interval of absorber amount (log10) in the table (dwe)
c  size of the interval of pressure (log10) in the table (dpe)
c  pre-computed coefficients (coef1, coef2, and coef3)
c
c---- updated ---------------------
c  transmittance (tran)
c
c  Note:
c   (1) units of sabs are g/cm**2 for water vapor and
c       (cm-atm)stp for co2 and o3.
c   (2) units of spre and stem are, respectively, mb and K.
c   (3) there are nt identical copies of the tables (coef1, coef2, and
c       coef3).  the prupose of using the multiple copies of tables is
c       to increase the speed in parallel (vectorized) computations.
C       if such advantage does not exist, nt can be set to 1.
c   
c**********************************************************************
      implicit none
      integer k1,k2,m,n,np,nx,nh,nt,i,j

c---- input parameters -----

      _RL w1,p1,dwe,dpe
      _RL sabs(m,n,np+1),spre(m,n,np+1),stem(m,n,np+1)
      _RL coef1(nx,nh,nt),coef2(nx,nh,nt),coef3(nx,nh,nt)

c---- update parameter -----

      _RL tran(m,n)

c---- temporary variables -----

      _RL x1,x2,x3,we,pe,fw,fp,pa,pb,pc,ax,ba,bb,t1,ca,cb,t2
      integer iw,ip,nn

c**********************************************************************

      do j=1,n
       do i=1,m

        nn=mod(i,nt)+1

        x1=sabs(i,j,k2)-sabs(i,j,k1)
        x2=(spre(i,j,k2)-spre(i,j,k1))/x1
        x3=(stem(i,j,k2)-stem(i,j,k1))/x1

        we=(log10(x1)-w1)/dwe
        pe=(log10(x2)-p1)/dpe

        we=max(we,w1-2.*dwe)
        pe=max(pe,p1)

        iw=int(we+1.5)
        ip=int(pe+1.5)

        iw=min(iw,nh-1)
        iw=max(iw, 2)

        ip=min(ip,nx-1)
        ip=max(ip, 1)

        fw=we-float(iw-1)
        fp=pe-float(ip-1)

c-----linear interpolation in pressure

        pa = coef1(ip,iw-1,nn)*(1.-fp)+coef1(ip+1,iw-1,nn)*fp
        pb = coef1(ip,iw,  nn)*(1.-fp)+coef1(ip+1,iw,  nn)*fp
        pc = coef1(ip,iw+1,nn)*(1.-fp)+coef1(ip+1,iw+1,nn)*fp

c-----quadratic interpolation in absorber amount for coef1

        ax = (-pa*(1.-fw)+pc*(1.+fw)) *fw*0.5 + pb*(1.-fw*fw)

c-----linear interpolation in absorber amount for coef2 and coef3

        ba = coef2(ip,iw,  nn)*(1.-fp)+coef2(ip+1,iw,  nn)*fp
        bb = coef2(ip,iw+1,nn)*(1.-fp)+coef2(ip+1,iw+1,nn)*fp
        t1 = ba*(1.-fw) + bb*fw

        ca = coef3(ip,iw,  nn)*(1.-fp)+coef3(ip+1,iw,  nn)*fp
        cb = coef3(ip,iw+1,nn)*(1.-fp)+coef3(ip+1,iw+1,nn)*fp
        t2 = ca*(1.-fw) + cb*fw

c-----update the total transmittance between levels k1 and k2

        tran(i,j)= (ax + (t1+t2*x3) * x3)*tran(i,j)

       enddo
      enddo

      return
      end
c**********************************************************************
      subroutine h2okdis(ib,m,n,np,k,fkw,gkw,ne,h2oexp,conexp,
     *                   th2o,tcon,tran)
c**********************************************************************
c   compute water vapor transmittance between levels k1 and k2 for
c   m x n soundings, using the k-distribution method.
c
c   computations follow eqs. (34), (46), (50) and (52).
c
c---- input parameters
c  spectral band (ib)
c  number of grid intervals in zonal direction (m)
c  number of grid intervals in meridional direction (n)
c  number of levels (np)
c  current level (k)
c  planck-weighted k-distribution function due to
c    h2o line absorption (fkw)
c  planck-weighted k-distribution function due to
c    h2o continuum absorption (gkw)
c  number of terms used in each band to compute water vapor
c     continuum transmittance (ne)
c  exponentials for line absorption (h2oexp) 
c  exponentials for continuum absorption (conexp) 
c
c---- updated parameters
c  transmittance between levels k1 and k2 due to
c    water vapor line absorption (th2o)
c  transmittance between levels k1 and k2 due to
c    water vapor continuum absorption (tcon)
c  total transmittance (tran)
c
c**********************************************************************
      implicit none
      integer ib,m,n,np,k,i,j

c---- input parameters ------

      _RL conexp(m,n,np,3),h2oexp(m,n,np,6)
      integer ne(9)
      _RL  fkw(6,9),gkw(6,3)

c---- updated parameters -----

      _RL th2o(m,n,6),tcon(m,n,3),tran(m,n)

c---- temporary arrays -----

      _RL trnth2o

c-----tco2 are the six exp factors between levels k1 and k2 
c     tran is the updated total transmittance between levels k1 and k2

c-----th2o is the 6 exp factors between levels k1 and k2 due to
c     h2o line absorption. 

c-----tcon is the 3 exp factors between levels k1 and k2 due to
c     h2o continuum absorption.

c-----trnth2o is the total transmittance between levels k1 and k2 due
c     to both line and continuum absorption computed from eq. (52).

         do j=1,n
          do i=1,m
           th2o(i,j,1) = th2o(i,j,1)*h2oexp(i,j,k,1)
           th2o(i,j,2) = th2o(i,j,2)*h2oexp(i,j,k,2)
           th2o(i,j,3) = th2o(i,j,3)*h2oexp(i,j,k,3)
           th2o(i,j,4) = th2o(i,j,4)*h2oexp(i,j,k,4)
           th2o(i,j,5) = th2o(i,j,5)*h2oexp(i,j,k,5)
           th2o(i,j,6) = th2o(i,j,6)*h2oexp(i,j,k,6)
          enddo
         enddo

      if (ne(ib).eq.0) then

         do j=1,n
          do i=1,m

           trnth2o      =(fkw(1,ib)*th2o(i,j,1)
     *                  + fkw(2,ib)*th2o(i,j,2)
     *                  + fkw(3,ib)*th2o(i,j,3)
     *                  + fkw(4,ib)*th2o(i,j,4)
     *                  + fkw(5,ib)*th2o(i,j,5)
     *                  + fkw(6,ib)*th2o(i,j,6))

          tran(i,j)=tran(i,j)*trnth2o

          enddo
         enddo

      elseif (ne(ib).eq.1) then

         do j=1,n
          do i=1,m

           tcon(i,j,1)= tcon(i,j,1)*conexp(i,j,k,1)

           trnth2o      =(fkw(1,ib)*th2o(i,j,1)
     *                  + fkw(2,ib)*th2o(i,j,2)
     *                  + fkw(3,ib)*th2o(i,j,3)
     *                  + fkw(4,ib)*th2o(i,j,4)
     *                  + fkw(5,ib)*th2o(i,j,5)
     *                  + fkw(6,ib)*th2o(i,j,6))*tcon(i,j,1)

          tran(i,j)=tran(i,j)*trnth2o

          enddo
         enddo

      else

         do j=1,n
          do i=1,m

           tcon(i,j,1)= tcon(i,j,1)*conexp(i,j,k,1)
           tcon(i,j,2)= tcon(i,j,2)*conexp(i,j,k,2)
           tcon(i,j,3)= tcon(i,j,3)*conexp(i,j,k,3)


           trnth2o      = (  gkw(1,1)*th2o(i,j,1)
     *                     + gkw(2,1)*th2o(i,j,2)
     *                     + gkw(3,1)*th2o(i,j,3)
     *                     + gkw(4,1)*th2o(i,j,4)
     *                     + gkw(5,1)*th2o(i,j,5)
     *                     + gkw(6,1)*th2o(i,j,6) ) * tcon(i,j,1)
     *                  + (  gkw(1,2)*th2o(i,j,1)
     *                     + gkw(2,2)*th2o(i,j,2)
     *                     + gkw(3,2)*th2o(i,j,3)
     *                     + gkw(4,2)*th2o(i,j,4)
     *                     + gkw(5,2)*th2o(i,j,5)
     *                     + gkw(6,2)*th2o(i,j,6) ) * tcon(i,j,2)
     *                  + (  gkw(1,3)*th2o(i,j,1)
     *                     + gkw(2,3)*th2o(i,j,2)
     *                     + gkw(3,3)*th2o(i,j,3)
     *                     + gkw(4,3)*th2o(i,j,4)
     *                     + gkw(5,3)*th2o(i,j,5)
     *                     + gkw(6,3)*th2o(i,j,6) ) * tcon(i,j,3)

          tran(i,j)=tran(i,j)*trnth2o

          enddo
         enddo

      endif

      return
      end
c**********************************************************************
      subroutine co2kdis(m,n,np,k,co2exp,tco2,tran)
c**********************************************************************
c   compute co2 transmittances between levels k1 and k2 for
c    m x n soundings, using the k-distribution method with linear
c    pressure scaling. computations follow eq. (34).
c
c---- input parameters
c   number of grid intervals in zonal direction (m)
c   number of grid intervals in meridional direction (n)
c   number of levels (np)
c   current level (k)
c   exponentials for co2 absorption (co2exp)
c
c---- updated parameters
c   transmittance between levels k1 and k2 due to co2 absorption
c     for the various values of the absorption coefficient (tco2)
c   total transmittance (tran)
c
c**********************************************************************
      implicit none
      integer m,n,np,k,i,j

c---- input parameters -----

      _RL co2exp(m,n,np,6,2)

c---- updated parameters -----

      _RL tco2(m,n,6,2),tran(m,n)

c---- temporary arrays -----

      _RL xc

c-----tco2 is the 6 exp factors between levels k1 and k2. 
c     xc is the total co2 transmittance given by eq. (53).

         do j=1,n
          do i=1,m

c-----band-wings

           tco2(i,j,1,1)=tco2(i,j,1,1)*co2exp(i,j,k,1,1)
           xc=   0.1395 *tco2(i,j,1,1)

           tco2(i,j,2,1)=tco2(i,j,2,1)*co2exp(i,j,k,2,1)
           xc=xc+0.1407 *tco2(i,j,2,1)

           tco2(i,j,3,1)=tco2(i,j,3,1)*co2exp(i,j,k,3,1)
           xc=xc+0.1549 *tco2(i,j,3,1)

           tco2(i,j,4,1)=tco2(i,j,4,1)*co2exp(i,j,k,4,1)
           xc=xc+0.1357 *tco2(i,j,4,1)

           tco2(i,j,5,1)=tco2(i,j,5,1)*co2exp(i,j,k,5,1)
           xc=xc+0.0182 *tco2(i,j,5,1)

           tco2(i,j,6,1)=tco2(i,j,6,1)*co2exp(i,j,k,6,1)
           xc=xc+0.0220 *tco2(i,j,6,1)

c-----band-center region

           tco2(i,j,1,2)=tco2(i,j,1,2)*co2exp(i,j,k,1,2)
           xc=xc+0.0766 *tco2(i,j,1,2)

           tco2(i,j,2,2)=tco2(i,j,2,2)*co2exp(i,j,k,2,2)
           xc=xc+0.1372 *tco2(i,j,2,2)

           tco2(i,j,3,2)=tco2(i,j,3,2)*co2exp(i,j,k,3,2)
           xc=xc+0.1189 *tco2(i,j,3,2)

           tco2(i,j,4,2)=tco2(i,j,4,2)*co2exp(i,j,k,4,2)
           xc=xc+0.0335 *tco2(i,j,4,2)

           tco2(i,j,5,2)=tco2(i,j,5,2)*co2exp(i,j,k,5,2)
           xc=xc+0.0169 *tco2(i,j,5,2)

           tco2(i,j,6,2)=tco2(i,j,6,2)*co2exp(i,j,k,6,2)
           xc=xc+0.0059 *tco2(i,j,6,2)

           tran(i,j)=tran(i,j)*xc

          enddo
         enddo

      return
      end
c**********************************************************************
      subroutine n2okdis(ib,m,n,np,k,n2oexp,tn2o,tran)
c**********************************************************************
c   compute n2o transmittances between levels k1 and k2 for
c    m x n soundings, using the k-distribution method with linear
c    pressure scaling.
c
c---- input parameters
c   spectral band (ib)
c   number of grid intervals in zonal direction (m)
c   number of grid intervals in meridional direction (n)
c   number of levels (np)
c   current level (k)
c   exponentials for n2o absorption (n2oexp)
c
c---- updated parameters
c   transmittance between levels k1 and k2 due to n2o absorption
c     for the various values of the absorption coefficient (tn2o)
c   total transmittance (tran)
c
c**********************************************************************
      implicit none
      integer ib,m,n,np,k,i,j

c---- input parameters -----

      _RL n2oexp(m,n,np,4)

c---- updated parameters -----

      _RL tn2o(m,n,4),tran(m,n)

c---- temporary arrays -----

      _RL xc

c-----tn2o is the 2 exp factors between levels k1 and k2. 
c     xc is the total n2o transmittance

        do j=1,n
         do i=1,m

c-----band 6

          if (ib.eq.6) then

           tn2o(i,j,1)=tn2o(i,j,1)*n2oexp(i,j,k,1)
           xc=   0.940414*tn2o(i,j,1)

           tn2o(i,j,2)=tn2o(i,j,2)*n2oexp(i,j,k,2)
           xc=xc+0.059586*tn2o(i,j,2)

c-----band 7

          else

           tn2o(i,j,1)=tn2o(i,j,1)*n2oexp(i,j,k,1)
           xc=   0.561961*tn2o(i,j,1)

           tn2o(i,j,2)=tn2o(i,j,2)*n2oexp(i,j,k,2)
           xc=xc+0.138707*tn2o(i,j,2)

           tn2o(i,j,3)=tn2o(i,j,3)*n2oexp(i,j,k,3)
           xc=xc+0.240670*tn2o(i,j,3)

           tn2o(i,j,4)=tn2o(i,j,4)*n2oexp(i,j,k,4)
           xc=xc+0.058662*tn2o(i,j,4)

          endif

           tran(i,j)=tran(i,j)*xc

         enddo
        enddo

      return
      end
c**********************************************************************
      subroutine ch4kdis(ib,m,n,np,k,ch4exp,tch4,tran)
c**********************************************************************
c   compute ch4 transmittances between levels k1 and k2 for
c    m x n soundings, using the k-distribution method with
c    linear pressure scaling.
c
c---- input parameters
c   spectral band (ib)
c   number of grid intervals in zonal direction (m)
c   number of grid intervals in meridional direction (n)
c   number of levels (np)
c   current level (k)
c   exponentials for ch4 absorption (ch4exp)
c
c---- updated parameters
c   transmittance between levels k1 and k2 due to ch4 absorption
c     for the various values of the absorption coefficient (tch4)
c   total transmittance (tran)
c
c**********************************************************************
      implicit none
      integer ib,m,n,np,k,i,j

c---- input parameters -----

      _RL ch4exp(m,n,np,4)

c---- updated parameters -----

      _RL tch4(m,n,4),tran(m,n)

c---- temporary arrays -----

      _RL xc

c-----tch4 is the 2 exp factors between levels k1 and k2. 
c     xc is the total ch4 transmittance

        do j=1,n
         do i=1,m

c-----band 6

          if (ib.eq.6) then

           tch4(i,j,1)=tch4(i,j,1)*ch4exp(i,j,k,1)
           xc= tch4(i,j,1)

c-----band 7

          else

           tch4(i,j,1)=tch4(i,j,1)*ch4exp(i,j,k,1)
           xc=   0.610650*tch4(i,j,1)

           tch4(i,j,2)=tch4(i,j,2)*ch4exp(i,j,k,2)
           xc=xc+0.280212*tch4(i,j,2)

           tch4(i,j,3)=tch4(i,j,3)*ch4exp(i,j,k,3)
           xc=xc+0.107349*tch4(i,j,3)

           tch4(i,j,4)=tch4(i,j,4)*ch4exp(i,j,k,4)
           xc=xc+0.001789*tch4(i,j,4)

          endif

           tran(i,j)=tran(i,j)*xc

         enddo
        enddo

      return
      end
c**********************************************************************
      subroutine comkdis(ib,m,n,np,k,comexp,tcom,tran)
c**********************************************************************
c  compute co2-minor transmittances between levels k1 and k2
c   for m x n soundings, using the k-distribution method
c   with linear pressure scaling.
c
c---- input parameters
c   spectral band (ib)
c   number of grid intervals in zonal direction (m)
c   number of grid intervals in meridional direction (n)
c   number of levels (np)
c   current level (k)
c   exponentials for co2-minor absorption (comexp)
c
c---- updated parameters
c   transmittance between levels k1 and k2 due to co2-minor absorption
c     for the various values of the absorption coefficient (tcom)
c   total transmittance (tran)
c
c**********************************************************************
      implicit none
      integer ib,m,n,np,k,i,j

c---- input parameters -----

      _RL comexp(m,n,np,2)

c---- updated parameters -----

      _RL tcom(m,n,2),tran(m,n)

c---- temporary arrays -----

      _RL xc

c-----tcom is the 2 exp factors between levels k1 and k2. 
c     xc is the total co2-minor transmittance

         do j=1,n
          do i=1,m

c-----band 4

           if (ib.eq.4) then

            tcom(i,j,1)=tcom(i,j,1)*comexp(i,j,k,1)
            xc=   0.972025*tcom(i,j,1)
            tcom(i,j,2)=tcom(i,j,2)*comexp(i,j,k,2)
            xc=xc+0.027975*tcom(i,j,2)

c-----band 5

           else

            tcom(i,j,1)=tcom(i,j,1)*comexp(i,j,k,1)
            xc=   0.961324*tcom(i,j,1)
            tcom(i,j,2)=tcom(i,j,2)*comexp(i,j,k,2)
            xc=xc+0.038676*tcom(i,j,2)

           endif

            tran(i,j)=tran(i,j)*xc

          enddo
         enddo

      return
      end
c**********************************************************************
      subroutine cfckdis(m,n,np,k,cfcexp,tcfc,tran)
c**********************************************************************
c  compute cfc-(11,12,22) transmittances between levels k1 and k2
c   for m x n soundings, using the k-distribution method with
c   linear pressure scaling.
c
c---- input parameters
c   number of grid intervals in zonal direction (m)
c   number of grid intervals in meridional direction (n)
c   number of levels (np)
c   current level (k)
c   exponentials for cfc absorption (cfcexp)
c
c---- updated parameters
c   transmittance between levels k1 and k2 due to cfc absorption
c     for the various values of the absorption coefficient (tcfc)
c   total transmittance (tran)
c
c**********************************************************************
      implicit none
      integer m,n,np,k,i,j

c---- input parameters -----

      _RL cfcexp(m,n,np)

c---- updated parameters -----

      _RL tcfc(m,n),tran(m,n)

c-----tcfc is the exp factors between levels k1 and k2. 

         do j=1,n
          do i=1,m

            tcfc(i,j)=tcfc(i,j)*cfcexp(i,j,k)
            tran(i,j)=tran(i,j)*tcfc(i,j)

          enddo
         enddo

      return
      end
c**********************************************************************
      subroutine b10kdis(m,n,np,k,h2oexp,conexp,co2exp,n2oexp
     *          ,th2o,tcon,tco2,tn2o,tran)
c**********************************************************************
c
c   compute h2o (line and continuum),co2,n2o transmittances between
c   levels k1 and k2 for m x n soundings, using the k-distribution
c   method with linear pressure scaling.
c
c---- input parameters
c   number of grid intervals in zonal direction (m)
c   number of grid intervals in meridional direction (n)
c   number of levels (np)
c   current level (k)
c   exponentials for h2o line absorption (h2oexp)
c   exponentials for h2o continuum absorption (conexp)
c   exponentials for co2 absorption (co2exp)
c   exponentials for n2o absorption (n2oexp)
c
c---- updated parameters
c   transmittance between levels k1 and k2 due to h2o line absorption
c     for the various values of the absorption coefficient (th2o)
c   transmittance between levels k1 and k2 due to h2o continuum
c     absorption for the various values of the absorption
c     coefficient (tcon)
c   transmittance between levels k1 and k2 due to co2 absorption
c     for the various values of the absorption coefficient (tco2)
c   transmittance between levels k1 and k2 due to n2o absorption
c     for the various values of the absorption coefficient (tn2o)
c   total transmittance (tran)
c
c**********************************************************************
      implicit none
      integer m,n,np,k,i,j

c---- input parameters -----

      _RL h2oexp(m,n,np,6),conexp(m,n,np,3),co2exp(m,n,np,6,2)
     *    ,n2oexp(m,n,np,4)

c---- updated parameters -----

      _RL th2o(m,n,6),tcon(m,n,3),tco2(m,n,6,2),tn2o(m,n,4)
     *    ,tran(m,n)

c---- temporary arrays -----

      _RL xx

c-----initialize tran

       do j=1,n
        do i=1,m
           tran(i,j)=1.0
        enddo
       enddo

c-----for h2o line

        do j=1,n
         do i=1,m

           th2o(i,j,1)=th2o(i,j,1)*h2oexp(i,j,k,1)
           xx=   0.3153*th2o(i,j,1)

           th2o(i,j,2)=th2o(i,j,2)*h2oexp(i,j,k,2)
           xx=xx+0.4604*th2o(i,j,2)

           th2o(i,j,3)=th2o(i,j,3)*h2oexp(i,j,k,3)
           xx=xx+0.1326*th2o(i,j,3)

           th2o(i,j,4)=th2o(i,j,4)*h2oexp(i,j,k,4)
           xx=xx+0.0798*th2o(i,j,4)

           th2o(i,j,5)=th2o(i,j,5)*h2oexp(i,j,k,5)
           xx=xx+0.0119*th2o(i,j,5)

           tran(i,j)=tran(i,j)*xx

         enddo
        enddo

c-----for h2o continuum

        do j=1,n
         do i=1,m

           tcon(i,j,1)=tcon(i,j,1)*conexp(i,j,k,1)
           tran(i,j)=tran(i,j)*tcon(i,j,1)

         enddo
        enddo
 
c-----for co2 

        do j=1,n
         do i=1,m

           tco2(i,j,1,1)=tco2(i,j,1,1)*co2exp(i,j,k,1,1)
           xx=    0.2673*tco2(i,j,1,1)

           tco2(i,j,2,1)=tco2(i,j,2,1)*co2exp(i,j,k,2,1)
           xx=xx+ 0.2201*tco2(i,j,2,1)

           tco2(i,j,3,1)=tco2(i,j,3,1)*co2exp(i,j,k,3,1)
           xx=xx+ 0.2106*tco2(i,j,3,1)

           tco2(i,j,4,1)=tco2(i,j,4,1)*co2exp(i,j,k,4,1)
           xx=xx+ 0.2409*tco2(i,j,4,1)

           tco2(i,j,5,1)=tco2(i,j,5,1)*co2exp(i,j,k,5,1)
           xx=xx+ 0.0196*tco2(i,j,5,1)

           tco2(i,j,6,1)=tco2(i,j,6,1)*co2exp(i,j,k,6,1)
           xx=xx+ 0.0415*tco2(i,j,6,1)

           tran(i,j)=tran(i,j)*xx

         enddo
        enddo

c-----for n2o

        do j=1,n
         do i=1,m

           tn2o(i,j,1)=tn2o(i,j,1)*n2oexp(i,j,k,1)
           xx=   0.970831*tn2o(i,j,1)

           tn2o(i,j,2)=tn2o(i,j,2)*n2oexp(i,j,k,2)
           xx=xx+0.029169*tn2o(i,j,2)

           tran(i,j)=tran(i,j)*(xx-1.0)

         enddo
        enddo

      return
      end

#include "GGL90_OPTIONS.h"

CBOP
C     !ROUTINE: GGL90_CALC_VISC

C     !INTERFACE:
      SUBROUTINE GGL90_CALC_VISC(
     I        bi, bj, iMin, iMax, jMin, jMax, k,
     U        KappaRU, KappaRV,
     I        myThid )

C     !DESCRIPTION:
C     *==========================================================*
C     | SUBROUTINE GGL90_CALC_VISC                               |
C     | o Add contribution to net viscosity from GGL90 mixing    |
C     *==========================================================*

C     !USES:
      IMPLICIT NONE
C     == GLobal variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
c#include "DYNVARS.h"
c#include "GRID.h"
#include "GGL90.h"

C     !INPUT/OUTPUT PARAMETERS:
C     bi, bj    :: current tile indices
C     iMin,iMax :: Range of points for which calculation is done
C     jMin,jMax :: Range of points for which calculation is done
C     k         :: current level index
C     KappaRU   :: vertical viscosity array for U-component
C     KappaRV   :: vertical viscosity array for V-component
C     myThid    :: my Thread Id number
      INTEGER bi, bj, iMin, iMax, jMin, jMax, k
      _RL KappaRU(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL KappaRV(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      INTEGER myThid

#ifdef ALLOW_GGL90
C     !LOCAL VARIABLES:
C     i, j      :: Loop counters
      INTEGER i, j
CEOP

      DO j=jMin,jMax
       DO i=iMin,iMax
        KappaRU(i,j,k) = KappaRU(i,j,k)
     &                 + ( GGL90viscArU(i,j,k,bi,bj) - viscArNr(k) )
       ENDDO
      ENDDO

      DO j=jMin,jMax
       DO i=iMin,iMax
        KappaRV(i,j,k) = KappaRV(i,j,k)
     &                 + ( GGL90viscArV(i,j,k,bi,bj) - viscArNr(k) )
       ENDDO
      ENDDO

#endif /* ALLOW_GGL90 */

      RETURN
      END

#include "COST_OPTIONS.h"
#ifdef ALLOW_CTRL
# include "CTRL_OPTIONS.h"
#endif

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C !ROUTINE: COST_FINAL

C !INTERFACE:
      SUBROUTINE COST_FINAL( myThid )

C     !DESCRIPTION:
C     Sum of all cost function contributions.

C     !USES:
      IMPLICIT NONE
C     == Global variables ===
#include "EEPARAMS.h"
#include "SIZE.h"
#include "PARAMS.h"

#include "cost.h"
#ifdef ALLOW_CTRL
# include "OPTIMCYCLE.h"
#endif
#ifdef ALLOW_DIC
# include "DIC_COST.h"
#endif
#if ( defined ALLOW_SHELFICE && defined ALLOW_COST_SHELFICE )
# include "SHELFICE_COST.h"
#endif
#ifdef ALLOW_PROFILES
# include "PROFILES_SIZE.h"
# include "profiles.h"
#endif
#ifdef ALLOW_OBSFIT
# include "OBSFIT_SIZE.h"
# include "OBSFIT.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     myThid ::  my Thread Id number
      INTEGER myThid
CEOP

#ifdef ALLOW_COST
C     !FUNCTIONS:
      LOGICAL  MASTER_CPU_THREAD
      EXTERNAL MASTER_CPU_THREAD

C     !LOCAL VARIABLES:
      INTEGER bi,bj
      _RL glob_fc, loc_fc
#ifndef ALLOW_CTRL
C     dummy parameter for this unlikely case
      INTEGER optimcycle
#endif
      INTEGER ifc
      INTEGER ioUnit
      CHARACTER*15 tile15c
      CHARACTER*17 cfname
      CHARACTER*(MAX_LEN_MBUF) msgBuf

      ioUnit = standardMessageUnit
      WRITE(msgBuf,'(A)')
     &  '// ======================================================='
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)') '// Start of S/R COST_FINAL'
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)')
     &  '// ======================================================='
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )

#ifndef ALLOW_CTRL
C     dummy value for this unlikely case
      optimcycle = 0
#endif

C     ifc = -1 means: do not write output to a file costfunction_${PKG}.XXXX
      ifc = -1
      IF ( MASTER_CPU_THREAD(myThid) .AND. costWriteCostFunction ) THEN
       CALL MDSFINDUNIT( ifc, myThid )
      ENDIF

C--   final cost from comparison-to-obs pkgs:
#ifdef ALLOW_PROFILES
      IF (usePROFILES)
     &     CALL PROFILES_COST_FINAL( ifc, optimcycle, myThid )
#endif
#ifdef ALLOW_OBSFIT
      IF (useOBSFIT) CALL OBSFIT_COST_FINAL( ifc, optimcycle, myThid )
#endif

C--   final cost from generic-cost pkg, i.e., pkg/ecco:
#ifdef ALLOW_ECCO
      IF (useECCO) CALL ECCO_COST_FINAL( ifc, optimcycle, myThid )
#endif

C--   final cost from control (Tikhonov regularisation), i.e., ctrl & obcs:
#ifdef ALLOW_CTRL
      IF (useCTRL) CALL CTRL_COST_FINAL( ifc, optimcycle, myThid )
#endif
#ifdef ALLOW_OBCS
      IF (useOBCS) CALL OBCS_COST_FINAL( ifc, optimcycle, myThid )
#endif

C--   final cost from remaining individual pkgs:
#ifdef ALLOW_THSICE
      IF (useThSIce) CALL THSICE_COST_FINAL( ifc, optimcycle, myThid )
#endif
#ifdef ALLOW_SEAICE
      IF (useSEAICE) CALL SEAICE_COST_FINAL( ifc, optimcycle, myThid )
#endif
#if ( defined ALLOW_SHELFICE && defined ALLOW_COST_SHELFICE )
      IF (useShelfIce)
     &     CALL SHELFICE_COST_FINAL( ifc, optimcycle, myThid )
#endif

#if ( defined ALLOW_STREAMICE && defined ALLOW_COST_STREAMICE )
      IF (useStreamice) CALL STREAMICE_COST_FINAL( myThid )
#endif

C--   final cost from customized/testing code:
# ifdef ALLOW_COST_TEST
      CALL COST_TEST( myThid )
# endif

# ifdef ALLOW_COST_ATLANTIC_HEAT
      CALL COST_ATLANTIC_HEAT( myThid )
# endif

#ifdef ALLOW_COST_HFLUXM
      CALL COST_HFLUX( myThid )
#endif

#ifdef ALLOW_COST_TEMP
      CALL COST_TEMP( myThid )
#endif

C--   final cost with alternative cost-function:
#ifdef ALLOW_COST_STATE_FINAL
      CALL COST_STATE_FINAL( myThid )
Cgf : effectively using this in adjoint requires the use of adjoint_state_final.
C     That will activate the objf_state_final vector in place of the fc scalar.
C     objf_state_final is therefore not added to fc.
#endif

#ifdef ALLOW_COST_VECTOR
Cgf : same idea as for ALLOW_COST_STATE_FINAL
      CALL COST_VECTOR( myThid )
#endif

      WRITE(msgBuf,'(A,1PE22.14)') '  early fc = ', fc
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )

C--   Sum up all other contributions.
      loc_fc = 0.
      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
        WRITE(tile15c,'(2(A,I3),A)') '(bi,bj=', bi, ',', bj, ')'

#ifdef ALLOW_COST_TEST
        WRITE(ioUnit,'(3A,1PE22.14,1X,1PE9.2)')
     &       ' --> objf_test     ', tile15c, ' =',
     &       objf_test(bi,bj), mult_test
#endif
#ifdef ALLOW_COST_TRACER
        WRITE(ioUnit,'(3A,1PE22.14,1X,1PE9.2)')
     &       ' --> objf_tracer   ', tile15c, ' =',
     &       objf_tracer(bi,bj), mult_tracer
#endif
#ifdef ALLOW_COST_ATLANTIC_HEAT
        WRITE(ioUnit,'(3A,1PE22.14,1X,1PE9.2)')
     &       ' --> objf_atl      ', tile15c, ' =',
     &       objf_atl(bi,bj), mult_atl
#endif
#ifdef ALLOW_COST_TEMP
        WRITE(ioUnit,'(3A,1PE22.14,1X,1PE9.2)')
     &       ' --> objf_temp_tut ', tile15c, ' =',
     &       objf_temp_tut(bi,bj), mult_temp_tut
#endif
#ifdef ALLOW_COST_HFLUXM
        WRITE(ioUnit,'(3A,1PE22.14,1X,1PE9.2)')
     &       ' --> objf_hflux_tut', tile15c, ' =',
     &       objf_hflux_tut(bi,bj), mult_hflux_tut
#endif

         tile_fc(bi,bj) = tile_fc(bi,bj)
#ifdef ALLOW_COST_TEST
     &            + mult_test   * objf_test(bi,bj)
#endif
#ifdef ALLOW_COST_TRACER
     &            + mult_tracer * objf_tracer(bi,bj)
#endif
#ifdef ALLOW_COST_ATLANTIC_HEAT
     &            + mult_atl    * objf_atl(bi,bj)
#endif
#ifdef ALLOW_COST_TEMP
     &            + mult_temp_tut  * objf_temp_tut(bi,bj)
#endif
#ifdef ALLOW_COST_HFLUXM
     &            + mult_hflux_tut * objf_hflux_tut(bi,bj)
#endif

         loc_fc = loc_fc + tile_fc(bi,bj)

       ENDDO
      ENDDO

      WRITE(msgBuf,'(A,1PE22.14)') '  local fc = ', loc_fc
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )

C--   Do global summation.
      CALL GLOBAL_SUM_TILE_RL( tile_fc, glob_fc, myThid )
      _BEGIN_MASTER( myThid )
      fc = fc + glob_fc

C--   Add contributions from global mean constraints (includes pkg/obsfit)
      fc = fc + glofc
      _END_MASTER( myThid )

#if ( defined ALLOW_DIC && defined ALLOW_DIC_COST )
Cph-- quickly for testing
      fc = totcost
#endif

      IF ( ifc .NE. -1 ) THEN
       WRITE(cfname,'(A,I4.4)') 'costfunction.',optimcycle
       WRITE(msgBuf,'(A,A)')
     &      'Writing global cost function info to ', cfname
       CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
       OPEN(UNIT=ifc,FILE=cfname)
       WRITE(ifc,'(A,1PE22.14)') 'fc =', fc
C     Collect and copy other cost function contributions in a separate
C     file to hide irreducible statements from TAF
       CALL COST_COPY_FILE( ifc, optimcycle, myThid )

       CLOSE(ifc)
C     Do not ever write this cost function again to cfname
       costWriteCostFunction = .FALSE.
      ENDIF

      WRITE(msgBuf,'(A,1PE22.14)') ' global fc = ', fc
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )

      WRITE(msgBuf,'(A)')
     &  '// ======================================================='
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)') '// End of S/R COST_FINAL'
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)')
     &  '// ======================================================='
      CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )

C--   to avoid re-write of output in reverse checkpointing loops,
C--   switch off output flag :
      CALL TURNOFF_MODEL_IO( 0, myThid )

#endif /* ALLOW_COST */

      RETURN
      END

#include "LONGSTEP_OPTIONS.h"
#ifdef ALLOW_GMREDI
# include "GMREDI_OPTIONS.h"
#endif

CBOP
C     !ROUTINE: LONGSTEP_AVERAGE
C     !INTERFACE:
      SUBROUTINE LONGSTEP_AVERAGE( myTime, myIter, myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE LONGSTEP_AVERAGE
C     | o Average variables needed for longstep
C     |   - myIter is used for determining the averaging interval
C     |     (LS_nIter timesteps, phase 0)
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     == Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "DYNVARS.h"
#include "FFIELDS.h"
#include "SURFACE.h"
#include "LONGSTEP_PARAMS.h"
#include "LONGSTEP.h"
#ifdef ALLOW_GMREDI
#include "GMREDI.h"
#endif
#ifdef ALLOW_KPP
#include "KPP.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     myTime     :: Current time in simulation
C     myIter     :: Current iteration number in simulation
C     myThid     :: my Thread Id number
      _RL     myTime
      INTEGER myIter
      INTEGER myThid

#ifdef ALLOW_LONGSTEP
C     !LOCAL VARIABLES:
C     == Local variables ==
CEOP

C     first iteration in a long time step? - reset averages
      IF ( MOD(myIter, LS_nIter) .EQ. 0 ) THEN

       CALL LONGSTEP_RESET_3D(LS_uVelCount, LS_uVel, Nr, myThid)
       CALL LONGSTEP_RESET_3D(LS_vVelCount, LS_vVel, Nr, myThid)
       CALL LONGSTEP_RESET_3D(LS_wVelCount, LS_wVel, Nr, myThid)
       CALL LONGSTEP_RESET_3D(LS_thetaCount,LS_theta,Nr, myThid)
       CALL LONGSTEP_RESET_3D(LS_saltCount, LS_salt, Nr, myThid)
       IF ( ivdc_kappa .NE. 0. _d 0 )
     &  CALL LONGSTEP_RESET_3D(LS_IVDConvCountCount,
     &                        LS_IVDConvCount, Nr, myThid)
#ifdef SHORTWAVE_HEATING
       CALL LONGSTEP_RESET_3D(LS_QswCount, LS_Qsw, 1, myThid)
#endif
       CALL LONGSTEP_RESET_3D(LS_fwFluxCount, LS_fwFlux, 1, myThid)
#ifdef ALLOW_GMREDI
       IF ( useGMRedi ) THEN
        CALL LONGSTEP_RESET_3D(LS_KwxCount, LS_Kwx, Nr, myThid)
        CALL LONGSTEP_RESET_3D(LS_KwyCount, LS_Kwy, Nr, myThid)
        CALL LONGSTEP_RESET_3D(LS_KwzCount, LS_Kwz, Nr, myThid)
        CALL LONGSTEP_RESET_3D(LS_KuxCount, LS_Kux, Nr, myThid)
        CALL LONGSTEP_RESET_3D(LS_KvyCount, LS_Kvy, Nr, myThid)
        IF ( GM_ExtraDiag ) THEN
         CALL LONGSTEP_RESET_3D(LS_KuzCount, LS_Kuz, Nr, myThid)
         CALL LONGSTEP_RESET_3D(LS_KvzCount, LS_Kvz, Nr, myThid)
        ENDIF
        IF ( GM_AdvForm ) THEN
         CALL LONGSTEP_RESET_3D(LS_PsiXCount, LS_PsiX, Nr, myThid)
         CALL LONGSTEP_RESET_3D(LS_PsiYCount, LS_PsiY, Nr, myThid)
        ENDIF
       ENDIF
#endif
#ifdef ALLOW_KPP
       IF ( useKPP ) THEN
        CALL LONGSTEP_RESET_3D(LS_KPPdiffKzSCount,
     &                         LS_KPPdiffKzS, Nr, myThid)
        CALL LONGSTEP_RESET_3D(LS_KPPghatCount,
     &                         LS_KPPghat, Nr, myThid)
       ENDIF
#endif

      ENDIF

C--   update average inside tile (no overlaps) for all bi,bj

      CALL LONGSTEP_FILL_3D_FAC(LS_uVelCount, LS_uVel, uVel, hFacW,
     &                          Nr, myThid)
      CALL LONGSTEP_FILL_3D_FAC(LS_vVelCount, LS_vVel, vVel, hFacS,
     &                          Nr, myThid)
      CALL LONGSTEP_FILL_3D(LS_wVelCount, LS_wVel, wVel, Nr, myThid)
      CALL LONGSTEP_FILL_3D(LS_thetaCount, LS_theta, theta, Nr, myThid)
      CALL LONGSTEP_FILL_3D(LS_saltCount, LS_salt, salt, Nr, myThid)
      IF ( ivdc_kappa .NE. 0. _d 0 )
     & CALL LONGSTEP_FILL_3D(LS_IVDConvCountCount,
     &                      LS_IVDConvCount, IVDConvCount, Nr, myThid)
#ifdef SHORTWAVE_HEATING
      CALL LONGSTEP_FILL_3D_RS(LS_QswCount, LS_Qsw, Qsw, 1, myThid)
#endif
      IF ( LS_usePmEpR ) THEN
       CALL LONGSTEP_FILL_3D(   LS_fwFluxCount,LS_fwFlux,PmEpR,1,myThid)
      ELSE
       CALL LONGSTEP_FILL_3D_RS(LS_fwFluxCount,LS_fwFlux,EmPmR,1,myThid)
      ENDIF
#ifdef ALLOW_GMREDI
      IF ( useGMRedi ) THEN
       CALL LONGSTEP_FILL_3D(LS_KwxCount, LS_Kwx, Kwx, Nr, myThid)
       CALL LONGSTEP_FILL_3D(LS_KwyCount, LS_Kwy, Kwy, Nr, myThid)
       CALL LONGSTEP_FILL_3D(LS_KwzCount, LS_Kwz, Kwz, Nr, myThid)
       CALL LONGSTEP_FILL_3D(LS_KuxCount, LS_Kux, Kux, Nr, myThid)
       CALL LONGSTEP_FILL_3D(LS_KvyCount, LS_Kvy, Kvy, Nr, myThid)
#ifdef GM_EXTRA_DIAGONAL
       IF ( GM_ExtraDiag ) THEN
        CALL LONGSTEP_FILL_3D(LS_KuzCount, LS_Kuz, Kuz, Nr, myThid)
        CALL LONGSTEP_FILL_3D(LS_KvzCount, LS_Kvz, Kvz, Nr, myThid)
       ENDIF
#endif
#ifdef GM_BOLUS_ADVEC
       IF ( GM_AdvForm ) THEN
        CALL LONGSTEP_FILL_3D(LS_PsiXCount, LS_PsiX, GM_PsiX,
     &                        Nr, myThid)
        CALL LONGSTEP_FILL_3D(LS_PsiYCount, LS_PsiY, GM_PsiY,
     &                        Nr, myThid)
       ENDIF
#endif
      ENDIF
#endif
#ifdef ALLOW_KPP
      IF ( useKPP ) THEN
       CALL LONGSTEP_FILL_3D(LS_KPPdiffKzSCount,
     &                       LS_KPPdiffKzS, KPPdiffKzS, Nr, myThid)
       CALL LONGSTEP_FILL_3D(LS_KPPghatCount,
     &                       LS_KPPghat, KPPghat, Nr, myThid)
      ENDIF
#endif

C     time for a ptracer time step? - finish average
      IF ( MOD(myIter, LS_nIter) .EQ. LS_nIter-1 ) THEN

       CALL LONGSTEP_AVERAGE_3D_FAC(LS_uVelCount, LS_uVel, hFacW,
     &                              Nr, myThid)
       CALL LONGSTEP_AVERAGE_3D_FAC(LS_vVelCount, LS_vVel, hFacS,
     &                              Nr, myThid)
       CALL LONGSTEP_AVERAGE_3D(LS_wVelCount, LS_wVel, Nr, myThid)
       CALL LONGSTEP_AVERAGE_3D(LS_thetaCount,LS_theta,Nr, myThid)
       CALL LONGSTEP_AVERAGE_3D(LS_saltCount, LS_salt, Nr, myThid)
       IF ( ivdc_kappa .NE. 0. _d 0 )
     &  CALL LONGSTEP_AVERAGE_3D(LS_IVDConvCountCount,
     &                        LS_IVDConvCount, Nr, myThid)
#ifdef SHORTWAVE_HEATING
       CALL LONGSTEP_AVERAGE_3D(LS_QswCount, LS_Qsw, 1, myThid)
#endif
       CALL LONGSTEP_AVERAGE_3D(LS_fwFluxCount, LS_fwFlux, 1, myThid)

#ifdef ALLOW_GMREDI
       IF ( useGMRedi ) THEN
        CALL LONGSTEP_AVERAGE_3D(LS_KwxCount, LS_Kwx, Nr, myThid)
        CALL LONGSTEP_AVERAGE_3D(LS_KwyCount, LS_Kwy, Nr, myThid)
        CALL LONGSTEP_AVERAGE_3D(LS_KwzCount, LS_Kwz, Nr, myThid)
        CALL LONGSTEP_AVERAGE_3D(LS_KuxCount, LS_Kux, Nr, myThid)
        CALL LONGSTEP_AVERAGE_3D(LS_KvyCount, LS_Kvy, Nr, myThid)
        IF ( GM_ExtraDiag ) THEN
         CALL LONGSTEP_AVERAGE_3D(LS_KuzCount, LS_Kuz, Nr, myThid)
         CALL LONGSTEP_AVERAGE_3D(LS_KvzCount, LS_Kvz, Nr, myThid)
        ENDIF
        IF ( GM_AdvForm ) THEN
         CALL LONGSTEP_AVERAGE_3D(LS_PsiXCount, LS_PsiX, Nr, myThid)
         CALL LONGSTEP_AVERAGE_3D(LS_PsiYCount, LS_PsiY, Nr, myThid)
        ENDIF
       ENDIF
#endif
#ifdef ALLOW_KPP
       IF ( useKPP ) THEN
        CALL LONGSTEP_AVERAGE_3D(LS_KPPdiffKzSCount,
     &                           LS_KPPdiffKzS, Nr, myThid)
        CALL LONGSTEP_AVERAGE_3D(LS_KPPghatCount,
     &                           LS_KPPghat, Nr, myThid)
       ENDIF
#endif

#if 0
C     and update overlaps
       CALL EXCH_UV_3D_RL( LS_uVel, LS_vVel, .TRUE., Nr, myThid )
       CALL EXCH_3D_RL( LS_wVel , Nr, myThid )
       CALL EXCH_3D_RL( LS_theta, Nr, myThid )
       CALL EXCH_3D_RL( LS_salt , Nr, myThid )
       IF ( ivdc_kappa .NE. 0. _d 0 )
     &  CALL EXCH_3D_RL( LS_IVDConvCount, myThid )
#ifdef SHORTWAVE_HEATING
       CALL EXCH_XY_RL( LS_Qsw, myThid )
#endif
       CALL EXCH_XY_RL( LS_fwFlux, myThid )
#ifdef ALLOW_GMREDI
       IF ( useGMRedi ) THEN
        CALL EXCH_UV_AGRID_3D_RL( LS_Kwx, LS_Kwy, .TRUE., Nr, myThid )
        CALL EXCH_3D_RL( LS_Kwz  , Nr, myThid )
        CALL EXCH_UV_3D_RL( LS_Kux, LS_Kvy, .FALSE., Nr, myThid )
        IF ( GM_ExtraDiag ) THEN
         CALL EXCH_UV_3D_RL( LS_Kuz, LS_Kvz, .TRUE., Nr, myThid )
        ENDIF
        IF ( GM_AdvForm ) THEN
         CALL EXCH_UV_3D_RL( LS_PsiX, LS_PsiY, .TRUE., Nr, myThid )
        ENDIF
       ENDIF
#endif
#ifdef ALLOW_KPP
       IF ( useKPP ) THEN
        CALL EXCH_3D_RL( LS_KPPdiffKzS, Nr, myThid )
        CALL EXCH_3D_RL( LS_KPPghat, Nr, myThid )
       ENDIF
#endif
#endif /* 0 */

#ifdef ALLOW_DIAGNOSTICS
       IF ( useDiagnostics ) THEN
        CALL DIAGNOSTICS_FILL(LS_uVel, 'LSuVel  ',0,Nr,0,1,1,myThid)
        CALL DIAGNOSTICS_FILL(LS_vVel, 'LSvVel  ',0,Nr,0,1,1,myThid)
        CALL DIAGNOSTICS_FILL(LS_wVel, 'LSwVel  ',0,Nr,0,1,1,myThid)
        CALL DIAGNOSTICS_FILL(LS_theta,'LStheta ',0,Nr,0,1,1,myThid)
        CALL DIAGNOSTICS_FILL(LS_salt, 'LSsalt  ',0,Nr,0,1,1,myThid)
        IF ( ivdc_kappa .NE. 0. _d 0 .AND. .NOT. useKPP )
     &   CALL DIAGNOSTICS_FILL(LS_IVDConvCount,
     &                                 'LScnvAdj',0,Nr,0,1,1,myThid)
#ifdef SHORTWAVE_HEATING
        CALL DIAGNOSTICS_FILL(LS_Qsw , 'LSqsw   ',0,1 ,0,1,1,myThid)
#endif
        CALL DIAGNOSTICS_FILL(LS_fwFlux, 'LSfwFlux',0,1 ,0,1,1,myThid)
#ifdef ALLOW_GMREDI
        IF ( useGMRedi ) THEN
         CALL DIAGNOSTICS_FILL(LS_Kwx , 'LSkwx   ',0,Nr,0,1,1,myThid)
         CALL DIAGNOSTICS_FILL(LS_Kwy , 'LSkwy   ',0,Nr,0,1,1,myThid)
         CALL DIAGNOSTICS_FILL(LS_Kwz , 'LSkwz   ',0,Nr,0,1,1,myThid)
         CALL DIAGNOSTICS_FILL(LS_Kux , 'LSkux   ',0,Nr,0,1,1,myThid)
         CALL DIAGNOSTICS_FILL(LS_Kvy , 'LSkvy   ',0,Nr,0,1,1,myThid)
         IF ( GM_ExtraDiag ) THEN
          CALL DIAGNOSTICS_FILL(LS_Kuz, 'LSkuz   ',0,Nr,0,1,1,myThid)
          CALL DIAGNOSTICS_FILL(LS_Kvz, 'LSkvz   ',0,Nr,0,1,1,myThid)
         ENDIF
         IF ( GM_AdvForm ) THEN
          CALL DIAGNOSTICS_FILL(LS_PsiX, 'LS_PsiX ',0,Nr,0,1,1,myThid)
          CALL DIAGNOSTICS_FILL(LS_PsiY, 'LS_PsiY ',0,Nr,0,1,1,myThid)
         ENDIF
        ENDIF
#endif
#ifdef ALLOW_KPP
        IF ( useKPP ) THEN
         CALL DIAGNOSTICS_FILL(LS_KPPdiffKzs,
     &                                 'LSKPPdfS',0,Nr,0,1,1,myThid)
         CALL DIAGNOSTICS_FILL(LS_KPPghat,
     &                                 'LSKPPght',0,Nr,0,1,1,myThid)
        ENDIF
#endif
C       if useDiagnostics: end
       ENDIF
#endif /* ALLOW_DIAGNOSTICS */

       _BARRIER
       _BEGIN_MASTER(myThid)
C      we decide whether to do a timestep here and everybody else just
C      checks this variable.  This avoids complications with
C      staggerTimeStep
       LS_doTimeStep = .TRUE.
       _END_MASTER(myThid)
       _BARRIER

      ELSEIF ( MOD(myIter, LS_nIter) .EQ. 0 ) THEN

C      next time-step: switch back LS_doTimeStep
       _BARRIER
       _BEGIN_MASTER(myThid)
       LS_doTimeStep = .FALSE.
       _END_MASTER(myThid)
       _BARRIER

C      if MOD(myIter, LS_nIter): end
      ENDIF

#endif /* ALLOW_LONGSTEP */

      RETURN
      END

#include "SEAICE_OPTIONS.h"
#include "AD_CONFIG.h"
#ifdef ALLOW_AUTODIFF
# include "AUTODIFF_OPTIONS.h"
#endif

CBOP
C     !ROUTINE: SEAICE_AD_DUMP
C     !INTERFACE:
      SUBROUTINE SEAICE_AD_DUMP( myTime, myIter, myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE seaice_ad_dump
C     *==========================================================*
C     Extract adjoint variable from TAF-generated
C     adjoint common blocks, contained in adcommon.h
C     and write fields to file;
C     Make sure common blocks in adcommon.h are up-to-date
C     w.r.t. current adjoint code.
C     *==========================================================*
C     | SUBROUTINE seaice_ad_dump
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     == Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "SEAICE_SIZE.h"
#include "SEAICE_PARAMS.h"
#ifdef ALLOW_MNC
#include "MNC_PARAMS.h"
#endif
#include "GRID.h"
#ifdef ALLOW_AUTODIFF_MONITOR
# include "AUTODIFF_PARAMS.h"
# include "AUTODIFF.h"
# include "adcommon.h"
# ifdef ALLOW_DIAGNOSTICS
#  include "DIAGNOSTICS_P2SHARE.h"
# endif
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     myTime :: time counter for this thread
C     myIter :: iteration counter for this thread
C     myThid :: Thread number for this instance of the routine.
      _RL     myTime
      INTEGER myIter
      INTEGER myThid

#if (defined (ALLOW_ADJOINT_RUN) || defined (ALLOW_ADMTLM))
#ifdef ALLOW_AUTODIFF_MONITOR

C     !FUNCTIONS:
      LOGICAL  DIFFERENT_MULTIPLE
      EXTERNAL DIFFERENT_MULTIPLE

C     !LOCAL VARIABLES:
C     == local variables ==
C     suff   :: Hold suffix part of a filename
C     msgBuf :: Error message buffer
c     CHARACTER*(10) suff
c     CHARACTER*(MAX_LEN_MBUF) msgBuf
#ifdef ALLOW_MNC
      _RL var2Du(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL var2Dv(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
#endif
      _RS dumRS(1)
      LOGICAL doExch
      LOGICAL doDump
CEOP

C--- do dump?
      doDump = DIFFERENT_MULTIPLE( adjDumpFreq, myTime, deltaTClock )

C--- Test for adexch based on dumpAdVarExch flag
      doExch = doDump
#ifdef ALLOW_DIAGNOSTICS
      doExch = doDump .OR. useDiag4AdjOutp
#endif
      doExch = doExch .AND. ( dumpAdVarExch.EQ.1 )

C--- If necessary, do the exchanges
      IF ( doExch ) THEN
        CALL TIMER_START('I/O (WRITE)        [ADJOINT LOOP]', myThid )
#ifdef ALLOW_OPENAD
C--   need to all the correct OpenAD EXCH S/R ; left empty for now
#else /* ALLOW_OPENAD */

# ifdef AUTODIFF_TAMC_COMPATIBILITY
        CALL ADEXCH_XY_RL( myThid, adarea )
        CALL ADEXCH_XY_RL( myThid, adheff )
        CALL ADEXCH_XY_RL( myThid, adhsnow )
        CALL ADEXCH_UV_XYZ_RL( .TRUE., myThid, aduice,advice )
# else
        CALL ADEXCH_XY_RL( adarea, myThid )
        CALL ADEXCH_XY_RL( adheff, myThid )
        CALL ADEXCH_XY_RL( adhsnow, myThid )
        CALL ADEXCH_UV_3D_RL( aduice,advice, .TRUE., 1, myThid )
# endif /* AUTODIFF_TAMC_COMPATIBILITY */
#endif /* ALLOW_OPENAD */
        ENDIF

C-----------------------------------------------------------------------
C--- Turn diagnostics on/off
C    <-- This has already been done in autodiff_inadmode_set_ad.F

C-----------------------------------------------------------------------
C--- do dump?
C-----------------------------------------------------------------------
      IF ( doDump ) THEN
c increment ad dump record number (used only if dumpAdByRec is true)
        dumpAdRecSi=dumpAdRecSi+1
        CALL TIMER_START('I/O (WRITE)        [ADJOINT LOOP]', myThid )
      ENDIF

C-----------------------------------------------------------------------
C--- Seaice state variables
C-----------------------------------------------------------------------
      CALL DUMP_ADJ_XY( dumRS, adarea, 'ADJarea ', 'ADJarea.',
     &     12, doDump, dumpAdRecSi, myTime, myIter, myThid )
      CALL DUMP_ADJ_XY( dumRS, adheff, 'ADJheff ', 'ADJheff.',
     &     12, doDump, dumpAdRecSi, myTime, myIter, myThid )
      CALL DUMP_ADJ_XY( dumRS, adhsnow, 'ADJhsnow', 'ADJhsnow.',
     &     12, doDump, dumpAdRecSi, myTime, myIter, myThid )
# if ( defined SEAICE_CGRID || defined SEAICE_BGRID_DYNAMICS )
C     IF (SEAICEuseDYNAMICS) THEN
      CALL DUMP_ADJ_XY_UV(
     &     dumRS, aduice, 'ADJuice ', 'ADJuice.',
     &     dumRS, advice, 'ADJvice ', 'ADJvice.',
     &     34, doDump, dumpAdRecSi, myTime, myIter, myThid)
C     ENDIF
# endif

      IF ( doDump ) THEN
#ifdef ALLOW_MNC
        IF (useMNC .AND. autodiff_mnc) THEN

         CALL MNC_CW_SET_UDIM('adseaice', -1, myThid)
         CALL MNC_CW_RL_W_S('D','adseaice',0,0,'T',myTime,myThid)
         CALL MNC_CW_SET_UDIM('adseaice', 0, myThid)
         CALL MNC_CW_I_W_S('I','adseaice',0,0,'iter',myIter,myThid)
         CALL MNC_CW_RL_W_S('D','adseaice',0,0,'model_time',myTime,
     &        myThid)
c
         IF (dumpAdVarExch.EQ.2) THEN
          CALL COPY_ADVAR_OUTP( dumRS, adarea, var2Du, 1 , 12, myThid )
          CALL MNC_CW_RL_W('D','adseaice',0,0,'adarea',
     &         var2Du, myThid)
          CALL COPY_ADVAR_OUTP( dumRS, adheff, var2Du, 1 , 12, myThid )
          CALL MNC_CW_RL_W('D','adseaice',0,0,'adheff',
     &         var2Du, myThid)
          CALL COPY_ADVAR_OUTP( dumRS, adhsnow, var2Du, 1 , 12, myThid )
          CALL MNC_CW_RL_W('D','adseaice',0,0,'adhsnow',
     &         var2Du, myThid)
# if ( defined SEAICE_CGRID || defined SEAICE_BGRID_DYNAMICS )
C          IF (SEAICEuseDYNAMICS) THEN
          CALL COPY_AD_UV_OUTP( dumRS, dumRS, aduice, advice,
     &         var2Du, var2Dv, 1, 34, myThid )
          CALL MNC_CW_RL_W('D','adseaice',0,0,'aduice',
     &         var2Du, myThid)
          CALL MNC_CW_RL_W('D','adseaice',0,0,'advice',
     &         var2Dv, myThid)
C          ENDIF
# endif
         ELSE
          CALL MNC_CW_RL_W('D','adseaice',0,0,'adarea',
     &         adarea, myThid)
          CALL MNC_CW_RL_W('D','adseaice',0,0,'adheff',
     &         adheff, myThid)
          CALL MNC_CW_RL_W('D','adseaice',0,0,'adhsnow',
     &         adhsnow, myThid)
# if ( defined SEAICE_CGRID || defined SEAICE_BGRID_DYNAMICS )
C          IF (SEAICEuseDYNAMICS) THEN
          CALL MNC_CW_RL_W('D','adseaice',0,0,'aduice',
     &         aduice, myThid)
          CALL MNC_CW_RL_W('D','adseaice',0,0,'advice',
     &         advice, myThid)
C          ENDIF
# endif
         ENDIF

        ENDIF
#endif /* ALLOW_MNC */

        CALL TIMER_STOP( 'I/O (WRITE)        [ADJOINT LOOP]', myThid )

      ENDIF

#endif /* ALLOW_AUTODIFF_MONITOR */
#endif /* ALLOW_ADJOINT_RUN */

      RETURN
      END

#include "CHEAPAML_OPTIONS.h"

CBOP
C     !ROUTINE: CHEAPAML_COPY_EDGES
C     !INTERFACE:
      SUBROUTINE CHEAPAML_COPY_EDGES(
     I                     xIsPeriodic, yIsPeriodic,
     I                     refFld,
     U                     trcFld,
     I                     bi, bj, myIter, myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R CHEAPAML_COPY_EDGES
C     | o If not periodic, copy Edges of reference array "refFld"
C     |   into current tracer field array "trcFld"
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     == Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine Arguments ==
C     xIsPeriodic :: periodic in X dir
C     yIsPeriodic :: periodic in Y dir
C     refFld      :: reference tracer field (copy from this field)
C     trcFld      :: current tracer field to update at the Edges
C     bi, bj      :: tile indices
C     myIter      :: current iteration number
C     myThid      :: my Thread Id number
      LOGICAL xIsPeriodic, yIsPeriodic
      _RL  refFld(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL  trcFld(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER bi, bj, myIter, myThid

C     !LOCAL VARIABLES:
C     == Local variables ==
      INTEGER i, j, iG, jG
CEOP

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

c     DO bj=myByLo(myThid),myByHi(myThid)
c      DO bi=myBxLo(myThid),myBxHi(myThid)

        IF (.NOT.xIsPeriodic) THEN
          iG = 1 + myXGlobalLo-1+(bi-1)*sNx
          IF (iG.EQ.1) THEN
            DO j=1-OLy,sNy+OLy
             DO i=1-OLx,1
               trcFld(i,j) = refFld(i,j)
             ENDDO
            ENDDO
          ENDIF
          iG = sNx + myXGlobalLo-1+(bi-1)*sNx
          IF (iG.GE.Nx) THEN
            DO j=1-OLy,sNy+OLy
             DO i=sNx,sNx+OLx
               trcFld(i,j) = refFld(i,j)
             ENDDO
            ENDDO
          ENDIF
        ENDIF

        IF (.NOT.yIsPeriodic) THEN
          jG = 1 + myYGlobalLo-1+(bj-1)*sNy
          IF (jG.EQ.1) THEN
            DO j=1-OLy,1
             DO i=1-OLx,sNx+OLx
               trcFld(i,j) = refFld(i,j)
             ENDDO
            ENDDO
          ENDIF
          jG = sNy + myYGlobalLo-1+(bj-1)*sNy
          IF (jG.GE.Ny) THEN
            DO j=sNy,sNy+OLy
             DO i=1-OLx,sNx+OLx
               trcFld(i,j) = refFld(i,j)
             ENDDO
            ENDDO
          ENDIF
        ENDIF

c      ENDDO
c     ENDDO

      RETURN
      END

#include "PACKAGES_CONFIG.h"
#include "CPP_OPTIONS.h"
#ifdef ALLOW_AUTODIFF
# include "AUTODIFF_OPTIONS.h"
#endif

C--  File seawater.F: routines that compute quantities related to seawater.
C--   Contents
C     Seawater (SW) librabry routines
C--   o SW_PTMP: function to compute potential temperature
C--   o SW_TEMP: function to compute in-situ temperature from pot. temp.
C--   o SW_ADTG: function to compute adiabatic temperature gradient
C--              (used by both SW_PTMP & SW_TEMP)
C     TEOS10 routines (renamed and modified from MOM6 implementation)
C--   o CONVERT_CT2PT: S/R to convert conservative to potential temperature
C--   o CONVERT_PT2CT: S/R to convert potential to conservative temperature
C--                    (used by CONVERT_CT2PT)

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

CBOP
C     !ROUTINE: SW_PTMP
C     !INTERFACE:
      _RL FUNCTION SW_PTMP  (S,T,P,PR)

C     !DESCRIPTION: \bv
C     *=============================================================*
C     | S/R  SW_PTMP
C     | o compute potential temperature as per UNESCO 1983 report.
C     *=============================================================*
C     \ev
C     started:
C              Armin Koehl akoehl@ucsd.edu
C
C     ==================================================================
C     SUBROUTINE SW_PTMP
C     ==================================================================
C     S  :: salinity    [         (PSS-78) ]
C     T  :: temperature [degree C (IPTS-68)]
C     P  :: pressure    [dbar]
C     PR :: Reference pressure  [dbar]
C     \ev

C     !USES:
      IMPLICIT NONE

C     !INPUT/OUTPUT PARAMETERS:
      _RL S,T,P,PR

C     !FUNCTIONS:
      _RL SW_ADTG
      EXTERNAL SW_ADTG

C     !LOCAL VARIABLES
      _RL del_P ,del_th, th, q
      _RL onehalf, two, three
      PARAMETER ( onehalf = 0.5 _d 0, two = 2. _d 0, three = 3. _d 0 )
CEOP

C theta1
      del_P  = PR - P
      del_th = del_P*SW_ADTG(S,T,P)
      th     = T + onehalf*del_th
      q      = del_th
C theta2
      del_th = del_P*SW_ADTG(S,th,P+onehalf*del_P)

      th     = th + (1 - 1/sqrt(two))*(del_th - q)
      q      = (two-sqrt(two))*del_th + (-two+three/sqrt(two))*q

C theta3
      del_th = del_P*SW_ADTG(S,th,P+onehalf*del_P)
      th     = th + (1 + 1/sqrt(two))*(del_th - q)
      q      = (two + sqrt(two))*del_th + (-two-three/sqrt(two))*q

C theta4
      del_th = del_P*SW_ADTG(S,th,P+del_P)
      SW_PTMP     = th + (del_th - two*q)/(two*three)

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

CBOP
C     !ROUTINE: SW_TEMP
C     !INTERFACE:
      _RL FUNCTION SW_TEMP( S, T, P, PR )
C     !DESCRIPTION: \bv
C     *=============================================================*
C     | S/R  SW_TEMP
C     | o compute in-situ temperature from potential temperature
C     *=============================================================*
C
C     REFERENCES:
C     Fofonoff, P. and Millard, R.C. Jr
C     Unesco 1983. Algorithms for computation of fundamental properties of
C     seawater, 1983. _Unesco Tech. Pap. in Mar. Sci._, No. 44, 53 pp.
C     Eqn.(31) p.39
C
C     Bryden, H. 1973.
C     New Polynomials for thermal expansion, adiabatic temperature gradient
C     and potential temperature of sea water.
C     DEEP-SEA RES., 1973, Vol20,401-408.
C     \ev

C     !USES:
      IMPLICIT NONE
C     === Global variables ===

C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
C     S      :: salinity
C     T      :: potential temperature
C     P      :: pressure
C     PR     :: reference pressure
      _RL  S, T, P, PR
CEOP

C     !FUNCTIONS:
      _RL SW_PTMP
      EXTERNAL SW_PTMP

      SW_TEMP = SW_PTMP (S,T,PR,P)

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

CBOP
C     !ROUTINE: SW_ADTG
C     !INTERFACE:
      _RL FUNCTION SW_ADTG  (S,T,P)

C     !DESCRIPTION: \bv
C     *=============================================================*
C     | S/R  SW_ADTG
C     | o compute adiabatic temperature gradient as per UNESCO 1983 routines.
C     *=============================================================*
C
C     started:
C              Armin Koehl akoehl@ucsd.edu
C     \ev

C     !USES:
      IMPLICIT NONE

C     !INPUT/OUTPUT PARAMETERS:
      _RL S,T,P

C     !LOCAL VARIABLES:
      _RL a0,a1,a2,a3,b0,b1,c0,c1,c2,c3,d0,d1,e0,e1,e2
      _RL sref
CEOP

      sref = 35. _d 0
      a0 =  3.5803 _d -5
      a1 = +8.5258 _d -6
      a2 = -6.836 _d -8
      a3 =  6.6228 _d -10

      b0 = +1.8932 _d -6
      b1 = -4.2393 _d -8

      c0 = +1.8741 _d -8
      c1 = -6.7795 _d -10
      c2 = +8.733 _d -12
      c3 = -5.4481 _d -14

      d0 = -1.1351 _d -10
      d1 =  2.7759 _d -12

      e0 = -4.6206 _d -13
      e1 = +1.8676 _d -14
      e2 = -2.1687 _d -16

      SW_ADTG =      a0 + (a1 + (a2 + a3*T)*T)*T
     &     + (b0 + b1*T)*(S-sref)
     &     + ( (c0 + (c1 + (c2 + c3*T)*T)*T) + (d0 + d1*T)*(S-sref) )*P
     &     + (  e0 + (e1 + e2*T)*T )*P*P

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

CBOP
C !ROUTINE: CONVERT_PT2CT

C !INTERFACE:
      SUBROUTINE CONVERT_PT2CT(
     I     Tp, Sa,
     O     Tc,
     I     myTime, myIter, myThid )
C     !DESCRIPTION:
C     Convert input potential temperature (degC) and absolute salinity
C     (g kg-1) to returned conservative temperature (degC) using the
C     polynomial expressions from TEOS-10.

C     !USES:
      IMPLICIT NONE
C     == Global variables ===
#include "SIZE.h"
#include "EOS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     Tc        :: Conservative temperature (degC)
C     Sa        :: Absolute salinity        (g kg-1)
C     T         :: potential temperature (degC)
C     myTime    :: Current time in simulation
C     myIter    :: Current iteration number
C     myThid    :: my Thread Id number
      _RL Tc(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL Sa(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL Tp(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL myTime
      INTEGER myIter, myThid
CEOP

C     !LOCAL VARIABLES:
      INTEGER i,j
C     Absolute salinity normalized by a plausible salinity range and its
C     square root (nondim)
      _RL x2, x
C
      _RL     zeRL
      PARAMETER ( zeRL = 0.0 _d 0 )

      DO j=1-OLy,sNy+OLy
       DO i=1-OLx,sNx+OLx
        x2 = MAX(I_S0 * Sa(i,j), zeRL)
#ifdef ALLOW_AUTODIFF
        x = 0. _d 0
        IF ( x2 .GT. 0. _d 0 ) x = SQRT(x2)
#else
        x = SQRT(x2)
#endif
        Tc(i,j) = H00 + (Tp(i,j)*(H01 + Tp(i,j)*(H02 +  Tp(i,j)*(H03
     &       +  Tp(i,j)*(H04  + Tp(i,j)*(H05
     &       + Tp(i,j)*(H06 + Tp(i,j)* H07))))))
     &       + x2*(H20 + (Tp(i,j)*(H21 +  Tp(i,j)*(H22  + Tp(i,j)*(H23
     &       + Tp(i,j)*(H24 + Tp(i,j)*(H25 + Tp(i,j)*H26)))))
     &       +  x*(H30 + (Tp(i,j)*(H31  + Tp(i,j)*(H32
     &       + Tp(i,j)*(H33 + Tp(i,j)* H34)))
     &       + x*(H40 + (Tp(i,j)*(H41 + Tp(i,j)*(H42 + Tp(i,j)*(H43
     &       + Tp(i,j)*(H44 + Tp(i,j)*H45))))
     &       + x*(H50 + x*(H60 + x* H70)) )) )) )) )
       ENDDO
      ENDDO

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

CBOP
C !ROUTINE: CONVERT_CT2PT

C !INTERFACE:
      SUBROUTINE CONVERT_CT2PT(
     I         Tc, Sa,
     O         Tp,
     I         myTime, myIter, myThid )

C     !DESCRIPTION:
C     Convert input conservative (degC) and absolute salinity
C     (g kg-1) to returned potential temperature (degC) by inverting
C     the polynomial expressions from TEOS-10.

C     !USES:
      IMPLICIT NONE
C     == Global variables ===
#include "SIZE.h"
#include "EOS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     Tc        :: Conservative temperature (degC)
C     Sa        :: Absolute salinity        (g kg-1)
C     Tp        :: potential temperature (degC)
C     bi,bj     :: Current tile indices
C     myTime    :: Current time in simulation
C     myIter    :: Current iteration number
C     myThid    :: my Thread Id number
      _RL Tc(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL Sa(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL Tp(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL myTime
      INTEGER myIter, myThid
CEOP

C     !LOCAL VARIABLES:
      INTEGER i,j
C     The numerator of a simple expression for potential temperature (degC)
      _RL Tp_num
C     The inverse of the denominator of a simple expression for
C     potential temperature (nondim)
      _RL I_Tp_den
C     The difference between an estimate of conservative temperature and
C     its target (degC)
      _RL Tc_diff(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
C     A previous estimate of the potential tempearture (degC)
      _RL Tp_old(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
C     The partial derivative of potential temperature with conservative
C     temperature and inverse (nondim)
      _RL dTp_dTc(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL dTc_dTp
C     Absolute salinity normalized by a plausible salinity range and its
C     square root (nondim)
      _RL x2, x
C     intermediate temperature (degC)
      _RL Tmp
C
      _RL     zeRL
      PARAMETER ( zeRL = 0.0 _d 0 )

      DO j=1-OLy,sNy+OLy
       DO i=1-OLx,sNx+OLx
        Tp_num = TPN00 + (Sa(i,j)*(TPN10 + TPN20*Sa(i,j))
     &       + Tc(i,j)*(TPN01 + (TPN11*Sa(i,j) + TPN02*Tc(i,j))))
        I_Tp_den = 1.0 _d 0 / (1.0 _d 0
     &       + (TPD10*Sa(i,j) + Tc(i,j)*(TPD01 + TPD02*Tc(i,j))))
        Tp(i,j) = Tp_num*I_Tp_den
        dTp_dTc(i,j) = ((TPN01 + (TPN11*Sa(i,j) + 2.*TPN02*Tc(i,j)))
     &       - (TPD01 + 2.*TPD02*Tc(i,j))*Tp(i,j))*I_Tp_den
       ENDDO
      ENDDO

C--   Start the 1.5 iterations through the modified Newton-Raphson
C     iterative method, which is also known as the Newton-McDougall
C     method.  In this case 1.5 iterations converge to 64-bit machine
C     precision for oceanographically relevant temperatures and
C     salinities.
      CALL CONVERT_PT2CT (
     I     Tp, Sa,
     O     Tc_diff,
     I     myTime, myIter, myThid )
      DO j=1-OLy,sNy+OLy
       DO i=1-OLx,sNx+OLx
        Tc_diff(i,j) = Tc_diff(i,j) - Tc(i,j)
        Tp_old(i,j) = Tp(i,j)
#ifdef ALLOW_AUTODIFF
       ENDDO
      ENDDO
# ifdef ALLOW_AUTODIFF_TAMC
CADJ INIT loctape_cp2ct = COMMON, 1
CADJ STORE Tc_diff = loctape_cp2ct
CADJ STORE dTp_dTc = loctape_cp2ct
# endif
      DO j=1-OLy,sNy+OLy
       DO i=1-OLx,sNx+OLx
#endif
        Tp(i,j) = Tp_old(i,j) - Tc_diff(i,j)*dTp_dTc(i,j)
C--   Estimate the potential temperature and its derivative from an C
C     approximate rational function fit.
        x2 = MAX(I_S0 * Sa(i,j), zeRL)
#ifdef ALLOW_AUTODIFF
        x = 0. _d 0
        IF ( x2 .GT. 0. _d 0 ) x = SQRT(x2)
#else
        x = SQRT(x2)
#endif
        Tmp = 0.5 _d 0 *(Tp(i,j) + Tp_old(i,j))
        dTc_dTp = (     H01 + Tmp*(2.*H02 + Tmp*(3.*H03 + Tmp*(4.*H04
     &       + Tmp*(5.*H05 + Tmp*(6.*H06 + Tmp*(7.*H07)))))) )
     &       + x2*(     (H21 + Tmp*(2.*H22 + Tmp*(3.*H23 + Tmp*(4.*H24
     &       + Tmp*(5.*H25 + Tmp*(6.*H26))))))
     &       +  x*(  (H31 + Tmp*(2.*H32 + Tmp*(3.*H33 + Tmp*(4.*H34))))
     &       + x*(H41 + Tmp*(2.*H42 + Tmp*(3.*H43
     &       + Tmp*(4.*H44 + Tmp*(5.*H45))))) ) )
        dTp_dTc(i,j) = 1. _d 0 / dTc_dTp
#ifdef ALLOW_AUTODIFF
       ENDDO
      ENDDO
# ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE dTp_dTc = loctape_cp2ct
# endif
      DO j=1-OLy,sNy+OLy
       DO i=1-OLx,sNx+OLx
#endif
        Tp(i,j) = Tp_old(i,j) - Tc_diff(i,j)*dTp_dTc(i,j)
       ENDDO
      ENDDO
      CALL CONVERT_PT2CT (
     I     Tp, Sa,
     O     Tc_diff,
     I     myTime, myIter, myThid )
      DO j=1-OLy,sNy+OLy
       DO i=1-OLx,sNx+OLx
        Tc_diff(i,j) = Tc_diff(i,j) - Tc(i,j)
        Tp(i,j) = Tp(i,j) - Tc_diff(i,j)*dTp_dTc(i,j)
       ENDDO
      ENDDO

      RETURN
      END

#include "DEBUG_OPTIONS.h"

      SUBROUTINE CHKSUM_TILED( str,fld,NN,bi,bj,myThid )
      IMPLICIT NONE
C     Global/common
#include "SIZE.h"
#include "EEPARAMS.h"
C     Routines arguments
      CHARACTER*(*) str
      INTEGER NN,bi,bj,myThid
      _RL fld(1-OLx:sNx+OLx,1-OLy:sNy+OLy,NN,nSx,nSy)
C     Local
      INTEGER I,J,K
      INTEGER cnt
      _RL Fmn,Fmin,Fmax,Frms

      Fmn=0.
      Frms=0.
      Fmin=fld(1,1,1,bi,bj)
      Fmax=fld(1,1,1,bi,bj)
      cnt=0
      DO K=1,NN
       DO J=1,sNy
        DO I=1,sNx
         Fmin=min(Fmin,fld(I,J,K,bi,bj))
         Fmax=max(Fmax,fld(I,J,K,bi,bj))
         Fmn=Fmn+fld(I,J,K,bi,bj)
         cnt=cnt+1
        ENDDO
       ENDDO
      ENDDO
      Fmn=Fmn/float(cnt)
      DO K=1,NN
       DO J=1,sNy
        DO I=1,sNx
         Frms=Frms+(fld(I,J,K,bi,bj)-Fmn)**2
        ENDDO
       ENDDO
      ENDDO
      Frms=sqrt(Frms/float(cnt))

      write(*,'(a,1p4e12.5,1x,a)')
     &      'CHKSUM_TILED: ',Fmin,Fmax,Fmn,Frms,str

      RETURN
      END

#include "MOM_COMMON_OPTIONS.h"

CBOP
C !ROUTINE: MOM_W_METRIC_NH

C !INTERFACE: ==========================================================
      SUBROUTINE MOM_W_METRIC_NH(
     I               bi,bj,k,
     I               uFld, vFld,
     O               wMetricTerms,
     I               myThid )

C !DESCRIPTION:
C Calculates the vertical metric term due to non-hydrostaticity on the sphere:
C \begin{equation}
C + \frac{1}{a} \overline{ \overline{u^2}^{i} + \overline{v^2}^{j} }^{k}
C \end{equation}

C !USES: ===============================================================
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"

C !INPUT PARAMETERS: ===================================================
C  bi,bj                :: tile indices
C  k                    :: vertical level
C  uFld                 :: zonal flow
C  vFld                 :: meridional flow
C  myThid               :: my Thread Id number
      INTEGER bi,bj,k
      _RL uFld(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      _RL vFld(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      INTEGER myThid

C !OUTPUT PARAMETERS: ==================================================
C  wMetricTerms         :: metric term
      _RL wMetricTerms(1-OLx:sNx+OLx,1-OLy:sNy+OLy)

#ifdef ALLOW_NONHYDROSTATIC
C !LOCAL VARIABLES: ====================================================
C  i,j                  :: loop indices
      INTEGER i,j
CEOP

      IF ( k.GT.1 .AND. k.LE.Nr ) THEN
        DO j=1-Olx,sNy+Oly-1
         DO i=1-Olx,sNx+Olx-1
           wMetricTerms(i,j) = -gravitySign*wUnit2rVel(k)
     &      *recip_rSphere*recip_deepFacF(k)*(
     &          ( (uFld( i ,j,k-1,bi,bj)*uFld( i ,j,k-1,bi,bj)
     &            +uFld(i+1,j,k-1,bi,bj)*uFld(i+1,j,k-1,bi,bj))
     &          + (vFld(i, j ,k-1,bi,bj)*vFld(i, j ,k-1,bi,bj)
     &            +vFld(i,j+1,k-1,bi,bj)*vFld(i,j+1,k-1,bi,bj))
     &          )
     &        + ( (uFld( i ,j, k ,bi,bj)*uFld( i ,j, k ,bi,bj)
     &            +uFld(i+1,j, k ,bi,bj)*uFld(i+1,j, k ,bi,bj))
     &          + (vFld(i, j , k ,bi,bj)*vFld(i, j , k ,bi,bj)
     &            +vFld(i,j+1, k ,bi,bj)*vFld(i,j+1, k ,bi,bj))
     &          )                            )*0.25 _d 0
         ENDDO
        ENDDO
      ELSE
        DO j=1-Olx,sNy+Oly-1
         DO i=1-Olx,sNx+Olx-1
           wMetricTerms(i,j) = 0. _d 0
         ENDDO
        ENDDO
      ENDIF

#endif /* ALLOW_NONHYDROSTATIC */

      RETURN
      END

#include "CPP_OPTIONS.h"

CBOP
C     !ROUTINE: FIND_HYD_PRESS_1D
C     !INTERFACE:
      SUBROUTINE FIND_HYD_PRESS_1D(
     O                    pCen, pInt,
     U                    rhoCen,
     I                    tCen, sCen, maxResid,
     I                    belowCritNb, maxIterNb, myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R FIND_HYD_PRESS_1D
C     | o Over one column, find pressure in hydrostatic balance
C     |   with updated density (which is function of pressure)
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     == Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"

C     !INPUT/OUTPUT PARAMETERS:
C     pCen      :: Pressure vertical profile at grid-cell center
C     pInt      :: Pressure vertical profile at grid-cell interface
C     rhoCen    :: Density vertical profile
C     tCen      :: Potential temperature vertical profile
C     sCen      :: Salinity/water-vapor vertical profile
C     maxResid  :: Maximum density difference criteria
C   belowCritNb :: Required number of consecutive iter below maxResid
C     maxIterNb :: Maximum number of iterations to perform
C     myThid    :: my Thread Id number
      _RL     pCen(Nr), pInt(Nr+1)
      _RL     rhoCen(Nr)
      _RL     tCen(Nr), sCen(Nr)
      _RL     maxResid
      INTEGER belowCritNb, maxIterNb
      INTEGER myThid

C     !LOCAL VARIABLES:
C     msgBuf     :: Informational/error message buffer
C     k, n       :: loop counter
C     nIter      :: iteration counter
C     nUnderCrit :: count number of iter below density Diff Criteria
C     searchForP :: Continue to iterate/search for P(rho(P))
C     rhoLoc     :: new density profile (computed using new Pres)
C     diffMax    :: Maximum density difference (new minus previous)
C     diffRMS    :: Root Mean Squared density difference
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      INTEGER k, n
      INTEGER nIter, nUnderCrit
      LOGICAL searchForP
      _RL     rhoLoc(Nr)
      _RL     dRlocM, dRlocP, dRho
      _RL     diffMax, diffRMS
CEOP

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      WRITE(msgBuf,'(A)') ' '
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(2A,I5,A)') 'FIND_HYD_PRESS_1D: ',
     &  'Start to iterate (MaxIter=', maxIterNb,
     &   ' ) until P(rho(P))'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(2A,I3,A,1PE13.6)') 'FIND_HYD_PRESS_1D: ',
     &   ' converges ; critera (x', belowCritNb,
     &   ') on Rho diff=', maxResid
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )

      pInt(1)  = top_Pres
      searchForP = .TRUE.
      nUnderCrit = 0
      DO n=1,maxIterNb
       IF ( searchForP ) THEN
        nIter = n

C--   Integrate Hydrostatic pressure
        IF ( integr_GeoPot.EQ.1 ) THEN
         DO k=1,Nr
          pCen(k)   = pInt(k)
     &              + rhoCen(k)*gravity*gravFacC(k)*drF(k)*halfRL
          pInt(k+1) = pInt(k)
     &              + rhoCen(k)*gravity*gravFacC(k)*drF(k)
         ENDDO
        ELSE
         DO k=1,Nr
          dRlocM = halfRL*drC(k)
          dRlocP = halfRL*drC(k+1)
          IF (k.EQ.1)  dRlocM = drC(k)
          IF (k.EQ.Nr) dRlocP = drC(k+1)
          pCen(k)   = pInt(k)
     &              + rhoCen(k)*gravity*gravFacF(k)*dRlocM
          pInt(k+1) = pCen(k)
     &              + rhoCen(k)*gravity*gravFacF(k+1)*dRlocP
         ENDDO
        ENDIF

C--   Compute new density
        DO k=1,Nr
          CALL FIND_RHO_SCALAR(
     I                          tCen(k), sCen(k), pCen(k),
     O                          rhoLoc(k), myThid )
        ENDDO

C--   Test for convergence:
        diffRMS = 0.
        diffMax = 0.
        DO k=1,Nr
          dRho = rhoLoc(k)-rhoCen(k)
          IF ( ABS(dRho) .GT. ABS(diffMax) ) diffMax = dRho
          diffRMS = diffRMS + dRho*dRho
        ENDDO
        diffRMS = diffRMS/DFLOAT(Nr)
        IF ( diffRMS.GT.0. ) diffRMS = SQRT(diffRMS)
        IF ( ABS(diffMax).LE.maxResid ) THEN
          nUnderCrit = nUnderCrit + 1
        ELSE
          nUnderCrit = 0
        ENDIF
C-    Double criteria: stop if perfect convergence or if below
C      criteria for at least "belowCritNb" iterations
        searchForP = ( nUnderCrit.LT.belowCritNb )
     &         .AND. ( diffMax.NE.zeroRL )

        IF ( debugLevel.GE.debLevB ) THEN
         WRITE(msgBuf,'(A,I5,2(A,1PE20.12))')
     &    ' iter', nIter,', RMS-diff=', diffRMS,', Max-diff=', diffMax
         CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                       SQUEEZE_RIGHT, myThid )
        ENDIF

        IF ( searchForP .AND. nIter.LT.maxIterNb ) THEN
C--   Update rhoCen for new iteration
         DO k=1,Nr
          rhoCen(k) = rhoLoc(k)
         ENDDO
        ENDIF

       ENDIF
      ENDDO

      IF ( searchForP ) THEN
        WRITE(msgBuf,'(2A,I5,A,I3,A)') 'FIND_HYD_PRESS_1D: ',
     &    'No convergence after', nIter,
     &    ' iters (nUnderCrit=', nUnderCrit, ' )'
        CALL PRINT_ERROR( msgBuf, myThid )
        STOP 'ABNORMAL END: S/R FIND_HYD_PRESS_1D'
      ELSE
        WRITE(msgBuf,'(2A,I5,A,I3,A)') 'FIND_HYD_PRESS_1D: ',
     &    'converged after', nIter,
     &    ' iters (nUnderCrit=', nUnderCrit, ' )'
        CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
C--   Update rhoCen with new solution
        DO k=1,Nr
          rhoCen(k) = rhoLoc(k)
        ENDDO
      ENDIF

      RETURN
      END

#include "PACKAGES_CONFIG.h"
#include "CPP_OPTIONS.h"
#ifdef ALLOW_AUTODIFF
# include "AUTODIFF_OPTIONS.h"
#endif
#ifdef ALLOW_CTRL
# include "CTRL_OPTIONS.h"
#endif

C--  File update_masks_etc.F:
C--   Contents
C--   o S/R UPDATE_MASKS_ETC
C--   o FCT SMOOTHMIN_RS( a, b )
C--   o FCT SMOOTHMIN_RL( a, b )
C--   o FCT SMOOTHABS_RS( x )
C--   o FCT SMOOTHABS_RL( x )
Cml   o S/R LIMIT_HFACC_TO_ONE
Cml   o S/R ADLIMIT_HFACC_TO_ONE

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: UPDATE_MASKS_ETC
C     !INTERFACE:
      SUBROUTINE UPDATE_MASKS_ETC( myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE UPDATE_MASKS_ETC
C     | o Re-initialise masks and topography factors after a new
C     |   hFacC has been calculated by the minimizer
C     *==========================================================*
C     | These arrays are used throughout the code and describe
C     | the topography of the domain through masks (0s and 1s)
C     | and fractional height factors (0<hFac<1). The latter
C     | distinguish between the lopped-cell and full-step
C     | topographic representations.
C     *==========================================================*
C     | code taken from ini_masks_etc.F
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "SURFACE.h"
Cml we need optimcycle for storing the new hFaC(C/W/S) and depth
#ifdef ALLOW_AUTODIFF
# include "OPTIMCYCLE.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     myThid -  Number of this instance of INI_MASKS_ETC
      INTEGER myThid

#ifdef ALLOW_DEPTH_CONTROL
C     !FUNCTIONS:
      _RS SMOOTHMIN_RS
      EXTERNAL SMOOTHMIN_RS

C     !LOCAL VARIABLES:
C     == Local variables ==
C     bi,bj   :: Loop counters
C     I,J,K
C     tmpfld  :: Temporary array used to compute & write Total Depth
      INTEGER bi, bj
      INTEGER I, J, K
      _RS tmpfld(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      CHARACTER*(MAX_LEN_MBUF) suff
Cml(
      INTEGER Im1, Jm1
      _RL hFacCtmp
Cml   _RL hFacCtmp2
      _RL hFacMnSz
Cml)
CEOP

C- Calculate lopping factor hFacC : over-estimate the part inside of the domain
C    taking into account the lower_R Boundary (Bathymetrie / Top of Atmos)
      DO bj=myByLo(myThid), myByHi(myThid)
       DO bi=myBxLo(myThid), myBxHi(myThid)
        DO K=1, Nr
         hFacMnSz=max( hFacMin, min(hFacMinDr*recip_drF(k),1. _d 0) )
         DO J=1-OLy,sNy+OLy
          DO I=1-OLx,sNx+OLx
C      o Non-dimensional distance between grid bound. and domain lower_R bound.
           hFacCtmp = ( rF(K) - xx_r_low(I,J,bi,bj) )*recip_drF(K)
Cml           IF ( hFacCtmp .LE. 0. _d 0 ) THEN
CmlC           IF ( hFacCtmp .LT. 0.5*hfacMnSz ) THEN
Cml            hFacCtmp2 = 0. _d 0
Cml           ELSE
Cml            hFacCtmp2 = hFacCtmp + hFacMnSz*(
Cml     &           EXP(-hFacCtmp/hFacMnSz)-EXP(-1./hFacMnSz) )
Cml           ENDIF
Cml           CALL limit_hfacc_to_one( hFacCtmp2 )
Cml           hFacC(I,J,K,bi,bj) = hFacCtmp2
           IF ( hFacCtmp .LE. 0. _d 0 ) THEN
C           IF ( hFacCtmp .LT. 0.5*hfacMnSz ) THEN
            hFacC(I,J,K,bi,bj) = 0. _d 0
           ELSEIF ( hFacCtmp .GT. 1. _d 0 ) THEN
            hFacC(I,J,K,bi,bj) = 1. _d 0
           ELSE
            hFacC(I,J,K,bi,bj) = hFacCtmp + hFacMnSz*(
     &           EXP(-hFacCtmp/hFacMnSz)-EXP(-1./hFacMnSz) )
           ENDIF
Cml           print '(A,3I5,F20.16)', 'ml-hfac:', I,J,K,hFacC(I,J,K,bi,bj)
CmlC      o Select between, closed, open or partial (0,1,0-1)
Cml            hFacCtmp=min( max( hFacCtmp, 0. _d 0) , 1. _d 0)
CmlC      o Impose minimum fraction and/or size (dimensional)
Cml            IF (hFacCtmp.LT.hFacMnSz) THEN
Cml             IF (hFacCtmp.LT.hFacMnSz*0.5) THEN
Cml              hFacC(I,J,K,bi,bj)=0.
Cml             ELSE
Cml              hFacC(I,J,K,bi,bj)=hFacMnSz
Cml             ENDIF
Cml            ELSE
Cml             hFacC(I,J,K,bi,bj)=hFacCtmp
Cml            ENDIF
Cml           ENDIF
Cml           print '(A,F15.4,F20.16)', 'ml-hfac:', R_low(i,j,bi,bj),hFacC(I,J,K,bi,bj)
          ENDDO
         ENDDO
        ENDDO
C - end bi,bj loops.
       ENDDO
      ENDDO

C      _EXCH_XYZ_RS(hFacC,myThid)

C-  Re-calculate lower-R Boundary position, taking into account hFacC
      DO bj=myByLo(myThid), myByHi(myThid)
       DO bi=myBxLo(myThid), myBxHi(myThid)
        DO J=1-OLy,sNy+OLy
         DO I=1-OLx,sNx+OLx
          R_low(i,j,bi,bj) = rF(1)
         ENDDO
        ENDDO
        DO K=Nr,1,-1
         DO J=1-OLy,sNy+OLy
          DO I=1-OLx,sNx+OLx
           R_low(I,J,bi,bj) = R_low(I,J,bi,bj)
     &                      - drF(K)*hFacC(I,J,K,bi,bj)
          ENDDO
         ENDDO
        ENDDO
C - end bi,bj loops.
       ENDDO
      ENDDO

Cml      DO bj=myByLo(myThid), myByHi(myThid)
Cml       DO bi=myBxLo(myThid), myBxHi(myThid)
CmlC-  Re-calculate Reference surface position, taking into account hFacC
Cml        DO J=1-OLy,sNy+OLy
Cml         DO I=1-OLx,sNx+OLx
Cml          Ro_surf(I,J,bi,bj) = R_low(I,J,bi,bj)
Cml          DO K=Nr,1,-1
Cml           Ro_surf(I,J,bi,bj) = Ro_surf(I,J,bi,bj)
Cml     &                        + drF(k)*hFacC(I,J,K,bi,bj)
Cml          ENDDO
Cml         ENDDO
Cml        ENDDO
CmlC     - end bi,bj loops.
Cml       ENDDO
Cml      ENDDO

      IF ( plotLevel.GE.debLevC ) THEN
        _BARRIER
        CALL PLOT_FIELD_XYRS( R_low,
     &         'Model R_low (update_masks_etc)', 1, myThid )
CML I assume that Ro_surf is not changed anywhere else in the code
CML and since it is not changed in this routine, we do not need to
CML print it again.
CML     CALL PLOT_FIELD_XYRS( Ro_surf,
CML  &         'Model Ro_surf (update_masks_etc)', 1, myThid )
      ENDIF

C     Calculate quantities derived from XY depth map
      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
C         Total fluid column thickness (r_unit) :
          tmpfld(i,j,bi,bj) = Ro_surf(i,j,bi,bj) - R_low(i,j,bi,bj)
C         Inverse of fluid column thickness (1/r_unit)
          IF ( tmpfld(i,j,bi,bj) .LE. 0. ) THEN
           recip_Rcol(i,j,bi,bj) = 0.
          ELSE
           recip_Rcol(i,j,bi,bj) = 1. _d 0 / tmpfld(i,j,bi,bj)
          ENDIF
         ENDDO
        ENDDO
       ENDDO
      ENDDO
C     _EXCH_XY_RS(   recip_Rcol, myThid )

C     hFacW and hFacS (at U and V points)
CML   This will be the crucial part of the code, because here the minimum
CML   function MIN is involved which does not have a continuous derivative
CML   for MIN(x,y) at y=x.
CML   The thin walls representation has been moved into this loop, that is
CML   before the call to EXCH_UV_XVY_RS, because TAF will prefer it this
CML   way. On the other hand, this might cause difficulties in some
CML   configurations.
      DO bj=myByLo(myThid), myByHi(myThid)
       DO bi=myBxLo(myThid), myBxHi(myThid)
        DO K=1, Nr
         DO J=1-OLy,sNy+OLy
          DO I=1-OLx,sNx+OLx
           Im1=MAX(I-1,1-OLx)
           Jm1=MAX(J-1,1-OLy)
           IF (DYG(I,J,bi,bj).EQ.0.) THEN
C     thin walls representation of non-periodic
C     boundaries such as happen on the lat-lon grid at the N/S poles.
C     We should really supply a flag for doing this.
              hFacW(I,J,K,bi,bj)=0.
           ELSE
              hFacW(I,J,K,bi,bj)=maskW(I,J,K,bi,bj)*
#ifdef USE_SMOOTH_MIN
     &           SMOOTHMIN_RS(hFacC(I,J,K,bi,bj),hFacC(Im1,J,K,bi,bj))
#else
     &                    MIN(hFacC(I,J,K,bi,bj),hFacC(Im1,J,K,bi,bj))
#endif /* USE_SMOOTH_MIN */
           ENDIF
           IF (DXG(I,J,bi,bj).EQ.0.) THEN
              hFacS(I,J,K,bi,bj)=0.
           ELSE
              hFacS(I,J,K,bi,bj)=maskS(I,J,K,bi,bj)*
#ifdef USE_SMOOTH_MIN
     &           SMOOTHMIN_RS(hFacC(I,J,K,bi,bj),hFacC(I,Jm1,K,bi,bj))
#else
     &                    MIN(hFacC(I,J,K,bi,bj),hFacC(I,Jm1,K,bi,bj))
#endif /* USE_SMOOTH_MIN */
           ENDIF
          ENDDO
         ENDDO
        ENDDO
       ENDDO
      ENDDO
#if ( defined ALLOW_AUTODIFF && defined ALLOW_AUTODIFF_MONITOR )
C     Include call to a dummy routine. Its adjoint will be called at the proper
C     place in the adjoint code. The adjoint routine will print out adjoint
C     values if requested. The location of the call is important, it has to be
C     after the adjoint of the exchanges (DO_GTERM_BLOCKING_EXCHANGES).
Cml      CALL DUMMY_IN_HFAC( 'W', 0, myThid )
Cml      CALL DUMMY_IN_HFAC( 'S', 0, myThid )
#endif
      CALL EXCH_UV_XYZ_RS(hFacW,hFacS,.FALSE.,myThid)
#if ( defined ALLOW_AUTODIFF && defined ALLOW_AUTODIFF_MONITOR )
C     Include call to a dummy routine. Its adjoint will be called at the proper
C     place in the adjoint code. The adjoint routine will print out adjoint
C     values if requested. The location of the call is important, it has to be
C     after the adjoint of the exchanges (DO_GTERM_BLOCKING_EXCHANGES).
Cml      CALL DUMMY_IN_HFAC( 'W', 1, myThid )
Cml      CALL DUMMY_IN_HFAC( 'S', 1, myThid )
#endif

C-    Write to disk: Total Column Thickness & hFac(C,W,S):
      WRITE(suff,'(I10.10)') optimcycle
      CALL WRITE_FLD_XY_RS( 'Depth.',suff,tmpfld,optimcycle,myThid)
      CALL WRITE_FLD_XYZ_RS( 'hFacC.',suff,hFacC,optimcycle,myThid)
      CALL WRITE_FLD_XYZ_RS( 'hFacW.',suff,hFacW,optimcycle,myThid)
      CALL WRITE_FLD_XYZ_RS( 'hFacS.',suff,hFacS,optimcycle,myThid)

      IF ( plotLevel.GE.debLevC ) THEN
        _BARRIER
C--   Write to monitor file (standard output)
        CALL PLOT_FIELD_XYZRS( hFacC,'hFacC (update_masks_etc)',
     &                                          Nr, 1, myThid )
        CALL PLOT_FIELD_XYZRS( hFacW,'hFacW (update_masks_etc)',
     &                                          Nr, 1, myThid )
        CALL PLOT_FIELD_XYZRS( hFacS,'hFacS (update_masks_etc)',
     &                                          Nr, 1, myThid )
      ENDIF

C     Masks and reciprocals of hFac[CWS]
Cml   The masks should stay constant, so they are not recomputed at this time
Cml   implicitly implying that no cell that is wet in the begin will ever dry
Cml   up! This is a strong constraint and should be implementent as a hard
Cml   inequality contraint when performing optimization (m1qn3 cannot do that)
Cml   Also, I am assuming here that the new hFac(s) never become zero during
Cml   optimization!
      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
        DO K=1,Nr
         DO J=1-OLy,sNy+OLy
          DO I=1-OLx,sNx+OLx
           IF (hFacC(I,J,K,bi,bj) .NE. 0. ) THEN
Cml           IF (maskC(I,J,K,bi,bj) .NE. 0. ) THEN
            recip_hFacC(I,J,K,bi,bj) = 1. _d 0 / hFacC(I,J,K,bi,bj)
Cml            maskC(I,J,K,bi,bj) = 1.
           ELSE
            recip_hFacC(I,J,K,bi,bj) = 0.
Cml            maskC(I,J,K,bi,bj) = 0.
           ENDIF
           IF (hFacW(I,J,K,bi,bj) .NE. 0. ) THEN
Cml           IF (maskW(I,J,K,bi,bj) .NE. 0. ) THEN
            recip_hFacW(I,J,K,bi,bj) = 1. _d 0 / hFacw(I,J,K,bi,bj)
Cml            maskW(I,J,K,bi,bj) = 1.
           ELSE
            recip_hFacW(I,J,K,bi,bj) = 0.
Cml            maskW(I,J,K,bi,bj) = 0.
           ENDIF
           IF (hFacS(I,J,K,bi,bj) .NE. 0. ) THEN
Cml           IF (maskS(I,J,K,bi,bj) .NE. 0. ) THEN
            recip_hFacS(I,J,K,bi,bj) = 1. _d 0 / hFacS(I,J,K,bi,bj)
Cml            maskS(I,J,K,bi,bj) = 1.
           ELSE
            recip_hFacS(I,J,K,bi,bj) = 0.
Cml            maskS(I,J,K,bi,bj) = 0.
           ENDIF
          ENDDO
         ENDDO
        ENDDO
CmlCml(
Cml       ENDDO
Cml      ENDDO
Cml      _EXCH_XYZ_RS(recip_hFacC    , myThid )
Cml      _EXCH_XYZ_RS(recip_hFacW    , myThid )
Cml      _EXCH_XYZ_RS(recip_hFacS    , myThid )
Cml      _EXCH_XYZ_RS(maskC    , myThid )
Cml      _EXCH_XYZ_RS(maskW    , myThid )
Cml      _EXCH_XYZ_RS(maskS    , myThid )
Cml      DO bj = myByLo(myThid), myByHi(myThid)
Cml       DO bi = myBxLo(myThid), myBxHi(myThid)
CmlCml)
#ifdef NONLIN_FRSURF
C--   Save initial geometrical hFac factor into h0Fac (fixed in time):
C     Note: In case 1 pkg modifies hFac (from packages_init_fixed, called
C     later in sequence of calls) this pkg would need also to update h0Fac.
        DO k=1,Nr
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           h0FacC(i,j,k,bi,bj) = _hFacC(i,j,k,bi,bj)
           h0FacW(i,j,k,bi,bj) = _hFacW(i,j,k,bi,bj)
           h0FacS(i,j,k,bi,bj) = _hFacS(i,j,k,bi,bj)
          ENDDO
         ENDDO
        ENDDO
#endif /* NONLIN_FRSURF */
C - end bi,bj loops.
       ENDDO
      ENDDO

#endif /* ALLOW_DEPTH_CONTROL */
      RETURN
      END

#ifdef USE_SMOOTH_MIN
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      _RS FUNCTION SMOOTHMIN_RS( a, b )

      IMPLICIT NONE

      _RS a, b

      _RS SMOOTHABS_RS
      EXTERNAL SMOOTHABS_RS

Cml      smoothMin_R4 = .5*(a+b)
      SMOOTHMIN_RS = .5*( a+b - SMOOTHABS_RS(a-b) )
CML      smoothMin_R4 = MIN(a,b)

      RETURN
      END

      _RL FUNCTION SMOOTHMIN_RL( a, b )

      IMPLICIT NONE

      _RL a, b

      _RL SMOOTHABS_RL
      EXTERNAL SMOOTHABS_RL

Cml      smoothMin_R8 = .5*(a+b)
      SMOOTHMIN_RL = .5*( a+b - SMOOTHABS_RL(a-b) )
Cml      smoothMin_R8 = MIN(a,b)

      RETURN
      END

      _RS FUNCTION SMOOTHABS_RS( x )

      IMPLICIT NONE
C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
C     input parameter
      _RS x
c     local variable
      _RS sf, rsf

      IF ( smoothAbsFuncRange .LT. 0.0 ) THEN
c     limit of smoothMin(a,b) = .5*(a+b)
         SMOOTHABS_RS = 0.
      ELSE
         IF ( smoothAbsFuncRange .NE. 0.0 ) THEN
            sf  = 10.0/smoothAbsFuncRange
            rsf = 1./sf
         ELSE
c     limit of smoothMin(a,b) = min(a,b)
            sf  = 0.
            rsf = 0.
         ENDIF
c
         IF ( x .GT. smoothAbsFuncRange ) THEN
            SMOOTHABS_RS = x
         ELSEIF ( x .LT. -smoothAbsFuncRange ) THEN
            SMOOTHABS_RS = -x
         ELSE
            SMOOTHABS_RS = log(.5*(exp(x*sf)+exp(-x*sf)))*rsf
         ENDIF
      ENDIF

      RETURN
      END

      _RL FUNCTION SMOOTHABS_RL( x )

      IMPLICIT NONE
C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
C     input parameter
      _RL x
c     local variable
      _RL sf, rsf

      IF ( smoothAbsFuncRange .LT. 0.0 ) THEN
c     limit of smoothMin(a,b) = .5*(a+b)
         SMOOTHABS_RL = 0.
      ELSE
         IF ( smoothAbsFuncRange .NE. 0.0 ) THEN
            sf  = 10.0D0/smoothAbsFuncRange
            rsf = 1.D0/sf
         ELSE
c     limit of smoothMin(a,b) = min(a,b)
            sf  = 0.D0
            rsf = 0.D0
         ENDIF
c
         IF ( x .GE. smoothAbsFuncRange ) THEN
            SMOOTHABS_RL = x
         ELSEIF ( x .LE. -smoothAbsFuncRange ) THEN
            SMOOTHABS_RL = -x
         ELSE
            SMOOTHABS_RL = log(.5*(exp(x*sf)+exp(-x*sf)))*rsf
         ENDIF
      ENDIF

      RETURN
      END
#endif /* USE_SMOOTH_MIN */

Cml#ifdef ALLOW_DEPTH_CONTROL
Cmlcadj SUBROUTINE limit_hfacc_to_one INPUT   = 1
Cmlcadj SUBROUTINE limit_hfacc_to_one OUTPUT  = 1
Cmlcadj SUBROUTINE limit_hfacc_to_one ACTIVE  = 1
Cmlcadj SUBROUTINE limit_hfacc_to_one DEPEND  = 1
Cmlcadj SUBROUTINE limit_hfacc_to_one REQUIRED
Cmlcadj SUBROUTINE limit_hfacc_to_one ADNAME  = adlimit_hfacc_to_one
Cml#endif /* ALLOW_DEPTH_CONTROL */
Cml      SUBROUTINE LIMIT_HFACC_TO_ONE( hf )
Cml
Cml      _RL hf
Cml
Cml      IF ( hf .GT. 1. _d 0 ) THEN
Cml       hf = 1. _d 0
Cml      ENDIF
Cml
Cml      RETURN
Cml      END
Cml
Cml      SUBROUTINE ADLIMIT_HFACC_TO_ONE( hf, adhf )
Cml
Cml      _RL hf, adhf
Cml
Cml      RETURN
Cml      END

#ifdef ALLOW_DEPTH_CONTROL
cadj SUBROUTINE dummy_in_hfac INPUT   = 1, 2, 3
cadj SUBROUTINE dummy_in_hfac OUTPUT  =
cadj SUBROUTINE dummy_in_hfac ACTIVE  =
cadj SUBROUTINE dummy_in_hfac DEPEND  = 1, 2, 3
cadj SUBROUTINE dummy_in_hfac REQUIRED
cadj SUBROUTINE dummy_in_hfac INFLUENCED
cadj SUBROUTINE dummy_in_hfac ADNAME  = addummy_in_hfac
cadj SUBROUTINE dummy_in_hfac FTLNAME = g_dummy_in_hfac
#endif /* ALLOW_DEPTH_CONTROL */

! ============================================================================
module surface_flux_mod
! ============================================================================

! use             fms_mod, only: FATAL, close_file, mpp_pe, mpp_root_pe,        &
!                               write_version_number
! use             fms_mod, only: file_exist, check_nml_error, open_namelist_file, stdlog

use   monin_obukhov_mod, only: mo_drag, mo_profile
use  simple_sat_vapor_pres_mod, only: escomp, descomp
use      gcm_params_mod, only: gcm_LEN_MBUF, gcm_SQZ_R, gcm_stdMsgUnit
use       constants_mod, only: cp_air, hlv, stefan, rdgas, rvgas, grav

implicit none
private

! ==== public interface ======================================================
public  surface_flux
! ==== end of public interface ===============================================

interface surface_flux
!    module procedure surface_flux_0d
!    module procedure surface_flux_1d
    module procedure surface_flux_2d
end interface

!-----------------------------------------------------------------------

character(len=*), parameter :: version = '$Id: surface_flux_mod.F90,v 1.3 2017/08/11 20:48:51 jmc Exp $'
character(len=*), parameter :: tagname = '$Name:  $'

logical :: do_init = .true.

real, parameter :: d622   = rdgas/rvgas
real, parameter :: d378   = 1.-d622
real, parameter :: hlars  = hlv/rvgas
real, parameter :: gcp    = grav/cp_air
real, parameter :: kappa  = rdgas/cp_air
real            :: d608   = d378/d622
      ! d608 set to zero at initialization if the use of
      ! virtual temperatures is turned off in namelist

! ---- namelist with default values ------------------------------------------
logical :: no_neg_q         = .false.  ! for backwards compatibility
logical :: use_virtual_temp = .true.
logical :: alt_gustiness    = .false.
logical :: use_mixing_ratio = .false.
real    :: gust_const       =  1.0

namelist /surface_flux_nml/ no_neg_q,         &
                            use_virtual_temp, &
                            alt_gustiness,    &
                            gust_const,       &
                            use_mixing_ratio

contains

! ============================================================================
subroutine surface_flux_1d (                                           &
     t_atm,     q_atm_in,   u_atm,     v_atm,     p_atm,     z_atm,    &
     p_surf,    t_surf,     t_ca,      q_surf,                         &
     u_surf,    v_surf,                                                &
     rough_mom, rough_heat, rough_moist, gust,  &
     flux_t, flux_q, flux_r, flux_u, flux_v,                &
     cd_m,      cd_t,       cd_q,                                      &
     w_atm,     u_star,     b_star,     q_star,                        &
     dhdt_surf, dedt_surf,  dedq_surf,  drdt_surf,                     &
     dhdt_atm,  dedq_atm,   dtaudv_atm,                                &
! + slm Mar 28 2002 -- it is not necessary here since it is just cd_q*wind
!     drag_q,                                                           &
! - slm Mar 28 2002
     dt,        land,      avail, myThid  )
! ============================================================================
  ! ---- arguments -----------------------------------------------------------
  logical, intent(in), dimension(:) :: land,  avail
  real, intent(in),  dimension(:) :: &
       t_atm,     q_atm_in,   u_atm,     v_atm,              &
       p_atm,     z_atm,      t_ca,                          &
       p_surf,    t_surf,     u_surf,    v_surf,  &
       rough_mom, rough_heat, rough_moist,  gust
  real, intent(out), dimension(:) :: &
       flux_t,    flux_q,     flux_r,    flux_u,  flux_v,    &
       dhdt_surf, dedt_surf,  dedq_surf, drdt_surf,          &
       dhdt_atm,  dedq_atm,   dtaudv_atm,                    &
       w_atm,     u_star,     b_star,    q_star,             &
       cd_m,      cd_t,       cd_q
  real, intent(inout), dimension(:) :: q_surf
  real, intent(in) :: dt
  integer, intent(in) :: myThid

  ! ---- local constants -----------------------------------------------------
  ! temperature increment and its reciprocal value for comp. of derivatives
  real, parameter:: del_temp=0.1, del_temp_inv=1.0/del_temp

  ! ---- local vars ----------------------------------------------------------
  real, dimension(size(t_atm)) ::                          &
       thv_atm,  th_atm,   tv_atm,    thv_surf,            &
       e_sat,    e_sat1,   q_sat,     q_sat1,    p_ratio,  &
       t_surf0,  t_surf1,  u_dif,     v_dif,               &
       rho_drag, drag_t,    drag_m,   drag_q,    rho,      &
       q_atm,    q_surf0

  integer :: i, nbad

  if (do_init) call surface_flux_init(myThid)

  !---- use local value of surf temp ----

  t_surf0 = 200.   !  avoids out-of-bounds in es lookup
  where (avail)
     where (land)
        t_surf0 = t_ca
     elsewhere
        t_surf0 = t_surf
     endwhere
  endwhere

  t_surf1 = t_surf0 + del_temp

  call escomp ( t_surf0, e_sat  )  ! saturation vapor pressure
  call escomp ( t_surf1, e_sat1 )  ! perturbed  vapor pressure

  if(use_mixing_ratio) then
    ! surface mixing ratio at saturation
    q_sat   = d622*e_sat /(p_surf-e_sat )
    q_sat1  = d622*e_sat1/(p_surf-e_sat1)
  else
    ! surface specific humidity at saturation
    q_sat   = d622*e_sat /(p_surf-d378*e_sat )
    q_sat1  = d622*e_sat1/(p_surf-d378*e_sat1)
  endif

  ! initilaize surface air humidity according to surface type
  where (land)
     q_surf0 = q_surf ! land calculates it
  elsewhere
     q_surf0 = q_sat  ! everything else assumes saturated sfc humidity
  endwhere

  ! check for negative atmospheric humidities
  where(avail) q_atm = q_atm_in
  if(no_neg_q) then
     where(avail .and. q_atm_in < 0.0) q_atm = 0.0
  endif

  ! generate information needed by monin_obukhov
  where (avail)
     p_ratio = (p_surf/p_atm)**kappa

     tv_atm  = t_atm  * (1.0 + d608*q_atm)     ! virtual temperature
     th_atm  = t_atm  * p_ratio  ! potential T, using p_surf as refernce
     thv_atm = tv_atm * p_ratio  ! virt. potential T, using p_surf as reference
     thv_surf= t_surf0 * (1.0 + d608*q_surf0 ) ! surface virtual (potential) T
!     thv_surf= t_surf0  ! surface virtual (potential) T -- just for testing tun off the q_surf

     u_dif = u_surf - u_atm      ! velocity components relative to surface
     v_dif = v_surf - v_atm
  endwhere

  if(alt_gustiness) then
     where(avail) &
          w_atm = max(sqrt(u_dif*u_dif + v_dif*v_dif), gust_const)
  else
     where(avail) &
          w_atm = sqrt(u_dif*u_dif + v_dif*v_dif + gust*gust)
  endif

  !  monin-obukhov similarity theory
  call mo_drag (thv_atm, thv_surf, z_atm,                  &
       rough_mom, rough_heat, rough_moist, w_atm,          &
       cd_m, cd_t, cd_q, u_star, b_star, myThid, avail     )

  where (avail)
     ! surface layer drag coefficients
     drag_t = cd_t * w_atm
     drag_q = cd_q * w_atm
     drag_m = cd_m * w_atm

     ! density
     rho = p_atm / (rdgas * tv_atm)

     ! sensible heat flux
     rho_drag = cp_air * drag_t * rho
     flux_t = rho_drag * (t_surf0 - th_atm)  ! flux of sensible heat (W/m**2)
     dhdt_surf =  rho_drag                   ! d(sensible heat flux)/d(surface temperature)
     dhdt_atm  = -rho_drag*p_ratio           ! d(sensible heat flux)/d(atmos temperature)

     ! evaporation
     rho_drag  =  drag_q * rho
     flux_q    =  rho_drag * (q_surf0 - q_atm) ! flux of water vapor  (Kg/(m**2 s))
     where (land)
        dedq_surf = rho_drag
        dedt_surf = 0
     elsewhere
        dedq_surf = 0
        dedt_surf =  rho_drag * (q_sat1 - q_sat) *del_temp_inv
     endwhere

     dedq_atm  = -rho_drag   ! d(latent heat flux)/d(atmospheric mixing ratio)

     q_star = flux_q / (u_star * rho)             ! moisture scale
     ! ask Chris and Steve K if we still want to keep this for diagnostics
     q_surf = q_atm + flux_q / (rho*cd_q*w_atm)   ! surface specific humidity

     ! upward long wave radiation
     flux_r    =   stefan*t_surf**4               ! (W/m**2)
     drdt_surf = 4*stefan*t_surf**3               ! d(upward longwave)/d(surface temperature)

     ! stresses
     rho_drag   = drag_m * rho
     flux_u     = rho_drag * u_dif   ! zonal      component of stress (Nt/m**2)
     flux_v     = rho_drag * v_dif   ! meridional component of stress
     dtaudv_atm = -rho_drag          ! d(stress component)/d(atmos wind)

  elsewhere
     ! zero-out un-available data in output only fields
     flux_t     = 0.0
     flux_q     = 0.0
     flux_r     = 0.0
     flux_u     = 0.0
     flux_v     = 0.0
     dhdt_surf  = 0.0
     dedt_surf  = 0.0
     dedq_surf  = 0.0
     drdt_surf  = 0.0
     dhdt_atm   = 0.0
     dedq_atm   = 0.0
     dtaudv_atm = 0.0
     u_star     = 0.0
     b_star     = 0.0
     q_star     = 0.0
     q_surf     = 0.0
     w_atm      = 0.0
  endwhere

end subroutine surface_flux_1d

!#######################################################################

subroutine surface_flux_0d (                                                 &
     t_atm_0,     q_atm_0,      u_atm_0,     v_atm_0,   p_atm_0, z_atm_0,    &
     p_surf_0,    t_surf_0,     t_ca_0,      q_surf_0,                       &
     u_surf_0,    v_surf_0,                                                  &
     rough_mom_0, rough_heat_0, rough_moist_0, gust_0,                       &
     flux_t_0,    flux_q_0,     flux_r_0,    flux_u_0,  flux_v_0,            &
     cd_m_0,      cd_t_0,       cd_q_0,                                      &
     w_atm_0,     u_star_0,     b_star_0,     q_star_0,                      &
     dhdt_surf_0, dedt_surf_0,  dedq_surf_0,  drdt_surf_0,                   &
     dhdt_atm_0,  dedq_atm_0,   dtaudv_atm_0,                                &
     dt,          land_0,       avail_0, myThid  )

  ! ---- arguments -----------------------------------------------------------
  logical, intent(in) :: land_0,  avail_0
  real, intent(in) :: &
       t_atm_0,     q_atm_0,      u_atm_0,     v_atm_0,              &
       p_atm_0,     z_atm_0,      t_ca_0,                          &
       p_surf_0,    t_surf_0,     u_surf_0,    v_surf_0,  &
       rough_mom_0, rough_heat_0, rough_moist_0,  gust_0
  real, intent(out) :: &
       flux_t_0,    flux_q_0,     flux_r_0,    flux_u_0,  flux_v_0,    &
       dhdt_surf_0, dedt_surf_0,  dedq_surf_0, drdt_surf_0,          &
       dhdt_atm_0,  dedq_atm_0,   dtaudv_atm_0,                    &
       w_atm_0,     u_star_0,     b_star_0,    q_star_0,             &
       cd_m_0,      cd_t_0,       cd_q_0
  real, intent(inout) :: q_surf_0
  real, intent(in)    :: dt
  integer, intent(in) :: myThid

  ! ---- local vars ----------------------------------------------------------
  logical, dimension(1) :: land,  avail
  real, dimension(1) :: &
       t_atm,     q_atm,      u_atm,     v_atm,              &
       p_atm,     z_atm,      t_ca,                          &
       p_surf,    t_surf,     u_surf,    v_surf,  &
       rough_mom, rough_heat, rough_moist,  gust
  real, dimension(1) :: &
       flux_t,    flux_q,     flux_r,    flux_u,  flux_v,    &
       dhdt_surf, dedt_surf,  dedq_surf, drdt_surf,          &
       dhdt_atm,  dedq_atm,   dtaudv_atm,                    &
       w_atm,     u_star,     b_star,    q_star,             &
       cd_m,      cd_t,       cd_q
  real, dimension(1) :: q_surf

  avail = .true.

  t_atm(1)       = t_atm_0
  q_atm(1)       = q_atm_0
  u_atm(1)       = u_atm_0
  v_atm(1)       = v_atm_0
  p_atm(1)       = p_atm_0
  z_atm(1)       = z_atm_0
  p_surf(1)      = p_surf_0
  t_surf(1)      = t_surf_0
  t_ca(1)        = t_ca_0
  q_surf(1)      = q_surf_0
  u_surf(1)      = u_surf_0
  v_surf(1)      = v_surf_0
  rough_mom(1)   = rough_mom_0
  rough_heat(1)  = rough_heat_0
  rough_moist(1) = rough_moist_0
  gust(1)        = gust_0
  land(1)        = land_0

  call surface_flux_1d (                                           &
       t_atm,     q_atm,      u_atm,     v_atm,     p_atm,     z_atm,    &
       p_surf,    t_surf,     t_ca,      q_surf,                         &
       u_surf,    v_surf,                                                &
       rough_mom, rough_heat, rough_moist, gust,  &
       flux_t, flux_q, flux_r, flux_u, flux_v,                &
       cd_m,      cd_t,       cd_q,                                      &
       w_atm,     u_star,     b_star,     q_star,                        &
       dhdt_surf, dedt_surf,  dedq_surf,  drdt_surf,                     &
       dhdt_atm,  dedq_atm,   dtaudv_atm,                                &
       dt,        land,      avail, myThid  )

  flux_t_0     = flux_t(1)
  flux_q_0     = flux_q(1)
  flux_r_0     = flux_r(1)
  flux_u_0     = flux_u(1)
  flux_v_0     = flux_v(1)
  cd_m_0       = cd_m(1)
  cd_t_0       = cd_t(1)
  cd_q_0       = cd_q(1)
  w_atm_0      = w_atm(1)
  u_star_0     = u_star(1)
  b_star_0     = b_star(1)
  q_star_0     = q_star(1)
  q_surf_0     = q_surf(1)
  dhdt_surf_0  = dhdt_surf(1)
  dedt_surf_0  = dedt_surf(1)
  dedq_surf_0  = dedq_surf(1)
  drdt_surf_0  = drdt_surf(1)
  dhdt_atm_0   = dhdt_atm(1)
  dedq_atm_0   = dedq_atm(1)
  dtaudv_atm_0 = dtaudv_atm(1)

end subroutine surface_flux_0d

subroutine surface_flux_2d (                                           &
     t_atm,     q_atm_in,   u_atm,     v_atm,     p_atm,     z_atm,    &
     p_surf,    t_surf,     t_ca,      q_surf,                         &
     u_surf,    v_surf,                                                &
     rough_mom, rough_heat, rough_moist, gust,                         &
     flux_t,    flux_q,     flux_r,    flux_u,    flux_v,              &
     cd_m,      cd_t,       cd_q,                                      &
     w_atm,     u_star,     b_star,     q_star,                        &
     dhdt_surf, dedt_surf,  dedq_surf,  drdt_surf,                     &
     dhdt_atm,  dedq_atm,   dtaudv_atm,                                &
     dt,        land,       avail, myThid  )

  ! ---- arguments -----------------------------------------------------------
  logical, intent(in), dimension(:,:) :: land,  avail
  real, intent(in),  dimension(:,:) :: &
       t_atm,     q_atm_in,   u_atm,     v_atm,              &
       p_atm,     z_atm,      t_ca,                          &
       p_surf,    t_surf,     u_surf,    v_surf,  &
       rough_mom, rough_heat, rough_moist,  gust
  real, intent(out), dimension(:,:) :: &
       flux_t,    flux_q,     flux_r,    flux_u,  flux_v,    &
       dhdt_surf, dedt_surf,  dedq_surf, drdt_surf,          &
       dhdt_atm,  dedq_atm,   dtaudv_atm,                    &
       w_atm,     u_star,     b_star,    q_star,             &
       cd_m,      cd_t,       cd_q
  real, intent(inout), dimension(:,:) :: q_surf
  real, intent(in) :: dt
  integer, intent (in) :: myThid

  ! ---- local vars -----------------------------------------------------------
  integer :: j
  do j = 1, size(t_atm,2)
     call surface_flux_1d (                                           &
          t_atm(:,j),     q_atm_in(:,j),   u_atm(:,j),     v_atm(:,j),     p_atm(:,j),     z_atm(:,j),    &
          p_surf(:,j),    t_surf(:,j),     t_ca(:,j),      q_surf(:,j),                         &
          u_surf(:,j),    v_surf(:,j),                                                &
          rough_mom(:,j), rough_heat(:,j), rough_moist(:,j), gust(:,j),                         &
          flux_t(:,j),    flux_q(:,j),     flux_r(:,j),    flux_u(:,j),    flux_v(:,j),              &
          cd_m(:,j),      cd_t(:,j),       cd_q(:,j),                                      &
          w_atm(:,j),     u_star(:,j),     b_star(:,j),     q_star(:,j),                        &
          dhdt_surf(:,j), dedt_surf(:,j),  dedq_surf(:,j),  drdt_surf(:,j),                     &
          dhdt_atm(:,j),  dedq_atm(:,j),   dtaudv_atm(:,j),                                &
          dt,             land(:,j),       avail(:,j), myThid  )
  end do
end subroutine surface_flux_2d

! ============================================================================
subroutine surface_flux_init (myThid)
! ============================================================================
! initializes surface flux module
  ! ---- local vars ----------------------------------------------------------
 integer, intent(in) :: myThid
 integer :: unit, ierr, io
!-- added:
 integer         :: iUnit
 CHARACTER*(gcm_LEN_MBUF) :: msgBuf

  ! read namelist

!    _BARRIER
!    _BEGIN_MASTER(myThid)
     CALL BARRIER(myThid)
     IF ( myThid.EQ.1 ) THEN

     WRITE(msgBuf,'(A)') 'SURFACE_FLUX_INIT: opening data.atm_gray'
     CALL PRINT_MESSAGE( msgBuf, gcm_stdMsgUnit, gcm_SQZ_R, myThid )
     CALL OPEN_COPY_DATA_FILE(                                      &
                           'data.atm_gray', 'SURFACE_FLUX_INIT',       &
                           iUnit,                                   &
                           myThid )
!    Read parameters from open data file
     READ(UNIT=iUnit,NML=surface_flux_nml)
     WRITE(msgBuf,'(A)')                                            &
          'SURFACE_FLUX_INIT: finished reading data.atm_gray'
     CALL PRINT_MESSAGE( msgBuf, gcm_stdMsgUnit, gcm_SQZ_R, myThid )
!    Close the open data file
#ifdef SINGLE_DISK_IO
     CLOSE(iUnit)
#else
     CLOSE(iUnit,STATUS='DELETE')
#endif /* SINGLE_DISK_IO */

!  if ( file_exist('input.nml')) then
!     unit = open_namelist_file ()
!     ierr=1;
!     do while (ierr /= 0)
!        read  (unit, nml=surface_flux_nml, iostat=io, end=10)
!        ierr = check_nml_error(io,'surface_flux_nml')
!     enddo
!10   call close_file (unit)
!  endif

!  ! write version number
!  call write_version_number(version, tagname)

!  if ( mpp_pe() == mpp_root_pe() ) write (stdlog(), nml=surface_flux_nml)

!  if(.not. use_virtual_temp) d608 = 0.0

    do_init = .false.

    ENDIF
    CALL BARRIER (myThid)

end subroutine surface_flux_init

end module surface_flux_mod

#include "GAD_OPTIONS.h"
#ifdef ALLOW_AUTODIFF
# include "AUTODIFF_OPTIONS.h"
#endif

CBOP
C !ROUTINE: GAD_CALC_RHS

C !INTERFACE: ==========================================================
      SUBROUTINE GAD_CALC_RHS(
     I           bi,bj,iMin,iMax,jMin,jMax,k,kM1,kUp,kDown,
     I           xA, yA, maskUp, uFld, vFld, wFld,
     I           uTrans, vTrans, rTrans, rTransKp1,
     I           diffKh, diffK4, KappaR, diffKr4, TracerN, TracAB,
     I           deltaTLev, trIdentity,
     I           advectionSchArg, vertAdvecSchArg,
     I           calcAdvection, implicitAdvection, applyAB_onTracer,
     I           trUseDiffKr4, trUseGMRedi, trUseKPP, trUseSmolHack,
     O           fZon, fMer,
     U           fVerT, gTracer,
     I           myTime, myIter, myThid )

C !DESCRIPTION:
C Calculates the tendency of a tracer due to advection and diffusion.
C It calculates the fluxes in each direction indepentently and then
C sets the tendency to the divergence of these fluxes. The advective
C fluxes are only calculated here when using the linear advection schemes
C otherwise only the diffusive and parameterized fluxes are calculated.
C
C Contributions to the flux are calculated and added:
C \begin{equation*}
C {\bf F} = {\bf F}_{adv} + {\bf F}_{diff} +{\bf F}_{GM} + {\bf F}_{KPP}
C \end{equation*}
C
C The tendency is the divergence of the fluxes:
C \begin{equation*}
C G_\theta = G_\theta + \nabla \cdot {\bf F}
C \end{equation*}
C
C The tendency is assumed to contain data on entry.

C !USES: ===============================================================
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "SURFACE.h"
#include "GAD.h"
#ifdef ALLOW_LAYERS
# include "LAYERS_P2SHARE.h"
#endif
#ifdef ALLOW_AUTODIFF
# include "AUTODIFF_PARAMS.h"
#endif /* ALLOW_AUTODIFF */

C !INPUT PARAMETERS: ===================================================
C bi, bj           :: tile indices
C iMin, iMax       :: for called routines, to get valid output "gTracer"
C jMin, jMax       ::                      over this range of indices
C k                :: vertical index
C kM1              :: =k-1 for k>1, =1 for k=1
C kUp              :: index into 2 1/2D array, toggles between 1|2
C kDown            :: index into 2 1/2D array, toggles between 2|1
C xA, yA           :: areas of X and Y face of tracer cells
C maskUp           :: 2-D array for mask at W points
C uFld, vFld, wFld :: Local copy of velocity field (3 components)
C uTrans, vTrans   :: 2-D arrays of volume transports at U,V points
C rTrans           :: 2-D arrays of volume transports at W points
C rTransKp1        :: 2-D array of volume trans at W pts, interf k+1
C diffKh           :: horizontal diffusion coefficient
C diffK4           :: horizontal bi-harmonic diffusion coefficient
C KappaR           :: 2-D array for vertical diffusion coefficient, interf k
C diffKr4          :: 1-D array for vertical bi-harmonic diffusion coefficient
C TracerN          :: tracer field @ time-step n (Note: only used
C                     if applying AB on tracer field rather than on tendency gTr)
C TracAB           :: current tracer field (@ time-step n if applying AB on gTr
C                     or extrapolated fwd in time to n+1/2 if applying AB on Tr)
C trIdentity       :: tracer identifier (required for KPP,GM)
C advectionSchArg  :: advection scheme to use (Horizontal plane)
C vertAdvecSchArg  :: advection scheme to use (Vertical direction)
C calcAdvection    :: =False if Advec computed with multiDim scheme
C implicitAdvection:: =True if vertical Advec computed implicitly
C applyAB_onTracer :: apply Adams-Bashforth on Tracer (rather than on gTr)
C trUseDiffKr4     :: true if this tracer uses vertical bi-harmonic diffusion
C trUseGMRedi      :: true if this tracer uses GM-Redi
C trUseKPP         :: true if this tracer uses KPP
C trUseSmolHack    :: true if this tracer uses Smolarkiewicz-Hack to remain > 0
C myTime           :: current time
C myIter           :: iteration number
C myThid           :: thread number
      INTEGER bi,bj,iMin,iMax,jMin,jMax
      INTEGER k,kUp,kDown,kM1
      _RS xA    (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RS yA    (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RS maskUp(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL uFld  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL vFld  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL wFld  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL uTrans(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL vTrans(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL rTrans(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL rTransKp1(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL diffKh, diffK4
      _RL KappaR(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL diffKr4(Nr)
      _RL TracerN(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL TracAB (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL deltaTLev(Nr)
      INTEGER trIdentity
      INTEGER advectionSchArg, vertAdvecSchArg
      LOGICAL calcAdvection
      LOGICAL implicitAdvection, applyAB_onTracer
      LOGICAL trUseDiffKr4, trUseGMRedi, trUseKPP, trUseSmolHack
      _RL     myTime
      INTEGER myIter, myThid

C !OUTPUT PARAMETERS: ==================================================
C gTracer          :: tendency array
C fZon             :: zonal flux
C fMer             :: meridional flux
C fVerT            :: 2 1/2D arrays for vertical advective flux
      _RL gTracer(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL fZon  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL fMer  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL fVerT (1-OLx:sNx+OLx,1-OLy:sNy+OLy,2)

C !FUNCTIONS:       ====================================================
#ifdef ALLOW_DIAGNOSTICS
      CHARACTER*4 GAD_DIAG_SUFX
      EXTERNAL    GAD_DIAG_SUFX
#endif /* ALLOW_DIAGNOSTICS */

C !LOCAL VARIABLES: ====================================================
C i,j              :: loop indices
C advectionScheme  :: local copy of routine argument advectionSchArg
C vertAdvecScheme  :: local copy of routine argument vertAdvecSchArg
C df4              :: used for storing del^2 T for bi-harmonic term
C af               :: advective flux
C df               :: diffusive flux
C localT           :: local copy of tracer field
C locABT           :: local copy of (AB-extrapolated) tracer field
      INTEGER i,j
      INTEGER advectionScheme, vertAdvecScheme
      _RS maskLocW(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RS maskLocS(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL df4   (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL af    (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL df    (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL localT(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL locABT(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL advFac, rAdvFac
#ifdef GAD_SMOLARKIEWICZ_HACK
      _RL outFlux, trac, gTrFac
#endif
#ifdef ALLOW_DIAGNOSTICS
      CHARACTER*8 diagName
      CHARACTER*4 diagSufx
#endif
CEOP

C     make local copies to be tampered with if necessary
      advectionScheme = advectionSchArg
      vertAdvecScheme = vertAdvecSchArg
#ifdef ALLOW_AUTODIFF
#ifdef ALLOW_AUTODIFF_TAMC
CADJ INIT gad_local_tape = COMMON, 1
C     This store directive just suppresses a recomputation warning.
C     TAF generates an extra field with or without this directive.
CADJ STORE fvert = gad_local_tape
#endif
C--   only the kUp part of fverT is set in this subroutine
C--   the kDown is still required
      fVerT(1,1,kDown) = fVerT(1,1,kDown)
C
      IF ( inAdMode .AND. useApproxAdvectionInAdMode ) THEN
C     In AD-mode, we change non-linear, potentially unstable AD advection
C     schemes to linear schemes with more stability. So far only DST3 with
C     flux limiting is replaced by DST3 without flux limiting, but any
C     combination is possible.
       IF ( advectionSchArg.EQ.ENUM_DST3_FLUX_LIMIT )
     &      advectionScheme = ENUM_DST3
       IF ( vertAdvecSchArg.EQ.ENUM_DST3_FLUX_LIMIT )
     &      vertAdvecScheme = ENUM_DST3
C     here is room for more advection schemes as this becomes necessary
      ENDIF
#endif /* ALLOW_AUTODIFF */

#ifdef ALLOW_DIAGNOSTICS
C--   Set diagnostic suffix for the current tracer
      IF ( useDiagnostics ) THEN
        diagSufx = GAD_DIAG_SUFX( trIdentity, myThid )
      ENDIF
#endif

      advFac  = 0. _d 0
      IF (calcAdvection) advFac = 1. _d 0
      rAdvFac = rkSign*advFac
      IF (implicitAdvection) rAdvFac = rkSign

      DO j=1-OLy,sNy+OLy
       DO i=1-OLx,sNx+OLx
        fZon(i,j)      = 0. _d 0
        fMer(i,j)      = 0. _d 0
        fVerT(i,j,kUp) = 0. _d 0
        df(i,j)        = 0. _d 0
        df4(i,j)       = 0. _d 0
       ENDDO
      ENDDO

C--   Make local copy of tracer array
      IF ( applyAB_onTracer ) THEN
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          localT(i,j)=TracerN(i,j,k)
          locABT(i,j)= TracAB(i,j,k)
         ENDDO
        ENDDO
      ELSE
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          localT(i,j)=TracerN(i,j,k)
          locABT(i,j)=TracerN(i,j,k)
         ENDDO
        ENDDO
      ENDIF

C--   Pre-calculate del^2 T if bi-harmonic coefficient is non-zero
      IF (diffK4 .NE. 0.) THEN
#ifdef ALLOW_AUTODIFF_TAMC
C     These store directives suppress two recomputation warnings and
C     avoid the corresponding recomputations of fZon, fMer at the cost
C     of only four extra local 2D-fields.
CADJ STORE localT = gad_local_tape
#endif
       CALL GAD_GRAD_X(bi,bj,k,xA,localT,fZon,myThid)
#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE localT = gad_local_tape
#endif
       CALL GAD_GRAD_Y(bi,bj,k,yA,localT,fMer,myThid)
#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE fZon, fMer = gad_local_tape
#endif
       CALL GAD_DEL2(bi,bj,k,fZon,fMer,df4,myThid)
      ENDIF

C--   Initialize net flux in X direction
      DO j=1-OLy,sNy+OLy
       DO i=1-OLx,sNx+OLx
        fZon(i,j) = 0. _d 0
       ENDDO
      ENDDO

C-    Advective flux in X
      IF (calcAdvection) THEN
        IF ( advectionScheme.EQ.ENUM_CENTERED_2ND ) THEN
           CALL GAD_C2_ADV_X( bi,bj,k, uTrans, locABT, af, myThid )
        ELSEIF ( advectionScheme.EQ.ENUM_UPWIND_1RST
     &          .OR. advectionScheme.EQ.ENUM_DST2 ) THEN
           CALL GAD_DST2U1_ADV_X( bi,bj,k, advectionScheme, .TRUE.,
     I              deltaTLev(k), uTrans, uFld, locABT,
     O              af, myThid )
        ELSE
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
#ifdef ALLOW_OBCS
           maskLocW(i,j) = _maskW(i,j,k,bi,bj)*maskInW(i,j,bi,bj)
#else /* ALLOW_OBCS */
           maskLocW(i,j) = _maskW(i,j,k,bi,bj)
#endif /* ALLOW_OBCS */
          ENDDO
         ENDDO
         IF ( advectionScheme.EQ.ENUM_FLUX_LIMIT ) THEN
           CALL GAD_FLUXLIMIT_ADV_X( bi,bj,k, .TRUE., deltaTLev(k),
     I              uTrans, uFld, maskLocW, locABT,
     O              af, myThid )
         ELSEIF ( advectionScheme.EQ.ENUM_UPWIND_3RD ) THEN
           CALL GAD_U3_ADV_X( bi,bj,k, uTrans, maskLocW, locABT,
     O              af, myThid )
         ELSEIF ( advectionScheme.EQ.ENUM_CENTERED_4TH ) THEN
           CALL GAD_C4_ADV_X( bi,bj,k, uTrans, maskLocW, locABT,
     O              af, myThid )
         ELSEIF ( advectionScheme.EQ.ENUM_DST3 ) THEN
           CALL GAD_DST3_ADV_X( bi,bj,k, .TRUE., deltaTLev(k),
     I              uTrans, uFld, maskLocW, locABT,
     O              af, myThid )
         ELSEIF ( advectionScheme.EQ.ENUM_DST3_FLUX_LIMIT ) THEN
           CALL GAD_DST3FL_ADV_X( bi,bj,k, .TRUE., deltaTLev(k),
     I              uTrans, uFld, maskLocW, locABT,
     O              af, myThid )
         ELSEIF ( advectionScheme.EQ.ENUM_OS7MP ) THEN
           CALL GAD_OS7MP_ADV_X( bi,bj,k, .TRUE., deltaTLev(k),
     I              uTrans, uFld, maskLocW, locABT,
     O              af, myThid )
         ELSE
          STOP 'GAD_CALC_RHS: Bad advectionScheme (X)'
         ENDIF
        ENDIF
#ifdef ALLOW_OBCS
        IF ( useOBCS ) THEN
C-      replace advective flux with 1st order upwind scheme estimate
          CALL OBCS_U1_ADV_TRACER( .TRUE., trIdentity, bi, bj, k,
     I                             maskW(1-OLx,1-OLy,k,bi,bj),
     I                             uTrans, locABT,
     U                             af, myThid )
        ENDIF
#endif /* ALLOW_OBCS */
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          fZon(i,j) = fZon(i,j) + af(i,j)
         ENDDO
        ENDDO
#ifdef ALLOW_DIAGNOSTICS
        IF ( useDiagnostics ) THEN
          diagName = 'ADVx'//diagSufx
          CALL DIAGNOSTICS_FILL( af, diagName, k,1, 2,bi,bj, myThid )
        ENDIF
#ifdef ALLOW_LAYERS
        IF ( layers_useThermo ) THEN
          CALL LAYERS_FILL( af, trIdentity, 'AFX',
     &                      k, 1, 2,bi,bj, myThid )
        ENDIF
#endif /* ENDIF */
#endif
      ENDIF

C-    Diffusive flux in X
      IF (diffKh.NE.0.) THEN
       CALL GAD_DIFF_X(bi,bj,k,xA,diffKh,localT,df,myThid)
      ELSE
       DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
         df(i,j) = 0. _d 0
        ENDDO
       ENDDO
      ENDIF

C-    Add bi-harmonic diffusive flux in X
      IF (diffK4 .NE. 0.) THEN
       CALL GAD_BIHARM_X(bi,bj,k,xA,df4,diffK4,df,myThid)
      ENDIF

#ifdef ALLOW_GMREDI
C-    GM/Redi flux in X
      IF ( trUseGMRedi ) THEN
        CALL GMREDI_XTRANSPORT(
     I         trIdentity, bi, bj, k, iMin, iMax+1, jMin, jMax,
     I         xA, maskUp, TracerN,
     U         df,
     I         myThid )
      ENDIF
#endif
C     anelastic: advect.fluxes are scaled by rhoFac but hor.diff. flx are not
      DO j=1-OLy,sNy+OLy
       DO i=1-OLx,sNx+OLx
        fZon(i,j) = fZon(i,j) + df(i,j)*rhoFacC(k)
       ENDDO
      ENDDO

#ifdef ALLOW_DIAGNOSTICS
C-    Diagnostics of Tracer flux in X dir (mainly Diffusive term),
C       excluding advective terms:
      IF ( useDiagnostics .AND.
     &    (diffKh.NE.0. .OR. diffK4 .NE.0. .OR. trUseGMRedi) ) THEN
          diagName = 'DFxE'//diagSufx
          CALL DIAGNOSTICS_FILL( df, diagName, k,1, 2,bi,bj, myThid )
#ifdef ALLOW_LAYERS
          IF ( layers_useThermo ) THEN
           CALL LAYERS_FILL( df, trIdentity, 'DFX',
     &                       k, 1, 2,bi,bj, myThid )
          ENDIF
#endif /* ALLOW_LAYERS */
      ENDIF
#endif

C--   Initialize net flux in Y direction
      DO j=1-OLy,sNy+OLy
       DO i=1-OLx,sNx+OLx
        fMer(i,j) = 0. _d 0
       ENDDO
      ENDDO

C-    Advective flux in Y
      IF (calcAdvection) THEN
        IF ( advectionScheme.EQ.ENUM_CENTERED_2ND ) THEN
           CALL GAD_C2_ADV_Y( bi,bj,k, vTrans, locABT, af, myThid )
        ELSEIF ( advectionScheme.EQ.ENUM_UPWIND_1RST
     &          .OR. advectionScheme.EQ.ENUM_DST2 ) THEN
           CALL GAD_DST2U1_ADV_Y( bi,bj,k, advectionScheme, .TRUE.,
     I              deltaTLev(k), vTrans, vFld, locABT,
     O              af, myThid )
        ELSE
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
#ifdef ALLOW_OBCS
           maskLocS(i,j) = _maskS(i,j,k,bi,bj)*maskInS(i,j,bi,bj)
#else /* ALLOW_OBCS */
           maskLocS(i,j) = _maskS(i,j,k,bi,bj)
#endif /* ALLOW_OBCS */
          ENDDO
         ENDDO
         IF ( advectionScheme.EQ.ENUM_FLUX_LIMIT ) THEN
           CALL GAD_FLUXLIMIT_ADV_Y( bi,bj,k, .TRUE., deltaTLev(k),
     I              vTrans, vFld, maskLocS, locABT,
     O              af, myThid )
         ELSEIF ( advectionScheme.EQ.ENUM_UPWIND_3RD ) THEN
           CALL GAD_U3_ADV_Y( bi,bj,k, vTrans, maskLocS, locABT,
     O              af, myThid )
         ELSEIF ( advectionScheme.EQ.ENUM_CENTERED_4TH ) THEN
           CALL GAD_C4_ADV_Y( bi,bj,k, vTrans, maskLocS, locABT,
     O              af, myThid )
         ELSEIF ( advectionScheme.EQ.ENUM_DST3 ) THEN
           CALL GAD_DST3_ADV_Y( bi,bj,k, .TRUE., deltaTLev(k),
     I              vTrans, vFld, maskLocS, locABT,
     O              af, myThid )
         ELSEIF ( advectionScheme.EQ.ENUM_DST3_FLUX_LIMIT ) THEN
           CALL GAD_DST3FL_ADV_Y( bi,bj,k, .TRUE., deltaTLev(k),
     I              vTrans, vFld, maskLocS, locABT,
     O              af, myThid )
         ELSEIF ( advectionScheme.EQ.ENUM_OS7MP ) THEN
           CALL GAD_OS7MP_ADV_Y( bi,bj,k, .TRUE., deltaTLev(k),
     I              vTrans, vFld, maskLocS, locABT,
     O              af, myThid )
         ELSE
           STOP 'GAD_CALC_RHS: Bad advectionScheme (Y)'
         ENDIF
        ENDIF
#ifdef ALLOW_OBCS
        IF ( useOBCS ) THEN
C-      replace advective flux with 1st order upwind scheme estimate
          CALL OBCS_U1_ADV_TRACER( .FALSE., trIdentity, bi, bj, k,
     I                             maskS(1-OLx,1-OLy,k,bi,bj),
     I                             vTrans, locABT,
     U                             af, myThid )
        ENDIF
#endif /* ALLOW_OBCS */
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          fMer(i,j) = fMer(i,j) + af(i,j)
         ENDDO
        ENDDO
#ifdef ALLOW_DIAGNOSTICS
        IF ( useDiagnostics ) THEN
          diagName = 'ADVy'//diagSufx
          CALL DIAGNOSTICS_FILL( af, diagName, k,1, 2,bi,bj, myThid )
        ENDIF
#ifdef ALLOW_LAYERS
        IF ( layers_useThermo ) THEN
          CALL LAYERS_FILL( af, trIdentity, 'AFY',
     &                          k, 1, 2,bi,bj, myThid )
        ENDIF
#endif /* ALLOW_LAYES */
#endif
      ENDIF

C-    Diffusive flux in Y
      IF (diffKh.NE.0.) THEN
       CALL GAD_DIFF_Y(bi,bj,k,yA,diffKh,localT,df,myThid)
      ELSE
       DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
         df(i,j) = 0. _d 0
        ENDDO
       ENDDO
      ENDIF

C-    Add bi-harmonic flux in Y
      IF (diffK4 .NE. 0.) THEN
       CALL GAD_BIHARM_Y(bi,bj,k,yA,df4,diffK4,df,myThid)
      ENDIF

#ifdef ALLOW_GMREDI
C-    GM/Redi flux in Y
      IF ( trUseGMRedi ) THEN
        CALL GMREDI_YTRANSPORT(
     I         trIdentity, bi, bj, k, iMin, iMax, jMin, jMax+1,
     I         yA, maskUp, TracerN,
     U         df,
     I         myThid )
      ENDIF
#endif
C     anelastic: advect.fluxes are scaled by rhoFac but hor.diff. flx are not
      DO j=1-OLy,sNy+OLy
       DO i=1-OLx,sNx+OLx
        fMer(i,j) = fMer(i,j) + df(i,j)*rhoFacC(k)
       ENDDO
      ENDDO

#ifdef ALLOW_DIAGNOSTICS
C-    Diagnostics of Tracer flux in Y dir (mainly Diffusive terms),
C       excluding advective terms:
      IF ( useDiagnostics .AND.
     &    (diffKh.NE.0. .OR. diffK4 .NE.0. .OR. trUseGMRedi) ) THEN
          diagName = 'DFyE'//diagSufx
          CALL DIAGNOSTICS_FILL( df, diagName, k,1, 2,bi,bj, myThid )
#ifdef ALLOW_LAYERS
          IF ( layers_useThermo ) THEN
           CALL LAYERS_FILL( df, trIdentity, 'DFY',
     &                           k, 1, 2,bi,bj, myThid )
          ENDIF
#endif /* ALLOW_LAYERS */
      ENDIF
#endif

C--   Compute vertical flux fVerT(kUp) at interface k (between k-1 & k):
C-    Advective flux in R
#ifdef ALLOW_AIM
C- a hack to prevent Water-Vapor vert.transport into the stratospheric level Nr
      IF (calcAdvection .AND. .NOT.implicitAdvection .AND. k.GE.2 .AND.
     &     (.NOT.useAIM .OR. trIdentity.NE.GAD_SALINITY .OR. k.LT.Nr)
     &   ) THEN
#else
      IF (calcAdvection .AND. .NOT.implicitAdvection .AND. k.GE.2) THEN
#endif
       IF ( applyAB_onTracer ) THEN
C-    Compute vertical advective flux in the interior using TracAB:
        IF ( vertAdvecScheme.EQ.ENUM_CENTERED_2ND ) THEN
           CALL GAD_C2_ADV_R( bi,bj,k, rTrans, TracAB, af, myThid )
        ELSEIF ( vertAdvecScheme.EQ.ENUM_UPWIND_1RST
     &          .OR. vertAdvecScheme.EQ.ENUM_DST2 ) THEN
           CALL GAD_DST2U1_ADV_R( bi,bj,k,vertAdvecScheme,deltaTLev(k),
     I              rTrans, wFld, TracAB,
     O              af, myThid )
        ELSEIF ( vertAdvecScheme.EQ.ENUM_FLUX_LIMIT ) THEN
           CALL GAD_FLUXLIMIT_ADV_R( bi,bj,k, deltaTLev(k),
     I              rTrans, wFld, TracAB,
     O              af, myThid )
        ELSEIF ( vertAdvecScheme.EQ.ENUM_UPWIND_3RD ) THEN
           CALL GAD_U3_ADV_R( bi,bj,k, rTrans, TracAB, af, myThid )
        ELSEIF (vertAdvecScheme.EQ.ENUM_CENTERED_4TH) THEN
           CALL GAD_C4_ADV_R( bi,bj,k, rTrans, TracAB, af, myThid )
        ELSEIF ( vertAdvecScheme.EQ.ENUM_DST3 ) THEN
           CALL GAD_DST3_ADV_R( bi,bj,k, deltaTLev(k),
     I              rTrans, wFld, TracAB,
     O              af, myThid )
        ELSEIF ( vertAdvecScheme.EQ.ENUM_DST3_FLUX_LIMIT ) THEN
           CALL GAD_DST3FL_ADV_R( bi,bj,k, deltaTLev(k),
     I              rTrans, wFld, TracAB,
     O              af, myThid )
        ELSEIF ( vertAdvecScheme.EQ.ENUM_OS7MP ) THEN
           CALL GAD_OS7MP_ADV_R( bi,bj,k, deltaTLev(k),
     I              rTrans, wFld, TracAB,
     O              af, myThid )
        ELSE
          STOP 'GAD_CALC_RHS: Bad vertAdvecScheme (R)'
        ENDIF
       ELSE
C-    Compute vertical advective flux in the interior using TracerN:
        IF ( vertAdvecScheme.EQ.ENUM_CENTERED_2ND ) THEN
           CALL GAD_C2_ADV_R( bi,bj,k, rTrans, TracerN, af, myThid )
        ELSEIF ( vertAdvecScheme.EQ.ENUM_UPWIND_1RST
     &          .OR. vertAdvecScheme.EQ.ENUM_DST2 ) THEN
           CALL GAD_DST2U1_ADV_R( bi,bj,k,vertAdvecScheme,deltaTLev(k),
     I              rTrans, wFld, TracerN,
     O              af, myThid )
        ELSEIF ( vertAdvecScheme.EQ.ENUM_FLUX_LIMIT ) THEN
           CALL GAD_FLUXLIMIT_ADV_R( bi,bj,k, deltaTLev(k),
     I              rTrans, wFld, TracerN,
     O              af, myThid )
        ELSEIF ( vertAdvecScheme.EQ.ENUM_UPWIND_3RD ) THEN
           CALL GAD_U3_ADV_R( bi,bj,k, rTrans, TracerN, af, myThid )
        ELSEIF ( vertAdvecScheme.EQ.ENUM_CENTERED_4TH ) THEN
           CALL GAD_C4_ADV_R( bi,bj,k, rTrans, TracerN, af, myThid )
        ELSEIF( vertAdvecScheme.EQ.ENUM_DST3 ) THEN
           CALL GAD_DST3_ADV_R( bi,bj,k, deltaTLev(k),
     I              rTrans, wFld, TracerN,
     O              af, myThid )
        ELSEIF ( vertAdvecScheme.EQ.ENUM_DST3_FLUX_LIMIT ) THEN
           CALL GAD_DST3FL_ADV_R( bi,bj,k, deltaTLev(k),
     I              rTrans, wFld, TracerN,
     O              af, myThid )
        ELSEIF ( vertAdvecScheme.EQ.ENUM_OS7MP ) THEN
           CALL GAD_OS7MP_ADV_R( bi,bj,k, deltaTLev(k),
     I              rTrans, wFld, TracerN,
     O              af, myThid )
        ELSE
          STOP 'GAD_CALC_RHS: Bad vertAdvecScheme (R)'
        ENDIF
       ENDIF
C-     add the advective flux to fVerT
       DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
          fVerT(i,j,kUp) = fVerT(i,j,kUp) + af(i,j)*maskInC(i,j,bi,bj)
        ENDDO
       ENDDO
#ifdef ALLOW_DIAGNOSTICS
       IF ( useDiagnostics ) THEN
          diagName = 'ADVr'//diagSufx
          CALL DIAGNOSTICS_FILL( af, diagName, k,1, 2,bi,bj, myThid )
C- note: needs to explicitly increment the counter since DIAGNOSTICS_FILL
C        does it only if k=1 (never the case here)
          IF ( k.EQ.2 ) CALL DIAGNOSTICS_COUNT(diagName,bi,bj,myThid)
#ifdef ALLOW_LAYERS
          IF ( layers_useThermo ) THEN
            CALL LAYERS_FILL(af,trIdentity,'AFR',k,1,2,bi,bj,myThid)
          ENDIF
#endif /* ALLOW_LAYERS */
       ENDIF
#endif
      ENDIF

C-    Diffusive flux in R
C     Note: For K=1 then KM1=1 and this gives a dT/dr = 0 upper
C           boundary condition.
      IF (implicitDiffusion) THEN
       DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
         df(i,j) = 0. _d 0
        ENDDO
       ENDDO
      ELSE
        CALL GAD_DIFF_R(
     I                    bi,bj,k, maskup, KappaR, TracerN,
     O                    df, myThid )
      ENDIF

      IF ( trUseDiffKr4 ) THEN
        CALL GAD_BIHARM_R(
     I                    bi,bj,k, maskUp, diffKr4, TracerN,
     U                    df, myThid )
      ENDIF

#ifdef ALLOW_GMREDI
C-    GM/Redi flux in R
      IF ( trUseGMRedi ) THEN
        CALL GMREDI_RTRANSPORT(
     I         trIdentity, bi, bj, k, iMin, iMax, jMin, jMax,
     I         maskUp, TracerN,
     U         df,
     I         myThid )
      ENDIF
#endif

      DO j=1-OLy,sNy+OLy
       DO i=1-OLx,sNx+OLx
        fVerT(i,j,kUp) = fVerT(i,j,kUp) + df(i,j)
       ENDDO
      ENDDO

#ifdef ALLOW_DIAGNOSTICS
C-    Diagnostics of Tracer flux in R dir (mainly Diffusive terms),
C       Explicit terms only & excluding advective terms:
      IF ( useDiagnostics .AND.
     &    (.NOT.implicitDiffusion .OR. trUseDiffKr4 .OR. trUseGMRedi)
     &   ) THEN
          diagName = 'DFrE'//diagSufx
          CALL DIAGNOSTICS_FILL( df, diagName, k,1, 2,bi,bj, myThid )
#ifdef ALLOW_LAYERS
          IF ( layers_useThermo ) THEN
           CALL LAYERS_FILL(df,trIdentity,'DFR',k,1,2,bi,bj,myThid)
          ENDIF
#endif /* ALLOW_LAYERS */
      ENDIF
#endif

#ifdef ALLOW_KPP
C-    Set non local KPP transport term (ghat):
      IF ( trUseKPP .AND. k.GE.2 ) THEN
       DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
         df(i,j) = 0. _d 0
        ENDDO
       ENDDO
       IF (trIdentity.EQ.GAD_TEMPERATURE) THEN
        CALL KPP_TRANSPORT_T(
     I           iMin,iMax,jMin,jMax,bi,bj,k,km1,
     O           df,
     I           myTime, myIter, myThid )
       ELSEIF (trIdentity.EQ.GAD_SALINITY) THEN
        CALL KPP_TRANSPORT_S(
     I           iMin,iMax,jMin,jMax,bi,bj,k,km1,
     O           df,
     I           myTime, myIter, myThid )
#ifdef ALLOW_PTRACERS
       ELSEIF (trIdentity .GE. GAD_TR1) THEN
        CALL KPP_TRANSPORT_PTR(
     I           iMin,iMax,jMin,jMax,bi,bj,k,km1,
     I           trIdentity-GAD_TR1+1,
     O           df,
     I           myTime, myIter, myThid )
#endif
       ELSE
        WRITE(errorMessageUnit,*)
     &    'tracer identity =', trIdentity, ' is not valid => STOP'
        STOP 'ABNORMAL END: S/R GAD_CALC_RHS: invalid tracer identity'
       ENDIF
       DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
         fVerT(i,j,kUp) = fVerT(i,j,kUp)
     &                  + df(i,j)*maskUp(i,j)*rhoFacF(k)
        ENDDO
       ENDDO
#ifdef ALLOW_DIAGNOSTICS
C-    Diagnostics of Non-Local Tracer (vertical) flux
       IF ( useDiagnostics ) THEN
         diagName = 'KPPg'//diagSufx
         CALL DIAGNOSTICS_FILL( df, diagName, k,1, 2,bi,bj, myThid )
C- note: needs to explicitly increment the counter since DIAGNOSTICS_FILL
C        does it only if k=1 (never the case here)
         IF ( k.EQ.2 ) CALL DIAGNOSTICS_COUNT(diagName,bi,bj,myThid)
#ifdef ALLOW_LAYERS
         IF ( layers_useThermo ) THEN
          CALL LAYERS_FILL(df,trIdentity,'DFR',k,1,2,bi,bj,myThid)
         ENDIF
#endif /* ALLOW_LAYERS */
       ENDIF
#endif
      ENDIF
#endif /* ALLOW_KPP */

#ifdef GAD_SMOLARKIEWICZ_HACK
coj   Hack to make redi (and everything else in this s/r) positive
coj   (see Smolarkiewicz MWR 1989 and Bott MWR 1989).
coj   Only works if 'down' is k+1 and k loop in thermodynamics is k=Nr,1,-1
      IF ( trUseSmolHack ) THEN
       DO j=1-OLy,sNy+OLy-1
        DO i=1-OLx,sNx+OLx-1
coj   Add outgoing fluxes
         outFlux=deltaTLev(k)*
     &    _recip_hFacC(i,j,k,bi,bj)*recip_drF(k)
     &   *recip_rA(i,j,bi,bj)*recip_deepFac2C(k)*recip_rhoFacC(k)
     &    *( MAX(0. _d 0,fZon(i+1,j)) + MAX(0. _d 0,-fZon(i,j))
     &      +MAX(0. _d 0,fMer(i,j+1)) + MAX(0. _d 0,-fMer(i,j))
     &      +MAX(0. _d 0,fVerT(i,j,kDown)*rkSign)
     &      +MAX(0. _d 0,-fVerT(i,j,kUp)*rkSign)
     &     )
         trac = localT(i,j)
coj   If they would reduce tracer by a fraction of more than
coj   SmolarkiewiczMaxFrac, scale them down
         IF (outFlux.GT.0. _d 0 .AND.
     &       outFlux.GT.SmolarkiewiczMaxFrac*trac) THEN
coj   If tracer is already negative, scale flux to zero
           gTrFac = MAX(0. _d 0,SmolarkiewiczMaxFrac*trac/outFlux)

           IF (fZon(i+1,j).GT.0. _d 0) fZon(i+1,j)=gTrFac*fZon(i+1,j)
           IF (-fZon(i,j) .GT.0. _d 0) fZon(i,j)  =gTrFac*fZon(i,j)
           IF (fMer(i,j+1).GT.0. _d 0) fMer(i,j+1)=gTrFac*fMer(i,j+1)
           IF (-fMer(i,j) .GT.0. _d 0) fMer(i,j)  =gTrFac*fMer(i,j)
           IF (-fVerT(i,j,kUp)*rkSign .GT.0. _d 0)
     &       fVerT(i,j,kUp)=gTrFac*fVerT(i,j,kUp)

           IF (k.LT.Nr .AND. fVerT(i,j,kDown)*rkSign.GT.0. _d 0) THEN
coj   Down flux is special: it has already been applied in lower layer,
coj   so we have to readjust this.
coj   undo down flux, ...
             gTracer(i,j,k+1) = gTracer(i,j,k+1)
     &        +_recip_hFacC(i,j,k+1,bi,bj)*recip_drF(k+1)
     &         *recip_rA(i,j,bi,bj)*recip_deepFac2C(k+1)
     &         *recip_rhoFacC(k+1)
     &         *( -fVerT(i,j,kDown)*rkSign )
coj   ... scale ...
             fVerT(i,j,kDown)=gTrFac*fVerT(i,j,kDown)
coj   ... and reapply
             gTracer(i,j,k+1) = gTracer(i,j,k+1)
     &        +_recip_hFacC(i,j,k+1,bi,bj)*recip_drF(k+1)
     &         *recip_rA(i,j,bi,bj)*recip_deepFac2C(k+1)
     &         *recip_rhoFacC(k+1)
     &         *( fVerT(i,j,kDown)*rkSign )
           ENDIF

         ENDIF
        ENDDO
       ENDDO
      ENDIF
#endif /* GAD_SMOLARKIEWICZ_HACK */

C--   Divergence of fluxes
C     Anelastic: scale vertical fluxes by rhoFac and leave Horizontal fluxes unchanged
C     for Stevens OBC: keep only vertical diffusive contribution on boundaries
      DO j=1-OLy,sNy+OLy-1
       DO i=1-OLx,sNx+OLx-1
        gTracer(i,j,k) = gTracer(i,j,k)
     &   -_recip_hFacC(i,j,k,bi,bj)*recip_drF(k)
     &   *recip_rA(i,j,bi,bj)*recip_deepFac2C(k)*recip_rhoFacC(k)
     &   *( (fZon(i+1,j)-fZon(i,j))*maskInC(i,j,bi,bj)
     &     +(fMer(i,j+1)-fMer(i,j))*maskInC(i,j,bi,bj)
     &     +(fVerT(i,j,kDown)-fVerT(i,j,kUp))*rkSign
     &     -localT(i,j)*( (uTrans(i+1,j)-uTrans(i,j))*advFac
     &                   +(vTrans(i,j+1)-vTrans(i,j))*advFac
     &                   +(rTransKp1(i,j)-rTrans(i,j))*rAdvFac
     &                  )*maskInC(i,j,bi,bj)
     &    )
       ENDDO
      ENDDO

#ifdef ALLOW_DEBUG
      IF ( debugLevel .GE. debLevC
     &   .AND. trIdentity.EQ.GAD_TEMPERATURE
     &   .AND. k.EQ.2 .AND. myIter.EQ.1+nIter0
     &   .AND. nPx.EQ.1 .AND. nPy.EQ.1
     &   .AND. useCubedSphereExchange ) THEN
        CALL DEBUG_CS_CORNER_UV( ' fZon,fMer from GAD_CALC_RHS',
     &             fZon,fMer, k, standardMessageUnit,bi,bj,myThid )
      ENDIF
#endif /* ALLOW_DEBUG */

      RETURN
      END

#include "DEBUG_OPTIONS.h"

      SUBROUTINE DEBUG_LEAVE(
     I                text,
     I                myThid )
C     /==========================================================\
C     | SUBROUTINE DEBUG_LEAVE                                   |
C     | o Prints to STDOUT the text argument after "LEAVING S/R" |
C     |==========================================================|
C     \==========================================================/
      IMPLICIT NONE

C     === Global data ===
#include "SIZE.h"
#include "EEPARAMS.h"

C     === Routine arguments ===
      CHARACTER*(*) text
      INTEGER myThid

C     === Local variables ====
      CHARACTER*(MAX_LEN_MBUF) msgBuf

      WRITE(msgBuf,'(A,A)') 'LEAVING S/R ',text
      CALL DEBUG_MSG( msgBuf, myThid )

      RETURN
      END

#include "SEAICE_OPTIONS.h"

      SUBROUTINE SEAICE_COST_SENSI( myTime, myIter, myThid )
C     *==========================================================*
C     | SUBROUTINE SEAICE_COST_SENSI
C     | o driver for seaice sensitivity cost functions
C     *==========================================================*

      IMPLICIT NONE

C     == Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"

C     == Routine arguments ==
C     myThid - Thread number for this instance of the routine.
      _RL myTime
      INTEGER myIter
      INTEGER myThid

#ifdef ALLOW_COST
C     == Local variables

      CALL SEAICE_COST_TEST ( myTime, myIter, myThid )

      CALL SEAICE_COST_ACCUMULATE_MEAN (
     &    myTime, myIter, myThid)

#endif

      RETURN
      END

#include "SEAICE_OPTIONS.h"
#ifdef ALLOW_OBCS
# include "OBCS_OPTIONS.h"
#endif

C--   File seaice_preconditioner.F:
C--   Contents
C--   o SEAICE_PRECONDITIONER
C--   o SEAICE_PRECOND_RHSU
C--   o SEAICE_PRECOND_RHSV

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

CBOP
C     !ROUTINE: SEAICE_PRECONDITIONER
C     !INTERFACE:
      SUBROUTINE SEAICE_PRECONDITIONER(
     U     duIce, dvIce,
     I     zetaPre, etaPre, etaZpre, zetaZpre, dwatPre,
     I     newtonIter, krylovIter, myTime, myIter, myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE SEAICE_PRECONDITIONER
C     | o Preconditioner for Jacobian-free Newton-Krylov solver,
C     |   compute improved first guess solution du/vIce, with
C     |   suboptimal solver, here LSOR
C     *==========================================================*
C     | written by Martin Losch, Oct 2012
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "DYNVARS.h"
#include "GRID.h"
#include "SEAICE_SIZE.h"
#include "SEAICE_PARAMS.h"
#include "SEAICE_GRID.h"
#include "SEAICE.h"

C     !INPUT PARAMETERS:
C     === Routine arguments ===
C     myTime :: Simulation time
C     myIter :: Simulation timestep number
C     myThid :: my Thread Id. number
C     newtonIter :: current iterate of Newton iteration
C     krylovIter :: current iterate of Krylov iteration
C     *Pre are precomputed and held fixed during the Krylov iteration
      _RL   zetaPre(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL  zetaZPre(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL    etaPre(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL   etaZPre(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL   dwatPre(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      INTEGER newtonIter
      INTEGER krylovIter
      _RL     myTime
      INTEGER myIter
      INTEGER myThid

C     !OUTPUT PARAMETERS:
C     du/vIce :: solution vector
      _RL duIce(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL dvIce(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
CEOP

#if ( defined SEAICE_CGRID && \
      ( defined SEAICE_ALLOW_JFNK || defined SEAICE_ALLOW_KRYLOV ) )
C     !FUNCTIONS:
      LOGICAL  DIFFERENT_MULTIPLE
      EXTERNAL DIFFERENT_MULTIPLE

C     !LOCAL VARIABLES:
C     === Local variables ===
C     i,j,bi,bj  :: Loop counters

      INTEGER i, j, m, bi, bj
      INTEGER k
      INTEGER iMin, iMax, jMin, jMax
      CHARACTER*(MAX_LEN_MBUF) msgBuf

      _RL WFAU, WFAV

C     diagonals of coefficient matrices
      _RL AU   (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL BU   (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL CU   (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL AV   (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL BV   (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL CV   (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
C     RHS
      _RL rhsU (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL rhsV (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL rhsU0(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL rhsV0(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
C     coefficients for lateral points, u(j+/-1)
      _RL uRt1(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL uRt2(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
C     coefficients for lateral points, v(i+/-1)
      _RL vRt1(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL vRt2(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
C     abbreviations
      _RL etaPlusZeta (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL zetaMinusEta(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
C     symmetric drag coefficient
      _RL dragSym(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
C     auxillary fields
      _RL uTmp (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL vTmp (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RS SINWAT
      _RL COSWAT
      _RL coriFac
      _RL fricFac
      LOGICAL printResidual
      _RL residUini, residVini, residUend, residVend
C
CEOP

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      printResidual = debugLevel.GE.debLevC
     &  .AND. DIFFERENT_MULTIPLE( SEAICE_monFreq, myTime, deltaTClock )

C     extra overlap for (restricted) additive Schwarz method
      jMin = 1-SEAICE_OLy
      jMax = sNy+SEAICE_OLy
      iMin = 1-SEAICE_OLx
      iMax = sNx+SEAICE_OLx
C     convergence is affected with coriFac = fricFac = 1
      coriFac = 0. _d 0
      fricFac = coriFac
C     surface level
      k = 1
C--   introduce turning angles
      SINWAT=SIN(SEAICE_waterTurnAngle*deg2rad)
      COSWAT=COS(SEAICE_waterTurnAngle*deg2rad)

C     copy relaxation parameters
      WFAU=SEAICE_LSRrelaxU
      WFAV=SEAICE_LSRrelaxV
C
C     Initialise
C
      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          rhsU (I,J,bi,bj) = 0. _d 0
          rhsV (I,J,bi,bj) = 0. _d 0
          rhsU0(I,J,bi,bj) = duIce(I,J,bi,bj)
          rhsV0(I,J,bi,bj) = dvIce(I,J,bi,bj)
C     first guess for the increment is 0.
          duIce(I,J,bi,bj) = 0. _d 0
          dvIce(I,J,bi,bj) = 0. _d 0
C     this is only the symmetric part of the drag
          dragSym(I,J,bi,bj) = dwatPre(I,J,bi,bj)*COSWAT
         ENDDO
        ENDDO
       ENDDO
      ENDDO
C
C     some abbreviations
C
      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        DO J=jMin-1,jMax
         DO I=iMin-1,iMax
          etaPlusZeta (I,J,bi,bj)= etaPre(I,J,bi,bj)+zetaPre(I,J,bi,bj)
          zetaMinusEta(I,J,bi,bj)=zetaPre(I,J,bi,bj)- etaPre(I,J,bi,bj)
         ENDDO
        ENDDO
       ENDDO
      ENDDO
C
C     calculate coefficients of tridiagonal matrices for both u- and
C     v-equations
C
      CALL SEAICE_LSR_CALC_COEFFS(
     I     etaPlusZeta, zetaMinusEta, etaZpre, zetaZpre, dragSym,
     O     AU, BU, CU, AV, BV, CV, uRt1, uRt2, vRt1, vRt2,
     I     iMin, iMax, jMin, jMax, myTime, myIter, myThid )

#ifndef OBCS_UVICE_OLD
C--     prevent tri-diagonal solver from modifying OB values:
      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        DO J=jMin,jMax
         DO I=iMin,iMax
          IF ( maskInC(i,j,bi,bj)*maskInC(i-1,j,bi,bj) .EQ. 0. ) THEN
           AU(I,J,bi,bj)   = ZERO
           BU(I,J,bi,bj)   = ONE
           CU(I,J,bi,bj)   = ZERO
           uRt1(I,J,bi,bj) = ZERO
           uRt2(I,J,bi,bj) = ZERO
          ENDIF
          IF ( maskInC(i,j,bi,bj)*maskInC(i,j-1,bi,bj) .EQ. 0. ) THEN
           AV(I,J,bi,bj)   = ZERO
           BV(I,J,bi,bj)   = ONE
           CV(I,J,bi,bj)   = ZERO
           vRt1(I,J,bi,bj) = ZERO
           vRt2(I,J,bi,bj) = ZERO
          ENDIF
         ENDDO
        ENDDO
       ENDDO
      ENDDO
#endif /* OBCS_UVICE_OLD */

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#ifdef ALLOW_DEBUG
      IF ( debugLevel .GE. debLevD ) THEN
        WRITE(msgBuf,'(A,I3,A,I3,A)')
     &        'Uice pre iter (SEAICE_PRECONDITIONER',
     &      newtonIter, ',', krylovIter, ')'
        CALL DEBUG_STATS_RL( 1, UICE, msgBuf, myThid )
        WRITE(msgBuf,'(A,I3,A,I3,A)')
     &        'Vice pre iter (SEAICE_PRECONDITIONER',
     &      newtonIter, ',', krylovIter, ')'
        CALL DEBUG_STATS_RL( 1, VICE, msgBuf, myThid )
      ENDIF
#endif /* ALLOW_DEBUG */

C--   Calculate initial residual of the linearised system
      IF ( printResidual ) THEN
C     set up right-hand side now (will be redone in each iteration)
       DO bj=myByLo(myThid),myByHi(myThid)
        DO bi=myBxLo(myThid),myBxHi(myThid)
         DO j=jMin,jMax
          DO i=iMin,iMax
           rhsU(I,J,bi,bj) = rhsU0(I,J,bi,bj)
           rhsV(I,J,bi,bj) = rhsV0(I,J,bi,bj)
          ENDDO
         ENDDO
         CALL SEAICE_PRECOND_RHSU (
     I        zetaMinusEta, etaPlusZeta, etaZpre, zetaZpre,
     I        dwatPre, coriFac, fricFac, SINWAT, COSWAT,
     I        duIce, dvIce,
     O        rhsU,
     I        iMin,iMax,jMin,jMax,bi,bj,myThid )
         CALL SEAICE_PRECOND_RHSV (
     I        zetaMinusEta, etaPlusZeta, etaZpre, zetaZpre,
     I        dwatPre, coriFac, fricFac, SINWAT, COSWAT,
     I        duIce, dvIce,
     O        rhsV,
     I        iMin,iMax,jMin,jMax,bi,bj,myThid )
#ifndef OBCS_UVICE_OLD
         DO J=jMin,jMax
          DO I=iMin,iMax
           IF ( maskInC(i,j,bi,bj)*maskInC(i-1,j,bi,bj) .EQ. 0. ) THEN
            rhsU(I,J,bi,bj) = duIce(I,J,bi,bj)
           ENDIF
           IF ( maskInC(i,j,bi,bj)*maskInC(i,j-1,bi,bj) .EQ. 0. ) THEN
            rhsV(I,J,bi,bj) = dvIce(I,J,bi,bj)
           ENDIF
          ENDDO
         ENDDO
#endif /* OBCS_UVICE_OLD */
        ENDDO
       ENDDO
       CALL SEAICE_RESIDUAL(
     I                  rhsU, rhsV, uRt1, uRt2, vRt1, vRt2,
     I                  AU, BU, CU, AV, BV, CV, duIce, dvIce,
     O                  residUini, residVini, uTmp, vTmp,
     I                  printResidual, myIter, myThid )
      ENDIF

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C NOW DO ITERATION

C ITERATION START -----------------------------------------------------

      DO m = 1, SEAICEpreconLinIter

       DO bj=myByLo(myThid),myByHi(myThid)
        DO bi=myBxLo(myThid),myBxHi(myThid)

C     save du/vIce prior to iteration
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           uTmp(I,J,bi,bj)=duIce(I,J,bi,bj)
           vTmp(I,J,bi,bj)=dvIce(I,J,bi,bj)
          ENDDO
         ENDDO

C     set up right-hand sides for u- and v-equations
         DO j=jMin,jMax
          DO i=iMin,iMax
           rhsU(I,J,bi,bj) = rhsU0(I,J,bi,bj)
#ifndef SEAICE_PRECOND_EXTRA_EXCHANGE
           rhsV(I,J,bi,bj) = rhsV0(I,J,bi,bj)
#endif /* SEAICE_PRECOND_EXTRA_EXCHANGE */
          ENDDO
         ENDDO
         CALL SEAICE_PRECOND_RHSU (
     I        zetaMinusEta, etaPlusZeta, etaZpre, zetaZPre,
     I        dwatPre, coriFac, fricFac, SINWAT, COSWAT,
     I        duIce, dvIce,
     U        rhsU,
     I        iMin,iMax,jMin,jMax,bi,bj,myThid )
#ifndef SEAICE_PRECOND_EXTRA_EXCHANGE
         CALL SEAICE_PRECOND_RHSV (
     I        zetaMinusEta, etaPlusZeta, etaZpre, zetaZpre,
     I        dwatPre, coriFac, fricFac, SINWAT, COSWAT,
     I        duIce, dvIce,
     U        rhsV,
     I        iMin,iMax,jMin,jMax,bi,bj,myThid )
#endif /* SEAICE_PRECOND_EXTRA_EXCHANGE */
#ifndef OBCS_UVICE_OLD
C--     prevent tri-diagonal solver from modifying OB values:
         DO J=jMin,jMax
          DO I=iMin,iMax
           IF ( maskInC(i,j,bi,bj)*maskInC(i-1,j,bi,bj) .EQ. 0. ) THEN
            rhsU(I,J,bi,bj) = duIce(I,J,bi,bj)
           ENDIF
#ifndef SEAICE_PRECOND_EXTRA_EXCHANGE
           IF ( maskInC(i,j,bi,bj)*maskInC(i,j-1,bi,bj) .EQ. 0. ) THEN
            rhsV(I,J,bi,bj) = dvIce(I,J,bi,bj)
           ENDIF
#endif /* SEAICE_PRECOND_EXTRA_EXCHANGE */
          ENDDO
         ENDDO
#endif /* OBCS_UVICE_OLD */

C Solve for uIce :
         CALL SEAICE_LSR_TRIDIAGU(
     I        AU, BU, CU, uRt1, uRt2, rhsU, uTmp, seaiceMaskU, WFAU,
     U        duIce,
     I        imin, imax, jmin, jmax, bi, bj, myTime, myIter, myThid )

#ifdef SEAICE_PRECOND_EXTRA_EXCHANGE
        ENDDO
       ENDDO
C     ideally one would like to get rid off this exchange
       CALL EXCH_UV_XY_RL( duIce, dvIce, .TRUE., myThid )

       DO bj=myByLo(myThid),myByHi(myThid)
        DO bi=myBxLo(myThid),myBxHi(myThid)
C     set up right-hand-side for v-equation
         DO j=jMin,jMax
          DO i=iMin,iMax
           rhsV(I,J,bi,bj) = rhsV0(I,J,bi,bj)
          ENDDO
         ENDDO
         CALL SEAICE_PRECOND_RHSV (
     I        zetaMinusEta, etaPlusZeta, etaZpre, zetaZpre,
     I        dwatPre, coriFac, fricFac, SINWAT, COSWAT,
     I        duIce, dvIce,
     U        rhsV,
     I        iMin,iMax,jMin,jMax,bi,bj,myThid )
#ifndef OBCS_UVICE_OLD
C--     prevent tri-diagonal solver from modifying OB values:
         DO J=jMin,jMax
          DO I=iMin,iMax
           IF ( maskInC(i,j,bi,bj)*maskInC(i,j-1,bi,bj) .EQ. 0. ) THEN
            rhsV(I,J,bi,bj) = dvIce(I,J,bi,bj)
           ENDIF
          ENDDO
         ENDDO
#endif /* OBCS_UVICE_OLD */
#endif /* SEAICE_PRECOND_EXTRA_EXCHANGE */

C Solve for dvIce
         CALL SEAICE_LSR_TRIDIAGV(
     I        AV, BV, CV, vRt1, vRt2, rhsV, vTmp, seaiceMaskV, WFAV,
     U        dvIce,
     I        imin, imax, jmin, jmax, bi, bj, myTime, myIter, myThid )

C     end bi,bj-loops
        ENDDO
       ENDDO

       CALL EXCH_UV_XY_RL( duIce, dvIce, .TRUE., myThid )

      ENDDO
C ITERATION END -----------------------------------------------------

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      IF ( printResidual ) THEN
C--   Calculate final residual of the linearised system
        CALL SEAICE_RESIDUAL(
     I                  rhsU, rhsV, uRt1, uRt2, vRt1, vRt2,
     I                  AU, BU, CU, AV, BV, CV, duIce, dvIce,
     O                  residUend, residVend, uTmp, vTmp,
     I                  printResidual, myIter, myThid )
        _BEGIN_MASTER( myThid )
        WRITE(standardMessageUnit,'(A,A,1X,1P2E16.8)')
     &       ' SEAICE_PRECONDITIONER: Residual Initial Uice,Vice     =',
     &       '     ', residUini, residVini
        WRITE(standardMessageUnit,'(A,I4,A,I4,A,I6,1P2E16.8)')
     &       ' SEAICE_PRECONDITIONER (iter=',newtonIter,',',
     &       krylovIter, ') iters, U/VResid=',
     &       SEAICEpreconLinIter, residUend, residVend
        _END_MASTER( myThid )
      ENDIF
#ifdef ALLOW_DEBUG
      IF ( debugLevel .GE. debLevD ) THEN
        WRITE(msgBuf,'(A,I3,A,I3,A)')
     &        'Uice post iter (SEAICE_PRECONDITIONER',
     &      newtonIter, ',', krylovIter, ')'
        CALL DEBUG_STATS_RL( 1, UICE, msgBuf, myThid )
        WRITE(msgBuf,'(A,I3,A,I3,A)')
     &        'Vice post iter (SEAICE_PRECONDITIONER',
     &      newtonIter, ',', krylovIter, ')'
        CALL DEBUG_STATS_RL( 1, VICE, msgBuf, myThid )
      ENDIF
#endif /* ALLOW_DEBUG */

C     APPLY MASKS
      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        DO J=1-OLy,sNy+OLy
         DO I=1-OLx,sNx+OLx
          duIce(I,J,bi,bj)=duIce(I,J,bi,bj)* seaiceMaskU(I,J,bi,bj)
          dvIce(I,J,bi,bj)=dvIce(I,J,bi,bj)* seaiceMaskV(I,J,bi,bj)
         ENDDO
        ENDDO
       ENDDO
      ENDDO

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

CBOP
C     !ROUTINE: SEAICE_PRECOND_RHSU
C     !INTERFACE:
      SUBROUTINE SEAICE_PRECOND_RHSU (
     I     zetaMinusEta, etaPlusZeta, etaZpre, zetaZpre,
     I     dwatPre, coriFac, fricFac, SINWAT, COSWAT,
     I     uIceLoc, vIceLoc,
     U     rhsU,
     I     iMin,iMax,jMin,jMax,bi,bj,myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE SEAICE_PRECOND_RHSU
C     | o Calculate the right-hand-side of the u-momentum equation
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "DYNVARS.h"
#include "GRID.h"
#include "SEAICE_SIZE.h"
#include "SEAICE_PARAMS.h"
#include "SEAICE.h"

C     !INPUT/OUTPUT PARAMETERS:
      _RL zetaMinusEta(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL etaPlusZeta (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL  etaZpre    (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL zetaZpre    (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL uIceLoc     (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL vIceLoc     (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL dwatPre     (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL coriFac, fricFac
      _RS SINWAT
      _RL COSWAT
      _RL rhsU        (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      INTEGER iMin, iMax, jMin, jMax, bi, bj, myThid
CEOP

C     !LOCAL VARIABLES:
      INTEGER I,J,K
      _RL zeros(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL areaW(1-OLx:sNx+OLx,1-OLy:sNy+OLy)

C     surface level
      k = 1
C     set dummy pressure to zero
      DO J=1-OLy,sNy+OLy
       DO I=1-OLx,sNx+OLx
        zeros(I,J,bi,bj) = 0. _d 0
       ENDDO
      ENDDO
      CALL SEAICE_LSR_RHSU(
     I     zetaMinusEta, etaPlusZeta, etaZpre, zetaZpre, zeros,
     I     uIceLoc, vIceLoc,
     U     rhsU,
     I     iMin, iMax, jMin, jMax, bi, bj, myThid )

C     neglected for preconditioning step
      IF ( fricFac+coriFac .NE. 0. _d 0 ) THEN
       IF ( SEAICEscaleSurfStress ) THEN
        DO J=jMin,jMax
         DO I=iMin,iMax
          areaW(I,J) = 0.5 _d 0*(AREA(I,J,bi,bj)+AREA(I-1,J,bi,bj))
         ENDDO
        ENDDO
       ELSE
        DO J=jMin,jMax
         DO I=iMin,iMax
          areaW(I,J) = 1. _d 0
         ENDDO
        ENDDO
       ENDIF
       DO J=jMin,jMax
        DO I=iMin,iMax
         rhsU(I,J,bi,bj) = rhsU(I,J,bi,bj)
     &        - SIGN(SINWAT, _fCori(I,J,bi,bj))* 0.5 _d 0 *
     &        ( dwatPre(I  ,J,bi,bj) * 0.5 _d 0 *
     &        (vVel(I  ,J  ,k,bi,bj)-vIceLoc(I  ,J  ,bi,bj)
     &        +vVel(I  ,J+1,k,bi,bj)-vIceLoc(I  ,J+1,bi,bj))
     &        + dwatPre(I-1,J,bi,bj) * 0.5 _d 0 *
     &        (vVel(I-1,J  ,k,bi,bj)-vIceLoc(I-1,J  ,bi,bj)
     &        +vVel(I-1,J+1,k,bi,bj)-vIceLoc(I-1,J+1,bi,bj))
     &        ) * fricFac * areaW(I,J)
C-    add Coriolis term
         rhsU(I,J,bi,bj) = rhsU(I,J,bi,bj) + 0.5 _d 0 *
     &        ( seaiceMassC(I  ,J,bi,bj) * _fCori(I  ,J,bi,bj)
     &        *0.5 _d 0*(vIceLoc( i ,j,bi,bj)+vIceLoc( i ,j+1,bi,bj))
     &        + seaiceMassC(I-1,J,bi,bj) * _fCori(I-1,J,bi,bj)
     &        *0.5 _d 0*(vIceLoc(i-1,j,bi,bj)+vIceLoc(i-1,j+1,bi,bj))
     &        ) * coriFac
        ENDDO
       ENDDO
      ENDIF

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

CBOP
C     !ROUTINE: SEAICE_PRECOND_RHSV
C     !INTERFACE:
      SUBROUTINE SEAICE_PRECOND_RHSV (
     I     zetaMinusEta, etaPlusZeta, etaZpre, zetaZpre,
     I     dwatPre, coriFac, fricFac, SINWAT, COSWAT,
     I     uIceLoc, vIceLoc,
     U     rhsV,
     I     iMin,iMax,jMin,jMax,bi,bj,myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE SEAICE_PRECOND_RHSV
C     | o Calculate the right-hand-side of the v-momentum equation
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "DYNVARS.h"
#include "GRID.h"
#include "SEAICE_SIZE.h"
#include "SEAICE_PARAMS.h"
#include "SEAICE.h"

C     !INPUT/OUTPUT PARAMETERS:
      _RL zetaMinusEta(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL etaPlusZeta (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL  etaZpre    (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL zetaZpre    (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL uIceLoc     (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL vIceLoc     (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL dwatPre     (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL coriFac, fricFac
      _RS SINWAT
      _RL COSWAT
      _RL rhsV        (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      INTEGER iMin, iMax, jMin, jMax, bi, bj, myThid
CEOP

C     !LOCAL VARIABLES:
      INTEGER I,J,K
      _RL zeros(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL areaS(1-OLx:sNx+OLx,1-OLy:sNy+OLy)

C     surface level
      k = 1
C     set dummy pressure to zero
      DO J=1-OLy,sNy+OLy
       DO I=1-OLx,sNx+OLx
        zeros(I,J,bi,bj) = 0. _d 0
       ENDDO
      ENDDO
      CALL SEAICE_LSR_RHSV(
     I     zetaMinusEta, etaPlusZeta, etaZpre, zetaZpre, zeros,
     I     uIceLoc, vIceLoc,
     U     rhsV,
     I     iMin, iMax, jMin, jMax, bi, bj, myThid )

C     neglected for preconditioning step
      IF ( fricFac+coriFac .NE. 0. _d 0 ) THEN
       IF ( SEAICEscaleSurfStress ) THEN
        DO J=jMin,jMax
         DO I=iMin,iMax
          areaS(I,J) = 0.5 _d 0*(AREA(I,J,bi,bj)+AREA(I,J-1,bi,bj))
         ENDDO
        ENDDO
       ELSE
        DO J=jMin,jMax
         DO I=iMin,iMax
          areaS(I,J) = 1. _d 0
         ENDDO
        ENDDO
       ENDIF
       DO J=jMin,jMax
        DO I=iMin,iMax
         rhsV(I,J,bi,bj) = rhsV(I,J,bi,bj)
     &        + SIGN(SINWAT, _fCori(I,J,bi,bj)) * 0.5 _d 0 *
     &        ( dwatPre(I,J  ,bi,bj) * 0.5 _d 0 *
     &        (uVel(I  ,J  ,k,bi,bj)-uIceLoc(I  ,J  ,bi,bj)
     &        +uVel(I+1,J  ,k,bi,bj)-uIceLoc(I+1,J  ,bi,bj))
     &        + dwatPre(I,J-1,bi,bj) * 0.5 _d 0 *
     &        (uVel(I  ,J-1,k,bi,bj)-uIceLoc(I  ,J-1,bi,bj)
     &        +uVel(I+1,J-1,k,bi,bj)-uIceLoc(I+1,J-1,bi,bj))
     &        ) * fricFac * areaS(I,J)
C-    add Coriolis term
         rhsV(I,J,bi,bj) = rhsV(I,J,bi,bj) - 0.5 _d 0 *
     &        ( seaiceMassC(I,J  ,bi,bj) * _fCori(I,J  ,bi,bj)
     &        *0.5 _d 0*(uIceLoc(i  ,j  ,bi,bj)+uIceLoc(i+1,  j,bi,bj))
     &        + seaiceMassC(I,J-1,bi,bj) * _fCori(I,J-1,bi,bj)
     &        *0.5 _d 0*(uIceLoc(i  ,j-1,bi,bj)+uIceLoc(i+1,j-1,bi,bj))
     &        ) * coriFac
        ENDDO
       ENDDO
      ENDIF

#endif /* SEAICE_CGRID, SEAICE_ALLOW_JFNK and KRYLOV */

      RETURN
      END

#include "ECCO_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: cost_gencal
C     !INTERFACE:
      subroutine cost_gencal(
     I     localbarfile, localobsfile,
     I     irec, localstartdate, localperiod,
     O     fname1, fname2, localrec, obsrec, exst,
     I     mythid )

C     !DESCRIPTION: \bv
C     ==================================================================
C     SUBROUTINE cost_gencal
C     ==================================================================
C     reads and pre-processes bar file records
C     ==================================================================
C     SUBROUTINE cost_gencal
C     ==================================================================
C     \ev

C     !USES:
      IMPLICIT NONE

C     == global variables ==
#include "EEPARAMS.h"
#include "SIZE.h"
#include "PARAMS.h"
#ifdef ALLOW_CAL
# include "cal.h"
#endif
#ifdef ALLOW_ECCO
# include "ECCO_SIZE.h"
# include "ECCO.h"
#endif

c     == routine arguments ==
      character*(MAX_LEN_FNAM) localbarfile
      character*(MAX_LEN_FNAM) localobsfile
      integer irec, localstartdate(4)
      _RL localperiod
      character*(128) fname1, fname2
      integer localrec, obsrec
      logical exst
      integer mythid

#ifdef ALLOW_ECCO
c     == external functions ==
      integer  ilnblnk
      external ilnblnk

c     == local variables ==
c      CHARACTER*(MAX_LEN_MBUF) msgBuf
      integer k, il
      _RL daytime
      _RL diffsecs
      integer dayiter
      integer daydate(4)
      integer difftime(4)
      integer tempDate_1
      integer middate(4)
      integer yday, ymod
      integer md, dd, sd, ld, wd
      integer mody, modm

c     == end of interface ==
CEOP

      il=ilnblnk( localbarfile )
      write(fname1,'(2a,i10.10)')
     &     localbarfile(1:il),'.',eccoiter

        if ( localperiod.EQ.dTtracerLev(1) ) then
           localrec = irec
           obsrec = irec
           yday = 0
        elseif ( localperiod .EQ. 86400. ) then
c-- assume daily fields
           obsrec = irec
           daytime = FLOAT(secondsperday*(irec-1)) + modelstart
           dayiter = hoursperday*(irec-1) + modeliter0
           call cal_getdate( dayiter, daytime, daydate, mythid )
           call cal_convdate( daydate,yday,md,dd,sd,ld,wd,mythid )
           ymod = modelstartdate(1)/10000
           do k=1,4
              middate(k)=0
           enddo
           tempDate_1 = yday*10000+100+1
           if ( ymod .GE. yday ) then
              call cal_FullDate( modelstartdate(1), 0, middate, mythid)
           else
              call cal_FullDate( tempDate_1, 0, middate, mythid)
           endif
           call cal_TimePassed( middate, daydate, difftime, mythid )
           call cal_ToSeconds( difftime, diffsecs, mythid )
c           localrec = floor(diffsecs/localperiod) + 1
           localrec = int(diffsecs/localperiod) + 1
        else
c-- assume monthly fields
           obsrec = irec
           mody   = modelstartdate(1)/10000
           modm   = modelstartdate(1)/100 - mody*100
           yday   = mody + INT((modm-1+irec-1)/12)
           localrec = 1 + MOD(modm-1+irec-1,12)
        endif

        il=ilnblnk(localobsfile)
        write(fname2,'(2a,i4)')
     &       localobsfile(1:il), '_', yday
        inquire( file=fname2, exist=exst )
        if (.NOT. exst) then
c          assume that the data set is cyclic
           write(fname2,'(a)') localobsfile(1:il)
           inquire( file=fname2, exist=exst )
        endif

#endif /* ALLOW_ECCO */

      RETURN
      END

#include "FIZHI_OPTIONS.h"
      function minval (q,im)
      implicit none
      integer  im, i
      _RL q(im), minval
      minval = 1.e15
      do i=1,im
      if( q(i).lt.minval ) minval = q(i)
      enddo
      return
      end
      FUNCTION ERRF (ARG)
C***********************************************************************
C  FUNCTION ERRF
C  PURPOSE
C     COMPUTES ERROR FUNCTION OF ARGUMENT
C  USAGE
C     CALLED BY TRBFLX
C  DESCRIPTION OF PARAMETERS
C     ARG   -  INPUTED ARGUMENT
C  REMARKS:
C        USED TO COMPUTE FRACTIONAL CLOUD COVER AND LIQUID WATER CONTENT
C          FROM TURBULENCE STATISTICS
C **********************************************************************
      implicit none
      _RL arg,errf

      _RL aa1,aa2,aa3,aa4,aa5,pp,x2,x3,x4,x5
      PARAMETER ( AA1  =   0.254829592 )
      PARAMETER ( AA2  =  -0.284496736 )
      PARAMETER ( AA3  =   1.421413741 )
      PARAMETER ( AA4  =  -1.453152027 )
      PARAMETER ( AA5  =   1.061405429 )
      PARAMETER ( PP   =   0.3275911   )
      PARAMETER ( X2   =   AA2 / AA1   )
      PARAMETER ( X3   =   AA3 / AA2   )
      PARAMETER ( X4   =   AA5 / AA3   )
      PARAMETER ( X5   =   AA5 / AA4   )

      _RL aarg,tt

      ERRF = 1.
      AARG=ABS(ARG)

      IF ( AARG .LT. 4.0 )  THEN
       TT = 1./(1.+PP*AARG)
       ERRF = 1. -
     1  (AA1*TT*(1.+X2*TT*(1.+X3*TT*(1.+X4*TT*(1.+X5*TT)))))
     2   * EXP(-AARG*AARG)
      ENDIF

      IF ( ARG .LT. 0.0 )  ERRF = -ERRF

      RETURN
      END

      SUBROUTINE STRIP(A,B,IA,IB,L,K)
      implicit none
      integer ia,ib,L,K
      _RL A(IA,L), B(IB,L)

      INTEGER OFFSET,Lena,i,j

      OFFSET = IB*(K-1)
      Lena    = MIN(IB,IA-OFFSET)
      OFFSET = OFFSET+1

      IF(Lena.EQ.IB) THEN
        DO 100 J=1,L
        DO 100 I=1,Lena
        B(I,J) = A(I+OFFSET-1,J)
100     CONTINUE
      ELSE
        DO 200 J=1,L
        DO 300 I=1,Lena
        B(I,J) = A(I+OFFSET-1,J)
300     CONTINUE
        DO 400 I=1,IB-Lena
        B(Lena+I,J) = A(Lena+OFFSET-1,J)
400     CONTINUE
200     CONTINUE
      ENDIF

      RETURN
      END
      SUBROUTINE STRIPINT(A,B,IA,IB,L,K)
      implicit none
      integer ia,ib,L,K
      INTEGER A(IA,L), B(IB,L)

      INTEGER OFFSET,Lena,i,j

      OFFSET = IB*(K-1)
      Lena    = MIN(IB,IA-OFFSET)
      OFFSET = OFFSET+1

      IF(Lena.EQ.IB) THEN
        DO 100 J=1,L
        DO 100 I=1,Lena
        B(I,J) = A(I+OFFSET-1,J)
100     CONTINUE
      ELSE
        DO 200 J=1,L
        DO 300 I=1,Lena
        B(I,J) = A(I+OFFSET-1,J)
300     CONTINUE
        DO 400 I=1,IB-Lena
        B(Lena+I,J) = A(Lena+OFFSET-1,J)
400     CONTINUE
200     CONTINUE
      ENDIF

      RETURN
      END
      SUBROUTINE PASTE(B,A,IB,IA,L,K)
      implicit none
      integer ia,ib,L,K
      _RL A(IA,L), B(IB,L)

      INTEGER OFFSET,Lena,i,j

      OFFSET = IB*(K-1)
      Lena    = MIN(IB,IA-OFFSET)
      OFFSET = OFFSET+1

      DO 100 J=1,L
      DO 100 I=1,Lena
      A(I+OFFSET-1,J) = B(I,J)
100   CONTINUE

      RETURN
      END
      SUBROUTINE PSTBMP(B,A,IB,IA,L,K)
      implicit none
      integer ia,ib,L,K
      _RL A(IA,L), B(IB,L)

      INTEGER OFFSET,Lena,i,j

      OFFSET = IB*(K-1)
      Lena    = MIN(IB,IA-OFFSET)
      OFFSET = OFFSET+1

      DO 100 J=1,L
      DO 100 I=1,Lena
      A(I+OFFSET-1,J) = A(I+OFFSET-1,J) + B(I,J)
100   CONTINUE
C
      RETURN
      END
      SUBROUTINE STRINT(A,B,IA,IB,L,K)
      implicit none
      integer ia,ib,L,K
      INTEGER A(IA,L), B(IB,L)

      INTEGER OFFSET,Lena,i,j

      OFFSET = IB*(K-1)
      Lena = MIN(IB,IA-OFFSET)
      OFFSET = OFFSET+1

      IF(Lena.EQ.IB) THEN
        DO 100 J=1,L
        DO 100 I=1,Lena
        B(I,J) = A(I+OFFSET-1,J)
100     CONTINUE
      ELSE
        DO 200 J=1,L
        DO 300 I=1,Lena
        B(I,J) = A(I+OFFSET-1,J)
300     CONTINUE
        DO 400 I=1,IB-Lena
        B(Lena+I,J) = A(Lena+OFFSET-1,J)
400     CONTINUE
200     CONTINUE
      ENDIF

      RETURN
      END
      SUBROUTINE QSAT (TT,P,Q,DQDT,LDQDT)
C***********************************************************************
C
C  PURPOSE:
C  ========
C    Compute Saturation Specific Humidity
C
C  INPUT:
C  ======
C    TT ......... Temperature (Kelvin)
C    P .......... Pressure (mb)
C    LDQDT ...... Logical Flag to compute QSAT Derivative
C
C  OUTPUT:
C  =======
C    Q .......... Saturation Specific Humidity
C    DQDT ....... Saturation Specific Humidity Derivative wrt Temperature
C
C
C***********************************************************************

      IMPLICIT NONE
      _RL TT, P, Q, DQDT
      LOGICAL LDQDT

      _RL AIRMW, H2OMW

      PARAMETER ( AIRMW  = 28.97      )
      PARAMETER ( H2OMW  = 18.01      )

      _RL ESFAC, ERFAC
      PARAMETER ( ESFAC = H2OMW/AIRMW       )
      PARAMETER ( ERFAC = (1.0-ESFAC)/ESFAC )

      _RL aw0, aw1, aw2, aw3, aw4, aw5, aw6
      _RL bw0, bw1, bw2, bw3, bw4, bw5, bw6
      _RL ai0, ai1, ai2, ai3, ai4, ai5, ai6
      _RL bi0, bi1, bi2, bi3, bi4, bi5, bi6

      _RL d0, d1, d2, d3, d4, d5, d6
      _RL e0, e1, e2, e3, e4, e5, e6
      _RL f0, f1, f2, f3, f4, f5, f6
      _RL g0, g1, g2, g3, g4, g5, g6

c ********************************************************
c ***  Polynomial Coefficients WRT Water (Lowe, 1977) ****
c ***              (Valid +50 C to -50 C)             ****
c ********************************************************

      parameter ( aw0 =  6.107799961e+00 * esfac )
      parameter ( aw1 =  4.436518521e-01 * esfac )
      parameter ( aw2 =  1.428945805e-02 * esfac )
      parameter ( aw3 =  2.650648471e-04 * esfac )
      parameter ( aw4 =  3.031240396e-06 * esfac )
      parameter ( aw5 =  2.034080948e-08 * esfac )
      parameter ( aw6 =  6.136820929e-11 * esfac )

      parameter ( bw0 = +4.438099984e-01 * esfac )
      parameter ( bw1 = +2.857002636e-02 * esfac )
      parameter ( bw2 = +7.938054040e-04 * esfac )
      parameter ( bw3 = +1.215215065e-05 * esfac )
      parameter ( bw4 = +1.036561403e-07 * esfac )
      parameter ( bw5 = +3.532421810e-10 * esfac )
      parameter ( bw6 = -7.090244804e-13 * esfac )

c ********************************************************
c ***   Polynomial Coefficients WRT Ice  (Lowe, 1977) ****
c ***              (Valid  +0 C to -50 C)             ****
c ********************************************************

      parameter ( ai0 = +6.109177956e+00 * esfac )
      parameter ( ai1 = +5.034698970e-01 * esfac )
      parameter ( ai2 = +1.886013408e-02 * esfac )
      parameter ( ai3 = +4.176223716e-04 * esfac )
      parameter ( ai4 = +5.824720280e-06 * esfac )
      parameter ( ai5 = +4.838803174e-08 * esfac )
      parameter ( ai6 = +1.838826904e-10 * esfac )

      parameter ( bi0 = +5.030305237e-01 * esfac )
      parameter ( bi1 = +3.773255020e-02 * esfac )
      parameter ( bi2 = +1.267995369e-03 * esfac )
      parameter ( bi3 = +2.477563108e-05 * esfac )
      parameter ( bi4 = +3.005693132e-07 * esfac )
      parameter ( bi5 = +2.158542548e-09 * esfac )
      parameter ( bi6 = +7.131097725e-12 * esfac )

c ********************************************************
c ***         Polynomial Coefficients WRT Ice         ****
c ***   Starr and Cox (1985) (Valid -40 C to -70 C)   ****
c ********************************************************

      parameter ( d0 = 0.535098336e+01 * esfac )
      parameter ( d1 = 0.401390832e+00 * esfac )
      parameter ( d2 = 0.129690326e-01 * esfac )
      parameter ( d3 = 0.230325039e-03 * esfac )
      parameter ( d4 = 0.236279781e-05 * esfac )
      parameter ( d5 = 0.132243858e-07 * esfac )
      parameter ( d6 = 0.314296723e-10 * esfac )

      parameter ( e0 = 0.469290530e+00 * esfac )
      parameter ( e1 = 0.333092511e-01 * esfac )
      parameter ( e2 = 0.102164528e-02 * esfac )
      parameter ( e3 = 0.172979242e-04 * esfac )
      parameter ( e4 = 0.170017544e-06 * esfac )
      parameter ( e5 = 0.916466531e-09 * esfac )
      parameter ( e6 = 0.210844486e-11 * esfac )

c ********************************************************
c ***         Polynomial Coefficients WRT Ice         ****
c ***   Starr and Cox (1985) (Valid -65 C to -95 C)   ****
c ********************************************************

      parameter ( f0 = 0.298152339e+01 * esfac )
      parameter ( f1 = 0.191372282e+00 * esfac )
      parameter ( f2 = 0.517609116e-02 * esfac )
      parameter ( f3 = 0.754129933e-04 * esfac )
      parameter ( f4 = 0.623439266e-06 * esfac )
      parameter ( f5 = 0.276961083e-08 * esfac )
      parameter ( f6 = 0.516000335e-11 * esfac )

      parameter ( g0 = 0.312654072e+00 * esfac )
      parameter ( g1 = 0.195789002e-01 * esfac )
      parameter ( g2 = 0.517837908e-03 * esfac )
      parameter ( g3 = 0.739410547e-05 * esfac )
      parameter ( g4 = 0.600331350e-07 * esfac )
      parameter ( g5 = 0.262430726e-09 * esfac )
      parameter ( g6 = 0.481960676e-12 * esfac )

      _RL TMAX, TICE
      PARAMETER ( TMAX=323.15, TICE=273.16)

      _RL T, D, W, QX, DQX
      T = MIN(TT,TMAX) - TICE
      DQX = 0.
      QX  = 0.

c Fitting for temperatures above 0 degrees centigrade
c ---------------------------------------------------
      if(t.gt.0.) then
       qx = aw0+T*(aw1+T*(aw2+T*(aw3+T*(aw4+T*(aw5+T*aw6)))))
      if (ldqdt)  then
      dqx = bw0+T*(bw1+T*(bw2+T*(bw3+T*(bw4+T*(bw5+T*bw6)))))
      endif
      endif

c Fitting for temperatures between 0 and -40
c ------------------------------------------
      if( t.le.0. .and. t.gt.-40.0 ) then
        w = (40.0 + t)/40.0
       qx =     w *(aw0+T*(aw1+T*(aw2+T*(aw3+T*(aw4+T*(aw5+T*aw6))))))
     .    + (1.-w)*(ai0+T*(ai1+T*(ai2+T*(ai3+T*(ai4+T*(ai5+T*ai6))))))
      if (ldqdt)  then
      dqx =     w *(bw0+T*(bw1+T*(bw2+T*(bw3+T*(bw4+T*(bw5+T*bw6))))))
     .    + (1.-w)*(bi0+T*(bi1+T*(bi2+T*(bi3+T*(bi4+T*(bi5+T*bi6))))))
      endif
      endif

c Fitting for temperatures between -40 and -70
c --------------------------------------------
      if( t.le.-40.0 .and. t.ge.-70.0 ) then
       qx = d0+T*(d1+T*(d2+T*(d3+T*(d4+T*(d5+T*d6)))))
      if (ldqdt) then
      dqx = e0+T*(e1+T*(e2+T*(e3+T*(e4+T*(e5+T*e6)))))
      endif
      endif

c Fitting for temperatures less than -70
c --------------------------------------
      if(t.lt.-70.0) then
       qx = f0+t*(f1+t*(f2+t*(f3+t*(f4+t*(f5+t*f6)))))
      if (ldqdt) then
      dqx = g0+t*(g1+t*(g2+t*(g3+t*(g4+t*(g5+t*g6)))))
      endif
      endif

c Compute Saturation Specific Humidity
c ------------------------------------
      D = (P-ERFAC*QX)
      IF(D.LT.0.) THEN
       Q = 1.0
       IF (LDQDT)  DQDT = 0.
      ELSE
       D = 1.0 / D
       Q = MIN(QX * D,1.0 _d 0)
       IF (LDQDT)  DQDT = (1.0 + ERFAC*Q) * D * DQX
      ENDIF
      RETURN
      END
      subroutine vqsat (tt,p,q,dqdt,ldqdt,n)
      implicit none
      integer  i,n
      logical  ldqdt
      _RL tt(n), p(n), q(n), dqdt(n)
#ifdef FIZHI_CRAY
#ifdef FIZHI_F77_COMPIL
cfpp$ expand (qsat)
#endif
#endif
      do i=1,n
      call qsat ( tt(i),p(i),q(i),dqdt(i),ldqdt )
      enddo
      return
      end

      subroutine stripit(a,b,irun,ia,ib,l,k)
      implicit none
      integer ia,ib,irun,l,k
      _RL a(ia,l), b(ib,l)
      integer   i,j,Lena,offset

      offset = ib*(k-1)
      Lena    = min(ib,irun-offset)
      offset = offset+1

      if(Lena.eq.ib) then
        do 100 j=1,l
        do 100 i=1,Lena
        b(i,j) = a(i+offset-1,j)
100     continue
      else
        do 200 j=1,l
        do 300 i=1,Lena
        b(i,j) = a(i+offset-1,j)
300     continue
        do 400 i=1,ib-Lena
        b(Lena+i,j) = a(Lena+offset-1,j)
400     continue
200     continue
      endif
      return
      end

      subroutine stripitint(a,b,irun,ia,ib,l,k)
      implicit none
      integer ia,ib,irun,l,k,a(ia,l),b(ib,l)
      integer i,j,Lena,offset

      offset = ib*(k-1)
      Lena = min(ib,irun-offset)
      offset = offset+1

      if(Lena.eq.ib) then
        do 100 j=1,l
        do 100 i=1,Lena
        b(i,j) = a(i+offset-1,j)
100     continue
      else
        do 200 j=1,l
        do 300 i=1,Lena
        b(i,j) = a(i+offset-1,j)
300     continue
        do 400 i=1,ib-Lena
        b(Lena+i,j) = a(Lena+offset-1,j)
400     continue
200     continue
      endif
      return
      end

      subroutine pastit(b,a,ib,ia,irun,L,k)
      implicit none
      integer ib,ia,L,k,irun,Lena,offset
      integer i,j
      _RL a(ia,l), b(ib,l)

      offset = ib*(k-1)
      Lena    = min(ib,irun-offset)
      offset = offset+1

      do 100 j=1,L
      do 100 i=1,Lena
      a(i+offset-1,j) = b(i,j)
100   continue
      return
      end

      subroutine pstbitint(b,a,ib,ia,irun,l,k)
      implicit none
      integer ib,ia,L,k,irun,Lena,offset
      _RL a(ia,l)
      integer b(ib,l)
      integer i,j

      offset = ib*(k-1)
      Lena    = min(ib,irun-offset)
      offset = offset+1

      do 100 j=1,L
      do 100 i=1,Lena
      a(i+offset-1,j) = a(i+offset-1,j) + float(b(i,j))
100   continue
      return
      end

      subroutine pstbmpit(b,a,ib,ia,irun,l,k)
      implicit none
      integer ib,ia,L,k,irun,Lena,offset
      _RL a(ia,l), b(ib,l)
      integer i,j

      offset = ib*(k-1)
      Lena    = min(ib,irun-offset)
      offset = offset+1

      do 100 j=1,L
      do 100 i=1,Lena
      a(i+offset-1,j) = a(i+offset-1,j) + b(i,j)
100   continue
      return
      end

      subroutine strip2tile(a,indx,b,irun,ia,ib,levs,npeice)
c-----------------------------------------------------------------------
c subroutine strip2tile - extract one processors worth of grid points
c                         from a grid space array to a stripped tile
c                         space array
c
c  input:
c      a      - array to be stripped FROM [ia,levs]
c      indx   - array of horizontal indeces of grid points to convert to
c               tile space
c      irun   - number of points in array a that need to be stripped
c      ia     - inner of dimension of source array
c      ib     - inner dimension of target array AND the number of points
c               in the target array to be filled
c      levs   - number of vertical levels AND outer dimension of arrays
c      npeice - the current strip number to be filled
c output:
c      b      - array to be filled, ie, one processors field [ib,levs]
c-----------------------------------------------------------------------
      implicit none
      integer ia,ib,irun,levs,npeice
      _RL a(ia,levs), b(ib,levs)
      integer indx(irun)
      integer i,k,Lena,offset

      offset = ib*(npeice-1)
      Lena    = min(ib,irun-offset)
      offset = offset+1

      if(Lena.eq.ib) then
        do 100 k=1,levs
        do 100 i=1,Lena
        b(i,k) = a(indx(i+offset-1),k)
100     continue
      else
        do 200 k=1,levs
        do 300 i=1,Lena
        b(i,k) = a(indx(i+offset-1),k)
300     continue
        do 400 i=1,ib-Lena
        b(Lena+i,k) = a(indx(Lena+offset-1),k)
400     continue
200     continue
      endif
      return
      end

      subroutine paste2grd_old(b,indx,chfr,ib,numpts,a,ia,levs,npeice)
c-----------------------------------------------------------------------
c subroutine paste2grd - paste one processors worth of grid points
c                        from a stripped tile array to a grid
c                        space array
c
c  input:
c      b      - array to be pasted back into grid space [ib,levs]
c      indx   - array of horizontal indeces of grid points to convert to
c               tile space[numpts]
c      chfr   - fractional area covered by the tile [ib]
c      ib     - inner dimension of source array AND number of points in
c               array a that need to be pasted
c      numpts - total number of points which were stripped
c      ia     - inner of dimension of target array
c      levs   - number of vertical levels AND outer dimension of arrays
c      npeice - the current strip number to be filled
c output:
c      a      - grid space array to be filled [ia,levs]
c
c IMPORTANT NOTE:
c
c This routine will result in roundoff differences if called from
c within a parallel region.
c-----------------------------------------------------------------------

      implicit none
      integer ia,ib,levs,numpts,npeice
      integer indx(numpts)
      _RL a(ia,levs), b(ib,levs), chfr(ib)

      integer i,L,offset,Lena

      offset = ib*(npeice-1)
      Lena    = min(ib,numpts-offset)
      offset = offset+1

      do L = 1,levs
      do i=1,Lena
       a(indx(i+offset-1),L) = a(indx(i+offset-1),L) + b(i,L)*chfr(i)
      enddo
      enddo
      return
      end
      subroutine paste2grd (b,indx,chfr,ib,numpts,a,ia,levs,npeice,
     .                                                            check)
c-----------------------------------------------------------------------
c subroutine paste2grd - paste one processors worth of grid points
c                        from a stripped tile array to a grid
c                        space array
c
c  input:
c      b      - array to be pasted back into grid space [ib,levs]
c      indx   - array of horizontal indeces of grid points to convert to
c               tile space[numpts]
c      chfr   - fractional area covered by the tile [ib]
c      ib     - inner dimension of source array AND number of points in
c               array a that need to be pasted
c      numpts - total number of points which were stripped
c      ia     - inner of dimension of target array
c      levs   - number of vertical levels AND outer dimension of arrays
c      npeice - the current strip number to be filled
c      check  - logical to check for undefined values
c output:
c      a      - grid space array to be filled [ia,levs]
c
c IMPORTANT NOTE:
c
c This routine will result in roundoff differences if called from
c within a parallel region.
c-----------------------------------------------------------------------

      implicit none
      integer ia,ib,levs,numpts,npeice
      integer indx(numpts)
      _RL a(ia,levs), b(ib,levs), chfr(ib)
      logical check

      integer i,L,offset,Lena
      _RL    undef,getcon

      offset = ib*(npeice-1)
      Lena    = min(ib,numpts-offset)
      offset = offset+1

      if( check ) then
      undef = getcon('UNDEF')
       do L= 1,levs
       do i= 1,Lena
        if( a(indx(i+offset-1),L).eq.undef .or. b(i,L).eq.undef ) then
         a(indx(i+offset-1),L) = undef
        else
         a(indx(i+offset-1),L)=a(indx(i+offset-1),L) + b(i,L)*chfr(i)
        endif
       enddo
       enddo
      else
       do L= 1,levs
       do i= 1,Lena
        a(indx(i+offset-1),L)=a(indx(i+offset-1),L) + b(i,L)*chfr(i)
       enddo
       enddo
      endif

      return
      end
      SUBROUTINE GRD2MSC(A,IM,JM,IGRD,B,MXCHPS,NCHP)

      implicit none
      integer im,jm,mxchps,nchp
      integer igrd(mxchps)
c     _RL A(IM,JM), B(MXCHPS)
      _RL A(IM*JM), B(MXCHPS)

      integer i

      IF(NCHP.GE.0) THEN
        DO I=1,NCHP
c        B(I) = A(IGRD(I),1)
         B(I) = A(IGRD(I))
        ENDDO
      ELSE
        PRINT *, 'ERROR IN GRD2MSC'
      ENDIF

      RETURN
      END

      SUBROUTINE MSC2GRD(IGRD,CHFR,B,MXCHPS,NCHP,FRACG,A,IM,JM)

      implicit none
      _RL zero,one
      parameter ( one = 1.)
      parameter (zero = 0.)
      integer im,jm,mxchps,nchp
      integer igrd(mxchps)
c     _RL A(IM,JM), B(MXCHPS), CHFR(MXCHPS), FRACG(IM,JM)
      _RL A(IM*JM), B(MXCHPS), CHFR(MXCHPS), FRACG(IM*JM)

c     _RL VT1(IM,JM)
      _RL VT1(IM*JM)
      integer i

      IF(NCHP.GE.0) THEN
        DO I=1,IM*JM
c        VT1(I,1) = ZERO
         VT1(I) = ZERO
        ENDDO

        DO I=1,NCHP
c        VT1(IGRD(I),1) = VT1(IGRD(I),1) + B(I)*CHFR(I)
         VT1(IGRD(I)) = VT1(IGRD(I)) + B(I)*CHFR(I)
        ENDDO

        DO I=1,IM*JM
c        A(I,1) = A(I,1)*(ONE-FRACG(I,1)) + VT1(I,1)
         A(I) = A(I)*(ONE-FRACG(I)) + VT1(I)
        ENDDO
      ELSE
        PRINT *, 'ERROR IN MSC2GRD'
      ENDIF

      RETURN
      END

      subroutine chpprm(nymd,nhms,mxchps,nchp,chlt,ityp,alai,
     1       agrn,zoch,z2ch,cdrc,cdsc,sqsc,ufac,rsl1,rsl2,rdcs)

       implicit none

       integer nymd,nhms,nchp,mxchps,ityp(mxchps)
       _RL chlt(mxchps)
       _RL alai(mxchps),agrn(mxchps)
       _RL zoch(mxchps), z2ch(mxchps), cdrc(mxchps), cdsc(mxchps)
       _RL sqsc(mxchps), ufac(mxchps), rsl1(mxchps), rsl2(mxchps)
       _RL rdcs(mxchps)

C*********************************************************************
C********************* SUBROUTINE CHPPRM  ****************************
C**********************  14 JUNE 1991   ******************************
C*********************************************************************

      integer ntyps
      parameter (ntyps=10)

      _RL pblzet
      parameter (pblzet = 50.)
      integer k1,k2,nymd1,nhms1,nymd2,nhms2,i
      _RL getcon,vkrm,rootl,vroot,dum1,dum2,alphaf
      _RL facm,facp
      _RL scat,d

      _RL
     &     vgdd(12, ntyps),    vgz0(12, ntyps),
     &     vgrd(12, ntyps),    vgrt(12, ntyps),

     &     vgrf11(ntyps),         vgrf12(ntyps),
     &     vgtr11(ntyps),         vgtr12(ntyps),
     &     vgroca(ntyps),         vgrotd(ntyps),
     &     vgrdrs(ntyps),         vgz2  (ntyps)

      data vgz0  /
     1   2.6530, 2.6530, 2.6530, 2.6530, 2.6530, 2.6530, 2.6530,
     1   2.6530, 2.6530, 2.6530, 2.6530, 2.6530,
     2   0.5200, 0.5200, 0.6660, 0.9100, 1.0310, 1.0440, 1.0420,
     2   1.0370, 1.0360, 0.9170, 0.6660, 0.5200,
     3   1.1120, 1.1030, 1.0880, 1.0820, 1.0760, 1.0680, 1.0730,
     3   1.0790, 1.0820, 1.0880, 1.1030, 1.1120,
     4   0.0777, 0.0778, 0.0778, 0.0779, 0.0778, 0.0771, 0.0759,
     4   0.0766, 0.0778, 0.0779, 0.0778, 0.0778,
     5   0.2450, 0.2450, 0.2270, 0.2000, 0.2000, 0.2000, 0.2000,
     5   0.267,  0.292,  0.280,  0.258,  0.2450,
     6   0.0752, 0.0752, 0.0752, 0.0752, 0.0752, 0.0757, 0.0777,
     6   0.0778, 0.0774, 0.0752, 0.0752, 0.0752,
     7   0.0112, 0.0112, 0.0112, 0.0112, 0.0112, 0.0112, 0.0112,
     7   0.0112, 0.0112, 0.0112, 0.0112, 0.0112,
     8   0.0112, 0.0112, 0.0112, 0.0112, 0.0112, 0.0112, 0.0112,
     8   0.0112, 0.0112, 0.0112, 0.0112, 0.0112,
     9   0.0112, 0.0112, 0.0112, 0.0112, 0.0112, 0.0112, 0.0112,
     9   0.0112, 0.0112, 0.0112, 0.0112, 0.0112,
     1   0.0112, 0.0112, 0.0112, 0.0112, 0.0112, 0.0112, 0.0112,
     1   0.0112, 0.0112, 0.0112, 0.0112, 0.0112
     &  /

      data vgrd    /
     1   285.87, 285.87, 285.87, 285.87, 285.87, 285.87, 285.87,
     1   285.87, 285.87, 285.87, 285.87, 285.87,
     2   211.32, 211.32, 218.78, 243.40, 294.87, 345.90, 355.18,
     2   341.84, 307.22, 244.84, 218.78, 211.32,
     3   565.41, 587.05, 623.46, 638.13, 652.86, 675.04, 660.24,
     3   645.49, 638.13, 623.46, 587.05, 565.41,
     4    24.43,  24.63,  24.80,  24.96,  25.72,  27.74,  30.06,
     4    28.86,  25.90,  25.11,  24.80,  24.63,
     5   103.60, 103.60, 102.35, 100.72, 100.72, 100.72, 100.72,
     5   105.30, 107.94, 106.59, 104.49, 103.60,
     6    22.86,  22.86,  22.86,  22.86,  22.86,  23.01,  24.36,
     6    24.69,  24.04,  22.86,  22.86,  22.86,
     7    23.76,  23.76,  23.76,  23.76,  23.76,  23.76,  23.76,
     7    23.76,  23.76,  23.76,  23.76,  23.76,
     8    23.76,  23.76,  23.76,  23.76,  23.76,  23.76,  23.76,
     8    23.76,  23.76,  23.76,  23.76,  23.76,
     9    23.76,  23.76,  23.76,  23.76,  23.76,  23.76,  23.76,
     9    23.76,  23.76,  23.76,  23.76,  23.76,
     1    23.76,  23.76,  23.76,  23.76,  23.76,  23.76,  23.76,
     1    23.76,  23.76,  23.76,  23.76,  23.76
     &  /

      data vgrt  /
     1   19737.8, 19737.8, 19737.8, 19737.8, 19737.8, 19737.8, 19737.8,
     1   19737.8, 19737.8, 19737.8, 19737.8, 19737.8,
     2    5010.0,  5010.0,  5270.0,  6200.0,  8000.0,  9700.0,  9500.0,
     2    8400.0,  6250.0,  5270.0,  5010.0,  5010.0,
     3    9000.0,  9200.0,  9533.3,  9666.7,  9800.0,  9866.7,  9733.3,
     3    9666.7,  9533.3,  9200.0,  9000.0,  9000.0,
     4    5500.0,  5625.0,  5750.0,  5875.0,  6625.0,  8750.0,  9375.0,
     4    6875.0,  6000.0,  5750.0,  5625.0,  5500.0,
     5    6500.0,  6000.0,  5500.0,  5500.0,  5500.0,  5500.0,  5500.0,
     5    7500.0,  8500.0,  7000.0,  6500.0,  6500.0,
     6   10625.0, 10625.0, 10625.0, 10625.0, 10625.0, 11250.0, 18750.0,
     6   17500.0, 10625.0, 10625.0, 10625.0, 10625.0,
     7       1.0,     1.0,     1.0,     1.0,     1.0,     1.0,     1.0,
     7       1.0,     1.0,     1.0,     1.0,     1.0,
     8       1.0,     1.0,     1.0,     1.0,     1.0,     1.0,     1.0,
     8       1.0,     1.0,     1.0,     1.0,     1.0,
     9       1.0,     1.0,     1.0,     1.0,     1.0,     1.0,     1.0,
     9       1.0,     1.0,     1.0,     1.0,     1.0,
     1       1.0,     1.0,     1.0,     1.0,     1.0,     1.0,     1.0,
     1       1.0,     1.0,     1.0,     1.0,     1.0
     &  /

      data vgdd  /
     1   27.37,   27.37,   27.37,   27.37,   27.37,   27.37,  27.37,
     1   27.37,   27.37,   27.37,   27.37,   27.37,
     2   13.66,   13.66,   14.62,   15.70,   16.33,   16.62,   16.66,
     2   16.60,   16.41,   15.73,   14.62,   13.66,
     3   13.76,   13.80,   13.86,   13.88,   13.90,   13.93,   13.91,
     3   13.89,   13.88,   13.86,   13.80,   13.76,
     4    0.218,   0.227,   0.233,   0.239,   0.260,   0.299,   0.325,
     4    0.313,   0.265,   0.244,   0.233,   0.227,
     5    2.813,   2.813,   2.662,   2.391,   2.391,   2.391,   2.391,
     5    2.975,   3.138,   3.062,   2.907,   2.813,
     6    0.10629, 0.10629, 0.10629, 0.10629, 0.10629, 0.12299, 0.21521,
     6    0.22897, 0.19961, 0.10629, 0.10629, 0.10629,
     7    0.0001,  0.0001,  0.0001,  0.0001,  0.0001,  0.0001,  0.0001,
     7    0.0001,  0.0001,  0.0001,  0.0001,  0.0001,
     8    0.0001,  0.0001,  0.0001,  0.0001,  0.0001,  0.0001,  0.0001,
     8    0.0001,  0.0001,  0.0001,  0.0001,  0.0001,
     9    0.0001,  0.0001,  0.0001,  0.0001,  0.0001,  0.0001,  0.0001,
     9    0.0001,  0.0001,  0.0001,  0.0001,  0.0001,
     1    0.0001,  0.0001,  0.0001,  0.0001,  0.0001,  0.0001,  0.0001,
     1    0.0001,  0.0001,  0.0001,  0.0001,  0.0001
     &  /

      data vgrf11 /0.10,0.10,0.07,0.105,0.10,0.10,.001,.001,.001,.001/

      data vgrf12 /0.16,0.16,0.16,0.360,0.16,0.16,.001,.001,.001,.001/

      data vgtr11 /0.05,0.05,0.05,0.070,0.05,0.05,.001,.001,.001,.001/

      data vgtr12 /.001,.001,.001, .220,.001,.001,.001,.001,.001,.001/

      data vgroca /
     &  0.384E-6, 0.384E-6, 0.384E-6, 0.384E-6, 0.384E-6, 0.384E-6,
     &   .1E-6, .1E-6, .1E-6, .1E-6  /

      data vgrotd /1.00,1.00,0.50,0.50,0.50,0.20,0.10,0.10,0.10,0.10/

      data vgrdrs  /
     &   0.75E13, 0.75E13, 0.75E13, 0.40E13, 0.75E13, 0.75E13,
     &   0.10E13, 0.10E13, 0.10E13, 0.10E13  /

      data vgz2 /35.0, 20.0, 17.0, 0.6, 5.0, 0.6, 0.1, 0.1, 0.1, 0.1/

      vkrm = GETCON('VON KARMAN')

      call time_bound  ( nymd,nhms, nymd1,nhms1, nymd2,nhms2, k1,k2 )
      call interp_time ( nymd,nhms, nymd1,nhms1, nymd2,nhms2, facm,facp)

      do i=1,nchp

      zoch(i) = vgz0(k2,ityp(i))*facp + vgz0(k1,ityp(i))*facm
      rdcs(i) = vgrd(k2,ityp(i))*facp + vgrd(k1,ityp(i))*facm

      rootl   = vgrt(k2,ityp(i))*facp + vgrt(k1,ityp(i))*facm

      vroot  = rootl * vgroca(ityp (i))
      dum1   = log (vroot / (1. - vroot))
      dum2   = 1. / (8. * 3.14159 * rootl)
      alphaf = dum2 * (vroot - 3. -2. * dum1)

      rsl1(i) = vgrdrs (ityp (i)) / (rootl * vgrotd (ityp (i)))
      rsl2(i) = alphaf / vgrotd (ityp (i))

      scat =       agrn(i) *(vgtr11(ityp(i)) + vgrf11(ityp(i)))
     &     + (1. - agrn(i))*(vgtr12(ityp(i)) + vgrf12(ityp(i)))
      sqsc(i) = sqrt (1. - scat)

      d       = vgdd(k2,ityp(i))*facp + vgdd(k1,ityp(i))*facm
      ufac(i) = log( (vgz2(ityp(i)) - d) / zoch(i) )
     *        / log(  pblzet             / zoch(i) )

      z2ch(i) = vgz2(ityp (i))

      cdsc(i) = pblzet/zoch(i)+1.
      cdrc(i) = vkrm/log(cdsc(i))
      cdrc(i) = cdrc(i)*cdrc(i)
      cdsc(i) = sqrt(cdsc(i))
      cdsc(i) = cdrc(i)*cdsc(i)

      enddo

      return
      end

      subroutine pkappa (im,jm,lm,ple,pkle,pkz)
C***********************************************************************
C  Purpose
C     Calculate Phillips P**Kappa
C
C  Arguments
C     PLE .... edge-level pressure
C     PKLE ... edge-level pressure**kappa
C     IM ..... longitude  dimension
C     JM ..... latitude   dimension
C     LM ..... vertical   dimension
C     PKZ .... mid-level pressure**kappa
C***********************************************************************
      implicit  none

      integer   im,jm,lm
      _RL ple(im,jm,lm+1)
      _RL pkle(im,jm,lm+1)
      _RL pkz(im,jm,lm)

      _RL akap1,getcon
      integer i,j,L

      akap1 = 1.0 + getcon('KAPPA')

      do L = 1,lm
      do j = 1,jm
      do i = 1,im
       pkz(i,j,L) = ( ple (i,j,l+1)*pkle(i,j,l+1)
     .             - ple (i,j,l)*pkle(i,j,l) )
     .           /  ( akap1* (ple (i,j,l+1)-ple (i,j,l)) )
      enddo
      enddo
      enddo

      return
      end

#include "CPP_OPTIONS.h"

CBOP
C     !ROUTINE: CALC_GRAD_PHI_SURF
C     !INTERFACE:
      SUBROUTINE CALC_GRAD_PHI_SURF( bi, bj, iMin, iMax, jMin, jMax,
     I                       etaFld,
     O                       phiSurfX, phiSurfY,
     I                       myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R CALC_GRAD_PHI_SURF                                    
C     | o Calculate the gradient of the surface Potential anomaly 
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "SURFACE.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine Arguments ==
C     etaFld             :: free-surface r-anomaly (r unit).
C     phiSurfX, phiSurfY :: Gradient in the X and Y directions of surface
C       Potentiel anomaly (atmos: =Geopotential ; ocean: =Pressure/rho) 
C     bi,bj,iMin,iMax,jMin,jMax :: Loop counters
C     myThid :: Instance number for this call of the routine.
      INTEGER bi,bj,iMin,iMax,jMin,jMax
      _RL etaFld(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL phiSurfX(1-Olx:sNx+Olx,1-Oly:sNy+Oly)
      _RL phiSurfY(1-Olx:sNx+Olx,1-Oly:sNy+Oly)
      INTEGER myThid

C     !LOCAL VARIABLES:
C     == Local variables ==
C     i,j :: Loop counters
      INTEGER i,j
CEOP

C     Zonal term
      DO j=jMin,jMax
       DO i=iMin,iMax
        phiSurfX(i,j)=_recip_dxC(i,j,bi,bj)*
     &   ( Bo_surf(i,j,bi,bj)*etaFld(i,j,bi,bj)
     &   - Bo_surf(i-1,j,bi,bj)*etaFld(i-1,j,bi,bj) )      
       ENDDO
      ENDDO

C     Meridional term
      DO j=jMin,jMax
       DO i=iMin,iMax
        phiSurfY(i,j)=_recip_dyC(i,j,bi,bj)*
     &   ( Bo_surf(i,j,bi,bj)*etaFld(i,j,bi,bj)
     &   - Bo_surf(i,j-1,bi,bj)*etaFld(i,j-1,bi,bj) ) 
       ENDDO
      ENDDO

      RETURN
      END

#include "FIZHI_OPTIONS.h"
      subroutine swrio (nymd,nhms,bi,bj,ndswr,myid,istrip,npcs,
     .        low_level,mid_level,im,jm,lm,
     .        pz,plz,plze,dpres,pkht,pkz,tz,qz,oz,co2,
     .        albvisdr,albvisdf,albnirdr,albnirdf,
     .        dtradsw,dtswclr,radswg,swgclr,
     .        fdifpar,fdirpar,osr,osrclr,
     .        ptop,nswcld,cldsw,cswmo,nswlz,swlz,
     .        lpnt,imstturb,qliqave,fccave,landtype,xlats,xlons)

      implicit none

c Input Variables
c ---------------
      integer nymd,nhms,bi,bj,ndswr,myid,istrip,npcs
      integer mid_level,low_level
      integer im,jm,lm
      _RL  ptop
      _RL pz(im,jm),plz(im,jm,lm),plze(im,jm,lm+1),dpres(im,jm,lm)
      _RL pkht(im,jm,lm+1),pkz(im,jm,lm)
      _RL tz(im,jm,lm),qz(im,jm,lm)
      _RL oz(im,jm,lm)
      _RL co2
      _RL albvisdr(im,jm),albvisdf(im,jm),albnirdr(im,jm)
      _RL albnirdf(im,jm)
      _RL radswg(im,jm),swgclr(im,jm),fdifpar(im,jm),fdirpar(im,jm)
      _RL osr(im,jm),osrclr(im,jm),dtradsw(im,jm,lm)
      _RL dtswclr(im,jm,lm)
      integer nswcld,nswlz
      _RL cldsw(im,jm,lm),cswmo(im,jm,lm),swlz(im,jm,lm)
      logical lpnt
      integer imstturb
      _RL qliqave(im,jm,lm),fccave(im,jm,lm)
      integer landtype(im,jm)
      _RL xlats(im,jm),xlons(im,jm)

c Local Variables
c ---------------
      integer   i,j,L,nn,nsecf
      integer   ntmstp,nymd2,nhms2
      _RL      getcon,grav,cp,undef
      _RL      ra,alf,reffw,reffi,tminv

      parameter ( reffw = 10.0 )
      parameter ( reffi = 65.0 )

      _RL tdry(im,jm,lm)
      _RL TEMP1(im,jm)
      _RL TEMP2(im,jm)
      _RL zenith (im,jm)
      _RL cldtot (im,jm,lm)
      _RL cldmxo (im,jm,lm)
      _RL totcld (im,jm)
      _RL cldlow (im,jm)
      _RL cldmid (im,jm)
      _RL cldhi  (im,jm)
      _RL taulow (im,jm)
      _RL taumid (im,jm)
      _RL tauhi  (im,jm)
      _RL tautype(im,jm,lm,3)
      _RL tau(im,jm,lm)
      _RL albedo(im,jm)

      _RL PK(ISTRIP,lm)
      _RL qzl(ISTRIP,lm),CLRO(ISTRIP,lm)
      _RL TZL(ISTRIP,lm)
      _RL OZL(ISTRIP,lm)
      _RL PLE(ISTRIP,lm+1)
      _RL COSZ(ISTRIP)
      _RL dpstrip(ISTRIP,lm)

      _RL albuvdr(ISTRIP),albuvdf(ISTRIP)
      _RL albirdr(ISTRIP),albirdf(ISTRIP)
      _RL difpar (ISTRIP),dirpar (ISTRIP)

      _RL fdirir(istrip),fdifir(istrip)
      _RL fdiruv(istrip),fdifuv(istrip)

      _RL flux(istrip,lm+1)
      _RL fluxclr(istrip,lm+1)
      _RL dtsw(istrip,lm)
      _RL dtswc(istrip,lm)

      _RL taul   (istrip,lm)
      _RL reff   (istrip,lm,2)
      _RL tauc   (istrip,lm,2)
      _RL taua   (istrip,lm)
      _RL tstrip (istrip)
#ifdef ALLOW_DIAGNOSTICS
      logical  diagnostics_is_on
      external diagnostics_is_on
      _RL tmpdiag(im,jm),tmpdiag2(im,jm)
#endif

      logical first
      data first /.true./

C **********************************************************************
C ****                       INITIALIZATION                         ****
C **********************************************************************

      grav  = getcon('GRAVITY')
      cp    = getcon('CP')
      undef = getcon('UNDEF')

      NTMSTP = nsecf(NDSWR)
      TMINV  = 1./float(ntmstp)

C Compute Temperature from Theta
C ------------------------------
      do L=1,lm
      do j=1,jm
      do i=1,im
      tdry(i,j,L) = tz(i,j,L)*pkz(i,j,L)
      enddo
      enddo
      enddo

      if (first .and. myid.eq.1 ) then
      print *
      print *,'Low-Level Clouds are Grouped between levels: ',
     .         lm,' and ',low_level
      print *,'Mid-Level Clouds are Grouped between levels: ',
     .         low_level-1,' and ',mid_level
      print *
      first = .false.
      endif

C **********************************************************************
C ****             CALCULATE COSINE OF THE ZENITH ANGLE             ****
C **********************************************************************

#ifdef FIZHI_USE_FIXED_DAY
      CALL ASTRO ( 20040321,  NHMS,  XLATS,XLONS, im*jm, TEMP1,RA )
                   NYMD2 = NYMD
                   NHMS2 = NHMS
      CALL TICK  ( NYMD2,  NHMS2, NTMSTP )
      CALL ASTRO ( 20040321,  NHMS2, XLATS,XLONS, im*jm, TEMP2,RA )
#else
      CALL ASTRO ( NYMD,   NHMS,  XLATS,XLONS, im*jm, TEMP1,RA )
                   NYMD2 = NYMD
                   NHMS2 = NHMS
      CALL TICK  ( NYMD2,  NHMS2, NTMSTP )
      CALL ASTRO ( NYMD2,  NHMS2, XLATS,XLONS, im*jm, TEMP2,RA )
#endif

      do j = 1,jm
      do i = 1,im
          zenith(I,j) = TEMP1(I,j) + TEMP2(I,j)
      IF( zenith(I,j) .GT. 0.0 ) THEN
          zenith(I,j) = (2./3.)*( zenith(I,j)-TEMP2(I,j)*TEMP1(I,j)
     .                          / zenith(I,j) )
      ENDIF
      ENDDO
      ENDDO

C **********************************************************************
c ****        Compute Two-Dimension Total Cloud Fraction (0-1)      ****
C **********************************************************************

c Initialize Clear Sky Probability for Low, Mid, and High Clouds
c --------------------------------------------------------------
      do j =1,jm
      do i =1,im
      cldlow(i,j) = 0.0
      cldmid(i,j) = 0.0
      cldhi (i,j) = 0.0
      enddo
      enddo

c Adjust cloud fractions and cloud liquid water due to moist turbulence
c ---------------------------------------------------------------------
      if(imstturb.ne.0) then
        do L =1,lm
        do j =1,jm
        do i =1,im
           cldtot(i,j,L)=min(1.0 _d 0,max(cldsw(i,j,L),fccave(i,j,L)/
     $          imstturb))
           cldmxo(i,j,L)=min(1.0 _d 0,cswmo(i,j,L))
           swlz(i,j,L)=swlz(i,j,L)+qliqave(i,j,L)/imstturb
        enddo
        enddo
        enddo
      else
        do L =1,lm
        do j =1,jm
        do i =1,im
         cldtot(i,j,L) =  min( 1.0 _d 0,cldsw(i,j,L) )
         cldmxo(i,j,L) =  min( 1.0 _d 0,cswmo(i,j,L) )
        enddo
        enddo
        enddo
      endif

c Compute 3-D Cloud Fractions
c ---------------------------
      if( nswcld.ne.0 ) then
      do L = 1,lm
      do j = 1,jm
      do i = 1,im
c Compute Low-Mid-High Maximum Overlap Cloud Fractions
c ----------------------------------------------------
      if(     L.lt.mid_level ) then
             cldhi (i,j) = max( cldtot(i,j,L),cldhi (i,j) )
      elseif( L.ge.mid_level .and.
     .        L.lt.low_level ) then
             cldmid(i,j) = max( cldtot(i,j,L),cldmid(i,j) )
      elseif( L.ge.low_level ) then
             cldlow(i,j) = max( cldtot(i,j,L),cldlow(i,j) )
      endif

      enddo
      enddo
      enddo
      endif

c Totcld => Product of Clear Sky Probabilities for Low, Mid, and High Clouds
c --------------------------------------------------------------------------
      do j = 1,jm
      do i = 1,im
      totcld(i,j) = 1.0 - (1.-cldhi (i,j))
     .                  * (1.-cldmid(i,j))
     .                  * (1.-cldlow(i,j))
      enddo
      enddo

#ifdef ALLOW_DIAGNOSTICS

c Compute Cloud Diagnostics
c -------------------------
      if(diagnostics_is_on('CLDFRC  ',myid) ) then
       call diagnostics_fill(totcld,'CLDFRC  ',0,1,3,bi,bj,myid)
      endif

      if(diagnostics_is_on('CLDRAS  ',myid) ) then
       do L=1,lm
       do j=1,jm
       do i=1,im
        tmpdiag(i,j) = cswmo(i,j,L)
       enddo
       enddo
       call diagnostics_fill(tmpdiag,'CLDRAS  ',L,1,3,bi,bj,myid)
      enddo
      endif

      if(diagnostics_is_on('CLDTOT  ',myid) ) then
       do L=1,lm
       do j=1,jm
       do i=1,im
        tmpdiag(i,j) = cldtot(i,j,L)
       enddo
       enddo
       call diagnostics_fill(tmpdiag,'CLDTOT  ',L,1,3,bi,bj,myid)
      enddo
      endif

      if(diagnostics_is_on('CLDLOW  ',myid) ) then
       call diagnostics_fill(cldlow,'CLDLOW  ',0,1,3,bi,bj,myid)
      endif

      if(diagnostics_is_on('CLDMID  ',myid) ) then
       call diagnostics_fill(cldmid,'CLDMID  ',0,1,3,bi,bj,myid)
      endif

      if(diagnostics_is_on('CLDHI   ',myid) ) then
       call diagnostics_fill(cldhi,'CLDHI   ',0,1,3,bi,bj,myid)
      endif

      if(diagnostics_is_on('LZRAD   ',myid) ) then
       do L=1,lm
       do j=1,jm
       do i=1,im
        tmpdiag(i,j) = swlz(i,j,L) * 1.0e6
       enddo
       enddo
       call diagnostics_fill(tmpdiag,'LZRAD   ',L,1,3,bi,bj,myid)
       enddo
      endif

c Albedo Diagnostics
c ------------------
      if(diagnostics_is_on('ALBVISDR',myid) ) then
       call diagnostics_fill(albvisdr,'ALBVISDR',0,1,3,bi,bj,myid)
      endif

      if(diagnostics_is_on('ALBVISDF',myid) ) then
       call diagnostics_fill(albvisdf,'ALBVISDF',0,1,3,bi,bj,myid)
      endif

      if(diagnostics_is_on('ALBNIRDR',myid) ) then
       call diagnostics_fill(albnirdr,'ALBNIRDR',0,1,3,bi,bj,myid)
      endif

      if(diagnostics_is_on('ALBNIRDF',myid) ) then
       call diagnostics_fill(albnirdf,'ALBNIRDF',0,1,3,bi,bj,myid)
      endif

#endif

C Compute Optical Thicknesses and Diagnostics
C -------------------------------------------
      call opthk(tdry,plz,plze,swlz,cldtot,cldmxo,landtype,im,jm,lm,
     .                                                          tautype)

      do L = 1,lm
      do j = 1,jm
      do i = 1,im
      tau(i,j,L) = tautype(i,j,L,1)+tautype(i,j,L,2)+tautype(i,j,L,3)
      enddo
      enddo
      enddo

#ifdef ALLOW_DIAGNOSTICS
      if(diagnostics_is_on('TAUAVE  ',myid) ) then
       do L=1,lm
       do j=1,jm
       do i=1,im
        tmpdiag(i,j) = tau(i,j,L)*100/(plze(i,j,L+1)-plze(i,j,L))
       enddo
       enddo
       call diagnostics_fill(tmpdiag,'TAUAVE  ',L,1,3,bi,bj,myid)
      enddo
      endif

      if(diagnostics_is_on('TAUCLD  ',myid) .and.
     .                 diagnostics_is_on('TAUCLDC ',myid) ) then
       do L=1,lm
       do j=1,jm
       do i=1,im
        if( cldtot(i,j,L).ne.0.0 ) then
        tmpdiag(i,j) = tau(i,j,L)*100/(plze(i,j,L+1)-plze(i,j,L))
        tmpdiag2(i,j) = 1.
        else
        tmpdiag(i,j) = 0.
        tmpdiag2(i,j) = 0.
        endif
       enddo
       enddo
       call diagnostics_fill(tmpdiag,'TAUCLD  ',L,1,3,bi,bj,myid)
       call diagnostics_fill(tmpdiag,'TAUCLDC ',L,1,3,bi,bj,myid)
      enddo
      endif

c Compute Low, Mid, and High Cloud Optical Depth Diagnostics
c ----------------------------------------------------------
      if(diagnostics_is_on('TAULOW  ',myid) .and.
     .                 diagnostics_is_on('TAULOWC ',myid) ) then
       do j = 1,jm
       do i = 1,im
        taulow(i,j) =  0.0
        if( cldlow(i,j).ne.0.0 ) then
         do L = low_level,lm
          taulow(i,j) = taulow(i,j) + tau(i,j,L)
         enddo
         tmpdiag2(i,j) = 1.
        else
         tmpdiag(i,j) = 0.
        endif
       enddo
       enddo
       call diagnostics_fill(taulow,'TAULOW  ',0,1,3,bi,bj,myid)
       call diagnostics_fill(tmpdiag2,'TAULOWC ',0,1,3,bi,bj,myid)
      endif

      if(diagnostics_is_on('TAUMID  ',myid) .and.
     .                 diagnostics_is_on('TAUMIDC ',myid) ) then
       do j = 1,jm
       do i = 1,im
        taumid(i,j) =  0.0
        if( cldmid(i,j).ne.0.0 ) then
         do L = mid_level,low_level+1
          taumid(i,j) = taumid(i,j) + tau(i,j,L)
         enddo
         tmpdiag2(i,j) = 1.
        else
         tmpdiag(i,j) = 0.
        endif
       enddo
       enddo
       call diagnostics_fill(taumid,'TAUMID  ',0,1,3,bi,bj,myid)
       call diagnostics_fill(tmpdiag2,'TAUMIDC ',0,1,3,bi,bj,myid)
      endif

      if(diagnostics_is_on('TAUHI   ',myid) .and.
     .                 diagnostics_is_on('TAUHIC  ',myid) ) then
       do j = 1,jm
       do i = 1,im
        tauhi(i,j) =  0.0
        if( cldhi(i,j).ne.0.0 ) then
         do L = 1,mid_level+1
          tauhi(i,j) = tauhi(i,j) + tau(i,j,L)
         enddo
         tmpdiag2(i,j) = 1.
        else
         tmpdiag(i,j) = 0.
        endif
       enddo
       enddo
       call diagnostics_fill(tauhi,'TAUHI   ',0,1,3,bi,bj,myid)
       call diagnostics_fill(tmpdiag2,'TAUHIC  ',0,1,3,bi,bj,myid)
      endif
#endif

C***********************************************************************
C ****                     LOOP OVER GLOBAL REGIONS                 ****
C **********************************************************************

      do 1000 nn = 1,npcs

C **********************************************************************
C ****                   VARIABLE INITIALIZATION                    ****
C **********************************************************************

      CALL STRIP ( zenith,COSZ,im*jm,ISTRIP,1,NN )

      CALL STRIP ( plze,  ple   ,im*jm,ISTRIP,lm+1,NN)
      CALL STRIP ( pkz ,  pk    ,im*jm,ISTRIP,lm  ,NN)
      CALL STRIP ( dpres,dpstrip,im*jm,ISTRIP,lm  ,NN)
      CALL STRIP ( tdry,  tzl   ,im*jm,ISTRIP,lm  ,NN)
      CALL STRIP ( qz  ,  qzl   ,im*jm,ISTRIP,lm  ,NN)
      CALL STRIP ( oz  ,  ozl   ,im*jm,ISTRIP,lm  ,NN)
      CALL STRIP ( tau ,  taul  ,im*jm,ISTRIP,lm  ,NN)

      CALL STRIP ( albvisdr,albuvdr,im*jm,ISTRIP,1,NN )
      CALL STRIP ( albvisdf,albuvdf,im*jm,ISTRIP,1,NN )
      CALL STRIP ( albnirdr,albirdr,im*jm,ISTRIP,1,NN )
      CALL STRIP ( albnirdf,albirdf,im*jm,ISTRIP,1,NN )

      call strip ( cldtot,clro,im*jm,istrip,lm,nn )

c Partition Tau between Water and Ice Particles
c ---------------------------------------------
      do L= 1,lm
      do i= 1,istrip
              alf = min( max((tzl(i,l)-253.15)/20.,0. _d 0) ,1. _d 0)
      taua(i,L)   = 0.

      if( alf.ne.0.0 .and. alf.ne.1.0 ) then
      tauc(i,L,1) = taul(i,L)/(1.+alf/(1-alf) * (reffi/reffw*0.80) )
      tauc(i,L,2) = taul(i,L)/(1.+(1-alf)/alf * (reffw/reffi*1.25) )
      endif

      if( alf.eq.0.0 ) then
      tauc(i,L,1) = taul(i,L)
      tauc(i,L,2) = 0.0
      endif

      if( alf.eq.1.0 ) then
      tauc(i,L,1) = 0.0
      tauc(i,L,2) = taul(i,L)
      endif

      reff(i,L,1) = reffi
      reff(i,L,2) = reffw
      enddo
      enddo

      call sorad ( istrip,1,1,lm,ple,tzl,qzl,ozl,co2,
     .             tauc,reff,clro,mid_level,low_level,taua,
     .             albirdr,albirdf,albuvdr,albuvdf,cosz,
     .             flux,fluxclr,fdirir,fdifir,dirpar,difpar,
     .             fdiruv,fdifuv )

C **********************************************************************
C ****     Compute Mass-Weighted Theta Tendencies from Fluxes       ****
C **********************************************************************

      do l=1,lm
      do i=1,istrip
      alf = grav*(ple(i,Lm+1)-ptop)/(cp*dpstrip(i,L)*100)
      dtsw (i,L) = alf*( flux   (i,L)-flux   (i,L+1) )/pk(i,L)
      dtswc(i,L) = alf*( fluxclr(i,L)-fluxclr(i,L+1) )/pk(i,L)
      enddo
      enddo

      call paste ( dtsw , dtradsw ,istrip,im*jm,lm,nn )
      call paste ( dtswc, dtswclr ,istrip,im*jm,lm,nn )

      call paste ( flux   (1,1),osr   ,istrip,im*jm,1,nn )
      call paste ( fluxclr(1,1),osrclr,istrip,im*jm,1,nn )

      call paste ( flux   (1,lm+1),radswg,istrip,im*jm,1,nn )
      call paste ( fluxclr(1,lm+1),swgclr,istrip,im*jm,1,nn )

      call paste ( dirpar,fdirpar,istrip,im*jm,1,nn )
      call paste ( difpar,fdifpar,istrip,im*jm,1,nn )

c Calculate Mean Albedo
c ---------------------
      do i=1,istrip
       if( cosz(i).gt.0.0 ) then
        tstrip(i) = 1.0 - flux(i,lm+1)/
     . ( fdirir(i)+fdifir(i)+dirpar(i)+difpar(i) + fdiruv(i)+fdifuv(i) )
        if( tstrip(i).lt.0.0 ) tstrip(i) = undef
       else
        tstrip(i) = undef
       endif
      enddo
      call paste ( tstrip,albedo,istrip,im*jm,1,nn )

 1000 CONTINUE

#ifdef ALLOW_DIAGNOSTICS

c Mean Albedo Diagnostic
c ----------------------
      if(diagnostics_is_on('ALBEDO  ',myid) .and.
     .                 diagnostics_is_on('ALBEDOC ',myid) ) then
       do j=1,jm
       do i=1,im
        if( albedo(i,j).ne.undef ) then
         tmpdiag(i,j) = albedo(i,j)
         tmpdiag2(i,j) = 1.
        else
         tmpdiag(i,j) = 0.
         tmpdiag2(i,j) = 0.
        endif
       enddo
       enddo
       call diagnostics_fill(tmpdiag,'ALBEDO  ',0,1,3,bi,bj,myid)
       call diagnostics_fill(tmpdiag2,'ALBEDOC ',0,1,3,bi,bj,myid)
      endif
#endif

C **********************************************************************
C ****                 ZERO-OUT OR BUMP COUNTERS                    ****
C **********************************************************************

      nswlz    = 0
      nswcld   = 0
      imstturb = 0

      do L = 1,lm
      do j = 1,jm
      do i = 1,im
         fccave(i,j,L) = 0.
        qliqave(i,j,L) = 0.
      enddo
      enddo
      enddo

      return
      end
      subroutine opthk ( tl,pl,ple,lz,cf,cfm,lwi,im,jm,lm,tau )
C***********************************************************************
C
C  PURPOSE:
C  ========
C    Compute cloud optical thickness using temperature and
C    cloud fractions.
C
C  INPUT:
C  ======
C    tl ......... Temperature at Model Layers (K)
C    pl ......... Model Layer Pressures (mb)
C    ple ........ Model Edge  Pressures (mb)
C    lz ......... Diagnosed Convective and Large-Scale Cloud Water (g/g)
C    cf ......... Total Cloud Fraction (Random + Maximum Overlap)
C    cfm ........ Maximum Overlap Cloud Fraction
C    lwi ........ Surface Land Type
C    im ......... Longitudinal dimension
C    jm ......... Latitudinal  dimension
C    lm ......... Vertical     dimension
C
C  OUTPUT:
C  =======
C    tau ........ Cloud Optical Thickness (non-dimensional)
C                  tau(im,jm,lm,1):  Suspended Ice
C                  tau(im,jm,lm,2):  Suspended Water
C                  tau(im,jm,lm,3):  Raindrops
C
C***********************************************************************

      implicit none

      integer  im,jm,lm,i,j,L

      _RL  tl(im,jm,lm)
      _RL  pl(im,jm,lm)
      _RL ple(im,jm,lm+1)
      _RL  lz(im,jm,lm)
      _RL  cf(im,jm,lm)
      _RL cfm(im,jm,lm)
      _RL tau(im,jm,lm,3)
      integer lwi(im,jm)

      _RL dp, alf, fracls, fraccu
      _RL tauice, tauh2o, tauras

c Compute Cloud Optical Depths
c ----------------------------
      do L=1,lm
      do j=1,jm
      do i=1,im
         alf   =  min( max(( tl(i,j,L)-233.15)/20.,0. _d 0), 1. _d 0)
         dp   =  ple(i,j,L+1)-ple(i,j,L)
         tau(i,j,L,1)  = 0.0
         tau(i,j,L,2)  = 0.0
         tau(i,j,L,3)  = 0.0
      if( cf(i,j,L).ne.0.0 ) then

c Determine fraction of large-scale and cumulus clouds
c ----------------------------------------------------
         fracls = ( cf(i,j,L)-cfm(i,j,L) )/cf(i,j,L)
         fraccu = 1.0-fracls

c Define tau for large-scale ice and water clouds
c Note:  tauice is scaled between (0.02 & .2) for:  0 < lz <  2 mg/kg over Land
c Note:  tauh2o is scaled between (0.20 & 20) for:  0 < lz <  5 mg/kg over Land
c Note:  tauh2o is scaled between (0.20 & 12) for:  0 < lz < 50 mg/kg over Ocean
c -------------------------------------------------------------------------------

c Large-Scale Ice
c ---------------
         tauice = max( 0.0002 _d 0, 0.002*min(500*lz(i,j,L)*1000,
     $        1.0 _d 0) )
         tau(i,j,L,1) = fracls*(1-alf)*tauice*dp

c Large-Scale Water
c -----------------
C Over Land
         if( lwi(i,j).le.10 ) then
            tauh2o = max( 0.0020 _d 0, 0.200*min(200*lz(i,j,L)*1000,
     $           1.0 _d 0) )
          tau(i,j,L,3) = fracls*alf*tauh2o*dp
         else
C Non-Precipitation Clouds Over Ocean
          if( lz(i,j,L).eq.0.0 ) then
           tauh2o = .12
           tau(i,j,L,2) = fracls*alf*tauh2o*dp
          else
C Over Ocean
             tauh2o = max( 0.0020 _d 0, 0.120*min( 20*lz(i,j,L)*1000,
     $            1.0 _d 0) )
           tau(i,j,L,3) = fracls*alf*tauh2o*dp
          endif
         endif

c Sub-Grid Convective
c -------------------
         if( tl(i,j,L).gt.210.0 ) then
         tauras = .16
         tau(i,j,L,3) = tau(i,j,L,3) + fraccu*tauras*dp
         else
         tauras = tauice
         tau(i,j,L,1) = tau(i,j,L,1) + fraccu*tauras*dp
         endif

c Define tau for large-scale and cumulus clouds
c ---------------------------------------------
ccc      tau(i,j,L) = ( fracls*( alf*tauh2o + (1-alf)*tauice )
ccc  .                + fraccu*tauras )*dp

      endif

      enddo
      enddo
      enddo

      return
      end
      subroutine sorad(m,n,ndim,np,pl,ta,wa,oa,co2,
     *                 taucld,reff,fcld,ict,icb,
     *                 taual,rsirbm,rsirdf,rsuvbm,rsuvdf,cosz,
     *                 flx,flc,fdirir,fdifir,fdirpar,fdifpar,
     *                 fdiruv,fdifuv)
c********************************************************************
c
c This routine computes solar fluxes due to the absoption by water
c  vapor, ozone, co2, o2, clouds, and aerosols and due to the
c  scattering by clouds, aerosols, and gases.
c
c This is a vectorized code. It computes the fluxes simultaneous for
c  (m x n) soundings, which is a subset of the (m x ndim) soundings.
c  In a global climate model, m and ndim correspond to the numbers of
c  grid boxes in the zonal and meridional directions, respectively.
c
c Ice and liquid cloud particles are allowed to co-exist in any of the
c  np layers. Two sets of cloud parameters are required as inputs, one
c  for ice paticles and the other for liquid particles.  These parameters
c  are optical thickness (taucld) and effective particle size (reff).
c
c If no information is available for reff, a default value of
c  10 micron for liquid water and 75 micron for ice can be used.
c
c Clouds are grouped into high, middle, and low clouds separated by the
c  level indices ict and icb.  For detail, see the subroutine cldscale.
c
c----- Input parameters:
c                                                   units      size
c   number of soundings in zonal direction (m)       n/d        1
c   number of soundings in meridional direction (n)  n/d        1
c   maximum number of soundings in                   n/d        1
c           meridional direction (ndim)
c   number of atmospheric layers (np)                n/d        1
c   level pressure (pl)                              mb       m*ndim*(np+1)
c   layer temperature (ta)                           k        m*ndim*np
c   layer specific humidity (wa)                     gm/gm    m*ndim*np
c   layer ozone concentration (oa)                   gm/gm    m*ndim*np
c   co2 mixing ratio by volumn (co2)               parts/part   1
c   cloud optical thickness (taucld)                 n/d      m*ndim*np*2
c                index 1 for ice particles
c                index 2 for liquid drops
c   effective cloud-particle size (reff)           micrometer m*ndim*np*2
c                index 1 for ice particles
c                index 2 for liquid drops
c   cloud amount (fcld)                            fraction   m*ndim*np
c   level index separating high and middle           n/d        1
c                clouds (ict)
c   level index separating middle and low clouds     n/d        1
c                clouds (icb)
c   aerosol optical thickness (taual)                n/d      m*ndim*np
c   solar ir surface albedo for beam                fraction   m*ndim
c                radiation (rsirbm)
c   solar ir surface albedo for diffuse             fraction   m*ndim
c                radiation (rsirdf)
c   uv + par surface albedo for beam                     fraction   m*ndim
c                radiation (rsuvbm)
c   uv + par surface albedo for diffuse                  fraction   m*ndim
c                radiation (rsuvdf)
c   cosine of solar zenith angle (cosz)            n/d        m*ndim
c
c----- Output parameters
c
c   all-sky flux (downward minus upward) (flx)     fraction   m*ndim*(np+1)
c   clear-sky flux (downward minus upward) (flc)   fraction   m*ndim*(np+1)
c   all-sky direct downward ir (0.7-10 micron)
c                flux at the surface (fdirir)      fraction   m*ndim
c   all-sky diffuse downward ir flux at
c                the surface (fdifir)              fraction   m*ndim
c   all-sky direct downward par (0.4-0.7 micron)
c                flux at the surface (fdirpar)     fraction   m*ndim
c   all-sky diffuse downward par flux at
c                the surface (fdifpar)             fraction   m*ndim
*
c----- Notes:
c
c    (1) The unit of flux is fraction of the incoming solar radiation
c        at the top of the atmosphere.  Therefore, fluxes should
c        be equal to flux multiplied by the extra-terrestrial solar
c        flux and the cosine of solar zenith angle.
c    (2) Clouds and aerosols can be included in any layers by specifying
c        fcld(i,j,k), taucld(i,j,k,*) and taual(i,j,k), k=1,np.
c        For an atmosphere without clouds and aerosols,
c        set fcld(i,j,k)=taucld(i,j,k,*)=taual(i,j,k)=0.0.
c    (3) Aerosol single scattering albedos and asymmetry
c        factors are specified in the subroutines solir and soluv.
c    (4) pl(i,j,1) is the pressure at the top of the model, and
c        pl(i,j,np+1) is the surface pressure.
c    (5) the pressure levels ict and icb correspond approximately
c        to 400 and 700 mb.
c
c**************************************************************************

      implicit none

c-----Explicit Inline Directives

#ifdef FIZHI_CRAY
#ifdef FIZHI_F77_COMPIL
cfpp$ expand (expmn)
#endif
#endif
      _RL expmn

c-----input parameters

      integer m,n,ndim,np,ict,icb
      _RL pl(m,ndim,np+1),ta(m,ndim,np),wa(m,ndim,np),oa(m,ndim,np)
      _RL  taucld(m,ndim,np,2),reff(m,ndim,np,2)
      _RL  fcld(m,ndim,np),taual(m,ndim,np)
      _RL  rsirbm(m,ndim),rsirdf(m,ndim),
     *     rsuvbm(m,ndim),rsuvdf(m,ndim),cosz(m,ndim),co2

c-----output parameters

      _RL  flx(m,ndim,np+1),flc(m,ndim,np+1)
      _RL  fdirir(m,ndim),fdifir(m,ndim)
      _RL  fdirpar(m,ndim),fdifpar(m,ndim)
      _RL  fdiruv(m,ndim),fdifuv(m,ndim)

c-----temporary array

      integer i,j,k
      _RL  cc(m,n,3),tauclb(m,n,np),tauclf(m,n,np)
      _RL  dp(m,n,np),wh(m,n,np),oh(m,n,np),scal(m,n,np)
      _RL  swh(m,n,np+1),so2(m,n,np+1),df(m,n,np+1)
      _RL  sdf(m,n),sclr(m,n),csm(m,n),x

c-----------------------------------------------------------------

      do j= 1, n
       do i= 1, m

         swh(i,j,1)=0.
         so2(i,j,1)=0.

c-----csm is the effective secant of the solar zenith angle
c     see equation (12) of Lacis and Hansen (1974, JAS)

         csm(i,j)=35./sqrt(1224.*cosz(i,j)*cosz(i,j)+1.)

       enddo
      enddo

      do k= 1, np
       do j= 1, n
         do i= 1, m

c-----compute layer thickness and pressure-scaling function.
c     indices for the surface level and surface layer
c     are np+1 and np, respectively.

          dp(i,j,k)=pl(i,j,k+1)-pl(i,j,k)
          scal(i,j,k)=dp(i,j,k)*(.5*(pl(i,j,k)+pl(i,j,k+1))/300.)**.8

c-----compute scaled water vapor amount, unit is g/cm**2

          wh(i,j,k)=1.02*wa(i,j,k)*scal(i,j,k)*
     *              (1.+0.00135*(ta(i,j,k)-240.))
          swh(i,j,k+1)=swh(i,j,k)+wh(i,j,k)

c-----compute ozone amount, unit is (cm-atm)stp.

          oh(i,j,k)=1.02*oa(i,j,k)*dp(i,j,k)*466.7

        enddo
       enddo
      enddo

c-----scale cloud optical thickness in each layer from taucld (with
c     cloud amount fcld) to tauclb and tauclf (with cloud amount cc).
c     tauclb is the scaled optical thickness for beam radiation and
c     tauclf is for diffuse radiation.

      call cldscale(m,n,ndim,np,cosz,fcld,taucld,ict,icb,
     *              cc,tauclb,tauclf)

c-----initialize fluxes for all-sky (flx), clear-sky (flc), and
c     flux reduction (df)

      do k=1, np+1
       do j=1, n
        do i=1, m
          flx(i,j,k)=0.
          flc(i,j,k)=0.
          df(i,j,k)=0.
        enddo
       enddo
      enddo

c-----compute solar ir fluxes

      call solir (m,n,ndim,np,wh,taucld,tauclb,tauclf,reff,ict,icb
     *     ,fcld,cc,taual,csm,rsirbm,rsirdf,flx,flc,fdirir,fdifir)

c-----compute and update uv and par fluxes

      call soluv (m,n,ndim,np,oh,dp,taucld,tauclb,tauclf,reff,ict,icb
     *     ,fcld,cc,taual,csm,rsuvbm,rsuvdf,flx,flc
     *     ,fdirpar,fdifpar,fdiruv,fdifuv)

c-----compute scaled amount of o2 (so2), unit is (cm-atm)stp.

      do k= 1, np
       do j= 1, n
        do i= 1, m
          so2(i,j,k+1)=so2(i,j,k)+165.22*scal(i,j,k)
        enddo
       enddo
      enddo

c-----compute flux reduction due to oxygen following
c      chou (J. climate, 1990). The fraction 0.0287 is the
c      extraterrestrial solar flux in the o2 bands.

       do k= 2, np+1
        do j= 1, n
         do i= 1, m
           x=so2(i,j,k)*csm(i,j)
           df(i,j,k)=df(i,j,k)+0.0287*(1.-expmn(-0.00027*sqrt(x)))
         enddo
        enddo
       enddo

c-----compute scaled amounts for co2 (so2). unit is (cm-atm)stp.

      do k= 1, np
       do j= 1, n
        do i= 1, m
         so2(i,j,k+1)=so2(i,j,k)+co2*789.*scal(i,j,k)
        enddo
       enddo
      enddo

c-----compute and update flux reduction due to co2 following
c     chou (J. Climate, 1990)

      call flxco2(m,n,np,so2,swh,csm,df)

c-----adjust for the effect of o2 cnd co2 on clear-sky fluxes.

      do k= 2, np+1
       do j= 1, n
        do i= 1, m
          flc(i,j,k)=flc(i,j,k)-df(i,j,k)
        enddo
       enddo
      enddo

c-----adjust for the all-sky fluxes due to o2 and co2.  It is
c     assumed that o2 and co2 have no effects on solar radiation
c     below clouds. clouds are assumed randomly overlapped.

      do j=1,n
       do i=1,m
        sdf(i,j)=0.0
        sclr(i,j)=1.0
       enddo
      enddo

      do k=1,np
       do j=1,n
        do i=1,m

c-----sclr is the fraction of clear sky.
c     sdf is the flux reduction below clouds.

         if(fcld(i,j,k).gt.0.01) then
          sdf(i,j)=sdf(i,j)+df(i,j,k)*sclr(i,j)*fcld(i,j,k)
          sclr(i,j)=sclr(i,j)*(1.-fcld(i,j,k))
         endif
          flx(i,j,k+1)=flx(i,j,k+1)-sdf(i,j)-df(i,j,k+1)*sclr(i,j)

        enddo
       enddo
      enddo

c-----adjust for the direct downward ir flux.
      do j= 1, n
       do i= 1, m
         x = (1.-rsirdf(i,j))*fdifir(i,j) + (1.-rsirbm(i,j))*fdirir(i,j)
         x = (-sdf(i,j)-df(i,j,np+1)*sclr(i,j))/x
         fdirir(i,j)=fdirir(i,j)*(1.+x)
         fdifir(i,j)=fdifir(i,j)*(1.+x)
       enddo
      enddo

      return
      end

c********************************************************************

      subroutine cldscale (m,n,ndim,np,cosz,fcld,taucld,ict,icb,
     *                     cc,tauclb,tauclf)

c********************************************************************
c
c   This subroutine computes the covers of high, middle, and
c    low clouds and scales the cloud optical thickness.
c
c   To simplify calculations in a cloudy atmosphere, clouds are
c    grouped into high, middle and low clouds separated by the levels
c    ict and icb (level 1 is the top of the atmosphere).
c
c   Within each of the three groups, clouds are assumed maximally
c    overlapped, and the cloud cover (cc) of a group is the maximum
c    cloud cover of all the layers in the group.  The optical thickness
c    (taucld) of a given layer is then scaled to new values (tauclb and
c    tauclf) so that the layer reflectance corresponding to the cloud
c    cover cc is the same as the original reflectance with optical
c    thickness taucld and cloud cover fcld.
c
c---input parameters
c
c    number of grid intervals in zonal direction (m)
c    number of grid intervals in meridional direction (n)
c    maximum number of grid intervals in meridional direction (ndim)
c    number of atmospheric layers (np)
c    cosine of the solar zenith angle (cosz)
c    fractional cloud cover (fcld)
c    cloud optical thickness (taucld)
c    index separating high and middle clouds (ict)
c    index separating middle and low clouds (icb)
c
c---output parameters
c
c    fractional cover of high, middle, and low clouds (cc)
c    scaled cloud optical thickness for beam radiation (tauclb)
c    scaled cloud optical thickness for diffuse radiation (tauclf)
c
c********************************************************************

      implicit none

c-----input parameters

      integer m,n,ndim,np,ict,icb
      _RL  cosz(m,ndim),fcld(m,ndim,np),taucld(m,ndim,np,2)

c-----output parameters

      _RL  cc(m,n,3),tauclb(m,n,np),tauclf(m,n,np)

c-----temporary variables

      integer i,j,k,im,it,ia,kk
      _RL   fm,ft,fa,xai,taux

c-----pre-computed table

      integer   nm,nt,na
      parameter (nm=11,nt=9,na=11)
      _RL   dm,dt,da,t1,caib(nm,nt,na),caif(nt,na)
      parameter (dm=0.1,dt=0.30103,da=0.1,t1=-0.9031)

c-----include the pre-computed table for cai

#include "cai-dat.h"
      save caib,caif

c-----clouds within each of the high, middle, and low clouds are
c     assumed maximally overlapped, and the cloud cover (cc)
c     for a group is the maximum cloud cover of all the layers
c     in the group

      do j=1,n
       do i=1,m
          cc(i,j,1)=0.0
          cc(i,j,2)=0.0
          cc(i,j,3)=0.0
       enddo
      enddo

      do k=1,ict-1
       do j=1,n
        do i=1,m
           cc(i,j,1)=max(cc(i,j,1),fcld(i,j,k))
        enddo
       enddo
      enddo

      do k=ict,icb-1
       do j=1,n
        do i=1,m
           cc(i,j,2)=max(cc(i,j,2),fcld(i,j,k))
        enddo
       enddo
      enddo

      do k=icb,np
       do j=1,n
        do i=1,m
           cc(i,j,3)=max(cc(i,j,3),fcld(i,j,k))
        enddo
       enddo
      enddo

c-----scale the cloud optical thickness.
c     taucld(i,j,k,1) is the optical thickness for ice particles, and
c     taucld(i,j,k,2) is the optical thickness for liquid particles.

      do k=1,np

         if(k.lt.ict) then
            kk=1
         elseif(k.ge.ict .and. k.lt.icb) then
            kk=2
         else
            kk=3
         endif

       do j=1,n
        do i=1,m

         tauclb(i,j,k) = 0.0
         tauclf(i,j,k) = 0.0

         taux=taucld(i,j,k,1)+taucld(i,j,k,2)
         if (taux.gt.0.05 .and. fcld(i,j,k).gt.0.01) then

c-----normalize cloud cover

           fa=fcld(i,j,k)/cc(i,j,kk)

c-----table look-up

           taux=min(taux,32. _d 0)

           fm=cosz(i,j)/dm
           ft=(log10(taux)-t1)/dt
           fa=fa/da

           im=int(fm+1.5)
           it=int(ft+1.5)
           ia=int(fa+1.5)

           im=max(im,2)
           it=max(it,2)
           ia=max(ia,2)

           im=min(im,nm-1)
           it=min(it,nt-1)
           ia=min(ia,na-1)

           fm=fm-float(im-1)
           ft=ft-float(it-1)
           fa=fa-float(ia-1)

c-----scale cloud optical thickness for beam radiation.
c     the scaling factor, xai, is a function of the solar zenith
c     angle, optical thickness, and cloud cover.

           xai=    (-caib(im-1,it,ia)*(1.-fm)+
     *      caib(im+1,it,ia)*(1.+fm))*fm*.5+caib(im,it,ia)*(1.-fm*fm)

           xai=xai+(-caib(im,it-1,ia)*(1.-ft)+
     *      caib(im,it+1,ia)*(1.+ft))*ft*.5+caib(im,it,ia)*(1.-ft*ft)

           xai=xai+(-caib(im,it,ia-1)*(1.-fa)+
     *     caib(im,it,ia+1)*(1.+fa))*fa*.5+caib(im,it,ia)*(1.-fa*fa)

           xai= xai-2.*caib(im,it,ia)
           xai=max(xai,0.0 _d 0)

           tauclb(i,j,k) = taux*xai

c-----scale cloud optical thickness for diffuse radiation.
c     the scaling factor, xai, is a function of the cloud optical
c     thickness and cover but not the solar zenith angle.

           xai=    (-caif(it-1,ia)*(1.-ft)+
     *      caif(it+1,ia)*(1.+ft))*ft*.5+caif(it,ia)*(1.-ft*ft)

           xai=xai+(-caif(it,ia-1)*(1.-fa)+
     *      caif(it,ia+1)*(1.+fa))*fa*.5+caif(it,ia)*(1.-fa*fa)

           xai= xai-caif(it,ia)
           xai=max(xai,0.0 _d 0)

           tauclf(i,j,k) = taux*xai

         endif

        enddo
       enddo
      enddo

      return
      end
c***********************************************************************

      subroutine solir (m,n,ndim,np,wh,taucld,tauclb,tauclf,reff,
     *  ict,icb,fcld,cc,taual,csm,rsirbm,rsirdf,flx,flc,fdirir,fdifir)

c************************************************************************
c  compute solar flux in the infrared region. The spectrum is divided
c   into three bands:
c
c          band   wavenumber(/cm)  wavelength (micron)
c           1       1000-4400         2.27-10.0
c           2       4400-8200         1.22-2.27
c           3       8200-14300        0.70-1.22
c
c----- Input parameters:                            units      size
c
c   number of soundings in zonal direction (m)       n/d        1
c   number of soundings in meridional direction (n)  n/d        1
c   maximum number of soundings in                   n/d        1
c          meridional direction (ndim)
c   number of atmospheric layers (np)                n/d        1
c   layer water vapor content (wh)                 gm/cm^2    m*n*np
c   cloud optical thickness (taucld)                 n/d      m*ndim*np*2
c          index 1 for ice paticles
c          index 2 for liquid particles
c   scaled cloud optical thickness                   n/d      m*n*np
c          for beam radiation (tauclb)
c   scaled cloud optical thickness                   n/d      m*n*np
c          for diffuse radiation  (tauclf)
c   effective cloud-particle size (reff)           micrometer m*ndim*np*2
c          index 1 for ice paticles
c          index 2 for liquid particles
c   level index separating high and                  n/d      m*n
c          middle clouds (ict)
c   level index separating middle and                n/d      m*n
c          low clouds (icb)
c   cloud amount (fcld)                            fraction   m*ndim*np
c   cloud amount of high, middle, and                n/d      m*n*3
c          low clouds (cc)
c   aerosol optical thickness (taual)                n/d      m*ndim*np
c   cosecant of the solar zenith angle (csm)         n/d      m*n
c   near ir surface albedo for beam                fraction   m*ndim
c                radiation (rsirbm)
c   near ir surface albedo for diffuse             fraction   m*ndim
c                radiation (rsirdf)
c
c----- output (updated) parameters:
c
c   all-sky flux (downward-upward) (flx)           fraction   m*ndim*(np+1)
c   clear-sky flux (downward-upward) (flc)         fraction   m*ndim*(np+1)
c   all-sky direct downward ir flux at
c          the surface (fdirir)                    fraction   m*ndim
c   all-sky diffuse downward ir flux at
c          the surface (fdifir)                    fraction   m*ndim
c
c----- note: the following parameters must be specified by users:
c   aerosol single scattering albedo (ssaal)         n/d      nband
c   aerosol asymmetry factor (asyal)                 n/d      nband
c
c*************************************************************************

      implicit none

c-----Explicit Inline Directives

#ifdef FIZHI_CRAY
#ifdef FIZHI_F77_COMPIL
cfpp$ expand (deledd)
cfpp$ expand (sagpol)
cfpp$ expand (expmn)
#endif
#endif
      _RL expmn

c-----input parameters

      integer m,n,ndim,np,ict,icb
      _RL  taucld(m,ndim,np,2),reff(m,ndim,np,2),fcld(m,ndim,np)
      _RL  tauclb(m,n,np),tauclf(m,n,np),cc(m,n,3)
      _RL  rsirbm(m,ndim),rsirdf(m,ndim)
      _RL  wh(m,n,np),taual(m,ndim,np),csm(m,n)

c-----output (updated) parameters

      _RL  flx(m,ndim,np+1),flc(m,ndim,np+1)
      _RL  fdirir(m,ndim),fdifir(m,ndim)

c-----static parameters

      integer nk,nband
      parameter (nk=10,nband=3)
      _RL  xk(nk),hk(nband,nk),ssaal(nband),asyal(nband)
      _RL  aia(nband,3),awa(nband,3),aig(nband,3),awg(nband,3)

c-----temporary array

      integer ib,ik,i,j,k
      _RL  ssacl(m,n,np),asycl(m,n,np)
      _RL  rr(m,n,np+1,2),tt(m,n,np+1,2),td(m,n,np+1,2),
     *       rs(m,n,np+1,2),ts(m,n,np+1,2)
      _RL  fall(m,n,np+1),fclr(m,n,np+1)
      _RL  fsdir(m,n),fsdif(m,n)

      _RL  tauwv,tausto,ssatau,asysto,tauto,ssato,asyto
      _RL  taux,reff1,reff2,w1,w2,g1,g2
      _RL  ssaclt(m,n),asyclt(m,n)
      _RL  rr1t(m,n),tt1t(m,n),td1t(m,n),rs1t(m,n),ts1t(m,n)
      _RL  rr2t(m,n),tt2t(m,n),td2t(m,n),rs2t(m,n),ts2t(m,n)

c-----water vapor absorption coefficient for 10 k-intervals.
c     unit: cm^2/gm

      data xk/
     1  0.0010, 0.0133, 0.0422, 0.1334, 0.4217,
     2  1.334,  5.623,  31.62,  177.8,  1000.0/

c-----water vapor k-distribution function,
c     the sum of hk is 0.52926. unit: fraction

      data hk/
     1 .01074,.08236,.20673,  .00360,.01157,.03497,
     2 .00411,.01133,.03011,  .00421,.01143,.02260,
     3 .00389,.01240,.01336,  .00326,.01258,.00696,
     4 .00499,.01381,.00441,  .00465,.00650,.00115,
     5 .00245,.00244,.00026,  .00145,.00094,.00000/

c-----aerosol single-scattering albedo and asymmetry factor

      data ssaal,asyal/nband*0.999,nband*0.850/

c-----coefficients for computing the single scattering albedo of
c     ice clouds from ssa=1-(aia(*,1)+aia(*,2)*reff+aia(*,3)*reff**2)

      data aia/
     1  .08938331, .00215346,-.00000260,
     2  .00299387, .00073709, .00000746,
     3 -.00001038,-.00000134, .00000000/

c-----coefficients for computing the single scattering albedo of
c     liquid clouds from ssa=1-(awa(*,1)+awa(*,2)*reff+awa(*,3)*reff**2)

      data awa/
     1  .01209318,-.00019934, .00000007,
     2  .01784739, .00088757, .00000845,
     3 -.00036910,-.00000650,-.00000004/

c-----coefficients for computing the asymmetry factor of ice clouds
c     from asycl=aig(*,1)+aig(*,2)*reff+aig(*,3)*reff**2

      data aig/
     1  .84090400, .76098937, .74935228,
     2  .00126222, .00141864, .00119715,
     3 -.00000385,-.00000396,-.00000367/

c-----coefficients for computing the asymmetry factor of liquid clouds
c     from asycl=awg(*,1)+awg(*,2)*reff+awg(*,3)*reff**2

      data awg/
     1  .83530748, .74513197, .79375035,
     2  .00257181, .01370071, .00832441,
     3  .00005519,-.00038203,-.00023263/

c-----initialize surface fluxes, reflectances, and transmittances

      do j= 1, n
       do i= 1, m
         fdirir(i,j)=0.0
         fdifir(i,j)=0.0
         rr(i,j,np+1,1)=rsirbm(i,j)
         rr(i,j,np+1,2)=rsirbm(i,j)
         rs(i,j,np+1,1)=rsirdf(i,j)
         rs(i,j,np+1,2)=rsirdf(i,j)
         td(i,j,np+1,1)=0.0
         td(i,j,np+1,2)=0.0
         tt(i,j,np+1,1)=0.0
         tt(i,j,np+1,2)=0.0
         ts(i,j,np+1,1)=0.0
         ts(i,j,np+1,2)=0.0
       enddo
      enddo

c-----integration over spectral bands

      do 100 ib=1,nband

c-----compute cloud single scattering albedo and asymmetry factor
c     for a mixture of ice and liquid particles.

       do k= 1, np

        do j= 1, n
         do i= 1, m

           ssaclt(i,j)=1.0
           asyclt(i,j)=1.0

           taux=taucld(i,j,k,1)+taucld(i,j,k,2)
          if (taux.gt.0.05 .and. fcld(i,j,k).gt.0.01) then

           reff1=min(reff(i,j,k,1),130. _d 0)
           reff2=min(reff(i,j,k,2),20.0 _d 0)

           w1=(1.-(aia(ib,1)+(aia(ib,2)+
     *         aia(ib,3)*reff1)*reff1))*taucld(i,j,k,1)
           w2=(1.-(awa(ib,1)+(awa(ib,2)+
     *         awa(ib,3)*reff2)*reff2))*taucld(i,j,k,2)
           ssaclt(i,j)=(w1+w2)/taux

           g1=(aig(ib,1)+(aig(ib,2)+aig(ib,3)*reff1)*reff1)*w1
           g2=(awg(ib,1)+(awg(ib,2)+awg(ib,3)*reff2)*reff2)*w2
           asyclt(i,j)=(g1+g2)/(w1+w2)

          endif

         enddo
        enddo

        do j=1,n
         do i=1,m
            ssacl(i,j,k)=ssaclt(i,j)
         enddo
        enddo
        do j=1,n
         do i=1,m
            asycl(i,j,k)=asyclt(i,j)
         enddo
        enddo

       enddo

c-----integration over the k-distribution function

         do 200 ik=1,nk

          do 300 k= 1, np

           do j= 1, n
            do i= 1, m

             tauwv=xk(ik)*wh(i,j,k)

c-----compute total optical thickness, single scattering albedo,
c     and asymmetry factor.

             tausto=tauwv+taual(i,j,k)+1.0e-8
             ssatau=ssaal(ib)*taual(i,j,k)
             asysto=asyal(ib)*ssaal(ib)*taual(i,j,k)

c-----compute reflectance and transmittance for cloudless layers

             tauto=tausto
             ssato=ssatau/tauto+1.0e-8

c            if (ssato .gt. 0.001) then

c             ssato=min(ssato,0.999999 _d 0)
c             asyto=asysto/(ssato*tauto)

c             call deledd(tauto,ssato,asyto,csm(i,j),
c     *                   rr1t(i,j),tt1t(i,j),td1t(i,j))

c             call sagpol (tauto,ssato,asyto,rs1t(i,j),ts1t(i,j))

c            else

             td1t(i,j)=expmn(-tauto*csm(i,j))
             ts1t(i,j)=expmn(-1.66*tauto)
             tt1t(i,j)=0.0
             rr1t(i,j)=0.0
             rs1t(i,j)=0.0

c            endif

c-----compute reflectance and transmittance for cloud layers

             if (tauclb(i,j,k) .lt. 0.01) then

              rr2t(i,j)=rr1t(i,j)
              tt2t(i,j)=tt1t(i,j)
              td2t(i,j)=td1t(i,j)
              rs2t(i,j)=rs1t(i,j)
              ts2t(i,j)=ts1t(i,j)

             else

              tauto=tausto+tauclb(i,j,k)
              ssato=(ssatau+ssacl(i,j,k)*tauclb(i,j,k))/tauto+1.0e-8
              ssato=min(ssato,0.999999 _d 0)
              asyto=(asysto+asycl(i,j,k)*ssacl(i,j,k)*tauclb(i,j,k))/
     *              (ssato*tauto)

              call deledd(tauto,ssato,asyto,csm(i,j),
     *                    rr2t(i,j),tt2t(i,j),td2t(i,j))

              tauto=tausto+tauclf(i,j,k)
              ssato=(ssatau+ssacl(i,j,k)*tauclf(i,j,k))/tauto+1.0e-8
              ssato=min(ssato,0.999999 _d 0)
              asyto=(asysto+asycl(i,j,k)*ssacl(i,j,k)*tauclf(i,j,k))/
     *              (ssato*tauto)

              call sagpol (tauto,ssato,asyto,rs2t(i,j),ts2t(i,j))

             endif

            enddo
           enddo

c-----the following code appears to be awkward, but it is efficient
c     in certain parallel processors.

           do j=1,n
            do i=1,m
               rr(i,j,k,1)=rr1t(i,j)
            enddo
           enddo
           do j=1,n
            do i=1,m
               tt(i,j,k,1)=tt1t(i,j)
            enddo
           enddo
           do j=1,n
            do i=1,m
               td(i,j,k,1)=td1t(i,j)
            enddo
           enddo
           do j=1,n
            do i=1,m
               rs(i,j,k,1)=rs1t(i,j)
            enddo
           enddo
           do j=1,n
            do i=1,m
               ts(i,j,k,1)=ts1t(i,j)
            enddo
           enddo

           do j=1,n
            do i=1,m
               rr(i,j,k,2)=rr2t(i,j)
            enddo
           enddo
           do j=1,n
            do i=1,m
               tt(i,j,k,2)=tt2t(i,j)
            enddo
           enddo
           do j=1,n
            do i=1,m
               td(i,j,k,2)=td2t(i,j)
            enddo
           enddo
           do j=1,n
            do i=1,m
               rs(i,j,k,2)=rs2t(i,j)
            enddo
           enddo
           do j=1,n
            do i=1,m
               ts(i,j,k,2)=ts2t(i,j)
            enddo
           enddo

 300  continue

c-----flux calculations

       do k= 1, np+1
        do j= 1, n
         do i= 1, m
          fclr(i,j,k) = 0.
          fall(i,j,k) = 0.
         enddo
        enddo
       enddo
       do j= 1, n
        do i= 1, m
         fsdir(i,j) = 0.
         fsdif(i,j) = 0.
        enddo
       enddo

        call cldflx (m,n,np,ict,icb,cc,rr,tt,td,rs,ts,
     *               fclr,fall,fsdir,fsdif)

       do k= 1, np+1
        do j= 1, n
         do i= 1, m
          flx(i,j,k) = flx(i,j,k)+fall(i,j,k)*hk(ib,ik)
         enddo
        enddo
        do j= 1, n
         do i= 1, m
          flc(i,j,k) = flc(i,j,k)+fclr(i,j,k)*hk(ib,ik)
         enddo
        enddo
       enddo

       do j= 1, n
        do i= 1, m
          fdirir(i,j) = fdirir(i,j)+fsdir(i,j)*hk(ib,ik)
          fdifir(i,j) = fdifir(i,j)+fsdif(i,j)*hk(ib,ik)
        enddo
       enddo

  200 continue
  100 continue

      return
      end

c************************************************************************

      subroutine soluv (m,n,ndim,np,oh,dp,taucld,tauclb,tauclf,reff,
     *  ict,icb,fcld,cc,taual,csm,rsuvbm,rsuvdf,flx,flc
     * ,fdirpar,fdifpar,fdiruv,fdifuv)

c************************************************************************
c  compute solar fluxes in the uv+visible region. the spectrum is
c  grouped into 8 bands:
c
c              Band     Micrometer
c
c       UV-C    1.     .175 - .225
c               2.     .225 - .245
c                      .260 - .280
c               3.     .245 - .260
c
c       UV-B    4.     .280 - .295
c               5.     .295 - .310
c               6.     .310 - .320
c
c       UV-A    7.     .320 - .400
c
c       PAR     8.     .400 - .700
c
c----- Input parameters:                            units      size
c
c   number of soundings in zonal direction (m)       n/d        1
c   number of soundings in meridional direction (n)  n/d        1
c   maximum number of soundings in                   n/d        1
c           meridional direction (ndim)
c   number of atmospheric layers (np)                n/d        1
c   layer ozone content (oh)                      (cm-atm)stp m*n*np
c   layer pressure thickness (dp)                    mb       m*n*np
c   cloud optical thickness (taucld)                 n/d      m*ndim*np*2
c          index 1 for ice paticles
c          index 2 for liquid particles
c   scaled cloud optical thickness                   n/d      m*n*np
c          for beam radiation (tauclb)
c   scaled cloud optical thickness                   n/d      m*n*np
c          for diffuse radiation  (tauclf)
c   effective cloud-particle size (reff)           micrometer m*ndim*np*2
c          index 1 for ice paticles
c          index 2 for liquid particles
c   level indiex separating high and                 n/d      m*n
c          middle clouds (ict)
c   level indiex separating middle and               n/d      m*n
c          low clouds (icb)
c   cloud amount (fcld)                            fraction   m*ndim*np
c   cloud amounts of high, middle, and               n/d      m*n*3
c          low clouds (cc)
c   aerosol optical thickness (taual)                n/d      m*ndim*np
c   cosecant of the solar zenith angle (csm)         n/d      m*n
c   uv+par surface albedo for beam                 fraction   m*ndim
c           radiation (rsuvbm)
c   uv+par surface albedo for diffuse              fraction   m*ndim
c           radiation (rsuvdf)
c
c----- output (updated) parameters:
c
c   all-sky net downward flux (flx)                fraction   m*ndim*(np+1)
c   clear-sky net downward flux (flc)              fraction   m*ndim*(np+1)
c   all-sky direct downward par flux at
c          the surface (fdirpar)                   fraction   m*ndim
c   all-sky diffuse downward par flux at
c          the surface (fdifpar)                   fraction   m*ndim
c
c----- note: the following parameters must be specified by users:
c
c   aerosol single scattering albedo (ssaal)         n/d        1
c   aerosol asymmetry factor (asyal)                 n/d        1
c
*
c***********************************************************************

      implicit none

c-----Explicit Inline Directives

#ifdef FIZHI_CRAY
#ifdef FIZHI_F77_COMPIL
cfpp$ expand (deledd)
cfpp$ expand (sagpol)
#endif
#endif

c-----input parameters

      integer m,n,ndim,np,ict,icb
      _RL  taucld(m,ndim,np,2),reff(m,ndim,np,2),fcld(m,ndim,np)
      _RL  tauclb(m,n,np),tauclf(m,n,np),cc(m,n,3)
      _RL  oh(m,n,np),dp(m,n,np),taual(m,ndim,np)
      _RL  rsuvbm(m,ndim),rsuvdf(m,ndim),csm(m,n)

c-----output (updated) parameter

      _RL  flx(m,ndim,np+1),flc(m,ndim,np+1)
      _RL  fdirpar(m,ndim),fdifpar(m,ndim)
      _RL  fdiruv(m,ndim),fdifuv(m,ndim)

c-----static parameters

      integer nband
      parameter (nband=8)
      _RL  hk(nband),xk(nband),ry(nband)
      _RL  asyal(nband),ssaal(nband),aig(3),awg(3)

c-----temporary array

      integer i,j,k,ib
      _RL  taurs,tauoz,tausto,ssatau,asysto,tauto,ssato,asyto
      _RL  taux,reff1,reff2,g1,g2,asycl(m,n,np)
      _RL  td(m,n,np+1,2),rr(m,n,np+1,2),tt(m,n,np+1,2),
     *       rs(m,n,np+1,2),ts(m,n,np+1,2)
      _RL  fall(m,n,np+1),fclr(m,n,np+1),fsdir(m,n),fsdif(m,n)
      _RL  asyclt(m,n)
      _RL  rr1t(m,n),tt1t(m,n),td1t(m,n),rs1t(m,n),ts1t(m,n)
      _RL  rr2t(m,n),tt2t(m,n),td2t(m,n),rs2t(m,n),ts2t(m,n)

c-----hk is the fractional extra-terrestrial solar flux.
c     the sum of hk is 0.47074.

      data hk/.00057, .00367, .00083, .00417,
     *        .00600, .00556, .05913, .39081/

c-----xk is the ozone absorption coefficient. unit: /(cm-atm)stp

      data xk /30.47, 187.2,  301.9,   42.83,
     *         7.09,  1.25,   0.0345,  0.0539/

c-----ry is the extinction coefficient for Rayleigh scattering.
c     unit: /mb.

      data ry /.00604, .00170, .00222, .00132,
     *         .00107, .00091, .00055, .00012/

c-----aerosol single-scattering albedo and asymmetry factor

      data ssaal,asyal/nband*0.999,nband*0.850/

c-----coefficients for computing the asymmetry factor of ice clouds
c     from asycl=aig(*,1)+aig(*,2)*reff+aig(*,3)*reff**2

      data aig/.74625000,.00105410,-.00000264/

c-----coefficients for computing the asymmetry factor of liquid
c     clouds from asycl=awg(*,1)+awg(*,2)*reff+awg(*,3)*reff**2

      data awg/.82562000,.00529000,-.00014866/

c-----initialize surface reflectances and transmittances

      do j= 1, n
       do i= 1, m
         rr(i,j,np+1,1)=rsuvbm(i,j)
         rr(i,j,np+1,2)=rsuvbm(i,j)
         rs(i,j,np+1,1)=rsuvdf(i,j)
         rs(i,j,np+1,2)=rsuvdf(i,j)
         td(i,j,np+1,1)=0.0
         td(i,j,np+1,2)=0.0
         tt(i,j,np+1,1)=0.0
         tt(i,j,np+1,2)=0.0
         ts(i,j,np+1,1)=0.0
         ts(i,j,np+1,2)=0.0
       enddo
      enddo

c-----compute cloud asymmetry factor for a mixture of
c     liquid and ice particles.  unit of reff is micrometers.

      do k= 1, np

       do j= 1, n
        do i= 1, m

           asyclt(i,j)=1.0

           taux=taucld(i,j,k,1)+taucld(i,j,k,2)
          if (taux.gt.0.05 .and. fcld(i,j,k).gt.0.01) then

           reff1=min(reff(i,j,k,1),130. _d 0)
           reff2=min(reff(i,j,k,2),20.0 _d 0)

           g1=(aig(1)+(aig(2)+aig(3)*reff1)*reff1)*taucld(i,j,k,1)
           g2=(awg(1)+(awg(2)+awg(3)*reff2)*reff2)*taucld(i,j,k,2)
           asyclt(i,j)=(g1+g2)/taux

          endif

        enddo
       enddo

       do j=1,n
        do i=1,m
           asycl(i,j,k)=asyclt(i,j)
        enddo
       enddo

      enddo

      do j=1,n
       do i=1,m
        fdiruv(i,j)=0.0
        fdifuv(i,j)=0.0
       enddo
      enddo

c-----integration over spectral bands

      do 100 ib=1,nband

       do 300 k= 1, np

        do j= 1, n
         do i= 1, m

c-----compute ozone and rayleigh optical thicknesses

          taurs=ry(ib)*dp(i,j,k)
          tauoz=xk(ib)*oh(i,j,k)

c-----compute total optical thickness, single scattering albedo,
c     and asymmetry factor

          tausto=taurs+tauoz+taual(i,j,k)+1.0e-8
          ssatau=ssaal(ib)*taual(i,j,k)+taurs
          asysto=asyal(ib)*ssaal(ib)*taual(i,j,k)

c-----compute reflectance and transmittance for cloudless layers

          tauto=tausto
          ssato=ssatau/tauto+1.0e-8
          ssato=min(ssato,0.999999 _d 0)
          asyto=asysto/(ssato*tauto)

          call deledd(tauto,ssato,asyto,csm(i,j),
     *                rr1t(i,j),tt1t(i,j),td1t(i,j))

          call sagpol (tauto,ssato,asyto,rs1t(i,j),ts1t(i,j))

c-----compute reflectance and transmittance for cloud layers

          if (tauclb(i,j,k) .lt. 0.01) then

           rr2t(i,j)=rr1t(i,j)
           tt2t(i,j)=tt1t(i,j)
           td2t(i,j)=td1t(i,j)
           rs2t(i,j)=rs1t(i,j)
           ts2t(i,j)=ts1t(i,j)

          else

           tauto=tausto+tauclb(i,j,k)
           ssato=(ssatau+tauclb(i,j,k))/tauto+1.0e-8
           ssato=min(ssato,0.999999 _d 0)
           asyto=(asysto+asycl(i,j,k)*tauclb(i,j,k))/(ssato*tauto)

           call deledd(tauto,ssato,asyto,csm(i,j),
     *                 rr2t(i,j),tt2t(i,j),td2t(i,j))

           tauto=tausto+tauclf(i,j,k)
           ssato=(ssatau+tauclf(i,j,k))/tauto+1.0e-8
           ssato=min(ssato,0.999999 _d 0)
           asyto=(asysto+asycl(i,j,k)*tauclf(i,j,k))/(ssato*tauto)

           call sagpol (tauto,ssato,asyto,rs2t(i,j),ts2t(i,j))

          endif

         enddo
        enddo

        do j=1,n
         do i=1,m
            rr(i,j,k,1)=rr1t(i,j)
         enddo
        enddo
        do j=1,n
         do i=1,m
            tt(i,j,k,1)=tt1t(i,j)
         enddo
        enddo
        do j=1,n
         do i=1,m
            td(i,j,k,1)=td1t(i,j)
         enddo
        enddo
        do j=1,n
         do i=1,m
            rs(i,j,k,1)=rs1t(i,j)
         enddo
        enddo
        do j=1,n
         do i=1,m
            ts(i,j,k,1)=ts1t(i,j)
         enddo
        enddo

        do j=1,n
         do i=1,m
            rr(i,j,k,2)=rr2t(i,j)
         enddo
        enddo
        do j=1,n
         do i=1,m
            tt(i,j,k,2)=tt2t(i,j)
         enddo
        enddo
        do j=1,n
         do i=1,m
            td(i,j,k,2)=td2t(i,j)
         enddo
        enddo
        do j=1,n
         do i=1,m
            rs(i,j,k,2)=rs2t(i,j)
         enddo
        enddo
        do j=1,n
         do i=1,m
            ts(i,j,k,2)=ts2t(i,j)
         enddo
        enddo

 300  continue

c-----flux calculations

       do k= 1, np+1
        do j= 1, n
         do i= 1, m
          fclr(i,j,k) = 0.
          fall(i,j,k) = 0.
         enddo
        enddo
       enddo
       do j= 1, n
        do i= 1, m
         fsdir(i,j) = 0.
         fsdif(i,j) = 0.
        enddo
       enddo
        call cldflx (m,n,np,ict,icb,cc,rr,tt,td,rs,ts,
     *               fclr,fall,fsdir,fsdif)

       do k= 1, np+1
        do j= 1, n
         do i= 1, m
          flx(i,j,k)=flx(i,j,k)+fall(i,j,k)*hk(ib)
         enddo
        enddo
        do j= 1, n
         do i= 1, m
          flc(i,j,k)=flc(i,j,k)+fclr(i,j,k)*hk(ib)
         enddo
        enddo
       enddo

       if(ib.eq.nband) then
         do j=1,n
          do i=1,m
           fdirpar(i,j)=fsdir(i,j)*hk(ib)
           fdifpar(i,j)=fsdif(i,j)*hk(ib)
         enddo
        enddo
       else
         do j=1,n
          do i=1,m
           fdiruv(i,j)=fdiruv(i,j)+fsdir(i,j)*hk(ib)
           fdifuv(i,j)=fdifuv(i,j)+fsdif(i,j)*hk(ib)
         enddo
        enddo
       endif

 100  continue

      return
      end

c*********************************************************************

      subroutine deledd(tau,ssc,g0,csm,rr,tt,td)

c*********************************************************************
c
c-----uses the delta-eddington approximation to compute the
c     bulk scattering properties of a single layer
c     coded following King and Harshvardhan (JAS, 1986)
c
c  inputs:
c
c     tau: the effective optical thickness
c     ssc: the effective single scattering albedo
c     g0:  the effective asymmetry factor
c     csm: the effective secant of the zenith angle
c
c  outputs:
c
c     rr: the layer reflection of the direct beam
c     tt: the layer diffuse transmission of the direct beam
c     td: the layer direct transmission of the direct beam

c*********************************************************************

      implicit none

c-----Explicit Inline Directives

#ifdef FIZHI_CRAY
#ifdef FIZHI_F77_COMPIL
cfpp$ expand (expmn)
#endif
#endif
      _RL expmn

      _RL  zero,one,two,three,four,fourth,seven,tumin
      parameter (one=1., three=3.)
      parameter (seven=7., two=2.)
      parameter (four=4., fourth=.25)
      parameter (zero=0., tumin=1.e-20)

c-----input parameters
      _RL  tau,ssc,g0,csm

c-----output parameters
      _RL  rr,tt,td

c-----temporary parameters

      _RL  zth,ff,xx,taup,sscp,gp,gm1,gm2,gm3,akk,alf1,alf2,
     *     all1,bll,st7,st8,cll,dll,fll,ell,st1,st2,st3,st4
c
                zth = one / csm

c  delta-eddington scaling of single scattering albedo,
c  optical thickness, and asymmetry factor,
c  K & H eqs(27-29)

                ff  = g0*g0
                xx  = one-ff*ssc
                taup= tau*xx
                sscp= ssc*(one-ff)/xx
                gp  = g0/(one+g0)

c  extinction of the direct beam transmission

                td  = expmn(-taup*csm)

c  gamma1, gamma2, gamma3 and gamma4. see table 2 and eq(26) K & H
c  ssc and gp are the d-s single scattering
c  albedo and asymmetry factor.

                xx  =  three*gp
                gm1 =  (seven - sscp*(four+xx))*fourth
                gm2 = -(one   - sscp*(four-xx))*fourth
                gm3 =  (two   -        zth*xx )*fourth

c  akk is k as defined in eq(25) of K & H

                xx  = gm1-gm2
                akk = sqrt((gm1+gm2)*xx)

c   alf1 and alf2 are alpha1 and alpha2 from eqs (23) & (24) of K & H

                alf1 = gm1 - gm3 * xx
                alf2 = gm2 + gm3 * xx

c  all1 is last term in eq(21) of K & H
c  bll is last term in eq(22) of K & H

                xx  = akk * two
                all1 = (gm3 - alf2 * zth    )*xx*td
                bll = (one - gm3 + alf1*zth)*xx

                xx  = akk * zth
                st7 = one - xx
                st8 = one + xx

                xx  = akk * gm3
                cll = (alf2 + xx) * st7
                dll = (alf2 - xx) * st8

                xx  = akk * (one-gm3)
                fll = (alf1 + xx) * st8
                ell = (alf1 - xx) * st7

                st3 = max(abs(st7*st8),tumin)
                st3 = sign (st3,st7)

                st2 = expmn(-akk*taup)
                st4 = st2 * st2

                st1 =  sscp / ((akk+gm1 + (akk-gm1)*st4) * st3)

c   rr is r-hat of eq(21) of K & H
c   tt is diffuse part of t-hat of eq(22) of K & H

                rr =   ( cll-dll*st4    -all1*st2)*st1
                tt = - ((fll-ell*st4)*td-bll*st2)*st1

                rr = max(rr,zero)
                tt = max(tt,zero)

      return
      end

c*********************************************************************

      subroutine sagpol(tau,ssc,g0,rll,tll)

c*********************************************************************
c-----transmittance (tll) and reflectance (rll) of diffuse radiation
c     follows Sagan and Pollock (JGR, 1967).
c     also, eq.(31) of Lacis and Hansen (JAS, 1974).
c
c-----input parameters:
c
c      tau: the effective optical thickness
c      ssc: the effective single scattering albedo
c      g0:  the effective asymmetry factor
c
c-----output parameters:
c
c      rll: the layer reflection of diffuse radiation
c      tll: the layer transmission of diffuse radiation
c
c*********************************************************************

      implicit none

c-----Explicit Inline Directives

#ifdef FIZHI_CRAY
#ifdef FIZHI_F77_COMPIL
cfpp$ expand (expmn)
#endif
#endif
      _RL expmn

      _RL  one,three,four
      parameter (one=1., three=3., four=4.)

c-----output parameters:

      _RL  tau,ssc,g0

c-----output parameters:

      _RL  rll,tll

c-----temporary arrays

      _RL  xx,uuu,ttt,emt,up1,um1,st1

             xx  = one-ssc*g0
             uuu = sqrt( xx/(one-ssc))
             ttt = sqrt( xx*(one-ssc)*three )*tau
             emt = expmn(-ttt)
             up1 = uuu + one
             um1 = uuu - one
             xx  = um1*emt
             st1 = one / ((up1+xx) * (up1-xx))
             rll = up1*um1*(one-emt*emt)*st1
             tll = uuu*four*emt         *st1

      return
      end

c*******************************************************************

      function expmn(fin)

c*******************************************************************
c compute exponential for arguments in the range 0> fin > -10.
c*******************************************************************
      implicit none
      _RL  fin,expmn

      _RL one,expmin,e1,e2,e3,e4
      parameter (one=1.0, expmin=-10.0)
      parameter (e1=1.0,        e2=-2.507213e-1)
      parameter (e3=2.92732e-2, e4=-3.827800e-3)

      if (fin .lt. expmin) fin = expmin
      expmn = ((e4*fin + e3)*fin+e2)*fin+e1
      expmn = expmn * expmn
      expmn = one / (expmn * expmn)

      return
      end

c*******************************************************************

      subroutine cldflx (m,n,np,ict,icb,cc,rr,tt,td,rs,ts,
     *           fclr,fall,fsdir,fsdif)

c*******************************************************************
c  compute upward and downward fluxes using a two-stream adding method
c  following equations (3)-(5) of Chou (1992, JAS).
c
c  clouds are grouped into high, middle, and low clouds which are
c  assumed randomly overlapped. It involves eight sets of calculations.
c  In each set of calculations, each atmospheric layer is homogeneous,
c  either with clouds or without clouds.

c  input parameters:
c     m:   number of soundings in zonal direction
c     n:   number of soundings in meridional direction
c     np:  number of atmospheric layers
c     ict: the level separating high and middle clouds
c     icb: the level separating middle and low clouds
c     cc:  effective cloud covers for high, middle and low clouds
c     tt:  diffuse transmission of a layer illuminated by beam radiation
c     td:  direct beam tranmssion
c     ts:  transmission of a layer illuminated by diffuse radiation
c     rr:  reflection of a layer illuminated by beam radiation
c     rs:  reflection of a layer illuminated by diffuse radiation
c
c  output parameters:
c     fclr:  clear-sky flux (downward minus upward)
c     fall:  all-sky flux (downward minus upward)
c     fdndir: surface direct downward flux
c     fdndif: surface diffuse downward flux
c*********************************************************************c

      implicit none

c-----input parameters

      integer m,n,np,ict,icb

      _RL  rr(m,n,np+1,2),tt(m,n,np+1,2),td(m,n,np+1,2)
      _RL  rs(m,n,np+1,2),ts(m,n,np+1,2)
      _RL  cc(m,n,3)

c-----temporary array

      integer i,j,k,ih,im,is
      _RL  rra(m,n,np+1,2,2),tta(m,n,np+1,2,2),tda(m,n,np+1,2,2)
      _RL  rsa(m,n,np+1,2,2),rxa(m,n,np+1,2,2)
      _RL  ch(m,n),cm(m,n),ct(m,n),flxdn(m,n,np+1)
      _RL  fdndir(m,n),fdndif(m,n),fupdif
      _RL  denm,xx

c-----output parameters

      _RL  fclr(m,n,np+1),fall(m,n,np+1)
      _RL  fsdir(m,n),fsdif(m,n)

c-----initialize all-sky flux (fall) and surface downward fluxes

      do k=1,np+1
       do j=1,n
        do i=1,m
           fall(i,j,k)=0.0
        enddo
       enddo
      enddo

       do j=1,n
        do i=1,m
           fsdir(i,j)=0.0
           fsdif(i,j)=0.0
        enddo
       enddo

c-----compute transmittances and reflectances for a composite of
c     layers. layers are added one at a time, going down from the top.
c     tda is the composite transmittance illuminated by beam radiation
c     tta is the composite diffuse transmittance illuminated by
c         beam radiation
c     rsa is the composite reflectance illuminated from below
c         by diffuse radiation
c     tta and rsa are computed from eqs. (4b) and (3b) of Chou

c-----for high clouds. indices 1 and 2 denote clear and cloudy
c     situations, respectively.

      do 10 ih=1,2

       do j= 1, n
        do i= 1, m
          tda(i,j,1,ih,1)=td(i,j,1,ih)
          tta(i,j,1,ih,1)=tt(i,j,1,ih)
          rsa(i,j,1,ih,1)=rs(i,j,1,ih)
          tda(i,j,1,ih,2)=td(i,j,1,ih)
          tta(i,j,1,ih,2)=tt(i,j,1,ih)
          rsa(i,j,1,ih,2)=rs(i,j,1,ih)
        enddo
       enddo

       do k= 2, ict-1
        do j= 1, n
         do i= 1, m
          denm = ts(i,j,k,ih)/( 1.-rsa(i,j,k-1,ih,1)*rs(i,j,k,ih))
          tda(i,j,k,ih,1)= tda(i,j,k-1,ih,1)*td(i,j,k,ih)
          tta(i,j,k,ih,1)= tda(i,j,k-1,ih,1)*tt(i,j,k,ih)
     *                  +(tda(i,j,k-1,ih,1)*rr(i,j,k,ih)
     *                  *rsa(i,j,k-1,ih,1)+tta(i,j,k-1,ih,1))*denm
          rsa(i,j,k,ih,1)= rs(i,j,k,ih)+ts(i,j,k,ih)
     *                  *rsa(i,j,k-1,ih,1)*denm
          tda(i,j,k,ih,2)= tda(i,j,k,ih,1)
          tta(i,j,k,ih,2)= tta(i,j,k,ih,1)
          rsa(i,j,k,ih,2)= rsa(i,j,k,ih,1)
         enddo
        enddo
       enddo

c-----for middle clouds

      do 10 im=1,2

       do k= ict, icb-1
        do j= 1, n
         do i= 1, m
          denm = ts(i,j,k,im)/( 1.-rsa(i,j,k-1,ih,im)*rs(i,j,k,im))
          tda(i,j,k,ih,im)= tda(i,j,k-1,ih,im)*td(i,j,k,im)
          tta(i,j,k,ih,im)= tda(i,j,k-1,ih,im)*tt(i,j,k,im)
     *                  +(tda(i,j,k-1,ih,im)*rr(i,j,k,im)
     *                  *rsa(i,j,k-1,ih,im)+tta(i,j,k-1,ih,im))*denm
          rsa(i,j,k,ih,im)= rs(i,j,k,im)+ts(i,j,k,im)
     *                  *rsa(i,j,k-1,ih,im)*denm
         enddo
        enddo
       enddo

  10  continue

c-----layers are added one at a time, going up from the surface.
c     rra is the composite reflectance illuminated by beam radiation
c     rxa is the composite reflectance illuminated from above
c         by diffuse radiation
c     rra and rxa are computed from eqs. (4a) and (3a) of Chou

c-----for the low clouds

      do 20 is=1,2

       do j= 1, n
        do i= 1, m
         rra(i,j,np+1,1,is)=rr(i,j,np+1,is)
         rxa(i,j,np+1,1,is)=rs(i,j,np+1,is)
         rra(i,j,np+1,2,is)=rr(i,j,np+1,is)
         rxa(i,j,np+1,2,is)=rs(i,j,np+1,is)
        enddo
       enddo

       do k=np,icb,-1
        do j= 1, n
         do i= 1, m
          denm=ts(i,j,k,is)/( 1.-rs(i,j,k,is)*rxa(i,j,k+1,1,is) )
          rra(i,j,k,1,is)=rr(i,j,k,is)+(td(i,j,k,is)
     *        *rra(i,j,k+1,1,is)+tt(i,j,k,is)*rxa(i,j,k+1,1,is))*denm
          rxa(i,j,k,1,is)= rs(i,j,k,is)+ts(i,j,k,is)
     *        *rxa(i,j,k+1,1,is)*denm
          rra(i,j,k,2,is)=rra(i,j,k,1,is)
          rxa(i,j,k,2,is)=rxa(i,j,k,1,is)
         enddo
        enddo
       enddo

c-----for middle clouds

      do 20 im=1,2

       do k= icb-1,ict,-1
        do j= 1, n
         do i= 1, m
          denm=ts(i,j,k,im)/( 1.-rs(i,j,k,im)*rxa(i,j,k+1,im,is) )
          rra(i,j,k,im,is)= rr(i,j,k,im)+(td(i,j,k,im)
     *        *rra(i,j,k+1,im,is)+tt(i,j,k,im)*rxa(i,j,k+1,im,is))*denm
          rxa(i,j,k,im,is)= rs(i,j,k,im)+ts(i,j,k,im)
     *        *rxa(i,j,k+1,im,is)*denm
         enddo
        enddo
       enddo

  20  continue

c-----integration over eight sky situations.
c     ih, im, is denotes high, middle and low cloud groups.

      do 100 ih=1,2

c-----clear portion

         if(ih.eq.1) then
           do j=1,n
            do i=1,m
             ch(i,j)=1.0-cc(i,j,1)
            enddo
           enddo

          else

c-----cloudy portion

           do j=1,n
            do i=1,m
             ch(i,j)=cc(i,j,1)
            enddo
           enddo

          endif

      do 100 im=1,2

c-----clear portion

         if(im.eq.1) then

           do j=1,n
            do i=1,m
              cm(i,j)=ch(i,j)*(1.0-cc(i,j,2))
            enddo
           enddo

         else

c-----cloudy portion

           do j=1,n
            do i=1,m
              cm(i,j)=ch(i,j)*cc(i,j,2)
            enddo
           enddo

         endif

      do 100 is=1,2

c-----clear portion

         if(is.eq.1) then

           do j=1,n
            do i=1,m
             ct(i,j)=cm(i,j)*(1.0-cc(i,j,3))
            enddo
           enddo

         else

c-----cloudy portion

           do j=1,n
            do i=1,m
             ct(i,j)=cm(i,j)*cc(i,j,3)
            enddo
           enddo

         endif

c-----add one layer at a time, going down.

       do k= icb, np
        do j= 1, n
         do i= 1, m
          denm = ts(i,j,k,is)/( 1.-rsa(i,j,k-1,ih,im)*rs(i,j,k,is) )
          tda(i,j,k,ih,im)= tda(i,j,k-1,ih,im)*td(i,j,k,is)
          tta(i,j,k,ih,im)=  tda(i,j,k-1,ih,im)*tt(i,j,k,is)
     *         +(tda(i,j,k-1,ih,im)*rr(i,j,k,is)
     *         *rsa(i,j,k-1,ih,im)+tta(i,j,k-1,ih,im))*denm
          rsa(i,j,k,ih,im)= rs(i,j,k,is)+ts(i,j,k,is)
     *         *rsa(i,j,k-1,ih,im)*denm
         enddo
        enddo
       enddo

c-----add one layer at a time, going up.

       do k= ict-1,1,-1
        do j= 1, n
         do i= 1, m
          denm =ts(i,j,k,ih)/(1.-rs(i,j,k,ih)*rxa(i,j,k+1,im,is))
          rra(i,j,k,im,is)= rr(i,j,k,ih)+(td(i,j,k,ih)
     *        *rra(i,j,k+1,im,is)+tt(i,j,k,ih)*rxa(i,j,k+1,im,is))*denm
          rxa(i,j,k,im,is)= rs(i,j,k,ih)+ts(i,j,k,ih)
     *        *rxa(i,j,k+1,im,is)*denm
         enddo
        enddo
       enddo

c-----compute fluxes following eq (5) of Chou (1992)

c     fdndir is the direct  downward flux
c     fdndif is the diffuse downward flux
c     fupdif is the diffuse upward flux

      do k=2,np+1
       do j=1, n
        do i=1, m
         denm= 1./(1.- rxa(i,j,k,im,is)*rsa(i,j,k-1,ih,im))
         fdndir(i,j)= tda(i,j,k-1,ih,im)
         xx = tda(i,j,k-1,ih,im)*rra(i,j,k,im,is)
         fdndif(i,j)= (xx*rsa(i,j,k-1,ih,im)+tta(i,j,k-1,ih,im))*denm
         fupdif= (xx+tta(i,j,k-1,ih,im)*rxa(i,j,k,im,is))*denm
         flxdn(i,j,k)=fdndir(i,j)+fdndif(i,j)-fupdif
        enddo
       enddo
      enddo

       do j=1, n
        do i=1, m
         flxdn(i,j,1)=1.0-rra(i,j,1,im,is)
        enddo
       enddo

c-----summation of fluxes over all (eight) sky situations.

       do k=1,np+1
        do j=1,n
         do i=1,m
           if(ih.eq.1 .and. im.eq.1 .and. is.eq.1) then
             fclr(i,j,k)=flxdn(i,j,k)
           endif
             fall(i,j,k)=fall(i,j,k)+flxdn(i,j,k)*ct(i,j)
         enddo
        enddo
       enddo

        do j=1,n
         do i=1,m
            fsdir(i,j)=fsdir(i,j)+fdndir(i,j)*ct(i,j)
            fsdif(i,j)=fsdif(i,j)+fdndif(i,j)*ct(i,j)
         enddo
        enddo

  100 continue

      return
      end

c*****************************************************************

      subroutine flxco2(m,n,np,swc,swh,csm,df)

c*****************************************************************

c-----compute the reduction of clear-sky downward solar flux
c     due to co2 absorption.

      implicit none

c-----input parameters

      integer m,n,np
      _RL  csm(m,n),swc(m,n,np+1),swh(m,n,np+1),cah(22,19)

c-----output (undated) parameter

      _RL  df(m,n,np+1)

c-----temporary array

      integer i,j,k,ic,iw
      _RL  xx,clog1,wlog,dc,dw,x1,x2,y2

c********************************************************************
c-----include co2 look-up table

#include "cah-dat.h"
c     save cah

c********************************************************************
c-----table look-up for the reduction of clear-sky solar
c     radiation due to co2. The fraction 0.0343 is the
c     extraterrestrial solar flux in the co2 bands.

      do k= 2, np+1
       do j= 1, n
        do i= 1, m
          xx=1./.3
          clog1=log10(swc(i,j,k)*csm(i,j))
          wlog=log10(swh(i,j,k)*csm(i,j))
          ic=int( (clog1+3.15)*xx+1.)
          iw=int( (wlog+4.15)*xx+1.)
          if(ic.lt.2)ic=2
          if(iw.lt.2)iw=2
          if(ic.gt.22)ic=22
          if(iw.gt.19)iw=19
          dc=clog1-float(ic-2)*.3+3.
          dw=wlog-float(iw-2)*.3+4.
          x1=cah(1,iw-1)+(cah(1,iw)-cah(1,iw-1))*xx*dw
          x2=cah(ic-1,iw-1)+(cah(ic-1,iw)-cah(ic-1,iw-1))*xx*dw
          y2=x2+(cah(ic,iw-1)-cah(ic-1,iw-1))*xx*dc
          if (x1.lt.y2) x1=y2
          df(i,j,k)=df(i,j,k)+0.0343*(x1-y2)
        enddo
       enddo
      enddo

      return
      end

#include "GCHEM_OPTIONS.h"
#ifdef ALLOW_SEAICE
# include "SEAICE_OPTIONS.h"
#endif /* ALLOW_SEAICE */
#ifdef ALLOW_THSICE
# include "THSICE_OPTIONS.h"
#endif /* ALLOW_THSICE */
#ifdef ALLOW_AUTODIFF
# include "AUTODIFF_OPTIONS.h"
#endif

CBOP
C     !ROUTINE: CFC12_FORCING
C     !INTERFACE:
      SUBROUTINE CFC_FIELDS_LOAD (
     I           myTime, myIter, myThid )

C     !DESCRIPTION:
C     *==========================================================*
C     | SUBROUTINE CFC_FIELDS_LOAD
C     *==========================================================*

C     !USES:
      IMPLICIT NONE

C     == GLobal variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "CFC.h"
#ifdef ALLOW_EXF
# include "EXF_FIELDS.h"
#endif
#ifdef ALLOW_SEAICE
# include "SEAICE_SIZE.h"
# include "SEAICE.h"
#endif
#ifdef ALLOW_THSICE
# include "THSICE_VARS.h"
#endif /* ALLOW_THSICE */

C     !INPUT/OUTPUT PARAMETERS:
C     myTime     :: current time in simulation
C     myIter     :: current iteration number
C     myThid     :: my Thread Id number
      _RL myTime
      INTEGER myIter
      INTEGER myThid

C     !LOCAL VARIABLES:
      INTEGER intimeP, intime0, intime1
       INTEGER bi, bj, i, j
      _RL aWght, bWght
      _RL locWind(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
CEOP

      IF ( CFC_forcingCycle .GT. 0. _d 0 ) THEN

C First call requires that we initialize everything to zero for safety
cQQQ need to check timing
       IF ( myIter .EQ. nIter0 ) THEN
         DO bj = myByLo(myThid), myByHi(myThid)
          DO bi = myBxLo(myThid), myBxHi(myThid)
            CFC_ldRec(bi,bj) = 0
          ENDDO
         ENDDO
         CALL LEF_ZERO( wind0,myThid )
         CALL LEF_ZERO( wind1,myThid )
         CALL LEF_ZERO( atmosp0,myThid )
         CALL LEF_ZERO( atmosp1,myThid )
         CALL LEF_ZERO( ice0,myThid )
         CALL LEF_ZERO( ice1,myThid )
       ENDIF

C--   Now calculate whether it is time to update the forcing arrays
       CALL GET_PERIODIC_INTERVAL(
     O                   intimeP, intime0, intime1, bWght, aWght,
     I                   CFC_forcingCycle, CFC_forcingPeriod,
     I                   deltaTClock, myTime, myThid )

       bi = myBxLo(myThid)
       bj = myByLo(myThid)
#ifdef ALLOW_DEBUG
       IF ( debugLevel.GE.debLevB ) THEN
        _BEGIN_MASTER(myThid)
        WRITE(standardMessageUnit,'(A,I10,A,4I5,A,2F14.10)')
     &   ' CFC_FIELDS_LOAD,', myIter,
     &   ' : iP,iLd,i0,i1=', intimeP,CFC_ldRec(bi,bj), intime0,intime1,
     &   ' ; Wght=', bWght, aWght
        _END_MASTER(myThid)
       ENDIF
#endif /* ALLOW_DEBUG */

#ifdef ALLOW_AUTODIFF_TAMC
C-    assuming that we call S/R CFC_FIELDS_LOAD at each time-step and
C     with increasing time, this will catch when we need to load new records;
C     But with Adjoint run, this is not always the case => might end-up using
C     the wrong time-records
       IF ( intime0.NE.intimeP .OR. myIter.EQ.nIter0 ) THEN
#else /* ALLOW_AUTODIFF_TAMC */
C-    Make no assumption on sequence of calls to CFC_FIELDS_LOAD ;
C     This is the correct formulation (works in Adjoint run).
C     Unfortunatly, might produce many recomputations <== not used until it is fixed
       IF ( intime1.NE.CFC_ldRec(bi,bj) ) THEN
#endif /* ALLOW_AUTODIFF_TAMC */

C--   If the above condition is met then we need to read in
C     data for the period ahead and the period behind myTime.
        IF ( debugLevel.GE.debLevZero ) THEN
         _BEGIN_MASTER(myThid)
         WRITE(standardMessageUnit,'(A,I10,A,2(2I5,A))')
     &    ' CFC_FIELDS_LOAD, it=', myIter,
     &    ' : Reading new data, i0,i1=', intime0, intime1,
     &    ' (prev=', intimeP, CFC_ldRec(bi,bj), ' )'
         _END_MASTER(myThid)
        ENDIF

        _BARRIER

        IF ( CFC_windFile .NE. ' '  .AND. .NOT.useEXF ) THEN
         CALL READ_REC_XY_RS( CFC_windFile,wind0,intime0,
     &        myIter,myThid )
         CALL READ_REC_XY_RS( CFC_windFile,wind1,intime1,
     &        myIter,myThid )
        ENDIF
        IF ( CFC_atmospFile .NE. ' '  ) THEN
         CALL READ_REC_XY_RS( CFC_atmospFile,atmosp0,intime0,
     &        myIter,myThid )
         CALL READ_REC_XY_RS( CFC_atmospFile,atmosp1,intime1,
     &        myIter,myThid )
        ENDIF
        IF ( CFC_iceFile .NE. ' ' .AND.
     &       .NOT.useSEAICE .AND. .NOT.useThSIce ) THEN
         CALL READ_REC_XY_RS( CFC_iceFile,ice0,intime0,
     &       myIter,myThid )
         CALL READ_REC_XY_RS( CFC_iceFile,ice1,intime1,
     &       myIter,myThid )
        ENDIF

        IF ( .NOT.useEXF ) THEN
         _EXCH_XY_RS(wind0, myThid )
         _EXCH_XY_RS(wind1, myThid )
        ENDIF
         _EXCH_XY_RS(atmosp0, myThid )
         _EXCH_XY_RS(atmosp1, myThid )
        IF ( .NOT.useSEAICE .AND. .NOT.useThSIce ) THEN
         _EXCH_XY_RS(ice0, myThid )
         _EXCH_XY_RS(ice1, myThid )
        ENDIF

C-    save newly loaded time-record
        DO bj = myByLo(myThid), myByHi(myThid)
         DO bi = myBxLo(myThid), myBxHi(myThid)
           CFC_ldRec(bi,bj) = intime1
         ENDDO
        ENDDO

C--   end if-block for loading new time-records
       ENDIF

C endif for periodicForcing
      ENDIF

      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)

#ifdef ALLOW_EXF
        IF ( useEXF ) THEN
          DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
C     sh = max(wspeed,umin), with default umin=0.5m/s
c            locWind(i,j) = wspeed(i,j,bi,bj)
             locWind(i,j) = sh(i,j,bi,bj)
           ENDDO
          ENDDO
        ELSEIF ( CFC_forcingCycle.GT.zeroRL
     &           .AND. CFC_windFile.NE.' ' ) THEN
#else
        IF     ( CFC_forcingCycle.GT.zeroRL
     &           .AND. CFC_windFile.NE.' ' ) THEN
#endif /* ALLOW_EXF */
          DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
             locWind(i,j) = bWght*wind0(i,j,bi,bj)
     &                    + aWght*wind1(i,j,bi,bj)
           ENDDO
          ENDDO
        ELSE
          DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
             locWind(i,j) = 5. _d 0*maskC(i,j,1,bi,bj)
           ENDDO
          ENDDO
        ENDIF
c calculate piston velocity
c QQ: note - we should have wind speed variance in here
c following Wannikof (1992)
        DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
            pisVel(i,j,bi,bj)=(0.31 _d 0*locWind(i,j)**2)/3.6 _d 5
          ENDDO
        ENDDO

        IF ( CFC_forcingCycle.GT.zeroRL
     &       .AND. CFC_atmospFile.NE.' ' ) THEN
          DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
             ATMOSP(i,j,bi,bj) = bWght*atmosp0(i,j,bi,bj)
     &                         + aWght*atmosp1(i,j,bi,bj)
           ENDDO
          ENDDO
        ELSE
          DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
             ATMOSP(i,j,bi,bj) = maskC(i,j,1,bi,bj)
           ENDDO
          ENDDO
        ENDIF

        IF ( useThSIce ) THEN
#ifdef ALLOW_THSICE
          DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
             FIce(i,j,bi,bj) = iceMask(i,j,bi,bj)
           ENDDO
          ENDDO
#endif /* ALLOW_THSICE */
        ELSEIF ( useSEAICE ) THEN
#ifdef ALLOW_SEAICE
          DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
             FIce(i,j,bi,bj) = AREA(i,j,bi,bj)
           ENDDO
          ENDDO
#endif /* ALLOW_SEAICE */
        ELSEIF ( CFC_forcingCycle.GT.zeroRL
     &           .AND. CFC_iceFile.NE.' ' ) THEN
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
             FIce(i,j,bi,bj) = bWght*ice0(i,j,bi,bj)
     &                       + aWght*ice1(i,j,bi,bj)
          ENDDO
         ENDDO
        ELSE
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
             FIce(i,j,bi,bj) = 0. _d 0
          ENDDO
         ENDDO
        ENDIF

C--   end bi.bj loops
       ENDDO
      ENDDO

      RETURN
      END

#include "DWNSLP_OPTIONS.h"

CBOP
C     !ROUTINE: DWNSLP_CALC_FLOW
C     !INTERFACE:
      SUBROUTINE DWNSLP_CALC_FLOW(
     I                             bi, bj, kBottom, rho3d,
     I                             myTime, myIter, myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE DWNSLP_CALC_FLOW
C     | o Detect active site of Down-Sloping flow and compute
C     |   the corresponding volume transport
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "DWNSLP_SIZE.h"
#include "DWNSLP_PARAMS.h"
#include "DWNSLP_VARS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
C     bi,bj     :: Tile indices
C     kBottom   :: Vertical index of bottom grid cell.
C     rho3d     :: In-situ density [kg/m3] computed at z=rC ;
C     myTime    :: Current time in simulation
C     myIter    :: Current time-step number
C     myThid    :: my Thread Id number
      INTEGER bi, bj
      INTEGER kBottom( xySize, nSx,nSy )
      _RL     rho3d  ( xySize, Nr,nSx,nSy )
      _RL     myTime
      INTEGER myIter, myThid

#ifdef ALLOW_DOWN_SLOPE

C     !LOCAL VARIABLES:
C     === Local variables ===
C     msgBuf    :: Informational/error message buffer
C     ijd     :: horiz. index of deep water column receiving dense water flow
C     ijs     :: horiz. index of shallow water column (e.g. shelf)
C                from which dense water flow originates
c     CHARACTER*(MAX_LEN_MBUF) msgBuf
      INTEGER k
      INTEGER n, ijd, ijr, ijs
      INTEGER kdeep, ishelf, jshelf, kshelf
      _RL     dRhoH
      INTEGER downward
#ifdef ALLOW_DIAGNOSTICS
      LOGICAL doDiagDwnSlpFlow
      INTEGER ij
      _RL     sgnFac
      _RL     uFlow( xySize )
      _RL     vFlow( xySize )
C-    Functions:
      LOGICAL  DIAGNOSTICS_IS_ON
      EXTERNAL DIAGNOSTICS_IS_ON
#endif /* ALLOW_DIAGNOSTICS */

CEOP

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

c     downward = rkSign*NINT(gravitySign)
      downward = 1
      IF ( usingPCoords ) downward = -1

#ifdef ALLOW_DIAGNOSTICS
      IF ( useDiagnostics ) THEN
        doDiagDwnSlpFlow = DIAGNOSTICS_IS_ON( 'DSLPuFlw', myThid )
     &                .OR. DIAGNOSTICS_IS_ON( 'DSLPvFlw', myThid )
        IF ( doDiagDwnSlpFlow ) THEN
          DO ij=1,xySize
           uFlow(ij) = 0. _d 0
           vFlow(ij) = 0. _d 0
          ENDDO
        ENDIF
      ELSE
        doDiagDwnSlpFlow = .FALSE.
      ENDIF
#endif /* ALLOW_DIAGNOSTICS */

      DO n=1,DWNSLP_NbSite(bi,bj)
        DWNSLP_deepK(n,bi,bj) = 0

C- detect density gradient along the slope => Downsloping flow

        ijd = DWNSLP_ijDeep(n,bi,bj)
        ijr = DWNSLP_shVsD(n,bi,bj)
        ijs = ijd + ijr
        kshelf = kBottom(ijs,bi,bj)

        dRhoH = rho3d(ijs,kshelf,bi,bj)
     &         -rho3d(ijd,kshelf,bi,bj)
c       IF ( dRhoH.GT.0. _d 0 ) THEN
        IF ( rho3d(ijs,kshelf+1,bi,bj).GT.rho3d(ijd,kshelf+1,bi,bj)
     &    .AND. dRhoH.GT.0. _d 0 ) THEN

C- search for deepest level where Rho_shelf > Rho_deep
          kdeep = kshelf
          DO k=kshelf+1,kBottom(ijd,bi,bj),downward
           IF ( rho3d(ijs,k,bi,bj).GT.rho3d(ijd,k,bi,bj) ) kdeep = k
          ENDDO
          DWNSLP_deepK(n,bi,bj) = kdeep

C- Compute the Volume Transport :
C- same formulation as described in the paper:
c         downslpFlow  = DWNSLP_gamma/mu *gravity*dRhoH*recip_rhoConst
C    with DWNSLP_Gamma = slope * effective cross-section area
          DWNSLP_Transp(n,bi,bj) = DWNSLP_Gamma(n,bi,bj)
     &             *DWNSLP_rec_mu*gravity*dRhoH*recip_rhoConst

#ifdef ALLOW_DIAGNOSTICS
          IF ( doDiagDwnSlpFlow ) THEN
            ij = MAX( ijd, ijs )
            sgnFac = SIGN(1,-ijr)
            IF ( ABS(ijr).EQ.1 ) THEN
             uFlow(ij) = sgnFac*DWNSLP_Transp(n,bi,bj)
            ELSE
             vFlow(ij) = sgnFac*DWNSLP_Transp(n,bi,bj)
            ENDIF
          ENDIF
#endif /* ALLOW_DIAGNOSTICS */

        ENDIF

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
      ENDDO

      IF ( DWNSLP_ioUnit.GT.0 ) THEN
       _BEGIN_MASTER(myThid)
       WRITE(DWNSLP_ioUnit,'(A,I8,2I4)')
     &      ' DWNSLP_CALC_FLOW: iter,bi,bj=',myIter,bi,bj
       WRITE(DWNSLP_ioUnit,'(A)')
     &   '  bi  bj     n :     ijd   ijr  is  js ;  ks kd-s Transp :'
       DO n=1,DWNSLP_NbSite(bi,bj)
        IF (DWNSLP_deepK(n,bi,bj).NE.0) THEN
         ijs = DWNSLP_ijDeep(n,bi,bj) + DWNSLP_shVsD(n,bi,bj)
         ishelf = 1-OLx + mod(ijs-1,xSize)
         jshelf = 1-OLy + (ijs-1)/xSize
         kshelf = kBottom(ijs,bi,bj)
         WRITE(DWNSLP_ioUnit,'(2I4,I6,A,I8,I6,2I4,A,2I4,1PE14.6)')
     &     bi,bj,n,' :', DWNSLP_ijDeep(n,bi,bj),
     &                   DWNSLP_shVsD(n,bi,bj), ishelf,jshelf,
     &             ' ;', kshelf, DWNSLP_deepK(n,bi,bj)-kshelf,
     &                   DWNSLP_Transp(n,bi,bj)
        ENDIF
       ENDDO
       WRITE(DWNSLP_ioUnit,*)
       _END_MASTER(myThid)
      ENDIF

#ifdef ALLOW_DIAGNOSTICS
      IF ( doDiagDwnSlpFlow ) THEN
        CALL DIAGNOSTICS_FILL( uFlow, 'DSLPuFlw', 0,1,2,bi,bj,myThid )
        CALL DIAGNOSTICS_FILL( vFlow, 'DSLPvFlw', 0,1,2,bi,bj,myThid )
      ENDIF
#endif /* ALLOW_DIAGNOSTICS */

#endif /* ALLOW_DOWN_SLOPE */

      RETURN
      END

#include "STREAMICE_OPTIONS.h"
c#ifdef ALLOW_AUTODIFF
c# include "AUTODIFF_OPTIONS.h"
c#endif
#ifdef ALLOW_COST
# include "COST_OPTIONS.h"
#endif

      subroutine streamice_cost_vel_accum ( myIter, myThid )
C     *==========================================================*
C     | subroutine streamice_cost_vel_accum                      |
C     | o this routine calculates the velocity misfit contri-    |
C     |   bution to the per-timestep STREAMICE cost              |
C     *==========================================================*
C     |                                                          |
C     | Notes                                                    |
C     | =====                                                    |
C     *==========================================================*
      IMPLICIT NONE

C     == Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "DYNVARS.h"
#include "GRID.h"
#ifdef ALLOW_STREAMICE
# include "STREAMICE.h"
#endif

#ifdef ALLOW_COST
# include "cost.h"
#endif
c#ifdef ALLOW_AUTODIFF_TAMC
c# include "tamc.h"
c#endif

C     == Routine arguments ==
C     myThid - Thread number for this instance of the routine.
      integer myIter, myThid

#ifdef ALLOW_STREAMICE_TC_COST
C     == Local variables
      _RL HAF
      integer i, j, k, bi, bj
      integer ig, jg
      integer itlo,ithi
      integer jtlo,jthi
      integer il
      INTEGER  ILNBLNK
      EXTERNAL ILNBLNK
      CHARACTER*(MAX_LEN_FNAM) uvelfilename
      CHARACTER*(MAX_LEN_FNAM) vvelfilename
      CHARACTER*(MAX_LEN_FNAM) errvelfilename
      CHARACTER*(10) myIterStr
      _RL uvelobs (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL vvelobs (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL errvelobs (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL i_numcells, vel_err, uobs, vobs, verr

      WRITE(myIterStr,'(I10.10)') myIter

      uvelfilename=STREAMICEvelOptimTCBasename(1:
     & ILNBLNK(STREAMICEvelOptimTCBasename))//myIterStr//"u.bin"
      vvelfilename=STREAMICEvelOptimTCBasename(1:
     & ILNBLNK(STREAMICEvelOptimTCBasename))//myIterStr//"v.bin"
      errvelfilename=STREAMICEvelOptimTCBasename(1:
     & ILNBLNK(STREAMICEvelOptimTCBasename))//myIterStr//"err.bin"
      CALL READ_FLD_XY_RL( uvelfilename, ' ', uvelobs,
     &      0, myThid )
      CALL READ_FLD_XY_RL( vvelfilename, ' ', vvelobs,
     &      0, myThid )
      CALL READ_FLD_XY_RL( errvelfilename, ' ', errvelobs,
     &      0, myThid )

c#ifdef ALLOW_AUTODIFF_TAMC
cCADJ STORE surf_el_streamice  = comlev1, key = ikey_dynamics,
cCADJ &     kind = isbyte
cCADJ STORE H_streamice_prev  = comlev1, key = ikey_dynamics,
cCADJ &     kind = isbyte
cCADJ STORE H_streamice  = comlev1, key = ikey_dynamics,
cCADJ &     kind = isbyte
c#endif

      i_numcells = 1.0/(Nx*Ny)

C--   Calculate cost function on tile of this instance
      DO bj=myByLo(myThid),myByHi(myThid)
        DO bi=myBxLo(myThid),myBxHi(myThid)
          do j=1,sNy
            do i=1,sNx

             uobs = uvelobs(i,j,bi,bj)
             vobs = vvelobs(i,j,bi,bj)
             verr = errvelobs(i,j,bi,bj)

             if (uobs.gt.-999990. .and. vobs.gt.-999990. .and.
     &           verr.gt.-999990.) then

              vel_err = streamice_wgt_vel * i_numcells * (
     &         (streamice_u_surf(i,j,bi,bj)-uobs)**2
     &        +(streamice_v_surf(i,j,bi,bj)-vobs)**2)
     &        /(1. + verr**2)

              cost_func1_streamice (bi,bj) =
     &        cost_func1_streamice (bi,bj) +
     &              vel_err
              cost_vel_streamice (bi,bj) =
     &        cost_vel_streamice (bi,bj) +
     &              vel_err

             end if

            end do
          end do
        end do
      end do

#endif

      RETURN
      END

#include "EXF_OPTIONS.h"
#ifdef ALLOW_BLING
# include "BLING_OPTIONS.h"
#endif

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: EXF_MONITOR

C     !INTERFACE:
      SUBROUTINE EXF_MONITOR(
     I               myTime, myIter, myThid )

C     !DESCRIPTION:
C     Print some statistics about input forcing fields.

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "EXF_PARAM.h"
#include "EXF_FIELDS.h"
#ifdef ALLOW_MONITOR
# include "MONITOR.h"
#endif
#ifdef ALLOW_MNC
# include "MNC_PARAMS.h"
#endif
#ifdef ALLOW_BLING
# include "EXF_INTERP_SIZE.h"
# include "BLING_VARS.h"
#endif

C     !INPUT PARAMETERS:
      _RL myTime
      INTEGER myIter
      INTEGER myThid
CEOP

#ifdef ALLOW_MONITOR

C     === Functions ====
      LOGICAL  DIFFERENT_MULTIPLE
      EXTERNAL DIFFERENT_MULTIPLE
      LOGICAL  MASTER_CPU_IO
      EXTERNAL MASTER_CPU_IO

C     == Local variables ==
      _RL dummyRL(6)
      CHARACTER*(MAX_LEN_MBUF) msgBuf
#ifdef ALLOW_MNC
      INTEGER k
#endif
      LOGICAL computed

#ifdef ALLOW_BULKFORMULAE
      computed = .TRUE.
#else
      computed = .FALSE.
#endif

      IF ( DIFFERENT_MULTIPLE(exf_monFreq,myTime,deltaTClock)
     &   ) THEN

        IF ( MASTER_CPU_IO(myThid) ) THEN
C--   only the master thread is allowed to switch On/Off mon_write_stdout
C     & mon_write_mnc (since it is the only thread that uses those flags):

          IF (monitor_stdio) THEN
            mon_write_stdout = .TRUE.
          ELSE
            mon_write_stdout = .FALSE.
          ENDIF
          mon_write_mnc = .FALSE.
#ifdef ALLOW_MNC
          IF (useMNC .AND. monitor_mnc) THEN
            DO k = 1,MAX_LEN_MBUF
              mon_fname(k:k) = ' '
            ENDDO
            mon_fname(1:11) = 'monitor_exf'
            CALL MNC_CW_APPEND_VNAME(
     &           'T', '-_-_--__-__t', 0,0, myThid)
            CALL MNC_CW_SET_UDIM(mon_fname, -1, myThid)
            CALL MNC_CW_RL_W_S(
     &          'D',mon_fname,1,1,'T', myTime, myThid)
            CALL MNC_CW_SET_UDIM(mon_fname, 0, myThid)
            mon_write_mnc = .TRUE.
          ENDIF
#endif /* ALLOW_MNC */

          IF ( mon_write_stdout ) THEN
            WRITE(msgBuf,'(2A)') '// ===========================',
     &           '============================'
            CALL PRINT_MESSAGE(msgBuf, mon_ioUnit, SQUEEZE_RIGHT, 1)
            WRITE(msgBuf,'(A)') '// Begin MONITOR EXF statistics'
            CALL PRINT_MESSAGE(msgBuf, mon_ioUnit, SQUEEZE_RIGHT, 1)
            WRITE(msgBuf,'(2A)') '// ===========================',
     &           '============================'
            CALL PRINT_MESSAGE(msgBuf, mon_ioUnit, SQUEEZE_RIGHT, 1)
          ENDIF

C--   endif master cpu io
        ENDIF

        CALL MON_SET_PREF('exf',myThid)
        CALL MON_OUT_I ('_tsnumber', myIter,mon_string_none,myThid)
        CALL MON_OUT_RL('_time_sec', myTime,mon_string_none,myThid)

C       Print some statistics about input forcing fields
        IF ( stressIsOnCgrid ) THEN
          CALL MON_WRITESTATS_RL( 1, ustress, '_ustress',
     &             maskInW, maskInW, rAw, drF, dummyRL, myThid )
          CALL MON_WRITESTATS_RL( 1, vstress, '_vstress',
     &             maskInS, maskInS, rAs, drF, dummyRL, myThid )
        ELSE
          CALL MON_WRITESTATS_RL( 1, ustress, '_ustress',
     &             maskInC, maskInC, rA , drF, dummyRL, myThid )
          CALL MON_WRITESTATS_RL( 1, vstress, '_vstress',
     &             maskInC, maskInC, rA , drF, dummyRL, myThid )
        ENDIF
        IF ( computed .OR. hfluxfile .NE. ' ' ) THEN
          CALL MON_WRITESTATS_RL( 1, hflux,   '_hflux',
     &             maskInC, maskInC, rA , drF, dummyRL, myThid )
        ENDIF
        IF ( computed .OR. sfluxfile .NE. ' ' ) THEN
          CALL MON_WRITESTATS_RL( 1, sflux,   '_sflux',
     &             maskInC, maskInC, rA , drF, dummyRL, myThid )
        ENDIF
        IF ( useAtmWind ) THEN
          CALL MON_WRITESTATS_RL( 1, uwind,   '_uwind',
     &             maskInC, maskInC, rA , drF, dummyRL, myThid )
          CALL MON_WRITESTATS_RL( 1, vwind,   '_vwind',
     &             maskInC, maskInC, rA , drF, dummyRL, myThid )
        ENDIF
        IF ( computed .OR. wspeedfile .NE. ' ' ) THEN
          CALL MON_WRITESTATS_RL( 1, wspeed,  '_wspeed',
     &             maskInC, maskInC, rA , drF, dummyRL, myThid )
        ENDIF
#ifdef ALLOW_ATM_TEMP
        IF ( atempfile .NE. ' ' ) THEN
          CALL MON_WRITESTATS_RL( 1, atemp,   '_atemp',
     &             maskInC, maskInC, rA , drF, dummyRL, myThid )
        ENDIF
        IF ( aqhfile .NE. ' ' ) THEN
          CALL MON_WRITESTATS_RL( 1, aqh,     '_aqh',
     &             maskInC, maskInC, rA , drF, dummyRL, myThid )
        ENDIF
        IF ( lwdownfile .NE. ' ' .OR. lwfluxfile .NE. ' ' ) THEN
          CALL MON_WRITESTATS_RL( 1, lwflux,  '_lwflux',
     &             maskInC, maskInC, rA , drF, dummyRL, myThid )
        ENDIF
        IF ( computed .OR. evapfile .NE. ' ' ) THEN
          CALL MON_WRITESTATS_RL( 1, evap,    '_evap',
     &             maskInC, maskInC, rA , drF, dummyRL, myThid )
        ENDIF
        IF ( precipfile .NE. ' ' ) THEN
          CALL MON_WRITESTATS_RL( 1, precip,  '_precip',
     &             maskInC, maskInC, rA , drF, dummyRL, myThid )
        ENDIF
        IF ( snowprecipfile .NE. ' ' ) THEN
          CALL MON_WRITESTATS_RL(1,snowprecip,'_snowprecip',
     &             maskInC, maskInC, rA , drF, dummyRL, myThid )
        ENDIF
#endif /* ALLOW_ATM_TEMP */
#if defined(ALLOW_ATM_TEMP) || defined(SHORTWAVE_HEATING)
        IF ( swdownfile .NE. ' ' .OR. swfluxfile .NE. ' ' ) THEN
          CALL MON_WRITESTATS_RL( 1, swflux,  '_swflux',
     &             maskInC, maskInC, rA , drF, dummyRL, myThid )
        ENDIF
#endif
#ifdef ALLOW_DOWNWARD_RADIATION
        IF ( swdownfile .NE. ' ' ) THEN
          CALL MON_WRITESTATS_RL( 1, swdown,  '_swdown',
     &             maskInC, maskInC, rA , drF, dummyRL, myThid )
        ENDIF
        IF ( lwdownfile .NE. ' ' ) THEN
          CALL MON_WRITESTATS_RL( 1, lwdown,  '_lwdown',
     &             maskInC, maskInC, rA , drF, dummyRL, myThid )
        ENDIF
#endif
#ifdef ATMOSPHERIC_LOADING
        IF ( apressurefile .NE. ' ' ) THEN
           CALL MON_WRITESTATS_RL( 1,apressure,'_apressure',
     &              maskInC, maskInC, rA , drF, dummyRL, myThid )
        ENDIF
#endif
#ifdef ALLOW_RUNOFF
        IF ( runofffile .NE. ' ' ) THEN
          CALL MON_WRITESTATS_RL( 1, runoff,  '_runoff',
     &             maskInC, maskInC, rA , drF, dummyRL, myThid )
        ENDIF
# ifdef ALLOW_RUNOFTEMP
        IF ( runoftempfile .NE. ' ' ) THEN
          CALL MON_WRITESTATS_RL( 1, runoftemp,  '_runoftemp',
     &             maskInC, maskInC, rA , drF, dummyRL, myThid )
        ENDIF
# endif
#endif
#ifdef ALLOW_SALTFLX
        IF ( saltflxfile .NE. ' ' ) THEN
          CALL MON_WRITESTATS_RL( 1, saltflx,'_saltflx',
     &             maskInC, maskInC, rA , drF, dummyRL, myThid )
        ENDIF
#endif
#ifdef EXF_SEAICE_FRACTION
        IF ( areamaskfile .NE. ' ' ) THEN
          CALL MON_WRITESTATS_RL( 1, areamask,'_areamask',
     &             maskInC, maskInC, rA , drF, dummyRL, myThid )
        ENDIF
#endif
#ifdef ALLOW_BLING
        IF ( apco2file .NE. ' ' ) THEN
          CALL MON_WRITESTATS_RL( 1, apCO2, '_apco2',
     &             maskInC, maskInC, rA , drF, dummyRL, myThid )
        ENDIF
#endif
#ifdef ALLOW_CLIMSST_RELAXATION
        IF ( climsstfile .NE. ' ' ) THEN
          CALL MON_WRITESTATS_RL( 1, climsst, '_climsst',
     &             maskInC, maskInC, rA , drF, dummyRL, myThid )
        ENDIF
#endif
#ifdef ALLOW_CLIMSSS_RELAXATION
        IF ( climsssfile .NE. ' ' ) THEN
          CALL MON_WRITESTATS_RL( 1, climsss, '_climsss',
     &             maskInC, maskInC, rA , drF, dummyRL, myThid )
        ENDIF
#endif
#ifdef ALLOW_CLIMSTRESS_RELAXATION
        IF ( climustrfile .NE. ' ' ) THEN
          CALL MON_WRITESTATS_RL( 1, climustr, '_climustr',
     &             maskInW, maskInW, rAw, drF, dummyRL, myThid )
        ENDIF
        IF ( climvstrfile .NE. ' ' ) THEN
          CALL MON_WRITESTATS_RL( 1, climvstr, '_climvstr',
     &             maskInS, maskInS, rAs, drF, dummyRL, myThid )
        ENDIF
#endif

        IF ( MASTER_CPU_IO(myThid) ) THEN
C--   only the master thread is allowed to switch On/Off mon_write_stdout
C     & mon_write_mnc (since it is the only thread that uses those flags):

          IF ( mon_write_stdout ) THEN
            WRITE(msgBuf,'(2A)') '// ===========================',
     &           '============================'
            CALL PRINT_MESSAGE(msgBuf, mon_ioUnit, SQUEEZE_RIGHT, 1)
            WRITE(msgBuf,'(A)') '// End MONITOR EXF statistics'
            CALL PRINT_MESSAGE(msgBuf, mon_ioUnit, SQUEEZE_RIGHT, 1)
            WRITE(msgBuf,'(2A)') '// ===========================',
     &           '============================'
            CALL PRINT_MESSAGE(msgBuf, mon_ioUnit, SQUEEZE_RIGHT, 1)
          ENDIF

          mon_write_stdout = .FALSE.
          mon_write_mnc    = .FALSE.

C--   endif master cpu io
        ENDIF

C     endif different multiple
      ENDIF

#endif /* ALLOW_MONITOR */

      RETURN
      END

#include "LAND_OPTIONS.h"

CBOP
C     !ROUTINE: LAND_DIAGNOSTICS_STATE
C     !INTERFACE:
      SUBROUTINE LAND_DIAGNOSTICS_STATE(
     I                            myTime, myIter, myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R LAND_DIAGNOSTICS_STATE
C     | o fill-in diagnostics array for LAND state variables
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     == Global variables ===
C-- size for MITgcm & Land package :
#include "LAND_SIZE.h"

#include "EEPARAMS.h"
#include "PARAMS.h"
#include "LAND_PARAMS.h"
#include "LAND_VARS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     myTime   :: Current time of simulation ( s )
C     myIter   :: Current iteration number in simulation
C     myThid   :: my Thread number Id
      _RL     myTime
      INTEGER myIter, myThid
CEOP

#ifdef ALLOW_DIAGNOSTICS
C     == Local variables ==
C     bi,bj    :: Tile indices
c     INTEGER bi, bj
c     INTEGER i,j
c     _RL tmpFld(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
c     LOGICAL  DIAGNOSTICS_IS_ON
c     EXTERNAL DIAGNOSTICS_IS_ON

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      IF ( useDiagnostics ) THEN

        CALL DIAGNOSTICS_FILL(land_skinT,'GrdSurfT',0,1,0,1,1,myThid)
        CALL DIAGNOSTICS_FILL(land_groundT,'GrdTemp ',0,land_nLev,
     &                                                  0,1,1,myThid)
        CALL DIAGNOSTICS_FILL(land_enthalp,'GrdEnth ',0,land_nLev,
     &                                                  0,1,1,myThid)
        CALL DIAGNOSTICS_FILL(land_groundW,'GrdWater',0,land_nLev,
     &                                                  0,1,1,myThid)
        CALL DIAGNOSTICS_FILL(land_hSnow,'LdSnowH ',0,1,0,1,1,myThid)
        CALL DIAGNOSTICS_FILL(land_snowAge,'LdSnwAge',0,1,
     &                                                  0,1,1,myThid)

      ENDIF

#endif /* ALLOW_DIAGNOSTICS */

      RETURN
      END

#include "SHAP_FILT_OPTIONS.h"

CBOP
C     !ROUTINE: SHAP_FILT_INIT_FIXED
C     !INTERFACE:
      SUBROUTINE SHAP_FILT_INIT_FIXED( myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE SHAP_FILT_INIT_FIXED
C     | o Routine to initialize GM/Redi variables 
C     |   that are kept fixed during the run.
C     *==========================================================*
C     \ev
C     !USES:
      IMPLICIT NONE

C     === Global variables ===
#include "EEPARAMS.h"
#include "SIZE.h"
#include "PARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
C     myThid ::  my Thread Id number
      INTEGER myThid
CEOP

C     !LOCAL VARIABLES:
C     === Local variables ===

#ifdef ALLOW_DIAGNOSTICS
      IF ( useDiagnostics ) THEN
        CALL SHAP_FILT_DIAGNOSTICS_INIT( myThid )
      ENDIF
#endif

      RETURN
      END

#include "OBCS_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: OBCS_APPLY_R_STAR

C     !INTERFACE:
      SUBROUTINE OBCS_APPLY_R_STAR(
     I                bi, bj, etaFld,
     U                rStarFldC, rStarFldW, rStarFldS,
     I                myTime, myIter, myThid )

C     !DESCRIPTION:
C     *==========================================================*
C     | S/R OBCS_APPLY_R_STAR
C     *==========================================================*

C     !USES:
      IMPLICIT NONE
C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "OBCS_PARAMS.h"
#include "OBCS_GRID.h"
#include "OBCS_FIELDS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     bi, bj    :: tile indices
C     etaFld    :: current eta field used to update the hFactor
C     rStarFldC :: r* thickness-factor (grid-cell center)
C     hFac_FldW :: r* thickness-factor (grid-cell Western -Edge)
C     hFac_FldS :: r* thickness-factor (grid-cell Southern-Edge)
C     myTime    :: current time in simlation
C     myIter    :: current time-step number
C     myThid    :: my Thread Id number
      INTEGER bi, bj
      _RL etaFld   (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL rStarFldC(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL rStarFldW(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL rStarFldS(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL myTime
      INTEGER myIter, myThid
CEOP

#ifdef NONLIN_FRSURF
#ifndef DISABLE_RSTAR_CODE

C     !LOCAL VARIABLES:
      INTEGER i,j
      LOGICAL useOBeta

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C-- Eta OB values corresponding to previous iteration are not available when
C   calc_r_star is called for the 1rst time (myIter=-1) form initialise_varia.
C   Use current "etaFld" values instead, only for this 1rst call (myIter=-1).
      useOBeta = myIter.NE.-1

C- Set model rStar_Factor to OB values on North/South Boundaries
      IF ( tileHasOBN(bi,bj) ) THEN
C  Northern boundary
       DO i=1-OLx,sNx+OLx
        IF ( OB_Jn(i,bi,bj).NE.OB_indexNone ) THEN
         j = OB_Jn(i,bi,bj)
         IF (kSurfS(i,j,bi,bj).LE.Nr) THEN
          IF ( useOBeta ) THEN
           rStarFldS(i,j,bi,bj) = 1. _d 0
     &      + OBNeta(  j,bi,bj) / (rSurfS(i,j,bi,bj)-rLowS(i,j,bi,bj))
          ELSE
           rStarFldS(i,j,bi,bj) = 1. _d 0
     &      + etaFld(i,j,bi,bj) / (rSurfS(i,j,bi,bj)-rLowS(i,j,bi,bj))
          ENDIF
         ENDIF
        ENDIF
       ENDDO
      ENDIF
      IF ( tileHasOBS(bi,bj) ) THEN
C  Southern boundary
       DO i=1-OLx,sNx+OLx
        IF ( OB_Js(i,bi,bj).NE.OB_indexNone ) THEN
         j = OB_Js(i,bi,bj)+1
         IF (kSurfS(i,j,bi,bj).LE.Nr) THEN
          IF ( useOBeta ) THEN
           rStarFldS(i,j,bi,bj) = 1. _d 0
     &      + OBSeta(  j,bi,bj) / (rSurfS(i,j,bi,bj)-rLowS(i,j,bi,bj))
          ELSE
           rStarFldS(i,j,bi,bj) = 1. _d 0
     &      + etaFld(i,j-1,bi,bj)/(rSurfS(i,j,bi,bj)-rLowS(i,j,bi,bj))
          ENDIF
         ENDIF
        ENDIF
       ENDDO
      ENDIF

C- Set model rStar_Factor to OB values on East/West Boundaries
      IF ( tileHasOBE(bi,bj) ) THEN
C  Eastern boundary
       DO j=1-OLy,sNy+OLy
        IF ( OB_Ie(j,bi,bj).NE.OB_indexNone ) THEN
         i = OB_Ie(j,bi,bj)
         IF (kSurfW(i,j,bi,bj).LE.Nr) THEN
          IF ( useOBeta ) THEN
           rStarFldW(i,j,bi,bj) = 1. _d 0
     &      + OBEeta(  j,bi,bj) / (rSurfW(i,j,bi,bj)-rLowW(i,j,bi,bj))
          ELSE
           rStarFldW(i,j,bi,bj) = 1. _d 0
     &      + etaFld(i,j,bi,bj) / (rSurfW(i,j,bi,bj)-rLowW(i,j,bi,bj))
          ENDIF
         ENDIF
        ENDIF
       ENDDO
      ENDIF
      IF ( tileHasOBW(bi,bj) ) THEN
C  Western boundary
       DO j=1-OLy,sNy+OLy
        IF ( OB_Iw(j,bi,bj).NE.OB_indexNone ) THEN
         i = OB_Iw(j,bi,bj)+1
         IF (kSurfW(i,j,bi,bj).LE.Nr) THEN
          IF ( useOBeta ) THEN
           rStarFldW(i,j,bi,bj) = 1. _d 0
     &      + OBWeta(  j,bi,bj) / (rSurfW(i,j,bi,bj)-rLowW(i,j,bi,bj))
          ELSE
           rStarFldW(i,j,bi,bj) = 1. _d 0
     &      + etaFld(i-1,j,bi,bj)/(rSurfW(i,j,bi,bj)-rLowW(i,j,bi,bj))
          ENDIF
         ENDIF
        ENDIF
       ENDDO
      ENDIF

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#endif /* DISABLE_RSTAR_CODE */
#endif /* NONLIN_FRSURF */

      RETURN
      END

#include "KPP_OPTIONS.h"
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 0
C     !ROUTINE: KPP_INIT_VARIA

C     !INTERFACE:
      SUBROUTINE KPP_INIT_VARIA( myThid )

C     !DESCRIPTION:
C     Routine to initialize KPP parameters and variables.

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "GAD.h"
#include "KPP.h"
#include "KPP_PARAMS.h"

C     !INPUT PARAMETERS:
      INTEGER myThid
CEOP

#ifdef ALLOW_KPP
C     !LOCAL VARIABLES:
C     i,j,k,bi,bj - Loop counters
      INTEGER i, j, k, bi, bj

C-----------------------------------------------------------------------
C     calculate mask pMask for pressure/tracer cells
C        (0 => land, 1 => water)
C     compute maximum number of wet levels in each column
C-----------------------------------------------------------------------

      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)

             DO j = 1-OLy, sNy+OLy
               DO i = 1-OLx, sNx+OLx
                  nzmax(i,j,bi,bj) = kLowC(I,J,bi,bj)
CML                  DO k = 1, Nr
CMLc                    IF (_hFacC(i,j,k,bi,bj).EQ.0.) THEN
CMLc                       pMask (i,j,k,bi,bj) = 0.
CMLc                    ELSE
CMLc                       pMask (i,j,k,bi,bj) = 1.
CMLc                    ENDIF
CML                     nzmax(i,j,bi,bj) = nzmax(i,j,bi,bj)
CML     &                                + INT(maskC(i,j,k,bi,bj))
CMLc    &                                + INT(pMask(i,j,k,bi,bj))
CML                  ENDDO
               ENDDO
            ENDDO

C-----------------------------------------------------------------------
C Initialize KPP variables KPPhbl, KPPghat, KPPviscAz,
C    KPPdiffKzT, and KPPdiffKzS
C-----------------------------------------------------------------------

            DO j = 1-OLy, sNy+OLy
               DO i = 1-OLx, sNx+OLx
                  KPPhbl(i,j,bi,bj) = 0.
               ENDDO
            ENDDO
            DO k = 1, Nr
               DO j = 1-OLy, sNy+OLy
                  DO i = 1-OLx, sNx+OLx
                     KPPghat       (i,j,k,bi,bj) = 0.
                     KPPviscAz  (i,j,k,bi,bj) = viscArNr(1)
                     KPPdiffKzS (i,j,k,bi,bj) = 0.
                     KPPdiffKzT (i,j,k,bi,bj) = 0.
                  ENDDO
               ENDDO
            ENDDO

cph Not needed here. Do this in kpp_calc.
cph            CALL CALC_3D_DIFFUSIVITY(
cph     I           bi,bj,1-Olx,sNx+OLx,1-Oly,sNy+OLy,
cph     I           GAD_SALINITY, .FALSE., .FALSE.,
cph     O           KPPdiffKzS(1-Olx,1-Oly,1,bi,bj),
cph     I           myThid)
cph            CALL CALC_3D_DIFFUSIVITY(
cph     I           bi,bj,1-Olx,sNx+OLx,1-Oly,sNy+OLy,
cph     I           GAD_TEMPERATURE, .FALSE., .FALSE.,
cph     O           KPPdiffKzT(1-Olx,1-Oly,1,bi,bj),
cph     I           myThid)

       ENDDO
      ENDDO

#endif /* ALLOW_KPP */

      RETURN
      END

#include "AIM_OPTIONS.h"

CBOP
C     !ROUTINE: AIM_DO_CO2
C     !INTERFACE:
      SUBROUTINE AIM_DO_CO2( myTime, myIter, myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R AIM_DO_CO2
C     | o CO2 budget of the atmosphere
C     *==========================================================*
C     \ev
C     !USES:
      IMPLICIT NONE

C     == Global data ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "RESTART.h"
#include "GRID.h"

#include "AIM_PARAMS.h"
#include "AIM_CO2.h"
C-- Coupled to the Ocean :
#ifdef COMPONENT_MODULE
#include "CPL_PARAMS.h"
#include "ATMCPL.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     myTime :: Current time of simulation ( s )
C     myIter :: Current iteration number in simulation
C     myThid :: Number of this instance of the routine
      _RL myTime
      INTEGER myIter, myThid
CEOP

#ifdef ALLOW_AIM
#ifdef ALLOW_AIM_CO2
C     !FUNCTIONS:
      INTEGER  ILNBLNK, IFNBLNK
      EXTERNAL ILNBLNK, IFNBLNK
      LOGICAL  DIFFERENT_MULTIPLE
      EXTERNAL DIFFERENT_MULTIPLE

C     !LOCAL VARIABLES:
C     bi,bj  - Tile index
C     i,j    - loop counters
      INTEGER bi, bj, i, j
      _RL total_flux, atpco2_check
      _RL flxCO2tile(nSx,nSy)
      LOGICAL modelEnd
      LOGICAL permPickup, tempPickup
      INTEGER iUnit, iLo, iHi
      _RS dummyRS(1)
      _RL tmpco2(2)
      CHARACTER*(10) suff
      CHARACTER*(MAX_LEN_FNAM) fn
      CHARACTER*(MAX_LEN_MBUF) msgBuf

#ifdef COMPONENT_MODULE
      IF ( useCoupler .AND. useImportFlxCO2 ) THEN
       DO bj=myByLo(myThid),myByHi(myThid)
        DO bi=myBxLo(myThid),myBxHi(myThid)
         DO j=1,sNy
          DO i=1,sNx
           aimflxCo2(i,j,bi,bj) = flxCO2ocn(i,j,bi,bj)
          ENDDO
         ENDDO
        ENDDO
       ENDDO
      ENDIF
#endif /* COMPONENT_MODULE */

      IF ( aim_select_pCO2 .GE. 2 ) THEN

C- First compute global mole flux at air-sea interface
        DO bj=myByLo(myThid),myByHi(myThid)
         DO bi=myBxLo(myThid),myBxHi(myThid)
          flxCO2tile(bi,bj) = 0. _d 0
          DO j=1,sNy
           DO i=1,sNx
            flxCO2tile(bi,bj)=flxCO2tile(bi,bj) + aimflxCo2(i,j,bi,bj)
     &                      * rA(i,j,bi,bj) * deltaT
           ENDDO
          ENDDO
         ENDDO
        ENDDO
        CALL GLOBAL_SUM_TILE_RL(flxCO2tile,total_flux,myThid)

        _BARRIER
        _BEGIN_MASTER(myThid)
        IF ( myIter.EQ.0 ) THEN
C- If  first iteration, use atmpCO2init as initial condition
          atm_CO2_Moles = atm_pCO2 * total_atmos_moles

        ELSEIF ( myIter.EQ.nIter0 ) THEN
C- If restart, read moles number from pickup
          IF ( pickupSuff.EQ.' ' ) THEN
            IF ( rwSuffixType.EQ.0 ) THEN
              WRITE(fn,'(A,I10.10)') 'pickup_aimCo2.', myIter
            ELSE
              CALL RW_GET_SUFFIX( suff, myTime, myIter, myThid )
              WRITE(fn,'(A,A)') 'pickup_aimCo2.', suff
            ENDIF
          ELSE
            WRITE(fn,'(A,A10)') 'pickup_aimCo2.', pickupSuff
          ENDIF
          iUnit = 0
          CALL MDS_READVEC_LOC(  fn, precFloat64, iUnit, 'RL', 2,
     O                           tmpco2, dummyRS,
     I                           0, 0, 1, myThid )
          atm_CO2_Moles = tmpco2(1)
          atpco2_check  = tmpco2(2)
          atm_pCO2 = atm_CO2_Moles / total_atmos_moles

          iUnit = standardMessageUnit
          iLo = IFNBLNK(fn)
          iHi = ILNBLNK(fn)
          WRITE(msgBuf,'(A)') ' '
          CALL PRINT_MESSAGE(msgBuf,iUnit,SQUEEZE_RIGHT,myThid)
          WRITE(msgBuf,'(A)') '// ==================================='
          CALL PRINT_MESSAGE(msgBuf,iUnit,SQUEEZE_RIGHT,myThid)
          WRITE(msgBuf,'(2A)') '// AIM_DO_CO2: Read pickup ',fn(iLo:iHi)
          CALL PRINT_MESSAGE(msgBuf,iUnit,SQUEEZE_RIGHT,myThid)

          CALL WRITE_0D_RL( atpco2_check, INDEX_NONE, 'atpco2_check =',
     &                     ' /* pCo2 from pickup file */')
          CALL WRITE_0D_RL( atm_pCO2, INDEX_NONE, 'atm_pCO2 =',
     &                     ' /* pCo2 from atm_CO2_Moles */')
        ENDIF

C- Calculate new atmos pCO2
        atm_CO2_Moles = atm_CO2_Moles - total_flux
        atm_pCO2 = atm_CO2_Moles / total_atmos_moles

C- Set pCO2 for AIM Radiation:
        IF ( aim_select_pCO2 .EQ. 3 ) THEN
          aim_pCO2 = atm_pCO2
        ENDIF

C- Write out if time for a new pickup
        modelEnd = (myTime+deltaTClock).EQ.endTime
     &        .OR. (myIter+1).EQ.nEndIter
        permPickup = .FALSE.
        tempPickup = .FALSE.
        permPickup =
     &    DIFFERENT_MULTIPLE(pChkptFreq,myTime+deltaTClock,deltaTClock)
        tempPickup =
     &    DIFFERENT_MULTIPLE( chkptFreq,myTime+deltaTClock,deltaTClock)
        IF ( (modelEnd.AND.writePickupAtEnd)
     &       .OR. permPickup .OR. tempPickup ) THEN
          IF ( permPickup ) THEN
            IF ( rwSuffixType.EQ.0 ) THEN
              WRITE(fn,'(A,I10.10)') 'pickup_aimCo2.', myIter+1
            ELSE
              CALL RW_GET_SUFFIX( suff,
     &                    myTime+deltaTClock, myIter+1, myThid )
              WRITE(fn,'(A,A)') 'pickup_aimCo2.', suff
            ENDIF
          ELSE
            WRITE(fn,'(A,A)') 'pickup_aimCo2.', checkPtSuff(nCheckLev)
          ENDIF
C- write values to new pickup
          tmpco2(1)= atm_CO2_Moles
          tmpco2(2)= atm_pCO2
          iUnit = 0
          CALL MDS_WRITEVEC_LOC( fn, precFloat64, iUnit, 'RL', 2,
     I                           tmpco2, dummyRS,
     I                           0, 0, -1, myIter, myThid )
        ENDIF
        _END_MASTER(myThid)
        _BARRIER

C--- end if aim_select_pCO2 >= 2
      ENDIF

#endif /* ALLOW_AIM_CO2 */
#endif /* ALLOW_AIM */

      RETURN
      END

#include "SEAICE_OPTIONS.h"
#ifdef ALLOW_EXF
# include "EXF_OPTIONS.h"
#endif
#ifdef ALLOW_SALT_PLUME
# include "SALT_PLUME_OPTIONS.h"
#endif
#ifdef ALLOW_AUTODIFF
# include "AUTODIFF_OPTIONS.h"
#endif

CBOP
C     !ROUTINE: SEAICE_GROWTH
C     !INTERFACE:
      SUBROUTINE SEAICE_GROWTH( myTime, myIter, myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE seaice_growth
C     | o Updata ice thickness and snow depth
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "DYNVARS.h"
#include "GRID.h"
#include "FFIELDS.h"
#include "SEAICE_SIZE.h"
#include "SEAICE_PARAMS.h"
#include "SEAICE_GRID.h"
#include "SEAICE.h"
#include "SEAICE_TRACER.h"
#ifdef ALLOW_EXF
# include "EXF_PARAM.h"
# include "EXF_FIELDS.h"
#endif
#ifdef ALLOW_SALT_PLUME
# include "SALT_PLUME.h"
#endif
#ifdef ALLOW_AUTODIFF_TAMC
# include "tamc.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
C     myTime :: Simulation time
C     myIter :: Simulation timestep number
C     myThid :: Thread no. that called this routine.
      _RL myTime
      INTEGER myIter, myThid
CEOP

#ifndef SEAICE_USE_GROWTH_ADX
#if (defined ALLOW_EXF) && (defined ALLOW_ATM_TEMP)
C     !FUNCTIONS:
#ifdef ALLOW_DIAGNOSTICS
      LOGICAL  DIAGNOSTICS_IS_ON
      EXTERNAL DIAGNOSTICS_IS_ON
#endif

C     !LOCAL VARIABLES:
C     === Local variables ===
C
C unit/sign convention:
C    Within the thermodynamic computation all stocks, except HSNOW,
C      are in 'effective ice meters' units, and >0 implies more ice.
C    This holds for stocks due to ocean and atmosphere heat,
C      at the outset of 'PART 2: determine heat fluxes/stocks'
C      and until 'PART 7: determine ocean model forcing'
C    This strategy minimizes the need for multiplications/divisions
C      by ice fraction, heat capacity, etc. The only conversions that
C      occurs are for the HSNOW (in effective snow meters) and
C      PRECIP (fresh water m/s).
C
C HEFF is effective Hice thickness (m3/m2)
C HSNOW is Heffective snow thickness (m3/m2)
C HSALT is Heffective salt content (g/m2)
C AREA is the seaice cover fraction (0<=AREA<=1)
C Q denotes heat stocks -- converted to ice stocks (m3/m2) early on
C
C For all other stocks/increments, such as d_HEFFbyATMonOCN
C or a_QbyATM_cover, the naming convention is as follows:
C    The prefix 'a_' means available, the prefix 'd_' means delta
C       (i.e. increment), and the prefix 'r_' means residual.
C    The suffix '_cover' denotes a value for the ice covered fraction
C       of the grid cell, whereas '_open' is for the open water fraction.
C    The main part of the name states what ice/snow stock is concerned
C       (e.g. QbyATM or HEFF), and how it is affected (e.g. d_HEFFbyATMonOCN
C       is the increment of HEFF due to the ATMosphere extracting heat from the
C       OCeaN surface, or providing heat to the OCeaN surface).

C     i,j,bi,bj :: Loop counters
      INTEGER i, j, bi, bj
C     number of surface interface layer, and second interface layer
      INTEGER kSurface
#ifdef SHORTWAVE_HEATING
      INTEGER kSrfS
#endif
C     IT        :: ice thickness category index (MULTICATEGORIES and ITD code)
      INTEGER IT
C     msgBuf    :: Informational/error message buffer
#ifdef ALLOW_BALANCE_FLUXES
      CHARACTER*(MAX_LEN_MBUF) msgBuf
#elif (defined (SEAICE_DEBUG))
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      CHARACTER*12 msgBufForm
#endif
C     constants
      _RL tempFrz, ICE2SNOW, SNOW2ICE
      _RL QI, QS, recip_QI
      _RL lhSublim

C conversion factors to go from Q (W/m2) to HEFF (ice meters)
      _RL convertQ2HI, convertHI2Q
C conversion factors to go from precip (m/s) unit to HEFF (ice meters)
      _RL convertPRECIP2HI, convertHI2PRECIP
C     Factor by which we increase the upper ocean friction velocity (u*) when
C     ice is absent in a grid cell  (dimensionless)
      _RL MixedLayerTurbulenceFactor

C     wind speed square
      _RL SPEED_SQ

C     Regularization values squared
      _RL area_reg_sq, hice_reg_sq
C     pathological cases thresholds
      _RL heffTooHeavy
C     local copy of surface layer thickness in meters
      _RL dzSurf

C     Helper variables: reciprocal of some constants
      _RL recip_multDim
      _RL recip_deltaTtherm
      _RL recip_rhoIce
C     local value (=1/HO or 1/HO_south)
      _RL recip_HO
C     local value (=1/ice thickness)
      _RL recip_HH
#ifndef SEAICE_ITD
C     facilitate multi-category snow implementation
      _RL pFac, pFacSnow
#endif
C     additional factors accounting for a non-uniform sea-ice PDF
      _RL denominator, recip_denominator, areaPDFfac

C     temporary variables available for the various computations
      _RL tmpscal0, tmpscal1, tmpscal2, tmpscal3, tmpscal4

#ifdef ALLOW_SITRACER
      INTEGER iTr
#ifdef ALLOW_DIAGNOSTICS
      CHARACTER*8   diagName
#endif
#ifdef SEAICE_GREASE
      INTEGER iTrGrease
      _RL greaseDecayTime
      _RL greaseNewFrazil
      _RL THIRD
      PARAMETER (THIRD = 1.0 _d 0 / 3.0 _d 0)
#endif
#endif /* ALLOW_SITRACER */
#ifdef ALLOW_AUTODIFF_TAMC
C     tkey :: tape key (depends on tiles)
      INTEGER tkey
#endif

C==   local arrays ==
C     TmixLoc   :: ocean surface/mixed-layer temperature (in K)
      _RL TmixLoc       (1:sNx,1:sNy)

#ifndef SEAICE_ITD
C     actual ice thickness (with upper and lower limit)
      _RL heffActual          (1:sNx,1:sNy)
C     actual snow thickness
      _RL hsnowActual         (1:sNx,1:sNy)
#endif
C     actual ice thickness (with lower limit only) Reciprocal
      _RL recip_heffActual    (1:sNx,1:sNy)

C     AREA_PRE  :: hold sea-ice fraction field before any seaice-thermo update
      _RL AREApreTH           (1:sNx,1:sNy)
      _RL HEFFpreTH           (1:sNx,1:sNy)
      _RL HSNWpreTH           (1:sNx,1:sNy)
#ifdef SEAICE_ITD
      _RL AREAITDpreTH        (1:sNx,1:sNy,1:nITD)
      _RL HEFFITDpreTH        (1:sNx,1:sNy,1:nITD)
      _RL HSNWITDpreTH        (1:sNx,1:sNy,1:nITD)
      _RL areaFracFactor      (1:sNx,1:sNy,1:nITD)
#endif

C     wind speed
      _RL UG                  (1:sNx,1:sNy)

C     temporary variables available for the various computations
      _RL tmparr1             (1:sNx,1:sNy)

      _RL ticeInMult          (1:sNx,1:sNy,nITD)
      _RL ticeOutMult         (1:sNx,1:sNy,nITD)
      _RL heffActualMult      (1:sNx,1:sNy,nITD)
      _RL hsnowActualMult     (1:sNx,1:sNy,nITD)
#ifdef SEAICE_ITD
      _RL recip_heffActualMult(1:sNx,1:sNy,nITD)
#endif
      _RL a_QbyATMmult_cover  (1:sNx,1:sNy,nITD)
      _RL a_QSWbyATMmult_cover(1:sNx,1:sNy,nITD)
      _RL a_FWbySublimMult    (1:sNx,1:sNy,nITD)
#if defined ( ALLOW_SITRACER ) && defined ( SEAICE_GREASE )
      _RL greaseLayerThick    (1:sNx,1:sNy)
      _RL d_HEFFbyGREASE      (1:sNx,1:sNy)
      _RL uRelW               (1:sNx,1:sNy)
      _RL vRelW               (1:sNx,1:sNy)
#endif
#ifdef SEAICE_ITD
      _RL r_QbyATMmult_cover  (1:sNx,1:sNy,nITD)
      _RL r_FWbySublimMult    (1:sNx,1:sNy,nITD)
C for lateral melt parameterization:
      _RL latMeltFrac         (1:sNx,1:sNy,nITD)
      _RL latMeltRate         (1:sNx,1:sNy,nITD)
      _RL floeAlpha
      _RL floeDiameter
      _RL floeDiameterMin
      _RL floeDiameterMax
#endif

C     a_QbyATM_cover :: available heat (in W/m^2) due to the interaction of
C             the atmosphere and the ocean surface - for ice covered water
C     a_QbyATM_open  :: same but for open water
C     r_QbyATM_cover :: residual of a_QbyATM_cover after freezing/melting processes
C     r_QbyATM_open  :: same but for open water
      _RL a_QbyATM_cover      (1:sNx,1:sNy)
      _RL a_QbyATM_open       (1:sNx,1:sNy)
      _RL r_QbyATM_cover      (1:sNx,1:sNy)
      _RL r_QbyATM_open       (1:sNx,1:sNy)
C     a_QSWbyATM_open   - short wave heat flux over ocean in W/m^2
C     a_QSWbyATM_cover  - short wave heat flux under ice in W/m^2
      _RL a_QSWbyATM_open     (1:sNx,1:sNy)
      _RL a_QSWbyATM_cover    (1:sNx,1:sNy)
C     a_QbyOCN :: available heat (in W/m^2) due to the
C             interaction of the ice pack and the ocean surface
C     r_QbyOCN :: residual of a_QbyOCN after freezing/melting
C             processes have been accounted for
      _RL a_QbyOCN            (1:sNx,1:sNy)
      _RL r_QbyOCN            (1:sNx,1:sNy)

C     The change of mean ice thickness due to turbulent ocean-sea ice heat fluxes
      _RL d_HEFFbyOCNonICE    (1:sNx,1:sNy)

C     The sum of mean ice thickness increments due to atmospheric fluxes over
C     the open water fraction and ice-covered fractions of the grid cell
      _RL d_HEFFbyATMonOCN    (1:sNx,1:sNy)
C     The change of mean ice thickness due to flooding by snow
      _RL d_HEFFbyFLOODING    (1:sNx,1:sNy)

C     The mean ice thickness increments due to atmospheric fluxes over the open
C     water fraction and ice-covered fractions of the grid cell, respectively
      _RL d_HEFFbyATMonOCN_open(1:sNx,1:sNy)
      _RL d_HEFFbyATMonOCN_cover(1:sNx,1:sNy)

      _RL d_HSNWbyATMonSNW    (1:sNx,1:sNy)
      _RL d_HSNWbyOCNonSNW    (1:sNx,1:sNy)
      _RL d_HSNWbyRAIN        (1:sNx,1:sNy)

      _RL d_HFRWbyRAIN        (1:sNx,1:sNy)

C     a_FWbySublim :: fresh water flux implied by latent heat of
C                     sublimation to atmosphere, same sign convention
C                     as EVAP (positive upward)
      _RL a_FWbySublim        (1:sNx,1:sNy)
      _RL r_FWbySublim        (1:sNx,1:sNy)
      _RL d_HEFFbySublim      (1:sNx,1:sNy)
      _RL d_HSNWbySublim      (1:sNx,1:sNy)

#ifdef SEAICE_CAP_SUBLIM
C     The latent heat flux which will sublimate all snow and ice
C     over one time step
      _RL latentHeatFluxMax   (1:sNx,1:sNy)
      _RL latentHeatFluxMaxMult(1:sNx,1:sNy,nITD)
#endif

#ifdef SEAICE_ITD
      _RL d_HEFFbySublim_ITD        (1:sNx,1:sNy,1:nITD)
      _RL d_HSNWbySublim_ITD        (1:sNx,1:sNy,1:nITD)
      _RL d_HEFFbyOCNonICE_ITD      (1:sNx,1:sNy,1:nITD)
      _RL d_HSNWbyATMonSNW_ITD      (1:sNx,1:sNy,1:nITD)
      _RL d_HEFFbyATMonOCN_ITD      (1:sNx,1:sNy,1:nITD)
      _RL d_HEFFbyATMonOCN_cover_ITD(1:sNx,1:sNy,1:nITD)
      _RL d_HEFFbyATMonOCN_open_ITD (1:sNx,1:sNy,1:nITD)
      _RL d_HSNWbyRAIN_ITD          (1:sNx,1:sNy,1:nITD)
      _RL d_HSNWbyOCNonSNW_ITD      (1:sNx,1:sNy,1:nITD)
      _RL d_HEFFbyFLOODING_ITD      (1:sNx,1:sNy,1:nITD)
#endif

#ifdef ALLOW_DIAGNOSTICS
C ICE/SNOW stocks tendencies associated with the various melt/freeze processes
      _RL d_AREAbyATM   (1:sNx,1:sNy)
      _RL d_AREAbyOCN   (1:sNx,1:sNy)
      _RL d_AREAbyICE   (1:sNx,1:sNy)
C     Helper variables for diagnostics
      _RL DIAGarrayA    (1:sNx,1:sNy)
      _RL DIAGarrayB    (1:sNx,1:sNy)
      _RL DIAGarrayC    (1:sNx,1:sNy)
      _RL DIAGarrayD    (1:sNx,1:sNy)
#endif /* ALLOW_DIAGNOSTICS */

      _RL SItflux     (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL SIatmQnt    (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL SIatmFW     (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
#ifdef ALLOW_BALANCE_FLUXES
      _RL FWFsiTile(nSx,nSy)
      _RL FWFsiGlob
      _RL HFsiTile(nSx,nSy)
      _RL HFsiGlob
      _RL FWF2HFsiTile(nSx,nSy)
      _RL FWF2HFsiGlob
#endif

#ifdef ALLOW_SALT_PLUME
      _RL localSPfrac         (1:sNx,1:sNy)
#ifdef SALT_PLUME_IN_LEADS
      _RL leadPlumeFraction   (1:sNx,1:sNy)
      _RL IceGrowthRateInLeads(1:sNx,1:sNy)
#endif /* SALT_PLUME_IN_LEADS */
#endif /* ALLOW_SALT_PLUME */

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C ===================================================================
C =================PART 0: constants and initializations=============
C ===================================================================

      IF ( usingPCoords ) THEN
       kSurface = Nr
       dzSurf   = drF(kSurface)*recip_rhoConst*recip_gravity
      ELSE
       kSurface = 1
       dzSurf   = drF(kSurface)
      ENDIF
#ifdef SHORTWAVE_HEATING
      IF ( usingPCoords ) THEN
       kSrfS    = Nr
      ELSE
       kSrfS    = 2
      ENDIF
#endif

C     avoid unnecessary divisions in loops
      recip_multDim     = SEAICE_multDim
      recip_multDim     = ONE / recip_multDim
C     above/below: double/single precision calculation of recip_multDim
c     recip_multDim     = 1.  / float(SEAICE_multDim)
      recip_deltaTtherm = ONE / SEAICE_deltaTtherm
      recip_rhoIce      = ONE / SEAICE_rhoIce

C     Cutoff for iceload
      heffTooHeavy = dzSurf * 0.2 _d 0
C     RATIO OF SEA ICE DENSITY to SNOW DENSITY
      ICE2SNOW     = SEAICE_rhoIce/SEAICE_rhoSnow
      SNOW2ICE     = ONE / ICE2SNOW

C     HEAT OF FUSION OF ICE (J/m^3)
      QI           = SEAICE_rhoIce*SEAICE_lhFusion
      recip_QI     = ONE / QI
C     HEAT OF FUSION OF SNOW (J/m^3)
      QS           = SEAICE_rhoSnow*SEAICE_lhFusion

C     ICE LATENT HEAT CONSTANT
      lhSublim = SEAICE_lhEvap + SEAICE_lhFusion

C     regularization constants
      area_reg_sq = SEAICE_area_reg * SEAICE_area_reg
      hice_reg_sq = SEAICE_hice_reg * SEAICE_hice_reg

C conversion factors to go from Q (W/m2) to HEFF (ice meters)
      convertQ2HI=SEAICE_deltaTtherm/QI
      convertHI2Q = ONE/convertQ2HI
C conversion factors to go from precip (m/s) unit to HEFF (ice meters)
      convertPRECIP2HI=SEAICE_deltaTtherm*rhoConstFresh/SEAICE_rhoIce
      convertHI2PRECIP = ONE/convertPRECIP2HI
C     compute parameters for thickness pdf (cheap enough to do it here
C     and not in seaice_readparms and store in common block)
      denominator = 0. _d 0
      DO IT=1,SEAICE_multDim
       denominator = denominator + IT * SEAICE_pdf(IT)
      ENDDO
      denominator = (2.0 _d 0 * denominator) - 1.0 _d 0
      recip_denominator = 1. _d 0 / denominator
#ifdef SEAICE_ITD
      areaPDFfac  = 1. _d 0
#else
      areaPDFfac  = denominator * recip_multDim
#endif /* SEAICE_ITD */
#ifdef SEAICE_ITD
C constants for lateral melt parameterization:
C following Steele (1992), Equ. 2
      floeAlpha                  = 0.66 _d 0
C typical mean diameter used in CICE 4.1:
C (this is currently computed as a function of ice concentration
C  following a suggestion by Luepkes at al. (2012))
C      floeDiameter               = 300. _d 0
C parameters needed for variable floe diameter following Luepkes et al. (2012):
      floeDiameterMin            = 8. _d 0
      floeDiameterMax            = 300. _d 0
#endif

      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)

#ifdef ALLOW_AUTODIFF_TAMC
        tkey = bi + (bj-1)*nSx + (ikey_dynamics-1)*nSx*nSy
#endif /* ALLOW_AUTODIFF_TAMC */

#if defined ( ALLOW_SITRACER ) && defined ( SEAICE_GREASE )
C time scale of grease ice decline by solidification,
C with 50% grease ice becoming solid pancake ice within 1 day:
        greaseDecayTime=1.44*86400. _d 0
C store position of 'grease' in tracer array
        iTrGrease=-1
        DO iTr = 1, SItrNumInUse
         IF (SItrName(iTr).EQ.'grease') iTrGrease=iTr
        ENDDO
#endif

C array initializations
C =====================

        DO j=1,sNy
         DO i=1,sNx
          a_QbyATM_cover(i,j)        = 0.0 _d 0
          a_QbyATM_open (i,j)        = 0.0 _d 0
          r_QbyATM_cover(i,j)        = 0.0 _d 0
          r_QbyATM_open (i,j)        = 0.0 _d 0

          a_QSWbyATM_open (i,j)      = 0.0 _d 0
          a_QSWbyATM_cover(i,j)      = 0.0 _d 0

          a_QbyOCN (i,j)             = 0.0 _d 0
          r_QbyOCN (i,j)             = 0.0 _d 0

#ifdef ALLOW_DIAGNOSTICS
          d_AREAbyATM(i,j)           = 0.0 _d 0
          d_AREAbyICE(i,j)           = 0.0 _d 0
          d_AREAbyOCN(i,j)           = 0.0 _d 0
#endif

          d_HEFFbyOCNonICE(i,j)      = 0.0 _d 0
          d_HEFFbyATMonOCN(i,j)      = 0.0 _d 0
          d_HEFFbyFLOODING(i,j)      = 0.0 _d 0

          d_HEFFbyATMonOCN_open(i,j) = 0.0 _d 0
          d_HEFFbyATMonOCN_cover(i,j)= 0.0 _d 0

          d_HSNWbyATMonSNW(i,j)      = 0.0 _d 0
          d_HSNWbyOCNonSNW(i,j)      = 0.0 _d 0
          d_HSNWbyRAIN(i,j)          = 0.0 _d 0
          a_FWbySublim(i,j)          = 0.0 _d 0
          r_FWbySublim(i,j)          = 0.0 _d 0
          d_HEFFbySublim(i,j)        = 0.0 _d 0
          d_HSNWbySublim(i,j)        = 0.0 _d 0
#ifdef SEAICE_CAP_SUBLIM
          latentHeatFluxMax(i,j)     = 0.0 _d 0
#endif
          d_HFRWbyRAIN(i,j)          = 0.0 _d 0
          tmparr1(i,j)               = 0.0 _d 0
#if defined ( ALLOW_SITRACER ) && defined ( SEAICE_GREASE )
          greaseLayerThick(i,j)      = 0.0 _d 0
          d_HEFFbyGREASE(i,j)        = 0.0 _d 0
#endif
          DO IT=1,SEAICE_multDim
            ticeInMult(i,j,IT)            = 0.0 _d 0
            ticeOutMult(i,j,IT)           = 0.0 _d 0
            a_QbyATMmult_cover(i,j,IT)    = 0.0 _d 0
            a_QSWbyATMmult_cover(i,j,IT)  = 0.0 _d 0
            a_FWbySublimMult(i,j,IT)      = 0.0 _d 0
#ifdef SEAICE_CAP_SUBLIM
            latentHeatFluxMaxMult(i,j,IT) = 0.0 _d 0
#endif
#ifdef SEAICE_ITD
            d_HEFFbySublim_ITD(i,j,IT)         = 0.0 _d 0
            d_HSNWbySublim_ITD(i,j,IT)         = 0.0 _d 0
            d_HEFFbyOCNonICE_ITD(i,j,IT)       = 0.0 _d 0
            d_HSNWbyATMonSNW_ITD(i,j,IT)       = 0.0 _d 0
            d_HEFFbyATMonOCN_ITD(i,j,IT)       = 0.0 _d 0
            d_HEFFbyATMonOCN_cover_ITD(i,j,IT) = 0.0 _d 0
            d_HEFFbyATMonOCN_open_ITD(i,j,IT)  = 0.0 _d 0
            d_HSNWbyRAIN_ITD(i,j,IT)           = 0.0 _d 0
            d_HSNWbyOCNonSNW_ITD(i,j,IT)       = 0.0 _d 0
            d_HEFFbyFLOODING_ITD(i,j,IT)       = 0.0 _d 0
            r_QbyATMmult_cover(i,j,IT)         = 0.0 _d 0
            r_FWbySublimMult(i,j,IT)           = 0.0 _d 0
C for lateral melt parameterization:
            latMeltFrac(i,j,IT)                = 0.0 _d 0
            latMeltRate(i,j,IT)                = 0.0 _d 0
#endif
          ENDDO
         ENDDO
        ENDDO

C =====================================================================
C ===========PART 1: treat pathological cases (post advdiff)===========
C =====================================================================

C     This part has been mostly moved to S/R seaice_reg_ridge, which is
C     called before S/R seaice_growth

C     store regularized values of heff, hsnow, area at the onset of thermo.
        DO j=1,sNy
         DO i=1,sNx
          HEFFpreTH(i,j) = HEFF(i,j,bi,bj)
          HSNWpreTH(i,j) = HSNOW(i,j,bi,bj)
          AREApreTH(i,j) = AREA(i,j,bi,bj)
#ifdef ALLOW_DIAGNOSTICS
          DIAGarrayB(i,j) = AREA(i,j,bi,bj)
          DIAGarrayC(i,j) = HEFF(i,j,bi,bj)
          DIAGarrayD(i,j) = HSNOW(i,j,bi,bj)
#endif
#ifdef ALLOW_SITRACER
          SItrHEFF(i,j,bi,bj,1)=HEFF(i,j,bi,bj)
          SItrAREA(i,j,bi,bj,2)=AREA(i,j,bi,bj)
#endif
         ENDDO
        ENDDO
#ifdef SEAICE_ITD
        DO IT=1,SEAICE_multDim
         DO j=1,sNy
          DO i=1,sNx
           HEFFITDpreTH(i,j,IT)=HEFFITD(i,j,IT,bi,bj)
           HSNWITDpreTH(i,j,IT)=HSNOWITD(i,j,IT,bi,bj)
           AREAITDpreTH(i,j,IT)=AREAITD(i,j,IT,bi,bj)

C     keep track of areal and volume fraction of each ITD category
           IF (AREA(i,j,bi,bj) .GT. ZERO) THEN
            areaFracFactor(i,j,IT)=AREAITD(i,j,IT,bi,bj)/AREA(i,j,bi,bj)
           ELSE
C           if there is no ice, potential growth starts in 1st category
            IF (IT .EQ. 1) THEN
             areaFracFactor(i,j,IT)=ONE
            ELSE
             areaFracFactor(i,j,IT)=ZERO
            ENDIF
           ENDIF
          ENDDO
         ENDDO
        ENDDO
#ifdef ALLOW_SITRACER
C     prepare SItrHEFF to be computed as cumulative sum
        DO iTr=2,5
         DO j=1,sNy
          DO i=1,sNx
           SItrHEFF(i,j,bi,bj,iTr)=ZERO
          ENDDO
         ENDDO
        ENDDO
C     prepare SItrAREA to be computed as cumulative sum
        DO j=1,sNy
         DO i=1,sNx
          SItrAREA(i,j,bi,bj,3)=ZERO
         ENDDO
        ENDDO
#endif
#endif /* SEAICE_ITD */

#ifdef ALLOW_DIAGNOSTICS
        IF ( useDiagnostics ) THEN
         CALL DIAGNOSTICS_FILL(DIAGarrayB,'SIareaPT',0,1,3,bi,bj,myThid)
         CALL DIAGNOSTICS_FILL(DIAGarrayC,'SIheffPT',0,1,3,bi,bj,myThid)
         CALL DIAGNOSTICS_FILL(DIAGarrayD,'SIhsnoPT',0,1,3,bi,bj,myThid)
#ifdef ALLOW_SITRACER
         DO iTr = 1, SItrNumInUse
          WRITE(diagName,'(A4,I2.2,A2)') 'SItr',iTr,'PT'
          IF (SItrMate(iTr).EQ.'HEFF') THEN
           CALL DIAGNOSTICS_FRACT_FILL(
     I          SItracer(1-OLx,1-OLy,bi,bj,iTr),HEFF(1-OLx,1-OLy,bi,bj),
     I          ONE, 1, diagName,0,1,2,bi,bj,myThid )
          ELSE
           CALL DIAGNOSTICS_FRACT_FILL(
     I          SItracer(1-OLx,1-OLy,bi,bj,iTr),AREA(1-OLx,1-OLy,bi,bj),
     I          ONE, 1, diagName,0,1,2,bi,bj,myThid )
          ENDIF
         ENDDO
#endif /* ALLOW_SITRACER */
        ENDIF
#endif /* ALLOW_DIAGNOSTICS */

#if (defined ALLOW_AUTODIFF && defined SEAICE_MODIFY_GROWTH_ADJ)
Cgf no additional dependency of air-sea fluxes to ice
        IF ( SEAICEadjMODE.GE.1 ) THEN
         DO j=1,sNy
          DO i=1,sNx
           HEFFpreTH(i,j) = 0. _d 0
           HSNWpreTH(i,j) = 0. _d 0
           AREApreTH(i,j) = 0. _d 0
          ENDDO
         ENDDO
#ifdef SEAICE_ITD
         DO IT=1,SEAICE_multDim
          DO j=1,sNy
           DO i=1,sNx
            HEFFITDpreTH(i,j,IT) = 0. _d 0
            HSNWITDpreTH(i,j,IT) = 0. _d 0
            AREAITDpreTH(i,j,IT) = 0. _d 0
           ENDDO
          ENDDO
         ENDDO
#endif
        ENDIF
#endif

C     COMPUTE ACTUAL ICE/SNOW THICKNESS; USE MIN/MAX VALUES
C     TO REGULARIZE SEAICE_SOLVE4TEMP/d_AREA COMPUTATIONS

#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE AREApreTH = comlev1_bibj, key = tkey, byte = isbyte
CADJ STORE HEFFpreTH = comlev1_bibj, key = tkey, byte = isbyte
CADJ STORE HSNWpreTH = comlev1_bibj, key = tkey, byte = isbyte
#endif /* ALLOW_AUTODIFF_TAMC */
#ifdef SEAICE_ITD
        DO IT=1,SEAICE_multDim
         DO j=1,sNy
          DO i=1,sNx
           IF (HEFFITDpreTH(i,j,IT) .GT. ZERO) THEN
C     regularize AREA with SEAICE_area_reg
            tmpscal1 = SQRT( AREAITDpreTH(i,j,IT)*AREAITDpreTH(i,j,IT)
     &                     + area_reg_sq )
C     heffActual calculated with the regularized AREA
            tmpscal2 = HEFFITDpreTH(i,j,IT) / tmpscal1
C     regularize heffActual with SEAICE_hice_reg (add lower bound)
            heffActualMult(i,j,IT) = SQRT(tmpscal2 * tmpscal2
     &                                    + hice_reg_sq)
C     hsnowActual calculated with the regularized AREA
            hsnowActualMult(i,j,IT) = HSNWITDpreTH(i,j,IT) / tmpscal1
C     regularize the inverse of heffActual by hice_reg
            recip_heffActualMult(i,j,IT)  = AREAITDpreTH(i,j,IT) /
     &           SQRT(HEFFITDpreTH(i,j,IT) * HEFFITDpreTH(i,j,IT)
     &           + hice_reg_sq)
C     Do not regularize when HEFFpreTH = 0
           ELSE
            heffActualMult(i,j,IT) = ZERO
            hsnowActualMult(i,j,IT) = ZERO
            recip_heffActualMult(i,j,IT)  = ZERO
           ENDIF
          ENDDO
         ENDDO
        ENDDO
#else /* ndef SEAICE_ITD */
        DO j=1,sNy
         DO i=1,sNx
          IF (HEFFpreTH(i,j) .GT. ZERO) THEN
Cif        regularize AREA with SEAICE_area_reg
           tmpscal1 = SQRT(AREApreTH(i,j)* AREApreTH(i,j) + area_reg_sq)
Cif        heffActual calculated with the regularized AREA
           tmpscal2 = HEFFpreTH(i,j) / tmpscal1
Cif        regularize heffActual with SEAICE_hice_reg (add lower bound)
           heffActual(i,j) = SQRT(tmpscal2 * tmpscal2 + hice_reg_sq)
Cif        hsnowActual calculated with the regularized AREA
           hsnowActual(i,j) = HSNWpreTH(i,j) / tmpscal1
Cif        regularize the inverse of heffActual by hice_reg
           recip_heffActual(i,j)  = AREApreTH(i,j) /
     &                 SQRT(HEFFpreTH(i,j)*HEFFpreTH(i,j) + hice_reg_sq)
Cif       Do not regularize when HEFFpreTH = 0
          ELSE
           heffActual(i,j) = ZERO
           hsnowActual(i,j) = ZERO
           recip_heffActual(i,j)  = ZERO
          ENDIF
         ENDDO
        ENDDO
#endif /* SEAICE_ITD */

#if (defined ALLOW_AUTODIFF && defined SEAICE_MODIFY_GROWTH_ADJ)
        CALL ZERO_ADJ_1D( sNx*sNy, heffActual, myThid)
        CALL ZERO_ADJ_1D( sNx*sNy, hsnowActual, myThid)
        CALL ZERO_ADJ_1D( sNx*sNy, recip_heffActual, myThid)
#endif

#ifdef SEAICE_CAP_SUBLIM
C     COMPUTE MAXIMUM LATENT HEAT FLUXES FOR THE CURRENT ICE
C     AND SNOW THICKNESS
C     The latent heat flux over the sea ice which
C     will sublimate all of the snow and ice over one time
C     step (W/m^2)
#ifdef SEAICE_ITD
        DO IT=1,SEAICE_multDim
         DO j=1,sNy
          DO i=1,sNx
           IF (HEFFITDpreTH(i,j,IT) .GT. ZERO) THEN
            latentHeatFluxMaxMult(i,j,IT) = lhSublim*recip_deltaTtherm *
     &           (HEFFITDpreTH(i,j,IT)*SEAICE_rhoIce +
     &            HSNWITDpreTH(i,j,IT)*SEAICE_rhoSnow)
     &           /AREAITDpreTH(i,j,IT)
           ELSE
            latentHeatFluxMaxMult(i,j,IT) = ZERO
           ENDIF
          ENDDO
         ENDDO
        ENDDO
#else /* ndef SEAICE_ITD */
        DO j=1,sNy
         DO i=1,sNx
          IF (HEFFpreTH(i,j) .GT. ZERO) THEN
           latentHeatFluxMax(i,j) = lhSublim * recip_deltaTtherm *
     &          (HEFFpreTH(i,j) * SEAICE_rhoIce +
     &           HSNWpreTH(i,j) * SEAICE_rhoSnow)/AREApreTH(i,j)
          ELSE
           latentHeatFluxMax(i,j) = ZERO
          ENDIF
         ENDDO
        ENDDO
#endif /* SEAICE_ITD */
#endif /* SEAICE_CAP_SUBLIM */

C ===================================================================
C ================PART 2: determine heat fluxes/stocks===============
C ===================================================================

C determine available heat due to the atmosphere -- for open water
C ================================================================

        DO j=1,sNy
         DO i=1,sNx
C ocean surface/mixed layer temperature
          TmixLoc(i,j) = theta(i,j,kSurface,bi,bj)+celsius2K
C wind speed from exf
          UG(i,j) = MAX(SEAICE_EPS,wspeed(i,j,bi,bj))
         ENDDO
        ENDDO

#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE qnet(:,:,bi,bj) = comlev1_bibj, key = tkey,byte=isbyte
CADJ STORE qsw(:,:,bi,bj)  = comlev1_bibj, key = tkey,byte=isbyte
cCADJ STORE UG = comlev1_bibj, key = tkey,byte=isbyte
cCADJ STORE TmixLoc = comlev1_bibj, key = tkey,byte=isbyte
#endif /* ALLOW_AUTODIFF_TAMC */

        CALL SEAICE_BUDGET_OCEAN(
     I       UG,
     I       TmixLoc,
     O       a_QbyATM_open, a_QSWbyATM_open,
     I       bi, bj, myTime, myIter, myThid )

C determine available heat due to the atmosphere -- for ice covered water
C =======================================================================

        IF (useRelativeWind.AND.useAtmWind) THEN
C     Compute relative wind speed over sea ice.
         DO j=1,sNy
          DO i=1,sNx
           SPEED_SQ =
     &          (uWind(i,j,bi,bj)
     &          -0.5 _d 0*(uice(i,j,bi,bj)+uice(i+1,j,bi,bj)))**2
     &          +(vWind(i,j,bi,bj)
     &          -0.5 _d 0*(vice(i,j,bi,bj)+vice(i,j+1,bi,bj)))**2
           IF ( SPEED_SQ .LE. SEAICE_EPS_SQ ) THEN
             UG(i,j)=SEAICE_EPS
           ELSE
             UG(i,j)=SQRT(SPEED_SQ)
           ENDIF
          ENDDO
         ENDDO
        ENDIF

#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE hsnowActual = comlev1_bibj, key = tkey, byte = isbyte
CADJ STORE heffActual  = comlev1_bibj, key = tkey, byte = isbyte
CADJ STORE UG          = comlev1_bibj, key = tkey, byte = isbyte
CADJ STORE tices(:,:,:,bi,bj)
CADJ &     = comlev1_bibj, key = tkey, byte = isbyte
CADJ STORE salt(:,:,kSurface,bi,bj) = comlev1_bibj,
CADJ &                       key = tkey, byte = isbyte
#endif /* ALLOW_AUTODIFF_TAMC */

C--   Start loop over multi-categories
        DO IT=1,SEAICE_multDim
         DO j=1,sNy
          DO i=1,sNx
           ticeInMult(i,j,IT)  = TICES(i,j,IT,bi,bj)
           ticeOutMult(i,j,IT) = TICES(i,j,IT,bi,bj)
           TICES(i,j,IT,bi,bj) = ZERO
          ENDDO
         ENDDO
#ifndef SEAICE_ITD
C     for SEAICE_ITD heffActualMult and latentHeatFluxMaxMult have been
C     calculated above (instead of heffActual and latentHeatFluxMax)
C--   assume homogeneous distribution between 0 and 2 x heffActual
         pFac = (2.0 _d 0*IT - 1.0 _d 0)*recip_denominator
         pFacSnow = 1. _d 0
         IF ( SEAICE_useMultDimSnow ) pFacSnow=pFac
         DO j=1,sNy
          DO i=1,sNx
           heffActualMult(i,j,IT)        = heffActual(i,j)*pFac
           hsnowActualMult(i,j,IT)       = hsnowActual(i,j)*pFacSnow
#ifdef SEAICE_CAP_SUBLIM
           latentHeatFluxMaxMult(i,j,IT) = latentHeatFluxMax(i,j)*pFac
#endif
          ENDDO
         ENDDO
#endif /* ndef SEAICE_ITD */
        ENDDO

#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE heffActualMult = comlev1_bibj, key = tkey, byte = isbyte
CADJ STORE hsnowActualMult= comlev1_bibj, key = tkey, byte = isbyte
CADJ STORE ticeInMult     = comlev1_bibj, key = tkey, byte = isbyte
# ifdef SEAICE_CAP_SUBLIM
CADJ STORE latentHeatFluxMaxMult
CADJ &     = comlev1_bibj, key = tkey, byte = isbyte
# endif
CADJ STORE a_QbyATMmult_cover   =
CADJ &     comlev1_bibj, key = tkey, byte = isbyte
CADJ STORE a_QSWbyATMmult_cover =
CADJ &     comlev1_bibj, key = tkey, byte = isbyte
CADJ STORE a_FWbySublimMult     =
CADJ &     comlev1_bibj, key = tkey, byte = isbyte
#endif /* ALLOW_AUTODIFF_TAMC */

        DO IT=1,SEAICE_multDim
         CALL SEAICE_SOLVE4TEMP(
     I        UG, heffActualMult(1,1,IT), hsnowActualMult(1,1,IT),
#ifdef SEAICE_CAP_SUBLIM
     I        latentHeatFluxMaxMult(1,1,IT),
#endif
     I        ticeInMult(1,1,IT),
     O        ticeOutMult(1,1,IT),
     O        a_QbyATMmult_cover(1,1,IT),
     O        a_QSWbyATMmult_cover(1,1,IT),
     O        a_FWbySublimMult(1,1,IT),
     I        bi, bj, myTime, myIter, myThid )
        ENDDO

#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE heffActualMult = comlev1_bibj, key = tkey, byte = isbyte
CADJ STORE hsnowActualMult= comlev1_bibj, key = tkey, byte = isbyte
CADJ STORE ticeOutMult    = comlev1_bibj, key = tkey, byte = isbyte
# ifdef SEAICE_CAP_SUBLIM
CADJ STORE latentHeatFluxMaxMult
CADJ &     = comlev1_bibj, key = tkey, byte = isbyte
# endif
CADJ STORE a_QbyATMmult_cover   =
CADJ &     comlev1_bibj, key = tkey, byte = isbyte
CADJ STORE a_QSWbyATMmult_cover =
CADJ &     comlev1_bibj, key = tkey, byte = isbyte
CADJ STORE a_FWbySublimMult     =
CADJ &     comlev1_bibj, key = tkey, byte = isbyte
#endif /* ALLOW_AUTODIFF_TAMC */

        DO IT=1,SEAICE_multDim
         DO j=1,sNy
          DO i=1,sNx
C     update TICES
CMLC     and tIce, if required later on (currently not the case)
CML#ifdef SEAICE_ITD
CMLC     calculate area weighted mean
CMLC     (although the ice temperature relates to its energy content
CMLC      and hence should be averaged weighted by ice volume,
CMLC      the temperature here is a result of the fluxes through the ice surface
CMLC      computed individually for each single category in SEAICE_SOLVE4TEMP
CMLC      and hence is averaged area weighted [areaFracFactor])
CML           tIce(I,J,bi,bj) = tIce(I,J,bi,bj)
CML     &          +  ticeOutMult(I,J,IT)*areaFracFactor(I,J,IT)
CML#else
CML           tIce(I,J,bi,bj) = tIce(I,J,bi,bj)
CML     &          +  ticeOutMult(I,J,IT)*SEAICE_PDF(IT)
CML#endif
           TICES(i,j,IT,bi,bj) = ticeOutMult(i,j,IT)
C     average over categories
#ifdef SEAICE_ITD
C     calculate area weighted mean
C     (fluxes are per unit (ice surface) area and are thus area weighted)
           a_QbyATM_cover   (i,j) = a_QbyATM_cover(i,j)
     &          + a_QbyATMmult_cover(i,j,IT)*areaFracFactor(i,j,IT)
           a_QSWbyATM_cover (i,j) = a_QSWbyATM_cover(i,j)
     &          + a_QSWbyATMmult_cover(i,j,IT)*areaFracFactor(i,j,IT)
           a_FWbySublim     (i,j) = a_FWbySublim(i,j)
     &          + a_FWbySublimMult(i,j,IT)*areaFracFactor(i,j,IT)
#else
           a_QbyATM_cover   (i,j) = a_QbyATM_cover(i,j)
     &          + a_QbyATMmult_cover(i,j,IT)*SEAICE_PDF(IT)
           a_QSWbyATM_cover (i,j) = a_QSWbyATM_cover(i,j)
     &          + a_QSWbyATMmult_cover(i,j,IT)*SEAICE_PDF(IT)
           a_FWbySublim     (i,j) = a_FWbySublim(i,j)
     &          + a_FWbySublimMult(i,j,IT)*SEAICE_PDF(IT)
#endif
          ENDDO
         ENDDO
        ENDDO

#ifdef SEAICE_CAP_SUBLIM
# ifdef ALLOW_DIAGNOSTICS
        DO j=1,sNy
         DO i=1,sNx
C          The actual latent heat flux realized by SOLVE4TEMP
           DIAGarrayA(i,j) = a_FWbySublim(i,j) * lhSublim
         ENDDO
        ENDDO
Cif     The actual vs. maximum latent heat flux
        IF ( useDiagnostics ) THEN
          CALL DIAGNOSTICS_FILL(DIAGarrayA,
     &     'SIactLHF',0,1,3,bi,bj,myThid)
          CALL DIAGNOSTICS_FILL(latentHeatFluxMax,
     &     'SImaxLHF',0,1,3,bi,bj,myThid)
        ENDIF
# endif /* ALLOW_DIAGNOSTICS */
#endif /* SEAICE_CAP_SUBLIM */

#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE AREApreTH       = comlev1_bibj, key = tkey, byte = isbyte
CADJ STORE a_QbyATM_cover  = comlev1_bibj, key = tkey, byte = isbyte
CADJ STORE a_QSWbyATM_cover= comlev1_bibj, key = tkey, byte = isbyte
CADJ STORE a_QbyATM_open   = comlev1_bibj, key = tkey, byte = isbyte
CADJ STORE a_QSWbyATM_open = comlev1_bibj, key = tkey, byte = isbyte
CADJ STORE a_FWbySublim    = comlev1_bibj, key = tkey, byte = isbyte
#endif /* ALLOW_AUTODIFF_TAMC */

C switch heat fluxes from W/m2 to 'effective' ice meters
#ifdef SEAICE_ITD
        DO IT=1,SEAICE_multDim
         DO j=1,sNy
          DO i=1,sNx
           a_QbyATMmult_cover(i,j,IT)   = a_QbyATMmult_cover(i,j,IT)
     &          * convertQ2HI * AREAITDpreTH(i,j,IT)
           a_QSWbyATMmult_cover(i,j,IT) = a_QSWbyATMmult_cover(i,j,IT)
     &          * convertQ2HI * AREAITDpreTH(i,j,IT)
C and initialize r_QbyATMmult_cover
           r_QbyATMmult_cover(i,j,IT)=a_QbyATMmult_cover(i,j,IT)
C     Convert fresh water flux by sublimation to 'effective' ice meters.
C     Negative sublimation is resublimation and will be added as snow.
#ifdef SEAICE_DISABLE_SUBLIM
           a_FWbySublimMult(i,j,IT) = ZERO
#endif
           a_FWbySublimMult(i,j,IT) = SEAICE_deltaTtherm*recip_rhoIce
     &            * a_FWbySublimMult(i,j,IT)*AREAITDpreTH(i,j,IT)
           r_FWbySublimMult(i,j,IT)=a_FWbySublimMult(i,j,IT)
          ENDDO
         ENDDO
        ENDDO
        DO j=1,sNy
         DO i=1,sNx
          a_QbyATM_open(i,j)    = a_QbyATM_open(i,j)
     &         * convertQ2HI * ( ONE - AREApreTH(i,j) )
          a_QSWbyATM_open(i,j)  = a_QSWbyATM_open(i,j)
     &         * convertQ2HI * ( ONE - AREApreTH(i,j) )
C and initialize r_QbyATM_open
          r_QbyATM_open(i,j)=a_QbyATM_open(i,j)
         ENDDO
        ENDDO
#else /* SEAICE_ITD */
        DO j=1,sNy
         DO i=1,sNx
          a_QbyATM_cover(i,j)   = a_QbyATM_cover(i,j)
     &         * convertQ2HI * AREApreTH(i,j)
          a_QSWbyATM_cover(i,j) = a_QSWbyATM_cover(i,j)
     &         * convertQ2HI * AREApreTH(i,j)
          a_QbyATM_open(i,j)    = a_QbyATM_open(i,j)
     &         * convertQ2HI * ( ONE - AREApreTH(i,j) )
          a_QSWbyATM_open(i,j)  = a_QSWbyATM_open(i,j)
     &         * convertQ2HI * ( ONE - AREApreTH(i,j) )
C and initialize r_QbyATM_cover/r_QbyATM_open
          r_QbyATM_cover(i,j)=a_QbyATM_cover(i,j)
          r_QbyATM_open(i,j)=a_QbyATM_open(i,j)
C     Convert fresh water flux by sublimation to 'effective' ice meters.
C     Negative sublimation is resublimation and will be added as snow.
#ifdef SEAICE_DISABLE_SUBLIM
Cgf just for those who may need to omit this term to reproduce old results
          a_FWbySublim(i,j) = ZERO
#endif /* SEAICE_DISABLE_SUBLIM */
          a_FWbySublim(i,j) = SEAICE_deltaTtherm*recip_rhoIce
     &           * a_FWbySublim(i,j)*AREApreTH(i,j)
          r_FWbySublim(i,j)=a_FWbySublim(i,j)
         ENDDO
        ENDDO
#endif /* SEAICE_ITD */

#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE AREApreTH       = comlev1_bibj, key = tkey, byte = isbyte
CADJ STORE a_QbyATM_cover  = comlev1_bibj, key = tkey, byte = isbyte
CADJ STORE a_QSWbyATM_cover= comlev1_bibj, key = tkey, byte = isbyte
CADJ STORE a_QbyATM_open   = comlev1_bibj, key = tkey, byte = isbyte
CADJ STORE a_QSWbyATM_open = comlev1_bibj, key = tkey, byte = isbyte
CADJ STORE a_FWbySublim    = comlev1_bibj, key = tkey, byte = isbyte
CADJ STORE r_QbyATM_cover  = comlev1_bibj, key = tkey, byte = isbyte
CADJ STORE r_QbyATM_open   = comlev1_bibj, key = tkey, byte = isbyte
CADJ STORE r_FWbySublim    = comlev1_bibj, key = tkey, byte = isbyte
#endif /* ALLOW_AUTODIFF_TAMC */

#if (defined ALLOW_AUTODIFF && defined SEAICE_MODIFY_GROWTH_ADJ)
Cgf no additional dependency through ice cover
        IF ( SEAICEadjMODE.GE.3 ) THEN
#ifdef SEAICE_ITD
         DO IT=1,SEAICE_multDim
          DO j=1,sNy
           DO i=1,sNx
            a_QbyATMmult_cover(i,j,IT)   = 0. _d 0
            r_QbyATMmult_cover(i,j,IT)   = 0. _d 0
            a_QSWbyATMmult_cover(i,j,IT) = 0. _d 0
           ENDDO
          ENDDO
         ENDDO
#else /* ndef SEAICE_ITD */
         DO j=1,sNy
          DO i=1,sNx
           a_QbyATM_cover(i,j)   = 0. _d 0
           r_QbyATM_cover(i,j)   = 0. _d 0
           a_QSWbyATM_cover(i,j) = 0. _d 0
          ENDDO
         ENDDO
#endif /* SEAICE_ITD */
        ENDIF
#endif

C determine available heat due to the ice pack tying the
C underlying surface water temperature to freezing point
C ======================================================

#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE theta(:,:,kSurface,bi,bj) = comlev1_bibj,
CADJ &                       key = tkey, byte = isbyte
CADJ STORE salt(:,:,kSurface,bi,bj) = comlev1_bibj,
CADJ &                       key = tkey, byte = isbyte
#endif

        DO j=1,sNy
         DO i=1,sNx
C         FREEZING TEMP. OF SEA WATER (deg C)
          tempFrz = SEAICE_tempFrz0 +
     &              SEAICE_dTempFrz_dS *salt(i,j,kSurface,bi,bj)
C efficiency of turbulent fluxes : dependency to sign of THETA-TBC
          IF ( theta(i,j,kSurface,bi,bj) .GE. tempFrz ) THEN
           tmpscal1 = SEAICE_mcPheePiston
          ELSE
           tmpscal1 =SEAICE_frazilFrac*dzSurf/SEAICE_deltaTtherm
          ENDIF
C efficiency of turbulent fluxes : dependency to AREA (McPhee cases)
          IF ( (AREApreTH(i,j) .GT. 0. _d 0).AND.
     &         (.NOT.SEAICE_mcPheeStepFunc) ) THEN
           MixedLayerTurbulenceFactor = ONE -
     &          SEAICE_mcPheeTaper * AREApreTH(i,j)
          ELSEIF ( (AREApreTH(i,j) .GT. 0. _d 0).AND.
     &             (SEAICE_mcPheeStepFunc) ) THEN
           MixedLayerTurbulenceFactor = ONE - SEAICE_mcPheeTaper
          ELSE
           MixedLayerTurbulenceFactor = ONE
          ENDIF
C maximum turbulent flux, in ice meters
          tmpscal2= - (HeatCapacity_Cp*rhoConst * recip_QI)
     &         * (theta(i,j,kSurface,bi,bj)-tempFrz)
     &         * SEAICE_deltaTtherm * HEFFM(i,j,bi,bj)
C available turbulent flux
          a_QbyOCN(i,j) =
     &         tmpscal1 * tmpscal2 * MixedLayerTurbulenceFactor
          r_QbyOCN(i,j) = a_QbyOCN(i,j)
         ENDDO
        ENDDO

#ifdef SEAICE_ITD
C determine lateral melt rate at floe edges based on an
C average floe diameter or a floe size distribution
C following Steele (1992, Tab. 2)
C ======================================================
        DO IT=1,SEAICE_multDim
         DO j=1,sNy
          DO i=1,sNx
           tempFrz = SEAICE_tempFrz0 +
     &          SEAICE_dTempFrz_dS *salt(i,j,kSurface,bi,bj)
           tmpscal1=(theta(i,j,kSurface,bi,bj)-tempFrz)
           tmpscal2=SQRT(0.87 + 0.067*UG(i,j)) * UG(i,j)

C     variable floe diameter following Luepkes et al. (2012, JGR, Equ. 26)
C     with beta=1
CML           tmpscal3=ONE/(ONE-(floeDiameterMin/floeDiameterMax))
CML           floeDiameter = floeDiameterMin
CML     &          * (tmpscal3 / (tmpscal3-AREApreTH(I,J)))
C     this form involves fewer divisions but gives the same result
           floeDiameter = floeDiameterMin * floeDiameterMax
     &          / ( floeDiameterMax*( 1. _d 0 - AREApreTH(i,j) )
     &            + floeDiameterMin*AREApreTH(i,j) )
C     following the idea of SEAICE_areaLossFormula == 1:
           IF (a_QbyATMmult_cover(i,j,IT).LT.ZERO .OR.
     &         a_QbyATM_open(i,j) .LT.ZERO .OR.
     &         a_QbyOCN(i,j)      .LT.ZERO) THEN
C     lateral melt rate as suggested by Perovich, 1983 (PhD thesis)
c           latMeltRate(i,j,IT) = 1.6 _d -6 * tmpscal1**1.36
C     The following for does the same, but is faster
            latMeltRate(i,j,IT) = ZERO
            IF (tmpscal1 .GT. ZERO)
     &         latMeltRate(i,j,IT) = 1.6 _d -6 * exp(1.36*log(tmpscal1))
C     lateral melt rate as suggested by Maykut and Perovich, 1987
C     (JGR 92(C7)), Equ. 24
c           latMeltRate(i,j,IT) = 13.5 _d -6 * tmpscal2 * tmpscal1**1.3
C     further suggestion by Maykut and Perovich to avoid
C     latMeltRate -> 0 for UG -> 0
c           latMeltRate(i,j,IT) = (1.6 _d -6 + 13.5 _d -6 * tmpscal2)
c    &                          * tmpscal1**1.3
C     factor determining fraction of area and ice volume reduction
C     due to lateral melt
            latMeltFrac(i,j,IT) =
     &       latMeltRate(i,j,IT)*SEAICE_deltaTtherm*PI /
     &       (floeAlpha * floeDiameter)
            latMeltFrac(i,j,IT)=max(ZERO, min(latMeltFrac(i,j,IT),ONE))
           ELSE
            latMeltRate(i,j,IT)=0.0 _d 0
            latMeltFrac(i,j,IT)=0.0 _d 0
           ENDIF
          ENDDO
         ENDDO
        ENDDO
#endif /* SEAICE_ITD */

#if (defined ALLOW_AUTODIFF && defined SEAICE_MODIFY_GROWTH_ADJ)
        CALL ZERO_ADJ_1D( sNx*sNy, r_QbyOCN, myThid)
#endif

C ===================================================================
C =========PART 3: determine effective thicknesses increments========
C ===================================================================

#if defined ( ALLOW_SITRACER ) && defined ( SEAICE_GREASE )
C convert SItracer 'grease' from ratio to grease ice volume:
C ==========================================================
        DO j=1,sNy
         DO i=1,sNx
          SItracer(i,j,bi,bj,iTrGrease) =
     &     SItracer(i,j,bi,bj,iTrGrease) * HEFF(i,j,bi,bj)
          uRelW(i,j) = uWind(i,j,bi,bj)
          vRelW(i,j) = vWind(i,j,bi,bj)
         ENDDO
        ENDDO
        IF ( useRelativeWind ) THEN
         DO j=1,sNy
          DO i=1,sNx
           uRelW(i,j) = uWind(i,j,bi,bj)
     &          - 0.5 _d 0*( uIce(i,j,bi,bj) + uIce(i+1,j,bi,bj) )
           vRelW(i,j) = vWind(i,j,bi,bj)
     &          - 0.5 _d 0*( vIce(i,j,bi,bj) + vIce(i,j+1,bi,bj) )
          ENDDO
         ENDDO
        ENDIF
C compute actual grease ice layer thickness
C as a function of wind stress
C following Smedsrud [2011, Ann.Glac.]
C =========================================
         DO j=1,sNy
          DO i=1,sNx
C
C          computing compaction force acting on grease
C           (= air and water stress acting on ice)
C          wind stress (using calculation of SPEED_SQ & UG as template)
C          u_a**2 + v_a**2:
           tmpscal1 = uRelW(i,j)*uRelW(i,j) + vRelW(i,j)*vRelW(i,j)
           IF ( tmpscal1 .LE. SEAICE_EPS_SQ ) THEN
             tmpscal1=SEAICE_EPS
           ELSE
             tmpscal1=SQRT(tmpscal2)
           ENDIF
           tmpscal1 = 1.4 _d 0 * 1.3 _d -3 * tmpscal1
C          water stress
C          u_w - u_i:
           tmpscal2 =
     &        0.5 _d 0*(uVel(i,j,kSurface,bi,bj)
     &                 +uVel(i+1,j,kSurface,bi,bj))
     &       -0.5 _d 0*(uIce(i,j,bi,bj)+uIce(i+1,j,bi,bj))
C          v_w - v_i:
           tmpscal3 =
     &        0.5 _d 0*(vVel(i,j,kSurface,bi,bj)
     &                 +vVel(i,j+1,kSurface,bi,bj))
     &       -0.5 _d 0*(vIce(i,j,bi,bj)+vIce(i,j+1,bi,bj))
C          (u_w - u_i)**2 + (v_w - v_i)**2:
           tmpscal4 = (tmpscal2*tmpscal2 + tmpscal3*tmpscal3)
           IF ( tmpscal4 .LE. SEAICE_EPS_SQ ) THEN
             tmpscal4=SEAICE_EPS
           ELSE
             tmpscal4=SQRT(tmpscal4)
           ENDIF
           tmpscal4 = 1027.0 _d 0 * 6.0 _d -3 * tmpscal4
C          magnitude of compined stresses:
           tmpscal0 =
     &         ( tmpscal1 * uRelW(i,j) + tmpscal4 * tmpscal2 )**2
     &       + ( tmpscal1 * vRelW(i,j) + tmpscal4 * tmpscal3 )**2
           IF ( tmpscal0 .LE. SEAICE_EPS_SQ ) THEN
             tmpscal0=SEAICE_EPS
           ELSE
             tmpscal0=SQRT(tmpscal0)
           ENDIF
C
C          mean grid cell width between tracer points
           tmpscal3 = 0.5 _d 0 * (dxC(i,j,bi,bj)+dyC(i,j,bi,bj))
C          grease ice volume Vg [m^3/m] as in Smedsrud [2011]
C           is SItracer * gridcell_area / lead_width
C           where lead width is lead extent along lead,
C           i.e. perpendicular to L_lead in Smedsrud (2011),
C           which is in the absence of lead length statistics
C           simply the grid cell length
           tmpscal4 = 4. _d 0 * SItracer(i,j,bi,bj,iTrGrease) * tmpscal3
C
C          mean grease ice layer thickness <h_g>, Eq.10 in Smedsrud [2011] but incl. water stress
           greaseLayerThick(i,j) = 0.763 _d 0
C          grease ice volume
     &           * ( tmpscal4
C          times magnitude of vector sum of air and water stresses
C          (in fact, only the component perpendicular to the lead edge, i.e. along L_lead counts)
C          ATTENTION: since we do not have lead orientation with respect to wind
C                     we use 80% of the total force assuming angles 45-90deg between wind and lead edge
     &           * 0.8 _d 0 * tmpscal0
C          devided by K_r = 100 N/m^3 (resistance of grease against compression)
     &           * 0.01 _d 0 )**THIRD
C
C          assure a minimum thickness of 4 cm (equals HO=0.01):
           greaseLayerThick(i,j)=max(4. _d -2, greaseLayerThick(i,j))
C          ... and a maximum thickness of 4 m (equals HO=1.0):
           greaseLayerThick(i,j)=min(4. _d 0 , greaseLayerThick(i,j))
C
          ENDDO
         ENDDO
#endif /* SEAICE_GREASE */

C compute snow/ice tendency due to sublimation
C ============================================

#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE hsnow(:,:,bi,bj) = comlev1_bibj,key=tkey,byte=isbyte
CADJ STORE r_FWbySublim     = comlev1_bibj,key=tkey,byte=isbyte
#endif /* ALLOW_AUTODIFF_TAMC */
#ifdef SEAICE_ITD
        DO IT=1,SEAICE_multDim
#endif /* SEAICE_ITD */
        DO j=1,sNy
         DO i=1,sNx
C     First sublimate/deposite snow
          tmpscal2 =
#ifdef SEAICE_ITD
     &     MAX(MIN(r_FWbySublimMult(i,j,IT),HSNOWITD(i,j,IT,bi,bj)
     &             *SNOW2ICE),ZERO)
          d_HSNWbySublim_ITD(i,j,IT) = - tmpscal2 * ICE2SNOW
C         accumulate change over ITD categories
          d_HSNWbySublim(i,j)     = d_HSNWbySublim(i,j)      - tmpscal2
     &                                                       *ICE2SNOW
          r_FWbySublimMult(i,j,IT)= r_FWbySublimMult(i,j,IT) - tmpscal2
#else /* ndef SEAICE_ITD */
     &     MAX(MIN(r_FWbySublim(i,j),HSNOW(i,j,bi,bj)*SNOW2ICE),ZERO)
          d_HSNWbySublim(i,j) = - tmpscal2 * ICE2SNOW
          HSNOW(i,j,bi,bj)    = HSNOW(i,j,bi,bj)  - tmpscal2*ICE2SNOW
          r_FWbySublim(i,j)   = r_FWbySublim(i,j) - tmpscal2
#endif /* SEAICE_ITD */
         ENDDO
        ENDDO
#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE heff(:,:,bi,bj) = comlev1_bibj,key=tkey,byte=isbyte
CADJ STORE r_FWbySublim    = comlev1_bibj,key=tkey,byte=isbyte
#endif /* ALLOW_AUTODIFF_TAMC */
        DO j=1,sNy
         DO i=1,sNx
C     If anything is left, sublimate ice
          tmpscal2 =
#ifdef SEAICE_ITD
     &     MAX(MIN(r_FWbySublimMult(i,j,IT),HEFFITD(i,j,IT,bi,bj)),ZERO)
          d_HEFFbySublim_ITD(i,j,IT) = - tmpscal2
C         accumulate change over ITD categories
          d_HEFFbySublim(i,j)      = d_HEFFbySublim(i,j)      - tmpscal2
          r_FWbySublimMult(i,j,IT) = r_FWbySublimMult(i,j,IT) - tmpscal2
#else /* ndef SEAICE_ITD */
     &     MAX(MIN(r_FWbySublim(i,j),HEFF(i,j,bi,bj)),ZERO)
          d_HEFFbySublim(i,j) = - tmpscal2
          HEFF(i,j,bi,bj)     = HEFF(i,j,bi,bj)   - tmpscal2
          r_FWbySublim(i,j)   = r_FWbySublim(i,j) - tmpscal2
#endif /* SEAICE_ITD */
         ENDDO
        ENDDO
        DO j=1,sNy
         DO i=1,sNx
C     If anything is left, it will be evaporated from the ocean rather than sublimated.
C     Since a_QbyATM_cover was computed for sublimation, not simple evaporation, we need to
C     remove the fusion part for the residual (that happens to be precisely r_FWbySublim).
#ifdef SEAICE_ITD
          a_QbyATMmult_cover(i,j,IT) = a_QbyATMmult_cover(i,j,IT)
     &                               - r_FWbySublimMult(i,j,IT)
          r_QbyATMmult_cover(i,j,IT) = r_QbyATMmult_cover(i,j,IT)
     &                               - r_FWbySublimMult(i,j,IT)
#else /* ndef SEAICE_ITD */
          a_QbyATM_cover(i,j) = a_QbyATM_cover(i,j)-r_FWbySublim(i,j)
          r_QbyATM_cover(i,j) = r_QbyATM_cover(i,j)-r_FWbySublim(i,j)
#endif /* SEAICE_ITD */
         ENDDO
        ENDDO
#ifdef SEAICE_ITD
C       end IT loop
        ENDDO
#endif /* SEAICE_ITD */

C compute ice thickness tendency due to ice-ocean interaction
C ===========================================================

#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE heff(:,:,bi,bj) = comlev1_bibj,key=tkey,byte=isbyte
CADJ STORE r_QbyOCN = comlev1_bibj,key=tkey,byte=isbyte
#endif /* ALLOW_AUTODIFF_TAMC */

       IF (.NOT.SEAICE_growMeltByConv) THEN

#ifdef SEAICE_ITD
        DO IT=1,SEAICE_multDim
         DO j=1,sNy
          DO i=1,sNx
C          ice growth/melt due to ocean heat r_QbyOCN (W/m^2) is
C          equally distributed under the ice and hence weighted by
C          fractional area of each thickness category
           tmpscal1=MAX(r_QbyOCN(i,j)*areaFracFactor(i,j,IT),
     &                               -HEFFITD(i,j,IT,bi,bj))
           d_HEFFbyOCNonICE_ITD(i,j,IT)=tmpscal1
           d_HEFFbyOCNonICE(i,j) = d_HEFFbyOCNonICE(i,j) + tmpscal1
          ENDDO
         ENDDO
        ENDDO
#ifdef ALLOW_SITRACER
        DO j=1,sNy
         DO i=1,sNx
          SItrHEFF(i,j,bi,bj,2) = HEFFpreTH(i,j)
     &                          + d_HEFFbySublim(i,j)
     &                          + d_HEFFbyOCNonICE(i,j)
         ENDDO
        ENDDO
#endif
        DO j=1,sNy
         DO i=1,sNx
          r_QbyOCN(i,j)=r_QbyOCN(i,j)-d_HEFFbyOCNonICE(i,j)
         ENDDO
        ENDDO
#else /* SEAICE_ITD */
        DO j=1,sNy
         DO i=1,sNx
          d_HEFFbyOCNonICE(i,j)=MAX(r_QbyOCN(i,j), -HEFF(i,j,bi,bj))
          r_QbyOCN(i,j)=r_QbyOCN(i,j)-d_HEFFbyOCNonICE(i,j)
          HEFF(i,j,bi,bj)=HEFF(i,j,bi,bj) + d_HEFFbyOCNonICE(i,j)
#ifdef ALLOW_SITRACER
          SItrHEFF(i,j,bi,bj,2)=HEFF(i,j,bi,bj)
#endif
         ENDDO
        ENDDO
#endif /* SEAICE_ITD */

      ENDIF !SEAICE_growMeltByConv

C compute snow melt tendency due to snow-atmosphere interaction
C ==================================================================

#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE hsnow(:,:,bi,bj) = comlev1_bibj,key=tkey,byte=isbyte
CADJ STORE r_QbyATM_cover = comlev1_bibj,key=tkey,byte=isbyte
#endif /* ALLOW_AUTODIFF_TAMC */

#ifdef SEAICE_ITD
        DO IT=1,SEAICE_multDim
         DO j=1,sNy
          DO i=1,sNx
C     Convert to standard units (meters of ice) rather than to meters
C     of snow. This appears to be more robust.
           tmpscal1=MAX(r_QbyATMmult_cover(i,j,IT),
     &                  -HSNOWITD(i,j,IT,bi,bj)*SNOW2ICE)
           tmpscal2=MIN(tmpscal1,0. _d 0)
#ifdef SEAICE_MODIFY_GROWTH_ADJ
Cgf no additional dependency through snow
           IF ( SEAICEadjMODE.GE.2 ) tmpscal2 = 0. _d 0
#endif
           d_HSNWbyATMonSNW_ITD(i,j,IT) = tmpscal2*ICE2SNOW
           d_HSNWbyATMonSNW(i,j) = d_HSNWbyATMonSNW(i,j)
     &                           + tmpscal2*ICE2SNOW
           r_QbyATMmult_cover(i,j,IT)=r_QbyATMmult_cover(i,j,IT)
     &                           - tmpscal2
          ENDDO
         ENDDO
        ENDDO
#else /* SEAICE_ITD */
        DO j=1,sNy
         DO i=1,sNx
C     Convert to standard units (meters of ice) rather than to meters
C     of snow. This appears to be more robust.
          tmpscal1=MAX(r_QbyATM_cover(i,j),-HSNOW(i,j,bi,bj)*SNOW2ICE)
          tmpscal2=MIN(tmpscal1,0. _d 0)
#ifdef SEAICE_MODIFY_GROWTH_ADJ
Cgf no additional dependency through snow
          IF ( SEAICEadjMODE.GE.2 ) tmpscal2 = 0. _d 0
#endif
          d_HSNWbyATMonSNW(i,j)= tmpscal2*ICE2SNOW
          HSNOW(i,j,bi,bj) = HSNOW(i,j,bi,bj) + tmpscal2*ICE2SNOW
          r_QbyATM_cover(i,j)=r_QbyATM_cover(i,j) - tmpscal2
         ENDDO
        ENDDO
#endif /* SEAICE_ITD */

C compute ice thickness tendency due to the atmosphere
C ====================================================

#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE heff(:,:,bi,bj) = comlev1_bibj,key=tkey,byte=isbyte
CADJ STORE r_QbyATM_cover  = comlev1_bibj,key=tkey,byte=isbyte
#endif /* ALLOW_AUTODIFF_TAMC */

Cgf note: this block is not actually tested by lab_sea
Cgf where all experiments start in January. So even though
Cgf the v1.81=>v1.82 revision would change results in
Cgf warming conditions, the lab_sea results were not changed.

#ifdef SEAICE_ITD
        DO IT=1,SEAICE_multDim
         DO j=1,sNy
          DO i=1,sNx
           tmpscal1 = HEFFITDpreTH(i,j,IT)
     &              + d_HEFFbySublim_ITD(i,j,IT)
     &              + d_HEFFbyOCNonICE_ITD(i,j,IT)
           tmpscal2 = MAX(-tmpscal1,
     &                     r_QbyATMmult_cover(i,j,IT)
C         Limit ice growth by potential melt by ocean
     &              + AREAITDpreTH(i,j,IT) * r_QbyOCN(i,j))
           d_HEFFbyATMonOCN_cover_ITD(i,j,IT) = tmpscal2
           d_HEFFbyATMonOCN_cover(i,j) = d_HEFFbyATMonOCN_cover(i,j)
     &                                 + tmpscal2
           d_HEFFbyATMonOCN_ITD(i,j,IT) = d_HEFFbyATMonOCN_ITD(i,j,IT)
     &                                 + tmpscal2
           d_HEFFbyATMonOCN(i,j)       = d_HEFFbyATMonOCN(i,j)
     &                                 + tmpscal2
           r_QbyATMmult_cover(i,j,IT)  = r_QbyATMmult_cover(i,j,IT)
     &                                 - tmpscal2
          ENDDO
         ENDDO
        ENDDO
#ifdef ALLOW_SITRACER
        DO j=1,sNy
         DO i=1,sNx
          SItrHEFF(i,j,bi,bj,3) = SItrHEFF(i,j,bi,bj,2)
     &                          + d_HEFFbyATMonOCN_cover(i,j)
         ENDDO
        ENDDO
#endif
#else /* ndef SEAICE_ITD */
        DO j=1,sNy
         DO i=1,sNx

          tmpscal2 = MAX(-HEFF(i,j,bi,bj),r_QbyATM_cover(i,j)+
C         Limit ice growth by potential melt by ocean
     &        AREApreTH(i,j) * r_QbyOCN(i,j))

          d_HEFFbyATMonOCN_cover(i,j)=tmpscal2
          d_HEFFbyATMonOCN(i,j)=d_HEFFbyATMonOCN(i,j)+tmpscal2
          r_QbyATM_cover(i,j)=r_QbyATM_cover(i,j)-tmpscal2
          HEFF(i,j,bi,bj) = HEFF(i,j,bi,bj) + tmpscal2

#ifdef ALLOW_SITRACER
          SItrHEFF(i,j,bi,bj,3)=HEFF(i,j,bi,bj)
#endif
         ENDDO
        ENDDO
#endif /* SEAICE_ITD */

C add snow precipitation to HSNOW.
C =================================================
#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE a_QbyATM_cover = comlev1_bibj,key=tkey,byte=isbyte
CADJ STORE PRECIP(:,:,bi,bj) = comlev1_bibj,key=tkey,byte=isbyte
CADJ STORE AREApreTH = comlev1_bibj,key=tkey,byte=isbyte
#endif /* ALLOW_AUTODIFF_TAMC */
        IF ( snowPrecipFile .NE. ' ' ) THEN
C add snowPrecip to HSNOW
         DO j=1,sNy
          DO i=1,sNx
           d_HSNWbyRAIN(i,j) = convertPRECIP2HI * ICE2SNOW *
     &          snowPrecip(i,j,bi,bj) * AREApreTH(i,j)
           d_HFRWbyRAIN(i,j) = -convertPRECIP2HI *
     &          ( PRECIP(i,j,bi,bj) - snowPrecip(i,j,bi,bj) ) *
     &          AREApreTH(i,j)
           HSNOW(i,j,bi,bj) = HSNOW(i,j,bi,bj) + d_HSNWbyRAIN(i,j)
          ENDDO
         ENDDO
        ELSE
C attribute precip to fresh water or snow stock,
C depending on atmospheric conditions.
         DO j=1,sNy
          DO i=1,sNx
C possible alternatives to the a_QbyATM_cover criterium
c          IF (tIce(I,J,bi,bj) .LT. TMIX) THEN ! would require computing tIce
c          IF (atemp(I,J,bi,bj) .LT. celsius2K) THEN
           IF ( a_QbyATM_cover(i,j).GE. 0. _d 0 ) THEN
C           add precip as snow
            d_HFRWbyRAIN(i,j)=0. _d 0
            d_HSNWbyRAIN(i,j)=convertPRECIP2HI*ICE2SNOW*
     &            PRECIP(i,j,bi,bj)*AREApreTH(i,j)
           ELSE
C           add precip to the fresh water bucket
            d_HFRWbyRAIN(i,j)=-convertPRECIP2HI*
     &            PRECIP(i,j,bi,bj)*AREApreTH(i,j)
            d_HSNWbyRAIN(i,j)=0. _d 0
           ENDIF
         ENDDO
        ENDDO
#ifdef SEAICE_ITD
        DO IT=1,SEAICE_multDim
         DO j=1,sNy
          DO i=1,sNx
           d_HSNWbyRAIN_ITD(i,j,IT)
     &     = d_HSNWbyRAIN(i,j)*areaFracFactor(i,j,IT)
          ENDDO
         ENDDO
        ENDDO
#else /* ndef SEAICE_ITD */
        DO j=1,sNy
         DO i=1,sNx
          HSNOW(i,j,bi,bj) = HSNOW(i,j,bi,bj) + d_HSNWbyRAIN(i,j)
         ENDDO
        ENDDO
#endif /* SEAICE_ITD */
Cgf note: this does not affect air-sea heat flux,
Cgf since the implied air heat gain to turn
Cgf rain to snow is not a surface process.
C end of IF statement snowPrecipFile:
        ENDIF

C compute snow melt due to heat available from ocean.
C =================================================================

Cgf do we need to keep this comment and cpp bracket?
Cph( very sensitive bit here by JZ
#ifndef SEAICE_EXCLUDE_FOR_EXACT_AD_TESTING
#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE HSNOW(:,:,bi,bj) = comlev1_bibj,key=tkey,byte=isbyte
CADJ STORE r_QbyOCN = comlev1_bibj,key=tkey,byte=isbyte
#endif /* ALLOW_AUTODIFF_TAMC */

      IF (.NOT.SEAICE_growMeltByConv) THEN

#ifdef SEAICE_ITD
        DO IT=1,SEAICE_multDim
         DO j=1,sNy
          DO i=1,sNx
           tmpscal4 = HSNWITDpreTH(i,j,IT)
     &              + d_HSNWbySublim_ITD(i,j,IT)
     &              + d_HSNWbyATMonSNW_ITD(i,j,IT)
     &              + d_HSNWbyRAIN_ITD(i,j,IT)
           tmpscal1=MAX(r_QbyOCN(i,j)*ICE2SNOW*areaFracFactor(i,j,IT),
     &                  -tmpscal4)
           tmpscal2=MIN(tmpscal1,0. _d 0)
#ifdef SEAICE_MODIFY_GROWTH_ADJ
Cgf no additional dependency through snow
           IF ( SEAICEadjMODE.GE.2 ) tmpscal2 = 0. _d 0
#endif
           d_HSNWbyOCNonSNW_ITD(i,j,IT) = tmpscal2
           d_HSNWbyOCNonSNW(i,j) = d_HSNWbyOCNonSNW(i,j) + tmpscal2
           r_QbyOCN(i,j)=r_QbyOCN(i,j) - tmpscal2*SNOW2ICE
          ENDDO
         ENDDO
        ENDDO
#else /* ndef SEAICE_ITD */
        DO j=1,sNy
         DO i=1,sNx
          tmpscal1=MAX(r_QbyOCN(i,j)*ICE2SNOW, -HSNOW(i,j,bi,bj))
          tmpscal2=MIN(tmpscal1,0. _d 0)
#ifdef SEAICE_MODIFY_GROWTH_ADJ
Cgf no additional dependency through snow
          IF ( SEAICEadjMODE.GE.2 ) tmpscal2 = 0. _d 0
#endif
          d_HSNWbyOCNonSNW(i,j) = tmpscal2
          r_QbyOCN(i,j)=r_QbyOCN(i,j)
     &                               -d_HSNWbyOCNonSNW(i,j)*SNOW2ICE
          HSNOW(i,j,bi,bj) = HSNOW(i,j,bi,bj)+d_HSNWbyOCNonSNW(i,j)
         ENDDO
        ENDDO
#endif /* SEAICE_ITD */

      ENDIF !SEAICE_growMeltByConv

#endif /* SEAICE_EXCLUDE_FOR_EXACT_AD_TESTING */
Cph)

C gain of new ice over open water
C ===============================
#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE heff(:,:,bi,bj) = comlev1_bibj,key=tkey,byte=isbyte
CADJ STORE r_QbyATM_open = comlev1_bibj,key=tkey,byte=isbyte
CADJ STORE r_QbyOCN = comlev1_bibj,key=tkey,byte=isbyte
CADJ STORE a_QSWbyATM_cover = comlev1_bibj,key=tkey,byte=isbyte
CADJ STORE a_QSWbyATM_open = comlev1_bibj,key=tkey,byte=isbyte
#endif /* ALLOW_AUTODIFF_TAMC */

        DO j=1,sNy
         DO i=1,sNx
#ifdef SEAICE_ITD
C     HEFF will be updated at the end of PART 3,
C     hence sum of tendencies so far is needed
          tmpscal4 = HEFFpreTH(i,j)
     &             + d_HEFFbySublim(i,j)
     &             + d_HEFFbyOCNonICE(i,j)
     &             + d_HEFFbyATMonOCN(i,j)
#else /* ndef SEAICE_ITD */
C     HEFF is updated step by step throughout seaice_growth
          tmpscal4 = HEFF(i,j,bi,bj)
#endif /* SEAICE_ITD */
C     Initial ice growth is triggered by open water
C     heat flux overcoming potential melt by ocean
          tmpscal1=r_QbyATM_open(i,j)+r_QbyOCN(i,j) *
     &         (1.0 _d 0 - AREApreTH(i,j))
C     Penetrative shortwave flux beyond first layer
C     that is therefore not available to ice growth/melt
#ifdef SHORTWAVE_HEATING
C     Here we do not use the runtime parameter within the i/j-loops for
C     better performance. If selectPenetratingSW < 1, then
C     SWFrac3D(kSrfS) = 0 anyway.
          tmpscal2 = SWFrac3D(i,j,kSrfS,bi,bj) * a_QSWbyATM_open(i,j)
#else
          tmpscal2 = 0. _d 0
#endif
C     impose -HEFF as the maxmum melting if SEAICE_doOpenWaterMelt
C     or 0. otherwise (no melting if not SEAICE_doOpenWaterMelt)
          tmpscal3=facOpenGrow*MAX(tmpscal1-tmpscal2,
     &         -tmpscal4*facOpenMelt)*HEFFM(i,j,bi,bj)
#if defined ( ALLOW_SITRACER ) && defined ( SEAICE_GREASE )
C     Grease ice is a tracer or "bucket" for newly formed frazil ice
C     that instead of becoming solid sea ice instantly has a half-time
C     of 1 day (see greaseDecayTime) before solidifying.
C     The most important effect is that for fluxes the grease ice
C     area/volume acts like open water.
C
C     store freezing/melting condition:
          greaseNewFrazil = max(0.0 _d 0, tmpscal3)
C
C 1) mechanical removal of grease by ridging:
C     if there is no open water left after advection, there cannot be
C     any grease ice
          IF ((1.0 _d 0 - AREApreTH(i,j)).LE.siEps) THEN
           tmpscal3 = tmpscal3 + SItracer(i,j,bi,bj,iTrGrease)
           SItracer(i,j,bi,bj,iTrGrease) = 0. _d 0

          ELSEIF (greaseNewFrazil .GT. 0. _d 0) THEN
C     new ice growth goes into grease tracer not HEFF:
           tmpscal3=0. _d 0
C
C 2) solidification of "old" grease ice
C     (only when cold enough for ice growth)
C
C     time scale dependent solidification
C     (50%  of grease ice area become solid ice within 24h):
           tmpscal1=exp(-SEAICE_deltaTtherm/greaseDecayTime)
C     gain in solid sea ice volume due to solidified grease:
           d_HEFFbyGREASE(i,j) =
     &             SItracer(i,j,bi,bj,iTrGrease)
     &           * (1.0 _d 0 - tmpscal1)
C     ... and related loss of grease ice (tracer) volume
           SItracer(i,j,bi,bj,iTrGrease) =
     &             SItracer(i,j,bi,bj,iTrGrease) * tmpscal1
C     the solidified grease ice volume needs to be added to HEFF:
           SItrBucket(i,j,bi,bj,iTrGrease) =
     &             SItrBucket(i,j,bi,bj,iTrGrease)
     &           + d_HEFFbyGREASE(i,j)
C
C 3) grease ice growth from new frazil ice:
C
           SItracer(i,j,bi,bj,iTrGrease) =
     &      SItracer(i,j,bi,bj,iTrGrease) + greaseNewFrazil
          ENDIF
C 4) mapping SItrBucket to external variable, in this case HEFF, ...
          tmpscal3=tmpscal3+SItrBucket(i,j,bi,bj,iTrGrease)
C     ... and empty SItrBucket for tracer 'grease'
          SItrBucket(i,j,bi,bj,iTrGrease)=0. _d 0
#endif /* SEAICE_GREASE */
#ifdef SEAICE_ITD
C     ice growth in open water adds to first category
          d_HEFFbyATMonOCN_open_ITD(i,j,1)=tmpscal3
          d_HEFFbyATMonOCN_ITD(i,j,1)     =d_HEFFbyATMonOCN_ITD(i,j,1)
     &                                    +tmpscal3
#endif /* SEAICE_ITD */
          d_HEFFbyATMonOCN_open(i,j)=tmpscal3
          d_HEFFbyATMonOCN(i,j)=d_HEFFbyATMonOCN(i,j)+tmpscal3
          r_QbyATM_open(i,j)=r_QbyATM_open(i,j)-tmpscal3
          HEFF(i,j,bi,bj) = HEFF(i,j,bi,bj) + tmpscal3
         ENDDO
        ENDDO

#ifdef ALLOW_SITRACER
        DO j=1,sNy
         DO i=1,sNx
C needs to be here to allow use also with LEGACY branch
#ifdef SEAICE_ITD
          SItrHEFF(i,j,bi,bj,4)=SItrHEFF(i,j,bi,bj,3)
     &                         +d_HEFFbyATMonOCN_open(i,j)
#else /* ndef SEAICE_ITD */
          SItrHEFF(i,j,bi,bj,4)=HEFF(i,j,bi,bj)
#endif /* SEAICE_ITD */
         ENDDO
        ENDDO
#endif /* ALLOW_SITRACER */

C convert snow to ice if submerged.
C =================================

C note: in legacy, this process is done at the end
#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE heff(:,:,bi,bj) = comlev1_bibj,key=tkey,byte=isbyte
CADJ STORE hsnow(:,:,bi,bj) = comlev1_bibj,key=tkey,byte=isbyte
#endif /* ALLOW_AUTODIFF_TAMC */
        IF ( SEAICEuseFlooding ) THEN
#ifdef SEAICE_ITD
         DO IT=1,SEAICE_multDim
          DO j=1,sNy
           DO i=1,sNx
            tmpscal3 = HEFFITDpreTH(i,j,IT)
     &               + d_HEFFbySublim_ITD(i,j,IT)
     &               + d_HEFFbyOCNonICE_ITD(i,j,IT)
     &               + d_HEFFbyATMonOCN_ITD(i,j,IT)
            tmpscal4 = HSNWITDpreTH(i,j,IT)
     &               + d_HSNWbySublim_ITD(i,j,IT)
     &               + d_HSNWbyATMonSNW_ITD(i,j,IT)
     &               + d_HSNWbyRAIN_ITD(i,j,IT)
            tmpscal0 = (tmpscal4*SEAICE_rhoSnow
     &               +  tmpscal3*SEAICE_rhoIce)
     &               * recip_rhoConst
            tmpscal1 = MAX( 0. _d 0, tmpscal0 - tmpscal3)
            d_HEFFbyFLOODING_ITD(i,j,IT) = tmpscal1
            d_HEFFbyFLOODING(i,j) = d_HEFFbyFLOODING(i,j)  + tmpscal1
           ENDDO
          ENDDO
         ENDDO
#else /* ndef SEAICE_ITD */
         DO j=1,sNy
          DO i=1,sNx
           tmpscal0 = (HSNOW(i,j,bi,bj)*SEAICE_rhoSnow
     &              +HEFF(i,j,bi,bj)*SEAICE_rhoIce)*recip_rhoConst
           tmpscal1 = MAX( 0. _d 0, tmpscal0 - HEFF(i,j,bi,bj))
           d_HEFFbyFLOODING(i,j)=tmpscal1
           HEFF(i,j,bi,bj) = HEFF(i,j,bi,bj)+d_HEFFbyFLOODING(i,j)
           HSNOW(i,j,bi,bj) = HSNOW(i,j,bi,bj)-
     &                           d_HEFFbyFLOODING(i,j)*ICE2SNOW
          ENDDO
         ENDDO
#endif /* SEAICE_ITD */
        ENDIF

#ifdef SEAICE_ITD
C apply ice and snow thickness changes
C =================================================================
         DO IT=1,SEAICE_multDim
          DO j=1,sNy
           DO i=1,sNx
            HEFFITD(i,j,IT,bi,bj) = HEFFITD(i,j,IT,bi,bj)
     &                            + d_HEFFbySublim_ITD(i,j,IT)
     &                            + d_HEFFbyOCNonICE_ITD(i,j,IT)
     &                            + d_HEFFbyATMonOCN_ITD(i,j,IT)
     &                            + d_HEFFbyFLOODING_ITD(i,j,IT)
            HSNOWITD(i,j,IT,bi,bj) = HSNOWITD(i,j,IT,bi,bj)
     &                            + d_HSNWbySublim_ITD(i,j,IT)
     &                            + d_HSNWbyATMonSNW_ITD(i,j,IT)
     &                            + d_HSNWbyRAIN_ITD(i,j,IT)
     &                            + d_HSNWbyOCNonSNW_ITD(i,j,IT)
     &                            - d_HEFFbyFLOODING_ITD(i,j,IT)
     &                            * ICE2SNOW
           ENDDO
          ENDDO
         ENDDO
#endif /* SEAICE_ITD */

C ===================================================================
C ==========PART 4: determine ice cover fraction increments=========-
C ===================================================================

#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE d_HEFFbyATMonOCN = comlev1_bibj,key=tkey,byte=isbyte
CADJ STORE d_HEFFbyATMonOCN_cover = comlev1_bibj,key=tkey,byte=isbyte
CADJ STORE d_HEFFbyATMonOCN_open = comlev1_bibj,key=tkey,byte=isbyte
CADJ STORE d_HEFFbyOCNonICE = comlev1_bibj,key=tkey,byte=isbyte
CADJ STORE recip_heffActual = comlev1_bibj,key=tkey,byte=isbyte
CADJ STORE d_hsnwbyatmonsnw = comlev1_bibj,key=tkey,byte=isbyte
cph(
cphCADJ STORE d_AREAbyATM  = comlev1_bibj,key=tkey,byte=isbyte
cphCADJ STORE d_AREAbyICE  = comlev1_bibj,key=tkey,byte=isbyte
cphCADJ STORE d_AREAbyOCN  = comlev1_bibj,key=tkey,byte=isbyte
cph)
CADJ STORE a_QbyATM_open = comlev1_bibj,key=tkey,byte=isbyte
CADJ STORE heffActual = comlev1_bibj,key=tkey,byte=isbyte
CADJ STORE AREApreTH = comlev1_bibj,key=tkey,byte=isbyte
CADJ STORE HEFF(:,:,bi,bj) = comlev1_bibj,key=tkey,byte=isbyte
CADJ STORE HSNOW(:,:,bi,bj) = comlev1_bibj,key=tkey,byte=isbyte
CADJ STORE AREA(:,:,bi,bj) = comlev1_bibj,key=tkey,byte=isbyte
#endif /* ALLOW_AUTODIFF_TAMC */

#ifdef SEAICE_ITD
C--   in thinnest category account for lateral ice growth and melt the
C--   "non-ITD" way, so that the ITD simulation with SEAICE_multDim=1
C--   is identical with the non-ITD simulation;
C--   use HEFF, ARE, HSNOW, etc. as temporal storage for 1st category
        DO j=1,sNy
         DO i=1,sNx
          HEFF(i,j,bi,bj)=HEFFITD(i,j,1,bi,bj)
          AREA(i,j,bi,bj)=AREAITD(i,j,1,bi,bj)
          HSNOW(i,j,bi,bj)=HSNOWITD(i,j,1,bi,bj)
          HEFFpreTH(i,j)=HEFFITDpreTH(i,j,1)
          AREApreTH(i,j)=AREAITDpreTH(i,j,1)
          recip_heffActual(i,j)=recip_heffActualMult(i,j,1)
         ENDDO
        ENDDO
#endif /* SEAICE_ITD */
        DO j=1,sNy
         DO i=1,sNx

#if defined ( ALLOW_SITRACER ) && defined ( SEAICE_GREASE )
C         grease ice layer thickness (Hg) includes
C         1 part frazil ice and 3 parts sea water
C         i.e. HO = 0.25 * Hg
          recip_HO=4. _d 0 / greaseLayerThick(i,j)
#else /* SEAICE_GREASE */
          IF ( YC(i,j,bi,bj) .LT. ZERO ) THEN
           recip_HO=1. _d 0 / HO_south
          ELSE
           recip_HO=1. _d 0 / HO
          ENDIF
#endif /* SEAICE_GREASE */
          recip_HH = recip_heffActual(i,j)

C gain of ice over open water : computed from
#if defined ( ALLOW_SITRACER ) && defined ( SEAICE_GREASE )
C   from growth by ATM with grease ice time delay
          tmpscal4 = MAX(ZERO,d_HEFFbyGREASE(i,j))
#else /* SEAICE_GREASE */
C   (SEAICE_areaGainFormula.EQ.1) from growth by ATM
C   (SEAICE_areaGainFormula.EQ.2) from predicted growth by ATM
          IF (SEAICE_areaGainFormula.EQ.1) THEN
            tmpscal4 = MAX(ZERO,d_HEFFbyATMonOCN_open(i,j))
          ELSE
            tmpscal4=MAX(ZERO,a_QbyATM_open(i,j))
          ENDIF
#endif /* SEAICE_GREASE */

C loss of ice cover by melting : computed from
C   (SEAICE_areaLossFormula.EQ.1) from all but only melt conributions by ATM and OCN
C   (SEAICE_areaLossFormula.EQ.2) from net melt-growth>0 by ATM and OCN
C   (SEAICE_areaLossFormula.EQ.3) from predicted melt by ATM
          IF (SEAICE_areaLossFormula.EQ.1) THEN
            tmpscal3 = MIN( 0. _d 0 , d_HEFFbyATMonOCN_cover(i,j) )
     &        + MIN( 0. _d 0 , d_HEFFbyATMonOCN_open(i,j) )
     &        + MIN( 0. _d 0 , d_HEFFbyOCNonICE(i,j) )
          ELSEIF (SEAICE_areaLossFormula.EQ.2) THEN
            tmpscal3 = MIN( 0. _d 0 , d_HEFFbyATMonOCN_cover(i,j)
     &        + d_HEFFbyATMonOCN_open(i,j) + d_HEFFbyOCNonICE(i,j) )
          ELSE
C           compute heff after ice melt by ocn:
            tmpscal0=HEFF(i,j,bi,bj) - d_HEFFbyATMonOCN(i,j)
C           compute available heat left after snow melt by atm:
            tmpscal1= a_QbyATM_open(i,j)+a_QbyATM_cover(i,j)
     &            - d_HSNWbyATMonSNW(i,j)*SNOW2ICE
C           could not melt more than all the ice
            tmpscal2 = MAX(-tmpscal0,tmpscal1)
            tmpscal3 = MIN(ZERO,tmpscal2)
          ENDIF

C apply tendency
          IF ( (HEFF(i,j,bi,bj).GT.0. _d 0).OR.
     &        (HSNOW(i,j,bi,bj).GT.0. _d 0) ) THEN
           AREA(i,j,bi,bj)=MAX(0. _d 0,
     &      MIN( SEAICE_area_max, AREA(i,j,bi,bj)
     &       + recip_HO*tmpscal4+HALF*recip_HH*tmpscal3
     &       * areaPDFfac ))
          ELSE
           AREA(i,j,bi,bj)=0. _d 0
          ENDIF
#ifdef ALLOW_SITRACER
          SItrAREA(i,j,bi,bj,3)=AREA(i,j,bi,bj)
#endif /* ALLOW_SITRACER */
#ifdef ALLOW_DIAGNOSTICS
          d_AREAbyATM(i,j)=
     &       recip_HO*MAX(ZERO,d_HEFFbyATMonOCN_open(i,j))
     &       +HALF*recip_HH*MIN(0. _d 0,d_HEFFbyATMonOCN_open(i,j))
     &       *areaPDFfac
          d_AREAbyICE(i,j)=
     &        HALF*recip_HH*MIN(0. _d 0,d_HEFFbyATMonOCN_cover(i,j))
     &       *areaPDFfac
          d_AREAbyOCN(i,j)=
     &        HALF*recip_HH*MIN( 0. _d 0,d_HEFFbyOCNonICE(i,j) )
     &       *areaPDFfac
#endif /* ALLOW_DIAGNOSTICS */
         ENDDO
        ENDDO
#ifdef SEAICE_ITD
C       transfer 1st category values back into ITD variables
        DO j=1,sNy
         DO i=1,sNx
          HEFFITD(i,j,1,bi,bj)=HEFF(i,j,bi,bj)
          AREAITD(i,j,1,bi,bj)=AREA(i,j,bi,bj)
          HSNOWITD(i,j,1,bi,bj)=HSNOW(i,j,bi,bj)
         ENDDO
        ENDDO
C       now melt ice laterally in all other thickness categories
C       (areal growth, i.e. new ice formation, only occurrs in 1st category)
        IF (SEAICE_multDim .GT. 1) THEN
         DO IT=2,SEAICE_multDim
          DO j=1,sNy
           DO i=1,sNx
            IF (HEFFITD(i,j,IT,bi,bj).LE.ZERO) THEN
C       when thickness is zero, area should be zero, too:
             AREAITD(i,j,IT,bi,bj)=ZERO
            ELSE
C     tmpscal1 is the minimal ice concentration after lateral melt that will
C     not lead to an unphysical increase of ice thickness by lateral melt;
C     estimated as the concentration before thermodynamics scaled by the
C     ratio of new ice thickness and ice thickness before thermodynamics
             IF ( HEFFITDpreTH(i,j,IT).LE.ZERO ) THEN
              tmpscal1=0. _d 0
             ELSE
              tmpscal1=AREAITDpreTH(i,j,IT)*
     &             HEFFITD(i,j,IT,bi,bj)/HEFFITDpreTH(i,j,IT)
             ENDIF
C       melt ice laterally based on an average floe sice
C       following Steele (1992)
             AREAITD(i,j,IT,bi,bj) = AREAITD(i,j,IT,bi,bj)
     &                             * (ONE - latMeltFrac(i,j,IT))
CML   not necessary:
CML          AREAITD(I,J,IT,bi,bj) = max(ZERO,AREAITD(I,J,IT,bi,bj))
C       limit area reduction so that actual ice thickness does not increase
             AREAITD(i,j,IT,bi,bj) = max(AREAITD(i,j,IT,bi,bj),
     &                                   tmpscal1)
            ENDIF
#ifdef ALLOW_SITRACER
            SItrAREA(i,j,bi,bj,3)=SItrAREA(i,j,bi,bj,3)
     &                           +AREAITD(i,j,IT,bi,bj)
#endif /* ALLOW_SITRACER */
           ENDDO
          ENDDO
         ENDDO
        ENDIF
#endif /* SEAICE_ITD */

#if (defined ALLOW_AUTODIFF && defined SEAICE_MODIFY_GROWTH_ADJ)
Cgf 'bulk' linearization of area=f(HEFF)
        IF ( SEAICEadjMODE.GE.1 ) THEN
#ifdef SEAICE_ITD
         DO IT=1,SEAICE_multDim
          DO j=1,sNy
           DO i=1,sNx
            AREAITD(i,j,IT,bi,bj) = AREAITDpreTH(i,j,IT) + 0.1 _d 0 *
     &               ( HEFFITD(i,j,IT,bi,bj) - HEFFITDpreTH(i,j,IT) )
           ENDDO
          ENDDO
         ENDDO
#else /* ndef SEAICE_ITD */
         DO j=1,sNy
          DO i=1,sNx
C            AREA(I,J,bi,bj) = 0.1 _d 0 * HEFF(I,J,bi,bj)
           AREA(i,j,bi,bj) = AREApreTH(i,j) + 0.1 _d 0 *
     &               ( HEFF(i,j,bi,bj) - HEFFpreTH(i,j) )
          ENDDO
         ENDDO
#endif /* SEAICE_ITD */
        ENDIF
#endif
#ifdef SEAICE_ITD
C check categories for consistency with limits after growth/melt ...
        IF ( SEAICEuseLinRemapITD ) CALL SEAICE_ITD_REMAP(
     I     heffitdPreTH, areaitdPreTH,
     I     bi, bj, myTime, myIter, myThid )
        CALL SEAICE_ITD_REDIST(bi, bj, myTime, myIter, myThid)
C ... and update total AREA, HEFF, HSNOW
C     (the updated HEFF is used below for ice salinity increments)
        CALL SEAICE_ITD_SUM(bi, bj, myTime, myIter, myThid)
#endif /* SEAICE_ITD */
#if defined ( ALLOW_SITRACER ) && defined ( SEAICE_GREASE )
C convert SItracer 'grease' from grease ice volume back to ratio:
C ===============================================================
        DO j=1,sNy
         DO i=1,sNx
          IF (HEFF(i,j,bi,bj).GT.siEps) THEN
           SItracer(i,j,bi,bj,iTrGrease) =
     &      SItracer(i,j,bi,bj,iTrGrease) / HEFF(i,j,bi,bj)
          ELSE
           SItracer(i,j,bi,bj,iTrGrease) = 0. _d 0
          ENDIF
         ENDDO
        ENDDO
#endif /* SEAICE_GREASE */

C ===================================================================
C =============PART 5: determine ice salinity increments=============
C ===================================================================

#ifndef SEAICE_VARIABLE_SALINITY
# ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE d_HEFFbyNEG(:,:,bi,bj) = comlev1_bibj,
CADJ &                              key = tkey, byte = isbyte
#  ifdef ALLOW_SALT_PLUME
CADJ STORE d_HEFFbyOCNonICE = comlev1_bibj,key=tkey,byte=isbyte
CADJ STORE d_HEFFbyATMonOCN = comlev1_bibj,key=tkey,byte=isbyte
CADJ STORE d_HEFFbyATMonOCN_open = comlev1_bibj,key=tkey,byte=isbyte
CADJ STORE d_HEFFbyATMonOCN_cover = comlev1_bibj,key=tkey,byte=isbyte
CADJ STORE d_HEFFbyFLOODING = comlev1_bibj,key=tkey,byte=isbyte
CADJ STORE d_HEFFbySublim = comlev1_bibj,key=tkey,byte=isbyte
CADJ STORE salt(:,:,kSurface,bi,bj) = comlev1_bibj,
CADJ &                       key = tkey, byte = isbyte
#  endif /* ALLOW_SALT_PLUME */
# endif /* ALLOW_AUTODIFF_TAMC */
        DO j=1,sNy
         DO i=1,sNx
          tmpscal1 = d_HEFFbyNEG(i,j,bi,bj) + d_HEFFbyOCNonICE(i,j) +
     &               d_HEFFbyATMonOCN(i,j) + d_HEFFbyFLOODING(i,j)
     &             + d_HEFFbySublim(i,j)
#ifdef EXF_SEAICE_FRACTION
     &             + d_HEFFbyRLX(i,j,bi,bj)
#endif
Catn: can not take out more that surface salinity when SSS<SEAICE_salt0
          tmpscal3 = max( 0. _d 0,
     &                    min(SEAICE_salt0,salt(i,j,kSurface,bi,bj)) )
          tmpscal2 = tmpscal1 * tmpscal3 * HEFFM(i,j,bi,bj)
     &            * recip_deltaTtherm * SEAICE_rhoIce
          saltFlux(i,j,bi,bj) = tmpscal2
#ifdef ALLOW_SALT_PLUME
#ifdef SALT_PLUME_SPLIT_BASIN
catn attempt to split East/West basins in Arctic
          localSPfrac(i,j) = SPsalFRAC(1)
          IF ( SaltPlumeSplitBasin ) THEN
            localSPfrac(i,j) = SPsalFRAC(2)
            IF(YC(i,j,bi,bj).LT. 85.0 .AND. YC(i,j,bi,bj).GT. 71.0
     &       .AND. XC(i,j,bi,bj) .LT. -90.0) THEN
             localSPfrac(i,j) = SPsalFRAC(1)
            ENDIF
          ENDIF
#else
          localSPfrac(i,j) = SPsalFRAC
#endif /* SALT_PLUME_SPLIT_BASIN */
#ifdef SALT_PLUME_IN_LEADS
Catn: Only d_HEFFbyATMonOCN should contribute to plume.
C     By redefining tmpscal1 here, saltPlumeFlux is smaller in case
C     define inLeads than case undef inLeads.  Physical interpretation
C     is that when d_HEFF is formed from below via ocean freezing, it
C     occurs more uniform over grid cell and not inLeads, thus not
C     participating in pkg/salt_plume.
C     Note: tmpscal1 is defined only after saltFlux is calculated.
          IceGrowthRateInLeads(i,j)=max(0. _d 0,d_HEFFbyATMonOCN(i,j))
          tmpscal1 = IceGrowthRateInLeads(i,j)
          leadPlumeFraction(i,j) =
     &      (ONE + EXP( (SPinflectionPoint - AREApreTH(i,j))*5.0
     &                 /(ONE - SPinflectionPoint) ))**(-ONE)
          localSPfrac(i,j)=localSPfrac(i,j)*leadPlumeFraction(i,j)
#endif /* SALT_PLUME_IN_LEADS */
          tmpscal3 = tmpscal1*salt(i,j,kSurface,bi,bj)*HEFFM(i,j,bi,bj)
     &            * recip_deltaTtherm * SEAICE_rhoIce
          saltPlumeFlux(i,j,bi,bj) = MAX( tmpscal3-tmpscal2 , 0. _d 0)
     &            *localSPfrac(i,j)
C if SaltPlumeSouthernOcean=.FALSE. turn off salt plume in Southern Ocean
          IF ( .NOT. SaltPlumeSouthernOcean ) THEN
           IF ( YC(i,j,bi,bj) .LT. 0.0 _d 0 )
     &          saltPlumeFlux(i,j,bi,bj) = 0.0 _d 0
          ENDIF
#endif /* ALLOW_SALT_PLUME */
         ENDDO
        ENDDO
#endif /* ndef SEAICE_VARIABLE_SALINITY */

#ifdef SEAICE_VARIABLE_SALINITY

#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE hsalt(:,:,bi,bj) = comlev1_bibj,key=tkey,byte=isbyte
#endif /* ALLOW_AUTODIFF_TAMC */

        DO j=1,sNy
         DO i=1,sNx
C sum up the terms that affect the salt content of the ice pack
         tmpscal1=d_HEFFbyOCNonICE(i,j)+d_HEFFbyATMonOCN(i,j)

C recompute HEFF before thermodynamic updates (which is not AREApreTH in legacy code)
         tmpscal2=HEFF(i,j,bi,bj)-tmpscal1-d_HEFFbyFLOODING(i,j)
C tmpscal1 > 0 : m of sea ice that is created
          IF ( tmpscal1 .GE. 0.0 ) THEN
             saltFlux(i,j,bi,bj) =
     &            HEFFM(i,j,bi,bj)*recip_deltaTtherm
     &            *SEAICE_saltFrac*salt(i,j,kSurface,bi,bj)
     &            *tmpscal1*SEAICE_rhoIce
#ifdef ALLOW_SALT_PLUME
#ifdef SALT_PLUME_SPLIT_BASIN
catn attempt to split East/West basins in Arctic
             localSPfrac(i,j) = SPsalFRAC(1)
             IF ( SaltPlumeSplitBasin ) THEN
               localSPfrac(i,j) = SPsalFRAC(2)
               IF(YC(i,j,bi,bj).LT. 85.0 .AND. YC(i,j,bi,bj).GT. 71.0
     &                  .AND. XC(i,j,bi,bj) .LT. -90.0) THEN
                 localSPfrac(i,j) = SPsalFRAC(1)
               ENDIF
             ENDIF
#else
             localSPfrac(i,j) = SPsalFRAC
#endif /* SALT_PLUME_SPLIT_BASIN */
#ifndef SALT_PLUME_IN_LEADS
C saltPlumeFlux is defined only during freezing:
             saltPlumeFlux(i,j,bi,bj)=
     &            HEFFM(i,j,bi,bj)*recip_deltaTtherm
     &            *(ONE-SEAICE_saltFrac)*salt(i,j,kSurface,bi,bj)
     &            *tmpscal1*SEAICE_rhoIce
     &            *localSPfrac(i,j)
#endif /* ndef SALT_PLUME_IN_LEADS */
#endif /* ALLOW_SALT_PLUME */

C tmpscal1 < 0 : m of sea ice that is melted
          ELSE
             saltFlux(i,j,bi,bj) =
     &         HEFFM(i,j,bi,bj)*recip_deltaTtherm
     &         *HSALT(i,j,bi,bj)
     &         *tmpscal1/tmpscal2
#ifdef ALLOW_SALT_PLUME
#ifndef SALT_PLUME_IN_LEADS
             saltPlumeFlux(i,j,bi,bj) = 0.0 _d 0
#endif /* ndef SALT_PLUME_IN_LEADS */
#endif /* ALLOW_SALT_PLUME */
          ENDIF

#ifdef ALLOW_SALT_PLUME
#ifdef SALT_PLUME_IN_LEADS
Catn: only d_HEFFbyATMonOCN should contribute to plume
C     By redefining tmpscal1 here, saltPlumeFlux is smaller in case
C     define inLeads than case undef inLeads.  Physical interpretation
C     is that when d_HEFF is formed from below via ocean freezing, it
C     occurs more uniform over grid cell and not inLeads, thus not
C     participating in pkg/salt_plume.
C     Note: tmpscal1 is defined only after saltFlux is calculated.
          IceGrowthRateInLeads(i,j)=max(0. _d 0,d_HEFFbyATMonOCN(i,j))
          tmpscal1 = IceGrowthRateInLeads(i,j)
          leadPlumeFraction(i,j) =
     &      (ONE + EXP( (SPinflectionPoint - AREApreTH(i,j))*5.0
     &                 /(ONE - SPinflectionPoint) ))**(-ONE)
          localSPfrac(i,j)=localSPfrac(i,j)*leadPlumeFraction(i,j)
          IF ( tmpscal1 .GE. 0.0) THEN
C saltPlumeFlux is defined only during freezing:
             saltPlumeFlux(i,j,bi,bj)=
     &            HEFFM(i,j,bi,bj)*recip_deltaTtherm
     &            *(ONE-SEAICE_saltFrac)*salt(i,j,kSurface,bi,bj)
     &            *tmpscal1*SEAICE_rhoIce
     &            *localSPfrac(i,j)
          ELSE
             saltPlumeFlux(i,j,bi,bj) = 0. _d 0
          ENDIF
#endif /* SALT_PLUME_IN_LEADS */
C if SaltPlumeSouthernOcean=.FALSE. turn off salt plume in Southern Ocean
          IF ( .NOT. SaltPlumeSouthernOcean ) THEN
           IF ( YC(i,j,bi,bj) .LT. 0.0 _d 0 )
     &          saltPlumeFlux(i,j,bi,bj) = 0.0 _d 0
          ENDIF
#endif /* ALLOW_SALT_PLUME */
C update HSALT based on surface saltFlux
          HSALT(i,j,bi,bj) = HSALT(i,j,bi,bj) +
     &         saltFlux(i,j,bi,bj) * SEAICE_deltaTtherm
          saltFlux(i,j,bi,bj) =
     &         saltFlux(i,j,bi,bj) + saltFluxAdjust(i,j,bi,bj)
         ENDDO
        ENDDO
#endif /* SEAICE_VARIABLE_SALINITY */

#ifdef ALLOW_SITRACER
        DO j=1,sNy
         DO i=1,sNx
C needs to be here to allow use also with LEGACY branch
          SItrHEFF(i,j,bi,bj,5)=HEFF(i,j,bi,bj)
         ENDDO
        ENDDO
#endif /* ALLOW_SITRACER */

C ===================================================================
C ==============PART 7: determine ocean model forcing================
C ===================================================================

C compute net heat flux leaving/entering the ocean,
C accounting for the part used in melt/freeze processes
C =====================================================

#ifdef SEAICE_ITD
C compute total of "mult" fluxes for ocean forcing
        DO j=1,sNy
         DO i=1,sNx
          a_QbyATM_cover(i,j)   = 0.0 _d 0
          r_QbyATM_cover(i,j)   = 0.0 _d 0
          a_QSWbyATM_cover(i,j) = 0.0 _d 0
          r_FWbySublim(i,j)     = 0.0 _d 0
         ENDDO
        ENDDO
        DO IT=1,SEAICE_multDim
         DO j=1,sNy
          DO i=1,sNx
C if fluxes in W/m^2 then use:
c           a_QbyATM_cover(I,J)=a_QbyATM_cover(I,J)
c     &      + a_QbyATMmult_cover(I,J,IT) * areaFracFactor(I,J,IT)
c           r_QbyATM_cover(I,J)=r_QbyATM_cover(I,J)
c     &      + r_QbyATMmult_cover(I,J,IT) * areaFracFactor(I,J,IT)
c           a_QSWbyATM_cover(I,J)=a_QSWbyATM_cover(I,J)
c     &      + a_QSWbyATMmult_cover(I,J,IT) * areaFracFactor(I,J,IT)
c           r_FWbySublim(I,J)=r_FWbySublim(I,J)
c     &      + r_FWbySublimMult(I,J,IT) * areaFracFactor(I,J,IT)
C if fluxes in effective ice meters, i.e. ice volume per area, then use:
           a_QbyATM_cover(i,j)=a_QbyATM_cover(i,j)
     &      + a_QbyATMmult_cover(i,j,IT)
           r_QbyATM_cover(i,j)=r_QbyATM_cover(i,j)
     &      + r_QbyATMmult_cover(i,j,IT)
           a_QSWbyATM_cover(i,j)=a_QSWbyATM_cover(i,j)
     &      + a_QSWbyATMmult_cover(i,j,IT)
           r_FWbySublim(i,j)=r_FWbySublim(i,j)
     &      + r_FWbySublimMult(i,j,IT)
          ENDDO
         ENDDO
        ENDDO
#endif /* SEAICE_ITD */

#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE d_hsnwbyneg(:,:,bi,bj) = comlev1_bibj,
CADJ &                              key = tkey, byte = isbyte
CADJ STORE d_hsnwbyocnonsnw = comlev1_bibj,key=tkey,byte=isbyte
#endif /* ALLOW_AUTODIFF_TAMC */

        DO j=1,sNy
         DO i=1,sNx
          QNET(i,j,bi,bj) = r_QbyATM_cover(i,j) + r_QbyATM_open(i,j)
     &         +   a_QSWbyATM_cover(i,j)
     &         - ( d_HEFFbyOCNonICE(i,j)
     &           + d_HSNWbyOCNonSNW(i,j)*SNOW2ICE
     &           + d_HEFFbyNEG(i,j,bi,bj)
#ifdef EXF_SEAICE_FRACTION
     &           + d_HEFFbyRLX(i,j,bi,bj)
#endif
     &           + d_HSNWbyNEG(i,j,bi,bj)*SNOW2ICE
     &           - convertPRECIP2HI *
     &             snowPrecip(i,j,bi,bj) * (ONE-AREApreTH(i,j))
     &           ) * HEFFM(i,j,bi,bj)
         ENDDO
        ENDDO
        DO j=1,sNy
         DO i=1,sNx
          QSW(i,j,bi,bj)  = a_QSWbyATM_cover(i,j) + a_QSWbyATM_open(i,j)
         ENDDO
        ENDDO

C switch heat fluxes from 'effective' ice meters to W/m2
C ======================================================

        DO j=1,sNy
         DO i=1,sNx
          QNET(i,j,bi,bj) = QNET(i,j,bi,bj)*convertHI2Q
          QSW(i,j,bi,bj)  = QSW(i,j,bi,bj)*convertHI2Q
         ENDDO
        ENDDO

#ifndef SEAICE_DISABLE_HEATCONSFIX
C treat advective heat flux by ocean to ice water exchange (at 0decC)
C ===================================================================
# ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE d_HEFFbyNEG(:,:,bi,bj) = comlev1_bibj,
CADJ &                              key = tkey, byte = isbyte
CADJ STORE d_HEFFbyOCNonICE = comlev1_bibj,key=tkey,byte=isbyte
CADJ STORE d_HEFFbyATMonOCN = comlev1_bibj,key=tkey,byte=isbyte
CADJ STORE d_HSNWbyNEG(:,:,bi,bj) = comlev1_bibj,
CADJ &                              key = tkey, byte = isbyte
CADJ STORE d_HSNWbyOCNonSNW = comlev1_bibj,key=tkey,byte=isbyte
CADJ STORE d_HSNWbyATMonSNW = comlev1_bibj,key=tkey,byte=isbyte
CADJ STORE theta(:,:,kSurface,bi,bj) = comlev1_bibj,
CADJ &                       key = tkey, byte = isbyte
# endif /* ALLOW_AUTODIFF_TAMC */
Cgf Unlike for evap and precip, the temperature of gained/lost
C ocean liquid water due to melt/freeze of solid water cannot be chosen
C arbitrarily to be e.g. the ocean SST. Indeed the present seaice model
C implies a constant ice temperature of 0degC. If melt/freeze water is exchanged
C at a different temperature, it leads to a loss of conservation in the
C ocean+ice system. While this is mostly a serious issue in the
C real fresh water + non linear free surface framework, a mismatch
C between ice and ocean boundary condition can result in all cases.
C Below we therefore anticipate on external_forcing_surf.F
C to diagnoze and/or apply the correction to QNET.
        DO j=1,sNy
         DO i=1,sNx
catn: initialize tmpscal1
           tmpscal1 = ZERO
C ocean water going to ice/snow, in precip units
           tmpscal3=rhoConstFresh*HEFFM(i,j,bi,bj)*(
     &       ( d_HSNWbyATMonSNW(i,j)*SNOW2ICE
     &       + d_HSNWbyOCNonSNW(i,j)*SNOW2ICE
     &       + d_HEFFbyOCNonICE(i,j) + d_HEFFbyATMonOCN(i,j)
     &       + d_HEFFbyNEG(i,j,bi,bj)+ d_HSNWbyNEG(i,j,bi,bj)*SNOW2ICE )
     &       * convertHI2PRECIP
     &       - snowPrecip(i,j,bi,bj) * (ONE-AREApreTH(i,j)) )
C factor in the heat content as done in external_forcing_surf.F
           IF ( (temp_EvPrRn.NE.UNSET_RL).AND.
     &         useRealFreshWaterFlux.AND.(nonlinFreeSurf.NE.0) ) THEN
             tmpscal1 = - tmpscal3*
     &         HeatCapacity_Cp * temp_EvPrRn
           ELSEIF ( (temp_EvPrRn.EQ.UNSET_RL).AND.
     &         useRealFreshWaterFlux.AND.(nonlinFreeSurf.NE.0) ) THEN
             tmpscal1 = - tmpscal3*
     &         HeatCapacity_Cp * theta(i,j,kSurface,bi,bj)
           ELSEIF ( (temp_EvPrRn.NE.UNSET_RL) ) THEN
             tmpscal1 = - tmpscal3*HeatCapacity_Cp*
     &       ( temp_EvPrRn - theta(i,j,kSurface,bi,bj) )
           ELSEIF ( (temp_EvPrRn.EQ.UNSET_RL) ) THEN
             tmpscal1 = ZERO
           ENDIF
#ifdef ALLOW_DIAGNOSTICS
C in all cases, diagnoze the boundary condition mismatch to SIaaflux
           DIAGarrayA(i,j)=tmpscal1
#endif
C remove the mismatch when real fresh water is exchanged (at 0degC here)
           IF ( useRealFreshWaterFlux.AND.(nonlinFreeSurf.GT.0)
     &          .AND.SEAICEheatConsFix )
     &       QNET(i,j,bi,bj)=QNET(i,j,bi,bj)+tmpscal1
         ENDDO
        ENDDO
#ifdef ALLOW_DIAGNOSTICS
        IF ( useDiagnostics ) THEN
          CALL DIAGNOSTICS_FILL(DIAGarrayA,
     &        'SIaaflux',0,1,3,bi,bj,myThid)
        ENDIF
#endif
#endif /* ndef SEAICE_DISABLE_HEATCONSFIX */

C compute the net heat flux, incl. adv. by water, entering ocean+ice
C ===================================================================
        DO j=1,sNy
         DO i=1,sNx
Cgf 1) SIatmQnt (analogous to qnet; excl. adv. by water exch.)
CML If I consider the atmosphere above the ice, the surface flux
CML which is relevant for the air temperature dT/dt Eq
CML accounts for sensible and radiation (with different treatment
CML according to wave-length) fluxes but not for "latent heat flux",
CML since it does not contribute to heating the air.
CML So this diagnostic is only good for heat budget calculations within
CML the ice-ocean system.
           SIatmQnt(i,j,bi,bj) =
     &            HEFFM(i,j,bi,bj)*convertHI2Q*(
     &            a_QSWbyATM_cover(i,j) +
     &            a_QbyATM_cover(i,j) + a_QbyATM_open(i,j) )
Cgf 2) SItflux (analogous to tflux; includes advection by water
C             exchanged between atmosphere and ocean+ice)
C solid water going to atm, in precip units
           tmpscal1 = rhoConstFresh*HEFFM(i,j,bi,bj)
     &       * convertHI2PRECIP * ( - d_HSNWbyRAIN(i,j)*SNOW2ICE
     &       + a_FWbySublim(i,j) - r_FWbySublim(i,j) )
C liquid water going to atm, in precip units
           tmpscal2=rhoConstFresh*HEFFM(i,j,bi,bj)*
     &       ( ( EVAP(i,j,bi,bj)-PRECIP(i,j,bi,bj) )
     &         * ( ONE - AREApreTH(i,j) )
#ifdef ALLOW_RUNOFF
     &         - RUNOFF(i,j,bi,bj)
#endif /* ALLOW_RUNOFF */
     &         + ( d_HFRWbyRAIN(i,j) + r_FWbySublim(i,j) )
     &         *convertHI2PRECIP )
C In real fresh water flux + nonlinFS, we factor in the advected specific
C energy (referenced to 0 for 0deC liquid water). In virtual salt flux or
C linFS, rain/evap get a special treatment (see external_forcing_surf.F).
           tmpscal1= - tmpscal1*
     &       ( -SEAICE_lhFusion + HeatCapacity_Cp * ZERO )
           IF ( (temp_EvPrRn.NE.UNSET_RL).AND.
     &          useRealFreshWaterFlux.AND.(nonlinFreeSurf.NE.0) ) THEN
             tmpscal2= - tmpscal2*
     &        ( ZERO + HeatCapacity_Cp * temp_EvPrRn )
           ELSEIF ( (temp_EvPrRn.EQ.UNSET_RL).AND.
     &          useRealFreshWaterFlux.AND.(nonlinFreeSurf.NE.0) ) THEN
             tmpscal2= - tmpscal2*
     &        ( ZERO + HeatCapacity_Cp * theta(i,j,kSurface,bi,bj) )
           ELSEIF ( (temp_EvPrRn.NE.UNSET_RL) ) THEN
             tmpscal2= - tmpscal2*HeatCapacity_Cp*
     &        ( temp_EvPrRn - theta(i,j,kSurface,bi,bj) )
           ELSEIF ( (temp_EvPrRn.EQ.UNSET_RL) ) THEN
             tmpscal2= ZERO
           ENDIF
           SItflux(i,j,bi,bj)= SIatmQnt(i,j,bi,bj)-tmpscal1-tmpscal2
         ENDDO
        ENDDO

C compute net fresh water flux leaving/entering
C the ocean, accounting for fresh/salt water stocks.
C ==================================================

        DO j=1,sNy
         DO i=1,sNx
          tmpscal1= d_HSNWbyATMonSNW(i,j)*SNOW2ICE
     &             +d_HFRWbyRAIN(i,j)
     &             +d_HSNWbyOCNonSNW(i,j)*SNOW2ICE
     &             +d_HEFFbyOCNonICE(i,j)
     &             +d_HEFFbyATMonOCN(i,j)
     &             +d_HEFFbyNEG(i,j,bi,bj)
#ifdef EXF_SEAICE_FRACTION
     &             +d_HEFFbyRLX(i,j,bi,bj)
#endif
     &             +d_HSNWbyNEG(i,j,bi,bj)*SNOW2ICE
C     If r_FWbySublim>0, then it is evaporated from ocean.
     &             +r_FWbySublim(i,j)
          EmPmR(i,j,bi,bj)  = HEFFM(i,j,bi,bj)*(
     &         ( EVAP(i,j,bi,bj)-PRECIP(i,j,bi,bj) )
     &         * ( ONE - AREApreTH(i,j) )
#ifdef ALLOW_RUNOFF
     &         - RUNOFF(i,j,bi,bj)
#endif /* ALLOW_RUNOFF */
     &         + tmpscal1*convertHI2PRECIP
     &         )*rhoConstFresh
#ifdef SEAICE_ITD
C     beware of the sign: fw2ObyRidge is snow mass moved into the ocean
C     by ridging, so requires a minus sign
     &         - fw2ObyRidge(i,j,bi,bj)*recip_deltaTtherm
     &           * HEFFM(i,j,bi,bj)
#endif /* SEAICE_ITD */
C and the flux leaving/entering the ocean+ice
           SIatmFW(i,j,bi,bj) = HEFFM(i,j,bi,bj)*(
     &          EVAP(i,j,bi,bj)*( ONE - AREApreTH(i,j) )
     &          - PRECIP(i,j,bi,bj)
#ifdef ALLOW_RUNOFF
     &          - RUNOFF(i,j,bi,bj)
#endif /* ALLOW_RUNOFF */
     &           )*rhoConstFresh
     &     + a_FWbySublim(i,j) * SEAICE_rhoIce * recip_deltaTtherm

         ENDDO
        ENDDO

#ifdef SEAICE_DEBUG
       IF ( plotLevel.GE.debLevC ) THEN
        CALL PLOT_FIELD_XYRL( QSW,'Current QSW ', myIter, myThid )
        CALL PLOT_FIELD_XYRL( QNET,'Current QNET ', myIter, myThid )
        CALL PLOT_FIELD_XYRL( EmPmR,'Current EmPmR ', myIter, myThid )
       ENDIF
#endif /* SEAICE_DEBUG */

C Sea Ice Load on the sea surface.
C =================================

#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE heff(:,:,bi,bj)  = comlev1_bibj,key=tkey,byte=isbyte
CADJ STORE hsnow(:,:,bi,bj) = comlev1_bibj,key=tkey,byte=isbyte
#endif /* ALLOW_AUTODIFF_TAMC */

        IF ( useRealFreshWaterFlux ) THEN
         DO j=1,sNy
          DO i=1,sNx
#ifdef SEAICE_CAP_ICELOAD
           tmpscal1 = HEFF(i,j,bi,bj)*SEAICE_rhoIce
     &              + HSNOW(i,j,bi,bj)*SEAICE_rhoSnow
           tmpscal2 = MIN(tmpscal1,heffTooHeavy*rhoConst)
#else
           tmpscal2 = HEFF(i,j,bi,bj)*SEAICE_rhoIce
     &              + HSNOW(i,j,bi,bj)*SEAICE_rhoSnow
#endif
           sIceLoad(i,j,bi,bj) = tmpscal2
          ENDDO
         ENDDO
        ENDIF

#ifdef ALLOW_BALANCE_FLUXES
C Compute tile integrals of heat/fresh water fluxes to/from atm.
C ==============================================================
        FWFsiTile(bi,bj) = 0. _d 0
        IF ( selectBalanceEmPmR.EQ.1 ) THEN
         DO j=1,sNy
          DO i=1,sNx
           FWFsiTile(bi,bj) =
     &       FWFsiTile(bi,bj) + SIatmFW(i,j,bi,bj)
     &       * rA(i,j,bi,bj) * maskInC(i,j,bi,bj)
          ENDDO
         ENDDO
        ENDIF
C to translate global mean FWF adjustements (see below) we may need :
        FWF2HFsiTile(bi,bj) = 0. _d 0
        IF ( selectBalanceEmPmR.EQ.1 .AND.
     &       temp_EvPrRn.EQ.UNSET_RL ) THEN
         DO j=1,sNy
          DO i=1,sNx
           FWF2HFsiTile(bi,bj) = FWF2HFsiTile(bi,bj) +
     &       HeatCapacity_Cp * theta(i,j,kSurface,bi,bj)
     &       * rA(i,j,bi,bj) * maskInC(i,j,bi,bj)
          ENDDO
         ENDDO
        ENDIF
        HFsiTile(bi,bj) = 0. _d 0
        IF ( balanceQnet ) THEN
         DO j=1,sNy
          DO i=1,sNx
           HFsiTile(bi,bj) =
     &       HFsiTile(bi,bj) + SItflux(i,j,bi,bj)
     &       * rA(i,j,bi,bj) * maskInC(i,j,bi,bj)
          ENDDO
         ENDDO
        ENDIF
#endif /* ALLOW_BALANCE_FLUXES */

C ===================================================================
C ======================PART 8: diagnostics==========================
C ===================================================================

#ifdef ALLOW_DIAGNOSTICS
        IF ( useDiagnostics ) THEN
         tmpscal1=1. _d 0 * recip_deltaTtherm
         CALL DIAGNOSTICS_SCALE_FILL(a_QbyATM_cover,
     &      tmpscal1,1,'SIaQbATC',0,1,3,bi,bj,myThid)
         CALL DIAGNOSTICS_SCALE_FILL(a_QbyATM_open,
     &      tmpscal1,1,'SIaQbATO',0,1,3,bi,bj,myThid)
         CALL DIAGNOSTICS_SCALE_FILL(a_QbyOCN,
     &      tmpscal1,1,'SIaQbOCN',0,1,3,bi,bj,myThid)
         CALL DIAGNOSTICS_SCALE_FILL(d_HEFFbyOCNonICE,
     &      tmpscal1,1,'SIdHbOCN',0,1,3,bi,bj,myThid)
         CALL DIAGNOSTICS_SCALE_FILL(d_HEFFbyATMonOCN_cover,
     &      tmpscal1,1,'SIdHbATC',0,1,3,bi,bj,myThid)
         CALL DIAGNOSTICS_SCALE_FILL(d_HEFFbyATMonOCN_open,
     &      tmpscal1,1,'SIdHbATO',0,1,3,bi,bj,myThid)
         CALL DIAGNOSTICS_SCALE_FILL(d_HEFFbyFLOODING,
     &      tmpscal1,1,'SIdHbFLO',0,1,3,bi,bj,myThid)
         CALL DIAGNOSTICS_SCALE_FILL(d_HSNWbyOCNonSNW,
     &      tmpscal1,1,'SIdSbOCN',0,1,3,bi,bj,myThid)
         CALL DIAGNOSTICS_SCALE_FILL(d_HSNWbyATMonSNW,
     &      tmpscal1,1,'SIdSbATC',0,1,3,bi,bj,myThid)
         CALL DIAGNOSTICS_SCALE_FILL(d_AREAbyATM,
     &      tmpscal1,1,'SIdAbATO',0,1,3,bi,bj,myThid)
         CALL DIAGNOSTICS_SCALE_FILL(d_AREAbyICE,
     &      tmpscal1,1,'SIdAbATC',0,1,3,bi,bj,myThid)
         CALL DIAGNOSTICS_SCALE_FILL(d_AREAbyOCN,
     &      tmpscal1,1,'SIdAbOCN',0,1,3,bi,bj,myThid)
         CALL DIAGNOSTICS_SCALE_FILL(r_QbyATM_open,
     &      convertHI2Q,1, 'SIqneto ',0,1,3,bi,bj,myThid)
         CALL DIAGNOSTICS_SCALE_FILL(r_QbyATM_cover,
     &      convertHI2Q,1, 'SIqneti ',0,1,3,bi,bj,myThid)
C three that actually need intermediate storage
         DO j=1,sNy
          DO i=1,sNx
            DIAGarrayA(i,j) = HEFFM(i,j,bi,bj)
     &        * d_HSNWbyRAIN(i,j)*SEAICE_rhoSnow*recip_deltaTtherm
            DIAGarrayB(i,j) =  AREA(i,j,bi,bj)-AREApreTH(i,j)
          ENDDO
         ENDDO
         CALL DIAGNOSTICS_FILL(DIAGarrayA,
     &      'SIsnPrcp',0,1,3,bi,bj,myThid)
         CALL DIAGNOSTICS_SCALE_FILL(DIAGarrayB,
     &      tmpscal1,1,'SIdA    ',0,1,3,bi,bj,myThid)
         DO j=1,sNy
          DO i=1,sNx
           DIAGarrayB(i,j) = HEFFM(i,j,bi,bj) *
     &       a_FWbySublim(i,j) * SEAICE_rhoIce * recip_deltaTtherm
          ENDDO
         ENDDO
         CALL DIAGNOSTICS_FILL(DIAGarrayB,
     &      'SIfwSubl',0,1,3,bi,bj,myThid)
C
         DO j=1,sNy
          DO i=1,sNx
C the actual Freshwater flux of sublimated ice, >0 decreases ice
           DIAGarrayA(i,j) = HEFFM(i,j,bi,bj)
     &       * (a_FWbySublim(i,j)-r_FWbySublim(i,j))
     &       * SEAICE_rhoIce * recip_deltaTtherm
C the residual Freshwater flux of sublimated ice
           DIAGarrayC(i,j) = HEFFM(i,j,bi,bj)
     &       * r_FWbySublim(i,j)
     &       * SEAICE_rhoIce * recip_deltaTtherm
C the latent heat flux
           tmpscal1= EVAP(i,j,bi,bj)*( ONE - AREApreTH(i,j) )
     &             + r_FWbySublim(i,j)*convertHI2PRECIP
           tmpscal2= ( a_FWbySublim(i,j)-r_FWbySublim(i,j) )
     &             * convertHI2PRECIP
           tmpscal3= SEAICE_lhEvap+SEAICE_lhFusion
           DIAGarrayB(i,j) = -HEFFM(i,j,bi,bj)*rhoConstFresh
     &             * ( tmpscal1*SEAICE_lhEvap + tmpscal2*tmpscal3 )
          ENDDO
         ENDDO
         CALL DIAGNOSTICS_FILL(DIAGarrayA,'SIacSubl',0,1,3,bi,bj,myThid)
         CALL DIAGNOSTICS_FILL(DIAGarrayC,'SIrsSubl',0,1,3,bi,bj,myThid)
         CALL DIAGNOSTICS_FILL(DIAGarrayB,'SIhl    ',0,1,3,bi,bj,myThid)
# if defined ( ALLOW_SITRACER ) && defined ( SEAICE_GREASE )
C actual grease ice layer thickness
         CALL DIAGNOSTICS_FILL(greaseLayerThick,
     &        'SIgrsLT ',0,1,3,bi,bj,myThid)
# endif /* SEAICE_GREASE */
        ENDIF
#endif /* ALLOW_DIAGNOSTICS */

C close bi,bj loops
       ENDDO
      ENDDO

C ===================================================================
C =========PART 9: HF/FWF global integrals and balancing=============
C ===================================================================

#ifdef ALLOW_BALANCE_FLUXES

C 1)  global sums
# ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE FWFsiTile    = comlev1, key=ikey_dynamics, kind=isbyte
CADJ STORE HFsiTile     = comlev1, key=ikey_dynamics, kind=isbyte
CADJ STORE FWF2HFsiTile = comlev1, key=ikey_dynamics, kind=isbyte
# endif /* ALLOW_AUTODIFF_TAMC */
      FWFsiGlob = 0. _d 0
      FWF2HFsiGlob = 0. _d 0
      IF ( selectBalanceEmPmR.EQ.1 ) THEN
        CALL GLOBAL_SUM_TILE_RL( FWFsiTile, FWFsiGlob, myThid )
        IF ( temp_EvPrRn.EQ.UNSET_RL ) THEN
          CALL GLOBAL_SUM_TILE_RL( FWF2HFsiTile, FWF2HFsiGlob, myThid )
        ELSE
          FWF2HFsiGlob = HeatCapacity_Cp * temp_EvPrRn * globalArea
        ENDIF
      ENDIF
      HFsiGlob=0. _d 0
      IF ( balanceQnet )
     &   CALL GLOBAL_SUM_TILE_RL( HFsiTile, HFsiGlob, myThid )

C 2) global means
C mean SIatmFW
      tmpscal0=FWFsiGlob / globalArea
C corresponding mean advection by atm to ocean+ice water exchange
C        (if mean SIatmFW was removed uniformely from ocean)
      tmpscal1=FWFsiGlob / globalArea * FWF2HFsiGlob / globalArea
C mean SItflux (before potential adjustement due to SIatmFW)
      tmpscal2=HFsiGlob / globalArea
C mean SItflux (after potential adjustement due to SIatmFW)
      IF ( selectBalanceEmPmR.EQ.1 ) tmpscal2=tmpscal2-tmpscal1

C 3) balancing adjustments
      IF ( selectBalanceEmPmR.EQ.1 ) THEN
       DO bj=myByLo(myThid),myByHi(myThid)
        DO bi=myBxLo(myThid),myBxHi(myThid)
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
            empmr(i,j,bi,bj) = empmr(i,j,bi,bj) - tmpscal0
            SIatmFW(i,j,bi,bj) = SIatmFW(i,j,bi,bj) - tmpscal0
C           adjust SItflux consistently
            IF ( (temp_EvPrRn.NE.UNSET_RL).AND.
     &        useRealFreshWaterFlux.AND.(nonlinFreeSurf.NE.0) ) THEN
            tmpscal1=
     &       ( ZERO + HeatCapacity_Cp * temp_EvPrRn )
            ELSEIF ( (temp_EvPrRn.EQ.UNSET_RL).AND.
     &        useRealFreshWaterFlux.AND.(nonlinFreeSurf.NE.0) ) THEN
            tmpscal1=
     &       ( ZERO + HeatCapacity_Cp * theta(i,j,kSurface,bi,bj) )
            ELSEIF ( (temp_EvPrRn.NE.UNSET_RL) ) THEN
            tmpscal1=
     &       HeatCapacity_Cp*(temp_EvPrRn - theta(i,j,kSurface,bi,bj))
            ELSE
            tmpscal1=ZERO
            ENDIF
            SItflux(i,j,bi,bj) = SItflux(i,j,bi,bj) - tmpscal0*tmpscal1
C           no qnet or tflux adjustement is needed
          ENDDO
         ENDDO
        ENDDO
       ENDDO
       IF ( balancePrintMean ) THEN
        _BEGIN_MASTER( myThid )
        WRITE(msgBuf,'(2A,1PE21.14,A,I10)') 'rm Global mean of',
     &               ' SIatmFW = ', tmpscal0, '  @ it=', myIter
        CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
        _END_MASTER( myThid )
       ENDIF
      ENDIF
      IF ( balanceQnet ) THEN
       DO bj=myByLo(myThid),myByHi(myThid)
        DO bi=myBxLo(myThid),myBxHi(myThid)
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
            SItflux(i,j,bi,bj) = SItflux(i,j,bi,bj) - tmpscal2
            qnet(i,j,bi,bj) = qnet(i,j,bi,bj) - tmpscal2
            SIatmQnt(i,j,bi,bj) = SIatmQnt(i,j,bi,bj) - tmpscal2
          ENDDO
         ENDDO
        ENDDO
       ENDDO
       IF ( balancePrintMean ) THEN
        _BEGIN_MASTER( myThid )
        WRITE(msgBuf,'(2A,1PE21.14,A,I10)') 'rm Global mean of',
     &               ' SItflux = ', tmpscal2, '  @ it=', myIter
        CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
        _END_MASTER( myThid )
       ENDIF
      ENDIF
#endif /* ALLOW_BALANCE_FLUXES */

#ifdef ALLOW_DIAGNOSTICS
      IF ( useDiagnostics ) THEN
C these diags need to be done outside of the bi,bj loop so that
C we may do potential global mean adjustement to them consistently.
        CALL DIAGNOSTICS_FILL(SItflux,
     &        'SItflux ',0,1,0,1,1,myThid)
        CALL DIAGNOSTICS_FILL(SIatmQnt,
     &        'SIatmQnt',0,1,0,1,1,myThid)
C SIatmFW follows the same convention as empmr -- SIatmFW diag does not
        tmpscal1= - 1. _d 0
        CALL DIAGNOSTICS_SCALE_FILL(SIatmFW,
     &        tmpscal1,1,'SIatmFW ',0,1,0,1,1,myThid)
      ENDIF
#endif /* ALLOW_DIAGNOSTICS */

#else  /* ALLOW_EXF and ALLOW_ATM_TEMP */
      STOP 'SEAICE_GROWTH not compiled without EXF and ALLOW_ATM_TEMP'
#endif /* ALLOW_EXF and ALLOW_ATM_TEMP */
#endif /* ndef SEAICE_USE_GROWTH_ADX */

      RETURN
      END

#include "THSICE_OPTIONS.h"

CBOP
C     !ROUTINE: THSICE_COST_FINAL
C     !INTERFACE:
      SUBROUTINE THSICE_COST_FINAL( ifc, optimcycle, myThid )

C     !DESCRIPTION:
C     *==========================================================*
C     | SUBROUTINE THSICE_COST_FINAL
C     *==========================================================*

C     !USES:
      IMPLICIT NONE

C     == global variables ==
#include "EEPARAMS.h"
#include "SIZE.h"
#include "PARAMS.h"
#include "DYNVARS.h"
#include "THSICE_PARAMS.h"
#ifdef ALLOW_COST
# include "THSICE_COST.h"
# include "cost.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     ifc        :: file unit for costfunction_thsice.XXXX
C     optimcycle :: cycle number of the off-line optimization.
C     myThid     :: my Thread Id number
      INTEGER ifc
      INTEGER optimcycle
      INTEGER myThid

#ifdef ALLOW_COST
C     !LOCAL VARIABLES:
      INTEGER bi,bj
      _RL f_thsice
      _RL no_thsice
c     CHARACTER*24 cfname
CEOP

c     print *, 'ph-2 in thsice_cost_final'

      f_thsice      = 0. _d 0
      no_thsice     = 0. _d 0

C--   Sum up all contributions.
      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)

          tile_fc(bi,bj) = tile_fc(bi,bj)
     &          + mult_thsice        * objf_thsice(bi,bj)

          f_thsice = f_thsice + objf_thsice(bi,bj)

       ENDDO
      ENDDO

C--   Do global summation for each part of the cost function
c     CALL GLOBAL_SUM_TILE_RL( objf_thsice, f_thsice, myThid )
c     CALL GLOBAL_SUM_TILE_RL( num_thsice, no_thsice, myThid )

      WRITE(standardMessageUnit,'(A,1PE22.14)')
     &     ' --> f_thsice     = ', f_thsice

c     IF ( ifc .NE. -1 ) THEN
c       WRITE(cfname,'(A,i4.4)') 'costfunction_thsice.',optimcycle
c       OPEN(unit=ifc,file=cfname)
c       WRITE(ifc,'(A,1PE22.14,1PE22.14,1X,1PE9.2)')
c    &       'f_thsice =', f_thsice, no_thsice, mult_thsice
c       CLOSE(ifc)
c     ENDIF

#endif /* ALLOW_COST */

      RETURN
      END

#include "PACKAGES_CONFIG.h"
#include "CPP_EEOPTIONS.h"
#undef DBUG_EXCH_VEC

C--   Contents
C--   o EXCH2_SEND_PUT_VEC_RL

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 0
C !ROUTINE: EXCH2_SEND_PUT_VEC_RL

C !INTERFACE:
      SUBROUTINE EXCH2_SEND_PUT_VEC_RL(
     I                        array,
     O                        bufRec,
     O                        theHandle,
     I                        myd1, myThid )
C     !DESCRIPTION:
C     *==========================================================*
C     | SUBROUTINE EXCH2_SEND_PUT_VEC_RL
C     | o "Send" or "put" edges for RL array.
C     *==========================================================*
C     | Routine that invokes actual message passing send or
C     | direct "put" of data to update buffer
C     *==========================================================*

C     !USES:
      IMPLICIT NONE

C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "EESUPPORT.h"
#ifdef ALLOW_EXCH2
#include "W2_EXCH2_SIZE.h"
#include "W2_EXCH2_TOPOLOGY.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     array         :: Input buffer array to send to Neighbours
C     bufRec        :: buffer array to collect Neighbour values
C     myd1          :: size
C     myThid        :: my Thread Id. number
      INTEGER myd1
      _RL  array(myd1,nSx,nSy,4)
      _RL bufRec(myd1,nSx,nSy,4)
#ifdef ALLOW_EXCH2
      INTEGER theHandle(2,W2_maxNeighbours,nSx,nSy)
#else
      INTEGER theHandle
#endif
      INTEGER myThid
CEOP

#ifdef ALLOW_EXCH2

C     !LOCAL VARIABLES:
C     I             :: Loop counters
C     bi, bj        :: tile indices
C     theProc       :: Variables used in message building
C     theTag        :: Variables used in message building
C     theType       :: Variables used in message building
C     theSize       :: Variables used in message building
      INTEGER I,J,sBi,sBj, nN, thisTile, tgT, tgN, dir, sDir
      INTEGER bi, bj
#ifdef ALLOW_USE_MPI
      INTEGER theProc, theTag, theType, theSize, mpiRc
#endif
#ifdef DBUG_EXCH_VEC
      INTEGER ioUnit
#endif

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C--   Write data to exchange buffer
C     Various actions are possible depending on the communication mode
C     as follows:
C       Mode      Action
C     --------   ---------------------------
C     COMM_NONE  Do nothing
C
C     COMM_MSG   Message passing communication ( e.g. MPI )
C                Fill west send buffer from this tile.
C                Send data with tag identifying tile and direction.
C                Fill east send buffer from this tile.
C                Send data with tag identifying tile and direction.
C
C     COMM_PUT   "Put" communication ( UMP_, shmemput, etc... )
C                Fill east receive buffer of west-neighbor tile
C                Fill west receive buffer of east-neighbor tile
C                Sync. memory
C                Write data-ready Ack for east edge of west-neighbor tile
C                Write data-ready Ack for west edge of east-neighbor tile
C                Sync. memory

      _BEGIN_MASTER(myThid)

#ifdef DBUG_EXCH_VEC
      ioUnit = errorMessageUnit
#endif

      DO bj=1,nSy
      DO bi=1,nSx

       thisTile = W2_myTileList(bi,bj)

C- loop over neighboring tiles
       DO nN=1,exch2_nNeighbours(thisTile)

        tgT = exch2_neighbourId(nN, thisTile )
        dir = exch2_neighbourDir(nN,thisTile)
        tgN = exch2_opposingSend(nN,thisTIle)
        sDir = exch2_neighbourDir(tgN,tgT)

        IF ( W2_myCommFlag(nN,bi,bj) .EQ. 'P' ) THEN
C         find bi,bj of target tile
          DO j=1,nSy
           DO i=1,nSx
            IF ( W2_myTileList(i,j).EQ.tgT ) THEN
             sBi = i
             sBj = j
            ENDIF
           ENDDO
          ENDDO
          DO I=1,myd1
            bufRec(I,sBi,sBj,sDir) = array(I,bi,bj,dir)
          ENDDO
#ifdef ALLOW_USE_MPI
        ELSEIF ( usingMPI .AND.
     &           W2_myCommFlag(nN,bi,bj) .EQ. 'M' ) THEN
C        Send the data
          theProc = W2_tileProc(tgT) - 1
          theTag  = (thisTile-1)*W2_maxNeighbours + nN
          theSize = myd1
          theType = _MPI_TYPE_RL
#ifdef DBUG_EXCH_VEC
          write(ioUnit,'(A,5I5,I8)') 'qq1xW: ',myProcId,bi,bj,
     &          theProc,theTag, theSize
#endif
          CALL MPI_Isend(array(1,bi,bj,dir), theSize, theType,
     &                  theProc, theTag, MPI_COMM_MODEL,
     &                  theHandle(1,nN,bi,bj), mpiRc)
#endif /* ALLOW_USE_MPI */
        ELSE
         STOP 'S/R EXCH2_SEND_PUT_VEC_RL: Invalid commFlag.'
        ENDIF

C-     nN
       ENDDO

C-    bj,bi
      ENDDO
      ENDDO

      _END_MASTER(myThid)

#endif /* ALLOW_EXCH2 */

      RETURN
      END

#include "CPP_OPTIONS.h"

CBOP 0
C !ROUTINE: CPL_SEND_ATM_OCNCONFIG

C !INTERFACE:
      SUBROUTINE CPL_SEND_ATM_OCNCONFIG

C !DESCRIPTION:
C     *==========================================================*
C     | SUBROUTINE CPL_SEND_ATM_OCNCONFIG
C     | o Routine for sending atmos. config to ocean component.
C     *==========================================================*
C     | This version talks to the MITgcm general circulation
C     | model. For now just send atmosphere depths.
C     *==========================================================*

C !USES:
      IMPLICIT NONE
C     == Global variables ==
c#include "CPL_PARAMS.h"
#include "ATMIDS.h"
#include "ATMSIZE.h"
#include "ATMVARS.h"
#include "OCNSIZE.h"
#include "OCNVARS.h"

C !INPUT/OUTPUT PARAMETERS:
C !LOCAL VARIABLES:
CEOP

C-    Map ocean depth map onto atmos. grid
      CALL OCN_TO_ATM_MAPXYR8(
     I     Nx_ocn, Ny_ocn,
     I     OcMxlD_ocn,
     I     Nx_atm, Ny_atm,
     O     OcMxlD_atm)

C-    Send ocean config to atmos. component
      CALL COUPSEND_R8TILES( atmCompName, atmMxlDName, Nx_atm, Ny_atm,
     &                       OcMxlD_atm )

      RETURN
      END

#include "DWNSLP_OPTIONS.h"

CBOP
C     !ROUTINE: DWNSLP_READPARMS
C     !INTERFACE:
      SUBROUTINE DWNSLP_READPARMS( myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE DWNSLP_READPARMS
C     | o Routine to initialize Down-Sloping Parameters
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "DWNSLP_PARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
      INTEGER myThid

#ifdef ALLOW_DOWN_SLOPE
C     !LOCAL VARIABLES:
C     === Local variables ===
C     msgBuf     :: Informational/error message buffer
C     iUnit      :: Work variable for IO unit number
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      INTEGER iUnit
CEOP

      NAMELIST /DWNSLP_PARM01/
     &          DWNSLP_slope, DWNSLP_rec_mu, DWNSLP_drFlow,
     &          temp_useDWNSLP, salt_useDWNSLP

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      IF ( .NOT.useDOWN_SLOPE ) THEN
C-    pkg DOWN_SLOPE is not used
        _BEGIN_MASTER(myThid)
C-    Track pkg activation status:
C     print a (weak) warning if data.down_slope is found
         CALL PACKAGES_UNUSED_MSG(
     I                'useDOWN_SLOPE', 'DWNSLP_READPARMS', ' ' )
        _END_MASTER(myThid)
        RETURN
      ENDIF

      _BEGIN_MASTER(myThid)

      WRITE(msgBuf,'(A)')' DWNSLP_READPARMS: opening data.down_slope'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT , 1)

      CALL OPEN_COPY_DATA_FILE(
     I                         'data.down_slope', 'DWNSLP_READPARMS',
     O                         iUnit,
     I                         myThid )

C--   Default flags and values for DownSlope Parameterisation
      temp_useDWNSLP = tempStepping
      salt_useDWNSLP = saltStepping
      DWNSLP_slope  = 0.
      DWNSLP_rec_mu = 0.
      DWNSLP_drFlow = 0.

C--   Read parameters from open data file
      READ(UNIT=iUnit,NML=DWNSLP_PARM01)

      WRITE(msgBuf,'(A)')
     &   ' DWNSLP_READPARMS: finished reading data.downslp'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT , 1)

C--   Close the open data file
#ifdef SINGLE_DISK_IO
      CLOSE(iUnit)
#else
      CLOSE(iUnit,STATUS='DELETE')
#endif /* SINGLE_DISK_IO */
      _END_MASTER(myThid)

C--   Everyone else must wait for the parameters to be loaded
      _BARRIER

C--   Check the parameters :
      IF ( temp_useDWNSLP .AND. .NOT. tempStepping ) THEN
        WRITE(msgBuf,'(A)')
     &  'need tempStepping=T to apply DWNSLP to Temp (temp_useDWNSLP=T)'
        CALL PRINT_ERROR( msgBuf , myThid )
        STOP 'ABNORMAL END: S/R DWNSLP_READPARMS'
      ENDIF
      IF ( salt_useDWNSLP .AND. .NOT. saltStepping ) THEN
        WRITE(msgBuf,'(A)')
     &  'need saltStepping=T to apply DWNSLP to Salt (salt_useDWNSLP=T)'
        CALL PRINT_ERROR( msgBuf , myThid )
        STOP 'ABNORMAL END: S/R DWNSLP_READPARMS'
      ENDIF

C- print out some kee parameters :
      _BEGIN_MASTER(myThid)

       CALL WRITE_0D_RL( DWNSLP_slope, INDEX_NONE,'DWNSLP_slope =',
     &  '   /* DOWNSLP fixed slope (=0 => use local slope) */')
       CALL WRITE_0D_RL( DWNSLP_rec_mu,INDEX_NONE,'DWNSLP_rec_mu =',
     &  '   /* DOWNSLP recip. friction parameter (time, s ) */')
       CALL WRITE_0D_RL( DWNSLP_drFlow,INDEX_NONE,'DWNSLP_drFlow =',
     &  '   /* DOWNSLP effective layer thickness ( m ) */')

      _END_MASTER(myThid)

#endif /* ALLOW_DOWN_SLOPE */
      RETURN
      END

#include "MOM_VECINV_OPTIONS.h"

CBOP
C !ROUTINE: MOM_VI_CORIOLIS

C !INTERFACE: ==========================================================
      SUBROUTINE MOM_VI_CORIOLIS(
     I        bi, bj, k,
     I        uFld, vFld, hFacZ, r_hFacZ,
     O        uCoriolisTerm, vCoriolisTerm,
     I        myThid )

C !DESCRIPTION:
C  Calculates the 2 horizontal components of Coriolis acceleration

C !USES: ===============================================================
      IMPLICIT NONE
C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "GRID.h"
#include "PARAMS.h"

C !INPUT PARAMETERS: ===================================================
C   bi, bj         :: current tile indices
C   k              :: current vertical level
C   uFld, vFld     :: local copy of horizontal velocity (u & v components)
C   hFacZ          :: hFac thickness factor at corner location
C   r_hFacZ        :: reciprocal hFac thickness factor at corner location
C   myThid         :: my Thread Id number
      INTEGER bi,bj,k
      _RL uFld   (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL vFld   (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RS hFacZ  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RS r_hFacZ(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER myThid

C !OUTPUT PARAMETERS: ==================================================
C   uCoriolisTerm  :: Coriolis tendency for u-component momentum
C   vCoriolisTerm  :: Coriolis tendency for v-component momentum
      _RL uCoriolisTerm(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL vCoriolisTerm(1-OLx:sNx+OLx,1-OLy:sNy+OLy)

C !LOCAL VARIABLES: ====================================================
C   i, j           :: loop indices
C   uBarXY, vBarXY :: averaged (in X & Y direction) of u & v velocity
C   uBarYm, uBarYp :: u velocity, Y direction averaged (at i and i+1)
C   vBarXm, vBarXp :: v velocity, X direction averaged (at j and j+1)
C   epsil          :: small number
      INTEGER i,j
      _RL uBarXY, vBarXY
      _RL uBarYm, uBarYp, vBarXm, vBarXp
      _RS epsil
CEOP

      epsil = 1. _d -9

      IF ( selectCoriScheme .EQ. 0 ) THEN
C- Simple average, no hFac :
       DO j=1-OLy,sNy+OLy-1
        DO i=2-OLx,sNx+OLx
         vBarXY=0.25*(
     &      (vFld( i , j )*dxG( i , j ,bi,bj)
     &      +vFld(i-1, j )*dxG(i-1, j ,bi,bj))
     &     +(vFld( i ,j+1)*dxG( i ,j+1,bi,bj)
     &      +vFld(i-1,j+1)*dxG(i-1,j+1,bi,bj))
     &               )
         uCoriolisTerm(i,j)=
     &    +0.5*( fCoriG(i,j,bi,bj)+fCoriG(i,j+1,bi,bj)
     &         )*vBarXY*recip_dxC(i,j,bi,bj)*_maskW(i,j,k,bi,bj)
        ENDDO
       ENDDO
      ELSEIF ( selectCoriScheme .EQ. 1 ) THEN
C- Partial-cell generalization of the Wet-point average method :
C     (formerly called: useJamartWetPoints)
       DO j=1-OLy,sNy+OLy-1
        DO i=2-OLx,sNx+OLx
         vBarXY=(
     &      (vFld( i , j )*dxG( i , j ,bi,bj)*_hFacS( i , j ,k,bi,bj)
     &      +vFld(i-1, j )*dxG(i-1, j ,bi,bj)*_hFacS(i-1, j ,k,bi,bj))
     &     +(vFld( i ,j+1)*dxG( i ,j+1,bi,bj)*_hFacS( i ,j+1,k,bi,bj)
     &      +vFld(i-1,j+1)*dxG(i-1,j+1,bi,bj)*_hFacS(i-1,j+1,k,bi,bj)))
     &   / MAX( epsil,(_hFacS(i, j ,k,bi,bj)+_hFacS(i-1, j ,k,bi,bj))
     &               +(_hFacS(i,j+1,k,bi,bj)+_hFacS(i-1,j+1,k,bi,bj)) )
         uCoriolisTerm(i,j)=
     &    +0.5*( fCoriG(i,j,bi,bj)+fCoriG(i,j+1,bi,bj)
     &         )*vBarXY*recip_dxC(i,j,bi,bj)*_maskW(i,j,k,bi,bj)
        ENDDO
       ENDDO
      ELSEIF ( selectCoriScheme .EQ. 2 ) THEN
C- hFac weighted average :
       DO j=1-OLy,sNy+OLy-1
        DO i=2-OLx,sNx+OLx
         vBarXY=0.25*(
     &      (vFld( i , j )*dxG( i , j ,bi,bj)*_hFacS( i , j ,k,bi,bj)
     &      +vFld(i-1, j )*dxG(i-1, j ,bi,bj)*_hFacS(i-1, j ,k,bi,bj))
     &     +(vFld( i ,j+1)*dxG( i ,j+1,bi,bj)*_hFacS( i ,j+1,k,bi,bj)
     &      +vFld(i-1,j+1)*dxG(i-1,j+1,bi,bj)*_hFacS(i-1,j+1,k,bi,bj))
     &               )
         uCoriolisTerm(i,j)=
     &    +0.5*( fCoriG(i,j,bi,bj)+fCoriG(i,j+1,bi,bj)
     &         )*vBarXY*recip_dxC(i,j,bi,bj)*_recip_hFacW(i,j,k,bi,bj)
        ENDDO
       ENDDO
      ELSEIF ( selectCoriScheme .EQ. 3 ) THEN
C- Energy-conserving discretisation with hFac weighted average :
       DO j=1-OLy,sNy+OLy-1
        DO i=2-OLx,sNx+OLx
         vBarXm = halfRL *(
     &       vFld( i , j )*dxG( i , j ,bi,bj)*_hFacS( i , j ,k,bi,bj)
     &      +vFld(i-1, j )*dxG(i-1, j ,bi,bj)*_hFacS(i-1, j ,k,bi,bj) )
         vBarXp = halfRL *(
     &       vFld( i ,j+1)*dxG( i ,j+1,bi,bj)*_hFacS( i ,j+1,k,bi,bj)
     &      +vFld(i-1,j+1)*dxG(i-1,j+1,bi,bj)*_hFacS(i-1,j+1,k,bi,bj) )
         uCoriolisTerm(i,j) = +0.5 _d 0
     &        *( vBarXm*fCoriG(i, j ,bi,bj)
     &          +vBarXp*fCoriG(i,j+1,bi,bj)
     &         )*recip_dxC(i,j,bi,bj)*_recip_hFacW(i,j,k,bi,bj)
        ENDDO
       ENDDO
      ELSE
        STOP 'MOM_VI_CORIOLIS: invalid selectCoriScheme'
      ENDIF

      IF ( selectCoriScheme .EQ. 0 ) THEN
C- Simple average, no hFac :
       DO j=2-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx-1
         uBarXY=0.25*(
     &      (uFld( i , j )*dyG( i , j ,bi,bj)
     &      +uFld( i ,j-1)*dyG( i ,j-1,bi,bj))
     &     +(uFld(i+1, j )*dyG(i+1, j ,bi,bj)
     &      +uFld(i+1,j-1)*dyG(i+1,j-1,bi,bj))
     &               )
         vCoriolisTerm(i,j)=
     &    -0.5*( fCoriG(i,j,bi,bj)+fCoriG(i+1,j,bi,bj)
     &         )*uBarXY*recip_dyC(i,j,bi,bj)*_maskS(i,j,k,bi,bj)
        ENDDO
       ENDDO
      ELSEIF ( selectCoriScheme .EQ. 1 ) THEN
C- Partial-cell generalization of the Wet-point average method :
C     (formerly called: useJamartWetPoints)
       DO j=2-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx-1
         uBarXY=(
     &      (uFld( i , j )*dyG( i , j ,bi,bj)*_hFacW( i , j ,k,bi,bj)
     &      +uFld( i ,j-1)*dyG( i ,j-1,bi,bj)*_hFacW( i ,j-1,k,bi,bj))
     &     +(uFld(i+1, j )*dyG(i+1, j ,bi,bj)*_hFacW(i+1, j ,k,bi,bj)
     &      +uFld(i+1,j-1)*dyG(i+1,j-1,bi,bj)*_hFacW(i+1,j-1,k,bi,bj)))
     &   / MAX( epsil,(_hFacW( i ,j,k,bi,bj)+_hFacW( i ,j-1,k,bi,bj))
     &               +(_hFacW(i+1,j,k,bi,bj)+_hFacW(i+1,j-1,k,bi,bj)) )
         vCoriolisTerm(i,j)=
     &    -0.5*( fCoriG(i,j,bi,bj)+fCoriG(i+1,j,bi,bj)
     &         )*uBarXY*recip_dyC(i,j,bi,bj)*_maskS(i,j,k,bi,bj)
        ENDDO
       ENDDO
      ELSEIF ( selectCoriScheme .EQ. 2 ) THEN
C- hFac weighted average :
       DO j=2-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx-1
         uBarXY=0.25*(
     &      (uFld( i , j )*dyG( i , j ,bi,bj)*_hFacW( i , j ,k,bi,bj)
     &      +uFld( i ,j-1)*dyG( i ,j-1,bi,bj)*_hFacW( i ,j-1,k,bi,bj))
     &     +(uFld(i+1, j )*dyG(i+1, j ,bi,bj)*_hFacW(i+1, j ,k,bi,bj)
     &      +uFld(i+1,j-1)*dyG(i+1,j-1,bi,bj)*_hFacW(i+1,j-1,k,bi,bj))
     &               )
         vCoriolisTerm(i,j)=
     &    -0.5*( fCoriG(i,j,bi,bj)+fCoriG(i+1,j,bi,bj)
     &         )*uBarXY*recip_dyC(i,j,bi,bj)*_recip_hFacS(i,j,k,bi,bj)
        ENDDO
       ENDDO
      ELSEIF ( selectCoriScheme .EQ. 3 ) THEN
C- Energy-conserving discretisation with hFac weighted average :
       DO j=2-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx-1
         uBarYm = halfRL *(
     &       uFld( i , j )*dyG( i , j ,bi,bj)*_hFacW( i , j ,k,bi,bj)
     &      +uFld( i ,j-1)*dyG( i ,j-1,bi,bj)*_hFacW( i ,j-1,k,bi,bj) )
         uBarYp = halfRL *(
     &       uFld(i+1, j )*dyG(i+1, j ,bi,bj)*_hFacW(i+1, j ,k,bi,bj)
     &      +uFld(i+1,j-1)*dyG(i+1,j-1,bi,bj)*_hFacW(i+1,j-1,k,bi,bj) )
         vCoriolisTerm(i,j) = -0.5 _d 0
     &        *( uBarYm*fCoriG( i ,j,bi,bj)
     &          +uBarYp*fCoriG(i+1,j,bi,bj)
     &         )*recip_dyC(i,j,bi,bj)*_recip_hFacS(i,j,k,bi,bj)
        ENDDO
       ENDDO
      ELSE
        STOP 'MOM_VI_CORIOLIS: invalid selectCoriScheme'
      ENDIF

      RETURN
      END

#include "OCN_CPL_OPTIONS.h"

CBOP
C     !ROUTINE: CPL_WRITE_PICKUP
C     !INTERFACE:
      SUBROUTINE CPL_WRITE_PICKUP(
     I                             suff, myTime, myIter, myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE CPL_WRITE_PICKUP                              |
C     | o Store coupling state for restart.                      |
C     | - Oceanic version -                                      |
C     *==========================================================*
C     | Presently, the atmospheric compon. is in charge of the   |
C     |  writing of coupling fields ; nothing done here for now. |
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "CPL_PARAMS.h"
#include "OCNCPL.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     permPickup :: write a permanent pickup
C     suff    :: suffix for pickup file (eg. ckptA or 0000000010)
C     myTime  :: Current time in simulation
C     myIter  :: Current iteration number in simulation
C     myThid  :: My Thread Id number
c     LOGICAL permPickup
      CHARACTER*(*) suff
      _RL     myTime
      INTEGER myIter
      INTEGER myThid
CEOP

#ifdef COMPONENT_MODULE
C     == Local variables ==
C     fn          :: Workspace for building file name
C     rec_ind     :: index of the record in pickup file
      CHARACTER*(MAX_LEN_FNAM) fn
      INTEGER prec, rec_ind

      WRITE(fn,'(A,A)') 'pickup_cpl.',suff
      prec = precFloat64
      rec_ind=0

c     IF ( .NOT. cpl_earlyExpImpCall ) THEN
c       CALL WRITE_REC_3D_RL( fn,prec,1, atmSLPr   , 1, myIter, myThid )
c       CALL WRITE_REC_3D_RL( fn,prec,1, HeatFlux  , 2, myIter, myThid )
c       CALL WRITE_REC_3D_RL( fn,prec,1, qShortWave, 3, myIter, myThid )
c       CALL WRITE_REC_3D_RL( fn,prec,1, tauX      , 4, myIter, myThid )
c       CALL WRITE_REC_3D_RL( fn,prec,1, tauY      , 5, myIter, myThid )
c       CALL WRITE_REC_3D_RL( fn,prec,1, FWFlux    , 6, myIter, myThid )
c       CALL WRITE_REC_3D_RL( fn,prec,1, iceSaltFlx, 7, myIter, myThid )
c       CALL WRITE_REC_3D_RL( fn,prec,1, seaIceMass, 8, myIter, myThid )
c       rec_ind=8
c     ENDIF

#ifdef ALLOW_DIC
      IF ( ocn_cplExch_DIC ) THEN
        rec_ind = rec_ind + 1
        CALL WRITE_REC_3D_RL( fn, prec, 1,
     &                        fluxCO2cpl, rec_ind, myIter, myThid )
      ENDIF
#endif /* ALLOW_DIC */

#endif /* COMPONENT_MODULE */

      RETURN
      END

module OAD_rev

  implicit none

  private
  public :: modeType, our_rev_mode, OAD_revInit, &
OAD_revPlain, OAD_revTape, OAD_revAdjoint, & 
OAD_revStorePlain, OAD_revRestoreTape, &
our_indent, splitPrint, oad_dump_revmod

  type modeType
     logical :: arg_store=.FALSE.
     logical :: arg_restore=.FALSE.
     logical :: res_store=.FALSE.
     logical :: res_restore=.FALSE.
     logical :: plain=.FALSE.
     logical :: tape=.FALSE.
     logical :: adjoint=.FALSE.
     logical :: switchedToCheckpoint=.FALSE.
     logical :: strictAnonymous=.TRUE.
  end type modeType

  type(modeType), save :: our_rev_mode

  interface OAD_revInit
     module procedure init
  end interface
  
  interface OAD_revPlain
     module procedure plain
  end interface
  
  interface OAD_revTape
     module procedure tape
  end interface
  
  interface OAD_revAdjoint
     module procedure adjoint
  end interface
  
  interface OAD_revStorePlain
     module procedure storePlain
  end interface
  
  interface OAD_revRestoreTape
     module procedure restoreTape
  end interface

  integer, save:: our_indent=0
  logical, save:: splitPrint=.false.

  interface oad_dump_revmod
     module procedure dump_revmod
  end interface

contains

  subroutine init()
    our_rev_mode%arg_store=.FALSE.
    our_rev_mode%arg_restore=.FALSE.
    our_rev_mode%res_store=.FALSE.
    our_rev_mode%res_restore=.FALSE.
    our_rev_mode%plain=.TRUE.
    our_rev_mode%tape=.FALSE.
    our_rev_mode%adjoint=.FALSE.
  end subroutine 

  subroutine plain()
    our_rev_mode%arg_store=.FALSE.
    our_rev_mode%arg_restore=.FALSE.
    our_rev_mode%res_store=.FALSE.
    our_rev_mode%res_restore=.FALSE.
    our_rev_mode%plain=.TRUE.
    our_rev_mode%tape=.FALSE.
    our_rev_mode%adjoint=.FALSE.
  end subroutine 

  subroutine tape()
    our_rev_mode%arg_store=.FALSE.
    our_rev_mode%arg_restore=.FALSE.
    our_rev_mode%res_store=.FALSE.
    our_rev_mode%res_restore=.FALSE.
    our_rev_mode%plain=.FALSE.
    our_rev_mode%tape=.TRUE.
    our_rev_mode%adjoint=.FALSE.
  end subroutine 

  subroutine adjoint()
    our_rev_mode%arg_store=.FALSE.
    our_rev_mode%arg_restore=.FALSE.
    our_rev_mode%res_store=.FALSE.
    our_rev_mode%res_restore=.FALSE.
    our_rev_mode%plain=.FALSE.
    our_rev_mode%tape=.FALSE.
    our_rev_mode%adjoint=.TRUE.
  end subroutine 

  subroutine storePlain()
    our_rev_mode%arg_store=.TRUE.
    our_rev_mode%arg_restore=.FALSE.
    our_rev_mode%res_store=.FALSE.
    our_rev_mode%res_restore=.FALSE.
    our_rev_mode%plain=.TRUE.
    our_rev_mode%tape=.FALSE.
    our_rev_mode%adjoint=.FALSE.
  end subroutine 

  subroutine restoreTape()
    our_rev_mode%arg_store=.FALSE.
    our_rev_mode%arg_restore=.TRUE.
    our_rev_mode%res_store=.FALSE.
    our_rev_mode%res_restore=.FALSE.
    our_rev_mode%plain=.FALSE.
    our_rev_mode%tape=.TRUE.
    our_rev_mode%adjoint=.FALSE.
  end subroutine 

  subroutine dump_revmod()
    write(*,'(A,L,A,L,A,L,A,L,A,L,A,L)', ADVANCE='NO') & 
         ' As:',our_rev_mode%arg_store, &
         ' Ar:',our_rev_mode%arg_restore, &
         ' Pl:',our_rev_mode%plain, &
         ' Ta:',our_rev_mode%tape, &
         ' Ad:',our_rev_mode%adjoint, &
         ' Sw:',our_rev_mode%switchedToCheckpoint
  end subroutine dump_revmod

end module OAD_rev

#include "AIM_OPTIONS.h"

      SUBROUTINE LSCOND (PSA,dpFac,QA,QSAT,
     O                   PRECLS,DTLSC,DQLSC,
     I                   kGrd,bi,bj,myThid)
C--
C--   SUBROUTINE LSCOND (PSA,QA,QSAT,
C--  *                   PRECLS,DTLSC,DQLSC)
C--
C--   Purpose: Compute large-scale precipitation and
C--            associated tendencies of temperature and moisture
C--   Input:   PSA    = norm. surface pressure [p/p0]           (2-dim)
C              dpFac  = cell delta_P fraction                   (3-dim)
C--            QA     = specific humidity [g/kg]                (3-dim)
C--            QSAT   = saturation spec. hum. [g/kg]            (3-dim)
C--   Output:  PRECLS = large-scale precipitation [g/(m^2 s)]   (2-dim)
C--            DTLSC  = temperature tendency from l.s. cond     (3-dim)
C--            DQLSC  = hum. tendency [g/(kg s)] from l.s. cond (3-dim)
C    Input:    kGrd   = Ground level index              (2-dim)
C              bi,bj  = tile index
C              myThid = Thread number for this instance of the routine
C--

      IMPLICIT NONE

C     Resolution parameters

C-- size for MITgcm & Physics package :
#include "AIM_SIZE.h"

#include "EEPARAMS.h"

C     Physical constants + functions of sigma and latitude

#include "com_physcon.h"

C     Large-scale condensation constants

#include "com_lsccon.h"

C-- Routine arguments:
      _RL PSA(NGP), dpFac(NGP,NLEV), QA(NGP,NLEV), QSAT(NGP,NLEV)
      _RL PRECLS(NGP), DTLSC(NGP,NLEV), DQLSC(NGP,NLEV)
      INTEGER  kGrd(NGP)
      INTEGER  bi,bj,myThid

#ifdef ALLOW_AIM

C-- Local variables:
      INTEGER J, K
      _RL PSA2(NGP)

C- jmc: declare all local variables:
      _RL RTLSC, TFACT, PRG
      _RL SIG2, RHREF, DQMAX, PFACT
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C--   1. Initialization

c_FM  QSMAX = 50.

      RTLSC = 1./(TRLSC*3600.)
      TFACT = ALHC/CP
      PRG = P0/GG

      DO J=1,NGP
        DTLSC(J,1) = 0.
        DQLSC(J,1) = 0.
        PRECLS(J)  = 0.
        PSA2(J)    = PSA(J)*PSA(J)
      ENDDO

C--   2. Tendencies of temperature and moisture
C        NB. A maximum heating rate is imposed to avoid
C            grid-point-storm instability

      DO K=2,NLEV
        SIG2=SIG(K)*SIG(K)
c_FM    RHREF = RHLSC+DRHLSC*(SIG2-1.)
c_FM    DQMAX = (1.1-RHREF)*QSMAX*SIG2*RTLSC
        DO J=1,NGP
          RHREF = RHLSC+DRHLSC*(SIG2/PSA2(J) - 1. _d 0)
          DQMAX = (1.1 _d 0-RHREF)*QSMAX*SIG2*RTLSC
          DQLSC(J,K) = MIN(0. _d 0,(RHREF*QSAT(J,K)-QA(J,K)))*RTLSC
c_FM      DTLSC(J,K) = TFACT*MIN(-DQLSC(J,K),DQMAX*PSA2(J))
c         DTLSC(J,K) = TFACT*MIN(-DQLSC(J,K),DQMAX)
C-jmc: the threshold on latent heat (above) breaks the energy conservation;
C      to fix this, apply the threshold directly to the condensation
          DQLSC(J,K) = MAX(-DQMAX, DQLSC(J,K) )
          DTLSC(J,K) = -TFACT*DQLSC(J,K)
        ENDDO
      ENDDO

C--   Scale LSC tendencies by dpFac (=Partial-Cell factor) (=> Mass Weighted)
C     to get homogenous units & scaling across all physics tendencies.
      DO K=2,NLEV
        DO J=1,NGP
          DQLSC(J,K) = DQLSC(J,K)*dpFac(J,K)
          DTLSC(J,K) = DTLSC(J,K)*dpFac(J,K)
        ENDDO
      ENDDO

C--   3. Large-scale precipitation

      DO J=1,NGP
        DO K=2,kGrd(J)
          PFACT = DSIG(K)*PRG
          PRECLS(J) = PRECLS(J)-PFACT*DQLSC(J,K)
        ENDDO
      ENDDO

c_FM  DO J=1,NGP
c_FM    PRECLS(J) = PRECLS(J)*PSA(J)
c_FM  ENDDO

C--
#endif /* ALLOW_AIM */

      RETURN
      END

#include "GAD_OPTIONS.h"

CBOP
C     !ROUTINE: GAD_INIT_FIXED
C     !INTERFACE:
      SUBROUTINE GAD_INIT_FIXED( myThid )
C     !DESCRIPTION:
C     Routine to initialize Generic Advection/Diffusion variables and
C     constants.

C     !USES:
      IMPLICIT NONE
C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GAD.h"

C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
C     myThid  :: My Thread Id. number
      INTEGER myThid
CEOP

C     !FUNCTIONS
      INTEGER  GAD_ADVSCHEME_GET
      EXTERNAL GAD_ADVSCHEME_GET

C     !LOCAL VARIABLES:
C     === Local variables ===
C     msgBuf  :: Informational/error message buffer
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      INTEGER   errCode, n, minSize

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      _BEGIN_MASTER(myThid)

C-- Initialise advection scheme parameter
      CALL GAD_ADVSCHEME_INIT( myThid )

C-  Set advection scheme parameter (overlap minimum size) for each scheme:
      errCode = 0
      CALL GAD_ADVSCHEME_SET( ENUM_UPWIND_1RST   , 1, errCode, myThid )
      CALL GAD_ADVSCHEME_SET( ENUM_CENTERED_2ND  , 1, errCode, myThid )
      CALL GAD_ADVSCHEME_SET( ENUM_UPWIND_3RD    , 2, errCode, myThid )
      CALL GAD_ADVSCHEME_SET( ENUM_CENTERED_4TH  , 2, errCode, myThid )
      CALL GAD_ADVSCHEME_SET( ENUM_DST2          , 1, errCode, myThid )
      CALL GAD_ADVSCHEME_SET( ENUM_FLUX_LIMIT    , 2, errCode, myThid )
      CALL GAD_ADVSCHEME_SET( ENUM_DST3          , 2, errCode, myThid )
      CALL GAD_ADVSCHEME_SET( ENUM_DST3_FLUX_LIMIT,2, errCode, myThid )
      CALL GAD_ADVSCHEME_SET( ENUM_OS7MP         , 4, errCode, myThid )
      CALL GAD_ADVSCHEME_SET( ENUM_SOM_PRATHER   , 1, errCode, myThid )
      CALL GAD_ADVSCHEME_SET( ENUM_SOM_LIMITER   , 1, errCode, myThid )
      CALL GAD_ADVSCHEME_SET( ENUM_PPM_NULL_LIMIT, 3, errCode, myThid )
      CALL GAD_ADVSCHEME_SET( ENUM_PPM_MONO_LIMIT, 3, errCode, myThid )
      CALL GAD_ADVSCHEME_SET( ENUM_PPM_WENO_LIMIT, 3, errCode, myThid )
      CALL GAD_ADVSCHEME_SET( ENUM_PQM_NULL_LIMIT, 4, errCode, myThid )
      CALL GAD_ADVSCHEME_SET( ENUM_PQM_MONO_LIMIT, 4, errCode, myThid )
      CALL GAD_ADVSCHEME_SET( ENUM_PQM_WENO_LIMIT, 4, errCode, myThid )
      IF ( errCode.GT.0 ) THEN
        WRITE(msgBuf,'(A)')
     &     'GAD_INIT_FIXED: Invalid Advection-Scheme Number setting'
        CALL PRINT_ERROR( msgBuf, myThid )
        STOP 'ABNORMAL END: S/R GAD_INIT_FIXED'
      ENDIF

C-  Initialise overlap minimum size for GAD pkg:
      GAD_OlMinSize(1) = 0
      GAD_OlMinSize(2) = 0
      GAD_OlMinSize(3) = 1

C-  Set SOM I/O suffix (used for pickup, diagnostics ...)
      DO n=1,nSOM
        somSfx(n) = '  '
        IF (n.EQ.1) somSfx(n) = '_x'
        IF (n.EQ.2) somSfx(n) = '_y'
        IF (n.EQ.3) somSfx(n) = '_z'
        IF (n.EQ.4) somSfx(n) = 'xx'
        IF (n.EQ.5) somSfx(n) = 'yy'
        IF (n.EQ.6) somSfx(n) = 'zz'
        IF (n.EQ.7) somSfx(n) = 'xy'
        IF (n.EQ.8) somSfx(n) = 'xz'
        IF (n.EQ.9) somSfx(n) = 'yz'
      ENDDO

C-- Check that Temp & Salt have valid advection scheme number:
      n = GAD_ADVSCHEME_GET( tempAdvScheme )
      IF ( n.LT.0 ) THEN
        WRITE(msgBuf,'(2A,I6)') 'GAD_INIT_FIXED: ',
     &   'invalid Temp. advection scheme number=', tempAdvScheme
        CALL PRINT_ERROR( msgBuf, myThid )
        STOP 'ABNORMAL END: S/R GAD_INIT_FIXED'
      ENDIF
      n = GAD_ADVSCHEME_GET( tempVertAdvScheme )
      IF ( n.LT.0 ) THEN
        WRITE(msgBuf,'(2A,I6)') 'GAD_INIT_FIXED: ',
     &   'invalid Temp. Vert. Adv.scheme number=', tempVertAdvScheme
        CALL PRINT_ERROR( msgBuf, myThid )
        STOP 'ABNORMAL END: S/R GAD_INIT_FIXED'
      ENDIF
      n = GAD_ADVSCHEME_GET( saltAdvScheme )
      IF ( n.LT.0 ) THEN
        WRITE(msgBuf,'(2A,I6)') 'GAD_INIT_FIXED: ',
     &   'invalid Salt. advection scheme number=', saltAdvScheme
        CALL PRINT_ERROR( msgBuf, myThid )
        STOP 'ABNORMAL END: S/R GAD_INIT_FIXED'
      ENDIF
      n = GAD_ADVSCHEME_GET( saltVertAdvScheme )
      IF ( n.LT.0 ) THEN
        WRITE(msgBuf,'(2A,I6)') 'GAD_INIT_FIXED: ',
     &   'invalid Salt. Vert. Adv.scheme number=', saltVertAdvScheme
        CALL PRINT_ERROR( msgBuf, myThid )
        STOP 'ABNORMAL END: S/R GAD_INIT_FIXED'
      ENDIF

C-- Set Temp & Salt 2nd-Order Moment Advec. flag according to advection scheme
      tempSOM_Advection = tempAdvScheme.GE.ENUM_SOM_PRATHER
     &              .AND. tempAdvScheme.LE.ENUM_SOM_LIMITER
      tempSOM_Advection = tempSOM_Advection .AND. tempAdvection
      saltSOM_Advection = saltAdvScheme.GE.ENUM_SOM_PRATHER
     &              .AND. saltAdvScheme.LE.ENUM_SOM_LIMITER
      saltSOM_Advection = saltSOM_Advection .AND. saltAdvection

C-- Set Temp & Salt multi-Dim Advec. flag according to advection scheme used
      tempMultiDimAdvec = multiDimAdvection .AND. tempAdvection
      saltMultiDimAdvec = multiDimAdvection .AND. saltAdvection
      IF ( tempAdvScheme.EQ.ENUM_CENTERED_2ND
     & .OR.tempAdvScheme.EQ.ENUM_UPWIND_3RD
     & .OR.tempAdvScheme.EQ.ENUM_CENTERED_4TH ) THEN
           tempMultiDimAdvec = .FALSE.
      ENDIF
      IF ( saltAdvScheme.EQ.ENUM_CENTERED_2ND
     & .OR.saltAdvScheme.EQ.ENUM_UPWIND_3RD
     & .OR.saltAdvScheme.EQ.ENUM_CENTERED_4TH ) THEN
           saltMultiDimAdvec = .FALSE.
      ENDIF

C-- Set general multi-Dim Advec. flag when at least 1 tracer use multi-Dim Advec.
      useMultiDimAdvec = useMultiDimAdvec.OR.tempMultiDimAdvec
      useMultiDimAdvec = useMultiDimAdvec.OR.saltMultiDimAdvec

C-- Set Temp & Salt Adams-Bashforth flag according to advection scheme used
      AdamsBashforthGt = .FALSE.
      AdamsBashforthGs = .FALSE.
      AdamsBashforth_T = .FALSE.
      AdamsBashforth_S = .FALSE.
      IF ( tempAdvScheme.EQ.ENUM_CENTERED_2ND
     & .OR.tempAdvScheme.EQ.ENUM_UPWIND_3RD
     & .OR.tempAdvScheme.EQ.ENUM_CENTERED_4TH ) THEN
           AdamsBashforthGt = tempStepping
      ENDIF
      IF ( saltAdvScheme.EQ.ENUM_CENTERED_2ND
     & .OR.saltAdvScheme.EQ.ENUM_UPWIND_3RD
     & .OR.saltAdvScheme.EQ.ENUM_CENTERED_4TH ) THEN
           AdamsBashforthGs = saltStepping
      ENDIF
      IF ( .NOT.doAB_onGtGs ) THEN
        AdamsBashforth_T = AdamsBashforthGt
        AdamsBashforth_S = AdamsBashforthGs
        AdamsBashforthGt = .FALSE.
        AdamsBashforthGs = .FALSE.
      ENDIF

#ifdef GAD_SMOLARKIEWICZ_HACK
      SmolarkiewiczMaxFrac = 1. _d 0
#endif

C-- Set Overlap minimum size according to Temp & Salt advection
      IF ( tempAdvection ) THEN
         minSize = GAD_ADVSCHEME_GET( tempAdvScheme )
         GAD_OlMinSize(1) = MAX( GAD_OlMinSize(1), minSize )
      ENDIF
      IF ( saltAdvection ) THEN
         minSize = GAD_ADVSCHEME_GET( saltAdvScheme )
         GAD_OlMinSize(1) = MAX( GAD_OlMinSize(1), minSize )
      ENDIF
      IF ( useCubedSphereExchange .AND. useMultiDimAdvec ) THEN
C-    multi-dim-advection on CS-grid requires to double the size of OLx,OLy
        GAD_OlMinSize(3) = MAX( GAD_OlMinSize(3), 2 )
      ENDIF
      WRITE(msgBuf,'(A,9I3)')
     &      'GAD_INIT_FIXED: GAD_OlMinSize=', GAD_OlMinSize
      CALL PRINT_MESSAGE(msgBuf,standardMessageUnit,SQUEEZE_RIGHT,1)

      _END_MASTER(myThid)

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#ifdef ALLOW_DIAGNOSTICS
      IF ( useDiagnostics ) THEN
C--   Add diagnostics of Temp & Salt fluxes to the (long) list of diagnostics:
        CALL GAD_DIAGNOSTICS_INIT( myThid )
      ENDIF
#endif /* ALLOW_DIAGNOSTICS */

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C-- Print out GAD parameters :
      _BEGIN_MASTER(myThid)

      WRITE(msgBuf,'(A)') ' '
      CALL PRINT_MESSAGE(msgBuf,standardMessageUnit,SQUEEZE_RIGHT,1)
      WRITE(msgBuf,'(A)') '// ==================================='
      CALL PRINT_MESSAGE(msgBuf,standardMessageUnit,SQUEEZE_RIGHT,1)
      WRITE(msgBuf,'(A)')'// GAD parameters :'
      CALL PRINT_MESSAGE(msgBuf,standardMessageUnit,SQUEEZE_RIGHT,1)
      WRITE(msgBuf,'(A)') '// ==================================='
      CALL PRINT_MESSAGE(msgBuf,standardMessageUnit,SQUEEZE_RIGHT,1)

      CALL WRITE_0D_I( tempAdvScheme, INDEX_NONE,
     & 'tempAdvScheme =',
     & '   /* Temp. Horiz.Advection scheme selector */')
      CALL WRITE_0D_I( tempVertAdvScheme, INDEX_NONE,
     & 'tempVertAdvScheme =',
     & '   /* Temp. Vert. Advection scheme selector */')
      CALL WRITE_0D_L( tempMultiDimAdvec, INDEX_NONE,
     & 'tempMultiDimAdvec =',
     & '   /* use Muti-Dim Advec method for Temp */')
      CALL WRITE_0D_L( tempSOM_Advection, INDEX_NONE,
     & 'tempSOM_Advection =',
     & ' /* use 2nd Order Moment Advection for Temp */')
      CALL WRITE_0D_L( AdamsBashforthGt, INDEX_NONE,
     & 'AdamsBashforthGt =',
     & ' /* apply Adams-Bashforth extrapolation on Gt */')
      CALL WRITE_0D_L( AdamsBashforth_T, INDEX_NONE,
     & 'AdamsBashforth_T =',
     & ' /* apply Adams-Bashforth extrapolation on Temp */')
#ifdef GAD_SMOLARKIEWICZ_HACK
      CALL WRITE_0D_L( temp_stayPositive, INDEX_NONE,
     & 'temp_stayPositive =',
     & ' /* use Smolarkiewicz Hack for Temperature */')
#endif

      CALL WRITE_0D_I( saltAdvScheme, INDEX_NONE,
     & 'saltAdvScheme =',
     & '   /* Salt. Horiz.advection scheme selector */')
      CALL WRITE_0D_I( saltVertAdvScheme, INDEX_NONE,
     & 'saltVertAdvScheme =',
     & '   /* Salt. Vert. Advection scheme selector */')
      CALL WRITE_0D_L( saltMultiDimAdvec, INDEX_NONE,
     & 'saltMultiDimAdvec =',
     & '   /* use Muti-Dim Advec method for Salt */')
      CALL WRITE_0D_L( saltSOM_Advection, INDEX_NONE,
     & 'saltSOM_Advection =',
     & ' /* use 2nd Order Moment Advection for Salt */')
      CALL WRITE_0D_L( AdamsBashforthGs, INDEX_NONE,
     & 'AdamsBashforthGs =',
     & ' /* apply Adams-Bashforth extrapolation on Gs */')
      CALL WRITE_0D_L( AdamsBashforth_S, INDEX_NONE,
     & 'AdamsBashforth_S =',
     & ' /* apply Adams-Bashforth extrapolation on Salt */')
#ifdef GAD_SMOLARKIEWICZ_HACK
      CALL WRITE_0D_L( salt_stayPositive, INDEX_NONE,
     & 'salt_stayPositive =',
     & ' /* use Smolarkiewicz Hack for Salinity */')
#endif

#ifdef GAD_SMOLARKIEWICZ_HACK
      CALL WRITE_0D_RL( SmolarkiewiczMaxFrac, INDEX_NONE,
     & 'SmolarkiewiczMaxFrac =',
     & ' /* maximal fraction of tracer to flow out of a cell */')
#endif
      WRITE(msgBuf,'(A)') '// ==================================='
      CALL PRINT_MESSAGE(msgBuf,standardMessageUnit,SQUEEZE_RIGHT,1)

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      _END_MASTER(myThid)
      _BARRIER

      RETURN
      END

#include "MOM_COMMON_OPTIONS.h"

CBOP
C !ROUTINE: MOM_V_CORIOLIS_NH

C !INTERFACE: ==========================================================
      SUBROUTINE MOM_V_CORIOLIS_NH(
     I               bi, bj, k, wFld,
     O               vCoriolisTerm,
     I               myThid )

C !DESCRIPTION:
C Calculates the 3.D Coriolis term in the meridional momentum equation:
C \begin{equation*}
C - \overline{ f_prime \overline{w}^{k} }^{i}
C \end{equation*}
C consistent with Non-Hydrostatic (or quasi-hydrostatic) formulation

C !USES: ===============================================================
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"

C !INPUT PARAMETERS: ===================================================
C  bi, bj               :: tile indices
C  k                    :: vertical level
C  wFld                 :: vertical flow
C  myThid               :: thread number
      INTEGER bi, bj, k
      _RL wFld(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      INTEGER myThid

C !OUTPUT PARAMETERS: ==================================================
C  vCoriolisTerm        :: Coriolis term
      _RL vCoriolisTerm(1-OLx:sNx+OLx,1-OLy:sNy+OLy)

C !LOCAL VARIABLES: ====================================================
C  i, j                 :: loop indices
      INTEGER i, j, kp1
      _RL wMsk
CEOP

      kp1 = MIN(k+1,Nr)
      wMsk = 1.
      IF (k.EQ.Nr) wMsk = 0.

      IF ( select3dCoriScheme.EQ.1 ) THEN
C-    Original discretization of 2*Omega*cos(phi)*w
C     documented as Energy conserving
       DO j=2-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
         vCoriolisTerm(i,j) = -gravitySign*halfRL
     &       *( fCoriCos(i, j ,bi,bj)*angleSinC(i, j ,bi,bj)*halfRL
     &           *( wFld(i, j , k ,bi,bj)*rVel2wUnit( k )
     &            + wFld(i, j ,kp1,bi,bj)*rVel2wUnit(kp1)*wMsk )
     &        + fCoriCos(i,j-1,bi,bj)*angleSinC(i,j-1,bi,bj)*halfRL
     &           *( wFld(i,j-1, k ,bi,bj)*rVel2wUnit( k )
     &            + wFld(i,j-1,kp1,bi,bj)*rVel2wUnit(kp1)*wMsk )
     &        )
        ENDDO
       ENDDO
      ELSE
C-    Using averaged transport:
       DO j=2-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
         vCoriolisTerm(i,j) = -gravitySign*halfRL
     &    *( fCoriCos(i, j ,bi,bj)*angleSinC(i, j ,bi,bj)
     &      *( wFld(i, j , k ,bi,bj)*rVel2wUnit( k )*deepFac2F( k )
     &       + wFld(i, j ,kp1,bi,bj)*rVel2wUnit(kp1)*deepFac2F(kp1)*wMsk
     &         )*rA(i, j ,bi,bj)*halfRL
     &     + fCoriCos(i,j-1,bi,bj)*angleSinC(i,j-1,bi,bj)
     &      *( wFld(i,j-1, k ,bi,bj)*rVel2wUnit( k )*deepFac2F( k )
     &       + wFld(i,j-1,kp1,bi,bj)*rVel2wUnit(kp1)*deepFac2F(kp1)*wMsk
     &         )*rA(i,j-1,bi,bj)*halfRL
     &     )*recip_rAs(i,j,bi,bj)*recip_deepFac2C(k)
     &      *recip_hFacS(i,j,k,bi,bj)
        ENDDO
       ENDDO
      ENDIF

      RETURN
      END

#include "PACKAGES_CONFIG.h"
#include "CPP_OPTIONS.h"

CBOP
C     !ROUTINE: INI_MODEL_IO

C     !INTERFACE:
      SUBROUTINE INI_MODEL_IO( myThid )

C     !DESCRIPTION:
C     Initialisation and setting of I/O:
C     - Check size and initialise global I/O buffer
C     - Initialise flags for pickup and for mdsio/rw.
C     - Do MNC model-IO initialisation
C     - Do Monitor-IO initialisation

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "EESUPPORT.h"
#include "PARAMS.h"
#include "RESTART.h"
#ifdef ALLOW_EXCH2
# include "W2_EXCH2_SIZE.h"
# include "W2_EXCH2_TOPOLOGY.h"
# include "W2_EXCH2_PARAMS.h"
#endif /* ALLOW_EXCH2 */
#include "EEBUFF_SCPU.h"

C     !INPUT/OUTPUT PARAMETERS:
C     myThid :: my Thread Id number
      INTEGER myThid

C     !FUNCTIONS
      INTEGER  ILNBLNK
      EXTERNAL ILNBLNK

C     !LOCAL VARIABLES:
C     msgBuf :: Informational/error message buffer
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      CHARACTER*(MAX_LEN_FNAM) namBuf
      INTEGER i, iL, pIL
      LOGICAL useGlobalBuff
#ifdef ALLOW_EXCH2
      INTEGER xySize
#endif /* ALLOW_EXCH2 */
CEOP

C-    Safety check:
#ifdef FAST_BYTESWAP
      _BEGIN_MASTER( myThid )
       WRITE(msgBuf,'(2A)') 'INI_MODEL_IO: ',
     &   'Option FAST_BYTESWAP (from CPP_EEOPTIONS.h) has been removed'
      CALL PRINT_ERROR( msgBuf, myThid )
      STOP 'ABNORMAL END: S/R INI_MODEL_IO (FAST_BYTESWAP)'
      _END_MASTER( myThid )
#endif /* FAST_BYTESWAP */
      IF ( nPx*nPy.NE.1 .AND. globalFiles
     &                  .AND. .NOT.useSingleCpuIO ) THEN
        _BEGIN_MASTER( myThid )
c       WRITE(msgBuf,'(2A)')
c    &   'INI_MODEL_IO: globalFiles=TRUE is not safe',
c    &   ' in Multi-processors (MPI) run'
c       CALL PRINT_ERROR( msgBuf , myThid)
c       WRITE(msgBuf,'(2A)')
c    &   'INI_MODEL_IO: use instead "useSingleCpuIO=.TRUE."'
c       CALL PRINT_ERROR( msgBuf , myThid)
c       STOP 'ABNORMAL END: S/R INI_MODEL_IO'
C------
C   GlobalFiles option with Multi-processors execution (with MPI) is not
C   safe: dependending on the platform & compiler, it may produce:
C    - incomplete output files (wrong size)
C    - wrong isolated values in some output files
C    - missing tiles (all zeros) in some output files.
C   A safe alternative is to set "useSingleCpuIO=.TRUE." in file "data",
C     namelist PARAM01  (and to keep the default value of globalFiles=FALSE)
C   or if you are really sure that the globalFile works well on our platform
C     & compiler, comment out the above "stop"
C-----
        WRITE(msgBuf,'(2A)')
     &   '** WARNING ** INI_MODEL_IO: globalFiles=TRUE is not safe',
     &   ' in Multi-processors (MPI) run'
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
        WRITE(msgBuf,'(2A)') '** WARNING ** INI_MODEL_IO:',
     &   ' use instead "useSingleCpuIO=.TRUE."'
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
        _END_MASTER( myThid )
      ENDIF

C-    Check size of IO buffers:
      useGlobalBuff = useSingleCpuIO
#ifdef CG2D_SINGLECPU_SUM
      useGlobalBuff = .TRUE.
#endif /* CG2D_SINGLECPU_SUM */
#ifdef ALLOW_EXCH2
      IF ( useGlobalBuff ) THEN
        xySize = exch2_global_Nx*exch2_global_Ny
#ifndef CG2D_SINGLECPU_SUM
        IF ( .NOT.W2_useE2ioLayOut ) xySize = Nx*Ny
#endif /* ndef CG2D_SINGLECPU_SUM */
        IF ( xySize.GT.W2_ioBufferSize ) THEN
          WRITE(msgBuf,'(A,2(I10,A))')
     &       'W2_ioBufferSize=', W2_ioBufferSize,
     &       ' <', xySize, ' = Size of Global 2-D map'
          CALL PRINT_ERROR( msgBuf, myThid )
          WRITE(msgBuf,'(2A)')
     &       'INI_MODEL_IO: increase W2_ioBufferSize',
     &       ' in "W2_EXCH2_SIZE.h" + recompile'
          CALL PRINT_ERROR( msgBuf, myThid )
          STOP 'ABNORMAL END: S/R INI_MODEL_IO (buffer size)'
        ENDIF
      ENDIF
#endif /* ALLOW_EXCH2 */
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C-    Only Master-thread updates IO-parameter in Common blocks:
      _BEGIN_MASTER( myThid )

C-    Initialise AB starting level
C      notes: those could be modified when reading a pickup that does
C             not correspond to what is actually needed.
      tempStartAB = nIter0
      saltStartAB = nIter0
      mom_StartAB = nIter0
      nHydStartAB = nIter0
      qHydStartAB = nIter0
      IF ( startFromPickupAB2 ) tempStartAB = MIN( nIter0 , 1 )
      saltStartAB = tempStartAB
      mom_StartAB = tempStartAB
      nHydStartAB = tempStartAB
      qHydStartAB = tempStartAB
      dPhiNHstatus= 0

C-    Initialise Alternating pickup-suffix
      nCheckLev         = 1
      checkPtSuff(1)    = 'ckptA'
      checkPtSuff(2)    = 'ckptB'

C-    Flags specific to RW and MDSIO (and PLOT_FIELDS)

C-    now we make local directories with myProcessStr appended.
      IF ( mdsioLocalDir .NE. ' ' ) THEN
        iL = ILNBLNK( mdsioLocalDir )
C     Local dir name should not be too long to fit MAX_LEN_FNAM
C     after adding file-name: set a limit to half MAX_LEN_FNAM
        IF ( 2*IL.GT.MAX_LEN_FNAM ) THEN
          WRITE(msgBuf,'(2A,I4,A)') 'INI_MODEL_IO: ',
     &    'Too long (IL=',IL,') mdsioLocalDir:'
          CALL PRINT_ERROR( msgBuf, myThid )
          WRITE(errorMessageUnit,'(3A)')
     &       'localDir: >',mdsioLocalDir(1:IL),'<'
          STOP 'ABNORMAL END: S/R INI_MODEL_IO (mdsioLocalDir)'
        ENDIF
        i = ILNBLNK( myProcessStr )
        WRITE(namBuf,'(4A)')
     &         ' mkdir -p ', mdsioLocalDir(1:iL),myProcessStr(1:i),' '
        pIL = 1 + ILNBLNK( namBuf )
#ifdef HAVE_SYSTEM
        WRITE(standardMessageUnit,'(3A)')
     &  '==> SYSTEM CALL (from INI_MODEL_IO): >',namBuf(1:pIL),'<'
        CALL SYSTEM( namBuf(1:pIL) )
#else
        WRITE(msgBuf,'(3A)') '** WARNING ** INI_MODEL_IO: ',
     &   'SYSTEM call missing (HAVE_SYSTEM undef) for mdsioLocalDir'
        CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
        WRITE(errorMessageUnit,'(4A)') '** WARNING ** INI_MODEL_IO: ',
     &   'Skip command: >',namBuf(1:pIL),'<'
#endif
        WRITE(msgBuf,'(A)') ' '
        CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
        namBuf(1:iL) = mdsioLocalDir(1:iL)
        WRITE(mdsioLocalDir,'(3A)') namBuf(1:iL),myProcessStr(1:i),'/'
      ENDIF

C-    Initialise MFLDS variables in common block
      CALL READ_MFLDS_INIT( myThid )

C     Set globalFiles flag for READ_WRITE_FLD package
      CALL SET_WRITE_GLOBAL_FLD( globalFiles )
C     Set globalFiles flag for READ_WRITE_REC package
      CALL SET_WRITE_GLOBAL_REC( globalFiles )
C     Set globalFiles flag for READ_WRITE_SEC package
      IF ( useOBCS .AND. globalFiles ) THEN
        WRITE(msgBuf,'(2A)') '** WARNING ** INI_MODEL_IO:',
     &   ' use tiled-files to write sections (for OBCS)'
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
        CALL SET_WRITE_GLOBAL_SEC( .FALSE. )
      ELSE
        CALL SET_WRITE_GLOBAL_SEC( globalFiles )
      ENDIF

      _END_MASTER( myThid )
C-    Everyone else must wait for the IO-parameters to be set
      _BARRIER

C-    Global IO-buffers initialisation
      IF ( useGlobalBuff ) THEN
        _BEGIN_MASTER( myThid )
        DO i=1,xyBuffer_size
          xy_buffer_r8(i) = 0. _d 0
          xy_buffer_r4(i) = 0.
        ENDDO
        _END_MASTER( myThid )
      ENDIF

C-    MNC model-io initialisation

#ifdef ALLOW_MNC
      IF (useMNC) THEN
C-    Initialize look-up tables for MNC
        CALL MNC_INIT( myThid )
        CALL MNC_CW_INIT( sNx,sNy,OLx,OLy,nSx,nSy,nPx,nPy,
     &                    Nr,myThid )
CEH3       IF ( mnc_echo_gvtypes ) THEN
CEH3       CALL MNC_CW_DUMP( myThid )
CEH3       ENDIF
C       Write units/set precision/etc for I/O of variables/arrays
C       belonging to the core dynamical model
        CALL INI_MNC_VARS( myThid )
      ENDIF
#endif /* ALLOW_MNC */

#ifdef ALLOW_AUTODIFF
      IF ( useAUTODIFF ) CALL AUTODIFF_INI_MODEL_IO( myThid )
#endif

#ifdef ALLOW_PROFILES
      IF ( usePROFILES ) CALL PROFILES_INI_IO( myThid )
#endif

#ifdef ALLOW_OBSFIT
      IF ( useOBSFIT ) CALL OBSFIT_INI_IO( myThid )
#endif

#ifdef ALLOW_DIAGNOSTICS
      IF ( useDiagnostics ) CALL DIAGNOSTICS_INI_IO( myThid )
#endif

#ifdef ALLOW_MONITOR
C--   Initialise MONITOR I/O streams so we can report config. info
      CALL MON_INIT( myThid )
#endif

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      RETURN
      END

#include "CPP_OPTIONS.h"

CBOP
C     !ROUTINE: EXTERNAL_FORCING_U
C     !INTERFACE:
      SUBROUTINE EXTERNAL_FORCING_U(
     I           iMin,iMax, jMin,jMax, bi,bj, kLev,
     I           myTime, myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R EXTERNAL_FORCING_U
C     | o Contains problem specific forcing for zonal velocity.
C     *==========================================================*
C     | Adds terms to gU for forcing by external sources
C     | e.g. wind stress, bottom friction etc ...
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     == Global data ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "DYNVARS.h"
#include "FFIELDS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     iMin,iMax :: Working range of x-index for applying forcing.
C     jMin,jMax :: Working range of y-index for applying forcing.
C     bi,bj     :: Current tile indices
C     kLev      :: Current vertical level index
C     myTime    :: Current time in simulation
C     myThid    :: Thread Id number
      INTEGER iMin, iMax, jMin, jMax, kLev, bi, bj
      _RL myTime
      INTEGER myThid

C     !LOCAL VARIABLES:
C     == Local variables ==
C     i,j       :: Loop counters
      INTEGER i, j
CEOP
      _RL recip_P0g, termP, kV, kF, sigma_b

C--   Forcing term(s)
      kF=1. _d 0/86400. _d 0
      sigma_b = 0.7 _d 0
c     DO j=1,sNy
C-jmc: Without CD-scheme, this is OK ; but with CD-scheme, needs to cover [0:sNy+1]
      DO j=0,sNy+1
       DO i=1,sNx+1
        IF ( hFacW(i,j,kLev,bi,bj) .GT. 0. ) THEN
         recip_P0g=MAX(recip_Rcol(i,j,bi,bj),recip_Rcol(i-1,j,bi,bj))
         termP=0.5 _d 0*( MIN(rF(kLev)*recip_P0g,1. _d 0)
     &                   +rF(kLev+1)*recip_P0g )
c        termP=0.5 _d 0*( rF(kLev) + rF(kLev+1) )*recip_P0g
         kV=kF*MAX( 0. _d 0, (termP-sigma_b)/(1. _d 0-sigma_b) )
         gU(i,j,kLev,bi,bj)=gU(i,j,kLev,bi,bj)
     &                     -kV*uVel(i,j,kLev,bi,bj)
        ENDIF
       ENDDO
      ENDDO

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: EXTERNAL_FORCING_V
C     !INTERFACE:
      SUBROUTINE EXTERNAL_FORCING_V(
     I           iMin,iMax, jMin,jMax, bi,bj, kLev,
     I           myTime, myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R EXTERNAL_FORCING_V
C     | o Contains problem specific forcing for merid velocity.
C     *==========================================================*
C     | Adds terms to gV for forcing by external sources
C     | e.g. wind stress, bottom friction etc ...
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     == Global data ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "DYNVARS.h"
#include "FFIELDS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     iMin,iMax :: Working range of x-index for applying forcing.
C     jMin,jMax :: Working range of y-index for applying forcing.
C     bi,bj     :: Current tile indices
C     kLev      :: Current vertical level index
C     myTime    :: Current time in simulation
C     myThid    :: Thread Id number
      INTEGER iMin, iMax, jMin, jMax, kLev, bi, bj
      _RL myTime
      INTEGER myThid

C     !LOCAL VARIABLES:
C     == Local variables ==
C     i,j       :: Loop counters
      INTEGER i, j
CEOP
      _RL recip_P0g, termP, kV, kF, sigma_b

C--   Forcing term(s)
      kF=1. _d 0/86400. _d 0
      sigma_b = 0.7 _d 0
      DO j=1,sNy+1
c      DO i=1,sNx
C-jmc: Without CD-scheme, this is OK ; but with CD-scheme, needs to cover [0:sNx+1]
       DO i=0,sNx+1
        IF ( hFacS(i,j,kLev,bi,bj) .GT. 0. ) THEN
         recip_P0g=MAX(recip_Rcol(i,j,bi,bj),recip_Rcol(i,j-1,bi,bj))
         termP=0.5 _d 0*( MIN(rF(kLev)*recip_P0g,1. _d 0)
     &                   +rF(kLev+1)*recip_P0g )
c        termP=0.5 _d 0*( rF(kLev) + rF(kLev+1) )*recip_P0g
         kV=kF*MAX( 0. _d 0, (termP-sigma_b)/(1. _d 0-sigma_b) )
         gV(i,j,kLev,bi,bj)=gV(i,j,kLev,bi,bj)
     &                      -kV*vVel(i,j,kLev,bi,bj)
        ENDIF
       ENDDO
      ENDDO

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: EXTERNAL_FORCING_T
C     !INTERFACE:
      SUBROUTINE EXTERNAL_FORCING_T(
     I           iMin,iMax, jMin,jMax, bi,bj, kLev,
     I           myTime, myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R EXTERNAL_FORCING_T
C     | o Contains problem specific forcing for temperature.
C     *==========================================================*
C     | Adds terms to gT for forcing by external sources
C     | e.g. heat flux, climatalogical relaxation, etc ...
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     == Global data ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "DYNVARS.h"
#include "FFIELDS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     iMin,iMax :: Working range of x-index for applying forcing.
C     jMin,jMax :: Working range of y-index for applying forcing.
C     bi,bj     :: Current tile indices
C     kLev      :: Current vertical level index
C     myTime    :: Current time in simulation
C     myThid    :: Thread Id number
      INTEGER iMin, iMax, jMin, jMax, kLev, bi, bj
      _RL myTime
      INTEGER myThid

C     !LOCAL VARIABLES:
C     == Local variables ==
C     i,j       :: Loop counters
      INTEGER i, j
CEOP
      _RL thetaLim,kT,ka,ks,sigma_b,term1,term2,thetaEq,termP

C--   Forcing term(s)
      ka=1. _d 0/(40. _d 0*86400. _d 0)
      ks=1. _d 0/(4. _d 0 *86400. _d 0)
      sigma_b = 0.7 _d 0
      DO j=1,sNy
       DO i=1,sNx
         term1=60. _d 0*(SIN(yC(i,j,bi,bj)*deg2rad)**2)
         termP=0.5 _d 0*( rF(kLev) + rF(kLev+1) )
         term2=10. _d 0*LOG(termP/atm_po)
     &            *(COS(yC(i,j,bi,bj)*deg2rad)**2)
         thetaLim = 200. _d 0/ ((termP/atm_po)**atm_kappa)
         thetaEq=315. _d 0-term1-term2
         thetaEq=MAX(thetaLim,thetaEq)
         termP=0.5 _d 0*( MIN(rF(kLev),Ro_surf(i,j,bi,bj))+rF(kLev+1) )
         kT=ka+(ks-ka)
     &     *MAX(0. _d 0,
     &       (termP*recip_Rcol(i,j,bi,bj)-sigma_b)/(1. _d 0-sigma_b) )
     &     *COS((yC(i,j,bi,bj)*deg2rad))**4
         gT(i,j,kLev,bi,bj)=gT(i,j,kLev,bi,bj)
     &        - kT*( theta(i,j,kLev,bi,bj)-thetaEq )
     &            *maskC(i,j,kLev,bi,bj)
       ENDDO
      ENDDO

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: EXTERNAL_FORCING_S
C     !INTERFACE:
      SUBROUTINE EXTERNAL_FORCING_S(
     I           iMin,iMax, jMin,jMax, bi,bj, kLev,
     I           myTime, myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R EXTERNAL_FORCING_S
C     | o Contains problem specific forcing for merid velocity.
C     *==========================================================*
C     | Adds terms to gS for forcing by external sources
C     | e.g. fresh-water flux, climatalogical relaxation, etc ...
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     == Global data ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "DYNVARS.h"
#include "FFIELDS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     iMin,iMax :: Working range of x-index for applying forcing.
C     jMin,jMax :: Working range of y-index for applying forcing.
C     bi,bj     :: Current tile indices
C     kLev      :: Current vertical level index
C     myTime    :: Current time in simulation
C     myThid    :: Thread Id number
      INTEGER iMin, iMax, jMin, jMax, kLev, bi, bj
      _RL myTime
      INTEGER myThid

C     !LOCAL VARIABLES:
C     == Local variables ==
C     i,j       :: Loop counters
c     INTEGER i, j
CEOP

C--   Forcing term(s)

      RETURN
      END

#include "MONITOR_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: MON_SOLUTION

C     !INTERFACE:
      SUBROUTINE MON_SOLUTION(
     I     statsTemp,
     I     myTime, myIter, myThid )

C     !DESCRIPTION:
C     Checks that the solutions is within bounds

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "DYNVARS.h"
#include "GRID.h"
#include "MONITOR.h"

C     !INPUT PARAMETERS:
      _RL statsTemp(*)
      _RL myTime
      INTEGER myIter
      INTEGER myThid
CEOP

C     !LOCAL VARIABLES:
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      _RL tMin,tMax,tMean,tSD,tDel2,tVol

      IF ( statsTemp(1) .LE. statsTemp(2) ) THEN
C     Take statistics from the input argument "statsTemp":
        tMin = statsTemp(1)
        tMax = statsTemp(2)
      ELSE
C     Statistics for T
        CALL MON_CALC_STATS_RL(
     I                Nr, theta, hFacC, maskInC, rA, drF,
     O                tMin, tMax, tMean, tSD, tDel2, tVol,
     I                myThid )
      ENDIF

      IF ( (tMax-tMin).GT.monSolutionMaxRange ) THEN
        _BEGIN_MASTER(myThid)
        WRITE(msgBuf,'(A,1P2E11.3)')
     &    'SOLUTION IS HEADING OUT OF BOUNDS: tMin,tMax=',tMin,tMax
        CALL PRINT_MESSAGE(msgBuf,errorMessageUnit,SQUEEZE_RIGHT,myThid)
        WRITE(msgBuf,'(2A,1PE11.3,A)') '  exceeds allowed range ',
     &             '(monSolutionMaxRange=', monSolutionMaxRange,')'
        CALL PRINT_MESSAGE(msgBuf,errorMessageUnit,SQUEEZE_RIGHT,myThid)
        WRITE(msgBuf,'(A,I10)')
     &    'MON_SOLUTION: STOPPING CALCULATION at Iter=', myIter
        CALL PRINT_MESSAGE(msgBuf,errorMessageUnit,SQUEEZE_RIGHT,myThid)
        _END_MASTER(myThid)

        CALL ALL_PROC_DIE( myThid )
        STOP
     &  'ABNORMAL END: S/R MON_SOLUTION, stops due to EXTREME Pot.Temp'
      ENDIF

      RETURN
      END

#include "AUTODIFF_OPTIONS.h"
#include "AD_CONFIG.h"

CBOP
C !ROUTINE: COPY_AD_UV_OUTP
C !INTERFACE:
      SUBROUTINE COPY_AD_UV_OUTP(
     I                            uFldRS, vFldRS,  uFldRL, vFldRL,
     O                            uFldOut, vFldOut,
     I                            nNz, vType, myThid )

C !DESCRIPTION:
C     Copy 2-components input AD-variable (RS or RL) into output array and then,
C      according to variable type, apply ADEXCH to output array.
C     vType (1rst digit):
C           = 1,3 : process RS input field ; = 2,4 : process RL input field
C           = 1,2 : without sign. ;          = 3,4 : with sign.
C     vType (2nd digit) = 10 : A-grid location (i.e., grid-cell center)
C                       = 20 : B-grid location (i.e., grid-cell corner)
C                       = 30 : C-grid location ; = 40 : D-grid location

C     !USES:
      IMPLICIT NONE

C Global variables / common blocks
#include "EEPARAMS.h"
#include "SIZE.h"

C     !INPUT/OUTPUT PARAMETERS:
C Routine arguments
C uFldRS   ( RS )  :: input AD-vector field, 1rst component
C vFldRS   ( RS )  :: input AD-vector field, 2nd  component
C uFldRL   ( RL )  :: input AD-vector field, 1rst component
C vFldRL   ( RL )  :: input AD-vector field, 2nd  component
C uFldOut  ( RL )  :: copy of input field, 1rst component
C vFldOut  ( RL )  :: copy of input field, 1rst component
C nNz     (integer):: third dimension of 3-D input/output field
C vType   (integer):: type of AD-variable (select which ADEXCH to use)
C myThid  (integer):: my Thread Id number
      INTEGER nNz
      _RS    uFldRS (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nNz,nSx,nSy)
      _RS    vFldRS (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nNz,nSx,nSy)
      _RL    uFldRL (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nNz,nSx,nSy)
      _RL    vFldRL (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nNz,nSx,nSy)
      _RL    uFldOut(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nNz,nSx,nSy)
      _RL    vFldOut(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nNz,nSx,nSy)
      INTEGER vType
      INTEGER myThid

#ifdef ALLOW_AUTODIFF_MONITOR
#if (defined (ALLOW_ADJOINT_RUN) || defined (ALLOW_ADMTLM))
C !LOCAL VARIABLES:
C   i,j,k   :: loop indices
C   bi,bj   :: tile indices
C   gridloc :: advar horizontal-grid location
      INTEGER i,j,k,bi,bj
      INTEGER gridloc
      LOGICAL wSign
CEOP

      gridloc = vType/10
      IF ( MOD(vType,10).LT.1 .OR. MOD(vType,10).GT.4
     &      .OR. gridloc.LT.1 .OR. gridloc.GT.4 ) THEN
        STOP 'ABNORMAL END: COPY_AD_UV_OUTP invalid vType'
      ENDIF
      wSign = MOD(vType,10).GE.3

      IF ( MOD(vType,2).EQ.1 ) THEN
       DO bj = myByLo(myThid), myByHi(myThid)
        DO bi = myBxLo(myThid), myBxHi(myThid)
         DO k=1,nNz
          DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
             uFldOut(i,j,k,bi,bj) = uFldRS(i,j,k,bi,bj)
             vFldOut(i,j,k,bi,bj) = vFldRS(i,j,k,bi,bj)
           ENDDO
          ENDDO
         ENDDO
        ENDDO
       ENDDO
      ELSE
       DO bj = myByLo(myThid), myByHi(myThid)
        DO bi = myBxLo(myThid), myBxHi(myThid)
         DO k=1,nNz
          DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
             uFldOut(i,j,k,bi,bj) = uFldRL(i,j,k,bi,bj)
             vFldOut(i,j,k,bi,bj) = vFldRL(i,j,k,bi,bj)
           ENDDO
          ENDDO
         ENDDO
        ENDDO
       ENDDO
      ENDIF

#ifdef ALLOW_OPENAD
C--   need to all the correct OpenAD EXCH S/R ; left empty for now
#else /* ALLOW_OPENAD */

      IF ( gridloc.EQ.1 ) THEN
#ifdef AUTODIFF_TAMC_COMPATIBILITY
c       CALL ADEXCH_UV_AGRID_3D_RL( wSign,nNz,myThid, uFldOut,vFldOut )
#else
c       CALL ADEXCH_UV_AGRID_3D_RL( uFldOut,vFldOut, wSign,nNz,myThid )
#endif
        STOP 'ABNORMAL END: COPY_AD_UV_OUTP missing vType=11-14'
      ELSEIF ( gridloc.EQ.2 ) THEN
#ifdef AUTODIFF_TAMC_COMPATIBILITY
c       CALL ADEXCH_UV_BGRID_3D_RL( wSign,nNz,myThid, uFldOut,vFldOut )
#else
c       CALL ADEXCH_UV_BGRID_3D_RL( uFldOut,vFldOut, wSign,nNz,myThid )
#endif
        STOP 'ABNORMAL END: COPY_AD_UV_OUTP missing vType=21-24'
      ELSEIF ( gridloc.EQ.3 ) THEN
#ifdef AUTODIFF_TAMC_COMPATIBILITY
        CALL ADEXCH_UV_3D_RL( wSign,nNz,myThid, uFldOut,vFldOut )
#else
        CALL ADEXCH_UV_3D_RL( uFldOut,vFldOut, wSign,nNz,myThid )
#endif
      ELSEIF ( gridloc.EQ.4 ) THEN
#ifdef AUTODIFF_TAMC_COMPATIBILITY
c       CALL ADEXCH_UV_DGRID_3D_RL( wSign,nNz,myThid, uFldOut,vFldOut )
#else
c       CALL ADEXCH_UV_DGRID_3D_RL( uFldOut,vFldOut, wSign,nNz,myThid )
#endif
        STOP 'ABNORMAL END: COPY_AD_UV_OUTP missing vType=41-44'
      ENDIF

#endif /* ALLOW_OPENAD */

#endif /* ALLOW_ADJOINT_RUN or ALLOW_ADMTLM */
#endif /* ALLOW_AUTODIFF_MONITOR */
      RETURN
      END

#include "ctrparam.h"
#include "ATM2D_OPTIONS.h"
C     !INTERFACE:
      SUBROUTINE ATM2OCN_MAIN( iloop, aloop, inMonth,
     &                                 myIter, myThid )
C     *==========================================================*
C     | Main call after atmos call; calls routine to convert/get |
C     | the atmos fluxes, do ther derivative term calculation,   |
C     | then add restoring and fixed fluxes, if any.             |
C     *==========================================================*
        IMPLICIT NONE

C     === Global Atmos/Ocean/Seaice Interface Variables ===
#include "ATMSIZE.h"
#include "SIZE.h"
#include "EEPARAMS.h"
#include "ATM2D_VARS.h"


C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
C     iloop - loop counter for main loop (coupled periods)
C     aloop - loop counter for atm time steps (within a coupled per.)
C     inMonth - current month
C     myThid - Thread no. that called this routine.
      INTEGER iloop
      INTEGER aloop
      INTEGER inMonth
      INTEGER myIter
      INTEGER myThid

C     LOCAL VARIABLES:
      _RL wght0,wght1
      INTEGER intime0,intime1
      LOGICAL iftime ! comes back true if time to do a file re-load
      _RL  curTime   ! current time (s) of simulation starting from 0.0

      curTime = float(iloop-1)*dtcouplo + (float(aloop)-0.5)*dtatmo

      PRINT *,'Executing atm2ocn main',curTime
      CALL CALC_FILELOAD( curTime, iloop, aloop, wght0, wght1,
     &                    intime0, intime1, ifTime, myThid)

      CALL READ_ATMOS( inMonth,myThid)

      IF ( (atmosTauuFile.NE.' ').OR.
     &   (atmosTauvFile.NE.' ').OR.(atmosWindFile.NE.' ')) THEN
        CALL SUBTRACT_MEANS( wght0, wght1,
     &                       intime0, intime1, myThid)
      ENDIF

      CALL CALC_1DTO2D( myThid)

      CALL FIXED_FLUX_ADD( inMonth, wght0,wght1,
     &              intime0,intime1,ifTime,myIter,myThid)

      CALL RELAX_ADD( wght0,wght1,
     &              intime0,intime1,ifTime,myIter,myThid)

      RETURN
      END

#include "GAD_OPTIONS.h"

      SUBROUTINE GAD_DST3FL_ADV_Y(
     I           bi,bj,k, calcCFL, deltaTloc,
     I           vTrans, vFld,
     I           maskLocS, tracer,
     O           vT,
     I           myThid )
C     /==========================================================\
C     | SUBROUTINE GAD_DST3FL_ADV_Y                              |
C     | o Compute Meridional advective Flux of Tracer using      |
C     |   3rd Order DST Sceheme with flux limiting               |
C     |==========================================================|
      IMPLICIT NONE

C     == GLobal variables ==
#include "SIZE.h"
#include "GRID.h"
#include "GAD.h"

C     == Routine arguments ==
      INTEGER bi,bj,k
      LOGICAL calcCFL
      _RL deltaTloc
      _RL vTrans(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL vFld  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RS maskLocS(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL tracer(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL vT    (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER myThid

C     == Local variables ==
      INTEGER i,j
      _RL Rjm,Rj,Rjp,vCFL,d0,d1,psiP,psiM,thetaP,thetaM
      _RL thetaMax
      PARAMETER( thetaMax = 1.D+20 )

      DO i=1-OLx,sNx+OLx
       vT(i,1-OLy)=0. _d 0
       vT(i,2-OLy)=0. _d 0
       vT(i,sNy+OLy)=0. _d 0
      ENDDO
      DO j=1-OLy+2,sNy+OLy-1
       DO i=1-OLx,sNx+OLx
#if (defined ALLOW_AUTODIFF && defined TARGET_NEC_SX)
C     These lines make TAF create vectorizable code
        thetaP = 0. _d 0
        thetaM = 0. _d 0
#endif
        Rjp=(tracer(i,j+1)-tracer(i, j ))*maskLocS(i,j+1)
        Rj =(tracer(i, j )-tracer(i,j-1))*maskLocS(i, j )
        Rjm=(tracer(i,j-1)-tracer(i,j-2))*maskLocS(i,j-1)

        vCFL = vFld(i,j)
        IF ( calcCFL ) vCFL = ABS( vFld(i,j)*deltaTloc
     &                  *recip_dyC(i,j,bi,bj)*recip_deepFacC(k) )
        d0=(2. _d 0 -vCFL)*(1. _d 0 -vCFL)*oneSixth
        d1=(1. _d 0 -vCFL*vCFL)*oneSixth

C-      the old version: can produce overflow, division by zero,
c       and is wrong for tracer with low concentration:
c       thetaP=Rjm/(1.D-20+Rj)
c       thetaM=Rjp/(1.D-20+Rj)
C-      the right expression, but not bounded:
c       thetaP=0.D0
c       thetaM=0.D0
c       IF (Rj.NE.0.D0) thetaP=Rjm/Rj
c       IF (Rj.NE.0.D0) thetaM=Rjp/Rj
C-      prevent |thetaP,M| to reach too big value:
        IF ( ABS(Rj)*thetaMax .LE. ABS(Rjm) ) THEN
          thetaP=SIGN(thetaMax,Rjm*Rj)
        ELSE
          thetaP=Rjm/Rj
        ENDIF
        IF ( ABS(Rj)*thetaMax .LE. ABS(Rjp) ) THEN
          thetaM=SIGN(thetaMax,Rjp*Rj)
        ELSE
          thetaM=Rjp/Rj
        ENDIF

        psiP=d0+d1*thetaP
        psiP=MAX(0. _d 0,MIN(MIN(1. _d 0,psiP),
     &                       thetaP*(1. _d 0 -vCFL)/(vCFL+1. _d -20) ))
        psiM=d0+d1*thetaM
        psiM=MAX(0. _d 0,MIN(MIN(1. _d 0,psiM),
     &                       thetaM*(1. _d 0 -vCFL)/(vCFL+1. _d -20) ))

        vT(i,j)=
     &   0.5*(vTrans(i,j)+ABS(vTrans(i,j)))
     &      *( Tracer(i,j-1) + psiP*Rj )
     &  +0.5*(vTrans(i,j)-ABS(vTrans(i,j)))
     &      *( Tracer(i, j ) - psiM*Rj )

       ENDDO
      ENDDO

      RETURN
      END

#include "DIAG_OPTIONS.h"

CBOP
C     !ROUTINE: DIAGSTATS_SET_REGIONS
C     !INTERFACE:
      SUBROUTINE DIAGSTATS_SET_REGIONS( myThid )

C     !DESCRIPTION: \bv
C     *==================================================================
C     | S/R DIAGSTATS_SET_REGIONS
C     | o set region-mask for regional statistics diagnostics
C     *==================================================================
C     \ev

C     !USES:
      IMPLICIT NONE

C     == Global variables ===
#include "EEPARAMS.h"
#include "SIZE.h"
#include "PARAMS.h"
#include "DIAGNOSTICS_SIZE.h"
#include "DIAGSTATS_REGIONS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     myThid - Thread number for this instance of the routine.
      INTEGER myThid
CEOP

C     !LOCAL VARIABLES:
C     == Local variables ==
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      INTEGER iLen
      INTEGER i, j
      INTEGER bi, bj
#ifdef DIAGSTATS_REGION_MASK
      CHARACTER*(MAX_LEN_MBUF) tmpBuf
      INTEGER ioUnit
      INTEGER k, nbReg
      _RS     tmpVar(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      COMMON / SET_REGIONS_LOCAL / tmpVar
#else
      LOGICAL flag
#endif
      INTEGER  ILNBLNK
      EXTERNAL ILNBLNK

#ifdef DIAGSTATS_REGION_MASK

C--   Initialize region-mask array to zero:
      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
        DO k=1,sizRegMsk
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           diagSt_regMask(i,j,k,bi,bj) = 0.
          ENDDO
         ENDDO
        ENDDO
       ENDDO
      ENDDO
      ioUnit = -1

      _BEGIN_MASTER( myThid )
      ioUnit = standardMessageUnit
C--   Check size & parameter first:
      IF ( (diagSt_regMaskFile.NE.' ' .AND. nSetRegMskFile.EQ.0)
     & .OR.(diagSt_regMaskFile.EQ.' ' .AND. nSetRegMskFile.GT.0) ) THEN
        WRITE(msgBuf,'(2A)') 'DIAGSTATS_SET_REGIONS:',
     &   ' regMaskFile and nSetRegMskFile Not consistent'
        CALL PRINT_ERROR( msgBuf , myThid )
        STOP 'ABNORMAL END: S/R DIAGSTATS_SET_REGIONS'
      ENDIF
      IF ( nSetRegMskFile.GT.sizRegMsk ) THEN
        WRITE(msgBuf,'(2A,I4,A,I4)') 'DIAGSTATS_SET_REGIONS:',
     &   ' regMaskFile set-index number=', nSetRegMskFile,
     &   ' exceeds sizRegMsk=', sizRegMsk
        CALL PRINT_ERROR( msgBuf , myThid )
        STOP 'ABNORMAL END: S/R DIAGSTATS_SET_REGIONS'
      ENDIF
      _END_MASTER( myThid )

C--   Read region-mask from file
      IF ( diagSt_regMaskFile .NE. ' ' ) THEN
       _BARRIER
       iLen = ILNBLNK(diagSt_regMaskFile)
       IF (ioUnit.GE.0 ) WRITE(ioUnit,'(2A)')
     &   ' DIAGSTATS_SET_REGIONS: start reading region-mask file: ',
     &   diagSt_regMaskFile(1:iLen)
       DO k=1,nSetRegMskFile
C       _BEGIN_MASTER( myThid )
         IF (ioUnit.GE.0 )  WRITE(ioUnit,'(A,I3)')
     &   ' DIAGSTATS_SET_REGIONS:  reading set k=',k
         CALL READ_REC_XY_RS( diagSt_regMaskFile, tmpVar, k,
     &                        nIter0, myThid )
         IF (ioUnit.GE.0 ) WRITE(ioUnit,'(A,I3,A)')
     &   ' DIAGSTATS_SET_REGIONS:          set k=',k,' <= done'
C       _END_MASTER( myThid )
        _EXCH_XY_RS( tmpVar, myThid )
        DO bj = myByLo(myThid), myByHi(myThid)
         DO bi = myBxLo(myThid), myBxHi(myThid)
          DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
            diagSt_regMask(i,j,k,bi,bj) = tmpVar(i,j,bi,bj)
           ENDDO
          ENDDO
         ENDDO
        ENDDO
C-     end of k loop
       ENDDO
      ENDIF

C--   Other way to define regions (e.g., latitude bands):
C      set corresponding set-index of the region-mask array,
C      starting from nSetRegMskFile+1 up to nSetRegMask
C note: for now, empty !
      _BEGIN_MASTER( myThid )
      nSetRegMask = nSetRegMskFile
      _END_MASTER( myThid )

C--   Region Identificator arrays
C       for now, directly filled when reading data.diagnostics

      _BEGIN_MASTER( myThid )
C--   Check defined regions
      nbReg = 0
      DO j=1,nRegions
C-      check for valid region-mask index:
        IF ( diagSt_kRegMsk(j).LT.0  .OR.
     &       diagSt_kRegMsk(j).GT.sizRegMsk ) THEN
          WRITE(msgBuf,'(2A,I3,A,I4)') 'DIAGSTATS_SET_REGIONS: ',
     &     '(region',j,') invalid region-mask index :',diagSt_kRegMsk(j)
          CALL PRINT_ERROR( msgBuf , myThid )
          STOP 'ABNORMAL END: S/R DIAGSTATS_SET_REGIONS'
C-      check for unset region-mask:
        ELSEIF ( diagSt_kRegMsk(j).GT.nSetRegMask ) THEN
          WRITE(msgBuf,'(2A,I3,A,I3,A)') 'DIAGSTATS_SET_REGIONS: ',
     &     'region',j,' , kRegMsk=', diagSt_kRegMsk(j),
     &     ' <- has not been set !'
          CALL PRINT_ERROR( msgBuf , myThid )
          STOP 'ABNORMAL END: S/R DIAGSTATS_SET_REGIONS'
        ELSEIF ( diagSt_kRegMsk(j).NE.0 ) THEN
          nbReg = nbReg + 1
C-      check for empty region: build temp mask 0 / 1 :
c         k = diagSt_kRegMsk(j)
c         IF ( diagSt_regMask(i,j,k,bi,bj).EQ.diagSt_vRegMsk(j) ) THEN
c           tmpVar(i,j,bi,bj) = 1.
c         ELSE
c           tmpVar(i,j,bi,bj) = 0.
c         ELSE
C-      print region mask:
c         IF ( diag_dBugLevel.GE.debLevA ) THEN
c           WRITE(msgBuf,'(A,I3,A)') 'DIAGSTAT Region',j,' mask:'
c           iLen = ILNBLNK(msgBuf)
c           CALL PLOT_FIELD_XYRS( tmpVar, msgBuf(1:iLen), -1, myThid )
c         ENDIF
        ENDIF
      ENDDO

C-    Global statistics (region # 0) <- done in diagnostics_readparams
c     diagSt_kRegMsk(0) = 1
c     diagSt_vRegMsk(0) = 0.

      WRITE(msgBuf,'(A,I4,A)') 'DIAGSTATS_SET_REGIONS: define',
     &                         nbReg,' regions:'
      iLen = ILNBLNK(msgBuf)
      DO j=1,nRegions
        IF ( diagSt_kRegMsk(j).NE.0 ) THEN
          iLen = MIN( iLen, MAX_LEN_MBUF -3 )
          tmpBuf(1:iLen) = msgBuf(1:iLen)
          WRITE(msgBuf,'(A,I3)') tmpBuf(1:iLen),j
          iLen = iLen+3
        ENDIF
      ENDDO
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                      SQUEEZE_RIGHT , myThid)
      WRITE(msgBuf,'(2A)')
     &   '------------------------------------------------------------'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                      SQUEEZE_RIGHT , myThid)

      _END_MASTER( myThid )

#else /* DIAGSTATS_REGION_MASK */

C--   Initialize region-mask array to zero:
      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
c        DO j=1-Oly,sNy+Oly
c         DO i=1-Olx,sNx+Olx
         DO j=1-OLy,1-OLy
          DO i=1-OLx,1-OLx
           diagSt_regMask(i,j,1,bi,bj) = 0.
          ENDDO
         ENDDO
       ENDDO
      ENDDO

      _BEGIN_MASTER( myThid )
C--   Check parameter consitency:
      flag = .FALSE.
      DO j=1,nRegions
        flag = flag .OR. diagSt_kRegMsk(j).NE.0
     &              .OR. diagSt_vRegMsk(j).NE.0.
      ENDDO
      iLen = ILNBLNK(diagSt_regMaskFile)
      IF ( flag .OR. iLen.GE.1 .OR. nSetRegMskFile.NE.0 ) THEN
        WRITE(msgBuf,'(2A)') 'DIAGSTATS_SET_REGIONS:',
     &   ' #define DIAGSTATS_REGION_MASK missing in DIAG_OPTIONS.h'
        CALL PRINT_ERROR( msgBuf , myThid )
        STOP 'ABNORMAL END: S/R DIAGSTATS_SET_REGIONS'
      ENDIF

      WRITE(msgBuf,'(A)') 'DIAGSTATS_SET_REGIONS: define no region'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                      SQUEEZE_RIGHT , myThid)
      WRITE(msgBuf,'(2A)')
     &   '------------------------------------------------------------'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                      SQUEEZE_RIGHT , myThid)

      _END_MASTER( myThid )

#endif /* DIAGSTATS_REGION_MASK */

      RETURN
      END

#include "ATM_CPL_OPTIONS.h"

CBOP
C     !ROUTINE: ATM_EXPORT_FLD
C     !INTERFACE:
      SUBROUTINE ATM_EXPORT_FLD(
     I               atmFldName,
     U               atmFld, countTime,
     I               myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE ATM_EXPORT_FLD
C     | o Routine for exporting 1 atmos. field to coupling layer:
C     |   - compute the time-average (if needed)
C     |   - send the field to the coupler
C     |   - reset time and field to zero
C     *==========================================================*
C     | This version talks to the MIT Coupler. It uses the MIT
C     | Coupler "checkpoint1" library calls.
C     | Note: requires arg. array "atmFld" to be shared
C     |       (in common block) to work in multi-threaded.
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
C     atmFldName :: atmos. Field identificator name
C     atmFld     :: array containing the atmospheric Field to export
C     countTime  :: fractional integrated time
C     myThid     :: my Thread Id number
      CHARACTER*(*) atmFldName
      _RL     atmFld   (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL     countTime(nSx,nSy)
      INTEGER myThid
CEOP

#ifdef COMPONENT_MODULE
C     !LOCAL VARIABLES:
C     == Local variables ==
C     recipAvT  :: Temp. for holding reciprocal of averaging period.
C     i,j,bi,bj :: Loop counters
      _RL recipAvT
      INTEGER i,j,bi,bj

C     Convert time integrated heatflux to mean value ready for export.
      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        IF ( ABS(countTime(bi,bj) -1. _d 0).GT. 1. _d -12
     &     .AND. countTime(bi,bj) .NE. 0. ) THEN
         recipAvT = 1. _d 0/countTime(bi,bj)
         DO j=1,sNy
          DO i=1,sNx
           atmFld(i,j,bi,bj) = atmFld(i,j,bi,bj)*recipAvT
          ENDDO
         ENDDO
         WRITE(errorMessageUnit,'(3A,2I4,1PE15.8)')
     &     'ATM_EXPORT_FLD: ',atmFldName,' : 1-CountTime=',
     &                             bi,bj,1.-countTime(bi,bj)
        ENDIF
       ENDDO
      ENDDO

C     Send atmos. field to coupling layer.
      _BARRIER
      _BEGIN_MASTER( myThid )
      CALL COMPSEND_R8TILES(
     I              atmFldName, sNx, OLx, sNy, OLy, 1, nSx, nSy,
     I              atmFld )
      _END_MASTER( myThid )
      _BARRIER

C     Reset atmos. field & integrated time before accumulating again.
      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        countTime(bi,bj) = 0.
        DO j=1,sNy
         DO i=1,sNx
          atmFld(i,j,bi,bj) = 0.
         ENDDO
        ENDDO
       ENDDO
      ENDDO

#endif /* COMPONENT_MODULE */

      RETURN
      END

#include "MOM_VECINV_OPTIONS.h"

CBOP
C     !ROUTINE: MOM_VI_V_VERTSHEAR

C     !INTERFACE:
      SUBROUTINE MOM_VI_V_VERTSHEAR(
     I        bi, bj, k, deepFacA,
     I        vFld, wFld,
     U        vShearTerm,
     I        myThid )

C     !DESCRIPTION:
C     *==========================================================*
C     | S/R MOM_V_VERTSHEAR
C     *==========================================================*

C     !USES:
      IMPLICIT NONE
C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "GRID.h"
#include "PARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
C  deepFacA             :: deep-model grid factor at level center
      INTEGER bi, bj, k
      _RL deepFacA(Nr)
      _RL vFld(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      _RL wFld(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      _RL vShearTerm(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER myThid

C     !LOCAL VARIABLES:
      INTEGER i, j, kp1, km1
      _RL mask_Kp1, mask_Km1, wBarYm, wBarYp
      _RL vZm, vZp, recip_drDeepRho
      LOGICAL rAdvAreaWeight
c     _RL vmask_Kp1,vmask_K,vmask_Km1
c1    _RL wBarYZ,vZbarZ
CEOP

      rAdvAreaWeight =.TRUE.
C-    Area-weighted average either in KE or in vert. advection:
      IF ( selectKEscheme.EQ.1 .OR. selectKEscheme.EQ.3 )
     &  rAdvAreaWeight =.FALSE.

      kp1 = MIN(k+1,Nr)
      mask_Kp1 = oneRL
      IF (k.EQ.Nr) mask_Kp1 = zeroRL
      km1 = MAX(k-1,1)
      mask_Km1 = oneRL
      IF (k.EQ.1) mask_Km1 = zeroRL

      recip_drDeepRho = recip_drF(k)/deepFacA(k)
     &                * recip_deepFac2C(k)*recip_rhoFacC(k)

      DO j=2-OLy,sNy+OLy
       DO i=1-OLx,sNx+OLx

c       vmask_K=_maskS(i,j,k,bi,bj)

C barZ( barY( W ) )
c       wBarYm=0.5*(wFld(I,J,K,bi,bj)+wFld(I,J-1,K,bi,bj))
c       wBarYp=0.5*(wFld(I,J,Kp1,bi,bj)+wFld(I,J-1,Kp1,bi,bj))
c    &              *mask_Kp1

       IF ( rAdvAreaWeight ) THEN
C     Transport at interface k : Area weighted average
        wBarYm = halfRL*(
     &     wFld(i,j,k,bi,bj)*rA(i,j,bi,bj)*maskC(i,j,km1,bi,bj)
     &   + wFld(i,j-1,k,bi,bj)*rA(i,j-1,bi,bj)*maskC(i,j-1,km1,bi,bj)
     &                  )*mask_Km1*deepFac2F(k)*rhoFacF(k)
     &                   *recip_rAs(i,j,bi,bj)

C     Transport at interface k+1 (here wFld is already masked)
        wBarYp = halfRL*(
     &     wFld(i,j,kp1,bi,bj)*rA(i,j,bi,bj)
     &   + wFld(i,j-1,kp1,bi,bj)*rA(i,j-1,bi,bj)
     &                  )*mask_Kp1*deepFac2F(kp1)*rhoFacF(kp1)
     &                   *recip_rAs(i,j,bi,bj)
       ELSE
C     Transport at interface k : simple average
        wBarYm = halfRL*(
     &     wFld(i,j,k,bi,bj)*maskC(i,j,km1,bi,bj)
     &   + wFld(i,j-1,k,bi,bj)*maskC(i,j-1,km1,bi,bj)
     &                  )*mask_Km1*deepFac2F(k)*rhoFacF(k)

C     Transport at interface k+1 (here wFld is already masked)
        wBarYp = halfRL*(
     &     wFld(i,j,kp1,bi,bj)
     &   + wFld(i,j-1,kp1,bi,bj)
     &                  )*mask_Kp1*deepFac2F(kp1)*rhoFacF(kp1)
       ENDIF

C-    delta_Z( V*deepFac )  @ interface k
c       vmask_Km1=mask_Km1*maskS(i,j,Km1,bi,bj)
        vZm = ( vFld(i,j, k ,bi,bj)*deepFacA( k )
     &        - vFld(i,j,km1,bi,bj)*deepFacA(km1)*mask_Km1 )*rkSign
c2   &      *recip_dRC(K)
c       IF (freeslip1) vZm=vZm*vmask_Km1
c       IF (noslip1.AND.vmask_Km1.EQ.0.) vZm=vZm*2.

C-    delta_Z( V*deepFac )  @ interface k+1
c       vmask_Kp1=mask_Kp1*maskS(i,j,Kp1,bi,bj)
        vZp = ( vFld(i,j,kp1,bi,bj)*deepFacA(kp1)*mask_Kp1
     &        - vFld(i,j, k ,bi,bj)*deepFacA( k ) )*rkSign
c2   &      *recip_dRC(Kp1)
c       IF (freeslipK) vZp=vZp*vmask_Kp1
c       IF (noslipK.AND.vmask_Kp1.EQ.0.) vZp=vZp*2.

c1      IF (upwindShear) THEN
c1       wBarYZ=0.5*( wBarXm + wBarXp )
c1       IF (wBarYZ.GT.0.) THEN
c1        vZbarZ=vZp
c1       ELSE
c1        vZbarZ=vZm
c1       ENDIF
c1      ELSE
c1       vZbarZ=0.5*(vZm+vZp)
c1      ENDIF
c1      vShearTerm(I,J)=-wBarYZ*vZbarZ*_maskS(I,J,K,bi,bj)

c2      vShearTerm(I,J)=-0.5*(wBarYp*vZp+wBarYm*vZm)
c2   &                  *_maskS(I,J,K,bi,bj)
        IF (upwindShear) THEN
         vShearTerm(i,j) = -halfRL*
     &                  (    (     wBarYp *vZp +     wBarYm *vZm )
     &                     + ( ABS(wBarYp)*vZp - ABS(wBarYm)*vZm )
     &                  )*_recip_hFacS(i,j,k,bi,bj)*recip_drDeepRho
        ELSE
         vShearTerm(i,j) = -halfRL*( wBarYp*vZp + wBarYm*vZm )
     &                   *_recip_hFacS(i,j,k,bi,bj)*recip_drDeepRho
        ENDIF
       ENDDO
      ENDDO

      RETURN
      END

module dargan_bettsmiller_mod

! modified by pog:
!
! - changed comments to say r is mixing ratio in capecalcnew
! - removed unused avg_bl code
! - removed second order in p code that was commented out
! - add fatal error if LCL table lookup out of range
! - changed so mixing ratio has conventional definition
! - changed lcl table routine call so uses conventional mixing ratio
! - didn't change approximate saturated adiabatic ascent integration or
!   approximate 'saturate out at constant p if r0>rs' calculation to be
!   consistent with conventional definition of mixing ratio
! - CAPE/CIN calculation uses virtual temperature if option set

!----------------------------------------------------------------------
!use            fms_mod, only:  file_exist, error_mesg, open_file,  &
!                               check_nml_error, mpp_pe, FATAL,  &
!                               close_file

use simple_sat_vapor_pres_mod, only:  escomp, descomp
use     gcm_params_mod, only: gcm_LEN_MBUF, gcm_SQZ_R, gcm_stdMsgUnit
use      constants_mod, only:  HLv,HLs,Cp_air,Grav,rdgas,rvgas, &
                               kappa

implicit none
private
!---------------------------------------------------------------------
!  ---- public interfaces ----

   public  dargan_bettsmiller, dargan_bettsmiller_init

!-----------------------------------------------------------------------
!   ---- version number ----

 character(len=128) :: version = '$Id: dargan_bettsmiller_mod.F90,v 1.3 2017/08/11 20:48:50 jmc Exp $'
 character(len=128) :: tag = '$Name:  $'

!-----------------------------------------------------------------------
!   ---- local/private data ----

    logical :: do_init=.true.

!-----------------------------------------------------------------------
!   --- namelist ----

real    :: tau_bm=7200.
real    :: rhbm = .8
logical :: do_virtual = .false.
logical :: do_shallower = .false.
logical :: do_changeqref = .false.
logical :: do_envsat = .false.
logical :: do_taucape = .false.
logical :: do_bm_shift = .false.
real    :: capetaubm = 900.
real    :: tau_min = 2400.

namelist /dargan_bettsmiller_nml/  tau_bm, rhbm, &
                            do_shallower, do_changeqref, &
                            do_envsat, do_taucape, capetaubm, tau_min, &
                            do_virtual, do_bm_shift

!-----------------------------------------------------------------------
!           description of namelist variables
!
!  tau_bm    =  betts-miller relaxation timescale (seconds)
!
!  rhbm      = relative humidity that you're relaxing towards
!
!  do_shallower = do the shallow convection scheme where it chooses a smaller
!                 depth such that precipitation is zero
!
!  do_changeqref = do the shallow convection scheme where if changes the
!                  profile of both q and T in order make precip zero
!
!  do_envsat = reference profile is rhbm times saturated wrt environment
!              (if false, it's rhbm times parcel)
!
!  do_taucape = scheme where taubm is proportional to CAPE**-1/2
!
!  capetaubm = for the above scheme, the value of CAPE for which
!              tau = tau_bm
!
!  tau_min   = minimum relaxation time allowed for the above scheme
!
!  do_virtual = use virtual temperature for CAPE/CIN calculation
!
!  do_bm_shift = always conserve enthalpy by shifting temperature
!-----------------------------------------------------------------------

contains

!#######################################################################

   subroutine dargan_bettsmiller (dt, tin, qin, pfull, phalf, coldT, &
                                  rain, snow, tdel, qdel, q_ref, bmflag, &
                                  klzbs, cape, cin, t_ref,invtau_bm_t,invtau_bm_q, &
                                  capeflag, bi,bj,myIter, myThid, mask, conv)

!-----------------------------------------------------------------------
!
!                     Betts-Miller Convection Scheme
!
!-----------------------------------------------------------------------
!
!   input:  dt       time step in seconds
!           tin      temperature at full model levels
!           qin      specific humidity of water vapor at full
!                      model levels
!           pfull    pressure at full model levels
!           phalf    pressure at half (interface) model levels
!           coldT    should precipitation be snow at this point?
!   optional:
!           mask     optional mask (0 or 1.)
!           conv     logical flag; if true then no betts-miller
!                       adjustment is performed at that grid-point or
!                       model level
!
!  output:  rain     liquid precipitation (kg/m2)
!           snow     frozen precipitation (kg/m2)
!           tdel     temperature tendency at full model levels
!           qdel     specific humidity tendency (of water vapor) at
!                      full model levels
!           bmflag   flag for which routines you're calling
!           klzbs    stored (integer part) klzb and ktop (decimal part) values
!           cape     convectively available potential energy
!           cin      convective inhibition (this and the above are before the
!                    adjustment)
!           invtau_bm_t temperature relaxation timescale
!           invtau_bm_q humidity relaxation timescale
!           capeflag a flag that says why cape=0

!-----------------------------------------------------------------------
!--------------------- interface arguments -----------------------------

   real   , intent(in) , dimension(:,:,:) :: tin, qin, pfull, phalf
   real   , intent(in)                    :: dt
   logical   , intent(in) , dimension(:,:):: coldT
   real   , intent(out), dimension(:,:)   :: rain,snow, bmflag, klzbs, cape, &
       cin, invtau_bm_t, invtau_bm_q, capeflag
   real   , intent(out), dimension(:,:,:) :: tdel, qdel, q_ref, t_ref
   integer, intent(in)                    :: bi,bj, myIter
   integer, intent(in)                    :: myThid
   real   , intent(in) , dimension(:,:,:), optional :: mask
   logical, intent(in) , dimension(:,:,:), optional :: conv
!-----------------------------------------------------------------------
!---------------------- local data -------------------------------------

!logical,dimension(size(tin,1),size(tin,2),size(tin,3)) :: do_adjust
   real,dimension(size(tin,1),size(tin,2),size(tin,3)) :: rin
   real,dimension(size(tin,1),size(tin,2))             :: precip, precip_t
   real,dimension(size(tin,3))                         :: eref, rpc, tpc

   real                                                ::  &
       cape1, cin1, tot, deltak, deltaq, qrefint, deltaqfrac, deltaqfrac2, &
       ptopfrac, es, capeflag1, small
 integer  i, j, k, ix, jx, kx, klzb, ktop
!-----------------------------------------------------------------------
!     computation of precipitation by betts-miller scheme
!-----------------------------------------------------------------------
      capeflag1 = 0.

!     if (do_init) call error_mesg ('dargan_bettsmiller',  &
!                        'dargan_bettsmiller_init has not been called.', FATAL)

      ix=size(tin,1)
      jx=size(tin,2)
      kx=size(tin,3)
      small = 1.e-10

! initialise output:
      precip = 0.
      tdel   = 0.
      qdel   = 0.
      t_ref  = tin
      q_ref  = qin
      bmflag = 0.
      klzbs  = 0.
      cape   = 0.
      cin    = 0.
      invtau_bm_t = 0.
      invtau_bm_q = 0.
      precip_t = 0.

! calculate r (where r is the mixing ratio)
       rin = qin/(1.0 - qin)

       do j=1,jx
          do i=1,ix
             cape1 = 0.
             cin1 = 0.
             tot = 0.
             klzb=0
! the bmflag is written out to show what aspects of the bm scheme is called
! bmflag = 0 is no cape, no convection
! bmflag = 1 is shallow conv, the predicted precip is less than zero
! bmflag = 2 is deep convection
             bmflag(i,j) = 0.
             tpc = tin(i,j,:)
             rpc = rin(i,j,:)
! calculate cape, cin, level of zero buoyancy, and parcel properties
! new code (second order in delta ln p and exact LCL calculation)
             call capecalcnew( kx,  pfull(i,j,:),  phalf(i,j,:),&
                            cp_air, rdgas, rvgas, hlv, kappa, tin(i,j,:), &
                            rin(i,j,:), cape1, cin1, tpc, &
                            rpc, klzb, i,j,bi,bj,myIter,myThid)

! set values for storage
             capeflag(i,j) = capeflag1
             cape(i,j) = cape1
             cin(i,j) = cin1
             klzbs(i,j) = klzb
             if(cape1.gt.0.) then
!             if((tot.gt.0.).and.(cape1.gt.0.)) then
                bmflag(i,j) = 1.
! reference temperature is just that of the parcel all the way up
!               t_ref(i,j,:) = tpc
                t_ref(i,j,klzb:kx) = tpc(klzb:kx)
                do k=klzb,kx
! sets reference spec hum to a certain relative hum (change to vapor pressure,
! multiply by rhbm, then back to spec humid)
                   if(do_envsat) then
                      call escomp(tin(i,j,k),es)
                      es = es*rhbm
                      rpc(k) = mixing_ratio(es, pfull(i,j,k))
                      q_ref(i,j,k) = rpc(k)/(1 + rpc(k))
                   else
                      eref(k) = rhbm*pfull(i,j,k)*rpc(k)/(rdgas/rvgas + rpc(k))
                      rpc(k) = mixing_ratio(eref(k),pfull(i,j,k))
                      q_ref(i,j,k) = rpc(k)/(1 + rpc(k))
                   endif
                end do
! set the tendencies to zero where you don't adjust
! set the reference profiles to be the original profiles (for diagnostic
! purposes only --  you can think of this as what you're relaxing to in
! areas above the actual convection
!               do k=1,max(klzb-1,1)
!                  qdel(i,j,k) = 0.0
!                  tdel(i,j,k) = 0.0
!                  q_ref(i,j,k) = qin(i,j,k)
!                  t_ref(i,j,k) = tin(i,j,k)
!               end do
! initialize p to zero for the loop
                precip(i,j) = 0.
                precip_t(i,j) = 0.
! makes t_bm prop to (CAPE)**-.5.  Gives a relaxation time of tau_bm when
! CAPE = sqrt(capetaubm)
                if(do_taucape) then
                   tau_bm = sqrt(capetaubm)*tau_bm/sqrt(cape1)
                   if(tau_bm.lt.tau_min) tau_bm = tau_min
                endif
                do k=klzb, kx
! relax to reference profiles
                   tdel(i,j,k) = - (tin(i,j,k) - t_ref(i,j,k))/tau_bm*dt
                   qdel(i,j,k) = - (qin(i,j,k) - q_ref(i,j,k))/tau_bm*dt
! Precipitation can be calculated already, based on the change in q on the
! way up (this isn't altered in the energy conservation scheme).
                   precip(i,j)  = precip(i,j) - qdel(i,j,k)           &
                                *(phalf(i,j,k+1)- phalf(i,j,k))/grav
                   precip_t(i,j)= precip_t(i,j) + cp_air/(hlv+small)*tdel(i,j,k) &
                                *(phalf(i,j,k+1)-phalf(i,j,k))/grav
                end do
                if ((precip(i,j).gt.0.).and.(precip_t(i,j).gt.0.)) then
! If precip > 0, then correct energy.
                   bmflag(i,j) = 2.
! not simple scheme: shift the reference profile of temperature
! deltak is the energy correction that you make to the temperature reference
! profile
                   if(precip(i,j).gt.precip_t(i,j) .and. (.not. do_bm_shift)) then
! if the q precip is greater, then lengthen the relaxation timescale on q to
! conserve energy.  qdel is therefore changed.
                      invtau_bm_q(i,j) = precip_t(i,j)/precip(i,j)/tau_bm
                      qdel(i,j,klzb:kx) = tau_bm*invtau_bm_q(i,j)* &
                         qdel(i,j,klzb:kx)
                      precip(i,j) = precip_t(i,j)
                      invtau_bm_t(i,j) = 1./tau_bm
                   else

                         deltak = 0.
                         do k=klzb, kx
! Calculate the integrated difference in energy change within each level.
                            deltak = deltak - (tdel(i,j,k) + hlv/cp_air*&
                                     qdel(i,j,k))* &
                                     (phalf(i,j,k+1) - phalf(i,j,k))
                         end do
! Divide by total pressure.
                         deltak = deltak/(phalf(i,j,kx+1) - phalf(i,j,klzb))
! Adjust the reference profile (uniformly with height), and correspondingly
! the temperature change.
                         t_ref(i,j,klzb:kx) = t_ref(i,j,klzb:kx)+ &
                              deltak*tau_bm/dt
                         tdel(i,j,klzb:kx) = tdel(i,j,klzb:kx) + deltak
                   endif
                else if(precip_t(i,j).gt.0.) then
! If precip < 0, then do the shallow conv routine.
! First option: do_shallower = true
! This chooses the depth of convection based on choosing the height that
! it can make precip zero, i.e., subtract off heights until that precip
! becomes positive.
                   if (do_shallower) then
! ktop is the new top of convection.  set this initially to klzb.
                      ktop = klzb
! Work your way down until precip is positive again.
                      do while ((precip(i,j).lt.0.).and.(ktop.le.kx))
                         precip(i,j) = precip(i,j) - qdel(i,j,ktop)* &
                                  (phalf(i,j,ktop) - phalf(i,j,ktop+1))/grav
                         ktop = ktop + 1
                      end do
! since there will be an overshoot (precip is going to be greater than zero
! once we finish this), the actual new top of convection is somewhere between
! the current ktop, and one level above this.  set ktop to the level above.
                      ktop = ktop - 1
                      klzbs(i,j) = klzbs(i,j) + float(ktop)/( kx + 1.d0 )
! Adjust the tendencies in the places above back to zero, and the reference
! profiles back to the original t,q.
                      if (ktop.gt.klzb) then
                         qdel(i,j,klzb:ktop-1) = 0.
!                        q_ref(i,j,klzb:ktop-1) = qin(i,j,klzb:ktop-1)
                         tdel(i,j,klzb:ktop-1) = 0.
!                        t_ref(i,j,klzb:ktop-1) = tin(i,j,klzb:ktop-1)
                      end if
! Then make the change only a fraction of the new top layer so the precip is
! identically zero.
! Calculate the fractional penetration of convection through that top layer.
! This is the amount necessary to make precip identically zero.
                      if (precip(i,j).gt.0.) then
                         ptopfrac = precip(i,j)/(qdel(i,j,ktop)* &
                            (phalf(i,j,ktop+1) - phalf(i,j,ktop)))*grav
! Reduce qdel in the top layer by this fraction.
                         qdel(i,j,ktop) = ptopfrac*qdel(i,j,ktop)
! Set precip to zero
                         precip(i,j) = 0.
! Now change the reference temperature in such a way to make the net
! heating zero.

!! modification: pog
!! Reduce tdel in the top layer
                         tdel(i,j,ktop) = ptopfrac*tdel(i,j,ktop)
!! end modification: pog

                         deltak = 0.
                         if (ktop.lt.kx) then
!! modification: pog
!! include the full mass of the top layer when calculating delta_k
!! also use the entire mass of the column when normalizing
!
! Integrate temperature tendency
                            do k=ktop,kx
                               deltak = deltak + tdel(i,j,k)* &
                                   (phalf(i,j,k) - phalf(i,j,k+1))
                            end do

! Normalize by the pressure difference.
                            deltak = deltak/(phalf(i,j,kx+1) - phalf(i,j,ktop))

!! end modification: pog

! Subtract this value uniformly from tdel, and make the according change to
! t_ref.
                            do k=ktop,kx
                               tdel(i,j,k) = tdel(i,j,k) + deltak
                               t_ref(i,j,k) = t_ref(i,j,k) + deltak*tau_bm/dt
                            end do
                         end if
                      else
                         precip(i,j) = 0.
                         qdel(i,j,kx) = 0.
!                        q_ref(i,j,kx) = qin(i,j,kx)
                         tdel(i,j,kx) = 0.
!                        t_ref(i,j,kx) = tin(i,j,kx)
!                        invtau_bm_t(i,j) = 0.
!                        invtau_bm_q(i,j) = 0.
                      end if
                   else if(do_changeqref) then
! Change the reference profile of q by a certain fraction so that precip is
! zero.  This involves calculating the total integrated q_ref dp (this is the
! quantity intqref), as well as the necessary change in q_ref (this is the
! quantity deltaq).  Then the fractional change in q_ref at each level (the
! quantity deltaqfrac) is 1-deltaq/intqref.  (have to multiply q_ref by
! 1-deltaq/intqref at every level)  Then the change in qdel is
! -deltaq/intqref*q_ref*dt/tau_bm.
! Change the reference profile of T by a uniform amount so that precip is zero.
                      deltak = 0.
                      deltaq = 0.
                      qrefint = 0.
                      do k=klzb,kx
! deltaq = a positive quantity (since int qdel is positive).  It's how
! much q_ref must be changed by, in an integrated sense.  The requisite
! change in qdel is this without the factors of tau_bm and dt.
                         deltaq = deltaq - qdel(i,j,k)*tau_bm/dt* &
                                   (phalf(i,j,k) - phalf(i,j,k+1))
! deltak = the amount tdel needs to be changed
                         deltak  = deltak  + tdel(i,j,k)* &
                                   (phalf(i,j,k) - phalf(i,j,k+1))
! qrefint = integrated value of qref
                         qrefint = qrefint - q_ref(i,j,k)* &
                                   (phalf(i,j,k) - phalf(i,j,k+1))
                      end do
! Normalize deltak by total pressure.
                      deltak  = deltak /(phalf(i,j,kx+1) - phalf(i,j,klzb))
! multiplying factor for q_ref is 1 + the ratio
                      deltaqfrac = 1. - deltaq/qrefint
! multiplying factor for qdel adds dt/tau_bm
                      deltaqfrac2 = - deltaq/qrefint*dt/tau_bm
                      precip(i,j) = 0.0
                      do k=klzb,kx
                         qdel(i,j,k) = qdel(i,j,k) + deltaqfrac2*q_ref(i,j,k)
                         q_ref(i,j,k) = deltaqfrac*q_ref(i,j,k)
                         tdel(i,j,k) = tdel(i,j,k) + deltak
                         t_ref(i,j,k) = t_ref(i,j,k) + deltak*tau_bm/dt
                      end do
                   else
                      precip(i,j) = 0.
                      tdel(i,j,:) = 0.
                      qdel(i,j,:) = 0.
!                     invtau_bm_t(i,j) = 0.
!                     invtau_bm_q(i,j) = 0.
                   end if
! for cases where virtual temp predicts CAPE but precip_t < 0.
! - also note cape and precip_t are different because cape
! involves integration wrt dlogp and precip_t wrt dp
                else
                   tdel(i,j,:) = 0.0
                   qdel(i,j,:) = 0.0
                   precip(i,j) = 0.0
!                  q_ref(i,j,:) = qin(i,j,:)
!                  t_ref(i,j,:) = tin(i,j,:)
!                  invtau_bm_t(i,j) = 0.
!                  invtau_bm_q(i,j) = 0.
                end if
! if no CAPE, set tendencies to zero.
!            else
!               tdel(i,j,:) = 0.0
!               qdel(i,j,:) = 0.0
!               precip(i,j) = 0.0
!               q_ref(i,j,:) = qin(i,j,:)
!               t_ref(i,j,:) = tin(i,j,:)
!               invtau_bm_t(i,j) = 0.
!               invtau_bm_q(i,j) = 0.
             end if
          end do
       end do

       rain = precip
       snow = 0.
!      snow = precip_t  !to output value of precip_t (debug)

   end subroutine dargan_bettsmiller

!#######################################################################

!all new cape calculation.

      subroutine capecalcnew(kx,p,phalf,cp_air,rdgas,rvgas,hlv,kappa,tin,rin,&
                             cape,cin,tp,rp,klzb, i,j,bi,bj,myIter,myThid)

!
!    Input:
!
!    kx          number of levels
!    p           pressure (index 1 refers to TOA, index kx refers to surface)
!    phalf       pressure at half levels
!    cp_air      specific heat of dry air
!    rdgas       gas constant for dry air
!    rvgas       gas constant for water vapor
!    hlv         latent heat of vaporization
!    kappa       the constant kappa
!    tin         temperature of the environment
!    rin         mixing ratio of the environment
!
!    Output:
!    cape        Convective available potential energy
!    cin         Convective inhibition (if there's no LFC, then this is set
!                to zero)
!    tp          Parcel temperature (set to the environmental temperature
!                where no adjustment)
!    rp          Parcel mixing ratio (set to the environmental humidity
!                where no adjustment, and set to the saturation humidity at
!                the parcel temperature below the LCL)
!    klzb        Level of zero buoyancy
!
!    Algorithm:
!    Start with surface parcel.
!    Calculate the lifting condensation level (uses an analytic formula and a
!       lookup table).
!    Calculate parcel ascent up to LZB.
!    Calculate CAPE and CIN.
      implicit none
      integer, intent(in)                    :: kx
      real, intent(in), dimension(:)         :: p, phalf, tin, rin
      real, intent(in)                       :: rdgas, rvgas, hlv, kappa, cp_air
      integer, intent(out)                   :: klzb
      real, intent(out), dimension(:)        :: tp, rp
      real, intent(out)                      :: cape, cin
      integer, intent(in)                    :: i,j,bi,bj,myIter
      integer, intent(in)                    :: myThid
      integer            :: k, klcl, klfc
      logical            :: nocape
      real, dimension(kx)   :: tin_virtual
      real                  :: t0, r0, es, rs, theta0, pstar, value, tlcl, &
                               a, b, dtdlnp, &
                               plcl, plzb, small

      pstar = 1.e5
! so we can run dry limit (one expression involves 1/hlv)
      small = 1.e-10

      nocape = .true.
      cape = 0.
      cin = 0.
      plcl = 0.
      plzb = 0.
      klfc = 0
      klcl = 0
      klzb = 0
      tp(1:kx) = tin(1:kx)
      rp(1:kx) = rin(1:kx)

      ! calculate the virtual temperature
      do k=1,kx
       tin_virtual(k) = virtual_temp(tin(k), rin(k))
      enddo

! start with surface parcel
      t0 = tin(kx)
      r0 = rin(kx)
! calculate the lifting condensation level by the following:
! are you saturated to begin with?
      call escomp(t0,es)
      rs = mixing_ratio(es, p(kx))
      if (r0.ge.rs) then
! if you¹re already saturated, set lcl to be the surface value.
         plcl = p(kx)
! the first level where you¹re completely saturated.
         klcl = kx
! saturate out to get the parcel temp and humidity at this level
! first order (in delta T) accurate expression for change in temp
! note this is assumed to happen at constant pressure, also the resulting
! saturation mixing ratio is different from rs and this is accounted for in
! the formula, but the formula is approximate and should be replaced
         tp(kx) = t0 + (r0 - rs)/(cp_air/(hlv+small) + hlv*rs/rvgas/t0**2.)
         call escomp(tp(kx),es)
         rp(kx) = mixing_ratio(es, p(kx))
      else
! if not saturated to begin with, use the analytic expression to calculate the
! exact pressure and temperature where you¹re saturated.
         theta0 = tin(kx)*(pstar/p(kx))**kappa
! the expression that we utilize is log(r/(Rd/Rv+r)/theta**(1/kappa)*pstar) =
! log(es/T**(1/kappa))
! The right hand side of this is only a function of temperature, therefore
! this is put into a lookup table to solve for temperature.
         if (r0.gt.0.) then
            value = log(theta0**(-1/kappa)*pstar*r0/(rdgas/rvgas+r0))
!           call lcltabl(value,tlcl,myThid)
            call lcltabl(value,tlcl,i,j,bi,bj,myIter,myThid)
            plcl = pstar*(tlcl/theta0)**(1/kappa)
! just in case plcl is very high up
            if (plcl.lt.p(1)) then
               plcl = p(1)
               tlcl = theta0*(plcl/pstar)**kappa
               write (*,*) 'hi lcl'
            end if
            k = kx
         else
! if the parcel mixing ratio is zero or negative, set lcl to top level
            plcl = p(1)
            tlcl = theta0*(plcl/pstar)**kappa
!            write (*,*) 'zero r0', r0
            go to 11
         end if
! calculate the parcel temperature (adiabatic ascent) below the LCL.
! the mixing ratio stays the same
         do while (p(k).gt.plcl)
            tp(k) = theta0*(p(k)/pstar)**kappa
            call escomp(tp(k),es)
! note rp is not the actual parcel mixing ratio here, but rather will be used
! to calculate the reference moisture profile using rhbm
            rp(k) = mixing_ratio(es,p(k))
! this definition of CIN contains everything below the LCL
! we use the actual parcel mixing ratio for the virtual temperature effect
            cin = cin + rdgas*(tin_virtual(k)-virtual_temp(tp(k),r0))*log(phalf(k+1)/phalf(k))
            k = k-1
         end do
! first level where you¹re saturated at the level
         klcl = k
! do a saturated ascent to get the parcel temp at the LCL.
! use your 2nd order equation up to the pressure above.
! moist adaibat derivatives: (use the lcl values for temp, humid, and
! pressure)
! note moist adiabat derivatives are approximate and should be replaced
! with more accurate expressions (see e.g. Holton pg 503 for derivation)
         a = kappa*tlcl + hlv/cp_air*r0
         b = hlv**2.*r0/cp_air/rvgas/tlcl**2.
         dtdlnp = a/(1. + b)
! first order in p
!         tp(klcl) = tlcl + dtdlnp*log(p(klcl)/plcl)
! second order in p (RK2)
! first get temp halfway up
         tp(klcl) = tlcl + dtdlnp*log(p(klcl)/plcl)/2.
         if ((tp(klcl).lt.173.16).and.nocape) go to 11
         call escomp(tp(klcl),es)
         rp(klcl) = mixing_ratio(es,(p(klcl) + plcl)/2)
         a = kappa*tp(klcl) + hlv/cp_air*rp(klcl)
         b = hlv**2./cp_air/rvgas*rp(klcl)/tp(klcl)**2.
         dtdlnp = a/(1. + b)
! second half of RK2
         tp(klcl) = tlcl + dtdlnp*log(p(klcl)/plcl)
         if ((tp(klcl).lt.173.16).and.nocape) go to 11
         call escomp(tp(klcl),es)
         rp(klcl) = mixing_ratio(es,p(klcl))
!         write (*,*) 'tp, rp klcl:kx, new', tp(klcl:kx), rp(klcl:kx)
! CAPE/CIN stuff
         if ((virtual_temp(tp(klcl),rp(klcl)).lt.tin_virtual(klcl)).and.nocape) then
! if you¹re not yet buoyant, then add to the CIN and continue
            cin = cin + rdgas*(tin_virtual(klcl) - &
                 virtual_temp(tp(klcl),rp(klcl)))*log(phalf(klcl+1)/phalf(klcl))
         else
! if you¹re buoyant, then add to cape
            cape = cape + rdgas*(virtual_temp(tp(klcl),rp(klcl)) - &
                  tin_virtual(klcl))*log(phalf(klcl+1)/phalf(klcl))
! if it¹s the first time buoyant, then set the level of free convection to k
            if (nocape) then
               nocape = .false.
               klfc = klcl
            endif
         end if
      end if
! then average the properties over the boundary layer if so desired.  to give
! a new "parcel".  this may not be saturated at the LCL, so make sure you get
! to a level where it is before moist adiabatic ascent!
!
! then, start at the LCL, and do moist adiabatic ascent by the first order
! scheme -- 2nd order as well
      do k=klcl-1,1,-1
! note moist adiabat derivatives are approximate and should be replaced
! with more accurate expressions (see e.g. Holton pg 503 for derivation)
         a = kappa*tp(k+1) + hlv/cp_air*rp(k+1)
         b = hlv**2./cp_air/rvgas*rp(k+1)/tp(k+1)**2.
         dtdlnp = a/(1. + b)
! first order in p
!         tp(k) = tp(k+1) + dtdlnp*log(p(k)/p(k+1))
! second order in p (RK2)
! first get temp halfway up
         tp(k) = tp(k+1) + dtdlnp*log(p(k)/p(k+1))/2.
         if ((tp(k).lt.173.16).and.nocape) go to 11
         call escomp(tp(k),es)
         rp(k) = mixing_ratio(es,(p(k) + p(k+1))/2)
         a = kappa*tp(k) + hlv/cp_air*rp(k)
         b = hlv**2./cp_air/rvgas*rp(k)/tp(k)**2.
         dtdlnp = a/(1. + b)
! second half of RK2
         tp(k) = tp(k+1) + dtdlnp*log(p(k)/p(k+1))
! if you're below the lookup table value, just presume that there's no way
! you could have cape and call it quits
         if ((tp(k).lt.173.16).and.nocape) go to 11
         call escomp(tp(k),es)
         rp(k) = mixing_ratio(es,p(k))
         if ((virtual_temp(tp(k),rp(k)).lt.tin_virtual(k)).and.nocape) then
! if you¹re not yet buoyant, then add to the CIN and continue
            cin = cin + rdgas*(tin_virtual(k)-virtual_temp(tp(k),rp(k)))*log(phalf(k+1)/phalf(k))
         elseif((virtual_temp(tp(k),rp(k)).lt.tin_virtual(k)).and.(.not.nocape)) then
! if you have CAPE, and it¹s your first time being negatively buoyant,
! then set the level of zero buoyancy to k+1, and stop the moist ascent
            klzb = k+1
            go to 11
         else
! if you¹re buoyant, then add to cape
            cape = cape + rdgas*(virtual_temp(tp(k),rp(k))-tin_virtual(k))*log(phalf(k+1)/phalf(k))
! if it¹s the first time buoyant, then set the level of free convection to k
            if (nocape) then
               nocape = .false.
               klfc = k
            endif
         end if
      end do
 11   if(nocape) then
! this is if you made it through without having a LZB
! set LZB to be the top level.
         plzb = p(1)
         klzb = 0
         klfc = 0
         cin = 0.
         tp(1:kx) = tin(1:kx)
         rp(1:kx) = rin(1:kx)
      end if
!      write (*,*) 'plcl, klcl, tlcl, r0 new', plcl, klcl, tlcl, r0
!      write (*,*) 'tp, rp new', tp, rp
!       write (*,*) 'tp, new', tp
!       write (*,*) 'tin new', tin
!       write (*,*) 'klcl, klfc, klzb new', klcl, klfc, klzb
      end subroutine capecalcnew

! lookup table for the analytic evaluation of LCL
!     subroutine lcltabl(value,tlcl,myThid)
      subroutine lcltabl(value,tlcl,i,j,bi,bj,myIter,myThid)
!
! Table of values used to compute the temperature of the lifting condensation
! level.
!
! the expression that we utilize is log(r/(Rd/Rv+r)/theta**(1/kappa)*pstar) =
! log(es/T**(1/kappa))
!
! Gives the values of the temperature for the following range:
!   starts with -23, is uniformly distributed up to -10.4.  There are a
! total of 127 values, and the increment is .1.
!
      implicit none
      real, intent(in)     :: value
      real, intent(out)    :: tlcl
      integer, intent(in)  :: i,j,bi,bj,myIter
      integer, intent(in)  :: myThid

      integer              :: ival
      real, dimension(127) :: lcltable
      real                 :: v1, v2

      integer              :: errorMessageUnit
      DATA errorMessageUnit / 15 /

      data lcltable/  1.7364512e+02,   1.7427449e+02,   1.7490874e+02, &
      1.7554791e+02,   1.7619208e+02,   1.7684130e+02,   1.7749563e+02, &
      1.7815514e+02,   1.7881989e+02,   1.7948995e+02,   1.8016539e+02, &
      1.8084626e+02,   1.8153265e+02,   1.8222461e+02,   1.8292223e+02, &
      1.8362557e+02,   1.8433471e+02,   1.8504972e+02,   1.8577068e+02, &
      1.8649767e+02,   1.8723077e+02,   1.8797006e+02,   1.8871561e+02, &
      1.8946752e+02,   1.9022587e+02,   1.9099074e+02,   1.9176222e+02, &
      1.9254042e+02,   1.9332540e+02,   1.9411728e+02,   1.9491614e+02, &
      1.9572209e+02,   1.9653521e+02,   1.9735562e+02,   1.9818341e+02, &
      1.9901870e+02,   1.9986158e+02,   2.0071216e+02,   2.0157057e+02, &
      2.0243690e+02,   2.0331128e+02,   2.0419383e+02,   2.0508466e+02, &
      2.0598391e+02,   2.0689168e+02,   2.0780812e+02,   2.0873335e+02, &
      2.0966751e+02,   2.1061074e+02,   2.1156316e+02,   2.1252493e+02, &
      2.1349619e+02,   2.1447709e+02,   2.1546778e+02,   2.1646842e+02, &
      2.1747916e+02,   2.1850016e+02,   2.1953160e+02,   2.2057364e+02, &
      2.2162645e+02,   2.2269022e+02,   2.2376511e+02,   2.2485133e+02, &
      2.2594905e+02,   2.2705847e+02,   2.2817979e+02,   2.2931322e+02, &
      2.3045895e+02,   2.3161721e+02,   2.3278821e+02,   2.3397218e+02, &
      2.3516935e+02,   2.3637994e+02,   2.3760420e+02,   2.3884238e+02, &
      2.4009473e+02,   2.4136150e+02,   2.4264297e+02,   2.4393941e+02, &
      2.4525110e+02,   2.4657831e+02,   2.4792136e+02,   2.4928053e+02, &
      2.5065615e+02,   2.5204853e+02,   2.5345799e+02,   2.5488487e+02, &
      2.5632953e+02,   2.5779231e+02,   2.5927358e+02,   2.6077372e+02, &
      2.6229310e+02,   2.6383214e+02,   2.6539124e+02,   2.6697081e+02, &
      2.6857130e+02,   2.7019315e+02,   2.7183682e+02,   2.7350278e+02, &
      2.7519152e+02,   2.7690354e+02,   2.7863937e+02,   2.8039954e+02, &
      2.8218459e+02,   2.8399511e+02,   2.8583167e+02,   2.8769489e+02, &
      2.8958539e+02,   2.9150383e+02,   2.9345086e+02,   2.9542719e+02, &
      2.9743353e+02,   2.9947061e+02,   3.0153922e+02,   3.0364014e+02, &
      3.0577420e+02,   3.0794224e+02,   3.1014515e+02,   3.1238386e+02, &
      3.1465930e+02,   3.1697246e+02,   3.1932437e+02,   3.2171609e+02, &
      3.2414873e+02,   3.2662343e+02,   3.2914139e+02,   3.3170385e+02 /

!     v1 = value
      v1 = MIN( MAX( value, -23.d0 ), -10.4d0 )
!     if (value.lt.-23.0) call error_mesg ('dargan_bettsmiller',  &
!                        'lcltable: value too low', FATAL)

!     if (value.gt.-10.4) call error_mesg ('dargan_bettsmiller',  &
!                        'lcltable: value too high', FATAL)
      if (value.lt.-23.0) then
          CALL PRINT_ERROR( 'In: dargan_bettsmiller '//  &
                            'lcltable: value too low', myThid)
          WRITE(errorMessageUnit,'(A,4I4,I6,1PE14.6)')   &
            'i,j,bi,bj,myIter,value=',i,j,bi,bj,myIter,value
!         STOP 'ABNORMAL END: S/R LCLTABL (dargan_bettsmiller_mod)'
      endif
      if (value.gt.-10.4) then
          CALL PRINT_ERROR( 'In: dargan_bettsmiller '//  &
                            'lcltable: value too high', myThid)
          WRITE(errorMessageUnit,'(A,4I4,I6,1PE14.6)')   &
            'i,j,bi,bj,myIter,value=',i,j,bi,bj,myIter,value
!         STOP 'ABNORMAL END: S/R LCLTABL (dargan_bettsmiller_mod)'
      endif
      ival = floor(10.*(v1 + 23.0))
      v2 = -230. + ival
      v1 = 10.*v1
      tlcl = (v2 + 1.0 - v1)*lcltable(ival+1) + (v1 - v2)*lcltable(ival+2)

      end subroutine lcltabl

!#######################################################################

   subroutine dargan_bettsmiller_init (myThid)

!-----------------------------------------------------------------------
!
!        initialization for bettsmiller
!
!-----------------------------------------------------------------------

! integer  unit,io,ierr
  integer, intent(in) ::myThid
!-------------------------------------------------------------------------------------
!integer, dimension(3) :: half = (/1,2,4/)
!integer :: ierr, io
integer         :: iUnit
CHARACTER*(gcm_LEN_MBUF) :: msgBuf
!-------------------------------------------------------------------------------

!----------- read namelist ---------------------------------------------

!      if (file_exist('input.nml')) then
!         unit = open_file (file='input.nml', action='read')
!         ierr=1; do while (ierr /= 0)
!            read  (unit, nml=dargan_bettsmiller_nml, iostat=io, end=10)
!            ierr = check_nml_error (io,'dargan_bettsmiller_nml')
!         enddo
!  10     call close_file (unit)
!      endif

!---------- output namelist --------------------------------------------

!      unit = open_file (file='logfile.out', action='append')
!      if ( mpp_pe() == 0 ) then
!           write (unit,'(/,80("="),/(a))') trim(version), trim(tag)
!           write (unit,nml=dargan_bettsmiller_nml)
!      endif
!      call close_file (unit)

!      do_init=.false.

!    _BARRIER
!    _BEGIN_MASTER(myThid)
     CALL BARRIER(myThid)
     IF ( myThid.EQ.1 ) THEN

     WRITE(msgBuf,'(A)') 'DARGAN_BETTSMILLER_init: opening data.atm_gray'
     CALL PRINT_MESSAGE( msgBuf, gcm_stdMsgUnit, gcm_SQZ_R, myThid )
     CALL OPEN_COPY_DATA_FILE(                                      &
                           'data.atm_gray', 'DARGAN_BETTSMILLER_init',       &
                           iUnit,                                   &
                           myThid )
!    Read parameters from open data file
     READ(UNIT=iUnit,NML=dargan_bettsmiller_nml)
     WRITE(msgBuf,'(A)')                                            &
          'DARGAB_BETTSMILLER_INIT: finished reading data.atm_gray'
     CALL PRINT_MESSAGE( msgBuf, gcm_stdMsgUnit, gcm_SQZ_R, myThid )
!    Close the open data file
#ifdef SINGLE_DISK_IO
     CLOSE(iUnit)
#else
     CLOSE(iUnit,STATUS='DELETE')
#endif /* SINGLE_DISK_IO */

     ENDIF
     CALL BARRIER(myThid)

   return
   end subroutine dargan_bettsmiller_init

!#######################################################################

 real function mixing_ratio(vapor_pressure, pressure)

 ! calculates the mixing ratio from the vapor pressure and pressure

      implicit none
      real, intent(in)     :: vapor_pressure, pressure

      mixing_ratio = rdgas*vapor_pressure/rvgas/(pressure-vapor_pressure)

 end function mixing_ratio

!#######################################################################

 real function virtual_temp(temp, r)

 ! calculates the virtual temperature from the temperature and mixing ratio
 ! consistent with the approximation used in the fms code

      implicit none
      real, intent(in)     :: temp         ! temperature
      real, intent(in)     :: r            ! mixing ratio

      real                 :: q            ! specific humidity

      if (do_virtual) then
       q = r/(1.0+r)
       virtual_temp = temp*(1.0+q*(rvgas/rdgas-1.0))
      else
       virtual_temp = temp
      endif

 end function virtual_temp

!#######################################################################

end module dargan_bettsmiller_mod

#include "MOM_FLUXFORM_OPTIONS.h"

CBOP
C !ROUTINE: MOM_V_ADV_WV

C !INTERFACE: ==========================================================
      SUBROUTINE MOM_V_ADV_WV(
     I        bi, bj, k, deepFacA,
     I        vFld, wFld, rTrans,
     O        advectiveFluxWV,
     I        myThid )

C !DESCRIPTION:
C Calculates the vertical advective flux of meridional momentum:
C \begin{equation*}
C F^r = \overline{W}^j \overline{v}^{k}
C \end{equation*}

C !USES: ===============================================================
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"

C !INPUT PARAMETERS: ===================================================
C  bi, bj               :: tile indices
C  k                    :: vertical level
C  deepFacA             :: deep-model grid factor at level center
C  vFld                 :: meridional velocity
C  wFld                 :: vertical velocity
C  rTrans               :: vertical transport (above V point)
C  myThid               :: my Thread Id number
      INTEGER bi, bj, k
      _RL deepFacA(Nr)
      _RL vFld(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      _RL wFld(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      _RL rTrans(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER myThid

C !OUTPUT PARAMETERS: ==================================================
C  advectiveFluxWV      :: advective flux
      _RL advectiveFluxWV(1-OLx:sNx+OLx,1-OLy:sNy+OLy)

C !LOCAL VARIABLES: ====================================================
C  i, j                 :: loop indices
      INTEGER i, j
CEOP

      IF ( k.EQ.Nr+1 .AND.
     &     useRealFreshWaterFlux .AND. usingPCoords ) THEN
       DO j=1-OLy+1,sNy+OLy
        DO i=1-OLx+1,sNx+OLx
         advectiveFluxWV(i,j) = rTrans(i,j)*vFld(i,j,k-1,bi,bj)
     &                                     *deepFacA(k-1)
        ENDDO
       ENDDO

      ELSEIF ( k.GT.Nr .OR. (k.EQ.1.AND.rigidLid) ) THEN
C     Advective flux = 0  at k=Nr+1 ; = 0 at k=1 if rigid-lid

       DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
         advectiveFluxWV(i,j) = 0.
        ENDDO
       ENDDO

      ELSEIF (k.EQ.1) THEN
C     (linear) Free-surface correction at k=1

       DO j=1-OLy+1,sNy+OLy
        DO i=1-OLx+1,sNx+OLx
         advectiveFluxWV(i,j) = rTrans(i,j)*vFld(i,j,k,bi,bj)
     &                                     *deepFacA(k)
        ENDDO
       ENDDO

      ELSE

C     Vertical advection - interior ; assume vFld & wFld are masked
       DO j=1-OLy+1,sNy+OLy
        DO i=1-OLx+1,sNx+OLx
         advectiveFluxWV(i,j) = rTrans(i,j)*halfRL
#ifdef MOM_BOUNDARY_CONSERVE
     &    *( vFld(i,j, k ,bi,bj)*deepFacA( k )*_maskS(i,j,k-1,bi,bj)
     &     + vFld(i,j,k-1,bi,bj)*deepFacA(k-1)*_maskS(i,j, k ,bi,bj) )
#else
     &    *( vFld(i,j, k ,bi,bj)*deepFacA( k )
     &     + vFld(i,j,k-1,bi,bj)*deepFacA(k-1) )
#endif
        ENDDO
       ENDDO

       IF ( select_rStar.EQ.0 .AND. .NOT.rigidLid ) THEN
c    &                        .AND. usingPCoords ) THEN
C     (linear) Free-surface correction at k>1
        DO j=1-OLy+1,sNy+OLy
         DO i=1-OLx+1,sNx+OLx
          advectiveFluxWV(i,j) = advectiveFluxWV(i,j)
     &     +0.25 _d 0*(
     &          wFld(i, j ,k,bi,bj)*rA(i, j ,bi,bj)
     &           *(maskC(i, j ,k,bi,bj)-maskC(i, j ,k-1,bi,bj))
     &         +wFld(i,j-1,k,bi,bj)*rA(i,j-1,bi,bj)
     &           *(maskC(i,j-1,k,bi,bj)-maskC(i,j-1,k-1,bi,bj))
     &                )*deepFac2F(k)*rhoFacF(k)
     &                 *vFld(i,j,k,bi,bj)*deepFacA(k)
         ENDDO
        ENDDO
C- endif select_rStar=0 and NOT rigidLid
       ENDIF

C- endif special k cases
      ENDIF

      RETURN
      END

#include "CPP_EEOPTIONS.h"
C--   File active_read_tap.F: Active read with Tapenade.
C--    Contents:
C--    o ACTIVE_READ_XY_D
C--    o ACTIVE_READ_XYZ_D
C--    o ACTIVE_READ_XY_B
C--    o ACTIVE_READ_XYZ_B
C--    o ACTIVE_READ_XY_BWD (for use without checkpointing)
C--    o ACTIVE_READ_XY_FWD (for use without checkpointing)

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

CBOP
C     !ROUTINE: ACTIVE_READ_XY_D
C     !INTERFACE:
      SUBROUTINE ACTIVE_READ_XY_D(active_var_file,
     &                 active_var, active_vard,
     &                 iRec, doglobalread, lAdInit,
     &                 myOptimIter, myThid, dummy, dummyd)

C     *==========================================================*
C     | SUBROUTINE ACTIVE_READ_XY_D
C     | o Tangent linear differentiation of ACTIVE_READ_XY.
C     *==========================================================*
C     | written by Shreyas Gaikwad, Laurent Hascoet in Nov 2022
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     active_var_file:: filename
C     active_var     :: array
C     active_vard     :: forward derivative of active_var
C     iRec           :: record number
C     doglobalread   :: flag for global or local read/write
C                       (default: .false.)
C     lAdInit        :: initialisation of corresponding adjoint
C                       variable and write to active file
C     myOptimIter    :: number of optimization iteration (default: 0)
C     myThid     :: my Thread Id. number
      CHARACTER*(*) active_var_file
      _RL     active_vard(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL     active_var(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      INTEGER iRec
      LOGICAL doglobalread
      LOGICAL lAdInit
      INTEGER myOptimIter
      INTEGER myThid
      _RL  dummy
      _RL dummyd

C     !LOCAL VARIABLES:
      CHARACTER*(80) fname
      CHARACTER*(2) tlmpref
CEOP

      tlmpref = 'g_'
      CALL ADD_PREFIX( tlmpref, active_var_file, fname )

      CALL ACTIVE_READ_XY(active_var_file, active_var,
     &                    iRec, doglobalread, lAdInit,
     &                    myOptimIter, myThid, dummy)
      CALL ACTIVE_READ_XY(fname, active_vard, iRec,
     &                    doglobalread, lAdInit,
     &                    myOptimIter, myThid, dummyd)

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

CBOP
C     !ROUTINE: ACTIVE_READ_XYZ_D
C     !INTERFACE:
      SUBROUTINE ACTIVE_READ_XYZ_D(active_var_file,
     &                 active_var, active_vard,
     &                 iRec, doglobalread, lAdInit,
     &                 myOptimIter, myThid, dummy, dummyd)

C     *==========================================================*
C     | SUBROUTINE ACTIVE_READ_XYZ_D
C     | o Tangent linear differentiation of ACTIVE_READ_XYZ.
C     *==========================================================*
C     | written by Shreyas Gaikwad, Laurent Hascoet in Nov 2022
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     active_var_file:: filename
C     active_var     :: array
C     active_vard     :: forward derivative of active_var
C     iRec           :: record number
C     doglobalread   :: flag for global or local read/write
C                       (default: .false.)
C     lAdInit        :: initialisation of corresponding adjoint
C                       variable and write to active file
C     myOptimIter    :: number of optimization iteration (default: 0)
C     myThid     :: my Thread Id. number
      CHARACTER*(*) active_var_file
      _RL     active_vard(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      _RL     active_var(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      INTEGER iRec
      LOGICAL doglobalread
      LOGICAL lAdInit
      INTEGER myOptimIter
      INTEGER myThid
      _RL  dummy
      _RL dummyd

C     !LOCAL VARIABLES:
      CHARACTER*(80) fname
      CHARACTER*(2) tlmpref
CEOP

      tlmpref = 'g_'
      CALL ADD_PREFIX( tlmpref, active_var_file, fname )

      CALL ACTIVE_READ_XYZ(active_var_file, active_var,
     &                    iRec, doglobalread, lAdInit,
     &                    myOptimIter, myThid, dummy)
      CALL ACTIVE_READ_XYZ(fname, active_vard, iRec,
     &                    doglobalread, lAdInit,
     &                    myOptimIter, myThid, dummyd)

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

CBOP
C     !ROUTINE: ACTIVE_READ_XY_B
C     !INTERFACE:
      SUBROUTINE ACTIVE_READ_XY_B(active_var_file,
     &                 active_var, active_varb,
     &                 iRec, doglobalread, lAdInit,
     &                 myOptimIter, myThid, dummy, dummyb)

C     *==========================================================*
C     | SUBROUTINE ACTIVE_READ_XY_B
C     | o Reverse differentiation of ACTIVE_READ_XY.
C     *==========================================================*
C     | written by Shreyas Gaikwad, Laurent Hascoet in Nov 2022
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     active_var_file:: filename
C     active_var     :: array
C     active_varb     :: reverse derivative of active_var
C     iRec           :: record number
C     doglobalread   :: flag for global or local read/write
C                       (default: .false.)
C     lAdInit        :: initialisation of corresponding adjoint
C                       variable and write to active file
C     myOptimIter    :: number of optimization iteration (default: 0)
C     myThid     :: my Thread Id. number
      CHARACTER*(*) active_var_file
      _RL     active_var(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL     active_varb(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      INTEGER iRec
      INTEGER myIter, myThid
      LOGICAL doglobalread
      LOGICAL lAdInit
      INTEGER myOptimIter
C Tags for IO: ctrl input and adjoint (gradient) output
      _RL  dummy, dummyb

C     !LOCAL VARIABLES:
      CHARACTER*(2) adpref
      CHARACTER*(80) fname
      INTEGER myNr
      LOGICAL useCurrentDir
CEOP

      adpref = 'ad'
      CALL ADD_PREFIX( adpref, active_var_file, fname )
      myNr = 1
      useCurrentDir = .FALSE.

      CALL ACTIVE_READ_3D_RL(
     &                 fname, active_varb, doglobalread,
     &                 useCurrentDir, lAdInit, iRec, myNr,
     &                 REVERSE_SIMULATION, myIter, myThid )

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

CBOP
C     !ROUTINE: ACTIVE_READ_XYZ_B
C     !INTERFACE:
      SUBROUTINE ACTIVE_READ_XYZ_B(active_var_file,
     &                 active_var, active_varb,
     &                 iRec, doglobalread, lAdInit,
     &                 myOptimIter, myThid, dummy, dummyb)

C     *==========================================================*
C     | SUBROUTINE ACTIVE_READ_XYZ_B
C     | o Reverse differentiation of ACTIVE_READ_XYZ.
C     *==========================================================*
C     | written by Shreyas Gaikwad, Laurent Hascoet in Nov 2022
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     active_var_file:: filename
C     active_var     :: array
C     active_varb     :: reverse derivative of active_var
C     iRec           :: record number
C     doglobalread   :: flag for global or local read/write
C                       (default: .false.)
C     lAdInit        :: initialisation of corresponding adjoint
C                       variable and write to active file
C     myOptimIter    :: number of optimization iteration (default: 0)
C     myThid     :: my Thread Id. number
      CHARACTER*(*) active_var_file
      _RL     active_var(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      _RL     active_varb(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      INTEGER iRec
      INTEGER myIter, myThid
      LOGICAL doglobalread
      LOGICAL lAdInit
      INTEGER myOptimIter
C Tags for IO: ctrl input and adjoint (gradient) output
      _RL  dummy, dummyb

C     !LOCAL VARIABLES:
      CHARACTER*(2) adpref
      CHARACTER*(80) fname
      INTEGER myNr
      LOGICAL useCurrentDir
CEOP

      adpref = 'ad'
      CALL ADD_PREFIX( adpref, active_var_file, fname )
      myNr = Nr
      useCurrentDir = .FALSE.

      CALL ACTIVE_READ_3D_RL(
     &                 fname, active_varb, doglobalread,
     &                 useCurrentDir, lAdInit, iRec, myNr,
     &                 REVERSE_SIMULATION, myIter, myThid )

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

CBOP
C     !ROUTINE: ACTIVE_READ_XY_FWD
C     !INTERFACE:
      SUBROUTINE ACTIVE_READ_XY_FWD(active_var_file,
     &                 active_var,
     &                 iRec, doglobalread, lAdInit,
     &                 myOptimIter, myThid, dummy)

C     *==========================================================*
C     | SUBROUTINE ACTIVE_READ_XY_FWD
C     | o Reverse differentiation of ACTIVE_READ_XY.
C     *==========================================================*
C     | written by Shreyas Gaikwad, Laurent Hascoet in Nov 2022
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     active_var_file:: filename
C     active_var     :: array
C     active_varb     :: reverse derivative of active_var
C     iRec           :: record number
C     doglobalread   :: flag for global or local read/write
C                       (default: .false.)
C     lAdInit        :: initialisation of corresponding adjoint
C                       variable and write to active file
C     myOptimIter    :: number of optimization iteration (default: 0)
C     myThid     :: my Thread Id. number
      CHARACTER*(*) active_var_file
      _RL     active_var(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      INTEGER iRec
      INTEGER myIter, myThid
      LOGICAL doglobalread
      LOGICAL lAdInit
      INTEGER myOptimIter
C Tags for IO: ctrl input and adjoint (gradient) output
      _RL  dummy

      CALL ACTIVE_READ_XY(active_var_file, active_var,
     &                    iRec, doglobalread, lAdInit,
     &                    myOptimIter, myThid, dummy)

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

CBOP
C     !ROUTINE: ACTIVE_READ_XY_BWD
C     !INTERFACE:
      SUBROUTINE ACTIVE_READ_XY_BWD(active_var_file,
     &                 active_var, active_varb,
     &                 iRec, doglobalread, lAdInit,
     &                 myOptimIter, myThid, dummy, dummyb)

C     *==========================================================*
C     | SUBROUTINE ACTIVE_READ_XY_BWD
C     | o Reverse differentiation of ACTIVE_READ_XY.
C     *==========================================================*
C     | written by Shreyas Gaikwad, Laurent Hascoet in Nov 2022
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     active_var_file:: filename
C     active_var     :: array
C     active_varb     :: reverse derivative of active_var
C     iRec           :: record number
C     doglobalread   :: flag for global or local read/write
C                       (default: .false.)
C     lAdInit        :: initialisation of corresponding adjoint
C                       variable and write to active file
C     myOptimIter    :: number of optimization iteration (default: 0)
C     myThid     :: my Thread Id. number
      CHARACTER*(*) active_var_file
      _RL     active_var(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL     active_varb(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      INTEGER iRec
      INTEGER myIter, myThid
      LOGICAL doglobalread
      LOGICAL lAdInit
      INTEGER myOptimIter
C Tags for IO: ctrl input and adjoint (gradient) output
      _RL  dummy, dummyb

      CALL ACTIVE_READ_XY_B(active_var_file,
     &                 active_var, active_varb,
     &                 iRec, doglobalread, lAdInit,
     &                 myOptimIter, myThid, dummy, dummyb)

      RETURN
      END

#include "ATM2D_OPTIONS.h"

CBOP 0
C !ROUTINE: CPL_SEND_OCN_ATMCONFIG

C !INTERFACE:
      SUBROUTINE CPL_SEND_OCN_ATMCONFIG

C !DESCRIPTION:
C     *==========================================================*
C     | SUBROUTINE CPL_SEND_OCN_ATMCONFIG
C     | o Routine for sending atmos. config to ocean component.
C     *==========================================================*
C     | This version talks to the MITgcm general circulation
C     | model. For now just send atmosphere land/sea mask.
C     *==========================================================*

#ifdef ATM2D_MPI_ON
C !USES:
      IMPLICIT NONE
C     == Global variables ==
c#include "ATMSIZE.h"
c#include "ATMVARS.h"
#include "ATMIDS.h"
#include "OCNSIZE.h"
#include "OCNVARS.h"
#include "OCNIDS.h"

C !INPUT/OUTPUT PARAMETERS:
C !LOCAL VARIABLES:
      INTEGER i,j
CEOP

C     Map atmos. depth map onto ocean grid
c     CALL ATM_TO_OCN_MAPXYR8(
c    I     Nx_atm, Ny_atm,
c    I     landMask_atm,
c    I     Nx_ocn, Ny_ocn,
c    O     landMask_ocn)
      DO i=1,Nx_ocn
        DO j=1,Ny_ocn
          landMask_ocn(i,j)= 0.5  !ocean code checks for this
        ENDDO
      ENDDO

C     Send atmos. config to ocean component
      CALL COUPSEND_R8TILES( ocnCompName, atmLandName, Nx_ocn, Ny_ocn,
     &                       landMask_ocn )

#endif /* ATM2D_MPI_ON */

      RETURN
      END

#include "ATM_CPL_OPTIONS.h"

CBOP
C     !ROUTINE: ATM_IMPORT_FIELDS
C     !INTERFACE:
      SUBROUTINE ATM_IMPORT_FIELDS( myIter, myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE ATM_IMPORT_FIELDS
C     | o Routine for importing ocean surface coupling fields
C     |   from coupling layer.
C     *==========================================================*
C     | This version talks to the MIT Coupler. It uses the MIT
C     | Coupler "checkpoint1" library calls.
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "CPL_PARAMS.h"
#include "ATMCPL.h"
#include "ATMIDS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     myIter  :: Current timestep number.
C     myThid  :: my Thread Id number
      INTEGER myIter
      INTEGER myThid
CEOP

#ifdef COMPONENT_MODULE
C     !LOCAL VARIABLES:
C     == Local variables ==

C     Fetch data from coupling layer. Note MIT Coupler checkpoint1
C     does not allow asynchronous extraction of data, so ordering
C     has to be consistent with ordering coupling layer.

      _BARRIER
      _BEGIN_MASTER( myThid )

C-    Receive ocean mixed-layer thickness from coupling layer.
      CALL COMPRECV_R8TILES( atmMxlDName,
     I                       sNx, OLx, sNy, OLy, 1, nSx, nSy,
     O                       ocMxlD )

C-    Receive ocean surface temperatures from coupling layer.
      CALL COMPRECV_R8TILES( atmSSTName,
     I                       sNx, OLx, sNy, OLy, 1, nSx, nSy,
     O                       SSTocn )

C-    Receive ocean surface salinity from coupling layer.
      CALL COMPRECV_R8TILES( atmSSSName,
     I                       sNx, OLx, sNy, OLy, 1, nSx, nSy,
     O                       SSSocn )

C-    Receive ocean surface velocity square from coupling layer.
      CALL COMPRECV_R8TILES( atmSSVsqName,
     I                       sNx, OLx, sNy, OLy, 1, nSx, nSy,
     O                       vSqocn )

#ifdef ALLOW_AIM
C-    Receive air-sea flux of CO2
      IF ( atm_cplExch_DIC ) THEN
        CALL COMPRECV_R8TILES( atmCO2FluxName,
     I                         sNx, OLx, sNy, OLy, 1, nSx, nSy,
     O                         flxCO2ocn )
      ENDIF
#endif /* ALLOW_AIM */
#ifdef ALLOW_THSICE
      IF ( atm_cplExch2W_sIce ) THEN
C-    Receive seaice fraction:
        CALL COMPRECV_R8TILES( atmSIceFracName,
     I                         sNx, OLx, sNy, OLy, 1, nSx, nSy,
     O                         sIceFrac_cpl )
C-    Receive seaice thickness:
        CALL COMPRECV_R8TILES( atmSIceThickName,
     I                         sNx, OLx, sNy, OLy, 1, nSx, nSy,
     O                         sIceThick_cpl )
C-    Receive snow thickness:
        CALL COMPRECV_R8TILES( atmSIceSnowName,
     I                         sNx, OLx, sNy, OLy, 1, nSx, nSy,
     O                         sIceSnowH_cpl )
C-    Receive seaice enthalpy (layer 1):
        CALL COMPRECV_R8TILES( atmSIceQ1Name,
     I                         sNx, OLx, sNy, OLy, 1, nSx, nSy,
     O                         sIceQ1_cpl )
C-    Receive seaice enthalpy (layer 2):
        CALL COMPRECV_R8TILES( atmSIceQ2Name,
     I                         sNx, OLx, sNy, OLy, 1, nSx, nSy,
     O                         sIceQ2_cpl )
      ENDIF
#endif /* ALLOW_THSICE */

      _END_MASTER( myThid )
      _BARRIER

#endif /* COMPONENT_MODULE */

      RETURN
      END

#include "FRAZIL_OPTIONS.h"

CBOP
C !ROUTINE: FRAZIL_CALC_RHS

C !INTERFACE: ==========================================================
      SUBROUTINE FRAZIL_CALC_RHS(
     I                     myTime, myIter, myThid )

C !DESCRIPTION:
C Check water temperature and if colder than freezing
C point bring excess negative heat to the surface.

C !USES: ===============================================================
      IMPLICIT NONE
#include "EEPARAMS.h"
#include "SIZE.h"
#include "PARAMS.h"
#include "GRID.h"
#include "DYNVARS.h"
#include "FFIELDS.h"
#ifdef ALLOW_FRAZIL
# include "FRAZIL.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     myTime :: current time in simulation
C     myIter :: current iteration number in simulation
C     myThid :: my Thread Id number
      _RL     myTime
      INTEGER myIter
      INTEGER myThid
CEOP

#ifdef ALLOW_FRAZIL

C     !LOCAL VARIABLES:
C     Tfreezing :: freezing threshold temperature
      INTEGER bi,bj,i,j,k,kTop
      _RL Tfreezing, Tresid, pLoc, sLoc, tLoc
      _RL a0, a1, a2, b
      PARAMETER( a0 = -0.0575   _d  0 )
      PARAMETER( a1 = 1.710523  _d -3 )
      PARAMETER( a2 = -2.154996 _d -4 )
      PARAMETER( b  = -7.53     _d -4 )

      _RL SW_TEMP
      EXTERNAL SW_TEMP

      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)

C     Initialize FrazilForcingT to zero
        DO k=1,Nr
         DO j=1-Oly,sNy+OLy
          DO i=1-Olx,sNx+Olx
           FrazilForcingT(i,j,k,bi,bj) = 0. _d 0
          ENDDO
         ENDDO
        ENDDO

C     Check for water below freezing point.
        DO k = 2, Nr
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           IF ( maskC(i,j,k-1,bi,bj) .NE. 0. _d 0 .AND.
     &          maskC(i,j,k,  bi,bj) .NE. 0. _d 0 ) THEN

            pLoc = ABS(RC(k))
            sLoc = MAX(salt(i,j,k,bi,bj), 0. _d 0)
            tLoc = SW_TEMP(sLoc,theta(i,j,k,bi,bj),pLoc,0. _d 0)

C Freezing point of seawater
C   REFERENCE: UNESCO TECH. PAPERS IN THE MARINE SCIENCE NO. 28. 1978
C   EIGHTH REPORT JPOTS
C   ANNEX 6 FREEZING POINT OF SEAWATER F.J. MILLERO PP.29-35.
C
C  UNITS:
C         PRESSURE      P          DECIBARS
C         SALINITY      S          PSS-78
C         TEMPERATURE   TF         DEGREES CELSIUS
C         FREEZING PT.
C************************************************************
C  CHECKVALUE: TF= -2.588567 DEG. C FOR S=40.0, P=500. DECIBARS 
            Tfreezing = (a0 + a1*sqrt(sLoc) + a2*sLoc) * sLoc + b*pLoc

            IF (tLoc .LT. Tfreezing) THEN
C     Move the negative heat to surface level.
             kTop = kSurfC(i,j,bi,bj)
             Tresid = ( Tfreezing - tloc )
     &            * HeatCapacity_Cp * rUnit2mass
     &            * drF(k) * _hFacC(i,j,k,bi,bj)
             FrazilForcingT(i,j,k,bi,bj) = Tresid / dTtracerLev(k)
             FrazilForcingT(i,j,kTop,bi,bj) =
     &            FrazilForcingT(i,j,kTop,bi,bj)
     &            - Tresid / dTtracerLev(kTop)
            ENDIF
           ENDIF
          ENDDO
         ENDDO
        ENDDO
       ENDDO
      ENDDO

# ifdef ALLOW_DIAGNOSTICS
      IF ( useDiagnostics ) THEN
         CALL DIAGNOSTICS_FILL( FrazilForcingT, 'FrzForcT',
     &                          0,Nr, 0, 1, 1, myThid )
      ENDIF
# endif /* ALLOW_DIAGNOSTICS */

#endif /* ALLOW_FRAZIL */

      RETURN
      END

#include "PACKAGES_CONFIG.h"
#include "CPP_OPTIONS.h"

CBOP
C     !ROUTINE: INI_MASKS_ETC
C     !INTERFACE:
      SUBROUTINE INI_MASKS_ETC( myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE INI_MASKS_ETC
C     | o Initialise masks and topography factors
C     *==========================================================*
C     | These arrays are used throughout the code and describe
C     | the topography of the domain through masks (0s and 1s)
C     | and fractional height factors (0<hFac<1). The latter
C     | distinguish between the lopped-cell and full-step
C     | topographic representations.
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#ifdef NONLIN_FRSURF
# include "SURFACE.h"
#endif /* NONLIN_FRSURF */

C     !INPUT/OUTPUT PARAMETERS:
C     myThid    ::  my Thread Id number
      INTEGER myThid

C     !LOCAL VARIABLES:
C     bi, bj    :: tile indices
C     i, j, k   :: Loop counters
C     tmpFld    :: Temporary array used to compute & write Total Depth
C     tmpVar    :: Temporary array used to integrate column thickness
C     rEmpty    :: empty column r-position
      INTEGER bi, bj
      INTEGER i, j, k
c     _RS tmpFld (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL tmpVar(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL hFacMnSz, hFac_loc
      _RL hFac1tmp, hFac2tmp
      _RS rEmpty
CEOP

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#ifdef ALLOW_SHELFICE
      IF ( useShelfIce ) THEN
C--   Modify  ocean upper boundary position according to ice-shelf topography
       CALL SHELFICE_INIT_DEPTHS(
     U               R_low, Ro_surf,
     I               myThid )
      ENDIF
#endif /* ALLOW_SHELFICE */
#ifdef ALLOW_STEEP_ICECAVITY
      IF ( useSTIC ) CALL STIC_INIT_DEPTHS( myThid )
#endif /* ALLOW_STEEP_ICECAVITY */

      IF ( selectSigmaCoord.EQ.0 ) THEN
C---  r-coordinate with partial-cell or full cell mask

C--   Initialise rLow & reference rSurf at Western & Southern edges (U & V pts)
C     Note: not final value since these estimates ignore hFacMin constrain
      rEmpty = rF(1)
      DO bj=myByLo(myThid), myByHi(myThid)
       DO bi=myBxLo(myThid), myBxHi(myThid)
        i = 1-OLx
        DO j=1-OLy,sNy+OLy
           rLowW (i,j,bi,bj) = rEmpty
           rSurfW(i,j,bi,bj) = rEmpty
        ENDDO
        j = 1-OLy
        DO i=1-OLx,sNx+OLx
           rLowS (i,j,bi,bj) = rEmpty
           rSurfS(i,j,bi,bj) = rEmpty
        ENDDO
        DO j=1-OLy,sNy+OLy
         DO i=2-OLx,sNx+OLx
           rLowW(i,j,bi,bj)  =
     &           MAX(   R_low(i-1,j,bi,bj),   R_low(i,j,bi,bj) )
           rSurfW(i,j,bi,bj) =
     &           MIN( Ro_surf(i-1,j,bi,bj), Ro_surf(i,j,bi,bj) )
         ENDDO
        ENDDO
        DO j=2-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
           rLowS(i,j,bi,bj)  =
     &           MAX(   R_low(i,j-1,bi,bj),   R_low(i,j,bi,bj) )
           rSurfS(i,j,bi,bj) =
     &           MIN( Ro_surf(i,j-1,bi,bj), Ro_surf(i,j,bi,bj) )
         ENDDO
        ENDDO
       ENDDO
      ENDDO

      DO bj=myByLo(myThid), myByHi(myThid)
       DO bi=myBxLo(myThid), myBxHi(myThid)

C--   Calculate lopping factor hFacC : over-estimate the part inside of the domain
C     taking into account the lower_R Boundary (Bathymetry / Top of Atmos)
        DO k=1, Nr
         hFacMnSz = MAX( hFacMin, MIN(hFacMinDr*recip_drF(k),oneRL) )
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
C      o Non-dimensional distance between grid bound. and domain lower_R bound.
           hFac_loc = (rF(k)-R_low(i,j,bi,bj))*recip_drF(k)
C      o Select between, closed, open or partial (0,1,0-1)
           hFac_loc = MIN( MAX( hFac_loc, zeroRL ) , oneRL )
C      o Impose minimum fraction and/or size (dimensional)
           IF ( hFac_loc.LT.hFacMnSz*halfRL .OR.
     &          R_low(i,j,bi,bj).GE.Ro_surf(i,j,bi,bj) ) THEN
             hFacC(i,j,k,bi,bj) = zeroRS
           ELSE
             hFacC(i,j,k,bi,bj) = MAX( hFac_loc, hFacMnSz )
           ENDIF
          ENDDO
         ENDDO
        ENDDO

C-    Re-calculate lower-R Boundary position, taking into account hFacC
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
           tmpVar(i,j) = 0. _d 0
         ENDDO
        ENDDO
        DO k=1,Nr
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           tmpVar(i,j) = tmpVar(i,j) + drF(k)*hFacC(i,j,k,bi,bj)
          ENDDO
         ENDDO
        ENDDO
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
           R_low(i,j,bi,bj) = rF(1) - tmpVar(i,j)
         ENDDO
        ENDDO

C--   Calculate lopping factor hFacC : Remove part outside of the domain
C     taking into account the Reference (=at rest) Surface Position Ro_surf
        DO k=1, Nr
         hFacMnSz = MAX( hFacMin, MIN(hFacMinDr*recip_drF(k),oneRL) )
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
C      o Non-dimensional distance between grid boundary and model surface
           hFac_loc = (rF(k)-Ro_surf(i,j,bi,bj))*recip_drF(k)
C      o Reduce the previous fraction : substract the outside part.
           hFac_loc = hFacC(i,j,k,bi,bj) - MAX( hFac_loc, zeroRL )
C      o set to zero if empty Column :
           hFac_loc = MAX( hFac_loc, zeroRL )
C      o Impose minimum fraction and/or size (dimensional)
           IF ( hFac_loc.LT.hFacMnSz*halfRL ) THEN
             hFacC(i,j,k,bi,bj) = zeroRS
           ELSE
             hFacC(i,j,k,bi,bj) = MAX( hFac_loc, hFacMnSz )
           ENDIF
          ENDDO
         ENDDO
        ENDDO

C-    Re-calculate Reference surface position, taking into account hFacC
C     initialize Total column fluid thickness and surface k index
C       Note: if no fluid (continent) ==> kSurf = Nr+1
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          tmpVar(i,j) = 0. _d 0
          kSurfC(i,j,bi,bj) = Nr+1
          kLowC (i,j,bi,bj) = 0
         ENDDO
        ENDDO
        DO k=1,Nr
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           tmpVar(i,j) = tmpVar(i,j) + drF(k)*hFacC(i,j,k,bi,bj)
           IF ( hFacC(i,j,k,bi,bj).NE.zeroRS ) kLowC(i,j,bi,bj) = k
          ENDDO
         ENDDO
        ENDDO
        DO k=Nr,1,-1
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           IF ( hFacC(i,j,k,bi,bj).NE.zeroRS ) kSurfC(i,j,bi,bj) = k
          ENDDO
         ENDDO
        ENDDO
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          Ro_surf(i,j,bi,bj) = R_low(i,j,bi,bj) + tmpVar(i,j)
          maskInC(i,j,bi,bj) = 0.
          IF ( kSurfC(i,j,bi,bj).LE.Nr ) maskInC(i,j,bi,bj) = 1.
c         k = MAX( 0, kLowC (i,j,bi,bj) - kSurfC(i,j,bi,bj) + 1 )
c         tmpFld(i,j,bi,bj) = k
         ENDDO
        ENDDO

C-    end bi,bj loops.
       ENDDO
      ENDDO

      IF ( plotLevel.GE.debLevB ) THEN
c       CALL PLOT_FIELD_XYRS( tmpFld,
c    &           'Model Depths K Index' , -1, myThid )
        CALL PLOT_FIELD_XYRS(R_low,
     &           'Model R_low (ini_masks_etc)', -1, myThid )
        CALL PLOT_FIELD_XYRS(Ro_surf,
     &           'Model Ro_surf (ini_masks_etc)', -1, myThid )
      ENDIF

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)

C--   Calculate quantities derived from XY depth map
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
C         Total fluid column thickness (r_unit) :
          tmpVar(i,j) = Ro_surf(i,j,bi,bj) - R_low(i,j,bi,bj)
c         tmpFld(i,j,bi,bj) = tmpVar(i,j)
C         Inverse of fluid column thickness (1/r_unit)
          IF ( tmpVar(i,j) .LE. zeroRL ) THEN
           recip_Rcol(i,j,bi,bj) = zeroRS
          ELSE
           recip_Rcol(i,j,bi,bj) = 1. _d 0 / tmpVar(i,j)
          ENDIF
         ENDDO
        ENDDO

C- Method-1 (useMin4hFacEdges = T):
C    compute hFacW,hFacS as minimum of adjacent hFacC factor
C- Method-2 (useMin4hFacEdges = F):
C    compute hFacW,hFacS from rSurfW,S and rLowW,S by applying
C    same rules as for hFacC
C Note: Currently, no difference between methods except when useShelfIce=T and
C       if, in adjacent columns, ice-draft and bathy are within the same level k

        IF ( useMin4hFacEdges ) THEN
C--   hFacW and hFacS (at U and V points):
C-    Method-1: use simply minimum of adjacent hFacC factor

         DO k=1, Nr
          DO j=1-OLy,sNy+OLy
           hFacW(1-OLx,j,k,bi,bj) = zeroRS
           DO i=2-OLx,sNx+OLx
            hFacW(i,j,k,bi,bj) =
     &        MIN( hFacC(i,j,k,bi,bj), hFacC(i-1,j,k,bi,bj) )
           ENDDO
          ENDDO
          DO i=1-OLx,sNx+OLx
            hFacS(i,1-OLy,k,bi,bj) = zeroRS
          ENDDO
          DO j=2-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
            hFacS(i,j,k,bi,bj) =
     &        MIN( hFacC(i,j,k,bi,bj), hFacC(i,j-1,k,bi,bj) )
           ENDDO
          ENDDO
         ENDDO

        ELSE
C--   hFacW and hFacS (at U and V points):
C-    Method-2: compute new hFacW,S from rSurfW,S and rLowW,S
C               by applying same rules as for hFacC

         DO k=1, Nr
          hFacMnSz = MAX( hFacMin, MIN(hFacMinDr*recip_drF(k),oneRL) )
          DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
C      o Non-dimensional distance between grid bound. and domain lower_R bound.
            hFac1tmp = ( rF(k) - rLowW(i,j,bi,bj) )*recip_drF(k)
            hFac_loc = MIN( hFac1tmp, oneRL )
c           hFac_loc = MAX( hFac_loc, zeroRL )
C      o Impose minimum fraction and/or size (dimensional)
            IF ( hFac_loc.LT.hFacMnSz*halfRL .OR.
     &           rLowW(i,j,bi,bj).GE.rSurfW(i,j,bi,bj) ) THEN
              hFac1tmp = 0. _d 0
            ELSE
              hFac1tmp = MAX( hFac_loc, hFacMnSz )
            ENDIF
C      o Reduce the previous fraction : substract the outside fraction
C        (i.e., beyond reference (=at rest) surface position rSurfW)
            hFac2tmp = ( rF(k) -rSurfW(i,j,bi,bj) )*recip_drF(k)
            hFac_loc = hFac1tmp - MAX( hFac2tmp, zeroRL )
C      o Impose minimum fraction and/or size (dimensional)
            IF ( hFac_loc.LT.hFacMnSz*halfRL ) THEN
              hFacW(i,j,k,bi,bj) = zeroRS
            ELSE
              hFacW(i,j,k,bi,bj) = MAX( hFac_loc, hFacMnSz )
            ENDIF
           ENDDO
          ENDDO
          DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
C      o Non-dimensional distance between grid bound. and domain lower_R bound.
            hFac1tmp = ( rF(k) - rLowS(i,j,bi,bj) )*recip_drF(k)
            hFac_loc = MIN( hFac1tmp, oneRL )
c           hFac_loc = MAX( hFac_loc, zeroRL )
C      o Impose minimum fraction and/or size (dimensional)
            IF ( hFac_loc.LT.hFacMnSz*halfRL .OR.
     &           rLowS(i,j,bi,bj).GE.rSurfS(i,j,bi,bj) ) THEN
              hFac1tmp = 0. _d 0
            ELSE
              hFac1tmp = MAX( hFac_loc, hFacMnSz )
            ENDIF
C      o Reduce the previous fraction : substract the outside fraction
C        (i.e., beyond reference (=at rest) surface position rSurfS)
            hFac2tmp = ( rF(k) -rSurfS(i,j,bi,bj) )*recip_drF(k)
            hFac_loc = hFac1tmp - MAX( hFac2tmp, zeroRL )
C      o Impose minimum fraction and/or size (dimensional)
            IF ( hFac_loc.LT.hFacMnSz*halfRL ) THEN
              hFacS(i,j,k,bi,bj) = zeroRS
            ELSE
              hFacS(i,j,k,bi,bj) = MAX( hFac_loc, hFacMnSz )
            ENDIF
           ENDDO
          ENDDO
         ENDDO
        ENDIF

C--   Update rLow & reference rSurf at Western & Southern edges (U & V pts):
C     account for adjusted R_low & Ro_surf due to hFacMin constrain on hFacC.
C     Might need further adjustment (e.g., if useShelfIce=T) to match
C     integrated level thickness ( =Sum_k(drF*hFac) )
        DO j=1-OLy,sNy+OLy
         DO i=2-OLx,sNx+OLx
           rLowW(i,j,bi,bj)  =
     &           MAX(   R_low(i-1,j,bi,bj),   R_low(i,j,bi,bj) )
           rSurfW(i,j,bi,bj) =
     &           MIN( Ro_surf(i-1,j,bi,bj), Ro_surf(i,j,bi,bj) )
           rSurfW(i,j,bi,bj) =
     &           MAX( rSurfW(i,j,bi,bj), rLowW(i,j,bi,bj) )
         ENDDO
        ENDDO
        DO j=2-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
           rLowS(i,j,bi,bj)  =
     &           MAX(   R_low(i,j-1,bi,bj),   R_low(i,j,bi,bj) )
           rSurfS(i,j,bi,bj) =
     &           MIN( Ro_surf(i,j-1,bi,bj), Ro_surf(i,j,bi,bj) )
           rSurfS(i,j,bi,bj) =
     &           MAX( rSurfS(i,j,bi,bj), rLowS(i,j,bi,bj) )
         ENDDO
        ENDDO

c       IF ( useShelfIce ) THEN
C--   Adjust reference rSurf at Western & Southern edges (U & V pts)
C     to get consistent column thickness from Sum_k(hFac*drF) and rSurf-rLow

C-    Total column thickness at Western edge
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
            tmpVar(i,j) = 0. _d 0
          ENDDO
         ENDDO
         DO k=1,Nr
          DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
            tmpVar(i,j) = tmpVar(i,j) + drF(k)*hFacW(i,j,k,bi,bj)
           ENDDO
          ENDDO
         ENDDO
C-    Adjust rSurf at W edge (correct for the difference)
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
             rSurfW(i,j,bi,bj) = rLowW(i,j,bi,bj) + tmpVar(i,j)
          ENDDO
         ENDDO

C-    Total column thickness at Southern edges
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
            tmpVar(i,j) = 0. _d 0
          ENDDO
         ENDDO
         DO k=1,Nr
          DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
            tmpVar(i,j) = tmpVar(i,j) + drF(k)*hFacS(i,j,k,bi,bj)
           ENDDO
          ENDDO
         ENDDO
C-    Adjust rSurf at S edge (correct for the difference)
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
             rSurfS(i,j,bi,bj) = rLowS(i,j,bi,bj) + tmpVar(i,j)
          ENDDO
         ENDDO

C-    end if useShelfIce
c       ENDIF

C-    end bi,bj loops.
       ENDDO
      ENDDO

      CALL EXCH_UV_XYZ_RS( hFacW,  hFacS, .FALSE., myThid )
      CALL EXCH_UV_XY_RS( rSurfW, rSurfS, .FALSE., myThid )
      CALL EXCH_UV_XY_RS(  rLowW,  rLowS, .FALSE., myThid )

C--   Calculate surface k index for interface W & S (U & V points)
      DO bj=myByLo(myThid), myByHi(myThid)
       DO bi=myBxLo(myThid), myBxHi(myThid)
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          kSurfW(i,j,bi,bj) = Nr+1
          kSurfS(i,j,bi,bj) = Nr+1
          DO k=Nr,1,-1
           IF (hFacW(i,j,k,bi,bj).NE.zeroRS) kSurfW(i,j,bi,bj) = k
           IF (hFacS(i,j,k,bi,bj).NE.zeroRS) kSurfS(i,j,bi,bj) = k
          ENDDO
          maskInW(i,j,bi,bj)= zeroRS
          IF ( kSurfW(i,j,bi,bj).LE.Nr ) maskInW(i,j,bi,bj)= oneRS
          maskInS(i,j,bi,bj)= zeroRS
          IF ( kSurfS(i,j,bi,bj).LE.Nr ) maskInS(i,j,bi,bj)= oneRS
         ENDDO
        ENDDO
       ENDDO
      ENDDO

C--   Additional closing of Western and Southern grid-cell edges: for example,
C     a) might add some "thin walls" in specific location
C     b) close non-periodic N & S boundaries of lat-lon grid at the N/S poles.
C     new: location now reccorded as kSurfW/S = Nr+2
      CALL ADD_WALLS2MASKS( rEmpty, myThid )

      ELSE
#ifndef DISABLE_SIGMA_CODE
C---  Sigma and Hybrid-Sigma set-up:
        CALL INI_SIGMA_HFAC( myThid )
#endif /* DISABLE_SIGMA_CODE */
      ENDIF

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C--   Write to disk: Total Column Thickness & hFac(C,W,S):
C     This I/O is now done in write_grid.F
c     CALL WRITE_FLD_XY_RS( 'Depth',' ',tmpFld,0,myThid)
c     CALL WRITE_FLD_XYZ_RS( 'hFacC',' ',hFacC,0,myThid)
c     CALL WRITE_FLD_XYZ_RS( 'hFacW',' ',hFacW,0,myThid)
c     CALL WRITE_FLD_XYZ_RS( 'hFacS',' ',hFacS,0,myThid)

      IF ( plotLevel.GE.debLevB ) THEN
        CALL PLOT_FIELD_XYZRS( hFacC, 'hFacC' , Nr, 0, myThid )
        CALL PLOT_FIELD_XYZRS( hFacW, 'hFacW' , Nr, 0, myThid )
        CALL PLOT_FIELD_XYZRS( hFacS, 'hFacS' , Nr, 0, myThid )
      ENDIF

C--   Masks and reciprocals of hFac[CWS]
      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
        DO k=1,Nr
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           IF ( hFacC(i,j,k,bi,bj).NE.zeroRS ) THEN
            recip_hFacC(i,j,k,bi,bj) = 1. _d 0 / hFacC(i,j,k,bi,bj)
            maskC(i,j,k,bi,bj) = oneRS
           ELSE
            recip_hFacC(i,j,k,bi,bj) = zeroRS
            maskC(i,j,k,bi,bj) = zeroRS
           ENDIF
           IF ( hFacW(i,j,k,bi,bj).NE.zeroRS ) THEN
            recip_hFacW(i,j,k,bi,bj) = 1. _d 0 / hFacW(i,j,k,bi,bj)
            maskW(i,j,k,bi,bj) = oneRS
           ELSE
            recip_hFacW(i,j,k,bi,bj) = zeroRS
            maskW(i,j,k,bi,bj) = zeroRS
           ENDIF
           IF ( hFacS(i,j,k,bi,bj).NE.zeroRS ) THEN
            recip_hFacS(i,j,k,bi,bj) = 1. _d 0 / hFacS(i,j,k,bi,bj)
            maskS(i,j,k,bi,bj) = oneRS
           ELSE
            recip_hFacS(i,j,k,bi,bj) = zeroRS
            maskS(i,j,k,bi,bj) = zeroRS
           ENDIF
          ENDDO
         ENDDO
        ENDDO
#ifdef NONLIN_FRSURF
C--   Save initial geometrical hFac factor into h0Fac (fixed in time):
C     Note: In case 1 pkg modifies hFac (from packages_init_fixed, called
C     later in sequence of calls) this pkg would need also to update h0Fac.
        DO k=1,Nr
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
           h0FacC(i,j,k,bi,bj) = _hFacC(i,j,k,bi,bj)
           h0FacW(i,j,k,bi,bj) = _hFacW(i,j,k,bi,bj)
           h0FacS(i,j,k,bi,bj) = _hFacS(i,j,k,bi,bj)
          ENDDO
         ENDDO
        ENDDO
#endif /* NONLIN_FRSURF */
C-    end bi,bj loops.
       ENDDO
      ENDDO

c #ifdef ALLOW_NONHYDROSTATIC
C--   Calculate "recip_hFacU" = reciprocal hfac distance/volume for W cells
C NOTE:  not used ; computed locally in CALC_GW
c #endif

      RETURN
      END

#include "DIAG_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 0
C     !ROUTINE: DIAGNOSTICS_SUM_LEVELS

C     !INTERFACE:
      SUBROUTINE DIAGNOSTICS_SUM_LEVELS(
     I                        listId, md, ndId, ip, im, lm,
     U                        fld3d,
     I                        undef,
     I                        myTime, myIter, myThid )

C     !DESCRIPTION:
C     Cumulate selected levels from a multi-level diagnostics field
C       before writing to file this level integrated output
C     (e.g., can be used to integrate vertically an Nr field).

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "DIAGNOSTICS_SIZE.h"
#include "DIAGNOSTICS.h"

      INTEGER NrMax
      PARAMETER( NrMax = numLevels )

C     !INPUT PARAMETERS:
C     listId  :: Diagnostics list number being written
C     md      :: field number in the list "listId".
C     ndId    :: diagnostics  Id number (in available diagnostics list)
C     ip      :: diagnostics  pointer to storage array
C     im      :: counter-mate pointer to storage array
C     lm      :: index in the averageCycle
C     fld3d   :: diagnostics field output array
C     undef   ::
C     myTime  :: current time of simulation (s)
C     myIter  :: current iteration number
C     myThid  :: my Thread Id number
      INTEGER listId, md, ndId, ip, im, lm
      _RL     fld3d(1-OLx:sNx+OLx,1-OLy:sNy+OLy,NrMax,nSx,nSy)
      _RL     undef
      _RL     myTime
      INTEGER myIter, myThid
CEOP

C     !FUNCTIONS:

C     !LOCAL VARIABLES:
C     i,j,k :: loop indices
      INTEGER i, j, k
      INTEGER bi, bj
      INTEGER kLev
      _RL     tmpFld(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL     tmpFac, hFacLoc
c     CHARACTER*(MAX_LEN_MBUF) msgBuf
      CHARACTER*(10) gcode
      LOGICAL wFac

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      IF ( fflags(listId)(2:2).EQ.'I' ) THEN

        gcode = gdiag(ndId)(1:10)
        wFac = jdiag(md,listId).LT.0

C--   start loops on tile indices bi,bj:
        DO bj = myByLo(myThid), myByHi(myThid)
         DO bi = myBxLo(myThid), myBxHi(myThid)

          DO j = 1-OLy,sNy+OLy
            DO i = 1-OLx,sNx+OLx
              tmpFld(i,j) = 0. _d 0
            ENDDO
          ENDDO

          IF ( gcode(3:3).EQ.' ' ) THEN
C--   Cumulate levels directly:

             DO k = 1,nlevels(listId)
              kLev = NINT(levs(k,listId))
              DO j = 1,sNy+1
               DO i = 1,sNx+1
                tmpFld(i,j) = tmpFld(i,j) + fld3d(i,j,kLev,bi,bj)
               ENDDO
              ENDDO
             ENDDO
             DO j = 1-OLy,sNy+OLy
              DO i = 1-OLx,sNx+OLx
                fld3d(i,j,1,bi,bj) = tmpFld(i,j)
              ENDDO
             ENDDO

          ELSEIF ( gcode(3:3).EQ.'r' .OR.
     &            (gcode(3:3).EQ.'R' .AND. wFac) ) THEN
C--   Cumulate the level-thickness product:

             DO k = 1,nlevels(listId)
              kLev = NINT(levs(k,listId))
              IF ( gcode(9:9).EQ.'L' ) THEN
                tmpFac = drC(kLev)
              ELSE
                tmpFac = drF(kLev)
              ENDIF
              DO j = 1,sNy+1
               DO i = 1,sNx+1
                tmpFld(i,j) = tmpFld(i,j)
     &                      + tmpFac*fld3d(i,j,kLev,bi,bj)
               ENDDO
              ENDDO
             ENDDO
             DO j = 1-OLy,sNy+OLy
              DO i = 1-OLx,sNx+OLx
                fld3d(i,j,1,bi,bj) = tmpFld(i,j)
              ENDDO
             ENDDO

          ELSEIF ( gcode(3:3).EQ.'R' ) THEN
C--   Cumulate the level-thickness & hFac product:

             IF ( gcode(2:2).EQ.'M' ) THEN
               DO k = 1,nlevels(listId)
               kLev = NINT(levs(k,listId))
               IF ( gcode(9:9).EQ.'L' ) THEN
                 tmpFac = drC(kLev)
               ELSE
                 tmpFac = drF(kLev)
               ENDIF
               DO j = 1,sNy+1
                DO i = 1,sNx+1
                 tmpFld(i,j) = tmpFld(i,j)
     &                       + tmpFac*fld3d(i,j,kLev,bi,bj)
     &                               *hFacC(i,j,kLev,bi,bj)
                ENDDO
               ENDDO
              ENDDO
             ELSEIF ( gcode(2:2).EQ.'U' ) THEN
              DO k = 1,nlevels(listId)
               kLev = NINT(levs(k,listId))
               IF ( gcode(9:9).EQ.'L' ) THEN
                 tmpFac = drC(kLev)
               ELSE
                 tmpFac = drF(kLev)
               ENDIF
               DO j = 1,sNy+1
                DO i = 1,sNx+1
                 tmpFld(i,j) = tmpFld(i,j)
     &                       + tmpFac*fld3d(i,j,kLev,bi,bj)
     &                               *hFacW(i,j,kLev,bi,bj)
                ENDDO
               ENDDO
              ENDDO
             ELSEIF ( gcode(2:2).EQ.'V' ) THEN
              DO k = 1,nlevels(listId)
               kLev = NINT(levs(k,listId))
               IF ( gcode(9:9).EQ.'L' ) THEN
                 tmpFac = drC(kLev)
               ELSE
                 tmpFac = drF(kLev)
               ENDIF
               DO j = 1,sNy+1
                DO i = 1,sNx+1
                 tmpFld(i,j) = tmpFld(i,j)
     &                       + tmpFac*fld3d(i,j,kLev,bi,bj)
     &                               *hFacS(i,j,kLev,bi,bj)
                ENDDO
               ENDDO
              ENDDO
             ELSEIF ( gcode(2:2).EQ.'Z' ) THEN
              DO k = 1,nlevels(listId)
               kLev = NINT(levs(k,listId))
               IF ( gcode(9:9).EQ.'L' ) THEN
                 tmpFac = drC(kLev)
               ELSE
                 tmpFac = drF(kLev)
               ENDIF
               DO j = 1,sNy+1
                DO i = 1,sNx+1
                 hFacLoc = MIN(
     &                          hFacW( i, j, kLev,bi,bj),
     &                          hFacW( i,j-1,kLev,bi,bj),
     &                          hFacS( i, j, kLev,bi,bj),
     &                          hFacS(i-1,j, kLev,bi,bj)
     &                        )
                 tmpFld(i,j) = tmpFld(i,j)
     &                       + tmpFac*fld3d(i,j,kLev,bi,bj)
     &                               *hFacLoc
                ENDDO
               ENDDO
              ENDDO
             ELSE
               STOP 'DIAGNOSTICS_SUM_LEVELS: invalid gcode(2)'
             ENDIF
             DO j = 1-OLy,sNy+OLy
              DO i = 1-OLx,sNx+OLx
                fld3d(i,j,1,bi,bj) = tmpFld(i,j)
              ENDDO
             ENDDO

          ELSE
            STOP 'DIAGNOSTICS_SUM_LEVELS: Bad gcode(3) option'
          ENDIF

C-   end bi,bj loops
         ENDDO
        ENDDO

      ENDIF

      RETURN
      END

#include "THSICE_OPTIONS.h"
#ifdef ALLOW_AUTODIFF
# include "AUTODIFF_OPTIONS.h"
#endif

CBOP
C     !ROUTINE: THSICE_BALANCE_FRW
C     !INTERFACE:
      SUBROUTINE THSICE_BALANCE_FRW(
     I                          iMin, iMax, jMin, jMax,
     I                          prcAtm, myTime, myIter, myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE THSICE_BALANCE_FRW
C     | o Correct ocean fresh-water forcing for global imbalance
C     |   of Atmos+Land fresh-water flux
C     *==========================================================*
C     \ev
C     !USES:
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "FFIELDS.h"
#include "THSICE_SIZE.h"
#include "THSICE_PARAMS.h"
#include "THSICE_VARS.h"
#ifdef ALLOW_AUTODIFF_TAMC
# include "tamc.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     iMin,iMax :: computation domain: 1rst index range
C     jMin,jMax :: computation domain: 2nd  index range
C     prcAtm    :: precip (+RunOff) from Atmos+Land
C     myTime    :: Current time in simulation (s)
C     myIter    :: Current iteration number
C     myThid    :: My Thread Id. number
      INTEGER iMin, iMax
      INTEGER jMin, jMax
      _RL prcAtm(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL     myTime
      INTEGER myIter
      INTEGER myThid
CEOP

#ifdef ALLOW_BALANCE_FLUXES
C     !LOCAL VARIABLES:
C     bi,bj     :: Tile indices
C     i, j      :: loop indices
      INTEGER bi,bj
      INTEGER i, j
      _RL sumPrc, sumTilePrc(nSx,nSy)
      _RL sumFrW, sumTileFrW(nSx,nSy)
      _RL tmpFac, tmpVar

C--   Calculate and global-mean precip (+RunOff)
C     and global-mean imbalance of net Atmos Fresh-Water flux
#ifdef ALLOW_AUTODIFF_TAMC
C     It is important to store these fields here so that in s/r
C     thsice_main_ad the entire timestep does not get recomputed just to
C     produce these two fields.
CADJ STORE icFrwAtm = comlev1, key = ikey_dynamics, kind = isbyte
CADJ STORE prcAtm   = comlev1, key = ikey_dynamics, kind = isbyte
#endif
      IF ( thSIceBalanceAtmFW.NE.0 ) THEN

        DO bj=myByLo(myThid),myByHi(myThid)
         DO bi=myBxLo(myThid),myBxHi(myThid)
          sumTilePrc(bi,bj) = 0. _d 0
          sumTileFrW(bi,bj) = 0. _d 0
          DO j = 1,sNy
           DO i = 1,sNx
            sumTilePrc(bi,bj) = sumTilePrc(bi,bj)
     &                        + MAX( prcAtm(i,j,bi,bj), zeroRL )
     &                         *rA(i,j,bi,bj)*maskInC(i,j,bi,bj)
            sumTileFrW(bi,bj) = sumTileFrW(bi,bj)
     &                        + icFrwAtm(i,j,bi,bj)
     &                         *rA(i,j,bi,bj)*maskInC(i,j,bi,bj)
           ENDDO
          ENDDO
         ENDDO
        ENDDO
        sumPrc = 0. _d 0
        IF ( thSIceBalanceAtmFW.EQ.2 )
     &  CALL GLOBAL_SUM_TILE_RL( sumTilePrc, sumPrc, myThid )
        CALL GLOBAL_SUM_TILE_RL( sumTileFrW, sumFrW, myThid )

        IF ( globalArea.GT.0. _d 0 ) THEN
          sumPrc = sumPrc / globalArea
          sumFrW = sumFrW / globalArea
        ENDIF

C-    save amount of correction (for diagnostics)
        _BEGIN_MASTER(myThid)
        adjustFrW = -sumFrW
        _END_MASTER(myThid)

      ENDIF

      IF     ( thSIceBalanceAtmFW.EQ.1 ) THEN
C--   Apply uniform correction to Ocean FW Forcing (+ Atm-Flux, for diagnostics)
        DO bj=myByLo(myThid),myByHi(myThid)
         DO bi=myBxLo(myThid),myBxHi(myThid)
          DO j = jMin,jMax
           DO i = iMin,iMax
             icFrwAtm(i,j,bi,bj) = icFrwAtm(i,j,bi,bj)
     &                           - sumFrW*maskInC(i,j,bi,bj)
             EmPmR(i,j,bi,bj)    = EmPmR(i,j,bi,bj)
     &                           - sumFrW*maskInC(i,j,bi,bj)
           ENDDO
          ENDDO
         ENDDO
        ENDDO

      ELSEIF ( thSIceBalanceAtmFW.EQ.2 ) THEN
C--   Scale correction by local precip and apply it to Ocean FW Forcing
C      (+ Atm-Flux, for diagnostics)
        IF ( sumPrc.GT.0. _d 0 ) THEN
          tmpFac = sumFrW / sumPrc
        ELSE
          tmpFac = 0.
          _BEGIN_MASTER(myThid)
          adjustFrW = 0. _d 0
          _END_MASTER(myThid)
        ENDIF
        DO bj=myByLo(myThid),myByHi(myThid)
         DO bi=myBxLo(myThid),myBxHi(myThid)
          DO j = jMin,jMax
           DO i = iMin,iMax
             tmpVar = tmpFac*MAX( prcAtm(i,j,bi,bj), zeroRL )
     &                      *maskInC(i,j,bi,bj)
             icFrwAtm(i,j,bi,bj) = icFrwAtm(i,j,bi,bj) - tmpVar
             EmPmR(i,j,bi,bj)    = EmPmR(i,j,bi,bj)    - tmpVar
           ENDDO
          ENDDO
         ENDDO
        ENDDO

      ELSEIF ( thSIceBalanceAtmFW.NE.0 ) THEN
        STOP
     &  'ABNORMAL END: THSICE_BALANCE_FRW: invalid thSIceBalanceAtmFW'
      ENDIF

#endif /* ALLOW_BALANCE_FLUXES */

      RETURN
      END

#include "MY82_OPTIONS.h"

CBOP
C     !ROUTINE: MY82_INIT_FIXED
C     !INTERFACE:
      SUBROUTINE MY82_INIT_FIXED( myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE MY82_INIT_FIXED
C     | o Routine to initialize MY82 variables
C     |   that are kept fixed during the run.
C     *==========================================================*
C     \ev
C     !USES:
      IMPLICIT NONE

C     === Global variables ===
#include "EEPARAMS.h"
#include "SIZE.h"
#include "PARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
C     myThid ::  my Thread Id number
      INTEGER myThid

C     !LOCAL VARIABLES :
C     === Local variables ===
CEOP

#ifdef ALLOW_DIAGNOSTICS
      IF ( useDiagnostics ) THEN
        CALL MY82_DIAGNOSTICS_INIT( myThid )
      ENDIF
#endif

      RETURN
      END

#include "OBSFIT_OPTIONS.h"
#ifdef ALLOW_AUTODIFF
# include "AUTODIFF_OPTIONS.h"
#endif
c#ifdef ALLOW_ECCO
c# include "ECCO_OPTIONS.h"
c#endif
c#ifdef ALLOW_BLING
c# include "BLING_OPTIONS.h"
c#endif

CBOP
C     !ROUTINE: OBSFIT_SAMPLING

C     !INTERFACE:
      SUBROUTINE OBSFIT_SAMPLING(
     O                            modval_cur_out,
     I                            i_cur,
     I                            j_cur,
     I                            k_cur,
     I                            weights_cur,
     I                            var_cur,
     I                            file_cur,
     I                            bi, bj,
     I                            myTime, myIter, myThid )

C     !DESCRIPTION:
C     ==================================================================
C     | 3D interpolation of model counterparts for ObsFit data
C     ==================================================================

C     !USES:
      IMPLICIT NONE
C     == Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "DYNVARS.h"
c#ifdef ALLOW_CAL
c# include "cal.h"
c#endif
c#ifdef ALLOW_ECCO
c# include "ECCO_SIZE.h"
c# include "ECCO.h"
c#endif
#ifdef ALLOW_OBSFIT
# include "OBSFIT_SIZE.h"
# include "OBSFIT.h"
#endif
c#ifdef ALLOW_PTRACERS
c# include "PTRACERS_SIZE.h"
c# include "PTRACERS_FIELDS.h"
c#endif
c#ifdef ALLOW_BLING
c# include "BLING_VARS.h"
c#endif

C     !INPUT PARAMETERS:
C     i/j/k_cur   :: i/j/k - index arrays of model grid points
C     weights_cur :: weights array for profile data
C     var_cur     :: current variable name
C     file_cur    :: current filenumber
C     bi, bj      :: tile indices
C     myTime      :: Current time in simulation
C     myIter      :: Current iteration number in simulation
C     myThid      :: my thread ID number
#ifdef ALLOW_OBSFIT
      INTEGER  i_cur(NUM_INTERP_PTS_OBS)
      INTEGER  j_cur(NUM_INTERP_PTS_OBS)
      INTEGER  k_cur(NUM_INTERP_PTS_OBS)
      _RL      weights_cur(NUM_INTERP_PTS_OBS)
#else
      INTEGER  i_cur, j_cur, k_cur
      _RL      weights_cur
#endif
      INTEGER  var_cur, file_cur
      INTEGER  bi, bj
      _RL     myTime
      INTEGER myIter
      INTEGER myThid

C     !OUTPUT PARAMETERS:
C     modval_cur_out :: interpolated model data
      _RL modval_cur_out
CEOP

#ifdef ALLOW_OBSFIT
C     !LOCAL VARIABLES:
      INTEGER  iq
      _RL      tab_coeffs1(NUM_INTERP_PTS_OBS)
      _RL      tab_coeffs3(NUM_INTERP_PTS_OBS)
      _RL      weighing_pts(NUM_INTERP_PTS_OBS),weighingSUM
      _RL      modval_cur, mask_cur

C This is where sample types are assigned to model variables
      weighingSUM = 0. _d 0
      DO iq = 1, NUM_INTERP_PTS_OBS
        IF ( var_cur.EQ.1 ) THEN
         tab_coeffs1(iq) = theta(i_cur(iq),j_cur(iq),k_cur(iq),bi,bj)
        ELSEIF ( var_cur.EQ.2 ) THEN
         tab_coeffs1(iq) = salt(i_cur(iq),j_cur(iq),k_cur(iq),bi,bj)
        ELSEIF ( var_cur.EQ.3 ) THEN
         tab_coeffs1(iq) = uvel(i_cur(iq),j_cur(iq),k_cur(iq),bi,bj)
        ELSEIF ( var_cur.EQ.4 ) THEN
         tab_coeffs1(iq) = vvel(i_cur(iq),j_cur(iq),k_cur(iq),bi,bj)
        ELSEIF ( var_cur.EQ.5 ) THEN
         tab_coeffs1(iq) = etan(i_cur(iq),j_cur(iq),bi,bj)
        ELSE
         tab_coeffs1(iq) = 0. _d 0
        ENDIF
        tab_coeffs3(iq) = maskC(i_cur(iq),j_cur(iq),k_cur(iq),bi,bj)
        weighing_pts(iq) = tab_coeffs3(iq)*weights_cur(iq)
        weighingSUM = weighingSUM+weighing_pts(iq)
      ENDDO

      IF ( weighingSUM.GT.zeroRL ) THEN
        modval_cur = 0. _d 0
        mask_cur = 1. _d 0
        DO iq = 1, NUM_INTERP_PTS_OBS
          modval_cur = modval_cur
     &     +tab_coeffs1(iq)*weighing_pts(iq)/weighingSUM
        ENDDO
      ELSE
        modval_cur = 0. _d 0
        mask_cur = 0. _d 0
      ENDIF

#ifdef ALLOW_AUTODIFF_TAMC
C     This is necessary, because TAF does not recognise sample_modmask
C     as active and does not include it in the TL-version of this
C     routine leading to sample_modmask=0 and also to
C     objf_obsfit_tl=0.
C$TAF INCOMPLETE sample_modmask
#endif

      modval_cur_out = modval_cur
      sample_modmask(bi,bj) = mask_cur

#endif /* ALLOW_OBSFIT */

      RETURN
      END

#include "DIAG_OPTIONS.h"

CBOP
C     !ROUTINE: DIAGSTATS_CALC
C     !INTERFACE:
      SUBROUTINE DIAGSTATS_CALC(
     O                  statArr,
     I                  inpArr, frcArr, scaleFact, power, useFract,
     I                  useReg, regMskVal,
     I                  nStats,sizI1,sizI2,sizJ1,sizJ2, iRun,jRun,
     I                  regMask, arrMask, arrhFac, arrArea,
     I                  arrDr, specialVal, exclSpVal, useWeight,
     I                  myThid )

C     !DESCRIPTION:
C     Compute statistics for this tile, level, region

C     !USES:
      IMPLICIT NONE

#include "EEPARAMS.h"
#include "SIZE.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine Arguments ==
C     statArr     :: output statistics array
C     inpArr      :: input field array to process (compute stats & add to statFld)
C     frcArr      :: fraction used for weighted-average diagnostics
C     scaleFact   :: scaling factor
C     power       :: option to fill-in with the field square (power=2)
C     useFract    :: if True, use fraction-weight
C     useReg      :: how to use region-mask: =0 : not used ;
C                    =1 : grid-center location ; =2 : U location ; =3 : V location
C     regMskVal   :: region-mask identificator value
C                    (point i,j belong to region <=> regMask(i,j) = regMskVal)
C     nStats      :: size of output array: statArr
C     sizI1,sizI2 :: size of inpArr array: 1rst index range (min,max)
C     sizJ1,sizJ2 :: size of inpArr array: 2nd  index range (min,max)
C     iRun,jRun   :: range of 1rst & 2nd index to process
C     regMask     :: regional mask
C     arrMask     :: mask for this input array
C     arrhFac     :: weight factor (horizontally varying)
C     arrArea     :: Area weighting factor
C     arrDr       :: uniform weighting factor
C     specialVal  :: special value in input array (to exclude if exclSpVal=T)
C     exclSpVal   :: if T, exclude "specialVal" in input array
C     useWeight   :: use weight factor "arrhFac"
Cc    k,bi,bj     :: level and tile indices used for weighting (mask,area ...)
Cc    parsFld     :: parser field with characteristics of the diagnostics
C     myThid      :: my Thread Id number
      INTEGER nStats,sizI1,sizI2,sizJ1,sizJ2
      INTEGER iRun, jRun
      _RL statArr(0:nStats)
      _RL inpArr (sizI1:sizI2,sizJ1:sizJ2)
      _RL frcArr (sizI1:sizI2,sizJ1:sizJ2)
      _RL scaleFact
      INTEGER power
      LOGICAL useFract
      INTEGER useReg
      _RS regMskVal
      _RS regMask(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RS arrMask(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RS arrhFac(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RS arrArea(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL arrDr
      _RL specialVal
      LOGICAL exclSpVal
      LOGICAL useWeight
      INTEGER myThid
CEOP

C     !LOCAL VARIABLES:
C     i,j    :: loop indices
      INTEGER i, j, n
      INTEGER im, ix
#ifndef TARGET_NEC_SX
      LOGICAL inside(sNx+1,sNy+1)
      _RL     tmpFld(sNx+1,sNy+1)
      _RL     tmpVol(sNx+1,sNy+1)
#else
C     Extra variables and fields to support vectorization.
C     This code also uses the intrinsic F90 routines SUM, MINVAL, MAXVAL
C     and thus will not compile with a F77 compiler.
      _RL     arrMaskL(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL     tmpFld  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL     tmpVol  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
#endif

      im = nStats - 1
      ix = nStats
      DO n=0,nStats
        statArr(n) = 0.
      ENDDO

#ifndef TARGET_NEC_SX

C-    Apply Scaling Factor and power option to Input Field (-> tmpFld):
      IF ( power.EQ.2 ) THEN
       DO j = 1,jRun
        DO i = 1,iRun
          tmpFld(i,j) = scaleFact*inpArr(i,j)
          tmpFld(i,j) = tmpFld(i,j)*tmpFld(i,j)
        ENDDO
       ENDDO
      ELSE
       DO j = 1,jRun
        DO i = 1,iRun
          tmpFld(i,j) = scaleFact*inpArr(i,j)
        ENDDO
       ENDDO
      ENDIF

C-    Set weight factor "tmpVol" (area and hFac and/or fraction field)
C     and part of domain (=inside) where to compute stats
      IF ( useFract .AND. useWeight ) THEN
       DO j = 1,jRun
        DO i = 1,iRun
          inside(i,j) = arrMask(i,j).NE.0.
     &            .AND. arrhFac(i,j).NE.0.
     &            .AND. frcArr(i,j) .NE.0.
          tmpVol(i,j) = arrArea(i,j)*arrhFac(i,j)*frcArr(i,j)
        ENDDO
       ENDDO
      ELSEIF ( useFract ) THEN
       DO j = 1,jRun
        DO i = 1,iRun
          inside(i,j) = arrMask(i,j).NE.0.
     &            .AND. arrhFac(i,j).NE.0.
     &            .AND. frcArr(i,j) .NE.0.
          tmpVol(i,j) = arrArea(i,j)*frcArr(i,j)
        ENDDO
       ENDDO
      ELSEIF ( useWeight ) THEN
       DO j = 1,jRun
        DO i = 1,iRun
          inside(i,j) = arrMask(i,j).NE.0.
     &            .AND. arrhFac(i,j).NE.0.
          tmpVol(i,j) = arrArea(i,j)*arrhFac(i,j)
        ENDDO
       ENDDO
      ELSE
       DO j = 1,jRun
        DO i = 1,iRun
          inside(i,j) = arrMask(i,j).NE.0.
     &            .AND. arrhFac(i,j).NE.0.
          tmpVol(i,j) = arrArea(i,j)
        ENDDO
       ENDDO
      ENDIF

C-    Exclude (setting inside=F) Special Value:
      IF ( exclSpVal ) THEN
       DO j = 1,jRun
        DO i = 1,iRun
          inside(i,j) = inside(i,j) .AND. inpArr(i,j).NE.specialVal
        ENDDO
       ENDDO
      ENDIF
C-    Account for Region-mask (refine "inside"):
      IF ( useReg.EQ.1 ) THEN
       DO j = 1,jRun
        DO i = 1,iRun
          inside(i,j) = inside(i,j) .AND. regMask(i,j).EQ.regMskVal
        ENDDO
       ENDDO
      ELSEIF ( useReg.EQ.2 ) THEN
       DO j = 1,jRun
        DO i = 1,iRun
          inside(i,j) = inside(i,j) .AND.( regMask(i,j).EQ.regMskVal
     &                              .OR. regMask(i-1,j).EQ.regMskVal )
        ENDDO
       ENDDO
      ELSEIF ( useReg.EQ.3 ) THEN
       DO j = 1,jRun
        DO i = 1,iRun
          inside(i,j) = inside(i,j) .AND.( regMask(i,j).EQ.regMskVal
     &                              .OR. regMask(i,j-1).EQ.regMskVal )
        ENDDO
       ENDDO
      ENDIF

C-    Calculate Stats
      DO j = 1,jRun
       DO i = 1,iRun
        IF ( inside(i,j) ) THEN
          statArr(im) = tmpFld(i,j)
          statArr(0) = statArr(0) + tmpVol(i,j)
          statArr(1) = statArr(1) + tmpVol(i,j)*tmpFld(i,j)
          statArr(2) = statArr(2) + tmpVol(i,j)*tmpFld(i,j)*tmpFld(i,j)
        ENDIF
       ENDDO
      ENDDO
      statArr(ix) = statArr(im)
      DO j = 1,jRun
       DO i = 1,iRun
        IF ( inside(i,j) ) THEN
          statArr(im) = MIN(tmpFld(i,j),statArr(im))
          statArr(ix) = MAX(tmpFld(i,j),statArr(ix))
        ENDIF
       ENDDO
      ENDDO
      statArr(0) = statArr(0)*arrDr
      statArr(1) = statArr(1)*arrDr
      statArr(2) = statArr(2)*arrDr

#else /* TARGET_NEC_SX defined */

      arrMaskL = 0. _d 0

      IF ( useFract .AND. exclSpVal ) THEN

       DO j = 1,jRun
        DO i = 1,iRun
         IF ( arrMask(i,j).NE.0. .AND. frcArr(i,j).NE.0.
     &             .AND. arrhFac(i,j).NE.0.
     &             .AND. inpArr(i,j).NE.specialVal )
     &        arrMaskL(i,j) = 1. _d 0
        ENDDO
       ENDDO
       IF ( useWeight ) THEN
        tmpVol = arrhFac*arrArea*frcArr
       ELSE
        tmpVol = arrArea*frcArr
       ENDIF

      ELSEIF ( useFract ) THEN

       DO j = 1,jRun
        DO i = 1,iRun
         IF ( arrMask(i,j).NE.0. .AND. frcArr(i,j).NE.0.
     &             .AND. arrhFac(i,j).NE.0. )
     &        arrMaskL(i,j) = 1. _d 0
        ENDDO
       ENDDO
       IF ( useWeight ) THEN
        tmpVol = arrhFac*arrArea*frcArr
       ELSE
        tmpVol = arrArea*frcArr
       ENDIF

      ELSEIF ( exclSpVal ) THEN

       DO j = 1,jRun
        DO i = 1,iRun
         IF ( arrMask(i,j).NE.0.
     &             .AND. arrhFac(i,j).NE.0.
     &             .AND. inpArr(i,j).NE.specialVal )
     &        arrMaskL(i,j) = 1. _d 0
        ENDDO
       ENDDO
       IF ( useWeight ) THEN
        tmpVol = arrhFac*arrArea
       ELSE
        tmpVol = arrArea
       ENDIF

      ELSE

       DO j = 1,jRun
        DO i = 1,iRun
         IF ( arrMask(i,j).NE.0.
     &             .AND. arrhFac(i,j).NE.0. )
     &        arrMaskL(i,j) = 1. _d 0
        ENDDO
       ENDDO
       IF ( useWeight ) THEN
        tmpVol = arrhFac*arrArea
       ELSE
        tmpVol = arrArea
       ENDIF

      ENDIF

C-    Account for Region-mask:
      IF ( useReg.EQ.1 ) THEN
       DO j = 1,jRun
        DO i = 1,iRun
          IF ( regMask(i,j).NE.regMskVal ) arrMaskL(i,j) = 0. _d 0
        ENDDO
       ENDDO
      ELSEIF ( useReg.EQ.2 ) THEN
       DO j = 1,jRun
        DO i = 1,iRun
          IF ( regMask(i,j).NE.regMskVal .AND.
     &       regMask(i-1,j).NE.regMskVal ) arrMaskL(i,j) = 0. _d 0
        ENDDO
       ENDDO
      ELSEIF ( useReg.EQ.3 ) THEN
       DO j = 1,jRun
        DO i = 1,iRun
          IF ( regMask(i,j).NE.regMskVal .AND.
     &       regMask(i,j-1).NE.regMskVal ) arrMaskL(i,j) = 0. _d 0
        ENDDO
       ENDDO
      ENDIF

C     inpArr can be undefined/non-initialised in overlaps, so we need
C     to clean this fields first by copying the defined range to tmpFld
      tmpFld = 0. _d 0
      DO j = 1,jRun
       DO i = 1,iRun
        tmpFld(i,j) = inpArr(i,j)*scaleFact
       ENDDO
      ENDDO
      IF ( power.EQ.2) THEN
       tmpFld = tmpFld*tmpFld
      ENDIF
C     sum up the volume
      tmpVol = tmpVol*arrMaskL
      statArr(0)  = SUM(tmpVol)*arrDr
C     compute and sum up volume*field
      tmpVol = tmpVol*tmpFld
      statArr(1)  = SUM(tmpVol)*arrDr
C     compute and sum up volume*field**2
      tmpVol = tmpVol*tmpFld
      statArr(2)  = SUM(tmpVol)*arrDr
      statArr(im) = MINVAL(tmpFld, MASK = arrMaskL>0.)
      statArr(ix) = MAXVAL(tmpFld, MASK = arrMaskL>0.)

#endif /* TARGET_NEC_SX */

      RETURN
      END

#include "OBCS_OPTIONS.h"

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: OBCS_APPLY_SURF_DR

C     !INTERFACE:
      SUBROUTINE OBCS_APPLY_SURF_DR(
     I                bi, bj, etaFld,
     U                hFac_FldC, hFac_FldW, hFac_FldS,
     I                myTime, myIter, myThid )

C     !DESCRIPTION:
C     *==========================================================*
C     | S/R OBCS_APPLY_SURF_DR
C     |  update surface-level thickness factor at Open-Boundaries
C     *==========================================================*

C     !USES:
      IMPLICIT NONE
C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "SURFACE.h"
#include "OBCS_PARAMS.h"
#include "OBCS_GRID.h"
#include "OBCS_FIELDS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     bi, bj    :: tile indices
C     etaFld    :: current eta field used to update the hFactor
C     hFac_FldC :: surface-level new thickness factor (grid-cell center)
C     hFac_FldW ::  idem, West  interface (U point)
C     hFac_FldS ::  idem, South interface (V point)
C     myTime    :: current time in simlation
C     myIter    :: current time-step number
C     myThid    :: my Thread Id number
      INTEGER bi,bj
      _RL etaFld   (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RS hFac_FldC(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RS hFac_FldW(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RS hFac_FldS(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL myTime
      INTEGER myIter, myThid
CEOP

#ifdef NONLIN_FRSURF

C     !LOCAL VARIABLES:
      INTEGER i,j,ks
      LOGICAL useOBeta
      _RS hFacInfMOM, hFactmp

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      hFacInfMOM = hFacInf

C-- Eta OB values corresponding to previous iteration are not available when
C   calc_surf_dr is called for the 1rst time (myIter=-1) form initialise_varia.
C   Use current "etaFld" values instead, only for this 1rst call (myIter=-1).
      useOBeta = myIter.NE.-1

C- Set model surface h_Factor to OB values on North/South Boundaries
      IF ( tileHasOBN(bi,bj) ) THEN
C  Northern boundary
       DO i=1-OLx,sNx+OLx
        IF ( OB_Jn(i,bi,bj).NE.OB_indexNone ) THEN
         j = OB_Jn(i,bi,bj)
         ks = kSurfS(i,j,bi,bj)
         IF (ks.LE.Nr) THEN
          IF ( useOBeta ) THEN
           hFactmp = h0FacS(i,j,ks,bi,bj)
     &             + OBNeta(i,bi,bj)*recip_drF(ks)
          ELSE
           hFactmp = h0FacS(i,j,ks,bi,bj)
     &             + etaFld(i,j,bi,bj)*recip_drF(ks)
          ENDIF
          hFac_FldS(i,j,bi,bj) = MAX( hFacInfMOM, hFactmp )
         ENDIF
        ENDIF
       ENDDO
      ENDIF
      IF ( tileHasOBS(bi,bj) ) THEN
C  Southern boundary
       DO i=1-OLx,sNx+OLx
        IF ( OB_Js(i,bi,bj).NE.OB_indexNone ) THEN
         j = OB_Js(i,bi,bj)+1
         ks = kSurfS(i,j,bi,bj)
         IF (ks.LE.Nr) THEN
          IF ( useOBeta ) THEN
           hFactmp = h0FacS(i,j,ks,bi,bj)
     &             + OBSeta(i,bi,bj)*recip_drF(ks)
          ELSE
           hFactmp = h0FacS(i,j,ks,bi,bj)
     &             + etaFld(i,j-1,bi,bj)*recip_drF(ks)
          ENDIF
          hFac_FldS(i,j,bi,bj) = MAX( hFacInfMOM, hFactmp )
         ENDIF
        ENDIF
       ENDDO
      ENDIF

C- Set model surface h_Factor to OB values on East/West Boundaries
      IF ( tileHasOBE(bi,bj) ) THEN
C  Eastern boundary
       DO j=1-OLy,sNy+OLy
        IF ( OB_Ie(j,bi,bj).NE.OB_indexNone ) THEN
         i = OB_Ie(j,bi,bj)
         ks = kSurfW(i,j,bi,bj)
         IF (ks.LE.Nr) THEN
          IF ( useOBeta ) THEN
           hFactmp = h0FacW(i,j,ks,bi,bj)
     &             + OBEeta(j,bi,bj)*recip_drF(ks)
          ELSE
           hFactmp = h0FacW(i,j,ks,bi,bj)
     &             + etaFld(i,j,bi,bj)*recip_drF(ks)
          ENDIF
          hFac_FldW(i,j,bi,bj) = MAX( hFacInfMOM, hFactmp )
         ENDIF
        ENDIF
       ENDDO
      ENDIF
      IF ( tileHasOBW(bi,bj) ) THEN
C  Western boundary
       DO j=1-OLy,sNy+OLy
        IF ( OB_Iw(j,bi,bj).NE.OB_indexNone ) THEN
         i = OB_Iw(j,bi,bj)+1
         ks = kSurfW(i,j,bi,bj)
         IF (ks.LE.Nr) THEN
          IF ( useOBeta ) THEN
           hFactmp = h0FacW(i,j,ks,bi,bj)
     &             + OBWeta(j,bi,bj)*recip_drF(ks)
          ELSE
           hFactmp = h0FacW(i,j,ks,bi,bj)
     &             + etaFld(i-1,j,bi,bj)*recip_drF(ks)
          ENDIF
          hFac_FldW(i,j,bi,bj) = MAX( hFacInfMOM, hFactmp )
         ENDIF
        ENDIF
       ENDDO
      ENDIF

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#endif /* NONLIN_FRSURF */

      RETURN
      END

      subroutine dostore( n, x, store, j )
c
c         arguments
c
      integer n, i, j
      double precision    x(n)
      real*4 tmpx(n) 
      logical store

      common /xxstore/ itape, ntape, isize
      integer itape, ntape, isize

cph(
cph      print *, 'pathei in dostore ', 
cph     &   store, n, ntape, j
cph)

      if (store) then
        do i = 1, n
          tmpx(i) = x(i)
        enddo
        write( ntape, rec=j ) tmpx
      else
        read(  ntape, rec=j ) tmpx
	do i = 1, n
          x(i) = tmpx(i)
        enddo
      endif

      return
      end

#include "OBCS_OPTIONS.h"

CBOP
C     !ROUTINE: OBCS_ADJUST_UVICE
C     !INTERFACE:
      SUBROUTINE OBCS_ADJUST_UVICE(
     U                          uFld, vFld,
     I                          myThid )

C     !DESCRIPTION:
C     *==========================================================*
C     | S/R OBCS_ADJUST_UVICE
C     *==========================================================*

C     !USES:
      IMPLICIT NONE
C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "OBCS_PARAMS.h"
#include "OBCS_GRID.h"
#include "OBCS_SEAICE.h"

C     !INPUT/OUTPUT PARAMETERS:
C    myThid   :: my Thread Id number
      _RL uFld(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL vFld(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      INTEGER myThid

#if (defined (ALLOW_OBCS) && defined (ALLOW_SEAICE))
#ifdef OBCS_UVICE_OLD

C     !LOCAL VARIABLES:
C     I,J,K,bi,bj :: Loop counters
      INTEGER I,J,K,bi,bj
CEOP

      K = 1
      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)

C     Set model variables to OB values on North/South Boundaries
# ifdef ALLOW_OBCS_NORTH
      IF ( tileHasOBN(bi,bj) ) THEN
      DO I=1-OLx,sNx+OLx
C     Northern boundary
       IF (OB_Jn(I,bi,bj).NE.OB_indexNone) THEN
#  ifdef OBCS_SEAICE_COMPUTE_UVICE
        uFld(I,OB_Jn(I,bi,bj)  ,bi,bj) =
     &       _maskW(I,OB_Jn(I,bi,bj),K,bi,bj) *
     &       uFld(I,OB_Jn(I,bi,bj)-1,bi,bj)
        vFld(I,OB_Jn(I,bi,bj)  ,bi,bj) =
     &       _maskS(I,OB_Jn(I,bi,bj),K,bi,bj) *
     &       vFld(I,OB_Jn(I,bi,bj)-1,bi,bj)
#  else /* OBCS_SEAICE_COMPUTE_UVICE */
#   ifdef OBCS_SEAICE_AVOID_CONVERGENCE
        vFld(I,OB_Jn(I,bi,bj),bi,bj) =
     &       max(OBNvice(I,bi,bj),vFld(I,OB_Jn(I,bi,bj),bi,bj)) *
     &       _maskS(I,OB_Jn(I,bi,bj),K,bi,bj)
#   else /* OBCS_SEAICE_AVOID_CONVERGENCE */
        vFld(I,OB_Jn(I,bi,bj),bi,bj) = OBNvice(I,bi,bj) *
     &       _maskS(I,OB_Jn(I,bi,bj),K,bi,bj)
#   endif /* OBCS_SEAICE_AVOID_CONVERGENCE */
        uFld(I,OB_Jn(I,bi,bj),bi,bj) = OBNuice(I,bi,bj) *
     &       _maskW(I,OB_Jn(I,bi,bj),K,bi,bj)
#   ifdef OBCS_SEAICE_SMOOTH_UVICE_PERP
        if ( _maskS(I,OB_Jn(I,bi,bj)  ,K,bi,bj) .NE. 0. .AND.
     &       _maskS(I,OB_Jn(I,bi,bj)-2,K,bi,bj) .NE. 0. )
     &       vFld(I,OB_Jn(I,bi,bj)-1,bi,bj) = 0.5 _d 0 *
     &       ( vFld(I,OB_Jn(I,bi,bj)  ,bi,bj) +
     &       vFld(I,OB_Jn(I,bi,bj)-2,bi,bj) ) *
     &       _maskS(I,OB_Jn(I,bi,bj)-1,K,bi,bj)
#   endif /* OBCS_SEAICE_SMOOTH_UVICE_PERP */
#   ifdef OBCS_SEAICE_SMOOTH_UVICE_PAR
        if ( _maskW(I,OB_Jn(I,bi,bj)  ,K,bi,bj) .NE. 0. .AND.
     &       _maskW(I,OB_Jn(I,bi,bj)-2,K,bi,bj) .NE. 0. )
     &       uFld(I,OB_Jn(I,bi,bj)-1,bi,bj) = 0.5 _d 0 *
     &       ( uFld(I,OB_Jn(I,bi,bj)  ,bi,bj) +
     &       uFld(I,OB_Jn(I,bi,bj)-2,bi,bj) ) *
     &       _maskW(I,OB_Jn(I,bi,bj)-1,K,bi,bj)
#   endif /* OBCS_SEAICE_SMOOTH_UVICE_PAR */
#  endif /* OBCS_SEAICE_COMPUTE_UVICE */
       ENDIF
      ENDDO
      ENDIF
# endif /* ALLOW_OBCS_NORTH */

# ifdef ALLOW_OBCS_SOUTH
      IF ( tileHasOBS(bi,bj) ) THEN
      DO I=1-OLx,sNx+OLx
C     Southern boundary
       IF (OB_Js(I,bi,bj).NE.OB_indexNone) THEN
#  ifdef OBCS_SEAICE_COMPUTE_UVICE
C-jmc: this uFld looks like a bug; should be:
c       uFld(I,OB_Js(I,bi,bj),bi,bj) =
c    &         _maskW(I,OB_Js(I,bi,bj),K,bi,bj) *
c    &         uFld(I,OB_Js(I,bi,bj)+1,bi,bj)
C- rather than:
        uFld(I,OB_Js(I,bi,bj)+1,bi,bj) =
     &         _maskW(I,OB_Js(I,bi,bj)+1,K,bi,bj) *
     &         uFld(I,OB_Js(I,bi,bj)+2,bi,bj)
        vFld(I,OB_Js(I,bi,bj)+1,bi,bj) =
     &         _maskS(I,OB_Js(I,bi,bj)+1,K,bi,bj) *
     &         vFld(I,OB_Js(I,bi,bj)+2,bi,bj)
#  else /* OBCS_SEAICE_COMPUTE_UVICE */
#   ifdef OBCS_SEAICE_AVOID_CONVERGENCE
        vFld(I,OB_Js(I,bi,bj)+1,bi,bj)=
     &       min(OBSvice(I,bi,bj),vFld(I,OB_Js(I,bi,bj)+1,bi,bj))
     &       * _maskS(I,OB_Js(I,bi,bj)+1,K,bi,bj)
#   else /* OBCS_SEAICE_AVOID_CONVERGENCE */
        vFld(I,OB_Js(I,bi,bj)+1,bi,bj)=OBSvice(I,bi,bj)
     &       * _maskS(I,OB_Js(I,bi,bj)+1,K,bi,bj)
#   endif /* OBCS_SEAICE_AVOID_CONVERGENCE */
        uFld(I,OB_Js(I,bi,bj),bi,bj)=OBSuice(I,bi,bj)
     &       * _maskW(I,OB_Js(I,bi,bj),K,bi,bj)
#   ifdef OBCS_SEAICE_SMOOTH_UVICE_PERP
        if ( _maskS(I,OB_Js(I,bi,bj)+1,K,bi,bj) .NE. 0. .AND.
     &       _maskS(I,OB_Js(I,bi,bj)+3,K,bi,bj) .NE. 0. )
     &       vFld(I,OB_Js(I,bi,bj)+2,bi,bj) = 0.5 _d 0 *
     &       ( vFld(I,OB_Js(I,bi,bj)+1,bi,bj) +
     &       vFld(I,OB_Js(I,bi,bj)+3,bi,bj) ) *
     &       _maskS(I,OB_Js(I,bi,bj)+2,K,bi,bj)
#   endif /* OBCS_SEAICE_SMOOTH_UVICE_PERP */
#   ifdef OBCS_SEAICE_SMOOTH_UVICE_PAR
        if ( _maskW(I,OB_Js(I,bi,bj)  ,K,bi,bj) .NE. 0. .AND.
     &       _maskW(I,OB_Js(I,bi,bj)+2,K,bi,bj) .NE. 0. )
     &       uFld(I,OB_Js(I,bi,bj)+1,bi,bj) = 0.5 _d 0 *
     &       ( uFld(I,OB_Js(I,bi,bj)  ,bi,bj) +
     &       uFld(I,OB_Js(I,bi,bj)+2,bi,bj) ) *
     &       _maskW(I,OB_Js(I,bi,bj)+1,K,bi,bj)
#   endif /* OBCS_SEAICE_SMOOTH_UVICE_PAR */
#  endif /* OBCS_SEAICE_COMPUTE_UVICE */
       ENDIF
      ENDDO
      ENDIF
# endif /* ALLOW_OBCS_SOUTH */

C     Set model variables to OB values on East/West Boundaries
# ifdef ALLOW_OBCS_EAST
      IF ( tileHasOBE(bi,bj) ) THEN
      DO J=1-OLy,sNy+OLy
C     Eastern boundary
       IF (OB_Ie(J,bi,bj).NE.OB_indexNone) THEN
#  ifdef OBCS_SEAICE_COMPUTE_UVICE
        uFld(OB_Ie(J,bi,bj),J,bi,bj) =
     &         _maskW(OB_Ie(J,bi,bj),J,K,bi,bj) *
     &         uFld(OB_Ie(J,bi,bj)-1,J,bi,bj)
        vFld(OB_Ie(J,bi,bj),J,bi,bj) =
     &         _maskS(OB_Ie(J,bi,bj),J,K,bi,bj) *
     &         vFld(OB_Ie(J,bi,bj)-1,J,bi,bj)
#  else /* OBCS_SEAICE_COMPUTE_UVICE */
#   ifdef OBCS_SEAICE_AVOID_CONVERGENCE
        uFld(OB_Ie(J,bi,bj),J,bi,bj)=
     &       max(OBEuice(J,bi,bj),uFld(OB_Ie(J,bi,bj),J,bi,bj))
     &       * _maskW(OB_Ie(J,bi,bj),J,K,bi,bj)
#   else /* OBCS_SEAICE_AVOID_CONVERGENCE */
        uFld(OB_Ie(J,bi,bj),J,bi,bj)=OBEuice(J,bi,bj)
     &       * _maskW(OB_Ie(J,bi,bj),J,K,bi,bj)
#   endif /* OBCS_SEAICE_AVOID_CONVERGENCE */
        vFld(OB_Ie(J,bi,bj),J,bi,bj)=OBEvice(J,bi,bj)
     &       * _maskS(OB_Ie(J,bi,bj),J,K,bi,bj)
#   ifdef OBCS_SEAICE_SMOOTH_UVICE_PERP
        if ( _maskW(OB_Ie(J,bi,bj)  ,J,K,bi,bj) .NE. 0. .AND.
     &       _maskW(OB_Ie(J,bi,bj)-2,J,K,bi,bj) .NE. 0. )
     &       uFld(OB_Ie(J,bi,bj)-1,J,bi,bj) = 0.5 _d 0 *
     &       ( uFld(OB_Ie(J,bi,bj)  ,J,bi,bj) +
     &       uFld(OB_Ie(J,bi,bj)-2,J,bi,bj) ) *
     &       _maskW(OB_Ie(J,bi,bj)-1,J,K,bi,bj)
#   endif /* OBCS_SEAICE_SMOOTH_UVICE_PERP */
#   ifdef OBCS_SEAICE_SMOOTH_UVICE_PAR
        if ( _maskS(OB_Ie(J,bi,bj)  ,J,K,bi,bj) .NE. 0. .AND.
     &       _maskS(OB_Ie(J,bi,bj)-2,J,K,bi,bj) .NE. 0. )
     &       vFld(OB_Ie(J,bi,bj)-1,J,bi,bj) = 0.5 _d 0 *
     &       ( vFld(OB_Ie(J,bi,bj)  ,J,bi,bj) +
     &       vFld(OB_Ie(J,bi,bj)-2,J,bi,bj) ) *
     &       _maskS(OB_Ie(J,bi,bj)-1,J,K,bi,bj)
#   endif /* OBCS_SEAICE_SMOOTH_UVICE_PAR */
#  endif /* OBCS_SEAICE_COMPUTE_UVICE */
       ENDIF
      ENDDO
      ENDIF
# endif /* ALLOW_OBCS_EAST */

# ifdef ALLOW_OBCS_WEST
      IF ( tileHasOBW(bi,bj) ) THEN
      DO J=1-OLy,sNy+OLy
C     Western boundary
       IF (OB_Iw(J,bi,bj).NE.OB_indexNone) THEN
#  ifdef OBCS_SEAICE_COMPUTE_UVICE
        uFld(OB_Iw(J,bi,bj)+1,J,bi,bj)=
     &         _maskW(OB_Iw(J,bi,bj)+1,J,K,bi,bj) *
     &         uFld(OB_Iw(J,bi,bj)+2,J,bi,bj)
C-jmc: this vFld looks like a bug; should be:
c       vFld(OB_Iw(J,bi,bj),J,bi,bj)=
c    &         _maskS(OB_Iw(J,bi,bj),J,K,bi,bj) *
c    &         vFld(OB_Iw(J,bi,bj)+1,J,bi,bj)
C- rather than:
        vFld(OB_Iw(J,bi,bj)+1,J,bi,bj)=
     &         _maskS(OB_Iw(J,bi,bj)+1,J,K,bi,bj) *
     &         vFld(OB_Iw(J,bi,bj)+2,J,bi,bj)
#  else /* OBCS_SEAICE_COMPUTE_UVICE */
#   ifdef OBCS_SEAICE_AVOID_CONVERGENCE
        uFld(OB_Iw(J,bi,bj)+1,J,bi,bj)=
     &       min(OBWuice(J,bi,bj),uFld(OB_Iw(J,bi,bj)+1,J,bi,bj))
     &       * _maskW(OB_Iw(J,bi,bj)+1,J,K,bi,bj)
#   else /* OBCS_SEAICE_AVOID_CONVERGENCE */
        uFld(OB_Iw(J,bi,bj)+1,J,bi,bj)=OBWuice(J,bi,bj)
     &       * _maskW(OB_Iw(J,bi,bj)+1,J,K,bi,bj)
#   endif /* OBCS_SEAICE_AVOID_CONVERGENCE */
        vFld(OB_Iw(J,bi,bj),J,bi,bj)=OBWvice(J,bi,bj)
     &       * _maskS(OB_Iw(J,bi,bj),J,K,bi,bj)
#   ifdef OBCS_SEAICE_SMOOTH_UVICE_PERP
        if ( _maskW(OB_Iw(J,bi,bj)+1,J,K,bi,bj) .NE. 0. .AND.
     &       _maskW(OB_Iw(J,bi,bj)+3,J,K,bi,bj) .NE. 0. )
     &       uFld(OB_Iw(J,bi,bj)+2,J,bi,bj) = 0.5 _d 0 *
     &       ( uFld(OB_Iw(J,bi,bj)+1,J,bi,bj) +
     &       uFld(OB_Iw(J,bi,bj)+3,J,bi,bj) ) *
     &       _maskW(OB_Iw(J,bi,bj)+2,J,K,bi,bj)
#   endif /* OBCS_SEAICE_SMOOTH_UVICE_PERP */
#   ifdef OBCS_SEAICE_SMOOTH_UVICE_PAR
        if ( _maskS(OB_Iw(J,bi,bj)  ,J,K,bi,bj) .NE. 0. .AND.
     &       _maskS(OB_Iw(J,bi,bj)+2,J,K,bi,bj) .NE. 0. )
     &       vFld(OB_Iw(J,bi,bj)+1,J,bi,bj) = 0.5 _d 0 *
     &       ( vFld(OB_Iw(J,bi,bj)  ,J,bi,bj) +
     &       vFld(OB_Iw(J,bi,bj)+2,J,bi,bj) ) *
     &       _maskS(OB_Iw(J,bi,bj)+1,J,K,bi,bj)
#   endif /* OBCS_SEAICE_SMOOTH_UVICE_PAR */
#  endif /* OBCS_SEAICE_COMPUTE_UVICE */
       ENDIF
      ENDDO
      ENDIF
# endif /* ALLOW_OBCS_WEST */

       ENDDO
      ENDDO

      CALL EXCH_UV_XY_RL( uFld, vFld, .TRUE., myThid )

#endif /* OBCS_UVICE_OLD */
#endif /* defined (ALLOW_OBCS) && defined (ALLOW_SEAICE) */

      RETURN
      END

#include "GAD_OPTIONS.h"

CBOP
C !ROUTINE: GAD_DIFF_X

C !INTERFACE: ==========================================================
      SUBROUTINE GAD_DIFF_X(
     I           bi,bj,k,
     I           xA, diffKh,
     I           tracer,
     O           dfx,
     I           myThid )

C !DESCRIPTION:
C Calculates the area integrated zonal flux due to down-gradient diffusion
C of a tracer:
C \begin{equation*}
C F^x_{diff} = - A^x \kappa_h \frac{1}{\Delta x_c} \delta_i \theta
C \end{equation*}

C !USES: ===============================================================
      IMPLICIT NONE
#include "SIZE.h"
#include "GRID.h"
#ifdef ALLOW_SMAG_3D_DIFFUSIVITY
# include "EEPARAMS.h"
# include "PARAMS.h"
# include "DYNVARS.h"
#endif

C !INPUT PARAMETERS: ===================================================
C  bi,bj                :: tile indices
C  k                    :: vertical level
C  xA                   :: area of face at U points
C  diffKh               :: horizontal diffusivity
C  tracer               :: tracer field
C  myThid               :: thread number
      INTEGER bi,bj,k
      _RS xA    (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL diffKh
      _RL tracer(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER myThid

C !OUTPUT PARAMETERS: ==================================================
C  dfx                  :: zonal diffusive flux
      _RL dfx   (1-OLx:sNx+OLx,1-OLy:sNy+OLy)

C !LOCAL VARIABLES: ====================================================
C  i,j                  :: loop indices
      INTEGER i,j
CEOP

#ifdef ALLOW_SMAG_3D_DIFFUSIVITY
      IF ( smag3D_diffCoeff.GT.zeroRL ) THEN
        DO j=1-OLy,sNy+OLy
         dfx(1-OLx,j) = 0.
         DO i=1-OLx+1,sNx+OLx
          dfx(i,j) = -( diffKh
     &                + halfRL*( smag3D_diffK(i-1,j,k,bi,bj)
     &                         + smag3D_diffK( i, j,k,bi,bj) )
     &                )*xA(i,j)
     &             *_recip_dxC(i,j,bi,bj)*recip_deepFacC(k)
     &             *( tracer(i,j) - tracer(i-1,j) )
     &             *cosFacU(j,bi,bj)
         ENDDO
        ENDDO
      ELSE
#endif /* ALLOW_SMAG_3D_DIFFUSIVITY */
        DO j=1-OLy,sNy+OLy
         dfx(1-OLx,j) = 0.
         DO i=1-OLx+1,sNx+OLx
          dfx(i,j) = -diffKh*xA(i,j)
     &             *_recip_dxC(i,j,bi,bj)*recip_deepFacC(k)
     &             *( tracer(i,j) - tracer(i-1,j) )
     &             *cosFacU(j,bi,bj)
         ENDDO
        ENDDO
#ifdef ALLOW_SMAG_3D_DIFFUSIVITY
      ENDIF
#endif /* ALLOW_SMAG_3D_DIFFUSIVITY */

      RETURN
      END

#include "ICEFRONT_OPTIONS.h"
C--  File icefront_tendency_apply.F: Routines to apply ICEFRONT tendencies
C--   Contents
C--   o ICEFRONT_TENDENCY_APPLY_T
C--   o ICEFRONT_TENDENCY_APPLY_S

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 0
C !ROUTINE: ICEFRONT_TENDENCY_APPLY_T

C !INTERFACE:
      SUBROUTINE ICEFRONT_TENDENCY_APPLY_T(
     U                    gT_arr,
     I                    k, bi, bj, myTime, myIter, myThid )

C     !DESCRIPTION:
C     Add icefront tendency terms to T (theta) tendency.
C     Routine works for one level at a time.

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
c#include "GRID.h"
c#include "DYNVARS.h"
#include "ICEFRONT.h"

C     !INPUT/OUTPUT PARAMETERS:
C     gT_arr    :: the tendency array
C     k         :: Current vertical level index
C     bi,bj     :: Current tile indices
C     myTime    :: Current time in simulation
C     myIter    :: Current iteration number
C     myThid    :: my Thread Id number
      _RL     gT_arr(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER k, bi, bj
      _RL     myTime
      INTEGER myIter
      INTEGER myThid
CEOP

C     !LOCAL VARIABLES:
      INTEGER i, j

      IF ( applyIcefrontTendT ) THEN
       DO j=1,sNy
        DO i=1,sNx
         IF ( k .LE. k_icefront(i,j,bi,bj) ) THEN  
          gT_arr(i,j) = gT_arr(i,j)
     &         + ICEFRONT_TendT(i,j,k,bi,bj)
         ENDIF
        ENDDO
       ENDDO
      ENDIF

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 0
C !ROUTINE: ICEFRONT_TENDENCY_APPLY_S

C !INTERFACE:
      SUBROUTINE ICEFRONT_TENDENCY_APPLY_S(
     U                    gS_arr,
     I                    k, bi, bj, myTime, myIter, myThid )

C     !DESCRIPTION:
C     Add icefront tendency terms to S tendency.
C     Routine works for one level at a time.

C     !INPUT PARAMETERS:
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
c#include "GRID.h"
c#include "DYNVARS.h"
#include "ICEFRONT.h"

C     !INPUT/OUTPUT PARAMETERS:
C     gS_arr    :: the tendency array
C     k         :: Current vertical level index
C     bi,bj     :: Current tile indices
C     myTime    :: Current time in simulation
C     myIter    :: Current iteration number
C     myThid    :: my Thread Id number
      _RL     gS_arr(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER k, bi, bj
      _RL     myTime
      INTEGER myIter
      INTEGER myThid
CEOP

C     !LOCAL VARIABLES:
      INTEGER i, j

      IF ( applyIcefrontTendS ) THEN
       DO j=1,sNy
        DO i=1,sNx
         IF ( k .LE. k_icefront(i,j,bi,bj) ) THEN  
          gS_arr(i,j) = gS_arr(i,j)
     &         + ICEFRONT_TendS(i,j,k,bi,bj)
         ENDIF
        ENDDO
       ENDDO
      ENDIF

      RETURN
      END

#include "ctrparam.h"
#include "ATM2D_OPTIONS.h"

C     !INTERFACE:
      SUBROUTINE ATM2D_READ_PICKUP( myThid )
C     *==========================================================*
C     | Read couple flux pickup, which contains fluxes for the   |
C     | initial ocean step and seaice growth/melt step. Called   |
C     | from the "normal" place (atm2d_init_vars).               |
C     *==========================================================*
        IMPLICIT NONE

#include "ATMSIZE.h"
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"

C     === Global SeaIce Variables ===
#include "THSICE_VARS.h"

C     === Atmos/Ocean/Seaice Interface Variables ===
#include "ATM2D_VARS.h"


C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
C     myThid - Thread no. that called this routine.
      INTEGER myThid

C     LOCAL VARIABLES:
      CHARACTER*(MAX_LEN_FNAM) fn
      INTEGER prec

      IF (startTime.NE.baseTime .OR. nIter0.NE.0) THEN

        prec=precFloat64

        WRITE(fn,'(A,I10.10)') 'pickup_atm2d.',nIter0

        CALL READ_REC_3D_RL(fn,prec,1,pass_slp,      1, nIter0, myThid)
        CALL READ_REC_3D_RL(fn,prec,1,pass_qnet,     2, nIter0, myThid)
        CALL READ_REC_3D_RL(fn,prec,1,pass_solarnet, 3, nIter0, myThid)
        CALL READ_REC_3D_RL(fn,prec,1,pass_fu,       4, nIter0, myThid)
        CALL READ_REC_3D_RL(fn,prec,1,pass_fv,       5, nIter0, myThid)
        CALL READ_REC_3D_RL(fn,prec,1,pass_precip,   6, nIter0, myThid)
        CALL READ_REC_3D_RL(fn,prec,1,pass_evap,     7, nIter0, myThid)
        CALL READ_REC_3D_RL(fn,prec,1,pass_runoff,   8, nIter0, myThid)
        CALL READ_REC_3D_RL(fn,prec,1,pass_wspeed,   9, nIter0, myThid)
        CALL READ_REC_3D_RL(fn,prec,1,pass_pCO2,    10, nIter0, myThid)
        CALL READ_REC_3D_RL(fn,prec,1,pass_sIceLoad,11, nIter0, myThid)

        CALL READ_REC_3D_RL(fn,prec,1,sHeating,     12, nIter0, myThid)
        CALL READ_REC_3D_RL(fn,prec,1,flxCndBt,     13, nIter0, myThid)
        CALL READ_REC_3D_RL(fn,prec,1,pass_prcAtm,  14, nIter0, myThid)
        CALL READ_REC_3D_RL(fn,prec,1,snowPrc,      15, nIter0, myThid)
        CALL READ_REC_3D_RL(fn,prec,1,icFrwAtm,     16, nIter0, myThid)
        CALL READ_REC_3D_RL(fn,prec,1,icFlxSw,      17, nIter0, myThid)
        CALL READ_REC_3D_RL(fn,prec,1,siceAlb,      18, nIter0, myThid)

      ENDIF

      RETURN
      END

#include "MOM_COMMON_OPTIONS.h"
#ifdef ALLOW_AUTODIFF
# include "AUTODIFF_OPTIONS.h"
#endif

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: MOM_CALC_VISC

C     !INTERFACE:
      SUBROUTINE MOM_CALC_VISC(
     I        bi,bj,k,
     O        viscAh_Z,viscAh_D,viscA4_Z,viscA4_D,
     I        hDiv,vort3,tension,strain,stretching,KE,hFacZ,
     I        myThid)

C     !DESCRIPTION:
C     Calculate horizontal viscosities (L is typical grid width)
C     harmonic viscosity=
C       viscAh (or viscAhD on div pts and viscAhZ on zeta pts)
C       +0.25*L**2*viscAhGrid/deltaT
C       +sqrt((viscC2leith/pi)**6*grad(Vort3)**2
C             +(viscC2leithD/pi)**6*grad(hDiv)**2)*L**3
C       +(viscC2smag/pi)**2*L**2*sqrt(Tension**2+Strain**2)
C
C     biharmonic viscosity=
C       viscA4 (or viscA4D on div pts and viscA4Z on zeta pts)
C       +0.25*0.125*L**4*viscA4Grid/deltaT (approx)
C       +0.125*L**5*sqrt((viscC4leith/pi)**6*grad(Vort3)**2
C                        +(viscC4leithD/pi)**6*grad(hDiv)**2)
C       +0.125*L**4*(viscC4smag/pi)**2*sqrt(Tension**2+Strain**2)
C
C     Note that often 0.125*L**2 is the scale between harmonic and
C     biharmonic (see Griffies and Hallberg (2000))
C     This allows the same value of the coefficient to be used
C     for roughly similar results with biharmonic and harmonic
C
C     LIMITERS -- limit min and max values of viscosities
C     viscAhReMax is min value for grid point harmonic Reynolds num
C      harmonic viscosity>sqrt(2*KE)*L/viscAhReMax
C
C     viscA4ReMax is min value for grid point biharmonic Reynolds num
C      biharmonic viscosity>sqrt(2*KE)*L**3/8/viscA4ReMax
C
C     viscAhgridmax is CFL stability limiter for harmonic viscosity
C      harmonic viscosity<0.25*viscAhgridmax*L**2/deltaT
C
C     viscA4gridmax is CFL stability limiter for biharmonic viscosity
C      biharmonic viscosity<viscA4gridmax*L**4/32/deltaT (approx)
C
C     viscAhgridmin and viscA4gridmin are lower limits for viscosity:
C       harmonic viscosity>0.25*viscAhgridmin*L**2/deltaT
C       biharmonic viscosity>viscA4gridmin*L**4/32/deltaT (approx)

C     RECOMMENDED VALUES
C     viscC2Leith=1-3
C     viscC2LeithD=1-3
C     viscC2LeithQG=1
C     viscC4Leith=1-3
C     viscC4LeithD=1.5-3
C     viscC2smag=2.2-4 (Griffies and Hallberg,2000)
C               0.2-0.9 (Smagorinsky,1993)
C     viscC4smag=2.2-4 (Griffies and Hallberg,2000)
C     viscAhReMax>=1, (<2 suppresses a computational mode)
C     viscA4ReMax>=1, (<2 suppresses a computational mode)
C     viscAhgridmax=1
C     viscA4gridmax=1
C     viscAhgrid<1
C     viscA4grid<1
C     viscAhgridmin<<1
C     viscA4gridmin<<1

C     !USES:
      IMPLICIT NONE

C     == Global variables ==
#include "SIZE.h"
#include "GRID.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "MOM_VISC.h"
#ifdef ALLOW_AUTODIFF_TAMC
#include "tamc.h"
#endif /* ALLOW_AUTODIFF_TAMC */

C     !INPUT/OUTPUT PARAMETERS:
C     myThid               :: my thread Id number
      INTEGER bi,bj,k
      _RL viscAh_Z(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL viscAh_D(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL viscA4_Z(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL viscA4_D(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL hDiv(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL vort3(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL tension(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL strain(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL stretching(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL KE(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RS hFacZ(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER myThid
CEOP

C     !LOCAL VARIABLES:
      INTEGER i,j
#ifdef ALLOW_NONHYDROSTATIC
      _RL shiftAh, shiftA4
#endif
#ifdef ALLOW_AUTODIFF_TAMC
C     kkey   :: tape key (depends on levels and tiles)
C     ijkkey :: tape key (depends on i,j-indices, levels, and tiles)
      INTEGER kkey, ijkkey
#endif
      _RL smag2fac, smag4fac
      _RL leith2fac, leith4fac
      _RL leithD2fac, leithD4fac
      _RL leithQG2fac
      _RL viscAhRe_max, viscA4Re_max
      _RL Alin, grdVrt, grdDiv, keZpt
      _RL deepFac3, deepFac4
      _RL L2, L3, L5, L2rdt, L4rdt, recip_dt
      _RL Uscl,U4scl
      _RL divDx(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL divDy(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL vrtDx(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL vrtDy(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL viscAh_ZMax(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL viscAh_DMax(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL viscA4_ZMax(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL viscA4_DMax(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL viscAh_ZMin(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL viscAh_DMin(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL viscA4_ZMin(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL viscA4_DMin(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL viscAh_ZLth(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL viscAh_DLth(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL viscA4_ZLth(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL viscA4_DLth(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL viscAh_ZLthD(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL viscAh_DLthD(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL viscA4_ZLthD(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL viscA4_DLthD(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
#ifdef ALLOW_LEITH_QG
      _RL viscAh_ZLthQG(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL viscAh_DLthQG(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL sqargQG
#endif
      _RL viscAh_ZSmg(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL viscAh_DSmg(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL viscA4_ZSmg(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL viscA4_DSmg(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL sqargAh, sqargA4, sqargAhD, sqargA4D, sqargSmag
      LOGICAL calcLeith, calcSmag, calcLeithQG

#ifdef ALLOW_AUTODIFF_TAMC
      kkey = bi + (bj-1)*nSx + (ikey_dynamics-1)*nSx*nSy
      kkey = k  + (kkey-1)*Nr
#endif /* ALLOW_AUTODIFF_TAMC */

C--   Set flags which are used in this S/R and elsewhere :
C     useVariableVisc, useHarmonicVisc and useBiharmonicVisc
C     are now set early on (in S/R SET_PARAMS)

c     IF ( useVariableVisc ) THEN
C---- variable viscosity :

       recip_dt = 1. _d 0
       IF ( deltaTMom.NE.0. ) recip_dt = 1. _d 0/deltaTMom
       deepFac3 = deepFac2C(k)*deepFacC(k)
       deepFac4 = deepFac2C(k)*deepFac2C(k)

       IF ( useHarmonicVisc .AND. viscAhReMax.NE.0. ) THEN
        viscAhRe_max=SQRT(2. _d 0)/viscAhReMax
       ELSE
        viscAhRe_max=0. _d 0
       ENDIF

       IF ( useBiharmonicVisc .AND. viscA4ReMax.NE.0. ) THEN
        viscA4Re_max=0.125 _d 0*SQRT(2. _d 0)/viscA4ReMax
       ELSE
        viscA4Re_max=0. _d 0
       ENDIF

       calcLeithQG = (viscC2LeithQG.NE.zeroRL)
       calcLeith=
     &      (viscC2leith.NE.0.)
     &  .OR.(viscC2leithD.NE.0.)
     &  .OR.(viscC4leith.NE.0.)
     &  .OR.(viscC4leithD.NE.0.)
     &  .OR. calcLeithQG

       calcSmag=
     &      (viscC2smag.NE.0.)
     &  .OR.(viscC4smag.NE.0.)

       IF (calcSmag) THEN
        smag2fac=(viscC2smag/pi)**2
        smag4fac=0.125 _d 0*(viscC4smag/pi)**2
       ELSE
        smag2fac=0. _d 0
        smag4fac=0. _d 0
       ENDIF

       IF (calcLeith) THEN
        IF (useFullLeith) THEN
C       Uses correct calculation for gradients, but might not work on cube sphere
         leith2fac =(viscC2leith /pi)**6
         leithD2fac=(viscC2leithD/pi)**6
         leithQG2fac = (viscC2LeithQG/pi)**6
         leith4fac =0.015625 _d 0*(viscC4leith /pi)**6
         leithD4fac=0.015625 _d 0*(viscC4leithD/pi)**6
        ELSE
C       Uses approximate gradients, but works on cube sphere. No reason to use this
C        unless `useFullLeith` fails for your setup.
         leith2fac =(viscC2leith /pi)**3
         leithD2fac=(viscC2leithD/pi)**3
         leithQG2fac = (viscC2LeithQG/pi)**3
         leith4fac =0.125 _d 0*(viscC4leith /pi)**3
         leithD4fac=0.125 _d 0*(viscC4leithD/pi)**3
        ENDIF
       ELSE
        leith2fac=0. _d 0
        leith4fac=0. _d 0
        leithQG2fac=0. _d 0
        leithD2fac=0. _d 0
        leithD4fac=0. _d 0
       ENDIF

       DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
C-    viscosity arrays have been initialised everywhere before calling this S/R
c         viscAh_D(i,j) = viscAhD
c         viscAh_Z(i,j) = viscAhZ
c         viscA4_D(i,j) = viscA4D
c         viscA4_Z(i,j) = viscA4Z

          viscAh_DLth(i,j) = 0. _d 0
          viscAh_ZLth(i,j) = 0. _d 0
          viscA4_DLth(i,j) = 0. _d 0
          viscA4_ZLth(i,j) = 0. _d 0
          viscAh_DLthD(i,j)= 0. _d 0
          viscAh_ZLthD(i,j)= 0. _d 0
          viscA4_DLthD(i,j)= 0. _d 0
          viscA4_ZLthD(i,j)= 0. _d 0
#ifdef ALLOW_LEITH_QG
          viscAh_DLthQG(i,j) = 0. _d 0
          viscAh_ZLthQG(i,j) = 0. _d 0
#endif

          viscAh_DSmg(i,j) = 0. _d 0
          viscAh_ZSmg(i,j) = 0. _d 0
          viscA4_DSmg(i,j) = 0. _d 0
          viscA4_ZSmg(i,j) = 0. _d 0
        ENDDO
       ENDDO

C-    Initialise to zero gradient of vorticity and divergence:
       DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
          divDx(i,j) = 0.
          divDy(i,j) = 0.
          vrtDx(i,j) = 0.
          vrtDy(i,j) = 0.
        ENDDO
       ENDDO

       IF ( calcLeith ) THEN
C--   horizontal gradient of horizontal divergence:
C-       gradient in x direction:
         IF (useCubedSphereExchange) THEN
C        to compute d/dx(hDiv), fill corners with appropriate values:
           CALL FILL_CS_CORNER_TR_RL( 1, .FALSE.,
     &                                hDiv, bi,bj, myThid )
         ENDIF
         DO j=2-OLy,sNy+OLy-1
          DO i=2-OLx,sNx+OLx-1
            divDx(i,j) = (hDiv(i,j)-hDiv(i-1,j))
     &                  *recip_dxC(i,j,bi,bj)*recip_deepFacC(k)
          ENDDO
         ENDDO

C-       gradient in y direction:
         IF (useCubedSphereExchange) THEN
C        to compute d/dy(hDiv), fill corners with appropriate values:
           CALL FILL_CS_CORNER_TR_RL( 2, .FALSE.,
     &                                hDiv, bi,bj, myThid )
         ENDIF
         DO j=2-OLy,sNy+OLy-1
          DO i=2-OLx,sNx+OLx-1
            divDy(i,j) = (hDiv(i,j)-hDiv(i,j-1))
     &                  *recip_dyC(i,j,bi,bj)*recip_deepFacC(k)
          ENDDO
         ENDDO

C--   horizontal gradient of vertical vorticity:
C-       gradient in x direction:
         DO j=2-OLy,sNy+OLy
          DO i=2-OLx,sNx+OLx-1
            vrtDx(i,j) = (vort3(i+1,j)-vort3(i,j))
     &                  *recip_dxG(i,j,bi,bj)*recip_deepFacC(k)
     &                  *maskS(i,j,k,bi,bj)
#ifdef ALLOW_OBCS
     &                  *maskInS(i,j,bi,bj)
#endif
          ENDDO
         ENDDO
C-       gradient in y direction:
         DO j=2-OLy,sNy+OLy-1
          DO i=2-OLx,sNx+OLx
            vrtDy(i,j) = (vort3(i,j+1)-vort3(i,j))
     &                  *recip_dyG(i,j,bi,bj)*recip_deepFacC(k)
     &                  *maskW(i,j,k,bi,bj)
#ifdef ALLOW_OBCS
     &                  *maskInW(i,j,bi,bj)
#endif
          ENDDO
         ENDDO

#ifdef ALLOW_LEITH_QG
        IF ( calcLeithQG ) THEN
C      horizontal gradient of vorticity and vortex stretching:
C        In the case of using QG Leith, we want to add a term
C        before calculating vector magnitude, so add to the
C        values just calculated.
C        gradient in x direction:
         DO j=2-OLy,sNy+OLy
          DO i=2-OLx,sNx+OLx-1
C        Average d/dx of stretching onto V-points to match vrtDX
            vrtDx(i,j) = vrtDx(i,j)
     &                 + halfRL*halfRL*
     &                   ( (stretching(i+1,j)-stretching(i,j))
     &                     *recip_dxC(i+1,j,bi,bj)*recip_deepFacC(k)
     &                   + (stretching(i,j)-stretching(i-1,j))
     &                     *recip_dxC(i,j,bi,bj)*recip_deepFacC(k)
     &                   + (stretching(i+1,j-1)-stretching(i,j-1))
     &                     *recip_dxC(i,j-1,bi,bj)*recip_deepFacC(k)
     &                   + (stretching(i,j-1)-stretching(i-1,j-1))
     &                     *recip_dxC(i-1,j-1,bi,bj)*recip_deepFacC(k)
     &                   )*maskS(i,j,k,bi,bj)
#ifdef ALLOW_OBCS
     &                    *maskInS(i,j,bi,bj)
#endif
          ENDDO
         ENDDO
C-       gradient in y direction:
         DO j=2-OLy,sNy+OLy-1
          DO i=2-OLx,sNx+OLx
C        Average d/dy of stretching onto U-points to match vrtDy
            vrtDy(i,j) = vrtDy(i,j)
     &                 + halfRL*halfRL*
     &                   ( (stretching(i,j+1)-stretching(i,j))
     &                     *recip_dyC(i,j+1,bi,bj)*recip_deepFacC(k)
     &                   + (stretching(i,j)-stretching(i,j-1))
     &                     *recip_dyC(i,j,bi,bj)*recip_deepFacC(k)
     &                   + (stretching(i-1,j+1)-stretching(i-1,j))
     &                     *recip_dyC(i-1,j+1,bi,bj)*recip_deepFacC(k)
     &                   + (stretching(i-1,j)-stretching(i-1,j-1))
     &                     *recip_dyC(i-1,j,bi,bj)*recip_deepFacC(k)
     &                   )*maskW(i,j,k,bi,bj)
#ifdef ALLOW_OBCS
     &                    *maskInW(i,j,bi,bj)
#endif
          ENDDO
         ENDDO
C      end if calcLeithQG
        ENDIF
#endif /* ALLOW_LEITH_QG */

C--   end if calcLeith
       ENDIF

       DO j=2-OLy,sNy+OLy-1
        DO i=2-OLx,sNx+OLx-1
CCCCCCCCCCCCCCC Divergence Point CalculationsCCCCCCCCCCCCCCCCCCCC

#ifdef ALLOW_AUTODIFF_TAMC
# ifndef AUTODIFF_DISABLE_LEITH
         ijkkey = i+OLx + (j+OLy-1)*(sNx+2*OLx)
     &                   + (kkey-1)*(sNx+2*OLx)*(sNy+2*OLy)
CADJ STORE viscA4_ZSmg(i,j)=comlev1_mom_ijk_loop,key=ijkkey,byte=isbyte
CADJ STORE viscAh_ZSmg(i,j)=comlev1_mom_ijk_loop,key=ijkkey,byte=isbyte
# endif
#endif /* ALLOW_AUTODIFF_TAMC */

C These are (powers of) length scales
         L2 = L2_D(i,j,bi,bj)*deepFac2C(k)
         L2rdt = 0.25 _d 0*recip_dt*L2
         L3 = L3_D(i,j,bi,bj)*deepFac3
         L4rdt = L4rdt_D(i,j,bi,bj)*deepFac4
         L5 = (L2*L3)

#ifndef AUTODIFF_DISABLE_REYNOLDS_SCALE
C Velocity Reynolds Scale
         IF ( viscAhRe_max.GT.0. .AND. KE(i,j).GT.0. ) THEN
           Uscl=SQRT(KE(i,j)*L2)*viscAhRe_max
         ELSE
           Uscl=0.
         ENDIF
         IF ( viscA4Re_max.GT.0. .AND. KE(i,j).GT.0. ) THEN
           U4scl=SQRT(KE(i,j))*L3*viscA4Re_max
         ELSE
           U4scl=0.
         ENDIF
#endif /* ndef AUTODIFF_DISABLE_REYNOLDS_SCALE */

#ifndef AUTODIFF_DISABLE_LEITH
         IF (useFullLeith.AND.calcLeith) THEN
C This is the vector magnitude of the vorticity gradient squared
          grdVrt=0.25 _d 0*( (vrtDx(i,j+1)*vrtDx(i,j+1)
     &                        + vrtDx(i,j)*vrtDx(i,j) )
     &                     + (vrtDy(i+1,j)*vrtDy(i+1,j)
     &                        + vrtDy(i,j)*vrtDy(i,j) )  )

C This is the vector magnitude of grad (div.v) squared
C Using it in Leith serves to damp instabilities in w.
          grdDiv=0.25 _d 0*( (divDx(i+1,j)*divDx(i+1,j)
     &                        + divDx(i,j)*divDx(i,j) )
     &                     + (divDy(i,j+1)*divDy(i,j+1)
     &                        + divDy(i,j)*divDy(i,j) )  )

          sqargAh  = leith2fac*grdVrt+leithD2fac*grdDiv
          sqargA4  = leith4fac*grdVrt+leithD4fac*grdDiv
          sqargAhD = leithD2fac*grdDiv
          sqargA4D = leithD4fac*grdDiv
#ifdef ALLOW_LEITH_QG
          sqargQG  = leithQG2fac*(grdVrt+grdDiv)
#endif

#ifdef ALLOW_AUTODIFF
C Avoid derivative of SQRT(0)
          IF (sqargAh .GT.0. _d 0) sqargAh = SQRT(sqargAh)
          IF (sqargA4 .GT.0. _d 0) sqargA4 = SQRT(sqargA4)
          IF (sqargAhD .GT.0. _d 0) sqargAhD = SQRT(sqargAhD)
          IF (sqargA4D .GT.0. _d 0) sqargA4D = SQRT(sqargA4D)
# ifdef ALLOW_LEITH_QG
          IF (sqargQG .GT.0. _d 0) sqargQG = SQRT(sqargQG)
# endif
#else /* ALLOW_AUTODIFF */
          sqargAh = SQRT(sqargAh)
          sqargA4 = SQRT(sqargA4)
          sqargAhD = SQRT(sqargAhD)
          sqargA4D = SQRT(sqargA4D)
# ifdef ALLOW_LEITH_QG
          sqargQG = SQRT(sqargQG)
# endif
#endif /* ALLOW_AUTODIFF */
          viscAh_DLth(i,j) = sqargAh  * L3
          viscA4_DLth(i,j) = sqargA4  * L5
          viscAh_DLthd(i,j)= sqargAhD * L3
          viscA4_DLthd(i,j)= sqargA4D * L5
#ifdef ALLOW_LEITH_QG
          viscAh_DLthQG(i,j)=sqargQG  * L3
#endif

         ELSEIF (calcLeith) THEN
C but this approximation will work on cube (and differs by as much as 4X)
          grdVrt=MAX( ABS(vrtDx(i,j+1)), ABS(vrtDx(i,j)) )
          grdVrt=MAX( grdVrt, ABS(vrtDy(i+1,j)) )
          grdVrt=MAX( grdVrt, ABS(vrtDy(i,j))   )

C This approximation is good to the same order as above...
          grdDiv=MAX( ABS(divDx(i+1,j)), ABS(divDx(i,j)) )
          grdDiv=MAX( grdDiv, ABS(divDy(i,j+1)) )
          grdDiv=MAX( grdDiv, ABS(divDy(i,j))   )

          viscAh_DLth(i,j)=(leith2fac*grdVrt+(leithD2fac*grdDiv))*L3
          viscA4_DLth(i,j)=(leith4fac*grdVrt+(leithD4fac*grdDiv))*L5
          viscAh_DLthD(i,j)=((leithD2fac*grdDiv))*L3
          viscA4_DLthD(i,j)=((leithD4fac*grdDiv))*L5
#ifdef ALLOW_LEITH_QG
          viscAh_DLthQG(i,j)=leithQG2fac*(grdVrt + grdDiv)*L3
#endif

         ELSE
          viscAh_DLth(i,j)=0. _d 0
          viscA4_DLth(i,j)=0. _d 0
          viscAh_DLthD(i,j)=0. _d 0
          viscA4_DLthD(i,j)=0. _d 0
#ifdef ALLOW_LEITH_QG
          viscAh_DLthQG(i,j)=0. _d 0
#endif
         ENDIF

         IF (calcSmag) THEN
          sqargSmag = tension(i,j)**2
     &       +0.25 _d 0*(strain(i+1, j )**2+strain( i ,j+1)**2
     &                  +strain(i  , j )**2+strain(i+1,j+1)**2)
#ifdef ALLOW_AUTODIFF
C Avoid derivative of SQRT(0)
          IF (sqargSmag.GT.0. _d 0) sqargSmag = SQRT(sqargSmag)
#else
          sqargSmag = SQRT(sqargSmag)
#endif
          viscAh_DSmg(i,j)=L2*sqargSmag
          viscA4_DSmg(i,j)=smag4fac*L2*viscAh_DSmg(i,j)
          viscAh_DSmg(i,j)=smag2fac*viscAh_DSmg(i,j)
         ELSE
          viscAh_DSmg(i,j)=0. _d 0
          viscA4_DSmg(i,j)=0. _d 0
         ENDIF
#endif /* AUTODIFF_DISABLE_LEITH */

C  Harmonic on Div.u points
         Alin=viscAhD+viscAhGrid*L2rdt
     &         + viscAh_DLth(i,j)+viscAh_DSmg(i,j)
#ifdef ALLOW_LEITH_QG
     &         + viscAh_DLthQG(i,j)
#endif
#ifdef ALLOW_3D_VISCAH
     &         + viscAhDfld(i,j,k,bi,bj)
# ifdef AUTODIFF_ALLOW_VISCFACADJ
     &          *viscFacAdj
# endif /* AUTODIFF_ALLOW_VISCFACADJ */
#endif /* ALLOW_3D_VISCAH */
         viscAh_DMin(i,j)=MAX(viscAhGridMin*L2rdt,Uscl)
         viscAh_D(i,j)=MAX(viscAh_DMin(i,j),Alin)
         viscAh_DMax(i,j)=MIN(viscAhGridMax*L2rdt,viscAhMax)
         viscAh_D(i,j)=MIN(viscAh_DMax(i,j),viscAh_D(i,j))

C  BiHarmonic on Div.u points
         Alin=viscA4D+viscA4Grid*L4rdt
     &         + viscA4_DLth(i,j)+viscA4_DSmg(i,j)
#ifdef ALLOW_3D_VISCA4
     &         + viscA4Dfld(i,j,k,bi,bj)
# ifdef AUTODIFF_ALLOW_VISCFACADJ
     &          *viscFacAdj
# endif /* AUTODIFF_ALLOW_VISCFACADJ */
#endif /* ALLOW_3D_VISCA4 */
         viscA4_DMin(i,j)=MAX(viscA4GridMin*L4rdt,U4scl)
         viscA4_D(i,j)=MAX(viscA4_DMin(i,j),Alin)
         viscA4_DMax(i,j)=MIN(viscA4GridMax*L4rdt,viscA4Max)
         viscA4_D(i,j)=MIN(viscA4_DMax(i,j),viscA4_D(i,j))

CCCCCCCCCCCCC Vorticity Point CalculationsCCCCCCCCCCCCCCCCCC
C These are (powers of) length scales
         L2 = L2_Z(i,j,bi,bj)*deepFac2C(k)
         L2rdt = 0.25 _d 0*recip_dt*L2
         L3 = L3_Z(i,j,bi,bj)*deepFac3
         L4rdt = L4rdt_Z(i,j,bi,bj)*deepFac4
         L5 = (L2*L3)

#ifndef AUTODIFF_DISABLE_REYNOLDS_SCALE
C Velocity Reynolds Scale (Pb here at CS-grid corners !)
         IF ( viscAhRe_max.GT.0. .OR. viscA4Re_max.GT.0. ) THEN
           keZpt=0.25 _d 0*( (KE(i,j)+KE(i-1,j-1))
     &                      +(KE(i-1,j)+KE(i,j-1)) )
           IF ( keZpt.GT.0. ) THEN
             Uscl = SQRT(keZpt*L2)*viscAhRe_max
             U4scl= SQRT(keZpt)*L3*viscA4Re_max
           ELSE
             Uscl =0.
             U4scl=0.
           ENDIF
         ELSE
           Uscl =0.
           U4scl=0.
         ENDIF
#endif /* ndef AUTODIFF_DISABLE_REYNOLDS_SCALE */

#ifndef AUTODIFF_DISABLE_LEITH
C This is the vector magnitude of the vorticity gradient squared
         IF (useFullLeith.AND.calcLeith) THEN
          grdVrt=0.25 _d 0*( (vrtDx(i-1,j)*vrtDx(i-1,j)
     &                        + vrtDx(i,j)*vrtDx(i,j) )
     &                     + (vrtDy(i,j-1)*vrtDy(i,j-1)
     &                        + vrtDy(i,j)*vrtDy(i,j) )  )

C This is the vector magnitude of grad(div.v) squared
          grdDiv=0.25 _d 0*( (divDx(i,j-1)*divDx(i,j-1)
     &                        + divDx(i,j)*divDx(i,j) )
     &                     + (divDy(i-1,j)*divDy(i-1,j)
     &                        + divDy(i,j)*divDy(i,j) )  )

          sqargAh  = leith2fac*grdVrt+leithD2fac*grdDiv
          sqargA4  = leith4fac*grdVrt+leithD4fac*grdDiv
          sqargAhD = leithD2fac*grdDiv
          sqargA4D = leithD4fac*grdDiv
#ifdef ALLOW_LEITH_QG
          sqargQG  = leithQG2fac*(grdVrt+grdDiv)
#endif
#ifdef ALLOW_AUTODIFF
C Avoid derivative of SQRT(0)
          IF (sqargAh .GT.0. _d 0) sqargAh = SQRT(sqargAh)
          IF (sqargA4 .GT.0. _d 0) sqargA4 = SQRT(sqargA4)
          IF (sqargAhD .GT.0. _d 0) sqargAhD = SQRT(sqargAhD)
          IF (sqargA4D .GT.0. _d 0) sqargA4D = SQRT(sqargA4D)
# ifdef ALLOW_LEITH_QG
          IF (sqargQG .GT.0. _d 0) sqargQG = SQRT(sqargQG)
# endif
#else /* ALLOW_AUTODIFF */
          sqargAh = SQRT(sqargAh)
          sqargA4 = SQRT(sqargA4)
          sqargAhD = SQRT(sqargAhD)
          sqargA4D = SQRT(sqargA4D)
# ifdef ALLOW_LEITH_QG
          sqargQG = SQRT(sqargQG)
# endif
#endif /* ALLOW_AUTODIFF */
          viscAh_ZLth(i,j) = sqargAh  * L3
          viscA4_ZLth(i,j) = sqargA4  * L5
          viscAh_ZLthd(i,j)= sqargAhD * L3
          viscA4_ZLthd(i,j)= sqargA4D * L5
#ifdef ALLOW_LEITH_QG
          viscAh_ZLthQG(i,j)=sqargQG  * L3
#endif

         ELSEIF (calcLeith) THEN
C but this approximation will work on cube (and differs by 4X)
          grdVrt=MAX( ABS(vrtDx(i-1,j)), ABS(vrtDx(i,j)) )
          grdVrt=MAX( grdVrt, ABS(vrtDy(i,j-1)) )
          grdVrt=MAX( grdVrt, ABS(vrtDy(i,j))   )

          grdDiv=MAX( ABS(divDx(i,j)), ABS(divDx(i,j-1)) )
          grdDiv=MAX( grdDiv, ABS(divDy(i,j))   )
          grdDiv=MAX( grdDiv, ABS(divDy(i-1,j)) )

          viscAh_ZLth(i,j)=(leith2fac*grdVrt+(leithD2fac*grdDiv))*L3
          viscA4_ZLth(i,j)=(leith4fac*grdVrt+(leithD4fac*grdDiv))*L5
          viscAh_ZLthD(i,j)=(leithD2fac*grdDiv)*L3
          viscA4_ZLthD(i,j)=(leithD4fac*grdDiv)*L5
#ifdef ALLOW_LEITH_QG
          viscAh_ZLthQG(i,j)=leithQG2fac*(grdVrt + grdDiv)*L3
#endif
         ELSE
          viscAh_ZLth(i,j)=0. _d 0
          viscA4_ZLth(i,j)=0. _d 0
          viscAh_ZLthD(i,j)=0. _d 0
          viscA4_ZLthD(i,j)=0. _d 0
#ifdef ALLOW_LEITH_QG
          viscAh_ZLthQG(i,j)=0. _d 0
#endif
         ENDIF

         IF (calcSmag) THEN
          sqargSmag = strain(i,j)**2
     &        +0.25 _d 0*(tension( i , j )**2+tension( i ,j-1)**2
     &                   +tension(i-1, j )**2+tension(i-1,j-1)**2)
#ifdef ALLOW_AUTODIFF
C Avoid derivative of SQRT(0)
          IF (sqargSmag.GT.0. _d 0) sqargSmag = SQRT(sqargSmag)
#else
          sqargSmag = SQRT(sqargSmag)
#endif
          viscAh_ZSmg(i,j)=L2*sqargSmag
          viscA4_ZSmg(i,j)=smag4fac*L2*viscAh_ZSmg(i,j)
          viscAh_ZSmg(i,j)=smag2fac*viscAh_ZSmg(i,j)
         ENDIF
#endif /* AUTODIFF_DISABLE_LEITH */

C  Harmonic on Zeta points
         Alin=viscAhZ+viscAhGrid*L2rdt
     &         + viscAh_ZLth(i,j)+viscAh_ZSmg(i,j)
#ifdef ALLOW_LEITH_QG
     &         + viscAh_ZLthQG(i,j)
#endif
#ifdef ALLOW_3D_VISCAH
     &         + viscAhZfld(i,j,k,bi,bj)
# ifdef AUTODIFF_ALLOW_VISCFACADJ
     &          *viscFacAdj
# endif /* AUTODIFF_ALLOW_VISCFACADJ */
#endif
         viscAh_ZMin(i,j)=MAX(viscAhGridMin*L2rdt,Uscl)
         viscAh_Z(i,j)=MAX(viscAh_ZMin(i,j),Alin)
         viscAh_ZMax(i,j)=MIN(viscAhGridMax*L2rdt,viscAhMax)
         viscAh_Z(i,j)=MIN(viscAh_ZMax(i,j),viscAh_Z(i,j))

C  BiHarmonic on Zeta points
         Alin=viscA4Z+viscA4Grid*L4rdt
     &         + viscA4_ZLth(i,j)+viscA4_ZSmg(i,j)
#ifdef ALLOW_3D_VISCA4
     &         + viscA4Zfld(i,j,k,bi,bj)
# ifdef AUTODIFF_ALLOW_VISCFACADJ
     &          *viscFacAdj
# endif /* AUTODIFF_ALLOW_VISCFACADJ */
#endif
         viscA4_ZMin(i,j)=MAX(viscA4GridMin*L4rdt,U4scl)
         viscA4_Z(i,j)=MAX(viscA4_ZMin(i,j),Alin)
         viscA4_ZMax(i,j)=MIN(viscA4GridMax*L4rdt,viscA4Max)
         viscA4_Z(i,j)=MIN(viscA4_ZMax(i,j),viscA4_Z(i,j))
        ENDDO
       ENDDO

#ifdef ALLOW_NONHYDROSTATIC
       IF ( nonHydrostatic ) THEN
C--   Pass Viscosities to calc_gw (if constant, not necessary)

        IF ( k.LT.Nr ) THEN
C     Prepare for next level (next call)
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
            viscAh_W(i,j,k+1,bi,bj) = halfRL*viscAh_D(i,j)
            viscA4_W(i,j,k+1,bi,bj) = halfRL*viscA4_D(i,j)
          ENDDO
         ENDDO
        ENDIF

        shiftAh = viscAhW - viscAhD
        shiftA4 = viscA4W - viscA4D
        IF ( k.EQ.1 ) THEN
C     These values dont get used
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
            viscAh_W(i,j,k,bi,bj) = shiftAh + viscAh_D(i,j)
            viscA4_W(i,j,k,bi,bj) = shiftA4 + viscA4_D(i,j)
          ENDDO
         ENDDO
        ELSE
C     Note that previous call of this function has already added half.
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
            viscAh_W(i,j,k,bi,bj) = shiftAh + viscAh_W(i,j,k,bi,bj)
     &                                      + halfRL*viscAh_D(i,j)
            viscA4_W(i,j,k,bi,bj) = shiftA4 + viscA4_W(i,j,k,bi,bj)
     &                                      + halfRL*viscA4_D(i,j)
          ENDDO
         ENDDO
        ENDIF

       ENDIF
#endif /* ALLOW_NONHYDROSTATIC */

c     ELSE
C---- use constant viscosity (useVariableVisc=F):
c      DO j=1-OLy,sNy+OLy
c       DO i=1-OLx,sNx+OLx
c        viscAh_D(i,j) = viscAhD
c        viscAh_Z(i,j) = viscAhZ
c        viscA4_D(i,j) = viscA4D
c        viscA4_Z(i,j) = viscA4Z
c       ENDDO
c      ENDDO
C---- variable/constant viscosity : end if/else block
c     ENDIF

#ifdef ALLOW_DIAGNOSTICS
      IF (useDiagnostics) THEN
       CALL DIAGNOSTICS_FILL(viscAh_D,'VISCAHD ',k,1,2,bi,bj,myThid)
       CALL DIAGNOSTICS_FILL(viscA4_D,'VISCA4D ',k,1,2,bi,bj,myThid)
       CALL DIAGNOSTICS_FILL(viscAh_Z,'VISCAHZ ',k,1,2,bi,bj,myThid)
       CALL DIAGNOSTICS_FILL(viscA4_Z,'VISCA4Z ',k,1,2,bi,bj,myThid)

       CALL DIAGNOSTICS_FILL(viscAh_DMax,'VAHDMAX ',k,1,2,bi,bj,myThid)
       CALL DIAGNOSTICS_FILL(viscA4_DMax,'VA4DMAX ',k,1,2,bi,bj,myThid)
       CALL DIAGNOSTICS_FILL(viscAh_ZMax,'VAHZMAX ',k,1,2,bi,bj,myThid)
       CALL DIAGNOSTICS_FILL(viscA4_ZMax,'VA4ZMAX ',k,1,2,bi,bj,myThid)

       CALL DIAGNOSTICS_FILL(viscAh_DMin,'VAHDMIN ',k,1,2,bi,bj,myThid)
       CALL DIAGNOSTICS_FILL(viscA4_DMin,'VA4DMIN ',k,1,2,bi,bj,myThid)
       CALL DIAGNOSTICS_FILL(viscAh_ZMin,'VAHZMIN ',k,1,2,bi,bj,myThid)
       CALL DIAGNOSTICS_FILL(viscA4_ZMin,'VA4ZMIN ',k,1,2,bi,bj,myThid)

       CALL DIAGNOSTICS_FILL(viscAh_DLth,'VAHDLTH ',k,1,2,bi,bj,myThid)
       CALL DIAGNOSTICS_FILL(viscA4_DLth,'VA4DLTH ',k,1,2,bi,bj,myThid)
       CALL DIAGNOSTICS_FILL(viscAh_ZLth,'VAHZLTH ',k,1,2,bi,bj,myThid)
       CALL DIAGNOSTICS_FILL(viscA4_ZLth,'VA4ZLTH ',k,1,2,bi,bj,myThid)

       CALL DIAGNOSTICS_FILL(viscAh_DLthD,'VAHDLTHD',
     &                       k,1,2,bi,bj,myThid)
       CALL DIAGNOSTICS_FILL(viscA4_DLthD,'VA4DLTHD',
     &                       k,1,2,bi,bj,myThid)
       CALL DIAGNOSTICS_FILL(viscAh_ZLthD,'VAHZLTHD',
     &                       k,1,2,bi,bj,myThid)
       CALL DIAGNOSTICS_FILL(viscA4_ZLthD,'VA4ZLTHD',
     &                       k,1,2,bi,bj,myThid)
#ifdef ALLOW_LEITH_QG
       CALL DIAGNOSTICS_FILL(viscAh_DLthQG,'VAHDLTHQ',
     &                       k,1,2,bi,bj,myThid)
       CALL DIAGNOSTICS_FILL(viscAh_ZLthQG,'VAHZLTHQ',
     &                       k,1,2,bi,bj,myThid)
#endif
       CALL DIAGNOSTICS_FILL(viscAh_DSmg,'VAHDSMAG',k,1,2,bi,bj,myThid)
       CALL DIAGNOSTICS_FILL(viscA4_DSmg,'VA4DSMAG',k,1,2,bi,bj,myThid)
       CALL DIAGNOSTICS_FILL(viscAh_ZSmg,'VAHZSMAG',k,1,2,bi,bj,myThid)
       CALL DIAGNOSTICS_FILL(viscA4_ZSmg,'VA4ZSMAG',k,1,2,bi,bj,myThid)
      ENDIF
#endif /* ALLOW_DIAGNOSTICS */

      RETURN
      END

#include "CPP_EEOPTIONS.h"

CBOP
C     !ROUTINE: EXCH2_RL1_CUBE_B

C     !INTERFACE:
      SUBROUTINE EXCH2_RL1_CUBE_B(
     U            array, arrayb,
     I            signOption, fieldCode,
     I            myOLw, myOLe, myOLs, myOLn, myNz,
     I            exchWidthX, exchWidthY,
     I            cornerMode, myThid )

C     !DESCRIPTION:
C     Scalar field (1 component) AD-Exchange:
C     Tile-edge overlap-region of a 1 component scalar field is added to
C     corresponding near-edge interior data point and then zero out.

C     !USES:
      IMPLICIT NONE

C     == Global data ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "EESUPPORT.h"
#include "W2_EXCH2_SIZE.h"
#include "W2_EXCH2_TOPOLOGY.h"
#include "W2_EXCH2_BUFFER.h"

C     !INPUT/OUTPUT PARAMETERS:
C     array       :: Array with edges to exchange.
C     signOption  :: Flag controlling whether field sign depends on orientation
C                 :: (signOption not yet implemented but needed for SM exch)
C     fieldCode   :: field code (position on staggered grid)
C     myOLw,myOLe :: West and East overlap region sizes.
C     myOLs,myOLn :: South and North overlap region sizes.
C     exchWidthX  :: Width of data regi exchanged in X.
C     exchWidthY  :: Width of data region exchanged in Y.
C     cornerMode  :: halo-corner-region treatment: update/ignore corner region
C     myThid      :: Thread number of this instance of S/R EXCH...

      INTEGER myOLw, myOLe, myOLs, myOLn, myNz
      _RL array(1-myOLw:sNx+myOLe,
     &          1-myOLs:sNy+myOLn,
     &          myNZ, nSx, nSy)
      _RL arrayb(1-myOLw:sNx+myOLe,
     &          1-myOLs:sNy+myOLn,
     &          myNZ, nSx, nSy)
      LOGICAL signOption
      CHARACTER*2 fieldCode
      INTEGER exchWidthX
      INTEGER exchWidthY
      INTEGER cornerMode
      INTEGER myThid

C     !LOCAL VARIABLES:
CEOP
      CALL EXCH2_RL1_CUBE_AD(
     U            arrayb,
     I            signOption, fieldCode,
     I            myOLw, myOLe, myOLs, myOLn, myNz,
     I            exchWidthX, exchWidthY,
     I            cornerMode, myThid )
      RETURN
      END

#include "BLING_OPTIONS.h"
#include "PTRACERS_OPTIONS.h"

CBOP
      subroutine BLING_CARBONATE_INIT( myThid )

C     ==========================================================
C     | subroutine bling_carbonate_init
C     | o Calculate first guess of pH
C     |   Adapted from pkg/dic/dic_surfforcing_init.F
C     ==========================================================

      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "DYNVARS.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "FFIELDS.h"
#include "BLING_VARS.h"
#include "PTRACERS_SIZE.h"
#include "PTRACERS_PARAMS.h"
#include "PTRACERS_FIELDS.h"
#include "BLING_LOAD.h"

C     === Routine arguments ===
C     myThid               :: thread Id. number
      INTEGER  myThid

#ifdef ALLOW_BLING
C     === Local variables ===
       INTEGER i,j, k, it
       INTEGER intimeP, intime0, intime1
       _RL aWght, bWght, co3dummy
C Number of iterations for pCO2 solvers...
C Solubility relation coefficients
C local variables for carbon chem
      INTEGER iMin,iMax,jMin,jMax, bi, bj
      _RL alktmp(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL phostmp(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL sitmp(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL thetatmp(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL salttmp(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL dictmp(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      LOGICAL pH_isLoaded
CEOP

#ifndef USE_SIBLING
      IF ( periodicExternalForcing ) THEN

c read in silica field
         CALL LEF_ZERO( silica0,myThid )
         CALL LEF_ZERO( silica1,myThid )

C--   Now calculate whether it is time to update the forcing arrays
       CALL GET_PERIODIC_INTERVAL(
     O                   intimeP, intime0, intime1, bWght, aWght,
     I                   externForcingCycle, externForcingPeriod,
     I                   deltaTClock, startTime, myThid )

       _BARRIER
       _BEGIN_MASTER(myThid)
        WRITE(standardMessageUnit,'(A,I10,A,2(2I5,A))')
     &   ' BLING_SURFFORCING_INIT, it=', nIter0,
     &   ' : Reading new data, i0,i1=', intime0, intime1
       _END_MASTER(myThid)

       IF ( BLING_silicaFile .NE. ' '  ) THEN
         CALL READ_REC_XY_RS( BLING_silicaFile,silica0,intime0,
     &        nIter0,myThid )
         CALL READ_REC_XY_RS( BLING_silicaFile,silica1,intime1,
     &        nIter0,myThid )
       ENDIF

#ifdef ALLOW_OFFLINE
       IF ( useOffLine ) THEN
         CALL OFFLINE_FIELDS_LOAD( startTime, nIter0, myThid )
       ENDIF
#endif

       _EXCH_XY_RS(silica0, myThid )
       _EXCH_XY_RS(silica1, myThid )

       IF ( BLING_silicaFile .NE. ' '  ) THEN
        DO bj = myByLo(myThid), myByHi(myThid)
         DO bi = myBxLo(myThid), myBxHi(myThid)
          DO j=1-OLy,sNy+OLy
           DO i=1-OLx,sNx+OLx
             silica(i,j,bi,bj)= bWght*silica0(i,j,bi,bj)
     &                        + aWght*silica1(i,j,bi,bj)
           ENDDO
          ENDDO
         ENDDO
        ENDDO
       ENDIF

c end periodicExternalForcing
      ENDIF
c end SiBLING
#endif

C =================================================================

      jMin=1
      jMax=sNy
      iMin=1
      iMax=sNx

      DO k=1,Nr
      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
            pH(i,j,k,bi,bj) = 8. _d 0
          ENDDO
         ENDDO
       ENDDO
      ENDDO
      ENDDO

      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          ak0(i,j,bi,bj)=0. _d 0
          ak1(i,j,bi,bj)=0. _d 0
          ak2(i,j,bi,bj)=0. _d 0
          akw(i,j,bi,bj)=0. _d 0
          akb(i,j,bi,bj)=0. _d 0
          akf(i,j,bi,bj)=0. _d 0
          ak1p(i,j,bi,bj)=0. _d 0
          ak2p(i,j,bi,bj)=0. _d 0
          ak3p(i,j,bi,bj)=0. _d 0
          aksi(i,j,bi,bj)=0. _d 0
          fugf(i,j,bi,bj)=0. _d 0
          ff(i,j,bi,bj)=0. _d 0
          ft(i,j,bi,bj)=0. _d 0
          st(i,j,bi,bj)=0. _d 0
          bt(i,j,bi,bj)=0. _d 0
#ifdef CARBONCHEM_SOLVESAPHE
          cat(i,j,bi,bj)=0. _d 0
          akn(i,j,bi,bj)=0. _d 0
          akhs(i,j,bi,bj)=0. _d 0
          aphscale(i,j,bi,bj)=0. _d 0
#endif
         ENDDO
        ENDDO
       ENDDO
      ENDDO

      pH_isLoaded = .FALSE.
      IF ( nIter0.GT.PTRACERS_Iter0 .OR.
     &    (nIter0.EQ.PTRACERS_Iter0 .AND. pickupSuff.NE.' ')
     &   ) THEN
C       Read pH from a pickup file if needed
        CALL BLING_READ_PICKUP(
     O                        pH_isLoaded,
     I                        nIter0, myThid )
      ENDIF

      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)

C determine inorganic carbon chem coefficients

        IF ( .NOT.pH_isLoaded ) THEN
C set guess of pH for first step here

        DO k=1,Nr
         DO j=jMin,jMax
          DO i=iMin,iMax
             thetatmp(i,j) = theta(i,j,k,bi,bj)
             salttmp(i,j) = salt(i,j,k,bi,bj)
             dictmp(i,j) = PTRACER(i,j,k,bi,bj,1)
     &                          * maskC(i,j,k,bi,bj)
             alktmp(i,j) = PTRACER(i,j,k,bi,bj,2)
     &                          * maskC(i,j,k,bi,bj)
#ifndef USE_BLING_V1
             phostmp(i,j) = PTRACER(i,j,k,bi,bj,5)
     &                          * maskC(i,j,k,bi,bj)
#else
             phostmp(i,j) = PTRACER(i,j,k,bi,bj,4)
     &                          * maskC(i,j,k,bi,bj)
#endif
#ifdef USE_SIBLING
             sitmp(i,j) = PTRACER(i,j,k,bi,bj,9)
     &                          * maskC(i,j,k,bi,bj)
#else
C FOR NON-INTERACTIVE Si
             IF ( k.eq.1 ) THEN
              sitmp(i,j) = silica(i,j,bi,bj) * maskC(i,j,k,bi,bj)
             ELSE
              sitmp(i,j) = 0.03 * maskC(i,j,k,bi,bj)
             ENDIF
#endif
          ENDDO
         ENDDO

#ifdef CARBONCHEM_SOLVESAPHE
#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_CALL('DIC_COEFFS_DEEP',myThid)
#endif
        CALL DIC_COEFFS_SURF(
cav changing surftheta to thetatmp
     I                       thetatmp,salttmp,
     I                       bi,bj,iMin,iMax,jMin,jMax,myThid)
C Now correct the coefficients for pressure dependence
        CALL DIC_COEFFS_DEEP(
     I                       thetatmp,salttmp,
     I                       bi,bj,iMin,iMax,jMin,jMax,
     I                       k,myThid)
#else
#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_CALL('CARBON_COEFFS',myThid)
#endif
         CALL CARBON_COEFFS_PRESSURE_DEP(
     I                       thetatmp,salttmp,
     I                       bi,bj,iMin,iMax,jMin,jMax,k,myThid)
#endif

C====================================================================

c first approximation

          DO j=jMin,jMax
           DO i=iMin,iMax
            IF ( maskC(i,j,k,bi,bj) .NE. 0. _d 0) THEN

#ifdef CARBONCHEM_SOLVESAPHE
             IF ( selectPHsolver.GT.0 ) THEN
C Use Munhoven (2013) Solvesaphe routine to initialize pH
#ifdef ALLOW_DEBUG
              IF (debugMode) CALL DEBUG_CALL(
     &            'AHINI_FOR_AT',myThid)
#endif
C call AHINI_FOR_AT to get better initial guess of pH
              CALL AHINI_FOR_AT(
     I           alktmp(i,j)*permil,
     I           dictmp(i,j)*permil,
     I           bt(i,j,bi,bj),
     U           pH(i,j,k,bi,bj),
     I           i,j,k,bi,bj,nIter0,myThid )
CAV C$TAF STORE pH(i,j,k,bi,bj)                            = dic_surf
CAV C$TAF STORE alktmp(i,j), phostmp(i,j), sitmp(i,j)      = dic_surf
#ifdef ALLOW_DEBUG
              IF (debugMode) CALL DEBUG_CALL(
     &           'CALC_PCO2_SOLVESAPHE',myThid)
#endif
              CALL CALC_PCO2_SOLVESAPHE(
     I        thetatmp(i,j),salttmp(i,j),
     I        dictmp(i,j), phostmp(i,j),
     I        sitmp(i,j),alktmp(i,j),
     U        pH(i,j,k,bi,bj),pCO2(i,j,bi,bj),co3dummy,
     I        i,j,k,bi,bj, it ,  myThid )
             ELSE
C Use the original Follows et al. (2006) solver
#endif /* CARBONCHEM_SOLVESAPHE */
#ifdef ALLOW_DEBUG
              IF (debugMode) CALL DEBUG_CALL(
     &           'CALC_PCO2_APPROX',myThid)
#endif

             DO it=1,10
              CALL CALC_PCO2_APPROX(
     I        thetatmp(i,j),salttmp(i,j),
     I        dictmp(i,j), phostmp(i,j),
     I        sitmp(i,j),alktmp(i,j),
     I        ak1(i,j,bi,bj),ak2(i,j,bi,bj),
     I        ak1p(i,j,bi,bj),ak2p(i,j,bi,bj),ak3p(i,j,bi,bj),
     I        aks(i,j,bi,bj),akb(i,j,bi,bj),akw(i,j,bi,bj),
     I        aksi(i,j,bi,bj),akf(i,j,bi,bj),
     I        ak0(i,j,bi,bj), fugf(i,j,bi,bj),
     I        ff(i,j,bi,bj),
     I        bt(i,j,bi,bj),st(i,j,bi,bj),ft(i,j,bi,bj),
     U        pH(i,j,k,bi,bj),pCO2(i,j,bi,bj),co3dummy,
     I        i,j,k,bi,bj, it ,  myThid )
             ENDDO
            ENDIF
#ifdef CARBONCHEM_SOLVESAPHE
             ENDIF
#endif /* CARBONCHEM_SOLVESAPHE */
           ENDDO
          ENDDO
         ENDDO
        ENDIF

C     end bi,bj loops
       ENDDO
      ENDDO

#endif /* ALLOW_BLING */

      RETURN
      END

#include "CPP_OPTIONS.h"

C--  File rotate_uv2en.F: Routines to handle a vector coordinate system rotation.
C--   Contents
C--   o ROTATE_UV2EN_RL
C--   o ROTATE_UV2EN_RS

      subroutine rotate_uv2en_rl(
     U          uFldX, vFldY,
     U          uFldE, vFldN,
     I          xy2en, switchGrid, applyMask, kSize, mythid
     &                     )

c     ==================================================================
c     SUBROUTINE rotate_uv2en_rl
c     ==================================================================
c
c     o uFldX/vFldY are in the model grid directions. 
c     o uFldE/vFldN are eastward/northward.
c     o This routine goes from uFldX/vFldY to uFldE/vFldN (for xy2en=.TRUE.) 
c         or vice versa (for xy2en=.FALSE.).
c     o uFldX/vFldY may be at the C grid velocity points, or at the A grid
c         velocity points (i.e. the C grid cell center). uFldE/vFldN are always 
c         at the cell center. If switchGrid=.TRUE. we go from C grid uFldX/vFldY
c         to A grid uFldE/vFldN, or vice versa. If switchGrid=.FALSE. we go
c         from A grid uFldX/vFldY to A grid uFldE/vFldN, or vice versa.
c     o If applyMask=.TRUE. then masks are applied to the output.
c         If kSize=1 (resp. nr) we then use the surface (resp. 3D) masks.
c     o In any case it is assumed that exchanges are done on the outside.
c
c     ==================================================================
c     SUBROUTINE rotate_uv2en_rl
c     ==================================================================

      implicit none

c     == global variables ==

#include "EEPARAMS.h"
#include "SIZE.h"
#include "PARAMS.h"
#include "GRID.h"

c     == routine arguments ==

      integer kSize 
      logical xy2en, switchGrid, applyMask
      _RL     uFldX(1-olx:snx+olx,1-oly:sny+oly,kSize,nsx,nsy)
      _RL     vFldY(1-olx:snx+olx,1-oly:sny+oly,kSize,nsx,nsy)
      _RL     uFldE(1-olx:snx+olx,1-oly:sny+oly,kSize,nsx,nsy)
      _RL     vFldN(1-olx:snx+olx,1-oly:sny+oly,kSize,nsx,nsy)

      integer mythid

c     == local variables ==

      integer bi,bj
      integer i,j,k,kk
      _RL     tmpU(1-olx:snx+olx,1-oly:sny+oly)
      _RL     tmpV(1-olx:snx+olx,1-oly:sny+oly)
      CHARACTER*(MAX_LEN_MBUF) msgBuf

c     == end of interface ==

      if ( (kSize.NE.1).AND.(kSize.NE.nr)
     &   .AND.(applyMask) ) then
        WRITE(msgBuf,'(2A,I4,A)') ' ROTATE_UV2EN: ',
     &       'no mask has ',kSize,' levels'
        CALL PRINT_ERROR(msgBuf, myThid)      
        STOP 'ABNROMAL END: S/R ROTATE_UV2EN' 
      endif

      do bj = mybylo(mythid),mybyhi(mythid)
       do bi = mybxlo(mythid),mybxhi(mythid)
        do k = 1,kSize

        if ( (kSize.EQ.1).AND.(usingPCoords) ) then
          kk=nr
        else
          kk=k
        endif

        if ( xy2en ) then
c go from uFldX/vFldY to uFldE/vFldN
        if ( switchGrid ) then
C 1a) go from C grid velocity points to A grid velocity points
        do i = 1-olx,snx+olx
          tmpU(i,sny+Oly)=0.
          tmpV(i,sny+Oly)=0.
        enddo
        do j = 1-oly,sny+oly-1
          tmpU(snx+Olx,j)=0.
          tmpV(snx+Olx,j)=0.
        do i = 1-olx,snx+olx-1
          tmpU(i,j) = 0.5 _d 0
     &          *( uFldX(i+1,j,k,bi,bj) + uFldX(i,j,k,bi,bj) )
          tmpV(i,j) = 0.5 _d 0
     &          *( vFldY(i,j+1,k,bi,bj) + vFldY(i,j,k,bi,bj) )
          if (applyMask) then
            tmpU(i,j) = tmpU(i,j) * maskC(i,j,kk,bi,bj)
            tmpV(i,j) = tmpV(i,j) * maskC(i,j,kk,bi,bj)
          endif
          enddo
          enddo
        else
C 1b) stay at A grid velocity points (i.e. at the C grid cell center)
          do j = 1-oly,sny+oly
          do i = 1-olx,snx+olx
            tmpU(i,j) = uFldX(i,j,k,bi,bj)
            tmpV(i,j) = vFldY(i,j,k,bi,bj)
            if (applyMask) then
              tmpU(i,j) = tmpU(i,j) * maskC(i,j,kk,bi,bj)
              tmpV(i,j) = tmpV(i,j) * maskC(i,j,kk,bi,bj)
            endif
          enddo
          enddo
        endif!if ( switchGrid ) then

C 2) rotation
          do j = 1-oly,sny+oly
          do i = 1-olx,snx+olx
            uFldE(i,j,k,bi,bj) = 
     &         angleCosC(i,j,bi,bj)*tmpU(i,j)
     &        -angleSinC(i,j,bi,bj)*tmpV(i,j)
            vFldN(i,j,k,bi,bj) = 
     &         angleSinC(i,j,bi,bj)*tmpU(i,j)
     &        +angleCosC(i,j,bi,bj)*tmpV(i,j)
          enddo
          enddo

      else!if (xy2en) then
c go from uFldE/vFldN to uFldX/vFldY

C 1) rotation
          do j = 1-oly,sny+oly
          do i = 1-olx,snx+olx
            tmpU(i,j) = 
     &         angleCosC(i,j,bi,bj)*uFldE(i,j,k,bi,bj)
     &        +angleSinC(i,j,bi,bj)*vFldN(i,j,k,bi,bj)
            tmpV(i,j) =
     &        -angleSinC(i,j,bi,bj)*uFldE(i,j,k,bi,bj)
     &        +angleCosC(i,j,bi,bj)*vFldN(i,j,k,bi,bj)
          enddo
          enddo

        if ( switchGrid ) then
C 2a) go from A grid velocity points to C grid velocity points
          do i = 1-olx,snx+olx
            uFldX(i,1,k,bi,bj)=0.
            vFldY(i,1,k,bi,bj)=0.
          enddo
          do j = 1-oly+1,sny+oly
             uFldX(1,j,k,bi,bj)=0.
             vFldY(1,j,k,bi,bj)=0.
          do i = 1-olx+1,snx+olx
            uFldX(i,j,k,bi,bj) = 0.5 _d 0
     &         *( tmpU(i-1,j) + tmpU(i,j) )
            vFldY(i,j,k,bi,bj) = 0.5 _d 0
     &         *( tmpV(i,j-1) + tmpV(i,j) )
            if (applyMask) then
              uFldX(i,j,k,bi,bj)=uFldX(i,j,k,bi,bj)*maskW(i,j,kk,bi,bj)
              vFldY(i,j,k,bi,bj)=vFldY(i,j,k,bi,bj)*maskS(i,j,kk,bi,bj)
            endif
          enddo
          enddo
        else
C 2b) stay at A grid velocity points (i.e. at the C grid cell center)
          do j = 1-oly,sny+oly
          do i = 1-olx,snx+olx
            uFldX(i,j,k,bi,bj) = tmpU(i,j)
            vFldY(i,j,k,bi,bj) = tmpV(i,j)
            if (applyMask) then
              uFldX(i,j,k,bi,bj)=uFldX(i,j,k,bi,bj)*maskC(i,j,kk,bi,bj)
              vFldY(i,j,k,bi,bj)=vFldY(i,j,k,bi,bj)*maskC(i,j,kk,bi,bj)
            endif
          enddo
          enddo
        endif!if ( switchGrid ) then

        endif!if (xy2en) then

        enddo
       enddo
      enddo

      return
      end

      subroutine rotate_uv2en_rs(
     U          uFldX, vFldY,
     U          uFldE, vFldN,
     I          xy2en, switchGrid, applyMask, kSize, mythid
     &                     )

c     ==================================================================
c     SUBROUTINE rotate_uv2en_rs
c     ==================================================================
c
c     o uFldX/vFldY are in the model grid directions. 
c     o uFldE/vFldN are eastward/northward.
c     o This routine goes from uFldX/vFldY to uFldE/vFldN (for xy2en=.TRUE.) 
c         or vice versa (for xy2en=.FALSE.).
c     o uFldX/vFldY may be at the C grid velocity points, or at the A grid
c         velocity points (i.e. the C grid cell center). uFldE/vFldN are always 
c         at the cell center. If switchGrid=.TRUE. we go from C grid uFldX/vFldY
c         to A grid uFldE/vFldN, or vice versa. If switchGrid=.FALSE. we go
c         from A grid uFldX/vFldY to A grid uFldE/vFldN, or vice versa.
c     o If applyMask=.TRUE. then masks are applied to the output.
c         If kSize=1 (resp. nr) we then use the surface (resp. 3D) masks.
c     o In any case it is assumed that exchanges are done on the outside.
c
c     ==================================================================
c     SUBROUTINE rotate_uv2en_rs
c     ==================================================================

      implicit none

c     == global variables ==

#include "EEPARAMS.h"
#include "SIZE.h"
#include "PARAMS.h"
#include "GRID.h"

c     == routine arguments ==

      integer kSize 
      logical xy2en, switchGrid, applyMask
      _RS     uFldX(1-olx:snx+olx,1-oly:sny+oly,kSize,nsx,nsy)
      _RS     vFldY(1-olx:snx+olx,1-oly:sny+oly,kSize,nsx,nsy)
      _RS     uFldE(1-olx:snx+olx,1-oly:sny+oly,kSize,nsx,nsy)
      _RS     vFldN(1-olx:snx+olx,1-oly:sny+oly,kSize,nsx,nsy)

      integer mythid

c     == local variables ==

      integer bi,bj
      integer i,j,k,kk
      _RS     tmpU(1-olx:snx+olx,1-oly:sny+oly)
      _RS     tmpV(1-olx:snx+olx,1-oly:sny+oly)
      CHARACTER*(MAX_LEN_MBUF) msgBuf

c     == end of interface ==

      if ( (kSize.NE.1).AND.(kSize.NE.nr)
     &   .AND.(applyMask) ) then
        WRITE(msgBuf,'(2A,I4,A)') ' ROTATE_UV2EN: ',
     &       'no mask has ',kSize,' levels'
        CALL PRINT_ERROR(msgBuf, myThid)      
        STOP 'ABNROMAL END: S/R ROTATE_UV2EN' 
      endif

      do bj = mybylo(mythid),mybyhi(mythid)
       do bi = mybxlo(mythid),mybxhi(mythid)
        do k = 1,kSize

        if ( (kSize.EQ.1).AND.(usingPCoords) ) then
          kk=nr
        else
          kk=k
        endif

        if ( xy2en ) then
c go from uFldX/vFldY to uFldE/vFldN
        if ( switchGrid ) then
C 1a) go from C grid velocity points to A grid velocity points
        do i = 1-olx,snx+olx
          tmpU(i,sny+Oly)=0.
          tmpV(i,sny+Oly)=0.
        enddo
        do j = 1-oly,sny+oly-1
          tmpU(snx+Olx,j)=0.
          tmpV(snx+Olx,j)=0.
        do i = 1-olx,snx+olx-1
          tmpU(i,j) = 0.5 _d 0
     &          *( uFldX(i+1,j,k,bi,bj) + uFldX(i,j,k,bi,bj) )
          tmpV(i,j) = 0.5 _d 0
     &          *( vFldY(i,j+1,k,bi,bj) + vFldY(i,j,k,bi,bj) )
          if (applyMask) then
            tmpU(i,j) = tmpU(i,j) * maskC(i,j,kk,bi,bj)
            tmpV(i,j) = tmpV(i,j) * maskC(i,j,kk,bi,bj)
          endif
          enddo
          enddo
        else
C 1b) stay at A grid velocity points (i.e. at the C grid cell center)
          do j = 1-oly,sny+oly
          do i = 1-olx,snx+olx
            tmpU(i,j) = uFldX(i,j,k,bi,bj)
            tmpV(i,j) = vFldY(i,j,k,bi,bj)
            if (applyMask) then
              tmpU(i,j) = tmpU(i,j) * maskC(i,j,kk,bi,bj)
              tmpV(i,j) = tmpV(i,j) * maskC(i,j,kk,bi,bj)
            endif
          enddo
          enddo
        endif!if ( switchGrid ) then

C 2) rotation
          do j = 1-oly,sny+oly
          do i = 1-olx,snx+olx
            uFldE(i,j,k,bi,bj) = 
     &         angleCosC(i,j,bi,bj)*tmpU(i,j)
     &        -angleSinC(i,j,bi,bj)*tmpV(i,j)
            vFldN(i,j,k,bi,bj) = 
     &         angleSinC(i,j,bi,bj)*tmpU(i,j)
     &        +angleCosC(i,j,bi,bj)*tmpV(i,j)
          enddo
          enddo

      else!if (xy2en) then
c go from uFldE/vFldN to uFldX/vFldY

C 1) rotation
          do j = 1-oly,sny+oly
          do i = 1-olx,snx+olx
            tmpU(i,j) = 
     &         angleCosC(i,j,bi,bj)*uFldE(i,j,k,bi,bj)
     &        +angleSinC(i,j,bi,bj)*vFldN(i,j,k,bi,bj)
            tmpV(i,j) =
     &        -angleSinC(i,j,bi,bj)*uFldE(i,j,k,bi,bj)
     &        +angleCosC(i,j,bi,bj)*vFldN(i,j,k,bi,bj)
          enddo
          enddo

        if ( switchGrid ) then
C 2a) go from A grid velocity points to C grid velocity points
          do i = 1-olx,snx+olx
            uFldX(i,1,k,bi,bj)=0.
            vFldY(i,1,k,bi,bj)=0.
          enddo
          do j = 1-oly+1,sny+oly
             uFldX(1,j,k,bi,bj)=0.
             vFldY(1,j,k,bi,bj)=0.
          do i = 1-olx+1,snx+olx
            uFldX(i,j,k,bi,bj) = 0.5 _d 0
     &         *( tmpU(i-1,j) + tmpU(i,j) )
            vFldY(i,j,k,bi,bj) = 0.5 _d 0
     &         *( tmpV(i,j-1) + tmpV(i,j) )
            if (applyMask) then
              uFldX(i,j,k,bi,bj)=uFldX(i,j,k,bi,bj)*maskW(i,j,kk,bi,bj)
              vFldY(i,j,k,bi,bj)=vFldY(i,j,k,bi,bj)*maskS(i,j,kk,bi,bj)
            endif
          enddo
          enddo
        else
C 2b) stay at A grid velocity points (i.e. at the C grid cell center)
          do j = 1-oly,sny+oly
          do i = 1-olx,snx+olx
            uFldX(i,j,k,bi,bj) = tmpU(i,j)
            vFldY(i,j,k,bi,bj) = tmpV(i,j)
            if (applyMask) then
              uFldX(i,j,k,bi,bj)=uFldX(i,j,k,bi,bj)*maskC(i,j,kk,bi,bj)
              vFldY(i,j,k,bi,bj)=vFldY(i,j,k,bi,bj)*maskC(i,j,kk,bi,bj)
            endif
          enddo
          enddo
        endif!if ( switchGrid ) then

        endif!if (xy2en) then

        enddo
       enddo
      enddo

      return
      end

#include "MNC_OPTIONS.h"

C--  File mnc_cwrapper.F:
C--   Contents
C--   o MNC_CW_ADD_GNAME
C--   o MNC_CW_DEL_GNAME
C--   o MNC_CW_DUMP
C--   o MNC_CW_APPEND_VNAME
C--   o MNC_CW_ADD_VNAME
C--   o MNC_CW_DEL_VNAME
C--   o MNC_CW_ADD_VATTR_TEXT
C--   o MNC_CW_ADD_VATTR_INT
C--   o MNC_CW_ADD_VATTR_DBL
C--   o MNC_CW_ADD_VATTR_ANY
C--   o MNC_CW_GET_TILE_NUM
C--   o MNC_CW_GET_FACE_NUM
C--   o MNC_CW_GET_XYFO
C--   o MNC_CW_FILE_AORC

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 0
C     !ROUTINE: MNC_CW_ADD_GNAME

C     !INTERFACE:
      SUBROUTINE MNC_CW_ADD_GNAME(
     I     name,
     I     ndim,
     I     dlens,
     I     dnames,
     I     inds_beg, inds_end,
     I     myThid )

C     !DESCRIPTION:
C     Add a grid name to the MNC convenience wrapper layer.

C     !USES:
      implicit none
#include "MNC_COMMON.h"
#include "EEPARAMS.h"

C     !INPUT PARAMETERS:
      integer myThid, ndim
      character*(*) name
      integer dlens(*), inds_beg(*), inds_end(*)
      character*(*) dnames(*)
CEOP

C     !LOCAL VARIABLES:
      integer i, nnf,nnl, indg
      character*(MAX_LEN_MBUF) msgbuf

C     Functions
      integer IFNBLNK, ILNBLNK

      nnf = IFNBLNK(name)
      nnl = ILNBLNK(name)

C     Check that this name is not already defined
      CALL MNC_GET_IND(MNC_MAX_ID, name, mnc_cw_gname, indg, myThid)
      IF (indg .GT. 0) THEN
        write(msgbuf,'(3a)') 'MNC_CW_ADD_GNAME ERROR: ''', name,
     &       ''' is already defined'
        CALL print_error(msgbuf, mythid)
        stop 'ABNORMAL END: S/R MNC_CW_ADD_GNAME'
      ENDIF
      CALL MNC_GET_NEXT_EMPTY_IND(MNC_MAX_ID, mnc_cw_gname,
     &     'mnc_cw_gname', indg, myThid)

      mnc_cw_gname(indg)(1:MNC_MAX_CHAR)=mnc_blank_name(1:MNC_MAX_CHAR)
      mnc_cw_gname(indg)(1:(nnl-nnf+1)) = name(nnf:nnl)
      mnc_cw_ndim(indg) = ndim

      DO i = 1,ndim
        mnc_cw_dn(i,indg)(1:MNC_MAX_CHAR)=mnc_blank_name(1:MNC_MAX_CHAR)
        nnf = IFNBLNK(dnames(i))
        nnl = ILNBLNK(dnames(i))
        mnc_cw_dn(i,indg)(1:(nnl-nnf+1)) = dnames(i)(nnf:nnl)
        mnc_cw_dims(i,indg) = dlens(i)
        mnc_cw_is(i,indg)   = inds_beg(i)
        mnc_cw_ie(i,indg)   = inds_end(i)
      ENDDO

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 0
C     !ROUTINE: MNC_CW_DEL_GNAME

C     !INTERFACE:
      SUBROUTINE MNC_CW_DEL_GNAME(
     I     name,
     I     myThid )

C     !DESCRIPTION:
C     Delete a grid name from the MNC convenience wrapper layer.

C     !USES:
      implicit none
#include "MNC_COMMON.h"
#include "EEPARAMS.h"

C     !INPUT PARAMETERS:
      integer myThid
      character*(*) name
CEOP

C     !LOCAL VARIABLES:
      integer nnf,nnl, indg

C     Functions
      integer IFNBLNK, ILNBLNK

      nnf = IFNBLNK(name)
      nnl = ILNBLNK(name)

C     Check that this name is not already defined
      CALL MNC_GET_IND(MNC_MAX_ID, name, mnc_cw_gname, indg, myThid)
      IF (indg .LT. 1) THEN
        RETURN
      ENDIF

      mnc_cw_gname(indg)(1:MNC_MAX_CHAR)=mnc_blank_name(1:MNC_MAX_CHAR)
      mnc_cw_ndim(indg) = 0

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 1
C     !ROUTINE: MNC_CW_DUMP

C     !INTERFACE:
      SUBROUTINE MNC_CW_DUMP( myThid )

C     !DESCRIPTION:
C     Write a condensed view of the current state of the MNC look-up
C     tables for the convenience wrapper section.

C     !USES:
      implicit none
#include "MNC_COMMON.h"
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"

C     !INPUT PARAMETERS:
      integer myThid
CEOP

C     !LOCAL VARIABLES:
      integer i,j, ntot
      integer NBLNK
      parameter ( NBLNK = 150 )
      character s1*(NBLNK), blnk*(NBLNK)

      _BEGIN_MASTER(myThid)

      DO i = 1,NBLNK
        blnk(i:i) = ' '
      ENDDO

      s1(1:NBLNK) = blnk(1:NBLNK)
      write(s1,'(a5,a)') 'MNC: ',
     &     'The currently defined Grid Types are:'
      CALL PRINT_MESSAGE(
     &     s1, standardMessageUnit, SQUEEZE_RIGHT, mythid)
      ntot = 0
      DO j = 1,MNC_MAX_ID
        IF (mnc_cw_gname(j)(1:MNC_MAX_CHAR)
     &       .NE. mnc_blank_name(1:MNC_MAX_CHAR)) THEN

          ntot = ntot + 1
          s1(1:NBLNK) = blnk(1:NBLNK)
          write(s1,'(a5,2i5,a3,a20,i3,a3,5i4,a4,5i4,a4,5i4,6a8)')
     &         'MNC: ',
     &         j, ntot, ' : ', mnc_cw_gname(j)(1:20), mnc_cw_ndim(j),
     &         ' : ', (mnc_cw_dims(i,j), i=1,5),
     &         '  | ', (mnc_cw_is(i,j), i=1,5),
     &         '  | ', (mnc_cw_ie(i,j), i=1,5),
     &         '  | ', (mnc_cw_dn(i,j)(1:7), i=1,5)
          CALL PRINT_MESSAGE(
     &         s1, standardMessageUnit, SQUEEZE_RIGHT, mythid)

        ENDIF
      ENDDO

      s1(1:NBLNK) = blnk(1:NBLNK)
      write(s1,'(a5,a)') 'MNC: ',
     &     'The currently defined Variable Types are:'
      CALL PRINT_MESSAGE(
     &     s1, standardMessageUnit, SQUEEZE_RIGHT, mythid)
      ntot = 0
      DO j = 1,MNC_MAX_ID
        IF (mnc_cw_vname(j)(1:MNC_MAX_CHAR)
     &       .NE. mnc_blank_name(1:MNC_MAX_CHAR)) THEN

          ntot = ntot + 1
          s1(1:NBLNK) = blnk(1:NBLNK)
          write(s1,'(a5,2i5,a3,a25,a3,i4)') 'MNC: ',
     &         j, ntot, ' | ',
     &         mnc_cw_vname(j)(1:20), ' | ', mnc_cw_vgind(j)
          CALL PRINT_MESSAGE(
     &         s1, standardMessageUnit, SQUEEZE_RIGHT, mythid)

          DO i = 1,mnc_cw_vnat(1,j)
            s1(1:NBLNK) = blnk(1:NBLNK)
            write(s1,'(a5,a14,i4,a3,a25,a3,a55)')
     &           'MNC: ','      text_at:',i,
     &           ' : ', mnc_cw_vtnm(i,j)(1:25), ' : ',
     &           mnc_cw_vtat(i,j)(1:MNC_MAX_CHAR)
            CALL PRINT_MESSAGE(
     &           s1, standardMessageUnit, SQUEEZE_RIGHT, mythid)
          ENDDO
          DO i = 1,mnc_cw_vnat(2,j)
            s1(1:NBLNK) = blnk(1:NBLNK)
            write(s1,'(a5,a14,i4,a3,a25,a3,i20)')
     &           'MNC: ','      int__at:',i,
     &           ' : ', mnc_cw_vinm(i,j)(1:25), ' : ',
     &           mnc_cw_viat(i,j)
            CALL PRINT_MESSAGE(
     &           s1, standardMessageUnit, SQUEEZE_RIGHT, mythid)
          ENDDO
          DO i = 1,mnc_cw_vnat(3,j)
            s1(1:NBLNK) = blnk(1:NBLNK)
            write(s1,'(a5,a14,i4,a3,a25,a3,f25.10)')
     &           'MNC: ','      dbl__at:',i,
     &           ' : ', mnc_cw_vdnm(i,j)(1:25), ' : ',
     &           mnc_cw_vdat(i,j)
            CALL PRINT_MESSAGE(
     &           s1, standardMessageUnit, SQUEEZE_RIGHT, mythid)
        ENDDO

        ENDIF
      ENDDO
      IF (ntot .EQ. 0) THEN
        s1(1:NBLNK) = blnk(1:NBLNK)
        write(s1,'(a)') 'MNC:    None defined!'
        CALL PRINT_MESSAGE(
     &       s1, standardMessageUnit, SQUEEZE_RIGHT, mythid)
      ENDIF

      _END_MASTER(myThid)

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 0
C     !ROUTINE: MNC_CW_APPEND_VNAME

C     !INTERFACE:
      SUBROUTINE MNC_CW_APPEND_VNAME(
     I     vname,
     I     gname,
     I     bi_dim, bj_dim,
     I     myThid )

C     !DESCRIPTION:
C     If it is not yet defined within the MNC CW layer, append a
C     variable type.  Calls MNC\_CW\_ADD\_VNAME().

C     !USES:
      implicit none
#include "MNC_COMMON.h"

C     !INPUT PARAMETERS:
      integer myThid, bi_dim, bj_dim
      character*(*) vname, gname
CEOP

C     !LOCAL VARIABLES:
      integer indv

C     Check whether vname is defined
      CALL MNC_GET_IND(MNC_MAX_ID, vname, mnc_cw_vname, indv, myThid)
      IF (indv .LT. 1) THEN
        CALL MNC_CW_ADD_VNAME(vname, gname, bi_dim, bj_dim, myThid)
      ENDIF


      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 0
C     !ROUTINE: MNC_CW_ADD_VNAME

C     !INTERFACE:
      SUBROUTINE MNC_CW_ADD_VNAME(
     I     vname,
     I     gname,
     I     bi_dim, bj_dim,
     I     myThid )

C     !DESCRIPTION:
C     Add a variable type to the MNC CW layer.  The variable type is an
C     association between a variable type name and the following items:
C     \begin{center}
C       \begin{tabular}[h]{|ll|}\hline
C         \textbf{Item}  & \textbf{Purpose}  \\\hline
C         grid type  &  defines the in-memory arrangement  \\
C         \texttt{bi,bj} dimensions  &  tiling indices, if present  \\\hline
C       \end{tabular}
C     \end{center}

C     !USES:
      implicit none
#include "MNC_COMMON.h"
#include "EEPARAMS.h"

C     !INPUT PARAMETERS:
      integer myThid, bi_dim, bj_dim
      character*(*) vname, gname
CEOP

C     !LOCAL VARIABLES:
      integer i, nvf,nvl, ngf,ngl, indv,indg
      character*(MAX_LEN_MBUF) msgbuf

C     Functions
      integer IFNBLNK, ILNBLNK

      nvf = IFNBLNK(vname)
      nvl = ILNBLNK(vname)
      ngf = IFNBLNK(gname)
      ngl = ILNBLNK(gname)

C     Check that this vname is not already defined
      CALL MNC_GET_IND(MNC_MAX_ID, vname, mnc_cw_vname, indv, myThid)
      IF (indv .GT. 0) THEN
        write(msgbuf,'(3a)') 'MNC_CW_ADD_VNAME ERROR: ''',
     &       vname(nvf:nvl), ''' is already defined'
        CALL print_error(msgbuf, mythid)
        stop 'ABNORMAL END: S/R MNC_CW_ADD_VNAME'
      ENDIF
      CALL MNC_GET_NEXT_EMPTY_IND(MNC_MAX_ID, mnc_cw_vname,
     &     'mnc_cw_vname', indv, myThid)

C     Check that gname exists
      CALL MNC_GET_IND(MNC_MAX_ID, gname, mnc_cw_gname, indg, myThid)
      IF (indg .LT. 1) THEN
        write(msgbuf,'(3a)') 'MNC_CW_ADD_VNAME ERROR: ''',
     &       gname(ngf:ngl), ''' is not defined'
        CALL print_error(msgbuf, mythid)
        stop 'ABNORMAL END: S/R MNC_CW_ADD_VNAME'
      ENDIF

      mnc_cw_vname(indv)(1:MNC_MAX_CHAR)=mnc_blank_name(1:MNC_MAX_CHAR)
      mnc_cw_vname(indv)(1:(nvl-nvf+1)) = vname(nvf:nvl)
      mnc_cw_vgind(indv) = indg
      DO i = 1,3
        mnc_cw_vnat(i,indv) = 0
      ENDDO
      mnc_cw_vbij(1,indv) = bi_dim
      mnc_cw_vbij(2,indv) = bj_dim

#ifdef MNC_DEBUG_GTYPE
      CALL MNC_CW_ADD_VATTR_TEXT(vname,1,'mitgcm_grid',gname, myThid)
#endif

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 0
C     !ROUTINE: MNC_CW_DEL_VNAME

C     !INTERFACE:
      SUBROUTINE MNC_CW_DEL_VNAME(
     I     vname,
     I     myThid )

C     !DESCRIPTION:
C     Delete a variable type from the MNC CW layer.

C     !USES:
      implicit none
#include "MNC_COMMON.h"
#include "EEPARAMS.h"

C     !INPUT PARAMETERS:
      integer myThid
      character*(*) vname
CEOP

C     !LOCAL VARIABLES:
      integer i, indv

C     Check that this vname is not already defined
      CALL MNC_GET_IND(MNC_MAX_ID, vname, mnc_cw_vname, indv, myThid)
      IF (indv .LT. 1) THEN
        RETURN
      ENDIF

      mnc_cw_vname(indv)(1:MNC_MAX_CHAR)=mnc_blank_name(1:MNC_MAX_CHAR)
      mnc_cw_vgind(indv) = 0
      DO i = 1,3
        mnc_cw_vnat(i,indv) = 0
      ENDDO

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: MNC_CW_ADD_VATTR_TEXT
C     !INTERFACE:
      SUBROUTINE MNC_CW_ADD_VATTR_TEXT(
     I     vname, tname, tval,
     I     myThid )

C     !DESCRIPTION:
C     Add a text attribute

C     !USES:
      implicit none

C     !INPUT PARAMETERS:
      integer myThid
      character*(*) vname, tname, tval
      integer ival
      REAL*8 dval
CEOP
      ival = 0
      dval = 0.0D0
      CALL MNC_CW_ADD_VATTR_ANY(vname, 1,
     &     tname, ' ', ' ', tval, ival, dval, myThid )
      RETURN
      END
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: MNC_CW_ADD_VATTR_INT
C     !INTERFACE:
      SUBROUTINE MNC_CW_ADD_VATTR_INT(
     I     vname, iname, ival,
     I     myThid )

C     !DESCRIPTION:
C     Add integer attribute

C     !USES:
      implicit none

C     !INPUT PARAMETERS:
      integer myThid
      character*(*) vname, iname
      integer ival
      REAL*8 dval
CEOP
      dval = 0.0D0
      CALL MNC_CW_ADD_VATTR_ANY(vname, 2,
     &     ' ', iname, ' ', ' ', ival, dval, myThid )
      RETURN
      END
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C !ROUTINE: MNC_CW_ADD_VATTR_DBL
C !INTERFACE:
      SUBROUTINE MNC_CW_ADD_VATTR_DBL(
     I     vname, dname, dval,
     I     myThid )

C     !DESCRIPTION:
C     Add double-precision real attribute

C     !USES:
      implicit none

C     !INPUT PARAMETERS:
      integer myThid
      character*(*) vname, dname
      integer ival
      REAL*8 dval
CEOP
      ival = 0
      CALL MNC_CW_ADD_VATTR_ANY(vname, 3,
     &     ' ', ' ', dname, ' ', ival, dval, myThid )
      RETURN
      END
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 1
C     !ROUTINE: MNC_CW_ADD_VATTR_ANY

C     !INTERFACE:
      SUBROUTINE MNC_CW_ADD_VATTR_ANY(
     I     vname,
     I     atype,
     I     tname, iname, dname,
     I     tval,  ival,  dval,
     I     myThid )

C     !DESCRIPTION:

C     !USES:
      implicit none
#include "MNC_COMMON.h"
#include "EEPARAMS.h"

C     !INPUT PARAMETERS:
      integer myThid
      integer atype
      character*(*) vname
      character*(*) tname, iname, dname
      character*(*) tval
      integer ival
      REAL*8 dval
CEOP

C     !LOCAL VARIABLES:
      integer n, nvf,nvl, n1,n2, indv, ic
      character*(MAX_LEN_MBUF) msgbuf

C     Functions
      integer IFNBLNK, ILNBLNK

      nvf = IFNBLNK(vname)
      nvl = ILNBLNK(vname)

C     Check that vname is defined
      CALL MNC_GET_IND(MNC_MAX_ID, vname, mnc_cw_vname, indv, myThid)
      IF (indv .LT. 1) THEN
        write(msgbuf,'(3a)') 'MNC_CW_ADD_VATTR_ANY ERROR: ''',
     &       vname(nvf:nvl), ''' is not defined'
        CALL print_error(msgbuf, mythid)
        stop 'ABNORMAL END: S/R MNC_CW_ADD_VATTR_ANY'
      ENDIF

      IF (atype .EQ. 1) THEN
C       Text Attribute
        n = mnc_cw_vnat(1,indv) + 1
        n1 = IFNBLNK(tname)
        n2 = ILNBLNK(tname)
        IF ((n2-n1+1) .GT. MNC_MAX_CHAR) THEN
          write(msgbuf,'(3a,i6,2a)')
     &         'MNC_CW_ADD_VATTR_ANY WARNING: attribute name ''',
     &         tname(n1:n2), ''' has more than ', MNC_MAX_CHAR,
     &         ' characters and has been truncated to fit--please',
     &         'use a smaller name or increase MNC_MAX_CHAR'
          CALL PRINT_MESSAGE( msgbuf, errorMessageUnit,
     &                        SQUEEZE_RIGHT , myThid)
C         MNC_MAX_CHAR = n2 - n1 + 1
          n2 = MNC_MAX_CHAR + n1 - 1
        ENDIF
C       write(*,*) atype,tname(n1:n2)
        mnc_cw_vtnm(n,indv)(1:MNC_MAX_CHAR) =
     &       mnc_blank_name(1:MNC_MAX_CHAR)
        mnc_cw_vtnm(n,indv)(1:(n2-n1+1)) = tname(n1:n2)

        n1 = IFNBLNK(tval)
        n2 = ILNBLNK(tval)
        IF ((n2-n1+1) .GT. MNC_MAX_CATT) THEN
          write(msgbuf,'(3a,i6,2a)')
     &         'MNC_CW_ADD_VATTR_ANY WARNING: attribute value ''',
     &         tval(n1:n2), ''' has more than ', MNC_MAX_CATT,
     &         ' characters and has been truncated to fit--please',
     &         'use a smaller name or increase MNC_MAX_CATT'
          CALL PRINT_MESSAGE( msgbuf, errorMessageUnit,
     &                        SQUEEZE_RIGHT , myThid)
          n2 = MNC_MAX_CATT + n1 - 1
        ENDIF

        mnc_cw_vnat(1,indv) = n
        DO ic = 1,MNC_MAX_CATT
          mnc_cw_vtat(n,indv)(ic:ic) = ' '
        ENDDO
        IF ((n1 .NE. 0) .AND. (n2 .NE. 0)) THEN
          mnc_cw_vtat(n,indv)(1:(n2-n1+1)) = tval(n1:n2)
        ENDIF
      ENDIF

      IF (atype .EQ. 2) THEN
C       Integer Attribute
        n = mnc_cw_vnat(2,indv) + 1
        n1 = IFNBLNK(iname)
        n2 = ILNBLNK(iname)
C       write(*,*) atype,iname(n1:n2)
        mnc_cw_vinm(n,indv)(1:(n2-n1+1)) = iname(n1:n2)
        mnc_cw_viat(n,indv) = ival
        mnc_cw_vnat(2,indv) = n
      ENDIF

      IF (atype .EQ. 3) THEN
C       Double Attribute
        n = mnc_cw_vnat(3,indv) + 1
        n1 = IFNBLNK(dname)
        n2 = ILNBLNK(dname)
C       write(*,*) atype,dname(n1:n2)
        mnc_cw_vdnm(n,indv)(1:(n2-n1+1)) = dname(n1:n2)
        mnc_cw_vdat(n,indv) = dval
        mnc_cw_vnat(3,indv) = n
      ENDIF

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 1
C     !ROUTINE: MNC_CW_GET_TILE_NUM

C     !INTERFACE:
      SUBROUTINE MNC_CW_GET_TILE_NUM(
     I     bi, bj,
     O     uniq_tnum,
     I     myThid )

C     !DESCRIPTION:

C     !USES:
      implicit none
#include "EEPARAMS.h"
#include "SIZE.h"
#ifdef ALLOW_EXCH2
#include "W2_EXCH2_SIZE.h"
#include "W2_EXCH2_TOPOLOGY.h"
#endif

C     !INPUT PARAMETERS:
      integer myThid, bi,bj, uniq_tnum
CEOP

C     !LOCAL VARIABLES:
      integer iG,jG

      iG = 0
      jG = 0

#ifdef ALLOW_EXCH2

      uniq_tnum = W2_myTileList(bi,bj)

#else

C     Global tile number for simple (non-cube) domains
      iG = bi+(myXGlobalLo-1)/sNx
      jG = bj+(myYGlobalLo-1)/sNy

      uniq_tnum = (jG - 1)*(nPx*nSx) + iG

#endif

CEH3      write(*,*) 'iG,jG,uniq_tnum :', iG,jG,uniq_tnum

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 1
C     !ROUTINE: MNC_CW_GET_FACE_NUM

C     !INTERFACE:
      SUBROUTINE MNC_CW_GET_FACE_NUM(
     I     bi, bj,
     O     uniq_fnum,
     I     myThid )

C     !DESCRIPTION:

C     !USES:
      implicit none
#include "EEPARAMS.h"
#include "SIZE.h"
#ifdef ALLOW_EXCH2
#include "W2_EXCH2_SIZE.h"
#include "W2_EXCH2_TOPOLOGY.h"
#endif

C     !INPUT PARAMETERS:
      integer myThid, bi,bj, uniq_fnum
CEOP

#ifdef ALLOW_EXCH2

      uniq_fnum = exch2_myFace( W2_myTileList(bi,bj) )

#else

C     Global face number for simple (EXCH "1") domains
      uniq_fnum = -1

#endif

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 1
C     !ROUTINE: MNC_CW_GET_XYFO

C     !INTERFACE:
      SUBROUTINE MNC_CW_GET_XYFO(
     I     bi, bj,
     O     ixoff, iyoff,
     I     myThid )

C     !DESCRIPTION:

C     !USES:
      implicit none
#include "EEPARAMS.h"
#include "SIZE.h"
#ifdef ALLOW_EXCH2
#include "W2_EXCH2_SIZE.h"
#include "W2_EXCH2_TOPOLOGY.h"
#endif

C     !INPUT PARAMETERS:
      integer myThid, bi,bj, ixoff,iyoff
CEOP

C     !LOCAL VARIABLES:
#ifdef ALLOW_EXCH2
      integer uniq_tnum
#endif

#ifdef ALLOW_EXCH2

      uniq_tnum = W2_myTileList(bi,bj)
      ixoff = exch2_tbasex( uniq_tnum )
      iyoff = exch2_tbasey( uniq_tnum )

#else

C     Global tile number for simple (non-cube) domains
C     iG = bi+(myXGlobalLo-1)/sNx
C     jG = bj+(myYGlobalLo-1)/sNy
C     uniq_tnum = (jG - 1)*(nPx*nSx) + iG
      ixoff = myXGlobalLo + bi * sNx
      iyoff = myYGlobalLo + bj * sNy

#endif

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP 1
C     !ROUTINE: MNC_CW_FILE_AORC

C     !INTERFACE:
      SUBROUTINE MNC_CW_FILE_AORC(
     I     fname,
     O     indf,
     I     lbi, lbj, uniq_tnum,
     I     myThid )

C     !DESCRIPTION:
C     Open a NetCDF file, appending to the file if it already exists
C     and, if not, creating a new file.

C     !USES:
      implicit none
#include "MNC_COMMON.h"
#include "EEPARAMS.h"
#include "netcdf.inc"

C     !INPUT PARAMETERS:
      integer myThid, indf, lbi, lbj, uniq_tnum
      character*(*) fname
CEOP

C     !LOCAL VARIABLES:
      integer ierr

C     Check if the file is already open
      CALL MNC_GET_IND(MNC_MAX_FID, fname, mnc_f_names, indf, myThid)
      IF (indf .GT. 0) THEN
        RETURN
      ENDIF

C     Try to open an existing file
      CALL MNC_FILE_TRY_READ(fname, ierr, indf, myThid)
      IF (ierr .NE. NF_NOERR) THEN
C       Try to create a new one
        CALL MNC_FILE_OPEN(fname, 0, indf, myThid)
      ENDIF

C     Add the global attributes
      CALL MNC_CW_SET_GATTR(fname, lbi,lbj, uniq_tnum, myThid)

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#include "CTRL_OPTIONS.h"
C- note: although we just need CPP_EEOPTIONS.h here, prefer to
C        include the same option-file above as in the AD version.

C--  File ctrl_bound_tl.F:
C--   Contents
C--   o CTRL_BOUND_3D_TL
C--   o CTRL_BOUND_2D_TL

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: CTRL_BOUND_3D_TL
C     !INTERFACE:
      SUBROUTINE CTRL_BOUND_3D_TL(
     U                fieldCur, fieldCur_tl,
     I                mask3D, boundsVec, myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | o tangent linear version of S/R CTRL_BOUND_3D. Call
C     |   S/R CTRL_BOUND_3D to apply specified bounds to control
C     |   variable, but leave tangent linear variable alone
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
      _RL fieldCur   (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      _RL fieldCur_tl(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      _RS mask3D     (1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr,nSx,nSy)
      _RL boundsVec(5)
      INTEGER myThid

      CALL CTRL_BOUND_3D(fieldCur,mask3D,boundsVec,myThid)

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C
C     !ROUTINE: CTRL_BOUND_2D_TL
C     !INTERFACE:
      SUBROUTINE CTRL_BOUND_2D_TL(
     U                fieldCur, fieldCur_tl,
     I                mask2D, boundsVec, myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | o tangent linear version of S/R CTRL_BOUND_2D. Call
C     |   S/R CTRL_BOUND_2D to apply specified bounds to control
C     |   variable, but leave tangent linear variable alone
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
      _RL fieldCur   (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL fieldCur_tl(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RS mask2D     (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL boundsVec(5)
      INTEGER myThid

      CALL CTRL_BOUND_2D(fieldCur,mask2D,boundsVec,myThid)

      RETURN
      END

#include "PACKAGES_CONFIG.h"
#include "CPP_OPTIONS.h"

CBOP
C     !ROUTINE: PACKAGES_INIT_FIXED
C     !INTERFACE:
      SUBROUTINE PACKAGES_INIT_FIXED( myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE PACKAGES_INIT_FIXED
C     | o Does initialisation of package-related fixed fields
C     *==========================================================*
C     \ev

C     !CALLING SEQUENCE:
C     PACKAGES_INIT_FIXED
C       |
C       |-- RUNCLOCK_INIT
C       |
C       |-- CAL_INIT_FIXED
C       |
C       |-- DIAGNOSTICS_INIT_EARLY
C       |-- DIAGNOSTICS_MAIN_INIT
C       |
C       |-- NEST2W_INIT_FIXED
C       |
C       |-- GAD_INIT_FIXED
C       |
C       |-- MOM_INIT_FIXED
C       |
C       |-- CD_CODE_INIT_FIXED
C       |
C       |-- OBCS_INIT_FIXED
C       |
C       |-- SHAP_FILT_INIT_FIZED
C       |
C       |-- ZONAL_FILT_INIT
C       |
C       |-- EXF_INIT_FIXED
C       |
C       |-- CHEAPAML_INIT_FIXED
C       |
C       |-- OPPS_INIT
C       |
C       |-- PP81_INIT_FIXED
C       |
C       |-- KL10_INIT_FIXED
C       |
C       |-- MY82_INIT_FIXED
C       |
C       |-- GGL90_INIT_FIXED
C       |
C       |-- KPP_INIT_FIXED
C       |
C       |-- GMREDI_INIT_FIXED
C       |
C       |-- BBL_INIT_FIXED
C       |
C       |-- DWNSLP_INIT_FIXED
C       |
C       |-- COST_INIT_FIXED
C       |
C       |-- SEAICE_COST_INIT_FIXED
C       |
C       |-- SMOOTH_INIT_FIXED
C       |
C       |-- ECCO_INIT_FIXED
C       |   |- ECCO_COST_INIT_FIXED
C       |
C       |-- PROFILES_INIT_FIXED
C       |
C       |-- OBSFIT_INIT_FIXED
C       |
C       |-- FLT_INIT_FIXED
C       |
C       |-- LONGSTEP_INIT_FIXED
C       |
C       |-- PTRACERS_INIT_FIXED
C       |
C       |-- GCHEM_INIT_FIXED
C       |
C       |-- RBCS_INIT_FIXED
C       |
C       |-- STREAMICE_INIT_FIXED
C       |
C       |-- SHELFICE_INIT_FIXED
C       |
C       |-- STIC_INIT_FIXED
C       |
C       |-- ICEFRONT_INIT_FIXED
C       |
C       |-- FRAZIL_INIT_FIXED
C       |
C       |-- SEAICE_INIT_FIXED
C       |
C       |-- SALT_PLUME_INIT_FIXED
C       |
C       |-- THSICE_INIT_FIXED
C       |
C       |-- LAND_INIT_FIXED
C       |
C       |-- ATM2D_INIT_FIXED
C       |
C       |-- AIM_INITIALISE
C       |
C       |-- ATM_PHYS_INIT_FIXED
C       |
C       |-- FIZHI_INIT_FIXED
C       |
C       |-- GRIDALT_INITIALISE
C       |
C       |-- REGRID_INIT_FIXED
C       |
C       |-- LAYERS_INIT_FIXED
C       |
C       |-- CPL_INIT_FIXED
C       |
C       |-- OASIS_INIT_FIXED
C       |
C       |-- EMBED_FILES_INIT
C       |
C       |-- MYPACKAGE_INIT_FIXED
C       |
C       |-- CTRL_INIT_FIXED
C       |-- CTRL_ADMTLM
C       |
C       |-- DIAGNOSTICS_INIT_FIXED

C     !USES:
      IMPLICIT NONE
C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
C     myThid :: my Thread Id Number
      INTEGER myThid
CEOP

#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_ENTER('PACKAGES_INIT_FIXED',myThid)
#endif

#ifdef ALLOW_RUNCLOCK
      IF ( useRunClock ) THEN
# ifdef ALLOW_DEBUG
        IF (debugMode) CALL DEBUG_CALL('RUNCLOCK_INIT',myThid)
# endif
        CALL RUNCLOCK_INIT( myThid )
      ENDIF
#endif

#ifdef ALLOW_CAL
C--   Initialise the calendar package.
      IF ( useCAL ) THEN
# ifdef ALLOW_DEBUG
        IF (debugMode) CALL DEBUG_CALL('CAL_INIT_FIXED',myThid)
# endif
        CALL CAL_INIT_FIXED( myThid )
      ENDIF
#endif /* ALLOW_CAL */

#ifdef ALLOW_DIAGNOSTICS
      IF ( useDiagnostics ) THEN
C-    needs to call DIAGNOSTICS_INIT_EARLY before all package-diag-init calls
# ifdef ALLOW_DEBUG
        IF (debugMode) CALL DEBUG_CALL('DIAGNOSTICS_INIT_EARLY',myThid)
# endif
        CALL DIAGNOSTICS_INIT_EARLY( myThid )
# ifdef ALLOW_DEBUG
        IF (debugMode) CALL DEBUG_CALL('DIAGNOSTICS_MAIN_INIT',myThid)
# endif
        CALL DIAGNOSTICS_MAIN_INIT( myThid )
      ENDIF
#endif

#ifdef ALLOW_NEST2W_COMMON
C--   Initialise the 2-Way Nesting packages
      IF ( useNest2W_parent .OR. useNest2W_child ) THEN
# ifdef ALLOW_DEBUG
        IF (debugMode) CALL DEBUG_CALL('NEST2W_INIT_FIXED',myThid)
# endif
        CALL NEST2W_INIT_FIXED( myThid )
      ENDIF
#endif /* ALLOW_NEST2W_COMMON */

#ifdef ALLOW_GENERIC_ADVDIFF
C--   Initialize fixed params for GAD
# ifdef ALLOW_DEBUG
        IF (debugMode) CALL DEBUG_CALL('GAD_INIT_FIXED',myThid)
# endif
      CALL GAD_INIT_FIXED( myThid )
#endif

#ifdef ALLOW_MOM_COMMON
C--   Initialize fixed params for Momentum pkgs (common, fluxform, vecinv)
      IF ( momStepping ) THEN
# ifdef ALLOW_DEBUG
        IF (debugMode) CALL DEBUG_CALL('MOM_INIT_FIXED',myThid)
# endif
        CALL MOM_INIT_FIXED( myThid )
      ENDIF
#endif

#ifdef ALLOW_CD_CODE
      IF (useCDscheme) THEN
# ifdef ALLOW_DEBUG
        IF (debugMode) CALL DEBUG_CALL('CD_CODE_INIT_FIXED',myThid)
# endif
        CALL CD_CODE_INIT_FIXED(myThid)
      ENDIF
#endif

C--   Initialize fixed arrays for OBCS
#ifdef ALLOW_OBCS
      IF (useOBCS) THEN
# ifdef ALLOW_DEBUG
        IF (debugMode) CALL DEBUG_CALL('OBCS_INIT_FIXED',myThid)
# endif
        CALL OBCS_INIT_FIXED( myThid )
      ENDIF
#endif

#ifdef ALLOW_SHAP_FILT
C--   Shapiro filter initialisation
      IF (useSHAP_FILT) THEN
# ifdef ALLOW_DEBUG
        IF (debugMode) CALL DEBUG_CALL('SHAP_FILT_INIT_FIXED',myThid)
# endif
        CALL SHAP_FILT_INIT_FIXED( myThid )
      ENDIF
#endif

#ifdef ALLOW_ZONAL_FILT
C--   Latitude circle filter initialisation
      IF (useZONAL_FILT) THEN
# ifdef ALLOW_DEBUG
        IF (debugMode) CALL DEBUG_CALL('ZONAL_FILT_INIT',myThid)
# endif
        CALL ZONAL_FILT_INIT(myThid)
      ENDIF
#endif

#ifdef ALLOW_EXF
C--   Initialize fixed arrays for EXF
      IF ( useEXF ) THEN
# ifdef ALLOW_DEBUG
        IF (debugMode) CALL DEBUG_CALL('EXF_INIT_FIXED',myThid)
# endif
        CALL EXF_INIT_FIXED( myThid )
      ENDIF
#endif

#ifdef ALLOW_CHEAPAML
      IF ( useCheapAML ) THEN
# ifdef ALLOW_DEBUG
        IF (debugMode) CALL DEBUG_CALL('CHEAPAML_INIT_FIXED',myThid)
# endif
        CALL CHEAPAML_INIT_FIXED( myThid )
      ENDIF
#endif

#ifdef ALLOW_OPPS
      IF (useOPPS) THEN
# ifdef ALLOW_DEBUG
        IF (debugMode) CALL DEBUG_CALL('OPPS_INIT',myThid)
# endif
        CALL OPPS_INIT( myThid )
      ENDIF
#endif /* ALLOW_OPPS */

#ifdef ALLOW_PP81
C--   Initialize fixed arrays for PP81
      IF ( usePP81 ) THEN
# ifdef ALLOW_DEBUG
        IF (debugMode) CALL DEBUG_CALL('PP81_INIT_FIXED',myThid)
# endif
        CALL PP81_INIT_FIXED( myThid )
      ENDIF
#endif

#ifdef ALLOW_KL10
C--   Initialize fixed arrays for KL10
      IF ( useKL10 ) THEN
# ifdef ALLOW_DEBUG
        IF (debugMode) CALL DEBUG_CALL('KL10_INIT_FIXED',myThid)
# endif
        CALL KL10_INIT_FIXED( myThid )
      ENDIF
#endif /* ALLOW_KL10 */

#ifdef ALLOW_MY82
C--   Initialize fixed arrays for MY82
      IF ( useMY82 ) THEN
# ifdef ALLOW_DEBUG
        IF (debugMode) CALL DEBUG_CALL('MY82_INIT_FIXED',myThid)
# endif
        CALL MY82_INIT_FIXED( myThid )
      ENDIF
#endif

#ifdef ALLOW_GGL90
C--   Initialize fixed arrays for GGL90
      IF ( useGGL90 ) THEN
# ifdef ALLOW_DEBUG
        IF (debugMode) CALL DEBUG_CALL('GGL90_INIT_FIXED',myThid)
# endif
        CALL GGL90_INIT_FIXED( myThid )
      ENDIF
#endif

#ifdef ALLOW_KPP
C--   Initialize fixed arrays for KPP
      IF ( useKPP ) THEN
# ifdef ALLOW_DEBUG
        IF (debugMode) CALL DEBUG_CALL('KPP_INIT_FIXED',myThid)
# endif
        CALL KPP_INIT_FIXED( myThid )
      ENDIF
#endif

#ifdef ALLOW_GMREDI
C--   Initialize fixed arrays for GM-Redi
      IF ( useGMRedi ) THEN
# ifdef ALLOW_DEBUG
        IF (debugMode) CALL DEBUG_CALL('GMREDI_INIT_FIXED',myThid)
# endif
        CALL GMREDI_INIT_FIXED( myThid )
      ENDIF
#endif

#ifdef ALLOW_BBL
C--   Initialize fixed arrays for BBL pkg
      IF ( useBBL ) THEN
# ifdef ALLOW_DEBUG
        IF (debugMode) CALL DEBUG_CALL('BBL_INIT_FIXED',myThid)
# endif
        CALL BBL_INIT_FIXED( myThid )
      ENDIF
#endif

#ifdef ALLOW_DOWN_SLOPE
C--   Initialize fixed arrays for Down-Slope pkg
      IF ( useDOWN_SLOPE ) THEN
# ifdef ALLOW_DEBUG
        IF (debugMode) CALL DEBUG_CALL('DWNSLP_INIT_FIXED',myThid)
# endif
        CALL DWNSLP_INIT_FIXED( myThid )
      ENDIF
#endif

#ifdef ALLOW_COST
C--   Initialise cost function.
# ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_CALL('COST_INIT_FIXED',myThid)
# endif
      CALL COST_INIT_FIXED( myThid )
#endif

#ifdef ALLOW_SEAICE
C--   Initialise seaice-specific cost function.
      IF (useSEAICE) THEN
# ifdef ALLOW_DEBUG
        IF (debugMode) CALL DEBUG_CALL('SEAICE_COST_INIT_FIXED',myThid)
# endif
        CALL SEAICE_COST_INIT_FIXED( myThid )
      ENDIF
#endif

#ifdef ALLOW_ECCO
      IF (useECCO) THEN
C--   Calls ECCO_COST_INIT_FIXED which initialises ecco-specific cost
C--   function. This needs to preceed CTRL_INIT_FIXED call in order to
C--   provide the weight files.
# ifdef ALLOW_DEBUG
        IF (debugMode) CALL DEBUG_CALL('ECCO_INIT_FIXED',myThid)
# endif
        CALL ECCO_INIT_FIXED( myThid )
      ENDIF
#endif

#ifdef ALLOW_PROFILES
      IF (usePROFILES) THEN
# ifdef ALLOW_DEBUG
        IF (debugMode) CALL DEBUG_CALL('PROFILES_INIT_FIXED',myThid)
# endif
        CALL PROFILES_INIT_FIXED( myThid )
      ENDIF
#endif

#ifdef ALLOW_OBSFIT
      IF (useOBSFIT) THEN
# ifdef ALLOW_DEBUG
        IF (debugMode) CALL DEBUG_CALL('OBSFIT_INIT_FIXED',myThid)
# endif
        CALL OBSFIT_INIT_FIXED( myThid )
      ENDIF
#endif

C--   Old place where CTRL_INIT_FIXED & CTRL_ADMTLM used to be called

#ifdef ALLOW_FLT
C--   Initialise fixed array for Float pkg
      IF ( useFLT ) THEN
# ifdef ALLOW_DEBUG
        IF (debugMode) CALL DEBUG_CALL('FLT_INIT_FIXED',myThid)
# endif
        CALL FLT_INIT_FIXED( myThid )
      ENDIF
#endif

#ifdef ALLOW_LONGSTEP
      IF (usePTRACERS) THEN
# ifdef ALLOW_DEBUG
        IF (debugMode) CALL DEBUG_CALL('LONGSTEP_INIT_FIXED',myThid)
# endif
        CALL LONGSTEP_INIT_FIXED(myThid)
      ENDIF
#endif

#ifdef ALLOW_PTRACERS
      IF (usePTRACERS) THEN
# ifdef ALLOW_DEBUG
        IF (debugMode) CALL DEBUG_CALL('PTRACERS_INIT_FIXED',myThid)
# endif
        CALL PTRACERS_INIT_FIXED(myThid)
      ENDIF
#endif

#ifdef ALLOW_GCHEM
      IF (useGCHEM) THEN
# ifdef ALLOW_DEBUG
        IF (debugMode) CALL DEBUG_CALL('GCHEM_INIT_FIXED',myThid)
# endif
        CALL GCHEM_INIT_FIXED(myThid)
      ENDIF
#endif

#ifdef ALLOW_RBCS
      IF (useRBCS) THEN
# ifdef ALLOW_DEBUG
        IF (debugMode) CALL DEBUG_CALL('RBCS_INIT_FIXED',myThid)
# endif
        CALL RBCS_INIT_FIXED(myThid)
      ENDIF
#endif

#ifdef ALLOW_STREAMICE
      IF (useStreamIce) THEN
# ifdef ALLOW_DEBUG
        IF (debugMode) CALL DEBUG_CALL('STREAMICE_INIT_FIXED',myThid)
# endif
#ifndef ALLOW_OPENAD
       CALL STREAMICE_INIT_FIXED( myThid )
#else
       CALL OPENAD_STREAMICE_INIT_FIXED( myThid )
#endif
      ENDIF
#endif /* ALLOW_STREAMICE */

#ifdef ALLOW_SHELFICE
      IF (useShelfIce) THEN
# ifdef ALLOW_DEBUG
        IF (debugMode) CALL DEBUG_CALL('SHELFICE_INIT_FIXED',myThid)
# endif
        CALL SHELFICE_INIT_FIXED( myThid )
      ENDIF
#endif /* ALLOW_SHELFICE */

#ifdef ALLOW_STEEP_ICECAVITY
      IF (useSTIC) THEN
# ifdef ALLOW_DEBUG
        IF (debugMode) CALL DEBUG_CALL('STIC_INIT_FIXED',myThid)
# endif
        CALL STIC_INIT_FIXED( myThid )
      ENDIF
#endif /* ALLOW_STEEP_ICECAVITY */

#ifdef ALLOW_SMOOTH
      IF (useSMOOTH) THEN
# ifdef ALLOW_DEBUG
        IF (debugMode) CALL DEBUG_CALL('SMOOTH_INIT_FIXED',myThid)
# endif
        CALL SMOOTH_INIT_FIXED(myThid)
      ENDIF
#endif /* ALLOW_SMOOTH */

#ifdef ALLOW_ICEFRONT
      IF (useICEFRONT) THEN
# ifdef ALLOW_DEBUG
        IF (debugMode) CALL DEBUG_CALL('ICEFRONT_INIT_FIXED',myThid)
# endif
        CALL ICEFRONT_INIT_FIXED( myThid )
      ENDIF
#endif /* ALLOW_ICEFRONT */

#ifdef ALLOW_FRAZIL
      IF (useFRAZIL) THEN
# ifdef ALLOW_DEBUG
        IF (debugMode) CALL DEBUG_CALL('FRAZIL_INIT_FIXED',myThid)
# endif
        CALL FRAZIL_INIT_FIXED(myThid)
      ENDIF
#endif

#ifdef ALLOW_SEAICE
      IF (useSEAICE) THEN
# ifdef ALLOW_DEBUG
        IF (debugMode) CALL DEBUG_CALL('SEAICE_INIT_FIXED',myThid)
# endif
        CALL SEAICE_INIT_FIXED(myThid)
      ENDIF
#endif

#ifdef ALLOW_SALT_PLUME
      IF (useSALT_PLUME) THEN
# ifdef ALLOW_DEBUG
        IF (debugMode) CALL DEBUG_CALL('SALT_PLUME_INIT_FIXED',myThid)
# endif
        CALL SALT_PLUME_INIT_FIXED(myThid)
      ENDIF
#endif

#ifdef ALLOW_THSICE
      IF (useThSIce) THEN
# ifdef ALLOW_DEBUG
        IF (debugMode) CALL DEBUG_CALL('THSICE_INIT_FIXED',myThid)
# endif
        CALL THSICE_INIT_FIXED(myThid)
      ENDIF
#endif

#ifdef ALLOW_LAND
C--   Initialise Land package
      IF ( useLand ) THEN
# ifdef ALLOW_DEBUG
        IF (debugMode) CALL DEBUG_CALL('LAND_INIT_FIXED',myThid)
# endif
        CALL LAND_INIT_FIXED( myThid )
      ENDIF
#endif

#ifdef ALLOW_ATM2D
      IF ( useAtm2d ) THEN
# ifdef ALLOW_DEBUG
        IF (debugMode) CALL DEBUG_CALL('ATM2D_INIT_FIXED',myThid)
# endif
        CALL ATM2D_INIT_FIXED( myThid )
      ENDIF
#endif

#ifdef ALLOW_AIM
C--   Initialise & Read AIM physical parameters
      IF (useAIM) THEN
# ifdef ALLOW_DEBUG
        IF (debugMode) CALL DEBUG_CALL('AIM_INITIALISE',myThid)
# endif
        CALL AIM_INITIALISE( myThid )
      ENDIF
#endif

#ifdef ALLOW_ATM_PHYS
C--   Initialise Atm_Phys pkg
      IF ( useAtm_Phys ) THEN
# ifdef ALLOW_DEBUG
        IF (debugMode) CALL DEBUG_CALL('ATM_PHYS_INIT_FIXED',myThid)
# endif
        CALL ATM_PHYS_INIT_FIXED( myThid )
      ENDIF
#endif /* ALLOW_ATM_PHYS */

#ifdef ALLOW_FIZHI
C--   Initialise & Read FIZHI physical parameters
      IF (useFIZHI) THEN
# ifdef ALLOW_DEBUG
        IF (debugMode) CALL DEBUG_CALL('FIZHI_INIT_FIXED',myThid)
# endif
        CALL FIZHI_INIT_FIXED( myThid )
      ENDIF
#endif

#ifdef ALLOW_GRIDALT
C--   Initialise GRIDALT parameters - the alternative grid
      IF (useGRIDALT) then
# ifdef ALLOW_DEBUG
        IF (debugMode) CALL DEBUG_CALL('GRIDALT_INITIALISE',myThid)
# endif
        CALL GRIDALT_INITIALISE( myThid )
      ENDIF
#endif

#ifdef ALLOW_REGRID
      IF ( useREGRID ) THEN
# ifdef ALLOW_DEBUG
        IF (debugMode) CALL DEBUG_CALL('REGRID_INIT_FIXED',myThid)
# endif
        CALL REGRID_INIT_FIXED( myThid )
      ENDIF
#endif

#ifdef ALLOW_LAYERS
      IF ( useLayers ) THEN
# ifdef ALLOW_DEBUG
        IF (debugMode) CALL DEBUG_CALL('LAYERS_INIT_FIXED',myThid)
# endif
        CALL LAYERS_INIT_FIXED( myThid )
      ENDIF
#endif /* ALLOW_LAYERS */

#ifdef COMPONENT_MODULE
      IF ( useCoupler ) THEN
# ifdef ALLOW_DEBUG
        IF (debugMode) CALL DEBUG_CALL('CPL_INIT_FIXED',myThid)
# endif
        CALL CPL_INIT_FIXED( myThid )
      ENDIF
#endif

#ifdef ALLOW_OASIS
C--   needs to be called after the OASIS_INIT
      IF (useOASIS) THEN
# ifdef ALLOW_DEBUG
        IF (debugMode) CALL DEBUG_CALL('OASIS_INIT_FIXED',myThid)
# endif
        CALL OASIS_INIT_FIXED(myThid)
      ENDIF
#endif

#ifdef ALLOW_EMBED_FILES
      IF ( useEMBED_FILES ) THEN
# ifdef ALLOW_DEBUG
        IF (debugMode) CALL DEBUG_CALL('EMBED_FILES_INIT',myThid)
# endif
        CALL EMBED_FILES_INIT( myThid )
      ENDIF
#endif

#ifdef ALLOW_MYPACKAGE
      IF (useMYPACKAGE) THEN
# ifdef ALLOW_DEBUG
        IF (debugMode) CALL DEBUG_CALL('MYPACKAGE_INIT_FIXED',myThid)
# endif
        CALL MYPACKAGE_INIT_FIXED(myThid)
      ENDIF
#endif

#ifdef ALLOW_CTRL
      IF (useCTRL) THEN
C--   Initialise the control variables. Moved to the end of this S/R
C     to allow other pkgs to set mask and weight fields.
# ifdef ALLOW_DEBUG
        IF (debugMode) CALL DEBUG_CALL('CTRL_INIT_FIXED',myThid)
# endif
        CALL CTRL_INIT_FIXED( myThid )
      ENDIF

# ifdef ALLOW_ADMTLM
      IF (useCTRL) THEN
C--   Initialise ADMTLM
#  ifdef ALLOW_DEBUG
        IF (debugMode) CALL DEBUG_CALL('CTRL_ADMTLM',myThid)
#  endif
        CALL CTRL_ADMTLM( myThid )
      ENDIF
# endif /* ALLOW_ADMTLM */
#endif /* ALLOW_CTRL */

#ifdef ALLOW_DIAGNOSTICS
C-    needs to call DIAGNOSTICS_INIT_FIXED after all package-diag-init calls
      IF ( useDiagnostics ) THEN
# ifdef ALLOW_DEBUG
        IF (debugMode) CALL DEBUG_CALL('DIAGNOSTICS_INIT_FIXED',myThid)
# endif
        CALL DIAGNOSTICS_INIT_FIXED( myThid )
      ENDIF
#endif

#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_LEAVE('PACKAGES_INIT_FIXED',myThid)
#endif

      RETURN
      END

#include "MDSIO_OPTIONS.h"

CBOP
C !ROUTINE: MDS_WRITEVEC_LOC
C !INTERFACE:
      SUBROUTINE MDS_WRITEVEC_LOC(
     I   fName,
     I   filePrec,
     U   ioUnit,
     I   arrType,
     I   nSize,
     I   fldRL, fldRS,
     I   bi, bj,
     I   irecord,
     I   myIter,
     I   myThid )

C !DESCRIPTION:
C Arguments:
C
C fName    string  :: base name for file to written
C filePrec integer :: number of bits per word in file (32 or 64)
C ioUnit   integer :: fortran file IO unit
C nSize    integer :: number of elements from input array "fldRL/RS" to be written
C arrType  char(2) :: which array (fldRL/RS) to write, either "RL" or "RS"
C fldRL    ( RL )  :: array to write if arrType="RL", fldRL(nSize)
C fldRS    ( RS )  :: array to write if arrType="RS", fldRS(nSize)
C bi,bj    integer :: tile indices (if tiled array) or 0,0 if not a tiled array
C irecord  integer :: record number to WRITE =|irecord|
C myIter   integer :: time step number
C myThid   integer :: my Thread Id number
C
C MDS_WRITEVEC_LOC according to ioUnit:
C  ioUnit = 0 : open file, write and close the file (return ioUnit=0).
C  ioUnit =-1 : open file, write and leave it open (return IO unit in ioUnit)
C  ioUnit > 0 : assume file "ioUnit" is open, and write to it.
C MDS_WRITEVEC_LOC writes either to a file of the form "fName.data" and
C "fName.meta" if bi=bj=0. Otherwise it writes to MDS tiled files of the
C form "fName.xxx.yyy.data" and "fName.xxx.yyy.meta".
C If irecord>0, a meta-file is created (skipped if irecord<0).
C The precision of the file is described by filePrec, set either
C to floatPrec32 or floatPrec64.
C |irecord|=iRec is the record number to be written and must be >=1.

C !USES:
      IMPLICIT NONE

C Global variables / common blocks
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#ifdef ALLOW_FIZHI
# include "fizhi_SIZE.h"
#endif /* ALLOW_FIZHI */
#include "MDSIO_BUFF_3D.h"

C !INPUT/OUTPUT PARAMETERS:
      CHARACTER*(*) fName
      INTEGER ioUnit
      INTEGER filePrec
      CHARACTER*(2) arrType
      INTEGER nSize
      _RL     fldRL(*)
      _RS     fldRS(*)
      INTEGER bi,bj
      INTEGER irecord
      INTEGER myIter
      INTEGER myThid

C !FUNCTIONS:
      INTEGER ILNBLNK
      INTEGER MDS_RECLEN
      EXTERNAL ILNBLNK
      EXTERNAL MDS_RECLEN

C !LOCAL VARIABLES:
      CHARACTER*(MAX_LEN_FNAM) dataFName, metaFName, pfName
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      LOGICAL fileIsOpen
      INTEGER iG,jG,iRec,dUnit,IL,pIL
      INTEGER dimList(3,3), nDims, map2gl(2)
      INTEGER length_of_rec
      INTEGER buffSize
      _RL dummyRL(1)
      CHARACTER*8 blank8c
CEOP

      DATA dummyRL(1) / 0. _d 0 /
      DATA blank8c / '        ' /
      DATA map2gl  / 0, 1 /

C We write a non-tiled array (bi=bj=0) only 1 time (if ProcId=0):
      IF ( myProcId.EQ.0 .OR. bi.NE.0 .OR. bj.NE.0 ) THEN

C Only DO I/O IF I am the master thread
        _BEGIN_MASTER( myThid )

C Assume nothing
        fileIsOpen = .FALSE.
        IL  = ILNBLNK( fName )
        iRec = ABS(irecord)

C Record number must be >= 1
        IF ( iRec.LT.1 ) THEN
          WRITE(msgBuf,'(A,I9)')
     &      ' MDS_WRITEVEC_LOC: argument irecord = ',irecord
          CALL PRINT_ERROR( msgBuf, myThid )
          WRITE(msgBuf,'(A)')
     &     ' MDS_WRITEVEC_LOC: invalid value for irecord'
          CALL PRINT_ERROR( msgBuf, myThid )
          STOP 'ABNORMAL END: S/R MDS_WRITEVEC_LOC'
        ENDIF

C Check buffer size
        buffSize = sNx*sNy*size3dBuf*nSx*nSy
        IF ( nSize.GT.buffSize ) THEN
          WRITE(msgBuf,'(3A)')
     &     ' MDS_WRITEVEC_LOC: writing to file "', fName(1:IL), '":'
          CALL PRINT_ERROR( msgBuf, myThid )
          WRITE(msgBuf,'(A,I9)')
     &      ' MDS_WRITEVEC_LOC: dim of array to write=', nSize
          CALL PRINT_ERROR( msgBuf, myThid )
          WRITE(msgBuf,'(A,I9)')
     &      ' MDS_WRITEVEC_LOC: exceeds buffer size=', buffSize
          CALL PRINT_ERROR( msgBuf, myThid )
          WRITE(msgBuf,'(A)')
     &    ' increase "size3dBuf" in "MDSIO_BUFF_3D.h" and recompile'
          CALL PRINT_ERROR( msgBuf, myThid )
          STOP 'ABNORMAL END: S/R MDS_WRITEVEC_LOC'
        ENDIF

C Assign special directory
        IF ( mdsioLocalDir .NE. ' ' ) THEN
         pIL = ILNBLNK( mdsioLocalDir )
         WRITE(pFname,'(2A)') mdsioLocalDir(1:pIL), fName(1:IL)
         pIL = IL + pIL
        ELSE
         WRITE(pFname,'(A)') fName(1:IL)
         pIL = IL
        ENDIF

        IF ( ioUnit.GT.0 ) THEN
C- Assume file Unit is already open with correct Rec-Length & Precision
          fileIsOpen = .TRUE.
          dUnit = ioUnit
        ELSE
C- Need to open file IO unit with File-name, Rec-Length & Precision

C     Assign a free unit number as the I/O channel for this routine
          CALL MDSFINDUNIT( dUnit, myThid )

C--   Set the file Name:
          IF ( bi.EQ.0 .AND. bj.EQ.0 ) THEN
C-    we are writing a non-tiled array (bi=bj=0):
            WRITE(dataFname,'(2A)') fName(1:IL),'.data'
          ELSE
C-    we are writing a tiled array (bi>0,bj>0):
            iG=bi+(myXGlobalLo-1)/sNx
            jG=bj+(myYGlobalLo-1)/sNy
            WRITE(dataFname,'(2A,I3.3,A,I3.3,A)')
     &             pfName(1:pIL),'.',iG,'.',jG,'.data'
          ENDIF

C--   Open the file:
          length_of_rec=MDS_RECLEN( filePrec, nSize, myThid )
          IF (iRec .EQ. 1) THEN
            OPEN( dUnit, file=dataFName, status=_NEW_STATUS,
     &            access='direct', recl=length_of_rec )
            fileIsOpen=.TRUE.
          ELSE
            OPEN( dUnit, file=dataFName, status=_OLD_STATUS,
     &            access='direct', recl=length_of_rec )
            fileIsOpen=.TRUE.
          ENDIF
          IF ( debugLevel.GE.debLevC ) THEN
            WRITE(msgBuf,'(2A)')
     &      ' MDS_WRITEVEC_LOC: open file: ',dataFname(1:pIL+13)
            CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                          SQUEEZE_RIGHT , 1)
          ENDIF
C- End if block: File Unit is already open / Need to open it
        ENDIF

        IF (fileIsOpen) THEN
          IF ( arrType.EQ.'RS' ) THEN
            CALL MDS_WR_REC_RS( fldRS, shared3dBuf_r4, shared3dBuf_r8,
     I                          filePrec, dUnit, iRec, nSize, myThid )
          ELSEIF ( arrType.EQ.'RL' ) THEN
            CALL MDS_WR_REC_RL( fldRL, shared3dBuf_r4, shared3dBuf_r8,
     I                          filePrec, dUnit, iRec, nSize, myThid )
          ELSE
            WRITE(msgBuf,'(A)')
     &          ' MDS_WRITEVEC_LOC: illegal value for arrType'
            CALL PRINT_ERROR( msgBuf, myThid )
            STOP 'ABNORMAL END: S/R MDS_WRITEVEC_LOC'
          ENDIF
        ELSE
          WRITE(msgBuf,'(A)')
     &      ' MDS_WRITEVEC_LOC: should never reach this point'
          CALL PRINT_ERROR( msgBuf, myThid )
          STOP 'ABNORMAL END: S/R MDS_WRITEVEC_LOC'
        ENDIF

C If we were writing to a tiled MDS file then we close it here
        IF ( fileIsOpen .AND. ioUnit.EQ.0 ) THEN
          CLOSE( dUnit )
          fileIsOpen = .FALSE.
        ENDIF
        IF ( ioUnit.EQ.-1 ) ioUnit = dUnit

        IF ( irecord.GT.0 ) THEN
C Create meta-file for each tile IF we are tiling
          IF ( bi.EQ.0 .AND. bj.EQ.0 ) THEN
C--   we are writing a non-tiled array (bi=bj=0):
            WRITE(metaFname,'(2A)') fName(1:IL),'.meta'
            dimList(1,1)=1
            dimList(2,1)=1
            dimList(3,1)=1
            dimList(1,2)=1
            dimList(2,2)=1
            dimList(3,2)=1
          ELSE
C--   we are writing a tiled array (bi>0,bj>0):
            iG=bi+(myXGlobalLo-1)/sNx
            jG=bj+(myYGlobalLo-1)/sNy
            WRITE(metaFname,'(2A,I3.3,A,I3.3,A)')
     &             pfName(1:pIL),'.',iG,'.',jG,'.meta'
            dimList(1,1)=nSx*nPx
            dimList(2,1)=iG
            dimList(3,1)=iG
            dimList(1,2)=nSy*nPy
            dimList(2,2)=jG
            dimList(3,2)=jG
          ENDIF
          dimList(1,3)=nSize
          dimList(2,3)=1
          dimList(3,3)=nSize
          nDims=3
          IF ( nSize.EQ.1 ) nDims=2
          CALL MDS_WRITE_META(
     I              metaFName, dataFName, the_run_name, ' ',
     I              filePrec, nDims, dimList, map2gl, 0, blank8c,
     I              0, dummyRL, oneRL, irecord, myIter, myThid )
        ENDIF

        _END_MASTER( myThid )
      ENDIF

      RETURN
      END

#include "CPP_EEOPTIONS.h"

      subroutine oad_s_MDS_RECLEN( filePrec, nnn, myThid, reclen )
C IN:
C   filePrec    integer :: precision of file in bits
C   nnn         integer :: number of elements in record
C OUT:
C   MDS_RECLEN  integer :: appropriate length of record in bytes or words
C
C Created: 03/29/99 eckert@mit.edu + adcroft@mit.edu

      implicit none

C Global variables
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
C
C Arguments
      integer filePrec
      integer nnn
      integer myThid
      integer reclen
C
C Local
      character*(max_len_mbuf) msgbuf
C     ------------------------------------------------------------------

      if (filePrec .EQ. precFloat32) then
       reclen=nnn*WORDLENGTH
      elseif (filePrec .EQ. precFloat64) then
       reclen=nnn*WORDLENGTH*2
      else
       write(msgbuf,'(a,i2.2)')
     &   ' MDS_RECLEN: filePrec = ',filePrec
       call print_message( msgbuf, standardmessageunit,
     &                     SQUEEZE_RIGHT , myThid)
       write(msgbuf,'(a)')
     &   ' MDS_RECLEN: illegal value for filePrec'
       call print_error( msgbuf, myThid )
       stop 'ABNORMAL END: S/R MDS_RECLEN'
      endif

C     ------------------------------------------------------------------
      return
      end

#include "OBSFIT_OPTIONS.h"
C--  File obsfit_active_file_g.F:
C--   Contents
C--   o g_active_read_obs_tile
C--   o g_active_write_obs_tile
C--   o g_active_read_obs_glob
C--   o g_active_write_obs_glob

CBOP
C     !ROUTINE: G_ACTIVE_READ_OBS_TILE

C     !INTERFACE:
      SUBROUTINE G_ACTIVE_READ_OBS_TILE(
     I                                   active_num_file,
     O                                   active_var,
     I                                   g_active_var,
     I                                   irec,
     I                                   lAdInit,
     I                                   myOptimIter,
     I                                   bi,
     I                                   bj,
     I                                   myThid,
     I                                   dummy )

C     !DESCRIPTION:
C     ==================================================================
C     | Read an active record from an ObsFit .equi. tiled file
C     | for tangent linear calculations
C     ==================================================================

C     !USES:
      IMPLICIT NONE
C     == Global variables ===
#include "EEPARAMS.h"
#include "SIZE.h"
#ifdef ALLOW_OBSFIT
# include "OBSFIT_SIZE.h"
# include "OBSFIT.h"
#endif

C     !INPUT PARAMETERS:
C     active_num_file: file number
C     active_var:      array
C     irec:            record number
C     myOptimIter:     number of optimization iteration (default: 0)
C     myThid:          my thread ID number
C     lAdInit:         initialisation of corresponding adjoint
C                      variable and write to active file
      _RL     active_var
      _RL     g_active_var
      INTEGER irec, active_num_file
      INTEGER myOptimIter
      INTEGER bi, bj, myThid
      LOGICAL lAdInit
      _RL     dummy
CEOP

#ifdef ALLOW_OBSFIT
      CALL ACTIVE_READ_OBS_TILE_RL(
     I     fidfwd_obs(active_num_file,bi,bj), active_num_file,
     O     active_var,
     I     lAdInit, irec, sample_ind_glob(active_num_file,irec,bi,bj),
     I     FORWARD_SIMULATION, myOptimIter, bi, bj, myThid )

      CALL ACTIVE_READ_OBS_TILE_RL(
     I     fidtan_obs(active_num_file,bi,bj), active_num_file,
     O     g_active_var,
     I     lAdInit, irec, sample_ind_glob(active_num_file,irec,bi,bj),
     I     TANGENT_SIMULATION, myOptimIter, bi, bj, myThid )

#endif

      RETURN
      END

C     ==================================================================

CBOP
C     !ROUTINE: G_ACTIVE_WRITE_OBS_TILE

C     !INTERFACE:
      SUBROUTINE G_ACTIVE_WRITE_OBS_TILE(
     I                                    active_num_file,
     I                                    active_var,
     I                                    g_active_var,
     I                                    irec,
     I                                    myOptimIter,
     I                                    bi,
     I                                    bj,
     I                                    myThid,
     I                                    dummy,
     I                                    g_dummy )

C     !DESCRIPTION:
C     ==================================================================
C     | Write an active record to an ObsFit .equi. tiled file
C     | for tangent linear calculations
C     ==================================================================

C     !USES:
      IMPLICIT NONE
C     == Global variables ===
#include "EEPARAMS.h"
#include "SIZE.h"
#ifdef ALLOW_OBSFIT
# include "OBSFIT_SIZE.h"
# include "OBSFIT.h"
#endif

C     !INPUT PARAMETERS:
C     active_num_file: file number
C     active_var:      array
C     irec:            record number
C     myOptimIter:     number of optimization iteration (default: 0)
C     myThid:          my thread ID number
      INTEGER active_num_file
      _RL     active_var
      _RL     g_active_var
      INTEGER irec
      INTEGER myOptimIter
      INTEGER bi, bj, myThid
      _RL     dummy
      _RL     g_dummy
CEOP

#ifdef ALLOW_OBSFIT
      CALL ACTIVE_WRITE_OBS_TILE_RL(
     I     fidfwd_obs(active_num_file,bi,bj),
     I     active_num_file, active_var,
     I     irec, sample_ind_glob(active_num_file,irec,bi,bj),
     I     FORWARD_SIMULATION, myOptimIter, bi, bj, myThid )

      CALL ACTIVE_WRITE_OBS_TILE_RL(
     I     fidtan_obs(active_num_file,bi,bj),
     I     active_num_file, g_active_var,
     I     irec, sample_ind_glob(active_num_file,irec,bi,bj),
     I     TANGENT_SIMULATION, myOptimIter, bi, bj, myThid )

#endif

      RETURN
      END

C     ==================================================================

CBOP
C     !ROUTINE: G_ACTIVE_READ_OBS_GLOB

C     !INTERFACE:
      SUBROUTINE G_ACTIVE_READ_OBS_GLOB(
     I                                   active_num_file,
     O                                   active_var,
     I                                   g_active_var,
     O                                   active_mask,
     I                                   g_active_mask,
     I                                   irec,
     I                                   lAdInit,
     I                                   myOptimIter,
     I                                   myThid,
     I                                   dummy )

C     !DESCRIPTION:
C     ==================================================================
C     | Read an active record from an ObsFit .equi. global file
C     | for tangent linear calculations
C     ==================================================================

C     !USES:
      IMPLICIT NONE
C     == Global variables ===
#include "EEPARAMS.h"
#include "SIZE.h"
#ifdef ALLOW_OBSFIT
# include "OBSFIT_SIZE.h"
# include "OBSFIT.h"
#endif

C     !INPUT PARAMETERS:
C     active_num_file: file number
C     active_var:      array
C     active_mask:     array mask
C     irec:            record number
C     myOptimIter:     number of optimization iteration (default: 0)
C     myThid:          my thread ID number
C     lAdInit:         initialisation of corresponding adjoint
C                      variable and write to active file
      _RL     active_var
      _RL     g_active_var
      _RL     active_mask
      _RL     g_active_mask
      INTEGER irec, active_num_file
      INTEGER myOptimIter
      INTEGER myThid
      LOGICAL lAdInit
      _RL     dummy
CEOP

#ifdef ALLOW_OBSFIT

      CALL ACTIVE_READ_OBS_GLOB_RL(
     I     fidglobal(active_num_file), active_num_file,
     O     active_var, active_mask,
     I     lAdInit, irec, obs_ind_glob(active_num_file,irec),
     I     FORWARD_SIMULATION, myOptimIter, myThid )

      CALL ACTIVE_READ_OBS_GLOB_RL(
     I     fidtanglobal(active_num_file), active_num_file,
     O     g_active_var, active_mask,
     I     lAdInit, irec, obs_ind_glob(active_num_file,irec),
     I     TANGENT_SIMULATION, myOptimIter, myThid )

#endif

      RETURN
      END

C     ==================================================================

CBOP
C     !ROUTINE: G_ACTIVE_WRITE_OBS_GLOB

C     !INTERFACE:
      SUBROUTINE G_ACTIVE_WRITE_OBS_GLOB(
     I                                    active_num_file,
     I                                    active_var,
     I                                    g_active_var,
     I                                    active_mask,
     I                                    g_active_mask,
     I                                    irec,
     I                                    myOptimIter,
     I                                    myThid,
     I                                    dummy,
     I                                    g_dummy )

C     !DESCRIPTION:
C     ==================================================================
C     | Write an active record to an ObsFit .equi. global file
C     | for tangent linear calculations
C     ==================================================================

C     !USES:
      IMPLICIT NONE
C     == Global variables ===
#include "EEPARAMS.h"
#include "SIZE.h"
#ifdef ALLOW_OBSFIT
# include "OBSFIT_SIZE.h"
# include "OBSFIT.h"
#endif

C !INPUT PARAMETERS:
C     active_num_file: file number
C     active_var:      array
C     active_mask:     array mask
C     irec:            record number
C     myOptimIter:     number of optimization iteration (default: 0)
C     myThid:          my thread ID number
      INTEGER active_num_file
      _RL     active_var
      _RL     g_active_var
      _RL     active_mask
      _RL     g_active_mask
      INTEGER irec
      INTEGER myOptimIter
      INTEGER myThid
      _RL     dummy
      _RL     g_dummy
CEOP

#ifdef ALLOW_OBSFIT
      CALL ACTIVE_WRITE_OBS_GLOB_RL(
     I     fidglobal(active_num_file), active_num_file,
     I     active_var, active_mask,
     I     irec, obs_ind_glob(active_num_file,irec),
     I     FORWARD_SIMULATION, myOptimIter, myThid )

      CALL ACTIVE_WRITE_OBS_GLOB_RL(
     I     fidtanglobal(active_num_file), active_num_file,
     I     g_active_var, g_active_mask,
     I     irec, obs_ind_glob(active_num_file,irec),
     I     TANGENT_SIMULATION, myOptimIter, myThid )

#endif

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#include "CTRL_OPTIONS.h"

      subroutine ctrl_set_unpack_yz(
     &     cunit, ivar, fname, masktype, weighttype,
     &     weightfld, nwetglobal, mythid)

c     ==================================================================
c     SUBROUTINE ctrl_set_unpack_yz
c     ==================================================================
c
c     o Unpack the control vector such that land points are filled in.
c
c     o Open boundary packing added :
c          gebbie@mit.edu, 18-Mar-2003
c
c     changed: heimbach@mit.edu 17-Jun-2003
c              merged changes from Armin to replace write of
c              nr * globfld2d by 1 * globfld3d
c              (ad hoc fix to speed up global I/O)
c
c     ==================================================================

      implicit none

c     == global variables ==

#include "EEPARAMS.h"
#include "SIZE.h"
#include "PARAMS.h"
#include "GRID.h"

#include "CTRL_SIZE.h"
#include "CTRL.h"
#include "CTRL_OBCS.h"
#include "OPTIMCYCLE.h"

c     == routine arguments ==

      integer cunit
      integer ivar
      character*(MAX_LEN_FNAM)   fname
      character*  (9) masktype
      character*  (*) weighttype
      _RL     weightfld( Nr,nobcs )
      integer nwetglobal(Nr,nobcs)
      integer mythid

#ifndef EXCLUDE_CTRL_PACK
c     == local variables ==

      logical lxxadxx

      integer bi,bj
      integer ip,jp
      integer i,j,k
      integer ii,jj,kk
      integer irec,iobcs,nrec_nl
      integer itlo,ithi
      integer jtlo,jthi
      integer jmin,jmax
      integer imin,imax

      integer cbuffindex

      real*4  cbuff     ( nSx*nPx*sNy*nSy*nPy )
      real*4 globfldtmp2( nSx,nPx,sNy,nSy,nPy )
      real*4 globfldtmp3( nSx,nPx,sNy,nSy,nPy )
      _RL     globfldyz( nSx,nPx,sNy,nSy,nPy,Nr )
      _RL     globfld3d( sNx,nSx,nPx,sNy,nSy,nPy,Nr )
      _RL     globmskyz( nSx,nPx,sNy,nSy,nPy,Nr,nobcs )

      integer reclen, irectrue
      integer cunit2, cunit3
      character*(MAX_LEN_FNAM) cfile2, cfile3

C     These variables are read-in from file, but not used much
      integer loc_ncbuffindex
      integer loc_i
      integer loc_j
      integer loc_k
      integer loc_ncvarindex

#ifdef CTRL_UNPACK_PRECISE
      integer il
      character*(MAX_LEN_FNAM) weightname
      _RL   weightfldyz( nSx,nPx,sNy,nSy,nPy,Nr,nobcs )

c     == external ==

      integer  ilnblnk
      external ilnblnk
#endif

cc     == end of interface ==

      jtlo = 1
      jthi = nSy
      itlo = 1
      ithi = nSx
      jmin = 1
      jmax = sNy
      imin = 1
      imax = sNx

      lxxadxx = .TRUE.

c     Initialise temporary file
      do k = 1,Nr
         do jp = 1,nPy
            do bj = jtlo,jthi
               do j = jmin,jmax
                  do ip = 1,nPx
                     do bi = itlo,ithi
                        globfldyz  (bi,ip,j,bj,jp,k) = 0. _d 0
                        globfldtmp2(bi,ip,j,bj,jp)   = 0.
                        globfldtmp3(bi,ip,j,bj,jp)   = 0.
                        do iobcs=1,nobcs
                           globmskyz(bi,ip,j,bj,jp,k,iobcs) = 0. _d 0
                        enddo
                     enddo
                  enddo
               enddo
            enddo
         enddo
      enddo
c     Initialise temporary file
      do k = 1,Nr
         do jp = 1,nPy
            do bj = jtlo,jthi
               do j = jmin,jmax
                  do ip = 1,nPx
                     do bi = itlo,ithi
                        do i = imin,imax
                           globfld3d(i,bi,ip,j,bj,jp,k) = 0. _d 0
                        enddo
                     enddo
                  enddo
               enddo
            enddo
         enddo
      enddo

c--   Only the master thread will do I/O.
      _BEGIN_MASTER( mythid )

      if ( doPackDiag ) then
         if ( lxxadxx ) then
            write(cfile2,'(a,I2.2,a,I4.4,a)')
     &           'diag_unpack_nondim_ctrl_',
     &           ivar, '_', optimcycle, '.bin'
            write(cfile3,'(a,I2.2,a,I4.4,a)')
     &           'diag_unpack_dimens_ctrl_',
     &           ivar, '_', optimcycle, '.bin'
         else
            write(cfile2,'(a,I2.2,a,I4.4,a)')
     &           'diag_unpack_nondim_grad_',
     &           ivar, '_', optimcycle, '.bin'
            write(cfile3,'(a,I2.2,a,I4.4,a)')
     &           'diag_unpack_dimens_grad_',
     &           ivar, '_', optimcycle, '.bin'
         endif

         reclen = nSx*nPx*sNy*nSy*nPy*4
         call mdsfindunit( cunit2, mythid )
         open( cunit2, file=cfile2, status='unknown',
     &        access='direct', recl=reclen )
         call mdsfindunit( cunit3, mythid )
         open( cunit3, file=cfile3, status='unknown',
     &        access='direct', recl=reclen )
      endif

      do iobcs=1,nobcs
         call MDSREADFIELD_YZ_GL(
     &        masktype, ctrlprec, 'RL',
     &        Nr, globmskyz(1,1,1,1,1,1,iobcs), iobcs, mythid)
#ifdef CTRL_UNPACK_PRECISE
         il=ilnblnk( weighttype)
         write(weightname,'(a)') weighttype(1:il)
         call MDSREADFIELD_YZ_GL(
     &       weightname, ctrlprec, 'RL',
     &       Nr, weightfldyz(1,1,1,1,1,1,iobcs), iobcs, mythid)
#endif /* CTRL_UNPACK_PRECISE */
      enddo

      if ( useSingleCPUio ) then
C     MDSWRITEFIELD_YZ_GL does not know about useSingleCPUio, so the faster
C     method that works for .not.useSingleCPUio cannot be used
       nrec_nl = 0
      else
       nrec_nl = int(ncvarrecs(ivar)/Nx)
      endif
      do irec = 1, nrec_nl
c     And now back-calculate what iobcs should be.
         do i=1,sNx
            iobcs= mod((irec-1)*sNx+i-1,nobcs)+1

            read(cunit) loc_ncvarindex
            if (loc_ncvarindex .NE. ncvarindex(ivar)) then
               IF ( irec.EQ.1 )
     &         print *, 'ctrl_set_unpack_yz:WARNING: wrong ncvarindex ',
     &              loc_ncvarindex, ncvarindex(ivar)
# ifndef READ_OLD_CTRL_PACK_FILE
               STOP 'in S/R ctrl_set_unpack_yz'
# endif
            endif
            read(cunit) loc_j
            read(cunit) loc_i
            do k = 1, Nr
               irectrue = (irec-1)*nobcs*Nr + (iobcs-1)*Nr + k
               cbuffindex = nwetglobal(k,iobcs)
               if ( cbuffindex .gt. 0 ) then
                  read(cunit) loc_ncbuffindex
                  if (loc_ncbuffindex .NE. cbuffindex) then
                     print *, 'WARNING: wrong cbuffindex ',
     &                    loc_ncbuffindex, cbuffindex
                     STOP 'in S/R ctrl_set_unpack_yz'
                  endif
                  read(cunit) loc_k
                  if (loc_k .NE. k) then
                     print *, 'WARNING: wrong k ',
     &                    loc_k, k
                     STOP 'in S/R ctrl_set_unpack_yz'
                  endif
                  read(cunit) (cbuff(ii), ii=1,cbuffindex)
               endif
               cbuffindex = 0
               do jp = 1,nPy
                do bj = jtlo,jthi
                 do j = jmin,jmax
                  do ip = 1,nPx
                   do bi = itlo,ithi
                    ii=mod((i-1)*Nr*sNy+(k-1)*sNy+j-1,sNx)+1
                    jj=mod(((i-1)*Nr*sNy+(k-1)*sNy+j-1)/sNx,sNy)+1
                    kk=int((i-1)*Nr*sNy+(k-1)*sNy+j-1)/(sNx*sNy)+1
                    if ( globmskyz(bi,ip,j,bj,jp,k,iobcs) .ne. 0. ) then
                       cbuffindex = cbuffindex + 1
                       globfld3d(ii,bi,ip,jj,bj,jp,kk) =
     &                      cbuff(cbuffindex)
cph(
                       globfldtmp2(bi,ip,jj,bj,jp) =
     &                      cbuff(cbuffindex)
cph)
#ifdef ALLOW_NONDIMENSIONAL_CONTROL_IO
                       globfld3d(ii,bi,ip,jj,bj,jp,kk) =
     &                      globfld3d(ii,bi,ip,jj,bj,jp,kk)/
# ifdef CTRL_UNPACK_PRECISE
     &                      sqrt(weightfldyz(bi,ip,j,bj,jp,k,iobcs))
# else
     &                      sqrt(weightfld(k,iobcs))
# endif
#endif /* ALLOW_NONDIMENSIONAL_CONTROL_IO */
                    else
                       globfld3d(ii,bi,ip,jj,bj,jp,kk) = 0. _d 0
                    endif
cph(
                    globfldtmp3(bi,ip,jj,bj,jp) =
     &                   globfld3d(ii,bi,ip,jj,bj,jp,kk)
cph)
                   enddo
                  enddo
                 enddo
                enddo
               enddo
c
               if ( doPackDiag ) then
                  write(cunit2,rec=irectrue) globfldtmp2
                  write(cunit3,rec=irectrue) globfldtmp3
               endif
c
c     -- end of k loop --
            enddo
c     -- end of i loop --
         enddo

         call MDSWRITEFIELD_3d_GL( fname, ctrlprec, 'RL',
     &                             Nr, globfld3d, irec,
     &                             optimcycle, mythid)

c     -- end of irec loop --
      enddo

      do irec = nrec_nl*nx+1,ncvarrecs(ivar)
c     And now back-calculate what iobcs should be.
         iobcs= mod(irec-1,nobcs)+1

         read(cunit) loc_ncvarindex
         if (loc_ncvarindex .NE. ncvarindex(ivar)) then
            IF ( irec.EQ.1 )
     &      print *, 'ctrl_set_unpack_yz:WARNING: wrong ncvarindex ',
     &           loc_ncvarindex, ncvarindex(ivar)
# ifndef READ_OLD_CTRL_PACK_FILE
            STOP 'in S/R ctrl_set_unpack_yz'
# endif
         endif
         read(cunit) loc_j
         read(cunit) loc_i
         do k = 1, Nr
            irectrue = (irec-1)*nobcs*Nr + (iobcs-1)*Nr + k
            cbuffindex = nwetglobal(k,iobcs)
            if ( cbuffindex .gt. 0 ) then
               read(cunit) loc_ncbuffindex
               if (loc_ncbuffindex .NE. cbuffindex) then
                  print *, 'WARNING: wrong cbuffindex ',
     &                 loc_ncbuffindex, cbuffindex
                  STOP 'in S/R ctrl_set_unpack_yz'
               endif
               read(cunit) loc_k
               if (loc_k .NE. k) then
                  print *, 'WARNING: wrong k ',
     &                 loc_k, k
                  STOP 'in S/R ctrl_set_unpack_yz'
               endif
               read(cunit) (cbuff(ii), ii=1,cbuffindex)
            endif
            cbuffindex = 0
            do jp = 1,nPy
             do bj = jtlo,jthi
              do j = jmin,jmax
               do ip = 1,nPx
                do bi = itlo,ithi
                  if ( globmskyz(bi,ip,j,bj,jp,k,iobcs) .ne. 0. ) then
                     cbuffindex = cbuffindex + 1
                     globfldyz(bi,ip,j,bj,jp,k) = cbuff(cbuffindex)
cph(
                     globfldtmp2(bi,ip,j,bj,jp) = cbuff(cbuffindex)
cph)
#ifdef ALLOW_NONDIMENSIONAL_CONTROL_IO
                     globfldyz(bi,ip,j,bj,jp,k) =
     &                    globfldyz(bi,ip,j,bj,jp,k)/
# ifdef CTRL_UNPACK_PRECISE
     &                    sqrt(weightfldyz(bi,ip,j,bj,jp,k,iobcs))
# else
     &                    sqrt(weightfld(k,iobcs))
# endif
#endif /* ALLOW_NONDIMENSIONAL_CONTROL_IO */
                  else
                     globfldyz(bi,ip,j,bj,jp,k) = 0. _d 0
                  endif
cph(
                  globfldtmp3(bi,ip,j,bj,jp) =
     &                 globfldyz(bi,ip,j,bj,jp,k)
cph)
                enddo
               enddo
              enddo
             enddo
            enddo
c
c     -- end of k loop
         enddo

         call MDSWRITEFIELD_YZ_GL( fname, ctrlprec, 'RL',
     &                             Nr, globfldyz, irec,
     &                             optimcycle, mythid)

c     -- end of irec loop --
      enddo

      _END_MASTER( mythid )

#endif

      return
      end

#include "EXF_OPTIONS.h"
#include "AD_CONFIG.h"
#ifdef ALLOW_AUTODIFF
# include "AUTODIFF_OPTIONS.h"
#endif

CBOP
C     !ROUTINE: G_EXF_ADJOINT_SNAPSHOTS
C     !INTERFACE:
      SUBROUTINE G_EXF_ADJOINT_SNAPSHOTS(
     I                 iwhen, myTime, myIter, myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE G_EXF_ADJOINT_SNAPSHOTS                       |
C     *==========================================================*
C     Tangent-Linear version of EXF Adjoint-variable output S/R:
C     extract tangent linear variable from TAF-generated
C     tangent linear common blocks, contained in g_common.h
C     and write fields to file;
C     Make sure common blocks in g_common.h are up-to-date
C     w.r.t. current adjoint code.
C     *==========================================================*
C     | SUBROUTINE G_EXF_ADJOINT_SNAPSHOTS                       |
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     == Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "EXF_PARAM.h"
#ifdef ALLOW_AUTODIFF_MONITOR
# include "g_common.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     iwhen  :: indicates where this S/R is called from
C     myIter :: Iteration counter for this thread
C     myTime :: Time counter for this thread
C     myThid :: Thread number for this instance of the routine.
      INTEGER iwhen
      _RL     myTime
      INTEGER myIter
      INTEGER myThid

#ifdef ALLOW_TANGENTLINEAR_RUN
#ifdef ALLOW_AUTODIFF_MONITOR

C     !FUNCTIONS:
      LOGICAL  DIFFERENT_MULTIPLE
      EXTERNAL DIFFERENT_MULTIPLE

C     !LOCAL VARIABLES:
C     suff   :: Hold suffix part of a filename
C     msgBuf :: Error message buffer
      CHARACTER*(10) suff
c     CHARACTER*(MAX_LEN_MBUF) msgBuf
CEOP

      IF (useEXF) THEN
       IF (
     &      DIFFERENT_MULTIPLE(adjDumpFreq,myTime,deltaTClock)
     &    ) THEN

        CALL TIMER_START('I/O (WRITE)        [TLM LOOP]', myThid )

C--     Set suffix for this set of data files.
        IF ( rwSuffixType.EQ.0 ) THEN
          WRITE(suff,'(I10.10)') myIter
        ELSE
          CALL RW_GET_SUFFIX( suff, myTime, myIter, myThid )
        ENDIF

        IF ( iwhen .EQ.1 ) THEN

        CALL WRITE_FLD_XY_RL ( 'G_Justress.',
     &       suff, g_ustress, myIter, myThid )
        CALL WRITE_FLD_XY_RL ( 'G_Jvstress.',
     &       suff, g_vstress, myIter, myThid )
        CALL WRITE_FLD_XY_RL ( 'G_Jhflux.',
     &       suff, g_hflux, myIter, myThid )
        CALL WRITE_FLD_XY_RL ( 'G_Jsflux.',
     &       suff, g_sflux, myIter, myThid )

        ELSEIF ( iwhen .EQ.2 ) THEN

# ifdef ALLOW_ATM_TEMP
        CALL WRITE_FLD_XY_RL ( 'G_Jatemp.',
     &       suff, g_atemp, myIter, myThid )
        CALL WRITE_FLD_XY_RL ( 'G_Jaqh.',
     &       suff, g_aqh, myIter, myThid )
        CALL WRITE_FLD_XY_RL ( 'G_Jprecip.',
     &       suff, g_precip, myIter, myThid )
# endif
        IF ( useAtmWind ) THEN
          CALL WRITE_FLD_XY_RL ( 'G_Juwind.',
     &         suff, g_uwind, myIter, myThid )
          CALL WRITE_FLD_XY_RL ( 'G_Jvwind.',
     &         suff, g_vwind, myIter, myThid )
        ENDIF
# ifdef ALLOW_DOWNWARD_RADIATION
        CALL WRITE_FLD_XY_RL ( 'G_Jswdown.',
     &       suff, g_swdown, myIter, myThid )
# endif
# ifdef ALLOW_CLIMSST_RELAXATION
        CALL WRITE_FLD_XY_RL ( 'G_Jclimsst.',
     &       suff, g_climsst, myIter, myThid )
# endif
# ifdef ALLOW_CLIMSSS_RELAXATION
        CALL WRITE_FLD_XY_RL ( 'G_Jclimsss.',
     &       suff, g_climsss, myIter, myThid )
# endif

        ENDIF

        CALL TIMER_STOP( 'I/O (WRITE)        [TLM LOOP]', myThid )

       ENDIF
      ENDIF

#endif /* ALLOW_AUTODIFF_MONITOR */
#endif /* ALLOW_TANGENTLINEAR_RUN */

      RETURN
      END

#include "FIZHI_OPTIONS.h"

C--  File fizhi_clockstuff.F:
C--   Contents
C--   o SET_ALARM
C--   o GET_ALARM
C--   o ALARM      (function)
C--   o ALARM2     (function)
C--   o ALARM2NEXT (function)
C--   o SET_TIME
C--   o GET_TIME
C--   o NSECF      (function)
C--   o NHMSF      (function)
C--   o NSECF2     (function)
C--   o FIXDATE
C--   o INTERP_TIME
C--   o TICK
C--   o TIC_TIME
C--   o NALARM     (function)
C--   o NALARM2    (function)
C--   o INCYMD     (function)
C--   o ASTRO
C--   o TIME_BOUND
C--   o TIME2FREQ2

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      subroutine set_alarm (tag,datein,timein,freq)
C***********************************************************************
C  Purpose
C  -------
C     Utility to Set Internal Alarms
C
C  Argument Description
C  --------------------
C     tag ....... Character String Tagging Alarm Process
C     date ...... Begining Date for Alarm
C     time ...... Begining Time for Alarm
C     freq ...... Repeating Frequency Interval for Alarm
C
C***********************************************************************

      implicit none
#include "EEPARAMS.h"
#include "chronos.h"

      character*(*) tag
      integer       freq,datein,timein

C-    functions:
      INTEGER  ILNBLNK
      EXTERNAL ILNBLNK

C-    local variables:
      integer myid
      logical first,set
      data          first /.true./
      integer n, iL

      myid = 1
      if(first) then
         ntags    = 1
          tags(1) = tag
         freqs(1) = freq
         dates(1) = datein
         times(1) = timein
         iL = ILNBLNK(tag)
         WRITE(standardMessageUnit,'(A,I8,A,I6.6,A,I10,2A)')
     &    '  Set Alarm for: ', datein, '  ', timein,
     &    ', with frequency: ', freq, ', and Tag: ',tag(1:iL)
      else

      set = .false.
      do n=1,ntags
       if(tag.eq.tags(n)) then
        if( myid.eq.1 ) then
         print *, 'Warning!  Alarm has already been set for Tag: ',tag
         print *, 'Changing  Alarm Information:'
         print *, 'Frequency: ',freqs(n),' (Old) ',freq,' (New)'
         print *, '    Date0: ',dates(n),' (Old) ',datein,' (New)'
         print *, '    Time0: ',times(n),' (Old) ',timein,' (New)'
        endif
        freqs(n) = freq
        dates(n) = datein
        times(n) = timein
        set = .true.
       endif
      enddo
      if(.not.set) then
            ntags = ntags+1
         if(ntags.gt.maxtag ) then
            if( myid.eq.1 ) then
            print *, 'Too many Alarms are Set!!'
            print *, 'Maximum Number of Alarms = ',maxtag
            endif
         call my_finalize
         call my_exit (101)
         endif
          tags(ntags) = tag
         freqs(ntags) = freq
         dates(ntags) = datein
         times(ntags) = timein
         iL = ILNBLNK(tag)
         WRITE(standardMessageUnit,'(A,I8,A,I6.6,A,I10,2A)')
     &    '  Set Alarm for: ', datein, '  ', timein,
     &    ', with frequency: ', freq, ', and Tag: ',tag(1:iL)
      endif
      endif

      first = .false.
      return
      end

      subroutine get_alarm (tag,datein,timein,freq,tleft)
C***********************************************************************
C  Purpose
C  -------
C     Utility to Get Internal Alarm Information
C
C  Input
C  -----
C     tag ....... Character String Tagging Alarm Process
C
C  Output
C  ------
C     datein ...... Begining  Date for Alarm
C     timein ...... Begining  Time for Alarm
C     freq ........ Frequency Interval for Alarm
C     tleft ....... Time Remaining (seconds) before Alarm is TRUE
C
C***********************************************************************

      implicit none
      character*(*) tag
      integer freq,datein,timein,tleft

#include "chronos.h"

      logical set,alarm
      external alarm
      integer myid,n,nalarm,nsecf

      myid = 1
      set = .false.
      do n=1,ntags
       if (tag.eq.tags(n)) then
         freq   = freqs(n)
         datein = dates(n)
         timein = times(n)

         if ( alarm(tag) ) then
          tleft = 0
         else
          call get_time (nymd,nhms)
          tleft = nsecf(freq) - nalarm(freq,nymd,nhms,datein,timein )
         endif

         set = .true.
       endif
      enddo

      if(.not.set) then
      if( myid.eq.1 ) print *, 'Alarm has not been set for Tag: ',tag
      freq  = 0
      datein  = 0
      timein  = 0
      tleft = 0
      endif

      return
      end

      LOGICAL FUNCTION ALARM (tag)
      implicit none
      character*(*) tag
#include "chronos.h"

      integer datein,timein
      integer n,nalarm
      external nalarm

      call get_time (datein,timein)

      alarm = .false.
      do n=1,ntags
       if( tags(n).eq.tag  ) then
        if( freqs(n).eq.0 ) then
          alarm = (dates(n).eq.datein) .and. (times(n).eq.timein)
        else
          alarm = ( datein.gt.dates(n) .or.
     &             (datein.eq.dates(n) .and. timein.ge.times(n)) )
     &    .and. nalarm( freqs(n),datein,timein,dates(n),times(n) ).eq.0
        endif
       endif
      enddo

      return
      end

      LOGICAL FUNCTION ALARM2 (tag)
      implicit none
      character*(*) tag
#include "chronos.h"

      integer datein,timein
      integer n,nalarm2
      external nalarm2

      call get_time (datein,timein)

      alarm2 = .false.
      do n=1,ntags
       if( tags(n).eq.tag  ) then
        if( freqs(n).eq.0 ) then
          alarm2 = (dates(n).eq.datein) .and. (times(n).eq.timein)
        else
          alarm2 = ( datein.gt.dates(n) .or.
     &              (datein.eq.dates(n) .and. timein.ge.times(n)) )
     &    .and. nalarm2( freqs(n),datein,timein,dates(n),times(n) ).eq.0
        endif
       endif
      enddo

      return
      end

      LOGICAL FUNCTION ALARM2NEXT (tag,deltat)
      implicit none
      character*(*) tag
      _RL deltat
#include "chronos.h"

      integer datein,timein,ndt
      integer dateminus,timeminus
      integer n,nalarm2
      external nalarm2

      ndt = int(deltat)
      call get_time (dateminus,timeminus)
      datein = dateminus
      timein = timeminus
      call tick(datein,timein,ndt)

      alarm2next = .false.
      do n=1,ntags
       if( tags(n).eq.tag  ) then
        if( freqs(n).eq.0 ) then
          alarm2next = (dates(n).eq.datein) .and. (times(n).eq.timein)
        else
          alarm2next = ( datein.gt.dates(n) .or.
     &                  (datein.eq.dates(n) .and. timein.ge.times(n)) )
     &    .and. nalarm2( freqs(n),datein,timein,dates(n),times(n) ).eq.0
        endif
       endif
      enddo

      return
      end

      subroutine set_time (datein,timein)
      implicit none
      integer  datein,timein

#include "chronos.h"

      integer myid

      myid = 1
      if(  myid.eq.1 ) then
      print *, 'Setting Clock'
      print *, 'Date: ',datein
      print *, 'Time: ',timein
      endif

      nymd = datein
      nhms = timein
      return
      end

      subroutine get_time (datein,timein)
      implicit none
      integer datein,timein

#include "chronos.h"

      datein = nymd
      timein = nhms
      return
      end

      function nsecf (nhms)
C***********************************************************************
C  Purpose
C     Converts NHMS format to Total Seconds
C
C***********************************************************************
      implicit none
      integer  nhms, nsecf
      nsecf =  nhms/10000*3600 + mod(nhms,10000)/100*60 + mod(nhms,100)
      return
      end

      function nhmsf (nsec)
C***********************************************************************
C  Purpose
C     Converts Total Seconds to NHMS format
C
C***********************************************************************
      implicit none
      integer  nhmsf, nsec
      nhmsf =  nsec/3600*10000 + mod(nsec,3600)/60*100 + mod(nsec,60)
      return
      end

      function nsecf2 (nhhmmss,nmmdd,nymd)
C***********************************************************************
C  Purpose
C     Computes the Total Number of seconds from NYMD using NHHMMSS & NMMDD
C
C  Arguments   Description
C     NHHMMSS  IntervaL Frequency (HHMMSS)
C     NMMDD    Interval Frequency (MMDD)
C     NYMD     Current  Date      (YYMMDD)
C
C  NOTE:
C     IF (NMMDD.ne.0), THEN HOUR FREQUENCY HH MUST BE < 24
C
C***********************************************************************
      implicit none

      integer nsecf2,nhhmmss,nmmdd,nymd

      INTEGER NSDAY, NCYCLE
      PARAMETER ( NSDAY  = 86400 )
      PARAMETER ( NCYCLE = 1461*24*3600 )

      INTEGER YEAR, MONTH, DAY

c     INTEGER  MNDY(12,4)
      INTEGER  MNDY(12*4)
      DATA MNDY /0,31,60,91,121,152,182,213,244,274,305,335,366,
     &           397,34*0 /

      integer nsecf,i,nsegm,nsegd,iday,iday2,nday

C***********************************************************************
C*                 COMPUTE # OF SECONDS FROM NHHMMSS                   *
C***********************************************************************

      nsecf2 = nsecf( nhhmmss )

      if( nmmdd.eq.0 ) return

C***********************************************************************
C*                 COMPUTE # OF DAYS IN A 4-YEAR CYCLE                 *
C***********************************************************************

      DO I=15,48
c     MNDY(I,1) = MNDY(I-12,1) + 365
        MNDY(I) = MNDY(I-12) + 365
      ENDDO

C***********************************************************************
C*                 COMPUTE # OF SECONDS FROM NMMDD                     *
C***********************************************************************

      nsegm =     nmmdd/100
      nsegd = mod(nmmdd,100)

      YEAR   = NYMD / 10000
      MONTH  = MOD(NYMD,10000) / 100
      DAY    = MOD(NYMD,100)

c     IDAY   = MNDY( MONTH ,MOD(YEAR ,4)+1 )
      IDAY   = MNDY( MONTH +12*MOD(YEAR ,4) )
      month = month + nsegm
      If( month.gt.12 ) then
      month = month - 12
      year = year + 1
      endif
c     IDAY2  = MNDY( MONTH ,MOD(YEAR ,4)+1 )
      IDAY2  = MNDY( MONTH +12*MOD(YEAR ,4) )

                    nday = iday2-iday
      if(nday.lt.0) nday = nday + 1461
                    nday = nday + nsegd

      nsecf2 = nsecf2 + nday*nsday

      return
      end

      subroutine fixdate (nymd)
      implicit none
      integer nymd

C Modify 6-digit YYMMDD for dates between 1950-2050
C -------------------------------------------------
      if (nymd .lt. 500101) then
        nymd = 20000000 + nymd
      else if (nymd .le. 991231) then
        nymd = 19000000 + nymd
      endif

      return
      end

      subroutine interp_time ( nymd ,nhms ,
     &                         nymd1,nhms1, nymd2,nhms2, fac1,fac2 )
C***********************************************************************
C
C  PURPOSE:
C  ========
C    Compute interpolation factors, fac1 & fac2, to be used in the
C    calculation of the instantanious boundary conditions, ie:
C
C               q(i,j) = fac1*q1(i,j) + fac2*q2(i,j)
C    where:
C               q(i,j) => Boundary Data valid    at (nymd  , nhms )
C              q1(i,j) => Boundary Data centered at (nymd1 , nhms1)
C              q2(i,j) => Boundary Data centered at (nymd2 , nhms2)
C
C  INPUT:
C  ======
C    nymd     : Date (yymmdd) of Current Timestep
C    nhms     : Time (hhmmss) of Current Timestep
C    nymd1    : Date (yymmdd) of Boundary Data 1
C    nhms1    : Time (hhmmss) of Boundary Data 1
C    nymd2    : Date (yymmdd) of Boundary Data 2
C    nhms2    : Time (hhmmss) of Boundary Data 2
C
C  OUTPUT:
C  =======
C    fac1     : Interpolation factor for Boundary Data 1
C    fac2     : Interpolation factor for Boundary Data 2
C
C
C***********************************************************************
      implicit none

      integer nhms,nymd,nhms1,nymd1,nhms2,nymd2
      _RL fac1,fac2

      INTEGER  YEAR , MONTH , DAY , SEC
      INTEGER  YEAR1, MONTH1, DAY1, SEC1
      INTEGER  YEAR2, MONTH2, DAY2, SEC2

      _RL time00, time1, time2

      INTEGER    DAYSCY
      parameter ( dayscy   = 365*4 + 1 )

      INTEGER MNDY(12*4)

      LOGICAL FIRST
      DATA    FIRST/.TRUE./

      DATA MNDY /0,31,60,91,121,152,182,213,244,274,305,335,366,
     &           397,34*0 /

      integer i,nsecf

C***********************************************************************
C*                         SET TIME BOUNDARIES                         *
C***********************************************************************

      YEAR   = NYMD / 10000
      MONTH  = MOD(NYMD,10000) / 100
      DAY    = MOD(NYMD,100)
      SEC    = NSECF(NHMS)

      YEAR1  = NYMD1 / 10000
      MONTH1 = MOD(NYMD1,10000) / 100
      DAY1   = MOD(NYMD1,100)
      SEC1   = NSECF(NHMS1)

      YEAR2  = NYMD2 / 10000
      MONTH2 = MOD(NYMD2,10000) / 100
      DAY2   = MOD(NYMD2,100)
      SEC2   = NSECF(NHMS2)

C***********************************************************************
C*                    COMPUTE DAYS IN 4-YEAR CYCLE                     *
C***********************************************************************

      IF(FIRST) THEN
      DO I=15,48
        MNDY(I) = MNDY(I-12) + 365
      ENDDO
      FIRST=.FALSE.
      ENDIF

C***********************************************************************
C*                     COMPUTE INTERPOLATION FACTORS                   *
C***********************************************************************

      time00 = DAY + MNDY(MONTH +12*MOD(YEAR ,4)) + float(sec )/86400.
      time1 = DAY1 + MNDY(MONTH1+12*MOD(YEAR1,4)) + float(sec1)/86400.
      time2 = DAY2 + MNDY(MONTH2+12*MOD(YEAR2,4)) + float(sec2)/86400.

      if( time00 .lt.time1 ) time00  = time00  + dayscy
      if( time2.lt.time1 ) time2 = time2 + dayscy

      fac1  = (time2-time00)/(time2-time1)
      fac2  = (time00-time1)/(time2-time1)

      RETURN
      END

      subroutine tick (nymd,nhms,ndt)
C***********************************************************************
C  Purpose
C     Tick the Date (nymd) and Time (nhms) by NDT (seconds)
C
C***********************************************************************
      implicit none

      integer nymd,nhms,ndt

      integer nsec,nsecf,incymd,nhmsf

      IF(NDT.NE.0) THEN
      NSEC = NSECF(NHMS) + NDT

      IF (NSEC.GT.86400)  THEN
      DO WHILE (NSEC.GT.86400)
      NSEC = NSEC - 86400
      NYMD = INCYMD (NYMD,1)
      ENDDO
      ENDIF

      IF (NSEC.EQ.86400)  THEN
      NSEC = 0
      NYMD = INCYMD (NYMD,1)
      ENDIF

      IF (NSEC.LT.00000)  THEN
      DO WHILE (NSEC.LT.0)
      NSEC = 86400 + NSEC
      NYMD = INCYMD (NYMD,-1)
      ENDDO
      ENDIF

      NHMS = NHMSF (NSEC)
      ENDIF

#ifdef FIZHI_USE_FIXED_DAY
      NYMD = 20040321
#endif

      RETURN
      END

      subroutine tic_time (mymd,mhms,ndt)
C***********************************************************************
C  PURPOSE
C     Tick the Clock by NDT (seconds)
C
C***********************************************************************
      implicit none
#include "chronos.h"

      integer mymd,mhms,ndt

      integer nsec,nsecf,incymd,nhmsf

      IF(NDT.NE.0) THEN
      NSEC = NSECF(NHMS) + NDT

      IF (NSEC.GT.86400)  THEN
      DO WHILE (NSEC.GT.86400)
      NSEC = NSEC - 86400
      NYMD = INCYMD (NYMD,1)
      ENDDO
      ENDIF

      IF (NSEC.EQ.86400)  THEN
      NSEC = 0
      NYMD = INCYMD (NYMD,1)
      ENDIF

      IF (NSEC.LT.00000)  THEN
      DO WHILE (NSEC.LT.0)
      NSEC = 86400 + NSEC
      NYMD = INCYMD (NYMD,-1)
      ENDDO
      ENDIF

      NHMS = NHMSF (NSEC)
      ENDIF

C Pass Back Current Updated Time
C ------------------------------
      mymd = nymd
      mhms = nhms

      RETURN
      END

      FUNCTION NALARM (MHMS,NYMD,NHMS,NYMD0,NHMS0)
C***********************************************************************
C  PURPOSE
C     COMPUTES MODULO-FRACTION BETWEEN MHHS AND TOTAL TIME
C  USAGE
C  ARGUMENTS   DESCRIPTION
C     MHMS     INTERVAL FREQUENCY (HHMMSS)
C     NYMD     CURRENT   YYMMDD
C     NHMS     CURRENT   HHMMSS
C     NYMD0    BEGINNING YYMMDD
C     NHMS0    BEGINNING HHMMSS
C
C***********************************************************************
      implicit none

      integer nalarm,MHMS,NYMD,NHMS,NYMD0,NHMS0

      integer nsday, ncycle
      PARAMETER ( NSDAY  = 86400 )
      PARAMETER ( NCYCLE = 1461*24*3600 )

      INTEGER YEAR, MONTH, DAY, SEC, YEAR0, MONTH0, DAY0, SEC0

      integer MNDY(12*4)
      DATA MNDY /0,31,60,91,121,152,182,213,244,274,305,335,366,
     &           397,34*0 /

      integer i,nsecf,iday,iday0,nsec,nsec0,ntime

C***********************************************************************
C*                 COMPUTE # OF DAYS IN A 4-YEAR CYCLE                 *
C***********************************************************************

      DO I=15,48
        MNDY(I) = MNDY(I-12) + 365
      ENDDO

C***********************************************************************
C*                   SET CURRENT AND BEGINNING TIMES                   *
C***********************************************************************

      YEAR   = NYMD / 10000
      MONTH  = MOD(NYMD,10000) / 100
      DAY    = MOD(NYMD,100)
      SEC    = NSECF(NHMS)

      YEAR0  = NYMD0 / 10000
      MONTH0 = MOD(NYMD0,10000) / 100
      DAY0   = MOD(NYMD0,100)
      SEC0   = NSECF(NHMS0)

C***********************************************************************
C*      COMPUTE POSITIONS IN CYCLE FOR CURRENT AND BEGINNING TIMES     *
C***********************************************************************

      IDAY   = (DAY -1) + MNDY( MONTH +12*MOD(YEAR ,4) )
      IDAY0  = (DAY0-1) + MNDY( MONTH0+12*MOD(YEAR0,4) )

      NSEC   = IDAY *NSDAY + SEC
      NSEC0  = IDAY0*NSDAY + SEC0

                       NTIME  = NSEC-NSEC0
      IF (NTIME.LT.0 ) NTIME  = NTIME + NCYCLE
                       NALARM = NTIME
      IF ( MHMS.NE.0 ) NALARM = MOD( NALARM,NSECF(MHMS) )

      RETURN
      END

      FUNCTION NALARM2(MHMS,NYMD,NHMS,NYMD0,NHMS0)
C***********************************************************************
C  PURPOSE
C     COMPUTES MODULO-FRACTION BETWEEN MHHS AND TOTAL TIME
C  USAGE
C  ARGUMENTS   DESCRIPTION
C     MHMS     INTERVAL FREQUENCY (MMDDHHMMSS)
C     NYMD     CURRENT   YYMMDD
C     NHMS     CURRENT   HHMMSS
C     NYMD0    BEGINNING YYMMDD
C     NHMS0    BEGINNING HHMMSS
C
C***********************************************************************
      implicit none

      integer nalarm2,MHMS,NYMD,NHMS,NYMD0,NHMS0

      integer nsday, ncycle
      PARAMETER ( NSDAY  = 86400 )
      PARAMETER ( NCYCLE = 1461*24*3600 )

      INTEGER YEAR, MONTH, DAY, SEC, YEAR0, MONTH0, DAY0, SEC0

      integer MNDY(12*4)
      DATA MNDY /0,31,60,91,121,152,182,213,244,274,305,335,366,
     &           397,34*0 /
      INTEGER NDPM(12)
      DATA NDPM /31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31/

      integer i,nsecf,iday,iday0,nsec,nsec0,ntime
      integer NHMMSS,NMMDD
      integer iloop
      integer testnymd,testnhms,testndpm

C***********************************************************************
C*                 COMPUTE # OF DAYS IN A 4-YEAR CYCLE                 *
C***********************************************************************

      DO I=15,48
        MNDY(I) = MNDY(I-12) + 365
      ENDDO

C***********************************************************************
C*                   SET CURRENT AND BEGINNING TIMES                   *
C***********************************************************************

      YEAR   = NYMD / 10000
      MONTH  = MOD(NYMD,10000) / 100
      DAY    = MOD(NYMD,100)
      SEC    = NSECF(NHMS)

      YEAR0  = NYMD0 / 10000
      MONTH0 = MOD(NYMD0,10000) / 100
      DAY0   = MOD(NYMD0,100)
      SEC0   = NSECF(NHMS0)

C***********************************************************************
C*      COMPUTE POSITIONS IN CYCLE FOR CURRENT AND BEGINNING TIMES     *
C***********************************************************************

      IDAY   = (DAY -1) + MNDY( MONTH +12*MOD(YEAR ,4) )
      IDAY0  = (DAY0-1) + MNDY( MONTH0+12*MOD(YEAR0,4) )

      NSEC   = IDAY *NSDAY + SEC
      NSEC0  = IDAY0*NSDAY + SEC0

      NTIME  = NSEC-NSEC0
      IF(NTIME.LT.0) NTIME  = NTIME + NCYCLE
      NALARM2 = NTIME
      IF(MHMS.NE.0)NALARM2 = MOD( NALARM2,NSECF(MHMS) )
      IF(MHMS.GE.1000000) THEN
       testnymd=nymd0
       testnhms=nhms0
       NMMDD = MHMS / 1000000
       NHMMSS = MOD(MHMS,1000000)
       do iloop=1,100000
        testnymd=testnymd + nmmdd
        testnhms=testnhms + nhmmss
        year0=testnymd/10000
        month0=mod(testnymd,10000)/100
        day0 = mod(testnymd,100)
        testndpm = ndpm(month0)
        if( month0.eq.2  .and. mod(year0,4).eq.0) testndpm = 29
        if(testnhms.ge.240000) then
         testnhms = testnhms-240000
         testnymd = testnymd + 1
         day0 = day0 + 1
        endif
        if(day0.gt.testndpm) then
         testnymd = testnymd - testndpm
         testnymd = testnymd + 100
         day0 = day0 - testndpm
         month0 = month0 + 1
        endif
        if(month0.gt.12) then
         month0 = month0 - 12
         year0 = year0 + 1
         testnymd = testnymd + 10000 - 1200
        endif
        sec0 = nsecf(testnhms)
        iday0 = (day0-1) + MNDY(month0+12*mod(year0,4) )
        nsec0 = iday0 *nsday + sec0
        if( (testnymd.gt.nymd) .or.
     &         (testnymd.eq.testnymd) .and. (testnhms.gt.nhms) )
     &                    go to 200
        nalarm2 = nsec-nsec0
       enddo
 200   continue
      ENDIF

      RETURN
      END

      FUNCTION INCYMD (NYMD,M)
C***********************************************************************
C  PURPOSE
C     INCYMD:  NYMD CHANGED BY ONE DAY
C     MODYMD:  NYMD CONVERTED TO JULIAN DATE
C  DESCRIPTION OF INPUT VARIABLES
C     NYMD     CURRENT DATE IN YYMMDD FORMAT
C     M        +/- 1 (DAY ADJUSTMENT)
C
C***********************************************************************
      implicit none
      integer incymd,nymd,m

      integer ny,nm,nd,ny00,modymd

      INTEGER NDPM(12)
      DATA NDPM /31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31/
      LOGICAL LEAP
      DATA NY00 /1900 /
      LEAP(NY) = MOD(NY,4).EQ.0 .AND. (NY.NE.0 .OR. MOD(NY00,400).EQ.0)

C***********************************************************************
C
      NY = NYMD / 10000
      NM = MOD(NYMD,10000) / 100
      ND = MOD(NYMD,100) + M

      IF (ND.EQ.0) THEN
      NM = NM - 1
      IF (NM.EQ.0) THEN
          NM = 12
          NY = NY - 1
      ENDIF
      ND = NDPM(NM)
      IF (NM.EQ.2 .AND. LEAP(NY))  ND = 29
      ENDIF

      IF (ND.EQ.29 .AND. NM.EQ.2 .AND. LEAP(NY))  GO TO 20

      IF (ND.GT.NDPM(NM)) THEN
      ND = 1
      NM = NM + 1
      IF (NM.GT.12) THEN
          NM = 1
          NY = NY + 1
      ENDIF
      ENDIF

   20 CONTINUE
      INCYMD = NY*10000 + NM*100 + ND

      RETURN

C***********************************************************************
C                      E N T R Y    M O D Y M D
C***********************************************************************

      ENTRY MODYMD (NYMD)

      NY = NYMD / 10000
      NM = MOD(NYMD,10000) / 100
      ND = MOD(NYMD,100)

   40 CONTINUE
      IF (NM.LE.1)  GO TO 60
      NM = NM - 1
      ND = ND + NDPM(NM)
      IF (NM.EQ.2 .AND. LEAP(NY))  ND = ND + 1
      GO TO 40

   60 CONTINUE
      MODYMD = ND

      RETURN
      END

      SUBROUTINE ASTRO ( NYMD,NHMS,ALAT,ALON,IRUN,COSZ,RA )
C***********************************************************************
C
C  INPUT:
C  ======
C    NYMD      : CURRENT YYMMDD
C    NHMS      : CURRENT HHMMSS
C    ALAT(IRUN):LATITUDES  IN DEGREES.
C    ALON(IRUN):LONGITUDES IN DEGREES. (0 = GREENWICH, + = EAST).
C    IRUN      : # OF POINTS TO CALCULATE
C
C  OUTPUT:
C  =======
C    COSZ(IRUN)  : COSINE OF ZENITH ANGLE.
C    RA          : EARTH-SUN DISTANCE IN UNITS OF
C                  THE ORBITS SEMI-MAJOR AXIS.
C
C  NOTE:
C  =====
C  THE INSOLATION AT THE TOP OF THE ATMOSPHERE IS:
C
C  S(I) = (SOLAR CONSTANT)*(1/RA**2)*COSZ(I),
C
C  WHERE:
C  RA AND COSZ(I) ARE THE TWO OUTPUTS OF THIS SUBROUTINE.
C
C***********************************************************************

      implicit none

C Input Variables
C ---------------
      integer nymd, nhms, irun
      _RL getcon, cosz(irun), alat(irun), alon(irun), ra

C Local Variables
C ---------------
      integer year, day, sec, month, iday, idayp1
      integer dayscy
      integer i,nsecf,k,km,kp

      _RL hc
      _RL pi, zero, one, two, six, dg2rd, yrlen, eqnx, ob, ecc, per
      _RL daylen, fac, thm, thp, thnow, zs, zc, sj, cj

      parameter ( zero  = 0.0 )
      parameter ( one   = 1.0 )
      parameter ( two   = 2.0 )
      parameter ( six   = 6.0 )
      parameter ( dayscy   = 365*4 + 1 )

      _RL      TH(DAYSCY),T0,T1,T2,T3,T4,FUN,Y
      INTEGER  MNDY(12*4)

      LOGICAL FIRST
      DATA    FIRST/.TRUE./
      SAVE

      DATA MNDY /0,31,60,91,121,152,182,213,244,274,305,335,366,
     &           397,34*0 /

      FUN(Y,PI,ECC,YRLEN,PER) = (TWO*PI/((ONE-ECC**2)**1.5))*(ONE/YRLEN)
     &       * (ONE - ECC*COS(Y-PER)) ** 2

C***********************************************************************
C*                         SET SOME CONSTANTS                          *
C***********************************************************************
      pi = getcon('PI')
      dg2rd = getcon('DEG2RAD')
      yrlen = getcon('YRLEN')
      ob =  getcon('OBLDEG') * dg2rd
      daylen = getcon('SDAY')
      eqnx = getcon('VERNAL EQUINOX')
      ecc = getcon('ECCENTRICITY')
      per = getcon('PERIHELION') * dg2rd

C***********************************************************************
C*                          SET CURRENT TIME                           *
C***********************************************************************

      YEAR  = NYMD / 10000
      MONTH = MOD(NYMD,10000) / 100
      DAY   = MOD(NYMD,100)
      SEC   = NSECF(NHMS)

C***********************************************************************
C*                 COMPUTE DAY-ANGLES FOR 4-YEAR CYCLE                 *
C***********************************************************************

      IF(FIRST) THEN
           DO 100 I=15,48
             MNDY(I) = MNDY(I-12) + 365
100        CONTINUE

           KM  = INT(EQNX) + 1
           FAC = KM-EQNX
           T0 = ZERO
           T1 = FUN(T0,PI,ECC,YRLEN,PER         )*FAC
           T2 = FUN(ZERO+T1/TWO,PI,ECC,YRLEN,PER)*FAC
           T3 = FUN(ZERO+T2/TWO,PI,ECC,YRLEN,PER)*FAC
           T4 = FUN(ZERO+T3,PI,ECC,YRLEN,PER    )*FAC
           TH(KM) = (T1 + TWO*(T2 + T3) + T4) / SIX

           DO 200 K=2,DAYSCY
           T1 = FUN(TH(KM),PI,ECC,YRLEN,PER       )
           T2 = FUN(TH(KM)+T1/TWO,PI,ECC,YRLEN,PER)
           T3 = FUN(TH(KM)+T2/TWO,PI,ECC,YRLEN,PER)
           T4 = FUN(TH(KM)+T3,PI,ECC,YRLEN,PER    )
           KP = MOD(KM,DAYSCY) + 1
           TH(KP) = TH(KM) + (T1 + TWO*(T2 + T3) + T4) / SIX
           KM = KP
 200       CONTINUE

           FIRST=.FALSE.
      ENDIF

C***********************************************************************
C*            COMPUTE EARTH-SUN DISTANCE TO CURRENT SECOND             *
C***********************************************************************

      IDAY   = DAY + MNDY(MONTH+12*MOD(YEAR,4) )
      IDAYP1 = MOD( IDAY,DAYSCY) + 1
      THM    = MOD( TH(IDAY)  ,TWO*PI)
      THP    = MOD( TH(IDAYP1),TWO*PI)

      IF(THP.LT.THM) THP = THP + TWO*PI
      FAC   = FLOAT(SEC)/DAYLEN
      THNOW = THM*(ONE-FAC) + THP*FAC

      ZS = SIN(THNOW) * SIN(OB)
      ZC = SQRT(ONE-ZS*ZS)
      RA = (1.-ECC*ECC) / ( ONE-ECC*COS(THNOW-PER) )

C***********************************************************************
C*                 COMPUTE COSINE OF THE ZENITH ANGLE                  *
C***********************************************************************

      FAC  = FAC*TWO*PI + PI
      DO I = 1,IRUN

      HC = COS( FAC+ALON(I)*DG2RD )
      SJ = SIN(ALAT(I)*DG2RD)
      CJ = SQRT(ONE-SJ*SJ)

          COSZ(I) = SJ*ZS + CJ*ZC*HC
      IF( COSZ(I).LT.ZERO ) COSZ(I) = ZERO
      ENDDO

      RETURN
      END

      subroutine time_bound(nymd,nhms,nymd1,nhms1,nymd2,nhms2,imnm,imnp)
C***********************************************************************
C  PURPOSE
C     Compute Date and Time boundaries.
C
C  ARGUMENTS   DESCRIPTION
C     nymd .... Current    Date
C     nhms .... Current    Time
C     nymd1 ... Previous   Date Boundary
C     nhms1 ... Previous   Time Boundary
C     nymd2 ... Subsequent Date Boundary
C     nhms2 ... Subsequent Time Boundary
C
C     imnm .... Previous   Time Index for Interpolation
C     imnp .... Subsequent Time Index for Interpolation
C
C***********************************************************************

      implicit none
      integer  nymd,nhms, nymd1,nhms1, nymd2,nhms2

C Local Variables
C ---------------
      integer  month,day,nyear,midmon1,midmon,midmon2
      integer  imnm,imnp
      INTEGER  DAYS(14), daysm, days0, daysp
      DATA     DAYS /31,31,28,31,30,31,30,31,31,30,31,30,31,31/

      integer nmonf,ndayf,n
      NMONF(N) = MOD(N,10000)/100
      NDAYF(N) = MOD(N,100)

C*********************************************************************
C**** Find Proper Month and Time Boundaries for Climatological Data **
C*********************************************************************

      MONTH  = NMONF(NYMD)
      DAY    = NDAYF(NYMD)

      daysm  = days(month  )
      days0  = days(month+1)
      daysp  = days(month+2)

C Check for Leap Year
C -------------------
      nyear = nymd/10000
      if( 4*(nyear/4).eq.nyear ) then
      if( month.eq.3 ) daysm = daysm+1
      if( month.eq.2 ) days0 = days0+1
      if( month.eq.1 ) daysp = daysp+1
      endif

      MIDMON1 = daysm/2 + 1
      MIDMON  = days0/2 + 1
      MIDMON2 = daysp/2 + 1


      IF(DAY.LT.MIDMON) THEN
         imnm = month
         imnp = month + 1
         nymd2 = (nymd/10000)*10000 + month*100 + midmon
         nhms2 = 000000
         nymd1 = nymd2
         nhms1 = nhms2
         call tick ( nymd1,nhms1,       -midmon  *86400 )
         call tick ( nymd1,nhms1,-(daysm-midmon1)*86400 )
      ELSE
         IMNM = MONTH + 1
         IMNP = MONTH + 2
         nymd1 = (nymd/10000)*10000 + month*100 + midmon
         nhms1 = 000000
         nymd2 = nymd1
         nhms2 = nhms1
         call tick ( nymd2,nhms2,(days0-midmon)*86400 )
         call tick ( nymd2,nhms2,       midmon2*86400 )
      ENDIF

C -------------------------------------------------------------
C Note:  At this point, imnm & imnp range between 01-14, where
C        01    -> Previous years December
C        02-13 -> Current  years January-December
C        14    -> Next     years January
C -------------------------------------------------------------

      imnm = imnm-1
      imnp = imnp-1

      if( imnm.eq.0  ) imnm = 12
      if( imnp.eq.0  ) imnp = 12
      if( imnm.eq.13 ) imnm = 1
      if( imnp.eq.13 ) imnp = 1

      return
      end
      subroutine time2freq2(MMDD,NYMD,NHMS,timeleft)
C***********************************************************************
C  PURPOSE
C     COMPUTES TIME IN SECONDS UNTIL WE REACH THE NEXT MMDD
C       (ASSUME that the target time is 0Z)
C
C  ARGUMENTS   DESCRIPTION
C     MMDD     FREQUENCY (MMDDHHMMSS)
C     NYMD     CURRENT   YYMMDD
C     NHMS     CURRENT   HHMMSS
C     TIMELEFT TIME LEFT (SECONDS)
C
C  NOTES - Only used when the frequency is in units of months
C          Assumes that we always want to be at a month boundary
C***********************************************************************
      implicit none

      integer mmdd,nymd,nhms,timeleft,daysleft

      integer nsday
      PARAMETER ( NSDAY  = 86400 )
      integer year, month, day, sec
      integer yearnext, monthnext, daynext
      integer i,nsecf,iday,idaynext,nsec
      integer testnymd
      integer MNDY(12*4)
      DATA MNDY /0,31,60,91,121,152,182,213,244,274,305,335,366,
     &           397,34*0 /

C***********************************************************************
C*                 COMPUTE # OF DAYS IN A 4-YEAR CYCLE                 *
C***********************************************************************
      DO I=15,48
        MNDY(I) = MNDY(I-12) + 365
      ENDDO
C***********************************************************************
C*                   SET CURRENT TIME ELEMENTS                                 *
C***********************************************************************
      YEAR   = NYMD / 10000
      MONTH  = MOD(NYMD,10000) / 100
      DAY    = MOD(NYMD,100)
      SEC    = NSECF(NHMS)
C***********************************************************************
C*      COMPUTE POSITIONS IN CYCLE FOR CURRENT AND BEGINNING TIMES     *
C***********************************************************************
      IDAY   = (DAY -1) + MNDY( MONTH +12*MOD(YEAR ,4) )
      NSEC   = IDAY *NSDAY + SEC

      testnymd=nymd + mmdd
      yearnext=testnymd/10000
      monthnext=mod(testnymd,10000)/100
      daynext = 1
      if(monthnext.gt.12) then
       monthnext = monthnext - 12
       yearnext = yearnext + 1
      endif
      testnymd = yearnext*10000 + monthnext*100 + daynext
      idaynext = MNDY(monthnext+12*mod(yearnext,4) )
      daysleft = idaynext - iday
      if(daysleft.lt.0) daysleft = daysleft + 1461

      timeleft = daysleft * nsday - sec

      RETURN
      END

#include "THSICE_OPTIONS.h"
#ifdef ALLOW_EXF
#include "EXF_OPTIONS.h"
#endif

CBOP
C     !ROUTINE: THSICE_MAP_EXF
C     !INTERFACE:
      SUBROUTINE THSICE_MAP_EXF(
     I                  iceMsk, locSST,
     O                  totPrc, snowPrc, qPrcRnO, flxSW,
     I                  iMin,iMax,jMin,jMax, bi,bj, myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R  THSICE_MAP_EXF
C     | Interface S/R : map Precip, Snow and shortwave fluxes
C     |                 from pkg EXF to thsice variables
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     == Global data ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "FFIELDS.h"
#ifdef ALLOW_EXF
# include "EXF_CONSTANTS.h"
# include "EXF_PARAM.h"
# include "EXF_FIELDS.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
C     iceMsk    :: sea-ice fraction: no ice=0, grid all ice 1  []
C     locSST    :: local Sea-Surface Temperature [deg.C]
C     totPrc    :: Total Precipitation (including run-off) [kg/m2/s]
C     snowPrc   :: Snow Precipitation [kg/m2/s]
C     qPrcRnO   :: Energy content of Precip+RunOff (+=down) [W/m2]
C     flxSW     :: Downward short-wave surface flux (+=down) [W/m2]
C     iMin,iMax :: range of indices of computation domain
C     jMin,jMax :: range of indices of computation domain
C     bi,bj     :: current tile indices
C     myThid      :: Thread no. that called this routine.
      _RL iceMsk (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL locSST (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL totPrc (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL snowPrc(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL qPrcRnO(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL flxSW  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER iMin,iMax
      INTEGER jMin,jMax
      INTEGER bi,bj
      INTEGER myThid
CEOP

#ifdef ALLOW_EXF

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C     === Local variables ===
C     i,j   :: current grid point indices
      INTEGER i,j

      DO j = jMin, jMax
       DO i = iMin, iMax
#ifdef ALLOW_ATM_TEMP
        totPrc(i,j) = precip(i,j,bi,bj)*rhoConstFresh
#endif
#ifdef ALLOW_RUNOFF
        totPrc(i,j) = totPrc(i,j) + runoff(i,j,bi,bj)*rhoConstFresh
#else
        STOP 'ABNORMAL END: S/R THSICE_MAP_EXF: ALLOW_RUNOFF undef'
#endif
#ifdef ALLOW_DOWNWARD_RADIATION
        flxSW (i,j) = swdown(i,j,bi,bj)
#else
      STOP 'ABNORMAL END: S/R THSICE_MAP_EXF: DOWNWARD_RADIATION undef'
#endif
       ENDDO
      ENDDO

#ifdef ALLOW_ATM_TEMP
      IF ( snowPrecipFile .NE. ' ' ) THEN
       DO j = jMin, jMax
        DO i = iMin, iMax
         snowPrc(i,j) = snowPrecip(i,j,bi,bj)*rhoConstFresh
        ENDDO
       ENDDO
      ELSE
C     If specific snow precipitiation is not available, use
C     precipitation when ever the air temperature is below 0 degC
       DO j = jMin, jMax
        DO i = iMin, iMax
         IF ( iceMsk(i,j,bi,bj).GT.0. _d 0
     &        .AND. atemp(i,j,bi,bj).LE.cen2kel )  THEN
cML     &        .AND. atemp(i,j,bi,bj).LE.Tf0kel )  THEN
          snowPrc(i,j) = precip(i,j,bi,bj)*rhoConstFresh
         ENDIF
        ENDDO
       ENDDO
      ENDIF
      IF ( temp_EvPrRn .NE. UNSET_RL ) THEN
C--   Account for energy content of Precip + RunOff :
C     assume 1) rain has same temp as Air (higher altitude, e.g., 850.mb would
C      be better); 2) Snow has no heat capacity (+ is counted separately)
C     3) no distinction between sea-water Cp and fresh-water Cp
C     4) Run-Off comes at the temp of surface water (with same Cp)
       DO j = jMin, jMax
        DO i = iMin, iMax
         qPrcRnO(i,j) = HeatCapacity_Cp
     &          *( atemp(i,j,bi,bj) - cen2kel - temp_EvPrRn )
     &          *( precip(i,j,bi,bj)*rhoConstFresh - snowPrc(i,j) )
     &
#ifdef ALLOW_RUNOFF
         qPrcRnO(i,j) = qPrcRnO(i,j)
     &                + HeatCapacity_Cp
     &                 *( locSST(i,j,bi,bj) - temp_EvPrRn )
     &                 *runoff(i,j,bi,bj)*rhoConstFresh
#endif
        ENDDO
       ENDDO
      ENDIF
#else /* ALLOW_ATM_TEMP */
      STOP 'ABNORMAL END: S/R THSICE_MAP_EXF: ATM_TEMP undef'
#endif /* ALLOW_ATM_TEMP */

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#endif /* ALLOW_EXF */

      RETURN
      END

#include "PTRACERS_OPTIONS.h"

CBOP
C     !ROUTINE: PTRACERS_DIAGNOSTICS_INIT
C     !INTERFACE:
      SUBROUTINE PTRACERS_DIAGNOSTICS_INIT( myThid )

C     !DESCRIPTION:
C     Routine to initialize pTracers diagnostics

C     !USES:
      IMPLICIT NONE
C     === Global variables ===
#include "SIZE.h"
#include "PTRACERS_SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "PTRACERS_PARAMS.h"
#include "GAD.h"

C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
C     myThid :: my Thread Id. number
      INTEGER myThid
CEOP

#ifdef ALLOW_DIAGNOSTICS
C     !FUNCTIONS:
      INTEGER     ILNBLNK
      EXTERNAL    ILNBLNK
      CHARACTER*4 GAD_DIAG_SUFX
      EXTERNAL    GAD_DIAG_SUFX
      CHARACTER*16 DIAGS_MK_UNITS
      EXTERNAL     DIAGS_MK_UNITS

C     !LOCAL VARIABLES:
C     === Local variables ===
C     msgBuf      :: Informational/error message buffer
c     CHARACTER*(MAX_LEN_MBUF) msgBuf
      INTEGER       diagNum
      INTEGER       diagMate
      CHARACTER*8   diagName
      CHARACTER*16  diagCode
      CHARACTER*16  diagUnits
      CHARACTER*(80) diagTitle

      INTEGER      iTrc, ilnb, ilng, tracerId
      CHARACTER*7  trcUnits
      CHARACTER*9  flxUnits, wUnits
      CHARACTER*30 locName
      CHARACTER*60 longName
      CHARACTER*4  diagSufx

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C--   Add diagnostics to the (long) list

      IF ( usingPCoords ) THEN
         flxUnits = '.Pa.m^2/s'
         wUnits   = '.Pa/s    '
      ELSE
         flxUnits = '.m^3/s   '
         wUnits   = '.m/s     '
      ENDIF

      DO iTrc=1,PTRACERS_num
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C--    Set default name & tracer Units:
       WRITE(locName,'(A,I4.4,A)') 'Tracer ',iTrc
       trcUnits  = 'kg/kg  '
C-     use units & names from data.ptracers :
       ilnb = ILNBLNK(PTRACERS_units(iTrc))
       IF ( ilnb.GE.1 ) THEN
         ilnb = LEN(trcUnits)
         trcUnits = PTRACERS_units(iTrc)(1:ilnb)
       ENDIF
       ilnb = ILNBLNK(PTRACERS_names(iTrc))
       IF ( ilnb.GE.1 ) THEN
         ilnb = MIN(LEN(locName),ilnb)
         WRITE(locName,'(A)') PTRACERS_names(iTrc)(1:ilnb)
       ENDIF
       ilnb = MAX(ILNBLNK(locName),1)
C-     long name:
       WRITE(longName,'(A)') locName
       ilng = ILNBLNK(PTRACERS_long_names(iTrc))
       IF ( ilng.GE.1 ) THEN
         ilng = MIN(LEN(longName),ilng)
         WRITE(longName,'(A)') PTRACERS_long_names(iTrc)(1:ilng)
       ENDIF
       ilng = MAX(ILNBLNK(longName),1)

C--    Add diagnostics of Tracer concentration & u,v,w Transport
       WRITE(diagName,'(A4,A2,A2)') 'TRAC',PTRACERS_ioLabel(iTrc),'  '
       WRITE(diagTitle,'(2A)') longName(1:ilng), ' concentration'
       WRITE(diagUnits,'(A)') trcUnits
       diagCode  = 'SMR     MR      '
       CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I           diagName, diagCode, diagUnits, diagTitle, 0, myThid )

       diagUnits = DIAGS_MK_UNITS( trcUnits//'.m/s', myThid )
       WRITE(diagName,'(A5,A2,A1)') 'UTRAC',PTRACERS_ioLabel(iTrc),' '
       WRITE(diagTitle,'(2A)') 'Zonal Mass-Weighted Transp of ',
     &                 locName(1:ilnb)
       diagCode  = 'UUr     MR      '
       diagMate  = diagNum + 2
       CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I    diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

       WRITE(diagName,'(A5,A2,A1)') 'VTRAC',PTRACERS_ioLabel(iTrc),' '
       WRITE(diagTitle,'(2A)') 'Merid Mass-Weighted Transp of ',
     &                 locName(1:ilnb)
       diagCode  = 'VVr     MR      '
       diagMate  = diagNum
       CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I    diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

       diagUnits = DIAGS_MK_UNITS( trcUnits//wUnits, myThid )
       WRITE(diagName,'(A5,A2,A1)') 'WTRAC',PTRACERS_ioLabel(iTrc),' '
       WRITE(diagTitle,'(2A)') 'Vert  Mass-Weighted Transp of ',
     &                 locName(1:ilnb)
       diagCode  = 'WM      MR      '
       CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I           diagName, diagCode, diagUnits, diagTitle, 0, myThid )

C--    add diagnostics for Forcing and Adams-Bashforth tendency increment
       tracerId = iTrc + GAD_TR1 - 1
       diagSufx = GAD_DIAG_SUFX( tracerId, myThid )
       diagUnits = DIAGS_MK_UNITS( trcUnits//'/s', myThid )
       diagName  = 'Forc'//diagSufx
       WRITE(diagTitle,'(2A)') locName(1:ilnb),
     &                   ' forcing tendency'
       diagCode  = 'SMR     MR      '
       CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I           diagName, diagCode, diagUnits, diagTitle, 0, myThid )

       diagName  = 'AB_g'//diagSufx
       WRITE(diagTitle,'(2A)') locName(1:ilnb),
     &                   ' tendency from Adams-Bashforth'
       diagCode  = 'SMR     MR      '
       CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I           diagName, diagCode, diagUnits, diagTitle, 0, myThid )

       diagName  = 'Tp_g'//diagSufx
       WRITE(diagTitle,'(2A)') locName(1:ilnb),
     &         ' total transport tendency (before gchem_forcing_sep)'
       diagCode  = 'SMR     MR      '
       CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I           diagName, diagCode, diagUnits, diagTitle, 0, myThid )

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C--    Add diagnostics of advective & diffusive flux:
       diagUnits = DIAGS_MK_UNITS( trcUnits//flxUnits, myThid )

C-     Advective flux:
       diagName  = 'ADVr'//diagSufx
       WRITE(diagTitle,'(2A)') 'Vertical   Advective Flux of ',
     &                 locName(1:ilnb)
       diagCode  = 'WM      LR      '
       CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I           diagName, diagCode, diagUnits, diagTitle, 0, myThid )
       diagName  = 'ADVx'//diagSufx
       WRITE(diagTitle,'(2A)') 'Zonal      Advective Flux of ',
     &                 locName(1:ilnb)
       diagCode  = 'UU      MR      '
       diagMate  = diagNum + 2
       CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I    diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )
       diagName  = 'ADVy'//diagSufx
       WRITE(diagTitle,'(2A)') 'Meridional Advective Flux of ',
     &                 locName(1:ilnb)
       diagCode  = 'VV      MR      '
       diagMate  = diagNum
       CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I    diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

C-     Diffusive flux:
       diagName  = 'DFrE'//diagSufx
       WRITE(diagTitle,'(2A)') 'Vertical Diffusive Flux of ',
     &                 locName(1:ilnb)//' (Explicit part)'
       diagCode  = 'WM      LR      '
       CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I           diagName, diagCode, diagUnits, diagTitle, 0, myThid )
       diagName  = 'DFxE'//diagSufx
       WRITE(diagTitle,'(2A)') 'Zonal      Diffusive Flux of ',
     &                 locName(1:ilnb)
       diagCode  = 'UU      MR      '
       diagMate  = diagNum + 2
       CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I    diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )
       diagName  = 'DFyE'//diagSufx
       WRITE(diagTitle,'(2A)') 'Meridional Diffusive Flux of ',
     &                 locName(1:ilnb)
       diagCode  = 'VV      MR      '
       diagMate  = diagNum
       CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I    diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

       diagName  = 'DFrI'//diagSufx
       WRITE(diagTitle,'(2A)') 'Vertical Diffusive Flux of ',
     &                 locName(1:ilnb)//' (Implicit part)'
       diagCode  = 'WM      LR      '
       CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I           diagName, diagCode, diagUnits, diagTitle, 0, myThid )

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C--    Add diagnostics for other pkg contribution to ptracer solution
       IF ( useKPP ) THEN
        diagName  = 'KPPg'//diagSufx
        WRITE(diagTitle,'(2A)') 'KPP non-local Flux of ',
     &                 locName(1:ilnb)
        diagCode  = 'WM      LR      '
        diagUnits = DIAGS_MK_UNITS( trcUnits//flxUnits, myThid )
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )
       ENDIF

       IF ( useDOWN_SLOPE ) THEN
        diagName  = 'DSLP'//diagSufx
        WRITE(diagTitle,'(2A)') locName(1:ilnb),
     &                   ' tendency from Down-Slope package'
        diagCode  = 'SMR     MR      '
        diagUnits = DIAGS_MK_UNITS( trcUnits//'/s', myThid )
        CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I           diagName, diagCode, diagUnits, diagTitle, 0, myThid )
       ENDIF

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#ifdef ALLOW_AUTODIFF
       WRITE(diagName,'(A6,A2)') 'ADJptr',PTRACERS_ioLabel(iTrc)
       WRITE(diagTitle,'(3A)') 'sensitivity to ',
     &                         longName(1:ilng), ' concentration'
       WRITE(diagUnits,'(2A)') 'dJ/',trcUnits
       diagCode  = 'SMRA    MR      '
       CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I           diagName, diagCode, diagUnits, diagTitle, 0, myThid )
#endif

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
      ENDDO

      diagName  = 'Add2EmP '
      diagTitle = 'additional EmP from salt relaxation'
      diagUnits = 'kg/m^2/s        '
      diagCode  = 'SM      U1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

#endif /* ALLOW_DIAGNOSTICS */

      RETURN
      END

#include "KL10_OPTIONS.h"

      SUBROUTINE KL10_CALC_VISC(
     I        bi,bj,iMin,iMax,jMin,jMax,k,
     U        KappaRU,KappaRV,
     I        myThid)

CBOP
C     *==========================================================*
C     | SUBROUTINE KL10_CALC_VISC                                |
C     | o Add contrubution to net viscosity from KL10 mixing     |
C     *==========================================================*
      IMPLICIT NONE

C     == GLobal variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "DYNVARS.h"
#include "GRID.h"
#include "KL10.h"

C     == Routine arguments ==
C     bi, bj :: tile numbers
C     iMin, iMax, jMin, jMax :: Range of points for which calculation
C     maskUp :: land/water mask for Wvel points (above tracer level)
C     myThid :: Instance number for this innvocation of KL10_CALC_VISC
C
      INTEGER bi,bj,iMin,iMax,jMin,jMax,k
      _RL KappaRU(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL KappaRV(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      INTEGER myThid

#ifdef ALLOW_KL10

C     == Local variables ==
C     i, j    :: Loop counters
      INTEGER i,j
CEOP
      DO j=jMin,jMax
       DO i=iMin,iMax
        KappaRU(i,j,k) = max ( KappaRU(i,j,k),
     &         KappaRU(i,j,k) - viscArNr(k) + _maskW(i,j,k,bi,bj) *
     &         0.5*(KLviscAr(i,j,k,bi,bj)+KLviscAr(i-1,j,k,bi,bj)) )
       ENDDO
      ENDDO

      DO j=jMin,jMax
       DO i=iMin,iMax
        KappaRV(i,j,k) = max ( KappaRV(i,j,k),
     &         KappaRV(i,j,k) - viscArNr(k) + _maskS(i,j,k,bi,bj) *
     &         0.5*(KLviscAr(i,j,k,bi,bj)+KLviscAr(i,j-1,k,bi,bj)) )
       ENDDO
      ENDDO

#endif /* ALLOW_KL10 */

      RETURN
      END

#include "SEAICE_OPTIONS.h"

CBOP
C     !ROUTINE: SEAICE_CHECK_PICKUP
C     !INTERFACE:
      SUBROUTINE SEAICE_CHECK_PICKUP(
     I                        missFldList,
     I                        nMissing, nbFields,
     I                        myIter, myThid )

C     !DESCRIPTION:
C     Check that fields that are needed to restart have been read.
C     In case some fields are missing, stop if pickupStrictlyMatch=T
C     or try, if possible, to restart without the missing field.

C     !USES:
      IMPLICIT NONE

C     == Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "SEAICE_SIZE.h"
#include "SEAICE_PARAMS.h"
#include "SEAICE.h"
#include "SEAICE_TRACER.h"

C     !INPUT/OUTPUT PARAMETERS:
C     missFldList :: List of missing fields   (attempted to read but not found)
C     nMissing    :: Number of missing fields (attempted to read but not found)
C     nbFields    :: number of fields in pickup file (read from meta file)
C     myIter      :: Iteration number
C     myThid      :: my Thread Id. number
      CHARACTER*(8) missFldList(*)
      INTEGER nMissing
      INTEGER nbFields
      INTEGER myIter
      INTEGER myThid
CEOP

C     !FUNCTIONS
      INTEGER  ILNBLNK
      EXTERNAL ILNBLNK

C     !LOCAL VARIABLES:
C     == Local variables ==
C     nj          :: record & field number
C     ioUnit      :: temp for writing msg unit
C     msgBuf      :: Informational/error message buffer
C     i,j,k       :: loop indices
C     bi,bj       :: tile indices
      INTEGER nj, ioUnit
      INTEGER tIceFlag, warnCnts
      LOGICAL stopFlag
c     LOGICAL oldIceAge
#ifdef SEAICE_ITD
C     Flag indicating absence of ITD fields such as AREAITD
C      in this case try to use average fields such as AREA
C      (program will stop if fields liek AREA are missing)
      LOGICAL useAvgFldsForITD
#endif
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      CHARACTER*(8) fldName
c     INTEGER i,j,k,bi,bj
#ifdef ALLOW_SITRACER
      INTEGER iTracer
      CHARACTER*(2) fldNum
#endif
CEOP

c     IF ( seaice_pickup_read_mdsio ) THEN

       IF ( nMissing.GE.1 ) THEN
        ioUnit = errorMessageUnit
        tIceFlag = 0
c       oldIceAge = .TRUE.
        DO nj=1,nMissing
         IF ( missFldList(nj).EQ.'siTICES ' ) tIceFlag = tIceFlag + 2
         IF ( missFldList(nj).EQ.'siTICE  ' ) tIceFlag = tIceFlag + 1
c        IF ( missFldList(nj).EQ.'siAGE   ' ) oldIceAge = .FALSE.
        ENDDO
        stopFlag = .FALSE.
#ifdef SEAICE_ITD
        useAvgFldsForITD = .FALSE.
#endif
        warnCnts = nMissing

        DO nj=1,nMissing
         fldName = missFldList(nj)
         IF     ( fldName.EQ.'siTICE  ' .AND. tIceFlag.LE.1 ) THEN
          IF ( .NOT.pickupStrictlyMatch ) THEN
           _BEGIN_MASTER( myThid )
           WRITE(msgBuf,'(4A)') '** WARNING ** SEAICE_CHECK_PICKUP:',
     &      ' restart with Tice from 1rst category'
           CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
           _END_MASTER( myThid )
          ENDIF
         ELSEIF ( fldName.EQ.'siTICES ' .AND. tIceFlag.LE.2 ) THEN
          IF ( .NOT.pickupStrictlyMatch .AND. SEAICE_multDim.GT.1 ) THEN
           _BEGIN_MASTER( myThid )
           WRITE(msgBuf,'(4A)') '** WARNING ** SEAICE_CHECK_PICKUP:',
     &      ' restart from single category Tice (copied to TICES)'
           CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
           _END_MASTER( myThid )
C     copy TICE -> TICES, already done in s/r seaice_read_pickup
          ENDIF
         ELSEIF ( fldName(1:6).EQ.'siSigm' ) THEN
C- Note: try to restart without Sigma1,2,12 (as if SEAICEuseEVPpickup=F)
C        An alternative would be to restart only if SEAICEuseEVPpickup=F:
C        if SEAICEuseEVPpickup then stop / else warning / endif
          IF ( .NOT.pickupStrictlyMatch ) THEN
           _BEGIN_MASTER( myThid )
           WRITE(msgBuf,'(4A)') '** WARNING ** SEAICE_CHECK_PICKUP:',
     &      ' restart without "',fldName,'" (set to zero)'
           CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
           _END_MASTER( myThid )
          ENDIF
         ELSEIF ( fldName(1:8).EQ.'siUicNm1' .OR.
     &            fldName(1:8).EQ.'siVicNm1' ) THEN
          IF ( .NOT.pickupStrictlyMatch ) THEN
C     print a warning and restart anyway
           SEAICEmomStartBDF = 0
           _BEGIN_MASTER( myThid )
           WRITE(msgBuf,'(4A)') '** WARNING ** SEAICE_CHECK_PICKUP:',
     &      ' restart without "',fldName,'" (set to zero)'
           CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
           _END_MASTER( myThid )
          ENDIF
         ELSEIF ( fldName.EQ.'siTICES ' .OR.
     &            fldName.EQ.'siTICE  ' .OR.
     &            fldName.EQ.'siUICE  ' .OR.
     &            fldName.EQ.'siVICE  ' .OR.
     &            fldName.EQ.'siAREA  ' .OR.
     &            fldName.EQ.'siHEFF  ' .OR.
     &            fldName.EQ.'siHSNOW ' .OR.
     &            fldName.EQ.'siHSALT ' ) THEN
           stopFlag = .TRUE.
           _BEGIN_MASTER( myThid )
           WRITE(msgBuf,'(4A)') 'SEAICE_CHECK_PICKUP: ',
     &       'cannot restart without field "',fldName,'"'
           CALL PRINT_ERROR( msgBuf, myThid )
           _END_MASTER( myThid )
#ifdef SEAICE_ITD
         ELSEIF ( fldName.EQ.'siAREAn ' .OR.
     &            fldName.EQ.'siHEFFn ' .OR.
     &            fldName.EQ.'siHSNOWn' ) THEN
          IF ( .NOT.pickupStrictlyMatch ) THEN
C          generate ITD from mean ice thickness
           useAvgFldsForITD = .TRUE.
          ELSE
C          if strict match is requested
C          run will bestopped in case of missing ITD fields
           stopFlag = .TRUE.
           WRITE(msgBuf,'(4A)') 'SEAICE_CHECK_PICKUP: ',
     &       'cannot restart without ITD field "',fldName,'"'
           CALL PRINT_ERROR( msgBuf, myThid )
          ENDIF
#endif
#ifdef ALLOW_SITRACER
         ELSEIF ( fldName(1:6).EQ.'siTrac' ) THEN
           IF ( .NOT.pickupStrictlyMatch ) THEN
            _BEGIN_MASTER( myThid )
            DO iTracer = 1, SItrMaxNum
             WRITE(fldNum,'(I2.2)') iTracer
             IF ( fldName(7:8).EQ.fldNum ) THEN
              WRITE(msgBuf,'(4A)')
     &         '** WARNING ** SEAICE_CHECK_PICKUP: ',
     &         'restart without "',fldName,'" (set to zero)'
              CALL PRINT_MESSAGE(
     &         msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
             ENDIF
            ENDDO
            _END_MASTER( myThid )
           ENDIF
#endif /* ALLOW_SITRACER */
         ELSE
C-    not recognized fields:
           stopFlag = .TRUE.
           _BEGIN_MASTER( myThid )
           WRITE(msgBuf,'(4A)') 'SEAICE_CHECK_PICKUP: ',
     &       'missing field "',fldName,'" not recognized'
           CALL PRINT_ERROR( msgBuf, myThid )
           _END_MASTER( myThid )
         ENDIF
C-    end nj loop
        ENDDO

        IF ( stopFlag ) THEN
         STOP 'ABNORMAL END: S/R SEAICE_CHECK_PICKUP'
        ELSEIF ( pickupStrictlyMatch ) THEN
         _BEGIN_MASTER( myThid )
         WRITE(msgBuf,'(4A)') 'SEAICE_CHECK_PICKUP: ',
     &      'try with " pickupStrictlyMatch=.FALSE.,"',
     &      ' in file: "data", NameList: "PARM03"'
         CALL PRINT_ERROR( msgBuf, myThid )
         _END_MASTER( myThid )
         STOP 'ABNORMAL END: S/R SEAICE_CHECK_PICKUP'
        ELSEIF ( warnCnts .GT. 0 ) THEN
         _BEGIN_MASTER( myThid )
#ifdef SEAICE_ITD
         IF ( useAvgFldsForITD ) THEN
          WRITE(msgBuf,'(3A)') '** WARNING ** SEAICE_CHECK_PICKUP:',
     &     ' no ITD fields available, restart from single category',
     &     ' fields,'
          CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
          WRITE(msgBuf,'(2A)') '** WARNING ** SEAICE_CHECK_PICKUP:',
     &     ' i.e. AREA -> AREAITD, HEFF -> HEFFITD, etc.'
          CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
          CALL SEAICE_ITD_PICKUP( myIter, myThid )
         ENDIF
#endif
         WRITE(msgBuf,'(4A)') '** WARNING ** SEAICE_CHECK_PICKUP: ',
     &     'Will get only an approximated Restart'
         CALL PRINT_MESSAGE( msgBuf, ioUnit, SQUEEZE_RIGHT, myThid )
         _END_MASTER( myThid )
        ENDIF

       ENDIF

C--   end: seaice_pickup_read_mdsio
c     ENDIF

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      RETURN
      END

#include "DIC_OPTIONS.h"
#include "PTRACERS_OPTIONS.h"

CBOP
C !ROUTINE: DIC_ATMOS

C !INTERFACE: ==========================================================
      SUBROUTINE DIC_ATMOS( myTime, myIter, myThid )

C !DESCRIPTION:
C  Calculate the atmospheric pCO2
C  dic_int1:
C  0=use default 278.d-6
C  1=use constant value - dic_pCO2, read in from data.dic
C  2=read in from file
C  3=interact with atmospheric box (use dic_pCO2 as initial atmos. value)

C !USES: ===============================================================
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "DIC_VARS.h"
#include "PTRACERS_SIZE.h"
#include "PTRACERS_PARAMS.h"
#include "PTRACERS_FIELDS.h"
#include "DIC_ATMOS.h"

C !INPUT PARAMETERS: ===================================================
C  myTime             :: current time
C  myIter             :: current iteration number
C  myThid             :: my Thread Id number
      _RL myTime
      INTEGER myIter, myThid

#ifdef ALLOW_DIC

C !FUNCTIONS:       ====================================================
      LOGICAL  DIFFERENT_MULTIPLE
      EXTERNAL DIFFERENT_MULTIPLE

C !LOCAL VARIABLES: ====================================================
C   total_atmos_moles :: atmosphere total gas content (should be parameter)
      _RL total_atmos_moles
      INTEGER bi, bj, i,j,k
      INTEGER ntim

      _RL tile_flux  (nSx,nSy)
      _RL tile_carbon(nSx,nSy)
      _RL total_flux
      _RL total_carbon

C for carbon budget ouput
      INTEGER ioUnit
      _RL total_ocean_carbon_old
      _RL total_atmos_carbon_old
      _RL total_carbon_old, carbon_diff
      _RL year_diff_ocean, year_diff_atmos, year_total
      _RL start_diff_ocean, start_diff_atmos, start_total
C variables for reading CO2 input files
      _RL aWght, bWght
      _RL atm_pCO2
      LOGICAL timeCO2budget
CEOP

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      ioUnit = standardMessageUnit

      IF ( dic_int1.EQ.2 ) THEN
C read from a file and linearly interpolate between file entries
C     (note:  dic_int2=number entries to read
C             dic_int3=start timestep,
C             dic_int4=timestep between file entries)
        ntim=int((myIter-dic_int3)/dic_int4)+1
        aWght = FLOAT(myIter-dic_int3)
        bWght = FLOAT(dic_int4)
        aWght = 0.5 _d 0 + aWght/bWght - FLOAT(ntim-1)
        IF (aWght.GT.1. _d 0) THEN
          ntim=ntim+1
          aWght=aWght-1. _d 0
        ENDIF
        bWght = 1. _d 0 - aWght
        atm_pCO2 = co2atmos(ntim)*bWght + co2atmos(ntim+1)*aWght
        WRITE(ioUnit,*) 'weights',ntim, aWght, bWght, atm_pCO2

      ELSEIF ( dic_int1.EQ.3 ) THEN
C interactive atmosphere

C Mass dry atmosphere = (5.1352+/-0.0003)d18 kg (Trenberth & Smith,
C Journal of Climate 2005)
C and Mean molecular mass air = 28.97 g/mol (NASA earth fact sheet)
       total_atmos_moles = 1.77 _d 20
C for 278ppmv we need total_atmos_carbon=4.9206e+16

       DO bj=myByLo(myThid),myByHi(myThid)
        DO bi=myBxLo(myThid),myBxHi(myThid)
         tile_flux(bi,bj)   = 0.
         tile_carbon(bi,bj) = 0.
         DO j=1,sNy
           DO i=1,sNx
             tile_flux(bi,bj) = tile_flux(bi,bj)
     &                        + fluxCO2(i,j,bi,bj)*rA(i,j,bi,bj)
     &                         *maskC(i,j,1,bi,bj)*dTtracerLev(1)
           ENDDO
         ENDDO
         DO k=1,Nr
          DO j=1,sNy
           DO i=1,sNx
             tile_carbon(bi,bj) = tile_carbon(bi,bj)
     &            + ( pTracer(i,j,k,bi,bj,1)
#ifdef DIC_BIOTIC
     &               +R_cp*pTracer(i,j,k,bi,bj,4)
#endif
     &              ) * rA(i,j,bi,bj)
     &                *drF(k)*hFacC(i,j,k,bi,bj)
           ENDDO
          ENDDO
         ENDDO
        ENDDO
       ENDDO

       CALL GLOBAL_SUM_TILE_RL( tile_flux,   total_flux,   myThid )
       CALL GLOBAL_SUM_TILE_RL( tile_carbon, total_carbon, myThid )

#ifdef ALLOW_AUTODIFF
C--NOTE: we DO need to make this section Master-Thread only to prevent multiple
C   update (by each thread) of shared variable "total_atmos_carbon"
C- However, TAF does not recognize MITgcm multi-threading and shared variable
C   status and see a conditional (if myThid=1) reset of "atpco2" that results
C   in major recomputations.
#else
       _BEGIN_MASTER(myThid)
#endif
C store previous content:
       total_ocean_carbon_old = total_ocean_carbon
       total_atmos_carbon_old = total_atmos_carbon
C calculate new atmos pCO2
       total_atmos_carbon = total_atmos_carbon - total_flux
       total_ocean_carbon = total_carbon
       atpco2 = total_atmos_carbon/total_atmos_moles

       WRITE(ioUnit,*) 'QQ atmos C, total, pCo2',
     &                     total_atmos_carbon, atpco2
       total_carbon = total_atmos_carbon + total_ocean_carbon
       total_carbon_old = total_atmos_carbon_old+total_ocean_carbon_old
       carbon_diff = total_carbon-total_carbon_old
       WRITE(ioUnit,*) 'QQ total C, current, old, diff',
     &                     total_carbon, total_carbon_old, carbon_diff
       carbon_diff = total_ocean_carbon-total_ocean_carbon_old
       WRITE(ioUnit,*) 'QQ ocean C, current, old, diff',
     &         total_ocean_carbon, total_ocean_carbon_old, carbon_diff
       WRITE(ioUnit,*) 'QQ air-sea flux, addition diff',
     &                     total_flux, carbon_diff-total_flux

C if end of forcing cycle, find total change in ocean carbon
       timeCO2budget =
     &    DIFFERENT_MULTIPLE(externForcingCycle,myTime,deltaTClock)
       IF ( timeCO2budget ) THEN
          year_diff_ocean = total_ocean_carbon-total_ocean_carbon_year
          year_diff_atmos = total_atmos_carbon-total_atmos_carbon_year
          year_total = (total_ocean_carbon+total_atmos_carbon) -
     &               (total_ocean_carbon_year+total_atmos_carbon_year)
          start_diff_ocean = total_ocean_carbon-total_ocean_carbon_start
          start_diff_atmos = total_atmos_carbon-total_atmos_carbon_start
          start_total = (total_ocean_carbon+total_atmos_carbon) -
     &               (total_ocean_carbon_start+total_atmos_carbon_start)
          WRITE(ioUnit,*) 'QQ YEAR END'
          WRITE(ioUnit,*) 'year diff: ocean, atmos, total',
     &                  year_diff_ocean,  year_diff_atmos,  year_total
          WRITE(ioUnit,*) 'start diff: ocean, atmos, total ',
     &                 start_diff_ocean, start_diff_atmos, start_total

          total_ocean_carbon_year = total_ocean_carbon
          total_atmos_carbon_year = total_atmos_carbon
       ENDIF

#ifndef ALLOW_AUTODIFF
       _END_MASTER(myThid)
       _BARRIER
#endif

       atm_pCO2 = atpco2
      ELSE
       atm_pCO2 = dic_pCO2
      ENDIF

#ifndef ALLOW_AUTODIFF
      IF ( dic_int1.EQ.2 .OR. dic_int1.EQ.3 ) THEN
#endif
C--    Set AtmospCO2 for next iteration:
       DO bj=myByLo(myThid),myByHi(myThid)
        DO bi=myBxLo(myThid),myBxHi(myThid)
         DO j=1-OLy,sNy+OLy
          DO i=1-OLx,sNx+OLx
            AtmospCO2(i,j,bi,bj) = atm_pCO2
          ENDDO
         ENDDO
        ENDDO
       ENDDO
#ifndef ALLOW_AUTODIFF
      ENDIF
#endif

#endif /* ALLOW_DIC */

      RETURN
      END

#include "CPP_EEOPTIONS.h"

      SUBROUTINE EEDATA_EXAMPLE
C     *==========================================================*
C     | S/R EEDATA\_EXAMPLE                                      |
C     | o Write example eedata file                              |
C     *==========================================================*
C     | Notes:                                                   |
C     |    Some systems require & as the namelist terminator.    |
C     |    Other systems use a / character.                      |
C     *==========================================================*
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"

C     -- Local variables --
      CHARACTER*(MAX_LEN_MBUF) msgBuf

      WRITE(msgBuf,'(A)') '// Shown below is an example "eedata" file.'
      CALL PRINT_MESSAGE( msgBuf,standardMessageUnit,SQUEEZE_RIGHT,1 )
      WRITE(msgBuf,'(2A)') '// To use this example copy and paste',
     &                     ' the ">" lines.'
      CALL PRINT_MESSAGE( msgBuf,standardMessageUnit,SQUEEZE_RIGHT,1 )
      WRITE(msgBuf,'(2A)') '// Then remove the text up to',
     &                     ' and including the ">".'
      CALL PRINT_MESSAGE( msgBuf,standardMessageUnit,SQUEEZE_RIGHT,1 )
      WRITE(msgBuf,'(A)') '># Example "eedata" file'
      CALL PRINT_MESSAGE( msgBuf,standardMessageUnit,SQUEEZE_RIGHT,1 )
      WRITE(msgBuf,'(A)') '># Lines beginning "#" are comments'
      CALL PRINT_MESSAGE( msgBuf,standardMessageUnit,SQUEEZE_RIGHT,1 )
      WRITE(msgBuf,'(A)') '># nTx - No. threads per process in X'
      CALL PRINT_MESSAGE( msgBuf,standardMessageUnit,SQUEEZE_RIGHT,1 )
      WRITE(msgBuf,'(A)') '># nTy - No. threads per process in Y'
      CALL PRINT_MESSAGE( msgBuf,standardMessageUnit,SQUEEZE_RIGHT,1 )
      WRITE(msgBuf,'(A)') '>&EEPARMS '
      CALL PRINT_MESSAGE( msgBuf,standardMessageUnit,SQUEEZE_RIGHT,1 )
      WRITE(msgBuf,'(A)') '> nTx=1,  '
      CALL PRINT_MESSAGE( msgBuf,standardMessageUnit,SQUEEZE_RIGHT,1 )
      WRITE(msgBuf,'(A)') '> nTy=1,  '
      CALL PRINT_MESSAGE( msgBuf,standardMessageUnit,SQUEEZE_RIGHT,1 )
      WRITE(msgBuf,'(A)') '>&        '
      CALL PRINT_MESSAGE( msgBuf,standardMessageUnit,SQUEEZE_RIGHT,1 )
      WRITE(msgBuf,'(2A)') '># Note: Some systems use & as the ',
     &                     'namelist terminator (as shown here).'
      CALL PRINT_MESSAGE( msgBuf,standardMessageUnit,SQUEEZE_RIGHT,1 )
      WRITE(msgBuf,'(A)') '>#       Other systems use a / character.'
      CALL PRINT_MESSAGE( msgBuf,standardMessageUnit,SQUEEZE_RIGHT,1 )
      WRITE(msgBuf,'(A)') ' '
      CALL PRINT_MESSAGE( msgBuf,standardMessageUnit,SQUEEZE_RIGHT,1 )

      RETURN
      END

#include "ZONAL_FILT_OPTIONS.h"

CBOP 0
C     !ROUTINE: ZONAL_FILTER

C     !INTERFACE:
      SUBROUTINE ZONAL_FILTER(
     U           field,
     I           fieldMask,
     I           jMin, jMax, kSize, bi, bj, gridLoc, myThid )

C     !DESCRIPTION:
C     *==========================================================*
C     | S/R ZONAL_FILTER
C     | o Apply FFT filter to a latitude circle.
C     *==========================================================*

C     !USES:
      IMPLICIT NONE
C     == Global data ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "ZONAL_FILT.h"
#include "FFTPACK.h"

C     !INPUT/OUTPUT PARAMETERS:
C     jMin      :: Range of points to filter
C     jMax
C     kSize     :: Number of levels to filter
C     bi, bj    :: tile indices
C     field     :: Field to filter
C     fieldMask :: mask corresponding to field to filter
C     gridLoc   :: Position on the grid (U or V) of field.
C     myThid    :: my Thread Id number
      INTEGER kSize
      _RL     field    (1-OLx:sNx+OLx,1-OLy:sNy+OLy,kSize)
      _RS     fieldMask(1-Olx:sNx+Olx,1-Oly:sNy+Oly,kSize)
      INTEGER jMin, jMax, bi, bj
      INTEGER gridLoc
      INTEGER myThid
CEOP

#ifdef ALLOW_ZONAL_FILT

C     !LOCAL VARIABLES:
      Real*8 phi(Nx)
      Real*8 phiMask(Nx)
      Real*8 avPhi
      INTEGER i, j, k

      DO k= 1, kSize
       DO j=jMin, jMax
        IF ( (gridLoc.EQ.1 .AND.ABS(yC(1,j,bi,bj)).GE.zonal_filt_lat)
     &   .OR.(gridLoc.EQ.2 .AND.ABS(yG(2,j,bi,bj)).GE.zonal_filt_lat)
     &   .OR. zonal_filt_mode2dx.EQ.2 ) THEN

C     o Copy zonal line of field into local workspace
        DO i=1,sNx
         phi(i) = field(i,j,k)
         phiMask(i) = fieldMask(i,j,k)
        ENDDO

C Interpolate through land
        CALL ZONAL_FILT_PRESMOOTH( phiMask,phi,avPhi,sNx,myThid )

C     o Forward transform (using specific FFT package)
C       CALL R8FFTF( Nx, phi, FFTPACKWS(1,bj) )
        CALL R8FFTF1( Nx, phi,
     &    FFTPACKWS1(1,bj), FFTPACKWS2(1,bj),FFTPACKWS3(1,bj) )

C     o Apply amplitude filter and normalize
        IF (gridLoc .EQ. 1) THEN
         DO i=1, Nx
          phi(i)=phi(i)*ampFactor(i,j,bi,bj)/float(Nx)
         ENDDO
        ELSEIF (gridLoc .EQ. 2) THEN
         DO i=1, Nx
          phi(i)=phi(i)*ampFactorV(i,j,bi,bj)/float(Nx)
         ENDDO
        ELSE
         WRITE(*,*) 'Error: gridLoc = ',gridLoc
         STOP 'Error: gridLoc has illegal value'
        ENDIF

C     o Backward transform (using specific FFT package)
C       CALL R8FFTB( Nx, phi, FFTPACKWS(1,bj) )
        CALL R8FFTB1( Nx, phi,
     &    FFTPACKWS1(1,bj), FFTPACKWS2(1,bj),FFTPACKWS3(1,bj) )

C De-interpolate through land
        CALL ZONAL_FILT_POSTSMOOTH(phiMask,phi,avPhi,sNx,myThid)

C       o Do periodic wrap around by hand
        DO i=1-OLx,0
         field(i,j,k) = phi(sNx+i)
        ENDDO
        DO i=1,sNx
         field(i,j,k) = phi(i)
        ENDDO
        DO i=sNx+1,sNx+OLx
         field(i,j,k) = phi(i-sNx)
        ENDDO

        ENDIF
       ENDDO
      ENDDO

#endif /* ALLOW_ZONAL_FILT */

      RETURN
      END

#include "PACKAGES_CONFIG.h"
#include "CPP_OPTIONS.h"
#ifdef ALLOW_AUTODIFF
# include "AUTODIFF_OPTIONS.h"
#endif

CBOP
C     !ROUTINE: SOLVE_PENTADIAGONAL
C     !INTERFACE:
      SUBROUTINE SOLVE_PENTADIAGONAL(
     I                     iMin,iMax, jMin,jMax,
     U                     a5d, b5d, c5d, d5d, e5d,
     U                     y5d,
     O                     errCode,
     I                     bi, bj, myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R SOLVE_PENTADIAGONAL
C     | o Solve a penta-diagonal system A*X=Y (dimension Nr)
C     *==========================================================*
C     | o Used to solve implicitly vertical advection & diffusion
#ifdef SOLVE_DIAGONAL_LOWMEMORY
C     | o Allows 2 types of call:
C     | 1) with INPUT errCode < 0 (first call):
C     |   Solve system A*X=Y by LU decomposition and return
C     |     inverse matrix as output (in a5d,b5d,c5d,d5d,e5d)
C     | 2) with INPUT errCode = 0 (subsequent calls):
C     |   Solve system A*Xp=Yp by using inverse matrix coeff
C     |     from first call output.
#endif /* SOLVE_DIAGONAL_LOWMEMORY */
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     == Global data ==
#include "SIZE.h"
#include "EEPARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     -- INPUT: --
C     iMin,iMax,jMin,jMax  :: computational domain
C     a5d     :: 2nd  lower diagonal of the pentadiagonal matrix
C     b5d     :: 1rst lower diagonal of the pentadiagonal matrix
C     c5d     :: main diagonal       of the pentadiagonal matrix
C     d5d     :: 1rst upper diagonal of the pentadiagonal matrix
C     e5d     :: 2nd  upper diagonal of the pentadiagonal matrix
C     y5d     :: Y vector (R.H.S.);
C     bi,bj   :: tile indices
C     myThid  :: thread number
C     -- OUTPUT: --
C     y5d     :: X = solution of A*X=Y
C     errCode :: > 0 if singular matrix
#ifdef SOLVE_DIAGONAL_LOWMEMORY
C     a5d,b5d,c5d,d5d,e5d :: inverse matrix coeff to enable to find Xp solution
C                            of A*Xp=Yp with subsequent call to this routine
#endif /* SOLVE_DIAGONAL_LOWMEMORY */
      INTEGER iMin,iMax,jMin,jMax
      _RL a5d(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL b5d(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL c5d(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL d5d(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL e5d(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL y5d(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      INTEGER errCode
      INTEGER bi, bj, myThid

C/*   This flag combination is only false if INCLUDE_IMPLVERTADV_CODE is
C     not defined while ALLOW_AUTODIFF is. */
#if ( defined INCLUDE_IMPLVERTADV_CODE || !defined ALLOW_AUTODIFF )
C     !LOCAL VARIABLES:
C     == Local variables ==
      INTEGER i,j,k
#ifndef SOLVE_DIAGONAL_LOWMEMORY
      _RL tmpVar, recVar
      _RL y5d_m1(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
# ifdef SOLVE_DIAGONAL_KINNER
      _RL c5d_prime(Nr)
      _RL d5d_prime(Nr)
      _RL e5d_prime(Nr)
      _RL y5d_prime(Nr)
      _RL y5d_update(Nr)
#  ifdef ALLOW_AUTODIFF_TAMC
C     kkey :: tape key, depends on i,j,k
      INTEGER kkey
#  endif
# else
      _RL c5d_prime(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL d5d_prime(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL e5d_prime(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
      _RL y5d_prime(1-OLx:sNx+OLx,1-OLy:sNy+OLy,Nr)
# endif
#endif /* SOLVE_DIAGONAL_LOWMEMORY */
CEOP

#ifdef SOLVE_DIAGONAL_LOWMEMORY

      IF ( errCode .LT. 0 ) THEN
       errCode = 0

       DO k=1,Nr
C--   forward sweep (starting from top) part-1: matrix L.U decomposition
        IF (k.EQ.1) THEN
         DO j=jMin,jMax
          DO i=iMin,iMax
           IF ( c5d(i,j,k).NE.0. _d 0 ) THEN
            c5d(i,j,k) = 1. _d 0 / c5d(i,j,k)
           ELSE
            c5d(i,j,k) = 0. _d 0
            errCode = 1
           ENDIF
          ENDDO
         ENDDO

        ELSEIF (k.EQ.2) THEN
         DO j=jMin,jMax
          DO i=iMin,iMax
C--        [k] <- [k] - b_k/c_k-1 * [k-1]
           b5d(i,j,k) = b5d(i,j,k)*c5d(i,j,k-1)
           c5d(i,j,k) = c5d(i,j,k) - b5d(i,j,k)*d5d(i,j,k-1)
           d5d(i,j,k) = d5d(i,j,k) - b5d(i,j,k)*e5d(i,j,k-1)
           IF ( c5d(i,j,k).NE.0. _d 0 ) THEN
            c5d(i,j,k) = 1. _d 0 / c5d(i,j,k)
           ELSE
            c5d(i,j,k) = 0. _d 0
            errCode = 1
           ENDIF
          ENDDO
         ENDDO

        ELSE
C--   Middle of forward sweep
         DO j=jMin,jMax
          DO i=iMin,iMax
C--        [k] <- [k] - a_k/c_k-2 * [k-2]
           a5d(i,j,k) = a5d(i,j,k)*c5d(i,j,k-2)
           b5d(i,j,k) = b5d(i,j,k) - a5d(i,j,k)*d5d(i,j,k-2)
           c5d(i,j,k) = c5d(i,j,k) - a5d(i,j,k)*e5d(i,j,k-2)
C--        [k] <- [k] - b_k/c_k-1 * [k-1]
           b5d(i,j,k) = b5d(i,j,k)*c5d(i,j,k-1)
           c5d(i,j,k) = c5d(i,j,k) - b5d(i,j,k)*d5d(i,j,k-1)
           d5d(i,j,k) = d5d(i,j,k) - b5d(i,j,k)*e5d(i,j,k-1)
           IF ( c5d(i,j,k).NE.0. _d 0 ) THEN
            c5d(i,j,k) = 1. _d 0 / c5d(i,j,k)
           ELSE
            c5d(i,j,k) = 0. _d 0
            errCode = 1
           ENDIF
          ENDDO
         ENDDO
C-      end if k= .. ; end of k loop
        ENDIF
       ENDDO

C--   end if errCode < 0
      ENDIF

      DO k=2,Nr
C--   forward sweep (starting from top) part-2: process RHS
       IF (k.EQ.2) THEN
        DO j=jMin,jMax
         DO i=iMin,iMax
          y5d(i,j,k) = y5d(i,j,k) - b5d(i,j,k)*y5d(i,j,k-1)
         ENDDO
        ENDDO
       ELSE
        DO j=jMin,jMax
         DO i=iMin,iMax
          y5d(i,j,k) = y5d(i,j,k) - b5d(i,j,k)*y5d(i,j,k-1)
     &                            - a5d(i,j,k)*y5d(i,j,k-2)
         ENDDO
        ENDDO
C-      end if k= .. ; end of k loop
       ENDIF
      ENDDO

C--   Backward sweep (starting from bottom)
      DO k=Nr,1,-1
       IF (k.EQ.Nr) THEN
        DO j=jMin,jMax
         DO i=iMin,iMax
          y5d(i,j,k) =   y5d(i,j,k)*c5d(i,j,k)
         ENDDO
        ENDDO
       ELSEIF (k.EQ.Nr-1) THEN
        DO j=jMin,jMax
         DO i=iMin,iMax
          y5d(i,j,k) = ( y5d(i,j,k)
     &                 - d5d(i,j,k)*y5d(i,j,k+1)
     &                 )*c5d(i,j,k)
         ENDDO
        ENDDO
       ELSE
        DO j=jMin,jMax
         DO i=iMin,iMax
          y5d(i,j,k) = ( y5d(i,j,k)
     &                 - d5d(i,j,k)*y5d(i,j,k+1)
     &                 - e5d(i,j,k)*y5d(i,j,k+2)
     &                 )*c5d(i,j,k)
         ENDDO
        ENDDO
C-      end if k= .. ; end of k loop
       ENDIF
      ENDDO

#else /* ndef SOLVE_DIAGONAL_LOWMEMORY */

      errCode = 0

#ifdef SOLVE_DIAGONAL_KINNER

#ifdef ALLOW_AUTODIFF_TAMC
CADJ INIT loctape_solvepenta = COMMON, Nr*(sNy+2*OLy)*(sNx+2*OLx)
#endif
C--   Temporary array
      DO k=1,Nr
       DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
         y5d_m1(i,j,k) = y5d(i,j,k)
        ENDDO
       ENDDO
      ENDDO

C--   Main loop
      DO j=1-OLy,sNy+OLy
       DO i=1-OLx,sNx+OLx

        DO k=1,Nr
         c5d_prime(k) = 0. _d 0
         d5d_prime(k) = 0. _d 0
         e5d_prime(k) = 0. _d 0
         y5d_prime(k) = 0. _d 0
         y5d_update(k) = 0. _d 0
        ENDDO

        DO k=1,Nr
C--   forward sweep (starting from top)

#ifdef ALLOW_AUTODIFF_TAMC
          kkey = k + Nr*(i-1+OLx) + Nr*(sNx+2*OLx)*(j-1+OLy)
CADJ STORE d5d_prime(k) = loctape_solvepenta, key = kkey
CADJ STORE e5d_prime(k) = loctape_solvepenta, key = kkey
CADJ STORE y5d_prime(k) = loctape_solvepenta, key = kkey
#endif
          IF (k.EQ.1) THEN
c just copy terms
           c5d_prime(k) = c5d(i,j,k)
           d5d_prime(k) = d5d(i,j,k)
           e5d_prime(k) = e5d(i,j,k)
           y5d_prime(k) = y5d_m1(i,j,k)
          ELSEIF (k.EQ.2) THEN
c subtract one term
           c5d_prime(k) = c5d(i,j,k)
     &      -b5d(i,j,k)*d5d_prime(k-1)
           d5d_prime(k) = d5d(i,j,k)
     &      -b5d(i,j,k)*e5d_prime(k-1)
           e5d_prime(k) = e5d(i,j,k)
           y5d_prime(k) = y5d_m1(i,j,k)
     &      -b5d(i,j,k)*y5d_prime(k-1)
          ELSE
c subtract two terms
#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE d5d_prime(k) = loctape_solvepenta, key = kkey
#endif
           c5d_prime(k) = c5d(i,j,k)
     &      -a5d(i,j,k)*e5d_prime(k-2)
     &      -(b5d(i,j,k)-a5d(i,j,k)*d5d_prime(k-2))*d5d_prime(k-1)
           d5d_prime(k) = d5d(i,j,k)
     &      -(b5d(i,j,k)-a5d(i,j,k)*d5d_prime(k-2))*e5d_prime(k-1)
           e5d_prime(k) = e5d(i,j,k)
           y5d_prime(k) = y5d_m1(i,j,k)
     &      -a5d(i,j,k)*y5d_prime(k-2)
     &      -(b5d(i,j,k)-a5d(i,j,k)*d5d_prime(k-2))*y5d_prime(k-1)
          ENDIF

c normalization
          tmpVar = c5d_prime(k)
          IF ( tmpVar.NE.0. _d 0 ) THEN
           recVar = 1. _d 0 / tmpVar
           d5d_prime(k) = d5d_prime(k)*recVar
           e5d_prime(k) = e5d_prime(k)*recVar
           y5d_prime(k) = y5d_prime(k)*recVar
          ELSE
           d5d_prime(k) = 0. _d 0
           e5d_prime(k) = 0. _d 0
           y5d_prime(k) = 0. _d 0
           errCode = 1
          ENDIF

C-- k loop
        ENDDO

C--   Backward sweep (starting from bottom)
        DO k=Nr,1,-1
         IF (k.EQ.Nr) THEN
          y5d_update(k) =   y5d_prime(k)
         ELSEIF (k.EQ.Nr-1) THEN
          y5d_update(k) =   y5d_prime(k)
     &     - y5d_update(k+1)*d5d_prime(k)
         ELSE
          y5d_update(k) =   y5d_prime(k)
     &     - y5d_update(k+1)*d5d_prime(k)
     &     - y5d_update(k+2)*e5d_prime(k)
         ENDIF
        ENDDO

C--   Update array
        DO k=1,Nr
         y5d(i,j,k) = y5d_update(k)
        ENDDO

C-    end i,j loop
       ENDDO
      ENDDO

#else  /* ndef SOLVE_DIAGONAL_KINNER */

#ifdef ALLOW_AUTODIFF_TAMC
CADJ INIT loctape_solvepenta = COMMON, Nr
#endif
C--   Init. + copy to temp. array
      DO k=1,Nr
       DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
         c5d_prime(i,j,k) = 0. _d 0
         d5d_prime(i,j,k) = 0. _d 0
         e5d_prime(i,j,k) = 0. _d 0
         y5d_prime(i,j,k) = 0. _d 0
         y5d_m1(i,j,k) = y5d(i,j,k)
        ENDDO
       ENDDO
      ENDDO

      DO k=1,Nr
C--   Forward sweep (starting from top)
#ifdef ALLOW_AUTODIFF_TAMC
CADJ STORE d5d_prime(:,:,k) = loctape_solvepenta, key = k
CADJ STORE e5d_prime(:,:,k) = loctape_solvepenta, key = k
CADJ STORE y5d_prime(:,:,k) = loctape_solvepenta, key = k
#endif
       IF ( k .EQ. 1 ) THEN
C-    just copy terms
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          c5d_prime(i,j,k) = c5d(i,j,k)
          d5d_prime(i,j,k) = d5d(i,j,k)
          e5d_prime(i,j,k) = e5d(i,j,k)
          y5d_prime(i,j,k) = y5d_m1(i,j,k)
         ENDDO
        ENDDO
       ELSEIF ( k .EQ. 2 ) THEN
C-    subtract one term
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          tmpVar = b5d(i,j,k)
          c5d_prime(i,j,k) = c5d(i,j,k)    - tmpVar*d5d_prime(i,j,k-1)
          d5d_prime(i,j,k) = d5d(i,j,k)    - tmpVar*e5d_prime(i,j,k-1)
          e5d_prime(i,j,k) = e5d(i,j,k)
          y5d_prime(i,j,k) = y5d_m1(i,j,k) - tmpVar*y5d_prime(i,j,k-1)
         ENDDO
        ENDDO
       ELSE
C-    subtract two terms
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          tmpVar = b5d(i,j,k)-a5d(i,j,k)*d5d_prime(i,j,k-2)
          c5d_prime(i,j,k) = c5d(i,j,k)    - tmpVar*d5d_prime(i,j,k-1)
     &         -a5d(i,j,k)*e5d_prime(i,j,k-2)
          d5d_prime(i,j,k) = d5d(i,j,k)    - tmpVar*e5d_prime(i,j,k-1)
          e5d_prime(i,j,k) = e5d(i,j,k)
          y5d_prime(i,j,k) = y5d_m1(i,j,k) - tmpVar*y5d_prime(i,j,k-1)
     &         -a5d(i,j,k)*y5d_prime(i,j,k-2)
         ENDDO
        ENDDO
       ENDIF

C-    normalization
       DO j=1-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
         tmpVar = c5d_prime(i,j,k)
         IF ( tmpVar.NE.0. _d 0 ) THEN
          recVar = 1. _d 0 / tmpVar
          d5d_prime(i,j,k) = d5d_prime(i,j,k)*recVar
          e5d_prime(i,j,k) = e5d_prime(i,j,k)*recVar
          y5d_prime(i,j,k) = y5d_prime(i,j,k)*recVar
         ELSE
          d5d_prime(i,j,k) = 0. _d 0
          e5d_prime(i,j,k) = 0. _d 0
          y5d_prime(i,j,k) = 0. _d 0
          errCode = 1
         ENDIF
        ENDDO
       ENDDO

C-    end k-loop
      ENDDO

C--   Backward sweep (starting from bottom)
      DO k=Nr,1,-1
       IF ( k .EQ. Nr ) THEN
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          y5d(i,j,k) =    y5d_prime(i,j,k)
         ENDDO
        ENDDO
       ELSEIF ( k .EQ. Nr-1 ) THEN
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          y5d(i,j,k) =    y5d_prime(i,j,k)
     &     - y5d(i,j,k+1)*d5d_prime(i,j,k)
         ENDDO
        ENDDO
       ELSE
        DO j=1-OLy,sNy+OLy
         DO i=1-OLx,sNx+OLx
          y5d(i,j,k) =    y5d_prime(i,j,k)
     &     - y5d(i,j,k+1)*d5d_prime(i,j,k)
     &     - y5d(i,j,k+2)*e5d_prime(i,j,k)
         ENDDO
        ENDDO
       ENDIF
C-    k-loop
      ENDDO

#endif /* SOLVE_DIAGONAL_KINNER */

#endif /* SOLVE_DIAGONAL_LOWMEMORY */

#endif /* INCLUDE_IMPLVERTADV_CODE */

      RETURN
      END

#include "MOM_VECINV_OPTIONS.h"

      SUBROUTINE MOM_VI_V_GRAD_KE(
     I        bi,bj,k,
     I        KE,
     O        dKEdy,
     I        myThid)
      IMPLICIT NONE
C     /==========================================================\
C     | S/R MOM_V_GRAD_KE                                        |
C     |==========================================================|
C     \==========================================================/

C     == Global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "GRID.h"

C     == Routine arguments ==
      INTEGER bi,bj,k
      _RL KE(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL dKEdy(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER myThid

C     == Local variables ==
      INTEGER i,j

      DO j=2-OLy,sNy+OLy
        DO i=1-OLx,sNx+OLx
          dKEdy(i,j)=-_recip_dyC(i,j,bi,bj)*(KE(i,j)-KE(i,j-1))
     &               *_maskS(i,j,k,bi,bj)*recip_deepFacC(k)
        ENDDO
      ENDDO

      RETURN
      END

#include "PTRACERS_OPTIONS.h"

CBOP
C !ROUTINE: PTRACERS_APPLY_FORCING

C !INTERFACE: ==========================================================
      SUBROUTINE PTRACERS_APPLY_FORCING(
     U                    gPtracer,
     I                    surfForcPtr,
     I                    iMin,iMax,jMin,jMax, k, bi, bj,
     I                    iTracer, myTime, myIter, myThid )

C !DESCRIPTION:
C     Apply passive tracer forcing, i.e., sources and sinks of tracer,
C      by adding forcing terms to the tendency array

C !USES: ===============================================================
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "PTRACERS_SIZE.h"
#include "PTRACERS_PARAMS.h"
#include "PTRACERS_FIELDS.h"

C !INPUT PARAMETERS: ===================================================
C  gPtracer             :: the tendency array
C  surfForcPtr          :: surface forcing term
C  iMin iMax jMin jMax  :: working range of tile for applying forcing
C  k                    :: vertical level number
C  bi,bj                :: tile indices
C  iTracer              :: tracer number
C  myIter               :: time-step number
C  myTime               :: model time
C  myThid               :: thread number
      _RL gPtracer   (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL surfForcPtr(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER iMin,iMax,jMin,jMax
      INTEGER k, bi,bj, iTracer
      _RL myTime
      INTEGER myIter
      INTEGER myThid

C !OUTPUT PARAMETERS: ==================================================
C  gPtracer       :: updates tendency array

#ifdef ALLOW_PTRACERS

C !LOCAL VARIABLES: ====================================================
C  i,j            :: loop indices
      INTEGER i,j
C     number of surface interface layer
      INTEGER kSurface
CEOP

      IF ( fluidIsAir ) THEN
       kSurface = 0
      ELSEIF ( usingZCoords .AND. useShelfIce ) THEN
       kSurface = -1
      ELSEIF ( usingPCoords ) THEN
       kSurface = Nr
      ELSE
       kSurface = 1
      ENDIF

C--   Surface forcing term surfForcPtr is previously computed by
C     PTRACERS_FORCING_SURF (and stored as surfaceForcingPTr)
C     because it is needed by KPP_TRANSPORT_PTR.

#ifdef ALLOW_GCHEM
      IF ( useGCHEM ) THEN
        CALL GCHEM_ADD_TENDENCY(
     U                 gPtracer,
     I                 iMin,iMax,jMin,jMax, k, bi, bj,
     I                 iTracer, myTime, myIter, myThid )
      ENDIF
#endif /* ALLOW_GCHEM */

      IF ( k .EQ. kSurface ) THEN
c      DO j=jMin,jMax
c       DO i=iMin,iMax
       DO j=0,sNy+1
        DO i=0,sNx+1
          gPtracer(i,j) = gPtracer(i,j)
     &                  + surfForcPtr(i,j)
     &                   *recip_drF(k)*recip_hFacC(i,j,k,bi,bj)
        ENDDO
       ENDDO
      ELSEIF ( kSurface.EQ.-1 ) THEN
       DO j=0,sNy+1
        DO i=0,sNx+1
         IF ( kSurfC(i,j,bi,bj).EQ.k ) THEN
          gPtracer(i,j) = gPtracer(i,j)
     &                  + surfForcPtr(i,j)
     &                   *recip_drF(k)*recip_hFacC(i,j,k,bi,bj)
         ENDIF
        ENDDO
       ENDDO
      ENDIF

      IF (PTRACERS_linFSConserve(iTracer)) THEN
       DO j=0,sNy+1
        DO i=0,sNx+1
         IF ( kSurfC(i,j,bi,bj).EQ.k ) THEN
            gPtracer(i,j) = gPtracer(i,j)
     &           +meanSurfCorPTr(iTracer)*recip_drF(k)
     &           *_recip_hFacC(i,j,k,bi,bj)
         ENDIF
        ENDDO
       ENDDO
      ENDIF

#ifdef ALLOW_RBCS
      IF ( useRBCS ) THEN
         CALL RBCS_ADD_TENDENCY(
     U                 gPtracer,
     I                 k, bi, bj, iTracer+2,
     I                 myTime, myIter, myThid )
      ENDIF
#endif /* ALLOW_RBCS */

#endif /* ALLOW_PTRACERS */

      RETURN
      END

#include "DIAG_OPTIONS.h"
#undef DEBUG_DIAG_CG2D

CBOP
C     !ROUTINE: DIAG_CG2D
C     !INTERFACE:
      SUBROUTINE DIAG_CG2D(
     I                aW2d, aS2d, b2d,
     I                offDiagFactor, residCriter,
     O                firstResidual, minResidual, lastResidual,
     U                x2d, numIters,
     O                nIterMin,
     I                printResidFrq, myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE CG2D
C     | o Two-dimensional grid problem conjugate-gradient
C     |   inverter (with preconditioner).
C     *==========================================================*
C     | Con. grad is an iterative procedure for solving Ax = b.
C     | It requires the A be symmetric.
C     | This implementation assumes A is a five-diagonal
C     | matrix of the form that arises in the discrete
C     | representation of the del^2 operator in a
C     | two-dimensional space.
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     === Global data ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
C     b2d           :: The source term or "right hand side"
C     x2d           :: The solution
C     offDiagFactor :: preconditioner off-diagonal factor
C     residCriter   :: residual target for convergence
C     firstResidual :: the initial residual before any iterations
C     minResidual   :: the lowest residual reached
C     lastResidual  :: the actual residual reached
C     numIters  :: Entry: the maximum number of iterations allowed
C                  Exit:  the actual number of iterations used
C     nIterMin      :: iteration number corresponding to lowest residual
C     printResidFrq :: Frequency for printing residual in CG iterations
C     myThid        :: my Thread Id number
      _RS  aW2d(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RS  aS2d(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL  b2d (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL  residCriter
      _RL  offDiagFactor
      _RL  firstResidual
      _RL  minResidual
      _RL  lastResidual
      _RL  x2d (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      INTEGER numIters
      INTEGER nIterMin
      INTEGER printResidFrq
      INTEGER myThid

C     !LOCAL VARIABLES:
C     === Local variables ====
C     bi, bj     :: tile indices
C     eta_qrN    :: Used in computing search directions
C     eta_qrNM1     suffix N and NM1 denote current and
C     cgBeta        previous iterations respectively.
C     alpha
C     sumRHS     :: Sum of right-hand-side. Sometimes this is a
C                   useful debuggin/trouble shooting diagnostic.
C                   For neumann problems sumRHS needs to be ~0.
C                   or they converge at a non-zero residual.
C     err        :: Measure of current residual of Ax - b, usually the norm.
C     i, j, it2d :: Loop counters ( it2d counts CG iterations )
      INTEGER bi, bj
      INTEGER i, j, it2d
      _RL    err,     errTile(nSx,nSy)
      _RL    eta_qrN, eta_qrNtile(nSx,nSy)
      _RL    eta_qrNM1
      _RL    cgBeta
      _RL    alpha,  alphaTile(nSx,nSy)
      _RL    sumRHS, sumRHStile(nSx,nSy)
      _RL    pW_tmp, pS_tmp
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      LOGICAL printResidual
CEOP
      _RS  aC2d(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RS  pW  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RS  pS  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RS  pC  (1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL  q2d(0:sNx+1,0:sNy+1,nSx,nSy)
#ifdef DEBUG_DIAG_CG2D
      CHARACTER*(10) sufx
      _RL  r2d(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
#else
      _RL  r2d(0:sNx+1,0:sNy+1,nSx,nSy)
#endif
      _RL  s2d(0:sNx+1,0:sNy+1,nSx,nSy)
      _RL  x2dm(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)

#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_ENTER('DIAG_CG2D',myThid)
#endif

C--   Set matrice main diagnonal:
      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
C-    Initialise overlap regions (in case EXCH call do not fill them all)
        DO j = 1-OLy,sNy+OLy
         DO i = 1-OLx,sNx+OLx
           aC2d(i,j,bi,bj) = 0.
         ENDDO
        ENDDO
        DO j=1,sNy
         DO i=1,sNx
           aC2d(i,j,bi,bj) = -( ( aW2d(i,j,bi,bj)+aW2d(i+1,j,bi,bj) )
     &                         +( aS2d(i,j,bi,bj)+aS2d(i,j+1,bi,bj) )
     &                        )
         ENDDO
        ENDDO
       ENDDO
      ENDDO
      CALL EXCH_XY_RS(aC2d, myThid)

C--   Initialise preconditioner
      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        DO j=1,sNy+1
         DO i=1,sNx+1
          IF ( aC2d(i,j,bi,bj) .EQ. 0. ) THEN
           pC(i,j,bi,bj) = 1. _d 0
          ELSE
           pC(i,j,bi,bj) = 1. _d 0 / aC2d(i,j,bi,bj)
          ENDIF
          pW_tmp = aC2d(i,j,bi,bj)+aC2d(i-1,j,bi,bj)
          IF ( pW_tmp .EQ. 0. ) THEN
           pW(i,j,bi,bj) = 0.
          ELSE
           pW(i,j,bi,bj) = -aW2d(i,j,bi,bj)*offDiagFactor
     &                     *4. _d 0/( pW_tmp*pW_tmp )
          ENDIF
          pS_tmp = aC2d(i,j,bi,bj)+aC2d(i,j-1,bi,bj)
          IF ( pS_tmp .EQ. 0. ) THEN
           pS(i,j,bi,bj) = 0.
          ELSE
           pS(i,j,bi,bj) = -aS2d(i,j,bi,bj)*offDiagFactor
     &                     *4. _d 0/( pS_tmp*pS_tmp )
          ENDIF
c         pC(i,j,bi,bj) = 1.
c         pW(i,j,bi,bj) = 0.
c         pS(i,j,bi,bj) = 0.
         ENDDO
        ENDDO
       ENDDO
      ENDDO

C--   Initialise inverter
      eta_qrNM1 = 1. _d 0

      CALL EXCH_XY_RL( x2d, myThid )

C--   Initial residual calculation
      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        DO j=0,sNy+1
         DO i=0,sNx+1
          r2d(i,j,bi,bj) = 0.
          s2d(i,j,bi,bj) = 0.
          x2dm(i,j,bi,bj) = x2d(i,j,bi,bj)
         ENDDO
        ENDDO
        sumRHStile(bi,bj) = 0. _d 0
        errTile(bi,bj)    = 0. _d 0
        DO j=1,sNy
         DO i=1,sNx
          r2d(i,j,bi,bj) = b2d(i,j,bi,bj) -
     &      (aW2d(i  ,j  ,bi,bj)*x2d(i-1,j  ,bi,bj)
     &      +aW2d(i+1,j  ,bi,bj)*x2d(i+1,j  ,bi,bj)
     &      +aS2d(i  ,j  ,bi,bj)*x2d(i  ,j-1,bi,bj)
     &      +aS2d(i  ,j+1,bi,bj)*x2d(i  ,j+1,bi,bj)
     &      +aC2d(i  ,j  ,bi,bj)*x2d(i  ,j  ,bi,bj)
     &      )
          errTile(bi,bj) = errTile(bi,bj)
     &                  + r2d(i,j,bi,bj)*r2d(i,j,bi,bj)
          sumRHStile(bi,bj) = sumRHStile(bi,bj) + b2d(i,j,bi,bj)
         ENDDO
        ENDDO
       ENDDO
      ENDDO
#ifdef DEBUG_DIAG_CG2D
      CALL EXCH_XY_RL ( r2d, myThid )
#else
      CALL EXCH_S3D_RL( r2d, 1, myThid )
#endif
      CALL GLOBAL_SUM_TILE_RL( errTile,    err,    myThid )
      IF ( printResidFrq.GE.1 )
     &  CALL GLOBAL_SUM_TILE_RL( sumRHStile, sumRHS, myThid )
      err = SQRT(err)
      it2d = 0
      firstResidual = err
      minResidual   = err
      nIterMin = it2d

      printResidual = .FALSE.
      IF ( debugLevel .GE. debLevZero ) THEN
        _BEGIN_MASTER( myThid )
        printResidual = printResidFrq.GE.1
        IF ( printResidual ) THEN
         WRITE(msgBuf,'(2A,I6,A,1PE17.9,A,1PE14.6)')' diag_cg2d:',
     &    ' iter=', it2d, ' ; resid.=', err, ' ; sumRHS=', sumRHS
         CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                       SQUEEZE_RIGHT, myThid )
        ENDIF
        _END_MASTER( myThid )
      ENDIF
#ifdef DEBUG_DIAG_CG2D
      IF ( printResidFrq.GE.1 ) THEN
        WRITE(sufx,'(I10.10)') 0
        CALL WRITE_FLD_XY_RL( 'r2d.',sufx, r2d, 1, myThid )
      ENDIF
#endif

      IF ( err .LT. residCriter ) GOTO 11

C     >>>>>>>>>>>>>>> BEGIN SOLVER <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
      DO 10 it2d=1, numIters

C--    Solve preconditioning equation and update
C--    conjugate direction vector "s".
       DO bj=myByLo(myThid),myByHi(myThid)
        DO bi=myBxLo(myThid),myBxHi(myThid)
         eta_qrNtile(bi,bj) = 0. _d 0
         DO j=1,sNy
          DO i=1,sNx
           q2d(i,j,bi,bj) =
     &        pC(i  ,j  ,bi,bj)*r2d(i  ,j  ,bi,bj)
     &       +pW(i  ,j  ,bi,bj)*r2d(i-1,j  ,bi,bj)
     &       +pW(i+1,j  ,bi,bj)*r2d(i+1,j  ,bi,bj)
     &       +pS(i  ,j  ,bi,bj)*r2d(i  ,j-1,bi,bj)
     &       +pS(i  ,j+1,bi,bj)*r2d(i  ,j+1,bi,bj)
           eta_qrNtile(bi,bj) = eta_qrNtile(bi,bj)
     &       +q2d(i,j,bi,bj)*r2d(i,j,bi,bj)
          ENDDO
         ENDDO
        ENDDO
       ENDDO

       CALL GLOBAL_SUM_TILE_RL( eta_qrNtile,eta_qrN,myThid )
       cgBeta   = eta_qrN/eta_qrNM1
       eta_qrNM1 = eta_qrN

       DO bj=myByLo(myThid),myByHi(myThid)
        DO bi=myBxLo(myThid),myBxHi(myThid)
         DO j=1,sNy
          DO i=1,sNx
           s2d(i,j,bi,bj) = q2d(i,j,bi,bj)
     &                    + cgBeta*s2d(i,j,bi,bj)
          ENDDO
         ENDDO
        ENDDO
       ENDDO

C--    Do exchanges that require messages i.e. between processes.
       CALL EXCH_S3D_RL( s2d, 1, myThid )

C==    Evaluate laplace operator on conjugate gradient vector
C==    q = A.s
       DO bj=myByLo(myThid),myByHi(myThid)
        DO bi=myBxLo(myThid),myBxHi(myThid)
         alphaTile(bi,bj) = 0. _d 0
         DO j=1,sNy
          DO i=1,sNx
           q2d(i,j,bi,bj) =
     &       aW2d(i  ,j  ,bi,bj)*s2d(i-1,j  ,bi,bj)
     &      +aW2d(i+1,j  ,bi,bj)*s2d(i+1,j  ,bi,bj)
     &      +aS2d(i  ,j  ,bi,bj)*s2d(i  ,j-1,bi,bj)
     &      +aS2d(i  ,j+1,bi,bj)*s2d(i  ,j+1,bi,bj)
     &      +aC2d(i  ,j  ,bi,bj)*s2d(i  ,j  ,bi,bj)
           alphaTile(bi,bj) = alphaTile(bi,bj)
     &                      + s2d(i,j,bi,bj)*q2d(i,j,bi,bj)
          ENDDO
         ENDDO
        ENDDO
       ENDDO
       CALL GLOBAL_SUM_TILE_RL( alphaTile,  alpha,  myThid )
       alpha = eta_qrN/alpha

C==    Update solution and residual vectors
C      Now compute "interior" points.
       DO bj=myByLo(myThid),myByHi(myThid)
        DO bi=myBxLo(myThid),myBxHi(myThid)
         errTile(bi,bj) = 0. _d 0
         DO j=1,sNy
          DO i=1,sNx
           x2d(i,j,bi,bj)=x2d(i,j,bi,bj)+alpha*s2d(i,j,bi,bj)
           r2d(i,j,bi,bj)=r2d(i,j,bi,bj)-alpha*q2d(i,j,bi,bj)
           errTile(bi,bj) = errTile(bi,bj)
     &                    + r2d(i,j,bi,bj)*r2d(i,j,bi,bj)
          ENDDO
         ENDDO
        ENDDO
       ENDDO

       CALL GLOBAL_SUM_TILE_RL( errTile,    err,    myThid )
       err = SQRT(err)
       IF ( printResidual ) THEN
        IF ( MOD( it2d-1, printResidFrq ).EQ.0 ) THEN
         WRITE(msgBuf,'(A,I6,A,1PE17.9)')
     &    ' diag_cg2d: iter=', it2d, ' ; resid.=', err
         CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                       SQUEEZE_RIGHT, myThid )
        ENDIF
       ENDIF
       IF ( err .LT. residCriter ) GOTO 11
       IF ( err .LT. minResidual ) THEN
C-     Store lowest residual solution
         minResidual = err
         nIterMin = it2d
         DO bj=myByLo(myThid),myByHi(myThid)
          DO bi=myBxLo(myThid),myBxHi(myThid)
           DO j=1,sNy
            DO i=1,sNx
             x2dm(i,j,bi,bj) = x2d(i,j,bi,bj)
            ENDDO
           ENDDO
          ENDDO
         ENDDO
       ENDIF

#ifdef DEBUG_DIAG_CG2D
       CALL EXCH_XY_RL( r2d, myThid )
       IF ( printResidFrq.GE.1 ) THEN
        WRITE(sufx,'(I10.10)') it2d
        CALL WRITE_FLD_XY_RL( 'r2d.',sufx, r2d, 1, myThid )
        CALL WRITE_FLD_XY_RL( 'x2d.',sufx, x2d, 1, myThid )
       ENDIF
#else
       CALL EXCH_S3D_RL( r2d, 1, myThid )
#endif

   10 CONTINUE
      it2d = numIters
   11 CONTINUE

C--   Return parameters to caller
      lastResidual = err
      numIters = it2d

      IF ( err .GT. minResidual ) THEN
C-    use the lowest residual solution (instead of current one <-> last residual)
        DO bj=myByLo(myThid),myByHi(myThid)
         DO bi=myBxLo(myThid),myBxHi(myThid)
          DO j=1,sNy
           DO i=1,sNx
             x2d(i,j,bi,bj) = x2dm(i,j,bi,bj)
           ENDDO
          ENDDO
         ENDDO
        ENDDO
      ENDIF
c     CALL EXCH_XY_RL( x2d, myThid )

#ifdef ALLOW_DEBUG
      IF (debugMode) CALL DEBUG_LEAVE('DIAG_CG2D',myThid)
#endif

      RETURN
      END

#include "THSICE_OPTIONS.h"
#ifdef ALLOW_AUTODIFF
# include "AUTODIFF_OPTIONS.h"
# ifdef ALLOW_EXF
#  include "EXF_OPTIONS.h"
# endif
# define ALLOW_AUTODIFF_TAMC_MORE
#endif

CBOP
C     !ROUTINE: THSICE_SOLVE4TEMP
C     !INTERFACE:
      SUBROUTINE THSICE_SOLVE4TEMP(
     I                  bi, bj,
     I                  iMin,iMax, jMin,jMax, dBugFlag,
     I                  useBulkForce, useEXF,
     I                  icMask, hIce, hSnow, tFrz, flxExSW,
     U                  flxSW, tSrf, qIc1, qIc2,
     O                  tIc1, tIc2, dTsrf,
     O                  sHeat, flxCnB, flxAtm, evpAtm,
     I                  myTime, myIter, myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R  THSICE_SOLVE4TEMP
C     *==========================================================*
C     | Solve (implicitly) for sea-ice and surface temperature
C     *==========================================================*
C     \ev

C ADAPTED FROM:
C LANL CICE.v2.0.2
C-----------------------------------------------------------------------
C.. thermodynamics (vertical physics) based on M. Winton 3-layer model
C.. See Bitz, C. M. and W. H. Lipscomb, 1999:  An energy-conserving
C..       thermodynamic sea ice model for climate study.
C..       J. Geophys. Res., 104, 15669 - 15677.
C..     Winton, M., 1999:  "A reformulated three-layer sea ice model."
C..       Submitted to J. Atmos. Ocean. Technol.
C.. authors Elizabeth C. Hunke and William Lipscomb
C..         Fluid Dynamics Group, Los Alamos National Laboratory
C-----------------------------------------------------------------------
Cc****subroutine thermo_winton(n,fice,fsnow,dqice,dTsfc)
C.. Compute temperature change using Winton model with 2 ice layers, of
C.. which only the top layer has a variable heat capacity.

C     !USES:
      IMPLICIT NONE

C     == Global variables ===
#include "EEPARAMS.h"
#include "SIZE.h"
#include "THSICE_PARAMS.h"
#ifdef ALLOW_AUTODIFF
# include "THSICE_SIZE.h"
c#include "THSICE_VARS.h"
# ifdef ALLOW_EXF
#  include "EXF_PARAM.h"
#  include "EXF_CONSTANTS.h"
#  include "EXF_FIELDS.h"
# endif
#endif
#ifdef ALLOW_AUTODIFF_TAMC
# include "tamc.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine Arguments ==
C     bi,bj       :: tile indices
C     iMin,iMax   :: computation domain: 1rst index range
C     jMin,jMax   :: computation domain: 2nd  index range
C     dBugFlag    :: allow to print debugging stuff (e.g. on 1 grid point).
C     useBulkForce:: use surf. fluxes from bulk-forcing external S/R
C     useEXF      :: use surf. fluxes from exf          external S/R
C---  Input:
C     icMask      :: sea-ice fractional mask [0-1]
C     hIce        :: ice height [m]
C     hSnow       :: snow height [m]
C     tFrz        :: sea-water freezing temperature [oC] (function of S)
C     flxExSW     :: Net (minus SW) surf. heat flux (+=down) fct of surf temp Ts
C                    0: Flx(Ts=0) ; 1: Flx(Ts=Ts^n) ; 2: d.Flx/dTs(Ts=Ts^n)
C---  Modified (input&output):
C     flxSW       :: net Short-Wave flux (+=down) [W/m2]: input= at surface
C                 ::                 output= below sea-ice, into the ocean
C     tSrf        :: surface (ice or snow) temperature
C     qIc1        :: ice enthalpy [J/kg], 1rst level
C     qIc2        :: ice enthalpy [J/kg], 2nd level
C---  Output
C     tIc1        :: temperature of ice layer 1 [oC]
C     tIc2        :: temperature of ice layer 2 [oC]
C     dTsrf       :: surface temp adjusment: Ts^n+1 - Ts^n
C     sHeat       :: surf heat flux left to melt snow or ice (=Atmos-conduction)
C     flxCnB      :: heat flux conducted through the ice to bottom surface
C     flxAtm      :: net flux of energy from the atmosphere [W/m2] (+=down)
C                    without snow precip. (energy=0 for liquid water at 0.oC)
C     evpAtm      :: evaporation to the atmosphere [kg/m2/s] (>0 if evaporate)
C---  Input:
C     myTime      :: current Time of simulation [s]
C     myIter      :: current Iteration number in simulation
C     myThid      :: my Thread Id number
      INTEGER bi,bj
      INTEGER iMin, iMax
      INTEGER jMin, jMax
      LOGICAL dBugFlag
      LOGICAL useBulkForce
      LOGICAL useEXF
      _RL icMask (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL hIce   (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL hSnow  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL tFrz   (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL flxSW  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL tSrf   (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL qIc1   (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL qIc2   (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL tIc1   (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL tIc2   (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL sHeat  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL flxCnB (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL flxAtm (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL evpAtm (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
C
      _RL flxExSW(1:sNx,1:sNy,0:2)
      _RL dTsrf  (1:sNx,1:sNy)
      _RL myTime
      INTEGER myIter
      INTEGER myThid
CEOP

#ifdef ALLOW_THSICE
C     !LOCAL VARIABLES:
C     == Local Variables ==
C     useBlkFlx    :: use some bulk-formulae to compute fluxes over sea-ice
C                  :: (otherwise, fluxes are passed as argument from AIM)
C     iterate4Tsf  :: to stop to iterate when all icy grid pts Tsf did converged
C     iceFlag      :: True= do iterate for Surf.Temp ; False= do nothing
C     frsnow       :: fractional snow cover
C     fswpen       :: SW penetrating beneath surface [W/m2]
C     fswdn        :: SW absorbed at surface [W/m2]
C     fswint       :: SW absorbed in ice [W/m2]
C     fswocn       :: SW passed through ice to ocean [W/m2]
C     Tsf_mlt      :: surface temperature of snow or ice at melting point
C     flx0exSW     :: net (minus SW) surface heat flux over melting snow/ice
C     flxTexSW     :: net (minus SW) surface heat flux (+=down) [W/m2]
C     dFlxdT       :: derivative of flxNet wrt tSrf [W/m2/K]
C     evap_0       :: evaporation over melting snow/ice (>0 evaporate) [kg/m2/s]
C                     renamed to avoid conflict with EXF evap0 (AUTODIFF)
C     evapT        :: evaporation over snow/ice (>0 if evaporate) [kg/m2/s]
C     dEvdT        :: derivative of evap. with respect to tSrf [kg/m2/s/K]
C     flxNet       :: net surf heat flux (+=down), from atmos to sea-ice [W/m2]
C     netSW        :: net Short-Wave flux at surface (+=down) [W/m2]
C     fct          :: heat conducted to top surface
C     k12, k32     :: thermal conductivity terms
C     a10,b10,c10  :: coefficients in quadratic eqn for T1
C     a1, b1, c1   :: coefficients in quadratic eqn for T1
C     dt           :: timestep
      LOGICAL useBlkFlx
      LOGICAL iterate4Tsf
      INTEGER i, j, k, iterMax
      INTEGER ii, jj, icount, stdUnit
#if ( defined ALLOW_DBUG_THSICE || !defined ALLOW_AUTODIFF )
      CHARACTER*(MAX_LEN_MBUF) msgBuf
#endif
      _RL  frsnow
      _RL  fswpen
      _RL  fswdn
      _RL  fswint
      _RL  fswocn
      _RL  iceFlag (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL  Tsf_mlt (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL  flx0exSW(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL  flxTexSW(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL  dFlxdT  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL  evap_0  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL  evapT   (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL  dEvdT   (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL  flxNet
      _RL  fct
      _RL  k12     (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL  k32
      _RL  a10     (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL  b10     (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL  c10     (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL  a1, b1, c1
      _RL  dt
      _RL  recip_dhSnowLin
      _RL  TsfTmp, tIc2Tmp
#ifdef ALLOW_DBUG_THSICE
      _RL  netSW
#endif
#ifdef ALLOW_AUTODIFF_TAMC
C     tkey  :: tape key (depends on tiles)
C     ikey  :: tape key (depends on iteration index and tiles)
      INTEGER tkey, ikey
#endif

#ifdef ALLOW_DBUG_THSICE
C-    Define grid-point location where to print debugging values
#include "THSICE_DEBUG.h"
 1010 FORMAT(A,I3,3F11.6)
 1020 FORMAT(A,1P4E14.6)
#endif
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

#ifdef ALLOW_AUTODIFF_TAMC
      tkey = bi + (bj-1)*nSx + (ikey_dynamics-1)*nSx*nSy
CADJ STORE flxsw  = comlev1_bibj, key = tkey, kind = isbyte
CADJ STORE hSnow  = comlev1_bibj, key = tkey, kind = isbyte
#endif /* ALLOW_AUTODIFF_TAMC */

#ifdef ALLOW_AUTODIFF
      DO j = 1-OLy, sNy+OLy
       DO i = 1-OLx, sNx+OLx
        tIc1(i,j) = 0. _d 0
        tIc2(i,j) = 0. _d 0
C-   set these arrays everywhere: overlap are not set and not used,
C     but some arrays are stored and storage includes overlap.
        flx0exSW(i,j) = 0. _d 0
        flxTexSW(i,j) = 0. _d 0
        dFlxdT  (i,j) = 0. _d 0
        evap_0  (i,j) = 0. _d 0
        evapT   (i,j) = 0. _d 0
        dEvdT   (i,j) = 0. _d 0
        iceFlag (i,j) = 0. _d 0
        Tsf_mlt (i,j) = 0. _d 0
       ENDDO
      ENDDO
#endif

      stdUnit = standardMessageUnit
      useBlkFlx = useEXF .OR. useBulkForce
      dt  = thSIce_dtTemp
      IF ( dhSnowLin.GT.0. _d 0 ) THEN
        recip_dhSnowLin = 1. _d 0 / dhSnowLin
      ELSE
        recip_dhSnowLin = 0. _d 0
      ENDIF

      iterate4Tsf = .FALSE.
      icount = 0

      DO j = jMin, jMax
       DO i = iMin, iMax
        IF ( icMask(i,j).GT.0. _d 0) THEN
          iterate4Tsf  = .TRUE.
          iceFlag(i,j) = 1. _d 0
#ifdef ALLOW_DBUG_THSICE
          IF ( dBug(i,j,bi,bj) ) WRITE(stdUnit,'(A,2I4,2I2)')
     &         'ThSI_SOLVE4T: i,j=',i,j,bi,bj
#endif
          IF ( hIce(i,j).LT.hIceMin ) THEN
C     if hi < hIceMin, melt the ice.
C     keep the position of this problem but do the stop later
           ii = i
           jj = j
           icount = icount + 1
          ENDIF

C--   Fractional snow cover:
C     assume a linear distribution of snow thickness, with dhSnowLin slope,
C      from hs-dhSnowLin to hs+dhSnowLin if full ice & snow cover.
C     frsnow = fraction of snow over the ice-covered part of the grid cell
          IF ( hSnow(i,j) .GT. icMask(i,j)*dhSnowLin ) THEN
           frsnow = 1. _d 0
          ELSE
           frsnow = hSnow(i,j)*recip_dhSnowLin/icMask(i,j)
           IF ( frsnow.GT.0. _d 0 ) frsnow = SQRT(frsnow)
          ENDIF

C--   Compute SW flux absorbed at surface and penetrating to layer 1.
          fswpen = flxSW(i,j) * (1. _d 0 - frsnow) * i0swFrac
          fswocn = fswpen * exp(-ksolar*hIce(i,j))
          fswint = fswpen - fswocn
          fswdn  = flxSW(i,j) - fswpen

C     Initialise Atmospheric surf. heat flux with net SW flux at the surface
          flxAtm(i,j) = flxSW(i,j)
C     SW flux at sea-ice base left to the ocean
          flxSW(i,j) = fswocn
C     Initialise surface Heating with SW contribution
          sHeat(i,j) = fswdn

C--   Compute conductivity terms at layer interfaces.
          k12(i,j) = 4. _d 0*kIce*kSnow
     &             / (kSnow*hIce(i,j) + 4. _d 0*kIce*hSnow(i,j))
          k32      = 2. _d 0*kIce  / hIce(i,j)

C--   Compute ice temperatures
          a1 = cpIce
          b1 = qIc1(i,j) + (cpWater-cpIce )*Tmlt1 - Lfresh
          c1 = Lfresh * Tmlt1
          tIc1(i,j) = 0.5 _d 0 *(-b1 - SQRT(b1*b1-4. _d 0*a1*c1))/a1
          tIc2(i,j) = (Lfresh-qIc2(i,j)) / cpIce

#ifdef ALLOW_DBUG_THSICE
          IF (tIc1(i,j).GT.0. _d 0 ) THEN
           WRITE(stdUnit,'(A,I12,1PE14.6)')
     &       ' BBerr: Tice(1) > 0 ; it=', myIter, qIc1(i,j)
           WRITE(stdUnit,'(A,4I5,2F11.4)')
     &      ' BBerr: i,j,bi,bj,Tice = ',i,j,bi,bj,tIc1(i,j),tIc2(i,j)
          ENDIF
          IF ( tIc2(i,j).GT.0. _d 0) THEN
           WRITE(stdUnit,'(A,I12,1PE14.6)')
     &       ' BBerr: Tice(2) > 0 ; it=', myIter, qIc2(i,j)
           WRITE(stdUnit,'(A,4I5,2F11.4)')
     &      ' BBerr: i,j,bi,bj,Tice = ',i,j,bi,bj,tIc1(i,j),tIc2(i,j)
          ENDIF
          IF ( dBug(i,j,bi,bj) ) WRITE(stdUnit,1010)
     &     'ThSI_SOLVE4T: k, Ts, Tice=',0,tSrf(i,j),tIc1(i,j),tIc2(i,j)
#endif

C--   Compute coefficients used in quadratic formula.

          a10(i,j) = rhoi*cpIce *hIce(i,j)/(2. _d 0*dt) +
     &          k32*( 4. _d 0*dt*k32 + rhoi*cpIce *hIce(i,j) )
     &           / ( 6. _d 0*dt*k32 + rhoi*cpIce *hIce(i,j) )
          b10(i,j) = -hIce(i,j)*
     &          ( rhoi*cpIce*tIc1(i,j) + rhoi*Lfresh*Tmlt1/tIc1(i,j) )
     &           /(2. _d 0*dt)
     &        - k32*( 4. _d 0*dt*k32*tFrz(i,j)
     &               +rhoi*cpIce*hIce(i,j)*tIc2(i,j) )
     &           / ( 6. _d 0*dt*k32 + rhoi*cpIce *hIce(i,j) )
     &        - fswint
          c10(i,j) = rhoi*Lfresh*hIce(i,j)*Tmlt1 / (2. _d 0*dt)

        ELSE
          iceFlag(i,j) = 0. _d 0
        ENDIF
       ENDDO
      ENDDO
#ifndef ALLOW_AUTODIFF
      IF ( icount .gt. 0 ) THEN
       WRITE(stdUnit,'(A,I5,A)')
     &      'THSICE_SOLVE4TEMP: there are ',icount,
     &      ' case(s) where hIce<hIceMin;'
       WRITE(stdUnit,'(A,I3,A1,I3,A)')
     &      'THSICE_SOLVE4TEMP: the last one was at (',ii,',',jj,
     &      ') with hIce = ', hIce(ii,jj)
       WRITE( msgBuf, '(A)')
     &      'THSICE_SOLVE4TEMP: should not enter if hIce<hIceMin'
       CALL PRINT_ERROR( msgBuf , myThid )
       STOP 'ABNORMAL END: S/R THSICE_SOLVE4TEMP'
      ENDIF
#endif /* ALLOW_AUTODIFF */

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

C--   Get surface fluxes over melting surface (assumed to be @ 0 oC)
#ifndef ALLOW_AUTODIFF
      IF ( useBlkFlx .AND. iterate4Tsf  ) THEN
#endif
        DO j = jMin, jMax
         DO i = iMin, iMax
           Tsf_mlt(i,j) = 0.
         ENDDO
        ENDDO
#ifndef ALLOW_AUTODIFF
        IF ( useEXF ) THEN
#endif
           k = 1
           CALL THSICE_GET_EXF(   bi, bj, k,
     I                            iMin, iMax, jMin, jMax,
     I                            iceFlag, hSnow, Tsf_mlt,
     O                            flx0exSW, dFlxdT, evap_0, dEvdT,
     I                            myTime, myIter, myThid )
#ifndef ALLOW_AUTODIFF
C-    could add this "ifdef" to hide THSICE_GET_BULKF from TAF
        ELSEIF ( useBulkForce ) THEN
           CALL THSICE_GET_BULKF( bi, bj,
     I                            iMin, iMax, jMin, jMax,
     I                            iceFlag, hSnow, Tsf_mlt,
     O                            flx0exSW, dFlxdT, evap_0, dEvdT,
     I                            myTime, myIter, myThid )
C--- end if: IF ( useEXF ) THEN
        ENDIF
C--- end if: IF ( useBlkFlx .AND. iterate4Tsf  ) THEN
      ENDIF
#endif

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C---  Compute new surface and ice temperatures; iterate until tSrf converges.
      DO j = jMin, jMax
        DO i = iMin, iMax
          dTsrf(i,j) = Terrmax
        ENDDO
      ENDDO
      IF ( useBlkFlx ) THEN
        iterMax = nitMaxTsf
      ELSE
        iterMax = 1
      ENDIF

C ----- begin iteration  -----
      DO k = 1,iterMax
#ifndef ALLOW_AUTODIFF
       IF ( iterate4Tsf ) THEN
        iterate4Tsf = .FALSE.
C
        IF ( useBlkFlx ) THEN
#endif
#ifdef ALLOW_AUTODIFF_TAMC
         ikey = (tkey-1)*MaxTsf + k
CADJ STORE iceflag  = comlev1_thsice_s4t, key = ikey, kind = isbyte
CADJ STORE tSrf     = comlev1_thsice_s4t, key = ikey, kind = isbyte
CADJ STORE flxTexSW = comlev1_thsice_s4t, key = ikey, kind = isbyte
CADJ STORE dFlxdT   = comlev1_thsice_s4t, key = ikey, kind = isbyte
CADJ STORE dEvdT    = comlev1_thsice_s4t, key = ikey, kind = isbyte
#endif

C--   Compute top surface flux.
#ifndef ALLOW_AUTODIFF
         IF ( useEXF ) THEN
#endif
           CALL THSICE_GET_EXF(   bi, bj, k+1,
     I                            iMin, iMax, jMin, jMax,
     I                            iceFlag, hSnow, tSrf,
     O                            flxTexSW, dFlxdT, evapT, dEvdT,
     I                            myTime, myIter, myThid )
C-    could add this "ifdef" to hide THSICE_GET_BULKF from TAF
#ifndef ALLOW_AUTODIFF
         ELSEIF ( useBulkForce ) THEN
           CALL THSICE_GET_BULKF( bi, bj,
     I                            iMin, iMax, jMin, jMax,
     I                            iceFlag, hSnow, tSrf,
     O                            flxTexSW, dFlxdT, evapT, dEvdT,
     I                            myTime, myIter, myThid )
C--- end if: IF ( useEXF ) THEN
         ENDIF
        ELSE
         DO j = jMin, jMax
          DO i = iMin, iMax
           IF ( iceFlag(i,j).GT.0. _d 0 ) THEN
             flxTexSW(i,j) = flxExSW(i,j,1)
             dFlxdT(i,j) = flxExSW(i,j,2)
           ENDIF
          ENDDO
         ENDDO
C--- end if: IF ( useBlkFlx ) THEN
        ENDIF
#endif /* ALLOW_AUTODIFF */

#ifdef ALLOW_AUTODIFF_TAMC_MORE
C     avoid calling thsice_get_exf in ad-code
CADJ STORE flxTexSW = comlev1_thsice_s4t, key = ikey, kind = isbyte
CADJ STORE dFlxdT   = comlev1_thsice_s4t, key = ikey, kind = isbyte
#endif
C--   Compute new top layer and surface temperatures.
C     If tSrf is computed to be > 0 C, fix tSrf = 0 and recompute tIc1
C     with different coefficients.
        DO j = jMin, jMax
         DO i = iMin, iMax
          IF ( iceFlag(i,j).GT.0. _d 0 ) THEN
           flxNet = sHeat(i,j) + flxTexSW(i,j)
#ifdef ALLOW_DBUG_THSICE
           IF ( dBug(i,j,bi,bj) ) WRITE(stdUnit,1020)
     &     'ThSI_SOLVE4T: flxNet,dFlxdT,k12,D=',
     &      flxNet, dFlxdT(i,j), k12(i,j), k12(i,j)-dFlxdT(i,j)
#endif

           a1 = a10(i,j) - k12(i,j)*dFlxdT(i,j) / (k12(i,j)-dFlxdT(i,j))
           b1 = b10(i,j) - k12(i,j)*(flxNet-dFlxdT(i,j)*tSrf(i,j))
     &                   /(k12(i,j)-dFlxdT(i,j))
           c1 = c10(i,j)
           tIc1(i,j)  = -(b1 + SQRT(b1*b1-4. _d 0*a1*c1))/(2. _d 0*a1)
           dTsrf(i,j) = (flxNet + k12(i,j)*(tIc1(i,j)-tSrf(i,j)))
     &                   /(k12(i,j)-dFlxdT(i,j))
C     this line causes 3 recomputation warings for TAF because tSrf is
C     updated and the updated value is used to update tSrf (and other
C     variables) again; with this intermediate variable, the warnings go
C     away.
C          tSrf(i,j) = tSrf(i,j) + dTsrf(i,j)
           TsfTmp = tSrf(i,j) + dTsrf(i,j)
C
           IF ( TsfTmp .GT. 0. _d 0 ) THEN
#ifdef ALLOW_DBUG_THSICE
            IF ( dBug(i,j,bi,bj) ) WRITE(stdUnit,1010)
     &     'ThSI_SOLVE4T: k,ts,t1,dTs=',k,TsfTmp,tIc1(i,j),dTsrf(i,j)
#endif
            a1 = a10(i,j) + k12(i,j)
C      note: b1 = b10 - k12*Tf0
            b1 = b10(i,j)
            tIc1(i,j) = (-b1 - SQRT(b1*b1-4. _d 0*a1*c1))/(2. _d 0*a1)
            tSrf(i,j) = 0. _d 0
#ifndef ALLOW_AUTODIFF
            IF ( useBlkFlx ) THEN
#endif /* ALLOW_AUTODIFF */
             flxTexSW(i,j) = flx0exSW(i,j)
             evapT(i,j) = evap_0(i,j)
             dTsrf(i,j) = 0. _d 0
#ifndef ALLOW_AUTODIFF
            ELSE
             flxTexSW(i,j) = flxExSW(i,j,0)
             dTsrf(i,j) = 1000.
             dFlxdT(i,j) = 0.
            ENDIF
#endif /* ALLOW_AUTODIFF */
           ELSE
            tSrf(i,j) = TsfTmp
           ENDIF

C--   Check for convergence.  If no convergence, then repeat.
           IF (ABS(dTsrf(i,j)).GE.Terrmax) THEN
            iceFlag(i,j) = 1. _d 0
           ELSE
            iceFlag(i,j) = 0. _d 0
           ENDIF
#ifndef ALLOW_AUTODIFF
           iterate4Tsf = iterate4Tsf .OR. (iceFlag(i,j).GT.0. _d 0)
#endif

C     Convergence test: Make sure tSrf has converged, within prescribed error.
C     (Energy conservation is guaranteed within machine roundoff, even
C      if tSrf has not converged.)
C     If no convergence, then repeat.

#ifdef ALLOW_DBUG_THSICE
           IF ( dBug(i,j,bi,bj) ) WRITE(stdUnit,1010)
     &  'ThSI_SOLVE4T: k,ts,t1,dTs=', k,tSrf(i,j),tIc1(i,j),dTsrf(i,j)
           IF ( useBlkFlx .AND. k.EQ.nitMaxTsf .AND.
     &                     (iceFlag(i,j).GT.0. _d 0) ) THEN
            WRITE(stdUnit,'(A,4I4,I12,F15.9)')
     &       ' BB: not converge: i,j,it,hi=',i,j,bi,bj,myIter,hIce(i,j)
            WRITE(stdUnit,*)
     &        'BB: not converge: tSrf, dTsrf=', tSrf(i,j), dTsrf(i,j)
            WRITE(stdUnit,*)
     &        'BB: not converge: flxNet,dFlxT=', flxNet, dFlxdT(i,j)
            IF ( tSrf(i,j).LT.-70. _d 0 ) THEN
             WRITE( msgBuf, '(A,2I4,2I3,I10,F12.3)')
     &        'THSICE_SOLVE4TEMP: Too low tSrf in', i, j, bi, bj,
     &                            myIter, tSrf(i,j)
             CALL PRINT_ERROR( msgBuf , myThid )
             STOP 'ABNORMAL END: S/R THSICE_SOLVE4TEMP'
            ENDIF
           ENDIF
#endif /* ALLOW_DBUG_THSICE */

          ENDIF
         ENDDO
        ENDDO
#ifndef ALLOW_AUTODIFF
C--- end if: IF ( iterate4Tsf ) THEN
       ENDIF
#endif /* ALLOW_AUTODIFF */
C--- end loop DO k = 1,iterMax
      ENDDO
C ------ end iteration ------------
#ifdef ALLOW_AUTODIFF_TAMC_MORE
C     avoid calling thsice_get_exf in ad-code
CADJ STORE tIc1   = comlev1_bibj, key = tkey, kind = isbyte
CADJ STORE dTsrf  = comlev1_bibj, key = tkey, kind = isbyte
CADJ STORE tSrf   = comlev1_bibj, key = tkey, kind = isbyte
CADJ STORE dFlxdT = comlev1_bibj, key = tkey, kind = isbyte
CADJ STORE dEvdT  = comlev1_bibj, key = tkey, kind = isbyte
#endif

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      DO j = jMin, jMax
       DO i = iMin, iMax
C     this intermediate variable avoids a recomputation warning
        tIc2Tmp = tIc2(i,j)
        IF ( icMask(i,j).GT.0. _d 0 ) THEN

C--   Compute new bottom layer temperature.
          k32       = 2. _d 0*kIce  / hIce(i,j)
          tIc2(i,j) = ( 2. _d 0*dt*k32*(tIc1(i,j)+2. _d 0*tFrz(i,j))
     &                 + rhoi*cpIce*hIce(i,j)*tIc2Tmp)
     &               /(6. _d 0*dt*k32 + rhoi*cpIce*hIce(i,j))
#ifdef ALLOW_DBUG_THSICE
          IF ( dBug(i,j,bi,bj) ) WRITE(stdUnit,1010)
     &  'ThSI_SOLVE4T: k, Ts, Tice=',k,tSrf(i,j),tIc1(i,j),tIc2(i,j)
          netSW   = flxAtm(i,j)
#endif

C--   Compute final flux values at surfaces.
          fct    = k12(i,j)*(tSrf(i,j)-tIc1(i,j))
          flxCnB(i,j) = 4. _d 0*kIce *(tIc2(i,j)-tFrz(i,j))/hIce(i,j)
          flxNet = sHeat(i,j) + flxTexSW(i,j)
          flxNet = flxNet + dFlxdT(i,j)*dTsrf(i,j)
#ifndef ALLOW_AUTODIFF
          IF ( useBlkFlx ) THEN
#endif
C--   need to update also Evap (tSrf changes) since Latent heat has
C     been updated
            evpAtm(i,j) = evapT(i,j) + dEvdT(i,j)*dTsrf(i,j)
#ifndef ALLOW_AUTODIFF
          ELSE
C- WARNING: Evap & +Evap*Lfresh are missing ! (but only affects Diagnostics)
            evpAtm(i,j) = 0.
          ENDIF
#endif
C-    Update energy flux to Atmos with other than SW contributions;
C     use latent heat = Lvap (energy=0 for liq. water at 0.oC)
          flxAtm(i,j) = flxAtm(i,j) + flxTexSW(i,j)
     &                + dFlxdT(i,j)*dTsrf(i,j) + evpAtm(i,j)*Lfresh
C-    excess of energy @ surface (used for surface melting):
          sHeat(i,j) = flxNet - fct

#ifdef ALLOW_DBUG_THSICE
          IF ( dBug(i,j,bi,bj) ) WRITE(stdUnit,1020)
     &     'ThSI_SOLVE4T: flxNet,fct,Dif,flxCnB=',
     &                    flxNet,fct,flxNet-fct,flxCnB(i,j)
#endif

C--   Compute new enthalpy for each layer.
          qIc1(i,j) = -cpWater*Tmlt1 + cpIce *(Tmlt1-tIc1(i,j))
     &                + Lfresh*(1. _d 0-Tmlt1/tIc1(i,j))
          qIc2(i,j) = -cpIce *tIc2(i,j) + Lfresh

#ifdef ALLOW_DBUG_THSICE
C--   Make sure internal ice temperatures do not exceed Tmlt.
C     (This should not happen for reasonable values of i0swFrac)
          IF (tIc1(i,j) .GE. Tmlt1) THEN
           WRITE(stdUnit,'(A,2I4,2I3,1P2E14.6)')
     &     ' BBerr - Bug: IceT(1) > Tmlt',i,j,bi,bj,tIc1(i,j),Tmlt1
          ENDIF
          IF (tIc2(i,j) .GE. 0. _d 0) THEN
           WRITE(stdUnit,'(A,2I4,2I3,1P2E14.6)')
     &     ' BBerr - Bug: IceT(2) > 0',i,j,bi,bj,tIc2(i,j)
          ENDIF

          IF ( dBug(i,j,bi,bj) ) THEN
           WRITE(stdUnit,1020) 'ThSI_SOLV_4T: tSrf,Tice(1,2), dTsurf=',
     &           tSrf(i,j), tIc1(i,j), tIc2(i,j), dTsrf(i,j)
           WRITE(stdUnit,1020) 'ThSI_SOLV_4T: sHeat, flxCndBt, Qice =',
     &           sHeat(i,j), flxCnB(i,j), qIc1(i,j), qIc2(i,j)
           WRITE(stdUnit,1020) 'ThSI_SOLV_4T: flxA, evpA, fxSW_bf,af=',
     &           flxAtm(i,j), evpAtm(i,j), netSW, flxSW(i,j)
          ENDIF
#endif

        ELSE
C--     ice-free grid point:
c         tIc1  (i,j) = 0. _d 0
c         tIc2  (i,j) = 0. _d 0
          dTsrf (i,j) = 0. _d 0
c         sHeat (i,j) = 0. _d 0
c         flxCnB(i,j) = 0. _d 0
c         flxAtm(i,j) = 0. _d 0
c         evpAtm(i,j) = 0. _d 0

        ENDIF
       ENDDO
      ENDDO
#endif  /* ALLOW_THSICE */

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      RETURN
      END

#include "OBCS_OPTIONS.h"
#ifdef ALLOW_CTRL
# include "CTRL_OPTIONS.h"
#endif
#ifdef ALLOW_ECCO
# include "ECCO_OPTIONS.h"
#endif

      subroutine obcs_cost_vol(
     I                          startrec, endrec,
     I                          mytime, myiter, mythid )

c     ==================================================================
c     SUBROUTINE obcs_cost_vol
c     ==================================================================
c
c     o cost function contribution obc -- Volume flux imbalance.
c
c     ==================================================================
c     SUBROUTINE obcs_cost_vol
c     ==================================================================

      implicit none

c     == global variables ==

#ifdef OBCS_VOLFLUX_COST_CONTRIBUTION
#include "EEPARAMS.h"
#include "SIZE.h"
#include "PARAMS.h"
#include "GRID.h"
#ifdef ALLOW_OBCS
# include "OBCS_GRID.h"
#endif

#ifdef ALLOW_CAL
# include "cal.h"
#endif
c#ifdef ALLOW_ECCO
c# include "ecco_cost.h"
c#endif
#ifdef ALLOW_CTRL
# include "CTRL_SIZE.h"
# include "CTRL.h"
# include "CTRL_DUMMY.h"
# include "OPTIMCYCLE.h"
#endif
#endif

c     == routine arguments ==
      integer startrec, endrec
      _RL     mytime
      integer myiter
      integer mythid

#if (defined (ALLOW_CTRL) && defined (ALLOW_OBCS))

#ifdef OBCS_VOLFLUX_COST_CONTRIBUTION
#ifdef BAROTROPIC_OBVEL_CONTROL
c     == external functions ==
      integer  ilnblnk
      external ilnblnk

c     == local variables ==
      integer bi,bj
      integer i,j,k
      integer itlo,ithi
      integer jtlo,jthi
      integer jmin,jmax
      integer imin,imax
      integer irec
      integer iobcs
      integer nrec
      integer ilfld
      integer igg
      _RL fctile
      _RL sumvol
      _RL gg
      _RL tmpx
      _RL tmpy
      _RL wobcsvol
      character*(MAX_LEN_FNAM) fnamefldn
      character*(MAX_LEN_FNAM) fnameflds
      character*(MAX_LEN_FNAM) fnamefldw
      character*(MAX_LEN_FNAM) fnameflde
#if (defined ALLOW_OBCSN_CONTROL || defined ALLOW_OBCSS_CONTROL)
      _RL tmpfldxz (1-OLx:sNx+OLx,Nr,nSx,nSy)
#endif
#if (defined ALLOW_OBCSE_CONTROL || defined ALLOW_OBCSW_CONTROL)
      _RL tmpfldyz (1-OLy:sNy+OLy,Nr,nSx,nSy)
#endif
      logical doglobalread
      logical ladinit
#ifdef ECCO_VERBOSE
      character*(MAX_LEN_MBUF) msgbuf
#endif
c     == end of interface ==

      stop 's/r obcs_cost_vol needs to be fixed'

      jtlo = myByLo(mythid)
      jthi = myByHi(mythid)
      itlo = myBxLo(mythid)
      ithi = myBxHi(mythid)
      jmin = 1
      jmax = sNy
      imin = 1
      imax = sNx

c--   Read tiled data.
      doglobalread = .false.
      ladinit      = .false.

cgg   Assume the number of records is the same for
cgg   all boundaries.
c     Number of records to be used.
      nrec = endrec-startrec+1

      sumvol = 0. _d 0
      wobcsvol = .01
cgg   Acceptable volume flux is 10^-3. Corresponds to 5 mm change over a year.
cgg   Added a factor of 1000 because its very important to me.
      wobcsvol = 1./(wobcsvol * wobcsvol)

#ifdef ECCO_VERBOSE
      _BEGIN_MASTER( mythid )
      write(msgbuf,'(a)') ' '
      call print_message( msgbuf, standardmessageunit,
     &                    SQUEEZE_RIGHT , mythid)
      write(msgbuf,'(a)') ' '
      call print_message( msgbuf, standardmessageunit,
     &                    SQUEEZE_RIGHT , mythid)
      write(msgbuf,'(a,i9.8)')
     &  ' obcs_cost_vol: number of records to process: ',nrec
      call print_message( msgbuf, standardmessageunit,
     &                    SQUEEZE_RIGHT , mythid)
      write(msgbuf,'(a)') ' '
      call print_message( msgbuf, standardmessageunit,
     &                    SQUEEZE_RIGHT , mythid)
      _END_MASTER( mythid )
#endif

      if (optimcycle .ge. 0) then
#ifdef ALLOW_OBCSN_CONTROL
        ilfld=ilnblnk( xx_obcsn_file )
        write(fnamefldn,'(2a,i10.10)')
     &        xx_obcsn_file(1:ilfld),'.', optimcycle
#endif
#ifdef ALLOW_OBCSS_CONTROL
        ilfld=ilnblnk( xx_obcss_file )
        write(fnameflds,'(2a,i10.10)')
     &        xx_obcss_file(1:ilfld),'.',optimcycle
#endif
#ifdef ALLOW_OBCSW_CONTROL
        ilfld=ilnblnk( xx_obcsw_file )
        write(fnamefldw,'(2a,i10.10)')
     &        xx_obcsw_file(1:ilfld),'.',optimcycle
#endif
#ifdef ALLOW_OBCSE_CONTROL
        ilfld=ilnblnk( xx_obcse_file )
        write(fnameflde,'(2a,i10.10)')
     &        xx_obcse_file(1:ilfld),'.',optimcycle
#endif
      else
         print*
         print*,' obcs_obcsvol: optimcycle has a wrong value.'
         print*,'                 optimcycle = ',optimcycle
         print*
         stop   '  ... stopped in obcs_obcsvol.'
      endif

      do irec = 1,nrec
c--   Loop over records. For north boundary, we only need V velocity.

cgg    Need to solve for iobcs. Then only keep iobcs=3.or.4.
        gg   = (irec-1)/nobcs
        igg  = int(gg)
        iobcs = irec - igg*nobcs

#ifdef ALLOW_OBCSN_CONTROL
cgg   Assume that nobcs=4, and V velocity is the 4th record. I cannot
cgg   think of a more general way to do this.
        if (iobcs.eq.4) then
#ifdef ALLOW_AUTODIFF
          call active_read_xz( fnamefldn, tmpfldxz, irec, doglobalread,
     &                         ladinit, optimcycle, mythid,
     &                         xx_obcsn_dummy )
#else
          CALL READ_REC_XZ_RL( fnamefldn, ctrlprec, Nr,
     &                         tmpfldxz, irec, 1, mythid )
#endif

cgg  At this point, do not be concerned with the overlap halos.
cgg  From experience, there is no control contribution in the
cgg  velocity points outside the boundaries. This has something
cgg  to do with the computational stencil, and the fact that we
cgg  are diagonally offset. Could check later by employing both
cgg  BALANCE_CONTROL_VOLFLUX and VOLFLUX_COST_CONTRIBUTION.
cgg
cgg  25-jan-03 --- no idea what i was talking about ^^^^
c--     Loop over this thread tiles.
          do bj = jtlo,jthi
            do bi = itlo,ithi

c--         Determine the weights to be used.
              fctile = 0. _d 0

              do k = 1, Nr
                do i = imin,imax
                  j = OB_Jn(I,bi,bj)
                  IF ( j.EQ.OB_indexNone ) j = 1
cgg    Barotropic velocity is stored in level 1.
                  tmpx = tmpfldxz(i,1,bi,bj)
                  if (maskS(i,j,k,bi,bj) .ne. 0.) then
cgg -- Positive is flux in.
                    fctile = fctile - tmpx* drF(k) *dxg(i,j,bi,bj)
     &                  * _hFacS(i,j,k,bi,bj)
                  endif
                enddo
              enddo

              sumvol         = sumvol + fctile
            enddo
          enddo
        endif
#endif

#ifdef ALLOW_OBCSS_CONTROL
cgg   Assume that nobcs=4, and V velocity is the 4th record. I cannot
cgg   think of a more general way to do this.
        if (iobcs.eq.4) then
#ifdef ALLOW_AUTODIFF
          call active_read_xz( fnameflds, tmpfldxz, irec, doglobalread,
     &                         ladinit, optimcycle, mythid,
     &                         xx_obcss_dummy )
#else
          CALL READ_REC_XZ_RL( fnameflds, ctrlprec, Nr,
     &                         tmpfldxz, irec, 1, mythid )
#endif

cgg  At this point, do not be concerned with the overlap halos.
cgg  From experience, there is no control contribution in the
cgg  velocity points outside the boundaries. This has something
cgg  to do with the computational stencil, and the fact that we
cgg  are diagonally offset. Could check later by employing both
cgg  BALANCE_CONTROL_VOLFLUX and VOLFLUX_COST_CONTRIBUTION.

c--     Loop over this thread tiles.
          do bj = jtlo,jthi
            do bi = itlo,ithi

c--         Determine the weights to be used.
              fctile = 0. _d 0

              do k = 1, Nr
                do i = imin,imax
                  j = OB_Js(I,bi,bj)
                  IF ( j.EQ.OB_indexNone ) j = 1
cgg    Barotropic velocity is stored in level 1.
                  tmpx = tmpfldxz(i,1,bi,bj)
                  if (maskS(i,j+1,k,bi,bj) .ne. 0.) then
cgg -- Positive is flux in.
                    fctile = fctile + tmpx* drF(k) *dxg(i,j+1,bi,bj)
     &                  * _hFacS(i,j+1,k,bi,bj)
                  endif
                enddo
              enddo

              sumvol         = sumvol + fctile
            enddo
          enddo
        endif

#endif

#ifdef ALLOW_OBCSW_CONTROL
cgg   Assume that nobcs=4, and V velocity is the 4th record. I cannot
cgg   think of a more general way to do this.
        if (iobcs.eq.3) then
#ifdef ALLOW_AUTODIFF
          call active_read_yz( fnamefldw, tmpfldyz, irec, doglobalread,
     &                         ladinit, optimcycle, mythid,
     &                         xx_obcsw_dummy )
#else
          CALL READ_REC_YZ_RL( fnamefldw, ctrlprec, Nr,
     &                         tmpfldyz, irec, 1, mythid )
#endif

cgg  At this point, do not be concerned with the overlap halos.
cgg  From experience, there is no control contribution in the
cgg  velocity points outside the boundaries. This has something
cgg  to do with the computational stencil, and the fact that we
cgg  are diagonally offset. Could check later by employing both
cgg  BALANCE_CONTROL_VOLFLUX and VOLFLUX_COST_CONTRIBUTION.

c--     Loop over this thread tiles.
          do bj = jtlo,jthi
            do bi = itlo,ithi

c--         Determine the weights to be used.
              fctile = 0. _d 0

              do k = 1, Nr
                do j = jmin,jmax
                  i = OB_Iw(j,bi,bj)
                  IF ( i.EQ.OB_indexNone ) i = 1
cgg    Barotropic velocity is stored in the level 1.
                  tmpy = tmpfldyz(j,1,bi,bj)
                  if (maskW(i+1,j,k,bi,bj) .ne. 0.) then
cgg -- Positive is flux in.
                    fctile = fctile + tmpy* drF(k) *dyg(i+1,j,bi,bj)
     &                  * _hFacW(i+1,j,k,bi,bj)
                  endif
                enddo
              enddo

              sumvol         = sumvol + fctile
            enddo
          enddo
        endif

#endif

#ifdef ALLOW_OBCSE_CONTROL
cgg   Assume that nobcs=4, and V velocity is the 4th record. I cannot
cgg   think of a more general way to do this.
        if (iobcs.eq.3) then
#ifdef ALLOW_AUTODIFF
          call active_read_yz( fnameflde, tmpfldyz, irec, doglobalread,
     &                         ladinit, optimcycle, mythid,
     &                         xx_obcse_dummy )
#else
          CALL READ_REC_YZ_RL( fnameflde, ctrlprec, Nr,
     &                         tmpfldyz, irec, 1, mythid )
#endif

cgg  At this point, do not be concerned with the overlap halos.
cgg  From experience, there is no control contribution in the
cgg  velocity points outside the boundaries. This has something
cgg  to do with the computational stencil, and the fact that we
cgg  are diagonally offset. Could check later by employing both
cgg  BALANCE_CONTROL_VOLFLUX and VOLFLUX_COST_CONTRIBUTION.

c--     Loop over this thread tiles.
          do bj = jtlo,jthi
            do bi = itlo,ithi

c--         Determine the weights to be used.
              fctile = 0. _d 0

              do k = 1, Nr
                do j = jmin,jmax
                  i = OB_Ie(j,bi,bj)
                  IF ( i.EQ.OB_indexNone ) i = 1
cgg    Barotropic velocity stored in level 1.
                  tmpy = tmpfldyz(j,1,bi,bj)
                  if (maskW(i,j,k,bi,bj) .ne. 0.) then
cgg -- Positive is flux in.
                    fctile = fctile - tmpy* drF(k) *dyg(i,j,bi,bj)
     &                  * _hFacW(i,j,k,bi,bj)
                  endif
                enddo
              enddo

              sumvol         = sumvol + fctile
            enddo
          enddo
        endif

#endif

      enddo
c--   End of loop over records.

c--   Do the global summation.
      _GLOBAL_SUM_RL( sumvol, mythid )
      objf_obcsvol =  wobcsvol * sumvol* sumvol

#endif /* BAROTROPIC_OBVEL_CONTROL */
#endif /* OBCS_VOLFLUX_COST_CONTRIBUTION */

#endif /* ALLOW_CTRL and ALLOW_OBCS */

      return
      end

#include "CPP_OPTIONS.h"

      _RL FUNCTION ETA_GL_STREAMICE (X, M1, M2, Y0, W)

!      This function smooths out slope discontinuities in a 1D function
!      y(x) is assumed piecewise linear with a slope discontinuity at 0
!      the results is smoothed only on -w/2 < x < w/2

!     X: input variable
!     M1: slope of y where x<0
!     M2: slope of y where x>0
!     Y0: value of y at 0
!     W: width of smoothing

       _RL X, M1, M2, Y0, W
       _RL TMP1, PI

       IF (X.le.-0.5*W) THEN
         ETA_GL_STREAMICE = Y0 + M1 * X
       ELSEIF(X.gt.0.5*W) THEN
         ETA_GL_STREAMICE = Y0 + M2 * X
       ELSE
         PI = 3.14159265358979323844D0
         TMP1 = W/PI * COS(PI*X/W)
         ETA_GL_STREAMICE = Y0 + 
     &     M1/2 * (X-0.5*W+TMP1) + 
     &     M2/2 * (X+0.5*W-TMP1)
       ENDIF

       RETURN
       END 

#include "CPP_OPTIONS.h"
#ifdef TARGET_NEC_SX
C     set a sensible default for the outer loop unrolling parameter that can
C     be overriden in the Makefile with the DEFINES macro or in CPP_OPTIONS.h
#ifndef CG2D_OUTERLOOPITERS
# define CG2D_OUTERLOOPITERS 10
#endif
#endif /* TARGET_NEC_SX */

CBOP
C     !ROUTINE: CG2D_EX0
C     !INTERFACE:
      SUBROUTINE CG2D_EX0(
     U                cg2d_b, cg2d_x,
     O                firstResidual, minResidualSq, lastResidual,
     U                numIters, nIterMin,
     I                myThid )
C     !DESCRIPTION: \bv
C     *================================================================*
C     | SUBROUTINE CG2D_EX0
C     | o Two-dimensional grid problem conjugate-gradient inverter
C     |   (with preconditioner).
C     | This is the disconnected-tile version (each tile treated
C     |   independently as a small domain, with locally periodic
C     |   BC at the edges.
C     *================================================================*
C     | Con. grad is an iterative procedure for solving Ax = b.
C     | It requires the A be symmetric.
C     | This implementation assumes A is a five-diagonal matrix
C     | of the form that arises in the discrete representation of
C     | the del^2 operator in a two-dimensional space.
C     *================================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     === Global data ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "CG2D.h"

C     !INPUT/OUTPUT PARAMETERS:
C     cg2d_b    :: The source term or "right hand side" (output: normalised RHS)
C     cg2d_x    :: The solution (input: first guess)
C     firstResidual :: the initial residual before any iterations
C     minResidualSq :: the lowest residual reached (squared)
C     lastResidual  :: the actual residual reached
C     numIters  :: Inp: the maximum number of iterations allowed
C                  Out: the actual number of iterations used
C     nIterMin  :: Inp: decide to store (if >=0) or not (if <0) lowest res. sol.
C                  Out: iteration number corresponding to lowest residual
C     myThid    :: Thread on which I am working.
      _RL  cg2d_b(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL  cg2d_x(1-OLx:sNx+OLx,1-OLy:sNy+OLy,nSx,nSy)
      _RL  firstResidual
      _RL  minResidualSq
      _RL  lastResidual
      INTEGER numIters
      INTEGER nIterMin
      INTEGER myThid

C     !LOCAL VARIABLES:
C     bi, bj     :: tile index in X and Y.
C     i, j, it2d :: Loop counters ( it2d counts CG iterations )
C     actualIts  :: actual CG iteration number
C     err_sq     :: Measure of the square of the residual of Ax - b.
C     eta_qrN    :: Used in computing search directions; suffix N and NM1
C     eta_qrNM1     denote current and previous iterations respectively.
C     cgBeta     :: coeff used to update conjugate direction vector "s".
C     alpha      :: coeff used to update solution & residual
C     sumRHS     :: Sum of right-hand-side. Sometimes this is a useful
C                   debugging/trouble shooting diagnostic. For neumann problems
C                   sumRHS needs to be ~0 or it converge at a non-zero residual.
C     cg2d_min   :: used to store solution corresponding to lowest residual.
C     msgBuf     :: Informational/error message buffer
C--   local working array (used to be in CG2D.h common block:
C     cg2d_q     :: Intermediate matrix-vector product term
C     cg2d_r     ::   *same*
C     cg2d_s     ::   *same*
      INTEGER bi, bj
      INTEGER i, j, it2d
      INTEGER actualIts(nSx,nSy)
      INTEGER minResIter(nSx,nSy)
      _RL    err_sq,  errTile(nSx,nSy)
      _RL    eta_qrNtile(nSx,nSy)
      _RL    eta_qrNM1(nSx,nSy)
      _RL    cgBeta
      _RL    alpha,   alphaTile(nSx,nSy)
      _RL    sumRHS,  sumRHStile(nSx,nSy)
      _RL    rhsMax, rhsMaxLoc
      _RL    rhsNorm(nSx,nSy)
      _RL    minResTile(nSx,nSy)
      _RL    cg2d_min(1:sNx,1:sNy,nSx,nSy)
      _RL    cg2d_q  (1:sNx,1:sNy,nSx,nSy)
      _RL    cg2d_r(1-1:sNx+1,1-1:sNy+1,nSx,nSy)
      _RL    cg2d_s(1-1:sNx+1,1-1:sNy+1,nSx,nSy)
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      LOGICAL printResidual
CEOP

C--   Initialise auxiliary constant, some output variable

C--   Initialise inverter and Normalise RHS
      rhsMax = 0. _d 0
      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)

        actualIts(bi,bj)  = 0
        minResIter(bi,bj) = 0
        minResTile(bi,bj) = -1. _d 0
        eta_qrNM1(bi,bj) =  1. _d 0
        rhsMaxLoc = 0. _d 0
        DO j=1,sNy
         DO i=1,sNx
          cg2d_b(i,j,bi,bj) = cg2d_b(i,j,bi,bj)*cg2dNorm
          rhsMaxLoc = MAX(ABS(cg2d_b(i,j,bi,bj)),rhsMaxLoc)
         ENDDO
        ENDDO
        rhsNorm(bi,bj) = 1. _d 0
        IF ( rhsMaxLoc .NE. 0. ) rhsNorm(bi,bj) = 1. _d 0 / rhsMaxLoc
        IF (cg2dNormaliseRHS) THEN
         DO j=1,sNy
          DO i=1,sNx
           cg2d_b(i,j,bi,bj) = cg2d_b(i,j,bi,bj)*rhsNorm(bi,bj)
           cg2d_x(i,j,bi,bj) = cg2d_x(i,j,bi,bj)*rhsNorm(bi,bj)
          ENDDO
         ENDDO
        ENDIF
        rhsMax = MAX( rhsMaxLoc, rhsMax )

       ENDDO
      ENDDO
      _GLOBAL_MAX_RL( rhsMax, myThid )

C--   Update overlaps
      CALL EXCH_XY_RL( cg2d_x, myThid )

C--   Initial residual calculation
      err_sq = 0.
      sumRHS = 0.
      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
C-    Initialise local working arrays:
        DO j=0,sNy+1
         DO i=0,sNx+1
          cg2d_r(i,j,bi,bj) = 0. _d 0
          cg2d_s(i,j,bi,bj) = 0. _d 0
         ENDDO
        ENDDO
        IF ( nIterMin.GE.0 ) THEN
C-    Initialise saved solution
         DO j=1,sNy
          DO i=1,sNx
           cg2d_min(i,j,bi,bj) = cg2d_x(i,j,bi,bj)
          ENDDO
         ENDDO
        ENDIF
        sumRHStile(bi,bj) = 0. _d 0
        errTile(bi,bj)    = 0. _d 0
#ifdef TARGET_NEC_SX
!CDIR OUTERUNROLL=CG2D_OUTERLOOPITERS
#endif /* TARGET_NEC_SX */
        DO j=1,sNy
         DO i=1,sNx
          cg2d_r(i,j,bi,bj) = cg2d_b(i,j,bi,bj) -
     &    (aW2d(i  ,j  ,bi,bj)*cg2d_x(i-1,j  ,bi,bj)
     &    +aW2d(i+1,j  ,bi,bj)*cg2d_x(i+1,j  ,bi,bj)
     &    +aS2d(i  ,j  ,bi,bj)*cg2d_x(i  ,j-1,bi,bj)
     &    +aS2d(i  ,j+1,bi,bj)*cg2d_x(i  ,j+1,bi,bj)
     &    +aC2d(i  ,j  ,bi,bj)*cg2d_x(i  ,j  ,bi,bj)
     &    )
          errTile(bi,bj)    = errTile(bi,bj)
     &                      + cg2d_r(i,j,bi,bj)*cg2d_r(i,j,bi,bj)
          sumRHStile(bi,bj) = sumRHStile(bi,bj) + cg2d_b(i,j,bi,bj)
         ENDDO
        ENDDO
        IF ( nIterMin.GE.0 ) THEN
          minResTile(bi,bj) = errTile(bi,bj)
        ENDIF
        err_sq = MAX( errTile(bi,bj), err_sq )
        sumRHS = MAX( ABS(sumRHStile(bi,bj)), sumRHS )

       ENDDO
      ENDDO
      CALL EXCH_S3D_RL( cg2d_r, 1, myThid )
      _GLOBAL_MAX_RL( err_sq, myThid )
      _GLOBAL_MAX_RL( sumRHS, myThid )
      firstResidual = SQRT(err_sq)

      printResidual = .FALSE.
      IF ( debugLevel .GE. debLevZero ) THEN
        _BEGIN_MASTER( myThid )
        printResidual = printResidualFreq.GE.1
        WRITE(standardMessageUnit,'(A,1P2E22.14)')
     &  ' cg2d: Sum(rhs),rhsMax = ', sumRHS,rhsMax
        _END_MASTER( myThid )
      ENDIF

c     IF ( err_sq .LT. cg2dTolerance_sq ) GOTO 11

C     >>>>>>>>>>>>>>> BEGIN SOLVER <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
      DO it2d=1, numIters
      IF ( err_sq.GE.cg2dTolerance_sq ) THEN
       err_sq = 0. _d 0

       DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
        IF ( errTile(bi,bj).GE.cg2dTolerance_sq ) THEN

C--    Solve preconditioning equation and update
C--    conjugate direction vector "s".
         eta_qrNtile(bi,bj) = 0. _d 0
#ifdef TARGET_NEC_SX
!CDIR OUTERUNROLL=CG2D_OUTERLOOPITERS
#endif /* TARGET_NEC_SX */
         DO j=1,sNy
          DO i=1,sNx
           cg2d_q(i,j,bi,bj) =
     &      pC(i  ,j  ,bi,bj)*cg2d_r(i  ,j  ,bi,bj)
     &     +pW(i  ,j  ,bi,bj)*cg2d_r(i-1,j  ,bi,bj)
     &     +pW(i+1,j  ,bi,bj)*cg2d_r(i+1,j  ,bi,bj)
     &     +pS(i  ,j  ,bi,bj)*cg2d_r(i  ,j-1,bi,bj)
     &     +pS(i  ,j+1,bi,bj)*cg2d_r(i  ,j+1,bi,bj)
           eta_qrNtile(bi,bj) = eta_qrNtile(bi,bj)
     &     +cg2d_q(i,j,bi,bj)*cg2d_r(i,j,bi,bj)
          ENDDO
         ENDDO

         cgBeta   = eta_qrNtile(bi,bj)/eta_qrNM1(bi,bj)
         eta_qrNM1(bi,bj) = eta_qrNtile(bi,bj)

         DO j=1,sNy
          DO i=1,sNx
           cg2d_s(i,j,bi,bj) = cg2d_q(i,j,bi,bj)
     &                       + cgBeta*cg2d_s(i,j,bi,bj)
          ENDDO
         ENDDO

C--    Do exchanges that require messages i.e. between processes.
         CALL FILL_HALO_LOCAL_RL(
     U                  cg2d_s(0,0,bi,bj),
     I                  1, 1, 1, 1, 1,
     I                  EXCH_IGNORE_CORNERS, bi, bj, myThid )

C==    Evaluate laplace operator on conjugate gradient vector
C==    q = A.s
         alphaTile(bi,bj) = 0. _d 0
#ifdef TARGET_NEC_SX
!CDIR OUTERUNROLL=CG2D_OUTERLOOPITERS
#endif /* TARGET_NEC_SX */
         DO j=1,sNy
          DO i=1,sNx
           cg2d_q(i,j,bi,bj) =
     &     aW2d(i  ,j  ,bi,bj)*cg2d_s(i-1,j  ,bi,bj)
     &    +aW2d(i+1,j  ,bi,bj)*cg2d_s(i+1,j  ,bi,bj)
     &    +aS2d(i  ,j  ,bi,bj)*cg2d_s(i  ,j-1,bi,bj)
     &    +aS2d(i  ,j+1,bi,bj)*cg2d_s(i  ,j+1,bi,bj)
     &    +aC2d(i  ,j  ,bi,bj)*cg2d_s(i  ,j  ,bi,bj)
          alphaTile(bi,bj) = alphaTile(bi,bj)
     &                     + cg2d_s(i,j,bi,bj)*cg2d_q(i,j,bi,bj)
          ENDDO
         ENDDO
         alpha = eta_qrNtile(bi,bj)/alphaTile(bi,bj)

C==    Update simultaneously solution and residual vectors (and Iter number)
C      Now compute "interior" points.
         errTile(bi,bj) = 0. _d 0
         DO j=1,sNy
          DO i=1,sNx
           cg2d_x(i,j,bi,bj)=cg2d_x(i,j,bi,bj)+alpha*cg2d_s(i,j,bi,bj)
           cg2d_r(i,j,bi,bj)=cg2d_r(i,j,bi,bj)-alpha*cg2d_q(i,j,bi,bj)
           errTile(bi,bj) = errTile(bi,bj)
     &                    + cg2d_r(i,j,bi,bj)*cg2d_r(i,j,bi,bj)
          ENDDO
         ENDDO
         actualIts(bi,bj) = it2d

         IF ( printResidual ) THEN
          IF ( MOD( it2d-1, printResidualFreq ).EQ.0 ) THEN
           WRITE(msgBuf,'(A,2I4,A,I6,A,1PE21.14)') ' cg2d(bi,bj=', bi,
     &      bj, '): iter=', it2d, ' ; resid.= ', SQRT(errTile(bi,bj))
           CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                         SQUEEZE_RIGHT, myThid )
          ENDIF
         ENDIF
         IF ( errTile(bi,bj) .GE. cg2dTolerance_sq .AND.
     &        errTile(bi,bj) .LT. minResTile(bi,bj) ) THEN
C-     Store lowest residual solution
           minResTile(bi,bj) = errTile(bi,bj)
           minResIter(bi,bj) = it2d
           DO j=1,sNy
            DO i=1,sNx
             cg2d_min(i,j,bi,bj) = cg2d_x(i,j,bi,bj)
            ENDDO
           ENDDO
         ENDIF

         CALL FILL_HALO_LOCAL_RL(
     U                  cg2d_r(0,0,bi,bj),
     I                  1, 1, 1, 1, 1,
     I                  EXCH_IGNORE_CORNERS, bi, bj, myThid )

        ENDIF
        err_sq = MAX( errTile(bi,bj), err_sq )
C-    end bi,bj loops
       ENDDO
       ENDDO
C-    end cg-2d iteration loop
      ENDIF
      ENDDO

c  11 CONTINUE

      IF ( nIterMin.GE.0 ) THEN
C-    use the lowest residual solution (instead of current one = last residual)
       DO bj=myByLo(myThid),myByHi(myThid)
        DO bi=myBxLo(myThid),myBxHi(myThid)
c         minResidualSq = MAX( minResTile(bi,bj), minResidualSq )
c         nIterMin = MAX( minResIter(bi,bj), nIterMin )
         IF ( errTile(bi,bj) .GT. minResTile(bi,bj) ) THEN
          DO j=1,sNy
           DO i=1,sNx
             cg2d_x(i,j,bi,bj) = cg2d_min(i,j,bi,bj)
           ENDDO
          ENDDO
         ENDIF
        ENDDO
       ENDDO
      ENDIF

      IF (cg2dNormaliseRHS) THEN
C--   Un-normalise the answer
        DO bj=myByLo(myThid),myByHi(myThid)
         DO bi=myBxLo(myThid),myBxHi(myThid)
          DO j=1,sNy
           DO i=1,sNx
            cg2d_x(i,j,bi,bj) = cg2d_x(i,j,bi,bj)/rhsNorm(bi,bj)
           ENDDO
          ENDDO
         ENDDO
        ENDDO
      ENDIF

C--   Return parameters to caller
C     return largest Iter # and Max residual     in numIters and lastResidual
C     return lowest  Iter # and Min residual(^2) in nIterMin and minResidualSq
      _GLOBAL_MAX_RL( err_sq, myThid )
      nIterMin = numIters
      numIters = 0
      minResidualSq = err_sq
      DO bj=myByLo(myThid),myByHi(myThid)
       DO bi=myBxLo(myThid),myBxHi(myThid)
         nIterMin = MIN( actualIts(bi,bj), nIterMin )
         numIters = MAX( actualIts(bi,bj), numIters )
         minResidualSq = MIN( errTile(bi,bj), minResidualSq )
       ENDDO
      ENDDO
      lastResidual = SQRT(err_sq)
      alpha = -nIterMin
      _GLOBAL_MAX_RL( alpha, myThid )
      nIterMin = NINT( -alpha )
      alpha = numIters
      _GLOBAL_MAX_RL( alpha, myThid )
      numIters = NINT( alpha )
      alpha = -minResidualSq
      _GLOBAL_MAX_RL( alpha, myThid )
      minResidualSq = -alpha

      RETURN
      END

#include "EXF_OPTIONS.h"

CBOP
C     !ROUTINE: EXF_ZENITHANGLE
C     !INTERFACE:
      SUBROUTINE EXF_ZENITHANGLE(
     I               myTime, myIter, myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE EXF_ZENITHANGLE
C     | o compute zenith angle, derive albedo and
C     |   the incoming flux at the top of the atm.
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     == global variables ==
#include "EEPARAMS.h"
#include "SIZE.h"
#include "PARAMS.h"
#include "GRID.h"
#include "EXF_PARAM.h"
#include "EXF_FIELDS.h"
#include "EXF_CONSTANTS.h"
#ifdef ALLOW_CAL
# include "cal.h"
#endif

C     !INPUT/OUTPUT PARAMETERS:
      _RL     myTime
      INTEGER myIter
      INTEGER myThid

#ifdef ALLOW_DOWNWARD_RADIATION
#ifdef ALLOW_ZENITHANGLE
C     !FUNCTIONS:
#ifdef ALLOW_CAL
      INTEGER  cal_IsLeap
      EXTERNAL cal_IsLeap
#endif

C     !LOCAL VARIABLES:
      INTEGER i, j, bi, bj
      INTEGER iLat1,iLat2,iTyear1,iTyear2
      _RL     wLat1,wLat2,wTyear1,wTyear2
      _RL H0, dD0dDsq, CZENdaily, CZENdiurnal
      _RL TDAY, TYEAR, ALBSEA1, ALPHA, CZEN, CZEN2
      _RL DECLI, ZS, ZC, SJ, CJ, TMPA, TMPB, TMPL, hlim
      _RL SOLC, FSOL
c     _RL CSR1, CSR2, FLAT2
      _RL secondsInYear
#ifdef ALLOW_CAL
      _RL myDateSeconds
      INTEGER year0,mydate(4),difftime(4)
      INTEGER dayStartDate(4),yearStartDate(4)
#endif
CEOP

C solar constant
C --------------
      SOLC   = 1368. _d 0
C note: it is fourth (342. _d 0) is called SOLC in pkg/aim_v23

C determine time of year/day
C --------------------------

#ifdef ALLOW_CAL
      IF ( useCAL ) THEN
       CALL cal_GetDate( myIter, myTime, mydate, myThid )
       year0         = INT(mydate(1)/10000.)
       secondsInYear = ndaysnoleap * secondsperday
       IF ( cal_IsLeap(year0,myThid) .EQ. 2)
     &       secondsInYear = ndaysleap * secondsperday

       yearStartDate(1) = year0 * 10000 + 101
       yearStartDate(2) = 0
       yearStartDate(3) = mydate(3)
       yearStartDate(4) = mydate(4)
       CALL cal_TimePassed(yearStartDate,mydate,difftime,myThid)
       CALL cal_ToSeconds (difftime,myDateSeconds,myThid)

       TYEAR=myDateSeconds/secondsInYear

       dayStartDate(1) = mydate(1)
       dayStartDate(2) = 0
       dayStartDate(3) = mydate(3)
       dayStartDate(4) = mydate(4)
       CALL cal_TimePassed(dayStartDate,mydate,difftime,myThid)
       CALL cal_ToSeconds (difftime,myDateSeconds,myThid)

       TDAY= myDateSeconds / ( 86400 . _d 0 )

      ELSE
#else /* ALLOW_CAL */
      IF ( .TRUE. ) THEN
#endif /* ALLOW_CAL */

       secondsInYear = 86400. _d 0 * 365.25 _d 0
       TYEAR = myTime / secondsInYear
       TDAY  = myTime / 86400 . _d 0
       TYEAR = MOD( TYEAR, oneRL )
       TDAY  = MOD( TDAY , oneRL )

      ENDIF

      IF ( useExfZenAlbedo ) THEN

       DO bj = myByLo(myThid),myByHi(myThid)
        DO bi = myBxLo(myThid),myBxHi(myThid)

         IF ( select_ZenAlbedo.EQ.0 ) THEN

          DO j = 1,sNy
           DO i = 1,sNx
            zen_albedo (i,j,bi,bj) = exf_albedo
           ENDDO
          ENDDO

         ELSEIF ( select_ZenAlbedo.EQ.1 ) then

C     This is the default option: daily mean albedo (i.e. without diurnal
C     cycle) obtained from the reference table that was computed in
C     exf_zenithangle_table.F. Using either daily or 6 hourly fields, this
C     option yields correct values of daily upward sw flux.
C     This is not the case for select_ZenAlbedo.GT.1 (see comments below).

          iTyear1= 1 + 365.*TYEAR
          wTyear1= iTyear1 - 365.*TYEAR
          iTyear2= iTyear1 + 1
          wTyear2= 1.0 _d 0 - wTyear1

          DO j = 1,sNy
           DO i = 1,sNx
            IF ( zen_albedo_pointer(i,j,bi,bj).EQ. 181. _d 0 ) THEN
              iLat1=181
              wLat1=0.5  _d 0
              iLat2=181
              wLat2=0.5  _d 0
            ELSE
              iLat1= INT(zen_albedo_pointer(i,j,bi,bj))
              wLat1= 1. _d 0 + iLat1 - zen_albedo_pointer(i,j,bi,bj)
              iLat2= iLat1 + 1
              wLat2= 1. _d 0 - wLat1
            ENDIF
            ALBSEA1 =
     &         wTyear1*wLat1*zen_albedo_table(iTyear1,iLat1)
     &       + wTyear1*wLat2*zen_albedo_table(iTyear1,iLat2)
     &       + wTyear2*wLat1*zen_albedo_table(iTyear2,iLat1)
     &       + wTyear2*wLat2*zen_albedo_table(iTyear2,iLat2)

C determine overall albedo: approximation: half direct and half diffus
            zen_albedo (i,j,bi,bj) =
     &          0.5 _d 0 * exf_albedo + 0.5 _d 0 * ALBSEA1
           ENDDO
          ENDDO

C        if select_ZenAlbedo = 0, = 1, else
         ELSE

C determine solar declination
C ---------------------------
C       (formula from Hartmann textbook, after Spencer 1971)
          ALPHA= 2. _d 0*PI*TYEAR
          DECLI = 0.006918 _d 0
     &       - 0.399912 _d 0 * COS ( 1. _d 0 * ALPHA )
     &       + 0.070257 _d 0 * SIN ( 1. _d 0 * ALPHA )
     &       - 0.006758 _d 0 * COS ( 2. _d 0 * ALPHA )
     &       + 0.000907 _d 0 * SIN ( 2. _d 0 * ALPHA )
     &       - 0.002697 _d 0 * COS ( 3. _d 0 * ALPHA )
     &       + 0.001480 _d 0 * SIN ( 3. _d 0 * ALPHA )

C note: alternative formulas include
C   1) formula from aim_surf_bc.F, neglecting eccentricity:
C         ALPHA= 2. _d 0*PI*(TYEAR+10. _d 0/365. _d 0)
C         DECLI = COS(ALPHA) * ( -23.45 _d 0 * deg2rad)
C   2) formulas that accounts for minor astronomic effects, e.g.
C    Yallop, B. D., Position of the sun to 1 minute of arc precision,
C     H. M. Nautical Almanac Office, Royal Greenwich Observatory,
C     Herstmonceux Castle, Hailsham, Sussex BN27 1RP, 1977.

          ZC = COS(DECLI)
          ZS = SIN(DECLI)
          DO j = 1,sNy
           DO i = 1,sNx

            SJ = SIN(yC(i,j,bi,bj) * deg2rad)
            CJ = COS(yC(i,j,bi,bj) * deg2rad)
            TMPA = SJ*ZS
            TMPB = CJ*ZC

            IF ( select_ZenAlbedo.EQ.3 ) THEN
C determine DAILY VARYING cos of solar zenith angle CZEN
C ------------------------------------------------------
C       (formula from Hartmann textbook, classic trigo)
             CZENdiurnal = TMPA + TMPB *
     &         COS( 2. _d 0 *PI* TDAY + xC(i,j,bi,bj) * deg2rad )
C note: a more complicated hour angle formula is given by Yallop 1977
             IF ( CZENdiurnal .LE.0 ) CZENdiurnal = 0. _d 0
             CZEN = CZENdiurnal

            ELSEIF ( select_ZenAlbedo.EQ.2 ) THEN
C determine DAILY MEAN cos of solar zenith angle CZEN
C ---------------------------------------------------
C       ( formula from aim_surf_bc.F <--> mean(CZEN*CZEN)/mean(CZEN) )
             TMPL = -TMPA/TMPB
             IF (TMPL .GE. 1.0 _d 0) THEN
              CZEN = 0.0 _d 0
             ELSEIF (TMPL .LE. -1.0 _d 0) THEN
              CZEN = (2.0 _d 0)*TMPA*PI
              CZEN2= PI*((2.0 _d 0)*TMPA*TMPA + TMPB*TMPB)
              CZEN = CZEN2/CZEN
             ELSE
              hlim = ACOS(TMPL)
              CZEN = 2.0 _d 0*(TMPA*hlim + TMPB*SIN(hlim))
              CZEN2= 2.0 _d 0*TMPA*TMPA*hlim
     &          + 4.0 _d 0*TMPA*TMPB*SIN(hlim)
     &          + TMPB*TMPB*( hlim + 0.5 _d 0*SIN(2.0 _d 0*hlim) )
              CZEN = CZEN2/CZEN
             ENDIF
             CZENdaily = CZEN
c            CZEN = CZENdaily

            ELSE
              print *, 'select_ZenAlbedo is out of range'
              STOP 'ABNORMAL END: S/R EXF_ZENITHANGLE'
            ENDIF

C determine direct ocean albedo
C -----------------------------
C     (formula from Briegleb, Minnis, et al 1986)
C     comments on select_ZenAlbedo.GT.1 methods:
C     - CZENdaily as computed in aim was found to imply sizable biases in
C       daily upward sw fluxes.  It is not advised to use it, but it is kept
C       in connection to pkg/aim_v23.
C     - CZENdiurnal should never be used with daily mean input fields.
C       Furthermore, at this point, it is not advised to use it even with 6
C       hourly swdown input fields. This is because we simply time interpolate
C       between 6 hourly swdown fields, so each day there will be times when
C       CZENdiurnal correctly reflects that it is night time, but swdown.NE.0.
C       does not. CZENdiurnal may actually be rather harmful in this context,
C       since an inconsistency of phase between CZENdiurnal and swdown will
C       yield biases in daily mean upward sw fluxes. So ...

            ALBSEA1 =
     &            ( ( 2.6 _d 0 / (CZEN**(1.7 _d 0) + 0.065 _d 0) )
     &          + ( 15. _d 0 * (CZEN-0.1 _d 0) * (CZEN-0.5 _d 0)
     &          * (CZEN-1.0 _d 0) ) ) / 100.0 _d 0

C determine overall albedo
C ------------------------
C       (approximation: half direct and half diffu.)
            zen_albedo (i,j,bi,bj) =
     &          0.5 _d 0 * exf_albedo + 0.5 _d 0 * ALBSEA1
           ENDDO
          ENDDO

C        end if select_ZenAlbedo = 0, = 1, else
         ENDIF

C       end bi,bj loops
        ENDDO
       ENDDO

C      end if ( useExfZenAlbedo )
      ENDIF

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      IF ( useExfZenIncoming ) THEN

       DO bj = myByLo(myThid),myByHi(myThid)
        DO bi = myBxLo(myThid),myBxHi(myThid)

C compute incoming flux at the top of the atm.:
C ---------------------------------------------
C       (formula from Hartmann textbook, after Spencer 1971)
         ALPHA= 2. _d 0*PI*TYEAR
         DECLI = 0.006918 _d 0
     &         - 0.399912 _d 0 * COS ( 1. _d 0 * ALPHA )
     &         + 0.070257 _d 0 * SIN ( 1. _d 0 * ALPHA )
     &         - 0.006758 _d 0 * COS ( 2. _d 0 * ALPHA )
     &         + 0.000907 _d 0 * SIN ( 2. _d 0 * ALPHA )
     &         - 0.002697 _d 0 * COS ( 3. _d 0 * ALPHA )
     &         + 0.001480 _d 0 * SIN ( 3. _d 0 * ALPHA )
         dD0dDsq = 1.000110 _d 0
     &         + 0.034221 _d 0 * COS ( 1. _d 0 * ALPHA )
     &         + 0.001280 _d 0 * SIN ( 1. _d 0 * ALPHA )
     &         + 0.000719 _d 0 * COS ( 2. _d 0 * ALPHA )
     &         + 0.000077 _d 0 * SIN ( 2. _d 0 * ALPHA )
         ZC = COS(DECLI)
         ZS = SIN(DECLI)

         DO j = 1,sNy
          DO i = 1,sNx
           SJ = SIN(yC(i,j,bi,bj) * deg2rad)
           CJ = COS(yC(i,j,bi,bj) * deg2rad)
           TMPA = SJ*ZS
           TMPB = CJ*ZC
C DAILY VARYING value:
           CZEN = TMPA + TMPB *
     &         COS( 2. _d 0 *PI*TDAY + xC(i,j,bi,bj)*deg2rad )
           IF ( CZEN .LE.0 ) CZEN = 0. _d 0
           FSOL = SOLC * dD0dDsq * MAX( 0. _d 0, CZEN )
           zen_fsol_diurnal(i,j,bi,bj) = FSOL

C DAILY MEAN value:
           H0 = -TAN( yC(i,j,bi,bj) *deg2rad ) * TAN( DECLI )
           IF ( H0.LT.-1. _d 0 ) H0 = -1. _d 0
           IF ( H0.GT. 1. _d 0 ) H0 =  1. _d 0
           H0 = ACOS( H0 )
           FSOL = SOLC * dD0dDsq / PI
     &          * ( H0 * TMPA + SIN(H0) * TMPB )
           zen_fsol_daily(i,j,bi,bj) = FSOL

C note: an alternative for the DAILY MEAN is, as done in pkg/aim_v23,
C          ALPHA= 2. _d 0*PI*(TYEAR+10. _d 0/365. _d 0)
C          CSR1=-0.796 _d 0*COS(ALPHA)
C          CSR2= 0.147 _d 0*COS(2. _d 0*ALPHA)-0.477 _d 0
C          FLAT2 = 1.5 _d 0*SJ**2 - 0.5 _d 0
C          FSOL = 0.25 _d 0 * SOLC
C    &          * MAX( 0. _d 0, 1. _d 0+CSR1*SJ+CSR2*FLAT2 )
C          zen_fsol_daily (i,j,bi,bj) = FSOL
          ENDDO
         ENDDO

C       end bi,bj loops
        ENDDO
       ENDDO

C      end if ( useExfZenIncoming )
      ENDIF

#endif /* ALLOW_ZENITHANGLE */
#endif /* ALLOW_DOWNWARD_RADIATION */

      RETURN
      END

#include "MOM_FLUXFORM_OPTIONS.h"
#ifdef ALLOW_MOM_COMMON
# include "MOM_COMMON_OPTIONS.h"
#endif

CBOP
C !ROUTINE: MOM_V_DEL2V

C !INTERFACE: ==========================================================
      SUBROUTINE MOM_V_DEL2V(
     I        bi, bj, k,
     I        vFld, hFacZ, h0FacZ,
     O        del2v,
     I        myThid )

C !DESCRIPTION:
C Calculates the Laplacian of meridional flow

C !USES: ===============================================================
      IMPLICIT NONE
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "SURFACE.h"

C !INPUT PARAMETERS: ===================================================
C  bi,bj                :: tile indices
C  k                    :: vertical level
C  vFld                 :: meridional flow
C  hFacZ                :: fractional thickness at vorticity points
C  h0FacZ               :: fixed fractional thickness at vorticity points
C  myThid               :: my Thread Id number
      INTEGER bi, bj, k
      _RL vFld  (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RS hFacZ (1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RS h0FacZ(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER myThid
C !OUTPUT PARAMETERS: ==================================================
C  del2v                :: Laplacian
      _RL del2v(1-OLx:sNx+OLx,1-OLy:sNy+OLy)

C !LOCAL VARIABLES: ====================================================
C  i,j                  :: loop indices
      INTEGER i,j
      _RL fZon(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RL fMer(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      _RS hFacZClosedE, hFacZClosedW
CEOP

C     Zonal flux d/dx V
      DO j=1-OLy+1,sNy+OLy-1
       DO i=1-OLx+1,sNx+OLx
        fZon(i,j) = drF(k)*hFacZ(i,j)
     &   *_dyU(i,j,bi,bj)
     &   *_recip_dxV(i,j,bi,bj)
     &   *(vFld(i,j)-vFld(i-1,j))
#ifdef COSINEMETH_III
     &   *sqCosFacV(j,bi,bj)
#endif
c    &   *deepFacC(k)        ! dyU scaling factor
c    &   *recip_deepFacC(k)  ! recip_dxV scaling factor
       ENDDO
      ENDDO

C     Meridional flux d/dy V
      DO j=1-OLy,sNy+OLy-1
       DO i=1-OLx+1,sNx+OLx-1
        fMer(i,j) = drF(k)*_hFacC(i,j,k,bi,bj)
     &   *_dxF(i,j,bi,bj)
     &   *_recip_dyF(i,j,bi,bj)
     &   *(vFld(i,j+1)-vFld(i,j))
#if (defined (ISOTROPIC_COS_SCALING) && defined (COSINEMETH_III))
     &   *sqCosFacU(j,bi,bj)
#endif
#ifdef ALLOW_OBCS
     &   *maskInC(i,j,bi,bj)
#endif
c    &   *deepFacC(k)        ! dxF scaling factor
c    &   *recip_deepFacC(k)  ! recip_dyF scaling factor
       ENDDO
      ENDDO

C     del^2 V
      DO j=1-OLy+1,sNy+OLy-1
       DO i=1-OLx+1,sNx+OLx-1
        del2v(i,j) =
     &   recip_drF(k)*_recip_hFacS(i,j,k,bi,bj)
     &  *recip_rAs(i,j,bi,bj)*recip_deepFac2C(k)
     &  *( fZon(i+1,j)    - fZon(i, j )
     &    +fMer( i ,j)    - fMer(i,j-1)
     &   )*_maskS(i,j,k,bi,bj)
#ifdef ALLOW_OBCS
     &    *maskInS(i,j,bi,bj)
#endif
       ENDDO
      ENDDO

      IF (no_slip_sides) THEN
C-- No-slip BCs impose a drag at walls...
       DO j=1-OLy+1,sNy+OLy-1
        DO i=1-OLx+1,sNx+OLx-1
#ifdef NONLIN_FRSURF
         hFacZClosedW = h0FacS(i,j,k,bi,bj) - h0FacZ(i,j)
         hFacZClosedE = h0FacS(i,j,k,bi,bj) - h0FacZ(i+1,j)
#else
         hFacZClosedW = _hFacS(i,j,k,bi,bj) - h0FacZ(i,j)
         hFacZClosedE = _hFacS(i,j,k,bi,bj) - h0FacZ(i+1,j)
#endif
         del2v(i,j) = del2v(i,j)
     &    -_recip_hFacS(i,j,k,bi,bj)
     &       *recip_rAs(i,j,bi,bj)*recip_deepFac2C(k)
     &       *( hFacZClosedW*dyU( i ,j,bi,bj)
     &                      *_recip_dxV( i ,j,bi,bj)
     &         +hFacZClosedE*dyU(i+1,j,bi,bj)
     &                      *_recip_dxV(i+1,j,bi,bj)
     &        )*vFld(i,j)*sideDragFactor
     &         *_maskS(i,j,k,bi,bj)
        ENDDO
       ENDDO
      ENDIF

      RETURN
      END

#include "FLT_OPTIONS.h"

C--   Contents
C--   o FLT_MAP_XY2IJLOCAL
C--   o FLT_MAP_IJLOCAL2XY
C--   o FLT_MAP_R2K  (Function)
C--   o FLT_MAP_K2R  (Function)

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      SUBROUTINE FLT_MAP_XY2IJLOCAL(
     O                               ix, jy,
     I                               xx, yy, bi, bj, myThid )

C     ==================================================================
C     SUBROUTINE FLT_MAP_XY2IJLOCAL
C     ==================================================================
C     o Converts global x,y-coordinates (grid) to corresponding
C       local fractional horizontal indices for specific tile
C     Range: [1/2 , sNx+1/2] , [1/2 , sNy+1/2]
C           Center  (Tracer Pt) <-> integer , integer
C           U-velocity Pt <-> half integer , integer
C           V-velocity Pt <-> integer , half integer
C           Vorticity  Pt <-> half integer , half integer
C     ==================================================================

C     !USES:
      IMPLICIT NONE

C     == global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "GRID.h"
#include "PARAMS.h"

C     == routine arguments ==
      _RL ix, jy
      _RL xx, yy
      INTEGER bi, bj, myThid

C     == local variables ==
      _RL fm, dist
      INTEGER i, j

C     == end of interface ==

      IF ( usingCartesianGrid .OR.
     &     usingSphericalPolarGrid .AND. .NOT.rotateGrid
     &   ) THEN

        ix = -1. _d 0
        jy = -1. _d 0

        j = 1
        DO i=0,sNx+1
          IF ( ix.EQ.-1. _d 0 ) THEN
           IF ( xG(i,j,bi,bj).LE.xx .AND. xx.LT.xG(i+1,j,bi,bj) ) THEN
             dist = xG(i+1,j,bi,bj) - xG(i,j,bi,bj)
             fm = ( xx - xG(i,j,bi,bj) ) / dist
             ix = DFLOAT(i)+fm-0.5 _d 0
           ENDIF
          ENDIF
        ENDDO

        i = 1
        DO j=0,sNy+1
          IF ( jy.EQ.-1. _d 0 ) THEN
           IF ( yG(i,j,bi,bj).LE.yy .AND. yy.LT.yG(i,j+1,bi,bj) ) THEN
             dist = yG(i,j+1,bi,bj) - yG(i,j,bi,bj)
             fm = ( yy - yG(i,j,bi,bj) ) / dist
             jy = DFLOAT(j)+fm-0.5 _d 0
           ENDIF
          ENDIF
        ENDDO

      ELSE
        STOP 'FLT_MAP_XY2IJLOCAL: not yet coded for this grid'
      ENDIF

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      SUBROUTINE FLT_MAP_IJLOCAL2XY(
     O                               xx, yy,
     I                               ix, jy, bi, bj, myThid )

C     ==================================================================
C     SUBROUTINE FLT_MAP_IJLOCAL2XY
C     ==================================================================
C     o Converts local fractional horizontal indices for specific tile
C       to corresponding global x,y-coordinates (grid)
C     Range: [1/2 , sNx+1/2] , [1/2 , sNy+1/2]
C           Center  (Tracer Pt) <-> integer , integer
C           U-velocity Pt <-> half integer , integer
C           V-velocity Pt <-> integer , half integer
C           Vorticity  Pt <-> half integer , half integer
C     ==================================================================

C     !USES:
      IMPLICIT NONE

C     == global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "GRID.h"
#include "PARAMS.h"

C     == routine arguments ==
      _RL xx, yy
      _RL ix, jy
      INTEGER bi, bj, myThid

C     == local variables ==
      _RL ddx, ddy
      INTEGER i, j
      _RL xx_ij,xx_ip1j,xx_ijp1,xx_ip1jp1

C     == end of interface ==

      IF ( usingCartesianGrid .OR.
     &     usingSphericalPolarGrid .AND. .NOT.rotateGrid
     &   ) THEN

        i = NINT(ix)
        j = NINT(jy)
        ddx = 0.5 _d 0 + ix - DFLOAT(i)
        ddy = 0.5 _d 0 + jy - DFLOAT(j)

        xx = xG(i,j,bi,bj) + ddx*( xG(i+1,j,bi,bj) - xG(i,j,bi,bj) )
        yy = yG(i,j,bi,bj) + ddy*( yG(i,j+1,bi,bj) - yG(i,j,bi,bj) )

      ELSEIF ( usingCurvilinearGrid ) THEN

        i = NINT(ix)
        j = NINT(jy)
        ddx = 0.5 _d 0 + ix - DFLOAT(i)
        ddy = 0.5 _d 0 + jy - DFLOAT(j)

C       bilinear interpolation within grid cell (should use arcs instead?)
        xx = xG(i,j,bi,bj) + ddx*( xG(i+1,j,bi,bj) - xG(i,j,bi,bj) )
     &                     + ddy*( xG(i,j+1,bi,bj) - xG(i,j,bi,bj) )
     &                 + ddx*ddy*( xG(i+1,j+1,bi,bj) - xG(i+1,j,bi,bj)
     &                           - xG(i,j+1,bi,bj) + xG(i,j,bi,bj) )
        yy = yG(i,j,bi,bj) + ddx*( yG(i+1,j,bi,bj) - yG(i,j,bi,bj) )
     &                     + ddy*( yG(i,j+1,bi,bj) - yG(i,j,bi,bj) )
     &                 + ddx*ddy*( yG(i+1,j+1,bi,bj) - yG(i+1,j,bi,bj)
     &                           - yG(i,j+1,bi,bj) + yG(i,j,bi,bj) )

        xx_ij=xG(i,j,bi,bj)
        xx_ip1j=xG(i+1,j,bi,bj)
        xx_ijp1=xG(i,j+1,bi,bj)
        xx_ip1jp1=xG(i+1,j+1,bi,bj)
        if (xx_ip1j.GT.xx_ij+180) xx_ip1j=xx_ip1j-360
        if (xx_ip1j.LT.xx_ij-180) xx_ip1j=xx_ip1j+360
        if (xx_ijp1.GT.xx_ij+180) xx_ijp1=xx_ijp1-360
        if (xx_ijp1.LT.xx_ij-180) xx_ijp1=xx_ijp1+360
        if (xx_ip1jp1.GT.xx_ij+180) xx_ip1jp1=xx_ip1jp1-360
        if (xx_ip1jp1.LT.xx_ij-180) xx_ip1jp1=xx_ip1jp1+360
        xx = xx_ij + ddx*( xx_ip1j - xx_ij )
     &             + ddy*( xx_ijp1 - xx_ij )
     &         + ddx*ddy*( xx_ip1jp1 - xx_ip1j - xx_ijp1 + xx_ij )

      ELSE
        STOP 'FLT_MAP_IJLOCAL2XY: not yet coded for this grid'
      ENDIF

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      _RL FUNCTION FLT_MAP_R2K(
     I                          rr, bi, bj, myThid )

C     ==================================================================
C     FUNCTION FLT_MAP_R2K
C     ==================================================================
C     o Converts r-coordinate (grid) to corresponding
C       fractional vertical index
C     Range: [1/2 , Nr+1/2],
C           Center  (Tracer Pt) <-> integer
C           Interface (wVel Pt) <-> half integer
C     ==================================================================

C     !USES:
      IMPLICIT NONE

C     == global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "GRID.h"

C     == routine arguments ==
      _RL rr
      INTEGER bi, bj, myThid

C     == local variables ==
      _RL fm
      INTEGER k

C     == end of interface ==

      FLT_MAP_R2K = 0. _d 0
      DO k=1,Nr
        IF ( FLT_MAP_R2K .EQ. 0. _d 0 ) THEN
C-    r decreases when k increases (rkSign < 0):
          IF ( rF(k) .GE. rr .AND. rr.GT.rF(k+1) ) THEN
            fm = ( rr - rF(k) ) * recip_drF(k)*rkSign
            FLT_MAP_R2K = DFLOAT(k)+fm-0.5 _d 0
          ENDIF
        ENDIF
      ENDDO

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      _RL FUNCTION FLT_MAP_K2R(
     I                          kr, bi, bj, myThid )

C     ==================================================================
C     FUNCTION FLT_MAP_K2R
C     ==================================================================
C     o Converts fractional vertical index to corresponding
C           r-coordinate (grid)
C     Range: [1/2 , Nr+1/2],
C           Center  (Tracer Pt) <-> integer
C           Interface (wVel Pt) <-> half integer
C     ==================================================================

C     !USES:
      IMPLICIT NONE

C     == global variables ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "GRID.h"

C     == routine arguments ==
      _RL kr
      INTEGER bi, bj, myThid

C     == local variables ==
      _RL ddz
      INTEGER k

C     == end of interface ==

      k = NINT(kr)
      IF ( k.LT.1 ) THEN
        FLT_MAP_K2R = rF(1)
      ELSEIF ( k.GT.Nr ) THEN
        FLT_MAP_K2R = rF(Nr+1)
      ELSE
        ddz = 0.5 _d 0 + kr - DFLOAT(k)
        FLT_MAP_K2R = rF(k) + ddz*drF(k)*rkSign
      ENDIF

      RETURN
      END

#include "FIZHI_OPTIONS.h"
      subroutine my_finalize
      implicit none
#ifdef ALLOW_USE_MPI
      integer  ierror
      call mpi_finalize (ierror )
#endif
      return
      end
                                                                                
      subroutine my_exit (irc)
      implicit none
      integer irc
#ifdef ALLOW_USE_MPI
      integer  ierror
      call system ('touch gcm_error')
      call mpi_finalize (ierror)
#endif
      call exit (irc)
      return
      end

#include "PACKAGES_CONFIG.h"
#include "CPP_OPTIONS.h"

CBOP
C     !ROUTINE: PACKAGES_BOOT
C     !INTERFACE:
      SUBROUTINE PACKAGES_BOOT( myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE PACKAGES_BOOT
C     | o Routine to parse runtime package selection file
C     *==========================================================*
C     | Routine reads a flat file which contains a single flag
C     | for each known "package". Flag can enables runtime
C     | activation or deactivation of a package. The data is read
C     | from a file called data.pkg.
C     | Note - If a runtime activation flag is set on but the
C     |        package code was not included in the build then
C     |        the default behavior is to stop with an error.
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
C     myThid   :: my Thread Id number
      INTEGER myThid

C     !LOCAL VARIABLES:
C     === Local variables ===
C     msgBuf   :: Informational/error message buffer
C     iUnit    :: Work variable for IO unit number
      CHARACTER*(MAX_LEN_MBUF) msgBuf
      INTEGER iUnit
      LOGICAL locFlag
CEOP

C     data.pkg namelists
      NAMELIST /PACKAGES/
     &          useOBCS,
     &          useSHAP_FILT,
     &          useZONAL_FILT,
     &          useOPPS,
     &          usePP81,
     &          useKL10,
     &          useMY82,
     &          useGGL90,
     &          useKPP,
     &          useGMRedi,
     &          useDOWN_SLOPE,
     &          useBBL,
     &          useCAL,
     &          useEXF,
     &          useBulkForce,
     &          useEBM,
     &          useCheapAML,
     &          useAUTODIFF,
     &          useGrdchk,
     &          useSMOOTH,
     &          usePROFILES,
     &          useOBSFIT,
     &          useECCO,
     &          useCTRL,
     &          useSBO,
     &          useFLT,
     &          usePTRACERS,
     &          useGCHEM,
     &          useRBCS,
     &          useOffLine,
     &          useMATRIX,
     &          useFRAZIL,
     &          useSEAICE,
     &          useSALT_PLUME,
     &          useShelfIce,
     &          useSTIC,
     &          useStreamIce,
     &          useICEFRONT,
     &          useThSIce,
     &          useLand,
     &          useATM2d,
     &          useAIM,
     &          useAtm_Phys,
     &          useFizhi,
     &          useGridAlt,
     &          useDiagnostics,
     &          useREGRID,
     &          useLayers,
     &          useMNC,
     &          useRunClock,
     &          useEMBED_FILES,
     &          useMYPACKAGE

      _BEGIN_MASTER(myThid)

      WRITE(msgBuf,'(A)') ' PACKAGES_BOOT: opening data.pkg'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT , myThid )

      CALL OPEN_COPY_DATA_FILE(
     I                          'data.pkg', 'PACKAGES_BOOT',
     O                          iUnit,
     I                          myThid )

C--   Default package configuration
c     useGAD          =.FALSE.
      useOBCS         =.FALSE.
      useSHAP_FILT    =.FALSE.
      useZONAL_FILT   =.FALSE.
      useOPPS         =.FALSE.
      usePP81         =.FALSE.
      useKL10         =.FALSE.
      useMY82         =.FALSE.
      useGGL90        =.FALSE.
      useKPP          =.FALSE.
      useGMRedi       =.FALSE.
      useDOWN_SLOPE   =.FALSE.
      useBBL          =.FALSE.
      useCAL          =.FALSE.
      useEXF          =.FALSE.
      useBulkForce    =.FALSE.
      useEBM          =.FALSE.
      useCheapAML     =.FALSE.
      useAUTODIFF     =.FALSE.
      useGrdchk       =.FALSE.
      useSMOOTH       =.FALSE.
      usePROFILES     =.FALSE.
      useOBSFIT       =.FALSE.
      useECCO         =.FALSE.
      useCTRL         =.FALSE.
      useSBO          =.FALSE.
      useFLT          =.FALSE.
      usePTRACERS     =.FALSE.
      useGCHEM        =.FALSE.
      useRBCS         =.FALSE.
      useOffLine      =.FALSE.
      useMATRIX       =.FALSE.
      useFRAZIL       =.FALSE.
      useSEAICE       =.FALSE.
      useSALT_PLUME   =.FALSE.
      useShelfIce     =.FALSE.
      useSTIC         =.FALSE.
      useStreamIce    =.FALSE.
      useICEFRONT     =.FALSE.
      useThSIce       =.FALSE.
      useLand         =.FALSE.
      useATM2d        =.FALSE.
      useAIM          =.FALSE.
      useAtm_Phys     =.FALSE.
      useFizhi        =.FALSE.
      useGridAlt      =.FALSE.
      useDiagnostics  =.FALSE.
      useREGRID       =.FALSE.
      useLayers       =.FALSE.
      useMNC          =.FALSE.
      useRunClock     =.FALSE.
      useEMBED_FILES  =.FALSE.
      useMYPACKAGE    =.FALSE.

C-    Adjust default to account for pkgs without run-time On/Off switch
#ifdef ALLOW_AUTODIFF
      useAUTODIFF     =.TRUE.
# ifdef ALLOW_ECCO
      useECCO         =.TRUE.
# endif
# ifdef ALLOW_CTRL
      useCTRL         =.TRUE.
# endif
#endif /* ALLOW_AUTODIFF */

C--   Read parameters from open data file
      READ(UNIT=iUnit,NML=PACKAGES)

      WRITE(msgBuf,'(A)') ' PACKAGES_BOOT: finished reading data.pkg'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT , myThid )

C--   Close the open data file
#ifdef SINGLE_DISK_IO
      CLOSE(iUnit)
#else
      CLOSE(iUnit,STATUS='DELETE')
#endif /* SINGLE_DISK_IO */

C--   packages with hard-coded switch
#ifndef HAVE_NETCDF
      IF (usePROFILES) THEN
        WRITE(msgBuf,'(2A)') '** WARNING ** pkg/profiles uses NetCDF',
     &   ' which is unavailable (genmake2 test failed)'
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
        WRITE(msgBuf,'(2A)') '** WARNING ** PACKAGES_BOOT:',
     &                       ' ==> Reset usePROFILES to FALSE'
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
        WRITE(msgBuf,'(2A)') ' PACKAGES_BOOT: undef HAVE_NETCDF',
     &                       ' ==> Reset usePROFILES to FALSE'
        CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
        usePROFILES=.FALSE.
      ENDIF
      IF (useOBSFIT) THEN
        WRITE(msgBuf,'(2A)') '** WARNING ** pkg/obsfit uses NetCDF',
     &   ' which is unavailable (genmake2 test failed)'
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
        WRITE(msgBuf,'(2A)') '** WARNING ** PACKAGES_BOOT:',
     &                       ' ==> Reset useOBSFIT to FALSE'
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
        WRITE(msgBuf,'(2A)') ' PACKAGES_BOOT: undef HAVE_NETCDF',
     &                       ' ==> Reset useOBSFIT to FALSE'
        CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
        useOBSFIT=.FALSE.
      ENDIF
#endif

#ifdef ALLOW_CAL
      IF (usePROFILES) useCAL = .TRUE.
      IF (useOBSFIT) useCAL = .TRUE.
      IF (useECCO) useCAL = .TRUE.
#endif

#ifdef ALLOW_CTRL
      IF (useGrdchk) useCTRL = .TRUE.
#endif

C--   packages with an implied switch
      useGAD = tempStepping .OR. saltStepping .OR. usePTRACERS

#ifdef ALLOW_CAL
c     IF (useEXF) useCAL = .TRUE.
C--   Double warning (StdErr & StdOut) after changing useCAL setting
      IF ( useEXF .AND. .NOT. useCAL ) THEN
        WRITE(msgBuf,'(2A)') '** WARNING ** PACKAGES_BOOT: ',
     &    'useCAL no longer set to T when using EXF (useEXF=T)'
        CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
        WRITE(msgBuf,'(2A)') '** WARNING ** PACKAGES_BOOT: ',
     &    ' as it used to be before checkpoint66d (2017/02/13)'
        CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
        WRITE(msgBuf,'(2A)') '** WARNING ** PACKAGES_BOOT: ',
     &    'To continue to use pkg/cal with EXF, need to add:'
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
        WRITE(msgBuf,'(2A)') '** WARNING ** PACKAGES_BOOT: ',
     &    '> useCAL=.TRUE., < in file "data.pkg"'
        CALL PRINT_MESSAGE( msgBuf, errorMessageUnit,
     &                      SQUEEZE_RIGHT, myThid )
      ENDIF
#endif /* ALLOW_CAL */

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C--   Short summary of which package is compiled and used
      WRITE(msgBuf,'(2A)') ' PACKAGES_BOOT: On/Off package Summary'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )

C----- pkgs with a standard "usePKG" On/Off switch in "data.pkg":
      WRITE(standardMessageUnit,'(2A)') ' --------  pkgs with a',
     & ' standard "usePKG" On/Off switch in "data.pkg":  --------'
#ifdef ALLOW_OBCS
      CALL PACKAGES_PRINT_MSG( useOBCS,       'OBCS',        ' ' )
#endif
#ifdef ALLOW_SHAP_FILT
      CALL PACKAGES_PRINT_MSG( useSHAP_FILT,  'SHAP_FILT',   ' ' )
#endif
#ifdef ALLOW_ZONAL_FILT
      CALL PACKAGES_PRINT_MSG( useZONAL_FILT, 'ZONAL_FILT',  ' ' )
#endif
#ifdef ALLOW_OPPS
      CALL PACKAGES_PRINT_MSG( useOPPS,       'OPPS',        ' ' )
#endif
#ifdef ALLOW_PP81
      CALL PACKAGES_PRINT_MSG( usePP81,       'PP81',        ' ' )
#endif
#ifdef ALLOW_KL10
      CALL PACKAGES_PRINT_MSG( useKL10,       'KL10',        ' ' )
#endif
#ifdef ALLOW_MY82
      CALL PACKAGES_PRINT_MSG( useMY82,       'MY82',        ' ' )
#endif
#ifdef ALLOW_GGL90
      CALL PACKAGES_PRINT_MSG( useGGL90,      'GGL90',       ' ' )
#endif
#ifdef ALLOW_KPP
      CALL PACKAGES_PRINT_MSG( useKPP,        'KPP',         ' ' )
#endif
#ifdef ALLOW_GMREDI
      CALL PACKAGES_PRINT_MSG( useGMRedi,     'GMRedi',      ' ' )
#endif
#ifdef ALLOW_DOWN_SLOPE
      CALL PACKAGES_PRINT_MSG( useDOWN_SLOPE, 'DOWN_SLOPE',  ' ' )
#endif
#ifdef ALLOW_BBL
      CALL PACKAGES_PRINT_MSG( useBBL,        'BBL',         ' ' )
#endif
#ifdef ALLOW_CAL
      CALL PACKAGES_PRINT_MSG( useCAL,        'CAL',         ' ' )
#endif
#ifdef ALLOW_EXF
      CALL PACKAGES_PRINT_MSG( useEXF,        'EXF',         ' ' )
#endif
#ifdef ALLOW_BULK_FORCE
      CALL PACKAGES_PRINT_MSG(useBulkForce,'BULK_FORCE','useBulkForce')
#endif
#ifdef ALLOW_EBM
      CALL PACKAGES_PRINT_MSG( useEBM,        'EBM',         ' ' )
#endif
#ifdef ALLOW_CHEAPAML
      CALL PACKAGES_PRINT_MSG( useCheapAML,   'CheapAML',    ' ' )
#endif
#ifdef ALLOW_AUTODIFF
      CALL PACKAGES_PRINT_MSG( useAUTODIFF,   'AUTODIFF',    ' ' )
#endif
#ifdef ALLOW_GRDCHK
      CALL PACKAGES_PRINT_MSG( useGrdchk,     'Grdchk',      ' ' )
#endif
#ifdef ALLOW_SMOOTH
      CALL PACKAGES_PRINT_MSG( useSMOOTH,     'SMOOTH',      ' ' )
#endif
#ifdef ALLOW_PROFILES
      CALL PACKAGES_PRINT_MSG( usePROFILES,   'PROFILES',    ' ' )
#endif
#ifdef ALLOW_OBSFIT
      CALL PACKAGES_PRINT_MSG( useOBSFIT,     'OBSFIT',      ' ' )
#endif
#ifdef ALLOW_ECCO
      CALL PACKAGES_PRINT_MSG( useECCO,       'ECCO',        ' ' )
#endif
#ifdef ALLOW_CTRL
      CALL PACKAGES_PRINT_MSG( useCTRL,       'CTRL',        ' ' )
#endif
#ifdef ALLOW_SBO
      CALL PACKAGES_PRINT_MSG( useSBO,        'SBO',         ' ' )
#endif
#ifdef ALLOW_FLT
      CALL PACKAGES_PRINT_MSG( useFLT,        'FLT',         ' ' )
#endif
#ifdef ALLOW_PTRACERS
      CALL PACKAGES_PRINT_MSG( usePTRACERS,   'PTRACERS',    ' ' )
#endif
#ifdef ALLOW_LONGSTEP
      CALL PACKAGES_PRINT_MSG( usePTRACERS,'LONGSTEP','usePTRACERS' )
#endif
#ifdef ALLOW_GCHEM
      CALL PACKAGES_PRINT_MSG( useGCHEM,      'GCHEM',       ' ' )
#endif
#ifdef ALLOW_RBCS
      CALL PACKAGES_PRINT_MSG( useRBCS,       'RBCS',        ' ' )
#endif
#ifdef ALLOW_OFFLINE
      CALL PACKAGES_PRINT_MSG( useOffLine,    'OffLine',     ' ' )
#endif
#ifdef ALLOW_MATRIX
      CALL PACKAGES_PRINT_MSG( useMATRIX,     'MATRIX',      ' ' )
#endif
#ifdef ALLOW_FRAZIL
      CALL PACKAGES_PRINT_MSG( useFRAZIL,     'FRAZIL',      ' ' )
#endif
#ifdef ALLOW_SEAICE
      CALL PACKAGES_PRINT_MSG( useSEAICE,     'SEAICE',      ' ' )
#endif
#ifdef ALLOW_SALT_PLUME
      CALL PACKAGES_PRINT_MSG( useSALT_PLUME, 'SALT_PLUME',  ' ' )
#endif
#ifdef ALLOW_SHELFICE
      CALL PACKAGES_PRINT_MSG( useShelfIce,   'ShelfIce',    ' ' )
#endif
#ifdef ALLOW_STEEP_ICECAVITY
      CALL PACKAGES_PRINT_MSG( useSTIC,   'STEEP_ICECAVITY', ' ' )
#endif
#ifdef ALLOW_STREAMICE
      CALL PACKAGES_PRINT_MSG( useStreamIce,  'StreamIce',   ' ' )
#endif
#ifdef ALLOW_ICEFRONT
      CALL PACKAGES_PRINT_MSG( useICEFRONT,   'ICEFRONT',    ' ' )
#endif
#ifdef ALLOW_THSICE
      CALL PACKAGES_PRINT_MSG( useThSIce,     'ThSIce',      ' ' )
#endif
#ifdef ALLOW_LAND
      CALL PACKAGES_PRINT_MSG( useLand,       'Land',        ' ' )
#endif
#ifdef ALLOW_ATM2D
      CALL PACKAGES_PRINT_MSG( useATM2d,      'ATM2d',       ' ' )
#endif
#ifdef ALLOW_AIM_V23
      CALL PACKAGES_PRINT_MSG( useAIM,        'aim_v23', 'useAIM' )
#endif
#ifdef ALLOW_ATM_PHYS
      CALL PACKAGES_PRINT_MSG( useAtm_Phys,   'Atm_Phys',    ' ' )
#endif
#ifdef ALLOW_FIZHI
      CALL PACKAGES_PRINT_MSG( useFizhi,      'Fizhi',       ' ' )
#endif
#ifdef ALLOW_GRIDALT
      CALL PACKAGES_PRINT_MSG( useGridAlt,    'GridAlt',     ' ' )
#endif
#ifdef ALLOW_DIAGNOSTICS
      CALL PACKAGES_PRINT_MSG( useDiagnostics,'Diagnostics', ' ' )
#endif
#ifdef ALLOW_REGRID
      CALL PACKAGES_PRINT_MSG( useREGRID,     'REGRID',      ' ' )
#endif
#ifdef ALLOW_LAYERS
      CALL PACKAGES_PRINT_MSG( useLayers,     'Layers',      ' ' )
#endif
#ifdef ALLOW_MNC
      CALL PACKAGES_PRINT_MSG( useMNC,        'MNC',         ' ' )
#endif
#ifdef ALLOW_RUNCLOCK
      CALL PACKAGES_PRINT_MSG( useRunClock,   'RunClock',    ' ' )
#endif
#ifdef ALLOW_EMBED_FILES
      CALL PACKAGES_PRINT_MSG( useEMBED_FILES,'EMBED_FILES', ' ' )
#endif
#ifdef ALLOW_MYPACKAGE
      CALL PACKAGES_PRINT_MSG( useMYPACKAGE,  'MYPACKAGE',   ' ' )
#endif

C----- pkgs without standard "usePKG" in "data.pkg":
      WRITE(standardMessageUnit,'(2A)') ' -------- pkgs without',
     & ' standard "usePKG" On/Off switch in "data.pkg":  --------'
#ifdef ALLOW_GENERIC_ADVDIFF
      CALL PACKAGES_PRINT_MSG( useGAD, 'GENERIC_ADVDIFF', 'useGAD' )
#endif
#ifdef ALLOW_MOM_COMMON
      CALL PACKAGES_PRINT_MSG( momStepping,'MOM_COMMON','momStepping' )
#endif
#ifdef ALLOW_MOM_VECINV
      locFlag = momStepping .AND. vectorInvariantMomentum
      CALL PACKAGES_PRINT_MSG( locFlag, 'MOM_VECINV',
     &                                  '+vectorInvariantMomentum' )
#endif
#ifdef ALLOW_MOM_FLUXFORM
      locFlag = momStepping .AND. .NOT.vectorInvariantMomentum
      CALL PACKAGES_PRINT_MSG( locFlag, 'MOM_FLUXFORM',
     &                                  '& not vectorInvariantMom' )
#endif
#ifdef ALLOW_CD_CODE
      CALL PACKAGES_PRINT_MSG( useCDscheme, 'CD_CODE', 'useCDscheme' )
#endif
#ifdef ALLOW_MONITOR
      locFlag = monitorFreq.GT.0.
      CALL PACKAGES_PRINT_MSG( locFlag, 'MONITOR', 'monitorFreq > 0.' )
#endif
#ifdef ALLOW_DEBUG
      CALL PACKAGES_PRINT_MSG( debugMode, 'DEBUG', 'debugMode' )
#endif
#ifdef ALLOW_COMPON_COMMUNIC
      CALL PACKAGES_PRINT_MSG( useCoupler, 'COMPON_COMMUNIC',
     &                         'useCoupler' )
#endif
#ifdef ALLOW_ATM_COMPON_INTERF
      CALL PACKAGES_PRINT_MSG( useCoupler, 'ATM_COMPON_INTERF',
     &                         'useCoupler' )
#endif
#ifdef ALLOW_OCN_COMPON_INTERF
      CALL PACKAGES_PRINT_MSG( useCoupler, 'OCN_COMPON_INTERF',
     &                         'useCoupler' )
#endif
C----- pkgs without a run-time switch:
      locFlag = .TRUE.
#ifdef ALLOW_ATM_OCN_COUPLER
      CALL PACKAGES_PRINT_MSG( locFlag, 'ATM_OCN_COUPLER', 'Used' )
#endif
#ifdef ALLOW_EXCH2
      CALL PACKAGES_PRINT_MSG( locFlag, 'EXCH2',      'Used' )
#endif
#ifdef ALLOW_RW
      CALL PACKAGES_PRINT_MSG( locFlag, 'RW',        'Used' )
#endif
#ifdef ALLOW_MDSIO
      CALL PACKAGES_PRINT_MSG( locFlag, 'MDSIO',     'Used' )
#endif
#ifdef ALLOW_SHOWFLOPS
      CALL PACKAGES_PRINT_MSG( locFlag, 'SHOWFLOPS', 'Used' )
#endif
C----- AD related pkgs:
#ifdef ALLOW_ADMTLM
      CALL PACKAGES_PRINT_MSG( locFlag, 'ADMTLM',     'Used' )
#endif
#ifdef ALLOW_AUTODIFF
      CALL PACKAGES_PRINT_MSG( locFlag, 'AUTODIFF',   'Used' )
#endif
#ifdef ALLOW_OPENAD
      CALL PACKAGES_PRINT_MSG( locFlag, 'OPENAD',     'Used' )
#endif
#ifdef ALLOW_COST
      CALL PACKAGES_PRINT_MSG( locFlag, 'COST',       'Used' )
#endif
C----- mysterious pkgs:
#ifdef ALLOW_SPHERE
      CALL PACKAGES_PRINT_MSG( locFlag, 'SPHERE',     'None' )
#endif
#ifdef ALLOW_CHRONOS
      CALL PACKAGES_PRINT_MSG( locFlag, 'CHRONOS',    'None' )
#endif
#ifdef ALLOW_ATM_COMMON
      CALL PACKAGES_PRINT_MSG( locFlag, 'ATM_COMMON', 'None' )
#endif

      WRITE(msgBuf,'(2A)') ' PACKAGES_BOOT: End of package Summary'
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )
      WRITE(msgBuf,'(A)') ' '
      CALL PRINT_MESSAGE( msgBuf, standardMessageUnit,
     &                    SQUEEZE_RIGHT, myThid )

      _END_MASTER(myThid)

C--   Everyone else must wait for the parameters to be loaded
      _BARRIER

      RETURN
      END

#include "CPP_OPTIONS.h"

      _RL FUNCTION PHI_GL_STREAMICE (X, W)

c      This function returns a "smoothed indicator function"
c      that is zero when x<0, 1 when x>w, and continuously diff.

       _RL X, W
       _RL TMP1, PI

       IF (X.le.0.0) THEN
         PHI_GL_STREAMICE = 0.0
       ELSEIF(X.gt.W) THEN
         PHI_GL_STREAMICE = 1.0
       ELSE
         PI = 3.14159265358979323844D0
         TMP1 = COS (PI*X/W)
         PHI_GL_STREAMICE = 0.5 * (1-TMP1)
       ENDIF

       RETURN
       END

#include "OBCS_OPTIONS.h"

C--   File obcs_sponge.F:
C--    Contents:
C--    o OBCS_SPONGE_U
C--    o OBCS_SPONGE_V
C--    o OBCS_SPONGE_T
C--    o OBCS_SPONGE_S

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

CStartOfInterface
      SUBROUTINE OBCS_SPONGE_U(
     U                gU_arr,
     I                iMin,iMax,jMin,jMax, k, bi, bj,
     I                myTime, myIter, myThid )
C     *==========================================================*
C     | S/R OBCS_SPONGE_U
C     | o Contains problem specific forcing for zonal velocity.
C     *==========================================================*
C     | Adds a relaxation term to gU near Open-Boundaries
C     *==========================================================*
      IMPLICIT NONE

C     == Global data ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "DYNVARS.h"
#include "OBCS_PARAMS.h"
#include "OBCS_GRID.h"
#include "OBCS_FIELDS.h"

C     == Routine arguments ==
C     gU_arr    :: the tendency array
C     iMin,iMax :: Working range of x-index for applying forcing.
C     jMin,jMax :: Working range of y-index for applying forcing.
C     k         :: Current vertical level index
C     bi,bj     :: Current tile indices
      _RL gU_arr(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER iMin, iMax, jMin, jMax
      INTEGER k, bi, bj
      _RL myTime
      INTEGER myIter
      INTEGER myThid
CEndOfInterface

#if defined(ALLOW_OBCS) && defined(ALLOW_OBCS_SPONGE)
C     == Local variables ==
C     Loop counters
      INTEGER i, j
#if (defined ALLOW_OBCS_EAST ) || (defined ALLOW_OBCS_WEST )
      INTEGER isl
#endif
#if (defined ALLOW_OBCS_NORTH) || (defined ALLOW_OBCS_SOUTH)
      INTEGER jsl
#endif
      _RL urelax, lambda_obcs_u

      IF ( useOBCSsponge .AND. spongeThickness.NE.0 ) THEN

C Northern Open Boundary
#ifdef ALLOW_OBCS_NORTH
       IF ( OBCSsponge_N .AND. OBCSsponge_UatNS ) THEN
        DO i=iMin,iMax
         IF ( OB_Jn(i,bi,bj).NE.OB_indexNone ) THEN
          DO jsl= 1,spongeThickness
           j=OB_Jn(i,bi,bj)-jsl
           IF ( j.GE.jMin .AND. j.LE.jMax ) THEN
            IF (useLinearSponge) THEN
             urelax = OBNu(i,k,bi,bj)
            ELSE
             urelax=(
     &           float(spongeThickness-jsl)*OBNu(i,k,bi,bj)
     &           + float(jsl)*uVel(i,j,k,bi,bj) )
     &           / float(spongeThickness)
            ENDIF
            lambda_obcs_u = (
     &           float(spongeThickness-jsl)*Vrelaxobcsbound
     &           + float(jsl)*Vrelaxobcsinner)
     &           / float(spongeThickness)
            IF (lambda_obcs_u.ne.0.) THEN
             lambda_obcs_u = 1. _d 0 / lambda_obcs_u
            ELSE
             lambda_obcs_u = 0. _d 0
            ENDIF
            gU_arr(i,j) = gU_arr(i,j)
     &           - _maskW(i,j,k,bi,bj) * lambda_obcs_u
     &           * ( uVel(i,j,k,bi,bj) - urelax )
           ENDIF
          ENDDO
         ENDIF
        ENDDO
       ENDIF
#endif /* ALLOW_OBCS_NORTH */

C Southern Open Boundary
#ifdef ALLOW_OBCS_SOUTH
       IF ( OBCSsponge_S .AND. OBCSsponge_UatNS ) THEN
        DO i=iMin,iMax
         IF ( OB_Js(i,bi,bj).NE.OB_indexNone ) THEN
          DO jsl= 1,spongeThickness
           j=OB_Js(i,bi,bj)+jsl
           IF ( j.GE.jMin .AND. j.LE.jMax ) THEN
            IF (useLinearSponge) THEN
             urelax= OBSu(i,k,bi,bj)
            ELSE
             urelax=(
     &           float(spongeThickness-jsl)*OBSu(i,k,bi,bj)
     &           + float(jsl)*uVel(i,j,k,bi,bj) )
     &           / float(spongeThickness)
            ENDIF
            lambda_obcs_u = (
     &           float(spongeThickness-jsl)*Vrelaxobcsbound
     &           + float(jsl)*Vrelaxobcsinner)
     &           / float(spongeThickness)
            IF (lambda_obcs_u.ne.0.) THEN
             lambda_obcs_u = 1. _d 0 / lambda_obcs_u
            ELSE
             lambda_obcs_u = 0. _d 0
            ENDIF
            gU_arr(i,j) = gU_arr(i,j)
     &           - _maskW(i,j,k,bi,bj) * lambda_obcs_u
     &           * ( uVel(i,j,k,bi,bj) - urelax )
           ENDIF
          ENDDO
         ENDIF
        ENDDO
       ENDIF
#endif /* ALLOW_OBCS_SOUTH */

C Eastern Open Boundary
#ifdef ALLOW_OBCS_EAST
       IF ( OBCSsponge_E .AND. OBCSsponge_UatEW ) THEN
        DO j=jMin,jMax
         IF ( OB_Ie(j,bi,bj).NE.OB_indexNone ) THEN
          DO isl= 1,spongeThickness
           i=OB_Ie(j,bi,bj)-isl
           IF ( i.GE.iMin .AND. i.LE.iMax ) THEN
            IF (useLinearSponge) THEN
             urelax=OBEu(j,k,bi,bj)
            ELSE
             urelax=(
     &           float(spongeThickness-isl)*OBEu(j,k,bi,bj)
     &           + float(isl)*uVel(i,j,k,bi,bj) )
     &           / float(spongeThickness)
            ENDIF
            lambda_obcs_u = (
     &           float(spongeThickness-isl)*Urelaxobcsbound
     &           + float(isl)*Urelaxobcsinner)
     &           / float(spongeThickness)
            IF (lambda_obcs_u.ne.0.) THEN
             lambda_obcs_u = 1. _d 0 / lambda_obcs_u
            ELSE
             lambda_obcs_u = 0. _d 0
            ENDIF
            gU_arr(i,j) = gU_arr(i,j)
     &           - _maskW(i,j,k,bi,bj) * lambda_obcs_u
     &           * ( uVel(i,j,k,bi,bj) - urelax )
           ENDIF
          ENDDO
         ENDIF
        ENDDO
       ENDIF
#endif /* ALLOW_OBCS_EAST */

C Western Open Boundary
#ifdef ALLOW_OBCS_WEST
       IF ( OBCSsponge_W .AND. OBCSsponge_UatEW ) THEN
        DO j=jMin,jMax
         IF ( OB_Iw(j,bi,bj).NE.OB_indexNone ) THEN
          DO isl= 1,spongeThickness
           i=OB_Iw(j,bi,bj)+isl+1
           IF ( i.GE.iMin .AND. i.LE.iMax ) THEN
            IF (useLinearSponge) THEN
             urelax= OBWu(j,k,bi,bj)
            ELSE
             urelax=(
     &           float(spongeThickness-isl)*OBWu(j,k,bi,bj)
     &           + float(isl)*uVel(i,j,k,bi,bj) )
     &           / float(spongeThickness)
            ENDIF
            lambda_obcs_u= (
     &           float(spongeThickness-isl)*Urelaxobcsbound
     &           + float(isl)*Urelaxobcsinner)
     &           / float(spongeThickness)
            IF (lambda_obcs_u.ne.0.) THEN
             lambda_obcs_u = 1. _d 0 / lambda_obcs_u
            ELSE
             lambda_obcs_u = 0. _d 0
            ENDIF
            gU_arr(i,j) = gU_arr(i,j)
     &           - _maskW(i,j,k,bi,bj) * lambda_obcs_u
     &           * ( uVel(i,j,k,bi,bj) - urelax )
           ENDIF
          ENDDO
         ENDIF
        ENDDO
       ENDIF
#endif /* ALLOW_OBCS_WEST */

      ENDIF

#endif /* ALLOW_OBCS & ALLOW_OBCS_SPONGE */

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

CStartOfInterface
      SUBROUTINE OBCS_SPONGE_V(
     U                gV_arr,
     I                iMin,iMax,jMin,jMax, k, bi, bj,
     I                myTime, myIter, myThid )
C     *==========================================================*
C     | S/R OBCS_SPONGE_V
C     | o Contains problem specific forcing for merid velocity.
C     *==========================================================*
C     | Adds a relaxation term to gV near Open-Boundaries
C     *==========================================================*
      IMPLICIT NONE

C     == Global data ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "DYNVARS.h"
#include "OBCS_PARAMS.h"
#include "OBCS_GRID.h"
#include "OBCS_FIELDS.h"

C     == Routine arguments ==
C     gV_arr    :: the tendency array
C     iMin,iMax :: Working range of x-index for applying forcing.
C     jMin,jMax :: Working range of y-index for applying forcing.
C     k         :: Current vertical level index
C     bi,bj     :: Current tile indices
      _RL gV_arr(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER iMin, iMax, jMin, jMax
      INTEGER k, bi, bj
      _RL myTime
      INTEGER myIter
      INTEGER myThid
CEndOfInterface

#if defined(ALLOW_OBCS) && defined(ALLOW_OBCS_SPONGE)
C     == Local variables ==
C     Loop counters
      INTEGER i, j
#if (defined ALLOW_OBCS_EAST ) || (defined ALLOW_OBCS_WEST )
      INTEGER isl
#endif
#if (defined ALLOW_OBCS_NORTH) || (defined ALLOW_OBCS_SOUTH)
      INTEGER jsl
#endif
      _RL vrelax,lambda_obcs_v

      IF ( useOBCSsponge .AND. spongeThickness.NE.0 ) THEN

C Northern Open Boundary
#ifdef ALLOW_OBCS_NORTH
       IF ( OBCSsponge_N .AND. OBCSsponge_VatNS ) THEN
        DO i=iMin,iMax
         IF ( OB_Jn(i,bi,bj).NE.OB_indexNone ) THEN
          DO jsl= 1,spongeThickness
           j=OB_Jn(i,bi,bj)-jsl
           IF ( j.GE.jMin .AND. j.LE.jMax ) THEN
            IF (useLinearSponge) THEN
             vrelax= OBNv(i,k,bi,bj)
            ELSE
             vrelax=(
     &           float(spongeThickness-jsl)*OBNv(i,k,bi,bj)
     &           + float(jsl)*vVel(i,j,k,bi,bj) )
     &           / float(spongeThickness)
            ENDIF
            lambda_obcs_v = (
     &           float(spongeThickness-jsl)*Vrelaxobcsbound
     &           + float(jsl)*Vrelaxobcsinner)
     &           / float(spongeThickness)
            IF (lambda_obcs_v.ne.0.) THEN
             lambda_obcs_v = 1. _d 0 / lambda_obcs_v
            ELSE
             lambda_obcs_v = 0. _d 0
            ENDIF
            gV_arr(i,j) = gV_arr(i,j)
     &           - _maskS(i,j,k,bi,bj) * lambda_obcs_v
     &           * ( vVel(i,j,k,bi,bj) - vrelax )
           ENDIF
          ENDDO
         ENDIF
        ENDDO
       ENDIF
#endif /* ALLOW_OBCS_NORTH */

C Southern Open Boundary
#ifdef ALLOW_OBCS_SOUTH
       IF ( OBCSsponge_S .AND. OBCSsponge_VatNS ) THEN
        DO i=iMin,iMax
         IF ( OB_Js(i,bi,bj).NE.OB_indexNone ) THEN
          DO jsl= 1,spongeThickness
           j=OB_Js(i,bi,bj)+jsl+1
           IF ( j.GE.jMin .AND. j.LE.jMax ) THEN
            IF (useLinearSponge) THEN
             vrelax= OBSv(i,k,bi,bj)
            ELSE
             vrelax=(
     &           float(spongeThickness-jsl)*OBSv(i,k,bi,bj)
     &           + float(jsl)*vVel(i,j,k,bi,bj) )
     &           / float(spongeThickness)
            ENDIF
            lambda_obcs_v = (
     &           float(spongeThickness-jsl)*Vrelaxobcsbound
     &           + float(jsl)*Vrelaxobcsinner)
     &           / float(spongeThickness)
            IF (lambda_obcs_v.ne.0.) THEN
             lambda_obcs_v = 1. _d 0 / lambda_obcs_v
            ELSE
             lambda_obcs_v = 0. _d 0
            ENDIF
            gV_arr(i,j) = gV_arr(i,j)
     &           - _maskS(i,j,k,bi,bj) * lambda_obcs_v
     &           * ( vVel(i,j,k,bi,bj) - vrelax )
           ENDIF
          ENDDO
         ENDIF
        ENDDO
       ENDIF
#endif /* ALLOW_OBCS_SOUTH */

C Eastern Open Boundary
#ifdef ALLOW_OBCS_EAST
       IF ( OBCSsponge_E .AND. OBCSsponge_VatEW ) THEN
        DO j=jMin,jMax
         IF ( OB_Ie(j,bi,bj).NE.OB_indexNone ) THEN
          DO isl= 1,spongeThickness
           i=OB_Ie(j,bi,bj)-isl
           IF ( i.GE.iMin .AND. i.LE.iMax ) THEN
            IF (useLinearSponge) THEN
             vrelax= OBEv(j,k,bi,bj)
            ELSE
             vrelax=(
     &           float(spongeThickness-isl)*OBEv(j,k,bi,bj)
     &           + float(isl)*vVel(i,j,k,bi,bj) )
     &           / float(spongeThickness)
            ENDIF
            lambda_obcs_v = (
     &           float(spongeThickness-isl)*Urelaxobcsbound
     &           + float(isl)*Urelaxobcsinner)
     &           / float(spongeThickness)
            If (lambda_obcs_v.ne.0.) THEN
             lambda_obcs_v = 1. _d 0 / lambda_obcs_v
            ELSE
             lambda_obcs_v = 0. _d 0
            ENDIF
            gV_arr(i,j) = gV_arr(i,j)
     &           - _maskS(i,j,k,bi,bj) * lambda_obcs_v
     &           * ( vVel(i,j,k,bi,bj) - vrelax )
           ENDIF
          ENDDO
         ENDIF
        ENDDO
       ENDIF
#endif /* ALLOW_OBCS_EAST */

C Western Open Boundary
#ifdef ALLOW_OBCS_WEST
       IF ( OBCSsponge_W .AND. OBCSsponge_VatEW ) THEN
        DO j=jMin,jMax
         IF ( OB_Iw(j,bi,bj).NE.OB_indexNone ) THEN
          DO isl= 1,spongeThickness
           i=OB_Iw(j,bi,bj)+isl
           IF ( i.GE.iMin .AND. i.LE.iMax ) THEN
            IF (useLinearSponge) THEN
             vrelax = OBWv(j,k,bi,bj)
            ELSE
             vrelax=(
     &           float(spongeThickness-isl)*OBWv(j,k,bi,bj)
     &           + float(isl)*vVel(i,j,k,bi,bj) )
     &           / float(spongeThickness)
            ENDIF
            lambda_obcs_v = (
     &           float(spongeThickness-isl)*Urelaxobcsbound
     &           + float(isl)*Urelaxobcsinner)
     &           / float(spongeThickness)
            IF (lambda_obcs_v.ne.0.) THEN
             lambda_obcs_v = 1. _d 0 / lambda_obcs_v
            ELSE
             lambda_obcs_v = 0. _d 0
            ENDIF
            gV_arr(i,j) = gV_arr(i,j)
     &           - _maskS(i,j,k,bi,bj) * lambda_obcs_v
     &           * ( vVel(i,j,k,bi,bj) - vrelax )
           ENDIF
          ENDDO
         ENDIF
        ENDDO
       ENDIF
#endif /* ALLOW_OBCS_WEST */

      ENDIF

#endif /* ALLOW_OBCS & ALLOW_OBCS_SPONGE */

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

CStartOfInterface
      SUBROUTINE OBCS_SPONGE_T(
     U                gT_arr,
     I                iMin,iMax,jMin,jMax, k, bi, bj,
     I                myTime, myIter, myThid )
C     *==========================================================*
C     | S/R OBCS_SPONGE_T
C     | o Contains problem specific forcing for temperature.
C     *==========================================================*
C     | Adds a relaxation term to gT near Open-Boundaries
C     *==========================================================*
      IMPLICIT NONE

C     == Global data ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "DYNVARS.h"
#include "OBCS_PARAMS.h"
#include "OBCS_GRID.h"
#include "OBCS_FIELDS.h"

C     == Routine arguments ==
C     gT_arr    :: the tendency array
C     iMin,iMax :: Working range of x-index for applying forcing.
C     jMin,jMax :: Working range of y-index for applying forcing.
C     k         :: Current vertical level index
C     bi,bj     :: Current tile indices
      _RL gT_arr(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER iMin, iMax, jMin, jMax
      INTEGER k, bi, bj
      _RL myTime
      INTEGER myIter
      INTEGER myThid
CEndOfInterface

#if defined(ALLOW_OBCS) && defined(ALLOW_OBCS_SPONGE)
C     == Local variables ==
C     Loop counters
      INTEGER i, j
#if (defined ALLOW_OBCS_EAST ) || (defined ALLOW_OBCS_WEST )
      INTEGER isl
#endif
#if (defined ALLOW_OBCS_NORTH) || (defined ALLOW_OBCS_SOUTH)
      INTEGER jsl
#endif
      _RL trelax, lambda_obcs_t

      IF ( useOBCSsponge .AND. spongeThickness.NE.0 ) THEN

C Northern Open Boundary
#ifdef ALLOW_OBCS_NORTH
       IF ( OBCSsponge_N .AND. OBCSsponge_Theta ) THEN
        DO i=iMin,iMax
         IF ( OB_Jn(i,bi,bj).NE.OB_indexNone ) THEN
          DO jsl= 1,spongeThickness
           j=OB_Jn(i,bi,bj)-jsl
           IF ( j.GE.jMin .AND. j.LE.jMax ) THEN
c          IF  (OBNt(i,k,bi,bj).ne. 0.d0) then
            IF (useLinearSponge) THEN
             trelax = OBNt(i,k,bi,bj)
            ELSE
             trelax=(
     &           float(spongeThickness-jsl)*OBNt(i,k,bi,bj)
     &           + float(jsl)*theta(i,j,k,bi,bj) )
     &           / float(spongeThickness)
            ENDIF
            lambda_obcs_t = (
     &           float(spongeThickness-jsl)*Vrelaxobcsbound
     &           + float(jsl)*Vrelaxobcsinner)
     &           / float(spongeThickness)
            IF (lambda_obcs_t.ne.0.) THEN
             lambda_obcs_t = 1. _d 0 / lambda_obcs_t
            ELSE
             lambda_obcs_t = 0. _d 0
            ENDIF
            gT_arr(i,j) = gT_arr(i,j)
     &           -  maskC(i,j,k,bi,bj) * lambda_obcs_t
     &           * ( theta(i,j,k,bi,bj) - trelax )
c          ENDIF
           ENDIF
          ENDDO
         ENDIF
        ENDDO
       ENDIF
#endif /* ALLOW_OBCS_NORTH */

C Southern Open Boundary
#ifdef ALLOW_OBCS_SOUTH
       IF ( OBCSsponge_S .AND. OBCSsponge_Theta ) THEN
        DO i=iMin,iMax
         IF ( OB_Js(i,bi,bj).NE.OB_indexNone ) THEN
          DO jsl= 1,spongeThickness
           j=OB_Js(i,bi,bj)+jsl
           IF ( j.GE.jMin .AND. j.LE.jMax ) THEN
c          IF  (OBSt(i,k,bi,bj).ne. 0.d0) then
            IF (useLinearSponge) THEN
             trelax= OBSt(i,k,bi,bj)
            ELSE
             trelax=(
     &           float(spongeThickness-jsl)*OBSt(i,k,bi,bj)
     &           + float(jsl)*theta(i,j,k,bi,bj) )
     &           / float(spongeThickness)
            ENDIF
            lambda_obcs_t = (
     &           float(spongeThickness-jsl)*Vrelaxobcsbound
     &           + float(jsl)*Vrelaxobcsinner)
     &           / float(spongeThickness)
            IF (lambda_obcs_t.ne.0.) THEN
             lambda_obcs_t = 1. _d 0 / lambda_obcs_t
            ELSE
             lambda_obcs_t = 0. _d 0
            ENDIF
            gT_arr(i,j) = gT_arr(i,j)
     &           - maskC(i,j,k,bi,bj) * lambda_obcs_t
     &           * ( theta(i,j,k,bi,bj) - trelax )
c          ENDIF
           ENDIF
          ENDDO
         ENDIF
        ENDDO
       ENDIF
#endif /* ALLOW_OBCS_SOUTH */

C Eastern Open Boundary
#ifdef ALLOW_OBCS_EAST
       IF ( OBCSsponge_E .AND. OBCSsponge_Theta ) THEN
        DO j=jMin,jMax
         IF ( OB_Ie(j,bi,bj).NE.OB_indexNone ) THEN
          DO isl= 1,spongeThickness
           i=OB_Ie(j,bi,bj)-isl
           IF ( i.GE.iMin .AND. i.LE.iMax ) THEN
c          IF  (OBEt(j,k,bi,bj).ne. 0.d0) then
            IF (useLinearSponge) THEN
             trelax = OBEt(j,k,bi,bj)
            ELSE
             trelax=(
     &           float(spongeThickness-isl)*OBEt(j,k,bi,bj)
     &           + float(isl)*theta(i,j,k,bi,bj) )
     &           / float(spongeThickness)
            ENDIF
            lambda_obcs_t = (
     &           float(spongeThickness-isl)*Urelaxobcsbound
     &           + float(isl)*Urelaxobcsinner)
     &           / float(spongeThickness)
            IF (lambda_obcs_t.ne.0.) THEN
             lambda_obcs_t = 1. _d 0 / lambda_obcs_t
            ELSE
             lambda_obcs_t = 0. _d 0
            ENDIF
            gT_arr(i,j) = gT_arr(i,j)
     &           - maskC(i,j,k,bi,bj) * lambda_obcs_t
     &           * ( theta(i,j,k,bi,bj) - trelax )
c          ENDIF
           ENDIF
          ENDDO
         ENDIF
        ENDDO
       ENDIF
#endif /* ALLOW_OBCS_EAST */

C Western Open Boundary
#ifdef ALLOW_OBCS_WEST
       IF ( OBCSsponge_W .AND. OBCSsponge_Theta ) THEN
        DO j=jMin,jMax
         IF ( OB_Iw(j,bi,bj).NE.OB_indexNone ) THEN
          DO isl= 1,spongeThickness
           i=OB_Iw(j,bi,bj)+isl
           IF ( i.GE.iMin .AND. i.LE.iMax ) THEN
c          IF  (OBWt(j,k,bi,bj).ne. 0.d0) THEN
            IF (useLinearSponge) THEN
             trelax= OBWt(j,k,bi,bj)
            ELSE
             trelax=(
     &           float(spongeThickness-isl)*OBWt(j,k,bi,bj)
     &           + float(isl)*theta(i,j,k,bi,bj) )
     &           / float(spongeThickness)
            ENDIF
            lambda_obcs_t= (
     &           float(spongeThickness-isl)*Urelaxobcsbound
     &           + float(isl)*Urelaxobcsinner)
     &           / float(spongeThickness)
            IF (lambda_obcs_t .ne. 0.) THEN
             lambda_obcs_t = 1. _d 0 / lambda_obcs_t
            ELSE
             lambda_obcs_t = 0. _d 0
            ENDIF
            gT_arr(i,j) = gT_arr(i,j)
     &           - maskC(i,j,k,bi,bj) * lambda_obcs_t
     &           * ( theta(i,j,k,bi,bj) - trelax )
c          ENDIF
           ENDIF
          ENDDO
         ENDIF
        ENDDO
       ENDIF
#endif /* ALLOW_OBCS_WEST */

      ENDIF

#endif /* ALLOW_OBCS & ALLOW_OBCS_SPONGE */

      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

CStartOfInterface
      SUBROUTINE OBCS_SPONGE_S(
     U                gS_arr,
     I                iMin,iMax,jMin,jMax, k, bi, bj,
     I                myTime, myIter, myThid )
C     *==========================================================*
C     | S/R OBCS_SPONGE_S
C     | o Contains problem specific forcing for salinity.
C     *==========================================================*
C     | Adds a relaxation term to gS near Open-Boundaries
C     *==========================================================*
      IMPLICIT NONE

C     == Global data ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "DYNVARS.h"
#include "OBCS_PARAMS.h"
#include "OBCS_GRID.h"
#include "OBCS_FIELDS.h"

C     == Routine arguments ==
C     gS_arr    :: the tendency array
C     iMin,iMax :: Working range of x-index for applying forcing.
C     jMin,jMax :: Working range of y-index for applying forcing.
C     k         :: Current vertical level index
C     bi,bj     :: Current tile indices
      _RL gS_arr(1-OLx:sNx+OLx,1-OLy:sNy+OLy)
      INTEGER iMin, iMax, jMin, jMax
      INTEGER k, bi, bj
      _RL myTime
      INTEGER myIter
      INTEGER myThid
CEndOfInterface

#if defined(ALLOW_OBCS) && defined(ALLOW_OBCS_SPONGE)
C     == Local variables ==
C     Loop counters
      INTEGER i, j
#if (defined ALLOW_OBCS_EAST ) || (defined ALLOW_OBCS_WEST )
      INTEGER isl
#endif
#if (defined ALLOW_OBCS_NORTH) || (defined ALLOW_OBCS_SOUTH)
      INTEGER jsl
#endif
      _RL srelax, lambda_obcs_s

      IF ( useOBCSsponge .AND. spongeThickness.NE.0 ) THEN

C Northern Open Boundary
#ifdef ALLOW_OBCS_NORTH
       IF ( OBCSsponge_N .AND. OBCSsponge_Salt ) THEN
        DO i=iMin,iMax
         IF ( OB_Jn(i,bi,bj).NE.OB_indexNone ) THEN
          DO jsl= 1,spongeThickness
           j=OB_Jn(i,bi,bj)-jsl
           IF ( j.GE.jMin .AND. j.LE.jMax ) THEN
c          IF  (OBNs(i,k,bi,bj).ne. 0.d0) then
            IF (useLinearSponge) THEN
             srelax= OBNs(i,k,bi,bj)
            ELSE
             srelax=(
     &           float(spongeThickness-jsl)*OBNs(i,k,bi,bj)
     &           + float(jsl)*salt(i,j,k,bi,bj) )
     &           / float(spongeThickness)
            ENDIF
            lambda_obcs_s = (
     &           float(spongeThickness-jsl)*Vrelaxobcsbound
     &           + float(jsl)*Vrelaxobcsinner)
     &           / float(spongeThickness)
            IF (lambda_obcs_s.ne.0.) THEN
             lambda_obcs_s = 1. _d 0 / lambda_obcs_s
            ELSE
             lambda_obcs_s = 0. _d 0
            ENDIF
            gS_arr(i,j) = gS_arr(i,j)
     &           - maskC(i,j,k,bi,bj) * lambda_obcs_s
     &           * ( salt(i,j,k,bi,bj) - srelax )
c          ENDIF
           ENDIF
          ENDDO
         ENDIF
        ENDDO
       ENDIF
#endif /* ALLOW_OBCS_NORTH */

C Southern Open Boundary
#ifdef ALLOW_OBCS_SOUTH
       IF ( OBCSsponge_S .AND. OBCSsponge_Salt ) THEN
        DO i=iMin,iMax
         IF ( OB_Js(i,bi,bj).NE.OB_indexNone ) THEN
          DO jsl= 1,spongeThickness
           j=OB_Js(i,bi,bj)+jsl
           IF ( j.GE.jMin .AND. j.LE.jMax ) THEN
c          IF  (OBSs(i,k,bi,bj).ne. 0.d0) THEN
            IF (useLinearSponge) THEN
             srelax= OBSs(i,k,bi,bj)
            ELSE
             srelax=(
     &           float(spongeThickness-jsl)*OBSs(i,k,bi,bj)
     &           + float(jsl)*salt(i,j,k,bi,bj) )
     &           / float(spongeThickness)
            ENDIF
            lambda_obcs_s = (
     &           float(spongeThickness-jsl)*Vrelaxobcsbound
     &           + float(jsl)*Vrelaxobcsinner)
     &           / float(spongeThickness)
            IF (lambda_obcs_s.ne.0.) THEN
             lambda_obcs_s = 1. _d 0 / lambda_obcs_s
            ELSE
             lambda_obcs_s = 0. _d 0
            ENDIF
            gS_arr(i,j) = gS_arr(i,j)
     &           - maskC(i,j,k,bi,bj) * lambda_obcs_s
     &           * ( salt(i,j,k,bi,bj) - srelax )
c          ENDIF
           ENDIF
          ENDDO
         ENDIF
        ENDDO
       ENDIF
#endif /* ALLOW_OBCS_SOUTH */

C Eastern Open Boundary
#ifdef ALLOW_OBCS_EAST
       IF ( OBCSsponge_E .AND. OBCSsponge_Salt ) THEN
        DO j=jMin,jMax
         IF ( OB_Ie(j,bi,bj).NE.OB_indexNone ) THEN
          DO isl= 1,spongeThickness
           i=OB_Ie(j,bi,bj)-isl
           IF ( i.GE.iMin .AND. i.LE.iMax ) THEN
c          IF  (OBEs(j,k,bi,bj).ne. 0.d0) THEN
            IF (useLinearSponge) THEN
             srelax=  OBEs(j,k,bi,bj)
            ELSE
             srelax=(
     &           float(spongeThickness-isl)*OBEs(j,k,bi,bj)
     &           + float(isl)*salt(i,j,k,bi,bj) )
     &           / float(spongeThickness)
            ENDIF
            lambda_obcs_s = (
     &           float(spongeThickness-isl)*Urelaxobcsbound
     &           + float(isl)*Urelaxobcsinner)
     &           / float(spongeThickness)
            IF (lambda_obcs_s.ne.0.) THEN
             lambda_obcs_s = 1. _d 0 / lambda_obcs_s
            ELSE
             lambda_obcs_s = 0. _d 0
            ENDIF
            gS_arr(i,j) = gS_arr(i,j)
     &           - maskC(i,j,k,bi,bj) * lambda_obcs_s
     &           * ( salt(i,j,k,bi,bj) - srelax )
c          ENDIF
           ENDIF
          ENDDO
         ENDIF
        ENDDO
       ENDIF
#endif /* ALLOW_OBCS_EAST */

C Western Open Boundary
#ifdef ALLOW_OBCS_WEST
       IF ( OBCSsponge_W .AND. OBCSsponge_Salt ) THEN
        DO j=jMin,jMax
         IF ( OB_Iw(j,bi,bj).NE.OB_indexNone ) THEN
          DO isl= 1,spongeThickness
           i=OB_Iw(j,bi,bj)+isl
           IF ( i.GE.iMin .AND. i.LE.iMax ) THEN
c          IF  (OBWs(j,k,bi,bj).ne. 0.d0) then
            IF (useLinearSponge) THEN
             srelax= OBWs(j,k,bi,bj)
            ELSE
             srelax=(
     &           float(spongeThickness-isl)*OBWs(j,k,bi,bj)
     &           + float(isl)*salt(i,j,k,bi,bj) )
     &           / float(spongeThickness)
            ENDIF
            lambda_obcs_s= (
     &           float(spongeThickness-isl)*Urelaxobcsbound
     &           + float(isl)*Urelaxobcsinner)
     &           / float(spongeThickness)
            IF (lambda_obcs_s.ne.0.) THEN
             lambda_obcs_s = 1. _d 0 / lambda_obcs_s
            ELSE
             lambda_obcs_s = 0. _d 0
            ENDIF
            gS_arr(i,j) = gS_arr(i,j)
     &           - maskC(i,j,k,bi,bj) * lambda_obcs_s
     &           * ( salt(i,j,k,bi,bj) - srelax )
c          ENDIF
           ENDIF
          ENDDO
         ENDIF
        ENDDO
       ENDIF
#endif /* ALLOW_OBCS_WEST */

      ENDIF

#endif /* ALLOW_OBCS & ALLOW_OBCS_SPONGE */

      RETURN
      END

#include "DIAG_OPTIONS.h"

CBOP
C     !ROUTINE: DIAGSTATS_LOCAL
C     !INTERFACE:
      SUBROUTINE DIAGSTATS_LOCAL(
     U                  statFld,
     I                  inpFld, frcFld,
     I                  scaleFact, power, useFract, sizF,
     I                  sizI1,sizI2,sizJ1,sizJ2,sizK,sizTx,sizTy,
     I                  iRun,jRun,kIn,biIn,bjIn,
     I                  k,bi,bj, bibjFlg, region2fill,
     I                  ndId, parsFld, myThid )

C     !DESCRIPTION:
C     Update array statFld
C     by adding statistics over the range [1:iRun],[1:jRun]
C     from input field array inpFld
C- note:
C   a) this S/R should not see DIAGNOSTICS pkg commons blocks (in DIAGNOSTICS.h)
C   b) for main grid variables, get area & weigting factors (to compute global mean)
C      from the main common blocks.
C   c) for other type of grids, call a specifics S/R which include its own
C      grid common blocks

C     !USES:
      IMPLICIT NONE

#include "EEPARAMS.h"
#include "SIZE.h"
#include "DIAGNOSTICS_SIZE.h"
#include "DIAGSTATS_REGIONS.h"
#include "PARAMS.h"
#include "GRID.h"
c #include "SURFACE.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine Arguments ==
C     statFld     :: cumulative statistics array (updated)
C     inpFld      :: input field array to process (compute stats & add to statFld)
C     frcFld      :: fraction used for weighted-average diagnostics
C     scaleFact   :: scaling factor
C     power       :: option to fill-in with the field square (power=2)
C     useFract    :: if True, use fraction-weight
C     sizF        :: size of frcFld array: 3rd  dimension
C     sizI1,sizI2 :: size of inpFld array: 1rst index range (min,max)
C     sizJ1,sizJ2 :: size of inpFld array: 2nd  index range (min,max)
C     sizK        :: size of inpFld array: 3rd  dimension
C     sizTx,sizTy :: size of inpFld array: tile dimensions
C     iRun,jRun   :: range of 1rst & 2nd index
C     kIn         :: level index of inpFld array to process
C     biIn,bjIn   :: tile indices of inpFld array to process
C     k,bi,bj     :: level and tile indices used for weighting (mask,area ...)
C     bibjFlg     :: passed from calling S/R (see diagstats_fill.F)
C     region2fill :: indicates whether to compute statistics over this region
C     ndId        :: Diagnostics Id Number (in available diag. list)
C     parsFld     :: parser field with characteristics of the diagnostics
C     myThid      :: my Thread Id number
      _RL     statFld(0:nStats,0:nRegions)
      INTEGER sizI1,sizI2,sizJ1,sizJ2
      INTEGER sizF,sizK,sizTx,sizTy
      _RL     inpFld(sizI1:sizI2,sizJ1:sizJ2,sizK,sizTx,sizTy)
      _RL     frcFld(sizI1:sizI2,sizJ1:sizJ2,sizF,sizTx,sizTy)
      _RL     scaleFact
      INTEGER power
      LOGICAL useFract
      INTEGER iRun, jRun, kIn, biIn, bjIn
      INTEGER k, bi, bj, bibjFlg
      INTEGER region2fill(0:nRegions)
      INTEGER ndId
      CHARACTER*16 parsFld
      INTEGER myThid
CEOP

C     !FUNCTIONS:
#ifdef ALLOW_FIZHI
      _RL   getcon
      EXTERNAL getcon
#endif

C     !LOCAL VARIABLES:
C     i,j    :: loop indices
      INTEGER i, n, kFr, kRegMsk, lReg
      INTEGER im, ix, iv
      PARAMETER ( iv = nStats - 2 , im = nStats - 1 , ix = nStats )
      LOGICAL exclSpVal
      LOGICAL useWeight
      _RL statLoc(0:nStats)
      _RL drLoc
      _RL specialVal

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      useWeight = .FALSE.
      exclSpVal = .FALSE.
      specialVal = 0.
#ifdef ALLOW_FIZHI
      IF ( useFIZHI ) THEN
        exclSpVal = .TRUE.
        specialVal = getcon('UNDEF')
      ENDIF
#endif
      kFr = MIN(kIn,sizF)

      DO n=0,nRegions
       IF (region2fill(n).NE.0) THEN
C---   Compute statistics for this tile, level and region:

         kRegMsk = diagSt_kRegMsk(n)
         lReg = 0
         IF ( n.GE.1 ) THEN
           lReg = 1
           IF ( parsFld(2:2).EQ.'U' ) lReg = 2
           IF ( parsFld(2:2).EQ.'V' ) lReg = 3
         ENDIF

         IF ( parsFld(10:10) .EQ. 'R' ) THEN

          drLoc = drF(k)
          IF ( parsFld(9:9).EQ.'L') drLoc = drC(k)
          IF ( parsFld(9:9).EQ.'U') drLoc = drC(MIN(k+1,Nr))
          IF ( parsFld(9:9).EQ.'M') useWeight = .TRUE.

          IF     ( parsFld(2:2).EQ.'U' ) THEN
           CALL DIAGSTATS_CALC(
     O            statLoc,
     I            inpFld(sizI1,sizJ1,kIn,biIn,bjIn),
     I            frcFld(sizI1,sizJ1,kFr,biIn,bjIn),
     I            scaleFact, power, useFract, lReg, diagSt_vRegMsk(n),
     I            nStats,sizI1,sizI2,sizJ1,sizJ2,iRun,jRun,
     I            diagSt_regMask(1-OLx,1-OLy,kRegMsk,bi,bj),
     I            maskInW(1-OLx,1-OLy,bi,bj),
     I            hFacW(1-OLx,1-OLy,k,bi,bj), rAw(1-OLx,1-OLy,bi,bj),
     I            drLoc, specialVal, exclSpVal, useWeight, myThid )
c    I            drLoc, k,bi,bj, parsFld, myThid )
          ELSEIF ( parsFld(2:2).EQ.'V' ) THEN
           CALL DIAGSTATS_CALC(
     O            statLoc,
     I            inpFld(sizI1,sizJ1,kIn,biIn,bjIn),
     I            frcFld(sizI1,sizJ1,kFr,biIn,bjIn),
     I            scaleFact, power, useFract, lReg, diagSt_vRegMsk(n),
     I            nStats,sizI1,sizI2,sizJ1,sizJ2,iRun,jRun,
     I            diagSt_regMask(1-OLx,1-OLy,kRegMsk,bi,bj),
     I            maskInS(1-OLx,1-OLy,bi,bj),
     I            hFacS(1-OLx,1-OLy,k,bi,bj), rAs(1-OLx,1-OLy,bi,bj),
     I            drLoc, specialVal, exclSpVal, useWeight, myThid )
          ELSE
           CALL DIAGSTATS_CALC(
     O            statLoc,
     I            inpFld(sizI1,sizJ1,kIn,biIn,bjIn),
     I            frcFld(sizI1,sizJ1,kFr,biIn,bjIn),
     I            scaleFact, power, useFract, lReg, diagSt_vRegMsk(n),
     I            nStats,sizI1,sizI2,sizJ1,sizJ2,iRun,jRun,
     I            diagSt_regMask(1-OLx,1-OLy,kRegMsk,bi,bj),
     I            maskInC(1-OLx,1-OLy,bi,bj),
     I            hFacC(1-OLx,1-OLy,k,bi,bj), rA(1-OLx,1-OLy,bi,bj),
     I            drLoc, specialVal, exclSpVal, useWeight, myThid )
          ENDIF

         ELSEIF ( useFIZHI .AND.
     &           (parsFld(10:10).EQ.'L' .OR. parsFld(10:10).EQ.'M')
     &          ) THEN
           CALL DIAGSTATS_LM_CALC(
     O            statLoc,
     I            inpFld(sizI1,sizJ1,kIn,biIn,bjIn),
     I            frcFld(sizI1,sizJ1,kFr,biIn,bjIn),
     I            scaleFact, power, useFract, lReg, diagSt_vRegMsk(n),
     I            nStats,sizI1,sizI2,sizJ1,sizJ2,iRun,jRun,
     I            diagSt_regMask(1-OLx,1-OLy,kRegMsk,bi,bj),
     I            maskInC(1-OLx,1-OLy,bi,bj), rA(1-OLx,1-OLy,bi,bj),
     I            specialVal, exclSpVal,
     I            k,bi,bj, parsFld, myThid )
         ELSEIF ( useLand .AND.
     &           (parsFld(10:10).EQ.'G' .OR. parsFld(10:10).EQ.'g')
     &          ) THEN
           CALL DIAGSTATS_G_CALC(
     O            statLoc,
     I            inpFld(sizI1,sizJ1,kIn,biIn,bjIn),
     I            frcFld(sizI1,sizJ1,kFr,biIn,bjIn),
     I            scaleFact, power, useFract, lReg, diagSt_vRegMsk(n),
     I            nStats,sizI1,sizI2,sizJ1,sizJ2,iRun,jRun,
     I            diagSt_regMask(1-OLx,1-OLy,kRegMsk,bi,bj),
     I            rA(1-OLx,1-OLy,bi,bj),
     I            specialVal, exclSpVal,
     I            k,bi,bj, parsFld, myThid )
c        ELSEIF ( parsFld(10:10) .EQ. 'I' ) THEN
c        ELSEIF ( parsFld(10:10) .EQ. '1' ) THEN
         ELSE

          drLoc = 1. _d 0
          IF     ( parsFld(2:2).EQ.'U' ) THEN
           CALL DIAGSTATS_CALC(
     O            statLoc,
     I            inpFld(sizI1,sizJ1,kIn,biIn,bjIn),
     I            frcFld(sizI1,sizJ1,kFr,biIn,bjIn),
     I            scaleFact, power, useFract, lReg, diagSt_vRegMsk(n),
     I            nStats,sizI1,sizI2,sizJ1,sizJ2,iRun,jRun,
     I            diagSt_regMask(1-OLx,1-OLy,kRegMsk,bi,bj),
     I            maskInW(1-OLx,1-OLy,bi,bj),
     I            maskInW(1-OLx,1-OLy,bi,bj),rAw(1-OLx,1-OLy,bi,bj),
     I            drLoc, specialVal, exclSpVal, useWeight, myThid )
          ELSEIF ( parsFld(2:2).EQ.'V' ) THEN
           CALL DIAGSTATS_CALC(
     O            statLoc,
     I            inpFld(sizI1,sizJ1,kIn,biIn,bjIn),
     I            frcFld(sizI1,sizJ1,kFr,biIn,bjIn),
     I            scaleFact, power, useFract, lReg, diagSt_vRegMsk(n),
     I            nStats,sizI1,sizI2,sizJ1,sizJ2,iRun,jRun,
     I            diagSt_regMask(1-OLx,1-OLy,kRegMsk,bi,bj),
     I            maskInS(1-OLx,1-OLy,bi,bj),
     I            maskInS(1-OLx,1-OLy,bi,bj),rAs(1-OLx,1-OLy,bi,bj),
     I            drLoc, specialVal, exclSpVal, useWeight, myThid )
          ELSE
           CALL DIAGSTATS_CALC(
     O            statLoc,
     I            inpFld(sizI1,sizJ1,kIn,biIn,bjIn),
     I            frcFld(sizI1,sizJ1,kFr,biIn,bjIn),
     I            scaleFact, power, useFract, lReg, diagSt_vRegMsk(n),
     I            nStats,sizI1,sizI2,sizJ1,sizJ2,iRun,jRun,
     I            diagSt_regMask(1-OLx,1-OLy,kRegMsk,bi,bj),
     I            maskInC(1-OLx,1-OLy,bi,bj),
     I            maskInC(1-OLx,1-OLy,bi,bj), rA(1-OLx,1-OLy,bi,bj),
     I            drLoc, specialVal, exclSpVal, useWeight, myThid )
          ENDIF

         ENDIF

C     Update cumulative statistics array
         IF ( statLoc(0).GT.0. ) THEN
           IF ( statFld(0,n).LE.0. ) THEN
             statFld(im,n) = statLoc(im)
             statFld(ix,n) = statLoc(ix)
           ELSE
             statFld(im,n) = MIN( statFld(im,n), statLoc(im) )
             statFld(ix,n) = MAX( statFld(ix,n), statLoc(ix) )
           ENDIF
           IF ( bibjFlg.GE.0 ) THEN
            DO i=0,iv
             statFld(i,n) = statFld(i,n) + statLoc(i)
            ENDDO
           ELSE
            DO i=1,iv
             statFld(i,n) = statFld(i,n) + statLoc(i)
            ENDDO
           ENDIF
         ENDIF

C---   processing region "n" ends here.
       ENDIF
      ENDDO

      RETURN
      END

#include "EXF_OPTIONS.h"

CBOP
C     !ROUTINE: EXF_DIAGNOSTICS_INIT
C     !INTERFACE:
      SUBROUTINE EXF_DIAGNOSTICS_INIT( myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE EXF_DIAGNOSTICS_INIT
C     | o Routine to initialize list of all available diagnostics
C     |   for EXF package
C     *==========================================================*
C     \ev
C     !USES:
      IMPLICIT NONE

C     === Global variables ===
#include "EEPARAMS.h"
#include "EXF_PARAM.h"

C     !INPUT/OUTPUT PARAMETERS:
C     === Routine arguments ===
C     myThid ::  my Thread Id number
      INTEGER myThid
CEOP

#ifdef ALLOW_DIAGNOSTICS
C     !LOCAL VARIABLES:
C     === Local variables ===
C     diagNum   :: diagnostics number in the (long) list of available diag.
C     diagName  :: local short name (8c) of a diagnostics
C     diagCode  :: local parser field with characteristics of the diagnostics
C              cf head of S/R DIAGNOSTICS_INIT_EARLY or DIAGNOSTICS_MAIN_INIT
C     diagUnits :: local string (16c): physical units of a diagnostic field
C     diagTitle :: local string (80c): description of field in diagnostic
      INTEGER       diagNum
#ifdef ALLOW_AUTODIFF
      INTEGER       diagMate
#endif
      CHARACTER*8   diagName
      CHARACTER*16  diagCode
      CHARACTER*16  diagUnits
      CHARACTER*(80) diagTitle

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|

      diagName  = 'EXFhs   '
      diagTitle = 'Sensible heat flux into ocean, >0 increases theta'
      diagUnits = 'W/m^2           '
      diagCode  = 'SM      U1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'EXFhl   '
      diagTitle = 'Latent heat flux into ocean, >0 increases theta'
      diagUnits = 'W/m^2           '
      diagCode  = 'SM      U1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'EXFlwnet'
      diagTitle = 'Net upward longwave radiation, >0 decreases theta'
      diagUnits = 'W/m^2           '
      diagCode  = 'SM      U1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'EXFswnet'
      diagTitle = 'Net upward shortwave radiation, >0 decreases theta'
      diagUnits = 'W/m^2           '
      diagCode  = 'SM      U1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'EXFlwdn '
      diagTitle = 'Downward longwave radiation, >0 increases theta'
      diagUnits = 'W/m^2           '
      diagCode  = 'SM      U1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'EXFswdn '
      diagTitle = 'Downward shortwave radiation, >0 increases theta'
      diagUnits = 'W/m^2           '
      diagCode  = 'SM      U1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'EXFqnet '
      diagTitle = 'Net upward heat flux (turb+rad), >0 decreases theta'
      diagUnits = 'W/m^2           '
      diagCode  = 'SM      U1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

C--   surface fluxes:
      diagName  = 'EXFtaux '
      diagTitle = 'zonal surface wind stress, >0 increases uVel    '
      diagUnits = 'N/m^2           '
      IF ( stressIsOnCgrid ) THEN
       diagCode = 'UU      U1      '
      ELSE
       diagCode = 'UM      U1      '
      ENDIF
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'EXFtauy '
      diagTitle = 'meridional surface wind stress, >0 increases vVel'
      diagUnits = 'N/m^2           '
      IF ( stressIsOnCgrid ) THEN
       diagCode = 'VV      U1      '
      ELSE
       diagCode = 'VM      U1      '
      ENDIF
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'EXFuwind'
      diagTitle = 'zonal 10-m wind speed, >0 eastward'
      diagUnits = 'm/s             '
      diagCode  = 'UM      U1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'EXFvwind'
      diagTitle = 'meridional 10-m wind speed, >0 northward'
      diagUnits = 'm/s             '
      diagCode  = 'VM      U1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'EXFurelw'
      diagTitle = 'zonal relative 10-m wind speed, >0 eastward'
      diagUnits = 'm/s             '
      diagCode  = 'UM      U1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'EXFvrelw'
      diagTitle = 'meridional relative 10-m wind speed, >0 northward'
      diagUnits = 'm/s             '
      diagCode  = 'VM      U1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'EXFwspee'
      diagTitle = '10-m wind speed modulus ( >= 0 )'
      diagUnits = 'm/s             '
      diagCode  = 'SM      U1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'EXFatemp'
      diagTitle = 'surface (2-m) air temperature'
      diagUnits = 'degK            '
      diagCode  = 'SM      U1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'EXFaqh  '
      diagTitle = 'surface (2-m) specific humidity'
      diagUnits = 'kg/kg           '
      diagCode  = 'SM      U1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'EXFevap '
      diagTitle = 'evaporation, > 0 increases salinity'
      diagUnits = 'm/s             '
      diagCode  = 'SM      U1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'EXFpreci'
      diagTitle = 'precipitation, > 0 decreases salinity'
      diagUnits = 'm/s             '
      diagCode  = 'SM      U1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'EXFsnow '
      diagTitle = 'snow precipitation, > 0 decreases salinity'
      diagUnits = 'm/s             '
      diagCode  = 'SM      U1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'EXFempmr'
      diagTitle = 'net upward freshwater flux, > 0 increases salinity'
      diagUnits = 'm/s             '
      diagCode  = 'SM      U1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'EXFpress'
      diagTitle = 'atmospheric pressure field'
      diagUnits = 'N/m^2           '
      diagCode  = 'SM      U1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'EXFroff '
      diagTitle = 'river runoff, > 0 decreases salinity'
      diagUnits = 'm/s             '
      diagCode  = 'SM      U1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'EXFroft '
      diagTitle = 'river runoff temperature'
      diagUnits = 'deg C           '
      diagCode  = 'SM      U1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'EXFsalfx'
      diagTitle = 'upward salt flux, > 0 decreases salinity'
      diagUnits = 'g/m^2/s         '
      diagCode  = 'SM      U1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

#ifdef ALLOW_AUTODIFF
C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
C     Adjoint state variables
      diagName  = 'ADJustrs'
      diagTitle = 'dJ/dustress: Senstivity to zonal surface wind stress'
      diagUnits = 'dJ/(N/m^2)      '
      IF ( stressIsOnCgrid ) THEN
       diagCode = 'UU A    U1      '
      ELSE
       diagCode = 'UM A    U1      '
      ENDIF
      diagMate  = diagNum + 2
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I   diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

      diagName  = 'ADJvstrs'
      diagTitle = 'dJ/dvstrs: Sensitivity to merid. surface wind stress'
      diagUnits = 'dJ/(N/m^2)      '
      IF ( stressIsOnCgrid ) THEN
       diagCode = 'VV A    U1      '
      ELSE
       diagCode = 'VM A    U1      '
      ENDIF
      diagMate  = diagNum
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I   diagName, diagCode, diagUnits, diagTitle, diagMate, myThid )

      diagName  = 'ADJhflux'
      diagTitle = 'dJ/dhflux: Sensitivity to upward heat flux'
      diagUnits = 'dJ/(W/m^2)      '
      diagCode  = 'SM A    U1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'ADJsflux'
      diagTitle = 'dJ/dhflux: Sensitivity to upward fresh water flux'
      diagUnits = 'dJ/(m/s)        '
      diagCode  = 'SM A    U1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'ADJatemp'
      diagTitle = 'dJ/datemp: Sensitivity to atmos. surface temperature'
      diagUnits = 'dJ/K            '
      diagCode  = 'SM A    U1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'ADJpreci'
      diagTitle = 'dJ/daqh: Sensitivity to precipitation'
      diagUnits = 'dJ/(m/s)        '
      diagCode  = 'SM A    U1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'ADJroff '
      diagTitle = 'dJ/daqh: Sensitivity to river runoff'
      diagUnits = 'dJ/(m/s)        '
      diagCode  = 'SM A    U1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'ADJswdn '
      diagTitle = 'dJ/dswdown: Sensitivity to downward SW radiation'
      diagUnits = 'dJ/(W/m^2)      '
      diagCode  = 'SM A    U1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'ADJlwdn '
      diagTitle = 'dJ/dlwdown: Sensitivity to downward LW radiation'
      diagUnits = 'dJ/(W/m^2)      '
      diagCode  = 'SM A    U1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'ADJuwind'
      diagTitle = 'dJ/duwind: Senstivity to zonal 10-m wind speed'
      diagUnits = 'dJ/d(m/s)       '
      diagCode  = 'UM A    U1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'ADJvwind'
      diagTitle = 'dJ/dvwind: Senstivity to meridional 10-m wind speed'
      diagUnits = 'dJ/d(m/s)       '
      diagCode  = 'VM A    U1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I          diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'ADJclsst'
      diagTitle = 'dJ/dclimsst: Sensitivity to restoring SST'
      diagUnits = 'dJ/K            '
      diagCode  = 'SM A    U1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

      diagName  = 'ADJclsss'
      diagTitle = 'dJ/dclimsss: Sensitivity to restoring SSS'
      diagUnits = 'dJ/(g/kg)       '
      diagCode  = 'SM A    U1      '
      CALL DIAGNOSTICS_ADDTOLIST( diagNum,
     I     diagName, diagCode, diagUnits, diagTitle, 0, myThid )

#endif /* ALLOW_AUTODIFF */
#endif /* ALLOW_DIAGNOSTICS */

      RETURN
      END

#include "PACKAGES_CONFIG.h"
#include "CPP_OPTIONS.h"

CBOP
C     !ROUTINE: INI_THETA
C     !INTERFACE:
      SUBROUTINE INI_THETA( myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | SUBROUTINE INI_THETA
C     | o Set model initial temperature field.
C     *==========================================================*
C     | There are several options for setting the initial
C     | temperature file
C     |  1. Inline code
C     |  2. Vertical profile ( uniform T in X and Y )
C     |  3. Three-dimensional data from a file. For example from
C     |     Levitus or from a checkpoint file from a previous
C     |     integration.
C     | In addition to setting the temperature field we also
C     | set the initial temperature tendency term here.
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE

C     === Global variables ===
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "DYNVARS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     myThid -  Number of this instance of INI_THETA
      INTEGER myThid

C     == Functions ==
c     real*8  PORT_RAND
c     real*8  seed

C     !LOCAL VARIABLES:
C     == Local variables ==
C     bi,bj  - Loop counters
C     I,J,K
      INTEGER bi, bj
      INTEGER I, J, K, localWarnings
      _RL     term1,term2,thetaLim,thetaEq
      CHARACTER*(MAX_LEN_MBUF) msgBuf
CEOP

      J = 99+myBxLo(myThid)+nPx*myByLo(myThid)
c     CALL SRAND( J )
c     seed = j

      IF ( hydrogThetaFile .EQ. ' ' ) THEN
C--    Initialise temperature field to Held & Saurez equilibrium theta
       DO bj = myByLo(myThid), myByHi(myThid)
        DO bi = myBxLo(myThid), myBxHi(myThid)
         DO K=1,Nr
          thetaLim = 200. _d 0/((rC(K)/atm_po)**atm_kappa)
          DO J=1,sNy
           DO I=1,sNx
            term1=60. _d 0*(sin(yC(I,J,bi,bj)*deg2rad)**2)
            term2=10. _d 0*log((rC(K)/atm_po))
     &              *(cos(yC(I,J,bi,bj)*deg2rad)**2)
            thetaEq=315. _d 0-term1-term2
            theta(I,J,K,bi,bj) = MAX( thetaLim, thetaEq )
c    &                          + 0.01*(RAND()-0.5)
c    &                          + 0.01*(PORT_RAND(seed)-0.5)
c           theta(I,J,K,bi,bj) = tRef(K)
           ENDDO
          ENDDO
         ENDDO
#ifdef ALLOW_ZONAL_FILT
C--   Zonal FFT filter initial conditions
         IF (useZONAL_FILT) THEN
          CALL ZONAL_FILTER(
     U                       theta(1-OLx,1-OLy,1,bi,bj),
     I                       hFacC(1-OLx,1-OLy,1,bi,bj),
     I                       1, sNy, Nr, bi, bj, 1, myThid )
         ENDIF
#endif /* ALLOW_ZONAL_FILT */
        ENDDO
       ENDDO
      ELSE
       CALL READ_FLD_XYZ_RL( hydrogThetaFile, ' ', theta, 0, myThid )
      ENDIF
C--   Apply mask and test consistency
      localWarnings=0
      DO bj = myByLo(myThid), myByHi(myThid)
       DO bi = myBxLo(myThid), myBxHi(myThid)
        DO K=1,Nr
         DO J=1-Oly,sNy+Oly
          DO I=1-Olx,sNx+Olx
           IF (maskC(I,J,K,bi,bj).EQ.0.) theta(I,J,K,bi,bj) = 0.
          ENDDO
         ENDDO
         IF ( tRef(k).NE.0. ) THEN
          DO J=1,sNy
           DO I=1,sNx
            IF (  maskC(I,J,K,bi,bj).NE.0.
     &      .AND. theta(I,J,K,bi,bj).EQ.0. ) THEN
              localWarnings=localWarnings+1
            ENDIF
           ENDDO
          ENDDO
         ENDIF
        ENDDO
       ENDDO
      ENDDO
      IF (localWarnings.NE.0) THEN
       WRITE(msgBuf,'(A,A)')
     &  'S/R INI_THETA: theta = 0 identically. If this is intentional',
     &  'you will need to edit ini_theta.F to avoid this safety check'
       CALL PRINT_ERROR( msgBuf , myThid)
       STOP 'ABNORMAL END: S/R INI_THETA'
      ENDIF

      _EXCH_XYZ_RL(theta , myThid )

      IF (debugMode) THEN
        CALL PLOT_FIELD_XYZRL( theta, 'Initial Temperature' ,
     &                         Nr, 1, myThid )
      ENDIF

      RETURN
      END

#include "PACKAGES_CONFIG.h"
#include "CPP_OPTIONS.h"

C--  File external_forcing.F:
C--   Contents
C--   o EXTERNAL_FORCING_U
C--   o EXTERNAL_FORCING_V
C--   o EXTERNAL_FORCING_T
C--   o EXTERNAL_FORCING_S

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: EXTERNAL_FORCING_U
C     !INTERFACE:
      SUBROUTINE EXTERNAL_FORCING_U(
     I           iMin,iMax, jMin,jMax, bi,bj, kLev,
     I           myTime, myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R EXTERNAL_FORCING_U
C     | o Contains problem specific forcing for zonal velocity.
C     *==========================================================*
C     | Adds terms to gU for forcing by external sources
C     | e.g. wind stress, bottom friction etc ...
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     == Global data ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "DYNVARS.h"
#include "FFIELDS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     iMin,iMax :: Working range of x-index for applying forcing.
C     jMin,jMax :: Working range of y-index for applying forcing.
C     bi,bj     :: Current tile indices
C     kLev      :: Current vertical level index
C     myTime    :: Current time in simulation
C     myThid    :: Thread Id number
      INTEGER iMin, iMax, jMin, jMax, kLev, bi, bj
      _RL myTime
      INTEGER myThid

#ifdef USE_OLD_EXTERNAL_FORCING
C     !LOCAL VARIABLES:
C     == Local variables ==
C     i,j       :: Loop counters
C     kSurface  :: index of surface level
      INTEGER i, j
      INTEGER kSurface
CEOP

      IF ( fluidIsAir ) THEN
       kSurface = 0
      ELSEIF ( usingPCoords ) THEN
       kSurface = Nr
      ELSE
       kSurface = 1
      ENDIF

C--   Forcing term
#ifdef ALLOW_AIM
      IF ( useAIM ) CALL AIM_TENDENCY_APPLY_U(
     U                       gU(1-OLx,1-OLy,kLev,bi,bj),
     I                       iMin,iMax,jMin,jMax, kLev, bi,bj,
     I                       myTime, 0, myThid )
#endif /* ALLOW_AIM */

#ifdef ALLOW_ATM_PHYS
      IF ( useAtm_Phys ) CALL ATM_PHYS_TENDENCY_APPLY_U(
     U                       gU(1-OLx,1-OLy,kLev,bi,bj),
     I                       iMin,iMax,jMin,jMax, kLev, bi,bj,
     I                       myTime, 0, myThid )
#endif /* ALLOW_ATM_PHYS */

#ifdef ALLOW_FIZHI
      IF ( useFIZHI ) CALL FIZHI_TENDENCY_APPLY_U(
     U                       gU(1-OLx,1-OLy,kLev,bi,bj),
     I                       iMin,iMax,jMin,jMax, kLev, bi,bj,
     I                       myTime, 0, myThid )
#endif /* ALLOW_FIZHI */

C     Ocean: Add momentum surface forcing (e.g., wind-stress) in surface level
      IF ( kLev .EQ. kSurface ) THEN
c      DO j=1,sNy
C-jmc: Without CD-scheme, this is OK ; but with CD-scheme, needs to cover [0:sNy+1]
       DO j=0,sNy+1
        DO i=1,sNx+1
          gU(i,j,kLev,bi,bj) = gU(i,j,kLev,bi,bj)
     &      +foFacMom*surfaceForcingU(i,j,bi,bj)
     &      *recip_drF(kLev)*_recip_hFacW(i,j,kLev,bi,bj)
        ENDDO
       ENDDO
      ELSEIF ( kSurface.EQ.-1 ) THEN
       DO j=0,sNy+1
        DO i=1,sNx+1
         IF ( kSurfW(i,j,bi,bj).EQ.kLev ) THEN
          gU(i,j,kLev,bi,bj) = gU(i,j,kLev,bi,bj)
     &      +foFacMom*surfaceForcingU(i,j,bi,bj)
     &      *recip_drF(kLev)*_recip_hFacW(i,j,kLev,bi,bj)
         ENDIF
        ENDDO
       ENDDO
      ENDIF

#ifdef ALLOW_EDDYPSI
         CALL TAUEDDY_TENDENCY_APPLY_U(
     U                 gU(1-OLx,1-OLy,kLev,bi,bj),
     I                 iMin,iMax,jMin,jMax, kLev, bi,bj,
     I                 myTime, 0, myThid )
#endif

#ifdef ALLOW_RBCS
      IF (useRBCS) THEN
        CALL RBCS_ADD_TENDENCY(
     U                 gU(1-OLx,1-OLy,kLev,bi,bj),
     I                 kLev, bi, bj, -1,
     I                 myTime, 0, myThid )

      ENDIF
#endif /* ALLOW_RBCS */

#ifdef ALLOW_OBCS
      IF (useOBCS) THEN
        CALL OBCS_SPONGE_U(
     U                   gU(1-OLx,1-OLy,kLev,bi,bj),
     I                   iMin,iMax,jMin,jMax, kLev, bi,bj,
     I                   myTime, 0, myThid )
      ENDIF
#endif /* ALLOW_OBCS */

#ifdef ALLOW_MYPACKAGE
      IF ( useMYPACKAGE ) THEN
        CALL MYPACKAGE_TENDENCY_APPLY_U(
     U                 gU(1-OLx,1-OLy,kLev,bi,bj),
     I                 iMin,iMax,jMin,jMax, kLev, bi,bj,
     I                 myTime, 0, myThid )
      ENDIF
#endif /* ALLOW_MYPACKAGE */

#endif /* USE_OLD_EXTERNAL_FORCING */
      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: EXTERNAL_FORCING_V
C     !INTERFACE:
      SUBROUTINE EXTERNAL_FORCING_V(
     I           iMin,iMax, jMin,jMax, bi,bj, kLev,
     I           myTime, myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R EXTERNAL_FORCING_V
C     | o Contains problem specific forcing for merid velocity.
C     *==========================================================*
C     | Adds terms to gV for forcing by external sources
C     | e.g. wind stress, bottom friction etc ...
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     == Global data ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "DYNVARS.h"
#include "FFIELDS.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     iMin,iMax :: Working range of x-index for applying forcing.
C     jMin,jMax :: Working range of y-index for applying forcing.
C     bi,bj     :: Current tile indices
C     kLev      :: Current vertical level index
C     myTime    :: Current time in simulation
C     myThid    :: Thread Id number
      INTEGER iMin, iMax, jMin, jMax, kLev, bi, bj
      _RL myTime
      INTEGER myThid

#ifdef USE_OLD_EXTERNAL_FORCING
C     !LOCAL VARIABLES:
C     == Local variables ==
C     i,j       :: Loop counters
C     kSurface  :: index of surface level
      INTEGER i, j
      INTEGER kSurface
CEOP

      IF ( fluidIsAir ) THEN
       kSurface = 0
      ELSEIF ( usingPCoords ) THEN
       kSurface = Nr
      ELSE
       kSurface = 1
      ENDIF

C--   Forcing term
#ifdef ALLOW_AIM
      IF ( useAIM ) CALL AIM_TENDENCY_APPLY_V(
     U                       gV(1-OLx,1-OLy,kLev,bi,bj),
     I                       iMin,iMax,jMin,jMax, kLev, bi,bj,
     I                       myTime, 0, myThid )
#endif /* ALLOW_AIM */

#ifdef ALLOW_ATM_PHYS
      IF ( useAtm_Phys ) CALL ATM_PHYS_TENDENCY_APPLY_V(
     U                       gV(1-OLx,1-OLy,kLev,bi,bj),
     I                       iMin,iMax,jMin,jMax, kLev, bi,bj,
     I                       myTime, 0, myThid )
#endif /* ALLOW_ATM_PHYS */

#ifdef ALLOW_FIZHI
      IF ( useFIZHI ) CALL FIZHI_TENDENCY_APPLY_V(
     U                       gV(1-OLx,1-OLy,kLev,bi,bj),
     I                       iMin,iMax,jMin,jMax, kLev, bi,bj,
     I                       myTime, 0, myThid )
#endif /* ALLOW_FIZHI */

C     Ocean: Add momentum surface forcing (e.g., wind-stress) in surface level
      IF ( kLev .EQ. kSurface ) THEN
       DO j=1,sNy+1
c       DO i=1,sNx
C-jmc: Without CD-scheme, this is OK ; but with CD-scheme, needs to cover [0:sNx+1]
        DO i=0,sNx+1
          gV(i,j,kLev,bi,bj) = gV(i,j,kLev,bi,bj)
     &      +foFacMom*surfaceForcingV(i,j,bi,bj)
     &      *recip_drF(kLev)*_recip_hFacS(i,j,kLev,bi,bj)
        ENDDO
       ENDDO
      ELSEIF ( kSurface.EQ.-1 ) THEN
       DO j=1,sNy+1
        DO i=0,sNx+1
         IF ( kSurfS(i,j,bi,bj).EQ.kLev ) THEN
          gV(i,j,kLev,bi,bj) = gV(i,j,kLev,bi,bj)
     &      +foFacMom*surfaceForcingV(i,j,bi,bj)
     &      *recip_drF(kLev)*_recip_hFacS(i,j,kLev,bi,bj)
         ENDIF
        ENDDO
       ENDDO
      ENDIF

#ifdef ALLOW_EDDYPSI
         CALL TAUEDDY_TENDENCY_APPLY_V(
     U                 gV(1-OLx,1-OLy,kLev,bi,bj),
     I                 iMin,iMax,jMin,jMax, kLev, bi,bj,
     I                 myTime, 0, myThid )
#endif

#ifdef ALLOW_RBCS
      IF (useRBCS) THEN
        CALL RBCS_ADD_TENDENCY(
     U                 gV(1-OLx,1-OLy,kLev,bi,bj),
     I                 kLev, bi, bj, -2,
     I                 myTime, 0, myThid )
      ENDIF
#endif /* ALLOW_RBCS */

#ifdef ALLOW_OBCS
      IF (useOBCS) THEN
        CALL OBCS_SPONGE_V(
     U                   gV(1-OLx,1-OLy,kLev,bi,bj),
     I                   iMin,iMax,jMin,jMax, kLev, bi,bj,
     I                   myTime, 0, myThid )
      ENDIF
#endif /* ALLOW_OBCS */

#ifdef ALLOW_MYPACKAGE
      IF ( useMYPACKAGE ) THEN
        CALL MYPACKAGE_TENDENCY_APPLY_V(
     U                 gV(1-OLx,1-OLy,kLev,bi,bj),
     I                 iMin,iMax,jMin,jMax, kLev, bi,bj,
     I                 myTime, 0, myThid )
      ENDIF
#endif /* ALLOW_MYPACKAGE */

#endif /* USE_OLD_EXTERNAL_FORCING */
      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: EXTERNAL_FORCING_T
C     !INTERFACE:
      SUBROUTINE EXTERNAL_FORCING_T(
     I           iMin,iMax, jMin,jMax, bi,bj, kLev,
     I           myTime, myThid )
C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R EXTERNAL_FORCING_T
C     | o Contains problem specific forcing for temperature.
C     *==========================================================*
C     | Adds terms to gT for forcing by external sources
C     | e.g. heat flux, climatalogical relaxation, etc ...
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     == Global data ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "DYNVARS.h"
#include "FFIELDS.h"
#include "SURFACE.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     iMin,iMax :: Working range of x-index for applying forcing.
C     jMin,jMax :: Working range of y-index for applying forcing.
C     bi,bj     :: Current tile indices
C     kLev      :: Current vertical level index
C     myTime    :: Current time in simulation
C     myThid    :: Thread Id number
      INTEGER iMin, iMax, jMin, jMax, kLev, bi, bj
      _RL myTime
      INTEGER myThid

#ifdef USE_OLD_EXTERNAL_FORCING
C     !LOCAL VARIABLES:
C     == Local variables ==
C     i,j       :: Loop counters
C     kSurface  :: index of surface level
      INTEGER i, j
      INTEGER kSurface
      INTEGER km, kc, kp
      _RL tmpVar(1:sNx,1:sNy)
      _RL tmpFac, delPI
      _RL recip_Cp
CEOP
#ifdef SHORTWAVE_HEATING
      _RL minusone
      PARAMETER (minusOne=-1.)
      _RL swfracb(2)
      INTEGER kp1
#endif

      IF ( fluidIsAir ) THEN
       kSurface = 0
      ELSEIF ( usingZCoords .AND. useShelfIce ) THEN
       kSurface = -1
      ELSEIF ( usingPCoords ) THEN
       kSurface = Nr
      ELSE
       kSurface = 1
      ENDIF
      recip_Cp = 1. _d 0 / HeatCapacity_Cp

C--   Forcing term
#ifdef ALLOW_AIM
      IF ( useAIM ) CALL AIM_TENDENCY_APPLY_T(
     U                       gT(1-OLx,1-OLy,kLev,bi,bj),
     I                       iMin,iMax,jMin,jMax, kLev, bi,bj,
     I                       myTime, 0, myThid )
#endif /* ALLOW_AIM */

#ifdef ALLOW_ATM_PHYS
      IF ( useAtm_Phys ) CALL ATM_PHYS_TENDENCY_APPLY_T(
     U                       gT(1-OLx,1-OLy,kLev,bi,bj),
     I                       iMin,iMax,jMin,jMax, kLev, bi,bj,
     I                       myTime, 0, myThid )
#endif /* ALLOW_ATM_PHYS */

#ifdef ALLOW_FIZHI
      IF ( useFIZHI ) CALL FIZHI_TENDENCY_APPLY_T(
     U                       gT(1-OLx,1-OLy,kLev,bi,bj),
     I                       iMin,iMax,jMin,jMax, kLev, bi,bj,
     I                       myTime, 0, myThid )
#endif /* ALLOW_FIZHI */

#ifdef ALLOW_ADDFLUID
      IF ( selectAddFluid.NE.0 .AND. temp_addMass.NE.UNSET_RL ) THEN
       IF ( ( selectAddFluid.GE.1 .AND. nonlinFreeSurf.GT.0 )
     &      .OR. convertFW2Salt.EQ.-1. _d 0 ) THEN
         DO j=1,sNy
          DO i=1,sNx
            gT(i,j,kLev,bi,bj) = gT(i,j,kLev,bi,bj)
     &        + addMass(i,j,kLev,bi,bj)*mass2rUnit
     &          *( temp_addMass - theta(i,j,kLev,bi,bj) )
     &          *recip_rA(i,j,bi,bj)
     &          *recip_drF(kLev)*_recip_hFacC(i,j,kLev,bi,bj)
C    &          *recip_deepFac2C(kLev)*recip_rhoFacC(kLev)
          ENDDO
         ENDDO
       ELSE
         DO j=1,sNy
          DO i=1,sNx
            gT(i,j,kLev,bi,bj) = gT(i,j,kLev,bi,bj)
     &        + addMass(i,j,kLev,bi,bj)*mass2rUnit
     &          *( temp_addMass - tRef(kLev) )
     &          *recip_rA(i,j,bi,bj)
     &          *recip_drF(kLev)*_recip_hFacC(i,j,kLev,bi,bj)
C    &          *recip_deepFac2C(kLev)*recip_rhoFacC(kLev)
          ENDDO
         ENDDO
       ENDIF
      ENDIF
#endif /* ALLOW_ADDFLUID */

#ifdef ALLOW_FRICTION_HEATING
      IF ( addFrictionHeating ) THEN
        IF ( fluidIsAir ) THEN
C         conversion from in-situ Temp to Pot.Temp
          tmpFac = (atm_Po/rC(kLev))**atm_kappa
C         conversion from W/m^2/r_unit to K/s
          tmpFac = (tmpFac/atm_Cp) * mass2rUnit
        ELSE
C         conversion from W/m^2/r_unit to K/s
          tmpFac = recip_Cp * mass2rUnit
        ENDIF
        DO j=1,sNy
          DO i=1,sNx
            gT(i,j,kLev,bi,bj) = gT(i,j,kLev,bi,bj)
     &         + frictionHeating(i,j,k,bi,bj)*tmpFac
     &          *recip_drF(kLev)*_recip_hFacC(i,j,kLev,bi,bj)
          ENDDO
        ENDDO
      ENDIF
#endif /* ALLOW_FRICTION_HEATING */

      IF ( fluidIsAir .AND. atm_Rq.NE.zeroRL .AND. Nr.NE.1 ) THEN
C--   Compressible fluid: account for difference between moist and dry air
C     specific volume in Enthalpy equation (+ V.dP term), since only the
C     dry air part is accounted for in the (dry) Pot.Temp formulation.
C     Used centered averaging from interface to center (consistent with
C     conversion term in KE eq) and same discretisation ( [T*Q]_bar_k )
C     as for Theta_v in CALC_PHI_HYD

C     conversion from in-situ Temp to Pot.Temp
        tmpFac = (atm_Po/rC(kLev))**atm_kappa
C     conversion from W/kg to K/s
        tmpFac = tmpFac/atm_Cp
        km = kLev-1
        kc = kLev
        kp = kLev+1
        IF ( kLev.EQ.1 ) THEN
          DO j=1,sNy
           DO i=1,sNx
            tmpVar(i,j) = 0.
           ENDDO
          ENDDO
        ELSE
          delPI = atm_Cp*( (rC(km)/atm_Po)**atm_kappa
     &                   - (rC(kc)/atm_Po)**atm_kappa )
          DO j=1,sNy
           DO i=1,sNx
            tmpVar(i,j) = wVel(i,j,kc,bi,bj)*delPI*atm_Rq
     &                  *( theta(i,j,km,bi,bj)*salt(i,j,km,bi,bj)
     &                   + theta(i,j,kc,bi,bj)*salt(i,j,kc,bi,bj)
     &                   )*maskC(i,j,km,bi,bj)*0.25 _d 0
           ENDDO
          ENDDO
        ENDIF
        IF ( kLev.LT.Nr ) THEN
          delPI = atm_Cp*( (rC(kc)/atm_Po)**atm_kappa
     &                   - (rC(kp)/atm_Po)**atm_kappa )
          DO j=1,sNy
           DO i=1,sNx
            tmpVar(i,j) = tmpVar(i,j)
     &                  + wVel(i,j,kp,bi,bj)*delPI*atm_Rq
     &                  *( theta(i,j,kc,bi,bj)*salt(i,j,kc,bi,bj)
     &                   + theta(i,j,kp,bi,bj)*salt(i,j,kp,bi,bj)
     &                   )*maskC(i,j,kp,bi,bj)*0.25 _d 0
           ENDDO
          ENDDO
        ENDIF
        DO j=1,sNy
          DO i=1,sNx
            gT(i,j,kLev,bi,bj) = gT(i,j,kLev,bi,bj)
     &         + tmpVar(i,j)*tmpFac
     &          *recip_drF(kLev)*_recip_hFacC(i,j,kLev,bi,bj)
          ENDDO
        ENDDO
#ifdef ALLOW_DIAGNOSTICS
        IF ( useDiagnostics ) THEN
C     conversion to W/m^2
          tmpFac = rUnit2mass
          CALL DIAGNOSTICS_SCALE_FILL( tmpVar, tmpFac, 1,
     &                     'MoistCor', kc, 1, 3, bi,bj,myThid )
        ENDIF
#endif /* ALLOW_DIAGNOSTICS */
      ENDIF

C     Ocean: Add temperature surface forcing (e.g., heat-flux) in surface level
      IF ( kLev .EQ. kSurface ) THEN
       DO j=1,sNy
        DO i=1,sNx
          gT(i,j,kLev,bi,bj)=gT(i,j,kLev,bi,bj)
     &      +surfaceForcingT(i,j,bi,bj)
     &      *recip_drF(kLev)*_recip_hFacC(i,j,kLev,bi,bj)
        ENDDO
       ENDDO
      ELSEIF ( kSurface.EQ.-1 ) THEN
       DO j=1,sNy
        DO i=1,sNx
         IF ( kSurfC(i,j,bi,bj).EQ.kLev ) THEN
          gT(i,j,kLev,bi,bj)=gT(i,j,kLev,bi,bj)
     &      +surfaceForcingT(i,j,bi,bj)
     &      *recip_drF(kLev)*_recip_hFacC(i,j,kLev,bi,bj)
         ENDIF
        ENDDO
       ENDDO
      ENDIF

      IF (linFSConserveTr) THEN
       DO j=1,sNy
        DO i=1,sNx
          IF (kLev .EQ. kSurfC(i,j,bi,bj)) THEN
            gT(i,j,kLev,bi,bj)=gT(i,j,kLev,bi,bj)
     &        +TsurfCor*recip_drF(kLev)*_recip_hFacC(i,j,kLev,bi,bj)
          ENDIF
        ENDDO
       ENDDO
      ENDIF

#ifdef SHORTWAVE_HEATING
C Penetrating SW radiation
c     IF ( usePenetratingSW ) THEN
       swfracb(1)=abs(rF(kLev))
       swfracb(2)=abs(rF(kLev+1))
       CALL SWFRAC(
     I             2, minusOne,
     U             swfracb,
     I             myTime, 1, myThid )
       kp1 = kLev+1
       IF (kLev.EQ.Nr) THEN
        kp1 = kLev
        swfracb(2)=0. _d 0
       ENDIF
       DO j=1,sNy
        DO i=1,sNx
         gT(i,j,kLev,bi,bj) = gT(i,j,kLev,bi,bj)
     &   -Qsw(i,j,bi,bj)*(swfracb(1)*maskC(i,j,kLev,bi,bj)
     &                   -swfracb(2)*maskC(i,j,kp1, bi,bj))
     &    *recip_Cp*mass2rUnit
     &    *recip_drF(kLev)*_recip_hFacC(i,j,kLev,bi,bj)
        ENDDO
       ENDDO
c     ENDIF
#endif

#ifdef ALLOW_FRAZIL
      IF ( useFRAZIL )
     &     CALL FRAZIL_TENDENCY_APPLY_T(
     U                 gT(1-OLx,1-OLy,kLev,bi,bj),
     I                 iMin,iMax,jMin,jMax, kLev, bi,bj,
     I                 myTime, 0, myThid )
#endif /* ALLOW_FRAZIL */

#ifdef ALLOW_SHELFICE
      IF ( useShelfIce )
     &     CALL SHELFICE_FORCING_T(
     U                   gT(1-OLx,1-OLy,kLev,bi,bj),
     I                   iMin,iMax,jMin,jMax, kLev, bi,bj,
     I                   myTime, 0, myThid )
#endif /* ALLOW_SHELFICE */

#ifdef ALLOW_ICEFRONT
      IF ( useICEFRONT )
     &     CALL ICEFRONT_TENDENCY_APPLY_T(
     U                   gT(1-OLx,1-OLy,kLev,bi,bj),
     I                   kLev, bi, bj, myTime, 0, myThid )
#endif /* ALLOW_ICEFRONT */

#ifdef ALLOW_SALT_PLUME
      IF ( useSALT_PLUME )
     &     CALL SALT_PLUME_TENDENCY_APPLY_T(
     U                     gT(1-OLx,1-OLy,kLev,bi,bj),
     I                     iMin,iMax,jMin,jMax, kLev, bi,bj,
     I                     myTime, 0, myThid )
#endif /* ALLOW_SALT_PLUME */

#ifdef ALLOW_RBCS
      IF (useRBCS) THEN
        CALL RBCS_ADD_TENDENCY(
     U                 gT(1-OLx,1-OLy,kLev,bi,bj),
     I                 kLev, bi, bj, 1,
     I                 myTime, 0, myThid )
      ENDIF
#endif /* ALLOW_RBCS */

#ifdef ALLOW_OBCS
      IF (useOBCS) THEN
        CALL OBCS_SPONGE_T(
     U                   gT(1-OLx,1-OLy,kLev,bi,bj),
     I                   iMin,iMax,jMin,jMax, kLev, bi,bj,
     I                   myTime, 0, myThid )
      ENDIF
#endif /* ALLOW_OBCS */

#ifdef ALLOW_BBL
      IF ( useBBL ) CALL BBL_TENDENCY_APPLY_T(
     U                       gT(1-OLx,1-OLy,kLev,bi,bj),
     I                       iMin,iMax,jMin,jMax, kLev, bi,bj,
     I                       myTime, 0, myThid )
#endif /* ALLOW_BBL */

#ifdef ALLOW_MYPACKAGE
      IF ( useMYPACKAGE ) THEN
        CALL MYPACKAGE_TENDENCY_APPLY_T(
     U                 gT(1-OLx,1-OLy,kLev,bi,bj),
     I                 iMin,iMax,jMin,jMax, kLev, bi,bj,
     I                 myTime, 0, myThid )
      ENDIF
#endif /* ALLOW_MYPACKAGE */

#endif /* USE_OLD_EXTERNAL_FORCING */
      RETURN
      END

C---+----1----+----2----+----3----+----4----+----5----+----6----+----7-|--+----|
CBOP
C     !ROUTINE: EXTERNAL_FORCING_S
C     !INTERFACE:
      SUBROUTINE EXTERNAL_FORCING_S(
     I           iMin,iMax, jMin,jMax, bi,bj, kLev,
     I           myTime, myThid )

C     !DESCRIPTION: \bv
C     *==========================================================*
C     | S/R EXTERNAL_FORCING_S
C     | o Contains problem specific forcing for merid velocity.
C     *==========================================================*
C     | Adds terms to gS for forcing by external sources
C     | e.g. fresh-water flux, climatalogical relaxation, etc ...
C     *==========================================================*
C     \ev

C     !USES:
      IMPLICIT NONE
C     == Global data ==
#include "SIZE.h"
#include "EEPARAMS.h"
#include "PARAMS.h"
#include "GRID.h"
#include "DYNVARS.h"
#include "FFIELDS.h"
#include "SURFACE.h"

C     !INPUT/OUTPUT PARAMETERS:
C     == Routine arguments ==
C     iMin,iMax :: Working range of x-index for applying forcing.
C     jMin,jMax :: Working range of y-index for applying forcing.
C     bi,bj     :: Current tile indices
C     kLev      :: Current vertical level index
C     myTime    :: Current time in simulation
C     myThid    :: Thread Id number
      INTEGER iMin, iMax, jMin, jMax, kLev, bi, bj
      _RL myTime
      INTEGER myThid

#ifdef USE_OLD_EXTERNAL_FORCING
C     !LOCAL VARIABLES:
C     == Local variables ==
C     i,j       :: Loop counters
C     kSurface  :: index of surface level
      INTEGER i, j
      INTEGER kSurface
CEOP

      IF ( fluidIsAir ) THEN
       kSurface = 0
      ELSEIF ( usingZCoords .AND. useShelfIce ) THEN
       kSurface = -1
      ELSEIF ( usingPCoords ) THEN
       kSurface = Nr
      ELSE
       kSurface = 1
      ENDIF

C--   Forcing term
#ifdef ALLOW_AIM
      IF ( useAIM ) CALL AIM_TENDENCY_APPLY_S(
     U                       gS(1-OLx,1-OLy,kLev,bi,bj),
     I                       iMin,iMax,jMin,jMax, kLev, bi,bj,
     I                       myTime, 0, myThid )
#endif /* ALLOW_AIM */

#ifdef ALLOW_ATM_PHYS
      IF ( useAtm_Phys ) CALL ATM_PHYS_TENDENCY_APPLY_S(
     U                       gS(1-OLx,1-OLy,kLev,bi,bj),
     I                       iMin,iMax,jMin,jMax, kLev, bi,bj,
     I                       myTime, 0, myThid )
#endif /* ALLOW_ATM_PHYS */

#ifdef ALLOW_FIZHI
      IF ( useFIZHI ) CALL FIZHI_TENDENCY_APPLY_S(
     U                       gS(1-OLx,1-OLy,kLev,bi,bj),
     I                       iMin,iMax,jMin,jMax, kLev, bi,bj,
     I                       myTime, 0, myThid )
#endif /* ALLOW_FIZHI */

#ifdef ALLOW_ADDFLUID
      IF ( selectAddFluid.NE.0 .AND. salt_addMass.NE.UNSET_RL ) THEN
       IF ( ( selectAddFluid.GE.1 .AND. nonlinFreeSurf.GT.0 )
     &      .OR. convertFW2Salt.EQ.-1. _d 0 ) THEN
         DO j=1,sNy
          DO i=1,sNx
            gS(i,j,kLev,bi,bj) = gS(i,j,kLev,bi,bj)
     &        + addMass(i,j,kLev,bi,bj)*mass2rUnit
     &          *( salt_addMass - salt(i,j,kLev,bi,bj) )
     &          *recip_rA(i,j,bi,bj)
     &          *recip_drF(kLev)*_recip_hFacC(i,j,kLev,bi,bj)
C    &          *recip_deepFac2C(kLev)*recip_rhoFacC(kLev)
          ENDDO
         ENDDO
       ELSE
         DO j=1,sNy
          DO i=1,sNx
            gS(i,j,kLev,bi,bj) = gS(i,j,kLev,bi,bj)
     &        + addMass(i,j,kLev,bi,bj)*mass2rUnit
     &          *( salt_addMass - sRef(kLev) )
     &          *recip_rA(i,j,bi,bj)
     &          *recip_drF(kLev)*_recip_hFacC(i,j,kLev,bi,bj)
C    &          *recip_deepFac2C(kLev)*recip_rhoFacC(kLev)
          ENDDO
         ENDDO
       ENDIF
      ENDIF
#endif /* ALLOW_ADDFLUID */

C     Ocean: Add salinity surface forcing (e.g., fresh-water) in surface level
      IF ( kLev .EQ. kSurface ) THEN
       DO j=1,sNy
        DO i=1,sNx
          gS(i,j,kLev,bi,bj)=gS(i,j,kLev,bi,bj)
     &      +surfaceForcingS(i,j,bi,bj)
     &      *recip_drF(kLev)*_recip_hFacC(i,j,kLev,bi,bj)
        ENDDO
       ENDDO
      ELSEIF ( kSurface.EQ.-1 ) THEN
       DO j=1,sNy
        DO i=1,sNx
         IF ( kSurfC(i,j,bi,bj).EQ.kLev ) THEN
          gS(i,j,kLev,bi,bj)=gS(i,j,kLev,bi,bj)
     &      +surfaceForcingS(i,j,bi,bj)
     &      *recip_drF(kLev)*_recip_hFacC(i,j,kLev,bi,bj)
         ENDIF
        ENDDO
       ENDDO
      ENDIF

      IF (linFSConserveTr) THEN
       DO j=1,sNy
        DO i=1,sNx
          IF (kLev .EQ. kSurfC(i,j,bi,bj)) THEN
            gS(i,j,kLev,bi,bj)=gS(i,j,kLev,bi,bj)
     &        +SsurfCor*recip_drF(kLev)*_recip_hFacC(i,j,kLev,bi,bj)
          ENDIF
        ENDDO
       ENDDO
      ENDIF

#ifdef ALLOW_SHELFICE
      IF ( useShelfIce )
     &     CALL SHELFICE_FORCING_S(
     U                   gS(1-OLx,1-OLy,kLev,bi,bj),
     I                   iMin,iMax,jMin,jMax, kLev, bi,bj,
     I                   myTime, 0, myThid )
#endif /* ALLOW_SHELFICE */

#ifdef ALLOW_ICEFRONT
      IF ( useICEFRONT )
     &     CALL ICEFRONT_TENDENCY_APPLY_S(
     U                   gS(1-OLx,1-OLy,kLev,bi,bj),
     I                   kLev, bi, bj, myTime, 0, myThid )
#endif /* ALLOW_ICEFRONT */

#ifdef ALLOW_SALT_PLUME
      IF ( useSALT_PLUME )
     &     CALL SALT_PLUME_TENDENCY_APPLY_S(
     U                     gS(1-OLx,1-OLy,kLev,bi,bj),
     I                     iMin,iMax,jMin,jMax, kLev, bi,bj,
     I                     myTime, 0, myThid )
#endif /* ALLOW_SALT_PLUME */

#ifdef ALLOW_RBCS
      IF (useRBCS) THEN
        CALL RBCS_ADD_TENDENCY(
     U                 gS(1-OLx,1-OLy,kLev,bi,bj),
     I                 kLev, bi, bj, 2,
     I                 myTime, 0, myThid )
      ENDIF
#endif /* ALLOW_RBCS */

#ifdef ALLOW_OBCS
      IF (useOBCS) THEN
        CALL OBCS_SPONGE_S(
     U                   gS(1-OLx,1-OLy,kLev,bi,bj),
     I                   iMin,iMax,jMin,jMax, kLev, bi,bj,
     I                   myTime, 0, myThid )
      ENDIF
#endif /* ALLOW_OBCS */

#ifdef ALLOW_BBL
      IF ( useBBL ) CALL BBL_TENDENCY_APPLY_S(
     U                       gS(1-OLx,1-OLy,kLev,bi,bj),
     I                       iMin,iMax,jMin,jMax, kLev, bi,bj,
     I                       myTime, 0, myThid )
#endif /* ALLOW_BBL */

#ifdef ALLOW_MYPACKAGE
      IF ( useMYPACKAGE ) THEN
        CALL MYPACKAGE_TENDENCY_APPLY_S(
     U                 gS(1-OLx,1-OLy,kLev,bi,bj),
     I                 iMin,iMax,jMin,jMax, kLev, bi,bj,
     I                 myTime, 0, myThid )
      ENDIF
#endif /* ALLOW_MYPACKAGE */

#endif /* USE_OLD_EXTERNAL_FORCING */
      RETURN
      END

#!/bin/bash 
# GMT script to plot the development of the residual and the 
# number of Krylov steps per Newton step
#

\rm -rf .gmtdefault*
gmtset HEADER_FONT_SIZE 24p
gmtset GRID_PEN_PRIMARY thinnest,-

ps=res.ps
prj=-JX14/12l
xticks=100g500a500
#ticks="-B${xticks}:newton iteration:/1g5a5:residual:WSne"
ticks="-B${xticks}/1g5a5:residual:WSne"
xoff=-X4c
yoff=-Y14c

infile=STDOUT.0000
infile=$1
tmpfile1=res.tmp
tmpfile2=iter.tmp
grep JFNK: $infile | grep initial | \
    awk '{printf("%i %e\n", $(NF-2), $NF)}' > ${tmpfile1}
# get min/max as y-axis limits
R=`minmax -I1.e-16 ${tmpfile1}`
RR=`echo $R | awk -F/ '{printf("%e/%e",$3,$4)}'`
#R=-R0/2400/1.e-16/10
R=-R0/2400/$RR
psbasemap ${xoff} ${yoff} $R $prj -G255 "${ticks}" -P -K > $ps
psxy ${tmpfile1} -R -J -W1p,blue -O -K >> $ps
psxy ${tmpfile1} -R -J -Sx0.075i -O -K >> $ps
# add number of FGMRES iterations
grep JFNK: $infile | grep 'Nb. of FGMRES' | \
    awk '{printf("%i %i\n",$12,$NF)}' > ${tmpfile2}
yoff=-Y-10c
prj=-JX14/7
ticks="-B${xticks}:newton iteration:/1g5a5:FGMRES iterations:WSne"
ticks="-B${xticks}:newton iteration:/a10f5g10:FGMRES iterations:WSne"
# get x-range
R1=`echo $R | awk -F/ '{printf("%s/%s/",$1,$2)}'`
R=${R1}0/50
#R2=`minmax -C ${tmpfile2} | awk '{printf("%i/%i",$3,$4)}'`
#R=$R1$R2
psbasemap -Y-8c $R $prj -G255 "${ticks}" -O -K >> $ps
psxy ${tmpfile2} -R -J -W1p,blue -O -K >> $ps
psxy ${tmpfile2} -R -J -Sx0.075i -O -K >> $ps
#
echo "" | psxy -R -J -O  >> $ps

# if available show plot
have_gv=`which gv`
if [[ x$have_gv != x ]]; then
 gv $ps
fi
# generate png-file
ps2raster -A -Tg ${ps}

# clean up
\rm -f ${tmpfile1} ${tmpfile2} ${ps}

#! /usr/bin/env bash
OADTOOLS=`dirname $0`
#OADTOOLS=`awk '{print $1 }' < oadtempflile`
echo "#generated file" > temp.sed
for i in `grep '^ *SUBROUTINE ' $1 | awk '{print $2}'`
do
  # extract the name
  srName=${i%%\(*}
  echo "/^ *SUBROUTINE $srName(/i\\" >> temp.sed
  case "$srName" in
    "OpenAD_main_do_loop" )
      if [ -z ${ALLOW_OPENAD_DIVA+x} ]; then
        echo "c\$openad XXX Template ad_template.revolve.f" >> temp.sed
      else
        echo "c\$openad XXX Template ad_template.regular.f" >> temp.sed
      fi
      ;;
    "OpenAD_streamice_cg_make_a" )
      echo "c\$openad XXX Template ad_template.split_non_anonymous.f" >> temp.sed
      ;;
    "OpenAD_inner_do_loop" )
      echo "c\$openad XXX Template ad_template.revolve.f" >> temp.sed
      ;;
    "OpenAD_cg2d" )
      echo "c\$openad XXX Template ad_template.sa_cg2d.f" >> temp.sed
      ;;
    "OpenAD_streamice_cg_solve" )
      echo "c\$openad XXX Template ad_template.streamice_cg_solve.f" >> temp.sed
      ;;
    "OpenAD_active_read_xyz" )
      echo "c\$openad XXX Template ad_template.active_read_xyz.f" >> temp.sed
      ;;
    "OpenAD_active_read_xy" )
      echo "c\$openad XXX Template ad_template.active_read_xy.f" >> temp.sed
      ;;
    "OpenAD_active_write_xy" )
      echo "c\$openad XXX Template ad_template.active_write_xy.f" >> temp.sed
      ;;
    "OpenAD_dummy_in_stepping" )
      echo "c\$openad XXX Template ad_template.dummy_in_stepping.f" >> temp.sed
      ;;
    "OpenAD_streamice_vel_phistage" )
      echo "c\$openad XXX Template ad_template.streamice_vel_phistage.f" >> temp.sed
      ;;
    "OpenAD_streamice_get_fp_err_oad" )
      echo "c\$openad XXX Template ad_template.streamice_get_fp_err_oad.f" >> temp.sed
      ;;
    "OpenAD_streamice_get_vel_resid_err_oad" )
      echo "c\$openad XXX Template ad_template.streamice_get_vel_resid_err_oad.f" >> temp.sed
      ;;
    "OpenAD_streamice_invert_surf_forthick" )
      echo "c\$openad XXX Template ad_template.streamice_invert_surf_forthick.f" >> temp.sed
      ;;
    "OpenAD_streamice_smooth_adjoint_field" )
      echo "c\$openad XXX Template ad_template.streamice_smooth_adjoint_field.f" >> temp.sed
      ;;
    "OpenAD_exch1_rl" |          \
    "OpenAD_exch1_rs" |          \
    "OpenAD_global_max_r8" |     \
    "OpenAD_global_sum_r8" |     \
    "OpenAD_global_sum_tile_rl" )
      tmpName=${srName#OpenAD_}
      echo "c\$openad XXX Template ad_template.${tmpName}.f" >> temp.sed
      ;;
    *)
      echo "c\$openad XXX Template ad_template.split.f" >> temp.sed
      ;;
  esac
done
cat $1 | sed -f temp.sed > $2

#!/bin/csh -f
set file=${1:r}
set awkScript=${2} 
awk -f ${awkScript} ${file}.h  | grep -v mpif.h > ${file}.h_temp
shift
shift   
foreach name ($*)
  cat ${file}.h_temp | grep -v ${name}.h > ${file}.h_t1
  mv ${file}.h_t1 ${file}.h_temp
end
echo '       USE '${file}'_mod' >> ${file}.h_temp
mv ${file}.h_temp ${file}_mod.h

#extract CPP directives with continuation lines from the input. 
BEGIN { ppContd = 0} 
/^# *ifdef .*\\$/ || /^# *ifndef .*\\$/ || /^# *endif.*\\$/ || /^# *if .*\\$/ || /^# *else.*\\$/ || /^# *define.*\\$/ { ppContd=1 }
!/^.*\\$/ { if (ppContd ==1) {print; ppContd=0} }
/^# *ifdef .*/ || /^# *ifndef .*/ || /^# *endif.*/ || /^# *if .*/ || /^# *else.*/ || /^# *define.*/ || /^# *include .*/ { if (ppContd != 1) {print} }
{if (ppContd == 1 ) print }
END {}

#!/bin/bash
file=$1
wantMPI=$2
needMpi=false
cp ${file} ${file}.tmp
for includeFile in `egrep "\# *include *\"" ${file} | sed 's/# *include *\"\(.*\)\"/\1/' | sort | uniq`
do 
  modFileName=${includeFile%.h}_mod.h
  if [ -f ${modFileName} ] 
  then 
    echo  "s/\# *include *\(\"${includeFile}\"\)/\#include \"${modFileName}\"/" > temp.sed
    # add in the mpi include here since we filtered it from the module
    if [ "$modFileName" == "EESUPPORT_mod.h" ] 
    then 
      needMpi=true
    fi
    cat ${file}.tmp | sed -f temp.sed | sed 's/IMPLICIT NONE//' | sed 's/implicit none//' > ${file}.tmp.1
    mv ${file}.tmp.1 ${file}.tmp
  fi
done
if [ "$needMpi" == "true" -a -n "$wantMPI" ] 
then 
   cat > cb2mUseMPI.awk <<EOF
BEGIN { useSeq = 0; inSR=0}
/^ *SUBROUTINE/ { inSR=1 } 
/^#include /  { if (inSR == 1) { useSeq = 1 ; print } }
/^#ifdef/ || /^#endif/ { if (useSeq == 1) print } 
!/^#include / && !/^#ifdef/ && !/^#endif/ {  if (useSeq == 1) { printf("#include \"mpif.h\"\n"); useSeq=0; inSR=0 } }
{if (useSeq == 0) print }
END {}
EOF
  awk -f cb2mUseMPI.awk ${file}.tmp > ${file}.tmp.1
  mv ${file}.tmp.1 ${file}.tmp
  rm -f cb2mUseMPI.awk
fi
mv ${file}.tmp ${file%.F}_cb2m.FF90

#!/bin/sh
mpicommand=`which mpif90  >/dev/null 2>&1`
status=$?
if [ "$status" == "0" ]; then
 mpicommand=`which mpif90`
 mpibin=`echo $mpicommand  | sed s'z\(.*\)/[^/]*$z\1'z`
 mpiroot=`echo $mpibin     | sed s'z\(.*\)/[^/]*$z\1'z`
 mpi_idir=$mpiroot"/include"
else
 mpi_idir=""
fi
echo $mpi_idir

#!/bin/bash
#
# Testreport running script for CI,
# - now as GitHub action, called from build_testing.ym
#   (formerly with Travis, called from .travis.yml script )
# - section with environment variables:
#   if they are not set then defaults are configured here.
# MITGCM_DECMD - command to run under Docker
# MITGCM_EXP   - MITgcm test to run
# MITGCM_TROPT - Test report options
#

if [ -z "${MITGCM_TROPT}" ]; then
 export MITGCM_TROPT='-devel -of=../tools/build_options/linux_amd64_gfortran -match 14'
fi
if [ -z "${MITGCM_DECMD}" ]; then
 export MITGCM_DECMD='docker exec -i ubuntu_18_04-testreport bash -c'
fi
if [ -z "${MITGCM_INPUT_DIR_PAT}" ]; then
 export MITGCM_INPUT_DIR_PAT='/input.*'
fi

${MITGCM_DECMD} "cd /MITgcm/verification; ./testreport -pass -t ${MITGCM_EXP} ${MITGCM_TROPT}"

#  Set up environment needed for Sphinx to build docs
sudo apt-get update
sudo apt-get install texlive-latex-recommended
sudo apt-get install texlive-latex-extra
sudo apt-get install texlive-fonts-recommended
sudo apt-get install latexmk
pip install -r doc/requirements.txt
pip install sphinx_rtd_theme

#- to update "data.obcs" content following code update from PR #752:
#  > mv data.obcs data.obcs.bak
#  > sed -f update_TideFileName.sed data.obcs.bak > data.obcs
#- Warning: This is case sensitive while data.obcs namelist are not !
s/\<tidalPeriod\> *=/OBCS_tidalPeriod=/g
s/OBNamFile/OBN_vTidAmFile/g
s/OBNphFile/OBN_vTidPhFile/g
s/OBSamFile/OBS_vTidAmFile/g
s/OBSphFile/OBS_vTidPhFile/g
s/OBEamFile/OBE_uTidAmFile/g
s/OBEphFile/OBE_uTidPhFile/g
s/OBWamFile/OBW_uTidAmFile/g
s/OBWphFile/OBW_uTidPhFile/g

#!/bin/csh
# invoking mpirun on ITRDA Linux cluster
#
# o -q queue
#   available on itrda are four (=2hours), long (=168hours)
#PBS -q long
#
# o -N Job name
#PBS -N global2x2
#
# -l resource lists
#PBS -l nodes=6:ppn=2
#
# o STDERR/OUT
#PBS -e stderr
#PBS -o stdout
#
# o export all my environment var's
#PBS -V
printenv
#
# get PBS node info
#
echo $PBS_NODEFILE
cat  $PBS_NODEFILE
#
cat $PBS_NODEFILE >! my_proc_list
set ncpus = ( `wc -l my_proc_list | awk '{print $1}'` )
echo 'ncpus = ' $ncpus
set listvar = `cat my_proc_list`
#
cd /u1/heimbach/ecco/ecco-branch/exe
cp ~heimbach/ecco/ecco-branch/exe/mitgcmuv .
#
echo $ncpus >! my_list
set dualvar = 1
foreach lv ($listvar)
  if ( $dualvar == 1 ) then
    echo $lv 2 >> my_list
    set dualvar = 2
  else
    echo $lv 4 >> my_list
    set dualvar = 1
  endif
end
#
/usr/local/mpich/mpich-1.2.1..7b_pgi/bin/mpirun.ch_gm \
    --gm-f ./my_list --gm-v ./mitgcmuv

exit

#!/bin/csh
# Example PBS script to run a job on the myrinet-3 cluster.
# The lines beginning #PBS set various queuing parameters.
#
# o -N Job Name
#PBS -N global2x2
#
# o -l resource lists that control where job goes
#      here we ask for 3 nodes, each with the attribute "p4".
#PBS -l nodes=6:p4
#
# o Where to write output
#PBS -e stderr
#PBS -o stdout
#
# o Export all my environment variables to the job
#PBS -V
#
#
echo $PBS_NODEFILE
cat  $PBS_NODEFILE
#
cd /s07/heimbach/ecco-branch/exe
rm -f proc_list *.00?.00?.*
cp ~heimbach/ecco/ecco-branch/exe/mitgcmuv .
#
cat $PBS_NODEFILE >! proc_list
set ncpus = ( `wc -l proc_list | awk '{print $1}'` )
echo 'ncpus = ' $ncpus
set listvar = `cat proc_list`
#
foreach lv ($listvar)
echo 'creating /s/local/1/ecco-exe on ' $lv
rsh -n $lv rm -rf /s/local/1/ecco-exe
rsh -n $lv mkdir /s/local/1/ecco-exe
end
#
/usr/local/pkg/mpi/mpi-1.2.4..8a-gm-1.5/g77/bin/mpirun.ch_gm -machinefile proc_list --gm-kill 7 -v -np $ncpus ./mitgcmuv
#
set out=$?
echo 'end with status' $out

#! /usr/bin/env bash

#- script to run the sequence of multiple Divided-Adjoint runs:
#  no argment -> using non-MPI built AD-executable
#  single-arg -> using MPI built executable and "mpirun -np ${single-arg}" command

#- number of additional executions to perform is given by "add_DIVA_runs"
#  and corresponds to "nchklev_3" value in file "code_ad/tamc.h"
#- take it from file "run_ADM_DIVA" (as done in testreport):
adm_diva_nb=`sed -n '/^ *add_DIVA_runs *=/p' run_ADM_DIVA | sed 's/ //g'`
echo " Divided Adjoint Run: $adm_diva_nb"
eval "let $adm_diva_nb"
#- or set-it directly:
#add_DIVA_runs=4

extraRuns=`expr $add_DIVA_runs - 1`	
if test $# = 0 ; then
    rm -f costfunction*0000 costfinal divided.ctrl snapshot*
#- not MPI run:
    echo "Run $add_DIVA_runs times + final run:"
    for ii in `seq 0 $extraRuns` ; do
      echo " --> starts DIVA run # $ii :"
      ./mitgcmuv_ad > output_adm.txt.diva_${ii}
      echo -n " <-- DIVA run # $ii : done"
      if test -f divided.ctrl ; then
        echo -n ", divided.ctrl :" ; cat divided.ctrl
      else  echo ", no 'divided.ctrl' file" ; fi
#     if test $ii = 2 ; then exit $ii ; fi
    done
    echo " --> Final DIVA run :"
    ./mitgcmuv_ad > output_adm.txt
    echo -n " <-- Final run : done"
    if test -f divided.ctrl ; then echo -n ", divided.ctrl :" ; cat divided.ctrl
    else  echo "" ; fi
else
  if [ $1 -ge 1 ] ; then
    rm -f costfunction*0000 costfinal divided.ctrl snapshot*
#- MPI run on $1 procs (note: may need to edit mpirun command):
    echo "Run $add_DIVA_runs times + final run (use 'mpirun -np $1' ):"
    for ii in `seq 0 $extraRuns` ; do
      echo " --> starts DIVA run # $ii :"
      mpirun -np $1 ./mitgcmuv_ad
      echo -n " <-- DIVA run # $ii : done"
      mv -f STDOUT.0000 STDOUT.0000.diva_${ii}
      if test -f divided.ctrl ; then
        echo ", divided.ctrl :"
        cat divided.ctrl
      else  echo ", no 'divided.ctrl' file" ; fi
    done
    echo " --> Final DIVA run :"
    mpirun -np $1 ./mitgcmuv_ad
    echo -n " <-- Final run : done"
    if test -f divided.ctrl ; then echo ", divided.ctrl :" ; cat divided.ctrl
    else  echo "" ; fi
  fi
fi

#!/bin/csh
# script for running line search routine
# * set line search parameters
# * link control and gradient vector
# * generate runtime parameter files
# * run line search
# heimbach@mit.edu 27-May-2003

# set parameters for namelist ECCO_OPTIM
set optimcycle = 0
set numiter    = 1
set nfunc      = 3
set fmin       = 300.
set iprint     = 10
set nupdate    = 4

# set parameters for namelist ECCO_PARMS
set expId = MIT_CE_000

# set parameters for namelist CTRL_NML and CTRL_PACKNAMES
set ctrlname = ecco_ctrl
set costname = ecco_cost

# set system parameters
set mitgcmdir = /cluster/scratch/month01/heimbach/ecco-branch/exe
set optimdir = /cluster/scratch/month01/heimbach/ecco-branch/optim/exe

# IDEALLY, NO MORE EDITING BEYOND THIS LINE.
# ---------------------------------------------------------------------

# do some stuff
#
if ( $optimcycle < 10 ) then
  set optsuffix = 000${optimcycle}
else if ( $optimcycle < 100 ) then
  set optsuffix = 00${optimcycle}
else if ( $optimcycle < 1000 ) then
  set optsuffix = 0${optimcycle}
else
  set optsuffix = ${optimcycle}
endif

# go to wrkdir and proceed:
#
cd $optimdir
rm -f data.*
if ( $optimcycle == 0 ) then
  rm -f OPWARM? PH_?.dat *.opt0001 fort.94
endif

cat >! data.optim << EOF
# ********************************
# Off-line optimization parameters
# ********************************
 &ECCO_OPTIM
 optimcycle = $optimcycle,
 numiter    = $numiter,
 nfunc      = $nfunc,
 fmin       = $fmin,
 iprint     = $iprint,
 nupdate    = $nupdate,
 &
EOF

cat >! data.ecco << EOF
# ***************
# ECCO parameters
# ***************
 &ECCO_PARMS
 expId = '${expId}',
 &
EOF

cat >! data.ctrl << EOF
# *********************
# ECCO controlvariables
# *********************
 &CTRL_NML
 &
# *********************
# names for ctrl_pack/unpack
# *********************
 &CTRL_PACKNAMES
 ctrlname = '${ctrlname}',
 costname = '${costname}',
 &
EOF

ln -s ${mitgcmdir}/${ctrlname}_${expId}.opt${optsuffix} .
ln -s ${mitgcmdir}/${costname}_${expId}.opt${optsuffix} .

./optim.x >&! output_${optsuffix}.txt

exit

#!/bin/csh
# invoking mpirun at AERs Linux cluster beehive
#
foreach node (01 02 03 04 05 06 07)
echo node$node
rsh -n beehive$node mkdir /client/scratch/heimbach
rsh -n beehive$node rm -rf /client/scratch/heimbach/exe
rsh -n beehive$node mkdir /client/scratch/heimbach/exe
end
#
# the default dir is globally visible.
# all ctrl related output is written to this dir.
# the mdsioLocalDir is /client/scratch/...
#
rm -rf /cluster/scratch/month01/ecco-exe/
mkdir /cluster/scratch/month01/ecco-exe/
cd /cluster/scratch/month01/ecco-exe/
cp -f /cluster/scratch/month01/heimbach/ecco-branch/verification/global2x2_tot/input/* .
ln -s /cluster/scratch/month01/ponte/UV_2x2/* .
#
# the local scratch dir /client/scratch/...
# is specified in the "data" file, variable mdsioLocalDir
#
set exec = /cluster/scratch/month01/heimbach/ecco-branch/exe/mitgcmuv
/opt/mpich/bin/mpirun.ch_gm -np 6 --gm-kill 7 --gm-v $exec
exit

#!/bin/csh -f
#
# Usage: nc oldvar newvar filelist
#

if ( $#argv < 3 ) then
 echo "Usage: $0 oldvar newvar filelist"
 exit
endif

set  oldvar = "$1";
set  newvar = "$2";
shift; shift;

echo Replace \""$oldvar"\" with \"$newvar\" '[yes/(no)]'
set response = ( $< )
if ( "$response" != "yes" ) then
 exit
endif

set savedir = ( nc-$$ )
mkdir $savedir

foreach curfile ( $* )

 echo Substituting \"$newvar\" for \""$oldvar"\" in file \"$curfile\".
 cp   $curfile $savedir/${curfile:t}.before
 cat  $savedir/${curfile:t}.before | sed s/'\([^a-zA-Z_]\)\('"$oldvar"'\)/\1'$newvar'/g' > $curfile

end
#
# cat $oldfile | sed s/'\([^a-zA-Z]\)\([Nn][Zz]\)/\1Nr/' > $newfile
#

# run on 6 cpu's for 2 hours
# lsc.windf stands for large scale computing
# ac.windf stands for analysis cluster
#
#$ -pe lsc.windf 60 -l h_cpu=8:00:00
#
# if using with DIVA, FTMPDIR must not be deleted,
# or costfinal, divided.ctrl, snapshot* need to be
# saved and re-copied
#if (-e $FTMPDIR ) then
#  rm -f $FTMPDIR/*
#endif
#
cd $FTMPDIR
pwd
#
\cp -f ~/ecco/ecco-branch/exe/mitgcmuv .
\cp -f ~/ecco/ecco-branch/verification/global1x1_tot/input/* .
dmget /archive/psh/data/UV_1x1/*
\cp -f /archive/psh/data/UV_1x1/* .
#
mpirun -np 60 mitgcmuv
#
mv STD* /archive/psh/ecco/ecco-branch/res/.
mv cost* /archive/psh/ecco/ecco-branch/res/.
mv ecco_* /archive/psh/ecco/ecco-branch/res/.
mv ?.00000* /archive/psh/ecco/ecco-branch/res/.
mv adxx_* /archive/psh/ecco/ecco-branch/res/.
mv xx_* /archive/psh/ecco/ecco-branch/res/.
mv pickup* /archive/psh/ecco/ecco-branch/res/.
mv snapshot* /archive/psh/ecco/ecco-branch/res/.
mv divided* /archive/psh/ecco/ecco-branch/res/.
mv tapelev3_1_* /archive/psh/ecco/ecco-branch/res/.
mv tapelev2_2_* /archive/psh/ecco/ecco-branch/res/.

#!/bin/sh

if [ ! $# -eq 1 ]
then
echo "contextAD.sh: missing file operand"
exit 1
fi

TRACE=$1

if [ ! -f $TRACE ]
then
echo "contextAD.sh: "$TRACE": No such file "
exit 1
fi

INITVAR=`grep init $TRACE | sort -u | grep of | awk '{print $3}' | awk 'BEGIN{FS=","} {print $1}' `
CONCVAR=`grep conclude $TRACE | sort -u | awk '{print $3}' | awk 'BEGIN{FS=":"} {print $1}' `

PERTURBED_RESULT=`grep "Condensed perturbed result" $TRACE | tail -1 | awk '{print $6}' `
RESULT=`grep "Condensed result" $TRACE | tail -1 | awk '{print $5}' `
TANGENT=`grep "Condensed tangent" $TRACE | tail -1 | awk '{print $4}' `
ADJOINT=`grep "Condensed adjoint" $TRACE | tail -1 | awk '{print $4}' `


echo "RESULT          " $RESULT
echo "PERTURBED_RESULT" $PERTURBED_RESULT
echo "TANGENT         " $TANGENT
echo "ADJOINT         " $ADJOINT

EPSILON=`grep run $TRACE | tail -1 | grep epsilon | awk 'BEGIN{FS="="}  {print $3}'`

FEP=${PERTURBED_RESULT/[eE][+]/*10^}
FEP=${FEP/[eE][-]/*10^-}
F=${RESULT/[eE][+]/*10^}
F=${F/[eE][-]/*10^-}
TGT=${TANGENT/[eE][+]/*10^}
TGT=${TGT/[eE][-]/*10^-}
ADJ=${ADJOINT/[eE][+]/*10^}
ADJ=${ADJ/[eE][-]/*10^-}

EPS_INV=${EPSILON/[eE][-][0]/*10^}

echo "Derivatives of " $CONCVAR " with respect to " $INITVAR
echo -n "Divided differences "
echo "(("$FEP - $F")" "*" $EPS_INV ")" | bc -l

echo -n "Condensed tangent   " 
echo $TGT | bc -l

echo -n "Condensed adjoint   " 
echo $ADJ | bc -l

#!/bin/csh -f
set fileName=${1:r}
set awkScript=${2}
echo '      MODULE '${fileName}_mod   > ${fileName}_temp
echo '#include "PACKAGES_CONFIG.h"'   >> ${fileName}_temp
echo '#include "CPP_OPTIONS.h"'       >> ${fileName}_temp
echo '#ifdef ALLOW_AUTODIFF'          >> ${fileName}_temp
echo '# include "AUTODIFF_OPTIONS.h"' >> ${fileName}_temp
echo '#endif'                         >> ${fileName}_temp
echo '#ifdef ALLOW_COST'              >> ${fileName}_temp
echo '# include "COST_OPTIONS.h"'     >> ${fileName}_temp
echo '#endif'                         >> ${fileName}_temp
echo '#ifdef ALLOW_CTRL'              >> ${fileName}_temp
echo '# include "CTRL_OPTIONS.h"'     >> ${fileName}_temp
echo '#endif'                         >> ${fileName}_temp
echo '#ifdef ALLOW_ECCO'              >> ${fileName}_temp
echo '# include "ECCO_OPTIONS.h"'     >> ${fileName}_temp
echo '#endif'                         >> ${fileName}_temp
if ( ${fileName} == 'DIC_LOAD' || ${fileName} == 'DIC_VARS' ) then
  echo '#include "DIC_OPTIONS.h"'    >> ${fileName}_temp
endif
if ( ${fileName} == 'GAD' ) then
  echo '#include "GAD_OPTIONS.h"'    >> ${fileName}_temp
endif
if ( ${fileName} == 'GGL90' ) then
  echo '#include "GGL90_OPTIONS.h"'    >> ${fileName}_temp
endif
if ( ${fileName} == 'GMREDI' ) then
  echo '#include "GMREDI_OPTIONS.h"'    >> ${fileName}_temp
endif
if ( ${fileName} == 'KPP' ) then
  echo '#include "KPP_OPTIONS.h"'    >> ${fileName}_temp
endif
if ( ${fileName} == 'MOM_VISC' ) then
  echo '#include "MOM_COMMON_OPTIONS.h"'    >> ${fileName}_temp
endif
if ( ${fileName} == 'RBCS' ) then
  echo '#include "RBCS_OPTIONS.h"'    >> ${fileName}_temp
endif
if ( ${fileName} == 'SHAP_FILT' ) then
  echo '#include "SHAP_FILT_OPTIONS.h"'    >> ${fileName}_temp
endif
if ( ${fileName} == 'STREAMICE' ) then
  echo '#include "STREAMICE_OPTIONS.h"'    >> ${fileName}_temp
endif
if ( ${fileName} != 'SIZE' &&  ${fileName} != 'MNC_COMMON' &&  ${fileName} != 'EEPARAMS' ) then
  echo '      use SIZE_mod'          >> ${fileName}_temp
endif
if ( ${fileName} != 'EEPARAMS' &&  ${fileName} != 'SIZE' &&  ${fileName} != 'MNC_COMMON' ) then
  echo '      use EEPARAMS_mod'      >> ${fileName}_temp
endif
if ( ${fileName} != 'PARAMS' && ${fileName} != 'EEPARAMS' &&  ${fileName} != 'SIZE' &&  ${fileName} != 'MNC_COMMON' && ${fileName} != 'GAD' && ${fileName} != 'GRID' ) then
  echo '      use PARAMS_mod'	     >> ${fileName}_temp
endif
if ( ${fileName} == 'CTRL' || ${fileName} == 'CTRL_DUMMY' || ${fileName} == 'CTRL_GENARR' ) then
  echo '      use CTRL_SIZE_mod'     >> ${fileName}_temp
endif
if ( ${fileName} == 'DIAGSTATS_REGIONS' || ${fileName} == 'DIAGNOSTICS' ) then
  echo '      use DIAGNOSTICS_SIZE_mod'     >> ${fileName}_temp
endif
if ( ${fileName} == 'PTRACERS_FIELDS' || ${fileName} == 'PTRACERS_PARAMS' || \
     ${fileName} == 'PTRACERS_START' || ${fileName} == 'GCHEM_FIELDS' ) then
  echo '      use PTRACERS_SIZE_mod' >> ${fileName}_temp
endif
if ( ${fileName} == 'RBCS_FIELDS' ) then
  echo '      use RBCS_SIZE_mod' >> ${fileName}_temp
endif
#echo awk -f ${awkScript} ${fileName}.h
awk -f ${awkScript} ${fileName}.h | grep -v mpif.h   >> ${fileName}_temp
echo '      END MODULE' ${fileName}_mod   >> ${fileName}_temp
cp ${fileName}_temp ${fileName}_mod.FF90
\rm ${fileName}_temp

## What changes does this PR introduce?
(Bug fix, feature, docs update, ...)


## What is the current behaviour? 
(You can also link to an open issue here)


## What is the new behaviour 
(if this is a feature change)?


## Does this PR introduce a breaking change? 
(What changes might users need to make in their application due to this PR?)


## Other information:


## Suggested addition to `tag-index`
(To avoid unnecessary merge conflicts, please don't update `tag-index`. One of the admins will do that when merging your pull request.)
